prompt --application/set_environment
set define off verify off feedback off
--------------------------------------------------------------------------------
--
-- Oracle APEX export file
--
-- You should run this script using a SQL client connected to the database as
-- the owner (parsing schema) of the application or as a database user with the
-- APEX_ADMINISTRATOR_ROLE role.
--
-- This export file has been automatically generated. Modifying this file is not
-- supported by Oracle and can lead to unexpected application and/or instance
-- behavior now or in the future.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_imp.import_begin (
 p_version_yyyy_mm_dd=>'2024.05.31'
,p_release=>'24.1.0'
,p_default_workspace_id=>10
,p_default_application_id=>4000
,p_default_id_offset=>0
,p_default_owner=>'APEX_240100'
);
end;
/
 
prompt APPLICATION 4000 - Oracle APEX App Builder
--
-- Application Export:
--   Application:     4000
--   Name:            Oracle APEX App Builder
--   Exported By:     APEX_240100
--   Flashback:       0
--   Export Type:     Application Export
--     Pages:                    865
--       Items:                5,309
--       Computations:           597
--       Validations:          1,493
--       Processes:            1,448
--       Regions:              4,054
--       Buttons:              2,369
--       Dynamic Actions:      1,612
--     Shared Components:
--       Logic:
--         Items:                 40
--         Processes:             12
--         Computations:          10
--         Build Options:          8
--       Navigation:
--         Lists:                280
--         Breadcrumbs:            1
--           Entries:            785
--         NavBar Entries:         3
--       Security:
--         Authentication:         1
--         Authorization:         21
--       User Interface:
--         Themes:                 1
--         Templates:
--           Page:                10
--           Region:              40
--           Label:               12
--           List:                16
--           Popup LOV:            1
--           Calendar:             1
--           Breadcrumb:           1
--           Button:               8
--           Report:              19
--         LOVs:                 942
--         Shortcuts:              9
--         Plug-ins:              28
--       PWA:
--       Globalization:
--         Messages:             785
--       Reports:
--       E-Mail:
--     Supporting Objects:  Included
--   Version:         24.1.0
--   Instance ID:     1000197243005302
--

prompt --application/delete_application
begin
wwv_flow_imp.remove_flow(wwv_flow.g_flow_id);
end;
/
prompt --application/create_application
begin
wwv_imp_workspace.create_flow(
 p_id=>wwv_flow.g_flow_id
,p_owner=>nvl(wwv_flow_application_install.get_schema,'APEX_240100')
,p_name=>nvl(wwv_flow_application_install.get_application_name,'Oracle APEX App Builder')
,p_alias=>nvl(wwv_flow_application_install.get_application_alias,'APP-BUILDER')
,p_application_group=>wwv_flow_imp.id(91050719712959059)
,p_application_group_name=>'APEX Product'
,p_application_group_comment=>'Applications shipped with the APEX product distribution'
,p_page_view_logging=>'YES'
,p_charset=>'utf-8'
,p_page_protection_enabled_y_n=>'Y'
,p_checksum_salt_last_reset=>'20240716121407'
,p_bookmark_checksum_function=>'SH1'
,p_compatibility_mode=>'5.0'
,p_accessible_read_only=>'N'
,p_session_state_commits=>'IMMEDIATE'
,p_flow_language=>'en'
,p_flow_language_derived_from=>'SESSION'
,p_date_format=>'&DATE_FORMAT.'
,p_direction_right_to_left=>'N'
,p_flow_image_prefix => nvl(wwv_flow_application_install.get_image_prefix,'')
,p_publish_yn=>'Y'
,p_documentation_banner=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Oracle APEX application development user interface.',
'',
'Developers:  Michael Hichwa, Joel Kallman, Christina Cho, Scott Spadafore, Marc Sewtz, Jason Straub, Sharon Kennedy, Carl Backstrom, Kris Rice, Syme Kutz, Terri Winters, Marco Adelfio, Hilary Farrell, Anthony Rayner, Allan Sitterson, Sathish Kumar, A'
||'shish Verma, Patrick Wolf, Carsten Czarski',
'',
'Contributors:  William Dwight, Tim Hoechst, Thomas Kyte, Chris Beck, David Bliss, Jason Rhodes, Sean Dillon, Ken Jacobs, Darcy Menard, Sudha Kannan, Ganesh Pitchaiah, Srinivas Rayapeddi, Anton Nielsen, Sergio Leunissen, Tyler Muth, Raj Mattamal, Scot'
||'t Spendolini'))
,p_authentication_id=>wwv_flow_imp.id(532421019614096524)
,p_populate_roles=>'A'
,p_application_tab_set=>1
,p_logo_type=>'C'
,p_logo=>'<img src="#IMAGE_PREFIX#apex_ui/apexlogo.png" width="282" height="20" alt="&PRODUCT_NAME." />'
,p_public_user=>'APEX_PUBLIC_USER'
,p_proxy_server=>nvl(wwv_flow_application_install.get_proxy,'')
,p_no_proxy_domains=>nvl(wwv_flow_application_install.get_no_proxy_domains,'')
,p_flow_version=>'&PRODUCT_NAME. 24.1.0'
,p_flow_status=>'AVAILABLE_W_EDIT_LINK'
,p_flow_unavailable_text=>'This application is currently unavailable at this time.'
,p_exact_substitutions_only=>'Y'
,p_browser_cache=>'N'
,p_browser_frame=>'D'
,p_runtime_api_usage=>'T:O'
,p_pass_ecid=>'N'
,p_security_scheme=>wwv_flow_imp.id(12510423405283164)
,p_authorize_public_pages_yn=>'Y'
,p_rejoin_existing_sessions=>'N'
,p_csv_encoding=>'Y'
,p_auto_time_zone=>'N'
,p_error_handling_function=>'wwv_flow_error_dev.internal_error_handler'
,p_substitution_string_01=>'HELP'
,p_substitution_value_01=>'Help'
,p_substitution_string_02=>'PRODUCT_NAME'
,p_substitution_value_02=>'Oracle APEX'
,p_substitution_string_03=>'MSG_COMPANY'
,p_substitution_value_03=>'Workspace: &COMPANY.'
,p_substitution_string_04=>'MSG_LANGUAGE'
,p_substitution_value_04=>'Language'
,p_substitution_string_05=>'MSG_COPYRIGHT'
,p_substitution_value_05=>'Copyright &copy; 1999, 2024, Oracle and/or its affiliates.'
,p_substitution_string_06=>'MSG_USER'
,p_substitution_value_06=>'User'
,p_substitution_string_07=>'MSG_JSCRIPT'
,p_substitution_value_07=>'You must run this product with JavaScript enabled.'
,p_substitution_string_08=>'MSG_TBL_SUMMARY'
,p_substitution_value_08=>'Page Layout Table'
,p_substitution_string_09=>'EDIT'
,p_substitution_value_09=>'Edit'
,p_substitution_string_10=>'DONE'
,p_substitution_value_10=>'Done'
,p_substitution_string_11=>'TOP'
,p_substitution_value_11=>'Top'
,p_substitution_string_12=>'CLOSE'
,p_substitution_value_12=>'Close'
,p_substitution_string_13=>'MSG_WORKSPACE'
,p_substitution_value_13=>'Workspace'
,p_substitution_string_14=>'DATE_FORMAT'
,p_substitution_value_14=>'mm/dd/yyyy'
,p_substitution_string_15=>'LONG_DATE_FORMAT'
,p_substitution_value_15=>'fmDay, Month dd, yyyy'
,p_substitution_string_16=>'TIME_FORMAT'
,p_substitution_value_16=>'hh:mi:ss AM'
,p_substitution_string_17=>'DATE_TIME_FORMAT'
,p_substitution_value_17=>'mm/dd/yyyy hh:mi:ss AM'
,p_substitution_string_18=>'RETURN_TO_APP'
,p_substitution_value_18=>'Return to Application'
,p_substitution_string_19=>'DELETE_MSG'
,p_substitution_value_19=>'Would you like to perform this delete action?'
,p_substitution_string_20=>'PAGE'
,p_substitution_value_20=>'Page'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_app_file_prefix,'')
,p_files_version=>32
,p_print_server_type=>'INSTANCE'
,p_file_storage=>'DB'
,p_is_pwa=>'N'
);
end;
/
prompt --application/user_interfaces
begin
wwv_flow_imp_shared.create_user_interface(
 p_id=>wwv_flow_imp.id(4000)
,p_theme_id=>3
,p_home_url=>'f?p=4000:1500:&SESSION.'
,p_login_url=>'f?p=4550:1:&SESSION.'
,p_theme_style_by_user_pref=>false
,p_global_page_id=>0
,p_navigation_list_position=>'SIDE'
,p_include_legacy_javascript=>'PRE18:18'
,p_nav_bar_type=>'NAVBAR'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_tab_navigation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(5297709875)
,p_name=>'shared.components.tab.navigation'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474639
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(450480819599472048)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Tabs'
,p_list_item_link_target=>'f?p=&APP_ID.:643:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'643'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(46189308080649570)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Manage Tabs'
,p_list_item_link_target=>'f?p=&APP_ID.:9000:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'9000:9005'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(155545004712893410)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'TabSet View'
,p_list_item_link_target=>'f?p=&APP_ID.:77:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'77'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'77'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(155551816129903365)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Edit Standard Tabs'
,p_list_item_link_target=>'f?p=&APP_ID.:123:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'123'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(36310824965543438)
,p_list_item_display_sequence=>55
,p_list_item_link_text=>'Edit Parent Tabs'
,p_list_item_link_target=>'f?p=&APP_ID.:331:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'331'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(188150925414136195)
,p_list_item_display_sequence=>56
,p_list_item_link_text=>'Conditional Display'
,p_list_item_link_target=>'f?p=&APP_ID.:562:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'562'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(4187304378934429)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Utilization'
,p_list_item_link_target=>'f?p=&FLOW_ID.:200:&SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'200'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(31647421041127463)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Parent Tab Management'
,p_list_item_link_target=>'f?p=&APP_ID.:398:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'398'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'398'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(11162415001016997)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'History'
,p_list_item_link_target=>'f?p=4000:58:&SESSION.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'58'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_template_navigation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(12437772301)
,p_name=>'shared.components.template.navigation'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474639
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(12439783039)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Templates'
,p_list_item_link_target=>'f?p=&FLOW_ID.:4003:&SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4003'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(181570910687524006)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Subscription'
,p_list_item_link_target=>'f?p=&APP_ID.:124:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'124'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(103318918740149314)
,p_list_item_display_sequence=>35
,p_list_item_link_text=>'Publish'
,p_list_item_link_target=>'f?p=&APP_ID.:727:&SESSION.::&DEBUG.:727:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'727:651'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(12441785324)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Utilization'
,p_list_item_link_target=>'f?p=&APP_ID.:4656:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4656,707'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(7436519543386292)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'History'
,p_list_item_link_target=>'f?p=4000:368:&SESSION.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'368'
);
end;
/
prompt --application/shared_components/navigation/lists/export_options
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(12802829107)
,p_name=>'Export_options'
,p_list_status=>'PUBLIC'
,p_version_scn=>117484617
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(45716606101005971)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Application'
,p_list_item_link_target=>'f?p=&APP_ID.:4900:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4900'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(6205783903288710)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Page'
,p_list_item_link_target=>'f?p=&APP_ID.:164:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'164'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(6206059937291623)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Components'
,p_list_item_link_target=>'f?p=&APP_ID.:688:&SESSION.::&DEBUG.:CR:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'688'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(60513615035446206)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Themes'
,p_list_item_link_target=>'f?p=&FLOW_ID.:224:&SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'224'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(30477123909319995)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Plug-ins'
,p_list_item_link_target=>'f?p=&APP_ID.:4460:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4460'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(189447213907433212)
,p_list_item_display_sequence=>75
,p_list_item_link_text=>'XML Export and Reporting'
,p_list_item_link_target=>'f?p=4850:1:&SESSION.'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(145288215599412878)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'UI Defaults'
,p_list_item_link_target=>'f?p=&APP_ID.:479:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'479,541'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(472191226795751981)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Feedback'
,p_list_item_link_target=>'f?p=&APP_ID.:689:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'689'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3743275033992392)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Catalog'
,p_list_item_link_target=>'f?p=&APP_ID.:1965:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(10804139761201725)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'Workspace'
,p_list_item_link_target=>'f?p=&APP_ID.:76:&SESSION.::&DEBUG.::::'
,p_security_scheme=>wwv_flow_imp.id(12511519296310366)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'76'
);
end;
/
prompt --application/shared_components/navigation/lists/pull_templates
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(320074633987)
,p_name=>'pull_templates'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474639
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(320076637876)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Creation Method'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(320078641296)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Copy From'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'26:4320:4069:86:4321:241:219:655:468:177'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(150871808522531061)
,p_list_item_display_sequence=>25
,p_list_item_link_text=>'Identify Theme'
,p_list_item_link_target=>'f?p=&FLOW_ID.:498:&SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'498:225:343:353:412:413:415:418:423'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(177583606462600141)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'New Templates'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'144:158:159:167:168:242:223:657:469'
);
end;
/
prompt --application/shared_components/navigation/lists/p4500_create_menu
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(3734458575652)
,p_name=>'P4500 Create Menu'
,p_list_status=>'PUBLIC'
,p_version_scn=>80431272
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3734460575652)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Page'
,p_list_item_link_target=>'f?p=&APP_ID.:2500:&SESSION.::&DEBUG.:2500,2501,2502,2503,2504,2505,2506,2507,2508,2509,2510,2511,2512,2513,2514,2515,2516,2517,2518,2519,2520:FB_FLOW_ID:&FB_FLOW_ID.:'
,p_list_text_01=>'pd-create-page'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3734467605558)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>'Copy Page'
,p_list_item_link_target=>'f?p=&APP_ID.:618:&SESSION.::&DEBUG.:618,301,302,305,308,309:::'
,p_list_text_01=>'pd-create-copy-page'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1478127242456137222)
,p_list_item_display_sequence=>17
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1477161567189313896)
,p_list_item_display_sequence=>19
,p_list_item_link_text=>'Page Component'
,p_list_item_link_target=>'f?p=&APP_ID.:97:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(337326867726113326)
,p_list_item_display_sequence=>35
,p_list_item_link_text=>'Breadcrumb Region'
,p_list_item_link_target=>'f?p=&APP_ID.:263:&SESSION.:PD:&DEBUG.:259,181,380:::'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not wwv_flow_page_dev.page_pattern_is_subscribed (',
'    p_application_id => :fb_flow_id,',
'    p_page_id        => :fb_flow_page_id )'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_text_01=>'pd-create-breadcrumb-region'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3734469612579)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Shared Component'
,p_list_item_link_target=>'f?p=&APP_ID.:364:&SESSION.::&DEBUG.::::'
,p_list_text_01=>'pd-create-shared-component'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1557581895922320741)
,p_list_item_display_sequence=>52
,p_list_item_link_text=>'Page Group'
,p_list_item_link_target=>'f?p=&APP_ID.:521:&SESSION.::&DEBUG.:521:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1478127597899141859)
,p_list_item_display_sequence=>55
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3734471629609)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Developer Comment'
,p_list_item_link_target=>'f?p=&APP_ID.:1234:&SESSION.::&DEBUG.:1234:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(45451535915378438)
,p_list_item_display_sequence=>65
,p_list_item_link_text=>'Issue'
,p_list_item_link_target=>'f?p=4600:110:&SESSION.::&DEBUG.::P110_ASSOCIATED_APP,P110_ASSOCIATED_PAGE:&FB_FLOW_ID.,&FB_FLOW_PAGE_ID.'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/p4500_utilities_menu
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(3741507057557)
,p_name=>'P4500 Utilities Menu'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474639
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3759689081747)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Delete Page'
,p_list_item_link_target=>'f?p=&APP_ID.:21:&SESSION.::&DEBUG.:21:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1557582117917328385)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3741509057557)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Advisor'
,p_list_item_link_target=>'javascript:apex.navigation.popup({ url: ''f?p=&APP_ID.:8101:&SESSION.::&DEBUG.:8101:P8101_PAGE_ID:'' + pe.getCurrentPageId(), width: 1000, height: 800 }); void(0);'
,p_list_text_01=>'pd-advisor'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1557573865167095591)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Caching'
,p_list_item_link_target=>'f?p=&APP_ID.:14:&SESSION.::&DEBUG.:RP,14:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3759733090282)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'History'
,p_list_item_link_target=>'f?p=&APP_ID.:201:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(591681741179830880)
,p_list_item_display_sequence=>65
,p_list_item_link_text=>'Checksum'
,p_list_item_link_target=>'f?p=&APP_ID.:109:&SESSION.::&DEBUG.:109:P109_COMPONENT:PAGE:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3759730086463)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Export'
,p_list_item_link_target=>'f?p=&APP_ID.:637:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1564223914175232731)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(168415028897876470)
,p_list_item_display_sequence=>150
,p_list_item_link_text=>'Show'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(84646475110887465)
,p_list_item_display_sequence=>170
,p_list_item_link_text=>'Tooltips'
,p_parent_list_item_id=>wwv_flow_imp.id(168415028897876470)
,p_list_text_01=>'pd-enable-tooltips'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(168639226669446654)
,p_list_item_display_sequence=>175
,p_list_item_link_text=>'----'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_imp.id(168415028897876470)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(168416197532917059)
,p_list_item_display_sequence=>190
,p_list_item_link_text=>'Layout View'
,p_parent_list_item_id=>wwv_flow_imp.id(168415028897876470)
,p_list_text_01=>'pd-show-layout-view'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(715120241154282785)
,p_list_item_display_sequence=>160
,p_list_item_link_text=>'Layout'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(715121304457300310)
,p_list_item_display_sequence=>200
,p_list_item_link_text=>'Two Pane Mode'
,p_parent_list_item_id=>wwv_flow_imp.id(715120241154282785)
,p_list_text_01=>'pd-two-column'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(715121981042303143)
,p_list_item_display_sequence=>210
,p_list_item_link_text=>'Three Pane Mode'
,p_parent_list_item_id=>wwv_flow_imp.id(715120241154282785)
,p_list_text_01=>'pd-three-column'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(715122647048306435)
,p_list_item_display_sequence=>220
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_imp.id(715120241154282785)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(715123600559310924)
,p_list_item_display_sequence=>230
,p_list_item_link_text=>'Reset Layout'
,p_parent_list_item_id=>wwv_flow_imp.id(715120241154282785)
,p_list_text_01=>'pd-reset-tab-layout'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/application_script_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(940230882533174)
,p_name=>'Application Script Tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474639
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(940613006537413)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'View Install Summary'
,p_list_item_link_target=>'f?p=&APP_ID.:2106:&SESSION.::&DEBUG.:RP:P2106_DEPLOYMENT_FLOW_ID:&FB_FLOW_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(10221704948316206)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Export Application'
,p_list_item_link_target=>'f?p=&APP_ID.:4900:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(23417101078571978)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Install Supporting Objects'
,p_list_item_link_target=>'f?p=&APP_ID.:2100:&SESSION.::&DEBUG.:RP,2100,2101,2102,2103,2105:P2100_CANCEL_PAGE:2:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(57806406935019088)
,p_list_item_display_sequence=>45
,p_list_item_link_text=>'Upgrade Supporting Objects'
,p_list_item_link_target=>'f?p=&APP_ID.:2150:&SESSION.::&DEBUG.:2150:P2150_CANCEL_PAGE:2:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(23486008772829647)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Deinstall Supporting Objects'
,p_list_item_link_target=>'f?p=&APP_ID.:155:&SESSION.::&DEBUG.:155:FB_FLOW_ID,P2110_CANCEL_PAGE:&FB_FLOW_ID.,2:'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>'select 1 from WWV_FLOW_INSTALL where FLOW_ID = :fb_flow_id and sys.dbms_lob.getlength(DEINSTALL_SCRIPT) > 2'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(10173510414062342)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Remove All Supporting Objects'
,p_list_item_link_target=>'f?p=&APP_ID.:632:&SESSION.::&DEBUG.:632:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(4800287802045379)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Create Data Package'
,p_list_item_link_target=>'f?p=&APP_ID.:6000:&SESSION.::&DEBUG.:6000:P850_SCRIPT_SOURCE:DATA:'
,p_security_scheme=>wwv_flow_imp.id(3200591188196688)
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_component_map_background
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(1385199811261560)
,p_name=>'shared.component.map.background'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474639
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1385365419261562)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Map Backgrounds'
,p_list_item_link_target=>'f?p=&APP_ID.:6100:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1385708105261562)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Utilization'
,p_list_item_link_target=>'f?p=&APP_ID.:6140:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1386107393261562)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'History'
,p_list_item_link_target=>'f?p=&APP_ID.:6150:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/working_copy_main_app_menu
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(1415423878169192)
,p_name=>'Working Copy Main App Menu'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474639
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1415696030169193)
,p_list_item_display_sequence=>5
,p_list_item_link_text=>'Create Working Copy'
,p_list_item_link_target=>'f?p=&APP_ID.:5310:&SESSION.::&DEBUG.:5310:FB_FLOW_ID:&FB_FLOW_ID.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(287944139440737541)
,p_list_item_display_sequence=>7
,p_list_item_link_text=>'---'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1416041769169194)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Working Copies'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_working_copy_dev.app_has_working_copy( ',
'    p_application_id    => :FB_FLOW_ID,',
'    p_security_group_id => :WORKSPACE_ID )'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'TARGET_PAGE'
,p_sub_list_id=>wwv_flow_imp.id(1421615343198967)
);
end;
/
prompt --application/shared_components/navigation/lists/working_copies_for_main_app_menu
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(1421615343198967)
,p_name=>'Working Copies (For Main App Menu)'
,p_list_type=>'SQL_QUERY'
,p_list_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null as level1,',
'       a.working_copy_name || '' - '' || a.id  as label,',
'       wwv_flow_utilities.prepare_url(',
'           ''f?p=4000:'' ||',
'           case',
'             when :APP_PAGE_ID = 4500 ',
'              and exists ( select null ',
'                             from wwv_flow_steps ',
'                            where id = :FB_FLOW_PAGE_ID ',
'                              and flow_id = a.id ',
'                              and security_group_id = :WORKSPACE_ID )',
'             then ''4500''',
'             else ''1''',
'           end || '':'' || :app_session || ''::::'' ||',
'           ''FB_FLOW_ID,F4000_P1_FLOW,RECENT_PAGES:'' ||',
'           a.id || '','' || a.id ) as target,',
'       ''NO'' as is_current_list_entry',
'  from wwv_working_copy_apps_dev a',
' where exists ',
'   (select null ',
'      from wwv_main_apps_dev ',
'     where id = :FB_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID',
'       and a.import_orig_app_id = id',
'   )',
'   and security_group_id = :WORKSPACE_ID',
'   and import_orig_app_id != id',
'order by a.id'))
,p_list_status=>'PUBLIC'
,p_version_scn=>62802544
);
end;
/
prompt --application/shared_components/navigation/lists/working_copy_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(1444976166319775)
,p_name=>'Working Copy Tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474639
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1449964168319778)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Create Working Copy'
,p_list_item_link_target=>'f?p=&APP_ID.:5310:&SESSION.::&DEBUG.:5310:FB_FLOW_ID:&FB_FLOW_ID.:'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_working_copy_dev.is_main_app (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_security_group_id => :WORKSPACE_ID )',
'',
''))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1450389761319778)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Merge into Main'
,p_list_item_link_target=>'f?p=&APP_ID.:5300:&SESSION.:DIFF:&DEBUG.:5300,5301,5302:FB_FLOW_ID,P5300_REVERSE,P5300_ACTION,P5300_COMPARE_ONLY:&FB_FLOW_ID.,N,MERGE_BACK_TO_MAIN,N:'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_working_copy_dev.is_working_copy( ',
'    p_application_id    => :FB_FLOW_ID,',
'    p_security_group_id => :WORKSPACE_ID )'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1450770091319778)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Refresh Working Copy'
,p_list_item_link_target=>'f?p=&APP_ID.:5300:&SESSION.:DIFF:&DEBUG.:5300,5301,5302:FB_FLOW_ID,P5300_REVERSE,P5300_ACTION,P5300_COMPARE_ONLY:&FB_FLOW_ID.,Y,REFRESH_FROM_MAIN,N:'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_working_copy_dev.is_working_copy( ',
'    p_application_id    => :FB_FLOW_ID,',
'    p_security_group_id => :WORKSPACE_ID )'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1451192036319778)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Compare Changes'
,p_list_item_link_target=>'f?p=&APP_ID.:5300:&SESSION.:DIFF:&DEBUG.:5300,5301,5302:FB_FLOW_ID,P5300_COMPARE_ONLY,P5300_REVERSE,P5300_ACTION:&FB_FLOW_ID.,Y,N,COMPARE_WITH_MAIN:'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_working_copy_dev.is_working_copy( ',
'    p_application_id    => :FB_FLOW_ID,',
'    p_security_group_id => :WORKSPACE_ID )'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_taskdefs_navigation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(1507124731460473)
,p_name=>'shared.components.taskdefs.navigation'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474639
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1507349964460476)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Task Definitions'
,p_list_item_link_target=>'f?p=&APP_ID.:9500:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2800349004582069)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Utilization'
,p_list_item_link_target=>'f?p=&APP_ID.:9508:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1508196532460478)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'History'
,p_list_item_link_target=>'f?p=&APP_ID.:9507:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_workflows_navigation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(1518491468091534)
,p_name=>'shared.components.workflows.navigation'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474639
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1518697790091541)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Workflows'
,p_list_item_link_target=>'f?p=&APP_ID.:9601:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1518953063091542)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Utilization'
,p_list_item_link_target=>'f?p=&APP_ID.:9603:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1519319136091543)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'History'
,p_list_item_link_target=>'f?p=&APP_ID.:9602:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_workflows
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(1601510944576262)
,p_name=>'shared.components.workflows'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474639
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1601767746576283)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Task Definitions'
,p_list_item_link_target=>'f?p=&APP_ID.:9500:&SESSION.::&DEBUG.::::'
,p_list_text_01=>'&P9_TASK_DEFINITIONS.'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(231803343077607847)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Automations'
,p_list_item_link_target=>'f?p=&APP_ID.:7020:&SESSION.::&DEBUG.::::'
,p_list_text_01=>'&P9_AUTOMATIONS.'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1477707101570684)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Workflows'
,p_list_item_link_target=>'f?p=&APP_ID.:9601:&SESSION.::&DEBUG.::::'
,p_list_text_01=>'&P9_WORKFLOWS.'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_component_search_config
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(1693027045185449)
,p_name=>'shared.component.search.config'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474639
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1693298408185461)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Search Configurations'
,p_list_item_link_target=>'f?p=&APP_ID.:3100:&APP_SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1693671632185462)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Utilization'
,p_list_item_link_target=>'f?p=&APP_ID.:3121:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1694028045185463)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'History'
,p_list_item_link_target=>'f?p=&APP_ID.:3122:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_report_query_edit_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(1730363137427210)
,p_name=>'shared.components.report_query.edit.tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>76460168
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1731345882427212)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Utilization'
,p_list_item_link_target=>'f?p=&APP_ID.:1130:&SESSION.::&DEBUG.:RP,CIR:IR_DISPLAY_NAME:\&P1116_NAME.\:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_search_config
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(1957878877823352)
,p_name=>'Wizard Create Search Config'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474639
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1958041589823362)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Detail'
,p_list_item_link_target=>'f?p=&APP_ID.:3111:&APP_SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1958406596823363)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Source'
,p_list_item_link_target=>'f?p=&APP_ID.:3112:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'3112,3113,3118'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1958879393823363)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Column Mapping'
,p_list_item_link_target=>'f?p=&APP_ID.:3114:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/email_template_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(2010986589661811)
,p_name=>'Email Template Tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474639
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2011158465661823)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Copy from another app'
,p_list_item_link_target=>'f?p=&APP_ID.:120:&SESSION.::&DEBUG.:120:P120_COPY_SOURCE:OTHER:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2011568042661825)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Refresh Subscriptions'
,p_list_item_link_target=>'f?p=&APP_ID.:6:&SESSION.::&DEBUG.:6:P6_COMPONENT_TYPE:EMAIL_TEMPLATE:'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from wwv_flow_email_templates',
' where :APP_PAGE_ID      = 4860',
'   and reference_id      is not null',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/rest_source_catalog_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(2036513182725270)
,p_name=>'REST Source Catalog Tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474639
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2038981474767972)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Import Catalog'
,p_list_item_link_target=>'f?p=&APP_ID.:460:&SESSION.::&DEBUG.:RP,460:P460_FILE_TYPE,P460_CANCEL_TARGET:CATALOG,&APP_PAGE_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2039418623771813)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Export Catalog'
,p_list_item_link_target=>'f?p=&APP_ID.:1965:&SESSION.::&DEBUG.:RP,1965:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2036724084725272)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Manage Catalog Groups'
,p_list_item_link_target=>'f?p=&APP_ID.:1968:&SESSION.::&DEBUG.:RP,1968:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/list_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(2205558900359981)
,p_name=>'List Tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>57136890
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2205723258359989)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Copy from another app'
,p_list_item_link_target=>'f?p=&APP_ID.:663:&SESSION.::&DEBUG.:663:P663_COPY_SOURCE:OTHER:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2206115522359992)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Refresh Subscriptions'
,p_list_item_link_target=>'f?p=&APP_ID.:6:&SESSION.::&DEBUG.:6:P6_COMPONENT_TYPE:LIST:'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from wwv_flow_lists',
' where :APP_PAGE_ID      = 405',
'   and reference_id      is not null',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_email_templates_navigation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(2306436841283369)
,p_name=>'shared.components.email_templates.navigation'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474639
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2306693158283381)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Email Templates'
,p_list_item_link_target=>'f?p=&APP_ID.:4860:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2307095200283385)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Utilization'
,p_list_item_link_target=>'f?p=&APP_ID.:4862:&APP_SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3100533916025399)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'History'
,p_list_item_link_target=>'f?p=&APP_ID.:4863:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/map_background_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(2317463565649817)
,p_name=>'Map Background Tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>7567153
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2317651761649818)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Copy from another app'
,p_list_item_link_target=>'f?p=&APP_ID.:6130:&SESSION.::&DEBUG.:6130:P6130_COPY_SOURCE:OTHER:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2318011007649819)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Refresh Subscriptions'
,p_list_item_link_target=>'f?p=&APP_ID.:6:&SESSION.::&DEBUG.:6:P6_COMPONENT_TYPE:MAP_BACKGROUND:'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from wwv_flow_map_backgrounds',
' where :APP_PAGE_ID      = 6100',
'   and reference_id      is not null',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_ai_servers
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(2400998349683334)
,p_name=>'shared.components.ai_servers'
,p_list_status=>'PUBLIC'
,p_version_scn=>1102235179
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2401126596683336)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Generative AI Services'
,p_list_item_link_target=>'f?p=&APP_ID.:9800:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2401536442683338)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Utilization'
,p_list_item_link_target=>'f?p=&APP_ID.:9803:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2401976402683338)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'History'
,p_list_item_link_target=>'f?p=&APP_ID.:9804:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/authorization_scheme_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(2513428566412576)
,p_name=>'Authorization Scheme Tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474639
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2514224288420608)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Utilization'
,p_list_item_link_target=>'f?p=&APP_ID.:340:&SESSION.::&DEBUG.:340:P340_AUTHORIZATION_SCHEME:&F4000_P4008_ID.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/component_settings_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(2565914177260747)
,p_name=>'Component Settings Tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>7233166
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2566793965294912)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Refresh Subscriptions'
,p_list_item_link_target=>'f?p=&APP_ID.:6:&SESSION.::&DEBUG.:6:P6_COMPONENT_TYPE:PLUGIN_SETTINGS:'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from wwv_flow_plugin_settings',
' where reference_id      is not null',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and plugin            like ''NATIVE\_%'' escape ''\''',
'   and :APP_PAGE_ID      = 4445'))
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3295344744545271)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Edit Plug-in'
,p_list_item_link_target=>'f?p=&APP_ID.:4410:&SESSION.::&DEBUG.:4410:P4410_ID:&P4446_PLUGIN_ID.:'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>':APP_PAGE_ID = 4446'
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/extension_links_menu
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(2601789395872251)
,p_name=>'Extension Links Menu'
,p_list_type=>'SQL_QUERY'
,p_list_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select lev,',
'       label,',
'       target,',
'       null     as is_current,',
'       null     as image,',
'       null     as image_attrib,',
'       null     as image_alt_attribute,',
'       null     as attribute1,',
'       null     as attribute2,',
'       null     as attribute3,',
'       null     as attribute4,',
'       null     as attribute5,',
'       ''_blank'' as attribute6,',
'       null     as attribute7,',
'       null     as attribute8,',
'       null     as attribute9,',
'       null     as attribute10',
'  from (',
'          select 1                          as lev,',
'                 name                       as label,',
'                 wwv_extension.get_url(url) as target,',
'                 null                       as wsname,',
'                 display_sequence',
'            from wwv_extension_links',
'           where security_group_id = :workspace_id',
'          union all',
'          select 1                                           as lev,',
'                 nvl(eg.menu_label, initcap(c.display_name)) as label,',
'                 null                                        as target,',
'                 c.display_name                              as wsname,',
'                 0                                           as display_sequence',
'            from wwv_extension_grants eg, wwv_flow_companies c',
'           where eg.security_group_id           = :workspace_id',
'             and eg.extension_security_group_id = c.provisioning_company_id',
'             and exists (',
'                   select 1',
'                     from wwv_extension_links l',
'                    where l.security_group_id = eg.extension_security_group_id',
'                      and is_public           = ''Y'' )',
'          union all',
'          select 2                             as lev,',
'                 name                          as label,',
'                 wwv_extension.get_url(el.url) as target,',
'                 eg.wsname                     as wsname,',
'                 el.display_sequence',
'            from (',
'                    select eg.*,',
'                           c.display_name as wsname',
'                      from wwv_extension_grants eg, wwv_flow_companies c',
'                     where eg.security_group_id           = :workspace_id',
'                       and eg.extension_security_group_id = c.provisioning_company_id',
'                 )                         eg, wwv_extension_links el',
'           where el.security_group_id = eg.extension_security_group_id',
'             and el.is_public         = ''Y''',
'       )',
' order by wsname nulls first, lev, display_sequence, label'))
,p_list_status=>'PUBLIC'
,p_reference_id=>2000133062045966
,p_version_scn=>40349138
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_automations_navigation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(2700189206621868)
,p_name=>'shared.components.automations.navigation'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474639
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2700397035621879)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Automations'
,p_list_item_link_target=>'f?p=&APP_ID.:7020:&APP_SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2700767814621880)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Execution Log'
,p_list_item_link_target=>'f?p=&APP_ID.:7025:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'7025,7026'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2701101624621880)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'History'
,p_list_item_link_target=>'f?p=&APP_ID.:7027:&APP_SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/workspace_utilities
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(2778715503937249)
,p_name=>'Workspace Utilities'
,p_list_status=>'PUBLIC'
,p_version_scn=>1473517444
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(699057997282634091)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'All Workspace Utilities'
,p_list_item_link_target=>'f?p=&APP_ID.:182:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'1500'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(525225511743184058)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'REST Enabled SQL Services'
,p_list_item_link_target=>'f?p=&APP_ID.:1600:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-ords-rest'
,p_list_text_01=>'Manage references to external REST Enabled SQL services.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2603322302536738)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Generative AI'
,p_list_item_link_target=>'f?p=&APP_ID.:9800:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-apex-assistant-settings'
,p_list_text_01=>'Configure Generative AI Services.'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(533164636995207229)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Remote Servers'
,p_list_item_link_target=>'f?p=&APP_ID.:1931:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-database-object'
,p_list_text_01=>'Manage Remote Server objects used for REST Data Sources and Authentications.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(91019908621880192)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Application Groups'
,p_list_item_link_target=>'f?p=&APP_ID.:722:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'icon-util-app-groups'
,p_list_text_01=>'Organize applications into logical groups.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'722'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(522749587305194510)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Web Credentials'
,p_list_item_link_target=>'f?p=&APP_ID.:1620:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-security-profiles'
,p_list_text_01=>'Manage secure credentials to connect to REST Enabled SQL or other REST services.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(113574116563879249)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Workspace Themes'
,p_list_item_link_target=>'f?p=&APP_ID.:763:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-workspace-themes'
,p_list_text_01=>'Manage workspace themes that can be utilized by any application within the workspace.'
,p_translate_list_text_y_n=>'Y'
,p_security_scheme=>wwv_flow_imp.id(12511519296310366)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'763'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(787290498859273399)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Export ...'
,p_list_item_link_target=>'f?p=&APP_ID.:4900:&SESSION.::&DEBUG.::FB_FLOW_ID::'
,p_list_item_icon=>'icon-util-export-repository'
,p_list_text_01=>'Export workspace components.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(201138622968628415)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'&PRODUCT_NAME. Views'
,p_list_item_link_target=>'f?p=&APP_ID.:714:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-apex-views'
,p_list_text_01=>'Query the various views against &PRODUCT_NAME. metadata.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'714,905'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47677831332249228)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Cross Application Reports'
,p_list_item_link_target=>'f?p=&APP_ID.:9009:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-cross-app-reports'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_list_item_disp_condition=>'182'
,p_list_text_01=>'Review various attribute, comparison, security and UI reports for the workspace..'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'9009'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(70887011747382286)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'Manage Backups'
,p_list_item_link_target=>'f?p=&APP_ID.:970:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-apex-backup'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_backup.backup_limit() > 0'
,p_list_item_disp_condition2=>'PLSQL'
,p_list_text_01=>'View and manage backups across applications in this workspace'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2035130738670100)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>'REST Source Catalogs'
,p_list_item_link_target=>'f?p=&APP_ID.:1960:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-sc-data-references'
,p_list_text_01=>'Manage catalogs of REST Sources for integration into applications'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/static_files_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(3004906169504692)
,p_name=>'Static Files Tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474639
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3005130715504693)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Synchronize Files'
,p_list_item_link_target=>'f?p=&APP_ID.:1852:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(415631017807348421)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'View Object Storage Files'
,p_list_item_link_target=>'f?p=&APP_ID.:1853:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/working_copy_menu
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(3056785755622754)
,p_name=>'Working Copy Menu'
,p_list_status=>'PUBLIC'
,p_version_scn=>66283056
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3056984287622755)
,p_list_item_display_sequence=>5
,p_list_item_link_text=>'Switch to Main'
,p_list_item_link_target=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.::FB_FLOW_ID,F4000_P1_FLOW,RECENT_PAGES:&MAIN_APP_ID.,&MAIN_APP_ID.:'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>':APP_PAGE_ID != 4500'
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3434657502537094)
,p_list_item_display_sequence=>5
,p_list_item_link_text=>'Switch to Main'
,p_list_item_link_target=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_ID,F4000_P1_FLOW:&MAIN_APP_ID.,&MAIN_APP_ID.:'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':APP_PAGE_ID = 4500 ',
'and exists ( ',
'  select null',
'    from wwv_flow_steps ',
'   where id                = :FB_FLOW_PAGE_ID ',
'     and flow_id           = :FB_FLOW_ID',
'     and security_group_id = :WORKSPACE_ID )'))
,p_list_item_disp_condition2=>'SQL'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3196442522307274)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Working Copies'
,p_list_item_current_type=>'TARGET_PAGE'
,p_sub_list_id=>wwv_flow_imp.id(3208183252105812)
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3060391563642790)
,p_list_item_display_sequence=>11
,p_list_item_link_text=>'---'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3057332780622755)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Merge into Main'
,p_list_item_link_target=>'f?p=&APP_ID.:5300:&SESSION.:DIFF:&DEBUG.:5300,5301,5302:FB_FLOW_ID,P5300_REVERSE,P5300_ACTION,P5300_COMPARE_ONLY:&FB_FLOW_ID.,N,MERGE_BACK_TO_MAIN,N:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3057702603622755)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Refresh Working Copy'
,p_list_item_link_target=>'f?p=&APP_ID.:5300:&SESSION.:DIFF:&DEBUG.:5300,5301,5302:FB_FLOW_ID,P5300_REVERSE,P5300_ACTION,P5300_COMPARE_ONLY:&FB_FLOW_ID.,Y,REFRESH_FROM_MAIN,N:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3058172302622756)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Compare Working Copy with Main'
,p_list_item_link_target=>'f?p=&APP_ID.:5300:&SESSION.:DIFF:&DEBUG.:5300,5301,5302:FB_FLOW_ID,P5300_COMPARE_ONLY,P5300_REVERSE,P5300_ACTION:&FB_FLOW_ID.,Y,N,COMPARE_WITH_MAIN:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2801814564779905)
,p_list_item_display_sequence=>41
,p_list_item_link_text=>'Compare Current Page with Main'
,p_list_item_link_target=>'f?p=&APP_ID.:5335:&SESSION.::&DEBUG.:5335:P5335_RIGHT_ID,P5335_COMPARING_MAIN:&MAIN_APP_ID.,Y:'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_EQUALS_CONDITION'
,p_list_item_disp_condition=>'4500'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3460032743050184)
,p_list_item_display_sequence=>45
,p_list_item_link_text=>'View Working Copy Details'
,p_list_item_link_target=>'f?p=&APP_ID.:5305:&SESSION.::&DEBUG.:5305:P5305_ID,P5305_LAST_APP_ID,P5305_LAST_PAGE_ID:&FB_FLOW_ID.,&APP_ID.,&APP_PAGE_ID.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3060629417642791)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'---'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3058578033622756)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Delete Working Copy'
,p_list_item_link_target=>'f?p=&APP_ID.:5320:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/p9600_utilities_menu
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(3115558112261397)
,p_name=>'P9600 Utilities Menu'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474639
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3118921804261393)
,p_list_item_display_sequence=>150
,p_list_item_link_text=>'Show'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3119723180261392)
,p_list_item_display_sequence=>170
,p_list_item_link_text=>'Tooltips'
,p_parent_list_item_id=>wwv_flow_imp.id(3118921804261393)
,p_list_text_01=>'pd-enable-tooltips'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3120135136261392)
,p_list_item_display_sequence=>175
,p_list_item_link_text=>'----'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_imp.id(3118921804261393)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3119321922261392)
,p_list_item_display_sequence=>160
,p_list_item_link_text=>'Layout'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3120963070261392)
,p_list_item_display_sequence=>200
,p_list_item_link_text=>'Two Pane Mode'
,p_parent_list_item_id=>wwv_flow_imp.id(3119321922261392)
,p_list_text_01=>'pd-two-column'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3121313705261391)
,p_list_item_display_sequence=>210
,p_list_item_link_text=>'Three Pane Mode'
,p_parent_list_item_id=>wwv_flow_imp.id(3119321922261392)
,p_list_text_01=>'pd-three-column'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3121701073261391)
,p_list_item_display_sequence=>220
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_imp.id(3119321922261392)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3122158759261391)
,p_list_item_display_sequence=>230
,p_list_item_link_text=>'Reset Layout'
,p_parent_list_item_id=>wwv_flow_imp.id(3119321922261392)
,p_list_text_01=>'pd-reset-tab-layout'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/working_copies_for_working_copy_menu
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(3208183252105812)
,p_name=>'Working Copies (For Working Copy Menu)'
,p_list_type=>'SQL_QUERY'
,p_list_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null as level1,',
'       a.working_copy_name || '' - '' || a.id  as label,',
'       wwv_flow_utilities.prepare_url(',
'           ''f?p=4000:'' ||',
'           case',
'             when :APP_PAGE_ID = 4500 ',
'              and exists ( select null ',
'                             from wwv_flow_steps ',
'                            where id = :FB_FLOW_PAGE_ID ',
'                              and flow_id = a.id ',
'                              and security_group_id = :WORKSPACE_ID )',
'             then ''4500''',
'             else ''1''',
'           end || '':'' || :app_session || ''::::'' ||',
'           ''FB_FLOW_ID,F4000_P1_FLOW,RECENT_PAGES:'' ||',
'           a.id || '','' || a.id ) as target,',
'       ''NO'' as is_current_list_entry,',
'       case ',
'       when a.id = :FB_FLOW_ID then ''icon-check'' ',
'       else null',
'       end as image',
'  from wwv_working_copy_apps_dev a',
' where exists ',
'   (select null ',
'      from wwv_working_copy_apps_dev ',
'     where id = :FB_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID',
'       and a.import_orig_app_id = import_orig_app_id',
'   )',
'   and security_group_id = :WORKSPACE_ID',
'   and import_orig_app_id != id',
'order by a.id'))
,p_list_status=>'PUBLIC'
,p_version_scn=>62802619
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_data_load_method
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(3306223094711954)
,p_name=>'Wizard Create Data Load Method'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474639
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3306442061711970)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Method'
,p_list_item_link_target=>'f?p=&APP_ID.:1815:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3306814575711971)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Copy From'
,p_list_item_link_target=>'f?p=&APP_ID.:1816:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3307245062711971)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Copy'
,p_list_item_link_target=>'f?p=&APP_ID.:1817:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/report_layout_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(3621584740178712)
,p_name=>'Report Layout Tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474639
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3621723734178714)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Copy from another app'
,p_list_item_link_target=>'f?p=&APP_ID.:1122:&SESSION.::&DEBUG.:1122:P1122_COPY_SOURCE:OTHER:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3622133921178716)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Refresh Subscriptions'
,p_list_item_link_target=>'f?p=&APP_ID.:6:&SESSION.::&DEBUG.:6:P6_COMPONENT_TYPE:REPORT_LAYOUT:'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from wwv_flow_report_layouts',
' where :APP_PAGE_ID      = 1400',
'   and reference_id      is not null',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/rest_catalog_services_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(3816997850663267)
,p_name=>'REST Catalog Services Tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474639
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3817572751663269)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Export Catalog'
,p_list_item_link_target=>'f?p=&APP_ID.:1965:&SESSION.::&DEBUG.:RP,1965:P1965_CATALOG_ID:&P1963_CATALOG_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3817166638663268)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Refresh Catalog'
,p_list_item_link_target=>'f?p=&APP_ID.:1967:&SESSION.::&DEBUG.:RP,1967:P1967_ID:&P1963_CATALOG_ID.:'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null ',
'from wwv_web_src_catalogs ',
'where security_group_id = :WORKSPACE_ID ',
'and id = :P1963_CATALOG_ID ',
'and endpoint_url is not null'))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_application_process_navigation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(4020210037479119)
,p_name=>'shared.components.application_process.navigation'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474639
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(4030001947619598)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Application Processes'
,p_list_item_link_target=>'f?p=&APP_ID.:4207:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4207'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(11000225909481279)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'History'
,p_list_item_link_target=>'f?p=&APP_ID.:42:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'42'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_data_load_definitions
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(4115808439009126)
,p_name=>'Wizard Create Data Load Definitions'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474639
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(4116092287009128)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Target'
,p_list_item_link_target=>'f?p=&APP_ID.:1811:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'1810,1811,1812'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(4201581850045538)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Sample Data'
,p_list_item_link_target=>'f?p=&APP_ID.:1810:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'1810,1811,1812'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(4201904650049010)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Map Columns'
,p_list_item_link_target=>'f?p=&APP_ID.:1812:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'1810,1811,1812'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(4202527391061819)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Navigation Menu'
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_user_interface_dev.supports_tabs (',
'                   p_application_id     => :FB_FLOW_ID );'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(4202874397063680)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Tabs'
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_user_interface_dev.supports_tabs (',
'           p_application_id => :FB_FLOW_ID );'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
end;
/
prompt --application/shared_components/navigation/lists/application_setting_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(4229347245662858)
,p_name=>'Application Setting Tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474639
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(4229502782662872)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Copy from another app'
,p_list_item_link_target=>'f?p=&APP_ID.:4852:&SESSION.::&DEBUG.:4852:P4852_COPY_SOURCE:OTHER:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(4229984091662873)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Refresh Subscriptions'
,p_list_item_link_target=>'f?p=&APP_ID.:6:&SESSION.::&DEBUG.:6:P6_COMPONENT_TYPE:APP_SETTING:'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from wwv_flow_app_settings',
' where :APP_PAGE_ID      = 4850',
'   and reference_id      is not null',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/build_option_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(4232641859826655)
,p_name=>'Build Option Tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474639
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(4233474343841029)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Copy from another app'
,p_list_item_link_target=>'f?p=&APP_ID.:4912:&SESSION.::&DEBUG.:4912:P4912_COPY_SOURCE:OTHER:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(6345111830118127)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Refresh Subscriptions'
,p_list_item_link_target=>'f?p=&APP_ID.:6:&SESSION.::&DEBUG.:6:P6_COMPONENT_TYPE:BUILD_OPTION:'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from wwv_flow_patches',
' where :APP_PAGE_ID      = 4910',
'   and reference_id      is not null',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/working_copies
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(4415388010910357)
,p_name=>'Working Copies'
,p_list_type=>'SQL_QUERY'
,p_list_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null as level1,',
'       a.working_copy_name || '' - '' || a.id  as label,',
'       htmldb_util.prepare_url(''f?p=4000:1:''||:app_session||''::::FB_FLOW_ID,F4000_P1_FLOW,RECENT_PAGES:''||a.id||'',''||a.id) as target,',
'       ''NO'' as is_current_list_entry',
'  from wwv_working_copy_apps_dev a',
' where exists ',
'   (select null ',
'      from wwv_main_apps_dev ',
'     where id = :FB_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID',
'       and a.import_orig_app_id = id',
'   )',
'   and security_group_id = :WORKSPACE_ID',
'   and import_orig_app_id != id',
'order by a.id'))
,p_list_status=>'PUBLIC'
,p_version_scn=>72474639
);
end;
/
prompt --application/shared_components/navigation/lists/working_copy_main_application
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(4415554118934819)
,p_name=>'Working Copy Main Application'
,p_list_type=>'SQL_QUERY'
,p_list_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null as level1,',
'       a1.name || '' - '' || a1.id  as label,',
'       htmldb_util.prepare_url(''f?p=4000:1:''||:app_session||''::::FB_FLOW_ID,F4000_P1_FLOW,RECENT_PAGES:''||a1.id||'',''||a1.id) as target,',
'       ''NO'' as is_current_list_entry',
'  from wwv_flows a1,',
'       wwv_flows a2',
' where a2.id = :fb_flow_id',
'   and a1.id = a2.import_orig_app_id',
'   and a1.security_group_id = :WORKSPACE_ID',
'   and a2.security_group_id = :WORKSPACE_ID',
'   and exists ( select null ',
'                  from wwv_main_apps_dev ',
'                 where id = a2.import_orig_app_id ',
'                   and security_group_id = a2.security_group_id)'))
,p_list_status=>'PUBLIC'
,p_version_scn=>72474639
);
end;
/
prompt --application/shared_components/navigation/lists/application_item_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(4419912902081041)
,p_name=>'Application Item Tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474639
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(4420390011087518)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Copy from another app'
,p_list_item_link_target=>'f?p=&APP_ID.:4120:&SESSION.::&DEBUG.:4120:P4120_COPY_SOURCE:OTHER:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(6609288994544526)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Refresh Subscriptions'
,p_list_item_link_target=>'f?p=&APP_ID.:6:&SESSION.::&DEBUG.:6:P6_COMPONENT_TYPE:APP_ITEM:'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from wwv_flow_items',
' where :APP_PAGE_ID      = 4100',
'   and reference_id      is not null',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/application_process_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(4433238684424109)
,p_name=>'Application Process Tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474639
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(4433402264424110)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Copy from another app'
,p_list_item_link_target=>'f?p=&APP_ID.:4209:&SESSION.::&DEBUG.:4209:P4209_COPY_SOURCE:OTHER:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(6625750427963082)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Refresh Subscriptions'
,p_list_item_link_target=>'f?p=&APP_ID.:6:&SESSION.::&DEBUG.:6:P6_COMPONENT_TYPE:APP_PROCESS:'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from wwv_flow_processing',
' where :APP_PAGE_ID      = 4207',
'   and reference_id      is not null',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/application_computation_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(4439523336547769)
,p_name=>'Application Computation Tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474639
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(4439782431547769)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Copy from another app'
,p_list_item_link_target=>'f?p=&APP_ID.:4102:&SESSION.::&DEBUG.:4102:P4102_COPY_SOURCE:OTHER:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(6631681536662153)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Refresh Subscriptions'
,p_list_item_link_target=>'f?p=&APP_ID.:6:&SESSION.::&DEBUG.:6:P6_COMPONENT_TYPE:APP_COMPUTATION:'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from wwv_flow_computations',
' where :APP_PAGE_ID      = 4101',
'   and reference_id      is not null',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/application_access_control_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(4484441724644222)
,p_name=>'Application Access Control Tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>7588409
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(4484943964655292)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Copy Role from another app'
,p_list_item_link_target=>'f?p=&APP_ID.:2330:&SESSION.::&DEBUG.:2330:P2330_COPY_SOURCE:OTHER:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(4821524862332532)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Refresh Subscriptions'
,p_list_item_link_target=>'f?p=&APP_ID.:6:&SESSION.::&DEBUG.:6:P6_COMPONENT_TYPE:APP_ACL:'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from wwv_flow_fnd_user_groups',
' where :APP_PAGE_ID      = 2300',
'   and reference_id      is not null',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/shortcut_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(4583987353560664)
,p_name=>'Shortcut Tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>54204601
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(4584158145560664)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Copy from another app'
,p_list_item_link_target=>'f?p=&APP_ID.:132:&SESSION.::&DEBUG.:132:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(4584519585560665)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Refresh Subscriptions'
,p_list_item_link_target=>'f?p=&APP_ID.:6:&SESSION.::&DEBUG.:6:P6_COMPONENT_TYPE:SHORTCUT:'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from wwv_flow_shortcuts',
' where :APP_PAGE_ID      = 4047',
'   and reference_id      is not null',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/create_installation_script
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(4589709522084091)
,p_name=>'Create Installation Script'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474639
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(4590429608089842)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Method'
,p_list_item_link_target=>'f?p=&APP_ID.:850:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'850'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(4611332135223026)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>'Script Attributes'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'nvl(:P850_MODE,''INSTALL'') in (''INSTALL'',''UPGRADE'')'
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'855,6000'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(4591211039093928)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Define Script'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'856:857:858:578:669:6001'
);
end;
/
prompt --application/shared_components/navigation/lists/text_message_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(4604973800825488)
,p_name=>'Text Message Tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474641
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(4606199463842049)
,p_list_item_display_sequence=>5
,p_list_item_link_text=>'Grid Edit'
,p_list_item_link_target=>'f?p=&APP_ID.:888:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(4605155244825491)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Copy from another app'
,p_list_item_link_target=>'f?p=&APP_ID.:4007:&SESSION.::&DEBUG.:4007:P4007_COPY_SOURCE:OTHER:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(6651984101001000)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Refresh Subscriptions'
,p_list_item_link_target=>'f?p=&APP_ID.:6:&SESSION.::&DEBUG.:6:P6_COMPONENT_TYPE:MESSAGE:'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from wwv_flow_messages$',
' where :APP_PAGE_ID      = 4006',
'   and reference_id      is not null',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/run_page
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(4717527352803690)
,p_name=>'run.page'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474641
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(4717913977809214)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Run Page &FB_FLOW_PAGE_ID.'
,p_list_item_link_target=>'f?p=&APP_ID.:RUN_PAGE:&SESSION.:BRANCH_TO_PAGE_ACCEPT:&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID,F4000_P1_FLOW:&FB_FLOW_ID.,&FB_FLOW_PAGE_ID.,&FB_FLOW_ID.:'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_steps p,',
'       wwv_flows f',
' where p.flow_id = :FB_FLOW_ID',
'   and p.id      = :FB_FLOW_PAGE_ID',
'   and f.id      = p.flow_id',
'   and ( f.global_page_id  <> :FB_FLOW_PAGE_ID',
'       or f.global_page_id is null',
'       )'))
,p_list_text_01=>'runPage'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(5741512908621046)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Edit Page &FB_FLOW_PAGE_ID.'
,p_list_item_link_target=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID:&FB_FLOW_ID.,&FB_FLOW_PAGE_ID.:'
,p_list_text_01=>'editPage'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1521230401042075)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Shared Components'
,p_list_item_link_target=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_list_item_disp_condition=>'9'
,p_list_text_01=>'sharedComponents'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(445219706544405464)
,p_list_item_display_sequence=>35
,p_list_item_link_text=>'Application Utilities'
,p_list_item_link_target=>'f?p=&APP_ID.:674:&SESSION.::&DEBUG.::::'
,p_list_text_01=>'utilities'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(123487516760321097)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Export Page &FB_FLOW_PAGE_ID.'
,p_list_item_link_target=>'f?p=&APP_ID.:164:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID,FB_FLOW_ID:&FB_FLOW_PAGE_ID.,&FB_FLOW_ID.:'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'23,268,201,523,8'
,p_list_text_01=>'export'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(4844126798254470)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Find'
,p_list_item_link_target=>'javascript:popUpNamed(''f?p=4000:273:&SESSION.:::RP:F4000_P273_PAGE:&FB_FLOW_PAGE_ID.'',''Finder'');'
,p_list_text_01=>'findItem'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/script_tabs
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(4852514958421306)
,p_name=>'Script Tabs'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474641
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(24081006745684565)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Script Properties'
,p_list_item_link_target=>'javascript:pageSubmit(''APPLY_CHANGES_328'');'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'328'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(4853228464425278)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Script Editor'
,p_list_item_link_target=>'javascript:pageSubmit(''APPLY_CHANGES_865'');'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'865'
);
end;
/
prompt --application/shared_components/navigation/lists/authentication_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(4883690711914138)
,p_name=>'Authentication Tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>57962467
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(4883881654914138)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Copy from another app'
,p_list_item_link_target=>'f?p=&APP_ID.:816:&SESSION.::&DEBUG.:816:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(4884218511914137)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Refresh Subscriptions'
,p_list_item_link_target=>'f?p=&APP_ID.:6:&SESSION.::&DEBUG.:6:P6_COMPONENT_TYPE:AUTHENTICATION:'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from wwv_flow_authentications',
' where :APP_PAGE_ID      = 801',
'   and reference_id      is not null',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_tree_navigation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(4884503079390537)
,p_name=>'shared.components.tree.navigation'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474641
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(4888317947398805)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Trees'
,p_list_item_link_target=>'f?p=&APP_ID.:28:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'28'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(4889111693401694)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Utilization'
,p_list_item_link_target=>'f?p=&APP_ID.:202:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>'select 1 from WWV_FLOW_TREES where flow_id = :fb_flow_id'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'202'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(11042723644717174)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'History'
,p_list_item_link_target=>'f?p=&APP_ID.:45:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'45'
);
end;
/
prompt --application/shared_components/navigation/lists/websrcmodule_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(4900739432788654)
,p_name=>'websrcmodule.tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>69606594
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(4901345879788687)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Manage Synchronization'
,p_list_item_link_target=>'f?p=&APP_ID.:1951:&SESSION.::&DEBUG.:1951:P1951_WEB_SRC_MODULE_ID:&P1921_WEB_SRC_MODULE_ID.:'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>':P1921_REFERENCE_ID is null'
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2700581299603832)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'REST Source Catalogs'
,p_list_item_link_target=>'f?p=&APP_ID.:1960:&SESSION.::&DEBUG.:1960:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/page_tasks_4301
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(5093603989423342)
,p_name=>'Page Tasks 4301'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474641
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(5093917495427251)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Delete Multiple Pages'
,p_list_item_link_target=>'f?p=&APP_ID.:339:&SESSION.::&DEBUG.::FB_FLOW_ID:&FB_FLOW_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(5094530439440376)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Manage Page Groups'
,p_list_item_link_target=>'f?p=&APP_ID.:520:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(5094707714443306)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Manage Page Locks'
,p_list_item_link_target=>'f?p=&APP_ID.:291:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/component_group_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(5960568658265871)
,p_name=>'Component Group Tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>7171559
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(5960786431265872)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Copy from another app'
,p_list_item_link_target=>'f?p=&APP_ID.:6202:&SESSION.::&DEBUG.:6202:P6202_COPY_SOURCE:OTHER:'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/finder_tabs
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(6207014968942318)
,p_name=>'Finder Tabs'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474645
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(12888222063068359)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Items'
,p_list_item_link_target=>'f?p=&APP_ID.:273:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'273'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(6208031937947265)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Pages'
,p_list_item_link_target=>'f?p=&APP_ID.:516:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'516'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(6284502070657757)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Queries'
,p_list_item_link_target=>'f?p=&APP_ID.:527:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'527'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(6207727781946089)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Tables'
,p_list_item_link_target=>'f?p=&APP_ID.:514:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'514'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(60548519958087566)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'PL/SQL'
,p_list_item_link_target=>'f?p=&APP_ID.:431:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'431'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(451355613725606074)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Debug'
,p_list_item_link_target=>'f?p=&APP_ID.:19:&SESSION.::&DEBUG.:RIR,19:IR_APPLICATION_ID,IR_PAGE_ID:&FB_FLOW_ID.,&F4000_P34_PAGE.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'939,19'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(451401219021090108)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Session'
,p_list_item_link_target=>'f?p=&APP_ID.:34:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'34'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(483658821697886476)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'Errors'
,p_list_item_link_target=>'f?p=&APP_ID.:959:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'959'
);
end;
/
prompt --application/shared_components/navigation/lists/list_item_edit_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(6276618987043262)
,p_name=>'list item edit tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474645
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(6277013577051156)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Change Parent List'
,p_list_item_link_target=>'f?p=&APP_ID.:4053:&SESSION.::&DEBUG.:4053:P4053_ID:&F4000_P4052_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_security
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(6730409642972302)
,p_name=>'shared.components.security'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474645
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(131581022927862632)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Security Attributes'
,p_list_item_link_target=>'f?p=&APP_ID.:509:&SESSION.::&DEBUG.:509:FB_FLOW_ID,509_FB_UPD_ID:&FB_FLOW_ID.,&FB_FLOW_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(6731321416975780)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Authentication Schemes'
,p_list_item_link_target=>'f?p=&APP_ID.:801:&SESSION.::&DEBUG.::::'
,p_list_text_01=>'&P9_AUTHN_SCHEMES.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(6731930074978251)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Authorization Schemes'
,p_list_item_link_target=>'f?p=&APP_ID.:4070:&SESSION.::&DEBUG.::::'
,p_list_text_01=>'&P9_AUTHZ_SCHEMES.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(715703720905977567)
,p_list_item_display_sequence=>35
,p_list_item_link_text=>'Application Access Control'
,p_list_item_link_target=>'f?p=&APP_ID.:2300:&SESSION.::&DEBUG.:RP,2300:::'
,p_list_text_01=>'&P9_APP_ACCESS_ROLES.'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(107341512439481992)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Session State Protection'
,p_list_item_link_target=>'f?p=&APP_ID.:510:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(154637234323820007)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Web Credentials'
,p_list_item_link_target=>'f?p=&APP_ID.:1620:&SESSION.::&DEBUG.:1620:::'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_text_03=>'has-arrow'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_user_interface
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(6736213021992272)
,p_name=>'shared.components.user.interface'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474645
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(355051223966396435)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'User Interface Attributes'
,p_list_item_link_target=>'f?p=&APP_ID.:197:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(106530626957945061)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Progressive Web App'
,p_list_item_link_target=>'f?p=&APP_ID.:507:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(716516312898369111)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Themes'
,p_list_item_link_target=>'f?p=&APP_ID.:260:&SESSION.::&DEBUG.::::'
,p_list_text_01=>'&P9_THEMES.'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(136592605767706703)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Templates'
,p_list_item_link_target=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.::::'
,p_list_text_01=>'&P9_TEMPLATES.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(6742208088009777)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Lists of Values'
,p_list_item_link_target=>'f?p=&APP_ID.:4110:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(6744131637016530)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Shortcuts'
,p_list_item_link_target=>'f?p=&APP_ID.:4047:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(27476131766793984)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Plug-ins'
,p_list_item_link_target=>'f?p=&APP_ID.:4400:&SESSION.::&DEBUG.:RP:::'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(14966220663089761)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Component Settings'
,p_list_item_link_target=>'f?p=&APP_ID.:4445:&SESSION.::&DEBUG.:RP:::'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'NEVER'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(231777605877531934)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Email Templates'
,p_list_item_link_target=>'f?p=&APP_ID.:4860:&SESSION.::&DEBUG.::::'
,p_list_text_01=>'&P9_EMAIL_TEMPLATES.'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_navigation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(6746028090034478)
,p_name=>'shared.components.navigation'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474645
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(6747207789038012)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Lists'
,p_list_item_link_target=>'f?p=&APP_ID.:405:&SESSION.::&DEBUG.:RIR:::'
,p_list_text_01=>'&P9_LISTS.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1404393804983091259)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>'Navigation Menu'
,p_list_item_link_target=>'f?p=&APP_ID.:405:&SESSION.::&DEBUG.:RIR:IR_IS_NAVMENU:1:'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_themes',
'  where flow_id = :fb_flow_id ',
'     and security_group_id = :flow_security_group_id ',
'     and navigation_type = ''L'''))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(6748930298044550)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Tabs (Legacy)'
,p_list_item_link_target=>'f?p=&APP_ID.:643:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_themes',
'  where flow_id = :fb_flow_id ',
'     and security_group_id = :flow_security_group_id ',
'     and navigation_type <> ''L'''))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(6748216793040621)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Breadcrumbs'
,p_list_item_link_target=>'f?p=&APP_ID.:546:&SESSION.::&DEBUG.::::'
,p_list_text_01=>'&P9_BREADCRUMBS.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(6748621987042177)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Classic Navigation Bar Entries'
,p_list_item_link_target=>'f?p=&APP_ID.:4005:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flows',
'where nav_bar_type = ''NAVBAR''',
'   and id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1418265896610430063)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Navigation Bar List'
,p_list_item_link_target=>'f?p=&APP_ID.:405:&SESSION.::&DEBUG.:RIR:IR_IS_NAVBAR:1:'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flows',
'where nav_bar_type = ''LIST''',
'   and id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2100634388116864)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Search Configurations'
,p_list_item_link_target=>'f?p=&APP_ID.:3100:&SESSION.::&DEBUG.::::'
,p_list_text_01=>'&P9_SEARCH_CONFIGS.'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_component_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(6753822621133458)
,p_name=>'shared component tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>1006126700
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(204067027873902941)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Export Application Components'
,p_list_item_link_target=>'f?p=&APP_ID.:688:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(23409530421523625)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Manage Supporting Objects'
,p_list_item_link_target=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(694983664029694709)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Edit Application Comment'
,p_list_item_link_target=>'f?p=&APP_ID.:4310:&SESSION.::&DEBUG.::F4000_P4310_ID:&FB_FLOW_ID.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(185215606520315768)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Developer Comments'
,p_list_item_link_target=>'f?p=&APP_ID.:606:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(185215915524318393)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Developer Comments Calendar'
,p_list_item_link_target=>'f?p=&APP_ID.:594:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_translations
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(6868813338465446)
,p_name=>'shared.components.translations'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474645
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(131583418902870966)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Globalization Attributes'
,p_list_item_link_target=>'f?p=&APP_ID.:506:&SESSION.::&DEBUG.:506:FB_FLOW_ID:&FB_FLOW_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(6873620180486312)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Text Messages'
,p_list_item_link_target=>'f?p=&APP_ID.:4006:&SESSION.::&DEBUG.::::'
,p_list_text_01=>'&P9_TEXT_MESSAGES.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(6870414162475145)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Application Translations'
,p_list_item_link_target=>'f?p=&APP_ID.:4761:&SESSION.::&DEBUG.::::'
,p_list_text_01=>'&P9_APP_TRANSLATIONS.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_files
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(6874810268492937)
,p_name=>'shared.components.files'
,p_list_status=>'PUBLIC'
,p_version_scn=>4607631
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(9999913109548888)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Static Application Files'
,p_list_item_link_target=>'f?p=&APP_ID.:40:&SESSION.::&DEBUG.::::'
,p_list_text_01=>'&P9_APP_FILES.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(6777811617190566)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Static Workspace Files'
,p_list_item_link_target=>'f?p=&APP_ID.:312:&SESSION.::&DEBUG.:RP:::'
,p_list_text_01=>'&P9_WORKSPACE_FILES.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(231782854585563204)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Report Layouts'
,p_list_item_link_target=>'f?p=&APP_ID.:1400:&SESSION.::&DEBUG.::::'
,p_list_text_01=>'&P9_REPORT_LAYOUTS.'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(231782518871563201)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Report Queries'
,p_list_item_link_target=>'f?p=&APP_ID.:1100:&SESSION.::&DEBUG.::::'
,p_list_text_01=>'&P9_REPORT_QUERIES.'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/application_monitor_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(7285601119000778)
,p_name=>'Application Monitor Tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474645
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(7286509084003017)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Monitor Workspace Activity'
,p_list_item_link_target=>'f?p=4350:22:&SESSION.::NO:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(35256609257872204)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'View Developer Comments'
,p_list_item_link_target=>'f?p=&APP_ID.:606:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/authorization_scheme_tasks_subscribe
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(7570344622934033)
,p_name=>'Authorization Scheme Tasks - Subscribe'
,p_list_status=>'PUBLIC'
,p_version_scn=>57143615
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(7570551178934032)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Copy from another app'
,p_list_item_link_target=>'f?p=&APP_ID.:185:&SESSION.::&DEBUG.:185:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(7570941883934032)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Refresh Subscriptions'
,p_list_item_link_target=>'f?p=&APP_ID.:6:&SESSION.::&DEBUG.:6:P6_COMPONENT_TYPE:AUTHORIZATION:'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from wwv_flow_security_schemes',
' where :APP_PAGE_ID      = 4070',
'   and reference_id      is not null',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_process2
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(8047824983989923)
,p_name=>'Wizard Create Process2'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474645
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_summarypage
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(8771208191950732)
,p_name=>'wizard_SummaryPage'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474645
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(8776908610965769)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Page Attributes'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'5100'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(12306121730146667)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>'Navigation Menu'
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_user_interface_dev.supports_tabs (',
'                     p_application_id     => :FB_FLOW_ID );'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1523948471338130108)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>'Tabs'
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_user_interface_dev.supports_tabs (',
'           p_application_id => :FB_FLOW_ID );'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(8878700445197468)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Item Attributes'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'5105'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(9251713948619425)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Summary Items'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'5110'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(7559603306884347)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Confirm'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'303'
);
end;
/
prompt --application/shared_components/navigation/lists/supporting_objects_installation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(10025113710400997)
,p_name=>'Supporting Objects Installation'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474645
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(10025907954408780)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Prerequisites'
,p_list_item_link_target=>'f?p=&APP_ID.:631:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(10026522499412995)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Application Substitution Strings '
,p_list_item_link_target=>'f?p=&APP_ID.:17:&SESSION.::&DEBUG.::::'
,p_list_text_01=>'&P2_SUBSTR_CNT.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(19115930214978417)
,p_list_item_display_sequence=>45
,p_list_item_link_text=>'Build Options'
,p_list_item_link_target=>'f?p=&APP_ID.:511:&SESSION.::&DEBUG.::::'
,p_list_text_01=>'&P2_BUILD_OPT_CNT.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(10026826654414177)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Pre-installation Validations'
,p_list_item_link_target=>'f?p=&APP_ID.:445:&SESSION.::&DEBUG.:RP:::'
,p_list_text_01=>'&P2_PRE_INS_VAL_CNT.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(10117115357770425)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Installation Scripts'
,p_list_item_link_target=>'f?p=&APP_ID.:473:&SESSION.::&DEBUG.:RP:::'
,p_list_text_01=>'&P2_INST_SCRIPT_CNT.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47099730350498293)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Messages'
,p_list_item_link_target=>'f?p=&APP_ID.:567:&SESSION.::&DEBUG.::FB_FLOW_ID:&FB_FLOW_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/supporting_objects_deinstallation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(10121209647806692)
,p_name=>'Supporting Objects Deinstallation'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474645
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(10122025231811196)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Deinstallation Script'
,p_list_item_link_target=>'f?p=&APP_ID.:576:&SESSION.::&DEBUG.::::'
,p_list_text_01=>'&P2_DE_INS_SCRIPT_CNT.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47101131567536488)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Deinstallation Message'
,p_list_item_link_target=>'f?p=&APP_ID.:567:&SESSION.::&DEBUG.::FB_FLOW_ID:&FB_FLOW_ID.#DEINSTALL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/lists_of_values_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(10662051819310192)
,p_name=>'Lists of Values Tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>60052682
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(10662275996310190)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Copy from another app'
,p_list_item_link_target=>'f?p=&APP_ID.:138:&SESSION.::&DEBUG.:138:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(10662646727310189)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Refresh Subscriptions'
,p_list_item_link_target=>'f?p=&APP_ID.:6:&SESSION.::&DEBUG.:6:P6_COMPONENT_TYPE:LOV:'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from wwv_flow_lists_of_values$',
' where :APP_PAGE_ID      = 4110',
'   and reference_id      is not null',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/data_load_definition_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(10878966511822167)
,p_name=>'Data Load Definition Tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>60806241
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(10879156418822165)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Copy from another app'
,p_list_item_link_target=>'f?p=&APP_ID.:1816:&SESSION.::&DEBUG.:1816:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(10879583440822164)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Refresh Subscriptions'
,p_list_item_link_target=>'f?p=&APP_ID.:6:&SESSION.::&DEBUG.:6:P6_COMPONENT_TYPE:DATA_LOAD:'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select l.*',
'  from wwv_flow_load_tables l',
' where :APP_PAGE_ID      = 1800',
'   and l.reference_id      is not null',
'   and l.flow_id           = :FB_FLOW_ID',
'   and l.security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/workspace_static_files_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(10900130470111258)
,p_name=>'Workspace Static Files Tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474645
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(10900385148111269)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Export Workspace Static Files'
,p_list_item_link_target=>'f?p=&APP_ID.:688:&SESSION.::&DEBUG.:CR,688,MULTI_COMPONENT_EXPORT:IR[APP_COMPONENTS]EQ_TYPE_NAME:&P312_WS_STATIC_FILE.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_web_service_navigation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(11271810048283515)
,p_name=>'shared.components.web_service.navigation'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474645
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(11272321130286719)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Web Service References'
,p_list_item_link_target=>'f?p=&APP_ID.:170:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'170'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(11279906285310777)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'History'
,p_list_item_link_target=>'f?p=&APP_ID.:63:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'63'
);
end;
/
prompt --application/shared_components/navigation/lists/page_branch_navigation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(11286824340344465)
,p_name=>'page.branch.navigation'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474645
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(194567927186940748)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Utilities'
,p_list_item_link_target=>'f?p=&APP_ID.:881:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'881:563:885'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(11287304385348126)
,p_list_item_display_sequence=>64
,p_list_item_link_text=>'History'
,p_list_item_link_target=>'f?p=&APP_ID.:64:&SESSION.::&DEBUG.:RIR:IR_PAGE_ID:&FB_FLOW_PAGE_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'64'
);
end;
/
prompt --application/shared_components/navigation/lists/page_process_navigation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(11322022496485821)
,p_name=>'page.process.navigation'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474645
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(193857202841290851)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Utilities'
,p_list_item_link_target=>'f?p=&APP_ID.:482:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'482:213:552:866'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(11323227822496829)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'History'
,p_list_item_link_target=>'f?p=&APP_ID.:65:&SESSION.::&DEBUG.:RIR:IR_PAGE_ID:&FB_FLOW_PAGE_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'65'
);
end;
/
prompt --application/shared_components/navigation/lists/create_breadcrumb
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(11694125812505020)
,p_name=>'create breadcrumb'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474645
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(11694630293505024)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Breadcrumb'
,p_list_item_link_target=>'f?p=&APP_ID.:288:&SESSION.:'
,p_list_item_current_for_pages=>'288'
);
end;
/
prompt --application/shared_components/navigation/lists/search_configuration_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(12263103496827474)
,p_name=>'Search Configuration Tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>62106554
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(12263360554827473)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Copy from another app'
,p_list_item_link_target=>'f?p=&APP_ID.:3116:&SESSION.::&DEBUG.:3116:P3116_COPY_SOURCE:OTHER:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(12263759073827472)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Refresh Subscriptions'
,p_list_item_link_target=>'f?p=&APP_ID.:6:&SESSION.::&DEBUG.:6:P6_COMPONENT_TYPE:SEARCH_CONFIG:'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from wwv_flow_search_configs',
' where :APP_PAGE_ID      = 3100',
'   and reference_id      is not null',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/page_region_view_mode
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(12991522578387911)
,p_name=>'page.region.view.mode'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474645
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(22186214630159256)
,p_list_item_display_sequence=>115
,p_list_item_link_text=>'Definition'
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_CALENDAR_DEFINITION'');'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'122,697,670,661,836,80'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'697'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(22153400161060412)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>'Monthly Calendar'
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_MONTHLY_CALENDAR'');'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'122,697,670,661,836,80'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'122'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(16872109954486071)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>'Weekly Calendar'
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_WEEKLY_CALENDAR'');'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'122,697,670,661,836,80'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'670'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(16872929001491541)
,p_list_item_display_sequence=>140
,p_list_item_link_text=>'Daily Calendar'
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_DAILY_CALENDAR'');'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'122,697,670,661,836,80'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'661'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(30766002077732772)
,p_list_item_display_sequence=>150
,p_list_item_link_text=>'Custom Calendar'
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_CUSTOM_CALENDAR'');'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'122,697,670,661,836,80'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'836'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3696311919048128)
,p_list_item_display_sequence=>200
,p_list_item_link_text=>'List Calendar'
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_AGENDA_CALENDAR'');'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'122,697,670,661,836,80'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'80'
);
end;
/
prompt --application/shared_components/navigation/lists/rest_data_source_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(13061782984169455)
,p_name=>'REST Data Source tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>11300218
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(13061918740169454)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Copy from another app'
,p_list_item_link_target=>'f?p=&APP_ID.:1906:&SESSION.::&DEBUG.:1906::OTHER:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(13062390937169453)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Refresh Subscriptions'
,p_list_item_link_target=>'f?p=&APP_ID.:6:&SESSION.::&DEBUG.:6:P6_COMPONENT_TYPE:WEB_SOURCE:'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from wwv_flow_web_src_modules',
' where :APP_PAGE_ID      = 1901',
'   and reference_id      is not null',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/page_region_navigation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(13987931263515071)
,p_name=>'page.region.navigation'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474645
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(189958910147635012)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Utilities'
,p_list_item_link_target=>'f?p=&APP_ID.:853:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'853:249:480:70:157:438:459:128:247:217:212:864:136:690'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(11228932521987173)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'History'
,p_list_item_link_target=>'f?p=&APP_ID.:60:&SESSION.::&DEBUG.:RIR:IR_PAGE_ID:&FB_FLOW_PAGE_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'60'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_component_settings_navigation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(14972101971160040)
,p_name=>'shared.components.component_settings.navigation'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474645
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(14972319391160042)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Component Settings'
,p_list_item_link_target=>'f?p=&APP_ID.:4445:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(14972912989160044)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'History'
,p_list_item_link_target=>'f?p=&APP_ID.:4447:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/cross_application_reports_comparison
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(15030113309394959)
,p_name=>'Cross Application Reports / Comparison'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474645
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(15030613786404487)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Application Comparison'
,p_list_item_link_target=>'f?p=&APP_ID.:1300:&SESSION.:NORUN:&DEBUG.::::'
,p_list_item_icon=>'icon-util-app-compare'
,p_list_text_01=>'Query differences in component names.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(17208701402593062)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Component Summary Counts'
,p_list_item_link_target=>'f?p=&APP_ID.:1301:&SESSION.:NORUN:&DEBUG.::::'
,p_list_item_icon=>'icon-util-component-counts'
,p_list_text_01=>'Query differences in component counts.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_component_load_tables
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(15132926917246073)
,p_name=>'shared.component.load.tables'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474645
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(15133112993246073)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Data Load Definitions'
,p_list_item_link_target=>'f?p=&APP_ID.:1800:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2902795457911853)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Utilization'
,p_list_item_link_target=>'f?p=&APP_ID.:1821:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(15134306858246075)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'History'
,p_list_item_link_target=>'f?p=&APP_ID.:1808:&SESSION.:'
,p_list_item_current_for_pages=>'1808'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_form_on_ws
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(15577802944637145)
,p_name=>'wizard_form_on_ws'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474645
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(15578929956644992)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Page Attributes'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'605'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(15579201690646275)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Navigation Menu'
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_user_interface_dev.supports_tabs (',
'                     p_application_id     => :FB_FLOW_ID );'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1523950262441140962)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Tabs'
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_user_interface_dev.supports_tabs (',
'           p_application_id => :FB_FLOW_ID );'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(15578618528641637)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Choose Service'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'600'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(15579621083651886)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Form Items'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'620:884'
);
end;
/
prompt --application/shared_components/navigation/lists/create_page_introduction
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(15960618523591402)
,p_name=>'create.page.introduction'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474646
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(15961725795593556)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Page'
,p_list_item_link_target=>'f?p=&APP_ID.:2500:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2500,752'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(15962230990595065)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Define'
,p_list_item_link_target=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'500,849'
);
end;
/
prompt --application/shared_components/navigation/lists/create_component_introduction
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(16004105550701290)
,p_name=>'create.component.introduction'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474646
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(16006006374710902)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Identify Control'
,p_list_item_link_target=>'f?p=&APP_ID.:0:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'323,364,336'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'323,364'
);
end;
/
prompt --application/shared_components/navigation/lists/create_menu_with_menu_option
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(16141621180084222)
,p_name=>'create.menu.with.menu.option'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474646
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(16142629838086700)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Region Attributes'
,p_list_item_link_target=>'f?p=&APP_ID.:263:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'263'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(16143922350093999)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Breadcrumb Entry'
,p_list_item_link_target=>'f?p=&APP_ID.:264:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'264'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(16144801703097508)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Confirm'
,p_list_item_link_target=>'f?p=&APP_ID.:286:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'286'
);
end;
/
prompt --application/shared_components/navigation/lists/page_button_navigation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(16353308133052510)
,p_name=>'page.button.navigation'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474646
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(189959220536638052)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Utilities'
,p_list_item_link_target=>'f?p=&APP_ID.:852:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'852:250:446:548:878'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(11249424312117274)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'History'
,p_list_item_link_target=>'f?p=&APP_ID.:61:&SESSION.::&DEBUG.:RIR:IR_PAGE_ID:&FB_FLOW_PAGE_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'61,'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_legacy_data_load_wizard
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(16993520375207189)
,p_name=>'Wizard Create Legacy Data Load Wizard'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474654
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(585808545428825920)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Data Load Table'
,p_list_item_link_target=>'f?p=&APP_ID.:1700:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(585808884340828845)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Transformation Rules'
,p_list_item_link_target=>'f?p=&APP_ID.:1702:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(585809128851831410)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Table Lookups'
,p_list_item_link_target=>'f?p=&APP_ID.:1701:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(20142616358500970)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Pages Attributes'
,p_list_item_link_target=>'f?p=&APP_ID.:1704:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1523936815498664127)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Navigation Menu'
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_user_interface_dev.supports_tabs (',
'                   p_application_id     => :FB_FLOW_ID );'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(16994623223207192)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Tabs'
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_user_interface_dev.supports_tabs (',
'           p_application_id => :FB_FLOW_ID );'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(307986230539557923)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Buttons and Branching'
,p_list_item_link_target=>'f?p=&APP_ID.:1706:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1706'
);
end;
/
prompt --application/shared_components/navigation/lists/home_page_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(17113830931867323)
,p_name=>'home.page.tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474654
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(53347908603459381)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Delete Application'
,p_list_item_link_target=>'f?p=&APP_ID.:2110:&SESSION.::&DEBUG.:RP,2110:FB_FLOW_ID,FB_FLOW_PAGE_ID,P2110_CANCEL_PAGE:&FB_FLOW_ID.,&FB_FLOW_PAGE_ID.,1:'
,p_list_item_icon=>'a-Icon icon-delete-app'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from wwv_flows ',
'where security_group_id = :flow_security_group_id and ',
':app_page_id = ''1'''))
,p_security_scheme=>wwv_flow_imp.id(12472323342703137)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(115201606939032288)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Copy Application'
,p_list_item_link_target=>'f?p=&APP_ID.:499:&SESSION.::&DEBUG.:499,611:FB_FLOW_ID:&FB_FLOW_ID.:'
,p_list_item_icon=>'a-Icon icon-copy-app'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'1'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(212830002493156758)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Page Groups'
,p_list_item_link_target=>'f?p=&APP_ID.:520:&SESSION.::&DEBUG.:RP:FB_FLOW_ID:&FB_FLOW_ID.:'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(34528309073406519)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Page Locks'
,p_list_item_link_target=>'f?p=&APP_ID.:291:&SESSION.::&DEBUG.:RP:::'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47796518629853915)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Dependencies'
,p_list_item_link_target=>'f?p=&APP_ID.:425:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(198461526128088208)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Export Repository'
,p_list_item_link_target=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.:RP:::'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(6831812856407773)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Add Feature Page'
,p_list_item_link_target=>'f?p=&APP_ID.:2500:&SESSION.::&DEBUG.:2500,500,572,575,849,1310,1311,1312,1313,1314,1315,1316,1317:FB_FLOW_ID,P2500_CATEGORY,P2500_PAGE_TYPE:&FB_FLOW_ID.,FEATURE,ABOUTAPP:'
,p_list_item_icon=>'a-Icon icon-add-feature'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'1'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(210726611906133664)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Monitor Workspace Activity'
,p_list_item_link_target=>'f?p=4350:22:&SESSION.'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'71'
,p_security_scheme=>wwv_flow_imp.id(12511519296310366)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(6996930509253802)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Application Dashboard'
,p_list_item_link_target=>'f?p=&APP_ID.:71:&SESSION.::&DEBUG.::FB_FLOW_ID:&FB_FLOW_ID.:'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'71,300,70'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(4065812606027121)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'Activity Dashboard'
,p_list_item_link_target=>'f?p=&APP_ID.:14:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(70886790977359157)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>'Manage Backups'
,p_list_item_link_target=>'f?p=&APP_ID.:971:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(500599555964351445)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>'Browse by Facets'
,p_list_item_link_target=>'f?p=&APP_ID.:33:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'a-Icon icon-browse-facets'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(179999630626869964)
,p_list_item_display_sequence=>140
,p_list_item_link_text=>'Workflow Designer'
,p_list_item_link_target=>'f?p=&APP_ID.:9600:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'a-Icon icon-workflow-designer'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/page_computation_navigation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(17446232715505772)
,p_name=>'page.computation.navigation'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474654
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(193688712738615625)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Utilities'
,p_list_item_link_target=>'f?p=&APP_ID.:847:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'847:215:549:877'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(17448822934521895)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'History'
,p_list_item_link_target=>'f?p=&APP_ID.:152:&SESSION.::&DEBUG.:RIR:IR_PAGE_ID:&FB_FLOW_PAGE_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'152'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_copy_page
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(18564606387816293)
,p_name=>'wizard Copy Page'
,p_list_status=>'PUBLIC'
,p_version_scn=>80440309
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(203365725936637465)
,p_list_item_display_sequence=>5
,p_list_item_link_text=>'Copy Page Option'
,p_list_item_link_target=>'f?p=&APP_ID.:618:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'618'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(18565123356821261)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Page to Copy'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'301'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(18565729375832463)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Navigation Menu'
,p_list_item_link_target=>'f?p=&APP_ID.:305:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_user_interface_dev.supports_tabs (',
'                     p_application_id     => :FB_FLOW_ID );'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'305:316'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1523947008998118995)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Tabs'
,p_list_item_link_target=>'f?p=&APP_ID.:305:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_user_interface_dev.supports_tabs (',
'           p_application_id => :FB_FLOW_ID );'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'305:316'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(20734321130916756)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'New Names'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'302'
);
end;
/
prompt --application/shared_components/navigation/lists/create_calendar_template
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(19035021988626357)
,p_name=>'create calendar template'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474654
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(19036431470638590)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Create Method'
,p_list_item_link_target=>'f?p=&FLOW_ID.:161:&SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'161'
);
end;
/
prompt --application/shared_components/navigation/lists/report_layout_creation_steps
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(19263904166280419)
,p_name=>'Report Layout Creation Steps'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474654
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(19265711569292026)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Layout Type'
,p_list_item_link_target=>'f?p=&APP_ID.:1401:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1401'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(19266719244398256)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Layout Source'
,p_list_item_link_target=>'f?p=&APP_ID.:1402:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'nvl(:P1401_LAYOUT_TYPE, ''GENERIC'') = ''GENERIC'''
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1736623483749676)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Layout Type'
,p_list_item_link_target=>'f?p=&APP_ID.:1406:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_list_item_disp_condition=>'P1401_LAYOUT_TYPE'
,p_list_item_disp_condition2=>'FILE'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/switch_theme
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(20663215911569971)
,p_name=>'switch.theme'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474654
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(20663630109574042)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Identify Theme'
,p_list_item_link_target=>'f?p=&APP_ID.:179:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'179'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(20664529201583245)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Verify Compatibility'
,p_list_item_link_target=>'f?p=&APP_ID.:386:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'386'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(20670121761618936)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Confirm Switch'
,p_list_item_link_target=>'f?p=&APP_ID.:180:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'180'
);
end;
/
prompt --application/shared_components/navigation/lists/web_service_reference_wizard
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(22410710903630445)
,p_name=>'web service reference wizard'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474654
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(33465030663752652)
,p_list_item_display_sequence=>11
,p_list_item_link_text=>'REST Details'
,p_list_item_link_target=>'f?p=&APP_ID.:871:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_list_item_disp_condition=>'P870_WEB_REFERENCE_TYPE'
,p_list_item_disp_condition2=>'REST'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'871'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(33473413946041089)
,p_list_item_display_sequence=>12
,p_list_item_link_text=>'REST Inputs'
,p_list_item_link_target=>'f?p=&APP_ID.:872:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_list_item_disp_condition=>'P870_WEB_REFERENCE_TYPE'
,p_list_item_disp_condition2=>'REST'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'872'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(33478806692190351)
,p_list_item_display_sequence=>13
,p_list_item_link_text=>'REST Outputs'
,p_list_item_link_target=>'f?p=&APP_ID.:873:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_list_item_disp_condition=>'P870_WEB_REFERENCE_TYPE'
,p_list_item_disp_condition2=>'REST'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'873'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(22495103330356887)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'WSDL Location'
,p_list_item_link_target=>'f?p=&APP_ID.:580:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_list_item_disp_condition=>'P870_WEB_REFERENCE_TYPE'
,p_list_item_disp_condition2=>'WSDL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'580'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(22505817687597564)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Web Service Details'
,p_list_item_link_target=>'f?p=&APP_ID.:585:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_list_item_disp_condition=>'P870_WEB_REFERENCE_TYPE'
,p_list_item_disp_condition2=>'WSDL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'585'
);
end;
/
prompt --application/shared_components/navigation/lists/deployment_tabs
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(22452018965176093)
,p_name=>'deployment tabs'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474654
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(22452810092182983)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Messages'
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_567'')'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'567'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(22521803109426954)
,p_list_item_display_sequence=>2
,p_list_item_link_text=>'Prerequisites'
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_631'')'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'631'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(22503614097373329)
,p_list_item_display_sequence=>3
,p_list_item_link_text=>'Substitutions'
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_17'')'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'17'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(22516317738412258)
,p_list_item_display_sequence=>4
,p_list_item_link_text=>'Build Options'
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_511'')'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'511'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(22484008809315095)
,p_list_item_display_sequence=>7
,p_list_item_link_text=>'Validations'
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_445'')'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'445'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(22468026031263279)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Install'
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_473'')'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'473'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(23543014930276179)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Upgrade'
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_667'')'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'667'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(22498325263357607)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Deinstall'
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_576'')'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'576,579'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(22452401088180364)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Export'
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_633'')'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'633'
);
end;
/
prompt --application/shared_components/navigation/lists/create_shared_query_train
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(22638505565903517)
,p_name=>'create shared query train'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474654
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(5000711144756411)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Create Report Query'
,p_list_item_link_target=>'f?p=&APP_ID.:1105:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(22639713530905876)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Report Query Definition'
,p_list_item_link_target=>'f?p=&APP_ID.:1110:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1110'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(22641406735913386)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Report Query Source'
,p_list_item_link_target=>'f?p=&APP_ID.:1119:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3030845311403559)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Report Query Sources'
,p_list_item_link_target=>'f?p=&APP_ID.:1115:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(22641712623915044)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Confirm'
,p_list_item_link_target=>'f?p=&APP_ID.:1114:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1114'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_reports
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(22726621018248639)
,p_name=>'shared.components.reports'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474654
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(11534830686211676)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Report Queries'
,p_list_item_link_target=>'f?p=&APP_ID.:1100:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(18838121614544449)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Report Layouts'
,p_list_item_link_target=>'f?p=&APP_ID.:1400:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_component_application_attributes
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(23333311543130294)
,p_name=>'shared component application attributes'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474654
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(23334104055137553)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Edit Definition'
,p_list_item_link_target=>'f?p=&APP_ID.:4001:&SESSION.::&DEBUG.::FB_FLOW_ID:&FB_FLOW_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(23346722503199625)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Edit Comments'
,p_list_item_link_target=>'f?p=&APP_ID.:4310:&SESSION.::&DEBUG.::F4000_P4310_ID:&FB_FLOW_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/supporting_object_upgrade
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(23445516456661592)
,p_name=>'Supporting Object Upgrade'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474654
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(23447506544668156)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Upgrade Scripts'
,p_list_item_link_target=>'f?p=&APP_ID.:667:&SESSION.::&DEBUG.::::'
,p_list_text_01=>'&P2_UPG_CNT.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47100700053527309)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Upgrade Message'
,p_list_item_link_target=>'f?p=&APP_ID.:567:&SESSION.::&DEBUG.::FB_FLOW_ID:&FB_FLOW_ID.#UPGRADE'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/copy_application
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(23817524863605164)
,p_name=>'Copy Application'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474654
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(23817717317605164)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Identify Copy Target'
,p_list_item_link_target=>'f?p=&APP_ID.:499:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(23818031260605166)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Confirm'
,p_list_item_link_target=>'f?p=&APP_ID.:611:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'611'
);
end;
/
prompt --application/shared_components/navigation/lists/script_results_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(24172418538839346)
,p_name=>'script results tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474654
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(24173525249850711)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Install Supporting Objects'
,p_list_item_link_target=>'f?p=&APP_ID.:2100:&SESSION.::&DEBUG.::P2100_CANCEL_PAGE:2:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(80633901866542564)
,p_list_item_display_sequence=>2
,p_list_item_link_text=>'Upgrade Supporting Objects'
,p_list_item_link_target=>'f?p=&APP_ID.:2150:&SESSION.::&DEBUG.:2150,2151,2152,2153,2154:P2150_CANCEL_PAGE:2:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(24173116592848238)
,p_list_item_display_sequence=>3
,p_list_item_link_text=>'Deinstall Application'
,p_list_item_link_target=>'f?p=&APP_ID.:2110:&SESSION.::&DEBUG.:2110:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(24257620317868232)
,p_list_item_display_sequence=>4
,p_list_item_link_text=>'Edit Installation Scripts'
,p_list_item_link_target=>'f?p=&APP_ID.:473:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'2106'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(24256800577862502)
,p_list_item_display_sequence=>5
,p_list_item_link_text=>'Manage Supporting Objects'
,p_list_item_link_target=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'2106'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(37122929947493126)
,p_list_item_display_sequence=>6
,p_list_item_link_text=>'Edit Application'
,p_list_item_link_target=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(96986426278147432)
,p_list_item_display_sequence=>7
,p_list_item_link_text=>'Run Application'
,p_list_item_link_target=>'&P2106_HOME_LINK.'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'2106'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(98381926501308170)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'View and Download Single Script'
,p_list_item_link_target=>'f?p=&APP_ID.:432:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :FLOW_PAGE_ID = 473 then',
'  for c1 in (select null',
'             from #OWNER#.wwv_flow_install_scripts',
'             where flow_id = :fb_flow_id ',
'             and security_group_id = :flow_security_group_id',
'             and nvl(script_type,''INSTALL'') = ''INSTALL'')',
'  loop',
'      return true;',
'  end loop;',
'end if;',
'return false;'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(403371215736939990)
,p_list_item_display_sequence=>12
,p_list_item_link_text=>'View and Download Single Script'
,p_list_item_link_target=>'f?p=&APP_ID.:457:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :FLOW_PAGE_ID = 667 then',
'  for c1 in (select 1',
'             from #OWNER#.wwv_flow_install_scripts',
'             where flow_id = :fb_flow_id ',
'             and security_group_id = :flow_security_group_id',
'             and nvl(script_type,''INSTALL'') = ''UPGRADE'')',
'  loop',
'      return true;',
'  end loop;',
'end if;',
'return false;'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(403375103864031484)
,p_list_item_display_sequence=>13
,p_list_item_link_text=>'View and Download Single Script'
,p_list_item_link_target=>'f?p=&APP_ID.:462:&SESSION.::&DEBUG.:462:::'
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :flow_page_id = 576 then',
'  for c1 in (select null',
'             from wwv_flow_install',
'             where flow_id = :fb_flow_id',
'             and security_group_id = :flow_security_group_id',
'             and nvl(sys.dbms_lob.getlength(deinstall_script),0) > 0)',
'  loop',
'      return true;',
'  end loop;',
'end if;',
'return false;',
''))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(236577109798623828)
,p_list_item_display_sequence=>25
,p_list_item_link_text=>'Resequence Scripts'
,p_list_item_link_target=>'f?p=&APP_ID.:802:&SESSION.::&DEBUG.:802:::'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'from wwv_flow_install_scripts',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'and nvl(script_type,''INSTALL'') = ''INSTALL''',
'and :APP_PAGE_ID = 473'))
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(380042987976769926)
,p_list_item_display_sequence=>35
,p_list_item_link_text=>'Resequence Scripts'
,p_list_item_link_target=>'f?p=&APP_ID.:38:&SESSION.::&DEBUG.:38:::'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'from wwv_flow_install_scripts',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'and nvl(script_type,''INSTALL'') = ''UPGRADE''',
'and :APP_PAGE_ID = 667'))
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(4700464872031326)
,p_list_item_display_sequence=>45
,p_list_item_link_text=>'Create Data Package'
,p_list_item_link_target=>'f?p=&APP_ID.:6000:&SESSION.::&DEBUG.:6000:P850_SCRIPT_SOURCE:DATA:'
,p_security_scheme=>wwv_flow_imp.id(3200591188196688)
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/create_dynamic_action
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(25338502483800688)
,p_name=>'create.dynamic_action'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474654
);
end;
/
prompt --application/shared_components/navigation/lists/mb_context_menu
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(25800649414501670)
,p_name=>'MB Context Menu'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474654
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(25800842464501683)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Restore'
,p_list_item_link_target=>'f?p=&APP_ID.:974:&SESSION.::&DEBUG.:974:P974_ID,P974_FLOW_ID:$backupid$,$flowid$:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(25801216993501684)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Download'
,p_list_item_link_target=>'p?n=$objectid$'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(25801607394501685)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'View Details'
,p_list_item_link_target=>'f?p=&APP_ID.:973:&SESSION.::&DEBUG.:973:P973_ID:$backupid$:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(25802068672501685)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Manage Lock'
,p_list_item_link_target=>'f?p=&APP_ID.:976:&SESSION.::&DEBUG.:976:P976_ID:$backupid$:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(25803493813511373)
,p_list_item_display_sequence=>55
,p_list_item_link_text=>'-'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(25803138133508799)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Delete'
,p_list_item_link_target=>'f?p=&APP_ID.:977:&SESSION.::&DEBUG.:977:P977_FLOW_ID,P977_ID:$flowid$,$backupid$:'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/create_application_process
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(25941806450198106)
,p_name=>'create.application.process'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474654
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(25942514415200446)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Identification'
,p_list_item_link_target=>'f?p=&APP_ID.:147:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'147'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(25943018571201605)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Source'
,p_list_item_link_target=>'f?p=&APP_ID.:148:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'148'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(25955304550235459)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Conditionality'
,p_list_item_link_target=>'f?p=&APP_ID.:150:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'150'
);
end;
/
prompt --application/shared_components/navigation/lists/multi_table_create_application
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(26219416632336505)
,p_name=>'multi-table create application'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474658
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(170634803652169586)
,p_list_item_display_sequence=>55
,p_list_item_link_text=>'Shared Components'
,p_list_item_link_target=>'f?p=&APP_ID.:17:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'17:476:433'
);
end;
/
prompt --application/shared_components/navigation/lists/developer_resources
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(26512283167477231)
,p_name=>'developer.resources'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474658
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(26512415103477231)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Font APEX Icons'
,p_list_item_link_target=>'https://apex.oracle.com/fontapex'
,p_list_text_02=>'target="_blank"'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_plugins_edit_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(27884204995681439)
,p_name=>'shared.components.plugins.edit.tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>64861977
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(15025526109384601)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Component Settings'
,p_list_item_link_target=>'f?p=&APP_ID.:4445:&SESSION.::&DEBUG.:4445,CIR:::'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_plugin_dev.has_application_attributes (',
'    p_application_id => :P4410_FLOW_ID,',
'    p_plugin_type    => :P4410_PLUGIN_TYPE,',
'    p_plugin_name    => :P4410_NAME )'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(28084903887018683)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Export Plug-in'
,p_list_item_link_target=>'f?p=&APP_ID.:4460:&SESSION.::&DEBUG.:RP,4460:P4460_PLUGIN_ID:&P4410_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(27884715851681468)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Utilization'
,p_list_item_link_target=>'f?p=&APP_ID.:4420:&SESSION.::&DEBUG.:RP,CIR:IR_DISPLAY_NAME:&P4410_DISPLAY_NAME.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_plugins_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(27943608569240649)
,p_name=>'shared.components.plugins.tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>73082334
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(28086530815045307)
,p_list_item_display_sequence=>25
,p_list_item_link_text=>'Export Plug-in'
,p_list_item_link_target=>'f?p=&APP_ID.:4460:&SESSION.::&DEBUG.:RP,4460:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(13869043349421165)
,p_list_item_display_sequence=>35
,p_list_item_link_text=>'Copy from another app'
,p_list_item_link_target=>'f?p=&APP_ID.:4404:&SESSION.::&DEBUG.:4404:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(13869639751393008)
,p_list_item_display_sequence=>45
,p_list_item_link_text=>'Refresh Subscriptions'
,p_list_item_link_target=>'f?p=&APP_ID.:6:&SESSION.::&DEBUG.:6:P6_COMPONENT_TYPE:PLUGIN:'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from wwv_flow_plugins',
' where :APP_PAGE_ID      = 4400',
'   and reference_id      is not null',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and theme_id          is null'))
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/page_dynamic_action_navigation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(28119925264668131)
,p_name=>'page.dynamic_action.navigation'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474658
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(194156219281175220)
,p_list_item_display_sequence=>25
,p_list_item_link_text=>'Utilities'
,p_list_item_link_target=>'f?p=&APP_ID.:699:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'863:699'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(28120618815675737)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'History'
,p_list_item_link_target=>'f?p=&APP_ID.:795:&SESSION.::&DEBUG.:RIR:IR_PAGE_ID:&FB_FLOW_PAGE_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'795'
);
end;
/
prompt --application/shared_components/navigation/lists/web_service_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(28359907580129646)
,p_name=>'web service tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474662
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(28360319831142579)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Create Web Service Reference Manually'
,p_list_item_link_target=>'f?p=&APP_ID.:199:&SESSION.::&DEBUG.:196:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/synchronize_defaults
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(28511519360309024)
,p_name=>'Synchronize Defaults'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474662
);
end;
/
prompt --application/shared_components/navigation/lists/form_on_ws_with_rpt
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(30094110886480012)
,p_name=>'form_on_ws_with_rpt'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474662
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(30094627509484763)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Choose Service and Operation'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'700'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(30094903052487151)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Page and Region Attributes'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'705'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(30095522099492672)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Input Items'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'720:880'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(22663523536956076)
,p_list_item_display_sequence=>45
,p_list_item_link_text=>'Authentication'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''WS_AUTH_ITEMS'''))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'716'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(30095815304500150)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Web Service Results'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'725:842'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(30096124308502737)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Report Parameters'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'730:882:848'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(30095212402489886)
,p_list_item_display_sequence=>65
,p_list_item_link_text=>'Navigation Menu'
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_user_interface_dev.supports_tabs (',
'                   p_application_id     => :FB_FLOW_ID );'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1556523170111727633)
,p_list_item_display_sequence=>65
,p_list_item_link_text=>'Tabs'
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_user_interface_dev.supports_tabs (',
'           p_application_id => :FB_FLOW_ID );'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(30096432619505205)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Confirm'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'735'
);
end;
/
prompt --application/shared_components/navigation/lists/application_utilities_line3
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(30782715391876326)
,p_name=>'application.utilities.line3'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474662
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(30782921600876331)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Saved Reports'
,p_list_item_link_target=>'f?p=&APP_ID.:37:&SESSION.::&DEBUG.:RP,RIR:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(30783226672876332)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Subscriptions'
,p_list_item_link_target=>'f?p=&APP_ID.:39:&SESSION.::&DEBUG.:RP,RIR:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/caching
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(31086920674251816)
,p_name=>'Caching'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474662
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(31098728732310986)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'All Cached Pages'
,p_list_item_link_target=>'f?p=&APP_ID.:638:&SESSION.::&DEBUG.:RIR:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(31087325522253253)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'All Cached Regions'
,p_list_item_link_target=>'f?p=&APP_ID.:656:&SESSION.::&DEBUG.:RIR:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/sqlquery_on_ws_result
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(31960916110521509)
,p_name=>'sqlquery_on_ws_result'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474662
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(31962812085529789)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Web Reference Information'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'760,775,784'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(31963927323534138)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Report Parameters and Options'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'765,780,790'
);
end;
/
prompt --application/shared_components/navigation/lists/list_utility_options
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(33430506092105266)
,p_name=>'list utility options'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474662
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(33455121161147439)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Copy List'
,p_list_item_link_target=>'f?p=&APP_ID.:663:&SESSION.::&DEBUG.:663:P663_ID:&F4000_P4050_LIST_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(33431712672107181)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Copy List Entries from one List to Another'
,p_list_item_link_target=>'f?p=&APP_ID.:477:&SESSION.::&DEBUG.:477:P477_COPY_LIST_FROM:&F4000_P4050_LIST_ID.:'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_lists',
' where id = :F4000_P4050_LIST_ID ',
'   and list_type = ''STATIC''',
'   and security_group_id = :WORKSPACE_ID'))
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(33434024793110611)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Reparent List Entries within this List'
,p_list_item_link_target=>'f?p=&APP_ID.:2222:&SESSION.::&DEBUG.::P2222_LIST_ID:&F4000_P4050_LIST_ID.:'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_lists',
' where id           = :F4000_P4050_LIST_ID',
'   and list_type    = ''STATIC''',
'   and reference_id is null',
'   and security_group_id = :WORKSPACE_ID'))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(40745428326672193)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Manage Orphaned List Entries'
,p_list_item_link_target=>'f?p=&APP_ID.:712:&SESSION.::&DEBUG.:RP:P712_LIST_ID:&F4000_P4050_LIST_ID.:'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_lists',
' where id           = :F4000_P4050_LIST_ID',
'   and list_type    = ''STATIC''',
'   and reference_id is null',
'   and security_group_id = :WORKSPACE_ID'))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(170300712666400884)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>'Resequence List Entries'
,p_list_item_link_target=>'f?p=&APP_ID.:536:&SESSION.::&DEBUG.::P536_LIST_ID:&F4000_P4050_LIST_ID.:'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_lists',
' where id           = :F4000_P4050_LIST_ID',
'   and list_type    = ''STATIC''',
'   and reference_id is null',
'   and security_group_id = :WORKSPACE_ID'))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/copy_list_entries
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(33731702665524035)
,p_name=>'Copy List Entries'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474662
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(33733202927543059)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Identify Copy Target'
,p_list_item_link_target=>'f?p=&APP_ID.:477:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'477'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(33733511584545617)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Confirm List Entry Copy'
,p_list_item_link_target=>'f?p=&APP_ID.:478:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'478'
);
end;
/
prompt --application/shared_components/navigation/lists/lock_functions
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(34740016606195595)
,p_name=>'lock.functions'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474662
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(34740422493197305)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Page Locks'
,p_list_item_link_target=>'f?p=&APP_ID.:291:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'291'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(34740830804199645)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Lock Administration'
,p_list_item_link_target=>'f?p=&APP_ID.:299:&SESSION.::&DEBUG.::::'
,p_security_scheme=>wwv_flow_imp.id(12511519296310366)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'299'
);
end;
/
prompt --application/shared_components/navigation/lists/standard_tab_management
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(35060712015585948)
,p_name=>'standard.tab.management'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474662
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(35061409029594543)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Move highlighted Standard Tab to a different Parent Tab'
,p_list_item_link_target=>'f?p=&FLOW_ID.:77:&SESSION.::&DEBUG.:::'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from WWV_FLOW_TOPLEVEL_TABS',
' where flow_id = :fb_flow_id'))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(35061718033597155)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Rename Standard Tab Set'
,p_list_item_link_target=>'f?p=&FLOW_ID.:345:&SESSION.::&DEBUG.:::'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>'select 1 from wwv_flow_tabs where flow_id = :fb_flow_id'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(35062024959599144)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Resequence display order'
,p_list_item_link_target=>'f?p=&FLOW_ID.:123:&SESSION.::&DEBUG.:::'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>'select 1 from wwv_flow_tabs where flow_id = :fb_flow_id'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(35062632017610572)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Associate Page(s) with selected Standard Tab'
,p_list_item_link_target=>'f?p=&APP_ID.:9005:&SESSION.::&DEBUG.:9005:F4000_P9005_TAB_ID:&F4000_CUR_STD_TAB.:'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>'select 1 from wwv_flow_tabs where flow_id = :fb_flow_id'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(35097012080765730)
,p_list_item_display_sequence=>45
,p_list_item_link_text=>'Create New Standard Tab'
,p_list_item_link_target=>'f?p=4000:90:&SESSION.::NO:92,94,95,96,4722,4723,4724'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(35063015871615372)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Create New Standard Tab Set'
,p_list_item_link_target=>'f?p=4000:9000:&SESSION.::::F4000_P9000_CUR_PTAB,F4000_CUR_STD_TAB:999999999999,'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/install_progress
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(37438506954816730)
,p_name=>'Install Progress'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474662
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(37439316651819553)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Supporting Objects'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2100:2115'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(37439619768820400)
,p_list_item_display_sequence=>2
,p_list_item_link_text=>'License'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where license_message is not null',
'   and flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2101'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(37440226347822326)
,p_list_item_display_sequence=>3
,p_list_item_link_text=>'Application Substitutions'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where replace(prompt_substitution_01_yn||',
'                 prompt_substitution_02_yn||',
'                 prompt_substitution_03_yn||',
'                 prompt_substitution_04_yn||',
'                 prompt_substitution_05_yn||',
'                 prompt_substitution_06_yn||',
'                 prompt_substitution_07_yn||',
'                 prompt_substitution_08_yn||',
'                 prompt_substitution_09_yn||',
'                 prompt_substitution_10_yn||',
'                 prompt_substitution_11_yn||',
'                 prompt_substitution_12_yn||',
'                 prompt_substitution_13_yn||',
'                 prompt_substitution_14_yn||',
'                 prompt_substitution_15_yn||',
'                 prompt_substitution_16_yn||',
'                 prompt_substitution_17_yn||',
'                 prompt_substitution_18_yn||',
'                 prompt_substitution_19_yn||',
'                 prompt_substitution_20_yn,''N'','''') is not null',
'   and flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2103'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(13556731674021001)
,p_list_item_display_sequence=>4
,p_list_item_link_text=>'Build Options'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install_build_opt',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2107'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(37439922884821393)
,p_list_item_display_sequence=>6
,p_list_item_link_text=>'Validations'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * from wwv_flow_install_checks',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2102:2108'
);
end;
/
prompt --application/shared_components/navigation/lists/import_progress
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(37899301707472090)
,p_name=>'import progress'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474662
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(37899710018474406)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Specify File'
,p_list_item_link_target=>'f?p=&APP_ID.:460:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'460'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(37910625087516631)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Install'
,p_list_item_link_target=>'f?p=&APP_ID.:49:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'49:67:166:409:253:321:598:4450:929:494:612:1966'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(272780339297125857)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Prompts'
,p_list_item_link_target=>'f?p=&APP_ID.:2160:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/repository
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(38836703962860678)
,p_name=>'repository'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474662
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(38837209849862399)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Manage Export Repository'
,p_list_item_link_target=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.:RP:::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'460,163,48,644'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(226337903706179254)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Preview File'
,p_list_item_link_target=>'javascript:popupURL(''f?p=&FLOW_ID.:2120:&SESSION.::&DEBUG.::P2120_FILE_ID:&P163_FILE_ID.'');'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'163,49,48,494,644'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_calendar
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(41547421928169148)
,p_name=>'Wizard Create Calendar'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474664
);
end;
/
prompt --application/shared_components/navigation/lists/home_page_apex_4_0_list
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(46890703166185102)
,p_name=>'Home Page APEX 4.0 list'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474664
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(46891214941188463)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Run Application'
,p_list_item_link_target=>'&F4000_P1_RUN_LINK.'
,p_list_item_icon=>'app-builder-run-app'
,p_list_item_icon_attributes=>'width="128" height="128" alt=""'
,p_list_item_current_type=>'ALWAYS'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(46891420828190182)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Supporting Objects'
,p_list_item_link_target=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'apex-sql-script'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(46891900873193850)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Shared Components'
,p_list_item_link_target=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID:&FB_FLOW_ID.,&FB_FLOW_PAGE_ID.:'
,p_list_item_icon=>'app-builder-shared-components'
,p_list_item_icon_attributes=>'width="128" height="128" alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(177830030226412242)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Utilities'
,p_list_item_link_target=>'f?p=&APP_ID.:674:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'apex-utilities'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(46892107107195637)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Export / Import'
,p_list_item_link_target=>'f?p=&APP_ID.:461:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID:&FB_FLOW_ID.,&FB_FLOW_PAGE_ID.:'
,p_list_item_icon=>'app-builder-export-import'
,p_list_item_icon_attributes=>'width="128" height="128" alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/page_region_utilities_report_regions
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(47104812669691866)
,p_name=>'page.region.utilities.report.regions'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474664
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(492651908993878213)
,p_list_item_display_sequence=>35
,p_list_item_link_text=>'Update Interactive Report Settings'
,p_list_item_link_target=>'f?p=&APP_ID.:940:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(492644402142781679)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Interactive Report Subscriptions'
,p_list_item_link_target=>'f?p=4350:92:&SESSION.::&DEBUG.:RIR:IR_NFLOW_ID:&FB_FLOW_ID.'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/cross_application_reports_security
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(47648606548052805)
,p_name=>'Cross Application Reports / Security'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474664
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47650319458052824)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Security Profiles'
,p_list_item_link_target=>'f?p=&APP_ID.:9014:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-security-profiles'
,p_list_text_01=>'View security details for each application.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47650917494052824)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Authentication Schemes'
,p_list_item_link_target=>'f?p=&APP_ID.:9015:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-auth-scheme'
,p_list_text_01=>'View all authentication schemes for each application.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47650613876052824)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Password Items'
,p_list_item_link_target=>'f?p=&APP_ID.:7777:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-password'
,p_list_text_01=>'Review individual password items and their settings.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/cross_application_reports_user_interface
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(47656832568088745)
,p_name=>'Cross Application Reports / User Interface'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474664
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47658830638088749)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Theme Summary'
,p_list_item_link_target=>'f?p=&APP_ID.:737:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-theme-summary'
,p_list_text_01=>'View the default theme and theme count.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_application_item_navigation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(47807005066095922)
,p_name=>'shared.components.application_item.navigation'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474666
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47807417533099513)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Application Items'
,p_list_item_link_target=>'f?p=&APP_ID.:4100:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4100'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47808827230102390)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Utilization'
,p_list_item_link_target=>'f?p=&APP_ID.:130:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'130'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(192556407703412832)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'History'
,p_list_item_link_target=>'f?p=&APP_ID.:533:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'533'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_application_computation_navigation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(47827519966525945)
,p_name=>'shared.components.application_computation.navigation'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474666
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47827910747532792)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Application Computations'
,p_list_item_link_target=>'f?p=&APP_ID.:4101:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4101'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47828120790535668)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'History'
,p_list_item_link_target=>'f?p=&APP_ID.:43:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'43'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_build_option_navigation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(47909111131552473)
,p_name=>'shared.components.build_option.navigation'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474666
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47909728792557644)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Build Options'
,p_list_item_link_target=>'f?p=&APP_ID.:4910:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4910'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47909902258559446)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Utilization'
,p_list_item_link_target=>'f?p=&APP_ID.:203:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'203'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(192566112775480588)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'History'
,p_list_item_link_target=>'f?p=&APP_ID.:535:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'535'
);
end;
/
prompt --application/shared_components/navigation/lists/install_progress_upgrade
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(48681713885605105)
,p_name=>'Install Progress (Upgrade)'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474666
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(48681921050605105)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Supporting Objects'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2150'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(48682216352605105)
,p_list_item_display_sequence=>2
,p_list_item_link_text=>'License'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where license_message is not null',
'   and flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2151'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(48682518004605105)
,p_list_item_display_sequence=>3
,p_list_item_link_text=>'Application Substitutions'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where replace(prompt_substitution_01_yn||',
'                 prompt_substitution_02_yn||',
'                 prompt_substitution_03_yn||',
'                 prompt_substitution_04_yn||',
'                 prompt_substitution_05_yn||',
'                 prompt_substitution_06_yn||',
'                 prompt_substitution_07_yn||',
'                 prompt_substitution_08_yn||',
'                 prompt_substitution_09_yn||',
'                 prompt_substitution_10_yn||',
'                 prompt_substitution_11_yn||',
'                 prompt_substitution_12_yn||',
'                 prompt_substitution_13_yn||',
'                 prompt_substitution_14_yn||',
'                 prompt_substitution_15_yn||',
'                 prompt_substitution_16_yn||',
'                 prompt_substitution_17_yn||',
'                 prompt_substitution_18_yn||',
'                 prompt_substitution_19_yn||',
'                 prompt_substitution_20_yn,''N'','''') is not null',
'   and flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2153'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(48682805062605105)
,p_list_item_display_sequence=>4
,p_list_item_link_text=>'Build Options'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install_build_opt',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2157'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(48683114640605105)
,p_list_item_display_sequence=>6
,p_list_item_link_text=>'Validations'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * from wwv_flow_install_checks',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2152,2158'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(48683423866605106)
,p_list_item_display_sequence=>7
,p_list_item_link_text=>'Confirmation'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'2154'
);
end;
/
prompt --application/shared_components/navigation/lists/structured_query
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(55535125515641311)
,p_name=>'Structured_Query'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474666
);
end;
/
prompt --application/shared_components/navigation/lists/create_web_reference_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(57083604297327751)
,p_name=>'create_web_reference_tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474666
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1030018641100391162)
,p_list_item_display_sequence=>5
,p_list_item_link_text=>'Create RESTFul Web Reference'
,p_list_item_link_target=>'f?p=&APP_ID.:871:&SESSION.::&DEBUG.:871:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(57084621958332785)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Create Web Reference Manually'
,p_list_item_link_target=>'f?p=&APP_ID.:199:&SESSION.::&DEBUG.:199:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/install_preview_upgrade
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(57809829707044603)
,p_name=>'Install Preview (Upgrade)'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474666
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(57810025849044605)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Preview Upgrade Scripts'
,p_list_item_link_target=>'f?p=&APP_ID.:2109:&SESSION.::&DEBUG.::P2109_MODE:UPGRADE'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/export_install_navigate
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(58916220936178306)
,p_name=>'export.install.navigate'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474666
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(58917130286181031)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Manage Export Repository'
,p_list_item_link_target=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(486309116766298442)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>'Export'
,p_list_item_link_target=>'f?p=&APP_ID.:4900:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_list_item_disp_condition=>'461'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(445307613122457455)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Component Export'
,p_list_item_link_target=>'f?p=&APP_ID.:688:&SESSION.::&DEBUG.:CR:::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_list_item_disp_condition=>'680'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_theme_navigation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(58949101764235429)
,p_name=>'shared.components.theme.navigation'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474666
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1030175014751098308)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Themes'
,p_list_item_link_target=>'f?p=&APP_ID.:260:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(44080124445670825)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Reports'
,p_list_item_link_target=>'f?p=&APP_ID.:173:&SESSION.::&DEBUG.:RP:P173_SHOW:1:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'173,435,491,492'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(193120127053383246)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'History'
,p_list_item_link_target=>'f?p=&APP_ID.:681:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'681'
);
end;
/
prompt --application/shared_components/navigation/lists/view_ui_default
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(59836303269637894)
,p_name=>'view.ui.default'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474666
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(59850310111658783)
,p_list_item_display_sequence=>5
,p_list_item_link_text=>'View Table Defaults'
,p_list_item_link_target=>'javascript:popupURL(''f?p=4000:391:&SESSION.:::391,RP:P391_SCHEMA,P391_TABLE:&UI_SCHEMA.,&UI_TABLE.'');'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_list_item_disp_condition=>'769,4795,4811,4017'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(177740131510804118)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Edit Table Dictionary'
,p_list_item_link_target=>'f?p=4500:802:&SESSION.::NO:RP,802:P800_SCHEMA,P802_TABLE_ID:&UI_SCHEMA.,&UI_TABLE_ID.'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_list_item_disp_condition=>'769,4795,4811,4017'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(491980431480090226)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>'View Attribute Dictionary'
,p_list_item_link_target=>'javascript:popupURL(''f?p=4000:579:&SESSION.:::RIR:P391_SCHEMA:&UI_SCHEMA.'');'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/theme_home_page_utilities
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(60448901162323653)
,p_name=>'theme home page utilities'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474666
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(60452220471348108)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Copy Theme'
,p_list_item_link_target=>'f?p=&FLOW_ID.:401:&SESSION.::&DEBUG.:401::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(60458828136378754)
,p_list_item_display_sequence=>2
,p_list_item_link_text=>'Delete Theme'
,p_list_item_link_target=>'f?p=&APP_ID.:221:&SESSION.::&DEBUG.:221:::'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flows f,',
'       wwv_flow_themes t',
' where f.id                = :FB_FLOW_ID',
'   and f.security_group_id = :WORKSPACE_ID',
'   and t.flow_id           = f.id',
'   and t.theme_id         != f.theme_id',
'   and t.security_group_id = :WORKSPACE_ID'))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(60449412936327043)
,p_list_item_display_sequence=>4
,p_list_item_link_text=>'Export Theme'
,p_list_item_link_target=>'f?p=&FLOW_ID.:224:&SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(60449817785328400)
,p_list_item_display_sequence=>5
,p_list_item_link_text=>'Import Theme'
,p_list_item_link_target=>'f?p=&APP_ID.:460:&SESSION.::&DEBUG.:460:P460_FILE_TYPE,P460_CANCEL_TARGET:THEME,&APP_PAGE_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(60460231384389174)
,p_list_item_display_sequence=>6
,p_list_item_link_text=>'Change Identification Number'
,p_list_item_link_target=>'f?p=&FLOW_ID.:397:&SESSION.::&DEBUG.:397::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1433728355595982335)
,p_list_item_display_sequence=>7
,p_list_item_link_text=>'Restore Theme Subscription'
,p_list_item_link_target=>'f?p=&APP_ID.:117:&SESSION.::&DEBUG.:117:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(112939916055325918)
,p_list_item_display_sequence=>8
,p_list_item_link_text=>'Manage Workspace Themes'
,p_list_item_link_target=>'f?p=&APP_ID.:763:&SESSION.::&DEBUG.:RP,764,789,762:P764_FLOW_ID:&FB_FLOW_ID.:'
,p_security_scheme=>wwv_flow_imp.id(12511519296310366)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_auth_scheme
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(61117217587002695)
,p_name=>'Wizard Create Auth Scheme'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474668
);
end;
/
prompt --application/shared_components/navigation/lists/authorization_reports
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(62154210909909582)
,p_name=>'authorization.reports'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474668
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(62154920044921741)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Report Pages With Authorization Schemes'
,p_list_item_link_target=>'f?p=&APP_ID.:4046:&SESSION.::&DEBUG.:4046:P4046_OPT:1:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(62154609655918761)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Report Pages Without Authorization Schemes'
,p_list_item_link_target=>'f?p=&APP_ID.:4046:&SESSION.::&DEBUG.:4046:P4046_OPT:2:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_list_navigation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(62973516530710918)
,p_name=>'shared.components.list.navigation'
,p_list_status=>'PUBLIC'
,p_version_scn=>69947132
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(16379422446669293)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Lists'
,p_list_item_link_target=>'f?p=&APP_ID.:405:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'405'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(152909708490771744)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Unused'
,p_list_item_link_target=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_lists',
' where flow_id = :fb_flow_id',
'   and security_group_id = :WORKSPACE_ID'))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'10'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(188112617636897422)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Conditional Entries'
,p_list_item_link_target=>'f?p=&APP_ID.:557:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'557'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(3698822128638837)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Utilization'
,p_list_item_link_target=>'f?p=&APP_ID.:156:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_lists',
' where flow_id = :fb_flow_id',
'   and security_group_id = :WORKSPACE_ID',
''))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'156,417'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(11021905065645615)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'History'
,p_list_item_link_target=>'f?p=&APP_ID.:44:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'44'
);
end;
/
prompt --application/shared_components/navigation/lists/p1500_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(63310734885303893)
,p_name=>'p1500 tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474668
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(5800991752119782)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Manage Backups'
,p_list_item_link_target=>'f?p=&APP_ID.:970:&SESSION.::&DEBUG.:970:::'
,p_list_item_icon=>'icon-apex-backup'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2800971278201882)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Export Applications'
,p_list_item_link_target=>'f?p=&APP_ID.:4900:&SESSION.::&DEBUG.:4900:FB_FLOW_ID::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(500597206178327494)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Browse by Facets'
,p_list_item_link_target=>'f?p=&APP_ID.:69:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/breadcrumb_entry_views
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(65506221314219691)
,p_name=>'breadcrumb entry views'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474668
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_button_template
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(79547928409156701)
,p_name=>'Wizard Create Button Template'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474668
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(79552721077160159)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Creation Method'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(79555017842161642)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Details'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'218'
);
end;
/
prompt --application/shared_components/navigation/lists/application_group_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(91618427870317883)
,p_name=>'Application Group Tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474668
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(92285408876511015)
,p_list_item_display_sequence=>2
,p_list_item_link_text=>'Manage Assignments'
,p_list_item_link_target=>'f?p=&APP_ID.:736:&SESSION.::&DEBUG.:RP,736:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(91618806877321244)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Manage Unassigned'
,p_list_item_link_target=>'f?p=&APP_ID.:736:&SESSION.::&DEBUG.:RP,736:P736_SHOW:UNASSIGNED:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/ir_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(91747231305508774)
,p_name=>'ir_tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474668
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(196353019228502005)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'View Saved Report Activity'
,p_list_item_link_target=>'f?p=4350:93:&SESSION.:::RIR,CIR:IR_APPLICATION_ID,IR_PAGE_ID:&FB_FLOW_ID.,&FB_FLOW_PAGE_ID.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(442777026341677254)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Manage Subscriptions'
,p_list_item_link_target=>'f?p=4350:92:&SESSION.:::RIR,CIR:IR_NFLOW_ID,IR_NPAGE_ID:&FB_FLOW_ID.,&FB_FLOW_PAGE_ID.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_interactive_report_page
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(92836304316872750)
,p_name=>'wizard_create_interactive_report_page'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474668
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(92837021977877846)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Page Attributes'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'326,759,98,961'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(92837632366880883)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Navigation Menu'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.page_exists (',
'  p_flow_id => :fb_flow_id, ',
'  p_page_id => :P759_PAGE_ID',
') = false'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1523948867681134525)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Tabs'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.page_exists (',
'  p_flow_id => :fb_flow_id, ',
'  p_page_id => :P759_PAGE_ID',
') = false'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(235189540462900083)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Web Reference Type'
,p_list_item_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_list_item_disp_condition=>'P2500_PAGE_TYPE'
,p_list_item_disp_condition2=>'WEBSERVICE'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'778'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(235190199021968007)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Web Reference Information'
,p_list_item_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_list_item_disp_condition=>'P2500_PAGE_TYPE'
,p_list_item_disp_condition2=>'WEBSERVICE'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'779:781:859'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(235190496270971838)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Parameters and Options'
,p_list_item_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_list_item_disp_condition=>'P2500_PAGE_TYPE'
,p_list_item_disp_condition2=>'WEBSERVICE'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'782:783:860'
);
end;
/
prompt --application/shared_components/navigation/lists/edit_page_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(92837202675352059)
,p_name=>'edit Page Tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474668
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(200213907900661288)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Edit Application Comment'
,p_list_item_link_target=>'f?p=&APP_ID.:4310:&SESSION.::&DEBUG.::F4000_P4310_ID:&FB_FLOW_ID.:'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'4001'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'f?p=4000:4310:&SESSION.::::F4000_P4310_ID:&FB_FLOW_ID.'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(138317724706866221)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Edit Theme &P4003_THEME.'
,p_list_item_link_target=>'f?p=&APP_ID.:267:&SESSION.::&DEBUG.::P267_ID:&P4003_THEME_ID.:'
,p_list_item_disp_cond_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_list_item_disp_condition=>'P4003_THEME'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(31490816073500952)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Add Row Selector'
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_ADD_CHECK'');'
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'    has_row_selector boolean := false;',
'begin',
'    for c1 in (',
'        select 1 from ',
'    	wwv_flow_region_report_column',
'    	where region_id = :P420_REGION_ID',
'    	and column_alias like ''CHECK$%''',
'    ) loop',
'        has_row_selector := true;',
'    end loop;	',
'    return not has_row_selector',
'           and :FLOW_PAGE_ID     = 420',
'           and :P420_REGION_TYPE = wwv_flow_region_native.c_tabform;',
'end;'))
,p_list_item_disp_condition2=>'PLSQL'
,p_required_patch=>wwv_flow_imp.id(121426746309283317)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(36704211967171442)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Add Column Link'
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_ADD_LINK'');'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>':FLOW_PAGE_ID=420'
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(36802112434805591)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Add Derived Column'
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_ADD_COLUMN'');'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>':FLOW_PAGE_ID=420'
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(205489829874815043)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'Theme Reports'
,p_list_item_link_target=>'f?p=&APP_ID.:173:&SESSION.::&DEBUG.::P173_SHOW:1:'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'4003'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(90724807717089029)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>'Replace Templates'
,p_list_item_link_target=>'f?p=&APP_ID.:708:&SESSION.::&DEBUG.:708,711,713:::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'4003'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(95667030632845330)
,p_list_item_display_sequence=>140
,p_list_item_link_text=>'Unsubscribe Templates'
,p_list_item_link_target=>'f?p=&APP_ID.:540:&SESSION.::&DEBUG.:540:::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_list_item_disp_condition=>'4311'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/button_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(97266605334780088)
,p_name=>'Button.Tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474668
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_region
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(99487325551482211)
,p_name=>'Wizard Create Region'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474668
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(99491916062486630)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Display Attributes'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_list_item_disp_condition=>'474'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4016,91,2002,2003,799,313'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(99492810454489250)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Source'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugins',
' where flow_id = case',
'                   when :F4000_P4016_SOURCE_TYPE like ''NATIVE_%'' then 4411',
'                   else to_number(:FB_FLOW_ID)',
'                 end',
'   and plugin_type = ''REGION TYPE''',
'   and name        = substr(:F4000_P4016_SOURCE_TYPE, 8)',
'   and instr('':''||standard_attributes||'':'', '':SOURCE'') > 0',
'union all',
'select 1',
'  from dual',
' where substr(:F4000_P4016_SOURCE_TYPE, 1, 7) not in (''NATIVE_'', ''PLUGIN_'',''JSTREE'')',
'   and substr(:P4016_SOURCE_TYPE,1,7) not in (''JSTREE'')',
'   and :APP_PAGE_ID <> 7000'))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4017,407,683'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(99494305710491468)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Conditional Display'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_list_item_disp_condition=>'474'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4018:692'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_button
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(99644130313723164)
,p_name=>'Wizard Create Button'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474668
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_item
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(99795626246952886)
,p_name=>'Wizard Create Item'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474668
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(99797121286955232)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Slot and Name'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4717,690'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(99797817188957126)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Item Attributes'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugins',
' where flow_id = case',
'                   when :F4000_P4717_DISPLAY_AS like ''NATIVE_%'' then 4411',
'                   else to_number(:FB_FLOW_ID)',
'                 end',
'   and plugin_type = ''ITEM TYPE''',
'   and name        = substr(:F4000_P4717_DISPLAY_AS, 8)',
'   and instr('':''||standard_attributes||'':'', '':VISIBLE:'') > 0'))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4721'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(99798513522958795)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Source'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_list_item_disp_condition=>'690'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4718,691'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_computation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(100146402180654207)
,p_name=>'Wizard Create Computation'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474668
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_validation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(100288425710144762)
,p_name=>'Wizard Create Validation'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474668
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_branches
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(100367812684257161)
,p_name=>'Wizard Create Branches'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474668
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_process
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(100583211191032690)
,p_name=>'Wizard Create Process'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474668
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_parent_tab
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(100804924518345585)
,p_name=>'Wizard Create Parent Tab'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474668
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(100806819126348134)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Parent Tab'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4725'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(100810614813350139)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Target'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4726'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(100812510716351983)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Sequence and Display'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4727'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_standard_tab
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(100922117111440207)
,p_name=>'Wizard Create Standard Tab'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474668
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(101132401201918650)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'New or Existing Tab Set'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'90'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(101135523617923462)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>'Tab Set'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'93:94'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(101900810245789723)
,p_list_item_display_sequence=>16
,p_list_item_link_text=>'Tab Parent'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'95'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(101901507441790975)
,p_list_item_display_sequence=>17
,p_list_item_link_text=>'Tab Name'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'96'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(100923610426443280)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Current Page'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4722'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(100924705466445586)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Sequence and Images'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4723'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(100925402231447156)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Display Conditions'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4724'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(101374521774334568)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Confirm'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'92'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_asynchronous_actions_navigation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(103622378763412957)
,p_name=>'shared.components.asynchronous_actions.navigation'
,p_list_status=>'PUBLIC'
,p_required_patch=>wwv_flow_imp.id(103621306777465158)
,p_version_scn=>72474668
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(103622584173412956)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Asynchronous Actions'
,p_list_item_link_target=>'f?p=&APP_ID.:7000:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(103622949684412955)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Asynchronous Action Details'
,p_list_item_link_target=>'f?p=&APP_ID.:7005:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(103623310655412955)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Execution Log'
,p_list_item_link_target=>'f?p=&APP_ID.:7009:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(103623751064412955)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'History'
,p_list_item_link_target=>'f?p=&APP_ID.:7010:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_navigation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(103870209211856610)
,p_name=>'Wizard Create Navigation'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474668
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(196983008322003866)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Method'
,p_list_item_link_target=>'f?p=&APP_ID.:22:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'4023,4024,4025,392,497,392,22'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'22'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(103874127098863515)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Attributes'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'4023,4024,4025,392,22'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4023'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(103875221491866142)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Target'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'4023,4024,4025,392,22'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4024'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(103876314806869217)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Display Condition'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'4023,4024,4025,392,22'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4025'
);
end;
/
prompt --application/shared_components/navigation/lists/create_theme_progress
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(106473613360356705)
,p_name=>'create.theme.progress'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474668
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(106476128944361283)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Method'
,p_list_item_link_target=>'f?p=&APP_ID.:207:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'207'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(107807112014581973)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Complete'
,p_list_item_link_target=>'f?p=&APP_ID.:401:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/copy_theme
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(106491204103410821)
,p_name=>'copy.theme'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474668
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(106491709991412525)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Copy Theme'
,p_list_item_link_target=>'f?p=&APP_ID.:401:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'401'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(106495009083421774)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Confirm'
,p_list_item_link_target=>'f?p=&APP_ID.:410:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'410'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_region_template
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(106501409747300331)
,p_name=>'Wizard - Create Region Template'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474668
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(17580228667075703)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Template Type'
,p_list_item_link_target=>'f?p=&APP_ID.:162:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'162'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(106505327419307356)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Creation Method'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'901:920:931:941:951:238:211:348'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(106947820318367086)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Name'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'902:924:935:945:955:240:225:652:349:350'
);
end;
/
prompt --application/shared_components/navigation/lists/theme_change_identification_number
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(106512001249472508)
,p_name=>'theme.change.identification.number'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474668
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(106514712808485302)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Theme Number'
,p_list_item_link_target=>'f?p=&APP_ID.:397:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'397'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(106515019042487151)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Confirm'
,p_list_item_link_target=>'f?p=&APP_ID.:400:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'400'
);
end;
/
prompt --application/shared_components/navigation/lists/copy_asynchronous_action_train
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(106873536031910266)
,p_name=>'copy asynchronous action train'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474668
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(106873705662910265)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Application'
,p_list_item_link_target=>'f?p=&APP_ID.:7002:&SESSION.::&DEBUG.::::'
,p_required_patch=>wwv_flow_imp.id(103621306777465158)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'7002'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(106874144154910264)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Identify Asynchronous Action'
,p_list_item_link_target=>'f?p=&APP_ID.:7003:&SESSION.::&DEBUG.::::'
,p_required_patch=>wwv_flow_imp.id(103621306777465158)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'7003,7004'
);
end;
/
prompt --application/shared_components/navigation/lists/p7005_asynchronous_action_utilities
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(106944141274550933)
,p_name=>'P7005 asynchronous action utilities'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474668
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(106944732788550932)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Copy Asynchronous Action'
,p_list_item_link_target=>'f?p=&APP_ID.:7002:&SESSION.::&DEBUG.:7002,7003,7004:P7003_ID:&P7005_ACTION_TRIGGER_ID.:'
,p_required_patch=>wwv_flow_imp.id(103621306777465158)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(106946388576550930)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>'Resequence Actions'
,p_list_item_link_target=>'f?p=&APP_ID.:7008:&SESSION.::&DEBUG.::P7008_ACTION_TRIGGER_ID:&P7005_ACTION_TRIGGER_ID.:'
,p_required_patch=>wwv_flow_imp.id(103621306777465158)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'7008'
);
end;
/
prompt --application/shared_components/navigation/lists/sssc
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(107370720292626153)
,p_name=>'sssc'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474668
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(107372308995632305)
,p_list_item_display_sequence=>2
,p_list_item_link_text=>'Page'
,p_list_item_link_target=>'f?p=&APP_ID.:512:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'menu/page_64.gif'
,p_list_item_icon_attributes=>'height="64" width="64" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(107373730120638467)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Page Item'
,p_list_item_link_target=>'f?p=&APP_ID.:513:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'menu/edit_64.gif'
,p_list_item_icon_attributes=>'height="64" width="64" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(107789910275250763)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Application Item'
,p_list_item_link_target=>'f?p=&APP_ID.:518:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'menu/prod_apex_64.gif'
,p_list_item_icon_attributes=>'height="64" width="64" title="#LIST_LABEL#" alt="#LIST_LABEL#"'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/sss_standard
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(109521305294221172)
,p_name=>'sss.standard'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474668
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(109521827242236960)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Session State Protection is disabled.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(110690209142337959)
,p_list_item_display_sequence=>5
,p_list_item_link_text=>'Pages in your application will not require checksums.'
,p_list_item_link_target=>'f?p=&APP_ID.:9008:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(109522205902240205)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Application items can be set using arguments passed in a URL (except Restricted items).'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(110689114205329908)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>'Page items can be set using arguments set in a URL (except Restricted items).'
,p_list_item_link_target=>'f?p=&APP_ID.:9008:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(110694132391373080)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Page items'' <i>Escape on HTTP Input</i> attribute will continue to be observed.'
,p_list_item_link_target=>'f?p=&APP_ID.:9008:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/sss_progress
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(109642120442735590)
,p_name=>'sss.progress'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474668
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(109642530139738374)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Select Action'
,p_list_item_link_target=>'f?p=&APP_ID.:525:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'525'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(114177918693680391)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Page and Item Attributes'
,p_list_item_link_target=>'f?p=&APP_ID.:9006:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'9006'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(109642810530742159)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Confirm'
,p_list_item_link_target=>'f?p=&APP_ID.:9007:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'9007,9008'
);
end;
/
prompt --application/shared_components/navigation/lists/authenitcation_create
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(109993128340686080)
,p_name=>'authenitcation.create'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474668
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(109993532150687193)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Method'
,p_list_item_link_target=>'f?p=&APP_ID.:815:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'815'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(109993802845688109)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Scheme'
,p_list_item_link_target=>'f?p=&APP_ID.:816:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'816,818'
);
end;
/
prompt --application/shared_components/navigation/lists/copy_template
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(110615031296644849)
,p_name=>'Copy Template'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474668
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(110663804762646615)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Copy a template from another application'
,p_list_item_link_target=>'f?p=&APP_ID.:162:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/view_templates_task
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(111435127334933550)
,p_name=>'View Templates Task'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474668
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(111437316383939828)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'View Templates'
,p_list_item_link_target=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.:4003,RIR:IR_THEME,P4003_THEME:&FB_THEME_ID.,&FB_THEME_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1218253654992416500)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Delete Theme'
,p_list_item_link_target=>'f?p=&APP_ID.:221:&SESSION.::&DEBUG.:221:P221_REMOVE_THEME:&P267_THEME_ID.:'
,p_list_item_disp_cond_type=>'NOT_EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flows f,',
'       wwv_flow_themes t',
' where f.id                = :FB_FLOW_ID',
'   and f.security_group_id = :WORKSPACE_ID',
'   and t.flow_id           = f.id',
'   and t.theme_id          = f.theme_id',
'   and t.security_group_id = :WORKSPACE_ID',
'   and t.id                = :P267_ID'))
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_breadcrumb_navigation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(111619820846587947)
,p_name=>'shared.components.breadcrumb.navigation'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474668
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(111620411281594656)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Breadcrumbs'
,p_list_item_link_target=>'f?p=&APP_ID.:546:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'546'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(183475506631296658)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Grid Edit'
,p_list_item_link_target=>'f?p=&APP_ID.:3:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'3'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(14900821723122972)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Reparent Entries'
,p_list_item_link_target=>'f?p=&APP_ID.:106:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(111620004355592595)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Utilization'
,p_list_item_link_target=>'f?p=&APP_ID.:365:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'365'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(111620206086593181)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'History'
,p_list_item_link_target=>'f?p=&APP_ID.:369:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'369'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_sqlquery_on_ws_page
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(114018423833281484)
,p_name=>'wizard_sqlquery_on_ws_page'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474668
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(206858322178171502)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Page and Region Attributes'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'776'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(206858932567174539)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Navigation Menu'
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_user_interface_dev.supports_tabs (',
'                     p_application_id     => :FB_FLOW_ID );'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1523950895298145683)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Tabs'
,p_list_item_disp_cond_type=>'FUNCTION_BODY'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_user_interface_dev.supports_tabs (',
'           p_application_id => :FB_FLOW_ID );'))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4716'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(114018618816281486)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Web Reference Type'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'778'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(114018928354281487)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Web Reference Information'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'779:781:859'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(114019202992281488)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Parameters and Options'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'782:783:860'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(114162210486514180)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Confirm'
,p_list_item_current_for_pages=>'786'
);
end;
/
prompt --application/shared_components/navigation/lists/sss_extended
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(114371329791585494)
,p_name=>'sss.extended'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474669
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(114418321983210267)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Pages: &P9007_PAGE_LEVEL.'
,p_list_item_link_target=>'f?p=&APP_ID.:9007:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(114418726485211591)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Application Items: &P9007_APP_ITEM_LEVEL.'
,p_list_item_link_target=>'f?p=&APP_ID.:9007:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(114420921767219662)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Data Entry Items: &P9007_DATA_ENTRY_ITEM_LEVEL.'
,p_list_item_link_target=>'f?p=&APP_ID.:9007:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(114421526616221094)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Display Only Items: &P9007_DISPLAY_ONLY_ITEM_LEVEL.'
,p_list_item_link_target=>'f?p=&APP_ID.:9007:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(114422831464222441)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Page Item Cross-Site Scripting Protection: &P9007_PAGE_ITEM_ESCAPE.'
,p_list_item_link_target=>'f?p=&APP_ID.:9007:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/workspace_theme_progress
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(114829600122838504)
,p_name=>'workspace theme progress'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474669
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(114830714320842637)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Identify Theme'
,p_list_item_link_target=>'f?p=&APP_ID.:764:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_list_item_disp_condition=>'754'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'764'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(114831221593844797)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Identify Name'
,p_list_item_link_target=>'f?p=&APP_ID.:789:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_list_item_disp_condition=>'754'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'789'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(114831926787846213)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Confirm'
,p_list_item_link_target=>'f?p=&APP_ID.:762:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_list_item_disp_condition=>'754'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'762'
);
end;
/
prompt --application/shared_components/navigation/lists/dependencies_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(117039522797176386)
,p_name=>'Dependencies Tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474669
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(117040128338177988)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Generate DDL'
,p_list_item_link_target=>'f?p=&APP_ID.:637:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/create_app_from_spreasheet_opt
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(118042377093675208)
,p_name=>'create.app.from.spreasheet.opt'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474669
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(118042502492675209)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Upload file'
,p_list_item_link_target=>'f?p=4500:3100:&SESSION.:::3100,3110,3120:P3100_SOURCE_TYPE:FILE'
,p_list_item_icon=>'a-Icon icon-region- icon-file-upload'
,p_list_text_01=>'Upload CSV, XLSX, XML, JSON data'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(118042942497675210)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Copy and paste'
,p_list_item_link_target=>'f?p=4500:3100:&SESSION.:::3100,3110,3120:P3100_SOURCE_TYPE:COPY_PASTE'
,p_list_item_icon=>'a-Icon icon-region- icon-clipboard'
,p_list_text_01=>'Copy and paste CSV data'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/comments
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(123545913988020430)
,p_name=>'comments'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474669
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(123546321607022623)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Create Comment'
,p_list_item_link_target=>'f?p=&APP_ID.:1234:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1234'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(123546700960026141)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'View Comments'
,p_list_item_link_target=>'f?p=&APP_ID.:1235:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1235'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(123547007539028056)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Edit Comment'
,p_list_item_link_target=>'f?p=&APP_ID.:1236:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'1236'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1236'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(125612105656334840)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Delete Comments'
,p_list_item_link_target=>'f?p=&APP_ID.:1237:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from WWV_FLOW_APP_COMMENTS',
'where flow_id = :fb_flow_id',
'and security_group_id = :flow_security_group_id'))
,p_security_scheme=>wwv_flow_imp.id(12511519296310366)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1237,1238'
);
end;
/
prompt --application/shared_components/navigation/lists/create_application_image_nav
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(128724959151960807)
,p_name=>'Create Application - Image Nav'
,p_list_status=>'PUBLIC'
,p_version_scn=>221584846
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(20568709850105837)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Use Create App Wizard'
,p_list_item_link_target=>'javascript:apex.submit(''FULL_CREATE_WIZ'');'
,p_list_item_icon=>'icon-apex'
,p_list_text_01=>'Create a new application using the full Create Application wizard with advanced options.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1601720953461283)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Create App Using Generative AI'
,p_list_item_link_target=>'f?p=4020:2000:&SESSION.:::2000'
,p_list_item_icon=>'icon-apex-assistant'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_ai_api.is_enabled'
,p_list_item_disp_condition2=>'PLSQL'
,p_list_text_01=>'Enter a natural language prompt to create your application.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(128728137528960809)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Create App From a File'
,p_list_item_link_target=>'f?p=4500:3100:&SESSION.:::3100,3110,3120,APEX$DATALOAD_COLUMNS:P3100_SOURCE_TYPE:FILE'
,p_list_item_icon=>'icon-file-browse'
,p_list_text_01=>'Upload a CSV, XLSX, XML or JSON file, or copy and paste data, then create your application.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(20575398280881574)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Create App From Quick SQL'
,p_list_item_link_target=>'f?p=4500:1100:&SESSION.::&DEBUG.:1100:::'
,p_list_item_icon=>'icon-code-block'
,p_list_text_01=>'Build your own data model or use an existing one and create a new application from it.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(128728733474960809)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Browse Apps in Gallery'
,p_list_item_link_target=>'f?p=4750:50:&SESSION.::&DEBUG.:50:::'
,p_list_item_icon=>'icon-download'
,p_list_text_01=>'Install one of many Sample and Starter Apps from the Gallery.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(128725983083960807)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Copy Existing App'
,p_list_item_link_target=>'f?p=&APP_ID.:3009:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-copy'
,p_list_text_01=>'Create a new application as a copy of an existing application in your workspace.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'NEVER'
);
end;
/
prompt --application/shared_components/navigation/lists/create_application_step_1
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(139866417493663090)
,p_name=>'create application step 1'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474681
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(139870325374684265)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Method'
,p_list_item_link_target=>'f?p=&APP_ID.:56:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'56'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(139870631607686094)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Select Application'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_list_item_disp_condition=>'84,3009'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'887'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(23857907389713612)
,p_list_item_display_sequence=>25
,p_list_item_link_text=>'Identify Copy Target'
,p_list_item_link_target=>'f?p=&APP_ID.:3009:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'3009,84'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(139871004034687499)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Confirm'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'130,84'
);
end;
/
prompt --application/shared_components/navigation/lists/confirm_page
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(148407226188594759)
,p_name=>'confirm.page'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474681
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(148409915022610438)
,p_list_item_display_sequence=>5
,p_list_item_link_text=>'Run Page'
,p_list_item_link_target=>'f?p=&FB_FLOW_ID.:&F4000_RUN_EDIT_PAGE.:&SESSION.'
,p_list_item_icon=>'htmldb/builder/run_flow.gif'
,p_list_item_icon_attributes=>'width="100" height="75" alt="&F4000_RUN."'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(148417611521656692)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Edit Page'
,p_list_item_link_target=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID,F4000_P1_FLOW:&FB_FLOW_ID.,&F4000_RUN_EDIT_PAGE.,&FB_FLOW_ID.:'
,p_list_item_icon=>'htmldb/builder/edit_page.gif'
,p_list_item_icon_attributes=>'width="100" height="75" alt="&EDIT."'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/p4653_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(153210815104527139)
,p_name=>'P4653_TASKS'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474681
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(153212128263530955)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Find Items'
,p_list_item_link_target=>'javascript:popUp(''f?p=4000:273:&SESSION.::::F4000_P273_PAGE:&FB_FLOW_PAGE_ID.'');'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_remote_servers_navigation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(154051976265844427)
,p_name=>'shared.components.remote_servers.navigation'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474681
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(154052121551844430)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'REST Enabled SQL'
,p_list_item_link_target=>'f?p=&APP_ID.:1600:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1600'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(154052580732844434)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Utilization'
,p_list_item_link_target=>'f?p=&APP_ID.:1602:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1602'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(154052913913844434)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'History'
,p_list_item_link_target=>'f?p=&APP_ID.:1603:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1603'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_credential_stores_navigation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(154583731613661573)
,p_name=>'shared.components.credential_stores.navigation'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474681
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(154583988141661575)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Web Credentials'
,p_list_item_link_target=>'f?p=&APP_ID.:1620:&SESSION.::&DEBUG.:1620:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1620'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(154584303580661578)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Utilization'
,p_list_item_link_target=>'f?p=&APP_ID.:1622:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1622'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(154584705715661578)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'History'
,p_list_item_link_target=>'f?p=&APP_ID.:1623:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1623'
);
end;
/
prompt --application/shared_components/navigation/lists/export_page
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(158038003748775992)
,p_name=>'Export Page'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474681
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(158038407557777097)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Export Page'
,p_list_item_link_target=>'f?p=&APP_ID.:164:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(25720216186980294)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Manage Supporting Objects'
,p_list_item_link_target=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(200682401972525159)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Component Export'
,p_list_item_link_target=>'f?p=&APP_ID.:688:&SESSION.::&DEBUG.:CR:::'
,p_list_item_disp_cond_type=>'ITEM_IS_NOT_NULL'
,p_list_item_disp_condition=>'FB_FLOW_ID'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(168868615219020507)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Manage Export Repository'
,p_list_item_link_target=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_lov
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(161740513874429436)
,p_name=>'Wizard Create LOV'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474681
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(202904909845918905)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Source'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'137'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(161742306326432962)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Name and Type'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4004'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(11540348458195148)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'List of Values Source'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4080'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(161745627233438452)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Static Values'
,p_list_item_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_list_item_disp_condition=>'F4000_P4004_TYPE'
,p_list_item_disp_condition2=>'STATIC'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4014'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(11542493794381119)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Column Mappings'
,p_list_item_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_list_item_disp_condition=>'F4000_P4004_TYPE'
,p_list_item_disp_condition2=>'DYNAMIC'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4081'
);
end;
/
prompt --application/shared_components/navigation/lists/cross_application_reports_attributes
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(162360828277873558)
,p_name=>'Cross Application Reports / Attributes'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474681
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(162361613863878819)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Application Attributes'
,p_list_item_link_target=>'f?p=&APP_ID.:9010:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-application-attributes'
,p_list_text_01=>'View component counts for each application.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(205251931899374098)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Build Status and Application Status'
,p_list_item_link_target=>'f?p=&APP_ID.:103:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'icon-app-status'
,p_list_text_01=>'Review the statuses for each application.'
,p_translate_list_text_y_n=>'Y'
,p_security_scheme=>wwv_flow_imp.id(12511519296310366)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(162362223560881642)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Build Options'
,p_list_item_link_target=>'f?p=&APP_ID.:9012:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-build-options'
,p_list_text_01=>'View build options across all applications.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(131390824277396235)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Developer Comments'
,p_list_item_link_target=>'f?p=&APP_ID.:380:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'icon-util-comments'
,p_list_text_01=>'Review comments from all applications.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(217724513488899294)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Developer Comments Calendar'
,p_list_item_link_target=>'f?p=&APP_ID.:665:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-comments-calendar'
,p_list_text_01=>'View when all comments were created.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/translation_utilities
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(165621520543370755)
,p_name=>'translation.utilities'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474681
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(171880500668996222)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Text Messages'
,p_list_item_link_target=>'f?p=&APP_ID.:4006:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-create-manage-text'
,p_list_text_01=>'Create and manage text messages.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(165622300589374384)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Dynamic Translations'
,p_list_item_link_target=>'f?p=&APP_ID.:4756:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-manage-dynamic-translation'
,p_list_text_01=>'Manage dynamic translation repository.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(28665818452018310)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Translation Repository'
,p_list_item_link_target=>'f?p=&APP_ID.:702:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-manually-edit-translation'
,p_list_text_01=>'Manually edit translated text in the translation repository.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/parent_tab_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(165863110284077420)
,p_name=>'parent.tab.tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474681
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(165865017557079566)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Rename Parent Tab Set'
,p_list_item_link_target=>'f?p=&FLOW_ID.:332:&SESSION.::&DEBUG.:332::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(165865522059080812)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Resequence display order'
,p_list_item_link_target=>'f?p=&FLOW_ID.:331:&SESSION.::&DEBUG.:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(165867932102083690)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Create New Parent Tab'
,p_list_item_link_target=>'f?p=&FLOW_ID.:4725:&SESSION.::&DEBUG.:4725,4726,4727::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/standard_tab_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(165876716780098264)
,p_name=>'standard.tab.tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474681
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(165879130286102126)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Manage Standard Tabs'
,p_list_item_link_target=>'f?p=&APP_ID.:9000:&SESSION.::&DEBUG.::F4000_P9000_PAGE:&FB_FLOW_PAGE_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/parent_tab_tasks_p9000
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(165884427300110704)
,p_name=>'parent_tab_tasks_p9000'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474681
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(165885332495112173)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Manage Parent Tabs'
,p_list_item_link_target=>'f?p=&APP_ID.:398:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/tasks_page_4714
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(165935217145249689)
,p_name=>'tasks_page_4714'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474681
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(165938632036253973)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Create a Login Page'
,p_list_item_link_target=>'f?p=4000:500:&SESSION.::NO'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/how_to_translate
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(165943028704262550)
,p_name=>'how_to_translate'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474681
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(165944104940265156)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Define application languages'
,p_list_item_link_target=>'f?p=&APP_ID.:4751:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-map-primary-language'
,p_list_text_01=>'Map primary language application to translated applications.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(165945811520267011)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Seed translatable text'
,p_list_item_link_target=>'f?p=&APP_ID.:385:&SESSION.::&DEBUG.::P385_ACTION:SEED:'
,p_list_item_icon=>'icon-util-seed-translatable-text'
,p_list_text_01=>'Copy the translatable text from the primary application into the translation repository.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(162434002630201887)
,p_list_item_display_sequence=>24
,p_list_item_link_text=>'Download XLIFF translation files'
,p_list_item_link_target=>'f?p=&APP_ID.:4750:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-download-xlif-translation'
,p_list_text_01=>'Download files with translatable text from the translation repository.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(165947319138269194)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Translate text'
,p_list_item_link_target=>'f?p=&APP_ID.:306:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-translate-text'
,p_list_text_01=>'Send XLIFF files for translation or manually edit translation repository.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(165949127796271740)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Apply XLIFF translation files'
,p_list_item_link_target=>'f?p=&APP_ID.:4758:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-upload-apply-xliff'
,p_list_text_01=>'Upload XLIFF files with translated text and apply translations to the translation repository.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(162434303453211574)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Publish translated applications'
,p_list_item_link_target=>'f?p=&APP_ID.:385:&SESSION.::&DEBUG.::P385_ACTION:PUBLISH:'
,p_list_item_icon=>'icon-util-publish-translated-applications'
,p_list_text_01=>'Make the translated applications available to users.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_nav_bar_navigation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(166766500720858594)
,p_name=>'shared.components.nav_bar.navigation'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474681
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(166769319685865035)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Classic Navigation Bar Entries'
,p_list_item_link_target=>'f?p=&APP_ID.:4005:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4005'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(166770609981869522)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Grid Edit'
,p_list_item_link_target=>'f?p=&APP_ID.:153:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>'select 1 from wwv_flow_icon_bar where flow_id = :fb_flow_id'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'153'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(201265401410394101)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Subscription'
,p_list_item_link_target=>'f?p=&APP_ID.:54:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>'select 1 from wwv_flow_icon_bar where flow_id = :fb_flow_id'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'54'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(10056426696402671)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'History'
,p_list_item_link_target=>'f?p=&APP_ID.:394:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>'select 1 from wwv_flow_icon_bar where flow_id = :fb_flow_id'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'394'
);
end;
/
prompt --application/shared_components/navigation/lists/replace_templates_train
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(168734227577365586)
,p_name=>'replace templates train'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474681
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(168734406930369089)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Template Type'
,p_list_item_link_target=>'f?p=&APP_ID.:708:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'708'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(168734718358372471)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Identify Templates'
,p_list_item_link_target=>'f?p=&APP_ID.:711:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'711'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(168734923899374008)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Confirm'
,p_list_item_link_target=>'f?p=&APP_ID.:713:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'713'
);
end;
/
prompt --application/shared_components/navigation/lists/create_list_train
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(169186610834587350)
,p_name=>'create list train'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474681
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(169186923301591019)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Name and Type'
,p_list_item_link_target=>'f?p=&APP_ID.:427:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'427'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(169189328373658702)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Query or Static Values '
,p_list_item_link_target=>'f?p=&APP_ID.:440:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'440,464'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(169192814961711597)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Confirm'
,p_list_item_link_target=>'f?p=&APP_ID.:529:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'529,734'
);
end;
/
prompt --application/shared_components/navigation/lists/page_region_utilities
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(171723423034567648)
,p_name=>'page.region.utilities'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474681
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(6821101659113491)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Edit Region Titles'
,p_list_item_link_target=>'f?p=&APP_ID.:438:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(193870804947518508)
,p_list_item_display_sequence=>3
,p_list_item_link_text=>'Region Attributes'
,p_list_item_link_target=>'f?p=&APP_ID.:249:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(171780931017721336)
,p_list_item_display_sequence=>4
,p_list_item_link_text=>'PL/SQL Regions'
,p_list_item_link_target=>'f?p=&APP_ID.:480:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(11339330772242551)
,p_list_item_display_sequence=>5
,p_list_item_link_text=>'Customized Regions'
,p_list_item_link_target=>'f?p=&APP_ID.:70:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47911925376585041)
,p_list_item_display_sequence=>6
,p_list_item_link_text=>'Conditional Regions'
,p_list_item_link_target=>'f?p=&APP_ID.:864:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/page_button_utilities
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(171743703949609405)
,p_name=>'page.button.utilities'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474681
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(193784520531105981)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Page Buttons'
,p_list_item_link_target=>'f?p=&APP_ID.:548:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(194556907147613285)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Conditional Buttons'
,p_list_item_link_target=>'f?p=&APP_ID.:878:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/page_item_utilities
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(171752432131627079)
,p_name=>'page.item.utilities'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474681
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(233013122336106602)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Edit Item Help Text'
,p_list_item_link_target=>'f?p=&APP_ID.:408:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(193917900275255057)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'All Page Items'
,p_list_item_link_target=>'f?p=&APP_ID.:547:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(15591500615424210)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Password Items'
,p_list_item_link_target=>'f?p=&APP_ID.:59:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(194531425614476695)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Conditional Items'
,p_list_item_link_target=>'f?p=&APP_ID.:869:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/page_validation_utilities
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(171763620666671065)
,p_name=>'page.validation.utilities'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474681
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(242557604450198238)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Validations by Page'
,p_list_item_link_target=>'f?p=&APP_ID.:501:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(194198200000377701)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Conditional Validations'
,p_list_item_link_target=>'f?p=&APP_ID.:883:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/page_computation_utilities
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(171769406383685886)
,p_name=>'page.computation.utilities'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474681
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(224269225570329050)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Computations by Page'
,p_list_item_link_target=>'f?p=&APP_ID.:549:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(194540617827512267)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Conditional Computations'
,p_list_item_link_target=>'f?p=&APP_ID.:877:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/page_process_utilities
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(171773504090694644)
,p_name=>'page.process.utilities'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474681
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(225375711989419725)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Processes by Page'
,p_list_item_link_target=>'f?p=&APP_ID.:552:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(194248225420820252)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Conditional Processes'
,p_list_item_link_target=>'f?p=&APP_ID.:866:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/application_utilities
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(177830919883437702)
,p_name=>'Application Utilities'
,p_list_status=>'PUBLIC'
,p_version_scn=>117491566
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(177833406770462269)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Application Dashboard'
,p_list_item_link_target=>'f?p=&APP_ID.:71:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-app-dashboard'
,p_list_text_01=>'Review a summary of this application.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1885595358268728653)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Advisor'
,p_list_item_link_target=>'javascript:apex.navigation.popup({ url: ''f?p=&APP_ID.:8101:&SESSION.::&DEBUG.:8101'', width: 1000, height: 800 }); void(0);'
,p_list_item_icon=>'icon-util-advisor'
,p_list_text_01=>'Perform various checks on this application, including programming errors and best practices.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1661255424982169004)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Upgrade Application'
,p_list_item_link_target=>'f?p=&APP_ID.:89:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'icon-util-upgrade-app'
,p_list_text_01=>'After upgrading to a new release, review components for upgrading to include the latest features.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(466865607820087113)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Recently Updated Pages'
,p_list_item_link_target=>'f?p=&APP_ID.:8:&SESSION.::&DEBUG.:RIR:IR_UPDATED_BY:&APP_USER.:'
,p_list_item_icon=>'icon-util-recent-pages'
,p_list_text_01=>'View a history of the page updates made on this application.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1160235601024416138)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Attribute Dictionary'
,p_list_item_link_target=>'f?p=&APP_ID.:889:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'icon-util-attribute-dictionary'
,p_list_text_01=>'Manage item / column UI Defaults for a selected page.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(177831203693437706)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Change History'
,p_list_item_link_target=>'f?p=&APP_ID.:358:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-change-history'
,p_list_text_01=>'View a detailed report of component updates made on this application.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1160225427040278954)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Database Object Dependencies'
,p_list_item_link_target=>'f?p=&APP_ID.:425:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-object-dependencies'
,p_list_text_01=>'Review the database objects referenced by this application.'
,p_translate_list_text_y_n=>'Y'
,p_required_patch=>wwv_flow_imp.id(170786031904296885)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(492241124877437516)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Debug Messages'
,p_list_item_link_target=>'f?p=&APP_ID.:666:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-debug-messages'
,p_list_text_01=>'Review debug messages generated by this application.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1173931504465813227)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'&PRODUCT_NAME. Views'
,p_list_item_link_target=>'f?p=&APP_ID.:714:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-apex-views'
,p_list_text_01=>'Query the various views against &PRODUCT_NAME. metadata.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(492240609162423534)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Export Repository'
,p_list_item_link_target=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-export-repository'
,p_list_text_01=>'View a history of application exports.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(70885805484327683)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'Manage Backups'
,p_list_item_link_target=>'f?p=&APP_ID.:971:&SESSION.::&DEBUG.:971:::'
,p_list_item_icon=>'icon-apex-backup'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_backup.backup_limit() > 0'
,p_list_item_disp_condition2=>'PLSQL'
,p_list_text_01=>'Review backup history, perform a manual backup or restore from a backup'
,p_list_text_02=>'P971_APPLICATION_ID:100'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1205104966610419)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>'Embedded Code'
,p_list_item_link_target=>'f?p=&APP_ID.:101:&SESSION.::&DEBUG.:RP,101:::'
,p_list_item_icon=>'icon-util-embedded-code'
,p_list_text_01=>'Review code such as SQL, PL/SQL, JavaScript etc.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(569740971924292915)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>'Application Checksum'
,p_list_item_link_target=>'f?p=&APP_ID.:109:&SESSION.::&DEBUG.:109:P109_COMPONENT:APPLICATION:'
,p_list_item_icon=>'icon-check-circle'
,p_list_text_01=>'The application checksum provides an easy way to determine whether the same application is deployed across workspaces.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(576931365336902572)
,p_list_item_display_sequence=>140
,p_list_item_link_text=>'Font APEX Icons'
,p_list_item_link_target=>'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:110:::'
,p_list_item_icon=>'icon-util-font-apex'
,p_list_text_01=>'Find Font APEX icons and HTML Markup'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(597489289435573267)
,p_list_item_display_sequence=>150
,p_list_item_link_text=>'Page Checksums'
,p_list_item_link_target=>'f?p=&APP_ID.:111:&SESSION.::&DEBUG.:RP,111:P109_COMPONENT:APPLICATION:'
,p_list_item_icon=>'icon-check-circle'
,p_list_text_01=>'The page checksum report provides an easy way to compare two application deployments and see which pages are the same and which are different'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_copy_item
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(179572716597169307)
,p_name=>'Wizard Copy Item'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474684
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(197073903769725734)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'New Page'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'171'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(179579323055181481)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'New Item'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'172'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_authentication_scheme_navigation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(180433926348108856)
,p_name=>'shared.components.authentication_scheme.navigation'
,p_list_status=>'PUBLIC'
,p_version_scn=>69947905
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(180435618514116022)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Authentication Schemes'
,p_list_item_link_target=>'f?p=&APP_ID.:801:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'801'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(192776728065739452)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'History'
,p_list_item_link_target=>'f?p=&APP_ID.:554:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'554'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_authorization_scheme_navigation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(180462022520306486)
,p_name=>'shared.components.authorization_scheme.navigation'
,p_list_status=>'PUBLIC'
,p_version_scn=>69954126
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(180462914339313581)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Authorization Schemes'
,p_list_item_link_target=>'f?p=&APP_ID.:4070:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4070'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47955811298564811)
,p_list_item_display_sequence=>25
,p_list_item_link_text=>'Utilization'
,p_list_item_link_target=>'f?p=&APP_ID.:340:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'340'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(192784124265814091)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'History'
,p_list_item_link_target=>'f?p=&APP_ID.:558:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'558'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_copy_button
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(181185105878280365)
,p_name=>'Wizard Copy Button'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474684
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(15213429898992140)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'New Page'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'231'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(181188725059286630)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'New Button'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'191'
);
end;
/
prompt --application/shared_components/navigation/lists/copy_dynamic_action
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(181501623296103719)
,p_name=>'copy.dynamic_action'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474684
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(181503411306109716)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Dynamic Action to Copy'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'728'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(181503816154111137)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'To Page'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'796'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(181504222388112936)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'New Dynamic Action'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'797'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_map_region
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(185155905837041142)
,p_name=>'Wizard Create Map Region'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474684
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(185157403628041147)
,p_list_item_display_sequence=>6
,p_list_item_link_text=>'Map Source'
,p_list_item_link_target=>'f?p=&APP_ID.:840:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>':P181_REGION_TYPE = ''Map'''
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'840'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(185157801641041147)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Display Attributes'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4016,91,2002,2003,799,313'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(185159024483041149)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Query'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4017,407,683,537'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(185159826358041149)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Conditional Display'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4018:692'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_shortcut
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(185305822581982553)
,p_name=>'Wizard Create Shortcut'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474684
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(185307615464985837)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Creation Method'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'131'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(185308412229987392)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Shortcut Attributes'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'174'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_pull_shortcuts
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(185309707700989517)
,p_name=>'Wizard Pull Shortcuts'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474684
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(185313922784997656)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Creation Method'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'131'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(185314719980998966)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Copy From'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'132'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(185315516746000474)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'New Shortcuts'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'133'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_shortcut_navigation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(186543329326722942)
,p_name=>'shared.components.shortcut.navigation'
,p_list_status=>'PUBLIC'
,p_version_scn=>69954502
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(186545123935725534)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Shortcuts'
,p_list_item_link_target=>'f?p=&APP_ID.:4047:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4047'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(10983506807371682)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'History'
,p_list_item_link_target=>'f?p=&APP_ID.:41:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'41'
);
end;
/
prompt --application/shared_components/navigation/lists/page_item_navigation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(186703109122914661)
,p_name=>'page.item.navigation'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474684
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(47958103726591074)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Utilities'
,p_list_item_link_target=>'f?p=&APP_ID.:854:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'854:408:6:547:59:869:389'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(11258131416157207)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'History'
,p_list_item_link_target=>'f?p=&APP_ID.:62:&SESSION.::&DEBUG.:RIR:IR_PAGE_ID:&FB_FLOW_PAGE_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'62'
);
end;
/
prompt --application/shared_components/navigation/lists/page_validation_navigation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(186826132498329280)
,p_name=>'page.validation.navigation'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474684
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(193767726569918515)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Utilities'
,p_list_item_link_target=>'f?p=&APP_ID.:851:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'851:214:501:883'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(11340930817563888)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'History'
,p_list_item_link_target=>'f?p=&APP_ID.:66:&SESSION.::&DEBUG.:RIR:IR_PAGE_ID:&FB_FLOW_PAGE_ID.:'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'66'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_pull_security_schemes
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(186904126354727159)
,p_name=>'Wizard Pull Security Schemes'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474684
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(186905916218731926)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Creation Method'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'184'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(186906712336733691)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Copy From'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'185'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(186907507376736030)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Names'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'186'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_authorization_schemes
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(186911322244744240)
,p_name=>'Wizard Create Authorization Schemes'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474684
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(186913114912747650)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Creation Method'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'184'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(186914408226750829)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Details'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'188'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_plug_in_navigation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(188993730020080349)
,p_name=>'shared.components.plug-in.navigation'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474684
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(188994312836084773)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Plug-ins'
,p_list_item_link_target=>'f?p=&APP_ID.:4400:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4400'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(188994619762086758)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Utilization'
,p_list_item_link_target=>'f?p=&APP_ID.:4420:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4420'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(193358210391475853)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'History'
,p_list_item_link_target=>'f?p=&APP_ID.:841:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'841'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_report_query_navigation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(193369209650497455)
,p_name=>'shared.components.report_query.navigation'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474684
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(193369600778504265)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Report Queries'
,p_list_item_link_target=>'f?p=&APP_ID.:1100:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1100'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1745210039082607)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Utilization'
,p_list_item_link_target=>'f?p=&APP_ID.:1130:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(193369910128507049)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'History'
,p_list_item_link_target=>'f?p=&APP_ID.:843:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'843'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_report_layout_navigation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(193374517232546937)
,p_name=>'shared.components.report_layout.navigation'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474684
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(193374801581546942)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Report Layouts'
,p_list_item_link_target=>'f?p=&APP_ID.:1400:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1400'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(193375221285546942)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'History'
,p_list_item_link_target=>'f?p=&APP_ID.:844:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'844'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_copy_navbar
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(193684503309130516)
,p_name=>'Wizard Copy NavBar'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474684
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(193686328960133836)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Creation Method'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'22'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(193687125078135642)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Copy From'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'134'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(193688421627137255)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'New Names'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'135'
);
end;
/
prompt --application/shared_components/navigation/lists/page_dynamic_action_utilities
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(194153003566161205)
,p_name=>'page.dynamic_action.utilities'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474689
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(194154929885168734)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'All Dynamic Actions'
,p_list_item_link_target=>'f?p=&APP_ID.:699:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/page_region_utilities_region_counts
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(194250609883844198)
,p_name=>'page.region.utilities.region.counts'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474689
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(194252923250844202)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Count by Region Type'
,p_list_item_link_target=>'f?p=&APP_ID.:128:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_region.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(194253310565844203)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Count by Page Template Slot'
,p_list_item_link_target=>'f?p=&APP_ID.:459:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'htmldb/icons/pt_region.png'
,p_list_item_icon_attributes=>'alt=""'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/page_branch_utilities
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(194565421168929524)
,p_name=>'page.branch.utilities'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474689
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(194566126273929526)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Branches by Page'
,p_list_item_link_target=>'f?p=&APP_ID.:563:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(194566502198929526)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Conditional Branches'
,p_list_item_link_target=>'f?p=&APP_ID.:885:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_copy_region
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(197233420990021629)
,p_name=>'Wizard Copy Region'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474689
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(197241701365030751)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'To Page'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'194'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(197243528741033202)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'New Region'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'195'
);
end;
/
prompt --application/shared_components/navigation/lists/apex_views_navigation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(200452609222306546)
,p_name=>'APEX Views Navigation'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474689
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(200453224460311015)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Report View'
,p_list_item_link_target=>'f?p=&APP_ID.:714:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'714'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(201268128688684688)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>'Tree View'
,p_list_item_link_target=>'f?p=&APP_ID.:905:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'905'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(200453701734313844)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Select Columns'
,p_list_item_link_target=>'f?p=&APP_ID.:892:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P892_VIEW_NAME is not null or',
':APP_PAGE_ID = ''892'''))
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'892'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(200454107275315499)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Filter'
,p_list_item_link_target=>'f?p=&APP_ID.:893:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'ITEM_IS_NOT_NULL'
,p_list_item_disp_condition=>'P892_SELECTED_COLS'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'893'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(200454411431316639)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Results'
,p_list_item_link_target=>'f?p=&APP_ID.:896:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'ITEM_IS_NOT_NULL'
,p_list_item_disp_condition=>'P892_SELECTED_COLS'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'896'
);
end;
/
prompt --application/shared_components/navigation/lists/copy_page_wiz_steps
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(202931703979545993)
,p_name=>'copy_page_wiz_steps'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474689
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(202933009304556968)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Copy Page Option'
,p_list_item_link_target=>'f?p=&APP_ID.:618:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'618'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(202934128351562472)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Page to Copy'
,p_list_item_link_target=>'f?p=&APP_ID.:621:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'621'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1556125534907719472)
,p_list_item_display_sequence=>35
,p_list_item_link_text=>'Navigation Menu'
,p_list_item_link_target=>'f?p=&APP_ID.:617:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_list_item_disp_condition=>'P621_NAVIGATION_TYPE'
,p_list_item_disp_condition2=>'L'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'671'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(204089926319940378)
,p_list_item_display_sequence=>35
,p_list_item_link_text=>'Tabs'
,p_list_item_link_target=>'f?p=&APP_ID.:617:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_list_item_disp_condition=>'P621_NAVIGATION_TYPE'
,p_list_item_disp_condition2=>'L'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'671'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(202934605626565380)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Templates'
,p_list_item_link_target=>'f?p=&APP_ID.:622:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'622'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(202935113937567735)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Lists of Values'
,p_list_item_link_target=>'f?p=&APP_ID.:623:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'623'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(202935522249570117)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Lists'
,p_list_item_link_target=>'f?p=&APP_ID.:625:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'625'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(202935827097571532)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Authorization Schemes'
,p_list_item_link_target=>'f?p=&APP_ID.:627:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'627'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(208023117796803899)
,p_list_item_display_sequence=>75
,p_list_item_link_text=>'Branches'
,p_list_item_link_target=>'f?p=&APP_ID.:593:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'593'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(202936132291573046)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Confirm'
,p_list_item_link_target=>'f?p=&APP_ID.:628:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'628'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_pull_lov
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(202952222735973765)
,p_name=>'Wizard Pull LOV'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474693
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(202954017990975969)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Creation Method'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'137'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(202954813893977815)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Copy From '
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'138'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(202955610442979398)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'New Lists of Values'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'139'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_lov_navigation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(203029530177365353)
,p_name=>'shared.components.lov.navigation'
,p_list_status=>'PUBLIC'
,p_version_scn=>69954299
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(203035015081372358)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Lists of Values'
,p_list_item_link_target=>'f?p=&APP_ID.:4110:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4110'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(184816719223361035)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Edit Null Text'
,p_list_item_link_target=>'f?p=&APP_ID.:169:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'169'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(184821331999411979)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Locally Defined'
,p_list_item_link_target=>'f?p=&APP_ID.:419:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'419'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(184821605811413905)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Grid Edit'
,p_list_item_link_target=>'f?p=&APP_ID.:178:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'178'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(188105422784870512)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Conditional Entries'
,p_list_item_link_target=>'f?p=&APP_ID.:556:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'556'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(631171523671392471)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Utilization'
,p_list_item_link_target=>'f?p=&APP_ID.:87:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>'select 1  from WWV_FLOW_LISTS_OF_VALUES$ where flow_id = :FB_FLOW_ID'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'87'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(193350901986416680)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'History'
,p_list_item_link_target=>'f?p=&APP_ID.:686:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'686'
);
end;
/
prompt --application/shared_components/navigation/lists/p224_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(205602222789276628)
,p_name=>'p224 tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474693
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1036212995590553756)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Manage Themes'
,p_list_item_link_target=>'f?p=&APP_ID.:260:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/export_component_tabs
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(207503732215648915)
,p_name=>'export component tabs'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474693
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(207504110528652105)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Components'
,p_list_item_link_target=>'f?p=&APP_ID.:688:&SESSION.:AC:&DEBUG.:CR:P688_MODE:AC:'
,p_list_item_current_type=>'EXPRESSION'
,p_list_item_current_for_pages=>'nvl(:P688_MODE,''AC'') = ''AC'''
,p_list_item_current_language=>'PLSQL'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(207504421956655470)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Components by Page'
,p_list_item_link_target=>'f?p=&APP_ID.:688:&SESSION.:PD:&DEBUG.:CR:P688_MODE:PD:'
,p_list_item_current_type=>'EXPRESSION'
,p_list_item_current_for_pages=>'nvl(:P688_MODE,''PD'') = ''PD'''
,p_list_item_current_language=>'PLSQL'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(228921921121485140)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Build Option Status'
,p_list_item_link_target=>'f?p=&APP_ID.:688:&SESSION.::&DEBUG.:CR:P688_MODE:BO:'
,p_list_item_current_type=>'EXPRESSION'
,p_list_item_current_for_pages=>'nvl(:P688_MODE,''AC'') = ''BO'''
,p_list_item_current_language=>'PLSQL'
);
end;
/
prompt --application/shared_components/navigation/lists/install_preview
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(210424614987781460)
,p_name=>'Install Preview'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474693
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(210426801959787134)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Preview Installation Script'
,p_list_item_link_target=>'f?p=&APP_ID.:2109:&SESSION.::&DEBUG.::P2109_MODE:INSTALL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/component_export_train
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(210787017222419064)
,p_name=>'component export train'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474693
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(210787424148421054)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Identify Components'
,p_list_item_link_target=>'f?p=&APP_ID.:688:&SESSION.::&DEBUG.:CR:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'688'
);
end;
/
prompt --application/shared_components/navigation/lists/page_group_navigation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(213192710092707758)
,p_name=>'page.group.navigation'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474693
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(213193117365709843)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Page Groups'
,p_list_item_link_target=>'f?p=&APP_ID.:520:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'520:521'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(7889418131882539)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Page Group Assignments'
,p_list_item_link_target=>'f?p=&APP_ID.:522:&SESSION.::&DEBUG.:RP,522:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'522'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(213326924824175665)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Pages by Page Group'
,p_list_item_link_target=>'f?p=&APP_ID.:528:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'528'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_copy_template
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(222829818333256486)
,p_name=>'Wizard Copy Template'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474695
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(222830025179256507)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Template to Copy'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'584'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(222830500690256514)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'New Template'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'538:568:569:571:564:573:574:636'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_create_rest_data_source
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(226545212901831813)
,p_name=>'Wizard Create REST Data Source'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474695
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(226545418188831828)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'General'
,p_list_item_link_target=>'f?p=&APP_ID.:1941:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(226545892098831833)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Remote Server'
,p_list_item_link_target=>'f?p=&APP_ID.:1942:&SESSION.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1295970335077570)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Settings'
,p_list_item_link_target=>'f?p=&APP_ID.:1945:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(226546270015831833)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Authentication'
,p_list_item_link_target=>'f?p=&APP_ID.:1943:&SESSION.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(226680867806416802)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Parameters'
,p_list_item_link_target=>'f?p=&APP_ID.:1944:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_EQUALS_CONDITION'
,p_list_item_disp_condition=>'1944'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(226546658284831833)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Preview'
,p_list_item_link_target=>'f?p=&APP_ID.:1946:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/deinstall_preview
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(227753031474767408)
,p_name=>'Deinstall Preview'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474695
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(227754420869773895)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Preview Deinstallation Script'
,p_list_item_link_target=>'f?p=&APP_ID.:2109:&SESSION.::&DEBUG.::P2109_MODE:DEINSTALL'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_copy_process
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(227766223920945009)
,p_name=>'Wizard Copy Process'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474695
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(227766422394945011)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Process to Copy'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'590'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(227766714836945011)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Process Options'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'645'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_copy_validation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(228167614670175482)
,p_name=>'Wizard Copy Validation'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474695
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_copy_branch
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(228256415837925869)
,p_name=>'Wizard Copy Branch'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474695
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(228256632661925872)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Branch to Copy'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'587'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(228256900182925873)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Branch Options'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'685'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_copy_computation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(228264919955974373)
,p_name=>'Wizard Copy Computation'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474695
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(228266003117978994)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Computation to Copy'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'592'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(228266412121981558)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Computation Options'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'597'
);
end;
/
prompt --application/shared_components/navigation/lists/copy_list_train
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(231136205422723196)
,p_name=>'copy list train'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474695
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(231137725854729050)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Identify List'
,p_list_item_link_target=>'f?p=&APP_ID.:663:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'663'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_web_sources_navigation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(241353531173849237)
,p_name=>'shared.components.web_sources.navigation'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474695
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(241353749272849252)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'REST Data Sources'
,p_list_item_link_target=>'f?p=&APP_ID.:1901:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(564743301883397522)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Synchronizations'
,p_list_item_link_target=>'f?p=&APP_ID.:1955:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(241354167823849253)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Utilization'
,p_list_item_link_target=>'f?p=&APP_ID.:1902:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(247801890036355717)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'History'
,p_list_item_link_target=>'f?p=&APP_ID.:1903:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/remoteserver_create
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(249337602894822823)
,p_name=>'remoteserver.create'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474695
);
end;
/
prompt --application/shared_components/navigation/lists/remoteserver_createnew
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(249355742923907578)
,p_name=>'remoteserver.createnew'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474695
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(249355942729907578)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'General'
,p_list_item_link_target=>'f?p=&APP_ID.:1615:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(249356348643907578)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>'Authentication'
,p_list_item_link_target=>'f?p=&APP_ID.:1616:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/websrcmodule_create
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(249385562937130742)
,p_name=>'websrcmodule.create'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474695
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(249385724604130742)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Method'
,p_list_item_link_target=>'f?p=&APP_ID.:1905:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(249386134393130742)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Copy From'
,p_list_item_link_target=>'f?p=&APP_ID.:1906:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_list_item_disp_condition=>'P1905_ACTION'
,p_list_item_disp_condition2=>'COPY'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(4600351737385437)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Create from Catalog'
,p_list_item_link_target=>'f?p=&APP_ID.:1908:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_list_item_disp_condition=>'P1905_ACTION'
,p_list_item_disp_condition2=>'CATALOG'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1908'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1903006796784570)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Choose Services'
,p_list_item_link_target=>'f?p=&APP_ID.:1911:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_list_item_disp_condition=>'P1905_ACTION'
,p_list_item_disp_condition2=>'CATALOG'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1911'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1904581007791181)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Summary'
,p_list_item_link_target=>'f?p=&APP_ID.:1910:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_list_item_disp_condition=>'P1905_ACTION'
,p_list_item_disp_condition2=>'CATALOG'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1910'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(249386558688130742)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Copy'
,p_list_item_link_target=>'f?p=&APP_ID.:1907:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_list_item_disp_condition=>'P1905_ACTION'
,p_list_item_disp_condition2=>'CATALOG'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/application_attributes_tabs
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(274897624522614662)
,p_name=>'application attributes tabs'
,p_list_status=>'PUBLIC'
,p_version_scn=>1054948234
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(274898302490617757)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Definition'
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_DEFN'');'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'4001'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(274905604268646630)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Security'
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_SEC'');'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'509'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(33757928911956810)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Globalization'
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_GLOBAL'');'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'506'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(42233410928343483)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'User Interface'
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_USERINTERFACE'');'
,p_required_patch=>wwv_flow_imp.id(235700916833599805)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'197, 677'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(106143872367571065)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Progressive Web App'
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_PWA'');'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'507'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1409824858643609)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'AI'
,p_list_item_link_target=>'javascript:doSubmit(''APPLY_CHANGES_AI'');'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'523'
);
end;
/
prompt --application/shared_components/navigation/lists/apex_5_administration_header
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(384736293175059813)
,p_name=>'APEX 5 - Administration (Header)'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474695
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(387750990921837996)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Administration'
,p_list_item_link_target=>'f?p=4350:1:&APP_SESSION.'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(488619320836057116)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'------'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(572044671779464700)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Manage Service'
,p_security_scheme=>wwv_flow_imp.id(12511519296310366)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(697357627145483514)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Manage Service'
,p_list_item_link_target=>'f?p=4350:21:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(572044671779464700)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(697357856198483516)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'------'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_imp.id(572044671779464700)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(572699887011597076)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Make a Service Request'
,p_list_item_link_target=>'f?p=4350:96:&SESSION.::NO:49::'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_platform.get_preference(''SERVICE_REQUESTS_ENABLED'') = ''Y'''
,p_list_item_disp_condition2=>'PLSQL'
,p_parent_list_item_id=>wwv_flow_imp.id(572044671779464700)
,p_security_scheme=>wwv_flow_imp.id(12511519296310366)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(697358175538483516)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'Set Workspace Preferences'
,p_list_item_link_target=>'f?p=4350:17:&SESSION.::NO:RP::'
,p_parent_list_item_id=>wwv_flow_imp.id(572044671779464700)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(697358473589483516)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>'Define Workspace Message'
,p_list_item_link_target=>'f?p=4350:35:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(572044671779464700)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(180638709312604050)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>'Define Environment Banner'
,p_list_item_link_target=>'f?p=4350:105:&SESSION.:::105:P105_LAST_APP_ID,P105_LAST_PAGE_ID:&APP_ID.,&APP_PAGE_ID.'
,p_parent_list_item_id=>wwv_flow_imp.id(572044671779464700)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(322860788157413129)
,p_list_item_display_sequence=>140
,p_list_item_link_text=>'Workspace Utilization'
,p_list_item_link_target=>'f?p=4350:101:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(572044671779464700)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2800246702386251)
,p_list_item_display_sequence=>150
,p_list_item_link_text=>'Manage Extension Links'
,p_list_item_link_target=>'f?p=4350:110:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(572044671779464700)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(195346789722904026)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Manage Users and Groups'
,p_list_item_link_target=>'f?p=4350:55:&SESSION.'
,p_security_scheme=>wwv_flow_imp.id(12511519296310366)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(572046067324491819)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Monitor Activity'
,p_list_item_link_target=>'f?p=4350:22:&SESSION.'
,p_security_scheme=>wwv_flow_imp.id(10593027526205581)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(327720126528125003)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Dashboards'
,p_list_item_link_target=>'f?p=4350:33:&SESSION.'
,p_security_scheme=>wwv_flow_imp.id(10593027526205581)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1250496483207165958)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Change My Password'
,p_list_item_link_target=>'f?p=4350:3:&SESSION.::&DEBUG.:3#pwd'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_authentication_dev.can_edit_builder_users'
,p_list_item_disp_condition2=>'PLSQL'
,p_security_scheme=>wwv_flow_imp.id(10593027526205581)
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/apex_shared_navigation_menu
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(384991882401692897)
,p_name=>'APEX Shared Navigation Menu'
,p_list_status=>'PUBLIC'
,p_reference_id=>2206460728364447
,p_version_scn=>117449631
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2035847551227433)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'App Builder'
,p_list_item_link_target=>'f?p=4000:1500:&SESSION.::&DEBUG.::::'
,p_list_item_icon_alt_attribute=>'App Builder Drill Down'
,p_list_text_01=>'tab-app-builder'
,p_security_scheme=>wwv_flow_imp.id(178938910382761975)
,p_list_item_current_type=>'EXPRESSION'
,p_list_item_current_for_pages=>':APP_ID in ( 4000, 4020 )'
,p_list_item_current_language=>'PLSQL'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2036231108227433)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Create'
,p_list_item_link_target=>'f?p=4000:56:&SESSION.::&DEBUG.:56,103,104,106,130,131,35,227,3020,3000,3001:FB_FLOW_ID,FB_FLOW_PAGE_ID::'
,p_parent_list_item_id=>wwv_flow_imp.id(2035847551227433)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2036691917227433)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Import'
,p_list_item_link_target=>'f?p=4000:460:&SESSION.::&DEBUG.:460:P460_FILE_TYPE:FLOW_EXPORT:'
,p_parent_list_item_id=>wwv_flow_imp.id(2035847551227433)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2037030018227433)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Export'
,p_list_item_link_target=>'f?p=4000:4900:&SESSION.::&DEBUG.:4900:FB_FLOW_ID,FB_FLOW_PAGE_ID::'
,p_parent_list_item_id=>wwv_flow_imp.id(2035847551227433)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2037419751227434)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_imp.id(2035847551227433)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2037884994227434)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Workspace Utilities'
,p_parent_list_item_id=>wwv_flow_imp.id(2035847551227433)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2038277030227434)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'All Workspace Utilities'
,p_list_item_link_target=>'f?p=4000:182:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_imp.id(2037884994227434)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2038694569227434)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_imp.id(2037884994227434)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2039048438227434)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>'Workspace Themes'
,p_list_item_link_target=>'f?p=4000:763:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_imp.id(2037884994227434)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2039470362227434)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>'Application Groups'
,p_list_item_link_target=>'f?p=4000:722:&SESSION.::&DEBUG.:RP'
,p_parent_list_item_id=>wwv_flow_imp.id(2037884994227434)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2039809844227434)
,p_list_item_display_sequence=>140
,p_list_item_link_text=>'&PRODUCT_NAME. Views'
,p_list_item_link_target=>'f?p=4000:714:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_imp.id(2037884994227434)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2040258370227434)
,p_list_item_display_sequence=>150
,p_list_item_link_text=>'Cross Application Reports'
,p_list_item_link_target=>'f?p=4000:9009:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_imp.id(2037884994227434)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2040646341227435)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'SQL Workshop'
,p_list_item_link_target=>'f?p=4500:3002:&SESSION.'
,p_list_item_icon_alt_attribute=>'SQL Workshop Drill Down'
,p_list_text_01=>'tab-sql-workshop'
,p_security_scheme=>wwv_flow_imp.id(178939331963761975)
,p_list_item_current_type=>'EXPRESSION'
,p_list_item_current_for_pages=>'( :APP_ID = 4500 and :APP_PAGE_ID not in ( ''1000'',''8000'',''35'', ''900'' ) ) or :APP_ID in ( 4850, 4300 )'
,p_list_item_current_language=>'PLSQL'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2041018136227435)
,p_list_item_display_sequence=>160
,p_list_item_link_text=>'Object Browser'
,p_list_item_link_target=>'f?p=4500:2000:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2040646341227435)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2041402316227435)
,p_list_item_display_sequence=>170
,p_list_item_link_text=>'SQL Commands'
,p_list_item_link_target=>'f?p=4500:1003:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2040646341227435)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2041810185227435)
,p_list_item_display_sequence=>180
,p_list_item_link_text=>'SQL Scripts'
,p_list_item_link_target=>'f?p=4500:1004:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2040646341227435)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2042252564227435)
,p_list_item_display_sequence=>190
,p_list_item_link_text=>'Utilities'
,p_parent_list_item_id=>wwv_flow_imp.id(2040646341227435)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2042651937227435)
,p_list_item_display_sequence=>220
,p_list_item_link_text=>'All Utilities'
,p_list_item_link_target=>'f?p=4500:1005:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2042252564227435)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2043018280227435)
,p_list_item_display_sequence=>230
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_imp.id(2042252564227435)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2043493110227435)
,p_list_item_display_sequence=>240
,p_list_item_link_text=>'Data Workshop'
,p_list_item_link_target=>'f?p=4300:1:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2042252564227435)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2043812370227436)
,p_list_item_display_sequence=>250
,p_list_item_link_text=>'Data Generator'
,p_list_item_link_target=>'f?p=4500:4000:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2042252564227435)
,p_security_scheme=>wwv_flow_imp.id(1753774729792863)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2044248148227436)
,p_list_item_display_sequence=>260
,p_list_item_link_text=>'Query Builder'
,p_list_item_link_target=>'f?p=4500:1002:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2042252564227435)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2044650772227436)
,p_list_item_display_sequence=>270
,p_list_item_link_text=>'Quick SQL'
,p_list_item_link_target=>'f?p=4500:1100:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2042252564227435)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2045048421227436)
,p_list_item_display_sequence=>280
,p_list_item_link_text=>'Sample Datasets'
,p_list_item_link_target=>'f?p=4300:100:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2042252564227435)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2045433683227436)
,p_list_item_display_sequence=>290
,p_list_item_link_text=>'Generate DDL'
,p_list_item_link_target=>'f?p=4500:12:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2042252564227435)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2045881550227436)
,p_list_item_display_sequence=>300
,p_list_item_link_text=>'UI Defaults'
,p_list_item_link_target=>'f?p=4500:813:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2042252564227435)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2046202089227436)
,p_list_item_display_sequence=>310
,p_list_item_link_text=>'Schema Comparison'
,p_list_item_link_target=>'f?p=4500:1350:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2042252564227435)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2046602964227436)
,p_list_item_display_sequence=>320
,p_list_item_link_text=>'Methods on Tables'
,p_list_item_link_target=>'f?p=4500:120:&SESSION.:'
,p_parent_list_item_id=>wwv_flow_imp.id(2042252564227435)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2047023524227436)
,p_list_item_display_sequence=>330
,p_list_item_link_text=>'Recycle Bin'
,p_list_item_link_target=>'f?p=4500:1070:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2042252564227435)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2047420503227437)
,p_list_item_display_sequence=>340
,p_list_item_link_text=>'Object Reports'
,p_list_item_link_target=>'f?p=4500:1042:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2042252564227435)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2047844256227437)
,p_list_item_display_sequence=>350
,p_list_item_link_text=>'About Database'
,p_list_item_link_target=>'f?p=4500:36:&SESSION.'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_platform.get_preference(''ALLOW_DB_MONITOR'') = ''Y'''
,p_list_item_disp_condition2=>'PLSQL'
,p_parent_list_item_id=>wwv_flow_imp.id(2042252564227435)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2048277577227437)
,p_list_item_display_sequence=>360
,p_list_item_link_text=>'Database Monitor'
,p_list_item_link_target=>'f?p=4500:11:&SESSION.'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_platform.get_preference(''ALLOW_DB_MONITOR'') = ''Y'''
,p_list_item_disp_condition2=>'PLSQL'
,p_parent_list_item_id=>wwv_flow_imp.id(2042252564227435)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2048614121227437)
,p_list_item_display_sequence=>200
,p_list_item_link_text=>'RESTful Services'
,p_list_item_link_target=>'f?p=4850:100:&SESSION.'
,p_parent_list_item_id=>wwv_flow_imp.id(2040646341227435)
,p_security_scheme=>wwv_flow_imp.id(802892920094782611)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2049011597227437)
,p_list_item_display_sequence=>210
,p_list_item_link_text=>'SQL Developer Web'
,p_list_item_link_target=>'f?p=4500:64:&SESSION.::&DEBUG.:64:::'
,p_parent_list_item_id=>wwv_flow_imp.id(2040646341227435)
,p_security_scheme=>wwv_flow_imp.id(11401665712577717)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2049461914227437)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Team Development'
,p_list_item_link_target=>'f?p=4600:1:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon_alt_attribute=>'Team Development Drill Down'
,p_list_text_01=>'tab-team-dev'
,p_security_scheme=>wwv_flow_imp.id(178939812163761988)
,p_list_item_current_type=>'EXPRESSION'
,p_list_item_current_for_pages=>':APP_ID in ( 4600, 4650 )'
,p_list_item_current_language=>'PLSQL'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2049805206227437)
,p_list_item_display_sequence=>370
,p_list_item_link_text=>'Labels'
,p_list_item_link_target=>'f?p=4600:300:&SESSION.::&DEBUG.:RP:::'
,p_parent_list_item_id=>wwv_flow_imp.id(2049461914227437)
,p_security_scheme=>wwv_flow_imp.id(12510423405283164)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2050202458227438)
,p_list_item_display_sequence=>380
,p_list_item_link_text=>'Milestones'
,p_list_item_link_target=>'f?p=4600:200:&SESSION.::&DEBUG.:RP:::'
,p_parent_list_item_id=>wwv_flow_imp.id(2049461914227437)
,p_security_scheme=>wwv_flow_imp.id(12510423405283164)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2050616257227438)
,p_list_item_display_sequence=>390
,p_list_item_link_text=>'Templates'
,p_list_item_link_target=>'f?p=4600:1000:&SESSION.::&DEBUG.:RP:::'
,p_parent_list_item_id=>wwv_flow_imp.id(2049461914227437)
,p_security_scheme=>wwv_flow_imp.id(12510423405283164)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2051085138227438)
,p_list_item_display_sequence=>400
,p_list_item_link_text=>'Utilities'
,p_list_item_link_target=>'f?p=4600:2000:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_imp.id(2049461914227437)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2051447562227438)
,p_list_item_display_sequence=>410
,p_list_item_link_text=>'-----'
,p_list_item_link_target=>'separator'
,p_parent_list_item_id=>wwv_flow_imp.id(2049461914227437)
,p_security_scheme=>wwv_flow_imp.id(12510423405283164)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2051859241227438)
,p_list_item_display_sequence=>420
,p_list_item_link_text=>'Feedback'
,p_list_item_link_target=>'f?p=4650:8012:&SESSION.::&DEBUG.::::'
,p_parent_list_item_id=>wwv_flow_imp.id(2049461914227437)
,p_security_scheme=>wwv_flow_imp.id(12510423405283164)
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2052239204227438)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Gallery'
,p_list_item_link_target=>'f?p=4750:50:&SESSION.'
,p_list_text_01=>'tab-apps'
,p_security_scheme=>wwv_flow_imp.id(12510423405283164)
,p_list_item_current_type=>'EXPRESSION'
,p_list_item_current_for_pages=>':APP_ID = 4750'
,p_list_item_current_language=>'PLSQL'
);
end;
/
prompt --application/shared_components/navigation/lists/application_utilities_managebackups
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(392874975855473167)
,p_name=>'application.utilities.managebackups'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474697
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(392875192940473167)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'All Backups'
,p_list_item_link_target=>'f?p=&APP_ID.:970:&SESSION.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(482121222077403370)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'All Backup Details'
,p_list_item_link_target=>'f?p=&APP_ID.:979:&SESSION.::&DEBUG.:RP,979:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/attribute_dictionary
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(445192614743849621)
,p_name=>'Attribute Dictionary'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474697
);
end;
/
prompt --application/shared_components/navigation/lists/p164_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(445352903500710112)
,p_name=>'P164_TASKS'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474697
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(445353209286710113)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Export Application'
,p_list_item_link_target=>'f?p=&APP_ID.:4900:&SESSION.:'
,p_list_item_current_for_pages=>'4900'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(445353627788710114)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Export Components'
,p_list_item_link_target=>'f?p=&APP_ID.:688:&SESSION.::&DEBUG.:CR:::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/standard_tab_display
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(454874132315440955)
,p_name=>'Standard Tab Display'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474697
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(454874414531440958)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'The page identifies a <strong>Standard Tab Set</strong>.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(454881521635541944)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'The <strong>Tab Entry</strong> identifies the page as the <strong>Tab Page</strong>, or the <strong>Tab Also Current For Pages</strong>.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(454874801932440962)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'The page''s <strong>Page Template</strong> is capable of displaying <strong>Standard Tabs</strong>.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(454875215155440962)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'The tab entries <strong>display condition</strong> do not prevent tab from displaying'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(454920400070828946)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'The tab entries <strong>Authorization Scheme</strong> does not prevent the tab from being displayed.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/parent_tab_display
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(455042113172478942)
,p_name=>'Parent Tab Display'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474702
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(455042409640478944)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'The page successfully displays a <strong>Standard Tab</strong>.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(455051127155492375)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'The <strong>Standard Tab</strong> identifies the correct <strong>Parent Tab Set</strong>.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(455060118431660179)
,p_list_item_display_sequence=>25
,p_list_item_link_text=>'The <strong>Parent Tab</strong> identifies the correct tab set in the <strong>Current on Standard Tab Set</strong> attribute.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(455051817936499217)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'The pages <strong>Page Template</strong> is capable of displaying <strong>Standard Tabs</strong> and <strong>Parent Tabs</strong>.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(455054405216552285)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'The parent tabs <strong>Display Condition</strong> does not prevent the parent tab from displaying.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(455055223701567123)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'The parent tabs <strong>Authorization Scheme</strong> does not prevent the parent tab from displaying.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/wizard_advanced_migration
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(484017424976766961)
,p_name=>'Wizard_Advanced_Migration'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474702
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(499114818402832919)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Select Page'
,p_list_item_link_target=>'f?p=&APP_ID.:911:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(484017612155766970)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Select Validations to Upgrade'
,p_list_item_link_target=>'f?p=&APP_ID.:86:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'86'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(484017930508766978)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Select Buttons to Not Execute Validations'
,p_list_item_link_target=>'f?p=&APP_ID.:646:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'646'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(631593123192499955)
,p_list_item_display_sequence=>25
,p_list_item_link_text=>'Select Validations to Always Execute'
,p_list_item_link_target=>'f?p=&APP_ID.:862:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'862'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(492683002038349240)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Upgrade '
,p_list_item_link_target=>'f?p=&APP_ID.:383:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'383'
);
end;
/
prompt --application/shared_components/navigation/lists/export
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(486268530815434681)
,p_name=>'Export'
,p_list_status=>'PUBLIC'
,p_version_scn=>117491716
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(486269231292444337)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Workspace'
,p_list_item_link_target=>'f?p=&APP_ID.:76:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-workspace'
,p_list_text_01=>'Export a workspace, which includes user groups, users, and team development data, but not applications.'
,p_translate_list_text_y_n=>'Y'
,p_security_scheme=>wwv_flow_imp.id(12511519296310366)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(486268818479440607)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Applications'
,p_list_item_link_target=>'f?p=&APP_ID.:4900:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-app-database'
,p_list_text_01=>'Export applications, individual pages, and shared components.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(486271016233477824)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Application Themes'
,p_list_item_link_target=>'f?p=&APP_ID.:224:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-workspace-themes'
,p_list_text_01=>'Export themes from a specific application.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(486271223505479946)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Plug-ins'
,p_list_item_link_target=>'f?p=&APP_ID.:4460:&SESSION.::&DEBUG.:4460:::'
,p_list_item_icon=>'icon-sc-plugin'
,p_list_text_01=>'Export plug-ins used in applications.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(486271911862486037)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'UI Defaults'
,p_list_item_link_target=>'f?p=&APP_ID.:479:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-utilities-ui-defaults'
,p_list_text_01=>'Export table or attribute UI Defaults.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(486272411647495352)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Team Development Feedback'
,p_list_item_link_target=>'f?p=&APP_ID.:689:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-page-feedback'
,p_list_text_01=>'Export feedback provided by application users in this workspace.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(4117748652625154)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'REST Source Catalog'
,p_list_item_link_target=>'f?p=&APP_ID.:1965:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-sc-data-references'
,p_list_text_01=>'Export REST Source Catalogs to be imported into other workspaces.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/export_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(486307715596288607)
,p_name=>'export tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474703
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(486307910526288621)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Export Repository'
,p_list_item_link_target=>'f?p=&APP_ID.:73:&SESSION.:'
,p_list_item_current_for_pages=>'73'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(486308216101288623)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Import'
,p_list_item_link_target=>'f?p=&APP_ID.:460:&SESSION.::&DEBUG.:460:P460_CANCEL_TARGET:&APP_PAGE_ID.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/ui_def_export_tabs
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(486427731138207743)
,p_name=>'ui def export tabs'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474704
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(486428118802213684)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Table Dictionary'
,p_list_item_link_target=>'f?p=&APP_ID.:479:&SESSION.::&DEBUG.:479:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'479'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(486428330923217163)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Attribute Dictionary'
,p_list_item_link_target=>'f?p=&APP_ID.:541:&SESSION.::&DEBUG.:541:::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'541'
);
end;
/
prompt --application/shared_components/navigation/lists/apex_5_help
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(488490120498750288)
,p_name=>'APEX 5 - Help'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474704
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(488490330263750290)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Documentation'
,p_list_item_link_target=>'&SYSTEM_HELP_URL.'
,p_list_text_01=>'helpLinkNewWindow'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2105950689804969205)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Discussion Forum'
,p_list_item_link_target=>'https://apex.oracle.com/forum'
,p_list_text_01=>'helpLinkForum'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2185440048625469825)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Learn More about Oracle APEX'
,p_list_item_link_target=>'https://apex.oracle.com'
,p_list_text_01=>'helpLinkOTN'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1493545637548007510)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Getting Started in Page Designer'
,p_list_item_link_target=>'f?p=&APP_ID.:30:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>':APP_ID = 4000 and :APP_PAGE_ID = 4500'
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(488495081334766183)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Keyboard Shortcuts'
,p_list_item_link_target=>'#'
,p_list_text_01=>'keyboardShortcuts'
,p_list_text_03=>'true'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(488616497367046354)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'---'
,p_list_item_link_target=>'separator'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(488492468953750295)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'About'
,p_list_item_link_target=>'f?p=4350:9:&SESSION.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/application_utilities_other
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(492631804585583697)
,p_name=>'application.utilities.other'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474704
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(492632127095590176)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Cross Page Utilities'
,p_list_item_link_target=>'f?p=&APP_ID.:553:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(404527353730174909)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Page Groups'
,p_list_item_link_target=>'f?p=&APP_ID.:520:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(492632330558591213)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Region Utilities'
,p_list_item_link_target=>'f?p=&APP_ID.:853:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(492632500560591999)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Button Utilities'
,p_list_item_link_target=>'f?p=&APP_ID.:852:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(492632703677592889)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Item Utilities'
,p_list_item_link_target=>'f?p=&APP_ID.:854:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(492632906448593646)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Computation Utilities'
,p_list_item_link_target=>'f?p=&APP_ID.:847:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(821538007832540402)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Validation Utilities'
,p_list_item_link_target=>'f?p=&APP_ID.:851:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(492633108872594367)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Process Utilities'
,p_list_item_link_target=>'f?p=&APP_ID.:482:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(492633311642595224)
,p_list_item_display_sequence=>90
,p_list_item_link_text=>'Dynamic Action Utilities'
,p_list_item_link_target=>'f?p=&APP_ID.:699:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(492633614413596002)
,p_list_item_display_sequence=>100
,p_list_item_link_text=>'Branch Utilities'
,p_list_item_link_target=>'f?p=&APP_ID.:881:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/page_utilities_cross_page
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(492636810051679904)
,p_name=>'page.utilities.cross.page'
,p_list_status=>'PUBLIC'
,p_version_scn=>196603926
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(492638629491713849)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Delete Multiple Pages'
,p_list_item_link_target=>'f?p=&APP_ID.:339:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(492638421180711426)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Page Attributes'
,p_list_item_link_target=>'f?p=&APP_ID.:484:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(492639008497717241)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Page Locks'
,p_list_item_link_target=>'f?p=&APP_ID.:291:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1410522729131857)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Page Pattern Utilization'
,p_list_item_link_target=>'f?p=&APP_ID.:6210:&SESSION.::&DEBUG.:RP:::'
,p_list_item_disp_cond_type=>'EXPRESSION'
,p_list_item_disp_condition=>'wwv_flow_platform.get_preference(''ENABLE_PAGE_PATTERNS'') = ''Y'''
,p_list_item_disp_condition2=>'PLSQL'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/advisor_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(504056409460898231)
,p_name=>'Advisor Tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474704
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(504056630453898233)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Save as My Preferences'
,p_list_item_link_target=>'javascript:apex.submit(''SAVE_PREF'')'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_workspace_objects
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(525226966024198272)
,p_name=>'shared.components.workspace_objects'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474704
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(525227999285198277)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Static Workspace Files'
,p_list_item_link_target=>'f?p=&APP_ID.:312:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(525227596268198277)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Credentials'
,p_list_item_link_target=>'f?p=&APP_ID.:1620:&SESSION.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(525227186638198275)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'REST Enabled SQL'
,p_list_item_link_target=>'f?p=&APP_ID.:1600:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(533134053205118467)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Remote Servers'
,p_list_item_link_target=>'f?p=&APP_ID.:1931:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_remote_servers
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(533145899605135270)
,p_name=>'shared.components.remote_servers'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474704
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(533146052588135270)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Remote Servers'
,p_list_item_link_target=>'f?p=&APP_ID.:1931:&SESSION.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(533146454181135274)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Utilization'
,p_list_item_link_target=>'f?p=&APP_ID.:1933:&SESSION.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(533187009031297607)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'History'
,p_list_item_link_target=>'f?p=&APP_ID.:1934:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/home_page_get_started_list
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(583541659513985598)
,p_name=>'Home Page Get Started List'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474704
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(583609906498114141)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'Create a New App'
,p_list_item_link_target=>'f?p=&APP_ID.:56:&SESSION.::&DEBUG.:56:::'
,p_list_item_icon=>'icon-check-circle'
,p_list_text_01=>'Start building your first application in Oracle APEX.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(583541885189985600)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Install a Starter or Sample App'
,p_list_item_link_target=>'f?p=4750:50:&APP_SESSION.'
,p_list_item_icon=>'icon-util-install'
,p_list_text_01=>'Choose from over 20 sample and starter apps.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/remoteprintserver_create
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(608916658335678510)
,p_name=>'remoteprintserver.create'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474704
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(608916854583678511)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Add Remote Print Server'
,p_list_item_link_target=>'f?p=&APP_ID.:1935:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(608917221616678511)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Add Remote Print Server Credentials'
,p_list_item_link_target=>'f?p=&APP_ID.:1936:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/legacy_data_load_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(675812107017852883)
,p_name=>'LEGACY_DATA_LOAD_TASKS'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474704
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(675812305879852884)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Create Pages using this Legacy Data Load'
,p_list_item_link_target=>'f?p=&APP_ID.:1704:&SESSION.::&DEBUG.:1704,1706:F4000_P1700_NAME,P1700_EXISTS:&P1801_NAME.,yes:'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_components
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(694733590452503217)
,p_name=>'shared.components.components'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474704
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(694734693779503223)
,p_list_item_display_sequence=>5
,p_list_item_link_text=>'Lists of Values'
,p_list_item_link_target=>'f?p=&APP_ID.:4110:&SESSION.::&DEBUG.::::'
,p_list_text_01=>'&P9_LOVS.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(694735222077503223)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Plug-ins'
,p_list_item_link_target=>'f?p=&APP_ID.:4400:&SESSION.::&DEBUG.:RP:::'
,p_list_text_01=>'&P9_PLUGINS.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(694735518639503226)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Component Settings'
,p_list_item_link_target=>'f?p=&APP_ID.:4445:&SESSION.::&DEBUG.:RP:::'
,p_list_item_current_type=>'NEVER'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(697104363364517738)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Trees'
,p_list_item_link_target=>'f?p=&APP_ID.:28:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from   WWV_FLOW_TREES t',
'where  flow_id = :fb_flow_id ',
'   and security_group_id = :flow_security_group_id'))
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(694734925778503223)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Shortcuts'
,p_list_item_link_target=>'f?p=&APP_ID.:4047:&SESSION.::&DEBUG.::::'
,p_list_text_01=>'&P9_SHORTCUTS.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(680965773582442489)
,p_list_item_display_sequence=>60
,p_list_item_link_text=>'Email Templates'
,p_list_item_link_target=>'f?p=&APP_ID.:4860:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_text_01=>'&P9_EMAIL_TEMPLATES.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1383594779215236)
,p_list_item_display_sequence=>70
,p_list_item_link_text=>'Map Backgrounds'
,p_list_item_link_target=>'f?p=&APP_ID.:6100:&SESSION.::&DEBUG.::::'
,p_list_text_01=>'&P9_MAP_BACKGROUNDS.'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(5957144086230748)
,p_list_item_display_sequence=>80
,p_list_item_link_text=>'Component Groups'
,p_list_item_link_target=>'f?p=&APP_ID.:6200:&SESSION.::&DEBUG.::::'
,p_list_text_01=>'&P9_COMPONENT_GROUPS.'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_application_logic
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(694736922570524377)
,p_name=>'shared.components.application_logic'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474704
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(694739304257531368)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Application Definition'
,p_list_item_link_target=>'f?p=&APP_ID.:4001:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(694737191989524378)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Application Items'
,p_list_item_link_target=>'f?p=&APP_ID.:4100:&SESSION.::&DEBUG.::::'
,p_list_text_01=>'&P9_APP_ITEMS.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(694737422504524378)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Application Processes'
,p_list_item_link_target=>'f?p=&APP_ID.:4207:&SESSION.::&DEBUG.::::'
,p_list_text_01=>'&P9_APP_PROCESSES.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(694737701535524378)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Application Computations'
,p_list_item_link_target=>'f?p=&APP_ID.:4101:&SESSION.::&DEBUG.::::'
,p_list_text_01=>'&P9_APP_COMPUTATIONS.'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(659490721011613496)
,p_list_item_display_sequence=>45
,p_list_item_link_text=>'Application Settings'
,p_list_item_link_target=>'f?p=&APP_ID.:4850:&SESSION.::&DEBUG.::::'
,p_list_text_01=>'&P9_APP_SETTINGS.'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2900257312389557)
,p_list_item_display_sequence=>49
,p_list_item_link_text=>'Automations'
,p_list_item_link_target=>'f?p=&APP_ID.:7020:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'NEVER'
,p_list_text_01=>'&P9_AUTOMATIONS.'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(154811378368453381)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Build Options'
,p_list_item_link_target=>'f?p=&APP_ID.:4910:&SESSION.::&DEBUG.::::'
,p_list_text_01=>'&P9_BUILD_OPTIONS.'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/shared_components_references
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(694855238818571795)
,p_name=>'shared.components.references'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474704
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(694857216757571796)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Data Load Definitions'
,p_list_item_link_target=>'f?p=&APP_ID.:1800:&SESSION.::&DEBUG.::::'
,p_list_text_01=>'&P9_DATA_LOAD_DEFINITIONS.'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(154069177738949720)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'REST Enabled SQL'
,p_list_item_link_target=>'f?p=&APP_ID.:1600:&SESSION.::&DEBUG.::::'
,p_list_text_03=>'has-arrow'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(226162637659581893)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'REST Data Sources'
,p_list_item_link_target=>'f?p=&APP_ID.:1901:&SESSION.::&DEBUG.::::'
,p_list_text_01=>'&P9_REST_DATA_SOURCES.'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(231826647978900986)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'REST Synchronization'
,p_list_item_link_target=>'f?p=&APP_ID.:1955:&SESSION.::&DEBUG.::::'
,p_list_text_01=>'&P9_REST_SYNCS.'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(694856635326571796)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Legacy Web Service References'
,p_list_item_link_target=>'f?p=&APP_ID.:170:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from WWV_FLOW_SHARED_WEB_SERVICES',
' where SECURITY_GROUP_ID = :flow_security_group_id ',
'   and FLOW_ID = :fb_flow_id'))
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/cross_application_reports
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(702923103587108064)
,p_name=>'Cross Application Reports'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474704
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(702928892130158098)
,p_list_item_display_sequence=>1
,p_list_item_link_text=>'All Reports'
,p_list_item_link_target=>'f?p=&APP_ID.:9009:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'182'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(702923320676108064)
,p_list_item_display_sequence=>110
,p_list_item_link_text=>'Application Attributes'
,p_list_item_link_target=>'f?p=&APP_ID.:9010:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-application-attributes'
,p_list_text_01=>'View component counts for each application.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'9010'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(702923966900108065)
,p_list_item_display_sequence=>120
,p_list_item_link_text=>'Build and App Status'
,p_list_item_link_target=>'f?p=&APP_ID.:103:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'icon-app-status'
,p_list_text_01=>'Review the statuses for each application.'
,p_translate_list_text_y_n=>'Y'
,p_security_scheme=>wwv_flow_imp.id(12511519296310366)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'103'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(702924515837108067)
,p_list_item_display_sequence=>130
,p_list_item_link_text=>'Build Options'
,p_list_item_link_target=>'f?p=&APP_ID.:9012:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-build-options'
,p_list_text_01=>'View Build options across all applications.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'9012'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(702923668978108065)
,p_list_item_display_sequence=>140
,p_list_item_link_text=>'Developer Comments'
,p_list_item_link_target=>'f?p=&APP_ID.:380:&SESSION.::&DEBUG.:RP:::'
,p_list_item_icon=>'icon-util-comments'
,p_list_text_01=>'Review comments from all applications.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'380'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(702924262274108066)
,p_list_item_display_sequence=>150
,p_list_item_link_text=>'Comments Calendar'
,p_list_item_link_target=>'f?p=&APP_ID.:665:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'icon-util-comments-calendar'
,p_list_text_01=>'View when all comments were created.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'665'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(702925980864149602)
,p_list_item_display_sequence=>210
,p_list_item_link_text=>'Application Comparison'
,p_list_item_link_target=>'f?p=&APP_ID.:1300:&SESSION.:NORUN:&DEBUG.::::'
,p_list_text_01=>'Query differences in component names.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_for_pages=>'1300'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(702926244508149602)
,p_list_item_display_sequence=>220
,p_list_item_link_text=>'Component Comparison'
,p_list_item_link_target=>'f?p=&APP_ID.:1301:&SESSION.:NORUN:&DEBUG.::::'
,p_list_text_01=>'Query differences in component counts.'
,p_translate_list_text_y_n=>'Y'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(702926528050149602)
,p_list_item_display_sequence=>310
,p_list_item_link_text=>'Security Profiles'
,p_list_item_link_target=>'f?p=&APP_ID.:9014:&SESSION.::&DEBUG.::::'
,p_list_item_current_for_pages=>'9014'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(702926833196149603)
,p_list_item_display_sequence=>320
,p_list_item_link_text=>'Authentication Schemes'
,p_list_item_link_target=>'f?p=&APP_ID.:9015:&SESSION.::&DEBUG.::::'
,p_list_item_current_for_pages=>'9015'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(702927168153149603)
,p_list_item_display_sequence=>330
,p_list_item_link_text=>'Password Items'
,p_list_item_link_target=>'f?p=&APP_ID.:7777:&SESSION.::&DEBUG.::::'
,p_list_item_current_for_pages=>'7777'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(702927429794149604)
,p_list_item_display_sequence=>410
,p_list_item_link_text=>'Theme Summary'
,p_list_item_link_target=>'f?p=&APP_ID.:737:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/developer_comments_navigation
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(784788000174894142)
,p_name=>'developer.comments.navigation'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474704
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(784788282093894144)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Developer Comments'
,p_list_item_link_target=>'f?p=&APP_ID.:606:&SESSION.::&DEBUG.::::'
,p_list_item_current_for_pages=>'f?p=&APP_ID.:606:&SESSION.::&DEBUG.::::'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(784788561594894145)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Developer Comments Calendar'
,p_list_item_link_target=>'f?p=&APP_ID.:594:&SESSION.::&DEBUG.::::'
,p_list_item_current_for_pages=>'f?p=&APP_ID.:594:&SESSION.::&DEBUG.::::'
);
end;
/
prompt --application/shared_components/navigation/lists/developer_comments_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(786331487669013778)
,p_name=>'developer.comments.tasks'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474704
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(786331600475013783)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Delete Comments'
,p_list_item_link_target=>'f?p=&APP_ID.:1237:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/app_builder_homepage_image_nav
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(787106333147859999)
,p_name=>'App Builder Homepage - Image Nav'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474704
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(787106515252860000)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Create'
,p_list_item_link_target=>'f?p=&APP_ID.:56:&SESSION.::&DEBUG.:56,103,104,106,130,131,35,227,3020,3000,3001:::'
,p_list_item_icon=>'app-builder-create-app'
,p_security_scheme=>wwv_flow_imp.id(12472323342703137)
,p_list_item_current_type=>'NEVER'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(787106820469860001)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Import'
,p_list_item_link_target=>'f?p=&APP_ID.:460:&SESSION.::&DEBUG.:460:P460_FILE_TYPE:FLOW_EXPORT:'
,p_list_item_icon=>'app-builder-import-app'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(787107719682860001)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Dashboard'
,p_list_item_link_target=>'f?p=&APP_ID.:160:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'admin-dashboards'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(787107428027860001)
,p_list_item_display_sequence=>50
,p_list_item_link_text=>'Workspace Utilities'
,p_list_item_link_target=>'f?p=&APP_ID.:182:&SESSION.::&DEBUG.::::'
,p_list_item_icon=>'apex-utilities'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
);
end;
/
prompt --application/shared_components/navigation/lists/delete_theme
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(1029750209782685847)
,p_name=>'delete.theme'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474705
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1029750412409686103)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Delete Theme'
,p_list_item_link_target=>'f?p=&APP_ID.:221:&SESSION.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1029750729764686109)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Confirm'
,p_list_item_link_target=>'f?p=&APP_ID.:229:&SESSION.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/new_comments
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(1284942185735713564)
,p_name=>'new comments'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474705
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1284942644091713566)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'View Comments'
,p_list_item_link_target=>'f?p=&APP_ID.:1235:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1235'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1284942921905713567)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Edit Comment'
,p_list_item_link_target=>'f?p=&APP_ID.:1236:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_list_item_disp_condition=>'1236'
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1236'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1284943266884713568)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Delete Comments'
,p_list_item_link_target=>'f?p=&APP_ID.:1237:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'EXISTS'
,p_list_item_disp_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from WWV_FLOW_APP_COMMENTS',
'where flow_id = :fb_flow_id',
'and security_group_id = :flow_security_group_id'))
,p_security_scheme=>wwv_flow_imp.id(12511519296310366)
,p_list_item_current_type=>'COLON_DELIMITED_PAGE_LIST'
,p_list_item_current_for_pages=>'1237,1238'
);
end;
/
prompt --application/shared_components/navigation/lists/plugin_create
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(1434105688733324411)
,p_name=>'plugin.create'
,p_list_status=>'PUBLIC'
,p_version_scn=>72474705
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1434105853379324421)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Method'
,p_list_item_link_target=>'f?p=&APP_ID.:4402:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1435745785714405537)
,p_list_item_display_sequence=>15
,p_list_item_link_text=>'Copy From'
,p_list_item_link_target=>'f?p=&APP_ID.:4404:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_list_item_disp_condition=>'P4402_ACTION'
,p_list_item_disp_condition2=>'COPY'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2236216184454914)
,p_list_item_display_sequence=>20
,p_list_item_link_text=>'Identify Theme'
,p_list_item_link_target=>'f?p=&APP_ID.:4405:&SESSION.::&DEBUG.::::'
,p_list_item_disp_cond_type=>'ITEM_IS_NOT_NULL'
,p_list_item_disp_condition=>'P4402_FOR_THEME'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1434106176547324425)
,p_list_item_display_sequence=>30
,p_list_item_link_text=>'Copy'
,p_list_item_link_target=>'f?p=&APP_ID.:4406:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(2485785555677901)
,p_list_item_display_sequence=>40
,p_list_item_link_text=>'Name'
,p_list_item_link_target=>'f?p=&APP_ID.:4403:&SESSION.::&DEBUG.::::'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/lists/template_utilization_tasks
begin
wwv_flow_imp_shared.create_list(
 p_id=>wwv_flow_imp.id(1598999842830947024)
,p_name=>'Template Utilization Tasks '
,p_list_status=>'PUBLIC'
,p_version_scn=>72474705
);
wwv_flow_imp_shared.create_list_item(
 p_id=>wwv_flow_imp.id(1599000030969947024)
,p_list_item_display_sequence=>10
,p_list_item_link_text=>'Remove Unused Templates'
,p_list_item_link_target=>'f?p=&APP_ID.:46:&SESSION.:'
,p_list_item_current_type=>'TARGET_PAGE'
);
end;
/
prompt --application/shared_components/navigation/listentry
begin
null;
end;
/
prompt --application/plugin_settings
begin
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(233833500443227)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_STAR_RATING'
,p_attribute_01=>'fa-star'
,p_attribute_04=>'#VALUE#'
,p_version_scn=>37165931336884
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(733704426762309)
,p_plugin_type=>'DYNAMIC ACTION'
,p_plugin=>'NATIVE_OPEN_AI_ASSISTANT'
,p_version_scn=>16255110
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(733774098438911)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SELECT_MANY'
,p_attribute_01=>'separated'
,p_version_scn=>229010237
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(2661913239125759)
,p_plugin_type=>'PROCESS TYPE'
,p_plugin=>'NATIVE_GEOCODING'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_version_scn=>117638154
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(14848431076940926)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_YES_NO'
,p_attribute_01=>'Y'
,p_attribute_03=>'N'
,p_attribute_05=>'SWITCH_CB'
,p_version_scn=>37165931336884
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(99821115378888928)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_GEOCODED_ADDRESS'
,p_attribute_01=>'RELAX_HOUSE_NUMBER'
,p_attribute_02=>'N'
,p_attribute_03=>'POPUP:ITEM'
,p_attribute_04=>'default'
,p_attribute_06=>'LIST'
,p_version_scn=>37165931336884
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(118450898459833014)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_MAP_REGION'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'use_vector_tile_layers', 'Y')).to_clob
,p_version_scn=>1088662545
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(123182470368478450)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_DATE_PICKER_APEX'
,p_attribute_01=>'MONTH-PICKER:YEAR-PICKER'
,p_attribute_02=>'VISIBLE'
,p_attribute_03=>'15'
,p_attribute_04=>'FOCUS'
,p_version_scn=>37165931336884
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(124362195026989292)
,p_plugin_type=>'WEB SOURCE TYPE'
,p_plugin=>'NATIVE_ADFBC'
,p_version_scn=>37165931336888
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(174677809582024970)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.APEX.SPLITTER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'Y')).to_clob
,p_version_scn=>1088662545
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(176117893097506806)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_SINGLE_CHECKBOX'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_version_scn=>37165931336884
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(1765072046903712054)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'include_slider', 'N')).to_clob
,p_version_scn=>1088662545
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(1831722437189993876)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'NATIVE_IR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'actions_menu_structure', 'IG')).to_clob
,p_version_scn=>1088662545
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(1917679704307940123)
,p_plugin_type=>'ITEM TYPE'
,p_plugin=>'NATIVE_COLOR_PICKER'
,p_attribute_01=>'FULL'
,p_attribute_02=>'POPUP'
,p_version_scn=>37165931336884
);
wwv_flow_imp_shared.create_plugin_setting(
 p_id=>wwv_flow_imp.id(2010954470365119059)
,p_plugin_type=>'REGION TYPE'
,p_plugin=>'PLUGIN_COM.ORACLE.FLOTLINECHART2'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', '3',
  'attribute_02', '1.333')).to_clob
,p_version_scn=>1088662545
);
end;
/
prompt --application/shared_components/security/authorizations/user_may_edit_current_application
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(317822338466)
,p_name=>'User May Edit Current Application'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_security.user_is_internal then',
'   return true;',
'elsif wwv_flow_security.user_can_develop_flow(p_flow_id=>:FB_FLOW_ID) then',
'   return true;',
'else',
'   return false;',
'end if;'))
,p_error_message=>'The user &USER. does not have the privilege to edit the application in question.'
,p_reference_id=>786944233424207200
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/flow_data_generator
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(1753774729792863)
,p_name=>'Flow: DATA_GENERATOR'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'DATA_GENERATOR'
,p_error_message=>'You are not authorized to use Data Generator in SQL Workshop'
,p_reference_id=>2200672316280271
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/extension_links_exist
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(3000262679771390)
,p_name=>'Extension Links Exist'
,p_scheme_type=>'NATIVE_EXISTS'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_extension_links',
' where security_group_id = :workspace_id',
'union all',
'select 1',
'  from wwv_extension_links el, wwv_extension_grants eg',
' where eg.security_group_id           = :workspace_id',
'   and eg.extension_security_group_id = el.security_group_id',
'   and el.is_public = ''Y'''))
,p_reference_id=>2801004939760399
,p_version_scn=>41671338
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/security/authorizations/dashboard_access
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(10593027526205581)
,p_name=>'Dashboard access'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return',
'    wwv_flow_authorization.is_authorized_developer(',
'        p_developer_authorization => ''ADMIN''',
'    )',
'    or wwv_flow_authorization.is_authorized_developer(',
'        p_developer_authorization => ''EDIT''',
'    );'))
,p_error_message=>'You are not authorized to access Dashboards and Monitor Activity.'
,p_reference_id=>786936829326142579
,p_caching=>'BY_USER_BY_SESSION'
,p_comments=>'Used to control access to Dashboards and Monitor Activity under Administration. Developers will have access when Builder is enabled, while Admins will always have access. Prompted by Bug 13859631.'
);
end;
/
prompt --application/shared_components/security/authorizations/sql_developer_web_enabled
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(11401665712577717)
,p_name=>'SQL Developer Web enabled'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    return wwv_flow_listener.sql_developer_web_enabled;',
'end;'))
,p_error_message=>'SQL Developer Web link is not enabled for this instance.'
,p_reference_id=>11401467991562895
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/flow_create
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(12472323342703137)
,p_name=>'Flow: CREATE'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'CREATE'
,p_error_message=>'You are not allowed to create or delete applications'
,p_reference_id=>786942708067207200
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/flow_edit
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(12510423405283164)
,p_name=>'Flow: EDIT'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'EDIT'
,p_error_message=>'You are not authorized to edit applications'
,p_reference_id=>12480509677812756
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/flow_admin
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(12511519296310366)
,p_name=>'Flow: ADMIN'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'ADMIN'
,p_error_message=>'You are not authorized to administer applications'
,p_reference_id=>12511219858301010
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/developer_may_edit_page
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(34674432490821717)
,p_name=>'Developer may edit page'
,p_scheme_type=>'NATIVE_EXISTS'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_steps s',
' where flow_id = to_number(:FB_FLOW_ID)',
'   and id      = to_number(:FB_FLOW_PAGE_ID)',
'   and security_group_id = to_number(:WORKSPACE_ID)',
'   and not exists (',
'         select 1',
'           from wwv_flow_lock_page l',
'          where l.flow_id    = s.flow_id',
'            and l.object_id  = s.id',
'            and l.locked_by != :APP_USER )'))
,p_error_message=>'Page may not be edited by developer'
,p_reference_id=>786942462038207200
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/security/authorizations/user_auth_to_access_schema
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(74725624313588476)
,p_name=>'User_auth_to_access_schema'
,p_scheme_type=>'NATIVE_EXISTS'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from   wwv_flow_company_schemas c,',
'       wwv_flow_fnd_user u',
'where  c.security_group_id = :flow_security_group_id and',
'       u.security_group_id = :flow_security_group_id and',
'       u.user_name = :flow_user and',
'       (u.ALLOW_ACCESS_TO_SCHEMAS is null or',
'        instr('':''||u.ALLOW_ACCESS_TO_SCHEMAS||'':'','':''||c.schema||'':'')>0) and',
'        c.schema = :P391_SCHEMA'))
,p_error_message=>'You do not have access to the selected schema.'
,p_reference_id=>786944588379207201
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/security/authorizations/user_has_edit_priv
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(74845831538733642)
,p_name=>'USER_HAS_EDIT_PRIV'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>'return wwv_flow_security.user_can_develop_any_flow;'
,p_error_message=>'You have no privilege to edit applications.'
,p_reference_id=>786943988629207200
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/is_real_application_security_enabled
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(125788121598195155)
,p_name=>'Is Real Application Security enabled'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>'return wwv_flow_platform.get_preference(''ALLOW_RAS'')=''Y'';'
,p_error_message=>'Real Application Security is not enabled'
,p_reference_id=>786943379004207200
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/apex_5_0_app_builder_enabled
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(178938910382761975)
,p_name=>'APEX 5.0 App Builder Enabled'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'EDIT'
,p_error_message=>'No privilege for attempted operation'
,p_reference_id=>786516029127697713
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/apex_5_0_sql_workshop_enabled
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(178939331963761975)
,p_name=>'APEX 5.0 SQL Workshop Enabled'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'SQL'
,p_error_message=>'You are not authorized to use SQL Workshop'
,p_reference_id=>786516265251697717
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/apex_5_0_team_development_enabled
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(178939812163761988)
,p_name=>'APEX 5.0 Team development enabled'
,p_scheme_type=>'NATIVE_EXISTS'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from wwv_flow_companies w, ',
'        wwv_flow_fnd_user u',
'where nvl(w.ALLOW_TEAM_DEVELOPMENT_YN,''Y'') = ''Y'' and ',
'      w.PROVISIONING_COMPANY_ID = :flow_security_group_id and',
'      u.security_group_id = :flow_security_group_id and',
'      u.USER_NAME = upper(:app_user) and',
'      nvl(u.ALLOW_TEAM_DEVELOPMENT_YN,''Y'') = ''Y'''))
,p_error_message=>'Team development not enabled for this workspace'
,p_reference_id=>786516861027697723
,p_caching=>'BY_USER_BY_PAGE_VIEW'
);
end;
/
prompt --application/shared_components/security/authorizations/sso_authentication
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(331660423436603298)
,p_name=>'SSO authentication'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>'return wwv_flow_authentication_dev.get_internal_authentication not in (''APEX'',''CLOUD_IDM'',''LDAP'',''DB'');'
,p_error_message=>'Builder SSO is not enabled'
,p_reference_id=>6738410669854771
,p_caching=>'BY_USER_BY_SESSION'
,p_comments=>wwv_flow_string.join(wwv_flow_t_varchar2(
'This authorization scheme checks whether the builder authentication can be used for single sign-on to workspaces. This includes SSO, header-based and LDAP authentication, but not',
'',
'  - APEX: login requires a workspace name',
'  - CLOUD_IDM: external login to IDM, but switching workspaces is not allowed, since the login is for a single tenant only'))
);
end;
/
prompt --application/shared_components/security/authorizations/attribute_dictionary_columns_defined
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(499915500493760557)
,p_name=>'Attribute Dictionary Columns Defined'
,p_scheme_type=>'NATIVE_EXISTS'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_hnt_column_dict',
' where security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_error_message=>'There are no attributes define in the Attribute Dictionary.'
,p_reference_id=>786942219366207200
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/team_dev_file_enabled
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(692489888034486589)
,p_name=>'Team Dev File Enabled'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_team_file.team_dev_file_enabled then',
'   return true;',
'else',
'   return false;',
'end if;'))
,p_error_message=>'Access to this page requires team development files to be enabled.'
,p_reference_id=>786943600005207200
,p_caching=>'NOCACHE'
);
end;
/
prompt --application/shared_components/security/authorizations/flow_restful
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(802892920094782611)
,p_name=>'Flow: RESTFUL'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_attribute_01=>'RESTFUL'
,p_error_message=>'No privilege for attempted operation'
,p_reference_id=>786519856057734816
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/security/authorizations/developer_may_edit_supporting_object_script
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(857903402130335025)
,p_name=>'Developer may edit supporting object script'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_lock.user_can_edit_script (',
'    p_flow_id   => :FB_FLOW_ID,',
'    p_script_id => :P865_SCRIPT_ID,',
'    p_override  => :P865_MODE = ''NEW'' -- allow viewing if create',
'    );'))
,p_error_message=>'Script may not be edited by the developer.'
,p_version_scn=>72474887
,p_caching=>'NOCACHE'
);
end;
/
prompt --application/shared_components/security/authorizations/service_requests_enabled
begin
wwv_flow_imp_shared.create_security_scheme(
 p_id=>wwv_flow_imp.id(917540220622028585)
,p_name=>'Service Requests Enabled'
,p_scheme_type=>'NATIVE_FUNCTION_BODY'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_platform.get_preference(''SERVICE_REQUESTS_ENABLED'') = ''Y'' then',
'    return TRUE;',
'else',
'    return FALSE;',
'end if;'))
,p_error_message=>'No privilege for attempted operation.'
,p_reference_id=>786932326296107981
,p_caching=>'BY_USER_BY_SESSION'
);
end;
/
prompt --application/shared_components/navigation/navigation_bar
begin
wwv_flow_imp_shared.create_icon_bar_item(
 p_id=>wwv_flow_imp.id(1361802214166928)
,p_icon_sequence=>10
,p_icon_subtext=>'Workspace &COMPANY.'
,p_icon_target=>'#'
,p_icon_image_alt=>'Workspace &COMPANY.'
,p_nav_entry_is_feedback_yn=>'N'
,p_begins_on_new_line=>'NO'
,p_cell_colspan=>1
);
wwv_flow_imp_shared.create_icon_bar_item(
 p_id=>wwv_flow_imp.id(331551200056558688)
,p_icon_sequence=>40
,p_icon_subtext=>'( <span style="text-decoration:underline;">Switch Workspace</span> )'
,p_icon_target=>'f?p=4550:20'
,p_icon_image_alt=>'Switch Workspace'
,p_nav_entry_is_feedback_yn=>'N'
,p_begins_on_new_line=>'NO'
,p_cell_colspan=>1
,p_security_scheme=>wwv_flow_imp.id(331660423436603298)
);
wwv_flow_imp_shared.create_icon_bar_item(
 p_id=>wwv_flow_imp.id(39804528545736393)
,p_icon_sequence=>50
,p_icon_subtext=>'( <span style="text-decoration:underline;">Logout</span> )'
,p_icon_target=>'&LOGOUT_URL.'
,p_icon_image_alt=>'Logout'
,p_nav_entry_is_feedback_yn=>'N'
,p_begins_on_new_line=>'NO'
,p_cell_colspan=>1
);
end;
/
prompt --application/shared_components/logic/application_processes/set_breadcrumb_app_icon
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(1713266918386916)
,p_process_sequence=>1
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set_breadcrumb_app_icon'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_4000_ui.set_breadcrumb_app_icon (',
'    p_application_id => :FB_FLOW_ID );'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'1500'
,p_process_when_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_security_scheme=>wwv_flow_imp.id(12510423405283164)
,p_version_scn=>39852375
);
end;
/
prompt --application/shared_components/logic/application_processes/returnnothing
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(26098116757095708)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'returnNothing'
,p_process_sql_clob=>'null;'
,p_process_clob_language=>'PLSQL'
,p_security_scheme=>wwv_flow_imp.id(12510423405283164)
,p_process_comment=>'this is useful for setting item values where no return value is needed.'
,p_version_scn=>37165770887417
);
end;
/
prompt --application/shared_components/logic/application_processes/p872_add_parameter
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(33555511200784610)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'P872_ADD_PARAMETER'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.update_members(',
'  p_collection_name => wwv_flow.g_x01,',
'  p_seq => wwv_flow.g_f01,',
'  p_c001 => wwv_flow.g_f02,',
'  p_c002 => wwv_flow.g_f03,',
'  p_c003 => wwv_flow.g_f04,',
'  p_c004 => wwv_flow.g_f05,',
'  p_c005 => wwv_flow.g_f06 );',
'wwv_flow_collection.add_member(p_collection_name =>wwv_flow.g_x01, p_c004 =>''N'');'))
,p_process_clob_language=>'PLSQL'
,p_security_scheme=>wwv_flow_imp.id(12510423405283164)
,p_version_scn=>37165770887417
);
end;
/
prompt --application/shared_components/logic/application_processes/p875_test_rest
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(33809312666721107)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'P875_TEST_REST'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_f4000_util.test_legacy_rest_service (',
'    p_url             => wwv_flow.g_x01,',
'    p_proxy_override  => wwv_flow.g_x02,',
'    p_method          => wwv_flow.g_x03,',
'    p_username        => wwv_flow.g_x04,',
'    p_password        => wwv_flow.g_x05,',
'    p_body            => wwv_flow.g_x06,',
'    p_parm_name       => wwv_flow.g_f01,',
'    p_parm_value      => wwv_flow.g_f02,',
'    p_http_headers    => wwv_flow.g_f03,',
'    p_http_hdr_values => wwv_flow.g_f04 );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'#SQLERRM#'
,p_security_scheme=>wwv_flow_imp.id(12510423405283164)
,p_version_scn=>37165770887417
);
end;
/
prompt --application/shared_components/logic/application_processes/p872_remove_parameter
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(33980127084358949)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'P872_REMOVE_PARAMETER'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.update_members(',
'  p_collection_name => wwv_flow.g_x01,',
'  p_seq => wwv_flow.g_f01,',
'  p_c001 => wwv_flow.g_f02,',
'  p_c002 => wwv_flow.g_f03,',
'  p_c003 => wwv_flow.g_f04,',
'  p_c004 => wwv_flow.g_f05,',
'  p_c005 => wwv_flow.g_f06 );',
'if nvl(wwv_flow.g_x03,''x'') != ''update'' then',
'  wwv_flow_collection.delete_member(wwv_flow.g_x01,wwv_flow.g_x02);',
'  wwv_flow_collection.resequence_collection(wwv_flow.g_x01);',
'else',
'  for c1 in (select c003',
'               from wwv_flow_collections',
'              where collection_name = wwv_flow.g_x01',
'                and seq_id = wwv_flow.g_x02 ) loop',
'    wwv_flow_collection.update_member(',
'      p_collection_name => wwv_flow.g_x01, ',
'      p_seq             => wwv_flow.g_x02,',
'      p_c001            => ''marked for delete'',',
'      p_c003            => c1.c003,',
'      p_c004            => ''D'' );',
'  end loop;',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_security_scheme=>wwv_flow_imp.id(12510423405283164)
,p_version_scn=>37165770887417
);
end;
/
prompt --application/shared_components/logic/application_processes/ajax_collect_clob
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(49827831510641638)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'AJAX_COLLECT_CLOB'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_code clob := empty_clob;',
'begin',
'   sys.dbms_lob.createtemporary( l_code, false, sys.dbms_lob.SESSION );',
'   for i in 1..wwv_flow.g_f01.count loop',
'        sys.dbms_lob.writeappend(l_code,length(wwv_flow.g_f01(i)),wwv_flow.g_f01(i));',
'    end loop;',
'wwv_flow_collection.create_or_truncate_collection(p_collection_name=>''CLOB_CONTENT'');',
'wwv_flow_collection.add_member(p_collection_name=>''CLOB_CONTENT'',p_clob001=>l_code);',
'sys.htp.prn(''SUCCESS'');',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_security_scheme=>wwv_flow_imp.id(12510423405283164)
,p_version_scn=>37165770887417
);
end;
/
prompt --application/shared_components/logic/application_processes/parse_report_query
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(59589024396402332)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'PARSE_REPORT_QUERY'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_owner varchar2(4000)  := null;',
'  l_query varchar2(32767) := null;',
'  l_error varchar2(32767) := null;',
'begin',
'',
'  l_owner := wwv_flow_security.flow_owner ( ',
'     p_flow_id           =>:FB_FLOW_ID, ',
'     p_security_group_id =>:FLOW_SECURITY_GROUP_ID',
'  );',
'',
'  for c1 in (',
'    select clob001 ',
'    from wwv_flow_collections ',
'    where collection_name = ''REPORT_QUERY_TEMP''',
'  ) loop',
'    l_query := c1.clob001;',
'    l_error := wwv_flow_f4000_util.is_valid_report_query (',
'      p_plug_source      => l_query,',
'      p_plug_source_type => wwv_flow_region_native.c_sql_report,',
'      p_owner            => l_owner',
'    );',
'  end loop;',
'         ',
'  if l_error is null then',
'    sys.htp.p(''1''||wwv_flow_lang.system_message(''REPORT_QUERIES.VALID_QUERY''));',
'  else',
'    sys.htp.p(''0''||wwv_flow_utilities.striphtml(l_error));',
'  end if;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_security_scheme=>wwv_flow_imp.id(12510423405283164)
,p_version_scn=>37165770887417
);
end;
/
prompt --application/shared_components/logic/application_processes/spotlightindex
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(233703836072822139)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'spotlightIndex'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_spotlight_dev.emit_spotlight_search_index(',
'    p_app_id          => wwv_flow.g_x01,',
'    p_advanced_search => wwv_flow.g_x02);'))
,p_process_clob_language=>'PLSQL'
,p_security_scheme=>'MUST_NOT_BE_PUBLIC_USER'
,p_version_scn=>36492158
);
end;
/
prompt --application/shared_components/logic/application_processes/developertoolbar
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(241203394876147425)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'developerToolbar'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_developer_toolbar.ajax;',
'    commit;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_security_scheme=>'MUST_NOT_BE_PUBLIC_USER'
,p_version_scn=>37165770887417
);
end;
/
prompt --application/shared_components/logic/application_processes/get_plugin_sql_examples
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(468201615965604310)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'get_plugin_sql_examples'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    sys.htp.p (',
'        wwv_flow_plugin_dev.get_sql_examples (',
'            p_application_id => :FB_FLOW_ID,',
'            p_plugin_type    => wwv_flow.g_x01,',
'            p_plugin_name    => wwv_flow.g_x02 ) );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_security_scheme=>wwv_flow_imp.id(12510423405283164)
,p_version_scn=>37165770887417
);
end;
/
prompt --application/shared_components/logic/application_processes/theme_roller
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(1199152637279464946)
,p_process_sequence=>1
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'theme_roller'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_theme_dev.theme_roller_ajax;',
'    commit;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_security_scheme=>wwv_flow_imp.id(12510423405283164)
,p_version_scn=>37165770887417
);
end;
/
prompt --application/shared_components/logic/application_processes/set_flow_page
begin
wwv_flow_imp_shared.create_flow_process(
 p_id=>wwv_flow_imp.id(72694123644888753)
,p_process_sequence=>1
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set flow page'
,p_process_sql_clob=>'wwv_flow_f4000_util.set_flow_page;'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error'
,p_process_when=>'1000,460,514,516,527,273,2100,2101,2102,2103,2105,2106,2107,2108,2109,2111,2115,1500,163,56,176,189,433,447,448,451,454,458,494,495,496,3001,3002,3005,3020,49,57,8000,8101'
,p_process_when_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_security_scheme=>wwv_flow_imp.id(12510423405283164)
,p_process_comment=>'Used to set env when two browsers are working on different apps in the same session.  Prevents a wizard from creating a component in the wrong application.'
,p_version_scn=>37165965956193
);
end;
/
prompt --application/shared_components/logic/application_items/ajax_temporary_item
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(6191718445268266)
,p_name=>'AJAX_TEMPORARY_ITEM'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/breadcrumb_app_icon
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(1705853857866357)
,p_name=>'BREADCRUMB_APP_ICON'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
,p_version_scn=>40148348
);
end;
/
prompt --application/shared_components/logic/application_items/cascading_selectlist_item_1
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(187760430466726137)
,p_name=>'CASCADING_SELECTLIST_ITEM_1'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/company
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(323366420862)
,p_name=>'COMPANY'
,p_scope=>'GLOBAL'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_item_comment=>'Prints workspace name referenced in page templates'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/diff_job_status
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(4457717002757645)
,p_name=>'DIFF_JOB_STATUS'
,p_protection_level=>'I'
,p_item_comment=>'For the working copy implementation'
,p_version_scn=>59424758
);
end;
/
prompt --application/shared_components/logic/application_items/f4000_check
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(137222915098326064)
,p_name=>'F4000_CHECK'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
,p_item_comment=>'Used to display system message "Check".'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/f4000_copy_to_theme
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2461529447025552654)
,p_name=>'F4000_COPY_TO_THEME'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/f4000_cur_std_tab
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(49554522682292670)
,p_name=>'F4000_CUR_STD_TAB'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/f4000_find_label
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2573484773802618001)
,p_name=>'F4000_FIND_LABEL'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/f4000_flow_page
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(83011119332503449)
,p_name=>'F4000_FLOW_PAGE'
,p_data_type=>'NUMBER'
,p_protection_level=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/f4000_flow_session
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(82990619769389485)
,p_name=>'F4000_FLOW_SESSION'
,p_data_type=>'NUMBER'
,p_protection_level=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/f4000_last_portal_view
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(201664305800188161)
,p_name=>'F4000_LAST_PORTAL_VIEW'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/f4000_last_view
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(46180307972)
,p_name=>'F4000_LAST_VIEW'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/f4000_max_response_size_kb
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(7801097540991591)
,p_name=>'F4000_MAX_RESPONSE_SIZE_KB'
,p_protection_level=>'I'
,p_version_scn=>14277461
);
end;
/
prompt --application/shared_components/logic/application_items/f4000_p35_demo_flows
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(174779207867417973)
,p_name=>'F4000_P35_DEMO_FLOWS'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
,p_item_comment=>'an item used for demostrations'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/f4000_print_server_type
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(1836995355899918)
,p_name=>'F4000_PRINT_SERVER_TYPE'
,p_protection_level=>'I'
,p_version_scn=>15599929
);
end;
/
prompt --application/shared_components/logic/application_items/f4000_region_selected
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(60363923165055254)
,p_name=>'F4000_REGION_SELECTED'
,p_escape_on_http_output=>'N'
,p_item_comment=>'Used to dynamically compute button postions for that region'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/f4000_run
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(137215819075289336)
,p_name=>'F4000_RUN'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
,p_item_comment=>'Item used to display system message "Run".'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/f4000_run_edit_page
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(148405327096585472)
,p_name=>'F4000_RUN_EDIT_PAGE'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/fb_flow_id
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(40006855470898)
,p_name=>'FB_FLOW_ID'
,p_data_type=>'NUMBER'
,p_escape_on_http_output=>'N'
,p_item_comment=>'Identifies the flow.'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/fb_flow_name
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(40006856470899)
,p_name=>'FB_FLOW_NAME'
,p_escape_on_http_output=>'N'
,p_item_comment=>'Y'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/fb_flow_page_id
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(40006857470899)
,p_name=>'FB_FLOW_PAGE_ID'
,p_data_type=>'NUMBER'
,p_escape_on_http_output=>'N'
,p_item_comment=>'Identifies the flow page.'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/fb_theme_id
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(146658914296443870)
,p_name=>'FB_THEME_ID'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/fp_max_rows_per_page
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(76847111472614227)
,p_name=>'FP_MAX_ROWS_PER_PAGE'
,p_escape_on_http_output=>'N'
,p_item_comment=>'obsolete this item when you get a chance'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/fp_pref_show_information
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(76852381884625214)
,p_name=>'FP_PREF_SHOW_INFORMATION'
,p_escape_on_http_output=>'N'
,p_item_comment=>'obosolete this item when you get a chance'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/fsp_after_login_url
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(61573406162429920)
,p_name=>'FSP_AFTER_LOGIN_URL'
,p_escape_on_http_output=>'N'
,p_item_comment=>'Used by Custom2 authentication for deep linking support'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/g_bc_parent_label
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(4102236188852409)
,p_name=>'G_BC_PARENT_LABEL'
,p_protection_level=>'I'
,p_item_comment=>'Used to dynamically set the parent entry label in complex breadcrumb setups.'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/g_bc_parent_url
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(15520576343950350)
,p_name=>'G_BC_PARENT_URL'
,p_protection_level=>'I'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/g_parse_as_schema_override
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(3692062815389)
,p_name=>'G_PARSE_AS_SCHEMA_OVERRIDE'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/last_step
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(22788166245)
,p_name=>'LAST_STEP'
,p_escape_on_http_output=>'N'
,p_item_comment=>'Y'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/main_app_id
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(2043059011162256)
,p_name=>'MAIN_APP_ID'
,p_protection_level=>'I'
,p_item_comment=>'This is the ID of your Main application used in conjunction with the Working Copy feature.'
,p_version_scn=>43425108
);
end;
/
prompt --application/shared_components/logic/application_items/monitor_user
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(453606206)
,p_name=>'MONITOR_USER'
,p_escape_on_http_output=>'N'
,p_item_comment=>'Used by monitoring Utility'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/recent_pages
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(163678415474826275)
,p_name=>'RECENT_PAGES'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/theme_id
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(12973032052396511)
,p_name=>'THEME_ID'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/theme_next_page
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(52224418686048921)
,p_name=>'THEME_NEXT_PAGE'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/ui_schema
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(60734732002851561)
,p_name=>'UI_SCHEMA'
,p_protection_level=>'I'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/ui_table
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(60735102005852345)
,p_name=>'UI_TABLE'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/ui_table_id
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(114948426092978491)
,p_name=>'UI_TABLE_ID'
,p_protection_level=>'N'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/wizard_entry_page
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(106733613326936844)
,p_name=>'WIZARD_ENTRY_PAGE'
,p_escape_on_http_output=>'N'
,p_version_scn=>37165770887405
);
end;
/
prompt --application/shared_components/logic/application_items/working_copy_name
begin
wwv_flow_imp_shared.create_flow_item(
 p_id=>wwv_flow_imp.id(224842501471598503)
,p_name=>'WORKING_COPY_NAME'
,p_protection_level=>'I'
,p_item_comment=>'This is the name of your working copy'
,p_version_scn=>37165963367965
);
end;
/
prompt --application/shared_components/logic/application_computations/company
begin
wwv_flow_imp_shared.create_flow_computation(
 p_id=>wwv_flow_imp.id(323368422455)
,p_computation_sequence=>10
,p_computation_item=>'COMPANY'
,p_computation_point=>'AFTER_LOGIN'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>'wwv_flow.get_company_name;'
,p_compute_when=>'COMPANY'
,p_compute_when_type=>'ITEM_IS_NULL'
,p_computation_error_message=>'Unable to compute workspace name.'
,p_version_scn=>37165770887460
);
end;
/
prompt --application/shared_components/logic/application_computations/main_app_id
begin
wwv_flow_imp_shared.create_flow_computation(
 p_id=>wwv_flow_imp.id(2043248870200812)
,p_computation_sequence=>10
,p_computation_item=>'MAIN_APP_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select import_orig_app_id',
'  from wwv_flows',
' where id = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':APP_PAGE_ID = 1 or',
'( :APP_PAGE_ID = 4500 and',
'   wwv_flow_working_copy_dev.is_working_copy(',
'       p_application_id    => :FB_FLOW_ID,',
'       p_security_group_id => :WORKSPACE_ID ) )'))
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
,p_version_scn=>62232370
);
end;
/
prompt --application/shared_components/logic/application_computations/working_copy_name
begin
wwv_flow_imp_shared.create_flow_computation(
 p_id=>wwv_flow_imp.id(224843069724611106)
,p_computation_sequence=>10
,p_computation_item=>'WORKING_COPY_NAME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_working_copy_dev.get_working_copy_name( ',
'    p_application_id    => :FB_FLOW_ID,',
'    p_security_group_id => :WORKSPACE_ID )'))
,p_compute_when=>'1,4500'
,p_compute_when_type=>'CURRENT_PAGE_IN_CONDITION'
,p_version_scn=>59141782
);
end;
/
prompt --application/shared_components/logic/application_computations/fb_flow_id
begin
wwv_flow_imp_shared.create_flow_computation(
 p_id=>wwv_flow_imp.id(40006858470900)
,p_computation_sequence=>1
,p_computation_item=>'FB_FLOW_ID'
,p_computation_point=>'ON_NEW_INSTANCE'
,p_computation_type=>'SET_ITEM_EQUAL_THIS_PREFERENCE'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>'FB_FLOW_ID'
,p_compute_when_type=>'NEVER'
,p_computation_error_message=>'Unable to get preference for Application.'
,p_version_scn=>37165770887460
);
end;
/
prompt --application/shared_components/logic/application_computations/fb_flow_page_id
begin
wwv_flow_imp_shared.create_flow_computation(
 p_id=>wwv_flow_imp.id(40006860470902)
,p_computation_sequence=>2
,p_computation_item=>'FB_FLOW_PAGE_ID'
,p_computation_point=>'ON_NEW_INSTANCE'
,p_computation_type=>'SET_ITEM_EQUAL_THIS_PREFERENCE'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>'FB_FLOW_PAGE_ID'
,p_compute_when=>'FB_FLOW_PAGE_ID'
,p_compute_when_type=>'ITEM_IS_NULL'
,p_computation_error_message=>'Unable to get preference for app builder page ID.'
,p_version_scn=>37165770887460
);
end;
/
prompt --application/shared_components/logic/application_computations/fb_flow_name
begin
wwv_flow_imp_shared.create_flow_computation(
 p_id=>wwv_flow_imp.id(40006859470901)
,p_computation_sequence=>3
,p_computation_item=>'FB_FLOW_NAME'
,p_computation_point=>'ON_NEW_INSTANCE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation_processed=>'ON_NEW_INSTANCE'
,p_computation=>'wwv_flow_escape.html(v(''FB_FLOW_NAME''))'
,p_computation_error_message=>'Unable to determine application name.'
,p_version_scn=>37165770887460
);
end;
/
prompt --application/shared_components/logic/application_computations/f4000_max_response_size_kb
begin
wwv_flow_imp_shared.create_flow_computation(
 p_id=>wwv_flow_imp.id(7801552706025785)
,p_computation_sequence=>10
,p_computation_item=>'F4000_MAX_RESPONSE_SIZE_KB'
,p_computation_point=>'ON_NEW_INSTANCE'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>'700'
,p_version_scn=>14277474
);
end;
/
prompt --application/shared_components/logic/application_computations/f4000_run
begin
wwv_flow_imp_shared.create_flow_computation(
 p_id=>wwv_flow_imp.id(137218026825301058)
,p_computation_sequence=>10
,p_computation_item=>'F4000_RUN'
,p_computation_point=>'ON_NEW_INSTANCE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>'wwv_flow_lang.system_message(''DEMO_APPLICATION.RUN'')'
,p_version_scn=>37165770887460
);
end;
/
prompt --application/shared_components/logic/application_computations/f4000_check
begin
wwv_flow_imp_shared.create_flow_computation(
 p_id=>wwv_flow_imp.id(137224006571333058)
,p_computation_sequence=>10
,p_computation_item=>'F4000_CHECK'
,p_computation_point=>'ON_NEW_INSTANCE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation_processed=>'REPLACE_EXISTING'
,p_computation=>'wwv_flow_lang.system_message(''F4500_CHECK'')'
,p_version_scn=>37165770887460
);
end;
/
prompt --application/shared_components/logic/application_computations/f4000_last_portal_view
begin
wwv_flow_imp_shared.create_flow_computation(
 p_id=>wwv_flow_imp.id(201669928216192952)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_PORTAL_VIEW'
,p_computation_point=>'ON_NEW_INSTANCE'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_processed=>'ON_NEW_INSTANCE'
,p_computation=>'page_definition'
,p_version_scn=>37165770887460
);
end;
/
prompt --application/shared_components/logic/application_settings
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/standard
begin
null;
end;
/
prompt --application/shared_components/navigation/tabs/parent
begin
null;
end;
/
prompt --application/shared_components/user_interface/lovs/4500_ui_def_alignment_l_c_r
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(200094129140149873)
,p_lov_name=>'4500 UI DEF ALIGNMENT L.C.R'
,p_reference_id=>260501806598530292
,p_lov_query=>'.'||wwv_flow_imp.id(200094129140149873)||'.'
,p_location=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(441093505492065867)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Start'
,p_lov_return_value=>'L'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(441093315770065865)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Center'
,p_lov_return_value=>'C'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(441093715747065867)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'End'
,p_lov_return_value=>'R'
);
end;
/
prompt --application/shared_components/user_interface/lovs/4791_url_or_page
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(6718617245289867)
,p_lov_name=>'4791_URL_OR_PAGE'
,p_lov_query=>'.'||wwv_flow_imp.id(6718617245289867)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475094
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(6718912393289869)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Create new edit page'
,p_lov_return_value=>'NEW'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(6719410796297458)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Page in this application'
,p_lov_return_value=>'FLOW'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(6719129689289872)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'URL'
,p_lov_return_value=>'URL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(598109125486803480)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Exclude Link Target'
,p_lov_return_value=>'NONE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/9999_url_or_page
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(191802018719438597)
,p_lov_name=>'9999_URL_OR_PAGE'
,p_lov_query=>'.'||wwv_flow_imp.id(191802018719438597)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475094
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(191802221865438607)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Page in this Application'
,p_lov_return_value=>'FLOW'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(191802417355438613)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'URL'
,p_lov_return_value=>'URL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(191803319328457621)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Javascript'
,p_lov_return_value=>'JAVASCRIPT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/advanced_upgrade_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(499502202331793325)
,p_lov_name=>'ADVANCED_UPGRADE_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(499502202331793325)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475094
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(499504213089793331)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Upgrade Text Item to Number Field'
,p_lov_return_value=>'NUMBER_FIELD'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(499502630417793330)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Upgrade Date Picker to new Date Picker'
,p_lov_return_value=>'DATE_PICKER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(499504425018793331)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Change Required item attribute to Yes'
,p_lov_return_value=>'REQUIRED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/aggregate_by
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(167761011505168202)
,p_lov_name=>'AGGREGATE BY'
,p_lov_query=>'.'||wwv_flow_imp.id(167761011505168202)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475094
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(167761226870168212)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'SUM'
,p_lov_return_value=>'SUM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(167761407532168218)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'AVG'
,p_lov_return_value=>'AVG'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(167761632408168219)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'MIN'
,p_lov_return_value=>'MIN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(167761817557168219)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'MAX'
,p_lov_return_value=>'MAX'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(167776619311284077)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'COUNT'
,p_lov_return_value=>'COUNT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/aggregate_function
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(49455515219053317)
,p_lov_name=>'AGGREGATE_FUNCTION'
,p_lov_query=>'.'||wwv_flow_imp.id(49455515219053317)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475094
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(49455814570053330)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Sum'
,p_lov_return_value=>'SUM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(49456006581053331)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Average'
,p_lov_return_value=>'AVG'
);
end;
/
prompt --application/shared_components/user_interface/lovs/aggregate_functions
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(101016778607432389)
,p_lov_name=>'AGGREGATE_FUNCTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(101016778607432389)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475094
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(101017392766432406)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Count'
,p_lov_return_value=>'COUNT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(155331225296971782)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Count Distinct'
,p_lov_return_value=>'COUNT_DISTINCT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(155331592721974019)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Approx. Count Distinct'
,p_lov_return_value=>'APPROX_COUNT_DISTINCT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(155331898423975434)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Minimum'
,p_lov_return_value=>'MIN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(155332158908977182)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Maximum'
,p_lov_return_value=>'MAX'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(101017723584432406)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Sum'
,p_lov_return_value=>'SUM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(155335855601993887)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Average'
,p_lov_return_value=>'AVG'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(166230555723037356)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Median'
,p_lov_return_value=>'MEDIAN'
);
end;
/
prompt --application/shared_components/user_interface/lovs/alignment_l_c_r
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84702113000663314)
,p_lov_name=>'ALIGNMENT_L_C_R'
,p_lov_query=>'.'||wwv_flow_imp.id(84702113000663314)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475094
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84702319979663314)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'start'
,p_lov_return_value=>'LEFT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84702526646663315)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'center'
,p_lov_return_value=>'CENTER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84702722814663315)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'end'
,p_lov_return_value=>'RIGHT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/all_items_page_and_application
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(194317808992054940)
,p_lov_name=>'ALL ITEMS (PAGE AND APPLICATION)'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, name r',
'from wwv_flow_items',
'where security_group_id = :flow_security_group_id and',
'         flow_id = :fb_flow_id',
'union all',
'select name d, name r',
'from wwv_flow_step_items',
'where security_group_id = :flow_security_group_id and',
'         flow_id = :fb_flow_id'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475094
);
end;
/
prompt --application/shared_components/user_interface/lovs/allow_page_repost
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84920132510743677)
,p_lov_name=>'ALLOW PAGE REPOST'
,p_lov_query=>'.'||wwv_flow_imp.id(84920132510743677)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475094
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84920305972743677)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'No - Prevent page from being re-posted'
,p_lov_return_value=>'N'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84920515901743678)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Yes - Allow page to be re-posted'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/allowed_operations
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(86630311100418314)
,p_lov_name=>'ALLOWED OPERATIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(86630311100418314)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475094
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88151603016962504)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Insert'
,p_lov_return_value=>'I'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88151802892962505)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Update'
,p_lov_return_value=>'U'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(605643319539148456)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Delete'
,p_lov_return_value=>'D'
);
end;
/
prompt --application/shared_components/user_interface/lovs/apex_end_users
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1741323331892226882)
,p_lov_name=>'APEX END USERS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select user_name d, user_name r',
'from wwv_flow_fnd_user u',
'where security_group_id = :flow_security_group_id',
'and not exists (select null',
'                from wwv_flow_developers d',
'                where d.security_group_id = u.security_group_id',
'                and d.userid            = u.user_name',
'                and (instr(d.developer_role,''ADMIN'') > 0',
'                     or instr(d.developer_role,''EDIT'') > 0))',
'and nvl(u.account_locked,''N'') = ''N''',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475094
);
end;
/
prompt --application/shared_components/user_interface/lovs/apex_views_filter_conditions
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(200640422229340739)
,p_lov_name=>'APEX VIEWS FILTER CONDITIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(200640422229340739)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475094
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(200640620893340743)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'='
,p_lov_return_value=>'='
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(200640809968340743)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'!='
,p_lov_return_value=>'!='
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(200641025381340743)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'LIKE'
,p_lov_return_value=>'LIKE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(200641212319340743)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'NOT LIKE'
,p_lov_return_value=>'NOT LIKE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(200641411936340743)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'>'
,p_lov_return_value=>'>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(200641614080340743)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'<'
,p_lov_return_value=>'<'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(200642026032340743)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'IS NULL'
,p_lov_return_value=>'IS NULL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(193463382693188419)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'IS NOT NULL'
,p_lov_return_value=>'IS NOT NULL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/app_computation_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84926512995804334)
,p_lov_name=>'APP COMPUTATION TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(84926512995804334)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475094
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84927104623804335)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Expression'
,p_lov_return_value=>'EXPRESSION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84926706354804335)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Function Body'
,p_lov_return_value=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84926905769804335)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Item Value'
,p_lov_return_value=>'ITEM_VALUE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84927328096804335)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'SQL Query (return single value)'
,p_lov_return_value=>'QUERY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(484391218230836490)
,p_lov_disp_sequence=>45
,p_lov_disp_value=>'SQL Query (return colon separated value)'
,p_lov_return_value=>'QUERY_COLON'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84927527354804336)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Set Item Equal to Preference'
,p_lov_return_value=>'SET_ITEM_EQUAL_THIS_PREFERENCE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84928121322804336)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Static Assignment'
,p_lov_return_value=>'STATIC_ASSIGNMENT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/app_diff_components
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(15166510896787111)
,p_lov_name=>'APP DIFF COMPONENTS'
,p_lov_query=>'.'||wwv_flow_imp.id(15166510896787111)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475094
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15166729440787257)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Page'
,p_lov_return_value=>'PAGE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15166920981787257)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Page Region'
,p_lov_return_value=>'PAGE.REGION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15167616090788599)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Page Item'
,p_lov_return_value=>'PAGE.ITEM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15214625580576733)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Page Button'
,p_lov_return_value=>'PAGE.BUTTON'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15272703827450402)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Breadcrumb'
,p_lov_return_value=>'BREADCRUMB'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15275406775489081)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Breadcrumb Entry'
,p_lov_return_value=>'BREADCRUMB.ENTRY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15280612335642113)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'List of Values'
,p_lov_return_value=>'LOV'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15282816060662069)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'List of Values Entry'
,p_lov_return_value=>'LOV.ENTRY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15286423211730438)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Page Branch'
,p_lov_return_value=>'PAGE.BRANCH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15289020964767588)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Page Process'
,p_lov_return_value=>'PAGE.PROCESS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15405712412659795)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Navigation Bar Entry'
,p_lov_return_value=>'NAVBAR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15407718009765502)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Page Validation'
,p_lov_return_value=>'PAGE.VALIDATION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16035403732024287)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Application Process'
,p_lov_return_value=>'APPLICATION.PROCESS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16049914242661216)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Application Computation'
,p_lov_return_value=>'APPLICATION.COMPUTATION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16051425979711899)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Tab'
,p_lov_return_value=>'TAB'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16053917069766164)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Parent Tab'
,p_lov_return_value=>'PARENT.TAB'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16055929929798216)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Application Item'
,p_lov_return_value=>'APPLICATION.ITEM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16057603787828581)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Build Option'
,p_lov_return_value=>'BUILD.OPTION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16059007512848565)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'List'
,p_lov_return_value=>'LIST'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16061027392939460)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'List Entry'
,p_lov_return_value=>'LIST.ENTRY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16063928309005945)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Shortcut'
,p_lov_return_value=>'SHORTCUT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16064814158030207)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Tree'
,p_lov_return_value=>'TREE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16066121917117672)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Authentication Scheme'
,p_lov_return_value=>'AUTHENTICATION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17120709519005837)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Application Attribute'
,p_lov_return_value=>'APPLICATION.ATTRIBUTES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17177423445965489)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Report Column'
,p_lov_return_value=>'REPORT.COLUMN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17180127956042460)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Authorization Scheme'
,p_lov_return_value=>'AUTHORIZATION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17181701739167324)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Theme'
,p_lov_return_value=>'THEME'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17182812400265020)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Page Template'
,p_lov_return_value=>'TEMPLATE.PAGE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23040505396709149)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Region Template'
,p_lov_return_value=>'TEMPLATE.REGION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23059602943831450)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'List Template'
,p_lov_return_value=>'TEMPLATE.LIST'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23060207099832682)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Label Template'
,p_lov_return_value=>'TEMPLATE.LABEL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23065614980853874)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Breadcrumb Template'
,p_lov_return_value=>'TEMPLATE.BREADCRUMB'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23072813388938597)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Report Template'
,p_lov_return_value=>'TEMPLATE.REPORT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23111731368066835)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Calendar Template'
,p_lov_return_value=>'TEMPLATE.CALENDAR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23112607258069299)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Popup List of Values Template'
,p_lov_return_value=>'TEMPLATE.POPUP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23114220071073019)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Button Template'
,p_lov_return_value=>'TEMPLATE.BUTTON'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27856206573040810)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Plug-in'
,p_lov_return_value=>'PLUGIN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27856417308043979)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Data Loading'
,p_lov_return_value=>'DATA.LOADING'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27863524730206971)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Text Message'
,p_lov_return_value=>'TEXT.MESSAGE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(30579828593361171)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Web Service'
,p_lov_return_value=>'WEB.SERVICE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(101938626726557494)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Region Printing'
,p_lov_return_value=>'REGION PRINTING'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(493071332668111886)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Page Computation'
,p_lov_return_value=>'PAGE.COMPUTATION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/app_extend_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84881512912473090)
,p_lov_name=>'APP EXTEND OPTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(84881512912473090)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475094
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84881732492473090)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'A blank page'))
,p_lov_return_value=>'PAGE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84881910860473091)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'A login page'))
,p_lov_return_value=>'LOGIN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84882130890473091)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'A page or application component'))
,p_lov_return_value=>'WIZARD'
);
end;
/
prompt --application/shared_components/user_interface/lovs/app_extend_options2
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84884222524494810)
,p_lov_name=>'APP EXTEND OPTIONS2'
,p_lov_query=>'.'||wwv_flow_imp.id(84884222524494810)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475094
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84884418462494811)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'A blank page'))
,p_lov_return_value=>'PAGE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84884606421494811)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'A login page'))
,p_lov_return_value=>'LOGIN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84884814299494811)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'A page or application component'))
,p_lov_return_value=>'WIZARD'
);
end;
/
prompt --application/shared_components/user_interface/lovs/app_groups_assigned_unassigned
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(92271115231446627)
,p_lov_name=>'APP GROUPS ASSIGNED UNASSIGNED'
,p_lov_query=>'.'||wwv_flow_imp.id(92271115231446627)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475094
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(92271314455446628)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'- All -'
,p_lov_return_value=>'0'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(92271714863446629)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Assigned'
,p_lov_return_value=>'ASSIGNED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(92271520282446629)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Unassigned'
,p_lov_return_value=>'UNASSIGNED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/app_print_server_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(6801471089410875)
,p_lov_name=>'APP PRINT SERVER TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(6801471089410875)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475094
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(6802190151410888)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Native Printing'
,p_lov_return_value=>'NATIVE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(6802558698410888)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Remote Print Server'
,p_lov_return_value=>'REMOTE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(6801733822410887)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Use Instance Settings'
,p_lov_return_value=>'INSTANCE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/app_wizard_page_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(149548310855791684)
,p_lov_name=>'APP WIZARD PAGE TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(149548310855791684)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475094
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(149548517242791690)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Blank page'
,p_lov_return_value=>'BLANK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(149548725452791693)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Report page'
,p_lov_return_value=>'REPORT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(149548909667791693)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Report with an edit form on a second page'
,p_lov_return_value=>'REPORTANDFORM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(149549130170791694)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Editable Interactive Grid'
,p_lov_return_value=>'TABULARFORM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(149549303695791694)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Form with insert, update and delete'
,p_lov_return_value=>'FORM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(147022416546025322)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Single page master detail'
,p_lov_return_value=>'MASTERDETAIL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(618762604165647502)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Chart page'
,p_lov_return_value=>'CHART'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(236361118648814472)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'List View Page'
,p_lov_return_value=>'LISTVIEW'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(236361514982816147)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'List View with an edit form on the second page'
,p_lov_return_value=>'LISTVIEWANDFORM'
);
end;
/
prompt --application/shared_components/user_interface/lovs/application_groups_and_unassigned_groups
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(91658312614512198)
,p_lov_name=>'APPLICATION GROUPS AND UNASSIGNED GROUPS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select group_name, id',
'  from (',
'select group_name, id, 2 ob',
'  from wwv_flow_application_groups ',
' where security_group_id = :flow_security_group_id ',
'union all',
'select ''- ''||wwv_flow_lang.system_message(''Unassigned'')||'' -'' group_name, -1 id, 1 ob',
'  from dual',
')',
'order by ob, group_name'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475094
);
end;
/
prompt --application/shared_components/user_interface/lovs/application_logo_image_or_text
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(210991102136588089)
,p_lov_name=>'APPLICATION LOGO IMAGE OR TEXT'
,p_lov_query=>'.'||wwv_flow_imp.id(210991102136588089)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475094
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(210991321100588090)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Image'
,p_lov_return_value=>'I'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(210991511506588095)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Text'
,p_lov_return_value=>'T'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(238999874444009828)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Image and Text'
,p_lov_return_value=>'IT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(239000212173009829)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Custom'
,p_lov_return_value=>'C'
);
end;
/
prompt --application/shared_components/user_interface/lovs/application_status
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(461314228761951916)
,p_lov_name=>'APPLICATION STATUS'
,p_lov_query=>'.'||wwv_flow_imp.id(461314228761951916)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475094
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(461314410157951917)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Available'
,p_lov_return_value=>'AVAILABLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(461315009499955796)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Unavailable'
,p_lov_return_value=>'UNAVAILABLE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/application_themes
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(60317311466182536)
,p_lov_name=>'APPLICATION THEMES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475094
);
end;
/
prompt --application/shared_components/user_interface/lovs/application_themes_active
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(8544631431632408)
,p_lov_name=>'APPLICATION THEMES (ACTIVE)'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.theme_id||''. '' ||t.theme_name as d,',
'       t.theme_id',
'  from wwv_flows f,',
'       wwv_flow_themes t',
' where f.id                = :FB_FLOW_ID',
'   and f.security_group_id = :WORKSPACE_ID',
'   and t.flow_id           = f.id',
'   and t.theme_id          = f.theme_id',
'   and t.security_group_id = :WORKSPACE_ID',
' order by t.theme_id'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475094
);
end;
/
prompt --application/shared_components/user_interface/lovs/application_compatibility_mode
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(207464823363457503)
,p_lov_name=>'APPLICATION.COMPATIBILITY_MODE'
,p_lov_query=>'.'||wwv_flow_imp.id(207464823363457503)||'.'
,p_location=>'STATIC'
,p_version_scn=>20711191
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(48215073577260787)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'21.2 to 24.1'
,p_lov_return_value=>'21.2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(183105967630838029)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'19.2 / 20.1 / 20.2 / 21.1'
,p_lov_return_value=>'19.2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(218606250087580379)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'19.1'
,p_lov_return_value=>'19.1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(610184552140315733)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'5.1 / 18.1 / 18.2'
,p_lov_return_value=>'5.1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4967401114954788)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'5.0'
,p_lov_return_value=>'5.0'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(207465025563457504)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'4.2'
,p_lov_return_value=>'4.2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(207465319619457504)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'4.1'
,p_lov_return_value=>'4.1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(207465627664457504)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Pre 4.1'
,p_lov_return_value=>'4.0'
);
end;
/
prompt --application/shared_components/user_interface/lovs/application_menus
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(149605524191093671)
,p_lov_name=>'APPLICATION.MENUS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name,',
'       id',
'  from wwv_flow_menus',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475094
);
end;
/
prompt --application/shared_components/user_interface/lovs/applications
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(15049727442569349)
,p_lov_name=>'APPLICATIONS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||name d, id r',
'  from wwv_flow_visible_flows f',
' where f.build_status != ''RUN_AND_HIDDEN''',
' order by 2'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475094
);
end;
/
prompt --application/shared_components/user_interface/lovs/application_templates
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(100224418521422119)
,p_lov_name=>'APPLICATION_TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||name d, id r',
'  from wwv_flows f',
' where security_group_id = 11 ',
'   and not exists ( select null',
'                      from wwv_flow_language_map',
'                     where translation_flow_id = f.id',
'                       and security_group_id = 11 )',
'order by 2'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475094
);
end;
/
prompt --application/shared_components/user_interface/lovs/application_view_mode
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84241428998396992)
,p_lov_name=>'APPLICATION_VIEW_MODE'
,p_lov_query=>'.'||wwv_flow_imp.id(84241428998396992)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475094
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84241625056396993)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Detail'
,p_lov_return_value=>'DETAIL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84241814483396993)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'List'
,p_lov_return_value=>'LIST'
);
end;
/
prompt --application/shared_components/user_interface/lovs/app_acl_groups
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(92479731157354006)
,p_lov_name=>'APP_ACL_GROUPS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select group_name d,',
'       id r',
'  from wwv_flow_fnd_user_groups',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475094
);
end;
/
prompt --application/shared_components/user_interface/lovs/app_auth_option
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1814979507688651821)
,p_lov_name=>'APP_AUTH_OPTION'
,p_lov_query=>'.'||wwv_flow_imp.id(1814979507688651821)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475094
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1814979824886651823)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Oracle APEX Accounts'
,p_lov_return_value=>'APEX'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1814980014644651823)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Oracle Cloud Identity Management'
,p_lov_return_value=>'IDM'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>'wwv_flow_authentication_dev.get_internal_authentication = ''CLOUD_IDM'''
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(288183120240134690)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'HTTP Header Variable'
,p_lov_return_value=>'HTTP_HEADER_VARIABLE'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>' wwv_flow_platform.get_preference(''PKG_APP_AUTH_ALLOW_HHEAD'') = ''Y'''
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(288183408656134690)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'LDAP Directory'
,p_lov_return_value=>'LDAP'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>' wwv_flow_platform.get_preference(''PKG_APP_AUTH_ALLOW_LDAP'') = ''Y'''
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(288183730099134690)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Oracle Application Server Single Sign-On'
,p_lov_return_value=>'IAS_SSO'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>' wwv_flow_platform.get_preference(''PKG_APP_AUTH_ALLOW_SSO'') = ''Y'''
,p_lov_disp_cond2=>'PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/app_char_set
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(86591912420238949)
,p_lov_name=>'APP_CHAR_SET'
,p_lov_query=>'.'||wwv_flow_imp.id(86591912420238949)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475094
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87520523148833682)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (US-ASCII)'
,p_lov_return_value=>'US-ASCII'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87520707773833682)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Unicode (UTF8)'
,p_lov_return_value=>'UTF8'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87520910595833682)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Western (Windows-1252)'
,p_lov_return_value=>'Windows-1252'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(87521104177833683)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Western (iso-8859-1)'
,p_lov_return_value=>'iso-8859-1'
);
end;
/
prompt --application/shared_components/user_interface/lovs/app_computation_points
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(48425308522403722)
,p_lov_name=>'APP_COMPUTATION_POINTS'
,p_lov_query=>'.'||wwv_flow_imp.id(48425308522403722)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475094
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(48425626846403752)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'On New Instance (new session)'
,p_lov_return_value=>'ON_NEW_INSTANCE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(48425926823403752)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'After Authentication'
,p_lov_return_value=>'AFTER_LOGIN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(48426208730403756)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Before Header'
,p_lov_return_value=>'BEFORE_HEADER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(48426516073403756)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'After Header'
,p_lov_return_value=>'AFTER_HEADER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(48426820582403756)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Before Region(s)'
,p_lov_return_value=>'BEFORE_BOX_BODY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(48427107076403756)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'After Region(s)'
,p_lov_return_value=>'AFTER_BOX_BODY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(48427419682403756)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Before Footer'
,p_lov_return_value=>'BEFORE_FOOTER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(48427721551403760)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'After Footer'
,p_lov_return_value=>'AFTER_FOOTER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(48428021631403760)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'After Submit'
,p_lov_return_value=>'AFTER_SUBMIT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/app_copy_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84341526733632941)
,p_lov_name=>'APP_COPY_OPTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(84341526733632941)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475094
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(171495412485960439)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'User Interface Themes'
,p_lov_return_value=>'THEMES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84341707833632941)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Lists of Values'
,p_lov_return_value=>'LOV'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1435744414125343373)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'Plug-Ins'
,p_lov_return_value=>'PLUGIN'
,p_required_patch=>wwv_flow_imp.id(170786031904296885)
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84341922244632941)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Navigation Bar Entries'
,p_lov_return_value=>'NAVBAR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84342129977632942)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Authorization Schemes'
,p_lov_return_value=>'AUTHORIZATION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(106274302385250184)
,p_lov_disp_sequence=>1040
,p_lov_disp_value=>'Authentication Schemes'
,p_lov_return_value=>'AUTHENTICATION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/app_item_scope
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(211617631947367477)
,p_lov_name=>'APP_ITEM_SCOPE'
,p_lov_query=>'.'||wwv_flow_imp.id(211617631947367477)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475094
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(211617908937367477)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Application'
,p_lov_return_value=>'APP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(211618207033367479)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Global'
,p_lov_return_value=>'GLOBAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/app_populate_roles
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(177081808679947721)
,p_lov_name=>'APP_POPULATE_ROLES'
,p_lov_query=>'.'||wwv_flow_imp.id(177081808679947721)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475094
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(177082156363947748)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Access Control User Role Assignments'
,p_lov_return_value=>'R'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(177082551234947749)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Authentication Scheme'
,p_lov_return_value=>'A'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(177082986222947749)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Custom Code'
,p_lov_return_value=>'C'
);
end;
/
prompt --application/shared_components/user_interface/lovs/app_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(367839101511546508)
,p_lov_name=>'APP_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(367839101511546508)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475094
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(367839421855546509)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Standard Application'
,p_lov_return_value=>'STANDARD'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(367839606331546509)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Application Template'
,p_lov_return_value=>'TEMPLATE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(367839807571546510)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Sample Application'
,p_lov_return_value=>'SAMPLE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/app_web_sources_for_reports
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(3852199756927887)
,p_lov_name=>'APP_WEB_SOURCES_FOR_REPORTS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_flow_web_src_modules m',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and exists ( select 1 ',
'                  from wwv_flow_web_src_operations',
'                 where web_src_module_id = m.id',
'                   and database_operation = ''FETCH_COLLECTION'' )',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475094
);
end;
/
prompt --application/shared_components/user_interface/lovs/app_wiz_chart_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(161900516722838362)
,p_lov_name=>'APP_WIZ_CHART_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(161900516722838362)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475094
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(161900809488838368)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'3D Column'
,p_lov_return_value=>'3DColumn'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(618825618287796251)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'3D Range Column'
,p_lov_return_value=>'Range3DColumn'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(617394520554093313)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'3D Stacked Column'
,p_lov_return_value=>'Stacked3DColumn'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(617394723671094261)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'3D Stacked Column (Percent)'
,p_lov_return_value=>'3DSTACKED_PCT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(161901023475838370)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'2D Column'
,p_lov_return_value=>'2DColumn'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(618825824520798054)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'2D Range Column'
,p_lov_return_value=>'Range2DColumn'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(617394927827095426)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'2D Stacked Column'
,p_lov_return_value=>'Stacked2DColumn'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615715300950879723)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'3D Bar Chart'
,p_lov_return_value=>'Horizontal3DColumn'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(617395131982096613)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'2D Stacked Column (Percent)'
,p_lov_return_value=>'2DSTACKED_PCT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(618826103873801635)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'3D Range Bar Chart'
,p_lov_return_value=>'HorizontalRange3DColumn'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(617404612290119346)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'3D Stacked Bar Chart'
,p_lov_return_value=>'StackedHorizontal3DColumn'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(617404817138120730)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'3D Stacked Bar Chart (Percent)'
,p_lov_return_value=>'3DHSTACKED_PCT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615715506838881495)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>'2D Bar Chart'
,p_lov_return_value=>'Horizontal2DColumn'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(618826408029802793)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>'2D Range Bar Chart'
,p_lov_return_value=>'HorizontalRange2DColumn'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(617405825103123010)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'2D Stacked Bar Chart'
,p_lov_return_value=>'StackedHorizontal2DColumn'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(617406029951124372)
,p_lov_disp_sequence=>16
,p_lov_disp_value=>'2D Stacked Bar Chart (Percent)'
,p_lov_return_value=>'2DHSTACKED_PCT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615716321729885785)
,p_lov_disp_sequence=>17
,p_lov_disp_value=>'Line'
,p_lov_return_value=>'2DLine'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(618826615301804931)
,p_lov_disp_sequence=>18
,p_lov_disp_value=>'Scatter Marker'
,p_lov_return_value=>'ScatterMarker'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615715710647882561)
,p_lov_disp_sequence=>19
,p_lov_disp_value=>'3D Pie'
,p_lov_return_value=>'3DPie'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615715914110883599)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'2D Pie'
,p_lov_return_value=>'2DPie'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615716117573884523)
,p_lov_disp_sequence=>21
,p_lov_disp_value=>'2D Doughnut'
,p_lov_return_value=>'2DDoughnut'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615716629694888045)
,p_lov_disp_sequence=>22
,p_lov_disp_value=>'Dial'
,p_lov_return_value=>'GaugeChart'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(618827129500808965)
,p_lov_disp_sequence=>23
,p_lov_disp_value=>'Dial (Percent)'
,p_lov_return_value=>'DIAL_PCT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(618826920842806469)
,p_lov_disp_sequence=>24
,p_lov_disp_value=>'Candlestick'
,p_lov_return_value=>'Candlestick'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(618827332616809914)
,p_lov_disp_sequence=>25
,p_lov_disp_value=>'Project Gantt'
,p_lov_return_value=>'ProjectGantt'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(618827502965810767)
,p_lov_disp_sequence=>26
,p_lov_disp_value=>'Resource Gantt'
,p_lov_return_value=>'ResourceGantt'
);
end;
/
prompt --application/shared_components/user_interface/lovs/app_wiz_create_mode
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(161818726905576357)
,p_lov_name=>'APP_WIZ_CREATE_MODE'
,p_lov_query=>'.'||wwv_flow_imp.id(161818726905576357)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475094
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(161819017462576362)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Read Only'
,p_lov_return_value=>'R'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(161819201423576364)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Read and Write'
,p_lov_return_value=>'RW'
);
end;
/
prompt --application/shared_components/user_interface/lovs/audit_action
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(192763415498955359)
,p_lov_name=>'AUDIT ACTION'
,p_lov_query=>'.'||wwv_flow_imp.id(192763415498955359)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475094
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192763609015955370)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Insert'
,p_lov_return_value=>'I'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192763829535955373)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Update'
,p_lov_return_value=>'U'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192764030537955373)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Delete'
,p_lov_return_value=>'D'
);
end;
/
prompt --application/shared_components/user_interface/lovs/audit_info_detail
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1726678227351632)
,p_lov_name=>'AUDIT INFO DETAIL'
,p_lov_query=>'.'||wwv_flow_imp.id(1726678227351632)||'.'
,p_location=>'STATIC'
,p_version_scn=>35727777
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1727347119351648)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Names and Dates'
,p_lov_return_value=>'NAMES_AND_DATES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1726928649351647)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Dates Only'
,p_lov_return_value=>'DATES_ONLY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/audit_naming
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(192773330531006109)
,p_lov_name=>'AUDIT_NAMING'
,p_lov_query=>'.'||wwv_flow_imp.id(192773330531006109)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475094
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192773504494006111)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Application Attributes'
,p_lov_return_value=>'WWV_FLOWS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192773719028006113)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Page Template'
,p_lov_return_value=>'WWV_FLOW_TEMPLATES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192773912582006113)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Navigation Bar'
,p_lov_return_value=>'WWV_FLOW_ICON_BAR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192774132498006113)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Application Process'
,p_lov_return_value=>'WWV_FLOW_PROCESSING'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192774324088006113)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Application Item'
,p_lov_return_value=>'WWV_FLOW_ITEMS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192774507402006114)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Application Computation'
,p_lov_return_value=>'WWV_FLOW_COMPUTATIONS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192774728974006114)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Tabs'
,p_lov_return_value=>'WWV_FLOW_TABS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192774924389006115)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Parent Tab'
,p_lov_return_value=>'WWV_FLOW_TOPLEVEL_TABS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192775116232006115)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'List of Values'
,p_lov_return_value=>'WWV_FLOW_LISTS_OF_VALUES$'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192775308893006115)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'List of Values Entry'
,p_lov_return_value=>'WWV_FLOW_LISTS_OF_VALUES_DATA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192775506134006116)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Page Attributes'
,p_lov_return_value=>'WWV_FLOW_STEPS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192775729209006116)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Page Button'
,p_lov_return_value=>'WWV_FLOW_STEP_BUTTONS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192775914488006116)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Page Branch'
,p_lov_return_value=>'WWV_FLOW_STEP_BRANCHES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192776105194006116)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Page Branch Arguments'
,p_lov_return_value=>'WWV_FLOW_STEP_BRANCH_ARGS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192776313341006117)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Page Item'
,p_lov_return_value=>'WWV_FLOW_STEP_ITEMS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192776518774006117)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Page Computation'
,p_lov_return_value=>'WWV_FLOW_STEP_COMPUTATIONS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192776728927006117)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Page Validation'
,p_lov_return_value=>'WWV_FLOW_STEP_VALIDATIONS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192776908821006117)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Page Process'
,p_lov_return_value=>'WWV_FLOW_STEP_PROCESSING'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192777132334006118)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Region Template'
,p_lov_return_value=>'WWV_FLOW_PAGE_PLUG_TEMPLATES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192777326352006118)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Row Template'
,p_lov_return_value=>'WWV_FLOW_ROW_TEMPLATES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192777504961006118)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'List Template'
,p_lov_return_value=>'WWV_FLOW_LIST_TEMPLATES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192777704768006118)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Region Attributes'
,p_lov_return_value=>'WWV_FLOW_PAGE_PLUGS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192777913070006119)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Messages'
,p_lov_return_value=>'WWV_FLOW_MESSAGES$'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192778131775006119)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Build Options'
,p_lov_return_value=>'WWV_FLOW_PATCHES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192778311606006120)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Application Developers (Administration)'
,p_lov_return_value=>'WWV_FLOW_DEVELOPERS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192778526631006120)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Lists'
,p_lov_return_value=>'WWV_FLOW_LISTS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192778710948006120)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'List Item'
,p_lov_return_value=>'WWV_FLOW_LIST_ITEMS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192778903034006120)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Effective User ID (Administration)'
,p_lov_return_value=>'WWV_FLOW_EFFECTIVE_USERID_MAP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192779106904006121)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Shortcuts'
,p_lov_return_value=>'WWV_FLOW_SHORTCUTS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192779305727006121)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Page Item Help Text'
,p_lov_return_value=>'WWV_FLOW_STEP_ITEM_HELP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192779523562006121)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Authentication Setups'
,p_lov_return_value=>'WWV_FLOW_AUTHENTICATIONS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192779703226006121)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Entry Points'
,p_lov_return_value=>'WWV_FLOW_ENTRY_POINTS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192779919153006122)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Entry Point Arguments'
,p_lov_return_value=>'WWV_FLOW_ENTRY_POINT_ARGS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192814127076119594)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Breadcrumb Entry'
,p_lov_return_value=>'WWV_FLOW_MENU_OPTIONS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192918929997948694)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Themes'
,p_lov_return_value=>'WWV_FLOW_THEMES'
);
end;
/
prompt --application/shared_components/user_interface/lovs/auth_scheme_component_list
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(19565023708932258)
,p_lov_name=>'AUTH SCHEME COMPONENT LIST'
,p_lov_query=>'.'||wwv_flow_imp.id(19565023708932258)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475098
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3010601809370879)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Region Action'
,p_lov_return_value=>'REGION_ACTIONS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3010996638370884)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Region Action Menu Entry'
,p_lov_return_value=>'REGION_ACTION_MENU_ENTRIES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3011360242370884)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Interactive Report Column Action'
,p_lov_return_value=>'IR_COLUMN_ACTIONS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3011707667370884)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Interactive Report Column Action Menu Entry'
,p_lov_return_value=>'IR_COLUMN_ACTION_MENU_ENTRIES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4401945308904583)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Dynamic Action'
,p_lov_return_value=>'WWV_FLOW_PAGE_DA_EVENTS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4402224443904585)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Dynamic Action - Action'
,p_lov_return_value=>'WWV_FLOW_PAGE_DA_ACTIONS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(19565408576932259)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Application Computation'
,p_lov_return_value=>'WWV_FLOW_COMPUTATIONS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(19565616823932259)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Navigation Bar Entry'
,p_lov_return_value=>'WWV_FLOW_ICON_BAR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(19565811243932259)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'List Entry'
,p_lov_return_value=>'WWV_FLOW_LIST_ITEMS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(19566018968932260)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Breadcrumb'
,p_lov_return_value=>'WWV_FLOW_MENU_OPTIONS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(19566229367932260)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Application Process'
,p_lov_return_value=>'WWV_FLOW_PROCESSING'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(19566425485932260)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Page Branch'
,p_lov_return_value=>'WWV_FLOW_STEP_BRANCHES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(19566609500932260)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Page Button'
,p_lov_return_value=>'WWV_FLOW_STEP_BUTTONS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(19566827943932260)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Page Computation'
,p_lov_return_value=>'WWV_FLOW_STEP_COMPUTATIONS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(19567024556932261)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Page Item'
,p_lov_return_value=>'WWV_FLOW_STEP_ITEMS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(19567203422932261)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Page Process'
,p_lov_return_value=>'WWV_FLOW_STEP_PROCESSING'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(19567427523932261)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Page Validation'
,p_lov_return_value=>'WWV_FLOW_STEP_VALIDATIONS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(19567631501932261)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Standard Tab'
,p_lov_return_value=>'WWV_FLOW_TABS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(19567802034932262)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Parent Tab'
,p_lov_return_value=>'WWV_FLOW_TOPLEVEL_TABS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(19568016566932263)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Page'
,p_lov_return_value=>'WWV_FLOW_STEPS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(19664501543326267)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Report Column'
,p_lov_return_value=>'WWV_FLOW_REGION_REPORT_COLUMN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(19664915179339682)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Region'
,p_lov_return_value=>'WWV_FLOW_PAGE_PLUGS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(51615570012410403)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Application'
,p_lov_return_value=>'WWV_FLOWS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(51615959036411770)
,p_lov_disp_sequence=>21
,p_lov_disp_value=>'Region Column'
,p_lov_return_value=>'WWV_FLOW_REGION_COLUMNS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(51616253689413333)
,p_lov_disp_sequence=>31
,p_lov_disp_value=>'Report Column'
,p_lov_return_value=>'WWV_FLOW_WORKSHEET_COLUMNS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(51616520244414938)
,p_lov_disp_sequence=>41
,p_lov_disp_value=>'Card Action'
,p_lov_return_value=>'WWV_FLOW_CARD_ACTIONS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4800999106560156)
,p_lov_disp_sequence=>51
,p_lov_disp_value=>'Chart Series'
,p_lov_return_value=>'WWV_FLOW_JET_CHART_SERIES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(5200387496569869)
,p_lov_disp_sequence=>61
,p_lov_disp_value=>'Interactive Grid Alternative Report'
,p_lov_return_value=>'WWV_FLOW_IG_REPORTS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(5200664158571635)
,p_lov_disp_sequence=>71
,p_lov_disp_value=>'Facet Group'
,p_lov_return_value=>'WWV_FLOW_STEP_ITEM_GROUPS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/authentication_methods2
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(62983620392370890)
,p_lov_name=>'AUTHENTICATION_METHODS2'
,p_lov_query=>'.'||wwv_flow_imp.id(62983620392370890)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475103
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(124262609673589368)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'SCHEME(ready-to-run or craft your own)'
,p_lov_return_value=>'CUSTOM2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(62984185221370917)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'INTERNAL (local account repository)'
,p_lov_return_value=>'COOKIE'
,p_lov_disp_cond_type=>'NEVER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/authentication_schemes
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(166264006489001223)
,p_lov_name=>'AUTHENTICATION_SCHEMES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name as d,',
'       id   as r',
'  from wwv_flow_authentications',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :WORKSPACE_ID',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475103
);
end;
/
prompt --application/shared_components/user_interface/lovs/authentication_scheme_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(346988529123216543)
,p_lov_name=>'AUTHENTICATION_SCHEME_TYPE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,',
'       r',
'  from (',
'        select wwv_flow_lang.system_message(''AUTHENTICATION_NAME.''|| name_with_prefix) as d,',
'               name_with_prefix      as r',
'          from wwv_flow_native_plugins',
'         where plugin_type = ''AUTHENTICATION TYPE''',
'         union all',
'        select display_name || wwv_flow_lang.system_message(''PLUGIN.DISPLAY_NAME_POSTFIX'') as d,',
'               ''PLUGIN_'' || name     as r',
'          from wwv_flow_plugins',
'         where flow_id           = to_number(:FB_FLOW_ID)',
'           and security_group_id = to_number(:WORKSPACE_ID)',
'           and plugin_type       = ''AUTHENTICATION TYPE''',
'       )',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475103
);
end;
/
prompt --application/shared_components/user_interface/lovs/authorization_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(11239432234132441)
,p_lov_name=>'AUTHORIZATION TYPE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,',
'       r',
'  from (',
'        select wwv_flow_lang.system_message(''AUTHORIZATION_NAME.''|| name_with_prefix) as d,',
'               name_with_prefix      as r',
'          from wwv_flow_native_plugins',
'         where plugin_type = ''AUTHORIZATION TYPE''',
'         union all',
'        select display_name || wwv_flow_lang.system_message(''PLUGIN.DISPLAY_NAME_POSTFIX'') as d,',
'               ''PLUGIN_'' || name     as r',
'          from wwv_flow_plugins',
'         where flow_id           = to_number(:FB_FLOW_ID)',
'           and security_group_id = to_number(:WORKSPACE_ID)',
'           and plugin_type       = ''AUTHORIZATION TYPE''',
'       )',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475103
);
end;
/
prompt --application/shared_components/user_interface/lovs/authz_scheme_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84861720259380643)
,p_lov_name=>'AUTHZ_SCHEME_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(84861720259380643)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475103
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84861902602380643)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Exists SQL Query'
,p_lov_return_value=>'EXISTS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84862521867380644)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'NOT Exists SQL Query'
,p_lov_return_value=>'NOT_EXISTS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84862132654380644)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Item in Expression 1 is NULL'
,p_lov_return_value=>'ITEM_IS_NULL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84862305726380644)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Item in Expression1 is NOT NULL'
,p_lov_return_value=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84862724485380644)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'PL/SQL Function Returning Boolean'
,p_lov_return_value=>'FUNCTION_RETURNING_BOOLEAN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84862924429380645)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Value of Preference in Expression 1 Equals Expression 2'
,p_lov_return_value=>'PREFERENCE_EQ_COND_TEXT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84863130627380645)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Value of Preference in Expression 1 Does NOT Equal Expression 2'
,p_lov_return_value=>'PREFERENCE_NOT_EQ_COND_TEXT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84863509444380645)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Value of item in Expression 1 Equals Expression 2'
,p_lov_return_value=>'VAL_OF_ITEM_IN_COND_EQ_COND_TEXT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84863327213380645)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'Value of Item in Expression 1 Does NOT Equal Expression 2'
,p_lov_return_value=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND_TEXT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/auth_scheme_caching
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84860700520374929)
,p_lov_name=>'AUTH_SCHEME_CACHING'
,p_lov_query=>'.'||wwv_flow_imp.id(84860700520374929)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475103
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84861103921374931)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Once per session'
,p_lov_return_value=>'BY_USER_BY_SESSION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84860914895374930)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Once per page view'
,p_lov_return_value=>'BY_USER_BY_PAGE_VIEW'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(360366921153074028)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Once per component'
,p_lov_return_value=>'BY_COMPONENT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(360367209904074033)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Always (No Caching)'
,p_lov_return_value=>'NOCACHE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/auth_scheme_refresh
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(86574617605164667)
,p_lov_name=>'AUTH_SCHEME_REFRESH'
,p_lov_query=>'select wwv_flow_lang.system_message(''INITCAP_REFRESH'')  a,''Y'' b from dual'
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475103
);
end;
/
prompt --application/shared_components/user_interface/lovs/auth_wiz_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84347110372647083)
,p_lov_name=>'AUTH_WIZ_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(84347110372647083)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475103
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88152606479963512)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'From Scratch'
,p_lov_return_value=>'BLANK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88152800735963512)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'As a Copy of an Existing Authorization Scheme'
,p_lov_return_value=>'COPY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/automations
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1378606678543833)
,p_lov_name=>'AUTOMATIONS'
,p_source_type=>'TABLE'
,p_location=>'LOCAL'
,p_query_table=>'WWV_FLOW_AUTOMATIONS'
,p_return_column_name=>'ID'
,p_display_column_name=>'NAME'
,p_default_sort_column_name=>'NAME'
,p_default_sort_direction=>'ASC'
,p_version_scn=>72475103
);
end;
/
prompt --application/shared_components/user_interface/lovs/automation_all_result_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1356468048734066)
,p_lov_name=>'AUTOMATION_ALL_RESULT_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(1356468048734066)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475103
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1356737017734067)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Rows Returned'
,p_lov_return_value=>'ROWS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1357181724734067)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'No Rows Returned'
,p_lov_return_value=>'NO_ROWS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1357517577734067)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'PL/SQL returning boolean'
,p_lov_return_value=>'FUNC_BODY_RETURNING_BOOLEAN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1357960373734067)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Always'
,p_lov_return_value=>'ALWAYS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/automation_object_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1387977807801823)
,p_lov_name=>'AUTOMATION_OBJECT_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(1387977807801823)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475103
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1388285199801823)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Automation'
,p_lov_return_value=>'AUTOMATION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1388637743801823)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Automation Action'
,p_lov_return_value=>'AUTOMATION ACTION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/automation_polling_status
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1358229692738259)
,p_lov_name=>'AUTOMATION_POLLING_STATUS'
,p_lov_query=>'.'||wwv_flow_imp.id(1358229692738259)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475103
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1358558106738259)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Active'
,p_lov_return_value=>'ACTIVE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1358916784738259)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Disabled'
,p_lov_return_value=>'DISABLED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1359379608738259)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Disabled (Error)'
,p_lov_return_value=>'ERROR'
);
end;
/
prompt --application/shared_components/user_interface/lovs/automation_result_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(601105473256773090)
,p_lov_name=>'AUTOMATION_RESULT_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(601105473256773090)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475103
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601105601663773090)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Rows returned'
,p_lov_return_value=>'ROWS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601106078134773091)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'No Rows returned'
,p_lov_return_value=>'NO_ROWS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/automation_trigger_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1355426926728029)
,p_lov_name=>'AUTOMATION_TRIGGER_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(1355426926728029)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475103
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1355759872728032)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'On Demand'
,p_lov_return_value=>'API'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1356183046728033)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Scheduled'
,p_lov_return_value=>'POLLING'
);
end;
/
prompt --application/shared_components/user_interface/lovs/axis_interval
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84866925931391695)
,p_lov_name=>'AXIS_INTERVAL'
,p_lov_query=>'.'||wwv_flow_imp.id(84866925931391695)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475103
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84867111432391695)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Define axis interval'
,p_lov_return_value=>'DEFINE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84867324796391696)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Display axis interval automatically'
,p_lov_return_value=>'AUTO'
);
end;
/
prompt --application/shared_components/user_interface/lovs/background_execution_status
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1814559837736230)
,p_lov_name=>'BACKGROUND_EXECUTION_STATUS'
,p_lov_query=>'.'||wwv_flow_imp.id(1814559837736230)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475103
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1814899375736279)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Submitted for Execution'
,p_lov_return_value=>'ENQUEUED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1815261264736281)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Scheduler Job Created'
,p_lov_return_value=>'SCHEDULED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1815626581736281)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Executing'
,p_lov_return_value=>'EXECUTING'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1816049237736281)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Finished Successfully'
,p_lov_return_value=>'SUCCESS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1816413251736284)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Terminated'
,p_lov_return_value=>'ABORTED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1816873419736285)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Failed'
,p_lov_return_value=>'FAILED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/Begin_on_new_line
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(67832807038215585)
,p_lov_name=>'BEGIN ON NEW LINE'
,p_lov_query=>'.'||wwv_flow_imp.id(67832807038215585)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475103
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(67833101831215595)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Beginning on New Line'
,p_lov_return_value=>'YES'
);
end;
/
prompt --application/shared_components/user_interface/lovs/Begin_on_new_field
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(86067527340770119)
,p_lov_name=>'BEGIN_ON_NEW_FIELD'
,p_lov_query=>'.'||wwv_flow_imp.id(86067527340770119)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475103
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88282922464772458)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Beginning on New Field'
,p_lov_return_value=>'YES'
);
end;
/
prompt --application/shared_components/user_interface/lovs/blob_format_content_disposition_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(317509508537932808)
,p_lov_name=>'BLOB_FORMAT_CONTENT_DISPOSITION_TYPES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''BLOB_FORMAT_ATTACHMENT'') d, ''Attachment'' r',
'     from dual',
'union',
'select wwv_flow_lang.system_message(''BLOB_FORMAT_INLINE'') d, ''Inline'' r',
'     from dual'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475103
);
end;
/
prompt --application/shared_components/user_interface/lovs/blob_format_mask_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(317502218630715477)
,p_lov_name=>'BLOB_FORMAT_MASK_TYPES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''BLOB_FORMAT_DOWNLOAD'') d, ''DOWNLOAD'' r',
'     from dual',
'union',
'select wwv_flow_lang.system_message(''BLOB_FORMAT_IMAGE'') d, ''IMAGE'' r',
'     from dual'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475103
);
end;
/
prompt --application/shared_components/user_interface/lovs/branch_points_condensed
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(185544520425574805)
,p_lov_name=>'BRANCH.POINTS.CONDENSED'
,p_lov_query=>'.'||wwv_flow_imp.id(185544520425574805)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475103
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(185544824823574814)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Before Computation'
,p_lov_return_value=>'BEFORE_COMPUTATION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(185545021461574815)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Before Validation'
,p_lov_return_value=>'BEFORE_VALIDATION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(185545229692574815)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Before Processing'
,p_lov_return_value=>'BEFORE_PROCESSING'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(185545414740574816)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'After Processing'
,p_lov_return_value=>'AFTER_PROCESSING'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(185545628448574816)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Before Header'
,p_lov_return_value=>'BEFORE_HEADER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/breadcrumb_entry_or_container
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(205111517140679117)
,p_lov_name=>'BREADCRUMB ENTRY OR CONTAINER'
,p_lov_query=>'.'||wwv_flow_imp.id(205111517140679117)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475103
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(205111902995679137)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Breadcrumb'
,p_lov_return_value=>'BREADCRUMB'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(205345212580624072)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Breadcrumb Entry'
,p_lov_return_value=>'REGION'
,p_lov_template=>'#DISPLAY_VALUE#'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>'select 1 from wwv_flow_menus where flow_id = :fb_flow_id and security_group_id = :flow_security_group_id;'
);
end;
/
prompt --application/shared_components/user_interface/lovs/break_on_report_positions
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(83332708448288963)
,p_lov_name=>'BREAK.ON.REPORT.POSITIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(83332708448288963)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475103
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88283729044774273)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'First Column'
,p_lov_return_value=>'1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88283921634774274)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'First and Second Columns'
,p_lov_return_value=>'1:2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88284111739774274)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'First, Second and Third column'
,p_lov_return_value=>'1:2:3'
);
end;
/
prompt --application/shared_components/user_interface/lovs/break_columns
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(86602811774267145)
,p_lov_name=>'BREAK_COLUMNS'
,p_lov_query=>'.'||wwv_flow_imp.id(86602811774267145)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475103
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88287205065786323)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Column 1'
,p_lov_return_value=>'1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88287428523786324)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Column 1 and 2'
,p_lov_return_value=>'1:2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88287603244786324)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Column 1, 2 and 3'
,p_lov_return_value=>'1:2:3'
);
end;
/
prompt --application/shared_components/user_interface/lovs/break_on_report_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84247004458418293)
,p_lov_name=>'BREAK_ON_REPORT_OPTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(84247004458418293)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475103
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84247211888418294)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'First Column'
,p_lov_return_value=>'1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84247432172418294)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'First and Second Columns'
,p_lov_return_value=>'12'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84247624024418294)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'First, Second and Third Column'
,p_lov_return_value=>'123'
);
end;
/
prompt --application/shared_components/user_interface/lovs/break_type_flag
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84369008472684429)
,p_lov_name=>'BREAK_TYPE_FLAG'
,p_lov_query=>'.'||wwv_flow_imp.id(84369008472684429)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475103
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84369227840684431)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Repeat Headings on Break'
,p_lov_return_value=>'REPEAT_HEADINGS_ON_BREAK_1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84369407631684431)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Default Break Formatting'
,p_lov_return_value=>'DEFAULT_BREAK_FORMATTING'
);
end;
/
prompt --application/shared_components/user_interface/lovs/browser_cache
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(875788205897309215)
,p_lov_name=>'BROWSER_CACHE'
,p_lov_query=>'.'||wwv_flow_imp.id(875788205897309215)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475103
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(875788522508309218)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Enabled'
,p_lov_return_value=>'Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(875788730295309223)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Disabled'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/browser_frame
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1098055005642193053)
,p_lov_name=>'BROWSER_FRAME'
,p_lov_query=>'.'||wwv_flow_imp.id(1098055005642193053)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475103
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1098055323316193055)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Deny'
,p_lov_return_value=>'D'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1098055511785193055)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Allow from same origin'
,p_lov_return_value=>'S'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1098055725585193055)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Allow'
,p_lov_return_value=>'A'
);
end;
/
prompt --application/shared_components/user_interface/lovs/build_status
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84305510710571518)
,p_lov_name=>'BUILD_STATUS'
,p_lov_query=>'.'||wwv_flow_imp.id(84305510710571518)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475103
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84305709177571518)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Run Application Only'
,p_lov_return_value=>'RUN_ONLY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84305911098571518)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Run and Build Application'
,p_lov_return_value=>'RUN_AND_BUILD'
);
end;
/
prompt --application/shared_components/user_interface/lovs/button_theme_class_id
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(43576623634636183)
,p_lov_name=>'BUTTON THEME CLASS ID'
,p_lov_query=>'.'||wwv_flow_imp.id(43576623634636183)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475108
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43576912701636189)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Button'
,p_lov_return_value=>'1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43584317316653265)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Button, Alternative 1'
,p_lov_return_value=>'4'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43584619394653936)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Button, Alternative 2'
,p_lov_return_value=>'5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(44139910490884391)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Button, Alternative 3'
,p_lov_return_value=>'2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43588706496669090)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 1'
,p_lov_return_value=>'6'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43592228791685003)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 2'
,p_lov_return_value=>'7'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43592532254685982)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 3'
,p_lov_return_value=>'8'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43592802256686769)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 4'
,p_lov_return_value=>'9'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43593427883694186)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 5'
,p_lov_return_value=>'10'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43593729961694767)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 6'
,p_lov_return_value=>'11'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43594031692695331)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 7'
,p_lov_return_value=>'12'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43594301695696066)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 8'
,p_lov_return_value=>'13'
);
end;
/
prompt --application/shared_components/user_interface/lovs/button_attributes
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(147003111936901406)
,p_lov_name=>'BUTTON.ATTRIBUTES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct rtrim(BUTTON_CATTRIBUTES ) ba, rtrim(BUTTON_CATTRIBUTES ) r',
'from   wwv_flow_step_buttons',
'where  flow_id = :fb_flow_id',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475108
);
end;
/
prompt --application/shared_components/user_interface/lovs/button_is_reset
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84945521447891923)
,p_lov_name=>'BUTTON.IS.RESET'
,p_lov_query=>'.'||wwv_flow_imp.id(84945521447891923)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475108
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84945714043891924)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Button is Reset'
,p_lov_return_value=>'YES'
);
end;
/
prompt --application/shared_components/user_interface/lovs/buttons_current_and_global_page
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(6214918033450806)
,p_lov_name=>'BUTTONS_CURRENT_AND_GLOBAL_PAGE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select button_name,',
'       id',
'  from (',
'        /* all region buttons from current page and global page */',
'        select case when b.flow_step_id = f.global_page_id then',
'                   wwv_flow_lang.system_message(''LAYOUT.GLOBAL_PAGE_REGION_PREFIX'')',
'               end ||',
'               b.button_name ||',
'               '' ('' || b.button_image_alt || '')'' as button_name,',
'               b.id,',
'               b.button_name bn,',
'               case when b.flow_step_id = f.global_page_id then 2 else 1 end x',
'          from wwv_flow_steps p,',
'               wwv_flows f,',
'               wwv_flow_step_buttons b',
'         where p.flow_id      = :FB_FLOW_ID',
'           and p.id           = :FB_FLOW_PAGE_ID',
'           and f.id           = p.flow_id',
'           and b.flow_id      = f.id',
'           and b.flow_step_id in (:FB_FLOW_PAGE_ID, f.global_page_id)',
'         order by x, bn ',
'       )'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475108
);
end;
/
prompt --application/shared_components/user_interface/lovs/button_action
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(458463318087925002)
,p_lov_name=>'BUTTON_ACTION'
,p_lov_query=>'.'||wwv_flow_imp.id(458463318087925002)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475108
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(458465032417938534)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Submit Page'
,p_lov_return_value=>'SUBMIT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(458463516386925008)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Redirect to Page in this Application'
,p_lov_return_value=>'REDIRECT_PAGE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(393410308299183569)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'Redirect to Page in a different Application'
,p_lov_return_value=>'REDIRECT_APP'
,p_lov_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_lov_disp_cond=>'4314'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(458463707481925009)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Redirect to URL'
,p_lov_return_value=>'REDIRECT_URL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2217226943030013)
,p_lov_disp_sequence=>25
,p_lov_disp_value=>'Defined by Dynamic Action'
,p_lov_return_value=>'DEFINED_BY_DA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(460984115025005702)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Download Printable Report Query'
,p_lov_return_value=>'REPORT'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_SHARED_QUERIES',
' where flow_id = :fb_flow_id ',
'   and security_group_id = :flow_security_group_id',
'   and :APP_PAGE_ID = 4732'))
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3791885581293)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Reset Page'
,p_lov_return_value=>'RESET'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3791888582683)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Next Page (DEPRECATED)'
,p_lov_return_value=>'NEXT_PAGE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3791891583799)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Previous Page (DEPRECATED)'
,p_lov_return_value=>'PREVIOUS_PAGE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/button_alignment_body
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1791921829301402873)
,p_lov_name=>'BUTTON_ALIGNMENT_BODY'
,p_lov_query=>'.'||wwv_flow_imp.id(1791921829301402873)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475108
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1791928140531406086)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Center'
,p_lov_return_value=>'CENTER'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'F4000_P4314_BUTTON_POSITION'
,p_lov_disp_cond2=>'BODY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1791992121273442944)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Center bottom'
,p_lov_return_value=>'CENTER-BOTTOM'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'F4000_P4314_BUTTON_POSITION'
,p_lov_disp_cond2=>'BODY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1791992586609442944)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Center center'
,p_lov_return_value=>'CENTER-CENTER'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'F4000_P4314_BUTTON_POSITION'
,p_lov_disp_cond2=>'BODY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1791992941985442945)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Center top'
,p_lov_return_value=>'CENTER-TOP'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'F4000_P4314_BUTTON_POSITION'
,p_lov_disp_cond2=>'BODY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1791922115849402875)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Start'
,p_lov_return_value=>'LEFT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1791994711029455023)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Start bottom'
,p_lov_return_value=>'LEFT-BOTTOM'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'F4000_P4314_BUTTON_POSITION'
,p_lov_disp_cond2=>'BODY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1791995189708455023)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Start center'
,p_lov_return_value=>'LEFT-CENTER'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'F4000_P4314_BUTTON_POSITION'
,p_lov_disp_cond2=>'BODY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1791995570954455023)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Start top'
,p_lov_return_value=>'LEFT-TOP'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'F4000_P4314_BUTTON_POSITION'
,p_lov_disp_cond2=>'BODY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1791922578885402875)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'End'
,p_lov_return_value=>'RIGHT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1791995970458455024)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'End bottom'
,p_lov_return_value=>'RIGHT-BOTTOM'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'F4000_P4314_BUTTON_POSITION'
,p_lov_disp_cond2=>'BODY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1791996381262455024)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'End center'
,p_lov_return_value=>'RIGHT-CENTER'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'F4000_P4314_BUTTON_POSITION'
,p_lov_disp_cond2=>'BODY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1791996791436455025)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'End top'
,p_lov_return_value=>'RIGHT-TOP'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'F4000_P4314_BUTTON_POSITION'
,p_lov_disp_cond2=>'BODY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/button_alignment_l_r
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84754827158805413)
,p_lov_name=>'BUTTON_ALIGNMENT_L_R'
,p_lov_query=>'.'||wwv_flow_imp.id(84754827158805413)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475108
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84755030664805414)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Start'
,p_lov_return_value=>'LEFT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84755202951805414)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'End'
,p_lov_return_value=>'RIGHT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/button_display_positions2
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(62990572348595109)
,p_lov_name=>'BUTTON_DISPLAY_POSITIONS2'
,p_lov_query=>'.'||wwv_flow_imp.id(62990572348595109)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475108
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(62990815665595115)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Before Page Title'
,p_lov_return_value=>'LEFT_OF_TITLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(62991037953595115)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'After Page Title'
,p_lov_return_value=>'RIGHT_OF_TITLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(62991212359595118)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Above Region'
,p_lov_return_value=>'ABOVE_BOX'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(62991440121595118)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Top of Region'
,p_lov_return_value=>'TOP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(62991617521595119)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Bottom of Region'
,p_lov_return_value=>'BOTTOM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(62991820415595119)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Top and Bottom of Region'
,p_lov_return_value=>'TOP_AND_BOTTOM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(62992017822595122)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Below Region'
,p_lov_return_value=>'BELOW_BOX'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(62992218359595123)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Region Template #DEFAULT# Position'
,p_lov_return_value=>'TEMPLATE_DEFAULT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(92320911107933644)
,p_lov_disp_sequence=>9.5
,p_lov_disp_value=>'Region Template Position #CHANGE#'
,p_lov_return_value=>'REGION_TEMPLATE_CHANGE'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_PAGE_PLUG_TEMPLATES t,wwv_flow_page_plugs p',
' where (p.flow_id = :FB_FLOW_ID',
'   and p.PLUG_TEMPLATE = t.id',
'   and sys.dbms_lob.instr(t.template,''#CHANGE#'') > 0',
'   and :F4000_REGION_SELECTED = p.id) '))
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(62992810843595124)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Region Template Position #CLOSE#'
,p_lov_return_value=>'REGION_TEMPLATE_CLOSE'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_PAGE_PLUG_TEMPLATES t,wwv_flow_page_plugs p',
' where p.flow_id = :FB_FLOW_ID',
'   and p.PLUG_TEMPLATE = t.id',
'   and sys.dbms_lob.instr(t.template,''#CLOSE#'') > 0',
'   and :F4000_REGION_SELECTED = p.id'))
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(93091020144798464)
,p_lov_disp_sequence=>10.1
,p_lov_disp_value=>'Region Template Position #COPY#'
,p_lov_return_value=>'REGION_TEMPLATE_COPY'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_PAGE_PLUG_TEMPLATES t,wwv_flow_page_plugs p',
' where p.flow_id = :FB_FLOW_ID',
'   and p.PLUG_TEMPLATE = t.id',
'   and sys.dbms_lob.instr(t.template,''#COPY#'') > 0',
'   and :F4000_REGION_SELECTED = p.id'))
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(62992615015595124)
,p_lov_disp_sequence=>10.2
,p_lov_disp_value=>'Region Template Position #CREATE#'
,p_lov_return_value=>'REGION_TEMPLATE_CREATE'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_PAGE_PLUG_TEMPLATES t,wwv_flow_page_plugs p',
' where p.flow_id = :FB_FLOW_ID',
'   and p.PLUG_TEMPLATE = t.id',
'   and sys.dbms_lob.instr(t.template,''#CREATE#'') > 0',
'   and :F4000_REGION_SELECTED = p.id'))
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(94882719481696997)
,p_lov_disp_sequence=>10.3
,p_lov_disp_value=>'Region Template Position #CREATE2#'
,p_lov_return_value=>'REGION_TEMPLATE_CREATE2'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_PAGE_PLUG_TEMPLATES t,wwv_flow_page_plugs p',
' where p.flow_id = :FB_FLOW_ID',
'   and p.PLUG_TEMPLATE = t.id',
'   and sys.dbms_lob.instr(t.template,''#CREATE2#'') > 0',
'   and :F4000_REGION_SELECTED = p.id'))
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(92332909801949409)
,p_lov_disp_sequence=>10.5
,p_lov_disp_value=>'Region Template Position #DELETE#'
,p_lov_return_value=>'REGION_TEMPLATE_DELETE'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_PAGE_PLUG_TEMPLATES t,wwv_flow_page_plugs p',
' where p.flow_id = :FB_FLOW_ID',
'   and p.PLUG_TEMPLATE = t.id',
'   and sys.dbms_lob.instr(t.template,''#DELETE#'') > 0',
'   and :F4000_REGION_SELECTED = p.id'))
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(62992414762595123)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Region Template Position #EDIT#'
,p_lov_return_value=>'REGION_TEMPLATE_EDIT'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_PAGE_PLUG_TEMPLATES t,wwv_flow_page_plugs p',
' where p.flow_id = :FB_FLOW_ID',
'   and p.PLUG_TEMPLATE = t.id',
'   and sys.dbms_lob.instr(t.template,''#EDIT#'') > 0',
'   and :F4000_REGION_SELECTED = p.id'))
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(62993052778595124)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'Region Template Position #EXPAND#'
,p_lov_return_value=>'REGION_TEMPLATE_EXPAND'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_PAGE_PLUG_TEMPLATES t,wwv_flow_page_plugs p',
' where p.flow_id = :FB_FLOW_ID',
'   and p.PLUG_TEMPLATE = t.id',
'   and sys.dbms_lob.instr(t.template,''#EXPAND#'') > 0',
'   and :F4000_REGION_SELECTED = p.id'))
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(62993213440595125)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>'Region Template Position #HELP#'
,p_lov_return_value=>'REGION_TEMPLATE_HELP'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_PAGE_PLUG_TEMPLATES t,wwv_flow_page_plugs p',
' where p.flow_id = :FB_FLOW_ID',
'   and p.PLUG_TEMPLATE = t.id',
'   and sys.dbms_lob.instr(t.template,''#HELP#'') > 0',
'   and :F4000_REGION_SELECTED = p.id'))
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(91088720180648151)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>'Region Template Position #NEXT#'
,p_lov_return_value=>'REGION_TEMPLATE_NEXT'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_PAGE_PLUG_TEMPLATES t,wwv_flow_page_plugs p',
' where p.flow_id = :FB_FLOW_ID',
'   and p.PLUG_TEMPLATE = t.id',
'   and sys.dbms_lob.instr(t.template,''#NEXT#'') > 0',
'   and :F4000_REGION_SELECTED = p.id'))
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(91089316514649842)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'Region Template Position #PREVIOUS#'
,p_lov_return_value=>'REGION_TEMPLATE_PREVIOUS'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_PAGE_PLUG_TEMPLATES t,wwv_flow_page_plugs p',
' where p.flow_id = :FB_FLOW_ID',
'   and p.PLUG_TEMPLATE = t.id',
'   and sys.dbms_lob.instr(t.template,''#PREVIOUS#'') > 0',
'   and :F4000_REGION_SELECTED = p.id'))
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(138976531453546871)
,p_lov_disp_sequence=>16
,p_lov_disp_value=>'Right of Interactive Report Search Bar'
,p_lov_return_value=>'RIGHT_OF_IR_SEARCH_BAR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(624319995418870652)
,p_lov_disp_sequence=>17
,p_lov_disp_value=>'Body'
,p_lov_return_value=>'BODY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/button_display_positions_p4314
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1905973109443967318)
,p_lov_name=>'BUTTON_DISPLAY_POSITIONS_P4314'
,p_lov_query=>'.'||wwv_flow_imp.id(1905973109443967318)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475112
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1905973494553967321)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Before Page Title'
,p_lov_return_value=>'LEFT_OF_TITLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1905973847440967326)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'After Page Title'
,p_lov_return_value=>'RIGHT_OF_TITLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1905974225968967326)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Above Region'
,p_lov_return_value=>'ABOVE_BOX'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1905974643088967327)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Top of Region'
,p_lov_return_value=>'TOP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1905975001534967328)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Bottom of Region'
,p_lov_return_value=>'BOTTOM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1905975451050967328)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Top and Bottom of Region'
,p_lov_return_value=>'TOP_AND_BOTTOM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1905975896920967328)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Below Region'
,p_lov_return_value=>'BELOW_BOX'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1905976264022967329)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Region Template #DEFAULT# Position'
,p_lov_return_value=>'TEMPLATE_DEFAULT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1905976604330967330)
,p_lov_disp_sequence=>9.5
,p_lov_disp_value=>'Region Template Position #CHANGE#'
,p_lov_return_value=>'REGION_TEMPLATE_CHANGE'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_PAGE_PLUG_TEMPLATES t,wwv_flow_page_plugs p',
' where (p.flow_id = :FB_FLOW_ID',
'   and p.PLUG_TEMPLATE = t.id',
'   and sys.dbms_lob.instr(t.template,''#CHANGE#'') > 0',
'   and :F4000_P4314_BUTTON_PLUG_ID = p.id) '))
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1905977013205967330)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Region Template Position #CLOSE#'
,p_lov_return_value=>'REGION_TEMPLATE_CLOSE'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_PAGE_PLUG_TEMPLATES t,wwv_flow_page_plugs p',
' where p.flow_id = :FB_FLOW_ID',
'   and p.PLUG_TEMPLATE = t.id',
'   and sys.dbms_lob.instr(t.template,''#CLOSE#'') > 0',
'   and :F4000_P4314_BUTTON_PLUG_ID = p.id'))
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1905977454417967330)
,p_lov_disp_sequence=>10.1
,p_lov_disp_value=>'Region Template Position #COPY#'
,p_lov_return_value=>'REGION_TEMPLATE_COPY'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_PAGE_PLUG_TEMPLATES t,wwv_flow_page_plugs p',
' where p.flow_id = :FB_FLOW_ID',
'   and p.PLUG_TEMPLATE = t.id',
'   and sys.dbms_lob.instr(t.template,''#COPY#'') > 0',
'   and :F4000_P4314_BUTTON_PLUG_ID = p.id'))
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1905977884980967330)
,p_lov_disp_sequence=>10.2
,p_lov_disp_value=>'Region Template Position #CREATE#'
,p_lov_return_value=>'REGION_TEMPLATE_CREATE'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_PAGE_PLUG_TEMPLATES t,wwv_flow_page_plugs p',
' where p.flow_id = :FB_FLOW_ID',
'   and p.PLUG_TEMPLATE = t.id',
'   and sys.dbms_lob.instr(t.template,''#CREATE#'') > 0',
'   and :F4000_P4314_BUTTON_PLUG_ID = p.id'))
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1905978269729967331)
,p_lov_disp_sequence=>10.3
,p_lov_disp_value=>'Region Template Position #CREATE2#'
,p_lov_return_value=>'REGION_TEMPLATE_CREATE2'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_PAGE_PLUG_TEMPLATES t,wwv_flow_page_plugs p',
' where p.flow_id = :FB_FLOW_ID',
'   and p.PLUG_TEMPLATE = t.id',
'   and sys.dbms_lob.instr(t.template,''#CREATE2#'') > 0',
'   and :F4000_P4314_BUTTON_PLUG_ID = p.id'))
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1905978605947967331)
,p_lov_disp_sequence=>10.5
,p_lov_disp_value=>'Region Template Position #DELETE#'
,p_lov_return_value=>'REGION_TEMPLATE_DELETE'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_PAGE_PLUG_TEMPLATES t,wwv_flow_page_plugs p',
' where p.flow_id = :FB_FLOW_ID',
'   and p.PLUG_TEMPLATE = t.id',
'   and sys.dbms_lob.instr(t.template,''#DELETE#'') > 0',
'   and :F4000_P4314_BUTTON_PLUG_ID = p.id'))
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1905979000705967331)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Region Template Position #EDIT#'
,p_lov_return_value=>'REGION_TEMPLATE_EDIT'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_PAGE_PLUG_TEMPLATES t,wwv_flow_page_plugs p',
' where p.flow_id = :FB_FLOW_ID',
'   and p.PLUG_TEMPLATE = t.id',
'   and sys.dbms_lob.instr(t.template,''#EDIT#'') > 0',
'   and :F4000_P4314_BUTTON_PLUG_ID = p.id'))
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1905979400972967331)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'Region Template Position #EXPAND#'
,p_lov_return_value=>'REGION_TEMPLATE_EXPAND'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_PAGE_PLUG_TEMPLATES t,wwv_flow_page_plugs p',
' where p.flow_id = :FB_FLOW_ID',
'   and p.PLUG_TEMPLATE = t.id',
'   and sys.dbms_lob.instr(t.template,''#EXPAND#'') > 0',
'   and :F4000_P4314_BUTTON_PLUG_ID = p.id'))
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1905979808782967331)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>'Region Template Position #HELP#'
,p_lov_return_value=>'REGION_TEMPLATE_HELP'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_PAGE_PLUG_TEMPLATES t,wwv_flow_page_plugs p',
' where p.flow_id = :FB_FLOW_ID',
'   and p.PLUG_TEMPLATE = t.id',
'   and sys.dbms_lob.instr(t.template,''#HELP#'') > 0',
'   and :F4000_P4314_BUTTON_PLUG_ID = p.id'))
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1905980225496967331)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>'Region Template Position #NEXT#'
,p_lov_return_value=>'REGION_TEMPLATE_NEXT'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_PAGE_PLUG_TEMPLATES t,wwv_flow_page_plugs p',
' where p.flow_id = :FB_FLOW_ID',
'   and p.PLUG_TEMPLATE = t.id',
'   and sys.dbms_lob.instr(t.template,''#NEXT#'') > 0',
'   and :F4000_P4314_BUTTON_PLUG_ID = p.id'))
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1905980687897967331)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'Region Template Position #PREVIOUS#'
,p_lov_return_value=>'REGION_TEMPLATE_PREVIOUS'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_PAGE_PLUG_TEMPLATES t,wwv_flow_page_plugs p',
' where p.flow_id = :FB_FLOW_ID',
'   and p.PLUG_TEMPLATE = t.id',
'   and sys.dbms_lob.instr(t.template,''#PREVIOUS#'') > 0',
'   and :F4000_P4314_BUTTON_PLUG_ID = p.id'))
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1905981095145967332)
,p_lov_disp_sequence=>16
,p_lov_disp_value=>'Right of Interactive Report Search Bar'
,p_lov_return_value=>'RIGHT_OF_IR_SEARCH_BAR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1905981421062967332)
,p_lov_disp_sequence=>17
,p_lov_disp_value=>'Body'
,p_lov_return_value=>'BODY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/button_style
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(86073927602789091)
,p_lov_name=>'BUTTON_STYLE'
,p_lov_query=>'.'||wwv_flow_imp.id(86073927602789091)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475116
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88291012122797801)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'HTML Button'
,p_lov_return_value=>'HTML'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88291203722797802)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Template Based Button'
,p_lov_return_value=>'BUTTON_TEMPLATE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88291406025797802)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Image'
,p_lov_return_value=>'IMAGE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/button_tag_attributes
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(159064700887669967)
,p_lov_name=>'BUTTON_TAG_ATTRIBUTES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct TAG_ATTRIBUTES d, tag_attributes r',
'from wwv_flow_step_items',
'where flow_id = :fb_flow_id and DISPLAY_AS = ''BUTTON''',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475117
);
end;
/
prompt --application/shared_components/user_interface/lovs/button_template
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(86577503884170242)
,p_lov_name=>'BUTTON_TEMPLATE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(template_name) d, id r',
'from   wwv_flow_button_templates',
'where  flow_id = :fb_flow_id and',
'       (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by upper(template_name)'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475117
);
end;
/
prompt --application/shared_components/user_interface/lovs/button_template_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(287725102195676672)
,p_lov_name=>'BUTTON_TEMPLATE_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(287725102195676672)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475117
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(287725414983676674)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Normal'
,p_lov_return_value=>'N'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(287725628953676674)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Hot'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/button_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(86072317559786247)
,p_lov_name=>'BUTTON_TYPE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''HTML_BUTTON'') d,''TEXT'' r from dual ',
'union all',
'select wwv_flow_lang.system_message(''TEMPLATE_DRIVEN'') d, ''TEMPLATE'' r from dual where exists (select 1 from wwv_flow_button_templates where flow_id = :FB_FLOW_ID) ',
'union all',
'select initcap(wwv_flow_lang.system_message(''IMAGE'')) d,''IMAGE'' r from dual order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475117
);
end;
/
prompt --application/shared_components/user_interface/lovs/cache_mode_page_and_region
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(22602312173782467)
,p_lov_name=>'CACHE_MODE (PAGE AND REGION)'
,p_lov_query=>'.'||wwv_flow_imp.id(22602312173782467)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475117
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(22602526326782467)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Disabled'
,p_lov_return_value=>'NOCACHE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(22602720414782468)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Enabled'
,p_lov_return_value=>'CACHE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(22602908361782468)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Cache By User'
,p_lov_return_value=>'USER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(672312620996057364)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Cache By Session'
,p_lov_return_value=>'SESSION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/caching_mode
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(225840272947805161)
,p_lov_name=>'CACHING_MODE'
,p_lov_query=>'.'||wwv_flow_imp.id(225840272947805161)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475121
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(225840584522805162)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'For all Users'
,p_lov_return_value=>'ALL_USERS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(225840998538805162)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'By User'
,p_lov_return_value=>'USER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(225841321120805163)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'By Session'
,p_lov_return_value=>'SESSION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/cal_display_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(37322928139444048)
,p_lov_name=>'CAL.DISPLAY_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(37322928139444048)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475121
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(37323215840444057)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Column'
,p_lov_return_value=>'COL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(37323417633444059)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Custom'
,p_lov_return_value=>'CUS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(37323623070444059)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'No Display Value'
,p_lov_return_value=>'NONE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/calendar_item_link_open_in
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(412002629772063159)
,p_lov_name=>'CALENDAR ITEM LINK OPEN IN'
,p_lov_query=>'.'||wwv_flow_imp.id(412002629772063159)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475121
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(412002801622063164)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Same Window'
,p_lov_return_value=>'W'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(412003126365063165)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Popup Window'
,p_lov_return_value=>'P'
);
end;
/
prompt --application/shared_components/user_interface/lovs/calendar_theme_class_id
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(43619531898960304)
,p_lov_name=>'CALENDAR THEME CLASS ID'
,p_lov_query=>'.'||wwv_flow_imp.id(43619531898960304)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475121
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43619801874960319)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Calendar'
,p_lov_return_value=>'1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43621609988960339)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Calendar, Alternative 1'
,p_lov_return_value=>'2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(52331910898784713)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Small Calendar'
,p_lov_return_value=>'3'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43620000338960319)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 1'
,p_lov_return_value=>'4'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43620205626960337)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 2'
,p_lov_return_value=>'5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43620400113960337)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 3'
,p_lov_return_value=>'6'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43620604334960337)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 4'
,p_lov_return_value=>'7'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43620830451960338)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 5'
,p_lov_return_value=>'8'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43621023248960338)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 6'
,p_lov_return_value=>'9'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43621201713960338)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 7'
,p_lov_return_value=>'10'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43621428586960338)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 8'
,p_lov_return_value=>'11'
);
end;
/
prompt --application/shared_components/user_interface/lovs/calendar_date_format
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(597767214994667976)
,p_lov_name=>'CALENDAR_DATE_FORMAT'
,p_lov_query=>'.'||wwv_flow_imp.id(597767214994667976)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475123
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(597767532504667980)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Only'
,p_lov_return_value=>'N'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(597767714309667984)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Date and Time'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/calendar_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(113156910229994686)
,p_lov_name=>'CALENDAR_TYPE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''CONFIRM.STANDARD_CALENDAR'') d, ''S'' r from dual union all',
'select wwv_flow_lang.system_message(''CONFIRM.PARTIAL_REFRESH_CALENDAR'') d, ''A'' r from dual'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475123
);
end;
/
prompt --application/shared_components/user_interface/lovs/cards_layout_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(12784439638072063)
,p_lov_name=>'CARDS_LAYOUT_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(12784439638072063)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475123
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(12785155574072076)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Grid'
,p_lov_return_value=>'GRID'
,p_lov_template=>'#DISPLAY_VALUE#| card-grid'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(12785568359072076)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Float'
,p_lov_return_value=>'FLOAT'
,p_lov_template=>'#DISPLAY_VALUE#| card-float'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(12785968016072076)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Horizontal (Row)'
,p_lov_return_value=>'ROW'
,p_lov_template=>'#DISPLAY_VALUE#| card-row'
);
end;
/
prompt --application/shared_components/user_interface/lovs/catalog_groups
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2707908862132331)
,p_lov_name=>'CATALOG_GROUPS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name as dv, id as rv',
'from WWV_WEB_SRC_CATALOG_GROUPS',
'where security_group_id = :WORKSPACE_ID',
'order by name'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_query_table=>'WWV_WEB_SRC_CATALOG_GROUPS'
,p_return_column_name=>'RV'
,p_display_column_name=>'DV'
,p_group_sort_direction=>'ASC'
,p_default_sort_direction=>'ASC'
,p_version_scn=>72475123
);
end;
/
prompt --application/shared_components/user_interface/lovs/chart_bar_color
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84324431881606062)
,p_lov_name=>'CHART_BAR_COLOR'
,p_lov_query=>'.'||wwv_flow_imp.id(84324431881606062)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475123
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84324600310606063)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Black'
,p_lov_return_value=>'BLACK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84324819442606063)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Blue'
,p_lov_return_value=>'BLUE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84325003884606064)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Brown'
,p_lov_return_value=>'BROWN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84325217038606064)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Green'
,p_lov_return_value=>'GREEN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84325407670606064)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Orange'
,p_lov_return_value=>'ORANGE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84325609277606064)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Purple'
,p_lov_return_value=>'PURPLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84325828072606065)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Red'
,p_lov_return_value=>'RED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84326022893606065)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Yellow'
,p_lov_return_value=>'YELLOW'
);
end;
/
prompt --application/shared_components/user_interface/lovs/chart_label_opts
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84785018266011049)
,p_lov_name=>'CHART_LABEL_OPTS'
,p_lov_query=>'.'||wwv_flow_imp.id(84785018266011049)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475123
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84785213250011049)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Show Bubble'
,p_lov_return_value=>'BUBBLE'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84785432162011050)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Show Value'
,p_lov_return_value=>'VALUE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/chart_link_column
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(193530927208786945)
,p_lov_name=>'CHART_LINK_COLUMN'
,p_lov_query=>'.'||wwv_flow_imp.id(193530927208786945)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475123
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(193531126012786958)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Link to Custom Target'
,p_lov_return_value=>'C'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(193531303307786960)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Use Value of LINK Column'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/chart_query_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2944917074050416)
,p_lov_name=>'CHART_QUERY_OPTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(2944917074050416)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475123
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2945205253050420)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Perform query validation'
,p_lov_return_value=>'PARSE_CHART_QUERY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2945401126050421)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Save query without validation'
,p_lov_return_value=>'IGNORE_CHART_QUERY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/chart_theme
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84770023535917923)
,p_lov_name=>'CHART_THEME'
,p_lov_query=>'.'||wwv_flow_imp.id(84770023535917923)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475123
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84770217422917924)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Look 1'
,p_lov_return_value=>'RED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84770421612917924)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Look 2'
,p_lov_return_value=>'ARG'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84770630757917924)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Look 3'
,p_lov_return_value=>'LOOK_3'
);
end;
/
prompt --application/shared_components/user_interface/lovs/chart_wizard_dial_maxvalue
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(249428101086098299)
,p_lov_name=>'CHART_WIZARD_DIAL_MAXVALUE'
,p_lov_query=>'.'||wwv_flow_imp.id(249428101086098299)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475123
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(249428318833098301)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'100%'
,p_lov_return_value=>'0'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(249457015809140458)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'MAX'
,p_lov_return_value=>'MAX'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(249457621350142006)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'SUM'
,p_lov_return_value=>'SUM'
);
end;
/
prompt --application/shared_components/user_interface/lovs/checkbox_show_page_components
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(145937328496747754)
,p_lov_name=>'CHECKBOX SHOW PAGE COMPONENTS'
,p_lov_query=>'.'||wwv_flow_imp.id(145937328496747754)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475123
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(145937826343747822)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Page Components'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/checkbox_show_shared_components
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(144512500887046057)
,p_lov_name=>'CHECKBOX SHOW SHARED COMPONENTS'
,p_lov_query=>'.'||wwv_flow_imp.id(144512500887046057)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475123
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144512826218046101)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Shared Components'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/checkbox_show_templates
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(152029513350781444)
,p_lov_name=>'CHECKBOX SHOW TEMPLATES'
,p_lov_query=>'.'||wwv_flow_imp.id(152029513350781444)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475123
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(152029929235781496)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Templates'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/checkbox_yes_noprompt
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84718210763776190)
,p_lov_name=>'CHECKBOX_YES_NOPROMPT'
,p_lov_query=>'.'||wwv_flow_imp.id(84718210763776190)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475123
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84718405875776191)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'&nbsp;'
,p_lov_return_value=>'YES'
);
end;
/
prompt --application/shared_components/user_interface/lovs/checkbox_y_noprompt
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84715102189754797)
,p_lov_name=>'CHECKBOX_Y_NOPROMPT'
,p_lov_query=>'.'||wwv_flow_imp.id(84715102189754797)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475123
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84715319258754797)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'&nbsp;'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/check_all
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84334521061621823)
,p_lov_name=>'CHECK_ALL'
,p_lov_query=>'.'||wwv_flow_imp.id(84334521061621823)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475123
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84334731772621824)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'&nbsp;'
,p_lov_return_value=>'CHECK'
);
end;
/
prompt --application/shared_components/user_interface/lovs/column_heading_sort
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(113075615286820438)
,p_lov_name=>'COLUMN_HEADING_SORT'
,p_lov_query=>'.'||wwv_flow_imp.id(113075615286820438)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475123
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(113075923766820443)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Use Column Heading Sorting'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/column_link_checksum_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(106733132624028207)
,p_lov_name=>'COLUMN_LINK_CHECKSUM_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(106733132624028207)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475123
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(106733331539028208)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Application Level - Link reusable by any user'
,p_lov_return_value=>'1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(106733500292028209)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'User Level - Link reusable by current user'
,p_lov_return_value=>'2'
);
end;
/
prompt --application/shared_components/user_interface/lovs/column_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84700223258656794)
,p_lov_name=>'COLUMN_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(84700223258656794)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475123
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84700401229656794)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Derived from query columns'
,p_lov_return_value=>'N'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84700609402656795)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Generic columns'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/column_width_units
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(137868513981838198)
,p_lov_name=>'COLUMN_WIDTH_UNITS'
,p_lov_query=>'.'||wwv_flow_imp.id(137868513981838198)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475123
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(137868804503838258)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Percent'
,p_lov_return_value=>'PERCENTAGE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(137869020870838259)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Point'
,p_lov_return_value=>'POINTS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/comment_mgt
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(131122619933750813)
,p_lov_name=>'COMMENT MGT'
,p_lov_query=>'.'||wwv_flow_imp.id(131122619933750813)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475123
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(131122805830750820)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Delete all comments'
,p_lov_return_value=>'ALL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(131123017423750828)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Delete comments created by a developer'
,p_lov_return_value=>'DEVELOPER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(131123206286750828)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Delete comments by date'
,p_lov_return_value=>'DATE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/component_export_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(377667910269420728)
,p_lov_name=>'COMPONENT EXPORT TYPES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang_dev.builder_message(''COMPONENT_TYPE.''||type_name) display_name,',
'       type_name',
'  from wwv_flow_appl_component_types',
' order by 1'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'TYPE_NAME'
,p_display_column_name=>'DISPLAY_NAME'
,p_group_sort_direction=>'ASC'
,p_default_sort_column_name=>'DISPLAY_NAME'
,p_default_sort_direction=>'ASC'
,p_version_scn=>72475123
);
end;
/
prompt --application/shared_components/user_interface/lovs/component_export_types_no_app_attributes
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(219174618713592113)
,p_lov_name=>'COMPONENT EXPORT TYPES (NO APP ATTRIBUTES)'
,p_lov_query=>'.'||wwv_flow_imp.id(219174618713592113)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475123
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27856632677057884)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Plug-in'
,p_lov_return_value=>'PLUGIN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27863315726204362)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Text Message'
,p_lov_return_value=>'MESSAGES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(42344010960230413)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Data Loading'
,p_lov_return_value=>'DATA LOADING'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(68335292197942905)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Remote Server'
,p_lov_return_value=>'REMOTE SERVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(68335681892942906)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Credential'
,p_lov_return_value=>'CREDENTIAL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88136025596580349)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Report Query'
,p_lov_return_value=>'SHARED QUERY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88136305988584229)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Report Layout'
,p_lov_return_value=>'REPORT LAYOUT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(160795105281345158)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'REST Data Source'
,p_lov_return_value=>'WEB SOURCE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(219174814389592127)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'List'
,p_lov_return_value=>'LIST'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(219175013995592129)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Breadcrumb'
,p_lov_return_value=>'BREADCRUMB'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(219175232752592129)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Button Template'
,p_lov_return_value=>'BUTTON TEMPLATE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(219175403520592129)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Region Template'
,p_lov_return_value=>'REGION TEMPLATE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(219175624120592129)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'List Template'
,p_lov_return_value=>'LIST TEMPLATE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(219175816990592129)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Report Template'
,p_lov_return_value=>'REPORT TEMPLATE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(219176032395592130)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Label Template'
,p_lov_return_value=>'LABEL TEMPLATE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(219176207318592130)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Breadcrumb Template'
,p_lov_return_value=>'BREADCRUMB TEMPLATE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(219176423240592130)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Popup List of Values Template'
,p_lov_return_value=>'POPUP LOV TEMPLATE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(219176631734592130)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Calendar Template'
,p_lov_return_value=>'CALENDAR TEMPLATE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(219176806484592131)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Shortcut'
,p_lov_return_value=>'SHORTCUTS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(219177013573592131)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Page Template'
,p_lov_return_value=>'PAGE TEMPLATE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(219177221576592131)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Page'
,p_lov_return_value=>'PAGE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(219177427540592131)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Tab'
,p_lov_return_value=>'TAB'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(219177604186592131)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'List of Values'
,p_lov_return_value=>'LOV'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(219177807693592132)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Parent Tab'
,p_lov_return_value=>'PARENT TAB'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(219178031878592132)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Navigation Bar Entry'
,p_lov_return_value=>'NAVBAR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(219178207428592132)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Authorization Scheme'
,p_lov_return_value=>'SECURITY SCHEME'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(219178405025592132)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Tree'
,p_lov_return_value=>'TREE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(219178614268592132)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Application Process'
,p_lov_return_value=>'APP PROCESS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(219178830557592133)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Application Item'
,p_lov_return_value=>'APP ITEM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(219179018777592133)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Application Computation'
,p_lov_return_value=>'APP COMPUTATION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(219179226730592133)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Breadcrumb Entry'
,p_lov_return_value=>'BREADCRUMB ENTRY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(219179423538592133)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Web Service'
,p_lov_return_value=>'WEB SERVICE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(219179610668592133)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Authentication Scheme'
,p_lov_return_value=>'AUTH SETUP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(219179805578592134)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Build Option'
,p_lov_return_value=>'BUILD OPTION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(683805038458933638)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Application Setting'
,p_lov_return_value=>'APP SETTING'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(727757877803458898)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Application Access Control Role'
,p_lov_return_value=>'APP ACL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/computation_item
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(86610204202293298)
,p_lov_name=>'COMPUTATION_ITEM'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''APPLICATION'')||'': ''||name d, name v',
'  from wwv_flow_items',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' union all',
'select wwv_flow_lang.system_message(''PAGE'')||'': ''||flow_step_id||'' ''||name d, name v',
'  from wwv_flow_step_items',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475124
);
end;
/
prompt --application/shared_components/user_interface/lovs/comp_grp_component_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(5087092943835745)
,p_lov_name=>'COMP_GRP_COMPONENT_TYPES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case when type_name = ''PAGE'' then',
'           wwv_flow_lang_dev.builder_message(''PAGE_PATTERN'')',
'       else',
'           wwv_flow_lang_dev.builder_message(''COMPONENT_TYPE.''||type_name)',
'       end display_val,',
'       type_name return_val',
'  from wwv_flow_appl_component_types app_comp',
' where app_comp.type_name in ( ''APP_ITEM'',',
'                               ''APP_PROCESS'',',
'                               ''APP_COMPUTATION'',',
'                               ''APP_SETTING'',',
'                               ''BUILD_OPTION'',',
'                               ''LIST'',',
'                               ''SEARCH_CONFIG'',',
'                               ''DATA_LOAD'',',
'                               ''WEB_SOURCE'',',
'                               ''AUTHENTICATION'',',
'                               ''AUTHORIZATION'',',
'                               ''APP_ACL'',',
'                               ''EMAIL_TEMPLATE'',',
'                               ''LOV'',',
'                               ''PLUGIN'',',
'                               ''PLUGIN_SETTINGS'',',
'                               ''SHORTCUT'',',
'                               ''MAP_BACKGROUND'',',
'                               ''REPORT_LAYOUT'',',
'                               ''MESSAGE'' )',
'     or ( app_comp.type_name = ''PAGE'' ',
'          and ( select wwv_flow_platform.get_preference(''ENABLE_PAGE_PATTERNS'') ',
'                  from sys.dual ) = ''Y'' )',
'order by 1'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_return_column_name=>'RETURN_VAL'
,p_display_column_name=>'DISPLAY_VAL'
,p_group_sort_direction=>'ASC'
,p_default_sort_direction=>'ASC'
,p_version_scn=>196623666
);
end;
/
prompt --application/shared_components/user_interface/lovs/condition_control_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(179476200494904933)
,p_lov_name=>'CONDITION CONTROL TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(179476200494904933)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475124
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(179477608235904943)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Branch'
,p_lov_return_value=>'BRANCH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(179492924267978066)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Button'
,p_lov_return_value=>'BUTTON'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(179477001828904942)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Computation'
,p_lov_return_value=>'COMPUTATION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(179476801795904940)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Item'
,p_lov_return_value=>'ITEM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(179477429719904942)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Process'
,p_lov_return_value=>'PROCESS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(179476625958904939)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Region'
,p_lov_return_value=>'REGION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(179477227849904942)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Validation'
,p_lov_return_value=>'VALIDATION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/condition_check
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(435017812694464482)
,p_lov_name=>'CONDITION_CHECK'
,p_lov_query=>'.'||wwv_flow_imp.id(435017812694464482)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475124
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(435018014601464492)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Do not validate code (parse code at runtime only).'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/consolidate_template_names_returning_id
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(94009001670849130)
,p_lov_name=>'CONSOLIDATE_TEMPLATE_NAMES RETURNING ID'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select page_plug_template_name d, id',
'from wwv_flow_page_plug_templates',
'where flow_id = :FB_FLOW_ID and ',
'THEME_ID = (select theme_id from wwv_flows where id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''REGION''',
'union all',
'select name d, id ',
'from WWV_FLOW_TEMPLATES ',
'where flow_id = :FB_FLOW_ID and ',
'THEME_ID = (select theme_id from wwv_flows where id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''PAGE''',
'union all',
'select template_name d, id',
'from wwv_flow_field_templates f',
'where ',
'f.flow_id = :FB_FLOW_ID and ',
'THEME_ID = (select theme_id from wwv_flows where id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''LABEL''',
'union all',
'select ',
'l.list_template_name d, l.id',
'from ',
'wwv_flow_list_templates l',
'where ',
'l.flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flows where id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''LIST''',
'union all',
'select name d, id',
'from wwv_flow_cal_templates',
'where flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flows where id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''CALENDAR''',
'union all',
'select name d, id',
'from wwv_flow_menu_templates',
'where flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flows where id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''MENU''',
'union all',
'select template_name d, id',
'from WWV_FLOW_BUTTON_TEMPLATES',
'where flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flows where id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''BUTTON''',
'union all',
'select ''* ''||wwv_flow_lang.system_message(''HTML_BUTTON'') d, -1 id',
'from dual',
'where :P708_TEMPLATE_TYPE = ''BUTTON''',
'union all',
'select ROW_TEMPLATE_NAME d, id',
'from WWV_FLOW_ROW_TEMPLATES',
'where flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flows where id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''REPORT''',
'union all',
'select ''* ''||wwv_flow_lang.system_message(''REGION_TEMPLATES_NO_TEMPLATE'') d, -1 id',
'from dual',
'where :P708_TEMPLATE_TYPE in (''PAGE'',''REGION'')'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475124
);
end;
/
prompt --application/shared_components/user_interface/lovs/content_delivery_network
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(16362507680404890)
,p_lov_name=>'CONTENT DELIVERY NETWORK'
,p_lov_query=>'.'||wwv_flow_imp.id(16362507680404890)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475124
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16362719475404893)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Google'
,p_lov_return_value=>'GOOGLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16362912968404893)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Microsoft'
,p_lov_return_value=>'MICROSOFT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16363119553404893)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'jQuery'
,p_lov_return_value=>'JQUERY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/content_disposition
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(137375920403903467)
,p_lov_name=>'CONTENT_DISPOSITION'
,p_lov_query=>'.'||wwv_flow_imp.id(137375920403903467)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475124
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(137376221863903468)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Attachment'
,p_lov_return_value=>'ATTACHMENT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(137376416435903468)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Inline'
,p_lov_return_value=>'INLINE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/copy_asynch_action_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(108520683650237775)
,p_lov_name=>'COPY ASYNCH ACTION OPTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(108520683650237775)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475124
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108520999008237765)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Asynchronous Action in this application'
,p_lov_return_value=>'SAME'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108521351556237764)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Asynchronous Action in another application'
,p_lov_return_value=>'DIFF'
);
end;
/
prompt --application/shared_components/user_interface/lovs/copy_list_option
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(231048823449529621)
,p_lov_name=>'COPY LIST OPTION'
,p_lov_query=>'.'||wwv_flow_imp.id(231048823449529621)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475124
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(231049006115529624)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'List in this application'
,p_lov_return_value=>'SAME'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(231049208911529628)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'List in another application'
,p_lov_return_value=>'DIFF'
);
end;
/
prompt --application/shared_components/user_interface/lovs/copy_lists
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(10919919806296646)
,p_lov_name=>'COPY LISTS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id ',
'  from wwv_flow_lists ',
' where flow_id                 = :FB_FLOW_ID',
'   and security_group_id       = :WORKSPACE_ID',
'   and id                      <> :P477_COPY_LIST_FROM',
'   and nvl(list_type,''STATIC'') = ''STATIC''',
'   and reference_id            is null',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475124
);
end;
/
prompt --application/shared_components/user_interface/lovs/copy_page_option
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(200992128346618114)
,p_lov_name=>'COPY_PAGE_OPTION'
,p_lov_query=>'.'||wwv_flow_imp.id(200992128346618114)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475124
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(200992325093618118)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Page in this application'
,p_lov_return_value=>'SAME'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(200992505592618121)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Page in another application'
,p_lov_return_value=>'DIFF'
);
end;
/
prompt --application/shared_components/user_interface/lovs/copy_sc_option
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(201061511357162008)
,p_lov_name=>'COPY_SC_OPTION'
,p_lov_query=>'.'||wwv_flow_imp.id(201061511357162008)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475124
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(201061731765162010)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Do Not Copy'
,p_lov_return_value=>'NO'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(201061913763162012)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Copy'
,p_lov_return_value=>'COPY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(201062131688162012)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Use Existing'
,p_lov_return_value=>'EXISTING'
);
end;
/
prompt --application/shared_components/user_interface/lovs/copy_source
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(9000141896148406)
,p_lov_name=>'COPY_SOURCE'
,p_lov_query=>'.'||wwv_flow_imp.id(9000141896148406)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475124
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9000407308148423)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'This Application'
,p_lov_return_value=>'THIS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9000858936148423)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Other Application'
,p_lov_return_value=>'OTHER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_application_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(59753909083040661)
,p_lov_name=>'CREATE APPLICATION OPTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(59753909083040661)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475124
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(40660315892684513)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'New Application'
,p_lov_return_value=>'DBAPP'
,p_lov_template=>'#DISPLAY_VALUE#| gi-icon-app-builder'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84640459791812785)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'From a Spreadsheet'
,p_lov_return_value=>'SPREADSHEET'
,p_lov_template=>'#DISPLAY_VALUE#| gi-icon-create-app-websheet'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(40660901478689821)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Productivity App'
,p_lov_return_value=>'PKGAPP'
,p_lov_template=>'#DISPLAY_VALUE#| gi-icon-create-app-pkg-apps'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_application_page_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(139812219112455338)
,p_lov_name=>'CREATE APPLICATION PAGE TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(139812219112455338)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475124
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(139812423391455342)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Add blank page to application'
,p_lov_return_value=>'BLANK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(139813830194458580)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Add a report'
,p_lov_return_value=>'REPORT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(386128979761969541)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Add a reflow table report'
,p_lov_return_value=>'REFLOWTABLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(386129452191973929)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Add a column toggle report'
,p_lov_return_value=>'COLUMNTOGGLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(139812618398455343)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Add a report with an edit form on a second page'
,p_lov_return_value=>'REPORTANDFORM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(228985906117785632)
,p_lov_disp_sequence=>25
,p_lov_disp_value=>'Add a list view with an edit form on a second page'
,p_lov_return_value=>'LISTVIEWANDFORM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(139812820281455343)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Add an editable interactive grid'
,p_lov_return_value=>'TABULARFORM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(139813027803455343)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Add a form with insert, update and delete'
,p_lov_return_value=>'FORM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(111750431837325937)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Add a single page master detail'
,p_lov_return_value=>'MASTERDETAIL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615632927102875004)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Add a Chart'
,p_lov_return_value=>'CHART'
,p_lov_disp_cond=>'(:APP_USER = ''HILARY'')'
,p_lov_disp_cond2=>'HILARY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(236338032309717022)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Add a list view'
,p_lov_return_value=>'LISTVIEW'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_cal_type2
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(637546843740095966)
,p_lov_name=>'CREATE CAL TYPE2'
,p_lov_query=>'.'||wwv_flow_imp.id(637546843740095966)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475124
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(637547104132095967)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Legacy Calendar'
,p_lov_return_value=>'CALENDAR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(637547448261095970)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Calendar'
,p_lov_return_value=>'CSSCALENDAR'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_install_script_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(4579300425024699)
,p_lov_name=>'CREATE INSTALL SCRIPT OPTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(4579300425024699)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475125
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4579506061024700)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Create from Scratch'
,p_lov_return_value=>'SCRATCH'
,p_lov_template=>'#DISPLAY_VALUE#| icon-page-blank'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4579908206024701)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Create from File'
,p_lov_return_value=>'FILE'
,p_lov_template=>'#DISPLAY_VALUE#| icon-page-blank'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(534084776604619224)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Create from Database Object'
,p_lov_return_value=>'DB'
,p_lov_template=>'#DISPLAY_VALUE#| icon-database-object'
,p_lov_disp_cond_type=>'VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST'
,p_lov_disp_cond=>'P850_MODE'
,p_lov_disp_cond2=>'UPGRADE:DEINSTALL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1602302547430022)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Data Package'
,p_lov_return_value=>'DATA'
,p_lov_template=>'#DISPLAY_VALUE#| icon-util-apex-views'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':P850_MODE not in (''UPGRADE'',''DEINSTALL'')'
,p_lov_disp_cond2=>'PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_multiple_items_p256
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(162048107844243840)
,p_lov_name=>'CREATE MULTIPLE ITEMS P256'
,p_lov_query=>'.'||wwv_flow_imp.id(162048107844243840)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475125
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(162048426183243882)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Text Field'
,p_lov_return_value=>'TEXT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(162048628552243882)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Textarea'
,p_lov_return_value=>'TEXTAREA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(162048825522243882)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Checkbox'
,p_lov_return_value=>'CHECKBOX'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(162049013715243883)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Radio Group'
,p_lov_return_value=>'RADIOGROUP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(162049424562243883)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Hidden'
,p_lov_return_value=>'HIDDEN_PROTECTED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_app_auth_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(175155625648607577)
,p_lov_name=>'CREATE.APP.AUTH.OPTIONS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, v from (',
'select ',
'  wwv_flow_lang.system_message(''CREATE_FLOW.CLOUD_IDM'') d ,''CLOUD_IDM'' v from dual',
'where wwv_flow_authentication_dev.get_internal_authentication = ''CLOUD_IDM''',
'union all',
'select ',
'  wwv_flow_lang.system_message(''AUTHENTICATION_NAME.NATIVE_APEX_ACCOUNTS'')d ,:PRODUCT_NAME v from dual',
'union all',
'select ',
'  wwv_flow_lang.system_message(''CREATE_FLOW.SSO'') d ,''SSO'' v from dual',
'where wwv_flow_authentication_dev.can_use_sso_yn = ''Y''',
'union all',
'select ',
'  wwv_flow_lang.system_message(''CREATE_FLOW.DBACCOUNT'') d,''DBACCOUNT'' v',
'from dual',
'where wwv_flow_authentication_dev.get_internal_authentication <> ''CLOUD_IDM''',
'union all',
'select ',
'  wwv_flow_lang.system_message(''CREATE_FLOW.NO_AUTH'') d,''DATABASE'' v from dual',
')'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475125
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_cal_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(16354319751573808)
,p_lov_name=>'CREATE.CAL.TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(16354319751573808)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475125
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(389128299383656476)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Calendar'
,p_lov_return_value=>'CSSCALENDAR'
,p_lov_template=>'#DISPLAY_VALUE#|NATIVE-CSS-CALENDAR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16354825012573816)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Legacy Calendar'
,p_lov_return_value=>'CALENDAR'
,p_lov_template=>'#DISPLAY_VALUE#|NATIVE-CALENDAR'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_flow_auth_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(52256503410339865)
,p_lov_name=>'CREATE.FLOW.AUTH.OPTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(52256503410339865)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475125
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(52257006525339871)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Oracle APEX Authentication'
,p_lov_return_value=>'HTML DB'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(52257200649339871)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'No Authentication'
,p_lov_return_value=>'DATABASE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_region_chart_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(59940502744006894)
,p_lov_name=>'CREATE.REGION.CHART.TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(59940502744006894)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475125
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(59940825061006894)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'HTML Chart<br /><a href="f?p=4000:4016:&SESSION.::::P4016_SOURCE_TYPE:SIMPLE_CHART"><img src="#IMAGE_PREFIX#wwv_example_chart.gif" alt=HTML Chart" height="115" width="140"></a>'
,p_lov_return_value=>'SIMPLE_CHART'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_tabs
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84948109242907300)
,p_lov_name=>'CREATE.TABS'
,p_lov_query=>'.'||wwv_flow_imp.id(84948109242907300)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475125
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84948313600907300)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'No Tabs'
,p_lov_return_value=>'NO_TABS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84948509310907301)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'One Level of Tabs'
,p_lov_return_value=>'SINGLE_LEVEL_TABS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84948706961907301)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Two Levels of Tabs'
,p_lov_return_value=>'TWO_LEVEL_TABS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_template_opts
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(88108326304250090)
,p_lov_name=>'CREATE.TEMPLATE.OPTS'
,p_lov_query=>'.'||wwv_flow_imp.id(88108326304250090)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475125
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88108531928250090)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Choose one from the &PRODUCT_NAME. repository'
,p_lov_return_value=>'DEFAULT'
,p_lov_disp_cond_type=>'NEVER'
,p_lov_disp_cond=>'161'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88108720351250091)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'From Scratch'
,p_lov_return_value=>'BLANK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88108928823250091)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'As a Copy of an Existing Template'
,p_lov_return_value=>'COPY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_app_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(238931611476537918)
,p_lov_name=>'CREATE_APP_OPTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(238931611476537918)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475125
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(238931830914537923)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Start from scratch'
,p_lov_return_value=>'SCRATCH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(24117720307079483)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Include Home Page'
,p_lov_return_value=>'INCLUDE_HOME'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(238932009935537927)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Use previously created application model'
,p_lov_return_value=>'MODEL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_button_loc
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84893616038549667)
,p_lov_name=>'CREATE_BUTTON_LOC'
,p_lov_query=>'.'||wwv_flow_imp.id(84893616038549667)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475125
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84894000323549667)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Create a button in a region position'
,p_lov_return_value=>'REGION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84893831137549667)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Create a button displayed among this region''s items'
,p_lov_return_value=>'ITEM'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_edit_build_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84363508688675017)
,p_lov_name=>'CREATE_EDIT_BUILD_OPTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(84363508688675017)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475125
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84363715344675017)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'All Options'
,p_lov_return_value=>'ALL_OPTIONS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84363903362675018)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Excluded Options'
,p_lov_return_value=>'EXCLUDED_OPTIONS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84364127083675018)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Included Options'
,p_lov_return_value=>'INCLUDED_OPTIONS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_page_wiz_report_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(229526604906633214)
,p_lov_name=>'CREATE_PAGE_WIZ_REPORT_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(229526604906633214)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475125
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(229526903566633217)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Interactive Report'
,p_lov_return_value=>'INTERACTIVE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(229527314006633219)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Classic Report'
,p_lov_return_value=>'CLASSIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(229527755815633220)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Report on Web Service'
,p_lov_return_value=>'WEBSERVICE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(246582799020000524)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Interactive Grid'
,p_lov_return_value=>'GRID'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2492748530737796)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Faceted Search'
,p_lov_return_value=>'FACETED_SEARCH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4700607937986792)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'Cards'
,p_lov_return_value=>'CARD'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1500806028588547)
,p_lov_disp_sequence=>25
,p_lov_disp_value=>'Map'
,p_lov_return_value=>'MAP_REGION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4501933264264256)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Smart Filters'
,p_lov_return_value=>'SMART_FILTERS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/create_ws_auth_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(460639712672013129)
,p_lov_name=>'CREATE_WS_AUTH_OPTIONS'
,p_reference_id=>174618728240220381
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, v from (',
'select ',
'  :product_name||''<br />''||',
'  ''<img src="#IMAGE_PREFIX#htmldb/builder/admin_page_xl.gif" class="htmldbGreenIcon" width="140" height="115" >'' d ,''HTML DB'' v from dual',
'union all',
'select ',
'  wwv_flow_lang.system_message(''CREATE_FLOW.NO_AUTH'')||''<br />''||',
'  ''<img src="#IMAGE_PREFIX#htmldb/builder/opendoor_page_xl.gif" class="htmldbGreenIcon" width="140" height="115" >'' d,''DATABASE'' v from dual',
'union all',
'select ',
'  wwv_flow_lang.system_message(''CREATE_FLOW.DBACCOUNT'')||''<br />''||',
'  ''<img src="#IMAGE_PREFIX#htmldb/builder/dbauth_page_xl.gif" class="htmldbGreenIcon" width="140" height="115" >'' d,''DBACCOUNT'' v from dual)'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/credentials_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(154078822199034715)
,p_lov_name=>'CREDENTIALS_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(154078822199034715)||'.'
,p_location=>'STATIC'
,p_version_scn=>2731523
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(154079142215034718)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Basic Authentication'
,p_lov_return_value=>'BASIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(154079510909034719)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'OAuth2 Client Credentials'
,p_lov_return_value=>'OAUTH2_CLIENT_CREDENTIALS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(549452051899386464)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'JSON Web Token'
,p_lov_return_value=>'JWT'
,p_required_patch=>wwv_flow_imp.id(170786031904296885)
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1341457865820980)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'OCI Native Authentication'
,p_lov_return_value=>'OCI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1701546541659999)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Certificate/Private Key Pair'
,p_lov_return_value=>'CERTIFICATE_PAIR'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>'wwv_flow_platform.get_preference(''SAML_ENABLED'')=''Y'''
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1800745749591458)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'HTTP Header'
,p_lov_return_value=>'HTTP_HEADER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1801015961593233)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'URL Query String'
,p_lov_return_value=>'HTTP_QUERY_STRING'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3000265063559897)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Key Pair'
,p_lov_return_value=>'KEY_PAIR'
,p_lov_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_lov_disp_cond=>'1620,1621,2160'
);
end;
/
prompt --application/shared_components/user_interface/lovs/css_categories
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2672426264055159)
,p_lov_name=>'CSS CATEGORIES'
,p_lov_query=>'.'||wwv_flow_imp.id(2672426264055159)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475125
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2672601779055159)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Absolute Sizes'
,p_lov_return_value=>'ABSOLUTE SIZES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2672821707055159)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Relative Sizes'
,p_lov_return_value=>'RELATIVE SIZES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2686105588181625)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Anchor Tags'
,p_lov_return_value=>'ANCHOR TAGS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/current_page_only
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(574892035638384809)
,p_lov_name=>'CURRENT PAGE ONLY'
,p_lov_query=>'.'||wwv_flow_imp.id(574892035638384809)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475125
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(574892359277384813)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Current page only'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/customizable_opts
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84780904844988257)
,p_lov_name=>'CUSTOMIZABLE_OPTS'
,p_lov_query=>'.'||wwv_flow_imp.id(84780904844988257)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475125
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84781129653988258)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Customizable and Not Shown By Default'
,p_lov_return_value=>'2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84781315535988258)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Customizable and Shown By Default'
,p_lov_return_value=>'1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84781523668988259)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Not Customizable By End Users'
,p_lov_return_value=>'0'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dashboard_chart_aggregate
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(657384343573981564)
,p_lov_name=>'DASHBOARD_CHART_AGGREGATE'
,p_lov_query=>'.'||wwv_flow_imp.id(657384343573981564)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475125
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(657384641982981565)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Column Value'
,p_lov_return_value=>'COLVALUE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(657385056655981565)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Sum'
,p_lov_return_value=>'SUM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(657385482368981565)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Count'
,p_lov_return_value=>'COUNT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dashboard_chart_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(657346995959744232)
,p_lov_name=>'DASHBOARD_CHART_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(657346995959744232)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475125
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(657347261583744232)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Area'
,p_lov_return_value=>'area'
,p_lov_template=>'<span class="a-Icon icon-region-chart-area" aria-hidden="true"></span><span class="u-VisuallyHidden">#DISPLAY_VALUE#</span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(657347677252744233)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Bar'
,p_lov_return_value=>'bar'
,p_lov_template=>'<span class="a-Icon icon-region-chart-bar" aria-hidden="true"></span><span class="u-VisuallyHidden">#DISPLAY_VALUE#</span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(657350049661744234)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Line'
,p_lov_return_value=>'line'
,p_lov_template=>'<span class="a-Icon icon-region-chart-line" aria-hidden="true"></span><span class="u-VisuallyHidden">#DISPLAY_VALUE#</span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(657350886473744235)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Pie'
,p_lov_return_value=>'pie'
,p_lov_template=>'<span class="a-Icon icon-region-chart-pie" aria-hidden="true"></span><span class="u-VisuallyHidden">#DISPLAY_VALUE#</span>'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dashboard_layout
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(42907758825155833)
,p_lov_name=>'DASHBOARD_LAYOUT'
,p_lov_query=>'.'||wwv_flow_imp.id(42907758825155833)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475125
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(42908060078155834)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Primary and 2 secondary charts'
,p_lov_return_value=>'PRIMARY_2_SECONDARY'
,p_lov_template=>'#DISPLAY_VALUE#| dashboard-1-top-2-bottom'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(42908446519155834)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Grid of 4 charts'
,p_lov_return_value=>'4_GRIDS'
,p_lov_template=>'#DISPLAY_VALUE#| dashboard-2-top-2-bottom'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(42908853030155834)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Primary and 3 secondary charts'
,p_lov_return_value=>'PRIMARY_3_SECONDARY'
,p_lov_template=>'#DISPLAY_VALUE#| dashboard-1-top-3-bottom'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(49787787520832477)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Grid of 6 charts'
,p_lov_return_value=>'6_GRIDS'
,p_lov_template=>'#DISPLAY_VALUE#| dashboard-3-top-3-bottom'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_load_case_sensitivity_option
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(15543021487067885)
,p_lov_name=>'DATA LOAD CASE SENSITIVITY OPTION'
,p_lov_query=>'.'||wwv_flow_imp.id(15543021487067885)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475125
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15543516355067889)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'No'
,p_lov_return_value=>'N'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15543328204067888)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Yes'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_load_skip_validation
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(380391855980609161)
,p_lov_name=>'DATA LOAD SKIP VALIDATION'
,p_lov_query=>'.'||wwv_flow_imp.id(380391855980609161)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475125
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(380392176743609168)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'No'
,p_lov_return_value=>'N'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(380392454037609170)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Yes'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_load_table_names
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(371957315073004609)
,p_lov_name=>'DATA LOAD TABLE NAMES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select TABLE_NAME display_value, TABLE_NAME return_value ',
'from WWV_FLOW_LOAD_TABLES',
'where name = :P1801_NAME order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475125
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_loading_rules_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(141003727830690827)
,p_lov_name=>'DATA LOADING RULES TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(141003727830690827)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475125
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(141004022216690828)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'To Upper Case'
,p_lov_return_value=>'TO_UPPER_CASE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(141004200887690829)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'To Lower Case'
,p_lov_return_value=>'TO_LOWER_CASE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(141004413247690829)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Replace'
,p_lov_return_value=>'REPLACE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(141004630986690829)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Trim'
,p_lov_return_value=>'TRIM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(675452628395802315)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Left Trim'
,p_lov_return_value=>'LTRIM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(675463400475803720)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Right Trim'
,p_lov_return_value=>'RTRIM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(141004815818690829)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Single Whitespace'
,p_lov_return_value=>'SINGLE_WHITESPACES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(141005014039690829)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'PLSQL Expression'
,p_lov_return_value=>'PLSQL_EXPRESSION'
,p_required_patch=>-wwv_flow_imp.id(170786031904296885)
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(141005230162690829)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Regular Expression'
,p_lov_return_value=>'REGULAR_EXPRESSION'
,p_required_patch=>wwv_flow_imp.id(170786031904296885)
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(13800125404733346)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'PLSQL Function Body'
,p_lov_return_value=>'PLSQL_FUNCTION_BODY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(13800313005733348)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'SQL Query (return single value)'
,p_lov_return_value=>'SQL_QUERY_SINGLE_VALUE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(13800507980733349)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'SQL Query (return colon separated value)'
,p_lov_return_value=>'SQL_QUERY_SEMI_COLON'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_loading_tables_list
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(15574010985556882)
,p_lov_name=>'DATA LOADING TABLES LIST'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select TABLE_NAME display_value, ID return_value ',
'from WWV_FLOW_LOAD_TABLES',
'where flow_id = :fb_flow_id',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475125
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_load_create_method
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(3313626961776680)
,p_lov_name=>'DATA.LOAD.CREATE_METHOD'
,p_lov_query=>'.'||wwv_flow_imp.id(3313626961776680)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475125
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3313925521776688)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'From scratch'
,p_lov_return_value=>'CREATE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3314383794776689)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'As copy of an existing Data Load Definition'
,p_lov_return_value=>'COPY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_load_csv_col_delimiter
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1963861252255121)
,p_lov_name=>'DATA.LOAD.CSV_COL_DELIMITER'
,p_lov_query=>'.'||wwv_flow_imp.id(1963861252255121)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475125
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1964152277255145)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>','
,p_lov_return_value=>','
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1964578744255147)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>';'
,p_lov_return_value=>';'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1964926636255147)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'|'
,p_lov_return_value=>'|'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1965387007255150)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'#'
,p_lov_return_value=>'#'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1965775882255150)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'tab'
,p_lov_return_value=>'tab'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_load_csv_enclosed_by
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1966044064255150)
,p_lov_name=>'DATA.LOAD.CSV_ENCLOSED_BY'
,p_lov_query=>'.'||wwv_flow_imp.id(1966044064255150)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475125
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1966448886255152)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'None'
,p_lov_return_value=>'None'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1966850775255152)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'"'
,p_lov_return_value=>'"'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1967240441255152)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>''''
,p_lov_return_value=>''''
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_load_data_source_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2505800285473362)
,p_lov_name=>'DATA.LOAD.DATA_SOURCE_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(2505800285473362)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475125
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2506199905473375)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'File'
,p_lov_return_value=>'FILE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2506506206473376)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Paste Delimited Data'
,p_lov_return_value=>'TEXT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_load_error_handling
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2102956113429319)
,p_lov_name=>'DATA.LOAD.ERROR_HANDLING'
,p_lov_query=>'.'||wwv_flow_imp.id(2102956113429319)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475125
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2103697193429319)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Ignore'
,p_lov_return_value=>'IGNORE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2103238683429319)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Stop'
,p_lov_return_value=>'ABORT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2104081805429319)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Log Error into Collection'
,p_lov_return_value=>'LOG_ROWS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4800818508627308)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>'Log into Error Log'
,p_lov_return_value=>'ERROR_LOG'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'P1820_TARGET_TYPE'
,p_lov_disp_cond2=>'TABLE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_load_first_line
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1311667928909742)
,p_lov_name=>'DATA.LOAD.FIRST_LINE'
,p_lov_query=>'.'||wwv_flow_imp.id(1311667928909742)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475125
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1311961412909759)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'First line contains headers'
,p_lov_return_value=>'HEADERS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_load_method
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2101544010414427)
,p_lov_name=>'DATA.LOAD.METHOD'
,p_lov_query=>'.'||wwv_flow_imp.id(2101544010414427)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475129
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2102263743414445)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Append'
,p_lov_return_value=>'APPEND'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2101835504414444)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Merge'
,p_lov_return_value=>'MERGE'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'P1820_TARGET_TYPE'
,p_lov_disp_cond2=>'TABLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2102647126414445)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Replace'
,p_lov_return_value=>'REPLACE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_load_sample_source_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1805213661837379)
,p_lov_name=>'DATA.LOAD.SAMPLE_SOURCE_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(1805213661837379)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475129
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1805549653837381)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Upload a File'
,p_lov_return_value=>'FILE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1805939151837382)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Copy and Paste'
,p_lov_return_value=>'COPY_PASTE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_load_selector_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(5203249727555533)
,p_lov_name=>'DATA.LOAD.SELECTOR_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(5203249727555533)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475129
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(5203574623555536)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Name'
,p_lov_return_value=>'NAME'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(5203977449555537)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Sequence'
,p_lov_return_value=>'SEQ'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(580688454483788977)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Regular Expression'
,p_lov_return_value=>'REGEXP'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_load_target_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1633774479940540)
,p_lov_name=>'DATA.LOAD.TARGET_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(1633774479940540)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475129
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1634008299940542)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Table'
,p_lov_return_value=>'TABLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1634440835940544)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Collection'
,p_lov_return_value=>'COLLECTION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_load_transform_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(4818478622110870)
,p_lov_name=>'DATA.LOAD.TRANSFORM_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(4818478622110870)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475129
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4818717517110876)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'SQL Expression'
,p_lov_return_value=>'SQL_EXPRESSION'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4819193073110876)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'SQL Query (return single value)'
,p_lov_return_value=>'SQL_QUERY'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4819525559110876)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Left Trim'
,p_lov_return_value=>'LTRIM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4819919107110877)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Right Trim'
,p_lov_return_value=>'RTRIM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4820398208110877)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Trim'
,p_lov_return_value=>'TRIM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4820732892110877)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Replace'
,p_lov_return_value=>'REPLACE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4821110204110877)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'To Lower Case'
,p_lov_return_value=>'LOWER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4821569297110877)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'To Upper Case'
,p_lov_return_value=>'UPPER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4821998789110877)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Null If'
,p_lov_return_value=>'NULLIF'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4822345396110877)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Regular Expression Replace'
,p_lov_return_value=>'REGEXP_REPLACE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4822789377110878)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Regular Expression Null If'
,p_lov_return_value=>'REGEXP_NULLIF'
);
end;
/
prompt --application/shared_components/user_interface/lovs/database_action_button_lov
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(147433904650386326)
,p_lov_name=>'DATABASE_ACTION BUTTON LOV'
,p_lov_query=>'.'||wwv_flow_imp.id(147433904650386326)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475129
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(147434227021386334)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'SQL INSERT action'
,p_lov_return_value=>'INSERT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(147434419098386340)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'SQL UPDATE action'
,p_lov_return_value=>'UPDATE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(147434607832386340)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'SQL DELETE action'
,p_lov_return_value=>'DELETE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_profile_col_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(242159593404725778)
,p_lov_name=>'DATA_PROFILE_COL_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(242159593404725778)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475130
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(242159828107725785)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Data'
,p_lov_return_value=>'DATA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4815028055049796)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Lookup'
,p_lov_return_value=>'LOOKUP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(242160239919725788)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'SQL Expression'
,p_lov_return_value=>'SQL_EXPRESSION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4815374705052172)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'SQL Query (return single value)'
,p_lov_return_value=>'SQL_QUERY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_profile_data_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(225929676126476839)
,p_lov_name=>'DATA_PROFILE_DATA_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(225929676126476839)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475130
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(225929903268476840)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'VARCHAR2'
,p_lov_return_value=>'VARCHAR2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(225930368549476840)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'NUMBER'
,p_lov_return_value=>'NUMBER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(225930744436476841)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'DATE'
,p_lov_return_value=>'DATE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(225931138522476841)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'TIMESTAMP'
,p_lov_return_value=>'TIMESTAMP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(225931522008476841)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'TIMESTAMP WITH LOCAL TIME ZONE'
,p_lov_return_value=>'TIMESTAMP WITH LOCAL TIME ZONE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(225931923485476841)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'TIMESTAMP WITH TIME ZONE'
,p_lov_return_value=>'TIMESTAMP WITH TIME ZONE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(249232043458816550)
,p_lov_disp_sequence=>16
,p_lov_disp_value=>'CLOB'
,p_lov_return_value=>'CLOB'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1515035473844796)
,p_lov_disp_sequence=>18
,p_lov_disp_value=>'BLOB'
,p_lov_return_value=>'BLOB'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1700989732317797)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Geometry (SDO_GEOMETRY)'
,p_lov_return_value=>'SDO_GEOMETRY'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>'wwv_flow_db_version.c_has_locator'
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1731316531374625)
,p_lov_disp_sequence=>21
,p_lov_disp_value=>'Array'
,p_lov_return_value=>'ARRAY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(263573975956906615)
,p_lov_disp_sequence=>26
,p_lov_disp_value=>'JSON Document'
,p_lov_return_value=>'DOCUMENT_FRAGMENT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/data_profile_date_format_masks
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(225940310284555905)
,p_lov_name=>'DATA_PROFILE_DATE_FORMAT_MASKS'
,p_lov_query=>'.'||wwv_flow_imp.id(225940310284555905)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475130
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(225940649643555906)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'2016-12-01'
,p_lov_return_value=>'YYYY-MM-DD'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(225941017139555907)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'2016-12-01T20:00:00'
,p_lov_return_value=>'YYYY-MM-DD"T"HH24:MI:SS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(225941432549555907)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'2016-12-02T20:00:00.516'
,p_lov_return_value=>'YYYY-MM-DD"T"HH24:MI:SS.FF3'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(225941811998555907)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'2016-12-02T20:00:00.516Z'
,p_lov_return_value=>'YYYY-MM-DD"T"HH24:MI:SS.FF3TZR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4412319045213134)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'$5,234.10'
,p_lov_return_value=>'FML999G999G999G999G990D00'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4412618495214033)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'5,234.10'
,p_lov_return_value=>'999G999G999G999G990D00'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4412945048216241)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'5,234'
,p_lov_return_value=>'999G999G999G999G999G999G990'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4413218817217822)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'-5,234.10'
,p_lov_return_value=>'S999G999G999G999G990D00'
);
end;
/
prompt --application/shared_components/user_interface/lovs/date_format_lov
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(460719917105668922)
,p_lov_name=>'DATE_FORMAT_LOV'
,p_reference_id=>460140315153255042
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r',
'  from wwv_flow_format_masks',
' where t=''D'''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/days_of_the_week
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(185376216434149048)
,p_lov_name=>'DAYS OF THE WEEK'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,r from (',
'   select to_char(to_date(''19721105'',''YYYYMMDD''),''Day'') d,19721105 r from dual',
'   union all',
'   select to_char(to_date(''19721106'',''YYYYMMDD''),''Day''),19721106 from dual',
'   union all',
'   select to_char(to_date(''19721107'',''YYYYMMDD''),''Day''),19721107 from dual',
'   union all',
'   select to_char(to_date(''19721108'',''YYYYMMDD''),''Day''),19721108 from dual',
'   union all',
'   select to_char(to_date(''19721109'',''YYYYMMDD''),''Day''),19721109 from dual',
'   union all',
'   select to_char(to_date(''19721110'',''YYYYMMDD''),''Day''),19721110 from dual',
'   union all',
'   select to_char(to_date(''19721111'',''YYYYMMDD''),''Day''),19721111 from dual',
')',
'order by 2 '))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475130
);
end;
/
prompt --application/shared_components/user_interface/lovs/db_column_items
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(156839505926131127)
,p_lov_name=>'DB.COLUMN.ITEMS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name a,name b',
'',
'from wwv_flow_step_items',
'',
'where flow_id = :fb_flow_id',
'',
'and flow_step_id = :FB_FLOW_PAGE_ID',
'',
'and security_group_id = :flow_security_group_id',
'',
'and source_type = ''DB_COLUMN'''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475130
);
end;
/
prompt --application/shared_components/user_interface/lovs/db_credential_access_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(3027178558775923)
,p_lov_name=>'DB_CREDENTIAL_ACCESS_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(3027178558775923)||'.'
,p_location=>'STATIC'
,p_version_scn=>2241430
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3027407477775923)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Schema'
,p_lov_return_value=>'SCHEMA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3027848720775924)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Instance'
,p_lov_return_value=>'INSTANCE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/deep_linking
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(34319101845334424)
,p_lov_name=>'DEEP_LINKING'
,p_lov_query=>'.'||wwv_flow_imp.id(34319101845334424)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475130
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(34319403683334426)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Enabled'
,p_lov_return_value=>'Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(34319716050334427)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Disabled'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/default_error_display_location
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(191207805708435328)
,p_lov_name=>'DEFAULT_ERROR_DISPLAY_LOCATION'
,p_lov_query=>'.'||wwv_flow_imp.id(191207805708435328)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475130
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(191208023843435360)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Inline with Field and in Notification'
,p_lov_return_value=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(191208231710435370)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Inline with Field'
,p_lov_return_value=>'INLINE_WITH_FIELD'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(191208402756435370)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Inline in Notification'
,p_lov_return_value=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/deinstall_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(17717826931614902)
,p_lov_name=>'DEINSTALL OPTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(17717826931614902)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475130
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17718426349614906)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Do Nothing'
,p_lov_return_value=>'NOT_ACCEPTED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(37670813248983399)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Delete Application Definition'
,p_lov_return_value=>'DROP_APP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17718232517614906)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Drop Database Objects'
,p_lov_return_value=>'DROP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17718011536614905)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Drop Database Objects and Delete Application Definition'
,p_lov_return_value=>'DROP_AND_DELETE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/delete_application_actions
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(15857613201776764)
,p_lov_name=>'DELETE APPLICATION ACTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(15857613201776764)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475130
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15857829844776765)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Run Application Deinstall Script (recommended)'
,p_lov_return_value=>'SCRIPT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15858025445776766)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Delete Application Definition'
,p_lov_return_value=>'DEL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/delete_corresponding_list_entries
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(139182915633902523)
,p_lov_name=>'DELETE CORRESPONDING LIST ENTRIES'
,p_lov_query=>'.'||wwv_flow_imp.id(139182915633902523)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475130
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(139183129828902528)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Yes -- Delete corresponding list entries'
,p_lov_return_value=>'Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(139183303567902531)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'No -- Do not delete corresponding list entries'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/delete_assoc_tabs
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84243720472403985)
,p_lov_name=>'DELETE_ASSOC_TABS'
,p_lov_query=>'.'||wwv_flow_imp.id(84243720472403985)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475130
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84243909960403986)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'No -- Do not delete corresponding tabs'
,p_lov_return_value=>'NO'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84244120450403986)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Yes -- Delete any associated tabs'
,p_lov_return_value=>'YES'
);
end;
/
prompt --application/shared_components/user_interface/lovs/deployment_build_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(19372012243626156)
,p_lov_name=>'DEPLOYMENT BUILD OPTIONS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select patch_name||'' (''||wwv_flow_lang.system_message(patch_status)||'')'' d, id r ',
'  from wwv_flow_patches ',
' where flow_id = :FB_FLOW_ID'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475130
);
end;
/
prompt --application/shared_components/user_interface/lovs/developers_with_comments
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(125707019629972839)
,p_lov_name=>'DEVELOPERS WITH COMMENTS'
,p_lov_query=>'select distinct created_by d, created_by r from wwv_flow_app_comments where flow_id = :fb_flow_id order by upper(created_by)'
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475130
);
end;
/
prompt --application/shared_components/user_interface/lovs/dialog_page_mode
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(44400703264122475)
,p_lov_name=>'DIALOG_PAGE_MODE'
,p_lov_query=>'.'||wwv_flow_imp.id(44400703264122475)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475130
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(44401020446122476)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Normal'
,p_lov_return_value=>'NORMAL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(44401312153122478)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Modal Dialog'
,p_lov_return_value=>'MODAL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(44401624389122478)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Non-Modal Dialog'
,p_lov_return_value=>'NON_MODAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dialog_page_mode_create_wizard
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1497542689968615899)
,p_lov_name=>'DIALOG_PAGE_MODE_CREATE_WIZARD'
,p_lov_query=>'.'||wwv_flow_imp.id(1497542689968615899)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475130
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1497542930985615927)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Normal'
,p_lov_return_value=>'NORMAL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1497543374287615927)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Modal Dialog'
,p_lov_return_value=>'MODAL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4603339827560500)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Drawer'
,p_lov_return_value=>'DRAWER'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':APP_PAGE_ID in (2501,2508) and wwv_flow_user_interface_dev.drawer_page_template_exists( p_application_id => :FB_FLOW_ID)'
,p_lov_disp_cond2=>'PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dialog_page_mode_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(887851591470130537)
,p_lov_name=>'DIALOG_PAGE_MODE_OPTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(887851591470130537)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475130
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(887851822217130538)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Modal Dialog'
,p_lov_return_value=>'MODAL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(887852157397130546)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Non-Modal Dialog'
,p_lov_return_value=>'NON_MODAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/display_3d_graph_y
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(88110219855257765)
,p_lov_name=>'DISPLAY.3D.GRAPH.Y'
,p_lov_query=>'.'||wwv_flow_imp.id(88110219855257765)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475130
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88110415537257766)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Display 3D Graph'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dq_column_default_when
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(89803912916156290)
,p_lov_name=>'DQ_COLUMN_DEFAULT_WHEN'
,p_lov_query=>'.'||wwv_flow_imp.id(89803912916156290)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475130
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(89804223419156291)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'When creating or updating rows and no value is provided'
,p_lov_return_value=>'WHEN_NULL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(89804424514156291)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Only when creating new rows'
,p_lov_return_value=>'WHEN_INSERTING'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dq_column_functionality
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(135655901614273908)
,p_lov_name=>'DQ_COLUMN_FUNCTIONALITY'
,p_lov_query=>'.'||wwv_flow_imp.id(135655901614273908)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475130
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(197867120372745037)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Hide'
,p_lov_return_value=>'HIDE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(135656201051273908)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Sort'
,p_lov_return_value=>'SORT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(135656409479273908)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Filter'
,p_lov_return_value=>'FILTER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(47292224899070718)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Highlight'
,p_lov_return_value=>'HIGHLIGHT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(135656630770273909)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Control Break'
,p_lov_return_value=>'BREAK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(135656816892273909)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Aggregate'
,p_lov_return_value=>'AGGREGATE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(135657009007273909)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Compute'
,p_lov_return_value=>'COMPUTE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(135657212463273909)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Chart'
,p_lov_return_value=>'CHART'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1542409404810451)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Group By'
,p_lov_return_value=>'GROUP_BY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(367035115416400374)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'Pivot'
,p_lov_return_value=>'PIVOT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dq_column_group_show
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(90206330144997352)
,p_lov_name=>'DQ_COLUMN_GROUP_SHOW'
,p_lov_query=>'.'||wwv_flow_imp.id(90206330144997352)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475130
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(90206602571997357)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'All Columns'
,p_lov_return_value=>'ALL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(90206830794997359)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Unassigned Columns'
,p_lov_return_value=>'UNASSIGNED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dq_column_lov_from
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(89795021349092520)
,p_lov_name=>'DQ_COLUMN_LOV_FROM'
,p_lov_query=>'.'||wwv_flow_imp.id(89795021349092520)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475130
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(89795329939092520)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Distinct Column Values'
,p_lov_return_value=>'Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(89795515067092520)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Static Domain of Values'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dq_column_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(89661604165746991)
,p_lov_name=>'DQ_COLUMN_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(89661604165746991)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475130
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(89661921597746991)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'String	'
,p_lov_return_value=>'STRING'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(89662130353746991)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Number'
,p_lov_return_value=>'NUMBER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(89662330603746991)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Date'
,p_lov_return_value=>'DATE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(89662503487746992)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Document'
,p_lov_return_value=>'DOCUMENT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(89662722742746992)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Computed'
,p_lov_return_value=>'COMPUTED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(91733204209169832)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Detail Link'
,p_lov_return_value=>'DETAIL_LINK'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dq_detail_page_functionality
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(93896321430905901)
,p_lov_name=>'DQ_DETAIL_PAGE_FUNCTIONALITY'
,p_lov_query=>'.'||wwv_flow_imp.id(93896321430905901)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475130
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(93896600582905901)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Allow Exclude Null Values'
,p_lov_return_value=>'EXCLUDE_NULL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(93896828769905901)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Allow Displayed Columns'
,p_lov_return_value=>'HIDE_EXTR_COL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dq_display_in_def_rpt
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(94105402933265699)
,p_lov_name=>'DQ_DISPLAY_IN_DEF_RPT'
,p_lov_query=>'.'||wwv_flow_imp.id(94105402933265699)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475130
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(94105722376265699)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Display In Default Report'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dq_display_text_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(113775430732356381)
,p_lov_name=>'DQ_DISPLAY_TEXT_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(113775430732356381)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475130
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(113775715473356384)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Standard Report Column'
,p_lov_return_value=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(113776305444356385)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Display as Text (escape special characters)'
,p_lov_return_value=>'ESCAPE_SC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(450124406392222095)
,p_lov_disp_sequence=>25
,p_lov_disp_value=>'Display as Text (based on LOV, escape special characters)'
,p_lov_return_value=>'LOV_ESCAPE_SC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(442890225057859433)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Remove HTML and escape special characters'
,p_lov_return_value=>'STRIP_HTML_ESCAPE_SC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(135238030911430173)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Hidden'
,p_lov_return_value=>'HIDDEN'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dq_download_format
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(91727320467023155)
,p_lov_name=>'DQ_DOWNLOAD_FORMAT'
,p_lov_query=>'.'||wwv_flow_imp.id(91727320467023155)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475132
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(91727602780023159)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CSV'
,p_lov_return_value=>'CSV'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3830908039991257)
,p_lov_disp_sequence=>1.5
,p_lov_disp_value=>'HTML'
,p_lov_return_value=>'HTML'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9204300405839444)
,p_lov_disp_sequence=>1.7
,p_lov_disp_value=>'Email *'
,p_lov_return_value=>'EMAIL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(91727810512023162)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'XLS'
,p_lov_return_value=>'XLS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(91728030204023162)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'PDF'
,p_lov_return_value=>'PDF'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(91728214017023162)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'RTF'
,p_lov_return_value=>'RTF'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dq_filter_date_range
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(113891626211903772)
,p_lov_name=>'DQ_FILTER_DATE_RANGE'
,p_lov_query=>'.'||wwv_flow_imp.id(113891626211903772)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475134
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(113891914381903774)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'All'
,p_lov_return_value=>'ALL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(113892122745903775)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Past'
,p_lov_return_value=>'PAST'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(113892318530903775)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Future'
,p_lov_return_value=>'FUTURE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dq_non_pub_rpt_functionality
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(480571702359614063)
,p_lov_name=>'DQ_NON_PUB_RPT_FUNCTIONALITY'
,p_lov_query=>'.'||wwv_flow_imp.id(480571702359614063)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475134
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(480574929174614071)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Save Report'
,p_lov_return_value=>'RPT_SAVING'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(480575104904614071)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Save Public Report'
,p_lov_return_value=>'SAVE_RPT_PUBLIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(480574106814614069)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Subscription'
,p_lov_return_value=>'NOTIFY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dq_rpt_functionality
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(93890902683872023)
,p_lov_name=>'DQ_RPT_FUNCTIONALITY'
,p_lov_query=>'.'||wwv_flow_imp.id(93890902683872023)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475134
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(93891207939872035)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Select Columns'
,p_lov_return_value=>'SELECT_COLS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(93891430852872035)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Filter'
,p_lov_return_value=>'FILTER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(445491215210900584)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Rows Per Page'
,p_lov_return_value=>'ROWS_PER_PAGE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(93891616940872035)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Sort'
,p_lov_return_value=>'SORT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(141674418886754015)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Control Break'
,p_lov_return_value=>'BREAK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(93891825853872035)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Highlight'
,p_lov_return_value=>'HIGHLIGHT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(93893009214872050)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Compute'
,p_lov_return_value=>'COMPUTATION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(93892010217872035)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Aggregate'
,p_lov_return_value=>'AGGREGATE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(96144107239525391)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'Chart'
,p_lov_return_value=>'CHART'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1541019690680918)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'Group By'
,p_lov_return_value=>'GROUP_BY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(367023902558041646)
,p_lov_disp_sequence=>105
,p_lov_disp_value=>'Pivot'
,p_lov_return_value=>'PIVOT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(93892230261872036)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'Calendar'
,p_lov_return_value=>'CALENDAR'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(93892430175872036)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'Flashback'
,p_lov_return_value=>'FLASHBACK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(480714630007218066)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'Save Report *'
,p_lov_return_value=>'RPT_SAVING'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(480714802780219726)
,p_lov_disp_sequence=>130
,p_lov_disp_value=>'Save Public Report *'
,p_lov_return_value=>'SAVE_RPT_PUBLIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(93892610127872036)
,p_lov_disp_sequence=>140
,p_lov_disp_value=>'Reset'
,p_lov_return_value=>'RESET'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(135686220155392741)
,p_lov_disp_sequence=>150
,p_lov_disp_value=>'Help'
,p_lov_return_value=>'HELP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(93892800927872050)
,p_lov_disp_sequence=>160
,p_lov_disp_value=>'Download'
,p_lov_return_value=>'DOWNLOAD'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(480715008321221245)
,p_lov_disp_sequence=>170
,p_lov_disp_value=>'Subscription *'
,p_lov_return_value=>'NOTIFY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(93893414283872050)
,p_lov_disp_sequence=>180
,p_lov_disp_value=>'Allow Report Categories'
,p_lov_return_value=>'RPT_CATEGORY'
,p_lov_disp_cond_type=>'NEVER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dq_rpt_list_mode
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(93938623554284943)
,p_lov_name=>'DQ_RPT_LIST_MODE'
,p_lov_query=>'.'||wwv_flow_imp.id(93938623554284943)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475138
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(93938902214284943)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Yes'
,p_lov_return_value=>'TABS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(131717516025931094)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'No'
,p_lov_return_value=>'NONE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dq_same_label_for_detail_view
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(96419205216695800)
,p_lov_name=>'DQ_SAME_LABEL_FOR_DETAIL_VIEW'
,p_lov_query=>'.'||wwv_flow_imp.id(96419205216695800)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475138
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(96419521321695807)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Use Same Text for Single Row View'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dq_search_functionality
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(131635032236756030)
,p_lov_name=>'DQ_SEARCH_FUNCTIONALITY'
,p_lov_query=>'.'||wwv_flow_imp.id(131635032236756030)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475138
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(131635314260756031)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Search Field'
,p_lov_return_value=>'SEARCH_TEXT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(131635716026756031)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Finder Drop Down'
,p_lov_return_value=>'FINDER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(192533912617244035)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Reports Select List'
,p_lov_return_value=>'REPORTS_SELECT_LIST'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(131635520752756031)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Rows Per Page Selector'
,p_lov_return_value=>'ROW_CNT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(135033300784021288)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Actions Menu'
,p_lov_return_value=>'ACTIONS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dq_worksheet_pagination
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(89240132490172141)
,p_lov_name=>'DQ_WORKSHEET_PAGINATION'
,p_lov_query=>'.'||wwv_flow_imp.id(89240132490172141)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475138
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(89240414406172201)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Row Ranges X to Y of Z'
,p_lov_return_value=>'ROWS_X_TO_Y_OF_Z'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(89240620434172201)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Row Ranges X to Y'
,p_lov_return_value=>'ROWS_X_TO_Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dq_worksheet_status
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(89234523991056148)
,p_lov_name=>'DQ_WORKSHEET_STATUS'
,p_lov_query=>'.'||wwv_flow_imp.id(89234523991056148)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475138
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(89234802427056220)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Available for Owner'
,p_lov_return_value=>'AVAILABLE_FOR_OWNER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(89235015173056220)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Not Available'
,p_lov_return_value=>'NOT_AVAILABLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(89235209196056220)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Available'
,p_lov_return_value=>'AVAILABLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(89235410026056220)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Access Control List'
,p_lov_return_value=>'ACL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dynamic_action_aff_elem_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(42588011898494805)
,p_lov_name=>'DYNAMIC ACTION AFF ELEM TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(42588011898494805)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475138
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(42588307156494808)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Item(s)'
,p_lov_return_value=>'ITEM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(206201404272235955)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Button'
,p_lov_return_value=>'BUTTON'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(42588501084494810)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Region'
,p_lov_return_value=>'REGION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(42588703168494810)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Column'
,p_lov_return_value=>'COLUMN'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(42588930101494810)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'DOM Object [deprecated]'
,p_lov_return_value=>'DOM_OBJECT'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
':APP_PAGE_ID <> 591',
'or ( :APP_PAGE_ID = 591 and :P591_AFFECTED_ELEMENTS_TYPE = ''DOM_OBJECT'' )'))
,p_lov_disp_cond2=>'PLSQL'
,p_required_patch=>wwv_flow_imp.id(121426746309283317)
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(42589125805494810)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'jQuery Selector'
,p_lov_return_value=>'JQUERY_SELECTOR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(855875291459963705)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'JavaScript Expression'
,p_lov_return_value=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(486612219500089929)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Triggering Element'
,p_lov_return_value=>'TRIGGERING_ELEMENT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(486612426080091815)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Event Source'
,p_lov_return_value=>'EVENT_SOURCE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dynamic_action_bind_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(34818831818567513)
,p_lov_name=>'DYNAMIC ACTION BIND TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(34818831818567513)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475138
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(34819108605567514)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Static'
,p_lov_return_value=>'bind'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(34819317513567514)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Dynamic'
,p_lov_return_value=>'live'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(47188804631100745)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Once'
,p_lov_return_value=>'one'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dynamic_action_condition
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(4505805282372682)
,p_lov_name=>'DYNAMIC ACTION CONDITION'
,p_lov_query=>'.'||wwv_flow_imp.id(4505805282372682)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475138
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4506012984372684)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'equal to'
,p_lov_return_value=>'EQUALS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4506219163372689)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'not equal to'
,p_lov_return_value=>'NOT_EQUALS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4506429627372689)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'greater than'
,p_lov_return_value=>'GREATER_THAN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(485047623220016520)
,p_lov_disp_sequence=>35
,p_lov_disp_value=>'greater than or equal to'
,p_lov_return_value=>'GREATER_THAN_OR_EQUAL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4506629608372689)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'less than'
,p_lov_return_value=>'LESS_THAN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(485047828414018007)
,p_lov_disp_sequence=>45
,p_lov_disp_value=>'less than or equal to'
,p_lov_return_value=>'LESS_THAN_OR_EQUAL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4506817808372689)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'is null'
,p_lov_return_value=>'NULL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4507030226372689)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'is not null'
,p_lov_return_value=>'NOT_NULL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(5702509159891012)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'in list'
,p_lov_return_value=>'IN_LIST'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(5703019894894122)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'not in list'
,p_lov_return_value=>'NOT_IN_LIST'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(36337703765902045)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'JavaScript expression'
,p_lov_return_value=>'JAVASCRIPT_EXPRESSION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dynamic_action_trigg_elem_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(34817614503562438)
,p_lov_name=>'DYNAMIC ACTION TRIGG ELEM TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(34817614503562438)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475140
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(34817919388562441)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Item(s)'
,p_lov_return_value=>'ITEM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(34818325097562443)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Button'
,p_lov_return_value=>'BUTTON'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(34818131975562443)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Region'
,p_lov_return_value=>'REGION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(34818512066562444)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'DOM Object [deprecated]'
,p_lov_return_value=>'DOM_OBJECT'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
':APP_PAGE_ID not in ( 423, 793, 797 )',
'or ( :APP_PAGE_ID = 793 and :P793_TRIGGERING_ELEMENT_TYPE = ''DOM_OBJECT'' )',
'or ( :APP_PAGE_ID = 797 and :P797_TRIGGERING_ELEMENT_TYPE = ''DOM_OBJECT'' )'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(34818720680562446)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'jQuery Selector'
,p_lov_return_value=>'JQUERY_SELECTOR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(855887929978084842)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'JavaScript Expression'
,p_lov_return_value=>'JAVASCRIPT_EXPRESSION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/dynamic_theme_list
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(317672930832099392)
,p_lov_name=>'DYNAMIC_THEME_LIST'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''THEME'')||'' ''||t.theme_id||''<br/><a href="f?p=4000:''||:THEME_NEXT_PAGE||'':''||:APP_SESSION||''::::THEME_ID:''||t.theme_id||''"><img src="#IMAGE_PREFIX#themes/theme_''||t.theme_id||''/themeshot.png" alt="''||wwv_flow_lang.'
||'system_message(''THEME'')||'' ''||t.theme_id||''" title="''||wwv_flow_lang.system_message(''THEME'')||'' ''||t.theme_id||''" width="150" height="80" class="htmldbthemeshots" /></a>'' display_value, t.theme_id ',
'from (',
'    select substr(object_name,16) theme_id ',
'    from   user_objects ',
'    where  object_name like ''WWV_FLOW_THEME_%''',
'    and    object_type = ''PACKAGE''',
'    and    substr(object_name,16) in (',
'        ''1'',''2'',''3'',''4'',''5'',''6'',''7'',''8'',''9'',''10'',',
'        ''11'',''12'',''13'',''14'',''15'',''16'',''17'',''18'',''19'',''20'',',
'        ''21'',''22'',''23'',''24'',''25'',''26'',''27'',''28'',''29'',''30'',',
'        ''31'',''32'',''33'',''34'',''35'',''36'',''37'',''38'',''39'',''40'',',
'        ''41'',''42'',''43'',''44'',''45'',''46'',''47'',''48'',''49'',''50'',',
'        ''51'',''52'',''53'',''54'',''55'',''56'',''57'',''58'',''59'',''60'',',
'        ''61'',''62'',''63'',''64'',''65'',''66'',''67'',''68'',''69'',''70'',',
'        ''71'',''72'',''73'',''74'',''75'',''76'',''77'',''78'',''79'',''80'',',
'        ''81'',''82'',''83'',''84'',''85'',''86'',''87'',''88'',''89'',''90'',',
'        ''91'',''92'',''93'',''94'',''95'',''96'',''97'',''98'',''99'',''100''',
'    )',
') t',
'where t.theme_id not in (select theme_id from wwv_flow_themes where flow_id = :fb_flow_id) ',
'order by to_number(t.theme_id)',
'',
'',
'',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475140
);
end;
/
prompt --application/shared_components/user_interface/lovs/editable_static_lists
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(25201951125390366)
,p_lov_name=>'EDITABLE_STATIC_LISTS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_flow_lists',
' where list_type    = ''STATIC''',
'   and reference_id is null',
'   and flow_id      = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
' order by 1'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'R'
,p_display_column_name=>'D'
,p_group_sort_direction=>'ASC'
,p_default_sort_direction=>'ASC'
,p_version_scn=>72475140
);
end;
/
prompt --application/shared_components/user_interface/lovs/enabled_disabled_returns_y_or_n
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(91439803955181562)
,p_lov_name=>'ENABLED_DISABLED_RETURNS_Y_OR_N'
,p_lov_query=>'.'||wwv_flow_imp.id(91439803955181562)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475140
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(91440204684181564)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Disabled'
,p_lov_return_value=>'N'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(91440020513181563)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Enabled'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/enable_calendar_data_add
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(7062800325985451)
,p_lov_name=>'ENABLE_CALENDAR_DATA_ADD'
,p_lov_query=>'select wwv_flow_lang.system_message(''CONFIRM.CALENDAR_ENABLE_AJAX_DATA_ADD'') d, ''Y'' r from dual'
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475140
);
end;
/
prompt --application/shared_components/user_interface/lovs/enable_calendar_drag_drop
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(7041321387979610)
,p_lov_name=>'ENABLE_CALENDAR_DRAG_DROP'
,p_lov_query=>'select wwv_flow_lang.system_message(''CONFIRM.CALENDAR_ENABLE_DRAG_AND_DROP'') d, ''Y'' r from dual'
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475140
);
end;
/
prompt --application/shared_components/user_interface/lovs/enable_csv_export
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(113206414430374390)
,p_lov_name=>'ENABLE_CSV_EXPORT'
,p_lov_query=>'.'||wwv_flow_imp.id(113206414430374390)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475140
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(113206730666374392)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Enable CSV Output'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/enable_disable
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84865108269386627)
,p_lov_name=>'ENABLE_DISABLE'
,p_lov_query=>'.'||wwv_flow_imp.id(84865108269386627)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475144
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84865322430386628)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Disable'
,p_lov_return_value=>'DISABLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84865528406386628)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Enable'
,p_lov_return_value=>'ENABLE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/error_display_location
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(175855211406623797)
,p_lov_name=>'ERROR_DISPLAY_LOCATION'
,p_lov_query=>'.'||wwv_flow_imp.id(175855211406623797)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475144
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(175855515052623815)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Inline with Field and in Notification'
,p_lov_return_value=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(175855711259623816)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Inline with Field'
,p_lov_return_value=>'INLINE_WITH_FIELD'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(175855923896623816)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Inline in Notification'
,p_lov_return_value=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(175856114844623817)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'On Error Page'
,p_lov_return_value=>'ON_ERROR_PAGE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/exact_match
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(165376410332055484)
,p_lov_name=>'EXACT_MATCH'
,p_lov_query=>'.'||wwv_flow_imp.id(165376410332055484)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475144
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(165376716320055488)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'exact match'
,p_lov_return_value=>'y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/exact_subs_y_n
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84908521896674445)
,p_lov_name=>'EXACT_SUBS_Y_N'
,p_lov_query=>'.'||wwv_flow_imp.id(84908521896674445)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475144
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84908724352674446)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'No - Perform non exact substitutions as well'
,p_lov_return_value=>'N'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84908932193674446)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Yes - Perform only exact substitutions'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/exec_location
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(3842073961668883)
,p_lov_name=>'EXEC_LOCATION'
,p_lov_query=>'.'||wwv_flow_imp.id(3842073961668883)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475144
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3842372126668884)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Local Database'
,p_lov_return_value=>'LOCAL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3842783209668886)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'REST Enabled SQL Service'
,p_lov_return_value=>'REMOTE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3843166174668886)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'REST Data Source'
,p_lov_return_value=>'WEB_SOURCE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/exec_query_types_table_or_sql
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(6900320112159786)
,p_lov_name=>'EXEC_QUERY_TYPES.TABLE_OR_SQL'
,p_lov_query=>'.'||wwv_flow_imp.id(6900320112159786)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475144
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(6900677939159804)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Table'
,p_lov_return_value=>'TABLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(6901086550159805)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'SQL Query'
,p_lov_return_value=>'SQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1941911974764226)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Property Graph'
,p_lov_return_value=>'GRAPH'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>'sys.dbms_db_version.version >= 23 and :APP_PAGE_ID = 3112'
,p_lov_disp_cond2=>'PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/exec_remote_sql_data_source_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1766286067212864)
,p_lov_name=>'EXEC_REMOTE_SQL_DATA_SOURCE_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(1766286067212864)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475144
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1766541006212865)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Table'
,p_lov_return_value=>'TABLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1766945153212865)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'SQL Query'
,p_lov_return_value=>'SQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1767329494212865)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Function Body Returning SQL'
,p_lov_return_value=>'FUNC_BODY_RETURNING_SQL'
,p_lov_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_lov_disp_cond=>'4111,3112'
);
end;
/
prompt --application/shared_components/user_interface/lovs/exec_sql_data_source_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(601107956819795211)
,p_lov_name=>'EXEC_SQL_DATA_SOURCE_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(601107956819795211)||'.'
,p_location=>'STATIC'
,p_version_scn=>3299119
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601108186629795212)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Table'
,p_lov_return_value=>'TABLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601108576965795212)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'SQL Query'
,p_lov_return_value=>'SQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601108991977795212)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Function Body Returning SQL'
,p_lov_return_value=>'FUNC_BODY_RETURNING_SQL'
,p_lov_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_lov_disp_cond=>'3112'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1910762657477618)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Property Graph'
,p_lov_return_value=>'GRAPH'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    sys.dbms_db_version.version >= 23 ',
'and :APP_PAGE_ID in ( 7021,3120,4080,4111,3112, 1117, 1119 )'))
,p_lov_disp_cond2=>'PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/exec_sql_locations
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(601110993871808630)
,p_lov_name=>'EXEC_SQL_LOCATIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(601110993871808630)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475144
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601111150897808630)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Local Database'
,p_lov_return_value=>'LOCAL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601111502081808631)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'REST Enabled SQL Service'
,p_lov_return_value=>'REMOTE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/exec_web_source_post_processing
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(601113045750817318)
,p_lov_name=>'EXEC_WEB_SOURCE_POST_PROCESSING'
,p_lov_query=>'.'||wwv_flow_imp.id(601113045750817318)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475144
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601113231405817319)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'None'
,p_lov_return_value=>'NONE'
,p_lov_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_lov_disp_cond=>'4111'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601113600388817319)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Where Clause'
,p_lov_return_value=>'WHERE_ORDER_BY_CLAUSE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601114018041817319)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'SQL Query'
,p_lov_return_value=>'SQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601114450986817320)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Function Body Returning SQL Query'
,p_lov_return_value=>'FUNC_BODY_RETURNING_SQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/export_component_application_attributes
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(201561021137913944)
,p_lov_name=>'EXPORT COMPONENT APPLICATION ATTRIBUTES'
,p_lov_query=>'.'||wwv_flow_imp.id(201561021137913944)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475144
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(201561202964913947)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Application Attribute: Default page template'
,p_lov_return_value=>'1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(201561427317913952)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Application Attribute: Logo'
,p_lov_return_value=>'2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(201561612262913952)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Application Attribute: Logout URL'
,p_lov_return_value=>'3'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(201561802624913952)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Application Attribute: Global Notification'
,p_lov_return_value=>'4'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(201562020313913952)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Application Attribute: Authentication'
,p_lov_return_value=>'5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(201589706900307265)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Application Attribute: Home Link'
,p_lov_return_value=>'6'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(201590720753311215)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Application Attribute: Image Prefix'
,p_lov_return_value=>'7'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(201591029064313600)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Application Attribute: Logging (Yes or No)'
,p_lov_return_value=>'8'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(201591602183315334)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'Application Attribute: Application Owner'
,p_lov_return_value=>'9'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(201592417767319814)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'Application Attribute: Static Substitution Strings'
,p_lov_return_value=>'10'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(201603224693321841)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'Application Attribute: Application Status and Message'
,p_lov_return_value=>'11'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(201604303007325019)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'Application Attribute: Enable Debugging (Yes or No)'
,p_lov_return_value=>'12'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(204137731018130907)
,p_lov_disp_sequence=>130
,p_lov_disp_value=>'Application Attribute: Application Name'
,p_lov_return_value=>'13'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(204138001713131913)
,p_lov_disp_sequence=>140
,p_lov_disp_value=>'Application Attribute: Application Alias'
,p_lov_return_value=>'14'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(204138307946133739)
,p_lov_disp_sequence=>150
,p_lov_disp_value=>'Application Attribute: Exact Substitution Mode'
,p_lov_return_value=>'15'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(204139019721137188)
,p_lov_disp_sequence=>160
,p_lov_disp_value=>'Application Attribute: Security Scheme'
,p_lov_return_value=>'16'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(204139423184138143)
,p_lov_disp_sequence=>170
,p_lov_disp_value=>'Application Attribute: Proxy Server'
,p_lov_return_value=>'17'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(204140027339139375)
,p_lov_disp_sequence=>180
,p_lov_disp_value=>'Application Attribute: Page Protection'
,p_lov_return_value=>'18'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(204140631495140521)
,p_lov_disp_sequence=>190
,p_lov_disp_value=>'Application Attribute: Virtual Private Database'
,p_lov_return_value=>'19'
);
end;
/
prompt --application/shared_components/user_interface/lovs/export_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(45348605156549399)
,p_lov_name=>'EXPORT.OPTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(45348605156549399)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475144
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(45349208290549436)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Import'
,p_lov_return_value=>'IMPORT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1846115445438584)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Export'
,p_lov_return_value=>'EXPORT'
,p_lov_disp_cond_type=>'NOT_EXISTS'
,p_lov_disp_cond=>'select 1 from wwv_flows where security_group_id = :flow_security_group_id'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(45349021845549425)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Export'
,p_lov_return_value=>'EXPORT'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>'select 1 from wwv_flows where security_group_id = :flow_security_group_id'
);
end;
/
prompt --application/shared_components/user_interface/lovs/export_options_with_icons
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(805553919796597674)
,p_lov_name=>'EXPORT.OPTIONS WITH ICONS'
,p_lov_query=>'.'||wwv_flow_imp.id(805553919796597674)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475148
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(805554221842597674)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Import'
,p_lov_return_value=>'IMPORT'
,p_lov_template=>'#DISPLAY_VALUE#| gi-icon-app-builder-import-app'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(805554564333597675)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Export'
,p_lov_return_value=>'EXPORT'
,p_lov_template=>'#DISPLAY_VALUE#| gi-icon-app-builder-export-app'
,p_lov_disp_cond_type=>'NOT_EXISTS'
,p_lov_disp_cond=>'select 1 from wwv_flows where security_group_id = :flow_security_group_id'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(805554842111597676)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Export'
,p_lov_return_value=>'EXPORT'
,p_lov_template=>'#DISPLAY_VALUE#| gi-icon-app-builder-export-app'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>'select 1 from wwv_flows where security_group_id = :flow_security_group_id'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3401075102772765)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Remote Deployment'
,p_lov_return_value=>'DEPLOY'
,p_lov_template=>'#DISPLAY_VALUE#| gi-icon-app-builder-remote-deploy'
);
end;
/
prompt --application/shared_components/user_interface/lovs/export_targets_no_xml
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(43935029932609535)
,p_lov_name=>'EXPORT.TARGETS.no.xml'
,p_lov_query=>'.'||wwv_flow_imp.id(43935029932609535)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475148
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43935319566609536)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'UNIX'
,p_lov_return_value=>'UNIX'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43935500793609538)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'DOS'
,p_lov_return_value=>'DOS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(107236303690563927)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Database'
,p_lov_return_value=>'DB'
,p_lov_disp_cond_type=>'FUNCTION_BODY'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if nvl(wwv_flow_platform.get_preference(''APP_EXPORT_TO_DB_ENABLED''),''Y'') = ''Y'' and :APP_PAGE_ID = 4900 then',
'    return TRUE;',
'else',
'    return FALSE;',
'end if;'))
,p_lov_disp_cond2=>'PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/export_feedback_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(472293315458205653)
,p_lov_name=>'EXPORT_FEEDBACK_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(472293315458205653)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475148
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(472293519211205655)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Export feedback to development'
,p_lov_return_value=>'TO_DEVELOPMENT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(472293702716205659)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Export response to deployment'
,p_lov_return_value=>'TO_DEPLOYMENT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/export_file_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84829617133304005)
,p_lov_name=>'EXPORT_FILE_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(84829617133304005)||'.'
,p_location=>'STATIC'
,p_version_scn=>117485636
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84829803958304006)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Application, Page or Component Export'
,p_lov_return_value=>'FLOW_EXPORT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(30414604424207501)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'Plug-in'
,p_lov_return_value=>'PLUGIN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84830627988304007)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Script File Export'
,p_lov_return_value=>'SCRIPT_FILE_EXPORT'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(141375217080001896)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Theme Export'
,p_lov_return_value=>'THEME'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(158557719334534776)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'UI Defaults'
,p_lov_return_value=>'UI_DEFAULTS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(472592924227766354)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Team Development Feedback'
,p_lov_return_value=>'FEEDBACK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3820800835815571)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'REST Source Catalog'
,p_lov_return_value=>'CATALOG'
);
end;
/
prompt --application/shared_components/user_interface/lovs/export_sup_obj_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(388231942990864305)
,p_lov_name=>'EXPORT_SUP_OBJ_OPTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(388231942990864305)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475148
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(388232203970864308)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Yes'
,p_lov_return_value=>'Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(388232554971864310)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'No'
,p_lov_return_value=>'N'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(388232860273864310)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Yes and Install on Import Automatically'
,p_lov_return_value=>'I'
);
end;
/
prompt --application/shared_components/user_interface/lovs/export_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84313028848586180)
,p_lov_name=>'EXPORT_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(84313028848586180)||'.'
,p_location=>'STATIC'
,p_version_scn=>117491829
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84313210243586181)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Workspaces'
,p_lov_return_value=>'COMPANY_EXPORT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84313400691586181)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Applications'
,p_lov_return_value=>'FLOW_EXPORT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84313629140586181)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Pages'
,p_lov_return_value=>'PAGE_EXPORT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(30460601502095997)
,p_lov_disp_sequence=>35
,p_lov_disp_value=>'Plug-in'
,p_lov_return_value=>'PLUGIN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84313822161586182)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'CSS'
,p_lov_return_value=>'CSS_EXPORT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84314021666586182)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Images'
,p_lov_return_value=>'IMAGE_EXPORT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84314231797586182)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Files'
,p_lov_return_value=>'FILE_EXPORT'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84314413534586182)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Scripts'
,p_lov_return_value=>'SCRIPT_FILE_EXPORT'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(218848421565947069)
,p_lov_disp_sequence=>75
,p_lov_disp_value=>'Static File Export'
,p_lov_return_value=>'FILE_EXPORT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(217881026720006951)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Themes'
,p_lov_return_value=>'THEME'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(217881302263009316)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'UI Defaults'
,p_lov_return_value=>'UI_DEFAULTS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(39083219682790387)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'Team Development Feedback'
,p_lov_return_value=>'FEEDBACK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3931071348171445)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'REST Source Catalog'
,p_lov_return_value=>'CATALOG'
);
end;
/
prompt --application/shared_components/user_interface/lovs/f4000_pt0x
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(104345318793564176)
,p_lov_name=>'F4000_PT0X'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select :F4000_PTN1 d, 1 r from dual ',
'where  :F4000_PTN1 is not null',
'union all',
'select :F4000_PTN2 d, 2 r from dual',
'where  :F4000_PTN2 is not null',
'union all',
'select :F4000_PTN3 d, 3 r from dual',
'where  :F4000_PTN3 is not null',
'union all',
'select :F4000_PTN4 d, 4 r from dual',
'where  :F4000_PTN4 is not null',
'order by 2'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475148
);
end;
/
prompt --application/shared_components/user_interface/lovs/feedback_status
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1498508547672379782)
,p_lov_name=>'FEEDBACK STATUS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||the_name the_name, id ',
'from wwv_flow_feedback_status ',
'order by 2'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475148
);
end;
/
prompt --application/shared_components/user_interface/lovs/feedback_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(692564541295242869)
,p_lov_name=>'FEEDBACK TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(692564541295242869)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475148
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(720957220062547736)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Developer Comment'
,p_lov_return_value=>'COMMENT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(692565162163242874)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Bug'
,p_lov_return_value=>'BUG'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(692564818123242871)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'To Do'
,p_lov_return_value=>'TODO'
);
end;
/
prompt --application/shared_components/user_interface/lovs/fieldtemplate
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(93450900806779850)
,p_lov_name=>'FIELDTEMPLATE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(template_name) d, id',
'from   wwv_flow_field_templates',
'where  flow_id = :fb_flow_id and ',
'       (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475148
);
end;
/
prompt --application/shared_components/user_interface/lovs/field_alignment
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84354125395660958)
,p_lov_name=>'FIELD_ALIGNMENT'
,p_lov_query=>'.'||wwv_flow_imp.id(84354125395660958)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475148
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84354312984660959)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Center'
,p_lov_return_value=>'CENTER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84354513344660959)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Center bottom'
,p_lov_return_value=>'CENTER-BOTTOM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84354712797660959)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Center center'
,p_lov_return_value=>'CENTER-CENTER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84354917729660959)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Center top'
,p_lov_return_value=>'CENTER-TOP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84355106101660960)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Start'
,p_lov_return_value=>'LEFT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84355327264660960)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Start bottom'
,p_lov_return_value=>'LEFT-BOTTOM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84355517743660961)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Start center'
,p_lov_return_value=>'LEFT-CENTER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84355723004660961)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Start top'
,p_lov_return_value=>'LEFT-TOP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84355913470660961)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'End'
,p_lov_return_value=>'RIGHT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84356104865660961)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'End bottom'
,p_lov_return_value=>'RIGHT-BOTTOM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84356323660660962)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'End center'
,p_lov_return_value=>'RIGHT-CENTER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84356511314660962)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'End top'
,p_lov_return_value=>'RIGHT-TOP'
);
end;
/
prompt --application/shared_components/user_interface/lovs/file_extensions
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(152392614641425297)
,p_lov_name=>'FILE EXTENSIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(152392614641425297)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475148
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(152392917070425300)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'gif'
,p_lov_return_value=>'gif'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(152393102499425300)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'jpg'
,p_lov_return_value=>'jpg'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(152393306933425300)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'png'
,p_lov_return_value=>'png'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(152393526593425301)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'js'
,p_lov_return_value=>'js'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(152393720879425301)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'ico'
,p_lov_return_value=>'ico'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(152393912392425301)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'swf'
,p_lov_return_value=>'swf'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(152561112881547769)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'css'
,p_lov_return_value=>'css'
);
end;
/
prompt --application/shared_components/user_interface/lovs/file_format
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84322414566600975)
,p_lov_name=>'FILE_FORMAT'
,p_lov_query=>'.'||wwv_flow_imp.id(84322414566600975)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475148
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84322611093600976)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'DOS'
,p_lov_return_value=>'DOS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84322801136600976)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'UNIX'
,p_lov_return_value=>'UNIX'
);
end;
/
prompt --application/shared_components/user_interface/lovs/file_storage
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1602419714639818)
,p_lov_name=>'FILE_STORAGE'
,p_lov_query=>'.'||wwv_flow_imp.id(1602419714639818)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475148
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1602787041639832)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Local Database'
,p_lov_return_value=>'DB'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1603128901639832)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Oracle Cloud Object Storage'
,p_lov_return_value=>'OBJECT_STORE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/file_storage_sync_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(575661404207029763)
,p_lov_name=>'FILE_STORAGE_SYNC_OPTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(575661404207029763)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475148
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(575661788094029764)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'From Object Storage to Local Database'
,p_lov_return_value=>'DB'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(575662160334029764)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'From Local Database to Object Storage'
,p_lov_return_value=>'OBJECT_STORE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/find_files_report_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(152121930169975580)
,p_lov_name=>'FIND FILES REPORT OPTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(152121930169975580)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475148
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(152122103854975582)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'With context'
,p_lov_return_value=>'CONTEXT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(152122325945975584)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Without context'
,p_lov_return_value=>'NO_CONTEXT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/first_item
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(88125512675662566)
,p_lov_name=>'FIRST.ITEM'
,p_lov_query=>'.'||wwv_flow_imp.id(88125512675662566)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475149
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88125727281662567)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'First item on page'
,p_lov_return_value=>'AUTO_FIRST_ITEM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88125912388662567)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Do not focus cursor'
,p_lov_return_value=>'NO_FIRST_ITEM'
);
end;
/
prompt --application/shared_components/user_interface/lovs/fixed_header_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1591954790699969778)
,p_lov_name=>'FIXED_HEADER_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(1591954790699969778)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475149
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1591955066049969781)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'None'
,p_lov_return_value=>'NONE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1591955376065969785)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Region'
,p_lov_return_value=>'REGION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1591955690098969785)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Page'
,p_lov_return_value=>'PAGE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/fk_col_source_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(61279713459133078)
,p_lov_name=>'FK_COL_SOURCE_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(61279713459133078)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475149
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(61280232645133087)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Item (application or page item name)'
,p_lov_return_value=>'ITEM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(137617420490097969)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'PL/SQL Expression or Function'
,p_lov_return_value=>'FUNCTION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/flash_chart_query_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(6026412205740110)
,p_lov_name=>'FLASH_CHART_QUERY_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(6026412205740110)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475149
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(6026711255740110)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'SQL Query'
,p_lov_return_value=>'SQL_QUERY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(6026911236740110)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Function Returning SQL Query'
,p_lov_return_value=>'FUNCTION_RETURNING_SQL_QUERY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_process_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(179311318624565491)
,p_lov_name=>'FLOW.PROCESS.TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(179311318624565491)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475149
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(179311622483565552)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'On Load: Before Header (page template header)'
,p_lov_return_value=>'BEFORE_HEADER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(179311831825565556)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'On Load: After Header (page template header)'
,p_lov_return_value=>'AFTER_HEADER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(179312200871565557)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'On Load: Before "Body" Region(s)'
,p_lov_return_value=>'BEFORE_BOX_BODY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(179312423113565557)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'On Load: After "Body" Region(s)'
,p_lov_return_value=>'AFTER_BOX_BODY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(179312600387565558)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'On Load: Before Footer (page template footer)'
,p_lov_return_value=>'BEFORE_FOOTER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(179312827063565558)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'On Load: After Footer (page template footer)'
,p_lov_return_value=>'AFTER_FOOTER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3451613729145560)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'On Submit: After Page Submission - Before Computations and Validations'
,p_lov_return_value=>'ON_SUBMIT_BEFORE_COMPUTATION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(179313012514565558)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'On Submit: After Page Submission - After Computations and Validations'
,p_lov_return_value=>'AFTER_SUBMIT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(179313403662565559)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'On New Instance (new session)'
,p_lov_return_value=>'ON_NEW_INSTANCE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(48424707885351870)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'After Authentication'
,p_lov_return_value=>'AFTER_LOGIN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(195926500168560659)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>'Ajax Callback: Run this application process when requested by a page process.'
,p_lov_return_value=>'ON_DEMAND'
);
end;
/
prompt --application/shared_components/user_interface/lovs/flowchart_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84246225797415032)
,p_lov_name=>'FLOWCHART_OPTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(84246225797415032)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475149
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88293501517804182)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Show All'
,p_lov_return_value=>'ALL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88293722687804182)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Show Used'
,p_lov_return_value=>'USED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_page_process_point
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(842344044)
,p_lov_name=>'FLOW_PAGE_PROCESS_POINT'
,p_lov_query=>'.'||wwv_flow_imp.id(842344044)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475149
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88153412020965107)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'On New Instance (new session)'
,p_lov_return_value=>'ON_NEW_INSTANCE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88153630053965109)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'On Load - Before Header'))
,p_lov_return_value=>'BEFORE_HEADER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88153816621965110)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'On Load - After Header'))
,p_lov_return_value=>'AFTER_HEADER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88154016104965110)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'On Load - Before Regions'))
,p_lov_return_value=>'BEFORE_BOX_BODY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88154204450965110)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'On Load - After Regions'))
,p_lov_return_value=>'AFTER_BOX_BODY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88154401617965110)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'On Load - Before Footer'))
,p_lov_return_value=>'BEFORE_FOOTER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88154630856965111)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'On Load - After Footer'))
,p_lov_return_value=>'AFTER_FOOTER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88154821308965111)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'On Submit - Before Computations and Validations '))
,p_lov_return_value=>'ON_SUBMIT_BEFORE_COMPUTATION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88155019536965111)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'On Submit - After Computations and Validations'))
,p_lov_return_value=>'AFTER_SUBMIT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(180086820088274193)
,p_lov_disp_sequence=>95
,p_lov_disp_value=>'Ajax Callback - Run this process when requested by Ajax'
,p_lov_return_value=>'ON_DEMAND'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88155215743965111)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'On Error - After Header'
,p_lov_return_value=>'AFTER_ERROR_HEADER'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88155426385965112)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'On Error - Before Footer'
,p_lov_return_value=>'BEFORE_ERROR_FOOTER'
,p_lov_disp_cond_type=>'NEVER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_page_process_types_used_by_layout_plb
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(173924028038191229)
,p_lov_name=>'FLOW_PAGE_PROCESS_TYPES (USED BY LAYOUT.PLB)'
,p_lov_query=>'.'||wwv_flow_imp.id(173924028038191229)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475150
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(5385505863234534)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Get Next or Previous Primary Key Value'
,p_lov_return_value=>'GET_NEXT_OR_PREV_PK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(24106509225424138)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Reset Pagination For All Pages'
,p_lov_return_value=>'INITIALIZE_PAGINATION_FOR_ALL_PAGES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(24106822384427913)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Reset Pagination For Page(s) (PageID,PageID,PageID)'
,p_lov_return_value=>'INITIALIZE_PAGE_PAGINATION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(37703005830510688)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Clear Cache For Current Application (removes all session state for current application)'
,p_lov_return_value=>'CLEAR_CACHE_CURRENT_FLOW'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(37703320721515055)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Clear Cache For Applications (removes all session state for listed applications)'
,p_lov_return_value=>'CLEAR_CACHE_FOR_FLOWS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(55952701190174406)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Add rows to tabular form'
,p_lov_return_value=>'ADD_ROWS_TO_TABULAR_FORM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(91224603956641545)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Web Service'
,p_lov_return_value=>'WEB_SERVICE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108355614250314633)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Close popup window'
,p_lov_return_value=>'CLOSE_WINDOW'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(173924310985191301)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'PL/SQL anonymous block'
,p_lov_return_value=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(173924502801191303)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'PL/SQL DBMS JOB (runs anonymous block asynchronously)'
,p_lov_return_value=>'PLSQL_DBMS_JOB'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(173924700917191304)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Reset Pagination'
,p_lov_return_value=>'RESET_PAGINATION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(173924903829191304)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Clear Cache for all Items on Pages (PageID,PageID,PageID)'
,p_lov_return_value=>'CLEAR_CACHE_FOR_PAGES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(173925127021191304)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Clear Cache for Items (ITEM,ITEM,ITEM)'
,p_lov_return_value=>'CLEAR_CACHE_FOR_ITEMS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(173925314775191305)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Automated Row Fetch'
,p_lov_return_value=>'DML_FETCH_ROW'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(173925531897191305)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Automatic Row Processing  (DML)'
,p_lov_return_value=>'DML_PROCESS_ROW'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(173925724656191305)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Set Preference to value of Item'
,p_lov_return_value=>'SET_PREFERENCE_TO_ITEM_VALUE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(173925923660191306)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Set Preference to value of Item if item is not null (PreferenceName:ITEM)'
,p_lov_return_value=>'SET_PREFERENCE_TO_ITEM_VALUE_IF_ITEM_NOT_NULL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(173926131005191309)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Multi Row Update'
,p_lov_return_value=>'MULTI_ROW_UPDATE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(173926306818191309)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Clear Cache For Current Session (removes all state for current session)'
,p_lov_return_value=>'RESET_SESSION_STATE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(174071729595622534)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Reset Preferences (remove all preferences for current user)'
,p_lov_return_value=>'RESET_USER_PREFERENCES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(195164405401312743)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Initialize all page items'
,p_lov_return_value=>'INITIALIZE_ALL_PAGE_ITEMS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(196226115576823870)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Ajax Callback - Run an "ajax callback" application process'
,p_lov_return_value=>'ON_DEMAND'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(31585223737231743)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Multi Row Delete'
,p_lov_return_value=>'MULTI_ROW_DELETE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_subscribe_from_app_computations
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(4452665082428256)
,p_lov_name=>'FLOW_SUBSCRIBE_FROM_APP_COMPUTATIONS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select b.flow_id ||'' ''||f.name||'' - ''|| b.computation_item d,',
'       b.id r',
'  from wwv_flow_computations b,',
'       wwv_main_apps_dev f',
' where b.flow_id          != nvl(:FB_FLOW_ID,0)',
'   and b.flow_id           = f.id',
'   and f.build_status      not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'   and b.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and f.security_group_id = :FLOW_SECURITY_GROUP_ID',
'order by 1'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'R'
,p_display_column_name=>'D'
,p_group_sort_direction=>'ASC'
,p_default_sort_direction=>'ASC'
,p_version_scn=>72475151
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_subscribe_from_app_items
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(8157411451380124)
,p_lov_name=>'FLOW_SUBSCRIBE_FROM_APP_ITEMS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select b.flow_id ||'' ''||f.name||'' - ''|| b.name d,',
'       b.id r',
'  from wwv_flow_items b,',
'       wwv_main_apps_dev f',
' where b.flow_id          != nvl(:FB_FLOW_ID,0)',
'   and b.flow_id           = f.id',
'   and f.build_status      not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'   and b.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and f.security_group_id = :FLOW_SECURITY_GROUP_ID',
'order by 1'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'R'
,p_display_column_name=>'D'
,p_group_sort_direction=>'ASC'
,p_default_sort_direction=>'ASC'
,p_version_scn=>72475151
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_subscribe_from_app_processes
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(3570798030238058)
,p_lov_name=>'FLOW_SUBSCRIBE_FROM_APP_PROCESSES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select b.flow_id ||'' ''||f.name||'' - ''|| b.process_name d,',
'       b.id r',
'  from wwv_flow_processing b,',
'       wwv_main_apps_dev f',
' where b.flow_id          != nvl(:FB_FLOW_ID,0)',
'   and b.flow_id           = f.id',
'   and f.build_status      not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'   and b.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and f.security_group_id = :FLOW_SECURITY_GROUP_ID',
'order by 1'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'R'
,p_display_column_name=>'D'
,p_group_sort_direction=>'ASC'
,p_default_sort_direction=>'ASC'
,p_version_scn=>72475151
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_subscribe_from_app_settings
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(8416516486708648)
,p_lov_name=>'FLOW_SUBSCRIBE_FROM_APP_SETTINGS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select b.flow_id ||'' ''||f.name||'' - ''|| b.name d,',
'       b.id r',
'  from wwv_flow_app_settings b,',
'       wwv_flows f',
' where b.flow_id          != nvl(:FB_FLOW_ID,0)',
'   and b.flow_id           = f.id',
'   and f.build_status      not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'   and b.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and f.security_group_id = :FLOW_SECURITY_GROUP_ID',
'order by 1'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'R'
,p_display_column_name=>'D'
,p_group_sort_direction=>'ASC'
,p_default_sort_direction=>'ASC'
,p_version_scn=>72475151
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_subscribe_from_button_templates
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(78596914570530945)
,p_lov_name=>'FLOW_SUBSCRIBE_FROM_BUTTON_TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''|| lower(wwv_flow_lang.system_message(''NO_TEMPLATE''))|| '' -'' d,',
'        0 r ',
'  from sys.dual union all',
'select flow_id||'' : ''||template_name||decode(theme_id,null,'''','' (''||theme_id||'')'') d, id r',
'  from wwv_flow_button_templates',
' where flow_id != nvl(:fb_flow_id,0) ',
'   and flow_id in ( select f.id',
'                      from wwv_main_apps_dev f',
'                     where security_group_id = :flow_security_group_id ',
'                       and build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') ',
'                       and exists ( select 1 ',
'                                      from wwv_flow_developers',
'                                     where userid            = :flow_user ',
'                                       and (flow_id = f.id or flow_id is null) ',
'                                       and security_group_id = :flow_security_group_id ) )',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475153
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_subscribe_from_cal_templates
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(38779012258862870)
,p_lov_name=>'FLOW_SUBSCRIBE_FROM_CAL_TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||lower(wwv_flow_lang.system_message(''NO_TEMPLATE''))||'' -'' d, ',
'        0 r from sys.dual',
' union all',
'select flow_id||'' : ''||name||decode(theme_id,',
'       null,',
'       '''',',
'       '' (''||theme_id||'')'') d,',
'       id r',
'  from wwv_flow_cal_templates',
' where flow_id          != nvl(:fb_flow_id,0)',
'   and security_group_id = :WORKSPACE_ID',
'   and flow_id          in ( select f.id',
'                               from wwv_main_apps_dev f',
'                              where security_group_id = :flow_security_group_id',
'                                and build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'                                and exists ( select 1 ',
'                                               from wwv_flow_developers',
'                                              where userid            = :flow_user ',
'                                                and (flow_id is null or flow_id = f.id)',
'                                                and security_group_id = :flow_security_group_id))',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475153
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_subscribe_from_email_templates
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(8415246467668018)
,p_lov_name=>'FLOW_SUBSCRIBE_FROM_EMAIL_TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select b.flow_id ||'' ''||f.name||'' - ''|| b.name d,',
'       b.id r',
'  from wwv_flow_email_templates b,',
'       wwv_flows f',
' where b.flow_id          != nvl(:FB_FLOW_ID,0)',
'   and b.flow_id           = f.id',
'   and f.build_status      not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'   and b.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and f.security_group_id = :FLOW_SECURITY_GROUP_ID',
'order by 1'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'R'
,p_display_column_name=>'D'
,p_group_sort_direction=>'ASC'
,p_default_sort_direction=>'ASC'
,p_version_scn=>72475153
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_subscribe_from_field_templates
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(164770817986385686)
,p_lov_name=>'FLOW_SUBSCRIBE_FROM_FIELD_TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||',
'lower(wwv_flow_lang.system_message(''NO_TEMPLATE''))||',
''' -'' d, 0 r from dual union all',
'select flow_id||'' : ''||template_name||decode(theme_id,null,'''','' (''||theme_id||'')'') d, id r',
'from   wwv_flow_field_templates',
'where  flow_id != nvl(:fb_flow_id,0) and flow_id in (',
'select f.id',
'from   wwv_main_apps_dev f',
'where  security_group_id = :flow_security_group_id and',
'       build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') and',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and ( flow_id is null or flow_id = f.id) and security_group_id = :flow_security_group_id)',
')',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475153
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_subscribe_from_item_help
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(36938013073570429)
,p_lov_name=>'FLOW_SUBSCRIBE_FROM_ITEM_HELP'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||',
'lower(wwv_flow_lang.system_message(''NO_ITEM''))||',
''' -''  d, 0 r from dual union all',
'select i.flow_id||'' : ''||i.name d, i.id r',
'from   wwv_flow_step_items i, wwv_flow_step_item_help h',
'where  i.id = h.flow_item_id',
'and i.flow_id = nvl(:fb_flow_id,0) and i.flow_id in (',
'select f.id',
'from   wwv_main_apps_dev f',
'where  security_group_id = :flow_security_group_id and',
'       build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') and',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id is null and security_group_id = :flow_security_group_id)',
'       or',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id = f.id and security_group_id = :flow_security_group_id )',
')',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475153
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_subscribe_from_lists
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(10900121491345998)
,p_lov_name=>'FLOW_SUBSCRIBE_FROM_LISTS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select flow_id||'' : ''||name d,',
'       id r',
'  from wwv_flow_lists l',
' where flow_id != nvl(:FB_FLOW_ID,0)',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and exists (',
'        select *',
'          from wwv_main_apps_dev f',
'         where f.security_group_id = :FLOW_SECURITY_GROUP_ID',
'           and f.build_status      not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'           and l.flow_id           = f.id )',
'order by 1'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'R'
,p_display_column_name=>'D'
,p_group_sort_direction=>'ASC'
,p_default_sort_direction=>'ASC'
,p_version_scn=>72475153
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_subscribe_from_list_templates
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(164157520028033233)
,p_lov_name=>'FLOW_SUBSCRIBE_FROM_LIST_TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,',
'       r ',
' from ( select ''- '' || lower(wwv_flow_lang.system_message(''NO_TEMPLATE'')) || '' -''  d, ',
'                0 r, ',
'                1 ob',
'          from sys.dual ',
'         union all',
'        select flow_id || '' : '' || list_template_name || decode( theme_id, null, '''', '' ('' || theme_id|| '')'' ) d,  ',
'               id r, ',
'               2 ob',
'          from wwv_flow_list_templates',
'         where flow_id != nvl( :fb_flow_id ,0 ) ',
'           and flow_id in ( select f.id',
'                              from wwv_main_apps_dev f',
'                             where security_group_id = :FLOW_SECURITY_GROUP_ID ',
'                               and build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'                               and exists ( select 1 ',
'                                              from wwv_flow_developers',
'                                             where userid = :FLOW_USER ',
'                                               and ( flow_id is null or flow_id = f.id )',
'                                               and security_group_id = :FLOW_SECURITY_GROUP_ID ',
'                                          )',
'',
'                           )',
'     )',
'order by ob,d'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475153
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_subscribe_from_lovs
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(202133627659471272)
,p_lov_name=>'FLOW_SUBSCRIBE_FROM_LOVS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||',
'wwv_flow_lang.system_message(''NO_LOV'')||',
''' -'' d, 0 r from sys.dual ',
'union all',
'select flow_id||'' : ''||LOV_NAME d, id r',
'from   wwv_flow_lists_of_values$',
'where  flow_id != nvl(:fb_flow_id,0) and flow_id in (',
'select f.id',
'from   wwv_main_apps_dev f',
'where  security_group_id = :flow_security_group_id and',
'       build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') and',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id is null and security_group_id = :flow_security_group_id)',
'       or',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id = f.id and security_group_id = :flow_security_group_id )',
')',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475153
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_subscribe_from_map_backgrounds
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2016690573118507)
,p_lov_name=>'FLOW_SUBSCRIBE_FROM_MAP_BACKGROUNDS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select mb.flow_id ||'' : ''|| mb.name d,',
'       mb.id r',
'  from wwv_flow_map_backgrounds mb',
' where mb.flow_id != nvl(:FB_FLOW_ID,0)',
'   and mb.security_group_id = :WORKSPACE_ID',
'   and exists (',
'        select *',
'          from wwv_flows f',
'         where f.security_group_id = :WORKSPACE_ID',
'           and f.build_status      not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'           and mb.flow_id           = f.id )',
'order by 1'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'R'
,p_display_column_name=>'D'
,p_group_sort_direction=>'ASC'
,p_default_sort_direction=>'ASC'
,p_version_scn=>72475153
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_subscribe_from_menu_templates
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(13324505967815786)
,p_lov_name=>'FLOW_SUBSCRIBE_FROM_MENU_TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- '' || lower(wwv_flow_lang.system_message(''NO_TEMPLATE'')) || '' -'' d, ',
'        0 r ',
'  from sys.dual ',
' union all',
'select flow_id||'' : ''||name||decode(theme_id,',
'       null,',
'       '''',',
'       '' (''||theme_id||'')'') n, ',
'       id r',
'  from wwv_flow_menu_templates',
' where flow_id != nvl(:fb_flow_id,0) ',
'   and flow_id in ( select f.id',
'                      from wwv_main_apps_dev f',
'                     where security_group_id = :flow_security_group_id ',
'                       and build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') ',
'   and exists ( select 1 ',
'  from wwv_flow_developers',
' where userid            = :flow_user ',
'   and ( flow_id is null or flow_id = f.id ) ',
'   and security_group_id = :flow_security_group_id)',
')',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475153
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_subscribe_from_navbars
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(200972808971926486)
,p_lov_name=>'FLOW_SUBSCRIBE_FROM_NAVBARS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||',
'lower(wwv_flow_lang.system_message(''LAYOUT.T_NO''))||'' '' ||wwv_flow_lang.system_message(''NAVBAR'')||',
'''  -'' d, 0 r from sys.dual union all',
'select flow_id||'' : ''||',
'icon_image_alt d,',
'id r',
'from   wwv_flow_icon_bar',
'where  flow_id != nvl(:fb_flow_id,0) and flow_id in (',
'select f.id',
'from   wwv_main_apps_dev f',
'where  security_group_id = :flow_security_group_id and',
'       build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') and',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id is null and security_group_id = :flow_security_group_id)',
'       or',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id = f.id and security_group_id = :flow_security_group_id )',
')',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475153
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_subscribe_from_page_templates
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(162657018721377376)
,p_lov_name=>'FLOW_SUBSCRIBE_FROM_PAGE_TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''|| lower(wwv_flow_lang.system_message(''NO_TEMPLATE'')) || '' -'' d, 0 r ',
'  from sys.dual union all',
'select d, r ',
'  from ( select flow_id || '' : '' || name || decode ( theme_id, null, '''', '' (''||theme_id||'')'') d, id r',
'           from wwv_flow_templates',
'          where  flow_id != nvl(:fb_flow_id,0)',
'            and flow_id in ( select f.id',
'                               from   wwv_main_apps_dev f',
'                              where  security_group_id = :flow_security_group_id ',
'                                and  build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') ',
'                                and exists ( select 1 from wwv_flow_developers',
'                                              where userid = :flow_user ',
'                                                and ( flow_id is null or flow_id = f.id) ',
'                                                and security_group_id = :flow_security_group_id',
'                                            )',
'                            )',
'          order by 1',
'        )'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475153
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_subscribe_from_patches
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(4824378368879083)
,p_lov_name=>'FLOW_SUBSCRIBE_FROM_PATCHES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select b.flow_id ||'' ''||f.name||'' - ''|| patch_name d,',
'       b.id r',
'  from wwv_flow_patches b,',
'       wwv_main_apps_dev f',
' where b.flow_id          != nvl(:FB_FLOW_ID,0)',
'   and b.flow_id           = f.id',
'   and f.build_status      not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'   and b.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and f.security_group_id = :FLOW_SECURITY_GROUP_ID',
'order by 1'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'R'
,p_display_column_name=>'D'
,p_group_sort_direction=>'ASC'
,p_default_sort_direction=>'ASC'
,p_version_scn=>72475153
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_subscribe_from_plugins
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(32725318570538377)
,p_lov_name=>'FLOW_SUBSCRIBE_FROM_PLUGINS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case when p.security_group_id in ( 11, 12 ) ',
'       then wwv_flow_lang.system_message( ''SUBSCRIBED_FROM.THEME_REPOSITORY'' )',
'       else to_char( p.flow_id )',
'       end ||'' : ''||p.display_name || ',
'       case when p.theme_id is not null',
'       then '' '' || wwv_flow_lang.system_message( ''THEME.THEME_ID_POSTFIX'', p0 => p.theme_id )',
'       end as d,',
'       p.id as r',
'  from wwv_flow_plugins p,',
'       wwv_main_apps_dev f',
' where ( (    p.flow_id != to_number(:FB_FLOW_ID)',
'          and p.theme_id is null',
'          and :P4410_THEME_ID is null )',
'        or ( p.theme_id is not null',
'          and :P4410_THEME_ID is not null',
'          and p.id != :P4410_ID ) )',
'   and p.security_group_id in ( to_number(:WORKSPACE_ID), 11, 12 )',
'   and f.id                = p.flow_id',
'   and f.build_status     not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475153
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_subscribe_from_popuplov_templates
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(13178025111508374)
,p_lov_name=>'FLOW_SUBSCRIBE_FROM_POPUPLOV_TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- '' || lower(wwv_flow_lang.system_message(''NO_TEMPLATE'')) || '' -'' d, ',
'       0 r',
'  from sys.dual',
' union all',
'select flow_id||'' : ''||',
'       lower(wwv_flow_lang.system_message(''POPUP_LOV''))||'' ''||',
'       lower(wwv_flow_lang.system_message(''TEMPLATE''))||decode(theme_id,null,'''','' (''||theme_id||'')'') d,',
'       id r',
'  from wwv_flow_popup_lov_template',
' where flow_id != nvl(:fb_flow_id,0)',
'   and security_group_id = :WORKSPACE_ID',
'   and flow_id          in ( select f.id',
'                               from wwv_flow_visible_flows f',
'                              where build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'                                and security_group_id = :WORKSPACE_ID )',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>82125582
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_subscribe_from_region_templates
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(164027403622318790)
,p_lov_name=>'FLOW_SUBSCRIBE_FROM_REGION_TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select flow_id||'' : ''||page_plug_template_name||decode(theme_id,null,'''','' (''||theme_id||'')'') d, id r',
'from   wwv_flow_page_plug_templates',
'where  flow_id != nvl(:fb_flow_id,0) and flow_id in (',
'select f.id',
'from   wwv_main_apps_dev f',
'where  security_group_id = :flow_security_group_id and',
'       build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') and',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and ( flow_id is null or flow_id = f.id ) and security_group_id = :flow_security_group_id)',
')',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475153
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_subscribe_from_report_layouts
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(8415791184678343)
,p_lov_name=>'FLOW_SUBSCRIBE_FROM_REPORT_LAYOUTS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select b.flow_id ||'' ''||f.name||'' - ''|| b.report_layout_name d,',
'       b.id r',
'  from wwv_flow_report_layouts b,',
'       wwv_flows f',
' where b.flow_id          != nvl(:FB_FLOW_ID,0)',
'   and b.flow_id           = f.id',
'   and f.build_status      not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'   and b.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and f.security_group_id = :FLOW_SECURITY_GROUP_ID',
'order by 1'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'R'
,p_display_column_name=>'D'
,p_group_sort_direction=>'ASC'
,p_default_sort_direction=>'ASC'
,p_version_scn=>72475153
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_subscribe_from_report_templates
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(164380503095031318)
,p_lov_name=>'FLOW_SUBSCRIBE_FROM_REPORT_TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- '' || lower(wwv_flow_lang.system_message(''NO_TEMPLATE'')) || '' -'' d,',
'       0 r ',
'  from sys.dual ',
' union all',
'select flow_id||'' : ''||row_template_name||decode(theme_id,',
'       null,',
'       '''',',
'       '' (''||theme_id||'')'') d, ',
'       id r',
'  from wwv_flow_row_templates',
' where flow_id != nvl(:fb_flow_id,0) ',
'   and flow_id in ( select f.id',
'                      from wwv_main_apps_dev f',
'                     where security_group_id = :flow_security_group_id ',
'                       and build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') ',
'                       and exists ( select 1 ',
'                                      from wwv_flow_developers',
'                                     where userid            = :flow_user ',
'                                       and ( flow_id is null or flow_id = f.id ) ',
'                                       and security_group_id = :flow_security_group_id)',
'    )',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475153
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_subscribe_from_roles
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(4788126741522121)
,p_lov_name=>'FLOW_SUBSCRIBE_FROM_ROLES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select b.flow_id ||'' ''||f.name||'' - ''|| b.group_name d,',
'       b.id r',
'  from wwv_flow_fnd_user_groups b,',
'       wwv_main_apps_dev f',
' where b.flow_id          != nvl(:FB_FLOW_ID,0)',
'   and b.flow_id           = f.id',
'   and f.build_status      not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'   and b.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and f.security_group_id = :FLOW_SECURITY_GROUP_ID',
'order by 1'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'R'
,p_display_column_name=>'D'
,p_group_sort_direction=>'ASC'
,p_default_sort_direction=>'ASC'
,p_version_scn=>72475153
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_subscribe_from_search_configs
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(298508806179550666)
,p_lov_name=>'FLOW_SUBSCRIBE_FROM_SEARCH_CONFIGS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select s.flow_id ||'' : ''|| s.label d,',
'       s.id r',
'  from wwv_flow_search_configs s',
' where s.flow_id != nvl(:FB_FLOW_ID,0)',
'   and s.security_group_id = :WORKSPACE_ID',
'   and exists (',
'        select *',
'          from wwv_main_apps_dev f',
'         where f.security_group_id = :WORKSPACE_ID',
'           and f.build_status      not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'           and s.flow_id           = f.id )',
'order by 1'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'R'
,p_display_column_name=>'D'
,p_group_sort_direction=>'ASC'
,p_default_sort_direction=>'ASC'
,p_version_scn=>72475153
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_subscribe_from_security_schemes
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(178729613950854599)
,p_lov_name=>'FLOW_SUBSCRIBE_FROM_SECURITY_SCHEMES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||',
'wwv_flow_lang.system_message(''NO_AUTHORIZATION_SCHEME'')||',
''' -'' d, 0 r from sys.dual union all',
'select flow_id||'' : ''||name d, id r',
'from   wwv_flow_security_schemes',
'where  flow_id != nvl(:fb_flow_id,0) and flow_id in (',
'select f.id',
'from   wwv_main_apps_dev f',
'where  security_group_id = :flow_security_group_id and',
'       build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') and',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id is null and security_group_id = :flow_security_group_id)',
'       or',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id = f.id and security_group_id = :flow_security_group_id )',
')',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475153
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_subscribe_from_shortcuts
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(185072604868032254)
,p_lov_name=>'FLOW_SUBSCRIBE_FROM_SHORTCUTS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||',
'wwv_flow_lang.system_message(''NO_SHORTCUT'')||',
''' -'' d, 0 r from sys.dual union all',
'select flow_id||'' : ''||shortcut_name d, id r',
'from   wwv_flow_shortcuts',
'where  flow_id != nvl(:fb_flow_id,0) and flow_id in (',
'select f.id',
'from   wwv_main_apps_dev f',
'where  security_group_id = :flow_security_group_id and',
'       build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') and',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id is null and security_group_id = :flow_security_group_id)',
'       or',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id = f.id and security_group_id = :flow_security_group_id )',
')',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475153
);
end;
/
prompt --application/shared_components/user_interface/lovs/flow_subscribe_from_text_messages
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2620983194638992)
,p_lov_name=>'FLOW_SUBSCRIBE_FROM_TEXT_MESSAGES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select b.flow_id ||'' ''||f.name||'' - ''||b.name||'' ( ''|| b.message_language ||'' )'' d,',
'       b.id r',
'  from wwv_flow_messages$ b,',
'       wwv_main_apps_dev f',
' where b.flow_id          != nvl(:FB_FLOW_ID,0)',
'   and b.flow_id           = f.id',
'   and f.build_status      not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'   and b.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and f.security_group_id = :FLOW_SECURITY_GROUP_ID',
'order by 1'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'R'
,p_display_column_name=>'D'
,p_group_sort_direction=>'ASC'
,p_default_sort_direction=>'ASC'
,p_version_scn=>72475153
);
end;
/
prompt --application/shared_components/user_interface/lovs/fnd_users
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(48667231497347248)
,p_lov_name=>'FND_USERS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(user_name) u, user_name r',
'from wwv_flow_fnd_user',
'where security_group_id = :flow_security_group_id',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475153
);
end;
/
prompt --application/shared_components/user_interface/lovs/font_categories
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1362022415318990531)
,p_lov_name=>'FONT_CATEGORIES'
,p_lov_query=>'.'||wwv_flow_imp.id(1362022415318990531)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475153
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(497170667382843497)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Gender'
,p_lov_return_value=>'GENDER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(497171279425847351)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Hand'
,p_lov_return_value=>'HAND'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(497171505282849539)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Transportation'
,p_lov_return_value=>'TRANSPORTATION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1362022731262990536)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Web Application'
,p_lov_return_value=>'WEB_APPLICATION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1362023055345990537)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'File Type'
,p_lov_return_value=>'FILE_TYPE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1362023361612990537)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spinner'
,p_lov_return_value=>'SPINNER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1362023649634990537)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Form Control'
,p_lov_return_value=>'FORM_CONTROL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1362023956430990537)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Payment'
,p_lov_return_value=>'PAYMENT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1362024258223990538)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chart'
,p_lov_return_value=>'CHART'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1362024591404990538)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Currency'
,p_lov_return_value=>'CURRENCY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1362024827423990538)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Text Editor'
,p_lov_return_value=>'TEXT_EDITOR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1362025156564990538)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Directional'
,p_lov_return_value=>'DIRECTIONAL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1362025474226990538)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Video Player'
,p_lov_return_value=>'VIDEO_PLAYER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1362025761844990538)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Brand'
,p_lov_return_value=>'BRAND'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1362026047790990538)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Medical'
,p_lov_return_value=>'MEDICAL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1498481689694180020)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Calendar'
,p_lov_return_value=>'CALENDAR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1498482021426180027)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Emoji'
,p_lov_return_value=>'EMOJI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1498482476450180027)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Numbers'
,p_lov_return_value=>'NUMBERS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/format_mask
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(32743907454195192)
,p_lov_name=>'FORMAT MASK'
,p_lov_query=>'.'||wwv_flow_imp.id(32743907454195192)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475154
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(32744227838195194)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'$5,234.10'
,p_lov_return_value=>'FML999G999G999G999G990D00'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(32744409098195194)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'5,234.10'
,p_lov_return_value=>'FM999G999G999G999G990'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(32744605601195195)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'5,234.1000'
,p_lov_return_value=>'FM999G999G999G999G990D0000'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(32744816704195195)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'12-JAN-04'
,p_lov_return_value=>'DD-MON-RR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(32745005542195195)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'12-JAN-2004'
,p_lov_return_value=>'DD-MON-YYYY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(32745228650195198)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'12-JAN'
,p_lov_return_value=>'DD-MON'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(32745408887195198)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Monday, January 12th 2004'
,p_lov_return_value=>'FMDay, Month DDth YYYY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(32745602717195199)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'12-JAN-2004 14:30'
,p_lov_return_value=>'DD-MON-YYYY HH24:MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(102480222352871523)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'10-JAN-2004 14:22:10'
,p_lov_return_value=>'DD-MON-YYYY HH24:MI:SS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(32745830450195199)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'12-JAN-2004 2:30PM'
,p_lov_return_value=>'DD-MON-YYYY HH:MIPM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(32746002562195199)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'January'
,p_lov_return_value=>'Month'
);
end;
/
prompt --application/shared_components/user_interface/lovs/format_mask_for_charts
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(100170629844530853)
,p_lov_name=>'FORMAT.MASK.FOR.CHARTS'
,p_lov_query=>'.'||wwv_flow_imp.id(100170629844530853)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475154
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(100170923893530859)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'$5,234.10'
,p_lov_return_value=>'FML999G999G999G999G990D00'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(100171118880530862)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'5,234.10'
,p_lov_return_value=>'FM999,999,999,999,990.00'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(100171313816530862)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'5,234.1000'
,p_lov_return_value=>'FM999,999,999,999,990.0000'
);
end;
/
prompt --application/shared_components/user_interface/lovs/format_mask_for_charts_dynamic
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(44804526758842632)
,p_lov_name=>'FORMAT.MASK.FOR.CHARTS.DYNAMIC'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select to_char((5234.1),''FML999G999G999G999G990D00'') d, ''FML999G999G999G999G990D00'' r from dual',
'    union all',
'select trim(to_char((5234.1),''999G999G999G999G990D00'')) d, ''999G999G999G999G990D00'' r from dual',
'    union all',
'select trim(to_char((5234.1),''999G999G999G999G990D0000'')) d, ''999G999G999G999G990D0000'' r from dual',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475154
);
end;
/
prompt --application/shared_components/user_interface/lovs/format_mask_dynamic
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(44798420131812391)
,p_lov_name=>'FORMAT_MASK_DYNAMIC'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475154
);
end;
/
prompt --application/shared_components/user_interface/lovs/format_mask_dynamic_dates
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(114314002567890312)
,p_lov_name=>'FORMAT_MASK_DYNAMIC_DATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''D''',
'union all',
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''S''',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475154
);
end;
/
prompt --application/shared_components/user_interface/lovs/format_mask_dynamic_dates_no_since
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(170713321121898589)
,p_lov_name=>'FORMAT_MASK_DYNAMIC_DATES_NO_SINCE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''D'''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475154
);
end;
/
prompt --application/shared_components/user_interface/lovs/format_mask_dynamic_dates_timestamps
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(49243501559614579)
,p_lov_name=>'FORMAT_MASK_DYNAMIC_DATES_TIMESTAMPS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''D''',
'union all',
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''T''',
'union all',
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''S''',
'',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475154
);
end;
/
prompt --application/shared_components/user_interface/lovs/format_mask_dynamic_dates_timestamps_no_since
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(170713631164901556)
,p_lov_name=>'FORMAT_MASK_DYNAMIC_DATES_TIMESTAMPS_NO_SINCE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''D''',
'union all',
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''T''',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475154
);
end;
/
prompt --application/shared_components/user_interface/lovs/format_mask_dynamic_dates_timestamps_tzr
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(49243714718618311)
,p_lov_name=>'FORMAT_MASK_DYNAMIC_DATES_TIMESTAMPS_TZR'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''D''',
'union all',
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''Z''',
'union all',
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''S''',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475154
);
end;
/
prompt --application/shared_components/user_interface/lovs/format_mask_dynamic_dates_timestamps_tzr_no_since
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(170713910516904980)
,p_lov_name=>'FORMAT_MASK_DYNAMIC_DATES_TIMESTAMPS_TZR_NO_SINCE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''D''',
'union all',
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''T''',
'union all',
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''Z'''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475154
);
end;
/
prompt --application/shared_components/user_interface/lovs/format_mask_dynamic_numbers
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(441970320516445261)
,p_lov_name=>'FORMAT_MASK_DYNAMIC_NUMBERS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''N''',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475154
);
end;
/
prompt --application/shared_components/user_interface/lovs/format_mask_dynamic_w_download
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(189097425865243903)
,p_lov_name=>'FORMAT_MASK_DYNAMIC_W_DOWNLOAD'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r',
'  from (',
'select d, r, t',
'  from wwv_flow_format_masks',
'union',
'select wwv_flow_lang.system_message(''BLOB_FORMAT'') d, ''BLOB'' r, ''A''',
'  from dual',
'order by 3 desc)'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475154
);
end;
/
prompt --application/shared_components/user_interface/lovs/form_item_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(276983704971116375)
,p_lov_name=>'FORM_ITEM_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(276983704971116375)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475154
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(276983927598116379)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Data Entry Items'
,p_lov_return_value=>'FORM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(276984120590116380)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Display-Only Items'
,p_lov_return_value=>'DISPLAY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/form_on_sp_item_display_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(161974832535033307)
,p_lov_name=>'FORM_ON_SP.ITEM_DISPLAY_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(161974832535033307)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475154
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(24105515005047067)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Textarea'
,p_lov_return_value=>'NATIVE_TEXTAREA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(161975121396033308)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Display Only'
,p_lov_return_value=>'NATIVE_DISPLAY_ONLY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(161975324655033308)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Hidden'
,p_lov_return_value=>'NATIVE_HIDDEN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(161975507223033308)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Password'
,p_lov_return_value=>'NATIVE_PASSWORD'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(161975722167033309)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Text Field'
,p_lov_return_value=>'NATIVE_TEXT_FIELD'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(161976700263033310)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker'
,p_lov_return_value=>'NATIVE_DATE_PICKER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/form_pagination_tables_in_schema
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(8278125741110451)
,p_lov_name=>'FORM_PAGINATION_TABLES_IN_SCHEMA'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = :P165_OWNER'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475154
);
end;
/
prompt --application/shared_components/user_interface/lovs/form_validation_data_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(197490902498999083)
,p_lov_name=>'FORM_VALIDATION_DATA_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(197490902498999083)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475154
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(197491131615999084)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'NUMBER'
,p_lov_return_value=>'NUMBER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(197491316482999084)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'VARCHAR'
,p_lov_return_value=>'VARCHAR'
);
end;
/
prompt --application/shared_components/user_interface/lovs/fs_display_as
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(592389652645199591)
,p_lov_name=>'FS_DISPLAY_AS'
,p_lov_query=>'.'||wwv_flow_imp.id(592389652645199591)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475154
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(592389945959199592)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Report'
,p_lov_return_value=>'CR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(592390301964199592)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Cards'
,p_lov_return_value=>'CARD'
);
end;
/
prompt --application/shared_components/user_interface/lovs/genai_providers
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(3600433605650143)
,p_lov_name=>'GENAI_PROVIDERS'
,p_lov_query=>'.'||wwv_flow_imp.id(3600433605650143)||'.'
,p_location=>'STATIC'
,p_version_scn=>1102386007
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3601144019650157)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Open AI'
,p_lov_return_value=>'OPENAI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3600766280650156)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'OCI Generative AI Service'
,p_lov_return_value=>'OCI_GENAI'
,p_required_patch=>wwv_flow_imp.id(1727232450260741)
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3601508008650158)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Cohere'
,p_lov_return_value=>'COHERE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/generic_report_layout
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(141528024100206812)
,p_lov_name=>'GENERIC_REPORT_LAYOUT'
,p_lov_query=>'.'||wwv_flow_imp.id(141528024100206812)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475154
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(141542620899224770)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Create file based report layout'
,p_lov_return_value=>'FILE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(141528328048206813)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Use generic report layout'
,p_lov_return_value=>'GENERIC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/global_session_state_security
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(109607612170295323)
,p_lov_name=>'GLOBAL.SESSION.STATE.SECURITY'
,p_lov_query=>'.'||wwv_flow_imp.id(109607612170295323)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475154
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(109608209132295340)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Disable'
,p_lov_return_value=>'DISABLE'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>'select 1 from wwv_flows where id=:FB_FLOW_ID and nvl(page_protection_enabled_y_n,''N'') = ''Y'''
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(109608009604295340)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Enable'
,p_lov_return_value=>'ENABLE'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>'select 1 from wwv_flows where id=:FB_FLOW_ID and nvl(page_protection_enabled_y_n,''N'') = ''N'''
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(165639226722055203)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Configure'
,p_lov_return_value=>'ALL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/global_set_session_state_security
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(114140130498629709)
,p_lov_name=>'GLOBAL.SET.SESSION.STATE.SECURITY'
,p_lov_query=>'.'||wwv_flow_imp.id(114140130498629709)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475154
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(114140303209629712)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Enable'
,p_lov_return_value=>'APP_ONLY'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:9007:&SESSION.::&DEBUG.:9006:P526_ACTION:APP_ONLY"><img src="#IMAGE_PREFIX#htmldb/builder/edit_page.gif" height="75" width="100" alt="#DISPLAY_VALUE#" class="htmldbGreenIcons" /></a>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(114140503745629714)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Enable and Set'
,p_lov_return_value=>'ALL'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:9006:&SESSION.::&DEBUG.:9006:P526_ACTION:ALL"><img src="#IMAGE_PREFIX#htmldb/builder/edit_page.gif" height="75" width="100" alt="#DISPLAY_VALUE#" class="htmldbGreenIcons" /></a>'
);
end;
/
prompt --application/shared_components/user_interface/lovs/globalization_nls_comp
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(326783910743783589)
,p_lov_name=>'GLOBALIZATION.NLS_COMP'
,p_lov_query=>'.'||wwv_flow_imp.id(326783910743783589)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475154
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(340064531506850448)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Database session NLS setting (default)'
,p_lov_return_value=>'0'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(326784217193783591)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Binary'
,p_lov_return_value=>'BINARY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(326784521494783591)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Linguistic'
,p_lov_return_value=>'LINGUISTIC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/grid_layout_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(203356809012666718)
,p_lov_name=>'GRID_LAYOUT.TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(203356809012666718)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475154
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(203357017969666729)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'HTML Table'
,p_lov_return_value=>'TABLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(203357326722666733)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Fixed Number of Columns'
,p_lov_return_value=>'FIXED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(203357625148666733)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Variable Number of Columns'
,p_lov_return_value=>'VARIABLE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/group_picker
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(212924308633451870)
,p_lov_name=>'GROUP PICKER'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d, id ',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id',
'and security_group_id = :flow_security_group_id',
'order by upper(group_name)'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475154
);
end;
/
prompt --application/shared_components/user_interface/lovs/hash_function
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(367957504585280755)
,p_lov_name=>'HASH_FUNCTION'
,p_lov_query=>'.'||wwv_flow_imp.id(367957504585280755)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475154
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(367957804400280757)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'SHA-1 [Deprecated]'
,p_lov_return_value=>'SH1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(367958102306280760)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'SHA-2, 256 bit'
,p_lov_return_value=>'SH256'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(367958428314280760)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'SHA-2, 384 bit'
,p_lov_return_value=>'SH384'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(367958707602280760)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'SHA-2, 512 bit'
,p_lov_return_value=>'SH512'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(367959005808280761)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'MD5 [Deprecated]'
,p_lov_return_value=>'MD5'
);
end;
/
prompt --application/shared_components/user_interface/lovs/hidden_or_hidden_and_protected
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(131237822858809392)
,p_lov_name=>'HIDDEN OR HIDDEN AND PROTECTED'
,p_lov_query=>'.'||wwv_flow_imp.id(131237822858809392)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475154
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(131238012226809394)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Hidden and Protected'
,p_lov_return_value=>'HIDDEN_PROTECTED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(131238205714809394)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Hidden'
,p_lov_return_value=>'HIDDEN'
);
end;
/
prompt --application/shared_components/user_interface/lovs/home_page_display_mode
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(430811903296261990)
,p_lov_name=>'HOME PAGE DISPLAY MODE'
,p_lov_query=>'.'||wwv_flow_imp.id(430811903296261990)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475154
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(430812126757261993)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Use Icons'
,p_lov_return_value=>'ICONS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(430812320446262006)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Use Buttons'
,p_lov_return_value=>'BUTTONS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/horizontal_n_vertical_y
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(148121507217144506)
,p_lov_name=>'HORIZONTAL_N_VERTICAL_Y'
,p_lov_query=>'.'||wwv_flow_imp.id(148121507217144506)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475154
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(148122607695144519)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Horizontal'
,p_lov_return_value=>'N'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(148123400557144527)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Vertical'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/html_escaping_mode
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(314983827117600277)
,p_lov_name=>'HTML_ESCAPING_MODE'
,p_lov_query=>'.'||wwv_flow_imp.id(314983827117600277)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475154
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(314984126950600278)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Basic'
,p_lov_return_value=>'B'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(314984408541600278)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Extended'
,p_lov_return_value=>'E'
);
end;
/
prompt --application/shared_components/user_interface/lovs/http_response_header
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(137613906194173724)
,p_lov_name=>'HTTP_RESPONSE_HEADER'
,p_lov_query=>'.'||wwv_flow_imp.id(137613906194173724)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475154
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(137614421689173725)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Report Settings'
,p_lov_return_value=>'APEX'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(137614228757173725)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Print Server'
,p_lov_return_value=>'SERVER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/i18n_iana_charset
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(144796827445692396)
,p_lov_name=>'I18N_IANA_CHARSET'
,p_lov_query=>'.'||wwv_flow_imp.id(144796827445692396)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475154
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9135511113548516)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Unicode UTF-16 Little Endian'
,p_lov_return_value=>'utf-16le'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9205201229849121)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Unicode UTF-16 Big Endian'
,p_lov_return_value=>'utf-16be'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(69601501664557233)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'US-ASCII'
,p_lov_return_value=>'us-ascii'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144797117419692400)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Arabic ISO-8859-6'
,p_lov_return_value=>'iso-8859-6'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144797316057692402)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Arabic Windows 1256'
,p_lov_return_value=>'windows-1256'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144797500330692402)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Chinese Big5'
,p_lov_return_value=>'big5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144797708396692402)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Chinese GBK'
,p_lov_return_value=>'gbk'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144797916474692403)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Cyrilic ISO-8859-5'
,p_lov_return_value=>'iso-8859-5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144798131344692405)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Cyrilic KOI8-R'
,p_lov_return_value=>'koi8-r'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144798312837692405)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Cyrilic KOI8-U'
,p_lov_return_value=>'koi8-u'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144798504968692405)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Cyrilic Windows 1251'
,p_lov_return_value=>'windows-1251'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144798718838692405)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Eastern European ISO-8859-2'
,p_lov_return_value=>'iso-8859-2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144798932645692407)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Eastern European Windows 1250'
,p_lov_return_value=>'windows-1250'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144799110457692407)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Greek ISO-8859-7'
,p_lov_return_value=>'iso-8859-7'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144799314923692407)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Greek Windows 1253'
,p_lov_return_value=>'windows-1253'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144799532216692407)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Hebrew ISO-8859-8-i'
,p_lov_return_value=>'iso-8859-8-i'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144799706409692408)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Hebrew Windows 1255'
,p_lov_return_value=>'windows-1255'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144799927372692408)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Japanese EUC'
,p_lov_return_value=>'euc-jp'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144800108899692408)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Japanese Shift JIS'
,p_lov_return_value=>'shift_jis'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144800330988692408)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Korean EUC'
,p_lov_return_value=>'euc-kr'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144800519069692409)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Northern European ISO-8859-4'
,p_lov_return_value=>'iso-8859-4'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144800711990692409)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Northern European Windows 1257'
,p_lov_return_value=>'windows-1257'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144800919398692409)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Southern European ISO-8859-3'
,p_lov_return_value=>'iso-8859-3'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144801121569692409)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Thai TIS-620'
,p_lov_return_value=>'tis-620'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144801321138692410)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Turkish ISO-8859-9'
,p_lov_return_value=>'iso-8859-9'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144801513548692410)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Turkish Windows 1254'
,p_lov_return_value=>'windows-1254'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144801730411692410)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Unicode UTF-8'
,p_lov_return_value=>'utf-8'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144801927440692410)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Vietnamese Windows 1258'
,p_lov_return_value=>'windows-1258'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144802114623692411)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Western European ISO-8859-1'
,p_lov_return_value=>'iso-8859-1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144802329838692411)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Western European Windows 1252'
,p_lov_return_value=>'windows-1252'
);
end;
/
prompt --application/shared_components/user_interface/lovs/i18n_iana_db_charset
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(144802427115692411)
,p_lov_name=>'I18N_IANA_DB_CHARSET'
,p_lov_query=>'.'||wwv_flow_imp.id(144802427115692411)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475154
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144802705132692411)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic ISO-8859-6'
,p_lov_return_value=>'AR8ISO8859P6'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144802901122692412)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Arabic Windows 1256'
,p_lov_return_value=>'AR8MSWIN1256'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144803127029692412)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Chinese Big5'
,p_lov_return_value=>'ZHT16MSWIN950'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144803324377692412)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Chinese GBK'
,p_lov_return_value=>'ZHS16GBK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144803513705692412)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Cyrilic ISO-8859-5'
,p_lov_return_value=>'CL8ISO8859P5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144803729051692412)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Cyrilic KOI8-R'
,p_lov_return_value=>'CL8KOI8R'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144803903575692413)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Cyrilic KOI8-U'
,p_lov_return_value=>'CL8KOI8U'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144804107518692413)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Cyrilic Windows 1251'
,p_lov_return_value=>'CL8MSWIN1251'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144804326415692413)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'Eastern European ISO-8859-2'
,p_lov_return_value=>'EE8ISO8859P2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144804519494692413)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'Eastern European Windows 1250'
,p_lov_return_value=>'EE8MSWIN1250'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144804719388692414)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'Greek ISO-8859-7'
,p_lov_return_value=>'EL8ISO8859P7'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144804930073692414)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'Greek Windows 1253'
,p_lov_return_value=>'EL8MSWIN1253'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144805102017692414)
,p_lov_disp_sequence=>130
,p_lov_disp_value=>'Hebrew ISO-8859-8-i'
,p_lov_return_value=>'IW8ISO8859P8'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144805316824692414)
,p_lov_disp_sequence=>140
,p_lov_disp_value=>'Hebrew Windows 1255'
,p_lov_return_value=>'IW8MSWIN1255'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144805529478692415)
,p_lov_disp_sequence=>150
,p_lov_disp_value=>'Japanese EUC'
,p_lov_return_value=>'JA16EUC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144805708758692415)
,p_lov_disp_sequence=>160
,p_lov_disp_value=>'Japanese Shift JIS'
,p_lov_return_value=>'JA16SJIS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144805930377692415)
,p_lov_disp_sequence=>170
,p_lov_disp_value=>'Korean EUC'
,p_lov_return_value=>'KO16MSWIN949'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144806119293692416)
,p_lov_disp_sequence=>180
,p_lov_disp_value=>'Northern European ISO-8859-4'
,p_lov_return_value=>'NEE8ISO8859P4'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144806300284692416)
,p_lov_disp_sequence=>190
,p_lov_disp_value=>'Northern European Windows 1257'
,p_lov_return_value=>'BLT8MSWIN1257'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144806517452692416)
,p_lov_disp_sequence=>200
,p_lov_disp_value=>'Southern European ISO-8859-3'
,p_lov_return_value=>'SE8ISO8859P3'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144806722982692416)
,p_lov_disp_sequence=>210
,p_lov_disp_value=>'Thai TIS-620'
,p_lov_return_value=>'TH8TISASCII'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144806902960692420)
,p_lov_disp_sequence=>220
,p_lov_disp_value=>'Turkish ISO-8859-9'
,p_lov_return_value=>'WE8ISO8859P9'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144807116856692420)
,p_lov_disp_sequence=>230
,p_lov_disp_value=>'Turkish Windows 1254'
,p_lov_return_value=>'TR8MSWIN1254'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144807330588692420)
,p_lov_disp_sequence=>240
,p_lov_disp_value=>'Unicode UTF-8'
,p_lov_return_value=>'AL32UTF8'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9135825312552564)
,p_lov_disp_sequence=>242
,p_lov_disp_value=>'Unicode UTF-16 Big Endian'
,p_lov_return_value=>'AL16UTF16'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9136032238554585)
,p_lov_disp_sequence=>244
,p_lov_disp_value=>'Unicode UTF-16 Little Endian'
,p_lov_return_value=>'AL16UTF16LE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(69721018333590467)
,p_lov_disp_sequence=>248
,p_lov_disp_value=>'US-ASCII'
,p_lov_return_value=>'US7ASCII'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144807508184692421)
,p_lov_disp_sequence=>250
,p_lov_disp_value=>'Vietnamese Windows 1258'
,p_lov_return_value=>'VN8MSWIN1258'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144807715067692421)
,p_lov_disp_sequence=>260
,p_lov_disp_value=>'Western European ISO-8859-1'
,p_lov_return_value=>'WE8ISO8859P1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(144807907122692421)
,p_lov_disp_sequence=>270
,p_lov_disp_value=>'Western European Windows 1252'
,p_lov_return_value=>'WE8MSWIN1252'
);
end;
/
prompt --application/shared_components/user_interface/lovs/i18n_languages_locales
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(107899321117195063)
,p_lov_name=>'I18N_LANGUAGES_LOCALES'
,p_lov_query=>'.'||wwv_flow_imp.id(107899321117195063)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475156
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(62331376945397671)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Azerbaijani (az)'
,p_lov_return_value=>'az'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(109801549002953044)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Serbian (Cyrillic)(sr-cyrl)'
,p_lov_return_value=>'sr-cyrl'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(109801808436950709)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Serbian (Latin)(sr-latn)'
,p_lov_return_value=>'sr-latn'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198763720924437003)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Afrikaans (af)'
,p_lov_return_value=>'af'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198763917931437003)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (ar)'
,p_lov_return_value=>'ar'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198764111074437003)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Algeria) (ar-dz)'
,p_lov_return_value=>'ar-dz'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198764302926437004)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Bahrain) (ar-bh)'
,p_lov_return_value=>'ar-bh'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198764518950437004)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Egypt) (ar-eg)'
,p_lov_return_value=>'ar-eg'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198764707881437004)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Iraq) (ar-iq)'
,p_lov_return_value=>'ar-iq'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198764920585437004)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Jordan) (ar-jo)'
,p_lov_return_value=>'ar-jo'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198765125710437005)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Kuwait) (ar-kw)'
,p_lov_return_value=>'ar-kw'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198765301909437005)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Lebanon) (ar-lb)'
,p_lov_return_value=>'ar-lb'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198765514908437005)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Libya) (ar-ly)'
,p_lov_return_value=>'ar-ly'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198765710657437005)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Morocco) (ar-ma)'
,p_lov_return_value=>'ar-ma'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198765921945437006)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Oman) (ar-om)'
,p_lov_return_value=>'ar-om'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198766127407437006)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Qatar) (ar-qa)'
,p_lov_return_value=>'ar-qa'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198766300363437006)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Saudi Arabia) (ar-sa)'
,p_lov_return_value=>'ar-sa'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198766505773437006)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Syria) (ar-sy)'
,p_lov_return_value=>'ar-sy'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198766707839437007)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Tunisia) (ar-tn)'
,p_lov_return_value=>'ar-tn'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198766917417437007)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (U.A.E.) (ar-ae)'
,p_lov_return_value=>'ar-ae'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198767112053437007)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Arabic (Yemen) (ar-ye)'
,p_lov_return_value=>'ar-ye'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198767312340437007)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Assamese (as)'
,p_lov_return_value=>'as'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198767522099437008)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Basque (eu)'
,p_lov_return_value=>'eu'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198767726246437008)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Belarusian (be)'
,p_lov_return_value=>'be'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198767919601437008)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Bengali (bn)'
,p_lov_return_value=>'bn'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198768103556437008)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Bulgarian (bg)'
,p_lov_return_value=>'bg'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198768313681437009)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Catalan (ca)'
,p_lov_return_value=>'ca'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198768503476437009)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinese (zh)'
,p_lov_return_value=>'zh'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198768717157437009)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinese (China) (zh-cn)'
,p_lov_return_value=>'zh-cn'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198768915177437009)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinese (Hong Kong SAR) (zh-hk)'
,p_lov_return_value=>'zh-hk'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198769104560437010)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinese (Macau SAR) (zh-mo)'
,p_lov_return_value=>'zh-mo'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198769309316437010)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinese (Singapore) (zh-sg)'
,p_lov_return_value=>'zh-sg'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198769519659437010)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinese (Taiwan) (zh-tw)'
,p_lov_return_value=>'zh-tw'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198769707113437011)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Croatian (hr)'
,p_lov_return_value=>'hr'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198769930859437011)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Czech (cs)'
,p_lov_return_value=>'cs'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198770121194437011)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Danish (da)'
,p_lov_return_value=>'da'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198770321280437011)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Dutch (Belgium) (nl-be)'
,p_lov_return_value=>'nl-be'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198770514114437012)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Dutch (Netherlands) (nl)'
,p_lov_return_value=>'nl'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198770704682437012)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (en)'
,p_lov_return_value=>'en'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198770926869437012)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (Australia) (en-au)'
,p_lov_return_value=>'en-au'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198771101039437012)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (Belize) (en-bz)'
,p_lov_return_value=>'en-bz'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198771311078437013)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (Canada) (en-ca)'
,p_lov_return_value=>'en-ca'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198771515830437013)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (Ireland) (en-ie)'
,p_lov_return_value=>'en-ie'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198771701647437013)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (Jamaica) (en-jm)'
,p_lov_return_value=>'en-jm'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198771911421437013)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (New Zealand) (en-nz)'
,p_lov_return_value=>'en-nz'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198772116247437014)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (Philippines) (en-ph)'
,p_lov_return_value=>'en-ph'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198772303293437014)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (South Africa) (en-za)'
,p_lov_return_value=>'en-za'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198772506232437014)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (Trinidad) (en-tt)'
,p_lov_return_value=>'en-tt'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198772709014437014)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (United Kingdom) (en-gb)'
,p_lov_return_value=>'en-gb'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198772921663437015)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (United States) (en-us)'
,p_lov_return_value=>'en-us'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198773103842437015)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English (Zimbabwe) (en-zw)'
,p_lov_return_value=>'en-zw'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198773302783437015)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Estonian (et)'
,p_lov_return_value=>'et'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198773520055437015)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'FYRO Macedonian (mk)'
,p_lov_return_value=>'mk'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198773712018437016)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Faeroese (fo)'
,p_lov_return_value=>'fo'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198773905928437016)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Farsi (fa)'
,p_lov_return_value=>'fa'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198774118945437016)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'French (Switzerland) (fr-ch)'
,p_lov_return_value=>'fr-ch'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198774304989437016)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Finnish (fi)'
,p_lov_return_value=>'fi'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198774521702437017)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'French (Belgium) (fr-be)'
,p_lov_return_value=>'fr-be'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198774726368437017)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'French (Canada) (fr-ca)'
,p_lov_return_value=>'fr-ca'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198774928038437017)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'French (France) (fr)'
,p_lov_return_value=>'fr'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198775114927437017)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'French (Luxembourg) (fr-lu)'
,p_lov_return_value=>'fr-lu'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198775332434437018)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'French (Monaco) (fr-mc)'
,p_lov_return_value=>'fr-mc'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198775527857437018)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Gaelic (gd)'
,p_lov_return_value=>'gd'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198775711321437018)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Galician (gl)'
,p_lov_return_value=>'gl'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198775904103437018)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'German (Austria) (de-at)'
,p_lov_return_value=>'de-at'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198776121734437019)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'German (Germany) (de)'
,p_lov_return_value=>'de'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198776332647437019)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'German (Liechtenstein) (de-li)'
,p_lov_return_value=>'de-li'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198776529287437019)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'German (Luxemgourg) (de-lu)'
,p_lov_return_value=>'de-lu'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198776722310437019)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'German (Switzerland) (de-ch)'
,p_lov_return_value=>'de-ch'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198776930154437020)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Greek (el)'
,p_lov_return_value=>'el'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198777117663437020)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Gujarati (gu)'
,p_lov_return_value=>'gu'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198777314234437020)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Hebrew (he)'
,p_lov_return_value=>'he'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198777520312437020)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Hindi (hi)'
,p_lov_return_value=>'hi'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198777700475437021)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Hungarian (hu)'
,p_lov_return_value=>'hu'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198777911922437021)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Icelandic (is)'
,p_lov_return_value=>'is'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198778128567437021)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Indonesian (id)'
,p_lov_return_value=>'id'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198778324997437021)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Italian (Italy) (it)'
,p_lov_return_value=>'it'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198778510434437022)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Italian (Switzerland) (it-ch)'
,p_lov_return_value=>'it-ch'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198778714304437022)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Japanese (ja)'
,p_lov_return_value=>'ja'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198778912949437022)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Kannada (kn)'
,p_lov_return_value=>'kn'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198779115578437022)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Kazakh (kk)'
,p_lov_return_value=>'kk'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198779329622437023)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Konkani (kok)'
,p_lov_return_value=>'kok'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198779521470437023)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Korean (ko)'
,p_lov_return_value=>'ko'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198779730912437023)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Kyrgyz (kz)'
,p_lov_return_value=>'kz'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198779928215437023)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Latvian (lv)'
,p_lov_return_value=>'lv'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198780118707437024)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Lithuanian (lt)'
,p_lov_return_value=>'lt'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198780313346437024)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Malay (Malaysia) (ms)'
,p_lov_return_value=>'ms'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198780501262437024)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Malayalam (ml)'
,p_lov_return_value=>'ml'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198780716986437024)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Maltese (mt)'
,p_lov_return_value=>'mt'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198780925915437025)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Marathi (mr)'
,p_lov_return_value=>'mr'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198781122126437025)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Nepali (India) (ne)'
,p_lov_return_value=>'ne'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198781323201437025)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Norwegian (Bokmal) (nb-no)'
,p_lov_return_value=>'nb-no'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198781531339437026)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Norwegian (Bokmal) (no)'
,p_lov_return_value=>'no'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198781717582437026)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Norwegian (Nynorsk) (nn-no)'
,p_lov_return_value=>'nn-no'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198781901148437026)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Oriya (or)'
,p_lov_return_value=>'or'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198782123357437026)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Polish (pl)'
,p_lov_return_value=>'pl'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198782308585437026)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Portuguese (Brazil) (pt-br)'
,p_lov_return_value=>'pt-br'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198782515205437027)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Portuguese (Portugal) (pt)'
,p_lov_return_value=>'pt'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198782712809437027)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Punjabi (pa)'
,p_lov_return_value=>'pa'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198782926250437027)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Romanian (ro)'
,p_lov_return_value=>'ro'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198783103701437028)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Russian (ru)'
,p_lov_return_value=>'ru'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198783313683437028)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Russian (Moldova) (ru-md)'
,p_lov_return_value=>'ru-md'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198783525893437028)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Serbian (sr)'
,p_lov_return_value=>'sr'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198783706765437028)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Slovak (sk)'
,p_lov_return_value=>'sk'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198783923934437029)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Slovenian (sl)'
,p_lov_return_value=>'sl'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198784123775437029)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Argentina) (es-ar)'
,p_lov_return_value=>'es-ar'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198784305305437029)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Bolivia) (es-bo)'
,p_lov_return_value=>'es-bo'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198784503555437029)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Chile) (es-cl)'
,p_lov_return_value=>'es-cl'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198784728332437030)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Colombia) (es-co)'
,p_lov_return_value=>'es-co'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198784908380437030)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Costa Rica) (es-cr)'
,p_lov_return_value=>'es-cr'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198785110585437030)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Dominican Republic) (es-do)'
,p_lov_return_value=>'es-do'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198785309022437030)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Ecuador) (es-ec)'
,p_lov_return_value=>'es-ec'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198785513360437031)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (El Salvador) (es-sv)'
,p_lov_return_value=>'es-sv'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198785722922437031)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Guatemala) (es-gt)'
,p_lov_return_value=>'es-gt'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198785903148437031)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Honduras) (es-hn)'
,p_lov_return_value=>'es-hn'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198786119876437031)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Mexico) (es-mx)'
,p_lov_return_value=>'es-mx'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198786323820437032)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Nicaragua) (es-ni)'
,p_lov_return_value=>'es-ni'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198786501745437032)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Panama) (es-pa)'
,p_lov_return_value=>'es-pa'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198786728889437032)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Paraguay) (es-py)'
,p_lov_return_value=>'es-py'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198786926053437032)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Peru) (es-pe)'
,p_lov_return_value=>'es-pe'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198787110239437033)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Puerto Rico) (es-pr)'
,p_lov_return_value=>'es-pr'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198787325084437033)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Traditional Sort) (es)'
,p_lov_return_value=>'es'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198787517364437033)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (United States) (es-us)'
,p_lov_return_value=>'es-us'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198787727100437033)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Uruguay) (es-uy)'
,p_lov_return_value=>'es-uy'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198787927315437033)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish (Venezuela) (es-ve)'
,p_lov_return_value=>'es-ve'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198788117011437034)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Swedish (sv)'
,p_lov_return_value=>'sv'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198788328010437034)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Swedish (Finland) (sv-fi)'
,p_lov_return_value=>'sv-fi'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198788517641437034)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Tamil (ta)'
,p_lov_return_value=>'ta'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198788706442437034)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Telugu (te)'
,p_lov_return_value=>'te'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198788903837437035)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Thai (th)'
,p_lov_return_value=>'th'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198789120777437035)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Turkish (tr)'
,p_lov_return_value=>'tr'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198789331021437035)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Ukrainian (uk)'
,p_lov_return_value=>'uk'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198789522886437035)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Urdu (ur)'
,p_lov_return_value=>'ur'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198789714421437036)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Uzbek (uz)'
,p_lov_return_value=>'uz'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198789914419437036)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Vietnamese (vi)'
,p_lov_return_value=>'vi'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296350229258484071)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Bosnian (ba)'
,p_lov_return_value=>'ba'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(296350523577489031)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Montenegrin (me)'
,p_lov_return_value=>'me'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(315594104997431311)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Irish (ga)'
,p_lov_return_value=>'ga'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(315594428276435636)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Welsh (cy)'
,p_lov_return_value=>'cy'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(398755246199483774)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Swahili (sw)'
,p_lov_return_value=>'sw'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2379664228886224616)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Albanian'
,p_lov_return_value=>'sq'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2379664559826228007)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Armenian'
,p_lov_return_value=>'hy'
);
end;
/
prompt --application/shared_components/user_interface/lovs/i18n_languages_locales_mapped_to_fb_flow_id
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(756583801210846491)
,p_lov_name=>'I18N_LANGUAGES_LOCALES_MAPPED_TO_FB_FLOW_ID'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.text_from_lov(translation_flow_language_code,''I18N_LANGUAGES_LOCALES'') d,',
'       translation_flow_id r',
'from   wwv_flow_language_map',
'where  security_group_id = :flow_security_group_id',
'  and  primary_language_flow_id = :FB_FLOW_ID',
'order  by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475170
);
end;
/
prompt --application/shared_components/user_interface/lovs/i18n_territories
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(634612723768159258)
,p_lov_name=>'I18N_TERRITORIES'
,p_lov_query=>'.'||wwv_flow_imp.id(634612723768159258)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475170
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(62332080749407778)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Azerbaijan'
,p_lov_return_value=>'AZERBAIJAN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634612925634159272)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Algeria'
,p_lov_return_value=>'ALGERIA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634617325415178665)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'America'
,p_lov_return_value=>'AMERICA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634617416564179068)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Argentina'
,p_lov_return_value=>'ARGENTINA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634617520069179068)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Australia'
,p_lov_return_value=>'AUSTRALIA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634617601920179068)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Austria'
,p_lov_return_value=>'AUSTRIA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634617719730179068)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Bahrain'
,p_lov_return_value=>'BAHRAIN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634617805450179068)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Bangladesh'
,p_lov_return_value=>'BANGLADESH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634617904577179068)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Belgium'
,p_lov_return_value=>'BELGIUM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634618014801179068)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Brazil'
,p_lov_return_value=>'BRAZIL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634618131872179068)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Bulgaria'
,p_lov_return_value=>'BULGARIA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634618228314179068)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Canada'
,p_lov_return_value=>'CANADA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634618317133179068)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Catalonia'
,p_lov_return_value=>'CATALONIA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634618420611179068)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chile'
,p_lov_return_value=>'CHILE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634618517466179069)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'China'
,p_lov_return_value=>'CHINA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634618625184179069)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Colombia'
,p_lov_return_value=>'COLOMBIA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634618732595179069)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Costa Rica'
,p_lov_return_value=>'COSTA RICA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634618800875179069)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Croatia'
,p_lov_return_value=>'CROATIA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634618907315179069)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Czech Republic'
,p_lov_return_value=>'CZECH REPUBLIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634619005552179069)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Denmark'
,p_lov_return_value=>'DENMARK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634619102819179069)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Ecuador'
,p_lov_return_value=>'ECUADOR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634619206088179069)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Egypt'
,p_lov_return_value=>'EGYPT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634619329332179070)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'El Salvador'
,p_lov_return_value=>'EL SALVADOR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634619417007179070)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Estonia'
,p_lov_return_value=>'ESTONIA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634619515038179070)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Finland'
,p_lov_return_value=>'FINLAND'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634619624034179070)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'France'
,p_lov_return_value=>'FRANCE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634619712611179070)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Macedonia'
,p_lov_return_value=>'FYR MACEDONIA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634619819469179070)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Germany'
,p_lov_return_value=>'GERMANY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634619901797179070)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Greece'
,p_lov_return_value=>'GREECE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634620000995179070)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Guatemala'
,p_lov_return_value=>'GUATEMALA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634620128980179070)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Hong Kong'
,p_lov_return_value=>'HONG KONG'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634620216260179070)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Hungary'
,p_lov_return_value=>'HUNGARY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634620321313179070)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Iceland'
,p_lov_return_value=>'ICELAND'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634620414838179070)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'India'
,p_lov_return_value=>'INDIA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634620531315179070)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Indonesia'
,p_lov_return_value=>'INDONESIA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634620623190179070)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Iraq'
,p_lov_return_value=>'IRAQ'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634620713620179070)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Ireland'
,p_lov_return_value=>'IRELAND'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634620825502179070)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Israel'
,p_lov_return_value=>'ISRAEL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634620901008179070)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Italy'
,p_lov_return_value=>'ITALY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634621030274179070)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Japan'
,p_lov_return_value=>'JAPAN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634621118591179070)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Jordan'
,p_lov_return_value=>'JORDAN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634621221080179071)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Kazakhstan'
,p_lov_return_value=>'KAZAKHSTAN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634621324332179071)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Korea'
,p_lov_return_value=>'KOREA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634621428808179071)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Kuwait'
,p_lov_return_value=>'KUWAIT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634621523349179071)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Latvia'
,p_lov_return_value=>'LATVIA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634621617780179071)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Lebanon'
,p_lov_return_value=>'LEBANON'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634621730434179071)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Libya'
,p_lov_return_value=>'LIBYA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634621829023179071)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Lithuania'
,p_lov_return_value=>'LITHUANIA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634621931936179071)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Luxembourg'
,p_lov_return_value=>'LUXEMBOURG'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634622011057179071)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Malaysia'
,p_lov_return_value=>'MALAYSIA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634622121433179071)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Mexico'
,p_lov_return_value=>'MEXICO'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634622209971179071)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Morocco'
,p_lov_return_value=>'MOROCCO'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634622316274179071)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'New Zealand'
,p_lov_return_value=>'NEW ZEALAND'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634622424344179071)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Nicaragua'
,p_lov_return_value=>'NICARAGUA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634622503049179071)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Norway'
,p_lov_return_value=>'NORWAY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634622621796179071)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Oman'
,p_lov_return_value=>'OMAN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634622713614179071)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Panama'
,p_lov_return_value=>'PANAMA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634622824986179071)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Peru'
,p_lov_return_value=>'PERU'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634622920268179071)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Philippines'
,p_lov_return_value=>'PHILIPPINES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634623021563179072)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Poland'
,p_lov_return_value=>'POLAND'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634623129496179072)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Portugal'
,p_lov_return_value=>'PORTUGAL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634623217645179072)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Puerto Rico'
,p_lov_return_value=>'PUERTO RICO'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634623330760179072)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Qatar'
,p_lov_return_value=>'QATAR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634623423279179072)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Romania'
,p_lov_return_value=>'ROMANIA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634623511418179072)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Russia'
,p_lov_return_value=>'RUSSIA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634623619236179072)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Saudi Arabia'
,p_lov_return_value=>'SAUDI ARABIA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634623720537179072)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Serbia and Montenegro'
,p_lov_return_value=>'SERBIA AND MONTENEGRO'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634623812184179072)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Singapore'
,p_lov_return_value=>'SINGAPORE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634623911000179072)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Slovakia'
,p_lov_return_value=>'SLOVAKIA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634624029069179072)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Slovenia'
,p_lov_return_value=>'SLOVENIA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634624129059179072)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'South Africa'
,p_lov_return_value=>'SOUTH AFRICA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634624207346179072)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spain'
,p_lov_return_value=>'SPAIN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634624313399179072)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Sweden'
,p_lov_return_value=>'SWEDEN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634624425936179076)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Switzerland'
,p_lov_return_value=>'SWITZERLAND'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634624529496179076)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Syria'
,p_lov_return_value=>'SYRIA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634624617557179077)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Taiwan'
,p_lov_return_value=>'TAIWAN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634624710505179077)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Thailand'
,p_lov_return_value=>'THAILAND'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634624807493179077)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Netherlands'
,p_lov_return_value=>'THE NETHERLANDS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634624919495179077)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Tunisia'
,p_lov_return_value=>'TUNISIA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634625012403179077)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Turkey'
,p_lov_return_value=>'TURKEY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634625126075179077)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Ukraine'
,p_lov_return_value=>'UKRAINE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634625205397179077)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'United Arab Emirates'
,p_lov_return_value=>'UNITED ARAB EMIRATES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634625306022179077)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'United Kingdom'
,p_lov_return_value=>'UNITED KINGDOM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634625413970179077)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Uzbekistan'
,p_lov_return_value=>'UZBEKISTAN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634625513954179077)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Venezuela'
,p_lov_return_value=>'VENEZUELA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634625626005179077)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Vietnam'
,p_lov_return_value=>'VIETNAM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(634625710240179077)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Yemen'
,p_lov_return_value=>'YEMEN'
);
end;
/
prompt --application/shared_components/user_interface/lovs/icon_animation
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(577722878770995845)
,p_lov_name=>'ICON ANIMATION'
,p_lov_query=>'.'||wwv_flow_imp.id(577722878770995845)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475175
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577723171929995847)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Spin'
,p_lov_return_value=>'fa-anim-spin'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577723576533995850)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Spin in Steps'
,p_lov_return_value=>'fa-anim-spin-step'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577723961937995850)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Flash'
,p_lov_return_value=>'fa-anim-flash'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577724321745995850)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Horizontal Shake'
,p_lov_return_value=>'fa-anim-horizontal-shake'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577724777139995850)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Vertical Shake'
,p_lov_return_value=>'fa-anim-vertical-shake'
);
end;
/
prompt --application/shared_components/user_interface/lovs/icon_categories
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(577691284053554107)
,p_lov_name=>'ICON CATEGORIES'
,p_lov_query=>'.'||wwv_flow_imp.id(577691284053554107)||'.'
,p_location=>'STATIC'
,p_version_scn=>69500087
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577691593627554111)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Accessibility'
,p_lov_return_value=>'ACCESSIBILITY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1428525045907176)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'AI'
,p_lov_return_value=>'AI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1428195343907176)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Business'
,p_lov_return_value=>'BUSINESS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577691952823554114)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Calendar'
,p_lov_return_value=>'CALENDAR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577692301824554114)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Chart'
,p_lov_return_value=>'CHART'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577692726882554115)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Currency'
,p_lov_return_value=>'CURRENCY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577693122003554115)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Directional'
,p_lov_return_value=>'DIRECTIONAL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577693541847554115)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Emoji'
,p_lov_return_value=>'EMOJI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577693922238554115)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'File Type'
,p_lov_return_value=>'FILE_TYPE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577694301523554116)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Form Control'
,p_lov_return_value=>'FORM_CONTROL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577694781188554116)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Gender'
,p_lov_return_value=>'GENDER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577695129448554116)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'Hand'
,p_lov_return_value=>'HAND'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(610340742405479426)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>'Maps'
,p_lov_return_value=>'MAPS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577695507696554116)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>'Medical'
,p_lov_return_value=>'MEDICAL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577695969229554116)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'Numbers'
,p_lov_return_value=>'NUMBERS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577696377143554117)
,p_lov_disp_sequence=>16
,p_lov_disp_value=>'Payment'
,p_lov_return_value=>'PAYMENT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577696741617554117)
,p_lov_disp_sequence=>17
,p_lov_disp_value=>'Spinner'
,p_lov_return_value=>'SPINNER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577697186360554125)
,p_lov_disp_sequence=>18
,p_lov_disp_value=>'Text Editor'
,p_lov_return_value=>'TEXT_EDITOR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577697771170564752)
,p_lov_disp_sequence=>19
,p_lov_disp_value=>'Transportation'
,p_lov_return_value=>'TRANSPORTATION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577698096318564753)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Video Player'
,p_lov_return_value=>'VIDEO_PLAYER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577698486427564753)
,p_lov_disp_sequence=>21
,p_lov_disp_value=>'Web Application'
,p_lov_return_value=>'WEB_APPLICATION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/icon_modifier
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(577742586590147796)
,p_lov_name=>'ICON MODIFIER'
,p_lov_query=>'.'||wwv_flow_imp.id(577742586590147796)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475175
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577742891771147796)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'25 Percent'
,p_lov_return_value=>'fam-25-percent'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577743228175147797)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'50 Percent'
,p_lov_return_value=>'fam-50-percent'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577743621479147797)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'75 Percent'
,p_lov_return_value=>'fam-75-percent'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577744006243147798)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'100 Percent'
,p_lov_return_value=>'fam-100-percent'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577744453509147798)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Arrow Down'
,p_lov_return_value=>'fam-arrow-down'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577744861593147798)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Arrow Left'
,p_lov_return_value=>'fam-arrow-left'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577745253038147799)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Arrow Right'
,p_lov_return_value=>'fam-arrow-right'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577745695304147799)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Arrow Up'
,p_lov_return_value=>'fam-arrow-up'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577746022797147800)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Blank'
,p_lov_return_value=>'fam-blank'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577746460643147800)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Check'
,p_lov_return_value=>'fam-check'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577746806145147800)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Circle'
,p_lov_return_value=>'fam-circle'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577747264625147800)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'Clock'
,p_lov_return_value=>'fam-clock'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577747665892147800)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>'Ellipsis Horizontal'
,p_lov_return_value=>'fam-ellipsis-h'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577748081928147801)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>'Ellipsis Vertical'
,p_lov_return_value=>'fam-ellipsis-v'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577748430278147801)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'Heart'
,p_lov_return_value=>'fam-heart'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577748910803151858)
,p_lov_disp_sequence=>16
,p_lov_disp_value=>'Information'
,p_lov_return_value=>'fam-information'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577749226646151858)
,p_lov_disp_sequence=>17
,p_lov_disp_value=>'Minus'
,p_lov_return_value=>'fam-minus'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577749667009151858)
,p_lov_disp_sequence=>18
,p_lov_disp_value=>'Pause'
,p_lov_return_value=>'fam-pause'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577750392660159601)
,p_lov_disp_sequence=>18
,p_lov_disp_value=>'Plus'
,p_lov_return_value=>'fam-plus'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577750060574159600)
,p_lov_disp_sequence=>19
,p_lov_disp_value=>'Play'
,p_lov_return_value=>'fam-play'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577750790392159601)
,p_lov_disp_sequence=>19
,p_lov_disp_value=>'Sleep'
,p_lov_return_value=>'fam-sleep'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577751113904159601)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Star'
,p_lov_return_value=>'fam-star'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577751577178159601)
,p_lov_disp_sequence=>21
,p_lov_disp_value=>'Stop'
,p_lov_return_value=>'fam-stop'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577751997570159603)
,p_lov_disp_sequence=>22
,p_lov_disp_value=>'Warning'
,p_lov_return_value=>'fam-warning'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577752309659159603)
,p_lov_disp_sequence=>23
,p_lov_disp_value=>'X'
,p_lov_return_value=>'fam-x'
);
end;
/
prompt --application/shared_components/user_interface/lovs/icon_modifier_status
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(577752611204165565)
,p_lov_name=>'ICON MODIFIER STATUS'
,p_lov_query=>'.'||wwv_flow_imp.id(577752611204165565)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475177
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577752963565165565)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Success'
,p_lov_return_value=>'fam-is-success'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577753360332165565)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Warning'
,p_lov_return_value=>'fam-is-warning'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577753798850165565)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Danger'
,p_lov_return_value=>'fam-is-danger'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577754112742165566)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Info'
,p_lov_return_value=>'fam-is-info'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577754522499165566)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Disabled'
,p_lov_return_value=>'fam-is-disabled'
);
end;
/
prompt --application/shared_components/user_interface/lovs/icon_preview_repository
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1845902759442614704)
,p_lov_name=>'ICON PREVIEW REPOSITORY'
,p_lov_query=>'.'||wwv_flow_imp.id(1845902759442614704)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475177
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1845903084419614712)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Previously Used Icons'
,p_lov_return_value=>'STANDARD_ICON'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(483162162223780333)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'Font APEX'
,p_lov_return_value=>'FONTAPEX'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_themes t,',
'       wwv_flows f',
' where f.id                = :FB_FLOW_ID',
'   and f.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and t.flow_id           = f.id',
'   and t.theme_id          = f.theme_id',
'   and t.security_group_id = f.security_group_id',
'   and t.icon_library      = ''FONTAPEX'''))
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1845904233620614716)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Font Awesome Icons'
,p_lov_return_value=>'FONTAWESOME'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_themes t,',
'       wwv_flows f',
' where f.id                = :FB_FLOW_ID',
'   and f.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and t.flow_id           = f.id',
'   and t.theme_id          = f.theme_id',
'   and t.security_group_id = f.security_group_id',
'   and t.icon_library      = ''FONTAWESOME'''))
);
end;
/
prompt --application/shared_components/user_interface/lovs/icon_rotate
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(577740129346133895)
,p_lov_name=>'ICON ROTATE'
,p_lov_query=>'.'||wwv_flow_imp.id(577740129346133895)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475181
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577740415199133896)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Rotate 90'
,p_lov_return_value=>'fa-rotate-90'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577740873415133896)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Rotate 180'
,p_lov_return_value=>'fa-rotate-180'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577741280627133896)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Rotate 270'
,p_lov_return_value=>'fa-rotate-270'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577741676385133896)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Flip Horizontal'
,p_lov_return_value=>'fa-flip-horizontal'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577742097112133897)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Flip Vertical'
,p_lov_return_value=>'fa-flip-vertical'
);
end;
/
prompt --application/shared_components/user_interface/lovs/icon_size
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(577725423197001069)
,p_lov_name=>'ICON SIZE'
,p_lov_query=>'.'||wwv_flow_imp.id(577725423197001069)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475181
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577725702259001069)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Small'
,p_lov_return_value=>'SMALL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(577726102930001069)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Large'
,p_lov_return_value=>'LARGE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/icon_libraries
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1284197032342757201)
,p_lov_name=>'ICON_LIBRARIES'
,p_lov_query=>'.'||wwv_flow_imp.id(1284197032342757201)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475181
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(482960538470359174)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Font APEX'
,p_lov_return_value=>'FONTAPEX'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(72460945675795418)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Font APEX - Latest'
,p_lov_return_value=>'FONTAPEX_LATEST'
);
end;
/
prompt --application/shared_components/user_interface/lovs/image_preview_repository
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2545625667361279)
,p_lov_name=>'IMAGE PREVIEW REPOSITORY'
,p_lov_query=>'.'||wwv_flow_imp.id(2545625667361279)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475181
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2545817600361279)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Standard Images'
,p_lov_return_value=>'STANDARD'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2546030307361279)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Workspace Images'
,p_lov_return_value=>'WORKSPACE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2546221573361279)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Application Images'
,p_lov_return_value=>'APPLICATION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(483093902289716002)
,p_lov_disp_sequence=>35
,p_lov_disp_value=>'Font APEX'
,p_lov_return_value=>'FONTAPEX'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_themes t,',
'       wwv_flows f',
' where f.id                = :FB_FLOW_ID',
'   and f.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and t.flow_id           = f.id',
'   and t.theme_id          = f.theme_id',
'   and t.security_group_id = f.security_group_id',
'   and t.icon_library      = ''FONTAPEX'''))
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1362021991963894895)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Font Awesome Icons'
,p_lov_return_value=>'FONTAWESOME'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_themes t,',
'       wwv_flows f',
' where f.id                = :FB_FLOW_ID',
'   and f.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and t.flow_id           = f.id',
'   and t.theme_id          = f.theme_id',
'   and t.security_group_id = f.security_group_id',
'   and t.icon_library      = ''FONTAWESOME'''))
);
end;
/
prompt --application/shared_components/user_interface/lovs/image_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84856825191363086)
,p_lov_name=>'IMAGE_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(84856825191363086)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475181
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84857007575363086)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'All Images'
,p_lov_return_value=>'0'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84857400079363087)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Workspace Images (only)'
,p_lov_return_value=>'2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84857607859363087)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Application Images (only)'
,p_lov_return_value=>'3'
);
end;
/
prompt --application/shared_components/user_interface/lovs/include_functions
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(60545525798060811)
,p_lov_name=>'INCLUDE FUNCTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(60545525798060811)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475181
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(60545732724060813)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Functions'
,p_lov_return_value=>'YES'
);
end;
/
prompt --application/shared_components/user_interface/lovs/include_packages
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(60546306536064747)
,p_lov_name=>'INCLUDE PACKAGES'
,p_lov_query=>'.'||wwv_flow_imp.id(60546306536064747)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475181
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(60546524313064747)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Packages'
,p_lov_return_value=>'YES'
);
end;
/
prompt --application/shared_components/user_interface/lovs/include_procedures
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(60547120735068828)
,p_lov_name=>'INCLUDE PROCEDURES'
,p_lov_query=>'.'||wwv_flow_imp.id(60547120735068828)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475181
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(60547315471068829)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Procedures'
,p_lov_return_value=>'YES'
);
end;
/
prompt --application/shared_components/user_interface/lovs/include_table_and_form_query_and_update
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(91319600010962461)
,p_lov_name=>'INCLUDE TABLE AND FORM (QUERY AND UPDATE)'
,p_lov_query=>'.'||wwv_flow_imp.id(91319600010962461)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475181
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(91319803768962466)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Query Only'
,p_lov_return_value=>'QUERY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(91320004153962467)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Query and Update'
,p_lov_return_value=>'UPDATE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/include_views
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(6397115937331647)
,p_lov_name=>'INCLUDE VIEWS'
,p_lov_query=>'.'||wwv_flow_imp.id(6397115937331647)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475181
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(6397327633331648)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Views'
,p_lov_return_value=>'YES'
);
end;
/
prompt --application/shared_components/user_interface/lovs/include_analysis_pages
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(168959914296647601)
,p_lov_name=>'INCLUDE_ANALYSIS_PAGES'
,p_lov_query=>'.'||wwv_flow_imp.id(168959914296647601)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475181
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(168960106462647608)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Include Analysis Pages'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/include_custom_calendar
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(497222811063840780)
,p_lov_name=>'INCLUDE_CUSTOM_CALENDAR'
,p_lov_query=>'select wwv_flow_lang.system_message(''CONFIRM.INCLUDE_CUSTOM_CALENDAR'') d, ''Y'' r from dual'
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475181
);
end;
/
prompt --application/shared_components/user_interface/lovs/include_exclude
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84357332667662999)
,p_lov_name=>'INCLUDE_EXCLUDE'
,p_lov_query=>'.'||wwv_flow_imp.id(84357332667662999)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475181
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84357508456662999)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Exclude'
,p_lov_return_value=>'EXCLUDE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84357711858663000)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Include'
,p_lov_return_value=>'INCLUDE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/include_legacy_javascript
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(723325277005791161)
,p_lov_name=>'INCLUDE_LEGACY_JAVASCRIPT'
,p_lov_query=>'.'||wwv_flow_imp.id(723325277005791161)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475181
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(723325530060791162)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Pre 18.1'
,p_lov_return_value=>'PRE18'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(723325916568791163)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'18.x'
,p_lov_return_value=>'18'
);
end;
/
prompt --application/shared_components/user_interface/lovs/include_shared_components_y
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(417652505855073319)
,p_lov_name=>'INCLUDE_SHARED_COMPONENTS_Y'
,p_lov_query=>'.'||wwv_flow_imp.id(417652505855073319)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475181
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(417652808595073320)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Include Shared Components'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/include_success_message
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84362432452672420)
,p_lov_name=>'INCLUDE_SUCCESS_MESSAGE'
,p_lov_query=>'.'||wwv_flow_imp.id(84362432452672420)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475181
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84362620952672421)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'include process success message'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/install_flow_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(73071600194414972)
,p_lov_name=>'INSTALL.FLOW.OPTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(73071600194414972)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475181
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(73072113397414978)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Auto Assign New Application ID'
,p_lov_return_value=>'AUTO'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(73071919023414978)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Reuse Application ID &P49_IMP_FLOW_ID. From Imported Application'
,p_lov_return_value=>'REUSE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(73106501130701222)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Change Application ID'
,p_lov_return_value=>'SPECIFY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/installer_build_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(35684329623125996)
,p_lov_name=>'INSTALLER BUILD OPTIONS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select patch_name, id from wwv_flow_patches ',
'where id in (select build_opt_id from wwv_flow_install_build_opt',
'              where flow_id = :fb_flow_id',
'                and security_group_id = :flow_security_group_id)'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475181
);
end;
/
prompt --application/shared_components/user_interface/lovs/install_condition_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2610902469203915)
,p_lov_name=>'INSTALL_CONDITION_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(2610902469203915)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475181
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2611107226203916)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Exists (SQL query returns at least one row)'
,p_lov_return_value=>'EXISTS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2611302822203917)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'NOT Exists (SQL query returns no rows)'
,p_lov_return_value=>'NOT_EXISTS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2611722452203917)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Expression'
,p_lov_return_value=>'EXPRESSION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2611903369203917)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Function Body Returning a Boolean'
,p_lov_return_value=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2612125323203917)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Value of User Preference in Expression 1 = Expression 2'
,p_lov_return_value=>'USER_PREF_IN_COND_EQ_COND2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2612300618203918)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Value of User Preference in Expression 1 != Expression 2'
,p_lov_return_value=>'USER_PREF_IN_COND_NOT_EQ_COND2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2612510467203918)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Text in Expression 1 Is Contained within the Text in Expression 2'
,p_lov_return_value=>'DISPLAY_COND_IN_COND_TEXT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2612716470203918)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Text in Expression 1 Is NOT Contained within the Text in Expression 2'
,p_lov_return_value=>'DISPLAY_COND_NOT_IN_COND_TEXT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2612916275203918)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Text in Expression 1 = Expression 2 (includes &amp;ITEM substitutions)'
,p_lov_return_value=>'DISPLAY_COND_EQUAL_COND_TEXT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2613122730203919)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Text in Expression 1 != Expression 2 (includes &amp;ITEM substitutions)'
,p_lov_return_value=>'DISP_COND_NOT_EQUAL_COND_TEXT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2613308299203919)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'Current Language Is Contained within Expression 1'
,p_lov_return_value=>'CURRENT_LANG_IN_COND1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2613518327203919)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>'Current Language Is NOT Contained within Expression 1'
,p_lov_return_value=>'CURRENT_LANG_NOT_IN_COND1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2613719056203919)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>'Current Language != Expression 1'
,p_lov_return_value=>'CURRENT_LANG_NOT_EQ_COND1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2613931075203919)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'Current Language = Expression 1'
,p_lov_return_value=>'CURRENT_LANG_EQ_COND1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2614914590207416)
,p_lov_disp_sequence=>16
,p_lov_disp_value=>'When CGI_ENV DAD_NAME = Expression 1'
,p_lov_return_value=>'DAD_NAME_EQ_CONDITION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2615524633210304)
,p_lov_disp_sequence=>17
,p_lov_disp_value=>'When CGI_ENV DAD_NAME != Expression 1'
,p_lov_return_value=>'DAD_NAME_NOT_EQ_CONDITION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2615829827211851)
,p_lov_disp_sequence=>18
,p_lov_disp_value=>'When CGI_ENV SERVER_NAME = Expression 1'
,p_lov_return_value=>'SERVER_NAME_EQ_CONDITION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2616102946213515)
,p_lov_disp_sequence=>19
,p_lov_disp_value=>'When CGI_ENV SERVER_NAME != Expression 1'
,p_lov_return_value=>'SERVER_NAME_NOT_EQ_CONDITION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2616407448214867)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'When CGI_ENV HTTP_HOST = Expression 1'
,p_lov_return_value=>'HTTP_HOST_EQ_CONDITION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2616711258215952)
,p_lov_disp_sequence=>21
,p_lov_disp_value=>'When CGI_ENV HTTP_HOST != Expression 1'
,p_lov_return_value=>'HTTP_HOST_NOT_EQ_CONDITION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(35854932212539564)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Application Schema is in comma separated list in Expression 1'
,p_lov_return_value=>'SCHEMA_IN_LIST'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>'1=0'
,p_lov_disp_cond2=>'SQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(35855211911543166)
,p_lov_disp_sequence=>31
,p_lov_disp_value=>'Application Schema NOT in comma separated list in Expression 1'
,p_lov_return_value=>'SCHEMA_NOT_IN_LIST'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>'1=0'
,p_lov_disp_cond2=>'SQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(47908326353191665)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Previous Software Version < Version Specified in Expression 1'
,p_lov_return_value=>'PREV_VERSION_LESS_THAN'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(47908631893193277)
,p_lov_disp_sequence=>41
,p_lov_disp_value=>'Previous Software Version = Version Specified in Expression 1'
,p_lov_return_value=>'PREV_VERSION_EQUALS'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(47908904320194771)
,p_lov_disp_sequence=>42
,p_lov_disp_value=>'Previous Software Version > Version Specified in Expression 1'
,p_lov_return_value=>'PREV_VERSION_GREATER_THAN'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2617015067217035)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'Never'
,p_lov_return_value=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2617419223218210)
,p_lov_disp_sequence=>101
,p_lov_disp_value=>'Always'
,p_lov_return_value=>'ALWAYS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/install_plugin_themes
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(3601964946809992)
,p_lov_name=>'INSTALL_PLUGIN_THEMES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P4450_NEW_FLOW_ID, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_return_column_name=>'THEME_ID'
,p_display_column_name=>'D'
,p_version_scn=>72475181
);
end;
/
prompt --application/shared_components/user_interface/lovs/install_script_source
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(4626801323289842)
,p_lov_name=>'INSTALL_SCRIPT_SOURCE'
,p_lov_query=>'.'||wwv_flow_imp.id(4626801323289842)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475181
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4627023954289843)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'From Scratch'
,p_lov_return_value=>'SCRATCH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4627422435289843)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'From File'
,p_lov_return_value=>'FILE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(534087945348728527)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'From Database Object'
,p_lov_return_value=>'DB'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1711580816703200)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'Data Package'
,p_lov_return_value=>'DATA'
);
end;
/
prompt --application/shared_components/user_interface/lovs/install_ws_app_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(504711916337338970)
,p_lov_name=>'INSTALL_WS_APP_OPTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(504711916337338970)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475181
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(504712121140338973)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Auto Assign New Application ID'
,p_lov_return_value=>'AUTO'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(504712330088338973)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Reuse Application ID &P494_IMP_WS_APP_ID. From Export File'
,p_lov_return_value=>'REUSE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(504712504417338973)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Change Application ID'
,p_lov_return_value=>'SPECIFY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/irr_rowid_or_cols
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(114719118636380285)
,p_lov_name=>'IRR.ROWID_OR_COLS'
,p_lov_query=>'.'||wwv_flow_imp.id(114719118636380285)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475181
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(114719413876380287)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'ROWID'
,p_lov_return_value=>'Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(114719616889380287)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Unique Column'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/irr_column_filter_lov
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(147261022842307147)
,p_lov_name=>'IRR_COLUMN_FILTER_LOV'
,p_lov_query=>'.'||wwv_flow_imp.id(147261022842307147)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475181
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(147261325305307148)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'None'
,p_lov_return_value=>'N'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(147261517398307148)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Default Based on Column Type'
,p_lov_return_value=>'D'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(147261708729307148)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Use Defined List of Values to Filter Exact Match'
,p_lov_return_value=>'S'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(46425214824687279)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Use Defined List of Values to Filter Word Contains'
,p_lov_return_value=>'C'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(450175625286008190)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Use Named List of Values to Filter Exact Match'
,p_lov_return_value=>'1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(450177224509026910)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Use Named List of Values to Filter Word Contains'
,p_lov_return_value=>'2'
);
end;
/
prompt --application/shared_components/user_interface/lovs/irr_link_column
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(134903721394714997)
,p_lov_name=>'IRR_LINK_COLUMN'
,p_lov_query=>'.'||wwv_flow_imp.id(134903721394714997)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475181
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(134904030028714997)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Link to Single Row View'
,p_lov_return_value=>'Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(134905202132718861)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'Link to Custom Target'
,p_lov_return_value=>'C'
,p_lov_disp_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_lov_disp_cond=>'601'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(134904219905714998)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Exclude Link Column'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ir_notify_interval
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(30663301353708410)
,p_lov_name=>'IR_NOTIFY_INTERVAL'
,p_lov_query=>'.'||wwv_flow_imp.id(30663301353708410)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475181
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(30663617752708413)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Daily'
,p_lov_return_value=>'D'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(30663926891708420)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Weekly'
,p_lov_return_value=>'W'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(30664230138708420)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Monthly'
,p_lov_return_value=>'M'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ir_notify_status
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(30664415898712648)
,p_lov_name=>'IR_NOTIFY_STATUS'
,p_lov_query=>'.'||wwv_flow_imp.id(30664415898712648)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475181
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(30664728283712648)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Submitted'
,p_lov_return_value=>'SUBMITTED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(30665008213712648)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Sent'
,p_lov_return_value=>'SENT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(30665313148712651)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Error'
,p_lov_return_value=>'ERROR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1703941607612344)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Skipped'
,p_lov_return_value=>'SKIPPED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ir_report_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(591769261601865016)
,p_lov_name=>'IR_REPORT_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(591769261601865016)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475181
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(591769521956865020)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Primary Default'
,p_lov_return_value=>'PRIMARY_DEFAULT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(591769894133865024)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Alternative Default'
,p_lov_return_value=>'ALTERNATIVE_DEFAULT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(591770186081865024)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Public'
,p_lov_return_value=>'PUBLIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(591770409876865025)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Private'
,p_lov_return_value=>'PRIVATE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/iscolumn_name_text
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(23469230991802389)
,p_lov_name=>'ISCOLUMN.NAME.TEXT'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<span class="instructiontext">''||',
'wwv_flow_lang.system_message(''F4300_INSTRUCT_TEXT'')||''</span>'' d, ''Y'' r from dual'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475181
);
end;
/
prompt --application/shared_components/user_interface/lovs/item_and_report
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(146337627678444760)
,p_lov_name=>'ITEM AND REPORT'
,p_lov_query=>'.'||wwv_flow_imp.id(146337627678444760)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475181
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(146337822091444773)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Page Item'
,p_lov_return_value=>'ITEM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(146338027107444777)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Report'
,p_lov_return_value=>'REPORT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/item_protection_level
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(17287012676783081)
,p_lov_name=>'ITEM PROTECTION LEVEL'
,p_lov_query=>'.'||wwv_flow_imp.id(17287012676783081)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475181
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17287200195783083)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Unrestricted'
,p_lov_return_value=>'N'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17287400587783083)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Checksum Required - Application Level'
,p_lov_return_value=>'B'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17287603082783083)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Checksum Required - User Level'
,p_lov_return_value=>'P'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17287806322783083)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Checksum Required - Session Level'
,p_lov_return_value=>'S'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17304317734788157)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Restricted - May not be set from browser'
,p_lov_return_value=>'I'
);
end;
/
prompt --application/shared_components/user_interface/lovs/item_protection_level_d
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(109261519627066371)
,p_lov_name=>'ITEM PROTECTION LEVEL D'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select nvl(PAGE_PROTECTION_ENABLED_Y_N,''N'') p from wwv_flows where id = :FB_FLOW_ID) loop',
'    if c1.p = ''Y'' then',
'       return  ''select wwv_flow_lang.system_message(''''UNRESTRICTED'''') d, ''''N'''' r',
'                  from sys.dual union all',
'                select wwv_flow_lang.system_message(''''CHECKSUM_REQUIRED_APPLICATION'''') d, ''''B'''' r',
'                  from sys.dual union all',
'                select wwv_flow_lang.system_message(''''CHECKSUM_REQUIRED_USER'''') d, ''''P'''' r',
'                  from sys.dual union all               ',
'                select wwv_flow_lang.system_message(''''CHECKSUM_REQUIRED_SESSION'''') d, ''''S'''' r',
'                  from sys.dual union all               ',
'                select wwv_flow_lang.system_message(''''RESTRICTED_NO_SET_FROM_BROWSER'''') d, ''''I'''' r',
'                  from sys.dual'';',
'    else',
'       return  ''select wwv_flow_lang.system_message(''''UNRESTRICTED'''') d, ''''N'''' r',
'                  from sys.dual union all ',
'                select wwv_flow_lang.system_message(''''RESTRICTED_NO_SET_FROM_BROWSER'''') d, ''''I'''' r',
'                  from sys.dual'';',
'    end if;',
'end loop;'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475181
);
end;
/
prompt --application/shared_components/user_interface/lovs/item_protection_level_no_restricted
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(109314413723246310)
,p_lov_name=>'ITEM PROTECTION LEVEL NO RESTRICTED'
,p_lov_query=>'.'||wwv_flow_imp.id(109314413723246310)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475181
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(109314629939246312)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Unrestricted'
,p_lov_return_value=>'N'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(109314820854246316)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Checksum Required - Application Level'
,p_lov_return_value=>'B'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(109315024526246316)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Checksum Required - User Level'
,p_lov_return_value=>'P'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(109315221763246316)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Checksum Required - Session Level'
,p_lov_return_value=>'S'
);
end;
/
prompt --application/shared_components/user_interface/lovs/item_caching_rule
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84930714296823567)
,p_lov_name=>'ITEM.CACHING.RULE'
,p_lov_query=>'.'||wwv_flow_imp.id(84930714296823567)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475182
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84930930267823568)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Always, replacing any existing value in session state'
,p_lov_return_value=>'NO'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84931103028823568)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Only when current value in session state is null'
,p_lov_return_value=>'YES'
);
end;
/
prompt --application/shared_components/user_interface/lovs/item_default_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(38747715987262349)
,p_lov_name=>'ITEM.DEFAULT.TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(38747715987262349)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475182
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(38748018541262374)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Static Text with Session State Substitutions'
,p_lov_return_value=>'STATIC_TEXT_WITH_SUBSTITUTIONS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(38748231848262376)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'PL/SQL Function Body'
,p_lov_return_value=>'PLSQL_FUNCTION_BODY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(38748428126262376)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'PL/SQL Expression'
,p_lov_return_value=>'PLSQL_EXPRESSION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/item_help_search
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84895631752563737)
,p_lov_name=>'ITEM.HELP.SEARCH'
,p_lov_query=>'.'||wwv_flow_imp.id(84895631752563737)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475182
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84895800944563739)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'All Pages'
,p_lov_return_value=>'ALL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84896012258563739)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Current Page'
,p_lov_return_value=>'CURRENT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/item_button_template
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(387672699225327824)
,p_lov_name=>'ITEM_BUTTON_TEMPLATE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(template_name) d, ''template:''||id r',
'from   wwv_flow_button_templates',
'where  flow_id = :fb_flow_id and',
'       (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by upper(template_name)'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475182
);
end;
/
prompt --application/shared_components/user_interface/lovs/item_current_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84729824360877320)
,p_lov_name=>'ITEM_CURRENT_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(84729824360877320)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475182
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(14501616510583410)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Current Page is Target'
,p_lov_return_value=>'TARGET_PAGE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84730000591877321)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Always'
,p_lov_return_value=>'ALWAYS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84730215547877321)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Comma Delimited Page List'
,p_lov_return_value=>'COLON_DELIMITED_PAGE_LIST'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84730407325877321)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Exists SQL Query'
,p_lov_return_value=>'EXISTS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84730612612877322)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Never'
,p_lov_return_value=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84730804253877322)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Not Exists SQL Query'
,p_lov_return_value=>'NOT_EXISTS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84731025371877322)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Expression'
,p_lov_return_value=>'EXPRESSION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/item_source_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(129889837649)
,p_lov_name=>'ITEM_SOURCE_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(129889837649)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475182
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(129890840816)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Null'
,p_lov_return_value=>'ALWAYS_NULL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(129891851389)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Static Assignment (value equals source attribute)'
,p_lov_return_value=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(129892852681)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'SQL Query (return single value)'
,p_lov_return_value=>'QUERY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(458482816683473299)
,p_lov_disp_sequence=>35
,p_lov_disp_value=>'SQL Query (return colon separated value)'
,p_lov_return_value=>'QUERY_COLON'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(129893855391)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Item (application or page item name)'
,p_lov_return_value=>'ITEM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(129894857627)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Expression'
,p_lov_return_value=>'EXPRESSION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(133432340478)
,p_lov_disp_sequence=>55
,p_lov_disp_value=>'Function Body'
,p_lov_return_value=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(129895858879)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Database Column'
,p_lov_return_value=>'DB_COLUMN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(76368092101)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Preference'
,p_lov_return_value=>'PREFERENCE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/item_types_requires_application_context
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(29353308376249352)
,p_lov_name=>'ITEM_TYPES (REQUIRES APPLICATION CONTEXT)'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name,',
'       name_with_prefix',
'  from wwv_flow_native_plugins',
' where plugin_type = ''ITEM TYPE''',
' union all',
'select display_name || wwv_flow_lang.system_message(''PLUGIN.DISPLAY_NAME_POSTFIX''),',
'       ''PLUGIN_'' || name',
'  from wwv_flow_plugins',
' where flow_id = to_number(:FB_FLOW_ID)',
'   and security_group_id = to_number(:WORKSPACE_ID)',
'   and plugin_type = ''ITEM TYPE''',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475182
);
end;
/
prompt --application/shared_components/user_interface/lovs/item_types_without_plugins
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(29544521926748713)
,p_lov_name=>'ITEM_TYPES (WITHOUT PLUGINS)'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_native_plugins varchar2(255);',
'begin',
'    l_native_plugins := '' union all select display_name as d, name_with_prefix as r from wwv_flow_native_plugins where plugin_type = ''''ITEM TYPE'''' order by 1'';',
'',
'    if lower(wwv_flow.g_flow_language) = ''en'' then',
'        return ''select display_name as d, name as r from wwv_flow_standard_item_types''||l_native_plugins;',
'    else',
'        return ''select wwv_flow_lang.system_message(''''ITEM_TYPE.''''||name) as d, name as r from wwv_flow_standard_item_types''||l_native_plugins;',
'    end if;',
'end;'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475182
);
end;
/
prompt --application/shared_components/user_interface/lovs/item_types_including_button_requires_application_context
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(828112523658823842)
,p_lov_name=>'ITEM_TYPES INCLUDING BUTTON (REQUIRES APPLICATION CONTEXT)'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_lov varchar2(32767);',
'begin',
'    if lower(wwv_flow.g_flow_language) = ''en'' then',
'        l_lov := ''select display_name as d, name as r from wwv_flow_standard_item_types'';',
'    else',
'        l_lov := ''select wwv_flow_lang.system_message(''''ITEM_TYPE.''''||name) as d, name as r from wwv_flow_standard_item_types'';',
'    end if;',
'',
'    return l_lov ||',
'           '' union all ''||',
'           ''select display_name, name_with_prefix from wwv_flow_native_plugins ''||',
'           ''where plugin_type = ''''ITEM TYPE''''''||',
'           '' union all ''||',
'           ''select display_name||wwv_flow_lang.system_message(''''PLUGIN.DISPLAY_NAME_POSTFIX''''), ''''PLUGIN_''''||name from wwv_flow_plugins ''||',
'           ''where flow_id = to_number(:FB_FLOW_ID) and security_group_id = to_number(:WORKSPACE_ID) and plugin_type = ''''ITEM TYPE'''' order by 1'';',
'end;'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475182
);
end;
/
prompt --application/shared_components/user_interface/lovs/iud_select
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(88127426312675871)
,p_lov_name=>'IUD.SELECT'
,p_lov_query=>'.'||wwv_flow_imp.id(88127426312675871)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475182
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88156615137966014)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Insert'
,p_lov_return_value=>'I'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88156828112966014)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Update'
,p_lov_return_value=>'U'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88157015984966014)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Delete'
,p_lov_return_value=>'D'
);
end;
/
prompt --application/shared_components/user_interface/lovs/jet_chart_coordinate
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(272269905187811870)
,p_lov_name=>'JET_CHART_COORDINATE'
,p_lov_query=>'.'||wwv_flow_imp.id(272269905187811870)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475182
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(272270240012811871)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Polar'
,p_lov_return_value=>'polar'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(272270622978811872)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Cartesian'
,p_lov_return_value=>'cartesian'
);
end;
/
prompt --application/shared_components/user_interface/lovs/jet_chart_gallery
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(246508417548358609)
,p_lov_name=>'JET_CHART_GALLERY'
,p_lov_query=>'.'||wwv_flow_imp.id(246508417548358609)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475182
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(246508701590358611)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Area'
,p_lov_return_value=>'area'
,p_lov_template=>'#DISPLAY_VALUE#| chart-area'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(246509129938358611)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Bar'
,p_lov_return_value=>'bar'
,p_lov_template=>'#DISPLAY_VALUE#| chart-bar'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(205873042229302453)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Box Plot'
,p_lov_return_value=>'boxPlot'
,p_lov_template=>'#DISPLAY_VALUE#| chart-box-plot'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(246509548297358616)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Bubble'
,p_lov_return_value=>'bubble'
,p_lov_template=>'#DISPLAY_VALUE#| chart-bubble'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(246509973226358616)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Combination'
,p_lov_return_value=>'combo'
,p_lov_template=>'#DISPLAY_VALUE#| chart-combo'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(246510306110358617)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Status Meter Gauge'
,p_lov_return_value=>'dial'
,p_lov_template=>'#DISPLAY_VALUE#| chart-dial'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(308729675689444557)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Donut'
,p_lov_return_value=>'donut'
,p_lov_template=>'#DISPLAY_VALUE#| chart-donut'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(246510750377358617)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Funnel'
,p_lov_return_value=>'funnel'
,p_lov_template=>'#DISPLAY_VALUE#| chart-funnel'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(558148316798907518)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Gantt'
,p_lov_return_value=>'GANTT'
,p_lov_template=>'#DISPLAY_VALUE#| chart-gantt'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(246511142688358617)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Line'
,p_lov_return_value=>'line'
,p_lov_template=>'#DISPLAY_VALUE#| chart-line'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(246511596688358617)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Line with Area'
,p_lov_return_value=>'lineWithArea'
,p_lov_template=>'#DISPLAY_VALUE#| chart-line-area'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(246511943759358621)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>'Pie'
,p_lov_return_value=>'pie'
,p_lov_template=>'#DISPLAY_VALUE#| chart-pie'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(308729953426446044)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>'Polar'
,p_lov_return_value=>'polar'
,p_lov_template=>'#DISPLAY_VALUE#| chart-polar'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(155504274794633386)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'Pyramid'
,p_lov_return_value=>'pyramid'
,p_lov_template=>'#DISPLAY_VALUE#| chart-pyramid'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(308730221520447970)
,p_lov_disp_sequence=>16
,p_lov_disp_value=>'Radar'
,p_lov_return_value=>'radar'
,p_lov_template=>'#DISPLAY_VALUE#| chart-radar'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(308730765229451160)
,p_lov_disp_sequence=>17
,p_lov_disp_value=>'Range'
,p_lov_return_value=>'range'
,p_lov_template=>'#DISPLAY_VALUE#| chart-range-bar'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(246512388827358624)
,p_lov_disp_sequence=>18
,p_lov_disp_value=>'Scatter'
,p_lov_return_value=>'scatter'
,p_lov_template=>'#DISPLAY_VALUE#| chart-scatter'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(246512701000358624)
,p_lov_disp_sequence=>19
,p_lov_disp_value=>'Stock'
,p_lov_return_value=>'stock'
,p_lov_template=>'#DISPLAY_VALUE#| chart-stock'
);
end;
/
prompt --application/shared_components/user_interface/lovs/jet_chart_legend
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(272324713923013998)
,p_lov_name=>'JET_CHART_LEGEND'
,p_lov_query=>'.'||wwv_flow_imp.id(272324713923013998)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475182
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(272325099342014001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'None'
,p_lov_return_value=>'none'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(272325497871014002)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Automatic'
,p_lov_return_value=>'auto'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(272325879803014002)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Bottom'
,p_lov_return_value=>'bottom'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(272326207002014002)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'End'
,p_lov_return_value=>'end'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(272326686037014003)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Start'
,p_lov_return_value=>'start'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(272327073014014003)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Top'
,p_lov_return_value=>'top'
);
end;
/
prompt --application/shared_components/user_interface/lovs/jet_chart_orientation
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(272256574572764306)
,p_lov_name=>'JET_CHART_ORIENTATION'
,p_lov_query=>'.'||wwv_flow_imp.id(272256574572764306)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475182
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(272256824856764320)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Horizontal'
,p_lov_return_value=>'horizontal'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(272257282840764322)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Vertical'
,p_lov_return_value=>'vertical'
);
end;
/
prompt --application/shared_components/user_interface/lovs/jet_chart_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(285041260607381464)
,p_lov_name=>'JET_CHART_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(285041260607381464)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475182
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(285041507970381478)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Area'
,p_lov_return_value=>'area'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(285041919546381481)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Bar'
,p_lov_return_value=>'bar'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(285042396209381481)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Bubble'
,p_lov_return_value=>'bubble'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(285042788719381482)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Combination'
,p_lov_return_value=>'combo'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(285043177232381482)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Status Meter Gauge'
,p_lov_return_value=>'dial'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(308720430074729586)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Donut'
,p_lov_return_value=>'donut'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(285043586888381482)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Funnel'
,p_lov_return_value=>'funnel'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(285043903336381482)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Line'
,p_lov_return_value=>'line'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(285044346749381483)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Line with Area'
,p_lov_return_value=>'lineWithArea'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(285044729648381483)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Pie'
,p_lov_return_value=>'pie'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(308719871403728110)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Polar'
,p_lov_return_value=>'polar'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(308720132434728806)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'Radar'
,p_lov_return_value=>'radar'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(308719513006727167)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>'Range'
,p_lov_return_value=>'range'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(285045130826381483)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>'Scatter'
,p_lov_return_value=>'scatter'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(285045589583381483)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'Stock'
,p_lov_return_value=>'stock'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(155509538047810000)
,p_lov_disp_sequence=>16
,p_lov_disp_value=>'Pyramid'
,p_lov_return_value=>'pyramid'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(205878611297350098)
,p_lov_disp_sequence=>17
,p_lov_disp_value=>'Box Plot'
,p_lov_return_value=>'boxPlot'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(5411068630930906)
,p_lov_disp_sequence=>18
,p_lov_disp_value=>'Gantt'
,p_lov_return_value=>'GANTT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/jet_gauge_orientation
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(21606267597566254)
,p_lov_name=>'JET_GAUGE_ORIENTATION'
,p_lov_query=>'.'||wwv_flow_imp.id(21606267597566254)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475184
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(21606569316566254)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Circular'
,p_lov_return_value=>'circular'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(21606931960566254)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Horizontal'
,p_lov_return_value=>'horizontal'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(21607248117566255)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Vertical'
,p_lov_return_value=>'vertical'
);
end;
/
prompt --application/shared_components/user_interface/lovs/jstree_themes
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(445986021038615393)
,p_lov_name=>'JSTREE_THEMES'
,p_lov_query=>'.'||wwv_flow_imp.id(445986021038615393)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475184
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(445986827650615404)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Default'
,p_lov_return_value=>'default'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(445986226113615399)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Blue'
,p_lov_return_value=>'apple'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(445986611271615404)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Classic'
,p_lov_return_value=>'classic'
);
end;
/
prompt --application/shared_components/user_interface/lovs/label_theme_class_id
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(43828319065855502)
,p_lov_name=>'LABEL THEME CLASS ID'
,p_lov_query=>'.'||wwv_flow_imp.id(43828319065855502)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475184
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43828604595855506)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Optional Label with Help'
,p_lov_return_value=>'1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43828821955855506)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Required Label with Help'
,p_lov_return_value=>'2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43829026521855506)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Optional Label'
,p_lov_return_value=>'3'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43829216754855507)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Required Label'
,p_lov_return_value=>'4'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(44168504088920423)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'No Label'
,p_lov_return_value=>'13'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43829403095855507)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 1'
,p_lov_return_value=>'5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43829614163855507)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 2'
,p_lov_return_value=>'6'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43829811310855507)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 3'
,p_lov_return_value=>'7'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43830028586855508)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 4'
,p_lov_return_value=>'8'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43830230461855508)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 5'
,p_lov_return_value=>'9'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43830425504855508)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 6'
,p_lov_return_value=>'10'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43830605003855508)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 7'
,p_lov_return_value=>'11'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43830820404855509)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 8'
,p_lov_return_value=>'12'
);
end;
/
prompt --application/shared_components/user_interface/lovs/label_alignment
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84757522618851451)
,p_lov_name=>'LABEL_ALIGNMENT'
,p_lov_query=>'.'||wwv_flow_imp.id(84757522618851451)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475184
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84757729764851451)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Above '
,p_lov_return_value=>'ABOVE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84757914076851452)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Below'
,p_lov_return_value=>'BELOW'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84758122408851452)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Center'
,p_lov_return_value=>'CENTER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84758309833851452)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Center bottom'
,p_lov_return_value=>'CENTER-BOTTOM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84758526184851452)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Center center'
,p_lov_return_value=>'CENTER-CENTER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84758718640851453)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Center top'
,p_lov_return_value=>'CENTER-TOP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84758917390851453)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Start'
,p_lov_return_value=>'LEFT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84759122923851453)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Start bottom'
,p_lov_return_value=>'LEFT-BOTTOM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84759320284851453)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'Start center'
,p_lov_return_value=>'LEFT-CENTER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84759518480851454)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'Start top'
,p_lov_return_value=>'LEFT-TOP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84759731211851454)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'End'
,p_lov_return_value=>'RIGHT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84759903007851454)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'End bottom'
,p_lov_return_value=>'RIGHT-BOTTOM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84760105209851455)
,p_lov_disp_sequence=>130
,p_lov_disp_value=>'End center'
,p_lov_return_value=>'RIGHT-CENTER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84760318434851455)
,p_lov_disp_sequence=>140
,p_lov_disp_value=>'End top'
,p_lov_return_value=>'RIGHT-TOP'
);
end;
/
prompt --application/shared_components/user_interface/lovs/label_template_wiz
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(86598309219256908)
,p_lov_name=>'LABEL_TEMPLATE_WIZ'
,p_lov_query=>'.'||wwv_flow_imp.id(86598309219256908)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475184
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88294304634805085)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Choose one from the &PRODUCT_NAME. repository'
,p_lov_return_value=>'DEFAULT'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(91902324410976802)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'From Scratch'
,p_lov_return_value=>'BLANK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(91903301685979689)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'As a Copy of an Existing Template'
,p_lov_return_value=>'COPY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/languages_installed
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(631619712812572565)
,p_lov_name=>'LANGUAGES_INSTALLED'
,p_lov_query=>'.'||wwv_flow_imp.id(631619712812572565)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475188
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(631619916261572566)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'English'
,p_lov_return_value=>'en'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(631620120219572571)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinese (China)'
,p_lov_return_value=>'zh-cn'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where id in ',
'   (select translation_flow_id',
'      from wwv_flow_language_map',
'     where primary_language_flow_id = :APP_ID',
'       and translation_flow_language_code = ''zh-cn'')         '))
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(631620319438572571)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Chinese (Taiwan)'
,p_lov_return_value=>'zh-tw'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where id in ',
'   (select translation_flow_id',
'      from wwv_flow_language_map',
'     where primary_language_flow_id = :APP_ID',
'       and translation_flow_language_code = ''zh-tw'')         '))
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(631620524976572571)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Spanish'
,p_lov_return_value=>'es'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where id in ',
'   (select translation_flow_id',
'      from wwv_flow_language_map',
'     where primary_language_flow_id = :APP_ID',
'       and translation_flow_language_code = ''es'')         '))
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(631620730994572572)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Italian'
,p_lov_return_value=>'it'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where id in ',
'   (select translation_flow_id',
'      from wwv_flow_language_map',
'     where primary_language_flow_id = :APP_ID',
'       and translation_flow_language_code = ''it'')         '))
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(631620918813572572)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'French'
,p_lov_return_value=>'fr'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where id in ',
'   (select translation_flow_id',
'      from wwv_flow_language_map',
'     where primary_language_flow_id = :APP_ID',
'       and translation_flow_language_code = ''fr'')'))
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(631621107621572572)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'German'
,p_lov_return_value=>'de'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where id in ',
'   (select translation_flow_id',
'      from wwv_flow_language_map',
'     where primary_language_flow_id = :APP_ID',
'       and translation_flow_language_code = ''de'')         '))
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(631621331959572572)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Japanese'
,p_lov_return_value=>'ja'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where id in ',
'   (select translation_flow_id',
'      from wwv_flow_language_map',
'     where primary_language_flow_id = :APP_ID',
'       and translation_flow_language_code = ''ja'')         '))
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(631621516834572572)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Portuguese (Brazil)'
,p_lov_return_value=>'pt-br'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where id in ',
'   (select translation_flow_id',
'      from wwv_flow_language_map',
'     where primary_language_flow_id = :APP_ID',
'       and translation_flow_language_code = ''pt-br'')         '))
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(797107324849116848)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Korean'
,p_lov_return_value=>'ko'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where id in ',
'   (select translation_flow_id',
'      from wwv_flow_language_map',
'     where primary_language_flow_id = :APP_ID',
'       and translation_flow_language_code = ''ko'')'))
);
end;
/
prompt --application/shared_components/user_interface/lovs/language_derived_from
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(73566910745435962)
,p_lov_name=>'LANGUAGE_DERIVED_FROM'
,p_lov_query=>'.'||wwv_flow_imp.id(73566910745435962)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475188
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88294907751806000)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'No NLS (Application not translated)'
,p_lov_return_value=>'0'
,p_lov_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_lov_disp_cond=>'933'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88295118806806000)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Application Primary Language'
,p_lov_return_value=>'FLOW_PRIMARY_LANGUAGE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88295311143806000)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Browser (use browser language preference)'
,p_lov_return_value=>'BROWSER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88295501503806001)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Application Preference (use FSP_LANGUAGE_PREFERENCE)'
,p_lov_return_value=>'FLOW_PREFERENCE'
,p_lov_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_lov_disp_cond=>'933'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88295718259806001)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Item Preference (use item containing preference)'
,p_lov_return_value=>'ITEM_PREFERENCE'
,p_lov_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_lov_disp_cond=>'933'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(253845925497886980)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Session'
,p_lov_return_value=>'SESSION'
,p_lov_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_lov_disp_cond=>'933'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ldap_ssl_lov
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(487674627120619297)
,p_lov_name=>'LDAP_SSL_LOV'
,p_lov_query=>'.'||wwv_flow_imp.id(487674627120619297)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475188
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(487674822640619303)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'SSL'
,p_lov_return_value=>'Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(487675029047619305)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'SSL with Authentication'
,p_lov_return_value=>'A'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(487675215263619306)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'No SSL'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ldap_ssl_plugin_lov
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(29453800248365382)
,p_lov_name=>'LDAP_SSL_PLUGIN_LOV'
,p_lov_query=>'.'||wwv_flow_imp.id(29453800248365382)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475188
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(29454107923365385)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'SSL'
,p_lov_return_value=>'SSL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(29454406015365389)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'SSL with Authentication'
,p_lov_return_value=>'SSL_AUTH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(29454730782365389)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'No SSL'
,p_lov_return_value=>'NO_SSL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ldap_username_escaping
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(39475531325852002)
,p_lov_name=>'LDAP_USERNAME_ESCAPING'
,p_lov_query=>'.'||wwv_flow_imp.id(39475531325852002)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475188
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(39475812001852003)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Standard'
,p_lov_return_value=>'STD'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(39476117154852003)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Only special characters'
,p_lov_return_value=>'ONLY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(39476413911852003)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'No Escaping'
,p_lov_return_value=>'NO'
);
end;
/
prompt --application/shared_components/user_interface/lovs/line_style
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84878309186453156)
,p_lov_name=>'LINE_STYLE'
,p_lov_query=>'.'||wwv_flow_imp.id(84878309186453156)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475188
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84878510088453156)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Dotted 1'
,p_lov_return_value=>'DOTTED_1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84878703174453157)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Dotted 2'
,p_lov_return_value=>'DOTTED_2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84878910394453157)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Dotted 3'
,p_lov_return_value=>'DOTTED_3'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84879114364453157)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Solid'
,p_lov_return_value=>'STRAIGHT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/line_weight
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(244579719911969185)
,p_lov_name=>'LINE_WEIGHT'
,p_lov_query=>'.'||wwv_flow_imp.id(244579719911969185)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475188
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(244580030013969188)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'1'
,p_lov_return_value=>'1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(244580206494969189)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'2'
,p_lov_return_value=>'2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(244580404944969189)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'3'
,p_lov_return_value=>'3'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(244580616739969190)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'4'
,p_lov_return_value=>'4'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(244580829606969190)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'5'
,p_lov_return_value=>'5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(244581020219969190)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'6'
,p_lov_return_value=>'6'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(244581203664969190)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'7'
,p_lov_return_value=>'7'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(244581404612969190)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'8'
,p_lov_return_value=>'8'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(244581619284969191)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'9'
,p_lov_return_value=>'9'
);
end;
/
prompt --application/shared_components/user_interface/lovs/link_option
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84330300975616054)
,p_lov_name=>'LINK_OPTION'
,p_lov_query=>'.'||wwv_flow_imp.id(84330300975616054)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475188
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88296717080806862)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Nothing'
,p_lov_return_value=>'NOTHING'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88296510521806862)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Existing Application Item'
,p_lov_return_value=>'EXISTING'
);
end;
/
prompt --application/shared_components/user_interface/lovs/link_target
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84811707811178296)
,p_lov_name=>'LINK_TARGET'
,p_lov_query=>'.'||wwv_flow_imp.id(84811707811178296)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475188
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84811912899178296)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Current Application'
,p_lov_return_value=>'F'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84812101106178297)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'All Applications'
,p_lov_return_value=>'C'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84812328270178297)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Remote URL'
,p_lov_return_value=>'E'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_deployment_p529
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(169222400131754330)
,p_lov_name=>'LIST DEPLOYMENT P529'
,p_lov_query=>'.'||wwv_flow_imp.id(169222400131754330)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475188
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(169222607062754337)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Do not create list region(s)'
,p_lov_return_value=>'0'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(169222802542754344)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Create list region on current page'
,p_lov_return_value=>'CURRENT_PAGE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(169223024966754344)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Create list region for each target page'
,p_lov_return_value=>'EACH_ENTRY'
,p_lov_disp_cond_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_lov_disp_cond=>'734'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_exportable_flows
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(189999522998166355)
,p_lov_name=>'LIST EXPORTABLE FLOWS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'  from   wwv_flow_visible_flows f',
' order by 2'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475188
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_flows
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(312074852)
,p_lov_name=>'LIST FLOWS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'where  build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'order by 2'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475188
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_flows_no_escape
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(116300273068552828)
,p_lov_name=>'LIST FLOWS_NO_ESCAPE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||f.name d, f.id r',
'from   wwv_flow_visible_flows f',
'where  build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'order by 2'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475188
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_items
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(918311972218937)
,p_lov_name=>'LIST ITEMS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(list_item_link_text) d, id',
'  from (',
'           select lpad('' '', 4 * (level - 1), ''.'') || list_item_link_text list_item_link_text, id',
'             from (',
'                      select id, parent_list_item_id, list_item_display_sequence, list_item_link_text',
'                        from wwv_flow_list_items i',
'                       where flow_id = :fb_flow_id',
'                         and security_group_id = :WORKSPACE_ID',
'                         and list_id = :f4000_p4052_list_id',
'                         and id not in (',
'                                 select id',
'                                   from wwv_flow_list_items',
'                                  where flow_id           = :fb_flow_id',
'                                    and security_group_id = :workspace_id',
'                                    and list_id           = :f4000_p4052_list_id',
'                                  start with id = :f4000_p4052_id',
'                                connect by prior id = parent_list_item_id',
'                             )',
'                         and sub_list_id is null',
'                  )',
'            start with parent_list_item_id is null',
'          connect by prior id = parent_list_item_id',
'            order siblings by list_item_display_sequence',
'       );'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475188
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_items_inline_edit
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(108645906791566587)
,p_lov_name=>'LIST ITEMS (INLINE EDIT)'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select lpad('' '',4*(level-1),''.'')|| wwv_flow_escape.html(list_item_link_text) list_item_link_text, id',
'from wwv_flow_list_items i',
'where id not in (',
'    select id from wwv_flow_list_items ',
'    where flow_id = :FB_FLOW_ID',
'    and list_id = :P373_LIST_ID',
'    start with id = :P373_ID ',
'    connect by prior id = parent_list_item_id',
')',
'start with parent_list_item_id is null',
'       and flow_id = :FB_FLOW_ID',
'       and list_id = :P373_LIST_ID',
'connect by prior id = parent_list_item_id ',
'        and prior list_id = list_id',
'order siblings by list_item_display_sequence',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475188
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_other_flows
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(51319520349273399)
,p_lov_name=>'LIST OTHER FLOWS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'  from   wwv_flow_visible_flows f',
' where id != :FB_FLOW_ID',
'   and build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'order by 2'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475192
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_page_regions
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(246039671)
,p_lov_name=>'LIST PAGE REGIONS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select plug_name, id from (',
'select plug_name || '' ('' || plug_display_sequence || '')'' as plug_name,',
'       id,',
'       upper(plug_name) pn,',
'       1 x',
'  from wwv_flow_page_plugs p',
' where flow_id           = :FB_FLOW_ID',
'   and page_id           = :FB_FLOW_PAGE_ID',
'   and security_group_id = :WORKSPACE_ID',
'union',
'select wwv_flow_lang.system_message(''LAYOUT.GLOBAL_PAGE_REGION_PREFIX'') ||',
'       r.plug_name || '' ('' || r.plug_display_sequence || '')'' as plug_name,',
'       r.id,',
'       upper(r.plug_name) pn,',
'       2 x',
'  from wwv_flow_steps p,',
'       wwv_flows f,',
'       wwv_flow_page_plugs r',
' where p.flow_id           = :FB_FLOW_ID',
'   and p.id                = :FB_FLOW_PAGE_ID',
'   and p.security_group_id = :WORKSPACE_ID',
'   and f.id                = p.flow_id',
'   and f.global_page_id   <> :fb_flow_page_id',
'   and r.flow_id           = f.id',
'   and r.page_id           = f.global_page_id',
' order by 4, 3) v'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475192
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_pages
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(313088181)
,p_lov_name=>'LIST PAGES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d',
'  from wwv_flow_steps',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and is_page_pattern   = ''N''',
'order by 2'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'ID'
,p_display_column_name=>'N'
,p_group_sort_direction=>'ASC'
,p_default_sort_direction=>'ASC'
,p_version_scn=>72475192
);
wwv_flow_imp_shared.create_list_of_values_cols(
 p_id=>wwv_flow_imp.id(556215676601931892)
,p_query_column_name=>'ID'
,p_display_sequence=>10
,p_data_type=>'NUMBER'
,p_is_visible=>'N'
,p_is_searchable=>'N'
);
wwv_flow_imp_shared.create_list_of_values_cols(
 p_id=>wwv_flow_imp.id(556216095466931893)
,p_query_column_name=>'D'
,p_heading=>'Page'
,p_display_sequence=>20
,p_data_type=>'NUMBER'
);
wwv_flow_imp_shared.create_list_of_values_cols(
 p_id=>wwv_flow_imp.id(556216448153931893)
,p_query_column_name=>'N'
,p_heading=>'Name'
,p_display_sequence=>30
,p_data_type=>'VARCHAR2'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_pages_by_mode
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(3783172060018)
,p_lov_name=>'LIST PAGES BY MODE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'  l_page_mode varchar2(10);',
'  l_where     varchar2(100) := '''';',
'begin',
'  l_page_mode := wwv_flow_page_dev.get_page_mode(p_application_id => :FB_FLOW_ID, p_page_id => :FB_FLOW_PAGE_ID);',
'  ',
'  if l_page_mode <> ''NORMAL'' then',
'    l_where := ''and page_mode=''''''||l_page_mode||'''''' '';',
'  end if;',
'',
'    return ''select id||'''' ''''||name n, id ''||',
'           ''from wwv_flow_steps ''||',
'           ''where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id ''||l_where||',
'           ''order by 2 '';',
'',
'end;'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475212
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_pages_escaped
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(375967232722946469)
,p_lov_name=>'LIST PAGES ESCAPED'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id || '' '' || wwv_flow_escape.html( name ) n, id',
'  from wwv_flow_steps',
' where flow_id           = nvl( :FB_FLOW_ID, :P164_APPLICATION )',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and is_page_pattern   = ''N''',
' order by 2'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_group_sort_direction=>'ASC'
,p_version_scn=>38020723
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_pagetemplates
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(4569556776)
,p_lov_name=>'LIST PAGETEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name, id',
'from   wwv_flow_templates',
'where  flow_id = :FB_FLOW_ID ',
'and   (:fb_theme_id is null or theme_id = :fb_theme_id)',
'and    is_popup = (case when :P4301_PAGE_MODE = ''NORMAL'' then ''N'' else ''Y'' end)',
'order  by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475212
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_theme_class_id
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(43918610013174571)
,p_lov_name=>'LIST THEME CLASS ID'
,p_lov_query=>'.'||wwv_flow_imp.id(43918610013174571)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475212
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43918904551174576)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Vertical Unordered List with Bullets'
,p_lov_return_value=>'1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43919114507174577)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Vertical Ordered List'
,p_lov_return_value=>'2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43919317508174577)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Horizontal Links List'
,p_lov_return_value=>'3'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43919513966174577)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Horizontal Images with Label List'
,p_lov_return_value=>'4'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43919702448174577)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Vertical Images List'
,p_lov_return_value=>'5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43919925901174577)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Button List'
,p_lov_return_value=>'6'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43920119551174578)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Tabbed Navigation List'
,p_lov_return_value=>'7'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43935130193237152)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Wizard Progress List'
,p_lov_return_value=>'17'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(58168303369425651)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Vertical Unordered List without Bullets'
,p_lov_return_value=>'18'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(111810925131441282)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Pull Down Menu'
,p_lov_return_value=>'20'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(111811229980442636)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Pull Down Menu with Image'
,p_lov_return_value=>'21'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(165320913369513737)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Vertical Sidebar List'
,p_lov_return_value=>'19'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43920508983174578)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 1'
,p_lov_return_value=>'9'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43920717140174578)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 2'
,p_lov_return_value=>'10'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43920901196174579)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 3'
,p_lov_return_value=>'11'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43921121313174579)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 4'
,p_lov_return_value=>'12'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43921328149174579)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 5'
,p_lov_return_value=>'13'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43921510615174579)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 6'
,p_lov_return_value=>'14'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43921731720174580)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 7'
,p_lov_return_value=>'15'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43922216940176602)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 8'
,p_lov_return_value=>'16'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(172045731559260808)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Hierarchical Expanding'
,p_lov_return_value=>'22'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(172048114721265462)
,p_lov_disp_sequence=>22
,p_lov_disp_value=>'Hierarchical Expanded'
,p_lov_return_value=>'23'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_ldap_hosts
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(159071014187759020)
,p_lov_name=>'LIST.LDAP.HOSTS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'       attribute_01 d,',
'       attribute_01 r',
'  from wwv_flow_authentications',
' where scheme_type  = ''NATIVE_LDAP''',
'   and attribute_01 is not null',
'   and security_group_id = :WORKSPACE_ID',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475212
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_ldap_ports
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(159071623191761652)
,p_lov_name=>'LIST.LDAP.PORTS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'       attribute_02 d,',
'       attribute_02 r',
'  from wwv_flow_authentications',
' where scheme_type  = ''NATIVE_LDAP''',
'   and attribute_02 is not null',
'   and security_group_id = :WORKSPACE_ID',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475212
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_ldap_search_filter
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(492934916113886709)
,p_lov_name=>'LIST.LDAP.SEARCH_FILTER'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'       attribute_06 d,',
'       attribute_06 r',
'  from wwv_flow_authentications',
' where scheme_type  = ''NATIVE_LDAP''',
'   and attribute_06 is not null',
'   and security_group_id = :WORKSPACE_ID',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475212
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_ldap_strings
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(159072229424763439)
,p_lov_name=>'LIST.LDAP.STRINGS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'       attribute_04 d,',
'       attribute_04 r',
'  from wwv_flow_authentications',
' where scheme_type  = ''NATIVE_LDAP''',
'   and attribute_04 is not null',
'   and security_group_id = :WORKSPACE_ID',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475212
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_ldap_username_edit
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(159073420552770275)
,p_lov_name=>'LIST.LDAP.USERNAME.EDIT'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'       attribute_07 d,',
'       attribute_07 r',
'  from wwv_flow_authentications',
' where scheme_type  = ''NATIVE_LDAP''',
'   and attribute_07 is not null',
'   and security_group_id = :WORKSPACE_ID',
' union',
'select ''return wwv_flow_custom_auth_std.ldap_dnprep;'' as d,',
'       ''return wwv_flow_custom_auth_std.ldap_dnprep;'' as r',
'  from dual',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475212
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_security_schemes
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(166867621769552393)
,p_lov_name=>'LIST.SECURITY.SCHEMES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name, to_char(id) id',
'  from wwv_flow_security_schemes',
' where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''MUST_NOT_BE_PUBLIC_USER'' name, ''MUST_NOT_BE_PUBLIC_USER'' id',
'  from sys.dual',
' order by name'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475212
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_web_services
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(156841902941139735)
,p_lov_name=>'LIST.WEB.SERVICES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r from wwv_flow_shared_web_services',
'',
'where security_group_id = :flow_security_group_id and',
'',
'      flow_id = :fb_flow_id',
'',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475212
);
end;
/
prompt --application/shared_components/user_interface/lovs/listallitems
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(598060166)
,p_lov_name=>'LISTALLITEMS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''CONFIRM.APPLICATION'')||',
''': ''||name a, name b ',
'from wwv_flow_items',
'where flow_id = :FB_FLOW_ID',
'union all',
'select initcap(wwv_flow_lang.system_message(''PAGE''))||',
''': ''||flow_step_id||'': ''||name a, name b',
'',
'from wwv_flow_step_items',
'',
'where flow_id = :FB_FLOW_ID',
'',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475212
);
end;
/
prompt --application/shared_components/user_interface/lovs/lists
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(158508012343182689)
,p_lov_name=>'LISTS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id ',
'  from wwv_flow_lists',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
' order by upper(name)'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475212
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_available_schemas
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(304941591413)
,p_lov_name=>'LIST_AVAILABLE_SCHEMAS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(schema) d, schema r',
'from   wwv_flow_company_schemas',
'where  security_group_id = :flow_security_group_id',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475212
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_available_schemas2
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(64000716365052273)
,p_lov_name=>'LIST_AVAILABLE_SCHEMAS2'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c.schema) d, c.schema r',
'',
'from   wwv_flow_company_schemas c,',
'',
'       wwv_flow_fnd_user u',
'',
'where  c.security_group_id = :flow_security_group_id and',
'',
'       u.security_group_id = :flow_security_group_id and',
'',
'       u.user_name = :flow_user and',
'',
'       (u.ALLOW_ACCESS_TO_SCHEMAS is null or    instr('':''||u.ALLOW_ACCESS_TO_SCHEMAS||'':'','':''||c.schema||'':'')>0)',
'',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475212
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_available_schemas_no_escape
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(116302266921552829)
,p_lov_name=>'LIST_AVAILABLE_SCHEMAS_NO_ESCAPE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select schema d, schema r',
'from   wwv_flow_company_schemas',
'where  security_group_id = :flow_security_group_id',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475212
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_button_templates
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(62093031232114360)
,p_lov_name=>'LIST_BUTTON_TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''BUTTON''',
'and flow_id = :fb_flow_id and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475212
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_calendar_templates
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(62098012232137239)
,p_lov_name=>'LIST_CALENDAR_TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''CALENDAR''',
'and flow_id = :fb_flow_id and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475212
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_dialog_page_templates
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(136602725312225757)
,p_lov_name=>'LIST_DIALOG_PAGE_TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name, id',
'from   wwv_flow_templates',
'where  flow_id = :FB_FLOW_ID ',
'and   (:fb_theme_id is null or theme_id = :fb_theme_id)',
'and    is_popup = ''Y''',
'order  by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475212
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_flow_status
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(634347472712995)
,p_lov_name=>'LIST_FLOW_STATUS'
,p_lov_query=>'.'||wwv_flow_imp.id(634347472712995)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475212
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88157618253966938)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Available'
,p_lov_return_value=>'AVAILABLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88157826171966938)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Available with Developer Toolbar'
,p_lov_return_value=>'AVAILABLE_W_EDIT_LINK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88158015347966939)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Available to Developers Only'
,p_lov_return_value=>'DEVELOPERS_ONLY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88158201893966939)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Restricted Access'
,p_lov_return_value=>'RESTRICTED_ACCESS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88158430795966939)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Unavailable'
,p_lov_return_value=>'UNAVAILABLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88158618218966939)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Unavailable (Status Shown with PL/SQL)'
,p_lov_return_value=>'UNAVAILABLE_PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88158822851966939)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Unavailable (Redirect to URL)'
,p_lov_return_value=>'UNAVAILABLE_URL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_label_templates
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(62099525391141046)
,p_lov_name=>'LIST_LABEL_TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''LABEL''',
'and flow_id = :fb_flow_id and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475212
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_list_templates
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(62101404051144326)
,p_lov_name=>'LIST_LIST_TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''LIST''',
'and flow_id = :fb_flow_id ',
'and theme_id = :fb_theme_id',
'order by upper(name)'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475212
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_menu_templates
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(62102615133147515)
,p_lov_name=>'LIST_MENU_TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''MENU''',
'and flow_id = :fb_flow_id and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475212
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_pages_except_global
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2064606642182259)
,p_lov_name=>'LIST_PAGES_EXCEPT_GLOBAL'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select step.name,',
'       step.id',
'  from wwv_flow_steps step',
' where step.flow_id           = :FB_FLOW_ID',
'   and step.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and is_page_pattern        = ''N''',
'   -- do not show global page',
'   and not exists (',
'       select 1',
'         from wwv_flows flow',
'        where flow.id                = :FB_FLOW_ID',
'          and flow.security_group_id = :FLOW_SECURITY_GROUP_ID',
'          and flow.global_page_id    = step.id )',
' order by 2'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'ID'
,p_display_column_name=>'NAME'
,p_group_sort_direction=>'ASC'
,p_default_sort_direction=>'ASC'
,p_version_scn=>72475212
);
wwv_flow_imp_shared.create_list_of_values_cols(
 p_id=>wwv_flow_imp.id(2065479613188940)
,p_query_column_name=>'ID'
,p_heading=>'Page'
,p_display_sequence=>10
,p_data_type=>'NUMBER'
);
wwv_flow_imp_shared.create_list_of_values_cols(
 p_id=>wwv_flow_imp.id(2065846213188940)
,p_query_column_name=>'NAME'
,p_heading=>'Name'
,p_display_sequence=>20
,p_data_type=>'VARCHAR2'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_page_items
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(5818802865968207)
,p_lov_name=>'LIST_PAGE_ITEMS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select initcap(wwv_flow_lang.system_message(''APPLICATION''))||',
''':''||name a, name b ',
'from wwv_flow_items',
'where flow_id = :FB_FLOW_ID',
'union all',
'select initcap(wwv_flow_lang.system_message(''PAGE''))||',
''': ''||flow_step_id||'': ''||name a, name b',
'from wwv_flow_step_items',
'where flow_id = :FB_FLOW_ID',
'and flow_step_id = :FB_FLOW_PAGE_ID',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475212
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_page_templates
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(62094620627120744)
,p_lov_name=>'LIST_PAGE_TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''PAGE''',
'and flow_id = :fb_flow_id and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475212
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_parent_tabsets
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(130412625318)
,p_lov_name=>'LIST_PARENT_TABSETS'
,p_lov_query=>'select distinct wwv_flow_escape.html(tab_set) d, tab_set r from wwv_flow_toplevel_tabs where flow_id = :fb_flow_id order by 1'
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475212
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_patches
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(198057397)
,p_lov_name=>'LIST_PATCHES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(patch_name) pn, id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'', wwv_flow_escape.html(patch_name))||',
'''} '' pn,0-id id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by pn'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475212
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_region_templates
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(62103530370151962)
,p_lov_name=>'LIST_REGION_TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''REGION''',
'and flow_id = :fb_flow_id  and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475212
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_report_templates
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(62104811455155975)
,p_lov_name=>'LIST_REPORT_TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''REPORT''',
'and flow_id = :fb_flow_id and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475212
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_schema
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(385522518549261442)
,p_lov_name=>'LIST_SCHEMA'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(owner) d, owner v',
'  from wwv_flows',
' where id = :FB_FLOW_ID'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475212
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_schemas_have_privs
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(77465221343784725)
,p_lov_name=>'LIST_SCHEMAS_HAVE_PRIVS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(owner) d, owner v',
'  from wwv_flow_object_owners_dev',
'order by d                   '))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475216
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_tabsets
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(130408529381)
,p_lov_name=>'LIST_TABSETS'
,p_lov_query=>'select wwv_flow_escape.html(d) d, r from wwv_flow_tabset_view'
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475216
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_template_wiz
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(86596530905253701)
,p_lov_name=>'LIST_TEMPLATE_WIZ'
,p_lov_query=>'.'||wwv_flow_imp.id(86596530905253701)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475216
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88297313984807785)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Choose one from the &PRODUCT_NAME. repository'
,p_lov_return_value=>'DEFAULT'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88297514924807786)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'From Scratch'
,p_lov_return_value=>'BLANK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88297709869807786)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'As a Copy of an Existing Template'
,p_lov_return_value=>'COPY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_trees
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(42828313831634427)
,p_lov_name=>'LIST_TREES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(tree_name)||'' (''||initcap(tree_type)||'')'' d,',
'',
'       id',
'',
'from   wwv_flow_trees',
'',
'where  flow_id = :fb_flow_id and',
'',
'       security_group_id = :flow_security_group_id',
'',
'order  by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475216
);
end;
/
prompt --application/shared_components/user_interface/lovs/list_wiz_lov
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(10676432019281440)
,p_lov_name=>'LIST_WIZ_LOV'
,p_lov_query=>'.'||wwv_flow_imp.id(10676432019281440)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475216
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(10676700422281446)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'From Scratch'
,p_lov_return_value=>'BLANK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(10676912271281449)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'As a Copy of an Existing List'
,p_lov_return_value=>'COPY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/load_data_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(23733127290776847)
,p_lov_name=>'LOAD_DATA_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(23733127290776847)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475216
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23733404759776862)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'NUMBER'
,p_lov_return_value=>'NUMBER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23733619464776862)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'VARCHAR2'
,p_lov_return_value=>'VARCHAR2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23733832697776862)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'DATE'
,p_lov_return_value=>'DATE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23734009833776862)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'CLOB'
,p_lov_return_value=>'CLOB'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23734214688776863)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'BINARY_FLOAT'
,p_lov_return_value=>'BINARY_FLOAT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23734413485776863)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'BINARY_DOUBLE'
,p_lov_return_value=>'BINARY_DOUBLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(173822017218331590)
,p_lov_disp_sequence=>16
,p_lov_disp_value=>'JSON CLOB'
,p_lov_return_value=>'JSON_CLOB'
);
end;
/
prompt --application/shared_components/user_interface/lovs/locally_defined_lov_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(3801130412459159)
,p_lov_name=>'LOCALLY_DEFINED_LOV_TYPE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''SC.LOV.PAGE_ITEM'') d,',
'       ''PAGE_ITEM'' r',
'from sys.dual',
'union all',
'select wwv_flow_lang.system_message(''SC.LOV.IG_COLUMN'') d,',
'       ''IG_COLUMN'' r',
'from sys.dual'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'R'
,p_display_column_name=>'D'
,p_group_sort_direction=>'ASC'
,p_default_sort_column_name=>'D'
,p_default_sort_direction=>'ASC'
,p_version_scn=>72475216
);
end;
/
prompt --application/shared_components/user_interface/lovs/lock_status_report_values
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(37430113453704739)
,p_lov_name=>'LOCK STATUS REPORT VALUES'
,p_lov_query=>'.'||wwv_flow_imp.id(37430113453704739)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475216
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(37430310670704743)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'All Pages'
,p_lov_return_value=>'ALL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(37430529682704745)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Locked Pages'
,p_lov_return_value=>'LOCKED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(37430723675704745)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Unlocked Pages'
,p_lov_return_value=>'UNLOCKED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/lock_action
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(857850100888646856)
,p_lov_name=>'LOCK_ACTION'
,p_lov_query=>'.'||wwv_flow_imp.id(857850100888646856)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475216
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(857850431729646858)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Lock'
,p_lov_return_value=>'LOCK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(857850739143646859)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Unlock'
,p_lov_return_value=>'UNLOCK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(857851004836646859)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Update'
,p_lov_return_value=>'UPDATE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/login_page_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(86589528912234244)
,p_lov_name=>'LOGIN_PAGE_TYPE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,r from (',
'    select initcap(',
'wwv_flow_lang.system_message(''USE_PAGE_AS_LOGIN_PAGE'',id)) d, ''LOGIN'' r, 4 ob from wwv_flow_steps where flow_id=:FB_FLOW_ID and upper(alias) = ''LOGIN''',
'  union all',
'    select initcap(',
'wwv_flow_lang.system_message(''CREATE_NEW_LOGIN_PAGE'')) d, ''CREATE'' r,2 ob from dual where',
'not exists (select 1 from wwv_flow_steps where flow_id=:FB_FLOW_ID and upper(alias) = ''LOGIN'')',
'  union all',
'    select initcap(',
'wwv_flow_lang.system_message(''USE_BUILTIN_LOGIN_PAGE''))  d,''-BUILTIN-'' r, 9 ob from dual)',
'order by ob'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475216
);
end;
/
prompt --application/shared_components/user_interface/lovs/logo_attributes
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(461376702019738964)
,p_lov_name=>'LOGO ATTRIBUTES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''BLACK_TEXT'') d, ''style="font-family:Arial; color:#000000; font-size:22px; white-space:nowrap; font-weight:bold;"'' r from dual ',
'union all',
'select wwv_flow_lang.system_message(''BLUE_TEXT'') d, ''style="font-family:Arial; color:#004C66; font-size:22px; white-space:nowrap; font-weight:bold;"'' r from dual ',
'union all',
'select wwv_flow_lang.system_message(''WHITE_TEXT'') d, ''style="font-family:Arial; color:#FFFFFF; font-size:22px; white-space:nowrap; font-weight:bold;"'' r from dual',
'union all',
'select wwv_flow_lang.system_message(''GRAY_TEXT'') d, ''style="font-family:Arial; color:#303030; font-size:22px; white-space:nowrap; font-weight:bold;"'' r from dual ',
'union all',
'select wwv_flow_lang.system_message(''image_attributes'') d, ''alt="Application" title="Application"'' r from dual '))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475216
);
end;
/
prompt --application/shared_components/user_interface/lovs/lov_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84909926183685150)
,p_lov_name=>'LOV.TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(84909926183685150)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475216
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84910313696685150)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Static'
,p_lov_return_value=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84910101277685150)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Dynamic'
,p_lov_return_value=>'DYNAMIC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/lov_column_display_roles
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(23061073014556223)
,p_lov_name=>'LOV_COLUMN_DISPLAY_ROLES'
,p_lov_query=>'.'||wwv_flow_imp.id(23061073014556223)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475216
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23061734797556224)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Displayed (Primary)'
,p_lov_return_value=>'PRIMARY_DISPLAY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23062121904556224)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Displayed'
,p_lov_return_value=>'DISPLAY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23062584379556225)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Group By'
,p_lov_return_value=>'GROUP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23062990524556225)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Icon'
,p_lov_return_value=>'ICON'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23195602034190758)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Hidden'
,p_lov_return_value=>'HIDDEN'
);
end;
/
prompt --application/shared_components/user_interface/lovs/lov_credential_stores
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(154515733779642473)
,p_lov_name=>'LOV_CREDENTIAL_STORES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_credentials',
' where security_group_id    = :FLOW_SECURITY_GROUP_ID',
'   and authentication_type != ''KEY_PAIR'''))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'R'
,p_display_column_name=>'D'
,p_group_sort_direction=>'ASC'
,p_default_sort_column_name=>'D'
,p_default_sort_direction=>'ASC'
,p_version_scn=>72475216
);
end;
/
prompt --application/shared_components/user_interface/lovs/lov_translated
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(86578518083174290)
,p_lov_name=>'LOV_TRANSLATED'
,p_lov_query=>'.'||wwv_flow_imp.id(86578518083174290)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475216
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88298317101808717)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Yes'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/lov_wiz_lov
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84344914743638898)
,p_lov_name=>'LOV_WIZ_LOV'
,p_lov_query=>'.'||wwv_flow_imp.id(84344914743638898)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475216
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88299120564809761)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'From Scratch'
,p_lov_return_value=>'BLANK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88299310826809761)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'As a Copy of an Existing List of Values'
,p_lov_return_value=>'COPY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/lanugagecodes
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(61396703881)
,p_lov_name=>'LanugageCodes'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select translation_flow_language_code',
'',
'from   wwv_flow_language_map',
'',
'where  primary_language_flow_id = :FB_FLOW_ID',
'',
'order  by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475216
);
end;
/
prompt --application/shared_components/user_interface/lovs/manage_dev_pref_view_mode
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(93546719421230687)
,p_lov_name=>'MANAGE_DEV_PREF_VIEW_MODE'
,p_lov_query=>'.'||wwv_flow_imp.id(93546719421230687)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475216
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(93546924483230689)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Icons'
,p_lov_return_value=>'ICON'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(93547106760230689)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Details'
,p_lov_return_value=>'DETAIL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/map_background_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1798811115902278)
,p_lov_name=>'MAP_BACKGROUND.TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(1798811115902278)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475216
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1799511994902290)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Vector Tile Layer'
,p_lov_return_value=>'VECTOR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1799128612902286)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Raster XYZ Tile Layer'
,p_lov_return_value=>'RASTER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1799903442902290)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'OGC WMS'
,p_lov_return_value=>'OGCWMS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/map_region_geometry_column_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2214661182663976)
,p_lov_name=>'MAP_REGION_GEOMETRY_COLUMN_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(2214661182663976)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475216
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2214906878663985)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Geometry Column'
,p_lov_return_value=>'GEOMETRY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2215331932663988)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Two Numeric Columns'
,p_lov_return_value=>'NUMBER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/map_region_layer_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2204527800561582)
,p_lov_name=>'MAP_REGION_LAYER_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(2204527800561582)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475216
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2204840421561687)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Points'
,p_lov_return_value=>'POINT'
,p_lov_template=>'#DISPLAY_VALUE#| map-points'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2205270686561690)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Lines'
,p_lov_return_value=>'LINE'
,p_lov_template=>'#DISPLAY_VALUE#| map-lines'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2205538404561690)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Polygons'
,p_lov_return_value=>'POLYGON'
,p_lov_template=>'#DISPLAY_VALUE#| map-polygons'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2205977070561690)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Heat Map'
,p_lov_return_value=>'HEATMAP'
,p_lov_template=>'#DISPLAY_VALUE#| map-heatmap'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2206380320561695)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Extruded Polygons'
,p_lov_return_value=>'POLYGON_3D'
,p_lov_template=>'#DISPLAY_VALUE#| map-extruded-polygons'
);
end;
/
prompt --application/shared_components/user_interface/lovs/marctest
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(125887329626694870)
,p_lov_name=>'MARCTEST'
,p_lov_query=>'.'||wwv_flow_imp.id(125887329626694870)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475216
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(125887611763694871)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'aaa'
,p_lov_return_value=>'10'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(125887930721694872)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'bbb'
,p_lov_return_value=>'20'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(125888224602694872)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'ccc'
,p_lov_return_value=>'30'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(125888508873694872)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'ddd'
,p_lov_return_value=>'40'
);
end;
/
prompt --application/shared_components/user_interface/lovs/marker_style
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84879717151455385)
,p_lov_name=>'MARKER_STYLE'
,p_lov_query=>'.'||wwv_flow_imp.id(84879717151455385)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475218
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84879905128455386)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Circle'
,p_lov_return_value=>'CIRCLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84880123391455386)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Diamond'
,p_lov_return_value=>'DIAMOND'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84880312259455387)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Square'
,p_lov_return_value=>'SQUARE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84880528001455387)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Triangle'
,p_lov_return_value=>'TRIANGLE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/maximum_rows_per_page
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84800803131139158)
,p_lov_name=>'MAXIMUM ROWS PER PAGE'
,p_lov_query=>'.'||wwv_flow_imp.id(84800803131139158)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475218
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(180345125591578775)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'5'
,p_lov_return_value=>'5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84801031902139159)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'10'
,p_lov_return_value=>'10'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84801207012139159)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'15'
,p_lov_return_value=>'15'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84801406447139159)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'20'
,p_lov_return_value=>'20'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84801631719139159)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'25'
,p_lov_return_value=>'25'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(239238717004567042)
,p_lov_disp_sequence=>45
,p_lov_disp_value=>'30'
,p_lov_return_value=>'30'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84801809006139160)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'50'
,p_lov_return_value=>'50'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84802017106139160)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'75'
,p_lov_return_value=>'75'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84802230048139160)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'100'
,p_lov_return_value=>'100'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84802410431139160)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'500'
,p_lov_return_value=>'500'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84802619722139161)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'1000'
,p_lov_return_value=>'1000'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84802809542139161)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'5000'
,p_lov_return_value=>'5000'
);
end;
/
prompt --application/shared_components/user_interface/lovs/menu_theme_class_id
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(43945521366272493)
,p_lov_name=>'MENU THEME CLASS ID'
,p_lov_query=>'.'||wwv_flow_imp.id(43945521366272493)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475219
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43945822796272497)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Breadcrumb'
,p_lov_return_value=>'1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43946021659272497)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Hierarchical'
,p_lov_return_value=>'2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43946200038272497)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 1'
,p_lov_return_value=>'3'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43946403201272498)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 2'
,p_lov_return_value=>'4'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43946615168272498)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 3'
,p_lov_return_value=>'5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43946827418272498)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 4'
,p_lov_return_value=>'6'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43947018619272498)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 5'
,p_lov_return_value=>'7'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43947229068272498)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 6'
,p_lov_return_value=>'8'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43947419430272499)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 7'
,p_lov_return_value=>'9'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(43947619554272499)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 8'
,p_lov_return_value=>'10'
);
end;
/
prompt --application/shared_components/user_interface/lovs/menu_templates
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(146659516889284778)
,p_lov_name=>'MENU.TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id',
'  from wwv_flow_menu_templates',
' where flow_id = :fb_flow_id and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by upper(name)'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475220
);
end;
/
prompt --application/shared_components/user_interface/lovs/menu_start_with
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84876111826444446)
,p_lov_name=>'MENU_START_WITH'
,p_lov_query=>'.'||wwv_flow_imp.id(84876111826444446)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475220
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84876328851444446)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Child Breadcrumb Entries'
,p_lov_return_value=>'CHILD_MENU'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84876509333444446)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Current Breadcrumb'
,p_lov_return_value=>'CURRENT_MENU'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84876719009444447)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Parent Breadcrumb Entries'
,p_lov_return_value=>'PARENT_MENU'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84876912643444447)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Parent to Leaf (breadcrumb style)'
,p_lov_return_value=>'PARENT_TO_LEAF'
);
end;
/
prompt --application/shared_components/user_interface/lovs/menu_template_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(86077012626803751)
,p_lov_name=>'MENU_TEMPLATE_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(86077012626803751)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475224
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88299923681810664)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'From Scratch'
,p_lov_return_value=>'BLANK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88300108885810665)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'As a Copy of an Existing Template'
,p_lov_return_value=>'COPY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/mobile_page_template
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(4794802534531342)
,p_lov_name=>'MOBILE_PAGE_TEMPLATE'
,p_lov_query=>'.'||wwv_flow_imp.id(4794802534531342)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475224
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4795112307531465)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Standard Browser'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/model_users
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(240554501608741323)
,p_lov_name=>'MODEL USERS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct wwv_flow_escape.html(m.created_by) d, m.created_by r',
'from wwv_flow_models m, wwv_flow_model_pages p, wwv_flow_company_schemas s',
'where m.id = p.model_id ',
'and   m.owner = s.schema',
'and m.security_group_id = :flow_security_group_id',
'and s.security_group_id = :flow_security_group_id',
'and m.model_complete = ''Y''',
'group by m.created_by'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475224
);
end;
/
prompt --application/shared_components/user_interface/lovs/model_link_extra_column
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(148927707220116911)
,p_lov_name=>'MODEL_LINK_EXTRA_COLUMN'
,p_lov_query=>'.'||wwv_flow_imp.id(148927707220116911)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475224
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(148928000552116912)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Use extra column to display link'
,p_lov_return_value=>'LINK_COLUMN'
);
end;
/
prompt --application/shared_components/user_interface/lovs/model_link_to_page
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(152446125589862819)
,p_lov_name=>'MODEL_LINK_TO_PAGE'
,p_lov_query=>'.'||wwv_flow_imp.id(152446125589862819)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475224
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(152446325930862821)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Theme Specific Edit Button'
,p_lov_return_value=>'LINK_COLUMN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(147361702073726841)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Report Column'
,p_lov_return_value=>'REPORT_COLUMN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(147371230863763536)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Custom Link'
,p_lov_return_value=>'CUSTOM_LINK'
);
end;
/
prompt --application/shared_components/user_interface/lovs/model_use_theme_button
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(153128814386643499)
,p_lov_name=>'MODEL_USE_THEME_BUTTON'
,p_lov_query=>'.'||wwv_flow_imp.id(153128814386643499)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475224
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(153129027237643499)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Use theme-specific edit button'
,p_lov_return_value=>'THEME'
);
end;
/
prompt --application/shared_components/user_interface/lovs/named_lov
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(5278749326)
,p_lov_name=>'NAMED_LOV'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(lov_name) d, lov_name r',
'',
'from wwv_flow_lists_of_values$',
'',
'where flow_id = :FB_FLOW_ID',
'',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475224
);
end;
/
prompt --application/shared_components/user_interface/lovs/named_lov_returning_id
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(73045019699242595)
,p_lov_name=>'NAMED_LOV_RETURNING_ID'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(lov_name) d, id',
'',
'from wwv_flow_lists_of_values$',
'',
'where flow_id = :FB_FLOW_ID',
'',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475224
);
end;
/
prompt --application/shared_components/user_interface/lovs/navigation_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(174541309940513694)
,p_lov_name=>'NAVIGATION TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(174541309940513694)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475224
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(174541620822513696)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Tabs'
,p_lov_return_value=>'T'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(174541910206513699)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'List'
,p_lov_return_value=>'L'
);
end;
/
prompt --application/shared_components/user_interface/lovs/navigation_bar_position
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1383752466189575385)
,p_lov_name=>'NAVIGATION_BAR_POSITION'
,p_lov_query=>'.'||wwv_flow_imp.id(1383752466189575385)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475224
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1383752716721575387)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Top'
,p_lov_return_value=>'TOP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1383753025830575387)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Side'
,p_lov_return_value=>'SIDE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/navlist_entries
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2004284670470158)
,p_lov_name=>'NAVLIST_ENTRIES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case',
'           when (nvl(list_item_link_target,''0'')=''0'' or parent_list_item_id is',
'null) then',
'               lpad('' '',(4*(level-1)),''.'')||list_item_link_text',
'           else',
'               lpad('' '',(4*(level-1)),''.'')||'' (''||list_item_link_text ||'')''',
'       end name,',
'       id',
'  from wwv_flow_list_items',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and sub_list_id is null',
' start with list_id = :P2500_NAVLIST_ID and parent_list_item_id is null',
'connect by prior list_id = list_id and prior id = parent_list_item_id',
' order siblings by list_item_display_sequence'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'ID'
,p_display_column_name=>'NAME'
,p_group_sort_direction=>'ASC'
,p_default_sort_direction=>'ASC'
,p_version_scn=>72475224
);
end;
/
prompt --application/shared_components/user_interface/lovs/nav_bar_create_method
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84245132593407471)
,p_lov_name=>'NAV_BAR_CREATE_METHOD'
,p_lov_query=>'.'||wwv_flow_imp.id(84245132593407471)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475224
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88302321041819363)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'From Scratch'
,p_lov_return_value=>'BLANK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88302522891819363)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'As a Copy of an Existing Navigation Bar'
,p_lov_return_value=>'COPY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/nav_bar_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1383750926477562234)
,p_lov_name=>'NAV_BAR_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(1383750926477562234)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475224
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1383751231985562235)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Classic'
,p_lov_return_value=>'NAVBAR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1383751513527562236)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'List'
,p_lov_return_value=>'LIST'
);
end;
/
prompt --application/shared_components/user_interface/lovs/nav_menu_position_icons
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1856613427542451349)
,p_lov_name=>'NAV_MENU_POSITION_ICONS'
,p_lov_query=>'.'||wwv_flow_imp.id(1856613427542451349)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475224
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1856613755632451354)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Top'
,p_lov_return_value=>'TOP'
,p_lov_template=>'<span class="a-Icon icon-nav-top" aria-hidden="true"></span> #DISPLAY_VALUE#'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1856614196674451355)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Side'
,p_lov_return_value=>'SIDE'
,p_lov_template=>'<span class="a-Icon icon-nav-side" aria-hidden="true"></span> #DISPLAY_VALUE#'
);
end;
/
prompt --application/shared_components/user_interface/lovs/new
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(41348803113175334)
,p_lov_name=>'NEW'
,p_lov_query=>'.'||wwv_flow_imp.id(41348803113175334)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475224
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(41353729217192272)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'New page'
,p_lov_return_value=>'NEW_PAGE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(41349526190175350)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Region on this page'
,p_lov_return_value=>'NEW_REGION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(41349127275175345)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Page control on this page'
,p_lov_return_value=>'NEW_PAGE_CONTROL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(41349322741175350)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Shared control'
,p_lov_return_value=>'NEW_SHARED_COMPONENT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/new_flow_component
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(56261603527740250)
,p_lov_name=>'NEW.FLOW.COMPONENT'
,p_lov_query=>'.'||wwv_flow_imp.id(56261603527740250)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475230
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1155882395637829140)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Application Computation'
,p_lov_return_value=>'APP_COMPUTATION'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1155881827328817113)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Application Item'
,p_lov_return_value=>'APP_ITEM'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1155879848948783070)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Application Process'
,p_lov_return_value=>'APP_PROCESS'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1155883932250884540)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Authentication Scheme'
,p_lov_return_value=>'AUTHENTICATION'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1155878330459754175)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Authorization Scheme'
,p_lov_return_value=>'AUTH_SCHEME'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(56262910363740259)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Breadcrumb'
,p_lov_return_value=>'MENU'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1155884584340896995)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Build Option'
,p_lov_return_value=>'BUILD_OPT'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(56262729926740259)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'List'
,p_lov_return_value=>'LIST'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(56262512111740259)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'List of Values'
,p_lov_return_value=>'LOV'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(56261902885740255)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Navigation Bar Entry'
,p_lov_return_value=>'NAVBAR'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(56262124240740258)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Parent Tab'
,p_lov_return_value=>'PTAB'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1155885541473911064)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'Plug-in'
,p_lov_return_value=>'PLUGIN'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1155876629693724292)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>'Report Layout'
,p_lov_return_value=>'REP_LAYOUT'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1155875729258709848)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>'Report Query'
,p_lov_return_value=>'REP_QRY'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1155877287613732395)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'Shortcut'
,p_lov_return_value=>'SHORTCUT'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(56262327091740258)
,p_lov_disp_sequence=>16
,p_lov_disp_value=>'Standard Tab'
,p_lov_return_value=>'STAB'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1155880688440799375)
,p_lov_disp_sequence=>17
,p_lov_disp_value=>'Static Application File'
,p_lov_return_value=>'APP_FILE'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1155881249285807487)
,p_lov_disp_sequence=>18
,p_lov_disp_value=>'Static Workspace File'
,p_lov_return_value=>'WS_FILE'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1155885032437902193)
,p_lov_disp_sequence=>19
,p_lov_disp_value=>'Template'
,p_lov_return_value=>'TEMPLATE'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1155879177309770213)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Text Message'
,p_lov_return_value=>'TEXT'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1155874775728640463)
,p_lov_disp_sequence=>21
,p_lov_disp_value=>'Web Service Reference'
,p_lov_return_value=>'WS_REF'
,p_lov_template=>'#DISPLAY_VALUE#'
);
end;
/
prompt --application/shared_components/user_interface/lovs/new_form_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(54502713568963394)
,p_lov_name=>'NEW.FORM.OPTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(54502713568963394)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475232
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(54503231398963400)
,p_lov_disp_sequence=>32
,p_lov_disp_value=>'Form on a Table'
,p_lov_return_value=>'FORM'
,p_lov_template=>'#DISPLAY_VALUE#| icon-page-form-table'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(54503811384963401)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Form on a SQL Query'
,p_lov_return_value=>'FORMONSQL'
,p_lov_template=>'#DISPLAY_VALUE#| icon-page-form-sql'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(54503606699963400)
,p_lov_disp_sequence=>55
,p_lov_disp_value=>'Form on a Procedure'
,p_lov_return_value=>'FORMONPROC'
,p_lov_template=>'#DISPLAY_VALUE#| icon-page-form-procedure'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(202747215734446805)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Form on Web Service'
,p_lov_return_value=>'FORMWS'
,p_lov_template=>'#DISPLAY_VALUE#| icon-page-report-webservice'
);
end;
/
prompt --application/shared_components/user_interface/lovs/new_page_component_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(55966712494123138)
,p_lov_name=>'NEW.PAGE.COMPONENT.TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(55966712494123138)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475232
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(55967204428123139)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Item'
,p_lov_return_value=>'ITEM'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(55967628285123140)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Button'
,p_lov_return_value=>'BUTTON'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(55967422140123139)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Branch'
,p_lov_return_value=>'BRANCH'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(55967827403123140)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Computation'
,p_lov_return_value=>'COMPUTATION'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(55968021272123140)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Process'
,p_lov_return_value=>'PROCESS'
,p_lov_template=>'#DISPLAY_VALUE#'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(55968210751123141)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Validation'
,p_lov_return_value=>'VALIDATION'
,p_lov_template=>'#DISPLAY_VALUE#'
);
end;
/
prompt --application/shared_components/user_interface/lovs/new_or_existing
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(4002730466623798)
,p_lov_name=>'NEW_OR_EXISTING'
,p_lov_query=>'.'||wwv_flow_imp.id(4002730466623798)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475232
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4003436086623815)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Existing bucket or'
,p_lov_return_value=>'EXISTING'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4003063941623815)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'New'
,p_lov_return_value=>'NEW'
);
end;
/
prompt --application/shared_components/user_interface/lovs/no_show_success_in_future
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84732526223887360)
,p_lov_name=>'NO_SHOW_SUCCESS_IN_FUTURE'
,p_lov_query=>'.'||wwv_flow_imp.id(84732526223887360)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475232
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84732711793887361)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Do not show success page in the future'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/object_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(277431029384153056)
,p_lov_name=>'OBJECT.TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(277431029384153056)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475232
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(277431204230153061)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Function'
,p_lov_return_value=>'FUNCTION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(277431400869153065)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Index'
,p_lov_return_value=>'INDEX'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(277431613646153065)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Package'
,p_lov_return_value=>'PACKAGE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(277431823408153065)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Procedure'
,p_lov_return_value=>'PROCEDURE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(277432017860153065)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Sequence'
,p_lov_return_value=>'SEQUENCE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(277432208891153066)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Synonym'
,p_lov_return_value=>'SYNONYM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(277432406661153066)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Table'
,p_lov_return_value=>'TABLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(277432614868153066)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Trigger'
,p_lov_return_value=>'TRIGGER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(277432808078153066)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'View'
,p_lov_return_value=>'VIEW'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(51094563587826026)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Type'
,p_lov_return_value=>'TYPE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/oci_credentials
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(5600842589888510)
,p_lov_name=>'OCI_CREDENTIALS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id',
'  from wwv_credentials',
' where authentication_type = ''OCI''',
'   and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'ID'
,p_display_column_name=>'NAME'
,p_group_sort_direction=>'ASC'
,p_default_sort_column_name=>'NAME'
,p_default_sort_direction=>'ASC'
,p_version_scn=>72475232
);
end;
/
prompt --application/shared_components/user_interface/lovs/on_demand_processes
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(156837711683123346)
,p_lov_name=>'ON.DEMAND.PROCESSES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(process_name) d, id r',
'',
'  from wwv_flow_processing',
'',
'where flow_id = :fb_flow_id and process_point = ''ON_DEMAND''',
'',
' order by process_name',
'',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475232
);
end;
/
prompt --application/shared_components/user_interface/lovs/on_off
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(9165706597746719)
,p_lov_name=>'ON_OFF'
,p_lov_query=>'.'||wwv_flow_imp.id(9165706597746719)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475232
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9165915858746727)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'On'
,p_lov_return_value=>'ON'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9166117224746730)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Off'
,p_lov_return_value=>'OFF'
);
end;
/
prompt --application/shared_components/user_interface/lovs/orphaned_lists_display
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(94838211998345101)
,p_lov_name=>'ORPHANED_LISTS_DISPLAY'
,p_lov_query=>'.'||wwv_flow_imp.id(94838211998345101)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475232
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(94838503112345102)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Orphaned'
,p_lov_return_value=>'O'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(94838713034345102)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'All'
,p_lov_return_value=>'A'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p105_all_my_files
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(153643805218811160)
,p_lov_name=>'P105_ALL_MY_FILES'
,p_lov_query=>'.'||wwv_flow_imp.id(153643805218811160)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475232
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(153644123892811161)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'My Files'
,p_lov_return_value=>'MY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(153644329503811161)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'All Files'
,p_lov_return_value=>'ALL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p143_grid_column
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(217410917274629373)
,p_lov_name=>'P143.GRID_COLUMN'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
' select level as d, level as r',
'   from sys.dual',
'connect by level <= :P143_GRID_MAX_COLUMNS'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475232
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1556_display_selections
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(112777512483182861)
,p_lov_name=>'P1556_DISPLAY_SELECTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(112777512483182861)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475232
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(112777702670182866)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'- All -'
,p_lov_return_value=>'All'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(112777913428182869)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Label'
,p_lov_return_value=>'L'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(112778103167182870)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Display As'
,p_lov_return_value=>'D'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(112778319856182870)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Format'
,p_lov_return_value=>'F'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(112778517171182870)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Form Default Value'
,p_lov_return_value=>'V'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(112778711439182870)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Display Size'
,p_lov_return_value=>'S'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(112778913135182870)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Form Help'
,p_lov_return_value=>'H'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(112779121557182871)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Report Alignment'
,p_lov_return_value=>'A'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1610_actions
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(249294887509698711)
,p_lov_name=>'P1610_ACTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(249294887509698711)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475232
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(249295104828698712)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'From scratch'
,p_lov_return_value=>'CREATE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(249295509034698713)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'As copy of an existing REST Enabled SQL Service'
,p_lov_return_value=>'COPY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1612_copy
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(249334505721803809)
,p_lov_name=>'P1612.COPY'
,p_lov_query=>'.'||wwv_flow_imp.id(249334505721803809)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475232
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(249334893554803810)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Yes'
,p_lov_return_value=>'Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(249335284311803810)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'No'
,p_lov_return_value=>'N'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(249335642186803811)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Copy and Subscribe'
,p_lov_return_value=>'SUBSCRIBE'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':P1611_COPY_FROM <> :FB_FLOW_ID'
,p_lov_disp_cond2=>'PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1700_columns
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(381833322409586869)
,p_lov_name=>'P1700_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :F4000_P1700_OWNER',
'   and table_name = :F4000_P1700_TABLE_NAME',
'   and data_type <> ''BLOB'''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475232
);
end;
/
prompt --application/shared_components/user_interface/lovs/p173_show
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(48989614083583743)
,p_lov_name=>'P173_SHOW'
,p_lov_query=>'.'||wwv_flow_imp.id(48989614083583743)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475232
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(48989812927583749)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Application Templates'
,p_lov_return_value=>'1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(48990014681583750)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Theme Template Counts'
,p_lov_return_value=>'2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(205410028377606456)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'File References'
,p_lov_return_value=>'FILE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(205425424268633678)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Class References'
,p_lov_return_value=>'CLASS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(205426329116635065)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Template Substitution Strings'
,p_lov_return_value=>'TEMPLATE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p176_page_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(714200985818178118)
,p_lov_name=>'P176_PAGE_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(714200985818178118)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475232
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(714201271961178121)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Report and Form'
,p_lov_return_value=>'REPORT_AND_FORM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(714201627845178122)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Single Page'
,p_lov_return_value=>'SINGLE_PG'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p176_report_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(329353513116624468)
,p_lov_name=>'P176_REPORT_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(329353513116624468)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475232
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(329353826739624470)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Interactive Report'
,p_lov_return_value=>'INTERACTIVE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(713173926577991309)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Interactive Grid'
,p_lov_return_value=>'IG'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(329354106024624470)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Classic Report'
,p_lov_return_value=>'CLASSIC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1801_columns
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1172046023461279303)
,p_lov_name=>'P1801_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P1801_OWNER',
'   and table_name = :P1801_TABLE_NAME'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475232
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1801_table_name
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(705239800153899318)
,p_lov_name=>'P1801_TABLE_NAME'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select TABLE_NAME display_value, ID return_value ',
'from WWV_FLOW_LOAD_TABLES',
'where name = :P1801_NAME',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475232
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1802_columns
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(694138215390835955)
,p_lov_name=>'P1802_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P1802_LOOKUP_OWNER',
'   and table_name = :P1802_LOOKUP_TABLE_NAME',
'   and data_type <> ''BLOB'''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475232
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1812_collection_columns
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(3007625702757031)
,p_lov_name=>'P1812_COLLECTION_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name||'' (''|| initcap(data_type) ||'')'' as d,',
'       column_name as r',
'from sys.dba_tab_columns',
'where owner = :OWNER',
'and table_name = ''WWV_FLOW_COLLECTIONS''',
'and data_type not in ( ''BLOB'', ''XMLTYPE'' )',
'and column_name not in ( ''SEQ_ID'', ''MD5_ORIGINAL'', ''COLLECTION_NAME'' )',
'order by column_id'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'R'
,p_display_column_name=>'D'
,p_group_sort_direction=>'ASC'
,p_default_sort_direction=>'ASC'
,p_version_scn=>72475232
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1812_table_columns
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2132493628676085)
,p_lov_name=>'P1812_TABLE_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name||'' (''|| initcap(data_type) ||'')'' as d,',
'       column_name as r',
'from sys.dba_tab_columns',
'where owner = :P1811_TABLE_OWNER',
'and table_name = :P1811_TABLE_NAME',
'order by column_id'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'R'
,p_display_column_name=>'D'
,p_group_sort_direction=>'ASC'
,p_default_sort_direction=>'ASC'
,p_version_scn=>72475232
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1817_copy
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(3387269549000655)
,p_lov_name=>'P1817.COPY'
,p_lov_query=>'.'||wwv_flow_imp.id(3387269549000655)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475232
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3387527981001063)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Yes'
,p_lov_return_value=>'Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3387951318001064)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'No'
,p_lov_return_value=>'N'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3388361761001064)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Copy and Subscribe'
,p_lov_return_value=>'SUBSCRIBE'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':P1816_COPY_FROM <> :FB_FLOW_ID'
,p_lov_disp_cond2=>'PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1905_actions
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(247678451096396264)
,p_lov_name=>'P1905_ACTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(247678451096396264)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475232
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(247678721347396266)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'From scratch'
,p_lov_return_value=>'CREATE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(247679191058396269)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'As copy of an existing REST Data Source'
,p_lov_return_value=>'COPY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4200940468413888)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'From a REST Source Catalog'
,p_lov_return_value=>'CATALOG'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null ',
'  from WWV_WEB_SRC_CATALOGS c',
' where security_group_id = :WORKSPACE_ID',
'   and exists ( select 1 ',
'                  from wwv_web_src_catalog_services s',
'                 where security_group_id = :WORKSPACE_ID',
'                   and s.catalog_id = c.id )'))
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1907_copy
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(247782857688295098)
,p_lov_name=>'P1907.COPY'
,p_lov_query=>'.'||wwv_flow_imp.id(247782857688295098)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475232
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(247783143135295099)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Yes'
,p_lov_return_value=>'Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(247783588055295099)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'No'
,p_lov_return_value=>'N'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(247783952074295099)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Copy and Subscribe'
,p_lov_return_value=>'SUBSCRIBE'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':P1906_COPY_FROM <> :FB_FLOW_ID'
,p_lov_disp_cond2=>'PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1925_data_profile_format
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(607713258081514419)
,p_lov_name=>'P1925_DATA_PROFILE_FORMAT'
,p_lov_query=>'.'||wwv_flow_imp.id(607713258081514419)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475232
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(607713548960514424)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CSV'
,p_lov_return_value=>'CSV'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(607713952628514429)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'JSON'
,p_lov_return_value=>'JSON'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(607714315537514429)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'XLSX'
,p_lov_return_value=>'XLSX'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'P1925_IS_WEB_SRC_PROFILE'
,p_lov_disp_cond2=>'N'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(607714737048514430)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'XML'
,p_lov_return_value=>'XML'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1926_data_profile_cols
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(4483925603898914)
,p_lov_name=>'P1926_DATA_PROFILE_COLS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name',
'from wwv_flow_data_profile_cols',
'where data_profile_id = :P1925_DATA_PROFILE_ID',
'and flow_id = :FB_FLOW_ID',
'and security_group_id = :FLOW_SECURITY_GROUP_ID',
'order by sequence'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_return_column_name=>'NAME'
,p_display_column_name=>'NAME'
,p_version_scn=>72475232
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1926_lookup_columns
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(4458615411627104)
,p_lov_name=>'P1926_LOOKUP_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = coalesce( :P1926_LOOKUP_OWNER, upper(wwv_flow_wizard_api.get_flow_owner(:FB_FLOW_ID)))',
'   and table_name = :P1926_LOOKUP_TABLE',
'   and data_type <> ''BLOB'''))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'COLUMN_NAME'
,p_display_column_name=>'COLUMN_NAME_ESC'
,p_group_sort_direction=>'ASC'
,p_default_sort_direction=>'ASC'
,p_version_scn=>72475232
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1951_max_requests_exc_action
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(601125790424873502)
,p_lov_name=>'P1951_MAX_REQUESTS_EXC_ACTION'
,p_lov_query=>'.'||wwv_flow_imp.id(601125790424873502)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475232
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601125956648873502)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Raise Error'
,p_lov_return_value=>'ERROR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601126391695873506)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Wait'
,p_lov_return_value=>'WAIT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1951_new_or_existing_table
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(601127065669873845)
,p_lov_name=>'P1951_NEW_OR_EXISTING_TABLE'
,p_lov_query=>'.'||wwv_flow_imp.id(601127065669873845)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475234
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601127244730873845)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'New Table'
,p_lov_return_value=>'NEW'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601127625076873845)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Existing Table'
,p_lov_return_value=>'EXISTING'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1951_replace_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(601128335146874196)
,p_lov_name=>'P1951_REPLACE_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(601128335146874196)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475234
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601128505255874196)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'DELETE (transactional)'
,p_lov_return_value=>'DELETE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601128965924874196)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'TRUNCATE (non-transactional)'
,p_lov_return_value=>'TRUNCATE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1951_script_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(601129636599874441)
,p_lov_name=>'P1951_SCRIPT_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(601129636599874441)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475234
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601129868183874441)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Install'
,p_lov_return_value=>'1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601130273688874441)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Upgrade'
,p_lov_return_value=>'2'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p1951_sync_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(601130955295874684)
,p_lov_name=>'P1951_SYNC_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(601130955295874684)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475234
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601131122496874684)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Append'
,p_lov_return_value=>'APPEND'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601131505261874685)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Merge'
,p_lov_return_value=>'MERGE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601131967547874685)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Replace'
,p_lov_return_value=>'REPLACE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p195_parent_regions
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(170777029602529928)
,p_lov_name=>'P195_PARENT_REGIONS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select plug_name || '' ('' || plug_display_sequence || '')'' as plug_name,',
'       id',
'  from wwv_flow_page_plugs p',
' where flow_id           = :FB_FLOW_ID',
'   and page_id           = :F4000_P194_COPY_TO_PAGE_ID',
'   and security_group_id = :WORKSPACE_ID',
' order by plug_name'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475234
);
end;
/
prompt --application/shared_components/user_interface/lovs/p198_icon_classes
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(4020363974607382)
,p_lov_name=>'P198_ICON_CLASSES'
,p_lov_query=>'.'||wwv_flow_imp.id(4020363974607382)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475234
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4020778800607383)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Folder'
,p_lov_return_value=>'folder'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-folder'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4021195666607383)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Spreadsheet'
,p_lov_return_value=>'spreadsheet'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-spreadsheet'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4021568429607383)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Messages'
,p_lov_return_value=>'talk-bubbles'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-talk-bubbles'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4021910784607383)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>'Analytics'
,p_lov_return_value=>'analytics'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-analytics'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4022358636607383)
,p_lov_disp_sequence=>24
,p_lov_disp_value=>'Bar Chart'
,p_lov_return_value=>'bar-line-chart'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-bar-line-chart'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4022725649607383)
,p_lov_disp_sequence=>34
,p_lov_disp_value=>'Calendar'
,p_lov_return_value=>'calendar'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-calendar'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4023111577607384)
,p_lov_disp_sequence=>44
,p_lov_disp_value=>'Cloud'
,p_lov_return_value=>'cloud'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-cloud'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4023568828607384)
,p_lov_disp_sequence=>54
,p_lov_disp_value=>'Cubes'
,p_lov_return_value=>'cubes'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-cubes'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4023948804607384)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Mail'
,p_lov_return_value=>'email'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-email'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4024347009607384)
,p_lov_disp_sequence=>64
,p_lov_disp_value=>'Database'
,p_lov_return_value=>'database'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-database'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4024733582607384)
,p_lov_disp_sequence=>74
,p_lov_disp_value=>'Gear'
,p_lov_return_value=>'gear'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-gear'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4025115858607384)
,p_lov_disp_sequence=>84
,p_lov_disp_value=>'Graphs'
,p_lov_return_value=>'graphs'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-graphs'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4025555984607385)
,p_lov_disp_sequence=>94
,p_lov_disp_value=>'Map'
,p_lov_return_value=>'map'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-map'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4025992497607385)
,p_lov_disp_sequence=>104
,p_lov_disp_value=>'People'
,p_lov_return_value=>'people'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-people'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4026354838607385)
,p_lov_disp_sequence=>114
,p_lov_disp_value=>'Smiley'
,p_lov_return_value=>'smiley'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-smiley'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4026747246607385)
,p_lov_disp_sequence=>124
,p_lov_disp_value=>'To Do'
,p_lov_return_value=>'todo'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-todo'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4027167138607386)
,p_lov_disp_sequence=>134
,p_lov_disp_value=>'Bug'
,p_lov_return_value=>'bug'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-bug'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4027549401607386)
,p_lov_disp_sequence=>144
,p_lov_disp_value=>'Dots'
,p_lov_return_value=>'dots'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-dots'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4027918738607386)
,p_lov_disp_sequence=>154
,p_lov_disp_value=>'Gauge'
,p_lov_return_value=>'gauge'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-gauge'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4028334538607387)
,p_lov_disp_sequence=>164
,p_lov_disp_value=>'Grid'
,p_lov_return_value=>'grid'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-grid'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4028744784607387)
,p_lov_disp_sequence=>174
,p_lov_disp_value=>'Pencil and Paper'
,p_lov_return_value=>'pencil-paper'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-pencil-paper'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4029156326607387)
,p_lov_disp_sequence=>184
,p_lov_disp_value=>'Toolbox'
,p_lov_return_value=>'toolbox'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-toolbox'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4029573285607387)
,p_lov_disp_sequence=>194
,p_lov_disp_value=>'Wrench'
,p_lov_return_value=>'wrench'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-wrench'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4029930090607387)
,p_lov_disp_sequence=>204
,p_lov_disp_value=>'Activity'
,p_lov_return_value=>'activity'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-activity'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4030316517607387)
,p_lov_disp_sequence=>300
,p_lov_disp_value=>'Stopwatch'
,p_lov_return_value=>'stopwatch'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-stopwatch'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4030748484607387)
,p_lov_disp_sequence=>301
,p_lov_disp_value=>'Pie Chart'
,p_lov_return_value=>'pie-chart'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-pie-chart'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4031196281607387)
,p_lov_disp_sequence=>302
,p_lov_disp_value=>'Checkmark'
,p_lov_return_value=>'check-circle'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-check-circle'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4031535932607388)
,p_lov_disp_sequence=>303
,p_lov_disp_value=>'Rocket'
,p_lov_return_value=>'rocket'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-rocket'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4031919406607388)
,p_lov_disp_sequence=>304
,p_lov_disp_value=>'Shield'
,p_lov_return_value=>'shield'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-shield'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4032387684607388)
,p_lov_disp_sequence=>305
,p_lov_disp_value=>'Lightbulb'
,p_lov_return_value=>'lightbulb'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-lightbulb'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4032710058607388)
,p_lov_disp_sequence=>306
,p_lov_disp_value=>'Lock'
,p_lov_return_value=>'lock'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-lock'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4033165706607388)
,p_lov_disp_sequence=>307
,p_lov_disp_value=>'Ship'
,p_lov_return_value=>'ship'
,p_lov_template=>'#DISPLAY_VALUE#| app-icon-ship'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p198_icon_colors
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(4016945210607359)
,p_lov_name=>'P198_ICON_COLORS'
,p_lov_query=>'.'||wwv_flow_imp.id(4016945210607359)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475238
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4017278092607379)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Blue'
,p_lov_return_value=>'#309FDB'
,p_lov_template=>'<span class="app-color app-color-1" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4017634923607380)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Light Blue'
,p_lov_return_value=>'#2EBFBC'
,p_lov_template=>'<span class="app-color app-color-2" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4018033341607380)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Green'
,p_lov_return_value=>'#81BB5F'
,p_lov_template=>'<span class="app-color app-color-3" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4018465903607381)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Orange'
,p_lov_return_value=>'#ED813E'
,p_lov_template=>'<span class="app-color app-color-4" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4018865133607381)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Red'
,p_lov_return_value=>'#E95B54'
,p_lov_template=>'<span class="app-color app-color-5" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4019227242607381)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Pink'
,p_lov_return_value=>'#CA589D'
,p_lov_template=>'<span class="app-color app-color-6" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4019665523607381)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Purple'
,p_lov_return_value=>'#5A68AD'
,p_lov_template=>'<span class="app-color app-color-7" aria-label="#DISPLAY_VALUE#"></span>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4020075827607382)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Grey'
,p_lov_return_value=>'#6E8598'
,p_lov_template=>'<span class="app-color app-color-8" aria-label="#DISPLAY_VALUE#"></span>'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p207_create_template
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(41876318884405056)
,p_lov_name=>'P207_CREATE_TEMPLATE'
,p_lov_query=>'.'||wwv_flow_imp.id(41876318884405056)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475240
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108721772809987834)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Universal Theme'
,p_lov_return_value=>'UNIVERSAL_THEME'
,p_lov_disp_cond_type=>'NOT_EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_themes',
' where theme_internal_name = ''UNIVERSAL_THEME''',
'   and flow_id             = :fb_flow_id',
'   and security_group_id   = :workspace_id'))
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1215440504952239567)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'As a copy from another theme'
,p_lov_return_value=>'COPY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(59285019370204245)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'From Scratch'
,p_lov_return_value=>'NEW_THEME'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(245682104880497308)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'From Export'
,p_lov_return_value=>'IMPORT_THEME'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p2222_list_entries_start_with
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(63393015128868636)
,p_lov_name=>'P2222 LIST ENTRIES START WITH'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select lpad('' '',4*(level-1),''.'')|| wwv_flow_escape.html(list_item_link_text) list_item_link_text, id',
'from wwv_flow_list_items i',
'where flow_id = :FB_FLOW_ID',
' and security_group_id = :WORKSPACE_ID',
' and list_id = :P2222_LIST_ID',
'start with parent_list_item_id is null       ',
'connect by prior id = parent_list_item_id ',
'        and prior list_id = list_id',
'order siblings by list_item_display_sequence'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475240
);
end;
/
prompt --application/shared_components/user_interface/lovs/p230_page_process_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(360899411445143497)
,p_lov_name=>'P230_PAGE_PROCESS_TYPES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(d)||',
'       case when is_supported = ''N'' then '' '' || wwv_flow_lang.system_message(''BUILDER.UNSUPPORTED_COMPONENT'') end d,',
'       r',
'  from ( select display_name     as d,',
'                name_with_prefix as r,',
'                ''Y''              as is_supported,',
'                case name',
'                  when ''PLSQL''               then ''process_plsql_xl''',
'                  when ''SEND_EMAIL''          then ''process_send_email''',
'                  when ''CLOSE_WINDOW''        then ''close_popup''',
'                  when ''SESSION_STATE''       then ''process_cache_management_xl''',
'                  when ''USER_PREFERENCES''    then ''process_cache_management_xl''',
'                  when ''RESET_PAGINATION''    then ''process_report_pagination_xl''',
'                  else                            ''process_plugins_xl''',
'                end||''.gif'' as icon',
'           from wwv_flow_native_plugins',
'          where plugin_type = ''PROCESS TYPE''',
'            and name in (''PLSQL'', ''CLOSE_WINDOW'', ''RESET_PAGINATION'', ''SEND_EMAIL'', ''SESSION_STATE'', ''USER_PREFERENCES'')',
'          union all',
'         select wwv_flow_lang.system_message(''BUILDER.PLUGINS'') as d,',
'                ''PLUGINS'' as r,',
'                ''Y''       as is_supported,',
'                ''process_plugins_xl.gif'' as icon',
'           from dual',
'          union all',
'         select wwv_flow_lang.system_message(''Data Manipulation'') as d,',
'                ''DATA_MANIPULATION'' as r,',
'                ''Y''       as is_supported,',
'                ''process_data_manipulation_xl.gif'' as icon',
'           from dual',
'          union all',
'         select wwv_flow_lang.system_message(''Web Services'') as d,',
'                ''WEB_SERVICES'' as r,',
'                ''Y''       as is_supported,',
'                ''process_webservice_xl.gif'' as icon',
'           from dual',
'          union all',
'         select wwv_flow_lang.system_message(''Form Pagination'') as d,',
'                ''FORM_PAGINATION'' as r,',
'                ''Y''       as is_supported,',
'                ''process_form_pagination_xl.gif'' as icon',
'           from dual',
'          order by 3 desc, d',
'       )',
' where :P366_SHOW_UNSUPPORTED = ''Y''',
'    or is_supported = ''Y''',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475240
);
end;
/
prompt --application/shared_components/user_interface/lovs/p230_tabular_form_process_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(361313530258501558)
,p_lov_name=>'P230_TABULAR_FORM_PROCESS_TYPES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(d)||',
'       case when is_supported = ''N'' then '' '' || wwv_flow_lang.system_message(''BUILDER.UNSUPPORTED_COMPONENT'') end ||',
'       ''<br /><a href="javascript:$s(''''P230_PAGE_PROCESS_TYPE'''',''||',
'       wwv_flow_escape.js_literal(r)||',
'       '');apex.submit(''''NEXT'''');"><img src="#IMAGE_PREFIX#htmldb/builder/''||icon|| ''" height="90" width="140" alt="''||',
'       wwv_flow_escape.html(d)||''" class="htmldbGreenIcons" /></a>'' d,',
'       r',
'  from ( select display_name     as d,',
'                name_with_prefix as r,',
'                ''Y''              as is_supported,',
'                case name',
'                  when ''SEND_EMAIL''          then ''process_send_email''',
'                  when ''PLSQL''               then ''process_plsql_xl''',
'                  when ''CLOSE_WINDOW''        then ''close_popup''',
'                  when ''SESSION_STATE''       then ''process_cache_management_xl''',
'                  else                            ''process_plugins_xl''',
'                end||''.gif'' as icon',
'           from wwv_flow_native_plugins',
'          where plugin_type = ''PROCESS TYPE''',
'            and name        in (''SEND_MAIL'', ''PLSQL'', ''PAGINATION'', ''DATA_MANIPULATION'', ''WEB_SERVICES'')',
'          union all',
'         select wwv_flow_lang.system_message(''RESET_PAGINATION'') as d,',
'                ''PAGINATION'' as r,',
'                ''Y''       as is_supported,',
'                ''process_report_pagination_xl.gif'' as icon',
'           from dual',
'          union all',
'         select wwv_flow_lang.system_message(''BUILDER.PLUGINS'') as d,',
'                ''PLUGINS'' as r,',
'                ''Y''       as is_supported,',
'                ''process_plugins_xl.gif'' as icon',
'           from dual',
'          union all',
'         select wwv_flow_lang.system_message(''Data Manipulation'') as d,',
'                ''DATA_MANIPULATION'' as r,',
'                ''Y''       as is_supported,',
'                ''process_data_manipulation_xl.gif'' as icon',
'           from dual',
'          union all',
'         select wwv_flow_lang.system_message(''Web Services'') as d,',
'                ''WEB_SERVICES'' as r,',
'                ''Y''       as is_supported,',
'                ''process_webservice_xl.gif'' as icon',
'           from dual',
'          order by 3 desc, d',
'       )',
' where :P366_SHOW_UNSUPPORTED = ''Y''',
'    or is_supported = ''Y''',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475242
);
end;
/
prompt --application/shared_components/user_interface/lovs/p248_page_item_level
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(10095011768327386)
,p_lov_name=>'P248_PAGE_ITEM_LEVEL'
,p_lov_query=>'.'||wwv_flow_imp.id(10095011768327386)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475242
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(10095312279327391)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Page Item'
,p_lov_return_value=>'ITEM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(179919107133518638)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Page'
,p_lov_return_value=>'PAGE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p248_tabular_form_level
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(7865801174075257)
,p_lov_name=>'P248_TABULAR_FORM_LEVEL'
,p_lov_query=>'.'||wwv_flow_imp.id(7865801174075257)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475244
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7866117948075285)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Column'
,p_lov_return_value=>'COLUMN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7866503344075287)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Tabular Form Row'
,p_lov_return_value=>'ROW'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p2515_table_name
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(4000262682894835)
,p_lov_name=>'P2515_TABLE_NAME'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if nvl(:P2515_SHOW_RELATED_TABLES,''N'') = ''N'' then',
'    return q''[select object_name_esc d,',
'           object_name r',
'      from wwv_flow_tables_views_dev',
'     where owner                               = :P2515_TABLE_OWNER',
'     order by 1]'';',
'else',
'    return q''[select detail_table_name d,',
'           detail_table_name r',
'      from wwv_flow_detail_tables_dev',
'     where master_owner               = :P2501_TABLE_OWNER',
'       and detail_owner               = :P2515_TABLE_OWNER',
'       and master_table_name          = :P2501_TABLE_NAME',
'       and :P2515_SHOW_RELATED_TABLES = ''Y''',
'    order by 1]''; ',
'end if;'))
,p_source_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'R'
,p_display_column_name=>'D'
,p_group_sort_direction=>'ASC'
,p_default_sort_direction=>'ASC'
,p_version_scn=>72475244
);
end;
/
prompt --application/shared_components/user_interface/lovs/p2518_detail_tables
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(5601180382505615)
,p_lov_name=>'P2518_DETAIL_TABLES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select child_table',
'  from wwv_dictionary_cache_fkcon c',
' where c.parent_table      = :P2518_MASTER_TABLE',
'   and c.parent_owner      = :P2518_TABLE_OWNER',
'   and c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and c.child_owner       in ( select schema from wwv_flow_company_schemas where security_group_id = :FLOW_SECURITY_GROUP_ID )'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_return_column_name=>'CHILD_TABLE'
,p_display_column_name=>'CHILD_TABLE'
,p_default_sort_column_name=>'CHILD_TABLE'
,p_default_sort_direction=>'ASC'
,p_version_scn=>72475244
);
end;
/
prompt --application/shared_components/user_interface/lovs/p260_report_view_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(229358215992778552)
,p_lov_name=>'P260.REPORT.VIEW.OPTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(229358215992778552)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475244
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(229358405044778555)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Detailed View'
,p_lov_return_value=>'2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(229358605815778557)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Summary View'
,p_lov_return_value=>'1'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p294_validation_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(194217322088478746)
,p_lov_name=>'P294 VALIDATION TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(194217322088478746)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475244
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(194217509741478748)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Function Returning Boolean'
,p_lov_return_value=>'FUNC_BODY_RETURNING_BOOLEAN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(194217703862478748)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'NOT Exists'
,p_lov_return_value=>'NOT_EXISTS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(194217926009478748)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Exists'
,p_lov_return_value=>'EXISTS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p3114_search_config_columns
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2944019087991689)
,p_lov_name=>'P3114.SEARCH_CONFIG.COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 column_display,',
'       case when :P3111_SEARCH_TYPE = ''APEX_LIST'' then',
'           to_char( seq_id ) ',
'       else',
'           c002',
'       end column_return,',
'      seq_id column_id',
' from wwv_flow_collections',
'where collection_name = ''APEX$SEARCH_CONFIG_COLUMNS'''))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'COLUMN_RETURN'
,p_display_column_name=>'COLUMN_DISPLAY'
,p_group_sort_direction=>'ASC'
,p_default_sort_column_name=>'COLUMN_ID'
,p_default_sort_direction=>'ASC'
,p_version_scn=>72475244
);
end;
/
prompt --application/shared_components/user_interface/lovs/p3120_search_config_blob_columns
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2367652410086404)
,p_lov_name=>'P3120.SEARCH_CONFIG.BLOB_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 column_display,',
'       case when :P3120_SEARCH_TYPE = ''APEX_LIST'' then',
'           to_char( seq_id ) ',
'       else',
'           c002',
'       end column_return,',
'      seq_id column_id',
' from wwv_flow_collections',
'where collection_name = ''APEX$SEARCH_CONFIG_COLUMNS''',
'  and c003            = ''BLOB'''))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'COLUMN_RETURN'
,p_display_column_name=>'COLUMN_DISPLAY'
,p_group_sort_direction=>'ASC_NULLS_FIRST'
,p_default_sort_column_name=>'COLUMN_ID'
,p_default_sort_direction=>'ASC'
,p_version_scn=>72475244
);
end;
/
prompt --application/shared_components/user_interface/lovs/p3120_search_config_columns
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2995224573020586)
,p_lov_name=>'P3120.SEARCH_CONFIG.COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 column_display,',
'       case when :P3120_SEARCH_TYPE = ''APEX_LIST'' then',
'           to_char( seq_id ) ',
'       else',
'           c002',
'       end column_return,',
'      seq_id column_id',
' from wwv_flow_collections',
'where collection_name = ''APEX$SEARCH_CONFIG_COLUMNS''',
'  and c003           != ''BLOB'''))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'COLUMN_RETURN'
,p_display_column_name=>'COLUMN_DISPLAY'
,p_group_sort_direction=>'ASC'
,p_default_sort_column_name=>'COLUMN_ID'
,p_default_sort_direction=>'ASC'
,p_version_scn=>72475244
);
end;
/
prompt --application/shared_components/user_interface/lovs/p341_tabs
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(158428705418480516)
,p_lov_name=>'P341_TABS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(TAB_NAME),tab_name',
'from   wwv_flow_tabs',
'where  flow_id = :fb_flow_id and',
'       security_group_id = :flow_security_group_id and',
'       tab_set = :F4000_P33_TAB_SET'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475244
);
end;
/
prompt --application/shared_components/user_interface/lovs/p356_avail_cols
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(153676505798953184)
,p_lov_name=>'P356_AVAIL_COLS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev a',
' where owner      = :P356_OWNER',
'   and table_name = :P356_Q_T1',
'   and not exists (select null from wwv_flow_collections',
'                              where collection_name = ''COLUMNS''',
'                                and c002 = a.table_name',
'                                and c003 = a.column_name )',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475244
);
end;
/
prompt --application/shared_components/user_interface/lovs/p356_selected_cols
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(153677215841956147)
,p_lov_name=>'P356_SELECTED_COLS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c002)||''.''||wwv_flow_escape.html(c003) d, seq_id v ',
'  from wwv_flow_collections',
' where collection_name = ''COLUMNS''',
'order by seq_id'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475244
);
end;
/
prompt --application/shared_components/user_interface/lovs/p36_breadcrumb_start_with
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(32867404643224989)
,p_lov_name=>'P36 BREADCRUMB START WITH'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'SELECT rpad('' '',(level-1)*3,''...................................'')||'' ''||wwv_flow_escape.html(short_name) sn,',
'       id',
'FROM wwv_flow_menu_options',
'WHERE flow_id = :fb_flow_id and ',
'      menu_id = :P36_MENU_ID',
'START WITH NVL(parent_id,0) = 0',
'CONNECT BY PRIOR id = parent_id',
'ORDER siblings BY short_name, OPTION_SEQUENCE'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475244
);
end;
/
prompt --application/shared_components/user_interface/lovs/p361_data_manipulation_process_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(8375625955210867)
,p_lov_name=>'P361_DATA_MANIPULATION_PROCESS_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(8375625955210867)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475244
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(8375916603210869)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Automated Row Fetch'
,p_lov_return_value=>'DML_FETCH_ROW'
,p_lov_disp_cond_type=>'ITEM_IS_NULL'
,p_lov_disp_cond=>'P230_REGION_ID'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(8376104476210869)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Automatic Row Processing  (DML)'
,p_lov_return_value=>'DML_PROCESS_ROW'
,p_lov_disp_cond_type=>'ITEM_IS_NULL'
,p_lov_disp_cond=>'P230_REGION_ID'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(8376321824210870)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Multi Row Update'
,p_lov_return_value=>'MULTI_ROW_UPDATE'
,p_lov_disp_cond_type=>'ITEM_IS_NOT_NULL'
,p_lov_disp_cond=>'P230_REGION_ID'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(31591023007278924)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Multi Row Delete'
,p_lov_return_value=>'MULTI_ROW_DELETE'
,p_lov_disp_cond_type=>'ITEM_IS_NOT_NULL'
,p_lov_disp_cond=>'P230_REGION_ID'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(55950301751165195)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Add rows to tabular form'
,p_lov_return_value=>'ADD_ROWS_TO_TABULAR_FORM'
,p_lov_disp_cond_type=>'ITEM_IS_NOT_NULL'
,p_lov_disp_cond=>'P230_REGION_ID'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p374_grid_columns
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(219858620208528757)
,p_lov_name=>'P374.GRID_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
' select level as d, level as r',
'   from sys.dual',
'connect by level <= :P374_GRID_MAX_COLUMNS'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475246
);
end;
/
prompt --application/shared_components/user_interface/lovs/p374_parent_regions
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(171212231306813752)
,p_lov_name=>'P374_PARENT_REGIONS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select plug_name || '' ('' || plug_display_sequence || '')'' as plug_name,',
'       id',
'  from wwv_flow_page_plugs p',
' where flow_id = :FB_FLOW_ID',
'   and page_id = :FB_FLOW_PAGE_ID',
'   and id not in ( select id /* not the current region and its sub regions */',
'                     from wwv_flow_page_plugs',
'                    start with id = :P374_ID',
'                   connect by prior id = parent_plug_id )',
' order by plug_name'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475246
);
end;
/
prompt --application/shared_components/user_interface/lovs/p375_tabs
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(162120332451402350)
,p_lov_name=>'P375_TABS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(TAB_NAME),tab_name',
'from   wwv_flow_tabs',
'where  flow_id = :fb_flow_id and',
'       security_group_id = :flow_security_group_id and',
'       tab_set = :F4000_P4710_TAB_SET'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475246
);
end;
/
prompt --application/shared_components/user_interface/lovs/p376_new_chart
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(41719408402645098)
,p_lov_name=>'P376_NEW_CHART'
,p_lov_query=>'.'||wwv_flow_imp.id(41719408402645098)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475246
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(41719727700645195)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Bar (HTML)'
,p_lov_return_value=>'SIMPLE_CHART'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(41719919282645197)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Bar, Horizontal'
,p_lov_return_value=>'HBAR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(41720106551645197)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Bar, Vertical'
,p_lov_return_value=>'VBAR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(41720312256645197)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Cluster Bar, Horizontal'
,p_lov_return_value=>'HCLUSTER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(41720527382645197)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Cluster Bar, Vertical'
,p_lov_return_value=>'CLUSTER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(41720723957645198)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Dial'
,p_lov_return_value=>'DIAL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(41720918900645198)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Dial - Sweep'
,p_lov_return_value=>'DIALSWEEP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(41721102267645198)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Line'
,p_lov_return_value=>'LINE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(41721323279645198)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Pie'
,p_lov_return_value=>'PIE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(41721519830645199)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Stacked Bar, Horizontal'
,p_lov_return_value=>'HSTACKED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(41721717772645206)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Stacked Bar, Vertical'
,p_lov_return_value=>'STACKED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(41721904067645206)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'Stacked Percentage Bar, Horizontal'
,p_lov_return_value=>'HSTACKED_PCT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(41722123718645206)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>'Stacked Percentage Bar, Vertical'
,p_lov_return_value=>'STACKED_PCT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p392_create_nav_bar_entry_type_selector
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(196955313648664768)
,p_lov_name=>'P392 CREATE NAV BAR ENTRY TYPE SELECTOR'
,p_lov_query=>'.'||wwv_flow_imp.id(196955313648664768)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475246
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(196955502204664773)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Navigation to URL'
,p_lov_return_value=>'URL'
,p_lov_template=>'#DISPLAY_VALUE#|native-url'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(196955720823664774)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Feedback'
,p_lov_return_value=>'FEEDBACK'
,p_lov_template=>'#DISPLAY_VALUE#| icon-page-feedback'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p399_cols_avail
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(153085921741582798)
,p_lov_name=>'P399_COLS_AVAIL'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev a',
' where owner      = :P399_OWNER',
'   and table_name = :P399_Q_T1',
'   and not exists (select null from wwv_flow_collections',
'                    where collection_name = ''COLUMNS''',
'                      and c002 = a.table_name',
'                      and c003 = a.column_name )',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475246
);
end;
/
prompt --application/shared_components/user_interface/lovs/p399_cols_selected
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(153086529706585093)
,p_lov_name=>'P399_COLS_SELECTED'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c002)||''.''||wwv_flow_escape.html(c003) d, seq_id v ',
'  from wwv_flow_collections',
' where collection_name = ''COLUMNS''',
'order by seq_id'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475246
);
end;
/
prompt --application/shared_components/user_interface/lovs/p4015_listallitems
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(22161709183858677)
,p_lov_name=>'P4015_LISTALLITEMS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select initcap(wwv_flow_lang.system_message(''APPLICATION''))||',
''': ''||name a, name b ',
'  from wwv_flow_items',
' where flow_id = :FB_FLOW_ID',
'   and :F4000_P4026_IS = ''FLOW_ITEM''',
' union all',
'select initcap(wwv_flow_lang.system_message(''PAGE''))||',
''': ''||flow_step_id||'': ''||name a, name b',
'  from wwv_flow_step_items',
' where flow_id = :FB_FLOW_ID',
'   and :F4000_P4026_IS != ''FLOW_ITEM''',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475246
);
end;
/
prompt --application/shared_components/user_interface/lovs/p4017_varchar_cols
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(123878420043886379)
,p_lov_name=>'P4017_VARCHAR_COLS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c003) d, seq_id v from wwv_flow_collections',
' where collection_name = ''REGION_QUERY_COLL''',
'order by seq_id',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475246
);
end;
/
prompt --application/shared_components/user_interface/lovs/p424_column_list
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(21951418381350663)
,p_lov_name=>'P424_COLUMN_LIST'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'from wwv_flow_table_columns_dev',
'where  owner     = :p104_owner',
'  and table_name = :p106_table '))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475246
);
end;
/
prompt --application/shared_components/user_interface/lovs/p424_date_column_list
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(799718429786902737)
,p_lov_name=>'P424_DATE_COLUMN_LIST'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'from wwv_flow_table_columns_dev',
'where  owner     = :p104_owner',
'  and table_name = :p106_table ',
'  and (data_type = ( ''DATE'')',
'       or data_type like  (''TIMESTAMP%''))'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475246
);
end;
/
prompt --application/shared_components/user_interface/lovs/p424_numeric_column_list
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(21951700504354877)
,p_lov_name=>'P424_NUMERIC_COLUMN_LIST'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'from wwv_flow_table_columns_dev',
'where  owner     = :p104_owner',
'  and table_name = :p106_table ',
'  and data_type in ( ''NUMBER'' , ''FLOAT'')'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475246
);
end;
/
prompt --application/shared_components/user_interface/lovs/p4311_grid_column
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(214426422068195312)
,p_lov_name=>'P4311.GRID_COLUMN'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
' select level as d, level as r',
'   from sys.dual',
'connect by level <= :P4311_GRID_MAX_COLUMNS'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475246
);
end;
/
prompt --application/shared_components/user_interface/lovs/p4311_grid_label_column_span
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1570705881299751507)
,p_lov_name=>'P4311.GRID_LABEL_COLUMN_SPAN'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
' select level-1 as d, level-1 as r',
'   from sys.dual',
'connect by level-1 < nvl( :P4311_GRID_COLUMN_SPAN, :P4311_GRID_MAX_COLUMNS )'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475246
);
end;
/
prompt --application/shared_components/user_interface/lovs/p4312_in_map_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(23490921670855286)
,p_lov_name=>'P4312_IN_MAP_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(23490921670855286)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475246
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23491218407855289)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Item'
,p_lov_return_value=>'ITEM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23491408926855290)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Static Value'
,p_lov_return_value=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(47089421019946824)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Function'
,p_lov_return_value=>'FUNCTION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p4312_out_map_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(23495520416864363)
,p_lov_name=>'P4312_OUT_MAP_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(23495520416864363)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475246
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23495831550864364)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Items'
,p_lov_return_value=>'ITEM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23496013407864364)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Collection'
,p_lov_return_value=>'COLLECTION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p4312_process_point
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(9405302986939246)
,p_lov_name=>'P4312_PROCESS_POINT'
,p_lov_query=>'.'||wwv_flow_imp.id(9405302986939246)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475246
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9405616193939261)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'On New Instance (new session)'
,p_lov_return_value=>'ON_NEW_INSTANCE'
,p_lov_disp_cond_type=>'ITEM_IS_NULL'
,p_lov_disp_cond=>'P4312_REGION_ID'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9405815372939263)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'On Load - Before Header'
,p_lov_return_value=>'BEFORE_HEADER'
,p_lov_disp_cond_type=>'ITEM_IS_NULL'
,p_lov_disp_cond=>'P4312_REGION_ID'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9406027772939263)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'On Load - After Header'
,p_lov_return_value=>'AFTER_HEADER'
,p_lov_disp_cond_type=>'ITEM_IS_NULL'
,p_lov_disp_cond=>'P4312_REGION_ID'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9406214595939263)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'On Load - Before Regions'
,p_lov_return_value=>'BEFORE_BOX_BODY'
,p_lov_disp_cond_type=>'ITEM_IS_NULL'
,p_lov_disp_cond=>'P4312_REGION_ID'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9406420830939263)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'On Load - After Regions'
,p_lov_return_value=>'AFTER_BOX_BODY'
,p_lov_disp_cond_type=>'ITEM_IS_NULL'
,p_lov_disp_cond=>'P4312_REGION_ID'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9406605804939263)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'On Load - Before Footer'
,p_lov_return_value=>'BEFORE_FOOTER'
,p_lov_disp_cond_type=>'ITEM_IS_NULL'
,p_lov_disp_cond=>'P4312_REGION_ID'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9406822975939263)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'On Load - After Footer'
,p_lov_return_value=>'AFTER_FOOTER'
,p_lov_disp_cond_type=>'ITEM_IS_NULL'
,p_lov_disp_cond=>'P4312_REGION_ID'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9407005058939263)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'On Submit - Before Computations and Validations '
,p_lov_return_value=>'ON_SUBMIT_BEFORE_COMPUTATION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9407219704939264)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'On Submit - After Computations and Validations'
,p_lov_return_value=>'AFTER_SUBMIT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9407419438939264)
,p_lov_disp_sequence=>95
,p_lov_disp_value=>'Ajax Callback - Run this process when requested by Ajax'
,p_lov_return_value=>'ON_DEMAND'
,p_lov_disp_cond_type=>'ITEM_IS_NULL'
,p_lov_disp_cond=>'P4312_REGION_ID'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9407614667939264)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'On Error - After Header'
,p_lov_return_value=>'AFTER_ERROR_HEADER'
,p_required_patch=>wwv_flow_imp.id(170786031904296885)
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9407800424939264)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'On Error - Before Footer'
,p_lov_return_value=>'BEFORE_ERROR_FOOTER'
,p_required_patch=>wwv_flow_imp.id(170786031904296885)
);
end;
/
prompt --application/shared_components/user_interface/lovs/p4312_web_operations
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(23280706593687071)
,p_lov_name=>'P4312_WEB_OPERATIONS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_ws_operations',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475246
);
end;
/
prompt --application/shared_components/user_interface/lovs/p4402_action
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1434173283114513679)
,p_lov_name=>'P4402.ACTION'
,p_lov_query=>'.'||wwv_flow_imp.id(1434173283114513679)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475246
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1434173551836514263)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'From Scratch'
,p_lov_return_value=>'CREATE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1434173808978514269)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'As a Copy of an Existing Plug-in'
,p_lov_return_value=>'COPY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p4406_copy
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1434176433131599379)
,p_lov_name=>'P4406.COPY'
,p_lov_query=>'.'||wwv_flow_imp.id(1434176433131599379)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475246
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1434176711169599381)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Yes'
,p_lov_return_value=>'Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1434177041222599383)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'No'
,p_lov_return_value=>'N'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1434177399061599383)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Copy and Subscribe'
,p_lov_return_value=>'SUBSCRIBE'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':P4404_COPY_FROM <> :FB_FLOW_ID and :P4404_COPY_FROM_THEME_ID is null'
,p_lov_disp_cond2=>'PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p4495_invalid_session_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(364180307858056288)
,p_lov_name=>'P4495_INVALID_SESSION_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(364180307858056288)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475246
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(364180530446056289)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Login Page'
,p_lov_return_value=>'LOGIN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(364180725680056289)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Built-In Login Page'
,p_lov_return_value=>'BUILTIN_LOGIN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(364181121070056289)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'URL'
,p_lov_return_value=>'URL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p4495_logout_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(369466420839722403)
,p_lov_name=>'P4495_LOGOUT_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(369466420839722403)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475246
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(369466702957722404)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Home Page'
,p_lov_return_value=>'HOME'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(369467107778722404)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'URL'
,p_lov_return_value=>'URL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p462_download_option
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(403387737278446376)
,p_lov_name=>'P462_DOWNLOAD_OPTION'
,p_lov_query=>'.'||wwv_flow_imp.id(403387737278446376)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475246
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(403387926098446380)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Deinstall Script'
,p_lov_return_value=>'DEINSTALL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(403547684590197232)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Remove Application'
,p_lov_return_value=>'APP_REMOVE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p462_include_app_remove
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(403388354521448419)
,p_lov_name=>'P462_INCLUDE_APP_REMOVE'
,p_lov_query=>'.'||wwv_flow_imp.id(403388354521448419)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475246
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(403388543370448419)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Include Application Remove'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p466_avail_cols
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(155828317190371371)
,p_lov_name=>'P466_AVAIL_COLS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev a',
' where owner      = :P466_OWNER',
'   and table_name = :P466_Q_T1',
'   and not exists (select null from wwv_flow_collections',
'                              where collection_name = ''COLUMNS''',
'                                and c003 = a.table_name',
'                                and c005 = a.column_name',
'                                and c006 != ''D'' )'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475247
);
end;
/
prompt --application/shared_components/user_interface/lovs/p466_selected_cols
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(155829628964374834)
,p_lov_name=>'P466_SELECTED_COLS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c003)||''.''||wwv_flow_escape.html(c005) d, seq_id v ',
'  from wwv_flow_collections',
' where collection_name = ''COLUMNS''',
'   and c006 != ''D''',
'order by seq_id'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475247
);
end;
/
prompt --application/shared_components/user_interface/lovs/p4734_process_points
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(9100501365042451)
,p_lov_name=>'P4734_PROCESS_POINTS'
,p_lov_query=>'.'||wwv_flow_imp.id(9100501365042451)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475247
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9100809612042466)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'On New Instance (new session)'
,p_lov_return_value=>'ON_NEW_INSTANCE'
,p_lov_disp_cond_type=>'ITEM_IS_NULL'
,p_lov_disp_cond=>'P230_REGION_ID'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9101011884042466)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'On Load - Before Header'
,p_lov_return_value=>'BEFORE_HEADER'
,p_lov_disp_cond_type=>'ITEM_IS_NULL'
,p_lov_disp_cond=>'P230_REGION_ID'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9101200813042466)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'On Load - After Header'
,p_lov_return_value=>'AFTER_HEADER'
,p_lov_disp_cond_type=>'ITEM_IS_NULL'
,p_lov_disp_cond=>'P230_REGION_ID'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9101425102042466)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'On Load - Before Regions'
,p_lov_return_value=>'BEFORE_BOX_BODY'
,p_lov_disp_cond_type=>'ITEM_IS_NULL'
,p_lov_disp_cond=>'P230_REGION_ID'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9101620856042466)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'On Load - After Regions'
,p_lov_return_value=>'AFTER_BOX_BODY'
,p_lov_disp_cond_type=>'ITEM_IS_NULL'
,p_lov_disp_cond=>'P230_REGION_ID'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9101828034042466)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'On Load - Before Footer'
,p_lov_return_value=>'BEFORE_FOOTER'
,p_lov_disp_cond_type=>'ITEM_IS_NULL'
,p_lov_disp_cond=>'P230_REGION_ID'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9102024546042467)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'On Load - After Footer'
,p_lov_return_value=>'AFTER_FOOTER'
,p_lov_disp_cond_type=>'ITEM_IS_NULL'
,p_lov_disp_cond=>'P230_REGION_ID'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9102223263042467)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'On Submit - Before Computations and Validations '
,p_lov_return_value=>'ON_SUBMIT_BEFORE_COMPUTATION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9102400883042467)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'On Submit - After Computations and Validations'
,p_lov_return_value=>'AFTER_SUBMIT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9102608720042467)
,p_lov_disp_sequence=>95
,p_lov_disp_value=>'Ajax Callback - Run this process when requested by Ajax'
,p_lov_return_value=>'ON_DEMAND'
,p_lov_disp_cond_type=>'ITEM_IS_NULL'
,p_lov_disp_cond=>'P230_REGION_ID'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9102821905042467)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'On Error - After Header'
,p_lov_return_value=>'AFTER_ERROR_HEADER'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9103006400042467)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'On Error - Before Footer'
,p_lov_return_value=>'BEFORE_ERROR_FOOTER'
,p_lov_disp_cond_type=>'NEVER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p4780_chart_scale
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(162187100656572875)
,p_lov_name=>'P4780_CHART_SCALE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 400 d, 400 r from dual ',
'union ',
'select 200 d, 200 r from dual ',
'union ',
'select 600 d, 600 r from dual',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475247
);
end;
/
prompt --application/shared_components/user_interface/lovs/p4795_columns
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1273317695384915524)
,p_lov_name=>'P4795_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P4795_TABLE_OWNER',
'   and table_name = :P4795_TABLE_NAME'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475247
);
end;
/
prompt --application/shared_components/user_interface/lovs/p4795_table_views
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(201375931366550586)
,p_lov_name=>'P4795_TABLE_VIEWS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = :P4795_TABLE_OWNER'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475247
);
end;
/
prompt --application/shared_components/user_interface/lovs/p4796_varchar_cols
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(109940315866524802)
,p_lov_name=>'P4796_VARCHAR_COLS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c003) d, wwv_flow_escape.html(c003) v from wwv_flow_collections',
' where collection_name = ''LOV_COLL''',
'order by seq_id',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475247
);
end;
/
prompt --application/shared_components/user_interface/lovs/p494_summary_col1
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(150739316469381909)
,p_lov_name=>'P494_SUMMARY_COL1'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c001) a, c001 b                ',
'from wwv_flow_collections ',
'where collection_name=''EXCEL_IMPORT''',
'and c004 = ''Y''',
'and c002 != ''CLOB''',
'order by seq_id'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475247
);
end;
/
prompt --application/shared_components/user_interface/lovs/p494_summary_col2
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(150742225173412831)
,p_lov_name=>'P494_SUMMARY_COL2'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c001) a, c001 b                ',
'from wwv_flow_collections ',
'where collection_name=''CSV_IMPORT''',
'and c004 = ''Y''',
'and c002 != ''CLOB''',
'order by seq_id'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475247
);
end;
/
prompt --application/shared_components/user_interface/lovs/p495_agg_col1
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(150843204404482597)
,p_lov_name=>'P495_AGG_COL1'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c001) a, c001 b',
'from wwv_flow_collections',
'where collection_name=''EXCEL_IMPORT''',
'and c004 = ''Y''',
'and c002 = ''NUMBER'''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475247
);
end;
/
prompt --application/shared_components/user_interface/lovs/p495_agg_col2
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(150845803496491785)
,p_lov_name=>'P495_AGG_COL2'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c001) a, c001 b',
'from wwv_flow_collections',
'where collection_name=''CSV_IMPORT''',
'and c004 = ''Y''',
'and c002 = ''NUMBER'''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475247
);
end;
/
prompt --application/shared_components/user_interface/lovs/p560_case_sensitive
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(13359205666146756)
,p_lov_name=>'P560_CASE_SENSITIVE'
,p_lov_query=>'.'||wwv_flow_imp.id(13359205666146756)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475247
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(13359510355146757)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'case sensitive'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p560_exact_match
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(13356927698143693)
,p_lov_name=>'P560_EXACT_MATCH'
,p_lov_query=>'.'||wwv_flow_imp.id(13356927698143693)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475247
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(13357217040143696)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'exact match'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p560_search_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(39290016198591148)
,p_lov_name=>'P560_SEARCH_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(39290016198591148)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475247
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(39290330944591151)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Business Name'
,p_lov_return_value=>'BUS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(39290532350591153)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Service Name'
,p_lov_return_value=>'SERV'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p600_service_operations
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(15589721785727739)
,p_lov_name=>'P600_SERVICE_OPERATIONS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'  from wwv_flow_ws_operations',
' where name != ''BASIC_AUTH''',
'   and ws_id = :P600_WS_ID'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475247
);
end;
/
prompt --application/shared_components/user_interface/lovs/p600_web_ref_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(191288700473281420)
,p_lov_name=>'P600_WEB_REF_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(191288700473281420)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475247
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(191288912474281428)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Manual'
,p_lov_return_value=>'MANUAL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(191289104429281431)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Based on a WSDL'
,p_lov_return_value=>'NEW_SCHOOL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(191289332191281431)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'RESTful'
,p_lov_return_value=>'REST'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p600_web_services
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(15587132043721216)
,p_lov_name=>'P600_WEB_SERVICES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'  from wwv_flow_shared_web_services',
' where flow_id = :FB_FLOW_ID',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475247
);
end;
/
prompt --application/shared_components/user_interface/lovs/p675_affected_elements_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(623954005465160350)
,p_lov_name=>'P675_AFFECTED_ELEMENTS_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(623954005465160350)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475247
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(623954804586160353)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Item(s)'
,p_lov_return_value=>'ITEM'
,p_lov_disp_cond_type=>'FUNCTION_BODY'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_plugin_dev.has_affected_element_type (',
'           p_application_id => :FB_FLOW_ID,',
'           p_true_action    => :P653_TRUE_ACTION,',
'           p_false_action   => :P198_FALSE_ACTION,',
'           p_type           => ''ITEM'' );'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(206240722890573621)
,p_lov_disp_sequence=>1.5
,p_lov_disp_value=>'Button'
,p_lov_return_value=>'BUTTON'
,p_lov_disp_cond_type=>'FUNCTION_BODY'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_plugin_dev.has_affected_element_type (',
'            p_application_id => :FB_FLOW_ID,',
'            p_true_action    => :P653_TRUE_ACTION,',
'            p_false_action   => :P198_FALSE_ACTION,',
'            p_type           => ''BUTTON'' );'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(623955231150160353)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Region'
,p_lov_return_value=>'REGION'
,p_lov_disp_cond_type=>'FUNCTION_BODY'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_plugin_dev.has_affected_element_type (',
'            p_application_id => :FB_FLOW_ID,',
'            p_true_action    => :P653_TRUE_ACTION,',
'            p_false_action   => :P198_FALSE_ACTION,',
'            p_type           => ''REGION'' );'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(623954201427160352)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Column'
,p_lov_return_value=>'COLUMN'
,p_lov_disp_cond_type=>'FUNCTION_BODY'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_plugin_dev.has_affected_element_type (',
'           p_application_id => :FB_FLOW_ID,',
'           p_true_action    => :P653_TRUE_ACTION,',
'           p_false_action   => :P198_FALSE_ACTION,',
'           p_type           => ''COLUMN'' );'))
,p_lov_disp_cond2=>'PLSQL'
,p_required_patch=>wwv_flow_imp.id(170786031904296885)
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(623955012034160353)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'jQuery Selector'
,p_lov_return_value=>'JQUERY_SELECTOR'
,p_lov_disp_cond_type=>'FUNCTION_BODY'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_plugin_dev.has_affected_element_type (',
'           p_application_id => :FB_FLOW_ID,',
'           p_true_action    => :P653_TRUE_ACTION,',
'           p_false_action   => :P198_FALSE_ACTION,',
'           p_type           => ''JQUERY_SELECTOR'' );'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(855877380156007050)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'JavaScript Expression'
,p_lov_return_value=>'JAVASCRIPT_EXPRESSION'
,p_lov_disp_cond_type=>'FUNCTION_BODY'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_plugin_dev.has_affected_element_type (',
'           p_application_id => :FB_FLOW_ID,',
'           p_true_action    => :P653_TRUE_ACTION,',
'           p_false_action   => :P198_FALSE_ACTION,',
'           p_type           => ''JAVASCRIPT_EXPRESSION'' );'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(623955413415160353)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Triggering Element'
,p_lov_return_value=>'TRIGGERING_ELEMENT'
,p_lov_disp_cond_type=>'FUNCTION_BODY'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_plugin_dev.has_affected_element_type (',
'           p_application_id => :FB_FLOW_ID,',
'           p_true_action    => :P653_TRUE_ACTION,',
'           p_false_action   => :P198_FALSE_ACTION,',
'           p_type           => ''TRIGGERING_ELEMENT'' );'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(623954631117160352)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Event Source'
,p_lov_return_value=>'EVENT_SOURCE'
,p_lov_disp_cond_type=>'FUNCTION_BODY'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_plugin_dev.has_affected_element_type (',
'           p_application_id => :FB_FLOW_ID,',
'           p_true_action    => :P653_TRUE_ACTION,',
'           p_false_action   => :P198_FALSE_ACTION,',
'           p_type           => ''EVENT_SOURCE'' );'))
,p_lov_disp_cond2=>'PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p700_service_operations
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(30137708159892825)
,p_lov_name=>'P700_SERVICE_OPERATIONS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'  from wwv_flow_ws_operations',
' where name != ''BASIC_AUTH''',
'   and ws_id = :P700_WS_ID'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475248
);
end;
/
prompt --application/shared_components/user_interface/lovs/p7020_copy_source
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(601116568254832030)
,p_lov_name=>'P7020_COPY_SOURCE'
,p_lov_query=>'.'||wwv_flow_imp.id(601116568254832030)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475248
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601116766374832030)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'This Application'
,p_lov_return_value=>'THIS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601117120524832032)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Other Application'
,p_lov_return_value=>'OTHER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p7021_columns
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(4100219380261370)
,p_lov_name=>'P7021_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P7021_TABLE_OWNER',
'   and table_name = :P7021_TABLE_NAME',
'   and :P7021_TABLE_NAME is not null',
'   and :P7021_REPORT_SOURCE_TYPE = ''TABLE'''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475248
);
end;
/
prompt --application/shared_components/user_interface/lovs/p7021_commit_each_row
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(601100928341755832)
,p_lov_name=>'P7021_COMMIT_EACH_ROW'
,p_lov_query=>'.'||wwv_flow_imp.id(601100928341755832)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475248
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601101161297755832)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Once'
,p_lov_return_value=>'N'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601101578470755833)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Each Row'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p7021_error_handling_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(601102221885756461)
,p_lov_name=>'P7021_ERROR_HANDLING_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(601102221885756461)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475248
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601102495495756461)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Ignore'
,p_lov_return_value=>'IGNORE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601102885695756461)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Terminate Automation'
,p_lov_return_value=>'ABORT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601103294616756461)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Disable Automation'
,p_lov_return_value=>'DISABLE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p7021_source_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(601093532765741216)
,p_lov_name=>'P7021_SOURCE_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(601093532765741216)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475248
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601093732932741217)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Query'
,p_lov_return_value=>'QUERY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601094151666741217)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Function Body Returning Boolean'
,p_lov_return_value=>'FUNC_BODY_RETURNING_BOOLEAN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601094507652741219)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Always'
,p_lov_return_value=>'ALWAYS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p7021_table_views
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(3504279958146176)
,p_lov_name=>'P7021_TABLE_VIEWS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = coalesce( :P7021_TABLE_OWNER, wwv_flow_security.flow_owner( p_flow_id => :FB_FLOW_ID, p_security_group_id => :WORKSPACE_ID ) )',
''))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'OBJECT_NAME'
,p_display_column_name=>'OBJECT_NAME_ESC'
,p_group_sort_direction=>'ASC'
,p_default_sort_column_name=>'OBJECT_NAME_ESC'
,p_default_sort_direction=>'ASC'
,p_version_scn=>72475248
);
end;
/
prompt --application/shared_components/user_interface/lovs/p7025_status_lov
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2000855720872191)
,p_lov_name=>'P7025_STATUS_LOV'
,p_lov_query=>'.'||wwv_flow_imp.id(2000855720872191)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475248
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2001129595872205)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Running'
,p_lov_return_value=>'RUNNING'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2001536872872206)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Success'
,p_lov_return_value=>'SUCCESS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2001964408872206)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'No Action'
,p_lov_return_value=>'NO_ACTION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2002386953872206)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Incomplete'
,p_lov_return_value=>'INCOMPLETE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2002788561872207)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Failure'
,p_lov_return_value=>'FAILURE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2003180778872207)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Terminated'
,p_lov_return_value=>'ABORTED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2003513333872207)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Job Already Running'
,p_lov_return_value=>'JOB_ALREADY_RUNNING'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p7026_msg_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(4601034447346038)
,p_lov_name=>'P7026_MSG_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(4601034447346038)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475248
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4601315751346042)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Information'
,p_lov_return_value=>'I'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4601704640346043)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Warning'
,p_lov_return_value=>'W'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4602167309346043)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Error'
,p_lov_return_value=>'E'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p7030_polling_interval_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(601120036396834677)
,p_lov_name=>'P7030_POLLING_INTERVAL_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(601120036396834677)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475248
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601120223229834677)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Daily'
,p_lov_return_value=>'DAILY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601120623881834677)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Hourly'
,p_lov_return_value=>'HOURLY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601121042951834677)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Minutely'
,p_lov_return_value=>'MINUTELY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p7030_polling_predefined
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(601117964216834048)
,p_lov_name=>'P7030_POLLING_PREDEFINED'
,p_lov_query=>'.'||wwv_flow_imp.id(601117964216834048)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475248
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601118147447834048)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Every 15 Minutes'
,p_lov_return_value=>'15M'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601118543260834048)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'On the Hour'
,p_lov_return_value=>'T1H'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601118986022834048)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Daily at Midnight'
,p_lov_return_value=>'MIDNIGHT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601119395266834049)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Custom'
,p_lov_return_value=>'CUSTOM'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p7030_result_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(601121722896835768)
,p_lov_name=>'P7030_RESULT_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(601121722896835768)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475248
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601121962684835769)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Query'
,p_lov_return_value=>'QUERY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601122304775835769)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Always'
,p_lov_return_value=>'ALWAYS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p725_arrays
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(30163920479050503)
,p_lov_name=>'P725_ARRAYS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name)||'' (''||wwv_flow_escape.html(parm_type)||'')'' d, id r',
'  from wwv_flow_ws_parameters a',
' where type_is_xsd = ''N''',
'   and input_or_output = ''O''',
'   and exists (select 1',
'                 from wwv_flow_ws_parameters',
'                where parent_id = a.id',
'                  and type_is_xsd = ''Y'') ',
'   and ws_opers_id = :P700_OPERATION_ID'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475248
);
end;
/
prompt --application/shared_components/user_interface/lovs/p755_message_style
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(40231925790463373)
,p_lov_name=>'P755.MESSAGE.STYLE'
,p_lov_query=>'.'||wwv_flow_imp.id(40231925790463373)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475248
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(40232212679463374)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Literal'
,p_lov_return_value=>'literal'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(40232431421463374)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Encoded'
,p_lov_return_value=>'encoded'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p755_soap_style
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(40229315139441290)
,p_lov_name=>'P755.SOAP.STYLE'
,p_lov_query=>'.'||wwv_flow_imp.id(40229315139441290)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475248
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(40229627356441290)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Document'
,p_lov_return_value=>'document'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(40229803305441290)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'RPC'
,p_lov_return_value=>'rpc'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p755_webreference_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(40198901222257565)
,p_lov_name=>'P755.WEBREFERENCE.TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(40198901222257565)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475248
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(40199230524257566)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Manually Created'
,p_lov_return_value=>'775'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(40199413274257566)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Generated from WSDL'
,p_lov_return_value=>'760'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(170453128566645522)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'REST'
,p_lov_return_value=>'784'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p76_export_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2046972184417676036)
,p_lov_name=>'P76_EXPORT_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(2046972184417676036)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475248
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2046972496837676036)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Full'
,p_lov_return_value=>'FULL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2046972881111676038)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Minimal'
,p_lov_return_value=>'MIN'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p778_webref_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(114277222597792014)
,p_lov_name=>'P778_WEBREF_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(114277222597792014)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475248
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(193948926790152005)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'REST'
,p_lov_return_value=>'860'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(114277727331792020)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Generated from WSDL'
,p_lov_return_value=>'782'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(114277531767792019)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Manually Created'
,p_lov_return_value=>'783'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p779_arrays
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(114317921745905322)
,p_lov_name=>'P779_ARRAYS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name)||'' (''||wwv_flow_escape.html(parm_type)||'')'' d, id r',
'  from wwv_flow_ws_parameters a',
' where type_is_xsd = ''N''',
'   and input_or_output = ''O''',
'   and exists (select 1',
'                 from wwv_flow_ws_parameters',
'                where parent_id = a.id',
'                  and type_is_xsd = ''Y'') ',
'   and ws_opers_id = :P779_OPERATION_ID'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475248
);
end;
/
prompt --application/shared_components/user_interface/lovs/p779_operations
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(114316827501897556)
,p_lov_name=>'P779_OPERATIONS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'  from wwv_flow_ws_operations',
' where name != ''BASIC_AUTH''',
'   and ws_id = :P779_WS_ID'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475248
);
end;
/
prompt --application/shared_components/user_interface/lovs/p779_wsdl_services
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1033194508949434213)
,p_lov_name=>'P779_WSDL_SERVICES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'  from wwv_flow_shared_web_services',
' where action = ''NEW_SCHOOL''',
'   and flow_id = :FB_FLOW_ID',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475248
);
end;
/
prompt --application/shared_components/user_interface/lovs/p806_inv_session_target
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(159056930707631319)
,p_lov_name=>'P806_INV_SESSION_TARGET'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return',
'''select d,r from (',
'    select :PRODUCT_NAME||'''' ''''||',
'    wwv_flow_lang.system_message(''''F4000_P806_BUILTIN_LOGIN_PG'''') d,',
'    ''''BUILTIN'''' r, 1 ob from dual',
'    union all',
'    select wwv_flow_lang.system_message(''''F4000_P806_PAGE_IN_THIS_FLOW'''') d,',
'    ''''PAGE'''' r, 2 ob from dual',
'    union all',
'    select wwv_flow_lang.system_message(''''F4000_P806_URL'''') d,',
'    ''''URL'''' r,3 ob from dual',
'    union all',
'    select wwv_flow_lang.system_message(''''F4000_P806_SSO_SERVER'''') d,',
'    ''''-PORTAL_SSO-'''' r, 4 ob',
'    from dual',
'    union all',
'    select wwv_flow_lang.system_message(''''F4000_P806_NONE'''') d,',
'    ''''NONE'''' r, 5 ob from dual)',
'order by ob'';'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475248
);
end;
/
prompt --application/shared_components/user_interface/lovs/p808_auth_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(159070400681755094)
,p_lov_name=>'P808_AUTH_TYPE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,r from (',
'    select wwv_flow_lang.system_message(''F4000_P808_AUTH_TYPE'',',
'      :PRODUCT_NAME) d, ''BUILTIN'' r, 1 ob from dual',
'    union',
'    select wwv_flow_lang.system_message(''F4000_P808_DBAUTH_TYPE'') d, ',
'    ''DBACCOUNT'' r, 2 ob from dual',
'    union',
'    select wwv_flow_lang.system_message(''F4000_P808_NO_VERIFY_CRED'') d,',
'      ''ALLOW'' r, 3 ob from dual',
'    union',
'    select wwv_flow_lang.system_message(''F4000_P808_USE_LDAP'') d,',
'      ''LDAP'' r,4 ob from dual',
'    union',
'    select wwv_flow_lang.system_message(''F4000_P808_USE_CUSTOM'') d,',
'      ''PLUGIN'' r,5 ob from dual)',
'order by ob'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475248
);
end;
/
prompt --application/shared_components/user_interface/lovs/p856_sql_scripts
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(4671330627638944)
,p_lov_name=>'P856_SQL_SCRIPTS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select filename, id from wwv_flow_files',
' where file_type = ''SCRIPT''',
' order by filename'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475248
);
end;
/
prompt --application/shared_components/user_interface/lovs/p865_script_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(686919732026917492)
,p_lov_name=>'P865_SCRIPT_OPTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(686919732026917492)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475248
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(686920044595917503)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Only package specifications'
,p_lov_return_value=>'PACKAGE_SPEC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(686920318192917509)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Only package bodies'
,p_lov_return_value=>'PACKAGE_BODY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(686920640544917509)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Include DDL related to tables'
,p_lov_return_value=>'TABLE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p872_input_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(48714213128492554)
,p_lov_name=>'P872_INPUT_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(48714213128492554)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475248
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(48714425928492556)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Name Value Pairs'
,p_lov_return_value=>'nvp'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(48714607865492557)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Specified Body with Substitutions'
,p_lov_return_value=>'body'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(48714805586492557)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'File Upload Item'
,p_lov_return_value=>'file'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(48715023064492557)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Function Returning CLOB'
,p_lov_return_value=>'function'
);
end;
/
prompt --application/shared_components/user_interface/lovs/p892_p893_apex_view_columns
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(200660406244440996)
,p_lov_name=>'P892_P893_APEX_VIEW_COLUMNS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name d, column_name r',
'  from apex_dictionary',
' where apex_view_name = :P892_VIEW_NAME',
'   and column_id > 0',
' order by column_id'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475248
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_group_returns_name
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(576061658331941850)
,p_lov_name=>'PAGE GROUP (RETURNS NAME)'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d, group_name r ',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'order by upper(group_name)'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475248
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_groups_with_unassigned_option
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(5085026803855916)
,p_lov_name=>'PAGE GROUPS WITH UNASSIGNED OPTION'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select group_name, id',
'from wwv_flow_page_groups g',
'where flow_id = :fb_flow_id ',
'union',
'select wwv_flow_lang.system_message(''UNASSIGNED''), 111222333444 id',
'from dual',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475248
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_items_of_current_and_global_page
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(455235230206380434)
,p_lov_name=>'PAGE ITEMS OF CURRENT AND GLOBAL PAGE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name as d,',
'       name as r',
'  from (',
'select name,',
'       flow_step_id,',
'       item_sequence',
'  from wwv_flow_step_items',
' where flow_id           = :FB_FLOW_ID',
'   and flow_step_id      = :FB_FLOW_PAGE_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
' union',
'select i.name,',
'       i.flow_step_id,',
'       i.item_sequence',
'  from wwv_flow_steps p,',
'       wwv_flows f,',
'       wwv_flow_step_items i',
' where p.flow_id           = :FB_FLOW_ID',
'   and p.id                = :FB_FLOW_PAGE_ID',
'   and p.security_group_id = :WORKSPACE_ID',
'   and f.id                = p.flow_id',
'   and f.global_page_id  <> :fb_flow_page_id',
'   and i.flow_id           = f.id',
'   and i.flow_step_id      = f.global_page_id',
'   and i.security_group_id = :WORKSPACE_ID',
')',
'order by flow_step_id, item_sequence, name',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475248
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_mode_dynamic_or_static
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(26630118049466478)
,p_lov_name=>'PAGE MODE DYNAMIC OR STATIC'
,p_lov_query=>'.'||wwv_flow_imp.id(26630118049466478)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475248
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(26630403516466478)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Dynamic'
,p_lov_return_value=>'D'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(26630601816466479)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Cache Created'
,p_lov_return_value=>'C'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(26630824926466479)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Cached'
,p_lov_return_value=>'R'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(131011417048612773)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Page Processing'
,p_lov_return_value=>'A'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(116684427784528179)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Partial Page'
,p_lov_return_value=>'P'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_protection_level
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(17255429593772638)
,p_lov_name=>'PAGE PROTECTION LEVEL'
,p_lov_query=>'.'||wwv_flow_imp.id(17255429593772638)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475248
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17255616290772804)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Unrestricted'
,p_lov_return_value=>'N'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17255831690772804)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Arguments Must Have Checksum'
,p_lov_return_value=>'C'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17256023739772805)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'No Arguments Allowed'
,p_lov_return_value=>'U'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17256209897772805)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'No URL Access'
,p_lov_return_value=>'D'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_theme_class_id
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(41972431732112027)
,p_lov_name=>'PAGE THEME CLASS ID'
,p_lov_query=>'.'||wwv_flow_imp.id(41972431732112027)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475248
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(41972715993112030)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'One Level Tabs'
,p_lov_return_value=>'1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(41972909583112031)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Two Level Tabs'
,p_lov_return_value=>'2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(41973110092112031)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'No Tabs'
,p_lov_return_value=>'3'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(41973323433112031)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Popup'
,p_lov_return_value=>'4'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(41973521858112032)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Printer Friendly'
,p_lov_return_value=>'5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(41973730212112032)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Login'
,p_lov_return_value=>'6'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(49461924616084412)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'One Level Tabs with Sidebar'
,p_lov_return_value=>'16'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(49462610895089957)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'No Tabs with Sidebar'
,p_lov_return_value=>'17'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(49463017128091735)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Two Level Tabs with Sidebar'
,p_lov_return_value=>'18'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(41977231648130915)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 1'
,p_lov_return_value=>'8'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(41977703036132119)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 2'
,p_lov_return_value=>'9'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(41978112040134702)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 3'
,p_lov_return_value=>'10'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(48394414687308491)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 4'
,p_lov_return_value=>'11'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(48394916765309025)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 5'
,p_lov_return_value=>'12'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(48395619189309771)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 6'
,p_lov_return_value=>'13'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(48396021613310403)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 7'
,p_lov_return_value=>'14'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(48396424037311168)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 8'
,p_lov_return_value=>'15'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_url
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(276391518317957635)
,p_lov_name=>'PAGE URL'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||'' ''||name n, ''f?p=&''||''APP_ID.:''||id||'':&''||''SESSION.'' d',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475252
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_view_mode
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(5035605136660409)
,p_lov_name=>'PAGE VIEW MODE'
,p_lov_query=>'.'||wwv_flow_imp.id(5035605136660409)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475252
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(5035918715660410)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Icons'
,p_lov_return_value=>'ICON'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(5036125439660410)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Details'
,p_lov_return_value=>'DETAIL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_branch_points
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(179397725241870240)
,p_lov_name=>'PAGE.BRANCH.POINTS'
,p_lov_query=>'.'||wwv_flow_imp.id(179397725241870240)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475252
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(179398028859870243)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'On Submit: Before Computation (Before Computation, Validation, and Processing)'
,p_lov_return_value=>'BEFORE_COMPUTATION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(179398229442870244)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'On Submit: Before Validation: (After Computation and Before Validation and Processing)'
,p_lov_return_value=>'BEFORE_VALIDATION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(179398419489870245)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'On Submit: Before Processing: (After Computation, Validation and Before Processing)'
,p_lov_return_value=>'BEFORE_PROCESSING'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(179398614240870246)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'On Submit: After Processing (After Computation, Validation, and Processing)'
,p_lov_return_value=>'AFTER_PROCESSING'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(179398805923870247)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'On Load: Before Header'
,p_lov_return_value=>'BEFORE_HEADER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_branch_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(15652127549539076)
,p_lov_name=>'PAGE.BRANCH.TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(15652127549539076)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475254
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15652422295539123)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Branch to Page Accept Processing (not common)'
,p_lov_return_value=>'BRANCH_TO_PAGE_ACCEPT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15652604683539128)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Branch to Page'
,p_lov_return_value=>'BRANCH_TO_STEP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15652814858539128)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Branch to PL/SQL Procedure'
,p_lov_return_value=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15653010159539128)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Branch to Page or URL'
,p_lov_return_value=>'REDIRECT_URL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15653228401539129)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Branch to Page Identified by Item (Use Item Name)'
,p_lov_return_value=>'BRANCH_TO_PAGE_IDENT_BY_ITEM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15653413667539129)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Branch to URL Identified by Item (Use Item Name)'
,p_lov_return_value=>'BRANCH_TO_URL_IDENT_BY_ITEM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15653610612539129)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Branch to Function Returning a URL'
,p_lov_return_value=>'BRANCH_TO_FUNCTION_RETURNING_URL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(24865323058688299)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Branch to Function Returning a Page'
,p_lov_return_value=>'BRANCH_TO_FUNCTION_RETURNING_PAGE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_public
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84921112902747500)
,p_lov_name=>'PAGE.PUBLIC'
,p_lov_query=>'.'||wwv_flow_imp.id(84921112902747500)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475254
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84921502289747501)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Page Requires Authentication'
,p_lov_return_value=>'N'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84921330545747501)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Page Is Public'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_subtitle_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84922124330750817)
,p_lov_name=>'PAGE.SUBTITLE.TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(84922124330750817)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475254
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84923527403750819)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'SQL Expression'
,p_lov_return_value=>'SQL_EXPRESSION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84923723303750819)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Text with Substitutions'
,p_lov_return_value=>'TEXT_WITH_SUBSTITUTIONS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pages_in_current_app
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(257008601524719157)
,p_lov_name=>'PAGES IN CURRENT APP'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id || '' - '' || name d, id r',
'  from wwv_flow_steps',
' where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475254
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_and_popup_transitions
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(16215309545314300)
,p_lov_name=>'PAGE_AND_POPUP_TRANSITIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(16215309545314300)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475254
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16219511258513530)
,p_lov_disp_sequence=>0
,p_lov_disp_value=>'None'
,p_lov_return_value=>'NONE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16215606084314306)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Fade'
,p_lov_return_value=>'FADE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16215829338314308)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Pop'
,p_lov_return_value=>'POP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16216017778314308)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Flip'
,p_lov_return_value=>'FLIP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16216202625314308)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Turn'
,p_lov_return_value=>'TURN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16216419460314309)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Flow'
,p_lov_return_value=>'FLOW'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16216618829314309)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Slide'
,p_lov_return_value=>'SLIDE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16216809885314309)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Slide Up'
,p_lov_return_value=>'SLIDEUP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16217001457314310)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Slide Down'
,p_lov_return_value=>'SLIDEDOWN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16218310256465838)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Slide Fade'
,p_lov_return_value=>'SLIDEFADE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_computation_points2
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(62981024179015035)
,p_lov_name=>'PAGE_COMPUTATION_POINTS2'
,p_lov_query=>'.'||wwv_flow_imp.id(62981024179015035)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475254
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(62981313883015043)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'On New Instance (new session)'
,p_lov_return_value=>'ON_NEW_INSTANCE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(62981519102015043)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Before Header'
,p_lov_return_value=>'BEFORE_HEADER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(62981718705015044)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'After Header'
,p_lov_return_value=>'AFTER_HEADER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(62981911645015044)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Before Region(s)'
,p_lov_return_value=>'BEFORE_BOX_BODY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(62982168927015047)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'After Region(s)'
,p_lov_return_value=>'AFTER_BOX_BODY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(62982312758015047)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Before Footer'
,p_lov_return_value=>'BEFORE_FOOTER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(62982513587015048)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'After Footer'
,p_lov_return_value=>'AFTER_FOOTER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(62982747036015048)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'After Submit'
,p_lov_return_value=>'AFTER_SUBMIT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_computation_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(86604122856270295)
,p_lov_name=>'PAGE_COMPUTATION_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(86604122856270295)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475254
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88303124504820277)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Item on This Page'
,p_lov_return_value=>'THIS_PAGE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88303320734820277)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Item on Another Page'
,p_lov_return_value=>'PAGE_ITEM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88303522865820278)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Application Level Item'
,p_lov_return_value=>'FLOW_ITEM'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_computation_types2
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(62977815884897285)
,p_lov_name=>'PAGE_COMPUTATION_TYPES2'
,p_lov_query=>'.'||wwv_flow_imp.id(62977815884897285)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475254
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(62978121078897312)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Static Assignment'
,p_lov_return_value=>'STATIC_ASSIGNMENT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(62978343008897315)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'PL/SQL Function Body'
,p_lov_return_value=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(62978514164897316)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'SQL Query (return single value)'
,p_lov_return_value=>'QUERY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(458512309400745522)
,p_lov_disp_sequence=>35
,p_lov_disp_value=>'SQL Query (return multiple values)'
,p_lov_return_value=>'QUERY_COLON'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(62978711197897316)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'SQL Expression'
,p_lov_return_value=>'SQL_EXPRESSION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(62978941617897319)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'PLSQL Expression'
,p_lov_return_value=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(22684624604995500)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Item Value'
,p_lov_return_value=>'ITEM_VALUE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_display_point
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(131723061838)
,p_lov_name=>'PAGE_DISPLAY_POINT'
,p_lov_query=>'.'||wwv_flow_imp.id(131723061838)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475254
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3695509594759)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Page Template Body'
,p_lov_return_value=>'BODY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_groups
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(3263658807462002)
,p_lov_name=>'PAGE_GROUPS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d,',
'       id r',
'  from wwv_flow_page_groups',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
' order by upper(group_name)'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_return_column_name=>'R'
,p_display_column_name=>'D'
,p_version_scn=>72475254
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_mode
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(259083013010648721)
,p_lov_name=>'PAGE_MODE'
,p_lov_query=>'.'||wwv_flow_imp.id(259083013010648721)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475254
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(259083317127648724)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Standard Browser'
,p_lov_return_value=>'N'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(259083521309648727)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Mobile Browser'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_process_button_ids
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(874104981)
,p_lov_name=>'PAGE_PROCESS_BUTTON_IDS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select button_name,',
'       id',
'  from (',
'        /* all region buttons from current page and global page */',
'        select case when b.flow_step_id = f.global_page_id then',
'                   wwv_flow_lang.system_message(''LAYOUT.GLOBAL_PAGE_REGION_PREFIX'')',
'               end ||',
'               b.button_name ||',
'               '' ('' || b.button_image_alt || '')'' as button_name,',
'               b.id,',
'               b.button_name bn,',
'               case when b.flow_step_id = f.global_page_id then 2 else 1 end x',
'          from wwv_flow_steps p,',
'               wwv_flows f,',
'               wwv_flow_step_buttons b',
'         where p.flow_id      = :FB_FLOW_ID',
'           and p.id           = :FB_FLOW_PAGE_ID',
'           and f.id           = p.flow_id',
'           and b.flow_id      = f.id',
'           and b.flow_step_id in (:FB_FLOW_PAGE_ID, f.global_page_id)',
'         order by x, bn ',
'       )'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475254
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_remote_source
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1770066301256915)
,p_lov_name=>'PAGE_REMOTE_SOURCE'
,p_lov_query=>'.'||wwv_flow_imp.id(1770066301256915)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475254
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1770394878256915)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Table'
,p_lov_return_value=>'TABLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1770747082256915)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'SQL Query'
,p_lov_return_value=>'QUERY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_size_units
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(11205810538925547)
,p_lov_name=>'PAGE_SIZE_UNITS'
,p_lov_query=>'.'||wwv_flow_imp.id(11205810538925547)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475254
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(11206106459925548)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Points'
,p_lov_return_value=>'POINTS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(11206318132925548)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Inches'
,p_lov_return_value=>'INCHES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(11206525283925548)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Millimeters'
,p_lov_return_value=>'MILIMETERS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(11206721741925548)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Centimeters'
,p_lov_return_value=>'CENTIMETERS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_source
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(141264908196813501)
,p_lov_name=>'PAGE_SOURCE'
,p_lov_query=>'.'||wwv_flow_imp.id(141264908196813501)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475254
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(141265101710813505)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Table'
,p_lov_return_value=>'TABLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(141265331215813507)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'SQL Query'
,p_lov_return_value=>'QUERY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1951814459068642)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'Property Graph'
,p_lov_return_value=>'GRAPH'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>'sys.dbms_db_version.version >= 23 and :APP_PAGE_ID = 7031'
,p_lov_disp_cond2=>'PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_template_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(361310216348385184)
,p_lov_name=>'PAGE_TEMPLATE_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(361310216348385184)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475254
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(361310505494385184)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Dialog Page'
,p_lov_return_value=>'Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(361310808301385185)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Normal Page'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_template_wiz
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(86592719346240927)
,p_lov_name=>'PAGE_TEMPLATE_WIZ'
,p_lov_query=>'.'||wwv_flow_imp.id(86592719346240927)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475254
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88304318793821260)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'From Scratch'
,p_lov_return_value=>'BLANK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88304522228821260)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'As a Copy of an Existing Template'
,p_lov_return_value=>'COPY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_type_selection
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(497897080593180120)
,p_lov_name=>'PAGE_TYPE_SELECTION'
,p_lov_query=>'.'||wwv_flow_imp.id(497897080593180120)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475254
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(497897377095180126)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Component'
,p_lov_return_value=>'PAGE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1407003736428649)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Pattern'
,p_lov_return_value=>'PATTERN'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>'wwv_flow_page_dev.app_has_page_patterns(:fb_flow_id)'
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(497897731033180129)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Feature'
,p_lov_return_value=>'FEATURE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15802403849499358)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Legacy Pages'
,p_lov_return_value=>'LEGACY_PAGE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_validation_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(131915151655)
,p_lov_name=>'PAGE_VALIDATION_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(131915151655)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475254
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88159421716967927)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Exists'
,p_lov_return_value=>'EXISTS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88159624014967927)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Function Returning Boolean'
,p_lov_return_value=>'FUNC_BODY_RETURNING_BOOLEAN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88159825561967927)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Function Returning Error Text'
,p_lov_return_value=>'FUNC_BODY_RETURNING_ERR_TEXT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88160001279967928)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Item / Column specified is NOT NULL'
,p_lov_return_value=>'ITEM_NOT_NULL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88162620381967931)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'NOT Exists'
,p_lov_return_value=>'NOT_EXISTS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88163214798967932)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'PL/SQL Expression'
,p_lov_return_value=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88163626551967932)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'SQL Expression'
,p_lov_return_value=>'SQL_EXPRESSION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88162807376967931)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'PL/SQL Error'
,p_lov_return_value=>'PLSQL_ERROR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88161630524967930)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'Item / Column specified is NOT zero'
,p_lov_return_value=>'ITEM_NOT_ZERO'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88161809824967930)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'Item / Column specified contains no spaces'
,p_lov_return_value=>'ITEM_CONTAINS_NO_SPACES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88162030394967930)
,p_lov_disp_sequence=>130
,p_lov_disp_value=>'Item / Column specified is NOT NULL or zero'
,p_lov_return_value=>'ITEM_NOT_NULL_OR_ZERO'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88162230185967930)
,p_lov_disp_sequence=>140
,p_lov_disp_value=>'Item / Column specified is alphanumeric'
,p_lov_return_value=>'ITEM_IS_ALPHANUMERIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88162428823967931)
,p_lov_disp_sequence=>150
,p_lov_disp_value=>'Item / Column specified is numeric'
,p_lov_return_value=>'ITEM_IS_NUMERIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(42663306349689860)
,p_lov_disp_sequence=>160
,p_lov_disp_value=>'Item / Column specified is a valid date'
,p_lov_return_value=>'ITEM_IS_DATE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(168169815429274616)
,p_lov_disp_sequence=>170
,p_lov_disp_value=>'Item / Column specified is a valid timestamp'
,p_lov_return_value=>'ITEM_IS_TIMESTAMP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88161023720967929)
,p_lov_disp_sequence=>180
,p_lov_disp_value=>'Item / Column in Expression 1 equals string literal in Expression 2'
,p_lov_return_value=>'ITEM_IN_VALIDATION_EQ_STRING2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88160629326967929)
,p_lov_disp_sequence=>190
,p_lov_disp_value=>'Item / Column in Expression 1 does NOT equal string literal in Expression2'
,p_lov_return_value=>'ITEM_IN_VALIDATION_NOT_EQ_STRING2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88163405736967932)
,p_lov_disp_sequence=>195
,p_lov_disp_value=>'Item / Column in Expression 1 matches Regular Expression in Expression 2'
,p_lov_return_value=>'REGULAR_EXPRESSION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88161429567967930)
,p_lov_disp_sequence=>200
,p_lov_disp_value=>'Item / Column in Expression 1 is contained in Expression 2'
,p_lov_return_value=>'ITEM_IN_VALIDATION_IN_STRING2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88161215339967929)
,p_lov_disp_sequence=>210
,p_lov_disp_value=>'Item / Column in Expression 1 is NOT contained in Expression 2'
,p_lov_return_value=>'ITEM_IN_VALIDATION_NOT_IN_STRING2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88160205381967928)
,p_lov_disp_sequence=>220
,p_lov_disp_value=>'Item / Column in Expression 1 contains at least one of the characters in Expression 2'
,p_lov_return_value=>'ITEM_IN_VALIDATION_CONTAINS_AT_LEAST_ONE_CHAR_IN_STRING2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88160405596967928)
,p_lov_disp_sequence=>230
,p_lov_disp_value=>'Item / Column in Expression 1 contains only characters in Expression 2'
,p_lov_return_value=>'ITEM_IN_VALIDATION_CONTAINS_ONLY_CHAR_IN_STRING2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88160803174967929)
,p_lov_disp_sequence=>240
,p_lov_disp_value=>'Item / Column in Expression 1 does not contain any of the characters in Expression 2'
,p_lov_return_value=>'ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(886430412165364351)
,p_lov_disp_sequence=>250
,p_lov_disp_value=>'At least one Row Selector checked'
,p_lov_return_value=>'ROW_SELECTORS_CHECKED'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(886493804678371606)
,p_lov_disp_sequence=>260
,p_lov_disp_value=>'Submitted Column Values are Unique'
,p_lov_return_value=>'UNIQUE_COLUMN'
,p_lov_disp_cond_type=>'NEVER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/page_view_mode_002
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84240119994394393)
,p_lov_name=>'PAGE_VIEW_MODE'
,p_lov_query=>'.'||wwv_flow_imp.id(84240119994394393)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475254
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84240330663394394)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'List'
,p_lov_return_value=>'LIST'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84240527246394394)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Detail'
,p_lov_return_value=>'DETAIL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pagination
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(99817717480817679)
,p_lov_name=>'PAGINATION'
,p_lov_query=>'.'||wwv_flow_imp.id(99817717480817679)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475254
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(99818003503817701)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Row Ranges X to Y of Z (no pagination)'
,p_lov_return_value=>'ROWS_X_TO_Y_OF_Z'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(99818224386817703)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Row Ranges X to Y (no pagination)'
,p_lov_return_value=>'ROWS_X_TO_Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(99818416060817704)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Search Engine 1,2,3,4 (set based pagination)'
,p_lov_return_value=>'SEARCH_ENGINE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(99818616394817704)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Use Externally Created Pagination Buttons'
,p_lov_return_value=>'COMPUTED_BUT_NOT_DISPLAYED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(99818822634817704)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Row Ranges 1-15 16-30  (with set pagination)'
,p_lov_return_value=>'ROW_RANGES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(99819028134817704)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Row Ranges 1-15 16-30 in select list (with pagination)'
,p_lov_return_value=>'ROW_RANGES_IN_SELECT_LIST'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(99819821574817706)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Row Ranges X to Y of Z (with pagination)'
,p_lov_return_value=>'ROW_RANGES_WITH_LINKS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(39002816961800537)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Row Ranges X to Y (with next and previous links)'
,p_lov_return_value=>'NEXT_PREVIOUS_LINKS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pagination_display_position
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(3941822825486065)
,p_lov_name=>'PAGINATION.DISPLAY.POSITION'
,p_lov_query=>'.'||wwv_flow_imp.id(3941822825486065)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475254
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88164425179968925)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Bottom - Start'
,p_lov_return_value=>'BOTTOM_LEFT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88164621858968925)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Bottom - End'
,p_lov_return_value=>'BOTTOM_RIGHT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88164803008968926)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Top - Start'
,p_lov_return_value=>'TOP_LEFT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88165000666968926)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Top - End'
,p_lov_return_value=>'TOP_RIGHT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88165212735968926)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Top and Bottom - Start'
,p_lov_return_value=>'TOP_AND_BOTTOM_LEFT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88165425741968928)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Top and Bottom - End'
,p_lov_return_value=>'TOP_AND_BOTTOM_RIGHT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/parent_list_list_items
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(6467729263888343)
,p_lov_name=>'PARENT_LIST.LIST_ITEMS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select lpad('' '',4*(level-1),''.'')|| wwv_flow_escape.html(list_item_link_text) list_item_link_text, id',
'from wwv_flow_list_items i',
'where id not in (',
'    select id from wwv_flow_list_items ',
'    where flow_id = :FB_FLOW_ID',
'    and list_id = :P4053_LIST_ID',
'    and security_group_id = :WORKSPACE_ID',
'    start with id = :P4053_ID ',
'    connect by prior id = parent_list_item_id )',
'and security_group_id = :WORKSPACE_ID',
'start with parent_list_item_id is null',
'       and flow_id = :FB_FLOW_ID',
'       and list_id = :P4053_LIST_ID',
'connect by prior id = parent_list_item_id ',
'        and prior list_id = list_id',
'order siblings by list_item_display_sequence'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475254
);
end;
/
prompt --application/shared_components/user_interface/lovs/parent_regions_current_page
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(171055708949151026)
,p_lov_name=>'PARENT_REGIONS_CURRENT_PAGE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select plug_name || '' ('' || plug_display_sequence || '')'' as plug_name,',
'       id',
'  from wwv_flow_page_plugs p',
' where flow_id           = :FB_FLOW_ID',
'   and page_id           = :FB_FLOW_PAGE_ID',
'   and security_group_id = :WORKSPACE_ID',
' order by plug_name'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475254
);
end;
/
prompt --application/shared_components/user_interface/lovs/parent_tab_set
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(83376300088038016)
,p_lov_name=>'PARENT_TAB_SET'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct wwv_flow_escape.html(tab_set) d, tab_set r',
'',
'from wwv_flow_toplevel_tabs',
'',
'where flow_id = nv(''FB_FLOW_ID'') and',
'',
'      security_group_id = :flow_security_group_id',
'',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475254
);
end;
/
prompt --application/shared_components/user_interface/lovs/persistence_opts
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84831517957313758)
,p_lov_name=>'PERSISTENCE_OPTS'
,p_lov_query=>'.'||wwv_flow_imp.id(84831517957313758)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475258
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84831715807313758)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Per Session (Disk)'
,p_lov_return_value=>'Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84831914478313759)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Per User (Disk)'
,p_lov_return_value=>'U'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(74481706551378214)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Per Request (Memory Only)'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pick_custom_css_link
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(353335506996711467)
,p_lov_name=>'PICK CUSTOM CSS LINK'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''#IMAGE''||''_PREFIX#themes/theme_''||theme_id||''/svg.css'' d,',
'''#IMAGE''||''_PREFIX#themes/theme_''||theme_id||''/svg.css'' r',
'from   wwv_flow_themes where flow_id = :fb_flow_id'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475258
);
end;
/
prompt --application/shared_components/user_interface/lovs/pick_item_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(8907709900373021)
,p_lov_name=>'PICK.ITEM.TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(8907709900373021)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475259
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3267203309997582)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (HTML5)'
,p_lov_return_value=>'NATIVE_DATE_PICKER_HTML5'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="javascript:$s(''P366_ITEM_TYPE'',''NATIVE_DATE_PICKER_HTML5'');apex.submit(''NEXT'');"><img src="#IMAGE_PREFIX#htmldb/icons/text_text.gif" height="60" width="140" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(8908006653373023)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Text Field'
,p_lov_return_value=>'NATIVE_TEXT_FIELD'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="javascript:$s(''P366_ITEM_TYPE'',''NATIVE_TEXT_FIELD'');apex.submit(''NEXT'');"><img src="#IMAGE_PREFIX#htmldb/icons/text_text.gif" height="60" width="140" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(8908224799373024)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Text Area'
,p_lov_return_value=>'NATIVE_TEXTAREA'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="javascript:$s(''P366_ITEM_TYPE'',''NATIVE_TEXTAREA'');apex.submit(''NEXT'');"><img src="#IMAGE_PREFIX#htmldb/icons/text_area.gif" height="60" width="140" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(8908418989373024)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Select List'
,p_lov_return_value=>'NATIVE_SELECT_LIST'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="javascript:$s(''P366_ITEM_TYPE'',''NATIVE_SELECT_LIST'');apex.submit(''NEXT'');"><img src="#IMAGE_PREFIX#htmldb/icons/text_pulldwn.gif" height="60" width="140" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(8908601172373024)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Radio'
,p_lov_return_value=>'NATIVE_RADIOGROUP'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="javascript:$s(''P366_ITEM_TYPE'',''NATIVE_RADIOGROUP'');apex.submit(''NEXT'');"><img src="#IMAGE_PREFIX#htmldb/icons/text_radio.gif" height="60" width="140" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(8908828638373027)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Hidden'
,p_lov_return_value=>'NATIVE_HIDDEN'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="javascript:$s(''P366_ITEM_TYPE'',''NATIVE_HIDDEN'');apex.submit(''NEXT'');"><img src="#IMAGE_PREFIX#htmldb/icons/text_hidden.gif"  height="60" width="140" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(8909015142373027)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Check Box'
,p_lov_return_value=>'NATIVE_CHECKBOX'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="javascript:$s(''P366_ITEM_TYPE'',''NATIVE_CHECKBOX'');apex.submit(''NEXT'');"><img src="#IMAGE_PREFIX#htmldb/icons/text_check.gif" height="60" width="140" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(8909408222373028)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Password'
,p_lov_return_value=>'NATIVE_PASSWORD'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="javascript:$s(''P366_ITEM_TYPE'',''NATIVE_PASSWORD'');apex.submit(''NEXT'');"><img src="#IMAGE_PREFIX#htmldb/icons/text_pswd.gif" height="60" width="140" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(8909609752373028)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Display Only'
,p_lov_return_value=>'NATIVE_DISPLAY_ONLY'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="javascript:$s(''P366_ITEM_TYPE'',''NATIVE_DISPLAY_ONLY'');apex.submit(''NEXT'');"><img src="#IMAGE_PREFIX#htmldb/icons/text_html2.gif" height="60" width="140" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(8909813534373028)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Popup List of Values'
,p_lov_return_value=>'POPUP'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="javascript:$s(''P366_ITEM_TYPE'',''POPUP'');apex.submit(''NEXT'');"><img src="#IMAGE_PREFIX#htmldb/icons/text_popup.gif" height="60" width="140" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(8910208834373029)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'List Manager'
,p_lov_return_value=>'NATIVE_LIST_MANAGER'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="javascript:$s(''P366_ITEM_TYPE'',''NATIVE_LIST_MANAGER'');apex.submit(''NEXT'');"><img src="#IMAGE_PREFIX#htmldb/icons/text_listmgr.gif" height="60" width="140" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9404502489953110)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'File Browse'
,p_lov_return_value=>'NATIVE_FILE'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="javascript:$s(''P366_ITEM_TYPE'',''NATIVE_FILE'');apex.submit(''NEXT'');" alt="File Browse Control Type"><img src="#IMAGE_PREFIX#htmldb/icons/text_fileupload.gif" height="60" width="140" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(10594217053221501)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Yes/No'
,p_lov_return_value=>'NATIVE_YES_NO'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="javascript:$s(''P366_ITEM_TYPE'',''NATIVE_YES_NO'');apex.submit(''NEXT'');"><img src="#IMAGE_PREFIX#htmldb/icons/item_generic.gif" height="60" width="140" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(10719314000450668)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Slider'
,p_lov_return_value=>'NATIVE_SLIDER'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="javascript:$s(''P366_ITEM_TYPE'',''NATIVE_SLIDER'');apex.submit(''NEXT'');"><img src="#IMAGE_PREFIX#htmldb/icons/item_generic.gif" height="60" width="140" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27291000242248919)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Plug-ins'
,p_lov_return_value=>'PLUGINS'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="javascript:$s(''P366_ITEM_TYPE'',''PLUGINS'');apex.submit(''NEXT'');"><img src="#IMAGE_PREFIX#htmldb/icons/text_custom_item.gif" height="60" width="140" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(28057322773126767)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Stop and Start Grid Layout (Deprecated)'
,p_lov_return_value=>'NATIVE_STOP_AND_START_HTML_TABLE'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="javascript:$s(''P366_ITEM_TYPE'',''NATIVE_STOP_AND_START_HTML_TABLE'');apex.submit(''NEXT'');"><img src="#IMAGE_PREFIX#htmldb/icons/text_start_stop_html.gif" height="60" width="140" alt="#DISPLAY_VALUE#" /></a>'
,p_lov_disp_cond_type=>'NEVER'
,p_required_patch=>wwv_flow_imp.id(170786031904296885)
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(41159810857656724)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Shuttle'
,p_lov_return_value=>'NATIVE_SHUTTLE'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="javascript:$s(''P366_ITEM_TYPE'',''NATIVE_SHUTTLE'');apex.submit(''NEXT'');"><img src="#IMAGE_PREFIX#htmldb/icons/shuttle.gif" height="60" width="140" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(178424424982076732)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Text Field with autocomplete'
,p_lov_return_value=>'NATIVE_AUTO_COMPLETE'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="javascript:$s(''P366_ITEM_TYPE'',''NATIVE_AUTO_COMPLETE'');apex.submit(''NEXT'');"><img src="#IMAGE_PREFIX#htmldb/icons/text_text.gif" height="60" width="140" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(186385501532616826)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Rich Text Editor'
,p_lov_return_value=>'NATIVE_RICH_TEXT_EDITOR'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="javascript:$s(''P366_ITEM_TYPE'',''NATIVE_RICH_TEXT_EDITOR'');apex.submit(''NEXT'');"><img src="#IMAGE_PREFIX#htmldb/icons/rich_text_editor.gif" height="60" width="140" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(262392928279878232)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker'
,p_lov_return_value=>'NATIVE_DATE_PICKER'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="javascript:$s(''P366_ITEM_TYPE'',''NATIVE_DATE_PICKER'');apex.submit(''NEXT'');"><img src="#IMAGE_PREFIX#htmldb/icons/text_cal.gif" height="60" width="140" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(429342610723553668)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Number Field'
,p_lov_return_value=>'NATIVE_NUMBER_FIELD'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="javascript:$s(''P366_ITEM_TYPE'',''NATIVE_NUMBER_FIELD'');apex.submit(''NEXT'');"><img src="#IMAGE_PREFIX#htmldb/icons/text_text.gif" height="60" width="140" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(483847108707511533)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Display Image'
,p_lov_return_value=>'NATIVE_DISPLAY_IMAGE'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="javascript:$s(''P366_ITEM_TYPE'',''NATIVE_DISPLAY_IMAGE'');apex.submit(''NEXT'');"><img src="#IMAGE_PREFIX#htmldb/icons/display_image.gif" height="60" width="140" alt="#DISPLAY_VALUE#" /></a>'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pick_plsql_validation_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(9572322050621169)
,p_lov_name=>'PICK.PLSQL.VALIDATION.TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(9572322050621169)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475259
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9572609687621171)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'PL/SQL Expression'
,p_lov_return_value=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9572832523621172)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'PL/SQL Error'
,p_lov_return_value=>'PLSQL_ERROR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9573017854621172)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Function Returning Boolean'
,p_lov_return_value=>'FUNC_BODY_RETURNING_BOOLEAN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9573212373621172)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Function Returning Error Text'
,p_lov_return_value=>'FUNC_BODY_RETURNING_ERR_TEXT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pick_validation_category
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(11226805981881336)
,p_lov_name=>'PICK.VALIDATION.CATEGORY'
,p_lov_query=>'.'||wwv_flow_imp.id(11226805981881336)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475259
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(11227126312881337)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'SQL<br /><img src="#IMAGE_PREFIX#htmldb/icons/validation_sql.gif" height="75" width="100" alt="Placeholder" />'
,p_lov_return_value=>'SQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(11227327505881337)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'PL/SQL<br /><img src="#IMAGE_PREFIX#htmldb/icons/validation_plsql.gif" height="75" width="100" alt="Placeholder" />'
,p_lov_return_value=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(11227532202881337)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Item Not Null<br /><img src="#IMAGE_PREFIX#htmldb/icons/validation_notnull.gif" height="75" width="100" alt="Placeholder" />'
,p_lov_return_value=>'NOT_NULL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(11227705592881338)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Item String Comparison<br /><img src="#IMAGE_PREFIX#htmldb/icons/validation_stringcompare.gif" height="75" width="100" alt="Placeholder" />'
,p_lov_return_value=>'STRING'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(11227907063881338)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Regular Expression<br /><img src="#IMAGE_PREFIX#htmldb/icons/validation_regexp.gif" height="75" width="100" alt="Placeholder" />'
,p_lov_return_value=>'REGEX'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pick_validation_category_with_images
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(9536028012528261)
,p_lov_name=>'PICK.VALIDATION.CATEGORY (WITH IMAGES)'
,p_lov_query=>'.'||wwv_flow_imp.id(9536028012528261)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475259
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9536732257528264)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Not Null'
,p_lov_return_value=>'ITEM_NOT_NULL'
,p_lov_disp_cond_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_lov_disp_cond=>'P248_LEVEL'
,p_lov_disp_cond2=>'ITEM:COLUMN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9536927140528265)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'String Comparison'
,p_lov_return_value=>'STRING'
,p_lov_disp_cond_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_lov_disp_cond=>'P248_LEVEL'
,p_lov_disp_cond2=>'ITEM:COLUMN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9537131769528265)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Regular Expression'
,p_lov_return_value=>'REGULAR_EXPRESSION'
,p_lov_disp_cond_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_lov_disp_cond=>'P248_LEVEL'
,p_lov_disp_cond2=>'ITEM:COLUMN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9536313428528264)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'SQL'
,p_lov_return_value=>'SQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9536510909528264)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'PL/SQL'
,p_lov_return_value=>'PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pick_export_flowid_user_has_priv_on
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(361587217232122032)
,p_lov_name=>'PICK_EXPORT_FLOWID_USER_HAS_PRIV_ON'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flows f',
'where  ',
'       security_group_id = :flow_security_group_id and',
'       f.build_status != ''RUN_AND_HIDDEN'' and',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id is null and security_group_id = :flow_security_group_id )',
'       or',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id = f.id and security_group_id = :flow_security_group_id) ',
'order by 2'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475261
);
end;
/
prompt --application/shared_components/user_interface/lovs/pick_flowid_user_has_priv_on
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(138126827261)
,p_lov_name=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475261
);
end;
/
prompt --application/shared_components/user_interface/lovs/pick_image_name
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(136371109397)
,p_lov_name=>'PICK_IMAGE_NAME'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select file_name || '' ('' || wwv_flow_lang.system_message(scope) || '')'' as d,',
'       r',
'  from ( select file_name,',
'                ''#'' || ''APP_FILES#'' || file_name as r,',
'                ''APPLICATION'' as scope',
'           from wwv_flow_static_files',
'          where flow_id           = :FB_FLOW_ID',
'            and security_group_id = :WORKSPACE_ID',
'            and upper(mime_type)  like ''IMAGE/%''',
'          union all',
'         select file_name,',
'                ''#'' || ''WORKSPACE_FILES#'' || file_name as r,',
'                ''WORKSPACE'' as scope',
'           from wwv_flow_company_static_files',
'          where security_group_id = :WORKSPACE_ID',
'            and upper(mime_type)  like ''IMAGE/%''',
'          order by scope, file_name',
'       )',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475261
);
end;
/
prompt --application/shared_components/user_interface/lovs/pk_col_source_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(484873618926179854)
,p_lov_name=>'PK_COL_SOURCE_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(484873618926179854)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475261
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(484874402027179857)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Existing trigger'
,p_lov_return_value=>'T'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(484873806464179857)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Custom PL/SQL function'
,p_lov_return_value=>'F'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(484874211660179857)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Existing sequence'
,p_lov_return_value=>'S'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(484874012442179857)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'PL/SQL Expression'
,p_lov_return_value=>'P'
,p_lov_disp_cond_type=>'NEVER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pk_col_source_types_appontab_pk2
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(354663504966529830)
,p_lov_name=>'PK_COL_SOURCE_TYPES.APPONTAB.PK2'
,p_lov_query=>'.'||wwv_flow_imp.id(354663504966529830)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475261
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(354663817551529832)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Existing trigger'
,p_lov_return_value=>'T'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:322:&SESSION.::::P322_PK2_SOURCE_TYPE:T"><img src="#IMAGE_PREFIX#htmldb/builder/pk_frm_tgr.gif" width="140" height="115" alt="#DISPLAY_VALUE#" title="#DISPLAY_VALUE#" class="htmldbGreenIcons" /></a>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(354664018203529833)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Custom PL/SQL function'
,p_lov_return_value=>'F'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:322:&SESSION.::::P322_PK2_SOURCE_TYPE:F"><img src="#IMAGE_PREFIX#htmldb/builder/pk_frm_fkt.gif" width="140" height="115" alt="#DISPLAY_VALUE#" title="#DISPLAY_VALUE#" class="htmldbGreenIcons" /></a>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(354664228766529833)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Existing sequence'
,p_lov_return_value=>'S'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:322:&SESSION.::::P322_PK2_SOURCE_TYPE:S"><img src="#IMAGE_PREFIX#htmldb/builder/pk_frm_seq.gif" width="140" height="115" alt="#DISPLAY_VALUE#" title="#DISPLAY_VALUE#" class="htmldbGreenIcons" /></a>'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pk_col_source_types_detail_table
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(352799013917119271)
,p_lov_name=>'PK_COL_SOURCE_TYPES.DETAIL_TABLE'
,p_lov_query=>'.'||wwv_flow_imp.id(352799013917119271)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475261
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(352799326578119281)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Existing trigger'
,p_lov_return_value=>'T'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(352799504982119287)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Custom PL/SQL function'
,p_lov_return_value=>'F'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(352799732085119287)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Existing sequence'
,p_lov_return_value=>'S'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pk_col_source_types_detail_table_pk2
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(354857822180853056)
,p_lov_name=>'PK_COL_SOURCE_TYPES.DETAIL_TABLE.pk2'
,p_lov_query=>'.'||wwv_flow_imp.id(354857822180853056)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475261
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(354858126082853060)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Existing trigger'
,p_lov_return_value=>'T'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(354858324350853060)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Custom PL/SQL function'
,p_lov_return_value=>'F'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(354858518105853060)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Existing sequence'
,p_lov_return_value=>'S'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pk_col_source_types_form_and_rpt
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(353086022864435670)
,p_lov_name=>'PK_COL_SOURCE_TYPES.FORM_AND_RPT'
,p_lov_query=>'.'||wwv_flow_imp.id(353086022864435670)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475261
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(353086319474435683)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Existing trigger'
,p_lov_return_value=>'T'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(353086510084435684)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Custom PL/SQL function'
,p_lov_return_value=>'F'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(353086701342435684)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Existing sequence'
,p_lov_return_value=>'S'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pk_col_source_types_form_and_rpt_pk2
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(353531720082576530)
,p_lov_name=>'PK_COL_SOURCE_TYPES.FORM_AND_RPT.PK2'
,p_lov_query=>'.'||wwv_flow_imp.id(353531720082576530)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475261
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(353532022777576538)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Existing trigger'
,p_lov_return_value=>'T'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(353532228693576540)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Custom PL/SQL function'
,p_lov_return_value=>'F'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(353532421265576540)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Existing sequence'
,p_lov_return_value=>'S'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pk_col_source_types_form_on_table
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(352937431933900311)
,p_lov_name=>'PK_COL_SOURCE_TYPES.FORM_ON_TABLE'
,p_lov_query=>'.'||wwv_flow_imp.id(352937431933900311)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475261
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(352937713224900316)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Existing trigger'
,p_lov_return_value=>'T'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(352937930916900317)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Custom PL/SQL function'
,p_lov_return_value=>'F'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(352938101747900317)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Existing sequence'
,p_lov_return_value=>'S'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pk_col_source_types_form_on_table_pk2
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(353234920560769172)
,p_lov_name=>'PK_COL_SOURCE_TYPES.FORM_ON_TABLE_PK2'
,p_lov_query=>'.'||wwv_flow_imp.id(353234920560769172)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475261
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(353235227228769175)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Existing trigger'
,p_lov_return_value=>'T'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(353235416326769176)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Custom PL/SQL function'
,p_lov_return_value=>'F'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(353235618729769176)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Existing sequence'
,p_lov_return_value=>'S'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pk_col_source_types_master_table
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(109748910763779674)
,p_lov_name=>'PK_COL_SOURCE_TYPES.MASTER_TABLE'
,p_lov_query=>'.'||wwv_flow_imp.id(109748910763779674)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475261
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(109749110982779676)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Existing trigger'
,p_lov_return_value=>'T'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(109749305139779677)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Custom PL/SQL function'
,p_lov_return_value=>'F'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(109749520411779678)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Existing sequence'
,p_lov_return_value=>'S'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pk_col_source_types_pk2
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(354777930196648711)
,p_lov_name=>'PK_COL_SOURCE_TYPES.PK2'
,p_lov_query=>'.'||wwv_flow_imp.id(354777930196648711)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475261
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(354778214608648715)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Existing trigger'
,p_lov_return_value=>'T'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(354778400953648715)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Custom PL/SQL function'
,p_lov_return_value=>'F'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(354778619727648715)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Existing sequence'
,p_lov_return_value=>'S'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pk_col_source_types_tabular_form
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(352924107252836399)
,p_lov_name=>'PK_COL_SOURCE_TYPES.TABULAR_FORM'
,p_lov_query=>'.'||wwv_flow_imp.id(352924107252836399)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475261
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(352924419959836410)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Existing trigger'
,p_lov_return_value=>'T'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(352924610617836410)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Custom PL/SQL function'
,p_lov_return_value=>'F'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(352924831123836410)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Existing sequence'
,p_lov_return_value=>'S'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pk_col_source_types_tabular_form_pk2
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(354918920831899336)
,p_lov_name=>'PK_COL_SOURCE_TYPES.TABULAR_FORM.pk2'
,p_lov_query=>'.'||wwv_flow_imp.id(354918920831899336)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475263
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(354919209780899342)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Existing trigger'
,p_lov_return_value=>'T'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(354919401744899342)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Custom PL/SQL function'
,p_lov_return_value=>'F'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(354919621470899342)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Existing sequence'
,p_lov_return_value=>'S'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pk_col_source_types_wiz_form_and_rpt
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(230311169888029514)
,p_lov_name=>'PK_COL_SOURCE_TYPES.WIZ.FORM_AND_RPT'
,p_lov_query=>'.'||wwv_flow_imp.id(230311169888029514)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475263
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(230311440988029534)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Existing Trigger'
,p_lov_return_value=>'T'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(230311848885029538)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Existing Sequence'
,p_lov_return_value=>'S'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plsql_anonymous_block
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84783318827001758)
,p_lov_name=>'PLSQL_ANONYMOUS_BLOCK'
,p_lov_query=>'.'||wwv_flow_imp.id(84783318827001758)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475265
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84783500539001759)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Execute Code'
,p_lov_return_value=>'NATIVE_PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plug_chart_axis
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84913307529708111)
,p_lov_name=>'PLUG.CHART.AXIS'
,p_lov_query=>'.'||wwv_flow_imp.id(84913307529708111)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475265
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84913517211708112)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Average Value in Series'
,p_lov_return_value=>'AVG'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84913719258708112)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'First Value in Series'
,p_lov_return_value=>'FIRST'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84913917773708112)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Last Value in Series'
,p_lov_return_value=>'LAST'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84914531578708113)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Zero'
,p_lov_return_value=>'ZERO'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_action_position_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2609610747438738)
,p_lov_name=>'PLUGIN.ACTION_POSITION.TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(2609610747438738)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475265
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2609908150438741)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Link'
,p_lov_return_value=>'LINK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2610390647438741)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Template'
,p_lov_return_value=>'TEMPLATE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_action_template_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2610859887449164)
,p_lov_name=>'PLUGIN.ACTION_TEMPLATE.TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(2610859887449164)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475265
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2611173616449164)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Button'
,p_lov_return_value=>'BUTTON'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2611532686449164)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Menu'
,p_lov_return_value=>'MENU'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_attribute_column_data_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(24174232595113027)
,p_lov_name=>'PLUGIN.ATTRIBUTE.COLUMN_DATA_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(24174232595113027)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475265
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(24174501605113034)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Varchar2'
,p_lov_return_value=>'VARCHAR2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(24174710587113038)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Number'
,p_lov_return_value=>'NUMBER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(24174906128113038)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Date'
,p_lov_return_value=>'DATE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(24175108781113038)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Timestamp'
,p_lov_return_value=>'TIMESTAMP'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_lov_disp_cond=>'P4415_PLUGIN_TYPE'
,p_lov_disp_cond2=>'TEMPLATE COMPONENT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(24175310330113038)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Timestamp with Time Zone'
,p_lov_return_value=>'TIMESTAMP_TZ'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_lov_disp_cond=>'P4415_PLUGIN_TYPE'
,p_lov_disp_cond2=>'TEMPLATE COMPONENT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(24175504536113038)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Timestamp with Local Time Zone'
,p_lov_return_value=>'TIMESTAMP_LTZ'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_lov_disp_cond=>'P4415_PLUGIN_TYPE'
,p_lov_disp_cond2=>'TEMPLATE COMPONENT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(24175729866113038)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Interval Year to Month'
,p_lov_return_value=>'INTERVAL_Y2M'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(24175905278113038)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Interval Day to Second'
,p_lov_return_value=>'INTERVAL_D2S'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(24176102810113039)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Blob'
,p_lov_return_value=>'BLOB'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_lov_disp_cond=>'P4415_PLUGIN_TYPE'
,p_lov_disp_cond2=>'TEMPLATE COMPONENT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(24176327601113039)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Clob'
,p_lov_return_value=>'CLOB'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(24176518608113039)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Bfile'
,p_lov_return_value=>'BFILE'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_lov_disp_cond=>'P4415_PLUGIN_TYPE'
,p_lov_disp_cond2=>'TEMPLATE COMPONENT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(24337427838636550)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'Rowid'
,p_lov_return_value=>'ROWID'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_lov_disp_cond=>'P4415_PLUGIN_TYPE'
,p_lov_disp_cond2=>'TEMPLATE COMPONENT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_attribute_condition_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(189411726584965751)
,p_lov_name=>'PLUGIN.ATTRIBUTE.CONDITION_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(189411726584965751)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475265
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(189411926786965763)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'equal to'
,p_lov_return_value=>'EQUALS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(189412102027965767)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'not equal to'
,p_lov_return_value=>'NOT_EQUALS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(189413112877965767)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'in list'
,p_lov_return_value=>'IN_LIST'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(189413328847965767)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'not in list'
,p_lov_return_value=>'NOT_IN_LIST'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(189412704581965767)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'is null'
,p_lov_return_value=>'NULL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(189412916403965767)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'is not null'
,p_lov_return_value=>'NOT_NULL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_attribute_scope
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(32688601172502165)
,p_lov_name=>'PLUGIN.ATTRIBUTE.SCOPE'
,p_lov_query=>'.'||wwv_flow_imp.id(32688601172502165)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475265
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(32689504325502172)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Application'
,p_lov_return_value=>'APPLICATION'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_lov_disp_cond=>'P4415_PLUGIN_TYPE'
,p_lov_disp_cond2=>'TEMPLATE COMPONENT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(32688926523502169)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Component'
,p_lov_return_value=>'COMPONENT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1452691544500933)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Report'
,p_lov_return_value=>'REPORT'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'   ( :APP_PAGE_ID = 4415 and :P4415_PLUGIN_TYPE = ''TEMPLATE COMPONENT'' )',
'or :APP_PAGE_ID <> 4415'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(548117909782258520)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Region Column'
,p_lov_return_value=>'COLUMN'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugins',
' where security_group_id = :WORKSPACE_ID',
'   and id          = ( case to_number(:APP_PAGE_ID)',
'                           when 4410 then to_number(:P4410_ID)',
'                           when 4415 then to_number(:P4415_PLUGIN_ID )',
'                       end )',
'   and plugin_type = ''REGION TYPE''',
'   and '':'' || standard_attributes || '':'' like ''%:COLUMNS:%'''))
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_attribute_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(28057124498012298)
,p_lov_name=>'PLUGIN.ATTRIBUTE.TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(28057124498012298)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475265
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1503862373833569)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Data Load Definition ID'
,p_lov_return_value=>'DATA LOAD DEFINITION ID'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'FB_FLOW_ID'
,p_lov_disp_cond2=>'4411'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1544998894154595)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Task Definition'
,p_lov_return_value=>'TASK DEFINITION ID'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'FB_FLOW_ID'
,p_lov_disp_cond2=>'4411'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1800728647881167)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Email Template'
,p_lov_return_value=>'EMAIL TEMPLATE ID'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'FB_FLOW_ID'
,p_lov_disp_cond2=>'4411'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2200241845369098)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Code Language'
,p_lov_return_value=>'CODE LANGUAGE'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'WORKSPACE_ID'
,p_lov_disp_cond2=>'10'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2200565089373416)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'JavaScript (MLE)'
,p_lov_return_value=>'MLE JAVASCRIPT'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'WORKSPACE_ID'
,p_lov_disp_cond2=>'10'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2200896501380458)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'JavaScript (MLE) Expression Returning VARCHAR2'
,p_lov_return_value=>'MLE JAVASCRIPT EXPRESSION VARCHAR2'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'WORKSPACE_ID'
,p_lov_disp_cond2=>'10'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2201131765383626)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'JavaScript (MLE) Expression Returning BOOLEAN'
,p_lov_return_value=>'MLE JAVASCRIPT EXPRESSION BOOLEAN'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'WORKSPACE_ID'
,p_lov_disp_cond2=>'10'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2201413213388324)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'JavaScript (MLE) Function Body Returning VARCHAR2'
,p_lov_return_value=>'MLE JAVASCRIPT FUNCTION BODY VARCHAR2'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'WORKSPACE_ID'
,p_lov_disp_cond2=>'10'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2201759703390771)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'JavaScript (MLE) Function Body Returning BOOLEAN'
,p_lov_return_value=>'MLE JAVASCRIPT FUNCTION BODY BOOLEAN'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'WORKSPACE_ID'
,p_lov_disp_cond2=>'10'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2602937146527325)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Media'
,p_lov_return_value=>'MEDIA'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case :APP_PAGE_ID',
'  when ''4410'' then :P4410_PLUGIN_TYPE = ''TEMPLATE COMPONENT''',
'  when ''4415'' then :P4415_PLUGIN_TYPE = ''TEMPLATE COMPONENT''',
'end'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(6007319371602182)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Session State Value'
,p_lov_return_value=>'SESSION STATE VALUE'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case :APP_PAGE_ID',
'  when ''4410'' then :P4410_PLUGIN_TYPE = ''TEMPLATE COMPONENT''',
'  when ''4415'' then :P4415_PLUGIN_TYPE = ''TEMPLATE COMPONENT''',
'end'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(6201272567707301)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'PL/SQL Package'
,p_lov_return_value=>'PLSQL PACKAGE'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'FB_FLOW_ID'
,p_lov_disp_cond2=>'4411'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(6201592310710506)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'PL/SQL Procedure or Function'
,p_lov_return_value=>'PLSQL METHOD'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'FB_FLOW_ID'
,p_lov_disp_cond2=>'4411'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(6374820124387388)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Checkboxes'
,p_lov_return_value=>'CHECKBOXES'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case :APP_PAGE_ID',
'  when ''4410'' then :P4410_PLUGIN_TYPE != ''TEMPLATE COMPONENT''',
'  when ''4415'' then :P4415_PLUGIN_TYPE != ''TEMPLATE COMPONENT''',
'end'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(20774004730407858)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Region SQL Statement Column'
,p_lov_return_value=>'REGION SOURCE COLUMN'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugins',
' where id          = ( case :APP_PAGE_ID',
'                           when ''4410'' then to_number(:P4410_ID)',
'                           when ''4415'' then to_number(:P4415_PLUGIN_ID)',
'                       end )',
'   and plugin_type = ''REGION TYPE''',
'   and security_group_id = :WORKSPACE_ID'))
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(28057401464012301)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Select List'
,p_lov_return_value=>'SELECT LIST'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(28057622942012301)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Text'
,p_lov_return_value=>'TEXT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(28057826100012301)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Textarea'
,p_lov_return_value=>'TEXTAREA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(28058027106012301)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Yes/No'
,p_lov_return_value=>'CHECKBOX'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(48007808620320962)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Number'
,p_lov_return_value=>'NUMBER'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case :APP_PAGE_ID',
'  when ''4410'' then :P4410_PLUGIN_TYPE != ''TEMPLATE COMPONENT''',
'  when ''4415'' then :P4415_PLUGIN_TYPE != ''TEMPLATE COMPONENT''',
'end'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(48008112083321912)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Integer'
,p_lov_return_value=>'INTEGER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(48008315200322857)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Page Item'
,p_lov_return_value=>'PAGE ITEM'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case :APP_PAGE_ID',
'  when ''4410'' then :P4410_PLUGIN_TYPE != ''TEMPLATE COMPONENT''',
'  when ''4415'' then :P4415_PLUGIN_TYPE != ''TEMPLATE COMPONENT''',
'end'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(48008519355324004)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Page Items'
,p_lov_return_value=>'PAGE ITEMS'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case :APP_PAGE_ID',
'  when ''4410'' then :P4410_PLUGIN_TYPE != ''TEMPLATE COMPONENT''',
'  when ''4415'' then :P4415_PLUGIN_TYPE != ''TEMPLATE COMPONENT''',
'end'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(48008932169327789)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'SQL Query'
,p_lov_return_value=>'SQL'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case :APP_PAGE_ID',
'  when ''4410'' then :P4410_PLUGIN_TYPE != ''TEMPLATE COMPONENT''',
'  when ''4415'' then :P4415_PLUGIN_TYPE != ''TEMPLATE COMPONENT''',
'end'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(48009102864328704)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'PL/SQL Code'
,p_lov_return_value=>'PLSQL'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case :APP_PAGE_ID',
'  when ''4410'' then :P4410_PLUGIN_TYPE != ''TEMPLATE COMPONENT''',
'  when ''4415'' then :P4415_PLUGIN_TYPE != ''TEMPLATE COMPONENT''',
'end'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(48010110829331087)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Page Number'
,p_lov_return_value=>'PAGE NUMBER'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case :APP_PAGE_ID',
'  when ''4410'' then :P4410_PLUGIN_TYPE != ''TEMPLATE COMPONENT''',
'  when ''4415'' then :P4415_PLUGIN_TYPE != ''TEMPLATE COMPONENT''',
'end'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(48406119103097620)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'PL/SQL Expression Returning VARCHAR2'
,p_lov_return_value=>'PLSQL EXPRESSION'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case :APP_PAGE_ID',
'  when ''4410'' then :P4410_PLUGIN_TYPE != ''TEMPLATE COMPONENT''',
'  when ''4415'' then :P4415_PLUGIN_TYPE != ''TEMPLATE COMPONENT''',
'end'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(361900618419930085)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Page Numbers'
,p_lov_return_value=>'PAGE NUMBERS'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case :APP_PAGE_ID',
'  when ''4410'' then :P4410_PLUGIN_TYPE != ''TEMPLATE COMPONENT''',
'  when ''4415'' then :P4415_PLUGIN_TYPE != ''TEMPLATE COMPONENT''',
'end'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(362599722274410565)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Owner'
,p_lov_return_value=>'OWNER'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'WORKSPACE_ID'
,p_lov_disp_cond2=>'10'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(362600020118411553)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Table'
,p_lov_return_value=>'TABLE'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'WORKSPACE_ID'
,p_lov_disp_cond2=>'10'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(362600317314412921)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Column'
,p_lov_return_value=>'COLUMN'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'WORKSPACE_ID'
,p_lov_disp_cond2=>'10'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(381665885535326362)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Link to Target Page/URL'
,p_lov_return_value=>'LINK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(428534230926850149)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'PL/SQL Function Body Returning VARCHAR2'
,p_lov_return_value=>'PLSQL FUNCTION BODY'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case :APP_PAGE_ID',
'  when ''4410'' then :P4410_PLUGIN_TYPE != ''TEMPLATE COMPONENT''',
'  when ''4415'' then :P4415_PLUGIN_TYPE != ''TEMPLATE COMPONENT''',
'end'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(452899578203741582)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'JavaScript Code'
,p_lov_return_value=>'JAVASCRIPT'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case :APP_PAGE_ID',
'  when ''4410'' then :P4410_PLUGIN_TYPE != ''TEMPLATE COMPONENT''',
'  when ''4415'' then :P4415_PLUGIN_TYPE != ''TEMPLATE COMPONENT''',
'end'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(671170332524876191)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Data Load Table ID'
,p_lov_return_value=>'DATA LOAD TABLE ID'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'FB_FLOW_ID'
,p_lov_disp_cond2=>'4411'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1480587753813774720)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Color'
,p_lov_return_value=>'COLOR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1480588039301781153)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'HTML'
,p_lov_return_value=>'HTML'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1480588346234783062)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Icon'
,p_lov_return_value=>'ICON'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1480588694006809077)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'PL/SQL Expression Returning BOOLEAN'
,p_lov_return_value=>'PLSQL EXPRESSION BOOLEAN'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case :APP_PAGE_ID',
'  when ''4410'' then :P4410_PLUGIN_TYPE != ''TEMPLATE COMPONENT''',
'  when ''4415'' then :P4415_PLUGIN_TYPE != ''TEMPLATE COMPONENT''',
'end'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1480589799621825268)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'PL/SQL Function Body Returning BOOLEAN'
,p_lov_return_value=>'PLSQL FUNCTION BODY BOOLEAN'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case :APP_PAGE_ID',
'  when ''4410'' then :P4410_PLUGIN_TYPE != ''TEMPLATE COMPONENT''',
'  when ''4415'' then :P4415_PLUGIN_TYPE != ''TEMPLATE COMPONENT''',
'end'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1480590833192849865)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'XML'
,p_lov_return_value=>'XML'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case :APP_PAGE_ID',
'  when ''4410'' then :P4410_PLUGIN_TYPE != ''TEMPLATE COMPONENT''',
'  when ''4415'' then :P4415_PLUGIN_TYPE != ''TEMPLATE COMPONENT''',
'end'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1568894080086807607)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Authorization Groups'
,p_lov_return_value=>'AUTHORIZATION GROUPS'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'FB_FLOW_ID'
,p_lov_disp_cond2=>'4411'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(225313893310167436)
,p_lov_disp_sequence=>21
,p_lov_disp_value=>'Credentials'
,p_lov_return_value=>'CREDENTIAL ID'
,p_lov_disp_cond_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_lov_disp_cond=>'FB_FLOW_ID'
,p_lov_disp_cond2=>'4411:4050'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2600591329258094)
,p_lov_disp_sequence=>31
,p_lov_disp_value=>'Template Placeholders'
,p_lov_return_value=>'PLACEHOLDER JSON'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'FB_FLOW_ID'
,p_lov_disp_cond2=>'4411'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2148733317792129)
,p_lov_disp_sequence=>41
,p_lov_disp_value=>'Map Background'
,p_lov_return_value=>'MAP BACKGROUND ID'
,p_lov_disp_cond_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_lov_disp_cond=>'FB_FLOW_ID'
,p_lov_disp_cond2=>'4411'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(169146271729841198)
,p_lov_disp_sequence=>51
,p_lov_disp_value=>'Workflow'
,p_lov_return_value=>'WORKFLOW ID'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'FB_FLOW_ID'
,p_lov_disp_cond2=>'4411'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1416351771338524)
,p_lov_disp_sequence=>61
,p_lov_disp_value=>'Report Query'
,p_lov_return_value=>'REPORT QUERY ID'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'FB_FLOW_ID'
,p_lov_disp_cond2=>'4411'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_authentication_attributes
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(332110302021701175)
,p_lov_name=>'PLUGIN.AUTHENTICATION_ATTRIBUTES'
,p_lov_query=>'.'||wwv_flow_imp.id(332110302021701175)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475265
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(332112222407701179)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Has Session not Valid Attribute'
,p_lov_return_value=>'INVALID_SESSION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1448982795495050063)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Has Login Page In Application'
,p_lov_return_value=>'LOGIN_PAGE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_category
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(626799404677287430)
,p_lov_name=>'PLUGIN.CATEGORY'
,p_lov_query=>'.'||wwv_flow_imp.id(626799404677287430)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475266
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3788202634702)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Navigation'
,p_lov_return_value=>'NAVIGATION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(626799631439287435)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Style'
,p_lov_return_value=>'STYLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(626799816855287438)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Miscellaneous'
,p_lov_return_value=>'MISC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(626800015856287439)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Effect'
,p_lov_return_value=>'EFFECT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(626800225391287439)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Notification'
,p_lov_return_value=>'NOTIFICATION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(626800411496287439)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Execute'
,p_lov_return_value=>'EXECUTE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(626800619508287439)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Component'
,p_lov_return_value=>'COMPONENT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(626808308823562993)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Initialize'
,p_lov_return_value=>'INIT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_dynamic_action_attributes
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(439399613733990280)
,p_lov_name=>'PLUGIN.DYNAMIC_ACTION_ATTRIBUTES'
,p_lov_query=>'.'||wwv_flow_imp.id(439399613733990280)||'.'
,p_location=>'STATIC'
,p_version_scn=>130221658
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(439399829752990280)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'For Item(s)'
,p_lov_return_value=>'ITEM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(206181812441168171)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'For Button'
,p_lov_return_value=>'BUTTON'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(439400021759990284)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'For Region'
,p_lov_return_value=>'REGION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(439401323346011992)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'For jQuery Selector'
,p_lov_return_value=>'JQUERY_SELECTOR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(855920777887326142)
,p_lov_disp_sequence=>42
,p_lov_disp_value=>'For JavaScript Expression'
,p_lov_return_value=>'JAVASCRIPT_EXPRESSION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(623898502368610777)
,p_lov_disp_sequence=>45
,p_lov_disp_value=>'For Triggering Element'
,p_lov_return_value=>'TRIGGERING_ELEMENT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(623898707908612350)
,p_lov_disp_sequence=>47
,p_lov_disp_value=>'For Event Source'
,p_lov_return_value=>'EVENT_SOURCE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(439490210997742654)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Affected Element Required'
,p_lov_return_value=>'REQUIRED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(439490428658747711)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Check "Fire on Initialization"'
,p_lov_return_value=>'ONLOAD'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(439401513087018475)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Has "Stop Execution on Error" Attribute'
,p_lov_return_value=>'STOP_EXECUTION_ON_ERROR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23170927204051838)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Has "Wait For Result" Attribute'
,p_lov_return_value=>'WAIT_FOR_RESULT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(835398202170249455)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'Has "Initialization JavaScript Code" Attribute'
,p_lov_return_value=>'INIT_JAVASCRIPT_CODE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2001534766421336)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'AI Enabled'
,p_lov_return_value=>'AI_ENABLED_ALWAYS'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':WORKSPACE_ID = 10'
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2001051171415727)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'Configurable "AI Enabled"'
,p_lov_return_value=>'AI_ENABLED'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':WORKSPACE_ID = 10'
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2001827519425010)
,p_lov_disp_sequence=>130
,p_lov_disp_value=>'Configurable "AI System Prompt"'
,p_lov_return_value=>'AI_SYSTEM_PROMPT'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':WORKSPACE_ID = 10'
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2002124384426973)
,p_lov_disp_sequence=>140
,p_lov_disp_value=>'Configurable "AI Welcome Message"'
,p_lov_return_value=>'AI_WELCOME_MESSAGE'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':WORKSPACE_ID = 10'
,p_lov_disp_cond2=>'PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_escape_mode
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2201509320945428)
,p_lov_name=>'PLUGIN.ESCAPE_MODE'
,p_lov_query=>'.'||wwv_flow_imp.id(2201509320945428)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475267
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2201892772945448)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'HTML'
,p_lov_return_value=>'HTML'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2202212872945449)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'HTML Attribute'
,p_lov_return_value=>'ATTR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2202655181945450)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Strip HTML'
,p_lov_return_value=>'STRIPHTML'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2203055201945450)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Raw'
,p_lov_return_value=>'RAW'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2203470313945450)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'JavaScript'
,p_lov_return_value=>'JS'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2203809815945450)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'JSON'
,p_lov_return_value=>'JSON'
,p_lov_disp_cond_type=>'NEVER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_item_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(27295207392317233)
,p_lov_name=>'PLUGIN.ITEM TYPES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(display_name) as d,',
'       ''PLUGIN_'' || name as r',
'  from wwv_flow_plugins',
' where flow_id           = to_number(:FB_FLOW_ID)',
'   and security_group_id = to_number(:WORKSPACE_ID)',
'   and plugin_type       = ''ITEM TYPE''',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475267
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_item_attributes
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(439387913761867364)
,p_lov_name=>'PLUGIN.ITEM_ATTRIBUTES'
,p_lov_query=>'.'||wwv_flow_imp.id(439387913761867364)||'.'
,p_location=>'STATIC'
,p_version_scn=>130221139
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(439388100102867367)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Is Visible Widget'
,p_lov_return_value=>'VISIBLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1426966529506570479)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Standard Form Element'
,p_lov_return_value=>'FORM_ELEMENT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(439388310531867374)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Session State Changeable'
,p_lov_return_value=>'SESSION_STATE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(441070411568686266)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Has Read Only Attribute'
,p_lov_return_value=>'READONLY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(439389300381867375)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Has Escape Special Characters Attribute'
,p_lov_return_value=>'ESCAPE_OUTPUT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(439389107985867375)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Has Quick Pick Attributes'
,p_lov_return_value=>'QUICKPICK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(441062726095189003)
,p_lov_disp_sequence=>22
,p_lov_disp_value=>'Has Source Attributes'
,p_lov_return_value=>'SOURCE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(441950109070290537)
,p_lov_disp_sequence=>25
,p_lov_disp_value=>'Format Mask Date Only'
,p_lov_return_value=>'FORMAT_MASK_DATE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(441963709603404191)
,p_lov_disp_sequence=>27
,p_lov_disp_value=>'Format Mask Number Only'
,p_lov_return_value=>'FORMAT_MASK_NUMBER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(442053408974983944)
,p_lov_disp_sequence=>32
,p_lov_disp_value=>'Has Element Attributes'
,p_lov_return_value=>'ELEMENT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(441379627757227124)
,p_lov_disp_sequence=>35
,p_lov_disp_value=>'Has Width Attributes'
,p_lov_return_value=>'WIDTH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(439388531474867374)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Has Height Attribute'
,p_lov_return_value=>'HEIGHT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(445142109307930388)
,p_lov_disp_sequence=>55
,p_lov_disp_value=>'Has Element Option Attribute'
,p_lov_return_value=>'ELEMENT_OPTION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2972426563463903)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Has Placeholder Attribute'
,p_lov_return_value=>'PLACEHOLDER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(656826758503014879)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Has Icon Attribute'
,p_lov_return_value=>'ICON'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(441292332046487512)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Has Encrypt Session State Attribute'
,p_lov_return_value=>'ENCRYPT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(439388725246867374)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'Has List of Values'
,p_lov_return_value=>'LOV'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(445130924273840076)
,p_lov_disp_sequence=>115
,p_lov_disp_value=>'Has LOV Display Null Attributes'
,p_lov_return_value=>'LOV_DISPLAY_NULL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(455253123560548840)
,p_lov_disp_sequence=>117
,p_lov_disp_value=>'Has Cascading LOV Attributes'
,p_lov_return_value=>'CASCADING_LOV'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(649667573866335830)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'Join LOV for Column Display'
,p_lov_return_value=>'JOIN_LOV'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1915746651405908)
,p_lov_disp_sequence=>121
,p_lov_disp_value=>'Optional Multiple Values'
,p_lov_return_value=>'MULTI_VALUE_OPTIONAL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1916125920405909)
,p_lov_disp_sequence=>122
,p_lov_disp_value=>'Always Multiple Values'
,p_lov_return_value=>'MULTI_VALUE_ALWAYS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(253162868502236618)
,p_lov_disp_sequence=>127
,p_lov_disp_value=>'Has Filter'
,p_lov_return_value=>'FILTER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(253163140954237733)
,p_lov_disp_sequence=>137
,p_lov_disp_value=>'Has Link'
,p_lov_return_value=>'LINK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(835397432361242933)
,p_lov_disp_sequence=>150
,p_lov_disp_value=>'Has "Initialization JavaScript Code" Attribute'
,p_lov_return_value=>'INIT_JAVASCRIPT_CODE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1701648455686548)
,p_lov_disp_sequence=>155
,p_lov_disp_value=>'Session State Supports CLOB'
,p_lov_return_value=>'SESSION_STATE_CLOB'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2508829793665868)
,p_lov_disp_sequence=>160
,p_lov_disp_value=>'Facet: Gather Occurrences'
,p_lov_return_value=>'FC_HAS_FEEDBACK'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':WORKSPACE_ID = 10'
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2509174100671781)
,p_lov_disp_sequence=>170
,p_lov_disp_value=>'Facet: Show Selected First'
,p_lov_return_value=>'FC_SHOW_SELECTED_FIRST'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':WORKSPACE_ID = 10'
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2509475818676107)
,p_lov_disp_sequence=>180
,p_lov_disp_value=>'Facet: Maximum Displayed Entries'
,p_lov_return_value=>'FC_SHOW_MORE_COUNT'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':WORKSPACE_ID = 10'
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2509782310680033)
,p_lov_disp_sequence=>190
,p_lov_disp_value=>'Facet: Client-Side Filtering'
,p_lov_return_value=>'FC_FILTER_VALUES'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':WORKSPACE_ID = 10'
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(598133888019449803)
,p_lov_disp_sequence=>200
,p_lov_disp_value=>'Facet: LOV Display Null Value'
,p_lov_return_value=>'FC_LOV_DISPLAY_NULL'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':WORKSPACE_ID = 10'
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3519087052887913)
,p_lov_disp_sequence=>210
,p_lov_disp_value=>'AI Enabled'
,p_lov_return_value=>'AI_ENABLED_ALWAYS'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':WORKSPACE_ID = 10'
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2232460948300009)
,p_lov_disp_sequence=>220
,p_lov_disp_value=>'Configurable "AI Enabled"'
,p_lov_return_value=>'AI_ENABLED'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':WORKSPACE_ID = 10'
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2232746725294852)
,p_lov_disp_sequence=>230
,p_lov_disp_value=>'Configurable "AI System Prompt"'
,p_lov_return_value=>'AI_SYSTEM_PROMPT'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':WORKSPACE_ID = 10'
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2233016773292653)
,p_lov_disp_sequence=>240
,p_lov_disp_value=>'Configurable "AI Welcome Message"'
,p_lov_return_value=>'AI_WELCOME_MESSAGE'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':WORKSPACE_ID = 10'
,p_lov_disp_cond2=>'PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_process_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(471074120618926840)
,p_lov_name=>'PLUGIN.PROCESS TYPES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name    as d,',
'       ''PLUGIN_''||name as r',
'  from wwv_flow_plugins',
' where flow_id           = to_number(:FB_FLOW_ID)',
'   and security_group_id = to_number(:WORKSPACE_ID)',
'   and plugin_type       = ''PROCESS TYPE''',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475267
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_process_attributes
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(366693502933776161)
,p_lov_name=>'PLUGIN.PROCESS_ATTRIBUTES'
,p_lov_query=>'.'||wwv_flow_imp.id(366693502933776161)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475267
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(366693829534776162)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Region'
,p_lov_return_value=>'REGION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(366694131496776164)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Region Required'
,p_lov_return_value=>'REGION_REQUIRED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(5600324782619199)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Wait for Completion'
,p_lov_return_value=>'WAIT_FOR_COMPLETION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_region_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(33181601315857917)
,p_lov_name=>'PLUGIN.REGION TYPES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name    as d,',
'       ''PLUGIN_''||name as r',
'  from wwv_flow_plugins',
' where flow_id           = to_number(:FB_FLOW_ID)',
'   and security_group_id = to_number(:WORKSPACE_ID)',
'   and plugin_type       = ''REGION TYPE''',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475267
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_region_attributes
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(439394121736945367)
,p_lov_name=>'PLUGIN.REGION_ATTRIBUTES'
,p_lov_query=>'.'||wwv_flow_imp.id(439394121736945367)||'.'
,p_location=>'STATIC'
,p_version_scn=>130221470
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(153189234261472126)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Region Source supports different Data Sources'
,p_lov_return_value=>'SOURCE_LOCATION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(439395528858945372)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Region Source is SQL Statement [Deprecated]'
,p_lov_return_value=>'SOURCE_SQL'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'   ( :APP_PAGE_ID = 4410 and :P4410_REGION_ATTRIBUTES like ''%SOURCE_SQL%'' )',
'or ( :APP_PAGE_ID = 4411 and :P4411_NAME like ''%SOURCE_SQL%'' )'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(384618513952478181)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Region Source is PL/SQL Statement'
,p_lov_return_value=>'SOURCE_PLSQL'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'WORKSPACE_ID'
,p_lov_disp_cond2=>'10'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(384618889206489831)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Region Source is PL/SQL Function Body [Deprecated]'
,p_lov_return_value=>'SOURCE_PLSQL_FUNCTION'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    :WORKSPACE_ID = 10',
'and (  ( :APP_PAGE_ID = 4410 and :P4410_REGION_ATTRIBUTES like ''%SOURCE_PLSQL_FUNCTION%'' )',
'    or ( :APP_PAGE_ID = 4411 and :P4411_NAME like ''%SOURCE_PLSQL_FUNCTION%'' )',
'    )'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(385143330920680664)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Region Source is HTML'
,p_lov_return_value=>'SOURCE_HTML'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'WORKSPACE_ID'
,p_lov_disp_cond2=>'10'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(439436520368796393)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Region Source is Plain Text'
,p_lov_return_value=>'SOURCE_PLAIN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(18432507772059146)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Has "Page Items to Submit" Attribute'
,p_lov_return_value=>'AJAX_ITEMS_TO_SUBMIT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2701499867764460)
,p_lov_disp_sequence=>32
,p_lov_disp_value=>'Has "Order By" Attribute'
,p_lov_return_value=>'ORDER_BY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(21670917336024482)
,p_lov_disp_sequence=>35
,p_lov_disp_value=>'Has "Number of Fetched Rows" Attribute'
,p_lov_return_value=>'FETCHED_ROWS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(22580629800196411)
,p_lov_disp_sequence=>37
,p_lov_disp_value=>'Has "No Data Found Message" Attribute'
,p_lov_return_value=>'NO_DATA_FOUND_MESSAGE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(18419625995054930)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Has "Escape Special Characters" Region Attribute'
,p_lov_return_value=>'ESCAPE_OUTPUT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(835394704716201109)
,p_lov_disp_sequence=>45
,p_lov_disp_value=>'Has "Initialization JavaScript Code" Attribute'
,p_lov_return_value=>'INIT_JAVASCRIPT_CODE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(548119689276281859)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Has "Region Columns"'
,p_lov_return_value=>'COLUMNS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(548987824966885830)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Has "Heading" Column Attribute'
,p_lov_return_value=>'COLUMN_HEADING'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(548989786890952346)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Has "Heading Alignment" Column Attribute'
,p_lov_return_value=>'HEADING_ALIGNMENT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(548990018583954291)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Has "Alignment" Column Attribute'
,p_lov_return_value=>'VALUE_ALIGNMENT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(548990319028956610)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'Has "CSS Class" Column Attribute'
,p_lov_return_value=>'VALUE_CSS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(548990626095958042)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'Has "Custom Attributes" Column Attribute'
,p_lov_return_value=>'VALUE_ATTRIBUTE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(548990943632960667)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'Has "Escape Special Characters" Column Attribute'
,p_lov_return_value=>'VALUE_ESCAPE_OUTPUT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1710553891306750)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'Supports Faceted Search / Smart Filters'
,p_lov_return_value=>'SUPPORTS_EXTERNAL_FILTERING'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3520913701873092)
,p_lov_disp_sequence=>130
,p_lov_disp_value=>'AI Enabled'
,p_lov_return_value=>'AI_ENABLED_ALWAYS'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':WORKSPACE_ID = 10'
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1412532447275680)
,p_lov_disp_sequence=>140
,p_lov_disp_value=>'Configurable "AI Enabled"'
,p_lov_return_value=>'AI_ENABLED'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':WORKSPACE_ID = 10'
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1412876867273677)
,p_lov_disp_sequence=>150
,p_lov_disp_value=>'Configurable "AI System Prompt"'
,p_lov_return_value=>'AI_SYSTEM_PROMPT'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':WORKSPACE_ID = 10'
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1413169073271857)
,p_lov_disp_sequence=>160
,p_lov_disp_value=>'Configurable "AI Welcome Message"'
,p_lov_return_value=>'AI_WELCOME_MESSAGE'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':WORKSPACE_ID = 10'
,p_lov_disp_cond2=>'PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_template_component_attributes
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1800908936730547)
,p_lov_name=>'PLUGIN.TEMPLATE_COMPONENT_ATTRIBUTES'
,p_lov_query=>'.'||wwv_flow_imp.id(1800908936730547)||'.'
,p_location=>'STATIC'
,p_version_scn=>109146569
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1801273105730571)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Has Row Selection Support'
,p_lov_return_value=>'ROW_SELECTION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3000235986400628)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Has Region Template Attribute'
,p_lov_return_value=>'REGION_TEMPLATE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(32850007287563326)
,p_lov_name=>'PLUGIN.TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(32850007287563326)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475267
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1203035157777517)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'REST Data Source'
,p_lov_return_value=>'WEB SOURCE TYPE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2000844658461080)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Template Component'
,p_lov_return_value=>'TEMPLATE COMPONENT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(10801624058272206)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Authorization Scheme Type'
,p_lov_return_value=>'AUTHORIZATION TYPE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(32850301282563333)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Region'
,p_lov_return_value=>'REGION TYPE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(32850532265563335)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Item'
,p_lov_return_value=>'ITEM TYPE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(34962508350286283)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Dynamic Action'
,p_lov_return_value=>'DYNAMIC ACTION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(185355615983053829)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Report Column'
,p_lov_return_value=>'REPORT COLUMN TYPE'
,p_required_patch=>wwv_flow_imp.id(170786031904296885)
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(331855316556629721)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Authentication Scheme Type'
,p_lov_return_value=>'AUTHENTICATION TYPE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(471054818560027488)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Process'
,p_lov_return_value=>'PROCESS TYPE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(20600528671574343)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Interactive Report Column'
,p_lov_return_value=>'IR COLUMN'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'FB_FLOW_ID'
,p_lov_disp_cond2=>'4411'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_web_source_attributes
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1416444037632936)
,p_lov_name=>'PLUGIN.WEB_SOURCE_ATTRIBUTES'
,p_lov_query=>'.'||wwv_flow_imp.id(1416444037632936)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475267
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1416731728632988)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Default Endpoint'
,p_lov_return_value=>'ENDPOINT_HINT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2215118159433749)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Do Not Test Endpoint'
,p_lov_return_value=>'NO_TEST_ENDPOINT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pluginpagetypes
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(393518083752056962)
,p_lov_name=>'PLUGINPAGETYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(393518083752056962)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475267
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(393518374793056965)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CSS Calebdar'
,p_lov_return_value=>'NATIVE_CSS_CALENDAR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(393518647212056970)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'List View'
,p_lov_return_value=>'NATIVE_JQM_LIST_VIEW'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(393518972587056970)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Responsive Table'
,p_lov_return_value=>'NATIVE_JQM_RESPONSIVE_TABLE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugins
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(30477426464330230)
,p_lov_name=>'PLUGINS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name as d,',
'       id           as r',
'  from wwv_flow_plugins',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
' order by display_name'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475267
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_api_version_item
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2202155239931633)
,p_lov_name=>'PLUGIN_API_VERSION_ITEM'
,p_lov_query=>'.'||wwv_flow_imp.id(2202155239931633)||'.'
,p_location=>'STATIC'
,p_version_scn=>96857534
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2202491428931633)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Procedure'
,p_lov_return_value=>'2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2202805117931633)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Function [deprecated]'
,p_lov_return_value=>'1'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_api_version_region
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2201166487924678)
,p_lov_name=>'PLUGIN_API_VERSION_REGION'
,p_lov_query=>'.'||wwv_flow_imp.id(2201166487924678)||'.'
,p_location=>'STATIC'
,p_version_scn=>96857598
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2201431722924691)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Procedure'
,p_lov_return_value=>'3'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2201841328924692)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Function [deprecated]'
,p_lov_return_value=>'1'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_attribute_lov_on_delete
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(361908530213065178)
,p_lov_name=>'PLUGIN_ATTRIBUTE_LOV_ON_DELETE'
,p_lov_query=>'.'||wwv_flow_imp.id(361908530213065178)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475267
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(361908726901065178)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Cascade'
,p_lov_return_value=>'WEAK_CASCADE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(361909027322065178)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Set to NULL'
,p_lov_return_value=>'WEAK_NULL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_attribute_lov_scope
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(361909922032072224)
,p_lov_name=>'PLUGIN_ATTRIBUTE_LOV_SCOPE'
,p_lov_query=>'.'||wwv_flow_imp.id(361909922032072224)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475267
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(361910110952072224)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Current Page'
,p_lov_return_value=>'PAGE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(361910432729072225)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Current Page and Global Page'
,p_lov_return_value=>'PAGE_AND_GLOBAL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(361910726090072225)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Within Parent Component'
,p_lov_return_value=>'PARENT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(361911031653072225)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Current Theme'
,p_lov_return_value=>'THEME'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_attribute_lov_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(361905807263001770)
,p_lov_name=>'PLUGIN_ATTRIBUTE_LOV_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(361905807263001770)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475267
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(361906028094001770)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Static'
,p_lov_return_value=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(361906321494001771)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Component'
,p_lov_return_value=>'COMPONENT'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'WORKSPACE_ID'
,p_lov_disp_cond2=>'10'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_attribute_set_text_case
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(361901313057946615)
,p_lov_name=>'PLUGIN_ATTRIBUTE_SET_TEXT_CASE'
,p_lov_query=>'.'||wwv_flow_imp.id(361901313057946615)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475268
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(361901512487946618)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Uppercase'
,p_lov_return_value=>'UPPER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(361901832142946620)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Lowercase'
,p_lov_return_value=>'LOWER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_item_type_component_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(513667640463524657)
,p_lov_name=>'PLUGIN_ITEM_TYPE_COMPONENT_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(513667640463524657)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475268
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(513667952736524660)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Page Items'
,p_lov_return_value=>'APEX_APPLICATION_PAGE_ITEMS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(513668320889524662)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Interactive Grid Columns'
,p_lov_return_value=>'APEX_APPL_PAGE_IG_COLUMNS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2000801925703610)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Facets'
,p_lov_return_value=>'APEX_APPL_PAGE_FACETS'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'WORKSPACE_ID'
,p_lov_disp_cond2=>'10'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2000867299582467)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Facet Group Items'
,p_lov_return_value=>'APEX_APPL_PAGE_FACET_GRP_ITEMS'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'WORKSPACE_ID'
,p_lov_disp_cond2=>'10'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2200783911728139)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Filters'
,p_lov_return_value=>'APEX_APPL_PAGE_SFILTERS'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'WORKSPACE_ID'
,p_lov_disp_cond2=>'10'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2201027090728164)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Filter Group Items'
,p_lov_return_value=>'APEX_APPL_PAGE_SFILTER_GRP_ITEMS'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'WORKSPACE_ID'
,p_lov_disp_cond2=>'10'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_process_type_component_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1800185422847060)
,p_lov_name=>'PLUGIN_PROCESS_TYPE_COMPONENT_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(1800185422847060)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475268
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1800462806847098)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Page Processes'
,p_lov_return_value=>'APEX_APPLICATION_PAGE_PROC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1800841216847099)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Automation Actions'
,p_lov_return_value=>'APEX_APPL_AUTOMATION_ACTIONS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1547434233223408)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Task Definition Actions'
,p_lov_return_value=>'APEX_APPL_TASKDEF_ACTIONS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1502751432873613)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Workflow Activities'
,p_lov_return_value=>'APEX_APPL_WORKFLOW_ACTIVITIES'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plugin_template_component_component_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(8409910097232187)
,p_lov_name=>'PLUGIN_TEMPLATE_COMPONENT_COMPONENT_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(8409910097232187)||'.'
,p_location=>'STATIC'
,p_version_scn=>107105877
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(8410207516232194)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Single (Partial)'
,p_lov_return_value=>'PARTIAL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1452091726486876)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Multiple (Report)'
,p_lov_return_value=>'REPORT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1909417849977550)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Region Only'
,p_lov_return_value=>'REGION_ONLY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plug_chart_axis_002
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84331708594618216)
,p_lov_name=>'PLUG_CHART_AXIS'
,p_lov_query=>'.'||wwv_flow_imp.id(84331708594618216)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475268
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84331906767618217)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Average Value in Series'
,p_lov_return_value=>'AVG'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84332132650618217)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'First Value in Series'
,p_lov_return_value=>'FIRST'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84332309505618218)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Last Value in Series'
,p_lov_return_value=>'LAST'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84332528115618218)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Maximum Value in Series'
,p_lov_return_value=>'MAX'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84332710962618218)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Minimum Value in Series'
,p_lov_return_value=>'MIN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84332909633618218)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Zero'
,p_lov_return_value=>'ZERO'
);
end;
/
prompt --application/shared_components/user_interface/lovs/plug_chart_font_size
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84691009705624527)
,p_lov_name=>'PLUG_CHART_FONT_SIZE'
,p_lov_query=>'.'||wwv_flow_imp.id(84691009705624527)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475270
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84691205352624528)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'-3'
,p_lov_return_value=>'-3'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84691410423624528)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'-2'
,p_lov_return_value=>'-2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84691626959624528)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'-1'
,p_lov_return_value=>'-1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84691800905624529)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'+0'
,p_lov_return_value=>'+0'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84692006310624529)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'+1'
,p_lov_return_value=>'+1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84692221772624529)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'+2'
,p_lov_return_value=>'+2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84692428366624529)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'+3'
,p_lov_return_value=>'+3'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84692607861624530)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'+4'
,p_lov_return_value=>'+4'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84692824991624530)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'+5'
,p_lov_return_value=>'+5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84693026747624530)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'+6'
,p_lov_return_value=>'+6'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84693202667624530)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'+7'
,p_lov_return_value=>'+7'
);
end;
/
prompt --application/shared_components/user_interface/lovs/popup_lov_template_theme_class_id
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(59418530750879398)
,p_lov_name=>'POPUP LOV TEMPLATE THEME CLASS ID'
,p_lov_query=>'.'||wwv_flow_imp.id(59418530750879398)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475270
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(59418812008879404)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Standard'
,p_lov_return_value=>'1'
);
end;
/
prompt --application/shared_components/user_interface/lovs/popup_table_finder_view_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(171249216657727210)
,p_lov_name=>'POPUP TABLE FINDER VIEW OPTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(171249216657727210)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475270
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(171249406596727214)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Tables and Views'
,p_lov_return_value=>'TABLES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(171249600269727216)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Selected Table Columns'
,p_lov_return_value=>'COLUMNS'
,p_lov_disp_cond_type=>'ITEM_IS_NOT_NULL'
,p_lov_disp_cond=>'P514_TABLE_NAME'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(171249804476727216)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Query on Selected Table'
,p_lov_return_value=>'QUERY'
,p_lov_disp_cond_type=>'ITEM_IS_NOT_NULL'
,p_lov_disp_cond=>'P514_TABLE_NAME'
);
end;
/
prompt --application/shared_components/user_interface/lovs/preserve_case_y
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(215454417816546080)
,p_lov_name=>'PRESERVE.CASE.Y'
,p_lov_query=>'.'||wwv_flow_imp.id(215454417816546080)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475270
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(215454707655546082)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Preserve Case'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/prez
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84371212244732793)
,p_lov_name=>'PREZ'
,p_lov_query=>'.'||wwv_flow_imp.id(84371212244732793)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475270
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84371421765732793)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'George W. Bush'
,p_lov_return_value=>'gwbush.jpg'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84371617057732794)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Bill Clinton'
,p_lov_return_value=>'clinton.jpg'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84371811280732794)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'George Washington'
,p_lov_return_value=>'washington.gif'
);
end;
/
prompt --application/shared_components/user_interface/lovs/primary_key_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(11186021931343531)
,p_lov_name=>'PRIMARY_KEY_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(11186021931343531)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475270
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(11186317316343531)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Managed by Database (ROWID)'
,p_lov_return_value=>'ROWID'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(11186522675343532)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Select Primary Key Column(s)'
,p_lov_return_value=>'PKCOLS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/primary_key_type_calendar
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(623711109271847205)
,p_lov_name=>'PRIMARY_KEY_TYPE_CALENDAR'
,p_lov_query=>'.'||wwv_flow_imp.id(623711109271847205)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475270
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(623711411862847210)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Managed by Database (ROWID)'
,p_lov_return_value=>'ROWID'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(623711613430847214)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Select Primary Key Column'
,p_lov_return_value=>'PKCOLS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/printer_friendly
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(148325219515185885)
,p_lov_name=>'PRINTER_FRIENDLY)'
,p_lov_query=>'.'||wwv_flow_imp.id(148325219515185885)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475270
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(148325416715185890)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Printer Friendly'
,p_lov_return_value=>'YES'
);
end;
/
prompt --application/shared_components/user_interface/lovs/print_att_include_link
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(57998911830398981)
,p_lov_name=>'PRINT_ATT_INCLUDE_LINK'
,p_lov_query=>'.'||wwv_flow_imp.id(57998911830398981)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475271
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(57999115213398981)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Yes'
,p_lov_return_value=>'Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(57999327144398981)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'No (manual link)'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/print_items
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(29642100479782966)
,p_lov_name=>'PRINT_ITEMS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name || '' ('' || t || '') '' d,name r from (',
'select name ,  j.t t, null prompt, to_number(NULL) p',
'from wwv_flow_items, (select wwv_flow_lang.system_message(''F4000.APPLICATION_ITEM'') t from dual) j',
'where  flow_id = :fb_flow_id',
'union all',
'select name , j.t t, prompt , flow_step_id p',
'from wwv_flow_step_items, (select wwv_flow_lang.system_message(''F4000.PAGE_ITEM'') t from dual) j',
'where flow_id = :fb_flow_id',
'order by 4 asc nulls first, 1 asc',
')'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475271
);
end;
/
prompt --application/shared_components/user_interface/lovs/print_server_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(6300179213172122)
,p_lov_name=>'PRINT_SERVER_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(6300179213172122)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475271
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(6300400826172138)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Oracle Analytics Publisher'
,p_lov_return_value=>'BIP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(6300856841172138)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'APEX Office Print'
,p_lov_return_value=>'AOP'
);
end;
/
prompt --application/shared_components/user_interface/lovs/prn_conditional_y_n
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(66513426858953865)
,p_lov_name=>'PRN_CONDITIONAL_Y_N'
,p_lov_query=>'.'||wwv_flow_imp.id(66513426858953865)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475271
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(66513706760953868)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Yes'
,p_lov_return_value=>'Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(66513908212953868)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'No'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/prn_fonts
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(14413827328266173)
,p_lov_name=>'PRN_FONTS'
,p_lov_query=>'.'||wwv_flow_imp.id(14413827328266173)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475271
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(14414108222266173)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Helvetica'
,p_lov_return_value=>'Helvetica'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(14414321991266173)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Times'
,p_lov_return_value=>'Times'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(14414502041266173)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Courier'
,p_lov_return_value=>'Courier'
);
end;
/
prompt --application/shared_components/user_interface/lovs/prn_font_weight
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(16555331301241275)
,p_lov_name=>'PRN_FONT_WEIGHT'
,p_lov_query=>'.'||wwv_flow_imp.id(16555331301241275)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475271
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16555620164241278)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Normal'
,p_lov_return_value=>'normal'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16555806266241278)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Bold'
,p_lov_return_value=>'bold'
);
end;
/
prompt --application/shared_components/user_interface/lovs/prn_format
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(16950902829395371)
,p_lov_name=>'PRN_FORMAT'
,p_lov_query=>'.'||wwv_flow_imp.id(16950902829395371)||'.'
,p_location=>'STATIC'
,p_version_scn=>79469309
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16951202412395371)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'PDF'
,p_lov_return_value=>'PDF'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16951406045395371)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Word'
,p_lov_return_value=>'RTF'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16951613265395371)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Excel'
,p_lov_return_value=>'XLS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16951828641395371)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'HTML'
,p_lov_return_value=>'HTM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(131706624505895733)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'XML'
,p_lov_return_value=>'XML'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_lov_disp_cond=>'F4000_PRINT_SERVER_TYPE'
,p_lov_disp_cond2=>'AOP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2714867588247378)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'Powerpoint'
,p_lov_return_value=>'PPTX'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'F4000_PRINT_SERVER_TYPE'
,p_lov_disp_cond2=>'AOP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2715168179249443)
,p_lov_disp_sequence=>25
,p_lov_disp_value=>'Markdown'
,p_lov_return_value=>'MARKDOWN'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'F4000_PRINT_SERVER_TYPE'
,p_lov_disp_cond2=>'AOP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2715471422251005)
,p_lov_disp_sequence=>35
,p_lov_disp_value=>'CSV'
,p_lov_return_value=>'CSV'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'F4000_PRINT_SERVER_TYPE'
,p_lov_disp_cond2=>'AOP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2715706778252676)
,p_lov_disp_sequence=>45
,p_lov_disp_value=>'Open Document Text'
,p_lov_return_value=>'ODT'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'F4000_PRINT_SERVER_TYPE'
,p_lov_disp_cond2=>'AOP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2716082504254592)
,p_lov_disp_sequence=>55
,p_lov_disp_value=>'Open Document Spreadsheet'
,p_lov_return_value=>'ODS'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'F4000_PRINT_SERVER_TYPE'
,p_lov_disp_cond2=>'AOP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2716311798258025)
,p_lov_disp_sequence=>65
,p_lov_disp_value=>'Open Document Presentation'
,p_lov_return_value=>'ODP'
,p_lov_disp_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_lov_disp_cond=>'F4000_PRINT_SERVER_TYPE'
,p_lov_disp_cond2=>'AOP'
);
end;
/
prompt --application/shared_components/user_interface/lovs/prn_page_orientation
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(14317429014888204)
,p_lov_name=>'PRN_PAGE_ORIENTATION'
,p_lov_query=>'.'||wwv_flow_imp.id(14317429014888204)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475276
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(14317704218888204)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Portrait'
,p_lov_return_value=>'VERTICAL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(14317927446888204)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Landscape'
,p_lov_return_value=>'HORIZONTAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/prn_page_units
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(14280128827774584)
,p_lov_name=>'PRN_PAGE_UNITS'
,p_lov_query=>'.'||wwv_flow_imp.id(14280128827774584)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475276
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(14280419832774585)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Points'
,p_lov_return_value=>'POINTS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(14280620486774585)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Inches'
,p_lov_return_value=>'INCHES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(14280802207774585)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Millimeters'
,p_lov_return_value=>'MILLIMETERS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(14281015797774585)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Centimeters'
,p_lov_return_value=>'CENTIMETERS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/prn_paper_size
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(14283929435793739)
,p_lov_name=>'PRN_PAPER_SIZE'
,p_lov_query=>'.'||wwv_flow_imp.id(14283929435793739)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475276
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(14284211408793739)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Custom'
,p_lov_return_value=>'CUSTOM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(14284428810793739)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Letter'
,p_lov_return_value=>'LETTER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(14284613426793739)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Legal'
,p_lov_return_value=>'LEGAL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(14284802250793739)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Tabloid'
,p_lov_return_value=>'TABLOID'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(14285022720793739)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'A4'
,p_lov_return_value=>'A4'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(14285218818793739)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'A3'
,p_lov_return_value=>'A3'
);
end;
/
prompt --application/shared_components/user_interface/lovs/process_error_display_location
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(4297030283172730)
,p_lov_name=>'PROCESS_ERROR_DISPLAY_LOCATION'
,p_lov_query=>'.'||wwv_flow_imp.id(4297030283172730)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475276
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4298230649172745)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Inline in Notification'
,p_lov_return_value=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4298418936172745)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'On Error Page'
,p_lov_return_value=>'ON_ERROR_PAGE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/process_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(362343527524601835)
,p_lov_name=>'PROCESS_TYPE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,',
'       r',
'  from (',
'        select display_name as d,',
'               name_with_prefix      as r',
'          from wwv_flow_native_plugins',
'         where plugin_type = ''PROCESS TYPE''',
'         union all',
'        select display_name || wwv_flow_lang.system_message(''PLUGIN.DISPLAY_NAME_POSTFIX'') as d,',
'               ''PLUGIN_'' || name     as r',
'          from wwv_flow_plugins',
'         where flow_id           = to_number(:FB_FLOW_ID)',
'           and security_group_id = to_number(:WORKSPACE_ID)',
'           and plugin_type       = ''PROCESS TYPE''',
'       )',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475276
);
end;
/
prompt --application/shared_components/user_interface/lovs/public_personal
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84916217834730025)
,p_lov_name=>'PUBLIC.PERSONAL'
,p_lov_query=>'.'||wwv_flow_imp.id(84916217834730025)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475276
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84916402749730026)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Personal'
,p_lov_return_value=>'PERSONAL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84916603755730026)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Public'
,p_lov_return_value=>'PUBLIC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/publish_application_id
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(167669830217852225)
,p_lov_name=>'PUBLISH APPLICATION ID'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000Lpubappid */ primary_language_flow_id||'' &gt;&gt; ''||translation_flow_id||'' (''||wwv_flow_escape.html(translation_flow_language_code)||'')'' d, ',
'       translation_flow_id r ',
'  from wwv_flow_language_map',
' where security_group_id = :flow_security_group_id',
'   and primary_language_flow_id = :FB_FLOW_ID',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475276
);
end;
/
prompt --application/shared_components/user_interface/lovs/publish_on_save
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(763360160878777085)
,p_lov_name=>'PUBLISH_ON_SAVE'
,p_lov_query=>'.'||wwv_flow_imp.id(763360160878777085)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475276
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(763360485051777149)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Publish on Save'
,p_lov_return_value=>'PUBLISH'
);
end;
/
prompt --application/shared_components/user_interface/lovs/purge_debug_age
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(624059001579304056)
,p_lov_name=>'PURGE_DEBUG_AGE'
,p_lov_query=>'.'||wwv_flow_imp.id(624059001579304056)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475276
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(624059225073304105)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'1 day'
,p_lov_return_value=>'1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(624059406874304105)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'2 days'
,p_lov_return_value=>'2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(624059604336304105)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'3 days'
,p_lov_return_value=>'3'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(624059807883304105)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'4 days'
,p_lov_return_value=>'4'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(624060031681304106)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'1 week'
,p_lov_return_value=>'7'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(624060212455304106)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'2 weeks'
,p_lov_return_value=>'14'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(624060427460304106)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'3 weeks'
,p_lov_return_value=>'21'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(624060618915304106)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'4 weeks'
,p_lov_return_value=>'28'
);
end;
/
prompt --application/shared_components/user_interface/lovs/purge_debug_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(624047408693069523)
,p_lov_name=>'PURGE_DEBUG_OPTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(624047408693069523)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475276
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(624047606508069524)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Purge all messages'
,p_lov_return_value=>'ALL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(624047819967069525)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Purge messages by age'
,p_lov_return_value=>'AGE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(624048000762069525)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Purge current session messages'
,p_lov_return_value=>'SESSION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(624048203677069525)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Purge by View Identifier'
,p_lov_return_value=>'IDENTIFIER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pwa_apple_status_bar_style
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(3776418597747042)
,p_lov_name=>'PWA_APPLE_STATUS_BAR_STYLE'
,p_lov_query=>'.'||wwv_flow_imp.id(3776418597747042)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475276
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3776765537747183)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Default'
,p_lov_return_value=>'default'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3777158697747184)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Black'
,p_lov_return_value=>'black'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3777588903747185)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Translucent'
,p_lov_return_value=>'black-translucent'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pwa_manifest_display
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1687503362489571)
,p_lov_name=>'PWA_MANIFEST_DISPLAY'
,p_lov_query=>'.'||wwv_flow_imp.id(1687503362489571)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475276
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1687842433489584)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Fullscreen'
,p_lov_return_value=>'fullscreen'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1688200412489585)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Standalone'
,p_lov_return_value=>'standalone'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1688659493489586)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Minimal UI'
,p_lov_return_value=>'minimal-ui'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1689030494489586)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Browser'
,p_lov_return_value=>'browser'
);
end;
/
prompt --application/shared_components/user_interface/lovs/pwa_manifest_orientation
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1689369179497016)
,p_lov_name=>'PWA_MANIFEST_ORIENTATION'
,p_lov_query=>'.'||wwv_flow_imp.id(1689369179497016)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475276
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1689618233497016)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Any'
,p_lov_return_value=>'any'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1690091857497016)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Natural'
,p_lov_return_value=>'natural'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1690479300497016)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Landscape'
,p_lov_return_value=>'landscape'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1690803540497017)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Landscape Primary'
,p_lov_return_value=>'landscape-primary'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1691278072497017)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Landscape Secondary'
,p_lov_return_value=>'landscape-secondary'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1691665400497017)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Portrait'
,p_lov_return_value=>'portrait'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1692030992497017)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Portrait Primary'
,p_lov_return_value=>'portrait-primary'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1692490290497017)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Portrait Secondary'
,p_lov_return_value=>'portrait-secondary'
);
end;
/
prompt --application/shared_components/user_interface/lovs/query_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84937920230853735)
,p_lov_name=>'QUERY.OPTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(84937920230853735)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475276
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84938130889853736)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Use Query-Specific Column Names and Validate Query'
,p_lov_return_value=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84938325410853736)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Use Generic Column Names (parse query at runtime only)'
,p_lov_return_value=>'GENERIC_REPORT_COLUMNS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/query_headings_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84301323392565701)
,p_lov_name=>'QUERY_HEADINGS_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(84301323392565701)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475276
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84301521685565702)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'Column Names'))
,p_lov_return_value=>'QUERY_COLUMNS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84301704281565702)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'Column Names (InitCap)'))
,p_lov_return_value=>'QUERY_COLUMNS_INITCAP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84301925334565702)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'Custom'))
,p_lov_return_value=>'COLON_DELMITED_LIST'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84302118859565703)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'PL/SQL'))
,p_lov_return_value=>'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84302301898565703)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'None'))
,p_lov_return_value=>'NO_HEADINGS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ras_dynamic_roles
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(360317412154680283)
,p_lov_name=>'RAS_DYNAMIC_ROLES'
,p_lov_query=>'select name n,name v from sys.dba_xs_dynamic_roles where system_defined=''NO'' order by 1'
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475276
);
end;
/
prompt --application/shared_components/user_interface/lovs/ras_namespace_templates
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(360317608272682130)
,p_lov_name=>'RAS_NAMESPACE_TEMPLATES'
,p_lov_query=>'select name n,name v from sys.dba_xs_ns_templates where name not like ''XS$%'' order by 1'
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475276
);
end;
/
prompt --application/shared_components/user_interface/lovs/read_only_condition_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(17050611946108603)
,p_lov_name=>'READ_ONLY_CONDITION_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(17050611946108603)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475276
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17050929764108615)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Exists (SQL query returns at least one row)'
,p_lov_return_value=>'EXISTS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17051100605108619)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'NOT Exists (SQL query returns no rows)'
,p_lov_return_value=>'NOT_EXISTS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17051511707108619)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Expression'
,p_lov_return_value=>'EXPRESSION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17051707362108619)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Function Body Returning a Boolean'
,p_lov_return_value=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17051923308108619)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Request = Expression 1&nbsp;'
,p_lov_return_value=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17052122488108620)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Request != Expression 1'
,p_lov_return_value=>'REQUEST_NOT_EQUAL_CONDITION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17052329069108620)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Request Is Contained within Expression 1&nbsp;'
,p_lov_return_value=>'REQUEST_IN_CONDITION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17052506526108622)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'Request Is NOT Contained within Expression 1&nbsp;'
,p_lov_return_value=>'REQUEST_NOT_IN_CONDITION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17052700466108622)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'Value of Item / Column in Expression 1 = Expression 2'
,p_lov_return_value=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17052913964108622)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'Value of Item / Column in Expression 1 != Expression 2'
,p_lov_return_value=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17053117063108622)
,p_lov_disp_sequence=>130
,p_lov_disp_value=>'Value of Item / Column in Expression 1 Is NULL'
,p_lov_return_value=>'ITEM_IS_NULL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17053331189108622)
,p_lov_disp_sequence=>140
,p_lov_disp_value=>'Value of Item / Column in Expression 1 Is NOT NULL'
,p_lov_return_value=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17053523987108622)
,p_lov_disp_sequence=>150
,p_lov_disp_value=>'Value of Item / Column in Expression 1 = Zero'
,p_lov_return_value=>'ITEM_IS_ZERO'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17053716908108622)
,p_lov_disp_sequence=>160
,p_lov_disp_value=>'Value of Item / Column in Expression 1 != Zero'
,p_lov_return_value=>'ITEM_IS_NOT_ZERO'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17053914469108622)
,p_lov_disp_sequence=>170
,p_lov_disp_value=>'Value of Item / Column in Expression 1 Is NULL or Zero'
,p_lov_return_value=>'ITEM_IS_NULL_OR_ZERO'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17054109879108622)
,p_lov_disp_sequence=>180
,p_lov_disp_value=>'Value of Item / Column in Expression 1 Is NOT null and the Item Is NOT Zero'
,p_lov_return_value=>'ITEM_NOT_NULL_OR_ZERO'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17054310717108623)
,p_lov_disp_sequence=>190
,p_lov_disp_value=>'Value of Item / Column in Expression 1 Contains No Spaces'
,p_lov_return_value=>'ITEM_CONTAINS_NO_SPACES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17054506909108623)
,p_lov_disp_sequence=>200
,p_lov_disp_value=>'Value of Item / Column in Expression 1 Is Numeric'
,p_lov_return_value=>'ITEM_IS_NUMERIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17054729773108623)
,p_lov_disp_sequence=>201
,p_lov_disp_value=>'Value of Item / Column in Expression 1 Is Not Numeric'
,p_lov_return_value=>'ITEM_IS_NOT_NUMERIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17054921234108623)
,p_lov_disp_sequence=>210
,p_lov_disp_value=>'Value of Item / Column in Expression 1 Is Alphanumeric'
,p_lov_return_value=>'ITEM_IS_ALPHANUMERIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17055116000108624)
,p_lov_disp_sequence=>220
,p_lov_disp_value=>'Value of Item / Column in Expression 1 Is Contained within Colon Delimited List in Expression 2'
,p_lov_return_value=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17055324881108624)
,p_lov_disp_sequence=>230
,p_lov_disp_value=>'Value of Item / Column in Expression 1 Is NOT Contained within Colon Delimited List in Expression 2'
,p_lov_return_value=>'VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17055526320108624)
,p_lov_disp_sequence=>240
,p_lov_disp_value=>'Value of User Preference in Expression 1 = Expression 2'
,p_lov_return_value=>'USER_PREF_IN_COND_EQ_COND2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17055716799108624)
,p_lov_disp_sequence=>250
,p_lov_disp_value=>'Value of User Preference in Expression 1 != Expression 2'
,p_lov_return_value=>'USER_PREF_IN_COND_NOT_EQ_COND2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17055919181108624)
,p_lov_disp_sequence=>260
,p_lov_disp_value=>'Current page = Expression 1'
,p_lov_return_value=>'CURRENT_PAGE_EQUALS_CONDITION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17056117265108624)
,p_lov_disp_sequence=>270
,p_lov_disp_value=>'Current page != Expression 1'
,p_lov_return_value=>'CURRENT_PAGE_NOT_EQUAL_CONDITION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17056315812108624)
,p_lov_disp_sequence=>280
,p_lov_disp_value=>'Current Page Is Contained Within Expression 1 (comma delimited list of pages)&nbsp;'
,p_lov_return_value=>'CURRENT_PAGE_IN_CONDITION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17056510827108624)
,p_lov_disp_sequence=>290
,p_lov_disp_value=>'Current Page Is NOT in Expression 1 (comma delimited list of pages)&nbsp;'
,p_lov_return_value=>'CURRENT_PAGE_NOT_IN_CONDITION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17056715597108624)
,p_lov_disp_sequence=>300
,p_lov_disp_value=>'Current Page = Page Submitted (this page was posted)'
,p_lov_return_value=>'WHEN_THIS_PAGE_SUBMITTED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17056928044108624)
,p_lov_disp_sequence=>310
,p_lov_disp_value=>'Current Page != Page Submitted (this page was not the page posted)'
,p_lov_return_value=>'WHEN_THIS_PAGE_NOT_SUBMITTED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17057121568108624)
,p_lov_disp_sequence=>320
,p_lov_disp_value=>'Current Page Is in Printer Friendly Mode'
,p_lov_return_value=>'PAGE_IS_IN_PRINTER_FRIENDLY_MODE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17057319272108624)
,p_lov_disp_sequence=>330
,p_lov_disp_value=>'Current page is NOT in Printer Friendly Mode'
,p_lov_return_value=>'PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17057520836108624)
,p_lov_disp_sequence=>340
,p_lov_disp_value=>'Text in Expression 1 Is Contained in Value of Item / Column in Expression 2'
,p_lov_return_value=>'CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17057700160108624)
,p_lov_disp_sequence=>350
,p_lov_disp_value=>'Text in Expression 1 Is Contained within the Text in Expression 2'
,p_lov_return_value=>'DISPLAY_COND_IN_COND_TEXT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17057917017108624)
,p_lov_disp_sequence=>360
,p_lov_disp_value=>'Text in Expression 1 Is NOT Contained within the Text in Expression 2'
,p_lov_return_value=>'DISPLAY_COND_NOT_IN_COND_TEXT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17058129556108624)
,p_lov_disp_sequence=>370
,p_lov_disp_value=>'Text in Expression 1 = Expression 2 (includes &amp;ITEM. substitutions)'
,p_lov_return_value=>'DISPLAY_COND_EQUAL_COND_TEXT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17058302599108624)
,p_lov_disp_sequence=>380
,p_lov_disp_value=>'Text in Expression 1 != Expression 2 (includes &amp;ITEM. substitutions)'
,p_lov_return_value=>'DISP_COND_NOT_EQUAL_COND_TEXT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17058500424108624)
,p_lov_disp_sequence=>390
,p_lov_disp_value=>'User is Authenticated  (not public)'
,p_lov_return_value=>'USER_IS_NOT_PUBLIC_USER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17058726811108624)
,p_lov_disp_sequence=>400
,p_lov_disp_value=>'User is the Public User (user has not authenticated)'
,p_lov_return_value=>'USER_IS_PUBLIC_USER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17058904202108624)
,p_lov_disp_sequence=>410
,p_lov_disp_value=>'Inline Validation Errors Displayed'
,p_lov_return_value=>'DISPLAYING_INLINE_VALIDATION_ERRORS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17059101306108625)
,p_lov_disp_sequence=>420
,p_lov_disp_value=>'No Inline Validation Errors Displayed'
,p_lov_return_value=>'NOT_DISPLAYING_INLINE_VALIDATION_ERRORS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17059327206108625)
,p_lov_disp_sequence=>430
,p_lov_disp_value=>'SQL Reports (OK to show the forward button)'
,p_lov_return_value=>'MAX_ROWS_LT_ROWS_FETCHED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17059504523108625)
,p_lov_disp_sequence=>440
,p_lov_disp_value=>'SQL Reports (OK to show the back button)'
,p_lov_return_value=>'MIN_ROW_GT_THAN_ONE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17059703304108625)
,p_lov_disp_sequence=>450
,p_lov_disp_value=>'Client Browser: Mozilla, Netscape 6.x/7x or higher'
,p_lov_return_value=>'BROWSER_IS_NSCP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17059928814108625)
,p_lov_disp_sequence=>460
,p_lov_disp_value=>'Client Browser: Microsoft Internet Explorer 5.5, 6.0 or higher'
,p_lov_return_value=>'BROWSER_IS_MSIE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17060118387108625)
,p_lov_disp_sequence=>470
,p_lov_disp_value=>'Client Browser: XHTML / CSS capable browser'
,p_lov_return_value=>'BROWSER_IS_MSIE_OR_NSCP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17060301979108625)
,p_lov_disp_sequence=>480
,p_lov_disp_value=>'Client Browser: Other browsers (or older version)'
,p_lov_return_value=>'BROWSER_IS_OTHER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17060502945108625)
,p_lov_disp_sequence=>490
,p_lov_disp_value=>'Current Language Is Contained within Expression 1'
,p_lov_return_value=>'CURRENT_LANG_IN_COND1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17060706361108625)
,p_lov_disp_sequence=>500
,p_lov_disp_value=>'Current Language Is NOT Contained within Expression 1'
,p_lov_return_value=>'CURRENT_LANG_NOT_IN_COND1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17060905285108625)
,p_lov_disp_sequence=>510
,p_lov_disp_value=>'Current Language != Expression 1'
,p_lov_return_value=>'CURRENT_LANG_NOT_EQ_COND1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17061114830108626)
,p_lov_disp_sequence=>520
,p_lov_disp_value=>'Current Language = Expression 1'
,p_lov_return_value=>'CURRENT_LANG_EQ_COND1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17061318820108626)
,p_lov_disp_sequence=>530
,p_lov_disp_value=>'When CGI_ENV DAD_NAME = Expression 1'
,p_lov_return_value=>'DAD_NAME_EQ_CONDITION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17061519255108626)
,p_lov_disp_sequence=>540
,p_lov_disp_value=>'When CGI_ENV DAD_NAME != Expression 1'
,p_lov_return_value=>'DAD_NAME_NOT_EQ_CONDITION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17061714239108626)
,p_lov_disp_sequence=>550
,p_lov_disp_value=>'When CGI_ENV SERVER_NAME = Expression 1'
,p_lov_return_value=>'SERVER_NAME_EQ_CONDITION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17061919406108627)
,p_lov_disp_sequence=>560
,p_lov_disp_value=>'When CGI_ENV SERVER_NAME != Expression 1'
,p_lov_return_value=>'SERVER_NAME_NOT_EQ_CONDITION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17062113867108627)
,p_lov_disp_sequence=>570
,p_lov_disp_value=>'When CGI_ENV HTTP_HOST = Expression 1'
,p_lov_return_value=>'HTTP_HOST_EQ_CONDITION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17062302529108627)
,p_lov_disp_sequence=>580
,p_lov_disp_value=>'When CGI_ENV HTTP_HOST != Expression 1'
,p_lov_return_value=>'HTTP_HOST_NOT_EQ_CONDITION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17062522015108627)
,p_lov_disp_sequence=>590
,p_lov_disp_value=>'When Process in Comma Delimited List of Process IDs Has Run'
,p_lov_return_value=>'WHEN_PROCESS_IN_COMMA_DELIMITED_LIST_OF_PROCESS_IDS_HAS_RUN'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17062711434108627)
,p_lov_disp_sequence=>600
,p_lov_disp_value=>'When any Item In Comma Delimited List of Items Has Changed'
,p_lov_return_value=>'WHEN_ANY_ITEM_IN_COMMA_DELIMITED_LIST_OF_ITEMS_HAS_CHANGED'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17062902568108627)
,p_lov_disp_sequence=>610
,p_lov_disp_value=>'When any Item In Comma Delimited List of Pages Has Changed'
,p_lov_return_value=>'WHEN_ANY_ITEM_IN_COMMA_DELIMITED_LIST_OF_PAGES_HAS_CHANGED'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17063119820108627)
,p_lov_disp_sequence=>620
,p_lov_disp_value=>'When any Item In Current Page Has Changed'
,p_lov_return_value=>'WHEN_ANY_ITEM_IN_CURRENT_PAGE_HAS_CHANGED'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17063325444108627)
,p_lov_disp_sequence=>630
,p_lov_disp_value=>'When any Item In Current Application Has Changed'
,p_lov_return_value=>'WHEN_ANY_ITEM_IN_CURRENT_FLOW_HAS_CHANGED'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17063504629108630)
,p_lov_disp_sequence=>640
,p_lov_disp_value=>'When any Item In Current Session Has Changed'
,p_lov_return_value=>'WHEN_ANY_ITEM_IN_CURRENT_SESSION_HAS_CHANGED'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17063727309108630)
,p_lov_disp_sequence=>999
,p_lov_disp_value=>'Never'
,p_lov_return_value=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17063920324108630)
,p_lov_disp_sequence=>1000
,p_lov_disp_value=>'Always'
,p_lov_return_value=>'ALWAYS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/real_application_security_mode
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(125789401878207743)
,p_lov_name=>'REAL APPLICATION SECURITY MODE'
,p_lov_query=>'.'||wwv_flow_imp.id(125789401878207743)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475279
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(125789707509207748)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Disabled'
,p_lov_return_value=>'0'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(125790005075207754)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'External Users'
,p_lov_return_value=>'1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(125790331290207754)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Internal Users'
,p_lov_return_value=>'2'
);
end;
/
prompt --application/shared_components/user_interface/lovs/recent_time_static
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(94747000503182513)
,p_lov_name=>'RECENT TIME STATIC'
,p_lov_query=>'.'||wwv_flow_imp.id(94747000503182513)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475279
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(94747313637182517)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'10 seconds'
,p_lov_return_value=>'.000115740740740740740740740740740740741'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(94747518394182517)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'1 minute'
,p_lov_return_value=>'.000694444444444444444444444444444444444'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(94747729794182517)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'5 minutes'
,p_lov_return_value=>'.003472222222222222222222222222222222222'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(94747926598182517)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'10 minutes'
,p_lov_return_value=>'.0069444444444444444444444444'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(94748115620182518)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'15 minutes'
,p_lov_return_value=>'.010416666666666666666666666666666666667'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(94748310633182518)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'30 minutes'
,p_lov_return_value=>'.020833333333333333333333333333333333333'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(94748508572182518)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'1 hour'
,p_lov_return_value=>'.041666666666666666666666666666666666667'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(94748724431182518)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'2 hours'
,p_lov_return_value=>'.083333333333333333333333333333333333333'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(94748910187182518)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'3 hours'
,p_lov_return_value=>'.125'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(94749125599182518)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'4 hours'
,p_lov_return_value=>'.166666666666666666666666666666666666667'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(94749323491182518)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'5 hours'
,p_lov_return_value=>'.208333333333333333333333333333333333333'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(94749508725182518)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'6 hours'
,p_lov_return_value=>'.25'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(94749718151182518)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>'8 hours'
,p_lov_return_value=>'.333333333333333333333333333333333333333'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(94749910023182518)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>'10 hours'
,p_lov_return_value=>'.416666666666666666666666666666666666667'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(94750119132182518)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'12 hours'
,p_lov_return_value=>'.5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(104466705973961841)
,p_lov_disp_sequence=>15.5
,p_lov_disp_value=>'1 day'
,p_lov_return_value=>'1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(94750607429184466)
,p_lov_disp_sequence=>16
,p_lov_disp_value=>'2 days'
,p_lov_return_value=>'2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(94750911239185592)
,p_lov_disp_sequence=>17
,p_lov_disp_value=>'3 days'
,p_lov_return_value=>'3'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(94751214355186496)
,p_lov_disp_sequence=>18
,p_lov_disp_value=>'4 days'
,p_lov_return_value=>'4'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(94751517818187469)
,p_lov_disp_sequence=>19
,p_lov_disp_value=>'5 days'
,p_lov_return_value=>'5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(94751822667188850)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'6 days'
,p_lov_return_value=>'6'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(94752125783189729)
,p_lov_disp_sequence=>21
,p_lov_disp_value=>'1 week'
,p_lov_return_value=>'7'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(94752428900190721)
,p_lov_disp_sequence=>22
,p_lov_disp_value=>'2 weeks'
,p_lov_return_value=>'14'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(94752702366192454)
,p_lov_disp_sequence=>23
,p_lov_disp_value=>'4 weeks'
,p_lov_return_value=>'28'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(94753006521193682)
,p_lov_disp_sequence=>26
,p_lov_disp_value=>'1 year'
,p_lov_return_value=>'365'
);
end;
/
prompt --application/shared_components/user_interface/lovs/redact_func_parms
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1633884855696516)
,p_lov_name=>'REDACT_FUNC_PARMS'
,p_lov_query=>'.'||wwv_flow_imp.id(1633884855696516)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475280
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1634225720696517)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Redact First Five US SSN'
,p_lov_return_value=>'VVVFVVFVVVV,VVV-VV-VVVV,X,1,5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1634682713696517)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Redact Last Four US SSN'
,p_lov_return_value=>'VVVFVVFVVVV,VVV-VV-VVVV,X,6,9'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1635042489696517)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Redact Entire US SSN'
,p_lov_return_value=>'VVVFVVFVVVV,VVV-VV-VVVV,X,1,9'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1635427075696517)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Redact First Five Numeric US SSN'
,p_lov_return_value=>'9,1,5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1635810749696517)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Redact Last Four Numeric US SSN'
,p_lov_return_value=>'9,6,9'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1636220044696517)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Redact Entire Numeric US SSN'
,p_lov_return_value=>'9,1,9'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1636653305696517)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Redact Numeric US ZIP Code'
,p_lov_return_value=>'9,1,5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1637023272696517)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Redact First Twelve Credit Card Number'
,p_lov_return_value=>'VVVVFVVVVFVVVVFVVVV,VVVV-VVVV-VVVV-VVVV,*,1,12'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1637410132696517)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Redact Date Millenium'
,p_lov_return_value=>'m1d1y2000'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1637887521696518)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Redact Date Epoch'
,p_lov_return_value=>'m1d1y1970'
);
end;
/
prompt --application/shared_components/user_interface/lovs/redact_regexp_pattern
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1638174978696518)
,p_lov_name=>'REDACT_REGEXP_PATTERN'
,p_lov_query=>'.'||wwv_flow_imp.id(1638174978696518)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475283
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1638514624696518)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'US Social Security Number'
,p_lov_return_value=>'(\d\d\d)-(\d\d)-(\d\d\d\d)'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1638993085696518)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Middle of Credit Card with Leading 6 and Trailing 4 digits'
,p_lov_return_value=>'(\d\d\d\d\d\d)(\d\d\d*)(\d\d\d\d)'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1639339518696518)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Any Digit'
,p_lov_return_value=>'\d'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1639794019696518)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'US Phone Number'
,p_lov_return_value=>'(\(\d\d\d\)|\d\d\d)-(\d\d\d)-(\d\d\d\d)'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1640131927696518)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Email Address'
,p_lov_return_value=>'([A-Za-z0-9._%+-]+)@([A-Za-z0-9.-]+\.[A-Za-z]{2,4})'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1640514119696518)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'IP Address'
,p_lov_return_value=>'(\d{1,3}\.\d{1,3}\.\d{1,3})\.\d{1,3}'
);
end;
/
prompt --application/shared_components/user_interface/lovs/redact_regexp_repl_str
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1640893349696518)
,p_lov_name=>'REDACT_REGEXP_REPL_STR'
,p_lov_query=>'.'||wwv_flow_imp.id(1640893349696518)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475283
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1641298348696519)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Redact Middle Credit Card Digits'
,p_lov_return_value=>'\1XXXXXX\3'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1641658067696519)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Redact with Single X'
,p_lov_return_value=>'X'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1642047513696519)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Redact with Single 1'
,p_lov_return_value=>'1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1642452306696519)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Redact US Phone'
,p_lov_return_value=>'\1-XXX-XXXX'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1642847604696519)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Redact Email Name'
,p_lov_return_value=>'xxxx@\2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1643249986696519)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Redact Email Domain'
,p_lov_return_value=>'\1 (at) xxxxx.com'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1643607252696519)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Redact Entire Email'
,p_lov_return_value=>'xxxx (at) xxxxx.com'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1644004648696519)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Redact IP Address'
,p_lov_return_value=>'\1.999'
);
end;
/
prompt --application/shared_components/user_interface/lovs/redirect_branch
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84944714521889885)
,p_lov_name=>'REDIRECT.BRANCH'
,p_lov_query=>'.'||wwv_flow_imp.id(84944714521889885)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475283
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84944918356889886)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'branch to page using redirect )'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/referrer_policy
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(576106643072201397)
,p_lov_name=>'REFERRER_POLICY'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select x.column_value disp,',
'       x.column_value ret',
'  from table(wwv_flow_t_varchar2 (',
'                 ''no-referrer'',',
'                 ''no-referrer-when-downgrade'',',
'                 ''origin'',',
'                 ''origin-when-cross-origin'',',
'                 ''same-origin'',',
'                 ''strict-origin'',',
'                 ''strict-origin-when-cross-origin'',',
'                 ''unsafe-url'' )) x',
''))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'RET'
,p_display_column_name=>'DISP'
,p_group_sort_direction=>'ASC'
,p_default_sort_direction=>'ASC'
,p_version_scn=>72475283
);
end;
/
prompt --application/shared_components/user_interface/lovs/refresh_label_template
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84317322746593889)
,p_lov_name=>'REFRESH_LABEL_TEMPLATE'
,p_lov_query=>'.'||wwv_flow_imp.id(84317322746593889)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475283
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88305802126823296)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Refresh'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/refresh_y
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(86078519684815185)
,p_lov_name=>'REFRESH_Y'
,p_lov_query=>'.'||wwv_flow_imp.id(86078519684815185)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475283
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88306405589824278)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Refresh'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/regexp_match_param
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1644350231696519)
,p_lov_name=>'REGEXP_MATCH_PARAM'
,p_lov_query=>'.'||wwv_flow_imp.id(1644350231696519)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475283
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1644787956696520)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Case Sensitive'
,p_lov_return_value=>'c'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1645191392696520)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Case Insensitive'
,p_lov_return_value=>'i'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1645521141696520)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Multiple Lines'
,p_lov_return_value=>'m'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1645928592696520)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Newline Wildcard'
,p_lov_return_value=>'n'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1646395316696520)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Ignore Whitespace'
,p_lov_return_value=>'x'
);
end;
/
prompt --application/shared_components/user_interface/lovs/region_name_lookup
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(7873722064289469)
,p_lov_name=>'REGION NAME LOOKUP'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select plug_name, id',
'  from wwv_flow_page_plugs'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475283
);
end;
/
prompt --application/shared_components/user_interface/lovs/region_theme_class_id
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(42003622222572861)
,p_lov_name=>'REGION THEME CLASS ID'
,p_lov_query=>'.'||wwv_flow_imp.id(42003622222572861)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475283
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(42003905055572869)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Hide and Show Region'
,p_lov_return_value=>'1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(42004121899572869)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Sidebar Region'
,p_lov_return_value=>'2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(42004332039572870)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Sidebar Region, Alternative 1'
,p_lov_return_value=>'3'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(42004527982572870)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Button Region with Title'
,p_lov_return_value=>'4'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(42004707368572870)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Navigation Region'
,p_lov_return_value=>'5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(42004922993572870)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Breadcrumb Region'
,p_lov_return_value=>'6'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(42005318792572871)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Form Region'
,p_lov_return_value=>'8'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(42005510332572871)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Reports Region'
,p_lov_return_value=>'9'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(42005908156572871)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Region without Title'
,p_lov_return_value=>'11'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(42006130670572872)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Wizard Region'
,p_lov_return_value=>'12'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(42006320789572872)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Reports Region 100% Width'
,p_lov_return_value=>'13'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(42009203091586314)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Navigation Region, Alternative 1'
,p_lov_return_value=>'16'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(42011722484591850)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Button Region without Title'
,p_lov_return_value=>'17'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(42016007687644405)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Bracketed Region'
,p_lov_return_value=>'18'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(42017128465650351)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Region without Buttons and Title'
,p_lov_return_value=>'19'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(44193631287041740)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Wizard Region with Icon'
,p_lov_return_value=>'20'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(52367908380077344)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Borderless Region'
,p_lov_return_value=>'7'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(52369713490097781)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Reports Region, Alternative 1'
,p_lov_return_value=>'10'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(75207904105349056)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'List Region with Icon'
,p_lov_return_value=>'29'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(76147331941126624)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Report Filter - Single Row'
,p_lov_return_value=>'31'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(76177513165215809)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Report Filter - Multi Row'
,p_lov_return_value=>'32'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(225619930801333589)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Chart Region'
,p_lov_return_value=>'30'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(44237530397202360)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 1'
,p_lov_return_value=>'21'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(44237832475202975)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 2'
,p_lov_return_value=>'22'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(44238101439203525)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 3'
,p_lov_return_value=>'23'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(44238403516204084)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 4'
,p_lov_return_value=>'24'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(44238705594204669)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 5'
,p_lov_return_value=>'25'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(44239007326205203)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 6'
,p_lov_return_value=>'26'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(44239309404205768)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 7'
,p_lov_return_value=>'27'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(44239611135206317)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 8'
,p_lov_return_value=>'28'
);
end;
/
prompt --application/shared_components/user_interface/lovs/region_title_translation
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(17378610268487082)
,p_lov_name=>'REGION TITLE TRANSLATION'
,p_lov_query=>'.'||wwv_flow_imp.id(17378610268487082)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475283
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17378825153487082)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'exclude title from translation'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/region_item_display_point
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(39812312012046225)
,p_lov_name=>'REGION.ITEM_DISPLAY_POINT'
,p_lov_query=>'.'||wwv_flow_imp.id(39812312012046225)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475283
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(39812524545046226)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Above Content'
,p_lov_return_value=>'ABOVE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(39812805656046228)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Below Content'
,p_lov_return_value=>'BELOW'
);
end;
/
prompt --application/shared_components/user_interface/lovs/region_templates
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(663424044)
,p_lov_name=>'REGION.TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.d, ',
'       t.r ',
'  from ( select wwv_flow_escape.html(page_plug_template_name) d, ',
'             id r',
'           from wwv_flow_page_plug_templates',
'          where security_group_id = :FLOW_SECURITY_GROUP_ID',
'            and flow_id           = :FB_FLOW_ID',
'            and (:FB_THEME_ID is null or theme_id = :FB_THEME_ID)',
'          order by upper(page_plug_template_name) ) t'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475283
);
end;
/
prompt --application/shared_components/user_interface/lovs/region_types_for_display_only_includes_legacy_values
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(538211928069052506)
,p_lov_name=>'REGION.TYPES (FOR DISPLAY ONLY - INCLUDES LEGACY VALUES)'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(wwv_flow_lang.system_message(''REGION_NAME.''||name_with_prefix), display_name) D,',
'       name_with_prefix R',
'  from wwv_flow_native_plugins',
' where plugin_type = ''REGION TYPE''',
' union all',
'select display_name||wwv_flow_lang.system_message(''PLUGIN.DISPLAY_NAME_POSTFIX'') D,',
'       ''PLUGIN_''||name R',
'  from wwv_flow_plugins',
' where flow_id           = to_number(:FB_FLOW_ID)',
'   and security_group_id = to_number(:WORKSPACE_ID)',
'   and plugin_type       = ''REGION TYPE''',
' union all',
'select wwv_flow_lang.system_message(''DYNAMIC_QUERY'') D, ''DYNAMIC_QUERY'' R from dual',
' union all',
'select wwv_flow_lang.system_message(''SQL_QUERY'') D, ''SQL_QUERY'' R from dual',
' union all',
'select wwv_flow_lang.system_message(''REGION_DISPLAY_SELECTOR'') D, ''REGION_DISPLAY_SELECTOR'' R from dual',
' union all',
'select wwv_flow_lang.system_message(''SQL_QUERY'')||'' (''||initcap(wwv_flow_lang.system_message(''STRUCTURED_QUERY''))||'')'' D, ''STRUCTURED_QUERY'' R from dual',
' union all',
'select wwv_flow_lang.system_message(''SQL_QUERY'')||'' (''||wwv_flow_lang.system_message(''FUNCTION_BODY_RETURNING_QUERY'')||'')'' D,''FUNCTION_RETURNING_SQL_QUERY'' R from dual',
' union all',
'select wwv_flow_lang.system_message(''HTML_TEXT'') D, ''STATIC_TEXT'' R from dual',
' union all',
'select wwv_flow_lang.system_message(''PLSQL_PROCEDURE'')||'' (''||wwv_flow_lang.system_message(''ANONYMOUS_BLOCK'')||'')'' D, ''PLSQL_PROCEDURE'' R from dual',
' union all',
'select initcap(wwv_flow_lang.system_message(''WEB_SERVICE_RESULT'')) D,''WEB_SERVICE'' R from dual',
' union all',
'select initcap(wwv_flow_lang.system_message(''WEB_SERVICE_RESULT'')) D,''SQL_QUERY_WS'' R from dual',
' union all',
'select initcap(wwv_flow_lang.system_message(''HELP_TEXT'')) D, ''HELP_TEXT'' R from dual',
' union all',
'select wwv_flow_lang.system_message(''HTML_TEXT'')||'' (''||wwv_flow_lang.system_message(''ESCAPE_SC'')||'')'' D, ''STATIC_TEXT_ESCAPE_SC'' R from dual',
' union all',
'select wwv_flow_lang.system_message(''HTML_TEXT'')||'' (''||wwv_flow_lang.system_message(''WITH_SHORTCUTS'')||'')'' D, ''STATIC_TEXT_WITH_SHORTCUTS'' R from dual',
' union all',
'select wwv_flow_lang.system_message(''SQL_QUERY'')||'' (''||wwv_flow_lang.system_message(''UPDATEABLE_REPORT'')||'')'' D, ''UPDATABLE_SQL_QUERY'' R from dual',
' union all',
'select wwv_flow_lang.system_message(''URL'') D, ''URL'' R from dual',
' union all',
'select initcap(wwv_flow_lang.system_message(''F4000_TREE'')) D, ''JSTREE'' R from dual',
' union all',
'select wwv_flow_lang.system_message(''LEGACY_CALENDAR'') D, ''CALENDAR'' R from dual',
' union all',
'select wwv_flow_lang.system_message(''CALENDAR_EASY_TYPE'') D, ''EASY_CALENDAR'' R from dual',
' union all',
'select wwv_flow_lang.system_message(''REGION_NAME.NATIVE_LIST'') D, ''LIST'' R from dual',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475283
);
end;
/
prompt --application/shared_components/user_interface/lovs/region_types_requires_application_context
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(32361488916)
,p_lov_name=>'REGION.TYPES (REQUIRES APPLICATION CONTEXT)'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select D,R from(',
'select display_name D, name_with_prefix R, 3 OB from wwv_flow_native_plugins where plugin_type = ''REGION TYPE''',
' union all',
'select display_name||wwv_flow_lang.system_message(''PLUGIN.DISPLAY_NAME_POSTFIX'') D, ''PLUGIN_''||name R, 3 OB from wwv_flow_plugins where flow_id = to_number(:FB_FLOW_ID) and security_group_id = to_number(:WORKSPACE_ID) and plugin_type = ''REGION TYPE''',
' union all',
'select ''___________________________________________________'' D,''FLOWS_DIVIDER'' R,4 OB from dual',
'order by 1)',
'order by OB'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475283
);
end;
/
prompt --application/shared_components/user_interface/lovs/region_comment
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(86070721237777807)
,p_lov_name=>'REGION_COMMENT'
,p_lov_query=>'.'||wwv_flow_imp.id(86070721237777807)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475283
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88309409052825302)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Return to Page'
,p_lov_return_value=>'YES'
);
end;
/
prompt --application/shared_components/user_interface/lovs/region_display_point_all
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(31553701621903696)
,p_lov_name=>'REGION_DISPLAY_POINT_ALL'
,p_lov_query=>'.'||wwv_flow_imp.id(31553701621903696)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475283
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1475524458526082046)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'Page Template Body'
,p_lov_return_value=>'BODY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(31554207818903702)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Page Template Body (1)'
,p_lov_return_value=>'BODY_1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(31554402066903703)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Page Template Body (2)'
,p_lov_return_value=>'BODY_2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(31554629662903703)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Page Template Body (3)'
,p_lov_return_value=>'BODY_3'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(31555003059903703)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Page Template Region Position 1'
,p_lov_return_value=>'REGION_POSITION_01'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(31555213544903704)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Page Template Region Position 2'
,p_lov_return_value=>'REGION_POSITION_02'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(31555419855903704)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Page Template Region Position 3'
,p_lov_return_value=>'REGION_POSITION_03'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(31555606434903704)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'Page Template Region Position 4'
,p_lov_return_value=>'REGION_POSITION_04'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(31555807935903704)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'Page Template Region Position 5'
,p_lov_return_value=>'REGION_POSITION_05'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(31556000647903704)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'Page Template Region Position 6'
,p_lov_return_value=>'REGION_POSITION_06'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(31556202527903705)
,p_lov_disp_sequence=>130
,p_lov_disp_value=>'Page Template Region Position 7'
,p_lov_return_value=>'REGION_POSITION_07'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(31556400273903705)
,p_lov_disp_sequence=>140
,p_lov_disp_value=>'Page Template Region Position 8'
,p_lov_return_value=>'REGION_POSITION_08'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(31554031866903701)
,p_lov_disp_sequence=>150
,p_lov_disp_value=>'After Header'
,p_lov_return_value=>'AFTER_HEADER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(31554812516903703)
,p_lov_disp_sequence=>160
,p_lov_disp_value=>'Before Footer'
,p_lov_return_value=>'BEFORE_FOOTER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/region_template_wiz
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(86595203201245715)
,p_lov_name=>'REGION_TEMPLATE_WIZ'
,p_lov_query=>'.'||wwv_flow_imp.id(86595203201245715)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475283
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88310014246826768)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Choose one from the &PRODUCT_NAME. repository'
,p_lov_return_value=>'DEFAULT'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88310206716826770)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'From Scratch'
,p_lov_return_value=>'BLANK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88310407341826770)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'As a Copy of an Existing Template'
,p_lov_return_value=>'COPY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/rejoin_existing_sessions
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(492680965578161495)
,p_lov_name=>'REJOIN_EXISTING_SESSIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(492680965578161495)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475283
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(492681259501161497)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Disabled'
,p_lov_return_value=>'N'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(492681550873161501)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Enabled for Public Sessions'
,p_lov_return_value=>'P'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(492681867549161501)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Enabled for All Sessions'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/remote_file_server
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1800219351660527)
,p_lov_name=>'REMOTE_FILE_SERVER'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_remote_servers',
' where server_type = ''CLOUD_OBJECT_STORE''',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_return_column_name=>'ID'
,p_display_column_name=>'NAME'
,p_default_sort_column_name=>'NAME'
,p_default_sort_direction=>'ASC'
,p_version_scn=>72475283
);
end;
/
prompt --application/shared_components/user_interface/lovs/remote_print_server
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(6609670475356322)
,p_lov_name=>'REMOTE_PRINT_SERVER'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_remote_servers',
' where server_type = ''PRINT_SERVER''',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'ID'
,p_display_column_name=>'NAME'
,p_group_sort_direction=>'ASC'
,p_default_sort_direction=>'ASC'
,p_version_scn=>72475283
);
end;
/
prompt --application/shared_components/user_interface/lovs/remote_server_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(154020705287547277)
,p_lov_name=>'REMOTE_SERVER_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(154020705287547277)||'.'
,p_location=>'STATIC'
,p_version_scn=>1468078741
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(525215053516054024)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Authentication'
,p_lov_return_value=>'AUTHENTICATION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(5900616837046045)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Print Server'
,p_lov_return_value=>'PRINT_SERVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(154021086016547295)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'REST Data Source'
,p_lov_return_value=>'WEB_SERVICE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(154021427047547298)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'REST Enabled SQL'
,p_lov_return_value=>'REMOTE_SQL'
,p_lov_disp_cond_type=>'CURRENT_PAGE_NOT_EQUAL_CONDITION'
,p_lov_disp_cond=>'1932'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3806566601983346)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>'File Server'
,p_lov_return_value=>'CLOUD_OBJECT_STORE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/remote_sql_database_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1803812385387219)
,p_lov_name=>'REMOTE_SQL_DATABASE_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(1803812385387219)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475283
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1804157843387230)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Oracle'
,p_lov_return_value=>'ORACLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1804588576387232)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'MySQL'
,p_lov_return_value=>'MYSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/remote_sql_oracle_servers
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1900402435833462)
,p_lov_name=>'REMOTE_SQL_ORACLE_SERVERS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_remote_servers',
' where server_type = ''REMOTE_SQL''',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and remote_sql_database_type = ''ORACLE'''))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_return_column_name=>'ID'
,p_display_column_name=>'NAME'
,p_default_sort_column_name=>'NAME'
,p_default_sort_direction=>'ASC'
,p_version_scn=>72475283
);
end;
/
prompt --application/shared_components/user_interface/lovs/remote_sql_servers
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(3916281406910608)
,p_lov_name=>'REMOTE_SQL_SERVERS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_remote_servers',
' where server_type = ''REMOTE_SQL''',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475283
);
end;
/
prompt --application/shared_components/user_interface/lovs/remove_application_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(69499523734506806)
,p_lov_name=>'REMOVE APPLICATION OPTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(69499523734506806)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475287
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(69499727417506807)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Remove Application Definition'
,p_lov_return_value=>'APPLICATION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(69499914386506809)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Deinstall Supporting Objects'
,p_lov_return_value=>'DBOBJECTS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/remove_supporting_objects_confirm
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(48392517652618439)
,p_lov_name=>'REMOVE SUPPORTING OBJECTS CONFIRM'
,p_lov_query=>'.'||wwv_flow_imp.id(48392517652618439)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475287
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(48393218492618442)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Deinstall Supporting Objects'
,p_lov_return_value=>'DBOBJECTS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/replace_subsribe
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(153629328412742095)
,p_lov_name=>'REPLACE_SUBSRIBE'
,p_lov_query=>'.'||wwv_flow_imp.id(153629328412742095)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475287
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(153629608857742097)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Replace'
,p_lov_return_value=>'REPLACE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(153629812815742097)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Replace / Subscribe'
,p_lov_return_value=>'SUBSCRIBE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/report_layout_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(98487819468346730)
,p_lov_name=>'REPORT LAYOUT TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(98487819468346730)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475287
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(98488104584346730)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Use generic report layout'
,p_lov_return_value=>'G'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(98488321656346730)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Upload XSL-FO based report layout file'
,p_lov_return_value=>'F'
);
end;
/
prompt --application/shared_components/user_interface/lovs/report_options_on_create_application
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(91329908068021523)
,p_lov_name=>'REPORT OPTIONS ON CREATE APPLICATION'
,p_lov_query=>'.'||wwv_flow_imp.id(91329908068021523)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475287
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(91330107385021523)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Report Filter'
,p_lov_return_value=>'F'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(91347711073164360)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Column Sorting'
,p_lov_return_value=>'S'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(91348319384166779)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Download Link'
,p_lov_return_value=>'D'
);
end;
/
prompt --application/shared_components/user_interface/lovs/report_theme_class_id
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(44022800298370465)
,p_lov_name=>'REPORT THEME CLASS ID'
,p_lov_query=>'.'||wwv_flow_imp.id(44022800298370465)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475287
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(44023108057370466)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Standard'
,p_lov_return_value=>'4'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(44023306894370466)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Standard, Alternating Row Colors'
,p_lov_return_value=>'5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(44023505444370467)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'One Column Unordered List'
,p_lov_return_value=>'3'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(44023703003370467)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Horizontal Border'
,p_lov_return_value=>'2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(44040305502447718)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Value Attribute Pairs'
,p_lov_return_value=>'6'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(44040817276451119)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Borderless'
,p_lov_return_value=>'1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(44024106645370467)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 1'
,p_lov_return_value=>'7'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(44024306507370468)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 2'
,p_lov_return_value=>'8'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(44024511658370468)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 3'
,p_lov_return_value=>'9'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(44024705287370468)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 4'
,p_lov_return_value=>'10'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(44024932615370468)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 5'
,p_lov_return_value=>'11'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(44025103039370479)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 6'
,p_lov_return_value=>'12'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(44025325537370479)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 7'
,p_lov_return_value=>'13'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(44025506216370479)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Custom 8'
,p_lov_return_value=>'14'
);
end;
/
prompt --application/shared_components/user_interface/lovs/report_layout_generic_or_file
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1805850678716417)
,p_lov_name=>'REPORT.LAYOUT.GENERIC_OR_FILE'
,p_lov_query=>'.'||wwv_flow_imp.id(1805850678716417)||'.'
,p_location=>'STATIC'
,p_version_scn=>3308844
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1806167712716420)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Generic Columns'
,p_lov_return_value=>'GENERIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1806554788716420)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Named Columns'
,p_lov_return_value=>'FILE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/report_layout_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(19274704924460373)
,p_lov_name=>'REPORT.LAYOUT.TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(19274704924460373)||'.'
,p_location=>'STATIC'
,p_version_scn=>79463171
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(19275219111460374)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Generic Columns (XSL-FO)'
,p_lov_return_value=>'XSL_GENERIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(19275015143460374)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Named Columns (RTF)'
,p_lov_return_value=>'RTF_FILE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1828232509732992)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Named Columns (XSL-FO)'
,p_lov_return_value=>'XSL_FILE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4983909628531654)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Named Columns (DOCX)'
,p_lov_return_value=>'DOCX_FILE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2710521525097351)
,p_lov_disp_sequence=>18
,p_lov_disp_value=>'Named Columns (XLSX)'
,p_lov_return_value=>'XLSX_FILE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2710866113099357)
,p_lov_disp_sequence=>28
,p_lov_disp_value=>'Named Columns (PPTX)'
,p_lov_return_value=>'PPTX_FILE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2711188904100741)
,p_lov_disp_sequence=>38
,p_lov_disp_value=>'Named Columns (HTML)'
,p_lov_return_value=>'HTML_FILE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2711421459103211)
,p_lov_disp_sequence=>48
,p_lov_disp_value=>'Named Columns (Markdown)'
,p_lov_return_value=>'MARKDOWN_FILE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2711781388105550)
,p_lov_disp_sequence=>58
,p_lov_disp_value=>'Named Columns (CSV)'
,p_lov_return_value=>'CSV_FILE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2712038227106865)
,p_lov_disp_sequence=>68
,p_lov_disp_value=>'Named Columns (TXT)'
,p_lov_return_value=>'TXT_FILE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2712392760153624)
,p_lov_disp_sequence=>78
,p_lov_disp_value=>'Named Columns (Open Document Text)'
,p_lov_return_value=>'ODT_FILE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2712657921155953)
,p_lov_disp_sequence=>88
,p_lov_disp_value=>'Named Columns (Open Document Spreadsheet)'
,p_lov_return_value=>'ODS_FILE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2712993934158261)
,p_lov_disp_sequence=>98
,p_lov_disp_value=>'Named Columns (Open Document Presentation)'
,p_lov_return_value=>'ODP_FILE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/report_region_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(20772130624604116)
,p_lov_name=>'REPORT.REGION.TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(20772130624604116)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475287
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(20772311900604119)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'SQL Report'
,p_lov_return_value=>'NATIVE_SQL_REPORT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(20772502048604122)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Tabular Form'
,p_lov_return_value=>'NATIVE_TABFORM'
);
end;
/
prompt --application/shared_components/user_interface/lovs/report_templates
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(31573884244)
,p_lov_name=>'REPORT.TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME1'')  d,  1 r from sys.dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME2'')  d,  2 r from sys.dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME21'') d, 21 r from sys.dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME22'') d, 22 r from sys.dual union',
'select wwv_flow_lang.system_message(''CONFIRM.TEMPLATE'')||'' ''||theme_id||''. ''||wwv_flow_escape.html(row_template_name) d, id r',
'  from wwv_flow_row_templates ',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID ',
'   and (:FB_THEME_ID is null or theme_id = :FB_THEME_ID)',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475287
);
end;
/
prompt --application/shared_components/user_interface/lovs/report_layouts
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(24313105570265439)
,p_lov_name=>'REPORT_LAYOUTS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id, report_layout_name ',
'  from wwv_flow_report_layouts ',
' where flow_id              = :FB_FLOW_ID ',
'   and security_group_id    = :WORKSPACE_ID',
'   and (    ( :F4000_PRINT_SERVER_TYPE = ''DOCUMENT_GENERATOR'' and report_layout_type = ''DOCX_FILE'' )',
'        or  ( :F4000_PRINT_SERVER_TYPE = ''ADVANCED'' and report_layout_type in (''XSL_GENERIC'', ''RTF_FILE'', ''XSL_FILE'' ) )',
'        or  ( :F4000_PRINT_SERVER_TYPE = ''STANDARD'' and report_layout_type in (''XSL_GENERIC'', ''XSL_FILE'' ) ) )',
'        or  ( :F4000_PRINT_SERVER_TYPE = ''AOP'' and report_layout_type in (''DOCX_FILE'',',
'                                                                          ''XLSX_FILE'',',
'                                                                          ''PPTX_FILE'',',
'                                                                          ''HTML_FILE'',',
'                                                                          ''MARKDOWN_FILE'',',
'                                                                          ''CSV_FILE'',',
'                                                                          ''TXT_FILE'',',
'                                                                          ''ODT_FILE'',',
'                                                                          ''ODS_FILE'',',
'                                                                          ''ODP_FILE'' ) )'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'ID'
,p_display_column_name=>'REPORT_LAYOUT_NAME'
,p_group_sort_direction=>'ASC'
,p_default_sort_direction=>'ASC'
,p_version_scn=>79465038
);
end;
/
prompt --application/shared_components/user_interface/lovs/report_queries
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(116512322599902216)
,p_lov_name=>'REPORT_QUERIES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'  name,',
'  id    ',
'from ',
'  wwv_flow_shared_queries',
'where ',
'  flow_id = :fb_flow_id and ',
'  security_group_id = :flow_security_group_id'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475287
);
end;
/
prompt --application/shared_components/user_interface/lovs/report_query_source_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(112611429059992822)
,p_lov_name=>'REPORT_QUERY_SOURCE_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(112611429059992822)||'.'
,p_location=>'STATIC'
,p_version_scn=>79470300
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(112611722136992824)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'XML Data'
,p_lov_return_value=>'XML'
,p_lov_disp_cond_type=>'VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST'
,p_lov_disp_cond=>'F4000_PRINT_SERVER_TYPE'
,p_lov_disp_cond2=>'DOCUMENT_GENERATOR:AOP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(112611900413992824)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'XML Schema'
,p_lov_return_value=>'XSD'
,p_lov_disp_cond_type=>'VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST'
,p_lov_disp_cond=>'F4000_PRINT_SERVER_TYPE'
,p_lov_disp_cond2=>'DOCUMENT_GENERATOR:AOP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1602617818847579)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'JSON'
,p_lov_return_value=>'JSON'
,p_lov_disp_cond_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_lov_disp_cond=>'F4000_PRINT_SERVER_TYPE'
,p_lov_disp_cond2=>'DOCUMENT_GENERATOR:AOP'
);
end;
/
prompt --application/shared_components/user_interface/lovs/report_templates_002
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84308802529578634)
,p_lov_name=>'REPORT_TEMPLATES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME1'') d, 1 r from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME2'') d, 2 r from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME3'') d, 3 r from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME4'') d, 4 r from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME5'') d, 5 r from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME11'') d, 11 r from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME12'') d, 12 r from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME13'') d, 13 r from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME14'') d, 14 r from dual union',
'select wwv_flow_lang.system_message(''CONFIRM.TEMPLATE'')||'' ''||wwv_flow_escape.html(row_template_name) d, id r ',
'  from wwv_flow_row_templates where flow_id = :FB_FLOW_ID',
' and (:fb_theme_id is null or theme_id = :fb_theme_id)',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475287
);
end;
/
prompt --application/shared_components/user_interface/lovs/report_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(349021129284645044)
,p_lov_name=>'REPORT_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(349021129284645044)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475289
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(349021416349645045)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Interactive'
,p_lov_return_value=>'INTERACTIVE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(349021707529645045)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Classic'
,p_lov_return_value=>'CLASSIC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/report_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84834330555326798)
,p_lov_name=>'REPORT_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(84834330555326798)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475289
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84834520323326798)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'SQL Query'
,p_lov_return_value=>'NATIVE_SQL_REPORT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/report_wiz_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(86600327227262164)
,p_lov_name=>'REPORT_WIZ_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(86600327227262164)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475289
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88311017363827760)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Choose one from the &PRODUCT_NAME. repository'
,p_lov_return_value=>'DEFAULT'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88311204775827761)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'From Scratch'
,p_lov_return_value=>'BLANK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88311406704827761)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'As a Copy of an Existing Template'
,p_lov_return_value=>'COPY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/required_system_privielges
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(38912529512012913)
,p_lov_name=>'REQUIRED SYSTEM PRIVIELGES'
,p_lov_query=>'.'||wwv_flow_imp.id(38912529512012913)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475289
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(38912711366012914)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE TABLE'
,p_lov_return_value=>'CREATE TABLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(38912923572012916)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE VIEW'
,p_lov_return_value=>'CREATE VIEW'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(38913303206012917)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE PROCEDURE'
,p_lov_return_value=>'CREATE PROCEDURE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(38913506769012917)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE TRIGGER'
,p_lov_return_value=>'CREATE TRIGGER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(38919419731029097)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE OPERATOR'
,p_lov_return_value=>'CREATE OPERATOR'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(38919924233030353)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE INDEXTYPE'
,p_lov_return_value=>'CREATE INDEXTYPE'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(38920506010034595)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE TYPE '
,p_lov_return_value=>'CREATE TYPE '
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(38921321940039162)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE SYNONYM'
,p_lov_return_value=>'CREATE SYNONYM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(38921928173040971)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE DATABASE LINK'
,p_lov_return_value=>'CREATE DATABASE LINK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(104583500287639787)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE SEQUENCE'
,p_lov_return_value=>'CREATE SEQUENCE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(104583805482641282)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'CREATE MATERIALIZED VIEW'
,p_lov_return_value=>'CREATE MATERIALIZED VIEW'
);
end;
/
prompt --application/shared_components/user_interface/lovs/required_role
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(283664112341)
,p_lov_name=>'REQUIRED_ROLE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.d, a.r from (',
'    select wwv_flow_lang.system_message(''MUST_NOT_BE_PUBLIC_USER'') d,''MUST_NOT_BE_PUBLIC_USER'' r, 1',
'      from sys.dual',
'    union all',
'    select wwv_flow_escape.html(substr(name,1,50)),to_char(id), 1',
'      from wwv_flow_security_schemes',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID',
'    union all',
'    select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'',wwv_flow_escape.html(substr(name,1,50)))||''}'' d, ''!''||to_char(id) r, 2',
'      from wwv_flow_security_schemes',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID',
'    order by 3,1) a'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475290
);
end;
/
prompt --application/shared_components/user_interface/lovs/reset_grid
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1859045918048678074)
,p_lov_name=>'RESET GRID'
,p_lov_query=>'.'||wwv_flow_imp.id(1859045918048678074)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475290
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1859046605976678092)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Reset fixed region positions'
,p_lov_return_value=>'REGIONONLY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1859047081603678092)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Reset all region and item grid settings'
,p_lov_return_value=>'ALL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/reset_pagination_scope
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(10281732604346186)
,p_lov_name=>'RESET PAGINATION SCOPE'
,p_lov_query=>'.'||wwv_flow_imp.id(10281732604346186)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475290
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(10281906395346188)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Current Page'
,p_lov_return_value=>'PAGE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(10282110564346190)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Multiple Pages'
,p_lov_return_value=>'PAGES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(10282302589346191)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'All Pages'
,p_lov_return_value=>'APP'
);
end;
/
prompt --application/shared_components/user_interface/lovs/reset_pagination
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84827913193293462)
,p_lov_name=>'RESET_PAGINATION'
,p_lov_query=>'.'||wwv_flow_imp.id(84827913193293462)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475290
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84828126818293462)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Reset Pagination'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/reset_pagination_paren
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84877500529450588)
,p_lov_name=>'RESET_PAGINATION_PAREN'
,p_lov_query=>'.'||wwv_flow_imp.id(84877500529450588)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475290
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84877715480450589)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'reset pagination for this page'
,p_lov_return_value=>'YES'
);
end;
/
prompt --application/shared_components/user_interface/lovs/restricted_characters
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2137019810509690868)
,p_lov_name=>'RESTRICTED_CHARACTERS'
,p_lov_query=>'.'||wwv_flow_imp.id(2137019810509690868)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475290
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2137020431618690875)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Allowlist for a-Z, 0-9 and space'
,p_lov_return_value=>'US_ONLY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2137020026035690873)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Blocklist HTML command characters (<>")'
,p_lov_return_value=>'WEB_SAFE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2137020602276690875)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Blocklist &<>"/;,*|=% and --'
,p_lov_return_value=>'NO_SPECIAL_CHAR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2137020219582690875)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Blocklist &<>"/;,*|=% or -- and new line'
,p_lov_return_value=>'NO_SPECIAL_CHAR_NL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(426503525299715372)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Workspace Schema'
,p_lov_return_value=>'WORKSPACE_SCHEMA'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>'wwv_flow_security.g_security_group_id=10'
,p_lov_disp_cond2=>'PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/rest_http_method
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(33996111639139709)
,p_lov_name=>'REST_HTTP_METHOD'
,p_lov_query=>'.'||wwv_flow_imp.id(33996111639139709)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475290
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(33996316405139719)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'GET'
,p_lov_return_value=>'GET'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(33996526720139722)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'HEAD'
,p_lov_return_value=>'HEAD'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(33996731839139722)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'POST'
,p_lov_return_value=>'POST'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(33996909427139722)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'PUT'
,p_lov_return_value=>'PUT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(33997106044139722)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'DELETE'
,p_lov_return_value=>'DELETE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/rest_input_parameter_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(33552428712278769)
,p_lov_name=>'REST_INPUT_PARAMETER_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(33552428712278769)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475290
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(33552726333278771)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'String'
,p_lov_return_value=>'string'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(33552914074278772)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Binary'
,p_lov_return_value=>'binary'
);
end;
/
prompt --application/shared_components/user_interface/lovs/rest_output_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(33563708997950496)
,p_lov_name=>'REST_OUTPUT_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(33563708997950496)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475290
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(33564030843950503)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'XML'
,p_lov_return_value=>'xml'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(33564222947950504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Text'
,p_lov_return_value=>'text'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(295282210117418318)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'JSON'
,p_lov_return_value=>'json'
);
end;
/
prompt --application/shared_components/user_interface/lovs/rest_web_services
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(170459828884768626)
,p_lov_name=>'REST_WEB_SERVICES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'  from wwv_flow_shared_web_services',
' where action = ''REST''',
'   and flow_id = :FB_FLOW_ID',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475290
);
end;
/
prompt --application/shared_components/user_interface/lovs/return_error_message_y
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84906211376661916)
,p_lov_name=>'RETURN.ERROR.MESSAGE.Y'
,p_lov_query=>'.'||wwv_flow_imp.id(84906211376661916)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475290
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84906418542661917)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Return error message?'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/return_to_page_y
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84870610048415471)
,p_lov_name=>'RETURN_TO_PAGE_Y'
,p_lov_query=>'.'||wwv_flow_imp.id(84870610048415471)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475290
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84870825641415472)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Return to page'
,p_lov_return_value=>'YES'
);
end;
/
prompt --application/shared_components/user_interface/lovs/right_to_left
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(124580607576171078)
,p_lov_name=>'RIGHT-TO-LEFT'
,p_lov_query=>'.'||wwv_flow_imp.id(124580607576171078)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475290
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(124580923879171083)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Left-To-Right'
,p_lov_return_value=>'N'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(124581359286171085)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Right-To-Left'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/row_column
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(153414216516104717)
,p_lov_name=>'ROW_COLUMN'
,p_lov_query=>'.'||wwv_flow_imp.id(153414216516104717)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475290
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(153414507220104721)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Column'
,p_lov_return_value=>'GENERIC_COLUMNS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(153414716223104730)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Row'
,p_lov_return_value=>'NAMED_COLUMNS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/row_template_cond
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84772600380939607)
,p_lov_name=>'ROW_TEMPLATE_COND'
,p_lov_query=>'.'||wwv_flow_imp.id(84772600380939607)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475290
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84772803392939608)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Even Row Numbers'
,p_lov_return_value=>'EVEN_ROW_NUMBERS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84773017173939608)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Not Conditional'
,p_lov_return_value=>'NOT_CONDITIONAL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84773214166939609)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Odd Row Numbers'
,p_lov_return_value=>'ODD_ROW_NUMBERS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/row_template_cond2
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84871821607428292)
,p_lov_name=>'ROW_TEMPLATE_COND2'
,p_lov_query=>'.'||wwv_flow_imp.id(84871821607428292)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475290
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84872030804428293)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Use Based on PL/SQL Expression'
,p_lov_return_value=>'NOT_CONDITIONAL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84872231653428294)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Use for Even Numbered Rows'
,p_lov_return_value=>'EVEN_ROW_NUMBERS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84872405949428294)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Use for Odd Numbered Rows'
,p_lov_return_value=>'ODD_ROW_NUMBERS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/row_template_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84775019904954668)
,p_lov_name=>'ROW_TEMPLATE_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(84775019904954668)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475290
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84775203595954669)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Generic Columns (column template)'
,p_lov_return_value=>'GENERIC_COLUMNS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84775417405954670)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Named Column (row template)'
,p_lov_return_value=>'NAMED_COLUMNS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/rpt_edit_link
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(158022218250867826)
,p_lov_name=>'RPT_EDIT_LINK'
,p_lov_query=>'.'||wwv_flow_imp.id(158022218250867826)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475290
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(65569417483157832)
,p_lov_disp_sequence=>0
,p_lov_disp_value=>'<IMG SRC="#IMAGE_PREFIX#e2.gif" alt="&EDIT.">'
,p_lov_return_value=>'e2.gif'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(158022531259867827)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'<IMG SRC="#IMAGE_PREFIX#edit_big.gif" alt="&EDIT.">'
,p_lov_return_value=>'edit_big.gif'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(158022707875867828)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'<IMG SRC="#IMAGE_PREFIX#ed-item.gif" alt="&EDIT.">'
,p_lov_return_value=>'ed-item.gif'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(172484126127501725)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" height="16" width="16" alt="&EDIT.">'
,p_lov_return_value=>'menu/pencil16x16.gif'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(158023321688867829)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Edit'
,p_lov_return_value=>'Edit'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(158023522361867829)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Other Image'
,p_lov_return_value=>'Other'
);
end;
/
prompt --application/shared_components/user_interface/lovs/run_stateful_process_when
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84835322721333991)
,p_lov_name=>'RUN_STATEFUL_PROCESS_WHEN'
,p_lov_query=>'.'||wwv_flow_imp.id(84835322721333991)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475290
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84835504796333991)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Once Per Session or When Reset'
,p_lov_return_value=>'Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84835721953333992)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Once Per Page Visit (default)'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/sample_data_spreadsheets
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(716356186809790186)
,p_lov_name=>'SAMPLE.DATA.SPREADSHEETS'
,p_lov_query=>'.'||wwv_flow_imp.id(716356186809790186)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475291
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(149723684457672201)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Academic'
,p_lov_return_value=>'ACADEMIC'
,p_lov_template=>'#DISPLAY_VALUE#| icon-sample-dataset'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(716357248405790188)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Classic Departments and Employees'
,p_lov_return_value=>'DEPT_EMP'
,p_lov_template=>'#DISPLAY_VALUE#| icon-sample-dataset'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(726144908377227108)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Formula 1'
,p_lov_return_value=>'F1'
,p_lov_template=>'#DISPLAY_VALUE#| icon-sample-dataset'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(150181083020036213)
,p_lov_disp_sequence=>22
,p_lov_disp_value=>'JSON and Structured Test Data'
,p_lov_return_value=>'JSON_TEST'
,p_lov_template=>'#DISPLAY_VALUE#| icon-sample-dataset'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(176278124270074590)
,p_lov_disp_sequence=>23
,p_lov_disp_value=>'JSON only Test Data'
,p_lov_return_value=>'JSON'
,p_lov_template=>'#DISPLAY_VALUE#| icon-sample-dataset'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(732887738842814881)
,p_lov_disp_sequence=>25
,p_lov_disp_value=>'Movies'
,p_lov_return_value=>'MOVIE'
,p_lov_template=>'#DISPLAY_VALUE#| icon-sample-dataset'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(716356887500790188)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Project and Tasks'
,p_lov_return_value=>'PROJECTS'
,p_lov_template=>'#DISPLAY_VALUE#| icon-sample-dataset'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(724044540844893278)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Sales'
,p_lov_return_value=>'SALES'
,p_lov_template=>'#DISPLAY_VALUE#| icon-sample-dataset'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(725116269981095762)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Tennis'
,p_lov_return_value=>'TENNIS'
,p_lov_template=>'#DISPLAY_VALUE#| icon-sample-dataset'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(724037064656719501)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Vehicle Speed'
,p_lov_return_value=>'SPEED'
,p_lov_template=>'#DISPLAY_VALUE#| icon-sample-dataset'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(725325190828392565)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'World Cup'
,p_lov_return_value=>'WORLDCUP'
,p_lov_template=>'#DISPLAY_VALUE#| icon-sample-dataset'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(716356418611790188)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'World Population'
,p_lov_return_value=>'WORLD'
,p_lov_template=>'#DISPLAY_VALUE#| icon-sample-dataset'
);
end;
/
prompt --application/shared_components/user_interface/lovs/save_model
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(239865426281311683)
,p_lov_name=>'SAVE MODEL'
,p_lov_query=>'.'||wwv_flow_imp.id(239865426281311683)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475291
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(239865606836311683)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Save this definition as a design model for reuse'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/save_state_before_branching
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(19772421278475486)
,p_lov_name=>'SAVE_STATE_BEFORE_BRANCHING'
,p_lov_query=>'.'||wwv_flow_imp.id(19772421278475486)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475291
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(19772713449475497)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'save state before branching'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/schedule_builder_byday
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(601095219556747684)
,p_lov_name=>'SCHEDULE_BUILDER_BYDAY'
,p_lov_query=>'.'||wwv_flow_imp.id(601095219556747684)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475291
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601095400505747685)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Mon'
,p_lov_return_value=>'MON'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601095817105747685)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Tue'
,p_lov_return_value=>'TUE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601096242136747685)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Wed'
,p_lov_return_value=>'WED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601096661742747686)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Thu'
,p_lov_return_value=>'THU'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601097002601747686)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Fri'
,p_lov_return_value=>'FRI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601097459306747686)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Sat'
,p_lov_return_value=>'SAT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601097847875747687)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Sun'
,p_lov_return_value=>'SUN'
);
end;
/
prompt --application/shared_components/user_interface/lovs/schedule_builder_frequency
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(601098854036755106)
,p_lov_name=>'SCHEDULE_BUILDER_FREQUENCY'
,p_lov_query=>'.'||wwv_flow_imp.id(601098854036755106)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475291
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601099035732755106)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Weekly'
,p_lov_return_value=>'WEEKLY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601099445265755107)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Daily'
,p_lov_return_value=>'DAILY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601099887531755107)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Hourly'
,p_lov_return_value=>'HOURLY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601100292402755107)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Minutely'
,p_lov_return_value=>'MINUTELY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/search_config_icon_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2302791576703581)
,p_lov_name=>'SEARCH_CONFIG.ICON_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(2302791576703581)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475291
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2303094403703586)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Initials'
,p_lov_return_value=>'INITIALS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2303418448703587)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Icon Class'
,p_lov_return_value=>'STATIC_CLASS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2303802836703587)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Icon Class Column'
,p_lov_return_value=>'DYNAMIC_CLASS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2304867816715297)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Image URL'
,p_lov_return_value=>'URL'
,p_lov_disp_cond_type=>'CURRENT_PAGE_EQUALS_CONDITION'
,p_lov_disp_cond=>'3120'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2304517359713819)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Image BLOB Column'
,p_lov_return_value=>'BLOB'
,p_lov_disp_cond_type=>'CURRENT_PAGE_EQUALS_CONDITION'
,p_lov_disp_cond=>'3120'
);
end;
/
prompt --application/shared_components/user_interface/lovs/search_config_link_target_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2381418198192059)
,p_lov_name=>'SEARCH_CONFIG.LINK_TARGET_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(2381418198192059)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475292
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2381705201192063)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Redirect to URL'
,p_lov_return_value=>'REDIRECT_URL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2382149971192064)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Redirect to Page in this Application'
,p_lov_return_value=>'REDIRECT_PAGE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2382599916192064)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Redirect to Page in a different Application'
,p_lov_return_value=>'REDIRECT_APP'
);
end;
/
prompt --application/shared_components/user_interface/lovs/search_config_lists
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1761783533180994)
,p_lov_name=>'SEARCH_CONFIG.LISTS'
,p_source_type=>'TABLE'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_query_table=>'WWV_FLOW_LISTS'
,p_query_where=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_id = :FB_FLOW_ID',
'and security_group_id = :WORKSPACE_ID'))
,p_return_column_name=>'ID'
,p_display_column_name=>'NAME'
,p_group_sort_direction=>'ASC'
,p_default_sort_column_name=>'NAME'
,p_default_sort_direction=>'ASC'
,p_version_scn=>72475292
);
end;
/
prompt --application/shared_components/user_interface/lovs/search_config_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1813067828014706)
,p_lov_name=>'SEARCH_CONFIG.TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(1813067828014706)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475292
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1814179345014726)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Standard'
,p_lov_return_value=>'SIMPLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1813723363014726)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Oracle Text'
,p_lov_return_value=>'TEXT_MANUAL'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>'wwv_flow_db_version.c_has_text'
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(6081038648721189)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Oracle Ubiquitous Search'
,p_lov_return_value=>'TEXT_DBMS_SEARCH'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>'wwv_flow_db_version.c_has_dbms_search'
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1813335623014723)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'List'
,p_lov_return_value=>'APEX_LIST'
);
end;
/
prompt --application/shared_components/user_interface/lovs/search_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(4766813181334483)
,p_lov_name=>'SEARCH_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(4766813181334483)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475293
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4767009070334486)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Match Case'
,p_lov_return_value=>'CASE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/seconds
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(218750809842831008)
,p_lov_name=>'SECONDS'
,p_lov_query=>'.'||wwv_flow_imp.id(218750809842831008)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475293
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(218754417461833265)
,p_lov_disp_sequence=>0
,p_lov_disp_value=>'10 seconds'
,p_lov_return_value=>'10'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(218751030263831063)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'1 minute'
,p_lov_return_value=>'60'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(218751217877831100)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'10 minutes'
,p_lov_return_value=>'600'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(218751411947831100)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'30 minutes'
,p_lov_return_value=>'1800'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(218751606758831101)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'1 hour'
,p_lov_return_value=>'3600'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(218751804764831101)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'2 hours'
,p_lov_return_value=>'7200'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(218752012635831101)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'3 hours'
,p_lov_return_value=>'10800'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(218752221460831101)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'4 hours'
,p_lov_return_value=>'14400'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(218752413453831101)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'6 hours'
,p_lov_return_value=>'21600'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(218752623840831102)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'12 hours'
,p_lov_return_value=>'43200'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(218752826160831102)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'1 day'
,p_lov_return_value=>'86400'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(218753022810831102)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'2 days'
,p_lov_return_value=>'172800'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(218753207360831102)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'3 days'
,p_lov_return_value=>'259200'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(218753416227831102)
,p_lov_disp_sequence=>130
,p_lov_disp_value=>'4 days'
,p_lov_return_value=>'345600'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(218753611463831103)
,p_lov_disp_sequence=>140
,p_lov_disp_value=>'1 week'
,p_lov_return_value=>'604800'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(218753812160831103)
,p_lov_disp_sequence=>150
,p_lov_disp_value=>'2 weeks'
,p_lov_return_value=>'1209600'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(224123526155787261)
,p_lov_disp_sequence=>155
,p_lov_disp_value=>'4 Weeks'
,p_lov_return_value=>'2419200'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(224116700875779908)
,p_lov_disp_sequence=>160
,p_lov_disp_value=>'10 Weeks'
,p_lov_return_value=>'6048000'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(224124404815790588)
,p_lov_disp_sequence=>170
,p_lov_disp_value=>'1 Year'
,p_lov_return_value=>'31536000'
);
end;
/
prompt --application/shared_components/user_interface/lovs/seconds_small
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(433752258048536863)
,p_lov_name=>'SECONDS_SMALL'
,p_lov_query=>'.'||wwv_flow_imp.id(433752258048536863)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475293
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(433752591581536864)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'1 minute'
,p_lov_return_value=>'60'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(433752927587536866)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'2 minutes'
,p_lov_return_value=>'120'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(433753313173536866)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'3 minutes'
,p_lov_return_value=>'180'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(433753718809536866)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'4 minutes'
,p_lov_return_value=>'240'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(433754195947536866)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'5 minutes'
,p_lov_return_value=>'300'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(433754557049536866)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'10 minutes'
,p_lov_return_value=>'600'
);
end;
/
prompt --application/shared_components/user_interface/lovs/select_cache_management_process_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(8261624729096999)
,p_lov_name=>'SELECT.CACHE.MANAGEMENT.PROCESS.TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(8261624729096999)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475293
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(8261900096097002)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Clear Cache For Applications (removes all session state for listed applications)'
,p_lov_return_value=>'CLEAR_CACHE_FOR_FLOWS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(8262130496097003)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Clear Cache For Current Application (removes all session state for current application)'
,p_lov_return_value=>'CLEAR_CACHE_CURRENT_FLOW'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(8262316343097003)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Clear Cache For Current Session (removes all state for current session)'
,p_lov_return_value=>'RESET_SESSION_STATE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(8262529998097003)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Clear Cache for Items (ITEM,ITEM,ITEM)'
,p_lov_return_value=>'CLEAR_CACHE_FOR_ITEMS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(8262724410097004)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Clear Cache for all Items on Pages (PageID,PageID,PageID)'
,p_lov_return_value=>'CLEAR_CACHE_FOR_PAGES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(8262912312097004)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Initialize all page items'
,p_lov_return_value=>'INITIALIZE_ALL_PAGE_ITEMS'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(8263116418097004)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Reset Preferences (remove all preferences for current user)'
,p_lov_return_value=>'RESET_USER_PREFERENCES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(8263331569097004)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Set Preference to value of Item (PreferenceName:ITEM)'
,p_lov_return_value=>'SET_PREFERENCE_TO_ITEM_VALUE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(8263502372097005)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Set Preference to value of Item if item is not null (PreferenceName:ITEM)'
,p_lov_return_value=>'SET_PREFERENCE_TO_ITEM_VALUE_IF_ITEM_NOT_NULL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/select_pagination_process_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(8208625525879595)
,p_lov_name=>'SELECT.PAGINATION.PROCESS.TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(8208625525879595)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475293
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(8208910190879598)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Reset Pagination'
,p_lov_return_value=>'RESET_PAGINATION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(8209131484879599)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Reset Pagination For All Pages'
,p_lov_return_value=>'INITIALIZE_PAGINATION_FOR_ALL_PAGES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(8209325215879600)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Reset Pagination For Page(s) (PageID,PageID,PageID)'
,p_lov_return_value=>'INITIALIZE_PAGE_PAGINATION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/session_cookie_sharing
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(46630896750249951)
,p_lov_name=>'SESSION COOKIE SHARING'
,p_lov_query=>'.'||wwv_flow_imp.id(46630896750249951)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475293
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(46631189628249955)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Application (No Sharing)'
,p_lov_return_value=>'A'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(46631517972249955)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Workspace Sharing'
,p_lov_return_value=>'W'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(46631998587249955)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Custom'
,p_lov_return_value=>'C'
);
end;
/
prompt --application/shared_components/user_interface/lovs/session_state_view_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(201460728952037663)
,p_lov_name=>'SESSION STATE VIEW OPTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(201460728952037663)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475293
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(201460911220037664)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Page Items'
,p_lov_return_value=>'P'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(201461105565037666)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Application Items'
,p_lov_return_value=>'I'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(201461325287037666)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Session State'
,p_lov_return_value=>'S'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(201461505002037666)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Collections'
,p_lov_return_value=>'C'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1808289529695466)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Background Executions'
,p_lov_return_value=>'BG'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(116336811370337963)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'All'
,p_lov_return_value=>'A'
);
end;
/
prompt --application/shared_components/user_interface/lovs/session_joining
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(487255841087229838)
,p_lov_name=>'SESSION_JOINING'
,p_lov_query=>'.'||wwv_flow_imp.id(487255841087229838)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475293
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(487256183344229845)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Enabled'
,p_lov_return_value=>'Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(487256453829229849)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Disabled'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/session_state_commits
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2404156723407174)
,p_lov_name=>'SESSION_STATE_COMMITS'
,p_lov_query=>'.'||wwv_flow_imp.id(2404156723407174)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475293
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2404283318408620)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Immediate'
,p_lov_return_value=>'IMMEDIATE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2404319296408674)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'End Of Request'
,p_lov_return_value=>'END_OF_REQUEST'
);
end;
/
prompt --application/shared_components/user_interface/lovs/shared_component_conditions
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(179567005218713166)
,p_lov_name=>'SHARED COMPONENT CONDITIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(179567005218713166)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475293
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(179575608989761516)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Standard Tabs'
,p_lov_return_value=>'TAB'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(179575911760762378)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Parent Tabs'
,p_lov_return_value=>'PTAB'
);
end;
/
prompt --application/shared_components/user_interface/lovs/shortcut_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84752421139794200)
,p_lov_name=>'SHORTCUT_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(84752421139794200)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475293
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84752622050794201)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Function Body returning VARCHAR2'
,p_lov_return_value=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84752832725794201)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'HTML Text'
,p_lov_return_value=>'HTML_TEXT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84753011629794202)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'HTML Text with Escaped Special Chars'
,p_lov_return_value=>'HTML_TEXT_ESCAPE_SC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84753228273794202)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Image'
,p_lov_return_value=>'IMAGE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(11964900251347159)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Text with JavaScript Escaped Single Quotes'
,p_lov_return_value=>'TEXT_ESCAPE_JS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(11965906831349042)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Message'
,p_lov_return_value=>'MESSAGE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(11968015488351531)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Message with JavaScript Escaped Single Quotes'
,p_lov_return_value=>'MESSAGE_ESCAPE_JS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/shortcut_wiz_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84343606432636502)
,p_lov_name=>'SHORTCUT_WIZ_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(84343606432636502)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475293
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88312022558829215)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'From Scratch'
,p_lov_return_value=>'BLANK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88312201540829216)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'As a Copy of an Existing Shortcut'
,p_lov_return_value=>'COPY'
);
end;
/
prompt --application/shared_components/user_interface/lovs/show_all_lov
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(138231514317962802)
,p_lov_name=>'SHOW ALL LOV'
,p_lov_query=>'.'||wwv_flow_imp.id(138231514317962802)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475293
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(138231707947962807)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'All'
,p_lov_return_value=>'ALL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(138231929246962812)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Popup Only'
,p_lov_return_value=>'POPUP'
);
end;
/
prompt --application/shared_components/user_interface/lovs/show_temp_subscribed_all_or_not
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(76989619199545586)
,p_lov_name=>'SHOW TEMP SUBSCRIBED ALL OR NOT'
,p_lov_query=>'.'||wwv_flow_imp.id(76989619199545586)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475293
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(76990030696545589)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'All Templates'
,p_lov_return_value=>'ALL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(76989818710545588)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Subscribed Templates'
,p_lov_return_value=>'REF'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(76990727856548087)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Not Subscribed Templates'
,p_lov_return_value=>'NOT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/show_themes
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(131260202585040081)
,p_lov_name=>'SHOW THEMES'
,p_lov_query=>'.'||wwv_flow_imp.id(131260202585040081)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475294
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(131260406218040082)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'All Themes'
,p_lov_return_value=>'ALL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(131260813106040083)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'Standard Themes'
,p_lov_return_value=>'STANDARD'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(131260606234040083)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Custom Themes'
,p_lov_return_value=>'CUSTOM'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_themes t',
' where t.theme_security_group_id is null',
'   and t.security_group_id = 11',
'   and t.flow_id in (select id from wwv_flows where application_type = ''STANDARD'' and security_group_id = 11)',
'   and t.theme_id > 99',
'   and t.navigation_type = :P3000_NAVIGATION_TYPE',
'union',
'select 1',
'  from wwv_flow_themes t',
' where theme_security_group_id = :WORKSPACE_ID',
'   and security_group_id = 11   ',
'   and t.navigation_type = :P3000_NAVIGATION_TYPE'))
,p_required_patch=>wwv_flow_imp.id(121426746309283317)
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(46613624991069841)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Legacy Themes'
,p_lov_return_value=>'LEGACY'
,p_lov_disp_cond_type=>'EXPRESSION'
,p_lov_disp_cond=>':P3000_NAVIGATION_TYPE = ''T'''
,p_lov_disp_cond2=>'PLSQL'
,p_required_patch=>wwv_flow_imp.id(121426746309283317)
);
end;
/
prompt --application/shared_components/user_interface/lovs/show_all_computations
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(86066623184768918)
,p_lov_name=>'SHOW_ALL_COMPUTATIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(86066623184768918)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475294
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88312825674830068)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Yes'
,p_lov_return_value=>'999999999999'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88313032367830069)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'No'))
,p_lov_return_value=>'15'
);
end;
/
prompt --application/shared_components/user_interface/lovs/show_grid
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(3278509884198440)
,p_lov_name=>'SHOW_GRID'
,p_lov_query=>'.'||wwv_flow_imp.id(3278509884198440)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475294
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3278823071198441)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Show Grid Line'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/show_legend
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84866116927389078)
,p_lov_name=>'SHOW_LEGEND'
,p_lov_query=>'.'||wwv_flow_imp.id(84866116927389078)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475294
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84866317039389078)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Show Legend'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/show_success_in_future
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84242708005400457)
,p_lov_name=>'SHOW_SUCCESS_IN_FUTURE'
,p_lov_query=>'.'||wwv_flow_imp.id(84242708005400457)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475294
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84242917723400457)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Do not show success page in the future'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/show_template_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84336604916626643)
,p_lov_name=>'SHOW_TEMPLATE_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(84336604916626643)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475294
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84337430906626644)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Breadcrumb'
,p_lov_return_value=>'Menu'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84336821420626643)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Button'
,p_lov_return_value=>'Button'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(47822118021181823)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'Legacy Calendar'
,p_lov_return_value=>'Calendar'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84337026704626644)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Field'
,p_lov_return_value=>'Field'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84337230566626644)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'List'
,p_lov_return_value=>'List'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84337622898626644)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Page'
,p_lov_return_value=>'Page'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84337805044626645)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Region'
,p_lov_return_value=>'Region'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84338018705626645)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Report'
,p_lov_return_value=>'Report'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1467333588944879614)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Popup LOV '
,p_lov_return_value=>'Popuplov'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7462151809992565)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'Template Component'
,p_lov_return_value=>'TemplateComponent'
);
end;
/
prompt --application/shared_components/user_interface/lovs/simplechart_paginationstyles
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(93470022413475791)
,p_lov_name=>'SIMPLECHART.PAGINATIONSTYLES'
,p_lov_query=>'.'||wwv_flow_imp.id(93470022413475791)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475294
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(93470332223475797)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Select List'
,p_lov_return_value=>'R'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(93470502299475799)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Search Engine'
,p_lov_return_value=>'E'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(93470704611475799)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Rows X -Y of Z (with next and previous buttons)'
,p_lov_return_value=>'P'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(99827615159625086)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'No Pagination'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/simplechart_summary
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(85992212281453507)
,p_lov_name=>'SIMPLECHART.SUMMARY'
,p_lov_query=>'.'||wwv_flow_imp.id(85992212281453507)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475294
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(85992527482453514)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Number of data points'
,p_lov_return_value=>'C'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(85992719931453514)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Axis'
,p_lov_return_value=>'A'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(85992930659453515)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Minimum value '
,p_lov_return_value=>'M'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(85993100384453515)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Maximum value'
,p_lov_return_value=>'X'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(85993304681453515)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Average value'
,p_lov_return_value=>'V'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(85993522601453515)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Sum of all values'
,p_lov_return_value=>'S'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(85993713082453516)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'First value'
,p_lov_return_value=>'F'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(85993914783453516)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Last value'
,p_lov_return_value=>'L'
);
end;
/
prompt --application/shared_components/user_interface/lovs/simplified_region_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(28331928066600148)
,p_lov_name=>'SIMPLIFIED.REGION.TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(28331928066600148)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475295
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(28332230854600155)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Report'
,p_lov_return_value=>'REPORT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(28332427630600158)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Web Service'
,p_lov_return_value=>'WEB_SERVICE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(28332629807600158)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Chart'
,p_lov_return_value=>'CHART'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(28332816374600158)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Help Text'
,p_lov_return_value=>'HELP_TEXT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(28333024667600158)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Static Content'
,p_lov_return_value=>'HTML'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(28333221783600159)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Tree'
,p_lov_return_value=>'TREE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(28333403597600159)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'PL/SQL'
,p_lov_return_value=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(28333621226600159)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'URL'
,p_lov_return_value=>'URL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(28333810937600159)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Calendar'
,p_lov_return_value=>'CALENDAR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(28334027077600160)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Menu'
,p_lov_return_value=>'MENU'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(28334201168600160)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'List'
,p_lov_return_value=>'LIST'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(28370021803071485)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Tabular Form'
,p_lov_return_value=>'TABULAR_FORM'
);
end;
/
prompt --application/shared_components/user_interface/lovs/sort_nulls
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(93797019007450994)
,p_lov_name=>'SORT NULLS'
,p_lov_query=>'.'||wwv_flow_imp.id(93797019007450994)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475295
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(93797213790450997)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'First'
,p_lov_return_value=>'F'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(93797405616450997)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Last'
,p_lov_return_value=>'L'
);
end;
/
prompt --application/shared_components/user_interface/lovs/sort_directions
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(601135878417900624)
,p_lov_name=>'SORT_DIRECTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(601135878417900624)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475295
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601136053597900624)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Ascending (Nulls Last)'
,p_lov_return_value=>'ASC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601136431456900625)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Ascending (Nulls First)'
,p_lov_return_value=>'ASC_NULLS_FIRST'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601136832942900625)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Descending (Nulls Last)'
,p_lov_return_value=>'DESC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(601137274557900625)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Descending (Nulls First)'
,p_lov_return_value=>'DESC_NULLS_FIRST'
);
end;
/
prompt --application/shared_components/user_interface/lovs/standard_icon_sizes
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1700420804690087)
,p_lov_name=>'STANDARD ICON SIZES'
,p_lov_query=>'.'||wwv_flow_imp.id(1700420804690087)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475295
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(208694932527642212)
,p_lov_disp_sequence=>0
,p_lov_disp_value=>'16x16'
,p_lov_return_value=>'16'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(130922308813815749)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'20x20'
,p_lov_return_value=>'20'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1700832074690087)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'32x32'
,p_lov_return_value=>'32'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1700624248690087)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'64x64'
,p_lov_return_value=>'64'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(112354600646082973)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'128x128'
,p_lov_return_value=>'128'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(145794820863445874)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'140x90'
,p_lov_return_value=>'140'
);
end;
/
prompt --application/shared_components/user_interface/lovs/standard_icon_sizes_2
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(208711104382927390)
,p_lov_name=>'STANDARD ICON SIZES 2'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''12x12''	 d, 12  r from dual union all',
'select ''16x16''	 d, 16  r from dual union all',
'select ''20x20''	 d, 20  r from dual union all',
'select ''32x32''	 d, 32  r from dual union all',
'select ''64x64''	 d, 64  r from dual union all',
'select ''128x128'' d, 128 r from dual union all',
'select ''140x90''	 d, 140 r from dual',
'order by 2'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475295
);
end;
/
prompt --application/shared_components/user_interface/lovs/standard_page_codes
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(5402514727348886)
,p_lov_name=>'STANDARD PAGE CODES'
,p_lov_query=>'.'||wwv_flow_imp.id(5402514727348886)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475295
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(5739801369768982)
,p_lov_disp_sequence=>0
,p_lov_disp_value=>'Home'
,p_lov_return_value=>'13'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(5831629645510743)
,p_lov_disp_sequence=>0
,p_lov_disp_value=>'Global Page'
,p_lov_return_value=>'14'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(5402701440348886)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Tabular Form'
,p_lov_return_value=>'01'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(5402909385348887)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'DML Form'
,p_lov_return_value=>'02'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(5403122972348887)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Report'
,p_lov_return_value=>'03'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(5403327785348887)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Chart'
,p_lov_return_value=>'04'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(5403520568348887)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Web Service'
,p_lov_return_value=>'05'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(5403731475348887)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Navigation'
,p_lov_return_value=>'06'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(5403924082348887)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Tree'
,p_lov_return_value=>'07'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(5404107694348887)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Calendar'
,p_lov_return_value=>'08'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(5404331595348888)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'URL'
,p_lov_return_value=>'09'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(5404515117348888)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Dynamic HTML'
,p_lov_return_value=>'10'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(5404700114348888)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Static HTML'
,p_lov_return_value=>'11'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(5719116485489493)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Login'
,p_lov_return_value=>'12'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(5866501145720101)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Blank'
,p_lov_return_value=>'15'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(8481401022510038)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Dynamic Form'
,p_lov_return_value=>'16'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(8486621763563293)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Navigation Form'
,p_lov_return_value=>'17'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(95820812557710460)
,p_lov_disp_sequence=>18
,p_lov_disp_value=>'Interactive Report'
,p_lov_return_value=>'18'
);
end;
/
prompt --application/shared_components/user_interface/lovs/standard_condition_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(13602414170805697)
,p_lov_name=>'STANDARD_CONDITION_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(13602414170805697)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475296
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(13603123074805757)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Exists (SQL query returns at least one row)'
,p_lov_return_value=>'EXISTS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(13603317895805758)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'NOT Exists (SQL query returns no rows)'
,p_lov_return_value=>'NOT_EXISTS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(13602817848805747)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Expression'
,p_lov_return_value=>'EXPRESSION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(13989216069093119)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Function Body Returning a Boolean'
,p_lov_return_value=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15047020206284804)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Request = Expression 1'
,p_lov_return_value=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15047716971286340)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Request != Expression 1'
,p_lov_return_value=>'REQUEST_NOT_EQUAL_CONDITION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15165118412046187)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Request Is Contained within Expression 1'
,p_lov_return_value=>'REQUEST_IN_CONDITION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15166516040047219)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'Request Is NOT Contained within Expression 1'
,p_lov_return_value=>'REQUEST_NOT_IN_CONDITION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(13603921598805759)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'Value of Item / Column in Expression 1 = Expression 2'
,p_lov_return_value=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(13604123781805759)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'Value of Item / Column in Expression 1 != Expression 2'
,p_lov_return_value=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(13603529275805758)
,p_lov_disp_sequence=>130
,p_lov_disp_value=>'Value of Item / Column in Expression 1 Is NULL'
,p_lov_return_value=>'ITEM_IS_NULL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(13603702602805758)
,p_lov_disp_sequence=>140
,p_lov_disp_value=>'Value of Item / Column in Expression 1 Is NOT NULL'
,p_lov_return_value=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15011515800134964)
,p_lov_disp_sequence=>150
,p_lov_disp_value=>'Value of Item / Column in Expression 1 = Zero'
,p_lov_return_value=>'ITEM_IS_ZERO'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15045831204279794)
,p_lov_disp_sequence=>160
,p_lov_disp_value=>'Value of Item / Column in Expression 1 != Zero'
,p_lov_return_value=>'ITEM_IS_NOT_ZERO'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(13990910462095775)
,p_lov_disp_sequence=>170
,p_lov_disp_value=>'Value of Item / Column in Expression 1 Is NULL or Zero'
,p_lov_return_value=>'ITEM_IS_NULL_OR_ZERO'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15470011873930461)
,p_lov_disp_sequence=>180
,p_lov_disp_value=>'Value of Item / Column in Expression 1 Is NOT null and the Item Is NOT Zero'
,p_lov_return_value=>'ITEM_NOT_NULL_OR_ZERO'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15491720474956815)
,p_lov_disp_sequence=>190
,p_lov_disp_value=>'Value of Item / Column in Expression 1 Contains No Spaces'
,p_lov_return_value=>'ITEM_CONTAINS_NO_SPACES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15476321781941049)
,p_lov_disp_sequence=>200
,p_lov_disp_value=>'Value of Item / Column in Expression 1 Is Numeric'
,p_lov_return_value=>'ITEM_IS_NUMERIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(85622123329305508)
,p_lov_disp_sequence=>201
,p_lov_disp_value=>'Value of Item / Column in Expression 1 Is Not Numeric'
,p_lov_return_value=>'ITEM_IS_NOT_NUMERIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15471900443935744)
,p_lov_disp_sequence=>210
,p_lov_disp_value=>'Value of Item / Column in Expression 1 Is Alphanumeric'
,p_lov_return_value=>'ITEM_IS_ALPHANUMERIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(16378325840224231)
,p_lov_disp_sequence=>220
,p_lov_disp_value=>'Value of Item / Column in Expression 1 Is Contained within Colon Delimited List in Expression 2'
,p_lov_return_value=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(37749811129022200)
,p_lov_disp_sequence=>230
,p_lov_disp_value=>'Value of Item / Column in Expression 1 Is NOT Contained within Colon Delimited List in Expression 2'
,p_lov_return_value=>'VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(14091700023206920)
,p_lov_disp_sequence=>240
,p_lov_disp_value=>'Value of User Preference in Expression 1 = Expression 2'
,p_lov_return_value=>'USER_PREF_IN_COND_EQ_COND2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(14093528694208826)
,p_lov_disp_sequence=>250
,p_lov_disp_value=>'Value of User Preference in Expression 1 != Expression 2'
,p_lov_return_value=>'USER_PREF_IN_COND_NOT_EQ_COND2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(14021821208136360)
,p_lov_disp_sequence=>260
,p_lov_disp_value=>'Current page = Expression 1'
,p_lov_return_value=>'CURRENT_PAGE_EQUALS_CONDITION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(14267417194095422)
,p_lov_disp_sequence=>270
,p_lov_disp_value=>'Current page != Expression 1'
,p_lov_return_value=>'CURRENT_PAGE_NOT_EQUAL_CONDITION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(14001701823114905)
,p_lov_disp_sequence=>280
,p_lov_disp_value=>'Current Page Is Contained Within Expression 1 (comma delimited list of pages)'
,p_lov_return_value=>'CURRENT_PAGE_IN_CONDITION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(14003630925116682)
,p_lov_disp_sequence=>290
,p_lov_disp_value=>'Current Page Is NOT in Expression 1 (comma delimited list of pages)'
,p_lov_return_value=>'CURRENT_PAGE_NOT_IN_CONDITION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15039116780255999)
,p_lov_disp_sequence=>300
,p_lov_disp_value=>'Current Page = Page Submitted (this page was posted)'
,p_lov_return_value=>'WHEN_THIS_PAGE_SUBMITTED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15039807291260459)
,p_lov_disp_sequence=>310
,p_lov_disp_value=>'Current Page != Page Submitted (this page was not the page posted)'
,p_lov_return_value=>'WHEN_THIS_PAGE_NOT_SUBMITTED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15037208597244692)
,p_lov_disp_sequence=>320
,p_lov_disp_value=>'Current Page Is in Printer Friendly Mode'
,p_lov_return_value=>'PAGE_IS_IN_PRINTER_FRIENDLY_MODE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15037905362246171)
,p_lov_disp_sequence=>330
,p_lov_disp_value=>'Current page is NOT in Printer Friendly Mode'
,p_lov_return_value=>'PAGE_IS_NOT_IN_PRINTER_FRIENDLY_MODE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17138426279336021)
,p_lov_disp_sequence=>340
,p_lov_disp_value=>'Text in Expression 1 Is Contained in Value of Item / Column in Expression 2'
,p_lov_return_value=>'CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15008126596114779)
,p_lov_disp_sequence=>350
,p_lov_disp_value=>'Text in Expression 1 Is Contained within the Text in Expression 2'
,p_lov_return_value=>'DISPLAY_COND_IN_COND_TEXT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15008817538118931)
,p_lov_disp_sequence=>360
,p_lov_disp_value=>'Text in Expression 1 Is NOT Contained within the Text in Expression 2'
,p_lov_return_value=>'DISPLAY_COND_NOT_IN_COND_TEXT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15006711512106511)
,p_lov_disp_sequence=>370
,p_lov_disp_value=>'Text in Expression 1 = Expression 2 (includes &ITEM. substitutions)'
,p_lov_return_value=>'DISPLAY_COND_EQUAL_COND_TEXT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15007405258109453)
,p_lov_disp_sequence=>380
,p_lov_disp_value=>'Text in Expression 1 != Expression 2 (includes &ITEM. substitutions)'
,p_lov_return_value=>'DISP_COND_NOT_EQUAL_COND_TEXT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17067417234166851)
,p_lov_disp_sequence=>385
,p_lov_disp_value=>'Page/Region is Read Only'
,p_lov_return_value=>'IS_READ_ONLY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17067626931169663)
,p_lov_disp_sequence=>387
,p_lov_disp_value=>'Page/Region is NOT Read Only'
,p_lov_return_value=>'IS_NOT_READ_ONLY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(13995619938106517)
,p_lov_disp_sequence=>390
,p_lov_disp_value=>'User is Authenticated  (not public)'
,p_lov_return_value=>'USER_IS_NOT_PUBLIC_USER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(13994228133102772)
,p_lov_disp_sequence=>400
,p_lov_disp_value=>'User is the Public User (user has not authenticated)'
,p_lov_return_value=>'USER_IS_PUBLIC_USER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4814310982912915)
,p_lov_disp_sequence=>410
,p_lov_disp_value=>'Inline Validation Errors Displayed'
,p_lov_return_value=>'DISPLAYING_INLINE_VALIDATION_ERRORS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4815518518924629)
,p_lov_disp_sequence=>420
,p_lov_disp_value=>'No Inline Validation Errors Displayed'
,p_lov_return_value=>'NOT_DISPLAYING_INLINE_VALIDATION_ERRORS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17189121220460009)
,p_lov_disp_sequence=>430
,p_lov_disp_value=>'SQL Reports (OK to show the forward button)'
,p_lov_return_value=>'MAX_ROWS_LT_ROWS_FETCHED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17186825533457975)
,p_lov_disp_sequence=>440
,p_lov_disp_value=>'SQL Reports (OK to show the back button)'
,p_lov_return_value=>'MIN_ROW_GT_THAN_ONE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4929605646440424)
,p_lov_disp_sequence=>450
,p_lov_disp_value=>'Client Browser: Mozilla, Netscape 6.x/7x or higher'
,p_lov_return_value=>'BROWSER_IS_NSCP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4928131488438441)
,p_lov_disp_sequence=>460
,p_lov_disp_value=>'Client Browser: Microsoft Internet Explorer 5.5, 6.0 or higher'
,p_lov_return_value=>'BROWSER_IS_MSIE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(5886202180257756)
,p_lov_disp_sequence=>470
,p_lov_disp_value=>'Client Browser: XHTML / CSS capable browser'
,p_lov_return_value=>'BROWSER_IS_MSIE_OR_NSCP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(5886511530260376)
,p_lov_disp_sequence=>480
,p_lov_disp_value=>'Client Browser: Other browsers (or older version)'
,p_lov_return_value=>'BROWSER_IS_OTHER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15016115991165257)
,p_lov_disp_sequence=>490
,p_lov_disp_value=>'Current Language Is Contained within Expression 1'
,p_lov_return_value=>'CURRENT_LANG_IN_COND1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15016810384167816)
,p_lov_disp_sequence=>500
,p_lov_disp_value=>'Current Language Is NOT Contained within Expression 1'
,p_lov_return_value=>'CURRENT_LANG_NOT_IN_COND1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15015429146159113)
,p_lov_disp_sequence=>510
,p_lov_disp_value=>'Current Language != Expression 1'
,p_lov_return_value=>'CURRENT_LANG_NOT_EQ_COND1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15014702201156470)
,p_lov_disp_sequence=>520
,p_lov_disp_value=>'Current Language = Expression 1'
,p_lov_return_value=>'CURRENT_LANG_EQ_COND1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(14059905871173891)
,p_lov_disp_sequence=>530
,p_lov_disp_value=>'When CGI_ENV DAD_NAME = Expression 1'
,p_lov_return_value=>'DAD_NAME_EQ_CONDITION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(14063031307177276)
,p_lov_disp_sequence=>540
,p_lov_disp_value=>'When CGI_ENV DAD_NAME != Expression 1'
,p_lov_return_value=>'DAD_NAME_NOT_EQ_CONDITION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(14035803295159838)
,p_lov_disp_sequence=>550
,p_lov_disp_value=>'When CGI_ENV SERVER_NAME = Expression 1'
,p_lov_return_value=>'SERVER_NAME_EQ_CONDITION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(14039027868163631)
,p_lov_disp_sequence=>560
,p_lov_disp_value=>'When CGI_ENV SERVER_NAME != Expression 1'
,p_lov_return_value=>'SERVER_NAME_NOT_EQ_CONDITION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(14028423999150274)
,p_lov_disp_sequence=>570
,p_lov_disp_value=>'When CGI_ENV HTTP_HOST = Expression 1'
,p_lov_return_value=>'HTTP_HOST_EQ_CONDITION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(14030116882153510)
,p_lov_disp_sequence=>580
,p_lov_disp_value=>'When CGI_ENV HTTP_HOST != Expression 1'
,p_lov_return_value=>'HTTP_HOST_NOT_EQ_CONDITION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(13966801644069447)
,p_lov_disp_sequence=>999
,p_lov_disp_value=>'Never'
,p_lov_return_value=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(167852523543243817)
,p_lov_disp_sequence=>1000
,p_lov_disp_value=>'Always'
,p_lov_return_value=>'ALWAYS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/start_tree
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84323624609603883)
,p_lov_name=>'START_TREE'
,p_lov_query=>'.'||wwv_flow_imp.id(84323624609603883)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475296
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88313628445830962)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Based on Existing Item'
,p_lov_return_value=>'ITEM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88313830642830963)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Based on a SQL Query'
,p_lov_return_value=>'SQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88314026283830963)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Based on Static Value'
,p_lov_return_value=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(492838704369360119)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Value is NULL'
,p_lov_return_value=>'NULL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/static_or_item
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(194124529474988937)
,p_lov_name=>'STATIC OR ITEM'
,p_lov_query=>'.'||wwv_flow_imp.id(194124529474988937)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475296
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(194124717685988940)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Static Value'
,p_lov_return_value=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(194124922999988942)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Item Name'
,p_lov_return_value=>'ITEM'
);
end;
/
prompt --application/shared_components/user_interface/lovs/static_dynamic
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84786916665020021)
,p_lov_name=>'STATIC_DYNAMIC'
,p_lov_query=>'.'||wwv_flow_imp.id(84786916665020021)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475296
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84787126609020022)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Dynamic'
,p_lov_return_value=>'D'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84787325791020022)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Static'
,p_lov_return_value=>'S'
);
end;
/
prompt --application/shared_components/user_interface/lovs/static_files
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84307528025576497)
,p_lov_name=>'STATIC_FILES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'initcap(',
'wwv_flow_lang.system_message(''ALL_STATIC_FILES''))d , -1 r',
'  from dual',
'union all',
'select wwv_flow_lang.system_message(''STATIC_FILES_NO_APPLICATION'') d, 0 r',
'  from dual',
'union all',
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flows f',
'where  security_group_id = :flow_security_group_id and',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id is null and security_group_id = :flow_security_group_id )',
'       or',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id = f.id and security_group_id = :flow_security_group_id )',
'order by 2'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475296
);
end;
/
prompt --application/shared_components/user_interface/lovs/stay
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(86063932403762069)
,p_lov_name=>'STAY'
,p_lov_query=>'.'||wwv_flow_imp.id(86063932403762069)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475296
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88314631562831853)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Return to Page'
,p_lov_return_value=>'YES'
);
end;
/
prompt --application/shared_components/user_interface/lovs/stay_on_page
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(159773503131383335)
,p_lov_name=>'STAY_ON_PAGE'
,p_lov_query=>'.'||wwv_flow_imp.id(159773503131383335)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475296
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(159773814876383337)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'&nbsp;'
,p_lov_return_value=>'YES'
);
end;
/
prompt --application/shared_components/user_interface/lovs/steps_std_tab
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84327116428611002)
,p_lov_name=>'STEPS_STD_TAB'
,p_lov_query=>'.'||wwv_flow_imp.id(84327116428611002)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475296
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88315201910832737)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'All steps use same standard tab'
,p_lov_return_value=>'ALL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88315426760832737)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'One standard tab per step'))
,p_lov_return_value=>'ONE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/subscribed_unsubscribed
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84896716300568756)
,p_lov_name=>'SUBSCRIBED.UNSUBSCRIBED'
,p_lov_query=>'.'||wwv_flow_imp.id(84896716300568756)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475296
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84896922929568758)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Subscribed'
,p_lov_return_value=>'SUB'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84897130563568758)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Unsubscribed'
,p_lov_return_value=>'UNSUB'
);
end;
/
prompt --application/shared_components/user_interface/lovs/supported_item_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1415923876037819)
,p_lov_name=>'SUPPORTED_ITEM_TYPES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name,',
'       name_with_prefix',
'  from wwv_flow_all_plugins',
' where plugin_type               = ''ITEM TYPE''',
'   and is_deprecated             = ''N''',
'   and is_legacy                 = ''N''',
'   and supported_component_types like ''%APEX_APPLICATION_PAGE_ITEMS%''',
''))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_return_column_name=>'NAME_WITH_PREFIX'
,p_display_column_name=>'DISPLAY_NAME'
,p_group_sort_direction=>'ASC'
,p_default_sort_column_name=>'DISPLAY_NAME'
,p_default_sort_direction=>'ASC'
,p_version_scn=>229909738
);
end;
/
prompt --application/shared_components/user_interface/lovs/supported_region_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1447420798857654)
,p_lov_name=>'SUPPORTED_REGION_TYPES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name, ',
'       name_with_prefix',
'  from wwv_flow_all_plugins ',
' where is_deprecated     = ''N''',
'   and is_legacy         = ''N''',
'   and plugin_type in (''REGION TYPE'',''TEMPLATE COMPONENT'')',
''))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_return_column_name=>'NAME_WITH_PREFIX'
,p_display_column_name=>'DISPLAY_NAME'
,p_group_sort_direction=>'ASC'
,p_default_sort_column_name=>'DISPLAY_NAME'
,p_default_sort_direction=>'ASC'
,p_version_scn=>229483022
);
end;
/
prompt --application/shared_components/user_interface/lovs/supporting_object_script_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(57799129745997268)
,p_lov_name=>'SUPPORTING OBJECT SCRIPT TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(57799129745997268)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475296
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(57799329552997269)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Install'
,p_lov_return_value=>'INSTALL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(57799516609997270)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Upgrade'
,p_lov_return_value=>'UPGRADE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(57930331990310140)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Deinstall'
,p_lov_return_value=>'DEINSTALL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/svg_chart_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(13873818427997807)
,p_lov_name=>'SVG CHART TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(13873818427997807)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475296
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(13874110086997853)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Bar, Vertical'
,p_lov_return_value=>'VBAR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(13874324361997857)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Bar, Horizontal'
,p_lov_return_value=>'HBAR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(13874508985997857)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Pie'
,p_lov_return_value=>'PIE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(5312118250963733)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Line'
,p_lov_return_value=>'LINE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(17478122660443416)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Scatter'
,p_lov_return_value=>'SCATTER'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3224907007165166)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Stacked Bar, Vertical'
,p_lov_return_value=>'STACKED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3225213587167083)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Stacked Percentage Bar, Vertical'
,p_lov_return_value=>'STACKED_PCT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3225520859169124)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Cluster Bar, Vertical'
,p_lov_return_value=>'CLUSTER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3364901558270620)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Stacked Bar, Horizontal'
,p_lov_return_value=>'HSTACKED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3365407792272446)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Stacked Percentage Bar, Horizontal'
,p_lov_return_value=>'HSTACKED_PCT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3366407576281829)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Cluster Bar, Horizontal'
,p_lov_return_value=>'HCLUSTER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3369215672293634)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'Dial'
,p_lov_return_value=>'DIAL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(5845103014129124)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'Dial - Sweep'
,p_lov_return_value=>'DIALSWEEP'
);
end;
/
prompt --application/shared_components/user_interface/lovs/svg_font_face
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(15705700831360468)
,p_lov_name=>'SVG_FONT_FACE'
,p_lov_query=>'.'||wwv_flow_imp.id(15705700831360468)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475297
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15706010936360500)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Arial'
,p_lov_return_value=>'Arial'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15706203457360504)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Helvetica'
,p_lov_return_value=>'Helvetica'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15706413226360504)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Geneva'
,p_lov_return_value=>'Geneva'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15706631186360504)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Sans-serif'
,p_lov_return_value=>'sans-serif'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(32373929116515333)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Verdana'
,p_lov_return_value=>'Verdana'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(35182603175246497)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'Tahoma'
,p_lov_return_value=>'Tahoma'
);
end;
/
prompt --application/shared_components/user_interface/lovs/svg_font_size
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(15707232345369601)
,p_lov_name=>'SVG_FONT_SIZE'
,p_lov_query=>'.'||wwv_flow_imp.id(15707232345369601)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475297
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15707524079369601)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'2'
,p_lov_return_value=>'2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15707707938369603)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'4'
,p_lov_return_value=>'4'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15707930580369603)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'6'
,p_lov_return_value=>'6'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15708109634369603)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'8'
,p_lov_return_value=>'8'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15708306344369603)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'10'
,p_lov_return_value=>'10'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15708523904369603)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'12'
,p_lov_return_value=>'12'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15708808135369609)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'14'
,p_lov_return_value=>'14'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15709011308369609)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'16'
,p_lov_return_value=>'16'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15709231985369609)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'18'
,p_lov_return_value=>'18'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15709413368369610)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'20'
,p_lov_return_value=>'20'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(15709630193369614)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'22'
,p_lov_return_value=>'22'
);
end;
/
prompt --application/shared_components/user_interface/lovs/sync_breadcrumb
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(47143021317359827)
,p_lov_name=>'SYNC BREADCRUMB'
,p_lov_query=>'.'||wwv_flow_imp.id(47143021317359827)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475297
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(47143222442359827)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Page Name and Title'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/tabform_execute_condition
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(7569601081513754)
,p_lov_name=>'TABFORM_EXECUTE_CONDITION'
,p_lov_query=>'.'||wwv_flow_imp.id(7569601081513754)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475297
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7569930183513774)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'For Each Row'
,p_lov_return_value=>'Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7570109252513777)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Once'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/tabform_only_for_changed_rows
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(9364428304832423)
,p_lov_name=>'TABFORM_ONLY_FOR_CHANGED_ROWS'
,p_lov_query=>'.'||wwv_flow_imp.id(9364428304832423)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475297
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9364904590832430)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'For Created and Modified Rows'
,p_lov_return_value=>'Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(9364732183832426)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'All Submitted Rows'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/tabs_for_800
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2804200546103254)
,p_lov_name=>'TABS (FOR 800)'
,p_lov_query=>'.'||wwv_flow_imp.id(2804200546103254)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475297
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2804500147103257)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'No Tabs'
,p_lov_return_value=>'NO_TABS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2804718846103257)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'One Level of Tabs'
,p_lov_return_value=>'SINGLE_LEVEL_TABS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2804919057103257)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Two Levels of Tabs'
,p_lov_return_value=>'TWO_LEVEL_TABS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/tabs_page_3020
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(140133614691303751)
,p_lov_name=>'TABS (PAGE 3020)'
,p_lov_query=>'.'||wwv_flow_imp.id(140133614691303751)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475297
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(140133828025303756)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'No Tabs'
,p_lov_return_value=>'NO_TABS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(140134000483303758)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'One Level of Tabs'
,p_lov_return_value=>'SINGLE_LEVEL_TABS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(140134208841303758)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Two Levels of Tabs'
,p_lov_return_value=>'TWO_LEVEL_TABS'
);
end;
/
prompt --application/shared_components/user_interface/lovs/tabsets_with_empty_sets_unioned
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(28738517235744577)
,p_lov_name=>'TABSETS WITH EMPTY SETS UNIONED'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(d) d, r',
'  from wwv_flow_tabset_view2'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475297
);
end;
/
prompt --application/shared_components/user_interface/lovs/tabular_form_date_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(19853917765280516)
,p_lov_name=>'TABULAR_FORM_DATE_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(19853917765280516)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475297
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(19855422713280526)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MON-RR)'
,p_lov_return_value=>'PICK_DATE_DD_MON_RR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(19855601684280526)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MON-RR HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_RR_HH24_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(19855806360280526)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MON-RR HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_RR_HH_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(19861607507280532)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD/MM/YYYY)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(19861831615280533)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (MM/DD/YYYY)'
,p_lov_return_value=>'PICK_DATE_MM_DD_YYYY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(19862013188280533)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MON-YYYY)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YYYY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(19862220933280533)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MON-YY)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YY'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(19862400541280533)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD/MM/YYYY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH24_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(19862629132280533)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (MM/DD/YYYY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_MM_DD_YYYY_HH24_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(19862821146280534)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MON-YYYY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YYYY_HH24_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(19863007312280534)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MON-YY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YY_HH24_MI'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(19863209393280534)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD/MM/YYYY HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(19863428929280534)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (MM/DD/YYYY HH:MI)'
,p_lov_return_value=>'PICK_DATE_MM_DD_YYYY_HH_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(19863623755280535)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MON-YYYY HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YYYY_HH_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(19863819825280535)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MON-YY HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YY_HH_MI'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(19864208396280535)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (use application format mask)'
,p_lov_return_value=>'PICK_DATE_USING_APP_FORMAT_MASK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(22073306493718862)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MM-YYYY)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_DASH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(22073913765720916)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MM-YYYY HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH_MI_DASH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(22074820692722982)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MM-YYYY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH24_MI_DASH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(22075421515732683)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD.MM.YYYY)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_DOT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(22075729134734808)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD.MM.YYYY HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH_MI_DOT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(22076002946736752)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD.MM.YYYY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH24_MI_DOT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(22076430304744622)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (RR-MON-DD HH:MI)'
,p_lov_return_value=>'PICK_DATE_RR_MON_DD_HH_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(22076704462746660)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (RR-MON-DD HH24:MI)'
,p_lov_return_value=>'PICK_DATE_RR_MON_DD_HH24_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(22077606802766286)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (YYYY-MM-DD HH24:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD_HH24_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(22077915113768696)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (YYYY-MM-DD HH:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD_HH_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(22078530482782518)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (YYYY.DD.MM HH24:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_DD_MM_HH24_MI_DOT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(22078805679784843)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (YYYY.DD.MM HH:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_DD_MM_HH_MI_DOT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(22079112951786930)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (YYYY.DD.MM)'
,p_lov_return_value=>'PICK_DATE_YYYY_DD_MM_DOT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(22080512389796225)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (YYYY/MM/DD HH24:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD_HH24_MI_SLASH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(22080917930797806)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (YYYY/MM/DD HH:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD_HH_MI_SLASH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(22081227281800546)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (YYYY/MM/DD)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD_SLASH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(41125203906793852)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (YYYY-MM-DD)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(41126623299799507)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (RR-MON-DD)'
,p_lov_return_value=>'PICK_DATE_RR_MON_DD'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(92184003441504374)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (use item format mask)'
,p_lov_return_value=>'PICK_DATE_USING_FORMAT_MASK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108027020146849063)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (use Application Date Format)'
,p_lov_return_value=>'PICK_DATE_USING_APP_DATE_FORMAT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/tabular_form_display_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(41868019518520883)
,p_lov_name=>'TABULAR_FORM_DISPLAY_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(41868019518520883)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475304
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(41868709480520899)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Standard Report Column'
,p_lov_return_value=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(146115508440728992)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Display as Text (based on LOV, does not save state)'
,p_lov_return_value=>'TEXT_FROM_LOV'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(41868501071520899)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Display as Text (saves state)'
,p_lov_return_value=>'DISPLAY_AND_SAVE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(41868905439520899)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Display as Text (escape special characters, does not save state)'
,p_lov_return_value=>'ESCAPE_SC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(41870530818520901)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Date Picker (Classic)'
,p_lov_return_value=>'DATE_POPUP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(619170920138130822)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Date Picker'
,p_lov_return_value=>'DATE_PICKER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(41869114721520900)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Text Field'
,p_lov_return_value=>'TEXT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(41869313403520900)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Text Area'
,p_lov_return_value=>'TEXTAREA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(41869519454520900)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'Select List (static LOV)'
,p_lov_return_value=>'SELECT_LIST'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(42037708820188188)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'Select List (named LOV)'
,p_lov_return_value=>'SELECT_LIST_FROM_LOV'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(41869932445520901)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'Select List (query based LOV)'
,p_lov_return_value=>'SELECT_LIST_FROM_QUERY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(184369431308294796)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'Radio Group (static LOV)'
,p_lov_return_value=>'RADIOGROUP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(184369607198297304)
,p_lov_disp_sequence=>130
,p_lov_disp_value=>'Radio Group (named LOV)'
,p_lov_return_value=>'RADIOGROUP_FROM_LOV'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(184369915163299514)
,p_lov_disp_sequence=>140
,p_lov_disp_value=>'Radio Group (query based LOV)	'
,p_lov_return_value=>'RADIOGROUP_FROM_QUERY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(41870102302520901)
,p_lov_disp_sequence=>150
,p_lov_disp_value=>'Hidden '
,p_lov_return_value=>'HIDDEN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(41870309076520901)
,p_lov_disp_sequence=>160
,p_lov_disp_value=>'Popup LOV (named LOV)'
,p_lov_return_value=>'POPUP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(90288409721242959)
,p_lov_disp_sequence=>170
,p_lov_disp_value=>'Popup LOV (query based LOV)'
,p_lov_return_value=>'POPUP_QUERY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(184154525058674461)
,p_lov_disp_sequence=>180
,p_lov_disp_value=>'Popup Key LOV (named LOV)'
,p_lov_return_value=>'POPUPKEY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(184156407181678728)
,p_lov_disp_sequence=>190
,p_lov_disp_value=>'Popup Key LOV (query based LOV)	'
,p_lov_return_value=>'POPUPKEY_QUERY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(615558619134956199)
,p_lov_disp_sequence=>200
,p_lov_disp_value=>'Simple Checkbox'
,p_lov_return_value=>'SIMPLE_CHECKBOX'
);
end;
/
prompt --application/shared_components/user_interface/lovs/tabular_form_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(37374013079477607)
,p_lov_name=>'TABULAR_FORM_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(37374013079477607)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475304
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(37374309130477610)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Update Only'
,p_lov_return_value=>'UPDATE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(37374515762477611)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Update and Insert'
,p_lov_return_value=>'INSERT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(37374718899477611)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Update, Insert and Delete'
,p_lov_return_value=>'INSERT_AND_DELETE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(37374901857477611)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Update and Delete'
,p_lov_return_value=>'DELETE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/tab_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84311114650582100)
,p_lov_name=>'TAB_OPTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(84311114650582100)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475304
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88316005027833611)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Do not use tabs'
,p_lov_return_value=>'NO_TAB'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88316224819833612)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'All pages use same standard tab'))
,p_lov_return_value=>'ALL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88316424372833612)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'One standard tab per page'))
,p_lov_return_value=>'ONE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/tab_sequence
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(151879426590303081)
,p_lov_name=>'TAB_SEQUENCE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct tab_sequence a, tab_sequence b',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID',
'order  by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475305
);
end;
/
prompt --application/shared_components/user_interface/lovs/tab_set_choice
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84320304523598135)
,p_lov_name=>'TAB_SET_CHOICE'
,p_lov_query=>'.'||wwv_flow_imp.id(84320304523598135)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475305
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84320517347598135)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Create a new tab set and a new tab within the tab set.'
,p_lov_return_value=>'NEW'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84320714112598136)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Use an existing tab set and create a new tab within the existing tab set.'
,p_lov_return_value=>'EXISTING'
);
end;
/
prompt --application/shared_components/user_interface/lovs/tab_set_choice_all
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84778506791979282)
,p_lov_name=>'TAB_SET_CHOICE_ALL'
,p_lov_query=>'.'||wwv_flow_imp.id(84778506791979282)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475305
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84778716079979282)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Do not use tabs'
,p_lov_return_value=>'NO'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84779119299979283)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Use an existing tab set and create a new tab within the existing tab set.'
,p_lov_return_value=>'EXISTING'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84779323082979285)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Use an existing tab set and reuse an existing tab within that tab set.'
,p_lov_return_value=>'EXISTING2'
);
end;
/
prompt --application/shared_components/user_interface/lovs/task_action_log_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1446742001365910)
,p_lov_name=>'TASK_ACTION_LOG_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(1446742001365910)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475305
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1447017494366035)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'None'
,p_lov_return_value=>'NONE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1447484030366036)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Success'
,p_lov_return_value=>'SUCCESS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1447858066366036)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Failure'
,p_lov_return_value=>'FAILURE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1448265470366036)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'All'
,p_lov_return_value=>'ALL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/task_action_on_events
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2058881135907033)
,p_lov_name=>'TASK_ACTION_ON_EVENTS'
,p_lov_query=>'.'||wwv_flow_imp.id(2058881135907033)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475305
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2059167764907047)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Claim'
,p_lov_return_value=>'CLAIM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2059513581907049)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Complete'
,p_lov_return_value=>'COMPLETE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2059939228907049)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Delegate'
,p_lov_return_value=>'DELEGATE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2060750496907050)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'Update Comment'
,p_lov_return_value=>'UPDATE_COMMENT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2061191059907050)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Update Priority'
,p_lov_return_value=>'UPDATE_PRIORITY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2201346656735987)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Update Parameter'
,p_lov_return_value=>'UPDATE_PARAM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2062331728907051)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Release'
,p_lov_return_value=>'RELEASE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2062775421907051)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Cancel'
,p_lov_return_value=>'CANCEL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1703984208044351)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'Create'
,p_lov_return_value=>'CREATE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1501456983399351)
,p_lov_disp_sequence=>100
,p_lov_disp_value=>'Request Information'
,p_lov_return_value=>'REQUEST_INFO'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1501742401400709)
,p_lov_disp_sequence=>110
,p_lov_disp_value=>'Submit Information'
,p_lov_return_value=>'SUBMIT_INFO'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1501409134666578)
,p_lov_disp_sequence=>120
,p_lov_disp_value=>'Before Expire'
,p_lov_return_value=>'BEFORE_EXPIRE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1501712538666585)
,p_lov_disp_sequence=>130
,p_lov_disp_value=>'Expire'
,p_lov_return_value=>'EXPIRE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/task_action_sources
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1702015671505978)
,p_lov_name=>'TASK_ACTION_SOURCES'
,p_lov_query=>'.'||wwv_flow_imp.id(1702015671505978)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475305
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1702351942505996)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'None'
,p_lov_return_value=>'NONE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1702784660505997)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'SQL Query'
,p_lov_return_value=>'SQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1703122681505997)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Table'
,p_lov_return_value=>'TABLE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/task_due_on_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2155568708112694)
,p_lov_name=>'TASK_DUE_ON_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(2155568708112694)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475305
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2155851637112710)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Interval'
,p_lov_return_value=>'INTERVAL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2156201389112711)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'SQL Query'
,p_lov_return_value=>'SQL_QUERY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2156693741112711)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Function Body'
,p_lov_return_value=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2157073026112711)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Expression'
,p_lov_return_value=>'EXPRESSION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2168035750119577)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Scheduler Expression'
,p_lov_return_value=>'SCHEDULER_EXPRESSION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/task_expiration_policy
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1502210050672785)
,p_lov_name=>'TASK_EXPIRATION_POLICY'
,p_lov_query=>'.'||wwv_flow_imp.id(1502210050672785)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475305
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1502508439672789)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'None'
,p_lov_return_value=>'NONE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1502946275672789)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Expire'
,p_lov_return_value=>'EXPIRE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1503307241672789)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Renew'
,p_lov_return_value=>'RENEW'
);
end;
/
prompt --application/shared_components/user_interface/lovs/task_outcomes
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1744994760068865)
,p_lov_name=>'TASK_OUTCOMES'
,p_lov_query=>'.'||wwv_flow_imp.id(1744994760068865)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475305
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1745297024068887)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Approved'
,p_lov_return_value=>'APPROVED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1745668209068889)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Rejected'
,p_lov_return_value=>'REJECTED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/task_param_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1501568839405634)
,p_lov_name=>'TASK_PARAM_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(1501568839405634)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475305
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1501816969405635)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'String'
,p_lov_return_value=>'VARCHAR2'
);
end;
/
prompt --application/shared_components/user_interface/lovs/task_participant_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1502966218419601)
,p_lov_name=>'TASK_PARTICIPANT_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(1502966218419601)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475305
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1503282984419601)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Potential Owner'
,p_lov_return_value=>'POTENTIAL_OWNER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1503621777419602)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Business Administrator'
,p_lov_return_value=>'BUSINESS_ADMIN'
);
end;
/
prompt --application/shared_components/user_interface/lovs/task_participant_val_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1503965976427173)
,p_lov_name=>'TASK_PARTICIPANT_VAL_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(1503965976427173)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475305
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1504216100427174)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Static'
,p_lov_return_value=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1504638809427174)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'SQL Query'
,p_lov_return_value=>'SQL_QUERY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1505040608427174)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Function Body'
,p_lov_return_value=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1505487127427175)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Expression'
,p_lov_return_value=>'EXPRESSION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/task_part_identity_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1505798300430108)
,p_lov_name=>'TASK_PART_IDENTITY_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(1505798300430108)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475305
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1506086487430108)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'User'
,p_lov_return_value=>'USER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/task_priority_levels
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1532482169327772)
,p_lov_name=>'TASK_PRIORITY_LEVELS'
,p_lov_query=>'.'||wwv_flow_imp.id(1532482169327772)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475305
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1532735643327779)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'1-Urgent'
,p_lov_return_value=>'1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1533150827327779)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'2-High'
,p_lov_return_value=>'2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1533556169327779)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'3-Medium'
,p_lov_return_value=>'3'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1533904993327780)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'4-Low'
,p_lov_return_value=>'4'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1534349875327780)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'5-Lowest'
,p_lov_return_value=>'5'
);
end;
/
prompt --application/shared_components/user_interface/lovs/task_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1500990392400098)
,p_lov_name=>'TASK_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(1500990392400098)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475305
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1501234431400135)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Action Task'
,p_lov_return_value=>'ACTION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1385420613383680)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Approval Task'
,p_lov_return_value=>'APPROVAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/team_dev_fs_limit
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2541932940202319161)
,p_lov_name=>'TEAM_DEV_FS_LIMIT'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 5       as dv,',
'       5242880 as rv',
' from dual',
'where 5242880 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_TEAM_DEV_FS_LIMIT''),15728640)',
'union all',
'select 10       as dv,',
'       10485760 as rv',
' from dual',
'where 10485760 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_TEAM_DEV_FS_LIMIT''),15728640)',
'union all',
'select 15       as dv,',
'       15728640 as rv',
' from dual',
'where 15728640 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_TEAM_DEV_FS_LIMIT''),15728640)',
'union all',
'select 20       as dv,',
'       20971520 as rv',
' from dual',
'where 20971520 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_TEAM_DEV_FS_LIMIT''),15728640)',
'union all',
'select 25       as dv,',
'       26214400 as rv',
' from dual',
'where 26214400 <= nvl(wwv_flow_platform.get_preference(''WORKSPACE_TEAM_DEV_FS_LIMIT''),15728640)',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475305
);
end;
/
prompt --application/shared_components/user_interface/lovs/template_cosolidation_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(97572901159694386)
,p_lov_name=>'TEMPLATE COSOLIDATION TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(97572901159694386)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475305
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(97573226909694391)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Page'
,p_lov_return_value=>'PAGE'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:920:&SESSION.:::920,921,922,924,26,144"><img src="#IMAGE_PREFIX#htmldb/builder/blank_page_xl.gif" class="htmldbGreenIcon" width="140" height="115" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(97573426902694392)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Region'
,p_lov_return_value=>'REGION'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:901:&SESSION.:::4653,901,902,4320,158"><img src="#IMAGE_PREFIX#htmldb/builder/region_component_xl.gif" class="htmldbGreenIcon" width="140" height="115" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(97573611581694392)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Report'
,p_lov_return_value=>'REPORT'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:951:&SESSION.:::951,955,4321,168"><img src="#IMAGE_PREFIX#htmldb/builder/report_component_xl.gif" class="htmldbGreenIcon" width="140" height="115" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(97573811962694392)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Label'
,p_lov_return_value=>'LABEL'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:941:&SESSION.:::941,86,167,650,652"><img src="#IMAGE_PREFIX#htmldb/builder/label_component_xl.gif" class="htmldbGreenIcon" width="140" height="115" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(97574031815694393)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'List'
,p_lov_return_value=>'LIST'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:931:&SESSION.:::931,934,935,4069,159"><img src="#IMAGE_PREFIX#htmldb/builder/list_component_xl.gif" class="htmldbGreenIcon" width="140" height="115" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(97574222180694393)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Button'
,p_lov_return_value=>'BUTTON'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:211:&SESSION.:::211,218,219,223,224,225"><img src="#IMAGE_PREFIX#htmldb/builder/button_component_xl.gif" class="htmldbGreenIcon" width="140" height="115" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(97574415983694393)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Breadcrumb'
,p_lov_return_value=>'MENU'
,p_lov_template=>'#DISPLAY_VALUE# <br /><a href="f?p=4000:238:&SESSION.:::238,240,241,242"><img src="#IMAGE_PREFIX#htmldb/builder/menu_component_xl.gif" class="htmldbGreenIcon" width="140" height="115" alt="#DISPLAY_VALUE#" /></a>'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(97574627093694393)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Calendar'
,p_lov_return_value=>'CALENDAR'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:161:&SESSION.:::161"><img src="#IMAGE_PREFIX#htmldb/builder/calendar_component_xl.gif" class="htmldbGreenIcon" width="140" height="115" alt="#DISPLAY_VALUE#" /></a>'
);
end;
/
prompt --application/shared_components/user_interface/lovs/template_match
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1382206179278736769)
,p_lov_name=>'TEMPLATE MATCH'
,p_lov_query=>'.'||wwv_flow_imp.id(1382206179278736769)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475305
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1382206400153736789)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'By Template Identifier'
,p_lov_return_value=>'N'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1382206845980736790)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'By Template Name'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/template_option_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(655584409399418944)
,p_lov_name=>'TEMPLATE OPTION TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(655584409399418944)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475305
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(655586597916418951)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Button'
,p_lov_return_value=>'BUTTON'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(655586205931418951)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Item'
,p_lov_return_value=>'FIELD'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(655585048066418950)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Region'
,p_lov_return_value=>'REGION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(655585342316418950)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Report'
,p_lov_return_value=>'REPORT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(655585948924418951)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'List'
,p_lov_return_value=>'LIST'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(655584729952418948)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Page'
,p_lov_return_value=>'PAGE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(655585628425418951)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Breadcrumb'
,p_lov_return_value=>'BREADCRUMB'
);
end;
/
prompt --application/shared_components/user_interface/lovs/template_types_page_708
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(168736405114387476)
,p_lov_name=>'TEMPLATE TYPES PAGE 708'
,p_lov_query=>'.'||wwv_flow_imp.id(168736405114387476)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475305
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(168736704180387479)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Page'
,p_lov_return_value=>'PAGE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(168736918167387480)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Region'
,p_lov_return_value=>'REGION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(168737102241387480)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Report'
,p_lov_return_value=>'REPORT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(168737309288387480)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Label'
,p_lov_return_value=>'LABEL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(168737511127387480)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'List'
,p_lov_return_value=>'LIST'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(168737715707387480)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Button'
,p_lov_return_value=>'BUTTON'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(168737909969387480)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Breadcrumb'
,p_lov_return_value=>'MENU'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(168738110866387480)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Legacy Calendar'
,p_lov_return_value=>'CALENDAR'
);
end;
/
prompt --application/shared_components/user_interface/lovs/template_types_returning_name
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(282026017647000169)
,p_lov_name=>'TEMPLATE TYPES RETURNING NAME'
,p_lov_query=>'.'||wwv_flow_imp.id(282026017647000169)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475306
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(282026324068000178)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Page'
,p_lov_return_value=>'PAGE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(282026529832000180)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Region'
,p_lov_return_value=>'REGION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(282026713154000180)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Label'
,p_lov_return_value=>'LABEL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(282026918534000181)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'List'
,p_lov_return_value=>'LIST'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(282027107889000181)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Popup List of Values'
,p_lov_return_value=>'POPUP_LOV'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(282027307751000181)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Calendar'
,p_lov_return_value=>'CALENDAR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(282027500156000181)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Breadcrumb'
,p_lov_return_value=>'MENU'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(282027714036000182)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Button'
,p_lov_return_value=>'BUTTON'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(282027909056000182)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Report'
,p_lov_return_value=>'REPORT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7466780066149900)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Template Component'
,p_lov_return_value=>'TEMPLATE_COMPONENT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/template_yes_no_subscribe
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(150847232623403358)
,p_lov_name=>'TEMPLATE YES.NO.SUBSCRIBE'
,p_lov_query=>'.'||wwv_flow_imp.id(150847232623403358)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475306
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(150847503925403360)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Yes'
,p_lov_return_value=>'Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(150847709120403362)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'No'
,p_lov_return_value=>'N'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(150847907139403362)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Copy and Subscribe'
,p_lov_return_value=>'SUBSCRIBE'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_themes',
'where flow_id = :FB_FLOW_ID',
'and theme_id = :F4000_COPY_TO_THEME',
'and reference_id is null'))
);
end;
/
prompt --application/shared_components/user_interface/lovs/template_types_all
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(90737426296160594)
,p_lov_name=>'TEMPLATE.TYPES.ALL'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  wwv_flow_lang.system_message_lit(''F4000.PAGE'') d,''PAGE'' r from sys.dual',
'union all',
'select wwv_flow_lang.system_message_lit(''F4000.REGION'') d,''REGION'' r from sys.dual',
'union all',
'select wwv_flow_lang.system_message_lit(''LABEL'') d,''LABEL'' r from sys.dual',
'union all',
'select wwv_flow_lang.system_message_lit(''F4000.LIST_INITCAP'') d, ''LIST'' r from sys.dual',
'union all',
'select wwv_flow_lang.system_message_lit(''F4000.P371.POPUP_LOV'') d, ''POPUP_LOV'' r from sys.dual',
'union all',
'select wwv_flow_lang.system_message_lit(''LEGACY_CALENDAR'') d,''CALENDAR'' r from sys.dual',
'union all',
'select wwv_flow_lang.system_message_lit(''BREADCRUMB'') d,''MENU'' r from sys.dual',
'union all',
'select wwv_flow_lang.system_message_lit(''F4000.BUTTON'') d, ''BUTTON'' r from sys.dual',
'union all',
'select wwv_flow_lang.system_message_lit(''REPORT'') d, ''REPORT'' r from sys.dual',
'union all',
'select wwv_flow_lang.system_message_lit(''F4000.TEMPLATE_COMPONENT'') d, ''TEMPLATE_COMPONENT'' r from sys.dual'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475306
);
end;
/
prompt --application/shared_components/user_interface/lovs/templates_view_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(230524412593007607)
,p_lov_name=>'TEMPLATES.VIEW.OPTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(230524412593007607)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475306
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(230524708572007610)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Templates Referenced'
,p_lov_return_value=>'R'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(230525020430007613)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Templates Not Referenced'
,p_lov_return_value=>'N'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(230525214548007613)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'All Templates'
,p_lov_return_value=>'A'
);
end;
/
prompt --application/shared_components/user_interface/lovs/template_report_on
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84836411424340211)
,p_lov_name=>'TEMPLATE_REPORT_ON'
,p_lov_query=>'.'||wwv_flow_imp.id(84836411424340211)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475306
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84836624193340211)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Page'
,p_lov_return_value=>'Page'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84836806641340212)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Region'
,p_lov_return_value=>'Region'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84837004299340212)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Report'
,p_lov_return_value=>'Report'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84837213121340212)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'List'
,p_lov_return_value=>'List'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84837423252340212)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'Label'
,p_lov_return_value=>'Field'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84837618414340213)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'Button'
,p_lov_return_value=>'Button'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84837825455340213)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'Breadcrumb'
,p_lov_return_value=>'Menu'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(19425309920595509)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'Calendar'
,p_lov_return_value=>'Calendar'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7470838911406013)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'Template Component'
,p_lov_return_value=>'TemplateComponent'
);
end;
/
prompt --application/shared_components/user_interface/lovs/template_subscription_status
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1467334342209901488)
,p_lov_name=>'TEMPLATE_SUBSCRIPTION_STATUS'
,p_lov_query=>'.'||wwv_flow_imp.id(1467334342209901488)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475306
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1467334665943901490)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Match'
,p_lov_return_value=>'MATCH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1467334924557901491)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Out of Sync'
,p_lov_return_value=>'OUT_OF_SYNC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1474343776393848287)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'Template Options Mismatch'
,p_lov_return_value=>'TEMPLATE_OPTIONS_MISMATCH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1475854067168452196)
,p_lov_disp_sequence=>22
,p_lov_disp_value=>'Not Defined in Subscribing Theme'
,p_lov_return_value=>'MISSING'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1592357805860111979)
,p_lov_disp_sequence=>32
,p_lov_disp_value=>'Not subscribed'
,p_lov_return_value=>'LOCAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/template_themes
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(26326826556101977)
,p_lov_name=>'TEMPLATE_THEMES'
,p_lov_query=>'.'||wwv_flow_imp.id(26326826556101977)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475309
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(26337621754128975)
,p_lov_disp_sequence=>0
,p_lov_disp_value=>'All Themes'
,p_lov_return_value=>'0'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(26327121768101985)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Blue and Tan'
,p_lov_return_value=>'1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(26327331118101989)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Red'
,p_lov_return_value=>'2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(26327522154101989)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Color Independent'
,p_lov_return_value=>'3'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(26327728603101990)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Navy and Gray'
,p_lov_return_value=>'4'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(26327900997101990)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Olive'
,p_lov_return_value=>'5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(26328104545101990)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Maroon'
,p_lov_return_value=>'6'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(26328332634101992)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Thin Blue and Tan'
,p_lov_return_value=>'7'
);
end;
/
prompt --application/shared_components/user_interface/lovs/template_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84868022945400324)
,p_lov_name=>'TEMPLATE_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(84868022945400324)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475309
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84869015029400326)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Page'
,p_lov_return_value=>'f?p=4000:920:&SESSION.:::920,921,922,924,26,144'
,p_lov_template=>'#DISPLAY_VALUE#| icon-template-page'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84869224199400326)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Region'
,p_lov_return_value=>'f?p=4000:901:&SESSION.:::4653,901,902,4320,158'
,p_lov_template=>'#DISPLAY_VALUE#| icon-template-region'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84869423577400327)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Report'
,p_lov_return_value=>'f?p=4000:951:&SESSION.:::951,955,4321,168'
,p_lov_template=>'#DISPLAY_VALUE#| icon-template-report'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84868407785400325)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Item'
,p_lov_return_value=>'f?p=4000:941:&SESSION.:::941,86,167,650,652'
,p_lov_template=>'#DISPLAY_VALUE#| icon-template-label'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84868623129400326)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'List'
,p_lov_return_value=>'f?p=4000:931:&SESSION.:::931,934,935,4069,159'
,p_lov_template=>'#DISPLAY_VALUE#| icon-template-list'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84868225653400325)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Button'
,p_lov_return_value=>'f?p=4000:211:&SESSION.:::211,218,219,223,224,225'
,p_lov_template=>'#DISPLAY_VALUE#| icon-template-button'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84868806178400326)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Breadcrumb'
,p_lov_return_value=>'f?p=4000:238:&SESSION.:::238,240,241,242'
,p_lov_template=>'#DISPLAY_VALUE#| icon-template-breadcrumb'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(19410014805549665)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Legacy Calendar'
,p_lov_return_value=>'f?p=4000:161:&SESSION.:::122'
,p_lov_template=>'#DISPLAY_VALUE#| icon-region-native-css-calendar'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(74989224462749317)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Popup'
,p_lov_return_value=>'f?p=4000:350:&SESSION.:::350'
,p_lov_template=>'#DISPLAY_VALUE#| icon-template-popup'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(6205322645733662)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Template Component Plug-in'
,p_lov_return_value=>'f?p=4000:4402:&SESSION.:::4402:P4402_FOR_THEME,P4410_PLUGIN_TYPE:Y,TEMPLATE COMPONENT'
,p_lov_template=>'#DISPLAY_VALUE#| icon-template-component'
);
end;
/
prompt --application/shared_components/user_interface/lovs/text_query_function_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1936977999928971)
,p_lov_name=>'TEXT_QUERY_FUNCTION_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(1936977999928971)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475309
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1937676715928972)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Search Engine'
,p_lov_return_value=>'SEARCH_ENGINE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1937285214928972)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Expert Search'
,p_lov_return_value=>'EXPERT_SEARCH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1938016536928973)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Custom'
,p_lov_return_value=>'CUSTOM'
);
end;
/
prompt --application/shared_components/user_interface/lovs/theme_list_for_ws_preferences
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2823513415211031)
,p_lov_name=>'THEME LIST FOR WS PREFERENCES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(t.theme_name)||'' (''|| wwv_flow_lang.system_message(''THEME'')||'' ''||t.theme_id||'')''||',
'       ''<a href="#" ><img src="#IMAGE_PREFIX#f_spacer.gif" class="theme-preview theme_''||t.theme_id||''" alt="''||wwv_flow_lang.system_message(''THEME'')||'' ''||t.theme_id||''"></a>'' display_value,',
'       to_char(t.theme_id) theme_id',
'       from wwv_flow_themes t, wwv_flows f ',
'      where t.security_group_id in (11,12) ',
'        and (t.THEME_SECURITY_GROUP_ID is null ',
'            or t.THEME_SECURITY_GROUP_ID = :flow_security_group_id) ',
'        and t.flow_id in (',
'              select id from wwv_flows f',
'               where (',
'                    (:P800_SHOW = ''ALL''      and f.application_type in (''STANDARD'',''THEME'')) or ',
'                    (:P800_SHOW = ''CUSTOM''   and f.application_type = ''STANDARD'') or ',
'                    (:P800_SHOW = ''STANDARD'' and f.application_type = ''THEME'') or',
'                    (:P800_SHOW = ''LEGACY''   and f.application_type = ''THEME'')',
'               ) ',
'               and f.security_group_id in (11,12)',
'               )',
'        and (',
'          (:P800_SHOW = ''STANDARD'' and instr('',''||wwv_flow_platform.get_preference(''TOP_THEMES'')||'','','',''||t.theme_id||'','') > 0 ) or',
'          (:P800_SHOW in (''LEGACY'',''CUSTOM'' ) and instr('',''||wwv_flow_platform.get_preference(''TOP_THEMES'')||'','','',''||t.theme_id||'','') = 0 ) or',
'          (:P800_SHOW = ''ALL'')',
'        )  ',
'        and f.id = t.flow_id',
'        and f.theme_id = t.theme_id',
'        order by t.flow_id'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475309
);
end;
/
prompt --application/shared_components/user_interface/lovs/theme_source
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1399872256703479206)
,p_lov_name=>'THEME SOURCE'
,p_lov_query=>'.'||wwv_flow_imp.id(1399872256703479206)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475309
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1399872521466479209)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Application Theme'
,p_lov_return_value=>'app'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1399872968543479210)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Workspace Theme'
,p_lov_return_value=>'workspace'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1399873345848479210)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Public Theme'
,p_lov_return_value=>'public'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1399873718982479211)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Oracle Theme'
,p_lov_return_value=>'oracle'
);
end;
/
prompt --application/shared_components/user_interface/lovs/theme_16_supplied_themes
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(48664803510648896)
,p_lov_name=>'THEME_16 (SUPPLIED THEMES)'
,p_lov_query=>'.'||wwv_flow_imp.id(48664803510648896)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475309
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(48665104317648900)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Theme 1'
,p_lov_return_value=>'1'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:&THEME_NEXT_PAGE.:&SESSION.::::THEME_ID:1"><img src="#IMAGE_PREFIX#themes/theme_1/themeshot.png" alt="#DISPLAY_VALUE#" title="#DISPLAY_VALUE#" width="150" height="80" class="htmldbthemeshots" /></a>'
,p_lov_disp_cond_type=>'FUNCTION_BODY'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select theme_id from wwv_flow_themes where flow_id = :fb_flow_id) loop',
'  if c1.theme_id = 1 then',
'    return false;',
'  end if;',
'end loop;',
'return true;'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(48979517706471248)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Theme 2'
,p_lov_return_value=>'2'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:&THEME_NEXT_PAGE.:&SESSION.::::THEME_ID:2"><img src="#IMAGE_PREFIX#themes/theme_2/themeshot.png" alt="#DISPLAY_VALUE#" title="#DISPLAY_VALUE#" width="150" height="80" class="htmldbthemeshots" /></a>'
,p_lov_disp_cond_type=>'FUNCTION_BODY'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select theme_id from wwv_flow_themes where flow_id = :fb_flow_id) loop',
'  if c1.theme_id = 2 then',
'    return false;',
'  end if;',
'end loop;',
'return true;'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(48979822208472580)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Theme 3'
,p_lov_return_value=>'3'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:&THEME_NEXT_PAGE.:&SESSION.::::THEME_ID:3"><img src="#IMAGE_PREFIX#themes/theme_3/themeshot.png" alt="#DISPLAY_VALUE#" title="#DISPLAY_VALUE#" width="150" height="80" class="htmldbthemeshots" /></a>'
,p_lov_disp_cond_type=>'FUNCTION_BODY'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select theme_id from wwv_flow_themes where flow_id = :fb_flow_id) loop',
'  if c1.theme_id = 3 then',
'    return false;',
'  end if;',
'end loop;',
'return true;'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(48980126710473810)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Theme 4'
,p_lov_return_value=>'4'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:&THEME_NEXT_PAGE.:&SESSION.::::THEME_ID:4"><img src="#IMAGE_PREFIX#themes/theme_4/themeshot.png" alt="#DISPLAY_VALUE#" title="#DISPLAY_VALUE#" width="150" height="80" class="htmldbthemeshots" /></a>'
,p_lov_disp_cond_type=>'FUNCTION_BODY'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select theme_id from wwv_flow_themes where flow_id = :fb_flow_id) loop',
'  if c1.theme_id = 4 then',
'    return false;',
'  end if;',
'end loop;',
'return true;'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(48980431558475223)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Theme 5'
,p_lov_return_value=>'5'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:&THEME_NEXT_PAGE.:&SESSION.::::THEME_ID:5"><img src="#IMAGE_PREFIX#themes/theme_5/themeshot.png" alt="#DISPLAY_VALUE#" title="#DISPLAY_VALUE#" width="150" height="80" class="htmldbthemeshots" /></a>'
,p_lov_disp_cond_type=>'FUNCTION_BODY'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select theme_id from wwv_flow_themes where flow_id = :fb_flow_id) loop',
'  if c1.theme_id = 5 then',
'    return false;',
'  end if;',
'end loop;',
'return true;'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(48980705023477033)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Theme 6'
,p_lov_return_value=>'6'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:&THEME_NEXT_PAGE.:&SESSION.::::THEME_ID:6"><img src="#IMAGE_PREFIX#themes/theme_6/themeshot.png" alt="#DISPLAY_VALUE#" title="#DISPLAY_VALUE#" width="150" height="80" class="htmldbthemeshots" /></a>'
,p_lov_disp_cond_type=>'FUNCTION_BODY'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select theme_id from wwv_flow_themes where flow_id = :fb_flow_id) loop',
'  if c1.theme_id = 6 then',
'    return false;',
'  end if;',
'end loop;',
'return true;'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(48981010218478513)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Theme 7'
,p_lov_return_value=>'7'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:&THEME_NEXT_PAGE.:&SESSION.::::THEME_ID:7"><img src="#IMAGE_PREFIX#themes/theme_7/themeshot.png" alt="#DISPLAY_VALUE#" title="#DISPLAY_VALUE#" width="150" height="80" class="htmldbthemeshots" /></a>'
,p_lov_disp_cond_type=>'FUNCTION_BODY'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select theme_id from wwv_flow_themes where flow_id = :fb_flow_id) loop',
'  if c1.theme_id = 7 then',
'    return false;',
'  end if;',
'end loop;',
'return true;'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(48981316798480442)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Theme 8'
,p_lov_return_value=>'8'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:&THEME_NEXT_PAGE.:&SESSION.::::THEME_ID:8"><img src="#IMAGE_PREFIX#themes/theme_8/themeshot.png" alt="#DISPLAY_VALUE#" title="#DISPLAY_VALUE#" width="150" height="80" class="htmldbthemeshots" /></a>'
,p_lov_disp_cond_type=>'FUNCTION_BODY'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select theme_id from wwv_flow_themes where flow_id = :fb_flow_id) loop',
'  if c1.theme_id = 8 then',
'    return false;',
'  end if;',
'end loop;',
'return true;'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(48981623031482219)
,p_lov_disp_sequence=>9
,p_lov_disp_value=>'Theme 9'
,p_lov_return_value=>'9'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:&THEME_NEXT_PAGE.:&SESSION.::::THEME_ID:9"><img src="#IMAGE_PREFIX#themes/theme_9/themeshot.png" alt="#DISPLAY_VALUE#" title="#DISPLAY_VALUE#" width="150" height="80" class="htmldbthemeshots" /></a>'
,p_lov_disp_cond_type=>'FUNCTION_BODY'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select theme_id from wwv_flow_themes where flow_id = :fb_flow_id) loop',
'  if c1.theme_id = 9 then',
'    return false;',
'  end if;',
'end loop;',
'return true;'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(48981927533483540)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Theme 10'
,p_lov_return_value=>'10'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:&THEME_NEXT_PAGE.:&SESSION.::::THEME_ID:10"><img src="#IMAGE_PREFIX#themes/theme_10/themeshot.png" alt="#DISPLAY_VALUE#" title="#DISPLAY_VALUE#" width="150" height="80" class="htmldbthemeshots" /></a>'
,p_lov_disp_cond_type=>'FUNCTION_BODY'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select theme_id from wwv_flow_themes where flow_id = :fb_flow_id) loop',
'  if c1.theme_id = 10 then',
'    return false;',
'  end if;',
'end loop;',
'return true;'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(48982231689484760)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Theme 11'
,p_lov_return_value=>'11'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:&THEME_NEXT_PAGE.:&SESSION.::::THEME_ID:11"><img src="#IMAGE_PREFIX#themes/theme_11/themeshot.png" alt="#DISPLAY_VALUE#" title="#DISPLAY_VALUE#" width="150" height="80" class="htmldbthemeshots" /></a>'
,p_lov_disp_cond_type=>'FUNCTION_BODY'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select theme_id from wwv_flow_themes where flow_id = :fb_flow_id) loop',
'  if c1.theme_id = 11 then',
'    return false;',
'  end if;',
'end loop;',
'return true;'))
,p_lov_disp_cond2=>'PLSQL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(48982504116486251)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'Theme 12'
,p_lov_return_value=>'12'
,p_lov_template=>'#DISPLAY_VALUE#<br /><a href="f?p=4000:&THEME_NEXT_PAGE.:&SESSION.::::THEME_ID:12"><img src="#IMAGE_PREFIX#themes/theme_12/themeshot.png" alt="#DISPLAY_VALUE#" title="#DISPLAY_VALUE#" width="150" height="80" class="htmldbthemeshots" /></a>'
,p_lov_disp_cond_type=>'FUNCTION_BODY'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select theme_id from wwv_flow_themes where flow_id = :fb_flow_id) loop',
'  if c1.theme_id = 12 then',
'    return false;',
'  end if;',
'end loop;',
'return true;'))
,p_lov_disp_cond2=>'PLSQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/theme_install
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(143032610843100694)
,p_lov_name=>'THEME_INSTALL'
,p_lov_query=>'.'||wwv_flow_imp.id(143032610843100694)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475309
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(143032931826100703)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Refresh Existing Theme'
,p_lov_return_value=>'REPLACE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(143033131431100704)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Create New Theme'
,p_lov_return_value=>'CREATE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/theme_list
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(240131711033281817)
,p_lov_name=>'THEME_LIST'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( t.theme_name ) ||',
'       '' ('' || ',
'       t.theme_id || ',
'       '') <a href="'' || ',
'       apex_util.prepare_url( p_url => ''f?p=4000:'' || :THEME_NEXT_PAGE  || '':'' ||:APP_SESSION || ''::::P496_THEME:'' || t.id  ) ||',
'       ''"><img src="#IMAGE_PREFIX#f_spacer.gif" class="theme_'' ||',
'       t.theme_id ||',
'       ''"></a>'' display_value,',
'       to_char(t.id) theme_app_id',
'  from wwv_flow_themes t, wwv_flows f ',
' where t.security_group_id in (11,12) ',
'   and (t.THEME_SECURITY_GROUP_ID is null or t.THEME_SECURITY_GROUP_ID = :flow_security_group_id) ',
'   and t.flow_id in (',
'              select id from wwv_flows f',
'               where (',
'                    (:P496_SHOW = ''ALL''      and f.application_type in (''STANDARD'',''THEME'')) or ',
'                    (:P496_SHOW = ''CUSTOM''   and f.application_type = ''STANDARD'') or ',
'                    (:P496_SHOW = ''STANDARD'' and f.application_type = ''THEME'') or',
'                    (:P496_SHOW = ''LEGACY''   and f.application_type = ''THEME'')',
'               ) ',
'               and f.security_group_id in (11,12)',
'               )',
'   and (',
'          (:P496_SHOW = ''STANDARD'' and instr('',''||wwv_flow_platform.get_preference(''TOP_THEMES'')||'','','',''||t.theme_id||'','') > 0 ) or',
'          (:P496_SHOW in (''LEGACY'',''CUSTOM'' ) and instr('',''||wwv_flow_platform.get_preference(''TOP_THEMES'')||'','','',''||t.theme_id||'','') = 0 ) or',
'          (:P496_SHOW = ''ALL'')',
'        )  ',
'   and f.id       = t.flow_id',
'   and f.theme_id = t.theme_id',
' order by t.theme_id'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'THEME_APP_ID'
,p_group_sort_direction=>'ASC'
,p_default_sort_direction=>'ASC'
,p_version_scn=>72475311
);
end;
/
prompt --application/shared_components/user_interface/lovs/time_format
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(61814624023212717)
,p_lov_name=>'TIME FORMAT'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select to_char(to_date(''06-26-1977 01:00'',''mm-dd-yyyy hh12:mi''),''am'') d,''AM'' r from dual ',
'UNION',
'select to_char(to_date(''06-26-1977 23:00'',''mm-dd-yyyy hh24:mi''),''am'') d,''PM'' r from dual ',
''))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475311
);
end;
/
prompt --application/shared_components/user_interface/lovs/translatable_y
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84791208054045923)
,p_lov_name=>'TRANSLATABLE_Y'
,p_lov_query=>'.'||wwv_flow_imp.id(84791208054045923)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475311
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84791403521045924)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Translatable'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/translate_returning_language_code
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(162455420955680205)
,p_lov_name=>'TRANSLATE - RETURNING LANGUAGE CODE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select primary_language_flow_id||'' &gt;&gt; ''||translation_flow_id||'' (''||wwv_flow_escape.html(translation_flow_language_code)||'')'' d, ',
'       translation_flow_language_code ',
'  from wwv_flow_language_map',
' where security_group_id = :flow_security_group_id',
'   and primary_language_flow_id = :FB_FLOW_ID'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475311
);
end;
/
prompt --application/shared_components/user_interface/lovs/translate_select_language_mapping
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(162395031982879189)
,p_lov_name=>'TRANSLATE SELECT LANGUAGE MAPPING'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select primary_language_flow_id||'' >> ''||translation_flow_id||'' (''||wwv_flow_escape.html(translation_flow_language_code)||'')'' d, ',
'       translation_flow_language_code ',
'  from wwv_flow_language_map',
' where security_group_id = :flow_security_group_id',
'   and primary_language_flow_id = :FB_FLOW_ID'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475311
);
end;
/
prompt --application/shared_components/user_interface/lovs/translation_mapping_id
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(640493208817215668)
,p_lov_name=>'TRANSLATION MAPPING ID'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select primary_language_flow_id||'' >> ''||translation_flow_id||'' (''||wwv_flow_escape.html(translation_flow_language_code)||'')'' d, ',
'      translation_flow_id ',
'  from wwv_flow_language_map',
' where security_group_id = :flow_security_group_id',
'   and primary_language_flow_id = :FB_FLOW_ID',
'order by primary_language_flow_id, translation_flow_id'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475311
);
end;
/
prompt --application/shared_components/user_interface/lovs/tree_button_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84309708763580409)
,p_lov_name=>'TREE_BUTTON_OPTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(84309708763580409)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475311
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84309922751580409)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Collapse All'
,p_lov_return_value=>'CONTRACT_ALL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84310126642580409)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Expand All'
,p_lov_return_value=>'EXPAND_ALL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84310313038580410)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Reset Tree'
,p_lov_return_value=>'RESET_TREE'
,p_lov_disp_cond_type=>'NEVER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/tree_click_action
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(483643112199322673)
,p_lov_name=>'TREE_CLICK_ACTION'
,p_lov_query=>'.'||wwv_flow_imp.id(483643112199322673)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475311
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(483643306184322681)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Single Click'
,p_lov_return_value=>'S'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(483643530500322682)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Double Click'
,p_lov_return_value=>'D'
);
end;
/
prompt --application/shared_components/user_interface/lovs/tree_query_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84328725778613735)
,p_lov_name=>'TREE_QUERY_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(84328725778613735)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475311
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84328916472613735)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Dynamic - From SQL Query'
,p_lov_return_value=>'DYNAMIC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/tree_tooltip_option
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(484108402301064790)
,p_lov_name=>'TREE_TOOLTIP_OPTION'
,p_lov_query=>'.'||wwv_flow_imp.id(484108402301064790)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475311
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(484108625829064799)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'None'
,p_lov_return_value=>'N'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(484108831383064804)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Static Assignment (value equals Tooltip Source attribute)'
,p_lov_return_value=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(484109010056064804)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Database Column'
,p_lov_return_value=>'DB'
);
end;
/
prompt --application/shared_components/user_interface/lovs/tree_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84296320837555546)
,p_lov_name=>'TREE_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(84296320837555546)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475311
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84296510914555547)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Dynamic- From SQL Query'
,p_lov_return_value=>'DYNAMIC'
);
end;
/
prompt --application/shared_components/user_interface/lovs/trim_conditions
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(23846801132546001)
,p_lov_name=>'TRIM_CONDITIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(23846801132546001)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475311
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23847125579546001)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Trailing'
,p_lov_return_value=>'trailing'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23847315260546002)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Leading'
,p_lov_return_value=>'leading'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23847528860546002)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Both'
,p_lov_return_value=>'both'
);
end;
/
prompt --application/shared_components/user_interface/lovs/true_false
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(34832921541772639)
,p_lov_name=>'TRUE_FALSE'
,p_lov_query=>'.'||wwv_flow_imp.id(34832921541772639)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475311
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(34833224822772639)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'True'
,p_lov_return_value=>'TRUE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(34833403317772639)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'False'
,p_lov_return_value=>'FALSE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ui
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(169775011419315124)
,p_lov_name=>'UI'
,p_lov_query=>'.'||wwv_flow_imp.id(169775011419315124)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475311
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(169775220892315128)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Use built in User Interface Themes'
,p_lov_return_value=>'THEME'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(169775418154315131)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Use Theme from an existing application'
,p_lov_return_value=>'APPLICATION'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ui_def_with_without_defaults
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(113914515973189452)
,p_lov_name=>'UI DEF WITH WITHOUT DEFAULTS'
,p_lov_query=>'.'||wwv_flow_imp.id(113914515973189452)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475311
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(113914915015189457)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'With Defaults'
,p_lov_return_value=>'W'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(113915116496189457)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Without Defaults'
,p_lov_return_value=>'WO'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ui_def_alignment_l_c_r
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(112376223175417562)
,p_lov_name=>'UI_DEF_ALIGNMENT.L.C.R'
,p_lov_query=>'.'||wwv_flow_imp.id(112376223175417562)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475311
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(112376421979417567)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Start'
,p_lov_return_value=>'L'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(112376611541417570)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Center'
,p_lov_return_value=>'C'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(112376830150417570)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'End'
,p_lov_return_value=>'R'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ui_def_display_as_reports
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(285506029323635827)
,p_lov_name=>'UI_DEF_DISPLAY_AS_REPORTS'
,p_lov_query=>'.'||wwv_flow_imp.id(285506029323635827)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475311
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(285507912489635846)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Standard Report Column (display-only, does not save state)'
,p_lov_return_value=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(285508121787635846)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Display as Text (based on LOV, does not save state)'
,p_lov_return_value=>'TEXT_FROM_LOV'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(285508323130635846)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Display as Text (saves state)'
,p_lov_return_value=>'DISPLAY_AND_SAVE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(285508512290635846)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Display as Text (escape special characters, does not save state)'
,p_lov_return_value=>'ESCAPE_SC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(285508705553635847)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Hidden '
,p_lov_return_value=>'HIDDEN'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ui_def_display_as_tabular_forms
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(285508811785635847)
,p_lov_name=>'UI_DEF_DISPLAY_AS_TABULAR_FORMS'
,p_lov_query=>'.'||wwv_flow_imp.id(285508811785635847)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475314
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23386007190363514)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Standard Report Column (display-only, does not save state)'
,p_lov_return_value=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23386208097363516)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Display as Text (based on LOV, does not save state)'
,p_lov_return_value=>'TEXT_FROM_LOV'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23386432155363516)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Display as Text (saves state)'
,p_lov_return_value=>'DISPLAY_AND_SAVE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23386602692363517)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Display as Text (escape special characters, does not save state)'
,p_lov_return_value=>'ESCAPE_SC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23386811273363517)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Text Field'
,p_lov_return_value=>'TEXT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23387002416363517)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Text Area'
,p_lov_return_value=>'TEXTAREA'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23387228952363517)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Select List'
,p_lov_return_value=>'SELECT_LIST_FROM_LOV'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23387404497363518)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Hidden '
,p_lov_return_value=>'HIDDEN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23387613926363518)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Popup LOV'
,p_lov_return_value=>'POPUP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23387831146363518)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker'
,p_lov_return_value=>'DATE_POPUP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23388023682363518)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (use application format mask)'
,p_lov_return_value=>'PICK_DATE_USING_APP_FORMAT_MASK'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23388204001363518)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MON-RR)'
,p_lov_return_value=>'PICK_DATE_DD_MON_RR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23388403010363519)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MON-RR HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_RR_HH24_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23388608852363519)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MON-RR HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_RR_HH_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23388832659363519)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MON-YY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YY_HH24_MI'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23389014256363519)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MON-YY HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YY_HH_MI'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23389220299363519)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MON-YYYY)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YYYY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23389405903363520)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MON-YYYY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YYYY_HH24_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23389626534363520)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MON-YYYY HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YYYY_HH_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23389823356363520)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MON-YY)'
,p_lov_return_value=>'PICK_DATE_DD_MON_YY'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23390022127363520)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD/MM/YYYY)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23390200308363520)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD/MM/YYYY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH24_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23390417928363521)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD/MM/YYYY HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23390628670363521)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (MM/DD/YYYY)'
,p_lov_return_value=>'PICK_DATE_MM_DD_YYYY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23390808396363521)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (MM/DD/YYYY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_MM_DD_YYYY_HH24_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23391024110363521)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (MM/DD/YYYY HH:MI)'
,p_lov_return_value=>'PICK_DATE_MM_DD_YYYY_HH_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23391223682363522)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (RR-MON-DD)'
,p_lov_return_value=>'PICK_DATE_RR_MON_DD'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23391412522363522)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (RR-MON-DD HH24:MI)'
,p_lov_return_value=>'PICK_DATE_RR_MON_DD_HH24_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23391629784363522)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (RR-MON-DD HH:MI)'
,p_lov_return_value=>'PICK_DATE_RR_MON_DD_HH_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23391815191363522)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (YYYY-MM-DD)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23392011300363522)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (YYYY-MM-DD HH24:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD_HH24_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23392230314363523)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (YYYY-MM-DD HH:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD_HH_MI'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23392427090363523)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MM-YYYY)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_DASH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23392612438363523)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MM-YYYY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH24_MI_DASH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23392821075363523)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD-MM-YYYY HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH_MI_DASH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23393008662363523)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD.MM.YYYY)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_DOT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23393230056363524)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD.MM.YYYY HH24:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH24_MI_DOT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23393405112363524)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (DD.MM.YYYY HH:MI)'
,p_lov_return_value=>'PICK_DATE_DD_MM_YYYY_HH_MI_DOT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23393616405363524)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (YYYY.DD.MM)'
,p_lov_return_value=>'PICK_DATE_YYYY_DD_MM_DOT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23393814391363524)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (YYYY.DD.MM HH24:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_DD_MM_HH24_MI_DOT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23394014250363525)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (YYYY.DD.MM HH:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_DD_MM_HH_MI_DOT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23394208845363525)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (YYYY/MM/DD)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD_SLASH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23394414236363525)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (YYYY/MM/DD HH24:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD_HH24_MI_SLASH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(23394602109363525)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (YYYY/MM/DD HH:MI)'
,p_lov_return_value=>'PICK_DATE_YYYY_MM_DD_HH_MI_SLASH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(108055312200998132)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Date Picker (use Application Date Format)'
,p_lov_return_value=>'PICK_DATE_USING_APP_DATE_FORMAT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/unified_task_list_report_context
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(264265368241987728)
,p_lov_name=>'UNIFIED_TASK_LIST_REPORT_CONTEXT'
,p_lov_query=>'.'||wwv_flow_imp.id(264265368241987728)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475314
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(264265600210987732)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'My Tasks'
,p_lov_return_value=>'MY_TASKS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(264266065037987737)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Admin Tasks'
,p_lov_return_value=>'ADMIN_TASKS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(264266441831987737)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Initiated by Me'
,p_lov_return_value=>'INITIATED_BY_ME'
);
end;
/
prompt --application/shared_components/user_interface/lovs/upgrade_app_validation_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(630881727193397263)
,p_lov_name=>'UPGRADE_APP.VALIDATION_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(630881727193397263)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475314
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(630881931512397264)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Not Null'
,p_lov_return_value=>'ITEM_NOT_NULL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(630882130251397264)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Numeric'
,p_lov_return_value=>'ITEM_IS_NUMERIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(630882332428397264)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Valid Date'
,p_lov_return_value=>'ITEM_IS_DATE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/upgrade_application_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(484799616606261493)
,p_lov_name=>'UPGRADE_APPLICATION_OPTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(484799616606261493)||'.'
,p_location=>'STATIC'
,p_version_scn=>1113407943
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(484800018242261496)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Update Text Field Item to Number Field Item, where appropriate'
,p_lov_return_value=>'NUMBER_FIELD'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(484800813451261496)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Update Value Required item attribute to Yes, where appropriate'
,p_lov_return_value=>'REQUIRED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(484801405136261496)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Remove %null% in LOV Null Return Value of Page Items'
,p_lov_return_value=>'LOV_NULL_VALUE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(491599022386863640)
,p_lov_disp_sequence=>11
,p_lov_disp_value=>'Enable Group By for Interactive Reports'
,p_lov_return_value=>'IR_GROUP_BY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(491599221824872943)
,p_lov_disp_sequence=>12
,p_lov_disp_value=>'Enable Save Public Report for Interactive Reports'
,p_lov_return_value=>'IR_SAVE_PUBLIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(491599601439895418)
,p_lov_disp_sequence=>13
,p_lov_disp_value=>'Enable Subscription for Interactive Reports'
,p_lov_return_value=>'IR_SUBSCRIBE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(491604409666916783)
,p_lov_disp_sequence=>14
,p_lov_disp_value=>'Enable Rows Per Page Selector for Interactive Reports'
,p_lov_return_value=>'IR_ROWS_PER_PAGE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(367019127224665540)
,p_lov_disp_sequence=>15
,p_lov_disp_value=>'Enable Pivot for Interactive Reports'
,p_lov_return_value=>'IR_PIVOT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(629252116720996156)
,p_lov_disp_sequence=>16
,p_lov_disp_value=>'Numeric, Required, and Date Picker Item updates based upon conditional validations'
,p_lov_return_value=>'ADVANCED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3792189388439)
,p_lov_disp_sequence=>17
,p_lov_disp_value=>'Convert theme based Calendar to CSS Calendar'
,p_lov_return_value=>'CALENDAR_TO_CSS_CALENDAR'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1595320122944031539)
,p_lov_disp_sequence=>28
,p_lov_disp_value=>'Enable fixed report headers to the top of the page, for Interactive Reports'
,p_lov_return_value=>'IR_FIXED_HEADER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(430765451682359447)
,p_lov_disp_sequence=>38
,p_lov_disp_value=>'Upgrade Tabular Form to Interactive Grid'
,p_lov_return_value=>'TABULAR_TO_IG'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1332733641538249759)
,p_lov_disp_sequence=>48
,p_lov_disp_value=>'Upgrade Yes / No radio groups and select lists to switch'
,p_lov_return_value=>'SWITCH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(180339313137164134)
,p_lov_disp_sequence=>58
,p_lov_disp_value=>'Upgrade Legacy Form page to page containing Form Region, where appropriate'
,p_lov_return_value=>'FORM_REGION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3500993843400161)
,p_lov_disp_sequence=>68
,p_lov_disp_value=>'Upgrade jQuery Date Picker to new Date Picker'
,p_lov_return_value=>'DATE_PICKER_APEX'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(7502547990939218)
,p_lov_disp_sequence=>88
,p_lov_disp_value=>'Upgrade Buttons to use Declarative Confirmation Dialogs instead of JavaScript in URLs'
,p_lov_return_value=>'BUTTON_CONFIRM_LINK_TO_NATIVE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(4410972740476667)
,p_lov_disp_sequence=>98
,p_lov_disp_value=>'Upgrade Number Fields to use a decimal virtual keyboard'
,p_lov_return_value=>'NUMBER_FIELD_VIRTUAL_KEYBOARD'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2403745604959062)
,p_lov_disp_sequence=>108
,p_lov_disp_value=>'Update all end-aligned Number Fields to start-aligned'
,p_lov_return_value=>'START_ALIGN_NUMBER_FIELD'
);
end;
/
prompt --application/shared_components/user_interface/lovs/url_or_page
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84796030957080920)
,p_lov_name=>'URL_OR_PAGE'
,p_lov_query=>'.'||wwv_flow_imp.id(84796030957080920)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475314
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84796226344080921)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Page in this Application'
,p_lov_return_value=>'FLOW'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84796415445080921)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'URL'
,p_lov_return_value=>'URL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/use_shared_components
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(198929422047616235)
,p_lov_name=>'USE SHARED COMPONENTS'
,p_lov_query=>'.'||wwv_flow_imp.id(198929422047616235)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475314
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198929800039616236)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Yes'
,p_lov_return_value=>'COPY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198929605827616235)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'No'
,p_lov_return_value=>'DEFAULT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/use_cache_before_default
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(86061111625756135)
,p_lov_name=>'USE_CACHE_BEFORE_DEFAULT'
,p_lov_query=>'.'||wwv_flow_imp.id(86061111625756135)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475314
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88317315070836550)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Only when the value is null (otherwise use cached value)'
,p_lov_return_value=>'YES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(88317518565836550)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'From source each time item is displayed.'))
,p_lov_return_value=>'NO'
);
end;
/
prompt --application/shared_components/user_interface/lovs/values_1_9
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84704207936671347)
,p_lov_name=>'VALUES_1-9'
,p_lov_query=>'.'||wwv_flow_imp.id(84704207936671347)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475314
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84704402727671348)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'1'
,p_lov_return_value=>'1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84704610060671349)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'2'
,p_lov_return_value=>'2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84704817905671349)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'3'
,p_lov_return_value=>'3'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84705030502671349)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'4'
,p_lov_return_value=>'4'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84705211955671349)
,p_lov_disp_sequence=>50
,p_lov_disp_value=>'5'
,p_lov_return_value=>'5'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84705410247671350)
,p_lov_disp_sequence=>60
,p_lov_disp_value=>'6'
,p_lov_return_value=>'6'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84705606131671350)
,p_lov_disp_sequence=>70
,p_lov_disp_value=>'7'
,p_lov_return_value=>'7'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84705812253671350)
,p_lov_disp_sequence=>80
,p_lov_disp_value=>'8'
,p_lov_return_value=>'8'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84706018237671353)
,p_lov_disp_sequence=>90
,p_lov_disp_value=>'9'
,p_lov_return_value=>'9'
);
end;
/
prompt --application/shared_components/user_interface/lovs/view_as_list_or_icons
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(116048926655714272)
,p_lov_name=>'VIEW AS LIST OR ICONS'
,p_lov_query=>'.'||wwv_flow_imp.id(116048926655714272)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475314
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(116049325234714289)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Icons'
,p_lov_return_value=>'ICON'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(131719518320129235)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Details'
,p_lov_return_value=>'DETAIL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/view_as_list_icon_or_group
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(91143304715922587)
,p_lov_name=>'VIEW AS LIST, ICON, OR GROUP'
,p_lov_query=>'.'||wwv_flow_imp.id(91143304715922587)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475314
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(91143619792922590)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Icons'
,p_lov_return_value=>'ICON'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(91143828888922592)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Details'
,p_lov_return_value=>'DETAIL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(91144701861940682)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'By Group'
,p_lov_return_value=>'GROUP'
);
end;
/
prompt --application/shared_components/user_interface/lovs/view_page_cache
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(223958418889243758)
,p_lov_name=>'VIEW PAGE CACHE'
,p_lov_query=>'.'||wwv_flow_imp.id(223958418889243758)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475314
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(223958608319243766)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'All Pages'
,p_lov_return_value=>'ALL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(223958827202243779)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Cached Pages'
,p_lov_return_value=>'CACHED'
);
end;
/
prompt --application/shared_components/user_interface/lovs/view_as_tree_y
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84875324854438753)
,p_lov_name=>'VIEW_AS_TREE_Y'
,p_lov_query=>'.'||wwv_flow_imp.id(84875324854438753)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475314
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84875508375438754)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Tree View'
,p_lov_return_value=>'YES'
);
end;
/
prompt --application/shared_components/user_interface/lovs/web_services_old
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(92907332256756059)
,p_lov_name=>'WEB SERVICES OLD'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r from wwv_flow_shared_web_services',
'',
'where nvl(action,''OLD_SCHOOL'') not in (''NEW_SCHOOL'',''REST'') and security_group_id = :flow_security_group_id and',
'',
'      flow_id = :fb_flow_id',
'',
'order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475314
);
end;
/
prompt --application/shared_components/user_interface/lovs/web_source_discovery_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(226025716904355846)
,p_lov_name=>'WEB SOURCE DISCOVERY TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(226025716904355846)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475314
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(226026440938355847)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Simple HTTP'
,p_lov_return_value=>'HTTP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(226026019836355847)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Oracle REST Data Services'
,p_lov_return_value=>'ORDS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(685217609643094733)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Oracle Cloud Applications (SaaS) REST Service'
,p_lov_return_value=>'ADFBC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1341040228791031)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Oracle Cloud Infrastructure (OCI)'
,p_lov_return_value=>'OCI'
);
end;
/
prompt --application/shared_components/user_interface/lovs/web_reference_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(33398606197612456)
,p_lov_name=>'WEB_REFERENCE_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(33398606197612456)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475314
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(33398907058612460)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'REST'
,p_lov_return_value=>'REST'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(33399114142612461)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Based on WSDL'
,p_lov_return_value=>'WSDL'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(33399327791612461)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Manual'
,p_lov_return_value=>'MANUAL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/web_source_authent_servers
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(11627272774641932)
,p_lov_name=>'WEB_SOURCE_AUTHENT_SERVERS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_remote_servers',
' where server_type = ''AUTHENTICATION''',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475314
);
end;
/
prompt --application/shared_components/user_interface/lovs/web_source_comp_param_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(358243382603181986)
,p_lov_name=>'WEB_SOURCE_COMP_PARAM_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(358243382603181986)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475314
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(358243668175182002)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Static'
,p_lov_return_value=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(358244096383182004)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Item'
,p_lov_return_value=>'ITEM'
,p_lov_disp_cond_type=>'CURRENT_PAGE_NOT_EQUAL_CONDITION'
,p_lov_disp_cond=>'1952'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(358244479273182005)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'SQL Query (return single value)'
,p_lov_return_value=>'SQL_QUERY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(358244886829182005)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'PL/SQL Expression'
,p_lov_return_value=>'EXPRESSION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(358245299838182005)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'PL/SQL Function Body'
,p_lov_return_value=>'FUNCTION_BODY'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(358245602423182006)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Collection (CLOB)'
,p_lov_return_value=>'COLLECTION'
,p_lov_disp_cond_type=>'CURRENT_PAGE_NOT_EQUAL_CONDITION'
,p_lov_disp_cond=>'1952'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(358246012358182006)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'Null'
,p_lov_return_value=>'NULL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/web_source_database_operations
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(225834585600778166)
,p_lov_name=>'WEB_SOURCE_DATABASE_OPERATIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(225834585600778166)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475314
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(225834820793778167)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Fetch rows'
,p_lov_return_value=>'FETCH_COLLECTION'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(225835206083778167)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Fetch single row'
,p_lov_return_value=>'FETCH_SINGLE_ROW'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(225835636769778167)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Insert row'
,p_lov_return_value=>'INSERT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(225836011822778168)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Update row'
,p_lov_return_value=>'UPDATE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(225836493789778168)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Delete row'
,p_lov_return_value=>'DELETE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/web_source_http_methods
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(225847729464891335)
,p_lov_name=>'WEB_SOURCE_HTTP_METHODS'
,p_lov_query=>'.'||wwv_flow_imp.id(225847729464891335)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475314
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(225848018952891335)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'GET'
,p_lov_return_value=>'GET'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(225848434282891336)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'POST'
,p_lov_return_value=>'POST'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(225848823876891336)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'PUT'
,p_lov_return_value=>'PUT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(225849221328891336)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'DELETE'
,p_lov_return_value=>'DELETE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(225849669829891336)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'PATCH'
,p_lov_return_value=>'PATCH'
);
end;
/
prompt --application/shared_components/user_interface/lovs/web_source_modules
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(529320221428437841)
,p_lov_name=>'WEB_SOURCE_MODULES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name as d,',
'       id as r',
'  from wwv_flow_web_src_modules',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475314
);
end;
/
prompt --application/shared_components/user_interface/lovs/web_source_module_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1213221291228531)
,p_lov_name=>'WEB_SOURCE_MODULE_TYPES'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,',
'       r',
'  from (',
'         select wwv_flow_lang.system_message(''WEB_SOURCE.''|| name_with_prefix) as d,',
'               name_with_prefix as r',
'          from wwv_flow_native_plugins',
'         where plugin_type = ''WEB SOURCE TYPE''',
'         union all',
'        select display_name || wwv_flow_lang.system_message(''PLUGIN.DISPLAY_NAME_POSTFIX'') as d,',
'               ''PLUGIN_'' || name     as r',
'          from wwv_flow_plugins',
'         where flow_id           = to_number(:FB_FLOW_ID)',
'           and security_group_id = to_number(:WORKSPACE_ID)',
'           and plugin_type       = ''WEB SOURCE TYPE''',
'       )',
' order by 1'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475314
);
end;
/
prompt --application/shared_components/user_interface/lovs/web_source_param_data_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(2225637019805602)
,p_lov_name=>'WEB_SOURCE_PARAM_DATA_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(2225637019805602)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475314
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2225942432805599)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'String'
,p_lov_return_value=>'VARCHAR2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2226311027805598)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Numeric'
,p_lov_return_value=>'NUMBER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2226716979805598)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Date'
,p_lov_return_value=>'DATE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2227199776805598)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Timestamp'
,p_lov_return_value=>'TIMESTAMP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2227538753805597)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Timestamp with Time Zone'
,p_lov_return_value=>'TIMESTAMP WITH TIME ZONE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2227968132805597)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Boolean'
,p_lov_return_value=>'BOOLEAN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1759519128698745)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'Binary'
,p_lov_return_value=>'BLOB'
);
end;
/
prompt --application/shared_components/user_interface/lovs/web_source_param_directions
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(226101569473456167)
,p_lov_name=>'WEB_SOURCE_PARAM_DIRECTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(226101569473456167)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475315
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(226101897314456185)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'In'
,p_lov_return_value=>'IN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(226102209648456186)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Out'
,p_lov_return_value=>'OUT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(226102635196456186)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'In/Out'
,p_lov_return_value=>'IN_OUT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/web_source_param_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(226045111811519566)
,p_lov_name=>'WEB_SOURCE_PARAM_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(226045111811519566)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475315
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(226045806403519566)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'URL Pattern'
,p_lov_return_value=>'URL_PATTERN'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(226046295199519568)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'URL Query String'
,p_lov_return_value=>'QUERY_STRING'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(226045498681519566)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'HTTP Header'
,p_lov_return_value=>'HEADER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1687926215729036)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Data Profile Column'
,p_lov_return_value=>'DATA_PROFILE'
,p_lov_disp_cond_type=>'CURRENT_PAGE_NOT_EQUAL_CONDITION'
,p_lov_disp_cond=>'1944'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(226046619802519568)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Request or Response Body'
,p_lov_return_value=>'BODY'
,p_lov_disp_cond_type=>'CURRENT_PAGE_NOT_EQUAL_CONDITION'
,p_lov_disp_cond=>'1944'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2002212148884417)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'HTTP Status Code'
,p_lov_return_value=>'STATUS_CODE'
,p_lov_disp_cond_type=>'CURRENT_PAGE_NOT_EQUAL_CONDITION'
,p_lov_disp_cond=>'1944'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(2431343804667370)
,p_lov_disp_sequence=>7
,p_lov_disp_value=>'HTTP Reason Phrase'
,p_lov_return_value=>'REASON_PHRASE'
,p_lov_disp_cond_type=>'CURRENT_PAGE_NOT_EQUAL_CONDITION'
,p_lov_disp_cond=>'1944'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(364666922734822564)
,p_lov_disp_sequence=>8
,p_lov_disp_value=>'HTTP Cookie'
,p_lov_return_value=>'COOKIE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/web_source_remote_servers
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(225850679597910405)
,p_lov_name=>'WEB_SOURCE_REMOTE_SERVERS'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_remote_servers',
' where server_type = ''WEB_SERVICE''',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475317
);
end;
/
prompt --application/shared_components/user_interface/lovs/web_source_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(225832058197705607)
,p_lov_name=>'WEB_SOURCE_TYPES'
,p_lov_query=>'.'||wwv_flow_imp.id(225832058197705607)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475317
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(225832325691705613)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Simple HTTP'
,p_lov_return_value=>'HTTP_FEED'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(225832737890705617)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Oracle REST Data Services (Legacy Syntax)'
,p_lov_return_value=>'ORDS_2'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(225833124357705617)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Oracle REST Data Services'
,p_lov_return_value=>'ORDS_3'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(685218421813102358)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Oracle Cloud Applications (SaaS) REST Service'
,p_lov_return_value=>'ADFBC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1794465163292936)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Oracle Cloud Infrastructure (OCI)'
,p_lov_return_value=>'OCI'
);
end;
/
prompt --application/shared_components/user_interface/lovs/when_item_or_page_button_pressed
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(273753232224499618)
,p_lov_name=>'WHEN.ITEM.OR.PAGE.BUTTON.PRESSED'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select button_name,',
'       id',
'  from (',
'        /* all region buttons from current page and global page */',
'        select case when b.flow_step_id = f.global_page_id then',
'                   wwv_flow_lang.system_message(''LAYOUT.GLOBAL_PAGE_REGION_PREFIX'')',
'               end ||',
'               b.button_name ||',
'               '' ('' || b.button_image_alt || '')'' as button_name,',
'               b.id,',
'               b.button_name bn,',
'               case when b.flow_step_id = f.global_page_id then 2 else 1 end x',
'          from wwv_flow_steps p,',
'               wwv_flows f,',
'               wwv_flow_step_buttons b',
'         where p.flow_id      = :FB_FLOW_ID',
'           and p.id           = :FB_FLOW_PAGE_ID',
'           and f.id           = p.flow_id',
'           and b.flow_id      = f.id',
'           and b.flow_step_id in (:FB_FLOW_PAGE_ID, f.global_page_id)',
'         order by 4, 3 ',
'       )'))
,p_source_type=>'LEGACY_SQL'
,p_location=>'LOCAL'
,p_version_scn=>72475318
);
end;
/
prompt --application/shared_components/user_interface/lovs/wizard_adminpage_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(31963614629360602)
,p_lov_name=>'WIZARD.ADMINPAGE.OPTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(31963614629360602)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475318
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(31964362200360605)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Create a new page'
,p_lov_return_value=>'NEW'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(31964780094360605)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Identify an existing page'
,p_lov_return_value=>'EXISTING'
);
end;
/
prompt --application/shared_components/user_interface/lovs/wizard_navigationlist_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(925221062390507339)
,p_lov_name=>'WIZARD.NAVIGATIONLIST.OPTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(925221062390507339)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475318
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(925221921118507355)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Do not associate this page with a  navigation menu entry'
,p_lov_return_value=>'NONE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(925221371828507342)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Create a new navigation menu entry'
,p_lov_return_value=>'NEW'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(925221619952507355)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Identify an existing navigation menu entry for this page'
,p_lov_return_value=>'EXISTING'
);
end;
/
prompt --application/shared_components/user_interface/lovs/wizard_navilist_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(25100593691198570)
,p_lov_name=>'WIZARD.NAVILIST.OPTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(25100593691198570)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475318
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(25101283638198593)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Create a new entry'
,p_lov_return_value=>'NEW'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(25101633008198593)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Map to an existing entry'
,p_lov_return_value=>'EXISTING'
);
end;
/
prompt --application/shared_components/user_interface/lovs/wizard_tab_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(35310611267199336)
,p_lov_name=>'WIZARD.TAB.OPTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(35310611267199336)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475318
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(35310910983199398)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Do not use tabs'
,p_lov_return_value=>'0'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(35311119318199402)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Use an existing tab set and create a new tab within the existing tab set.'
,p_lov_return_value=>'1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(35311304949199402)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Use an existing tab set and reuse an existing tab within that tab set.'
,p_lov_return_value=>'2'
);
end;
/
prompt --application/shared_components/user_interface/lovs/wizard_page_report_labels
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(152065307451147996)
,p_lov_name=>'WIZARD_PAGE_REPORT_LABELS'
,p_lov_query=>'.'||wwv_flow_imp.id(152065307451147996)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475319
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(152065527589148005)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Page Items'
,p_lov_return_value=>'FORM'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(152065724052148006)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Report Columns'
,p_lov_return_value=>'REPORT'
);
end;
/
prompt --application/shared_components/user_interface/lovs/wiz_columns_list
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(8900122502751806)
,p_lov_name=>'WIZ_COLUMNS_LIST'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 column_name_esc,',
'       c002 column_name',
'  from wwv_flow_collections',
' where collection_name = ''WIZ_COLUMNS_LIST''',
' order by seq_id'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_return_column_name=>'COLUMN_NAME'
,p_display_column_name=>'COLUMN_NAME_ESC'
,p_group_sort_direction=>'ASC'
,p_default_sort_direction=>'ASC'
,p_version_scn=>72475319
);
end;
/
prompt --application/shared_components/user_interface/lovs/wiz_facet_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(525330093618033199)
,p_lov_name=>'WIZ_FACET_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(525330093618033199)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475319
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(525330343522033201)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Search'
,p_lov_return_value=>'SEARCH'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(525330747019033201)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Checkbox'
,p_lov_return_value=>'CHECKBOX'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(525331172178033201)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Radio Group'
,p_lov_return_value=>'RADIOGROUP'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(525331571723033201)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'Select List'
,p_lov_return_value=>'SELECT_LIST'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(525331971543033202)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'Range'
,p_lov_return_value=>'RANGE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(525332356377033202)
,p_lov_disp_sequence=>6
,p_lov_disp_value=>'Text Field'
,p_lov_return_value=>'TEXT_FIELD'
);
end;
/
prompt --application/shared_components/user_interface/lovs/wiz_md_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(27314867128775183)
,p_lov_name=>'WIZ_MD_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(27314867128775183)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475320
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27319937658775186)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Stacked'
,p_lov_return_value=>'MD_SINGLE_PG'
,p_lov_template=>'#DISPLAY_VALUE#| md-stacked'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27320716133775188)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Side by Side'
,p_lov_return_value=>'MD_EMAIL_STYLE'
,p_lov_template=>'#DISPLAY_VALUE#| md-side-by-side'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(27320309659775188)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Drill Down'
,p_lov_return_value=>'MD_TWO_PG'
,p_lov_template=>'#DISPLAY_VALUE#| md-drill-down'
);
end;
/
prompt --application/shared_components/user_interface/lovs/wiz_page_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(3800272775820803)
,p_lov_name=>'WIZ_PAGE_TYPE'
,p_lov_query=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select page_type_display||''| ''||icon disp_val, page_type, display_order',
'  from wwv_flow_page_types_dev',
' where category = :P2500_CATEGORY',
' order by display_order, page_type_display'))
,p_source_type=>'SQL'
,p_location=>'LOCAL'
,p_use_local_sync_table=>false
,p_query_table=>'WWV_FLOW_PAGE_TYPES_DEV'
,p_return_column_name=>'PAGE_TYPE'
,p_display_column_name=>'DISP_VAL'
,p_group_sort_direction=>'ASC'
,p_default_sort_direction=>'ASC'
,p_version_scn=>72475320
);
end;
/
prompt --application/shared_components/user_interface/lovs/wiz_source_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(37501497605557000)
,p_lov_name=>'WIZ_SOURCE_TYPE'
,p_lov_query=>'.'||wwv_flow_imp.id(37501497605557000)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475320
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(37501702276557022)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Table'
,p_lov_return_value=>'TABLE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(37502170909557023)
,p_lov_disp_sequence=>5
,p_lov_disp_value=>'SQL Query'
,p_lov_return_value=>'SQL'
);
end;
/
prompt --application/shared_components/user_interface/lovs/wiz_wiz_tab_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84345829981643314)
,p_lov_name=>'WIZ_WIZ_TAB_OPTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(84345829981643314)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475320
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84346018173643315)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Use an existing tab set and create a new tab within the existing tab set.'
,p_lov_return_value=>'1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84346203959643315)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Use an existing tab set and reuse an existing tab within that tab set.'
,p_lov_return_value=>'2'
);
end;
/
prompt --application/shared_components/user_interface/lovs/workflow_console_report_context
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(3201550597510160)
,p_lov_name=>'WORKFLOW_CONSOLE_REPORT_CONTEXT'
,p_lov_query=>'.'||wwv_flow_imp.id(3201550597510160)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475320
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3201818253510188)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'My Workflows'
,p_lov_return_value=>'MY_WORKFLOWS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3202293236510189)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Admin Workflows'
,p_lov_return_value=>'ADMIN_WORKFLOWS'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(3202600477510189)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Initiated by Me'
,p_lov_return_value=>'INITIATED_BY_ME'
);
end;
/
prompt --application/shared_components/user_interface/lovs/workspace_theme_options
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(113820707988557953)
,p_lov_name=>'WORKSPACE THEME OPTIONS'
,p_lov_query=>'.'||wwv_flow_imp.id(113820707988557953)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475320
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(113820906685557954)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Create'
,p_lov_return_value=>'CREATE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(135526931799036577)
,p_lov_disp_sequence=>30
,p_lov_disp_value=>'Delete'
,p_lov_return_value=>'DELETE'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from   wwv_flow_themes',
'where  security_group_id = 11 and',
'       THEME_SECURITY_GROUP_ID = :flow_security_group_id'))
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(135608115850230686)
,p_lov_disp_sequence=>40
,p_lov_disp_value=>'View Existing'
,p_lov_return_value=>'VIEW'
,p_lov_disp_cond_type=>'EXISTS'
,p_lov_disp_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from   wwv_flow_themes',
'where  security_group_id = 11 and',
'       THEME_SECURITY_GROUP_ID = :flow_security_group_id'))
);
end;
/
prompt --application/shared_components/user_interface/lovs/ws_app_acl_type
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(460746220203713213)
,p_lov_name=>'WS_APP_ACL_TYPE'
,p_reference_id=>450940100671567605
,p_lov_query=>'.'||wwv_flow_imp.id(460746220203713213)||'.'
,p_location=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(460747302042713218)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Default'
,p_lov_return_value=>'DEFAULT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(460747103102713218)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Custom'
,p_lov_return_value=>'CUSTOM'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ws_app_admin_user_method
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1740196320530053227)
,p_lov_name=>'WS_APP_ADMIN_USER_METHOD'
,p_lov_query=>'.'||wwv_flow_imp.id(1740196320530053227)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475320
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1740197213951053228)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Use Existing User'
,p_lov_return_value=>'E'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1740197832363053228)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Create New User'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ws_include_getting_started
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(1736992503665130556)
,p_lov_name=>'WS_INCLUDE_GETTING_STARTED'
,p_lov_query=>'.'||wwv_flow_imp.id(1736992503665130556)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475320
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(1736992805000130557)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Include Getting Started Guide'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ws_logo_types
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(461275327966469166)
,p_lov_name=>'WS_LOGO_TYPES'
,p_reference_id=>461278502171499627
,p_lov_query=>'.'||wwv_flow_imp.id(461275327966469166)||'.'
,p_location=>'STATIC'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(461280508998501659)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'None'
,p_lov_return_value=>'NONE'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(461280730923501659)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Text'
,p_lov_return_value=>'TEXT'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(461280331003501659)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Uploaded Image'
,p_lov_return_value=>'IMAGE'
,p_lov_disp_cond_type=>'NEVER'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(461280109443501659)
,p_lov_disp_sequence=>4
,p_lov_disp_value=>'File Path'
,p_lov_return_value=>'FILEPATH'
,p_lov_disp_cond_type=>'NEVER'
);
end;
/
prompt --application/shared_components/user_interface/lovs/ws_soap_version
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(439439004288980949)
,p_lov_name=>'WS_SOAP_VERSION'
,p_lov_query=>'.'||wwv_flow_imp.id(439439004288980949)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475320
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(439439222910980951)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'1.1'
,p_lov_return_value=>'1.1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(439439430311980951)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'1.2'
,p_lov_return_value=>'1.2'
);
end;
/
prompt --application/shared_components/user_interface/lovs/wwv_flow_runtime_api_usage
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(561570937398567414)
,p_lov_name=>'WWV_FLOW-RUNTIME_API_USAGE'
,p_lov_query=>'.'||wwv_flow_imp.id(561570937398567414)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475320
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(561571212445567415)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Modify This Application'
,p_lov_return_value=>'T'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(561571509577567417)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Modify Other Applications'
,p_lov_return_value=>'O'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(561571812827567417)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Modify Workspace Repository'
,p_lov_return_value=>'W'
);
end;
/
prompt --application/shared_components/user_interface/lovs/xliff_elements_include
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(102649602892386356)
,p_lov_name=>'XLIFF_ELEMENTS_INCLUDE'
,p_lov_query=>'.'||wwv_flow_imp.id(102649602892386356)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475320
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(102649911269386359)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'All translatable elements'
,p_lov_return_value=>'Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(102650132340386359)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'Only those elements requiring translation'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/xliff_target_include
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(42166827828941188)
,p_lov_name=>'XLIFF_TARGET_INCLUDE'
,p_lov_query=>'.'||wwv_flow_imp.id(42166827828941188)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475320
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(42167111083941194)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Include XLIFF Target Elements'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/yes_no_returns_1_0
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(198612221943560137)
,p_lov_name=>'YES, NO RETURNS 1, 0'
,p_lov_query=>'.'||wwv_flow_imp.id(198612221943560137)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475320
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198612404411560139)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Yes'
,p_lov_return_value=>'1'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(198612632486560142)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'No'
,p_lov_return_value=>'0'
);
end;
/
prompt --application/shared_components/user_interface/lovs/yes_no_subscribe
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(309317735965282153)
,p_lov_name=>'YES.NO.SUBSCRIBE'
,p_lov_query=>'.'||wwv_flow_imp.id(309317735965282153)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475320
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(309318063170282177)
,p_lov_disp_sequence=>1
,p_lov_disp_value=>'Yes'
,p_lov_return_value=>'Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(309318402035282181)
,p_lov_disp_sequence=>2
,p_lov_disp_value=>'No'
,p_lov_return_value=>'N'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(309318793940282183)
,p_lov_disp_sequence=>3
,p_lov_disp_value=>'Copy and Subscribe'
,p_lov_return_value=>'SUBSCRIBE'
);
end;
/
prompt --application/shared_components/user_interface/lovs/yes_returns_y
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84886607679518894)
,p_lov_name=>'YES.RETURNS.Y'
,p_lov_query=>'.'||wwv_flow_imp.id(84886607679518894)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475320
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84886832024518895)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Yes'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/yes_no_returns_n_or_y
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84282932564530536)
,p_lov_name=>'YES_NO_RETURNS_N_OR_Y'
,p_lov_query=>'.'||wwv_flow_imp.id(84282932564530536)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475320
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84283132061530537)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Yes'
,p_lov_return_value=>'N'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84283318278530537)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'No'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/shared_components/user_interface/lovs/yes_no_returns_yes_or_no
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84270019143507704)
,p_lov_name=>'YES_NO_RETURNS_YES_OR_NO'
,p_lov_query=>'.'||wwv_flow_imp.id(84270019143507704)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475320
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84270401651507705)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Yes'
,p_lov_return_value=>'YES'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84270215696507704)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'No'
,p_lov_return_value=>'NO'
);
end;
/
prompt --application/shared_components/user_interface/lovs/yes_no_returns_y_or_n
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84259319526460470)
,p_lov_name=>'YES_NO_RETURNS_Y_OR_N'
,p_lov_query=>'.'||wwv_flow_imp.id(84259319526460470)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475320
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84259519184460471)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'Yes'
,p_lov_return_value=>'Y'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84259724142460471)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'No'
,p_lov_return_value=>'N'
);
end;
/
prompt --application/shared_components/user_interface/lovs/y_n
begin
wwv_flow_imp_shared.create_list_of_values(
 p_id=>wwv_flow_imp.id(84887415298521126)
,p_lov_name=>'Y_N'
,p_lov_query=>'.'||wwv_flow_imp.id(84887415298521126)||'.'
,p_location=>'STATIC'
,p_version_scn=>72475320
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84887627279521126)
,p_lov_disp_sequence=>10
,p_lov_disp_value=>'No'
,p_lov_return_value=>'N'
);
wwv_flow_imp_shared.create_static_lov_data(
 p_id=>wwv_flow_imp.id(84887809648521127)
,p_lov_disp_sequence=>20
,p_lov_disp_value=>'Yes'
,p_lov_return_value=>'Y'
);
end;
/
prompt --application/pages/page_groups
begin
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(200467223102537626)
,p_group_name=>'APEX Views'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(24935825160088375)
,p_group_name=>'Access Control Wizard'
,p_group_desc=>'wizard to create an acl for an application'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(213220627333807318)
,p_group_name=>'Application Definition'
,p_group_desc=>'Pages dedicated to defining attributes about or managing an application.  Includes application home page.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(91139922499861568)
,p_group_name=>'Application Groups'
,p_group_desc=>'Pages dedicated to the definition, reporting, and management of page groups'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(213261028690930718)
,p_group_name=>'Breadcrumbs'
,p_group_desc=>'Pages related to the definition and maintenance of breadcrumbs.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(213481614528579568)
,p_group_name=>'Build Options'
,p_group_desc=>'Pages dedicated to the maintenance of build options.  Build options are used to conditionally enable or disable functionality on deployment.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(213433100273471382)
,p_group_name=>'Calendar Functionality'
,p_group_desc=>'Pages related to the creation and management of calendar components.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(212889110308348288)
,p_group_name=>'Create Application'
,p_group_desc=>'Wizard used to create an application.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(213415628923422845)
,p_group_name=>'Create Charts'
,p_group_desc=>'Wizards to define charts'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(423953526918849791)
,p_group_name=>'Create Data Upload Wizard'
,p_group_desc=>'Pages associated with the Data Upload feature introduced in APEX 4.1'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(214164216163913779)
,p_group_name=>'Create Equi Join Form'
,p_group_desc=>'Equi Join Wizard'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(215582428597891495)
,p_group_name=>'Create Form & Report Pg Wiz'
,p_group_desc=>'Create two pages, report and form page.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(11502317173549416)
,p_group_name=>'Create Form Pagination'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(212960930328524322)
,p_group_name=>'Create Form on a SP'
,p_group_desc=>'Wizard'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(212960427558523531)
,p_group_name=>'Create Form on a Table'
,p_group_desc=>'Wizard'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(93464502376707648)
,p_group_name=>'Create Interactive Report Wizard'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(212882205890328007)
,p_group_name=>'Create Master Detail Form'
,p_group_desc=>'Wizard to create a master detail form.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(11511713242614593)
,p_group_name=>'Create Page'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(24944407948215834)
,p_group_name=>'Create Page Component Wiz'
,p_group_desc=>'wizard to select the component wizard'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(24946625394230350)
,p_group_name=>'Create Page Item Wizard'
,p_group_desc=>'wizard to define page items'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(103848364625132731)
,p_group_name=>'Create Page Wizard'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(213195414033718396)
,p_group_name=>'Create Region Wizards'
,p_group_desc=>'Wizard steps to create regions of all types.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(213576500084748241)
,p_group_name=>'Create Report'
,p_group_desc=>'Wizards used to create new reports.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(214168830839927421)
,p_group_name=>'Create Summary Page Wiz'
,p_group_desc=>'Create Summary Page Wizard'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(158563552508587748)
,p_group_name=>'Credentials'
,p_group_desc=>'Pages dedicated to maintain stored credentials for external services.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(109806184695090105)
,p_group_name=>'Data Generator'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(1449603451873552)
,p_group_name=>'Data Loading'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(117814363885361293)
,p_group_name=>'Data Packager'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(215588412929905871)
,p_group_name=>'Demonstration Application'
,p_group_desc=>'Create and manage demonstration applications'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(216995930363945283)
,p_group_name=>'Dependencies'
,p_group_desc=>'Manage and track database object dependencies.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(24897722063538624)
,p_group_name=>'Deployment'
,p_group_desc=>'Manage database object, image, and seed data installation meta data.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(4518805581694342)
,p_group_name=>'Dynamic Actions'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(213300727323081712)
,p_group_name=>'Export and Import'
,p_group_desc=>'Component, application, and page export import functionality.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(215592520464926917)
,p_group_name=>'File Management'
,p_group_desc=>'Manage image, CSS, and javascript files.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(5131626840158646)
,p_group_name=>'Flash Charts'
,p_group_desc=>'UI to manage creation and editing of Flash charts.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(24907316279669450)
,p_group_name=>'Install'
,p_group_desc=>'Install database objects, images, and seed data.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(91400029783905909)
,p_group_name=>'Interactive Report'
,p_group_desc=>'Pages to define and manage Interactive Report regions'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(213210808239773454)
,p_group_name=>'Lists'
,p_group_desc=>'All pages used to define and manage lists.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(213211113434774960)
,p_group_name=>'Lists of Values'
,p_group_desc=>'All pages used to define and manage lists of values.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(213427413171456110)
,p_group_name=>'Monitoring'
,p_group_desc=>'Monitoring of development activity.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(213263531591941060)
,p_group_name=>'Navigation Bar'
,p_group_desc=>'Pages related to the definition and maintence of navigation bar icons.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(158563443147585227)
,p_group_name=>'ORDS Remote SQL Servers'
,p_group_desc=>'Pages dedicated to configure ORDS Remote SQL Servers.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(212963412798528796)
,p_group_name=>'Page Definition'
,p_group_desc=>'Pages that are used to define a page and page attributes.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(212903908539395030)
,p_group_name=>'Page Groups'
,p_group_desc=>'Pages used to implement the page group functionality.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(213229021839834158)
,p_group_name=>'Page Locking'
,p_group_desc=>'Functionality supporting developers locking pages.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(27816729931938405)
,p_group_name=>'Plug-ins'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(5507600580299857)
,p_group_name=>'Popup finder'
,p_group_desc=>'flahlight popup pages'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(11501804013545635)
,p_group_name=>'Reporting'
,p_group_desc=>'Report on the builder meta data.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(213425326892450628)
,p_group_name=>'Security'
,p_group_desc=>'Pages related to the definition of authentication and authorization functionality.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(262753407599695606)
,p_group_name=>'Session State Protection'
,p_group_desc=>'Session State Protection'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(91429205691059841)
,p_group_name=>'Shared Components'
,p_group_desc=>'Application Items, Computations, Processes, ...'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(22569212548659511)
,p_group_name=>'Shared Queries'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(213468022923563047)
,p_group_name=>'Shortcuts'
,p_group_desc=>'All pages dedicated to the management of shortcuts.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(213240607818867991)
,p_group_name=>'Tabs'
,p_group_desc=>'Pages related to the organization of tabs.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(212879727923324936)
,p_group_name=>'Templates'
,p_group_desc=>'Definition of templates, different then themes.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(212879423075323511)
,p_group_name=>'Themes'
,p_group_desc=>'Theme subsystem, different from template management'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(213331522315193801)
,p_group_name=>'Translation'
,p_group_desc=>'Translation sub system including xliff export / import.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(213443923391496926)
,p_group_name=>'Tree'
,p_group_desc=>'Pages dedicated to the definition and management of tree components.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(262745606420610180)
,p_group_name=>'UI Defaults'
,p_group_desc=>'Pages that manage UI Defaults.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(261841008861828406)
,p_group_name=>'Update Attribute Dictionary'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(213347710073256556)
,p_group_name=>'Web Services'
,p_group_desc=>'All pages dedicated to the definition of web services related functionality.'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(214145517801857461)
,p_group_name=>'Wizard Wizard'
,p_group_desc=>'Wizards used to create wizards'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(113748409598274541)
,p_group_name=>'Workspace Themes'
);
wwv_flow_imp_page.create_page_group(
 p_id=>wwv_flow_imp.id(5507013954294272)
,p_group_name=>'Workspace Utilities'
);
end;
/
prompt --application/shared_components/navigation/breadcrumbs/app_builder_breadcrumb
begin
wwv_flow_imp_shared.create_menu(
 p_id=>wwv_flow_imp.id(6341600034528019)
,p_name=>'App Builder Breadcrumb'
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(799613605926722)
,p_parent_id=>wwv_flow_imp.id(6342315964532655)
,p_short_name=>'Supporting Objects'
,p_link=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:::'
,p_page_id=>2
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(855100382282348)
,p_parent_id=>wwv_flow_imp.id(6342315964532655)
,p_short_name=>'Install Application'
,p_link=>'f?p=&APP_ID.:2100:&SESSION.::&DEBUG.:::'
,p_page_id=>2100
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(869027208612693)
,p_parent_id=>wwv_flow_imp.id(799613605926722)
,p_short_name=>'Edit Substitutions'
,p_link=>'f?p=&APP_ID.:17:&SESSION.::&DEBUG.:::'
,p_page_id=>17
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(965315472705309)
,p_parent_id=>wwv_flow_imp.id(22464532161251314)
,p_short_name=>'Script Properties'
,p_link=>'f?p=&APP_ID.:328:&SESSION.::&DEBUG.:::'
,p_page_id=>328
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(1001331461925880)
,p_parent_id=>wwv_flow_imp.id(799613605926722)
,p_short_name=>'Validation'
,p_link=>'f?p=&APP_ID.:376:&SESSION.::&DEBUG.:::'
,p_page_id=>376
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(1308911481947279)
,p_short_name=>'<span class="u-VisuallyHidden">App Builder</span><span class="a-Icon icon-breadcrumb-previous" title="App Builder"></span>'
,p_link=>'f?p=&APP_ID.:1500:&SESSION.::&DEBUG.:::'
,p_page_id=>1500
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(1358650661486623)
,p_parent_id=>wwv_flow_imp.id(2549660762513182)
,p_short_name=>'Execution Log'
,p_link=>'f?p=&APP_ID.:7025:&APP_SESSION.::&DEBUG.:::'
,p_page_id=>7025
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(1411154832911151)
,p_parent_id=>wwv_flow_imp.id(177829529391401676)
,p_short_name=>'Embedded Code'
,p_link=>'f?p=&APP_ID.:101:&SESSION.::&DEBUG.:101::'
,p_page_id=>101
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(1425350635205164)
,p_parent_id=>wwv_flow_imp.id(6342315964532655)
,p_short_name=>'AI'
,p_link=>'f?p=&APP_ID.:523:&SESSION.::&DEBUG.:::'
,p_page_id=>523
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(1482681391903408)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Search Configurations'
,p_link=>'f?p=&APP_ID.:3100:&SESSION.::&DEBUG.:::'
,p_page_id=>3100
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(1493797321971786)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Workflows'
,p_link=>'f?p=&APP_ID.:9601:&APP_SESSION.::&DEBUG.:::'
,p_page_id=>9601
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(1522980851540798)
,p_parent_id=>wwv_flow_imp.id(3801099868410190)
,p_short_name=>'Edit Action Position'
,p_link=>'f?p=&APP_ID.:4417:&SESSION.::&DEBUG.:::'
,p_page_id=>4417
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(1525751098130060)
,p_parent_id=>wwv_flow_imp.id(1493797321971786)
,p_short_name=>'Workflow History'
,p_link=>'f?p=&APP_ID.:9602:&APP_SESSION.::&DEBUG.:::'
,p_page_id=>9602
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(1600610175123641)
,p_parent_id=>wwv_flow_imp.id(1819924318622952)
,p_short_name=>'History'
,p_link=>'f?p=&APP_ID.:9507:&SESSION.::&DEBUG.:::'
,p_page_id=>9507
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(1604711273349938)
,p_parent_id=>wwv_flow_imp.id(1493797321971786)
,p_short_name=>'Utilization'
,p_link=>'f?p=&APP_ID.:9603:&APP_SESSION.::&DEBUG.:::'
,p_page_id=>9603
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(1702645656042207)
,p_parent_id=>wwv_flow_imp.id(2550040639513183)
,p_short_name=>'Edit Action'
,p_link=>'f?p=&APP_ID.:7022:&SESSION.::&DEBUG.:::'
,p_page_id=>7022
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(1704369472535279)
,p_parent_id=>wwv_flow_imp.id(6342315964532655)
,p_short_name=>'Diff and Merge'
,p_link=>'f?p=&APP_ID.:5300:&SESSION.::&DEBUG.:::'
,p_page_id=>5300
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(1722728327303265)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Report Query Utilization'
,p_link=>'f?p=&APP_ID.:1130:&SESSION.::&DEBUG.:::'
,p_page_id=>1130
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(1757732572180845)
,p_parent_id=>wwv_flow_imp.id(1482681391903408)
,p_short_name=>'Edit'
,p_link=>'f?p=&APP_ID.:3120:&SESSION.::&DEBUG.:::'
,p_page_id=>3120
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(1805178818697444)
,p_parent_id=>wwv_flow_imp.id(15135828644258802)
,p_short_name=>'&P1820_BREADCRUMB_NAME.'
,p_link=>'f?p=&APP_ID.:1820:&SESSION.::&DEBUG.:::'
,p_page_id=>1820
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(1819924318622952)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Task Definitions'
,p_link=>'f?p=&APP_ID.:9500:&SESSION.::&DEBUG.:::'
,p_page_id=>9500
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(1901754624895114)
,p_parent_id=>wwv_flow_imp.id(1819924318622952)
,p_short_name=>'&P9502_NAME.'
,p_link=>'f?p=&APP_ID.:9502:&SESSION.::&DEBUG.:::'
,p_page_id=>9502
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(1901893890995229)
,p_parent_id=>wwv_flow_imp.id(699056895544610173)
,p_short_name=>'Manage Backups'
,p_link=>'f?p=&APP_ID.:970:&SESSION.::&DEBUG.:970::'
,p_page_id=>970
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(1901938911903919)
,p_parent_id=>wwv_flow_imp.id(1901754624895114)
,p_short_name=>'Edit Action'
,p_long_name=>'Edit Task Definition Action'
,p_link=>'f?p=&APP_ID.:9506:&SESSION.::&DEBUG.:::'
,p_page_id=>9506
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(1902075798009204)
,p_parent_id=>wwv_flow_imp.id(177829529391401676)
,p_short_name=>'Manage Backups'
,p_link=>'f?p=&APP_ID.:971:&SESSION.::&DEBUG.:971::'
,p_page_id=>971
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(1911442868458133)
,p_parent_id=>wwv_flow_imp.id(3801099868410190)
,p_short_name=>'Edit Action Template'
,p_link=>'f?p=&APP_ID.:4418:&APP_SESSION.::&DEBUG.:::'
,p_page_id=>4418
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(1913700761291636)
,p_short_name=>'Master Detail'
,p_link=>'f?p=&APP_ID.:12:&SESSION.::&DEBUG.:::'
,p_page_id=>12
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(1915025334295420)
,p_short_name=>'Create Master Detail'
,p_link=>'f?p=&APP_ID.:293:&SESSION.::&DEBUG.:::'
,p_page_id=>293
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(1916320158297870)
,p_short_name=>'Create Master Detail'
,p_link=>'f?p=&APP_ID.:15:&SESSION.::&DEBUG.:::'
,p_page_id=>15
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(1917316707299485)
,p_short_name=>'Master Detail'
,p_link=>'f?p=&APP_ID.:18:&SESSION.::&DEBUG.:::'
,p_page_id=>18
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(1918313041301140)
,p_short_name=>'Create Master Detail'
,p_link=>'f?p=&APP_ID.:24:&SESSION.::&DEBUG.:::'
,p_page_id=>24
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(1920305277304710)
,p_short_name=>'Create Master Detail'
,p_link=>'f?p=&APP_ID.:35:&SESSION.::&DEBUG.:::'
,p_page_id=>35
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(2000951442910272)
,p_parent_id=>wwv_flow_imp.id(221168815878138814)
,p_short_name=>'Edit Breadcrumb'
,p_link=>'f?p=&APP_ID.:104:&APP_SESSION.::&DEBUG.:::'
,p_page_id=>104
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(2034249953651264)
,p_parent_id=>wwv_flow_imp.id(699056895544610173)
,p_short_name=>'REST Source Catalogs'
,p_link=>'f?p=&APP_ID.:1960:&SESSION.::&DEBUG.:::'
,p_page_id=>1960
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(2141810057477568)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Application Item Utilization'
,p_link=>'f?p=&APP_ID.:130:&SESSION.::&DEBUG.:::'
,p_page_id=>130
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(2305319228274490)
,p_parent_id=>wwv_flow_imp.id(680963074297437695)
,p_short_name=>'Utilization'
,p_link=>'f?p=&APP_ID.:4862:&APP_SESSION.::&DEBUG.:::'
,p_page_id=>4862
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(2397821176365887)
,p_parent_id=>wwv_flow_imp.id(3401147094525811)
,p_short_name=>'Utilization'
,p_link=>'f?p=&APP_ID.:9803:&SESSION.::&DEBUG.:::'
,p_page_id=>9803
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(2398048959376128)
,p_parent_id=>wwv_flow_imp.id(3401147094525811)
,p_short_name=>'History'
,p_link=>'f?p=&APP_ID.:9804:&SESSION.::&DEBUG.:::'
,p_page_id=>9804
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(2405460176806715)
,p_parent_id=>wwv_flow_imp.id(680963074297437695)
,p_short_name=>'History'
,p_link=>'f?p=&APP_ID.:4863:&SESSION.::&DEBUG.:::'
,p_page_id=>4863
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(2413351093645080)
,p_parent_id=>wwv_flow_imp.id(1308911481947279)
,p_short_name=>'Export'
,p_link=>'f?p=&APP_ID.:4900:&SESSION.::&DEBUG.:::'
,p_page_id=>4900
,p_display_when_cond_type=>'ITEM_IS_NULL'
,p_display_when_condition=>'FB_FLOW_ID'
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(2487551860775188)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create Plug-in'
,p_link=>'f?p=&APP_ID.:4402:&SESSION.::&DEBUG.:::'
,p_page_id=>4402
,p_display_when_cond_type=>'ITEM_IS_NOT_NULL'
,p_display_when_condition=>'P4402_FOR_THEME'
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(2487892860787815)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create Plug-in'
,p_link=>'f?p=&APP_ID.:4403:&SESSION.::&DEBUG.:::'
,p_page_id=>4403
,p_display_when_cond_type=>'ITEM_IS_NOT_NULL'
,p_display_when_condition=>'P4403_FOR_THEME'
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(2488221185799499)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create Plug-in'
,p_link=>'f?p=&APP_ID.:4404:&SESSION.::&DEBUG.:::'
,p_page_id=>4404
,p_display_when_cond_type=>'ITEM_IS_NOT_NULL'
,p_display_when_condition=>'P4404_FOR_THEME'
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(2488401346805069)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create Plug-in'
,p_link=>'f?p=&APP_ID.:4405:&SESSION.::&DEBUG.:::'
,p_page_id=>4405
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(2488630270808601)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create Plug-in'
,p_link=>'f?p=&APP_ID.:4406:&SESSION.::&DEBUG.:::'
,p_page_id=>4406
,p_display_when_cond_type=>'ITEM_IS_NOT_NULL'
,p_display_when_condition=>'P4406_COPY_TO_THEME_ID'
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(2488828182812654)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Edit Plug-in'
,p_link=>'f?p=&APP_ID.:4410:&SESSION.::&DEBUG.:::'
,p_page_id=>4410
,p_display_when_cond_type=>'ITEM_IS_NOT_NULL'
,p_display_when_condition=>'P4410_THEME_ID'
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(2549660762513182)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Automations'
,p_link=>'f?p=&APP_ID.:7020:&SESSION.::&DEBUG.:::'
,p_page_id=>7020
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(2550040639513183)
,p_parent_id=>wwv_flow_imp.id(2549660762513182)
,p_short_name=>'&P7021_NAME.'
,p_link=>'f?p=&APP_ID.:7021:&APP_SESSION.::&DEBUG.:::'
,p_page_id=>7021
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(2601704129770062)
,p_parent_id=>wwv_flow_imp.id(4789520415461435)
,p_short_name=>'Data Package'
,p_link=>'f?p=&APP_ID.:6000:&SESSION.::&DEBUG.:::'
,p_page_id=>6000
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(2801449870741965)
,p_parent_id=>wwv_flow_imp.id(4789520415461435)
,p_short_name=>'Data Package'
,p_link=>'f?p=&APP_ID.:6001:&SESSION.::&DEBUG.:::'
,p_page_id=>6001
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(2801501581236541)
,p_parent_id=>wwv_flow_imp.id(6342315964532655)
,p_short_name=>'Export'
,p_link=>'f?p=&APP_ID.:164:&SESSION.::&DEBUG.:::'
,p_page_id=>164
,p_display_when_cond_type=>'ITEM_IS_NOT_NULL'
,p_display_when_condition=>'FB_FLOW_ID'
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(2821803379590494)
,p_parent_id=>wwv_flow_imp.id(492636106117616338)
,p_short_name=>'Delete Multiple Pages'
,p_link=>'f?p=&APP_ID.:339:&SESSION.::&DEBUG.:::'
,p_page_id=>339
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(2855632092663641)
,p_parent_id=>wwv_flow_imp.id(492636106117616338)
,p_short_name=>'Page Pattern Utilization'
,p_link=>'f?p=&APP_ID.:6210:&SESSION.::&DEBUG.:::'
,p_page_id=>6210
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(3007099013503414)
,p_parent_id=>wwv_flow_imp.id(6342315964532655)
,p_short_name=>'Remote Deployment Server'
,p_link=>'f?p=&APP_ID.:4905:&SESSION.::&DEBUG.:::'
,p_page_id=>4905
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(3011686675977907)
,p_parent_id=>wwv_flow_imp.id(3401147094525811)
,p_short_name=>'Create/Edit'
,p_link=>'f?p=&APP_ID.:9801:&SESSION.::&DEBUG.:::'
,p_page_id=>9801
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(3125161068266187)
,p_parent_id=>wwv_flow_imp.id(2034249953651264)
,p_short_name=>'&P1963_CATALOG_NAME.'
,p_link=>'f?p=&APP_ID.:1963:&SESSION.::&DEBUG.:::'
,p_page_id=>1963
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(3130377541661641)
,p_parent_id=>wwv_flow_imp.id(1805178818697444)
,p_short_name=>'Data Profile'
,p_link=>'f?p=&APP_ID.:1925:&SESSION.::&DEBUG.:::'
,p_page_id=>1925
,p_display_when_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_condition=>'P1925_IS_WEB_SRC_PROFILE'
,p_display_when_condition2=>'N'
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(3131763172705400)
,p_parent_id=>wwv_flow_imp.id(3130377541661641)
,p_short_name=>'Column'
,p_link=>'f?p=&APP_ID.:1926:&SESSION.::&DEBUG.:::'
,p_page_id=>1926
,p_display_when_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_condition=>'P1925_IS_WEB_SRC_PROFILE'
,p_display_when_condition2=>'N'
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(3200894554960973)
,p_parent_id=>wwv_flow_imp.id(1819924318622952)
,p_short_name=>'Utilization'
,p_long_name=>'Task Definitions Utilization'
,p_link=>'f?p=&APP_ID.:9508:&SESSION.::&DEBUG.:::'
,p_page_id=>9508
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(3201123196120267)
,p_parent_id=>wwv_flow_imp.id(15135828644258802)
,p_short_name=>'Utilization'
,p_link=>'f?p=&APP_ID.:1821:&SESSION.::&DEBUG.:::'
,p_page_id=>1821
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(3206923152925971)
,p_parent_id=>wwv_flow_imp.id(3125161068266187)
,p_short_name=>'&P1964_NAME.'
,p_link=>'f?p=&APP_ID.:1964:&SESSION.::&DEBUG.:::'
,p_page_id=>1964
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(3302233129660650)
,p_parent_id=>wwv_flow_imp.id(229167313944963222)
,p_short_name=>'Column'
,p_long_name=>'Data Profile Column'
,p_link=>'f?p=&APP_ID.:1926:&SESSION.::&DEBUG.:::'
,p_page_id=>1926
,p_display_when_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_condition=>'P1925_IS_WEB_SRC_PROFILE'
,p_display_when_condition2=>'Y'
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(3320654420728496)
,p_parent_id=>wwv_flow_imp.id(45432327870093655)
,p_short_name=>'Remote Deployment Options'
,p_link=>'f?p=&APP_ID.:4906:&SESSION.'
,p_page_id=>4906
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(3401147094525811)
,p_parent_id=>wwv_flow_imp.id(699056895544610173)
,p_short_name=>'Generative AI Services'
,p_link=>'f?p=&APP_ID.:9800:&SESSION.::&DEBUG.:::'
,p_page_id=>9800
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(3600249891202556)
,p_parent_id=>wwv_flow_imp.id(1358650661486623)
,p_short_name=>'Messages'
,p_link=>'f?p=&APP_ID.:7026:&SESSION.::&DEBUG.:::'
,p_page_id=>7026
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(3691700327027879)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Edit Legacy Calendar Template'
,p_link=>'f?p=&APP_ID.:80:&SESSION.::&DEBUG.:::'
,p_page_id=>80
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(3746494644600815)
,p_parent_id=>wwv_flow_imp.id(1308911481947279)
,p_short_name=>'Export'
,p_link=>'f?p=&APP_ID.:1965:&SESSION.::&DEBUG.:::'
,p_page_id=>1965
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(3800905874609467)
,p_parent_id=>wwv_flow_imp.id(3600263368521940)
,p_short_name=>'Edit File'
,p_link=>'f?p=&APP_ID.:118:&SESSION.::&DEBUG.:::'
,p_page_id=>118
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P118_SCOPE = ''PLUGIN'' and :P118_ID is not null'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(3801388702626905)
,p_parent_id=>wwv_flow_imp.id(6490322331050183)
,p_short_name=>'Edit'
,p_link=>'f?p=&APP_ID.:118:&SESSION.::&DEBUG.:::'
,p_page_id=>118
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P118_SCOPE = ''APP'' and :P118_ID is not null'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(3801648445638850)
,p_parent_id=>wwv_flow_imp.id(26484923558914183)
,p_short_name=>'Edit'
,p_link=>'f?p=&APP_ID.:118:&SESSION.::&DEBUG.:::'
,p_page_id=>118
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P118_SCOPE = ''WORKSPACE'' and :P118_ID is not null'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(3802125115659448)
,p_parent_id=>wwv_flow_imp.id(3803609664693374)
,p_short_name=>'Edit File'
,p_link=>'f?p=&APP_ID.:118:&SESSION.::&DEBUG.:::'
,p_page_id=>118
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P118_SCOPE = ''THEME'' and :P118_ID is not null'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(3813598957381798)
,p_parent_id=>wwv_flow_imp.id(1704369472535279)
,p_short_name=>'Confirm Action'
,p_link=>'f?p=&APP_ID.:5301:&SESSION.::&DEBUG.:::'
,p_page_id=>5301
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(3818189874234693)
,p_parent_id=>wwv_flow_imp.id(2034249953651264)
,p_short_name=>'REST Catalog Groups'
,p_link=>'f?p=&APP_ID.:1968:&SESSION.::&DEBUG.:RP,1968::'
,p_page_id=>1968
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4026476214335011)
,p_parent_id=>wwv_flow_imp.id(45432327870093655)
,p_short_name=>'Import REST Catalog'
,p_link=>'f?p=&APP_ID.:1966:&APP_SESSION.::&DEBUG.:::'
,p_page_id=>1966
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4522303667073067)
,p_parent_id=>wwv_flow_imp.id(177829529391401676)
,p_short_name=>'Dynamic Action Utilities'
,p_link=>'f?p=&APP_ID.:699:&SESSION.::&DEBUG.:::'
,p_page_id=>699
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4523532407080682)
,p_short_name=>'Copy Dynamic Action'
,p_link=>'f?p=&FLOW_ID.:728:&SESSION.'
,p_page_id=>728
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4700862005838378)
,p_parent_id=>wwv_flow_imp.id(225892393724191781)
,p_short_name=>'Synchronization'
,p_link=>'f?p=&APP_ID.:1951:&SESSION.::&DEBUG.:::'
,p_page_id=>1951
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4788028610457659)
,p_parent_id=>wwv_flow_imp.id(22464532161251314)
,p_short_name=>'Script Editor'
,p_link=>'f?p=&APP_ID.:865:&SESSION.::&DEBUG.:::'
,p_page_id=>865
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4789520415461435)
,p_parent_id=>wwv_flow_imp.id(799613605926722)
,p_short_name=>'Create Script'
,p_link=>'f?p=&FLOW_ID.:850:&SESSION.'
,p_page_id=>850
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4791400358470727)
,p_parent_id=>wwv_flow_imp.id(799613605926722)
,p_short_name=>'Create Script'
,p_link=>'f?p=&FLOW_ID.:855:&SESSION.'
,p_page_id=>855
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(4794822343475771)
,p_parent_id=>wwv_flow_imp.id(799613605926722)
,p_short_name=>'Create Script'
,p_link=>'f?p=&FLOW_ID.:857:&SESSION.'
,p_page_id=>857
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(5001582690003326)
,p_parent_id=>wwv_flow_imp.id(2549660762513182)
,p_short_name=>'History'
,p_link=>'f?p=&APP_ID.:7027:&SESSION.::&DEBUG.:::'
,p_page_id=>7027
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(5036226387452384)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Component Groups'
,p_link=>'f?p=&APP_ID.:6200:&APP_SESSION.::&DEBUG.:::'
,p_page_id=>6200
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(5052423135636793)
,p_parent_id=>wwv_flow_imp.id(5036226387452384)
,p_short_name=>'Component Group Details'
,p_link=>'f?p=&APP_ID.:6201:&SESSION.::&DEBUG.:::'
,p_page_id=>6201
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(5443523467188014)
,p_parent_id=>wwv_flow_imp.id(6342315964532655)
,p_short_name=>'Create Page'
,p_link=>'f?p=&FLOW_ID.:4716:&SESSION.'
,p_page_id=>4716
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(5642582838019749)
,p_parent_id=>wwv_flow_imp.id(1308911481947279)
,p_short_name=>'Export'
,p_link=>'f?p=&APP_ID.:688:&SESSION.::&DEBUG.:::'
,p_page_id=>688
,p_display_when_cond_type=>'ITEM_IS_NULL'
,p_display_when_condition=>'FB_FLOW_ID'
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(5643111092048922)
,p_parent_id=>wwv_flow_imp.id(1308911481947279)
,p_short_name=>'Export'
,p_link=>'f?p=&APP_ID.:224:&SESSION.::&DEBUG.:::'
,p_page_id=>224
,p_display_when_cond_type=>'ITEM_IS_NULL'
,p_display_when_condition=>'FB_FLOW_ID'
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(5643649990059315)
,p_parent_id=>wwv_flow_imp.id(1308911481947279)
,p_short_name=>'Export'
,p_link=>'f?p=&APP_ID.:4460:&SESSION.::&DEBUG.:::'
,p_page_id=>4460
,p_display_when_cond_type=>'ITEM_IS_NULL'
,p_display_when_condition=>'FB_FLOW_ID'
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6069927502983470)
,p_parent_id=>wwv_flow_imp.id(6349507415570925)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:186:&SESSION.::&DEBUG.:::'
,p_page_id=>186
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6342315964532655)
,p_parent_id=>wwv_flow_imp.id(1308911481947279)
,p_short_name=>'&BREADCRUMB_APP_ICON. Application &FB_FLOW_ID.'
,p_link=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:RP:FB_FLOW_ID,F4000_P1_FLOW:&FB_FLOW_ID.,&FB_FLOW_ID.'
,p_page_id=>1
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6346400957558726)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Regions'
,p_link=>'f?p=&APP_ID.:4650:&SESSION.::&DEBUG.:::'
,p_page_id=>4650
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6348417766566072)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Templates'
,p_link=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.:::'
,p_page_id=>4003
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6349507415570925)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Authorization Schemes'
,p_link=>'f?p=&APP_ID.:4070:&SESSION.::&DEBUG.:::'
,p_page_id=>4070
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6350702023573393)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Web Service References'
,p_link=>'f?p=&FLOW_ID.:170:&SESSION.::&DEBUG.:::'
,p_page_id=>170
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6351829184575999)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Shortcuts'
,p_link=>'f?p=&FLOW_ID.:4047:&SESSION.::&DEBUG.:::'
,p_page_id=>4047
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6355112362583811)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Trees'
,p_link=>'f?p=&FLOW_ID.:28:&SESSION.::&DEBUG.:::'
,p_page_id=>28
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6356205677586897)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Lists of Values'
,p_link=>'f?p=&FLOW_ID.:4110:&SESSION.::&DEBUG.:::'
,p_page_id=>4110
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6357300501589343)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Tabs'
,p_link=>'f?p=&APP_ID.:9000:&SESSION.::&DEBUG.:::'
,p_page_id=>9000
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6358428525591525)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Classic Navigation Bar Entries'
,p_link=>'f?p=&APP_ID.:4005:&SESSION.::&DEBUG.:::'
,p_page_id=>4005
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6359523564593791)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Application Computations'
,p_link=>'f?p=&APP_ID.:4101:&SESSION.::&DEBUG.:::'
,p_page_id=>4101
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6360618820595993)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Application Items'
,p_link=>'f?p=&APP_ID.:4100:&SESSION.::&DEBUG.:::'
,p_page_id=>4100
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6361712997598750)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Application Processes'
,p_link=>'f?p=&APP_ID.:4207:&SESSION.::&DEBUG.:::'
,p_page_id=>4207
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6386406453692928)
,p_parent_id=>wwv_flow_imp.id(6357300501589343)
,p_short_name=>'Edit Parent Tab'
,p_link=>'f?p=&FLOW_ID.:4318:&SESSION.'
,p_page_id=>4318
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6395029707727734)
,p_parent_id=>wwv_flow_imp.id(6356205677586897)
,p_short_name=>'Edit'
,p_link=>'f?p=&APP_ID.:4111:&SESSION.::&DEBUG.:::'
,p_page_id=>4111
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6396317415733372)
,p_parent_id=>wwv_flow_imp.id(6395029707727734)
,p_short_name=>'Entry'
,p_link=>'f?p=&APP_ID.:4113:&SESSION.::&DEBUG.:::'
,p_page_id=>4113
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6399720422747215)
,p_short_name=>'Create Item'
,p_link=>'f?p=&APP_ID.:4721:&SESSION.::&DEBUG.:::'
,p_page_id=>4721
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6401513642581053)
,p_parent_id=>wwv_flow_imp.id(6795302837254265)
,p_short_name=>'Change List'
,p_long_name=>'Change List'
,p_link=>'f?p=&APP_ID.:4053:&SESSION.::&DEBUG.:::'
,p_page_id=>4053
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6403032486756853)
,p_parent_id=>wwv_flow_imp.id(1308911481947279)
,p_short_name=>'Create Application'
,p_link=>'f?p=&APP_ID.:56:&SESSION.::&DEBUG.:::'
,p_page_id=>56
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6419208930828506)
,p_parent_id=>wwv_flow_imp.id(492636106117616338)
,p_short_name=>'Grid Edit of all Pages'
,p_link=>'f?p=&APP_ID.:243:&SESSION.::&DEBUG.:::'
,p_page_id=>243
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6422722720837321)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Replace Templates'
,p_link=>'f?p=&FLOW_ID.:220:&SESSION.'
,p_page_id=>220
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6423910643842876)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Replace Templates'
,p_link=>'f?p=&APP_ID.:222:&SESSION.::&DEBUG.:::'
,p_page_id=>222
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6424804389845860)
,p_short_name=>'Create Breadcrumb Region'
,p_link=>'f?p=&APP_ID.:263:&SESSION.::&DEBUG.:::'
,p_page_id=>263
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6425831765848304)
,p_short_name=>'Create Breadcrumb Region'
,p_link=>'f?p=&APP_ID.:264:&SESSION.::&DEBUG.:::'
,p_page_id=>264
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6426726589850683)
,p_short_name=>'Create Breadcrumb Region'
,p_link=>'f?p=&APP_ID.:286:&SESSION.::&DEBUG.:::'
,p_page_id=>286
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6431810187873541)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Buttons'
,p_link=>'f?p=&FLOW_ID.:4203:&SESSION.'
,p_page_id=>4203
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6432905873875539)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Page Items'
,p_link=>'f?p=&FLOW_ID.:4200:&SESSION.'
,p_page_id=>4200
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6434032172878572)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Computations'
,p_link=>'f?p=&APP_ID.:4204:&SESSION.::&DEBUG.:::'
,p_page_id=>4204
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6437409527889066)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Validations'
,p_link=>'f?p=&APP_ID.:4205:&SESSION.::&DEBUG.:::'
,p_page_id=>4205
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6438900038893444)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Page Processes'
,p_link=>'f?p=&FLOW_ID.:4201:&SESSION.'
,p_page_id=>4201
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6440026552896363)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Branches'
,p_link=>'f?p=&FLOW_ID.:4202:&SESSION.::&DEBUG.:::'
,p_page_id=>4202
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6441213828902170)
,p_parent_id=>wwv_flow_imp.id(6358428525591525)
,p_short_name=>'Edit'
,p_link=>'f?p=&APP_ID.:4308:&SESSION.::&DEBUG.:::'
,p_page_id=>4308
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6443000457908410)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Grid Edit'
,p_link=>'f?p=&APP_ID.:153:&SESSION.::&DEBUG.:::'
,p_page_id=>153
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6448120058929726)
,p_parent_id=>wwv_flow_imp.id(6351829184575999)
,p_short_name=>'Edit'
,p_link=>'f?p=&APP_ID.:4048:&SESSION.::&DEBUG.:::'
,p_page_id=>4048
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6449609059934771)
,p_parent_id=>wwv_flow_imp.id(6350702023573393)
,p_short_name=>'Edit'
,p_link=>'f?p=&APP_ID.:196:&SESSION.::&DEBUG.:::'
,p_page_id=>196
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6450831044939823)
,p_parent_id=>wwv_flow_imp.id(6361712997598750)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:147:&SESSION.::&DEBUG.:::'
,p_page_id=>147
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6452120045944932)
,p_parent_id=>wwv_flow_imp.id(6360618820595993)
,p_short_name=>'Create / Edit'
,p_link=>'f?p=&APP_ID.:4303:&SESSION.::&DEBUG.:::'
,p_page_id=>4303
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6453707968950476)
,p_parent_id=>wwv_flow_imp.id(6359523564593791)
,p_short_name=>'Create / Edit'
,p_link=>'f?p=&APP_ID.:4304:&SESSION.::&DEBUG.:::'
,p_page_id=>4304
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6456718523960790)
,p_parent_id=>wwv_flow_imp.id(6358428525591525)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:22:&SESSION.::&DEBUG.:::'
,p_page_id=>22
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6458403858967582)
,p_short_name=>'Create Form on Table'
,p_link=>'f?p=&APP_ID.:4708:&SESSION.::&DEBUG.:::'
,p_page_id=>4708
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6462116139977149)
,p_short_name=>'&P4703_PAGE_TITLE.'
,p_link=>'f?p=&APP_ID.:4703:&SESSION.::&DEBUG.:::'
,p_page_id=>4703
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6464801042984164)
,p_parent_id=>wwv_flow_imp.id(193869708580501594)
,p_short_name=>'SQL Query Region Source'
,p_link=>'f?p=&APP_ID.:247:&SESSION.::&DEBUG.:::'
,p_page_id=>247
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6467323027989165)
,p_short_name=>'Summary Page'
,p_link=>'f?p=&FLOW_ID.:5100:&SESSION.::&DEBUG.:::'
,p_page_id=>5100
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6472201246999222)
,p_short_name=>'Calendar'
,p_link=>'f?p=&FLOW_ID.:4785:&SESSION.::&DEBUG.:::'
,p_page_id=>4785
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6476306193012140)
,p_parent_id=>wwv_flow_imp.id(6349507415570925)
,p_short_name=>'Edit'
,p_link=>'f?p=&APP_ID.:4008:&SESSION.::&DEBUG.:::'
,p_page_id=>4008
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6478220630020590)
,p_parent_id=>wwv_flow_imp.id(6342315964532655)
,p_short_name=>'Edit Application Definition'
,p_link=>'f?p=&APP_ID.:4001:&SESSION.::&DEBUG.:::'
,p_page_id=>4001
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6479907044026887)
,p_parent_id=>wwv_flow_imp.id(6342315964532655)
,p_short_name=>'Export'
,p_link=>'f?p=&APP_ID.:4900:&SESSION.::&DEBUG.:::'
,p_page_id=>4900
,p_display_when_cond_type=>'ITEM_IS_NOT_NULL'
,p_display_when_condition=>'FB_FLOW_ID'
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6481002299029073)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Translate'
,p_link=>'f?p=&APP_ID.:4761:&SESSION.::&DEBUG.:::'
,p_page_id=>4761
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6482129244031803)
,p_parent_id=>wwv_flow_imp.id(6481002299029073)
,p_short_name=>'Text Messages'
,p_link=>'f?p=&APP_ID.:4006:&SESSION.::&DEBUG.:::'
,p_page_id=>4006
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6483519971036105)
,p_parent_id=>wwv_flow_imp.id(6482129244031803)
,p_short_name=>'Create / Edit'
,p_link=>'f?p=&APP_ID.:4009:&SESSION.::&DEBUG.:::'
,p_page_id=>4009
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6490322331050183)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Static Application Files'
,p_link=>'f?p=&APP_ID.:40:&SESSION.::&DEBUG.::FB_FLOW_ID:&FB_FLOW_ID.'
,p_page_id=>40
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6491917155052610)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Build Options'
,p_link=>'f?p=&APP_ID.:4910:&SESSION.::&DEBUG.:::'
,p_page_id=>4910
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6495901843059687)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Edit Page Template'
,p_link=>'f?p=&FLOW_ID.:4307:&SESSION.'
,p_page_id=>4307
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6499020162066439)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Edit Region Template'
,p_link=>'f?p=&FLOW_ID.:4653:&SESSION.'
,p_page_id=>4653
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6504200753075396)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Edit Report Template'
,p_link=>'f?p=&FLOW_ID.:258:&SESSION.'
,p_page_id=>258
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6506517346082898)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Edit List Template'
,p_link=>'f?p=&FLOW_ID.:4655:&SESSION.'
,p_page_id=>4655
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6515503938134714)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Lists of Values, Edit Null Text'
,p_link=>'f?p=&APP_ID.:169:&SESSION.::&DEBUG.:::'
,p_page_id=>169
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6527917703173888)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Edit Popup List of Values Template'
,p_link=>'f?p=&APP_ID.:251:&SESSION.::&DEBUG.:::'
,p_page_id=>251
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6529805411179605)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Edit Button Template'
,p_link=>'f?p=&FLOW_ID.:204:&SESSION.'
,p_page_id=>204
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6532523945186178)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Edit Item Template'
,p_link=>'f?p=&APP_ID.:85:&SESSION.::&DEBUG.:::'
,p_page_id=>85
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6534205183194898)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Edit Report Template'
,p_link=>'f?p=&FLOW_ID.:4654:&SESSION.'
,p_page_id=>4654
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6537319404203528)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Page Template Preview'
,p_link=>'f?p=&FLOW_ID.:4029:&SESSION.'
,p_page_id=>4029
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6550329946228991)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Template Utilization'
,p_link=>'f?p=&APP_ID.:4656:&SESSION.::&DEBUG.:::'
,p_page_id=>4656
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6551625202231243)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Template Subscription'
,p_link=>'f?p=&APP_ID.:124:&SESSION.::&DEBUG.:::'
,p_page_id=>124
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6554908596238944)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Tab Utilization'
,p_link=>'f?p=&APP_ID.:200:&SESSION.::&DEBUG.:::'
,p_page_id=>200
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6556700185242813)
,p_parent_id=>wwv_flow_imp.id(6357300501589343)
,p_short_name=>'Edit Tab Set by Page'
,p_link=>'f?p=&APP_ID.:77:&SESSION.::&DEBUG.:::'
,p_page_id=>77
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6558424327246804)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Edit Standard Tabs'
,p_link=>'f?p=&APP_ID.:123:&SESSION.::&DEBUG.:::'
,p_page_id=>123
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6562100389257933)
,p_parent_id=>wwv_flow_imp.id(450480426634467558)
,p_short_name=>'Edit Standard Tab'
,p_link=>'f?p=&APP_ID.:4305:&SESSION.::&DEBUG.:::'
,p_page_id=>4305
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6567501873287658)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:901:&SESSION.::&DEBUG.:::'
,p_page_id=>901
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6579019533309819)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create Page Template'
,p_link=>'f?p=&FLOW_ID.:920:&SESSION.'
,p_page_id=>920
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6580511985313322)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create Report Template'
,p_link=>'f?p=&FLOW_ID.:951:&SESSION.'
,p_page_id=>951
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6581706809315674)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create List Template'
,p_link=>'f?p=&FLOW_ID.:931:&SESSION.'
,p_page_id=>931
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6583001202318295)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create Label Template'
,p_link=>'f?p=&FLOW_ID.:941:&SESSION.'
,p_page_id=>941
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6584223618323157)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create Breadcrumb Template'
,p_link=>'f?p=&APP_ID.:238:&SESSION.::&DEBUG.:::'
,p_page_id=>238
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6594228985351058)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'List Utilization'
,p_link=>'f?p=&APP_ID.:156:&SESSION.::&DEBUG.:::'
,p_page_id=>156
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6603923150368917)
,p_parent_id=>wwv_flow_imp.id(6355112362583811)
,p_short_name=>'Edit'
,p_link=>'f?p=&APP_ID.:27:&SESSION.::&DEBUG.:::'
,p_page_id=>27
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6617305441407485)
,p_parent_id=>wwv_flow_imp.id(6357300501589343)
,p_short_name=>'Create Standard Tab'
,p_link=>'f?p=&FLOW_ID.:90:&SESSION.'
,p_page_id=>90
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6618930661411032)
,p_parent_id=>wwv_flow_imp.id(6357300501589343)
,p_short_name=>'Create Parent Tab'
,p_link=>'f?p=&FLOW_ID.:4725:&SESSION.'
,p_page_id=>4725
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6626722681414758)
,p_parent_id=>wwv_flow_imp.id(6481002299029073)
,p_short_name=>'XLIFF Export'
,p_link=>'f?p=&FLOW_ID.:4750:&SESSION.'
,p_page_id=>4750
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6629708879421074)
,p_parent_id=>wwv_flow_imp.id(6481002299029073)
,p_short_name=>'Language Mappings'
,p_link=>'f?p=&APP_ID.:4751:&SESSION.::&DEBUG.:::'
,p_page_id=>4751
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6632530217426427)
,p_parent_id=>wwv_flow_imp.id(6481002299029073)
,p_short_name=>'Dynamic Translations'
,p_link=>'f?p=&FLOW_ID.:4756:&SESSION.'
,p_page_id=>4756
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6656111405495930)
,p_parent_id=>wwv_flow_imp.id(6491917155052610)
,p_short_name=>'Create / Edit'
,p_link=>'f?p=&APP_ID.:4911:&SESSION.::&DEBUG.:::'
,p_page_id=>4911
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6658800838500771)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Build Option Utilization'
,p_link=>'f?p=&APP_ID.:203:&SESSION.::&DEBUG.:::'
,p_page_id=>203
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6661610099511746)
,p_parent_id=>wwv_flow_imp.id(1308911481947279)
,p_short_name=>'Export Repository'
,p_link=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.:::'
,p_page_id=>73
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6662704276514381)
,p_parent_id=>wwv_flow_imp.id(1308911481947279)
,p_short_name=>'Export'
,p_link=>'f?p=&APP_ID.:76:&SESSION.::&DEBUG.:::'
,p_page_id=>76
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6683703949651360)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Confirm Publish Component'
,p_link=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.:::'
,p_page_id=>149
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6715210092785244)
,p_parent_id=>wwv_flow_imp.id(6342315964532655)
,p_short_name=>'Confirm Delete'
,p_link=>'f?p=&FLOW_ID.:20:&SESSION.'
,p_page_id=>20
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6735531807989290)
,p_parent_id=>wwv_flow_imp.id(6342315964532655)
,p_short_name=>'Shared Components'
,p_link=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.:::'
,p_page_id=>9
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6795302837254265)
,p_parent_id=>wwv_flow_imp.id(16773830395421252)
,p_short_name=>'List Details'
,p_link=>'f?p=&APP_ID.:4050:&SESSION.::&DEBUG.:::'
,p_page_id=>4050
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6911427546266971)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:4320:&SESSION.::&DEBUG.:::'
,p_page_id=>4320
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(6914203177278186)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create Page Template'
,p_link=>'f?p=&FLOW_ID.:144:&SESSION.'
,p_page_id=>144
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7002213940754247)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Authentication Schemes'
,p_link=>'f?p=&APP_ID.:801:&SESSION.::&DEBUG.:::'
,p_page_id=>801
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7010702360813269)
,p_parent_id=>wwv_flow_imp.id(7002213940754247)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:816:&SESSION.::&DEBUG.:::'
,p_page_id=>816
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7011929736815673)
,p_parent_id=>wwv_flow_imp.id(7002213940754247)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:815:&SESSION.::&DEBUG.:::'
,p_page_id=>815
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7037014806883404)
,p_parent_id=>wwv_flow_imp.id(7002213940754247)
,p_short_name=>'Create / Edit'
,p_link=>'f?p=&APP_ID.:4495:&SESSION.::&DEBUG.:::'
,p_page_id=>4495
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7044908059962472)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Navigation Bar Entry Subscription'
,p_link=>'f?p=&APP_ID.:54:&SESSION.::&DEBUG.:::'
,p_page_id=>54
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7080421195245074)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create Report Template'
,p_link=>'f?p=&FLOW_ID.:4321:&SESSION.'
,p_page_id=>4321
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7081514725248136)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create Report Template'
,p_link=>'f?p=&FLOW_ID.:168:&SESSION.'
,p_page_id=>168
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7152101514588506)
,p_parent_id=>wwv_flow_imp.id(6357300501589343)
,p_short_name=>'Create Parent Tab'
,p_link=>'f?p=&FLOW_ID.:4726:&SESSION.::&DEBUG.:::'
,p_page_id=>4726
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7154823930593293)
,p_parent_id=>wwv_flow_imp.id(6357300501589343)
,p_short_name=>'Create Parent Tab'
,p_link=>'f?p=&FLOW_ID.:4727:&SESSION.::&DEBUG.:::'
,p_page_id=>4727
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7161412703613679)
,p_parent_id=>wwv_flow_imp.id(6357300501589343)
,p_short_name=>'Create Standard Tab'
,p_link=>'f?p=&FLOW_ID.:96:&SESSION.::&DEBUG.:::'
,p_page_id=>96
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7163206881616420)
,p_parent_id=>wwv_flow_imp.id(6357300501589343)
,p_short_name=>'Create Standard Tab'
,p_link=>'f?p=&FLOW_ID.:4722:&SESSION.::&DEBUG.:::'
,p_page_id=>4722
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7164601489618915)
,p_parent_id=>wwv_flow_imp.id(6357300501589343)
,p_short_name=>'Create Standard Tab'
,p_link=>'f?p=&FLOW_ID.:4723:&SESSION.::&DEBUG.:::'
,p_page_id=>4723
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7166328003621815)
,p_parent_id=>wwv_flow_imp.id(6357300501589343)
,p_short_name=>'Create Standard Tab'
,p_link=>'f?p=&FLOW_ID.:4724:&SESSION.::&DEBUG.:::'
,p_page_id=>4724
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7168518514626247)
,p_parent_id=>wwv_flow_imp.id(6357300501589343)
,p_short_name=>'Create Standard Tab'
,p_link=>'f?p=&APP_ID.:92:&SESSION.::&DEBUG.:::'
,p_page_id=>92
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7178316764657376)
,p_parent_id=>wwv_flow_imp.id(83259325931667653)
,p_short_name=>'Seed Item Help'
,p_link=>'f?p=&APP_ID.:13:&SESSION.::&DEBUG.:::'
,p_page_id=>13
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7191825797683623)
,p_short_name=>'&P4703_PAGE_TITLE.'
,p_link=>'f?p=&APP_ID.:4775:&SESSION.::&DEBUG.:::'
,p_page_id=>4775
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7193221268685688)
,p_short_name=>'Form and Report'
,p_link=>'f?p=&APP_ID.:4778:&SESSION.::&DEBUG.:::'
,p_page_id=>4778
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7195514798688693)
,p_short_name=>'&P4703_PAGE_TITLE.'
,p_link=>'f?p=&APP_ID.:4039:&SESSION.::&DEBUG.:::'
,p_page_id=>4039
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7199632470695744)
,p_short_name=>'&P4703_PAGE_TITLE.'
,p_link=>'f?p=&APP_ID.:4776:&SESSION.::&DEBUG.:::'
,p_page_id=>4776
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7201126431698544)
,p_short_name=>'&P4703_PAGE_TITLE.'
,p_link=>'f?p=&APP_ID.:4777:&SESSION.::&DEBUG.:::'
,p_page_id=>4777
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7202421040701003)
,p_short_name=>'&P4703_PAGE_TITLE.'
,p_link=>'f?p=&APP_ID.:4783:&SESSION.::&DEBUG.:::'
,p_page_id=>4783
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7204213923704318)
,p_short_name=>'&P4703_PAGE_TITLE.'
,p_link=>'f?p=&APP_ID.:296:&SESSION.::&DEBUG.:::'
,p_page_id=>296
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7328881720192438)
,p_parent_id=>wwv_flow_imp.id(1482681391903408)
,p_short_name=>'Utilization'
,p_link=>'f?p=&APP_ID.:3121:&SESSION.::&DEBUG.:RP::'
,p_page_id=>3121
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7336605867256348)
,p_parent_id=>wwv_flow_imp.id(1482681391903408)
,p_short_name=>'History'
,p_link=>'f?p=&APP_ID.:3122:&SESSION.::&DEBUG.:RP::'
,p_page_id=>3122
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7344218375857109)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Breadcrumb Utilization'
,p_link=>'f?p=&APP_ID.:365:&SESSION.::&DEBUG.:::'
,p_page_id=>365
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7353730606927328)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Copy Region'
,p_link=>'f?p=&FLOW_ID.:195:&SESSION.::&DEBUG.:::'
,p_page_id=>195
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7354622842930948)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Copy Region'
,p_link=>'f?p=&FLOW_ID.:194:&SESSION.::&DEBUG.:::'
,p_page_id=>194
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7356901276940875)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Copy Item'
,p_link=>'f?p=&APP_ID.:171:&SESSION.::&DEBUG.:::'
,p_page_id=>171
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7358027359944057)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Copy Item'
,p_link=>'f?p=&APP_ID.:172:&SESSION.::&DEBUG.:::'
,p_page_id=>172
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7408431450215623)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Copy Button'
,p_link=>'f?p=&FLOW_ID.:231:&SESSION.::&DEBUG.:::'
,p_page_id=>231
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7409526921217764)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Copy Button'
,p_link=>'f?p=&FLOW_ID.:191:&SESSION.::&DEBUG.:::'
,p_page_id=>191
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7415405761257899)
,p_short_name=>'Create Form on Table'
,p_link=>'f?p=&APP_ID.:4713:&SESSION.::&DEBUG.:::'
,p_page_id=>4713
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7416532275260839)
,p_short_name=>'Create Form on Table'
,p_link=>'f?p=&APP_ID.:4771:&SESSION.::&DEBUG.:::'
,p_page_id=>4771
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7418722570265291)
,p_short_name=>'Create Form on Table'
,p_link=>'f?p=&APP_ID.:4772:&SESSION.::&DEBUG.:::'
,p_page_id=>4772
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7419816963267952)
,p_short_name=>'Create Form on Table'
,p_link=>'f?p=&APP_ID.:4773:&SESSION.::&DEBUG.:::'
,p_page_id=>4773
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7420910493270877)
,p_short_name=>'Create Form on Table'
,p_link=>'f?p=&APP_ID.:255:&SESSION.::&DEBUG.:::'
,p_page_id=>255
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7432727672354081)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Template History'
,p_link=>'f?p=&APP_ID.:368:&SESSION.::&DEBUG.:::'
,p_page_id=>368
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7451619366494706)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Breadcrumb History'
,p_link=>'f?p=&APP_ID.:369:&SESSION.::&DEBUG.:::'
,p_page_id=>369
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7471411863672817)
,p_parent_id=>wwv_flow_imp.id(193869708580501594)
,p_short_name=>'Region Attributes'
,p_link=>'f?p=&APP_ID.:249:&SESSION.::&DEBUG.:::'
,p_page_id=>249
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7472506903675102)
,p_parent_id=>wwv_flow_imp.id(193782110098056426)
,p_short_name=>'Edit Buttons Labels'
,p_link=>'f?p=&APP_ID.:250:&SESSION.::&DEBUG.:::'
,p_page_id=>250
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7478909047689311)
,p_short_name=>'Create Form on Procedure'
,p_link=>'f?p=&APP_ID.:4705:&SESSION.::&DEBUG.:::'
,p_page_id=>4705
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7491427569711076)
,p_short_name=>'Form on Query'
,p_link=>'f?p=&APP_ID.:4811:&SESSION.::&DEBUG.:::'
,p_page_id=>4811
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7493719590714867)
,p_short_name=>'Form on Query'
,p_link=>'f?p=&APP_ID.:4812:&SESSION.::&DEBUG.:::'
,p_page_id=>4812
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7496910317719139)
,p_short_name=>'Form on Query'
,p_link=>'f?p=&APP_ID.:272:&SESSION.::&DEBUG.:::'
,p_page_id=>272
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7499828635725844)
,p_short_name=>'Summary Page'
,p_link=>'f?p=&FLOW_ID.:5105:&SESSION.::&DEBUG.:::'
,p_page_id=>5105
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7501423244728309)
,p_short_name=>'Summary Page'
,p_link=>'f?p=&FLOW_ID.:5110:&SESSION.::&DEBUG.:::'
,p_page_id=>5110
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7503017637730875)
,p_short_name=>'Summary Page'
,p_link=>'f?p=&FLOW_ID.:303:&SESSION.::&DEBUG.:::'
,p_page_id=>303
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7520013730763123)
,p_short_name=>'Calendar'
,p_link=>'f?p=&FLOW_ID.:4790:&SESSION.::&DEBUG.:::'
,p_page_id=>4790
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7521309417765117)
,p_short_name=>'Calendar'
,p_link=>'f?p=&FLOW_ID.:4791:&SESSION.::&DEBUG.:::'
,p_page_id=>4791
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7530906817781560)
,p_short_name=>'Calendar'
,p_link=>'f?p=&FLOW_ID.:281:&SESSION.::&DEBUG.:::'
,p_page_id=>281
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7664420265391505)
,p_parent_id=>wwv_flow_imp.id(221168815878138814)
,p_short_name=>'Create / Edit'
,p_link=>'f?p=&APP_ID.:288:&SESSION.::&DEBUG.:::'
,p_page_id=>288
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7665912286395269)
,p_parent_id=>wwv_flow_imp.id(6351829184575999)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:131:&SESSION.::&DEBUG.:::'
,p_page_id=>131
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7667003659399234)
,p_parent_id=>wwv_flow_imp.id(6351829184575999)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:174:&SESSION.::&DEBUG.:::'
,p_page_id=>174
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7832105639591954)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'History'
,p_link=>'f?p=&APP_ID.:201:&SESSION.::&DEBUG.:::'
,p_page_id=>201
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7914701005989088)
,p_parent_id=>wwv_flow_imp.id(6356205677586897)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:137:&SESSION.::&DEBUG.:::'
,p_page_id=>137
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7915827303992094)
,p_parent_id=>wwv_flow_imp.id(6356205677586897)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:4004:&SESSION.::&DEBUG.:::'
,p_page_id=>4004
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7916921696994671)
,p_parent_id=>wwv_flow_imp.id(6356205677586897)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:4014:&SESSION.::&DEBUG.:::'
,p_page_id=>4014
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7919430957005615)
,p_parent_id=>wwv_flow_imp.id(6358428525591525)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:4023:&SESSION.::&DEBUG.:::'
,p_page_id=>4023
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7920525781008029)
,p_parent_id=>wwv_flow_imp.id(6358428525591525)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:4024:&SESSION.::&DEBUG.:::'
,p_page_id=>4024
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7921621468010029)
,p_parent_id=>wwv_flow_imp.id(6358428525591525)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:4025:&SESSION.::&DEBUG.:::'
,p_page_id=>4025
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7923014567013198)
,p_parent_id=>wwv_flow_imp.id(6358428525591525)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:134:&SESSION.::&DEBUG.:::'
,p_page_id=>134
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(7924110469015106)
,p_parent_id=>wwv_flow_imp.id(6358428525591525)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:135:&SESSION.::&DEBUG.:::'
,p_page_id=>135
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(8075321485195951)
,p_parent_id=>wwv_flow_imp.id(6351829184575999)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:132:&SESSION.::&DEBUG.:::'
,p_page_id=>132
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(8077714369199249)
,p_parent_id=>wwv_flow_imp.id(6351829184575999)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:133:&SESSION.::&DEBUG.:::'
,p_page_id=>133
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(8079505311203450)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create Button Template'
,p_link=>'f?p=&FLOW_ID.:211:&SESSION.::&DEBUG.:::'
,p_page_id=>211
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(8083124924209514)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create Button Template'
,p_link=>'f?p=&FLOW_ID.:218:&SESSION.::&DEBUG.:::'
,p_page_id=>218
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(8084520395211660)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create Button Template'
,p_link=>'f?p=&FLOW_ID.:219:&SESSION.::&DEBUG.:::'
,p_page_id=>219
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(8086011121215923)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create Button Template'
,p_link=>'f?p=&FLOW_ID.:223:&SESSION.::&DEBUG.:::'
,p_page_id=>223
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(8106615841244156)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create List Template'
,p_link=>'f?p=&FLOW_ID.:4069:&SESSION.'
,p_page_id=>4069
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(8108013253245302)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create List Template'
,p_link=>'f?p=&FLOW_ID.:159:&SESSION.'
,p_page_id=>159
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(8118716260259107)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create Page Template'
,p_link=>'f?p=&FLOW_ID.:26:&SESSION.'
,p_page_id=>26
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(8128628109268771)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:158:&SESSION.::&DEBUG.:::'
,p_page_id=>158
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(8131420777272255)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create Report Template'
,p_link=>'f?p=&FLOW_ID.:955:&SESSION.'
,p_page_id=>955
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(8259502568660499)
,p_parent_id=>wwv_flow_imp.id(6629708879421074)
,p_short_name=>'Edit'
,p_link=>'f?p=&APP_ID.:4754:&SESSION.::&DEBUG.:::'
,p_page_id=>4754
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(8277523018696647)
,p_parent_id=>wwv_flow_imp.id(6632530217426427)
,p_short_name=>'Create/Edit Dynamic Translation'
,p_link=>'f?p=&APP_ID.:4757:&SESSION.::&DEBUG.:::'
,p_page_id=>4757
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(8303409826748280)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Tree Utilization'
,p_link=>'f?p=&APP_ID.:202:&SESSION.::&DEBUG.:::'
,p_page_id=>202
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(8602403040190431)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Authorization Scheme Utilization'
,p_link=>'f?p=&APP_ID.:340:&SESSION.::&DEBUG.:::'
,p_page_id=>340
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(8641230102314695)
,p_parent_id=>wwv_flow_imp.id(799613605926722)
,p_short_name=>'Supporting Object Messages'
,p_link=>'f?p=&APP_ID.:567:&SESSION.::&DEBUG.:::'
,p_page_id=>567
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(8711816389536515)
,p_short_name=>'Access Control'
,p_link=>'f?p=&APP_ID.:572:&SESSION.::&DEBUG.:::'
,p_page_id=>572
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(9594412395161749)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Caching'
,p_link=>'f?p=&APP_ID.:14:&SESSION.::&DEBUG.:::'
,p_page_id=>14
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(9744321690510681)
,p_parent_id=>wwv_flow_imp.id(7002213940754247)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:818:&SESSION.::&DEBUG.:::'
,p_page_id=>818
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(9766004998624840)
,p_parent_id=>wwv_flow_imp.id(6349507415570925)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:184:&SESSION.::&DEBUG.:::'
,p_page_id=>184
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(9767400685626788)
,p_parent_id=>wwv_flow_imp.id(6349507415570925)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:188:&SESSION.::&DEBUG.:::'
,p_page_id=>188
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(9769129787628491)
,p_parent_id=>wwv_flow_imp.id(6349507415570925)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:185:&SESSION.::&DEBUG.:::'
,p_page_id=>185
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(9966712969094387)
,p_parent_id=>wwv_flow_imp.id(799613605926722)
,p_short_name=>'Prerequisites'
,p_link=>'f?p=&APP_ID.:631:&SESSION.::&DEBUG.:::'
,p_page_id=>631
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(10077912702550901)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Navigation Bar Entry History'
,p_link=>'f?p=&APP_ID.:394:&SESSION.::&DEBUG.:::'
,p_page_id=>394
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(10171012622051760)
,p_parent_id=>wwv_flow_imp.id(799613605926722)
,p_short_name=>'Remove All Supporting Objects'
,p_link=>'f?p=&APP_ID.:632:&SESSION.::&DEBUG.:::'
,p_page_id=>632
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(10195213589188051)
,p_parent_id=>wwv_flow_imp.id(799613605926722)
,p_short_name=>'Export Status'
,p_link=>'f?p=&FLOW_ID.:633:&SESSION.'
,p_page_id=>633
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(10236303196165887)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Confirm Page Delete'
,p_link=>'f?p=&FLOW_ID.:21:&SESSION.'
,p_page_id=>21
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(10267803313287401)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Grid Edit Breadcrumbs'
,p_link=>'f?p=&APP_ID.:3:&SESSION.::&DEBUG.:::'
,p_page_id=>3
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(10536107887762771)
,p_short_name=>'Create Standard Tab'
,p_link=>'f?p=&FLOW_ID.:93:&SESSION.'
,p_page_id=>93
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(10538801849765550)
,p_parent_id=>wwv_flow_imp.id(6357300501589343)
,p_short_name=>'Create Standard Tab'
,p_link=>'f?p=&FLOW_ID.:94:&SESSION.::&DEBUG.:::'
,p_page_id=>94
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(10540331597766939)
,p_parent_id=>wwv_flow_imp.id(6357300501589343)
,p_short_name=>'Create Standard Tab'
,p_link=>'f?p=&FLOW_ID.:95:&SESSION.::&DEBUG.:::'
,p_page_id=>95
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(10597823088892387)
,p_parent_id=>wwv_flow_imp.id(6356205677586897)
,p_short_name=>'Create '
,p_link=>'f?p=&APP_ID.:138:&SESSION.::&DEBUG.:::'
,p_page_id=>138
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(10599019637894058)
,p_parent_id=>wwv_flow_imp.id(6356205677586897)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:139:&SESSION.::&DEBUG.:::'
,p_page_id=>139
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(10604820056908970)
,p_parent_id=>wwv_flow_imp.id(6361712997598750)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:148:&SESSION.::&DEBUG.:::'
,p_page_id=>148
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(10609306901915170)
,p_parent_id=>wwv_flow_imp.id(6361712997598750)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:150:&SESSION.::&DEBUG.:::'
,p_page_id=>150
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(10621115084926482)
,p_parent_id=>wwv_flow_imp.id(6661610099511746)
,p_short_name=>'Install Application'
,p_link=>'f?p=&APP_ID.:154:&SESSION.::&DEBUG.:::'
,p_page_id=>154
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(10645411621943305)
,p_parent_id=>wwv_flow_imp.id(1308911481947279)
,p_short_name=>'Import'
,p_link=>'f?p=&APP_ID.:163:&SESSION.::&DEBUG.:::'
,p_page_id=>163
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(10647309248944370)
,p_parent_id=>wwv_flow_imp.id(1308911481947279)
,p_short_name=>'Export'
,p_link=>'f?p=&APP_ID.:164:&SESSION.::&DEBUG.:::'
,p_page_id=>164
,p_display_when_cond_type=>'ITEM_IS_NULL'
,p_display_when_condition=>'FB_FLOW_ID'
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(10654722176953591)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Lists of Values Grid Edit'
,p_link=>'f?p=&APP_ID.:71:&SESSION.::&DEBUG.:::'
,p_page_id=>178
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(10681004612431355)
,p_parent_id=>wwv_flow_imp.id(16773830395421252)
,p_short_name=>'Create'
,p_link=>'f?p=&FLOW_ID.:464:&SESSION.'
,p_page_id=>464
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(10735320290151987)
,p_parent_id=>wwv_flow_imp.id(6350702023573393)
,p_short_name=>'Testing'
,p_link=>'f?p=&APP_ID.:226:&SESSION.::&DEBUG.:::'
,p_page_id=>226
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(10748931048177465)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create Breadcrumb Template'
,p_link=>'f?p=&APP_ID.:240:&SESSION.::&DEBUG.:::'
,p_page_id=>240
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(10750825657179959)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create Breadcrumb Template'
,p_link=>'f?p=&APP_ID.:241:&SESSION.::&DEBUG.:::'
,p_page_id=>241
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(10752121775181753)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create Breadcrumb Template'
,p_link=>'f?p=&APP_ID.:242:&SESSION.::&DEBUG.:::'
,p_page_id=>242
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(10768230808207960)
,p_short_name=>'Calendar'
,p_link=>'f?p=&APP_ID.:282:&SESSION.::&DEBUG.:::'
,p_page_id=>282
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(10770012383068687)
,p_parent_id=>wwv_flow_imp.id(3320654420728496)
,p_short_name=>'Remote Deployment Successful'
,p_link=>'f?p=&APP_ID.:4907:&SESSION.'
,p_page_id=>4907
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(10985516388385355)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Shortcut History'
,p_link=>'f?p=&APP_ID.:41:&SESSION.::&DEBUG.:::'
,p_page_id=>41
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(10993710960433463)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Application Process History'
,p_link=>'f?p=&APP_ID.:42:&SESSION.::&DEBUG.:::'
,p_page_id=>42
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11011406560541853)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Application Computation History'
,p_link=>'f?p=&APP_ID.:43:&SESSION.::&DEBUG.:::'
,p_page_id=>43
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11020231921636428)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'List History'
,p_link=>'f?p=&APP_ID.:44:&SESSION.::&DEBUG.:::'
,p_page_id=>44
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11041108796707910)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Tree History'
,p_link=>'f?p=&APP_ID.:45:&SESSION.::&DEBUG.:::'
,p_page_id=>45
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11160403095007768)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Tab History'
,p_link=>'f?p=&APP_ID.:58:&SESSION.::&DEBUG.:::'
,p_page_id=>58
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11228126661984416)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Region History'
,p_link=>'f?p=&APP_ID.:60:&SESSION.::&DEBUG.:::'
,p_page_id=>60
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11254230851134407)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Button History'
,p_link=>'f?p=&APP_ID.:61:&SESSION.::&DEBUG.:::'
,p_page_id=>61
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11268606598267240)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Page Item History'
,p_link=>'f?p=&APP_ID.:62:&SESSION.::&DEBUG.:::'
,p_page_id=>62
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11281004620313756)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Web Service Reference History'
,p_link=>'f?p=&APP_ID.:63:&SESSION.::&DEBUG.:::'
,p_page_id=>63
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11292413197370563)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Branch History'
,p_link=>'f?p=&APP_ID.:64:&SESSION.::&DEBUG.:::'
,p_page_id=>64
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11314228718673680)
,p_parent_id=>wwv_flow_imp.id(6342315964532655)
,p_short_name=>'Install Application'
,p_link=>'f?p=&APP_ID.:2103:&SESSION.::&DEBUG.:::'
,p_page_id=>2103
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11315821157692395)
,p_parent_id=>wwv_flow_imp.id(6342315964532655)
,p_short_name=>'Install Application'
,p_link=>'f?p=&APP_ID.:2102:&SESSION.::&DEBUG.:::'
,p_page_id=>2102
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11333517694709200)
,p_parent_id=>wwv_flow_imp.id(6342315964532655)
,p_short_name=>'Install Application'
,p_link=>'f?p=&APP_ID.:2105:&SESSION.::&DEBUG.:::'
,p_page_id=>2105
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11339503991557114)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Page Process History'
,p_link=>'f?p=&APP_ID.:65:&SESSION.::&DEBUG.:::'
,p_page_id=>65
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11342913252567976)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Validation History'
,p_link=>'f?p=&APP_ID.:66:&SESSION.::&DEBUG.:::'
,p_page_id=>66
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11429006112436881)
,p_parent_id=>wwv_flow_imp.id(16773830395421252)
,p_short_name=>'Create'
,p_link=>'f?p=&FLOW_ID.:734:&SESSION.'
,p_page_id=>734
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11539704173277683)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Report Queries'
,p_link=>'f?p=&APP_ID.:1100:&SESSION.::&DEBUG.:::'
,p_page_id=>1100
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(11654121930393742)
,p_parent_id=>wwv_flow_imp.id(855100382282348)
,p_short_name=>'Error'
,p_link=>'f?p=&FLOW_ID.:2115:&SESSION.'
,p_page_id=>2115
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(13557905417023023)
,p_parent_id=>wwv_flow_imp.id(6342315964532655)
,p_short_name=>'Install Application'
,p_link=>'f?p=&FLOW_ID.:2107:&SESSION.'
,p_page_id=>2107
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(13602017599154121)
,p_parent_id=>wwv_flow_imp.id(6342315964532655)
,p_short_name=>'Install Application'
,p_link=>'f?p=&FLOW_ID.:2101:&SESSION.'
,p_page_id=>2101
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(13769708611662541)
,p_parent_id=>wwv_flow_imp.id(11315821157692395)
,p_short_name=>'Error'
,p_link=>'f?p=&FLOW_ID.:2108:&SESSION.'
,p_page_id=>2108
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(13844100310061418)
,p_parent_id=>wwv_flow_imp.id(1308911481947279)
,p_short_name=>'Install Summary'
,p_link=>'f?p=&APP_ID.:2106:&SESSION.::&DEBUG.:::'
,p_page_id=>2106
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(13918029879549172)
,p_parent_id=>wwv_flow_imp.id(6342315964532655)
,p_short_name=>'Deinstall'
,p_link=>'f?p=&APP_ID.:2110:&SESSION.::&DEBUG.:::'
,p_page_id=>2110
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(13920032011578513)
,p_parent_id=>wwv_flow_imp.id(1308911481947279)
,p_short_name=>'Deinstall'
,p_link=>'f?p=&APP_ID.:2111:&SESSION.::&DEBUG.:::'
,p_page_id=>2111
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(14800472336097080)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Reparent Breadcrumb Entries'
,p_link=>'f?p=&APP_ID.:106:&SESSION.::&DEBUG.:::'
,p_page_id=>106
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(14890017142621948)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Component Settings'
,p_link=>'f?p=&APP_ID.:4445:&SESSION.::&DEBUG.:::'
,p_page_id=>4445
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(14923413480797232)
,p_parent_id=>wwv_flow_imp.id(14890017142621948)
,p_short_name=>'Edit'
,p_link=>'f?p=&APP_ID.:4446:&SESSION.'
,p_page_id=>4446
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(14971917454141291)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Component Settings History'
,p_link=>'f?p=&APP_ID.:4447:&SESSION.::&DEBUG.:::'
,p_page_id=>4447
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(15036126595436273)
,p_parent_id=>wwv_flow_imp.id(162360425664871103)
,p_short_name=>'Application Comparison'
,p_link=>'f?p=&APP_ID.:1300:&SESSION.::&DEBUG.:::'
,p_page_id=>1300
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(15135828644258802)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Data Load Definitions'
,p_link=>'f?p=&APP_ID.:1800:&SESSION.::&DEBUG.:::'
,p_page_id=>1800
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(15156017832458046)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Data Load Definition History'
,p_link=>'f?p=&APP_ID.:1808:&SESSION.::&DEBUG.:::'
,p_page_id=>1808
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(15591026729420129)
,p_parent_id=>wwv_flow_imp.id(193915914105228860)
,p_short_name=>'Password Items'
,p_link=>'f?p=&APP_ID.:59:&SESSION.::&DEBUG.:::'
,p_page_id=>59
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(15797702766949336)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Form on Web Service'
,p_link=>'f?p=&APP_ID.:600:&SESSION.::&DEBUG.:::'
,p_page_id=>600
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(15814118349953843)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Form on Web Service'
,p_link=>'f?p=&APP_ID.:605:&SESSION.::&DEBUG.:::'
,p_page_id=>605
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(15889514867947581)
,p_parent_id=>wwv_flow_imp.id(799613605926722)
,p_short_name=>'Build Options'
,p_link=>'f?p=&APP_ID.:511:&SESSION.::&DEBUG.:::'
,p_page_id=>511
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(15991000339058129)
,p_parent_id=>wwv_flow_imp.id(162360425664871103)
,p_short_name=>'Password Items'
,p_link=>'f?p=&FLOW_ID.:7777:&SESSION.'
,p_page_id=>7777
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(16358606741741103)
,p_parent_id=>wwv_flow_imp.id(6661610099511746)
,p_short_name=>'Install Page'
,p_link=>'f?p=&FLOW_ID.:67:&SESSION.::&DEBUG.:::'
,p_page_id=>67
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(16773830395421252)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Lists'
,p_link=>'f?p=&FLOW_ID.:405:&SESSION.::&DEBUG.:::'
,p_page_id=>405
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(16937906748551854)
,p_parent_id=>wwv_flow_imp.id(177829529391401676)
,p_short_name=>'Application Dashboard'
,p_link=>'f?p=&APP_ID.:71:&SESSION.::&DEBUG.:::'
,p_page_id=>71
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(17037523781612052)
,p_short_name=>'Data Loading'
,p_link=>'f?p=&APP_ID.:1704:&SESSION.::&DEBUG.:::'
,p_page_id=>1704
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(17191702841394320)
,p_parent_id=>wwv_flow_imp.id(162360425664871103)
,p_short_name=>'Application Comparison Counts'
,p_link=>'f?p=&APP_ID.:1301:&SESSION.::&DEBUG.:::'
,p_page_id=>1301
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(17287522385778639)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Edit Legacy Calendar Template'
,p_link=>'f?p=&APP_ID.:670:&SESSION.::&DEBUG.:::'
,p_page_id=>670
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(17460432491552675)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Computation History'
,p_link=>'f?p=&APP_ID.:152:&SESSION.::&DEBUG.:::'
,p_page_id=>152
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(17911903538190945)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Edit Legacy Calendar Template'
,p_link=>'f?p=&APP_ID.:661:&SESSION.::&DEBUG.:::'
,p_page_id=>661
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(17992125037245873)
,p_short_name=>'Calendar Attributes'
,p_long_name=>'Calendar Attributes'
,p_link=>'f?p=&APP_ID.:2000:&SESSION.::&DEBUG.:::'
,p_page_id=>2000
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(18285502523148221)
,p_parent_id=>wwv_flow_imp.id(193869708580501594)
,p_short_name=>'Customized Regions'
,p_link=>'f?p=&APP_ID.:70:&SESSION.::&DEBUG.:::'
,p_page_id=>70
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(18832229785461633)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Report Layouts'
,p_long_name=>'Report Layouts'
,p_link=>'f?p=&APP_ID.:1400:&SESSION.::&DEBUG.:::'
,p_page_id=>1400
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(19022319454443147)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Edit Legacy Calendar Template'
,p_link=>'f?p=&APP_ID.:122:&SESSION.::&DEBUG.:::'
,p_page_id=>122
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(19032123742471581)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create Legacy Calendar Template'
,p_link=>'f?p=&APP_ID.:161:&SESSION.::&DEBUG.:::'
,p_page_id=>161
,p_display_when_cond_type=>'CURRENT_PAGE_IN_CONDITION'
,p_display_when_condition=>'161'
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(19258329571249505)
,p_parent_id=>wwv_flow_imp.id(18832229785461633)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:1401:&SESSION.::&DEBUG.:::'
,p_page_id=>1401
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(19419401868575307)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:162:&SESSION.::&DEBUG.:::'
,p_page_id=>162
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(19894618913813791)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Copy Page'
,p_link=>'f?p=&FLOW_ID.:301:&SESSION.::&DEBUG.:::'
,p_page_id=>301
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(19896313737816242)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Copy Page'
,p_link=>'f?p=&FLOW_ID.:305:&SESSION.'
,p_page_id=>305
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(19937509097955070)
,p_short_name=>'Copy Page'
,p_link=>'f?p=&FLOW_ID.:308:&SESSION.'
,p_page_id=>308
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(19939204568957219)
,p_short_name=>'Copy Page'
,p_link=>'f?p=&FLOW_ID.:309:&SESSION.'
,p_page_id=>309
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(20043923532731419)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Region Slot Utilization'
,p_link=>'f?p=&FLOW_ID.:206:&SESSION.'
,p_page_id=>206
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(20647319360774865)
,p_parent_id=>wwv_flow_imp.id(1308911481947279)
,p_short_name=>'Create Application'
,p_link=>'f?p=&FLOW_ID.:3009:&SESSION.'
,p_page_id=>3009
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(22164400994144140)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Edit Legacy Calendar Template'
,p_link=>'f?p=&APP_ID.:697:&SESSION.::&DEBUG.:::'
,p_page_id=>697
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(22457404822203283)
,p_parent_id=>wwv_flow_imp.id(799613605926722)
,p_short_name=>'Validations'
,p_link=>'f?p=&APP_ID.:445:&SESSION.::&DEBUG.:::'
,p_page_id=>445
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(22464532161251314)
,p_parent_id=>wwv_flow_imp.id(799613605926722)
,p_short_name=>'Scripts'
,p_link=>'f?p=&APP_ID.:473:&SESSION.::&DEBUG.:::'
,p_page_id=>473
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(22494031119345991)
,p_parent_id=>wwv_flow_imp.id(6350702023573393)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:580:&SESSION.::&DEBUG.:::'
,p_page_id=>580
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(22494629499343773)
,p_parent_id=>wwv_flow_imp.id(799613605926722)
,p_short_name=>'Deinstall Script'
,p_link=>'f?p=&FLOW_ID.:576:&SESSION.'
,p_page_id=>576
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(22505427599590969)
,p_parent_id=>wwv_flow_imp.id(6350702023573393)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:585:&SESSION.::&DEBUG.:::'
,p_page_id=>585
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(22506626466040885)
,p_parent_id=>wwv_flow_imp.id(3803609664693374)
,p_short_name=>'Create File'
,p_link=>'f?p=&APP_ID.:118:&SESSION.::&DEBUG.:::'
,p_page_id=>118
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P118_SCOPE = ''THEME'' and :P118_ID is null'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(22572807015669847)
,p_parent_id=>wwv_flow_imp.id(11539704173277683)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:1110:&SESSION.::&DEBUG.:::'
,p_page_id=>1110
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(22655821130934008)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Form and Report on Web Service'
,p_link=>'f?p=&APP_ID.:716:&SESSION.::&DEBUG.:::'
,p_page_id=>716
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(22666606636975220)
,p_parent_id=>wwv_flow_imp.id(22464532161251314)
,p_short_name=>'Install Script'
,p_link=>'f?p=&FLOW_ID.:578:&SESSION.'
,p_page_id=>578
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(22673821761009565)
,p_parent_id=>wwv_flow_imp.id(18832229785461633)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:1402:&SESSION.::&DEBUG.:::'
,p_page_id=>1402
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(23761404070459334)
,p_parent_id=>wwv_flow_imp.id(1308911481947279)
,p_short_name=>'Create Application'
,p_link=>'f?p=&FLOW_ID.:84:&SESSION.'
,p_page_id=>84
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(24415726992637074)
,p_parent_id=>wwv_flow_imp.id(18832229785461633)
,p_short_name=>'Edit'
,p_link=>'f?p=&APP_ID.:1405:&SESSION.::&DEBUG.:::'
,p_page_id=>1405
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(24448222218694942)
,p_parent_id=>wwv_flow_imp.id(799613605926722)
,p_short_name=>'Upgrade'
,p_link=>'f?p=&FLOW_ID.:667:&SESSION.'
,p_page_id=>667
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(26225010322357939)
,p_parent_id=>wwv_flow_imp.id(1308911481947279)
,p_short_name=>'Create Application'
,p_link=>'f?p=&APP_ID.:3000:&SESSION.::&DEBUG.:::'
,p_page_id=>3000
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(26276826533862190)
,p_parent_id=>wwv_flow_imp.id(1308911481947279)
,p_short_name=>'Create Application'
,p_link=>'f?p=&APP_ID.:3001:&SESSION.::&DEBUG.:::'
,p_page_id=>3001
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(26314303002960839)
,p_parent_id=>wwv_flow_imp.id(6361712997598750)
,p_short_name=>'Edit'
,p_link=>'f?p=&APP_ID.:4309:&SESSION.::&DEBUG.:::'
,p_page_id=>4309
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(26467114976744807)
,p_parent_id=>wwv_flow_imp.id(6490322331050183)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:118:&SESSION.::&DEBUG.:::'
,p_page_id=>118
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P118_SCOPE = ''APP'' and :P118_ID is null'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(26484923558914183)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Static Workspace Files'
,p_link=>'f?p=&APP_ID.:312:&SESSION.'
,p_page_id=>312
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(26497601066968748)
,p_parent_id=>wwv_flow_imp.id(26484923558914183)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:118:&SESSION.::&DEBUG.:::'
,p_page_id=>118
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P118_SCOPE = ''WORKSPACE'' and :P118_ID is null'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(26719617493740595)
,p_parent_id=>wwv_flow_imp.id(1308911481947279)
,p_short_name=>'Create Application'
,p_link=>'f?p=&APP_ID.:3005:&SESSION.::&DEBUG.:::'
,p_page_id=>3005
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(27348317124101692)
,p_short_name=>'Create Calendar Region'
,p_link=>'f?p=&FLOW_ID.:470:&SESSION.'
,p_page_id=>470
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(27355913750296249)
,p_short_name=>'Create Calendar Region'
,p_link=>'f?p=&FLOW_ID.:615:&SESSION.'
,p_page_id=>615
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(27799320681844329)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Plug-ins'
,p_link=>'f?p=&APP_ID.:4400:&SESSION.::&DEBUG.:::'
,p_page_id=>4400
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(27855116546326915)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Plug-in Utilization'
,p_link=>'f?p=&APP_ID.:4420:&SESSION.::&DEBUG.:::'
,p_page_id=>4420
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(27902008881734561)
,p_parent_id=>wwv_flow_imp.id(27799320681844329)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:4410:&SESSION.::&DEBUG.:4410:P4410_ID,FB_FLOW_ID:,&FB_FLOW_ID.'
,p_page_id=>4410
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P4410_ID is null and :P4410_THEME_ID is null'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(28090518824128438)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Dynamic Actions'
,p_link=>'f?p=&APP_ID.:773:&SESSION.::&DEBUG.:::'
,p_page_id=>773
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(28660023095978630)
,p_parent_id=>wwv_flow_imp.id(6481002299029073)
,p_short_name=>'Translation Repository'
,p_link=>'f?p=&APP_ID.:702:&SESSION.::&DEBUG.:::'
,p_page_id=>702
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(28660317933978631)
,p_parent_id=>wwv_flow_imp.id(28660023095978630)
,p_short_name=>'Edit Translatable Text'
,p_link=>'f?p=&APP_ID.:704:&SESSION.::&DEBUG.:::'
,p_page_id=>704
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(28691420118449496)
,p_parent_id=>wwv_flow_imp.id(193869708580501594)
,p_short_name=>'Count by Region Type'
,p_link=>'f?p=&APP_ID.:128:&SESSION.::&DEBUG.:::'
,p_page_id=>128
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(28731306901690116)
,p_parent_id=>wwv_flow_imp.id(193869708580501594)
,p_short_name=>'Count by Slot'
,p_link=>'f?p=&APP_ID.:459:&SESSION.::&DEBUG.:::'
,p_page_id=>459
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(28919928791404969)
,p_parent_id=>wwv_flow_imp.id(6357300501589343)
,p_short_name=>'Rename Standard Tab Set'
,p_link=>'f?p=&APP_ID.:345:&SESSION.::&DEBUG.:::'
,p_page_id=>345
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(28947630899464790)
,p_parent_id=>wwv_flow_imp.id(6357300501589343)
,p_short_name=>'Rename Standard Tab Set'
,p_link=>'f?p=&APP_ID.:346:&SESSION.::&DEBUG.:::'
,p_page_id=>346
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(29079632388284659)
,p_parent_id=>wwv_flow_imp.id(6357300501589343)
,p_short_name=>'Rename Standard Tab Set'
,p_link=>'f?p=&APP_ID.:347:&SESSION.::&DEBUG.:::'
,p_page_id=>347
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(29655930553843283)
,p_parent_id=>wwv_flow_imp.id(11539704173277683)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:1114:&SESSION.::&DEBUG.:::'
,p_page_id=>1114
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(29881014393620137)
,p_parent_id=>wwv_flow_imp.id(3600263368521940)
,p_short_name=>'Create File'
,p_link=>'f?p=&APP_ID.:118:&SESSION.::&DEBUG.:::'
,p_page_id=>118
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P118_SCOPE = ''PLUGIN'' and :P118_ID is null'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(30089524645427141)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Form and Report on Web Service'
,p_link=>'f?p=&APP_ID.:700:&SESSION.::&DEBUG.:::'
,p_page_id=>700
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(30089908846432101)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Form and Report on Web Service'
,p_link=>'f?p=&APP_ID.:705:&SESSION.::&DEBUG.:::'
,p_page_id=>705
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(30090803090439908)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Form and Report on Web Service'
,p_link=>'f?p=&APP_ID.:720:&SESSION.::&DEBUG.:::'
,p_page_id=>720
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(30091112094442467)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Form and Report on Web Service'
,p_link=>'f?p=&APP_ID.:725:&SESSION.::&DEBUG.:::'
,p_page_id=>725
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(30091426292446571)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Form and Report on Web Service'
,p_link=>'f?p=&APP_ID.:730:&SESSION.::&DEBUG.:::'
,p_page_id=>730
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(30091712571452107)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Form and Report on Web Service'
,p_link=>'f?p=&APP_ID.:735:&SESSION.::&DEBUG.:::'
,p_page_id=>735
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(30302731462358764)
,p_parent_id=>wwv_flow_imp.id(177829529391401676)
,p_short_name=>'Saved Interactive Reports'
,p_link=>'f?p=&APP_ID.:37:&SESSION.'
,p_page_id=>37
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(30450428822739510)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Delete Multiple Dynamic Actions'
,p_link=>'f?p=&APP_ID.:794:&SESSION.::&DEBUG.:::'
,p_page_id=>794
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(30457608873900217)
,p_parent_id=>wwv_flow_imp.id(177829529391401676)
,p_short_name=>'Dynamic Action History'
,p_link=>'f?p=&APP_ID.:795:&SESSION.::&DEBUG.:::'
,p_page_id=>795
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(30468518358262614)
,p_parent_id=>wwv_flow_imp.id(6342315964532655)
,p_short_name=>'Export'
,p_link=>'f?p=&APP_ID.:4460:&SESSION.::&DEBUG.:::'
,p_page_id=>4460
,p_display_when_cond_type=>'ITEM_IS_NOT_NULL'
,p_display_when_condition=>'FB_FLOW_ID'
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(30498215610469161)
,p_parent_id=>wwv_flow_imp.id(1308911481947279)
,p_short_name=>'Install Plug-in'
,p_link=>'f?p=&APP_ID.:4450:&SESSION.::&DEBUG.:::'
,p_page_id=>4450
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(30640927390365885)
,p_parent_id=>wwv_flow_imp.id(177829529391401676)
,p_short_name=>'Subscriptions'
,p_link=>'f?p=&APP_ID.:39:&SESSION.::&DEBUG.:::'
,p_page_id=>39
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(30739614365181356)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Edit Legacy Calendar Template'
,p_link=>'f?p=&APP_ID.:836:&SESSION.::&DEBUG.:::'
,p_page_id=>836
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(30785800441167235)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Locally Defined Lists of Values'
,p_link=>'f?p=&APP_ID.:419:&SESSION.::&DEBUG.:::'
,p_page_id=>419
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(30913092047722238)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Map Backgrounds'
,p_link=>'f?p=&APP_ID.:6100:&SESSION.::&DEBUG.:::'
,p_page_id=>6100
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(30914051551729386)
,p_parent_id=>wwv_flow_imp.id(30913092047722238)
,p_short_name=>'Map Background'
,p_link=>'f?p=&APP_ID.:6120:&SESSION.::&DEBUG.:::'
,p_page_id=>6120
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(30914792312734201)
,p_parent_id=>wwv_flow_imp.id(30913092047722238)
,p_short_name=>'Map Background Utilization'
,p_link=>'f?p=&APP_ID.:6140:&SESSION.::&DEBUG.:::'
,p_page_id=>6140
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(30915284157735651)
,p_parent_id=>wwv_flow_imp.id(30913092047722238)
,p_short_name=>'Map Background History'
,p_link=>'f?p=&APP_ID.:6150:&SESSION.::&DEBUG.:::'
,p_page_id=>6150
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(31042308063790472)
,p_parent_id=>wwv_flow_imp.id(9594412395161749)
,p_short_name=>'Cached Regions'
,p_link=>'f?p=&APP_ID.:656:&SESSION.::&DEBUG.:::'
,p_page_id=>656
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(31650524804146842)
,p_parent_id=>wwv_flow_imp.id(6357300501589343)
,p_short_name=>'Parent Tab Report'
,p_link=>'f?p=&FLOW_ID.:398:&SESSION.'
,p_page_id=>398
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(32815330203586117)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Edit Parent Tabs'
,p_link=>'f?p=&APP_ID.:331:&SESSION.::&DEBUG.:::'
,p_page_id=>331
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(32866018483682765)
,p_parent_id=>wwv_flow_imp.id(6357300501589343)
,p_short_name=>'Rename Parent Tab Set'
,p_link=>'f?p=&APP_ID.:332:&SESSION.::&DEBUG.:::'
,p_page_id=>332
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(32869310503686430)
,p_parent_id=>wwv_flow_imp.id(6357300501589343)
,p_short_name=>'Rename Parent Tab Set'
,p_link=>'f?p=&APP_ID.:333:&SESSION.::&DEBUG.:::'
,p_page_id=>333
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(33396205771549676)
,p_parent_id=>wwv_flow_imp.id(6350702023573393)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:870:&SESSION.::&DEBUG.:::'
,p_page_id=>870
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(33404507616674451)
,p_parent_id=>wwv_flow_imp.id(6350702023573393)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:871:&SESSION.::&DEBUG.:::'
,p_page_id=>871
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(33462229310688402)
,p_parent_id=>wwv_flow_imp.id(6350702023573393)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:872:&SESSION.::&DEBUG.:::'
,p_page_id=>872
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(33477504160168267)
,p_parent_id=>wwv_flow_imp.id(6350702023573393)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:873:&SESSION.::&DEBUG.:::'
,p_page_id=>873
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(33528118901761498)
,p_parent_id=>wwv_flow_imp.id(6795302837254265)
,p_short_name=>'Reparent'
,p_link=>'f?p=&APP_ID.:2222:&SESSION.::&DEBUG.:::'
,p_page_id=>2222
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(33595328303408157)
,p_parent_id=>wwv_flow_imp.id(6350702023573393)
,p_short_name=>'Test'
,p_link=>'f?p=&APP_ID.:875:&SESSION.::&DEBUG.:::'
,p_page_id=>875
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(33766511907980118)
,p_parent_id=>wwv_flow_imp.id(6342315964532655)
,p_short_name=>'Edit Globalization Attributes'
,p_link=>'f?p=&APP_ID.:506:&SESSION.::&DEBUG.:::'
,p_page_id=>506
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(33987924944919169)
,p_parent_id=>wwv_flow_imp.id(6350702023573393)
,p_short_name=>'Edit'
,p_link=>'f?p=&APP_ID.:876:&SESSION.::&DEBUG.:::'
,p_page_id=>876
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(34479620623171629)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Create Form and Report on Web Service'
,p_link=>'f?p=&APP_ID.:880:&SESSION.::&DEBUG.:::'
,p_page_id=>880
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(34486714324302987)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Create Form and Report on Web Service'
,p_link=>'f?p=&APP_ID.:882:&SESSION.::&DEBUG.:::'
,p_page_id=>882
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(34529526845409561)
,p_parent_id=>wwv_flow_imp.id(492636106117616338)
,p_short_name=>'Page Locks'
,p_link=>'f?p=&APP_ID.:291:&SESSION.::&DEBUG.:::'
,p_page_id=>291
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(34893003789899070)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Create Form and Report on Web Service'
,p_link=>'f?p=&APP_ID.:884:&SESSION.::&DEBUG.:::'
,p_page_id=>884
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(34919800042540097)
,p_parent_id=>wwv_flow_imp.id(177829529391401676)
,p_short_name=>'Lock Administration'
,p_link=>'f?p=&APP_ID.:299:&SESSION.::&DEBUG.:::'
,p_page_id=>299
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(34983512563904574)
,p_parent_id=>wwv_flow_imp.id(34919800042540097)
,p_short_name=>'Edit Page Lock'
,p_link=>'f?p=&FLOW_ID.:330:&SESSION.::&DEBUG.:::'
,p_page_id=>330
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(35045730676235051)
,p_parent_id=>wwv_flow_imp.id(34529526845409561)
,p_short_name=>'Edit Lock Comment'
,p_link=>'f?p=&FLOW_ID.:337:&SESSION.::&DEBUG.:::'
,p_page_id=>337
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(35080631019682256)
,p_parent_id=>wwv_flow_imp.id(6357300501589343)
,p_short_name=>'Add Tab Association'
,p_link=>'f?p=&APP_ID.:9005:&SESSION.::&DEBUG.:::'
,p_page_id=>9005
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(36775909817926063)
,p_parent_id=>wwv_flow_imp.id(193915914105228860)
,p_short_name=>'Item Help Subscriptions'
,p_link=>'f?p=&APP_ID.:389:&SESSION.::&DEBUG.:::'
,p_page_id=>389
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(37885708427140508)
,p_parent_id=>wwv_flow_imp.id(34529526845409561)
,p_short_name=>'Lock Pages'
,p_link=>'f?p=&FLOW_ID.:444:&SESSION.'
,p_page_id=>444
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(38412104081069219)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create Legacy Calendar Template'
,p_long_name=>'Create Legacy Calendar Template'
,p_link=>'f?p=&APP_ID.:468:&SESSION.::&DEBUG.:::'
,p_page_id=>468
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(38412811700071392)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create Legacy Calendar Template'
,p_long_name=>'Create Legacy Calendar Template'
,p_link=>'f?p=&APP_ID.:469:&SESSION.::&DEBUG.:::'
,p_page_id=>469
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(39308104330344265)
,p_short_name=>'Create Page Component'
,p_link=>'f?p=&APP_ID.:323:&SESSION.::&DEBUG.:::'
,p_page_id=>323
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(40400718662461634)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Create Application Component'
,p_link=>'f?p=&APP_ID.:364:&SESSION.::&DEBUG.:::'
,p_page_id=>364
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(40426904951619920)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Application Comments'
,p_link=>'f?p=&APP_ID.:4310:&SESSION.::&DEBUG.:::'
,p_page_id=>4310
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(40741805928664126)
,p_parent_id=>wwv_flow_imp.id(6795302837254265)
,p_short_name=>'Manage Orphaned List Entries'
,p_link=>'f?p=&APP_ID.:712:&SESSION.::&DEBUG.:::'
,p_page_id=>712
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(41874016096395037)
,p_parent_id=>wwv_flow_imp.id(740988995699531167)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:207:&SESSION.::&DEBUG.:::'
,p_page_id=>207
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(42095611506558026)
,p_short_name=>'Column Attributes'
,p_link=>'f?p=&FLOW_ID.:422:&SESSION.::&DEBUG.:::'
,p_page_id=>422
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(42228527428329871)
,p_parent_id=>wwv_flow_imp.id(6342315964532655)
,p_short_name=>'User Interfaces'
,p_link=>'f?p=&APP_ID.:197:&SESSION.'
,p_page_id=>197
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(42239113024348195)
,p_parent_id=>wwv_flow_imp.id(6350702023573393)
,p_short_name=>'Edit'
,p_link=>'f?p=&APP_ID.:599:&SESSION.::&DEBUG.:::'
,p_page_id=>599
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(42239606229355665)
,p_parent_id=>wwv_flow_imp.id(6350702023573393)
,p_short_name=>'View'
,p_link=>'f?p=&APP_ID.:589:&SESSION.::&DEBUG.:::'
,p_page_id=>589
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(42239918004359113)
,p_parent_id=>wwv_flow_imp.id(6350702023573393)
,p_short_name=>'Test'
,p_link=>'f?p=&APP_ID.:588:&SESSION.::&DEBUG.:::'
,p_page_id=>588
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(44047420694470997)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Theme Reports'
,p_link=>'f?p=&APP_ID.:173:&SESSION.::&DEBUG.:::'
,p_page_id=>173
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(44092007432082923)
,p_parent_id=>wwv_flow_imp.id(6594228985351058)
,p_short_name=>'Page References'
,p_link=>'f?p=&APP_ID.:417:&SESSION.::&DEBUG.:::'
,p_page_id=>417
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(44862032766498285)
,p_parent_id=>wwv_flow_imp.id(6482129244031803)
,p_short_name=>'Grid Edit'
,p_link=>'f?p=&FLOW_ID.:888:&SESSION.'
,p_page_id=>888
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(45432327870093655)
,p_parent_id=>wwv_flow_imp.id(6342315964532655)
,p_short_name=>'Export / Import'
,p_link=>'f?p=&APP_ID.:461:&SESSION.::&DEBUG.:::'
,p_page_id=>461
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(45679206524935706)
,p_parent_id=>wwv_flow_imp.id(6481002299029073)
,p_short_name=>'XLIFF Translation Files'
,p_link=>'f?p=&FLOW_ID.:4758:&SESSION.'
,p_page_id=>4758
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(46338004382099030)
,p_parent_id=>wwv_flow_imp.id(95667010592946781)
,p_short_name=>'Column Names Aliases'
,p_link=>'f?p=&APP_ID.:1805:&SESSION.::&DEBUG.:::'
,p_page_id=>1805
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(46371404489562105)
,p_parent_id=>wwv_flow_imp.id(1308911481947279)
,p_short_name=>'Import'
,p_link=>'f?p=&APP_ID.:460:&SESSION.::&DEBUG.:::'
,p_page_id=>460
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(47702420424012761)
,p_parent_id=>wwv_flow_imp.id(1308911481947279)
,p_short_name=>'Install Application'
,p_link=>'f?p=&APP_ID.:49:&SESSION.::&DEBUG.:::'
,p_page_id=>49
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(47890813442207291)
,p_parent_id=>wwv_flow_imp.id(177829529391401676)
,p_short_name=>'Change History'
,p_link=>'f?p=&APP_ID.:358:&SESSION.::&DEBUG.:::'
,p_page_id=>358
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(48375032377887349)
,p_parent_id=>wwv_flow_imp.id(492636106117616338)
,p_short_name=>'Delete Multiple Pages'
,p_link=>'f?p=&APP_ID.:72:&SESSION.::&DEBUG.:::'
,p_page_id=>72
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(48381702709598053)
,p_short_name=>'Deinstall Supporting Objects'
,p_link=>'f?p=&APP_ID.:155:&SESSION.'
,p_page_id=>155
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(48414026097213196)
,p_parent_id=>wwv_flow_imp.id(3801099868410190)
,p_short_name=>'Edit Attribute'
,p_link=>'f?p=&APP_ID.:4415:&SESSION.::&DEBUG.:::'
,p_page_id=>4415
,p_display_when_cond_type=>'ITEM_IS_NULL'
,p_display_when_condition=>'P4410_THEME_ID'
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(48446526579705279)
,p_parent_id=>wwv_flow_imp.id(6661610099511746)
,p_short_name=>'Install Image'
,p_link=>'f?p=&FLOW_ID.:409:&SESSION.::&DEBUG.:::'
,p_page_id=>409
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(48578110317738240)
,p_parent_id=>wwv_flow_imp.id(6342315964532655)
,p_short_name=>'Page Designer'
,p_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.:::'
,p_page_id=>4500
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(48643012706424118)
,p_parent_id=>wwv_flow_imp.id(6342315964532655)
,p_short_name=>'Install Application'
,p_link=>'f?p=&FLOW_ID.:2150:&SESSION.'
,p_page_id=>2150
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(48656725459443596)
,p_parent_id=>wwv_flow_imp.id(6342315964532655)
,p_short_name=>'Install Application'
,p_link=>'f?p=&FLOW_ID.:2151:&SESSION.'
,p_page_id=>2151
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(48663025959454948)
,p_parent_id=>wwv_flow_imp.id(6342315964532655)
,p_short_name=>'Install Application'
,p_link=>'f?p=&FLOW_ID.:2152:&SESSION.'
,p_page_id=>2152
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(49204000503875094)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Confirm Delete of List Template'
,p_link=>'f?p=&APP_ID.:278:&SESSION.::&DEBUG.:::'
,p_page_id=>278
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(49260504263115354)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Confirm Delete of Page Template'
,p_link=>'f?p=&APP_ID.:298:&SESSION.::&DEBUG.:::'
,p_page_id=>298
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(51135515383124124)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Delete Multiple Buttons'
,p_link=>'f?p=&FLOW_ID.:724:&SESSION.'
,p_page_id=>724
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(51370918597464994)
,p_parent_id=>wwv_flow_imp.id(6342315964532655)
,p_short_name=>'Install Application'
,p_link=>'f?p=&FLOW_ID.:2153:&SESSION.'
,p_page_id=>2153
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(56073623850337643)
,p_short_name=>'Create Form on Table'
,p_link=>'f?p=&APP_ID.:453:&SESSION.::&DEBUG.:::'
,p_page_id=>453
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(56571426174792979)
,p_parent_id=>wwv_flow_imp.id(45679206524935706)
,p_short_name=>'XLIFF Upload'
,p_link=>'f?p=&FLOW_ID.:4760:&SESSION.'
,p_page_id=>4760
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(57402008958641680)
,p_parent_id=>wwv_flow_imp.id(6342315964532655)
,p_short_name=>'Install Application'
,p_link=>'f?p=&FLOW_ID.:2154:&SESSION.'
,p_page_id=>2154
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(57409130281645336)
,p_parent_id=>wwv_flow_imp.id(6342315964532655)
,p_short_name=>'Install Application'
,p_link=>'f?p=&FLOW_ID.:2155:&SESSION.'
,p_page_id=>2155
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(57430104579660620)
,p_parent_id=>wwv_flow_imp.id(6342315964532655)
,p_short_name=>'Install Application'
,p_link=>'f?p=&FLOW_ID.:2157:&SESSION.'
,p_page_id=>2157
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(57440225865676749)
,p_parent_id=>wwv_flow_imp.id(6342315964532655)
,p_short_name=>'Error'
,p_link=>'f?p=&FLOW_ID.:2158:&SESSION.'
,p_page_id=>2158
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(57481112855728406)
,p_parent_id=>wwv_flow_imp.id(6342315964532655)
,p_short_name=>'Install Application'
,p_link=>'f?p=&FLOW_ID.:2166:&SESSION.'
,p_page_id=>2166
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(57557104867216371)
,p_parent_id=>wwv_flow_imp.id(740988995699531167)
,p_short_name=>'Switch Theme'
,p_link=>'f?p=&APP_ID.:179:&SESSION.::&DEBUG.:::'
,p_page_id=>179
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(57558317334219907)
,p_parent_id=>wwv_flow_imp.id(740988995699531167)
,p_short_name=>'Switch Theme'
,p_link=>'f?p=&APP_ID.:180:&SESSION.::&DEBUG.:::'
,p_page_id=>180
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(57677029210705977)
,p_parent_id=>wwv_flow_imp.id(740988995699531167)
,p_short_name=>'Delete'
,p_link=>'f?p=&APP_ID.:221:&SESSION.::&DEBUG.:::'
,p_page_id=>221
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(57801802413038850)
,p_parent_id=>wwv_flow_imp.id(740988995699531167)
,p_short_name=>'Delete'
,p_link=>'f?p=&APP_ID.:229:&SESSION.::&DEBUG.:::'
,p_page_id=>229
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(57892000082254726)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Delete Multiple Validations'
,p_link=>'f?p=&FLOW_ID.:743:&SESSION.'
,p_page_id=>743
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(57960416328352825)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Delete Multiple Computations'
,p_link=>'f?p=&FLOW_ID.:744:&SESSION.'
,p_page_id=>744
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(57976310474373623)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Delete Multiple Processes'
,p_link=>'f?p=&APP_ID.:745:&SESSION.::&DEBUG.:::'
,p_page_id=>745
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(57995107400396507)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Delete Multiple Branches'
,p_link=>'f?p=&FLOW_ID.:746:&SESSION.'
,p_page_id=>746
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(58018323080431042)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Delete Multiple Regions'
,p_link=>'f?p=&APP_ID.:747:&SESSION.::&DEBUG.:::'
,p_page_id=>747
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(59091202259431920)
,p_parent_id=>wwv_flow_imp.id(740988995699531167)
,p_short_name=>'Create / Edit Theme'
,p_link=>'f?p=&APP_ID.:267:&SESSION.::&DEBUG.:267:P267_ID,FB_FLOW_ID:&P267_ID.,&FB_FLOW_ID.'
,p_page_id=>267
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(59327103752427404)
,p_parent_id=>wwv_flow_imp.id(740988995699531167)
,p_short_name=>'Switch Theme'
,p_link=>'f?p=&APP_ID.:386:&SESSION.::&DEBUG.:::'
,p_page_id=>386
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(60196720153711959)
,p_short_name=>'Change Theme Identification Number'
,p_link=>'f?p=&APP_ID.:397:&SESSION.::&DEBUG.:::'
,p_page_id=>397
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(60229931206838111)
,p_short_name=>'Change Theme Identification Number'
,p_link=>'f?p=&APP_ID.:400:&SESSION.::&DEBUG.:::'
,p_page_id=>400
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(60307011719125820)
,p_parent_id=>wwv_flow_imp.id(740988995699531167)
,p_short_name=>'Copy'
,p_link=>'f?p=&APP_ID.:401:&SESSION.::&DEBUG.:::'
,p_page_id=>401
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(60307318991127996)
,p_parent_id=>wwv_flow_imp.id(740988995699531167)
,p_short_name=>'Copy'
,p_link=>'f?p=&APP_ID.:410:&SESSION.::&DEBUG.:::'
,p_page_id=>410
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(60519601156521547)
,p_parent_id=>wwv_flow_imp.id(6342315964532655)
,p_short_name=>'Export'
,p_link=>'f?p=&APP_ID.:224:&SESSION.::&DEBUG.:::'
,p_page_id=>224
,p_display_when_cond_type=>'ITEM_IS_NOT_NULL'
,p_display_when_condition=>'FB_FLOW_ID'
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(61422109882617052)
,p_parent_id=>wwv_flow_imp.id(11539704173277683)
,p_short_name=>'Edit'
,p_link=>'f?p=&APP_ID.:1116:&SESSION.::&DEBUG.:::'
,p_page_id=>1116
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(61439918645696793)
,p_parent_id=>wwv_flow_imp.id(61422109882617052)
,p_short_name=>'Report Source'
,p_link=>'f?p=&APP_ID.:1117:&SESSION.::&DEBUG.:::'
,p_page_id=>1117
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(61780222135354731)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Confirm Delete of Region Template'
,p_link=>'f?p=&APP_ID.:307:&SESSION.::&DEBUG.:::'
,p_page_id=>307
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(62062513318815833)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create Page Template'
,p_link=>'f?p=&FLOW_ID.:924:&SESSION.::&DEBUG.:::'
,p_page_id=>924
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(62062718859817408)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create List Template'
,p_link=>'f?p=&FLOW_ID.:935:&SESSION.::&DEBUG.:::'
,p_page_id=>935
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(62547120512258610)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Copy Page'
,p_link=>'f?p=&FLOW_ID.:302:&SESSION.'
,p_page_id=>302
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(62590614310357796)
,p_parent_id=>wwv_flow_imp.id(6342315964532655)
,p_short_name=>'Create Login Page'
,p_long_name=>'Create Login Page'
,p_link=>'f?p=&FLOW_ID.:500:&SESSION.::&DEBUG.:::'
,p_page_id=>500
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(62967931336852582)
,p_parent_id=>wwv_flow_imp.id(11539704173277683)
,p_short_name=>'Copy'
,p_link=>'f?p=&APP_ID.:1121:&SESSION.::&DEBUG.:::'
,p_page_id=>1121
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(63109602699977365)
,p_parent_id=>wwv_flow_imp.id(18832229785461633)
,p_short_name=>'Copy'
,p_link=>'f?p=&APP_ID.:1122:&SESSION.::&DEBUG.:::'
,p_page_id=>1122
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(67875614692050047)
,p_parent_id=>wwv_flow_imp.id(95667010592946781)
,p_short_name=>'Transformation Rules'
,p_link=>'f?p=&APP_ID.:1804:&SESSION.::&DEBUG.:::'
,p_page_id=>1804
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(75670229803852849)
,p_parent_id=>wwv_flow_imp.id(6661610099511746)
,p_short_name=>'Replace'
,p_link=>'f?p=&APP_ID.:48:&SESSION.::&DEBUG.:::'
,p_page_id=>48
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(77256925975128112)
,p_parent_id=>wwv_flow_imp.id(6661610099511746)
,p_short_name=>'Install'
,p_link=>'f?p=&APP_ID.:57:&SESSION.::&DEBUG.:::'
,p_page_id=>57
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(78978224218406311)
,p_parent_id=>wwv_flow_imp.id(193869708580501594)
,p_short_name=>'Edit Messages'
,p_link=>'f?p=&APP_ID.:212:&SESSION.::&DEBUG.:::'
,p_page_id=>212
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(79204403826546075)
,p_parent_id=>wwv_flow_imp.id(193856726464283476)
,p_short_name=>'Edit Process Messages'
,p_link=>'f?p=&APP_ID.:213:&SESSION.::&DEBUG.:::'
,p_page_id=>213
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(79267021325765840)
,p_parent_id=>wwv_flow_imp.id(193766813255904989)
,p_short_name=>'Edit Error Messages'
,p_link=>'f?p=&APP_ID.:214:&SESSION.::&DEBUG.:::'
,p_page_id=>214
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(79282824498840307)
,p_parent_id=>wwv_flow_imp.id(193687816503601756)
,p_short_name=>'Edit Error Messages'
,p_link=>'f?p=&APP_ID.:215:&SESSION.::&DEBUG.:::'
,p_page_id=>215
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(79404406301213449)
,p_parent_id=>wwv_flow_imp.id(193869708580501594)
,p_short_name=>'Edit Standard Report Column Headings'
,p_link=>'f?p=&APP_ID.:217:&SESSION.::&DEBUG.:::'
,p_page_id=>217
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(79918583149078897)
,p_parent_id=>wwv_flow_imp.id(225891858843186075)
,p_short_name=>'Create REST Data Source - Catalog'
,p_link=>'f?p=&APP_ID.:1908:&APP_SESSION.::&DEBUG.:::'
,p_page_id=>1908
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(80225705495174264)
,p_short_name=>'Search Configuration'
,p_link=>'f?p=&APP_ID.:3120:&APP_SESSION.::&DEBUG.:::'
,p_page_id=>3120
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(83259325931667653)
,p_parent_id=>wwv_flow_imp.id(193915914105228860)
,p_short_name=>'Edit Item Help Text'
,p_link=>'f?p=&APP_ID.:408:&SESSION.::&DEBUG.:::'
,p_page_id=>408
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(87895810674830166)
,p_parent_id=>wwv_flow_imp.id(18832229785461633)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:1406:&SESSION.::&DEBUG.:::'
,p_page_id=>1406
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(89290906690646629)
,p_short_name=>'Dynamic Query Attributes'
,p_link=>'f?p=&FLOW_ID.:687:&SESSION.'
,p_page_id=>687
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(90113801987389954)
,p_short_name=>'Column Groups'
,p_link=>'f?p=&APP_ID.:694:&SESSION.::&DEBUG.:::'
,p_page_id=>694
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(90377510935749472)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Template Utilization'
,p_link=>'f?p=&APP_ID.:707:&SESSION.::&DEBUG.:::'
,p_page_id=>707
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(90724539002918797)
,p_short_name=>'Search Configuration'
,p_link=>'f?p=&APP_ID.:3116:&APP_SESSION.::&DEBUG.:::'
,p_page_id=>3116
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(90725377083924733)
,p_short_name=>'Search Configuration'
,p_link=>'f?p=&APP_ID.:3121:&APP_SESSION.::&DEBUG.:::'
,p_page_id=>3121
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(90726170023927791)
,p_short_name=>'Search Configuration'
,p_link=>'f?p=&APP_ID.:3122:&APP_SESSION.::&DEBUG.:::'
,p_page_id=>3122
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(90734228848148157)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Replace Templates'
,p_link=>'f?p=&APP_ID.:708:&SESSION.::&DEBUG.:::'
,p_page_id=>708
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(90747004454189845)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Replace Templates'
,p_link=>'f?p=&APP_ID.:711:&SESSION.::&DEBUG.:::'
,p_page_id=>711
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(90748600357191706)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Replace Templates'
,p_link=>'f?p=&APP_ID.:713:&SESSION.::&DEBUG.:::'
,p_page_id=>713
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(91017830060853347)
,p_parent_id=>wwv_flow_imp.id(699056895544610173)
,p_short_name=>'Application Groups'
,p_link=>'f?p=&APP_ID.:722:&SESSION.::&DEBUG.:::'
,p_page_id=>722
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(91045931065932064)
,p_parent_id=>wwv_flow_imp.id(91017830060853347)
,p_short_name=>'Application Group'
,p_link=>'f?p=&FLOW_ID.:726:&SESSION.'
,p_page_id=>726
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(91621226770329390)
,p_parent_id=>wwv_flow_imp.id(91017830060853347)
,p_short_name=>'Manage Application Group Assignments'
,p_link=>'f?p=&APP_ID.:736:&SESSION.::&DEBUG.:::'
,p_page_id=>736
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(92827822623864115)
,p_short_name=>'Interactive Report'
,p_link=>'f?p=&APP_ID.:759:&SESSION.::&DEBUG.:::'
,p_page_id=>759
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(94569703469105837)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Publish Templates'
,p_link=>'f?p=&APP_ID.:727:&SESSION.::&DEBUG.:::'
,p_page_id=>727
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(95655705018786533)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Unsubscribe Templates'
,p_link=>'f?p=&APP_ID.:540:&SESSION.::&DEBUG.:::'
,p_page_id=>540
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(95667010592946781)
,p_parent_id=>wwv_flow_imp.id(15135828644258802)
,p_short_name=>'Legacy Data Load'
,p_link=>'f?p=&APP_ID.:1801:&SESSION.::&DEBUG.:::'
,p_page_id=>1801
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(97822916515667432)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Publish Templates'
,p_link=>'f?p=&FLOW_ID.:651:&SESSION.'
,p_page_id=>651
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(102217040088695062)
,p_short_name=>'Create Search Page'
,p_link=>'f?p=&APP_ID.:3117:&APP_SESSION.::&DEBUG.:::'
,p_page_id=>3117
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(104385112024157526)
,p_parent_id=>wwv_flow_imp.id(1308911481947279)
,p_short_name=>'Application Status'
,p_link=>'f?p=&FLOW_ID.:733:&SESSION.'
,p_page_id=>733
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(104933404458744311)
,p_parent_id=>wwv_flow_imp.id(11539704173277683)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:1115:&SESSION.::&DEBUG.:::'
,p_page_id=>1115
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(104951728751856925)
,p_parent_id=>wwv_flow_imp.id(11539704173277683)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:1119:&SESSION.::&DEBUG.:::'
,p_page_id=>1119
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(105094119363311752)
,p_short_name=>'Confirm Interactive Report Region Change'
,p_link=>'f?p=&APP_ID.:729:&SESSION.::&DEBUG.:::'
,p_page_id=>729
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(106142992391558884)
,p_parent_id=>wwv_flow_imp.id(6342315964532655)
,p_short_name=>'Progressive Web App'
,p_link=>'f?p=&APP_ID.:507:&SESSION.::&DEBUG.:::'
,p_page_id=>507
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(107237015875905749)
,p_parent_id=>wwv_flow_imp.id(6342315964532655)
,p_short_name=>'Edit Security Attributes'
,p_link=>'f?p=&APP_ID.:509:&SESSION.::&DEBUG.:::'
,p_page_id=>509
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(107340613778477687)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Session State Protection'
,p_link=>'f?p=&APP_ID.:510:&SESSION.::&DEBUG.:::'
,p_page_id=>510
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(107378015355659275)
,p_parent_id=>wwv_flow_imp.id(107340613778477687)
,p_short_name=>'by Page'
,p_link=>'f?p=&APP_ID.:512:&SESSION.::&DEBUG.:::'
,p_page_id=>512
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(107541219987325697)
,p_parent_id=>wwv_flow_imp.id(107340613778477687)
,p_short_name=>'Set Page and Item Protection'
,p_link=>'f?p=&APP_ID.:515:&SESSION.::&DEBUG.:::'
,p_page_id=>515
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(107580516018433845)
,p_parent_id=>wwv_flow_imp.id(107340613778477687)
,p_short_name=>'by Item'
,p_link=>'f?p=&APP_ID.:513:&SESSION.::&DEBUG.:::'
,p_page_id=>513
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(107807706268289266)
,p_parent_id=>wwv_flow_imp.id(107340613778477687)
,p_short_name=>'by Application Item'
,p_link=>'f?p=&APP_ID.:518:&SESSION.::&DEBUG.:::'
,p_page_id=>518
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(109504303498128012)
,p_parent_id=>wwv_flow_imp.id(107340613778477687)
,p_short_name=>'Set Application Protection'
,p_link=>'f?p=&APP_ID.:525:&SESSION.::&DEBUG.:::'
,p_page_id=>525
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(109519507330187086)
,p_parent_id=>wwv_flow_imp.id(107340613778477687)
,p_short_name=>'Disable'
,p_link=>'f?p=&APP_ID.:9008:&SESSION.::&DEBUG.:::'
,p_page_id=>9008
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(109587519846938835)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Copy Template'
,p_link=>'f?p=&FLOW_ID.:538:&SESSION.'
,p_page_id=>538
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(110590227693558637)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Copy Template'
,p_link=>'f?p=&APP_ID.:569:&SESSION.::&DEBUG.:::'
,p_page_id=>569
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(113585132510930484)
,p_short_name=>'Create Workspace Theme'
,p_link=>'f?p=&APP_ID.:762:&SESSION.::&DEBUG.:::'
,p_page_id=>762
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(113626503368049158)
,p_parent_id=>wwv_flow_imp.id(699056895544610173)
,p_short_name=>'Workspace Themes'
,p_link=>'f?p=&APP_ID.:763:&SESSION.::&DEBUG.:::'
,p_page_id=>763
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(113841012584615990)
,p_parent_id=>wwv_flow_imp.id(113626503368049158)
,p_short_name=>'Create Workspace Theme'
,p_link=>'f?p=&APP_ID.:764:&SESSION.::&DEBUG.:::'
,p_page_id=>764
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(113936004199440283)
,p_parent_id=>wwv_flow_imp.id(6356205677586897)
,p_short_name=>'Copy'
,p_link=>'f?p=&APP_ID.:603:&SESSION.::&DEBUG.:::'
,p_page_id=>603
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(114028028739330135)
,p_short_name=>'Report on Web Service Result'
,p_link=>'f?p=&FLOW_ID.:776:&SESSION.'
,p_page_id=>776
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(114044014921679563)
,p_short_name=>'Create Breadcrumb Region'
,p_link=>'f?p=&APP_ID.:481:&SESSION.::&DEBUG.:::'
,p_page_id=>481
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(114051800144368750)
,p_short_name=>'Report on Web Service Result'
,p_link=>'f?p=&FLOW_ID.:778:&SESSION.'
,p_page_id=>778
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(114060700049385731)
,p_short_name=>'Report on Web Service Result'
,p_link=>'f?p=&FLOW_ID.:779:&SESSION.'
,p_page_id=>779
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(114090607634408249)
,p_short_name=>'Report on Web Service Result'
,p_link=>'f?p=&FLOW_ID.:781:&SESSION.'
,p_page_id=>781
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(114111118245435536)
,p_short_name=>'Report on Web Service Result'
,p_link=>'f?p=&FLOW_ID.:782:&SESSION.'
,p_page_id=>782
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(114127205640452275)
,p_short_name=>'Report on Web Service Result'
,p_link=>'f?p=&FLOW_ID.:783:&SESSION.'
,p_page_id=>783
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(114158724210504878)
,p_short_name=>'Report on Web Service Result'
,p_link=>'f?p=&FLOW_ID.:786:&SESSION.'
,p_page_id=>786
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(114188508847866753)
,p_parent_id=>wwv_flow_imp.id(107340613778477687)
,p_short_name=>'Enable'
,p_link=>'f?p=&APP_ID.:9007:&SESSION.::&DEBUG.:::'
,p_page_id=>9007
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(114300919862740460)
,p_parent_id=>wwv_flow_imp.id(107340613778477687)
,p_short_name=>'Configure'
,p_link=>'f?p=&APP_ID.:9006:&SESSION.::&DEBUG.:::'
,p_page_id=>9006
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(114703706139322862)
,p_parent_id=>wwv_flow_imp.id(6358428525591525)
,p_short_name=>'Copy'
,p_link=>'f?p=&APP_ID.:485:&SESSION.::&DEBUG.:::'
,p_page_id=>485
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(114757003254593118)
,p_short_name=>'Create Workspace Theme'
,p_link=>'f?p=&APP_ID.:789:&SESSION.::&DEBUG.:::'
,p_page_id=>789
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(115178103851908301)
,p_parent_id=>wwv_flow_imp.id(6349507415570925)
,p_short_name=>'Copy'
,p_link=>'f?p=&APP_ID.:493:&SESSION.::&DEBUG.:::'
,p_page_id=>493
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(115199004729023834)
,p_parent_id=>wwv_flow_imp.id(6342315964532655)
,p_short_name=>'Copy Application'
,p_link=>'f?p=&FLOW_ID.:499:&SESSION.'
,p_page_id=>499
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(115200531243026756)
,p_parent_id=>wwv_flow_imp.id(6342315964532655)
,p_short_name=>'Copy Application'
,p_link=>'f?p=&FLOW_ID.:611:&SESSION.'
,p_page_id=>611
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(115276620473263231)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Copy List Template'
,p_link=>'f?p=&APP_ID.:573:&SESSION.::&DEBUG.:::'
,p_page_id=>573
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(115638218243483150)
,p_parent_id=>wwv_flow_imp.id(11539704173277683)
,p_short_name=>'Edit'
,p_link=>'f?p=&APP_ID.:1112:&SESSION.::&DEBUG.:::'
,p_page_id=>1112
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(115678105236786168)
,p_parent_id=>wwv_flow_imp.id(6351829184575999)
,p_short_name=>'Copy'
,p_link=>'f?p=&APP_ID.:617:&SESSION.::&DEBUG.:::'
,p_page_id=>617
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(120128322008989756)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create Region Template'
,p_link=>'f?p=&APP_ID.:902:&SESSION.::&DEBUG.:::'
,p_page_id=>902
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(120138725518019136)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create Legacy Calendar Template'
,p_link=>'f?p=&APP_ID.:349:&SESSION.::&DEBUG.:::'
,p_page_id=>349
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(120139804178022439)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create Popup Template'
,p_link=>'f?p=&APP_ID.:350:&SESSION.::&DEBUG.:::'
,p_page_id=>350
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(124379705309764963)
,p_parent_id=>wwv_flow_imp.id(2488828182812654)
,p_short_name=>'Edit Attribute'
,p_link=>'f?p=&APP_ID.:4415:&SESSION.::&DEBUG.:::'
,p_page_id=>4415
,p_display_when_cond_type=>'ITEM_IS_NOT_NULL'
,p_display_when_condition=>'P4410_THEME_ID'
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(125696810110909836)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Developer Comments'
,p_link=>'f?p=&APP_ID.:606:&SESSION.::&DEBUG.:::'
,p_page_id=>606
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(131391613326402590)
,p_parent_id=>wwv_flow_imp.id(162360425664871103)
,p_short_name=>'Developer Comments'
,p_link=>'f?p=&APP_ID.:380:&SESSION.::&DEBUG.:::'
,p_page_id=>380
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(132785468674659372)
,p_parent_id=>wwv_flow_imp.id(1493797321971786)
,p_short_name=>'Workflow Definition'
,p_link=>'f?p=&APP_ID.:9600:&SESSION.::&DEBUG.:::'
,p_page_id=>9600
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(135993121714361133)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Theme Reports'
,p_link=>'f?p=&APP_ID.:435:&SESSION.::&DEBUG.:::'
,p_page_id=>435
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(136552508251247413)
,p_parent_id=>wwv_flow_imp.id(113626503368049158)
,p_short_name=>'Edit Workspace Theme'
,p_link=>'f?p=&APP_ID.:756:&SESSION.::&DEBUG.:::'
,p_page_id=>756
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(137021224528556329)
,p_short_name=>'Migrate to Interactive Report'
,p_link=>'f?p=&APP_ID.:758:&SESSION.::&DEBUG.:::'
,p_page_id=>758
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(139373910461217836)
,p_parent_id=>wwv_flow_imp.id(162360425664871103)
,p_short_name=>'Theme Counts by Application'
,p_link=>'f?p=&FLOW_ID.:737:&SESSION.'
,p_page_id=>737
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(141400217689131996)
,p_parent_id=>wwv_flow_imp.id(6661610099511746)
,p_short_name=>'Install Theme'
,p_link=>'f?p=&APP_ID.:253:&SESSION.::&DEBUG.:::'
,p_page_id=>253
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(145762826362643090)
,p_parent_id=>wwv_flow_imp.id(1308911481947279)
,p_short_name=>'Export'
,p_link=>'f?p=&APP_ID.:479:&SESSION.::&DEBUG.:::'
,p_page_id=>479
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(149654224766911057)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Theme Reports'
,p_link=>'f?p=&APP_ID.:491:&SESSION.::&DEBUG.:::'
,p_page_id=>491
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(149658623852924840)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Theme Reports'
,p_link=>'f?p=&APP_ID.:492:&SESSION.::&DEBUG.:::'
,p_page_id=>492
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(150882216015541693)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:498:&SESSION.::&DEBUG.:::'
,p_page_id=>498
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(151993517365697434)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create Page Template'
,p_link=>'f?p=&FLOW_ID.:225:&SESSION.::&DEBUG.:::'
,p_page_id=>225
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(152080223449888448)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create Report Template'
,p_link=>'f?p=&FLOW_ID.:343:&SESSION.::&DEBUG.:::'
,p_page_id=>343
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(152910808417776655)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Unused Lists'
,p_link=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.:::'
,p_page_id=>10
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(153000101526828257)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create Label Template'
,p_link=>'f?p=&APP_ID.:655:&SESSION.::&DEBUG.:::'
,p_page_id=>655
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(153007213794852904)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create Label Template'
,p_link=>'f?p=&APP_ID.:657:&SESSION.::&DEBUG.:::'
,p_page_id=>657
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(154028932045622478)
,p_parent_id=>wwv_flow_imp.id(699056895544610173)
,p_short_name=>'REST Enabled SQL'
,p_link=>'f?p=&APP_ID.:1600:&SESSION.::&DEBUG.:::'
,p_page_id=>1600
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(154029809453638559)
,p_parent_id=>wwv_flow_imp.id(154028932045622478)
,p_short_name=>'Edit'
,p_link=>'f?p=&APP_ID.:1601:&SESSION.::&DEBUG.:::'
,p_page_id=>1601
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(154065306503882365)
,p_parent_id=>wwv_flow_imp.id(154028932045622478)
,p_short_name=>'History'
,p_link=>'f?p=&APP_ID.:1603:&SESSION.::&DEBUG.:::'
,p_page_id=>1603
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(154549600882195703)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create List Template'
,p_link=>'f?p=&FLOW_ID.:412:&SESSION.::&DEBUG.:::'
,p_page_id=>412
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(154576065012566142)
,p_parent_id=>wwv_flow_imp.id(699056895544610173)
,p_short_name=>'Web Credentials'
,p_link=>'f?p=&APP_ID.:1620:&SESSION.::&DEBUG.:::'
,p_page_id=>1620
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(154598203203414099)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create Breadcrumb Template'
,p_link=>'f?p=&APP_ID.:415:&SESSION.::&DEBUG.:::'
,p_page_id=>415
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(154602037791686576)
,p_parent_id=>wwv_flow_imp.id(154576065012566142)
,p_short_name=>'Create&#x2F;Edit'
,p_link=>'f?p=&APP_ID.:1621:&SESSION.'
,p_page_id=>1621
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(154624717149474872)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create Legacy Calendar Template'
,p_link=>'f?p=&APP_ID.:418:&SESSION.::&DEBUG.:::'
,p_page_id=>418
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(154636025026761954)
,p_parent_id=>wwv_flow_imp.id(154576065012566142)
,p_short_name=>'History'
,p_link=>'f?p=&APP_ID.:1623:&SESSION.'
,p_page_id=>1623
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(154695337185795841)
,p_parent_id=>wwv_flow_imp.id(154576065012566142)
,p_short_name=>'Utilization'
,p_link=>'f?p=&APP_ID.:1622:&SESSION.'
,p_page_id=>1622
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(154793529653781222)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create Button Template'
,p_link=>'f?p=&APP_ID.:413:&SESSION.::&DEBUG.:::'
,p_page_id=>413
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(158644126867435867)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create Label Template'
,p_link=>'f?p=&FLOW_ID.:652:&SESSION.::&DEBUG.:::'
,p_page_id=>652
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(160755307544646925)
,p_parent_id=>wwv_flow_imp.id(6661610099511746)
,p_short_name=>'Install UI Defaults'
,p_link=>'f?p=&APP_ID.:321:&SESSION.::&DEBUG.:::'
,p_page_id=>321
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(161813712083563669)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Confirm Delete of Label Template'
,p_link=>'f?p=&FLOW_ID.:348:&SESSION.'
,p_page_id=>348
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(161815107338565828)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Confirm Delete of Button Template'
,p_link=>'f?p=&FLOW_ID.:502:&SESSION.'
,p_page_id=>502
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(161818120481574928)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Confirm Delete of Breadcrumb Template'
,p_link=>'f?p=&APP_ID.:503:&SESSION.::&DEBUG.:::'
,p_page_id=>503
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(161820015952577079)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Confirm Delete of Legacy Calendar Template'
,p_link=>'f?p=&APP_ID.:504:&SESSION.::&DEBUG.:::'
,p_page_id=>504
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(162360425664871103)
,p_parent_id=>wwv_flow_imp.id(699056895544610173)
,p_short_name=>'Cross Application Reports'
,p_link=>'f?p=&APP_ID.:9009:&SESSION.::&DEBUG.:::'
,p_page_id=>9009
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(162374325122008014)
,p_parent_id=>wwv_flow_imp.id(162360425664871103)
,p_short_name=>'Application Attributes'
,p_link=>'f?p=&FLOW_ID.:9010:&SESSION.'
,p_page_id=>9010
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(162376931363020383)
,p_parent_id=>wwv_flow_imp.id(162360425664871103)
,p_short_name=>'Build Options'
,p_link=>'f?p=&FLOW_ID.:9012:&SESSION.'
,p_page_id=>9012
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(162379501171034352)
,p_parent_id=>wwv_flow_imp.id(162360425664871103)
,p_short_name=>'Security Profiles'
,p_link=>'f?p=&APP_ID.:9014:&SESSION.::&DEBUG.:::'
,p_page_id=>9014
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(162380821862039909)
,p_parent_id=>wwv_flow_imp.id(162360425664871103)
,p_short_name=>'Authentication Schemes'
,p_link=>'f?p=&APP_ID.:9015:&SESSION.::&DEBUG.:::'
,p_page_id=>9015
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(162450914277621500)
,p_parent_id=>wwv_flow_imp.id(6481002299029073)
,p_short_name=>'Translate Text'
,p_link=>'f?p=&APP_ID.:306:&SESSION.::&DEBUG.:::'
,p_page_id=>306
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(162452108227639507)
,p_parent_id=>wwv_flow_imp.id(6481002299029073)
,p_short_name=>'Seed and Publish'
,p_link=>'f?p=&APP_ID.:385:&SESSION.::&DEBUG.:::'
,p_page_id=>385
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(165418722196771382)
,p_short_name=>'Create Master Detail'
,p_link=>'f?p=&APP_ID.:507:&SESSION.::&DEBUG.:::'
,p_page_id=>507
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(165570524142028754)
,p_short_name=>'Create Master Detail'
,p_link=>'f?p=&APP_ID.:508:&SESSION.::&DEBUG.:::'
,p_page_id=>508
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(168965907799367480)
,p_short_name=>'Create Form on Table'
,p_link=>'f?p=&APP_ID.:442:&SESSION.::&DEBUG.:::'
,p_page_id=>442
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(169026027097495242)
,p_short_name=>'&P4703_PAGE_TITLE.'
,p_link=>'f?p=&APP_ID.:443:&SESSION.::&DEBUG.:::'
,p_page_id=>443
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(169186218227566038)
,p_parent_id=>wwv_flow_imp.id(16773830395421252)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:427:&SESSION.::&DEBUG.:::'
,p_page_id=>427
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(169188309807640845)
,p_parent_id=>wwv_flow_imp.id(16773830395421252)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:440:&SESSION.::&DEBUG.:::'
,p_page_id=>440
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(169196020236747043)
,p_parent_id=>wwv_flow_imp.id(16773830395421252)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:529:&SESSION.::&DEBUG.:::'
,p_page_id=>529
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(170052511890818404)
,p_parent_id=>wwv_flow_imp.id(177829529391401676)
,p_short_name=>'Recently Updated Pages'
,p_link=>'f?p=&APP_ID.:8:&SESSION.::&DEBUG.:::'
,p_page_id=>8
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(170300003306388723)
,p_parent_id=>wwv_flow_imp.id(6795302837254265)
,p_short_name=>'Resequence List Entries'
,p_link=>'f?p=&APP_ID.:536:&SESSION.::&DEBUG.:::'
,p_page_id=>536
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(171699124709464076)
,p_parent_id=>wwv_flow_imp.id(193869708580501594)
,p_short_name=>'PL/SQL Regions'
,p_link=>'f?p=&APP_ID.:480:&SESSION.::&DEBUG.:::'
,p_page_id=>480
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(171877905296973607)
,p_short_name=>'Results'
,p_link=>'f?p=&APP_ID.:8101:&SESSION.::&DEBUG.:::'
,p_page_id=>8101
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(171905003724893273)
,p_parent_id=>wwv_flow_imp.id(492636106117616338)
,p_short_name=>'Page Attributes'
,p_link=>'f?p=&APP_ID.:484:&SESSION.::&DEBUG.:::'
,p_page_id=>484
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(174703620660828013)
,p_parent_id=>wwv_flow_imp.id(1308911481947279)
,p_short_name=>'Create Application'
,p_link=>'f?p=&APP_ID.:3020:&SESSION.::&DEBUG.:::'
,p_page_id=>3020
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(174788904891863226)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Referenced Database Objects'
,p_link=>'f?p=&APP_ID.:268:&SESSION.::&DEBUG.:::'
,p_page_id=>268
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(177829529391401676)
,p_parent_id=>wwv_flow_imp.id(6342315964532655)
,p_short_name=>'Utilities'
,p_link=>'f?p=&APP_ID.:674:&SESSION.::&DEBUG.:::'
,p_page_id=>674
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(182505732052858978)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Edit Breadcrumb Template'
,p_link=>'f?p=&APP_ID.:289:&SESSION.::&DEBUG.:::'
,p_page_id=>289
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(184663820849027926)
,p_parent_id=>wwv_flow_imp.id(48414026097213196)
,p_short_name=>'Edit Value'
,p_link=>'f?p=&FLOW_ID.:4416:&SESSION.'
,p_page_id=>4416
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(188100621615832352)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Conditional Lists of Values Entries'
,p_link=>'f?p=&APP_ID.:556:&SESSION.::&DEBUG.:::'
,p_page_id=>556
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(188108816910881685)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Conditional List Entries'
,p_link=>'f?p=&FLOW_ID.:557:&SESSION.'
,p_page_id=>557
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(188150209489131290)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Conditional Tab Display'
,p_link=>'f?p=&APP_ID.:562:&SESSION.::&DEBUG.:::'
,p_page_id=>562
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(190002104978248634)
,p_parent_id=>wwv_flow_imp.id(177829529391401676)
,p_short_name=>'Database Object Dependencies'
,p_link=>'f?p=&APP_ID.:425:&SESSION.::&DEBUG.:::'
,p_page_id=>425
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(190138606995764363)
,p_parent_id=>wwv_flow_imp.id(190002104978248634)
,p_short_name=>'Page References'
,p_link=>'f?p=&FLOW_ID.:434:&SESSION.'
,p_page_id=>434
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(192555809351400735)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Application Item History'
,p_link=>'f?p=&FLOW_ID.:533:&SESSION.'
,p_page_id=>533
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(192564311271466695)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Build Option History'
,p_link=>'f?p=&FLOW_ID.:535:&SESSION.'
,p_page_id=>535
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(192625619892729357)
,p_parent_id=>wwv_flow_imp.id(6795302837254265)
,p_short_name=>'Create / Edit'
,p_link=>'f?p=&APP_ID.:4052:&SESSION.::&DEBUG.:::'
,p_page_id=>4052
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(192764909884723601)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Authentication Scheme History'
,p_link=>'f?p=&FLOW_ID.:554:&SESSION.'
,p_page_id=>554
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(192783704238809048)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Authorization Scheme History'
,p_link=>'f?p=&FLOW_ID.:558:&SESSION.'
,p_page_id=>558
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(193119829696374981)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Theme History'
,p_link=>'f?p=&FLOW_ID.:681:&SESSION.'
,p_page_id=>681
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(193350432188403940)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'List of Values History'
,p_link=>'f?p=&FLOW_ID.:686:&SESSION.'
,p_page_id=>686
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(193355419042451698)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Plug-in History'
,p_link=>'f?p=&APP_ID.:841:&SESSION.::&DEBUG.:::'
,p_page_id=>841
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(193368710626376391)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Report Query History'
,p_link=>'f?p=&FLOW_ID.:843:&SESSION.'
,p_page_id=>843
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(193374131543539461)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Report Layout History'
,p_link=>'f?p=&FLOW_ID.:844:&SESSION.'
,p_page_id=>844
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(193687816503601756)
,p_parent_id=>wwv_flow_imp.id(177829529391401676)
,p_short_name=>'Computation Utilities'
,p_link=>'f?p=&APP_ID.:847:&SESSION.::&DEBUG.:::'
,p_page_id=>847
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(193705211223861131)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Create Form and Report on Web Service'
,p_link=>'f?p=&APP_ID.:842:&SESSION.::&DEBUG.:::'
,p_page_id=>842
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(193711914243872120)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Form and Report on Web Service'
,p_link=>'f?p=&APP_ID.:848:&SESSION.::&DEBUG.:::'
,p_page_id=>848
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(193766813255904989)
,p_parent_id=>wwv_flow_imp.id(177829529391401676)
,p_short_name=>'Validation Utilities'
,p_link=>'f?p=&APP_ID.:851:&SESSION.::&DEBUG.:::'
,p_page_id=>851
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(193782110098056426)
,p_parent_id=>wwv_flow_imp.id(177829529391401676)
,p_short_name=>'Button Utilities'
,p_link=>'f?p=&APP_ID.:852:&SESSION.::&DEBUG.:::'
,p_page_id=>852
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(193856726464283476)
,p_parent_id=>wwv_flow_imp.id(177829529391401676)
,p_short_name=>'Process Utilities'
,p_link=>'f?p=&APP_ID.:482:&SESSION.::&DEBUG.:::'
,p_page_id=>482
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(193869708580501594)
,p_parent_id=>wwv_flow_imp.id(177829529391401676)
,p_short_name=>'Region Utilities'
,p_link=>'f?p=&APP_ID.:853:&SESSION.::&DEBUG.:::'
,p_page_id=>853
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(193915914105228860)
,p_parent_id=>wwv_flow_imp.id(177829529391401676)
,p_short_name=>'Item Utilities'
,p_link=>'f?p=&APP_ID.:854:&SESSION.::&DEBUG.:::'
,p_page_id=>854
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(193940422363104089)
,p_short_name=>'Report on Web Service Result'
,p_link=>'f?p=&FLOW_ID.:859:&SESSION.'
,p_page_id=>859
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(193946420117118951)
,p_short_name=>'Report on Web Service Result'
,p_link=>'f?p=&FLOW_ID.:860:&SESSION.'
,p_page_id=>860
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(194188915515325710)
,p_parent_id=>wwv_flow_imp.id(194564807352908073)
,p_short_name=>'Branches by Page'
,p_link=>'f?p=&APP_ID.:563:&SESSION.::&DEBUG.:::'
,p_page_id=>563
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(194204902902418301)
,p_parent_id=>wwv_flow_imp.id(193869708580501594)
,p_short_name=>'Conditional'
,p_link=>'f?p=&APP_ID.:864:&SESSION.::&DEBUG.:::'
,p_page_id=>864
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(194240024554788875)
,p_parent_id=>wwv_flow_imp.id(193856726464283476)
,p_short_name=>'Conditional'
,p_link=>'f?p=&APP_ID.:866:&SESSION.::&DEBUG.:::'
,p_page_id=>866
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(194518712088362500)
,p_parent_id=>wwv_flow_imp.id(193915914105228860)
,p_short_name=>'Conditional'
,p_link=>'f?p=&APP_ID.:869:&SESSION.::&DEBUG.:::'
,p_page_id=>869
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(194534516750486783)
,p_parent_id=>wwv_flow_imp.id(193687816503601756)
,p_short_name=>'Conditional'
,p_link=>'f?p=&APP_ID.:877:&SESSION.::&DEBUG.:::'
,p_page_id=>877
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(194550309891571022)
,p_parent_id=>wwv_flow_imp.id(193782110098056426)
,p_short_name=>'Conditional'
,p_link=>'f?p=&APP_ID.:878:&SESSION.::&DEBUG.:::'
,p_page_id=>878
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(194564807352908073)
,p_parent_id=>wwv_flow_imp.id(177829529391401676)
,p_short_name=>'Branch Utilities'
,p_link=>'f?p=&APP_ID.:881:&SESSION.::&DEBUG.:::'
,p_page_id=>881
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(194571017770949039)
,p_parent_id=>wwv_flow_imp.id(193766813255904989)
,p_short_name=>'Conditional'
,p_link=>'f?p=&APP_ID.:883:&SESSION.::&DEBUG.:::'
,p_page_id=>883
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(194580430162010948)
,p_parent_id=>wwv_flow_imp.id(194564807352908073)
,p_short_name=>'Conditional'
,p_link=>'f?p=&APP_ID.:885:&SESSION.::&DEBUG.:::'
,p_page_id=>885
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(194634117689659288)
,p_parent_id=>wwv_flow_imp.id(193869708580501594)
,p_short_name=>'Regions by Type'
,p_link=>'f?p=&APP_ID.:136:&SESSION.::&DEBUG.:::'
,p_page_id=>136
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(194857168593967619)
,p_parent_id=>wwv_flow_imp.id(6342315964532655)
,p_short_name=>'Page &FB_FLOW_PAGE_ID.'
,p_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID:&FB_FLOW_ID.,&FB_FLOW_PAGE_ID.'
,p_page_id=>4500
,p_display_when_cond_type=>'CURRENT_PAGE_NOT_EQUAL_CONDITION'
,p_display_when_condition=>'4500'
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(196190910831857780)
,p_parent_id=>wwv_flow_imp.id(6342315964532655)
,p_short_name=>'Create Page'
,p_link=>'f?p=&FLOW_ID.:849:&SESSION.'
,p_page_id=>849
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(200451015171287637)
,p_parent_id=>wwv_flow_imp.id(699056895544610173)
,p_short_name=>'APEX Views'
,p_link=>'f?p=&APP_ID.:714:&SESSION.::&DEBUG.:::'
,p_page_id=>714
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(200456909973365514)
,p_parent_id=>wwv_flow_imp.id(200451015171287637)
,p_short_name=>'Select Columns'
,p_link=>'f?p=&APP_ID.:892:&SESSION.::&DEBUG.:::'
,p_page_id=>892
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(200560105669886915)
,p_parent_id=>wwv_flow_imp.id(200451015171287637)
,p_short_name=>'Filter'
,p_link=>'f?p=&APP_ID.:893:&SESSION.::&DEBUG.:::'
,p_page_id=>893
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(200567620998923812)
,p_parent_id=>wwv_flow_imp.id(200451015171287637)
,p_short_name=>'Results'
,p_link=>'f?p=&APP_ID.:896:&SESSION.::&DEBUG.:::'
,p_page_id=>896
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(200898422299282402)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Copy Page'
,p_link=>'f?p=&FLOW_ID.:618:&SESSION.'
,p_page_id=>618
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(200901232195308145)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Copy Page'
,p_link=>'f?p=&FLOW_ID.:621:&SESSION.'
,p_page_id=>621
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(200902429176309509)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Copy Page'
,p_link=>'f?p=&FLOW_ID.:622:&SESSION.'
,p_page_id=>622
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(200903626372310872)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Copy Page'
,p_link=>'f?p=&FLOW_ID.:623:&SESSION.'
,p_page_id=>623
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(201141118631650761)
,p_parent_id=>wwv_flow_imp.id(699056895544610173)
,p_short_name=>'APEX Views'
,p_link=>'f?p=&APP_ID.:905:&SESSION.::&DEBUG.:::'
,p_page_id=>905
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(201355804967508727)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Copy Page'
,p_link=>'f?p=&FLOW_ID.:625:&SESSION.'
,p_page_id=>625
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(201379522121622319)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Copy Page'
,p_link=>'f?p=&FLOW_ID.:627:&SESSION.'
,p_page_id=>627
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(203484913118434124)
,p_parent_id=>wwv_flow_imp.id(6795302837254265)
,p_short_name=>'Copy'
,p_link=>'f?p=&APP_ID.:477:&SESSION.::&DEBUG.:::'
,p_page_id=>477
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(203514430081517401)
,p_parent_id=>wwv_flow_imp.id(6795302837254265)
,p_short_name=>'Copy'
,p_link=>'f?p=&APP_ID.:478:&SESSION.::&DEBUG.:::'
,p_page_id=>478
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(203819226726711009)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Copy Page'
,p_link=>'f?p=&FLOW_ID.:628:&SESSION.'
,p_page_id=>628
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(204122928382059758)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Copy Page'
,p_link=>'f?p=&FLOW_ID.:671:&SESSION.'
,p_page_id=>671
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(205094930753634778)
,p_parent_id=>wwv_flow_imp.id(162360425664871103)
,p_short_name=>'Build Status and Application Status'
,p_link=>'f?p=&APP_ID.:103:&SESSION.::&DEBUG.:::'
,p_page_id=>103
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(205099108540645099)
,p_short_name=>'Breadcrumb'
,p_link=>'f?p=&FLOW_ID.:465:&SESSION.'
,p_page_id=>465
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(205279003609407006)
,p_parent_id=>wwv_flow_imp.id(205094930753634778)
,p_short_name=>'Edit Build Status'
,p_link=>'f?p=&APP_ID.:467:&SESSION.::&DEBUG.:::'
,p_page_id=>467
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(205875316195651101)
,p_parent_id=>wwv_flow_imp.id(6342315964532655)
,p_short_name=>'Export'
,p_link=>'f?p=&APP_ID.:688:&SESSION.::&DEBUG.:::'
,p_page_id=>688
,p_display_when_cond_type=>'ITEM_IS_NOT_NULL'
,p_display_when_condition=>'FB_FLOW_ID'
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(208025501375807758)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Copy Page'
,p_link=>'f?p=&FLOW_ID.:593:&SESSION.'
,p_page_id=>593
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(209921323872407276)
,p_parent_id=>wwv_flow_imp.id(1308911481947279)
,p_short_name=>'Install Application Components'
,p_link=>'f?p=&APP_ID.:598:&SESSION.::&DEBUG.:::'
,p_page_id=>598
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(212276525707666019)
,p_parent_id=>wwv_flow_imp.id(6342315964532655)
,p_short_name=>'Install Application'
,p_link=>'f?p=&FLOW_ID.:2116:&SESSION.'
,p_page_id=>2116
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(212832024367160609)
,p_parent_id=>wwv_flow_imp.id(177829529391401676)
,p_short_name=>'Page Groups'
,p_link=>'f?p=&APP_ID.:520:&SESSION.::&DEBUG.:::'
,p_page_id=>520
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(212878912813317924)
,p_parent_id=>wwv_flow_imp.id(212832024367160609)
,p_short_name=>'Page Group'
,p_link=>'f?p=&APP_ID.:521:&SESSION.::&DEBUG.:::'
,p_page_id=>521
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(212936631655476340)
,p_parent_id=>wwv_flow_imp.id(177829529391401676)
,p_short_name=>'Page Group Assignments'
,p_link=>'f?p=&APP_ID.:522:&SESSION.::&DEBUG.:::'
,p_page_id=>522
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(213314913518106173)
,p_parent_id=>wwv_flow_imp.id(177829529391401676)
,p_short_name=>'Pages by Page Group'
,p_link=>'f?p=&APP_ID.:528:&SESSION.::&DEBUG.:::'
,p_page_id=>528
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(217586628504429796)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Developer Comments Calendar'
,p_link=>'f?p=&APP_ID.:594:&SESSION.::&DEBUG.:::'
,p_page_id=>594
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(217721100387894207)
,p_parent_id=>wwv_flow_imp.id(162360425664871103)
,p_short_name=>'Developer Comments Calendar'
,p_link=>'f?p=&APP_ID.:665:&SESSION.::&DEBUG.:::'
,p_page_id=>665
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(218850916548983451)
,p_parent_id=>wwv_flow_imp.id(6661610099511746)
,p_short_name=>'Install Static Files'
,p_link=>'f?p=&APP_ID.:612:&SESSION.::&DEBUG.:::'
,p_page_id=>612
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(219158611394417994)
,p_parent_id=>wwv_flow_imp.id(1308911481947279)
,p_short_name=>'Install Application'
,p_link=>'f?p=&APP_ID.:2117:&SESSION.::&DEBUG.:::'
,p_page_id=>2117
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(221168815878138814)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Breadcrumbs'
,p_link=>'f?p=&APP_ID.:546:&SESSION.::&DEBUG.:::'
,p_page_id=>546
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(221229216805384320)
,p_parent_id=>wwv_flow_imp.id(193915914105228860)
,p_short_name=>'Page Items'
,p_link=>'f?p=&APP_ID.:547:&SESSION.::&DEBUG.:::'
,p_page_id=>547
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(222588214943495167)
,p_parent_id=>wwv_flow_imp.id(193782110098056426)
,p_short_name=>'Page Buttons'
,p_link=>'f?p=&APP_ID.:548:&SESSION.::&DEBUG.:::'
,p_page_id=>548
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(222848520344127566)
,p_short_name=>'Copy Template'
,p_link=>'f?p=&APP_ID.:584:&SESSION.::&DEBUG.:::'
,p_page_id=>584
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(222852405462198957)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Copy Template'
,p_link=>'f?p=&APP_ID.:568:&SESSION.::&DEBUG.:::'
,p_page_id=>568
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(223171208059454358)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Copy Template'
,p_link=>'f?p=&FLOW_ID.:636:&SESSION.'
,p_page_id=>636
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(224101606989701160)
,p_parent_id=>wwv_flow_imp.id(9594412395161749)
,p_short_name=>'Cached Pages'
,p_link=>'f?p=&APP_ID.:638:&SESSION.::&DEBUG.:::'
,p_page_id=>638
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(224247219739285835)
,p_parent_id=>wwv_flow_imp.id(193687816503601756)
,p_short_name=>'Computations By Page'
,p_link=>'f?p=&APP_ID.:549:&SESSION.::&DEBUG.:::'
,p_page_id=>549
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(225314227644373359)
,p_parent_id=>wwv_flow_imp.id(193856726464283476)
,p_short_name=>'Processes by Page'
,p_link=>'f?p=&APP_ID.:552:&SESSION.::&DEBUG.:::'
,p_page_id=>552
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(225891858843186075)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'REST Data Sources'
,p_link=>'f?p=&APP_ID.:1901:&SESSION.::&DEBUG.:::'
,p_page_id=>1901
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(225892393724191781)
,p_parent_id=>wwv_flow_imp.id(225891858843186075)
,p_short_name=>'&P1921_BREADCRUMB_NAME.'
,p_link=>'f?p=&APP_ID.:1921:&SESSION.::&DEBUG.:::'
,p_page_id=>1921
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(229167313944963222)
,p_parent_id=>wwv_flow_imp.id(225892393724191781)
,p_short_name=>'Data Profile'
,p_link=>'f?p=&APP_ID.:1925:&SESSION.::&DEBUG.:::'
,p_page_id=>1925
,p_display_when_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_condition=>'P1925_IS_WEB_SRC_PROFILE'
,p_display_when_condition2=>'Y'
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(229198344371064517)
,p_parent_id=>wwv_flow_imp.id(225892393724191781)
,p_short_name=>'Operation'
,p_link=>'f?p=&APP_ID.:1922:&SESSION.::&DEBUG.:::'
,p_page_id=>1922
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(231172611880791231)
,p_parent_id=>wwv_flow_imp.id(16773830395421252)
,p_short_name=>'Copy'
,p_link=>'f?p=&APP_ID.:663:&SESSION.::&DEBUG.:::'
,p_page_id=>663
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(231334612269180150)
,p_parent_id=>wwv_flow_imp.id(6342315964532655)
,p_short_name=>'Application Installed'
,p_link=>'f?p=&FLOW_ID.:2140:&SESSION.'
,p_page_id=>2140
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(232926602436928559)
,p_parent_id=>wwv_flow_imp.id(193869708580501594)
,p_short_name=>'Edit Region Titles'
,p_link=>'f?p=&APP_ID.:438:&SESSION.::&DEBUG.:::'
,p_page_id=>438
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(236298214357728332)
,p_parent_id=>wwv_flow_imp.id(154028932045622478)
,p_short_name=>'Utilization'
,p_link=>'f?p=&APP_ID.:1602:&SESSION.::&DEBUG.:::'
,p_page_id=>1602
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(236543116135568980)
,p_parent_id=>wwv_flow_imp.id(22464532161251314)
,p_short_name=>'Resequence Installation Scripts'
,p_link=>'f?p=&APP_ID.:802:&SESSION.::&DEBUG.:::'
,p_page_id=>802
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(240164301523392650)
,p_parent_id=>wwv_flow_imp.id(1308911481947279)
,p_short_name=>'Create Application'
,p_link=>'f?p=&APP_ID.:433:&SESSION.::&DEBUG.:::'
,p_page_id=>433
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(241361771869873980)
,p_parent_id=>wwv_flow_imp.id(225891858843186075)
,p_short_name=>'Utilization'
,p_link=>'f?p=&APP_ID.:1902:&SESSION.'
,p_page_id=>1902
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(242224030662625650)
,p_parent_id=>wwv_flow_imp.id(229198344371064517)
,p_short_name=>'Test Results'
,p_link=>'f?p=&APP_ID.:1927:&SESSION.::&DEBUG.:::'
,p_page_id=>1927
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(242513213859156159)
,p_parent_id=>wwv_flow_imp.id(193766813255904989)
,p_short_name=>'Validations by Page'
,p_link=>'f?p=&APP_ID.:501:&SESSION.::&DEBUG.:::'
,p_page_id=>501
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(247673724692352491)
,p_parent_id=>wwv_flow_imp.id(225891858843186075)
,p_short_name=>'Create REST Data Source - Method'
,p_link=>'f?p=&APP_ID.:1905:&SESSION.::&DEBUG.:::'
,p_page_id=>1905
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(247685482384424709)
,p_parent_id=>wwv_flow_imp.id(225891858843186075)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:1906:&SESSION.'
,p_page_id=>1906
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(247700619009474725)
,p_parent_id=>wwv_flow_imp.id(225891858843186075)
,p_short_name=>'Copy'
,p_link=>'f?p=&APP_ID.:1907:&SESSION.'
,p_page_id=>1907
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(247792552823343318)
,p_parent_id=>wwv_flow_imp.id(225891858843186075)
,p_short_name=>'History'
,p_link=>'f?p=&APP_ID.:1903:&SESSION.'
,p_page_id=>1903
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(249343822808868772)
,p_parent_id=>wwv_flow_imp.id(154028932045622478)
,p_short_name=>'Create from Scratch'
,p_link=>'f?p=&APP_ID.:1615:&SESSION.'
,p_page_id=>1615
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(249362552874932995)
,p_parent_id=>wwv_flow_imp.id(154028932045622478)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:1616:&SESSION.'
,p_page_id=>1616
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(253963607633373765)
,p_parent_id=>wwv_flow_imp.id(177829529391401676)
,p_short_name=>'Attribute Dictionary'
,p_link=>'f?p=&APP_ID.:889:&SESSION.::&DEBUG.:::'
,p_page_id=>889
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(254017812776206966)
,p_parent_id=>wwv_flow_imp.id(428271320102552345)
,p_short_name=>'Update using Items'
,p_link=>'f?p=&APP_ID.:890:&SESSION.::&DEBUG.:::'
,p_page_id=>890
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(257001006001664029)
,p_parent_id=>wwv_flow_imp.id(428271320102552345)
,p_short_name=>'Update Attribute Dictionary'
,p_link=>'f?p=&APP_ID.:906:&SESSION.::&DEBUG.:::'
,p_page_id=>906
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(257126724392643061)
,p_parent_id=>wwv_flow_imp.id(428271320102552345)
,p_short_name=>'Update Attribute Dictionary'
,p_link=>'f?p=&APP_ID.:907:&SESSION.::&DEBUG.:::'
,p_page_id=>907
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(257310231384323421)
,p_parent_id=>wwv_flow_imp.id(428271320102552345)
,p_short_name=>'Update using Report Columns'
,p_link=>'f?p=&APP_ID.:897:&SESSION.::&DEBUG.:::'
,p_page_id=>897
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(274110007727705515)
,p_short_name=>'User Interface'
,p_link=>'f?p=&APP_ID.:1207:&SESSION.'
,p_page_id=>1207
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(275501504241784015)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Confirm Delete of Report Template'
,p_link=>'f?p=&APP_ID.:505:&SESSION.::&DEBUG.:::'
,p_page_id=>505
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(294926122622741686)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Create Label Template'
,p_link=>'f?p=&APP_ID.:353:&SESSION.::&DEBUG.:::'
,p_page_id=>353
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(307837328746538120)
,p_short_name=>'Data Loading'
,p_link=>'f?p=&APP_ID.:1706:&SESSION.::&DEBUG.:::'
,p_page_id=>1706
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(309903827724755760)
,p_parent_id=>wwv_flow_imp.id(699056895544610173)
,p_short_name=>'Remote Servers'
,p_link=>'f?p=&APP_ID.:1931:&SESSION.::&DEBUG.:::'
,p_page_id=>1931
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(327358221301817083)
,p_short_name=>'Synchronize Column Order with Region Source'
,p_link=>'f?p=&APP_ID.:276:&SESSION.::&DEBUG.:::'
,p_page_id=>276
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(327665506273148385)
,p_parent_id=>wwv_flow_imp.id(28660023095978630)
,p_short_name=>'Grid Edit'
,p_link=>'f?p=&APP_ID.:891:&SESSION.::&DEBUG.:891::'
,p_page_id=>891
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(366556404137741695)
,p_parent_id=>wwv_flow_imp.id(59091202259431920)
,p_short_name=>'Theme Styles'
,p_link=>'f?p=&FLOW_ID.:177:&SESSION.'
,p_page_id=>177
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(380041921403746617)
,p_parent_id=>wwv_flow_imp.id(24448222218694942)
,p_short_name=>'Resequence Upgrade Scripts'
,p_link=>'f?p=&APP_ID.:38:&SESSION.::&DEBUG.:::'
,p_page_id=>38
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(386913179276970625)
,p_short_name=>'Global Page'
,p_link=>'f?p=&FLOW_ID.:0:&SESSION.'
,p_page_id=>0
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(394075449806720627)
,p_parent_id=>wwv_flow_imp.id(22464532161251314)
,p_short_name=>'SQL Script'
,p_link=>'f?p=&APP_ID.:432:&SESSION.::&DEBUG.:::'
,p_page_id=>432
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(403370909018934213)
,p_parent_id=>wwv_flow_imp.id(24448222218694942)
,p_short_name=>'Script'
,p_link=>'f?p=&APP_ID.:457:&SESSION.::&DEBUG.:::'
,p_page_id=>457
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(403372480392000869)
,p_parent_id=>wwv_flow_imp.id(22494629499343773)
,p_short_name=>'Script'
,p_link=>'f?p=&APP_ID.:462:&SESSION.::&DEBUG.:::'
,p_page_id=>462
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(427745549021846101)
,p_parent_id=>wwv_flow_imp.id(6342315964532655)
,p_short_name=>'Search Application Pages'
,p_link=>'f?p=&APP_ID.:33:&SESSION.::&DEBUG.:::'
,p_page_id=>33
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(428271320102552345)
,p_parent_id=>wwv_flow_imp.id(194857168593967619)
,p_short_name=>'Attribute Dictionary'
,p_link=>'f?p=&APP_ID.:912:&SESSION.::&DEBUG.:::'
,p_page_id=>912
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(444637522100159006)
,p_parent_id=>wwv_flow_imp.id(177829529391401676)
,p_short_name=>'Upgrade Application'
,p_link=>'f?p=&APP_ID.:89:&SESSION.::&DEBUG.:::'
,p_page_id=>89
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(445531401578394152)
,p_parent_id=>wwv_flow_imp.id(193869708580501594)
,p_short_name=>'Edit Interactive Report Column Headings'
,p_link=>'f?p=&FLOW_ID.:690:&SESSION.'
,p_page_id=>690
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(446031725196062481)
,p_parent_id=>wwv_flow_imp.id(428271320102552345)
,p_short_name=>'Update Items'
,p_link=>'f?p=&FLOW_ID.:921:&SESSION.'
,p_page_id=>921
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(446120818406960365)
,p_parent_id=>wwv_flow_imp.id(428271320102552345)
,p_short_name=>'Update Report Columns'
,p_link=>'f?p=&FLOW_ID.:922:&SESSION.'
,p_page_id=>922
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(450480426634467558)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Tabs'
,p_link=>'f?p=&APP_ID.:643:&SESSION.::&DEBUG.:::'
,p_page_id=>643
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(451217904250711518)
,p_parent_id=>wwv_flow_imp.id(623973113062360507)
,p_short_name=>'Debug Message Data'
,p_link=>'f?p=&APP_ID.:938:&SESSION.::&DEBUG.:::'
,p_page_id=>938
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(451363105591759348)
,p_parent_id=>wwv_flow_imp.id(193869708580501594)
,p_short_name=>'Update Interactive Report Settings'
,p_link=>'f?p=&APP_ID.:940:&SESSION.::&DEBUG.:::'
,p_page_id=>940
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(459820809191755570)
,p_parent_id=>wwv_flow_imp.id(444637522100159006)
,p_short_name=>'Upgrade'
,p_link=>'f?p=&APP_ID.:911:&SESSION.::&DEBUG.:::'
,p_page_id=>911
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(472187826172691526)
,p_parent_id=>wwv_flow_imp.id(1308911481947279)
,p_short_name=>'Export'
,p_link=>'f?p=&APP_ID.:689:&SESSION.::&DEBUG.:::'
,p_page_id=>689
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(472557222703196880)
,p_parent_id=>wwv_flow_imp.id(1308911481947279)
,p_short_name=>'Search Applications'
,p_link=>'f?p=&APP_ID.:69:&SESSION.::&DEBUG.:RP::'
,p_page_id=>69
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(472703113122672343)
,p_parent_id=>wwv_flow_imp.id(45432327870093655)
,p_short_name=>'Import Feedback'
,p_link=>'f?p=&FLOW_ID.:929:&SESSION.'
,p_page_id=>929
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(477698219810900844)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Copy Template'
,p_link=>'f?p=&APP_ID.:574:&SESSION.::&DEBUG.:::'
,p_page_id=>574
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(477728918687919422)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Copy Template'
,p_link=>'f?p=&APP_ID.:564:&SESSION.::&DEBUG.:::'
,p_page_id=>564
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(477729623320930173)
,p_parent_id=>wwv_flow_imp.id(6348417766566072)
,p_short_name=>'Copy Template'
,p_link=>'f?p=&APP_ID.:571:&SESSION.::&DEBUG.:::'
,p_page_id=>571
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(480498430720969430)
,p_parent_id=>wwv_flow_imp.id(107237015875905749)
,p_short_name=>'Invalidate Bookmarks'
,p_link=>'f?p=&APP_ID.:517:&SESSION.::&DEBUG.:::'
,p_page_id=>517
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(484013427405581669)
,p_parent_id=>wwv_flow_imp.id(444637522100159006)
,p_short_name=>'Upgrade'
,p_link=>'f?p=&APP_ID.:86:&SESSION.::&DEBUG.:::'
,p_page_id=>86
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(486423714718175502)
,p_parent_id=>wwv_flow_imp.id(1308911481947279)
,p_short_name=>'Export'
,p_link=>'f?p=&APP_ID.:541:&SESSION.::&DEBUG.:::'
,p_page_id=>541
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(492050414626710006)
,p_parent_id=>wwv_flow_imp.id(444637522100159006)
,p_short_name=>'Upgrade'
,p_link=>'f?p=&APP_ID.:646:&SESSION.::&DEBUG.:::'
,p_page_id=>646
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(492636106117616338)
,p_parent_id=>wwv_flow_imp.id(177829529391401676)
,p_short_name=>'Cross Page Utilities'
,p_link=>'f?p=&APP_ID.:553:&SESSION.::&DEBUG.:::'
,p_page_id=>553
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(495865506686956046)
,p_parent_id=>wwv_flow_imp.id(444637522100159006)
,p_short_name=>'Upgrade'
,p_link=>'f?p=&APP_ID.:383:&SESSION.::&DEBUG.:::'
,p_page_id=>383
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(533149940857152602)
,p_parent_id=>wwv_flow_imp.id(309903827724755760)
,p_short_name=>'Utilization'
,p_link=>'f?p=&APP_ID.:1933:&SESSION.::&DEBUG.:::'
,p_page_id=>1933
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(533184927171295694)
,p_parent_id=>wwv_flow_imp.id(309903827724755760)
,p_short_name=>'History'
,p_link=>'f?p=&APP_ID.:1934:&SESSION.'
,p_page_id=>1934
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(564744424516402988)
,p_parent_id=>wwv_flow_imp.id(225891858843186075)
,p_short_name=>'Synchronizations'
,p_link=>'f?p=&APP_ID.:1955:&SESSION.::&DEBUG.:::'
,p_page_id=>1955
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(577470581050015566)
,p_parent_id=>wwv_flow_imp.id(177829529391401676)
,p_short_name=>'Font APEX'
,p_link=>'f?p=&APP_ID.:110:&SESSION.::&DEBUG.:::'
,p_page_id=>110
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(584640985236978343)
,p_parent_id=>wwv_flow_imp.id(799613605926722)
,p_short_name=>'Create Script - Select Objects'
,p_link=>'f?p=&APP_ID.:858:&SESSION.'
,p_page_id=>858
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(597508154994597521)
,p_parent_id=>wwv_flow_imp.id(177829529391401676)
,p_short_name=>'Page Checksum Report'
,p_link=>'f?p=&APP_ID.:111:&APP_SESSION.::&DEBUG.:::'
,p_page_id=>111
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(623973113062360507)
,p_parent_id=>wwv_flow_imp.id(177829529391401676)
,p_short_name=>'Debug Messages'
,p_link=>'f?p=&APP_ID.:666:&SESSION.::&DEBUG.:::'
,p_page_id=>666
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(624021011236959577)
,p_parent_id=>wwv_flow_imp.id(623973113062360507)
,p_short_name=>'Purge Debug Messages'
,p_link=>'f?p=&APP_ID.:748:&SESSION.::&DEBUG.:::'
,p_page_id=>748
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(631170709627388717)
,p_parent_id=>wwv_flow_imp.id(6356205677586897)
,p_short_name=>'Utilization'
,p_link=>'f?p=&FLOW_ID.:87:&SESSION.'
,p_page_id=>87
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(631612905189532653)
,p_parent_id=>wwv_flow_imp.id(444637522100159006)
,p_short_name=>'Upgrade Application'
,p_link=>'f?p=&FLOW_ID.:862:&SESSION.'
,p_page_id=>862
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(659464448337551065)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Application Settings'
,p_link=>'f?p=&APP_ID.:4850:&SESSION.'
,p_page_id=>4850
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(659500903805635280)
,p_parent_id=>wwv_flow_imp.id(659464448337551065)
,p_short_name=>'Details'
,p_link=>'f?p=&APP_ID.:4851:&SESSION.::&DEBUG.:::'
,p_page_id=>4851
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(680963074297437695)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Email Templates'
,p_link=>'f?p=&APP_ID.:4860:&SESSION.'
,p_page_id=>4860
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(681164084121866571)
,p_parent_id=>wwv_flow_imp.id(680963074297437695)
,p_short_name=>'Details'
,p_link=>'f?p=&APP_ID.:4861:&SESSION.::&DEBUG.:::'
,p_page_id=>4861
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(687109918814982030)
,p_parent_id=>wwv_flow_imp.id(59091202259431920)
,p_short_name=>'Template Option Groups'
,p_link=>'f?p=&APP_ID.:81:&SESSION.::&DEBUG.:::'
,p_page_id=>81
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(693288905982721697)
,p_parent_id=>wwv_flow_imp.id(95667010592946781)
,p_short_name=>'Table Lookups'
,p_link=>'f?p=&APP_ID.:1802:&SESSION.::&DEBUG.:::'
,p_page_id=>1802
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(699056895544610173)
,p_parent_id=>wwv_flow_imp.id(1308911481947279)
,p_short_name=>'Workspace Utilities'
,p_link=>'f?p=&APP_ID.:182:&SESSION.::&DEBUG.:::'
,p_page_id=>182
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(715723076367144322)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Application Access Control'
,p_link=>'f?p=&APP_ID.:2300:&SESSION.::&DEBUG.:::'
,p_page_id=>2300
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(740988995699531167)
,p_parent_id=>wwv_flow_imp.id(6735531807989290)
,p_short_name=>'Themes'
,p_link=>'f?p=&FLOW_ID.:260:&SESSION.'
,p_page_id=>260
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(787143871474093343)
,p_parent_id=>wwv_flow_imp.id(1308911481947279)
,p_short_name=>'Dashboard'
,p_link=>'f?p=&APP_ID.:160:&SESSION.'
,p_page_id=>160
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(857797331467455145)
,p_short_name=>'Edit Region Column'
,p_link=>'f?p=&APP_ID.:4486:&SESSION.'
,p_page_id=>4486
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(857902555832260947)
,p_parent_id=>wwv_flow_imp.id(799613605926722)
,p_short_name=>'Lock Script'
,p_link=>'f?p=&APP_ID.:16:&SESSION.::&DEBUG.:::'
,p_page_id=>16
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(936713755243179424)
,p_short_name=>'Create Calendar & Form'
,p_link=>'f?p=&APP_ID.:234:&SESSION.'
,p_page_id=>234
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(936743079352383003)
,p_short_name=>'Create Calendar & Form'
,p_link=>'f?p=&APP_ID.:274:&SESSION.'
,p_page_id=>274
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(1141854268573856037)
,p_parent_id=>wwv_flow_imp.id(36775909817926063)
,p_short_name=>'Edit Item Help'
,p_link=>'f?p=&APP_ID.:390:&SESSION.::&DEBUG.:::'
,p_page_id=>390
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(1146699911367401673)
,p_parent_id=>wwv_flow_imp.id(36775909817926063)
,p_short_name=>'Publish Item Help'
,p_link=>'f?p=&APP_ID.:449:&SESSION.::&DEBUG.:::'
,p_page_id=>449
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(1433725849092861525)
,p_parent_id=>wwv_flow_imp.id(740988995699531167)
,p_short_name=>'Restore Theme Subscription'
,p_link=>'f?p=&APP_ID.:117:&SESSION.'
,p_page_id=>117
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(1434105149541321464)
,p_parent_id=>wwv_flow_imp.id(27799320681844329)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:4402:&SESSION.::&DEBUG.:::'
,p_page_id=>4402
,p_display_when_cond_type=>'ITEM_IS_NULL'
,p_display_when_condition=>'P4402_FOR_THEME'
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(1434160321580350908)
,p_parent_id=>wwv_flow_imp.id(27799320681844329)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:4404:&SESSION.::&DEBUG.:::'
,p_page_id=>4404
,p_display_when_cond_type=>'ITEM_IS_NULL'
,p_display_when_condition=>'P4404_FOR_THEME'
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(1434164955894375409)
,p_parent_id=>wwv_flow_imp.id(27799320681844329)
,p_short_name=>'Create'
,p_link=>'f?p=&APP_ID.:4406:&SESSION.::&DEBUG.:::'
,p_page_id=>4406
,p_display_when_cond_type=>'ITEM_IS_NULL'
,p_display_when_condition=>'P4406_COPY_TO_THEME_ID'
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(3801099868410190)
,p_parent_id=>wwv_flow_imp.id(27799320681844329)
,p_option_sequence=>20
,p_short_name=>'Edit'
,p_link=>'f?p=&APP_ID.:4410:&SESSION.::&DEBUG.:4410:P4410_ID,FB_FLOW_ID:&P4410_ID.,&FB_FLOW_ID.'
,p_page_id=>4410
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P4410_ID is not null and :P4410_THEME_ID is null'
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(3600263368521940)
,p_parent_id=>wwv_flow_imp.id(27799320681844329)
,p_option_sequence=>30
,p_short_name=>'&G_BC_PARENT_LABEL!HTML.'
,p_link=>'&G_BC_PARENT_URL.'
,p_page_id=>4410
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P118_SCOPE = ''PLUGIN'''
,p_display_when_condition2=>'PLSQL'
);
wwv_flow_imp_shared.create_menu_option(
 p_id=>wwv_flow_imp.id(3803609664693374)
,p_parent_id=>wwv_flow_imp.id(740988995699531167)
,p_option_sequence=>30
,p_short_name=>'&G_BC_PARENT_LABEL!HTML.'
,p_link=>'&G_BC_PARENT_URL.'
,p_page_id=>267
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P118_SCOPE = ''THEME'''
,p_display_when_condition2=>'PLSQL'
);
end;
/
prompt --application/shared_components/navigation/breadcrumbentry
begin
null;
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_restful_web_services
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(4868606398075172)
,p_theme_id=>3
,p_name=>'[x] APEX 5.0 - RESTful Web Services'
,p_internal_name=>'APEX_5.0_RESTFUL_WEB_SERVICES'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'</head>',
'<body #ONLOAD# class="a-Page--webservices #PAGE_CSS_CLASSES#">',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'<a href="#main" id="a_Body_skipToContent">&APP_TEXT$UI_PAGE_SKIP_TO_CONTENT.</a>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<header>',
'    #REGION_POSITION_07#',
'    </header>',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'  <div id="main" class="a-Body">',
'    <aside class="a-Side a-Side--left a-Side--large">',
'        #REGION_POSITION_03#',
'    </aside>',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-user" aria-label="&MSG_USER." title="&MSG_USER.">',
'        <span class="u-vh">&MSG_USER.</span>',
'      </span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-workspace" aria-label="&MSG_WORKSPACE." title="&MSG_WORKSPACE.">',
'        <span class="u-vh">&MSG_WORKSPACE.</span>',
'      </span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-language" aria-label="&MSG_LANGUAGE." title="&MSG_LANGUAGE.">',
'        <span class="u-vh">&MSG_LANGUAGE.</span>',
'      </span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg" role="region" aria-labelledby="page_success_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.SUCCESS"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_success_id" class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg" role="region" aria-labelledby="page_warning_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.WARNING"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_warning_id" class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>754942495369044641
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(2587515033067779)
,p_page_template_id=>wwv_flow_imp.id(4868606398075172)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(2588068625067779)
,p_page_template_id=>wwv_flow_imp.id(4868606398075172)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(2588598647067780)
,p_page_template_id=>wwv_flow_imp.id(4868606398075172)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(2589061556067780)
,p_page_template_id=>wwv_flow_imp.id(4868606398075172)
,p_name=>'Left Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(2589536279067780)
,p_page_template_id=>wwv_flow_imp.id(4868606398075172)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(2590075250067780)
,p_page_template_id=>wwv_flow_imp.id(4868606398075172)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(2590595383067780)
,p_page_template_id=>wwv_flow_imp.id(4868606398075172)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_4_2_popup
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(19943204431962826)
,p_theme_id=>3
,p_name=>'[x] APEX 4.2 - Popup'
,p_internal_name=>'APEX_4.2_POPUP'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title><link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'</head><body #ONLOAD# style="min-width:380px;"><noscript>&MSG_JSCRIPT.</noscript>#FORM_OPEN#<a name="PAGETOP"></a>'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="htmldbMessageHolder">#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#</div>',
'<div>',
'  <div id="RP2">#REGION_POSITION_02#</div>',
'  <div id="RP3">#REGION_POSITION_03#</div>',
'  <div id="RP4">#REGION_POSITION_04#</div>',
'  <div id="RP5">#REGION_POSITION_05#</div>',
'  <div class="popupContent" id="ContentArea">#BODY#</div>',
'</div>',
'<div id="RP8" style="text-align:middle;">#REGION_POSITION_08#</div>',
'<br />',
'<br />',
''))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification success" id="MESSAGE">',
'  <div class="aNotificationText">',
'    <h2 class="visuallyhidden" role="alert">#SUCCESS_MESSAGE_HEADING#</h2>',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium success"/>',
'    <p>#SUCCESS_MESSAGE#</p>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aNotification warning" id="MESSAGE">',
'  <div class="aNotificationText">',
'    <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" class="iconMedium warning"/>',
'    <div class="warningMessage">',
'      <h2 class="visuallyhidden">#ERROR_MESSAGE_HEADING#</h2>',
'      #MESSAGE#',
'    </div>',
'    <a href="#" class="closeMessage" onclick="$x_Remove(''MESSAGE'');return false;"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#CLOSE_NOTIFICATION#" class="iconSmall close"/></a>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<br />',
'<br />',
'<pre>#MESSAGE#</pre>',
'<a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a>'))
,p_grid_type=>'TABLE'
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_always_emit=>true
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>36144306570651063
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(72506438607978226)
,p_page_template_id=>wwv_flow_imp.id(19943204431962826)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(72506951228978227)
,p_page_template_id=>wwv_flow_imp.id(19943204431962826)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(72507496925978227)
,p_page_template_id=>wwv_flow_imp.id(19943204431962826)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(72507968865978228)
,p_page_template_id=>wwv_flow_imp.id(19943204431962826)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(72508423335978228)
,p_page_template_id=>wwv_flow_imp.id(19943204431962826)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(72508915454978229)
,p_page_template_id=>wwv_flow_imp.id(19943204431962826)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_dialog
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(120871216744825711)
,p_theme_id=>3
,p_name=>'[x] APEX 5.0 - Dialog'
,p_internal_name=>'APEX_5.0_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>'apex.builder.initWizardModal();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog" role="dialog" aria-label="#TITLE#">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg" role="region" aria-labelledby="page_success_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.SUCCESS"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_success_id" class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg" role="region" aria-labelledby="page_warning_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.WARNING"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_warning_id" class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,baseDialogClass:''a-Dialog--uiDialog'',dialogClass:#DIALOG_CSS_CLASSES#,jsDialogClass:true,#DIALOG'
||'_ATTRIBUTES#},#PAGE_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>120828417372192930
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293476250529977308)
,p_page_template_id=>wwv_flow_imp.id(120871216744825711)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293476700225977309)
,p_page_template_id=>wwv_flow_imp.id(120871216744825711)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293477250278977309)
,p_page_template_id=>wwv_flow_imp.id(120871216744825711)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_page_designer
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(384711093594980574)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Page Designer'
,p_internal_name=>'APEX_5.0_PAGE_DESIGNER'
,p_is_popup=>false
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ( apex.jQuery( "#successMessage" ).length > 0 ) {',
'    window.pageDesigner.showNotification( apex.jQuery( "#successMessage" ).text() );',
'}'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'</head>',
'<body #ONLOAD# class="#PAGE_CSS_CLASSES#">',
'<noscript>&MSG_JSCRIPT.</noscript>',
'<a href="#a_PageDesigner" id="a_Body_skipToContent">&APP_TEXT$UI_PAGE_SKIP_TO_CONTENT.</a>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<header>',
'#REGION_POSITION_07#',
'</header>',
'<main class="resize">',
'#REGION_POSITION_01#',
'<div class="a-AlertMessages a-AlertMessages--page" role="region" aria-labelledby="pdNotificationTitle" style="display: none;" id="pdNotification">',
' <div class="a-AlertMessages-item">',
'  <div id="pdNotificationState" class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span id="pdNotificationIcon" class="a-Icon a-Icon--medium icon-check" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.SUCCESS"!HTML.''></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h2 id="pdNotificationTitle" class="u-vh">&"APP_TEXT$APEX.SUCCESS_MESSAGE_HEADING"!HTML.</h2>',
'      <div class="a-AlertMessages-messageTitle" id="pdNotificationMessage" role="alert">#PD_MESSAGE#</div>',
'      <button id="pdNotificationClose" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" aria-label="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-'
||'remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'<div id="a_PageDesigner" class="a-PageDesigner resize">',
'  #REGION_POSITION_02#',
'  #REGION_POSITION_03#',
'  #REGION_POSITION_04#',
'  #BODY#',
'  <div style="display:none;">#REGION_POSITION_06#</div>',
'</div>',
'</main>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg" role="region" aria-labelledby="page_success_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.SUCCESS"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_success_id" class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove" aria-hidden="tru'
||'e"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg" role="region" aria-labelledby="page_warning_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.WARNING"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_warning_id" class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#"><span class="a-Icon icon-remove" aria-hidden="tru'
||'e"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<br />',
'<br />',
'<pre>#MESSAGE#</pre>',
'<a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>false
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>'<div class="apex-container">#ROWS#</div>'
,p_grid_row_template=>'<div class="apex-row">#COLUMNS#</div>'
,p_grid_column_template=>'<div class="apex-col apex-col-#COLUMN_NUMBER# #CSS_CLASSES#">#CONTENT#</div>'
,p_dialog_browser_frame=>'MODAL'
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140004292269349560)
,p_page_template_id=>wwv_flow_imp.id(384711093594980574)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140004303977349560)
,p_page_template_id=>wwv_flow_imp.id(384711093594980574)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140004499387349560)
,p_page_template_id=>wwv_flow_imp.id(384711093594980574)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140004526708349560)
,p_page_template_id=>wwv_flow_imp.id(384711093594980574)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140004674063349559)
,p_page_template_id=>wwv_flow_imp.id(384711093594980574)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140004731594349559)
,p_page_template_id=>wwv_flow_imp.id(384711093594980574)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(384711329924980579)
,p_page_template_id=>wwv_flow_imp.id(384711093594980574)
,p_name=>'Dialog Area'
,p_placeholder=>'REGION_POSITION_06'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
,p_max_fixed_grid_columns=>-1
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_right_side_bar
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(386677207130845076)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Right Side Bar'
,p_internal_name=>'APEX_5.0_RIGHT_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'<a href="#main" id="a_Body_skipToContent">&APP_TEXT$UI_PAGE_SKIP_TO_CONTENT.</a>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<header>',
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'</header>',
'  <div id="main" class="a-Body">',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'    </aside>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-user" title="&MSG_USER." aria-label="&MSG_USER."></span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-workspace" title="&MSG_WORKSPACE." aria-label="&MSG_WORKSPACE."></span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-language" title="&MSG_LANGUAGE." aria-label="&MSG_LANGUAGE."></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg" role="region" aria-labelledby="page_success_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.SUCCESS"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_success_id" class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg" role="region" aria-labelledby="page_warning_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.WARNING"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_warning_id" class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>386895861966224222
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293158480539857409)
,p_page_template_id=>wwv_flow_imp.id(386677207130845076)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293158991949857410)
,p_page_template_id=>wwv_flow_imp.id(386677207130845076)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293159402775857410)
,p_page_template_id=>wwv_flow_imp.id(386677207130845076)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293159996888857410)
,p_page_template_id=>wwv_flow_imp.id(386677207130845076)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293160401216857410)
,p_page_template_id=>wwv_flow_imp.id(386677207130845076)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293160926746857411)
,p_page_template_id=>wwv_flow_imp.id(386677207130845076)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293161495907857411)
,p_page_template_id=>wwv_flow_imp.id(386677207130845076)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_rw_faceted_search
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(438185046231548086)
,p_theme_id=>3
,p_name=>'APEX RW - Faceted Search'
,p_internal_name=>'APEX_RW_-_FACETED_SEARCH'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES# a-Page--facetedSearch" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'<a href="#main" id="a_Body_skipToContent">&APP_TEXT$UI_PAGE_SKIP_TO_CONTENT.</a>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'#REGION_POSITION_02#',
'  <div id="main" class="a-Body">',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'    </aside>',
'    <main class="a-Main">',
'        #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-user" title="&MSG_USER." aria-label="&MSG_USER."><span class="u-vh">&MSG_USER.</span></span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-workspace" title="&MSG_WORKSPACE." aria-label="&MSG_WORKSPACE."><span class="u-vh">&MSG_WORKSPACE.</span></span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-language" title="&MSG_LANGUAGE." aria-label="&MSG_LANGUAGE."><span class="u-vh">&MSG_LANGUAGE.</span></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg" role="region" aria-labelledby="page_success_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.SUCCESS"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_success_id" class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg" role="region" aria-labelledby="page_warning_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.WARNING"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_warning_id" class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>383682332851249713
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293446731634956026)
,p_page_template_id=>wwv_flow_imp.id(438185046231548086)
,p_name=>'Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293447234820956026)
,p_page_template_id=>wwv_flow_imp.id(438185046231548086)
,p_name=>'Page Header (Position 3)'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293447796820956027)
,p_page_template_id=>wwv_flow_imp.id(438185046231548086)
,p_name=>'Page Header (Position 4)'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293448231605956027)
,p_page_template_id=>wwv_flow_imp.id(438185046231548086)
,p_name=>'Facets'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293448750835956027)
,p_page_template_id=>wwv_flow_imp.id(438185046231548086)
,p_name=>'After Body'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293449273431956028)
,p_page_template_id=>wwv_flow_imp.id(438185046231548086)
,p_name=>'Page Header (Position 1)'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293449749950956028)
,p_page_template_id=>wwv_flow_imp.id(438185046231548086)
,p_name=>'Page Header (Position 2)'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_dialog
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(689065306389965836)
,p_theme_id=>3
,p_name=>'[x] APEX 5.0 - Wizard Dialog'
,p_internal_name=>'APEX_5.0_WIZARD_DIALOG'
,p_is_popup=>true
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.builder.initWizardModal();',
'apex.builder.initWizardProgressBar();'))
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="utf-8">  ',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'<meta name="viewport" content="width=device-width,initial-scale=1" />',
'</head>',
'<body class="a-Dialog-page #DIALOG_CSS_CLASSES# #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Dialog a-Dialog--wizard">',
'  <div class="a-Dialog-wrap">',
'    <div class=" a-Dialog-wizardSteps">',
'      #REGION_POSITION_01#',
'    </div>',
'    <div class="a-Dialog-body">',
'      #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'      #BODY#',
'    </div>',
'    <div class="a-Dialog-footer">',
'      #REGION_POSITION_03#',
'    </div>',
'  </div>',
'</div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body>',
'</html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg" role="region" aria-labelledby="page_success_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.SUCCESS"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_success_id" class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg" role="region" aria-labelledby="page_warning_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.WARNING"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_warning_id" class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="0" width="100%'
,p_theme_class_id=>4
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--defaultIcons a-Alert--inlineDialog a-Alert--wizard margin-none padding-none">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header u-vh">',
'        <h2 class="a-Alert-title">&APP_TEXT$ERROR!HTML.</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        <p>#MESSAGE# #ADDITIONAL_INFO#</p>',
'        <p><a href="#BACK_LINK#">#RETURN_TO_APPLICATION#</a></p>',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>        '))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,baseDialogClass:''a-Dialog--wizard'',dialogClass:#DIALOG_CSS_CLASSES#,jsDialogClass:true,#DIALOG_A'
||'TTRIBUTES#},#PAGE_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_height=>'480'
,p_dialog_width=>'800'
,p_dialog_max_width=>'1200'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689061037088924910
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293529073192992197)
,p_page_template_id=>wwv_flow_imp.id(689065306389965836)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293529567034992198)
,p_page_template_id=>wwv_flow_imp.id(689065306389965836)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293530053995992198)
,p_page_template_id=>wwv_flow_imp.id(689065306389965836)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_edit_screen
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(689605897838965863)
,p_theme_id=>3
,p_name=>'[x] APEX 5.0 - Edit Screen'
,p_internal_name=>'APEX_5.0_EDIT_SCREEN'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initStickyHeader(''a_EditScreen_header'');'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'<a href="#main" id="a_Body_skipToContent">&APP_TEXT$UI_PAGE_SKIP_TO_CONTENT.</a>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<header>',
'#REGION_POSITION_07#',
'</header>',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'  <div class="a-Body">',
'    <main id="main" class="a-Main">',
'      #REGION_POSITION_02#',
'      <div class="a-EditScreen">',
'        <div class="a-EditScreen-header" id="a_EditScreen_header">',
'          #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'          #REGION_POSITION_04#',
'        </div>',
'        <div class="a-EditScreen-body">',
'          #BODY#',
'        </div>',
'      </div>',
'    </main>',
'    <aside class="a-Side">',
'        #REGION_POSITION_03#',
'        #REGION_POSITION_05#',
'    </aside>',
'  </div>'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-user" title="&MSG_USER." aria-label="&MSG_USER.">',
'        <span class="u-vh">&MSG_USER.</span>',
'      </span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-workspace" title="&MSG_WORKSPACE." aria-label="&MSG_WORKSPACE.">',
'        <span class="u-vh">&MSG_WORKSPACE.</span>',
'      </span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-language" title="&MSG_LANGUAGE." aria-label="&MSG_LANGUAGE.">',
'        <span class="u-vh">&MSG_LANGUAGE.</span>',
'      </span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg" role="region" aria-labelledby="page_success_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.SUCCESS"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_success_id" class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg" role="region" aria-labelledby="page_warning_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.WARNING"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_warning_id" class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_sidebar_def_reg_pos=>'REGION_POSITION_03'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_js_init_code=>'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'
,p_dialog_js_close_code=>'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'
,p_dialog_js_cancel_code=>'apex.navigation.dialog.cancel(#IS_MODAL#);'
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>689595297061847770
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293304861873925367)
,p_page_template_id=>wwv_flow_imp.id(689605897838965863)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293305384324925368)
,p_page_template_id=>wwv_flow_imp.id(689605897838965863)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293305820741925368)
,p_page_template_id=>wwv_flow_imp.id(689605897838965863)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293306325743925368)
,p_page_template_id=>wwv_flow_imp.id(689605897838965863)
,p_name=>'Right Side Bar'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293306882262925369)
,p_page_template_id=>wwv_flow_imp.id(689605897838965863)
,p_name=>'Edit Screen Header'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293307349982925369)
,p_page_template_id=>wwv_flow_imp.id(689605897838965863)
,p_name=>'Page Position 5'
,p_placeholder=>'REGION_POSITION_05'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293307817584925369)
,p_page_template_id=>wwv_flow_imp.id(689605897838965863)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(293308300913925370)
,p_page_template_id=>wwv_flow_imp.id(689605897838965863)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_no_side_bar
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(698674781428105900)
,p_theme_id=>3
,p_name=>'APEX 5.0 - No Side Bar'
,p_internal_name=>'APEX_5.0_NO_SIDE_BAR'
,p_is_popup=>false
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'</head>',
'<body class="#PAGE_CSS_CLASSES#" #ONLOAD#>',
'<!--[if lte IE 9]><div id="outdated-browser">#OUTDATED_BROWSER#</div><![endif]-->',
'<noscript>&MSG_JSCRIPT.</noscript>',
'<a href="#main" id="a_Body_skipToContent">&APP_TEXT$UI_PAGE_SKIP_TO_CONTENT.</a>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<header>',
'    #REGION_POSITION_07#',
'#REGION_POSITION_08#',
'#REGION_POSITION_01#',
'</header>',
'#SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'#REGION_POSITION_02#',
'#REGION_POSITION_03#',
'  <div id="main" class="a-Body">',
'    <main class="a-Main">',
'        #BODY#',
'    </main>',
'  </div>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-user" title="&MSG_USER." aria-label="&MSG_USER."><span class="u-vh">&MSG_USER.</span></span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-workspace" title=''&"APP_TEXT$APEXDEV.TEMPLATE_WORKSPACE"!HTML.'' aria-label=''&"APP_TEXT$APEXDEV.TEMPLATE_WORKSPACE"!HTML.''><span class="u-vh">&MSG_WORKSPACE.</span></span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-language" title="&MSG_LANGUAGE." aria-label="&MSG_LANGUAGE."><span class="u-vh">&MSG_LANGUAGE.</span></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--success a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_success_msg" role="region" aria-labelledby="page_success_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.SUCCESS"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_success_id" class="a-Alert-title">#SUCCESS_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #SUCCESS_MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_success_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--warning a-Alert--horizontal a-Alert--defaultIcons a-Alert--colorBG a-Alert--page" id="page_warning_msg" role="region" aria-labelledby="page_warning_id">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.WARNING"!HTML.''></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="page_warning_id" class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      </div>',
'      <div class="a-Alert-body" role="alert">',
'        #MESSAGE#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI" onclick="$x_Remove(''page_warning_msg'');" value="#CLOSE_NOTIFICATION#" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#"><span class="a-Icon '
||'icon-remove" aria-hidden="true"></span></button>',
'    </div>',
'  </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 class="a-Alert-title">#MESSAGE#</h2>',
'      </div>',
'      <div class="a-Alert-body">',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>637437892049443496
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1490156834768808)
,p_page_template_id=>wwv_flow_imp.id(698674781428105900)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1490659235768808)
,p_page_template_id=>wwv_flow_imp.id(698674781428105900)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1491190580768808)
,p_page_template_id=>wwv_flow_imp.id(698674781428105900)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1491660218768808)
,p_page_template_id=>wwv_flow_imp.id(698674781428105900)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1492193654768809)
,p_page_template_id=>wwv_flow_imp.id(698674781428105900)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1492615710768809)
,p_page_template_id=>wwv_flow_imp.id(698674781428105900)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1493109817768809)
,p_page_template_id=>wwv_flow_imp.id(698674781428105900)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/page/apex_5_0_wizard_page
begin
wwv_flow_imp_shared.create_template(
 p_id=>wwv_flow_imp.id(702688271851047856)
,p_theme_id=>3
,p_name=>'APEX 5.0 - Wizard Page'
,p_internal_name=>'APEX_5.0_WIZARD_PAGE'
,p_is_popup=>false
,p_javascript_code_onload=>'apex.builder.initWizardProgressBar();'
,p_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!doctype html>',
'<html class="no-js page-&APP_PAGE_ID. app-&APP_ID." lang="&BROWSER_LANGUAGE.">',
'<head>',
'<meta http-equiv="x-ua-compatible" content="IE=edge" />',
'<meta charset="UTF-8" />',
'<title>#TITLE#</title>',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon.ico">',
'<link rel="icon" sizes="16x16" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-16x16.png">',
'<link rel="icon" sizes="32x32" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-32x32.png">',
'<link rel="apple-touch-icon" sizes="180x180" href="#IMAGE_PREFIX#apex_ui/img/favicons/favicon-180x180.png">',
'#APEX_CSS#',
'#THEME_CSS#',
'#TEMPLATE_CSS#',
'#THEME_STYLE_CSS#',
'#APPLICATION_CSS#',
'#PAGE_CSS#',
'#HEAD#',
'</head>',
'<body class="a-Page--wizard #PAGE_CSS_CLASSES#" #ONLOAD#>',
'<noscript>&MSG_JSCRIPT.</noscript>',
'#ENVIRONMENT_BANNER#',
'#FORM_OPEN#'))
,p_box=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<header>',
'#REGION_POSITION_07#',
'</header>',
'#REGION_POSITION_08#',
'<main class="a-Main" id="main">',
'  #SUCCESS_MESSAGE##NOTIFICATION_MESSAGE##GLOBAL_NOTIFICATION#',
'  <div class="u-Layout u-Layout--centerVertically">',
'    <div class="a-Wizard a-Wizard--default">',
'      #REGION_POSITION_02#',
'      <div class="a-Wizard-controls">#REGION_POSITION_01#</div>',
'      <div class="a-Wizard-body">#BODY#</div>',
'      <div class="a-Wizard-buttons">#REGION_POSITION_03#</div>',
'    </div>',
'  </div>',
'</main>',
'#REGION_POSITION_04#'))
,p_footer_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<footer class="a-Footer">',
'  <div class="a-Footer-info">',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-user" title="&MSG_USER." aria-label="&MSG_USER."><span class="u-vh">&MSG_USER.</span></span>',
'      &USER.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-workspace" title="&MSG_WORKSPACE." aria-label="&MSG_WORKSPACE."><span class="u-vh">&MSG_WORKSPACE.</span></span>',
'      &COMPANY.',
'    </span>',
'    <span class="a-Footer-attribute">',
'      <span role="img" class="a-Icon icon-language" title="&MSG_LANGUAGE." aria-label="&MSG_LANGUAGE."><span class="u-vh">&MSG_LANGUAGE.</span></span>',
'      &BROWSER_LANGUAGE.',
'    </span>',
'  </div>',
'  <div class="a-Footer-copyright">&MSG_COPYRIGHT.</div>',
'  <div class="a-Footer-version">#FLOW_VERSION#</div>',
'</footer>',
'#FORM_CLOSE#',
'#DEVELOPER_TOOLBAR#',
'#APEX_JAVASCRIPT#',
'#GENERATED_CSS#',
'#THEME_JAVASCRIPT#',
'#TEMPLATE_JAVASCRIPT#',
'#APPLICATION_JAVASCRIPT#',
'#PAGE_JAVASCRIPT#',
'#GENERATED_JAVASCRIPT#',
'</body></html>'))
,p_success_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" id="sucessMsg">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-success">',
'    <div class="a-MediaBlock-graphic">',
'      <span class="a-Icon a-Icon--medium icon-check"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h5 class="a-AlertMessages-messageTitle" id="sucessMsg-Message" role="alert">#SUCCESS_MESSAGE#</h5>',
'      <button id="sucessMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''sucessMsg'');return false;"><span class="a-I'
||'con icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_notification_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AlertMessages a-AlertMessages--page" id="errorMsg" role="region" aria-labelledby="page_warning_id">',
' <div class="a-AlertMessages-item">',
'  <div class="a-MediaBlock a-AlertMessages-message is-error">',
'    <div class="a-MediaBlock-graphic" role="img" aria-label=''&"APP_TEXT$APEXDEV.ICON_LABEL.WARNING"!HTML.''>',
'      <span class="a-Icon a-Icon--medium icon-remove"></span> ',
'    </div>',
'    <div class="a-MediaBlock-content">',
'      <h2 class="u-vh" id="page_warning_id" class="a-Alert-title">#ERROR_MESSAGE_HEADING#</h2>',
'      <div class="a-AlertMessages-messageTitle" id="errorMsg-Message" role="alert">#MESSAGE#</div>',
'      <button id="errorMsg-Close" class="a-Button a-Button--small a-Button--noUI a-Button--noLabel a-Button--withIcon a-Button--alertMessages" type="button" aria-label="#CLOSE_NOTIFICATION#" title="#CLOSE_NOTIFICATION#" onclick="$x_Remove(''errorMsg'')'
||';return false;"><span class="a-Icon icon-remove"></span></button>',
'    </div>',
'  </div>',
' </div>',
'</div>'))
,p_navigation_bar=>'#BAR_BODY#'
,p_navbar_entry=>'<a href="#LINK#" class="htmldbNavLink">#TEXT#</a>'
,p_region_table_cattributes=>' summary="" cellpadding="0" border="0" cellspacing="2" width="100%"'
,p_breadcrumb_def_reg_pos=>'REGION_POSITION_08'
,p_theme_class_id=>1
,p_error_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert a-Alert--danger a-Alert--wizard a-Alert--defaultIcons">',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'      </div>',
'      <div class="a-Alert-body">',
'        <h2 class="a-Alert-subTitle">#MESSAGE#</h2>',
'        #ADDITIONAL_INFO#',
'        #TECHNICAL_INFO#',
'      </div>',
'    </div>',
'    <div class="a-Alert-buttons">',
'      <button class="a-Button a-Button--large a-Button--hot" onclick="#BACK_LINK#" type="button">#RETURN_TO_APPLICATION#</button>',
'    </div>',
'  </div>',
'</div>'))
,p_grid_type=>'FIXED'
,p_grid_max_columns=>12
,p_grid_always_use_max_columns=>true
,p_grid_has_column_span=>true
,p_grid_always_emit=>false
,p_grid_emit_empty_leading_cols=>true
,p_grid_emit_empty_trail_cols=>false
,p_grid_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-grid-container">',
'#ROWS#',
'</div>'))
,p_grid_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-row">',
'#COLUMNS#',
'</div>'))
,p_grid_column_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="apex-col apex-col-#COLUMN_SPAN_NUMBER# #ATTRIBUTES#">',
'#CONTENT#',
'</div>'))
,p_dialog_browser_frame=>'MODAL'
,p_reference_id=>702684260095026477
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(3608964297568254)
,p_page_template_id=>wwv_flow_imp.id(702688271851047856)
,p_name=>'Page Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(3609463263568254)
,p_page_template_id=>wwv_flow_imp.id(702688271851047856)
,p_name=>'Page Position 1'
,p_placeholder=>'REGION_POSITION_01'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(3609978210568255)
,p_page_template_id=>wwv_flow_imp.id(702688271851047856)
,p_name=>'Page Position 2'
,p_placeholder=>'REGION_POSITION_02'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(3610479833568255)
,p_page_template_id=>wwv_flow_imp.id(702688271851047856)
,p_name=>'Page Position 3'
,p_placeholder=>'REGION_POSITION_03'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(3610926724568255)
,p_page_template_id=>wwv_flow_imp.id(702688271851047856)
,p_name=>'Page Position 4'
,p_placeholder=>'REGION_POSITION_04'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(3611440076568256)
,p_page_template_id=>wwv_flow_imp.id(702688271851047856)
,p_name=>'Page Position 7'
,p_placeholder=>'REGION_POSITION_07'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_page_tmpl_display_point(
 p_id=>wwv_flow_imp.id(3611919884568256)
,p_page_template_id=>wwv_flow_imp.id(702688271851047856)
,p_name=>'Page Position 8'
,p_placeholder=>'REGION_POSITION_08'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_menu_button
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(3705362896815)
,p_template_name=>'APEX 5.0 - Icon Menu Button'
,p_internal_name=>'APEX_5.0_ICON_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span><span class="a-Icon  icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_reference_id=>3705338883615
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_badge_menu_button
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(3770144455858)
,p_template_name=>'APEX 5.0 - Icon Badge Menu Button'
,p_internal_name=>'APEX_5.0_ICON_BADGE_MENU_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_'
||'CSS_CLASSES#"></span><span class="a-Button-badge"></span><span class="a-Icon icon-menu-drop-down"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--iconTextButton js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class='
||'"a-Icon #ICON_CSS_CLASSES#"></span><span class="a-Button-badge"></span><span class="a-Icon icon-menu-drop-down"></span></button>'
,p_reference_id=>631020159860848910
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_badge_button
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(3781715377307)
,p_template_name=>'APEX 5.0 - Icon Badge Button'
,p_internal_name=>'APEX_5.0_ICON_BADGE_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#"></span><span class="a-But'
||'ton-badge"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" aria-label="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#"></span><spa'
||'n class="a-Button-badge"></span></button>'
,p_reference_id=>631020282344854024
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(183227826797404355)
,p_template_name=>'APEX 5.0 - Button'
,p_internal_name=>'APEX_5.0_BUTTON'
,p_template=>'<button onclick="#JAVASCRIPT#" class="a-Button #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_hot_template=>'<button onclick="#JAVASCRIPT#" class="a-Button a-Button--hot #BUTTON_CSS_CLASSES#" type="button" #BUTTON_ATTRIBUTES# id="#BUTTON_ID#">#LABEL!HTML#</button>'
,p_reference_id=>174750904387485475
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_with_icon
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(267402330762941782)
,p_template_name=>'APEX 23.2 - Icon Text Menu Button'
,p_internal_name=>'APEX_5.0_BUTTON_WITH_ICON'
,p_template=>'<button class="a-Button a-Button--iconTextMenuButton a-Button--withIcon js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span>#L'
||'ABEL!HTML#<span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--iconTextMenuButton a-Button--withIcon js-menuButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#" aria-hidden="t'
||'rue"></span>#LABEL!HTML#<span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span></button>'
,p_reference_id=>266802167809919723
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_icon_only_button
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(354034308421865099)
,p_template_name=>'APEX 5.0 - Icon Only Button'
,p_internal_name=>'APEX_5.0_ICON_ONLY_BUTTON'
,p_template=>'<button class="a-Button a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CLASSES#" aria-h'
||'idden="true"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--noLabel a-Button--withIcon #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" aria-label="#LABEL!ATTR#" type="button" id="#BUTTON_ID#" title="#LABEL!ATTR#" #BUTTON_ATTRIBUTES#><span class="a-Icon #ICON_CSS_CL'
||'ASSES#" aria-hidden="true"></span></button>'
,p_reference_id=>353820721334283301
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_with_icon_002
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(651364628215578370)
,p_template_name=>'APEX 5.0 - Button with Icon'
,p_internal_name=>'APEX_5.0_BUTTON_WITH_ICON'
,p_template=>'<button class="a-Button a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL!HTML#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_reference_id=>404889142313786233
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/button/apex_5_0_button_with_icon_not_escaped
begin
wwv_flow_imp_shared.create_button_templates(
 p_id=>wwv_flow_imp.id(2045667935478789095)
,p_template_name=>'APEX 5.0 - Button with Icon - NOT ESCAPED'
,p_internal_name=>'APEX_5.0_BUTTON_WITH_ICON_NOT_ESCAPED'
,p_template=>'<button class="a-Button a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_hot_template=>'<button class="a-Button a-Button--hot a-Button--iconTextButton #BUTTON_CSS_CLASSES#" onclick="#JAVASCRIPT#" type="button" id="#BUTTON_ID#" #BUTTON_ATTRIBUTES#>#LABEL#<span class="a-Icon #ICON_CSS_CLASSES#"></span></button>'
,p_translate_this_template=>'N'
,p_theme_class_id=>1
,p_theme_id=>3
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_search_and_replace_region_editor
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(4753713214324595)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <script type="text/javascript">  ',
'    function toggleFind() {',
'      html_ToggleElement(''body#REGION_ID#'');  ',
'    }',
'  </script>',
'  <div id="body#REGION_ID#" style="display:none;">',
'    <table cellpadding="0" cellspacing="0" border="0" summary="" id="#REGION_ID#">',
'      <tr>',
'        <td valign="top">#BODY#</td>',
'        <td valign="top">#CLOSE##EDIT##DELETE##CREATE##CREATE2##PREVIOUS##NEXT#</td>',
'      </tr>',
'    </table>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 4.0 - Search and Replace Region (Editor)'
,p_internal_name=>'APEX_4.0_SEARCH_AND_REPLACE_REGION_EDITOR'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>112829305325461983
,p_translate_this_template=>'N'
,p_template_comment=>'Gray Head, white body'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92329024112279803)
,p_plug_template_id=>wwv_flow_imp.id(4753713214324595)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92329520753279803)
,p_plug_template_id=>wwv_flow_imp.id(4753713214324595)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92330055287279803)
,p_plug_template_id=>wwv_flow_imp.id(4753713214324595)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92330562479279804)
,p_plug_template_id=>wwv_flow_imp.id(4753713214324595)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92331043171279804)
,p_plug_template_id=>wwv_flow_imp.id(4753713214324595)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92331596945279804)
,p_plug_template_id=>wwv_flow_imp.id(4753713214324595)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92332016319279805)
,p_plug_template_id=>wwv_flow_imp.id(4753713214324595)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92332589803279805)
,p_plug_template_id=>wwv_flow_imp.id(4753713214324595)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92333099521279805)
,p_plug_template_id=>wwv_flow_imp.id(4753713214324595)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_page_anchors
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(5938210987232439)
,p_layout=>'TABLE'
,p_template=>'<div class="a-PageAnchors #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES#>#BODY#</div>'
,p_page_plug_template_name=>'[x] APEX 5.0 - Page Anchors'
,p_internal_name=>'APEX_5.0_PAGE_ANCHORS'
,p_plug_table_bgcolor=>'white'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'white'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_form_table_attr=>' '
,p_reference_id=>17354206769599941
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(135721787358120557)
,p_plug_template_id=>wwv_flow_imp.id(5938210987232439)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(135722288840120557)
,p_plug_template_id=>wwv_flow_imp.id(5938210987232439)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_message_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(29434107863295859)
,p_layout=>'TABLE'
,p_template=>'<div class="a-SystemMessage #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES#>#BODY#</div>'
,p_page_plug_template_name=>'[x] APEX 5.0 - Message Region'
,p_internal_name=>'APEX_5.0_MESSAGE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>29333927116050844
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(229908791130787145)
,p_plug_template_id=>wwv_flow_imp.id(29434107863295859)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(229909213323787146)
,p_plug_template_id=>wwv_flow_imp.id(29434107863295859)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_rounded_corner_small_gray_top
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(32617604264695688)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion smallRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'    <span class="aButtonContainer">',
'      #EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#',
'    </span>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'APEX 4.0 - Rounded Corner Small (Gray Top)'
,p_internal_name=>'APEX_4.0_ROUNDED_CORNER_SMALL_GRAY_TOP'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>9
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140397591502344620)
,p_plug_template_id=>wwv_flow_imp.id(32617604264695688)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140397650493344620)
,p_plug_template_id=>wwv_flow_imp.id(32617604264695688)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140397716283344620)
,p_plug_template_id=>wwv_flow_imp.id(32617604264695688)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140397830201344620)
,p_plug_template_id=>wwv_flow_imp.id(32617604264695688)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140397918894344620)
,p_plug_template_id=>wwv_flow_imp.id(32617604264695688)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140398009671344620)
,p_plug_template_id=>wwv_flow_imp.id(32617604264695688)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140398178740344620)
,p_plug_template_id=>wwv_flow_imp.id(32617604264695688)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140398240997344620)
,p_plug_template_id=>wwv_flow_imp.id(32617604264695688)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140398313626344620)
,p_plug_template_id=>wwv_flow_imp.id(32617604264695688)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140398408435344620)
,p_plug_template_id=>wwv_flow_imp.id(32617604264695688)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140398595705344619)
,p_plug_template_id=>wwv_flow_imp.id(32617604264695688)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140398616222344619)
,p_plug_template_id=>wwv_flow_imp.id(32617604264695688)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_wizard_box_wide
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(35941518945222321)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="rounded-corner-wiz-region" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES# style="width:100%;">',
'  <div class="rc-blue-top"><div class="rc-blue-top-r">',
'    <div class="rc-title"><h2>#TITLE#</h2></div>',
'    <div class="rc-buttons">#CLOSE##DELETE##EDIT##CHANGE##PREVIOUS##NEXT##CREATE#</div>',
'  </div></div>',
'  <div class="rc-body"><div class="rc-body-r"><div class="rc-content">#BODY#</div></div></div>',
'  <div class="rc-bottom"><div class="rc-bottom-r"></div></div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 4.0 - Wizard Box (wide)'
,p_internal_name=>'APEX_4.0_WIZARD_BOX_WIDE'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>35936104232216540
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93377467817364285)
,p_plug_template_id=>wwv_flow_imp.id(35941518945222321)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93377938795364287)
,p_plug_template_id=>wwv_flow_imp.id(35941518945222321)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93378402955364287)
,p_plug_template_id=>wwv_flow_imp.id(35941518945222321)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93378977192364288)
,p_plug_template_id=>wwv_flow_imp.id(35941518945222321)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93379442108364289)
,p_plug_template_id=>wwv_flow_imp.id(35941518945222321)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93379950056364290)
,p_plug_template_id=>wwv_flow_imp.id(35941518945222321)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93380471004364290)
,p_plug_template_id=>wwv_flow_imp.id(35941518945222321)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93380915313364290)
,p_plug_template_id=>wwv_flow_imp.id(35941518945222321)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93381452786364291)
,p_plug_template_id=>wwv_flow_imp.id(35941518945222321)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_header
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(40778201261099606)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="wizardHeader" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 5.0 - Wizard Header'
,p_internal_name=>'APEX_5.0_WIZARD_HEADER'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42210710875242480
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88185296296816925)
,p_plug_template_id=>wwv_flow_imp.id(40778201261099606)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88185759972816925)
,p_plug_template_id=>wwv_flow_imp.id(40778201261099606)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(42025417508627628)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Wizard-region a-Form #REGION_CSS_CLASSES#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <h2 id="#REGION_STATIC_ID#_TITLE" class="u-vh">#TITLE#</h2>',
'  <div class="a-Wizard-regionHeader">#REGION_HEADER#</div>',
'  <div class="a-Wizard-regionBody">#BODY#</div>',
'  <div class="a-Wizard-regionFooter">#REGION_FOOTER#</div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 5.0 - Wizard Region'
,p_internal_name=>'APEX_5.0_WIZARD_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_region_title_dom_id=>'#REGION_STATIC_ID#_TITLE'
,p_reference_id=>702777601713950915
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(214484422446485459)
,p_plug_template_id=>wwv_flow_imp.id(42025417508627628)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(214484936281485459)
,p_plug_template_id=>wwv_flow_imp.id(42025417508627628)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_2_wizard_body_divider
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(42027416946637016)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion dividerTop" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'<div class="wizardRegionHeading">',
'  <h1>#TITLE#</h1>',
'  <div class="buttonContainer">',
'#EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'  </div>',
'</div>',
'  #BODY#',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 4.2 - Wizard Body (Divider)'
,p_internal_name=>'APEX_4.2_WIZARD_BODY_DIVIDER'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>42209811475242480
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93631066061541268)
,p_plug_template_id=>wwv_flow_imp.id(42027416946637016)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93631500645541272)
,p_plug_template_id=>wwv_flow_imp.id(42027416946637016)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93632048648541272)
,p_plug_template_id=>wwv_flow_imp.id(42027416946637016)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93632539531541272)
,p_plug_template_id=>wwv_flow_imp.id(42027416946637016)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93633032368541273)
,p_plug_template_id=>wwv_flow_imp.id(42027416946637016)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93633517905541273)
,p_plug_template_id=>wwv_flow_imp.id(42027416946637016)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93634005115541273)
,p_plug_template_id=>wwv_flow_imp.id(42027416946637016)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93634560092541273)
,p_plug_template_id=>wwv_flow_imp.id(42027416946637016)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93635010338541274)
,p_plug_template_id=>wwv_flow_imp.id(42027416946637016)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93635555526541274)
,p_plug_template_id=>wwv_flow_imp.id(42027416946637016)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93636096248541274)
,p_plug_template_id=>wwv_flow_imp.id(42027416946637016)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93636503433541275)
,p_plug_template_id=>wwv_flow_imp.id(42027416946637016)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_2_action_box
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(91980429263284255)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion aActionRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'  <span class="aButtonContainer">',
'    #CLOSE##DELETE##EDIT##CHANGE##PREVIOUS##NEXT##CREATE#',
'  </span>',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 4.2 - Action Box'
,p_internal_name=>'APEX_4.2_ACTION_BOX'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>18253116293565611
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93411148644371961)
,p_plug_template_id=>wwv_flow_imp.id(91980429263284255)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93411664727371962)
,p_plug_template_id=>wwv_flow_imp.id(91980429263284255)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93412191288371962)
,p_plug_template_id=>wwv_flow_imp.id(91980429263284255)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93412656472371962)
,p_plug_template_id=>wwv_flow_imp.id(91980429263284255)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93413107514371963)
,p_plug_template_id=>wwv_flow_imp.id(91980429263284255)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93413633963371963)
,p_plug_template_id=>wwv_flow_imp.id(91980429263284255)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93414174538371963)
,p_plug_template_id=>wwv_flow_imp.id(91980429263284255)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93414669411371963)
,p_plug_template_id=>wwv_flow_imp.id(91980429263284255)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93415127679371964)
,p_plug_template_id=>wwv_flow_imp.id(91980429263284255)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_2_action_box_002
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(107834009497616535)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion aActionRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'  <span class="aButtonContainer">',
'    #CLOSE##DELETE##EDIT##CHANGE##PREVIOUS##NEXT##CREATE#',
'  </span>',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 4.2 - Action Box (2)'
,p_internal_name=>'APEX_4.2_ACTION_BOX'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>18253116293565611
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93419596659371972)
,p_plug_template_id=>wwv_flow_imp.id(107834009497616535)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93420034687371972)
,p_plug_template_id=>wwv_flow_imp.id(107834009497616535)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93420507696371973)
,p_plug_template_id=>wwv_flow_imp.id(107834009497616535)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93421061420371973)
,p_plug_template_id=>wwv_flow_imp.id(107834009497616535)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93421505516371973)
,p_plug_template_id=>wwv_flow_imp.id(107834009497616535)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93422092993371974)
,p_plug_template_id=>wwv_flow_imp.id(107834009497616535)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93422584060371974)
,p_plug_template_id=>wwv_flow_imp.id(107834009497616535)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93423010894371974)
,p_plug_template_id=>wwv_flow_imp.id(107834009497616535)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93423502882371974)
,p_plug_template_id=>wwv_flow_imp.id(107834009497616535)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/page_edit_standard_content
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(109502816944998716)
,p_layout=>'TABLE'
,p_template=>'<section class="aRegion smallHeading noPadding componentRegion #REGION_CSS_CLASSES#" id="#REGION_ID#" #REGION_ATTRIBUTES#>#BODY#</section>'
,p_page_plug_template_name=>'Page Edit - Standard Content'
,p_internal_name=>'PAGE_EDIT_STANDARD_CONTENT'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>' '
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140413549144344604)
,p_plug_template_id=>wwv_flow_imp.id(109502816944998716)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140413698329344604)
,p_plug_template_id=>wwv_flow_imp.id(109502816944998716)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_2_page_edit_component_top_bar
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(109512004324037517)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="componentViewHeader aRegion #REGION_CSS_CLASSES#" id="#REGION_ID#" #REGION_ATTRIBUTES#>',
'  <h1>#TITLE#</h1>',
'  #BODY#',
'</section>'))
,p_page_plug_template_name=>'APEX 4.2 - Page Edit Component Top Bar'
,p_internal_name=>'APEX_4.2_PAGE_EDIT_COMPONENT_TOP_BAR'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>' '
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140413714652344604)
,p_plug_template_id=>wwv_flow_imp.id(109512004324037517)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140413830300344603)
,p_plug_template_id=>wwv_flow_imp.id(109512004324037517)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_2_action_box_confirm
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(148578007466880598)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion aActionRegion confirmRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    <div class="aActionRegionIcon">',
'      <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" />',
'    </div>',
'    #BODY#',
'  </div>',
'  <span class="aButtonContainer">',
'    #CLOSE##DELETE##EDIT##CHANGE##PREVIOUS##NEXT##CREATE#',
'  </span>',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 4.2 - Action Box (Confirm) (2)'
,p_internal_name=>'APEX_4.2_ACTION_BOX_CONFIRM'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>186682507972859454
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93503475970376124)
,p_plug_template_id=>wwv_flow_imp.id(148578007466880598)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93503990835376124)
,p_plug_template_id=>wwv_flow_imp.id(148578007466880598)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93504441474376124)
,p_plug_template_id=>wwv_flow_imp.id(148578007466880598)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93504910220376125)
,p_plug_template_id=>wwv_flow_imp.id(148578007466880598)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93505436679376126)
,p_plug_template_id=>wwv_flow_imp.id(148578007466880598)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93505962979376127)
,p_plug_template_id=>wwv_flow_imp.id(148578007466880598)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93506425991376127)
,p_plug_template_id=>wwv_flow_imp.id(148578007466880598)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93506911222376127)
,p_plug_template_id=>wwv_flow_imp.id(148578007466880598)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93507430140376127)
,p_plug_template_id=>wwv_flow_imp.id(148578007466880598)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_action_box_warning
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(163254430635461528)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion aActionRegion warningRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    <div class="aActionRegionIcon">',
'      <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" />',
'    </div>',
'    #BODY#',
'  </div>',
'  <span class="aButtonContainer">',
'    #CLOSE##DELETE##EDIT##CHANGE##PREVIOUS##NEXT##CREATE#',
'  </span>',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 4.0 - Action Box / Wizard Box (Warning)'
,p_internal_name=>'APEX_4.0_ACTION_BOX_WARNING'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>162320107014603380
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60470048829140138)
,p_plug_template_id=>wwv_flow_imp.id(163254430635461528)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60470556005140138)
,p_plug_template_id=>wwv_flow_imp.id(163254430635461528)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60471061000140138)
,p_plug_template_id=>wwv_flow_imp.id(163254430635461528)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60471513164140139)
,p_plug_template_id=>wwv_flow_imp.id(163254430635461528)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60472088599140139)
,p_plug_template_id=>wwv_flow_imp.id(163254430635461528)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60472523851140140)
,p_plug_template_id=>wwv_flow_imp.id(163254430635461528)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60473069169140140)
,p_plug_template_id=>wwv_flow_imp.id(163254430635461528)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60473567735140140)
,p_plug_template_id=>wwv_flow_imp.id(163254430635461528)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60474085002140140)
,p_plug_template_id=>wwv_flow_imp.id(163254430635461528)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_page_designer_column
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(174784422470064928)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-PageColumn resize #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-PageColumn-header">',
'    <h2 class="a-PageColumn-heading">#TITLE#</h2>',
'  </div>',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Page Designer Column'
,p_internal_name=>'APEX_5.0_PAGE_DESIGNER_COLUMN'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174613223222362440
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140417721055344599)
,p_plug_template_id=>wwv_flow_imp.id(174784422470064928)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140417851643344599)
,p_plug_template_id=>wwv_flow_imp.id(174784422470064928)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_page_designer_column_body
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(174793821995076649)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-PageColumn-body resize #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Page Designer Column (Body)'
,p_internal_name=>'APEX_5.0_PAGE_DESIGNER_COLUMN_BODY'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174630015632506596
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140417917728344599)
,p_plug_template_id=>wwv_flow_imp.id(174793821995076649)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140418006847344599)
,p_plug_template_id=>wwv_flow_imp.id(174793821995076649)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(174794400314076650)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title" id="#REGION_STATIC_ID#_heading">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  <div class="a-Region-bodyHeader">#REGION_HEADER#</div>',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 5.0 - Region'
,p_internal_name=>'APEX_5.0_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_region_title_dom_id=>'#REGION_STATIC_ID#_heading'
,p_reference_id=>174748721787471587
,p_translate_this_template=>'N'
,p_template_comment=>'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(31246944732577735)
,p_plug_template_id=>wwv_flow_imp.id(174794400314076650)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(31247484473577736)
,p_plug_template_id=>wwv_flow_imp.id(174794400314076650)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(31247946312577736)
,p_plug_template_id=>wwv_flow_imp.id(174794400314076650)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(31248482529577736)
,p_plug_template_id=>wwv_flow_imp.id(174794400314076650)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(31248925713577737)
,p_plug_template_id=>wwv_flow_imp.id(174794400314076650)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(31249453487577737)
,p_plug_template_id=>wwv_flow_imp.id(174794400314076650)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(31249949042577737)
,p_plug_template_id=>wwv_flow_imp.id(174794400314076650)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(31250426840577738)
,p_plug_template_id=>wwv_flow_imp.id(174794400314076650)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(31250966766577738)
,p_plug_template_id=>wwv_flow_imp.id(174794400314076650)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(31251480155577738)
,p_plug_template_id=>wwv_flow_imp.id(174794400314076650)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(31251978578577739)
,p_plug_template_id=>wwv_flow_imp.id(174794400314076650)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(31252443152577739)
,p_plug_template_id=>wwv_flow_imp.id(174794400314076650)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(31252985485577739)
,p_plug_template_id=>wwv_flow_imp.id(174794400314076650)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region_top_buttons
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(174795123140076650)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--left">',
'      <h2 class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--right">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region (Top Buttons)'
,p_internal_name=>'APEX_5.0_REGION_TOP_BUTTONS'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174747104640428780
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140419491187344598)
,p_plug_template_id=>wwv_flow_imp.id(174795123140076650)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140419509329344597)
,p_plug_template_id=>wwv_flow_imp.id(174795123140076650)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140419612902344597)
,p_plug_template_id=>wwv_flow_imp.id(174795123140076650)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140419705397344597)
,p_plug_template_id=>wwv_flow_imp.id(174795123140076650)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140419821969344597)
,p_plug_template_id=>wwv_flow_imp.id(174795123140076650)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140419985519344597)
,p_plug_template_id=>wwv_flow_imp.id(174795123140076650)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140420080177344597)
,p_plug_template_id=>wwv_flow_imp.id(174795123140076650)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140420143678344597)
,p_plug_template_id=>wwv_flow_imp.id(174795123140076650)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140420247822344597)
,p_plug_template_id=>wwv_flow_imp.id(174795123140076650)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140420305481344597)
,p_plug_template_id=>wwv_flow_imp.id(174795123140076650)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140420426695344597)
,p_plug_template_id=>wwv_flow_imp.id(174795123140076650)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140420598080344596)
,p_plug_template_id=>wwv_flow_imp.id(174795123140076650)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140420689387344596)
,p_plug_template_id=>wwv_flow_imp.id(174795123140076650)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_toolbar
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(174795802901076650)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div role="toolbar" aria-label="#TITLE!ATTR#" class="a-Toolbar #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Toolbar-items a-Toolbar-items--left">#PREVIOUS#</div>',
'  <div class="a-Toolbar-items a-Toolbar-items--right">#NEXT#</div>',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Toolbar'
,p_internal_name=>'APEX_5.0_TOOLBAR'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174613705533399534
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(68587657421251715)
,p_plug_template_id=>wwv_flow_imp.id(174795802901076650)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(68588135452251715)
,p_plug_template_id=>wwv_flow_imp.id(174795802901076650)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(68588643241251716)
,p_plug_template_id=>wwv_flow_imp.id(174795802901076650)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(68589129771251716)
,p_plug_template_id=>wwv_flow_imp.id(174795802901076650)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_nested_splitter
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(177373906751600776)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES# class="resize #REGION_CSS_CLASSES#"> ',
'#BODY#',
'<div id="#REGION_STATIC_ID#_content" class="resize">',
'#SUB_REGIONS#',
'</div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Nested Splitter'
,p_internal_name=>'APEX_5.0_NESTED_SPLITTER'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140421177672344596)
,p_plug_template_id=>wwv_flow_imp.id(177373906751600776)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140421224592344596)
,p_plug_template_id=>wwv_flow_imp.id(177373906751600776)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_tabs
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(183219627032331552)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-TabsContainer #REGION_CSS_CLASSES#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Tabs-toolbar a-Toolbar">',
'    #SUB_REGION_HEADERS#',
'    <div class="a-Toolbar-items a-Toolbar-items--right">#NEXT#</div>',
'  </div>',
'  #SUB_REGIONS#',
'</div>',
''))
,p_sub_plug_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'#ENTRIES#',
'</ul>'))
,p_sub_plug_header_entry_templ=>'<li><a aria-hidden="true" href="##SUB_REGION_ID#">#SUB_REGION_TITLE#</a></li>'
,p_sub_plug_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#SUB_REGION#',
''))
,p_page_plug_template_name=>'APEX 5.0 - Tabs'
,p_internal_name=>'APEX_5.0_TABS'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_reference_id=>68426751589990534
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(68999528881746522)
,p_plug_template_id=>wwv_flow_imp.id(183219627032331552)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(69000018037746523)
,p_plug_template_id=>wwv_flow_imp.id(183219627032331552)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(69000504672746523)
,p_plug_template_id=>wwv_flow_imp.id(183219627032331552)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>false
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_sidebar_gray_header
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(196613003429111883)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion sideRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'    <span class="aButtonContainer">',
'      #EDIT##CLOSE##CREATE##CREATE2##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT#',
'    </span>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 4.0 - Sidebar (Gray Header)'
,p_internal_name=>'APEX_4.0_SIDEBAR_GRAY_HEADER'
,p_plug_table_bgcolor=>'#F7F7E7'
,p_theme_id=>3
,p_theme_class_id=>2
,p_plug_heading_bgcolor=>'#F7F7E7'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>' '
,p_reference_id=>17355419405599943
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92347318387283220)
,p_plug_template_id=>wwv_flow_imp.id(196613003429111883)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92347887595283220)
,p_plug_template_id=>wwv_flow_imp.id(196613003429111883)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92348311466283221)
,p_plug_template_id=>wwv_flow_imp.id(196613003429111883)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92348838216283221)
,p_plug_template_id=>wwv_flow_imp.id(196613003429111883)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92349391066283221)
,p_plug_template_id=>wwv_flow_imp.id(196613003429111883)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92349851035283222)
,p_plug_template_id=>wwv_flow_imp.id(196613003429111883)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92350333949283222)
,p_plug_template_id=>wwv_flow_imp.id(196613003429111883)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92350889325283222)
,p_plug_template_id=>wwv_flow_imp.id(196613003429111883)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92351367927283222)
,p_plug_template_id=>wwv_flow_imp.id(196613003429111883)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92351838293283223)
,p_plug_template_id=>wwv_flow_imp.id(196613003429111883)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92352334108283223)
,p_plug_template_id=>wwv_flow_imp.id(196613003429111883)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92352876005283223)
,p_plug_template_id=>wwv_flow_imp.id(196613003429111883)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_2_action_box_confirm_002
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(202282905326760449)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aRegion aActionRegion confirmRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="aRegionHeading">',
'    <h1>#TITLE#</h1>',
'  </div>',
'  <div class="aRegionContent clearfix">',
'    <div class="aActionRegionIcon">',
'      <img src="#IMAGE_PREFIX#f_spacer.gif" alt="" />',
'    </div>',
'    #BODY#',
'  </div>',
'  <span class="aButtonContainer">',
'    #CLOSE##DELETE##EDIT##CHANGE##PREVIOUS##NEXT##CREATE#',
'  </span>',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 4.2 - Action Box (Confirm)'
,p_internal_name=>'APEX_4.2_ACTION_BOX_CONFIRM'
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>186682507972859454
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93495154455376114)
,p_plug_template_id=>wwv_flow_imp.id(202282905326760449)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93495630408376114)
,p_plug_template_id=>wwv_flow_imp.id(202282905326760449)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93496093353376115)
,p_plug_template_id=>wwv_flow_imp.id(202282905326760449)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93496563543376116)
,p_plug_template_id=>wwv_flow_imp.id(202282905326760449)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93497093622376116)
,p_plug_template_id=>wwv_flow_imp.id(202282905326760449)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93497509625376116)
,p_plug_template_id=>wwv_flow_imp.id(202282905326760449)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93498067472376117)
,p_plug_template_id=>wwv_flow_imp.id(202282905326760449)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93498538015376117)
,p_plug_template_id=>wwv_flow_imp.id(202282905326760449)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(93499066331376117)
,p_plug_template_id=>wwv_flow_imp.id(202282905326760449)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_div_with_id_class_and_region_attributes
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(208928010704475743)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="#REGION_CSS_CLASSES#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES#>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'[x] APEX 5.0 - Div with ID, Class, and Region Attributes'
,p_internal_name=>'APEX_5.0_DIV_WITH_ID,_CLASS,_AND_REGION_ATTRIBUTES'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>716895227337398760
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32589211353747547)
,p_plug_template_id=>wwv_flow_imp.id(208928010704475743)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32589781044747547)
,p_plug_template_id=>wwv_flow_imp.id(208928010704475743)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32590214914747548)
,p_plug_template_id=>wwv_flow_imp.id(208928010704475743)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(32590783994747548)
,p_plug_template_id=>wwv_flow_imp.id(208928010704475743)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_page_designer_column_no_heading
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(226071526010722245)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-PageColumn resize #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  #BODY#',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Page Designer Column (No Heading)'
,p_internal_name=>'APEX_5.0_PAGE_DESIGNER_COLUMN_NO_HEADING'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>174613223222362440
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140425149448344592)
,p_plug_template_id=>wwv_flow_imp.id(226071526010722245)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140425277336344591)
,p_plug_template_id=>wwv_flow_imp.id(226071526010722245)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_4_0_top_bar_for_list_buttons
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(254081231995084695)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="topbar" style="width:100%;clear:both;" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <div class="topbar-top"><div class="topbar-top-r"></div></div>',
'  <div class="topbar-body"><div class="topbar-body-r"><div class="topbar-content">',
'     #BODY#',
'   </div></div></div>',
'  <div class="topbar-bottom"><div class="topbar-bottom-r"></div></div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 4.0 - Top Bar (for list buttons)'
,p_internal_name=>'APEX_4.0_TOP_BAR_FOR_LIST_BUTTONS'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>254074518265073133
,p_translate_this_template=>'N'
,p_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <table class="TopBarUIFix" cellpadding="0" cellspacing="0" border="0" summary="" id="#REGION_STATIC_ID#" width="100%"><tbody class="GreenBar"><tr><td valign="middle" class="L">#BODY#</td><td width="30" class="C"><br /></td><td valign="middle" class='
||'"R" align="right"><span style="margin-right:10px;">#CLOSE#</span>#COPY##DELETE##CHANGE##EDIT##PREVIOUS##NEXT##CREATE##EXPAND#</td></tr></tbody></table>',
''))
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92571503161304927)
,p_plug_template_id=>wwv_flow_imp.id(254081231995084695)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(92572055927304927)
,p_plug_template_id=>wwv_flow_imp.id(254081231995084695)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_body_hide_show
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(399849897040726767)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<section class="aWizardRegion aWizardRegion--disclosure" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="wizardRegionHeading">',
'    <h2>',
'        <button type="button">#TITLE#</button>',
'    </h2>',
'    <div class="buttonContainer">',
'    #EDIT##CLOSE##EXPAND##HELP##DELETE##COPY##PREVIOUS##NEXT##CREATE##CREATE2#',
'    </div>',
'  </div>',
'  <div class="hideShowRegion" id="#REGION_STATIC_ID#_content">',
'    #BODY#',
'  </div>',
'</section>'))
,p_page_plug_template_name=>'[x] APEX 5.0 - Wizard Body (Hide/Show)'
,p_internal_name=>'APEX_5.0_WIZARD_BODY_HIDE/SHOW'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( "##REGION_STATIC_ID#" ).collapsible({',
'    content: $( "##REGION_STATIC_ID#_content" )',
'});'))
,p_theme_id=>3
,p_theme_class_id=>12
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>399850559367741099
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88225742157825381)
,p_plug_template_id=>wwv_flow_imp.id(399849897040726767)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88226273165825381)
,p_plug_template_id=>wwv_flow_imp.id(399849897040726767)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88226752422825382)
,p_plug_template_id=>wwv_flow_imp.id(399849897040726767)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88227231789825382)
,p_plug_template_id=>wwv_flow_imp.id(399849897040726767)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88227700654825382)
,p_plug_template_id=>wwv_flow_imp.id(399849897040726767)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88228213474825383)
,p_plug_template_id=>wwv_flow_imp.id(399849897040726767)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88228733791825383)
,p_plug_template_id=>wwv_flow_imp.id(399849897040726767)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88229204140825383)
,p_plug_template_id=>wwv_flow_imp.id(399849897040726767)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88229742364825384)
,p_plug_template_id=>wwv_flow_imp.id(399849897040726767)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88230256715825384)
,p_plug_template_id=>wwv_flow_imp.id(399849897040726767)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88230704186825384)
,p_plug_template_id=>wwv_flow_imp.id(399849897040726767)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88231271160825384)
,p_plug_template_id=>wwv_flow_imp.id(399849897040726767)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_19_1_blank_grid
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(461857790551605627)
,p_layout=>'TABLE'
,p_template=>'<div id="#REGION_STATIC_ID#" class="#REGION_CSS_CLASSES#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES#>#PREVIOUS##BODY##NEXT#</div>'
,p_page_plug_template_name=>'APEX 19.1 - Blank (Grid)'
,p_internal_name=>'APEX_19.1_BLANK_GRID'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140426760356344590)
,p_plug_template_id=>wwv_flow_imp.id(461857790551605627)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140426845854344590)
,p_plug_template_id=>wwv_flow_imp.id(461857790551605627)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140426993300344590)
,p_plug_template_id=>wwv_flow_imp.id(461857790551605627)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140427058644344590)
,p_plug_template_id=>wwv_flow_imp.id(461857790551605627)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region_dialog
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(557449278618308550)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#REGION_STATIC_ID#"  class="a-DialogRegion js-regionDialog #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# style="display:none" title="#TITLE#">',
'  <div class="a-DialogRegion-body">',
'#BODY#',
'  </div>',
'  <div class="a-DialogRegion-buttons">',
'     <div class="a-ButtonRegion a-ButtonRegion--dialogRegion">',
'       <div class="a-ButtonRegion-wrap">',
'         <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'         <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'       </div>',
'     </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 5.0 - Region Dialog'
,p_internal_name=>'APEX_5.0_REGION_DIALOG'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'js-draggable:js-resizable:js-modal'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>428597701677720079
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88366607696832829)
,p_plug_template_id=>wwv_flow_imp.id(557449278618308550)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88367105180832829)
,p_plug_template_id=>wwv_flow_imp.id(557449278618308550)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88367612326832830)
,p_plug_template_id=>wwv_flow_imp.id(557449278618308550)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88368116876832830)
,p_plug_template_id=>wwv_flow_imp.id(557449278618308550)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88368632577832830)
,p_plug_template_id=>wwv_flow_imp.id(557449278618308550)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88369119346832834)
,p_plug_template_id=>wwv_flow_imp.id(557449278618308550)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88369604422832834)
,p_plug_template_id=>wwv_flow_imp.id(557449278618308550)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88370198774832834)
,p_plug_template_id=>wwv_flow_imp.id(557449278618308550)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_interactive_report_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(646287526247383209)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#REGION_STATIC_ID#" class="a-IRR-region #REGION_CSS_CLASSES#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES#>',
'  <h2 id="#REGION_STATIC_ID#_heading" class="u-vh a-Region-header">#TITLE#</h2>',
'  #PREVIOUS##BODY##NEXT#',
'</div>',
''))
,p_page_plug_template_name=>'[x] APEX 5.0 - Interactive Report Region'
,p_internal_name=>'APEX_5.0_INTERACTIVE_REPORT_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-IRR-region--responsiveIconView'
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_region_title_dom_id=>'#REGION_STATIC_ID#_heading'
,p_reference_id=>678354360586321695
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1491291758426774)
,p_plug_template_id=>wwv_flow_imp.id(646287526247383209)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1491798534426774)
,p_plug_template_id=>wwv_flow_imp.id(646287526247383209)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1492223215426775)
,p_plug_template_id=>wwv_flow_imp.id(646287526247383209)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1492757677426775)
,p_plug_template_id=>wwv_flow_imp.id(646287526247383209)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_region_with_icon
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(655568879441187677)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hasIcon #REGION_CSS_CLASSES#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 id="#REGION_STATIC_ID#_TITLE" class="a-Region-title">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'    <div class="a-RegionMedia">',
'      <div class="a-RegionMedia-graphic">',
'        <span aria-hidden="true" class="a-Icon a-Icon--regionIcon #ICON_CSS_CLASSES#"></span>',
'      </div>',
'      <div class="a-RegionMedia-content">',
'        #BODY#',
'      </div>',
'    </div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Region with Icon'
,p_internal_name=>'APEX_5.0_REGION_WITH_ICON'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--noPadding'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_region_title_dom_id=>'#REGION_STATIC_ID#_TITLE'
,p_reference_id=>698829239393878937
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131639518196047128)
,p_plug_template_id=>wwv_flow_imp.id(655568879441187677)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131640076787047129)
,p_plug_template_id=>wwv_flow_imp.id(655568879441187677)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131640502293047129)
,p_plug_template_id=>wwv_flow_imp.id(655568879441187677)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131641016881047129)
,p_plug_template_id=>wwv_flow_imp.id(655568879441187677)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131641582406047130)
,p_plug_template_id=>wwv_flow_imp.id(655568879441187677)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131642073044047130)
,p_plug_template_id=>wwv_flow_imp.id(655568879441187677)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131642567223047130)
,p_plug_template_id=>wwv_flow_imp.id(655568879441187677)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131643046992047131)
,p_plug_template_id=>wwv_flow_imp.id(655568879441187677)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131643527302047131)
,p_plug_template_id=>wwv_flow_imp.id(655568879441187677)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131644060043047131)
,p_plug_template_id=>wwv_flow_imp.id(655568879441187677)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131644583333047132)
,p_plug_template_id=>wwv_flow_imp.id(655568879441187677)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131645039080047132)
,p_plug_template_id=>wwv_flow_imp.id(655568879441187677)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(131645520548047132)
,p_plug_template_id=>wwv_flow_imp.id(655568879441187677)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_button_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(689274781922315777)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ButtonRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES#>',
'  <div class="a-ButtonRegion-wrap">',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--left"><div class="a-ButtonRegion-buttons">#PREVIOUS##DELETE##CLOSE#</div></div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--content">',
'      <h2 id="#REGION_STATIC_ID#_TITLE" class="a-ButtonRegion-title">#TITLE#</h2>',
'      #BODY#',
'      <div class="a-ButtonRegion-buttons">#CHANGE#</div>',
'    </div>',
'    <div class="a-ButtonRegion-col a-ButtonRegion-col--right"><div class="a-ButtonRegion-buttons">#EDIT##CREATE##NEXT#</div></div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Button Region'
,p_internal_name=>'APEX_5.0_BUTTON_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-ButtonRegion--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_region_title_dom_id=>'#REGION_STATIC_ID#_TITLE'
,p_reference_id=>687153470345619376
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(63676905559240631)
,p_plug_template_id=>wwv_flow_imp.id(689274781922315777)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(63677414202240631)
,p_plug_template_id=>wwv_flow_imp.id(689274781922315777)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(63677903061240632)
,p_plug_template_id=>wwv_flow_imp.id(689274781922315777)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(63678479372240632)
,p_plug_template_id=>wwv_flow_imp.id(689274781922315777)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(63678911209240632)
,p_plug_template_id=>wwv_flow_imp.id(689274781922315777)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(63679444889240633)
,p_plug_template_id=>wwv_flow_imp.id(689274781922315777)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(63679930427240633)
,p_plug_template_id=>wwv_flow_imp.id(689274781922315777)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(63680482764240633)
,p_plug_template_id=>wwv_flow_imp.id(689274781922315777)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(63680923111240633)
,p_plug_template_id=>wwv_flow_imp.id(689274781922315777)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_hide_show_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(689970285456172024)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region a-Region--hideShow #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# #REGION_LANDMARK_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--controls">',
'        <h2 id="#REGION_STATIC_ID#_TITLE" class="a-Region-title">',
'            <button class="a-Region-toggle" type="button">#TITLE#</button>',
'        </h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 5.0 - Hide + Show Region'
,p_internal_name=>'APEX_5.0_HIDE_+_SHOW_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_template_options=>'a-Region--flush'
,p_preset_template_options=>'is-expanded'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_region_title_dom_id=>'#REGION_STATIC_ID#_TITLE'
,p_reference_id=>689955986849128825
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1427572336065815)
,p_plug_template_id=>wwv_flow_imp.id(689970285456172024)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1428006242065815)
,p_plug_template_id=>wwv_flow_imp.id(689970285456172024)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1428507620065815)
,p_plug_template_id=>wwv_flow_imp.id(689970285456172024)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1429048030065815)
,p_plug_template_id=>wwv_flow_imp.id(689970285456172024)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1429570929065816)
,p_plug_template_id=>wwv_flow_imp.id(689970285456172024)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1430004820065816)
,p_plug_template_id=>wwv_flow_imp.id(689970285456172024)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1430539245065816)
,p_plug_template_id=>wwv_flow_imp.id(689970285456172024)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1431040422065816)
,p_plug_template_id=>wwv_flow_imp.id(689970285456172024)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1431555477065816)
,p_plug_template_id=>wwv_flow_imp.id(689970285456172024)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1432024698065817)
,p_plug_template_id=>wwv_flow_imp.id(689970285456172024)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1432533895065817)
,p_plug_template_id=>wwv_flow_imp.id(689970285456172024)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1433065928065817)
,p_plug_template_id=>wwv_flow_imp.id(689970285456172024)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(1433566836065817)
,p_plug_template_id=>wwv_flow_imp.id(689970285456172024)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_wizard_title_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(703488066986172098)
,p_layout=>'TABLE'
,p_template=>'<div class="#REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#><h1 class="a-Wizard-title">#TITLE#</h1></div>'
,p_page_plug_template_name=>'[x] APEX 5.0 - Wizard Title Region'
,p_internal_name=>'APEX_5.0_WIZARD_TITLE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>703469000349150769
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88131655244806712)
,p_plug_template_id=>wwv_flow_imp.id(703488066986172098)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(88132113653806712)
,p_plug_template_id=>wwv_flow_imp.id(703488066986172098)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_alert
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(770240542605907344)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Alert #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES#>',
'  <div class="a-Alert-wrap">',
'    <div class="a-Alert-icon">',
'      <span class="a-Icon #ICON_CSS_CLASSES#" aria-hidden="true"></span>',
'    </div>',
'    <div class="a-Alert-content">',
'      <div class="a-Alert-header">',
'        <h2 id="#REGION_STATIC_ID#_TITLE" class="a-Alert-title">#TITLE#</h2>',
'      </div>',
'      <div role="alert" class="a-Alert-body">#BODY#</div>',
'    </div>',
'    <div class="a-Alert-buttons">#PREVIOUS##CLOSE##CREATE##NEXT#</div>',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 5.0 - Alert'
,p_internal_name=>'APEX_5.0_ALERT'
,p_theme_id=>3
,p_theme_class_id=>7
,p_default_template_options=>'a-Alert--defaultIcons'
,p_preset_template_options=>'a-Alert--warning:a-Alert--wizard'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_region_title_dom_id=>'#REGION_STATIC_ID#_TITLE'
,p_reference_id=>746362351042209764
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4838957174959715)
,p_plug_template_id=>wwv_flow_imp.id(770240542605907344)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4839438036959715)
,p_plug_template_id=>wwv_flow_imp.id(770240542605907344)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4839981047959716)
,p_plug_template_id=>wwv_flow_imp.id(770240542605907344)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4840441032959716)
,p_plug_template_id=>wwv_flow_imp.id(770240542605907344)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4840910735959716)
,p_plug_template_id=>wwv_flow_imp.id(770240542605907344)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(4841426228959716)
,p_plug_template_id=>wwv_flow_imp.id(770240542605907344)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_1_tabs_with_icons_text
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(1094670710611261973)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-TabsContainer #REGION_CSS_CLASSES#" #REGION_LANDMARK_ATTRIBUTES# #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Tabs-toolbar a-Toolbar">',
'    #SUB_REGION_HEADERS#',
'    <div class="a-Toolbar-items a-Toolbar-items--right">#NEXT#</div>',
'  </div>',
'  #SUB_REGIONS#',
'</div>'))
,p_sub_plug_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'#ENTRIES#',
'</ul>'))
,p_sub_plug_header_entry_templ=>'<li><a aria-hidden="true" href="##SUB_REGION_ID#"><span title="#SUB_REGION_TITLE#" class="a-Icon #SUB_REGION_ICON_CSS_CLASSES#"></span><span class="a-Tabs-label">#SUB_REGION_TITLE#</span></a></li>'
,p_sub_plug_template=>'#SUB_REGION#'
,p_page_plug_template_name=>'[x] APEX 5.1 - Tabs with Icons + Text'
,p_internal_name=>'APEX_5.1_TABS_WITH_ICONS_+_TEXT'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_default_landmark_type=>'region'
,p_reference_id=>1094662472079256126
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(68491993927610285)
,p_plug_template_id=>wwv_flow_imp.id(1094670710611261973)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(68492409757610285)
,p_plug_template_id=>wwv_flow_imp.id(1094670710611261973)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(68492974394610285)
,p_plug_template_id=>wwv_flow_imp.id(1094670710611261973)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_processing_spinner_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(1147295105621079968)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ProcessingRegion #REGION_CSS_CLASSES#" id="#REGION_STATIC_ID#" #REGION_ATTRIBUTES#>',
'  <span class="u-Processing"><span class="u-Processing-spinner"></span></span>',
'  <div class="a-ProcessingRegion-title">#TITLE#</div>',
'  <div class="a-ProcessingRegion-body">#BODY#</div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 5.0 - Processing Spinner Region'
,p_internal_name=>'APEX_5.0_PROCESSING_SPINNER_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>1147280303078953726
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(61235040076733464)
,p_plug_template_id=>wwv_flow_imp.id(1147295105621079968)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(61235583258733464)
,p_plug_template_id=>wwv_flow_imp.id(1147295105621079968)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_grouping_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(1157701840355546344)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Region #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#" role="group" aria-labelledby="#REGION_STATIC_ID#_label">',
'  <div class="a-Region-header">',
'    <div class="a-Region-headerItems  a-Region-headerItems--title">',
'      <h2 class="a-Region-title" id="#REGION_STATIC_ID#_label">#TITLE#</h2>',
'    </div>',
'    <div class="a-Region-headerItems  a-Region-headerItems--buttons">',
'      #PREVIOUS##EXPAND##EDIT##CHANGE##DELETE##COPY##HELP##NEXT##CREATE##CREATE2##CLOSE#',
'    </div>',
'  </div>',
'  <div class="a-Region-body">',
'  <div class="a-Region-bodyHeader">#REGION_HEADER#</div>',
'  #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'[x] APEX 5.0 - Grouping Region'
,p_internal_name=>'APEX_5.0_GROUPING_REGION'
,p_theme_id=>3
,p_theme_class_id=>21
,p_preset_template_options=>'a-Region--paddedBody:a-Region--simple'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>1157694368668532777
,p_translate_this_template=>'N'
,p_template_comment=>'      <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI a-Button--goToTop" onclick="uF();" type="button" title="&TOP."><span class="a-Icon icon-up-chevron"></span></button>'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60767747140232499)
,p_plug_template_id=>wwv_flow_imp.id(1157701840355546344)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60768224794232499)
,p_plug_template_id=>wwv_flow_imp.id(1157701840355546344)
,p_name=>'Change'
,p_placeholder=>'CHANGE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60768720005232499)
,p_plug_template_id=>wwv_flow_imp.id(1157701840355546344)
,p_name=>'Close'
,p_placeholder=>'CLOSE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60769257496232499)
,p_plug_template_id=>wwv_flow_imp.id(1157701840355546344)
,p_name=>'Copy'
,p_placeholder=>'COPY'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60769766213232500)
,p_plug_template_id=>wwv_flow_imp.id(1157701840355546344)
,p_name=>'Create'
,p_placeholder=>'CREATE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60770284759232500)
,p_plug_template_id=>wwv_flow_imp.id(1157701840355546344)
,p_name=>'Create2'
,p_placeholder=>'CREATE2'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60770736880232500)
,p_plug_template_id=>wwv_flow_imp.id(1157701840355546344)
,p_name=>'Delete'
,p_placeholder=>'DELETE'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60771270089232500)
,p_plug_template_id=>wwv_flow_imp.id(1157701840355546344)
,p_name=>'Edit'
,p_placeholder=>'EDIT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60771754329232501)
,p_plug_template_id=>wwv_flow_imp.id(1157701840355546344)
,p_name=>'Expand'
,p_placeholder=>'EXPAND'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60772223806232501)
,p_plug_template_id=>wwv_flow_imp.id(1157701840355546344)
,p_name=>'Help'
,p_placeholder=>'HELP'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60772710366232501)
,p_plug_template_id=>wwv_flow_imp.id(1157701840355546344)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60773201292232502)
,p_plug_template_id=>wwv_flow_imp.id(1157701840355546344)
,p_name=>'Previous'
,p_placeholder=>'PREVIOUS'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(60773783269232502)
,p_plug_template_id=>wwv_flow_imp.id(1157701840355546344)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_page_designer_tree_region
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(1493521415868700099)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="#REGION_STATIC_ID#" class="a-PageDesigner-treeRegion resize #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES#>',
'  <div class="a-Toolbar a-Toolbar-pageColumn a-Toolbar--treeRegion">',
'    <div class="a-Toolbar-items a-Toolbar-items--left">',
'      <h3 id="#REGION_STATIC_ID#_title" class="a-PageDesigner-treeTitle">#TITLE#</h3>',
'    </div>',
'    <div class="a-Toolbar-items a-Toolbar-items--right">#NEXT#</div>',
'  </div>',
'  <div class="a-PageDesigner-treeWrap u-ScrollingViewport resize">',
'    #BODY#',
'  </div>',
'</div>'))
,p_page_plug_template_name=>'APEX 5.0 - Page Designer Tree Region'
,p_internal_name=>'APEX_5.0_PAGE_DESIGNER_TREE_REGION'
,p_plug_table_bgcolor=>'#FFFFFF'
,p_theme_id=>3
,p_theme_class_id=>0
,p_plug_heading_bgcolor=>'#FFFFFF'
,p_plug_font_size=>'-1'
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_form_table_attr=>'class="htmldbInstruct"'
,p_reference_id=>1493511686675667790
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140434473313344582)
,p_plug_template_id=>wwv_flow_imp.id(1493521415868700099)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140434531495344582)
,p_plug_template_id=>wwv_flow_imp.id(1493521415868700099)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140434634893344582)
,p_plug_template_id=>wwv_flow_imp.id(1493521415868700099)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/region/apex_5_0_tabs_with_icons
begin
wwv_flow_imp_shared.create_plug_template(
 p_id=>wwv_flow_imp.id(2046260646916292813)
,p_layout=>'TABLE'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-TabsContainer #REGION_CSS_CLASSES#" #REGION_ATTRIBUTES# id="#REGION_STATIC_ID#">',
'  <div class="a-Tabs-toolbar a-Toolbar">',
'    #SUB_REGION_HEADERS#',
'    <div class="a-Toolbar-items a-Toolbar-items--right">#NEXT#</div>',
'  </div>',
'  #SUB_REGIONS#',
'</div>'))
,p_sub_plug_header_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'#ENTRIES#',
'</ul>'))
,p_sub_plug_header_entry_templ=>'<li><a href="##SUB_REGION_ID#"><span title="#SUB_REGION_TITLE#" class="a-Icon #SUB_REGION_ICON_CSS_CLASSES#"></span><span class="u-VisuallyHidden">#SUB_REGION_TITLE#</span></a></li>'
,p_sub_plug_template=>'#SUB_REGION#'
,p_page_plug_template_name=>'APEX 5.0 - Tabs with Icons'
,p_internal_name=>'APEX_5.0_TABS_WITH_ICONS'
,p_theme_id=>3
,p_theme_class_id=>21
,p_default_label_alignment=>'RIGHT'
,p_default_field_alignment=>'LEFT'
,p_reference_id=>2046249791523279568
,p_translate_this_template=>'N'
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140434760072344582)
,p_plug_template_id=>wwv_flow_imp.id(2046260646916292813)
,p_name=>'Region Body'
,p_placeholder=>'BODY'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>true
,p_has_button_support=>true
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140434829875344581)
,p_plug_template_id=>wwv_flow_imp.id(2046260646916292813)
,p_name=>'Sub Regions'
,p_placeholder=>'SUB_REGIONS'
,p_has_grid_support=>true
,p_has_region_support=>true
,p_has_item_support=>false
,p_has_button_support=>false
,p_glv_new_row=>true
);
wwv_flow_imp_shared.create_plug_tmpl_display_point(
 p_id=>wwv_flow_imp.id(140434937378344581)
,p_plug_template_id=>wwv_flow_imp.id(2046260646916292813)
,p_name=>'Next'
,p_placeholder=>'NEXT'
,p_has_grid_support=>false
,p_has_region_support=>false
,p_has_item_support=>false
,p_has_button_support=>true
,p_glv_new_row=>true
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_menu_popup
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(3712705120335)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Menu Popup'
,p_internal_name=>'APEX_5.0_MENU_POPUP'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var e = apex.jQuery("##PARENT_STATIC_ID#_menu", apex.gPageContext$);',
'if (e.hasClass("js-addActions")) {',
'  apex.actions.addFromMarkup(e);',
'}',
'e.menu({ slide: e.hasClass("js-slide")});',
''))
,p_theme_id=>3
,p_theme_class_id=>20
,p_list_template_before_rows=>'<div id="#PARENT_STATIC_ID#_menu" class="#COMPONENT_CSS_CLASSES#" style="display:none;"><ul>'
,p_list_template_after_rows=>'</ul></div>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_sub_list_item_noncurrent=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_item_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_item_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_sub_templ_curr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_sub_templ_noncurr_w_child=>'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>'
,p_a06_label=>'Target'
,p_reference_id=>747588010155545129
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(35066701739635046)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="u-vh">&nbsp;</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="u-vh">&nbsp;</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'[x] APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="u-vh">&nbsp;</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="u-vh">&nbsp;</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_wizard_progress
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(40780006081223991)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-active" aria-current="step">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-WizardSteps-step is-inactive">',
'  <div class="a-WizardSteps-wrap">',
'    <span class="a-WizardSteps-marker" aria-hidden="true"><span class="a-Icon icon-wizard-step-complete"></span></span>',
'    <span class="a-WizardSteps-label">#TEXT#</span>',
'  </div>',
'</li>',
''))
,p_list_template_name=>'APEX 5.0 - Wizard Progress'
,p_internal_name=>'APEX_5.0_WIZARD_PROGRESS'
,p_theme_id=>3
,p_theme_class_id=>17
,p_default_template_options=>'a-WizardSteps--slim'
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul aria-label="#CURRENT_PROGRESS#" class="a-WizardSteps #COMPONENT_CSS_CLASSES#">',
''))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>687902065557685310
);
end;
/
prompt --application/shared_components/user_interface/templates/list/horizontal_list_with_images_fixed_width_30pxc_htmldblistimageshfw
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(74758915661371633)
,p_list_template_current=>'<td align="center" valign="top"><a href="#LINK#" title="#TEXT_ESC_SC#"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# class="htmldbGreenIcon" /></a><a href="#LINK#" class="noVisit" title="#TEXT_ESC_SC#">#TEXT#</a></td>'
,p_list_template_noncurrent=>'<td align="center" valign="top"><a href="#LINK#" title="#TEXT_ESC_SC#"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# class="htmldbGreenIcon"/></a><a href="#LINK#" class="noVisit" title="#TEXT_ESC_SC#">#TEXT#</a></td>'
,p_list_template_name=>'Horizontal List with Images Fixed Width 30px(c:htmldbListImagesHFW)'
,p_internal_name=>'HORIZONTAL_LIST_WITH_IMAGES_FIXED_WIDTH_30PXC:HTMLDBLISTIMAGESHFW'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<table cellspacing="0" cellpadding="0" border="0" class="htmldbListImages30px" summary=""><tr>'
,p_list_template_after_rows=>'</tr></table>'
,p_reference_id=>338219701416750315
);
end;
/
prompt --application/shared_components/user_interface/templates/list/simple_image_list
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(115202108671032786)
,p_list_template_current=>'<li><a href="#LINK#" title="#TEXT#">#TEXT#</a></li>'
,p_list_template_noncurrent=>'<li><a href="#LINK#" title="#TEXT#">#TEXT#</a></li>'
,p_list_template_name=>'Simple Image List'
,p_internal_name=>'SIMPLE_IMAGE_LIST'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="listwithicon">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>32421627622986728
,p_list_template_comment=>'<img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# />'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/unordered_list_without_links
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(137847231212506770)
,p_list_template_current=>'<li><span class="fielddata">#TEXT#</span></li>'
,p_list_template_noncurrent=>'<li><span class="fielddata">#TEXT#</a></li>'
,p_list_template_name=>'unordered list without links'
,p_internal_name=>'UNORDERED_LIST_WITHOUT_LINKS'
,p_theme_id=>3
,p_theme_class_id=>1
,p_list_template_before_rows=>'<ul class="htmldbUl">'
,p_list_template_after_rows=>'</ul>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_sub_tabs
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(168712225287236339)
,p_list_template_current=>'<li class="a-Tabs-item is-active" aria-current="page"><a href="#LINK#" class="a-Tabs-link">#TEXT#</a></li>'
,p_list_template_noncurrent=>'<li class="a-Tabs-item"><a href="#LINK#" class="a-Tabs-link">#TEXT#</a></li>'
,p_list_template_name=>'APEX 5.0 - Sub Tabs'
,p_internal_name=>'APEX_5.0_SUB_TABS'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-TabsContainer a-TabsContainer--subTabs">',
'  <ul class="a-Tabs a-Tabs--subTabButtons">'))
,p_list_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  </ul>',
'</div>'))
,p_reference_id=>168708522102193705
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="aSubTabs"><ul>',
'<li class="active"><a href="#LINK#" title="#TEXT_ESC_SC#"><span>#TEXT#</span></a></li>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_4_2_run_edit_bar
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(210393202311761690)
,p_list_template_current=>'  <li><a href="#LINK#" title="#TEXT_ESC_SC#"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#TEXT_ESC_SC#" class="iconSmall #A01#" /></a></li>'
,p_list_template_noncurrent=>'  <li><a href="#LINK#" title="#TEXT_ESC_SC#"><img src="#IMAGE_PREFIX#f_spacer.gif" alt="#TEXT_ESC_SC#" class="iconSmall #A01#" /></a></li>'
,p_list_template_name=>'APEX 4.2 - Run / Edit Bar'
,p_internal_name=>'APEX_4.2_RUN_/_EDIT_BAR'
,p_theme_id=>3
,p_theme_class_id=>3
,p_list_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="aRunEditBar">',
'  <li><span class="currentPage">&PAGE. &FB_FLOW_PAGE_ID.</span></li>'))
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>210390516819756900
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_4_0_pull_down_button_list
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(253875121745621830)
,p_list_template_current=>'<button onclick="javascript:redirect(''#LINK#'')" class="aButton hotButton #A01#" type="button"><span>#TEXT#</span></button> '
,p_list_template_noncurrent=>'<button onclick="javascript:redirect(''#LINK#'')" class="aButton #A01#" type="button"><span>#TEXT#</span></button> '
,p_list_template_name=>'APEX 4.0 - Pull Down Button List'
,p_internal_name=>'APEX_4.0_PULL_DOWN_BUTTON_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_list_template_before_rows=>'<div class="rButtonContainer dhtmlMenuLGButton">'
,p_list_template_after_rows=>'</div>'
,p_before_sub_list=>'<ul id="#PARENT_LIST_ITEM_ID#" htmldb:listlevel="#LEVEL#" class="dhtmlSubMenu" style="display:none;">'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>'<li class="dhtmlMenuSep"><img src="#IMAGE_PREFIX#themes/theme_13/1px_trans.gif"  width="1" height="1" alt="" class="dhtmlMenuSep" /></li>'
,p_sub_list_item_noncurrent=>'<li><a href="#LINK#" class="dhtmlSubMenuN" onmouseover="dhtml_CloseAllSubMenusL(this)">#TEXT#</a></li>'
,p_item_templ_curr_w_child=>'<button onclick="javascript:redirect(''#LINK#'')" class="aButton hotButton #A01#" type="button"><span>#TEXT#</span></button> '
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button onclick="app_AppMenuMultiOpenBottom2(this,''#LIST_ITEM_ID#'',false)" class="dhtmlMenu" type="button"><span>#TEXT#<img src="#IMAGE_PREFIX#f_spacer.gif" alt="" /></span></button> ',
''))
,p_sub_templ_curr_w_child=>'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t13MIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" alt="" /></a></li>'
,p_sub_templ_noncurr_w_child=>'<li class="dhtmlSubMenuS"><a href="#LINK#" class="dhtmlSubMenuS" onmouseover="dhtml_MenuOpen(this,''#LIST_ITEM_ID#'',true,''Left'')"><span style="float:left;">#TEXT#</span><img class="t13MIMG" src="#IMAGE_PREFIX#menu_open_right2.gif" alt="" / ></a></li>'
,p_reference_id=>253872418832604079
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_navigation_list
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(384714985827023169)
,p_list_template_current=>'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>'
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>',
''))
,p_list_template_name=>'APEX 5.0 - Navigation List'
,p_internal_name=>'APEX_5.0_NAVIGATION_LIST'
,p_theme_id=>3
,p_theme_class_id=>7
,p_list_template_before_rows=>'<ul>'
,p_list_template_after_rows=>'</ul>'
,p_before_sub_list=>'<ul>'
,p_after_sub_list=>'</ul></li>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>',
''))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a></li>',
''))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>',
''))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-current="true" data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>',
''))
,p_sub_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li data-id="#A01#" data-disabled="#A02#" data-hide="#A03#" data-shortcut="#A05#" data-icon="#IMAGE#"><a href="#LINK#" title="#A04#" target="#A06#">#TEXT_ESC_SC#</a>',
''))
,p_a06_label=>'Link Target'
,p_reference_id=>573607518145151423
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_image_navigation
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(481294291606549740)
,p_list_template_current=>'<li class="a-ImageNav-item"><button type="button" data-link="#LINK#" class="a-ImageNav-link launch-aut #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></button></li>'
,p_list_template_noncurrent=>'<li class="a-ImageNav-item"><a href="#LINK#" class="a-ImageNav-link #A01#"><span class="a-ImageNav-img gi-icon-#IMAGE#"></span><span class="a-ImageNav-label">#TEXT_ESC_SC#</span></a></li>'
,p_list_template_name=>'APEX 5.0 - Image Navigation'
,p_internal_name=>'APEX_5.0_IMAGE_NAVIGATION'
,p_theme_id=>3
,p_theme_class_id=>0
,p_list_template_before_rows=>'<ul class="a-ImageNav #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>481290423891543508
,p_list_template_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<td style="width: 20%">',
'	<a href="#LINK#" class="iconContainer" title="#TEXT_ESC_SC#">',
'		<span class="largeIcon"><img src="#IMAGE_PREFIX##IMAGE#" #IMAGE_ATTR# /></span>',
'		<span class="iconLabel">#TEXT#</span>',
'	</a>',
'</td>'))
);
end;
/
prompt --application/shared_components/user_interface/templates/list/unordered_list_no_links
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(492140130336707768)
,p_list_template_current=>'<li>#TEXT#</li>'
,p_list_template_noncurrent=>'<li>#TEXT#</li>'
,p_list_template_name=>'Unordered List (no links)'
,p_internal_name=>'UNORDERED_LIST_NO_LINKS'
,p_theme_id=>3
,p_theme_class_id=>1
,p_list_template_before_rows=>'<ul class="htmldbUl">'
,p_list_template_after_rows=>'</ul>'
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_media_list
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(693422331030340241)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item is-active">',
'    <div class="a-MediaList-link">',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon" aria-hidden="true"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title" aria-describedby="description_#LIST_ITEM_ID#"><a href="#LINK#" aria-current="page" #A03#>#TEXT#</a></h3>',
'            <p id="description_#LIST_ITEM_ID#" class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </div>',
'</li>'))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-MediaList-item">',
'    <div class="a-MediaList-link">',
'        <div class="a-MediaList-iconWrap">',
'            <span class="a-MediaList-icon" aria-hidden="true"><span class="a-Icon #IMAGE#" #IMAGE_ATTR#></span></span>',
'        </div>',
'        <div class="a-MediaList-body">',
'            <h3 class="a-MediaList-title" aria-describedby="description_#LIST_ITEM_ID#"><a href="#LINK#" #A03#>#TEXT#</a></h3>',
'            <p id="description_#LIST_ITEM_ID#" class="a-MediaList-desc">#A01#</p>',
'        </div>',
'        <div class="a-MediaList-badgeWrap">',
'            <span class="a-MediaList-badge">#A02#</span>',
'        </div>',
'    </div>',
'</li>'))
,p_list_template_name=>'[x] APEX 5.0 - Media List'
,p_internal_name=>'APEX_5.0_MEDIA_LIST'
,p_theme_id=>3
,p_theme_class_id=>9
,p_default_template_options=>'a-MediaList--noBadge'
,p_list_template_before_rows=>'<ul class="a-MediaList #COMPONENT_CSS_CLASSES#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>692720897220784060
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_links_list_002
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(697214733556634905)
,p_list_template_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="u-vh">&nbsp;</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="u-vh">&nbsp;</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>',
''))
,p_list_template_name=>'[x] APEX 5.0 - Links List (2)'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_default_template_options=>'a-LinksList--showArrow'
,p_list_template_before_rows=>'<ul class="a-LinksList #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_after_sub_list=>'</ul>'
,p_sub_list_item_current=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_sub_list_item_noncurrent=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'</li>'))
,p_item_templ_curr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item is-current is-expanded #A03#" aria-current="page">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="u-vh">&nbsp;</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_item_templ_noncurr_w_child=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-LinksList-item #A03#">',
'  <a href="#LINK#" class="a-LinksList-link" #A02#>',
'    <span class="a-LinksList-icon" aria-hidden="true"><span class="t-Icon #IMAGE#"></span></span>',
'    <span class="a-LinksList-label">#TEXT#</span>',
'    <span class="u-vh">&nbsp;</span>',
'    <span class="a-LinksList-badge">#A01#</span>',
'    <span class="a-LinksList-arrow" aria-hidden="true"></span>',
'  </a>',
'  #SUB_LISTS#',
'</li>'))
,p_reference_id=>60219508156141083
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_basic_list
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(1141991473595113955)
,p_list_template_current=>'<li class="a-List-item is-current"><a href="#LINK#" class="a-Links-link" #A02#>#TEXT#</a></li>'
,p_list_template_noncurrent=>'<li class="a-List-item"><a href="#LINK#" class="a-Links-link" #A02#>#TEXT#</a></li>'
,p_list_template_name=>'APEX 5.0 - Basic List'
,p_internal_name=>'APEX_5.0_BASIC_LIST'
,p_theme_id=>3
,p_theme_class_id=>1
,p_list_template_before_rows=>'<ul class="a-List #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>1141986383000090627
);
end;
/
prompt --application/shared_components/user_interface/templates/list/apex_5_0_basic_list_no_links
begin
wwv_flow_imp_shared.create_list_template(
 p_id=>wwv_flow_imp.id(1141992015120113961)
,p_list_template_current=>'<li class="a-List-item is-current">#TEXT#</li>'
,p_list_template_noncurrent=>'<li class="a-List-item">#TEXT#</li>'
,p_list_template_name=>'APEX 5.0 - Basic List (no links)'
,p_internal_name=>'APEX_5.0_BASIC_LIST_NO_LINKS'
,p_theme_id=>3
,p_theme_class_id=>1
,p_list_template_before_rows=>'<ul class="a-List a-List--basic #COMPONENT_CSS_CLASSES#" id="#LIST_ID#">'
,p_list_template_after_rows=>'</ul>'
,p_reference_id=>1141988805895106920
);
end;
/
prompt --application/shared_components/user_interface/templates/report/embedded_code_analysis
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(1310649889953751)
,p_row_template_name=>'Embedded Code'
,p_internal_name=>'EMBEDDED_CODE_ANALYSIS'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-EmbeddedCode ">',
'  <div class="a-EmbeddedCode-header">',
'    <div class="a-EmbeddedCode-headerItems a-EmbeddedCode-headerItems--primary">',
'      <div class="a-EmbeddedCode-attr">#COMPONENT_NAME# &gt; #GROUP_NAME# &gt; #PROPERTY_NAME#</div>',
'    </div>',
'    <div class="a-EmbeddedCode-headerItems a-EmbeddedCode-headerItems--buttons">',
'    </div>',
'  </div>',
'  <div class="a-EmbeddedCode-body">',
'    <!-- Code --><pre>#PROPERTY_SOURCE#</pre>',
'  </div>',
'</div>'))
,p_row_template2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-EmbeddedCode ">',
'  <div class="a-EmbeddedCode-header">',
'    <div class="a-EmbeddedCode-headerItems a-EmbeddedCode-headerItems--primary">',
'      <div class="a-EmbeddedCode-attr">#SCOPE_NAME#</div>',
'      <div class="a-EmbeddedCode-attr">#COMPONENT_TYPE_NAME#: #COMPONENT_NAME#</div>',
'    </div>',
'    <div class="a-EmbeddedCode-headerItems a-EmbeddedCode-headerItems--secondary">',
'      <div class="a-EmbeddedCode-attr">#GROUP_NAME#</div>',
'      <div class="a-EmbeddedCode-attr">#PROPERTY_NAME#</div>',
'    </div>',
'    <div class="a-EmbeddedCode-headerItems a-EmbeddedCode-headerItems--buttons">',
'      <!-- button data-link="" data-appid="#FLOW_ID#" data-pageid="#PAGE_ID#" data-typeid="#COMPONENT_TYPE_ID#" data-componentid="#COMPONENT_ID#">View</button -->',
'    </div>',
'  </div>',
'  <div class="a-EmbeddedCode-body">',
'    <!-- Code --><pre>#PROPERTY_SOURCE#</pre>',
'  </div>',
'</div>'))
,p_row_template_before_rows=>'<div class="apex-grid-container">'
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</div>',
'<table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>'))
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/p1911_rest_services
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(4900642989550776)
,p_row_template_name=>'P1911_REST_SERVICES'
,p_internal_name=>'P1911_REST_SERVICES'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ContentRowReport-item">',
'  <div class="a-ContentRowReport-itemWrap" id="service_#ID#">',
'    <div class="a-ContentRowReport-itemBody">',
'      <div class="a-ContentRowReport-itemContent">',
'        <h3 class="a-ContentRowReport-itemTitle">#NAME#</h3>',
'        <div class="a-ContentRowReport-itemDescription">#DESCRIPTION#</div>',
'        <div class="a-ContentRowReport-itemDescription a-ContentRowReport-itemDescription--operations">#OPERATIONS_HTML#</div>',
'      </div>',
'      <div class="a-ContentRowReport-itemActions">',
'        <button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noLabel" aria-label="Add #NAME#" title="Add #NAME#" type="button"><span class="a-Icon #ICON_CLASS#" aria-hidden="true"></span></button>',
'      </div>',
'    </div>',
'  </div>',
'</div>',
''))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-ContentRowReport a-IssueList">',
''))
,p_row_template_after_rows=>'</div>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_links_list
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(11667910335347890)
,p_row_template_name=>'APEX 5.0 - Links List'
,p_internal_name=>'APEX_5.0_LINKS_LIST'
,p_row_template1=>'<li class="a-LinksList-item">#COLUMN_VALUE#</li>'
,p_row_template_before_rows=>'<ul class="a-LinksList a-LinksList--report #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES#>'
,p_row_template_after_rows=>'</ul>'
,p_row_template_before_first=>'OMIT'
,p_row_template_after_last=>'OMIT'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'OMIT'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_default_template_options=>'a-LinksList--nowrap:a-LinksList--showArrow'
,p_reference_id=>17383712077884846
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/result
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(33634627411119986)
,p_row_template_name=>'Result'
,p_internal_name=>'RESULT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<tr><td align="left" class="header" style="width:70px;">#COLUMN_HEADER#</th><td#ALIGNMENT#>#COLUMN_VALUE#</td></tr>',
''))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<style>',
'table.htmldbStandard3 td.header { vertical-align:middle; }',
'table.htmldbStandard3 td.pagination { border: medium none; }',
'</style>',
'<div role="article">',
'<table width="100%" cellpadding="2" cellspacing="0" class="htmldbStandard3" role="presentation" datatable="0" summary="">',
'<tbody>'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</tbody>',
'</table>',
'</div>'))
,p_row_template_after_last=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</tbody>',
'</table>',
'</div>',
'<p></p>',
'<div role="article">',
'<table width="100%" cellpadding="2" cellspacing="0" class="htmldbStandard3" role="presentation" datatable="0" summary="">',
'<tbody>'))
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#TEXT#',
''))
,p_row_style_mouse_over=>'#CCCCCC'
,p_row_style_checked=>'#CCCCCC'
,p_theme_id=>3
,p_theme_class_id=>6
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_4_2_portlet_row_template
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(47141516446071328)
,p_row_template_name=>'APEX 4.2 - Portlet Row Template'
,p_internal_name=>'APEX_4.2_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46763700145123930
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_4_2_portlet_column_template
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(47939419129227350)
,p_row_template_name=>'APEX 4.2 - Portlet Column Template'
,p_internal_name=>'APEX_4.2_PORTLET_COLUMN_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/vertical_standard
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(82116118900238363)
,p_row_template_name=>'Vertical Standard'
,p_internal_name=>'VERTICAL_STANDARD'
,p_row_template1=>'<tr><td scope="row" class="label">#COLUMN_HEADER#</td><td class="data">#COLUMN_VALUE#</td></tr>'
,p_row_template_before_rows=>'#CSV_LINK#<table class="htmldbVerticalRegion2"  summary="#REGION_TITLE#" cellpadding="0" cellspacing="0" border="0">'
,p_row_template_after_rows=>'</table>'
,p_row_template_before_first=>' '
,p_row_template_after_last=>'<tr><td class="blank"><br /></td><td class="blank"><br /></td></tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'NOT_CONDITIONAL'
,p_row_template_display_cond2=>'NOT_CONDITIONAL'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'NOT_CONDITIONAL'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>81978430803840109
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_vertical_report
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(82408032331628644)
,p_row_template_name=>'APEX 5.0 - Vertical Report'
,p_internal_name=>'APEX_5.0_VERTICAL_REPORT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<tr>',
'  <td class="a-Report-cell a-Report-cell--header" scope="row">#COLUMN_HEADER#</td>',
'  <td class="a-Report-cell">#COLUMN_VALUE#</td>',
'</tr>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report a-Report--vertical a-Report--staticRowColors #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>' '
,p_row_template_after_last=>' '
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>1126924627125205941
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_standard_report
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(123728124628276646)
,p_row_template_name=>'APEX 5.0 - Standard Report'
,p_internal_name=>'APEX_5.0_STANDARD_REPORT'
,p_row_template1=>'<td class="a-Report-cell" #ALIGNMENT# #ACCESSIBLE_HEADERS# headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Report #COMPONENT_CSS_CLASSES#" id="report_#REGION_STATIC_ID#" #REPORT_ATTRIBUTES#>',
'  <div class="a-Report-wrap">',
'    <table class="a-Report-pagination" role="presentation">#TOP_PAGINATION#</table>',
'    <div class="a-Report-tableWrap">',
'    <table class="a-Report-report" aria-label="#REGION_TITLE#">'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      </tbody>',
'    </table>',
'    </div>',
'    <div class="a-Report-links">#EXTERNAL_LINK##CSV_LINK#</div>',
'    <table class="a-Report-pagination a-Report-pagination a-Report-pagination--bottom" role="presentation">#PAGINATION#</table>',
'  </div>',
'</div>'))
,p_row_template_before_first=>'<tr>'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_before_column_heading=>'<thead>'
,p_column_heading_template=>'<th class="a-Report-colHead" #ALIGNMENT# #ARIA_SORT# id="#COLUMN_HEADER_NAME#" #COLUMN_WIDTH#>#COLUMN_HEADER#</th>'
,p_after_column_heading=>'</thead><tbody>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_pagination_template=>'<span class="a-Report-paginationText">#TEXT#</span>'
,p_next_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_page_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS#',
'</a>'))
,p_next_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  #PAGINATION_NEXT_SET#<span class="a-Icon icon-right-arrow"></span>',
'</a>'))
,p_previous_set_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#LINK#" class="a-Report-paginationLink">',
'  <span class="a-Icon icon-left-arrow"></span>#PAGINATION_PREVIOUS_SET#',
'</a>'))
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>123725814882271159
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/no_background
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(249244707741859303)
,p_row_template_name=>'No Background'
,p_internal_name=>'NO_BACKGROUND'
,p_row_template1=>'<td#ALIGNMENT# id="td#ROWNUM#_#COLNUM#" headers="#COLUMN_HEADER_NAME#">#COLUMN_VALUE#</td>'
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellspacing="0" cellpadding="0" class="htmldbRptNoBackground" summary="#REGION_TITLE#">',
'<tbody>'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</tbody>',
'</table>'))
,p_row_template_before_first=>'<tr id="row#ROWNUM#">'
,p_row_template_after_last=>'</tr>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>237868603542157245
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/p890_ad_matching_items
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(254124201814387924)
,p_row_template_name=>'P890_AD_MATCHING_ITEMS'
,p_internal_name=>'P890_AD_MATCHING_ITEMS'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<tr><td>#CHK#</td><td>#REGION_NAME#</td><td>#I_NAME#</td><td>#I_LABEL#</td><td>#I_HELP_TEXT#</td><td>#I_FORMAT_MASK#</td><td>#I_FORMAT_MASK2#</td><td>#I_DEFAULT#</td><td>#I_WIDTH#</td><td>#I_HEIGHT#</td><td>#I_DATA_TYPE#</td></tr>',
'<tr><td>&nbsp;</td><td>#FROM_AD#</td><td>#C_COLUMN_NAME#</td><td>#C_LABEL#</td><td>#C_HELP_TEXT#</td><td>#C_FORMAT_MASK#</td><td>#C_FORM_FORMAT_MASK#</td><td>#C_DEFAULT_VALUE#</td><td>#C_FORM_DISPLAY_WIDTH#</td><td>#C_FORM_DISPLAY_HEIGHT#</td><td>#C_'
||'FORM_DATA_TYPE#</td></tr>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellpadding="0" cellspacing="0" class="htmldbStandard3"  border="0" summary="" id="#REGION_ID#">',
'<tbody>'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</tbody>',
'</table>'))
,p_row_template_type=>'NAMED_COLUMNS'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>2
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/p897_ad_matching_rc
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(257016805324994583)
,p_row_template_name=>'P897_AD_MATCHING_RC'
,p_internal_name=>'P897_AD_MATCHING_RC'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<tr><td>#CHK#</td><td>#REGION_NAME#</td><td>#RC_NAME#</td><td>#RC_LABEL#</td><td>#RC_HELP_TEXT#</td><td>#RC_FORMAT_MASK#</td><td>#RC_FORMAT_MASK2#</td><td>#RC_REPORT_COL_ALIGN#</td></tr>',
'<tr><td>&nbsp;</td><td>#FROM_AD#</td><td>&nbsp;</td><td>#C_LABEL#</td><td>#C_HELP_TEXT#</td><td>#C_FORMAT_MASK#</td><td>#C_REPORT_FORMAT_MASK#</td><td>#C_REPORT_COL_ALIGN#</td></tr>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellpadding="0" cellspacing="0" class="htmldbStandard3"  border="0" summary="" id="#REGION_ID#">',
'<tbody>'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</tbody>',
'</table>'))
,p_row_template_type=>'NAMED_COLUMNS'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>2
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/p921_ad_matching_items
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(446094518404500200)
,p_row_template_name=>'P921_AD_MATCHING_ITEMS'
,p_internal_name=>'P921_AD_MATCHING_ITEMS'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<tr><td>#CHK#</td><td>#REGION_NAME#</td><td>#I_NAME#</td><td>#I_LABEL#</td><td>#I_HELP_TEXT#</td><td>#I_FORMAT_MASK#</td><td>#I_DEFAULT#</td><td>#I_WIDTH#</td><td>#I_HEIGHT#</td><td>#I_DATA_TYPE#</td></tr>',
'<tr><td>&nbsp;</td><td>#FROM_AD#</td><td>#C_COLUMN_NAME#</td><td>#C_LABEL#</td><td>#C_HELP_TEXT#</td><td>#C_FORMAT_MASK#</td><td>#C_DEFAULT_VALUE#</td><td>#C_FORM_DISPLAY_WIDTH#</td><td>#C_FORM_DISPLAY_HEIGHT#</td><td>#C_FORM_DATA_TYPE#</td></tr>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellpadding="0" cellspacing="0" class="htmldbStandard3"  border="0" summary="" id="#REGION_ID#">',
'<tbody>'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</tbody>',
'</table>'))
,p_row_template_type=>'NAMED_COLUMNS'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>2
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/p922_ad_matching_rc
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(446251712544425577)
,p_row_template_name=>'P922_AD_MATCHING_RC'
,p_internal_name=>'P922_AD_MATCHING_RC'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<tr><td>#CHK#</td><td>#REGION_NAME#</td><td>#RC_NAME#</td><td>#RC_LABEL#</td><td>#RC_HELP_TEXT#</td><td>#RC_FORMAT_MASK#</td><td>#RC_REPORT_COL_ALIGN#</td></tr>',
'<tr><td>&nbsp;</td><td>#FROM_AD#</td><td>&nbsp;</td><td>#C_LABEL#</td><td>#C_HELP_TEXT#</td><td>#C_FORMAT_MASK#</td><td>#C_REPORT_COL_ALIGN#</td></tr>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table cellpadding="0" cellspacing="0" class="htmldbStandard3"  border="0" summary="" id="#REGION_ID#">',
'<tbody>'))
,p_row_template_after_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</tbody>',
'</table>'))
,p_row_template_type=>'NAMED_COLUMNS'
,p_column_heading_template=>'<th#ALIGNMENT# id="#COLUMN_HEADER_NAME#">#COLUMN_HEADER#</th>'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>2
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_app_cards_report
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(1041639921134406508)
,p_row_template_name=>'APEX 5.0 - App Cards Report'
,p_internal_name=>'APEX_5.0_APP_CARDS_REPORT'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AppCards-item #ID#">',
'  <div class="a-AppCards-itemContainer">',
'    <div class="a-AppCards-iconContainer">',
'      <span class="a-AppCards-icon #ICON_CLASS#"></span>',
'    </div>',
'    <div class="a-AppCards-contentContainer" id="#ID#_name">',
'      <h2 class="a-AppCards-name">#APP_NAME#</h2>',
'      <div class="a-AppCards-info">#APP_INFO#</div>',
'    </div>',
'    <div class="a-AppCards-actionsContainer">',
'        #MODIFY_APP_BUTTON#',
'        #RUN_APP_BUTTON#',
'    </div>',
'  </div>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AppCards a-AppCards--slim  a-AppCards--stacked">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>932268343459577530
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_named_column
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(1041640454953406573)
,p_row_template_name=>'APEX 5.0 - Badge List (Named Column)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_NAMED_COLUMN'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-BadgeList-item #A01#">',
'  <span class="a-BadgeList-label">#COLUMN_HEADER#</span>',
'  <span class="a-BadgeList-value">#COLUMN_VALUE#</span>',
'</li>',
''))
,p_row_template_before_rows=>'<ul class="a-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_preset_template_options=>'a-BadgeList--fixed:a-BadgeList--large'
,p_reference_id=>488487951233692049
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_badge_list_row
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(1041645002243406588)
,p_row_template_name=>'APEX 5.0 - Badge List (Row)'
,p_internal_name=>'APEX_5.0_BADGE_LIST_ROW'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="t-BadgeList-item">',
'  <span class="t-BadgeList-label">#1#</span>',
'  <span class="t-BadgeList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="t-BadgeList #COMPONENT_CSS_CLASSES#">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>6
,p_reference_id=>689060248369886348
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_column_template
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(1041645860037406591)
,p_row_template_name=>'APEX 5.0 - Portlet Column Template'
,p_internal_name=>'APEX_5.0_PORTLET_COLUMN_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#COLUMN_HEADER#</span>',
'  <span class="a-AVPList-value">#COLUMN_VALUE#</span>',
'</li>'))
,p_row_template_before_rows=>'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">'
,p_row_template_after_rows=>'</ul>'
,p_row_template_table_attr=>'OMIT'
,p_row_template_type=>'GENERIC_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'NOT_CONDITIONAL'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43020300221196425
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/report/apex_5_0_portlet_row_template
begin
wwv_flow_imp_shared.create_row_template(
 p_id=>wwv_flow_imp.id(1041646592238406593)
,p_row_template_name=>'APEX 5.0 - Portlet Row Template'
,p_internal_name=>'APEX_5.0_PORTLET_ROW_TEMPLATE'
,p_row_template1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-AVPList-item">',
'  <span class="a-AVPList-label">#1#</span>',
'  <span class="a-AVPList-value">#2#</span>',
'</li>'))
,p_row_template_before_rows=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul class="a-AVPList #COMPONENT_CSS_CLASSES#" #REPORT_ATTRIBUTES# id="#REGION_ID#_report">',
''))
,p_row_template_after_rows=>'</ul>'
,p_row_template_type=>'NAMED_COLUMNS'
,p_row_template_display_cond1=>'0'
,p_row_template_display_cond2=>'0'
,p_row_template_display_cond3=>'0'
,p_row_template_display_cond4=>'0'
,p_theme_id=>3
,p_theme_class_id=>7
,p_reference_id=>46763700145123930
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/outline_label_required
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(1385827696712229)
,p_template_name=>'Outline Label - Required'
,p_internal_name=>'OUTLINE_LABEL_REQUIRED'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="field-label__container field-col-3">',
'<label class="field-label" id="#CURRENT_ITEM_ID#_LABEL" for="#CURRENT_ITEM_NAME#">',
''))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="field field--style--boxed field--required #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="field-input__container field-col-9">',
'<div class="field-input__wrap">'))
,p_after_element=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</div>',
'</div>',
'#ERROR_TEMPLATE#',
'#HELP_TEMPLATE#',
'#INLINE_HELP_TEMPLATE#'))
,p_inline_help_text=>'<div class="a-Form-inlineHelp">#CURRENT_ITEM_INLINE_HELP_TEXT#</div>'
,p_error_template=>'<div class="field-error-message">#ERROR_MESSAGE#</div>'
,p_theme_id=>3
,p_theme_class_id=>3
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/hidden_label_read_by_screen_reader
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(4923925522744860)
,p_template_name=>'Hidden label, read by screen reader'
,p_internal_name=>'HIDDEN_LABEL,_READ_BY_SCREEN_READER'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" tabindex="999" class="hideMeButHearMe">'
,p_template_body2=>'</label>'
,p_on_error_after_label=>'<br/>#ERROR_MESSAGE#'
,p_theme_id=>3
,p_theme_class_id=>13
,p_reference_id=>4903009179971452
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/formfield_optional_no_labelonly_for_radiogroup
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(43067330834852524)
,p_template_name=>'FormField_Optional (no label-only for radiogroup)'
,p_internal_name=>'FORMFIELD_OPTIONAL_NO_LABELONLY_FOR_RADIOGROUP'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="aLabel aOptional"><a href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
,p_template_body2=>'</a></label>'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>43065615312847035
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_4_0_top_bar_label
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(57731626458856526)
,p_template_name=>'APEX 4.0 - Top Bar Label'
,p_internal_name=>'APEX_4.0_TOP_BAR_LABEL'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#"><a class="apex-ga-label" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
,p_template_body2=>'</a></label>'
,p_theme_id=>3
,p_theme_class_id=>0
,p_reference_id=>57728329098847875
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/formfield_optional
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(93372822814585113)
,p_template_name=>'FormField_Optional'
,p_internal_name=>'FORMFIELD_OPTIONAL'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="aLabel aOptional"><a href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
,p_template_body2=>'</a></label>'
,p_on_error_after_label=>'<small class="aError">#ERROR_MESSAGE#</small>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17388415351892041
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/columnheader
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(94297512553409964)
,p_template_name=>'ColumnHeader'
,p_internal_name=>'COLUMNHEADER'
,p_template_body1=>'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="aLabel aOptional"><a href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
,p_template_body2=>'</a></label>'
,p_on_error_after_label=>'<small class="aError">#ERROR_MESSAGE#</small>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17388415351892041
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(452656722938220607)
,p_template_name=>'APEX 5.0 - Required Label'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE##INLINE_HELP_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_inline_help_text=>'<div class="a-Form-inlineHelp">#CURRENT_ITEM_INLINE_HELP_TEXT#</div>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487443659585685414
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(561547836135222071)
,p_template_name=>'APEX 5.0 - Optional Label'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE##INLINE_HELP_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_inline_help_text=>'<div class="a-Form-inlineHelp">#CURRENT_ITEM_INLINE_HELP_TEXT#</div>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>487444299516703815
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_optional_label_above
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(561549638722251517)
,p_template_name=>'APEX 5.0 - Optional Label (Above)'
,p_internal_name=>'APEX_5.0_OPTIONAL_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE##INLINE_HELP_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_inline_help_text=>'<div class="a-Form-inlineHelp">#CURRENT_ITEM_INLINE_HELP_TEXT#</div>'
,p_on_error_after_label=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492676964457041934
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_required_label_above
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(561549716994252345)
,p_template_name=>'APEX 5.0 - Required Label (Above)'
,p_internal_name=>'APEX_5.0_REQUIRED_LABEL_ABOVE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' </label>#HELP_TEMPLATE#',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer a-Form-fieldContainer--stacked #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>492677038682043223
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_hidden_label
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(566010921977401124)
,p_template_name=>'APEX 5.0 - Hidden Label'
,p_internal_name=>'APEX_5.0_HIDDEN_LABEL'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer a-Form-labelContainer--visuallyhidden">',
'<label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label visuallyhidden">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'#HELP_TEMPLATE##ERROR_TEMPLATE#</div>'
,p_help_link=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-itemHelp" data-itemhelp="#CURRENT_ITEM_ID#" title="#CURRENT_ITEM_HELP_LABEL#"  aria-label="#CURRENT_ITEM_HELP_LABEL#" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidde'
||'n="true"></span></button>'
,p_theme_id=>3
,p_theme_class_id=>4
,p_reference_id=>687907221148719616
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/label/apex_5_0_dynamic_attribute
begin
wwv_flow_imp_shared.create_field_template(
 p_id=>wwv_flow_imp.id(566053095724681231)
,p_template_name=>'APEX 5.0 - Dynamic Attribute'
,p_internal_name=>'APEX_5.0_DYNAMIC_ATTRIBUTE'
,p_template_body1=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-Form-labelContainer">',
'  <span class="a-Form-required"><span class="a-Icon icon-asterisk"></span></span><label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#" class="a-Form-label">'))
,p_template_body2=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <span class="u-VisuallyHidden">(#VALUE_REQUIRED#)</span></label>',
'</div>'))
,p_before_item=>'<div class="a-Form-fieldContainer #ITEM_CSS_CLASSES#" id="#CURRENT_ITEM_CONTAINER_ID#">'
,p_after_item=>'</div>'
,p_before_element=>'<div class="a-Form-inputContainer">'
,p_after_element=>'<button class="a-Button a-Button--noUI a-Button--helpButton js-dynamicItemHelp" data-itemname="#CURRENT_ITEM_NAME#" data-appid="&FB_FLOW_ID." title="" aria-label="" tabindex="-1" type="button"><span class="a-Icon icon-help" aria-hidden="true"></span>'
||'</button>#ERROR_TEMPLATE#</div>'
,p_error_template=>'<span class="a-Form-error">#ERROR_MESSAGE#</span>'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>692681574974429799
,p_translate_this_template=>'N'
,p_template_comment=>'<label for="#CURRENT_ITEM_NAME#"><a class="htmldbLabelOptional" href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',''&SESSION.'',''&CLOSE.'')" tabindex="999">'
);
end;
/
prompt --application/shared_components/user_interface/templates/breadcrumb/apex_5_0_breadcrumbs
begin
wwv_flow_imp_shared.create_menu_template(
 p_id=>wwv_flow_imp.id(3705314539083)
,p_name=>'APEX 5.0 - Breadcrumbs'
,p_internal_name=>'APEX_5.0_BREADCRUMBS'
,p_before_first=>'<ul class="a-Breadcrumb">'
,p_current_page_option=>'<li class="a-Breadcrumb-item a-Breadcrumb-item is-active" aria-current="page"><span class="a-Breadcrumb-label">#NAME#</span></li>'
,p_non_current_page_option=>'<li class="a-Breadcrumb-item"><a href="#LINK#" class="a-Breadcrumb-label">#NAME#</a></li>'
,p_after_last=>'</ul>'
,p_max_levels=>8
,p_start_with_node=>'PARENT_TO_LEAF'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>689285808648404711
,p_translate_this_template=>'N'
);
end;
/
prompt --application/shared_components/user_interface/templates/popuplov
begin
wwv_flow_imp_shared.create_popup_lov_template(
 p_id=>wwv_flow_imp.id(10217320099610442)
,p_page_name=>'winlov'
,p_page_title=>'Search Dialog'
,p_page_html_head=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<!DOCTYPE html>',
'<html lang="&BROWSER_LANGUAGE.">',
'<head>',
'<title>#TITLE#</title>',
'#APEX_CSS#',
'#THEME_CSS#',
'#APEX_JAVASCRIPT#',
'<meta name="viewport" content="width=device-width,initial-scale=1.0" />',
'<link rel="shortcut icon" href="#IMAGE_PREFIX#favicon.ico" type="image/x-icon">',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'<link rel="stylesheet" href="#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css?v=#APEX_VERSION#" type="text/css"/>',
'</head>'))
,p_page_body_attr=>'onload="first_field()" class="a-Page a-Page--popupLOV"'
,p_before_field_text=>'<div class="a-PopupLOV-actions a-Form--large">'
,p_filter_width=>'15'
,p_filter_max_width=>'100'
,p_filter_text_attr=>'class="a-Form-field a-Form-searchField"'
,p_find_button_text=>'Search'
,p_find_button_attr=>'class="a-Button a-Button--hot a-Button--padLeft"'
,p_close_button_text=>'Close'
,p_close_button_attr=>'class="a-Button u-pullRight"'
,p_next_button_text=>'Next &gt;'
,p_next_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_prev_button_text=>'&lt; Previous'
,p_prev_button_attr=>'class="a-Button a-PopupLOV-button"'
,p_after_field_text=>'</div>'
,p_scrollbars=>'1'
,p_resizable=>'1'
,p_width=>'380'
,p_height=>'480'
,p_result_row_x_of_y=>'<div class="a-PopupLOV-pagination">Row(s) #FIRST_ROW# - #LAST_ROW#</div>'
,p_result_rows_per_pg=>200
,p_before_result_set=>'<div class="a-PopupLOV-links">'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>17343114994581872
,p_translate_this_template=>'N'
,p_after_result_set=>'</div>'
);
end;
/
prompt --application/shared_components/user_interface/templates/calendar/default_calander
begin
wwv_flow_imp_shared.create_calendar_template(
 p_id=>wwv_flow_imp.id(48746021817975821)
,p_cal_template_name=>'Default Calander'
,p_internal_name=>'DEFAULT_CALANDER'
,p_day_of_week_format=>'<th scope="col" width="14%" class="htmldbDayOfWeek">#IDAY#</th>'
,p_month_title_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<table class="htmldbCalendarHolder" cellpadding="0" cellspacing="0" border="0" width="100%" summary="" role="presentation"><tr>',
'<td class="htmldbMonthTitle">#IMONTH# #YYYY#</td>',
'</tr>',
'<tr><td>'))
,p_month_open_format=>'<table class="htmldbCalendar" cellpadding="0" cellspacing="3" border="0" width="100%" summary="#CALENDAR_TITLE# #IMONTH# #YYYY#">'
,p_month_close_format=>wwv_flow_string.join(wwv_flow_t_varchar2(
'</table></td></tr></table>',
'',
''))
,p_day_title_format=>'<div class="htmldbDayTitle">#DD#</div>'
,p_day_open_format=>'<td class="htmldbDay">#TITLE_FORMAT##DATA#'
,p_day_close_format=>'</td>'
,p_today_open_format=>'<td class="htmldbToday">#TITLE_FORMAT##DATA#'
,p_weekend_title_format=>'<div class="htmldbWeekendDayTitle">#DD#</div>'
,p_weekend_open_format=>'<td class="htmldbWeekendDay">#TITLE_FORMAT##DATA#'
,p_weekend_close_format=>'</td>'
,p_nonday_title_format=>'<div class="htmldbNonDayTitle">#DD#</div>'
,p_nonday_open_format=>'<td class="htmldbNonDay">'
,p_nonday_close_format=>'</td>'
,p_week_open_format=>'<tr>'
,p_week_close_format=>'</tr>'
,p_daily_title_format=>'<th width="14%" class="calheader">#IDAY#</th>'
,p_daily_open_format=>'<tr>'
,p_daily_close_format=>'</tr>'
,p_month_data_format=>'#DAYS#'
,p_month_data_entry_format=>'#DATA#'
,p_theme_id=>3
,p_theme_class_id=>1
,p_reference_id=>353925314576528967
);
end;
/
prompt --application/shared_components/user_interface/themes
begin
wwv_flow_imp_shared.create_theme(
 p_id=>wwv_flow_imp.id(59096518392456939)
,p_theme_id=>3
,p_theme_name=>'APEX 5.0'
,p_theme_internal_name=>'APEX_5.0'
,p_navigation_type=>'T'
,p_nav_bar_type=>'NAVBAR'
,p_is_locked=>false
,p_default_page_template=>wwv_flow_imp.id(386677207130845076)
,p_default_dialog_template=>wwv_flow_imp.id(689065306389965836)
,p_error_template=>wwv_flow_imp.id(702688271851047856)
,p_printer_friendly_template=>wwv_flow_imp.id(386677207130845076)
,p_default_button_template=>wwv_flow_imp.id(183227826797404355)
,p_default_region_template=>wwv_flow_imp.id(174794400314076650)
,p_default_chart_template=>wwv_flow_imp.id(174794400314076650)
,p_default_form_template=>wwv_flow_imp.id(174794400314076650)
,p_default_reportr_template=>wwv_flow_imp.id(174794400314076650)
,p_default_tabform_template=>wwv_flow_imp.id(174794400314076650)
,p_default_wizard_template=>wwv_flow_imp.id(42025417508627628)
,p_default_menur_template=>wwv_flow_imp.id(208928010704475743)
,p_default_listr_template=>wwv_flow_imp.id(174794400314076650)
,p_default_irr_template=>wwv_flow_imp.id(646287526247383209)
,p_default_report_template=>wwv_flow_imp.id(123728124628276646)
,p_default_label_template=>wwv_flow_imp.id(561547836135222071)
,p_default_menu_template=>wwv_flow_imp.id(3705314539083)
,p_default_calendar_template=>wwv_flow_imp.id(48746021817975821)
,p_default_list_template=>wwv_flow_imp.id(697214733556634905)
,p_default_nav_list_template=>wwv_flow_imp.id(384714985827023169)
,p_default_top_nav_list_temp=>wwv_flow_imp.id(384714985827023169)
,p_default_nav_list_position=>'TOP'
,p_theme_description=>'Oracle APEX 5.0 Internal Theme'
,p_file_prefix => nvl(wwv_flow_application_install.get_static_theme_file_prefix(3),'')
,p_files_version=>3
,p_css_file_urls=>'#IMAGE_PREFIX#libraries/oracle-fonts/oraclesans-apex#MIN#.css?v=#APEX_VERSION#'
);
end;
/
prompt --application/shared_components/user_interface/theme_style
begin
wwv_flow_imp_shared.create_theme_style(
 p_id=>wwv_flow_imp.id(72328790154483268)
,p_theme_id=>3
,p_name=>'DARK'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>true
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_imp_shared.create_theme_style(
 p_id=>wwv_flow_imp.id(204021106338377303)
,p_theme_id=>3
,p_name=>'STANDARD'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_imp_shared.create_theme_style(
 p_id=>wwv_flow_imp.id(556394191660089195)
,p_theme_id=>3
,p_name=>'DARK_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Dark#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
wwv_flow_imp_shared.create_theme_style(
 p_id=>wwv_flow_imp.id(556394903837090864)
,p_theme_id=>3
,p_name=>'STANDARD_AUTO'
,p_css_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#apex_ui/css/Core#MIN#.css',
'#IMAGE_PREFIX#apex_ui/css/Theme-Standard#MIN#.css'))
,p_is_current=>false
,p_is_public=>false
,p_is_accessible=>false
,p_theme_roller_read_only=>false
);
end;
/
prompt --application/shared_components/user_interface/theme_files
begin
null;
end;
/
prompt --application/shared_components/user_interface/template_opt_groups
begin
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(557449644465308555)
,p_theme_id=>3
,p_name=>'DIALOG_SIZE'
,p_display_name=>'Dialog Size'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Predefined dialog sizes'
,p_null_text=>'Default Size'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(689275479820315778)
,p_theme_id=>3
,p_name=>'REGION_STYLE'
,p_display_name=>'Region Style'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Style'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(689276459702315779)
,p_theme_id=>3
,p_name=>'REGION_PADDING'
,p_display_name=>'Region Padding'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Padding'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(689609975484986633)
,p_theme_id=>3
,p_name=>'REGION_POSITION'
,p_display_name=>'Region Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(689612194925986634)
,p_theme_id=>3
,p_name=>'REGION_OVERFLOW'
,p_display_name=>'Region Overflow'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(689868183333651274)
,p_theme_id=>3
,p_name=>'BUTTON_SET'
,p_display_name=>'Button Set'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Not Part of Button Set'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(689868297807651274)
,p_theme_id=>3
,p_name=>'BUTTON_SIZE'
,p_display_name=>'Button Size'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Button Size'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(689868381320651274)
,p_theme_id=>3
,p_name=>'BUTTON_TYPE'
,p_display_name=>'Button Type'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(689868416983651275)
,p_theme_id=>3
,p_name=>'ICON_POSITION'
,p_display_name=>'Icon Position'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Icon on Right'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(689868559342651275)
,p_theme_id=>3
,p_name=>'SPACING_LEFT'
,p_display_name=>'Spacing left'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Left Spacing'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(689868654527651275)
,p_theme_id=>3
,p_name=>'SPACING_RIGHT'
,p_display_name=>'Spacing Right'
,p_display_sequence=>1
,p_template_types=>'BUTTON'
,p_null_text=>'Default Right Spacing'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(689868765490651276)
,p_theme_id=>3
,p_name=>'HEIGHT'
,p_display_name=>'Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Behavior'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(689868817587651276)
,p_theme_id=>3
,p_name=>'MAX_HEIGHT'
,p_display_name=>'Max Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'No Max Height'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(689868920676651276)
,p_theme_id=>3
,p_name=>'MIN_HEIGHT'
,p_display_name=>'Min Height'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'No Min Height'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(689869052561651276)
,p_theme_id=>3
,p_name=>'ALTERNATING_TABLE_ROWS'
,p_display_name=>'Alternating Table Rows'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Enable'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(689869144051651276)
,p_theme_id=>3
,p_name=>'BADGE_LAYOUT'
,p_display_name=>'Badge Layout'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(689869268409651276)
,p_theme_id=>3
,p_name=>'BADGE_SIZE'
,p_display_name=>'Badge Size'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(689869335183651277)
,p_theme_id=>3
,p_name=>'REPORT_BORDER'
,p_display_name=>'Report Border'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default Border'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(689869421097651277)
,p_theme_id=>3
,p_name=>'REPORT_WIDTH'
,p_display_name=>'Report Width'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(689869558173651277)
,p_theme_id=>3
,p_name=>'ROW_HIGHLIGHTING'
,p_display_name=>'Row Highlighting'
,p_display_sequence=>1
,p_template_types=>'REPORT'
,p_null_text=>'Disable'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(689974585962172027)
,p_theme_id=>3
,p_name=>'DISPLAY'
,p_display_name=>'Display'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(693422786205340253)
,p_theme_id=>3
,p_name=>'LAYOUT'
,p_display_name=>'Layout'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(696621762127145456)
,p_theme_id=>3
,p_name=>'REGION_TITLE'
,p_display_name=>'Region Title'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(697227913650708839)
,p_theme_id=>3
,p_name=>'DISPLAY_ICONS'
,p_display_name=>'Display Icons'
,p_display_sequence=>1
,p_template_types=>'LIST'
,p_null_text=>'Default - No Icons'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(740999402311610211)
,p_theme_id=>3
,p_name=>'FORM_LABEL_ALIGNMENT'
,p_display_name=>'Form Label Alignment'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_help_text=>'Set Form Alignment for Grid Based forms'
,p_null_text=>'Right'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(740999733250610212)
,p_theme_id=>3
,p_name=>'FORM_LABEL_WIDTH'
,p_display_name=>'Form Label Width'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(741000588924610212)
,p_theme_id=>3
,p_name=>'LABEL_WIDTH'
,p_display_name=>'Label Width'
,p_display_sequence=>1
,p_template_types=>'FIELD'
,p_null_text=>'Default'
,p_is_advanced=>'Y'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(741000825482610212)
,p_theme_id=>3
,p_name=>'FORM_LABEL_POSITION'
,p_display_name=>'Form Label Position'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_null_text=>'Default Position'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_opt_group(
 p_id=>wwv_flow_imp.id(770240942803907358)
,p_theme_id=>3
,p_name=>'ALERT_TYPE'
,p_display_name=>'Alert Type'
,p_display_sequence=>1
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
end;
/
prompt --application/shared_components/user_interface/template_options
begin
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1493552334426775)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden to Assistive Tech'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(646287526247383209)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_imp.id(696621762127145456)
,p_template_types=>'REGION'
,p_help_text=>'By default, region title is hidden but accessible, use this option to remove the header from accessible interface'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(557450019695308556)
,p_theme_id=>3
,p_name=>'SMALL_480X320'
,p_display_name=>'Small (480x320)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(557449278618308550)
,p_css_classes=>'js-dialog-size480x320'
,p_group_id=>wwv_flow_imp.id(557449644465308555)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(557450481324308556)
,p_theme_id=>3
,p_name=>'MEDIUM_600X400'
,p_display_name=>'Medium (600x400)'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_imp.id(557449278618308550)
,p_css_classes=>'js-dialog-size600x400'
,p_group_id=>wwv_flow_imp.id(557449644465308555)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(557450884814308556)
,p_theme_id=>3
,p_name=>'LARGE_720X480'
,p_display_name=>'Large (720x480)'
,p_display_sequence=>3
,p_region_template_id=>wwv_flow_imp.id(557449278618308550)
,p_css_classes=>'js-dialog-size720x480'
,p_group_id=>wwv_flow_imp.id(557449644465308555)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(557451214013308556)
,p_theme_id=>3
,p_name=>'DRAGGABLE'
,p_display_name=>'Draggable'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(557449278618308550)
,p_css_classes=>'js-draggable'
,p_template_types=>'REGION'
,p_help_text=>'Allow dialog to be moved.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(557451669999308556)
,p_theme_id=>3
,p_name=>'MODAL'
,p_display_name=>'Modal'
,p_display_sequence=>3
,p_region_template_id=>wwv_flow_imp.id(557449278618308550)
,p_css_classes=>'js-modal'
,p_template_types=>'REGION'
,p_help_text=>'Display as modal.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(557452054623308557)
,p_theme_id=>3
,p_name=>'RESIZABLE'
,p_display_name=>'Resizable'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_imp.id(557449278618308550)
,p_css_classes=>'js-resizable'
,p_template_types=>'REGION'
,p_help_text=>'Allow dialog to be resized.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(697208282774627562)
,p_theme_id=>3
,p_name=>'2COLUMNGRID'
,p_display_name=>'2 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(693422331030340241)
,p_css_classes=>'a-MediaList--cols a-MediaList--2cols'
,p_group_id=>wwv_flow_imp.id(693422786205340253)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(697208599626627562)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(693422331030340241)
,p_css_classes=>'a-MediaList--cols a-MediaList--3cols'
,p_group_id=>wwv_flow_imp.id(693422786205340253)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(697208841349627562)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(693422331030340241)
,p_css_classes=>'a-MediaList--cols a-MediaList--4cols'
,p_group_id=>wwv_flow_imp.id(693422786205340253)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(697209169260627562)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(693422331030340241)
,p_css_classes=>'a-MediaList--cols a-MediaList--5cols'
,p_group_id=>wwv_flow_imp.id(693422786205340253)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(697209451926627562)
,p_theme_id=>3
,p_name=>'SPANHORIZONTALLY'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(693422331030340241)
,p_css_classes=>'a-MediaList--horizontal'
,p_group_id=>wwv_flow_imp.id(693422786205340253)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(697209751633627562)
,p_theme_id=>3
,p_name=>'HIDEBADGE'
,p_display_name=>'Hide Badge'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(693422331030340241)
,p_css_classes=>'a-MediaList--noBadge'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(697210078067627562)
,p_theme_id=>3
,p_name=>'HIDEDESCRIPTION'
,p_display_name=>'Hide Description'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(693422331030340241)
,p_css_classes=>'a-MediaList--noDesc'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(697210336187627563)
,p_theme_id=>3
,p_name=>'HIDETITLE'
,p_display_name=>'Hide Title'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(693422331030340241)
,p_css_classes=>'a-MediaList--noTitle'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(697210620803627563)
,p_theme_id=>3
,p_name=>'HIDEICONS'
,p_display_name=>'Hide Icons'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(693422331030340241)
,p_css_classes=>'a-MediaList--noIcons'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(697210944203627563)
,p_theme_id=>3
,p_name=>'SLIMLIST'
,p_display_name=>'Slim List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(693422331030340241)
,p_css_classes=>'a-MediaList--slim'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741089654519003588)
,p_theme_id=>3
,p_name=>'180PX'
,p_display_name=>'180px'
,p_display_sequence=>10
,p_css_classes=>'h180'
,p_group_id=>wwv_flow_imp.id(689868765490651276)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741089874408003588)
,p_theme_id=>3
,p_name=>'240PX'
,p_display_name=>'240px'
,p_display_sequence=>20
,p_css_classes=>'h240'
,p_group_id=>wwv_flow_imp.id(689868765490651276)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741090096334003588)
,p_theme_id=>3
,p_name=>'320PX'
,p_display_name=>'320px'
,p_display_sequence=>30
,p_css_classes=>'h320'
,p_group_id=>wwv_flow_imp.id(689868765490651276)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741090264686003589)
,p_theme_id=>3
,p_name=>'480PX'
,p_display_name=>'480px'
,p_display_sequence=>50
,p_css_classes=>'h480'
,p_group_id=>wwv_flow_imp.id(689868765490651276)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741090448934003589)
,p_theme_id=>3
,p_name=>'540PX'
,p_display_name=>'540px'
,p_display_sequence=>60
,p_css_classes=>'h540'
,p_group_id=>wwv_flow_imp.id(689868765490651276)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741090694411003589)
,p_theme_id=>3
,p_name=>'640PX'
,p_display_name=>'640px'
,p_display_sequence=>70
,p_css_classes=>'h640'
,p_group_id=>wwv_flow_imp.id(689868765490651276)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741090865640003590)
,p_theme_id=>3
,p_name=>'ALIGNLABELSLEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Form--leftLabels'
,p_group_id=>wwv_flow_imp.id(740999402311610211)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741091001367003591)
,p_theme_id=>3
,p_name=>'AUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form--autoWidthLabels'
,p_group_id=>wwv_flow_imp.id(740999733250610212)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741091228485003591)
,p_theme_id=>3
,p_name=>'FIRSTBUTTON'
,p_display_name=>'First Button'
,p_display_sequence=>1
,p_css_classes=>'a-Button--pillStart'
,p_group_id=>wwv_flow_imp.id(689868183333651274)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741091450592003591)
,p_theme_id=>3
,p_name=>'FIXEDLARGE'
,p_display_name=>'Fixed (Large Width)'
,p_display_sequence=>30
,p_css_classes=>'a-Form-fixedLabelsLarge'
,p_group_id=>wwv_flow_imp.id(740999733250610212)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741091609300003591)
,p_theme_id=>3
,p_name=>'FIXEDMEDIUM'
,p_display_name=>'Fixed (Medium Width)'
,p_display_sequence=>20
,p_css_classes=>'a-Form-fixedLabelsMed'
,p_group_id=>wwv_flow_imp.id(740999733250610212)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741091829391003591)
,p_theme_id=>3
,p_name=>'FIXEDWIDTH'
,p_display_name=>'Fixed'
,p_display_sequence=>10
,p_css_classes=>'a-Form--fixedLabels'
,p_group_id=>wwv_flow_imp.id(740999733250610212)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741092059119003591)
,p_theme_id=>3
,p_name=>'INNERBUTTON'
,p_display_name=>'Inner Button'
,p_display_sequence=>2
,p_css_classes=>'a-Button--pill'
,p_group_id=>wwv_flow_imp.id(689868183333651274)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741092244160003591)
,p_theme_id=>3
,p_name=>'LABELAUTOWIDTH'
,p_display_name=>'Auto Width'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_group_id=>wwv_flow_imp.id(741000588924610212)
,p_template_types=>'FIELD'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741092481259003591)
,p_theme_id=>3
,p_name=>'LABELSABOVE'
,p_display_name=>'Labels Above'
,p_display_sequence=>1
,p_css_classes=>'a-Form--labelsAbove'
,p_group_id=>wwv_flow_imp.id(741000825482610212)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741092636692003591)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'Large'
,p_display_sequence=>3
,p_css_classes=>'a-Button--large'
,p_group_id=>wwv_flow_imp.id(689868297807651274)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741092876511003591)
,p_theme_id=>3
,p_name=>'LARGELEFT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapLeft'
,p_group_id=>wwv_flow_imp.id(689868559342651275)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741093074530003591)
,p_theme_id=>3
,p_name=>'LARGERIGHT'
,p_display_name=>'Large'
,p_display_sequence=>1
,p_css_classes=>'a-Button--gapRight'
,p_group_id=>wwv_flow_imp.id(689868654527651275)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741093290797003592)
,p_theme_id=>3
,p_name=>'LASTBUTTON'
,p_display_name=>'Last Button'
,p_display_sequence=>3
,p_css_classes=>'a-Button--pillEnd'
,p_group_id=>wwv_flow_imp.id(689868183333651274)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741093445931003592)
,p_theme_id=>3
,p_name=>'LEFTICON'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_imp.id(689868416983651275)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741093643245003592)
,p_theme_id=>3
,p_name=>'PRIMARY'
,p_display_name=>'Primary'
,p_display_sequence=>1
,p_css_classes=>'a-Button--primary'
,p_group_id=>wwv_flow_imp.id(689868381320651274)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741093760024003592)
,p_theme_id=>3
,p_name=>'REGIONHEADERBUTTON'
,p_display_name=>'Button in Region Header'
,p_display_sequence=>1
,p_css_classes=>'a-Button--regionHeader'
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741093930595003592)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--small'
,p_group_id=>wwv_flow_imp.id(689868297807651274)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741094134610003592)
,p_theme_id=>3
,p_name=>'SMALLLEFT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padLeft'
,p_group_id=>wwv_flow_imp.id(689868559342651275)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741094365819003592)
,p_theme_id=>3
,p_name=>'SMALLRIGHT'
,p_display_name=>'Small'
,p_display_sequence=>1
,p_css_classes=>'a-Button--padRight'
,p_group_id=>wwv_flow_imp.id(689868654527651275)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741094405091003592)
,p_theme_id=>3
,p_name=>'STRETCHFORMFIELD'
,p_display_name=>'Stretch Form Field'
,p_display_sequence=>1
,p_css_classes=>'a-Form-fieldContainer--stretch'
,p_template_types=>'FIELD'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741094500525003592)
,p_theme_id=>3
,p_name=>'STRONGBUTTONLABEL'
,p_display_name=>'Strong Button Label'
,p_display_sequence=>1
,p_css_classes=>'a-Button--strongLabel'
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741106414101342390)
,p_theme_id=>3
,p_name=>'REGIONCONTAINSITEMSTEXT'
,p_display_name=>'Region Contains Items / Text'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(689274781922315777)
,p_css_classes=>'a-ButtonRegion--withItems'
,p_template_types=>'REGION'
,p_help_text=>'Check this option if this region contains items or text.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741106693350342391)
,p_theme_id=>3
,p_name=>'REMOVEUIDECORATION'
,p_display_name=>'Remove UI Decoration'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(689274781922315777)
,p_css_classes=>'a-ButtonRegion--noUI'
,p_group_id=>wwv_flow_imp.id(689275479820315778)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741106839320342397)
,p_theme_id=>3
,p_name=>'REMOVEBORDERS'
,p_display_name=>'Remove Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(689274781922315777)
,p_css_classes=>'a-ButtonRegion--noBorder'
,p_group_id=>wwv_flow_imp.id(689275479820315778)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741107026275342397)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(689274781922315777)
,p_css_classes=>'a-ButtonRegion--slimPadding'
,p_group_id=>wwv_flow_imp.id(689276459702315779)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741107203618342399)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(689274781922315777)
,p_css_classes=>'a-ButtonRegion--noPadding'
,p_group_id=>wwv_flow_imp.id(689276459702315779)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741107306045342399)
,p_theme_id=>3
,p_name=>'WIZARDDIALOG'
,p_display_name=>'Used for Wizard Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(689274781922315777)
,p_css_classes=>'a-ButtonRegion--wizard'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741107560569342399)
,p_theme_id=>3
,p_name=>'VISIBLE'
,p_display_name=>'Visible'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(689274781922315777)
,p_css_classes=>'a-ButtonRegion--showTitle'
,p_group_id=>wwv_flow_imp.id(696621762127145456)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(741107715180342399)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(689274781922315777)
,p_css_classes=>'a-ButtonRegion--accessibleTitle'
,p_group_id=>wwv_flow_imp.id(696621762127145456)
,p_template_types=>'REGION'
,p_help_text=>'Use this option to add a visually hidden heading which is accessible for screen readers, but otherwise not visible to users.'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(770242153138907403)
,p_theme_id=>3
,p_name=>'USE_COLORED_BACKGROUND'
,p_display_name=>'Use Colored Background'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(770240542605907344)
,p_css_classes=>'a-Alert--colorBG'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(770242217774907403)
,p_theme_id=>3
,p_name=>'USE_DEFAULT_ICONS'
,p_display_name=>'Use Default Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(770240542605907344)
,p_css_classes=>'a-Alert--defaultIcons'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(770242455742907403)
,p_theme_id=>3
,p_name=>'WARNING'
,p_display_name=>'Warning'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(770240542605907344)
,p_css_classes=>'a-Alert--warning'
,p_group_id=>wwv_flow_imp.id(770240942803907358)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(770242628364907403)
,p_theme_id=>3
,p_name=>'ERROR'
,p_display_name=>'Error'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(770240542605907344)
,p_css_classes=>'a-Alert--danger'
,p_group_id=>wwv_flow_imp.id(770240942803907358)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(770242837432907403)
,p_theme_id=>3
,p_name=>'INFORMATIONAL'
,p_display_name=>'Informational'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(770240542605907344)
,p_css_classes=>'a-Alert--info'
,p_group_id=>wwv_flow_imp.id(770240942803907358)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(770243035659907403)
,p_theme_id=>3
,p_name=>'HORIZONTAL'
,p_display_name=>'Horizontal'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(770240542605907344)
,p_css_classes=>'a-Alert--horizontal'
,p_group_id=>wwv_flow_imp.id(689974585962172027)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(770243278580907403)
,p_theme_id=>3
,p_name=>'WIZARD'
,p_display_name=>'Wizard'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(770240542605907344)
,p_css_classes=>'a-Alert--wizard'
,p_group_id=>wwv_flow_imp.id(689974585962172027)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(770243316570907403)
,p_theme_id=>3
,p_name=>'REMOVE_ICON'
,p_display_name=>'Remove Icons'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(770240542605907344)
,p_css_classes=>'a-Alert--noIcon'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(770243580216907404)
,p_theme_id=>3
,p_name=>'SUCCESS'
,p_display_name=>'Success'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(770240542605907344)
,p_css_classes=>'a-Alert--success'
,p_group_id=>wwv_flow_imp.id(770240942803907358)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(787114313200949704)
,p_theme_id=>3
,p_name=>'DISABLE'
,p_display_name=>'Disable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(123728124628276646)
,p_css_classes=>'a-Report--staticRowColors'
,p_group_id=>wwv_flow_imp.id(689869052561651276)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(787114559371949704)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(123728124628276646)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_imp.id(689869558173651277)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(787114799989949705)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(123728124628276646)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_imp.id(689869335183651277)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(787114909189949705)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(123728124628276646)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_imp.id(689869335183651277)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(787115121173949705)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(123728124628276646)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_imp.id(689869335183651277)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(787115251459949705)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(123728124628276646)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(787115445447949705)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(123728124628276646)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_imp.id(689869421097651277)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(928526155605885181)
,p_theme_id=>3
,p_name=>'ADD_ACTIONS'
,p_display_name=>'Add Actions'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(3712705120335)
,p_css_classes=>'js-addActions'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(928526230711885181)
,p_theme_id=>3
,p_name=>'ADD_SLIDE_ANIMATION'
,p_display_name=>'Add Slide Animation'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(3712705120335)
,p_css_classes=>'js-slide'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(940695146455341564)
,p_theme_id=>3
,p_name=>'SLIMPROGRESSLIST'
,p_display_name=>'Slim Progress List'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_css_classes=>'a-WizardSteps--slim'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1041642598877406586)
,p_theme_id=>3
,p_name=>'FLOATITEMS'
,p_display_name=>'Float Items'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(1041640454953406573)
,p_css_classes=>'a-BadgeList--float'
,p_group_id=>wwv_flow_imp.id(689869144051651276)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1041642782980406586)
,p_theme_id=>3
,p_name=>'FIXED'
,p_display_name=>'Span Horizontally'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(1041640454953406573)
,p_css_classes=>'a-BadgeList--fixed'
,p_group_id=>wwv_flow_imp.id(689869144051651276)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1041642919363406586)
,p_theme_id=>3
,p_name=>'STACKEDVERTICALLY'
,p_display_name=>'Stacked Vertically'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(1041640454953406573)
,p_css_classes=>'a-BadgeList--stacked'
,p_group_id=>wwv_flow_imp.id(689869144051651276)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1041643122919406586)
,p_theme_id=>3
,p_name=>'SMALL'
,p_display_name=>'32px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(1041640454953406573)
,p_css_classes=>'a-BadgeList--small'
,p_group_id=>wwv_flow_imp.id(689869268409651276)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1041643316814406586)
,p_theme_id=>3
,p_name=>'MEDIUM'
,p_display_name=>'48px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(1041640454953406573)
,p_css_classes=>'a-BadgeList--medium'
,p_group_id=>wwv_flow_imp.id(689869268409651276)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1041643534111406586)
,p_theme_id=>3
,p_name=>'LARGE'
,p_display_name=>'64px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(1041640454953406573)
,p_css_classes=>'a-BadgeList--large'
,p_group_id=>wwv_flow_imp.id(689869268409651276)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1041643755288406586)
,p_theme_id=>3
,p_name=>'XLARGE'
,p_display_name=>'96px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(1041640454953406573)
,p_css_classes=>'a-BadgeList--xlarge'
,p_group_id=>wwv_flow_imp.id(689869268409651276)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1041643993798406587)
,p_theme_id=>3
,p_name=>'XXLARGE'
,p_display_name=>'128px'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(1041640454953406573)
,p_css_classes=>'a-BadgeList--xxlarge'
,p_group_id=>wwv_flow_imp.id(689869268409651276)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1041644125366406587)
,p_theme_id=>3
,p_name=>'2COLUMNNGRID'
,p_display_name=>'2 Columnn Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(1041640454953406573)
,p_css_classes=>'a-BadgeList--cols'
,p_group_id=>wwv_flow_imp.id(689869144051651276)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1041644335394406587)
,p_theme_id=>3
,p_name=>'3COLUMNGRID'
,p_display_name=>'3 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(1041640454953406573)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--3cols'
,p_group_id=>wwv_flow_imp.id(689869144051651276)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1041644531040406588)
,p_theme_id=>3
,p_name=>'4COLUMNGRID'
,p_display_name=>'4 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(1041640454953406573)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--4cols'
,p_group_id=>wwv_flow_imp.id(689869144051651276)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1041644798256406588)
,p_theme_id=>3
,p_name=>'5COLUMNGRID'
,p_display_name=>'5 Column Grid'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(1041640454953406573)
,p_css_classes=>'a-BadgeList--cols a-BadgeList--5cols'
,p_group_id=>wwv_flow_imp.id(689869144051651276)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1041644987372406588)
,p_theme_id=>3
,p_name=>'FLEXIBLEBOX'
,p_display_name=>'Flexible Box'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(1041640454953406573)
,p_css_classes=>'a-BadgeList--flex'
,p_group_id=>wwv_flow_imp.id(689869144051651276)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1131767082685193976)
,p_theme_id=>3
,p_name=>'ENABLE'
,p_display_name=>'Enable'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(82408032331628644)
,p_css_classes=>'a-Report--rowHighlight'
,p_group_id=>wwv_flow_imp.id(689869558173651277)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1131767234242193977)
,p_theme_id=>3
,p_name=>'HORIZONTALBORDERS'
,p_display_name=>'Horizontal Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(82408032331628644)
,p_css_classes=>'a-Report--horizontalBorders'
,p_group_id=>wwv_flow_imp.id(689869335183651277)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1131767367046193977)
,p_theme_id=>3
,p_name=>'INLINEBORDERS'
,p_display_name=>'Inline Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(82408032331628644)
,p_css_classes=>'a-Report--inline'
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1131767505289193977)
,p_theme_id=>3
,p_name=>'NOBORDERS'
,p_display_name=>'No Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(82408032331628644)
,p_css_classes=>'a-Report--noBorders'
,p_group_id=>wwv_flow_imp.id(689869335183651277)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1131767726172193977)
,p_theme_id=>3
,p_name=>'STRETCH'
,p_display_name=>'Stretch'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(82408032331628644)
,p_css_classes=>'a-Report--stretch'
,p_group_id=>wwv_flow_imp.id(689869421097651277)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1131767933421193977)
,p_theme_id=>3
,p_name=>'VERTICALBORDERS'
,p_display_name=>'Vertical Borders'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(82408032331628644)
,p_css_classes=>'a-Report--verticalBorders'
,p_group_id=>wwv_flow_imp.id(689869335183651277)
,p_template_types=>'REPORT'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1157703657591546357)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(1157701840355546344)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_imp.id(696621762127145456)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1157703851151546357)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(1157701840355546344)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_imp.id(689612194925986634)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1157704045732546357)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(1157701840355546344)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_imp.id(689275479820315778)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1157704296302546362)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(1157701840355546344)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_imp.id(689276459702315779)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1157704476411546362)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(1157701840355546344)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_imp.id(696621762127145456)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1157704697318546362)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(1157701840355546344)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_imp.id(689276459702315779)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1157704791946546362)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(1157701840355546344)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1157704943766546362)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(1157701840355546344)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_imp.id(689612194925986634)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1157705149026546362)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(1157701840355546344)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_imp.id(689609975484986633)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1157705301596546363)
,p_theme_id=>3
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(1157701840355546344)
,p_css_classes=>'a-Region--simple'
,p_group_id=>wwv_flow_imp.id(689275479820315778)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1157705569971546363)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(1157701840355546344)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_imp.id(689276459702315779)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1199561996520032428)
,p_theme_id=>3
,p_name=>'LEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_imp.id(689868416983651275)
,p_template_types=>'BUTTON'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1241666629605396955)
,p_theme_id=>3
,p_name=>'USED_IN_DIALOG'
,p_display_name=>'Used in Dialog'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(1147295105621079968)
,p_css_classes=>'a-ProcessingRegion--dialog'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525650263272182045)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(35066701739635046)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525650309409182045)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(35066701739635046)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525650489655182045)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(35066701739635046)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525650593590182045)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(35066701739635046)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525650727471182049)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(35066701739635046)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_imp.id(697227913650708839)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525650922468182049)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(35066701739635046)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_imp.id(697227913650708839)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525666591122182129)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525666601935182129)
,p_theme_id=>3
,p_name=>'SHOWBADGES'
,p_display_name=>'Show Badges'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
,p_css_classes=>'a-LinksList--showBadge'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525666759120182129)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525666870164182129)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525667010590182130)
,p_theme_id=>3
,p_name=>'FORTOPLEVELONLY'
,p_display_name=>'For top level only'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
,p_css_classes=>'a-LinksList--showTopIcons'
,p_group_id=>wwv_flow_imp.id(697227913650708839)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1525667204783182130)
,p_theme_id=>3
,p_name=>'FORALLITEMS'
,p_display_name=>'For all items'
,p_display_sequence=>1
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
,p_css_classes=>'a-LinksList--showIcons'
,p_group_id=>wwv_flow_imp.id(697227913650708839)
,p_template_types=>'LIST'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1544814692647477977)
,p_theme_id=>3
,p_name=>'SHOWRIGHTARROW'
,p_display_name=>'Show Right Arrow'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(11667910335347890)
,p_css_classes=>'a-LinksList--showArrow'
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1544814737392477978)
,p_theme_id=>3
,p_name=>'USEBRIGHTHOVERS'
,p_display_name=>'Use Bright Hovers'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(11667910335347890)
,p_css_classes=>'a-LinksList--brightHover'
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1544814888710477978)
,p_theme_id=>3
,p_name=>'DONOTWRAPTEXT'
,p_display_name=>'Do not wrap text'
,p_display_sequence=>1
,p_report_template_id=>wwv_flow_imp.id(11667910335347890)
,p_css_classes=>'a-LinksList--nowrap'
,p_template_types=>'REPORT'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554810431372408369)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(174794400314076650)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_imp.id(696621762127145456)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554810659695408369)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(174794400314076650)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_imp.id(696621762127145456)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554810897146408369)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(174794400314076650)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_imp.id(689276459702315779)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554811060927408369)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(174794400314076650)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_imp.id(689276459702315779)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554811297403408370)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(174794400314076650)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_imp.id(689609975484986633)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554811421358408370)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(174794400314076650)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_imp.id(689275479820315778)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554811633484408370)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(174794400314076650)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_imp.id(689612194925986634)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554811807637408370)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(174794400314076650)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_imp.id(689612194925986634)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554812055317408370)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(174794400314076650)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_imp.id(689276459702315779)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554812141738408370)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(174794400314076650)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554812303379408370)
,p_theme_id=>3
,p_name=>'SIMPLE'
,p_display_name=>'Simple'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(174794400314076650)
,p_css_classes=>'a-Region--simple'
,p_group_id=>wwv_flow_imp.id(689275479820315778)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554833614262526816)
,p_theme_id=>3
,p_name=>'RESPONSIVEICONCOLUMNS'
,p_display_name=>'Responsive Icon Columns'
,p_display_sequence=>2
,p_region_template_id=>wwv_flow_imp.id(646287526247383209)
,p_css_classes=>'a-IRR-region--responsiveIconView'
,p_template_types=>'REGION'
,p_help_text=>'Automatically increases number of icon columns to show based on screen resolution.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554833748011526816)
,p_theme_id=>3
,p_name=>'ICONLABELSRIGHT'
,p_display_name=>'Icon Labels on Right'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(646287526247383209)
,p_css_classes=>'a-IRR-region--iconLabelsRight'
,p_template_types=>'REGION'
,p_help_text=>'Shows labels in Icon View to the right of the icon.'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554833844943526816)
,p_theme_id=>3
,p_name=>'REMOVEOUTERBORDERS'
,p_display_name=>'Remove Outer Borders'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(646287526247383209)
,p_css_classes=>'a-IRR-region--noOuterBorders'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554842901348542264)
,p_theme_id=>3
,p_name=>'FLUSHREGION'
,p_display_name=>'Flush Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(689970285456172024)
,p_css_classes=>'a-Region--flush'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554843076144542264)
,p_theme_id=>3
,p_name=>'STACKEDREGION'
,p_display_name=>'Stacked Region'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(689970285456172024)
,p_css_classes=>'a-Region--stacked'
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554843225147542265)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(689970285456172024)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_imp.id(689276459702315779)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554843436268542265)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(689970285456172024)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_imp.id(689276459702315779)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554843620652542265)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(689970285456172024)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_imp.id(689609975484986633)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554843876432542265)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(689970285456172024)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_imp.id(689275479820315778)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554844000995542265)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(689970285456172024)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_imp.id(689612194925986634)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554844269412542265)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(689970285456172024)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_imp.id(689612194925986634)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554844448441542265)
,p_theme_id=>3
,p_name=>'EXPANDED'
,p_display_name=>'Expanded'
,p_display_sequence=>.1
,p_region_template_id=>wwv_flow_imp.id(689970285456172024)
,p_css_classes=>'is-expanded'
,p_group_id=>wwv_flow_imp.id(689974585962172027)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554844621223542265)
,p_theme_id=>3
,p_name=>'COLLAPSED'
,p_display_name=>'Collapsed'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(689970285456172024)
,p_css_classes=>'is-collapsed'
,p_group_id=>wwv_flow_imp.id(689974585962172027)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554870725945550824)
,p_theme_id=>3
,p_name=>'REMOVE_TOP_BORDER'
,p_display_name=>'Remove Top Border'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(655568879441187677)
,p_css_classes=>'a-Region--noTopBorder'
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554870994093550824)
,p_theme_id=>3
,p_name=>'ACCESSIBLEHEADING'
,p_display_name=>'Hidden (Accessible)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(655568879441187677)
,p_css_classes=>'a-Region--accessibleHeader'
,p_group_id=>wwv_flow_imp.id(696621762127145456)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554871126221550824)
,p_theme_id=>3
,p_name=>'AUTOSCROLL'
,p_display_name=>'Scroll'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(655568879441187677)
,p_css_classes=>'a-Region--scrollAuto'
,p_group_id=>wwv_flow_imp.id(689612194925986634)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554871306470550825)
,p_theme_id=>3
,p_name=>'BORDERLESS'
,p_display_name=>'Borderless'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(655568879441187677)
,p_css_classes=>'a-Region--noBorder'
,p_group_id=>wwv_flow_imp.id(689275479820315778)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554871539071550825)
,p_theme_id=>3
,p_name=>'DEFAULTPADDING'
,p_display_name=>'Default Padding'
,p_display_sequence=>30
,p_region_template_id=>wwv_flow_imp.id(655568879441187677)
,p_css_classes=>'a-Region--paddedBody'
,p_group_id=>wwv_flow_imp.id(689276459702315779)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554871719655550825)
,p_theme_id=>3
,p_name=>'HIDDEN'
,p_display_name=>'Hidden'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(655568879441187677)
,p_css_classes=>'a-Region--hideHeader'
,p_group_id=>wwv_flow_imp.id(696621762127145456)
,p_template_types=>'REGION'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554871913363550825)
,p_theme_id=>3
,p_name=>'NOPADDING'
,p_display_name=>'No Padding'
,p_display_sequence=>10
,p_region_template_id=>wwv_flow_imp.id(655568879441187677)
,p_css_classes=>'a-Region--noPadding'
,p_group_id=>wwv_flow_imp.id(689276459702315779)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554872192256550825)
,p_theme_id=>3
,p_name=>'SCROLLWITHSHADOWS'
,p_display_name=>'Scroll (with Shadows)'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(655568879441187677)
,p_css_classes=>'a-Region--shadowScroll'
,p_group_id=>wwv_flow_imp.id(689612194925986634)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554872363548550825)
,p_theme_id=>3
,p_name=>'SIDEBAR'
,p_display_name=>'Sidebar'
,p_display_sequence=>1
,p_region_template_id=>wwv_flow_imp.id(655568879441187677)
,p_css_classes=>'a-Region--sideRegion'
,p_group_id=>wwv_flow_imp.id(689609975484986633)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(1554872549647550825)
,p_theme_id=>3
,p_name=>'SLIMPADDING'
,p_display_name=>'Slim Padding'
,p_display_sequence=>20
,p_region_template_id=>wwv_flow_imp.id(655568879441187677)
,p_css_classes=>'a-Region--slimPadding'
,p_group_id=>wwv_flow_imp.id(689276459702315779)
,p_template_types=>'REGION'
,p_is_advanced=>'N'
);
wwv_flow_imp_shared.create_template_option(
 p_id=>wwv_flow_imp.id(2045668162252789162)
,p_theme_id=>3
,p_name=>'LEFT'
,p_display_name=>'Left'
,p_display_sequence=>1
,p_button_template_id=>wwv_flow_imp.id(2045667935478789095)
,p_css_classes=>'a-Button--iconLeft'
,p_group_id=>wwv_flow_imp.id(689868416983651275)
,p_template_types=>'BUTTON'
);
end;
/
prompt --application/shared_components/globalization/language
begin
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(72240214480976150)
,p_translation_flow_id=>4001
,p_translation_flow_language_cd=>'es'
,p_translation_comments=>'App Builder - Spanish'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(72240317446976150)
,p_translation_flow_id=>4002
,p_translation_flow_language_cd=>'fr'
,p_translation_comments=>'App Builder - French'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(72240403392976150)
,p_translation_flow_id=>4003
,p_translation_flow_language_cd=>'de'
,p_translation_comments=>'App Builder - German'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(72240526225976151)
,p_translation_flow_id=>4004
,p_translation_flow_language_cd=>'it'
,p_translation_comments=>'App Builder - Italian'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(72240616935976151)
,p_translation_flow_id=>4005
,p_translation_flow_language_cd=>'pt-br'
,p_translation_comments=>'App Builder - Brazilian Portuguese'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(72240701618976151)
,p_translation_flow_id=>4006
,p_translation_flow_language_cd=>'zh-cn'
,p_translation_comments=>'App Builder - Simplified Chinese'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(72240819983976151)
,p_translation_flow_id=>4007
,p_translation_flow_language_cd=>'zh-tw'
,p_translation_comments=>'App Builder - Traditional Chinese'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(72240930768976151)
,p_translation_flow_id=>4008
,p_translation_flow_language_cd=>'ko'
,p_translation_comments=>'App Builder - Korean'
,p_direction_right_to_left=>'N'
);
wwv_flow_imp_shared.create_language_map(
 p_id=>wwv_flow_imp.id(72241017699976151)
,p_translation_flow_id=>4009
,p_translation_flow_language_cd=>'ja'
,p_translation_comments=>'App Builder - Japanese'
,p_direction_right_to_left=>'N'
);
end;
/
prompt --application/shared_components/logic/build_options
begin
wwv_flow_imp_shared.create_build_option(
 p_id=>wwv_flow_imp.id(1727232450260741)
,p_build_option_name=>'OCI Generative AI'
,p_build_option_status=>'INCLUDE'
,p_version_scn=>1102385149
,p_build_option_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Used for the support of OCI Generative AI Services in 24.1',
'Currently, OCI Generative AI is only available in Chicago data center.'))
);
wwv_flow_imp_shared.create_build_option(
 p_id=>wwv_flow_imp.id(30797216641778508)
,p_build_option_name=>'Remove in APEX 5.1'
,p_build_option_status=>'INCLUDE'
,p_version_scn=>37165770887393
);
wwv_flow_imp_shared.create_build_option(
 p_id=>wwv_flow_imp.id(103621306777465158)
,p_build_option_name=>'Asynchronous Actions'
,p_build_option_status=>'INCLUDE'
,p_version_scn=>37165770887393
);
wwv_flow_imp_shared.create_build_option(
 p_id=>wwv_flow_imp.id(121426746309283317)
,p_build_option_name=>'Remove in APEX 22.1'
,p_build_option_status=>'EXCLUDE'
,p_version_scn=>37165770887393
,p_build_option_comment=>'Used for components that are deleted as part of APEX-1012 task'
);
wwv_flow_imp_shared.create_build_option(
 p_id=>wwv_flow_imp.id(170786031904296885)
,p_build_option_name=>'Commented Out'
,p_build_option_status=>'EXCLUDE'
,p_version_scn=>37165770887393
);
wwv_flow_imp_shared.create_build_option(
 p_id=>wwv_flow_imp.id(235700916833599805)
,p_build_option_name=>'Do Not Include in APEX 4.2 EA1'
,p_build_option_status=>'INCLUDE'
,p_version_scn=>37165770887393
,p_default_on_export=>'INCLUDE'
);
wwv_flow_imp_shared.create_build_option(
 p_id=>wwv_flow_imp.id(693447794026530907)
,p_build_option_name=>'Enable APEX Internal Feedback'
,p_build_option_status=>'EXCLUDE'
,p_version_scn=>37165770887393
,p_default_on_export=>'EXCLUDE'
);
wwv_flow_imp_shared.create_build_option(
 p_id=>wwv_flow_imp.id(1338185675372185029)
,p_build_option_name=>'Build Query Button'
,p_build_option_status=>'EXCLUDE'
,p_version_scn=>37165770887393
);
end;
/
prompt --application/shared_components/globalization/messages
begin
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4746591522501496)
,p_name=>'ADVISOR.CHECK.DESC_LEGACY_ORPHAN_COMPONENTS'
,p_message_text=>'Legacy Orphan Components'
,p_version_scn=>37165770887567
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(381663683965881601)
,p_name=>'APEX.REMOTESQL.OAUTH_IS_RECOMMENDED'
,p_message_text=>'Warning: Oracle recommends the use of OAuth2 Client Credentials for authentication with REST Enabled SQL.'
,p_is_js_message=>true
,p_version_scn=>37165770887567
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(241852096464137932)
,p_name=>'APEX.WEBSRC.HIDE_COLUMNS'
,p_message_text=>'Hide Selected Columns'
,p_is_js_message=>true
,p_version_scn=>37165770887567
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(241852836899152391)
,p_name=>'APEX.WEBSRC.SHOW_COLUMNS'
,p_message_text=>'Show Selected Columns'
,p_is_js_message=>true
,p_version_scn=>37165770887567
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(324872833734196325)
,p_name=>'BUTTON.CANCEL'
,p_message_text=>'Cancel'
,p_version_scn=>37165770887567
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3441355199552320)
,p_name=>'COMP_GRP.COMPONENT_UNASSIGNED'
,p_message_text=>'Component unassigned.'
,p_is_js_message=>true
,p_version_scn=>16342013
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9382390952401323)
,p_name=>'COMP_GRP.DATA_LOAD_CANT_BE_REPLACED'
,p_message_text=>'Data Load Definition <strong>%0</strong> can''t be replaced in application %1. Please rename the component and try again.'
,p_version_scn=>13401966
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7448810256760291)
,p_name=>'COMP_GRP.MATCHING_STATUS.FOUND'
,p_message_text=>'Replace'
,p_version_scn=>48139646
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7448602962759449)
,p_name=>'COMP_GRP.MATCHING_STATUS.NEEDS_REFRESH'
,p_message_text=>'Refresh'
,p_version_scn=>48139672
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7449071556761112)
,p_name=>'COMP_GRP.MATCHING_STATUS.NOT_FOUND'
,p_message_text=>'Add'
,p_version_scn=>48139718
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7448455084758195)
,p_name=>'COMP_GRP.MATCHING_STATUS.UP_TO_DATE'
,p_message_text=>'Reuse'
,p_version_scn=>48139737
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2201499517996605)
,p_name=>'COMP_GRP.MULTIPLE_COMPS_TO_SAME_COMP'
,p_message_text=>'Multiple components from <strong>application %0</strong> map to the same component <strong>%1</strong> in <strong>application %2</strong>. This can occur when a master component is renamed and a new component is created using the old name. To fix thi'
||'s issue, first publish the renamed master component and then try again.'
,p_version_scn=>49694431
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2200402402931257)
,p_name=>'COMP_GRP.PAGE_CANT_BE_REPLACED'
,p_message_text=>'Existing pages can''t be replaced. Please delete the page <strong>%0</strong> in application %1 and try again.'
,p_version_scn=>25618420
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4333885802701830)
,p_name=>'COMP_GRP.REFRESH_ASSIGN'
,p_message_text=>'Refresh and Assign'
,p_version_scn=>18659603
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10176742276094315)
,p_name=>'COMP_GRP.REST_LOV_MASTER'
,p_message_text=>'LOV <strong>%0</strong> can''t be replaced in %1 application. Because master LOV is based on a REST Data Source.'
,p_version_scn=>49410101
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(10176148308065028)
,p_name=>'COMP_GRP.REST_SEARCH_CONFIG_MASTER'
,p_message_text=>'Search Configuration <strong>%0</strong> can''t be replaced in %1 application. Because master search configuration is based on a REST Data Source.'
,p_version_scn=>49409867
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4081478050941624)
,p_name=>'COMP_GRP.ROW_ACTION.ASSIGN'
,p_message_text=>'Assign'
,p_version_scn=>48140300
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4081825703967358)
,p_name=>'COMP_GRP.ROW_ACTION.RETAIN'
,p_message_text=>'Retain'
,p_version_scn=>48140315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4081695571953538)
,p_name=>'COMP_GRP.ROW_ACTION.UNASSIGN'
,p_message_text=>'Unassign'
,p_version_scn=>48140377
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1602203286310716)
,p_name=>'COMP_GRP.THEME_MUST_BE_SAME'
,p_message_text=>'Application %0 should use the same theme as Application %1.'
,p_version_scn=>30454530
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1602725890327957)
,p_name=>'COMP_GRP.THEME_VERSION_MUST_BE_SAME'
,p_message_text=>'The theme version of Application %0 should match the theme version of Application %1.'
,p_version_scn=>30485476
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9381923388997097)
,p_name=>'COMP_GRP.WEB_SOURCE_CANT_BE_REPLACED'
,p_message_text=>'REST Data Source <strong>%0</strong> can''t be replaced in application %1. Please rename the component and try again.'
,p_version_scn=>13402124
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(712796075623764037)
,p_name=>'CREATE_LOV_ENTRY'
,p_message_text=>'Create Entry'
,p_is_js_message=>true
,p_version_scn=>37165770887567
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(108312927489627778)
,p_name=>'F4000.ACTION'
,p_message_text=>'Action'
,p_version_scn=>37165770887567
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(108312728773628741)
,p_name=>'F4000.ASYNCH_ACTION'
,p_message_text=>'Asynchronous Action'
,p_version_scn=>37165770887567
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4801357285143452)
,p_name=>'F4000.P149.PUBLISH_APP_ACL'
,p_message_text=>'You have requested to publish <strong>%0</strong>. This will refresh the Roles in the following applications:'
,p_version_scn=>30133768
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4456406926705996)
,p_name=>'F4000.P149.PUBLISH_APP_COMPUTATION'
,p_message_text=>'You have requested to publish <strong>%0</strong>. This will refresh the Application Computations in the following applications:'
,p_version_scn=>30133966
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8207354894180893)
,p_name=>'F4000.P149.PUBLISH_APP_ITEM'
,p_message_text=>'You have requested to publish <strong>%0</strong>. This will refresh the Application Items in the following applications:'
,p_version_scn=>30134047
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3614624601683925)
,p_name=>'F4000.P149.PUBLISH_APP_PROCESS'
,p_message_text=>'You have requested to publish <strong>%0</strong>. This will refresh the Application Processes in the following applications:'
,p_version_scn=>30134076
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8414114681849552)
,p_name=>'F4000.P149.PUBLISH_APP_SETTING'
,p_message_text=>'You have requested to publish <strong>%0</strong>. This will refresh the Application Settings in the following applications:'
,p_version_scn=>30134206
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(13110746451714062)
,p_name=>'F4000.P149.PUBLISH_AUTHENTICATION'
,p_message_text=>'You have requested to publish <strong>%0</strong>. This will refresh the Authentication Scheme in the following applications:'
,p_version_scn=>34185482
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1066332894463410440)
,p_name=>'F4000.P149.PUBLISH_AUTHORIZATION'
,p_message_text=>'You have requested to publish <strong>%0</strong>. This will refresh the Authorization Schemes in the following applications:'
,p_version_scn=>30134318
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1066338985104492247)
,p_name=>'F4000.P149.PUBLISH_BREADCRUMB_TEMPLATE'
,p_message_text=>'You have requested to publish <strong>%0</strong>. This will refresh the Breadcrumb Templates in the following applications:'
,p_version_scn=>30134399
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5433119863565636)
,p_name=>'F4000.P149.PUBLISH_BUILD_OPTION'
,p_message_text=>'You have requested to publish <strong>%0</strong>. This will refresh the Build Options in the following applications:'
,p_version_scn=>30134473
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1066339300234502522)
,p_name=>'F4000.P149.PUBLISH_BUTTON_TEMPLATE'
,p_message_text=>'You have requested to publish <strong>%0</strong>. This will refresh the Button Templates in the following applications:'
,p_version_scn=>30134511
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1066340415941513880)
,p_name=>'F4000.P149.PUBLISH_CALENDAR_TEMPLATE'
,p_message_text=>'You have requested to publish <strong>%0</strong>. This will refresh the Calendar Templates in the following applications:'
,p_version_scn=>30134538
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7983077150601419)
,p_name=>'F4000.P149.PUBLISH_COMPONENT_GROUP'
,p_message_text=>'You have requested to publish <strong>%0</strong>. This will refresh the Component Groups in the following applications:'
,p_version_scn=>30134609
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(214900257333184564)
,p_name=>'F4000.P149.PUBLISH_CUSTOM_MAP_BACKGROUND'
,p_message_text=>'You have requested to publish <strong>%0</strong>. This will refresh the Map Backgrounds in the following applications:'
,p_version_scn=>30134646
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3515154685660544)
,p_name=>'F4000.P149.PUBLISH_DATA_LOAD'
,p_message_text=>'You have requested to publish <strong>%0</strong>. This will refresh the Data Load Definitions in the following applications:'
,p_version_scn=>30134775
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8412579512827932)
,p_name=>'F4000.P149.PUBLISH_EMAIL_TEMPLATE'
,p_message_text=>'You have requested to publish <strong>%0</strong>. This will refresh the Email Templates in the following applications:'
,p_version_scn=>30134804
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1066331765783387762)
,p_name=>'F4000.P149.PUBLISH_FIELD_TEMPLATE'
,p_message_text=>'You have requested to publish <strong>%0</strong>. This will refresh the Label Templates in the following applications:'
,p_version_scn=>30134880
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(11100225087699791)
,p_name=>'F4000.P149.PUBLISH_LIST'
,p_message_text=>'You have requested to publish <strong>%0</strong>. This will refresh the Lists in the following applications:'
,p_version_scn=>30134916
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1066327301658364110)
,p_name=>'F4000.P149.PUBLISH_LIST_TEMPLATE'
,p_message_text=>'You have requested to publish <strong>%0</strong>. This will refresh the List Templates in the following applications:'
,p_version_scn=>30134999
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1063461869007966419)
,p_name=>'F4000.P149.PUBLISH_LOV'
,p_message_text=>'You have requested to publish <strong>%0</strong>. This will refresh the Lists of Values in the following applications:'
,p_version_scn=>30135041
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(203424936531076464)
,p_name=>'F4000.P149.PUBLISH_MAP_BACKGROUND'
,p_message_text=>'You have requested to publish <strong>%0</strong>. This will refresh the Map Backgrounds in the following applications:'
,p_version_scn=>30135125
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2631779197273934)
,p_name=>'F4000.P149.PUBLISH_MESSAGE'
,p_message_text=>'You have requested to publish <strong>%0</strong>. This will refresh the Text Messages in the following applications:'
,p_version_scn=>30135187
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1066336159168440336)
,p_name=>'F4000.P149.PUBLISH_NAVBAR'
,p_message_text=>'You have requested to publish <strong>%0</strong>. This will refresh the Navigation Bar Entries in the following applications:'
,p_version_scn=>30135225
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1063528582243238150)
,p_name=>'F4000.P149.PUBLISH_PAGE_TEMPLATE'
,p_message_text=>'You have requested to publish <strong>%0</strong>. This will refresh the Page Templates in the following applications:'
,p_version_scn=>30135263
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1066341554964534518)
,p_name=>'F4000.P149.PUBLISH_PLUGIN'
,p_message_text=>'You have requested to publish <strong>%0</strong>. This will refresh the Plug-ins in the following applications:'
,p_version_scn=>30136621
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1406707325942323)
,p_name=>'F4000.P149.PUBLISH_PLUGIN_SETTINGS'
,p_message_text=>'You have requested to publish <strong>%0</strong>. This will refresh the Component Settings in the following applications:'
,p_version_scn=>30136656
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1066436179289617388)
,p_name=>'F4000.P149.PUBLISH_POPUP_LOV_TEMPLATE'
,p_message_text=>'You have requested to publish <strong>%0</strong>. This will refresh the Popup List of Values Templates in the following applications:'
,p_version_scn=>30136728
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1063533597707279189)
,p_name=>'F4000.P149.PUBLISH_REGION_TEMPLATE'
,p_message_text=>'You have requested to publish <strong>%0</strong>. This will refresh the Region Templates in the following applications:'
,p_version_scn=>30136755
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8413378221839852)
,p_name=>'F4000.P149.PUBLISH_REPORT_LAYOUT'
,p_message_text=>'You have requested to publish <strong>%0</strong>. This will refresh the Report Layouts in the following applications:'
,p_version_scn=>30136819
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1066330233179377218)
,p_name=>'F4000.P149.PUBLISH_REPORT_TEMPLATE'
,p_message_text=>'You have requested to publish <strong>%0</strong>. This will refresh the Report Templates in the following applications:'
,p_version_scn=>30136856
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(122403724590173317)
,p_name=>'F4000.P149.PUBLISH_SEARCH_CONFIG'
,p_message_text=>'You have requested to publish <strong>%0</strong>. This will refresh the Search Configurations in the following applications:'
,p_version_scn=>30136917
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1066333934417423253)
,p_name=>'F4000.P149.PUBLISH_SHORTCUT'
,p_message_text=>'You have requested to publish <strong>%0</strong>. This will refresh the Shortcuts in the following applications:'
,p_version_scn=>30136955
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(247779366717215288)
,p_name=>'F4000.P149.PUBLISH_WEB_SRC_MODULE'
,p_message_text=>'You have requested to publish <strong>%0</strong>. This will refresh the REST Data Sources in the following applications:'
,p_version_scn=>30136984
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2622571434426155)
,p_name=>'F4000.P149.SUBSCRIBED_APPLICATION'
,p_message_text=>'Application %0 - %1'
,p_version_scn=>31873810
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6021142222377044)
,p_name=>'F4000.P4410.ATTRIBUTE_GROUP_TITLE_ALREADY_EXISTS'
,p_message_text=>'Attribute Group Title already exists!'
,p_is_js_message=>true
,p_version_scn=>71857113
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(70809490291004780)
,p_name=>'FILE_EDITOR.COULD_NOT_OPEN_FILE'
,p_message_text=>'Could not read the contents of this file. Please ensure the file''s real encoding is utf-8.'
,p_version_scn=>37165770887567
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4804445264296043)
,p_name=>'FILE_EDITOR.CREATED'
,p_message_text=>'File created'
,p_version_scn=>37165770887567
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4804689305297068)
,p_name=>'FILE_EDITOR.CREATED_PLURAL'
,p_message_text=>'Files created'
,p_version_scn=>37165770887567
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4804069653294073)
,p_name=>'FILE_EDITOR.DELETE'
,p_message_text=>'Delete file'
,p_version_scn=>37165770887567
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4804817464298300)
,p_name=>'FILE_EDITOR.DELETED'
,p_message_text=>'File deleted'
,p_version_scn=>37165770887567
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4806092401305582)
,p_name=>'FILE_EDITOR.ERROR_COMPILATION'
,p_message_text=>'Could not compile file'
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4805830224304409)
,p_name=>'FILE_EDITOR.ERROR_MINIFICATION'
,p_message_text=>'Could not minify file'
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6500609730491309)
,p_name=>'FILE_EDITOR.EXTENSION_UNCHANGEABLE'
,p_message_text=>'File extension may not be changed'
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3891675698058143)
,p_name=>'FILE_EDITOR.FILE_NOT_FOUND'
,p_message_text=>'File not found'
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4806238549306554)
,p_name=>'FILE_EDITOR.LINE_COL'
,p_message_text=>'Line %0: %1'
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(110701399556417849)
,p_name=>'FILE_EDITOR.NAME_EMPTY'
,p_message_text=>'A file name must be provided'
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6500449729487383)
,p_name=>'FILE_EDITOR.NAME_TAKEN'
,p_message_text=>'A file by this name already exists. Would you like to overwrite it?'
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123411874078783528)
,p_name=>'FILE_EDITOR.NAME_TOO_LONG'
,p_message_text=>'The file name is too long. The limit is 255 characters.'
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(38450086216966647)
,p_name=>'FILE_EDITOR.OVERRIDE'
,p_message_text=>'Overwrite'
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4805085546299333)
,p_name=>'FILE_EDITOR.SAVED'
,p_message_text=>'File saved'
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4805236285300256)
,p_name=>'FILE_EDITOR.SAVED_COMPILED'
,p_message_text=>'File saved and compiled'
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4805487487302527)
,p_name=>'FILE_EDITOR.SAVED_MINIFIED'
,p_message_text=>'File saved and minified'
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4805696275303523)
,p_name=>'FILE_EDITOR.SAVED_MINIFIED_COMPILED'
,p_message_text=>'File saved, compiled and minified'
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4803833025293132)
,p_name=>'FILE_EDITOR.UPLOAD'
,p_message_text=>'Upload file'
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(528332798424248963)
,p_name=>'GL.BTN_POS_L'
,p_message_text=>'%0 (left)'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(528332868457248963)
,p_name=>'GL.BTN_POS_R'
,p_message_text=>'%0 (right)'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(528333085318248964)
,p_name=>'GL.DRAG_COPY'
,p_message_text=>'Copy'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(528332955217248964)
,p_name=>'GL.REGION_CONTENT'
,p_message_text=>'Region Content'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1479018050824438)
,p_name=>'INSTALLER.APP_HAS_SUPPORTING_OBJECTS'
,p_message_text=>'Your application contains supporting objects.'
,p_version_scn=>5534906
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1479211367827488)
,p_name=>'INSTALLER.INSTALL_SUPPORTING_OBJECTS'
,p_message_text=>'You may <a href="%0">preview the installation details</a>, or select <strong>Install Supporting Objects</strong> to continue.'
,p_version_scn=>6007732
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1673006115050006)
,p_name=>'INSTALLER.NEXT_SUPPORTING_OBJECTS'
,p_message_text=>'You may <a href="%0">preview the installation details</a>, or select <strong>Next</strong> to continue.'
,p_version_scn=>6008034
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1479737248847202)
,p_name=>'INSTALLER.TITLE.APP_INSTALLED'
,p_message_text=>'Application Installed'
,p_version_scn=>5535137
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1479983437849002)
,p_name=>'INSTALLER.TITLE.INSTALL_SUPP_OBJ'
,p_message_text=>'Install Supporting Objects'
,p_version_scn=>5535157
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8605538057332657)
,p_name=>'LAST_BACKUP'
,p_message_text=>'Last Backup'
,p_version_scn=>37165889113675
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8241401268285502)
,p_name=>'LOV.CANT_DELETE_ADDL_COLUMN'
,p_message_text=>'Column ''%0'' referred in column mapping. This column can''t be deleted from Additional Display Columns.'
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(534486299650665510)
,p_name=>'LOV_DIALOG.GO'
,p_message_text=>'Go'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(534486481203666410)
,p_name=>'LOV_DIALOG.LOV_ENTRIES'
,p_message_text=>'List of Values Entries'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(534486644445667235)
,p_name=>'LOV_DIALOG.SELECT'
,p_message_text=>'Select'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1273377881289480514)
,p_name=>'LOV_DIALOG.SELECT_VALUE'
,p_message_text=>'- Select -'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8605742181335606)
,p_name=>'MANAGE_BACKUPS'
,p_message_text=>'Manage backups'
,p_version_scn=>37165889113675
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(754837041673540738)
,p_name=>'MODEL.CALLBACKS.CLASSIC_RPT_TABFORM_COLUMN.NO_SORTING'
,p_message_text=>'Column heading sorting can''t be used when query contains "ORDER BY" clause.'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2407341013915000)
,p_name=>'MODEL.CALLBACKS.GRAPH.REMOTE_DB_NOT_SUPPORTED'
,p_message_text=>'Declarative Graph support is currently not available for REST Enabled SQL. Use SQL Query instead.'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(693035749102532173)
,p_name=>'MODEL.CALLBACKS.IG.HAS_ORDER_BY'
,p_message_text=>'ORDER BY clause is not supported, use column sorting instead.'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7601770771515880)
,p_name=>'MODEL.CALLBACKS.INVOKE_API.API_DEFAULT_ERROR'
,p_message_text=>'"API Default" can only be used if "Has Default" is On.'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7601507971508779)
,p_name=>'MODEL.CALLBACKS.INVOKE_API.HAS_DEFAULT_ERROR'
,p_message_text=>'Can''t be Off if "API Default" is used as type.'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8001235680641713)
,p_name=>'MODEL.CALLBACKS.INVOKE_API.OVERLOADED_WARNING'
,p_message_text=>'The procedure or function %0 is overloaded. Using parameters from the first occurrence in the package specification.'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2402401180965429)
,p_name=>'MODEL.CALLBACKS.ITEM.ERROR_COMBOBOX_MULTI_VALUE_AND_MULTI_SELECTION'
,p_message_text=>'"Multi Selection" must be disabled when "Type" of "Multiple Values" is set to "No".'
,p_is_js_message=>true
,p_version_scn=>9674369
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6401471685864494)
,p_name=>'MODEL.CALLBACKS.ITEM.ERROR_FORMAT_MASK_DATE'
,p_message_text=>'Format Mask has unsupported parts: %0.'
,p_is_js_message=>true
,p_version_scn=>13005819
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5208110473111681)
,p_name=>'MODEL.CALLBACKS.ITEM.ERROR_MULTI_VALUE_SEPARATOR_NOT_ALLOWED'
,p_message_text=>'" (double-quote) and \ (backslash) characters are not supported as Multi Value Separator, also not in the \xxxx format.'
,p_is_js_message=>true
,p_version_scn=>3959714
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2600233718057851)
,p_name=>'MODEL.CALLBACKS.ITEM.ERROR_POPUP_LOV_MULTI_VALUE_AND_ADDITIONAL_OUTPUTS'
,p_message_text=>'"Additional Outputs" must be empty in order to use multiple values for the Popup LOV Item.'
,p_is_js_message=>true
,p_version_scn=>9697315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6601447439765734)
,p_name=>'MODEL.CALLBACKS.ITEM.ERROR_SELECT_LIST_MULTI_VALUE_AND_PAGE_ACTION'
,p_message_text=>'For "Page Action on Selection", "None" must be selected in order to use multiple values for the Select List Item.'
,p_is_js_message=>true
,p_version_scn=>4214887
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2079762760660553187)
,p_name=>'MODEL.CALLBACKS.LEGACY_CALENDAR.ONLY_ONE_PER_PAGE'
,p_message_text=>'Only one calendar is allowed per page.'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(528255426508447750)
,p_name=>'MODEL.CALLBACKS.LEGACY_CALENDAR.WARNING'
,p_message_text=>'This will just create the calendar and not the associated page items and buttons. To generate the related page items and buttons use the Create Page / Create Region wizard.'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3000529729911427)
,p_name=>'MODEL.CALLBACKS.NO_SOURCE_ERROR'
,p_message_text=>'A region of type ''Multiple (Report)'' must have a source.'
,p_is_js_message=>true
,p_version_scn=>108856935
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(41132989256897018)
,p_name=>'MODEL.CALLBACKS.PROCESS.AJAX_RESTRICTION'
,p_message_text=>'Ajax Callbacks only support <em>Execute Code</em> process type.'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(22483511849371296)
,p_name=>'MODEL.CALLBACKS.PROCESS.CHILDREN_ONLY_ALLOWED_FOR_EXECUTION_CHAINS'
,p_message_text=>'Child processes are only allowed for Execution Chains.'
,p_is_js_message=>true
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8200157366349624)
,p_name=>'MODEL.CALLBACKS.PROCESS_BACKGROUND.CHILD_PROCESSES_W_REGION_NOT_SUPPORTED'
,p_message_text=>'Cannot execute in background as child process "%0" has an editable region assigned.'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4003885724547153)
,p_name=>'MODEL.CALLBACKS.PROCESS_BACKGROUND.PAGE_RENDERING_NOT_SUPPORTED'
,p_message_text=>'Cannot execute in background as the root process "%0" runs during Page Rendering.'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8201548192377055)
,p_name=>'MODEL.CALLBACKS.PROCESS_BACKGROUND.PROCESS_W_REGION_NOT_SUPPORTED'
,p_message_text=>'Editable Region not supported, as parent process "%0" executes in background.'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1604813269894122)
,p_name=>'MODEL.CALLBACKS.PROCESS_DOWNLOAD.PROCESS_NOT_SUPPORTED'
,p_message_text=>'The Download process type is exclusively supported in the ''Before Header'' position during Page Rendering or in Page Processing when the page-level attribute ''Reload on Submit'' is configured as ''Always''. To achieve the desired functionality, consider '
||'utilizing the Download dynamic action as an alternative instead of relying on a page process.'
,p_is_js_message=>true
,p_version_scn=>4121571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3862069693491664)
,p_name=>'MODEL.CALLBACKS.PROCESS_PRINT_REPORT.PROCESS_NOT_SUPPORTED'
,p_message_text=>'The Print Report process type is exclusively supported in the ''Before Header'' position during Page Rendering or in Page Processing when the page-level attribute ''Reload on Submit'' is configured as ''Always''. To achieve the desired functionality, consi'
||'der utilizing the Print Report dynamic action as an alternative instead of relying on a page process.'
,p_is_js_message=>true
,p_version_scn=>18036913
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(754668471514549350)
,p_name=>'MODEL.CALLBACKS.TABFORM.ONLY_ONE_PER_PAGE'
,p_message_text=>'You can only add one Tabular Form per page.'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(528255291567444333)
,p_name=>'MODEL.CALLBACKS.TABFORM.WARNING'
,p_message_text=>'This will just create the tabular form and not the associated processes and validations. To generate the related processes and validations please use the Create Page wizard.'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4001398451531100)
,p_name=>'MODEL.CALLBACKS.TEMPLATE_COMPONENT.MODAL_DIALOG_SCROLL_PAGINATION'
,p_message_text=>'Scroll pagination is currently not supported on a modal dialog page.'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4602795738344113)
,p_name=>'MODEL.CALLBACKS.WEB_SRC_PARAM.IGNORE_OUTPUT_FETCH_COLLECTION'
,p_message_text=>'Ignore Output must be enabled, when the database operation is <em>Fetch Rows</em>.'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4012356330868347)
,p_name=>'MODEL.CALLBACKS.WEB_SRC_PARAM.IGNORE_OUTPUT_NON_EDITABLE'
,p_message_text=>'For non-Editable Regions, Chart Series or Map Layers, Ignore Output must be enabled.'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(355254380085636187)
,p_name=>'MODEL.CALLBACKS.WEB_SRC_PARAM.REQUIRES_VALUE'
,p_message_text=>'Parameter requires a value!'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2340486547213213)
,p_name=>'MODEL.CALLBACKS.WF.ACT'
,p_message_text=>'Activity'
,p_is_js_message=>true
,p_version_scn=>38788392
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2340638695211967)
,p_name=>'MODEL.CALLBACKS.WF.END_ACT'
,p_message_text=>'End'
,p_is_js_message=>true
,p_version_scn=>38788392
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2664283965422794)
,p_name=>'MODEL.CALLBACKS.WF.ERROR_DUP_DEV'
,p_message_text=>'Only one Version is allowed to be in Development.'
,p_is_js_message=>true
,p_version_scn=>37166020057321
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2416310101160145)
,p_name=>'MODEL.CALLBACKS.WF.ERROR_MAX_ONE_NORMAL'
,p_message_text=>'There can be maximum one Normal Connection.'
,p_is_js_message=>true
,p_version_scn=>38788392
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2666185749335675)
,p_name=>'MODEL.CALLBACKS.WF.ERROR_MAX_ONE_OTHERWISE'
,p_message_text=>'There can be maximum one Otherwise Connection.'
,p_is_js_message=>true
,p_version_scn=>102147362
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2421678848968910)
,p_name=>'MODEL.CALLBACKS.WF.ERROR_MAX_ONE_TIMEOUT'
,p_message_text=>'There can be maximum one Timeout Connection.'
,p_is_js_message=>true
,p_version_scn=>38788392
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2664642656403030)
,p_name=>'MODEL.CALLBACKS.WF.ERROR_NO_END'
,p_message_text=>'There must be at least one End Activity.'
,p_is_js_message=>true
,p_version_scn=>101555216
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2665082811382082)
,p_name=>'MODEL.CALLBACKS.WF.ERROR_NO_INCOMING_CONN'
,p_message_text=>'There must be at least one incoming Connection.'
,p_is_js_message=>true
,p_version_scn=>38788392
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2411114844976104)
,p_name=>'MODEL.CALLBACKS.WF.ERROR_NO_OUTGOING_CONN'
,p_message_text=>'There must be at least one outgoing Connection.'
,p_is_js_message=>true
,p_version_scn=>38788392
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2664838318397689)
,p_name=>'MODEL.CALLBACKS.WF.ERROR_ONE_START'
,p_message_text=>'There must be exactly one Start Activity.'
,p_is_js_message=>true
,p_version_scn=>38788392
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2665444049357456)
,p_name=>'MODEL.CALLBACKS.WF.ERROR_SAME_FROM_TO'
,p_message_text=>'From and To properties cannot be the same.'
,p_is_js_message=>true
,p_version_scn=>38788392
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(169141073116734370)
,p_name=>'MODEL.CALLBACKS.WF.ERROR_START_AS_TARGET'
,p_message_text=>'A Start Activity cannot be a target of a Connection.'
,p_is_js_message=>true
,p_version_scn=>37165915388087
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2340267931215138)
,p_name=>'MODEL.CALLBACKS.WF.START_ACT'
,p_message_text=>'Start'
,p_is_js_message=>true
,p_version_scn=>38788392
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527136570358330604)
,p_name=>'MODEL.DEL.REFERENCE_EXISTS'
,p_message_text=>'Can not delete because component ''%0'' references this component!'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527130962233090448)
,p_name=>'MODEL.HELP.ABOUT_PLUGIN'
,p_message_text=>'See <a href="%0" target="_blank">Plug-In Homepage</a> for details.'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2840261728423134)
,p_name=>'MODEL.HELP.ACCESSIBILITY_HELP_TEXT'
,p_message_text=>'Accessibility'
,p_is_js_message=>true
,p_version_scn=>5174968
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1566811075007677079)
,p_name=>'MODEL.HELP.ADDITIONAL_INFO'
,p_message_text=>'Additional Information'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527130743945090447)
,p_name=>'MODEL.HELP.AVAILABLE_OPTIONS'
,p_message_text=>'Available options include:'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527130169768090446)
,p_name=>'MODEL.HELP.BIND_VARIABLES'
,p_message_text=>'Supported Bind Variables'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1475803449210256472)
,p_name=>'MODEL.HELP.DEPRECATED.ATTRIBUTE'
,p_message_text=>'This feature has been deprecated. Please review %0 Deprecated Features within the Release Notes for further information.'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1475853247507361315)
,p_name=>'MODEL.HELP.DEPRECATED.LOV_VALUE'
,p_message_text=>'This feature has been deprecated. Please review %0 Deprecated Features within the Release Notes for further information.'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527130817982090448)
,p_name=>'MODEL.HELP.EXAMPLES'
,p_message_text=>'Examples'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527130450101090447)
,p_name=>'MODEL.HELP.MAX_COLUMNS'
,p_message_text=>'Maximum Columns'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527130674716090447)
,p_name=>'MODEL.HELP.MAX_VALUE'
,p_message_text=>'Maximum Value'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527130302762090447)
,p_name=>'MODEL.HELP.MIN_COLUMNS'
,p_message_text=>'Minimum Columns'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527130569993090447)
,p_name=>'MODEL.HELP.MIN_VALUE'
,p_message_text=>'Minimum Value'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527129904219090446)
,p_name=>'MODEL.HELP.MULTIPLE. '
,p_message_text=>'a space'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527129803498090446)
,p_name=>'MODEL.HELP.MULTIPLE.,'
,p_message_text=>'a comma'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527130022216090446)
,p_name=>'MODEL.HELP.MULTIPLE.:'
,p_message_text=>'a colon'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527129740580090446)
,p_name=>'MODEL.HELP.MULTIPLE.TEXT'
,p_message_text=>'Separate multiple values with %0'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527129570913090445)
,p_name=>'MODEL.HELP.NO_TEXT'
,p_message_text=>'No help text available.'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2600568154988458)
,p_name=>'MODEL.HELP.PROP_TYPE.CODE LANGUAGE'
,p_message_text=>'Programming Language'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527132150459090450)
,p_name=>'MODEL.HELP.PROP_TYPE.COLOR'
,p_message_text=>'Color'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527132087772090450)
,p_name=>'MODEL.HELP.PROP_TYPE.COMBOBOX'
,p_message_text=>'Text'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527132267534090451)
,p_name=>'MODEL.HELP.PROP_TYPE.CSS'
,p_message_text=>'Cascading Style Sheet'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5200724775497510)
,p_name=>'MODEL.HELP.PROP_TYPE.FILE URLS CSS'
,p_message_text=>'CSS File URLs'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5200512321492868)
,p_name=>'MODEL.HELP.PROP_TYPE.FILE URLS JAVASCRIPT'
,p_message_text=>'JavaScript File URLs'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2600777705745613)
,p_name=>'MODEL.HELP.PROP_TYPE.GRAPH'
,p_message_text=>'Property Graph or Synonym'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527132559717090451)
,p_name=>'MODEL.HELP.PROP_TYPE.HTML'
,p_message_text=>'HTML'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(617256479963850366)
,p_name=>'MODEL.HELP.PROP_TYPE.ICON'
,p_message_text=>'Icon'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527132777972090451)
,p_name=>'MODEL.HELP.PROP_TYPE.INTEGER'
,p_message_text=>'Integer'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527132900468090452)
,p_name=>'MODEL.HELP.PROP_TYPE.ITEM'
,p_message_text=>'Item'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527132472357090451)
,p_name=>'MODEL.HELP.PROP_TYPE.JAVASCRIPT'
,p_message_text=>'JavaScript'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527132313603090451)
,p_name=>'MODEL.HELP.PROP_TYPE.LINK'
,p_message_text=>'Link to Target Page/URL'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4401644337893509)
,p_name=>'MODEL.HELP.PROP_TYPE.MEDIA'
,p_message_text=>'Media'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2600728932995012)
,p_name=>'MODEL.HELP.PROP_TYPE.MLE JAVASCRIPT'
,p_message_text=>'Server-side JavaScript (MLE) code'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2600953443000566)
,p_name=>'MODEL.HELP.PROP_TYPE.MLE JAVASCRIPT EXPRESSION BOOLEAN'
,p_message_text=>'Server-side JavaScript (MLE) Expression returning a BOOLEAN'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8602493754603856)
,p_name=>'MODEL.HELP.PROP_TYPE.MLE JAVASCRIPT EXPRESSION CUSTOM'
,p_message_text=>'Server-side JavaScript (MLE) Expression returning %0'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2601199789003477)
,p_name=>'MODEL.HELP.PROP_TYPE.MLE JAVASCRIPT EXPRESSION VARCHAR2'
,p_message_text=>'Server-side JavaScript (MLE) Expression returning a VARCHAR2'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2601358910005771)
,p_name=>'MODEL.HELP.PROP_TYPE.MLE JAVASCRIPT FUNCTION BODY BOOLEAN'
,p_message_text=>'Server-side JavaScript (MLE) Function Body returning a BOOLEAN'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2700925302835071)
,p_name=>'MODEL.HELP.PROP_TYPE.MLE JAVASCRIPT FUNCTION BODY CLOB'
,p_message_text=>'Server-side JavaScript (MLE) Function Body returning a CLOB'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8602222739599464)
,p_name=>'MODEL.HELP.PROP_TYPE.MLE JAVASCRIPT FUNCTION BODY CUSTOM'
,p_message_text=>'Server-side JavaScript (MLE) Function Body returning %0'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2601765139012071)
,p_name=>'MODEL.HELP.PROP_TYPE.MLE JAVASCRIPT FUNCTION BODY SQL'
,p_message_text=>'Server-side JavaScript (MLE) Function Body returning a SQL Query'
,p_is_js_message=>true
,p_version_scn=>37165770887568
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2601549615008636)
,p_name=>'MODEL.HELP.PROP_TYPE.MLE JAVASCRIPT FUNCTION BODY VARCHAR2'
,p_message_text=>'Server-side JavaScript (MLE) Function Body returning a VARCHAR2'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527132879960090451)
,p_name=>'MODEL.HELP.PROP_TYPE.NUMBER'
,p_message_text=>'Number'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(224607042166391049)
,p_name=>'MODEL.HELP.PROP_TYPE.ORDER BY CLAUSE'
,p_message_text=>'Order By Clause'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4200999140556894)
,p_name=>'MODEL.HELP.PROP_TYPE.ORDER BY ITEM'
,p_message_text=>'List of ORDER BY clauses with reference to a page item to choose one.'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527133001955090452)
,p_name=>'MODEL.HELP.PROP_TYPE.PAGE'
,p_message_text=>'Page'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1900135226181624)
,p_name=>'MODEL.HELP.PROP_TYPE.PLACEHOLDER JSON'
,p_message_text=>'Placeholders'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527133172697090452)
,p_name=>'MODEL.HELP.PROP_TYPE.PLSQL'
,p_message_text=>'PL/SQL Code'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527133320873090453)
,p_name=>'MODEL.HELP.PROP_TYPE.PLSQL EXPRESSION BOOLEAN'
,p_message_text=>'PL/SQL Expression returning a BOOLEAN'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8601852279588778)
,p_name=>'MODEL.HELP.PROP_TYPE.PLSQL EXPRESSION CUSTOM'
,p_message_text=>'PL/SQL Expression returning %0'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527133281464090452)
,p_name=>'MODEL.HELP.PROP_TYPE.PLSQL EXPRESSION VARCHAR2'
,p_message_text=>'PL/SQL Expression returning a VARCHAR2'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527133581026090453)
,p_name=>'MODEL.HELP.PROP_TYPE.PLSQL FUNCTION BODY BOOLEAN'
,p_message_text=>'PL/SQL Function Body returning a BOOLEAN'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2700676100827311)
,p_name=>'MODEL.HELP.PROP_TYPE.PLSQL FUNCTION BODY CLOB'
,p_message_text=>'PL/SQL Function Body returning a CLOB'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8602076306594637)
,p_name=>'MODEL.HELP.PROP_TYPE.PLSQL FUNCTION BODY CUSTOM'
,p_message_text=>'PL/SQL Function Body returning %0'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(353447216747040622)
,p_name=>'MODEL.HELP.PROP_TYPE.PLSQL FUNCTION BODY SQL'
,p_message_text=>'PL/SQL Function Body returning a SQL Query'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527133451492090453)
,p_name=>'MODEL.HELP.PROP_TYPE.PLSQL FUNCTION BODY VARCHAR2'
,p_message_text=>'PL/SQL Function Body returning a VARCHAR2'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5402402283441220)
,p_name=>'MODEL.HELP.PROP_TYPE.REST SOURCE ID'
,p_message_text=>'REST Source'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(126089546223907410)
,p_name=>'MODEL.HELP.PROP_TYPE.SESSION STATE VALUE'
,p_message_text=>'Session State Value'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527133629176090453)
,p_name=>'MODEL.HELP.PROP_TYPE.SQL'
,p_message_text=>'SQL Query'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527133772281090453)
,p_name=>'MODEL.HELP.PROP_TYPE.SQL EXPRESSION'
,p_message_text=>'SQL Expression'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(483405364308359451)
,p_name=>'MODEL.HELP.PROP_TYPE.SQL EXPRESSION BOOLEAN'
,p_message_text=>'SQL Expression returning a BOOLEAN'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8642218169921186)
,p_name=>'MODEL.HELP.PROP_TYPE.SQL EXPRESSION CUSTOM'
,p_message_text=>'SQL Expression returning %0'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(123698794239932730)
,p_name=>'MODEL.HELP.PROP_TYPE.STATIC LOV'
,p_message_text=>'Static Values'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527134163044090454)
,p_name=>'MODEL.HELP.PROP_TYPE.TABLE'
,p_message_text=>'Table, View or Synonym'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527133836619090453)
,p_name=>'MODEL.HELP.PROP_TYPE.TEXT'
,p_message_text=>'Text'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527134049338090454)
,p_name=>'MODEL.HELP.PROP_TYPE.TEXT EDITOR'
,p_message_text=>'Text'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527133976589090454)
,p_name=>'MODEL.HELP.PROP_TYPE.TEXTAREA'
,p_message_text=>'Text'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(224606871773389359)
,p_name=>'MODEL.HELP.PROP_TYPE.WHERE CLAUSE'
,p_message_text=>'Where Clause'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527132648627090451)
,p_name=>'MODEL.HELP.PROP_TYPE.XML'
,p_message_text=>'XML'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527131047776090448)
,p_name=>'MODEL.HELP.REF_SCOPE.COMPONENT'
,p_message_text=>'Application, Page Items and System Variables'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527131215052090449)
,p_name=>'MODEL.HELP.REF_SCOPE.DEPENDS'
,p_message_text=>'Depends'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527131118049090448)
,p_name=>'MODEL.HELP.REF_SCOPE.ROW'
,p_message_text=>'Application, Page Items, Region Columns and System Variables'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(64163150570963315)
,p_name=>'MODEL.HELP.RESTRICTED_CHARS.DOM_STATIC_ID'
,p_message_text=>'Not allowed are <>''" and spaces'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527131790624090449)
,p_name=>'MODEL.HELP.RESTRICTED_CHARS.NO_SPECIAL_CHAR'
,p_message_text=>'Not allowed are &<>"/;,*|=%--'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527131804024090450)
,p_name=>'MODEL.HELP.RESTRICTED_CHARS.NO_SPECIAL_CHAR_NL'
,p_message_text=>'Not allowed are &<>"/;,*|=%-- and new lines'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527131930984090450)
,p_name=>'MODEL.HELP.RESTRICTED_CHARS.SAFE_COMPONENT_NAME'
,p_message_text=>'Not allowed are spaces, new lines and :&,.''+?"^'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(186544444519380998)
,p_name=>'MODEL.HELP.RESTRICTED_CHARS.SAFE_COMPONENT_NAME_NO_NUMBER'
,p_message_text=>'Not allowed are spaces, new lines, :&,.''+?"^ and a numeric value'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527131411923090449)
,p_name=>'MODEL.HELP.RESTRICTED_CHARS.US_ONLY'
,p_message_text=>'Only a-z, A-Z, 0-9 and spaces'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527131518468090449)
,p_name=>'MODEL.HELP.RESTRICTED_CHARS.US_ONLY_NO_SPACE'
,p_message_text=>'Only a-z, A-Z and 0-9'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(759935317944961642)
,p_name=>'MODEL.HELP.RESTRICTED_CHARS.US_ONLY_UNDERSCORE_NO_SPACE'
,p_message_text=>'Only a-z, A-Z,0-9, and underscore'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527131613223090449)
,p_name=>'MODEL.HELP.RESTRICTED_CHARS.WEB_SAFE'
,p_message_text=>'Not allowed are <>"'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527131379156090449)
,p_name=>'MODEL.HELP.RESTRICTED_CHARS_LABEL'
,p_message_text=>'Restricted Characters'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527130270268090447)
,p_name=>'MODEL.HELP.SUBSTITUTIONS'
,p_message_text=>'Supported Substitutions'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(646476018564424729)
,p_name=>'MODEL.HELP.TEMPLATE_DIRECTIVE_CLIENT'
,p_message_text=>'Supports Client-side Template Directives'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2401534687709905)
,p_name=>'MODEL.HELP.TEMPLATE_DIRECTIVE_SERVER'
,p_message_text=>'Supports Server-side Template Directives'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527129649645090445)
,p_name=>'MODEL.HELP.TYPE'
,p_message_text=>'Type'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527126883295090439)
,p_name=>'MODEL.LOCKED.BY_OTHER_USER'
,p_message_text=>'Page is already locked by user ''%0''!'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(252218307380640929)
,p_name=>'MODEL.LOV.ABSOLUTE_COLUMN_NO'
,p_message_text=>'%0. Column [Deprecated]'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527127756269090442)
,p_name=>'MODEL.LOV.APEX_EVENTS'
,p_message_text=>'Framework Events'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527127623851090442)
,p_name=>'MODEL.LOV.BROWSER_EVENTS'
,p_message_text=>'Browser Events'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527129356338090445)
,p_name=>'MODEL.LOV.COLUMN_WRONG_DATA_TYPE'
,p_message_text=>'Wrong Data Type'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527127829540090442)
,p_name=>'MODEL.LOV.COMPONENT_EVENTS'
,p_message_text=>'Component Events'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527127962061090442)
,p_name=>'MODEL.LOV.CUSTOM_EVENT'
,p_message_text=>'Custom Event'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527127458036090441)
,p_name=>'MODEL.LOV.DATE_FORMAT_MASKS'
,p_message_text=>'Date Format Masks'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527127297021090439)
,p_name=>'MODEL.LOV.MUST_NOT_BE_PUBLIC_USER'
,p_message_text=>'Must Not Be Public User'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527127057105090439)
,p_name=>'MODEL.LOV.NO'
,p_message_text=>'No'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527127341221090440)
,p_name=>'MODEL.LOV.NOT_W_ARGUMENT'
,p_message_text=>'{Not %0}'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527127520574090441)
,p_name=>'MODEL.LOV.NUMBER_FORMAT_MASKS'
,p_message_text=>'Number Format Masks'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(591553197924192491)
,p_name=>'MODEL.LOV.TEMPLATE_OPTIONS.DEFAULT'
,p_message_text=>'Use Template Defaults'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(645960272017500120)
,p_name=>'MODEL.LOV.TEMPLATE_OPTIONS.DEFAULT.DESC'
,p_message_text=>'Use the Default Template Options specified for the selected template.'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527127108932090439)
,p_name=>'MODEL.LOV.UNKNOWN_LOOKUP'
,p_message_text=>'Unknown Lookup Value ''%0'''
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527126926451090439)
,p_name=>'MODEL.LOV.YES'
,p_message_text=>'Yes'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6812464791168899)
,p_name=>'MODEL.MEDIA.BLOB_COLUMN'
,p_message_text=>'BLOB Column'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6812170010143752)
,p_name=>'MODEL.MEDIA.COLUMN_HAS_WRONG_DATA_TYPE'
,p_message_text=>'%0 has wrong data type!'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6812688160171561)
,p_name=>'MODEL.MEDIA.FILENAME_COLUMN'
,p_message_text=>'Filename Column'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6813080095175294)
,p_name=>'MODEL.MEDIA.LAST_UPDATED_COLUMN'
,p_message_text=>'Last Updated Column'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6812877695173460)
,p_name=>'MODEL.MEDIA.MIME_TYPE_COLUMN'
,p_message_text=>'Mime Type Column'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6813261430180839)
,p_name=>'MODEL.MEDIA.URL_COLUMN'
,p_message_text=>'URL Column'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537622647429670519)
,p_name=>'MODEL.MULTIPLE_COMPONENTS'
,p_message_text=>'Multiple Components'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527128009832090443)
,p_name=>'MODEL.PLACEHOLDER.PLEASE_CHANGE'
,p_message_text=>'New'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527128152582090443)
,p_name=>'MODEL.PLACEHOLDER.PRINT_LINK_TEXT'
,p_message_text=>'Print'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527126715757090439)
,p_name=>'MODEL.POSTFIX.GLOBAL_PAGE'
,p_message_text=>'%0 [Global Page]'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(13305596527897632)
,p_name=>'MODEL.POSTFIX.LEGACY'
,p_message_text=>'%0 [Legacy]'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527126665753090438)
,p_name=>'MODEL.POSTFIX.PLUGIN'
,p_message_text=>'%0 [Plug-In]'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527126506723090438)
,p_name=>'MODEL.POSTFIX.UNSUPPORTED'
,p_message_text=>'%0 [Unsupported]'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527128351069090443)
,p_name=>'MODEL.SAVE.FAILED'
,p_message_text=>'Saving changes failed! See messages for details.'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527128228751090443)
,p_name=>'MODEL.SAVE.FIX_ERRORS'
,p_message_text=>'Before you can save, all errors have to be fixed!'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3748037431382094)
,p_name=>'MODEL.SHARED_COMPONENT_REFERENCE'
,p_message_text=>'%0 on Page %1'
,p_is_js_message=>true
,p_version_scn=>101733401
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(852091748387503916)
,p_name=>'MODEL.TRANSACTION.CHANGE_ATTRIBUTE'
,p_message_text=>'Change %0 > %1'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(852093816222513426)
,p_name=>'MODEL.TRANSACTION.CREATE'
,p_message_text=>'Create %0'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(852093646878512110)
,p_name=>'MODEL.TRANSACTION.DELETE'
,p_message_text=>'Delete %0'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(852094433993517371)
,p_name=>'MODEL.TRANSACTION.DELETE.MULTIPLE'
,p_message_text=>'Delete %0 components'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(852093447532510730)
,p_name=>'MODEL.TRANSACTION.DUPLICATE'
,p_message_text=>'Duplicate %0'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(852094207468515717)
,p_name=>'MODEL.TRANSACTION.DUPLICATE.MULTIPLE'
,p_message_text=>'Duplicate %0 components'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(852092140491507653)
,p_name=>'MODEL.TRANSACTION.MOVE'
,p_message_text=>'Move %0'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(852094066085514636)
,p_name=>'MODEL.TRANSACTION.MOVE.MULTIPLE'
,p_message_text=>'Move %0 components'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(852094784316518360)
,p_name=>'MODEL.TRANSACTION.UNDO'
,p_message_text=>'Undo: %0'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527129143247090445)
,p_name=>'MODEL.VAL.COLUMN_HAS_WRONG_DATA_TYPE'
,p_message_text=>'Wrong data type!'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527129230373090445)
,p_name=>'MODEL.VAL.COLUMN_NOT_FOUND'
,p_message_text=>'Invalid column!'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91015443173799796)
,p_name=>'MODEL.VAL.DOM_STATIC_ID'
,p_message_text=>'%0 contains invalid character ''%1''! Reserved HTML characters (<, >, ") can NOT be saved.'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527128470951090443)
,p_name=>'MODEL.VAL.IS_REQUIRED'
,p_message_text=>'Is required!'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527129096195090444)
,p_name=>'MODEL.VAL.MUST_BE_INTEGER'
,p_message_text=>'Must be an integer!'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527128913086090444)
,p_name=>'MODEL.VAL.MUST_BE_NUMERIC'
,p_message_text=>'Must be numeric!'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527129472183090445)
,p_name=>'MODEL.VAL.MUST_BE_UNIQUE'
,p_message_text=>'Must be unique!'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91695433489805682)
,p_name=>'MODEL.VAL.NO_SPECIAL_CHAR'
,p_message_text=>'%0 contains invalid character ''%1''! The following characters: &, <, >, ", /, ;, ",", *, |, =, % and "--" (PL/SQL comment) can NOT be saved.'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91695621760809410)
,p_name=>'MODEL.VAL.NO_SPECIAL_CHAR_NL'
,p_message_text=>'%0 contains invalid character ''%1''! The following characters: &, <, >, ", /, ;, ",", *, |, =, %, "--", and new line characters can NOT be saved.'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91696231239829739)
,p_name=>'MODEL.VAL.SAFE_COMPONENT_NAME'
,p_message_text=>'%0 contains invalid character ''%1''! The following characters: :&,.''+?"^, spaces and new line characters can NOT be saved.'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91696453185834291)
,p_name=>'MODEL.VAL.SAFE_COMPONENT_NAME_NO_NUMBER'
,p_message_text=>'%0 contains invalid character ''%1'' or is numeric! The following characters: :&,.''+?"^, spaces, new line characters and a numeric value can NOT be saved.'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(89857407104652240)
,p_name=>'MODEL.VAL.US_ONLY'
,p_message_text=>'%0 contains invalid character ''%1''! Only characters a-z, A-Z, 0-9 and space can be saved.'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91014508071779722)
,p_name=>'MODEL.VAL.US_ONLY_NO_SPACE'
,p_message_text=>'%0 contains invalid character ''%1''! Only characters a-z, A-Z and 0-9 can be saved.'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(91014752836783932)
,p_name=>'MODEL.VAL.US_ONLY_UNDERSCORE_NO_SPACE'
,p_message_text=>'%0 contains invalid character ''%1''! Only characters a-z, A-Z, 0-9 and _ can be saved.'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527128833018090444)
,p_name=>'MODEL.VAL.VALUE_GREATER_MAX_VALUE'
,p_message_text=>'Value is greater than specified maximum %0!'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527128708624090444)
,p_name=>'MODEL.VAL.VALUE_LESS_MIN_VALUE'
,p_message_text=>'Value is less than specified minimum %0!'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527128638377090444)
,p_name=>'MODEL.VAL.VALUE_TOO_LONG'
,p_message_text=>'Value too long by %0 characters!'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3009663561971259)
,p_name=>'NAVIGATION_MENU_SUBSCRIBED'
,p_message_text=>'Updating the Navigation Menu is not possible because it is subscribed from another application. Please change <strong>Navigation Preference</strong> to <strong>Do not associate this page with a navigation menu entry</strong>.'
,p_version_scn=>37165259336652
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2061430649900119)
,p_name=>'PAGE_CANT_BE_DELETED'
,p_message_text=>'Page %0 cannot be deleted because it is part of a component group.'
,p_version_scn=>159469370
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(649545829028788030)
,p_name=>'PD.ACTION.GOTO_BUTTONS'
,p_message_text=>'Go to Gallery Buttons'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(649542266328762333)
,p_name=>'PD.ACTION.GOTO_DA'
,p_message_text=>'Go to Dynamic Actions'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(649544304182774685)
,p_name=>'PD.ACTION.GOTO_GLV'
,p_message_text=>'Go to Layout'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(649541641983748984)
,p_name=>'PD.ACTION.GOTO_HELP'
,p_message_text=>'Go to Help'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(649545654198785587)
,p_name=>'PD.ACTION.GOTO_ITEMS'
,p_message_text=>'Go to Gallery Items'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(649546019975790770)
,p_name=>'PD.ACTION.GOTO_MSGS'
,p_message_text=>'Go to Messages'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(649544549442776562)
,p_name=>'PD.ACTION.GOTO_PE'
,p_message_text=>'Go to Property Editor'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2901122020424398)
,p_name=>'PD.ACTION.GOTO_PE_ATTRIBUTES'
,p_message_text=>'Go to Property Editor Attributes'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2900932236422558)
,p_name=>'PD.ACTION.GOTO_PE_MAIN'
,p_message_text=>'Go to Property Editor Main'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2901395047426879)
,p_name=>'PD.ACTION.GOTO_PE_PRINTING'
,p_message_text=>'Go to Property Editor Printing'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(649542963508765279)
,p_name=>'PD.ACTION.GOTO_PROCESSING'
,p_message_text=>'Go to Processing'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(649544798217780532)
,p_name=>'PD.ACTION.GOTO_REGIONS'
,p_message_text=>'Go to Gallery Regions'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(649542069967754252)
,p_name=>'PD.ACTION.GOTO_RENDERING'
,p_message_text=>'Go to Rendering'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(649544165288769921)
,p_name=>'PD.ACTION.GOTO_SHARED'
,p_message_text=>'Go to Page Shared Components'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(649546278475793647)
,p_name=>'PD.ACTION.PAGE_SEARCH'
,p_message_text=>'Page Search'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537573182293416358)
,p_name=>'PD.ALL_PAGES'
,p_message_text=>'All Pages'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537980750155112539)
,p_name=>'PD.APPLY_CHANGES'
,p_message_text=>'Apply Changes'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(538012652880304182)
,p_name=>'PD.BEFORE_AJAX_UNSAVED_CHANGES'
,p_message_text=>'There are unsaved changes. Press Ok to discard your changes or Cancel to return to the current page.'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537574100268421203)
,p_name=>'PD.BEFORE_PAGE_UNLOAD_UNSAVED_CHANGES'
,p_message_text=>'There are currently unsaved changes on this page. To save your changes stay on this page and press the Save Page button.'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537569806320399728)
,p_name=>'PD.BUGS'
,p_message_text=>'Bugs'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537570656778403492)
,p_name=>'PD.BUGS_N'
,p_message_text=>'Bugs (%0)'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537980049823090625)
,p_name=>'PD.CANCEL'
,p_message_text=>'Cancel'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537571009227406119)
,p_name=>'PD.CHANGES_SAVED'
,p_message_text=>'Changes saved'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537571870916410482)
,p_name=>'PD.CHANGES_SAVED_DIALOG_PAGE'
,p_message_text=>'Changes saved. Dialog pages cannot be run directly from Page Designer. Review this page by running a page that launches this dialog.'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(614834121386954214)
,p_name=>'PD.CHANGES_SAVED_GLOBAL_PAGE'
,p_message_text=>'Changes saved. Global pages cannot be run directly from Page Designer. Review the global components by running a page that includes content from the global page.'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(649433860839371302)
,p_name=>'PD.CMD.EXECUTE_FAILED'
,p_message_text=>'Failed to execute %0'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(649477823233378369)
,p_name=>'PD.CMD.REDO_FAILED'
,p_message_text=>'Failed to redo %0'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(649477234039375290)
,p_name=>'PD.CMD.UNDO_FAILED'
,p_message_text=>'Failed to undo %0'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(698821870981778655)
,p_name=>'PD.COMMENTS_BADGE_TITLE'
,p_message_text=>'Developer Comments (%0 comments)'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537573573527418311)
,p_name=>'PD.CURRENT_GROUP'
,p_message_text=>'Current Group'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537573788078419260)
,p_name=>'PD.CURRENT_UI'
,p_message_text=>'Current User Interface'
,p_is_js_message=>true
,p_version_scn=>37165770887569
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(189803850129151826)
,p_name=>'PD.CV.CLASSIC_REPORT'
,p_message_text=>'Classic Report'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(429933246591462258)
,p_name=>'PD.CV.CREATE_COMPONENT'
,p_message_text=>'Create %0'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(189803687130149412)
,p_name=>'PD.CV.LEGACY_CALENDAR'
,p_message_text=>'Legacy Calendar'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1569778285935204117)
,p_name=>'PD.CV.NAVIGATION_BAR_LIST'
,p_message_text=>'Navigation Bar'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(189803344321145963)
,p_name=>'PD.CV.NAVIGATION_MENU_LIST'
,p_message_text=>'Navigation Menu'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(189801613924747282)
,p_name=>'PD.CV.NO_REGION'
,p_message_text=>'Page Items and Buttons with no Region'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(189803197719143801)
,p_name=>'PD.CV.TAB_SET'
,p_message_text=>'Tab Set'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(189801356178745100)
,p_name=>'PD.CV.TEMPLATES'
,p_message_text=>'Templates'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(528332350904248962)
,p_name=>'PD.DEL'
,p_message_text=>'Delete'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(178118415824627739)
,p_name=>'PD.ENABLE_VIEW_WARN'
,p_message_text=>'A page reload is needed to show this view. Do you want to reload the page now?'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3600337186353439)
,p_name=>'PD.ERROR.INVALID_ALIAS_RESERVED_WORD'
,p_message_text=>'Invalid Alias. Entered Alias ''%0'' is a reserved word.'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2125898337756198)
,p_name=>'PD.ERROR.PAGE_IS_PART_OF_COMPONENT_GROUP'
,p_message_text=>'The page must remain a pattern since it is part of a component group.'
,p_is_js_message=>true
,p_version_scn=>166321315
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(110666085370655958)
,p_name=>'PD.ERROR.SEPARATOR_MUST_BE_ONE_CHAR'
,p_message_text=>'CSV Separator must be only one character. Use <code>\t</code> to specify TAB.'
,p_is_js_message=>true
,p_version_scn=>37165826091971
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(528332210796248962)
,p_name=>'PD.EXPAND'
,p_message_text=>'Expand'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537569475606397998)
,p_name=>'PD.FEATURES'
,p_message_text=>'Features'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537570219869401721)
,p_name=>'PD.FEATURES_N'
,p_message_text=>'Features (%0)'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537570003292400736)
,p_name=>'PD.FEEDBACK_ENTRIES'
,p_message_text=>'Feedback Entries'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537570870651404829)
,p_name=>'PD.FEEDBACK_ENTRIES_N'
,p_message_text=>'Feedback Entries (%0)'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537571247083407042)
,p_name=>'PD.FOCUS_PAGE'
,p_message_text=>'Focus Page'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(528335009778248971)
,p_name=>'PD.GAL.HOT_BTN'
,p_message_text=>'%0 [Hot]'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(528335134175248973)
,p_name=>'PD.GAL.MI.ADD2'
,p_message_text=>'Add To'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(589107456024341987)
,p_name=>'PD.GAL.MI.SHOW_LEGACY'
,p_message_text=>'Show Legacy Components'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(528335282909248973)
,p_name=>'PD.GAL.MI.SHOW_UNSUP'
,p_message_text=>'Show Unsupported Components'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(528334925530248971)
,p_name=>'PD.GAL.NOT_SUPPORTED'
,p_message_text=>'This component is not supported in the %0 user interface.'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(528333258688248965)
,p_name=>'PD.GLV.CMD.COPY'
,p_message_text=>'copy ''%0'''
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(528333349341248965)
,p_name=>'PD.GLV.CMD.CREATE'
,p_message_text=>'create new ''%0'''
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(528333446235248965)
,p_name=>'PD.GLV.CMD.DEL'
,p_message_text=>'delete ''%0'''
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(528333504013248967)
,p_name=>'PD.GLV.CMD.DEL_N'
,p_message_text=>'delete %0 components'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(528333159391248965)
,p_name=>'PD.GLV.CMD.MOVE'
,p_message_text=>'move ''%0'''
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(528333638311248967)
,p_name=>'PD.GLV.DP_ITEMS'
,p_message_text=>'Items'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(528333741766248967)
,p_name=>'PD.GLV.EMPTY_GRID'
,p_message_text=>'No page or page has no template'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(528333809923248968)
,p_name=>'PD.GLV.MI.DISP_PAGE'
,p_message_text=>'Display From Page'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(528333953504248968)
,p_name=>'PD.GLV.MI.DISP_REGION'
,p_message_text=>'Display From Here'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(528334529569248970)
,p_name=>'PD.GLV.MI.HIDE_BTNS'
,p_message_text=>'Hide Buttons'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(528334132795248969)
,p_name=>'PD.GLV.MI.HIDE_COND_COMP'
,p_message_text=>'Hide Conditional Components'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(528334376558248969)
,p_name=>'PD.GLV.MI.HIDE_EMPTY'
,p_message_text=>'Hide Empty Slots'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(528334457509248969)
,p_name=>'PD.GLV.MI.HIDE_GLOBAL'
,p_message_text=>'Hide Global Page Components'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(528334695426248971)
,p_name=>'PD.GLV.MI.HIDE_ITEMS'
,p_message_text=>'Hide Items'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(528334236246248969)
,p_name=>'PD.GLV.MI.HIDE_LEGACY'
,p_message_text=>'Hide Empty Legacy Positions'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(528334055873248968)
,p_name=>'PD.GLV.MI.NEW_GRID'
,p_message_text=>'Start New Grid'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(528334729797248971)
,p_name=>'PD.GLV.MI.ZOOM'
,p_message_text=>'Zoom'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(528334810545248971)
,p_name=>'PD.GLV.MI.ZOOM_N'
,p_message_text=>'%0%%'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537572769513414041)
,p_name=>'PD.GROUP'
,p_message_text=>'Group'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1884773848812648835)
,p_name=>'PD.HELP.DEFAULT'
,p_message_text=>'<p>Select a component and then select an attribute in the Property Editor to display help on that attribute.</p>'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(656312319835638569)
,p_name=>'PD.HELP.FEEDBACK'
,p_message_text=>'Provide Feedback on Help'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(525345528578098301)
,p_name=>'PD.ISSUES'
,p_message_text=>'Issues'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(525346851312100385)
,p_name=>'PD.ISSUES_N'
,p_message_text=>'Issues (%0)'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(649486426567475915)
,p_name=>'PD.KBD_SHORTCUTS'
,p_message_text=>'Keyboard Shortcuts'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537660426038712677)
,p_name=>'PD.LINK.APPLICATION_N'
,p_message_text=>'Application %0:%1'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(334526094638683120)
,p_name=>'PD.LINK.GOTO_APPLICATION_N'
,p_message_text=>'Go To Application %0:%1'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(334525775470680631)
,p_name=>'PD.LINK.GOTO_PAGE_N'
,p_message_text=>'Go To Page %0'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(334534157123685447)
,p_name=>'PD.LINK.GOTO_URL'
,p_message_text=>'Go To %0'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537660244921711760)
,p_name=>'PD.LINK.PAGE_N'
,p_message_text=>'Page %0'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537567469735388123)
,p_name=>'PD.LOCK'
,p_message_text=>'Lock'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537567221825387250)
,p_name=>'PD.LOCK_PAGE'
,p_message_text=>'Lock Page'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(162610416903625606)
,p_name=>'PD.MESSAGES'
,p_message_text=>'Messages'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(528332581323248962)
,p_name=>'PD.MI.COPY2'
,p_message_text=>'Copy To'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(528332433995248962)
,p_name=>'PD.MI.MOVE2'
,p_message_text=>'Move To'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1007362748417637543)
,p_name=>'PD.NAV_NEXT_PAGE'
,p_message_text=>'Navigate to Next Page'
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1007362992632640028)
,p_name=>'PD.NAV_PREV_PAGE'
,p_message_text=>'Navigate to Previous Page'
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3844979523030890)
,p_name=>'PD.NEXT_PAGE'
,p_message_text=>'Next Page'
,p_version_scn=>516536040
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2403157175156725)
,p_name=>'PD.NOT_SUBSCRIBED'
,p_message_text=>'Not Subscribed'
,p_is_js_message=>true
,p_version_scn=>153119869
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537568456892392751)
,p_name=>'PD.OK'
,p_message_text=>'OK'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(471808045621616222)
,p_name=>'PD.PAGE_ALIAS'
,p_message_text=>'Page Alias'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537574341738422409)
,p_name=>'PD.PAGE_DOES_NOT_EXIST'
,p_message_text=>'Specified page does not exist.'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537573929683420098)
,p_name=>'PD.PAGE_FINDER'
,p_message_text=>'Page Finder'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537568219857391835)
,p_name=>'PD.PAGE_LOCKED'
,p_message_text=>'Page Locked'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537567041067386291)
,p_name=>'PD.PAGE_LOCKED_BY'
,p_message_text=>'Page locked by %0'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537566890660384867)
,p_name=>'PD.PAGE_LOCKED_BY_YOU'
,p_message_text=>'Page locked by you'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537572345862412278)
,p_name=>'PD.PAGE_NAME'
,p_message_text=>'Page Name'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537572126227411393)
,p_name=>'PD.PAGE_NUMBER'
,p_message_text=>'Page Number'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1478300376952894357)
,p_name=>'PD.PAGE_PICKER.RECENTLY_EDITED'
,p_message_text=>'Recently Edited'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537572986622414995)
,p_name=>'PD.PAGE_PICKER.SHOW'
,p_message_text=>'Show'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537566614429383785)
,p_name=>'PD.PAGE_UNLOCKED'
,p_message_text=>'Page unlocked'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(9483741588741588)
,p_name=>'PD.PE.ACTIONS'
,p_message_text=>'Actions'
,p_is_js_message=>true
,p_version_scn=>37165770887604
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(538382728629244876)
,p_name=>'PD.PE.ALL_PAGES'
,p_message_text=>'All Pages'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537625141144687433)
,p_name=>'PD.PE.APPLICATION'
,p_message_text=>'Application'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1831313932615338930)
,p_name=>'PD.PE.BUTTON_NO_ID_ERROR'
,p_message_text=>'The selected button uses a ''Button Template'' that does not contain the #BUTTON_ID# substitution string'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537623524500675947)
,p_name=>'PD.PE.CANCEL'
,p_message_text=>'Cancel'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1272840568069283530)
,p_name=>'PD.PE.CATEGORY'
,p_message_text=>'Category'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537623891834677736)
,p_name=>'PD.PE.CLEAR'
,p_message_text=>'Clear'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537662675393726979)
,p_name=>'PD.PE.CODE_EDITOR.TITLE'
,p_message_text=>'Code Editor - %0'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537672977722859785)
,p_name=>'PD.PE.COLLAPSE_ALL'
,p_message_text=>'Collapse All'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2090206553663084091)
,p_name=>'PD.PE.COLUMNS'
,p_message_text=>'Columns'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537671957100852245)
,p_name=>'PD.PE.COMMENT'
,p_message_text=>'Comment'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537664387164741051)
,p_name=>'PD.PE.CURRENT_PAGE'
,p_message_text=>'Current Page'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(538382563034241645)
,p_name=>'PD.PE.CURRENT_UI'
,p_message_text=>'Current User Interface'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1272840715091284554)
,p_name=>'PD.PE.CUSTOM'
,p_message_text=>'Custom'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537664509989741800)
,p_name=>'PD.PE.CUSTOM_PAGE'
,p_message_text=>'Custom Page'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(777713516914954450)
,p_name=>'PD.PE.EDITOR.UNSAVED_CHANGES'
,p_message_text=>'Changes have been made. Press OK to close editor without saving changes.'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(656171294636279330)
,p_name=>'PD.PE.EXAMPLES'
,p_message_text=>'Examples'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537672744227858785)
,p_name=>'PD.PE.EXPAND_ALL'
,p_message_text=>'Expand All'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(756783228447129642)
,p_name=>'PD.PE.FA.ACCESSIBILITY'
,p_message_text=>'Accessibility'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1429570545916359)
,p_name=>'PD.PE.FA.AI'
,p_message_text=>'AI'
,p_is_js_message=>true
,p_version_scn=>70459926
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1272784898650949790)
,p_name=>'PD.PE.FA.BRAND'
,p_message_text=>'Brand'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1429357549913763)
,p_name=>'PD.PE.FA.BUSINESS'
,p_message_text=>'Business'
,p_is_js_message=>true
,p_version_scn=>70459996
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1498474760974163982)
,p_name=>'PD.PE.FA.CALENDAR'
,p_message_text=>'Calendar'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1272783831726944216)
,p_name=>'PD.PE.FA.CHART'
,p_message_text=>'Chart'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1272784097269945091)
,p_name=>'PD.PE.FA.CURRENCY'
,p_message_text=>'Currency'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(558071492772126993)
,p_name=>'PD.PE.FA.CUSTOM'
,p_message_text=>'Custom'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1272784453669947621)
,p_name=>'PD.PE.FA.DIRECTIONAL'
,p_message_text=>'Directional'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1498475123407164886)
,p_name=>'PD.PE.FA.EMOJI'
,p_message_text=>'Emoji'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1272783028745940107)
,p_name=>'PD.PE.FA.FILE_TYPE'
,p_message_text=>'File Type'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1272783433210942311)
,p_name=>'PD.PE.FA.FORM_CONTROL'
,p_message_text=>'Form Control'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(497172612922862395)
,p_name=>'PD.PE.FA.GENDER'
,p_message_text=>'Gender'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(497173037579866292)
,p_name=>'PD.PE.FA.HAND'
,p_message_text=>'Hand'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(610727733418013234)
,p_name=>'PD.PE.FA.MAPS'
,p_message_text=>'Maps'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1272785096027950700)
,p_name=>'PD.PE.FA.MEDICAL'
,p_message_text=>'Medical'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1498476009605166139)
,p_name=>'PD.PE.FA.NUMBERS'
,p_message_text=>'Numbers'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1272783677394943405)
,p_name=>'PD.PE.FA.PAYMENT'
,p_message_text=>'Payment'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1272783245380941280)
,p_name=>'PD.PE.FA.SPINNER'
,p_message_text=>'Spinner'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1272784293486946257)
,p_name=>'PD.PE.FA.TEXT_EDITOR'
,p_message_text=>'Text Editor'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(497173295662868307)
,p_name=>'PD.PE.FA.TRANSPORTATION'
,p_message_text=>'Transportation'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1272784679867948934)
,p_name=>'PD.PE.FA.VIDEO_PLAYER'
,p_message_text=>'Video Player'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1272782830890939019)
,p_name=>'PD.PE.FA.WEB_APPLICATION'
,p_message_text=>'Web Application'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6203985094872899)
,p_name=>'PD.PE.FUNCTIONS'
,p_message_text=>'Functions'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537664894919747259)
,p_name=>'PD.PE.GLOBAL_PAGE'
,p_message_text=>'Global Page'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(815789588829193078)
,p_name=>'PD.PE.GO_TO_COMPONENT'
,p_message_text=>'Go to %0'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(181863498639603572)
,p_name=>'PD.PE.ICON.DEFAULT'
,p_message_text=>'Default'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(181863995450605279)
,p_name=>'PD.PE.ICON.LARGE'
,p_message_text=>'Large'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(181863788545604494)
,p_name=>'PD.PE.ICON.SMALL'
,p_message_text=>'Small'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(181863227657602768)
,p_name=>'PD.PE.ICON.STYLE'
,p_message_text=>'Style'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(42511613650815864)
,p_name=>'PD.PE.INVALID_FALSE_ACTIONS'
,p_message_text=>'''False'' Actions will only execute when the Dynamic Action has a ''Condition'' defined in the ''When'' attributes. This Dynamic Action has no such ''Condition''.'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(538379530968186476)
,p_name=>'PD.PE.IS_REQUIRED'
,p_message_text=>'Is required!'
,p_is_js_message=>true
,p_version_scn=>37165770887570
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537663587259737411)
,p_name=>'PD.PE.ITEM_SCOPE'
,p_message_text=>'Item Scope'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537673123135860597)
,p_name=>'PD.PE.KEEP_LABELS_ABOVE'
,p_message_text=>'Keep Labels Above'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537663399103736453)
,p_name=>'PD.PE.LABEL'
,p_message_text=>'Label'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1829520606431648006)
,p_name=>'PD.PE.LINK.ADDITIONAL_PARAMETERS'
,p_message_text=>'Additional Parameters'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(272443287473582025)
,p_name=>'PD.PE.LINK.ANCHOR'
,p_message_text=>'Anchor'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(274227583536402662)
,p_name=>'PD.PE.LINK.CLEAR_ACTION'
,p_message_text=>'Action'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(274226587368361570)
,p_name=>'PD.PE.LINK.CLEAR_ACTION.CLEAR_REGIONS'
,p_message_text=>'Clear Regions'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(274226367391359106)
,p_name=>'PD.PE.LINK.CLEAR_ACTION.NONE'
,p_message_text=>'None'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(274226908325369024)
,p_name=>'PD.PE.LINK.CLEAR_ACTION.RESET_PAGINATION'
,p_message_text=>'Reset Pagination'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(274226775873367112)
,p_name=>'PD.PE.LINK.CLEAR_ACTION.RESET_REGIONS'
,p_message_text=>'Reset Regions'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537627401281693203)
,p_name=>'PD.PE.LINK.CLEAR_CACHE'
,p_message_text=>'Clear Cache'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537661466911719182)
,p_name=>'PD.PE.LINK.DG.ADVANCED'
,p_message_text=>'Advanced'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537661153054717714)
,p_name=>'PD.PE.LINK.DG.CLEAR_SESSION'
,p_message_text=>'Clear / Reset'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537660972096716685)
,p_name=>'PD.PE.LINK.DG.SET_ITEMS'
,p_message_text=>'Set Items'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537660767399715980)
,p_name=>'PD.PE.LINK.DG.TARGET'
,p_message_text=>'Target'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537657632066697191)
,p_name=>'PD.PE.LINK.ITEM_N_NAME'
,p_message_text=>'Item %0: Name'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537658016043698854)
,p_name=>'PD.PE.LINK.ITEM_N_NAME_LOV'
,p_message_text=>'Item %0: Name List of Values'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537657820073697914)
,p_name=>'PD.PE.LINK.ITEM_N_VALUE'
,p_message_text=>'Item %0: Value'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537658269779699734)
,p_name=>'PD.PE.LINK.ITEM_N_VALUE_LOV'
,p_message_text=>'Item %0: Value List of Values'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537658426349700535)
,p_name=>'PD.PE.LINK.NAME_LIST_OF_VALUES'
,p_message_text=>'Name: List of Values'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537660062507709035)
,p_name=>'PD.PE.LINK.NO_LINK_DEFINED'
,p_message_text=>'No Link Defined'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537626981130691563)
,p_name=>'PD.PE.LINK.PAGE'
,p_message_text=>'Page'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537659644893707024)
,p_name=>'PD.PE.LINK.REMOVE'
,p_message_text=>'Remove'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537659894109708196)
,p_name=>'PD.PE.LINK.REMOVE_ITEM_N'
,p_message_text=>'Remove Item %0'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537627298488692338)
,p_name=>'PD.PE.LINK.REQUEST'
,p_message_text=>'Request'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537659030111702916)
,p_name=>'PD.PE.LINK.SUCCESS_MESSAGE'
,p_message_text=>'Success Message'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537624382651681498)
,p_name=>'PD.PE.LINK.TITLE'
,p_message_text=>'Link Builder - %0'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537661809124721424)
,p_name=>'PD.PE.LINK.TYPE.PAGE_IN_DIFF_APP'
,p_message_text=>'Page in a different application'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537661601114720444)
,p_name=>'PD.PE.LINK.TYPE.PAGE_IN_THIS_APP'
,p_message_text=>'Page in this application'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537659387392705491)
,p_name=>'PD.PE.LINK.URL'
,p_message_text=>'URL'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537657432803696323)
,p_name=>'PD.PE.LINK.VALUE'
,p_message_text=>'Value'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537658638644701367)
,p_name=>'PD.PE.LINK.VALUE_LIST_OF_VALUES'
,p_message_text=>'Value: List of Values'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6811766972115819)
,p_name=>'PD.PE.LOV.COLUMN_WRONG_DATA_TYPE'
,p_message_text=>'Wrong Data Type'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(808610367027545316)
,p_name=>'PD.PE.LOV.UNKNOWN_LOOKUP'
,p_message_text=>'Unknown Lookup Value ''%0'''
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(12201296512184733)
,p_name=>'PD.PE.MEDIA.BLOB_COLUMN'
,p_message_text=>'BLOB Column'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(12201498642191257)
,p_name=>'PD.PE.MEDIA.FILENAME_COLUMN'
,p_message_text=>'Filename Column'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(12201874643198326)
,p_name=>'PD.PE.MEDIA.LAST_UPDATED_COLUMN'
,p_message_text=>'Last Updated Column'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(12202988316232253)
,p_name=>'PD.PE.MEDIA.MEDIA_ATTRIBUTES'
,p_message_text=>'Media Attributes'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(12201633949194722)
,p_name=>'PD.PE.MEDIA.MIME_TYPE_COLUMN'
,p_message_text=>'Mime Type Column'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(112505787686608972)
,p_name=>'PD.PE.MEDIA.NO_MEDIA'
,p_message_text=>'No Media'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(12200457173167683)
,p_name=>'PD.PE.MEDIA.NO_MEDIA_DEFINED'
,p_message_text=>'No Media Defined'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(12200878065177839)
,p_name=>'PD.PE.MEDIA.SOURCE'
,p_message_text=>'Source'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(12202753115219326)
,p_name=>'PD.PE.MEDIA.SOURCE.BLOB_COLUMN'
,p_message_text=>'BLOB Column'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(12202520387217341)
,p_name=>'PD.PE.MEDIA.SOURCE.URL'
,p_message_text=>'URL'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2602842574170398)
,p_name=>'PD.PE.MEDIA.SOURCE.URL_COLUMN'
,p_message_text=>'URL Column'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(12200660735169881)
,p_name=>'PD.PE.MEDIA.TITLE'
,p_message_text=>'Media'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(12201087516180611)
,p_name=>'PD.PE.MEDIA.URL'
,p_message_text=>'URL'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(12202024700199795)
,p_name=>'PD.PE.MEDIA.URL_COLUMN'
,p_message_text=>'URL Column'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537622237436668137)
,p_name=>'PD.PE.MULTIPLE_TYPES'
,p_message_text=>'Multiple Types'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537657263639695615)
,p_name=>'PD.PE.NAME'
,p_message_text=>'Name'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(538263210379816981)
,p_name=>'PD.PE.OK'
,p_message_text=>'OK'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3702233490031165)
,p_name=>'PD.PE.ORDER_BY_ITEM.BUTTON_TEXT_0'
,p_message_text=>'%0, no Order Bys'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3701693863025557)
,p_name=>'PD.PE.ORDER_BY_ITEM.BUTTON_TEXT_1'
,p_message_text=>'%0, 1 Order By'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3701883454027919)
,p_name=>'PD.PE.ORDER_BY_ITEM.BUTTON_TEXT_N'
,p_message_text=>'%0, %1 Order Bys'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3702443282032545)
,p_name=>'PD.PE.ORDER_BY_ITEM.BUTTON_TEXT_NULL'
,p_message_text=>'No Order By Item'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4800295911126452)
,p_name=>'PD.PE.ORDER_BY_ITEM.CLAUSE_1_IS_REQUIRED'
,p_message_text=>'Order By Clause 1 is required.'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4800176223126033)
,p_name=>'PD.PE.ORDER_BY_ITEM.CLAUSE_N_IS_REQUIRED'
,p_message_text=>'Order By Clause %0 is required.'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3700970456009646)
,p_name=>'PD.PE.ORDER_BY_ITEM.DISPLAY'
,p_message_text=>'Display'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3901556674096132)
,p_name=>'PD.PE.ORDER_BY_ITEM.DISPLAY_N'
,p_message_text=>'Display %0'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3701216969013159)
,p_name=>'PD.PE.ORDER_BY_ITEM.EXPRESSION'
,p_message_text=>'Clause'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3700284653000947)
,p_name=>'PD.PE.ORDER_BY_ITEM.EXPRESSIONS'
,p_message_text=>'Order By Clauses'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3901852113098634)
,p_name=>'PD.PE.ORDER_BY_ITEM.EXPRESSION_N'
,p_message_text=>'Clause %0'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3701844525425908)
,p_name=>'PD.PE.ORDER_BY_ITEM.INFO_ITEM_INLINE_STATIC_LOV'
,p_message_text=>'The Page Item <em>Inline Static LOV</em> will be built based on <strong>Key</strong> and <strong>Display</strong> values.'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3702044850435081)
,p_name=>'PD.PE.ORDER_BY_ITEM.INFO_ITEM_SHARED_LOV'
,p_message_text=>'The Page Item <em>Value</em>, or <em>Shared LOV Return Values</em>, must match the <strong>Key</strong> values.'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3700594762002694)
,p_name=>'PD.PE.ORDER_BY_ITEM.ITEM'
,p_message_text=>'Item'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2601225265236523)
,p_name=>'PD.PE.ORDER_BY_ITEM.KEY'
,p_message_text=>'Key'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3901321170094721)
,p_name=>'PD.PE.ORDER_BY_ITEM.KEY_N'
,p_message_text=>'Key %0'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2205595226389395)
,p_name=>'PD.PE.ORDER_BY_ITEM.MOVE_DOWN_CLAUSE_N'
,p_message_text=>'Move Down Clause %0'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2205495383389358)
,p_name=>'PD.PE.ORDER_BY_ITEM.MOVE_UP_CLAUSE_N'
,p_message_text=>'Move Up Clause %0'
,p_is_js_message=>true
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2000627694535510)
,p_name=>'PD.PE.ORDER_BY_ITEM.NO_ITEM'
,p_message_text=>'No Item'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4100538196628944)
,p_name=>'PD.PE.ORDER_BY_ITEM.OPEN_CODE_EDITOR'
,p_message_text=>'Edit with Code Editor'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2200270953356791)
,p_name=>'PD.PE.ORDER_BY_ITEM.OPEN_CODE_EDITOR_EXPR_N'
,p_message_text=>'Edit Order By Clause %0 with Code Editor'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1643459476556126)
,p_name=>'PD.PE.ORDER_BY_ITEM.PICK_ITEM'
,p_message_text=>'Name'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2205305835385405)
,p_name=>'PD.PE.ORDER_BY_ITEM.REMOVE_CLAUSE_N'
,p_message_text=>'Remove Clause %0'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3700744818006465)
,p_name=>'PD.PE.ORDER_BY_ITEM.TITLE'
,p_message_text=>'Order By Item'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6203320687864801)
,p_name=>'PD.PE.OWNER_SCHEMA'
,p_message_text=>'Selected Owner'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(471808288699617455)
,p_name=>'PD.PE.PAGE_ALIAS'
,p_message_text=>'Page Alias'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(538382341053234713)
,p_name=>'PD.PE.PAGE_NAME'
,p_message_text=>'Page Name'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(538380702144207711)
,p_name=>'PD.PE.PAGE_NUMBER'
,p_message_text=>'Page Number'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(538017331887609732)
,p_name=>'PD.PE.PICK'
,p_message_text=>'Pick %0'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1772493964847621)
,p_name=>'PD.PE.PLUGIN.GROUP.LEGACY'
,p_message_text=>'Legacy'
,p_is_js_message=>true
,p_version_scn=>226130873
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1772625872853956)
,p_name=>'PD.PE.PLUGIN.GROUP.UNSUPPORTED'
,p_message_text=>'Unsupported'
,p_is_js_message=>true
,p_version_scn=>226130968
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1272749126163569916)
,p_name=>'PD.PE.PREVIEW'
,p_message_text=>'Preview'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6203732040871686)
,p_name=>'PD.PE.PROCEDURES'
,p_message_text=>'Procedures'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(312185119285543175)
,p_name=>'PD.PE.PROPERTY.VALUE_VARIES'
,p_message_text=>'Value Varies'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6203533251866643)
,p_name=>'PD.PE.PUBLIC'
,p_message_text=>'Public'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(538380971245213043)
,p_name=>'PD.PE.SEARCH'
,p_message_text=>'Search'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537565292515276323)
,p_name=>'PD.PE.SHOW_ALL'
,p_message_text=>'Show All'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537565068472275021)
,p_name=>'PD.PE.SHOW_COMMON'
,p_message_text=>'Show Common'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2015595958832302404)
,p_name=>'PD.PE.SHOW_HIDE_NOT_SUPPORTED'
,p_message_text=>'''Show'' and ''Hide'' are not supported actions for Interactive Grid Columns'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(589107813215353527)
,p_name=>'PD.PE.SHOW_LEGACY'
,p_message_text=>'Show Legacy...'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1969920703439107)
,p_name=>'PD.PE.SHOW_UNSUPPORTED'
,p_message_text=>'Show Unsupported...'
,p_is_js_message=>true
,p_version_scn=>226300073
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(76682058457328371)
,p_name=>'PD.PE.STATIC_LOV.GROUP.SORT'
,p_message_text=>'Sort'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(76682445908330528)
,p_name=>'PD.PE.STATIC_LOV.GROUP.VALUES'
,p_message_text=>'Values'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(76684205124344144)
,p_name=>'PD.PE.STATIC_LOV.MOVE_DOWN'
,p_message_text=>'Move Down'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(79164195430947263)
,p_name=>'PD.PE.STATIC_LOV.MOVE_DOWN_VALUE_N'
,p_message_text=>'Move Down Value %0'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(76684078739342733)
,p_name=>'PD.PE.STATIC_LOV.MOVE_UP'
,p_message_text=>'Move Up'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(79163960555945937)
,p_name=>'PD.PE.STATIC_LOV.MOVE_UP_VALUE_N'
,p_message_text=>'Move Up Value %0'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(76683252158336569)
,p_name=>'PD.PE.STATIC_LOV.PROP.SORT'
,p_message_text=>'Sort at Runtime'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(76682209847329552)
,p_name=>'PD.PE.STATIC_LOV.PROP.VALUES'
,p_message_text=>'Values'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(76682830043333625)
,p_name=>'PD.PE.STATIC_LOV.REMOVE'
,p_message_text=>'Remove'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(76683486017337989)
,p_name=>'PD.PE.STATIC_LOV.REMOVE_VALUE_N'
,p_message_text=>'Remove Value %0'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(76683081699334747)
,p_name=>'PD.PE.STATIC_LOV.VALUE.DISPLAY'
,p_message_text=>'Display Value'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(76682648950331839)
,p_name=>'PD.PE.STATIC_LOV.VALUE.RETURN'
,p_message_text=>'Return Value'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(76683845473340513)
,p_name=>'PD.PE.STATIC_LOV.VALUE_N_DISPLAY'
,p_message_text=>'Value %0: Display'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(76683669394339372)
,p_name=>'PD.PE.STATIC_LOV.VALUE_N_RETURN'
,p_message_text=>'Value %0: Return'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537672137244853027)
,p_name=>'PD.PE.TABLES'
,p_message_text=>'Tables'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537663951693739656)
,p_name=>'PD.PE.TARGET_PAGE'
,p_message_text=>'Target Page'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(688353056054686017)
,p_name=>'PD.PE.TEMPLATE_OPTIONS.ADVANCED'
,p_message_text=>'Advanced'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(688352860440684819)
,p_name=>'PD.PE.TEMPLATE_OPTIONS.COMMON'
,p_message_text=>'Common'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(645962238747559222)
,p_name=>'PD.PE.TEMPLATE_OPTIONS.GENERAL'
,p_message_text=>'General'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(819013051686718161)
,p_name=>'PD.PE.TEMPLATE_OPTIONS.NONE_SELECTED'
,p_message_text=>'None selected'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4000249772412576)
,p_name=>'PD.PE.TEMPLATE_PLACEHOLDERS.ASSIGN_ITEMS'
,p_message_text=>'Assign Items or Values'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3700829933334349)
,p_name=>'PD.PE.TEMPLATE_PLACEHOLDERS.ITEMS'
,p_message_text=>'Items'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4100266606454465)
,p_name=>'PD.PE.TEMPLATE_PLACEHOLDERS.NAME'
,p_message_text=>'Placeholder'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3600571272229927)
,p_name=>'PD.PE.TEMPLATE_PLACEHOLDERS.NONE_DEFINED'
,p_message_text=>'No placeholders.'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(254750420302561492)
,p_name=>'PD.PE.TEMPLATE_PLACEHOLDERS.ONE_EMPTY_PLACEHOLDER'
,p_message_text=>'One unassigned placeholder.'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(254750719196564703)
,p_name=>'PD.PE.TEMPLATE_PLACEHOLDERS.ONE_PLACEHOLDER'
,p_message_text=>'One placeholder.'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3601248891238372)
,p_name=>'PD.PE.TEMPLATE_PLACEHOLDERS.PLACEHOLDERS'
,p_message_text=>'%0 placeholders, %1 unassigned.'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3900238893391707)
,p_name=>'PD.PE.TEMPLATE_PLACEHOLDERS.TITLE'
,p_message_text=>'Set Placeholder Values'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4100531479458777)
,p_name=>'PD.PE.TEMPLATE_PLACEHOLDERS.VALUE'
,p_message_text=>'Item or Value'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537621718691664863)
,p_name=>'PD.PE.TITLE'
,p_message_text=>'Property Editor'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537621969319666315)
,p_name=>'PD.PE.TITLE_WITH_TYPE'
,p_message_text=>'Property Editor - %0'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537624880689685824)
,p_name=>'PD.PE.TYPE'
,p_message_text=>'Type'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537671457403847382)
,p_name=>'PD.PE.USER_INTERFACE'
,p_message_text=>'User Interface'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1272748733444559396)
,p_name=>'PD.PE.UTILIZED'
,p_message_text=>'Utilized'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6811212331096369)
,p_name=>'PD.PE.VAL.COLUMN_HAS_WRONG_DATA_TYPE'
,p_message_text=>'Wrong data type!'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537624169781679380)
,p_name=>'PD.PE.VALIDATE'
,p_message_text=>'Validate'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537672331622853706)
,p_name=>'PD.PE.VIEWS'
,p_message_text=>'Views'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2666708877309141)
,p_name=>'PD.PE.WF.ACT_VARS'
,p_message_text=>'Activity Variables'
,p_is_js_message=>true
,p_version_scn=>38788392
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2666358169319482)
,p_name=>'PD.PE.WF.PARAMS'
,p_message_text=>'Workflow Parameters'
,p_is_js_message=>true
,p_version_scn=>38788392
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2666512969314599)
,p_name=>'PD.PE.WF.VERSION_VARS'
,p_message_text=>'Version Variables'
,p_is_js_message=>true
,p_version_scn=>38788392
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3845126954034515)
,p_name=>'PD.PREV_PAGE'
,p_message_text=>'Previous Page'
,p_version_scn=>516534229
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537976572330939112)
,p_name=>'PD.REDO'
,p_message_text=>'Redo %0'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(528332139355248960)
,p_name=>'PD.RESTORE'
,p_message_text=>'Restore'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537571438914408289)
,p_name=>'PD.RUN_PAGE'
,p_message_text=>'Run Page'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(79746876850633235)
,p_name=>'PD.SAVE'
,p_message_text=>'Save %0'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(79747018697638663)
,p_name=>'PD.SAVE_AND_RUN_PAGE'
,p_message_text=>'Save and Run Page %0'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537981109781145492)
,p_name=>'PD.SEARCH'
,p_message_text=>'Search'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537568823963395090)
,p_name=>'PD.SHOW_LABELS'
,p_message_text=>'Show Labels'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537569040720395945)
,p_name=>'PD.SHOW_NAMES'
,p_message_text=>'Show Names'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2045806106497419)
,p_name=>'PD.SLOTS.GROUP.PAGE'
,p_message_text=>'Page'
,p_is_js_message=>true
,p_version_scn=>103888834
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1417671963415861)
,p_name=>'PD.SLOTS.GROUP.PLUGIN'
,p_message_text=>'Component'
,p_is_js_message=>true
,p_version_scn=>219722256
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1417401024413083)
,p_name=>'PD.SLOTS.GROUP.REGION'
,p_message_text=>'Region'
,p_is_js_message=>true
,p_version_scn=>219722276
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(698822021038781732)
,p_name=>'PD.TEAM_DEV_BADGE_TITLE'
,p_message_text=>'Team Development (%0 items)'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537569678595398984)
,p_name=>'PD.TODOS'
,p_message_text=>'To Do''s'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537570479071402685)
,p_name=>'PD.TODOS_N'
,p_message_text=>'To Do''s (%0)'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(72522881608992258)
,p_name=>'PD.TREE.ADD_CHILD_PROCESS'
,p_message_text=>'Add Child Process'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3600191792672455)
,p_name=>'PD.TREE.BELOW'
,p_message_text=>'Below'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1260474461674058684)
,p_name=>'PD.TREE.CLASSIC_REPORT'
,p_message_text=>'Classic Report'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527537613604170966)
,p_name=>'PD.TREE.COLLAPSE_ALL_BELOW'
,p_message_text=>'Collapse All Below'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(482919853858738300)
,p_name=>'PD.TREE.COLUMN_NOT_NULL_VALIDATION'
,p_message_text=>'#COLUMN_HEADER# must have a value.'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1813070965398030)
,p_name=>'PD.TREE.COMMENT_OUT'
,p_message_text=>'Comment Out'
,p_is_js_message=>true
,p_version_scn=>99456487
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2100713668556598)
,p_name=>'PD.TREE.COMPONENTS'
,p_message_text=>'Components'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(538972319402137919)
,p_name=>'PD.TREE.COPY_SHARED_COMPONENT'
,p_message_text=>'Copy...'
,p_is_js_message=>true
,p_version_scn=>37165770887572
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527537410661170966)
,p_name=>'PD.TREE.COPY_TO_PAGE'
,p_message_text=>'Copy to other Page...'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527537001144170892)
,p_name=>'PD.TREE.CREATE'
,p_message_text=>'Create %0'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3700215992768614)
,p_name=>'PD.TREE.CREATE.BUTTON.BELOW'
,p_message_text=>'Create Button Below'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3700330866779063)
,p_name=>'PD.TREE.CREATE.ITEM.BELOW'
,p_message_text=>'Create Page Item Below'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2002808643474657)
,p_name=>'PD.TREE.CREATE.REGION.BELOW'
,p_message_text=>'Create Region Below'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(656711910940216220)
,p_name=>'PD.TREE.CREATE_SHARED_COMPONENT'
,p_message_text=>'Create...'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527537270246170966)
,p_name=>'PD.TREE.DELETE'
,p_message_text=>'Delete'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527537129643170965)
,p_name=>'PD.TREE.DUPLICATE'
,p_message_text=>'Duplicate'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527538137977170967)
,p_name=>'PD.TREE.DYNAMIC_ACTIONS'
,p_message_text=>'Dynamic Actions'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(656710456542192008)
,p_name=>'PD.TREE.EDIT_SHARED_COMPONENT'
,p_message_text=>'Edit...'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527539978321170971)
,p_name=>'PD.TREE.EVENTS'
,p_message_text=>'Events'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527537548833170966)
,p_name=>'PD.TREE.EXPAND_ALL_BELOW'
,p_message_text=>'Expand All Below'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(472565288037841275)
,p_name=>'PD.TREE.FACETS'
,p_message_text=>'Facets'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527537896795170967)
,p_name=>'PD.TREE.FALSE'
,p_message_text=>'False'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527538010432170967)
,p_name=>'PD.TREE.FALSE_ACTION'
,p_message_text=>'FALSE Action'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527540154173170971)
,p_name=>'PD.TREE.FIRED_ON_PAGE_LOAD'
,p_message_text=>'Actions Fired on Page Load'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(656713136946228971)
,p_name=>'PD.TREE.GOTO_TARGET_PAGE'
,p_message_text=>'Go to Target Page'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527539231754170969)
,p_name=>'PD.TREE.INVALID_SLOT'
,p_message_text=>'Invalid Slot [Not Rendered]'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527538677617170968)
,p_name=>'PD.TREE.ITEMS'
,p_message_text=>'Items'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1260474283086054127)
,p_name=>'PD.TREE.LEGACY_CALENDAR'
,p_message_text=>'Legacy Calendar'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1401545159876215)
,p_name=>'PD.TREE.NAME_DYNAMIC_ACTIONS'
,p_message_text=>'Dynamic Actions'
,p_version_scn=>21708979
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1401777566878962)
,p_name=>'PD.TREE.NAME_PROCESSING'
,p_message_text=>'Processing'
,p_version_scn=>21708956
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1401387784872978)
,p_name=>'PD.TREE.NAME_RENDERING'
,p_message_text=>'Rendering'
,p_version_scn=>21708110
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1401916259882804)
,p_name=>'PD.TREE.NAME_SHARED_COMPONENTS'
,p_message_text=>'Shared Components'
,p_version_scn=>21711644
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1569777757574198643)
,p_name=>'PD.TREE.NAVIGATION_BAR_LIST'
,p_message_text=>'Navigation Bar'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1301490697147181589)
,p_name=>'PD.TREE.NAVIGATION_MENU_LIST'
,p_message_text=>'Navigation Menu'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527539386842170970)
,p_name=>'PD.TREE.NO_REGION'
,p_message_text=>'Page Items and Buttons with no Region'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527538277053170968)
,p_name=>'PD.TREE.OPPOSITE_DYNAMIC_ACTION'
,p_message_text=>'Opposite Action'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527539753918170970)
,p_name=>'PD.TREE.PAGE_SEARCH'
,p_message_text=>'Page Search'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527539672014170970)
,p_name=>'PD.TREE.PAGE_TITLE'
,p_message_text=>'Page %0: %1'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527539553441170970)
,p_name=>'PD.TREE.POST_RENDERING'
,p_message_text=>'Post-Rendering'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527539483498170970)
,p_name=>'PD.TREE.PRE_RENDERING'
,p_message_text=>'Pre-Rendering'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527539889572170970)
,p_name=>'PD.TREE.REFERENCED_BY'
,p_message_text=>'Referenced by %0'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527538895932170968)
,p_name=>'PD.TREE.REGION_BUTTONS'
,p_message_text=>'Region Buttons'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527537310255170966)
,p_name=>'PD.TREE.RENAME'
,p_message_text=>'Rename...'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527538525323170968)
,p_name=>'PD.TREE.REPORT_COLUMNS'
,p_message_text=>'Columns'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527539101058170969)
,p_name=>'PD.TREE.ROW_SELECTOR'
,p_message_text=>'Row Selector'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1819824910361248)
,p_name=>'PD.TREE.SEARCH_SOURCES'
,p_message_text=>'Search Sources'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2703329261140545)
,p_name=>'PD.TREE.SFILTERS'
,p_message_text=>'Filters'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527538383837170968)
,p_name=>'PD.TREE.SUB_REGION'
,p_message_text=>'Sub Region'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527538482188170968)
,p_name=>'PD.TREE.SUB_REGIONS'
,p_message_text=>'Sub Regions'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(7206448885816529)
,p_name=>'PD.TREE.SYNCHRONIZE_API_PARAMS'
,p_message_text=>'Synchronize Parameters'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(715906558455048092)
,p_name=>'PD.TREE.SYNCHRONIZE_COLUMNS'
,p_message_text=>'Synchronize Columns'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1720533831286195)
,p_name=>'PD.TREE.SYNCHRONIZE_PAGE_ITEMS'
,p_message_text=>'Synchronize Page Items'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1524065287004920865)
,p_name=>'PD.TREE.TAB_SET'
,p_message_text=>'Tab Set'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1260474002527051621)
,p_name=>'PD.TREE.TEMPLATES'
,p_message_text=>'Templates'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527537740780170966)
,p_name=>'PD.TREE.TRUE'
,p_message_text=>'True'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527537944531170967)
,p_name=>'PD.TREE.TRUE_ACTION'
,p_message_text=>'TRUE Action'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1813250491396963)
,p_name=>'PD.TREE.UNCOMMENT'
,p_message_text=>'Uncomment'
,p_is_js_message=>true
,p_version_scn=>99456526
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527540047283170971)
,p_name=>'PD.TREE.UNDEFINED_EVENT'
,p_message_text=>'Not Specified'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(527539016193170969)
,p_name=>'PD.TREE.VIRTUAL_COLUMN'
,p_message_text=>'Virtual Column'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1847988916802187)
,p_name=>'PD.TREE.WF.ALERT_DUP_DEV_VERSION'
,p_message_text=>'There can be only one Version in Development. Please delete or update the following versions: %0'
,p_is_js_message=>true
,p_version_scn=>102582670
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537571622502409256)
,p_name=>'PD.TRY_AGAIN'
,p_message_text=>'Try Again'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537976312227933537)
,p_name=>'PD.UNDO'
,p_message_text=>'Undo %0'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537568086909390912)
,p_name=>'PD.UNLOCK'
,p_message_text=>'Unlock'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537567617629389094)
,p_name=>'PD.UNLOCK_PAGE'
,p_message_text=>'Unlock Page'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2402963796164004)
,p_name=>'PD.UNSUBSCRIBE'
,p_message_text=>'Unsubscribe'
,p_is_js_message=>true
,p_version_scn=>153119703
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(528332694370248963)
,p_name=>'PD.UNSUPPORTED'
,p_message_text=>'%0 [Unsupported]'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537572523831413304)
,p_name=>'PD.USER_INTERFACE'
,p_message_text=>'User Interface'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1853718935673551)
,p_name=>'PD.WF.ACTIVATE'
,p_message_text=>'Activate'
,p_is_js_message=>true
,p_version_scn=>38788392
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2663488513467780)
,p_name=>'PD.WF.ACTIVE'
,p_message_text=>'Active'
,p_is_js_message=>true
,p_version_scn=>38788392
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1854948970523591)
,p_name=>'PD.WF.ALERT_DELETE_VERSION'
,p_message_text=>'Ensure there''s no running instance of this Version.'
,p_is_js_message=>true
,p_version_scn=>37166020077079
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1854749831527375)
,p_name=>'PD.WF.ALERT_DELETE_WF_WITH_VERSION'
,p_message_text=>'This Workflow contains a Version with state Active/In Development. Are you sure you want to continue?'
,p_is_js_message=>true
,p_version_scn=>37166020076711
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1848135906792628)
,p_name=>'PD.WF.ALERT_NEW_VERSION'
,p_message_text=>'Do you want to create a new Version, or duplicate the currently Active one?'
,p_is_js_message=>true
,p_version_scn=>38788392
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4648068024388589)
,p_name=>'PD.WF.CONDITION_TYPE'
,p_message_text=>'Condition Type'
,p_is_js_message=>true
,p_version_scn=>102870845
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4649477543172254)
,p_name=>'PD.WF.CREATE'
,p_message_text=>'Create'
,p_is_js_message=>true
,p_version_scn=>102902144
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1854330013553426)
,p_name=>'PD.WF.CREATE_ACTIVITY_AFTER'
,p_message_text=>'Create Activity After'
,p_is_js_message=>true
,p_version_scn=>38788392
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1854157071598913)
,p_name=>'PD.WF.CREATE_ACTIVITY_BELOW'
,p_message_text=>'Create Activity Below'
,p_is_js_message=>true
,p_version_scn=>38788392
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1854576595543007)
,p_name=>'PD.WF.CREATE_CONNECTION'
,p_message_text=>'Create Connection'
,p_is_js_message=>true
,p_version_scn=>38788392
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1853974931646495)
,p_name=>'PD.WF.DEACTIVATE'
,p_message_text=>'Deactivate'
,p_is_js_message=>true
,p_version_scn=>38788392
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2663641095466189)
,p_name=>'PD.WF.DEV'
,p_message_text=>'Dev'
,p_is_js_message=>true
,p_version_scn=>38788392
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(205917098990287150)
,p_name=>'PD.WF.DIAGRAM.CHANGE_SELECTION_MODE'
,p_message_text=>'Change selection mode in diagram- Activity, Connection, or both'
,p_is_js_message=>true
,p_version_scn=>37166019868276
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(205917356832289314)
,p_name=>'PD.WF.DIAGRAM.DESELECT'
,p_message_text=>'Deselect Activity or Connection in diagram'
,p_is_js_message=>true
,p_version_scn=>37166019871041
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(205917550773290751)
,p_name=>'PD.WF.DIAGRAM.MOVE_CELL_DOWN'
,p_message_text=>'Move diagram''s Activity or Connection down'
,p_is_js_message=>true
,p_version_scn=>37166019871235
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(205917722651292501)
,p_name=>'PD.WF.DIAGRAM.MOVE_CELL_LEFT'
,p_message_text=>'Move diagram''s Activity or Connection to the left'
,p_is_js_message=>true
,p_version_scn=>37166019871547
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(205917917868294304)
,p_name=>'PD.WF.DIAGRAM.MOVE_CELL_RIGHT'
,p_message_text=>'Move diagram''s Activity or Connection to the right'
,p_is_js_message=>true
,p_version_scn=>37166019871598
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(205918128973295650)
,p_name=>'PD.WF.DIAGRAM.MOVE_CELL_UP'
,p_message_text=>'Move diagram''s Activity or Connection up'
,p_is_js_message=>true
,p_version_scn=>37166019871998
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3177267609161619)
,p_name=>'PD.WF.DIAGRAM.OPEN_MENU_ADD_TO_LINK'
,p_message_text=>'Open menu to insert Activities into the Connection'
,p_is_js_message=>true
,p_version_scn=>63347071
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(205918339992296840)
,p_name=>'PD.WF.DIAGRAM.OPEN_MENU_BOTTOM'
,p_message_text=>'Open bottom menu for selected Activity in diagram'
,p_is_js_message=>true
,p_version_scn=>37166019873960
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(205918563953298470)
,p_name=>'PD.WF.DIAGRAM.OPEN_MENU_LEFT'
,p_message_text=>'Open left menu for selected Activity in diagram'
,p_is_js_message=>true
,p_version_scn=>37166019878243
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(205918808914299758)
,p_name=>'PD.WF.DIAGRAM.OPEN_MENU_RIGHT'
,p_message_text=>'Open right menu for selected Activity in diagram'
,p_is_js_message=>true
,p_version_scn=>37166019883999
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3177088583196683)
,p_name=>'PD.WF.DIAGRAM.OPEN_MENU_TARGET'
,p_message_text=>'Open menu for target at the end of the Connection'
,p_is_js_message=>true
,p_version_scn=>63347401
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(205919064045301511)
,p_name=>'PD.WF.DIAGRAM.OPEN_MENU_TOP'
,p_message_text=>'Open top menu for selected Activity in diagram'
,p_is_js_message=>true
,p_version_scn=>37166019884676
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(205919201897302771)
,p_name=>'PD.WF.DIAGRAM.REMOVE_CELL'
,p_message_text=>'Remove selected Activity or Connection from diagram'
,p_is_js_message=>true
,p_version_scn=>37166019888157
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(205919556680322306)
,p_name=>'PD.WF.DIAGRAM.SCROLL_AREA_DOWN'
,p_message_text=>'Scroll diagram down'
,p_is_js_message=>true
,p_version_scn=>37166019992857
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(205919838376323824)
,p_name=>'PD.WF.DIAGRAM.SCROLL_AREA_LEFT'
,p_message_text=>'Scroll diagram to the left'
,p_is_js_message=>true
,p_version_scn=>37166019993455
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(205920037917326919)
,p_name=>'PD.WF.DIAGRAM.SCROLL_AREA_RIGHT'
,p_message_text=>'Scroll diagram to the right'
,p_is_js_message=>true
,p_version_scn=>37166019993514
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(205920260048328252)
,p_name=>'PD.WF.DIAGRAM.SCROLL_AREA_UP'
,p_message_text=>'Scroll diagram up'
,p_is_js_message=>true
,p_version_scn=>37166019994084
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(205920402498329514)
,p_name=>'PD.WF.DIAGRAM.SELECT_NEXT'
,p_message_text=>'Select next Activity or Connection in diagram'
,p_is_js_message=>true
,p_version_scn=>37166020035745
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(205922584822342398)
,p_name=>'PD.WF.DIAGRAM.SELECT_PREV'
,p_message_text=>'Select previous Activity or Connection in diagram'
,p_is_js_message=>true
,p_version_scn=>37166020037497
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(205922775831347053)
,p_name=>'PD.WF.DIAGRAM.SHOW_MENU'
,p_message_text=>'Show Activity or Connection menu in diagram'
,p_is_js_message=>true
,p_version_scn=>37166020037938
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(205923018684348886)
,p_name=>'PD.WF.DIAGRAM.ZOOM_IN'
,p_message_text=>'Zoom in diagram'
,p_is_js_message=>true
,p_version_scn=>37166020038479
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(205923255100354874)
,p_name=>'PD.WF.DIAGRAM.ZOOM_OUT'
,p_message_text=>'Zoom out diagram'
,p_is_js_message=>true
,p_version_scn=>37166020041828
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(205923408401356404)
,p_name=>'PD.WF.DIAGRAM.ZOOM_RESET'
,p_message_text=>'Reset zoom for diagram'
,p_is_js_message=>true
,p_version_scn=>37166020042730
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1837211889879063)
,p_name=>'PD.WF.ERROR.FIX_VALIDATION_ERROR'
,p_message_text=>'Validation Errors need to be fixed before this Workflow Version can be activated.'
,p_is_js_message=>true
,p_version_scn=>37166020079741
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1837086513886924)
,p_name=>'PD.WF.ERROR.MISSING_OWNER'
,p_message_text=>'Version must have at least one Owner to be activated.'
,p_is_js_message=>true
,p_version_scn=>38788392
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4647442968402447)
,p_name=>'PD.WF.FROM'
,p_message_text=>'From'
,p_is_js_message=>true
,p_version_scn=>102870977
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(205927838582422159)
,p_name=>'PD.WF.GO_TO_DIAGRAM'
,p_message_text=>'Go to Diagram Builder'
,p_is_js_message=>true
,p_version_scn=>37165943696022
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(205928079803423519)
,p_name=>'PD.WF.GO_TO_GALLERY'
,p_message_text=>'Go to Gallery'
,p_is_js_message=>true
,p_version_scn=>37165943696181
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(205928222005425112)
,p_name=>'PD.WF.GO_TO_PROPERTY_EDITOR'
,p_message_text=>'Go to Property Editor'
,p_is_js_message=>true
,p_version_scn=>37165943696279
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(205928464735426292)
,p_name=>'PD.WF.GO_TO_USED_SHARED_COMPONENTS'
,p_message_text=>'Go to Used Shared Components'
,p_is_js_message=>true
,p_version_scn=>37165943696437
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(205928664789427628)
,p_name=>'PD.WF.GO_TO_WORKFLOW_TREE'
,p_message_text=>'Go to Workflow Tree'
,p_is_js_message=>true
,p_version_scn=>37165943696660
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2308070613611682)
,p_name=>'PD.WF.INCOMING'
,p_message_text=>'Incoming'
,p_is_js_message=>true
,p_version_scn=>99818316
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2308264711610053)
,p_name=>'PD.WF.OUTGOING'
,p_message_text=>'Outgoing'
,p_is_js_message=>true
,p_version_scn=>99818337
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1837516610862655)
,p_name=>'PD.WF.QUESTION_ACTIVATE'
,p_message_text=>'If this workflow has an existing active version, it will be deactivated. Do you want to continue?'
,p_is_js_message=>true
,p_version_scn=>37166001615830
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1837769531851469)
,p_name=>'PD.WF.QUESTION_DEACTIVATE'
,p_message_text=>'Are you sure you want to deactivate this version?'
,p_is_js_message=>true
,p_version_scn=>102578005
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4649641512169807)
,p_name=>'PD.WF.REMOVE'
,p_message_text=>'Remove'
,p_is_js_message=>true
,p_version_scn=>102902178
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4647660754400844)
,p_name=>'PD.WF.TO'
,p_message_text=>'To'
,p_is_js_message=>true
,p_version_scn=>102870884
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2000821419502611)
,p_name=>'PD.WF.TREE.NAME_PDSHAREDCOMP'
,p_message_text=>'Used Shared Components'
,p_version_scn=>22825109
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1402100161884725)
,p_name=>'PD.WF.TREE.NAME_WORKFLOW'
,p_message_text=>'Workflow'
,p_version_scn=>21938432
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4650140700974381)
,p_name=>'PD.WF.TREE.WORKFLOWS'
,p_message_text=>'Workflows'
,p_is_js_message=>true
,p_version_scn=>102914217
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4649863661129630)
,p_name=>'PD.WF.UPDATE'
,p_message_text=>'Update'
,p_is_js_message=>true
,p_version_scn=>102905107
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2307859668617946)
,p_name=>'PD.WF.VARIABLES'
,p_message_text=>'Variables'
,p_is_js_message=>true
,p_version_scn=>99818185
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537662272729723687)
,p_name=>'PE.CODE_EDITOR'
,p_message_text=>'Code Editor'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537565465192277558)
,p_name=>'PE.COLLAPSE'
,p_message_text=>'Collapse %0'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1473568575657494210)
,p_name=>'PE.COLOR_PICKER'
,p_message_text=>'Color Picker: %0'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(534483814158614147)
,p_name=>'PE.EDIT_COMPONENT'
,p_message_text=>'Edit Component'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1509900016268857280)
,p_name=>'PE.ERROR_POSTFIX'
,p_message_text=>' (Error)'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537565620883278468)
,p_name=>'PE.EXPAND'
,p_message_text=>'Expand %0'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(610255774613370872)
,p_name=>'PE.FILTER'
,p_message_text=>'Filter'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(981108595457898203)
,p_name=>'PE.FILTER_NO_MATCH'
,p_message_text=>'No results found.'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(981108973841903075)
,p_name=>'PE.FILTER_NO_MATCH_COMMON'
,p_message_text=>'No results found. Try searching all properties by clicking the "Show All" button above.'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(350810077860801101)
,p_name=>'PE.FILTER_PROPERTIES'
,p_message_text=>'Filter Properties'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(534483295911612296)
,p_name=>'PE.INVALID'
,p_message_text=>'%0 (Invalid)'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(534482664001609140)
,p_name=>'PE.LIST_OF_VALUES'
,p_message_text=>'List of Values'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(534482297845606692)
,p_name=>'PE.NO'
,p_message_text=>'No'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(534483023282611297)
,p_name=>'PE.NO_COMMON_PROPERTIES'
,p_message_text=>'The selected components have no properties in common.'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(612246083695705237)
,p_name=>'PE.NO_COMPONENTS_SELECTED'
,p_message_text=>'No components currently selected'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(534484310614615647)
,p_name=>'PE.PICK'
,p_message_text=>'Pick %0'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(328222978969918943)
,p_name=>'PE.PIN_FILTER'
,p_message_text=>'Pin Filter'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(629293852695360861)
,p_name=>'PE.QUICK_PICK'
,p_message_text=>'Quick Pick'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(754510545732371331)
,p_name=>'PE.QUICK_PICK.CLEAR'
,p_message_text=>'Clear Selection'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1732856493796235)
,p_name=>'PE.QUICK_PICK_NOT_AVAILABLE'
,p_message_text=>'No Quick Pick is available'
,p_is_js_message=>true
,p_version_scn=>127298720
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537565803057279438)
,p_name=>'PE.REQUIRED'
,p_message_text=>'Required'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537573347187417263)
,p_name=>'PE.SEARCH'
,p_message_text=>'Search'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(534482490563607830)
,p_name=>'PE.SELECT'
,p_message_text=>'- Select -'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1509900495011861884)
,p_name=>'PE.VALUE_VARIES_POSTFIX'
,p_message_text=>' (Value Varies)'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(534483429148613211)
,p_name=>'PE.WARNING'
,p_message_text=>'Warning'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1509900256214859620)
,p_name=>'PE.WARNING_POSTFIX'
,p_message_text=>' (Warning)'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(537566081020280186)
,p_name=>'PE.YES'
,p_message_text=>'Yes'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2602716205865342)
,p_name=>'PWA.SHORTCUT.CROPPER.HELPTEXT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Drag your shortcut icon and use the zoom slider to reposition it within the frame.</p>',
'',
'<p>When focused on the shortcut icon cropper, the following keyboard shortcuts are available:</p>',
'<ul>',
'    <li>Left Arrow: Move image left*</li>',
'    <li>Up Arrow: Move image up*</li>',
'    <li>Right Arrow: Move image right*</li>',
'    <li>Down Arrow: Move image down*</li>',
'    <li>I: Zoom in</li>',
'    <li>O: Zoom out</li>',
'    <li>L: Rotate left</li>',
'    <li>R: Rotate right</li>',
'</ul>',
'',
'<p class="margin-top-md"><em>*Hold Shift to move faster</em></p>'))
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5901100369408293)
,p_name=>'PWA.SW.PREVIEW.HOOK.ENDS'
,p_message_text=>'"%0" hook ends'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(5900849889404346)
,p_name=>'PWA.SW.PREVIEW.HOOK.STARTS'
,p_message_text=>'"%0" hook starts'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(6313221010148611)
,p_name=>'REMOVE'
,p_message_text=>'Remove'
,p_version_scn=>37165889113675
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2270980705694256143)
,p_name=>'RESTORE'
,p_message_text=>'Restore'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2827051309721749)
,p_name=>'SUBSCRIPTION.ITEM_RENAME_NOT_POSSIBLE'
,p_message_text=>'Renaming the item %0 is not possible because an application computation is associated with this item and is subscribed from another application.'
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2667724421151956)
,p_name=>'WF.ACTION_SEL_NEXT_EL'
,p_message_text=>'Select next element'
,p_is_js_message=>true
,p_version_scn=>38788393
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2667919838142685)
,p_name=>'WF.ACTION_SEL_PREV_EL'
,p_message_text=>'Select previous element'
,p_is_js_message=>true
,p_version_scn=>102578166
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2668207079091098)
,p_name=>'WF.ACTION_SHOW_NAVIGATOR'
,p_message_text=>'Show Navigator'
,p_is_js_message=>true
,p_version_scn=>38788393
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(139965410624858376)
,p_name=>'WF.CREATE_ACTIVITY_VARIABLE'
,p_message_text=>'Create Activity Variable'
,p_is_js_message=>true
,p_version_scn=>37165882397443
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2666970646169887)
,p_name=>'WF.DEF_ROUTER_SETTING'
,p_message_text=>'Default Router Setting'
,p_is_js_message=>true
,p_version_scn=>38788393
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143539070025992589)
,p_name=>'WF.DIAGRAM_ARIA_DESC'
,p_message_text=>'The diagram builder is not accessible at this time. Please use the tree navigation on this page to manage your workflows.'
,p_version_scn=>37165892768385
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(143539206378994480)
,p_name=>'WF.DIAGRAM_ARIA_LABEL'
,p_message_text=>'Diagram Builder'
,p_version_scn=>37165892768608
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3650381157398638)
,p_name=>'WF.MOVE_ELEMENT_DOWN'
,p_message_text=>'Move Element Down'
,p_is_js_message=>true
,p_version_scn=>101363145
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3650576550395291)
,p_name=>'WF.MOVE_ELEMENT_LEFT'
,p_message_text=>'Move Element Left'
,p_is_js_message=>true
,p_version_scn=>101363283
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3650721149390569)
,p_name=>'WF.MOVE_ELEMENT_RIGHT'
,p_message_text=>'Move Element Right'
,p_is_js_message=>true
,p_version_scn=>101363366
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3650149986401099)
,p_name=>'WF.MOVE_ELEMENT_UP'
,p_message_text=>'Move Element Up'
,p_is_js_message=>true
,p_version_scn=>101363101
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2667131887166412)
,p_name=>'WF.NORMAL'
,p_message_text=>'Normal'
,p_is_js_message=>true
,p_version_scn=>38788393
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2667325696163342)
,p_name=>'WF.ORTHOGONAL'
,p_message_text=>'Orthogonal'
,p_is_js_message=>true
,p_version_scn=>38788393
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2669070483076356)
,p_name=>'WF.TO_BACK'
,p_message_text=>'To Back'
,p_is_js_message=>true
,p_version_scn=>38788393
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2668885032078616)
,p_name=>'WF.TO_FRONT'
,p_message_text=>'To Front'
,p_is_js_message=>true
,p_version_scn=>38788395
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2668469292089961)
,p_name=>'WF.ZOOM_IN'
,p_message_text=>'Zoom In'
,p_is_js_message=>true
,p_version_scn=>38788395
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(225364687334766342)
,p_name=>'WF.ZOOM_LEVEL'
,p_message_text=>'Zoom level {0}%'
,p_is_js_message=>true
,p_version_scn=>37165964171495
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2668686656079806)
,p_name=>'WF.ZOOM_OUT'
,p_message_text=>'Zoom Out'
,p_is_js_message=>true
,p_version_scn=>38788395
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(291767391313694836)
,p_name=>'WIZARD.IG.ACTIONS_MENU_LABEL'
,p_message_text=>'Actions'
,p_is_js_message=>true
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3168147572061020)
,p_name=>'WIZ_NAVIGATION_MENU_SUBSCRIBED'
,p_message_text=>'Updating the Navigation Menu is not possible because it is subscribed from another application. Please set <strong>Use Navigation</strong> to <strong>Off</strong>.'
,p_version_scn=>37165259336617
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3652275029660007)
,p_name=>'WWV_FLOW_APPROVAL_DEV.NO_MATCHING_TASK_DEF_FOUND'
,p_message_text=>'Application %1 does not contain a task definition with static ID <strong>%0<strong>. Please create or copy the task definition first.'
,p_version_scn=>1269428624
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2477598240850765)
,p_name=>'WWV_FLOW_COPY_METADATA.DUPLICATE_APP_ITEM'
,p_message_text=>'Application %0 contains an application item with the same name <strong>%1</strong>.'
,p_version_scn=>12490199
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2024832948208271)
,p_name=>'WWV_FLOW_COPY_METADATA.DUPLICATE_APP_PROCESS'
,p_message_text=>'Application %0 contains an application process with the same name <strong>%1</strong>.'
,p_version_scn=>12490228
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4235977008763065)
,p_name=>'WWV_FLOW_COPY_METADATA.DUPLICATE_APP_SETTING'
,p_message_text=>'Application %0 contains an application setting with the same name <strong>%1</strong>.'
,p_version_scn=>12490305
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8174872028162980)
,p_name=>'WWV_FLOW_COPY_METADATA.DUPLICATE_AUTHENTICATION'
,p_message_text=>'Application %0 contains an authentication scheme with the same name <strong>%1</strong>.'
,p_version_scn=>13366073
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3090625400172257)
,p_name=>'WWV_FLOW_COPY_METADATA.DUPLICATE_AUTHORIZATION'
,p_message_text=>'Application %0 contains an authorization scheme with the same name <strong>%1</strong>.'
,p_version_scn=>13365934
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3074260210314705)
,p_name=>'WWV_FLOW_COPY_METADATA.DUPLICATE_COMPONENT_GROUP'
,p_message_text=>'Application %0 contains a component group with the same name <strong>%1</strong>.'
,p_version_scn=>12493752
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8411400036803823)
,p_name=>'WWV_FLOW_COPY_METADATA.DUPLICATE_EMAIL_TEMPLATE'
,p_message_text=>'Application %0 contains an email template <strong>%1</strong> with the same static identifier.'
,p_version_scn=>13392405
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2024501111201770)
,p_name=>'WWV_FLOW_COPY_METADATA.DUPLICATE_LIST'
,p_message_text=>'Application %0 contains a list with the same name <strong>%1</strong>.'
,p_version_scn=>12675562
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3091648247252974)
,p_name=>'WWV_FLOW_COPY_METADATA.DUPLICATE_LOV'
,p_message_text=>'Application %0 contains a list of values with the same name <strong>%1</strong>.'
,p_version_scn=>12679512
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2001029570423570)
,p_name=>'WWV_FLOW_COPY_METADATA.DUPLICATE_MAP_BACKGROUND'
,p_message_text=>'Application %0 contains a map background with the same name <strong>%1</strong>.'
,p_version_scn=>12493304
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2477182906846186)
,p_name=>'WWV_FLOW_COPY_METADATA.DUPLICATE_PATCH'
,p_message_text=>'Application %0 contains a build option with the same name <strong>%1</strong>.'
,p_version_scn=>12490336
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(8410288044786863)
,p_name=>'WWV_FLOW_COPY_METADATA.DUPLICATE_REPORT_LAYOUT'
,p_message_text=>'Application %0 contains a report layout with the same name <strong>%1</strong>.'
,p_version_scn=>12493233
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4898206185745593)
,p_name=>'WWV_FLOW_COPY_METADATA.DUPLICATE_SHORTCUT'
,p_message_text=>'Application %0 contains a shortcut with the same name <strong>%1</strong>.'
,p_version_scn=>12493382
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4614375885248066)
,p_name=>'WWV_FLOW_COPY_METADATA.DUPLICATE_TEXT_MESSAGE'
,p_message_text=>'Application %0 contains a text message with the same name <strong>%1</strong> and language.'
,p_version_scn=>12684776
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3766495223180101)
,p_name=>'WWV_FLOW_COPY_METADATA.DUPLICATE_USER_GROUP'
,p_message_text=>'Application %0 contains a role with the same name <strong>%1</strong> or static identifier.'
,p_version_scn=>12490060
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(4818910860858344)
,p_name=>'WWV_FLOW_COPY_METADATA.INVALID_ITEM_NAME'
,p_message_text=>'Subscription failed. This computation is associated with page item %0, which does not exist in the application.'
,p_version_scn=>37165770887571
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1409026420652622)
,p_name=>'WWV_FLOW_COPY_PAGE.MULTIPLE_TEMPLATES_FOUND'
,p_message_text=>'Multiple matching templates found for <strong>%0</strong> in the application %1.'
,p_version_scn=>30442597
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1408861376639253)
,p_name=>'WWV_FLOW_COPY_PAGE.NO_MATCHING_TEMPLATE_FOUND'
,p_message_text=>'No matching template found for <strong>%0</strong> in the application %1.'
,p_version_scn=>30442454
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(1840700239758906)
,p_name=>'WWV_FLOW_DATA_LOADER_DEV.DUPLICATE_DATA_LOAD'
,p_message_text=>'Application %0 contains a data load definition with the same name <strong>%1</strong> or static identifier.'
,p_version_scn=>18431679
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(226423172893714270)
,p_name=>'WWV_FLOW_EXEC.INVALID_LOV_SPECIFICATION'
,p_message_text=>'Invalid List Of Value specification for column %s. Must be a valid LOV returning 2 columns.'
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3092330655465791)
,p_name=>'WWV_FLOW_PLUGIN_DEV.DUPLICATE_PLUGIN'
,p_message_text=>'Application %0 contains a plug-in with the same name <strong>%1</strong> and type.'
,p_version_scn=>12684853
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2011556536326312)
,p_name=>'WWV_FLOW_PROCESS_BACKGROUND.EXECUTIONS_0'
,p_message_text=>'<strong>No process execution</strong> is running right now (%0).'
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2011725223327372)
,p_name=>'WWV_FLOW_PROCESS_BACKGROUND.EXECUTIONS_1'
,p_message_text=>'<strong>One process execution</strong> is running right now (%0).'
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2011910482328261)
,p_name=>'WWV_FLOW_PROCESS_BACKGROUND.EXECUTIONS_N'
,p_message_text=>'<strong>%0 process executions</strong> are running right now (%1).'
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3097884233859678)
,p_name=>'WWV_FLOW_SEARCH_DEV.DUPLICATE_SEARCH_CONFIG'
,p_message_text=>'Application %0 contains a search configuration with the same static identifier <strong>%1</strong>.'
,p_version_scn=>12699611
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(97567553264925818)
,p_name=>'WWV_FLOW_WEB_SRC_DEV.CHECK_PROXY_APP_HINT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'%0',
'',
'Used application proxy server:',
'%1'))
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(97567730107927013)
,p_name=>'WWV_FLOW_WEB_SRC_DEV.CHECK_PROXY_INST_HINT'
,p_message_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'%0',
'',
'Instance proxy server was used. Please contact the instance administrator for further information.'))
,p_version_scn=>37165770887573
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(2189192790981755)
,p_name=>'WWV_FLOW_WEB_SRC_DEV.DUPLICATE_WEB_SRC'
,p_message_text=>'Application %0 contains a REST data source with the same name <strong>%1</strong> or static identifier.'
,p_version_scn=>18431400
);
wwv_flow_imp_shared.create_message(
 p_id=>wwv_flow_imp.id(3652422614657575)
,p_name=>'WWV_FLOW_WORKFLOW_DEV.NO_MATCHING_WORKFLOW_FOUND'
,p_message_text=>'Application %1 does not contain a workflow with static ID <strong>%0<strong>. Please create or copy the workflow first.'
,p_version_scn=>1269428671
);
end;
/
prompt --application/shared_components/globalization/dyntranslations
begin
null;
end;
/
prompt --application/shared_components/user_interface/shortcuts/ok_to_get_next_prev_pk_value
begin
wwv_flow_imp_shared.create_shortcut(
 p_id=>wwv_flow_imp.id(57515217372887724)
,p_shortcut_name=>'OK_TO_GET_NEXT_PREV_PK_VALUE'
,p_shortcut_type=>'TEXT_ESCAPE_JS'
,p_version_scn=>72475483
,p_shortcut=>'Are you sure you want to leave this page without saving?'
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/delete_confirm_msg
begin
wwv_flow_imp_shared.create_shortcut(
 p_id=>wwv_flow_imp.id(59030208829181524)
,p_shortcut_name=>'DELETE_CONFIRM_MSG'
,p_shortcut_type=>'TEXT_ESCAPE_JS'
,p_version_scn=>72475485
,p_shortcut=>'Would you like to perform this delete action?'
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/page_template_popup
begin
wwv_flow_imp_shared.create_shortcut(
 p_id=>wwv_flow_imp.id(64022328345714803)
,p_shortcut_name=>'PAGE_TEMPLATE_POPUP'
,p_shortcut_type=>'HTML_TEXT'
,p_version_scn=>72475485
,p_shortcut=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="javascript:callPageTemplatePopup(document.forms[0].#CURRENT_FORM_ELEMENT#, ''&FLOW_SESSION.'', &FB_FLOW_ID., &FB_FLOW_PAGE_ID.);"  class="a-Button a-Button--popupLOV">',
'  <span class="a-Icon icon-popup-lov">',
'    <span class="visuallyhidden">  ',
'      Find slot in page template',
'    </span>',
'  </span>',
'</a>',
''))
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/breadcrumb_parent
begin
wwv_flow_imp_shared.create_shortcut(
 p_id=>wwv_flow_imp.id(115510732068279066)
,p_shortcut_name=>'BREADCRUMB_PARENT'
,p_shortcut_type=>'FUNCTION_BODY'
,p_shortcut_language=>'PLSQL'
,p_version_scn=>72475485
,p_shortcut=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    x   varchar2(32767) := null;',
'begin',
'    x:=x||''<span class="a-Form-quickPicks">''||chr(10);',
'    x:=x||''<a href="javascript:setValue(''''#CURRENT_ITEM_NAME#'''',''''''||wwv_flow_lang.system_message(''NO_PARENT'')||'''''');setValue(''''#CURRENT_ITEM_NAME#_ID'''',''''0'''');" class="a-Form-quickPicks-link">[''||wwv_flow_lang.system_message(''NO_PARENT'')||'']</a>''||c'
||'hr(10);',
'    x:=x||''</span>''||chr(10);',
'    return x;',
'end; '))
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/jquery_and_version
begin
wwv_flow_imp_shared.create_shortcut(
 p_id=>wwv_flow_imp.id(427587403475368438)
,p_shortcut_name=>'JQUERY_AND_VERSION'
,p_shortcut_type=>'HTML_TEXT'
,p_version_scn=>72475485
,p_shortcut=>'jQuery 1.7.1'
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/no_plugins_installed
begin
wwv_flow_imp_shared.create_shortcut(
 p_id=>wwv_flow_imp.id(889405628525700213)
,p_shortcut_name=>'NO_PLUGINS_INSTALLED'
,p_shortcut_type=>'HTML_TEXT'
,p_version_scn=>72475485
,p_shortcut=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p></p>',
'<p>',
'<strong>There are no plug-ins installed.</strong>',
'</p>',
'<p>',
'A plug-in is an extension to the built-in types of &PRODUCT_NAME.. The following types are extensible with plug-ins:',
'<ul>',
'  <li>Items</li>',
'  <li>Regions</li>',
'  <li>Dynamic Actions</li>',
'  <li>Page Processes</li>',
'  <li>Authentication Schemes</li>',
'  <li>Authorization Schemes</li>',
'</ul>',
'</p>',
'<p>',
'Plug-ins can be downloaded, imported and created in <strong>Shared Components</strong> and then used in your application.',
'</p>'))
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/list_image_lov_title
begin
wwv_flow_imp_shared.create_shortcut(
 p_id=>wwv_flow_imp.id(1119263810878461105)
,p_shortcut_name=>'LIST_IMAGE_LOV_TITLE'
,p_shortcut_type=>'FUNCTION_BODY'
,p_shortcut_language=>'PLSQL'
,p_version_scn=>72475485
,p_shortcut=>'return wwv_flow_lang.system_message(''ITEM_NAME.POPUP_LIST_OF_VALUES'')||'': ''||wwv_flow_lang.system_message(''IMAGE'');'
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/chart_degrees
begin
wwv_flow_imp_shared.create_shortcut(
 p_id=>wwv_flow_imp.id(1142979828869056091)
,p_shortcut_name=>'CHART_DEGREES'
,p_shortcut_type=>'FUNCTION_BODY'
,p_shortcut_language=>'PLSQL'
,p_version_scn=>72475485
,p_shortcut=>'return wwv_flow_lang.system_message(''CHART_DEGREES'');'
);
end;
/
prompt --application/shared_components/user_interface/shortcuts/list_icon_lov_title
begin
wwv_flow_imp_shared.create_shortcut(
 p_id=>wwv_flow_imp.id(1846485616473772275)
,p_shortcut_name=>'LIST_ICON_LOV_TITLE'
,p_shortcut_type=>'FUNCTION_BODY'
,p_shortcut_language=>'PLSQL'
,p_version_scn=>72475485
,p_shortcut=>'return wwv_flow_lang.system_message(''ITEM_NAME.POPUP_LIST_OF_VALUES'')||'': ''||wwv_flow_lang.system_message(''UTR.LESS.ICON'');'
);
end;
/
prompt --application/shared_components/security/authentications/internal_authentication
begin
wwv_flow_imp_shared.create_authentication(
 p_id=>wwv_flow_imp.id(532421019614096524)
,p_name=>'Internal Authentication'
,p_scheme_type=>'PLUGIN_COM.ORACLE.APEX.AUTHN.INTERNAL.APEX'
,p_invalid_session_type=>'LOGIN'
,p_logout_url=>'f?p=4550:8:&SESSION.'
,p_cookie_name=>'ORA_WWV_USER_&INSTANCE_ID.'
,p_use_secure_cookie_yn=>'N'
,p_ras_mode=>0
,p_reference_id=>540226219724705040
);
end;
/
prompt --application/shared_components/plugins/region_type/com_oracle_apex_ai_hook
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1425806470660572)
,p_plugin_type=>'REGION TYPE'
,p_name=>'COM.ORACLE.APEX.AI_HOOK'
,p_display_name=>'AI Hook'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','COM.ORACLE.APEX.AI_HOOK'),'')
,p_plsql_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'procedure render (',
'    p_plugin in            apex_plugin.t_plugin,',
'    p_region in            apex_plugin.t_region,',
'    p_param  in            apex_plugin.t_region_render_param,',
'    p_result in out nocopy apex_plugin.t_region_render_result )',
'as',
'    l_enabled   boolean         := wwv_flow_ai.is_enabled;',
'    l_ajax_id   varchar2(1000)  := wwv_flow_plugin.get_ajax_identifier;',
'    l_ai_key    varchar2(1000)  := p_region.attributes.get_varchar2( ''ai_key'' );',
'begin',
'    wwv_flow_javascript.add_onload_code (',
'        p_code =>',
'            ''apex.aiHook = {'' || wwv_flow.LF ||',
'            ''    aiEnabled: '' || case when l_enabled then ''true'' else ''false'' end || '','' || wwv_flow.LF ||',
'            ''    ajaxId: {}''  || wwv_flow.LF ||',
'            ''};'',',
'        p_key  => ''ai-hook'' );',
'',
'    if l_enabled then',
'        wwv_flow_javascript.add_onload_code (',
'            p_code => ''apex.aiHook.ajaxId[ '' || wwv_flow_escape.js_literal( l_ai_key ) || '' ] = '' ||',
'                wwv_flow_escape.js_literal( l_ajax_id ) || '';'' );',
'    end if;',
'end render;'))
,p_api_version=>3
,p_render_function=>'render'
,p_standard_attributes=>'AI_ENABLED_ALWAYS:AI_SYSTEM_PROMPT'
,p_substitute_attributes=>true
,p_reference_id=>1423361590814899
,p_version_scn=>128904175
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2062337861567713)
,p_plugin_id=>wwv_flow_imp.id(1425806470660572)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_static_id=>'ai_key'
,p_prompt=>'Key'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_help_text=>'Provide a key, or an id, that will be used to get a handle on the plug-in''s AJAX ID as such: <code>apex.aiHook.ajaxId[ "{key here}" ]</code>.'
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_code_language
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1807557483699566)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.CODE_LANGUAGE'
,p_display_name=>'Code Language'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.CODE_LANGUAGE'),'')
,p_api_version=>2
,p_render_function=>'wwv_flow_f4000_plugins.render_code_language'
,p_validation_function=>'wwv_flow_f4000_plugins.validate_code_language'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:SOURCE'
,p_substitute_attributes=>true
,p_reference_id=>1801904462214602
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1616586820081253)
,p_plugin_id=>wwv_flow_imp.id(1807557483699566)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Default Language'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'Automatically Picked'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1616932854081253)
,p_plugin_attribute_id=>wwv_flow_imp.id(1616586820081253)
,p_display_sequence=>10
,p_display_value=>'SQL'
,p_return_value=>'SQL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1617453369081254)
,p_plugin_attribute_id=>wwv_flow_imp.id(1616586820081253)
,p_display_sequence=>20
,p_display_value=>'PL/SQL'
,p_return_value=>'PLSQL'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1617916473081254)
,p_plugin_id=>wwv_flow_imp.id(1807557483699566)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Type Page Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1618399660081255)
,p_plugin_id=>wwv_flow_imp.id(1807557483699566)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Hide SQL'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1617916473081254)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NULL'
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_plugin_dynamic_attribute
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(6480508142096556)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_display_name=>'Plug-In Dynamic Attribute'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_plugin_attribute'
,p_ajax_function=>'wwv_flow_f4000_plugins.ajax_plugin_attribute'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:SOURCE'
,p_substitute_attributes=>true
,p_version_scn=>72475490
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authorization_type/com_oracle_apex_developer_authorization
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(12452111455491580)
,p_plugin_type=>'AUTHORIZATION TYPE'
,p_name=>'COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'
,p_display_name=>'Developer Authorization'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHORIZATION TYPE','COM.ORACLE.APEX.DEVELOPER_AUTHORIZATION'),'')
,p_plsql_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function is_authorized (',
'    p_authorization in wwv_flow_plugin_api.t_authorization,',
'    p_plugin        in wwv_flow_plugin_api.t_plugin )',
'    return wwv_flow_plugin_api.t_authorization_exec_result',
'is',
'    l_result               wwv_flow_plugin_api.t_authorization_exec_result;',
'begin',
'    l_result.is_authorized := wwv_flow_authorization.is_authorized_developer ( ',
'                                  p_developer_authorization => p_authorization.attribute_01 );',
'    return l_result;',
'exception',
'    when no_data_found then',
'        l_result.is_authorized := false;',
'        return l_result;',
'end;'))
,p_api_version=>1
,p_execution_function=>'is_authorized'
,p_substitute_attributes=>true
,p_reference_id=>12457518297512494
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1665836202757893)
,p_plugin_id=>wwv_flow_imp.id(12452111455491580)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Developer Role'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1666755364757895)
,p_plugin_attribute_id=>wwv_flow_imp.id(1665836202757893)
,p_display_sequence=>10
,p_display_value=>'ADMIN: Ability to manage flow developer privileges'
,p_return_value=>'ADMIN'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1667280357757895)
,p_plugin_attribute_id=>wwv_flow_imp.id(1665836202757893)
,p_display_sequence=>20
,p_display_value=>'EDIT: Ability change all attributes of specified flow(s)'
,p_return_value=>'EDIT'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1667761909757895)
,p_plugin_attribute_id=>wwv_flow_imp.id(1665836202757893)
,p_display_sequence=>30
,p_display_value=>'HELP: Ability edit help page for a given company'
,p_return_value=>'HELP'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1668215573757895)
,p_plugin_attribute_id=>wwv_flow_imp.id(1665836202757893)
,p_display_sequence=>40
,p_display_value=>'BROWSE: Access to Oracle data dictionary browser'
,p_return_value=>'BROWSE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1668777805757895)
,p_plugin_attribute_id=>wwv_flow_imp.id(1665836202757893)
,p_display_sequence=>50
,p_display_value=>'CREATE: Ability to create new flows'
,p_return_value=>'CREATE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1669286129757896)
,p_plugin_attribute_id=>wwv_flow_imp.id(1665836202757893)
,p_display_sequence=>60
,p_display_value=>'MONITOR: Ability to monitor flow activity'
,p_return_value=>'MONITOR'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1669774859757896)
,p_plugin_attribute_id=>wwv_flow_imp.id(1665836202757893)
,p_display_sequence=>70
,p_display_value=>'DB_MONITOR: Ability to monitor Oracle database attributes'
,p_return_value=>'DB_MONITOR'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1670231842757897)
,p_plugin_attribute_id=>wwv_flow_imp.id(1665836202757893)
,p_display_sequence=>80
,p_display_value=>'SQL: Ability to issues SQL statements'
,p_return_value=>'SQL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1670723407757897)
,p_plugin_attribute_id=>wwv_flow_imp.id(1665836202757893)
,p_display_sequence=>90
,p_display_value=>'USER_MANAGER: Manage user accounts for cookie based authentication'
,p_return_value=>'USER_MANAGER'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1671270131757897)
,p_plugin_attribute_id=>wwv_flow_imp.id(1665836202757893)
,p_display_sequence=>100
,p_display_value=>'DATA_LOADER: Data Workshop'
,p_return_value=>'DATA_LOADER'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1671775347757898)
,p_plugin_attribute_id=>wwv_flow_imp.id(1665836202757893)
,p_display_sequence=>110
,p_display_value=>'RESTFUL: Ability to enable RESTful Services'
,p_return_value=>'RESTFUL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1672280901757898)
,p_plugin_attribute_id=>wwv_flow_imp.id(1665836202757893)
,p_display_sequence=>130
,p_display_value=>'EDIT or SQL'
,p_return_value=>'EDIT:SQL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1666205482757894)
,p_plugin_attribute_id=>wwv_flow_imp.id(1665836202757893)
,p_display_sequence=>140
,p_display_value=>'DATA_GENERATOR: Ability to access Data Generator in SQL Workshop'
,p_return_value=>'DATA_GENERATOR'
);
end;
/
prompt --application/shared_components/plugins/region_type/com_oracle_apex_subscriptions
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(33337730749616691)
,p_plugin_type=>'REGION TYPE'
,p_name=>'COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_display_name=>'Subscriptions'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','COM.ORACLE.APEX.SUBSCRIPTIONS'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_subscriptions'
,p_substitute_attributes=>true
,p_version_scn=>1088654318
,p_subscribe_plugin_settings=>true
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(33338020837623261)
,p_plugin_id=>wwv_flow_imp.id(33337730749616691)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_static_id=>'attribute_01'
,p_prompt=>'Table Name'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>30
,p_max_length=>30
,p_is_translatable=>false
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(33338531226626280)
,p_plugin_id=>wwv_flow_imp.id(33337730749616691)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_static_id=>'attribute_02'
,p_prompt=>'Name Column'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'NAME'
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(33339313695630694)
,p_plugin_id=>wwv_flow_imp.id(33337730749616691)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_static_id=>'attribute_03'
,p_prompt=>'PK Item Name'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'Pxxx_ID'
,p_display_length=>30
,p_max_length=>30
,p_is_translatable=>false
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(33340003437637190)
,p_plugin_id=>wwv_flow_imp.id(33337730749616691)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_static_id=>'attribute_04'
,p_prompt=>'Reference Item Name'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'Pxxx_REFERENCE_ID'
,p_display_length=>30
,p_max_length=>30
,p_is_translatable=>false
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(33340415904640767)
,p_plugin_id=>wwv_flow_imp.id(33337730749616691)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_static_id=>'attribute_05'
,p_prompt=>'System Message Prefix'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'SUBSCRIBE_XXX'
,p_display_length=>30
,p_max_length=>30
,p_is_translatable=>false
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(4004865245456024)
,p_plugin_id=>wwv_flow_imp.id(33337730749616691)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_static_id=>'attribute_06'
,p_prompt=>'Version SCN Column'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_default_value=>'VERSION_SCN'
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_text_case=>'UPPER'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_saml
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(44505855544251869)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.SAML'
,p_display_name=>'INTERNAL SAML'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.SAML'),'')
,p_api_version=>2
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_saml'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_saml'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_saml'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_saml'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_saml'
,p_substitute_attributes=>true
,p_reference_id=>77082398185639908
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_searchbox
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(73267156331555162)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.SEARCHBOX'
,p_display_name=>'Search Box'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.SEARCHBOX'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_searchbox'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT'
,p_substitute_attributes=>true
,p_reference_id=>42609120788689442
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1513164197626229978)
,p_plugin_id=>wwv_flow_imp.id(73267156331555162)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Redirect URL'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_default_value=>'f?p=&APP_ID.:<target page>:&SESSION.::&DEBUG.::<target item>:'
,p_display_length=>80
,p_max_length=>4000
,p_is_translatable=>false
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1513164528396229983)
,p_plugin_id=>wwv_flow_imp.id(73267156331555162)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Search Text'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'Search'
,p_is_translatable=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<br />',
''))
);
end;
/
prompt --application/shared_components/plugins/template_component/theme_3_actions
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(107220018856601424)
,p_plugin_type=>'TEMPLATE COMPONENT'
,p_theme_id=>nvl(wwv_flow_application_install.get_theme_id, '3')
,p_name=>'THEME_3$ACTIONS'
,p_display_name=>'Actions'
,p_supported_component_types=>'PARTIAL'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('TEMPLATE COMPONENT','THEME_3$ACTIONS'),'')
,p_partial_template=>'{IF ACTIONS/}<span class="b-InlineActions #STYLE#{if ACTIONS_WRAP/} b-InlineActions--wrap{endif/}">#ACTIONS#</span>{endif/}'
,p_default_escape_mode=>'HTML'
,p_translate_this_template=>false
,p_api_version=>1
,p_standard_attributes=>'REGION_TEMPLATE'
,p_substitute_attributes=>true
,p_reference_id=>107214662098533059
,p_version_scn=>75201737
,p_subscribe_plugin_settings=>true
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(20200541339086118)
,p_plugin_id=>wwv_flow_imp.id(107220018856601424)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>20
,p_static_id=>'ACTIONS_WRAP'
,p_prompt=>'Wrap Actions'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_escape_mode=>'ATTR'
,p_is_translatable=>false
,p_help_text=>'This will enable action buttons to wrap when a column or container is too thin for the contents.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(20201012581086117)
,p_plugin_id=>wwv_flow_imp.id(107220018856601424)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>10
,p_static_id=>'STYLE'
,p_prompt=>'Style'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_escape_mode=>'ATTR'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'Default'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(20201535917086117)
,p_plugin_attribute_id=>wwv_flow_imp.id(20201012581086117)
,p_display_sequence=>10
,p_display_value=>'Simple'
,p_return_value=>'b-InlineActions--simple'
);
wwv_flow_imp_shared.create_plugin_act_template(
 p_id=>wwv_flow_imp.id(214438625365151034)
,p_plugin_id=>wwv_flow_imp.id(107220018856601424)
,p_name=>'Button'
,p_type=>'BUTTON'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{with/}',
'LINK_URL:=#LINK_URL#',
'LINK_ATTR:=#LINK_ATTR#',
'LABEL:=#LABEL#',
'ICON_CLASSES:=#ICON_CLASSES#',
'CSS_CLASSES:=#CSS_CLASSES#',
'IS_HOT:=#IS_HOT#',
'IS_ICON_ONLY:=#IS_ICON_ONLY#',
'IS_DISABLED:=#IS_DISABLED#',
'{apply THEME$BUTTON/}'))
);
wwv_flow_imp_shared.create_plugin_act_template(
 p_id=>wwv_flow_imp.id(214439034740152230)
,p_plugin_id=>wwv_flow_imp.id(107220018856601424)
,p_name=>'Menu'
,p_type=>'MENU'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{with/}',
'MENU_ID:=#MENU_ID#',
'LABEL:=#LABEL#',
'ICON_CLASSES:=#ICON_CLASSES#',
'CSS_CLASSES:=#CSS_CLASSES#',
'IS_HOT:=#IS_HOT#',
'IS_DISABLED:=#IS_DISABLED#',
'IS_ICON_ONLY:=#IS_ICON_ONLY#',
'{apply THEME$BUTTON/}',
'#MENU#'))
);
wwv_flow_imp_shared.create_plugin_act_template(
 p_id=>wwv_flow_imp.id(583874857767349098)
,p_plugin_id=>wwv_flow_imp.id(107220018856601424)
,p_name=>'Button (No Link)'
,p_type=>'BUTTON'
,p_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button type="button" {if IS_DISABLED/} disabled{endif/} data-link="#LINK_URL#" #LINK_ATTR# class="b-Button{if IS_HOT/} b-Button--hot{endif/}{if IS_ICON_ONLY/} b-Button--noLabel b-Button--icon{else/}{if ICON_CLASSES/} b-Button--iconText{endif/}{endif'
||'/} #CSS_CLASSES#" title="#LABEL!STRIPHTML#">',
'  <span class="b-Button-label">',
'    {if ?ICON_CLASSES/}<span class="b-Button-icon a-Icon #ICON_CLASSES#" aria-hidden="true"></span>{endif/}',
'    <span class="b-Button-text">#LABEL#</span>',
'  </span>',
'</button>'))
,p_help_text=>'This will change the anchor to a button tag, and replace the href with data-link. For more advanced use cases that rely on javascript to take action.'
);
wwv_flow_imp_shared.create_plugin_act_position(
 p_id=>wwv_flow_imp.id(214437533860142316)
,p_plugin_id=>wwv_flow_imp.id(107220018856601424)
,p_name=>'ACTIONS'
,p_static_id=>'ACTIONS'
,p_display_sequence=>10
,p_is_quick_pick=>true
,p_type=>'TEMPLATE'
);
end;
/
prompt --application/shared_components/plugins/template_component/theme_3_button
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(107222116146601427)
,p_plugin_type=>'TEMPLATE COMPONENT'
,p_theme_id=>nvl(wwv_flow_application_install.get_theme_id, '3')
,p_name=>'THEME_3$BUTTON'
,p_display_name=>'Button'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('TEMPLATE COMPONENT','THEME_3$BUTTON'),'')
,p_partial_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{if MENU_ID/}<button type="button" data-menu="#MENU_ID#"{else/}{if IS_DISABLED/}<button type="button" disabled{else/}<a href="#LINK_URL#" #LINK_ATTR#{endif/}{endif/} class="b-Button{if IS_HOT/} b-Button--hot{endif/}{if IS_ICON_ONLY/} b-Button--noLabe'
||'l b-Button--icon{else/}{if ICON_CLASSES/} b-Button--iconText{endif/}{endif/} #CSS_CLASSES#" title="#LABEL!STRIPHTML#">',
'  <span class="b-Button-label">',
'    {if ?ICON_CLASSES/}<span class="b-Button-icon a-Icon #ICON_CLASSES#" aria-hidden="true"></span>{endif/}',
'    <span class="b-Button-text">#LABEL#</span>',
'  </span>',
'{if MENU_ID/}</button>{else/}{if IS_DISABLED/}</button>{else/}</a>{endif/}{endif/}',
''))
,p_default_escape_mode=>'HTML'
,p_translate_this_template=>false
,p_api_version=>1
,p_standard_attributes=>'REGION_TEMPLATE'
,p_substitute_attributes=>true
,p_reference_id=>107217693728544487
,p_version_scn=>76333852
,p_subscribe_plugin_settings=>true
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(30742272333305981)
,p_plugin_id=>wwv_flow_imp.id(107222116146601427)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_static_id=>'LABEL'
,p_prompt=>'Label'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_escape_mode=>'RAW'
,p_is_translatable=>true
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(30742773396305981)
,p_plugin_id=>wwv_flow_imp.id(107222116146601427)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_static_id=>'LINK_URL'
,p_prompt=>'Link URL'
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_escape_mode=>'ATTR'
,p_is_translatable=>false
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(30743210948305981)
,p_plugin_id=>wwv_flow_imp.id(107222116146601427)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_static_id=>'LINK_ATTR'
,p_prompt=>'Link Attribute'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_escape_mode=>'RAW'
,p_is_translatable=>false
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(30743713900305981)
,p_plugin_id=>wwv_flow_imp.id(107222116146601427)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_static_id=>'ICON_CLASSES'
,p_prompt=>'Icon Classes'
,p_attribute_type=>'ICON'
,p_is_required=>false
,p_escape_mode=>'ATTR'
,p_is_translatable=>false
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(30744277897305980)
,p_plugin_id=>wwv_flow_imp.id(107222116146601427)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_static_id=>'CSS_CLASSES'
,p_prompt=>'CSS Classes'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_escape_mode=>'ATTR'
,p_is_translatable=>false
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(30744711912305979)
,p_plugin_id=>wwv_flow_imp.id(107222116146601427)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_static_id=>'IS_DISABLED'
,p_prompt=>'Is Disabled'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_escape_mode=>'HTML'
,p_is_translatable=>false
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(30745245371305979)
,p_plugin_id=>wwv_flow_imp.id(107222116146601427)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_static_id=>'IS_HOT'
,p_prompt=>'Is Hot'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_escape_mode=>'HTML'
,p_is_translatable=>false
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(30745773596305979)
,p_plugin_id=>wwv_flow_imp.id(107222116146601427)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_static_id=>'IS_ICON_ONLY'
,p_prompt=>'Is Icon Only'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_escape_mode=>'HTML'
,p_is_translatable=>false
);
end;
/
prompt --application/shared_components/plugins/template_component/theme_3_avatar
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(107642902371278122)
,p_plugin_type=>'TEMPLATE COMPONENT'
,p_theme_id=>nvl(wwv_flow_application_install.get_theme_id, '3')
,p_name=>'THEME_3$AVATAR'
,p_display_name=>'Avatar'
,p_supported_component_types=>'PARTIAL'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('TEMPLATE COMPONENT','THEME_3$AVATAR'),'')
,p_partial_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{if APEX$IS_LAZY_LOADING/}',
'  <span class="b-Avatar is-placeholder{if ?SHAPE/} #SHAPE#{endif/}{if ?SIZE/} #SIZE#{endif/}{if ?CSS_CLASSES/} #CSS_CLASSES#{endif/}"></span>',
'{else/}',
'  {if ?LINK/}<a href="#LINK#" #LINK_ATTR#{else/}<span{endif/} class="b-Avatar{if ?TYPE/} b-Avatar--{if ?IMAGE/}image{else/}{if ?INITIALS/}initials{else/}icon{endif/}{endif/}{endif/}{if ?SHAPE/} #SHAPE#{endif/}{if ?SIZE/} #SIZE#{endif/}{if ?ICON/} a-I'
||'con #ICON#{else/} a-Icon icon-user{endif/}{if ?CSS_CLASSES/} #CSS_CLASSES#{endif/} u-color" {if !IMAGE/}{if DESCRIPTION/} role="img" aria-label="#DESCRIPTION#" title="#DESCRIPTION#"{else/} role="presentation"{endif/}{endif/}>{if IMAGE/}<img src="#IMA'
||'GE#" alt="#DESCRIPTION#"{if ?DESCRIPTION/} title="#DESCRIPTION#"{endif/} loading="lazy" />{else/}{if ?INITIALS/}#INITIALS#{endif/}{endif/}{if ?LINK/}</a>{else/}</span>{endif/}',
'{endif/}',
''))
,p_default_escape_mode=>'HTML'
,p_translate_this_template=>false
,p_api_version=>1
,p_standard_attributes=>'REGION_TEMPLATE'
,p_substitute_attributes=>true
,p_reference_id=>107628373109272015
,p_version_scn=>75203263
,p_subscribe_plugin_settings=>true
,p_help_text=>'Display an image, icon, or initials. Available as a partial template to display a single row.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(22400572956017991)
,p_plugin_id=>wwv_flow_imp.id(107642902371278122)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_static_id=>'TYPE'
,p_prompt=>'Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'IMAGE'
,p_demo_value=>'IMAGE'
,p_escape_mode=>'HTML'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Select the type of content that will be displayed in the avatar.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(22401053517017990)
,p_plugin_attribute_id=>wwv_flow_imp.id(22400572956017991)
,p_display_sequence=>10
,p_display_value=>'Image'
,p_return_value=>'IMAGE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(22401622823017989)
,p_plugin_attribute_id=>wwv_flow_imp.id(22400572956017991)
,p_display_sequence=>20
,p_display_value=>'Initials'
,p_return_value=>'INITIALS'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(22402245357017989)
,p_plugin_attribute_id=>wwv_flow_imp.id(22400572956017991)
,p_display_sequence=>30
,p_display_value=>'Icon'
,p_return_value=>'ICON'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(22402822589017988)
,p_plugin_id=>wwv_flow_imp.id(107642902371278122)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_static_id=>'IMAGE'
,p_prompt=>'Image'
,p_attribute_type=>'MEDIA'
,p_is_required=>false
,p_demo_value=>'#APEX_FILES#apex_ui/img/favicons/app-artwork-catalog.png'
,p_escape_mode=>'ATTR'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(22400572956017991)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'IMAGE'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use the Media popup dialog to select a source for the avatar image.</p>',
'',
'<p>Available options include:',
'<ul>',
'<li>URL</li>',
'<li>BLOB Column</li>',
'<li>URL Column</li>',
'</ul>',
'</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(22403368028017988)
,p_plugin_id=>wwv_flow_imp.id(107642902371278122)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>55
,p_static_id=>'DESCRIPTION'
,p_prompt=>'Description'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_escape_mode=>'ATTR'
,p_is_translatable=>false
,p_help_text=>'Enter a short description or select a source column from the quick pick options. This will be used as alt text for an avatar image. If no description is specified this will be hidden from screen readers.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(22403840949017988)
,p_plugin_id=>wwv_flow_imp.id(107642902371278122)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_static_id=>'INITIALS'
,p_prompt=>'Initials'
,p_attribute_type=>'SESSION STATE VALUE'
,p_is_required=>false
,p_escape_mode=>'HTML'
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(22400572956017991)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'INITIALS'
,p_help_text=>'Select the source column to be displayed within each avatar. Only varchar2 data types are supported.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(22404374338017987)
,p_plugin_id=>wwv_flow_imp.id(107642902371278122)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_static_id=>'ICON'
,p_prompt=>'Icon'
,p_attribute_type=>'ICON'
,p_is_required=>false
,p_escape_mode=>'ATTR'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(22400572956017991)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ICON'
,p_help_text=>'Enter an icon class or use the Pick Icon dialog to select the icon you want to add to display in the avatar.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(22404835223017987)
,p_plugin_id=>wwv_flow_imp.id(107642902371278122)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_static_id=>'SHAPE'
,p_prompt=>'Shape'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_escape_mode=>'ATTR'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'Default'
,p_help_text=>'Select the shape of the avatar. Default inherits the shape set by the containing template.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(22405376945017987)
,p_plugin_attribute_id=>wwv_flow_imp.id(22404835223017987)
,p_display_sequence=>10
,p_display_value=>'Rounded'
,p_return_value=>'b-Avatar--rounded'
,p_help_text=>'Displayed within a square with rounded corners.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(22405952174017986)
,p_plugin_attribute_id=>wwv_flow_imp.id(22404835223017987)
,p_display_sequence=>20
,p_display_value=>'Circular'
,p_return_value=>'b-Avatar--circle'
,p_help_text=>'Displayed within a circular shape.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(22406555520017986)
,p_plugin_attribute_id=>wwv_flow_imp.id(22404835223017987)
,p_display_sequence=>30
,p_display_value=>'Square'
,p_return_value=>'b-Avatar--square'
,p_help_text=>'Displayed within a square shape.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(22407102251017986)
,p_plugin_attribute_id=>wwv_flow_imp.id(22404835223017987)
,p_display_sequence=>40
,p_display_value=>'No Shape'
,p_return_value=>'b-Avatar--noShape'
,p_help_text=>'Displayed inline without a containing shape.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(22407714404017985)
,p_plugin_id=>wwv_flow_imp.id(107642902371278122)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_static_id=>'SIZE'
,p_prompt=>'Size'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_escape_mode=>'ATTR'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'Default'
,p_help_text=>'Set the size of the avatar. The default inherits the sizing set by the containing template.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(22408291399017985)
,p_plugin_attribute_id=>wwv_flow_imp.id(22407714404017985)
,p_display_sequence=>10
,p_display_value=>'Extra Extra Small'
,p_return_value=>'b-Avatar--xs'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(22408844284017984)
,p_plugin_attribute_id=>wwv_flow_imp.id(22407714404017985)
,p_display_sequence=>20
,p_display_value=>'Extra Small'
,p_return_value=>'b-Avatar--xs'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(22409408353017984)
,p_plugin_attribute_id=>wwv_flow_imp.id(22407714404017985)
,p_display_sequence=>30
,p_display_value=>'Small'
,p_return_value=>'b-Avatar--sm'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(22410089471017984)
,p_plugin_attribute_id=>wwv_flow_imp.id(22407714404017985)
,p_display_sequence=>40
,p_display_value=>'Medium'
,p_return_value=>'b-Avatar--md'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(22410621976017983)
,p_plugin_attribute_id=>wwv_flow_imp.id(22407714404017985)
,p_display_sequence=>50
,p_display_value=>'Large'
,p_return_value=>'b-Avatar--lg'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(22411200839017983)
,p_plugin_attribute_id=>wwv_flow_imp.id(22407714404017985)
,p_display_sequence=>60
,p_display_value=>'Extra Large'
,p_return_value=>'b-Avatar--xl'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(22411854117017983)
,p_plugin_attribute_id=>wwv_flow_imp.id(22407714404017985)
,p_display_sequence=>70
,p_display_value=>'Extra Extra Large'
,p_return_value=>'b-Avatar--xxl'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(22412445273017982)
,p_plugin_id=>wwv_flow_imp.id(107642902371278122)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_static_id=>'CSS_CLASSES'
,p_prompt=>'CSS Classes'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_common=>false
,p_escape_mode=>'ATTR'
,p_is_translatable=>false
,p_help_text=>'Enter classes to add to this component. You may add multiple classes by separating them with a space.'
);
wwv_flow_imp_shared.create_plugin_act_position(
 p_id=>wwv_flow_imp.id(2128649432559812906)
,p_plugin_id=>wwv_flow_imp.id(107642902371278122)
,p_name=>'Link'
,p_static_id=>'LINK'
,p_display_sequence=>10
,p_is_quick_pick=>true
,p_type=>'LINK'
);
end;
/
prompt --application/shared_components/plugins/template_component/theme_3_badge
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(107669866469383005)
,p_plugin_type=>'TEMPLATE COMPONENT'
,p_theme_id=>nvl(wwv_flow_application_install.get_theme_id, '3')
,p_name=>'THEME_3$BADGE'
,p_display_name=>'Badge'
,p_supported_component_types=>'PARTIAL:REPORT'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('TEMPLATE COMPONENT','THEME_3$BADGE'),'')
,p_partial_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{if APEX$IS_LAZY_LOADING/}',
'  <span class="b-Badge is-placeholder{if ?SIZE/} #SIZE#{endif/}{if ?SHAPE/} #SHAPE#{endif/}"></span>',
'{else/}',
'  {if ?LINK/}<a href="#LINK#" #LINK_ATTR#{else/}<span{endif/} class="b-Badge{if ?STATE/} b-Badge--#STATE#{endif/}{if ?STYLE/} #STYLE#{endif/}{if ?SIZE/} #SIZE#{endif/}{if ?SHAPE/} #SHAPE#{endif/}" role="status" aria-label="#LABEL!STRIPHTML# #VALUE#" '
||'title="#LABEL!STRIPHTML# #VALUE#">',
'    {if ?ICON/}<span class="b-Badge-icon #ICON#" aria-hidden="true"></span>{endif/}',
'    {if LABEL_DISPLAY/}<span class="b-Badge-label">#LABEL#</span>{endif/}',
'    <span class="b-Badge-value">#VALUE#</span>',
'  {if ?LINK/}</a>{else/}</span>{endif/}',
'{endif/}',
''))
,p_default_escape_mode=>'HTML'
,p_translate_this_template=>true
,p_api_version=>1
,p_report_body_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{if !APEX$HAS_MESSAGE/}',
'  <ul class="b-Badges #APEX$COMPONENT_CSS_CLASSES#">#APEX$ROWS#</ul>',
'{endif/}'))
,p_report_row_template=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="b-Badges-item" #APEX$ROW_IDENTIFICATION#>#APEX$PARTIAL#</li>',
''))
,p_report_placeholder_count=>1
,p_standard_attributes=>'REGION_TEMPLATE'
,p_substitute_attributes=>true
,p_reference_id=>107660297474380201
,p_version_scn=>75204539
,p_subscribe_plugin_settings=>true
,p_help_text=>'Display content within a badge. Available for multiple report rows or a single row.'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(22600531895014977)
,p_plugin_id=>wwv_flow_imp.id(107669866469383005)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_static_id=>'LABEL'
,p_prompt=>'Label'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_escape_mode=>'RAW'
,p_is_translatable=>true
,p_help_text=>'Enter a value for the badge label or select a source column from the quick pick options.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(22601002138014976)
,p_plugin_id=>wwv_flow_imp.id(107669866469383005)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_static_id=>'VALUE'
,p_prompt=>'Value'
,p_attribute_type=>'SESSION STATE VALUE'
,p_is_required=>true
,p_escape_mode=>'STRIPHTML'
,p_column_data_types=>'VARCHAR2:NUMBER:DATE:INTERVAL_Y2M:INTERVAL_D2S'
,p_is_translatable=>false
,p_help_text=>'Select a source column for the badge value.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(22601575821014976)
,p_plugin_id=>wwv_flow_imp.id(107669866469383005)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_static_id=>'STATE'
,p_prompt=>'State'
,p_attribute_type=>'SESSION STATE VALUE'
,p_is_required=>false
,p_escape_mode=>'ATTR'
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_help_text=>'Select the source column for the state of the badge. Substitute column value with "danger", "warning", "success" or "info" for default styling.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(22602020592014975)
,p_plugin_id=>wwv_flow_imp.id(107669866469383005)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_static_id=>'ICON'
,p_prompt=>'Icon'
,p_attribute_type=>'ICON'
,p_is_required=>false
,p_escape_mode=>'ATTR'
,p_is_translatable=>false
,p_help_text=>'Enter an icon class or use the Pick Icon dialog to select the icon you want to add to display in the badge.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(22602577038014975)
,p_plugin_id=>wwv_flow_imp.id(107669866469383005)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_static_id=>'LABEL_DISPLAY'
,p_prompt=>'Display Label'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_escape_mode=>'ATTR'
,p_is_translatable=>false
,p_help_text=>'Specify whether to display or hide the badge label. When set to Yes, the badge label will be displayed in addition to the badge value. When set to No, only the badge value will be displayed.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(22603030431014975)
,p_plugin_id=>wwv_flow_imp.id(107669866469383005)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_static_id=>'STYLE'
,p_prompt=>'Style'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_escape_mode=>'ATTR'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'Default'
,p_help_text=>'Select the badge style. Default inherits the style set by the containing template.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(22603581525014974)
,p_plugin_attribute_id=>wwv_flow_imp.id(22603030431014975)
,p_display_sequence=>10
,p_display_value=>'Subtle'
,p_return_value=>'b-Badge--subtle'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(22604134597014973)
,p_plugin_attribute_id=>wwv_flow_imp.id(22603030431014975)
,p_display_sequence=>20
,p_display_value=>'Outline'
,p_return_value=>'b-Badge--outline'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(22604764043014972)
,p_plugin_id=>wwv_flow_imp.id(107669866469383005)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_static_id=>'SHAPE'
,p_prompt=>'Shape'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_escape_mode=>'ATTR'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'Default'
,p_help_text=>'Select the shape of the badge. Default inherits the shape set by the containing template.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(22605205600014972)
,p_plugin_attribute_id=>wwv_flow_imp.id(22604764043014972)
,p_display_sequence=>10
,p_display_value=>'Rounded'
,p_return_value=>'b-Badge--rounded'
,p_help_text=>'Displayed with rounded corners.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(22605857923014971)
,p_plugin_attribute_id=>wwv_flow_imp.id(22604764043014972)
,p_display_sequence=>20
,p_display_value=>'Circular'
,p_return_value=>'b-Badge--circle'
,p_help_text=>'Displayed with circular edges.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(22606401553014971)
,p_plugin_attribute_id=>wwv_flow_imp.id(22604764043014972)
,p_display_sequence=>30
,p_display_value=>'Square'
,p_return_value=>'b-Badge--square'
,p_help_text=>'Displayed with squared edges.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(22607002698014969)
,p_plugin_id=>wwv_flow_imp.id(107669866469383005)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_static_id=>'SIZE'
,p_prompt=>'Size'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_escape_mode=>'ATTR'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_null_text=>'Default'
,p_help_text=>'Set the size of the badge. The default inherits the sizing set by the containing template.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(22607529399014969)
,p_plugin_attribute_id=>wwv_flow_imp.id(22607002698014969)
,p_display_sequence=>10
,p_display_value=>'Small'
,p_return_value=>'b-Badge--sm'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(22608199641014967)
,p_plugin_attribute_id=>wwv_flow_imp.id(22607002698014969)
,p_display_sequence=>20
,p_display_value=>'Medium'
,p_return_value=>'b-Badge--md'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(22608706150014967)
,p_plugin_attribute_id=>wwv_flow_imp.id(22607002698014969)
,p_display_sequence=>30
,p_display_value=>'Large'
,p_return_value=>'b-Badge--lg'
);
wwv_flow_imp_shared.create_plugin_act_position(
 p_id=>wwv_flow_imp.id(327477558780084520)
,p_plugin_id=>wwv_flow_imp.id(107669866469383005)
,p_name=>'Link'
,p_static_id=>'LINK'
,p_display_sequence=>10
,p_type=>'LINK'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_apex
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(113745221597665418)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.APEX'
,p_display_name=>'INTERNAL Oracle APEX Accounts'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.APEX'),'')
,p_api_version=>1
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_apex'
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>113737019268347425
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_social
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(118542747372907112)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.SOCIAL'
,p_display_name=>'INTERNAL Social Sign-In'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.SOCIAL'),'')
,p_api_version=>2
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_social'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_social'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_social'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_social'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_social'
,p_substitute_attributes=>true
,p_reference_id=>117694777698093086
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416827768402942499)
,p_plugin_id=>wwv_flow_imp.id(118542747372907112)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Authentication Provider'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'OPENID_CONNECT'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(416828116208942499)
,p_plugin_attribute_id=>wwv_flow_imp.id(416827768402942499)
,p_display_sequence=>10
,p_display_value=>'OpenID Connect Provider'
,p_return_value=>'OPENID_CONNECT'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(416828608833942499)
,p_plugin_attribute_id=>wwv_flow_imp.id(416827768402942499)
,p_display_sequence=>20
,p_display_value=>'Generic OAuth2 Provider'
,p_return_value=>'OAUTH2'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(416829165499942500)
,p_plugin_attribute_id=>wwv_flow_imp.id(416827768402942499)
,p_display_sequence=>30
,p_display_value=>'Google'
,p_return_value=>'GOOGLE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(416829626720942500)
,p_plugin_attribute_id=>wwv_flow_imp.id(416827768402942499)
,p_display_sequence=>40
,p_display_value=>'Facebook'
,p_return_value=>'FACEBOOK'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416830112747942500)
,p_plugin_id=>wwv_flow_imp.id(118542747372907112)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Discovery URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(416827768402942499)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OPENID_CONNECT'
,p_examples=>'https://accounts.example.com/.well-known/openid-configuration'
,p_help_text=>'Enter the OpenID Connect provider''s discovery URL.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416830575873942501)
,p_plugin_id=>wwv_flow_imp.id(118542747372907112)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Authorization Endpoint URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(416827768402942499)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>'Enter the OAuth2 provider''s authorization endpoint URL.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416830948285942501)
,p_plugin_id=>wwv_flow_imp.id(118542747372907112)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Token Endpoint URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(416827768402942499)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>'Enter the OAuth2 provider''s token endpoint URL.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416831337467942501)
,p_plugin_id=>wwv_flow_imp.id(118542747372907112)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'User Info Endpoint URL'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(416827768402942499)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_help_text=>'Enter the OAuth2 provider''s user info endpoint URL.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416831710698942501)
,p_plugin_id=>wwv_flow_imp.id(118542747372907112)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Scope'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'profile'
,p_is_translatable=>false
,p_help_text=>'Enter a comma separated list of permissions to request for the user who is logging in. The acceptable values depend on your authentication provider. For OpenID Connect and Google, Oracle APEX automatically adds the "openid" scope. The authentication '
||'provider returns user attributes based on these permissions. You can use a Post Authentication procedure to process these attributes, using the APEX_JSON.GET_% functions.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416832172458942502)
,p_plugin_id=>wwv_flow_imp.id(118542747372907112)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Authentication URI Parameters'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Enter optional parameters for the authentication URI. Consult the authentication provider''s documentation for supported parameters.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416832509492942502)
,p_plugin_id=>wwv_flow_imp.id(118542747372907112)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_prompt=>'Username Attribute'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'email'
,p_is_translatable=>false
,p_help_text=>'Enter the attribute which contains the username. Consult the authentication provider''s documentation for supported attributes.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416832964449942502)
,p_plugin_id=>wwv_flow_imp.id(118542747372907112)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_prompt=>'Additional User Attributes'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'Enter a comma separated list of additional user data attributes. Consult the authentication provider''s documentation for supported attributes.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416833305541942503)
,p_plugin_id=>wwv_flow_imp.id(118542747372907112)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_prompt=>'Logout URL'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Use this attribute to specify a URL to log out from your authentication provider.',
'For <em>OpenID Connect</em>, &PRODUCT_NAME. automatically uses the <em>end_session</em> endpoint, if that is defined in the <em>Discovery URL</em>.',
'For others, you can use #ID_TOKEN# and #REDIRECT_URI# in the URL, to substitute the ID token that was returned when logging in and the full URL to /apex on your instance, e.g. https://www.example.com/apex/apex.',
'Note that the redirect URI often has to be registered with your authentication provider.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416833747187942503)
,p_plugin_id=>wwv_flow_imp.id(118542747372907112)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>65
,p_prompt=>'Token Authentication Method'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'BASIC_AND_CLID'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(416827768402942499)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'OAUTH2'
,p_lov_type=>'STATIC'
,p_help_text=>'Enter how the credential''s client ID and client secret should be passed to the server.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(416834126430942503)
,p_plugin_attribute_id=>wwv_flow_imp.id(416833747187942503)
,p_display_sequence=>10
,p_display_value=>'Basic Authentication'
,p_return_value=>'BASIC'
,p_help_text=>'Send client id and client secret in a Basic Authentication header.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(416834695097942503)
,p_plugin_attribute_id=>wwv_flow_imp.id(416833747187942503)
,p_display_sequence=>20
,p_display_value=>'Basic Authentication and Client ID in Body'
,p_return_value=>'BASIC_AND_CLID'
,p_help_text=>'Send client id and client secret in a Basic Authentication header, but also send client it in the request body.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(416835152166942504)
,p_plugin_attribute_id=>wwv_flow_imp.id(416833747187942503)
,p_display_sequence=>30
,p_display_value=>'Client ID and Client Secret in Body'
,p_return_value=>'BODY'
,p_help_text=>'Send client id and client secret in the request body.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(416835658250942504)
,p_plugin_attribute_id=>wwv_flow_imp.id(416833747187942503)
,p_display_sequence=>40
,p_display_value=>'Client ID in Body'
,p_return_value=>'CLID'
,p_help_text=>'Only send client id in the request body.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(416836169423942504)
,p_plugin_id=>wwv_flow_imp.id(118542747372907112)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>91
,p_prompt=>'Verify Username'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>true
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'If enabled, &PRODUCT_NAME. will look for an attribute "#username#_verified" (for example, "email_verified" for Username Attribute "email"). If the value of this attribute is set to "false", the username will not be accepted.'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/com_oracle_apex_showrequired
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(168887529524073617)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'COM.ORACLE.APEX.SHOWREQUIRED'
,p_display_name=>'Show Required'
,p_category=>'COMPONENT'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','COM.ORACLE.APEX.SHOWREQUIRED'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_show_required'
,p_standard_attributes=>'REQUIRED'
,p_substitute_attributes=>true
,p_version_scn=>72475515
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/com_oracle_apex_hiderequired
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(168887711994078043)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'COM.ORACLE.APEX.HIDEREQUIRED'
,p_display_name=>'Hide Required'
,p_category=>'COMPONENT'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','COM.ORACLE.APEX.HIDEREQUIRED'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_hide_required'
,p_standard_attributes=>'ITEM:REQUIRED'
,p_substitute_attributes=>true
,p_version_scn=>72475515
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_condition_list
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(186814901672118890)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.CONDITION_LIST'
,p_display_name=>'Condition Type'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.CONDITION_LIST'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_condition_type'
,p_validation_function=>'wwv_flow_f4000_plugins.validate_condition_type'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:ESCAPE_OUTPUT:QUICKPICK:SOURCE:ELEMENT:LOV:LOV_DISPLAY_NULL'
,p_substitute_attributes=>true
,p_version_scn=>72475515
,p_subscribe_plugin_settings=>true
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(186815126952126271)
,p_plugin_id=>wwv_flow_imp.id(186814901672118890)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Expression 1 Page Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_default_value=>'PXXX_DISPLAY_WHEN'
,p_is_translatable=>false
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(186815604227129139)
,p_plugin_id=>wwv_flow_imp.id(186814901672118890)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Expression 2 Page Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_default_value=>'PXXX_DISPLAY_WHEN2'
,p_is_translatable=>false
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(186850620259616261)
,p_plugin_id=>wwv_flow_imp.id(186814901672118890)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Read Only Attribute Page Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(435006624881297772)
,p_plugin_id=>wwv_flow_imp.id(186814901672118890)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Check Expression Page Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_default_value=>'PXXX_DISPLAY_WHEN_CHECK'
,p_is_translatable=>false
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(9108120561208861)
,p_plugin_id=>wwv_flow_imp.id(186814901672118890)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Check Condition for each Row Page Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(17008114447614272)
,p_plugin_id=>wwv_flow_imp.id(186814901672118890)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>5
,p_prompt=>'Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'CONDITION'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(17013718256615389)
,p_plugin_attribute_id=>wwv_flow_imp.id(17008114447614272)
,p_display_sequence=>10
,p_display_value=>'Condition'
,p_return_value=>'CONDITION'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(17014223451616874)
,p_plugin_attribute_id=>wwv_flow_imp.id(17008114447614272)
,p_display_sequence=>20
,p_display_value=>'Read Only'
,p_return_value=>'READ_ONLY'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(17015529684618682)
,p_plugin_attribute_id=>wwv_flow_imp.id(17008114447614272)
,p_display_sequence=>30
,p_display_value=>'Validation'
,p_return_value=>'VALIDATION'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(17016001418619960)
,p_plugin_attribute_id=>wwv_flow_imp.id(17008114447614272)
,p_display_sequence=>40
,p_display_value=>'Cache'
,p_return_value=>'CACHE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(17025627831684357)
,p_plugin_attribute_id=>wwv_flow_imp.id(17008114447614272)
,p_display_sequence=>50
,p_display_value=>'Install'
,p_return_value=>'INSTALL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1147161874794101092)
,p_plugin_attribute_id=>wwv_flow_imp.id(17008114447614272)
,p_display_sequence=>60
,p_display_value=>'Wizard'
,p_return_value=>'WIZARD'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2523021215376825)
,p_plugin_attribute_id=>wwv_flow_imp.id(17008114447614272)
,p_display_sequence=>70
,p_display_value=>'Data Loading'
,p_return_value=>'DATA_LOADING'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(275279165622037026)
,p_plugin_attribute_id=>wwv_flow_imp.id(17008114447614272)
,p_display_sequence=>80
,p_display_value=>'Action (Automation or Task)'
,p_return_value=>'ACTION'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(275279567174037736)
,p_plugin_attribute_id=>wwv_flow_imp.id(17008114447614272)
,p_display_sequence=>90
,p_display_value=>'Automation'
,p_return_value=>'AUTOM'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1502656613845364)
,p_plugin_id=>wwv_flow_imp.id(186814901672118890)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>25
,p_prompt=>'Language Page Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_default_value=>'PXXX_LANG'
,p_is_translatable=>false
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(845154403169834506)
,p_plugin_id=>wwv_flow_imp.id(186814901672118890)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_sql_max_column_count=>2
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_ui_component_select_list
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(274985426340249335)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.UI_COMPONENT_SELECT_LIST'
,p_display_name=>'UI Components Select List'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.UI_COMPONENT_SELECT_LIST'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_ui_component_selectlist'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:HEIGHT:ELEMENT_OPTION:ENCRYPT:LOV:LOV_DISPLAY_NULL'
,p_substitute_attributes=>true
,p_version_scn=>72475515
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(274985715126254465)
,p_plugin_id=>wwv_flow_imp.id(274985426340249335)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Current application ID page item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_default_value=>'FB_FLOW_ID'
,p_is_translatable=>false
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(274987711601347260)
,p_plugin_id=>wwv_flow_imp.id(274985426340249335)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Current page ID page item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_default_value=>'FB_FLOW_PAGE_ID'
,p_is_translatable=>false
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(845154544647834507)
,p_plugin_id=>wwv_flow_imp.id(274985426340249335)
,p_name=>'LOV'
,p_sql_min_column_count=>3
,p_sql_max_column_count=>3
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select wwv_flow_lang.system_message(''DA_NAME.''|| name_with_prefix) as d,',
'       name_with_prefix      as r,',
'       nvl(category, ''MISC'') as category',
'  from wwv_flow_native_plugins',
' where plugin_type = ''DYNAMIC ACTION''',
' order by decode(category, ''MISC'', 1, 0), category, 1',
'</pre>'))
);
end;
/
prompt --application/shared_components/plugins/region_type/com_oracle_apex_splitter
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(330671351658403453)
,p_plugin_type=>'REGION TYPE'
,p_name=>'COM.ORACLE.APEX.SPLITTER'
,p_display_name=>'Splitter'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','COM.ORACLE.APEX.SPLITTER'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_splitter'
,p_ajax_function=>'wwv_flow_f4000_plugins.ajax_splitter'
,p_substitute_attributes=>true
,p_version_scn=>1088654318
,p_subscribe_plugin_settings=>true
,p_help_text=>'<p>A splitter dynamically divides the available space for two sub regions horizontally or vertically. The splitter region must have exactly two sub regions. Just about any region template can be used, as long as it has an id attribute, but some will '
||'look better than others. Avoid regions templates with margins or padding. If the region template has an element that wraps the sub regions then a CSS selector that selects the wrapping element must be entered in the Selector property.</p>'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(349220632388568598)
,p_plugin_id=>wwv_flow_imp.id(330671351658403453)
,p_attribute_scope=>'APPLICATION'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_static_id=>'attribute_01'
,p_prompt=>'Splitter Keyboard Navigation'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'If yes a global keyboard handler will be added to support using Ctrl-F6 to navigate to the next splitter and Shift-Ctrl-F6 to navigate to the previous splitter.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(330688557661299917)
,p_plugin_id=>wwv_flow_imp.id(330671351658403453)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_static_id=>'attribute_01'
,p_prompt=>'Selector'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>80
,p_max_length=>400
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'An optional CSS selector that identifies the element that contains the two sub regions. The selector should start with the static region id. If omitted the region id or static id will be used. ',
'<p>',
'Example:<br>',
'#regonStaticId > .container',
'<p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(330688948819304091)
,p_plugin_id=>wwv_flow_imp.id(330671351658403453)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_static_id=>'attribute_02'
,p_prompt=>'Orientation'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'horizontal'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'A horizontal splitter has the two sub regions side by side. A vertical splitter has the two sub regions one on top of the other. The first sub region is always on the left or top.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(330689346016305383)
,p_plugin_attribute_id=>wwv_flow_imp.id(330688948819304091)
,p_display_sequence=>10
,p_display_value=>'Horizontal'
,p_return_value=>'horizontal'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(330689738036309021)
,p_plugin_attribute_id=>wwv_flow_imp.id(330688948819304091)
,p_display_sequence=>20
,p_display_value=>'Vertical'
,p_return_value=>'vertical'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(330690450316318564)
,p_plugin_id=>wwv_flow_imp.id(330671351658403453)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_static_id=>'attribute_03'
,p_prompt=>'Positioned From'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'begin'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'This determines from which side the position of the splitter is measured and to which side the splitter will collapse. Choose Begin to collapse to the left (right if direction is RTL) or top. Choose End to collapse to the right (left if direction is '
||'RTL) or bottom.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(336045355822788793)
,p_plugin_attribute_id=>wwv_flow_imp.id(330690450316318564)
,p_display_sequence=>10
,p_display_value=>'Begin (left/top)'
,p_return_value=>'begin'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(336045754312789475)
,p_plugin_attribute_id=>wwv_flow_imp.id(330690450316318564)
,p_display_sequence=>20
,p_display_value=>'End (right/bottom)'
,p_return_value=>'end'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(330690840827322937)
,p_plugin_id=>wwv_flow_imp.id(330671351658403453)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_static_id=>'attribute_04'
,p_prompt=>'Position'
,p_attribute_type=>'NUMBER'
,p_is_required=>true
,p_default_value=>'100'
,p_display_length=>5
,p_max_length=>5
,p_is_translatable=>false
,p_help_text=>'This is the initial position in pixels of the splitter bar. If the splitter is initially collapsed this is the position used when the splitter is first expanded. If Persist State is Yes then if there is a saved position it overrides this value.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(330691231338327320)
,p_plugin_id=>wwv_flow_imp.id(330671351658403453)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_static_id=>'attribute_05'
,p_prompt=>'Collapsed'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1272749710877634174)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'If Yes the splitter is initially collapsed. If Persist State is Yes then if there is a saved collapsed state it overrides this value.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(330691658499329931)
,p_plugin_id=>wwv_flow_imp.id(330671351658403453)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_static_id=>'attribute_06'
,p_prompt=>'Snap'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>5
,p_max_length=>5
,p_is_translatable=>false
,p_help_text=>'Optional. The number of pixels the splitter moves in each increment when dragging or with the arrow keys. If not specified the splitter can be dragged with single pixel precision.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(330692042109337535)
,p_plugin_id=>wwv_flow_imp.id(330671351658403453)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_static_id=>'attribute_07'
,p_prompt=>'Keyboard Increment'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>5
,p_max_length=>5
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(330691658499329931)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'NULL'
,p_help_text=>'Optional. The number of pixels to move the splitter for each arrow key press. If not specified the default is 10.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(330692435208340781)
,p_plugin_id=>wwv_flow_imp.id(330671351658403453)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_static_id=>'attribute_08'
,p_prompt=>'Minimum Size'
,p_attribute_type=>'NUMBER'
,p_is_required=>false
,p_display_length=>5
,p_max_length=>5
,p_is_translatable=>false
,p_help_text=>'The minimum position of the splitter before it automatically collapses. If not specified the default of 60 is used.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(330692860643344184)
,p_plugin_id=>wwv_flow_imp.id(330671351658403453)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>90
,p_static_id=>'attribute_09'
,p_prompt=>'Continuous Resize'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'If Yes the two sub regions are sized on each movement of the splitter while dragging or moving with the arrow keys. Otherwise the sub regions are sized only when the splitter stops moving. This should be set to No if the sub regions are computational'
||'ly expensive to resize.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(330693249645349258)
,p_plugin_id=>wwv_flow_imp.id(330671351658403453)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>100
,p_static_id=>'attribute_10'
,p_prompt=>'Restore Text'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>80
,p_max_length=>120
,p_is_translatable=>true
,p_help_text=>'This is the title (tooltip) text for the splitter handle when the splitter is collapsed. If not specified a default is provided.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(330693643391352153)
,p_plugin_id=>wwv_flow_imp.id(330671351658403453)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_static_id=>'attribute_11'
,p_prompt=>'Collapse Text'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>80
,p_max_length=>120
,p_is_translatable=>true
,p_help_text=>'This is the title (tooltip) text for the splitter handle when the splitter is expanded. If not specified a default is provided.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(330694038430354494)
,p_plugin_id=>wwv_flow_imp.id(330671351658403453)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_static_id=>'attribute_12'
,p_prompt=>'Title'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_display_length=>80
,p_max_length=>120
,p_is_translatable=>true
,p_help_text=>'This is the title (tooltip) text for the splitter bar. Providing a title for each splitter is helpful for accessibility especially when there are multiple splitters.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(336050456955985813)
,p_plugin_id=>wwv_flow_imp.id(330671351658403453)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>12
,p_static_id=>'attribute_13'
,p_prompt=>'Persist State'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'If Yes the state of the splitter is persisted as a user preference.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1272749710877634174)
,p_plugin_id=>wwv_flow_imp.id(330671351658403453)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>45
,p_static_id=>'attribute_14'
,p_prompt=>'Can Collapse '
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'When set to Yes the splitter can collapse or expand by clicking on the handle or pressing Enter or Space. When set to No the splitter can only be moved to its minimum size.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1272751944026669582)
,p_plugin_id=>wwv_flow_imp.id(330671351658403453)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>150
,p_static_id=>'attribute_15'
,p_prompt=>'Sub Region Contains iframe'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'Only set to Yes if either sub region of the splitter contains an iframe.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1272753284660692508)
,p_plugin_id=>wwv_flow_imp.id(330671351658403453)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>16
,p_display_sequence=>160
,p_static_id=>'attribute_16'
,p_prompt=>'Drag To Collapse'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1272749710877634174)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'If Yes the splitter can be collapsed by dragging past the minimum size. If No the splitter can only be dragged to the minimum size.'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_cloud_idm
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(356672915595447685)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.CLOUD_IDM'
,p_display_name=>'INTERNAL Oracle Cloud Identity Management'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.CLOUD_IDM'),'')
,p_api_version=>1
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_cloud'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_cloud'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_cloud'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_cloud'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_cloud'
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>113749806821809026
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_db
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(356675223794447688)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.DB'
,p_display_name=>'INTERNAL Database Accounts'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.DB'),'')
,p_api_version=>1
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_db'
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>113749511183746276
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_header
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(356678515020447691)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.HEADER'
,p_display_name=>'INTERNAL HTTP Header Variable'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.HEADER'),'')
,p_api_version=>1
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_header'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_header'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_header'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_header'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_header'
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>708795120396802284
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(308162543022529831)
,p_plugin_id=>wwv_flow_imp.id(356678515020447691)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'HTTP Header Variable Name'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_default_value=>'OAM_REMOTE_USER'
,p_display_length=>30
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specifies the name of the HTTP header variable which contains the username.',
'The default OAM_REMOTE_USER is used by Oracle Access Manager and has to be changed',
'if another authentication provider is used.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(308162947868529831)
,p_plugin_id=>wwv_flow_imp.id(356678515020447691)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Action if Username is Empty'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'BUILTIN_URL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Specifies the action which should be performed if the username stored in the HTTP header variable is empty. The following options are available:',
'</p>',
'<p>',
'<ul>',
'  <li><strong>Redirect to Built-In URL</strong> to initiate a login by the web server. This Built-In URL has to be setup to be protected by the web server, in order to force a login when called. After login, the web server must store the validated us'
||'ername in the HTTP header variable, so it is available to the authentication scheme. The Built-In URL is',
'<pre>/apex/apex_authentication.callback</pre>',
'The prefix <code>/apex/</code> depends on your server configuration.',
'</li>',
'  <li><strong>Redirect to URL</strong> to initiate a login on an external server which then sets the validated username in the HTTP header variable. The external server should redirect back to the application using the URL generated by the <code>#CAL'
||'LBACK#</code> placeholder to complete authentication in the application.</li>',
'  <li><strong>Display Error</strong> will display the specified error message and no login will be performed in the application.</li>',
'</ul>',
'</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(308163322120529833)
,p_plugin_attribute_id=>wwv_flow_imp.id(308162947868529831)
,p_display_sequence=>10
,p_display_value=>'Redirect to Built-In URL'
,p_return_value=>'BUILTIN_URL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(308163859965529833)
,p_plugin_attribute_id=>wwv_flow_imp.id(308162947868529831)
,p_display_sequence=>20
,p_display_value=>'Redirect to URL'
,p_return_value=>'URL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(308164336758529835)
,p_plugin_attribute_id=>wwv_flow_imp.id(308162947868529831)
,p_display_sequence=>30
,p_display_value=>'Display Error'
,p_return_value=>'ERROR'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(308164825200529835)
,p_plugin_id=>wwv_flow_imp.id(356678515020447691)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(308162947868529831)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'URL'
,p_examples=>'http://sso.example.com/?success=#CALLBACK#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Specifies the URL of an external login server which sets the validated username in the HTTP header variable. The external server should redirect back to the application using the URL generated by the <code>#CALLBACK#</code> placeholder to complete au'
||'thentication in the application.',
'</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(308165296992529835)
,p_plugin_id=>wwv_flow_imp.id(356678515020447691)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Error Message'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_display_length=>60
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_imp.id(308162947868529831)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ERROR'
,p_help_text=>'Specifies the error message to be displayed if the HTTP header variable does not contain a value or the HTTP header variable does not exist.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(308165609186529836)
,p_plugin_id=>wwv_flow_imp.id(356678515020447691)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Verify Username'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ALWAYS'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Specifies how often the username stored in the HTTP header variable is verified. The following options are available:',
'</p>',
'<p>',
'<ul>',
'  <li><strong>Each Request</strong> will expect that the CGI variable is always set as soon as the login has been performed by the web server. If the username is not identical to the one stored in the current &PRODUCT_NAME. session, the session will '
||'be invalidated and a new login will be initiated. This is the most secure option because it detects logouts or username changes.',
'  </li>',
'  <li><strong>After Login</strong> will only verify and store the username in the &PRODUCT_NAME. session after the web server has performed the login and calls the callback to complete authentication in the application. For callback see "Action if Us'
||'ername is Empty" configuration.',
'  </li>',
'</ul>',
'</p>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(308166072641529836)
,p_plugin_attribute_id=>wwv_flow_imp.id(308165609186529836)
,p_display_sequence=>10
,p_display_value=>'Each Request'
,p_return_value=>'ALWAYS'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(308166570088529836)
,p_plugin_attribute_id=>wwv_flow_imp.id(308165609186529836)
,p_display_sequence=>20
,p_display_value=>'After Login'
,p_return_value=>'CALLBACK'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(308167098050529837)
,p_plugin_id=>wwv_flow_imp.id(356678515020447691)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Logout URL of SSO Server'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'If the authentication scheme is based on Oracle Access Manager or similar servers,',
'you can use this attribute to specify a URL to log out of the central single sign-on server.',
'<p/>',
'For Oracle Access Manager based SSO, enter for example',
'<pre>',
'/oamsso/logout.html?end_url=%POST_LOGOUT_URL%',
'</pre>',
'The substitution parameter <strong>%POST_LOGOUT_URL%</strong> will be replaced by an encoded URL to the login page of your application.'))
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_ldap
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(356745016189447752)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.LDAP'
,p_display_name=>'INTERNAL LDAP Directory'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.LDAP'),'')
,p_api_version=>1
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_ldap'
,p_standard_attributes=>'INVALID_SESSION:LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>863910941135523528
,p_subscribe_plugin_settings=>true
,p_help_text=>'<p>Enter the username and password for authentication against the LDAP directory identified on the login page. Remember, passwords may be case sensitive.</p>'
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(356745323877447752)
,p_plugin_id=>wwv_flow_imp.id(356745016189447752)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Host'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_max_length=>255
,p_is_translatable=>false
,p_help_text=>'The hostname of your LDAP directory server.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(356745710232447753)
,p_plugin_id=>wwv_flow_imp.id(356745016189447752)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Port'
,p_attribute_type=>'INTEGER'
,p_is_required=>false
,p_display_length=>6
,p_max_length=>10
,p_is_translatable=>false
,p_help_text=>'The port number of your LDAP directory host. The default is 389.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(356746109049447753)
,p_plugin_id=>wwv_flow_imp.id(356745016189447752)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Use SSL'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'NO_SSL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Choose whether to use SSL to bind to the LDAP directory. If SSL with Authentication is chosen, a wallet must be configured for the &PRODUCT_NAME. instance.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(356746532190447753)
,p_plugin_attribute_id=>wwv_flow_imp.id(356746109049447753)
,p_display_sequence=>10
,p_display_value=>'SSL'
,p_return_value=>'SSL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(356747029958447753)
,p_plugin_attribute_id=>wwv_flow_imp.id(356746109049447753)
,p_display_sequence=>20
,p_display_value=>'SSL with Authentication'
,p_return_value=>'SSL_AUTH'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(356747527068447753)
,p_plugin_attribute_id=>wwv_flow_imp.id(356746109049447753)
,p_display_sequence=>30
,p_display_value=>'No SSL'
,p_return_value=>'NO_SSL'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(356748002271447753)
,p_plugin_id=>wwv_flow_imp.id(356745016189447752)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Distinguished Name (DN) String'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the pattern used to construct the fully qualified distinguished name (DN) string to DBMS_LDAP.SIMPLE_BIND_S if using exact DN or the search base if using non-exact DN. Use <strong>%LDAP_USER%</strong> as a placeholder for the username.  For exa'
||'mple:',
'<p>',
'<strong>Exact DN</strong>',
'</p>',
'<p>',
'cn=%LDAP_USER%,l=amer,dc=yourdomain,dc=com',
'</p>',
'<p>',
'<strong>Non-Exact DN (Search Base)</strong>',
'</p>',
'<p>',
'dc=yourdomain,dc=com',
'</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(356748421799447754)
,p_plugin_id=>wwv_flow_imp.id(356745016189447752)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Use Exact Distinguished Name (DN)'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Choose whether the LDAP Distinguished Name (DN) String is exact or non-exact. If non-exact, LDAP Distinguished Name (DN) is the search base and you must supply a Search Filter.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(356748822347447754)
,p_plugin_id=>wwv_flow_imp.id(356745016189447752)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>60
,p_prompt=>'Search Filter'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_display_length=>40
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(356748421799447754)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the search filter when not using an exact distinguished name (DN). Use <strong>%LDAP_USER%</strong> as a place-holder for the username. For example:',
'</p>',
'<p><pre>cn=%LDAP_USER%</pre></p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(356749220453447755)
,p_plugin_id=>wwv_flow_imp.id(356745016189447752)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'LDAP Username Edit Function'
,p_attribute_type=>'PLSQL FUNCTION BODY'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'You may provide additional code to be executed to transform the username into a format perfectly suited to the LDAP directory entry or LDAP username.',
'The bind variable :USERNAME contains the name the end user specified.',
'For example, the following code calls a function which replaces all "."''s with "_"''s in the DN string:</p>',
'',
'<p><pre>',
'return apex_custom_auth.ldap_dnprep(p_username => :USERNAME);',
'</pre></p>',
'',
'<p>&PRODUCT_NAME. will escape the returned username based on the authentication attribute <strong>Username Escaping</strong>.'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(356749630581447755)
,p_plugin_id=>wwv_flow_imp.id(356745016189447752)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>80
,p_prompt=>'Username Escaping'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'STD'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Before replacing <strong>%LDAP_USER%</strong> in the LDAP distinguished name and search string,',
'&PRODUCT_NAME. can automatically escape special characters in the username.',
'<p/>',
'The possible rules for escaping are:',
'<ul>',
'<li><strong>Standard</strong>:',
'Escape special characters based on RFC 4514 (for distinguished names) and RFC 4515 (for search strings).',
'Additionally, escape unicode characters.',
'This is the most secure setting, but may cause problems with some LDAP servers.</li>',
'<li><strong>Only special characters</strong>:',
'Escape special characters based on RFC 4514 (for distinguished names) and RFC 4515 (for search strings).',
'Do not escape unicode characters.</li>',
'<li><strong>No escaping</strong>:',
'Do not escape any characters.',
'This setting is potentially insecure,',
'unless a <strong>Username Edit Function</strong> is employed that already',
'escapes the username (for example with apex_escape.ldap_dn or apex_escape.ldap_search_filter).</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(356750031552447755)
,p_plugin_attribute_id=>wwv_flow_imp.id(356749630581447755)
,p_display_sequence=>10
,p_display_value=>'Standard'
,p_return_value=>'STD'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(356750523626447755)
,p_plugin_attribute_id=>wwv_flow_imp.id(356749630581447755)
,p_display_sequence=>20
,p_display_value=>'Only special characters'
,p_return_value=>'ONLY'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(356751008833447756)
,p_plugin_attribute_id=>wwv_flow_imp.id(356749630581447755)
,p_display_sequence=>30
,p_display_value=>'No Escaping'
,p_return_value=>'NO'
);
end;
/
prompt --application/shared_components/plugins/authentication_type/com_oracle_apex_authn_internal_sso
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(356819511256447808)
,p_plugin_type=>'AUTHENTICATION TYPE'
,p_name=>'COM.ORACLE.APEX.AUTHN.INTERNAL.SSO'
,p_display_name=>'INTERNAL Oracle Application Server Single Sign-On'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('AUTHENTICATION TYPE','COM.ORACLE.APEX.AUTHN.INTERNAL.SSO'),'')
,p_api_version=>1
,p_ajax_function=>'wwv_flow_authentication_dev.plugin_callback_osso'
,p_session_sentry_function=>'wwv_flow_authentication_dev.plugin_sentry_osso'
,p_invalid_session_function=>'wwv_flow_authentication_dev.plugin_invalid_session_osso'
,p_authentication_function=>'wwv_flow_authentication_dev.plugin_authenticate_osso'
,p_post_logout_function=>'wwv_flow_authentication_dev.plugin_post_logout_osso'
,p_standard_attributes=>'LOGIN_PAGE'
,p_substitute_attributes=>true
,p_reference_id=>113750429890071859
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_tempalte_opt_checkbox
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(584703820034565801)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.TEMPALTE_OPT_CHECKBOX'
,p_display_name=>'Template Option Checkbox'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.TEMPALTE_OPT_CHECKBOX'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_template_opt_checkbox'
,p_ajax_function=>'wwv_flow_f4000_plugins.ajax_template_opt_checkbox'
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:ESCAPE_OUTPUT:SOURCE:ELEMENT:ELEMENT_OPTION:ENCRYPT:LOV:CASCADING_LOV'
,p_substitute_attributes=>true
,p_version_scn=>72475515
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(621147512543205393)
,p_plugin_id=>wwv_flow_imp.id(584703820034565801)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Include Default Option'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(625522324747628292)
,p_plugin_id=>wwv_flow_imp.id(584703820034565801)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Include Groups'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(628606941434451878)
,p_plugin_id=>wwv_flow_imp.id(584703820034565801)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Include Ungrouped Options'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(845154719817834512)
,p_plugin_id=>wwv_flow_imp.id(584703820034565801)
,p_name=>'LOV'
,p_sql_min_column_count=>6
,p_sql_max_column_count=>8
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name as d,',
'       css_classes as r,',
'       default_options,',
'       preset_options,',
'       description,',
'       unique_group_name,',
'       advanced_group,',
'       null_text',
'from ...'))
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_internal_page_popuplov
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(925354130594891115)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_display_name=>'Internal Page Popup LOV'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_internal_page_popuplov'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:SOURCE:ELEMENT:WIDTH:HEIGHT'
,p_substitute_attributes=>true
,p_reference_id=>925323717983648481
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1513308453290425442)
,p_plugin_id=>wwv_flow_imp.id(925354130594891115)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Target'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_default_value=>'4000_246'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1513309322451425448)
,p_plugin_attribute_id=>wwv_flow_imp.id(1513308453290425442)
,p_display_sequence=>10
,p_display_value=>'Item (4000:246)'
,p_return_value=>'4000_246'
,p_help_text=>'Popup page 4000.246 for item selection'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1513312335211425454)
,p_plugin_attribute_id=>wwv_flow_imp.id(1513308453290425442)
,p_display_sequence=>15
,p_display_value=>'Item Substitution (4000:414)'
,p_return_value=>'4000_414'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1513309825576425448)
,p_plugin_attribute_id=>wwv_flow_imp.id(1513308453290425442)
,p_display_sequence=>20
,p_display_value=>'Pick Action Info (4000:845)'
,p_return_value=>'4000_845'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1513310347097425449)
,p_plugin_attribute_id=>wwv_flow_imp.id(1513308453290425442)
,p_display_sequence=>30
,p_display_value=>'Pick Color (4000:723)'
,p_return_value=>'4000_723'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1513308842769425446)
,p_plugin_attribute_id=>wwv_flow_imp.id(1513308453290425442)
,p_display_sequence=>40
,p_display_value=>'Pick Report Column (4000:416)'
,p_return_value=>'4000_416'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1513310802437425453)
,p_plugin_attribute_id=>wwv_flow_imp.id(1513308453290425442)
,p_display_sequence=>50
,p_display_value=>'Pick Chart Column (4000:322)'
,p_return_value=>'4000_322'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1513311317968425453)
,p_plugin_attribute_id=>wwv_flow_imp.id(1513308453290425442)
,p_display_sequence=>60
,p_display_value=>'Pick Interactive Report Column (4000:721)'
,p_return_value=>'4000_721'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1513312841640425455)
,p_plugin_attribute_id=>wwv_flow_imp.id(1513308453290425442)
,p_display_sequence=>70
,p_display_value=>'Item Values (callItempopUp)'
,p_return_value=>'callItempopUp'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1513311807605425454)
,p_plugin_attribute_id=>wwv_flow_imp.id(1513308453290425442)
,p_display_sequence=>999
,p_display_value=>'JavaScript'
,p_return_value=>'javascript'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1513313371492425455)
,p_plugin_id=>wwv_flow_imp.id(925354130594891115)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Return Page Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1513308453290425442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'4000_246'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1513313735701425455)
,p_plugin_id=>wwv_flow_imp.id(925354130594891115)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Link Title'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1513314138954425455)
,p_plugin_id=>wwv_flow_imp.id(925354130594891115)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'JavaScript Code'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1513308453290425442)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'javascript'
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_hierarchical_checkbox
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1009908742651634862)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.HIERARCHICAL_CHECKBOX'
,p_display_name=>'Hierarchical Checkbox'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.HIERARCHICAL_CHECKBOX'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_hierarchical_checkbox'
,p_standard_attributes=>'VISIBLE:SESSION_STATE:READONLY:ESCAPE_OUTPUT:SOURCE:ELEMENT:ELEMENT_OPTION:ENCRYPT:LOV'
,p_substitute_attributes=>true
,p_version_scn=>72475517
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<br />',
''))
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(845155134238834519)
,p_plugin_id=>wwv_flow_imp.id(1009908742651634862)
,p_name=>'LOV'
,p_sql_min_column_count=>3
,p_sql_max_column_count=>3
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ename as d,',
'       empno as r,',
'       level',
'  from emp',
' start with mgr is null',
' connect by prior empno = mgr',
' order siblings by ename'))
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_code_editor
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1020525824503843147)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.CODE_EDITOR'
,p_display_name=>'Code Editor'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.CODE_EDITOR'),'')
,p_api_version=>2
,p_render_function=>'wwv_flow_f4000_plugins.render_code_editor'
,p_ajax_function=>'wwv_flow_f4000_plugins.ajax_code_editor'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:SOURCE:ELEMENT:WIDTH:HEIGHT:ENCRYPT:INIT_JAVASCRIPT_CODE:SESSION_STATE_CLOB:AI_ENABLED_ALWAYS'
,p_substitute_attributes=>true
,p_reference_id=>1114646612921244845
,p_version_scn=>120171691
,p_subscribe_plugin_settings=>true
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2017616526583271)
,p_plugin_id=>wwv_flow_imp.id(1020525824503843147)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Language'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'SQL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2018083706583272)
,p_plugin_attribute_id=>wwv_flow_imp.id(2017616526583271)
,p_display_sequence=>10
,p_display_value=>'SQL'
,p_return_value=>'SQL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2018530468583272)
,p_plugin_attribute_id=>wwv_flow_imp.id(2017616526583271)
,p_display_sequence=>20
,p_display_value=>'HTML'
,p_return_value=>'HTMLMIXED'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2019084724583272)
,p_plugin_attribute_id=>wwv_flow_imp.id(2017616526583271)
,p_display_sequence=>30
,p_display_value=>'CSS'
,p_return_value=>'CSS'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2019559568583272)
,p_plugin_attribute_id=>wwv_flow_imp.id(2017616526583271)
,p_display_sequence=>40
,p_display_value=>'JavaScript'
,p_return_value=>'JAVASCRIPT'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2020087093583272)
,p_plugin_attribute_id=>wwv_flow_imp.id(2017616526583271)
,p_display_sequence=>42
,p_display_value=>'JSON'
,p_return_value=>'json'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2020578879583273)
,p_plugin_attribute_id=>wwv_flow_imp.id(2017616526583271)
,p_display_sequence=>43
,p_display_value=>'YAML'
,p_return_value=>'yaml'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2021065164583273)
,p_plugin_attribute_id=>wwv_flow_imp.id(2017616526583271)
,p_display_sequence=>45
,p_display_value=>'DDL'
,p_return_value=>'DDL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2021581225583273)
,p_plugin_attribute_id=>wwv_flow_imp.id(2017616526583271)
,p_display_sequence=>50
,p_display_value=>'PL/SQL Block'
,p_return_value=>'PLSQL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2022099585583273)
,p_plugin_attribute_id=>wwv_flow_imp.id(2017616526583271)
,p_display_sequence=>60
,p_display_value=>'PL/SQL Functions/Procedures'
,p_return_value=>'PLSQL_FUNCTIONS'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2022546038583273)
,p_plugin_attribute_id=>wwv_flow_imp.id(2017616526583271)
,p_display_sequence=>70
,p_display_value=>'PL/SQL Expression'
,p_return_value=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2023052451583274)
,p_plugin_attribute_id=>wwv_flow_imp.id(2017616526583271)
,p_display_sequence=>80
,p_display_value=>'PL/SQL Function Body'
,p_return_value=>'PLSQL_FUNCTION_BODY'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2023561323583274)
,p_plugin_attribute_id=>wwv_flow_imp.id(2017616526583271)
,p_display_sequence=>90
,p_display_value=>'Based on Page Item'
,p_return_value=>'PAGE_ITEM'
,p_help_text=>'The language will be dynamically set by the value of a Page Item.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2024050004583274)
,p_plugin_attribute_id=>wwv_flow_imp.id(2017616526583271)
,p_display_sequence=>100
,p_display_value=>'MLE - JavaScript - Module'
,p_return_value=>'mle-javascript-module'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2024550061583274)
,p_plugin_attribute_id=>wwv_flow_imp.id(2017616526583271)
,p_display_sequence=>105
,p_display_value=>'MLE - JavaScript - Snippet'
,p_return_value=>'mle-javascript-snippet'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2025051440583274)
,p_plugin_attribute_id=>wwv_flow_imp.id(2017616526583271)
,p_display_sequence=>110
,p_display_value=>'File URLs - JavaScript'
,p_return_value=>'file-urls-javascript'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2025528482583275)
,p_plugin_attribute_id=>wwv_flow_imp.id(2017616526583271)
,p_display_sequence=>120
,p_display_value=>'File URLs - CSS'
,p_return_value=>'file-urls-css'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2026013798583275)
,p_plugin_id=>wwv_flow_imp.id(1020525824503843147)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Return Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2017616526583271)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'PLSQL_EXPRESSION,PLSQL_FUNCTION_BODY'
,p_lov_type=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2026420319583275)
,p_plugin_attribute_id=>wwv_flow_imp.id(2026013798583275)
,p_display_sequence=>10
,p_display_value=>'VARCHAR2'
,p_return_value=>'VARCHAR2'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2026919981583275)
,p_plugin_attribute_id=>wwv_flow_imp.id(2026013798583275)
,p_display_sequence=>20
,p_display_value=>'BOOLEAN'
,p_return_value=>'BOOLEAN'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2027430257583275)
,p_plugin_id=>wwv_flow_imp.id(1020525824503843147)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_prompt=>'Show Query Builder'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2017616526583271)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'SQL,PAGE_ITEM'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2027846085583275)
,p_plugin_id=>wwv_flow_imp.id(1020525824503843147)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_prompt=>'Adjustable Height'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>'If Yes the user can adjust the height of the code editor.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2028298670583275)
,p_plugin_id=>wwv_flow_imp.id(1020525824503843147)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_prompt=>'Remote  Database ID item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_common=>false
,p_show_in_wizard=>false
,p_is_translatable=>false
,p_help_text=>'Specify a page item containing the remote database ID to use for code validation.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2028651661583276)
,p_plugin_id=>wwv_flow_imp.id(1020525824503843147)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>15
,p_prompt=>'Page Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2017616526583271)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGE_ITEM'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Choose a page item whose value will decide the language (mode) of the editor.</p>',
'',
'<p>An event listener will be placed on this item, so when its value changes, the editor will change accordingly.</p>',
'',
'<p>Possible values for this item are the exact language identifiers the Monaco Editor supports, such as: <code>javascript</code>, <code>html</code>, <code>css</code>, <code>json</code>, <code>sql</code> or others.</p>',
'',
'<p>Note that changing the language will not change the editor''s value, so an extra Set Value dynamic action will be required to clear the contents.</p>'))
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2029031749583276)
,p_plugin_id=>wwv_flow_imp.id(1020525824503843147)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>70
,p_prompt=>'Diff Editor'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>When in diff mode, the value is expected to be a stringified JSON of type <code>{"original":"...","modified":"..."}</code></p>',
'<p>Set the session state data type to CLOB when dealing with large values.</p>',
'<p>The original value is not editable. The modified value is editable by default, but this can be changed via the item''s Read Only flag.</p>'))
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(2126066199583334)
,p_plugin_id=>wwv_flow_imp.id(1020525824503843147)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
);
end;
/
prompt --application/shared_components/plugins/region_type/com_oracle_apex_clob_code_editor
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1041616815958164797)
,p_plugin_type=>'REGION TYPE'
,p_name=>'COM.ORACLE.APEX.CLOB_CODE_EDITOR'
,p_display_name=>'CLOB Code Editor'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','COM.ORACLE.APEX.CLOB_CODE_EDITOR'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_clob_code_editor'
,p_ajax_function=>'wwv_flow_f4000_plugins.ajax_clob_code_editor'
,p_standard_attributes=>'SOURCE_SQL:NO_DATA_FOUND_MESSAGE:INIT_JAVASCRIPT_CODE:AI_ENABLED_ALWAYS'
,p_substitute_attributes=>true
,p_reference_id=>1127739634804688041
,p_version_scn=>120172118
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2169672505587354)
,p_plugin_id=>wwv_flow_imp.id(1041616815958164797)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_static_id=>'attribute_01'
,p_prompt=>'Language'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'SQL'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2170038371587354)
,p_plugin_attribute_id=>wwv_flow_imp.id(2169672505587354)
,p_display_sequence=>10
,p_display_value=>'SQL'
,p_return_value=>'SQL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2170508216587355)
,p_plugin_attribute_id=>wwv_flow_imp.id(2169672505587354)
,p_display_sequence=>20
,p_display_value=>'HTML'
,p_return_value=>'HTMLMIXED'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2171051769587355)
,p_plugin_attribute_id=>wwv_flow_imp.id(2169672505587354)
,p_display_sequence=>30
,p_display_value=>'CSS'
,p_return_value=>'CSS'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2171550086587355)
,p_plugin_attribute_id=>wwv_flow_imp.id(2169672505587354)
,p_display_sequence=>40
,p_display_value=>'JavaScript'
,p_return_value=>'JAVASCRIPT'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2172087920587355)
,p_plugin_attribute_id=>wwv_flow_imp.id(2169672505587354)
,p_display_sequence=>42
,p_display_value=>'JSON'
,p_return_value=>'json'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2172583460587355)
,p_plugin_attribute_id=>wwv_flow_imp.id(2169672505587354)
,p_display_sequence=>45
,p_display_value=>'DDL'
,p_return_value=>'DDL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2173055415587355)
,p_plugin_attribute_id=>wwv_flow_imp.id(2169672505587354)
,p_display_sequence=>50
,p_display_value=>'PL/SQL Block'
,p_return_value=>'PLSQL'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2173598469587355)
,p_plugin_attribute_id=>wwv_flow_imp.id(2169672505587354)
,p_display_sequence=>70
,p_display_value=>'PL/SQL Expression'
,p_return_value=>'PLSQL_EXPRESSION'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2174085940587356)
,p_plugin_attribute_id=>wwv_flow_imp.id(2169672505587354)
,p_display_sequence=>80
,p_display_value=>'PL/SQL Function Body'
,p_return_value=>'PL/SQL_FUNCTION_BODY'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2174565939587356)
,p_plugin_attribute_id=>wwv_flow_imp.id(2169672505587354)
,p_display_sequence=>90
,p_display_value=>'Based on Page Item'
,p_return_value=>'PAGE_ITEM'
,p_help_text=>'The language will be dynamically set by the value of a Page Item.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2175057127587356)
,p_plugin_attribute_id=>wwv_flow_imp.id(2169672505587354)
,p_display_sequence=>100
,p_display_value=>'MLE - JavaScript - Module'
,p_return_value=>'mle-javascript-module'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2175524630587356)
,p_plugin_attribute_id=>wwv_flow_imp.id(2169672505587354)
,p_display_sequence=>110
,p_display_value=>'MLE - JavaScript - Snippet'
,p_return_value=>'mle-javascript-snippet'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2176036952587356)
,p_plugin_id=>wwv_flow_imp.id(1041616815958164797)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_static_id=>'attribute_02'
,p_prompt=>'Height'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2176425551587356)
,p_plugin_attribute_id=>wwv_flow_imp.id(2176036952587356)
,p_display_sequence=>1
,p_display_value=>'5'
,p_return_value=>'5'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2176951505587357)
,p_plugin_attribute_id=>wwv_flow_imp.id(2176036952587356)
,p_display_sequence=>2
,p_display_value=>'10'
,p_return_value=>'10'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2177459586587357)
,p_plugin_attribute_id=>wwv_flow_imp.id(2176036952587356)
,p_display_sequence=>3
,p_display_value=>'20'
,p_return_value=>'20'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2177938319587357)
,p_plugin_attribute_id=>wwv_flow_imp.id(2176036952587356)
,p_display_sequence=>10
,p_display_value=>'30'
,p_return_value=>'30'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2178450864587357)
,p_plugin_attribute_id=>wwv_flow_imp.id(2176036952587356)
,p_display_sequence=>20
,p_display_value=>'60'
,p_return_value=>'60'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2178901108587357)
,p_plugin_attribute_id=>wwv_flow_imp.id(2176036952587356)
,p_display_sequence=>25
,p_display_value=>'80'
,p_return_value=>'80'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2179462339587357)
,p_plugin_attribute_id=>wwv_flow_imp.id(2176036952587356)
,p_display_sequence=>30
,p_display_value=>'Automatic'
,p_return_value=>'AUTO'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2179906338587358)
,p_plugin_id=>wwv_flow_imp.id(1041616815958164797)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_static_id=>'attribute_03'
,p_prompt=>'Read Only'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'N'
,p_is_translatable=>false
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2180395545587358)
,p_plugin_id=>wwv_flow_imp.id(1041616815958164797)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>15
,p_static_id=>'attribute_04'
,p_prompt=>'Return Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2169672505587354)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'PLSQL_EXPRESSION,PLSQL_FUNCTION_BODY'
,p_lov_type=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2180760271587358)
,p_plugin_attribute_id=>wwv_flow_imp.id(2180395545587358)
,p_display_sequence=>10
,p_display_value=>'VARCHAR2'
,p_return_value=>'VARCHAR2'
,p_help_text=>'VARCHAR2'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(2181283390587358)
,p_plugin_attribute_id=>wwv_flow_imp.id(2180395545587358)
,p_display_sequence=>20
,p_display_value=>'BOOLEAN'
,p_return_value=>'BOOLEAN'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2181747400587358)
,p_plugin_id=>wwv_flow_imp.id(1041616815958164797)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_static_id=>'attribute_05'
,p_prompt=>'Remote Database ID item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>false
,p_is_common=>false
,p_is_translatable=>false
,p_help_text=>'Specify the an item containing the ID of the remote database to use for code validation.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(2182117940587359)
,p_plugin_id=>wwv_flow_imp.id(1041616815958164797)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>15
,p_static_id=>'attribute_06'
,p_prompt=>'Page Item'
,p_attribute_type=>'PAGE ITEM'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(2169672505587354)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'PAGE_ITEM'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Choose a page item whose value will decide the language (mode) of the editor.</p>',
'<p>An event listener will further be placed on this item, so that when its value changes, the editor will change accordingly.</p>',
'<p>Possible values for this item are the exact language identifiers the Monaco Editor supports, such as: <code>javascript</code>, <code>html</code>, <code>css</code>, <code>json</code>, <code>sql</code> or others.</p>',
'<p>Note that changing the language will not change the editor''s value, so an extra Set Value dynamic action will be required to clear the contents.</p>'))
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(2185410606587362)
,p_plugin_id=>wwv_flow_imp.id(1041616815958164797)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(2185811484587362)
,p_plugin_id=>wwv_flow_imp.id(1041616815958164797)
,p_name=>'SOURCE_SQL'
,p_is_required=>false
,p_sql_min_column_count=>1
,p_sql_max_column_count=>1
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select clob_content',
'from demo_scripts'))
);
end;
/
prompt --application/shared_components/plugins/dynamic_action/com_oracle_apex_add_checkall_checkbox
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1198924687353295733)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
,p_display_name=>'Add Check All Checkbox'
,p_category=>'MISC'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('DYNAMIC ACTION','COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_add_check_all_checkbox'
,p_standard_attributes=>'ONLOAD'
,p_substitute_attributes=>true
,p_reference_id=>1223290239742970512
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The "Add Check All Checkbox" dynamic action turns a column heading containing the #CHECK_ALL_CHECKBOX# string into an accessible check all style checkbox, that will check and uncheck all the checkboxes in its corresponding column.<p>',
'<p>',
'To use this plug-in, please ensure the following attributes are set:',
'<ol>',
'<li>In the report column, defined ''#CHECK_ALL_CHECKBOX#'' as the Heading value.</li>',
'<li>For the Dynamic Action When attribute, select the report region containing the column.</li>',
'<li>Define the Dynamic Action to fire ''After Refresh'', and the Action to ''Fire on Page Load''. (Both will default appropriately if the Dynamic Action is created by selecting the region in the ''Rendering'' section of Page Designer and creating the Dynam'
||'ic Action from there.</li>',
'<li>This will not handle the accessibility of the checkboxes rendered on each row, this must be done separately in the region source. (See 4000:656 ''Regions'' region for an example).</li>',
'</ol>',
'</p>'))
,p_version_identifier=>'1.0'
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_group_select_list
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(1484532036002681868)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.GROUP_SELECT_LIST'
,p_display_name=>'Group Select List'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.GROUP_SELECT_LIST'),'')
,p_plsql_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- The render procedure is responsible for the rendering of the actual HTML control',
'-- of the new widget. APEX still takes care of the table cell for the layout,',
'-- the label, pre- and post element text. Only the html code between the pre- and',
'-- post element text is rendered by the plug-in. The render procedure has a',
'-- defined interface which every plug-in has to implement. It''s designed in a way',
'-- that future enhancements to the interface will not break existing plug-ins.',
'function render_group_selectlist (',
'    p_item                in wwv_flow_plugin_api.t_page_item,',
'    p_plugin              in wwv_flow_plugin_api.t_plugin,',
'    p_value               in varchar2,',
'    p_is_readonly         in boolean,',
'    p_is_printer_friendly in boolean )',
'    return wwv_flow_plugin_api.t_page_item_render_result',
'is',
'    -- value without the lov null value',
'    l_value             varchar2(32767) := case when p_value = p_item.lov_null_value then null else p_value end;',
'',
'    l_name              varchar2(30);',
'    l_display_value     varchar2(32767);',
'    l_is_selected       boolean := false;',
'    l_value_found       boolean := false;',
'    l_column_value_list wwv_flow_plugin_util.t_column_value_list;',
'    l_group_value       varchar2(4000);',
'    l_last_group_value  varchar2(4000);',
'    l_open_group        boolean := false;',
'    l_result            wwv_flow_plugin_api.t_page_item_render_result;',
'    ',
'    procedure print_option_local (',
'        p_display_value in varchar2,',
'        p_return_value  in varchar2,',
'        p_compare_value in varchar2 )',
'    is',
'        l_is_selected boolean := false;',
'    begin',
'        if not l_value_found and',
'           (  p_return_value = p_compare_value',
'           or p_return_value is null and p_compare_value is null',
'           )',
'        then',
'            l_value_found := true;',
'            l_is_selected := true;',
'        end if;',
'        -- add list entry',
'        wwv_flow_plugin_util.print_option (',
'            p_display_value => p_display_value,',
'            p_return_value  => p_return_value,',
'            p_is_selected   => l_is_selected,',
'            p_attributes    => p_item.element_option_attributes );',
'    end print_option_local;',
'begin',
'    -- During plug-in development it''s very helpful to have some debug information',
'    if wwv_flow.g_debug then',
'        wwv_flow_plugin_util.debug_page_item (',
'            p_plugin              => p_plugin,',
'            p_page_item           => p_item,',
'            p_value               => p_value,',
'            p_is_readonly         => p_is_readonly,',
'            p_is_printer_friendly => p_is_printer_friendly );',
'    end if;',
'',
'    -- Based on the flags we normally generate different HTML code, but that',
'    -- depends on the plug-in.',
'    if p_is_readonly or p_is_printer_friendly then',
'        wwv_flow_plugin_util.print_hidden_if_readonly (',
'            p_item_name           => p_item.name,',
'            p_value               => p_value,',
'            p_is_readonly         => p_is_readonly,',
'            p_is_printer_friendly => p_is_printer_friendly );',
'',
'        -- get the display value',
'        l_display_value := wwv_flow_plugin_util.get_display_data (',
'                               p_sql_statement     => p_item.lov_definition,',
'                               p_min_columns       => 3, -- LOV requires 3 column',
'                               p_max_columns       => 3,',
'                               p_component_name    => p_item.name,',
'                               p_display_column_no => 1,',
'                               p_search_column_no  => 2,',
'                               p_search_string     => l_value,',
'                               p_display_extra     => p_item.lov_display_extra );',
'',
'        -- emit display span with the value',
'        wwv_flow_plugin_util.print_display_only (',
'            p_item_name        => p_item.name,',
'            p_display_value    => l_display_value,',
'            p_show_line_breaks => false,',
'            p_escape           => true,',
'            p_attributes       => p_item.element_attributes );',
'    else',
'        -- If a page item saves state, we have to call the get_input_name_for_page_item',
'        -- to render the internal hidden p_arg_names field. It will also return the',
'        -- HTML field name which we have to use when we render the HTML input field.',
'        l_name := wwv_flow_plugin_api.get_input_name_for_page_item(false);',
'        sys.htp.prn(''<select name="''||l_name||''" id="''||p_item.name||''" ''||',
'                  coalesce(p_item.element_attributes, ''class="group_selectlist"'')||''>'');',
'',
'        -- add display null entry',
'        if p_item.lov_display_null then',
'            --wwv_flow_utilities.add_null_value_entry(''ITEM'', l_name, p_item.lov_null_value);',
'            -- add list entry',
'            print_option_local (',
'                    p_display_value => p_item.lov_null_text,',
'                    p_return_value  => p_item.lov_null_value,',
'                    p_compare_value => nvl(l_value, p_item.lov_null_value) );',
'        end if;',
'',
'        -- get all values',
'        l_column_value_list := wwv_flow_plugin_util.get_data (',
'                                   p_sql_statement      => p_item.lov_definition,',
'                                   p_min_columns        => 3,',
'                                   p_max_columns        => 3,',
'                                   p_component_name     => p_item.name );',
'',
'        -- loop through the result',
'        for i in 1 .. l_column_value_list(1).count /* display value */',
'        loop',
'            l_group_value := l_column_value_list(3)(i); /* group column */',
'            -- has the group changed?',
'            if (l_group_value <> l_last_group_value) or',
'               (l_group_value is     null and l_last_group_value is not null) or',
'               (l_group_value is not null and l_last_group_value is     null)',
'            then',
'                if l_open_group then',
'                    sys.htp.p(''</optgroup>'');',
'                    l_open_group := false;',
'                end if;',
'                if l_group_value is not null then',
'                    sys.htp.p (''<optgroup label="''||wwv_flow_escape.html(l_group_value)||''">'');',
'                    l_open_group := true;',
'                end if;',
'                l_last_group_value := l_group_value;',
'            end if;',
'            -- add list entry',
'            print_option_local (',
'                p_display_value => l_column_value_list(1)(i),',
'                p_return_value  => l_column_value_list(2)(i),',
'                p_compare_value => l_value );',
'        end loop;',
'',
'        if l_open_group then',
'            sys.htp.p(''</optgroup>'');',
'        end if;',
'        -- Show at least the value if it hasn''t been found in the database',
'        if not l_value_found and l_value is not null and p_item.lov_display_extra then',
'            print_option_local (',
'                p_display_value => l_value,',
'                p_return_value  => l_value,',
'                p_compare_value => l_value );',
'        end if;',
'        -- close our select list',
'        sys.htp.p(''</select>'');',
'       ',
'        wwv_flow_javascript.add_onload_code (',
'            p_code => ''apex.builder.plugin.groupSelectList(''||',
'                wwv_flow_javascript.add_value(''#''||p_item.name)||',
'                ''{''||',
'                wwv_flow_javascript.add_attribute(''nullValue'',      p_item.lov_null_value, false, false)||',
'                ''});'' );',
'        ',
'        -- Tell APEX that this field is navigable',
'        l_result.is_navigable := true;',
'    end if;',
'    return l_result;',
'end render_group_selectlist;'))
,p_api_version=>1
,p_render_function=>'render_group_selectlist'
,p_standard_attributes=>'VISIBLE:FORM_ELEMENT:SESSION_STATE:READONLY:QUICKPICK:SOURCE:ELEMENT:HEIGHT:ELEMENT_OPTION:ENCRYPT:LOV:LOV_DISPLAY_NULL'
,p_substitute_attributes=>true
,p_version_scn=>72475517
,p_subscribe_plugin_settings=>true
,p_version_identifier=>'1.0'
,p_about_url=>'http://www.oracleapex.info/'
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(845155281774834521)
,p_plugin_id=>wwv_flow_imp.id(1484532036002681868)
,p_name=>'LOV'
,p_sql_min_column_count=>3
,p_sql_max_column_count=>3
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'select e.ename as d,',
'       e.empno as r,',
'       d.dname as grp',
'  from emp e,',
'       dept d',
' where d.deptno = e.deptno',
' order by d.dname, e.ename',
'</pre>'))
);
end;
/
prompt --application/shared_components/plugins/item_type/com_oracle_apex_wizard_selection
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(3260301366184169092)
,p_plugin_type=>'ITEM TYPE'
,p_name=>'COM.ORACLE.APEX.WIZARD_SELECTION'
,p_display_name=>'Wizard Selection'
,p_supported_component_types=>'APEX_APPLICATION_PAGE_ITEMS'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('ITEM TYPE','COM.ORACLE.APEX.WIZARD_SELECTION'),'')
,p_api_version=>1
,p_render_function=>'wwv_flow_f4000_plugins.render_wizard_selection'
,p_ajax_function=>'wwv_flow_f4000_plugins.ajax_wizard_selection'
,p_standard_attributes=>'VISIBLE:SESSION_STATE:SOURCE:ELEMENT:LOV:CASCADING_LOV'
,p_substitute_attributes=>true
,p_version_scn=>72475535
,p_subscribe_plugin_settings=>true
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(369043407812412665)
,p_plugin_id=>wwv_flow_imp.id(3260301366184169092)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_prompt=>'Icon Size'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'S'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(369044006087413465)
,p_plugin_attribute_id=>wwv_flow_imp.id(369043407812412665)
,p_display_sequence=>10
,p_display_value=>'Small'
,p_return_value=>'S'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(369044404793414074)
,p_plugin_attribute_id=>wwv_flow_imp.id(369043407812412665)
,p_display_sequence=>20
,p_display_value=>'Medium'
,p_return_value=>'M'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(369044803715414606)
,p_plugin_attribute_id=>wwv_flow_imp.id(369043407812412665)
,p_display_sequence=>30
,p_display_value=>'Large'
,p_return_value=>'L'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(452918641523598191)
,p_plugin_id=>wwv_flow_imp.id(3260301366184169092)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_prompt=>'Submit Page'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_help_text=>'Select whether or not to submit the page when making a selection'
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(845155356484834522)
,p_plugin_id=>wwv_flow_imp.id(3260301366184169092)
,p_name=>'LOV'
,p_sql_min_column_count=>2
,p_sql_max_column_count=>2
);
end;
/
prompt --application/shared_components/plugins/region_type/com_oracle_apex_html5_bar_chart
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(3347174819831483585)
,p_plugin_type=>'REGION TYPE'
,p_name=>'COM.ORACLE.APEX.HTML5_BAR_CHART'
,p_display_name=>'HTML 5 Bar Chart ***'
,p_image_prefix => nvl(wwv_flow_application_install.get_static_plugin_file_prefix('REGION TYPE','COM.ORACLE.APEX.HTML5_BAR_CHART'),'#IMAGE_PREFIX#plugins/com.oracle.apex.html5_bar_chart/1.0/')
,p_javascript_file_urls=>'#PLUGIN_FILES#com_oracle_apex_html5_bar_chart.js'
,p_css_file_urls=>'#PLUGIN_FILES#com_oracle_apex_html5_bar_chart.css'
,p_plsql_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'FUNCTION RENDER (',
'    P_REGION IN WWV_FLOW_PLUGIN_API.T_REGION,',
'    P_PLUGIN IN WWV_FLOW_PLUGIN_API.T_PLUGIN,',
'    P_IS_PRINTER_FRIENDLY IN BOOLEAN',
') RETURN WWV_FLOW_PLUGIN_API.T_REGION_RENDER_RESULT IS',
'BEGIN',
'    sys.HTP.PRN(''<div id="''||WWV_FLOW_ESCAPE.HTML_ATTRIBUTE(P_REGION.STATIC_ID)||''_chart" class="hbc">'');',
'    sys.HTP.PRN(''</div>'');',
'    ',
'    WWV_FLOW_JAVASCRIPT_API.ADD_ONLOAD_CODE (',
'        P_CODE => ''com_oracle_apex_html5_bar_chart(''||',
'            WWV_FLOW_JAVASCRIPT_API.ADD_VALUE(P_REGION.STATIC_ID)||',
'            ''{''||',
'                -- Why is this attribute needed if is not used?',
'                WWV_FLOW_JAVASCRIPT_API.ADD_ATTRIBUTE(',
'                    ''pageItems'', ',
'                    WWV_FLOW_PLUGIN_UTIL.PAGE_ITEM_NAMES_TO_JQUERY(P_REGION.AJAX_ITEMS_TO_SUBMIT)',
'                )||',
'                WWV_FLOW_JAVASCRIPT_API.ADD_ATTRIBUTE(',
'                    ''ajaxIdentifier'', ',
'                    WWV_FLOW_PLUGIN_API.GET_AJAX_IDENTIFIER, ',
'                    FALSE, ',
'                    FALSE',
'                )||',
'            ''}''||',
'        '');''',
'    );',
'    ',
'    RETURN NULL;',
'END RENDER;',
'',
'FUNCTION AJAX (',
'    P_REGION IN WWV_FLOW_PLUGIN_API.T_REGION,',
'    P_PLUGIN IN WWV_FLOW_PLUGIN_API.T_PLUGIN',
') RETURN WWV_FLOW_PLUGIN_API.T_REGION_AJAX_RESULT IS',
'    -- Map region attributes to function constants',
'    -- MODERN, CLASSIC',
'    C_CHART_TYPE CONSTANT VARCHAR2(7) := P_REGION.ATTRIBUTE_15;',
'    -- MODERN, MODERN_2, SOLAR, METRO, CUSTOM, COLUMN',
'    C_COLOR_SCHEME CONSTANT VARCHAR2(8) := P_REGION.ATTRIBUTE_17;',
'    C_CUSTOM_CHART_COLORS CONSTANT VARCHAR2(4000) := P_REGION.ATTRIBUTE_10;',
'    C_COLOR_COLUMN CONSTANT VARCHAR2(255) := P_REGION.ATTRIBUTE_19;',
'    -- NONE, IMAGE, ICON, INITIALS',
'    C_ICON_TYPE CONSTANT VARCHAR2(8) := case when C_CHART_TYPE = ''ICON'' then P_REGION.ATTRIBUTE_01 end;',
'    C_LABEL_COLUMN CONSTANT VARCHAR2(255) := P_REGION.ATTRIBUTE_02;',
'    C_LABEL_LINK CONSTANT VARCHAR2(255) := P_REGION.ATTRIBUTE_03;',
'    C_VALUE_COLUMN CONSTANT VARCHAR2(255) := P_REGION.ATTRIBUTE_04;',
'    C_VALUE_LINK CONSTANT VARCHAR2(255) := P_REGION.ATTRIBUTE_05;',
'    -- ABOVE, AROUND',
'    C_TEXT_POSITION VARCHAR2(6) := P_REGION.ATTRIBUTE_18;',
'    C_CHART_CSS_CLASSES CONSTANT VARCHAR2(32767) := P_REGION.ATTRIBUTE_06;',
'    C_IMAGE_URL CONSTANT VARCHAR2(4000) := P_REGION.ATTRIBUTE_07;',
'    C_CSS_ICON_CLASS_NAME CONSTANT VARCHAR2(255) := P_REGION.ATTRIBUTE_08;',
'    C_INITIALS_COLUMN CONSTANT VARCHAR2(255) := P_REGION.ATTRIBUTE_09;',
'    -- ABSOLUTE, RELATIVE',
'    C_BAR_WIDTH_CALCULATION CONSTANT VARCHAR2(8) := P_REGION.ATTRIBUTE_16;',
'    C_DISPLAY CONSTANT VARCHAR2(19) := P_REGION.ATTRIBUTE_11;',
'    C_PREFIX_FOR_VALUE CONSTANT VARCHAR2(4000) := P_REGION.ATTRIBUTE_12;',
'    C_POSTFIX_FOR_VALUE CONSTANT VARCHAR2(4000) := P_REGION.ATTRIBUTE_13;',
'    C_MAXIMUM_ROWS CONSTANT NUMBER := P_REGION.ATTRIBUTE_14;',
'    C_MESSAGE_WHEN_NO_DATA_FOUND CONSTANT VARCHAR2(4000) := P_REGION.ATTRIBUTE_20;',
'    ',
'    L_COLOR_COLUMN_NUMBER PLS_INTEGER;',
'    L_LABEL_COLUMN_NUMBER PLS_INTEGER;',
'    L_VALUE_COLUMN_NUMBER PLS_INTEGER;',
'    L_INITIALS_COLUMN_NUMBER PLS_INTEGER;',
'    ',
'    L_COLUMN_VALUE_LIST WWV_FLOW_PLUGIN_UTIL.T_COLUMN_VALUE_LIST2;',
'    ',
'    L_COLOR VARCHAR2(4000) := NULL;',
'    L_LABEL VARCHAR2(4000) := NULL;',
'    L_LABEL_LINK VARCHAR2(4000) := NULL;',
'    L_VALUE VARCHAR2(4000) := NULL;',
'    L_VALUE_LINK VARCHAR2(4000) := NULL;',
'    L_IMAGE_URL VARCHAR2(4000) := NULL;',
'    L_CSS_ICON_CLASS_NAME VARCHAR2(4000) := NULL;',
'    L_INITIALS VARCHAR2(4000) := NULL;',
'    L_MESSAGE_WHEN_NO_DATA_FOUND VARCHAR2(4000) := NULL;',
'',
'    L_CUSTOM_CHART_COLORS_TABLE WWV_FLOW_GLOBAL.VC_ARR2;',
'    L_CUSTOM_CHART_COLORS VARCHAR2(32767) := NULL;',
'BEGIN',
'    L_COLUMN_VALUE_LIST := WWV_FLOW_PLUGIN_UTIL.GET_DATA2(',
'        P_SQL_STATEMENT  => P_REGION.SOURCE,',
'        P_MIN_COLUMNS    => 1,',
'        P_MAX_COLUMNS    => NULL,',
'        P_COMPONENT_NAME => P_REGION.NAME,',
'        P_MAX_ROWS => C_MAXIMUM_ROWS',
'    );',
'',
'    L_COLOR_COLUMN_NUMBER := WWV_FLOW_PLUGIN_UTIL.GET_COLUMN_NO (',
'        P_ATTRIBUTE_LABEL   => ''Color Column'',',
'        P_COLUMN_ALIAS      => C_COLOR_COLUMN,',
'        P_COLUMN_VALUE_LIST => L_COLUMN_VALUE_LIST,',
'        P_IS_REQUIRED       => C_COLOR_SCHEME = ''COLUMN'',',
'        P_DATA_TYPE         => WWV_FLOW_PLUGIN_UTIL.C_DATA_TYPE_VARCHAR2',
'    );',
'    L_LABEL_COLUMN_NUMBER := WWV_FLOW_PLUGIN_UTIL.GET_COLUMN_NO (',
'        P_ATTRIBUTE_LABEL   => ''Label Column'',',
'        P_COLUMN_ALIAS      => C_LABEL_COLUMN,',
'        P_COLUMN_VALUE_LIST => L_COLUMN_VALUE_LIST,',
'        P_IS_REQUIRED       => TRUE,',
'        P_DATA_TYPE         => WWV_FLOW_PLUGIN_UTIL.C_DATA_TYPE_VARCHAR2',
'    );',
'    L_VALUE_COLUMN_NUMBER := WWV_FLOW_PLUGIN_UTIL.GET_COLUMN_NO (',
'        P_ATTRIBUTE_LABEL   => ''Value Column'',',
'        P_COLUMN_ALIAS      => C_VALUE_COLUMN,',
'        P_COLUMN_VALUE_LIST => L_COLUMN_VALUE_LIST,',
'        P_IS_REQUIRED       => TRUE,',
'        P_DATA_TYPE         => WWV_FLOW_PLUGIN_UTIL.C_DATA_TYPE_VARCHAR2',
'    );',
'    if C_ICON_TYPE = ''INITIALS'' then',
'        L_INITIALS_COLUMN_NUMBER := WWV_FLOW_PLUGIN_UTIL.GET_COLUMN_NO (',
'            P_ATTRIBUTE_LABEL   => ''Initials Column'',',
'            P_COLUMN_ALIAS      => C_INITIALS_COLUMN,',
'            P_COLUMN_VALUE_LIST => L_COLUMN_VALUE_LIST,',
'            P_IS_REQUIRED       => true,',
'            P_DATA_TYPE         => WWV_FLOW_PLUGIN_UTIL.C_DATA_TYPE_VARCHAR2',
'        );',
'    end if;',
'    -- Begin output as JSON',
'    sys.OWA_UTIL.MIME_HEADER(''application/json'', FALSE);',
'    sys.HTP.P(''Cache-Control: no-cache'');',
'    sys.HTP.P(''Pragma: no-cache'');',
'    sys.OWA_UTIL.HTTP_HEADER_CLOSE;',
'    ',
'    IF C_COLOR_SCHEME = ''CUSTOM'' THEN',
'        L_CUSTOM_CHART_COLORS_TABLE := HTMLDB_UTIL.STRING_TO_TABLE(CASE WHEN C_CUSTOM_CHART_COLORS IS NOT NULL THEN TRIM(BOTH '''''''' FROM WWV_FLOW_ESCAPE.JS_LITERAL(C_CUSTOM_CHART_COLORS)) END, '':'');',
'        L_CUSTOM_CHART_COLORS := ''"color_scheme":['';',
'        FOR I IN L_CUSTOM_CHART_COLORS_TABLE.FIRST .. L_CUSTOM_CHART_COLORS_TABLE.LAST LOOP',
'            IF I > 1 THEN',
'                L_CUSTOM_CHART_COLORS := L_CUSTOM_CHART_COLORS||'','';',
'            END IF;',
'            L_CUSTOM_CHART_COLORS := L_CUSTOM_CHART_COLORS||''"''||L_CUSTOM_CHART_COLORS_TABLE(I)||''"'';',
'        END LOOP;',
'        L_CUSTOM_CHART_COLORS := L_CUSTOM_CHART_COLORS||''],'';',
'    END IF;',
'',
'    L_MESSAGE_WHEN_NO_DATA_FOUND := WWV_FLOW_ESCAPE.HTML_WHITELIST(',
'        WWV_FLOW_PLUGIN_UTIL.REPLACE_SUBSTITUTIONS (',
'                P_VALUE  => C_MESSAGE_WHEN_NO_DATA_FOUND,',
'                P_ESCAPE => FALSE',
'            )',
'        );',
'',
'    sys.HTP.PRN(',
'        ''{''||',
'            WWV_FLOW_JAVASCRIPT_API.ADD_ATTRIBUTE (',
'                ''chart_type'',',
'                C_CHART_TYPE,',
'                FALSE,',
'                TRUE',
'            )',
'    );',
'    sys.HTP.PRN(',
'        WWV_FLOW_JAVASCRIPT_API.ADD_ATTRIBUTE (',
'            ''message_when_no_data_found'',',
'            L_MESSAGE_WHEN_NO_DATA_FOUND,',
'            TRUE,',
'            TRUE',
'        )',
'    );',
'    sys.HTP.PRN(',
'        WWV_FLOW_JAVASCRIPT_API.ADD_ATTRIBUTE (',
'            ''chart_css_class_names'',',
'            C_CHART_CSS_CLASSES,',
'            TRUE,',
'            TRUE',
'        )',
'    );',
'    sys.HTP.PRN(',
'        WWV_FLOW_JAVASCRIPT_API.ADD_ATTRIBUTE (',
'            ''icon_type'',',
'            C_ICON_TYPE,',
'            TRUE,',
'            TRUE',
'        )',
'    );',
'    IF C_COLOR_SCHEME = ''CUSTOM'' THEN',
'        sys.HTP.PRN(',
'            L_CUSTOM_CHART_COLORS',
'        );',
'    ELSE',
'        sys.HTP.PRN(',
'            WWV_FLOW_JAVASCRIPT_API.ADD_ATTRIBUTE (',
'                ''color_scheme'',',
'                C_COLOR_SCHEME,',
'                TRUE,',
'                TRUE',
'            )',
'        );',
'    END IF;',
'    sys.HTP.PRN(',
'            WWV_FLOW_JAVASCRIPT_API.ADD_ATTRIBUTE (',
'                ''text_position'',',
'                C_TEXT_POSITION,',
'                FALSE,',
'                TRUE',
'            )||',
'            WWV_FLOW_JAVASCRIPT_API.ADD_ATTRIBUTE (',
'                ''bar_width_calculation'',',
'                C_BAR_WIDTH_CALCULATION,',
'                FALSE,',
'                TRUE',
'            )||',
'            WWV_FLOW_JAVASCRIPT_API.ADD_ATTRIBUTE (',
'                ''display'',',
'                C_DISPLAY,',
'                FALSE,',
'                TRUE',
'            )||',
'            CASE ',
'            	WHEN C_DISPLAY IN (''VALUE'') THEN',
'					WWV_FLOW_JAVASCRIPT_API.ADD_ATTRIBUTE (',
'						''prefix_for_value'',',
'						C_PREFIX_FOR_VALUE,',
'						TRUE,',
'						TRUE',
'					)||',
'					WWV_FLOW_JAVASCRIPT_API.ADD_ATTRIBUTE (',
'						''postfix_for_value'',',
'						C_POSTFIX_FOR_VALUE,',
'						TRUE,',
'						TRUE',
'					)',
'			END||',
'            ''"items":[''',
'    );',
'    ',
'    --FOR L_ROW_NUMBER IN L_COLUMN_VALUE_LIST(1).VALUE_LIST.FIRST .. L_COLUMN_VALUE_LIST(1).VALUE_LIST.LAST LOOP',
'    FOR L_ROW_NUMBER IN 1 .. L_COLUMN_VALUE_LIST(1).VALUE_LIST.COUNT LOOP',
'        BEGIN',
'            WWV_FLOW_PLUGIN_UTIL.SET_COMPONENT_VALUES (',
'                P_COLUMN_VALUE_LIST => L_COLUMN_VALUE_LIST,',
'                P_ROW_NUM => L_ROW_NUMBER ',
'            );',
'            ',
'            IF L_ROW_NUMBER > 1 THEN',
'            	sys.HTP.PRN('', '');',
'            END IF;',
'            ',
'            sys.HTP.PRN(''{'');',
'            ',
'            L_LABEL := WWV_FLOW_PLUGIN_UTIL.ESCAPE (',
'                WWV_FLOW_PLUGIN_UTIL.GET_VALUE_AS_VARCHAR2 (',
'                    P_DATA_TYPE => L_COLUMN_VALUE_LIST(L_LABEL_COLUMN_NUMBER).DATA_TYPE,',
'                    P_VALUE => L_COLUMN_VALUE_LIST(L_LABEL_COLUMN_NUMBER).VALUE_LIST(L_ROW_NUMBER)',
'                ),',
'                P_REGION.ESCAPE_OUTPUT',
'            );',
'            sys.HTP.PRN(',
'            	WWV_FLOW_JAVASCRIPT_API.ADD_ATTRIBUTE (',
'                    ''label'',',
'                    L_LABEL,',
'                    FALSE',
'            	)',
'            );',
'            L_LABEL_LINK := ',
'                CASE ',
'                    WHEN C_LABEL_LINK IS NOT NULL THEN ',
'                        HTMLDB_UTIL.PREPARE_URL (',
'                            WWV_FLOW_PLUGIN_UTIL.REPLACE_SUBSTITUTIONS (',
'                                P_VALUE  => C_LABEL_LINK,',
'                                P_ESCAPE => FALSE',
'                            )',
'                        )',
'                END;',
'            sys.HTP.PRN(',
'            	WWV_FLOW_JAVASCRIPT_API.ADD_ATTRIBUTE (',
'                    ''label_link'',',
'                    L_LABEL_LINK',
'                )',
'            );',
'            L_VALUE := WWV_FLOW_PLUGIN_UTIL.ESCAPE (',
'               WWV_FLOW_PLUGIN_UTIL.GET_VALUE_AS_VARCHAR2 (',
'                   P_DATA_TYPE => L_COLUMN_VALUE_LIST(L_VALUE_COLUMN_NUMBER).DATA_TYPE,',
'                   P_VALUE => L_COLUMN_VALUE_LIST(L_VALUE_COLUMN_NUMBER).VALUE_LIST(L_ROW_NUMBER)',
'               ),',
'               P_REGION.ESCAPE_OUTPUT',
'            );',
'            sys.HTP.PRN(',
'            	WWV_FLOW_JAVASCRIPT_API.ADD_ATTRIBUTE (',
'                    ''value'',',
'                    L_VALUE,',
'                    FALSE,',
'                    C_VALUE_LINK IS NOT NULL OR L_COLOR_COLUMN_NUMBER IS NOT NULL OR C_CHART_TYPE = ''ICON''',
'                )',
'            );',
'            L_VALUE_LINK := ',
'                CASE ',
'                    WHEN C_VALUE_LINK IS NOT NULL THEN ',
'                        HTMLDB_UTIL.PREPARE_URL (',
'                            WWV_FLOW_PLUGIN_UTIL.REPLACE_SUBSTITUTIONS (',
'                                P_VALUE  => C_VALUE_LINK,',
'                                P_ESCAPE => FALSE',
'                            )',
'                        )',
'                END;',
'             sys.HTP.PRN(',
'            	WWV_FLOW_JAVASCRIPT_API.ADD_ATTRIBUTE (',
'                    ''value_link'',',
'                    L_VALUE_LINK,',
'                    TRUE,',
'                    L_COLOR_COLUMN_NUMBER IS NOT NULL OR C_CHART_TYPE = ''ICON''',
'                )',
'            );',
'            IF L_COLOR_COLUMN_NUMBER IS NOT NULL THEN',
'                L_COLOR := WWV_FLOW_PLUGIN_UTIL.ESCAPE (',
'                   WWV_FLOW_PLUGIN_UTIL.GET_VALUE_AS_VARCHAR2 (',
'                       P_DATA_TYPE => L_COLUMN_VALUE_LIST(L_COLOR_COLUMN_NUMBER).DATA_TYPE,',
'                       P_VALUE => L_COLUMN_VALUE_LIST(L_COLOR_COLUMN_NUMBER).VALUE_LIST(L_ROW_NUMBER)',
'                   ),',
'                   P_REGION.ESCAPE_OUTPUT',
'                );',
'                sys.HTP.PRN(',
'                    WWV_FLOW_JAVASCRIPT_API.ADD_ATTRIBUTE (',
'                        ''color'',',
'                        L_COLOR,',
'                        FALSE,',
'                        C_CHART_TYPE = ''ICON''',
'                    )',
'                );',
'            END IF;',
'            IF C_ICON_TYPE = ''IMAGE'' THEN',
'				L_IMAGE_URL := ',
'                    CASE ',
'                        WHEN C_IMAGE_URL IS NOT NULL THEN ',
'                            HTMLDB_UTIL.PREPARE_URL (',
'                                WWV_FLOW_PLUGIN_UTIL.REPLACE_SUBSTITUTIONS (',
'                                    P_VALUE  => C_IMAGE_URL,',
'                                    P_ESCAPE => FALSE',
'                                )',
'                            )',
'                    END;',
'				sys.HTP.PRN(',
'					WWV_FLOW_JAVASCRIPT_API.ADD_ATTRIBUTE (',
'						''image_url'',',
'						L_IMAGE_URL,',
'						FALSE,',
'						FALSE',
'					)',
'				);',
'			ELSIF C_ICON_TYPE = ''ICON'' THEN',
'				L_CSS_ICON_CLASS_NAME := WWV_FLOW_PLUGIN_UTIL.REPLACE_SUBSTITUTIONS (',
'                    P_VALUE  => C_CSS_ICON_CLASS_NAME,',
'                    P_ESCAPE => TRUE',
'                );',
'				sys.HTP.PRN(',
'                	WWV_FLOW_JAVASCRIPT_API.ADD_ATTRIBUTE (',
'						''icon_css_class_name'',',
'						L_CSS_ICON_CLASS_NAME,',
'						FALSE,',
'						FALSE',
'					)',
'				);',
'			ELSIF C_ICON_TYPE = ''INITIALS'' THEN',
'				L_INITIALS := WWV_FLOW_PLUGIN_UTIL.ESCAPE (',
'					WWV_FLOW_PLUGIN_UTIL.GET_VALUE_AS_VARCHAR2 (',
'						P_DATA_TYPE => L_COLUMN_VALUE_LIST(L_INITIALS_COLUMN_NUMBER).DATA_TYPE,',
'						P_VALUE => L_COLUMN_VALUE_LIST(L_INITIALS_COLUMN_NUMBER).VALUE_LIST(L_ROW_NUMBER)',
'					),',
'					P_REGION.ESCAPE_OUTPUT',
'				);',
'				sys.HTP.PRN(',
'                	WWV_FLOW_JAVASCRIPT_API.ADD_ATTRIBUTE (',
'                    	''initials'',',
'	                    L_INITIALS,',
'	                    FALSE,',
'	                    FALSE',
'    	            )',
'    	        );',
'            END IF;',
'            ',
'			sys.HTP.PRN(''}'');',
'            ',
'            WWV_FLOW_PLUGIN_UTIL.CLEAR_COMPONENT_VALUES;',
'        EXCEPTION',
'            WHEN OTHERS THEN',
'                WWV_FLOW_PLUGIN_UTIL.CLEAR_COMPONENT_VALUES;',
'                RAISE;',
'        END;',
'    END LOOP;',
'    sys.HTP.PRN(',
'            '']''||',
'        ''}''',
'    );',
'    ',
'    RETURN NULL;',
'END AJAX;'))
,p_api_version=>1
,p_render_function=>'RENDER'
,p_ajax_function=>'AJAX'
,p_standard_attributes=>'SOURCE_SQL:AJAX_ITEMS_TO_SUBMIT:ESCAPE_OUTPUT'
,p_substitute_attributes=>false
,p_reference_id=>5610141522737396215
,p_subscribe_plugin_settings=>true
,p_help_text=>'<p>This plugin draws horizontal bar charts containing labels, values and even icons</p>'
,p_version_identifier=>'1.0'
,p_files_version=>16
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1702314010879247748)
,p_plugin_id=>wwv_flow_imp.id(3347174819831483585)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>10
,p_static_id=>'attribute_01'
,p_prompt=>'Icon Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'INITIALS'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1702322154391247789)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ICON'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>Image</strong>: Adds an image HTML element on the left side of the chart.</li>',
'    <li><strong>CSS Icon</strong>: Unlike the &quot;Image&quot; icon, instead of displaying an image HTML element, it displays an icon with the given CSS class.</li>',
'    <li><strong>Initials</strong>: Opposed to both, the &quot;Image&quot; and &quot;CSS Icon&quot; icons, this one displays a colored circle containing the given initials.</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1702314400089247749)
,p_plugin_attribute_id=>wwv_flow_imp.id(1702314010879247748)
,p_display_sequence=>10
,p_display_value=>'Image'
,p_return_value=>'IMAGE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1702314934323247750)
,p_plugin_attribute_id=>wwv_flow_imp.id(1702314010879247748)
,p_display_sequence=>20
,p_display_value=>'CSS Icon'
,p_return_value=>'ICON'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1702315423649247750)
,p_plugin_attribute_id=>wwv_flow_imp.id(1702314010879247748)
,p_display_sequence=>30
,p_display_value=>'Initials'
,p_return_value=>'INITIALS'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1702315964881247752)
,p_plugin_id=>wwv_flow_imp.id(3347174819831483585)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>20
,p_static_id=>'attribute_02'
,p_prompt=>'Label Column'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_help_text=>'<p>A query column from which the label to be displayed is given.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1702316376575247752)
,p_plugin_id=>wwv_flow_imp.id(3347174819831483585)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>3
,p_display_sequence=>30
,p_static_id=>'attribute_03'
,p_prompt=>'Label Link'
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_is_translatable=>false
,p_reference_scope=>'ROW'
,p_help_text=>'<p>A URL to be opened whenever the label is clicked. This attribute supports substitution strings.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1702316703235247786)
,p_plugin_id=>wwv_flow_imp.id(3347174819831483585)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>40
,p_static_id=>'attribute_04'
,p_prompt=>'Value Column'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_help_text=>'<p>A query column from which the label to be displayed is given. Notice that this value is not displayed on the chart items when the chart has been configured to display the bar width percentage instead.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1702317188143247786)
,p_plugin_id=>wwv_flow_imp.id(3347174819831483585)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>50
,p_static_id=>'attribute_05'
,p_prompt=>'Value Link'
,p_attribute_type=>'LINK'
,p_is_required=>false
,p_is_translatable=>false
,p_reference_scope=>'ROW'
,p_help_text=>'<p>A URL to be opened whenever the displayed value is clicked. This attribute supports substitution strings.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1702317539007247786)
,p_plugin_id=>wwv_flow_imp.id(3347174819831483585)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>5
,p_static_id=>'attribute_06'
,p_prompt=>'Chart CSS Class Names'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>false
,p_help_text=>'<p>CSS class names to be added to the root element of the chart separated with spaces.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1702317934333247786)
,p_plugin_id=>wwv_flow_imp.id(3347174819831483585)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>13
,p_static_id=>'attribute_07'
,p_prompt=>'Image URL'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1702314010879247748)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'IMAGE'
,p_help_text=>'<p>The Image URL to be displayed as the chart icon. This attribute supports Substitution strings referring to som query column like in <strong>&amp;IMAGE_URL.</strong> which would reference the <strong>IMAGE_URL</strong> column value for each of the '
||'bars presented on the char. Notice that substitutions with no value will be replaced with an empty string.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1702318377760247787)
,p_plugin_id=>wwv_flow_imp.id(3347174819831483585)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>12
,p_static_id=>'attribute_08'
,p_prompt=>'CSS Icon Class Name'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1702314010879247748)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'ICON'
,p_help_text=>'<p>The Icon CSS Class Name.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1702318725963247787)
,p_plugin_id=>wwv_flow_imp.id(3347174819831483585)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>14
,p_static_id=>'attribute_09'
,p_prompt=>'Initials Column'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1702314010879247748)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'INITIALS'
,p_help_text=>'<p>A query column from which initials to be displayed as an icon are given.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1702319144504247787)
,p_plugin_id=>wwv_flow_imp.id(3347174819831483585)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>7
,p_static_id=>'attribute_10'
,p_prompt=>'Custom Chart Colors'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1702324943371247791)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'CUSTOM'
,p_help_text=>'<p>A list of CSS supported colors separated by colons.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1702319520452247788)
,p_plugin_id=>wwv_flow_imp.id(3347174819831483585)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>110
,p_static_id=>'attribute_11'
,p_prompt=>'Display'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'VALUE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'<p>Displays either the item value or the calculated bar width on the right most text in the chart item.</p>'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1702319913806247788)
,p_plugin_attribute_id=>wwv_flow_imp.id(1702319520452247788)
,p_display_sequence=>10
,p_display_value=>'Value'
,p_return_value=>'VALUE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1702320403431247788)
,p_plugin_attribute_id=>wwv_flow_imp.id(1702319520452247788)
,p_display_sequence=>20
,p_display_value=>'Bar Width'
,p_return_value=>'BAR_WIDTH'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1702320901819247788)
,p_plugin_id=>wwv_flow_imp.id(3347174819831483585)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>120
,p_static_id=>'attribute_12'
,p_prompt=>'Prefix for Value'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_imp.id(1702319520452247788)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'VALUE'
,p_help_text=>'<p>When the value is displayed on the right most side of the chart item. The value of this attribute is prepended to it.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1702321301810247789)
,p_plugin_id=>wwv_flow_imp.id(3347174819831483585)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>130
,p_static_id=>'attribute_13'
,p_prompt=>'Postfix for Value'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_is_translatable=>true
,p_depending_on_attribute_id=>wwv_flow_imp.id(1702319520452247788)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'VALUE'
,p_help_text=>'<p>When the value is displayed on the right most side of the chart item. The value of this attribute is appended to it.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1702321709351247789)
,p_plugin_id=>wwv_flow_imp.id(3347174819831483585)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>140
,p_static_id=>'attribute_14'
,p_prompt=>'Maximum Rows'
,p_attribute_type=>'INTEGER'
,p_is_required=>true
,p_default_value=>'5'
,p_is_translatable=>false
,p_help_text=>'<p>The maximum number of items to be displayed inside the region. Notice bar width calculations are made based on the number of items displayed.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1702322154391247789)
,p_plugin_id=>wwv_flow_imp.id(3347174819831483585)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>4
,p_static_id=>'attribute_15'
,p_prompt=>'Chart Type'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'TEXT'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Defines how the chart will be displayed. There are two types of chart: </p>',
'<ul>',
'    <li><strong>Icon Chart</strong>: Displays bars with the label and value above and add an icon on the left.</li>',
'    <li><strong>Text Chart</strong>: Displays bars with the label and value either above or inline with the bar.</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1702322552294247789)
,p_plugin_attribute_id=>wwv_flow_imp.id(1702322154391247789)
,p_display_sequence=>10
,p_display_value=>'Icon Chart'
,p_return_value=>'ICON'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1702323097395247790)
,p_plugin_attribute_id=>wwv_flow_imp.id(1702322154391247789)
,p_display_sequence=>20
,p_display_value=>'Text Chart'
,p_return_value=>'TEXT'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1702323567631247790)
,p_plugin_id=>wwv_flow_imp.id(3347174819831483585)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>16
,p_display_sequence=>105
,p_static_id=>'attribute_16'
,p_prompt=>'Bar Width Calculation'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'ABSOLUTE'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Bar widths for each one of the chart items can be calculated in two ways:</p>',
'<ul>',
'    <li><strong>Absolute</strong>: 100% bar width is represented by the maximum value on the displayed chart items.</li>',
'    <li><strong>Relative</strong>: 100% bar width is represented by the sum of the values of all the displayed chart items.</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1702323943852247790)
,p_plugin_attribute_id=>wwv_flow_imp.id(1702323567631247790)
,p_display_sequence=>10
,p_display_value=>'Absolute'
,p_return_value=>'ABSOLUTE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1702324478736247791)
,p_plugin_attribute_id=>wwv_flow_imp.id(1702323567631247790)
,p_display_sequence=>20
,p_display_value=>'Relative'
,p_return_value=>'RELATIVE'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1702324943371247791)
,p_plugin_id=>wwv_flow_imp.id(3347174819831483585)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>17
,p_display_sequence=>6
,p_static_id=>'attribute_17'
,p_prompt=>'Color Scheme'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'MODERN'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The colors to be used in the chart bars. There are two special types of configuration: </p>',
'<ul>',
'    <li><strong>Custom</strong>: Provides a text box to receive a colon separated list of css supported colors.</li>',
'</ul>',
'<ul>',
'    <li><strong>Query Column</strong>: Provides a select list with the query columns which expects a css valid color.</li>',
'</ul>',
''))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1702325359834247791)
,p_plugin_attribute_id=>wwv_flow_imp.id(1702324943371247791)
,p_display_sequence=>5
,p_display_value=>'Default'
,p_return_value=>'DEFAULT'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1702325867654248011)
,p_plugin_attribute_id=>wwv_flow_imp.id(1702324943371247791)
,p_display_sequence=>10
,p_display_value=>'Modern'
,p_return_value=>'MODERN'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1702326211699248013)
,p_plugin_attribute_id=>wwv_flow_imp.id(1702324943371247791)
,p_display_sequence=>20
,p_display_value=>'Modern 2'
,p_return_value=>'MODERN_2'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1702326798928248016)
,p_plugin_attribute_id=>wwv_flow_imp.id(1702324943371247791)
,p_display_sequence=>30
,p_display_value=>'Solar'
,p_return_value=>'SOLAR'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1702327218421248016)
,p_plugin_attribute_id=>wwv_flow_imp.id(1702324943371247791)
,p_display_sequence=>40
,p_display_value=>'Metro'
,p_return_value=>'METRO'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1702327735065248017)
,p_plugin_attribute_id=>wwv_flow_imp.id(1702324943371247791)
,p_display_sequence=>50
,p_display_value=>'Custom'
,p_return_value=>'CUSTOM'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1702328258259248017)
,p_plugin_attribute_id=>wwv_flow_imp.id(1702324943371247791)
,p_display_sequence=>60
,p_display_value=>'Query Column'
,p_return_value=>'COLUMN'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1702328793407248017)
,p_plugin_id=>wwv_flow_imp.id(3347174819831483585)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>18
,p_display_sequence=>55
,p_static_id=>'attribute_18'
,p_prompt=>'Text Position'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'AROUND'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1702322154391247789)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'TEXT'
,p_lov_type=>'STATIC'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>When displaying a text chart, two options are available for displaying the label and value texts:</p>',
'<ul>',
'    <li><strong>Above the bar</strong>: The label and value texts are displayed above the bar at the left and right most sides of it respectively.</li>',
'    <li><strong>Inline with the bar</strong>: The label, the bar and the value are displayed in one line on that order.</li>',
'</ul>'))
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1702329113022248018)
,p_plugin_attribute_id=>wwv_flow_imp.id(1702328793407248017)
,p_display_sequence=>10
,p_display_value=>'Above the bar'
,p_return_value=>'ABOVE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(1702329653191248018)
,p_plugin_attribute_id=>wwv_flow_imp.id(1702328793407248017)
,p_display_sequence=>20
,p_display_value=>'Inline with the bar'
,p_return_value=>'AROUND'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1702330199798248018)
,p_plugin_id=>wwv_flow_imp.id(3347174819831483585)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>19
,p_display_sequence=>8
,p_static_id=>'attribute_19'
,p_prompt=>'Chart Colors Column'
,p_attribute_type=>'REGION SOURCE COLUMN'
,p_is_required=>true
,p_column_data_types=>'VARCHAR2'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(1702324943371247791)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'COLUMN'
,p_help_text=>'<p>A query column from which CSS supported colors are given.</p>'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(1702330572647248018)
,p_plugin_id=>wwv_flow_imp.id(3347174819831483585)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>20
,p_display_sequence=>200
,p_static_id=>'attribute_20'
,p_prompt=>'Message When No Data Found'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_default_value=>'No data found.'
,p_is_translatable=>true
,p_help_text=>'<p>Message to be displayed when no data was found.</p>'
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(1702334286876248033)
,p_plugin_id=>wwv_flow_imp.id(3347174819831483585)
,p_name=>'SOURCE_SQL'
,p_sql_min_column_count=>1
);
end;
/
prompt --application/user_interfaces/combined_files
begin
null;
end;
/
prompt --application/pages/page_00000
begin
wwv_flow_imp_page.create_page(
 p_id=>0
,p_name=>'Global Page'
,p_alias=>'GLOBAL-PAGE'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_comment=>'Global attributes for all pages'
,p_page_component_map=>'14'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4855919620928807)
,p_plug_name=>'Viewing Main Application'
,p_region_css_classes=>'a-Alert--slimNotice a-Alert--noTitle margin-bottom-none'
,p_region_template_options=>'a-Alert--colorBG:a-Alert--noIcon:a-Alert--danger:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_source=>'You are on the <strong>Main</strong> version of this application. Please make changes in working copies to prevent conflicts.'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_working_copy_dev.is_main_app (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_security_group_id => :WORKSPACE_ID )',
'and',
'wwv_flow_working_copy_dev.app_has_working_copy (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_security_group_id => :WORKSPACE_ID )',
'and :APP_PAGE_ID in (1,2,9,674,4500)'))
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(162055500354530228)
,p_plug_name=>'Global Objects'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'BEFORE_FOOTER'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_plug_display_when_condition=>'4500'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(386900176106343571)
,p_plug_name=>'APEX 5 - Header'
,p_region_css_classes=>'a-Header apex-app-builder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_07'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(386900501419360208)
,p_plug_name=>'APEX 5 - Header Left'
,p_parent_plug_id=>wwv_flow_imp.id(386900176106343571)
,p_region_css_classes=>'a-Header-col a-Header-col--left'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(32104619081781738)
,p_plug_name=>'Navigation Tabs Landmark'
,p_parent_plug_id=>wwv_flow_imp.id(386900501419360208)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'&PRODUCT_NAME.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(386867521811919469)
,p_plug_name=>'APEX 5 - Tabs'
,p_region_name=>'a_Header_menu'
,p_parent_plug_id=>wwv_flow_imp.id(32104619081781738)
,p_region_css_classes=>'a-Header-tabsContainer'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="display: none;"'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>40
,p_list_id=>wwv_flow_imp.id(384991882401692897)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(384714985827023169)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(386866421782888461)
,p_plug_name=>'Home Link'
,p_parent_plug_id=>wwv_flow_imp.id(386900501419360208)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NEVER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(386903916606439383)
,p_plug_name=>'APEX 5 - Logo'
,p_parent_plug_id=>wwv_flow_imp.id(386900501419360208)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(',
'    ''<a href="'' ||',
'    htmldb_util.prepare_url(''f?p=4100:1:''||:APP_SESSION||''::''||:DEBUG||''::::'') ||',
'    ''" class="a-Header-logo"''||',
'    wwv_flow_plugin_util.get_html_attr(',
'        p_name  => ''title'',',
'        p_value => wwv_flow_lang.system_message(''HOME_NAV'') ) ||',
'    ''><span role="img" aria-labelledby="logoLabel" class="a-Header-apexLogo"><span id="logoLabel" class="u-vh">'' ||',
'    wwv_flow_escape.html( wwv_flow_lang.system_message( ''HOME_NAV'' ) ) ||',
'    ''</span></span></a>'' );'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_landmark_type=>'region'
,p_landmark_label=>'Logo'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(386900769360361408)
,p_plug_name=>'APEX 5 - Header Right'
,p_parent_plug_id=>wwv_flow_imp.id(386900176106343571)
,p_region_css_classes=>'a-Header-col a-Header-col--right'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(386868520035950353)
,p_plug_name=>'APEX 5 - Header Navigation Links'
,p_parent_plug_id=>wwv_flow_imp.id(386900769360361408)
,p_region_css_classes=>'a-Header-navLinks'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>25
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_landmark_type=>'region'
,p_landmark_label=>'Navigation Bar'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2400473160991801)
,p_plug_name=>'Extensions Menu'
,p_region_name=>'extensionsMenu'
,p_parent_plug_id=>wwv_flow_imp.id(386868520035950353)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_location=>null
,p_list_id=>wwv_flow_imp.id(2601789395872251)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(3712705120335)
,p_translate_title=>'N'
,p_plug_required_role=>wwv_flow_imp.id(3000262679771390)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(384693505787932850)
,p_plug_name=>'Help Menu'
,p_region_name=>'helpMenu'
,p_parent_plug_id=>wwv_flow_imp.id(386868520035950353)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_imp.id(488490120498750288)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(3712705120335)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(386922861102419764)
,p_plug_name=>'Administration Menu'
,p_region_name=>'adminMenu'
,p_parent_plug_id=>wwv_flow_imp.id(386868520035950353)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_imp.id(384736293175059813)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(3712705120335)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(386870749356009641)
,p_plug_name=>'APEX 5 - Account'
,p_parent_plug_id=>wwv_flow_imp.id(386900769360361408)
,p_region_css_classes=>'a-Header-account'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>35
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_4000_ui.account_mega_menu (',
'    p_username          => :APP_USER,',
'    p_workspace_id      => :WORKSPACE_ID,',
'    p_session           => :APP_SESSION,',
'    p_logout_url        => :LOGOUT_URL',
');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_landmark_type=>'region'
,p_landmark_label=>'Account'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(702958167090571310)
,p_plug_name=>'APEX 5 - Search'
,p_parent_plug_id=>wwv_flow_imp.id(386900769360361408)
,p_region_css_classes=>'a-Header-search'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>15
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_search_label varchar2(255) := wwv_flow_lang.system_message(case when :APP_PAGE_ID = 1500 then ''WWV_FLOW_QUICK_FLOW.SEARCH.ALL_APPS'' else ''WWV_FLOW_QUICK_FLOW.SEARCH.APPS'' end);',
'begin',
'    sys.htp.p(''<div class="a-SearchBox a-SearchBox--noGoButton a-SearchBox--autoExpand a-SearchBox--fill">'');',
'    sys.htp.p(''  <div class="a-SearchBox-field">'');',
'    sys.htp.p(''    <span class="a-SearchBox-icon"><span class="a-Icon icon-search"></span></span>'');',
'    sys.htp.p(''    <label for="P0_SEARCH" class="visuallyhidden">''||l_search_label||''</label>'');',
'    sys.htp.p(''    <input type="text" class="a-SearchBox-input" id="P0_SEARCH" placeholder="''||l_search_label||''">'');',
'    sys.htp.p(''  </div>'');',
'    sys.htp.p(''</div>'');',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_required_patch=>wwv_flow_imp.id(170786031904296885)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(386911214938955189)
,p_plug_name=>'APEX 5 - Control Bar'
,p_region_css_classes=>'a-ControlBar apex-app-builder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_07'
,p_translate_title=>'N'
,p_plug_display_condition_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_plug_display_when_condition=>'1500, 4500, 9600'
,p_landmark_type=>'region'
,p_landmark_label=>'Control Bar'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(386911642894962070)
,p_plug_name=>'APEX 5 - Control Bar Left'
,p_parent_plug_id=>wwv_flow_imp.id(386911214938955189)
,p_region_css_classes=>'a-ControlBar-col a-ControlBar-col--noPadding'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(386912872680970625)
,p_plug_name=>'APEX 5 - Breadcrumb'
,p_parent_plug_id=>wwv_flow_imp.id(386911642894962070)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_menu_id=>wwv_flow_imp.id(6341600034528019)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_imp.id(3705314539083)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Breadcrumb'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(386912265387964452)
,p_plug_name=>'APEX 5 - Control Bar Right'
,p_parent_plug_id=>wwv_flow_imp.id(386911214938955189)
,p_region_css_classes=>'a-ControlBar-col'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_display_condition_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_plug_display_when_condition=>'4500,1500,460,514,516,527,273,2100,2101,2102,2103,2105,2106,2107,2108,2109,2111,2115,163,56,176,189,433,447,448,451,454,458,494,495,496,3001,3002,3005,3020,49,57,3000,2116,598,2117,73,227,20,800,2150,2151,2152,2153,2154,2155,2157,733,870,871,872,873,'
||'580,585,588,589,599,226,875,876,700,705,720,725,730,735,880,882,600,605,615,620,625,630,635,884,886,196,722,689,4460,479,224,4900,76,441,933,559,934,78,279,50,81,82,83,209,650,680,160,111,182,756,763,764,970,971,972,973,974,976,977,978,979,1931,1933,'
||'1934,1620,1621,1622,1623,1965,1600,1602,1603,714,905,1960,9009,9010,893,896,892,726,736,1300,1301,9015,9012,103,467,380,665,7777,9014,737,1616,1615,1601,1963,1964,1968'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(33628224409605418)
,p_plug_name=>'Run Page'
,p_region_name=>'apex-control-icons'
,p_parent_plug_id=>wwv_flow_imp.id(386912265387964452)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(4717527352803690)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(210393202311761690)
,p_translate_title=>'N'
,p_plug_display_condition_type=>'NEVER'
,p_plug_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'1500,460,514,516,527,273,2100,2101,2102,2103,2105,2106,2107,2108,2109,2111,2115,1556,1555,163,1550,56,320,176,189,351,433,437,447,448,451,454,458,494,495,496,3001,3002,3003,3004,3005,3006,3014,3015,3020,49,57,3000,2116,598,2117,73',
'',
'-- condition: current page is not in expression 1 (as of 01/06/2014)',
'4500,1500,460,514,516,527,273,2100,2101,2102,2103,2105,2106,2107,2108,2109,2111,2115,163,56,320,176,189,351,433,437,447,448,451,454,458,494,495,496,3001,3002,3003,3004,3005,3006,3014,3015,3020,49,57,3000,2116,598,2117,73,227,262,20,800,662,544,2150,2'
||'151,2152,2153,2154,2155,2156,2157,733,870,871,872,873,874,550,555,560,580,585,588,589,599,226,595,875,876,700,705,710,715,720,725,730,735,750,880,882,600,605,610,615,620,625,630,635,640,884,886,196,722,523,689,4460,479,224,4900,76,489,488,487,441,110'
||'05,933,559,934,679,11002,11003,11004,78,279,50,83,209,81,650,680'))
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(386916710302082539)
,p_plug_name=>'Page Selector'
,p_parent_plug_id=>wwv_flow_imp.id(386912265387964452)
,p_region_css_classes=>'a-PageSelect a-PageSelect--separate a-PageSelect--readOnly'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<span class="a-PageSelect-icon a-Icon icon-page"></span>&FB_FLOW_PAGE_ID.'
,p_translate_title=>'N'
,p_plug_display_condition_type=>'NEVER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1617426373817257725)
,p_plug_name=>'Container for global hidden items'
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_07'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3185299887144512)
,p_plug_name=>'Working Copy Menu'
,p_region_name=>'workingCopyMenu'
,p_parent_plug_id=>wwv_flow_imp.id(1617426373817257725)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_imp.id(3056785755622754)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(3712705120335)
,p_translate_title=>'N'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_working_copy_dev.is_working_copy( ',
'    p_application_id    => :FB_FLOW_ID,',
'    p_security_group_id => :WORKSPACE_ID )'))
,p_plug_display_when_cond2=>'PLSQL'
,p_landmark_type=>'exclude_landmark'
,p_plug_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'1500,460,514,516,527,273,2100,2101,2102,2103,2105,2106,2107,2108,2109,2111,2115,1556,1555,163,1550,56,320,176,189,351,433,437,447,448,451,454,458,494,495,496,3001,3002,3003,3004,3005,3006,3014,3015,3020,49,57,3000,2116,598,2117,73',
'',
'-- condition: current page is not in expression 1 (as of 01/06/2014)',
'4500,1500,460,514,516,527,273,2100,2101,2102,2103,2105,2106,2107,2108,2109,2111,2115,163,56,320,176,189,351,433,437,447,448,451,454,458,494,495,496,3001,3002,3003,3004,3005,3006,3014,3015,3020,49,57,3000,2116,598,2117,73,227,262,20,800,662,544,2150,2'
||'151,2152,2153,2154,2155,2156,2157,733,870,871,872,873,874,550,555,560,580,585,588,589,599,226,595,875,876,700,705,710,715,720,725,730,735,750,880,882,600,605,610,615,620,625,630,635,640,884,886,196,722,523,689,4460,479,224,4900,76,489,488,487,441,110'
||'05,933,559,934,679,11002,11003,11004,78,279,50,83,209,81,650,680',
''))
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4087202742729919)
,p_plug_name=>'Working Copy Main App Menu'
,p_region_name=>'mainAppMenu'
,p_parent_plug_id=>wwv_flow_imp.id(1617426373817257725)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_imp.id(1415423878169192)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(3712705120335)
,p_translate_title=>'N'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_working_copy_dev.is_main_app (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_security_group_id => :WORKSPACE_ID )'))
,p_plug_display_when_cond2=>'PLSQL'
,p_landmark_type=>'exclude_landmark'
,p_plug_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'1500,460,514,516,527,273,2100,2101,2102,2103,2105,2106,2107,2108,2109,2111,2115,1556,1555,163,1550,56,320,176,189,351,433,437,447,448,451,454,458,494,495,496,3001,3002,3003,3004,3005,3006,3014,3015,3020,49,57,3000,2116,598,2117,73',
'',
'-- condition: current page is not in expression 1 (as of 01/06/2014)',
'4500,1500,460,514,516,527,273,2100,2101,2102,2103,2105,2106,2107,2108,2109,2111,2115,163,56,320,176,189,351,433,437,447,448,451,454,458,494,495,496,3001,3002,3003,3004,3005,3006,3014,3015,3020,49,57,3000,2116,598,2117,73,227,262,20,800,662,544,2150,2'
||'151,2152,2153,2154,2155,2156,2157,733,870,871,872,873,874,550,555,560,580,585,588,589,599,226,595,875,876,700,705,710,715,720,725,730,735,750,880,882,600,605,610,615,620,625,630,635,640,884,886,196,722,523,689,4460,479,224,4900,76,489,488,487,441,110'
||'05,933,559,934,679,11002,11003,11004,78,279,50,83,209,81,650,680',
''))
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(591706539339020444)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(386868520035950353)
,p_button_name=>'UPGRADE_AVAILABLE'
,p_button_static_id=>'header-upgradeAvailable'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Upgrade Available'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:78:&SESSION.:UPGRADE_AVAILABLE:&DEBUG.:78::'
,p_button_condition=>'wwv_flow_cloud_db_services.get_upgrade_status().state = ''SCHEDULED'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-utilities-build-interval'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(591706620458020445)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(386868520035950353)
,p_button_name=>'UPGRADE_IN_PROGRESS'
,p_button_static_id=>'header-upgradeInProgress'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Upgrading'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:78:&SESSION.:UPGRADE_IN_PROGRESS:&DEBUG.:78::'
,p_button_condition=>'wwv_flow_cloud_db_services.get_upgrade_status().state = ''RUNNING'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-ig-refresh u-Animate-spin'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(233600616656079605)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(386868520035950353)
,p_button_name=>'Spotlight'
,p_button_static_id=>'header-spotlightSearch'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'Search'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-search'
,p_button_cattributes=>'data-action="spotlight-search" data-no-update="true"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2400513120991802)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(386868520035950353)
,p_button_name=>'EXTENSIONS'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(3705362896815)
,p_button_image_alt=>'Extensions'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-extension'
,p_button_cattributes=>'data-menu="extensionsMenu_menu"'
,p_security_scheme=>wwv_flow_imp.id(3000262679771390)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(386866668508896430)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(386866421782888461)
,p_button_name=>'HOME'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Home'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=4100:1:&SESSION.::&DEBUG.::::'
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-home'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(386920635912182000)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(386912265387964452)
,p_button_name=>'DEVELOPER_COMMENT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Developer Comment'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1234:&SESSION.::&DEBUG.:NONE,1234:P1234_FLOW_ID:&FB_FLOW_ID.'
,p_button_css_classes=>'a-Button a-Button--noLabel a-Button--padLeft'
,p_icon_css_classes=>'icon-add-comment'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(386869270812963957)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(386868520035950353)
,p_button_name=>'ADMINISTRATION'
,p_button_static_id=>'header-adminMenu'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(3705362896815)
,p_button_image_alt=>'Administration'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-gears-alt'
,p_button_cattributes=>'data-menu="adminMenu_menu"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2573485248212629191)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(386912265387964452)
,p_button_name=>'FIND'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Find'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.navigation.popup({url:"f?p=4000:273:&APP_SESSION.:::273:F4000_P273_PAGE:&FB_FLOW_PAGE_ID.",name:''Finder'',width:800,height:600});'
,p_button_condition=>'FB_FLOW_PAGE_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_icon_css_classes=>'icon-find'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(386914913915018339)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(386912265387964452)
,p_button_name=>'SHARED_COMPONENTS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Shared Components'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.:::'
,p_button_condition=>'FB_FLOW_PAGE_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_button_css_classes=>'a-Button a-Button--noLabel a-Button--padLeft'
,p_icon_css_classes=>'icon-shared-components'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4087184476729918)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(386912265387964452)
,p_button_name=>'MAIN_APP_MENU'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(267402330762941782)
,p_button_image_alt=>'Main'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_working_copy_dev.app_has_working_copy (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_security_group_id => :WORKSPACE_ID )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_css_classes=>'a-Button a-Button--gapLeft'
,p_icon_css_classes=>'icon-working-copy-main'
,p_button_cattributes=>'data-menu="mainAppMenu_menu" aria-label="Working Copy: Main" title="Working Copy: Main"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(386869633187969036)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(386868520035950353)
,p_button_name=>'Feedback'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Feedback'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=4750:11001:&SESSION.::&DEBUG.:RP,11001:P11001_APPLICATION_ID,P11001_PAGE_ID:&APP_ID.,&APP_PAGE_ID.:'
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-comments'
,p_required_patch=>wwv_flow_imp.id(693447794026530907)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3185339457144513)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_imp.id(386912265387964452)
,p_button_name=>'WORKING_COPY_MENU'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(267402330762941782)
,p_button_image_alt=>'&WORKING_COPY_NAME.'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_working_copy_dev.is_working_copy( ',
'    p_application_id    => :FB_FLOW_ID,',
'    p_security_group_id => :WORKSPACE_ID )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_css_classes=>'a-Button a-Button--gapLeft is-working-copy'
,p_icon_css_classes=>'icon-working-copy'
,p_button_cattributes=>'data-menu="workingCopyMenu_menu" aria-label="Working Copy: &WORKING_COPY_NAME." title="Working Copy: &WORKING_COPY_NAME."'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(386869842992971065)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_imp.id(386868520035950353)
,p_button_name=>'Help'
,p_button_static_id=>'header-helpMenu'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(3705362896815)
,p_button_image_alt=>'Help'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--noUI a-Button--navLink'
,p_icon_css_classes=>'icon-help'
,p_button_cattributes=>'data-menu="helpMenu_menu"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(386915504377040843)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_imp.id(386912265387964452)
,p_button_name=>'EDIT_PAGE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(2045667935478789095)
,p_button_image_alt=>'Edit Page &FB_FLOW_PAGE_ID.'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID:&FB_FLOW_ID.,&FB_FLOW_PAGE_ID.'
,p_button_condition=>'FB_FLOW_PAGE_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_button_css_classes=>'a-Button--withIcon a-Button--gapLeft a-Button--editPageButton a-Button--iconTopAction'
,p_icon_css_classes=>'icon-edit-page'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(386916235869059617)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_imp.id(386912265387964452)
,p_button_name=>'RUN_PAGE'
,p_button_static_id=>'button-run-page'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Run Page &FB_FLOW_PAGE_ID.'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:RUN_PAGE:&SESSION.:BRANCH_TO_PAGE_ACCEPT:&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID,F4000_P1_FLOW:&FB_FLOW_ID.,&FB_FLOW_PAGE_ID.,&FB_FLOW_ID.'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_steps p,',
'       wwv_flows f',
' where p.flow_id           = :FB_FLOW_ID',
'   and p.id                = :FB_FLOW_PAGE_ID',
'   and f.id                = p.flow_id',
'   and f.security_group_id = :WORKSPACE_ID',
'   and ( f.global_page_id  <> :FB_FLOW_PAGE_ID',
'       or f.global_page_id is null',
'       )',
'   and p.page_mode = ''NORMAL'''))
,p_button_condition_type=>'EXISTS'
,p_button_css_classes=>'launch-aut a-Button a-Button--noLabel a-Button--withIcon a-Button--iconTopAction a-Button--padLeft'
,p_icon_css_classes=>'icon-run-page'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(72688801649844540)
,p_name=>'P0_FLOWPAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(162055500354530228)
,p_use_cache_before_default=>'NO'
,p_source=>'&FB_FLOW_ID.;&FB_FLOW_PAGE_ID.|&F4000_LAST_VIEW.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_display_when=>'1000,460,514,516,527,273,2100,2101,2102,2103,2105,2106,2107,2108,2109,2111,2115,1500,163,56,176,189,433,447,448,451,454,458,494,495,496,3001,3002,3005,3020,49,57'
,p_display_when_type=>'CURRENT_PAGE_NOT_IN_CONDITION'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(385808383792243608)
,p_name=>'P0_WINDOW_MGMT_MODE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1617426373817257725)
,p_item_default=>'FOCUS'
,p_source=>'APEX_WINDOW_MGMT_MODE'
,p_source_type=>'PREFERENCE'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(385808740658243612)
,p_name=>'P0_WINDOW_MGMT_SHARE_WINDOW'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1617426373817257725)
,p_item_default=>'N'
,p_source=>'APEX_WINDOW_MGMT_SHARE_WINDOW'
,p_source_type=>'PREFERENCE'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
end;
/
prompt --application/pages/page_00001
begin
wwv_flow_imp_page.create_page(
 p_id=>1
,p_name=>'App Builder'
,p_alias=>'HOME'
,p_step_title=>'Pages - App Builder'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213220627333807318)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'<!--',
'function submitenter(e)',
'{',
'var keycode;',
'if (window.event) keycode = window.event.keyCode;',
'else if (e) keycode = e.which;',
'else return true;',
'',
'if (keycode == 13)',
'   {',
'   apex.submit(''PAGE'');',
'   return false;',
'   }',
'else',
'   return true;',
'}',
'',
'//-->',
'</script>'))
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/* Developer Toolbar integration */',
'apex.builder.nameBuilderWindow();',
'apex.jQuery(''#apex_pages_irr_toolbar'').wrap(''<div class="a-IRR-toolbarWrap" id="apps_irr_wrap_toolbar"></div>'');',
'apex.builder.initStickyHeader(''apps_irr_wrap_toolbar'');',
'apex.theme.defaultStickyTop = function() { return $("#apps_irr_wrap_toolbar").outerHeight(); }',
'',
''))
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(74845831538733642)
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(3273609219075266)
,p_name=>'Recently Edited Pages'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>70
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'REGION_POSITION_03'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||name p, id',
'from wwv_flow_steps',
'where security_group_id = :flow_security_group_id and',
'     flow_id = :fb_flow_id',
'order by last_updated_on desc nulls last'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(11667910335347890)
,p_query_num_rows=>8
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report contains no data'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>9
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3273926620075269)
,p_query_column_id=>1
,p_column_alias=>'P'
,p_column_display_sequence=>1
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=4000:4500:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID:&FB_FLOW_ID.,#ID#'
,p_column_linktext=>'#P#'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3274009553075269)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3326719762130228)
,p_plug_name=>'Pages'
,p_region_name=>'apex_pages_irr'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>40
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select p.id,',
'       p.flow_id the_flow,',
'       name,',
'       tab_set,',
'       p.id||'' - ''||name icon_text,',
'       last_updated_on updated,',
'       lower(last_updated_by) last_updated_by,',
'       created_on,',
'       lower(created_by) created_by,',
'       case ',
'         when p.page_mode = ''NORMAL'' and page_component_map <> 14 then',
'           wwv_flow_page_api.get_url (',
'               p_page    => ''RUN_PAGE'',',
'               p_request => ''BRANCH_TO_PAGE_ACCEPT'',',
'               p_items   => ''FB_FLOW_PAGE_ID,FB_FLOW_ID'',',
'               p_values  => p.id||'',''||p.flow_id )',
'         else null',
'       end as run_link,',
'       decode(',
'           l.locked_by,',
'           null,',
'           wwv_flow_page_api.get_url (',
'               p_page        => 444,',
'               p_clear_cache => 444,',
'               p_items       => ''P337_ID,FB_FLOW_PAGE_ID,P444_LOCK_PAGES'',',
'               p_values      => p.id||'',''||p.id||'',''||p.id),',
'           wwv_flow_page_api.get_url (',
'               p_page        => 337,',
'               p_clear_cache => 337,',
'               p_items       => ''P337_ID,FB_FLOW_PAGE_ID'',',
'               p_values      => l.id||'',''||p.id)) as lock_link,',
'       case ',
'         when l.locked_by is null then wwv_flow_lang.system_message( ''BU.UNLOCKED'' )',
'         else wwv_flow_lang.system_message( ''BU.LOCKED'' )',
'       end as lock_label,',
'       case ',
'         when l.locked_by is null then ''icon-unlock''',
'         when l.locked_by = :APP_USER then ''icon-lock-s''',
'         else ''icon-lock-user''',
'       end as lock_icon,',
'       decode(',
'           l.locked_by,',
'           null, sm.t_no,',
'           sm.t_yes) page_is_locked,',
'       nvl( g.group_name,sm.t_unassigned ) group_name,',
'       decode(',
'           g.group_name,',
'           null,',
'           wwv_flow_page_api.get_url (',
'               p_page        => 520,',
'               p_clear_cache => 520),',
'           wwv_flow_page_api.get_url (',
'               p_page        => 521,',
'               p_clear_cache => ''521,RP,RIR'',',
'               p_items       => ''P521_ID'',',
'               p_values      => g.id)',
'           ) group_link,',
'       p.page_type,',
'       p.page_mode,',
'       -- icon columns',
'       decode(substr(nvl(page_component_map,''00''),1,2),',
'             ''01'',''icon-page-form-tabular'',',
'             ''02'',''icon-page-form'',',
'             ''03'',''icon-page-report'',',
'             ''04'',''icon-page-chart'',',
'             ''05'',''icon-page-webservice'',',
'             ''06'',''icon-page-nav'',',
'             ''07'',''icon-page-tree'',',
'             ''08'',''icon-page-calendar'',',
'             ''09'',''icon-page-url'',',
'             ''10'',''icon-page-dynamic'',',
'             ''11'',''icon-page-static'',',
'             ''12'',''icon-page-login'',',
'             ''13'',''icon-page-home'',',
'             ''14'',''icon-page-global'',',
'             ''15'','' '',',
'             ''16'',''icon-page-dynamic-form'',',
'             ''17'',''icon-page-wizard'',',
'             ''18'',''icon-page-ir'',',
'             ''19'',''icon-page-map'',',
'             ''20'',''icon-page-tree'',',
'             ''21'',''icon-page-report'',',
'             ''22'',''icon-page-faceted-search'',',
'             ''23'',''icon-page-cards'',',
'             ''24'',''icon-page-smart-filters'',',
'             ''25'',''icon-page-dynamic'',',
'             ''26'',''icon-page-search'',',
'             ''27'',''icon-page-tmpl-report'',',
'             ''28'',''icon-page-pattern'',',
'             '' '') page_type_class,',
'       wwv_flow_page_api.get_url (',
'               p_page   => 4500,',
'               p_items  => ''FB_FLOW_ID,FB_FLOW_PAGE_ID'',',
'               p_values => p.flow_id||'',''||p.id) edit_page_url,',
'       lower(alias) alias,',
'       step_title Page_title,',
'       decode(',
'           first_item,',
'           ''NO_FIRST_ITEM'', sm.t_no,',
'           ''AUTO_FIRST_ITEM'', sm.auto_first_item,',
'           sm.t_no) first_item,',
'       decode(',
'           include_apex_css_js_yn,',
'           ''Y'', sm.t_yes,',
'           ''N'', sm.t_no,',
'           include_apex_css_js_yn ) include_apex_css_js,',
'       help_text,',
'       footer_text,',
'       welcome_text header_text,',
'       ( select name from wwv_flow_templates t where p.STEP_TEMPLATE = t.id ) page_template,',
'       case',
'         when p.required_role = ''MUST_NOT_BE_PUBLIC_USER'' then',
'             t_must_not_be_public_user',
'         else (select case when p.required_role like ''!%'' then ''{'' end||',
'                      max(name) ||',
'                      case when p.required_role like ''!%'' then ''}'' end',
'                 from wwv_flow_security_schemes s',
'                where s.flow_id = p.flow_id and to_char(s.id) = ltrim(p.REQUIRED_ROLE,''!''))',
'       end authorization_scheme,',
'       (select patch_name',
'          from wwv_flow_patches bo',
'         where bo.id = p.required_patch) build_option,',
'       html_page_header,',
'       html_page_onload,',
'       decode(',
'           allow_duplicate_submissions,',
'           ''Y'', sm.t_yes,',
'           ''N'', sm.t_no,',
'           sm.t_yes) allow_duplicate_submissions,',
'       on_dup_submission_goto_url,',
'       decode(',
'           page_is_public_y_n,',
'           ''Y'', sm.t_yes,',
'           ''N'', sm.t_no,',
'           page_is_public_y_n) page_is_public,',
'       decode(',
'           protection_level,',
'           ''D'', sm.no_url_access,',
'           ''N'', sm.unrestricted,',
'           ''U'', sm.no_arguments_allowed,',
'           ''C'', sm.arguments_must_have_checksum,',
'           sm.unrestricted ) protection_level,',
'       error_notification_text,',
'       decode(',
'           cache_mode,',
'           ''NOCACHE'', sm.t_no,',
'           sm.t_yes) cache_page,',
'       cache_timeout_seconds,',
'       page_comment,',
'       sm.edit,',
'       --',
'       null as actions',
'  from wwv_flow_pages_dev p,',
'       wwv_flow_lock_page l,',
'       (select wwv_flow_lang.system_message(''EDIT'') edit,',
'               wwv_flow_lang.system_message(''F4000.YES'') t_yes,',
'               wwv_flow_lang.system_message(''F4000.NO'') t_no,',
'               wwv_flow_lang.system_message(''AUTO_FIRST_ITEM'') auto_first_item,',
'               wwv_flow_lang.system_message(''NO_URL_ACCESS'') NO_URL_ACCESS,',
'               wwv_flow_lang.system_message(''UNRESTRICTED'') unrestricted,',
'               wwv_flow_lang.system_message(''NO_ARGUMENTS_ALLOWED'') no_arguments_allowed,',
'               wwv_flow_lang.system_message(''ARGUMENTS_MUST_HAVE_CHECKSUM'') arguments_must_have_checksum,',
'               wwv_flow_lang.system_message(''Unassigned'') t_unassigned,',
'               wwv_flow_lang.system_message(''MUST_NOT_BE_PUBLIC_USER'') t_must_not_be_public_user',
'          from sys.dual) sm,',
'       wwv_flow_page_groups g',
' where p.flow_id           = :fb_flow_id',
'   and p.security_group_id = :flow_security_group_id',
'   and p.flow_id           = l.flow_id   (+)',
'   and p.id                = l.object_id (+)',
'   and p.group_id          = g.id        (+)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_prn_output_show_link=>'Y'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#ffffff'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_plug_comment=>'apex 4 rounded corner no top = page template alt'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(3326806401130228)
,p_name=>'Pages'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_highlight=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#EDIT_PAGE_URL#" class="a-IRR-icon a-IRR-icon--page">',
'    <span class="a-Icon #PAGE_TYPE_CLASS#" aria-hidden="true"></span>',
'    <span class="a-Icon a-IRR-pageIcon"></span>',
'    <span class="a-IRR-iconName">#ICON_TEXT#</span>',
'</a>'))
,p_icon_view_columns_per_row=>6
,p_description=>'test'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3327015271130235)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3327219782130236)
,p_db_column_name=>'NAME'
,p_display_order=>2
,p_column_identifier=>'C'
,p_column_label=>'Name'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID:#THE_FLOW#,#ID#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3598317434824474)
,p_db_column_name=>'ALIAS'
,p_display_order=>12
,p_column_identifier=>'N'
,p_column_label=>'Alias'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3327325700130237)
,p_db_column_name=>'UPDATED'
,p_display_order=>22
,p_column_identifier=>'D'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3327405430130237)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>32
,p_column_identifier=>'E'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3327822682130239)
,p_db_column_name=>'PAGE_TYPE'
,p_display_order=>42
,p_column_identifier=>'I'
,p_column_label=>'Type'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3327706045130239)
,p_db_column_name=>'GROUP_NAME'
,p_display_order=>52
,p_column_identifier=>'H'
,p_column_label=>'Group'
,p_column_link=>'#GROUP_LINK#'
,p_column_linktext=>'#GROUP_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3327503654130239)
,p_db_column_name=>'ACTIONS'
,p_display_order=>72
,p_column_identifier=>'F'
,p_column_label=>'Actions'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'TMPL_THEME_3$ACTIONS'
,p_column_alignment=>'CENTER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'ACTIONS_WRAP', 'N',
  'STYLE', 'b-InlineActions--simple')).to_clob
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3327114487130236)
,p_db_column_name=>'THE_FLOW'
,p_display_order=>82
,p_column_identifier=>'B'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3529506898210201)
,p_db_column_name=>'TAB_SET'
,p_display_order=>102
,p_column_identifier=>'M'
,p_column_label=>'Tab Set'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3598430351824474)
,p_db_column_name=>'PAGE_TITLE'
,p_display_order=>112
,p_column_identifier=>'O'
,p_column_label=>'Page Title'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3598524038824474)
,p_db_column_name=>'FIRST_ITEM'
,p_display_order=>132
,p_column_identifier=>'P'
,p_column_label=>'Focus First Item'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3598618419824474)
,p_db_column_name=>'INCLUDE_APEX_CSS_JS'
,p_display_order=>142
,p_column_identifier=>'Q'
,p_column_label=>'Include APEX CSS JS'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3598714437824475)
,p_db_column_name=>'HELP_TEXT'
,p_display_order=>152
,p_column_identifier=>'R'
,p_column_label=>'Help Text'
,p_allow_sorting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_column_type=>'CLOB'
,p_heading_alignment=>'LEFT'
,p_rpt_show_filter_lov=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3598805627824475)
,p_db_column_name=>'AUTHORIZATION_SCHEME'
,p_display_order=>162
,p_column_identifier=>'S'
,p_column_label=>'Authorization Scheme'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3599027723824478)
,p_db_column_name=>'HTML_PAGE_HEADER'
,p_display_order=>172
,p_column_identifier=>'U'
,p_column_label=>'HTML Page Header'
,p_allow_sorting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_column_type=>'CLOB'
,p_heading_alignment=>'LEFT'
,p_rpt_show_filter_lov=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3599106523824478)
,p_db_column_name=>'HTML_PAGE_ONLOAD'
,p_display_order=>182
,p_column_identifier=>'V'
,p_column_label=>'HTML Page Onload'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3599205564824478)
,p_db_column_name=>'ALLOW_DUPLICATE_SUBMISSIONS'
,p_display_order=>192
,p_column_identifier=>'W'
,p_column_label=>'Allow Duplicate Submissions'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3599308440824478)
,p_db_column_name=>'ON_DUP_SUBMISSION_GOTO_URL'
,p_display_order=>202
,p_column_identifier=>'X'
,p_column_label=>'On Duplicate Submission Go To URL'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3599423888824478)
,p_db_column_name=>'PAGE_IS_PUBLIC'
,p_display_order=>212
,p_column_identifier=>'Y'
,p_column_label=>'Page Is Public'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3599520887824479)
,p_db_column_name=>'PROTECTION_LEVEL'
,p_display_order=>222
,p_column_identifier=>'Z'
,p_column_label=>'Protection Level'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3599601799824479)
,p_db_column_name=>'ERROR_NOTIFICATION_TEXT'
,p_display_order=>232
,p_column_identifier=>'AA'
,p_column_label=>'Error Notification Text'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3599719727824479)
,p_db_column_name=>'CACHE_PAGE'
,p_display_order=>242
,p_column_identifier=>'AB'
,p_column_label=>'Cache Page'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3599809426824479)
,p_db_column_name=>'CACHE_TIMEOUT_SECONDS'
,p_display_order=>252
,p_column_identifier=>'AC'
,p_column_label=>'Cache Timeout Seconds'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3599927201824479)
,p_db_column_name=>'PAGE_COMMENT'
,p_display_order=>262
,p_column_identifier=>'AD'
,p_column_label=>'Page Comment'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3615527514130105)
,p_db_column_name=>'BUILD_OPTION'
,p_display_order=>272
,p_column_identifier=>'AE'
,p_column_label=>'Build Option'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3619721860270356)
,p_db_column_name=>'FOOTER_TEXT'
,p_display_order=>282
,p_column_identifier=>'AF'
,p_column_label=>'Footer Text'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3619818778270357)
,p_db_column_name=>'HEADER_TEXT'
,p_display_order=>292
,p_column_identifier=>'AG'
,p_column_label=>'Header Text'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3619925056270357)
,p_db_column_name=>'PAGE_TEMPLATE'
,p_display_order=>302
,p_column_identifier=>'AH'
,p_column_label=>'Page Template'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3942706230112994)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>312
,p_column_identifier=>'AP'
,p_column_label=>'Created'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3942805862112994)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>322
,p_column_identifier=>'AQ'
,p_column_label=>'Created By'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(17232419477873067)
,p_db_column_name=>'EDIT'
,p_display_order=>342
,p_column_identifier=>'AT'
,p_column_label=>'Edit'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(246103625365182038)
,p_db_column_name=>'PAGE_TYPE_CLASS'
,p_display_order=>352
,p_column_identifier=>'AV'
,p_column_label=>'Page Type Class'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(246246315567566509)
,p_db_column_name=>'ICON_TEXT'
,p_display_order=>362
,p_column_identifier=>'AX'
,p_column_label=>'Icon Text'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(44907214251292068)
,p_db_column_name=>'PAGE_MODE'
,p_display_order=>372
,p_column_identifier=>'AY'
,p_column_label=>'Page Mode'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(44400703264122475)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(404733460492551882)
,p_db_column_name=>'GROUP_LINK'
,p_display_order=>382
,p_column_identifier=>'AZ'
,p_column_label=>'Group Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(112547833936702807)
,p_db_column_name=>'EDIT_PAGE_URL'
,p_display_order=>392
,p_column_identifier=>'BA'
,p_column_label=>'Edit Page Url'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2184233551145932)
,p_db_column_name=>'RUN_LINK'
,p_display_order=>402
,p_column_identifier=>'BB'
,p_column_label=>'Run Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2184432244145934)
,p_db_column_name=>'LOCK_LINK'
,p_display_order=>422
,p_column_identifier=>'BD'
,p_column_label=>'Lock Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2184547230145935)
,p_db_column_name=>'LOCK_LABEL'
,p_display_order=>432
,p_column_identifier=>'BE'
,p_column_label=>'Lock Label'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2184632066145936)
,p_db_column_name=>'LOCK_ICON'
,p_display_order=>442
,p_column_identifier=>'BF'
,p_column_label=>'Lock Icon'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2201015918856002)
,p_db_column_name=>'PAGE_IS_LOCKED'
,p_display_order=>452
,p_column_identifier=>'BH'
,p_column_label=>'Locked'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(3328003692130542)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_type=>'REPORT'
,p_report_alias=>'1297727334536645'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_view_mode=>'ICON'
,p_report_columns=>'ID:NAME:ALIAS:UPDATED:LAST_UPDATED_BY:PAGE_TYPE:GROUP_NAME:ACTIONS:'
,p_sort_column_1=>'ID'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'0'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(190825130815820460)
,p_application_user=>'JKALLMAN'
,p_report_seq=>10
,p_report_alias=>'1944958'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_display_rows=>15
,p_report_columns=>'ID:NAME:UPDATED:LAST_UPDATED_BY:PAGE_TYPE:GROUP_NAME:ACTIONS:THE_FLOW:TAB_SET:ALIAS:PAGE_TITLE:FIRST_ITEM:INCLUDE_APEX_CSS_JS:HELP_TEXT:AUTHORIZATION_SCHEME:HTML_PAGE_HEADER:HTML_PAGE_ONLOAD:ALLOW_DUPLICATE_SUBMISSIONS:ON_DUP_SUBMISSION_GOTO_URL:PAGE'
||'_IS_PUBLIC:PROTECTION_LEVEL:ERROR_NOTIFICATION_TEXT:CACHE_PAGE:CACHE_TIMEOUT_SECONDS:PAGE_COMMENT:BUILD_OPTION:FOOTER_TEXT:HEADER_TEXT:PAGE_TEMPLATE:CREATED_ON:CREATED_BY:EDIT:PAGE_TYPE_CLASS:ICON_TEXT:PAGE_MODE:GROUP_LINK'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4088761812729934)
,p_plug_name=>'Working Copy Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(1444976166319775)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(35066701739635046)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4088967555729936)
,p_plug_name=>'Working Copies'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(4415388010910357)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(35066701739635046)
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_working_copy_dev.app_has_working_copy ( ',
'    p_application_id    => :FB_FLOW_ID,',
'    p_security_group_id => :WORKSPACE_ID )'))
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4089147763729938)
,p_plug_name=>'Main Application'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(4415554118934819)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(35066701739635046)
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_working_copy_dev.is_working_copy ( ',
'    p_application_id    => :FB_FLOW_ID,',
'    p_security_group_id => :WORKSPACE_ID )'))
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4202587893056210)
,p_plug_name=>'Backups'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>&APP_TEXT$LAST_BACKUP!HTML.: &P1_LAST_BACKUP!HTML.</p>',
'</p><a href="f?p=&APP_ID.:971:&APP_SESSION_VISIBLE.:::971">&APP_TEXT$MANAGE_BACKUPS!HTML.</a></p>'))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_backup.backup_limit() > 0 and :P1_LAST_BACKUP is not null'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(25168428029007326)
,p_plug_name=>'Tasks'
,p_region_name=>'page_tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-LinksList--showIcons'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(17113830931867323)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(35066701739635046)
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(74808517252457688)
,p_plug_name=>'&P1_APPLICATION!RAW. &P1_APPLICATION_BADGE!RAW.'
,p_region_css_classes=>'a-Region--bottomBorder'
,p_region_sub_css_classes=>'app-builder'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_imp.id(46890703166185102)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(481294291606549740)
,p_plug_column_width=>'apex-col--bottomBorder'
,p_landmark_type=>'region'
,p_landmark_label=>'Actions for app &FB_FLOW_ID.'
,p_plug_comment=>'keep this one'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(117232502747823413)
,p_plug_name=>'Hidden'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>50
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(177874126414161443)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use the Application home page to run, edit, import, export, copy, or delete an application. Select a page to edit the page properties, or click <strong>Create Page</strong> to add a page to the application.</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30829506106300681)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(74808517252457688)
,p_button_name=>'EDIT_APPLICATION_PROPERTIES'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Edit Application Definition'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:4001:&SESSION.::&DEBUG.::FB_FLOW_ID:&FB_FLOW_ID.'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(39807507754554143)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(3326719762130228)
,p_button_name=>'NEW_PAGE'
,p_button_static_id=>'NEW_PAGE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Page'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:2500:&SESSION.::&DEBUG.:2500,2501,2502,2503,2504,2505,2506,2507,2508,2509,2510,2511,2512,2513,2514,2515,2516,2517,2518,2519,2520:FB_FLOW_ID:&FB_FLOW_ID.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4400686037821005)
,p_branch_name=>'Go to page designer'
,p_branch_action=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID:&P1_FB_FLOW_ID.,&P1_FB_FLOW_PAGE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'GO_TO_PAGE_DESIGNER'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(112826802284807604)
,p_branch_name=>'Go To Page 1'
,p_branch_action=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(318597845254)
,p_name=>'F4000_P1_RUN_LINK'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(117232502747823413)
,p_display_as=>'NATIVE_HIDDEN'
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WEB_SAFE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4400286223821001)
,p_name=>'P1_FB_FLOW_ID'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(117232502747823413)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4400391035821002)
,p_name=>'P1_FB_FLOW_PAGE_ID'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(117232502747823413)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4400447256821003)
,p_name=>'P1_APEX_SUCCESS_MESSAGE'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(117232502747823413)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7000812679286535)
,p_name=>'P1_GOTO_PAGE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(117232502747823413)
,p_display_as=>'NATIVE_HIDDEN'
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WEB_SAFE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(19152423570961323)
,p_name=>'P1_DATE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(117232502747823413)
,p_display_as=>'NATIVE_HIDDEN'
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WEB_SAFE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20216022830028036)
,p_name=>'P1_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(74808517252457688)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(70878103917225902)
,p_name=>'P1_LAST_BACKUP'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(117232502747823413)
,p_format_mask=>'SINCE'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  htmldb_util.get_since(max(nvl(last_updated_on, created_on)))',
'from wwv_flow_backups$',
'where application_id = :FB_FLOW_ID;'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'WEB_SAFE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(95753101893550270)
,p_name=>'F4000_P1_PAGE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(117232502747823413)
,p_display_as=>'NATIVE_HIDDEN'
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WEB_SAFE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(109273914819088651)
,p_name=>'F4000_P1_FLOW'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(117232502747823413)
,p_display_as=>'NATIVE_HIDDEN'
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WEB_SAFE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(137085400245224134)
,p_name=>'P1_EDIT_PAGE_ALT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(117232502747823413)
,p_source=>'wwv_flow_lang.system_message(''EDIT_PAGE'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(220666436739624521)
,p_name=>'P1_APPLICATION_BADGE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(74808517252457688)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(430810030823232090)
,p_name=>'P1_DISPLAY_MODE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(117232502747823413)
,p_source=>'ICONS'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'U'
,p_restricted_characters=>'WEB_SAFE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(4913821892)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'1'
,p_computation_error_message=>'Unable to compute item value.'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(19796816493002091)
,p_computation_sequence=>20
,p_computation_item=>'FB_FLOW_NAME'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>'select wwv_flow_escape.html(name) from wwv_flows where id = :fb_flow_id'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(168729305152340203)
,p_computation_sequence=>30
,p_computation_item=>'P1_APPLICATION'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'FB_FLOW_NAME'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(220666581845624522)
,p_computation_sequence=>40
,p_computation_item=>'P1_APPLICATION'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name)',
'  from wwv_flows',
' where id = ( select import_orig_app_id',
'                from wwv_flows',
'               where id = :FB_FLOW_ID',
'                 and security_group_id = :WORKSPACE_ID )       ',
'   and security_group_id = :WORKSPACE_ID'))
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_working_copy_dev.is_working_copy(',
'    p_application_id    => :FB_FLOW_ID,',
'    p_security_group_id => :WORKSPACE_ID )'))
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(4814887487)
,p_computation_sequence=>30
,p_computation_item=>'FB_FLOW_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_comment=>'when user creates a new flow then set the current flow ID to null.'
,p_computation_error_message=>'Unable to compute item value.'
,p_compute_when=>'CREATE_ROW'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(430814706460291255)
,p_computation_sequence=>40
,p_computation_item=>'P1_DISPLAY_MODE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'ICONS'
,p_compute_when=>'P1_DISPLAY_MODE'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(548124028089409874)
,p_name=>'Go to Page Designer'
,p_event_sequence=>5
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'#page_tasks,#NEW_PAGE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(551184684186821404)
,p_event_id=>wwv_flow_imp.id(548124028089409874)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.items.P1_FB_FLOW_ID.value = this.data.FB_FLOW_ID;',
'apex.items.P1_FB_FLOW_PAGE_ID.value = this.data.FB_FLOW_PAGE_ID;',
'apex.items.P1_APEX_SUCCESS_MESSAGE.value = this.data.successMessage.text;',
'apex.page.submit(''GO_TO_PAGE_DESIGNER'');'))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(43612743682)
,p_process_sequence=>10
,p_process_point=>'AFTER_FOOTER'
,p_process_type=>'NATIVE_USER_PREFERENCES'
,p_process_name=>'Save Flow Information'
,p_attribute_01=>'SET_PREFERENCE_TO_ITEM_VALUE'
,p_attribute_02=>'FB_FLOW_ID'
,p_attribute_03=>'FB_FLOW_ID'
,p_process_error_message=>'Error setting preference.'
,p_process_when=>'FB_FLOW_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>43612743682
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(57206698643424399)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set flow, page, and run link'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_page_component_map varchar2(255) := null;',
'  l_date date := null;',
'begin',
'wwv_flow_dev.set_flow_builder_state;',
'l_date := to_date(:p1_date,''YYYY.MM.DD.HH24:MI:SS'');',
'wwv_flow_page_map.set_current_application(p_application_id=>v(''FB_FLOW_ID''),p_date=>l_date);',
':p1_date := to_char(sysdate,''YYYY.MM.DD.HH24:MI:SS'');',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error performing process.'
,p_internal_uid=>57206698643424399
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(220666606285624523)
,p_process_sequence=>30
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set application badge'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_badge_class         varchar2(4000);',
'    l_working_copy_prefix varchar2(4000);',
'    l_working_copy_name   varchar2(4000);',
'begin',
'',
'    if wwv_flow_working_copy_dev.is_working_copy(',
'           p_application_id    => :FB_FLOW_ID,',
'           p_security_group_id => :WORKSPACE_ID ) then',
'        l_badge_class       := ''is-working-copy'';',
'        l_working_copy_name := wwv_flow_working_copy_dev.get_working_copy_name(',
'                                   p_application_id    => :FB_FLOW_ID,',
'                                   p_security_group_id => :WORKSPACE_ID );',
'    elsif wwv_flow_working_copy_dev.app_has_working_copy(',
'           p_application_id    => :FB_FLOW_ID,',
'           p_security_group_id => :WORKSPACE_ID ) then',
'       l_badge_class       := ''has-working-copy'';',
'       l_working_copy_name := wwv_flow_lang_dev.builder_message( ''APEXDEV.DIFF.MAIN'' );',
'    end if;',
'',
'    if l_badge_class is not null then',
'        l_working_copy_prefix := wwv_flow_lang_dev.builder_message( ''APEXDEV.DIFF.WORKING_COPY'' );',
'',
'        :P1_APPLICATION_BADGE := ''<span role="status"''||',
'                                 '' class="b-Badge b-Badge--sm b-Badge--circle '' || l_badge_class || ''"'' ||',
'                                 '' aria-label="'' || wwv_flow_escape.html_attribute( l_working_copy_prefix || '': '' || l_working_copy_name ) || ''"'' ||',
'                                 '' title="'' || wwv_flow_escape.html_attribute( l_working_copy_prefix || '': '' || l_working_copy_name ) || ''">'' ||',
'                                 ''<span class="b-Badge-value">'' || wwv_flow_escape.html( l_working_copy_name ) || ''</span>'' ||',
'                                 ''</span>'';',
'    else',
'        :P1_APPLICATION_BADGE := null;',
'    end if;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error performing process.'
,p_internal_uid=>220666606285624523
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4400536185821004)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Go to page designer'
,p_process_sql_clob=>'null;'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'GO_TO_PAGE_DESIGNER'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>'&P1_APEX_SUCCESS_MESSAGE.'
,p_internal_uid=>4400536185821004
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(97259817770153242)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'process audit trail purge'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete wwv_flow_builder_audit_trail',
' where audit_date        < ( sysdate - 365 )',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error purging developer audit trail.'
,p_internal_uid=>97259817770153242
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(31379609401682856)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_error_message=>'Error resetting pagination.'
,p_process_when=>':REQUEST is null or :REQUEST = ''GO'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>31379609401682856
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(238686021281822187)
,p_process_sequence=>50
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'security'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_error.raise_internal_error(',
'    p_error_message => wwv_flow_lang.system_message( p_name => ''F4000.P1.APP_DOES_NOT_EXIST'',',
'                                                     p0     => wwv_flow_escape.html( nvl( :FB_FLOW_ID, ''NULL'' ) ) ) );'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from sys.dual where :FB_FLOW_ID is null',
'union all',
'select 1',
'    from   wwv_flow_developers',
'    where  userid = :FLOW_USER ',
'       and',
'       security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and',
'       security_group_id = ',
'         (select security_group_id from wwv_flows where id=:FB_FLOW_ID)',
'       and',
'       instr(developer_role,''EDIT'') > 0 ',
'       and',
'       (flow_id = :FB_FLOW_ID or flow_id is null)  ',
'intersect',
'select 1',
'  from wwv_flows',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and id = :FB_FLOW_ID',
'   and build_status = ''RUN_AND_BUILD'''))
,p_process_when_type=>'NOT_EXISTS'
,p_internal_uid=>238686021281822187
);
wwv_flow_imp_page.create_component_action(
 p_id=>wwv_flow_imp.id(2184794774145937)
,p_ir_column_id=>wwv_flow_imp.id(3327503654130239)
,p_position_id=>wwv_flow_imp.id(214437533860142316)
,p_display_sequence=>10
,p_template_id=>wwv_flow_imp.id(214438625365151034)
,p_label=>'#LOCK_LABEL#'
,p_link_target_type=>'REDIRECT_URL'
,p_link_target=>'#LOCK_LINK#'
,p_button_display_type=>'ICON'
,p_icon_css_classes=>'#LOCK_ICON#'
,p_is_hot=>false
,p_show_as_disabled=>false
);
wwv_flow_imp_page.create_component_action(
 p_id=>wwv_flow_imp.id(2184845594145938)
,p_ir_column_id=>wwv_flow_imp.id(3327503654130239)
,p_position_id=>wwv_flow_imp.id(214437533860142316)
,p_display_sequence=>20
,p_template_id=>wwv_flow_imp.id(583874857767349098)
,p_label=>'Run'
,p_link_target_type=>'REDIRECT_URL'
,p_link_target=>'#RUN_LINK#'
,p_button_display_type=>'ICON'
,p_icon_css_classes=>'icon-run-page'
,p_action_css_classes=>'launch-aut'
,p_is_hot=>false
,p_show_as_disabled=>true
,p_condition_type=>'EXPRESSION'
,p_condition_expr1=>':RUN_LINK is not null'
,p_condition_expr2=>'PLSQL'
,p_exec_cond_for_each_row=>true
);
end;
/
prompt --application/pages/page_00002
begin
wwv_flow_imp_page.create_page(
 p_id=>2
,p_name=>'Supporting Objects'
,p_alias=>'SUPPORTING-OBJECTS'
,p_step_title=>'Supporting Objects'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(24897722063538624)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deployment.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(937004432516012)
,p_plug_name=>'Supporting Objects'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<p>Use this utility to define the database object definitions, images, and seed data to be included in your application export.<p />'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(941221663539994)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(940230882533174)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(10027605661417559)
,p_plug_name=>'Installation'
,p_region_css_classes=>'u-Height h280'
,p_icon_css_classes=>'icon-util-installation-scripts'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'a-LinksList--nowrap:a-LinksList--showBadge'
,p_plug_template=>wwv_flow_imp.id(655568879441187677)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_imp.id(10025113710400997)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
,p_plug_column_width=>'apex-col--rightBorder apex-col--bottomBorder'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(10122802506814085)
,p_plug_name=>'Deinstallation'
,p_region_css_classes=>'u-Height h280'
,p_icon_css_classes=>'icon-util-deinstallation-scripts'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'a-LinksList--nowrap:a-LinksList--showBadge'
,p_plug_template=>wwv_flow_imp.id(655568879441187677)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_imp.id(10121209647806692)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
,p_plug_column_width=>'apex-col--bottomBorder'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(23444102604657520)
,p_plug_name=>'Upgrade'
,p_region_css_classes=>'u-Height h280'
,p_icon_css_classes=>'icon-util-upgrade-scripts'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'a-LinksList--nowrap:a-LinksList--showBadge'
,p_plug_template=>wwv_flow_imp.id(655568879441187677)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_imp.id(23445516456661592)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
,p_plug_column_width=>'apex-col--rightBorder apex-col--bottomBorder'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(492257309498748106)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Use Supporting Objects to define database object installation scripts that are invoked when importing an application.  You can also define deinstallation scripts to drop objects when deleting an application.  Supporting objects allow you to packag'
||'e both the application and database objects needed in a single file.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1525384191848007107)
,p_plug_name=>'Hidden Items'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(8634913737291889)
,p_branch_action=>'f?p=&APP_ID.:567:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(938119323520376)
,p_name=>'P2_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(937004432516012)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application:'
,p_source=>'select id||'': ''||name from wwv_flows where id = :fb_flow_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies this application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10185825315142303)
,p_name=>'P2_INCLUDE_IN_EXPORT'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(937004432516012)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Include in Export:'
,p_source=>'select include_in_export_yn from wwv_flow_install where flow_id = :fb_flow_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The supporting object definitions can be optionally exported with your application. These include all configuration options and scripts.</p>',
'<ul>',
'<li>',
'<strong>Yes</strong> Includes supporting object definitions in the application export.  Does not automatically load supporting objects when invoked from a command line.',
'</li>',
'<li>',
'<strong>No</strong> Does not include the supporting object definitions in the export.',
'</li>',
'<li>',
'<strong>Yes and Install on Import Automatically</strong> Includes supporting object definitions and a call to install supporting objects in the application export.  This option is valid only for command line installs.  When application imports from t'
||'he command line, it automatically installs or upgrades the supporting objects.',
'</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'PLSQL'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p( ''<a title="'' || wwv_flow_escape.html( wwv_flow_lang.system_message( p_name => ''F4000.P2.UPDATE_EXPORT_SETTINGS'' ) ) ||',
'           ''" href="'' ||',
'           wwv_flow_utilities.prepare_url( ''f?p=&APP_ID.:633:'' || :APP_SESSION ) ||',
'           ''">'' || wwv_flow_escape.html( wwv_flow_item.text_from_lov( p_value => :P2_INCLUDE_IN_EXPORT,',
'                                                                      p_lov   => ''EXPORT_SUP_OBJ_OPTIONS'' ) ) ||',
'           ''</a>'' );'))
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(24034827712753809)
,p_name=>'P2_PROMPT_FOR_LICENSE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(937004432516012)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Prompt for License:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(LICENSE_MESSAGE,null,''N'',''Y'') i',
'from WWV_FLOW_INSTALL where FLOW_ID = :fb_flow_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(84259319526460470)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'If license text is provided, the install wizard will prompt for license acceptance.  If no license text is provided, the install wizard will not prompt for license acceptance.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(24880218657941536)
,p_name=>'P2_SYS_PRIVS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(937004432516012)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Verify System Privileges:'
,p_post_element_text=>'&nbsp;'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(REQUIRED_SYS_PRIVS,null,''N'',''Y'') REQUIRED_SYS_PRIVS',
'from WWV_FLOW_INSTALL ',
'where FLOW_ID = :fb_flow_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(84259319526460470)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'A value of <strong>Yes</strong> indicates that identified system privileges will be checked before installation of supporting objects.  A value of <strong>No</strong> indicates that system privileges will not be checked.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40726008959304027)
,p_name=>'P2_REQUIRED_FREE_KB'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(937004432516012)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Required Free KB:'
,p_post_element_text=>'&nbsp;'
,p_source=>'select to_char(nvl(REQUIRED_FREE_KB,0),''999G999G999G999G990'') kb from wwv_flow_install where flow_id = :fb_flow_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the amount of free space required to install the supporting objects.  The free space will not be checked for a value of zero.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40743517681486330)
,p_name=>'P2_CHECK_OBJECTS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(937004432516012)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Check for Objects:'
,p_post_element_text=>'&nbsp;'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(REQUIRED_NAMES_AVAILABLE,null,''N'',''Y'') ',
'from wwv_flow_install ',
'where flow_id = :fb_flow_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(84259319526460470)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'A value of <strong>Yes</strong> indicates that the installation of supporting objects will be prevented if the specified objects exist in the parsing schema.  A value of <strong>No</strong> indicates that no object existence checks will occur.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1525390710807024435)
,p_name=>'P2_PREREQ_CNT'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(1525384191848007107)
,p_prompt=>'Prereq Cnt'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1525390922767024436)
,p_name=>'P2_SUBSTR_CNT'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(1525384191848007107)
,p_prompt=>'Substr Cnt'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1525391163823024436)
,p_name=>'P2_BUILD_OPT_CNT'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(1525384191848007107)
,p_prompt=>'Build Opt Cnt'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1525391320830024436)
,p_name=>'P2_PRE_INS_VAL_CNT'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(1525384191848007107)
,p_prompt=>'Pre Ins Val Cnt'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1525391586725024437)
,p_name=>'P2_INST_SCRIPT_CNT'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(1525384191848007107)
,p_prompt=>'Inst Script Cnt'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1525391797857024437)
,p_name=>'P2_MESSAGE_CNT'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(1525384191848007107)
,p_prompt=>'Message Cnt'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1525391973271024437)
,p_name=>'P2_UPG_CNT'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(1525384191848007107)
,p_prompt=>'Upg Cnt'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1525392194868024438)
,p_name=>'P2_UPG_MSG_CNT'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(1525384191848007107)
,p_prompt=>'Upg Msg Cnt'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1525392357055024438)
,p_name=>'P2_DE_INS_SCRIPT_CNT'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_imp.id(1525384191848007107)
,p_prompt=>'De Ins Script Cnt'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1525392577959024439)
,p_name=>'P2_DE_INS_MSG_CNT'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_imp.id(1525384191848007107)
,p_prompt=>'De Ins Msg Cnt'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1020666694269825025)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'security'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_error.raise_internal_error(',
'    p_error_message => wwv_flow_lang.system_message( p_name => ''F4000.P1.APP_DOES_NOT_EXIST'',',
'                                                     p0     => wwv_flow_escape.html( nvl( :FB_FLOW_ID, ''NULL'' ) ) ) );'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and id = :FB_FLOW_ID',
'   and build_status = ''RUN_AND_BUILD'''))
,p_process_when_type=>'NOT_EXISTS'
,p_internal_uid=>1020666694269825025
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1525395170219042414)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'calculate counts'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P2_PREREQ_CNT  := ''''; ',
':P2_SUBSTR_CNT  := ''''; ',
':P2_BUILD_OPT_CNT  := '''';  ',
':P2_PRE_INS_VAL_CNT  := '''';  ',
':P2_INST_SCRIPT_CNT  := '''';  ',
':P2_MESSAGE_CNT  := '''';  ',
':P2_UPG_CNT  := '''';  ',
':P2_UPG_MSG_CNT  := '''';  ',
':P2_DE_INS_SCRIPT_CNT  := '''';  ',
':P2_DE_INS_MSG_CNT  := ''''; ',
'',
'select to_char(nullif(count(*),0),''999G999G990'') into :P2_INST_SCRIPT_CNT from WWV_FLOW_INSTALL_SCRIPTS where FLOW_ID = :fb_flow_id and nvl(script_type,''INSTALL'') = ''INSTALL'';',
'',
'select to_char(nullif(count(*),0),''999G999G990'') into :P2_UPG_CNT from WWV_FLOW_INSTALL_SCRIPTS where FLOW_ID = :fb_flow_id and nvl(script_type,''INSTALL'') = ''UPGRADE'';',
'',
'select to_char(nullif(count(*),0),''999G999G990'') into :P2_PRE_INS_VAL_CNT from WWV_FLOW_INSTALL_CHECKS where FLOW_ID = :fb_flow_id;',
'',
'select to_char(nullif(count(*),0),''999G999G990'') into :P2_BUILD_OPT_CNT from WWV_FLOW_INSTALL_BUILD_OPT where FLOW_ID = :fb_flow_id;',
'',
'for c1 in (',
'select ',
'decode(PROMPT_SUBSTITUTION_01_YN,''Y'',1,0) + ',
'decode(PROMPT_SUBSTITUTION_02_YN,''Y'',1,0) + ',
'decode(PROMPT_SUBSTITUTION_03_YN,''Y'',1,0) + ',
'decode(PROMPT_SUBSTITUTION_04_YN,''Y'',1,0) + ',
'decode(PROMPT_SUBSTITUTION_05_YN,''Y'',1,0) + ',
'decode(PROMPT_SUBSTITUTION_06_YN,''Y'',1,0) + ',
'decode(PROMPT_SUBSTITUTION_07_YN,''Y'',1,0) + ',
'decode(PROMPT_SUBSTITUTION_09_YN,''Y'',1,0) + ',
'decode(PROMPT_SUBSTITUTION_09_YN,''Y'',1,0) + ',
'decode(PROMPT_SUBSTITUTION_10_YN,''Y'',1,0) + ',
'decode(PROMPT_SUBSTITUTION_11_YN,''Y'',1,0) + ',
'decode(PROMPT_SUBSTITUTION_12_YN,''Y'',1,0) + ',
'decode(PROMPT_SUBSTITUTION_13_YN,''Y'',1,0) + ',
'decode(PROMPT_SUBSTITUTION_14_YN,''Y'',1,0) + ',
'decode(PROMPT_SUBSTITUTION_15_YN,''Y'',1,0) + ',
'decode(PROMPT_SUBSTITUTION_16_YN,''Y'',1,0) + ',
'decode(PROMPT_SUBSTITUTION_17_YN,''Y'',1,0) + ',
'decode(PROMPT_SUBSTITUTION_18_YN,''Y'',1,0) + ',
'decode(PROMPT_SUBSTITUTION_19_YN,''Y'',1,0) + ',
'decode(PROMPT_SUBSTITUTION_20_YN,''Y'',1,0) s',
' from wwv_flow_install where FLOW_ID = :fb_flow_id ) loop',
'    :P2_SUBSTR_CNT := c1.s;',
'end loop;',
'',
'-- Set to null if no substrings to hide badge',
':P2_SUBSTR_CNT := nullif(:P2_SUBSTR_CNT,0);',
'',
'select to_char(nullif(count(*),0),''999G999G990'')',
'  into :P2_DE_INS_SCRIPT_CNT',
'  from WWV_FLOW_INSTALL',
' where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and nvl(sys.dbms_lob.getlength(deinstall_script), 0) > 0;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>1525395170219042414
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(10156003432956263)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'seed row'
,p_process_sql_clob=>'insert into wwv_flow_install (id, flow_id, include_in_export_yn) values (wwv_flow_id.next_val,:fb_flow_id, ''Y'');'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to seed row of wwv_flow_install table.'
,p_process_when=>'select 1 from wwv_flow_install where flow_id = :fb_flow_id'
,p_process_when_type=>'NOT_EXISTS'
,p_internal_uid=>10156003432956263
);
end;
/
prompt --application/pages/page_00003
begin
wwv_flow_imp_page.create_page(
 p_id=>3
,p_name=>'Grid Edit Breadcrumbs'
,p_alias=>'GRID-EDIT-BREADCRUMBS'
,p_step_title=>'Grid Edit Breadcrumbs'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213261028690930718)
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
,p_page_component_map=>'21'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(24600496863590512)
,p_plug_name=>'Breadcrumb Entries'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_MENU_OPTIONS'
,p_query_where=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_id = :FB_FLOW_ID ',
'and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_include_rowid_column=>false
,p_plug_source_type=>'NATIVE_IG'
,p_translate_title=>'N'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Breadcrumb Entries'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(24600739791590514)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_LINK'
,p_heading=>'Edit'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>30
,p_value_alignment=>'LEFT'
,p_link_target=>'f?p=&APP_ID.:104:&SESSION.::&DEBUG.:104:P104_ID,P104_MENU_ID:&ID.,&MENU_ID.'
,p_link_text=>'<span role="img" class="a-Icon icon-edit" title="&EDIT." aria-label="&EDIT."></span>'
,p_link_attributes=>'class="a-Button a-Button--noUI"'
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
,p_escape_on_http_output=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(24600786875590515)
,p_name=>'PARENT_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'PARENT_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>40
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(24600947634590516)
,p_name=>'MENU_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'MENU_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Breadcrumb'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>50
,p_value_alignment=>'LEFT'
,p_attribute_02=>'LOV'
,p_attribute_05=>'PLAIN'
,p_lov_type=>'SQL_QUERY'
,p_lov_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'from wwv_flow_menus',
'where flow_id = :fb_flow_id and  ',
'security_group_id = :flow_security_group_id'))
,p_lov_display_extra=>true
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(24601016664590517)
,p_name=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FLOW_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>60
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(24601122311590518)
,p_name=>'OPTION_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'OPTION_SEQUENCE'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>70
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(24601266711590519)
,p_name=>'SHORT_NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'SHORT_NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Short Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>80
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_max_length=>255
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>true
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(24601321006590520)
,p_name=>'LONG_NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LONG_NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Long Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>90
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(24601449617590521)
,p_name=>'LINK'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LINK'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Target'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>100
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(24601485172590522)
,p_name=>'PAGE_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'PAGE_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_LINK'
,p_heading=>'Page'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>110
,p_value_alignment=>'LEFT'
,p_link_target=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.:4500:FB_FLOW_PAGE_ID:&PAGE_ID.'
,p_link_text=>'&PAGE_ID.'
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
,p_escape_on_http_output=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(24601607761590523)
,p_name=>'ALSO_CURRENT_FOR_PAGES'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ALSO_CURRENT_FOR_PAGES'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>120
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(24601688766590524)
,p_name=>'DISPLAY_WHEN_COND_TYPE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DISPLAY_WHEN_COND_TYPE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>130
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(24601864561590525)
,p_name=>'DISPLAY_WHEN_CONDITION'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DISPLAY_WHEN_CONDITION'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>140
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(24601880569590526)
,p_name=>'DISPLAY_WHEN_CONDITION2'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DISPLAY_WHEN_CONDITION2'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>150
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(24601978952590527)
,p_name=>'SECURITY_SCHEME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'SECURITY_SCHEME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Authorization Scheme'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>160
,p_value_alignment=>'LEFT'
,p_is_required=>false
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(283664112341)
,p_lov_display_extra=>true
,p_lov_display_null=>true
,p_lov_null_text=>'- No Authorization Required -'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(24602168880590528)
,p_name=>'REQUIRED_PATCH'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'REQUIRED_PATCH'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Build Option'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>170
,p_value_alignment=>'LEFT'
,p_is_required=>false
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(198057397)
,p_lov_display_extra=>true
,p_lov_display_null=>true
,p_lov_null_text=>'- No Build Option -'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(24602268232590529)
,p_name=>'SECURITY_GROUP_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'SECURITY_GROUP_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>180
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(24602350254590530)
,p_name=>'LAST_UPDATED_BY'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LAST_UPDATED_BY'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>190
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(24602431225590531)
,p_name=>'LAST_UPDATED_ON'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LAST_UPDATED_ON'
,p_data_type=>'DATE'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>200
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(24602492132590532)
,p_name=>'CREATED_BY'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'CREATED_BY'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>210
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(24602590525590533)
,p_name=>'CREATED_ON'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'CREATED_ON'
,p_data_type=>'DATE'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>220
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(24602714604590534)
,p_name=>'MENU_OPTION_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'MENU_OPTION_COMMENT'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>230
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(24602822737590535)
,p_name=>'APEX$ROW_ACTION'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>20
,p_use_as_row_header=>false
,p_display_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(24602954191590536)
,p_name=>'APEX$ROW_SELECTOR'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
,p_use_as_row_header=>false
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(24600637779590513)
,p_internal_uid=>24600637779590513
,p_is_editable=>true
,p_edit_operations=>'u'
,p_lost_update_check_type=>'VALUES'
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SET'
,p_show_total_row_count=>true
,p_show_toolbar=>true
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>true
,p_define_chart_view=>true
,p_enable_download=>true
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>true
,p_fixed_header=>'NONE'
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(24606193527613504)
,p_interactive_grid_id=>wwv_flow_imp.id(24600637779590513)
,p_static_id=>'209059'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(24606470538613507)
,p_report_id=>wwv_flow_imp.id(24606193527613504)
,p_view_type=>'GRID'
,p_stretch_columns=>true
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(24606951392613518)
,p_view_id=>wwv_flow_imp.id(24606470538613507)
,p_display_seq=>0
,p_column_id=>wwv_flow_imp.id(24600739791590514)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>42
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(24607785634613531)
,p_view_id=>wwv_flow_imp.id(24606470538613507)
,p_display_seq=>2
,p_column_id=>wwv_flow_imp.id(24600786875590515)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(24608756049613539)
,p_view_id=>wwv_flow_imp.id(24606470538613507)
,p_display_seq=>2
,p_column_id=>wwv_flow_imp.id(24600947634590516)
,p_is_visible=>false
,p_is_frozen=>false
,p_width=>150
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(24609576375613546)
,p_view_id=>wwv_flow_imp.id(24606470538613507)
,p_display_seq=>4
,p_column_id=>wwv_flow_imp.id(24601016664590517)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(24610551020613553)
,p_view_id=>wwv_flow_imp.id(24606470538613507)
,p_display_seq=>5
,p_column_id=>wwv_flow_imp.id(24601122311590518)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>80
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(24611437006613560)
,p_view_id=>wwv_flow_imp.id(24606470538613507)
,p_display_seq=>6
,p_column_id=>wwv_flow_imp.id(24601266711590519)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>250
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(24612368152613567)
,p_view_id=>wwv_flow_imp.id(24606470538613507)
,p_display_seq=>9
,p_column_id=>wwv_flow_imp.id(24601321006590520)
,p_is_visible=>false
,p_is_frozen=>false
,p_width=>300
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(24613180899613574)
,p_view_id=>wwv_flow_imp.id(24606470538613507)
,p_display_seq=>10
,p_column_id=>wwv_flow_imp.id(24601449617590521)
,p_is_visible=>false
,p_is_frozen=>false
,p_width=>250
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(24614133853613581)
,p_view_id=>wwv_flow_imp.id(24606470538613507)
,p_display_seq=>4
,p_column_id=>wwv_flow_imp.id(24601485172590522)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>50
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(24614999763613588)
,p_view_id=>wwv_flow_imp.id(24606470538613507)
,p_display_seq=>10
,p_column_id=>wwv_flow_imp.id(24601607761590523)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(24615896224613596)
,p_view_id=>wwv_flow_imp.id(24606470538613507)
,p_display_seq=>11
,p_column_id=>wwv_flow_imp.id(24601688766590524)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(24616853347613603)
,p_view_id=>wwv_flow_imp.id(24606470538613507)
,p_display_seq=>12
,p_column_id=>wwv_flow_imp.id(24601864561590525)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(24617747398613611)
,p_view_id=>wwv_flow_imp.id(24606470538613507)
,p_display_seq=>13
,p_column_id=>wwv_flow_imp.id(24601880569590526)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(24618603356613619)
,p_view_id=>wwv_flow_imp.id(24606470538613507)
,p_display_seq=>7
,p_column_id=>wwv_flow_imp.id(24601978952590527)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>250
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(24619486316613627)
,p_view_id=>wwv_flow_imp.id(24606470538613507)
,p_display_seq=>8
,p_column_id=>wwv_flow_imp.id(24602168880590528)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>150
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(24620465296613635)
,p_view_id=>wwv_flow_imp.id(24606470538613507)
,p_display_seq=>16
,p_column_id=>wwv_flow_imp.id(24602268232590529)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(24621369275613644)
,p_view_id=>wwv_flow_imp.id(24606470538613507)
,p_display_seq=>17
,p_column_id=>wwv_flow_imp.id(24602350254590530)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(24622232496613657)
,p_view_id=>wwv_flow_imp.id(24606470538613507)
,p_display_seq=>18
,p_column_id=>wwv_flow_imp.id(24602431225590531)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(24623120038613668)
,p_view_id=>wwv_flow_imp.id(24606470538613507)
,p_display_seq=>19
,p_column_id=>wwv_flow_imp.id(24602492132590532)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(24624023929613680)
,p_view_id=>wwv_flow_imp.id(24606470538613507)
,p_display_seq=>20
,p_column_id=>wwv_flow_imp.id(24602590525590533)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(24624899185613690)
,p_view_id=>wwv_flow_imp.id(24606470538613507)
,p_display_seq=>21
,p_column_id=>wwv_flow_imp.id(24602714604590534)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(24627980751634694)
,p_view_id=>wwv_flow_imp.id(24606470538613507)
,p_display_seq=>0
,p_column_id=>wwv_flow_imp.id(24602822737590535)
,p_is_visible=>true
,p_is_frozen=>true
,p_width=>30
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(183473316974271281)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(111619820846587947)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Breadcrumbs'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(5384689205657857)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'3'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(12641615093980826)
,p_tabular_form_region_id=>wwv_flow_imp.id(24600496863590512)
,p_validation_name=>'SHORT_NAME not null'
,p_validation_sequence=>10
,p_validation=>'SHORT_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#COLUMN_HEADER# must be specified.'
,p_associated_column=>'SHORT_NAME'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3710938572235157)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(24600496863590512)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Breadcrumb Entries - Save Interactive Grid Data'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Changes saved.'
,p_internal_uid=>3710938572235157
);
end;
/
prompt --application/pages/page_00005
begin
wwv_flow_imp_page.create_page(
 p_id=>5
,p_name=>'Application Change Detected'
,p_alias=>'APPLICATION-CHANGE-DETECTED'
,p_step_title=>'Application Change Detected'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'11'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3304386618286941)
,p_plug_name=>'Application Change Detected'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'Selected component is not valid for the current application &FB_FLOW_ID.. '
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3304450404286942)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(3304386618286941)
,p_button_name=>'RETURN'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Return to application'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:RP,:F4000_P1_FLOW:&FB_FLOW_ID.'
);
end;
/
prompt --application/pages/page_00006
begin
wwv_flow_imp_page.create_page(
 p_id=>6
,p_name=>'Refresh Subscriptions'
,p_alias=>'REFRESH-SUBSCRIPTIONS'
,p_page_mode=>'MODAL'
,p_step_title=>'Refresh Subscriptions'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4412344688904126)
,p_plug_name=>'Subscriptions that need refresh'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select component_type,',
'       component_id id,',
'       reference_id,',
'       flow_id,',
'       name,',
'       subscription_status',
'  from wwv_flow_subscribed_comp_dev',
' where component_type = :P6_COMPONENT_TYPE',
'  and ( master_version_scn != version_scn or version_scn is null )'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_display_condition_type=>'ITEM_IS_NOT_ZERO'
,p_plug_display_when_condition=>'P6_COUNT'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Subscriptions that need refresh'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(4412582214904128)
,p_max_row_count=>'1000000'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'ADMIN'
,p_internal_uid=>4412582214904128
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4412609180904129)
,p_db_column_name=>'COMPONENT_TYPE'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Component Type'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4412760569904130)
,p_db_column_name=>'ID'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4412879440904131)
,p_db_column_name=>'REFERENCE_ID'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Reference Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4412931251904132)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Subscribed From'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4413061124904133)
,p_db_column_name=>'NAME'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4413191149904134)
,p_db_column_name=>'SUBSCRIPTION_STATUS'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>'Subscription Status'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(6350146844612870)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'63502'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'NAME:FLOW_ID:SUBSCRIPTION_STATUS:'
,p_sort_column_1=>'NAME'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'0'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4413390559904136)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4413822347904141)
,p_plug_name=>'All subscriptions are up to date.'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--success:a-Alert--wizard'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>40
,p_plug_display_condition_type=>'ITEM_IS_ZERO'
,p_plug_display_when_condition=>'P6_COUNT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4413442378904137)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(4413390559904136)
,p_button_name=>'REFRESH_ALL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Refresh All'
,p_button_position=>'NEXT'
,p_button_condition=>'P6_COUNT'
,p_button_condition_type=>'ITEM_IS_NOT_ZERO'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4414158076904144)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(4413390559904136)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4413227780904135)
,p_name=>'P6_COMPONENT_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(4412344688904126)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4413645788904139)
,p_name=>'P6_COUNT'
,p_item_sequence=>30
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(4413779973904140)
,p_computation_sequence=>10
,p_computation_item=>'P6_COUNT'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*)',
'  from wwv_flow_subscribed_comp_dev',
' where component_type = :P6_COMPONENT_TYPE',
'   and ( master_version_scn != version_scn or version_scn is null )'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4414227994904145)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(4414158076904144)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4414391391904146)
,p_event_id=>wwv_flow_imp.id(4414227994904145)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(6610497732558809)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh All'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.refresh_all_components(',
'    p_app_id         => :FB_FLOW_ID,',
'    p_component_type => :P6_COMPONENT_TYPE );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(4413442378904137)
,p_process_success_message=>'Refresh successful.'
,p_internal_uid=>6610497732558809
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(6610505356558810)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Refresh successful.'
,p_internal_uid=>6610505356558810
);
end;
/
prompt --application/pages/page_00008
begin
wwv_flow_imp_page.create_page(
 p_id=>8
,p_name=>'Recently Updated Pages'
,p_alias=>'RECENTLY-UPDATED-PAGES'
,p_step_title=>'Recently Updated Pages'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'page_util.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(170054914261851800)
,p_plug_name=>'Recent Pages'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>140
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select p.id page_id,',
'       p.flow_id application_id, ',
'       p.name page_name,',
'       nvl(p.last_updated_on,p.created_on) last_updated,',
'       nvl(p.last_updated_by,p.created_by) updated_by,',
'       (select count(*)',
'        from wwv_flow_page_plugs',
'        where flow_id = p.flow_id and',
'              page_id = p.id) regions,',
'       (select count(*)',
'        from wwv_flow_step_items',
'        where flow_id = p.flow_id and',
'              flow_step_id = p.id) items,',
'       p.created_on created,',
'       p.created_by created_by,',
'       (select group_name ',
'        from WWV_FLOW_PAGE_GROUPS g',
'        where g.id = p.group_id) page_group_name',
'from wwv_flow_steps p',
'where p.flow_id = :fb_flow_id and ',
'      p.security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(170055004572851800)
,p_name=>'Recent Pages'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(171251900783826691)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>1
,p_column_identifier=>'I'
,p_column_label=>'Page'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID,FB_FLOW_ID:#PAGE_ID#,#APPLICATION_ID#'
,p_column_linktext=>'#PAGE_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(170056320275879428)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Page Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(170056520473889227)
,p_db_column_name=>'LAST_UPDATED'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(170077124144821898)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>4
,p_column_identifier=>'E'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(170077225497821899)
,p_db_column_name=>'CREATED'
,p_display_order=>5
,p_column_identifier=>'F'
,p_column_label=>'Created'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(170077301076821899)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>6
,p_column_identifier=>'G'
,p_column_label=>'Created By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(170077914363838032)
,p_db_column_name=>'PAGE_GROUP_NAME'
,p_display_order=>7
,p_column_identifier=>'H'
,p_column_label=>'Page Group'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(171254708234866673)
,p_db_column_name=>'REGIONS'
,p_display_order=>8
,p_column_identifier=>'J'
,p_column_label=>'Regions'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(171254800662866674)
,p_db_column_name=>'ITEMS'
,p_display_order=>9
,p_column_identifier=>'K'
,p_column_label=>'Items'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(171255311481877107)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>10
,p_column_identifier=>'L'
,p_column_label=>'Application Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(170055522720852028)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1297832166536645'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'PAGE_ID:PAGE_NAME:LAST_UPDATED:UPDATED_BY:REGIONS:ITEMS:PAGE_GROUP_NAME:APPLICATION_ID'
,p_sort_column_1=>'LAST_UPDATED'
,p_sort_direction_1=>'DESC'
,p_sort_column_2=>'THE_SEQUENCE'
,p_sort_direction_2=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(194062601696675323)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(170054914261851800)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:8:&SESSION.::&DEBUG.:8,RIR::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(170083208223892979)
,p_branch_action=>'f?p=&APP_ID.:8:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
end;
/
prompt --application/pages/page_00009
begin
wwv_flow_imp_page.create_page(
 p_id=>9
,p_name=>'Shared Components'
,p_alias=>'SHARED-COMPONENTS'
,p_step_title=>'Shared Components'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(91429205691059841)
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.smallRegion {',
'    height: 240px;',
'}'))
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_sc_about.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2141635246746305)
,p_plug_name=>'Workflows and Automations'
,p_region_css_classes=>'h270'
,p_icon_css_classes=>'icon-sc-tree'
,p_region_sub_css_classes=>'a-LinksList--noBorders'
,p_region_template_options=>'#DEFAULT#:a-Region--noBorder'
,p_component_template_options=>'a-LinksList--nowrap:a-LinksList--showBadge'
,p_plug_template=>wwv_flow_imp.id(655568879441187677)
,p_plug_display_sequence=>200
,p_plug_new_grid_row=>false
,p_plug_grid_column_span=>4
,p_list_id=>wwv_flow_imp.id(1601510944576262)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
,p_plug_column_width=>'apex-col--rightBorder apex-col--bottomBorder'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6717929419930781)
,p_plug_name=>'Application Logic'
,p_region_css_classes=>'h270'
,p_icon_css_classes=>'icon-sc-logic'
,p_region_sub_css_classes=>'a-LinksList--noBorders'
,p_region_template_options=>'#DEFAULT#:a-Region--noBorder:a-Region--noTopBorder'
,p_component_template_options=>'a-LinksList--nowrap:a-LinksList--showBadge'
,p_plug_template=>wwv_flow_imp.id(655568879441187677)
,p_plug_display_sequence=>30
,p_list_id=>wwv_flow_imp.id(694736922570524377)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
,p_plug_column_width=>'apex-col--rightBorder apex-col--bottomBorder'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6733813582982988)
,p_plug_name=>'Security'
,p_region_css_classes=>'h270'
,p_icon_css_classes=>'icon-util-security-profiles'
,p_region_sub_css_classes=>'a-LinksList--noBorders'
,p_region_template_options=>'#DEFAULT#:a-Region--noBorder:a-Region--noTopBorder'
,p_component_template_options=>'a-LinksList--nowrap:a-LinksList--showBadge'
,p_plug_template=>wwv_flow_imp.id(655568879441187677)
,p_plug_display_sequence=>140
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_imp.id(6730409642972302)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
,p_plug_column_width=>'apex-col--rightBorder apex-col--bottomBorder'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6738231375997556)
,p_plug_name=>'User Interface'
,p_region_css_classes=>'h270'
,p_icon_css_classes=>'icon-sc-ui'
,p_region_sub_css_classes=>'a-LinksList--noBorders'
,p_region_template_options=>'#DEFAULT#:a-Region--noBorder'
,p_component_template_options=>'a-LinksList--nowrap:a-LinksList--showBadge'
,p_plug_template=>wwv_flow_imp.id(655568879441187677)
,p_plug_display_sequence=>170
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_imp.id(6736213021992272)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
,p_plug_column_width=>'apex-col--rightBorder apex-col--bottomBorder'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6749911036048434)
,p_plug_name=>'Data Sources'
,p_region_css_classes=>'h270'
,p_icon_css_classes=>'icon-util-webservice'
,p_region_sub_css_classes=>'a-LinksList--noBorders'
,p_region_template_options=>'#DEFAULT#:a-Region--noBorder'
,p_component_template_options=>'a-LinksList--nowrap:a-LinksList--showBadge'
,p_plug_template=>wwv_flow_imp.id(655568879441187677)
,p_plug_display_sequence=>190
,p_list_id=>wwv_flow_imp.id(694855238818571795)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
,p_plug_column_width=>'apex-col--rightBorder apex-col--bottomBorder'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6754602426074365)
,p_plug_name=>'About'
,p_region_css_classes=>'margin-bottom-sm'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Shared components can display or be applied on any page within the application. This page provides a list of available shared components.</p>',
'<p><a rel="noopener noreferrer" target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6755001974136930)
,p_plug_name=>'Tasks'
,p_region_css_classes=>'margin-bottom-sm'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(6753822621133458)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6871226629478707)
,p_plug_name=>'Globalization'
,p_region_css_classes=>'h270'
,p_icon_css_classes=>'icon-sc-globalization'
,p_region_sub_css_classes=>'a-LinksList--noBorders'
,p_region_template_options=>'#DEFAULT#:a-Region--noBorder'
,p_component_template_options=>'a-LinksList--nowrap:a-LinksList--showBadge'
,p_plug_template=>wwv_flow_imp.id(655568879441187677)
,p_plug_display_sequence=>230
,p_plug_new_grid_row=>false
,p_plug_grid_column_span=>4
,p_list_id=>wwv_flow_imp.id(6868813338465446)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
,p_plug_column_width=>'apex-col--bottomBorder'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6877001049499703)
,p_plug_name=>'Files and Reports'
,p_region_css_classes=>'h270'
,p_icon_css_classes=>'icon-sc-files'
,p_region_sub_css_classes=>'a-LinksList--noBorders'
,p_region_template_options=>'#DEFAULT#:a-Region--noBorder'
,p_component_template_options=>'a-LinksList--nowrap:a-LinksList--showBadge'
,p_plug_template=>wwv_flow_imp.id(655568879441187677)
,p_plug_display_sequence=>180
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_imp.id(6874810268492937)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
,p_plug_column_width=>'apex-col--bottomBorder'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(23327731451098175)
,p_plug_name=>'Application'
,p_region_css_classes=>'margin-bottom-sm'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(23333311543130294)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
,p_plug_display_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(470836700216277717)
,p_plug_name=>'Refresh Theme'
,p_region_name=>'refresh_thm_conf'
,p_region_css_classes=>'js-dialog-autoheight'
,p_region_template_options=>'#DEFAULT#:js-dialog-size480x320'
,p_plug_template=>wwv_flow_imp.id(557449278618308550)
,p_plug_display_sequence=>240
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>It looks like your application has one or more custom theme styles.  Once your theme is refreshed, you will need to use Theme Roller to re-save your custom theme style and set it as current. </p>',
'',
'<p>You can learn more about this process by visiting the Migration Guides section of the <a rel="noopener noreferrer" href="https://apex.oracle.com/ut" target="_blank">Universal Theme app</a>.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(522798082125429248)
,p_plug_name=>'Workspace Objects'
,p_region_css_classes=>'margin-bottom-sm'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>130
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(525226966024198272)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Workspace Objects are stored at the workspace-level and are therefore visible in all applications.</p>'))
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(553718161835361902)
,p_plug_name=>'Update to Universal Theme Available'
,p_region_css_classes=>'a-Alert--page'
,p_region_template_options=>'#DEFAULT#:a-Alert--info:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'There is a new version of Universal Theme available! You can refresh your theme to take advantage of new features, enhancements, and bug fixes.'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P9_CURRENT_UT_THEME_ID'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(574349133365630526)
,p_plug_name=>'Navigation and Search'
,p_region_css_classes=>'h270'
,p_icon_css_classes=>'icon-sc-nav'
,p_region_sub_css_classes=>'a-LinksList--noBorders'
,p_region_template_options=>'#DEFAULT#:a-Region--noBorder'
,p_component_template_options=>'a-LinksList--nowrap:a-LinksList--showBadge'
,p_plug_template=>wwv_flow_imp.id(655568879441187677)
,p_plug_display_sequence=>160
,p_list_id=>wwv_flow_imp.id(6746028090034478)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
,p_plug_column_width=>'apex-col--rightBorder apex-col--bottomBorder'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(574349291023630527)
,p_plug_name=>'Other Components'
,p_region_css_classes=>'h270'
,p_icon_css_classes=>'icon-util-shared-components'
,p_region_sub_css_classes=>'a-LinksList--noBorders'
,p_region_template_options=>'#DEFAULT#:a-Region--noBorder:a-Region--noTopBorder'
,p_component_template_options=>'a-LinksList--nowrap:a-LinksList--showBadge'
,p_plug_template=>wwv_flow_imp.id(655568879441187677)
,p_plug_display_sequence=>150
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_imp.id(694733590452503217)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
,p_plug_column_width=>'apex-col--bottomBorder'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(28216468481136412)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(553718161835361902)
,p_button_name=>'REFRESH_THEME'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Refresh Theme'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P9_HAS_CUSTOM_STYLE'
,p_button_condition2=>'Y'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(470837088149277720)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(470836700216277717)
,p_button_name=>'REFRESH_THEME_DIALOG'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Refresh Theme'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(470836610885277716)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(553718161835361902)
,p_button_name=>'REFRESH_THEME_CUSTOM'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Refresh Theme'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P9_HAS_CUSTOM_STYLE'
,p_button_condition2=>'Y'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1710545886072501)
,p_name=>'P9_SEARCH_CONFIGS'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_imp.id(574349133365630526)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1942825037646307)
,p_name=>'P9_MAP_BACKGROUNDS'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_imp.id(574349291023630527)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5077360289291441)
,p_name=>'P9_COMPONENT_GROUPS'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_imp.id(574349291023630527)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28216559563136413)
,p_name=>'P9_CURRENT_UT_THEME_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(6738231375997556)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28216764128136415)
,p_name=>'P9_HAS_CUSTOM_STYLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(553718161835361902)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28216939022136417)
,p_name=>'P9_CURRENT_UT_APEX_VERSION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(553718161835361902)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28217544026136423)
,p_name=>'P9_THEME_REF_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(6738231375997556)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(139952355299709309)
,p_name=>'P9_WORKFLOWS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2141635246746305)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231744701987396005)
,p_name=>'P9_APP_ITEMS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(6717929419930781)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231744857968396006)
,p_name=>'P9_APP_PROCESSES'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(6717929419930781)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231744916314396007)
,p_name=>'P9_APP_COMPUTATIONS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(6717929419930781)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231745021672396008)
,p_name=>'P9_APP_SETTINGS'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(6717929419930781)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231745142624396009)
,p_name=>'P9_AUTOMATIONS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2141635246746305)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231745228115396010)
,p_name=>'P9_BUILD_OPTIONS'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(6717929419930781)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231745366984396011)
,p_name=>'P9_AUTHN_SCHEMES'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(6733813582982988)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231745465872396012)
,p_name=>'P9_AUTHZ_SCHEMES'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(6733813582982988)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231745560172396013)
,p_name=>'P9_LOVS'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(574349291023630527)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231745608000396014)
,p_name=>'P9_PLUGINS'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(574349291023630527)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231745719467396015)
,p_name=>'P9_SHORTCUTS'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(574349291023630527)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231745855324396016)
,p_name=>'P9_EMAIL_TEMPLATES'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_imp.id(6738231375997556)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231745993923396017)
,p_name=>'P9_LISTS'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_imp.id(574349133365630526)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231746018685396018)
,p_name=>'P9_BREADCRUMBS'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_imp.id(574349133365630526)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231746114318396019)
,p_name=>'P9_THEMES'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_imp.id(6738231375997556)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231746201742396020)
,p_name=>'P9_TEMPLATES'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_imp.id(6738231375997556)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231746339510396021)
,p_name=>'P9_APP_FILES'
,p_item_sequence=>260
,p_item_plug_id=>wwv_flow_imp.id(6877001049499703)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231746431267396022)
,p_name=>'P9_WORKSPACE_FILES'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_imp.id(6877001049499703)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231746508611396023)
,p_name=>'P9_DATA_LOAD_DEFINITIONS'
,p_item_sequence=>300
,p_item_plug_id=>wwv_flow_imp.id(6749911036048434)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231746666423396024)
,p_name=>'P9_REST_DATA_SOURCES'
,p_item_sequence=>320
,p_item_plug_id=>wwv_flow_imp.id(6749911036048434)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231746718064396025)
,p_name=>'P9_REPORT_QUERIES'
,p_item_sequence=>330
,p_item_plug_id=>wwv_flow_imp.id(6877001049499703)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231746863484396026)
,p_name=>'P9_REPORT_LAYOUTS'
,p_item_sequence=>340
,p_item_plug_id=>wwv_flow_imp.id(6877001049499703)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231746976025396027)
,p_name=>'P9_TEXT_MESSAGES'
,p_item_sequence=>350
,p_item_plug_id=>wwv_flow_imp.id(6871226629478707)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231747044832396028)
,p_name=>'P9_TASK_DEFINITIONS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2141635246746305)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231747282364396030)
,p_name=>'P9_REST_SYNCS'
,p_item_sequence=>330
,p_item_plug_id=>wwv_flow_imp.id(6749911036048434)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(599201895792999620)
,p_name=>'P9_APP_TRANSLATIONS'
,p_item_sequence=>360
,p_item_plug_id=>wwv_flow_imp.id(6871226629478707)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(599201994274999621)
,p_name=>'P9_APP_ACCESS_ROLES'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(6733813582982988)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(131586723535881749)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'9'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(470836876451277718)
,p_name=>'Open Refresh Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(470836610885277716)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(470836947950277719)
,p_event_id=>wwv_flow_imp.id(470836876451277718)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(470836700216277717)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(231753575610461233)
,p_name=>'onClick REFRESH_THEME'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(28216468481136412)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(231753699547461234)
,p_event_id=>wwv_flow_imp.id(231753575610461233)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH_THEME'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(28217439905136422)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh Theme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- map theme and template references by name',
'wwv_flow_copy_metadata.resubscribe_theme(',
'    p_master_theme_id      => :P9_THEME_REF_ID,',
'    p_subscribing_theme_id => :P9_CURRENT_UT_THEME_ID );',
'',
'-- refresh theme and templates from master',
'wwv_flow_copy_metadata.subscribe_theme (',
'    p_master_theme_id      => :P9_THEME_REF_ID,',
'    p_subscribing_theme_id => :P9_CURRENT_UT_THEME_ID );',
'',
'-- Reset so the conditional region won''t show up again.',
':P9_CURRENT_UT_THEME_ID := null;',
':P9_THEME_REF_ID := null;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'REFRESH_THEME, REFRESH_THEME_DIALOG'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'Successfully refreshed Universal Theme.'
,p_internal_uid=>28217439905136422
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1020628401159693462)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'security'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_error.raise_internal_error(',
'    p_error_message => wwv_flow_lang.system_message( p_name => ''F4000.P1.APP_DOES_NOT_EXIST'',',
'                                                     p0     => wwv_flow_escape.html( nvl( :FB_FLOW_ID, ''NULL'' ) ) ) );'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and id = :FB_FLOW_ID',
'   and build_status = ''RUN_AND_BUILD'''))
,p_process_when_type=>'NOT_EXISTS'
,p_internal_uid=>1020628401159693462
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(28217605394136424)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Init Refresh Theme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- Reset. So this value will not get carried over',
'-- to the this Shared Components page of other apps',
':P9_CURRENT_UT_THEME_ID := null;',
'',
'-- Should we display The refresh theme region?',
'for c1 in (',
'    select id,',
'           reference_id',
'      from wwv_flow_themes t',
'     where t.theme_id = 42',
'       and t.theme_internal_name = ''UNIVERSAL_THEME''',
'       and t.theme_id = (  select max(theme_id) as current_theme_id',
'                              from wwv_flows ',
'                             where id= :FB_FLOW_ID)      ',
'        and regexp_instr( t.file_prefix, ''/24\.1/$'') = 0',
'        and t.flow_id  = :FB_FLOW_ID',
'        and security_group_id = :FLOW_SECURITY_GROUP_ID',
') loop',
'',
'    if c1.reference_id is not null then',
'        :P9_CURRENT_UT_THEME_ID := c1.id;',
'        :P9_THEME_REF_ID := c1.reference_id;',
'    end if;',
'',
'end loop;',
'',
'if :P9_CURRENT_UT_THEME_ID is not null then',
'    -- Is custom style used in current theme style?',
'    for c2 in (',
'        select ''Y'' as yes',
'          from WWV_FLOW_THEME_STYLES s',
'         where s.THEME_ROLLER_CONFIG is not null',
'           and is_current = ''Y''',
'           and s.flow_id  = :FB_FLOW_ID',
'           and s.security_group_id = :FLOW_SECURITY_GROUP_ID',
'    ) loop',
'        :P9_HAS_CUSTOM_STYLE := c2.yes;',
'    end loop;',
'',
'    -- Get APEX version mapping based on theme version',
'    for c3 in (',
'        select decode(',
'                    substr(',
'                        t.file_prefix,',
'                        instr( t.file_prefix , ''/'', -2)',
'                    ),',
'                    ''/1.0/'', ''5.0'',',
'                    ''/1.1/'', ''5.1'',',
'                    ''/1.2/'', ''18.1'',',
'                    ''/1.3/'', ''19.1'',',
'                    ''/1.4/'', ''19.2'',',
'                    ''/1.5/'', ''20.1'',',
'                    ''/1.6/'', ''20.2'',',
'                    ''/21.1/'', ''21.1'',',
'                    ''/21.2/'', ''21.2'',',
'                    ''/22.1/'', ''22.1'',',
'                    ''/22.2/'', ''22.2'',',
'                    ''/23.1/'', ''23.1'',',
'                    ''/23.2/'', ''23.2'',',
'                    ''/24.1/'', ''24.1''',
'               ) as ut_version',
'          from wwv_flow_themes t',
'         where t.id = :P9_CURRENT_UT_THEME_ID',
'           and t.flow_id  = :FB_FLOW_ID',
'           and t.security_group_id = :FLOW_SECURITY_GROUP_ID',
'    ) loop',
'        :P9_CURRENT_UT_APEX_VERSION := c3.ut_version;',
'    end loop;',
'',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>28217605394136424
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(231747163006396029)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Compute Badge Counts'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    -- Application Items',
'    to_char(nullif( ',
'    (select count(*)',
'       from wwv_flow_items i',
'      where i.flow_id = :FB_FLOW_ID',
'        and i.security_group_id = :FLOW_SECURITY_GROUP_ID), 0), ''fm999G999G999G999'') as p9_app_items,',
'',
'    -- Application Processes',
'    to_char(nullif( ',
'    (select count(*)',
'       from wwv_flow_processing p',
'      where p.flow_id = :FB_FLOW_ID',
'        and p.security_group_id = :FLOW_SECURITY_GROUP_ID), 0), ''fm999G999G999G999'') as p9_app_processes,',
'',
'    -- Application Computations',
'    to_char(nullif( ',
'    (select count(*) ',
'       from wwv_flow_computations c',
'      where c.flow_id = :FB_FLOW_ID',
'        and c.security_group_id = :FLOW_SECURITY_GROUP_ID), 0), ''fm999G999G999G999'') as p9_app_computations,',
'',
'     -- Application Settings',
'     to_char(nullif( ',
'    (select count(*)',
'       from wwv_flow_app_settings s',
'      where flow_id = :FB_FLOW_ID',
'        and security_group_id = :FLOW_SECURITY_GROUP_ID), 0), ''fm999G999G999G999'') as p9_app_settings,',
'',
'     -- Automations',
'    to_char(nullif( ',
'    (select count(*) ',
'       from wwv_flow_automations a',
'      where a.flow_id = :FB_FLOW_ID ',
'        and a.security_group_id = :FLOW_SECURITY_GROUP_ID), 0), ''fm999G999G999G999'') as p9_automations,',
'',
'     -- Build Options',
'    to_char(nullif( ',
'    (select count(*) ',
'       from wwv_flow_patches b',
'      where b.flow_id = :FB_FLOW_ID ',
'        and b.security_group_id = :FLOW_SECURITY_GROUP_ID), 0), ''fm999G999G999G999'') as p9_build_options,',
'',
'     -- Authentication Schemes',
'    to_char(nullif( ',
'    (select count(*) ',
'       from wwv_flow_authentications a',
'      where a.flow_id = :FB_FLOW_ID',
'        and a.security_group_id = :FLOW_SECURITY_GROUP_ID), 0), ''fm999G999G999G999'') as p9_authn_schemes,',
'',
'     -- Authorization Schemes',
'    to_char(nullif( ',
'    (select count(*) ',
'       from wwv_flow_security_schemes a',
'      where a.flow_id = :FB_FLOW_ID',
'        and a.security_group_id = :FLOW_SECURITY_GROUP_ID), 0), ''fm999G999G999G999'') as p9_authz_schemes,',
'',
'     -- Appplication Access Control Roles',
'    to_char(nullif( ',
'    (select count(*) ',
'       from wwv_flow_fnd_user_groups r',
'      where r.flow_id = :FB_FLOW_ID',
'        and r.security_group_id = :FLOW_SECURITY_GROUP_ID), 0), ''fm999G999G999G999'') as p9_app_access_roles,',
'     ',
'     -- Lists of Values',
'    to_char(nullif( ',
'    (select count(*) ',
'       from wwv_flow_lists_of_values$ l',
'      where flow_id = :FB_FLOW_ID ',
'        and security_group_id = :FLOW_SECURITY_GROUP_ID), 0), ''fm999G999G999G999'') as p9_lovs,',
'',
'     -- Plug-ins',
'    to_char(nullif( ',
'    (select count(*)',
'       from wwv_flow_plugins p',
'      where p.flow_id = :FB_FLOW_ID',
'        and p.security_group_id = :FLOW_SECURITY_GROUP_ID',
'        and p.theme_id is null), 0), ''fm999G999G999G999'') as p9_plugins,',
'     ',
'     -- Shortcuts',
'    to_char(nullif( ',
'    (select count(*) ',
'       from wwv_flow_shortcuts s',
'      where flow_id = :FB_FLOW_ID',
'       and security_group_id = :FLOW_SECURITY_GROUP_ID), 0), ''fm999G999G999G999'') as p9_shortcuts,',
'',
'     -- Email Templates',
'    to_char(nullif( ',
'    (select count(*) ',
'       from wwv_flow_email_templates t',
'      where t.flow_id = :FB_FLOW_ID',
'        and t.security_group_id = :FLOW_SECURITY_GROUP_ID), 0), ''fm999G999G999G999'') as p9_email_templates,',
'     ',
'     -- Lists',
'     to_char(nullif( ',
'    (select count(*) ',
'       from wwv_flow_lists l',
'      where l.flow_id = :FB_FLOW_ID',
'        and l.security_group_id = :FLOW_SECURITY_GROUP_ID), 0), ''fm999G999G999G999'') as p9_lists,',
'     ',
'     -- Breadcrumbs',
'    to_char(nullif( ',
'    (select count(*)',
'       from wwv_flow_menus m',
'      where m.flow_id = :FB_FLOW_ID',
'        and m.security_group_id = :FLOW_SECURITY_GROUP_ID), 0), ''fm999G999G999G999'') as p9_breadcrumbs,',
'    ',
'    -- Search Configs',
'    to_char(nullif( ',
'    (select count(*)',
'       from wwv_flow_search_configs s',
'      where s.flow_id = :FB_FLOW_ID',
'        and s.security_group_id = :FLOW_SECURITY_GROUP_ID), 0), ''fm999G999G999G999'') as p9_search_configs,',
'     ',
'     -- Themes',
'    to_char(nullif( ',
'    (select count(*)',
'       from wwv_flow_themes t',
'      where t.flow_id = :FB_FLOW_ID',
'        and t.security_group_id = :FLOW_SECURITY_GROUP_ID), 0), ''fm999G999G999G999'') as p9_themes,',
'     ',
'     -- Templates',
'    to_char(nullif(',
'    (select sum(cnt)',
'       from ( select count(*) cnt',
'                from wwv_flow_popup_lov_template t',
'               where t.flow_id           = :FB_FLOW_ID',
'                 and t.security_group_id = :FLOW_SECURITY_GROUP_ID',
'           union all',
'              select count(*) cnt',
'                from wwv_flow_cal_templates t',
'               where t.flow_id           = :FB_FLOW_ID',
'                 and t.security_group_id = :FLOW_SECURITY_GROUP_ID',
'           union all',
'              select count(*) cnt',
'                from wwv_flow_menu_templates t',
'               where t.flow_id           = :FB_FLOW_ID',
'                 and t.security_group_id = :FLOW_SECURITY_GROUP_ID',
'           union all',
'              select count(*) cnt',
'                from wwv_flow_button_templates t',
'               where t.flow_id           = :FB_FLOW_ID',
'                 and t.security_group_id = :FLOW_SECURITY_GROUP_ID',
'           union all',
'              select count(*) cnt',
'                from wwv_flow_field_templates t',
'               where t.flow_id           = :FB_FLOW_ID',
'                 and t.security_group_id = :FLOW_SECURITY_GROUP_ID',
'           union all',
'              select count(*) cnt',
'                from wwv_flow_list_templates t',
'               where t.flow_id           = :FB_FLOW_ID',
'                 and t.security_group_id = :FLOW_SECURITY_GROUP_ID',
'           union all',
'              select count(*) cnt',
'                from wwv_flow_row_templates t',
'               where t.flow_id           = :FB_FLOW_ID',
'                 and t.security_group_id = :FLOW_SECURITY_GROUP_ID',
'           union all',
'              select count(*) cnt',
'                from wwv_flow_templates t',
'               where t.flow_id           = :FB_FLOW_ID',
'                 and t.security_group_id = :FLOW_SECURITY_GROUP_ID',
'           union all',
'              select count(*) cnt',
'                from wwv_flow_page_plug_templates t',
'               where t.flow_id           = :FB_FLOW_ID',
'                 and t.security_group_id = :FLOW_SECURITY_GROUP_ID',
'           union all',
'              select count(*) cnt',
'                from wwv_flow_template_components p',
'               where p.flow_id           = :FB_FLOW_ID',
'                 and p.security_group_id = :FLOW_SECURITY_GROUP_ID',
'                 and p.theme_id is not null',
'       ) ), 0), ''fm999G999G999G999'') as p9_templates,',
'     ',
'     -- Static Application Files',
'      to_char(nullif(',
'    (select count(*)',
'       from wwv_flow_static_files t',
'      where t.flow_id = :FB_FLOW_ID',
'        and t.security_group_id = :FLOW_SECURITY_GROUP_ID), 0), ''fm999G999G999G999'') as p9_app_files,',
'     ',
'     -- Static Workspace Files',
'    to_char(nullif(',
'    (select count(*)',
'       from wwv_flow_company_static_files t',
'      where t.security_group_id = :FLOW_SECURITY_GROUP_ID), 0), ''fm999G999G999G999'') as p9_workspace_files,',
'     ',
'     -- Data Load Definitions',
'    to_char(nullif( ',
'    (select count(*)',
'       from wwv_flow_load_tables l',
'      where l.flow_id = :FB_FLOW_ID',
'        and l.data_profile_id is not null',
'        and l.security_group_id = :FLOW_SECURITY_GROUP_ID), 0), ''fm999G999G999G999'') as p9_data_load_definitions,',
'     ',
'     -- REST Data Sources',
'    to_char(nullif( ',
'    (select count(*)',
'       from wwv_flow_web_src_modules m',
'      where m.flow_id = :FB_FLOW_ID',
'        and m.security_group_id = :FLOW_SECURITY_GROUP_ID), 0), ''fm999G999G999G999'') as p9_rest_data_sources,',
'',
'     -- REST Data Synchronizations',
'    to_char(nullif( ',
'    (select count(*)',
'       from wwv_flow_web_src_modules m',
'      where m.flow_id = :FB_FLOW_ID',
'        and m.security_group_id = :FLOW_SECURITY_GROUP_ID',
'        and m.sync_table_name is not null), 0), ''fm999G999G999G999'') as p9_rest_syncs,',
'     ',
'     -- Report Queries',
'    to_char(nullif( ',
'    (select count(*)',
'       from wwv_flow_shared_queries q',
'      where q.flow_id           = :FB_FLOW_ID',
'        and q.security_group_id = :FLOW_SECURITY_GROUP_ID), 0), ''fm999G999G999G999'') as p9_report_queries,',
'     ',
'     -- Report Layouts',
'    to_char(nullif( ',
'    (select count(*)',
'       from wwv_flow_report_layouts r',
'      where r.flow_id           = :FB_FLOW_ID',
'        and r.security_group_id = :FLOW_SECURITY_GROUP_ID), 0), ''fm999G999G999G999'') as p9_report_layouts,',
'',
'     -- Text Messages',
'    to_char(nullif( ',
'    (select count(*)',
'       from wwv_flow_messages$ m',
'      where m.flow_id = :FB_FLOW_ID',
'        and m.security_group_id = :FLOW_SECURITY_GROUP_ID), 0), ''fm999G999G999G999'') as p9_text_messages,',
'',
'     -- Text Messages',
'    to_char(nullif( ',
'    (select count(*)',
'       from wwv_flow_language_map m',
'      where m.primary_language_flow_id = :FB_FLOW_ID',
'        and m.security_group_id = :FLOW_SECURITY_GROUP_ID), 0), ''fm999G999G999G999'') as p9_app_translations,',
'',
'     -- Task Definitions',
'    to_char(nullif( ',
'    (select count(*)',
'       from wwv_flow_task_defs t',
'      where t.flow_id = :FB_FLOW_ID',
'        and t.security_group_id = :FLOW_SECURITY_GROUP_ID), 0), ''fm999G999G999G999'') as p9_task_definitions,',
'',
'     -- Map Backgrounds',
'    to_char(nullif( ',
'    (select count(*) ',
'       from wwv_flow_map_backgrounds mb',
'      where flow_id = :FB_FLOW_ID',
'        and security_group_id = :FLOW_SECURITY_GROUP_ID), 0), ''fm999G999G999G999'') as p9_map_backgrounds,',
'',
'    -- Workflows',
'    to_char(nullif( ',
'    (select count(*)',
'       from wwv_flow_workflows w',
'      where w.flow_id = :FB_FLOW_ID',
'        and w.security_group_id = :FLOW_SECURITY_GROUP_ID), 0), ''fm999G999G999G999'') as p9_workflows,',
'',
'    -- Component Groups',
'    to_char(nullif( ',
'    (select count(*)',
'       from wwv_flow_component_groups w',
'      where w.flow_id = :FB_FLOW_ID',
'        and w.security_group_id = :FLOW_SECURITY_GROUP_ID), 0), ''fm999G999G999G999'') as p9_component_groups        ',
'',
'into ',
'    :P9_APP_ITEMS,',
'    :P9_APP_PROCESSES,',
'    :P9_APP_COMPUTATIONS,',
'    :P9_APP_SETTINGS,',
'    :P9_AUTOMATIONS,',
'    :P9_BUILD_OPTIONS,',
'    :P9_AUTHN_SCHEMES,',
'    :P9_AUTHZ_SCHEMES,',
'    :P9_APP_ACCESS_ROLES,',
'    :P9_LOVS,',
'    :P9_PLUGINS,',
'    :P9_SHORTCUTS,',
'    :P9_EMAIL_TEMPLATES,',
'    :P9_LISTS,',
'    :P9_BREADCRUMBS,',
'    :P9_SEARCH_CONFIGS,',
'    :P9_THEMES,',
'    :P9_TEMPLATES,',
'    :P9_APP_FILES,',
'    :P9_WORKSPACE_FILES,',
'    :P9_DATA_LOAD_DEFINITIONS,',
'    :P9_REST_DATA_SOURCES,',
'    :P9_REST_SYNCS,',
'    :P9_REPORT_QUERIES,',
'    :P9_REPORT_LAYOUTS,',
'    :P9_TEXT_MESSAGES,',
'    :P9_APP_TRANSLATIONS,',
'    :P9_TASK_DEFINITIONS,',
'    :P9_MAP_BACKGROUNDS,',
'    :P9_WORKFLOWS,',
'    :P9_COMPONENT_GROUPS',
'from sys.dual;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>231747163006396029
);
end;
/
prompt --application/pages/page_00010
begin
wwv_flow_imp_page.create_page(
 p_id=>10
,p_name=>'Unused Lists'
,p_alias=>'UNUSED-LISTS'
,p_step_title=>'Unused Lists'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213210808239773454)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_list.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(48549912169384160)
,p_plug_name=>'Unused Lists'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select list_id,',
'       flow_number,',
'       list_name,',
'       list_entries,',
'       created_on,',
'       created_by,',
'       last_updated_on,',
'       last_updated_by,',
'       HTMLDB_ITEM.CHECKBOX(1,wwv_flow_escape.html(list_id),null,null,'':'', ''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0'') , wwv_flow_lang.system_message(''DELETE_LABEL'',wwv_flow_escape.html(list_name)) ) the_checkbox',
'from (',
'select list.id list_id,',
'       list.flow_id flow_number,',
'       list.name list_name,',
'       (select count(*) ',
'        from wwv_flow_list_items i',
'        where list.id = i.list_id) list_entries,',
'       list.created_on,',
'       list.created_by,',
'       list.last_updated_on,',
'       list.last_updated_by',
'  from wwv_flow_lists list ',
' where list.flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and not exists (select 1',
'                     from wwv_flow_page_plugs r ',
'                    where r.flow_id           = list.flow_id',
'                      and r.security_group_id = :flow_security_group_id',
'                      and r.list_id           = list.id)',
'   and not exists (select 1',
'                     from wwv_flow_steps p ',
'                    where p.flow_id            = list.flow_id',
'                      and p.security_group_id  = :flow_security_group_id',
'                      and p.navigation_list_id = list.id)',
'   and not exists (select 1',
'                     from wwv_flows f ',
'                    where f.id                 = list.flow_id',
'                      and f.security_group_id  = :flow_security_group_id',
'                      and f.navigation_list_id = list.id)',
'   and not exists (select 1',
'                     from wwv_flow_list_items i ',
'                    where i.flow_id            = list.flow_id',
'                      and i.security_group_id  = :flow_security_group_id',
'                      and i.sub_list_id        = list.id)                      ',
') q'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(48550008997384160)
,p_name=>'Unused Lists'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'Report contains no data'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(48550220609384182)
,p_db_column_name=>'LIST_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Edit'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(48550326450384188)
,p_db_column_name=>'FLOW_NUMBER'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Application ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(48550403478384189)
,p_db_column_name=>'LIST_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'List'
,p_column_link=>'f?p=&FLOW_ID.:4050:&SESSION.::&DEBUG.:4050:F4000_P4050_LIST_ID:#LIST_ID#'
,p_column_linktext=>'#LIST_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(111550012133481400)
,p_db_column_name=>'LIST_ENTRIES'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'List Entries'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(111550230833486710)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Created'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(111550327985486710)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Created By'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(111550616550501539)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(111550728835501539)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(111551610148537515)
,p_db_column_name=>'THE_CHECKBOX'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Delete'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(48550601868384480)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1297915951536645'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'THE_CHECKBOX:LIST_NAME:LIST_ENTRIES:CREATED_ON:CREATED_BY:LAST_UPDATED_ON:LAST_UPDATED_BY:'
,p_sort_column_1=>'LIST_NAME'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(152914005205808581)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(62973516530710918)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Lists'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(152943919197897776)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>This page identifies Lists that are not used within this application.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(188939910930895934)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(48549912169384160)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:10:&SESSION.::&DEBUG.:10,RIR::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(111550810794509403)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(48549912169384160)
,p_button_name=>'DELETE_CHECKED'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Delete Checked'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(111551932574562992)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete selected unused lists'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count loop',
'   delete from wwv_flow_lists',
'   where flow_id = :fb_flow_id and',
'         id = to_number(wwv_flow.g_f01(i)) and',
'         security_group_id = :flow_security_group_id;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>111551932574562992
);
end;
/
prompt --application/pages/page_00013
begin
wwv_flow_imp_page.create_page(
 p_id=>13
,p_name=>'Seed Item Help'
,p_alias=>'SEED-ITEM-HELP'
,p_step_title=>'Seed Item Help'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_item.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(85960108210083362)
,p_plug_name=>'Seed Item Help'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<p>Use this utility to set help text for all items in the current application that currently have no help text.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1080990226223523935)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(85961127994088572)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1080990226223523935)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(240668412249837987)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1080990226223523935)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:408:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(86469122641929623)
,p_branch_action=>'f?p=&APP_ID.:408:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(86035902696658898)
,p_name=>'P13_DEFAULT_HELP_TEXT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(85960108210083362)
,p_prompt=>'Default Help Text'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter help text to be applied to all items that currently have not help.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(86082311849822444)
,p_validation_name=>'required message'
,p_validation_sequence=>10
,p_validation=>'P13_DEFAULT_HELP_TEXT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_associated_item=>wwv_flow_imp.id(86035902696658898)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(86075612495794255)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'seed non existent messages'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'insert into WWV_FLOW_STEP_ITEM_HELP (FLOW_ITEM_ID,HELP_TEXT,FLOW_ID)',
'select id, :P13_DEFAULT_HELP_TEXT m, flow_id',
'from wwv_flow_step_items',
'where id not in (select flow_item_id from wwv_flow_step_item_help where flow_id = :fb_flow_id)',
'      and flow_id = :fb_flow_id and',
'      DISPLAY_AS not in ( ''NATIVE_HIDDEN'',''NATIVE_STOP_AND_START_HTML_TABLE'') and prompt is not null;',
'',
'delete from wwv_flow_step_item_help h',
'where flow_id = :fb_flow_id and',
'      exists (select 1 from',
'              wwv_flow_step_items',
'              where id = h.FLOW_ITEM_ID and',
'                    display_as in (''NATIVE_HIDDEN'',''NATIVE_STOP_AND_START_HTML_TABLE''));'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to seed item level help text.'
,p_process_when_button_id=>wwv_flow_imp.id(85961127994088572)
,p_process_success_message=>'Items with no help text seeded.'
,p_internal_uid=>86075612495794255
);
end;
/
prompt --application/pages/page_00014
begin
wwv_flow_imp_page.create_page(
 p_id=>14
,p_name=>'Caching'
,p_alias=>'CACHING'
,p_step_title=>'Caching'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(11501804013545635)
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'preface.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(31087728292254007)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(31086920674251816)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47787001885565213)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(47883828808092400)
,p_name=>'Cached Regions'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h320'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select region_name, cached_on',
'from (',
'select ',
'   r.plug_name region_name,',
'  cached_on',
'from wwv_flow_page_cache c,',
'     wwv_flow_page_plugs r',
'where c.region_id(+) = r.id and',
'      c.flow_id(+) = r.flow_id and',
'      r.flow_id = :fb_flow_id and ',
'      r.security_group_id = :flow_security_group_id and ',
'      c.region_id is not null and',
'      r.page_id = :P14_page_id ',
'order by 2 desc',
')',
'where rownum < 8'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(47141516446071328)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No regions cached.'
,p_query_row_count_max=>7
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(47883828808092400)
,p_plug_column_width=>'apex-col--bottomBorder apex-col--leftBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47884409546096302)
,p_query_column_id=>1
,p_column_alias=>'REGION_NAME'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47884523449096303)
,p_query_column_id=>2
,p_column_alias=>'CACHED_ON'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(47889025485176587)
,p_name=>'Cached Pages'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h320'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select LANGUAGE,',
'       CACHED_ON,',
'       case',
'         when valid_until < sysdate then m.expired',
'         else m.unexpired',
'       end cache_status',
'from (',
'select c.LANGUAGE,',
'       c.CACHED_ON,',
'       c.valid_until',
'  from WWV_FLOW_PAGE_CACHE c,',
'       wwv_flow_steps p',
' where c.flow_id = :fb_flow_id',
'   and c.flow_id = p.flow_id',
'   and c.page_id = p.id',
'   and p.id = :fb_flow_page_id',
'   and p.security_group_id = :flow_security_group_id',
'   and p.cache_mode <> ''NOCACHE''',
'order by 1',
'),',
'(select',
'   wwv_flow_lang.system_message(''F4500_P2610_EXPIRED'') expired,',
'   wwv_flow_lang.system_message(''UNEXPIRED'') unexpired',
' from sys.dual) m',
'where rownum < 8'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(47141516446071328)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No pages cached.'
,p_query_row_count_max=>7
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(47889025485176587)
,p_plug_column_width=>'apex-col--bottomBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(450463705691363985)
,p_query_column_id=>1
,p_column_alias=>'LANGUAGE'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(450463827683363985)
,p_query_column_id=>2
,p_column_alias=>'CACHED_ON'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(450465415518376225)
,p_query_column_id=>3
,p_column_alias=>'CACHE_STATUS'
,p_column_display_sequence=>3
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(47919210363646906)
,p_name=>'Recently Edited Pages'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'REGION_POSITION_03'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||name p, id',
'from wwv_flow_steps',
'where security_group_id = :flow_security_group_id and',
'     flow_id = :fb_flow_id',
'order by last_updated_on desc'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(11667910335347890)
,p_query_num_rows=>8
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report contains no data'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>9
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47919416222646922)
,p_query_column_id=>1
,p_column_alias=>'P'
,p_column_display_sequence=>1
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=4000:14:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID,P14_PAGE_ID:&FB_FLOW_ID.,#ID#,#ID#'
,p_column_linktext=>'#P#'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47919511948646926)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(184302302519207936)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(47787001885565213)
,p_button_name=>'P14_SET'
,p_button_static_id=>'P14_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Set'
,p_request_source=>'Set'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(450468132057399936)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(47889025485176587)
,p_button_name=>'MANAGE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'Manage'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:638:&SESSION.::&DEBUG.:RP,638,RIR:IR_ID,IR_APPLICATION:&FB_FLOW_PAGE_ID.,&FB_FLOW_ID.'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(47884813617116371)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(47883828808092400)
,p_button_name=>'MANAGE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'Manage'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:656:&SESSION.::&DEBUG.:RP,656,RIR:IR_PAGE_ID,IR_APPLICATION_ID:&FB_FLOW_PAGE_ID.,&FB_FLOW_ID.'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(198312403858815719)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47787001885565213)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:14:&SESSION.::&DEBUG.:14,RIR::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(47922932105747760)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(47787001885565213)
,p_button_name=>'EDIT_PAGE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'Edit Page'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(47923227997747766)
,p_branch_action=>'f?p=&FLOW_ID.:4500:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(47922932105747760)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(47835110868816623)
,p_branch_action=>'f?p=&APP_ID.:14:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47833932555813419)
,p_name=>'P14_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(47787001885565213)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Page'
,p_source=>'FB_FLOW_PAGE_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||name||decode(alias,null,null,'' (''||alias||'')'') n, id',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID',
'order by id'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Select a page to view.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47888310894144042)
,p_name=>'P14_TIME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(47787001885565213)
,p_item_default=>'1'
,p_prompt=>'Since'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME STATIC'
,p_lov=>'.'||wwv_flow_imp.id(94747000503182513)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Constrain the reporting of page activity to the selected time period.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(47837727622830904)
,p_computation_sequence=>10
,p_computation_item=>'FB_FLOW_PAGE_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'&P14_PAGE_ID.'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(47838825114849107)
,p_validation_name=>'P14_PAGE_ID'
,p_validation_sequence=>10
,p_validation=>'P14_PAGE_ID'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Page ID must be numeric'
,p_when_button_pressed=>wwv_flow_imp.id(184302302519207936)
,p_associated_item=>wwv_flow_imp.id(47833932555813419)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00016
begin
wwv_flow_imp_page.create_page(
 p_id=>16
,p_name=>'Lock Script'
,p_alias=>'LOCK-SCRIPT'
,p_page_mode=>'MODAL'
,p_step_title=>'&P16_DIALOG_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(24897722063538624)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(857293913086873803)
,p_plug_name=>'Lock Script'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_lock.user_can_edit_script (',
'    p_flow_id => :FB_FLOW_ID,',
'    p_script_id => :P16_LOCK_SCRIPT_ID',
'    )'))
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<p>Locking a script will ensure no other developer will change the definition of a script you lock.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(857809279363486436)
,p_name=>'Lock History'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>60
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select l.action, lower(l.locked_by) locked_by, l.action_date, l.lock_comment',
'from wwv_flow_lock_script_log l',
'where l.flow_id = :fb_flow_id',
'and l.security_group_id = :flow_security_group_id',
'and l.script_id = :P16_LOCK_SCRIPT_ID',
'order by action_date desc'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>50
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'no data found'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(857809520225486469)
,p_query_column_id=>1
,p_column_alias=>'ACTION'
,p_column_display_sequence=>1
,p_column_heading=>'Action'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(857850100888646856)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(857809602446486470)
,p_query_column_id=>2
,p_column_alias=>'LOCKED_BY'
,p_column_display_sequence=>2
,p_column_heading=>'By'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(857809705448486470)
,p_query_column_id=>3
,p_column_alias=>'ACTION_DATE'
,p_column_display_sequence=>3
,p_column_heading=>'Action Date'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(857809821861486470)
,p_query_column_id=>4
,p_column_alias=>'LOCK_COMMENT'
,p_column_display_sequence=>4
,p_column_heading=>'Lock Comment'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(857863288085728296)
,p_plug_name=>'wizard buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(926468845781223113)
,p_plug_name=>'Script Locked'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>50
,p_plug_item_display_point=>'BELOW'
,p_plug_query_num_rows=>15
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not wwv_flow_lock.user_can_edit_script (',
'    p_flow_id => :FB_FLOW_ID,',
'    p_script_id => :P16_LOCK_SCRIPT_ID',
'    ) and :P16_LOCK_ID is not null'))
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(925767723087802479)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(857863288085728296)
,p_button_name=>'UNLOCK'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Unlock'
,p_button_position=>'NEXT'
,p_button_condition=>'wwv_flow_lock.script_locked_by_user ( p_flow_id => :FB_FLOW_ID, p_script_id => :P16_LOCK_SCRIPT_ID ) and :P16_LOCK_ID is not null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(857294308077873806)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(857863288085728296)
,p_button_name=>'LOCK'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Lock Script'
,p_button_position=>'NEXT'
,p_button_condition=>'not wwv_flow_lock.script_locked ( p_flow_id => :FB_FLOW_ID, p_script_id => :P16_LOCK_SCRIPT_ID ) and :P16_LOCK_ID is null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(925768245001805108)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(857863288085728296)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'wwv_flow_lock.script_locked_by_user ( p_flow_id => :FB_FLOW_ID, p_script_id => :P16_LOCK_SCRIPT_ID ) and :P16_LOCK_ID is not null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(857294120953873806)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(857863288085728296)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(857294522125873807)
,p_name=>'P16_LOCK_SCRIPT_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(857293913086873803)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Lock Script:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name',
'from wwv_flow_install_scripts',
'where id = :P16_LOCK_SCRIPT_ID',
'and security_group_id = :flow_security_group_id',
'and flow_id = :fb_flow_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Name of the script to be locked.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(857295009620873810)
,p_name=>'P16_LOCK_COMMENT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(857293913086873803)
,p_prompt=>'Comment'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>8
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Comment to be applied to the locked script.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(857367779517306179)
,p_name=>'P16_LOCK_SCRIPT_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(857293913086873803)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(857368496709311259)
,p_name=>'P16_LOCK_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(857293913086873803)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(926470319613246860)
,p_name=>'P16_LOCKED_SCRIPT_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(926468845781223113)
,p_prompt=>'Script Name'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_lov_display_extra=>'YES'
,p_help_text=>'Name of the script that is locked.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(926470737226249910)
,p_name=>'P16_LOCKED_DATE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(926468845781223113)
,p_prompt=>'Locked On'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_lov_display_extra=>'YES'
,p_help_text=>'The date when the script was locked.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(926471089519252574)
,p_name=>'P16_LOCKED_BY'
,p_item_sequence=>65
,p_item_plug_id=>wwv_flow_imp.id(926468845781223113)
,p_prompt=>'Locked By'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_lov_display_extra=>'YES'
,p_help_text=>'The name of the developer who currently holds the script lock.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(926591597780542250)
,p_name=>'P16_LOCKED_BY2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(857293913086873803)
,p_prompt=>'Locked By'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'P16_LOCK_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_lov_display_extra=>'YES'
,p_help_text=>'The name of the developer who currently holds the script lock.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(926764581682021791)
,p_name=>'P16_DIALOG_TITLE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(857293913086873803)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(933185021779887582)
,p_name=>'P16_STEAL_LOCK_LINK'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(926468845781223113)
,p_prompt=>'Steal Lock'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'PLSQL'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<a href="''||wwv_flow_utilities.prepare_url(''f?p=4000:342:''||wwv_flow.g_instance||'':::342:P342_LOCK_SCRIPT_ID:''||:P16_LOCK_SCRIPT_ID)||',
'          ''">''||wwv_flow_escape.html(wwv_flow_lang.system_message(''STEAL_LOCK''))||''</a>'');'))
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(857372917911602720)
,p_computation_sequence=>10
,p_computation_item=>'P16_LOCK_COMMENT'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select lock_comment',
'from wwv_flow_lock_script',
'where id = :P16_LOCK_ID',
'and security_group_id = :flow_security_group_id',
'and flow_id = :fb_flow_id'))
,p_compute_when=>'P16_LOCK_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(926764764486030995)
,p_computation_sequence=>10
,p_computation_item=>'P16_DIALOG_TITLE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P16_LOCK_ID is not null then',
'     return  wwv_flow_lang.system_message(''EDIT_LOCK'');',
'else',
'     return  wwv_flow_lang.system_message(''LOCK_SCRIPT'');',
'end if;',
'  '))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(857295664133873811)
,p_validation_name=>'P16_LOCK_COMMENT'
,p_validation_sequence=>10
,p_validation=>'P16_LOCK_COMMENT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_validation_condition=>'LOCK, APPLY_CHANGES'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_when_button_pressed=>wwv_flow_imp.id(857294308077873806)
,p_associated_item=>wwv_flow_imp.id(857295009620873810)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(933181156432819747)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(857294120953873806)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(933181453950819748)
,p_event_id=>wwv_flow_imp.id(933181156432819747)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(857295705674873816)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'lock script'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_lock.lock_script (',
'    p_flow_id   => :FB_FLOW_ID,',
'    p_script_id => :P16_LOCK_SCRIPT_ID,',
'    p_comment   => :P16_LOCK_COMMENT);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to lock the script.'
,p_process_when_button_id=>wwv_flow_imp.id(857294308077873806)
,p_process_success_message=>'Script locked.'
,p_internal_uid=>857295705674873816
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(925770973953909129)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'unlock script'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_lock.unlock_script (',
'    p_id        => :P16_LOCK_ID,',
'    p_flow_id   => :FB_FLOW_ID);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to unlock the script.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(925767723087802479)
,p_process_when=>'P16_LOCK_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_process_success_message=>'Script unlocked.'
,p_internal_uid=>925770973953909129
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(925771119057935970)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update lock comment'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_lock.update_script_lock_comment (',
'    p_id        => :P16_LOCK_ID,',
'    p_flow_id   => :FB_FLOW_ID,',
'    p_comment => :P16_LOCK_COMMENT );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to update the comment.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(925768245001805108)
,p_process_when=>'P16_LOCK_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_process_success_message=>'Comment updated.'
,p_internal_uid=>925771119057935970
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(933181755880823470)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>933181755880823470
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(926575287274348044)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate locked script display items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select name',
'           from wwv_flow_install_scripts',
'           where id = :P16_LOCK_SCRIPT_ID',
'           and security_group_id = :flow_security_group_id',
'           and flow_id = :fb_flow_id)',
'loop',
'    :P16_LOCKED_SCRIPT_NAME := c1.name;',
'end loop;',
'',
'for c1 in (select locked_on, locked_by',
'                from wwv_flow_lock_script',
'                where id = :P16_LOCK_ID',
'                and security_group_id = :flow_security_group_id',
'                and flow_id = :fb_flow_id)',
'loop',
'    :P16_LOCKED_DATE := htmldb_util.get_since(c1.locked_on);',
'    :P16_LOCKED_BY := lower(c1.locked_by);',
'    :P16_LOCKED_BY2 := lower(c1.locked_by);',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P16_LOCKED_ID'
,p_process_when_type=>'ITEM_IS_NULL'
,p_internal_uid=>926575287274348044
);
end;
/
prompt --application/pages/page_00017
begin
wwv_flow_imp_page.create_page(
 p_id=>17
,p_name=>'Substitutions'
,p_alias=>'SUBSTITUTIONS'
,p_step_title=>'Substitutions'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(24897722063538624)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deployment.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(6077013252398487)
,p_name=>'Application Substitutions'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>150
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with ss as (select substitution_string_01 ss01, substitution_value_01 sv01, htmldb_item.checkbox(1,01,decode(PROMPT_SUBSTITUTION_01_YN,''Y'',''CHECKED'',null)) c01, htmldb_item.text(2,install_prompt_01,40,255) p01,',
'                   substitution_string_02 ss02, substitution_value_02 sv02, htmldb_item.checkbox(1,02,decode(PROMPT_SUBSTITUTION_02_YN,''Y'',''CHECKED'',null)) c02, htmldb_item.text(2,install_prompt_02,40,255) p02,',
'                   substitution_string_03 ss03, substitution_value_03 sv03, htmldb_item.checkbox(1,03,decode(PROMPT_SUBSTITUTION_03_YN,''Y'',''CHECKED'',null)) c03, htmldb_item.text(2,install_prompt_03,40,255) p03,',
'                   substitution_string_04 ss04, substitution_value_04 sv04, htmldb_item.checkbox(1,04,decode(PROMPT_SUBSTITUTION_04_YN,''Y'',''CHECKED'',null)) c04, htmldb_item.text(2,install_prompt_04,40,255) p04,',
'                   substitution_string_05 ss05, substitution_value_05 sv05, htmldb_item.checkbox(1,05,decode(PROMPT_SUBSTITUTION_05_YN,''Y'',''CHECKED'',null)) c05, htmldb_item.text(2,install_prompt_05,40,255) p05,',
'                   substitution_string_06 ss06, substitution_value_06 sv06, htmldb_item.checkbox(1,06,decode(PROMPT_SUBSTITUTION_06_YN,''Y'',''CHECKED'',null)) c06, htmldb_item.text(2,install_prompt_06,40,255) p06,',
'                   substitution_string_07 ss07, substitution_value_07 sv07, htmldb_item.checkbox(1,07,decode(PROMPT_SUBSTITUTION_07_YN,''Y'',''CHECKED'',null)) c07, htmldb_item.text(2,install_prompt_07,40,255) p07,',
'                   substitution_string_08 ss08, substitution_value_08 sv08, htmldb_item.checkbox(1,08,decode(PROMPT_SUBSTITUTION_08_YN,''Y'',''CHECKED'',null)) c08, htmldb_item.text(2,install_prompt_08,40,255) p08,',
'                   substitution_string_09 ss09, substitution_value_09 sv09, htmldb_item.checkbox(1,09,decode(PROMPT_SUBSTITUTION_09_YN,''Y'',''CHECKED'',null)) c09, htmldb_item.text(2,install_prompt_09,40,255) p09,',
'                   substitution_string_10 ss10, substitution_value_10 sv10, htmldb_item.checkbox(1,10,decode(PROMPT_SUBSTITUTION_10_YN,''Y'',''CHECKED'',null)) c10, htmldb_item.text(2,install_prompt_10,40,255) p10,',
'                   substitution_string_11 ss11, substitution_value_11 sv11, htmldb_item.checkbox(1,11,decode(PROMPT_SUBSTITUTION_11_YN,''Y'',''CHECKED'',null)) c11, htmldb_item.text(2,install_prompt_11,40,255) p11,',
'                   substitution_string_12 ss12, substitution_value_12 sv12, htmldb_item.checkbox(1,12,decode(PROMPT_SUBSTITUTION_12_YN,''Y'',''CHECKED'',null)) c12, htmldb_item.text(2,install_prompt_12,40,255) p12,',
'                   substitution_string_13 ss13, substitution_value_13 sv13, htmldb_item.checkbox(1,13,decode(PROMPT_SUBSTITUTION_13_YN,''Y'',''CHECKED'',null)) c13, htmldb_item.text(2,install_prompt_13,40,255) p13,',
'                   substitution_string_14 ss14, substitution_value_14 sv14, htmldb_item.checkbox(1,14,decode(PROMPT_SUBSTITUTION_14_YN,''Y'',''CHECKED'',null)) c14, htmldb_item.text(2,install_prompt_14,40,255) p14,',
'                   substitution_string_15 ss15, substitution_value_15 sv15, htmldb_item.checkbox(1,15,decode(PROMPT_SUBSTITUTION_15_YN,''Y'',''CHECKED'',null)) c15, htmldb_item.text(2,install_prompt_15,40,255) p15,',
'                   substitution_string_16 ss16, substitution_value_16 sv16, htmldb_item.checkbox(1,16,decode(PROMPT_SUBSTITUTION_16_YN,''Y'',''CHECKED'',null)) c16, htmldb_item.text(2,install_prompt_16,40,255) p16,',
'                   substitution_string_17 ss17, substitution_value_17 sv17, htmldb_item.checkbox(1,17,decode(PROMPT_SUBSTITUTION_17_YN,''Y'',''CHECKED'',null)) c17, htmldb_item.text(2,install_prompt_17,40,255) p17,',
'                   substitution_string_18 ss18, substitution_value_18 sv18, htmldb_item.checkbox(1,18,decode(PROMPT_SUBSTITUTION_18_YN,''Y'',''CHECKED'',null)) c18, htmldb_item.text(2,install_prompt_18,40,255) p18,',
'                   substitution_string_19 ss19, substitution_value_19 sv19, htmldb_item.checkbox(1,19,decode(PROMPT_SUBSTITUTION_19_YN,''Y'',''CHECKED'',null)) c19, htmldb_item.text(2,install_prompt_19,40,255) p19,',
'                   substitution_string_20 ss20, substitution_value_20 sv20, htmldb_item.checkbox(1,20,decode(PROMPT_SUBSTITUTION_20_YN,''Y'',''CHECKED'',null)) c20, htmldb_item.text(2,install_prompt_20,40,255) p20',
'              from wwv_flows, wwv_flow_install',
'             where wwv_flows.id = wwv_flow_install.flow_id',
'               and wwv_flows.id = :FB_FLOW_ID',
'               and wwv_flows.security_group_id = :flow_security_group_id)',
'select * from (',
'(select ss01 s, sv01 v, c01 c, p01 p, 01 ord from ss) union',
'(select ss02 s, sv02 v, c02 c, p02 p, 02 ord from ss) union',
'(select ss03 s, sv03 v, c03 c, p03 p, 03 ord from ss) union',
'(select ss04 s, sv04 v, c04 c, p04 p, 04 ord from ss) union',
'(select ss05 s, sv05 v, c05 c, p05 p, 05 ord from ss) union',
'(select ss06 s, sv06 v, c06 c, p06 p, 06 ord from ss) union',
'(select ss07 s, sv07 v, c07 c, p07 p, 07 ord from ss) union',
'(select ss08 s, sv08 v, c08 c, p08 p, 08 ord from ss) union',
'(select ss09 s, sv09 v, c09 c, p09 p, 09 ord from ss) union',
'(select ss10 s, sv10 v, c10 c, p10 p, 10 ord from ss) union',
'(select ss11 s, sv11 v, c11 c, p11 p, 11 ord from ss) union',
'(select ss12 s, sv12 v, c12 c, p12 p, 12 ord from ss) union',
'(select ss13 s, sv13 v, c13 c, p13 p, 13 ord from ss) union',
'(select ss14 s, sv14 v, c14 c, p14 p, 14 ord from ss) union',
'(select ss15 s, sv15 v, c15 c, p15 p, 15 ord from ss) union',
'(select ss16 s, sv16 v, c16 c, p16 p, 16 ord from ss) union',
'(select ss17 s, sv17 v, c17 c, p17 p, 17 ord from ss) union',
'(select ss18 s, sv18 v, c18 c, p18 p, 18 ord from ss) union',
'(select ss19 s, sv19 v, c19 c, p19 p, 19 ord from ss) union',
'(select ss20 s, sv20 v, c20 c, p20 p, 20 ord from ss))',
'where s is not null',
'order by ord'))
,p_header=>'<p>Identify the application substitution strings that a user may change when installing this application.</p>'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>20
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'The application has no substitutions.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(6077324496398511)
,p_query_column_id=>1
,p_column_alias=>'S'
,p_column_display_sequence=>2
,p_column_heading=>'Substitution String'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(6077407868398514)
,p_query_column_id=>2
,p_column_alias=>'V'
,p_column_display_sequence=>3
,p_column_heading=>'Current Value'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(6081409368492000)
,p_query_column_id=>3
,p_column_alias=>'C'
,p_column_display_sequence=>1
,p_column_heading=>'Prompt?'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7142703348111918)
,p_query_column_id=>4
,p_column_alias=>'P'
,p_column_display_sequence=>4
,p_column_heading=>'Prompt Text'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7218207578368645)
,p_query_column_id=>5
,p_column_alias=>'ORD'
,p_column_display_sequence=>5
,p_column_heading=>'Ord'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22504624486376355)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>90
,p_list_id=>wwv_flow_imp.id(22452018965176093)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(24432314869923448)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(24172418538839346)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(34010017345903944)
,p_plug_name=>'Substitutions'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>125
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(805631924001213)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(34010017345903944)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(805419391001212)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(34010017345903944)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'EDIT'
,p_button_condition=>'P17_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(29828621631478615)
,p_branch_name=>'Go To Page &P567_BRANCH_PAGE.'
,p_branch_action=>'f?p=&APP_ID.:&P567_BRANCH_PAGE.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'substr(:REQUEST,1,13) = ''APPLY_CHANGES'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(806212022001219)
,p_branch_action=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(806418611001222)
,p_name=>'P17_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(6077013252398487)
,p_prompt=>'Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(29832404447483121)
,p_computation_sequence=>10
,p_computation_item=>'P567_BRANCH_PAGE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'substr(v(''REQUEST''),15)'
,p_compute_when=>'substr(:REQUEST,1,13) = ''APPLY_CHANGES'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(908310264063515)
,p_computation_sequence=>10
,p_computation_item=>'P17_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>'select id from wwv_flow_install where flow_id = :fb_flow_id'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(6121000261706964)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'process sub strings'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  yn wwv_flow_global.vc_arr2;',
'  prompts wwv_flow_global.vc_arr2;',
'begin',
'  for i in 1..20 loop',
'    yn(i) := ''N'';',
'    if i <= htmldb_application.g_f02.count then',
'      prompts(i) := htmldb_application.g_f02(i);',
'    else',
'      prompts(i) := null;',
'    end if;',
'  end loop;',
'  ',
'  for i in 1..htmldb_application.g_f01.count loop',
'    yn(htmldb_application.g_f01(i)) := ''Y'';',
'  end loop;',
'  ',
'  update wwv_flow_install',
'     set prompt_substitution_01_yn = yn(01), install_prompt_01 = prompts(1),',
'         prompt_substitution_02_yn = yn(02), install_prompt_02 = prompts(2),',
'         prompt_substitution_03_yn = yn(03), install_prompt_03 = prompts(3),',
'         prompt_substitution_04_yn = yn(04), install_prompt_04 = prompts(4),',
'         prompt_substitution_05_yn = yn(05), install_prompt_05 = prompts(5),',
'         prompt_substitution_06_yn = yn(06), install_prompt_06 = prompts(6),',
'         prompt_substitution_07_yn = yn(07), install_prompt_07 = prompts(7),',
'         prompt_substitution_08_yn = yn(08), install_prompt_08 = prompts(8),',
'         prompt_substitution_09_yn = yn(09), install_prompt_09 = prompts(9),     ',
'         prompt_substitution_10_yn = yn(10), install_prompt_10 = prompts(10),',
'         prompt_substitution_11_yn = yn(11), install_prompt_11 = prompts(11),',
'         prompt_substitution_12_yn = yn(12), install_prompt_12 = prompts(12),',
'         prompt_substitution_13_yn = yn(13), install_prompt_13 = prompts(13),',
'         prompt_substitution_14_yn = yn(14), install_prompt_14 = prompts(14),',
'         prompt_substitution_15_yn = yn(15), install_prompt_15 = prompts(15),',
'         prompt_substitution_16_yn = yn(16), install_prompt_16 = prompts(16),',
'         prompt_substitution_17_yn = yn(17), install_prompt_17 = prompts(17),',
'         prompt_substitution_18_yn = yn(18), install_prompt_18 = prompts(18),',
'         prompt_substitution_19_yn = yn(19), install_prompt_19 = prompts(19),',
'         prompt_substitution_20_yn = yn(20), install_prompt_20 = prompts(20)',
'   where flow_id = :FB_FLOW_ID',
'     and security_group_id = :flow_security_group_id;',
'     ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Could not update substitution string prompts. '
,p_process_when=>'substr(:REQUEST,1,13) = ''APPLY_CHANGES'' or :REQUEST = ''SAVE'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>6121000261706964
);
end;
/
prompt --application/pages/page_00019
begin
wwv_flow_imp_page.create_page(
 p_id=>19
,p_name=>'Debug Message Data'
,p_alias=>'DEBUG-MESSAGE-DATA'
,p_step_title=>'Debug Message Data'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(19943204431962826)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'debug.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(451745516764288584)
,p_plug_name=>'Debug Page Events'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>40
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /*min(session_id)||',
'       case',
'         when min(session_id)<>max(session_id)',
'         then ''-''||max(session_id)',
'       end session_id,*/',
'',
'       case',
'         when min(case when session_id > 0 then session_id end)<>max(session_id)',
'         then min(case when session_id > 0 then session_id end)||''-''',
'       end||',
'       max(session_id) session_id,',
'       max(apex_user) apex_user,',
'       page_view_id,',
'       max(workflow_instance_id) workflow_instance_id,',
'       max(flow_id)||''.''||max(page_id) application_page,',
'       min(message_timestamp) message_timestamp,',
'       count(*) debug_entries,',
'       max(flow_id) application_id,',
'       max(page_id) page_id,',
'       max(elap) elapsed,',
'       substr (',
'           max(case',
'               when message like ''R E Q U E S T accept%'' then ''4''||substr(message, 15)',
'               when message like ''R E Q U E S T %'' then ''3''||substr(message, 15)',
'               when message = ''CGI: PATH_INFO = /f''    then ''2show''',
'               when message like ''CGI: PATH_INFO =%'' then ''1''||substr(message, 19)',
'               end),',
'           2 ) path_info',
'  from ( select * from wwv_flow_debug_messages',
'          union all',
'         select * from wwv_flow_debug_messages2 )',
' where security_group_id = :flow_security_group_id',
' group by page_view_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(451745617575288584)
,p_name=>'Debug Page Events'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(451745915660288595)
,p_db_column_name=>'APEX_USER'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'User'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(451746027116288596)
,p_db_column_name=>'PAGE_VIEW_ID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'View Identifier'
,p_column_link=>'f?p=&APP_ID.:939:&SESSION.::&DEBUG.:RP,939:P939_PAGE_VIEW_ID:#PAGE_VIEW_ID#'
,p_column_linktext=>'#PAGE_VIEW_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(200285411217572207)
,p_db_column_name=>'SESSION_ID'
,p_display_order=>4
,p_column_identifier=>'O'
,p_column_label=>'Session Id'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(451746423209288600)
,p_db_column_name=>'DEBUG_ENTRIES'
,p_display_order=>8
,p_column_identifier=>'G'
,p_column_label=>'Entries'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(451757121762330962)
,p_db_column_name=>'APPLICATION_PAGE'
,p_display_order=>9
,p_column_identifier=>'H'
,p_column_label=>'Application Page'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(451758608748337865)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>11
,p_column_identifier=>'J'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(451758726364337866)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>12
,p_column_identifier=>'K'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1803076738977028)
,p_db_column_name=>'WORKFLOW_INSTANCE_ID'
,p_display_order=>22
,p_column_identifier=>'P'
,p_column_label=>'Workflow Instance'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(452246807467087260)
,p_db_column_name=>'MESSAGE_TIMESTAMP'
,p_display_order=>32
,p_column_identifier=>'L'
,p_column_label=>'Timestamp'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(452246921820087280)
,p_db_column_name=>'ELAPSED'
,p_display_order=>42
,p_column_identifier=>'M'
,p_column_label=>'Seconds'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D0000'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(200165700725954119)
,p_db_column_name=>'PATH_INFO'
,p_display_order=>52
,p_column_identifier=>'N'
,p_column_label=>'Path Info'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(451746507039288843)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1298029587536645'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_display_rows=>100
,p_report_columns=>'PAGE_VIEW_ID:SESSION_ID:APEX_USER:APPLICATION_ID:PAGE_ID:PATH_INFO:DEBUG_ENTRIES:MESSAGE_TIMESTAMP:ELAPSED:'
,p_sort_column_1=>'PAGE_VIEW_ID'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(451750804531307064)
,p_plug_name=>'Finder Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_imp.id(6207014968942318)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(451761424794350824)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(451745516764288584)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:19:&SESSION.::&DEBUG.:19,RIR::'
);
end;
/
prompt --application/pages/page_00020
begin
wwv_flow_imp_page.create_page(
 p_id=>20
,p_name=>'Confirm Delete'
,p_alias=>'CONFIRM-DELETE'
,p_step_title=>'Confirm Delete'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213220627333807318)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_del_app.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(105023911750)
,p_plug_name=>'Confirm Delete'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>You have requested the permanent deletion of application <strong>&P20_APP_NAME. (&FB_FLOW_ID.)</strong>.  Please confirm your delete request.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(30939528178552245)
,p_name=>'Pages'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||'' - ''||name n',
'from wwv_flow_steps',
'where flow_id = :fb_flow_id',
'and security_group_id = :flow_security_group_id',
'order by id'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(11667910335347890)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No pages found'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(30940117776552261)
,p_query_column_id=>1
,p_column_alias=>'N'
,p_column_display_sequence=>1
,p_column_heading=>'Page Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46518431282125423)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(67457413423328017)
,p_name=>'Cascade Drop to Include Translated Applications'
,p_template=>wwv_flow_imp.id(42025417508627628)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select TRANSLATION_FLOW_ID,',
'       TRANSLATION_COMMENTS,',
'       PRIMARY_LANGUAGE_FLOW_ID',
'  from WWV_FLOW_LANGUAGE_MAP',
' where PRIMARY_LANGUAGE_FLOW_ID = :fb_flow_id',
' order by TRANSLATION_FLOW_ID'))
,p_display_when_condition=>'select 1 c from wwv_flow_language_map where primary_language_flow_id = :fb_flow_id'
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report contains no data'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(67459100081328032)
,p_query_column_id=>1
,p_column_alias=>'TRANSLATION_FLOW_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Translation Application'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(67459305999328032)
,p_query_column_id=>2
,p_column_alias=>'TRANSLATION_COMMENTS'
,p_column_display_sequence=>2
,p_column_heading=>'Translation Comments'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(67463710300345599)
,p_query_column_id=>3
,p_column_alias=>'PRIMARY_LANGUAGE_FLOW_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Primary Language Application'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747136922680138150)
,p_plug_name=>'Confirm Delete'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(105031946218)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46518431282125423)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:RP::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(105027942711)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(46518431282125423)
,p_button_name=>'DELETE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Permanently Delete Now'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(17859517579729759)
,p_branch_action=>'f?p=&APP_ID.:1500:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(105027942711)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(105034946220)
,p_branch_action=>'1500'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6524159070526318)
,p_name=>'P20_DELETE_FEEDBACK'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(105023911750)
,p_prompt=>'Delete Feedback'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_feedback',
' where application_id    = :F4000_P20_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'If you are planning to recreate this application using the same ID, you may want to keep your feedback.  If not, you should delete it so that it does not become associated with another application using this application number in the future.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57270914427796939)
,p_name=>'F4000_P20_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(105023911750)
,p_use_cache_before_default=>'NO'
,p_prompt=>'F4000_P20_FLOW_ID'
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(193632127365783582)
,p_name=>'P20_APP_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(105023911750)
,p_source=>'select name from wwv_flows where id = :FB_FLOW_ID'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(201886806068920618)
,p_name=>'P20_APPLICATION_DELETED'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(105023911750)
,p_source=>'wwv_flow_lang.system_message(''APPLICATION_DELETED'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(193661817584799666)
,p_computation_sequence=>10
,p_computation_item=>'P20_APP_NAME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>'select name from wwv_flows where id = :FB_FLOW_ID'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2415155555013314)
,p_validation_name=>'Check for working copies'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not wwv_flow_working_copy_dev.app_has_working_copy (',
'    p_application_id    => :F4000_P20_FLOW_ID,',
'    p_security_group_id => :WORKSPACE_ID )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Application cannot be deleted, as it has one or more working copies.'
,p_when_button_pressed=>wwv_flow_imp.id(105027942711)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(390436471194898140)
,p_name=>'Show Success Message'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(105027942711)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(390436584917898141)
,p_event_id=>wwv_flow_imp.id(390436471194898140)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'DELETE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(105038046820)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Flow'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P20_DELETE_FEEDBACK = ''Y'' then',
'    wwv_flow_imp.remove_application (',
'    p_application_id  => :F4000_P20_FLOW_ID,',
'    p_delete_feedback => true);',
'else',
'    wwv_flow_imp.remove_application (',
'    p_application_id  => :F4000_P20_FLOW_ID);',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error deleting application &F4000_P20_FLOW_ID..'
,p_process_when_button_id=>wwv_flow_imp.id(105027942711)
,p_process_success_message=>'Application &F4000_P20_FLOW_ID. deleted.'
,p_internal_uid=>105038046820
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(813180162)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Clean up Cache on Delete'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow.update_cache_with_write (''FB_FLOW_ID'',null);',
'wwv_flow.update_cache_with_write (''FB_FLOW_NAME'',null);',
'wwv_flow.update_cache_with_write (''FB_FLOW_PAGE_ID'',''1'');',
'wwv_flow.update_cache_with_write (''F4000_P1_PAGE'',''1'');',
'wwv_flow.update_cache_with_write (''F4000_P1_FLOW'',null);',
'',
'for c1 in (select min(id) min_id ',
'             from wwv_flows ',
'            where security_group_id = :flow_security_group_id',
'              and build_status = ''RUN_AND_BUILD'') loop',
'   wwv_flow.update_cache_with_write (''FB_FLOW_ID'',c1.min_id);',
'   wwv_flow.update_cache_with_write (''F4000_P1_FLOW'',c1.min_id);',
'   for c2 in (select min(id) p from wwv_flow_steps where flow_id = nv(''FB_FLOW_ID'')) loop',
'      wwv_flow.update_cache_with_write (''FB_FLOW_PAGE_ID'',c2.p);',
'      wwv_flow.update_cache_with_write (''F4000_P1_PAGE'',c2.p);',
'   end loop;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error performing process.'
,p_process_when_button_id=>wwv_flow_imp.id(105027942711)
,p_internal_uid=>813180162
);
end;
/
prompt --application/pages/page_00021
begin
wwv_flow_imp_page.create_page(
 p_id=>21
,p_name=>'Confirm Page Delete'
,p_alias=>'CONFIRM-PAGE-DELETE'
,p_step_title=>'Confirm Page Delete'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_del_pg.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(105124238853)
,p_plug_name=>'Confirm Delete'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'You have requested the permanent deletion of page &FB_FLOW_PAGE_ID. within application &FB_FLOW_ID., please confirm your delete request.',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(2017380840377444)
,p_name=>'Active Background Executions'
,p_parent_plug_id=>wwv_flow_imp.id(105124238853)
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--simple'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select e.id,',
'       p.process_name,',
'       e.status,',
'       e.started_from_session_id,',
'       e.created_on',
'  from wwv_flow_process_bg_execs$ e,',
'       wwv_flow_step_processing   p',
' where p.security_group_id = e.security_group_id',
'   and p.flow_id           = e.flow_id',
'   and p.flow_step_id      = e.page_id',
'   and p.id                = e.process_id',
'    --',
'   and e.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and e.flow_id           = :FB_FLOW_ID',
'   and e.page_id           = :FB_FLOW_PAGE_ID',
'   and e.status in ( ''SCHEDUED'', ''ENQUEUED'', ''EXECUTING'' )   ',
'   '))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_process_bg_execs$ e',
' where e.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and e.flow_id           = :FB_FLOW_ID',
'   and e.page_id           = :FB_FLOW_PAGE_ID',
'   and e.status in ( ''SCHEDUED'', ''ENQUEUED'', ''EXECUTING'' )'))
,p_display_condition_type=>'EXISTS'
,p_header=>'The following background executions will be terminated when the page is deleted.'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2017451829377445)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>10
,p_column_heading=>'Execution ID'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2017597076377446)
,p_query_column_id=>2
,p_column_alias=>'PROCESS_NAME'
,p_column_display_sequence=>20
,p_column_heading=>'Process'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2017668016377447)
,p_query_column_id=>3
,p_column_alias=>'STATUS'
,p_column_display_sequence=>30
,p_column_heading=>'Status'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(1814559837736230)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2017759975377448)
,p_query_column_id=>4
,p_column_alias=>'STARTED_FROM_SESSION_ID'
,p_column_display_sequence=>40
,p_column_heading=>'Session ID'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2017846586377449)
,p_query_column_id=>5
,p_column_alias=>'CREATED_ON'
,p_column_display_sequence=>50
,p_column_heading=>'Created On'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(139075200358595324)
,p_name=>'Corresponding List Entries'
,p_parent_plug_id=>wwv_flow_imp.id(105124238853)
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--simple'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select (select name',
'          from wwv_flow_lists',
'         where id = wwv_flow_list_items.list_id ) list_name,',
'	   list_item_link_target,',
'       list_item_link_text',
'  from wwv_flow_list_items',
' where flow_id                         = :FB_FLOW_ID',
'   and security_group_id               = :FLOW_SECURITY_GROUP_ID',
'   and upper(list_item_link_target) like ''F?P=%:''||:FB_FLOW_PAGE_ID||'':%''',
'   -- don''t show associated list items in this report',
'   -- because these list items are always deleted',
'   and (    list_item_current_for_pages is null ',
'         or list_item_current_for_pages != :FB_FLOW_PAGE_ID  )',
''))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_list_items',
' where flow_id                         = :FB_FLOW_ID ',
'   and security_group_id               = :FLOW_SECURITY_GROUP_ID',
'   and upper(list_item_link_target) like ''F?P=%:''||:FB_FLOW_PAGE_ID||'':%'''))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(139105515090713159)
,p_query_column_id=>1
,p_column_alias=>'LIST_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'List Name'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(139075714642595328)
,p_query_column_id=>2
,p_column_alias=>'LIST_ITEM_LINK_TARGET'
,p_column_display_sequence=>3
,p_column_heading=>'Target'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(139105612305713160)
,p_query_column_id=>3
,p_column_alias=>'LIST_ITEM_LINK_TEXT'
,p_column_display_sequence=>2
,p_column_heading=>'List Entry'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(161346930548564972)
,p_name=>'Associated List Items'
,p_parent_plug_id=>wwv_flow_imp.id(105124238853)
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--simple'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch:a-Report--rowHighlight'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select l.name list_name,',
'       i.list_item_link_text,',
'       i.list_item_link_target,',
'       i.list_item_current_for_pages',
'  from wwv_flow_list_items i,',
'       wwv_flow_lists l',
' where l.flow_id                     = :FB_FLOW_ID ',
'   and i.list_id                     = l.id ',
'   and i.list_item_current_for_pages = :FB_FLOW_PAGE_ID',
'   and l.security_group_id           = :FLOW_SECURITY_GROUP_ID'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_list_items i,',
'       wwv_flow_lists l',
' where l.flow_id                     = :FB_FLOW_ID ',
'   and i.list_id                     = l.id ',
'   and i.list_item_current_for_pages = :FB_FLOW_PAGE_ID',
'   and l.security_group_id           = :FLOW_SECURITY_GROUP_ID'))
,p_display_condition_type=>'EXISTS'
,p_header=>'The following list items will be removed.'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Report returned no rows.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(161347503194564990)
,p_query_column_id=>1
,p_column_alias=>'LIST_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'List Name'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(161347618377564990)
,p_query_column_id=>2
,p_column_alias=>'LIST_ITEM_LINK_TEXT'
,p_column_display_sequence=>2
,p_column_heading=>'List Item Name'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(161354614533579276)
,p_query_column_id=>3
,p_column_alias=>'LIST_ITEM_LINK_TARGET'
,p_column_display_sequence=>3
,p_column_heading=>'Target'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(161408529228744348)
,p_query_column_id=>4
,p_column_alias=>'LIST_ITEM_CURRENT_FOR_PAGES'
,p_column_display_sequence=>4
,p_column_heading=>'List Item Current For Pages'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(161383715544702576)
,p_name=>'Associated Tabs'
,p_parent_plug_id=>wwv_flow_imp.id(105124238853)
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--simple'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select tab_set,',
'       tab_name,',
'       tab_also_current_for_pages',
'  from wwv_flow_tabs ',
' where flow_id           = :FB_FLOW_ID ',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and tab_step          = :FB_FLOW_PAGE_ID',
''))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_tabs ',
' where flow_id           = :FB_FLOW_ID ',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and tab_step          = :FB_FLOW_PAGE_ID'))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(161385123986714466)
,p_query_column_id=>1
,p_column_alias=>'TAB_SET'
,p_column_display_sequence=>1
,p_column_heading=>'Tab Set'
,p_use_as_row_header=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(161385208462714467)
,p_query_column_id=>2
,p_column_alias=>'TAB_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Tab Name'
,p_use_as_row_header=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(161392522040723379)
,p_query_column_id=>3
,p_column_alias=>'TAB_ALSO_CURRENT_FOR_PAGES'
,p_column_display_sequence=>3
,p_column_heading=>'Tab Also Current For Pages'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(161418114599759022)
,p_name=>'Associated Breadcrumb Entries'
,p_parent_plug_id=>wwv_flow_imp.id(105124238853)
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--simple'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select m.name menu_name,',
'       o.short_name,',
'       o.long_name,',
'       o.link,',
'       o.also_current_for_pages',
'  from wwv_flow_menus m, ',
'       wwv_flow_menu_options o',
' where m.flow_id                 = o.flow_id',
'   and m.security_group_id       = o.security_group_id',
'    --',
'   and o.flow_id                 = :FB_FLOW_ID',
'   and o.page_id                 = :FB_FLOW_PAGE_ID',
'   and o.security_group_id       = :FLOW_SECURITY_GROUP_ID',
'   and o.also_current_for_pages is null',
''))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_menus        m, ',
'       wwv_flow_menu_options o',
'where m.flow_id                = o.flow_id',
'  and m.security_group_id      = o.security_group_id',
'   --',
'  and o.flow_id                = :FB_FLOW_ID ',
'  and o.security_group_id      = :FLOW_SECURITY_GROUP_ID',
'  and o.page_id                = :FB_FLOW_PAGE_ID ',
'  and o.also_current_for_pages is null'))
,p_display_condition_type=>'EXISTS'
,p_header=>'The following breadcrumb entries will be removed.'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(161420715553778211)
,p_query_column_id=>1
,p_column_alias=>'MENU_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Breadcrumb Name'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(161420801943778212)
,p_query_column_id=>2
,p_column_alias=>'SHORT_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Short Name'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(161420931215778212)
,p_query_column_id=>3
,p_column_alias=>'LONG_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Long Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(161421026223778212)
,p_query_column_id=>4
,p_column_alias=>'LINK'
,p_column_display_sequence=>4
,p_column_heading=>'Link'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(161421129376778212)
,p_query_column_id=>5
,p_column_alias=>'ALSO_CURRENT_FOR_PAGES'
,p_column_display_sequence=>5
,p_column_heading=>'Also Current For Pages'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(26542213329538061)
,p_name=>'Regions'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>70
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select plug_name',
'  from wwv_flow_page_plugs',
' where flow_id           = :FB_FLOW_ID',
'   and page_id           = :FB_FLOW_PAGE_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
' order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(11667910335347890)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'no regions found'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(26542828334538074)
,p_query_column_id=>1
,p_column_alias=>'PLUG_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'PLUG_NAME'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(26544728004551739)
,p_name=>'Items'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>80
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name',
'  from wwv_flow_step_items',
' where flow_id           = :FB_FLOW_ID',
'   and flow_step_id      = :FB_FLOW_PAGE_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
' order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(11667910335347890)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'no items found'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(26545331557551744)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'NAME'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(26548102640563422)
,p_name=>'Buttons'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>90
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select button_name',
'  from wwv_flow_step_buttons',
' where flow_id           = :FB_FLOW_ID',
'   and flow_step_id      = :FB_FLOW_PAGE_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
' order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(11667910335347890)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'no buttons found'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(26548706540563426)
,p_query_column_id=>1
,p_column_alias=>'BUTTON_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'BUTTON_NAME'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(26551316969576946)
,p_name=>'Processes'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>100
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select process_name',
'  from wwv_flow_step_processing',
' where flow_id           = :FB_FLOW_ID',
'   and flow_step_id      = :FB_FLOW_PAGE_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
' order by 1',
''))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(11667910335347890)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'no processes found'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(26551909978576951)
,p_query_column_id=>1
,p_column_alias=>'PROCESS_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'PROCESS_NAME'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(26554712383594620)
,p_name=>'Computations'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>120
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select computation_item',
'  from wwv_flow_step_computations',
' where flow_id           = :FB_FLOW_ID',
'   and flow_step_id      = :FB_FLOW_PAGE_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
' order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(11667910335347890)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'no computations found'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(26555304790594636)
,p_query_column_id=>1
,p_column_alias=>'COMPUTATION_ITEM'
,p_column_display_sequence=>1
,p_column_heading=>'COMPUTATION_ITEM'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(26556621864606836)
,p_name=>'Branches'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>130
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select substr(branch_action,1,25)',
'  from wwv_flow_step_branches',
' where flow_id           = :FB_FLOW_ID',
'   and flow_step_id      = :FB_FLOW_PAGE_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
'',
''))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(11667910335347890)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'no branches found'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(11504814665567615)
,p_query_column_id=>1
,p_column_alias=>'SUBSTR(BRANCH_ACTION,1,25)'
,p_column_display_sequence=>1
,p_column_heading=>'Substr(Branch Action,1,25)'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(26572606514744244)
,p_name=>'Validations'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>110
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select validation_name',
'  from wwv_flow_step_validations',
' where flow_id           = :FB_FLOW_ID',
'   and flow_step_id      = :FB_FLOW_PAGE_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(11667910335347890)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'no validations found'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(26573209627744265)
,p_query_column_id=>1
,p_column_alias=>'VALIDATION_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Validation Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(108099828357520038)
,p_plug_name=>'Warning'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>60
,p_plug_source=>'Deleting the login page may make your application unusable.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>'select 1 from wwv_flow_steps where flow_id = :fb_flow_id and alias = ''LOGIN'' and id = :fb_flow_page_id'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(231664327969078921)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>150
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747137049340138150)
,p_plug_name=>'Confirm Page Delete'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(105116238844)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(231664327969078921)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.:::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(105114238843)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(231664327969078921)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Permanently Delete Page'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(105118238845)
,p_branch_action=>'&F4000_LAST_VIEW.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(105114238843)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(105120238845)
,p_branch_action=>'1'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(105116238844)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(60428831890275742)
,p_name=>'P21_P'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(105124238853)
,p_prompt=>'Page:'
,p_source=>'wwv_flow_builder.get_current_page_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identifies page to be deleted.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(121359621776405514)
,p_name=>'P21_DELETE_TABS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(105124238853)
,p_use_cache_before_default=>'NO'
,p_item_default=>'NO'
,p_prompt=>'Cascade Delete'
,p_source=>'NO'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DELETE_ASSOC_TABS'
,p_lov=>'.'||wwv_flow_imp.id(84243720472403985)||'.'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_tabs ',
' where flow_id           = :FB_FLOW_ID ',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and tab_step          = :FB_FLOW_PAGE_ID',
''))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify whether the tabs corresponding to this page should be deleted.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(139141730383821612)
,p_name=>'P21_DEL_TARGET_LIST_ENTRIES'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(105124238853)
,p_item_default=>'N'
,p_prompt=>'Cascade Delete'
,p_source=>'N'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DELETE CORRESPONDING LIST ENTRIES'
,p_lov=>'.'||wwv_flow_imp.id(139182915633902523)||'.'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_list_items',
' where flow_id                         = :FB_FLOW_ID ',
'   and security_group_id               = :FLOW_SECURITY_GROUP_ID',
'   and upper(list_item_link_target) like ''F?P=%:''||:FB_FLOW_PAGE_ID||'':%'''))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Specify whether the list entries corresponding to this page should be deleted.  Corresponding list entries are list entries that specify a URL link to this page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(166803822650787345)
,p_validation_name=>'check page lock'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_lock_page',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and object_id         = :FB_FLOW_PAGE_ID',
'   and locked_by         != :APP_USER'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Can not delete a page locked by another user.'
,p_when_button_pressed=>wwv_flow_imp.id(105114238843)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2800632141820402)
,p_validation_name=>'Not part of a component group'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not wwv_flow_component_group_dev.is_part_of_comp_grp (',
'        p_component_id   => :FB_FLOW_PAGE_ID,',
'        p_component_type => wwv_flow_copy_metadata.c_page,',
'        p_app_id         => :FB_FLOW_ID )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'The page cannot be deleted because it is part of a component group.'
,p_when_button_pressed=>wwv_flow_imp.id(105114238843)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(105122238851)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_page_dev.delete_page (',
'    p_page_id                  => :FB_FLOW_PAGE_ID,',
'    p_application_id           => :FB_FLOW_ID,',
'    p_del_target_list_entries  => ( :P21_DEL_TARGET_LIST_ENTRIES = ''Y'' ),',
'    p_del_tabs                 => ( :P21_DELETE_TABS = ''YES'' ) );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error deleting page.'
,p_process_when_button_id=>wwv_flow_imp.id(105114238843)
,p_process_success_message=>'Page deleted.'
,p_internal_uid=>105122238851
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(162029321720000696)
,p_process_sequence=>90
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'reset current page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    select id ',
'      into :FB_FLOW_PAGE_ID',
'      from wwv_flow_steps',
'     where security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and flow_id           = :FB_FLOW_ID',
'       and id                > 0',
'       and rownum            = 1;',
'exception',
'    when no_data_found then',
'        null;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(105114238843)
,p_internal_uid=>162029321720000696
);
end;
/
prompt --application/pages/page_00022
begin
wwv_flow_imp_page.create_page(
 p_id=>22
,p_name=>'Create Navigation Bar Entry - Method'
,p_alias=>'CREATE-NAVIGATION-BAR-ENTRY-METHOD'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Navigation Bar Entry'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213263531591941060)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_navbar.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46446211382215703)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193535105470741906)
,p_plug_name=>'Select Navigation Bar Creation Method'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_row_template=>wwv_flow_imp.id(23828816607086312)
,p_plug_query_num_rows=>1500
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_row_count_max=>5000
,p_plug_query_show_nulls_as=>'-'
,p_plug_query_col_allignments=>'L:L:L:L:L:L:L:L'
,p_plug_query_break_cols=>'0'
,p_plug_query_sum_cols=>'NO:NO:NO:NO:NO:NO:NO:NO'
,p_plug_query_number_formats=>':::::::'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<p>You can create Navigation Bar Entries from scratch, or by copying them from another application. Copying Navigation Bar Entries provides you with a framework that you can modify.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(196981121351998160)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(103870209211856610)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
,p_plug_query_headings=>'Seq:Icon:Alt:Conditional'
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'-'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(193535424797741908)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46446211382215703)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(193535714903741910)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(46446211382215703)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(193536613283741916)
,p_branch_name=>'Go To Page 134'
,p_branch_action=>'134'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(193535714903741910)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'F4000_P22_WIZ_TYPE'
,p_branch_condition_text=>'COPY'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(27844683985921701)
,p_branch_name=>'Go To Page 4023'
,p_branch_action=>'f?p=&APP_ID.:4023:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(193535714903741910)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'F4000_P22_WIZ_TYPE'
,p_branch_condition_text=>'BLANK'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(193536000806741912)
,p_name=>'F4000_P22_WIZ_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(193535105470741906)
,p_item_default=>'BLANK'
,p_prompt=>'Create Navigation Bar Entry:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'NAV_BAR_CREATE_METHOD'
,p_lov=>'.'||wwv_flow_imp.id(84245132593407471)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_escape_on_http_output=>'N'
,p_help_text=>'Select the method by which you wish to create a new NavBar icon and click <strong>Next</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(573754179473229722)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(193535424797741908)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(573754220843229723)
,p_event_id=>wwv_flow_imp.id(573754179473229722)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00026
begin
wwv_flow_imp_page.create_page(
 p_id=>26
,p_name=>'Page Template Wizard - Copy From'
,p_alias=>'PAGE-TEMPLATE-WIZARD-COPY-FROM'
,p_page_mode=>'MODAL'
,p_step_title=>'Page Template Wizard'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47947818362720924)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(176866410930258995)
,p_plug_name=>'Create Page Template'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>'<p>Select the application that contains the templates you wish to copy.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(176867605048259001)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(320074633987)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(176868205270259010)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47947818362720924)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(177576213949589943)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(47947818362720924)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(176892509159292264)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(47947818362720924)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(176868831660259044)
,p_branch_action=>'225'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(177576213949589943)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(589949443937621439)
,p_branch_action=>'f?p=&APP_ID.:920:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(176892509159292264)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(176866717827258996)
,p_name=>'F4000_P26_COPY_FROM_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(176866410930258995)
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Copy From Application'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Application -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the application from which you wish to copy templates.'
,p_encrypt_session_state_yn=>'N'
,p_item_comment=>'select name||'' (''||id||'')'', id from wwv_flows where id = v(''FB_FLOW_ID'')'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(177568115964580552)
,p_validation_name=>'F4000_P26_COPY_FROM_FLOW_ID Not Null'
,p_validation_sequence=>10
,p_validation=>'F4000_P26_COPY_FROM_FLOW_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Application ID must be specified.'
,p_associated_item=>wwv_flow_imp.id(176866717827258996)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 18-FEB-2002 15:48'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(589949229289621437)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(176868205270259010)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(589949333181621438)
,p_event_id=>wwv_flow_imp.id(589949229289621437)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1997571893328693489)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_type=>'NEVER'
,p_internal_uid=>1997571893328693489
);
end;
/
prompt --application/pages/page_00027
begin
wwv_flow_imp_page.create_page(
 p_id=>27
,p_name=>'Tree User Interface Elements'
,p_alias=>'TREE-USER-INTERFACE-ELEMENTS'
,p_step_title=>'Edit Tree'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213443923391496926)
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tree.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(41660313778446370)
,p_plug_name=>'Name'
,p_region_name=>'R1'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_plug_query_show_nulls_as=>'(null)'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'generated 13-MAR-2001 22:41:22'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(41670955697548778)
,p_plug_name=>'Node Text Templates'
,p_region_name=>'R6'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(41673516284578820)
,p_plug_name=>'Static Node Templates'
,p_region_name=>'R4'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS_INITCAP'
,p_plug_query_num_rows=>10
,p_plug_query_show_nulls_as=>'(null)'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(41680540604674592)
,p_plug_name=>'Trees'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify Tree attributes.</p>',
'<p>Trees are based on a query and return data that can be represented in a hierarchy.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(41680814605688605)
,p_plug_name=>'Query'
,p_region_name=>'R2'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_footer=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInstructionText">Syntax: select id, pid, name, link, a1, a2 from ... where ... order by ...',
'<ol>',
'<li>All column names must use aliases shown above (for example id, pid, name, link, a1, a2)</li>',
'<li>You must select at least 4 columns (for example id, pid, name, link)</li>',
'<li>All PID (parent ID) referenced must also be ID''s</li>',
'<li>Ordering controls only the items of a single node</li>',
'</ol>',
'<strong>Example</strong>:<br />',
'select empno id, mgr pid, ename name, null link<br />',
'from emp<br />',
'order by ename',
'</div>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46154923902612559)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(58226716348068103)
,p_plug_name=>'Link Templates'
,p_region_name=>'R7'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(58227138260077767)
,p_plug_name=>'Before and After'
,p_region_name=>'R3'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(58247015661740508)
,p_plug_name=>'Template Components'
,p_region_name=>'R5'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS_INITCAP'
,p_plug_query_num_rows=>10
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_header=>'Dynamic expand and contract tree node templates.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(91201614411380148)
,p_plug_name=>'Tree'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>90
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(628876928431702685)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(29434107863295859)
,p_plug_display_sequence=>80
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from WWV_FLOW_TREES',
'where id = :F4000_P27_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :F4000_P27_ID,',
'      p_component_type => ''Application Item'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'F4000_P27_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(41660613435446375)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(91201614411380148)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(41660814005446377)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(91201614411380148)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
,p_button_condition=>'F4000_P27_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(41661020245446377)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(91201614411380148)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P27_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(41661217579446378)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(91201614411380148)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Tree'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P27_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(41659616901446365)
,p_branch_action=>'28'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'Create'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(41659847523446366)
,p_branch_action=>'28'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'Delete'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(41660060408446367)
,p_branch_action=>'&F4000_LAST_VIEW.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(41661418554446388)
,p_name=>'F4000_P27_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(41660313778446370)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(41661616997446395)
,p_name=>'F4000_P27_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(41660313778446370)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Application:'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LIST FLOWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'where  build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'order by 2'))
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'This attribute identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(41661855827446397)
,p_name=>'F4000_P27_TREE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(41660313778446370)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tree Name'
,p_source=>'TREE_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specifies the tree name which is used for the purposes of development.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(41662017225446398)
,p_name=>'F4000_P27_TREE_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(41660313778446370)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tree Type'
,p_source=>'TREE_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TREE_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(84296320837555546)||'.'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specifies the source of the tree, such as a SQL query.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(41662285728446399)
,p_name=>'F4000_P27_TREE_QUERY'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(41680814605688605)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tree Query'
,p_source=>'TREE_QUERY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>20
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a query which will be used to generate this tree.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(41662642214446403)
,p_name=>'F4000_P27_MAX_LEVELS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(41660313778446370)
,p_use_cache_before_default=>'NO'
,p_item_default=>'5'
,p_prompt=>'Max Levels'
,p_source=>'MAX_LEVELS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'select i d, i r from wwv_flow_dual100 order by 1'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'This attribute specifies how many levels will appear when a tree first displays.  After a user starts navigating a tree, the session state will remember their last position.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(41662818017446403)
,p_name=>'F4000_P27_UNEXPANDED_PARENT'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(58247015661740508)
,p_use_cache_before_default=>'NO'
,p_item_default=>'<td><a href="#DRILL_DOWN#"><img src="#IMAGE_PREFIX#Fndtre02.gif" width=16 height=22 border=0></a></td>'
,p_prompt=>'Unexpanded Parent (use #DRILL_DOWN# for expand and contract link)'
,p_source=>'UNEXPANDED_PARENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter template for unexpanded parent nodes. Use the #DRILL_DOWN# substitution string for the expand and unexpand link.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(41663018811446404)
,p_name=>'F4000_P27_UNEXPANDED_PARENT_LAST'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(58247015661740508)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Unexpanded Parent Last (use #DRILL_DOWN# for expand and contract link)'
,p_source=>'UNEXPANDED_PARENT_LAST'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter template for the last unexpanded parent node. Use the #DRILL_DOWN# substitution string for the expand and unexpand link.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(41663217470446406)
,p_name=>'F4000_P27_EXPANDED_PARENT'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(58247015661740508)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Expanded Parent (use #DRILL_DOWN# for expand and contract link)'
,p_source=>'EXPANDED_PARENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter template for the expanded parent node. Use the #DRILL_DOWN# substitution string for the expand and unexpand link.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(41663414146446408)
,p_name=>'F4000_P27_EXPANDED_PARENT_LAST'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(58247015661740508)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Expanded Parent Last (use #DRILL_DOWN# for expand and contract link)'
,p_source=>'EXPANDED_PARENT_LAST'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter template for the last expanded parent node. Use the #DRILL_DOWN# substitution string for the expand and unexpand link.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(41663616502446408)
,p_name=>'F4000_P27_LEAF_NODE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(41673516284578820)
,p_use_cache_before_default=>'NO'
,p_item_default=>'<td align=left><img src="#IMAGE_PREFIX#Fndtre07.gif" width=16 height=22 border=0></td>'
,p_prompt=>'Leaf Node (last node has no drill capabilities)'
,p_source=>'LEAF_NODE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'This attribute controls the text that is painted before showing the text of the leaf node. A leaf node is a tree node that has no children. This attribute applies only to leaf nodes that are not the last leaf nodes of the tree. For example:',
'<pre>',
'&lt;td align=left>&lt;img src="&#35;IMAGE_PREFIX&#35;Fndtre07.gif" width=16 height=22 border=0>&lt;/td>',
'</pre>',
'Fndtre07.gif = <img src="#IMAGE_PREFIX#Fndtre07.gif" width="16" height="22" border="2">'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(41663866477446409)
,p_name=>'F4000_P27_LEAF_NODE_LAST'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(41673516284578820)
,p_use_cache_before_default=>'NO'
,p_item_default=>'<td align=left><img src="#IMAGE_PREFIX#Fndtre08.gif" width=16 height=22 border=0></td>'
,p_prompt=>'Leaf Node Last (last node has no drill capabilities)'
,p_source=>'LEAF_NODE_LAST'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'This attribute controls the text that is painted before showing the text of the leaf node. A leaf node is a tree node that has no children. This attribute applies only to leaf nodes that are not the last leaf nodes of the tree. For example:',
'<pre>',
'&lt;td align=left>&lt;img src="&#35;IMAGE_PREFIX&#35;Fndtre08.gif" width="16" height="22" border="0" alt="Node">&lt;/td>',
'</pre>',
'',
'Fndtre07.gif = <img src="#IMAGE_PREFIX#Fndtre08.gif" width="16" height="22" border="2" alt="Node">'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(41664015640446410)
,p_name=>'F4000_P27_DRILL_UP'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(41673516284578820)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Drill Up (Link Text for #DRILL_UP# on root node template)'
,p_source=>'DRILL_UP'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'This attribute identifies the link text shown when drilling up is possible in the tree.  When using trees, you can display a tree having starting with a point which is not the root node. To facilitate user navigation of parent nodes you need drill up'
||' link. For example:',
'<pre>',
'&amp;nbsp;(up)',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(41664210620446410)
,p_name=>'F4000_P27_NAME_LINK_ANCHOR_TAG'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_imp.id(58226716348068103)
,p_use_cache_before_default=>'NO'
,p_item_default=>'<a href="#LINK#"><font class="nounderline" size=-3>#NAME#</font></a>'
,p_prompt=>'Name Link Anchor Tag (used in the event a link exists)'
,p_source=>'NAME_LINK_ANCHOR_TAG'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'This attribute identifies the manner in which a Name will render if the name has a link.  Use #LINK# and #NAME# substitution strings.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(41664412639446412)
,p_name=>'F4000_P27_NAME_LINK_NOT_ANCHOR_TAG'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_imp.id(58226716348068103)
,p_use_cache_before_default=>'NO'
,p_item_default=>'<font size=-3>#NAME#</font>'
,p_prompt=>'Name Link Not Anchor Tag'
,p_source=>'NAME_LINK_NOT_ANCHOR_TAG'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter name tag for node names which are not links.  Use #NAME# substitution string.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(41664618922446416)
,p_name=>'F4000_P27_INDENT_VERTICAL_LINE'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(41673516284578820)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Indent Vertical Line'
,p_source=>'INDENT_VERTICAL_LINE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'This attribute controls vertical line or spacing between peers. Consider the following example. Note that Jones, Smith, and Thomas are peers and that vertical line is used to the left of Smiths organization.  ',
'<pre>',
'+-+ Jones',
'',
'  + Smith',
'',
'  | |',
'',
'  | + Frank',
'',
'  | + Scott',
'',
'  + Thomas',
'',
'</pre>',
'',
'Consider the following example:',
'<pre>',
'&lt;td>&lt;img src="&#35;IMAGE_PREFIX&#35;Fndtre09.gif" width="16" height="22" border="0" alt="Branch">&lt;/td>',
'</pre>',
'<br/>',
'Fndtre09.gif = <img src="#IMAGE_PREFIX#Fndtre09.gif" width="16" height="22" border="2" alt="Branch">'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(41664816744446416)
,p_name=>'F4000_P27_INDENT_VERTICAL_LINE_LAST'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(41673516284578820)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Indent Vertical Line Last (aka blankspace)'
,p_source=>'INDENT_VERTICAL_LINE_LAST'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'This attributes controls a blank space. In the following example note the blank space under Thomas and before Marks.',
'<pre>',
'+-+ Jones',
'',
'  + Smith',
'',
'  | |',
'',
'  | + Frank',
'',
'  | + Scott',
'',
'  + Thomas',
'',
'    |',
'',
'    Marks',
'',
'</pre>',
'',
'Consider the following example:',
'<pre>',
'&lt;td>&lt;img src="&#35;IMAGE_PREFIX&#35;Fndtre10.gif" width=16 height=22 border=0>&lt;/td>',
'</pre>',
'<br/>',
'Fndtre10.gif = <img src="#IMAGE_PREFIX#Fndtre10.gif" width=16 height=22 border=2>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(41665044534446417)
,p_name=>'F4000_P27_BEFORE_TREE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(58227138260077767)
,p_use_cache_before_default=>'NO'
,p_item_default=>'<table border=0 cellspacing=0 cellpadding=0>'
,p_prompt=>'Before Tree (Display this HTML before printing Tree)'
,p_source=>'BEFORE_TREE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Display this text before displaying any nodes of the tree. This is typically used to open an HTML table. For example:',
'<pre>',
'&lt;table border=0 cellspacing=0 cellpadding=0&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(41665295973446418)
,p_name=>'F4000_P27_AFTER_TREE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(58227138260077767)
,p_use_cache_before_default=>'NO'
,p_item_default=>'</table>'
,p_prompt=>'After Tree'
,p_source=>'AFTER_TREE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Display this text after displaying nodes of the tree.  This is typically used to close an HTML table. For example:',
'<pre>',
'&lt;/table&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(41665415561446419)
,p_name=>'F4000_P27_LEVEL_1_TEMPLATE'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(41670955697548778)
,p_use_cache_before_default=>'NO'
,p_item_default=>'<tr>#INDENT#<td colspan=#COLSPAN# valign="CENTER">#NAME##A1##A2# #DRILL_UP#</td></tr>'
,p_prompt=>'Parent Node Template (used for root node) Use #NAME#, #DRILL_UP#, #A1#, #A2#, #COLSPAN#.'
,p_source=>'LEVEL_1_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'When specifying this attribute:',
'<ul>',
'<li>#NAME# specifies the value from your query name column</li>',
'<li>#DRILL_UP# is the link to drill up above the root</li>',
'<li>#A1# refers to a1 from query</li>',
'<li>#A2# refers to a2 from query</li>',
'<li>#COLSPAN# specifies the max levels (current level + 1.',
'Use #COLSPAN# to generate proper HTML tables using the default template style.',
'</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(41665692746446419)
,p_name=>'F4000_P27_LEVEL_2_TEMPLATE'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(41670955697548778)
,p_use_cache_before_default=>'NO'
,p_item_default=>'<tr>#INDENT#<td colspan=#COLSPAN# valign="CENTER">#NAME##A1##A2#</td></tr>'
,p_prompt=>'Node Text Template (#NAME# is expanded by hyper text link template below) Use #NAME#, #A1#, #A2#, #COLSPAN#'
,p_source=>'LEVEL_2_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter template for node text.  Use #NAME#, #A1#, #A2#, and #COLSPAN# substitution strings.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(42827836936288330)
,p_name=>'F4000_P27_FLOW_ITEM'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(41660313778446370)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application Item'
,p_source=>'FLOW_ITEM'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LISTALLITEMS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''CONFIRM.APPLICATION'')||',
''': ''||name a, name b ',
'from wwv_flow_items',
'where flow_id = :FB_FLOW_ID',
'union all',
'select initcap(wwv_flow_lang.system_message(''PAGE''))||',
''': ''||flow_step_id||'': ''||name a, name b',
'',
'from wwv_flow_step_items',
'',
'where flow_id = :FB_FLOW_ID',
'',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'This attribute identifies an application or page item which specifies the starting point of the tree (the first node). The query which defines the tree identifies a starting position. The value of this item should equal the primary key of the tree.',
'<br/><br/>',
'The parent of the first node is typically zero or null. If it is another value then an up link displays to facilitate drilling up.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(41681910493722669)
,p_validation_name=>'F4000_P27_TREE_NAME Not Null'
,p_validation_sequence=>10
,p_validation=>'F4000_P27_TREE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Tree Name must be specified.'
,p_associated_item=>wwv_flow_imp.id(41661855827446397)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 13-MAR-2001 23:27'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(41682118938722674)
,p_validation_name=>'F4000_P27_TREE_TYPE Not Null'
,p_validation_sequence=>20
,p_validation=>'F4000_P27_TREE_TYPE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Tree Type must be specified.'
,p_associated_item=>wwv_flow_imp.id(41662017225446398)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 13-MAR-2001 23:27'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(41682327682722675)
,p_validation_name=>'F4000_P27_MAX_LEVELS Not Null'
,p_validation_sequence=>30
,p_validation=>'F4000_P27_MAX_LEVELS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Max Levels must be specified.'
,p_associated_item=>wwv_flow_imp.id(41662642214446403)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 13-MAR-2001 23:27'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(41682514521722675)
,p_validation_name=>'F4000_P27_TREE_QUERY Not Null'
,p_validation_sequence=>40
,p_validation=>'F4000_P27_TREE_QUERY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Tree Query must be specified.'
,p_associated_item=>wwv_flow_imp.id(41662285728446399)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 13-MAR-2001 23:27'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(106551420103727021)
,p_validation_name=>'F4000_P27_FLOW_ITEM not null'
,p_validation_sequence=>50
,p_validation=>'F4000_P27_FLOW_ITEM'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Application Item must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(41661020245446377)
,p_associated_item=>wwv_flow_imp.id(42827836936288330)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(41667012370446430)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_TREES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_TREES'
,p_attribute_03=>'F4000_P27_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error getting tree attributes.'
,p_internal_uid=>41667012370446430
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(41667232451446438)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_TREES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_TREES'
,p_attribute_03=>'F4000_P27_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error performing process.'
,p_process_success_message=>'Action processed.'
,p_internal_uid=>41667232451446438
);
end;
/
prompt --application/pages/page_00028
begin
wwv_flow_imp_page.create_page(
 p_id=>28
,p_name=>'Trees'
,p_alias=>'TREES'
,p_step_title=>'Trees'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213443923391496926)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tree.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4893702635405949)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(4884503079390537)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(41669337920492677)
,p_plug_name=>'Trees'
,p_region_template_options=>'#DEFAULT#:a-Region--sideRegion:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>A Tree is a hierarchical navigation mechanism.  You can create a Tree from a query that specifies a hierarchical relationship by identifying an ID and parent ID column in a table or view.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(48497310933562027)
,p_plug_name=>'Trees'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P28a */ ID,',
'       tree_name, ',
'       tree_type,',
'       TREE_QUERY,',
'       tree_comment,',
'       ''icon-sc-tree'' icon_class,',
'       replace(tree_name,''_'','' '') icon_title,',
'       ''f?p=4000:27:''||:app_session||''::NO::F4000_P27_ID:''||ID edit_link,',
'       tree_name img_name,',
'       nvl(last_updated_by,created_by) updated_by,',
'       nvl(last_updated_on,created_on) updated',
'from   WWV_FLOW_TREES t',
'where  flow_id = :fb_flow_id ',
'   and security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(48497413326562027)
,p_name=>'Trees'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#EDIT_LINK#" class="a-IRR-icon"><span class="a-Icon #ICON_CLASS#"></span><span class="a-IRR-iconName">#ICON_TITLE#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(48497727234562030)
,p_db_column_name=>'TREE_NAME'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>'Name'
,p_column_link=>'f?p=&APP_ID.:27:&SESSION.::&DEBUG.::F4000_P27_ID:#ID#'
,p_column_linktext=>'#TREE_NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(48497808682562031)
,p_db_column_name=>'TREE_TYPE'
,p_display_order=>2
,p_column_identifier=>'C'
,p_column_label=>'Type'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(48497624593562029)
,p_db_column_name=>'ID'
,p_display_order=>4
,p_column_identifier=>'A'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(48497932373562031)
,p_db_column_name=>'TREE_QUERY'
,p_display_order=>5
,p_column_identifier=>'D'
,p_column_label=>'Query'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(48498018293562032)
,p_db_column_name=>'TREE_COMMENT'
,p_display_order=>6
,p_column_identifier=>'E'
,p_column_label=>'Comments'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(48498520970562034)
,p_db_column_name=>'IMG_NAME'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Img Name'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(48498607309562034)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(48498714815562035)
,p_db_column_name=>'UPDATED'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(656964258839061330)
,p_db_column_name=>'ICON_CLASS'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Icon Class'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(656964392968061330)
,p_db_column_name=>'ICON_TITLE'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Icon Title'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(656964485914061330)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'Edit Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(48499005856562994)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1298106184536645'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_view_mode=>'ICON'
,p_report_columns=>'TREE_NAME:TREE_COMMENT:ICON_CLASS:ICON_TITLE:EDIT_LINK'
,p_sort_column_1=>'TREE_NAME'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(188982523974842051)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(48497310933562027)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:28:&SESSION.::&DEBUG.:28,RIR::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(89007306708091375)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'28'
,p_computation_error_message=>'Unable to compute item value.'
,p_compute_when_type=>'%null%'
);
end;
/
prompt --application/pages/page_00030
begin
wwv_flow_imp_page.create_page(
 p_id=>30
,p_name=>'Getting Started in Page Designer'
,p_alias=>'GETTING-STARTED-IN-PAGE-DESIGNER'
,p_page_mode=>'MODAL'
,p_step_title=>'Getting Started in Page Designer'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_css_classes=>'a-Dialog--pageDesignerGetStarted'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'No help is available for this page.'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(153764270703903309)
,p_plug_name=>'Learn More Region'
,p_region_css_classes=>'a-ButtonRegion--banner apex-app-builder'
,p_region_template_options=>'a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<div class="a-MediaBlock">'');',
'sys.htp.p(''    <div class="a-MediaBlock-graphic">'');',
'sys.htp.p(''        <span class="icon-get-started" aria-hidden="true"></span>'');',
'sys.htp.p(''    </div>'');',
'sys.htp.p(''    <div class="a-MediaBlock-content">'');',
'sys.htp.p(''        <h2>''||wwv_flow_lang.system_message(''LEARN_MORE_PAGE_DESIGNER'')||''</h2>'');',
'sys.htp.p(''    </div>'');',
'sys.htp.p(''</div>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1493543391999991810)
,p_plug_name=>'Help'
,p_region_css_classes=>'a-Dialog-textContent'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_source=>'<big>The Page Designer is a comprehensive integrated development environment (IDE) used to maintain and enhance pages within your &PRODUCT_NAME. applications.</big>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1104689117393514433)
,p_plug_name=>'Page Designer Toolbar'
,p_parent_plug_id=>wwv_flow_imp.id(1493543391999991810)
,p_region_css_classes=>'a-Region--textContent'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The toolbar across the top of Page Designer has a number of capabilities:</p>',
'<ul>',
'  <li><strong>Page Selector</strong> - Displays the current page. You can enter a page number directly, or click on the popup list of values to select a page. </li>',
'  <li><strong>Messages</strong> - When you add a new component to a page, displays current errors and warnings. Clicking a message changes the focus within Property Editor to the corresponding attribute associated with the error or warning.</li>',
'  <li><strong>Page Lock</strong> - Indicates if the page is unlocked (clear), locked by you (red), or locked by another developer (red with person).<br/>',
'    By clicking on this icon you can lock or unlock the page, providing it is not locked by another developer.</li>',
'  <li><strong>Undo Changes</strong> - Click to undo the previous update you made within Page Designer.</li>',
'  <li><strong>Redo Changes</strong> - Click to reapply the last update that was undone using Undo Changes.</li>',
'  <li><strong>Create</strong> - Create new pages, copy pages, create regions, manage shared components, manage page groups, add developer comments, and create Team Development issues.</li>',
'  <li><strong>Utilities</strong> - Delete pages, run Advisor to perform a check, view Caching, view page history, view page checksum, export, enable or disable Tooltips and the Layout tab, or use Layout to toggle between Two Pane and Three Pane mode.'
||'<br/></li>',
'  <li><strong>Shared Components</strong> - Navigate to the Shared Components page.</li>',
'  <li><strong>Save</strong> - Save all changes you have made on the current page.</li>',
'  <li><strong>Save and Run Page</strong> - Save all changes and then run the current page.<br/>',
'    <em>Note: You cannot run modal and non-modal pages directly using Save and Run Page. Instead you need to navigate to a normal page and run the page from there and then navigate within the running application to the modal or non-modal page.</em></'
||'li>',
'</ul><br/>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1498784482317536966)
,p_plug_name=>'Main Panes'
,p_parent_plug_id=>wwv_flow_imp.id(1493543391999991810)
,p_region_css_classes=>'a-Region--textContent'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>There are three main panes within Page Designer:</p>',
'<ul>',
'  <li><strong>Left Pane</strong> - Includes tabs for Rendering, Dynamic Actions, Processing, and Shared Components. Each tab displays a list of the corresponding component types and components created on the current page.<br/>',
'    Right-click to access context sensitive menus. You can also drag components up and down within the tree to change the position or sequence of the selected component.</li>',
'  <li><strong>Central Pane</strong> - Includes tabs for Layout, Page Search, and Help.<br/>',
'   <em>Layout</em> shows a visual representation of the page. Add new page components by right-clicking to access a context sensitive menu, or dragging components from the Gallery tab at the bottom and dropping them in the Layout tab.<br/>',
'   <em>Page Search</em> enables you to search all page metadata including regions, items  buttons, dynamic actions, columns, and so on.<br/>',
'   <em>Help</em> displays attribute specific help. Click on the attribute name within Property Editor to view information and examples for that attribute.</li>',
'  <li><strong>Right Pane</strong> - Displays the Property Editor. Use the Property Editor to update attributes for the selected component(s).<br/>',
'    When you select multiple components the Property Editor only displays common attributes. Updating a common attribute will update that attribute for all of the selected components.</li>',
'</ul>',
'<p>&nbsp;</p>',
'<p>You can adjust the size of each pane by selecting and dragging the horizontal and vertical splitters. To expand or collapse each pane, click the small triangle labeled <strong>Collapse</strong> in the center of each splitter.</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(81564783738352513)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(153764270703903309)
,p_button_name=>'GET_STARTED'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Get Started'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.navigation.openInNewWindow(''https://apex.oracle.com/go/get_started_page_designer'');'
,p_button_css_classes=>'a-Button--dark'
);
end;
/
prompt --application/pages/page_00031
begin
wwv_flow_imp_page.create_page(
 p_id=>31
,p_name=>'Icons'
,p_alias=>'ICONS'
,p_step_title=>'Icons'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function passBack(x,return_item) {',
'    opener.$x(return_item).value = x;',
'	opener.$x(return_item).focus()',
'	close();',
'}'))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.fa-icon-block {',
'    display: inline-block;',
'}',
'.fa-icon-block a,',
'.fa-icon-block a:hover {',
'    text-decoration: none;',
'}',
'.fa-icon-block a {',
'    display: inline-block;',
'    width: 160px;',
'    padding: 8px;',
'    height: 90px;',
'    text-align: center;',
'    border-radius: 2px;',
'    vertical-align: top;',
'}',
'.fa-icon-block a:hover {',
'    background-color: #F8F8F8;',
'    box-shadow: 0 0 0 1px rgba(0,0,0,.1)',
'}',
'.fa-icon-block .fa {',
'    font-size: 42px;',
'    display: inline-block;',
'    color: #707070;',
'    line-height: 1.25;',
'}',
'.fa-icon-block .icon-label {',
'    font-size: 12px;',
'    line-height: 16px;',
'    display: block;',
'    color: #404040;',
'}'))
,p_step_template=>wwv_flow_imp.id(19943204431962826)
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1845883349389589583)
,p_plug_name=>'Images'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>100
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_f4000_util.show_popup_images(',
'    p_return_item => ''P4314_ICON_CSS_CLASSES'',',
'    p_image_size  => :P31_ICON_SIZE,',
'    p_show        => :P31_SHOW, ',
'    p_category    => :P31_ICON_CATEGORY);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1845883779315589585)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>92
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1845887618347589599)
,p_plug_name=>'Message'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>95
,p_translate_title=>'N'
,p_plug_header=>'<p>Click an icon to select the icon and close this window.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1845884556922589586)
,p_button_sequence=>4
,p_button_plug_id=>wwv_flow_imp.id(1845883779315589585)
,p_button_name=>'P31_GO'
,p_button_static_id=>'P654_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Go'
,p_button_alignment=>'LEFT-CENTER'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1845884161570589585)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1845883779315589585)
,p_button_name=>'CLOSE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Close'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:window.close();'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1845888119844589605)
,p_branch_action=>'f?p=&APP_ID.:31:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1845884993327589587)
,p_name=>'P31_SHOW'
,p_item_sequence=>3
,p_item_plug_id=>wwv_flow_imp.id(1845883779315589585)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_icon_library wwv_flow_themes.icon_library%type;',
'begin',
'    select min( icon_library )',
'      into l_icon_library',
'      from wwv_flow_themes t,',
'           wwv_flows f',
'     where f.id                = :FB_FLOW_ID',
'       and f.security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and t.flow_id           = f.id',
'       and t.theme_id          = f.theme_id',
'       and t.security_group_id = f.security_group_id;',
'',
'  return nvl( l_icon_library, ''STANDARD_ICON'' );',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Show'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ICON PREVIEW REPOSITORY'
,p_lov=>'.'||wwv_flow_imp.id(1845902759442614704)||'.'
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_help_text=>'Previously used icons are icons that are part of the &PRODUCT_NAME. distribution and have been previously used in the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1845885841404589598)
,p_name=>'P31_ICON_SIZE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1845883779315589585)
,p_item_default=>'64'
,p_prompt=>'Icon Size'
,p_source=>'64'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'STANDARD ICON SIZES 2'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''12x12''	 d, 12  r from dual union all',
'select ''16x16''	 d, 16  r from dual union all',
'select ''20x20''	 d, 20  r from dual union all',
'select ''32x32''	 d, 32  r from dual union all',
'select ''64x64''	 d, 64  r from dual union all',
'select ''128x128'' d, 128 r from dual union all',
'select ''140x90''	 d, 140 r from dual',
'order by 2'))
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_new_grid=>true
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select standard application image size.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1845886725298589599)
,p_name=>'P31_ICON_CATEGORY'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1845883779315589585)
,p_prompt=>'Category'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'FONT_CATEGORIES'
,p_lov=>'.'||wwv_flow_imp.id(1362022415318990531)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Category -'
,p_cSize=>30
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_new_grid=>true
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>':P31_SHOW is null or :P31_SHOW in ( ''FONTAPEX'', ''FONTAWESOME'' )'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select Font Awesome category.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
end;
/
prompt --application/pages/page_00033
begin
wwv_flow_imp_page.create_page(
 p_id=>33
,p_name=>'Application Pages'
,p_alias=>'APPLICATION-PAGES'
,p_step_title=>'Application Pages'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>'#showHideFacets { display: block; margin: 8px auto 16px auto;}'
,p_step_template=>wwv_flow_imp.id(438185046231548086)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var facets = ["P33_LOCKED", "P33_HAS_ALIAS", "P33_PAGE_MODE", ',
'              "P33_PAGE_IS_PUBLIC", "P33_CREATED_MONTH"],',
'    facetsVisible = false,',
'    region = apex.region("pageFacets"),',
'    btn$ = $("#showHideFacets"),',
'    btnLabels = btn$.text().split("|");',
'',
'function showHideFacets( visible ) {',
'    btn$.text( btnLabels[facetsVisible ? 1 : 0]);',
'    facets.forEach(function (f) {',
'        if ( visible ) {',
'            region.showFacet(f);',
'        } else {',
'            region.hideFacet(f);',
'        }',
'    });',
'}',
'',
'btn$.click(function() {',
'    facetsVisible = !facetsVisible;',
'    showHideFacets(facetsVisible);',
'});',
'showHideFacets(facetsVisible);'))
,p_page_component_map=>'22'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(390434885782898124)
,p_plug_name=>'Facets Header'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--slimPadding:a-ButtonRegion--noBorder'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<div id="active_facets"></div>'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(427665843253594857)
,p_name=>'Application Pages'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--staticRowColors:a-Report--stretch:a-Report--rowHighlight'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select p.id,',
'       p.flow_id the_flow,',
'       name page_name,',
'       last_updated_on updated,',
'       to_char(created_on,''YYYY.MM'') created_month,',
'       nvl(l.locked_by,sm.unlocked) locked,',
'       nvl(g.group_name,sm.t_unassigned) group_name,',
'       p.page_type,',
'       decode(p.page_mode,''NORMAL'',sm.apex_mode_normal,''MODAL'',sm.apex_mode_modal,''NON_MODAL'',sm.apex_mode_non_modal) page_mode,',
'       alias,',
'       decode(alias,null,sm.t_no,sm.t_yes) has_alias,',
'       nvl((select name from wwv_flow_templates t where p.STEP_TEMPLATE = t.id),sm.apex_default) page_template,',
'       --',
'       nvl(case',
'       when p.required_role = ''MUST_NOT_BE_PUBLIC_USER'' then t_must_not_be_public_user',
'       else (select case when p.required_role like ''!%'' then ''{'' end||',
'                    max(name) ||',
'                    case when p.required_role like ''!%'' then ''}'' end',
'               from wwv_flow_security_schemes s',
'              where s.flow_id = p.flow_id and to_char(s.id) = ltrim(p.required_role,''!''))',
'       end,sm.apex_no_authorization_scheme) authorization_scheme,',
'       --',
'       nvl((select replace(patch_name,'':'',''-'')',
'              from wwv_flow_patches bo',
'             where bo.id = p.required_patch),''No build option'') build_option,',
'       --',
'       decode(',
'           page_is_public_y_n,',
'           ''Y'', sm.t_yes,',
'           ''N'', sm.t_no,',
'           page_is_public_y_n) page_is_public,',
'       decode(',
'           protection_level,',
'           ''D'', sm.no_url_access,',
'           ''N'', sm.unrestricted,',
'           ''U'', sm.no_arguments_allowed,',
'           ''C'', sm.arguments_must_have_checksum,',
'           sm.unrestricted) protection_level,',
'       decode(',
'           cache_mode,',
'           ''NOCACHE'', sm.t_no,',
'           sm.t_yes) cache_page,',
'       nvl(lower(last_updated_by),sm.apex_unknown) last_updated_by,',
'       nvl(lower(created_by),sm.apex_unknown) created_by',
'  from wwv_flow_pages_dev p,',
'       wwv_flow_lock_page l,',
'       (select wwv_flow_lang.system_message(''UNLOCKED'') unlocked,',
'               wwv_flow_lang.system_message(''F4000.YES'') t_yes,',
'               wwv_flow_lang.system_message(''F4000.NO'') t_no,',
'               wwv_flow_lang.system_message(''NO_URL_ACCESS'') no_url_access,',
'               wwv_flow_lang.system_message(''UNRESTRICTED'') unrestricted,',
'               wwv_flow_lang.system_message(''NO_ARGUMENTS_ALLOWED'') no_arguments_allowed,',
'               wwv_flow_lang.system_message(''ARGUMENTS_MUST_HAVE_CHECKSUM'') arguments_must_have_checksum,',
'               wwv_flow_lang.system_message(''Unassigned'') t_unassigned,',
'               wwv_flow_lang.system_message(''MUST_NOT_BE_PUBLIC_USER'') t_must_not_be_public_user,',
'               wwv_flow_lang.system_message(''DEFAULT'') apex_default,',
'               wwv_flow_lang.system_message(''NO_AUTHORIZATION_SCHEME'') apex_no_authorization_scheme,',
'               wwv_flow_lang.system_message(''PE.PROPERTY.PAGE_MODE.LOV.MODAL.D'') apex_mode_modal,',
'               wwv_flow_lang.system_message(''PE.PROPERTY.PAGE_MODE.LOV.NON_MODAL.D'') apex_mode_non_modal,',
'               wwv_flow_lang.system_message(''PE.PROPERTY.PAGE_MODE.LOV.NORMAL.D'') apex_mode_normal,',
'               wwv_flow_lang.system_message(''UNKNOWN'') apex_unknown',
'          from sys.dual) sm,',
'       wwv_flow_page_groups g',
' where p.flow_id           = :FB_FLOW_ID',
'   and p.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and p.flow_id           = l.flow_id   (+)',
'   and p.id                = l.object_id (+)',
'   and p.group_id          = g.id        (+)'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>50
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'no data found'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>100000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_prn_format=>'PDF'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(427667390167594883)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(427667758364594890)
,p_query_column_id=>2
,p_column_alias=>'THE_FLOW'
,p_column_display_sequence=>3
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(395886561955084623)
,p_query_column_id=>3
,p_column_alias=>'PAGE_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Page Name'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.:Y,:FB_FLOW_ID,FB_FLOW_PAGE_ID:#THE_FLOW#,#ID#'
,p_column_linktext=>'#PAGE_NAME#'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(427669300784594891)
,p_query_column_id=>4
,p_column_alias=>'UPDATED'
,p_column_display_sequence=>18
,p_column_heading=>'Updated'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(395886776990084625)
,p_query_column_id=>5
,p_column_alias=>'CREATED_MONTH'
,p_column_display_sequence=>17
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(427671316119594894)
,p_query_column_id=>6
,p_column_alias=>'LOCKED'
,p_column_display_sequence=>4
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(427672150554594895)
,p_query_column_id=>7
,p_column_alias=>'GROUP_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Group'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(427672987174594897)
,p_query_column_id=>8
,p_column_alias=>'PAGE_TYPE'
,p_column_display_sequence=>6
,p_column_heading=>'Page Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(427673335449594898)
,p_query_column_id=>9
,p_column_alias=>'PAGE_MODE'
,p_column_display_sequence=>7
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(427674555198594899)
,p_query_column_id=>10
,p_column_alias=>'ALIAS'
,p_column_display_sequence=>9
,p_column_heading=>'Alias'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(395886699744084624)
,p_query_column_id=>11
,p_column_alias=>'HAS_ALIAS'
,p_column_display_sequence=>16
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(427677729650594904)
,p_query_column_id=>12
,p_column_alias=>'PAGE_TEMPLATE'
,p_column_display_sequence=>10
,p_column_heading=>'Page Template'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(427678102341594904)
,p_query_column_id=>13
,p_column_alias=>'AUTHORIZATION_SCHEME'
,p_column_display_sequence=>11
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(427678527195594905)
,p_query_column_id=>14
,p_column_alias=>'BUILD_OPTION'
,p_column_display_sequence=>12
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(427680554813594915)
,p_query_column_id=>15
,p_column_alias=>'PAGE_IS_PUBLIC'
,p_column_display_sequence=>13
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(427680942409594918)
,p_query_column_id=>16
,p_column_alias=>'PROTECTION_LEVEL'
,p_column_display_sequence=>14
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(427681721586594918)
,p_query_column_id=>17
,p_column_alias=>'CACHE_PAGE'
,p_column_display_sequence=>15
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(395887907733084637)
,p_query_column_id=>18
,p_column_alias=>'LAST_UPDATED_BY'
,p_column_display_sequence=>19
,p_column_heading=>'Updated By'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(395888154491084639)
,p_query_column_id=>19
,p_column_alias=>'CREATED_BY'
,p_column_display_sequence=>20
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(427665956719594857)
,p_plug_name=>'Search'
,p_region_name=>'pageFacets'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source_type=>'NATIVE_FACETED_SEARCH'
,p_filtered_region_id=>wwv_flow_imp.id(427665843253594857)
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'batch_facet_search', 'N',
  'current_facets_selector', '#active_facets',
  'display_chart_for_top_n_values', '10',
  'show_charts', 'Y',
  'show_current_facets', 'E',
  'show_total_row_count', 'N')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(178182682696189933)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(427665956719594857)
,p_button_name=>'SHOW_HIDE'
,p_button_static_id=>'showHideFacets'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Show All|Show Common'
,p_warn_on_unsaved_changes=>null
,p_button_condition_type=>'NEVER'
,p_grid_new_row=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(427666804632594870)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(390434885782898124)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'Reset'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:33:&SESSION.::&DEBUG.:RR,33::'
,p_icon_css_classes=>'icon-undo'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(395886863972084626)
,p_name=>'P33_LOCKED'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(427665956719594857)
,p_prompt=>'Locked'
,p_source=>'LOCKED'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov_sort_direction=>'ASC'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>5
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>true
,p_fc_initial_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>true
,p_fc_initial_toggled=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(395886982278084627)
,p_name=>'P33_GROUP'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(427665956719594857)
,p_prompt=>'Page Group'
,p_source=>'GROUP_NAME'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov_sort_direction=>'ASC'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>8
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>true
,p_fc_initial_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(395887002156084628)
,p_name=>'P33_PAGE_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(427665956719594857)
,p_prompt=>'Page Type'
,p_source=>'PAGE_TYPE'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov_sort_direction=>'ASC'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>8
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>true
,p_fc_initial_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(395887195142084629)
,p_name=>'P33_HAS_ALIAS'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(427665956719594857)
,p_prompt=>'Has Alias'
,p_source=>'HAS_ALIAS'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov_sort_direction=>'ASC'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>5
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>true
,p_fc_initial_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>true
,p_fc_initial_toggled=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(395887249730084630)
,p_name=>'P33_PAGE_MODE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(427665956719594857)
,p_prompt=>'Mode'
,p_source=>'PAGE_MODE'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov_sort_direction=>'ASC'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>5
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>true
,p_fc_initial_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>true
,p_fc_initial_toggled=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(395887305834084631)
,p_name=>'P33_PAGE_IS_PUBLIC'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(427665956719594857)
,p_prompt=>'Is Public'
,p_source=>'PAGE_IS_PUBLIC'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov_sort_direction=>'ASC'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>5
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>true
,p_fc_initial_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>true
,p_fc_initial_toggled=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(395887401867084632)
,p_name=>'P33_PAGE_TEMPLATE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(427665956719594857)
,p_prompt=>'Template'
,p_source=>'PAGE_TEMPLATE'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov_sort_direction=>'ASC'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>8
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>true
,p_fc_initial_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(395887541206084633)
,p_name=>'P33_AUTHORIZATION_SCHEME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(427665956719594857)
,p_prompt=>'Authorization'
,p_source=>'AUTHORIZATION_SCHEME'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov_sort_direction=>'ASC'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>8
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>true
,p_fc_initial_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(395887674127084634)
,p_name=>'P33_BUILD_OPTION'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(427665956719594857)
,p_prompt=>'Build Option'
,p_source=>'BUILD_OPTION'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov_sort_direction=>'ASC'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>8
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>true
,p_fc_initial_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(395887873039084636)
,p_name=>'P33_CREATED_MONTH'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(427665956719594857)
,p_prompt=>'Month Created'
,p_source=>'CREATED_MONTH'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov_sort_direction=>'ASC'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>8
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>false
,p_fc_show_selected_first=>false
,p_fc_show_chart=>true
,p_fc_initial_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>true
,p_fc_initial_toggled=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(395888013399084638)
,p_name=>'P33_LAST_UPDATED_BY'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(427665956719594857)
,p_prompt=>'Last Updated By'
,p_source=>'LAST_UPDATED_BY'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov_sort_direction=>'ASC'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>8
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>true
,p_fc_initial_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(395888242759084640)
,p_name=>'P33_CREATED_BY'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(427665956719594857)
,p_prompt=>'Created By'
,p_source=>'CREATED_BY'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov_sort_direction=>'ASC'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>8
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>true
,p_fc_initial_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(427666437262594869)
,p_name=>'P33_SEARCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(427665956719594857)
,p_prompt=>'Search'
,p_source=>'NAME,TAB_SET,ICON_TEXT,LAST_UPDATED_BY,CREATED_BY,ACTIONS,LOCKED,LOCKED_LINK,GROUP_NAME,GROUP_LINK,PAGE_TYPE,PAGE_MODE,PAGE_TYPE_CLASS,EDIT_PAGE_URL,ALIAS,PAGE_TITLE,FIRST_ITEM,INCLUDE_APEX_CSS_JS,FOOTER_TEXT,HEADER_TEXT,PAGE_TEMPLATE,AUTHORIZATION_S'
||'CHEME,BUILD_OPTION,HTML_PAGE_ONLOAD,ALLOW_DUPLICATE_SUBMISSIONS,ON_DUP_SUBMISSION_GOTO_URL,PAGE_IS_PUBLIC,PROTECTION_LEVEL,ERROR_NOTIFICATION_TEXT,CACHE_PAGE,PAGE_COMMENT,EDIT'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_SEARCH'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ROW'
,p_attribute_02=>'FACET'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_filter_values=>false
,p_fc_show_chart=>false
,p_fc_actions_filter=>false
);
end;
/
prompt --application/pages/page_00034
begin
wwv_flow_imp_page.create_page(
 p_id=>34
,p_name=>'Session State'
,p_alias=>'SESSION-STATE'
,p_step_title=>'Session State'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213427413171456110)
,p_step_template=>wwv_flow_imp.id(19943204431962826)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'concept_ses_view.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(720811677650848)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(2317966930424404)
,p_name=>'Background Processing'
,p_region_name=>'background_processing'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>80
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select e.id,',
'       e.flow_id,',
'       e.page_id,',
'       p.process_name      bg_process_name,',
'       cp.process_name     child_process_name,',
'       e.status,',
'       e.sofar,',
'       e.totalwork,',
'       e.context_value,',
'       e.created_on,',
'       e.last_updated_on,',
'       case when e.status in ( ''SCHEDULED'', ''EXECUTING'', ''ENQUEUED'' ) then to_char( e.id ) else ''X'' end as terminate_button',
'  from wwv_flow_step_processing p,',
'       wwv_flow_step_processing cp,',
'       wwv_flow_process_bg_execs$ e',
' where p.security_group_id       = e.security_group_id',
'   and p.flow_id                 = e.flow_id',
'   and p.id                      = e.process_id',
'    --',
'   and cp.security_group_id (+)     = e.security_group_id',
'   and cp.flow_id           (+)     = e.flow_id',
'   and cp.id                (+)     = e.current_exec_process_id',
'    --      ',
'   and e.security_group_id       = :FLOW_SECURITY_GROUP_ID',
'   and e.flow_id                 = :FB_FLOW_ID',
'   and e.started_from_session_id = :F4000_FLOW_SESSION',
'    --',
'   and page_id                   = :F4000_P34_PAGE',
'   and status                   in (select /*+ cardinality( t 3 )*/ column_value ',
'                                     from table( wwv_flow_string.split( :P34_BACKGROUND_STATES, '':'') ) t )',
'   and (   :P34_FIND is null',
'       or instr(p.process_name,upper(:P34_FIND)) > 0',
'       or instr(cp.process_name,upper(:P34_FIND)) > 0',
'       or instr(upper(p.process_name),upper(:P34_FIND)) > 0    ',
'       or instr(upper(cp.process_name),upper(:P34_FIND)) > 0 )',
''))
,p_display_when_condition=>'P34_VIEW'
,p_display_when_cond2=>'BG:A'
,p_display_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'F4000_P34_PAGE,P34_VIEW,P34_BACKGROUND_STATES,P34_FIND'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No background executions found.'
,p_query_num_rows_item=>'P34_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2319171210424416)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>20
,p_column_heading=>'ID'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2318953787424414)
,p_query_column_id=>2
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>30
,p_column_heading=>'Application'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2319096153424415)
,p_query_column_id=>3
,p_column_alias=>'PAGE_ID'
,p_column_display_sequence=>40
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2318623794424411)
,p_query_column_id=>4
,p_column_alias=>'BG_PROCESS_NAME'
,p_column_display_sequence=>50
,p_column_heading=>'Background Process '
,p_use_as_row_header=>'N'
,p_column_hit_highlight=>'&P34_FIND.'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2318795646424412)
,p_query_column_id=>5
,p_column_alias=>'CHILD_PROCESS_NAME'
,p_column_display_sequence=>80
,p_column_heading=>'Currently Executing'
,p_use_as_row_header=>'N'
,p_column_hit_highlight=>'&P34_FIND.'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2318288350424407)
,p_query_column_id=>6
,p_column_alias=>'STATUS'
,p_column_display_sequence=>60
,p_column_heading=>'Status'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(1814559837736230)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2319620218424421)
,p_query_column_id=>7
,p_column_alias=>'SOFAR'
,p_column_display_sequence=>120
,p_column_heading=>'So far'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2319720755424422)
,p_query_column_id=>8
,p_column_alias=>'TOTALWORK'
,p_column_display_sequence=>130
,p_column_heading=>'Total work'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1388676328156004)
,p_query_column_id=>9
,p_column_alias=>'CONTEXT_VALUE'
,p_column_display_sequence=>140
,p_column_heading=>'Context'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2319237104424417)
,p_query_column_id=>10
,p_column_alias=>'CREATED_ON'
,p_column_display_sequence=>100
,p_column_heading=>'Started'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_column_alignment=>'CENTER'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2319311703424418)
,p_query_column_id=>11
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>110
,p_column_heading=>'Last Change'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_column_alignment=>'CENTER'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2320026621424425)
,p_query_column_id=>12
,p_column_alias=>'TERMINATE_BUTTON'
,p_column_display_sequence=>150
,p_column_heading=>'Action'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{case TERMINATE_BUTTON/}',
'{when X/}',
' ',
'{otherwise/}',
'<button data-terminate-id="#ID#" type="button" title="Terminate Execution ID #ID#" aria-label="Terminate Execution ID #ID#" class="a-Button a-Button--danger a-Button--small terminate-execution">',
'        <span aria-hidden="true">Terminate</span>',
'</button>',
'{endcase/}',
'',
''))
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(77549119545304597)
,p_name=>'Page Items'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select application_id       flow,',
'       page_id              page,',
'       item_name            name,',
'       item_prompt          prompt,',
'       item_display_as      display_as,',
'       data_item_id         id,',
'       item_value_decrypted item_value,',
'       session_state_status,',
'       is_encrypted         encrypted',
'  from wwv_flow_data_view',
' where session_id        = :F4000_FLOW_SESSION',
'   and application_id    = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
'   and page_id           = :F4000_P34_PAGE',
'   and (   :P34_FIND is null',
'        or instr(item_name,upper(:P34_FIND)) > 0',
'        or instr(upper(item_value),upper(:P34_FIND)) > 0)'))
,p_display_when_condition=>'P34_VIEW'
,p_display_when_cond2=>'P:A'
,p_display_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' '
,p_query_no_data_found=>'Page has no items. '
,p_query_num_rows_item=>'P34_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
,p_comment=>'July-10-2003: Added this region to use SQL QUERY instead of PL/SQL block.'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(77549528962304616)
,p_query_column_id=>1
,p_column_alias=>'FLOW'
,p_column_display_sequence=>1
,p_column_heading=>'Application'
,p_use_as_row_header=>'N'
,p_column_css_class=>'instructiontext'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(77549619255304618)
,p_query_column_id=>2
,p_column_alias=>'PAGE'
,p_column_display_sequence=>2
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(77549704980304618)
,p_query_column_id=>3
,p_column_alias=>'NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Item Name'
,p_use_as_row_header=>'N'
,p_column_hit_highlight=>'&P34_FIND.'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(77549819529304618)
,p_query_column_id=>4
,p_column_alias=>'PROMPT'
,p_column_display_sequence=>4
,p_column_heading=>'Label'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(77549925620304618)
,p_query_column_id=>5
,p_column_alias=>'DISPLAY_AS'
,p_column_display_sequence=>6
,p_column_heading=>'Display'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(29353308376249352)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(77550008482304618)
,p_query_column_id=>6
,p_column_alias=>'ID'
,p_column_display_sequence=>5
,p_column_heading=>'ID'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(77778013919022076)
,p_query_column_id=>7
,p_column_alias=>'ITEM_VALUE'
,p_column_display_sequence=>7
,p_column_heading=>'Item Value'
,p_use_as_row_header=>'N'
,p_column_hit_highlight=>'&P34_FIND.'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(77680223403778203)
,p_query_column_id=>8
,p_column_alias=>'SESSION_STATE_STATUS'
,p_column_display_sequence=>8
,p_column_heading=>'Status'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(15256524524201747)
,p_query_column_id=>9
,p_column_alias=>'ENCRYPTED'
,p_column_display_sequence=>9
,p_column_heading=>'Encrypted'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(77898026254716368)
,p_name=>'Application Environment'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select :F4000_FLOW_SESSION     flow_session,',
'       :F4000_P34_USER         flow_user,',
'       :FLOW_SECURITY_GROUP_ID flow_security_group_id,',
'       :BROWSER_LANGUAGE       browser_language',
'  from sys.dual'))
,p_translate_title=>'N'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>2
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' '
,p_query_break_cols=>'0'
,p_query_num_rows_item=>'P34_ROWS'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_comment=>'July-10-2003: Added this region to use SQL QUERY instead of PL/SQL block.'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(77901015996722940)
,p_query_column_id=>1
,p_column_alias=>'FLOW_SESSION'
,p_column_display_sequence=>1
,p_column_heading=>'Session'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(77901117677722947)
,p_query_column_id=>2
,p_column_alias=>'FLOW_USER'
,p_column_display_sequence=>2
,p_column_heading=>'User'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(77901220077722947)
,p_query_column_id=>3
,p_column_alias=>'FLOW_SECURITY_GROUP_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Workspace'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(77901322766722947)
,p_query_column_id=>4
,p_column_alias=>'BROWSER_LANGUAGE'
,p_column_display_sequence=>4
,p_column_heading=>'Browser Language'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(77908104484738534)
,p_name=>'Session State'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>70
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select application_id  flow_id,',
'       page_id         flow_step_id,',
'       item_name       name,',
'       item_value      item_Val,',
'       item_display_as disp,',
'       item_prompt,',
'       data_item_id,',
'       is_encrypted    encrypted',
'  from wwv_flow_data_view',
' where session_id = :F4000_FLOW_SESSION',
'   and security_group_id = :flow_security_group_id',
'   and (application_id = :FB_FLOW_ID or item_scope = ''GLOBAL'')',
'   and (   :P34_FIND is null',
'       or instr(item_name,upper(:P34_FIND)) > 0',
'       or instr(upper(item_value),upper(:P34_FIND)) > 0)',
' order by 1,2,3'))
,p_display_when_condition=>'P34_VIEW'
,p_display_when_cond2=>'S:A'
,p_display_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' '
,p_query_no_data_found=>'No session state items.'
,p_query_num_rows_item=>'P34_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
,p_comment=>'July-10-2003: Added this region to use SQL QUERY instead of PL/SQL block.'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(77908719748738543)
,p_query_column_id=>1
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Application'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(77908803379738543)
,p_query_column_id=>2
,p_column_alias=>'FLOW_STEP_ID'
,p_column_display_sequence=>2
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(77908917456738544)
,p_query_column_id=>3
,p_column_alias=>'NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Item Name'
,p_use_as_row_header=>'N'
,p_column_hit_highlight=>'&P34_FIND.'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(77923009388844042)
,p_query_column_id=>4
,p_column_alias=>'ITEM_VAL'
,p_column_display_sequence=>4
,p_column_heading=>'Item Value'
,p_use_as_row_header=>'N'
,p_column_hit_highlight=>'&P34_FIND.'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(77922415144836261)
,p_query_column_id=>5
,p_column_alias=>'DISP'
,p_column_display_sequence=>5
,p_column_heading=>'Display'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(29544521926748713)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(77923419777847040)
,p_query_column_id=>6
,p_column_alias=>'ITEM_PROMPT'
,p_column_display_sequence=>6
,p_column_heading=>'Label'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(217301406366276681)
,p_query_column_id=>7
,p_column_alias=>'DATA_ITEM_ID'
,p_column_display_sequence=>8
,p_column_heading=>'Data Item Id'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(15257118075209375)
,p_query_column_id=>8
,p_column_alias=>'ENCRYPTED'
,p_column_display_sequence=>7
,p_column_heading=>'Encrypted'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(163722811206966904)
,p_name=>'Application Items'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>60
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select application_id flow,',
'       item_name,',
'       item_value',
'  from wwv_flow_data_view',
' where session_id        = :F4000_FLOW_SESSION',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and (application_id   = :FB_FLOW_ID or application_id is null)',
'   and item_scope in (''APP'',''GLOBAL'')',
'   and (   :P34_FIND is null',
'        or instr(item_name,upper(:P34_FIND))         > 0',
'        or instr(upper(item_value),upper(:P34_FIND)) > 0)'))
,p_display_when_condition=>'P34_VIEW'
,p_display_when_cond2=>'I:A'
,p_display_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_item=>'P34_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(163723113316966914)
,p_query_column_id=>1
,p_column_alias=>'FLOW'
,p_column_display_sequence=>1
,p_column_heading=>'Application'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(217263027532962986)
,p_query_column_id=>2
,p_column_alias=>'ITEM_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Item Name'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3704929527307)
,p_query_column_id=>3
,p_column_alias=>'ITEM_VALUE'
,p_column_display_sequence=>3
,p_column_heading=>'Item Value'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(243294006587845793)
,p_plug_name=>'Collections'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>90
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    c.collection_name, m.seq_id, ',
'    m.c001, m.c002, m.c003, m.c004, m.c005, m.c006, m.c007, ',
'    m.c008, m.c009, m.c010, m.c011, m.c012, m.c013, m.c014,',
'    m.c015, m.c016, m.c017, m.c018, m.c019, m.c020, m.c021,',
'    m.c022, m.c023, m.c024, m.c025, m.c026, m.c027, m.c028,',
'    m.c029, m.c030, m.c031, m.c032, m.c033, m.c034, m.c035,',
'    m.c036, m.c037, m.c038, m.c039, m.c040, m.c041, m.c042,',
'    m.c043, m.c044, m.c045, m.c046, m.c047, m.c048, m.c049,',
'    m.c050, m.n001, m.n002, m.n003, m.n004,',
'    m.n005, m.d001, m.d002, m.d003, m.d004, m.d005, ',
'    sys.dbms_lob.substr(m.clob001,500,1) clob001, ',
'    case when xmltype001 is null then null else sys.dbms_lob.substr(extract(xmltype001,''*'').getclobval(),500,1) || ''...'' end xmltype001,',
'm.md5_original ',
'from wwv_flow_collections$ c, ',
'     wwv_flow_collection_members$ m ',
'where c.session_id = :F4000_FLOW_SESSION',
'        and c.security_group_id = :flow_security_group_id',
'        and c.id = m.collection_id ',
'        and c.flow_id = :fb_flow_id and',
'       (:P34_FIND is null or ',
'        instr(upper(c.collection_name),upper(:P34_FIND)) > 0)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_plug_display_when_condition=>'P34_VIEW'
,p_plug_display_when_cond2=>'C:A'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(243294104975845793)
,p_name=>'Collections'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than #MAX_ROW_COUNT# rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'JOEL'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243294327893845805)
,p_db_column_name=>'COLLECTION_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Collection Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243294422127845812)
,p_db_column_name=>'SEQ_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Sequence'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243294519172845812)
,p_db_column_name=>'C001'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'C001'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243294601176845812)
,p_db_column_name=>'C002'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'C002'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243294731145845812)
,p_db_column_name=>'C003'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'C003'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243294809175845812)
,p_db_column_name=>'C004'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'C004'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243294910660845813)
,p_db_column_name=>'C005'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'C005'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243295003743845813)
,p_db_column_name=>'C006'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'C006'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243295111869845813)
,p_db_column_name=>'C007'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'C007'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243295213287845813)
,p_db_column_name=>'C008'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'C008'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243295328081845813)
,p_db_column_name=>'C009'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'C009'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243295406510845813)
,p_db_column_name=>'C010'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'C010'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243295517956845813)
,p_db_column_name=>'C011'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'C011'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243295623806845813)
,p_db_column_name=>'C012'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'C012'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243295703683845813)
,p_db_column_name=>'C013'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'C013'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243295805033845813)
,p_db_column_name=>'C014'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'C014'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243295926447845813)
,p_db_column_name=>'C015'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'C015'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243296013885845814)
,p_db_column_name=>'C016'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'C016'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243296114134845814)
,p_db_column_name=>'C017'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'C017'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243296222613845814)
,p_db_column_name=>'C018'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'C018'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243296306146845814)
,p_db_column_name=>'C019'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>'C019'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243296417367845814)
,p_db_column_name=>'C020'
,p_display_order=>22
,p_column_identifier=>'V'
,p_column_label=>'C020'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243296507042845815)
,p_db_column_name=>'C021'
,p_display_order=>23
,p_column_identifier=>'W'
,p_column_label=>'C021'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243296619652845815)
,p_db_column_name=>'C022'
,p_display_order=>24
,p_column_identifier=>'X'
,p_column_label=>'C022'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243296722552845815)
,p_db_column_name=>'C023'
,p_display_order=>25
,p_column_identifier=>'Y'
,p_column_label=>'C023'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243296822938845815)
,p_db_column_name=>'C024'
,p_display_order=>26
,p_column_identifier=>'Z'
,p_column_label=>'C024'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243296901401845815)
,p_db_column_name=>'C025'
,p_display_order=>27
,p_column_identifier=>'AA'
,p_column_label=>'C025'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243297017091845815)
,p_db_column_name=>'C026'
,p_display_order=>28
,p_column_identifier=>'AB'
,p_column_label=>'C026'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243297123610845815)
,p_db_column_name=>'C027'
,p_display_order=>29
,p_column_identifier=>'AC'
,p_column_label=>'C027'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243297224510845815)
,p_db_column_name=>'C028'
,p_display_order=>30
,p_column_identifier=>'AD'
,p_column_label=>'C028'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243297315457845816)
,p_db_column_name=>'C029'
,p_display_order=>31
,p_column_identifier=>'AE'
,p_column_label=>'C029'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243297427399845816)
,p_db_column_name=>'C030'
,p_display_order=>32
,p_column_identifier=>'AF'
,p_column_label=>'C030'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243297509787845816)
,p_db_column_name=>'C031'
,p_display_order=>33
,p_column_identifier=>'AG'
,p_column_label=>'C031'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243297626094845816)
,p_db_column_name=>'C032'
,p_display_order=>34
,p_column_identifier=>'AH'
,p_column_label=>'C032'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243297707700845816)
,p_db_column_name=>'C033'
,p_display_order=>35
,p_column_identifier=>'AI'
,p_column_label=>'C033'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243297825557845816)
,p_db_column_name=>'C034'
,p_display_order=>36
,p_column_identifier=>'AJ'
,p_column_label=>'C034'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243297930390845816)
,p_db_column_name=>'C035'
,p_display_order=>37
,p_column_identifier=>'AK'
,p_column_label=>'C035'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243298012437845817)
,p_db_column_name=>'C036'
,p_display_order=>38
,p_column_identifier=>'AL'
,p_column_label=>'C036'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243298101973845817)
,p_db_column_name=>'C037'
,p_display_order=>39
,p_column_identifier=>'AM'
,p_column_label=>'C037'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243298212273845817)
,p_db_column_name=>'C038'
,p_display_order=>40
,p_column_identifier=>'AN'
,p_column_label=>'C038'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243298321482845817)
,p_db_column_name=>'C039'
,p_display_order=>41
,p_column_identifier=>'AO'
,p_column_label=>'C039'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243298411370845817)
,p_db_column_name=>'C040'
,p_display_order=>42
,p_column_identifier=>'AP'
,p_column_label=>'C040'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243298527060845817)
,p_db_column_name=>'C041'
,p_display_order=>43
,p_column_identifier=>'AQ'
,p_column_label=>'C041'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243298608650845817)
,p_db_column_name=>'C042'
,p_display_order=>44
,p_column_identifier=>'AR'
,p_column_label=>'C042'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243298708661845817)
,p_db_column_name=>'C043'
,p_display_order=>45
,p_column_identifier=>'AS'
,p_column_label=>'C043'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243298829758845817)
,p_db_column_name=>'C044'
,p_display_order=>46
,p_column_identifier=>'AT'
,p_column_label=>'C044'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243298908965845817)
,p_db_column_name=>'C045'
,p_display_order=>47
,p_column_identifier=>'AU'
,p_column_label=>'C045'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243299001764845817)
,p_db_column_name=>'C046'
,p_display_order=>48
,p_column_identifier=>'AV'
,p_column_label=>'C046'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243299101936845817)
,p_db_column_name=>'C047'
,p_display_order=>49
,p_column_identifier=>'AW'
,p_column_label=>'C047'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243299221765845817)
,p_db_column_name=>'C048'
,p_display_order=>50
,p_column_identifier=>'AX'
,p_column_label=>'C048'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243299332668845817)
,p_db_column_name=>'C049'
,p_display_order=>51
,p_column_identifier=>'AY'
,p_column_label=>'C049'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243299408069845817)
,p_db_column_name=>'C050'
,p_display_order=>52
,p_column_identifier=>'AZ'
,p_column_label=>'C050'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243299507658845817)
,p_db_column_name=>'N001'
,p_display_order=>53
,p_column_identifier=>'BA'
,p_column_label=>'N001'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243299631780845817)
,p_db_column_name=>'N002'
,p_display_order=>54
,p_column_identifier=>'BB'
,p_column_label=>'N002'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243299730252845817)
,p_db_column_name=>'N003'
,p_display_order=>55
,p_column_identifier=>'BC'
,p_column_label=>'N003'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243299811939845819)
,p_db_column_name=>'N004'
,p_display_order=>56
,p_column_identifier=>'BD'
,p_column_label=>'N004'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243299909032845819)
,p_db_column_name=>'N005'
,p_display_order=>57
,p_column_identifier=>'BE'
,p_column_label=>'N005'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243300015354845819)
,p_db_column_name=>'D001'
,p_display_order=>58
,p_column_identifier=>'BF'
,p_column_label=>'D001'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243300100289845819)
,p_db_column_name=>'D002'
,p_display_order=>59
,p_column_identifier=>'BG'
,p_column_label=>'D002'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243300211790845819)
,p_db_column_name=>'D003'
,p_display_order=>60
,p_column_identifier=>'BH'
,p_column_label=>'D003'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243300312477845819)
,p_db_column_name=>'D004'
,p_display_order=>61
,p_column_identifier=>'BI'
,p_column_label=>'D004'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243300404785845819)
,p_db_column_name=>'D005'
,p_display_order=>62
,p_column_identifier=>'BJ'
,p_column_label=>'D005'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243300511996845820)
,p_db_column_name=>'CLOB001'
,p_display_order=>63
,p_column_identifier=>'BK'
,p_column_label=>'CLOB001'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243300629402845820)
,p_db_column_name=>'XMLTYPE001'
,p_display_order=>64
,p_column_identifier=>'BL'
,p_column_label=>'XMLTYPE001'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(243300711365845820)
,p_db_column_name=>'MD5_ORIGINAL'
,p_display_order=>65
,p_column_identifier=>'BM'
,p_column_label=>'MD5_ORIGINAL'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(243322903983850177)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1298210153536645'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'COLLECTION_NAME:SEQ_ID:C001:C002:C003:C004:C005:C006:C007:C008:C009:C010:N001:N002:N003:N004:N005:D001:D002:D003:D004:D005:CLOB001:XMLTYPE001:MD5_ORIGINAL'
,p_sort_column_1=>'COLLECTION_NAME'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'SEQ_ID'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(451400804130085872)
,p_plug_name=>'Finder Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(6207014968942318)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(483665625206265911)
,p_plug_name=>'Help'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_f4000_util.show_help_link (',
'   p_lang           => ''en'',',
'   p_session_id     => :app_session,',
'   p_application_id => 4000,',
'   p_page_id        => wwv_flow.g_flow_step_id);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NEVER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2416577690249213)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(2317966930424404)
,p_button_name=>'PICK_BG_STATUS'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Go'
,p_button_alignment=>'CENTER-CENTER'
,p_warn_on_unsaved_changes=>null
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(719111677573587)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(720811677650848)
,p_button_name=>'F4000_P34_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Set'
,p_button_alignment=>'LEFT-CENTER'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(719311677576698)
,p_branch_name=>'Go To Page 34'
,p_branch_action=>'f?p=&APP_ID.:34:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(718511677506223)
,p_name=>'F4000_P34_PAGE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(720811677650848)
,p_item_default=>'F4000_FLOW_PAGE'
,p_item_default_type=>'ITEM'
,p_prompt=>'Page'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>4
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_escape_on_http_input=>'Y'
,p_help_text=>'To locate a page, enter the page number and click <strong>Set</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(721411677695023)
,p_name=>'F4000_P34_FLOW'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(77898026254716368)
,p_use_cache_before_default=>'NO'
,p_item_default=>'FB_FLOW_ID'
,p_item_default_type=>'ITEM'
,p_prompt=>'Application:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LIST FLOWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'where  build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'order by 2'))
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies the application name, session ID, current user, workspace ID, and browser language.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2319522677424420)
,p_name=>'P34_BACKGROUND_STATES'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2317966930424404)
,p_item_default=>'ENQUEUED:SCHEDULED:EXECUTING'
,p_prompt=>'Statuses'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'BACKGROUND_EXECUTION_STATUS'
,p_lov=>'.'||wwv_flow_imp.id(1814559837736230)||'.'
,p_colspan=>12
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Fetch background executions with the following statuses.'
,p_attribute_01=>'6'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2320503597424430)
,p_name=>'P34_BG_EXECUTION_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2317966930424404)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(68360718344072070)
,p_name=>'F4000_P34_USER'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(720811677650848)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select username',
'  from wwv_flow_sessions$',
' where id                = :F4000_FLOW_SESSION',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(116334620243331046)
,p_name=>'P34_FIND'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(720811677650848)
,p_prompt=>'Find'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a case insensitive query for and click <strong>Set</strong>.  It will be used to search item name and item value or collection name (depending upon your View). '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(201433822925950722)
,p_name=>'P34_ROWS'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(720811677650848)
,p_item_default=>'50'
,p_prompt=>'Rows'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAXIMUM ROWS PER PAGE'
,p_lov=>'.'||wwv_flow_imp.id(84800803131139158)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'U'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the number of items to display and click <strong>Set</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(201438430806971908)
,p_name=>'P34_VIEW'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(720811677650848)
,p_item_default=>'P'
,p_prompt=>'View'
,p_source=>'P'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'SESSION STATE VIEW OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(201460728952037663)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the session state report you wish to view.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2319836595424423)
,p_name=>'Refresh'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2416577690249213)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2319904654424424)
,p_event_id=>wwv_flow_imp.id(2319836595424423)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2317966930424404)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2320103380424426)
,p_name=>'Terminate Execution'
,p_event_sequence=>20
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'.terminate-execution'
,p_bind_type=>'live'
,p_bind_delegate_to_selector=>'#background_processing'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2320202063424427)
,p_event_id=>wwv_flow_imp.id(2320103380424426)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'Do you really want to terminate that background execution?'
,p_attribute_03=>'danger'
,p_attribute_06=>'Terminate'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2320335889424428)
,p_event_id=>wwv_flow_imp.id(2320103380424426)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P34_BG_EXECUTION_ID'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$( this.triggeringElement ).data( "terminate-id" )'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2320467023424429)
,p_event_id=>wwv_flow_imp.id(2320103380424426)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'TERMINATE_JOB'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(216992649250910232)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Validate Session'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_session number;',
'begin',
'    if :F4000_FLOW_SESSION is not null then',
'        select id',
'          into l_session',
'          from wwv_flow_sessions$',
'         where security_group_id = :FLOW_SECURITY_GROUP_ID',
'           and id                = :F4000_FLOW_SESSION;',
'    end if;',
'exception when no_data_found then',
'    wwv_flow_error.raise_internal_error (',
'        p_error_code => ''APEX.SESSION.EXPIRED'' );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>216992649250910232
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(201458301248029637)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when_button_id=>wwv_flow_imp.id(719111677573587)
,p_internal_uid=>201458301248029637
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2320677193424431)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Terminate background execution'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_process_bg.abort(',
'        p_security_group_id => :FLOW_SECURITY_GROUP_ID,         ',
'        p_application_id    => :FB_FLOW_ID,',
'        p_execution_id      => :P34_BG_EXECUTION_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'TERMINATE_JOB'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>'Background Execution ID &P34_BG_EXECUTION_ID. terminated.'
,p_internal_uid=>2320677193424431
);
end;
/
prompt --application/pages/page_00037
begin
wwv_flow_imp_page.create_page(
 p_id=>37
,p_name=>'Saved Interactive Reports'
,p_alias=>'SAVED-INTERACTIVE-REPORTS'
,p_step_title=>'Saved Interactive Reports'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'No help is available for this page.'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30303226880414948)
,p_plug_name=>'Saved Reports'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'case when r.is_default!=''Y'' or r.application_user!=''APXWS_DEFAULT'' then',
'    wwv_flow_item.checkbox(1, r.id,null,null,'':'', ''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0'') ,',
'                           wwv_flow_lang.system_message(''REPORT_LABEL'',wwv_flow_escape.html(r.name))',
'                          )',
'end id,',
'i.page_id npage_id,',
'i.region_id nregion_id,',
'(select plug_name from wwv_flow_page_plugs where id = i.region_id) region_name,',
'case when r.is_default = ''Y''then ',
'     decode(r.application_user,',
'            ''APXWS_DEFAULT'',sm.primary_def, ',
'            ''APXWS_ALTERNATIVE'',sm.alt_def)',
'     when r.is_default = ''N'' and r.status = ''PUBLIC'' then',
'         sm.spublic',
'     when r.is_default = ''N'' and r.status = ''PRIVATE'' then',
'         sm.private',
'end report_type, ',
'case when r.is_default=''Y'' and r.application_user=''APXWS_DEFAULT'' then',
'    sm.primary_rpt',
'else',
'    r.name',
'end name,',
'decode(r.application_user,',
'       ''APXWS_DEFAULT'',null,',
'       ''APXWS_ALTERNATIVE'',null,',
'       r.application_user) owner,',
'substr(r.description,1,50) description,        ',
'r.report_alias report_alias',
'from wwv_flow_worksheets i,',
'wwv_flow_worksheet_rpts r,',
'(select wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY.DEFAULT'') primary_def,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.ALTERNATIVE.DEFAULT'') alt_def,               ',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.PRIVATE'') private,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.PUBLIC'') spublic,',
'      wwv_flow_lang.system_message(''SAVED_REPORTS.PRIMARY_REPORT'') primary_rpt',
' from dual) sm',
'where r.worksheet_id = i.id',
'and r.session_id is null',
'and r.security_group_id = :flow_security_group_id',
'and i.flow_id = :fb_flow_id',
'and i.flow_id not in (select id from wwv_flows where build_status = ''RUN_AND_HIDDEN'' and security_group_id=i.security_group_id)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(30303327946414950)
,p_name=>'Saved Reports'
,p_max_row_count=>'1000000'
,p_max_row_count_message=>'The maximum row count for this report is #MAX_ROW_COUNT# rows.  Please apply a filter to reduce the number of records in your query.'
,p_no_data_found_message=>'No saved reports found.'
,p_allow_report_categories=>'N'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'CBCHO'
,p_internal_uid=>30303327946414950
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30303526233414986)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30303722914414986)
,p_db_column_name=>'NPAGE_ID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Page'
,p_column_link=>'f?p=4000:4500:&SESSION.::NO::FB_FLOW_ID,FB_FLOW_PAGE_ID:&FB_FLOW_ID.,#NPAGE_ID#'
,p_column_linktext=>'#NPAGE_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30303821823414986)
,p_db_column_name=>'NREGION_ID'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Region ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30303906070414986)
,p_db_column_name=>'REGION_NAME'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Region Name'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#NPAGE_ID##5110:#NREGION_ID#'
,p_column_linktext=>'#REGION_NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30304016299414986)
,p_db_column_name=>'REPORT_TYPE'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Report Type'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30304122522414987)
,p_db_column_name=>'NAME'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Report Name'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30304206177414987)
,p_db_column_name=>'OWNER'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Owner'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30304306872414987)
,p_db_column_name=>'DESCRIPTION'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Description'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30304426408414987)
,p_db_column_name=>'REPORT_ALIAS'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Report Alias'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(30304628612415456)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'303047'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'ID:NPAGE_ID:REGION_NAME:REPORT_TYPE:NAME:REPORT_ALIAS:OWNER'
,p_sort_column_1=>'NPAGE_ID'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_worksheet_condition(
 p_id=>wwv_flow_imp.id(36464123124780221)
,p_report_id=>wwv_flow_imp.id(30304628612415456)
,p_condition_type=>'FILTER'
,p_allow_delete=>'Y'
,p_column_name=>'REPORT_TYPE'
,p_operator=>'!='
,p_expr=>'Primary Default'
,p_condition_sql=>'"REPORT_TYPE" != #APXWS_EXPR#'
,p_condition_display=>'#APXWS_COL_NAME# != ''Primary Default''  '
,p_enabled=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30324714693282004)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(30303226880414948)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:37:&SESSION.::&DEBUG.:RP,RIR::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30324929238286111)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(30303226880414948)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Delete Checked'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'from wwv_flow_worksheets i, wwv_flow_worksheet_rpts r',
'where i.id = r.worksheet_id',
'and i.security_group_id = :flow_security_group_id',
'and i.flow_id = :fb_flow_id',
'and r.session_id is null'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(30325900893339192)
,p_branch_action=>'f?p=&APP_ID.:37:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(30325532608309216)
,p_validation_name=>'must select report to delete'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow.g_f01.count = 0 then',
'  return false;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Report must be selected to delete.'
,p_when_button_pressed=>wwv_flow_imp.id(30324929238286111)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1199172901973878405)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(30303226880414948)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1199173020724878406)
,p_event_id=>wwv_flow_imp.id(1199172901973878405)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(30325609245337109)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete checked'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count',
'loop',
'    for l_ir_rpt in (',
'        select id, worksheet_id',
'          from wwv_flow_worksheet_rpts',
'         where id = wwv_flow.g_f01(i)',
'           and security_group_id = :WORKSPACE_ID',
'           and flow_id = :FB_FLOW_ID )',
'    loop',
'        wwv_flow_ir.builder_delete_saved_report (',
'            p_workspace_id      => :WORKSPACE_ID,',
'            p_worksheet_id      => l_ir_rpt.worksheet_id,',
'            p_report_id         => l_ir_rpt.id );     ',
'    end loop;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to delete report.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(30324929238286111)
,p_process_success_message=>'The report(s) deleted.'
,p_internal_uid=>30325609245337109
);
end;
/
prompt --application/pages/page_00038
begin
wwv_flow_imp_page.create_page(
 p_id=>38
,p_name=>'Resequence Upgrade Scripts'
,p_alias=>'RESEQUENCE-UPGRADE-SCRIPTS'
,p_step_title=>'Resequence Upgrade Scripts'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_pg_def_common.htm'
,p_page_component_map=>'11'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(380040721789746578)
,p_plug_name=>'Resequence'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>100
,p_plug_source=>'<p>Resequence upgrade scripts, incrementing sequence numbers by 10.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1080990639647523939)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(380041184606746588)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1080990639647523939)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Resequence'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(380040933054746581)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1080990639647523939)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:473:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(380042328067746625)
,p_branch_action=>'f?p=&APP_ID.:667:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(380042053236746621)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Resequence upgrade scripts'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  s number := 0;',
'begin',
'  for c1 in (',
'    select id, sequence',
'    from wwv_flow_install_scripts',
'    where flow_id = :fb_flow_id ',
'    and security_group_id = :flow_security_group_id',
'    and nvl(script_type,''INSTALL'') = ''UPGRADE''',
'    order by sequence)',
'  loop',
'    s := s + 10;',
'    update wwv_flow_install_scripts',
'    set sequence = s',
'    where flow_id = :fb_flow_id ',
'    and security_group_id = :flow_security_group_id ',
'    and id = c1.id',
'    and sequence != s;',
'  end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(380041184606746588)
,p_process_success_message=>'Upgrade scripts resequenced.'
,p_internal_uid=>380042053236746621
);
end;
/
prompt --application/pages/page_00039
begin
wwv_flow_imp_page.create_page(
 p_id=>39
,p_name=>'Subscriptions'
,p_alias=>'SUBSCRIPTIONS'
,p_step_title=>'Subscriptions'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'No help is available for this page.'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30639114984365858)
,p_plug_name=>'Subscriptions'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'wwv_flow_item.checkbox(1, n.id, null,null,'':'',''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0'') ,',
'wwv_flow_lang.system_message(''IR_SUBSCRIPTION_LABEL'',i.flow_id,i.page_id,n.owner)) id,',
'i.page_id npage_id,',
'region_id nregion_id,',
'(select plug_name from wwv_flow_page_plugs where id = i.region_id) region_name,',
'n.session_id,',
'n.owner    application_user,',
'n.language language,',
'decode(n.download_format,',
'    ''XLSX'',''Excel'',',
'    n.download_format) download_format,',
'decode(n.strip_rich_text,',
'    ''Y'',m.m_yes,',
'    ''N'',m.m_no) strip_rich_text,',
'decode(n.data_only,',
'    ''Y'',m.m_yes,',
'    ''N'',m.m_no,',
'    m.m_no) data_only,',
'decode(n.pdf_page_size,',
'    ''A3'',m.m_a3,',
'    ''A4'',m.m_a4,',
'    ''LEGAL'',m.m_legal,',
'    ''LETTER'',m.m_letter,',
'    ''CUSTOM'',m.m_custom,',
'    ''TABLOID'',m.m_tabloid,',
'    pdf_page_size) pdf_page_size,',
'decode(n.pdf_page_orientation,',
'    ''VERTICAL'',m.m_vertical,',
'    ''HORIZONTAL'',m.m_horizontal,',
'    pdf_page_orientation) pdf_page_orientation,',
'decode(n.pdf_accessible,',
'    ''Y'',m.m_yes,',
'    ''N'',m.m_no) pdf_accessible,',
'decode(n.skip_no_data_found,',
'    ''Y'',m.m_yes,',
'    ''N'',m.m_no) skip_no_data_found,',
'n.start_date at time zone sessiontimezone start_date,',
'n.end_date at time zone sessiontimezone end_date,',
'case when nvl(n.end_date,systimestamp) >= systimestamp then',
'    n.offset_date',
'end offset_date,',
'n.notify_interval notify_interval,',
'n.status,',
'n.notify_error,',
'n.email_from,',
'n.email_address,',
'n.email_subject,',
'n.created_by,',
'n.created_on',
'from wwv_flow_worksheet_notify n,',
'wwv_flow_worksheets i,',
'wwv_flow_worksheet_rpts r,',
'(select ',
'       wwv_flow_lang.system_message(''F4000.YES'') m_yes,',
'       wwv_flow_lang.system_message(''F4000.NO'') m_no,',
'       wwv_flow_lang.system_message(''APEXIR_PDF_ORIENTATION_VERTICAL'') m_vertical,',
'       wwv_flow_lang.system_message(''APEXIR_PDF_ORIENTATION_HORIZONTAL'') m_horizontal,',
'       wwv_flow_lang.system_message(''APEXIR_PDF_PAGE_SIZE_A3'') m_a3,',
'       wwv_flow_lang.system_message(''APEXIR_PDF_PAGE_SIZE_A4'') m_a4,',
'       wwv_flow_lang.system_message(''APEXIR_PDF_PAGE_SIZE_LEGAL'') m_legal,',
'       wwv_flow_lang.system_message(''APEXIR_PDF_PAGE_SIZE_LETTER'') m_letter,',
'       wwv_flow_lang.system_message(''APEXIR_PDF_PAGE_SIZE_CUSTOM'') m_custom,',
'       wwv_flow_lang.system_message(''APEXIR_PDF_PAGE_SIZE_TABLOID'') m_tabloid',
'from dual) m',
'where n.worksheet_id = i.id',
'and n.report_id = r.id',
'and n.security_group_id = :flow_security_group_id',
'and i.flow_id = :fb_flow_id',
'and i.flow_id not in (select id from wwv_flows where build_status = ''RUN_AND_HIDDEN'' and security_group_id=i.security_group_id)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(30639312830365860)
,p_name=>'Saved Reports'
,p_max_row_count=>'1000000'
,p_max_row_count_message=>'The maximum row count for this report is #MAX_ROW_COUNT# rows.  Please apply a filter to reduce the number of records in your query.'
,p_no_data_found_message=>'No subscriptions found.'
,p_allow_report_categories=>'N'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:EMAIL'
,p_enable_mail_download=>'Y'
,p_owner=>'CBCHO'
,p_internal_uid=>30639312830365860
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30639415394365869)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30639512230365871)
,p_db_column_name=>'NPAGE_ID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Page'
,p_column_link=>'f?p=4000:4500:&SESSION.::NO::FB_FLOW_ID,FB_FLOW_PAGE_ID:&FB_FLOW_ID.,#NPAGE_ID#'
,p_column_linktext=>'#NPAGE_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30639624413365871)
,p_db_column_name=>'NREGION_ID'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Region ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30639726708365871)
,p_db_column_name=>'REGION_NAME'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Region'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#NPAGE_ID##5110:#NREGION_ID#'
,p_column_linktext=>'#REGION_NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(170215980944860901)
,p_db_column_name=>'SESSION_ID'
,p_display_order=>15
,p_column_identifier=>'S'
,p_column_label=>'Session'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30642123922422753)
,p_db_column_name=>'APPLICATION_USER'
,p_display_order=>25
,p_column_identifier=>'G'
,p_column_label=>'Subscribed By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30642232486422753)
,p_db_column_name=>'LANGUAGE'
,p_display_order=>35
,p_column_identifier=>'H'
,p_column_label=>'Language'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30642300481422753)
,p_db_column_name=>'START_DATE'
,p_display_order=>45
,p_column_identifier=>'I'
,p_column_label=>'Start Date'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30642411525422754)
,p_db_column_name=>'END_DATE'
,p_display_order=>55
,p_column_identifier=>'J'
,p_column_label=>'End Date'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30642508608422754)
,p_db_column_name=>'OFFSET_DATE'
,p_display_order=>65
,p_column_identifier=>'K'
,p_column_label=>'Offset Date'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30642628163422754)
,p_db_column_name=>'NOTIFY_INTERVAL'
,p_display_order=>75
,p_column_identifier=>'L'
,p_column_label=>'Frequency'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(30663301353708410)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30642721569422754)
,p_db_column_name=>'STATUS'
,p_display_order=>85
,p_column_identifier=>'M'
,p_column_label=>'Status'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(30664415898712648)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30642830411422755)
,p_db_column_name=>'NOTIFY_ERROR'
,p_display_order=>95
,p_column_identifier=>'N'
,p_column_label=>'Error Message'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30642927635422755)
,p_db_column_name=>'EMAIL_FROM'
,p_display_order=>105
,p_column_identifier=>'O'
,p_column_label=>'Email From'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30643029636422755)
,p_db_column_name=>'EMAIL_ADDRESS'
,p_display_order=>115
,p_column_identifier=>'P'
,p_column_label=>'Email To'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(170216061811860902)
,p_db_column_name=>'EMAIL_SUBJECT'
,p_display_order=>125
,p_column_identifier=>'T'
,p_column_label=>'Email Subject'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30643122722422755)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>135
,p_column_identifier=>'Q'
,p_column_label=>'Created By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30643222015422755)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>145
,p_column_identifier=>'R'
,p_column_label=>'Created'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3801378576307211)
,p_db_column_name=>'DOWNLOAD_FORMAT'
,p_display_order=>155
,p_column_identifier=>'U'
,p_column_label=>'Format'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3801481928307212)
,p_db_column_name=>'STRIP_RICH_TEXT'
,p_display_order=>165
,p_column_identifier=>'V'
,p_column_label=>'Strip Rich Text'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3801547111307213)
,p_db_column_name=>'DATA_ONLY'
,p_display_order=>175
,p_column_identifier=>'W'
,p_column_label=>'Data Only'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3801678518307214)
,p_db_column_name=>'PDF_PAGE_SIZE'
,p_display_order=>185
,p_column_identifier=>'X'
,p_column_label=>'Pdf Page Size'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3801716487307215)
,p_db_column_name=>'PDF_PAGE_ORIENTATION'
,p_display_order=>195
,p_column_identifier=>'Y'
,p_column_label=>'Pdf Page Orientation'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3801860859307216)
,p_db_column_name=>'PDF_ACCESSIBLE'
,p_display_order=>205
,p_column_identifier=>'Z'
,p_column_label=>'Pdf Accessible'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4162648286589921)
,p_db_column_name=>'SKIP_NO_DATA_FOUND'
,p_display_order=>215
,p_column_identifier=>'AA'
,p_column_label=>'Skip if No Data Found'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(30640330395365872)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'306404'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'ID:NPAGE_ID:REGION_NAME:SESSION_ID:APPLICATION_USER:NOTIFY_INTERVAL:EMAIL_ADDRESS:EMAIL_SUBJECT:CREATED_ON:CREATED_BY:STATUS:DOWNLOAD_FORMAT:'
,p_sort_column_1=>'NPAGE_ID'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'REGION_NAME'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30638505571365853)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(30639114984365858)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:39:&SESSION.::&DEBUG.:RP,RIR::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30638732721365856)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(30639114984365858)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Delete Checked'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'from wwv_flow_worksheet_notify n, wwv_flow_worksheets w',
'where n.worksheet_id = w.id',
'and w.flow_id = :fb_flow_id',
'and n.security_group_id = :flow_security_group_id'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30643806733439663)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(30639114984365858)
,p_button_name=>'DELETE_ALL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete All'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'from wwv_flow_worksheet_notify n, wwv_flow_worksheets w',
'where n.worksheet_id = w.id',
'and w.flow_id = :fb_flow_id',
'and n.security_group_id = :flow_security_group_id'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(30641511796365894)
,p_branch_action=>'f?p=&APP_ID.:39:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(30641102324365888)
,p_validation_name=>'must select subscription to delete'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow.g_f01.count = 0 then',
'  return false;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Subscription must be selected to delete.'
,p_when_button_pressed=>wwv_flow_imp.id(30638732721365856)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1199173149398878407)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(30639114984365858)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1199173284957878408)
,p_event_id=>wwv_flow_imp.id(1199173149398878407)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(30641204591365889)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete checked'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count',
'loop',
'    for l_ir_sub in (',
'        select n.id',
'          from wwv_flow_worksheet_notify n, wwv_flow_worksheets w',
'         where n.worksheet_id = w.id',
'           and w.flow_id = :FB_FLOW_ID',
'           and n.security_group_id = :WORKSPACE_ID',
'           and n.id = wwv_flow.g_f01(i) )           ',
'    loop',
'        wwv_flow_ir.builder_delete_subscription (',
'            p_workspace_id     => :WORKSPACE_ID,',
'            p_subscription_id  => l_ir_sub.id );',
'    end loop;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to delete subscriptions.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(30638732721365856)
,p_process_success_message=>'The subscription(s) deleted.'
,p_internal_uid=>30641204591365889
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(30671321102789866)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete all'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_ir_sub in (',
'    select n.id',
'      from wwv_flow_worksheet_notify n, wwv_flow_worksheets w',
'     where n.worksheet_id = w.id',
'       and w.flow_id = :FB_FLOW_ID',
'       and n.security_group_id = :WORKSPACE_ID )           ',
'loop',
'    wwv_flow_ir.builder_delete_subscription (',
'        p_workspace_id     => :WORKSPACE_ID,',
'        p_subscription_id  => l_ir_sub.id );',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to delete subscriptions.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(30643806733439663)
,p_process_success_message=>'All subscriptions for the current application deleted.'
,p_internal_uid=>30671321102789866
);
end;
/
prompt --application/pages/page_00040
begin
wwv_flow_imp_page.create_page(
 p_id=>40
,p_name=>'Static Application Files'
,p_alias=>'STATIC-APPLICATION-FILES'
,p_step_title=>'Static Application Files'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215592520464926917)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_file_upload.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2411740784988433)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(3004906169504692)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P40_FILE_STORAGE'
,p_plug_display_when_cond2=>'OBJECT_STORE'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(48117108751266087)
,p_plug_name=>'Static Application Files'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.checkbox(',
'           p_idx => 1,',
'           p_value => wwv_flow_escape.html( id ),',
'           p_attributes => wwv_flow_plugin_util.get_html_attr(',
'                               p_name  => ''aria-label'',',
'                               p_value => wwv_flow_lang.runtime_message( ''SELECT_ROW'' ) ) ) cb,',
'       id,',
'       security_group_id,',
'       null as icon,',
'       file_name,',
'       mime_type,',
'       htmldb_util.filesize_mask(sys.dbms_lob.getLength(file_content)) as file_size,',
'       round( sys.dbms_lob.getLength(file_content) / 1024 / 1024, 2 )  as file_size_in_mb,',
'       file_charset,',
'       sys.dbms_lob.getLength(file_content) as file_content,',
'       wwv_flow_file_editor_dev.get_file_reference (',
'            p_scope     => ''APP'',',
'            p_app_id    => :FB_FLOW_ID,',
'            p_file_name => file_name ) as reference,',
'       case when file_ext in (''html'', ''js'', ''css'', ''json'', ''xml'') then ''icon-file-'' || file_ext',
'            when lower(mime_type) like ''image/%'' then ''icon-ws-image''',
'            else ''icon-sc-file''',
'       end as icon_class,',
'       case when file_ext in (''html'', ''js'', ''css'', ''json'', ''xml'') then upper( file_ext )',
'            when lower(mime_type) like ''image/%'' then wwv_flow_lang.runtime_message( ''APEXDEV.ICON_LABEL.IMAGE_FILE'' )',
'            else wwv_flow_lang.runtime_message( ''APEXDEV.ICON_LABEL.OTHER_FILE'' )',
'       end as icon_class_label,',
'       wwv_flow_page_api.get_url(',
'           p_page        => 118,',
'           p_clear_cache => 118,',
'           p_items       => ''P118_ID,P118_SCOPE,P118_APP_ID'',',
'           p_values      => id || '',APP,'' || flow_id',
'        ) as edit_link,',
'       last_updated_on          as updated,',
'       lower(last_updated_by)   as updated_by,',
'       created_on               as created,',
'       lower(created_by)        as created_by',
'  from ( select f.*, wwv_flow_string_util.get_file_extension(f.file_name) as file_ext from wwv_flow_static_files f)',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(48117227188266087)
,p_name=>'Files'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No Static Application Files found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#EDIT_LINK#" class="a-IRR-icon">',
'    <span class="a-Icon #ICON_CLASS#"></span>',
'    <span class="a-IRR-iconName">#FILE_NAME#</span>',
'</a>'))
,p_icon_view_columns_per_row=>5
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(48117426988266089)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3566931599979611)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>11
,p_column_identifier=>'Z'
,p_column_label=>'Security Group Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4904498771807742)
,p_db_column_name=>'CB'
,p_display_order=>21
,p_column_identifier=>'AA'
,p_column_label=>'&nbsp;'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(21698888312753940)
,p_db_column_name=>'ICON'
,p_display_order=>31
,p_column_identifier=>'Y'
,p_column_label=>'Type'
,p_column_html_expression=>'<span class="a-Icon #ICON_CLASS#" role="img" aria-label="#ICON_CLASS_LABEL#"></span>'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(26449719289558522)
,p_db_column_name=>'FILE_NAME'
,p_display_order=>41
,p_column_identifier=>'D'
,p_column_label=>'Name'
,p_column_link=>'#EDIT_LINK#'
,p_column_linktext=>'#FILE_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(48117621656266090)
,p_db_column_name=>'MIME_TYPE'
,p_display_order=>51
,p_column_identifier=>'C'
,p_column_label=>'Mime Type'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(26449825965558526)
,p_db_column_name=>'FILE_SIZE'
,p_display_order=>61
,p_column_identifier=>'E'
,p_column_label=>'Size'
,p_column_type=>'STRING'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30211109671089156)
,p_db_column_name=>'FILE_CHARSET'
,p_display_order=>71
,p_column_identifier=>'J'
,p_column_label=>'File Charset'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(144796827445692396)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(26449918105558526)
,p_db_column_name=>'FILE_CONTENT'
,p_display_order=>81
,p_column_identifier=>'F'
,p_column_label=>'File'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_column_type=>'NUMBER'
,p_column_alignment=>'CENTER'
,p_format_mask=>'DOWNLOAD:WWV_FLOW_STATIC_FILES:FILE_CONTENT:ID:SECURITY_GROUP_ID:MIME_TYPE:FILE_NAME::FILE_CHARSET:attachment:&APP_TEXT$DOWNLOAD.:'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(261792125788022050)
,p_db_column_name=>'REFERENCE'
,p_display_order=>91
,p_column_identifier=>'K'
,p_column_label=>'Reference'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(656775043555444485)
,p_db_column_name=>'ICON_CLASS'
,p_display_order=>101
,p_column_identifier=>'L'
,p_column_label=>'Icon Class'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1474903055476103)
,p_db_column_name=>'ICON_CLASS_LABEL'
,p_display_order=>106
,p_column_identifier=>'AB'
,p_column_label=>'Icon Class Label'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(361062077292469305)
,p_db_column_name=>'FILE_SIZE_IN_MB'
,p_display_order=>111
,p_column_identifier=>'N'
,p_column_label=>'File Size in MB'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4502499052515822)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>121
,p_column_identifier=>'O'
,p_column_label=>'Edit Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(21696862494753920)
,p_db_column_name=>'UPDATED'
,p_display_order=>131
,p_column_identifier=>'U'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(21696962494753921)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>141
,p_column_identifier=>'V'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(21697046647753922)
,p_db_column_name=>'CREATED'
,p_display_order=>151
,p_column_identifier=>'W'
,p_column_label=>'Created'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(21697167987753923)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>161
,p_column_identifier=>'X'
,p_column_label=>'Created By'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(48118623144274016)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_type=>'REPORT'
,p_report_alias=>'1298403106536645'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_view_mode=>'REPORT'
,p_report_columns=>'CB:ICON:FILE_NAME:MIME_TYPE:FILE_SIZE:REFERENCE:FILE_CONTENT:UPDATED:UPDATED_BY::ICON_CLASS_LABEL'
,p_sort_column_1=>'FILE_NAME'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'0'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(61358313623209746)
,p_plug_name=>'About'
,p_region_css_classes=>'margin-bottom-none'
,p_region_template_options=>'#DEFAULT#:a-Region--sideRegion:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Static application files are only available to the current application. Use <code><strong>&#35;APP_FILES#</strong></code> in your application to reference a file.</p>',
'',
'<p>Use this page to create, edit, and delete static files.</p>',
'',
'<p>Static application files can be stored locally in the database (default), or can be stored in Oracle Cloud Object Storage.',
'',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_plug_query_num_rows=>1500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'L:L:R'
,p_plug_query_break_cols=>'1'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(292978984629744903)
,p_plug_name=>'Application File Storage'
,p_region_css_classes=>'a-Alert--noTitle a-Alert--noUI margin-bottom-none'
,p_icon_css_classes=>'icon-tree-web-service'
,p_region_template_options=>'a-Alert--info:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'This application uses <strong>Oracle Cloud Object Storage</strong>.'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P40_FILE_STORAGE'
,p_plug_display_when_cond2=>'OBJECT_STORE'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(188934631091807160)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(48117108751266087)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:40:&SESSION.::&DEBUG.:40,RIR::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4904572338807743)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(48117108751266087)
,p_button_name=>'DELETE_CHECKED'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete Checked'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_static_files',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(29769008715122829)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(48117108751266087)
,p_button_name=>'DELETE_ALL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete All'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_static_files',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30092611793871223)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(48117108751266087)
,p_button_name=>'DOWNLOAD_ZIP'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Download as Zip'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_static_files',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(61586311331473472)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(48117108751266087)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create File'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:118:&SESSION.::&DEBUG.:118:P118_SCOPE,P118_APP_ID:APP,&FB_FLOW_ID.'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(29786806302194308)
,p_branch_name=>'Reset Pagination after delete all'
,p_branch_action=>'f?p=&APP_ID.:40:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(29769008715122829)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8400280520370301)
,p_name=>'P40_FILE_STORAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(48117108751266087)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(8400997784370308)
,p_computation_sequence=>10
,p_computation_item=>'P40_FILE_STORAGE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_object_store.get_file_storage ( p_app_id => :FB_FLOW_ID )'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4904668099807744)
,p_name=>'Delete Checked'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(4904572338807743)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4904708140807745)
,p_event_id=>wwv_flow_imp.id(4904668099807744)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'Do you really want to delete all checked files?'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4904833481807746)
,p_event_id=>wwv_flow_imp.id(4904668099807744)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'DELETE_CHECKED'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(29769822483145737)
,p_name=>'Delete All'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(29769008715122829)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(29770105437145744)
,p_event_id=>wwv_flow_imp.id(29769822483145737)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'Do you really want to delete all files?'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(29770331344152238)
,p_event_id=>wwv_flow_imp.id(29769822483145737)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'DELETE_ALL'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2004894804668745)
,p_name=>'show hide local files'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P40_SHOW_LOCAL'
,p_condition_element=>'P40_SHOW_LOCAL'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_cond=>'P40_FILE_STORAGE'
,p_display_when_cond2=>'OBJECT_STORE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2004978624668746)
,p_event_id=>wwv_flow_imp.id(2004894804668745)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(48117108751266087)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2005024774668747)
,p_event_id=>wwv_flow_imp.id(2004894804668745)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(48117108751266087)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4904919441807747)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Checked'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'   for i in 1 .. wwv_flow.g_f01.count loop',
'      wwv_flow_file_editor_dev.delete_file (',
'          p_id     => wwv_flow.g_f01(i),',
'          p_scope  => ''APP'',',
'          p_app_id => :FB_FLOW_ID );',
'    end loop;',
'',
'    if :P40_FILE_STORAGE = ''OBJECT_STORE'' ',
'       and wwv_flow_collection.collection_exists (p_collection_name => ''F4000_OB_FILES'' ) then',
'           wwv_flow_collection.delete_collection (p_collection_name => ''F4000_OB_FILES'' );',
'   end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'#SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(4904572338807743)
,p_process_success_message=>'Files deleted'
,p_internal_uid=>4904919441807747
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(29770407854160432)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete All'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if :P40_FILE_STORAGE = ''OBJECT_STORE'' then',
'        for c1 in (select file_name',
'                     from wwv_flow_static_files',
'                    where flow_id           = :FB_FLOW_ID',
'                      and security_group_id = :WORKSPACE_ID ) loop',
'            begin',
'                wwv_flow_object_store.delete_file (',
'                    p_app_id => :FB_FLOW_ID,',
'                    p_path   => c1.file_name );',
'            exception when others then --In case files out of sync, don''t stop deletes',
'                null;',
'            end;',
'        end loop;',
'        if wwv_flow_collection.collection_exists (p_collection_name => ''F4000_OB_FILES'' ) then',
'            wwv_flow_collection.delete_collection (p_collection_name => ''F4000_OB_FILES'' );',
'        end if;',
' ',
'    end if;',
'',
'    delete wwv_flow_static_files',
'     where flow_id           = :FB_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID;',
'  ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(29769008715122829)
,p_process_success_message=>'Files deleted'
,p_internal_uid=>29770407854160432
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(30816415335489937)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_DOWNLOAD'
,p_process_name=>'Download as Zip'
,p_attribute_01=>'Y'
,p_attribute_02=>'f&FB_FLOW_ID._static_application_files.zip'
,p_attribute_04=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select file_content,',
'       file_name',
'  from wwv_flow_static_files',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
' order by file_name'))
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(30092611793871223)
,p_internal_uid=>30816415335489937
);
end;
/
prompt --application/pages/page_00041
begin
wwv_flow_imp_page.create_page(
 p_id=>41
,p_name=>'Shortcut History'
,p_alias=>'SHORTCUT-HISTORY'
,p_step_title=>'Shortcut History'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213468022923563047)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_cut.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(10984427931377806)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(186543329326722942)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Shortcuts'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(178477724913086626)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>This page displays recent modifications made to Shortcuts in this application.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193356305758465047)
,p_plug_name=>'Shortcut History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_SHORTCUTS'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(193356508497465048)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193356611761465069)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193356707913465070)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Audit Comment'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193356827768465070)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Component Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193356901768465071)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193357024322465072)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Component Key'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193357115008465073)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Audit Date'
,p_column_type=>'DATE'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193357206527465073)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(193357327917465074)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1298503159536645'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'AUDIT_DATE:ACTION:DEVELOPER:COMPONENT_NAME'
,p_sort_column_1=>'AUDIT_DATE'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(188991707548026498)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(193356305758465047)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:41:&SESSION.::&DEBUG.:41,RIR::'
);
end;
/
prompt --application/pages/page_00042
begin
wwv_flow_imp_page.create_page(
 p_id=>42
,p_name=>'Application Process History'
,p_alias=>'APPLICATION-PROCESS-HISTORY'
,p_step_title=>'Application Process History'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(91429205691059841)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_proc.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11001418768488718)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(4020210037479119)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Application Process History'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47815719987196218)
,p_plug_name=>'Application Process History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_PROCESSING'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(47815815177196218)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47816828160196312)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47816905432196313)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Audit Comment'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47817202270196314)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Component Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47818224862205729)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47818503056205738)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Component Key'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47819724479239691)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192778227550777174)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Audit Date'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(47817731311198150)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1298632649536645'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'AUDIT_DATE:ACTION:DEVELOPER:COMPONENT_NAME'
,p_sort_column_1=>'AUDIT_DATE'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(179880415861754655)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>This page displays recent modifications made to Application Processes in this application.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(188877925572856627)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47815719987196218)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:42:&SESSION.::&DEBUG.:42,RIR::'
);
end;
/
prompt --application/pages/page_00043
begin
wwv_flow_imp_page.create_page(
 p_id=>43
,p_name=>'Computation History'
,p_alias=>'COMPUTATION-HISTORY'
,p_step_title=>'Application Computation History'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(91429205691059841)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_comp.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47829819105563603)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(47827519966525945)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Application Computation History'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(179882503309769998)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>This page displays recent modifications made to Application Computations in this application.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(192578206532753093)
,p_plug_name=>'Application Computation History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_COMPUTATIONS'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(192578428447753104)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192578723511753110)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192578811721753111)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Audit Comment'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192579014963753112)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Component Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192579105294753113)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192579329210753115)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Component Key'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192579404931753115)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Audit Date'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192579528837753116)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(192579605029753117)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1298729484536645'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'AUDIT_DATE:ACTION:DEVELOPER:COMPONENT_NAME'
,p_sort_column_1=>'AUDIT_DATE'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(188922818634179166)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(192578206532753093)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:43:&SESSION.::&DEBUG.:43,RIR::'
);
end;
/
prompt --application/pages/page_00044
begin
wwv_flow_imp_page.create_page(
 p_id=>44
,p_name=>'List History'
,p_alias=>'LIST-HISTORY'
,p_step_title=>'List History'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213210808239773454)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_list.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11023119264649745)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(62973516530710918)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Lists'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(180934307196721365)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>This page displays recent modifications made to Lists and List Entries in this application.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(192971527924071247)
,p_plug_name=>'List History'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  l.a object_type,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u,',
'  (select wwv_flow_lang.system_message(''F4000.LIST_INITCAP'') a from dual) l',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_LISTS''',
'union',
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  l.a object_type,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u,',
'  (select wwv_flow_lang.system_message(''F4000.LIST_ITEM'') a from dual) l',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_LIST_ITEMS'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(192971700145071263)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192971826504071267)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192971911263071268)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Audit Comment'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192972101092071270)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Component Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192972208850071271)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192972322792071271)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Component Key'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192972420788071272)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Audit Date'
,p_column_type=>'DATE'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192972532494071273)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193005932603110435)
,p_db_column_name=>'OBJECT_TYPE'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Object Type'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(192972607003071274)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1298822209536645'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'AUDIT_DATE:ACTION:DEVELOPER:OBJECT_TYPE:COMPONENT_NAME'
,p_sort_column_1=>'AUDIT_DATE'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(188941126299909859)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(192971527924071247)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:44:&SESSION.::&DEBUG.:44,RIR::'
);
end;
/
prompt --application/pages/page_00045
begin
wwv_flow_imp_page.create_page(
 p_id=>45
,p_name=>'Tree History'
,p_alias=>'TREE-HISTORY'
,p_step_title=>'Tree History'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213443923391496926)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tree.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11039813470704815)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(4884503079390537)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11041908060712694)
,p_plug_name=>'Tree History'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>This page displays recent modifications made to Trees in this application.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193078029767279936)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P45a */',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_TREES'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(193078208814279939)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193078331675279940)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193078411006279941)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Audit Comment'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193078530574279941)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Component Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193078630819279942)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193078720050279943)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Component Key'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193078820471279944)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Audit Date'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193078921328279944)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(193079026950279945)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1298926383536646'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'AUDIT_DATE:ACTION:DEVELOPER:COMPONENT_NAME'
,p_sort_column_1=>'AUDIT_DATE'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(188983902334873681)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(193078029767279936)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:45:&SESSION.::&DEBUG.:45,RIR::'
);
end;
/
prompt --application/pages/page_00046
begin
wwv_flow_imp_page.create_page(
 p_id=>46
,p_name=>'Remove Unused Templates'
,p_alias=>'REMOVE-UNUSED-TEMPLATES'
,p_page_mode=>'MODAL'
,p_step_title=>'Remove Unused Templates'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_dialog_height=>'500'
,p_dialog_width=>'640'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'No help is available for this page.'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(932808077499193724)
,p_plug_name=>'Buttons'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1599002002482970065)
,p_plug_name=>'Confirm Template Removal'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Please select theme from which you would like to remove any unused templates. A template is considered to be in use when it is either directly referenced by a component, used as one of the theme default templates, or subscribed to from another tem'
||'plate. Please note that if the theme itself is subscribed to a theme in another application or the theme master, then a theme refresh will restore all templates defined in the master theme. </p>'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(932808381486193727)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(932808077499193724)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(932808101375193725)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(932808077499193724)
,p_button_name=>'REMOVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Remove Templates'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(932808739506193731)
,p_branch_action=>'f?p=&APP_ID.:47:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(932807937166193723)
,p_name=>'P46_THEME_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1599002002482970065)
,p_prompt=>'Theme'
,p_source=>'P4656_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(932808473536193728)
,p_name=>'Close'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(932808381486193727)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(932808515389193729)
,p_event_id=>wwv_flow_imp.id(932808473536193728)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(932808617803193730)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Remove Templates'
,p_process_sql_clob=>'wwv_flow_templates_util.remove_ununsed_templates (:FB_FLOW_ID, :P46_THEME_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error removing templates'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>932808617803193730
);
end;
/
prompt --application/pages/page_00047
begin
wwv_flow_imp_page.create_page(
 p_id=>47
,p_name=>'Remove Unused Templates'
,p_alias=>'REMOVE-UNUSED-TEMPLATES1'
,p_page_mode=>'MODAL'
,p_step_title=>'Remove Unused Templates'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_dialog_height=>'500'
,p_dialog_width=>'640'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'No help is available for this page.'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(932809341058193737)
,p_name=>'Template Removal Summary'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'a-Region--paddedBody'
,p_new_grid_column=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  c003 template_type,',
'  n001 delete_count',
'from wwv_flow_collections where collection_name = ''TEMPLATE_CLEANUP'''))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(1041646592238406593)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'0'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(932809600949193740)
,p_query_column_id=>1
,p_column_alias=>'TEMPLATE_TYPE'
,p_column_display_sequence=>1
,p_column_heading=>'Template Type'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(282026017647000169)
,p_lov_show_nulls=>'NO'
,p_derived_column=>'N'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(932809787496193741)
,p_query_column_id=>2
,p_column_alias=>'DELETE_COUNT'
,p_column_display_sequence=>2
,p_column_heading=>'Deleted Templates'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1599146158139213535)
,p_plug_name=>'Buttons'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1599146563176213536)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1599146158139213535)
,p_button_name=>'CLOSE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Close'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(932809290061193736)
,p_branch_action=>'f?p=&APP_ID.:4656:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(1599146563176213536)
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_00048
begin
wwv_flow_imp_page.create_page(
 p_id=>48
,p_name=>'Replace'
,p_alias=>'REPLACE'
,p_step_title=>'Replace'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213300727323081712)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_install.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(24121815754638425)
,p_plug_name=>'Confirm Replace Attribute Dictionary'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>165
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>You have requested that the existing UI Defaults Attribute Dictionary in this workspace be updated by the UI Defaults Attribute Dictionary to be installed. If matching attributes are found, they will be updated. Please confirm this request.</p>',
'',
'<p>Before replacing them, consider exporting the UI Defaults as a backup.</p>'))
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'UI_DEFAULTS_AD'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30513005339674214)
,p_plug_name=>'Confirm Replace Plug-in'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>150
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>You have requested that the existing plug-in <strong>&P4450_DISPLAY_NAME. (&P4450_NAME.)</strong> in',
'application <strong>&P4450_NEW_FLOW_ID.</strong> be replaced by the plug-in to be installed. Please confirm',
'this request.</p>'))
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'PLUGIN'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(75651209346653682)
,p_plug_name=>'Confirm Replace Application'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>100
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>You have requested that the existing application <strong>&P49_NEW_FLOW_ID. - &P48_APPLICATION_NAME.</strong> be removed and',
'replaced by the application to be installed: <strong>&P49_IMP_FLOW_ID. - &P48_IMP_APP_NAME.</strong>. Please confirm this request.</p>',
'',
'<p>Before replacing an application, consider creating a backup.</p>'))
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'FLOW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1801750038575307)
,p_plug_name=>'Background Processing'
,p_parent_plug_id=>wwv_flow_imp.id(75651209346653682)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(29434107863295859)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The application to be replaced has page processes with background executions enabled. &P48_BG_EXECS_COUNT_TEXT!RAW.</p>',
'<p>Use the <strong>Replace Application</strong> button to install the imported application now. Running background executions will be terminated; waiting ones will be deleted.</p>'))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P48_HAS_BG_PROCESSES = ''Y'' and :P48_MAX_SCHEDULER_JOBS = 0'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2016877444377439)
,p_plug_name=>'Background Processing'
,p_parent_plug_id=>wwv_flow_imp.id(75651209346653682)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(29434107863295859)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The application to be replaced has page processes with background executions enabled. &P48_BG_EXECS_COUNT_TEXT!RAW.</p>',
'<ul>',
'    <li>Use the <strong>Disable Background Execution</strong> button to <em>prevent new executions to be kicked off</em> (by setting the <strong>Maximum Scheduler Jobs</strong> attribute to zero) and to return to this page.</li>',
'    <li>Use the <strong>Replace Application</strong> button to install the imported application now. Running background executions will be terminated; waiting ones will be deleted.</li>',
'</ul>'))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P48_HAS_BG_PROCESSES = ''Y'' and nvl( :P48_MAX_SCHEDULER_JOBS, 1 ) != 0'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(78171812934226554)
,p_plug_name=>'Confirm Replace Page'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>130
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>You have requested that the existing page &P67_IMP_PAGE_ID. in application <strong>&FB_FLOW_ID.</strong> be',
'removed and replaced by the page to be installed. Please confirm this request.</p>',
'',
'<p>Before replacing the page, consider creating a backup. You can create a backup of the entire application or',
'just selected pages.</p>'))
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'PAGE'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(141828919165478596)
,p_plug_name=>'Confirm Refresh Theme'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>140
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>You have requested to refresh the existing theme &P253_ORIGINAL_THEME_ID. in application &P253_NEW_FLOW_ID. with the theme to be imported.  ',
'Please confirm this request.</p>',
'',
'<p>Before refreshing the theme, consider exporting the application as a backup.</p>'))
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'THEME'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(160743029989473652)
,p_plug_name=>'Confirm Replace Table Dictionary'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>160
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>You have requested that the existing UI Defaults Table Dictionary in the workspace schema <strong>&P321_SCHEMA_NAME.</strong> be removed and replaced by the UI Defaults Table Dictionary to be installed. Please confirm this request.</p>',
'',
'<p>Before replacing them, consider exporting the UI Defaults as a backup.</p>'))
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'UI_DEFAULTS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(210947513275299904)
,p_plug_name=>'Replace Components'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>180
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>You have requested that one or more existing application components be replaced by',
'components defined in the export file. Please confirm this request.</p>',
'',
'<p>Before replacing application components, consider creating a backup.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST = ''COMP''',
'and nvl(:P48_EMPTY_MANIFEST, ''N'') = ''N'''))
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(211587310604227425)
,p_plug_name=>'Empty Manifest'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>170
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The component export file contains no components to be imported or the manifest',
'section of the export file is corrupt.</p>'))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST = ''COMP''',
'and :P48_EMPTY_MANIFEST = ''Y'''))
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(230829210468863513)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42027416946637016)
,p_plug_display_sequence=>190
,p_list_id=>wwv_flow_imp.id(38836703962860678)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NEVER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(388072302664289607)
,p_plug_name=>'Wizard buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>200
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(78193700691289249)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(388072302664289607)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_condition=>'FLOW'
,p_button_condition_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(78199718006294230)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(388072302664289607)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_condition=>'PAGE'
,p_button_condition_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(211588622856240436)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(388072302664289607)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST = ''COMP''',
'and :P48_EMPTY_MANIFEST = ''Y'''))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(210935320239904510)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(388072302664289607)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST = ''COMP''',
'and nvl(:P48_EMPTY_MANIFEST, ''N'') = ''N'''))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(24122010325638427)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(388072302664289607)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_condition=>'UI_DEFAULTS_AD'
,p_button_condition_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(160745415837497944)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(388072302664289607)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_condition=>'UI_DEFAULTS'
,p_button_condition_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30525330413766555)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(388072302664289607)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_condition=>'PLUGIN'
,p_button_condition_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(141839519558507069)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_imp.id(388072302664289607)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_condition=>'THEME'
,p_button_condition_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2016552207377436)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(388072302664289607)
,p_button_name=>'DISABLE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Disable Background Execution'
,p_button_position=>'CREATE'
,p_button_condition=>':P48_HAS_BG_PROCESSES = ''Y'' and nvl( :P48_MAX_SCHEDULER_JOBS, 1 ) != 0'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(78203024586296152)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(388072302664289607)
,p_button_name=>'CONFIRM'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Replace Application'
,p_button_position=>'CREATE'
,p_button_condition=>'FLOW'
,p_button_condition_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(75653600324653710)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(388072302664289607)
,p_button_name=>'CONFIRM'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Replace Page'
,p_button_position=>'CREATE'
,p_button_condition=>'PAGE'
,p_button_condition_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(211633819027788173)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(388072302664289607)
,p_button_name=>'CONFIRM'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Replace Application Components'
,p_button_position=>'CREATE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST = ''COMP''',
'and nvl(:P48_EMPTY_MANIFEST, ''N'') = ''N'''))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(24122200558638428)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(388072302664289607)
,p_button_name=>'CONFIRM'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Update Attribute Dictionary'
,p_button_position=>'CREATE'
,p_button_condition=>'UI_DEFAULTS_AD'
,p_button_condition_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(160746128304501541)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(388072302664289607)
,p_button_name=>'CONFIRM'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Replace Table Dictionary'
,p_button_position=>'CREATE'
,p_button_condition=>'UI_DEFAULTS'
,p_button_condition_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30525613922771212)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(388072302664289607)
,p_button_name=>'CONFIRM'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Replace Existing Plug-in'
,p_button_position=>'CREATE'
,p_button_condition=>'PLUGIN'
,p_button_condition_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(141840225099508626)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_imp.id(388072302664289607)
,p_button_name=>'CONFIRM'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Refresh Existing Theme'
,p_button_position=>'CREATE'
,p_button_condition=>'THEME'
,p_button_condition_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2227665211592314)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_imp.id(388072302664289607)
,p_button_name=>'Previous'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:598:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1801677912575306)
,p_branch_name=>'Go To Page 48'
,p_branch_action=>'f?p=&APP_ID.:48:&SESSION.:FLOW:&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2016552207377436)
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':P48_TYPE = ''FLOW'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(75703306759082671)
,p_branch_name=>'Go To Page 49'
,p_branch_action=>'f?p=&APP_ID.:49:&SESSION.:BRANCH_TO_PAGE_ACCEPT|REPLACE:&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(78203024586296152)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P48_TYPE'
,p_branch_condition_text=>'FLOW'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(78315807392574990)
,p_branch_name=>'Go To Page 67'
,p_branch_action=>'f?p=&APP_ID.:67:&SESSION.:BRANCH_TO_PAGE_ACCEPT|REPLACE:&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(78203024586296152)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P48_TYPE'
,p_branch_condition_text=>'PAGE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(141845904367531076)
,p_branch_name=>'Go To Page 253'
,p_branch_action=>'f?p=&APP_ID.:253:&SESSION.:BRANCH_TO_PAGE_ACCEPT|REPLACE:&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(141840225099508626)
,p_branch_sequence=>40
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P48_TYPE'
,p_branch_condition_text=>'THEME'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(160742420985471083)
,p_branch_name=>'Go To Page 321'
,p_branch_action=>'f?p=&APP_ID.:321:&SESSION.:BRANCH_TO_PAGE_ACCEPT|REPLACE:&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(160746128304501541)
,p_branch_sequence=>50
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P48_TYPE'
,p_branch_condition_text=>'UI_DEFAULTS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(24123626451688831)
,p_branch_name=>'Go To Page 321'
,p_branch_action=>'f?p=&APP_ID.:321:&SESSION.:BRANCH_TO_PAGE_ACCEPT|REPLACE:&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(24122200558638428)
,p_branch_sequence=>60
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P48_TYPE'
,p_branch_condition_text=>'UI_DEFAULTS_AD'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(210937707819929333)
,p_branch_action=>'f?p=&APP_ID.:598:&SESSION.:BRANCH_TO_PAGE_ACCEPT|REPLACE:&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(78203024586296152)
,p_branch_sequence=>70
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P48_TYPE'
,p_branch_condition_text=>'COMP'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(211589225411250663)
,p_branch_action=>'f?p=&APP_ID.:598:&SESSION.:BRANCH_TO_PAGE_ACCEPT|REPLACE:&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(78203024586296152)
,p_branch_sequence=>80
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P48_TYPE'
,p_branch_condition_text=>'COMP'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(30513621316707212)
,p_branch_action=>'f?p=&APP_ID.:4450:&SESSION.:BRANCH_TO_PAGE_ACCEPT|REPLACE:&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(30525613922771212)
,p_branch_sequence=>90
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P48_TYPE'
,p_branch_condition_text=>'PLUGIN'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(78318221722588609)
,p_branch_action=>'f?p=&APP_ID.:49:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(78193700691289249)
,p_branch_sequence=>80
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P48_TYPE'
,p_branch_condition_text=>'FLOW'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(78320209732594647)
,p_branch_action=>'f?p=&APP_ID.:1500:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(78193700691289249)
,p_branch_sequence=>90
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P48_TYPE'
,p_branch_condition_text=>'PAGE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(141843830425519626)
,p_branch_action=>'f?p=&FLOW_ID.:253:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(141839519558507069)
,p_branch_sequence=>100
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P48_TYPE'
,p_branch_condition_text=>'THEME'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(160747431552511958)
,p_branch_action=>'f?p=&FLOW_ID.:321:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(160745415837497944)
,p_branch_sequence=>110
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P48_TYPE'
,p_branch_condition_text=>'UI_DEFAULTS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(24123202210681894)
,p_branch_action=>'f?p=&APP_ID.:321:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(24122010325638427)
,p_branch_sequence=>115
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P48_TYPE'
,p_branch_condition_text=>'UI_DEFAULTS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(210936923618924476)
,p_branch_action=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(78193700691289249)
,p_branch_sequence=>120
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P48_TYPE'
,p_branch_condition_text=>'COMP'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(211589531298252361)
,p_branch_action=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(141839519558507069)
,p_branch_sequence=>130
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P48_TYPE'
,p_branch_condition_text=>'COMP'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(30513322570698023)
,p_branch_action=>'f?p=&APP_ID.:4450:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(30525330413766555)
,p_branch_sequence=>140
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P48_TYPE'
,p_branch_condition_text=>'PLUGIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1801363384575303)
,p_name=>'P48_BG_EXECS_COUNT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(75651209346653682)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2016667174377437)
,p_name=>'P48_HAS_BG_PROCESSES'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(75651209346653682)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2016974469377440)
,p_name=>'P48_MAX_SCHEDULER_JOBS'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(75651209346653682)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2017174097377442)
,p_name=>'P48_BG_EXECS_COUNT_TEXT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(75651209346653682)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(78173624015229740)
,p_name=>'P48_TYPE'
,p_item_sequence=>10
,p_item_display_point=>'LEGACY_ORPHAN_COMPONENTS'
,p_use_cache_before_default=>'NO'
,p_source=>'v(''REQUEST'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(103586633047901307)
,p_name=>'P48_APPLICATION_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(75651209346653682)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(120780655919320601)
,p_name=>'P48_IMP_APP_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(75651209346653682)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(211569931803138974)
,p_name=>'P48_EMPTY_MANIFEST'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(210947513275299904)
,p_source=>'N'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(230865730039907082)
,p_name=>'P48_APPLICATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(210947513275299904)
,p_prompt=>'Application'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LIST FLOWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'where  build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'order by 2'))
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'The application in which the components will be replaced.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(230885900266974107)
,p_name=>'P48_APPLICATION2'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(78171812934226554)
,p_prompt=>'Application:'
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_help_text=>'This attribute identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2017202614377443)
,p_computation_sequence=>50
,p_computation_item=>'P48_BG_EXECS_COUNT_TEXT'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case :P48_BG_EXECS_COUNT',
'    when 0 then wwv_flow_lang.runtime_message( ''WWV_FLOW_PROCESS_BACKGROUND.EXECUTIONS_0'', to_char(localtimestamp, ''ts''))',
'    when 1 then wwv_flow_lang.runtime_message( ''WWV_FLOW_PROCESS_BACKGROUND.EXECUTIONS_1'', to_char(localtimestamp, ''ts''))',
'    else        wwv_flow_lang.runtime_message( ''WWV_FLOW_PROCESS_BACKGROUND.EXECUTIONS_N'', :P48_BG_EXECS_COUNT, to_char(localtimestamp, ''ts''))',
'end'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(211576409602179834)
,p_computation_sequence=>10
,p_computation_item=>'P48_EMPTY_MANIFEST'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_manifest clob;',
'    l_start    pls_integer;',
'    l_stop     pls_integer;',
'    l_line     varchar2(4000);',
'    l_loop     pls_integer := 1;',
'begin',
'    l_manifest := wwv_flow_imp_parser.get_component_manifest(:P49_FILE_ID);',
'    l_start    := 1;',
'',
'    while sys.dbms_lob.instr(l_manifest,''--'',l_start) > 0 and l_loop < 1000 loop',
'    	l_loop  := l_loop + 1;',
'    	l_start := sys.dbms_lob.instr(l_manifest,''--'',l_start);',
'    	l_stop  := sys.dbms_lob.instr(l_manifest,chr(10),l_start);',
'    	l_line  := sys.dbms_lob.substr(l_manifest,l_stop-l_start,l_start);',
'',
'    	return ''N'';',
'',
'    	l_start := sys.dbms_lob.instr(l_manifest,''--'',l_stop+1);',
'    end loop;',
'',
'    return ''Y'';',
'exception ',
'    when others then ',
'        null;',
'end;'))
,p_compute_when=>'COMP'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2017096400377441)
,p_computation_sequence=>20
,p_computation_item=>'P48_MAX_SCHEDULER_JOBS'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select max_scheduler_jobs',
'  from wwv_flows',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and id                = :P49_NEW_FLOW_ID'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1801497026575304)
,p_computation_sequence=>30
,p_computation_item=>'P48_BG_EXECS_COUNT'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*)',
'  from wwv_flow_process_bg_execs$',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :P49_NEW_FLOW_ID',
'   and status in ( ''SCHEDULED'', ''EXECUTING'' )'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2016736058377438)
,p_computation_sequence=>50
,p_computation_item=>'P48_HAS_BG_PROCESSES'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case when wwv_flow_process_bg.has_bg_processing( ',
'              p_application_id    => :P49_NEW_FLOW_ID,',
'              p_security_group_id => :FLOW_SECURITY_GROUP_ID ) then ''Y'' else ''N'' end',
'   '))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1801893756575308)
,p_name=>'Refresh Background Execs Count'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1801998457575309)
,p_event_id=>wwv_flow_imp.id(1801893756575308)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_name=>'Set Initial Timeout'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'window.setTimeout( function(){ apex.region("background-executions-count").refresh();}, 5000 );'
,p_server_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_server_condition_expr1=>'P48_HAS_BG_PROCESSES'
,p_server_condition_expr2=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1801590952575305)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Disable Background Processing'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'update wwv_flows',
'   set max_scheduler_jobs = 0',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and id                = :P49_NEW_FLOW_ID;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2016552207377436)
,p_process_when=>':P48_TYPE = ''FLOW'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>1801590952575305
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(103586858644901309)
,p_process_sequence=>10
,p_process_point=>'BEFORE_BOX_BODY'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Get Application Information'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'',
'    for c1 in (',
'        select name',
'        from wwv_flows',
'        where id = :P49_NEW_FLOW_ID',
'        and security_group_id = :flow_security_group_id',
'    ) loop',
'        :P48_APPLICATION_NAME := c1.name;',
'    end loop;',
'',
'    :P48_IMP_APP_NAME := wwv_flow_imp_parser.get_app_name(:P163_FILE_ID);',
'    ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>103586858644901309
);
end;
/
prompt --application/pages/page_00049
begin
wwv_flow_imp_page.create_page(
 p_id=>49
,p_name=>'Install Application'
,p_alias=>'INSTALL-APPLICATION'
,p_step_title=>'Install Application'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213300727323081712)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_install.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47632929379498967)
,p_plug_name=>'Install Application'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_imp_parser.is_company_export(:P49_FILE_ID) = false'
,p_plug_display_when_cond2=>'PLSQL'
,p_plug_header=>'<p class="u-tC">Review the installation details and select <strong>Install Application</strong> to install the imported application to your workspace.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(67281583250724009)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(37899301707472090)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(79479717773383002)
,p_plug_name=>'Invalid File'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--danger:a-Alert--horizontal'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>30
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'File is not a valid &PRODUCT_NAME. application export file.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_imp_parser.is_company_export(:P49_FILE_ID) = true'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(201406304504703645)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747137283199138151)
,p_plug_name=>'Install Application'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(47637304969529814)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(201406304504703645)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:1500:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(47638615358532853)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(201406304504703645)
,p_button_name=>'INSTALL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Install Application'
,p_button_position=>'CREATE'
,p_button_condition=>'wwv_flow_imp_parser.is_company_export(:P49_FILE_ID) = false'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(217551631815327396)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(201406304504703645)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:460:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(224688012029789109)
,p_branch_action=>'f?p=&APP_ID.:2117:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_IN_CONDITION'
,p_branch_condition=>'INSTALL:REPLACE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(37975103840576773)
,p_branch_name=>'Go To Page 2100'
,p_branch_action=>'f?p=&APP_ID.:2100:&SESSION.:APP_INSTALLED:&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(47638615358532853)
,p_branch_sequence=>20
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install_scripts   where security_group_id = :flow_security_group_id and flow_id = :fb_flow_id union all',
'select 1 from wwv_flow_install_objects   where security_group_id = :flow_security_group_id and flow_id = :fb_flow_id union all',
'select 1 from wwv_flow_install_checks    where security_group_id = :flow_security_group_id and flow_id = :fb_flow_id union all',
'select 1 from wwv_flow_install_build_opt where security_group_id = :flow_security_group_id and flow_id = :fb_flow_id'))
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(73118923864773968)
,p_branch_action=>'f?p=&FLOW_ID.:49:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(209198226551507783)
,p_branch_action=>'f?p=&APP_ID.:598:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_HEADER'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow_imp_parser.is_component_export (p_file_id => :p49_file_id)'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(78016223614075187)
,p_branch_action=>'67'
,p_branch_point=>'BEFORE_HEADER'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>60
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow_imp_parser.get_page_id (p_file_id => :p49_file_id) is not null'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(51448131973367122)
,p_branch_action=>'f?p=&APP_ID.:154:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(47638615358532853)
,p_branch_sequence=>70
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where id = :P49_NEW_FLOW_ID',
'   and (    security_group_id <> :P49_LOGGED_IN_COMPANY',
'         or build_status      =  ''RUN_ONLY'' )'))
,p_security_scheme=>wwv_flow_imp.id(12511519296310366)
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(73107224679708034)
,p_branch_name=>'Go To Page 48'
,p_branch_action=>'f?p=&FLOW_ID.:48:&SESSION.:FLOW:&DEBUG.:::'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(47638615358532853)
,p_branch_sequence=>80
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flows',
' where :P49_NEW_FLOW_OPT in (''REUSE'',''SPECIFY'')',
'   and id                = :P49_NEW_FLOW_ID',
'   and security_group_id = :P49_LOGGED_IN_COMPANY'))
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2106617022185423)
,p_name=>'P49_IMP_FLOW_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(47632929379498967)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Imported Application Name'
,p_source=>'wwv_flow_imp_parser.get_app_name (p_file_id => :p49_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The application name of the imported application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47644600991566557)
,p_name=>'P49_LOGGED_IN_COMPANY'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(47632929379498967)
,p_use_cache_before_default=>'NO'
,p_source=>'&WORKSPACE_ID.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47645615882570805)
,p_name=>'P49_IMP_FLOW_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(47632929379498967)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Imported Application ID'
,p_source=>'wwv_flow_imp_parser.get_flow_id (p_file_id => :p49_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The application ID of the imported application.  ',
'',
'If a duplicate application ID is found in the current workspace, the existing application is deleted and the new application is installed.  If a duplicate application ID is found in a different workspace, an error is raised.  This is because an appli'
||'cation ID must be unique across all workspaces.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47646409087578322)
,p_name=>'P49_PARSE_AS'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(47632929379498967)
,p_prompt=>'Parsing Schema'
,p_source=>'wwv_flow_imp_parser.get_parse_as_schema (p_file_id => :p49_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(schema) d, schema r',
'from   wwv_flow_company_schemas',
'where  security_group_id = :flow_security_group_id',
'order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'The installation of the application will be completed using this selection.  After the installation finishes successfully, this will be used to set the owner of the application now installed. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47659712784721297)
,p_name=>'P49_IMP_COMPANY'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(47632929379498967)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Imported Application Workspace ID'
,p_source=>'wwv_flow_imp_parser.get_security_group_id (p_file_id => :p49_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the ID of the workspace from which the application was exported.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47661103911728224)
,p_name=>'P49_IMP_FLOW_OWNER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(47632929379498967)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Imported Application Parsing Schema'
,p_source=>'wwv_flow_imp_parser.get_parse_as_schema (p_file_id => :p49_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'This is the application owner from the imported application.  Your selection for <strong>Parsing Schema</strong> will be the owner of your new application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48075028683667245)
,p_name=>'P49_COMPANY_ACTION'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(47632929379498967)
,p_prompt=>'Imported Application Origin'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'This identifies the source of the imported application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48333316682715628)
,p_name=>'P49_LOGGED_IN_COMPANY2'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(47632929379498967)
,p_item_default=>'&COMPANY.'
,p_prompt=>'Current Workspace'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the current workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48337002400730366)
,p_name=>'P49_IMP_COMPANY2'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(47632929379498967)
,p_item_default=>'&COMPANY.'
,p_prompt=>'Imported Application Workspace'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'wwv_flow_imp_parser.get_security_group_id (p_file_id => :p49_file_id) = :flow_security_group_id'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the workspace from which the application was exported.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(53701615454623778)
,p_name=>'P49_FILE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(47632929379498967)
,p_prompt=>'File Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(56513630434665840)
,p_name=>'P49_IMP_VERSION'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(47632929379498967)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Imported Application Version'
,p_source=>'wwv_flow_imp_parser.get_version(:p49_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The version of &PRODUCT_NAME. from which this application was exported.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(59206517015336606)
,p_name=>'P49_BUILD_STATUS'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(47632929379498967)
,p_item_default=>'RUN_AND_BUILD'
,p_prompt=>'Build Status'
,p_source=>'wwv_flow_imp_parser.get_build_status (p_file_id => :p49_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'BUILD_STATUS'
,p_lov=>'.'||wwv_flow_imp.id(84305510710571518)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'The build status to be set for the resulting application.  ',
'</p>',
'',
'<p>',
'Note: If you set the status to Run Application Only and later want to change it to Run and Build Application,',
'you will need to log in as an instance administrator.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(72898709763530334)
,p_name=>'P49_NEW_FLOW_OPT'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(47632929379498967)
,p_item_default=>'AUTO'
,p_prompt=>'Install As Application'
,p_source=>'AUTO'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'INSTALL.FLOW.OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(73071600194414972)||'.'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Select how to install this application. Available options include:',
'</p>',
'',
'<p><ul>',
'<li><strong>Auto Assign New Application ID:</strong> A new application ID will be created for you.</li>',
'<li><strong>Reuse Application ID From Imported Application:</strong> The application ID attached to the imported application will be used. When you install an application with the same ID as an existing application in the current workspace, the exist'
||'ing application is deleted and then replaced by the new application.</li>',
'<li><strong>Change Application ID:</strong> Specify a new application ID.</li>',
'</ul>',
'</p>',
'',
'<p>',
'Remember, you must specify an application ID that is unique across all &PRODUCT_NAME. workspaces.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(73052424192272620)
,p_name=>'P49_ADJUST_OFFSETS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(47632929379498967)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(73108017537715434)
,p_name=>'P49_NEW_FLOW_ID'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(47632929379498967)
,p_use_cache_before_default=>'NO'
,p_prompt=>'New Application ID'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>8
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify a new application ID, which is an integer value that identifies the application.  The application ID must be unique within your &PRODUCT_NAME. instance.',
'<br /><br />',
'Application IDs in the range of 3000 to 9000 are reserved for internal use by &PRODUCT_NAME.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(73083719288517204)
,p_computation_sequence=>10
,p_computation_item=>'P49_NEW_FLOW_ID'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P49_IMP_FLOW_ID'
,p_computation_error_message=>'Unable to compute item value.'
,p_compute_when=>'P49_NEW_FLOW_OPT'
,p_compute_when_text=>'REUSE'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(73086102234531170)
,p_computation_sequence=>20
,p_computation_item=>'P49_NEW_FLOW_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return wwv_flow_utilities.minimum_free_flow;'
,p_computation_error_message=>'Unable to compute item value.'
,p_compute_when=>':P49_NEW_FLOW_OPT = ''AUTO'' and :REQUEST = ''INSTALL'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(225115916305424325)
,p_computation_sequence=>30
,p_computation_item=>'P2117_SUBMITTED'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'NO'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(248776121681030473)
,p_computation_sequence=>50
,p_computation_item=>'P163_FILE_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'SQL'
,p_computation=>':P49_FILE_ID'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(56432910873347878)
,p_validation_name=>'version must be compatible'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_runtime_version varchar2(200); -- the date of the current runtime flows',
'  l_calling_version varchar2(200);',
'begin',
'    l_calling_version := replace(replace(replace(wwv_flow_imp_parser.get_version (p_file_id => :p49_file_id),''.'',null),''_'',null),''/'',null);',
'    l_runtime_version := replace(replace(replace(wwv_flows_version,''.'',null),''_'',null),''/'',null);',
'',
'    if   l_calling_version > l_runtime_version',
'      or l_calling_version = ''20150701'' -- APEX 5.1 EA1',
'    then',
'        --',
'        -- version incompatability        ',
'        --',
'        ',
'        return false;',
'    else',
'        return true;',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'NOT COMPATIBLE (Your export may contain calls not supported by your &PRODUCT_NAME. version.)'
,p_when_button_pressed=>wwv_flow_imp.id(47638615358532853)
,p_associated_item=>wwv_flow_imp.id(56513630434665840)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(338249619399057431)
,p_validation_name=>'New Flow ID Not Null'
,p_validation_sequence=>20
,p_validation=>'P49_NEW_FLOW_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Application ID must be specified.'
,p_validation_condition=>'P49_NEW_FLOW_OPT'
,p_validation_condition2=>'SPECIFY'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(47638615358532853)
,p_associated_item=>wwv_flow_imp.id(73108017537715434)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(73122718501810340)
,p_validation_name=>'new flow id is numeric'
,p_validation_sequence=>30
,p_validation=>'P49_NEW_FLOW_ID'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Application ID must be numeric.'
,p_when_button_pressed=>wwv_flow_imp.id(47638615358532853)
,p_associated_item=>wwv_flow_imp.id(73108017537715434)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(75674329288890481)
,p_validation_name=>'specify new flow not same flow'
,p_validation_sequence=>40
,p_validation=>'ltrim(:P49_NEW_FLOW_ID,''0'') != nvl(:P49_IMP_FLOW_ID,-1)'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Specified Application ID must be different from old Application ID when using this option. To use the same application ID again, use the ''Reuse Application ID From Export File'' radio button.'
,p_validation_condition=>':P49_NEW_FLOW_OPT = ''SPECIFY'' and wwv_flow_utilities.is_numeric(:P49_NEW_FLOW_ID)'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(47638615358532853)
,p_associated_item=>wwv_flow_imp.id(73108017537715434)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(338252426718087928)
,p_validation_name=>'reserved flow id check 2'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_utilities.get_app_id_reserved_reason (',
'           p_security_group_id => :flow_security_group_id,',
'           p_application_id    => :P49_NEW_FLOW_ID );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':P49_NEW_FLOW_OPT = ''SPECIFY'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(47638615358532853)
,p_associated_item=>wwv_flow_imp.id(73108017537715434)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(59210409312353336)
,p_validation_name=>'build status not null'
,p_validation_sequence=>70
,p_validation=>'P49_BUILD_STATUS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Build Status must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(47638615358532853)
,p_associated_item=>wwv_flow_imp.id(59206517015336606)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(47684431812925489)
,p_validation_name=>'parse as not null'
,p_validation_sequence=>80
,p_validation=>'P49_PARSE_AS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Parse As Schema must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(47638615358532853)
,p_associated_item=>wwv_flow_imp.id(47646409087578322)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(47812121666857962)
,p_validation_name=>'not valid export file'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ((:P49_IMP_COMPANY is null)/* and (:P49_NEW_FLOW_ID is null)*/ and(:P49_IMP_FLOW_OWNER is null)) or',
'wwv_flow_imp_parser.is_company_export(:P49_FILE_ID) then',
'   return false;',
'else',
'   return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'File is not a valid &PRODUCT_NAME. application export file.'
,p_when_button_pressed=>wwv_flow_imp.id(47638615358532853)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(51925119200045924)
,p_validation_name=>'cannot import invalid range flow'
,p_validation_sequence=>100
,p_validation=>':P49_NEW_FLOW_ID not between 4000 and 4999'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'The application you are trying to install is reserved.'
,p_validation_condition=>'(:flow_security_group_id != 10) and (:P49_IMP_FLOW_ID is not null) and (wwv_flow_utilities.is_numeric(:P49_NEW_FLOW_ID) = true)'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(47638615358532853)
,p_associated_item=>wwv_flow_imp.id(47645615882570805)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(484652413021609778)
,p_validation_name=>'P49_NEW_FLOW_ID positive, whole number'
,p_validation_sequence=>110
,p_validation=>'P49_NEW_FLOW_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>'Application Number must be a positive, whole number.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P49_NEW_FLOW_ID is not null and',
':P49_NEW_FLOW_OPT = ''SPECIFY'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(47638615358532853)
,p_associated_item=>wwv_flow_imp.id(73108017537715434)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(119476622912947206)
,p_validation_name=>'application must not have any working copies'
,p_validation_sequence=>120
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not wwv_flow_working_copy_dev.app_has_working_copy (',
'    p_application_id     => :P49_NEW_FLOW_ID, ',
'    p_security_group_id  => :WORKSPACE_ID )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'The application you specified cannot be replaced because it has one or more working copies.'
,p_validation_condition=>'P49_NEW_FLOW_OPT'
,p_validation_condition2=>'SPECIFY'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(47638615358532853)
,p_associated_item=>wwv_flow_imp.id(73108017537715434)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(382393636208769611)
,p_name=>'Set Focus on New Application ID'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_cond=>'P49_NEW_FLOW_OPT'
,p_display_when_cond2=>'SPECIFY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(382393781319769612)
,p_event_id=>wwv_flow_imp.id(382393636208769611)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P49_NEW_FLOW_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(382393873371769613)
,p_name=>'Show New App ID'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P49_NEW_FLOW_OPT'
,p_condition_element=>'P49_NEW_FLOW_OPT'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SPECIFY'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(382393999889769614)
,p_event_id=>wwv_flow_imp.id(382393873371769613)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P49_NEW_FLOW_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(382394085941769615)
,p_event_id=>wwv_flow_imp.id(382393873371769613)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P49_NEW_FLOW_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(382394131710769616)
,p_event_id=>wwv_flow_imp.id(382393873371769613)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P49_NEW_FLOW_ID'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(48121120970958297)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'determine flow import company action'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :flow_security_group_id = wwv_flow_imp_parser.get_security_group_id(:p49_file_id) then',
'  :p49_company_action := wwv_flow_lang.system_message(''F4000.APP_EXPORT_CURR_WS'');',
'else',
'  :p49_company_action := wwv_flow_lang.system_message(''F4000.APP_EXPORT_NON_CURR_WS'');',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>48121120970958297
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(25458208466179758)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Clean Up Reserved Application IDs'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from wwv_flows_reserved ',
'where id in (select id from wwv_flows where security_group_id = :FLOW_SECURITY_GROUP_ID );',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>25458208466179758
);
end;
/
prompt --application/pages/page_00050
begin
wwv_flow_imp_page.create_page(
 p_id=>50
,p_name=>'List Template Attribute Descriptions'
,p_alias=>'LIST-TEMPLATE-ATTRIBUTE-DESCRIPTIONS'
,p_page_mode=>'MODAL'
,p_step_title=>'List Template Attribute Descriptions'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'No help is available for this page.'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1533932968307629863)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_query_num_rows=>15
,p_plug_header=>'Substitution strings #A01# - #A10# are optional attributes which can be used within a list template, to reference component values. Select a theme and associated list template, to view the descriptions that have been defined for these substitution st'
||'rings, where used within the selected list template.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(1533933130769636360)
,p_name=>'List Template Attributes'
,p_template=>wwv_flow_imp.id(646287526247383209)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select A01_LABEL,',
'       A02_LABEL,',
'       A03_LABEL,',
'       A04_LABEL,',
'       A05_LABEL,',
'       A06_LABEL,',
'       A07_LABEL,',
'       A08_LABEL,',
'       A09_LABEL,',
'       A10_LABEL',
'  from WWV_FLOW_LIST_TEMPLATES',
' where id = :P50_LIST_TEMPLATE_ID',
'   and security_group_id = :flow_security_group_id',
'   and flow_id = :FB_FLOW_ID'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P50_LIST_TEMPLATE_ID'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(82408032331628644)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>'No list template selected.'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1301373148833065040)
,p_query_column_id=>1
,p_column_alias=>'A01_LABEL'
,p_column_display_sequence=>1
,p_column_heading=>'#A01# Description'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1301373246763065041)
,p_query_column_id=>2
,p_column_alias=>'A02_LABEL'
,p_column_display_sequence=>2
,p_column_heading=>'#A02# Description'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1301373379356065042)
,p_query_column_id=>3
,p_column_alias=>'A03_LABEL'
,p_column_display_sequence=>3
,p_column_heading=>'#A03# Description'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1301373478910065043)
,p_query_column_id=>4
,p_column_alias=>'A04_LABEL'
,p_column_display_sequence=>4
,p_column_heading=>'#A04# Description'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1301373538961065044)
,p_query_column_id=>5
,p_column_alias=>'A05_LABEL'
,p_column_display_sequence=>5
,p_column_heading=>'#A05# Description'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1301373666692065045)
,p_query_column_id=>6
,p_column_alias=>'A06_LABEL'
,p_column_display_sequence=>6
,p_column_heading=>'#A06# Description'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1301373794269065046)
,p_query_column_id=>7
,p_column_alias=>'A07_LABEL'
,p_column_display_sequence=>7
,p_column_heading=>'#A07# Description'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1301373813275065047)
,p_query_column_id=>8
,p_column_alias=>'A08_LABEL'
,p_column_display_sequence=>8
,p_column_heading=>'#A08# Description'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1301373949620065048)
,p_query_column_id=>9
,p_column_alias=>'A09_LABEL'
,p_column_display_sequence=>9
,p_column_heading=>'#A09# Description'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1301374081447065049)
,p_query_column_id=>10
,p_column_alias=>'A10_LABEL'
,p_column_display_sequence=>10
,p_column_heading=>'#A10# Description'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1500323050132760214)
,p_name=>'P50_THEME_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1533932968307629863)
,p_prompt=>'Theme'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(theme_name)||'' - ''||theme_id theme_name, theme_id',
'  from wwv_flow_themes',
'where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'order by upper(theme_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Theme -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a theme associated with this application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1533324667053624070)
,p_name=>'P50_LIST_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1533932968307629863)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1533930926254603049)
,p_name=>'P50_LIST_TEMPLATE_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(1533932968307629863)
,p_prompt=>'List Template'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(list_template_name) list_template_name, id',
'  from wwv_flow_list_templates',
'where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and theme_id = :P50_THEME_ID',
'order by upper(list_template_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select List Template -'
,p_lov_cascade_parent_items=>'P50_THEME_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the list template you would like to view. The substitution string attributes will automatically display for the selected list template.  The attribute descriptions aid developers in understanding the use of the optional substitution strings #A'
||'01# - #A10# within a list template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1533931119542609584)
,p_name=>'Refresh Report'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P50_LIST_TEMPLATE_ID'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1301374128305065050)
,p_event_id=>wwv_flow_imp.id(1533931119542609584)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1533933130769636360)
);
end;
/
prompt --application/pages/page_00051
begin
wwv_flow_imp_page.create_page(
 p_id=>51
,p_name=>'Unsupported UI'
,p_alias=>'UNSUPPORTED-UI'
,p_page_mode=>'MODAL'
,p_step_title=>'Create a Page'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'11'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1440167474392501)
,p_plug_name=>'Unsupported User Interface'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'jQuery Mobile is no longer supported. This application has only a "Mobile" user interface defined. To add new pages to this application, you need to update your application to use Universal Theme. Use the <strong>Create Theme</strong> wizard to add U'
||'niversal Theme to your application, and then use the <strong>Switch Theme</strong> wizard to start using it in your application.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1440445662392504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1440842374392508)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1440167474392501)
,p_button_name=>'manage_ui'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Manage Themes'
,p_button_position=>'BELOW_BOX'
,p_button_redirect_url=>'f?p=&APP_ID.:260:&SESSION.::&DEBUG.:RP,::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1440521040392505)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1440445662392504)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1440626005392506)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1440521040392505)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1440744149392507)
,p_event_id=>wwv_flow_imp.id(1440626005392506)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00052
begin
wwv_flow_imp_page.create_page(
 p_id=>52
,p_name=>'Convert to Shared List of Values'
,p_alias=>'CONVERT-TO-SHARED-LIST-OF-VALUES'
,p_page_mode=>'MODAL'
,p_step_title=>'Convert to Shared List of Values'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213211113434774960)
,p_inline_css=>'.lov-source-region pre {margin: 0;}'
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(681994650910644701)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(681995236069644707)
,p_plug_name=>'Form Region'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'Convert a list of values defined at an item level to a shared list of values. Once this list of values is converted it can be referenced by any item within the current application.'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3348608179229757717)
,p_plug_name=>'List of Values Source'
,p_region_css_classes=>'lov-source-region'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--simple'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    cursor lov_data',
'    is',
'    select',
'          substr(i.lov,1,4000) lov',
'      from wwv_flow_step_items i',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and id = :F4000_P52_SOURCE_ID',
'       and :F4000_P52_SOURCE_TYPE = ''PAGE_ITEM''',
'    union all',
'    select',
'          substr(i.lov_source,1,4000) lov',
'      from wwv_flow_region_columns i',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and id = :F4000_P52_SOURCE_ID',
'       and :F4000_P52_SOURCE_TYPE = ''IG_COLUMN'';',
'begin',
'    for c1 in lov_data',
'    loop',
'        sys.htp.p(''<pre>''||wwv_flow_escape.html(c1.lov)||''</pre>'');',
'    end loop;',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(681994824368644703)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(681994650910644701)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(681994761845644702)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(681994650910644701)
,p_button_name=>'CONVERT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Convert List of Values'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2701819071095216)
,p_name=>'F4000_P52_SOURCE_TYPE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(681995236069644707)
,p_prompt=>'Type'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LOCALLY_DEFINED_LOV_TYPE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''SC.LOV.PAGE_ITEM'') d,',
'       ''PAGE_ITEM'' r',
'from sys.dual',
'union all',
'select wwv_flow_lang.system_message(''SC.LOV.IG_COLUMN'') d,',
'       ''IG_COLUMN'' r',
'from sys.dual'))
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(681995360652644708)
,p_name=>'F4000_P52_LOV_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(681995236069644707)
,p_prompt=>'Shared List of Values Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(708643875646067001)
,p_name=>'F4000_P52_LOV_SOURCE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(681995236069644707)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(708643954372067002)
,p_name=>'F4000_P52_PAGE_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(681995236069644707)
,p_prompt=>'Page Name'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3348608091212757716)
,p_name=>'F4000_P52_SOURCE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(681995236069644707)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3348608530308757721)
,p_validation_name=>'name not already in use'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_LISTS_OF_VALUES$',
' where FLOW_ID = :fb_flow_id',
'   and upper(LOV_NAME) = upper(:F4000_P52_LOV_NAME)'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Name must be unique within application'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(681994915812644704)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(681994824368644703)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(681995058088644705)
,p_event_id=>wwv_flow_imp.id(681994915812644704)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3348608460260757720)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Local Items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    cursor lov_data',
'    is',
'    select',
'          flow_step_id page_id,',
'          name,',
'          (select name',
'             from wwv_flow_steps p',
'            where p.id = i.flow_step_id',
'              and flow_id = :FB_FLOW_ID',
'              and security_group_id = :FLOW_SECURITY_GROUP_ID) page_name',
'      from wwv_flow_step_items i',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and id = :F4000_P52_SOURCE_ID',
'       and :F4000_P52_SOURCE_TYPE = ''PAGE_ITEM''',
'    union all',
'    select',
'          page_id,',
'          name,',
'          (select name',
'             from wwv_flow_steps p',
'            where p.id = i.page_id',
'              and flow_id = :FB_FLOW_ID',
'              and security_group_id = :FLOW_SECURITY_GROUP_ID) page_name',
'      from wwv_flow_region_columns i',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and id = :F4000_P52_SOURCE_ID',
'       and :F4000_P52_SOURCE_TYPE = ''IG_COLUMN'';',
'begin',
'    for c1 in lov_data',
'    loop',
'        :F4000_P52_LOV_NAME := c1.name;',
'        :F4000_P52_LOV_SOURCE_NAME := c1.name;',
'        :F4000_P52_PAGE_NAME := c1.page_id ||''. ''||c1.page_name;',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>3348608460260757720
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3348608235093757718)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Convert LOV'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    cursor lov_data',
'    is',
'    select',
'          i.lov lov',
'      from wwv_flow_step_items i',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and id = :F4000_P52_SOURCE_ID',
'       and :F4000_P52_SOURCE_TYPE = ''PAGE_ITEM''',
'    union all',
'    select',
'          i.lov_source lov',
'      from wwv_flow_region_columns i',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and id = :F4000_P52_SOURCE_ID',
'       and :F4000_P52_SOURCE_TYPE = ''IG_COLUMN'';',
'    l_id  number;',
'begin',
'    -- create shared LOV',
'    for c1 in lov_data',
'    loop',
'        wwv_flow_lov_dev.create_named_lov (',
'            p_id      => l_id,',
'            p_flow_id => :FB_FLOW_ID,',
'            p_name    => :F4000_P52_LOV_NAME,',
'            p_query   => c1.LOV );',
'    end loop;',
'    -- update page item or IG column to use shared LOV',
'    if :F4000_P52_SOURCE_TYPE = ''PAGE_ITEM'' then',
'        update wwv_flow_step_items',
'           set named_lov = upper(:F4000_P52_LOV_NAME)',
'         where id = :F4000_P52_SOURCE_ID',
'           and flow_id = :FB_FLOW_ID',
'           and security_group_id = :flow_security_group_id;',
'    elsif :F4000_P52_SOURCE_TYPE = ''IG_COLUMN'' then',
'        update wwv_flow_region_columns',
'           set lov_type = ''SHARED'',',
'               lov_id = l_id',
'         where id = :F4000_P52_SOURCE_ID',
'           and flow_id = :FB_FLOW_ID',
'           and security_group_id = :flow_security_group_id;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error creating shared list of values.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(681994761845644702)
,p_process_success_message=>'Shared list of values "&F4000_P52_LOV_NAME." created.'
,p_internal_uid=>3348608235093757718
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(681995112839644706)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>681995112839644706
);
end;
/
prompt --application/pages/page_00054
begin
wwv_flow_imp_page.create_page(
 p_id=>54
,p_name=>'Navigation Bar Entry Subscription'
,p_alias=>'NAVIGATION-BAR-ENTRY-SUBSCRIPTION'
,p_step_title=>'Navigation Bar Entry Subscription'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213263531591941060)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript1.1" type="text/javascript">',
'    function checkAll()  {          ',
'        for ( var i=0; i < document.wwv_flow.elements.length; i++ )          ',
'        {              var e = document.wwv_flow.elements[i];              ',
'        if ( e.name == "f01" || e.name == "f03" ||  e.name == "f05" ||e.name == "f07" ||  e.name == "f09" ){',
'            if ( e.length > 1 ) { for ( j=0;j<e.length;j++ ) ',
'                if ( !e[j].checked ) ',
'                  e[j].click();} ',
'                else ',
'                    if ( !e.checked ) ',
'                         e.click(); ',
'            }',
'         }',
'    }',
'</script>'))
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_navbar.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(201227528849320624)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_no_data_found=>'<font class="fieldtitleleft">No NavBars Found.</font>'
,p_plug_query_show_nulls_as=>'(null)'
,p_landmark_type=>'region'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(201233514400327310)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>This page displays subscribed Navigation Bar Entries in your application.</p>'
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_no_data_found=>'<font class="fieldtitleleft">No NavBars Found.</font>'
,p_plug_query_show_nulls_as=>'(null)'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(201238512231343527)
,p_name=>'Subscribed Navigation Bars'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    q varchar2(32767) := null;',
'begin',
'    q :=q||''select /* APEX 4000P54a */ '';',
'    q :=q||''wwv_flow_item.checkbox(1,id), '';',
'    q :=q||''wwv_flow_item.hidden(2,reference_id), '';',
'    q :=q||''flow_id, '';   ',
'    q :=q||''wwv_flow_escape.html(icon_image_alt) name, '';',
'    q :=q||''(select wwv_flow_lang.system_message(''''F4000_P801_FLOW'''')||'''' ''''||flow_id||'''', ''''||wwv_flow_escape.html(icon_image_alt) '';',
'    q :=q||''from wwv_flow_icon_bar where id = s.reference_id) cp_from '';      ',
'    q :=q||''from wwv_flow_icon_bar s '';',
'    q :=q||''where s.flow_id = :fb_flow_id '';',
'    q :=q||''and s.security_group_id = :flow_security_group_id '';',
'    q :=q||''and s.reference_id is not null '';',
'    return q;',
'end;'))
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_plug_query_max_columns=>60
,p_query_num_rows=>1000
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48552904796770781)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48553010591770781)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48553111660770781)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>3
,p_column_heading=>'Application'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48553220325770782)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>4
,p_column_heading=>'Navigation Bar Entry'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48553301951770782)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>5
,p_column_heading=>'Copied From'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48553407592770782)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>6
,p_column_heading=>'COL06'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48553510657770782)
,p_query_column_id=>7
,p_column_alias=>'COL07'
,p_column_display_sequence=>7
,p_column_heading=>'COL07'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48553620694770782)
,p_query_column_id=>8
,p_column_alias=>'COL08'
,p_column_display_sequence=>8
,p_column_heading=>'COL08'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48553711219770782)
,p_query_column_id=>9
,p_column_alias=>'COL09'
,p_column_display_sequence=>9
,p_column_heading=>'COL09'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48553821962770782)
,p_query_column_id=>10
,p_column_alias=>'COL10'
,p_column_display_sequence=>10
,p_column_heading=>'COL10'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48553910556770782)
,p_query_column_id=>11
,p_column_alias=>'COL11'
,p_column_display_sequence=>11
,p_column_heading=>'COL11'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48554030900770782)
,p_query_column_id=>12
,p_column_alias=>'COL12'
,p_column_display_sequence=>12
,p_column_heading=>'COL12'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48554124185770783)
,p_query_column_id=>13
,p_column_alias=>'COL13'
,p_column_display_sequence=>13
,p_column_heading=>'COL13'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48554210905770783)
,p_query_column_id=>14
,p_column_alias=>'COL14'
,p_column_display_sequence=>14
,p_column_heading=>'COL14'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48554320007770783)
,p_query_column_id=>15
,p_column_alias=>'COL15'
,p_column_display_sequence=>15
,p_column_heading=>'COL15'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(134508307399752849)
,p_query_column_id=>16
,p_column_alias=>'COL16'
,p_column_display_sequence=>16
,p_column_heading=>'Col16'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(134508423207752851)
,p_query_column_id=>17
,p_column_alias=>'COL17'
,p_column_display_sequence=>17
,p_column_heading=>'Col17'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(134508511257752851)
,p_query_column_id=>18
,p_column_alias=>'COL18'
,p_column_display_sequence=>18
,p_column_heading=>'Col18'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(134508607977752851)
,p_query_column_id=>19
,p_column_alias=>'COL19'
,p_column_display_sequence=>19
,p_column_heading=>'Col19'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(134508706135752851)
,p_query_column_id=>20
,p_column_alias=>'COL20'
,p_column_display_sequence=>20
,p_column_heading=>'Col20'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(176748315258590144)
,p_query_column_id=>21
,p_column_alias=>'COL21'
,p_column_display_sequence=>21
,p_column_heading=>'Col21'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(176748409188590147)
,p_query_column_id=>22
,p_column_alias=>'COL22'
,p_column_display_sequence=>22
,p_column_heading=>'Col22'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(176748530114590147)
,p_query_column_id=>23
,p_column_alias=>'COL23'
,p_column_display_sequence=>23
,p_column_heading=>'Col23'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(176748612398590147)
,p_query_column_id=>24
,p_column_alias=>'COL24'
,p_column_display_sequence=>24
,p_column_heading=>'Col24'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(176748704077590147)
,p_query_column_id=>25
,p_column_alias=>'COL25'
,p_column_display_sequence=>25
,p_column_heading=>'Col25'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(176748827906590147)
,p_query_column_id=>26
,p_column_alias=>'COL26'
,p_column_display_sequence=>26
,p_column_heading=>'Col26'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(176748924293590147)
,p_query_column_id=>27
,p_column_alias=>'COL27'
,p_column_display_sequence=>27
,p_column_heading=>'Col27'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(176749000134590148)
,p_query_column_id=>28
,p_column_alias=>'COL28'
,p_column_display_sequence=>28
,p_column_heading=>'Col28'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(176749111331590148)
,p_query_column_id=>29
,p_column_alias=>'COL29'
,p_column_display_sequence=>29
,p_column_heading=>'Col29'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(176749223268590148)
,p_query_column_id=>30
,p_column_alias=>'COL30'
,p_column_display_sequence=>30
,p_column_heading=>'Col30'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(176749321262590148)
,p_query_column_id=>31
,p_column_alias=>'COL31'
,p_column_display_sequence=>31
,p_column_heading=>'Col31'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(176749419617590148)
,p_query_column_id=>32
,p_column_alias=>'COL32'
,p_column_display_sequence=>32
,p_column_heading=>'Col32'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(176749527600590148)
,p_query_column_id=>33
,p_column_alias=>'COL33'
,p_column_display_sequence=>33
,p_column_heading=>'Col33'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(176749622600590148)
,p_query_column_id=>34
,p_column_alias=>'COL34'
,p_column_display_sequence=>34
,p_column_heading=>'Col34'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(176749726171590149)
,p_query_column_id=>35
,p_column_alias=>'COL35'
,p_column_display_sequence=>35
,p_column_heading=>'Col35'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(176749806706590149)
,p_query_column_id=>36
,p_column_alias=>'COL36'
,p_column_display_sequence=>36
,p_column_heading=>'Col36'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(176749903004590149)
,p_query_column_id=>37
,p_column_alias=>'COL37'
,p_column_display_sequence=>37
,p_column_heading=>'Col37'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(176750026259590149)
,p_query_column_id=>38
,p_column_alias=>'COL38'
,p_column_display_sequence=>38
,p_column_heading=>'Col38'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(176750121162590149)
,p_query_column_id=>39
,p_column_alias=>'COL39'
,p_column_display_sequence=>39
,p_column_heading=>'Col39'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(176750209943590149)
,p_query_column_id=>40
,p_column_alias=>'COL40'
,p_column_display_sequence=>40
,p_column_heading=>'Col40'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(176750313326590149)
,p_query_column_id=>41
,p_column_alias=>'COL41'
,p_column_display_sequence=>41
,p_column_heading=>'Col41'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(176750424238590149)
,p_query_column_id=>42
,p_column_alias=>'COL42'
,p_column_display_sequence=>42
,p_column_heading=>'Col42'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(176750528228590150)
,p_query_column_id=>43
,p_column_alias=>'COL43'
,p_column_display_sequence=>43
,p_column_heading=>'Col43'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(176750626203590150)
,p_query_column_id=>44
,p_column_alias=>'COL44'
,p_column_display_sequence=>44
,p_column_heading=>'Col44'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(176750721718590150)
,p_query_column_id=>45
,p_column_alias=>'COL45'
,p_column_display_sequence=>45
,p_column_heading=>'Col45'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(176750808993590150)
,p_query_column_id=>46
,p_column_alias=>'COL46'
,p_column_display_sequence=>46
,p_column_heading=>'Col46'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(176750904715590150)
,p_query_column_id=>47
,p_column_alias=>'COL47'
,p_column_display_sequence=>47
,p_column_heading=>'Col47'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(176751010218590150)
,p_query_column_id=>48
,p_column_alias=>'COL48'
,p_column_display_sequence=>48
,p_column_heading=>'Col48'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(176751109115590150)
,p_query_column_id=>49
,p_column_alias=>'COL49'
,p_column_display_sequence=>49
,p_column_heading=>'Col49'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(176751232623590151)
,p_query_column_id=>50
,p_column_alias=>'COL50'
,p_column_display_sequence=>50
,p_column_heading=>'Col50'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(176751325093590151)
,p_query_column_id=>51
,p_column_alias=>'COL51'
,p_column_display_sequence=>51
,p_column_heading=>'Col51'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(176751416019590151)
,p_query_column_id=>52
,p_column_alias=>'COL52'
,p_column_display_sequence=>52
,p_column_heading=>'Col52'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(176751517668590151)
,p_query_column_id=>53
,p_column_alias=>'COL53'
,p_column_display_sequence=>53
,p_column_heading=>'Col53'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(176751612465590151)
,p_query_column_id=>54
,p_column_alias=>'COL54'
,p_column_display_sequence=>54
,p_column_heading=>'Col54'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(176751706601590151)
,p_query_column_id=>55
,p_column_alias=>'COL55'
,p_column_display_sequence=>55
,p_column_heading=>'Col55'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(176751818691590151)
,p_query_column_id=>56
,p_column_alias=>'COL56'
,p_column_display_sequence=>56
,p_column_heading=>'Col56'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(176751928362590152)
,p_query_column_id=>57
,p_column_alias=>'COL57'
,p_column_display_sequence=>57
,p_column_heading=>'Col57'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(176752021366590152)
,p_query_column_id=>58
,p_column_alias=>'COL58'
,p_column_display_sequence=>58
,p_column_heading=>'Col58'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(176752122217590152)
,p_query_column_id=>59
,p_column_alias=>'COL59'
,p_column_display_sequence=>59
,p_column_heading=>'Col59'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(176752229824590152)
,p_query_column_id=>60
,p_column_alias=>'COL60'
,p_column_display_sequence=>60
,p_column_heading=>'Col60'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(201268225336398200)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(166766500720858594)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Classic Navigation Bar'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(201248202877360033)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(201227528849320624)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Refresh Checked'
,p_button_position=>'CREATE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_icon_bar s',
' where s.flow_id = :fb_flow_id',
'   and s.reference_id is not null'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(201248602877360037)
,p_branch_action=>'54'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(201248202877360033)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(201251422126369286)
,p_name=>'F4000_P54_CHECK_ALL'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(201227528849320624)
,p_prompt=>'</a><a href="javascript:checkAll()">Check All'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'select 1 from wwv_flow_icon_bar s where s.flow_id = :fb_flow_id and s.reference_id is not null'
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Click to check all.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(201257425996382675)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh checked NavBars'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'for i in 1..wwv_flow.g_f01.count loop',
'    wwv_flow_copy_metadata.refresh_navbar(    ',
'    p_subscribing_navbar_id    => wwv_flow.g_f01(i)',
'    );',
'end loop;',
'exception when others then',
'  raise_application_error(-20001,''Error in refreshing NavBars. ''||sqlerrm);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error refreshing navigation bar(s).'
,p_process_when_button_id=>wwv_flow_imp.id(201248202877360033)
,p_process_success_message=>'Selected navigation bar(s) refreshed.'
,p_internal_uid=>201257425996382675
);
end;
/
prompt --application/pages/page_00056
begin
wwv_flow_imp_page.create_page(
 p_id=>56
,p_name=>'Create Application - Method'
,p_alias=>'CREATE-APPLICATION'
,p_step_title=>'Create Application'
,p_allow_duplicate_submissions=>'N'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212889110308348288)
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#widget.cropperEditor#MIN#.js',
'#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#widget.iconEditor#MIN#.js'))
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_css_classes=>'a-Page--createApp'
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_wiz.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1664896374283001)
,p_plug_name=>'Quick Create'
,p_region_css_classes=>'a-BoxedForms a-BoxedForms--large mxw780 margin-auto margin-top-lg margin-bottom-lg'
,p_region_template_options=>'#DEFAULT#:a-Form--labelsAbove'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_landmark_type=>'form'
,p_landmark_label=>'Create application'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8334820237540202)
,p_plug_name=>'Buttons'
,p_parent_plug_id=>wwv_flow_imp.id(1664896374283001)
,p_region_css_classes=>'u-tC'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(369051111555895735)
,p_plug_name=>'Application Options'
,p_region_name=>'application_options'
,p_region_css_classes=>'mxw780 margin-auto margin-top-lg margin-bottom-lg'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>30
,p_list_id=>wwv_flow_imp.id(128724959151960807)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(693422331030340241)
,p_landmark_type=>'navigation'
,p_landmark_label=>'Additional create options'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(703476091007162401)
,p_plug_name=>'Create an Application'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1665184151283004)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(8334820237540202)
,p_button_name=>'CREATE_APP'
,p_button_static_id=>'CREATE_APP'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Application'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--xlarge'
,p_grid_new_row=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1667140100283024)
,p_branch_name=>'Go to new app home'
,p_branch_action=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.::FB_FLOW_ID,F4000_P1_FLOW:&P56_APP_ID.,&P56_APP_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'REQUEST_IN_CONDITION'
,p_branch_condition=>'CREATE_APP,P56_APP_NAME'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(21889163106730213)
,p_branch_name=>'Go to full create wizard'
,p_branch_action=>'f?p=4020:1:&SESSION.:NEW:&DEBUG.:1,5,130,150,170,250,2000:P1_APP_ID,P1_APP_NAME:&P56_APP_ID.,&P56_APP_NAME.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'FULL_CREATE_WIZ'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1664974460283002)
,p_name=>'P56_APP_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1664896374283001)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_tag_attributes=>'autocomplete="off"'
,p_field_template=>wwv_flow_imp.id(1385827696712229)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1665036471283003)
,p_name=>'P56_APP_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1664896374283001)
,p_prompt=>'ID'
,p_source=>'wwv_flow_utilities.minimum_free_flow'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>12
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_imp.id(1385827696712229)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_03=>'left'
,p_attribute_04=>'decimal'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1666213470283015)
,p_name=>'P56_APP_COLOR_HEX'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(1664896374283001)
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select lovd.lov_return_value',
'  from wwv_flow_list_of_values_data lovd,',
'       wwv_flow_lists_of_values$ lov',
' where lov.flow_id            = 4020',
'   and lovd.lov_id            = lov.id',
'   and lovd.flow_id           = lov.flow_id',
'   and lovd.security_group_id = lov.security_group_id',
'   and lov.lov_name           = ''P120_APP_COLORS''',
'   and lovd.lov_disp_sequence = replace(:P56_APP_COLOR_CLASS,''app-color-'');'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1669394716283046)
,p_name=>'P56_APP_ICON_CLASS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1664896374283001)
,p_source=>'app-icon-rocket'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1669412016283047)
,p_name=>'P56_APP_COLOR_CLASS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(1664896374283001)
,p_source=>'''app-color-'' || round( sys.dbms_random.value( 1,8 ) )'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3328105265902167)
,p_computation_sequence=>10
,p_computation_item=>'FB_FLOW_PAGE_ID'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>' '
,p_computation_error_message=>'Unable to compute item value.'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1665447102283007)
,p_validation_name=>'App Name is valid'
,p_validation_sequence=>10
,p_validation=>'return wwv_flow_utilities.is_valid_application_name(p_name => :P56_APP_NAME);'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P56_APP_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_imp.id(1664974460283002)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(21889280407730214)
,p_validation_name=>'App Name is not null'
,p_validation_sequence=>20
,p_validation=>'P56_APP_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Application Name must have a value.'
,p_validation_condition=>'CREATE_APP,P56_APP_NAME'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1665289320283005)
,p_validation_name=>'App ID is valid'
,p_validation_sequence=>30
,p_validation=>'return wwv_flow_utilities.is_valid_application_id( p_name => :P56_APP_ID);'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_associated_item=>wwv_flow_imp.id(1665036471283003)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1665367741283006)
,p_validation_name=>'App ID is available'
,p_validation_sequence=>40
,p_validation=>'select 1 from wwv_flows where id = :P56_APP_ID'
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Application ID already exists, or is reserved for another application.'
,p_associated_item=>wwv_flow_imp.id(1665036471283003)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1667998231283032)
,p_name=>'Icon initialization'
,p_event_sequence=>50
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1667535761283028)
,p_event_id=>wwv_flow_imp.id(1667998231283032)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_name=>'Generate app icon'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.iconEditor.saveStockIcon({',
'    iconClass: apex.items.P56_APP_ICON_CLASS.value.replaceAll(''app-icon-'', ''''),',
'    iconColor: apex.items.P56_APP_COLOR_HEX.value',
'});'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(12285172745498101)
,p_name=>'Submit and create app'
,p_event_sequence=>60
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1665184151283004)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(12285233814498102)
,p_event_id=>wwv_flow_imp.id(12285172745498101)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'CREATE_APP'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1665616793283009)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'createApplication'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_theme    wwv_flow_create_app_v3.t_theme;',
'begin',
'    -- default theme to UT',
'    l_theme.id          := 42;',
'    l_theme.theme_type  := ''UT'';',
'    l_theme.theme_style := ''Vita'';',
'',
'    wwv_flow_create_app_v3.create_app(',
'        -- required parameters',
'        p_app_id              => :P56_APP_ID,',
'        p_app_name            => :P56_APP_NAME,',
'        p_parsing_schema      => wwv_flow_user_api.get_default_schema,',
'        p_app_language        => :BROWSER_LANGUAGE,',
'        p_theme               => l_theme,',
'        -- build icon parameters',
'        p_app_icon_class      => :P56_APP_ICON_CLASS,',
'        p_app_color_class     => :P56_APP_COLOR_CLASS,',
'        p_app_icon_color_hex  => :P56_APP_COLOR_HEX,',
'        -- these parameters match the Advanced settings from detailed Create app wizard',
'        p_built_with_love     => false,',
'        p_learn_app_def       => false,',
'        p_learn_existing_apps => false,',
'        p_app_version         => ''Release 1.0'',',
'        p_document_direction  => ''N''',
'    );',
'',
'    htmldb_util.clear_app_cache( p_app_id => :P56_APP_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE_APP,P56_APP_NAME'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_internal_uid=>1665616793283009
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(21888466117730206)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Initialize create app wizard'
,p_process_sql_clob=>'wwv_flow_define_app_v3.init_wizard;'
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>21888466117730206
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1667794338283030)
,p_process_sequence=>20
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save_icon'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_collection.add_member (',
'        p_collection_name => wwv_flow_define_app_v3.c_icons_collection,',
'        p_c001            => ''icons/app-icon-''||wwv_flow.g_x01||''.png'',',
'        p_c002            => ''image/png'',',
'        p_blob001         => wwv_flow_webservices_api.clobbase642blob( p_clob => wwv_flow.g_clob_01 ) );',
'    ',
'    wwv_flow_json.open_object;',
'    wwv_flow_json.write( p_name => ''success'', p_value => true );',
'    wwv_flow_json.close_object;',
'exception',
'    when others then',
'        wwv_flow_json.open_object;',
'        wwv_flow_json.write( p_name => ''success'', p_value => false );',
'        wwv_flow_json.write( p_name => ''message'', p_value => sqlerrm );',
'        wwv_flow_json.close_object;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>1667794338283030
);
end;
/
prompt --application/pages/page_00057
begin
wwv_flow_imp_page.create_page(
 p_id=>57
,p_name=>'Install'
,p_alias=>'INSTALL'
,p_step_title=>'Install'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213300727323081712)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_install.htm'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(219194320039549095)
,p_plug_name=>'Application Installed'
,p_region_template_options=>'#DEFAULT#:a-Alert--success:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>30
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p( ''<p>'' || wwv_flow_lang.system_message( ''DATABASE_APP_SUCCESS_MSG'', :P49_NEW_FLOW_ID ) || ''</p>'' );',
'',
'sys.htp.p( ''<p>'' ||',
'           wwv_flow_lang.system_message( ''IMPORT_APP_SUCCESS_MSG'',',
'                                         wwv_flow_utilities.prepare_url( ''f?p='' || :APP_ID || '':73:'' || :APP_SESSION ) ) ||',
'           ''</p>'' );'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'FLOW'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(219194817530567271)
,p_plug_name=>'app success buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'FLOW'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(219201628153712228)
,p_plug_name=>'Page Installed'
,p_region_template_options=>'#DEFAULT#:a-Alert--success:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>40
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p( ''<p>'' || wwv_flow_lang.system_message( ''PAGE_INSTALL_SUCCESS_MSG'' ) || ''</p>'');',
'',
'sys.htp.p( ''<p>'' ||',
'           wwv_flow_lang.system_message( ''IMPORT_APP_SUCCESS_MSG'',',
'                                         wwv_flow_utilities.prepare_url( ''f?p='' || :APP_ID || '':73:'' || :APP_SESSION ) ) ||',
'           ''</p>'' );'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'PAGE'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(219201911662716950)
,p_plug_name=>'page success buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'PAGE'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(219205609069754096)
,p_plug_name=>'comp success buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'COMP'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(219206719458757054)
,p_plug_name=>'Components Installed'
,p_region_template_options=>'#DEFAULT#:a-Alert--success:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>50
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p( ''<p>'' || wwv_flow_lang.system_message( ''COMP_SUCCESS_MSG'' ) || ''</p>'' );',
'',
'sys.htp.p( ''<p>'' ||',
'           wwv_flow_lang.system_message( ''IMPORT_APP_SUCCESS_MSG'',',
'                                         wwv_flow_utilities.prepare_url( ''f?p='' || :APP_ID || '':73:'' || :APP_SESSION ) ) ||',
'           ''</p>'' );'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'COMP'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(219195822641587691)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(219194817530567271)
,p_button_name=>'RUN_APP'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Run Application'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(219206202354754098)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(219205609069754096)
,p_button_name=>'RUN_APP'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Run Application'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(219204427854740565)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(219201911662716950)
,p_button_name=>'RUN_PAGE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Run Page'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(219195416622576434)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(219194817530567271)
,p_button_name=>'UPGRADE_APP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Upgrade Application'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:89:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(219205831117754097)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(219205609069754096)
,p_button_name=>'UPGRADE_APP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Upgrade Application'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:89:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(219195600131581141)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(219194817530567271)
,p_button_name=>'EDIT_APP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Edit Application'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id from wwv_flows ',
' where id = :FB_FLOW_ID ',
'   and build_status = ''RUN_AND_BUILD''',
'   and security_group_id = :flow_security_group_id'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(219206026347754098)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(219205609069754096)
,p_button_name=>'EDIT_APP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Edit Application'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id from wwv_flows ',
' where id = :FB_FLOW_ID ',
'   and build_status = ''RUN_AND_BUILD''',
'   and security_group_id = :flow_security_group_id'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(219203627723731062)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(219201911662716950)
,p_button_name=>'EDIT_APP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Edit Application'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(219203912270736065)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(219201911662716950)
,p_button_name=>'EDIT_PAGE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Edit Page'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:&FB_FLOW_PAGE_ID.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(77263312394218861)
,p_branch_action=>'f?p=&FB_FLOW_ID.:1:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'RUN'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(77264815988229366)
,p_branch_action=>'f?p=&FLOW_ID.:73:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'VIEW'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(77263923129221887)
,p_branch_name=>'Go To Page 1'
,p_branch_action=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'EDIT'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(92105893178731301)
,p_name=>'P57_RUN_PAGE_URL'
,p_item_sequence=>20
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(219379223497988145)
,p_name=>'P57_RUN_APP_URL'
,p_item_sequence=>10
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(219379410558994145)
,p_computation_sequence=>10
,p_computation_item=>'P57_RUN_APP_URL'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_dev.get_run_url (p_application_id => :FB_FLOW_ID )'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(92105926521731302)
,p_computation_sequence=>20
,p_computation_item=>'P57_RUN_PAGE_URL'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_dev.get_run_url (',
'    p_application_id => :FB_FLOW_ID,',
'    p_page_id        => :FB_FLOW_PAGE_ID )'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2107699460185433)
,p_name=>'Run app in new tab'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(219195822641587691)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2107753306185434)
,p_event_id=>wwv_flow_imp.id(2107699460185433)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.builder.launchAppOrPage( $v("P57_RUN_APP_URL") );'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2108008814185437)
,p_name=>'Run in new tab'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(219206202354754098)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2108119304185438)
,p_event_id=>wwv_flow_imp.id(2108008814185437)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.builder.launchAppOrPage( $v("P57_RUN_APP_URL") );'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2107819426185435)
,p_name=>'Run page in new tab'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(219204427854740565)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2107936613185436)
,p_event_id=>wwv_flow_imp.id(2107819426185435)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.builder.launchAppOrPage( $v("P57_RUN_PAGE_URL") );'
);
end;
/
prompt --application/pages/page_00058
begin
wwv_flow_imp_page.create_page(
 p_id=>58
,p_name=>'Tab History'
,p_alias=>'TAB-HISTORY'
,p_step_title=>'Tab History'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213240607818867991)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11161705304014192)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(5297709875)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(181024709573043764)
,p_plug_name=>'Tab History'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>This page displays recent modifications made to Tabs in this application.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193057010449179752)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P58a */',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.a object_type,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u,',
'  (select wwv_flow_lang.system_message(''F4000.STANDARD_TAB'') a from dual) t',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_TABS''',
'union',
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.a object_type,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u,',
'  (select wwv_flow_lang.system_message(''F4000.PARENT_TAB'') a from dual) t',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_TOPLEVEL_TABS'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(193057228298179754)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193057304306179756)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193057426610179757)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Audit Comment'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193057527702179757)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Component Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193057624193179758)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193057706916179759)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Component Key'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193057816404179760)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Audit Date'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193057902683179760)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193058025027179761)
,p_db_column_name=>'OBJECT_TYPE'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Object Type'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(193058123804179762)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1299018023536646'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'AUDIT_DATE:ACTION:DEVELOPER:OBJECT_TYPE:COMPONENT_NAME'
,p_sort_column_1=>'AUDIT_DATE'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(188937907290857066)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(193057010449179752)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:58:&SESSION.::&DEBUG.:58,RIR::'
);
end;
/
prompt --application/pages/page_00059
begin
wwv_flow_imp_page.create_page(
 p_id=>59
,p_name=>'Password Items'
,p_alias=>'PASSWORD-ITEMS'
,p_step_title=>'Password Items'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_inline_css=>' tr[class^=''rule''] a, tr[class*='' rule''] a{ color: #AE562C; }'
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_item.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(15594313642437577)
,p_plug_name=>'Password Items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>100
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    p.id                            page_id,',
'    p.name                          page_name,',
'    --',
'    i.name                          item_name,',
'    case i.is_persistent when ''N'' then m_yes else m_no end as dnss,',
'    decode(i.encrypt_session_state_yn,''Y'',m.m_yes,m.m_no) encrypt_state,',
'    decode(nvl(p.AUTOCOMPLETE_ON_OFF,''ON''),',
'       ''ON'',m_on,',
'       ''OFF'',m_off,',
'       p.AUTOCOMPLETE_ON_OFF) AUTOCOMPLETE_ON_OFF,',
'    decode(nvl(i.encrypt_session_state_yn,''N''),',
'      ''Y'',m.m_no,',
'      case i.is_persistent when ''N'' then m_no else m_yes end) at_risk,',
'    decode(nvl(i.encrypt_session_state_yn,''N''),',
'      ''Y'',''N'',',
'      case i.is_persistent when ''N'' then ''N'' else ''Y'' end) at_risk_code,',
'    --',
'    i.ITEM_SEQUENCE                 display_sequence,',
'    (select plug_name',
'     from wwv_flow_page_plugs',
'     where id = i.ITEM_PLUG_ID)     region,',
'    i.item_plug_id                  region_id,',
'    --',
'    decode(',
'      i.USE_CACHE_BEFORE_DEFAULT,',
'      ''NO'',''Always, replacing any existing value in session state'',',
'      ''YES'',''Only when current value in session state is null'',',
'      i.USE_CACHE_BEFORE_DEFAULT)   source_used,',
'    --',
'    i.PROMPT                        label,',
'    --',
'    i.csize                         item_element_width,',
'    i.cmaxlength                    item_element_max_length,',
'    --',
'    i.cattributes                   html_table_cell_attr_label,',
'    i.cattributes_element           html_table_cell_attr_element,',
'    i.tag_attributes                html_form_element_attributes,',
'    i.tag_attributes2               form_element_option_attributes,',
'    --',
'    (select max(help_text) h',
'    from wwv_flow_step_item_help',
'    where FLOW_ITEM_ID = i.id)      item_help_text,',
'    --',
'    nvl(i.LAST_UPDATED_BY,i.created_by) last_updated_by,',
'    nvl(i.LAST_UPDATED_ON,i.created_on) last_updated_on,',
'    i.ITEM_COMMENT                  component_comment,',
'    i.id                            item_id',
'from wwv_flow_step_items i,',
'     wwv_flow_steps p,',
'     wwv_flows f,',
'(select ',
'       wwv_flow_lang.system_message(''F4000.YES'') m_yes,',
'       wwv_flow_lang.system_message(''F4000.NO'') m_no,',
'       wwv_flow_lang.system_message(''F4000_ON'') m_on,',
'       wwv_flow_lang.system_message(''F4000_OFF'') m_off',
'from dual) m',
'where i.flow_step_id = p.id and',
'      i.flow_id = :fb_flow_id and',
'      i.display_as = ''NATIVE_PASSWORD'' and',
'      i.security_group_id = :flow_security_group_id and',
'      i.flow_id = f.id and',
'      p.flow_id = i.flow_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'%null%'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(15594407150437577)
,p_name=>'Password Items'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15594609499437593)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Page'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID:&FB_FLOW_ID.,#PAGE_ID#'
,p_column_linktext=>'#PAGE_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15594708763437594)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Page Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15594812585437594)
,p_db_column_name=>'ITEM_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Item Name'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE_ID##5120:#ITEM_ID#'
,p_column_linktext=>'#ITEM_NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(435149329052617533)
,p_db_column_name=>'DNSS'
,p_display_order=>4
,p_column_identifier=>'BO'
,p_column_label=>'Does not save state'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15600810076437607)
,p_db_column_name=>'ENCRYPT_STATE'
,p_display_order=>5
,p_column_identifier=>'BK'
,p_column_label=>'Encrypt State'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15604401317500135)
,p_db_column_name=>'AUTOCOMPLETE_ON_OFF'
,p_display_order=>6
,p_column_identifier=>'BL'
,p_column_label=>'Form Auto Complete'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15987703711740894)
,p_db_column_name=>'AT_RISK'
,p_display_order=>7
,p_column_identifier=>'BN'
,p_column_label=>'At Risk'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(65056799821493646)
,p_db_column_name=>'AT_RISK_CODE'
,p_display_order=>17
,p_column_identifier=>'BR'
,p_column_label=>'Is At Risk'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15595118041437594)
,p_db_column_name=>'DISPLAY_SEQUENCE'
,p_display_order=>27
,p_column_identifier=>'F'
,p_column_label=>'Display Sequence'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15595202595437594)
,p_db_column_name=>'REGION'
,p_display_order=>37
,p_column_identifier=>'G'
,p_column_label=>'Region'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15595324068437595)
,p_db_column_name=>'REGION_ID'
,p_display_order=>47
,p_column_identifier=>'H'
,p_column_label=>'Region ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15595410594437595)
,p_db_column_name=>'SOURCE_USED'
,p_display_order=>57
,p_column_identifier=>'I'
,p_column_label=>'Source Used'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15595702334437595)
,p_db_column_name=>'LABEL'
,p_display_order=>67
,p_column_identifier=>'L'
,p_column_label=>'Item Label'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15597922585437599)
,p_db_column_name=>'ITEM_ELEMENT_WIDTH'
,p_display_order=>77
,p_column_identifier=>'AH'
,p_column_label=>'Item Element Width'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15598029536437599)
,p_db_column_name=>'ITEM_ELEMENT_MAX_LENGTH'
,p_display_order=>87
,p_column_identifier=>'AI'
,p_column_label=>'Item Element Max Length'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15598231843437599)
,p_db_column_name=>'HTML_TABLE_CELL_ATTR_LABEL'
,p_display_order=>97
,p_column_identifier=>'AK'
,p_column_label=>'HTML Table Cell Attr Label'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15598304235437599)
,p_db_column_name=>'HTML_TABLE_CELL_ATTR_ELEMENT'
,p_display_order=>107
,p_column_identifier=>'AL'
,p_column_label=>'HTML Table Cell Attr Element'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15598405005437599)
,p_db_column_name=>'HTML_FORM_ELEMENT_ATTRIBUTES'
,p_display_order=>117
,p_column_identifier=>'AM'
,p_column_label=>'HTML Form Element Attributes'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15598528843437600)
,p_db_column_name=>'FORM_ELEMENT_OPTION_ATTRIBUTES'
,p_display_order=>127
,p_column_identifier=>'AN'
,p_column_label=>'Form Element Option Attributes'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15600300111437606)
,p_db_column_name=>'ITEM_HELP_TEXT'
,p_display_order=>137
,p_column_identifier=>'BF'
,p_column_label=>'Item Help Text'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15600417284437606)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>147
,p_column_identifier=>'BG'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15600510870437606)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>157
,p_column_identifier=>'BH'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15600606604437606)
,p_db_column_name=>'COMPONENT_COMMENT'
,p_display_order=>167
,p_column_identifier=>'BI'
,p_column_label=>'Component Comment'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15600707979437607)
,p_db_column_name=>'ITEM_ID'
,p_display_order=>177
,p_column_identifier=>'BJ'
,p_column_label=>'Item ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(15601005726444634)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1299104604536646'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'PAGE_ID:PAGE_NAME:ITEM_NAME:LABEL:DISPLAY_AS:REGION:DNSS:ENCRYPT_STATE:AUTOCOMPLETE_ON_OFF:AT_RISK:LAST_UPDATED_BY:LAST_UPDATED_ON'
,p_sort_column_1=>'PAGE_ID'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_worksheet_condition(
 p_id=>wwv_flow_imp.id(197919680625707063)
,p_report_id=>wwv_flow_imp.id(15601005726444634)
,p_name=>'#APXWS_COL_NAME#'
,p_condition_type=>'HIGHLIGHT'
,p_allow_delete=>'Y'
,p_column_name=>'AT_RISK_CODE'
,p_operator=>'='
,p_expr=>'Y'
,p_condition_sql=>' (case when ("AT_RISK_CODE" = #APXWS_EXPR#) then #APXWS_HL_ID# end) '
,p_condition_display=>'#APXWS_COL_NAME# = ''Y''  '
,p_enabled=>'Y'
,p_highlight_sequence=>10
,p_row_bg_color=>'#fdfdd8'
,p_row_font_color=>'#000000'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193992105890562275)
,p_plug_name=>'Password Items'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>130
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Oracle recommends that password item values be available in memory only and not save the session state. ',
'To set a password item to not save state, edit the item by clicking on the <strong>Item Name</strong> and ',
'set the <strong>Session State, Storage</strong> attribute to <strong>Per Request (Memory Only)</strong>.</p>',
'',
'<p>When password items require session state to be maintained between page views, ',
'Oracle recommends encrypting the item values. To encrypt item session state, edit ',
'the item and enable the <strong>Security, Store value encrypted in session state</strong> ',
'attribute.</p>',
'',
'<p>Oracle also recommends disabling HTML form auto completion on pages with ',
'passwords. To disable auto completion, edit the page attributes and set the ',
'<strong>Security, Form Auto Complete</strong> value to <strong>Off</strong>.</p>',
'',
'<p>At risk password items, are password items that save state and are not ',
'encrypted.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(194142516286108125)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>91
,p_list_id=>wwv_flow_imp.id(186703109122914661)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(194143519095109785)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(15594313642437577)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:59:&SESSION.::&DEBUG.:59,RIR::'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(15610405660614960)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'59'
,p_compute_when_type=>'%null%'
);
end;
/
prompt --application/pages/page_00060
begin
wwv_flow_imp_page.create_page(
 p_id=>60
,p_name=>'Region History'
,p_alias=>'REGION-HISTORY'
,p_step_title=>'Region History'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_region.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11230923648994087)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(13987931263515071)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(251125116349739079)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.page_id,',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_PAGE_PLUGS'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(251125321598739080)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251125404345739081)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251125530685739084)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Audit Comment'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251125604677739085)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Component Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251125713972739086)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251125807374739087)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Component Key'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251125908175739088)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Audit Date'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251126009952739089)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251320816875793842)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(251126125534739090)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1299205080536646'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'PAGE_ID:AUDIT_DATE:ACTION:DEVELOPER:COMPONENT_NAME'
,p_sort_column_1=>'AUDIT_DATE'
,p_sort_direction_1=>'DESC'
,p_sort_column_2=>'PAGE_ID'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(251184216534602929)
,p_plug_name=>'Region History'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page displays recent modifications made to the Regions on the current page.</p>',
'<p>Remove the filter to view the history of all Regions within the application.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(251126818212749073)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(251125116349739079)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:60:&SESSION.::&DEBUG.:60,RIR:IR_PAGE_ID:&FB_FLOW_PAGE_ID.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(167698628594577197)
,p_branch_action=>'f?p=&APP_ID.:60:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_00061
begin
wwv_flow_imp_page.create_page(
 p_id=>61
,p_name=>'Button History'
,p_alias=>'BUTTON-HISTORY'
,p_step_title=>'Button History'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_but.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11250130199119064)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(16353308133052510)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(251067602395902502)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.page_id,',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_STEP_BUTTONS'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(251067823788902504)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251067906850902510)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251068023048902511)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Audit Comment'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251068108648902512)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Component Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251068214077902513)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251068325640902514)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Component Key'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251068400511902516)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Audit Date'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251068521338902517)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251328025906023504)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(251068623408902518)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1299327579536646'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'PAGE_ID:AUDIT_DATE:ACTION:DEVELOPER:COMPONENT_NAME'
,p_sort_column_1=>'PAGE_ID'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'AUDIT_DATE'
,p_sort_direction_2=>'DESC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(251196212697724816)
,p_plug_name=>'Button History'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page displays recent modifications made to the Buttons on the current page.</p>',
'<p>Remove the filter to view the history of all Buttons within the application.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(251070604089950313)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(251067602395902502)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:61:&SESSION.::&DEBUG.:61,RIR:IR_PAGE_ID:&FB_FLOW_PAGE_ID.'
);
end;
/
prompt --application/pages/page_00062
begin
wwv_flow_imp_page.create_page(
 p_id=>62
,p_name=>'Page Item History'
,p_alias=>'PAGE-ITEM-HISTORY'
,p_step_title=>'Page Item History'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_item_pg_edit.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11258803150158506)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>90
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(186703109122914661)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(251083714600237140)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>123
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.page_id,',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_STEP_ITEMS'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'%null%'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(251083922869237142)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251084021126237144)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251084111017237146)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Audit Comment'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251084215727237148)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Component Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251084326234237149)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251084400768237151)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Component Key'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251084501340237152)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Audit Date'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251084613537237153)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251330321797050755)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(251084732448237155)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1299407049536646'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'PAGE_ID:AUDIT_DATE:ACTION:DEVELOPER:COMPONENT_NAME'
,p_sort_column_1=>'PAGE_ID'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'AUDIT_DATE'
,p_sort_direction_2=>'DESC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(251196704863731972)
,p_plug_name=>'Item History'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>33
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page displays recent modifications made to the Items on the current page.</p>',
'<p>Remove the filter to view the history of all page Items within the application.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(251083506289234786)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(251083714600237140)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:62:&SESSION.::&DEBUG.:62,RIR:IR_PAGE_ID:&FB_FLOW_PAGE_ID.'
);
end;
/
prompt --application/pages/page_00063
begin
wwv_flow_imp_page.create_page(
 p_id=>63
,p_name=>'Web Service Reference History'
,p_alias=>'WEB-SERVICE-REFERENCE-HISTORY'
,p_step_title=>'Web Service Reference History'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11279127625307557)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(11271810048283515)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(179888826044842771)
,p_plug_name=>'Web Service Reference History'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>This page displays recent modifications made to Web Service References in this application.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(192583611558792389)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P63a */',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_SHARED_WEB_SERVICES'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(192583809228792438)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192584114336792441)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192584230115792442)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Audit Comment'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192584412045792443)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Component Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192584514864792444)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192584718866792446)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Component Key'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192584825072792446)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Audit Date'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192584903390792447)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(192585023813792448)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1299517865536646'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'AUDIT_DATE:ACTION:DEVELOPER:COMPONENT_NAME'
,p_sort_column_1=>'AUDIT_DATE'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(188924515780197240)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(192583611558792389)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:63:&SESSION.::&DEBUG.:63,RIR::'
);
end;
/
prompt --application/pages/page_00064
begin
wwv_flow_imp_page.create_page(
 p_id=>64
,p_name=>'Branch History'
,p_alias=>'BRANCH-HISTORY'
,p_step_title=>'Branch History'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_branch.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11290925987363786)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(11286824340344465)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(251072023829955972)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.page_id,',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_STEP_BRANCHES'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(251072206714955974)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251316521498728929)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>1
,p_column_identifier=>'T'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251072815632955988)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>2
,p_column_identifier=>'R'
,p_column_label=>'Audit Date'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251072919356955989)
,p_db_column_name=>'ACTION'
,p_display_order=>3
,p_column_identifier=>'S'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251072610518955987)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>4
,p_column_identifier=>'N'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251072525258955986)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>5
,p_column_identifier=>'M'
,p_column_label=>'Component Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251072312666955983)
,p_db_column_name=>'SCN'
,p_display_order=>6
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251072728008955987)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>7
,p_column_identifier=>'Q'
,p_column_label=>'Component Key'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251072406606955985)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>8
,p_column_identifier=>'J'
,p_column_label=>'Audit Comment'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(251073007495955991)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1299630063536646'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'PAGE_ID:AUDIT_DATE:ACTION:DEVELOPER:COMPONENT_NAME'
,p_sort_column_1=>'PAGE_ID'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'AUDIT_DATE'
,p_sort_direction_2=>'DESC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(251198808681808820)
,p_plug_name=>'Branch History'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page displays recent modifications made to the Branches on the current page.</p>',
'<p>Remove the filter to view the history of all Branches within the application.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(251074330540967375)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(251072023829955972)
,p_button_name=>'RESET_REPORT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:64:&SESSION.::&DEBUG.:64,RIR:IR_PAGE_ID:&FB_FLOW_PAGE_ID.'
);
end;
/
prompt --application/pages/page_00065
begin
wwv_flow_imp_page.create_page(
 p_id=>65
,p_name=>'Page Process History'
,p_alias=>'PAGE-PROCESS-HISTORY'
,p_step_title=>'Page Process History'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_pg_procs.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11325624143505197)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>90
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(11322022496485821)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(251113915376568491)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>130
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.page_id,',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_STEP_PROCESSING'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(251114129067568492)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251114204969568493)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251114330502568494)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Audit Comment'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251114401813568495)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Component Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251114524341568496)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251114623341568497)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Component Key'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251114710670568498)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Audit Date'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251114817189568499)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251337601113101539)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(251114901003568500)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1299726939536646'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'PAGE_ID:AUDIT_DATE:ACTION:DEVELOPER:COMPONENT_NAME'
,p_sort_column_1=>'AUDIT_DATE'
,p_sort_direction_1=>'DESC'
,p_sort_column_2=>'PAGE_ID'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(251197331659749150)
,p_plug_name=>'Page Process History'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page displays recent modifications made to the Processes on the current page.</p>',
'<p>Remove the filter to view the history of all page Processes within the application.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(251113000831564363)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(251113915376568491)
,p_button_name=>'RESET_REPORT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:65:&SESSION.::&DEBUG.:65,RIR:IR_PAGE_ID:&FB_FLOW_PAGE_ID.'
);
end;
/
prompt --application/pages/page_00066
begin
wwv_flow_imp_page.create_page(
 p_id=>66
,p_name=>'Validation History'
,p_alias=>'VALIDATION-HISTORY'
,p_step_title=>'Validation History'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_validate.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11342006360566338)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(186826132498329280)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11350028439591610)
,p_plug_name=>'Validation History'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page displays recent modifications made to the Validations on the current page.</p>',
'<p>Remove the filter to view the history of all page Validations within the application.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(251105912728501492)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.page_id,',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_STEP_VALIDATIONS'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(251106109719501494)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251106208710501495)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251106306076501498)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Audit Comment'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251106400612501499)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Component Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251106518079501500)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251106615475501501)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Component Key'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251106730319501503)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Audit Date'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251106815383501503)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251339907954122409)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(251106927057501504)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1299808608536646'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'PAGE_ID:AUDIT_DATE:ACTION:DEVELOPER:COMPONENT_NAME'
,p_sort_column_1=>'AUDIT_DATE'
,p_sort_direction_1=>'DESC'
,p_sort_column_2=>'PAGE_ID'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(251108524633514468)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(251105912728501492)
,p_button_name=>'RESET_REPORT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:66:&SESSION.::&DEBUG.:66,RIR:IR_PAGE_ID:&FB_FLOW_PAGE_ID.'
);
end;
/
prompt --application/pages/page_00067
begin
wwv_flow_imp_page.create_page(
 p_id=>67
,p_name=>'Install Page'
,p_alias=>'INSTALL-PAGE'
,p_step_title=>'Install Page'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213300727323081712)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_install.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(19167458918031792)
,p_plug_name=>'Unable to Install Page'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>10
,p_plug_source=>'You are trying to import a page to an application that is not editable. Workspace Administrators can change the application status using Workspace Utilities.'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P67_INSTALL'
,p_plug_display_when_cond2=>'RUN_ONLY'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(38853522961187869)
,p_plug_name=>'import progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(37899301707472090)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44694318083706152)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(77700532331857019)
,p_plug_name=>'Install Page'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_plug_header=>'<p>When you install a page having the same ID as an existing page in the current application, the existing page is deleted and then the new page is installed.  This can only be done if the page is not locked. If all statements are successful the inst'
||'all commits and becomes permanent. If any errors are encountered, the install is rolled back, resulting in no permanent changes.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747137439162138152)
,p_plug_name=>'Install Page'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(77701720320857034)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(44694318083706152)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(77701419437857029)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(44694318083706152)
,p_button_name=>'INSTALL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Install Page'
,p_button_position=>'CREATE'
,p_button_condition=>'P67_INSTALL'
,p_button_condition2=>'Y'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(77713702027857087)
,p_branch_action=>'f?p=&APP_ID.:57:&SESSION.:PAGE:&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_IN_CONDITION'
,p_branch_condition=>'INSTALL:REPLACE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(77713131797857083)
,p_branch_action=>'f?p=&FLOW_ID.:48:&SESSION.:PAGE:&DEBUG.:::'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(77701419437857029)
,p_branch_sequence=>20
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_steps',
'where',
'flow_id = :P67_IMP_FLOW_ID',
'and security_group_id = :P67_LOGGED_IN_COMPANY',
'and id = :P67_IMP_PAGE_ID;'))
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(77702001982857036)
,p_name=>'P67_IMP_VERSION'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(77700532331857019)
,p_prompt=>'Imported Page Version'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies version number.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(77702329973857039)
,p_name=>'P67_FILE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(77700532331857019)
,p_use_cache_before_default=>'NO'
,p_prompt=>'File Id'
,p_source=>'P49_FILE_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(77702909494857041)
,p_name=>'P67_COMPANY_ACTION'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(77700532331857019)
,p_prompt=>'Imported Page Origin'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'P67_INSTALL'
,p_display_when2=>'RUN_ONLY'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'This attribute identifies the application page origin.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(77703805471857046)
,p_name=>'P67_LOGGED_IN_COMPANY'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(77700532331857019)
,p_source=>'&WORKSPACE_ID.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(77704415612857049)
,p_name=>'P67_IMP_FLOW_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(77700532331857019)
,p_prompt=>'Imported Page Application'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'If duplicate application ID is found in the current workspace, the existing application is deleted and then the new application is installed.  If duplicate application ID is found in different workspace an error is raised.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(77706512070857055)
,p_name=>'P67_IMP_COMPANY'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(77700532331857019)
,p_prompt=>'Imported Page Workspace ID'
,p_source=>'wwv_flow_imp_parser.get_security_group_id (p_file_id => :p67_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Imported file workspace ID.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(77707132064857056)
,p_name=>'P67_LOGGED_IN_COMPANY2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(77700532331857019)
,p_item_default=>'&COMPANY.'
,p_prompt=>'Logged Into Workspace'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies current workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(77707431676857057)
,p_name=>'P67_IMP_COMPANY2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(77700532331857019)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&COMPANY.'
,p_prompt=>'Imported Page Workspace'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'wwv_flow_imp_parser.get_security_group_id (p_file_id => :p67_file_id) = :flow_security_group_id'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the workspace the page was imported from.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(77818414153164103)
,p_name=>'P67_IMP_PAGE_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(77700532331857019)
,p_prompt=>'Imported Page ID'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'If duplicate page number is found in the current application, the existing page is deleted and then the new page is installed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(78155021058115358)
,p_name=>'P67_PARSE_AS'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(77700532331857019)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(176941429530050057)
,p_name=>'P67_INSTALL'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(77700532331857019)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(78155912878122370)
,p_computation_sequence=>10
,p_computation_item=>'P67_PARSE_AS'
,p_computation_type=>'QUERY'
,p_computation=>'select owner from wwv_flows where id = :FB_FLOW_ID and security_group_id = :P67_LOGGED_IN_COMPANY;'
,p_computation_error_message=>'Unable to compute item value.'
,p_compute_when=>'INSTALL:REPLACE'
,p_compute_when_type=>'REQUEST_IN_CONDITION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(486402582591334301)
,p_computation_sequence=>10
,p_computation_item=>'P67_IMP_FLOW_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_imp_parser.get_flow_id (p_file_id => :P49_FILE_ID)'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(8692400270855650)
,p_computation_sequence=>20
,p_computation_item=>'FB_FLOW_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P67_IMP_FLOW_ID'
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flows ',
' where id = :P67_IMP_FLOW_ID ',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID ',
'   and :FB_FLOW_ID is null'))
,p_compute_when_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(77709607606857063)
,p_validation_name=>'version must be compatible'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_runtime_version varchar2(200); -- the date of the current runtime flows',
'  l_calling_version varchar2(200);',
'begin',
'    l_calling_version := replace(replace(replace(wwv_flow_imp_parser.get_version (p_file_id => :p67_file_id),''.'',null),''_'',null),''/'',null);',
'    l_runtime_version := replace(replace(replace(wwv_flows_version,''.'',null),''_'',null),''/'',null);',
'',
'    if l_calling_version > l_runtime_version then',
'        --',
'        -- version incompatability        ',
'        --',
'        ',
'        return false;',
'    else',
'        return true;',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Not Compatible (Your import may contain calls not supported by your &PRODUCT_NAME. version.)'
,p_when_button_pressed=>wwv_flow_imp.id(77701419437857029)
,p_associated_item=>wwv_flow_imp.id(77702001982857036)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(77790404747057323)
,p_validation_name=>'valid import file'
,p_validation_sequence=>20
,p_validation=>'(:P67_IMP_COMPANY is not null) and (:P67_IMP_FLOW_ID is not null) and (:P67_IMP_PAGE_ID is not null)'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'File is not a valid &PRODUCT_NAME. import.'
,p_when_button_pressed=>wwv_flow_imp.id(77701419437857029)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(176934026705904699)
,p_validation_name=>'page export from same app'
,p_validation_sequence=>30
,p_validation=>'(:P67_IMP_FLOW_ID = :FB_FLOW_ID) and (:flow_security_group_id = wwv_flow_imp_parser.get_security_group_id(:p49_file_id))'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Page was not exported from this application or was exported from a different workspace.'
,p_when_button_pressed=>wwv_flow_imp.id(77701419437857029)
,p_associated_item=>wwv_flow_imp.id(77818414153164103)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1596644594608873)
,p_process_sequence=>30
,p_process_point=>'AFTER_FOOTER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Unset flow IDs'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':FB_FLOW_ID := null;',
':FB_FLOW_PAGE_ID := null;',
':F4000_P1_FLOW := null;',
':F4000_P1_PAGE := null;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id from wwv_flows ',
' where id = :FB_FLOW_ID ',
'   and build_status = ''RUN_ONLY''',
'   and security_group_id = :flow_security_group_id'))
,p_process_when_type=>'EXISTS'
,p_internal_uid=>1596644594608873
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(479780812892535082)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load Data'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_build_status wwv_flows.build_status%type;',
'begin',
'',
'    :P67_IMP_COMPANY := wwv_flow_imp_parser.get_security_group_id (p_file_id => :P49_FILE_ID);',
'    :P67_IMP_PAGE_ID := wwv_flow_imp_parser.get_page_id (p_file_id => :P49_FILE_ID);',
'    :P67_IMP_VERSION := wwv_flow_imp_parser.get_version (:P49_FILE_ID);',
'',
'    begin',
'      select build_status ',
'        into l_build_status from wwv_flows ',
'       where id = :FB_FLOW_ID',
'         and security_group_id = :WORKSPACE_ID;',
'    exception when no_data_found then',
'        :P67_INSTALL := ''N'';',
'    end;',
'',
'    if l_build_status = ''RUN_ONLY'' then',
'        -- cannot install page is app is not editable',
'        :P67_INSTALL := ''RUN_ONLY'';',
'    else ',
'        if     :WORKSPACE_ID    = :P67_IMP_COMPANY ',
'           and :P67_IMP_FLOW_ID = :FB_FLOW_ID then',
'            -- allow install page if from the same workspace app',
'            :P67_INSTALL := ''Y'';',
'            :P67_company_action := wwv_flow_lang.system_message(''F4000.P67.EXPORTED_FROM_CURRENT_WORKSPACE'');',
'        else',
'            :P67_INSTALL := ''N'';',
'            :P67_company_action := wwv_flow_lang.system_message(''F4000.P67.EXPORTED_FROM_ANOTHER_APP_OR_WORKSPACE'');',
'        end if;',
'    end if;',
'',
'    for c1 in (',
'        select locked_by',
'          from wwv_flow_steps p,',
'               WWV_FLOW_LOCK_PAGE l',
'         where p.flow_id = :P67_IMP_FLOW_ID',
'           and p.id      = :P67_IMP_PAGE_ID',
'           and p.flow_id = l.flow_id(+)',
'           and p.id      = l.object_id(+)',
'           and p.security_group_id = :flow_security_group_id )',
'        loop',
'           if c1.locked_by is not null then',
'              :P67_INSTALL := ''N'';',
'              :P67_company_action := ',
'                   wwv_flow_lang.system_message(''F4000.P67.PAGE_LOCKED'');',
'           end if;',
'    end loop;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>479780812892535082
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(77712212771857073)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'install page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'wwv_flow_imp_parser.parse (',
'     p_file_id          => :P67_FILE_ID,',
'     p_parse_as_schema  => :P67_PARSE_AS,',
'     p_install_as_flow  => :FB_FLOW_ID,',
'     p_original_flow_id => wwv_flow_imp_parser.get_flow_id(:P67_FILE_ID),',
'     p_adjust_offset    => false',
'     );',
':FB_FLOW_PAGE_ID := :P67_IMP_PAGE_ID;',
':F4000_P1_PAGE := :P67_IMP_PAGE_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error installing page.'
,p_process_when=>'INSTALL:REPLACE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'Page installed.'
,p_internal_uid=>77712212771857073
);
end;
/
prompt --application/pages/page_00069
begin
wwv_flow_imp_page.create_page(
 p_id=>69
,p_name=>'Applications Faceted Search'
,p_alias=>'APPLICATIONS-FACETED-SEARCH'
,p_step_title=>'Applications Faceted Search'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>'#showHideFacets { display: block; margin: 8px auto 16px auto;}'
,p_step_template=>wwv_flow_imp.id(438185046231548086)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'22'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(472529554367148622)
,p_plug_name=>'Filter by Facets'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source_type=>'NATIVE_FACETED_SEARCH'
,p_filtered_region_id=>wwv_flow_imp.id(900178488329740816)
,p_landmark_type=>'search'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'batch_facet_search', 'N',
  'current_facets_selector', '#active_facets',
  'show_charts', 'N',
  'show_current_facets', 'E',
  'show_total_row_count', 'N')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(900178488329740816)
,p_name=>'Applications'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--staticRowColors:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'app_id,',
'COMPATIBILITY_MODE,',
'theme,',
'authentication_scheme,',
'link,',
'app_name,',
'build_status,',
'last_updated_on,',
'page_count,',
'created,',
'groupname,',
'application_security_scheme,',
'logging,',
'page_protection_enabled_y_n,',
'flow_language',
'from (',
'    select',
'        f.id app_id,',
'        compatibility_mode,',
'        (select min(t.theme_name ||'' - '' || t.theme_id )',
'         from wwv_flow_themes t',
'        where t.flow_id  = f.id',
'          and t.theme_id = f.theme_id) theme,',
'        (select max(name)',
'           from wwv_flow_authentications a',
'          where a.id = f.authentication_id',
'        ) as authentication_scheme,',
'        decode(f.build_status,',
'          ''RUN_ONLY'',',
'          ''f?p=4000:733:''||:app_session||''::::FB_FLOW_ID:''||f.id,',
'          ''f?p=4000:1:''||:app_session||''::''||:debug||',
'               '':RP:FB_FLOW_ID,F4000_P1_FLOW,P0_FLOWPAGE,RECENT_PAGES:''||f.id||'',''||f.id||'',''||f.id',
'        ) link,',
'        f.name as app_name,',
'        decode(f.build_status,',
'          ''RUN_AND_BUILD'', sm.run_and_build,',
'          ''RUN_ONLY'',sm.run_only,',
'          f.build_status) build_status,',
'        f.last_updated_on,',
'        (select count(*)',
'          from wwv_flow_steps',
'          where flow_id = f.id)',
'          page_count,',
'        f.created_on created,',
'        decode(group_id,null,sm.t_unassigned,',
'            (select max(group_name) n',
'            from wwv_flow_application_groups',
'            where id = f.group_id))',
'          groupname,',
'        nvl((select max(name)',
'           from   wwv_flow_security_schemes',
'           where flow_id = f.id and to_char(id) = f.security_scheme),sm.apex_no_authorization_scheme)',
'           application_security_scheme,',
'        decode(f.webdb_logging,''YES'',sm.t_yes,''NO'',sm.t_no,f.webdb_logging) logging,',
'        decode(f.page_protection_enabled_y_n,',
'          ''Y'',sm.t_yes,',
'          ''N'',sm.t_no,',
'          sm.t_no)',
'          page_protection_enabled_y_n,',
'        decode(f.rejoin_existing_sessions,',
'          ''Y'',sm.t_yes,',
'          ''N'',sm.t_no,',
'          rejoin_existing_sessions)',
'          rejoin_existing_sessions,',
'        f.flow_language',
'    from   wwv_flow_visible_flows f,',
'          (select wwv_flow_lang.system_message(''RUN'') run,',
'                  wwv_flow_lang.system_message(''EDIT'') edit,',
'                  wwv_flow_lang.system_message(''RUN_ONLY'') run_only,',
'                  wwv_flow_lang.system_message(''F4000_F1500_LOCKED'') locked,',
'                  wwv_flow_lang.system_message(''RUN_AND_BUILD'') run_and_build,',
'                  wwv_flow_lang.system_message(''F4000.YES'') t_yes,',
'                  wwv_flow_lang.system_message(''F4000.NO'') t_no,',
'                  wwv_flow_lang.system_message(''Unassigned'') t_unassigned,',
'                  wwv_flow_lang.system_message(''AVAILABLE'') available,',
'                  wwv_flow_lang.system_message(''AVAILABLE_WITH_EDIT_LINKS'') available_with_edit_links,',
'                  wwv_flow_lang.system_message(''AVAILABLE_TO_DEVELOPERS_ONLY'') available_to_developers_only,',
'                  wwv_flow_lang.system_message(''RESTRICTED_ACCESS'') restricted_access,',
'                  wwv_flow_lang.system_message(''UNAVAILABLE_STATUS_SHOWN_WITH_PLSQL'') unavailable_plsql,',
'                  wwv_flow_lang.system_message(''UNAVAILABLE_REDIRECT_TO_URL'') unavailable_redirect_to_url,                                        ',
'                  wwv_flow_lang.system_message(''NO_AUTHORIZATION_SCHEME'') apex_no_authorization_scheme,',
'                  wwv_flow_lang.system_message(''UNAVAILABLE'') unavailable',
'           from dual) sm',
')'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>50
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'no data found'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>100000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_prn_format=>'PDF'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(395888387250084641)
,p_query_column_id=>1
,p_column_alias=>'APP_ID'
,p_column_display_sequence=>1
,p_column_heading=>'App ID'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(472530996849148636)
,p_query_column_id=>2
,p_column_alias=>'COMPATIBILITY_MODE'
,p_column_display_sequence=>31
,p_column_heading=>'Compatibility'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(472531227396148639)
,p_query_column_id=>3
,p_column_alias=>'THEME'
,p_column_display_sequence=>41
,p_column_heading=>'Theme'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(395888573290084643)
,p_query_column_id=>4
,p_column_alias=>'AUTHENTICATION_SCHEME'
,p_column_display_sequence=>11
,p_column_heading=>'Authentication Scheme'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(395888679917084644)
,p_query_column_id=>5
,p_column_alias=>'LINK'
,p_column_display_sequence=>51
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(395888856174084646)
,p_query_column_id=>6
,p_column_alias=>'APP_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'App Name'
,p_use_as_row_header=>'N'
,p_column_link=>'#LINK#'
,p_column_linktext=>'#APP_NAME#'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(472527576117148602)
,p_query_column_id=>7
,p_column_alias=>'BUILD_STATUS'
,p_column_display_sequence=>17
,p_column_heading=>'Build Status'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(472527744149148604)
,p_query_column_id=>8
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>21
,p_column_heading=>'Last Updated'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(472527814194148605)
,p_query_column_id=>9
,p_column_alias=>'PAGE_COUNT'
,p_column_display_sequence=>4
,p_column_heading=>'Pages'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(472528005208148607)
,p_query_column_id=>10
,p_column_alias=>'CREATED'
,p_column_display_sequence=>20
,p_column_heading=>'Created'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(472528396835148610)
,p_query_column_id=>11
,p_column_alias=>'GROUPNAME'
,p_column_display_sequence=>61
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(472528491819148611)
,p_query_column_id=>12
,p_column_alias=>'APPLICATION_SECURITY_SCHEME'
,p_column_display_sequence=>71
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(472528535173148612)
,p_query_column_id=>13
,p_column_alias=>'LOGGING'
,p_column_display_sequence=>81
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(472528803860148615)
,p_query_column_id=>14
,p_column_alias=>'PAGE_PROTECTION_ENABLED_Y_N'
,p_column_display_sequence=>91
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(472529035122148617)
,p_query_column_id=>15
,p_column_alias=>'FLOW_LANGUAGE'
,p_column_display_sequence=>101
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(971848600399010722)
,p_plug_name=>'Facets Header'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--slimPadding:a-ButtonRegion--noBorder'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<div id="active_facets"></div>'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(472527011036145986)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(971848600399010722)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'Reset'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:69:&SESSION.::&DEBUG.:RR,69::'
,p_icon_css_classes=>'icon-undo'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(472529694774148623)
,p_name=>'P69_SEARCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(472529554367148622)
,p_prompt=>'Filter by text'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_SEARCH'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ROW'
,p_attribute_02=>'FACET'
,p_fc_show_chart=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(472529743229148624)
,p_name=>'P69_AUTHENTICATION_SCHEME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(472529554367148622)
,p_prompt=>'Authentication'
,p_source=>'AUTHENTICATION_SCHEME'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov_sort_direction=>'ASC'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>8
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(472529939157148626)
,p_name=>'P69_BUILD_STATUS'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(472529554367148622)
,p_prompt=>'Build Status'
,p_source=>'BUILD_STATUS'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov_sort_direction=>'ASC'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>true
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>5
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(472530040461148627)
,p_name=>'P69_FLOW_LANGUAGE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(472529554367148622)
,p_prompt=>'Language'
,p_source=>'FLOW_LANGUAGE'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov_sort_direction=>'ASC'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>true
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>8
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(472530153075148628)
,p_name=>'P69_LOGGING'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(472529554367148622)
,p_prompt=>'Logging'
,p_source=>'LOGGING'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov_sort_direction=>'ASC'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>true
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>5
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(472530249147148629)
,p_name=>'P69_APP_SECURITY_SCHEME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(472529554367148622)
,p_prompt=>'Security Scheme'
,p_source=>'APPLICATION_SECURITY_SCHEME'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov_sort_direction=>'ASC'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>true
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>8
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(472530716214148634)
,p_name=>'P69_PAGE_COUNT'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(472529554367148622)
,p_prompt=>'Pages'
,p_source=>'PAGE_COUNT'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_RANGE'
,p_lov=>'STATIC2:1 to 10;|11,11 - 50;11|51,51 - 100;51|101,101 - 200;101|201,> 200;201|'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'D'
,p_fc_show_more_count=>100
,p_fc_filter_values=>false
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(472530896423148635)
,p_name=>'P69_GROUPNAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(472529554367148622)
,p_prompt=>'Group'
,p_source=>'GROUPNAME'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov_sort_direction=>'ASC'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>true
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>8
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(472531042786148637)
,p_name=>'P69_COMPATIBILITY_MODE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(472529554367148622)
,p_prompt=>'Compatibility'
,p_source=>'COMPATIBILITY_MODE'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov_sort_direction=>'ASC'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>true
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>5
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(472531164541148638)
,p_name=>'P69_PAGE_PROTECTION_ENABLED_Y_N'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(472529554367148622)
,p_prompt=>'Session State Protection'
,p_source=>'PAGE_PROTECTION_ENABLED_Y_N'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov_sort_direction=>'ASC'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>true
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>8
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(472531318995148640)
,p_name=>'P69_THEME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(472529554367148622)
,p_prompt=>'Theme'
,p_source=>'THEME'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov_sort_direction=>'ASC'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>true
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>8
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>false
);
end;
/
prompt --application/pages/page_00070
begin
wwv_flow_imp_page.create_page(
 p_id=>70
,p_name=>'Customized Regions'
,p_alias=>'CUSTOMIZED-REGIONS'
,p_step_title=>'Customized Regions'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213220627333807318)
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_region.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193875214737578082)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>91
,p_list_id=>wwv_flow_imp.id(13987931263515071)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193881218370698706)
,p_plug_name=>'Customized Regions'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>100
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<a href="''',
'        ||htmldb_util.prepare_url(''f?p=4000:4500:''||:flow_session||''::::FB_FLOW_PAGE_ID:''',
'            ||wwv_flow_escape.html(page_id))',
'        ||''">''||wwv_flow_escape.html(page_id)||''</a>'' PAGE_ID, ',
'    ''<a href="''||htmldb_util.prepare_url(''f?p=4000:4500:''||:flow_session',
'        ||'':::4500:FB_FLOW_PAGE_ID:''||wwv_flow_escape.html(page_id))||''#5110:'' || wwv_flow_escape.html(id) || ''">''',
'        ||wwv_flow_escape.html(PLUG_NAME)||''</a>''',
'    region_name, ',
'    PLUG_DISPLAY_SEQUENCE, ',
'    PLUG_DISPLAY_COLUMN,',
'    PLUG_CUSTOMIZED,',
'    PLUG_CUSTOMIZED_NAME cn,',
'    LAST_UPDATED_BY, LAST_UPDATED_ON',
'from WWV_FLOW_PAGE_PLUGS',
'where flow_id = :fb_flow_id and',
'      plug_customized is not null and',
'      plug_customized > ''0'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(193881326920698706)
,p_name=>'Customized Regions'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193881520087698709)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Page'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193881612946698710)
,p_db_column_name=>'REGION_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Region'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193881703189698711)
,p_db_column_name=>'PLUG_DISPLAY_SEQUENCE'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Sequence'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193881803257698712)
,p_db_column_name=>'PLUG_DISPLAY_COLUMN'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Column'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193881903887698713)
,p_db_column_name=>'PLUG_CUSTOMIZED'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Customized'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193882008321698713)
,p_db_column_name=>'CN'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Customization Name'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193882116954698714)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193882218927698715)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Date'
,p_column_type=>'DATE'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(193882514709701058)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1299903483536646'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'PAGE_ID:REGION_NAME:PLUG_DISPLAY_SEQUENCE:PLUG_DISPLAY_COLUMN:PLUG_CUSTOMIZED:CN:LAST_UPDATED_BY:LAST_UPDATED_ON'
,p_sort_column_1=>'PAGE_ID'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'PLUG_DISPLAY_COLUMN'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'PLUG_DISPLAY_SEQUENCE'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(193878809552652309)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(193881218370698706)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:70:&SESSION.::&DEBUG.:70,RIR::'
);
end;
/
prompt --application/pages/page_00071
begin
wwv_flow_imp_page.create_page(
 p_id=>71
,p_name=>'Application Dashboard'
,p_alias=>'APPLICATION-DASHBOARD'
,p_step_title=>'Application Dashboard'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213220627333807318)
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery(''#pagesbytype .rc-content-bin'').css(''height'',''300px'');',
'apex.jQuery(''#applicationcomponents .rc-content-bin'').css(''height'',''300px'');',
'apex.jQuery(''#pagecomponents .rc-content-bin'').css(''height'',''300px'');'))
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_utilties.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(47933510325044189)
,p_name=>'Page Components'
,p_region_name=>'pagecomponents'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>60
,p_region_css_classes=>'h340'
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'  n n,',
'  ''<a href="f?p=4000:''||wwv_flow_escape.html(p)||'':''||:app_session||''">''||',
'    to_char(wwv_flow_escape.html(c),''999G999G999G999G990'')||''</a>'' v,',
'  c',
'from ',
'(',
'select wwv_flow_lang.system_message(''BUTTONS'')  n, count(*) c, 548 p',
'from wwv_flow_step_buttons where flow_id = :fb_flow_id',
'union all',
'select wwv_flow_lang.system_message(''REGIONS'')  n, count(*) c, 249 p',
'from wwv_flow_page_plugs where flow_id = :fb_flow_id',
'union all',
'select wwv_flow_lang.system_message(''ITEMS'')  n, count(*) c, 547 p ',
'from wwv_flow_step_items where flow_id = :fb_flow_id',
'union all',
'select wwv_flow_lang.system_message(''BRANCHES'')  n, count(*) c, 563 p ',
'from wwv_flow_step_branches where flow_id = :fb_flow_id',
'union all',
'select wwv_flow_lang.system_message(''PROCESSES'')  n, count(*) c, 552 p',
'from WWV_FLOW_STEP_PROCESSING where flow_id = :fb_flow_id',
'union all',
'select wwv_flow_lang.system_message(''DYNAMIC ACTIONS'') n, count(*) c, 699 p',
'from wwv_flow_page_da_events where flow_id = :fb_flow_id',
'union all',
'select wwv_flow_lang.system_message(''CLASSIC_REPORT_COLUMNS'')  n, count(*) c, 217 p',
'from wwv_flow_region_report_column where flow_id = :fb_flow_id',
'union all',
'select wwv_flow_lang.system_message(''IR_COLUMNS'') n, count(*) c, 690 p',
'from wwv_flow_worksheet_columns where flow_id = :fb_flow_id',
'union all',
'select wwv_flow_lang.system_message(''COMPUTATIONS'') n, count(*) c, 549 p',
'from wwv_flow_step_computations where flow_id = :fb_flow_id',
') x',
'order by 3 desc'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(1041646592238406593)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>9
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'no data found'
,p_query_row_count_max=>9
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(47933510325044189)
,p_plug_column_width=>'apex-col--bottomBorder apex-col--leftBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47933811156044203)
,p_query_column_id=>1
,p_column_alias=>'N'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47933914604044205)
,p_query_column_id=>2
,p_column_alias=>'V'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47934330757050138)
,p_query_column_id=>3
,p_column_alias=>'C'
,p_column_display_sequence=>3
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(47934922755095158)
,p_name=>'Application Components'
,p_region_name=>'applicationcomponents'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>50
,p_region_css_classes=>'h340'
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'  n n,',
'  ''<a href="f?p=4000:''||wwv_flow_escape.html(p)||'':''||:app_session||''">''||',
'    to_char(wwv_flow_escape.html(c),''999G999G999G999G990'')||''</a>'' v,',
'  c',
'from ',
'(',
'select wwv_flow_lang.system_message(''LAYOUT.T_LISTS'') n, count(*) c, 405  p',
'from wwv_flow_lists where flow_id = :fb_flow_id',
'and security_group_id = :flow_security_group_id',
'union all',
'select wwv_flow_lang.system_message(''SHORTCUTS'') n, count(*) c, 4047  p',
'from wwv_flow_shortcuts where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'union all',
'select wwv_flow_lang.system_message(''LAYOUT.T_LOV'') n, count(*) c, 4110 p',
'from WWV_FLOW_LISTS_OF_VALUES$ where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'union all',
'select wwv_flow_lang.system_message(''LAYOUT.T_ALT_STD_TAB'') n, count(*)  c, 9000  p',
'from wwv_flow_tabs where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'union all',
'select wwv_flow_lang.system_message(''APPLICACTION_PROCESS'') n, count(*) c, 4207 p',
'from wwv_flow_processing where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'union all',
'select wwv_flow_lang.system_message(''APPLICACTION_COMPUTATIONS'') n, count(*) c, 4101 p',
'from wwv_flow_computations where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'union all',
'select wwv_flow_lang.system_message(''APPLICATION_ITEMS'') n, count(*) c, 4100 p',
'from wwv_flow_items where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'union all',
'select wwv_flow_lang.system_message(''BUILDER.PLUGINS'') n, count(*) c, 4400 p',
'from wwv_flow_plugins where flow_id = :fb_flow_id',
'and security_group_id = :flow_security_group_id',
') x',
'order by 3 desc'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(1041646592238406593)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>9
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'no data found'
,p_query_row_count_max=>9
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(47934922755095158)
,p_plug_column_width=>'apex-col--bottomBorder apex-col--leftBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47935313339095159)
,p_query_column_id=>1
,p_column_alias=>'N'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47935132457095159)
,p_query_column_id=>2
,p_column_alias=>'V'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47935200415095159)
,p_query_column_id=>3
,p_column_alias=>'C'
,p_column_display_sequence=>3
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(47936724757190349)
,p_name=>'Pages by Type'
,p_region_name=>'pagesbytype'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>40
,p_region_css_classes=>'h340'
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select p.page_type,',
'       count(*) c',
'  from wwv_flow_pages_dev p',
' where p.flow_id           = :FB_FLOW_ID',
'   and p.security_group_id = :FLOW_SECURITY_GROUP_ID',
' group by p.page_type',
' order by 2 desc'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(1041646592238406593)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>9
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'no data found'
,p_query_row_count_max=>9
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(47936724757190349)
,p_plug_column_width=>'apex-col--bottomBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47938028567191395)
,p_query_column_id=>1
,p_column_alias=>'PAGE_TYPE'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47937009479190352)
,p_query_column_id=>2
,p_column_alias=>'C'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(47938203333212486)
,p_name=>'Application Overview'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>10
,p_region_css_classes=>'h340'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--shadowScroll:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       alias,',
'       name,',
'       trim(to_char((',
'         select count(*) from wwv_flow_steps where flow_id = f.id),',
'         ''999G999G990'')) pages,',
'       owner parsing_schema,',
'       (select group_name',
'        from WWV_FLOW_APPLICATION_GROUPS g ',
'        where g.id = f.group_id) application_group',
'from wwv_flows f',
'where id = :fb_flow_id and security_group_id = :flow_security_group_id'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(1041645860037406591)
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'no data found'
,p_query_row_count_max=>7
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47938718571216899)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47941804765241333)
,p_query_column_id=>2
,p_column_alias=>'ALIAS'
,p_column_display_sequence=>4
,p_column_heading=>'Alias'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47938831927216900)
,p_query_column_id=>3
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47941514677234658)
,p_query_column_id=>4
,p_column_alias=>'PAGES'
,p_column_display_sequence=>6
,p_column_heading=>'Pages'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47942302127262422)
,p_query_column_id=>5
,p_column_alias=>'PARSING_SCHEMA'
,p_column_display_sequence=>3
,p_column_heading=>'Parsing Schema'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47943602004316184)
,p_query_column_id=>6
,p_column_alias=>'APPLICATION_GROUP'
,p_column_display_sequence=>5
,p_column_heading=>'Group'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(47944910793328206)
,p_name=>'Security'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>20
,p_region_css_classes=>'h340'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--shadowScroll:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'       (select a.name',
'          from wwv_flow_authentications a',
'         where a.id                = f.authentication_id',
'           and a.security_group_id = f.security_group_id ) application_authentication,',
'       (select count(*) ',
'        from wwv_flow_steps p',
'        where p.flow_id = f.id and nvl(PAGE_IS_PUBLIC_Y_N,''N'') = ''Y'') ',
'        public_pages,',
'       (select count(*) ',
'        from wwv_flow_steps p',
'        where p.flow_id = f.id and nvl(PAGE_IS_PUBLIC_Y_N,''N'') = ''N'') ',
'        pages_requiring_authentication,',
'       (select count(*) ',
'        from WWV_FLOW_SECURITY_SCHEMES s',
'        where s.flow_id = f.id) authorization_schemes',
'',
'from wwv_flows f',
'where id = :fb_flow_id and security_group_id = :flow_security_group_id'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(1041645860037406591)
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'no data found'
,p_query_row_count_max=>7
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(47944910793328206)
,p_plug_column_width=>'apex-col--leftBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47946627546342517)
,p_query_column_id=>1
,p_column_alias=>'APPLICATION_AUTHENTICATION'
,p_column_display_sequence=>1
,p_column_heading=>'Authentication'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47946723201342517)
,p_query_column_id=>2
,p_column_alias=>'PUBLIC_PAGES'
,p_column_display_sequence=>2
,p_column_heading=>'Public Pages'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47946810958342518)
,p_query_column_id=>3
,p_column_alias=>'PAGES_REQUIRING_AUTHENTICATION'
,p_column_display_sequence=>3
,p_column_heading=>'Non Public'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47947111878356845)
,p_query_column_id=>4
,p_column_alias=>'AUTHORIZATION_SCHEMES'
,p_column_display_sequence=>4
,p_column_heading=>'Authorization Schemes'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(84541872937706844)
,p_plug_name=>'Plugin Region Utilization'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>119
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(',
'           trim(substr(plug_source_type,8)),',
'           ''STATIC'', wwv_flow_lang.system_message(''STATIC_REGION''),',
'           ''LIST'', wwv_flow_lang.system_message(''LIST_REGION''),',
'           ''SQL_REPORT'', wwv_flow_lang.system_message(''CLASSIC_REPORT''),',
'           ''IR'', wwv_flow_lang.system_message(''INTERACTIVE_REPORT''),',
'           ''IG'', wwv_flow_lang.system_message(''INTERACTIVE_GRID''),',
'           ''DISPLAY_SELECTOR'', wwv_flow_lang.system_message(''REGION_DISPLAY_SELECTOR''),',
'           ''TABFORM'', wwv_flow_lang.system_message(''TABULAR_FORM''),',
'           ''JET_CHART'', wwv_flow_lang.system_message(''JET_CHART''),',
'           ''JSTREE'', wwv_flow_lang.system_message(''JSTREE''),',
'           ''BREADCRUMB'', wwv_flow_lang.system_message(''BREADCRUMB_REGION''),',
'           ''CSS_CALENDAR'', wwv_flow_lang.system_message(''CSS_CALENDAR''),',
'           ''CALENDAR'', wwv_flow_lang.system_message(''CLASSIC_CALENDAR''),',
'           ''TREE'', wwv_flow_lang.system_message(''CLASSIC_TREE''),',
'           ''HELP_TEXT'', wwv_flow_lang.system_message(''HELP_TEXT''),',
'           ''JQM_COLUMN_TOGGLE'', wwv_flow_lang.system_message(''JQM COLUMN TOGGLE''),',
'           ''JQM_REFLOW'', wwv_flow_lang.system_message(''JQM REFLOW''),',
'           ''SVG_CHART'', wwv_flow_lang.system_message(''SVG CHART''),',
'           ''SIMPLE_CHART'', wwv_flow_lang.system_message(''SIMPLE_CHART''),',
'           ''PLSQL'', wwv_flow_lang.system_message(''PLSQL_REGION''),',
'           ''DATA_UPLOAD_COLUMN_MAPPING'',wwv_flow_lang.system_message(''DATA_UPLOAD_COLUMN_MAPPING''),',
'           ''JQM_LIST_VIEW'',wwv_flow_lang.system_message(''JQM_LIST_VIEW''),',
'           replace(substr(plug_source_type,8),''_'','' ''))',
'           region_type, ',
'       count(*) region_type_count',
'from  wwv_flow_page_plugs r',
'where plug_source_type not like ''PLUGIN%'' and ',
'      security_group_id = :flow_security_group_id and ',
'      flow_id = :FB_FLOW_ID',
'group by substr(plug_source_type,8)'))
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_num_rows=>15
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(84541920403706845)
,p_region_id=>wwv_flow_imp.id(84541872937706844)
,p_chart_type=>'bar'
,p_animation_on_display=>'none'
,p_animation_on_data_change=>'none'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'none'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'value-desc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(84542085397706846)
,p_chart_id=>wwv_flow_imp.id(84541920403706845)
,p_seq=>10
,p_name=>'Components'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select replace(substr(plug_source_type,12),''_'','' '') region_type, ',
'       count(*) region_type_count',
'from  wwv_flow_page_plugs r',
'where plug_source_type  like ''PLUGIN%'' and ',
'      security_group_id = :flow_security_group_id and ',
'      flow_id = :FB_FLOW_ID',
'group by substr(plug_source_type,12)',
'order by 2 desc'))
,p_items_value_column_name=>'REGION_TYPE_COUNT'
,p_items_label_column_name=>'REGION_TYPE'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(84542170092706847)
,p_chart_id=>wwv_flow_imp.id(84541920403706845)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(84542213584706848)
,p_chart_id=>wwv_flow_imp.id(84541920403706845)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(632975865957652814)
,p_name=>'Templates'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>35
,p_region_css_classes=>'h340'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--shadowScroll:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select p name,',
'    c',
'from (  select count(*) c, wwv_flow_lang.system_message_lit(''F4000.BUTTON'') p',
'        from wwv_flow_button_templates where flow_id = :FB_FLOW_ID',
'        union all',
'        select count(*) c, wwv_flow_lang.system_message_lit(''LABEL'') p',
'        from wwv_flow_field_templates where flow_id = :FB_FLOW_ID',
'        union all',
'        select count(*) c, wwv_flow_lang.system_message_lit(''F4000.LIST_INITCAP'') p',
'        from wwv_flow_list_templates where flow_id = :FB_FLOW_ID',
'        union all',
'        select count(*) c, wwv_flow_lang.system_message_lit(''F4000.PAGE'') p',
'        from wwv_flow_templates where flow_id = :FB_FLOW_ID',
'        union all',
'        select count(*) c, wwv_flow_lang.system_message_lit(''F4000.REGION'') p',
'        from wwv_flow_page_plug_templates where flow_id = :FB_FLOW_ID',
'        union all',
'        select count(*) c, wwv_flow_lang.system_message_lit(''F4000.P371.POPUP_LOV'') p',
'        from wwv_flow_popup_lov_template where flow_id = :FB_FLOW_ID',
'        union all',
'        select count(*) c, wwv_flow_lang.system_message_lit(''REPORT'') p',
'        from wwv_flow_row_templates where flow_id = :FB_FLOW_ID',
'        union all',
'        select count(*) c, wwv_flow_lang.system_message_lit(''LEGACY_CALENDAR'') p',
'        from wwv_flow_cal_templates where flow_id = :FB_FLOW_ID',
'        union all',
'        select count(*) c, wwv_flow_lang.system_message_lit(''BREADCRUMB'') p',
'        from wwv_flow_menu_templates where flow_id = :FB_FLOW_ID',
')',
'order by c desc, p'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(1041646592238406593)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>9
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'no data found'
,p_query_row_count_max=>9
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(632975865957652814)
,p_plug_column_width=>'apex-col--leftBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(632976679950666980)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(632976273620652819)
,p_query_column_id=>2
,p_column_alias=>'C'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.:RIR,4003:IR_T:#NAME#'
,p_column_linktext=>'#C#'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3348608641169757722)
,p_plug_name=>'Native Region Component Utilization'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>109
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(',
'           trim(substr(plug_source_type,8)),',
'           ''STATIC'', wwv_flow_lang.system_message(''STATIC_REGION''),',
'           ''LIST'', wwv_flow_lang.system_message(''LIST_REGION''),',
'           ''SQL_REPORT'', wwv_flow_lang.system_message(''CLASSIC_REPORT''),',
'           ''IR'', wwv_flow_lang.system_message(''INTERACTIVE_REPORT''),',
'           ''IG'', wwv_flow_lang.system_message(''INTERACTIVE_GRID''),',
'           ''DISPLAY_SELECTOR'', wwv_flow_lang.system_message(''REGION_DISPLAY_SELECTOR''),',
'           ''TABFORM'', wwv_flow_lang.system_message(''TABULAR_FORM''),',
'           ''JET_CHART'', wwv_flow_lang.system_message(''JET_CHART''),',
'           ''JSTREE'', wwv_flow_lang.system_message(''JSTREE''),',
'           ''BREADCRUMB'', wwv_flow_lang.system_message(''BREADCRUMB_REGION''),',
'           ''CSS_CALENDAR'', wwv_flow_lang.system_message(''CSS_CALENDAR''),',
'           ''CALENDAR'', wwv_flow_lang.system_message(''CLASSIC_CALENDAR''),',
'           ''TREE'', wwv_flow_lang.system_message(''CLASSIC_TREE''),',
'           ''HELP_TEXT'', wwv_flow_lang.system_message(''HELP_TEXT''),',
'           ''JQM_COLUMN_TOGGLE'', wwv_flow_lang.system_message(''JQM COLUMN TOGGLE''),',
'           ''JQM_REFLOW'', wwv_flow_lang.system_message(''JQM REFLOW''),',
'           ''SVG_CHART'', wwv_flow_lang.system_message(''SVG CHART''),',
'           ''SIMPLE_CHART'', wwv_flow_lang.system_message(''SIMPLE_CHART''),',
'           ''PLSQL'', wwv_flow_lang.system_message(''PLSQL_REGION''),',
'           ''DATA_UPLOAD_COLUMN_MAPPING'',wwv_flow_lang.system_message(''DATA_UPLOAD_COLUMN_MAPPING''),',
'           ''JQM_LIST_VIEW'',wwv_flow_lang.system_message(''JQM_LIST_VIEW''),',
'           ''FACETED_SEARCH'',wwv_flow_lang.system_message(''FACETED_SEARCH''),',
'           replace(substr(plug_source_type,8),''_'','' ''))',
'           region_type, ',
'       count(*) region_type_count',
'from  wwv_flow_page_plugs r',
'where plug_source_type not like ''PLUGIN%'' and ',
'      security_group_id = :flow_security_group_id and ',
'      flow_id = :FB_FLOW_ID',
'group by substr(plug_source_type,8)'))
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_num_rows=>15
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(3348608791771757723)
,p_region_id=>wwv_flow_imp.id(3348608641169757722)
,p_chart_type=>'bar'
,p_animation_on_display=>'none'
,p_animation_on_data_change=>'none'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'none'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'value-desc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(3348608870920757724)
,p_chart_id=>wwv_flow_imp.id(3348608791771757723)
,p_seq=>10
,p_name=>'Components'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(',
'           trim(substr(plug_source_type,8)),',
'           ''STATIC'', wwv_flow_lang.system_message(''STATIC_REGION''),',
'           ''LIST'', wwv_flow_lang.system_message(''LIST_REGION''),',
'           ''SQL_REPORT'', wwv_flow_lang.system_message(''CLASSIC_REPORT''),',
'           ''IR'', wwv_flow_lang.system_message(''INTERACTIVE_REPORT''),',
'           ''IG'', wwv_flow_lang.system_message(''INTERACTIVE_GRID''),',
'           ''DISPLAY_SELECTOR'', wwv_flow_lang.system_message(''REGION_DISPLAY_SELECTOR''),',
'           ''TABFORM'', wwv_flow_lang.system_message(''TABULAR_FORM''),',
'           ''JET_CHART'', wwv_flow_lang.system_message(''JET_CHART''),',
'           ''JSTREE'', wwv_flow_lang.system_message(''JSTREE''),',
'           ''BREADCRUMB'', wwv_flow_lang.system_message(''BREADCRUMB_REGION''),',
'           ''CSS_CALENDAR'', wwv_flow_lang.system_message(''CSS_CALENDAR''),',
'           ''CALENDAR'', wwv_flow_lang.system_message(''CLASSIC_CALENDAR''),',
'           ''TREE'', wwv_flow_lang.system_message(''CLASSIC_TREE''),',
'           ''HELP_TEXT'', wwv_flow_lang.system_message(''HELP_TEXT''),',
'           ''JQM_COLUMN_TOGGLE'', wwv_flow_lang.system_message(''JQM COLUMN TOGGLE''),',
'           ''JQM_REFLOW'', wwv_flow_lang.system_message(''JQM REFLOW''),',
'           ''SVG_CHART'', wwv_flow_lang.system_message(''SVG CHART''),',
'           ''SIMPLE_CHART'', wwv_flow_lang.system_message(''SIMPLE_CHART''),',
'           ''PLSQL'', wwv_flow_lang.system_message(''PLSQL_REGION''),',
'           ''DATA_UPLOAD_COLUMN_MAPPING'',wwv_flow_lang.system_message(''DATA_UPLOAD_COLUMN_MAPPING''),',
'           ''JQM_LIST_VIEW'',wwv_flow_lang.system_message(''JQM_LIST_VIEW''),',
'           ''FACETED_SEARCH'',wwv_flow_lang.system_message(''FACETED_SEARCH''),',
'           replace(substr(plug_source_type,8),''_'','' ''))',
'           region_type, ',
'       count(*) region_type_count',
'from  wwv_flow_page_plugs r',
'where plug_source_type not like ''PLUGIN%'' and ',
'      security_group_id = :flow_security_group_id and ',
'      flow_id = :FB_FLOW_ID',
'group by substr(plug_source_type,8)',
'order by 2 desc'))
,p_items_value_column_name=>'REGION_TYPE_COUNT'
,p_items_label_column_name=>'REGION_TYPE'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(3348609002035757726)
,p_chart_id=>wwv_flow_imp.id(3348608791771757723)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(3348608950094757725)
,p_chart_id=>wwv_flow_imp.id(3348608791771757723)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
end;
/
prompt --application/pages/page_00073
begin
wwv_flow_imp_page.create_page(
 p_id=>73
,p_name=>'Export Repository'
,p_alias=>'EXPORT-REPOSITORY'
,p_step_title=>'Export Repository'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213300727323081712)
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_export.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(49518014041474783)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(78240013758270704)
,p_name=>'Export Repository'
,p_template=>wwv_flow_imp.id(208928010704475743)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
' q varchar2(32767) := null;',
' l_install varchar2(4000) := wwv_flow_lang.system_message(''F4050.INSTALL'');',
'begin',
'  q:=''select '';  ',
'  q:=q||''''''<input type="checkbox" NAME="f01" VALUE="''''||id||''''" TITLE="''''||wwv_flow_lang.system_message(''''DELETE_LABEL'''',wwv_flow_escape.html(title))||''''">'''' cb, '';',
'  q:=q||''flow_id, '';',
'  q:=q||''decode(wwv_flow_imp_parser.flow_exists(flow_id),1,''''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''''||wwv_flow_lang.system_message(''''YES'''')||''''</span>'''',null) exist, '';',
'  q:=q||''wwv_flow_escape.html(title) title, '';',
'  q:=q||''wwv_flow_escape.html(mime_type) mime_type, '';',
'  q:=q||''doc_size, '';',
'  q:=q||''wwv_flow_escape.html(created_by) created_by, '';',
'  q:=q||''created_on co, '';',
'  q:=q||''file_type, '';',
'  q:=q||''id, '';',
'  q:=q||''decode(file_type,'';',
'  q:=q||''''''FLOW_EXPORT'''','';',
'  q:=q||''htf.anchor(''''f?p=&FLOW_ID.:49:''||:flow_session||'':::49:P49_FILE_ID:''''||id,'''''' || l_install || ''''''),'';',
'  q:=q||''''''PLUGIN'''','';',
'  q:=q||''sys.htf.anchor(''''f?p=&FLOW_ID.:4450:''||:flow_session||'':::4450:P4450_FILE_ID:''''||id,'''''' || l_install || ''''''),'';',
'  q:=q||''''''PAGE_EXPORT'''','';',
'  q:=q||''sys.htf.anchor(''''f?p=&FLOW_ID.:67:''||:flow_session||'':::67:P49_FILE_ID:''''||id,'''''' || l_install || ''''''),'';',
'  q:=q||''''''THEME'''','';',
'  q:=q||''wwv_htf.anchor(''''f?p=&FLOW_ID.:253:''||:flow_session||'':::253:P253_FILE_ID:''''||id,'''''' || l_install || ''''''),'';',
'  q:=q||''''''UI_DEFAULTS'''','';',
'  q:=q||''wwv_htf.anchor(''''f?p=&FLOW_ID.:321:''||:flow_session||'':::321:P321_FILE_ID:''''||id,'''''' || l_install || ''''''),'';      ',
'  q:=q||''''''FEEDBACK'''','';',
'  q:=q||''wwv_htf.anchor(''''f?p=&FLOW_ID.:929:''||:flow_session||'':::929:P929_FILE_ID:''''||id,'''''' || l_install || ''''''),'';  ',
'  q:=q||''''''CATALOG'''','';',
'  q:=q||''wwv_htf.anchor(''''f?p=&FLOW_ID.:1966:''||:flow_session||'':::1966:P1966_FILE_ID:''''||id,'''''' || l_install || ''''''),'';  ',
'  q:=q||''null) action, '';',
'  q:=q||''created_on + delete_after_days to_be_deleted '';',
'  q:=q||''from WWV_FLOW_FILE_OBJECTS$, (select wwv_flow_platform.get_preference(''''DELETE_UPLOADED_FILES_AFTER_DAYS'''') delete_after_days from dual) x '';',
'  q:=q||''where security_group_id = :flow_security_group_id and  '';',
'  q:=q||''   deleted_as_of = to_date(''''01.01.0001'''',''''MM.DD.YYYY'''') and  '';',
'  ',
'  if replace(:p73_show,''%''||''null%'',null) is not null then',
'    q:=q||''   file_type = :P73_SHOW'';',
'  else',
'    q:=q||''   file_type in (''''FLOW_EXPORT'''',''''PLUGIN'''', ''''PAGE_EXPORT'''',''''CSS_EXPORT'''',''''IMAGE_EXPORT'''',''''THEME'''',''''UI_DEFAULTS'''',''''FILE_EXPORT'''',''''FEEDBACK'''',''''CATALOG'''') ''; ',
'  end if;',
'  if trim(:P73_FIND) is not null then',
'    q:=q||'' and instr(to_char(flow_id)||'''' ''''||upper(created_by)||'''' ''''||upper(title),upper(:P73_FIND)) > 0 '';',
'  end if;',
'',
'  if :P73_OWNER is not null and :P73_OWNER != ''0'' then',
'    q:=q||'' and created_by = :P73_OWNER '';',
'  end if;',
'  return q;',
'end;'))
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No exports found.'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
,p_comment=>'generated 31-JUL-2001 13:40:41'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48739301214771908)
,p_query_column_id=>1
,p_column_alias=>'CB'
,p_column_display_sequence=>1
,p_column_heading=>'#CHECK_ALL_CHECKBOX#'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48739402835771908)
,p_query_column_id=>2
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>2
,p_column_heading=>'Application'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(53516718608859766)
,p_query_column_id=>3
,p_column_alias=>'EXIST'
,p_column_display_sequence=>10
,p_column_heading=>'Application Exists'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48739510203771908)
,p_query_column_id=>4
,p_column_alias=>'TITLE'
,p_column_display_sequence=>3
,p_column_heading=>'Content Title'
,p_use_as_row_header=>'Y'
,p_column_link=>'p?n=#ID#'
,p_column_linktext=>'#TITLE#'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48739627939771908)
,p_query_column_id=>5
,p_column_alias=>'MIME_TYPE'
,p_column_display_sequence=>4
,p_column_heading=>'MimeType'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48739728426771908)
,p_query_column_id=>6
,p_column_alias=>'DOC_SIZE'
,p_column_display_sequence=>5
,p_column_heading=>'Document Size'
,p_use_as_row_header=>'N'
,p_column_format=>'FILESIZE'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48739827912771909)
,p_query_column_id=>7
,p_column_alias=>'CREATED_BY'
,p_column_display_sequence=>6
,p_column_heading=>'Created By'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48739905785771909)
,p_query_column_id=>8
,p_column_alias=>'CO'
,p_column_display_sequence=>7
,p_column_heading=>'Created'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48740014995771909)
,p_query_column_id=>9
,p_column_alias=>'FILE_TYPE'
,p_column_display_sequence=>8
,p_column_heading=>'Export Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(84313028848586180)
,p_lov_show_nulls=>'YES'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48740113675771909)
,p_query_column_id=>10
,p_column_alias=>'ID'
,p_column_display_sequence=>9
,p_column_heading=>'&nbsp;'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(53489604868713799)
,p_query_column_id=>11
,p_column_alias=>'ACTION'
,p_column_display_sequence=>11
,p_column_heading=>'Action'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(173652221918037574)
,p_query_column_id=>12
,p_column_alias=>'TO_BE_DELETED'
,p_column_display_sequence=>12
,p_column_heading=>'To Be Deleted'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(226286701160894667)
,p_plug_name=>'Report Current Application'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_06'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :fb_flow_id is null then',
'    sys.htp.prn(''<span class="htmldbRunEdit">''||',
'       wwv_flow_lang.system_message(''no_application_selected'')||''&nbsp;</span>'');',
'else',
'   sys.htp.prn(''<span class="htmldbRunEdit">''||',
'    wwv_flow_lang.system_message(''application'')||'': ''||:fb_flow_id||''&nbsp;</span>'');',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(49560212440483792)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(49518014041474783)
,p_button_name=>'P73_GO'
,p_button_static_id=>'P73_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Set'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(78283817054597201)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(49518014041474783)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete Checked'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(47003300946069934)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(49518014041474783)
,p_button_name=>'IMPORT_FILE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Import File'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:460:&SESSION.::&DEBUG.:459,460:P461_EXPIMP,P460_CANCEL_TARGET:IMPORT,73'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(226294601900923228)
,p_branch_action=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(49556722006477082)
,p_name=>'P73_SHOW'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(49518014041474783)
,p_prompt=>'Show'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'EXPORT_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(84313028848586180)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- All -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a content type and then click <span class="fielddatabold">Go</span>.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(131910701379655614)
,p_name=>'P73_FIND'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(49518014041474783)
,p_prompt=>'Find'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a case insensitive query and click <strong>Go</strong>.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(217479517429209651)
,p_name=>'P73_OWNER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(49518014041474783)
,p_prompt=>'Owner'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct created_by d, created_by r',
'from WWV_FLOW_FILE_OBJECTS$',
'where security_group_id = :flow_security_group_id and',
'deleted_as_of = to_date(''01.01.0001'',''MM.DD.YYYY'') and ',
'       created_by != ''HTMLDB_PUBLIC_USER'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- All Owners -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Select a owner and then click <span class="fielddatabold">Go</span>.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(78294225357608359)
,p_validation_name=>'File Selection Not Null'
,p_validation_sequence=>10
,p_validation=>'wwv_flow_utilities.table_to_string2(wwv_flow.g_f01) is not null'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Select the files to delete.'
,p_when_button_pressed=>wwv_flow_imp.id(78283817054597201)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1157777646309618621)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(78240013758270704)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1157777798660618622)
,p_event_id=>wwv_flow_imp.id(1157777646309618621)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(78289504019603042)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Checked'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'forall i in 1..wwv_flow.g_f01.count',
'    delete from wwv_flow_file_objects$',
'     where id = wwv_flow.g_f01(i) and',
'           security_group_id = :flow_security_group_id',
'   ;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error deleting file(s).'
,p_process_when_button_id=>wwv_flow_imp.id(78283817054597201)
,p_process_success_message=>'File(s) deleted.'
,p_internal_uid=>78289504019603042
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(49561122829486861)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>49561122829486861
);
end;
/
prompt --application/pages/page_00075
begin
wwv_flow_imp_page.create_page(
 p_id=>75
,p_name=>'Verify Theme Subscription'
,p_alias=>'VERIFY-THEME-SUBSCRIPTION'
,p_page_mode=>'MODAL'
,p_step_title=>'Verify Theme Subscription'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'No help is available for this page.'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1449460199854055504)
,p_plug_name=>'Subscription Status'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--success:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>20
,p_plug_source=>'Current theme matches master theme '
,p_plug_display_condition_type=>'ITEM_IS_ZERO'
,p_plug_display_when_condition=>'P75_TEMPLATE_ERRORS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(1449467212952099784)
,p_name=>'Subscription Status'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--hideHeader'
,p_component_template_options=>'a-Report--stretch'
,p_new_grid_column=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  c001 flow_id,',
'  c002 theme_id,',
'  c003 template_type,',
'  c004 template_name,',
'  c005 template_id,',
'  c006 reference_id,',
'  c007 status',
'from wwv_flow_collections where collection_name = ''THEME_COMPARE'''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>'no data found'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1449583210096285755)
,p_query_column_id=>1
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>2
,p_column_heading=>'Application ID'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1449583397045285757)
,p_query_column_id=>2
,p_column_alias=>'THEME_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Theme ID'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1449583435185285757)
,p_query_column_id=>3
,p_column_alias=>'TEMPLATE_TYPE'
,p_column_display_sequence=>1
,p_column_heading=>'Template Type'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(84336604916626643)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1449583525390285757)
,p_query_column_id=>4
,p_column_alias=>'TEMPLATE_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Template Name'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1449583674162285757)
,p_query_column_id=>5
,p_column_alias=>'TEMPLATE_ID'
,p_column_display_sequence=>5
,p_column_heading=>'Template Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1449583797518285757)
,p_query_column_id=>6
,p_column_alias=>'REFERENCE_ID'
,p_column_display_sequence=>6
,p_column_heading=>'Reference Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1449588256960314290)
,p_query_column_id=>7
,p_column_alias=>'STATUS'
,p_column_display_sequence=>7
,p_column_heading=>'Status'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(1467334342209901488)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1467171150731485943)
,p_plug_name=>'Subscription Status'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--danger:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>10
,p_plug_source=>'Current theme does not match master theme'
,p_plug_query_num_rows=>15
,p_plug_display_condition_type=>'ITEM_IS_NOT_ZERO'
,p_plug_display_when_condition=>'P75_TEMPLATE_ERRORS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1475880097081627409)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1475880158104627410)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(1475880097081627409)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1467336217105916237)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1475880097081627409)
,p_button_name=>'REFRESH_THEME'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Refresh Theme'
,p_button_position=>'NEXT'
,p_button_condition=>'P75_TEMPLATE_ERRORS'
,p_button_condition_type=>'ITEM_IS_NOT_ZERO'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1449460366604055506)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1475880097081627409)
,p_button_name=>'OK'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Ok'
,p_button_position=>'NEXT'
,p_button_condition=>'P75_TEMPLATE_ERRORS'
,p_button_condition_type=>'ITEM_IS_ZERO'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1467362574290930207)
,p_branch_name=>'Go To Page 267'
,p_branch_action=>'f?p=&APP_ID.:75:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'REFRESH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1449460203341055505)
,p_name=>'P75_TEMPLATE_ERRORS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1449467212952099784)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1467562397353981872)
,p_name=>'P75_THEME_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1449467212952099784)
,p_prompt=>'Theme Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1467562577956983855)
,p_name=>'P75_REFERENCE_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1449467212952099784)
,p_prompt=>'Reference Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1476828701981906515)
,p_name=>'Submit'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1467336217105916237)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1476829074977906517)
,p_event_id=>wwv_flow_imp.id(1476828701981906515)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1467337210462923661)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh Theme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_theme (',
'    p_master_theme_id      => :P75_REFERENCE_ID,',
'    p_subscribing_theme_id => :P75_THEME_ID',
');',
'',
'declare ',
'  l_template_errors number := 0;',
'begin',
'  l_template_errors := wwv_flow_copy_metadata.compare_themes(:P267_ID);',
'  htmldb_util.set_session_state(',
'    p_name => ''P75_TEMPLATE_ERRORS'',',
'    p_value => l_template_errors);',
'end;',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'REFRESH'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>1467337210462923661
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1476829321397910969)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1475880158104627410)
,p_internal_uid=>1476829321397910969
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1449460422627055507)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Ok'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1449460366604055506)
,p_internal_uid=>1449460422627055507
);
end;
/
prompt --application/pages/page_00076
begin
wwv_flow_imp_page.create_page(
 p_id=>76
,p_name=>'Export Workspace'
,p_alias=>'EXPORT-WORKSPACE'
,p_step_title=>'Export Workspace'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213300727323081712)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_export_users.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(79092524857007202)
,p_plug_name=>'Export Workspace'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_translate_title=>'N'
,p_plug_header=>'Exports workspace, user groups, users, and team development data.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(79093621622008691)
,p_plug_name=>'Export Workspace'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page is only available to workspace administrators.</p> ',
'<p>Use this page to create an ASCII text SQL script of users, user groups and team development data (if any).</p>',
'<p>You can also use this page to export developer privileges and move developers you created from one &PRODUCT_NAME. installation to another.</p>',
'<p>Do not include Team Development data if you wish to import the workspace into a runtime only environment.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(79102928295020779)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(12802829107)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(168863917634945552)
,p_plug_name=>'Export Workspace'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(486306511850160598)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(168863917634945552)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:76:&SESSION.::&DEBUG.:76::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(79100309577017218)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(168863917634945552)
,p_button_name=>'Export'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Export'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2558764939975545)
,p_name=>'P76_INCLUDE_EXTENSION_LINKS'
,p_item_sequence=>23
,p_item_plug_id=>wwv_flow_imp.id(79092524857007202)
,p_item_default=>'Y'
,p_prompt=>'Include Extension Links'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Set to <strong>On</strong> if you want to include Extension Links data in your workspace export file.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(99856404704792438)
,p_name=>'P76_FILE_FORMAT'
,p_item_sequence=>43
,p_item_plug_id=>wwv_flow_imp.id(79092524857007202)
,p_source=>'UNIX'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select a file format. Options include:',
'<ul>',
'<li>Select <strong>DOS</strong> to have the lines in the resulting file terminated by carriage returns and line feeds.</li>',
'<li>Select <strong>UNIX</strong> to have the lines in the resulting file contain terminated by line feeds.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(162691910539389529)
,p_name=>'P76_FILE_CHARSET'
,p_item_sequence=>53
,p_item_plug_id=>wwv_flow_imp.id(79092524857007202)
,p_use_cache_before_default=>'NO'
,p_prompt=>'File Character Set:'
,p_source=>'return lower(trim(sys.owa_util.get_cgi_env(''REQUEST_IANA_CHARSET'')));'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'I18N_IANA_CHARSET'
,p_lov=>'.'||wwv_flow_imp.id(144796827445692396)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_escape_on_http_input=>'Y'
,p_help_text=>'The export file will be encoded in the specified character set.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(486366513365294425)
,p_name=>'P76_WORKSPACE_USER_COUNT'
,p_item_sequence=>3
,p_item_plug_id=>wwv_flow_imp.id(79092524857007202)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Workspace User Count:'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_source=>'select count(*) from wwv_flow_fnd_user where security_group_id = :flow_security_group_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identifies the number of users to be exported.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(618935020457553799)
,p_name=>'P76_INCLUDE_TEAM_DEVELOPMENT'
,p_item_sequence=>13
,p_item_plug_id=>wwv_flow_imp.id(79092524857007202)
,p_item_default=>'Y'
,p_prompt=>'Include Team Development'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Set to <strong>On</strong> if you want to include Team Development data like Features, Milestones, To Dos, Bugs, Feedback, Links, and News in your',
'workspace export file.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1796417873996006107)
,p_name=>'P76_MINIMAL'
,p_item_sequence=>33
,p_item_plug_id=>wwv_flow_imp.id(79092524857007202)
,p_item_default=>'MIN'
,p_prompt=>'Export Type'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P76_EXPORT_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(2046972184417676036)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Set to <strong>Full</strong> only if you want to replicate to another instance all workspace artifacts including SQL Scripts, SQL Command History, saved SQL, saved Quick SQL models, user preferences, developer login history, email logs, and UI defaul'
||'ts. In most cases, you should not change the default value <strong>Minimal</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(651513622966755629)
,p_name=>'Submit'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(79100309577017218)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(651513777578755630)
,p_event_id=>wwv_flow_imp.id(651513622966755629)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'Export'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(79119417641132091)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'export workspace'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.init;',
'wwv_flow_utilities.print_download_header (',
'    p_mime_type     => ''application/x-sql'',',
'    p_mime_charset  => ''utf-8'',',
'    p_file_name     => wwv_flow_security.find_company_name(wwv_flow_security.g_security_group_id)||''.sql'',',
'    p_is_attachment => false );',
'sys.owa_util.http_header_close;',
'',
'wwv_flow_utilities.export_workspace (',
'    p_workspace_id             => wwv_flow_security.g_security_group_id,',
'    p_format                   => :P76_FILE_FORMAT,',
'    p_include_team_development => (nvl(:P76_INCLUDE_TEAM_DEVELOPMENT, ''Y'') = ''Y''),',
'    p_include_extension_links  => (nvl(:P76_INCLUDE_EXTENSION_LINKS, ''Y'') = ''Y''),',
'    p_minimal                  => (nvl(:P76_MINIMAL,''x'') = ''MIN''));',
'',
'wwv_flow.stop_apex_engine;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error exporting workspace.'
,p_process_when_button_id=>wwv_flow_imp.id(79100309577017218)
,p_process_success_message=>'Workspace exported.'
,p_internal_uid=>79119417641132091
);
end;
/
prompt --application/pages/page_00077
begin
wwv_flow_imp_page.create_page(
 p_id=>77
,p_name=>'Edit Tab Set by Page'
,p_alias=>'EDIT-TAB-SET-BY-PAGE'
,p_step_title=>'Edit Tab Set by Page'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213240607818867991)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'function nullRange(){',
'document.forms.wwv_flow.p_t01.value = "";',
'document.forms.wwv_flow.p_t02.value = "";}',
'',
'function nullIn(){',
'document.forms.wwv_flow.p_t03.value = "";}',
'</script>',
''))
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(48954132099847673)
,p_plug_name=>'Move Standard Tab  to New Parent Tab'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>140
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'F4000_P77_UNDER_PARENT'
,p_plug_display_when_cond2=>'NO'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(49823719674810720)
,p_plug_name=>'Move Standard Tab to New Tab Set'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>150
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'F4000_P77_UNDER_PARENT'
,p_plug_display_when_cond2=>'NO'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(155243816069447478)
,p_plug_name=>'Page Tab Sets'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>17
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'Use this page to move a standard tab and all associated pages to a different parent tab or tab set.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(155330907966603259)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>90
,p_list_id=>wwv_flow_imp.id(5297709875)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_plug_query_headings=>':Page #:Name:Tab Set'
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_no_data_found=>'Report returned no rows.'
,p_plug_query_show_nulls_as=>'(null)'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(49766122928588025)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(48954132099847673)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(49761509768584187)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(48954132099847673)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(206913911977418459)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(49823719674810720)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(206922416479419784)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(49823719674810720)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(49763913390585689)
,p_branch_action=>'9000'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(49761509768584187)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(49898814856904164)
,p_branch_action=>'77'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>100
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(49766528261588026)
,p_branch_action=>'9000'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(49766122928588025)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(36228925724023202)
,p_name=>'P77_CURRENT_PARENT_TAB'
,p_item_sequence=>17
,p_item_plug_id=>wwv_flow_imp.id(48954132099847673)
,p_prompt=>'Current Parent Tab:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select p.tab_text tab_text',
'                 from wwv_flow_tabs s,wwv_flow_toplevel_tabs p',
'                where s.tab_set = p.current_on_tabset',
'                  and s.flow_id = :fb_flow_id',
'                  and p.flow_id = :fb_flow_id',
'                  and s.id = :F4000_CUR_STD_TAB'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the current parent tab.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(49006017397900148)
,p_name=>'F4000_P77_UNDER_PARENT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(48954132099847673)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(49672926632473200)
,p_name=>'F4000_P77_PARENT_TAB'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(48954132099847673)
,p_prompt=>'New Parent Tab:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ID',
'  from wwv_flow_toplevel_tabs',
' where id = :F4000_P77_UNDER_PARENT'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name,id from(',
'    select wwv_flow_escape.html(tab_text) name,ID,1 ob',
'      from wwv_flow_toplevel_tabs',
'     where id = v(''F4000_P77_UNDER_PARENT'')',
'    union all',
'    select ''----------------------'' name,0 id,2 ob from dual',
'    union all',
'    select wwv_flow_escape.html(tab_text) name,ID,3 ob',
'      from wwv_flow_toplevel_tabs',
'     where flow_id = v(''fb_flow_id'')',
'       and id != v(''F4000_P77_UNDER_PARENT'')',
')',
'order by ob'))
,p_cSize=>64
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the new parent tab.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(49832719649841078)
,p_name=>'F4000_P77_EXISTING_TABSET'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(49823719674810720)
,p_prompt=>'Tabset'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(tab_set)',
'',
'  from wwv_flow_tabs',
'',
' where id = v(''F4000_CUR_STD_TAB'')'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,r from(',
'    select wwv_flow_escape.html(tab_set) d,tab_set r,1 ob',
'      from wwv_flow_tabs',
'     where id = v(''F4000_CUR_STD_TAB'')',
'     union all',
'        select ''-------------------------'' d,''0'' r,2 ob from dual',
'     union all',
'        select ''**    ''||initcap(wwv_flow_lang.system_message(''NEW_TABSET''))||''    **'' d,''02271975'' r,3 ob from dual',
'     union all',
'        select ''-------------------------'' d,''0'' r,4 ob from dual',
'     union all',
'    select wwv_flow_escape.html(d),r,5 ob from (',
'        select distinct tab_set d,tab_set r',
'          from wwv_flow_tabs',
'         where flow_id = v(''fb_flow_id'')',
'         minus',
'        select tab_set d,tab_set r',
'          from wwv_flow_tabs',
'         where id = v(''F4000_CUR_STD_TAB''))',
')',
'order by ob'))
,p_cSize=>64
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the tab set.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(49911401269910423)
,p_name=>'F4000_P77_NEW_STD_TABSET'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(49823719674810720)
,p_prompt=>'New Tabset'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_display_when=>'F4000_P77_EXISTING_TABSET'
,p_display_when2=>'02271975'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identify the new tab set name.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(50148603917365014)
,p_name=>'F4000_P77_TAB_NAME'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_imp.id(48954132099847673)
,p_prompt=>'Standard Tab:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<strong>''||tab_text||''</strong>'' d',
'',
'  from wwv_flow_tabs',
'',
' where id = :F4000_CUR_STD_TAB'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the standard tab.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(50396601248730878)
,p_name=>'F4000_P77_TAB_NAME2'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_imp.id(49823719674810720)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tab'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<strong>''||tab_text||''</strong>'' d',
'',
'  from wwv_flow_tabs',
'',
' where id = :F4000_CUR_STD_TAB'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the tab name.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(49023612196932917)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P77_UNDER_PARENT'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'',
'    l_return    varchar2(255) := ''NO'';',
'',
'begin',
'    for c1 in (select p.id',
'',
'                 from wwv_flow_tabs s,wwv_flow_toplevel_tabs p',
'',
'                where s.tab_set = p.current_on_tabset',
'',
'                  and s.flow_id = :fb_flow_id',
'',
'                  and p.flow_id = :fb_flow_id',
'',
'                  and s.id = :F4000_CUR_STD_TAB)',
'',
'    loop',
'',
'        l_return := c1.id;',
'',
'    end loop;',
'',
'',
'',
'   return l_return;',
'',
'end;'))
,p_computation_error_message=>'Unable to compute item value.'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(207042018126439193)
,p_validation_name=>'Validate new parent tab'
,p_validation_sequence=>10
,p_validation=>'F4000_P77_PARENT_TAB'
,p_validation_type=>'ITEM_NOT_ZERO'
,p_error_message=>'Invalid parent tab'
,p_when_button_pressed=>wwv_flow_imp.id(49761509768584187)
,p_associated_item=>wwv_flow_imp.id(49672926632473200)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(50473004650790104)
,p_process_sequence=>5
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'New Tabset'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_tab_mgr.move_tab_new_tabset(',
'    p_flow         => :fb_flow_id,',
'    p_tab_id       => :F4000_CUR_STD_TAB,',
'    p_tabset       => :F4000_P77_EXISTING_TABSET,',
'    p_new_tabset   => :F4000_P77_NEW_STD_TABSET',
');'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P77_UNDER_PARENT = ''NO''',
'AND',
':REQUEST = ''APPLY_CHANGES'''))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>50473004650790104
,p_process_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P77_UNDER_PARENT = ''NO''',
'',
'AND',
'',
':REQUEST = ''APPLY_CHANGES'''))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(50110603726334675)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update - New Parent Tab'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_tab_mgr.move_tab_new_ptab(',
'    p_flow              => :fb_flow_id,',
'    p_tab_id            => :F4000_CUR_STD_TAB,',
'    p_new_parent_tab    => :F4000_P77_PARENT_TAB',
');'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error moving standard tab.'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P77_UNDER_PARENT != ''NO''',
'AND',
':REQUEST = ''APPLY_CHANGES'''))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Tab Updated.'
,p_internal_uid=>50110603726334675
);
end;
/
prompt --application/pages/page_00078
begin
wwv_flow_imp_page.create_page(
 p_id=>78
,p_name=>'Upgrade Information'
,p_alias=>'UPGRADE-INFORMATION'
,p_page_mode=>'MODAL'
,p_step_title=>'&PRODUCT_NAME. Upgrade'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'470'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(591706749341020446)
,p_plug_name=>'Upgrade Available'
,p_region_css_classes=>'a-Alert--inlineDialog a-Alert--noTitle'
,p_icon_css_classes=>'icon-utilities-build-interval'
,p_region_template_options=>'a-Alert--info:a-Alert--wizard'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(wwv_flow_lang.system_message(',
'    p_name => ''F4000_P78_UPGRADE_AVAILABLE'',',
'    p0     => wwv_flow_cloud_db_services.get_upgrade_status().upgrade_version,',
'    p1     => to_char(wwv_flow_cloud_db_services.get_upgrade_status().upgrade_date, ''&LONG_DATE_FORMAT.''),',
'    p2     => ''https://apex.oracle.com/adb-latest''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'UPGRADE_AVAILABLE'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(591706814243020447)
,p_plug_name=>'Upgrade In Progress'
,p_region_css_classes=>'a-Alert--inlineDialog a-Alert--noTitle'
,p_icon_css_classes=>'icon-ig-refresh'
,p_region_template_options=>'a-Alert--info:a-Alert--wizard'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(wwv_flow_lang.system_message(',
'    p_name => ''F4000_P78_UPGRADING'',',
'    p0     => ''&PRODUCT_NAME.'',',
'    p1     => ''3''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_plug_display_when_condition=>'UPGRADE_IN_PROGRESS'
);
end;
/
prompt --application/pages/page_00080
begin
wwv_flow_imp_page.create_page(
 p_id=>80
,p_name=>'Edit Calendar Template'
,p_alias=>'EDIT-CALENDAR-TEMPLATE'
,p_step_title=>'Edit Calendar Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'EXISTS'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_cal_templates t, wwv_flow_themes th',
'where t.id = :F4000_P697_ID',
'and t.flow_id = th.flow_id',
'and t.theme_id = th.theme_id',
'and t.reference_id is not null',
'and th.reference_id is not null'))
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3680213801027852)
,p_plug_name=>'List View Formats'
,p_region_name=>'AGENDA'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3683623156027862)
,p_plug_name=>'Page Button Button Box'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3689808822027871)
,p_plug_name=>'Calendar Templates'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Calendar templates control the appearance and placement of a calendar. Calendar templates frequently use HTML tables to arrange dates.</p>',
'<p>You place calendar attributes using substitution strings such as #DD# and  #MONTH#. Template substitution strings must be in upper case and begin and end with a pound sign (#).</p>'))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3690729585027872)
,p_plug_name=>'Substitution Strings'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The following date format substitution strings are available:</p>',
'<ul class="noIndent">',
'<li>DAY</li>',
'<li>DD</li>',
'<li>MON</li>',
'<li>YYYY</li>',
'<li>MM</li>',
'<li>MONTH</li>',
'<li>YY</li>',
'<li>RR</li>',
'<li>YEAR</li>',
'<li>WW</li>',
'<li>W</li>',
'<li>DDD</li>',
'<li>D</li>',
'<li>DY</li>',
'<li>DDSPTH</li>',
'<li>HH</li>',
'<li>HH12</li>',
'<li>HH24</li>',
'<li>AM</li>',
'<li>PM</li>',
'<li>MI</li>',
'<li>SYEAR</li>',
'<li>BC</li>',
'<li>CC</li>',
'<li>SCC</li>',
'<li>IYYY</li>',
'<li>Q</li>',
'<li>FMMONTH</li>',
'<li>RM</li>',
'<li>IW</li>',
'<li>FMDAY</li>',
'<li>DDTH</li>',
'<li>DDSPTH</li>',
'<li>J</li>',
'</ul>',
'<p>Placing an "I" in front of any string will INITCAP the text.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3690920930027872)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(12991522578387911)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3704800210224490)
,p_plug_name=>'Calendar Template'
,p_region_name=>'NAME'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_plug_display_condition_type=>'NEVER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46155527569612562)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3684807277027866)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(3683623156027862)
,p_button_name=>'APPLY_CHANGES_GET_PREVIOUS_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'disabled=""'
,p_button_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3684612246027866)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_imp.id(3683623156027862)
,p_button_name=>'APPLY_CHANGES_GET_NEXT_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Next'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'disabled=""'
,p_button_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3684003789027864)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(3683623156027862)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3684409219027866)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(3683623156027862)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:504:&SESSION.::&DEBUG.::P504_ID:&P80_ID.'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P697_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3683808714027862)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(3683623156027862)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P697_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3693700429027887)
,p_branch_action=>'f?p=&APP_ID.:80:&SESSION.::&DEBUG.::P80_ID:&P80_ID_NEXT.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(3684612246027866)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3693908559027887)
,p_branch_action=>'f?p=&APP_ID.:80:&SESSION.::&DEBUG.::P80_ID:&P80_ID_PREV.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(3684807277027866)
,p_branch_sequence=>20
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3694323549027887)
,p_branch_action=>'f?p=&APP_ID.:836:&SESSION.::&DEBUG.::P836_ID:&P80_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_CUSTOM_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3694504694027887)
,p_branch_action=>'f?p=&APP_ID.:670:&SESSION.::&DEBUG.::P670_ID:&P80_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_WEEKLY_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3694718599027887)
,p_branch_action=>'f?p=&APP_ID.:122:&SESSION.::&DEBUG.::P122_ID:&P80_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_MONTHLY_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3708315232238253)
,p_branch_action=>'f?p=&APP_ID.:661:&SESSION.::&DEBUG.::P661_ID:&P80_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>70
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_DAILY_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3694919674027888)
,p_branch_action=>'f?p=&APP_ID.:697:&SESSION.::&DEBUG.::F4000_P697_ID:&P80_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>80
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_CALENDAR_DEFINITION'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3695125791027888)
,p_branch_action=>'f?p=&APP_ID.:80:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>90
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P80_STAY'
,p_branch_condition_text=>'YES'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3695324303027888)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>100
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3695514015027888)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>110
,p_branch_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3685013148027867)
,p_name=>'P80_ID_NEXT'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(3683623156027862)
,p_prompt=>'P80_ID_NEXT'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3685205262027867)
,p_name=>'P80_ID_PREV'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(3683623156027862)
,p_prompt=>'P80_ID_PREV'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3685408597027867)
,p_name=>'P80_ID_COUNT'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(3683623156027862)
,p_prompt=>'Calendar Template: '
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies calendar template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3690011485027871)
,p_name=>'P80_STAY'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(3689808822027871)
,p_prompt=>'Stay on page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select this checkbox to stay on this page after applying changes.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'YES'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3691829356027879)
,p_name=>'P80_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>0
,p_item_plug_id=>wwv_flow_imp.id(3683623156027862)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3705009478224491)
,p_name=>'P80_ID_1'
,p_data_type=>'NUMBER'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(3704800210224490)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3705227467224491)
,p_name=>'P80_NAME'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(3704800210224490)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Defines a name that identifies the template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3705711451224491)
,p_name=>'P80_TRANSLATE_THIS_TEMPLATE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(3704800210224490)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Translatable'
,p_source=>'TRANSLATE_THIS_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3705907163224492)
,p_name=>'P80_THEME_ID'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(3704800210224490)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Theme:'
,p_source=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Indicates the theme to which the template is a member.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3706423706224492)
,p_name=>'P80_THEME_CLASS_ID'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(3704800210224490)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Template Class'
,p_source=>'THEME_CLASS_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CALENDAR THEME CLASS ID'
,p_lov=>'.'||wwv_flow_imp.id(43619531898960304)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Not Identified -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Identifies a specific usage for this template.</div>',
'<div class="htmldbInfoBodyP">When you switch to a new theme, all templates in one theme are assigned to corresponding templates in another theme. App Builder accomplishes this template mapping through the assignment of template class identifiers.</di'
||'v>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7778908831187447)
,p_name=>'P80_AGENDA_TODAY_DAY_FORMAT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(3680213801027852)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Today Day Title Format'
,p_source=>'AGENDA_TODAY_DAY_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the format for the week day names which display as the column header for that day of the week.  ',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'   &lt;th width="14%"&gt;#IDAY#&lt;/th&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7779524761191996)
,p_name=>'P80_AGENDA_TODAY_ENTRY_FORMAT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(3680213801027852)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Today Data Format'
,p_source=>'AGENDA_TODAY_ENTRY_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the HTML to be used to open a day.  This is printed immediately after the "Month Title Format".  Usually this would be an HTML tag which is a container such as a table.  ',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'   &lt;table  border="0" cellpadding="0" cellspacing="0" class="htmldbRowWithBorders" width="100%"&gt;&lt;tr&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7780213118198098)
,p_name=>'P80_AGENDA_FUTURE_DAY_FORMAT'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(3680213801027852)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Future Day Title Format'
,p_source=>'AGENDA_FUTURE_DAY_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the format for the week day names which display as the column header for that day of the week.  ',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'   &lt;th width="14%"&gt;#IDAY#&lt;/th&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7780901914261162)
,p_name=>'P80_AGENDA_FUTURE_ENTRY_FORMAT'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(3680213801027852)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Future Data Format'
,p_source=>'AGENDA_FUTURE_ENTRY_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the HTML to be used to open a day.  This is printed immediately after the "Month Title Format".  Usually this would be an HTML tag which is a container such as a table.  ',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'   &lt;table  border="0" cellpadding="0" cellspacing="0" class="htmldbRowWithBorders" width="100%"&gt;&lt;tr&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7836613810548435)
,p_name=>'P80_AGENDA_FORMAT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3680213801027852)
,p_use_cache_before_default=>'NO'
,p_prompt=>'List Open/Close Format'
,p_source=>'AGENDA_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the HTML to be used to open a day.  This is printed immediately after the "Month Title Format".  Usually this would be an HTML tag which is a container such as a table.  ',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'   &lt;table  border="0" cellpadding="0" cellspacing="0" class="htmldbRowWithBorders" width="100%"&gt;&lt;tr&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7838016365558609)
,p_name=>'P80_AGENDA_PAST_DAY_FORMAT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3680213801027852)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Past Day Title Format'
,p_source=>'AGENDA_PAST_DAY_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the format for the week day names which display as the column header for that day of the week.  ',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'   &lt;th width="14%"&gt;#IDAY#&lt;/th&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7840407838565631)
,p_name=>'P80_AGENDA_PAST_ENTRY_FORMAT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3680213801027852)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Past Data Format'
,p_source=>'AGENDA_PAST_ENTRY_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the HTML to be used to open a day.  This is printed immediately after the "Month Title Format".  Usually this would be an HTML tag which is a container such as a table.  ',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'   &lt;table  border="0" cellpadding="0" cellspacing="0" class="htmldbRowWithBorders" width="100%"&gt;&lt;tr&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3692120163027882)
,p_computation_sequence=>10
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P80_THEME_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(397284515489266400)
,p_name=>'ENABLE PREVIOUS'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P80_ID_PREV'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(397284807039266401)
,p_event_id=>wwv_flow_imp.id(397284515489266400)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(3684807277027866)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(397284921376268078)
,p_name=>'ENABLE NEXT'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P80_ID_NEXT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(397285202719268079)
,p_event_id=>wwv_flow_imp.id(397284921376268078)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(3684612246027866)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3692218601027882)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_CAL_TEMPLATES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_CAL_TEMPLATES'
,p_attribute_03=>'P80_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Unable to fetch row.'
,p_internal_uid=>3692218601027882
,p_process_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3692427028027884)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_PAGINATION'
,p_process_name=>'Get Next or Previous Primary Key Value'
,p_attribute_02=>'WWV_FLOW_CAL_TEMPLATES'
,p_attribute_03=>'P80_ID'
,p_attribute_04=>'ID'
,p_attribute_07=>'THEME_ID'
,p_attribute_08=>'NAME'
,p_attribute_09=>'P80_ID_NEXT'
,p_attribute_10=>'P80_ID_PREV'
,p_attribute_13=>'P80_ID_COUNT'
,p_attribute_14=>'flow_id = :fb_flow_id'
,p_process_error_message=>'Unable to run Get Next or Previous Primary Key Value process.'
,p_internal_uid=>3692427028027884
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3692625818027884)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_CAL_TEMPLATES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_CAL_TEMPLATES'
,p_attribute_03=>'P80_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Unable to process calendar template.'
,p_process_when=>'COPY_TEMPLATE'
,p_process_when_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>3692625818027884
,p_process_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3692819078027884)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'122'
,p_process_when_button_id=>wwv_flow_imp.id(3684409219027866)
,p_internal_uid=>3692819078027884
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3693017234027884)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh calendar template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_calendar_template (',
'    p_master_template_id         => :P80_REFERENCE_ID,',
'    p_subscribing_template_id    => :P80_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying template.'
,p_process_when=>'P80_REFERENCE_ID'
,p_process_when_type=>'NEVER'
,p_process_when2=>'0'
,p_process_success_message=>'Template copied.'
,p_internal_uid=>3693017234027884
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3693216642027884)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove reference id'
,p_process_sql_clob=>'wwv_flow_copy_metadata.remove_button_reference_id (:P80_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error setting template id to null.'
,p_process_when=>'P80_REFERENCE_ID'
,p_process_when_type=>'NEVER'
,p_process_when2=>'0'
,p_process_success_message=>'Reference id is removed.'
,p_internal_uid=>3693216642027884
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3693410156027884)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh calendar template 2'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_calendar_template (',
'    p_master_template_id         => :P80_REFERENCE_ID,',
'    p_subscribing_template_id    => :P80_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying template.'
,p_process_when_button_id=>wwv_flow_imp.id(3683808714027862)
,p_process_when=>':P80_REFERENCE_ID is not null and :P80_REFRESH = ''Y'''
,p_process_when_type=>'NEVER'
,p_process_success_message=>'Template copied.'
,p_internal_uid=>3693410156027884
);
end;
/
prompt --application/pages/page_00081
begin
wwv_flow_imp_page.create_page(
 p_id=>81
,p_name=>'Template Option Groups'
,p_alias=>'TEMPLATE-OPTION-GROUPS'
,p_page_mode=>'MODAL'
,p_step_title=>'Template Option Groups'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'590'
,p_dialog_width=>'970'
,p_dialog_attributes=>'resizable:true,minWidth:600,minHeight:400'
,p_dialog_chained=>'N'
,p_help_text=>'No help is available for this page.'
,p_page_component_map=>'21'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(687105780636946470)
,p_plug_name=>'Template Option Groups'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       flow_id,',
'       theme_id,',
'       name,',
'       display_name,',
'       display_sequence,',
'       template_types,',
'       help_text,',
'       null_text,',
'       is_advanced',
'  from wwv_flow_template_opt_groups',
' where flow_id        = :FB_FLOW_ID',
'   and theme_id       = :P81_THEME_ID',
'   and template_types = coalesce( :P81_TEMPLATE_TYPE, template_types )'))
,p_plug_source_type=>'NATIVE_IG'
,p_ajax_items_to_submit=>'P81_TEMPLATE_TYPE'
,p_plug_read_only_when_type=>'EXISTS'
,p_plug_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_themes',
' where security_group_id = :WORKSPACE_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and theme_id          = :P81_THEME_ID',
'   and reference_id      is not null'))
,p_prn_output_show_link=>'Y'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2801857197512015)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>40
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2801924358512016)
,p_name=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FLOW_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>50
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'FB_FLOW_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2802043963512017)
,p_name=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'THEME_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>60
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'P81_THEME_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2802119824512018)
,p_name=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Identifier'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>90
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_attribute_06=>'UPPER'
,p_is_required=>true
,p_max_length=>30
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2802257714512019)
,p_name=>'DISPLAY_NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DISPLAY_NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>80
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_max_length=>30
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_static_id=>'COLUMN_DISPLAY_NAME'
,p_use_as_row_header=>true
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2802350428512020)
,p_name=>'DISPLAY_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DISPLAY_SEQUENCE'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>'Sequence'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>100
,p_value_alignment=>'RIGHT'
,p_attribute_03=>'left'
,p_attribute_04=>'decimal'
,p_is_required=>true
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'1'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2802489372512021)
,p_name=>'TEMPLATE_TYPES'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'TEMPLATE_TYPES'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Template Type'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>70
,p_value_alignment=>'LEFT'
,p_is_required=>true
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(655584409399418944)
,p_lov_display_extra=>false
,p_lov_display_null=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>true
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'P81_TEMPLATE_TYPE'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2802546667512022)
,p_name=>'HELP_TEXT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'HELP_TEXT'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Help Text'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>120
,p_value_alignment=>'LEFT'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2802616157512023)
,p_name=>'NULL_TEXT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'NULL_TEXT'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Null Text'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>130
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>30
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2802724082512024)
,p_name=>'IS_ADVANCED'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'IS_ADVANCED'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Advanced'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>140
,p_value_alignment=>'CENTER'
,p_is_required=>true
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(84259319526460470)
,p_lov_display_extra=>false
,p_lov_display_null=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'N'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2802852818512025)
,p_name=>'APEX$ROW_ACTION'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>20
,p_use_as_row_header=>false
,p_display_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2802957207512026)
,p_name=>'APEX$ROW_SELECTOR'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_use_as_row_header=>false
,p_display_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(2801660455512013)
,p_internal_uid=>2801660455512013
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_add_row_if_empty=>false
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SET'
,p_show_total_row_count=>true
,p_no_data_found_message=>'No global template options.'
,p_show_toolbar=>true
,p_toolbar_buttons=>'SEARCH_FIELD:SAVE'
,p_add_button_label=>'Add Template Option Group'
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>false
,p_define_chart_view=>false
,p_enable_download=>false
,p_download_formats=>null
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function(config) {',
'    config.defaultGridViewOptions = {',
'        reorderColumns: false',
'    }',
'    return config;',
'}'))
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(3202131449564178)
,p_interactive_grid_id=>wwv_flow_imp.id(2801660455512013)
,p_static_id=>'32022'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(3202313115564179)
,p_report_id=>wwv_flow_imp.id(3202131449564178)
,p_view_type=>'GRID'
,p_stretch_columns=>true
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3203741676564190)
,p_view_id=>wwv_flow_imp.id(3202313115564179)
,p_display_seq=>2
,p_column_id=>wwv_flow_imp.id(2801857197512015)
,p_is_visible=>true
,p_is_frozen=>true
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3204620384564194)
,p_view_id=>wwv_flow_imp.id(3202313115564179)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(2801924358512016)
,p_is_visible=>true
,p_is_frozen=>true
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3205521372564197)
,p_view_id=>wwv_flow_imp.id(3202313115564179)
,p_display_seq=>4
,p_column_id=>wwv_flow_imp.id(2802043963512017)
,p_is_visible=>true
,p_is_frozen=>true
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3206493457564201)
,p_view_id=>wwv_flow_imp.id(3202313115564179)
,p_display_seq=>7
,p_column_id=>wwv_flow_imp.id(2802119824512018)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>143
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3207311052564204)
,p_view_id=>wwv_flow_imp.id(3202313115564179)
,p_display_seq=>6
,p_column_id=>wwv_flow_imp.id(2802257714512019)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>151.5
,p_sort_order=>2
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3208270101564207)
,p_view_id=>wwv_flow_imp.id(3202313115564179)
,p_display_seq=>8
,p_column_id=>wwv_flow_imp.id(2802350428512020)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>98
,p_sort_order=>1
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3209197164564210)
,p_view_id=>wwv_flow_imp.id(3202313115564179)
,p_display_seq=>5
,p_column_id=>wwv_flow_imp.id(2802489372512021)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>120
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3210077671564214)
,p_view_id=>wwv_flow_imp.id(3202313115564179)
,p_display_seq=>10
,p_column_id=>wwv_flow_imp.id(2802546667512022)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>120
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3210812556564217)
,p_view_id=>wwv_flow_imp.id(3202313115564179)
,p_display_seq=>9
,p_column_id=>wwv_flow_imp.id(2802616157512023)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3211776304564221)
,p_view_id=>wwv_flow_imp.id(3202313115564179)
,p_display_seq=>11
,p_column_id=>wwv_flow_imp.id(2802724082512024)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>75
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3212647389564224)
,p_view_id=>wwv_flow_imp.id(3202313115564179)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(2802852818512025)
,p_is_visible=>true
,p_is_frozen=>true
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5609164198662132)
,p_name=>'P81_TEMPLATE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(687105780636946470)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(687110812363004760)
,p_name=>'P81_THEME_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(687105780636946470)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(13088577398499042)
,p_tabular_form_region_id=>wwv_flow_imp.id(687105780636946470)
,p_validation_name=>'Template Options Groups - No duplicates name'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_template_opt_groups',
' where flow_id           = :FB_FLOW_ID',
'   and theme_id          = :P81_THEME_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and name              = :NAME',
'   and template_types    = :TEMPLATE_TYPES',
'   and (:ID is null or id != :ID)'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#COLUMN_HEADER# must be unique.'
,p_associated_column=>'NAME'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(687603574112687584)
,p_name=>'refresh report after edit'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(687105780636946470)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(687603895897687586)
,p_event_id=>wwv_flow_imp.id(687603574112687584)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(687105780636946470)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2803609815512033)
,p_name=>'upper case identifier'
,p_event_sequence=>30
,p_triggering_element_type=>'COLUMN'
,p_triggering_region_id=>wwv_flow_imp.id(687105780636946470)
,p_triggering_element=>'DISPLAY_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2803888036512035)
,p_event_id=>wwv_flow_imp.id(2803609815512033)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
':NAME := regexp_replace(',
'      srcstr     => :DISPLAY_NAME,',
'      pattern    => ''[^'' || wwv_flow_utilities.c_alnum || '']+'',',
'      replacestr => ''_'' );'))
,p_attribute_02=>'DISPLAY_NAME'
,p_attribute_03=>'NAME'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2803018209512027)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(687105780636946470)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Template Option Groups - Save Interactive Grid Data'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2803018209512027
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(7427995501981827)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(687105780636946470)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update Tempate Options'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'update wwv_flow_template_options t',
'  set t.template_types = ( select g.template_types ',
'                           from wwv_flow_template_opt_groups g',
'                          where g.id = t.group_id',
'                            and g.flow_id = t.flow_id',
'                            and g.security_group_id = t.security_group_id )',
'where t.flow_id = :FB_FLOW_ID',
' and t.security_group_id = :WORKSPACE_ID',
'and exists (',
'    select 1 ',
'      from wwv_flow_template_opt_groups g',
'     where g.id = t.group_id',
'       and g.flow_id = t.flow_id',
'       and g.security_group_id = t.security_group_id',
'       and g.template_types <> t.template_types',
');'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>7427995501981827
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(13088478623499041)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_region_id=>wwv_flow_imp.id(687105780636946470)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'upper :name'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':NAME := REGEXP_REPLACE(',
'      srcstr     => :NAME,',
'      pattern    => ''[^'' || wwv_flow_utilities.c_alnum || '']+'',',
'      replacestr => ''_'' );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>13088478623499041
);
end;
/
prompt --application/pages/page_00083
begin
wwv_flow_imp_page.create_page(
 p_id=>83
,p_name=>'Verify Theme Subscription'
,p_alias=>'VERIFY-THEME-SUBSCRIPTION1'
,p_page_mode=>'MODAL'
,p_step_title=>'Verify Theme Subscription'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'No help is available for this page.'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1475856076343506021)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--wizard'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1475879495831627403)
,p_plug_name=>'Verify'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'This wizard looks at all theme attributes, templates and template options in the subscribing theme and raises errors for those that are not in sync with the master theme. The wizard also highlights any templates that are defined in the master theme b'
||'ut not yet published to the subscribing theme. To publish changes from the master theme to the subscribing theme, press the "Refresh" button at the end of the wizard.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1475856217437509963)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1475856076343506021)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1475856786032519198)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1475856076343506021)
,p_button_name=>'VERIFY'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Verify'
,p_button_position=>'CREATE'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1475857069006520103)
,p_branch_action=>'f?p=&APP_ID.:75:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(1475856786032519198)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1475879250893627401)
,p_name=>'P83_MASTER_THEME_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1475879495831627403)
,p_prompt=>'Master Theme ID'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id from wwv_flow_themes',
'where id = :P75_REFERENCE_ID;'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1475879344552627402)
,p_name=>'P83_MASTER_THEME_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1475879495831627403)
,p_prompt=>'Master Theme Name'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_name from wwv_flow_themes',
'where id = :P75_REFERENCE_ID;'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1475879698953627405)
,p_name=>'P83_SUB_THEME_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(1475879495831627403)
,p_prompt=>'Subscribing Theme ID'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id from wwv_flow_themes',
'where id = :P75_THEME_ID;'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1475879715459627406)
,p_name=>'P83_SUB_THEME_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(1475879495831627403)
,p_prompt=>'Subscribing Theme Name'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_name from wwv_flow_themes',
'where id = :P75_THEME_ID;'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1475879865707627407)
,p_name=>'P83_MASTER_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1475879495831627403)
,p_prompt=>'Master Application ID'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select flow_id from wwv_flow_themes',
'where id = :P75_REFERENCE_ID;'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1475879923815627408)
,p_name=>'P83_SUB_FLOW_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(1475879495831627403)
,p_prompt=>'Subscribing Application ID'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select flow_id from wwv_flow_themes',
'where id = :P75_THEME_ID;'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1475857718994531054)
,p_name=>'Submit '
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1475856786032519198)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1475858042511531062)
,p_event_id=>wwv_flow_imp.id(1475857718994531054)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'VERIFY'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1475856497652512191)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1475856217437509963)
,p_internal_uid=>1475856497652512191
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1475857289831523296)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Verify'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'  l_template_errors number := 0;',
'begin',
'  l_template_errors := wwv_flow_copy_metadata.compare_themes(:P267_ID);',
'  htmldb_util.set_session_state(',
'    p_name => ''P75_TEMPLATE_ERRORS'',',
'    p_value => l_template_errors);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'VERIFY'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>1475857289831523296
);
end;
/
prompt --application/pages/page_00084
begin
wwv_flow_imp_page.create_page(
 p_id=>84
,p_name=>'Create Application - Confirm'
,p_alias=>'CREATE-APPLICATION-CONFIRM'
,p_step_title=>'Create Application'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213220627333807318)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_copy_app.htm'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(23757007845437601)
,p_plug_name=>'Create Application'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wiz_confirm.copy_application (',
'    p_old_app_id      => :P3009_COPY_FROM,',
'    p_old_app_name    => :P84_COPY_FROM_NAME,',
'    p_new_app_id      => :P3009_NEW_APP_ID,',
'    p_new_app_name    => :P3009_COPY_TO,',
'    p_copy_deployment => :P3009_COPY_DEPLOYMENT',
'    );'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(23763022898462655)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(139866417493663090)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(245910428558834687)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747137633701138152)
,p_plug_name=>'Create Application'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(23757207073437601)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(245910428558834687)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(23757415100437602)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(245910428558834687)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Application'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(23757611720437603)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(245910428558834687)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(23758304938437609)
,p_branch_action=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(23757415100437602)
,p_branch_sequence=>21
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(23758532228437609)
,p_branch_action=>'f?p=&APP_ID.:3009:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(23757611720437603)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(23777122215538115)
,p_name=>'P84_COPY_FROM_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(23757007845437601)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(23758028049437605)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'copy application'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_export_dev.copy_application (',
'    p_old_application_id => :P3009_COPY_FROM,',
'    p_new_application_id => :P3009_NEW_APP_ID,',
'    p_new_name           => :P3009_COPY_TO,',
'    p_export_sup_objects => :P3009_COPY_DEPLOYMENT );',
'',
':FB_FLOW_ID      := :P3009_NEW_APP_ID;',
':FB_FLOW_PAGE_ID := ''1'';',
':F4000_P1_FLOW   := :P3009_NEW_APP_ID;',
':F4000_P1_PAGE   := ''1'';  ',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to copy application &P3009_COPY_FROM..'
,p_process_when_button_id=>wwv_flow_imp.id(23757415100437602)
,p_process_success_message=>'Application created successfully.'
,p_internal_uid=>23758028049437605
);
end;
/
prompt --application/pages/page_00085
begin
wwv_flow_imp_page.create_page(
 p_id=>85
,p_name=>'Item Templates'
,p_alias=>'ITEM-TEMPLATES'
,p_step_title=>'Edit Item Template'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'<!--',
'',
' htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'EXISTS'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_field_templates t, ',
'       wwv_flow_themes th',
' where t.id                = :F4000_P85_ID',
'   and t.flow_id           = th.flow_id',
'   and t.theme_id          = th.theme_id',
'   and t.security_group_id = :WORKSPACE_ID',
'   and t.reference_id     is not null',
'   and th.reference_id    is not null'))
,p_help_text=>'ui_templt_label.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1406050092644002)
,p_plug_name=>'Landmark for Displayed Regions'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_landmark_type=>'region'
,p_landmark_label=>'Displayed Regions'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(15137524109292531)
,p_plug_name=>'Field Container'
,p_region_name=>'FC'
,p_parent_plug_id=>wwv_flow_imp.id(1406050092644002)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>170
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(26124820122893836)
,p_plug_name=>'Template Options'
,p_parent_plug_id=>wwv_flow_imp.id(1406050092644002)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>130
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(21546336307856480)
,p_plug_name=>'Template Options'
,p_parent_plug_id=>wwv_flow_imp.id(26124820122893836)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.template_types,',
'       o.id,',
'       o.display_name,',
'       o.name,',
'       o.display_sequence,',
'       o.css_classes,',
'       o.flow_id,',
'       o.theme_id,',
'       o.help_text,',
'       o.group_id,',
'       o.field_template_id,',
'       ( select g.display_sequence from wwv_flow_template_opt_groups g where g.id = o.group_id ) group_display_sequence,',
'       ( select g.display_name     from wwv_flow_template_opt_groups g where g.id = o.group_id ) group_display_name',
'  from wwv_flow_template_options o',
' where o.flow_id           = :FB_FLOW_ID',
'   and o.theme_id          = :P85_THEME',
'   and o.template_types    = ''FIELD''',
'   and o.field_template_id = :F4000_P85_ID',
'   and o.security_group_id = :WORKSPACE_ID'))
,p_plug_source_type=>'NATIVE_IG'
,p_ajax_items_to_submit=>'P85_DEFAULT_TEMPLATE_OPTIONS,P85_THEME'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Template Options'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(9690934235802642)
,p_name=>'FIELD_TEMPLATE_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FIELD_TEMPLATE_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>70
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'F4000_P85_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(13087759475499034)
,p_name=>'GROUP_DISPLAY_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'GROUP_DISPLAY_SEQUENCE'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Group Sequence'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>80
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(13087803750499035)
,p_name=>'GROUP_DISPLAY_NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'GROUP_DISPLAY_NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Group Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>90
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(21547114841856488)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>30
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(21547200990856489)
,p_name=>'DISPLAY_NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DISPLAY_NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>100
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_item_width=>30
,p_is_required=>true
,p_max_length=>30
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_static_id=>'COLUMN_DISPLAY_NAME'
,p_use_as_row_header=>true
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(21547250275856490)
,p_name=>'DISPLAY_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DISPLAY_SEQUENCE'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>'Sequence'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>120
,p_value_alignment=>'RIGHT'
,p_attribute_03=>'left'
,p_attribute_04=>'decimal'
,p_item_width=>5
,p_is_required=>true
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'1'
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(21547365662856491)
,p_name=>'CSS_CLASSES'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'CSS_CLASSES'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Classes'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>130
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_max_length=>255
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(21547717298856494)
,p_name=>'APEX$ROW_ACTION'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>20
,p_use_as_row_header=>false
,p_display_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(21547766775856495)
,p_name=>'APEX$ROW_SELECTOR'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_use_as_row_header=>false
,p_display_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(21548801284856505)
,p_name=>'TEMPLATE_TYPES'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'TEMPLATE_TYPES'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>60
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'FIELD'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(21548862800856506)
,p_name=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Identifier'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>110
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_attribute_06=>'UPPER'
,p_item_width=>30
,p_is_required=>true
,p_max_length=>30
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(22189553890011960)
,p_name=>'HELP_TEXT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'HELP_TEXT'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Help Text'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>150
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(22189655693011961)
,p_name=>'GROUP_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'GROUP_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Group'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>140
,p_value_alignment=>'LEFT'
,p_is_required=>false
,p_lov_type=>'SQL_QUERY'
,p_lov_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name,',
'       id',
'  from wwv_flow_template_opt_groups',
' where template_types    = :TEMPLATE_TYPES',
'   and flow_id           = :FB_FLOW_ID',
'   and theme_id          = :P85_THEME',
'   and security_group_id = :workspace_id'))
,p_lov_display_extra=>true
,p_lov_display_null=>true
,p_lov_cascade_parent_items=>'TEMPLATE_TYPES'
,p_ajax_items_to_submit=>'P85_THEME'
,p_ajax_optimize_refresh=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(22189751321011962)
,p_name=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FLOW_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>40
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'FB_FLOW_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(22189870485011963)
,p_name=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'THEME_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>50
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'P85_THEME'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(21547007044856487)
,p_internal_uid=>21547007044856487
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_add_row_if_empty=>false
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>true
,p_no_data_found_message=>'No template options.'
,p_show_toolbar=>true
,p_toolbar_buttons=>'SEARCH_FIELD:SAVE'
,p_add_button_label=>'Add Template Option'
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>false
,p_define_chart_view=>false
,p_enable_download=>false
,p_download_formats=>null
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function(config) {',
'    config.defaultGridViewOptions = {',
'        reorderColumns: false',
'    }',
'    return config;',
'}'))
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(21982973742995313)
,p_interactive_grid_id=>wwv_flow_imp.id(21547007044856487)
,p_static_id=>'94803'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(21983159760995314)
,p_report_id=>wwv_flow_imp.id(21982973742995313)
,p_view_type=>'GRID'
,p_stretch_columns=>true
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(12506036968229627)
,p_view_id=>wwv_flow_imp.id(21983159760995314)
,p_display_seq=>11
,p_column_id=>wwv_flow_imp.id(22189751321011962)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(12507076775229633)
,p_view_id=>wwv_flow_imp.id(21983159760995314)
,p_display_seq=>12
,p_column_id=>wwv_flow_imp.id(22189870485011963)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(12677557618250542)
,p_view_id=>wwv_flow_imp.id(21983159760995314)
,p_display_seq=>13
,p_column_id=>wwv_flow_imp.id(9690934235802642)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(21983710982995320)
,p_view_id=>wwv_flow_imp.id(21983159760995314)
,p_display_seq=>2
,p_column_id=>wwv_flow_imp.id(21547114841856488)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(21984615942995327)
,p_view_id=>wwv_flow_imp.id(21983159760995314)
,p_display_seq=>4
,p_column_id=>wwv_flow_imp.id(21547200990856489)
,p_is_visible=>true
,p_is_frozen=>false
,p_sort_order=>4
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(21985498479995331)
,p_view_id=>wwv_flow_imp.id(21983159760995314)
,p_display_seq=>6
,p_column_id=>wwv_flow_imp.id(21547250275856490)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>106
,p_sort_order=>3
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(21986344052995336)
,p_view_id=>wwv_flow_imp.id(21983159760995314)
,p_display_seq=>7
,p_column_id=>wwv_flow_imp.id(21547365662856491)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(21989067663995345)
,p_view_id=>wwv_flow_imp.id(21983159760995314)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(21547717298856494)
,p_is_visible=>true
,p_is_frozen=>true
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(22195579134014345)
,p_view_id=>wwv_flow_imp.id(21983159760995314)
,p_display_seq=>10
,p_column_id=>wwv_flow_imp.id(21548801284856505)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(22196487845014351)
,p_view_id=>wwv_flow_imp.id(21983159760995314)
,p_display_seq=>5
,p_column_id=>wwv_flow_imp.id(21548862800856506)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(22200127349014363)
,p_view_id=>wwv_flow_imp.id(21983159760995314)
,p_display_seq=>8
,p_column_id=>wwv_flow_imp.id(22189553890011960)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(22201024118014366)
,p_view_id=>wwv_flow_imp.id(21983159760995314)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(22189655693011961)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(23834712960977474)
,p_view_id=>wwv_flow_imp.id(21983159760995314)
,p_display_seq=>14
,p_column_id=>wwv_flow_imp.id(13087759475499034)
,p_is_visible=>false
,p_is_frozen=>false
,p_sort_order=>1
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(23835659149977481)
,p_view_id=>wwv_flow_imp.id(21983159760995314)
,p_display_seq=>15
,p_column_id=>wwv_flow_imp.id(13087803750499035)
,p_is_visible=>false
,p_is_frozen=>false
,p_sort_order=>2
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(709059267654700233)
,p_name=>'Global Template Options'
,p_parent_plug_id=>wwv_flow_imp.id(26124820122893836)
,p_template=>wwv_flow_imp.id(689970285456172024)
,p_display_sequence=>230
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.id,',
'       o.display_name,',
'       o.display_sequence,',
'       o.css_classes,',
'       g.display_name group_name',
'  from wwv_flow_template_options o,',
'       wwv_flow_template_opt_groups g',
' where o.flow_id              = :FB_FLOW_ID',
'   and o.virtual_template_id is null',
'   and o.template_types       = ''FIELD''',
'   and o.field_template_id   is null',
'   and o.security_group_id    = :WORKSPACE_ID',
'   and o.theme_id             = :P85_THEME',
'   and g.id (+)               = o.group_id',
' order by',
'       g.display_sequence,',
'       g.display_name,',
'       o.display_sequence,',
'       o.display_name'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P85_DEFAULT_TEMPLATE_OPTIONS,P85_THEME'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>200
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No template options defined.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(12512704525209388)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(12513142145209389)
,p_query_column_id=>2
,p_column_alias=>'DISPLAY_NAME'
,p_column_display_sequence=>21
,p_column_heading=>'Name'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(12513582642209389)
,p_query_column_id=>3
,p_column_alias=>'DISPLAY_SEQUENCE'
,p_column_display_sequence=>31
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(12513955624209389)
,p_query_column_id=>4
,p_column_alias=>'CSS_CLASSES'
,p_column_display_sequence=>41
,p_column_heading=>'Classes'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(12514390337209389)
,p_query_column_id=>5
,p_column_alias=>'GROUP_NAME'
,p_column_display_sequence=>11
,p_column_heading=>'Group'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(33419222793056919)
,p_plug_name=>'Subscription'
,p_region_name=>'SUBSCRIPTION'
,p_parent_plug_id=>wwv_flow_imp.id(1406050092644002)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>120
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P85_THEME_IS_SUBSCRIBED'
,p_plug_display_when_cond2=>'NONE'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'WWV_FLOW_FIELD_TEMPLATES',
  'attribute_02', 'TEMPLATE_NAME',
  'attribute_03', 'F4000_P85_ID',
  'attribute_04', 'F4000_P85_REFERENCE_ID',
  'attribute_05', 'SUBSCRIBE_TEMPLATE')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(92676922957336244)
,p_plug_name=>'Name'
,p_region_name=>'N'
,p_parent_plug_id=>wwv_flow_imp.id(1406050092644002)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'Region generated 04-OCT-2001 17:03:20'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(92735416527411011)
,p_plug_name=>'Definition'
,p_region_name=>'STD'
,p_parent_plug_id=>wwv_flow_imp.id(1406050092644002)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>150
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(92736513293412529)
,p_plug_name=>'Comments'
,p_region_name=>'C'
,p_parent_plug_id=>wwv_flow_imp.id(1406050092644002)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>180
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(166032826430627441)
,p_plug_name=>'Substitution Strings'
,p_region_name=>'S'
,p_parent_plug_id=>wwv_flow_imp.id(1406050092644002)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>190
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_templates_util.label_template_sub_str (',
'    p_template_id => :F4000_P85_ID);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'Substitution strings are used within templates to reference component values.  This report details substitution string usage for this template.'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(174456326258809270)
,p_plug_name=>'Error Display'
,p_region_name=>'ERR'
,p_parent_plug_id=>wwv_flow_imp.id(1406050092644002)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>160
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'Region generated 04-OCT-2001 17:03:20'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(932806954683193713)
,p_plug_name=>'Subscription'
,p_parent_plug_id=>wwv_flow_imp.id(1406050092644002)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P85_THEME_IS_SUBSCRIBED = ''BOTH'' then',
'     sys.htp.p(wwv_flow_lang.system_message(''TEMPLATE_SUBSCRIPTION.THEME_AND_TEMPLATE_SUBSCRIBED''));',
'else',
'     sys.htp.p(wwv_flow_lang.system_message(''TEMPLATE_SUBSCRIPTION.THEME_SUBSCRIBED''));',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P85_THEME_IS_SUBSCRIBED'
,p_plug_display_when_cond2=>'NONE'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'N',
  'attribute_02', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46155810950612564)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(92731110501398600)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Item templates are designed to centrally manage HTML markup of page item labels.</p> ',
'<p>You can control how items display using item templates. For example, you could create an item template called "Required Field" which contains HTML font controls to indicate to the user that the field is required by changing the color of the label.'
||'</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(92740432474418784)
,p_plug_name=>'Edit Item Template'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--accessibleTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_landmark_label=>'Item Template Actions'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(92859200616502822)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(92837202675352059)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(117328027016407678)
,p_plug_name=>'Hidden'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(617460819542020156)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_imp.id(29434107863295859)
,p_plug_display_sequence=>200
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from  WWV_FLOW_FIELD_TEMPLATES',
'where id = :F4000_P85_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :F4000_P85_ID,',
'      p_component_type => ''Label Template'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(134194118755432829)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(92740432474418784)
,p_button_name=>'APPLY_CHANGES_GET_PREVIOUS_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'disabled=""'
,p_button_comment=>'javascript:htmldb_goSubmit(''GET_PREVIOUS_ID'')'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(134194006039432829)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_imp.id(92740432474418784)
,p_button_name=>'APPLY_CHANGES_GET_NEXT_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Next'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'disabled=""'
,p_button_comment=>'javascript:htmldb_goSubmit(''GET_NEXT_ID'')'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(166470213174105062)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(33419222793056919)
,p_button_name=>'PUBLISH_TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Publish Template'
,p_button_position=>'COPY'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.::F4000_P149_ID,F4000_P149_PAGE_ID,F4000_P149_TEMPLATE_TYPE:&F4000_P85_ID.,&FLOW_PAGE_ID.,FIELD_TEMPLATE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_field_templates',
' where reference_id      = :F4000_P85_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(164764703441381497)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(33419222793056919)
,p_button_name=>'COPY_TEMPLATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Refresh'
,p_button_position=>'COPY'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_field_templates',
' where id                = :F4000_P85_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and reference_id     is not null'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(92677205290336246)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(92740432474418784)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(92677508451336246)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(92740432474418784)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:348:&SESSION.::&DEBUG.::P348_ID:&F4000_P85_ID.'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P85_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(92677422219336246)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(92740432474418784)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P85_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(92677307778336246)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(92740432474418784)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P85_ID is null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(12503051857209366)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_imp.id(26124820122893836)
,p_button_name=>'OPTION_GROUPS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Template Option Groups'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:81:&SESSION.::&DEBUG.:CR,81:P81_THEME_ID,P81_TEMPLATE_TYPE:&P85_THEME.,FIELD'
,p_button_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(134199918519432862)
,p_branch_action=>'f?p=&APP_ID.:85:&SESSION.::&DEBUG.::F4000_P85_ID:&P85_ID_NEXT.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(134194006039432829)
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(134200328530432866)
,p_branch_action=>'f?p=&APP_ID.:85:&SESSION.::&DEBUG.::F4000_P85_ID:&P85_ID_PREV.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(134194118755432829)
,p_branch_sequence=>40
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(164765129393381502)
,p_branch_name=>'Go To Page 85'
,p_branch_action=>'f?p=&APP_ID.:85:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(164764703441381497)
,p_branch_sequence=>50
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(27987623723767701)
,p_branch_action=>'f?p=&APP_ID.:85:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'F4000_P85_STAY_ON_PAGE'
,p_branch_condition_text=>'YES'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(92678417298336252)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>70
,p_branch_comment=>'Generated 04-OCT-2001 17:03:20'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12503472081209369)
,p_name=>'P85_PRESET_TEMPLATE_OPTIONS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(26124820122893836)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Preset Template Options:'
,p_source=>'PRESET_TEMPLATE_OPTIONS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.TEMPALTE_OPT_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.display_name as d,',
'       o.css_classes as r,',
'       null default_template_options,',
'       null,',
'       o.help_text,',
'       g.display_name group_name,',
'       g.is_advanced advanced_group,',
'       g.null_text',
'  from wwv_flow_template_options o,',
'       wwv_flow_template_opt_groups g,',
'       wwv_flow_field_templates t',
' where o.flow_id               = :fb_flow_id',
'   and o.template_types        = ''FIELD''',
'   and (field_template_id      = :f4000_p85_id or field_template_id is null)',
'   and o.theme_id              = t.theme_id',
'   and t.id                    = :f4000_p85_id',
'   and g.id                (+) = o.group_id',
'   and o.security_group_id     = :WORKSPACE_ID',
'   and g.security_group_id (+) = o.security_group_id',
'   and t.security_group_id     = o.security_group_id',
'',
' order by ',
'       g.is_advanced nulls first,',
'       g.display_sequence nulls first,',
'       g.display_name nulls first,',
'       o.display_sequence,',
'       o.display_name'))
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12503828718209371)
,p_name=>'P85_DEFAULT_TEMPLATE_OPTIONS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(26124820122893836)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Default Template Options:'
,p_source=>'DEFAULT_TEMPLATE_OPTIONS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.TEMPALTE_OPT_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.display_name as d,',
'       o.css_classes as r,',
'       t.default_template_options,',
'       null,',
'       o.help_text,',
'       g.display_name group_name',
'  from wwv_flow_template_options o,',
'       wwv_flow_template_opt_groups g,',
'       wwv_flow_field_templates t',
' where o.flow_id                = :fb_flow_id',
'   and t.id                     = o.field_template_id',
'   and o.field_template_id      = :F4000_P85_ID',
'   and g.id                 (+) = o.group_id',
'   and o.security_group_id      = :WORKSPACE_ID',
'   and g.security_group_id  (+) = o.security_group_id',
'   and t.security_group_id      = o.security_group_id',
'',
' order by',
'       g.display_sequence nulls first,',
'       g.display_name nulls first,',
'       o.display_sequence,',
'       o.display_name'))
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12504207683209372)
,p_name=>'P85_PRESET_TMPLOPT_CHECK'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(26124820122893836)
,p_source=>'P85_PRESET_TEMPLATE_OPTIONS'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(15138708095306882)
,p_name=>'P85_BEFORE_ITEM'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(15137524109292531)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Before Label and Item'
,p_source=>'BEFORE_ITEM'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter HTML to be displayed before the label and item. This is typically used to wrap an item into a DIV container or field set. The Before Label and Item attribute is only rendered for pages that do not use a table grid to display form items. This'
||' includes any page using a mobile page template.</p>',
'<p>',
'<div class="htmldbInfoBodyP">The following substitution strings are available for this attribute:',
'<ul class="noIndent">',
'<li>#CURRENT_FORM_ELEMENT#</li>',
'<li>#CURRENT_ITEM_ID#</li>',
'<li>#CURRENT_ITEM_NAME#</li>',
'<li>#CURRENT_ITEM_HELP_TEXT#</li>',
'<li>#CURRENT_ITEM_CONTAINER_ID#</li>',
'</ul>',
'</div>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(15139000953314202)
,p_name=>'P85_AFTER_ITEM'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(15137524109292531)
,p_use_cache_before_default=>'NO'
,p_prompt=>'After Label and Item'
,p_source=>'AFTER_ITEM'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter HTML to be displayed after the label and item. This is typically used to wrap an item into a DIV container or field set. The after item and label attribute is only rendered for pages that don''t use a table grid to display form items. This inclu'
||'des any page using a mobile page template.',
'',
'<div class="htmldbInfoBodyP">The following substitution strings are available for this attribute:',
'<ul class="noIndent">',
'<li>#CURRENT_FORM_ELEMENT#</li>',
'<li>#CURRENT_ITEM_ID#</li>',
'<li>#CURRENT_ITEM_NAME#</li>',
'<li>#CURRENT_ITEM_HELP_TEXT#</li>',
'</ul>',
'</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(24153717149540645)
,p_name=>'P85_TRANSLATABLE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(92676922957336244)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Translatable'
,p_source=>'TRANSLATE_THIS_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Check if translatable.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(27978600511685311)
,p_name=>'F4000_P85_STAY_ON_PAGE'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(92731110501398600)
,p_prompt=>'Stay on page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select this checkbox to stay on this page after applying changes.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'YES'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(35448530366673284)
,p_name=>'F4000_P85_REFRESH'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(33419222793056919)
,p_item_default=>'Y'
,p_prompt=>'Refresh'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_field_templates',
' where reference_id     is null',
'   and id                = :F4000_P85_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40817606973410538)
,p_name=>'P85_NAME'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(92740432474418784)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select TEMPLATE_NAME ',
'  from WWV_FLOW_FIELD_TEMPLATES ',
' where id                = :F4000_P85_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies template name'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(43714724672336692)
,p_name=>'P85_THEME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(92676922957336244)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Theme:'
,p_source=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Indicates the theme to which the template is a member.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(43838323482875713)
,p_name=>'P85_THEME_CLASS_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(92676922957336244)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Template Class'
,p_source=>'THEME_CLASS_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LABEL THEME CLASS ID'
,p_lov=>'.'||wwv_flow_imp.id(43828319065855502)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Not Identified -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Identifies a specific usage for this template.</div>',
'<div class="htmldbInfoBodyP">When you switch to a new theme, all templates in one theme are assigned to corresponding templates in another theme. App Builder accomplishes this template mapping through the assignment of template class identifiers.</di'
||'v>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(92679028424336256)
,p_name=>'F4000_P85_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(117328027016407678)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 04-OCT-2001 17:03:20'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(92679924863336270)
,p_name=>'F4000_P85_TEMPLATE_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(92676922957336244)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>'TEMPLATE_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Defines a name that identifies the template.<p />',
'Use the <strong>Translatable</strong> check box to indicate that the template contains text strings that require translation.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 04-OCT-2001 17:03:20'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(92680221480336272)
,p_name=>'F4000_P85_TEMPLATE_BODY1'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(92735416527411011)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Before Label'
,p_source=>'TEMPLATE_BODY1'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>6
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Enter HTML to be displayed before an item label.</div>',
'<div class="htmldbInfoBodyP">Note:  The label will be automatically display after the HTML in this region. Therefore, if you open an &lt;a&gt; tag, for instance, you should close it in the After Label region.</div>',
'<div class="htmldbInfoBodyP">The following substitution strings are available for this attribute:',
'<ul class="noIndent">',
'<li>#CURRENT_FORM_ELEMENT#</li>',
'<li>#CURRENT_ITEM_ID#</li>',
'<li>#CURRENT_ITEM_NAME#</li>',
'<li>#CURRENT_ITEM_HELP_TEXT#</li>',
'<li>#LABEL_ID#</li>',
'<li>#LABEL_COLUMN_SPAN_NUMBER#</li>',
'<li>#LABEL_COLUMN_SPAN_ALPHA#</li>',
'<li>#LABEL_COLUMN_SPAN_WORD#</li>',
'<li>#LABEL_COLUMN_SPAN_PLURAL#</li>',
'</ul>',
'</div>',
'<div class="htmldbInfoBodyP">For example:</div',
'<pre>',
'&lt;label for="#CURRENT_ITEM_NAME#" id="#LABEL_ID#"&gt;<br>&lt;a href="javascript:popupFieldHelp(''#CURRENT_ITEM_ID#'',<br>&nbsp;&nbsp;''&amp;SESSION.'',''&amp;CLOSE.'')" &gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 04-OCT-2001 17:03:20'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(92680511350336273)
,p_name=>'F4000_P85_TEMPLATE_COMMENT'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(92736513293412529)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comments'
,p_source=>'TEMPLATE_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Developer comments or notes. These comments never display when the application is running.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_item_comment=>'Generated 04-OCT-2001 17:03:20'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(92781318166516655)
,p_name=>'F4000_P85_TEMPLATE_BODY2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(92735416527411011)
,p_use_cache_before_default=>'NO'
,p_prompt=>'After Label'
,p_source=>'TEMPLATE_BODY2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>3
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Enter HTML to be displayed after an item label.</div>',
'<div class="htmldbInfoBodyP">NOTE:  The label will be automatically display before the HTML in this region. Therefore, any open HTML tags in the Before Label region should be closed here.</div>',
'',
'<div class="htmldbInfoBodyP">The following substitution strings are available for this attribute:',
'<ul class="noIndent">',
'<li>#CURRENT_FORM_ELEMENT#</li>',
'<li>#CURRENT_ITEM_ID#</li>',
'<li>#CURRENT_ITEM_NAME#</li>',
'<li>#CURRENT_ITEM_HELP_TEXT#</li>',
'</ul>',
'</div>',
'',
'<div class="htmldbInfoBodyP">For example:</div>',
'<pre>',
'&lt;/a&gt;&lt;/label&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 04-OCT-2001 17:03:20'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(134197704797432845)
,p_name=>'P85_ID_NEXT'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(117328027016407678)
,p_prompt=>'P85_ID_NEXT'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(134198124866432849)
,p_name=>'P85_ID_PREV'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(117328027016407678)
,p_prompt=>'P85_ID_PREV'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(134198526515432851)
,p_name=>'P85_ID_COUNT'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(92740432474418784)
,p_prompt=>'Item Template'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies item template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(164789621894411360)
,p_name=>'F4000_P85_REFERENCE_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(33419222793056919)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Reference Master Template From'
,p_source=>'REFERENCE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FLOW_SUBSCRIBE_FROM_FIELD_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||',
'lower(wwv_flow_lang.system_message(''NO_TEMPLATE''))||',
''' -'' d, 0 r from dual union all',
'select flow_id||'' : ''||template_name||decode(theme_id,null,'''','' (''||theme_id||'')'') d, id r',
'from   wwv_flow_field_templates',
'where  flow_id != nvl(:fb_flow_id,0) and flow_id in (',
'select f.id',
'from   wwv_main_apps_dev f',
'where  security_group_id = :flow_security_group_id and',
'       build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') and',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and ( flow_id is null or flow_id = f.id) and security_group_id = :flow_security_group_id)',
')',
'order by 1'))
,p_cSize=>60
,p_cMaxlength=>2000
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">You may select an existing template in this workspace or another template in your workspace''s schema. By selecting an existing template, you become a subscriber to that template.</div>',
'<div class="htmldbInfoBodyP">To load a new copy of any master template, click <span class="fielddatabold">Refresh</span>.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(174593500252568645)
,p_name=>'F4000_P85_ON_ERROR_BEFORE_LABEL'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(174456326258809270)
,p_use_cache_before_default=>'NO'
,p_prompt=>'On Error Before Label'
,p_source=>'ON_ERROR_BEFORE_LABEL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>3
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Enter HTML to precede the item label when a application displays an inline validation error message for the item.</div>',
'',
'<div class="htmldbInfoBodyP">The following substitution strings are available for this attribute:',
'<ul class="noIndent">',
'<li>#CURRENT_FORM_ELEMENT#</li>',
'<li>#CURRENT_ITEM_ID#</li>',
'<li>#CURRENT_ITEM_NAME#</li>',
'<li>#CURRENT_ITEM_HELP_TEXT#</li>',
'<li>#ERROR_TEMPLATE#</li>',
'</ul>',
'</div>',
'',
'<div class="htmldbInfoBodyP">For example:</div>',
'<pre>&lt;font class="fieldtitleleft"&gt;#ERROR_MESSAGE#&lt;/font&gt;</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(174594825256572260)
,p_name=>'F4000_P85_ON_ERROR_AFTER_LABEL'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(174456326258809270)
,p_use_cache_before_default=>'NO'
,p_prompt=>'On Error After Label'
,p_source=>'ON_ERROR_AFTER_LABEL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>3
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Enter HTML to be appended to the item label when a application  displays an inline validation error message for the item. For example:</div>',
'<pre>',
'&amp;nbsp;]&lt;/font&gt;',
'</pre>',
'<div class="htmldbInfoBodyP">This example would append a space and a closing bracket to the displayed item label with the error.</div>',
'',
'<div class="htmldbInfoBodyP">The following substitution strings are available for this attribute:',
'<ul class="noIndent">',
'<li>#CURRENT_FORM_ELEMENT#</li>',
'<li>#CURRENT_ITEM_ID#</li>',
'<li>#CURRENT_ITEM_NAME#</li>',
'<li>#CURRENT_ITEM_HELP_TEXT#</li>',
'<li>#ERROR_TEMPLATE#</li>',
'</ul>',
'</div>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(485601558507146365)
,p_name=>'P85_BEFORE_ELEMENT'
,p_item_sequence=>92
,p_item_plug_id=>wwv_flow_imp.id(92735416527411011)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Before Item'
,p_source=>'BEFORE_ELEMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter HTML to be displayed directly before the form item. This is typically used to wrap an item into a DIV container or to display a help button before or after the form item. </p>',
'<p>',
'<div class="htmldbInfoBodyP">The following substitution strings are available for this attribute:',
'<ul class="noIndent">',
'<li>#CURRENT_FORM_ELEMENT#</li>',
'<li>#CURRENT_ITEM_ID#</li>',
'<li>#CURRENT_ITEM_NAME#</li>',
'<li>#CURRENT_ITEM_HELP_TEXT#</li>',
'<li>#CURRENT_ITEM_CONTAINER_ID#</li>',
'<li>#ITEM_PRE_TEXT#</li>',
'<li>#HELP_TEMPLATE#</li>',
'<li>#INLINE_HELP_TEMPLATE#</li>',
'<li>#ERROR_TEMPLATE#</li>',
'<li>#ITEM_COLUMN_SPAN_NUMBER#</li>',
'<li>#ITEM_COLUMN_SPAN_ALPHA#</li>',
'<li>#ITEM_COLUMN_SPAN_WORD#</li>',
'<li>#ITEM_COLUMN_SPAN_PLURAL#</li>',
'</ul>',
'</div>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(485602045834156005)
,p_name=>'P85_AFTER_ELEMENT'
,p_item_sequence=>122
,p_item_plug_id=>wwv_flow_imp.id(92735416527411011)
,p_use_cache_before_default=>'NO'
,p_prompt=>'After Item'
,p_source=>'AFTER_ELEMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter HTML to be displayed directly after the form item. This is typically used to wrap an item into a DIV container or to display a help button before or after the form item. </p>',
'<p>',
'<div class="htmldbInfoBodyP">The following substitution strings are available for this attribute:',
'<ul class="noIndent">',
'<li>#CURRENT_FORM_ELEMENT#</li>',
'<li>#CURRENT_ITEM_ID#</li>',
'<li>#CURRENT_ITEM_NAME#</li>',
'<li>#ITEM_POST_TEXT#</li>',
'<li>#CURRENT_ITEM_HELP_TEXT#</li>',
'<li>#CURRENT_ITEM_CONTAINER_ID#</li>',
'<li>#HELP_TEMPLATE#</li>',
'<li>#INLINE_HELP_TEMPLATE#</li>',
'<li>#ERROR_TEMPLATE#</li>',
'</ul>',
'</div>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(485603564569198386)
,p_name=>'P85_HELP_LINK'
,p_item_sequence=>152
,p_item_plug_id=>wwv_flow_imp.id(92735416527411011)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Help Template'
,p_source=>'HELP_LINK'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'The help sub template allows for defining the link or button used to invoke the item level help. This sub template is only rendered for items that have help defined. ',
'</p>',
'<p>',
'<div class="htmldbInfoBodyP">The following substitution strings are available for this attribute:',
'<ul class="noIndent">',
'<li>#CURRENT_FORM_ELEMENT#</li>',
'<li>#CURRENT_ITEM_ID#</li>',
'<li>#CURRENT_ITEM_NAME#</li>',
'<li>#CURRENT_ITEM_HELP_LABEL#</li>',
'<li>#CURRENT_ITEM_HELP_TEXT#</li>',
'</ul>',
'</div>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(505633752141058243)
,p_name=>'P85_ERROR_TEMPLATE'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_imp.id(174456326258809270)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Error Template'
,p_source=>'ERROR_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the HTML rendered  to display the inline validation error message. Use the #ERROR_MESSAGE# substitution string to reference the message text. The error template can be included in the before and after item attributes using the #ERROR_TEMPLATE# '
||'substitution string.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(582266286585682833)
,p_name=>'P85_INLINE_HELP_TEXT'
,p_item_sequence=>162
,p_item_plug_id=>wwv_flow_imp.id(92735416527411011)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Inline Help Template'
,p_source=>'INLINE_HELP_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'The help sub template allows for defining the inline help text to be displayed immediately with the item. This sub template is only rendered for items that have inline help text defined. ',
'</p>',
'<p>',
'<div class="htmldbInfoBodyP">The following substitution strings are available for this attribute:',
'<ul class="noIndent">',
'<li>#CURRENT_FORM_ELEMENT#</li>',
'<li>#CURRENT_ITEM_ID#</li>',
'<li>#CURRENT_ITEM_NAME#</li>',
'<li>#CURRENT_ITEM_HELP_LABEL#</li>',
'<li>#CURRENT_ITEM_INLINE_HELP_TEXT#</li>',
'</ul>',
'</div>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(582266754792682838)
,p_name=>'P85_ITEM_PRE_TEXT'
,p_item_sequence=>132
,p_item_plug_id=>wwv_flow_imp.id(92735416527411011)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Item Pre Text'
,p_source=>'ITEM_PRE_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter HTML for the "Item Pre Text" subtemplate to format the <strong>Pre Text</strong> attribute content. This template can then be referenced in the <strong>Before Element</strong> template with the #ITEM_PRE_TEXT# substitution.</p>',
'<p>',
'<div class="htmldbInfoBodyP">The following substitution strings are available for this attribute:',
'<ul class="noIndent">',
'<li>#CURRENT_FORM_ELEMENT#</li>',
'<li>#CURRENT_ITEM_ID#</li>',
'<li>#CURRENT_ITEM_NAME#</li>',
'<li>#CURRENT_ITEM_PRE_TEXT#</li>',
'</ul>',
'</div>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(582266852717682839)
,p_name=>'P85_ITEM_POST_TEXT'
,p_item_sequence=>142
,p_item_plug_id=>wwv_flow_imp.id(92735416527411011)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Item Post Text'
,p_source=>'ITEM_POST_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter HTML for the "Item Post Text" subtemplate to format the <strong>Post Text</strong> attribute content. This template can then be referenced in the <strong>After Element</strong> template with the #ITEM_POST_TEXT# substitution.</p>',
'<p>',
'<div class="htmldbInfoBodyP">The following substitution strings are available for this attribute:',
'<ul class="noIndent">',
'<li>#CURRENT_FORM_ELEMENT#</li>',
'<li>#CURRENT_ITEM_ID#</li>',
'<li>#CURRENT_ITEM_NAME#</li>',
'<li>#CURRENT_ITEM_POST_TEXT#</li>',
'</ul>',
'</div>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(757097056956899232)
,p_name=>'F4000_P85_INTERNAL_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(92676922957336244)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Identifier'
,p_source=>'INTERNAL_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Template identifier, this is used when switching and upgrading themes and cannot be modified.',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'Generated 04-OCT-2001 17:03:20'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2104554249597408892)
,p_name=>'P85_THEME_IS_SUBSCRIBED'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(92676922957336244)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(146679113978670858)
,p_computation_sequence=>10
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P85_THEME'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2104570321156417112)
,p_computation_sequence=>20
,p_computation_item=>'P85_THEME_IS_SUBSCRIBED'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'    l_is_subscribed varchar2(16) := ''NONE'';',
'begin',
'  ',
'    for c1 in (',
'        select t.reference_id template_ref_id, ',
'               th.reference_id theme_ref_id',
'          from wwv_flow_field_templates t, ',
'               wwv_flow_themes th',
'         where t.id                 = :F4000_P85_ID',
'           and t.flow_id            = th.flow_id',
'           and t.theme_id           = th.theme_id',
'           and t.security_group_id  = :WORKSPACE_ID',
'           and th.security_group_id = t.security_group_id',
'    ) loop',
'        if c1. theme_ref_id is not null then',
'            if c1.template_ref_id is not null then',
'                l_is_subscribed := ''BOTH'';',
'            else ',
'                l_is_subscribed := ''THEME'';',
'            end if;',
'        end if;',
'    end loop;',
'',
'    return l_is_subscribed;',
'',
'end;'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(35453411819681960)
,p_computation_sequence=>20
,p_computation_item=>'F4000_P85_REFRESH'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'Unable to compute item value.'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(90835616177711401)
,p_validation_name=>'TemplateNameMand'
,p_validation_sequence=>10
,p_validation=>'F4000_P85_TEMPLATE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Template Name must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(92677422219336246)
,p_associated_item=>wwv_flow_imp.id(92679924863336270)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(164805403335435117)
,p_validation_name=>'reference id not null'
,p_validation_sequence=>20
,p_validation=>'F4000_P85_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Reference ID must be specified to refresh the template.'
,p_when_button_pressed=>wwv_flow_imp.id(164764703441381497)
,p_associated_item=>wwv_flow_imp.id(164789621894411360)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(164813222516441453)
,p_validation_name=>'reference id not zero'
,p_validation_sequence=>30
,p_validation=>'F4000_P85_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_ZERO'
,p_error_message=>'Template to refresh must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(164764703441381497)
,p_associated_item=>wwv_flow_imp.id(164789621894411360)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(116572254618859461)
,p_validation_name=>'unique template name'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_field_templates ',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :WORKSPACE_ID',
'   and theme_id          = :P85_THEME',
'   and template_name     = :F4000_P85_TEMPLATE_NAME',
'   and id               != :F4000_P85_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Template name must be unique'
,p_associated_item=>wwv_flow_imp.id(92679924863336270)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(24048575906574812)
,p_tabular_form_region_id=>wwv_flow_imp.id(21546336307856480)
,p_validation_name=>'Template Options - No duplicates name'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_template_options',
' where flow_id              = :FB_FLOW_ID',
'   and theme_id             = :P85_THEME',
'   and field_template_id    = :F4000_P85_ID',
'   and security_group_id    = :WORKSPACE_ID',
'   and name                 = :NAME',
'   and template_types       = :TEMPLATE_TYPES',
'   and (:ID is null or id != :ID)'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#COLUMN_HEADER# must be unique.'
,p_validation_condition=>'F4000_P85_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_exec_cond_for_each_row=>'Y'
,p_associated_column=>'NAME'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(24048670968574813)
,p_tabular_form_region_id=>wwv_flow_imp.id(21546336307856480)
,p_validation_name=>'Template Options - No duplicates classes'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_template_options',
' where flow_id              = :FB_FLOW_ID',
'   and theme_id             = :P85_THEME',
'   and field_template_id    = :F4000_P85_ID',
'   and security_group_id    = :WORKSPACE_ID',
'   and css_classes          = :CSS_CLASSES',
'   and template_types       = :TEMPLATE_TYPES',
'   and (:ID is null or id != :ID)'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#COLUMN_HEADER# must be unique.'
,p_validation_condition=>'F4000_P85_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_exec_cond_for_each_row=>'Y'
,p_associated_column=>'CSS_CLASSES'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(397288330998365438)
,p_name=>'ENABLE PREVIOUS'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P85_ID_PREV'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(397288601940365438)
,p_event_id=>wwv_flow_imp.id(397288330998365438)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(134194118755432829)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(397288708273368392)
,p_name=>'ENABLE NEXT'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P85_ID_NEXT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(397289009991368392)
,p_event_id=>wwv_flow_imp.id(397288708273368392)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(134194006039432829)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(9691016866802643)
,p_name=>'upper case identifier'
,p_event_sequence=>30
,p_triggering_element_type=>'COLUMN'
,p_triggering_region_id=>wwv_flow_imp.id(21546336307856480)
,p_triggering_element=>'DISPLAY_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(9691226544802645)
,p_event_id=>wwv_flow_imp.id(9691016866802643)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
':NAME := regexp_replace(',
'      srcstr     => :DISPLAY_NAME,',
'      pattern    => ''[^'' || wwv_flow_utilities.c_alnum || '']+'',',
'      replacestr => ''_'' );'))
,p_attribute_02=>'DISPLAY_NAME'
,p_attribute_03=>'NAME'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(9691377432802646)
,p_name=>'refresh template options on cancel'
,p_event_sequence=>40
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'body'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosecanceldialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(9691445778802647)
,p_event_id=>wwv_flow_imp.id(9691377432802646)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(21546336307856480)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(9691568432802648)
,p_event_id=>wwv_flow_imp.id(9691377432802646)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(709059267654700233)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3001211765333510)
,p_name=>'Show Publish Success Msg'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(166470213174105062)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3001313446333511)
,p_event_id=>wwv_flow_imp.id(3001211765333510)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ( this.data.successMessage ) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(92680927070336277)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_FIELD_TEMPLATES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_FIELD_TEMPLATES'
,p_attribute_03=>'F4000_P85_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Error fetching row.'
,p_internal_uid=>92680927070336277
,p_process_comment=>'Generated 04-OCT-2001 17:03:21'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(134199514652432857)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_PAGINATION'
,p_process_name=>'Get Next or Previous Primary Key Value'
,p_attribute_02=>'WWV_FLOW_FIELD_TEMPLATES'
,p_attribute_03=>'F4000_P85_ID'
,p_attribute_04=>'ID'
,p_attribute_07=>'THEME_ID'
,p_attribute_08=>'TEMPLATE_NAME'
,p_attribute_09=>'P85_ID_NEXT'
,p_attribute_10=>'P85_ID_PREV'
,p_attribute_13=>'P85_ID_COUNT'
,p_attribute_14=>'flow_id = :fb_flow_id'
,p_process_error_message=>'Unable to run Get Next or Previous Primary Key Value process.'
,p_internal_uid=>134199514652432857
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(164822026170454934)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh field template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_field_template (',
'    p_master_template_id         => :F4000_P85_REFERENCE_ID,',
'    p_subscribing_template_id    => :F4000_P85_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying template.'
,p_process_when_button_id=>wwv_flow_imp.id(164764703441381497)
,p_process_when=>'F4000_P85_REFERENCE_ID'
,p_process_when_type=>'VALUE_OF_ITEM_IN_COND_1_NOT_EQ_COND_2'
,p_process_when2=>'0'
,p_process_success_message=>'Template copied.'
,p_internal_uid=>164822026170454934
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(92681202519336282)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_FIELD_TEMPLATES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_FIELD_TEMPLATES'
,p_attribute_03=>'F4000_P85_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_process_error_message=>'Error updating item template.'
,p_process_when=>'COPY_TEMPLATE'
,p_process_when_type=>'REQUEST_NOT_IN_CONDITION'
,p_process_success_message=>'Item template updated.'
,p_internal_uid=>92681202519336282
,p_process_comment=>'Generated 04-OCT-2001 17:03:21'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(35459624315691365)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh template 2'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_field_template (',
'    p_master_template_id         => :F4000_P85_REFERENCE_ID,',
'    p_subscribing_template_id    => :F4000_P85_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying template.'
,p_process_when=>':F4000_P85_REFERENCE_ID is not null and :F4000_P85_REFRESH = ''Y'' and (upper(:request) like ''APPLY%'' or upper(:request) like ''SAVE'')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Template copied.'
,p_internal_uid=>35459624315691365
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1449463447340055537)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sync template option presets'
,p_process_sql_clob=>'wwv_flow_templates_util.sync_field_tmplopt_presets(:F4000_P85_ID);'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'nvl(:P85_PRESET_TEMPLATE_OPTIONS,''NOPRESETS'') <> nvl(:P85_PRESET_TMPLOPT_CHECK,''NOPRESETS'') '
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>1449463447340055537
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(164826810858462036)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove reference id as needed'
,p_process_sql_clob=>'wwv_flow_copy_metadata.remove_field_reference_id (:F4000_P85_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error setting template id to null.'
,p_process_when_type=>'VALUE_OF_ITEM_IN_COND_1_EQ_COND_2'
,p_internal_uid=>164826810858462036
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(12512055240209385)
,p_process_sequence=>80
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(21546336307856480)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Template Options - Save Interactive Grid Data'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>12512055240209385
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(24048434490574811)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_region_id=>wwv_flow_imp.id(21546336307856480)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'upper :name'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':NAME := REGEXP_REPLACE(',
'      srcstr     => :NAME,',
'      pattern    => ''[^'' || wwv_flow_utilities.c_alnum || '']+'',',
'      replacestr => ''_'' );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'F4000_P85_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_exec_cond_for_each_row=>'Y'
,p_internal_uid=>24048434490574811
);
end;
/
prompt --application/pages/page_00086
begin
wwv_flow_imp_page.create_page(
 p_id=>86
,p_name=>'Upgrade Application'
,p_alias=>'UPGRADE-APPLICATION'
,p_step_title=>'Upgrade Application - Select Validations to Upgrade'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(202555930603939361)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>50
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(484011119835581586)
,p_plug_name=>'Validations'
,p_region_template_options=>'#DEFAULT#:a-Region--scrollAuto:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case when c009 is not null then null',
'            else htmldb_item.checkbox(1, n002,(',
'                 select ''CHECKED'' from wwv_flow_collections ',
'                  where collection_name = ''UPGRADE_VALIDATIONS'' ',
'                    and n001 = v.n002),null,'':'',''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0'') ,',
'wwv_flow_lang.system_message(''VALIDATION_LABEL'',wwv_flow_escape.html(c005))) ',
'            end checkbox,',
'       c004 item_name,',
'       c005 validation_name,',
'       c006 validation_type,',
'       c009 additional_info,',
'       c010 page_locked_by,',
'       c007 button_name,',
'       c008 condition,',
'       c011 cond_exp1,',
'       c012 cond_exp2',
'  from wwv_flow_collections v',
' where collection_name = ''ADV_UPGRADE_REPORT''',
'   and n001 = :P86_PAGE_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(484011313289581594)
,p_name=>'Migration Objects'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No Validations found for Migration.'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_show_finder_drop_down=>'N'
,p_show_search_textbox=>'N'
,p_show_actions_menu=>'N'
,p_report_list_mode=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_enable_mail_download=>'N'
,p_owner=>'SATHISH'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(492607622837106443)
,p_db_column_name=>'CHECKBOX'
,p_display_order=>1
,p_column_identifier=>'F'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(492043509244609378)
,p_db_column_name=>'VALIDATION_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Validation Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(631192612011521069)
,p_db_column_name=>'ITEM_NAME'
,p_display_order=>3
,p_column_identifier=>'I'
,p_column_label=>'Item Name'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(631192830811521069)
,p_db_column_name=>'VALIDATION_TYPE'
,p_display_order=>4
,p_column_identifier=>'K'
,p_column_label=>'Validation Type'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_imp.id(630881727193397263)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(692607705216923380)
,p_db_column_name=>'ADDITIONAL_INFO'
,p_display_order=>5
,p_column_identifier=>'O'
,p_column_label=>'Additional Information'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(692607805513923383)
,p_db_column_name=>'PAGE_LOCKED_BY'
,p_display_order=>6
,p_column_identifier=>'P'
,p_column_label=>'Page Locked By'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(492043708517609378)
,p_db_column_name=>'BUTTON_NAME'
,p_display_order=>7
,p_column_identifier=>'D'
,p_column_label=>'Associated Button'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(631192904691521070)
,p_db_column_name=>'CONDITION'
,p_display_order=>8
,p_column_identifier=>'L'
,p_column_label=>'Condition'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_imp.id(13602414170805697)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(631193011047521070)
,p_db_column_name=>'COND_EXP1'
,p_display_order=>9
,p_column_identifier=>'M'
,p_column_label=>'Expression 1'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(631193115661521070)
,p_db_column_name=>'COND_EXP2'
,p_display_order=>10
,p_column_identifier=>'N'
,p_column_label=>'Expression 2'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(484011830383581643)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1300032392536646'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_view_mode=>'REPORT'
,p_report_columns=>'CHECKBOX:VALIDATION_TYPE:VALIDATION_NAME:ITEM_NAME:BUTTON_NAME:CONDITION:COND_EXP1:COND_EXP2'
,p_sort_column_1=>'VALIDATION_TYPE'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'VALIDATION_NAME'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(484018600220797746)
,p_plug_name=>'Wizard Menu'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-WizardSteps--slim'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>40
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(484017424976766961)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
,p_plug_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(499049722727446319)
,p_plug_name=>'Upgrade Application'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747137722601138152)
,p_plug_name=>'Upgrade Application'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(615673214634571526)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(202555930603939361)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:674:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(484012205657581654)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(202555930603939361)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :p86_page is null then',
'  return true;',
'else',
'  for c1 in (select 1 x from wwv_flow_lock_page where locked_by is not null and flow_id = :fb_flow_id and object_id = :p86_page) loop',
'     return false;',
'  end loop;',
'end if;',
'return true;'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'FUNCTION_BODY'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(499677731748000481)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(202555930603939361)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:911:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(484014412205581703)
,p_branch_action=>'f?p=&APP_ID.:646:&SESSION.::&DEBUG.::P646_PAGE_ID:&P86_PAGE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(484012205657581654)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(493043430085874630)
,p_name=>'P86_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(499049722727446319)
,p_prompt=>'Page:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(499813525383339193)
,p_validation_name=>'requires object selection'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if WWV_FLOW.G_F01.COUNT = 0 then',
'   return false;',
'else',
'   return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'You must select at least one Validation to proceed.'
,p_when_button_pressed=>wwv_flow_imp.id(484012205657581654)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2045580542019367802)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(484011119835581586)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2045580620939367803)
,p_event_id=>wwv_flow_imp.id(2045580542019367802)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(492598111175961164)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Add Validations'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_collection_status number;',
'   l_id                number;',
'   l_count             number;',
'begin',
'    wwv_flow_collection.create_or_truncate_collection(',
'        p_collection_name => ''UPGRADE_VALIDATIONS'');',
'    for i in 1..wwv_flow.g_f01.count ',
'    loop',
'        l_id := wwv_flow.g_f01(i);',
'        select count(*) into l_count ',
'          from wwv_flow_collections ',
'         where n001            = l_id ',
'           and collection_name = ''UPGRADE_VALIDATIONS'';',
'        if l_count = 0 then ',
'            l_collection_status := wwv_flow_collection.add_member(',
'                 p_collection_name => ''UPGRADE_VALIDATIONS'',',
'                 p_n001            => l_id);',
'        end if;',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>492598111175961164
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(631633708927666117)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'clear collections'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.create_or_truncate_collection(',
'   p_collection_name => ''UPGRADE_VALIDATIONS'');',
'wwv_flow_collection.create_or_truncate_collection(',
'   p_collection_name => ''UPGRADE_BUTTONS'');',
'wwv_flow_collection.create_or_truncate_collection(',
'   p_collection_name => ''UPGRADE_VALIDATIONS2'');'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>631633708927666117
);
end;
/
prompt --application/pages/page_00087
begin
wwv_flow_imp_page.create_page(
 p_id=>87
,p_name=>'List of Values Utilization'
,p_alias=>'LIST-OF-VALUES-UTILIZATION'
,p_step_title=>'List of Values Utilization'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_lov.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(631175403847405645)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(203029530177365353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Lists of Values'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(631182627915434600)
,p_plug_name=>'List of Values Utilization'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX4000P87a lov_util */ id, lov_name, ',
'(select count(*) ',
' from wwv_flow_step_items i',
' where flow_id = :fb_flow_id and i.named_lov = a.lov_name)',
' item_references,',
'(select count(*) ',
' from wwv_flow_region_report_column c',
' where c.flow_id = a.flow_id and c.security_group_id = a.security_group_id and c.named_lov = a.id) +',
'(select count(*) ',
' from wwv_flow_region_columns c',
' where c.flow_id = a.flow_id and c.security_group_id = a.security_group_id and ( c.lov_id = a.id or c.filter_lov_id = a.id )) ',
' report_column_references,',
'(select count(*)',
'from wwv_flow_worksheet_columns c',
'where c.flow_id = a.flow_id and c.security_group_id = a.security_group_id and',
'          c.rpt_named_lov = a.id) ir_references,',
'(select count(*) ',
' from wwv_flow_step_items i',
' where flow_id = :fb_flow_id and i.named_lov = a.lov_name)',
' +',
'(select count(*) ',
' from wwv_flow_region_report_column c',
' where c.flow_id = a.flow_id and c.security_group_id = a.security_group_id and c.named_lov = a.id) ',
' +',
'(select count(*) ',
' from wwv_flow_region_columns c',
' where c.flow_id = a.flow_id and c.security_group_id = a.security_group_id and ( c.lov_id = a.id or c.filter_lov_id = a.id ))',
'+',
'(select count(*)',
'from wwv_flow_worksheet_columns c',
'where c.flow_id = a.flow_id and c.security_group_id = a.security_group_id and',
'          c.rpt_named_lov = a.id)',
'  total_references',
'from WWV_FLOW_LISTS_OF_VALUES$ a',
'where  flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(631182707640434600)
,p_name=>'Utilization'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(631182924063434607)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(631183011459434609)
,p_db_column_name=>'LOV_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Name'
,p_column_link=>'f?p=&APP_ID.:4111:&SESSION.::&DEBUG.:4111:F4000_P4111_ID,FB_FLOW_ID:#ID#,&FB_FLOW_ID.:'
,p_column_linktext=>'#LOV_NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(631183127036434609)
,p_db_column_name=>'ITEM_REFERENCES'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Item References'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(631187225842449831)
,p_db_column_name=>'REPORT_COLUMN_REFERENCES'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Report Column References'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(631190215631484751)
,p_db_column_name=>'IR_REFERENCES'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Interactive Report References'
,p_allow_filtering=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(631198409856691182)
,p_db_column_name=>'TOTAL_REFERENCES'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Total References'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(631183407357435034)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1300132759536646'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'LOV_NAME:ITEM_REFERENCES:REPORT_COLUMN_REFERENCES:IR_REFERENCES:TOTAL_REFERENCES'
,p_sort_column_1=>'LOV_NAME'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'TOTAL_REFERENCES'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(631190424635487365)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(631182627915434600)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:87:&SESSION.::&DEBUG.:87,RIR,CIR::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(631193904981536440)
,p_branch_action=>'f?p=&FLOW_ID.:87:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(631200914975787319)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'87'
);
end;
/
prompt --application/pages/page_00089
begin
wwv_flow_imp_page.create_page(
 p_id=>89
,p_name=>'Upgrade Application'
,p_alias=>'UPGRADE-APPLICATION5'
,p_step_title=>'Upgrade Application'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_utilties.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(444636405193158991)
,p_plug_name=>'Upgrade Application'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'The available upgrade types are displayed along with the number of objects that can be upgraded.  Click on the object count to review the candidates and upgrade.',
'</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(444642525765435028)
,p_plug_name=>'Upgrade Summary'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ob,',
'       migration_type,',
'       migration_type as migration_type_code,',
'       object_count',
'  from ( select 1 ob, ',
'                ''NUMBER_FIELD''    as migration_type,',
'                count(*)          as object_count',
'           from wwv_flow_step_items i,',
'                wwv_flow_step_validations v',
'          where i.flow_id           = :FB_FLOW_ID',
'            and i.security_group_id = :WORKSPACE_ID',
'            and i.display_as        in (''TEXT'',''NATIVE_TEXT_FIELD'')',
'            and v.flow_id           = i.flow_id',
'            and v.flow_step_id      = i.flow_step_id',
'            and v.validation_type   = ''ITEM_IS_NUMERIC''',
'            and v.validation        = i.name',
'            and v.validation_condition_type is null',
'            and v.when_button_pressed       is null',
'         having count(*) > 0',
'          union',
'         select 3 ob, ',
'                ''REQUIRED''        as migration_type,',
'                count(*)          as object_count',
'           from wwv_flow_step_items i,',
'                wwv_flow_step_validations v',
'          where i.flow_id           = :FB_FLOW_ID',
'            and i.security_group_id = :WORKSPACE_ID',
'            and v.flow_id           = i.flow_id',
'            and v.flow_step_id      = i.flow_step_id',
'            and v.validation_type   = ''ITEM_NOT_NULL''',
'            and v.validation        = i.name',
'            and v.validation_condition_type is null',
'            and v.when_button_pressed       is null',
'         having count(*) > 0',
'          union',
'         select 15 ob, ',
'                ''ADVANCED''        as migration_type,',
'                count(*)          as object_count',
'           from wwv_flow_step_items i,',
'                wwv_flow_step_validations v',
'          where i.flow_id           = :FB_FLOW_ID',
'            and i.security_group_id = :WORKSPACE_ID',
'            and v.flow_id           = i.flow_id',
'            and v.flow_step_id      = i.flow_step_id',
'            and ((v.validation_type = ''ITEM_IS_NUMERIC'' and ',
'                  i.display_as in (''TEXT'',''NATIVE_TEXT_FIELD'')) or',
'                 v.validation_type in (''ITEM_NOT_NULL'',''ITEM_IS_DATE''))',
'            and v.validation        = i.name',
'            and (v.when_button_pressed is not null or',
'                 v.validation_condition_type is not null)',
'         having count(*) > 0',
'          union',
'         select 5 ob, ',
'                ''LOV_NULL_VALUE''  as migration_type,',
'                count(*)          as object_count',
'           from wwv_flow_step_items',
'          where flow_id           = :FB_FLOW_ID',
'            and security_group_id = :WORKSPACE_ID',
'            and lov_null_value    = ''%null%''',
'         having count(*) > 0',
'          union',
'         select 6 ob, ',
'                ''DATE_PICKER''     as migration_type,',
'                count(*)          as object_count',
'           from wwv_flow_step_items',
'          where flow_id           = :FB_FLOW_ID',
'            and security_group_id = :WORKSPACE_ID',
'            and display_as        = ''NATIVE_DATE_PICKER_CLASSIC''',
'         having count(*) > 0',
'          union',
'         select 11 ob, ',
'                ''IR_GROUP_BY''  as migration_type,',
'                count(*)          as object_count',
'           from wwv_flow_worksheets',
'          where flow_id           = :FB_FLOW_ID',
'            and security_group_id = :WORKSPACE_ID',
'            and show_group_by     = ''N''',
'            and show_search_bar   = ''Y''',
'            and show_actions_menu = ''Y''',
'         having count(*) > 0',
'          union',
'         select 12 ob, ',
'                ''IR_SAVE_PUBLIC''  as migration_type,',
'                count(*)          as object_count',
'           from wwv_flow_worksheets',
'          where flow_id               = :FB_FLOW_ID',
'            and security_group_id     = :WORKSPACE_ID',
'            and allow_save_rpt_public = ''N''',
'            and show_search_bar       = ''Y''',
'            and show_actions_menu     = ''Y''',
'         having count(*) > 0',
'          union',
'         select 13 ob, ',
'                ''IR_SUBSCRIBE''  as migration_type,',
'                count(*)          as object_count',
'           from wwv_flow_worksheets',
'          where flow_id           = :FB_FLOW_ID',
'            and security_group_id = :WORKSPACE_ID',
'            and show_notify       = ''N''',
'            and show_search_bar   = ''Y''',
'            and show_actions_menu = ''Y''',
'         having count(*) > 0',
'           union',
'         select 14 ob, ',
'                ''IR_ROWS_PER_PAGE''  as migration_type,',
'                count(*)          as object_count',
'           from wwv_flow_worksheets',
'          where flow_id            = :FB_FLOW_ID',
'            and security_group_id  = :WORKSPACE_ID',
'            and show_display_row_count = ''N''',
'            and show_search_bar    = ''Y''',
'         having count(*) > 0',
'           union',
'        select 15 ob, ',
'                ''IR_PIVOT''  as migration_type,',
'                count(*)    as object_count',
'           from wwv_flow_worksheets',
'          where flow_id            = :FB_FLOW_ID',
'            and security_group_id  = :WORKSPACE_ID',
'            and show_pivot         = ''N''',
'            and show_search_bar    = ''Y''',
'         having count(*) > 0',
'            union',
'         select 17 ob, ',
'                ''CALENDAR_TO_CSS_CALENDAR''    as migration_type,',
'                count(*)          as object_count',
'           from wwv_flow_page_plugs',
'          where flow_id           = :FB_FLOW_ID',
'            and security_group_id = :WORKSPACE_ID',
'            and plug_source_type  = ''NATIVE_CALENDAR''',
'         having count(*) > 0',
'           union',
'         select 19 ob, ',
'                ''IR_FIXED_HEADER'' as migration_type,',
'                count(*)          as object_count',
'           from wwv_flow_worksheets',
'          where flow_id           = :FB_FLOW_ID',
'            and security_group_id = :WORKSPACE_ID',
'            and fixed_header      = ''NONE''',
'         having count(*) > 0',
'           union',
'         select 21 ob, ',
'                ''TABULAR_TO_IG'' as migration_type,',
'                count(*)          as object_count',
'           from wwv_flow_page_plugs',
'          where flow_id           = :FB_FLOW_ID',
'            and security_group_id =  :WORKSPACE_ID',
'            and plug_source_type  = ''NATIVE_TABFORM''',
'         having count(*) > 0       ',
'                  union',
'         select 22 ob, ',
'                ''SWITCH''   as migration_type,',
'                count(*)          as object_count',
'           from wwv_flow_step_items',
'          where flow_id           = :FB_FLOW_ID',
'            and security_group_id =  :WORKSPACE_ID',
'            and display_as        in ( ''NATIVE_SELECT_LIST'', ''NATIVE_RADIOGROUP'')',
'            and wwv_flow_upgrade_app.can_update_to_switch( flow_id, lov, named_lov, lov_display_extra, lov_display_null, display_as, attribute_01, attribute_02, attribute_03 ) = ''Y''',
'         having count(*) > 0',
'                  union',
'         select 23 ob, ',
'                ''FORM_REGION''   as migration_type,',
'                count(*)          as object_count',
'           from wwv_flow_steps',
'          where flow_id           = :FB_FLOW_ID',
'            and security_group_id =  :WORKSPACE_ID',
'            and wwv_flow_upgrade_app.can_update_to_form_region( flow_id, id ) = ''Y''',
'         having count(*) > 0   ',
'                  union',
'         select 24 ob, ',
'                ''DATE_PICKER_APEX'' as migration_type,',
'                count(*)          as object_count',
'           from ( select 1 ',
'                    from wwv_flow_step_items',
'                   where flow_id = :FB_FLOW_ID',
'                     and security_group_id = :WORKSPACE_ID',
'                     and display_as        = ''NATIVE_DATE_PICKER''',
'                union all ',
'                  select 1',
'                    from wwv_flow_region_columns',
'                   where flow_id = :FB_FLOW_ID',
'                     and security_group_id = :WORKSPACE_ID',
'                     and item_type         = ''NATIVE_DATE_PICKER'' )',
'         having count(*) > 0',
'                  union',
'         select 26 ob, ',
'                ''BUTTON_CONFIRM_LINK_TO_NATIVE'' as migration_type,',
'                count(*)                        as object_count',
'           from wwv_flow_step_buttons',
'          where flow_id             = :FB_FLOW_ID',
'            and security_group_id   = :WORKSPACE_ID',
'            and button_action       = ''REDIRECT_URL''',
'            and button_name         = regexp_substr(button_redirect_url, q''{javascript:apex.confirm\(htmldb_delete_message,''(.+)''\);}'', 1, 1, null, 1)',
'            and confirm_enabled     = ''N''',
'         having count(*) > 0',
'         union',
'         select 27 ob, ',
'                ''NUMBER_FIELD_VIRTUAL_KEYBOARD'' as migration_type,',
'                count(*)                        as object_count',
'           from ( select 1',
'                    from wwv_flow_step_items',
'                   where flow_id           = :FB_FLOW_ID',
'                     and security_group_id = :WORKSPACE_ID',
'                     and display_as        = ''NATIVE_NUMBER_FIELD''',
'                     and attribute_04      = ''text''',
'                union all',
'                  select 1',
'                    from wwv_flow_region_columns',
'                   where flow_id           = :FB_FLOW_ID',
'                     and security_group_id = :WORKSPACE_ID',
'                     and item_type         = ''NATIVE_NUMBER_FIELD''',
'                     and attribute_04      = ''text'' )',
'         having count(*) > 0',
'         union',
'         select 28 ob, ',
'                ''START_ALIGN_NUMBER_FIELD''      as migration_type,',
'                count(*)                        as object_count',
'           from ( select 1',
'                    from wwv_flow_step_items',
'                   where flow_id           = :FB_FLOW_ID',
'                     and security_group_id = :WORKSPACE_ID',
'                     and display_as        = ''NATIVE_NUMBER_FIELD''',
'                     and attribute_03      = ''right''',
'                union all',
'                  select 1',
'                    from wwv_flow_region_columns',
'                   where flow_id           = :FB_FLOW_ID',
'                     and security_group_id = :WORKSPACE_ID',
'                     and item_type         = ''NATIVE_NUMBER_FIELD''',
'                     and attribute_03      = ''right'' )',
'         having count(*) > 0',
'       )'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(444642604334435028)
,p_name=>'Migration Objects'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No items found for Upgrade.'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_control_break=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'SATHISH'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(629276118592081823)
,p_db_column_name=>'OB'
,p_display_order=>1
,p_column_identifier=>'G'
,p_column_label=>'Display Sequence'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(484806625030472038)
,p_db_column_name=>'MIGRATION_TYPE'
,p_display_order=>2
,p_column_identifier=>'D'
,p_column_label=>'Upgrade Type'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(484799616606261493)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(484806725795472039)
,p_db_column_name=>'MIGRATION_TYPE_CODE'
,p_display_order=>3
,p_column_identifier=>'E'
,p_column_label=>'Migration Type Code'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(484806800223472039)
,p_db_column_name=>'OBJECT_COUNT'
,p_display_order=>4
,p_column_identifier=>'F'
,p_column_label=>'Candidate Objects'
,p_column_link=>'f?p=&APP_ID.:911:&SESSION.::&DEBUG.:RP,911:P911_UPGRADE_TYPE:#MIGRATION_TYPE_CODE#'
,p_column_linktext=>'#OBJECT_COUNT#'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(444643031700435663)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1300210041536646'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'CHECKBOX:MIGRATION_TYPE:OBJECT_COUNT'
,p_sort_column_1=>'OB'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'0'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(444639125839159043)
,p_branch_action=>'f?p=&FLOW_ID.:89:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_00090
begin
wwv_flow_imp_page.create_page(
 p_id=>90
,p_name=>'Create Standard Tab - New or Existing Tab Set'
,p_alias=>'CREATE-STANDARD-TAB-NEW-OR-EXISTING-TAB-SET'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Standard Tab'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213240607818867991)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46531111870668614)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>140
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(100947024191482524)
,p_plug_name=>'Create Standard Tab'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>'<p>Tabs are grouped in collections called a tab set.  Each tab must be part of a tab set.  A tab can have a one-to-one relationship with a page, or a tab can be the "current tab" for a number of pages.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(100997430155570916)
,p_name=>'Existing Tab Sets'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>130
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select tab_set, ',
' tab_sequence, ',
' tab_step, ',
' substr(tab_text,1,50) tab_text,',
' TAB_ALSO_CURRENT_FOR_PAGES',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'order  by 1, 2'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' -'
,p_query_break_cols=>'1'
,p_query_no_data_found=>'No tab sets exist.'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48873218651772683)
,p_query_column_id=>1
,p_column_alias=>'TAB_SET'
,p_column_display_sequence=>1
,p_column_heading=>'Tab Set'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48873323050772683)
,p_query_column_id=>2
,p_column_alias=>'TAB_SEQUENCE'
,p_column_display_sequence=>2
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48873413021772683)
,p_query_column_id=>3
,p_column_alias=>'TAB_STEP'
,p_column_display_sequence=>3
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48873509183772683)
,p_query_column_id=>4
,p_column_alias=>'TAB_TEXT'
,p_column_display_sequence=>4
,p_column_heading=>'Label'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200002702335706812)
,p_query_column_id=>5
,p_column_alias=>'TAB_ALSO_CURRENT_FOR_PAGES'
,p_column_display_sequence=>5
,p_column_heading=>'Tab Also Current For Pages'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(101139312403928576)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(100922117111440207)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(100953301640492391)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46531111870668614)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(100950323673489322)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(46531111870668614)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(100950727522489326)
,p_branch_action=>'93'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(100950323673489322)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND_TEXT'
,p_branch_condition=>'F4000_P4722_TAB_SET_CHOICE'
,p_branch_condition_text=>'EXISTING'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(101908723794829013)
,p_branch_action=>'94'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(100950323673489322)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND_TEXT'
,p_branch_condition=>'F4000_P4722_TAB_SET_CHOICE'
,p_branch_condition_text=>'NEW'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(100959114893517184)
,p_name=>'F4000_P4722_TAB_SET_CHOICE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(100947024191482524)
,p_item_default=>'EXISTING'
,p_prompt=>'Tab Set'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'TAB_SET_CHOICE'
,p_lov=>'.'||wwv_flow_imp.id(84320304523598135)||'.'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Choose one of the following:',
'<p/>',
'<ul class="noIndent">',
'<li>If your tab set does not exist, choose <strong>Create a new tab set and a new tab within the tab set.</strong>.  ',
'<li>If your tab set does exists, select <strong>Use an existing tab set and create a new tab within the existing tab set.</strong>.',
'Use this option if you already have a tab set and just want a new tab within this tab set.',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(100967617253531308)
,p_name=>'F4000_P90_F'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(100947024191482524)
,p_prompt=>'Application:'
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="fieldtitlebold"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'This attribute identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(574037695052616907)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(100953301640492391)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(574037755179616908)
,p_event_id=>wwv_flow_imp.id(574037695052616907)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(101924313633864135)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validate flow selected'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :FB_FLOW_ID is null then',
'   raise_application_error(''-20000'',''No flow selected'');',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(100950323673489322)
,p_internal_uid=>101924313633864135
);
end;
/
prompt --application/pages/page_00092
begin
wwv_flow_imp_page.create_page(
 p_id=>92
,p_name=>'Create Standard Tab - Confirm'
,p_alias=>'CREATE-STANDARD-TAB-CONFIRM'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Standard Tab'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213240607818867991)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46537707508752518)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(101350830881269568)
,p_plug_name=>'Create Standard Tab'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wiz_confirm.create_standard_tab (',
'    p_flow_id                      => :FB_FLOW_ID,',
'    p_new_parent_tabset            => :F4000_P4722_NEW_PARENT_TABSET,',
'    p_new_parent_tab_text          => v(''F4000_P4722_NEW_PARENT_TAB_TEXT''),',
'    p_parent_tab_set               => :F4000_P4722_PARENT_TAB_SET,',
'    p_tab_set_choice               => :F4000_P4722_TAB_SET_CHOICE,   ',
'    p_tab_set                      => :F4000_P4722_TABSET,    ',
'    p_new_tab_display_text         => v(''F4000_P4722_NEW_TAB_DISPLAY_TEXT''),',
'    p_tab_sequence                 => :F4000_P4722_TAB_SEQUENCE,',
'    p_current_page                 => :F4000_P4722_CURRENT_PAGE,    ',
'    p_current_image                => :F4000_P4722_CURRENT_IMAGE,',
'    p_non_current_page             => :F4000_P4722_NON_CURRENT_PAGE,',
'    p_image_attributes             => :F4000_P4722_IMAGE_ATTRIBUTES,',
'    p_display_condition            => :F4000_P4722_DISPLAY_CONDITION,',
'    p_condition_type               => :F4000_P4722_CONDITION_TYPE,',
'    p_display_condition_text       => v(''F4000_P4722_DISPLAY_CONDITION_TEXT''),',
'    p_build_option                 => :F4000_P4722_BUILD_OPTION);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(101376815088337671)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(100922117111440207)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(101357126367284941)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46537707508752518)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(130446514359)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46537707508752518)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Tab'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(101353724158274798)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(46537707508752518)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(130469708224)
,p_branch_action=>'&F4000_LAST_VIEW.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(130446514359)
,p_branch_sequence=>119
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(101354120578274801)
,p_branch_action=>'4724'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(101353724158274798)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(573755952054229740)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(101357126367284941)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(573756050060229741)
,p_event_id=>wwv_flow_imp.id(573755952054229740)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(130447519223)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Tab'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    n varchar2(4000);',
'begin',
'    n := replace(v(''F4000_P4722_NEW_TAB_DISPLAY_TEXT''),'' '',null);',
'    n := replace(n,''&'',null);',
'    n := replace(n,''_'',null);',
'    n := replace(n,''<'',null);',
'    n := replace(n,''>'',null);',
'    n := replace(n,''?'',null);',
'    n := replace(n,''%'',null);',
'    n := upper(substr(n,1,30));',
'    n := ''T_''||n;',
'    ',
'    if v(''F4000_P4722_TAB_SET_CHOICE'') = ''EXISTING'' then',
'        wwv_flow_imp_shared.create_tab (',
'            p_flow_id                    => nv(''FB_FLOW_ID''),',
'            p_tab_set                    => v(''F4000_P4722_TABSET''),',
'            p_tab_sequence               => v(''F4000_P4722_TAB_SEQUENCE''),',
'            p_tab_name                   => n,',
'            p_tab_image                  => v(''F4000_P4722_CURRENT_IMAGE''),',
'            p_tab_non_current_image      => v(''F4000_P4722_NON_CURRENT_IMAGE''),',
'            p_tab_image_attributes       => v(''F4000_P4722_IMAGE_ATTRIBUTES''),',
'            p_tab_text                   => v(''F4000_P4722_NEW_TAB_DISPLAY_TEXT''),',
'            p_tab_step                   => v(''F4000_P4722_CURRENT_PAGE''),',
'            p_tab_also_current_for_pages => null,',
'            p_tab_parent_tabset          => replace(v(''F4000_P4722_PARENT_TAB_SET''),''%null''||''%'',null),',
'            p_tab_plsql_condition        => v(''F4000_P4722_DISPLAY_CONDITION''),',
'            p_tab_disp_cond_text         => v(''F4000_P4722_DISPLAY_CONDITION_TEXT''),',
'            p_display_condition_type     => replace(v(''F4000_P4722_CONDITION_TYPE''),''%null''||''%'',null),',
'            p_required_patch             => replace(v(''F4000_P4722_BUILD_OPTION''),''%null''||''%'',null),',
'            p_tab_comment                => null);',
'            ',
'    elsif v(''F4000_P4722_TAB_SET_CHOICE'') = ''NEW'' then',
'        wwv_flow_imp_shared.create_tab (',
'            p_flow_id                    => nv(''FB_FLOW_ID''),',
'            p_tab_set                    => v(''F4000_P4722_TABSET''),',
'            p_tab_sequence               => v(''F4000_P4722_TAB_SEQUENCE''),',
'            p_tab_name                   => n,',
'            p_tab_image                  => v(''F4000_P4722_CURRENT_IMAGE''),',
'            p_tab_non_current_image      => v(''F4000_P4722_NON_CURRENT_IMAGE''),',
'            p_tab_image_attributes       => v(''F4000_P4722_IMAGE_ATTRIBUTES''),',
'            p_tab_text                   => v(''F4000_P4722_NEW_TAB_DISPLAY_TEXT''),',
'            p_tab_step                   => v(''F4000_P4722_CURRENT_PAGE''),',
'            p_tab_also_current_for_pages => null,',
'            p_tab_parent_tabset          => replace(v(''F4000_P4722_NEW_PARENT_TABSET''),''%null''||''%'',null),',
'            p_tab_plsql_condition        => v(''F4000_P4722_DISPLAY_CONDITION''),',
'            p_tab_disp_cond_text         => v(''F4000_P4722_DISPLAY_CONDITION_TEXT''),',
'            p_display_condition_type     => replace(v(''F4000_P4722_CONDITION_TYPE''),''%null''||''%'',null),',
'            p_required_patch             => replace(v(''F4000_P4722_BUILD_OPTION''),''%null''||''%'',null),',
'            p_tab_comment                => null,',
'            P_AUTO_PARENT_TAB_SET        => v(''F4000_P4722_NEW_PARENT_TABSET''),',
'            P_AUTO_PARENT_TAB_TEXT       => v(''F4000_P4722_NEW_PARENT_TAB_TEXT''));',
'    end if;  ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error creating tab.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Tab &F4000_P4722_NEW_TAB_DISPLAY_TEXT. created.'
,p_internal_uid=>130447519223
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(573756177462229742)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,F4000_LAST_VIEW'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(130446514359)
,p_process_success_message=>'Tab &F4000_P4722_NEW_TAB_DISPLAY_TEXT. created.'
,p_internal_uid=>573756177462229742
);
end;
/
prompt --application/pages/page_00093
begin
wwv_flow_imp_page.create_page(
 p_id=>93
,p_name=>'Choose Existing Tab Set'
,p_alias=>'CHOOSE-EXISTING-TAB-SET'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Standard Tab'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213240607818867991)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(101770219049479046)
,p_plug_name=>'Create Standard Tab'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>'<p>Use this page to create a tab within an existing tab set. Select a tab set from the list.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(101770831165479048)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(100922117111440207)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(101771118248479049)
,p_name=>'Existing Tab Sets'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select tab_set, ',
'       tab_step, ',
'       substr(tab_text,1,30) tab_text,',
'       replace(TAB_ALSO_CURRENT_FOR_PAGES,'','','', '') tacfp',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order  by tab_set, TAB_SEQUENCE, tab_step'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'1'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48825309314772402)
,p_query_column_id=>1
,p_column_alias=>'TAB_SET'
,p_column_display_sequence=>1
,p_column_heading=>'Tab Set'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48825411703772403)
,p_query_column_id=>2
,p_column_alias=>'TAB_STEP'
,p_column_display_sequence=>2
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48825527122772403)
,p_query_column_id=>3
,p_column_alias=>'TAB_TEXT'
,p_column_display_sequence=>3
,p_column_heading=>'Tab'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48825624636772403)
,p_query_column_id=>4
,p_column_alias=>'TACFP'
,p_column_display_sequence=>4
,p_column_heading=>'Also Current for Pages'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(200345431939216583)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(101767832553479034)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(200345431939216583)
,p_button_name=>'cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(101767523339479033)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(200345431939216583)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_button_alignment=>'LEFT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(101767228219479031)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(200345431939216583)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_alignment=>'LEFT'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(101768103975479036)
,p_branch_action=>'96'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(101767523339479033)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(101768416978479037)
,p_branch_action=>'96'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND_TEXT'
,p_branch_condition=>'F4000_P4722_TAB_SET_CHOICE'
,p_branch_condition_text=>'EXISTING'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(101769300058479040)
,p_branch_action=>'90'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(101767228219479031)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(101769606186479042)
,p_name=>'F4000_P4722_TABSET'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(101770219049479046)
,p_prompt=>'Identify Existing Tab Set'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct wwv_flow_escape.html(tab_set) d, tab_set v',
'  from wwv_flow_tabs ',
' where flow_id = v(''FB_FLOW_ID'')',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Tab Set -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'<p>Select an existing tab set. If you do not want to use an existing tab set, click <strong>Previous</strong> to select a different option.<p>'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(101769920531479044)
,p_validation_name=>'F4000_P4722_TABSET Not Null'
,p_validation_sequence=>10
,p_validation=>'F4000_P4722_TABSET'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Existing Tab Set must be specified.'
,p_associated_item=>wwv_flow_imp.id(101769606186479042)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 20-AUG-2001 00:00'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(574037409900616905)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(101767832553479034)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(574037568606616906)
,p_event_id=>wwv_flow_imp.id(574037409900616905)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00094
begin
wwv_flow_imp_page.create_page(
 p_id=>94
,p_name=>'Create Standard Tab - Tab Set'
,p_alias=>'CREATE-STANDARD-TAB-TAB-SET'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Standard Tab'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213240607818867991)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46529923036652873)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>150
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(101778604849484664)
,p_name=>'Tabs'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>140
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select tab_set, ',
'       tab_step, ',
'       substr(tab_text,1,30) tab_text,',
'       replace(TAB_ALSO_CURRENT_FOR_PAGES,'','','', '') tacfp',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order  by 1, 2'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'1'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48587921546771050)
,p_query_column_id=>1
,p_column_alias=>'TAB_SET'
,p_column_display_sequence=>1
,p_column_heading=>'Tab Set'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48588023946771050)
,p_query_column_id=>2
,p_column_alias=>'TAB_STEP'
,p_column_display_sequence=>2
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48588125278771050)
,p_query_column_id=>3
,p_column_alias=>'TAB_TEXT'
,p_column_display_sequence=>3
,p_column_heading=>'Tab'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48588228035771050)
,p_query_column_id=>4
,p_column_alias=>'TACFP'
,p_column_display_sequence=>4
,p_column_heading=>'Also Current for Pages'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(101779228119484667)
,p_plug_name=>'Create Standard Tab'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>130
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>1500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_row_count_max=>5000
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_break_cols=>'1'
,p_plug_header=>'<p>Use this page to specify the new tab set you wish to create. A tab set identifies a collection of tabs.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(101779529963484668)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(100922117111440207)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_plug_query_headings=>'Tab Set:Page:Tab:Also Current For Pages'
,p_plug_query_num_rows=>1500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_row_count_max=>5000
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_break_cols=>'1'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(101776231745484652)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46529923036652873)
,p_button_name=>'cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(101775920280484651)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46529923036652873)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_button_alignment=>'LEFT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(101775631337484650)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_imp.id(46529923036652873)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_alignment=>'LEFT'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(101776511272484653)
,p_branch_action=>'95'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(101776807882484654)
,p_branch_action=>'90'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(101775631337484650)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(101777714596484659)
,p_name=>'F4000_P4722_NEW_TAB_SET_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(101779228119484667)
,p_prompt=>'New Tab Set'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter a name for the new tab set you wish to create. A tab set identifies a collection of tabs.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(101778029412484660)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P4722_TABSET'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'&F4000_P4722_NEW_TAB_SET_NAME.'
,p_computation_error_message=>'Unable to compute item value.'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(101778326694484663)
,p_validation_name=>'F4000_P4722_NEW_TAB_SET_NAME Not Null'
,p_validation_sequence=>1
,p_validation=>'F4000_P4722_NEW_TAB_SET_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'New Tab Set must be specified.'
,p_associated_item=>wwv_flow_imp.id(101777714596484659)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 19-AUG-2001 21:58'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(574037251413616903)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(101776231745484652)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(574037378385616904)
,p_event_id=>wwv_flow_imp.id(574037251413616903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00095
begin
wwv_flow_imp_page.create_page(
 p_id=>95
,p_name=>'Create Standard Tab - Tab Parent'
,p_alias=>'CREATE-STANDARD-TAB-TAB-PARENT'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Standard Tab'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213240607818867991)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46532100704684349)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(101796821567496663)
,p_plug_name=>'Create Standard Tab'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'0'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_header=>'<p>To create parent tabs for this page you must do one of the following: (1) Select an existing parent tab set from the list; or (2) Create a new parent tab set by entering a tab set name and label text.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(101797426979496666)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(100922117111440207)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_plug_query_headings=>'Tab Set:Page:Tab:Also Current For Pages'
,p_plug_query_num_rows=>1500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_row_count_max=>5000
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_break_cols=>'1'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(101794130013496653)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46532100704684349)
,p_button_name=>'cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(101793832448496652)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(46532100704684349)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_button_alignment=>'LEFT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(101793523974496651)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46532100704684349)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_alignment=>'LEFT'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(101794716478496655)
,p_branch_action=>'96'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(101793832448496652)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(101795321588496656)
,p_branch_action=>'94'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(101793523974496651)
,p_branch_sequence=>1
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(101795617663496658)
,p_name=>'F4000_P4722_PARENT_TAB_SET'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(101796821567496663)
,p_prompt=>'Parent Tab Set'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PARENT_TAB_SET'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct wwv_flow_escape.html(tab_set) d, tab_set r',
'',
'from wwv_flow_toplevel_tabs',
'',
'where flow_id = nv(''FB_FLOW_ID'') and',
'',
'      security_group_id = :flow_security_group_id',
'',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Parent Tab Set -'
,p_lov_null_value=>'0'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Make a selection from the list to choose an existing parent tab set.</div> ',
''))
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(101795913646496659)
,p_name=>'F4000_P95_X'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_imp.id(101796821567496663)
,p_prompt=>'- or -'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(101796221176496660)
,p_name=>'F4000_P4722_NEW_PARENT_TABSET'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(101796821567496663)
,p_prompt=>'New Parent Tab Set'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'This option creates a new parent tab set. Enter a new parent tab set name.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(101796521230496661)
,p_name=>'F4000_P4722_NEW_PARENT_TAB_TEXT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(101796821567496663)
,p_prompt=>'New Parent Tab Text'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'This option creates a new parent tab set. This attribute defines the text that displays on the tab. If the tab is an image, enter text to describe the tab.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(574037099461616901)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(101794130013496653)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(574037194856616902)
,p_event_id=>wwv_flow_imp.id(574037099461616901)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00096
begin
wwv_flow_imp_page.create_page(
 p_id=>96
,p_name=>'Create Standard Tab - Tab Name'
,p_alias=>'CREATE-STANDARD-TAB-TAB-NAME'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Standard Tab'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213240607818867991)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46533525769700978)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>160
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(101786821889489659)
,p_plug_name=>'Create Standard Tab'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_header=>'<p>Tabs are part of a tab set. Use this page to specify a tab within the tab set.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(101787402566489665)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(100922117111440207)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_plug_query_headings=>'Tab Set:Page:Tab:Also Current For Pages'
,p_plug_query_num_rows=>1500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_row_count_max=>5000
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_break_cols=>'1'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(199998726661694911)
,p_name=>'Existing Tab Sets'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>150
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select tab_set, tab_sequence, tab_step, ',
' substr(tab_text,1,50) tab_text, TAB_ALSO_CURRENT_FOR_PAGES',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'order  by 1, 2'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' -'
,p_query_break_cols=>'1'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(199999028826694916)
,p_query_column_id=>1
,p_column_alias=>'TAB_SET'
,p_column_display_sequence=>1
,p_column_heading=>'Tab Set'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(199999106397694917)
,p_query_column_id=>2
,p_column_alias=>'TAB_SEQUENCE'
,p_column_display_sequence=>2
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(199999219301694917)
,p_query_column_id=>3
,p_column_alias=>'TAB_STEP'
,p_column_display_sequence=>3
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(199999330433694917)
,p_query_column_id=>4
,p_column_alias=>'TAB_TEXT'
,p_column_display_sequence=>4
,p_column_heading=>'Label'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(199999419992694917)
,p_query_column_id=>5
,p_column_alias=>'TAB_ALSO_CURRENT_FOR_PAGES'
,p_column_display_sequence=>5
,p_column_heading=>'Tab Also Current For Pages'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(101783814639489630)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46533525769700978)
,p_button_name=>'cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(101783519889489629)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(46533525769700978)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_button_alignment=>'LEFT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(101783228269489628)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46533525769700978)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_alignment=>'LEFT'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1828328417328731)
,p_branch_action=>'f?p=&FLOW_ID.:4722:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>41
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(810620502384714357)
,p_branch_action=>'f?p=&APP_ID.:95:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(101783228269489628)
,p_branch_sequence=>1
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(101785921664489638)
,p_name=>'F4000_P96_TS'
,p_item_sequence=>3
,p_item_plug_id=>wwv_flow_imp.id(101786821889489659)
,p_prompt=>'New Tab Set'
,p_source=>'v(''F4000_P4722_NEW_TAB_SET_NAME'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_attributes=>'class="fieldtitlebold"'
,p_display_when=>'F4000_P4722_TAB_SET_CHOICE'
,p_display_when2=>'NEW'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Enter a tab label.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(101786222597489657)
,p_name=>'F4000_P4722_NEW_TAB_DISPLAY_TEXT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(101786821889489659)
,p_prompt=>'Tab Label'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter the text for the tab label. This label will appear on the tab.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(102241931358132208)
,p_name=>'F4000_P96_TS2'
,p_item_sequence=>7
,p_item_plug_id=>wwv_flow_imp.id(101786821889489659)
,p_prompt=>'Tab Set:'
,p_source=>'F4000_P4722_TABSET'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_attributes=>'class="fieldtitlebold"'
,p_display_when=>'F4000_P4722_TAB_SET_CHOICE'
,p_display_when2=>'EXISTING'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Currently selected tab set.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(101786519403489658)
,p_validation_name=>'F4000_P4722_NEW_TAB_DISPLAY_TEXT Not Null'
,p_validation_sequence=>1
,p_validation=>'F4000_P4722_NEW_TAB_DISPLAY_TEXT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Tab display text must be specified.'
,p_associated_item=>wwv_flow_imp.id(101786222597489657)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 19-AUG-2001 23:46'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(573756854634229749)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(101783814639489630)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(573756933107229750)
,p_event_id=>wwv_flow_imp.id(573756854634229749)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00097
begin
wwv_flow_imp_page.create_page(
 p_id=>97
,p_name=>'How to Create Page Components'
,p_alias=>'HOW-TO-CREATE-PAGE-COMPONENTS'
,p_page_mode=>'MODAL'
,p_step_title=>'How to Create Page Components'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'640'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'No help is available for this page.'
,p_page_component_map=>'11'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1474233099802765822)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1477171307612322861)
,p_plug_name=>'Help'
,p_region_template_options=>'a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The Page Designer provides several options for creating new page components.',
'To create regions, items, and buttons you can drag and drop components within the Layout tab in the central pane, or use the context menus within the Rendering tab in the left pane.',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1104687824864514420)
,p_plug_name=>'Creating Regions, Items, and Buttons Using Drag and Drop'
,p_parent_plug_id=>wwv_flow_imp.id(1477171307612322861)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--simple'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>To drag and drop new components:</p>',
'<ol>',
'  <li>Select the Layout tab in the central pane.</li>',
'  <li>Within the Gallery at the bottom of the pane, select the Region, Item, or Button.</li>',
'  <li>Click and hold the mouse on the component to be created, and drag it into the Layout tab.</li>',
'  <li>Move the component to the desired location within the page and release the mouse.</li>',
'  <li>Enter the appropriate details into the Property Editor.</li>',
'  <li>Click <strong>Save</strong> or <strong>Save and Run Page</strong>.</li>',
'</ol>      ',
'<p><em>Note: Components can only be dropped into appropriate drop zones, shown in yellow, as determined by the component type.',
'  After hovering over an existing drop zone the yellow changes to show a black box in the relevant drop zone.<br/>',
'  If you wish to place the new component next to an existing component then drag the new component to the right, and level, with the existing component, and wait a short period until a new drop zone displays.</em></p>',
'<p>The Layout tab also includes context menus. By selecting a component and right-clicking, you can delete, move, or copy the component to other regions, or new regions on the page.</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1104687995506514421)
,p_plug_name=>'Creating Pre-Rendering Branches, Computations and Processes'
,p_parent_plug_id=>wwv_flow_imp.id(1477171307612322861)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--simple'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>To create branches, computations, and processes that execute before rendering the page:</p>',
'<ol>',
'  <li>Select the Rendering tab in the left pane.</li>',
'  <li>Expand the <strong>Pre-Rendering</strong> node at the top of the Rendering tree.</li>',
'  <li>Right-click Before Header, After Header, Before Regions to display the context menu for that processing point.</li>',
'  <li>Select <strong>Create Branch</strong>, <strong>Create Computation</strong>, or <strong>Create Process</strong>.</li>',
'  <li>Enter the appropriate details into the Property Editor.</li>',
'  <li>Click <strong>Save</strong> or <strong>Save and Run Page</strong>.</li>',
'</ol>',
'<p><em>Note: If you have changed the default display to group components by component type, then must navigate to the Processing tab to maintain pre-rendering components.</em></p>',
'<p>You can also use the context menus to duplicate, delete, and copy a component to other pages.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1104688010835514422)
,p_plug_name=>'Creating Page Submission Branches, Validations, Computations and Processes'
,p_parent_plug_id=>wwv_flow_imp.id(1477171307612322861)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--simple'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>To create branches, validations, computations, and processes that execute when the page is submitted:</p>',
'<ol>',
'  <li>Select the Processing tab in the left pane.</li>',
'  <li>Navigate to After Submit, Validating, Processing, or After Processing as appropriate within the processing tree.</li>',
'  <li>Right-click the identifier or an existing component to dsipaly the context menu for that procecssing point.</li>',
'  <li>Select <strong>Create Branch</strong>, <strong>Create Validation</strong>, <strong>Create Computation</strong>, or <strong>Create Process</strong>.</li>',
'  <li>Enter the appropriate details into the Property Editor.</li>',
'  <li>Click <strong>Save</strong> or <strong>Save and Run Page</strong>.</li>',
'</ol>',
'<p>You can also use the context menus to duplicate, delete, and copy a component to other pages.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1104689404381514436)
,p_plug_name=>'Creating Regions, Items, and Buttons Using Context Menus'
,p_parent_plug_id=>wwv_flow_imp.id(1477171307612322861)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--simple'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>To create new components within the Rendering tab:</p>',
'<ol>',
'  <li>Select the Rendering tab in the left pane.</li>',
'  <li>Navigate to the appropriate region, item, or region button.</li>',
'  <li>Right-click the identifier or an existing component to display the context menu for that component type.</li>',
'  <li>Select <strong>Create Region</strong>, <strong>Create Sub Region</strong>, <strong>Create Page Item</strong>, or <strong>Create Button</strong>.</li>',
'  <li>Enter the appropriate details into the Property Editor.</li>',
'  <li>Click <strong>Save</strong> or <strong>Save and Run Page</strong>.</li>',
'</ol>',
'<p>You can also use the context menus within the Rendering tab to duplicate, delete, and copy a component to other pages.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1474233168701765823)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1474233099802765822)
,p_button_name=>'close'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Close'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1474233250895765824)
,p_name=>'Close Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1474233168701765823)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1474233385337765825)
,p_event_id=>wwv_flow_imp.id(1474233250895765824)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00100
begin
wwv_flow_imp_page.create_page(
 p_id=>100
,p_name=>'Confirm Unsubscribe Theme'
,p_alias=>'CONFIRM-UNSUBSCRIBE-THEME'
,p_page_mode=>'MODAL'
,p_step_title=>'Confirm Unsubscribe Theme'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_dialog_height=>'400'
,p_dialog_width=>'640'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'No help is available for this page.'
,p_page_component_map=>'11'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(932805961191193703)
,p_plug_name=>'Dialog Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(932806341172193707)
,p_plug_name=>'Confirm Unsubscribe'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Please confirm that you wish to unsubscribe the current theme from its master theme. Unsubscribing a theme will prevent future updates to the theme being applied. It is non-trivial to re-subscribe a theme once unsubscribed, as it involves copying '
||'and switching themes.</p>',
'<p>Please note that subscribed themes can be extended by adding templates, styles and files that are local to the theme, for example by creating a new template or copying a subscribed template. Templates, styles and files added to a subscribed theme '
||'will be editable, however subscribed components are read-only.</p>',
'<p>Unsubscribing a theme also unsubscribes all templates, Javascript and CSS, global template options, icons, and styles allowing you to customize any of the currently subscribed components.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(932806140294193705)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(932805961191193703)
,p_button_name=>'Cancel'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(932806038468193704)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(932805961191193703)
,p_button_name=>'Unsubscribe'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Unsubscribe Theme'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(932806537367193709)
,p_branch_name=>'back to theme edit page'
,p_branch_action=>'f?p=&APP_ID.:267:&SESSION.::&DEBUG.:RP:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(932806265733193706)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'New'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(932806140294193705)
,p_internal_uid=>932806265733193706
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(932806431931193708)
,p_process_sequence=>20
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Unsubscribe Theme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.unsubscribe_theme(:P267_ID);',
'',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error unsubscribing theme.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(932806038468193704)
,p_process_success_message=>'Theme and template have been unsubscribed.'
,p_internal_uid=>932806431931193708
);
end;
/
prompt --application/pages/page_00101
begin
wwv_flow_imp_page.create_page(
 p_id=>101
,p_name=>'Embedded Code'
,p_alias=>'EMBEDDED-CODE'
,p_step_title=>'Embedded Code'
,p_reload_on_submit=>'A'
,p_autocomplete_on_off=>'OFF'
,p_javascript_file_urls=>'#IMAGE_PREFIX#apex_ui/js/#MIN_DIRECTORY#f4000_searchResults#MIN#.js'
,p_step_template=>wwv_flow_imp.id(438185046231548086)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'22'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(2600902150396862)
,p_name=>'Search Results'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_EMBEDDED_CODE'
,p_include_rowid_column=>false
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(1310649889953751)
,p_query_num_rows=>200
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>100000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_prn_format=>'PDF'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2604058026396983)
,p_query_column_id=>1
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2604463528396984)
,p_query_column_id=>2
,p_column_alias=>'PAGE_ID'
,p_column_display_sequence=>2
,p_column_heading=>'Page Id'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2604837636396985)
,p_query_column_id=>3
,p_column_alias=>'PROPERTY_ID'
,p_column_display_sequence=>3
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2605211195396985)
,p_query_column_id=>4
,p_column_alias=>'COMPONENT_ID'
,p_column_display_sequence=>4
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2605662403396985)
,p_query_column_id=>5
,p_column_alias=>'COMPONENT_TYPE_ID'
,p_column_display_sequence=>5
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2606021809396985)
,p_query_column_id=>6
,p_column_alias=>'PAGE_NAME'
,p_column_display_sequence=>6
,p_column_heading=>'Page Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2606447986396986)
,p_query_column_id=>7
,p_column_alias=>'COMPONENT_NAME'
,p_column_display_sequence=>7
,p_column_heading=>'Component Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2606815919396986)
,p_query_column_id=>8
,p_column_alias=>'COMPONENT_TYPE_NAME'
,p_column_display_sequence=>8
,p_column_heading=>'Component Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2607220772396986)
,p_query_column_id=>9
,p_column_alias=>'PROPERTY_NAME'
,p_column_display_sequence=>9
,p_column_heading=>'Property Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2607686629396987)
,p_query_column_id=>10
,p_column_alias=>'PROPERTY_TYPE'
,p_column_display_sequence=>10
,p_column_heading=>'Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2503656722458636)
,p_query_column_id=>11
,p_column_alias=>'CODE_TYPE'
,p_column_display_sequence=>22
,p_column_heading=>'Code Type'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2503772851458637)
,p_query_column_id=>12
,p_column_alias=>'GROUP_NAME'
,p_column_display_sequence=>32
,p_column_heading=>'Group Name'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2503898987458638)
,p_query_column_id=>13
,p_column_alias=>'SCOPE_NAME'
,p_column_display_sequence=>42
,p_column_heading=>'Scope Name'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2608445018396987)
,p_query_column_id=>14
,p_column_alias=>'PROPERTY_SOURCE'
,p_column_display_sequence=>12
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2601090955396862)
,p_plug_name=>'Search'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source_type=>'NATIVE_FACETED_SEARCH'
,p_filtered_region_id=>wwv_flow_imp.id(2600902150396862)
,p_plug_header=>'<div id="active_facets"></div>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'batch_facet_search', 'N',
  'compact_numbers_threshold', '10000',
  'current_facets_selector', '#active_facets',
  'display_chart_for_top_n_values', '10',
  'show_charts', 'Y',
  'show_current_facets', 'E',
  'show_total_row_count', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2603070942396873)
,p_plug_name=>'Embedded Code'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_plug_source=>'<!-- div id="active_facets"></div -->'
,p_plug_display_condition_type=>'NEVER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1602020543325526)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2600902150396862)
,p_button_name=>'DOWNLOAD'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Download'
,p_button_position=>'CLOSE'
,p_button_execute_validations=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2603557068396875)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2603070942396873)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:101:&SESSION.::&DEBUG.:RR,101::'
,p_button_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2504142698458641)
,p_name=>'P101_CODE_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2601090955396862)
,p_prompt=>'Language'
,p_source=>'CODE_TYPE'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov_sort_direction=>'ASC'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>5
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>true
,p_fc_initial_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2504244793458642)
,p_name=>'P101_SCOPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(2601090955396862)
,p_prompt=>'Scope'
,p_source=>'SCOPE_NAME'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select dv, rv ',
'from (',
'    select distinct scope_name as dv, scope_name as rv, -1 as page_id',
'    from wwv_flow_embedded_code ',
'    where page_id is null ',
'    union all ',
'    select distinct scope_name as dv, scope_name as rv, page_id',
'    from wwv_flow_embedded_code',
'    where page_id is not null',
'    order by page_id',
');'))
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>10
,p_fc_filter_values=>true
,p_fc_sort_by_top_counts=>false
,p_fc_show_selected_first=>false
,p_fc_show_chart=>true
,p_fc_initial_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2601570002396870)
,p_name=>'P101_SEARCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2601090955396862)
,p_prompt=>'Search'
,p_source=>'PAGE_NAME,COMPONENT_NAME,GROUP_NAME,PROPERTY_NAME,PROPERTY_SOURCE'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_SEARCH'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ROW'
,p_attribute_02=>'FACET'
,p_fc_show_chart=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2602331284396873)
,p_name=>'P101_COMPONENT_TYPE_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(2601090955396862)
,p_prompt=>'Component Type'
,p_source=>'COMPONENT_TYPE_NAME'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov_sort_direction=>'ASC'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>true
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>5
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>true
,p_fc_initial_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>false
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1602266964332619)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'security'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.init;',
'sys.owa_util.redirect_url(v(''LOGOUT_URL''));',
'wwv_flow.g_unrecoverable_error := true;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'    from   wwv_flow_developers',
'    where  userid = :FLOW_USER ',
'       and',
'       security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and',
'       security_group_id = ',
'         (select security_group_id from wwv_flows where id=:FB_FLOW_ID or :FB_FLOW_ID is null)',
'       and',
'       instr(developer_role,''EDIT'') > 0 ',
'       and',
'       (flow_id = :FB_FLOW_ID or flow_id is null)  ',
'       and not exists (select 1 from wwv_flows',
'                    where id = :FB_FLOW_ID',
'                      and build_status = ''RUN_AND_HIDDEN'')'))
,p_process_when_type=>'NOT_EXISTS'
,p_required_patch=>wwv_flow_imp.id(170786031904296885)
,p_internal_uid=>1602266964332619
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1602580579335924)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Export Source Zip'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_export_dev.export_embedded_code (',
'    p_application_id => :FB_FLOW_ID);',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error exporting flow &FB_FLOW_ID.. #SQLERRM#'
,p_process_when_button_id=>wwv_flow_imp.id(1602020543325526)
,p_process_success_message=>'Application &FB_FLOW_ID. exported.'
,p_internal_uid=>1602580579335924
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1601659872321907)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Cache Embedded Code'
,p_process_sql_clob=>'wwv_flow_property_dev.cache_embedded_code(:FB_FLOW_ID);'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>1601659872321907
);
end;
/
prompt --application/pages/page_00103
begin
wwv_flow_imp_page.create_page(
 p_id=>103
,p_name=>'Build Status'
,p_alias=>'BUILD-STATUS'
,p_step_title=>'Build Status'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(11501804013545635)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12511519296310366)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47672626351203105)
,p_plug_name=>'Application Build Status Report'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P103a */',
'ID,',
'OWNER,',
'NAME,',
'BUILD_STATUS,',
'flow_status,',
'id application',
'from WWV_FLOWS f',
'where ',
'f.security_group_id = :flow_security_group_id',
'and f.build_status != ''RUN_AND_HIDDEN'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(47672728272203105)
,p_name=>'Application Build Status Report'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47673429078203114)
,p_db_column_name=>'APPLICATION'
,p_display_order=>1
,p_column_identifier=>'F'
,p_column_label=>'APPLICATION'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47672909730203110)
,p_db_column_name=>'ID'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>'Application'
,p_column_link=>'f?p=&APP_ID.:467:&SESSION.::&DEBUG.:NONE,467:P467_ID:#ID#'
,p_column_linktext=>'#ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47673024002203111)
,p_db_column_name=>'OWNER'
,p_display_order=>3
,p_column_identifier=>'B'
,p_column_label=>'Parsing Schema'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47673121532203112)
,p_db_column_name=>'NAME'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47673206390203112)
,p_db_column_name=>'BUILD_STATUS'
,p_display_order=>5
,p_column_identifier=>'D'
,p_column_label=>'Build Status'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(84305510710571518)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
,p_security_scheme=>wwv_flow_imp.id(12511519296310366)
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47673319976203113)
,p_db_column_name=>'FLOW_STATUS'
,p_display_order=>6
,p_column_identifier=>'E'
,p_column_label=>'Application Status'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(634347472712995)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(47674515570206794)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1286113037536643'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'ID:NAME:OWNER:BUILD_STATUS:FLOW_STATUS:'
,p_sort_column_1=>'ID'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'0'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(702930752262201276)
,p_plug_name=>'Cross Application Reports'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(702923103587108064)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(755297901357836845)
,p_name=>'Edit Report - Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(47672626351203105)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(755298036596836846)
,p_event_id=>wwv_flow_imp.id(755297901357836845)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(47672626351203105)
);
end;
/
prompt --application/pages/page_00104
begin
wwv_flow_imp_page.create_page(
 p_id=>104
,p_name=>'Edit Breadcrumb'
,p_alias=>'EDIT-BREADCRUMB'
,p_step_title=>'Edit Breadcrumb'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213261028690930718)
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'// below legacy code is not moved to builder.js file',
'// this plugin "Internal Page Popup LOV" must be replaced with new one anyway',
'function callItempopUp(s1,s2) {',
'     var items = document.getElementById(s1).value.replace(/\,/g,''~'');',
'     var values = document.getElementById(s2).value.replace(/\,/g,''~'');',
'     var url = ''f?p=4000:404:&SESSION.:::404:P404_RETURN1,P404_RETURN2,P404_ITEMS,P404_VALUES:'' + s1 + '','' + s2 + '','' + escape(items) + '','' + escape(values);',
'     popUp(url);',
'}'))
,p_step_template=>wwv_flow_imp.id(4868606398075172)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2300916966269809)
,p_plug_name=>'Breadcrumb Entry Details'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_MENU_OPTIONS'
,p_query_where=>wwv_flow_string.join(wwv_flow_t_varchar2(
'menu_id = :P104_MENU_ID',
'and flow_id           = :FB_FLOW_ID',
'and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P104_MENU_ID IS NOT NULL AND (:P104_ID IS NOT NULL or :REQUEST = ''NEW_ENTRY'')'
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2303586761269835)
,p_plug_name=>'Breadcrumb Entry'
,p_parent_plug_id=>wwv_flow_imp.id(2300916966269809)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2303863961269838)
,p_plug_name=>'Authorization'
,p_parent_plug_id=>wwv_flow_imp.id(2300916966269809)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2303931297269839)
,p_plug_name=>'Configuration'
,p_parent_plug_id=>wwv_flow_imp.id(2300916966269809)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2428884315300722)
,p_plug_name=>'Comments'
,p_parent_plug_id=>wwv_flow_imp.id(2300916966269809)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>80
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(13853237952413056)
,p_plug_name=>'Conditions'
,p_region_name=>'COND'
,p_parent_plug_id=>wwv_flow_imp.id(2300916966269809)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(31178079384755103)
,p_plug_name=>'Target'
,p_region_name=>'TAR'
,p_parent_plug_id=>wwv_flow_imp.id(2300916966269809)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(617637922231599942)
,p_plug_name=>'Entry History'
,p_parent_plug_id=>wwv_flow_imp.id(2300916966269809)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_imp.id(29434107863295859)
,p_plug_display_sequence=>90
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from WWV_FLOW_MENU_OPTIONS',
'where id = :P104_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :P104_ID,',
'      p_component_type => ''Breadcrumb'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P104_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2599547492679702)
,p_plug_name=>'Breadcrumb Entry Selector'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_landmark_type=>'navigation'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3701695051555005)
,p_plug_name=>'Search'
,p_parent_plug_id=>wwv_flow_imp.id(2599547492679702)
,p_region_css_classes=>'searchBar a-TreeSearchBar'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_landmark_type=>'exclude_landmark'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(20904792963355447)
,p_plug_name=>'Breadcrumb Entries'
,p_region_name=>'bcEntries'
,p_parent_plug_id=>wwv_flow_imp.id(2599547492679702)
,p_region_css_classes=>'a-PageDesigner-treeWrap'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with bc_data as',
'(',
'    select name short_name,',
'           ''icon-sc-tree'' icon,',
'           ''bc''||menus.id id,',
'           null as parent_id,',
'           null as option_sequence,',
'           null as page_id,',
'           null as menu_option_id,',
'           menus.id as menu_id',
'      from wwv_flow_menus menus',
'     where menus.id                = :P104_MENU_ID',
'       and menus.flow_id           = :FB_FLOW_ID',
'       and menus.security_group_id = :FLOW_SECURITY_GROUP_ID',
'    union all',
'    select options.short_name,',
'           null as icon,',
'           to_char(options.id) id,',
'           case',
'               when options.parent_id is null or options.parent_id = 0 then ''bc''||options.menu_id',
'               else to_char(options.parent_id)',
'           end parent_id,',
'           option_sequence,',
'           options.page_id,',
'           options.id menu_option_id,',
'           options.menu_id',
'      from wwv_flow_menu_options options',
'     where options.menu_id           = :P104_MENU_ID',
'       and options.flow_id           = :FB_FLOW_ID',
'       and options.security_group_id = :FLOW_SECURITY_GROUP_ID',
'), bc_tree as',
'(',
'    select short_name,',
'           icon,',
'           id,',
'           parent_id,',
'           option_sequence,',
'           page_id,',
'           menu_option_id,',
'           menu_id,',
'           sys_connect_by_path(id, '':'')||'':'' as bc_entry_path',
'      from bc_data',
'     start with parent_id is null or parent_id = ''0''',
'   connect by prior id = parent_id',
'     order siblings by option_sequence',
'), bc_filtered_data as',
'(',
'    select short_name,',
'           icon,',
'           id,',
'           parent_id,',
'           option_sequence,',
'           page_id,',
'           menu_option_id,',
'           menu_id',
'      from bc_data bcd',
'     where :P104_SEARCH is null',
'        OR exists (select *',
'                     from (',
'                         select inn.bc_entry_path',
'                           from bc_tree inn',
'                          where upper(inn.short_name) like ''%''||upper(:P104_SEARCH)||''%'') bep',
'                    where bep.bc_entry_path like ''%:''||bcd.id||'':%'')',
')',
'-- ideally bc_filtered_data can be used as final output, but we can''t do that',
'-- because filering sometimes changes the order of rows, however tree rendering has strict dependency on the order',
'-- so we must again use start with and connect by to make hierarchical query',
'-- otherwise we will get apex_error_code: JSON.WRITER.CLOSE_ARRAY error, sometimes.',
' select case',
'            when connect_by_isleaf = 1 then 0',
'            when level = 1             then 1',
'            else -1',
'        end as status,',
'        level lvl,',
'        short_name,',
'        icon,',
'        id,',
'        parent_id,',
'        case',
'            when page_id is not null then wwv_flow_lang.system_message( ''PAGE'' )||'' ''||page_id',
'            else null',
'        end tooltip,',
'        wwv_flow_page_api.get_url(',
'            p_page        => :APP_PAGE_ID,',
'            p_clear_cache => :APP_PAGE_ID,',
'            p_items       => ''P104_ID,P104_MENU_ID,P104_SEARCH'',',
'            p_values      => menu_option_id||'',''||menu_id||'',''||:P104_SEARCH) link',
'   from bc_filtered_data',
'  start with parent_id is null or parent_id = ''0''',
'connect by prior id = parent_id',
'  order siblings by option_sequence, short_name'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_JSTREE'
,p_ajax_items_to_submit=>'P104_SEARCH'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P104_MENU_ID'
,p_plugin_init_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function(options) {',
'    options.makeNodeAdapter = function(data, types, hasIdentity) {',
'        var treeAdapter,',
'            // get the ids from session storage',
'            ids = apex.storage.getScopedSessionStorage( { usePageId: true, useAppId: true} ).getItem("treeExpansionState");',
'        if ( ids ) {',
'            ids = ids.split(":");',
'        }',
'        treeAdapter = $.apex.treeView.makeDefaultNodeAdapter( data, types, hasIdentity, ids );',
'        return treeAdapter;',
'    }',
'    return options;',
'}'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'activate_node_link_with', 'S',
  'default_icon_css_class', 'icon-sc-breadcrumb',
  'hierarchy_level_column', 'LVL',
  'icon_css_class_column', 'ICON',
  'icon_type_css_class', 'a-Icon',
  'link_column', 'LINK',
  'node_label_column', 'SHORT_NAME',
  'node_status_column', 'STATUS',
  'node_value_column', 'ID',
  'selected_node_page_item', 'P104_SELECTED_NODE',
  'tooltip_column', 'TOOLTIP',
  'tree_hierarchy', 'LEVEL',
  'tree_tooltip', 'DB')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(20904804175355448)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_MENUS'
,p_query_where=>wwv_flow_string.join(wwv_flow_t_varchar2(
'security_group_id = :flow_security_group_id',
'and flow_id       = :FB_FLOW_ID'))
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'u:d'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P104_MENU_ID IS NOT NULL AND :P104_ID IS NULL AND :REQUEST IS NULL'
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8469795847051403)
,p_plug_name=>'Breadcrumb History'
,p_parent_plug_id=>wwv_flow_imp.id(20904804175355448)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_imp.id(29434107863295859)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from WWV_FLOW_MENUS',
'where id = :P104_MENU_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :P104_MENU_ID,',
'      p_component_type => ''Breadcrumb'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(170645131771366897)
,p_name=>'Breadcrumb Usage'
,p_parent_plug_id=>wwv_flow_imp.id(20904804175355448)
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  p.page_id, ',
'     s.name, p.plug_name, m.SHORT_NAME',
'from wwv_flow_menu_options m, ',
'    wwv_flow_page_plugs p,',
'    wwv_flow_steps s',
'where p.menu_id           = m.menu_id',
'  and p.page_id           = m.page_id',
'  and p.flow_id           = :fb_flow_id',
'  and p.security_group_id = :flow_security_group_id',
'  and m.menu_id           = :P104_MENU_ID',
'  and s.id                = p.page_id',
'  and s.flow_id           = :fb_flow_id',
'order by p.page_id'))
,p_display_when_condition=>':P104_MENU_ID IS NOT NULL AND :P104_ID IS NULL AND :REQUEST IS NULL'
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_header=>'<p>Deleting a breadcrumb will cascade to delete all regions referencing that breadcrumb.</p>'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>50
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2700533532194196)
,p_query_column_id=>1
,p_column_alias=>'PAGE_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2700840963194198)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Page Name'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2701275852194199)
,p_query_column_id=>3
,p_column_alias=>'PLUG_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Region'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2701624960194199)
,p_query_column_id=>4
,p_column_alias=>'SHORT_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Breadcrumb Entry'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3100954151676304)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(3701695051555005)
,p_button_name=>'CLEAR'
,p_button_static_id=>'clear'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Clear'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'icon-remove'
,p_grid_new_row=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2311925385292714)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(20904804175355448)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2428782330300721)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2303586761269835)
,p_button_name=>'CANCEL_1'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2304445449269844)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(2303586761269835)
,p_button_name=>'DELETE_ENTRY'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete Entry'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P104_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2312385894292715)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(20904804175355448)
,p_button_name=>'DELETE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P104_MENU_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2304515876269845)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(20904804175355448)
,p_button_name=>'NEW_ENTRY'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'New Entry'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:104:&SESSION.:NEW_ENTRY:&DEBUG.:104:P104_MENU_ID:&P104_MENU_ID.'
,p_button_condition=>':P104_ID IS NULL AND :REQUEST IS NULL'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_icon_css_classes=>'icon-plus'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8470736556051413)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(2303586761269835)
,p_button_name=>'NEW_ENTRY_1'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'New Entry'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:104:&SESSION.:NEW_ENTRY:&DEBUG.:104:P104_MENU_ID,P104_PARENT_ID:&P104_MENU_ID.,&P104_ID.'
,p_button_condition=>':P104_ID IS NOT NULL'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_icon_css_classes=>'icon-plus'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2305002498269850)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(2303586761269835)
,p_button_name=>'CREATE_ENTRY_AGAIN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Create and Create Another'
,p_button_position=>'NEXT'
,p_button_condition=>'P104_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2304767400269847)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(2303586761269835)
,p_button_name=>'CREATE_ENTRY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Entry'
,p_button_position=>'NEXT'
,p_button_condition=>'P104_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2312767914292715)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(20904804175355448)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P104_MENU_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2304873252269848)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(2303586761269835)
,p_button_name=>'SAVE_ENTRY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P104_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2304910483269849)
,p_branch_name=>'Delete Breadcrumb'
,p_branch_action=>'f?p=&APP_ID.:546:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2312385894292715)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(8469674742051402)
,p_branch_name=>'Create and Create Another'
,p_branch_action=>'f?p=&APP_ID.:104:&SESSION.:NEW_ENTRY:&DEBUG.::P104_ID,P104_PARENT_ID:,&P104_PARENT_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2305002498269850)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(8469917147051405)
,p_branch_name=>'Delete Entry'
,p_branch_action=>'f?p=&APP_ID.:104:&SESSION.::&DEBUG.:104:P104_MENU_ID:&P104_MENU_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2304445449269844)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3304531707286943)
,p_branch_name=>'Application Change Detected'
,p_branch_action=>'f?p=&APP_ID.:5:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_HEADER'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'NOT_EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_menus',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and id                = :P104_MENU_ID'))
,p_branch_comment=>'When application is changed, that is current breadcrumb P104_MENU_ID is not valid for the current app FB_FLOW_ID, then show error page 5.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1801318894462312)
,p_name=>'P104_SYNC_PAGE_NAME'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(2303586761269835)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Synchronize page name and title'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Select this checkbox to synchronize the corresponding Page Name and Title with the Breadcrumb Short Name.'
,p_attribute_01=>'N'
,p_attribute_02=>'YES'
,p_item_comment=>'Label can''t be empty when help text exists, if we keep label empty, then help dialog is not being shown when we click the help icon. As a workaround, dummy label &nbsp; is added for this item.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2300175345269801)
,p_name=>'P104_FLOW_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(20904804175355448)
,p_item_source_plug_id=>wwv_flow_imp.id(20904804175355448)
,p_source=>'FLOW_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2300209457269802)
,p_name=>'P104_NAME'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(20904804175355448)
,p_item_source_plug_id=>wwv_flow_imp.id(20904804175355448)
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter a name for this breadcrumb. The breadcrumb name provides a way to name a collection of breadcrumb entries.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2300345616269803)
,p_name=>'P104_SECURITY_GROUP_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(20904804175355448)
,p_item_source_plug_id=>wwv_flow_imp.id(20904804175355448)
,p_source=>'SECURITY_GROUP_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2300872609269808)
,p_name=>'P104_MENU_COMMENT'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(20904804175355448)
,p_item_source_plug_id=>wwv_flow_imp.id(20904804175355448)
,p_prompt=>' Comments'
,p_source=>'MENU_COMMENT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter any developer comments or notes here. These comments only display within App Builder and never display when running the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2301209129269812)
,p_name=>'P104_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2300916966269809)
,p_item_source_plug_id=>wwv_flow_imp.id(2300916966269809)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2301332269269813)
,p_name=>'P104_PARENT_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(2303586761269835)
,p_item_source_plug_id=>wwv_flow_imp.id(2300916966269809)
,p_prompt=>'Parent Entry'
,p_source=>'PARENT_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select short_name||'' (''||p||'' ''||page_id||'')'' name, id',
'from wwv_flow_menu_options, (select wwv_flow_lang.system_message(''PAGE'') p from sys.dual) x',
'where menu_id = :P104_MENU_ID',
'order by name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Parent Entry -'
,p_cSize=>64
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the breadcrumb entry that is the parent of this entry.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'Y'
,p_attribute_06=>'0'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2301499265269814)
,p_name=>'P104_OPTION_MENU_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2300916966269809)
,p_item_source_plug_id=>wwv_flow_imp.id(2300916966269809)
,p_source=>'MENU_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2301699240269816)
,p_name=>'P104_OPTION_SEQUENCE'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(2303586761269835)
,p_item_source_plug_id=>wwv_flow_imp.id(2300916966269809)
,p_item_default=>'10'
,p_prompt=>'Sequence'
,p_source=>'OPTION_SEQUENCE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Specify the sequence for this component. The sequence determines the order of evaluation.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2301717367269817)
,p_name=>'P104_SHORT_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(2303586761269835)
,p_item_source_plug_id=>wwv_flow_imp.id(2300916966269809)
,p_prompt=>'Short Name'
,p_source=>'SHORT_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Identify the short name of this breadcrumb entry. Both the short and long names can be referenced from the breadcrumb template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2301884739269818)
,p_name=>'P104_LONG_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(2303586761269835)
,p_item_source_plug_id=>wwv_flow_imp.id(2300916966269809)
,p_prompt=>'Long Name'
,p_source=>'LONG_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Identify the long name of this breadcrumb entry. Both the short and long names can be referenced from the breadcrumb template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2301901379269819)
,p_name=>'P104_LINK'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(31178079384755103)
,p_item_source_plug_id=>wwv_flow_imp.id(2300916966269809)
,p_source=>'LINK'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2302032647269820)
,p_name=>'P104_PAGE_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2303586761269835)
,p_item_source_plug_id=>wwv_flow_imp.id(2300916966269809)
,p_item_default=>'FB_FLOW_PAGE_ID'
,p_item_default_type=>'ITEM'
,p_prompt=>'Page'
,p_source=>'PAGE_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d',
'  from wwv_flow_steps',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and is_page_pattern   = ''N''',
'order by 2'))
,p_cSize=>8
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the page associated with this breadcrumb.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2302109751269821)
,p_name=>'P104_ALSO_CURRENT_FOR_PAGES'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(2300916966269809)
,p_item_source_plug_id=>wwv_flow_imp.id(2300916966269809)
,p_source=>'ALSO_CURRENT_FOR_PAGES'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2302586353269825)
,p_name=>'P104_SECURITY_SCHEME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2303863961269838)
,p_item_source_plug_id=>wwv_flow_imp.id(2300916966269809)
,p_prompt=>'Authorization Scheme'
,p_source=>'SECURITY_SCHEME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REQUIRED_ROLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.d, a.r from (',
'    select wwv_flow_lang.system_message(''MUST_NOT_BE_PUBLIC_USER'') d,''MUST_NOT_BE_PUBLIC_USER'' r, 1',
'      from sys.dual',
'    union all',
'    select wwv_flow_escape.html(substr(name,1,50)),to_char(id), 1',
'      from wwv_flow_security_schemes',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID',
'    union all',
'    select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'',wwv_flow_escape.html(substr(name,1,50)))||''}'' d, ''!''||to_char(id) r, 2',
'      from wwv_flow_security_schemes',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID',
'    order by 3,1) a'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Authorization Required -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Optionally select an authorization scheme. This authorization scheme must evaluate to TRUE in order for this component to be rendered or otherwise processed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2302624969269826)
,p_name=>'P104_REQUIRED_PATCH'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2303931297269839)
,p_item_source_plug_id=>wwv_flow_imp.id(2300916966269809)
,p_prompt=>'Build Option'
,p_source=>'REQUIRED_PATCH'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PATCHES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(patch_name) pn, id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'', wwv_flow_escape.html(patch_name))||',
'''} '' pn,0-id id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by pn'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Build Option -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select a build option for this component. Build options are predefined settings that determine whether or not  components within an application are enabled.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2303233667269832)
,p_name=>'P104_MENU_OPTION_COMMENT'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_imp.id(2428884315300722)
,p_item_source_plug_id=>wwv_flow_imp.id(2300916966269809)
,p_prompt=>'Comments'
,p_source=>'MENU_OPTION_COMMENT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter any developer comments or notes here. These comments only display within App Builder and never display when running the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2427207209300706)
,p_name=>'P104_SELECTED_NODE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(20904792963355447)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2427444541300708)
,p_name=>'P104_PAGE_SUCCESS_MSG'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(20904792963355447)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3369056058172375)
,p_name=>'P104_URL_OR_FLOW'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(31178079384755103)
,p_item_default=>'FLOW'
,p_prompt=>'Target is a'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'URL_OR_PAGE'
,p_lov=>'.'||wwv_flow_imp.id(84796030957080920)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Target -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify if the target is a page or a URL.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3369910974172376)
,p_name=>'P104_TARGET_PAGE_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(31178079384755103)
,p_prompt=>'Page'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d',
'  from wwv_flow_steps',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and is_page_pattern   = ''N''',
'order by 2'))
,p_cSize=>8
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter the page number or alias. To reset pagination for that page, select <span class="fielddatabold">reset pagination for this page</span> .'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3370821776172378)
,p_name=>'P104_CLEAR_PAGE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(31178079384755103)
,p_prompt=>'Reset pagination for this page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'<p>Select this check box to reset the pagination that is linked to.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'YES'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3371798536172378)
,p_name=>'P104_REQUEST'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(31178079384755103)
,p_prompt=>'Request'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter text for which you would like to set the built-in application item called REQUEST. This is also the item that is set with the name of a button that was clicked.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3372617253172378)
,p_name=>'P104_CLEAR_CACHE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(31178079384755103)
,p_prompt=>'Clear Cache'
,p_post_element_text=>'<span class="instructionText">(comma separated page numbers)</span>'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Enter the page numbers (separated by commas) for those pages for which you would like to clear the user''s session state. Other valid entries:</div>',
'<ul class="noIndent">',
'<li>APPLICATION - resets the user''s session state for the entire application',
'<li>SESSION - resets the user''s session state completely',
'</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3373595794172379)
,p_name=>'P104_ARG_NAMES'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(31178079384755103)
,p_prompt=>'Set these items'
,p_post_element_text=>'<span class="instructionText">(comma separated name list)</span>'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter the list of application item names (separated by commas) for which you would like to set the session state (give the listed item a value).'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'callItempopUp'
,p_attribute_03=>'Find Item'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3374478931172379)
,p_name=>'P104_ARG_VALUES'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(31178079384755103)
,p_prompt=>'With these values'
,p_post_element_text=>'<span class="instructionText">(comma separated value list)</span>'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter a comma delimited list of values for the items specified in <span class="fielddatabold">Set these items</span>. You can specify static values or substitution syntax (for example, &amp;APP_ITEM_NAME.). ',
'<pre>&amp;APP_ITEM_NAME.</pre>',
'<div class="htmldbInfoBodyP">Item values passed to <span class="fielddatabold">f?p=</span> in the URL may never contain a colon (:). Item values may also not contain commas unless you enclose the entire value in backslash characters. For example:</di'
||'v>',
'<pre>\1234,56\</pre>',
'<div class="htmldbInfoBodyP">This is useful when decimal values must be passed where the NLS decimal separator character is a comma.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'callItempopUp'
,p_attribute_03=>'Find Item'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3375397848172379)
,p_name=>'P104_URL_TARGET'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(31178079384755103)
,p_prompt=>'URL Target'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Identify URL to go to when the breadcrumb entry is clicked.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3701719101555006)
,p_name=>'P104_SEARCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3701695051555005)
,p_prompt=>'Search'
,p_placeholder=>'Search Breadcrumb Entries...'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_icon_css_classes=>'a-Icon icon-search'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_warn_on_unsaved_changes=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4268679504696921)
,p_name=>'P104_DISPLAY_WHEN_COND_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(13853237952413056)
,p_item_source_plug_id=>wwv_flow_imp.id(2300916966269809)
,p_prompt=>'Condition Type'
,p_source=>'DISPLAY_WHEN_COND_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CONDITION_LIST'
,p_named_lov=>'STANDARD_CONDITION_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(13602414170805697)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Condition Type -'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select a condition type from the list. This condition must be met in order for this component to be rendered or processed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'P104_DISPLAY_WHEN_CONDITION'
,p_attribute_02=>'P104_DISPLAY_WHEN_CONDITION2'
,p_attribute_04=>'P104_DISPLAY_WHEN_CONDITION_CHECK'
,p_attribute_06=>'CONDITION'
,p_attribute_07=>'P104_DISPLAY_WHEN_COND_LANG'
,p_item_comment=>'Generated 30-APR-2002 21:01:54'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4269590506696925)
,p_name=>'P104_DISPLAY_WHEN_COND_LANG'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_imp.id(13853237952413056)
,p_prompt=>'Language'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Select a language that is used to evaluate the entered programming code.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4270499400696925)
,p_name=>'P104_DISPLAY_WHEN_CONDITION'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_imp.id(13853237952413056)
,p_item_source_plug_id=>wwv_flow_imp.id(2300916966269809)
,p_prompt=>'Expression 1'
,p_source=>'DISPLAY_WHEN_CONDITION'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'This attribute allows you to conditionally control whether or not a  component is rendered or processed. Enter values in this attribute based on the specific condition type selected. The component will be rendered or processed if the specified condit'
||'ion is met.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_item_comment=>'Generated 30-APR-2002 21:01:55'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4271374812696926)
,p_name=>'P104_DISPLAY_WHEN_CONDITION_CHECK'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_imp.id(13853237952413056)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Do not validate code (parse code at runtime only).'
,p_source=>'NULL'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4271717788696926)
,p_name=>'P104_DISPLAY_WHEN_CONDITION2'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_imp.id(13853237952413056)
,p_item_source_plug_id=>wwv_flow_imp.id(2300916966269809)
,p_prompt=>'Expression 2'
,p_source=>'DISPLAY_WHEN_CONDITION2'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Some condition types require two expressions for comparison. Enter the second expression or item here.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_item_comment=>'Generated 30-APR-2002 21:01:55'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20905008149355450)
,p_name=>'P104_MENU_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(20904804175355448)
,p_item_source_plug_id=>wwv_flow_imp.id(20904804175355448)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2304195256269841)
,p_computation_sequence=>10
,p_computation_item=>'P104_OPTION_MENU_ID'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P104_MENU_ID'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(9168306596345114)
,p_computation_sequence=>20
,p_computation_item=>'P104_LINK'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_clear_cache varchar2(4000);',
'begin',
'    if :P104_URL_OR_FLOW = ''FLOW'' then',
'        if :P104_CLEAR_PAGE = ''YES'' then',
'            l_clear_cache := ''RP,''||:P104_CLEAR_CACHE;',
'        else',
'            l_clear_cache := :P104_CLEAR_CACHE;',
'        end if;',
'        return ''f?p=&''||''APP_ID.:''||:P104_TARGET_PAGE_ID||'':&''||''SESSION.:''||:P104_REQUEST||'':&''||''DEBUG.:''||rtrim(l_clear_cache,'','')||'':''||:P104_ARG_NAMES||'':''||:P104_ARG_VALUES;',
'    elsif :P104_URL_OR_FLOW = ''0'' then',
'        return null;',
'    else ',
'        return :P104_URL_TARGET;',
'    end if;',
'end;'))
,p_computation_error_message=>'Unable to compute item value.'
,p_compute_when=>':REQUEST IN (''CREATE_ENTRY'',''CREATE_ENTRY_AGAIN'',''SAVE_ENTRY'')'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2427515248300709)
,p_computation_sequence=>30
,p_computation_item=>'P104_PAGE_SUCCESS_MSG'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(DECODE(:REQUEST,''CREATE_ENTRY'',''SC.BC.BCE_INSERTED'',''CREATE_ENTRY_AGAIN'',''SC.BC.BCE_INSERTED'',''SAVE_ENTRY'',''SC.BC.BCE_UPDATED'',''DELETE_ENTRY'',''SC.BC.BCE_DELETED'',''SAVE'',''SC.BC.BC_UPDATED'',''DELETE'',''SC.BC.BC_DELETED'
||''',''GENERIC.CHANGES_SAVED'')) msg',
'from sys.dual'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(8474338540051449)
,p_computation_sequence=>10
,p_computation_item=>'P104_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'from wwv_flow_menu_options',
'where menu_id = :P104_MENU_ID',
'and page_id = :P104_PAGE_ID',
'and flow_id = :FB_FLOW_ID  ',
'and security_group_id = :FLOW_SECURITY_GROUP_ID',
'and rownum = 1',
''))
,p_compute_when=>':P104_MENU_ID is not null and :P104_PAGE_ID is not null and :P104_ID is null'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2427345029300707)
,p_computation_sequence=>20
,p_computation_item=>'P104_SELECTED_NODE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'coalesce(:P104_ID,''bc''||:P104_MENU_ID)'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2428388409300717)
,p_computation_sequence=>30
,p_computation_item=>'P104_SEARCH'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'sys.utl_url.unescape(:P104_SEARCH)'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(8470095755051406)
,p_validation_name=>'P104_PAGE_ID is not null'
,p_validation_sequence=>10
,p_validation=>'P104_PAGE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>':REQUEST IN (''CREATE_ENTRY'',''CREATE_ENTRY_AGAIN'',''SAVE_ENTRY'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(2302032647269820)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(8470338116051409)
,p_validation_name=>'P104_PAGE_ID is unique'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'from wwv_flow_menu_options',
'where menu_id = :P104_MENU_ID',
'and page_id = :P104_PAGE_ID',
'and flow_id = :FB_FLOW_ID  ',
'and security_group_id = :flow_security_group_id',
'-- ignore current breadcrumb entry',
'and id != :P104_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'This Page already has an associated Breadcrumb Entry. You must select another page.'
,p_validation_condition=>':REQUEST IN (''CREATE_ENTRY'',''CREATE_ENTRY_AGAIN'',''SAVE_ENTRY'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(2302032647269820)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_required_patch=>wwv_flow_imp.id(170786031904296885)
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(8470213474051408)
,p_validation_name=>'P104_PAGE_ID is numeric'
,p_validation_sequence=>40
,p_validation=>'P104_PAGE_ID'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'#LABEL# must be numeric.'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(8470115948051407)
,p_validation_name=>'P104_SHORT_NAME is not null'
,p_validation_sequence=>50
,p_validation=>'P104_SHORT_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>':REQUEST IN (''CREATE_ENTRY'',''CREATE_ENTRY_AGAIN'',''SAVE_ENTRY'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(2301717367269817)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(8470498327051410)
,p_validation_name=>'P104_TARGET_PAGE_ID is not null'
,p_validation_sequence=>60
,p_validation=>'P104_TARGET_PAGE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>':REQUEST IN (''CREATE_ENTRY'',''CREATE_ENTRY_AGAIN'',''SAVE_ENTRY'') and :P104_URL_OR_FLOW = ''FLOW'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(3369910974172376)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(8470555035051411)
,p_validation_name=>'P104_URL_TARGET is not null'
,p_validation_sequence=>70
,p_validation=>'P104_URL_TARGET'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>':REQUEST IN (''CREATE_ENTRY'',''CREATE_ENTRY_AGAIN'',''SAVE_ENTRY'') and :P104_URL_OR_FLOW = ''URL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(3375397848172379)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(8470686159051412)
,p_validation_name=>'P104_PARENT_ID != P104_ID'
,p_validation_sequence=>80
,p_validation=>'coalesce(:P104_PARENT_ID,5555555566666666) != coalesce(:P104_ID,9999999988888888)'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Breadcrumb entry can not identify itself as its parent.'
,p_when_button_pressed=>wwv_flow_imp.id(2304873252269848)
,p_associated_item=>wwv_flow_imp.id(2301332269269813)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(10768689833283437)
,p_name=>'Hide FLOW Choice'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P104_URL_OR_FLOW'
,p_condition_element=>'P104_URL_OR_FLOW'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'FLOW,0'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(10769021618283457)
,p_event_id=>wwv_flow_imp.id(10768689833283437)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P104_URL_TARGET'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(10769574989283458)
,p_event_id=>wwv_flow_imp.id(10768689833283437)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P104_URL_TARGET'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(10868589641303115)
,p_name=>'Hide URL choice'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P104_URL_OR_FLOW'
,p_condition_element=>'P104_URL_OR_FLOW'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'URL,0'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(10868944410303128)
,p_event_id=>wwv_flow_imp.id(10868589641303115)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P104_TARGET_PAGE_ID,P104_CLEAR_CACHE,P104_CLEAR_PAGE,P104_REQUEST,P104_ARG_NAMES,P104_ARG_VALUES'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(10869405871303128)
,p_event_id=>wwv_flow_imp.id(10868589641303115)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P104_TARGET_PAGE_ID,P104_CLEAR_CACHE,P104_CLEAR_PAGE,P104_REQUEST,P104_ARG_NAMES,P104_ARG_VALUES'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(8470898405051414)
,p_name=>'Delete Breadcrumb'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2312385894292715)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8470999259051415)
,p_event_id=>wwv_flow_imp.id(8470898405051414)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.confirm(htmldb_delete_message,''DELETE'');'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(8471138820051417)
,p_name=>'Delete Breadcrumb Entry'
,p_event_sequence=>40
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2304445449269844)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8471269558051418)
,p_event_id=>wwv_flow_imp.id(8471138820051417)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.confirm(htmldb_delete_message,''DELETE_ENTRY'');'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3701880007555007)
,p_name=>'Search'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P104_SEARCH'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'this.browserEvent.which === 13'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'keydown'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2427782509300711)
,p_event_id=>wwv_flow_imp.id(3701880007555007)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(20904792963355447)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3101075834676305)
,p_name=>'Clear Search'
,p_event_sequence=>60
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3100954151676304)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3101147159676306)
,p_event_id=>wwv_flow_imp.id(3101075834676305)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P104_SEARCH'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2428275874300716)
,p_event_id=>wwv_flow_imp.id(3101075834676305)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(20904792963355447)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2427937204300713)
,p_name=>'Highlight Search Results'
,p_event_sequence=>70
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(20904792963355447)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3701918308555008)
,p_event_id=>wwv_flow_imp.id(2427937204300713)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.builder.treeUtil.search ($v("P104_SEARCH"),''bcEntries'',''a-Property-highlight'');'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2429010819300724)
,p_name=>'Focus Tree Node'
,p_event_sequence=>100
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2429180549300725)
,p_event_id=>wwv_flow_imp.id(2429010819300724)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.builder.treeUtil.focus("bcEntries");'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3303952744286937)
,p_name=>'Save Tree Expansion State'
,p_event_sequence=>110
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'unload'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3304068788286938)
,p_event_id=>wwv_flow_imp.id(3303952744286937)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var ids = apex.region("bcEntries").call("getExpandedNodeIds").join(":");',
'apex.storage.getScopedSessionStorage({usePageId: true, useAppId: true}).setItem("treeExpansionState", ids);'))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3676064321250177)
,p_process_sequence=>30
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Populate Target Items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_dummy varchar2(255);',
'begin',
'    for c1 in (select link',
'                 from wwv_flow_menu_options',
'                where id = :P104_ID) loop    ',
'        wwv_flow_builder.split_url(',
'            p_url         => c1.link,',
'            p_flow        => l_dummy,',
'            p_page        => :P104_TARGET_PAGE_ID,',
'            p_session     => l_dummy,',
'            p_request     => :P104_REQUEST,',
'            p_debug       => l_dummy,',
'            p_clear_cache => :P104_CLEAR_CACHE,',
'            p_arg_names   => :P104_ARG_NAMES,',
'            p_arg_values  => :P104_ARG_VALUES,',
'            p_success_msg => l_dummy);    ',
'        if :P104_TARGET_PAGE_ID is null then',
'            if c1.link is not null then',
'                :P104_URL_TARGET := c1.link;',
'                :P104_URL_OR_FLOW := ''URL'';',
'            else',
'                :P104_URL_OR_FLOW := ''0'';',
'            end if;',
'        else ',
'            :P104_URL_TARGET := null;',
'            :P104_URL_OR_FLOW := ''FLOW'';',
'            if instr(:P104_CLEAR_CACHE,''RP'') = 1 then',
'              :P104_CLEAR_PAGE := ''YES'';',
'              :P104_CLEAR_CACHE := ltrim(replace(:P104_CLEAR_CACHE,''RP'',null),'','');',
'            else',
'              :P104_CLEAR_PAGE := null;',
'            end if;',
'        end if;',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P104_ID'
,p_process_when_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_internal_uid=>3676064321250177
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(11468369998820719)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Breadcrumb Regions'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete wwv_flow_page_plugs',
' where menu_id           = :P104_MENU_ID',
'   and flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to delete breadcrumb regions.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2312385894292715)
,p_process_when=>'P104_MENU_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>11468369998820719
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2304200083269842)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(20904804175355448)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Save Breadcrumb Data'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':REQUEST IN (''SAVE'',''DELETE'')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'&P104_PAGE_SUCCESS_MSG.'
,p_internal_uid=>2304200083269842
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2304393691269843)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(2300916966269809)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Save Breadcrumb Entry Data'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':REQUEST IN (''CREATE_ENTRY'',''CREATE_ENTRY_AGAIN'',''SAVE_ENTRY'',''DELETE_ENTRY'')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'&P104_PAGE_SUCCESS_MSG.'
,p_internal_uid=>2304393691269843
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(8474235047051448)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'On Delete Entry - Update Parent ID'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'update wwv_flow_menu_options',
'   set parent_id = null',
' where parent_id         = :P104_ID',
'   and menu_id           = :P104_MENU_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2304445449269844)
,p_internal_uid=>8474235047051448
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1801409794462313)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Sync Page Name and Title'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'update wwv_flow_steps',
'   set name       = :P104_SHORT_NAME,',
'       step_title = :P104_SHORT_NAME',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID ',
'   and id                = :P104_PAGE_ID;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':REQUEST IN (''CREATE_ENTRY'',''CREATE_ENTRY_AGAIN'',''SAVE_ENTRY'') and :P104_SYNC_PAGE_NAME = ''YES'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>' Page Name and Title are synchronized with the Breadcrumb Short Name.'
,p_internal_uid=>1801409794462313
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(20904941992355449)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(20904804175355448)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Edit Breadcrumb'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>20904941992355449
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2301168541269811)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(2300916966269809)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Breadcrumb Entry'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2301168541269811
);
end;
/
prompt --application/pages/page_00106
begin
wwv_flow_imp_page.create_page(
 p_id=>106
,p_name=>'Reparent Breadcrumb Entries'
,p_alias=>'REPARENT-BREADCRUMB-ENTRIES'
,p_step_title=>'Reparent Breadcrumb Entries'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213261028690930718)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2429381632300727)
,p_plug_name=>'Select a Parent Node'
,p_region_name=>'bcEntriesParent'
,p_region_css_classes=>'a-PageDesigner-treeWrap'
,p_region_template_options=>'#DEFAULT#:js-dialog-size720x480'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(557449278618308550)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with breadcrumb_tree',
'as',
'(',
'    select name short_name,',
'           ''icon-sc-tree'' icon,',
'           ''bc''||menus.id id,',
'           null as parent_id,',
'           null as page_id,',
'           null as option_sequence',
'      from wwv_flow_menus menus',
'     where menus.id                = :P106_MENU_ID',
'       and menus.flow_id           = :FB_FLOW_ID',
'       and menus.security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and ( :P106_SELECTED_NODES is null or instr('':''||:P106_SELECTED_NODES||'':'', '':bc''||id||'':'') = 0 )',
'    union all',
'    select options.short_name,',
'           null as icon,',
'           to_char(options.id) id,',
'           case when options.parent_id is null or options.parent_id = 0',
'           then',
'                ''bc''||:P106_MENU_ID',
'           else to_char(options.parent_id)',
'           end parent_id,',
'           options.page_id,',
'           option_sequence           ',
'      from wwv_flow_menu_options options',
'     where options.menu_id            = :P106_MENU_ID',
'       and options.flow_id            = :FB_FLOW_ID',
'       and options.security_group_id  = :FLOW_SECURITY_GROUP_ID',
'       and ( :P106_SELECTED_NODES is null or instr('':''||:P106_SELECTED_NODES||'':'', '':''||id||'':'') = 0 )',
')',
' select case',
'            when connect_by_isleaf = 1 then 0',
'            when level = 1             then 1',
'            else -1',
'        end as status,',
'        level,',
'        short_name,',
'        icon,',
'        id,',
'        parent_id,',
'        case',
'            when page_id is not null then wwv_flow_lang.system_message( ''PAGE'' )||'' ''||page_id',
'            else null',
'        end tooltip,',
'        null as link',
'   from breadcrumb_tree',
'  start with parent_id is null or parent_id = ''0''',
'connect by prior id = parent_id',
'  order siblings by option_sequence, short_name'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_JSTREE'
,p_ajax_items_to_submit=>'P106_MENU_ID,P106_SELECTED_NODES'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'activate_node_link_with', 'D',
  'default_icon_css_class', 'icon-sc-breadcrumb',
  'hierarchy_level_column', 'LEVEL',
  'icon_css_class_column', 'ICON',
  'icon_type_css_class', 'a-Icon',
  'node_label_column', 'SHORT_NAME',
  'node_status_column', 'STATUS',
  'node_value_column', 'ID',
  'tooltip_column', 'TOOLTIP',
  'tree_hierarchy', 'LEVEL',
  'tree_link', 'javascript:apex.builder.breadcrumb.moveNodes( ''bcEntriesParent'', ''bcEntries'' );',
  'tree_tooltip', 'DB')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2666785289425901)
,p_plug_name=>'Reparent Breadcrumb Entries'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3101398367676308)
,p_plug_name=>'Breadcrumb Selector'
,p_parent_plug_id=>wwv_flow_imp.id(2666785289425901)
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(35904920662511686)
,p_plug_name=>'Breadcrumb Entries'
,p_region_name=>'bcEntries'
,p_parent_plug_id=>wwv_flow_imp.id(2666785289425901)
,p_region_css_classes=>'a-PageDesigner-treeWrap'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>40
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with breadcrumb_tree',
'as',
'(',
'    select name short_name,',
'           ''icon-sc-tree''||'' id-''||''bc''||menus.id as icon,',
'           ''bc''||menus.id id,',
'           null as parent_id,',
'           null as page_id,',
'           null as option_sequence',
'      from wwv_flow_menus menus',
'     where menus.id                = :P106_MENU_ID',
'       and menus.flow_id           = :FB_FLOW_ID',
'       and menus.security_group_id = :FLOW_SECURITY_GROUP_ID',
'    union all',
'    select options.short_name,',
'           ''icon-sc-breadcrumb''||'' id-''||to_char(options.id) as icon,',
'           to_char(options.id) id,',
'           case when options.parent_id is null or options.parent_id = 0',
'           then',
'                ''bc''||:P106_MENU_ID',
'           else to_char(options.parent_id)',
'           end parent_id,',
'           options.page_id,',
'           option_sequence           ',
'      from wwv_flow_menu_options options',
'     where options.menu_id            = :P106_MENU_ID',
'       and options.flow_id            = :FB_FLOW_ID',
'       and options.security_group_id  = :FLOW_SECURITY_GROUP_ID',
')',
' select case',
'            when connect_by_isleaf = 1 then 0',
'            when level = 1             then 1',
'            else -1',
'        end as status,',
'        level,',
'        short_name,',
'        icon,',
'        id,',
'        parent_id,',
'        case',
'            when page_id is not null then wwv_flow_lang.system_message( ''PAGE'' )||'' ''||page_id',
'            else null',
'        end tooltip,',
'        null as link',
'   from breadcrumb_tree',
'  start with parent_id is null or parent_id = ''0''',
'connect by prior id = parent_id',
'  order siblings by option_sequence, short_name'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_JSTREE'
,p_ajax_items_to_submit=>'P106_MENU_ID'
,p_plugin_init_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function(options) {',
'    options.dragAndDrop = true;',
'    options.multiple = true;',
'    options.dragMultiple = true;',
'    options.dragCursor = "move";',
'    options.dragOpacity = 0.6;',
'    options.dragCursorAt = { left: 20, bottom: -20 };',
'    options.dragHelper = true;',
'    options.delay = 10;',
'    options.distance = 5;',
'    options.dragAppendTo = document.body;',
'    options.dragScroll = true;',
'    // tree node adapter',
'    options.makeNodeAdapter = function (data, types, hasIdentity) {',
'        var lAdapter;',
'        lAdapter = $.apex.treeView.makeDefaultNodeAdapter( data, types, hasIdentity );',
'        lAdapter.types.default.operations = {',
'            canAdd: true, // moving and copying may involve adding nodes to new parent',
'            canDrag: true,',
'            canDelete: true, // moving may involve deleting from one parent',
'            drag: { normal: "move", ctrl: "copy" }',
'        };',
'        // by default it''s not possible to add children to lead nodes ',
'        // add empty children to enable adding (dropping nodes) to leaf nodes',
'        apex.builder.treeUtil.traverse(lAdapter.root());',
'        lAdapter.validateMove = apex.builder.breadcrumb.validateMove;',
'        return lAdapter;',
'    };',
'    // tree context menu',
'    var lSelection$,',
'        lTree$,',
'        lSelectedNodes,',
'        lAjaxRequest,',
'        lExpandAll,',
'        lCollapseAll,',
'        lExpandAllBelow,',
'        lCollapseAllBelow;',
'',
'    // context menu labels',
'    lExpandAll = apex.lang.getMessage( "TREE.EXPAND_ALL" );',
'    lCollapseAll = apex.lang.getMessage( "TREE.COLLAPSE_ALL" );',
'    lExpandAllBelow = apex.lang.getMessage( "TREE.EXPAND_ALL_BELOW" );',
'    lCollapseAllBelow = apex.lang.getMessage( "TREE.COLLAPSE_ALL_BELOW" );',
'',
'    options.contextMenuId = "bcTreeMenu";',
'    options.contextMenu = {',
'        items: [',
'            {',
'                type: "action",',
'                label: lExpandAll, ',
'                action: function( _, el ) {',
'                    lTree$.treeView("expandAll");',
'                }',
'            },',
'            {',
'                type: "action",',
'                label: lCollapseAll, ',
'                action: function( event, el ) {',
'                    lTree$.treeView("collapseAll");',
'                }',
'            },',
'            {',
'                type: "action",',
'                label: lExpandAllBelow,',
'                action: function( _, el ) {',
'                    lTree$.treeView("expandAll", lSelection$);',
'                }',
'            },',
'            {',
'                type: "action",',
'                label: lCollapseAllBelow,',
'                action: function( event, el ) {',
'                    lTree$.treeView("collapseAll", lSelection$);',
'                }',
'            },',
'            {',
'                type: "separator"',
'            },',
'            {',
'                type: "action",',
'                label: "Reparent",',
'                action: function( _, el ) {',
'                    apex.builder.breadcrumb.showParentTree( lSelectedNodes, "P106_SELECTED_NODES", "bcEntriesParent" );',
'                },',
'                disabled: function () { return ( lSelection$.length === 0 || ( lSelection$.length === 1 && ( lSelectedNodes[0].id ).indexOf( "bc" ) === 0 ) );}',
'            }',
'        ],',
'        beforeOpen: function( event, data ) {',
'            lTree$         = data.treeView;',
'            lSelection$    = data.selection;',
'            lSelectedNodes = data.selectedNodes;',
'        }',
'    }    ',
'    return options;',
'}'))
,p_landmark_type=>'region'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'activate_node_link_with', 'S',
  'default_icon_css_class', 'icon-sc-breadcrumb',
  'hierarchy_level_column', 'LEVEL',
  'icon_css_class_column', 'ICON',
  'icon_type_css_class', 'a-Icon',
  'node_label_column', 'SHORT_NAME',
  'node_status_column', 'STATUS',
  'node_value_column', 'ID',
  'tooltip_column', 'TOOLTIP',
  'tree_hierarchy', 'LEVEL',
  'tree_tooltip', 'DB')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(50608686167121130)
,p_plug_name=>'About'
,p_region_name=>'bcEntries'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'This page is used to manage a breadcrumb hierarchy. Use drag and drop to reparent breadcrumb entries. Changes are automatically saved.',
'<br /><br />It is also possible to reparent the entries using the context menu. Select one or more breadcrumb entries to reparent, right click and select the "Reparent" option. This will show a sub tree, with all the possible valid parent entries. Se'
||'lect a parent entry and click on "Reparent" button or just hit "Enter" key. This will reparent selected entries under new parent entry.'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(126520849800705750)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(111619820846587947)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Breadcrumbs'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2429591377300729)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(35904920662511686)
,p_button_name=>'TREE_MENU'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Breadcrumb Entries'
,p_button_position=>'ABOVE_BOX'
,p_button_alignment=>'LEFT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'js-menuButton'
,p_icon_css_classes=>'icon-menu'
,p_button_cattributes=>'data-menu="bcTreeMenu"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3101555629676310)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(3101398367676308)
,p_button_name=>'GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Go'
,p_warn_on_unsaved_changes=>null
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1154969520888084240)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(2429381632300727)
,p_button_name=>'REPARENT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Reparent'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2429411018300728)
,p_name=>'P106_SELECTED_NODES'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2429381632300727)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3101469216676309)
,p_name=>'P106_MENU_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3101398367676308)
,p_prompt=>'Breadcrumb'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION.MENUS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name,',
'       id',
'  from wwv_flow_menus',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
' order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2427689972300710)
,p_computation_sequence=>10
,p_computation_item=>'P106_MENU_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
' select min(id)',
'   from wwv_flow_menus',
'  where flow_id           = :FB_FLOW_ID',
'    and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_computation_comment=>'By Default show any breadcrumb from current application. If P106_MENU_ID is not null, ensure it''s from current application. Otherwise load any breadcrumb from current application. '
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
' select *',
'   from wwv_flow_menus',
'  where flow_id           = :FB_FLOW_ID',
'    and security_group_id = :FLOW_SECURITY_GROUP_ID',
'    and id                = coalesce(to_number(:P106_MENU_ID),-1)'))
,p_compute_when_type=>'NOT_EXISTS'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2429622506300730)
,p_name=>'Parent Tree - Focus Root Node'
,p_event_sequence=>20
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(2429381632300727)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2429742540300731)
,p_event_id=>wwv_flow_imp.id(2429622506300730)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// by default select root node',
'apex.builder.treeUtil.selectRoot( "bcEntriesParent" );'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2429885001300732)
,p_name=>'Main Tree - Focus Root Node'
,p_event_sequence=>30
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(35904920662511686)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2429934660300733)
,p_event_id=>wwv_flow_imp.id(2429885001300732)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// by default select root node',
'apex.builder.treeUtil.selectRoot( "bcEntries" );'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1154969623682084241)
,p_name=>'Reparent Selected Entries'
,p_event_sequence=>40
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1154969520888084240)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1154969741918084242)
,p_event_id=>wwv_flow_imp.id(1154969623682084241)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.builder.breadcrumb.moveNodes( ''bcEntriesParent'', ''bcEntries'' );'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(15100295260267560)
,p_process_sequence=>10
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'SAVE_CHANGES'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_4000_ui.save_breadcrumb_changes(',
'    p_menu_id           => :P106_MENU_ID,',
'    p_app_id            => :FB_FLOW_ID,',
'    p_workspace_id      => :FLOW_SECURITY_GROUP_ID,',
'    p_changes           => wwv_flow.g_f01);'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>15100295260267560
);
end;
/
prompt --application/pages/page_00109
begin
wwv_flow_imp_page.create_page(
 p_id=>109
,p_name=>'Component Checksum'
,p_alias=>'COMPONENT-CHECKSUM'
,p_page_mode=>'MODAL'
,p_step_title=>'Checksum'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_javascript_code=>'var lSpinner$;'
,p_javascript_code_onload=>'lSpinner$ = apex.util.showSpinner(''.a-Dialog-body''); '
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_width=>'600'
,p_dialog_attributes=>'resizable:true,height:320'
,p_help_text=>'bldapp_pg.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(632165757692856031)
,p_plug_name=>'Dialog Body'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="display: none;"'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(590828197353847074)
,p_plug_name=>'Checksum'
,p_parent_plug_id=>wwv_flow_imp.id(632165757692856031)
,p_region_css_classes=>'margin-left-md margin-right-md a-Form--large'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P109_COMPONENT = ''APPLICATION'' then',
'    sys.htp.p(wwv_flow_lang.message(''APEX.APPLICATION.CHECKSUM.DESCRIPTION''));',
'elsif :P109_COMPONENT = ''PAGE'' then',
'    sys.htp.p(wwv_flow_lang.message(''APEX.PAGE.CHECKSUM.DESCRIPTION''));',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(591702465565020403)
,p_name=>'Page Information'
,p_parent_plug_id=>wwv_flow_imp.id(632165757692856031)
,p_template=>wwv_flow_imp.id(208928010704475743)
,p_display_sequence=>40
,p_region_sub_css_classes=>'a-AVPList--leftAligned'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       name,',
'       null details,',
'       (select to_char(count(*),''999G999G990'') from wwv_flow_page_plugs   where flow_id = fs.flow_id and page_id = fs.id) regions,',
'       (select to_char(count(*),''999G999G990'') from wwv_flow_step_items   where flow_id = fs.flow_id and flow_step_id = fs.id) items,',
'       (select to_char(count(*),''999G999G990'') from wwv_flow_step_buttons where flow_id = fs.flow_id and flow_step_id = fs.id) buttons',
'from wwv_flow_steps fs',
'where flow_id = :FB_FLOW_ID and id = :fb_flow_page_id and security_group_id = :flow_security_group_id '))
,p_display_when_condition=>'P109_COMPONENT'
,p_display_when_cond2=>'PAGE'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(1041645860037406591)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(591702666299020405)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>20
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(591702504636020404)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>10
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<strong>#NAME#</strong>'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(591702788904020406)
,p_query_column_id=>3
,p_column_alias=>'DETAILS'
,p_column_display_sequence=>30
,p_column_heading=>'Details'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'#REGIONS# Regions, #ITEMS# Items, #BUTTONS# Buttons'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(591702901827020408)
,p_query_column_id=>4
,p_column_alias=>'REGIONS'
,p_column_display_sequence=>50
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(591703031873020409)
,p_query_column_id=>5
,p_column_alias=>'ITEMS'
,p_column_display_sequence=>60
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(591703189655020410)
,p_query_column_id=>6
,p_column_alias=>'BUTTONS'
,p_column_display_sequence=>70
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(632164936929856023)
,p_name=>'Application Information'
,p_parent_plug_id=>wwv_flow_imp.id(632165757692856031)
,p_template=>wwv_flow_imp.id(208928010704475743)
,p_display_sequence=>30
,p_region_sub_css_classes=>'a-AVPList--leftAligned'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       name,',
'       null details,',
'       (select to_char(count(*),''999G999G990'') from wwv_flow_steps where flow_id = f.id) pages,',
'       (select to_char(count(*),''999G999G990'') from wwv_flow_page_plugs where flow_id = f.id) regions,',
'       (select to_char(count(*),''999G999G990'') from wwv_flow_items where flow_id = f.id) items',
'from wwv_flows f',
'where id = :FB_FLOW_ID and security_group_id = :flow_security_group_id '))
,p_display_when_condition=>'P109_COMPONENT'
,p_display_when_cond2=>'APPLICATION'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(1041645860037406591)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(632165182214856025)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>20
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(632165388699856027)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>10
,p_column_heading=>'Application'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<strong>#NAME#</strong>'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(632166040647856034)
,p_query_column_id=>3
,p_column_alias=>'DETAILS'
,p_column_display_sequence=>40
,p_column_heading=>'Details'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'#PAGES# Pages, #REGIONS# Regions, #ITEMS# Items'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(632165468252856028)
,p_query_column_id=>4
,p_column_alias=>'PAGES'
,p_column_display_sequence=>50
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(632165821374856032)
,p_query_column_id=>5
,p_column_alias=>'REGIONS'
,p_column_display_sequence=>60
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(632165953500856033)
,p_query_column_id=>6
,p_column_alias=>'ITEMS'
,p_column_display_sequence=>70
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(569703810529235083)
,p_name=>'P109_CHECKSUM_VALUE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(590828197353847074)
,p_prompt=>'Checksum Value'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>1
,p_tag_css_classes=>'u-tC'
,p_tag_attributes=>'readonly style="font-size: 24px; line-height: 64px;"'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth a-Form-fieldContainer--stretch a-Form-fieldContainer--noPadding margin-bottom-md'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(575876134884387127)
,p_name=>'P109_COMPONENT'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(590828197353847074)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(632164065770856014)
,p_name=>'P109_CHECKSUM_HIDDEN'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(590828197353847074)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(632163699863856010)
,p_name=>'Load Checksum'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(632163702640856011)
,p_event_id=>wwv_flow_imp.id(632163699863856010)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P109_CHECKSUM_VALUE,P109_CHECKSUM_HIDDEN'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_export wwv_flow_t_export_files;',
'begin',
'    if :P109_COMPONENT = ''APPLICATION'' then',
'        l_export := wwv_flow_export_api.get_application (',
'                        p_application_id => :FB_FLOW_ID,',
'                        p_type           => ''CHECKSUM-SH1'' );',
'    elsif :P109_COMPONENT = ''PAGE'' then',
'        l_export := wwv_flow_export_api.get_application (',
'                        p_application_id => :FB_FLOW_ID,',
'                        p_components    => wwv_flow_t_varchar2(''PAGE:''||:FB_FLOW_PAGE_ID),',
'                        p_type           => ''CHECKSUM-SH1'' );',
'    end if;',
'    return l_export(1).contents;',
'end;'))
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(632164185083856015)
,p_name=>'Show Checksum'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P109_CHECKSUM_HIDDEN'
,p_condition_element=>'P109_CHECKSUM_HIDDEN'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(632164244353856016)
,p_event_id=>wwv_flow_imp.id(632164185083856015)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(632165757692856031)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(632164338106856017)
,p_event_id=>wwv_flow_imp.id(632164185083856015)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(632165757692856031)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(632163931090856013)
,p_event_id=>wwv_flow_imp.id(632164185083856015)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'lSpinner$.remove();',
'$("#P109_CHECKSUM_VALUE").focus().select();',
''))
);
end;
/
prompt --application/pages/page_00110
begin
wwv_flow_imp_page.create_page(
 p_id=>110
,p_name=>'Font APEX Icons'
,p_alias=>'FONT-APEX'
,p_step_title=>'Font APEX Icons'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(261841008861828406)
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.iconBuilder = apex.iconBuilder || {};',
'',
'(function( $, iconBuilder ){',
'',
'    iconBuilder.open = function( pIcon ){',
'        var icon = $(pIcon).text();',
'        $s( ''P110_ICONCLASS'', icon );',
'        $("#icon_dialog").dialog({',
'            title: icon,',
'            width: 600,',
'            modal: true,',
'        }).dialog( "open" );',
'        ',
'        iconBuilder.renderIconPreview ( icon );',
'    };',
'',
'    iconBuilder.renderIconPreview = function( ) {',
'        var iconClass = $v( ''P110_ICONCLASS'' );',
'            iconSize = $v(''P110_FA_SIZE'') === ''LARGE'' ? ''fa-lg'' : '''',',
'            iconScale = $v(''P110_ICON_SIZE'') !== ''null'' ? $v(''P110_ICON_SIZE'') : '''',',
'            iconModStatus = $v(''P110_MODIFIER'') ? $v(''P110_MODIFIER_STATUS'') : '''';',
'',
'        var iconModifiers = iconScale +'' ''+ $v(''P110_ANIMATION'') +'' ''+ $v(''P110_ROTATE'') +'' ''+ $v(''P110_MODIFIER'') +'' ''+ iconModStatus +'' ''+ iconSize;',
'        $("#icon_preview span").removeAttr("class").addClass("fa " + iconClass +'' ''+ iconModifiers).attr("aria-hidden","true");',
'        $("#icon_code").text($("#icon_preview").html());',
'        $("#icon_classes").text($("#icon_preview span").attr("class").substr(3));',
'    };',
'',
'})( apex.jQuery, apex.iconBuilder );'))
,p_css_file_urls=>'#FONT_APEX_LATEST_DIRECTORY#css/font-apex#MIN#.css'
,p_step_template=>wwv_flow_imp.id(438185046231548086)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'mg_attribute_dict.htm'
,p_page_component_map=>'22'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(563231405920439007)
,p_plug_name=>'Search'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_location=>null
,p_plug_source_type=>'NATIVE_FACETED_SEARCH'
,p_filtered_region_id=>wwv_flow_imp.id(563231781790439010)
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'batch_facet_search', 'N',
  'compact_numbers_threshold', '10000',
  'display_chart_for_top_n_values', '10',
  'show_charts', 'Y',
  'show_current_facets', 'N',
  'show_total_row_count', 'N')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(563231781790439010)
,p_plug_name=>'Icons'
,p_region_name=>'icons'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       icon_name,',
'       icon_filters,',
'       icon_category',
'  from wwv_flow_standard_icons',
' where icon_library = ''FONTAPEX''',
' order by icon_name;'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_CARDS'
,p_plug_query_num_rows_type=>'SCROLL'
,p_show_total_row_count=>false
);
wwv_flow_imp_page.create_card(
 p_id=>wwv_flow_imp.id(563232749835439020)
,p_region_id=>wwv_flow_imp.id(563231781790439010)
,p_layout_type=>'GRID'
,p_component_css_classes=>'a-FA-cards'
,p_title_adv_formatting=>false
,p_title_column_name=>'ICON_NAME'
,p_sub_title_adv_formatting=>false
,p_body_adv_formatting=>false
,p_second_body_adv_formatting=>false
,p_icon_source_type=>'DYNAMIC_CLASS'
,p_icon_class_column_name=>'ICON_NAME'
,p_icon_css_classes=>'fa'
,p_icon_position=>'START'
,p_media_adv_formatting=>false
,p_pk1_column_name=>'ID'
);
wwv_flow_imp_page.create_card_action(
 p_id=>wwv_flow_imp.id(563233179291439024)
,p_card_id=>wwv_flow_imp.id(563232749835439020)
,p_action_type=>'FULL_CARD'
,p_display_sequence=>10
,p_link_target_type=>'REDIRECT_PAGE'
,p_link_target=>'javascript:void(0);'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(563233046477439023)
,p_plug_name=>'Icon Dialog'
,p_region_name=>'icon_dialog'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="display:none"'
,p_plug_template=>wwv_flow_imp.id(461857790551605627)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'js-dialog-autoheight'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(563233503304439028)
,p_plug_name=>'Icon Preview'
,p_parent_plug_id=>wwv_flow_imp.id(563233046477439023)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(461857790551605627)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<div id="icon_preview" class="dm-IconDialog-preview"><span></span></div>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(563233680466439029)
,p_plug_name=>'Icon Form'
,p_parent_plug_id=>wwv_flow_imp.id(563233046477439023)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(461857790551605627)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(563233788250439030)
,p_plug_name=>'Icon Instructions'
,p_parent_plug_id=>wwv_flow_imp.id(563233046477439023)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(461857790551605627)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="dm-IconDialog-info ">',
'    <span class="dm-IconDialog-infoTitle">HTML <button type="button" title="Copy HTML Markup" class="a-Button a-Button--iconTextButton a-Button--withIcon a-Button--gapLeft a-Button--iconLeft a-Button--small" data-clipboard-source="#icon_code"><span a'
||'ria-hidden="true" class="a-Icon icon-copy"></span>Copy</button></span>',
'    <div class="dm-IconDialog-infoBody">',
'        <code id="icon_code"></code>',
'    </div>',
'</div>',
'<div class="dm-IconDialog-info ">',
'    <span class="dm-IconDialog-infoTitle">Icon <button type="button" title="Copy Icon Class" class="a-Button a-Button--iconTextButton a-Button--withIcon a-Button--gapLeft a-Button--iconLeft a-Button--small" data-clipboard-source="#icon_classes"><span'
||' aria-hidden="true" class="a-Icon icon-copy"></span>Copy</button> </span>',
'    <div class="dm-IconDialog-infoBody">',
'        <code id="icon_classes"></code>',
'        <small>Enter in the Icon property for Buttons, Regions, and other components.</small>',
'    </div>',
'</div>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(830858711838132553)
,p_plug_name=>'Font APEX'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>You can use this page to search for Font APEX icons.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(563235599368439048)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(563233046477439023)
,p_button_name=>'RESET_ICON'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader:a-Button--small:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'Reset Icon'
,p_button_position=>'TOP'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'icon-ig-refresh'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(563232590529439018)
,p_name=>'P110_CATEGORY'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(563231405920439007)
,p_prompt=>'Category'
,p_source=>'ICON_CATEGORY'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'ICON CATEGORIES'
,p_lov=>'.'||wwv_flow_imp.id(577691284053554107)||'.'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_fc_show_label=>false
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_compute_counts=>true
,p_fc_show_counts=>true
,p_fc_zero_count_entries=>'H'
,p_fc_show_more_count=>50
,p_fc_filter_values=>false
,p_fc_sort_by_top_counts=>true
,p_fc_show_selected_first=>false
,p_fc_show_chart=>false
,p_fc_actions_filter=>false
,p_fc_toggleable=>false
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
,p_multi_value_trim_space=>false
,p_fc_filter_combination=>'OR'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(563232643900439019)
,p_name=>'P110_SEARCH'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(563231405920439007)
,p_prompt=>'Search'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_SEARCH'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ROW'
,p_attribute_02=>'FACET'
,p_fc_show_label=>false
,p_fc_filter_values=>false
,p_fc_show_chart=>false
,p_fc_actions_filter=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(563233855248439031)
,p_name=>'P110_FA_SIZE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(563233680466439029)
,p_prompt=>'Size'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'ICON SIZE'
,p_lov=>'.'||wwv_flow_imp.id(577725423197001069)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(563233901508439032)
,p_name=>'P110_ICON_SIZE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(563233680466439029)
,p_item_default=>'null'
,p_prompt=>'Scale'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC:1x;null,2x;fa-2x,3x;fa-3x,4x;fa-4x,5x;fa-5x'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'5'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(563234015219439033)
,p_name=>'P110_ANIMATION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(563233680466439029)
,p_prompt=>'Animation'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ICON ANIMATION'
,p_lov=>'.'||wwv_flow_imp.id(577722878770995845)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Static'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(563234154061439034)
,p_name=>'P110_ROTATE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(563233680466439029)
,p_prompt=>'Rotate'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ICON ROTATE'
,p_lov=>'.'||wwv_flow_imp.id(577740129346133895)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Normal'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(563234200520439035)
,p_name=>'P110_MODIFIER'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(563233680466439029)
,p_prompt=>'Modifier'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ICON MODIFIER'
,p_lov=>'.'||wwv_flow_imp.id(577742586590147796)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'None'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(563234393997439036)
,p_name=>'P110_MODIFIER_STATUS'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(563233680466439029)
,p_item_default=>'fam-is-success'
,p_prompt=>'Status'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ICON MODIFIER STATUS'
,p_lov=>'.'||wwv_flow_imp.id(577752611204165565)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(563234423454439037)
,p_name=>'P110_SIZE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(563231405920439007)
,p_item_default=>'SMALL'
,p_prompt=>'New'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'ICON SIZE'
,p_lov=>'.'||wwv_flow_imp.id(577725423197001069)||'.'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(563235044567439043)
,p_name=>'P110_ICONCLASS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(563233046477439023)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(563233229939439025)
,p_name=>'Open Icon Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'.a-CardView-fullLink'
,p_bind_type=>'live'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(563233341041439026)
,p_event_id=>wwv_flow_imp.id(563233229939439025)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.iconBuilder.open(this.triggeringElement);'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(563234561203439038)
,p_name=>'Toggle Icon Size'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P110_SIZE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(563234646070439039)
,p_event_id=>wwv_flow_imp.id(563234561203439038)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var size = $v(''P110_SIZE''),',
'    icons$ = $( ''#icons'' ),',
'    L_CLASS = ''force-fa-lg'';',
'if ( size === ''LARGE'' ) {',
'    icons$.addClass( L_CLASS );',
'} else {',
'    icons$.removeClass( L_CLASS );',
'}'))
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(563235178446439044)
,p_event_id=>wwv_flow_imp.id(563234561203439038)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P110_FA_SIZE'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$v(''P110_SIZE'');'
,p_attribute_09=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(563234856755439041)
,p_name=>'Apply Modifier to Icon'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P110_ICON_SIZE,P110_ANIMATION,P110_ROTATE,P110_MODIFIER,P110_MODIFIER_STATUS'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(563234991722439042)
,p_event_id=>wwv_flow_imp.id(563234856755439041)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.iconBuilder.renderIconPreview()'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(563235225948439045)
,p_name=>'Set Icon Size'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P110_FA_SIZE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(563235393135439046)
,p_event_id=>wwv_flow_imp.id(563235225948439045)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$s(''P110_SIZE'',$v(''P110_FA_SIZE''));',
'apex.iconBuilder.renderIconPreview();',
''))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(563235638533439049)
,p_name=>'Reset Icon Settings'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(563235599368439048)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(563235754978439050)
,p_event_id=>wwv_flow_imp.id(563235638533439049)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P110_ANIMATION,P110_ROTATE,P110_MODIFIER'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(577766600675741001)
,p_event_id=>wwv_flow_imp.id(563235638533439049)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$s(''P110_ICON_SIZE'',''null'');',
'apex.iconBuilder.renderIconPreview();'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(577766931804741004)
,p_name=>'Toggle P110_MODIFIER_STATUS'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P110_MODIFIER'
,p_condition_element=>'P110_MODIFIER'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(577767061631741005)
,p_event_id=>wwv_flow_imp.id(577766931804741004)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P110_MODIFIER_STATUS'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(577767193595741006)
,p_event_id=>wwv_flow_imp.id(577766931804741004)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P110_MODIFIER_STATUS'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(577767251342741007)
,p_event_id=>wwv_flow_imp.id(577766931804741004)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P110_MODIFIER_STATUS'
);
end;
/
prompt --application/pages/page_00111
begin
wwv_flow_imp_page.create_page(
 p_id=>111
,p_name=>'Page Checksum Report'
,p_alias=>'PAGE-CHECKSUM-REPORT'
,p_step_title=>'Page Checksum Report'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(5507013954294272)
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.t-Body-inlineDialogs {border: 0;clip: rect(0 0 0 0);height: 1px;margin: -1px;overflow: hidden;padding: 0;position: absolute;width: 1px;}',
''))
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(610017009942816902)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>'<p>The page checksum report provides an easy way to compare two application deployments and see which pages are the same and which are different.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(612592719653511854)
,p_plug_name=>'Checksum Report'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'     id     page,',
'     name   page_name,',
'     lower(alias) alias,',
'     step_title page_title,',
'     group_id,',
'     wwv_flow_export_dev.page_checksum(flow_id,id) checksum,',
'     created_on, ',
'     created_by, ',
'     last_updated_on,',
'     last_updated_by',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_translate_title=>'N'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(607327911392998416)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'No backups have been created for application &FB_FLOW_ID.'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'DBLISS'
,p_internal_uid=>607327911392998416
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(632166648887856040)
,p_db_column_name=>'PAGE'
,p_display_order=>20
,p_column_identifier=>'AL'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(632167578865856049)
,p_db_column_name=>'ALIAS'
,p_display_order=>30
,p_column_identifier=>'AU'
,p_column_label=>'Alias'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(632167465092856048)
,p_db_column_name=>'GROUP_ID'
,p_display_order=>40
,p_column_identifier=>'AT'
,p_column_label=>'Group'
,p_column_type=>'NUMBER'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(212924308633451870)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(632166766689856041)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>50
,p_column_identifier=>'AM'
,p_column_label=>'Name'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.:4500:FB_FLOW_PAGE_ID:#PAGE#'
,p_column_linktext=>'#PAGE_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(632167304338856047)
,p_db_column_name=>'PAGE_TITLE'
,p_display_order=>60
,p_column_identifier=>'AS'
,p_column_label=>'Title'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(632166846425856042)
,p_db_column_name=>'CHECKSUM'
,p_display_order=>70
,p_column_identifier=>'AN'
,p_column_label=>'Checksum'
,p_column_html_expression=>'<code>#CHECKSUM#</code>'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(632166933922856043)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>80
,p_column_identifier=>'AO'
,p_column_label=>'Created'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(632167089953856044)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>90
,p_column_identifier=>'AP'
,p_column_label=>'Created By'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(632167130606856045)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>100
,p_column_identifier=>'AQ'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(632167276880856046)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>110
,p_column_identifier=>'AR'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(612621050442166301)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'5975034'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'PAGE_NAME:PAGE:ALIAS:CHECKSUM:LAST_UPDATED_BY:GROUP_ID:LAST_UPDATED_ON:'
,p_sort_column_1=>'LAST_UPDATED_ON'
,p_sort_direction_1=>'DESC'
,p_sort_column_2=>'CREATED_ON'
,p_sort_direction_2=>'DESC'
,p_sum_columns_on_break=>'DOC_SIZE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(597503865818597508)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(612592719653511854)
,p_button_name=>'reset_report'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:111:&SESSION.::&DEBUG.:RR,971::'
,p_icon_css_classes=>'icon-undo'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(632167616644856050)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(612592719653511854)
,p_button_name=>'VIEW_APP_CHECKSUM'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'View Application Checksum'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:109:&SESSION.::&DEBUG.:109:P109_COMPONENT:APPLICATION'
);
end;
/
prompt --application/pages/page_00117
begin
wwv_flow_imp_page.create_page(
 p_id=>117
,p_name=>'Restore Theme Subscription'
,p_alias=>'RESTORE-THEME-SUBSCRIPTION'
,p_step_title=>'Restore Theme Subscription'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879423075323511)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_themes.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1433723048148861501)
,p_plug_name=>'Restore Theme Subscription'
,p_region_template_options=>'#DEFAULT#:a-Form-fixedLabelsLarge'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<p>When restoring a theme subscription the current theme will be subscribed to the selected master theme and any template that has a corresponding template in the master theme, i.e. a template with a matching template identifier or template name, wil'
||'l be subscribed to that template. All templates that do not have a corresponding template in the master theme will be considered local templates.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1433724712373861519)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(106512001249472508)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1433724958099861520)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1433725564470861522)
,p_plug_name=>'Restore Theme Subscription'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1433725113968861520)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1433724958099861520)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1433725380623861521)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1433724958099861520)
,p_button_name=>'NEXT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Restore Subscription'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(932809856659193742)
,p_branch_action=>'f?p=&APP_ID.:260:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1364682539598820103)
,p_name=>'P117_MATCH_BY_NAME'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(1433723048148861501)
,p_item_default=>'N'
,p_prompt=>'Match Template:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TEMPLATE MATCH'
,p_lov=>'.'||wwv_flow_imp.id(1382206179278736769)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Templates can be matched by template identifier or name. Matching by template identifier is generally preferred as the identifiers can''t be modified after template creation.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1399864828901453701)
,p_name=>'P117_THEMES_SOURCE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(1433723048148861501)
,p_item_default=>'app'
,p_prompt=>'Theme source'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'THEME SOURCE'
,p_lov=>'.'||wwv_flow_imp.id(1399872256703479206)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1399864974479453702)
,p_name=>'P117_SHARED_MASTER_THEME_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(1433723048148861501)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'  from wwv_flow_themes ',
' where ((:P117_THEMES_SOURCE=''oracle'' and security_group_id = 12) or (:P117_THEMES_SOURCE in (''public'',''workspace'') and security_group_id = 11))',
'   and navigation_type in (select navigation_type from wwv_flow_themes where flow_id = :fb_flow_id and id = :P117_SUBSCRIBING_THEME_ID )',
'   and ((:P117_THEMES_SOURCE=''oracle'') or (:P117_THEMES_SOURCE=''public'' and theme_security_group_id is null) or (:P117_THEMES_SOURCE=''workspace'' and theme_security_group_id = :flow_security_group_id))',
' order by theme_id',
' fetch first 1 row only'))
,p_item_default_type=>'SQL_QUERY'
,p_prompt=>'Master Theme'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(theme_name) d, id r from wwv_flow_themes ',
'where ((:P117_THEMES_SOURCE=''oracle'' and security_group_id = 12) or (:P117_THEMES_SOURCE in (''public'',''workspace'') and security_group_id = 11))',
'and navigation_type in (select navigation_type from wwv_flow_themes where flow_id = :fb_flow_id and id = :P117_SUBSCRIBING_THEME_ID )',
'and ((:P117_THEMES_SOURCE=''oracle'') or (:P117_THEMES_SOURCE=''public'' and theme_security_group_id is null) or (:P117_THEMES_SOURCE=''workspace'' and theme_security_group_id = :flow_security_group_id))',
'order by theme_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Master Theme -'
,p_lov_cascade_parent_items=>'P117_THEMES_SOURCE'
,p_ajax_items_to_submit=>'P117_SUBSCRIBING_THEME_ID,P117_THEMES_SOURCE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select the master theme to which to subscribe the current theme.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1433723242914861505)
,p_name=>'P117_APPLICATION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1433723048148861501)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application:'
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_help_text=>'This attribute identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1433723779913861514)
,p_name=>'P117_SUBSCRIBING_THEME_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(1433723048148861501)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.id',
'  from wwv_flows f,',
'       wwv_flow_themes t',
' where f.id                = :fb_flow_id',
'   and f.security_group_id = :flow_security_group_id',
'   and t.flow_id           = f.id',
'   and t.security_group_id = f.security_group_id',
'   and t.theme_id          = f.theme_id',
' fetch first 1 row only'))
,p_item_default_type=>'SQL_QUERY'
,p_prompt=>'Subscribing Theme'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(theme_name) d, id r from wwv_flow_themes where flow_id = :fb_flow_id',
'order by theme_id'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the theme which you would like to subscribe to a master theme.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1433724276498861515)
,p_name=>'P117_MASTER_THEME_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(1433723048148861501)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'  from wwv_flow_themes ',
' where flow_id = :P117_MASTER_APP_ID',
' order by theme_id',
' fetch first 1 row only'))
,p_item_default_type=>'SQL_QUERY'
,p_prompt=>'Master Theme'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(theme_name) d, id r from wwv_flow_themes ',
'where flow_id = :P117_MASTER_APP_ID',
'order by theme_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Master Theme -'
,p_lov_cascade_parent_items=>'P117_MASTER_APP_ID'
,p_ajax_items_to_submit=>'P117_SUBSCRIBING_THEME_ID'
,p_ajax_optimize_refresh=>'N'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Select the master theme to which to subscribe the current theme.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1626110118247726820)
,p_name=>'P117_MASTER_APP_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(1433723048148861501)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.id',
'  from wwv_flow_visible_flows f',
' order by 1',
' fetch first 1 row only'))
,p_item_default_type=>'SQL_QUERY'
,p_prompt=>'Master Theme Application'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Master Theme Application - '
,p_lov_cascade_parent_items=>'P117_SUBSCRIBING_THEME_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select the master application for the theme subscription. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1399865675632453709)
,p_validation_name=>'template identifier allowed'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_themes',
'where id = :P117_SUBSCRIBING_THEME_ID',
'and theme_internal_name is not null;'))
,p_validation_type=>'EXISTS'
,p_error_message=>'This theme does not allow for template matching by template identifiers because there are no template identifiers defined.'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1399865081780453703)
,p_name=>'Show master theme selection'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P117_THEMES_SOURCE'
,p_condition_element=>'P117_THEMES_SOURCE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'app'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1399865101159453704)
,p_event_id=>wwv_flow_imp.id(1399865081780453703)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P117_MASTER_THEME_ID,P117_MASTER_APP_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1399865255988453705)
,p_event_id=>wwv_flow_imp.id(1399865081780453703)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P117_SHARED_MASTER_THEME_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1399865399490453706)
,p_event_id=>wwv_flow_imp.id(1399865081780453703)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P117_SHARED_MASTER_THEME_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1399865462192453707)
,p_event_id=>wwv_flow_imp.id(1399865081780453703)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P117_MASTER_THEME_ID,P117_MASTER_APP_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(231753745090461235)
,p_name=>'onClick NEXT'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1433725380623861521)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(231753865354461236)
,p_event_id=>wwv_flow_imp.id(231753745090461235)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'NEXT'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(932809935794193743)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'resubscribe theme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_master_theme_id number;',
'    ',
'begin',
'',
'    if :P117_THEMES_SOURCE = ''app'' then',
'        l_master_theme_id := :P117_MASTER_THEME_ID;',
'    else',
'        l_master_theme_id := :P117_SHARED_MASTER_THEME_ID;',
'    end if;',
'    ',
'',
'    -- map theme and template references by name',
'    wwv_flow_copy_metadata.resubscribe_theme(',
'        p_master_theme_id      => l_master_theme_id,',
'        p_subscribing_theme_id => :P117_SUBSCRIBING_THEME_ID,',
'        p_match_by_name        => :P117_MATCH_BY_NAME',
'    );',
'',
'    -- refresh theme and templates from master',
'    wwv_flow_copy_metadata.subscribe_theme (',
'        p_master_theme_id      => l_master_theme_id,',
'        p_subscribing_theme_id => :P117_SUBSCRIBING_THEME_ID',
'    );',
'    ',
'end;    '))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error subscribing theme: #SQLERRM_TEXT#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1433725380623861521)
,p_process_success_message=>'Theme successfully subscribed '
,p_internal_uid=>932809935794193743
);
end;
/
prompt --application/pages/page_00118
begin
wwv_flow_imp_page.create_page(
 p_id=>118
,p_name=>'File Editor'
,p_alias=>'FILE-EDITOR'
,p_step_title=>'File Editor'
,p_autocomplete_on_off=>'OFF'
,p_javascript_file_urls=>'#IMAGE_PREFIX#apex_ui/js/#MIN_DIRECTORY#f4000_p118#MIN#.js'
,p_javascript_code_onload=>'fileEditor.initPage();'
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4501448736515812)
,p_plug_name=>'Source'
,p_region_name=>'editor'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>4
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- get contents as base64 to avoid db-charser-related data corruption',
'-- conversion to back to plain text happens in javascript',
'select wwv_flow_file_editor_dev.get_file_as_base64 (',
'    p_id        => :P118_ID,',
'    p_scope     => :P118_SCOPE,',
'    p_app_id    => :P118_APP_ID,',
'    p_plugin_id => :P118_PLUGIN_ID,',
'    p_theme_id  => :P118_THEME_ID ) as content',
'  from sys.dual'))
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.CLOB_CODE_EDITOR'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P118_ID is not null and :P118_IS_EDITABLE = ''Y'''
,p_plug_display_when_cond2=>'PLSQL'
,p_plugin_init_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function(editorOptions){',
'    return fileEditor.configureEditor(editorOptions);',
'}'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'PAGE_ITEM',
  'attribute_02', 'AUTO',
  'attribute_03', 'N',
  'attribute_04', 'VARCHAR2',
  'attribute_06', 'P118_LANGUAGE')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4503346701515831)
,p_plug_name=>'File Details'
,p_region_name=>'details'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(18703871381360909)
,p_plug_name=>'Minified File'
,p_region_template_options=>'#DEFAULT#:a-Alert--info:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'You are attempting to edit an already minified file. You may wish to edit the base file instead.'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P118_ID is not null and (:P118_NAME like ''%.min.js'' or :P118_NAME like ''%.min.css'')'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(43903163431919823)
,p_plug_name=>'Actions'
,p_title=>'&P118_TITLE!HTML.'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_landmark_label=>'&P118_TITLE_LANDMARK!HTML.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46330642508795914)
,p_plug_name=>'UTF-8'
,p_region_template_options=>'#DEFAULT#:a-Alert--info:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'Only the contents of UTF-8 encoded files can be edited.'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P118_ID       is not null and',
':P118_LANGUAGE is not null and',
':P118_IS_EDITABLE = ''N'''))
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(66318979344810579)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--sideRegion:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Upload an already existing file, or create a blank one by entering a name, e.g script.js.</p>'
,p_plug_query_num_rows=>1500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'L:L:R'
,p_plug_query_break_cols=>'1'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(137232781242518009)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(43903163431919823)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'&G_BC_PARENT_URL.'
,p_button_execute_validations=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(14705596924332836)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(43903163431919823)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_confirm_message=>'&APP_TEXT$DELETE_MSG!RAW.'
,p_confirm_style=>'danger'
,p_button_condition=>'P118_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(14705888105332839)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(43903163431919823)
,p_button_name=>'CREATE_ANOTHER'
,p_button_static_id=>'CREATE_ANOTHER'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Create and Create Another'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P118_ID is null and nvl(:P118_FILE_STORAGE,''DB'') = ''DB''',
'    and :P118_SCOPE != ''WORKSPACE'''))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(14705356502332834)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(43903163431919823)
,p_button_name=>'CREATE'
,p_button_static_id=>'CREATE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P118_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(14706575909332846)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(43903163431919823)
,p_button_name=>'SAVE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Changes'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:$(''body'').trigger(''SAVE'');'
,p_button_condition=>'P118_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(18704022972360911)
,p_branch_name=>'Create - Then Edit File'
,p_branch_action=>'f?p=&APP_ID.:118:&SESSION.::&DEBUG.:118:P118_ID,P118_SCOPE,P118_APP_ID,P118_PLUGIN_ID,P118_THEME_ID:&P118_ID.,&P118_SCOPE.,&P118_APP_ID.,&P118_PLUGIN_ID.,&P118_THEME_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(14705356502332834)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(14706111347332842)
,p_branch_name=>'Create and Create Another - Refresh'
,p_branch_action=>'f?p=&APP_ID.:118:&SESSION.::&DEBUG.:118:P118_SCOPE,P118_APP_ID,P118_PLUGIN_ID,P118_THEME_ID:&P118_SCOPE.,&P118_APP_ID.,&P118_PLUGIN_ID.,&P118_THEME_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(14705888105332839)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(14706420184332845)
,p_branch_name=>'Delete - APP'
,p_branch_action=>'f?p=&APP_ID.:40:&SESSION.::&DEBUG.::FB_FLOW_ID:&P118_APP_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':REQUEST = ''DELETE'' and :P118_SCOPE = ''APP'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4902765799807725)
,p_branch_name=>'Delete - WORKSPACE'
,p_branch_action=>'f?p=&APP_ID.:312:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':REQUEST = ''DELETE'' and :P118_SCOPE = ''WORKSPACE'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4902950564807727)
,p_branch_name=>'Delete - PLUGIN'
,p_branch_action=>'f?p=&APP_ID.:4410:&SESSION.::&DEBUG.::FB_FLOW_ID,P4410_ID:&P118_APP_ID.,&P118_PLUGIN_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>70
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':REQUEST = ''DELETE'' and :P118_SCOPE = ''PLUGIN'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4903048708807728)
,p_branch_name=>'Delete - THEME'
,p_branch_action=>'f?p=&APP_ID.:267:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>80
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':REQUEST = ''DELETE'' and :P118_SCOPE = ''THEME'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3570122062979643)
,p_name=>'P118_NAME_ORIGINAL'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(4503346701515831)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3646212966874301)
,p_name=>'P118_TITLE'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(4503346701515831)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3646394321874302)
,p_name=>'P118_TITLE_LANDMARK'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_imp.id(4503346701515831)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4501019631515808)
,p_name=>'P118_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(4503346701515831)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4501120989515809)
,p_name=>'P118_SCOPE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(4503346701515831)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4501366668515811)
,p_name=>'P118_LANGUAGE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(4503346701515831)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4504108365515839)
,p_name=>'P118_CONTENT'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(4503346701515831)
,p_prompt=>'Content'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>30
,p_tag_attributes=>'data-show-progress="true"'
,p_display_when=>'P118_ID'
,p_display_when_type=>'ITEM_IS_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'File(s) to be uploaded.'
,p_attribute_01=>'APEX_APPLICATION_TEMP_FILES'
,p_attribute_09=>'SESSION'
,p_attribute_10=>'Y'
,p_attribute_12=>'DROPZONE_INLINE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6412366580218605)
,p_name=>'P118_LAST_MOD'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_imp.id(4503346701515831)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_file_editor_dev.get_file_last_modified (',
'    p_id        => :P118_ID,',
'    p_scope     => :P118_SCOPE,',
'    p_app_id    => :P118_APP_ID,',
'    p_plugin_id => :P118_PLUGIN_ID,',
'    p_theme_id  => :P118_THEME_ID )'))
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_display_when=>'P118_IS_EDITABLE'
,p_display_when2=>'Y'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8403078401370329)
,p_name=>'P118_FILE_STORAGE'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_imp.id(4503346701515831)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14702647126332807)
,p_name=>'P118_MIME_TYPE'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(4503346701515831)
,p_prompt=>'Mime Type'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'P118_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The mime type of the file.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14702737423332808)
,p_name=>'P118_CHARSET'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(4503346701515831)
,p_item_default=>'nvl(lower(trim(sys.owa_util.get_cgi_env(''REQUEST_IANA_CHARSET''))),''utf-8'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'File Character Set'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_IANA_CHARSET'
,p_lov=>'.'||wwv_flow_imp.id(144796827445692396)||'.'
,p_cHeight=>1
,p_read_only_when=>'P118_ID'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Indicates the character set encoding for the file. On file upload, this attribute only applies to text files.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14703326440332814)
,p_name=>'P118_NAME'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(4503346701515831)
,p_prompt=>'File Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>40
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The name of the file.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14705086813332831)
,p_name=>'P118_APP_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(4503346701515831)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14705167063332832)
,p_name=>'P118_PLUGIN_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(4503346701515831)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14705285341332833)
,p_name=>'P118_THEME_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(4503346701515831)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17602186898203758)
,p_name=>'P118_UNZIP'
,p_is_required=>true
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(4503346701515831)
,p_prompt=>'Unzip File'
,p_source=>'Y'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>If <strong>On</strong>, the uploaded Zip file is automatically unzipped and stored in the specified directory. Note that the actual Zip file is not stored.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17802337393434799)
,p_name=>'P118_DIRECTORY'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(4503346701515831)
,p_prompt=>'Directory'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value d, ',
'       column_value r',
'  from table( wwv_flow_file_editor_dev.get_directories(',
'        p_scope     => :P118_SCOPE,',
'        p_app_id    => :P118_APP_ID,',
'        p_plugin_id => :P118_PLUGIN_ID,',
'        p_theme_id  => :P118_THEME_ID ))',
' order by column_value'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Root'
,p_cSize=>40
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the name of the directory where the file should be stored. If no directory is specified, the file is stored in the root directory.</p>',
'<p>Examples:',
'<ul>',
'<li>css</li>',
'<li>css/images</li>',
'</ul>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18703023552360901)
,p_name=>'P118_REFERENCE'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(4503346701515831)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Reference'
,p_post_element_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button class="a-Button a-Button--small a-Button--simple" id="copy_ref_btn" type="button" title=''&"APP_TEXT$APEX.IG.COPY_CB".'' aria-label=''&"APP_TEXT$APEX.IG.COPY_CB".''>',
'    <span class="a-Icon icon-copy"></span>',
'</button>'))
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_file_editor_dev.get_file_reference (',
'    p_scope     => :P118_SCOPE,',
'    p_app_id    => :P118_APP_ID,',
'    p_plugin_id => :P118_PLUGIN_ID,',
'    p_theme_id  => :P118_THEME_ID,',
'    p_file_name => :P118_NAME_ORIGINAL )'))
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'P118_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18703290019360903)
,p_name=>'P118_CONTENT_IMAGE'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(4503346701515831)
,p_prompt=>'Image'
,p_display_as=>'NATIVE_DISPLAY_IMAGE'
,p_tag_attributes=>'style="max-width: 100%;"'
,p_display_when=>'lower(:P118_MIME_TYPE) like ''image/%'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Image content of the file'
,p_attribute_01=>'SQL'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select file_content as image,',
'       file_name    as alt_text,',
'       file_name    as filename,',
'       mime_type    as mimetype',
'  from (',
'        select id, security_group_id, file_content, file_name, mime_type',
'          from wwv_flow_static_files',
'         where :P118_SCOPE = ''APP''',
'           and flow_id     = :P118_APP_ID',
'',
'         union all',
'',
'        select id, security_group_id, file_content, file_name, mime_type',
'          from wwv_flow_company_static_files',
'         where :P118_SCOPE = ''WORKSPACE''',
'',
'         union all',
'',
'        select id, security_group_id, file_content, file_name, mime_type',
'          from wwv_flow_plugin_files',
'         where :P118_SCOPE = ''PLUGIN''',
'           and flow_id     = :P118_APP_ID',
'           and plugin_id   = :P118_PLUGIN_ID',
'',
'         union all',
'',
'        select id, security_group_id, file_content, file_name, mime_type',
'          from wwv_flow_theme_files',
'         where :P118_SCOPE = ''THEME''',
'           and flow_id     = :P118_APP_ID',
'           and theme_id    = :P118_THEME_ID',
'       )',
' where security_group_id = :WORKSPACE_ID',
'   and id                = :P118_ID;'))
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(46330382557795911)
,p_name=>'P118_IS_EDITABLE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(4503346701515831)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3570559038979647)
,p_computation_sequence=>10
,p_computation_item=>'P118_DIRECTORY'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_file_api.clean_dirname(:P118_DIRECTORY)'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3570656389979648)
,p_computation_sequence=>20
,p_computation_item=>'P118_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_file_api.get_file_name(:P118_DIRECTORY, :P118_NAME)'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3200397425191378)
,p_computation_sequence=>30
,p_computation_item=>'P118_FILE_STORAGE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_object_store.get_file_storage ( p_app_id => :FB_FLOW_ID )'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(18703480055360905)
,p_validation_name=>'Create Empty File - Name must be provided'
,p_validation_sequence=>10
,p_validation=>'P118_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'&"APP_TEXT$FILE_EDITOR.NAME_EMPTY".'
,p_validation_condition=>':REQUEST in (''CREATE'', ''CREATE_ANOTHER'') and :P118_CONTENT is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(14703326440332814)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3570867559979650)
,p_validation_name=>'Create Empty File - File name must contain an extension'
,p_validation_sequence=>20
,p_validation=>'wwv_flow_string_util.get_file_extension(:P118_NAME) is not null'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'The file name must contain an extension'
,p_validation_condition=>':REQUEST in (''CREATE'', ''CREATE_ANOTHER'') and :P118_CONTENT is null and :P118_NAME is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(14703326440332814)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(18706265474360933)
,p_validation_name=>'Create Empty File - Extension must be allowed'
,p_validation_sequence=>30
,p_validation=>'wwv_flow_string_util.get_file_extension(:P118_NAME) in (''js'', ''css'', ''html'', ''json'', ''less'', ''xml'', ''md'', ''txt'')'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Empty files must be one of: js, css, html, json, less, xml, md, txt'
,p_validation_condition=>':REQUEST in (''CREATE'', ''CREATE_ANOTHER'') and :P118_CONTENT is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(14703326440332814)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(78409105978861207)
,p_validation_name=>'Create/Edit - File name <= 255 characters'
,p_validation_sequence=>50
,p_validation=>'lengthb( :P118_NAME ) <= 255'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'&"APP_TEXT$FILE_EDITOR.NAME_TOO_LONG".'
,p_validation_condition=>'DELETE'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4504721218515845)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- creates an empty file if p_content is not provided',
'-- or loads the uploaded file named by p_content',
'    :P118_ID := wwv_flow_file_editor_dev.create_file (',
'        p_scope     => :P118_SCOPE,',
'        p_app_id    => :P118_APP_ID,',
'        p_plugin_id => :P118_PLUGIN_ID,',
'        p_theme_id  => :P118_THEME_ID,',
'        p_name      => :P118_NAME,',
'        p_directory => :P118_DIRECTORY,',
'        p_content   => :P118_CONTENT,',
'        p_unzip     => :P118_UNZIP,',
'        p_charset   => :P118_CHARSET );',
'',
'if :P118_FILE_STORAGE = ''OBJECT_STORE'' and :P118_SCOPE = ''APP'' ',
'    and wwv_flow_collection.collection_exists (p_collection_name => ''F4000_OB_FILES'' ) then',
'        wwv_flow_collection.delete_collection (p_collection_name => ''F4000_OB_FILES'' );',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'#SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE,CREATE_ANOTHER'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'File(s) created'
,p_internal_uid=>4504721218515845
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4904033233807738)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_file_editor_dev.update_file_name (',
'    p_id        => :P118_ID,',
'    p_name      => :P118_NAME,',
'    p_scope     => :P118_SCOPE,',
'    p_app_id    => :P118_APP_ID,',
'    p_plugin_id => :P118_PLUGIN_ID,',
'    p_theme_id  => :P118_THEME_ID );',
'',
'if :P118_FILE_STORAGE = ''OBJECT_STORE'' and :P118_SCOPE = ''APP'' ',
'    and wwv_flow_collection.collection_exists (p_collection_name => ''F4000_OB_FILES'' ) then',
'        wwv_flow_collection.delete_collection (p_collection_name => ''F4000_OB_FILES'' );',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'UPDATE'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>4904033233807738
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4904175075807739)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update - Dummy'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- dummy process to show page success and reset page state',
'-- when an editable file has been renamed',
'null;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'UPDATE_DUMMY'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>'Changes saved'
,p_internal_uid=>4904175075807739
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3568285912979624)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_file_editor_dev.delete_file (',
'    p_id               => :P118_ID,',
'    p_scope            => :P118_SCOPE,',
'    p_app_id           => :P118_APP_ID,',
'    p_plugin_id        => :P118_PLUGIN_ID,',
'    p_theme_id         => :P118_THEME_ID,',
'    p_delete_artifacts => true );',
'',
'if :P118_FILE_STORAGE = ''OBJECT_STORE'' and :P118_SCOPE = ''APP'' ',
'    and wwv_flow_collection.collection_exists (p_collection_name => ''F4000_OB_FILES'' ) then',
'        wwv_flow_collection.delete_collection (p_collection_name => ''F4000_OB_FILES'' );',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'DELETE'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>'File(s) deleted'
,p_internal_uid=>3568285912979624
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4502211707515820)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Init Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- performs sanity checks, populates items, loads needed libraries and text messages',
'wwv_flow_file_editor_dev.init_page (',
'    -- scope',
'    p_scope                 => :P118_SCOPE,',
'    p_app_id                => :P118_APP_ID,',
'    p_plugin_id             => :P118_PLUGIN_ID,',
'    p_theme_id              => :P118_THEME_ID,',
'    p_id                    => :P118_ID,',
'    -- items',
'    p_out_directory         => :P118_DIRECTORY,',
'    p_out_name              => :P118_NAME,',
'    p_out_name_original     => :P118_NAME_ORIGINAL,',
'    p_out_title             => :P118_TITLE,',
'    p_out_title_landmark    => :P118_TITLE_LANDMARK,',
'    p_out_mime_type         => :P118_MIME_TYPE,',
'    p_out_charset           => :P118_CHARSET,',
'    p_out_language          => :P118_LANGUAGE,',
'    p_out_is_editable       => :P118_IS_EDITABLE,',
'    p_out_bc_parent_label   => :G_BC_PARENT_LABEL,',
'    p_out_bc_parent_url     => :G_BC_PARENT_URL );'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>4502211707515820
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4501761426515815)
,p_process_sequence=>10
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'SAVE'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- saves and writes back status via apex_json',
'wwv_flow_file_editor_dev.save_ajax (',
'    p_id            => :P118_ID,',
'    p_scope         => :P118_SCOPE,',
'    p_app_id        => :P118_APP_ID,',
'    p_plugin_id     => :P118_PLUGIN_ID,',
'    p_theme_id      => :P118_THEME_ID,',
'',
'    p_file_1        => wwv_flow.g_f01,',
'    p_file_1_name   => wwv_flow.g_x01,',
'    p_file_2        => wwv_flow.g_f02,',
'    p_file_2_name   => wwv_flow.g_x02,',
'    p_file_3        => wwv_flow.g_f03,',
'    p_file_3_name   => wwv_flow.g_x03,',
'',
'    p_last_mod      => :P118_LAST_MOD,',
'    p_name_original => :P118_NAME_ORIGINAL );'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>4501761426515815
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(36741959531433204)
,p_process_sequence=>20
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'IS_NAME_TAKEN'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- pass 1 or more file names in the f01 array',
'declare',
'    l_is_name_taken boolean         := false;',
'    l_directory     varchar2(4000)  := wwv_flow_file_api.clean_dirname( :P118_DIRECTORY );',
'    l_file_name     varchar2(4000);',
'begin',
'    for i in 1 .. wwv_flow.g_f01.count loop',
'',
'        l_file_name := wwv_flow_file_api.get_file_name( l_directory, wwv_flow.g_f01( i ) );',
'',
'        if l_file_name is not null and',
'           wwv_flow_file_editor_dev.file_name_is_taken (',
'                p_scope     => :P118_SCOPE,',
'                p_app_id    => :P118_APP_ID,',
'                p_plugin_id => :P118_PLUGIN_ID,',
'                p_theme_id  => :P118_THEME_ID,',
'                p_ignore_id => :P118_ID,',
'                p_name      => l_file_name )',
'        then',
'            l_is_name_taken := true;',
'            exit;',
'        end if;',
'    end loop;',
'',
'    wwv_flow_json.open_object;',
'    wwv_flow_json.write( ''isNameTaken'', l_is_name_taken );',
'    wwv_flow_json.close_object;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>36741959531433204
);
end;
/
prompt --application/pages/page_00120
begin
wwv_flow_imp_page.create_page(
 p_id=>120
,p_name=>'Copy Email Template'
,p_alias=>'COPY-EMAIL-TEMPLATE'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Email Template'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(91429205691059841)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'auto'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2200811737471405)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5280359035337706)
,p_plug_name=>'Copy Email Template'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(461857790551605627)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3900773948149484)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2200811737471405)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1807103277551122)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(2200811737471405)
,p_button_name=>'COPY_FROM_ANOTHER'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Copy from another app'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:120:&SESSION.::&DEBUG.:120:P120_COPY_SOURCE:OTHER'
,p_button_condition=>'P120_COPY_SOURCE'
,p_button_condition2=>'THIS'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_button_css_classes=>'a-Button--noUI'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3901147747149485)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(2200811737471405)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy Email Template'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4700769082957403)
,p_branch_name=>'Show Copied Email Template'
,p_branch_action=>'f?p=&APP_ID.:4861:&SESSION.::&DEBUG.:4861:F4000_P4861_ID:&P120_COPY_NEW_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(3901147747149485)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1807076113551121)
,p_name=>'P120_SUBSCRIBE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(5280359035337706)
,p_item_default=>'Y'
,p_prompt=>'Subscribe'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>'P120_COPY_SOURCE'
,p_display_when2=>'OTHER'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'While copying the email template, you can also subscribe to it. Set Subscribe to <strong>On</strong> to subscribe to the email template.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3901552512149488)
,p_name=>'P120_COPY_SOURCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(5280359035337706)
,p_item_default=>'THIS'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3902489863149492)
,p_name=>'P120_FROM_APPLICATION_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(5280359035337706)
,p_prompt=>'Application'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST OTHER FLOWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'  from   wwv_flow_visible_flows f',
' where id != :FB_FLOW_ID',
'   and build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'order by 2'))
,p_cHeight=>1
,p_display_when=>'P120_COPY_SOURCE'
,p_display_when2=>'OTHER'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose the application to copy the email template from.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3903376734149493)
,p_name=>'P120_FROM_ID'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(5280359035337706)
,p_prompt=>'Copy Email Template'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name ||'' ( ''||static_id||'' )'' d,',
'       id r',
'  from wwv_flow_email_templates',
' where security_group_id = :WORKSPACE_ID',
'   and flow_id           = :P120_FROM_APPLICATION_ID',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_lov_cascade_parent_items=>'P120_FROM_APPLICATION_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_read_only_when=>'P120_FROM_ID'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose an email template to copy'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'Y'
,p_attribute_06=>'0'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3904222911149494)
,p_name=>'P120_COPY_NEW_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(5280359035337706)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3904640810149494)
,p_name=>'P120_COPY_NEW_NAME'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(5280359035337706)
,p_prompt=>'New Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'US_ONLY'
,p_help_text=>'Provide a name for the copied email template.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3905522938149494)
,p_name=>'P120_COPY_NEW_STATIC_ID'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(5280359035337706)
,p_prompt=>'New Static Identifier'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Provide a unique static identifier for the copied email template.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_attribute_06=>'UPPER'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(7801372789142419)
,p_validation_name=>'P120_COPY_NEW_STATIC_ID must be Unique'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_email_templates',
' where static_id         = upper( :P120_COPY_NEW_STATIC_ID )',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#LABEL# is already used by another email template.'
,p_validation_condition=>':P120_COPY_SOURCE = ''THIS'' or :P120_SUBSCRIBE = ''N'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(3901147747149485)
,p_associated_item=>wwv_flow_imp.id(3905522938149494)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(7801645844143964)
,p_validation_name=>'P120_COPY_NEW_STATIC_ID is alphanumeric'
,p_validation_sequence=>50
,p_validation=>'P120_COPY_NEW_STATIC_ID'
,p_validation_type=>'ITEM_IS_ALPHANUMERIC'
,p_error_message=>'#LABEL# may only contain alphanumeric characters and "_".'
,p_validation_condition=>':P120_COPY_SOURCE = ''THIS'' or :P120_SUBSCRIBE = ''N'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(3901147747149485)
,p_associated_item=>wwv_flow_imp.id(3905522938149494)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1807748123551128)
,p_validation_name=>'No duplicate subscription'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_email_templates',
' where security_group_id = :WORKSPACE_ID ',
'   and flow_id           = :FB_FLOW_ID ',
'   and reference_id      = :P120_FROM_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'There is another email template in this application that is subscribed to the same master. Please select another master email template.'
,p_validation_condition=>'P120_SUBSCRIBE'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(3901147747149485)
,p_associated_item=>wwv_flow_imp.id(3903376734149493)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1807281815551123)
,p_name=>'On Change of P120_SUBSCRIBE'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P120_SUBSCRIBE'
,p_condition_element=>'P120_SUBSCRIBE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_cond=>'P120_COPY_SOURCE'
,p_display_when_cond2=>'OTHER'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1807389375551124)
,p_event_id=>wwv_flow_imp.id(1807281815551123)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P120_COPY_NEW_NAME,P120_COPY_NEW_STATIC_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1807414348551125)
,p_event_id=>wwv_flow_imp.id(1807281815551123)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P120_COPY_NEW_NAME,P120_COPY_NEW_STATIC_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1807514539551126)
,p_name=>'Copy Name'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P120_FROM_ID'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_cond=>'P120_COPY_SOURCE'
,p_display_when_cond2=>'OTHER'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1807630040551127)
,p_event_id=>wwv_flow_imp.id(1807514539551126)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P120_COPY_NEW_NAME'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name',
'  from wwv_flow_email_templates',
' where id                = :P120_FROM_ID',
'   and flow_id           = :P120_FROM_APPLICATION_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_attribute_07=>'P120_FROM_ID'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2201215533471409)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3900773948149484)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2201316123471410)
,p_event_id=>wwv_flow_imp.id(2201215533471409)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(7800336189137481)
,p_name=>'Update Static ID'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P120_COPY_NEW_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7800730418137501)
,p_event_id=>wwv_flow_imp.id(7800336189137481)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P120_COPY_NEW_STATIC_ID'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$v(''P120_COPY_NEW_NAME'').replace(/\s+/g, ''_'')'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4700628395957402)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Email Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P120_COPY_NEW_ID := wwv_flow_copy_metadata.copy_component (',
'    p_component_type       => wwv_flow_copy_metadata.c_email_template,',
'    p_from_id              => :P120_FROM_ID,',
'    p_from_app_id          => :P120_FROM_APPLICATION_ID,',
'    p_to_app_id            => :FB_FLOW_ID,',
'    p_new_name             => :P120_COPY_NEW_NAME,',
'    p_additional_col       => :P120_COPY_NEW_STATIC_ID,',
'    p_subscribe            => :P120_SUBSCRIBE = ''Y'' );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to copy the email template.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3901147747149485)
,p_process_success_message=>'Email template copied.'
,p_internal_uid=>4700628395957402
);
end;
/
prompt --application/pages/page_00122
begin
wwv_flow_imp_page.create_page(
 p_id=>122
,p_name=>'Edit Calendar Template'
,p_alias=>'EDIT-CALENDAR-TEMPLATE1'
,p_step_title=>'Edit Calendar Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'EXISTS'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_cal_templates t, ',
'       wwv_flow_themes th',
' where t.id                 = :F4000_P697_ID',
'   and t.flow_id            = th.flow_id',
'   and t.theme_id           = th.theme_id',
'   and t.security_group_id  = :WORKSPACE_ID',
'   and th.security_group_id = t.security_group_id',
'   and t.reference_id      is not null',
'   and th.reference_id     is not null',
''))
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(16891607435128742)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(12991522578387911)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(18452530451155428)
,p_plug_name=>'Data Display Format'
,p_region_name=>'DATA'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>620
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(18877709410714380)
,p_plug_name=>'Page Button Button Box'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(18886121578746206)
,p_plug_name=>'Calendar Template'
,p_region_name=>'NAME'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>130
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_plug_display_condition_type=>'NEVER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(18886415062746206)
,p_plug_name=>'Template Subscription'
,p_region_name=>'SUB'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>140
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  i number := null;',
'  c number := 0;',
'begin',
'for c1 in (select reference_id ',
'             from wwv_flow_cal_templates ',
'            where id                = :P122_ID',
'              and security_group_id = :WORKSPACE_ID) loop',
'   i := c1.reference_id;',
'end loop;',
'',
'if i is not null then',
'  for c1 in (select flow_id, name ',
'               from wwv_flow_cal_templates',
'              where id                = i',
'                and security_group_id = wwv_flow_security.g_security_group_id) loop',
'    sys.htp.p(''<div class="htmldbFieldTitleLeft">''||wwv_flow_lang.system_message(''F4000_P204_COPIED_FROM_APP'')||'': ''|| ',
'    c1.flow_id||'', ''||wwv_flow_escape.html(c1.name)||''</div>'');',
'  end loop;',
'else',
'    sys.htp.p(''<div class="htmldbFieldTitleLeft">''||wwv_flow_lang.system_message(''F4000_P204_MASTER_COPY'')||''</div>'');',
'end if;',
'',
'for c1 in (select flow_id, ',
'                  name ',
'             from wwv_flow_cal_templates ',
'            where reference_id      = :P122_ID',
'              and security_group_id = wwv_flow_security.g_security_group_id) loop',
'   c := c + 1;',
'   if c = 1 then',
'      sys.htp.p(''<div class="htmldbFieldTitleLeft">''||wwv_flow_lang.system_message(''F4000_P122_CAL_TEMPL'')||'': </div><ul>'');',
'   end if;',
'   sys.htp.p(''<li> ''||c1.flow_id||'' - ''|| wwv_flow_escape.html(c1.name)||''</li>'');',
'end loop;',
'  sys.htp.p(''</ul>'');',
'if c = 0 then',
'   if i is not null then',
'      sys.htp.p(''<br />'');',
'   end if;',
'   sys.htp.p(''<div class="htmldbFieldTitleLeft">''||wwv_flow_lang.system_message(''F4000_P204_NO_SUBSCIRBERS'')||''</div>'');',
'end if;',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_num_rows=>15
,p_plug_display_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(18921417890029022)
,p_plug_name=>'Month Formats'
,p_region_name=>'MON'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>210
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(18921727767029023)
,p_plug_name=>'Week  Formats'
,p_region_name=>'WEEK'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>310
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(18922128903029024)
,p_plug_name=>'Weekday  Formats'
,p_region_name=>'DAY'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>410
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(18922517182029025)
,p_plug_name=>'Non-Day  Formats'
,p_region_name=>'NON'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>510
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(18922910505029025)
,p_plug_name=>'Weekend  Formats'
,p_region_name=>'END'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>610
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(18971803326223540)
,p_plug_name=>'Calendar Templates'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>600
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Calendar templates control the appearance and placement of a calendar. Calendar templates frequently use HTML tables to arrange dates.</p>',
'<p>You place calendar attributes using substitution strings such as #DD# and  #MONTH#. Template substitution strings must be in upper case and begin and end with a pound sign (#).</p>'))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46166630604774866)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>15
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(234115915333599671)
,p_plug_name=>'Substitution Strings'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>710
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The following date format substitution strings are available:</p>',
'<ul class="noIndent">',
'<li>DAY</li>',
'<li>DD</li>',
'<li>MON</li>',
'<li>YYYY</li>',
'<li>MM</li>',
'<li>MONTH</li>',
'<li>YY</li>',
'<li>RR</li>',
'<li>YEAR</li>',
'<li>WW</li>',
'<li>W</li>',
'<li>DDD</li>',
'<li>D</li>',
'<li>DY</li>',
'<li>DDSPTH</li>',
'<li>TIME</li>',
'<li>HH</li>',
'<li>HH12</li>',
'<li>HH24</li>',
'<li>AM</li>',
'<li>PM</li>',
'<li>MI</li>',
'<li>SYEAR</li>',
'<li>BC</li>',
'<li>CC</li>',
'<li>SCC</li>',
'<li>IYYY</li>',
'<li>Q</li>',
'<li>FMMONTH</li>',
'<li>RM</li>',
'<li>IW</li>',
'<li>FMDAY</li>',
'<li>DDTH</li>',
'<li>DDSPTH</li>',
'<li>J</li>',
'<li>FMHH</li>',
'<li>FMMI</li>',
'</ul>',
'<p>Placing an "I" in front of any string will INITCAP the text.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(38642223341465708)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(18886415062746206)
,p_button_name=>'COPY_TEMPLATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Refresh'
,p_button_position=>'BOTTOM'
,p_button_alignment=>'RIGHT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_cal_templates',
' where id                = :P122_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and reference_id     is not null'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(38642928882467332)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(18886415062746206)
,p_button_name=>'PUBLISH_TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Publish Template'
,p_button_position=>'BOTTOM'
,p_button_alignment=>'RIGHT'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.::F4000_P149_ID,F4000_P149_PAGE_ID,F4000_P149_TEMPLATE_TYPE:&P122_ID.,&FLOW_PAGE_ID.,CALENDAR_TEMPLATE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_cal_templates',
' where reference_id      = :P122_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(285855120692624393)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(18877709410714380)
,p_button_name=>'APPLY_CHANGES_GET_PREVIOUS_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'disabled=""'
,p_button_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(285855023241624393)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_imp.id(18877709410714380)
,p_button_name=>'APPLY_CHANGES_GET_NEXT_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Next'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'disabled=""'
,p_button_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(18849830415687048)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(18877709410714380)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(18850126609687048)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(18877709410714380)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:504:&SESSION.::&DEBUG.::P504_ID:&P122_ID.'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P697_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(18850014025687048)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(18877709410714380)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P697_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(285865727582624447)
,p_branch_action=>'f?p=&APP_ID.:122:&SESSION.::&DEBUG.::P122_ID:&P122_ID_NEXT.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(285855023241624393)
,p_branch_sequence=>21
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(285866118421624451)
,p_branch_action=>'f?p=&APP_ID.:122:&SESSION.::&DEBUG.::P122_ID:&P122_ID_PREV.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(285855120692624393)
,p_branch_sequence=>21
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(358388523833432008)
,p_branch_action=>'f?p=&APP_ID.:122:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(38642223341465708)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(17311115223820625)
,p_branch_action=>'f?p=&APP_ID.:670:&SESSION.::&DEBUG.::P670_ID:&P122_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>32
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_WEEKLY_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(17928410687201254)
,p_branch_action=>'f?p=&APP_ID.:661:&SESSION.::&DEBUG.::P661_ID:&P122_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>34
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_DAILY_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(30771031569845440)
,p_branch_action=>'f?p=&APP_ID.:836:&SESSION.::&DEBUG.::P836_ID:&P122_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>35
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_CUSTOM_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(22188331038173394)
,p_branch_action=>'f?p=&APP_ID.:697:&SESSION.::&DEBUG.::F4000_P697_ID:&P122_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>38
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_CALENDAR_DEFINITION'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3709923113259480)
,p_branch_action=>'f?p=&APP_ID.:80:&SESSION.::&DEBUG.::P80_ID:&P122_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>48
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_AGENDA_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(18986200649279586)
,p_branch_action=>'f?p=&APP_ID.:122:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>90
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P122_STAY'
,p_branch_condition_text=>'YES'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(18993421820314018)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>139
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(18851818152687065)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>140
,p_branch_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18454005779167197)
,p_name=>'P122_MONTH_DATA_FORMAT'
,p_item_sequence=>118
,p_item_plug_id=>wwv_flow_imp.id(18452530451155428)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Data Open/Close Format'
,p_source=>'MONTH_DATA_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter HTML be used to for the Calendar Data to be displayed together in a individual cell. ',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list. #DAYS# will be replaced with data rows.',
'',
'For example: ',
'<ul>',
'#DAYS#',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18454924825172784)
,p_name=>'P122_MONTH_DATA_ENTRY_FORMAT'
,p_item_sequence=>128
,p_item_plug_id=>wwv_flow_imp.id(18452530451155428)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Data Format'
,p_source=>'MONTH_DATA_ENTRY_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter HTML be used to for how individual calendar data will be displayed. ',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.#DATA# is used for substituting actual Calendar data.',
'',
'For example: ',
'<li>',
'#DATA#',
'</li>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18852208962687070)
,p_name=>'P122_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>0
,p_item_plug_id=>wwv_flow_imp.id(18886121578746206)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18852606345687082)
,p_name=>'P122_NAME'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_imp.id(18886121578746206)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Defines a name that identifies the template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18853415396687087)
,p_name=>'P122_TRANSLATE_THIS_TEMPLATE'
,p_item_sequence=>7
,p_item_plug_id=>wwv_flow_imp.id(18886121578746206)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Translatable'
,p_source=>'TRANSLATE_THIS_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18853814896687088)
,p_name=>'P122_MONTH_TITLE_FORMAT'
,p_item_sequence=>8
,p_item_plug_id=>wwv_flow_imp.id(18921417890029022)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Month Title Format'
,p_source=>'MONTH_TITLE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the format for the monthly title that appears at the top of each month. This is the first part of a calendar which is printed on the page.',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'&lt;table&gt;',
' &lt;tr&gt;',
'   &lt;td&gt;#MONTH#&lt;/td&gt;',
' &lt;/tr&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18854220278687090)
,p_name=>'P122_DAY_OF_WEEK_FORMAT'
,p_item_sequence=>9
,p_item_plug_id=>wwv_flow_imp.id(18921417890029022)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Day Of Week Format'
,p_source=>'DAY_OF_WEEK_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the format for the week day names which display as the column header for that day of the week.  ',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'   &lt;th width="14%"&gt;#IDAY#&lt;/th&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18854608281687091)
,p_name=>'P122_MONTH_OPEN_FORMAT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(18921417890029022)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Month Open Format'
,p_source=>'MONTH_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the HTML to be used to open a month.  This is printed immediately after the "Month Title Format".  Usually this would be an HTML tag which is a container such as a table.  ',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'   &lt;table  border="0" cellpadding="0" cellspacing="0" class="htmldbRowWithBorders" width="100%"&gt;&lt;tr&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18855009923687092)
,p_name=>'P122_MONTH_CLOSE_FORMAT'
,p_item_sequence=>11
,p_item_plug_id=>wwv_flow_imp.id(18921417890029022)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Month Close Format'
,p_source=>'MONTH_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the HTML to be used to close a month.  This is the last part printed so this should close any HTML tags which have been used such as the tag used in the "Month Open Format"',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'   &lt;/table&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18855424509687093)
,p_name=>'P122_DAY_TITLE_FORMAT'
,p_item_sequence=>12
,p_item_plug_id=>wwv_flow_imp.id(18922128903029024)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Day Title Format'
,p_source=>'DAY_TITLE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the HTML to be used for the day''s title which the first thing printed after the "Day Open Format" ',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'#DD#',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18855816337687094)
,p_name=>'P122_DAY_OPEN_FORMAT'
,p_item_sequence=>13
,p_item_plug_id=>wwv_flow_imp.id(18922128903029024)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Day Open Format'
,p_source=>'DAY_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the HTML to be used to opening a day. This is printed for each day. Usually this would be an HTML tag which is a container such as a td.  Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.'
||' Including #DATA# will substitute value from Data format attribute, #DATA# should be used to display Calendar data. For example:',
'<pre>',
' &lt;td&gt;#DATA#',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18856206615687095)
,p_name=>'P122_DAY_CLOSE_FORMAT'
,p_item_sequence=>14
,p_item_plug_id=>wwv_flow_imp.id(18922128903029024)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Day Close Format'
,p_source=>'DAY_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the HTML to be used to close a day.  This is the last part of each day printed so this should close any HTML tags which have been used such as the tag used in the "Day Open Format"',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.  Including #DATA# will substitute value from Data format attribute, #DATA# should be used to display Calendar data. ',
'',
'For example: ',
'<pre>',
'  #DATA#&lt;/td&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18856610273687096)
,p_name=>'P122_TODAY_OPEN_FORMAT'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_imp.id(18922128903029024)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Today Open Format'
,p_source=>'TODAY_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the HTML to be used to open today. Usually this would be an HTML tag which is a container such as a td and would be different somehow from the "Day Open Format". Include substitution strings to include dynamic content. See the "Substitution Str'
||'ings" for the full list.  Including #DATA# will substitute value from Data format attribute, #DATA# should be used to display Calendar data. For example:',
'<pre>',
'  &lt;td style="background:#c5d5c5"&gt;#DATA#',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18857024534687097)
,p_name=>'P122_WEEKEND_TITLE_FORMAT'
,p_item_sequence=>16
,p_item_plug_id=>wwv_flow_imp.id(18922910505029025)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Weekend Title Format'
,p_source=>'WEEKEND_TITLE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter HTML be used to for a day occurring on a weekend. ',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'#DD#',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18857425215687099)
,p_name=>'P122_WEEKEND_OPEN_FORMAT'
,p_item_sequence=>17
,p_item_plug_id=>wwv_flow_imp.id(18922910505029025)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Weekend Open Format'
,p_source=>'WEEKEND_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter HTML used to open a day which is on a weekend. Usually this would be an HTML tag which is a container such as a TD. Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list. Including #DATA# will'
||' substitute value from Data format attribute, #DATA# should be used to display Calendar data.  For example:',
'<pre>',
' &lt;td&gt',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18857706167687100)
,p_name=>'P122_WEEKEND_CLOSE_FORMAT'
,p_item_sequence=>18
,p_item_plug_id=>wwv_flow_imp.id(18922910505029025)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Weekend Close Format'
,p_source=>'WEEKEND_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter HTML used to close a day which is on a weekend. This is the last part of each weekend day printed so this should close any HTML tags which have been used such as the tag used in the "Weekend Open Format"',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list. Including #DATA# will substitute value from Data format attribute, #DATA# should be used to display Calendar data. ',
'',
'For example: ',
'<pre>',
'  #DATA# &lt;/td&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18858119260687101)
,p_name=>'P122_NONDAY_TITLE_FORMAT'
,p_item_sequence=>19
,p_item_plug_id=>wwv_flow_imp.id(18922517182029025)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Non-Day Title Format'
,p_source=>'NONDAY_TITLE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter HTML used to format a non-day title. For example, suppose the first of a month is a Monday, but the week starts on a Sunday. Since Sunday is not be part of the current month, Sunday would be a non-day.',
'<p> See the "Substitution Strings" for the full list. For example:',
'<pre>',
'  #DD#',
'</pre>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18858508945687102)
,p_name=>'P122_NONDAY_OPEN_FORMAT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(18922517182029025)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Non-Day Open Format'
,p_source=>'NONDAY_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter HTML to open a non-day. For example, suppose the first of a month is a Monday, but the week starts on a Sunday. Since Sunday is not be part of the current month, Sunday would be a non-day.',
'',
'<p>Usually this would be an HTML tag which is a container such as a td. Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list. For example:',
'<pre>',
'  &lt;td&gt;',
'</pre>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18858918031687103)
,p_name=>'P122_NONDAY_CLOSE_FORMAT'
,p_item_sequence=>21
,p_item_plug_id=>wwv_flow_imp.id(18922517182029025)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Non-Day Close Format'
,p_source=>'NONDAY_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the html which will close a non-day.  For example, when the first of a month is on a Monday and the week starts on a Sunday, Sunday would not have a date in the current month and therefore be a non-day.',
'<p>Usually this would be an HTML tag which closes the tag used in the "Non-Day Open Format".',
' Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list. For example:',
'<pre>',
'  &lt;/td&gt;',
'</pre>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18859319271687104)
,p_name=>'P122_WEEK_TITLE_FORMAT'
,p_item_sequence=>22
,p_item_plug_id=>wwv_flow_imp.id(18921727767029023)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Week Title Format'
,p_source=>'WEEK_TITLE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'Enter the html which will be printed as the title for a weekly view calendar.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18859723762687105)
,p_name=>'P122_WEEK_OPEN_FORMAT'
,p_item_sequence=>23
,p_item_plug_id=>wwv_flow_imp.id(18921727767029023)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Week Open Format'
,p_source=>'WEEK_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the HTML to be used to open a week. This is printed for each week. Usually this would be an HTML tag which is a container such as a tr. Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list. F'
||'or example:',
'<pre>',
' &lt;tr&gt;'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18860129599687106)
,p_name=>'P122_WEEK_CLOSE_FORMAT'
,p_item_sequence=>24
,p_item_plug_id=>wwv_flow_imp.id(18921727767029023)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Week Close Format'
,p_source=>'WEEK_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the HTML to be used to close a week.  This is the last part printed so this should close any HTML tags which have been used such as the tag used in the "Week Open Format"',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'   &lt;/tr&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18860511605687107)
,p_name=>'P122_DAILY_TITLE_FORMAT'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_imp.id(18922128903029024)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Daily Title Format'
,p_source=>'DAILY_TITLE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'Enter the html which will be used as the title for a daily view calendar.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18860929357687108)
,p_name=>'P122_DAILY_OPEN_FORMAT'
,p_item_sequence=>26
,p_item_plug_id=>wwv_flow_imp.id(18922128903029024)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Daily Open Format'
,p_source=>'DAILY_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'Enter the html which will be used to open a day in a daily view calendar.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18861304283687108)
,p_name=>'P122_DAILY_CLOSE_FORMAT'
,p_item_sequence=>27
,p_item_plug_id=>wwv_flow_imp.id(18922128903029024)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Daily Close Format'
,p_source=>'DAILY_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'Enter the html which will be used to close a day in a daily view calendar.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18861717044687109)
,p_name=>'P122_REFERENCE_ID'
,p_item_sequence=>28
,p_item_plug_id=>wwv_flow_imp.id(18886415062746206)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Reference Master Label Template From'
,p_source=>'REFERENCE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FLOW_SUBSCRIBE_FROM_CAL_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||lower(wwv_flow_lang.system_message(''NO_TEMPLATE''))||'' -'' d, ',
'        0 r from sys.dual',
' union all',
'select flow_id||'' : ''||name||decode(theme_id,',
'       null,',
'       '''',',
'       '' (''||theme_id||'')'') d,',
'       id r',
'  from wwv_flow_cal_templates',
' where flow_id          != nvl(:fb_flow_id,0)',
'   and security_group_id = :WORKSPACE_ID',
'   and flow_id          in ( select f.id',
'                               from wwv_main_apps_dev f',
'                              where security_group_id = :flow_security_group_id',
'                                and build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'                                and exists ( select 1 ',
'                                               from wwv_flow_developers',
'                                              where userid            = :flow_user ',
'                                                and (flow_id is null or flow_id = f.id)',
'                                                and security_group_id = :flow_security_group_id))',
''))
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">You may select an existing template in this workspace or another template in your workspace''s schema. By selecting an existing template, you become a subscriber to that template.</div>',
'<div class="htmldbInfoBodyP">To load a new copy of any master template, click <span class="fielddatabold">Refresh</span>.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18983103635270949)
,p_name=>'P122_STAY'
,p_item_sequence=>38
,p_item_plug_id=>wwv_flow_imp.id(18971803326223540)
,p_prompt=>'Stay on page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select this checkbox to stay on this page after applying changes.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'YES'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(38641001178459260)
,p_name=>'P122_REFRESH'
,p_item_sequence=>48
,p_item_plug_id=>wwv_flow_imp.id(18886415062746206)
,p_item_default=>'Y'
,p_prompt=>'Refresh'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_begin_on_new_line=>'N'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_cal_templates',
' where reference_id     is null',
'   and id                = :P122_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(43597419749729663)
,p_name=>'P122_THEME_ID'
,p_item_sequence=>58
,p_item_plug_id=>wwv_flow_imp.id(18886121578746206)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Theme:'
,p_source=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Indicates the theme to which the template is a member.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(43624130644969418)
,p_name=>'P122_THEME_CLASS_ID'
,p_item_sequence=>68
,p_item_plug_id=>wwv_flow_imp.id(18886121578746206)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Template Class'
,p_source=>'THEME_CLASS_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CALENDAR THEME CLASS ID'
,p_lov=>'.'||wwv_flow_imp.id(43619531898960304)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Not Identified -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Identifies a specific usage for this template.</div>',
'<div class="htmldbInfoBodyP">When you switch to a new theme, all templates in one theme are assigned to corresponding templates in another theme. App Builder accomplishes this template mapping through the assignment of template class identifiers.</di'
||'v>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(285863528641624431)
,p_name=>'P122_ID_NEXT'
,p_item_sequence=>88
,p_item_plug_id=>wwv_flow_imp.id(18877709410714380)
,p_prompt=>'P122_ID_NEXT'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(285863927865624433)
,p_name=>'P122_ID_PREV'
,p_item_sequence=>98
,p_item_plug_id=>wwv_flow_imp.id(18877709410714380)
,p_prompt=>'P122_ID_PREV'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(285864329438624435)
,p_name=>'P122_ID_COUNT'
,p_item_sequence=>108
,p_item_plug_id=>wwv_flow_imp.id(18877709410714380)
,p_prompt=>'Calendar Template: '
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies calendar template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(146914813480910295)
,p_computation_sequence=>10
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P122_THEME_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(397289523641382309)
,p_name=>'ENABLE PREVIOUS'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P122_ID_PREV'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(397289811293382310)
,p_event_id=>wwv_flow_imp.id(397289523641382309)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(285855120692624393)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(397289929874384084)
,p_name=>'ENABLE NEXT'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P122_ID_NEXT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(397290229849384084)
,p_event_id=>wwv_flow_imp.id(397289929874384084)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(285855023241624393)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3001433248333512)
,p_name=>'Show Publish Success Msg'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(38642928882467332)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3001528594333513)
,p_event_id=>wwv_flow_imp.id(3001433248333512)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ( this.data.successMessage ) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(18862218917687113)
,p_process_sequence=>1
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_CAL_TEMPLATES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_CAL_TEMPLATES'
,p_attribute_03=>'P122_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Unable to fetch row.'
,p_internal_uid=>18862218917687113
,p_process_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(285865301678624444)
,p_process_sequence=>11
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_PAGINATION'
,p_process_name=>'Get Next or Previous Primary Key Value'
,p_attribute_02=>'WWV_FLOW_CAL_TEMPLATES'
,p_attribute_03=>'P122_ID'
,p_attribute_04=>'ID'
,p_attribute_07=>'THEME_ID'
,p_attribute_08=>'NAME'
,p_attribute_09=>'P122_ID_NEXT'
,p_attribute_10=>'P122_ID_PREV'
,p_attribute_13=>'P122_ID_COUNT'
,p_attribute_14=>'flow_id = :fb_flow_id'
,p_process_error_message=>'Unable to run Get Next or Previous Primary Key Value process.'
,p_internal_uid=>285865301678624444
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(18862605198687116)
,p_process_sequence=>1
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_CAL_TEMPLATES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_CAL_TEMPLATES'
,p_attribute_03=>'P122_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Unable to process calendar template.'
,p_process_when=>'COPY_TEMPLATE'
,p_process_when_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>18862605198687116
,p_process_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(18863028809687117)
,p_process_sequence=>2
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'122'
,p_process_when_button_id=>wwv_flow_imp.id(18850126609687048)
,p_internal_uid=>18863028809687117
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(38774611116730118)
,p_process_sequence=>12
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh calendar template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_calendar_template (',
'    p_master_template_id         => :P122_REFERENCE_ID,',
'    p_subscribing_template_id    => :P122_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying template.'
,p_process_when_button_id=>wwv_flow_imp.id(38642223341465708)
,p_process_when=>'P122_REFERENCE_ID'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_process_when2=>'0'
,p_process_success_message=>'Template copied.'
,p_internal_uid=>38774611116730118
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(39018716264070765)
,p_process_sequence=>12
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove reference id'
,p_process_sql_clob=>'wwv_flow_copy_metadata.remove_button_reference_id (:P122_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error setting template id to null.'
,p_process_when=>'P122_REFERENCE_ID'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'0'
,p_process_success_message=>'Reference id is removed.'
,p_internal_uid=>39018716264070765
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(358391920286449981)
,p_process_sequence=>32
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh calendar template 2'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_calendar_template (',
'    p_master_template_id         => :P122_REFERENCE_ID,',
'    p_subscribing_template_id    => :P122_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying template.'
,p_process_when_button_id=>wwv_flow_imp.id(18850014025687048)
,p_process_when=>':P122_REFERENCE_ID is not null and :P122_REFRESH = ''Y'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Template copied.'
,p_internal_uid=>358391920286449981
);
end;
/
prompt --application/pages/page_00123
begin
wwv_flow_imp_page.create_page(
 p_id=>123
,p_name=>'Tab Label Grid View'
,p_alias=>'TAB-LABEL-GRID-VIEW'
,p_step_title=>'Edit Standard Tabs'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213240607818867991)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
,p_page_component_map=>'01'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(48819323334958123)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(155207503157382410)
,p_name=>'Edit Standard Tab Labels, Sequences, and Names'
,p_template=>wwv_flow_imp.id(208928010704475743)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P123a */',
'ID,',
'sys.htf.anchor(''f?p=4000:4305:''||:flow_session||',
'  ''::::F4000_P4305_ID:''||id,',
'  ''<span class="a-Icon icon-edit"></span><span class="u-VisuallyHidden">&EDIT.</span>'') e,',
'TAB_SET,',
'TAB_SEQUENCE,',
'TAB_NAME,',
'TAB_TEXT,',
'TAB_STEP,',
'TAB_ALSO_CURRENT_FOR_PAGES,',
'TAB_PARENT_TABSET',
'  from WWV_FLOW_TABS',
' where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and (replace(:F4000_P123_TABSET,''%''||''null%'',null) is null or :F4000_P123_TABSET = tab_set)'))
,p_translate_title=>'N'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>500
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No Tabs found.'
,p_query_num_rows_item=>'F4000_P123_MAX_ROWS'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
,p_comment=>'Region generated 28-DEC-2001 14:50:24'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48583720900771031)
,p_query_column_id=>1
,p_form_element_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48583822433771031)
,p_query_column_id=>2
,p_column_alias=>'E'
,p_column_display_sequence=>2
,p_column_heading=>'Edit'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48583911921771031)
,p_query_column_id=>3
,p_column_alias=>'TAB_SET'
,p_column_display_sequence=>3
,p_column_heading=>'Tab Set'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48584029289771031)
,p_query_column_id=>4
,p_form_element_id=>2
,p_column_alias=>'TAB_SEQUENCE'
,p_column_display_sequence=>4
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT'
,p_column_width=>5
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48584124308771031)
,p_query_column_id=>5
,p_form_element_id=>3
,p_column_alias=>'TAB_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Name'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT'
,p_column_width=>22
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48584211205771031)
,p_query_column_id=>6
,p_form_element_id=>4
,p_column_alias=>'TAB_TEXT'
,p_column_display_sequence=>6
,p_column_heading=>'Label'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT'
,p_column_width=>22
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48584315555771032)
,p_query_column_id=>7
,p_column_alias=>'TAB_STEP'
,p_column_display_sequence=>7
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48584405174771032)
,p_query_column_id=>8
,p_form_element_id=>5
,p_column_alias=>'TAB_ALSO_CURRENT_FOR_PAGES'
,p_column_display_sequence=>8
,p_column_heading=>'Also Current Pages'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT'
,p_column_width=>24
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48584519168771032)
,p_query_column_id=>9
,p_column_alias=>'TAB_PARENT_TABSET'
,p_column_display_sequence=>9
,p_column_heading=>'Parent Tab Set'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(155208110652382444)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'HIDDEN'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(155469804813777736)
,p_column_sequence=>2
,p_query_column_name=>'E'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(155208316028382445)
,p_column_sequence=>3
,p_query_column_name=>'TAB_SET'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(155208410999382445)
,p_column_sequence=>4
,p_query_column_name=>'TAB_SEQUENCE'
,p_display_as=>'TEXT'
,p_column_width=>5
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(155208506902382445)
,p_column_sequence=>5
,p_query_column_name=>'TAB_NAME'
,p_display_as=>'TEXT'
,p_column_width=>22
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(155208618396382445)
,p_column_sequence=>6
,p_query_column_name=>'TAB_TEXT'
,p_display_as=>'TEXT'
,p_column_width=>22
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(155208703555382445)
,p_column_sequence=>7
,p_query_column_name=>'TAB_STEP'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(155208809326382445)
,p_column_sequence=>8
,p_query_column_name=>'TAB_ALSO_CURRENT_FOR_PAGES'
,p_display_as=>'TEXT'
,p_column_width=>24
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(155208930758382446)
,p_column_sequence=>9
,p_query_column_name=>'TAB_PARENT_TABSET'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(155293631294546820)
,p_plug_name=>'Standard Tabs'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use this page to edit tabs for a specific application or tab set. You can edit multiple tab labels or sequences and names for multiple pages.</p>',
'<p><strong>Sequence</strong> controls the tab sequences or order within a tab set.</p>',
'<p><strong>Label</strong> identifies the tab label text that appears to the user.</p>',
'<p><strong>Name</strong> identifies name of the tab. Tab names must be unique within a tab set and be different from button names.</p>'))
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_item=>'F4000_P123_MAX_ROWS'
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_no_data_found=>'Report returned no rows.'
,p_plug_query_show_nulls_as=>'(null)'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(155519414022843491)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(5297709875)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(155288808662542129)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(48819323334958123)
,p_button_name=>'F4000_P123_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Go'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(155209321115382448)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(48819323334958123)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'EDIT'
,p_button_alignment=>'LEFT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(155210200188382465)
,p_branch_action=>'123'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(155209321115382448)
,p_branch_sequence=>10
,p_branch_comment=>'Generated 28-DEC-2001 14:50:25'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(155299523962550207)
,p_branch_action=>'123'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(155274902420529775)
,p_name=>'F4000_P123_TABSET'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(48819323334958123)
,p_prompt=>'Standard Tab Set'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_TABSETS'
,p_lov=>'select wwv_flow_escape.html(d) d, r from wwv_flow_tabset_view'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- All Tab Sets -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a tab set.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(155629015143055726)
,p_name=>'F4000_P123_MAX_ROWS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(48819323334958123)
,p_item_default=>'20'
,p_prompt=>'Rows'
,p_source=>'20'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAXIMUM ROWS PER PAGE'
,p_lov=>'.'||wwv_flow_imp.id(84800803131139158)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Select the number of rows to display and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(155209800752382457)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(155207503157382410)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'ApplyMRU'
,p_attribute_02=>'WWV_FLOW_TABS'
,p_attribute_03=>'ID'
,p_attribute_05=>'flow_id = :FB_FLOW_ID and security_group_id = :WORKSPACE_ID'
,p_process_error_message=>'Error processing update'
,p_process_when_button_id=>wwv_flow_imp.id(155209321115382448)
,p_process_success_message=>'#MRU_COUNT# tab(s) updated.'
,p_internal_uid=>155209800752382457
,p_process_comment=>'Generated 28-DEC-2001 14:50:24'
);
end;
/
prompt --application/pages/page_00124
begin
wwv_flow_imp_page.create_page(
 p_id=>124
,p_name=>'Subscribed Templates'
,p_alias=>'SUBSCRIBED-TEMPLATES'
,p_step_title=>'Template Subscriptions'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript" language="JavaScript1.1">',
'    function ToggleAll(e){	if (e.checked) {	CheckAll();	}',
'    	else {	ClearAll();	}',
'    }',
'    function Check(e){	e.checked = true;}',
'    function Clear(e){	e.checked = false;}',
'    function CheckAll(){	',
'        var ml = document.wwv_flow;	',
'        var len = ml.elements.length;	',
'        for (var i = 0; i < len; i++) {',
'        var e = ml.elements[i];	',
'        if (e.name == "f01" ||e.name == "f03" ||e.name == "f05" || e.name == "f07" || e.name == "f09" ||e.name == "f11" ||e.name == "f13" || e.name == "f15" ) {',
'        Check(e);}',
'        }',
'        ml.f01.checked = true;',
'    }',
'    function ClearAll(){	',
'        var ml = document.wwv_flow;	',
'        var len = ml.elements.length;	',
'        for (var i = 0; i < len; i++) {	',
'          var e = ml.elements[i];	if (e.name == "f01" ||	e.name == "f03" ||e.name == "f05" ||e.name == "f07" ||e.name == "f09" ||e.name == "f11" ||e.name == "f13" ||e.name == "f15" ) {		Clear(e);	}',
'        	}',
'        	ml.f01.checked = false;',
'    }',
'</SCRIPT>'))
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt_rpts.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(181499524342168233)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page displays subscribing templates in your application.</p>',
'<p>To refresh copied content from the master template, select those you want to refresh and click <strong>Refresh Checked</strong>.</p>'))
,p_plug_query_num_rows=>1000
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_no_data_found=>'<font class="fieldtitleleft">No subscribed templates found.</font>'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_break_cols=>'3:4'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(181579916929536274)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>91
,p_list_id=>wwv_flow_imp.id(12437772301)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Templates'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(181903622922384410)
,p_plug_name=>'Template Actions'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>93
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(181911325929398179)
,p_name=>'Template Subscriptions'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>95
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  with messages as (',
'      select ''PAGE'' as msg_code,    wwv_flow_lang.system_message(''F4000.PAGE'') as msg      from sys.dual union all',
'      select ''REGION'',              wwv_flow_lang.system_message(''F4000.REGION'')           from sys.dual union all',
'      select ''REPORT'',              wwv_flow_lang.system_message(''REPORT'')                 from sys.dual union all',
'      select ''LIST'',                wwv_flow_lang.system_message(''F4000.LIST_INITCAP'')     from sys.dual union all',
'      select ''LABEL'',               wwv_flow_lang.system_message(''LABEL'')                  from sys.dual union all',
'      select ''BUTTON'',              wwv_flow_lang.system_message(''F4000.BUTTON'')           from sys.dual union all',
'      select ''MENU'',                wwv_flow_lang.system_message(''BREADCRUMB'')             from sys.dual union all',
'      select ''CALENDAR'',            wwv_flow_lang.system_message(''LEGACY_CALENDAR'')        from sys.dual union all',
'      select ''POPUP_LOV'',           wwv_flow_lang.system_message(''F4000.P371.POPUP_LOV'')   from sys.dual union all',
'      select ''TEMPLATE_COMPONENT'',  wwv_flow_lang.system_message(''F4000.TEMPLATE_COMPONENT'') from sys.dual )',
'select wwv_flow_item.checkbox(',
'           item_id,',
'           id,',
'           ''title="''||wwv_flow_lang.system_message(''SELECT_ROW_C'', ',
'           wwv_flow_escape.html(template_name))||''"'') || wwv_flow_item.hidden(item_id+1,reference_id) as row_selector,',
'       flow_id,',
'       ( select msg from messages where msg_code = rtype ) as template_type,',
'       wwv_flow_escape.html(template_name) as template_name,',
'       cp_from,',
'       theme_id',
'  from ( select 1 as item_id,',
'                id,',
'                name as template_name,',
'                reference_id,',
'                flow_id,',
'                ''PAGE'' rtype,',
'                theme_id,',
'                (select wwv_flow_lang.system_message(''F4000_P801_FLOW'')||'' ''||flow_id||'', ''||wwv_flow_lang.system_message(''SUBSCRIBED_FROM.THEME'')||'' ''||theme_id||'', ''||wwv_flow_escape.html(name)',
'                   from wwv_flow_templates ',
'                  where id = p.reference_id) cp_from',
'           from wwv_flow_templates p',
'          where p.flow_id = :fb_flow_id',
'            and p.security_group_id = :flow_security_group_id',
'            and p.reference_id is not null ',
'            and (  :F4000_P124_SHOW = ''Page''',
'                or replace(:F4000_P124_SHOW,''%''||''null%'',null) is null)',
'          union all',
'         select 3,',
'                id,',
'                page_plug_template_name,',
'                reference_id,',
'                flow_id,',
'                ''REGION'' rtype,',
'                theme_id,',
'                (select wwv_flow_lang.system_message(''F4000_P801_FLOW'')||'' ''||flow_id||'', ''||wwv_flow_lang.system_message(''SUBSCRIBED_FROM.THEME'')||'' ''||theme_id||'', ''||wwv_flow_escape.html(page_plug_template_name)',
'                   from wwv_flow_page_plug_templates ',
'                  where id = p.reference_id) cp_from',
'           from wwv_flow_page_plug_templates p',
'          where p.flow_id = :fb_flow_id',
'            and p.security_group_id = :flow_security_group_id',
'            and p.reference_id is not null ',
'            and (  :F4000_P124_SHOW = ''Region''',
'                or replace(:F4000_P124_SHOW,''%''||''null%'',null) is null)',
'          union all',
'         select 5,',
'                id,',
'                row_template_name,',
'                reference_id,',
'                flow_id,',
'                ''REPORT'' rtype,',
'                theme_id,',
'                (select wwv_flow_lang.system_message(''F4000_P801_FLOW'')||'' ''||flow_id||'', ''||wwv_flow_lang.system_message(''SUBSCRIBED_FROM.THEME'')||'' ''||theme_id||'', ''||wwv_flow_escape.html(row_template_name)',
'                   from wwv_flow_row_templates ',
'                  where id = p.reference_id) cp_from',
'           from wwv_flow_row_templates p',
'          where p.flow_id = :fb_flow_id',
'            and p.security_group_id = :flow_security_group_id',
'            and p.reference_id is not null ',
'            and (  :F4000_P124_SHOW = ''Report''',
'                or replace(:F4000_P124_SHOW,''%''||''null%'',null) is null)',
'          union all',
'         select 7,',
'                id,',
'                list_template_name,',
'                reference_id,',
'                flow_id,',
'                ''LIST'' rtype,',
'                theme_id,',
'                (select initcap(wwv_flow_lang.system_message(''F4000_P801_FLOW''))||'' ''||flow_id||'', ''||wwv_flow_lang.system_message(''SUBSCRIBED_FROM.THEME'')||'' ''||theme_id||'', ''||wwv_flow_escape.html(list_template_name)',
'                   from wwv_flow_list_templates ',
'                  where id = p.reference_id) cp_from',
'           from wwv_flow_list_templates p',
'          where p.flow_id = :fb_flow_id',
'            and p.security_group_id = :flow_security_group_id',
'            and p.reference_id is not null ',
'            and (  :F4000_P124_SHOW = ''List''',
'                or replace(:F4000_P124_SHOW,''%''||''null%'',null) is null)',
'          union all',
'         select 9,',
'                id,',
'                template_name,',
'                reference_id,',
'                flow_id,',
'                ''LABEL'' rtype,',
'                theme_id,',
'                (select initcap(wwv_flow_lang.system_message(''F4000_P801_FLOW''))||'' ''||flow_id||'', ''||wwv_flow_lang.system_message(''SUBSCRIBED_FROM.THEME'')||'' ''||theme_id||'', ''||wwv_flow_escape.html(template_name)',
'                   from wwv_flow_field_templates ',
'                  where id = p.reference_id) cp_from',
'           from wwv_flow_field_templates p',
'          where p.flow_id = :fb_flow_id',
'            and p.security_group_id = :flow_security_group_id',
'            and p.reference_id is not null ',
'            and (  :F4000_P124_SHOW = ''Field''',
'                or replace(:F4000_P124_SHOW,''%''||''null%'',null) is null)',
'          union all',
'         select 11,',
'                id,',
'                template_name,',
'                reference_id,',
'                flow_id,',
'                ''BUTTON'' rtype,',
'                theme_id,',
'                (select initcap(wwv_flow_lang.system_message(''F4000_P801_FLOW''))||'' ''||flow_id||'', ''||wwv_flow_lang.system_message(''SUBSCRIBED_FROM.THEME'')||'' ''||theme_id||'', ''||wwv_flow_escape.html(template_name)',
'                   from wwv_flow_button_templates ',
'                  where id = p.reference_id) cp_from',
'           from wwv_flow_button_templates p',
'          where p.flow_id = :fb_flow_id',
'            and p.security_group_id = :flow_security_group_id',
'            and p.reference_id is not null ',
'            and (  :F4000_P124_SHOW = ''Button''',
'                or replace(:F4000_P124_SHOW,''%''||''null%'',null) is null)',
'          union all',
'         select 13,',
'                id,',
'                name,',
'                reference_id,',
'                flow_id,',
'                ''MENU'' rtype,',
'                theme_id,',
'                (select initcap(wwv_flow_lang.system_message(''F4000_P801_FLOW''))||'' ''||flow_id||'', ''||wwv_flow_lang.system_message(''SUBSCRIBED_FROM.THEME'')||'' ''||theme_id||'', ''||wwv_flow_escape.html(name)',
'                   from wwv_flow_menu_templates ',
'                  where id = p.reference_id) cp_from',
'           from wwv_flow_menu_templates p',
'          where p.flow_id = :fb_flow_id',
'            and p.security_group_id = :flow_security_group_id',
'            and p.reference_id is not null ',
'            and (  :F4000_P124_SHOW = ''Menu''',
'                or replace(:F4000_P124_SHOW,''%''||''null%'',null) is null)',
'          union all',
'         select 15,',
'                id,',
'                name,',
'                reference_id,',
'                flow_id,',
'                ''CALENDAR'' rtype,',
'                theme_id,',
'                (select initcap(wwv_flow_lang.system_message(''F4000_P801_FLOW''))||'' ''||flow_id||'', ''||wwv_flow_lang.system_message(''SUBSCRIBED_FROM.THEME'')||'' ''||theme_id||'', ''||wwv_flow_escape.html(name)',
'                   from wwv_flow_cal_templates ',
'                  where id = p.reference_id) cp_from',
'           from wwv_flow_cal_templates p',
'          where p.flow_id = :fb_flow_id',
'            and p.security_group_id = :flow_security_group_id',
'            and p.reference_id is not null ',
'            and (  :F4000_P124_SHOW = ''Calendar''',
'                or replace(:F4000_P124_SHOW,''%''||''null%'',null) is null)',
'          union all',
'         select 17,',
'                id,',
'                wwv_flow_lang.system_message(''F4000.P371.POPUP_LOV''),',
'                reference_id,',
'                flow_id,',
'                ''POPUP_LOV'' rtype,',
'                theme_id,',
'                (select initcap(wwv_flow_lang.system_message(''F4000_P801_FLOW''))||'' ''||flow_id||'', ''||wwv_flow_lang.system_message(''SUBSCRIBED_FROM.THEME'')||'' ''||theme_id||'', ''||wwv_flow_escape.html(wwv_flow_lang.system_message(''F4000.P371.POPUP_LOV'''
||'))',
'                   from wwv_flow_popup_lov_template ',
'                  where id = p.reference_id) cp_from',
'           from wwv_flow_popup_lov_template p',
'          where p.flow_id = :fb_flow_id',
'            and p.security_group_id = :flow_security_group_id',
'            and p.reference_id is not null ',
'            and (  :F4000_P124_SHOW = ''Popuplov''',
'                or replace(:F4000_P124_SHOW,''%''||''null%'',null) is null)',
'          union all',
'         select 19,',
'                id,',
'                builder_name,',
'                reference_id,',
'                flow_id,',
'                ''TEMPLATE_COMPONENT'' rtype,',
'                theme_id,',
'                (select initcap(wwv_flow_lang.system_message(''F4000_P801_FLOW''))||'' ''||flow_id||'', ''||wwv_flow_lang.system_message(''SUBSCRIBED_FROM.THEME'')||'' ''||theme_id||'', ''||wwv_flow_escape.html(builder_name)',
'                   from wwv_flow_template_components ',
'                  where id = p.reference_id) cp_from',
'           from wwv_flow_template_components p',
'          where p.flow_id = :fb_flow_id',
'            and p.security_group_id = :flow_security_group_id',
'            and p.reference_id is not null ',
'            and (  :F4000_P124_SHOW = ''TemplateComponent''',
'                or replace(:F4000_P124_SHOW,''%''||''null%'',null) is null)',
')'))
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_no_data_found=>'No subscribing templates available.'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5829057728948610)
,p_query_column_id=>1
,p_column_alias=>'ROW_SELECTOR'
,p_column_display_sequence=>10
,p_column_heading=>'#CHECK_ALL_CHECKBOX#'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5829130234948611)
,p_query_column_id=>2
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>20
,p_column_heading=>'Application'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5829234943948612)
,p_query_column_id=>3
,p_column_alias=>'TEMPLATE_TYPE'
,p_column_display_sequence=>40
,p_column_heading=>'Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5829338552948613)
,p_query_column_id=>4
,p_column_alias=>'TEMPLATE_NAME'
,p_column_display_sequence=>50
,p_column_heading=>'Template'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5829435894948614)
,p_query_column_id=>5
,p_column_alias=>'CP_FROM'
,p_column_display_sequence=>60
,p_column_heading=>'Copied From'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5833088208948650)
,p_query_column_id=>6
,p_column_alias=>'THEME_ID'
,p_column_display_sequence=>30
,p_column_heading=>'Theme'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(87231809713468209)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(181903622922384410)
,p_button_name=>'P124_GO'
,p_button_static_id=>'P124_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Go'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(181590632003554484)
,p_button_sequence=>2
,p_button_plug_id=>wwv_flow_imp.id(181903622922384410)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Refresh Checked'
,p_button_position=>'CREATE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if replace(:F4000_P124_SHOW,''%''||''null%'',null) is null then',
'        for c1 in (',
'            select 1 from wwv_flow_templates p where p.flow_id = :fb_flow_id and security_group_id = :flow_security_group_id and p.reference_id is not null      ',
'            union all',
'            select 1 from wwv_flow_page_plug_templates r where r.flow_id = :fb_flow_id and security_group_id = :flow_security_group_id and r.reference_id is not null',
'            union all',
'            select 1 from wwv_flow_row_templates ro where ro.flow_id = :fb_flow_id and security_group_id = :flow_security_group_id and ro.reference_id is not null  ',
'            union all',
'            select 1 from wwv_flow_list_templates l where l.flow_id = :fb_flow_id and security_group_id = :flow_security_group_id and l.reference_id is not null      ',
'            union all',
'            select 1 from wwv_flow_field_templates f where f.flow_id = :fb_flow_id and security_group_id = :flow_security_group_id and f.reference_id is not null',
'             union all',
'            select 1 from wwv_flow_button_templates b where b.flow_id = :fb_flow_id and security_group_id = :flow_security_group_id and b.reference_id is not null ',
'            union all',
'            select 1 from wwv_flow_menu_templates m where m.flow_id = :fb_flow_id and security_group_id = :flow_security_group_id  and m.reference_id is not null) loop',
'        --',
'            return true;',
'        end loop;',
'        return false;',
'    else',
'        if :F4000_P124_SHOW = ''Page'' then',
'            for c1 in (select 1 from wwv_flow_templates p where p.flow_id = :fb_flow_id and security_group_id = :flow_security_group_id and p.reference_id is not null) loop ',
'                return true; ',
'            end loop; ',
'            return false;',
'        elsif :F4000_P124_SHOW = ''Region'' then',
'            for c1 in (select 1 from wwv_flow_page_plug_templates r where r.flow_id = :fb_flow_id and security_group_id = :flow_security_group_id and r.reference_id is not null) loop',
'                return true; ',
'            end loop;',
'            return false;',
'        elsif :F4000_P124_SHOW = ''Report'' then',
'            for c1 in (select 1 from wwv_flow_row_templates ro where ro.flow_id = :fb_flow_id and security_group_id = :flow_security_group_id and ro.reference_id is not null) loop',
'                return true; ',
'            end loop; ',
'            return false;',
'        elsif :F4000_P124_SHOW = ''List'' then',
'            for c1 in (select 1 from wwv_flow_list_templates l where l.flow_id = :fb_flow_id and security_group_id = :flow_security_group_id and l.reference_id is not null) loop ',
'                return true; ',
'            end loop; ',
'            return false;',
'        elsif :F4000_P124_SHOW = ''Field'' then',
'            for c1 in (select 1 from wwv_flow_field_templates f where f.flow_id = :fb_flow_id and security_group_id = :flow_security_group_id and f.reference_id is not null) loop ',
'                return true; ',
'            end loop; ',
'            return false;',
'        elsif :F4000_P124_SHOW = ''Button'' then',
'            for c1 in (select 1 from wwv_flow_button_templates b where b.flow_id = :fb_flow_id and security_group_id = :flow_security_group_id and b.reference_id is not null) loop',
'                return true; ',
'            end loop; ',
'            return false;',
'        elsif :F4000_P124_SHOW = ''Menu'' then',
'            for c1 in (select 1 from wwv_flow_menu_templates m where m.flow_id = :fb_flow_id and security_group_id = :flow_security_group_id  and m.reference_id is not null) loop',
'                return true; ',
'            end loop; ',
'            return false;',
'        elsif :F4000_P124_SHOW = ''Calendar'' then',
'            for c1 in (select 1 from wwv_flow_cal_templates m where m.flow_id = :fb_flow_id and security_group_id = :flow_security_group_id  and m.reference_id is not null) loop',
'                return true; ',
'            end loop; ',
'            return false;',
'        end if;',
'        return true;',
'    end if;',
'end;'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'FUNCTION_BODY'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(181591019903554494)
,p_branch_action=>'124'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(181612113226583662)
,p_name=>'F4000_P124_SHOW'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(181903622922384410)
,p_prompt=>'Show'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'SHOW_TEMPLATE_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(84336604916626643)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- All Types -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Restrict the results by selecting a template type and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1157779601446618641)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(181911325929398179)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1157779706979618642)
,p_event_id=>wwv_flow_imp.id(1157779601446618641)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(181704614131795876)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh checked templates'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'for i in 1..wwv_flow.g_f01.count loop',
'    wwv_flow_copy_metadata.refresh_page_template (    ',
'    p_subscribing_template_id    => wwv_flow.g_f01(i)',
'    );',
'end loop;',
'exception when others then',
'  raise_application_error(-20001,''Error in refreshing page templates. ''||sqlerrm);',
'end;',
'begin',
'for i in 1..wwv_flow.g_f03.count loop',
'    wwv_flow_copy_metadata.refresh_region_template (',
'    p_subscribing_template_id    => wwv_flow.g_f03(i)',
'    );',
'end loop;',
'exception when others then',
'  raise_application_error(-20001,''Error in refreshing region templates. ''||sqlerrm);',
'end;',
'begin',
'for i in 1..wwv_flow.g_f05.count loop',
'    wwv_flow_copy_metadata.refresh_report_template (    ',
'    p_subscribing_template_id    => wwv_flow.g_f05(i)',
'    );',
'end loop;',
'exception when others then',
'   raise_application_error(-20001,''Error in refreshing report templates. ''||sqlerrm);',
'end;',
'begin',
'for i in 1..wwv_flow.g_f07.count loop',
'    wwv_flow_copy_metadata.refresh_list_template (    ',
'    p_subscribing_template_id    => wwv_flow.g_f07(i)',
'    );',
'end loop;',
'exception when others then',
'   raise_application_error(-20001,''Error in refreshing list templates. ''||sqlerrm);',
'end;',
'begin',
'for i in 1..wwv_flow.g_f09.count loop',
'    wwv_flow_copy_metadata.refresh_field_template (    ',
'    p_subscribing_template_id    => wwv_flow.g_f09(i)',
'    );',
'end loop;',
'exception when others then',
'   raise_application_error(-20001,''Error in refreshing field templates. ''||sqlerrm);',
'end;',
'begin',
'for i in 1..wwv_flow.g_f11.count loop',
'    wwv_flow_copy_metadata.refresh_button_template (    ',
'    p_subscribing_template_id    => wwv_flow.g_f11(i)',
'    );',
'end loop;',
'exception when others then',
'   raise_application_error(-20001,''Error in refreshing button templates. ''||sqlerrm);',
'end;',
'begin',
'for i in 1..wwv_flow.g_f13.count loop',
'    wwv_flow_copy_metadata.refresh_menu_template (    ',
'    p_subscribing_template_id    => wwv_flow.g_f13(i)',
'    );',
'end loop;',
'exception when others then',
'   raise_application_error(-20001,''Error in refreshing menu templates. ''||sqlerrm);',
'end;',
'begin',
'for i in 1..wwv_flow.g_f15.count loop',
'    wwv_flow_copy_metadata.refresh_calendar_template (    ',
'    p_subscribing_template_id    => wwv_flow.g_f15(i)',
'    );',
'end loop;',
'exception when others then',
'   raise_application_error(-20001,''Error in refreshing calendar templates. ''||sqlerrm);',
'end;',
'begin',
'for i in 1..wwv_flow.g_f17.count loop',
'    wwv_flow_copy_metadata.refresh_popuplov_template (    ',
'    p_subscribing_template_id    => wwv_flow.g_f17(i)',
'    );',
'end loop;',
'exception when others then',
'   raise_application_error(-20001,''Error in refreshing Popup LOVs. ''||sqlerrm);',
'end;',
'begin',
'for i in 1..wwv_flow.g_f19.count loop',
'    wwv_flow_copy_metadata.refresh_template_component (    ',
'    p_subscribing_template_id    => wwv_flow.g_f19(i)',
'    );',
'end loop;',
'exception when others then',
'   raise_application_error(-20001,''Error in refreshing template components. ''||sqlerrm);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error refreshing templates.'
,p_process_when_button_id=>wwv_flow_imp.id(181590632003554484)
,p_process_success_message=>'Selected template(s) refreshed.'
,p_internal_uid=>181704614131795876
);
end;
/
prompt --application/pages/page_00128
begin
wwv_flow_imp_page.create_page(
 p_id=>128
,p_name=>'Region Count by Region Type'
,p_alias=>'REGION-COUNT-BY-REGION-TYPE'
,p_step_title=>'Region Count by Region Type'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213220627333807318)
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_region.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(28394706425150973)
,p_name=>'Application Regions by Type'
,p_template=>wwv_flow_imp.id(208928010704475743)
,p_display_sequence=>100
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'SELECT',
'    plug_source_type,',
'    region_type,',
'    count(*) region_count,',
'    count(distinct page_id) pages_referenced,',
'    count(distinct PLUG_DISPLAY_POINT) display_points_used',
'FROM (',
'   select ',
'   plug_source_type,',
'   case',
'    when PLUG_SOURCE_TYPE like ''NATIVE%'' then wwv_flow_lang.system_message(''REGION_NAME.''||plug_source_type)',
'    else plug_source_type',
'    end region_type,',
'    page_id,',
'    plug_display_point',
'FROM',
'   WWV_FLOW_PAGE_PLUGS',
'WHERE',
'   FLOW_ID = :fb_flow_id)',
'group by ',
'   plug_source_type, region_type',
'order by 1'))
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No regions found.'
,p_query_num_rows_type=>'ROW_RANGES'
,p_query_row_count_max=>10000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'Y'
,p_csv_output_link_text=>'Download'
,p_prn_output=>'Y'
,p_prn_format=>'PDF'
,p_prn_output_show_link=>'Y'
,p_prn_output_link_text=>'Print'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'&PRODUCT_NAME.'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#ffffff'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'LEFT'
,p_prn_page_footer_alignment=>'LEFT'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
,p_comment=>'generated 14-MAY-2004 10:40:29'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(136572532696782738)
,p_query_column_id=>1
,p_column_alias=>'PLUG_SOURCE_TYPE'
,p_column_display_sequence=>5
,p_column_heading=>'Type'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_include_in_export=>'N'
,p_print_col_width=>'0'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(28405914718182947)
,p_query_column_id=>2
,p_column_alias=>'REGION_TYPE'
,p_column_display_sequence=>1
,p_column_heading=>'Region Type'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(28331928066600148)
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
,p_print_col_width=>'40'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(28697318218486798)
,p_query_column_id=>3
,p_column_alias=>'REGION_COUNT'
,p_column_display_sequence=>2
,p_column_heading=>'Region Count'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990'
,p_column_html_expression=>'<a href="f?p=&APP_ID.:136:&SESSION.:::RIR,136:IR_PLUG_SOURCE_TYPE:#PLUG_SOURCE_TYPE#" title="&P128_VIEW_PAGES_TEXT.">#REGION_COUNT#</a>'
,p_column_alignment=>'RIGHT'
,p_sum_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_print_col_width=>'20'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(28697419354486799)
,p_query_column_id=>4
,p_column_alias=>'PAGES_REFERENCED'
,p_column_display_sequence=>3
,p_column_heading=>'Pages Referenced'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
,p_print_col_width=>'20'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(28697500722486799)
,p_query_column_id=>5
,p_column_alias=>'DISPLAY_POINTS_USED'
,p_column_display_sequence=>4
,p_column_heading=>'Slots Used'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
,p_print_col_width=>'20'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193876003094584211)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>91
,p_list_id=>wwv_flow_imp.id(13987931263515071)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(28399921846151016)
,p_branch_action=>'f?p=&FLOW_ID.:128:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(177586817411723873)
,p_name=>'P128_VIEW_PAGES_TEXT'
,p_item_sequence=>10
,p_item_display_point=>'LEGACY_ORPHAN_COMPONENTS'
,p_source=>'wwv_flow_lang.system_message(''F4000_P128.VIEW_PAGES'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_00130
begin
wwv_flow_imp_page.create_page(
 p_id=>130
,p_name=>'Application Item Utilization'
,p_alias=>'APPLICATION-ITEM-UTILIZATION'
,p_step_title=>'Application Item Utilization'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(11501804013545635)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_item_app.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5051813440678195)
,p_plug_name=>'Application Item Utilization'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>100
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name,',
'       wwv_flow_computation.get_computation_points( :FB_FLOW_ID, name ) as comps,',
'       id',
'  from wwv_flow_items',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by name'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(5051906577678195)
,p_name=>'Appliation Items'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5052119857678207)
,p_db_column_name=>'NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Application Item'
,p_column_link=>'f?p=4000:4303:&SESSION.::NO::F4000_P4303_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5052232745678207)
,p_db_column_name=>'COMPS'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Utilization'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5052303163678207)
,p_db_column_name=>'ID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(5053430969682717)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1286216389536643'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'NAME:COMPS:ID'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47811023683120211)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>95
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(47807005066095922)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Application Items'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47826831348500844)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>This report lists where each Application Item is used.</p>'
,p_plug_query_num_rows=>1500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_no_data_found=>'<font class="fielddata">No Utilization Found.</font>'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_break_cols=>'1'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(188873318206797764)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(5051813440678195)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:130:&SESSION.::&DEBUG.:130,RIR::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(6415013990672239)
,p_branch_action=>'f?p=&FLOW_ID.:130:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(6415510085673100)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when_button_id=>wwv_flow_imp.id(188873318206797764)
,p_internal_uid=>6415510085673100
);
end;
/
prompt --application/pages/page_00131
begin
wwv_flow_imp_page.create_page(
 p_id=>131
,p_name=>'Create Shortcut - Creation Method'
,p_alias=>'CREATE-SHORTCUT-CREATION-METHOD'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Shortcut'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213468022923563047)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_cut.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47728616931641902)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(185245721349814176)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(185305822581982553)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(185246023181814186)
,p_plug_name=>'Create Shortcut'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<p>You can create Shortcuts from scratch or by copying them from another application.  Copying Shortcuts provides you with a framework that you can modify later.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(185246312970814192)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47728616931641902)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(185246631115814195)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(47728616931641902)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(185247522516814210)
,p_branch_action=>'132'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(185246631115814195)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND_TEXT'
,p_branch_condition=>'F4000_P131_WIZ_TYPE'
,p_branch_condition_text=>'COPY'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(185247821238814216)
,p_branch_action=>'174'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(185246631115814195)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND_TEXT'
,p_branch_condition=>'F4000_P131_WIZ_TYPE'
,p_branch_condition_text=>'BLANK'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(185248126606814220)
,p_branch_action=>'4047'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(185246312970814192)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(185246920821814198)
,p_name=>'F4000_P131_WIZ_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(185246023181814186)
,p_prompt=>'Create Shortcut:'
,p_source=>'BLANK'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'SHORTCUT_WIZ_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(84343606432636502)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_escape_on_http_output=>'N'
,p_help_text=>'<p>Select how to create shortcuts.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(589950181609621446)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(185246312970814192)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(589950286076621447)
,p_event_id=>wwv_flow_imp.id(589950181609621446)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(185248715359814230)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'CLEAR_CACHE'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'131:132:133'
,p_process_when_button_id=>wwv_flow_imp.id(185246312970814192)
,p_internal_uid=>185248715359814230
);
end;
/
prompt --application/pages/page_00132
begin
wwv_flow_imp_page.create_page(
 p_id=>132
,p_name=>'Create Shortcut - Copy From'
,p_alias=>'CREATE-SHORTCUT-COPY-FROM'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Shortcut'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213468022923563047)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_cut.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47731920441671255)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(185251706524816972)
,p_plug_name=>'Create Shortcut'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>'<p>This page allows you to copy Shortcuts from another application or within the current application. Select the application you want to copy Shortcuts from.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(185253512469816999)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(185309707700989517)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(185252312566816980)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(47731920441671255)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(185252618380816982)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(47731920441671255)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(185252021651816976)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47731920441671255)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(185254427925817008)
,p_branch_action=>'133'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(185253812124817002)
,p_branch_action=>'4047'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(185252312566816980)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(185254121835817005)
,p_branch_action=>'131'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(185252021651816976)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(185252932657816987)
,p_name=>'F4000_P132_COPY_FROM_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(185251706524816972)
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Copy From Application'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Application -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the application you want to copy shortcuts from.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_item_comment=>'select name||'' (''||id||'')'', id from wwv_flows where id = v(''FB_FLOW_ID'')'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(185254708259817013)
,p_validation_name=>'F4000_P132_COPY_FROM_FLOW_ID Not Null'
,p_validation_sequence=>10
,p_validation=>'F4000_P132_COPY_FROM_FLOW_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Application ID must be specified.'
,p_associated_item=>wwv_flow_imp.id(185252932657816987)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 18-FEB-2002 15:48'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(590010813975897501)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(185252312566816980)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(590010906638897502)
,p_event_id=>wwv_flow_imp.id(590010813975897501)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00133
begin
wwv_flow_imp_page.create_page(
 p_id=>133
,p_name=>'Create Shortcut - New Shortcuts'
,p_alias=>'CREATE-SHORTCUT-NEW-SHORTCUTS'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Shortcut'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213468022923563047)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_cut.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47732920918680897)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(185257704683820013)
,p_name=>'Create Shortcut'
,p_template=>wwv_flow_imp.id(42025417508627628)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q varchar2(32767) := null;',
'begin',
'  q:=''select '';',
'  q:=q||''flow_id, '';  ',
'  q:=q||''shortcut_name, '';',
'  q:=q||'' wwv_flow_item.text(1,wwv_flow_lang.system_message(''''F4000.P158.COPY_OF'''',shortcut_name),40,null,''''id="name''''||rownum||''''" title="''''||wwv_flow_lang.system_message(''''COPY_TO_NAME'''')||''''"''''), '';',
'  q:=q||'' wwv_flow_item.select_list_from_lov(2,''''N'''',''''YES.NO.SUBSCRIBE'''','''' title="''''||wwv_flow_lang.system_message(''''LAYOUT.T_ALT_COPY'''')||''''" id="copy''''||rownum||''''"'''',''''N''''), '';  ',
'  q:=q||''wwv_flow_item.hidden(3,id) '';  ',
'  q:=q||''from wwv_flow_shortcuts '';',
'  q:=q||''where flow_id = :F4000_P132_COPY_FROM_FLOW_ID '';',
'  q:=q||''and security_group_id = :flow_security_group_id'';',
' ',
'  return q;',
'end;'))
,p_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter names for Shortcuts to be copied, and choose the Copy option from the following:<p/>',
'<ul>',
'<li><strong>Yes.</strong> Enter new shortcut name.</li>',
'<li><strong>No.</strong> Do not copy this shortcut.</li>',
'<li><strong>Copy and Subscribe.</strong> Copy and subscribe to this shortcut.</li>',
'</ul><br/>'))
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_plug_query_max_columns=>60
,p_query_num_rows=>500
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'<font class="fieldtitleleft">No shortcuts found.</font>'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48698920029771705)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_column_heading=>'Application'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48699007315771705)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>2
,p_column_heading=>'From Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48699129612771705)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>3
,p_column_heading=>'To Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48699216963771705)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>4
,p_column_heading=>'Copy'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48699325973771705)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>5
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48699408072771706)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>6
,p_column_heading=>'COL06'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48699502393771706)
,p_query_column_id=>7
,p_column_alias=>'COL07'
,p_column_display_sequence=>7
,p_column_heading=>'COL07'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48699624046771706)
,p_query_column_id=>8
,p_column_alias=>'COL08'
,p_column_display_sequence=>8
,p_column_heading=>'COL08'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48699700843771706)
,p_query_column_id=>9
,p_column_alias=>'COL09'
,p_column_display_sequence=>9
,p_column_heading=>'COL09'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48699809241771706)
,p_query_column_id=>10
,p_column_alias=>'COL10'
,p_column_display_sequence=>10
,p_column_heading=>'COL10'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48699903007771706)
,p_query_column_id=>11
,p_column_alias=>'COL11'
,p_column_display_sequence=>11
,p_column_heading=>'COL11'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48700030935771706)
,p_query_column_id=>12
,p_column_alias=>'COL12'
,p_column_display_sequence=>12
,p_column_heading=>'COL12'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48700102099771706)
,p_query_column_id=>13
,p_column_alias=>'COL13'
,p_column_display_sequence=>13
,p_column_heading=>'COL13'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48700229393771706)
,p_query_column_id=>14
,p_column_alias=>'COL14'
,p_column_display_sequence=>14
,p_column_heading=>'COL14'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48700303853771707)
,p_query_column_id=>15
,p_column_alias=>'COL15'
,p_column_display_sequence=>15
,p_column_heading=>'COL15'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166091010162493699)
,p_query_column_id=>16
,p_column_alias=>'COL16'
,p_column_display_sequence=>16
,p_column_heading=>'Col16'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166091127654493703)
,p_query_column_id=>17
,p_column_alias=>'COL17'
,p_column_display_sequence=>17
,p_column_heading=>'Col17'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166091200212493703)
,p_query_column_id=>18
,p_column_alias=>'COL18'
,p_column_display_sequence=>18
,p_column_heading=>'Col18'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166091314294493703)
,p_query_column_id=>19
,p_column_alias=>'COL19'
,p_column_display_sequence=>19
,p_column_heading=>'Col19'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166091413806493703)
,p_query_column_id=>20
,p_column_alias=>'COL20'
,p_column_display_sequence=>20
,p_column_heading=>'Col20'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166091524751493704)
,p_query_column_id=>21
,p_column_alias=>'COL21'
,p_column_display_sequence=>21
,p_column_heading=>'Col21'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166091620881493704)
,p_query_column_id=>22
,p_column_alias=>'COL22'
,p_column_display_sequence=>22
,p_column_heading=>'Col22'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166091719417493704)
,p_query_column_id=>23
,p_column_alias=>'COL23'
,p_column_display_sequence=>23
,p_column_heading=>'Col23'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166091811500493704)
,p_query_column_id=>24
,p_column_alias=>'COL24'
,p_column_display_sequence=>24
,p_column_heading=>'Col24'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166091903030493704)
,p_query_column_id=>25
,p_column_alias=>'COL25'
,p_column_display_sequence=>25
,p_column_heading=>'Col25'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166092025460493704)
,p_query_column_id=>26
,p_column_alias=>'COL26'
,p_column_display_sequence=>26
,p_column_heading=>'Col26'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166092102619493704)
,p_query_column_id=>27
,p_column_alias=>'COL27'
,p_column_display_sequence=>27
,p_column_heading=>'Col27'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166092222542493705)
,p_query_column_id=>28
,p_column_alias=>'COL28'
,p_column_display_sequence=>28
,p_column_heading=>'Col28'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166092318882493706)
,p_query_column_id=>29
,p_column_alias=>'COL29'
,p_column_display_sequence=>29
,p_column_heading=>'Col29'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166092410859493706)
,p_query_column_id=>30
,p_column_alias=>'COL30'
,p_column_display_sequence=>30
,p_column_heading=>'Col30'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166092509732493706)
,p_query_column_id=>31
,p_column_alias=>'COL31'
,p_column_display_sequence=>31
,p_column_heading=>'Col31'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166092611856493706)
,p_query_column_id=>32
,p_column_alias=>'COL32'
,p_column_display_sequence=>32
,p_column_heading=>'Col32'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166092704747493706)
,p_query_column_id=>33
,p_column_alias=>'COL33'
,p_column_display_sequence=>33
,p_column_heading=>'Col33'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166092820483493706)
,p_query_column_id=>34
,p_column_alias=>'COL34'
,p_column_display_sequence=>34
,p_column_heading=>'Col34'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166092921835493706)
,p_query_column_id=>35
,p_column_alias=>'COL35'
,p_column_display_sequence=>35
,p_column_heading=>'Col35'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166093008221493706)
,p_query_column_id=>36
,p_column_alias=>'COL36'
,p_column_display_sequence=>36
,p_column_heading=>'Col36'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166093108353493706)
,p_query_column_id=>37
,p_column_alias=>'COL37'
,p_column_display_sequence=>37
,p_column_heading=>'Col37'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166093222114493707)
,p_query_column_id=>38
,p_column_alias=>'COL38'
,p_column_display_sequence=>38
,p_column_heading=>'Col38'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166093322369493707)
,p_query_column_id=>39
,p_column_alias=>'COL39'
,p_column_display_sequence=>39
,p_column_heading=>'Col39'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166093418036493707)
,p_query_column_id=>40
,p_column_alias=>'COL40'
,p_column_display_sequence=>40
,p_column_heading=>'Col40'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166093514753493707)
,p_query_column_id=>41
,p_column_alias=>'COL41'
,p_column_display_sequence=>41
,p_column_heading=>'Col41'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166093621122493707)
,p_query_column_id=>42
,p_column_alias=>'COL42'
,p_column_display_sequence=>42
,p_column_heading=>'Col42'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166093719263493707)
,p_query_column_id=>43
,p_column_alias=>'COL43'
,p_column_display_sequence=>43
,p_column_heading=>'Col43'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166093812091493707)
,p_query_column_id=>44
,p_column_alias=>'COL44'
,p_column_display_sequence=>44
,p_column_heading=>'Col44'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166093901369493708)
,p_query_column_id=>45
,p_column_alias=>'COL45'
,p_column_display_sequence=>45
,p_column_heading=>'Col45'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166094006575493708)
,p_query_column_id=>46
,p_column_alias=>'COL46'
,p_column_display_sequence=>46
,p_column_heading=>'Col46'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166094125133493708)
,p_query_column_id=>47
,p_column_alias=>'COL47'
,p_column_display_sequence=>47
,p_column_heading=>'Col47'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166094217123493708)
,p_query_column_id=>48
,p_column_alias=>'COL48'
,p_column_display_sequence=>48
,p_column_heading=>'Col48'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166094307961493708)
,p_query_column_id=>49
,p_column_alias=>'COL49'
,p_column_display_sequence=>49
,p_column_heading=>'Col49'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166094432324493708)
,p_query_column_id=>50
,p_column_alias=>'COL50'
,p_column_display_sequence=>50
,p_column_heading=>'Col50'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166094515029493708)
,p_query_column_id=>51
,p_column_alias=>'COL51'
,p_column_display_sequence=>51
,p_column_heading=>'Col51'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166094632574493708)
,p_query_column_id=>52
,p_column_alias=>'COL52'
,p_column_display_sequence=>52
,p_column_heading=>'Col52'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166094719773493709)
,p_query_column_id=>53
,p_column_alias=>'COL53'
,p_column_display_sequence=>53
,p_column_heading=>'Col53'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166094830626493709)
,p_query_column_id=>54
,p_column_alias=>'COL54'
,p_column_display_sequence=>54
,p_column_heading=>'Col54'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166094928615493709)
,p_query_column_id=>55
,p_column_alias=>'COL55'
,p_column_display_sequence=>55
,p_column_heading=>'Col55'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166095000925493709)
,p_query_column_id=>56
,p_column_alias=>'COL56'
,p_column_display_sequence=>56
,p_column_heading=>'Col56'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166095102808493709)
,p_query_column_id=>57
,p_column_alias=>'COL57'
,p_column_display_sequence=>57
,p_column_heading=>'Col57'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166095220849493709)
,p_query_column_id=>58
,p_column_alias=>'COL58'
,p_column_display_sequence=>58
,p_column_heading=>'Col58'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166095310285493709)
,p_query_column_id=>59
,p_column_alias=>'COL59'
,p_column_display_sequence=>59
,p_column_heading=>'Col59'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166095410798493709)
,p_query_column_id=>60
,p_column_alias=>'COL60'
,p_column_display_sequence=>60
,p_column_heading=>'Col60'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(185259229487820044)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(185309707700989517)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_plug_query_headings=>'Flow:From Name:To Name:Copy'
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_no_data_found=>'<font class="fieldtitleleft">No Page Template Found.</font>'
,p_plug_query_show_nulls_as=>'(null)'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(185258328517820025)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47732920918680897)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(185258008310820016)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(47732920918680897)
,p_button_name=>'Copy'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy Shortcut'
,p_button_position=>'CREATE'
,p_button_condition=>'select 1 from wwv_flow_shortcuts where flow_id = :F4000_P132_COPY_FROM_FLOW_ID'
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(185258616437820026)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(47732920918680897)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(185260109701820052)
,p_branch_action=>'4047'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(185258008310820016)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(185259511066820045)
,p_branch_action=>'4047'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(185258328517820025)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(185259804698820050)
,p_branch_action=>'132'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(185258616437820026)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(590011058635897503)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(185258328517820025)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(590011185797897504)
,p_event_id=>wwv_flow_imp.id(590011058635897503)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(185260418354820054)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Shortcut'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_shortcut_id number;',
'begin',
'    for i in 1..wwv_flow.g_f03.count loop',
'        if wwv_flow.g_f02(i) in (''Y'',''SUBSCRIBE'') then',
'            l_shortcut_id := wwv_flow_copy_metadata.copy_component (',
'                                 p_component_type       => wwv_flow_copy_metadata.c_shortcut,',
'                                 p_from_id              => wwv_flow.g_f03(i),',
'                                 p_from_app_id          => :F4000_P132_COPY_FROM_FLOW_ID,',
'                                 p_to_app_id            => :FB_FLOW_ID,',
'                                 p_new_name             => nvl(wwv_flow.g_f01(i),''Copy of ''||i),',
'                                 p_subscribe            => wwv_flow.g_f02(i) = ''SUBSCRIBE'' );',
'        end if;',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying shortcut(s).'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(185258008310820016)
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_fnd boolean := false;',
'begin',
'  for i in 1.. wwv_flow.g_f02.count loop',
'    if wwv_flow.g_f02(i) != ''N'' then',
'      l_fnd := true;',
'      exit;',
'    end if;',
'  end loop;',
'  return l_fnd;',
'end;'))
,p_process_when_type=>'FUNCTION_BODY'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Shortcut(s) copied.'
,p_internal_uid=>185260418354820054
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(590011213801897505)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,F4000_LAST_VIEW'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(185258008310820016)
,p_process_success_message=>'Shortcut(s) copied.'
,p_internal_uid=>590011213801897505
);
end;
/
prompt --application/pages/page_00134
begin
wwv_flow_imp_page.create_page(
 p_id=>134
,p_name=>'Create Navigation Bar Entry - Copy From'
,p_alias=>'CREATE-NAVIGATION-BAR-ENTRY-COPY-FROM'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Navigation Bar Entry'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213263531591941060)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_navbar.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193570125052895218)
,p_plug_name=>'Create Navigation Bar Entry'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193571927628895233)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(193684503309130516)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_plug_query_headings=>'Flow:From Name:To Name:Copy'
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_no_data_found=>'<font class="fieldtitleleft">No NavBars Found.</font>'
,p_plug_query_show_nulls_as=>'(null)'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(205143813168463328)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(193570726971895224)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(205143813168463328)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(193571025138895225)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(205143813168463328)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(193570403843895222)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(205143813168463328)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(193572827711895238)
,p_branch_action=>'135'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(193571025138895225)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(193572201834895235)
,p_branch_action=>'4005'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(193570726971895224)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(193572508306895237)
,p_branch_action=>'22'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(193570403843895222)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(193571318962895227)
,p_name=>'F4000_P134_COPY_FROM_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(193570125052895218)
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Copy From Application'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Application -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Select a application from which to copy a Navigation Bar option and click <strong>Next</strong>.</p>.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(193573132745895240)
,p_validation_name=>'F4000_P134_COPY_FROM_FLOW_ID Not Null'
,p_validation_sequence=>10
,p_validation=>'F4000_P134_COPY_FROM_FLOW_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Application ID must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(193571025138895225)
,p_associated_item=>wwv_flow_imp.id(193571318962895227)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 18-FEB-2002 15:48'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(573754687601229727)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(193570726971895224)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(573754768039229728)
,p_event_id=>wwv_flow_imp.id(573754687601229727)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00135
begin
wwv_flow_imp_page.create_page(
 p_id=>135
,p_name=>'Create Navigation Bar Entry - New Names'
,p_alias=>'CREATE-NAVIGATION-BAR-ENTRY-NEW-NAMES'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Navigation Bar Entry'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213263531591941060)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_navbar.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193576510750901030)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(193684503309130516)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_plug_query_headings=>'Flow:From Name:To Name:Copy'
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_no_data_found=>'<font class="fieldtitleleft">No NavBars Found.</font>'
,p_plug_query_show_nulls_as=>'(null)'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(193576821859901031)
,p_name=>'Create Navigation Bar Entry'
,p_template=>wwv_flow_imp.id(42025417508627628)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
' flow_id,  ',
' wwv_flow_escape.html(icon_image_alt)|| wwv_flow_item.hidden(3,wwv_flow_escape.html(id)) image_name,',
' wwv_flow_item.text(1,wwv_flow_lang.system_message(''F4000.P158.COPY_OF'',wwv_flow_escape.html(icon_image_alt)),40, 4000, ''title="''||wwv_flow_lang.system_message(''F4000.P158.COPY_OF'',wwv_flow_escape.html(icon_image_alt))||''"'') copy_to,',
' wwv_flow_item.select_list_from_lov(2,''N'',''YES.NO.SUBSCRIBE'',''title="''||wwv_flow_lang.system_message(''F4000.P135.COPY'',wwv_flow_escape.html(icon_image_alt))||''"'',''NO'') subscribe',
' ',
'from wwv_flow_icon_bar',
'where flow_id = :F4000_P134_COPY_FROM_FLOW_ID',
'and security_group_id = :flow_security_group_id'))
,p_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Name the Navigation Bar Entries to be copied and select the copy option. Copy options include:</p>',
'<ul class="noIndent">',
'<li><strong>Yes.</strong> Enter new name.</li>',
'<li><strong>No.</strong> Do not copy this Entry.</li>',
'<li><strong>Copy and Subscribe.</strong> Copy and subscribe to this Entry.</li>',
'</ul>'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'<font class="fieldtitleleft">No navigation bars found.</font>'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(287736001944824470)
,p_query_column_id=>1
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Application'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(287736114427824471)
,p_query_column_id=>2
,p_column_alias=>'IMAGE_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(287736210927824471)
,p_query_column_id=>3
,p_column_alias=>'COPY_TO'
,p_column_display_sequence=>3
,p_column_heading=>'Copy To'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(287736317710824471)
,p_query_column_id=>4
,p_column_alias=>'SUBSCRIBE'
,p_column_display_sequence=>4
,p_column_heading=>'Copy'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(205146227151476750)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(193577424587901033)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(205146227151476750)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(193577130912901032)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(205146227151476750)
,p_button_name=>'Copy'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy Navigation Bar Entries'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(193577715490901034)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(205146227151476750)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(193578612527901042)
,p_branch_action=>'4005'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(193577130912901032)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(193578030073901035)
,p_branch_action=>'4005'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(193577424587901033)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(193578316309901038)
,p_branch_action=>'134'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(193577715490901034)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(573754859823229729)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(193577424587901033)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(573754930157229730)
,p_event_id=>wwv_flow_imp.id(573754859823229729)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(193578908300901043)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy NavBar'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_navbar_id number;',
'lc number := wwv_flow.g_f03.count;',
'begin',
'for i in 1..wwv_flow.g_f03.count loop',
'  l_navbar_id := wwv_flow_id.next_val;',
'  if wwv_flow.g_f02(i) in (''Y'',''SUBSCRIBE'') then',
'    wwv_flow_copy_util.copy_navbar (',
'      p_copy_from_flow_id  => :F4000_P134_COPY_FROM_FLOW_ID,',
'      p_flow_id            => :fb_flow_id,',
'      p_from_navbar_id     => wwv_flow.g_f03(i),',
'      p_to_navbar_name     => nvl(wwv_flow.g_f01(i),''Copy of ''||i),',
'      p_to_navbar_id       => l_navbar_id    ',
'      );      ',
'    if wwv_flow.g_f02(i) = ''SUBSCRIBE'' then',
'      wwv_flow_copy_metadata.subscribe_navbar (',
'      p_master_navbar_id         => wwv_flow.g_f03(i),',
'      p_subscribing_navbar_id    => l_navbar_id',
'      );',
'    end if;',
'  end if;',
'end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying Navigation Bar Entry(s).'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(193577130912901032)
,p_process_success_message=>'Navigation Bar Entry(s) copied.'
,p_internal_uid=>193578908300901043
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(573755035470229731)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,F4000_LAST_VIEW'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(193577130912901032)
,p_process_success_message=>'Navigation Bar Entry(s) copied.'
,p_internal_uid=>573755035470229731
);
end;
/
prompt --application/pages/page_00136
begin
wwv_flow_imp_page.create_page(
 p_id=>136
,p_name=>'Regions by Type, Slot, and Template'
,p_alias=>'REGIONS-BY-TYPE-DISPLAY-POINT-AND-TEMPLATE'
,p_step_title=>'Regions by Type, Slot, and Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213220627333807318)
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(194633408721659272)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>91
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(13987931263515071)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(194635525077685524)
,p_plug_name=>'Regions by Type, Slot, and Template'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>112
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'   all_regions.PLUG_DISPLAY_POINT, ',
'   all_regions.PLUG_NAME, ',
'   all_regions.PAGE_ID, ',
'   ( select name',
'       from wwv_flow_templates',
'      where id = ( select wwv_flow_page_dev.get_template_id ( all_regions.flow_id, all_regions.page_id ) from dual )',
'   ) as page_template,',
'   all_regions.PLUG_SOURCE_TYPE,',
'   all_regions.PLUG_DISPLAY_CONDITION_TYPE,',
'   all_regions.flow_id,',
'   PAGE_PLUG_TEMPLATE_NAME,',
'   all_regions.region_id',
'from (',
'SELECT ',
'   id region_id,',
'   flow_id,',
'   LAST_UPDATED_BY, ',
'   LAST_UPDATED_ON, ',
'   PLUG_DISPLAY_POINT, ',
'   PLUG_NAME, ',
'   PAGE_ID, ',
'   plug_template,',
'   PLUG_SOURCE_TYPE,',
'   decode(PLUG_DISPLAY_CONDITION_TYPE,null,null,''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'') ',
'   PLUG_DISPLAY_CONDITION_TYPE',
'FROM ',
'   WWV_FLOW_PAGE_PLUGS',
'WHERE FLOW_ID = :fb_flow_id) all_regions,',
'WWV_FLOW_PAGE_PLUG_TEMPLATES t',
'where ',
'all_regions.plug_template = t.id(+)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(194635626214685524)
,p_name=>'Regions by Type, Slot, and Template'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194636223371685577)
,p_db_column_name=>'PLUG_SOURCE_TYPE'
,p_display_order=>1
,p_column_identifier=>'E'
,p_column_label=>'Region Type'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194636030583685575)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>2
,p_column_identifier=>'C'
,p_column_label=>'Page'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE_ID#'
,p_column_linktext=>'#PAGE_ID#'
,p_column_link_attr=>'title="&P497_VIEW_PAGE_DEF_TEXT."'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194635903669685574)
,p_db_column_name=>'PLUG_NAME'
,p_display_order=>3
,p_column_identifier=>'B'
,p_column_label=>'Region'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE_ID##5110:#REGION_ID#'
,p_column_linktext=>'#PLUG_NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194635819967685573)
,p_db_column_name=>'PLUG_DISPLAY_POINT'
,p_display_order=>4
,p_column_identifier=>'A'
,p_column_label=>'Slot'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194636532259685579)
,p_db_column_name=>'PAGE_PLUG_TEMPLATE_NAME'
,p_display_order=>5
,p_column_identifier=>'H'
,p_column_label=>'Region Template'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194636322349685577)
,p_db_column_name=>'PLUG_DISPLAY_CONDITION_TYPE'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Conditional'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194636122065685576)
,p_db_column_name=>'PAGE_TEMPLATE'
,p_display_order=>7
,p_column_identifier=>'D'
,p_column_label=>'Page Template'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194636421324685578)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>8
,p_column_identifier=>'G'
,p_column_label=>'Flow Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(100575188990284409)
,p_db_column_name=>'REGION_ID'
,p_display_order=>18
,p_column_identifier=>'I'
,p_column_label=>'Region Id'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(194637931958736794)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1286300701536643'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'PAGE_ID:PLUG_NAME:PLUG_SOURCE_TYPE:PLUG_DISPLAY_POINT:PAGE_PLUG_TEMPLATE_NAME:PLUG_DISPLAY_CONDITION_TYPE:PAGE_TEMPLATE:REGION_ID:'
,p_sort_column_1=>'PAGE_ID'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'PLUG_NAME'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(194640304300757190)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(194635525077685524)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:136:&SESSION.::&DEBUG.:136,RIR::'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(194634326691659288)
,p_name=>'P497_VIEW_PAGE_DEF_TEXT'
,p_item_sequence=>10
,p_item_display_point=>'LEGACY_ORPHAN_COMPONENTS'
,p_source=>'wwv_flow_lang.system_message(''F4000_P497.VIEW_PAGE_DEF'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_00137
begin
wwv_flow_imp_page.create_page(
 p_id=>137
,p_name=>'Create List of Values - Source'
,p_alias=>'CREATE-LIST-OF-VALUES-SOURCE'
,p_page_mode=>'MODAL'
,p_step_title=>'Create List of Values'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213211113434774960)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'500'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_lov.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44762511550082790)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(202759021091609841)
,p_plug_name=>'Create List of Values'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>'<div class="htmldbInfoBodyP">A List of Values is a static or dynamic definition used to display a specific type of page item, such as popup lists of values, a select list, a check box, a radio group, or multiple select lists.</div>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(202907703159922057)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(161740513874429436)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(202769930547624567)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(44762511550082790)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(202773210939628365)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(44762511550082790)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(202932410898948800)
,p_branch_action=>'4004'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(202773210939628365)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND_TEXT'
,p_branch_condition=>'F4000_P137_WIZ_TYPE'
,p_branch_condition_text=>'BLANK'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(202773616194628367)
,p_branch_action=>'138'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(202773210939628365)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND_TEXT'
,p_branch_condition=>'F4000_P137_WIZ_TYPE'
,p_branch_condition_text=>'COPY'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(202778430124635978)
,p_name=>'F4000_P137_WIZ_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(202759021091609841)
,p_prompt=>'Create List of Values:'
,p_source=>'BLANK'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'LOV_WIZ_LOV'
,p_lov=>'.'||wwv_flow_imp.id(84344914743638898)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Specify how to create a list of values (LOV). You can create a LOV from scratch or as a copy of an existing LOV.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(574039250149616923)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(202769930547624567)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(574039381544616924)
,p_event_id=>wwv_flow_imp.id(574039250149616923)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(202783214165643420)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'clear cache'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'137:138:139'
,p_process_when_button_id=>wwv_flow_imp.id(202769930547624567)
,p_internal_uid=>202783214165643420
);
end;
/
prompt --application/pages/page_00138
begin
wwv_flow_imp_page.create_page(
 p_id=>138
,p_name=>'Create List of Values - Copy From'
,p_alias=>'CREATE-LIST-OF-VALUES-COPY-FROM'
,p_page_mode=>'MODAL'
,p_step_title=>'Create List of Values'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213211113434774960)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_lov.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44775211166129981)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(202795805526662588)
,p_plug_name=>'Create List of Values'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>'<p>Copy Lists of Values from within the current application or from another application.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(202958400522984032)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(202952222735973765)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(202800315965667604)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(44775211166129981)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(202806005360674011)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(44775211166129981)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(202802927739671072)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(44775211166129981)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(171114422492457612)
,p_branch_action=>'f?p=&APP_ID.:139:&SESSION.::&DEBUG.:RP::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(202806005360674011)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(202803305809671074)
,p_branch_action=>'137'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(202802927739671072)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(202814618225687156)
,p_name=>'F4000_P138_COPY_FROM_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(202795805526662588)
,p_prompt=>'Copy From Application'
,p_source=>'&FB_FLOW_ID.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Application -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Select the application from which you want to copy LOVs.</p>'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(202816913912689145)
,p_validation_name=>'F4000_P138_COPY_FROM_FLOW_ID Not Null'
,p_validation_sequence=>10
,p_validation=>'F4000_P138_COPY_FROM_FLOW_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Copy From Application must be specified.'
,p_associated_item=>wwv_flow_imp.id(202814618225687156)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 11-APR-2002 15:52'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(574038248072616913)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(202800315965667604)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(574038323505616914)
,p_event_id=>wwv_flow_imp.id(574038248072616913)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00139
begin
wwv_flow_imp_page.create_page(
 p_id=>139
,p_name=>'Create List of Values - New List of Values'
,p_alias=>'CREATE-LIST-OF-VALUES-NEW-LIST-OF-VALUES'
,p_page_mode=>'MODAL'
,p_step_title=>'Create List of Values'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213211113434774960)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_lov.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44777004717137510)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(202824917997702398)
,p_name=>'Create List of Values'
,p_template=>wwv_flow_imp.id(42025417508627628)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  id,',
'  flow_id,',
'  ''<div title="''||wwv_flow_escape.html(v.lov_name)||',
'     ''" style="width:200px; overflow:hidden">''||',
'     wwv_flow_escape.html(v.lov_name)||''</div>''',
'     from_name,',
'  wwv_flow_lang.system_message(''F4000.P158.COPY_OF'',lov_name) to_name,',
'  ''N'' Sub',
'from wwv_flow_lists_of_values$ v',
'where flow_id = :F4000_P138_COPY_FROM_FLOW_ID ',
'  and security_group_id = :flow_security_group_id'))
,p_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Name the Lists of Values to be copied and select the copy option. Copy options include:</p>',
'<ul class="noIndent">',
'<li><strong>Yes.</strong> Enter new List of Values name.</li>',
'<li><strong>No.</strong> Do not copy this List of Value.</li>',
'<li><strong>Copy and Subscribe.</strong> Copy and subscribe to this List of Values.</li>',
'</ul>'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No lists of values found.'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>1000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_prn_format=>'PDF'
,p_prn_output_show_link=>'Y'
,p_prn_output_link_text=>'Print'
,p_prn_units=>'MILLIMETERS'
,p_prn_paper_size=>'A4'
,p_prn_width=>297
,p_prn_height=>210
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#ffffff'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'LEFT'
,p_prn_page_footer_alignment=>'LEFT'
,p_sort_null=>'F'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(289813428793814357)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_print_col_width=>'20'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(289813508814814357)
,p_query_column_id=>2
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>2
,p_column_heading=>'Application'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_print_col_width=>'20'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(289813612988814357)
,p_query_column_id=>3
,p_column_alias=>'FROM_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'From Name'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_print_col_width=>'20'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(289813701369814357)
,p_query_column_id=>4
,p_column_alias=>'TO_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'To Name'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>40
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_print_col_width=>'20'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(289813808431814358)
,p_query_column_id=>5
,p_column_alias=>'SUB'
,p_column_display_sequence=>5
,p_column_heading=>'Copy?'
,p_use_as_row_header=>'N'
,p_display_as=>'SELECT_LIST_FROM_LOV'
,p_named_lov=>wwv_flow_imp.id(309317735965282153)
,p_lov_show_nulls=>'NO'
,p_derived_column=>'N'
,p_lov_display_extra=>'NO'
,p_include_in_export=>'Y'
,p_print_col_width=>'20'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(202960721860989374)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(202952222735973765)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(202841116751724584)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(44777004717137510)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(202846810302732194)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(44777004717137510)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy List of Values'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(202843728872728139)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(44777004717137510)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(289882326116870396)
,p_branch_name=>'Go To Page 4110'
,p_branch_action=>'f?p=&APP_ID.:4110:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(202846810302732194)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(574038188111616912)
,p_branch_action=>'f?p=&APP_ID.:138:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(202843728872728139)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(36099000144565166)
,p_validation_name=>'nothing to copy'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  for i in 1..wwv_flow.g_f01.count loop',
'    if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'') then',
'      return true;',
'    end if;',
'  end loop;',
'  return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'There are no LOV(s) to copy.'
,p_when_button_pressed=>wwv_flow_imp.id(202846810302732194)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(291077815324830905)
,p_validation_name=>'IsDupeName'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_found_name varchar2(2000) := null;',
'begin',
'for i in 1..wwv_flow.g_f01.count loop',
'   if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'')',
'      then',
'      for c1 in ( select lov_name',
'                  from WWV_FLOW_LISTS_OF_VALUES$',
'                  where flow_id = :FB_FLOW_ID',
'                  and security_group_id = (select PROVISIONING_COMPANY_ID',
'                                           from wwv_flow_companies',
'                                           where SHORT_NAME = :COMPANY)',
'                  and lov_name = wwv_flow.g_f02(i) ) loop',
'         if c1.lov_name is not null then ',
'            if l_found_name is null then ',
'              l_found_name := c1.lov_name;',
'            else ',
'              l_found_name := l_found_name||'', ''||c1.lov_name;',
'            end if;',
'         end if;',
'      end loop;',
'   end if;',
'end loop;',
'',
'if l_found_name is not null then ',
'return wwv_flow_lang.system_message(''F4000_LOV_NAME_EXISTS'',',
'                                    l_found_name);',
'end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_when_button_pressed=>wwv_flow_imp.id(202846810302732194)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(574037834170616909)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(202841116751724584)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(574037976332616910)
,p_event_id=>wwv_flow_imp.id(574037834170616909)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(202854401582740437)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy LOV'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_lov_id number;',
'begin',
'    for i in 1..wwv_flow.g_f03.count loop',
'        l_lov_id := wwv_flow_id.next_val;',
'      ',
'        if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'') then',
'            wwv_flow_lov_dev.copy_named_lov(',
'                p_copy_from_flow_id => :F4000_P138_COPY_FROM_FLOW_ID,',
'                p_flow_id           => :fb_flow_id,',
'                p_lov_id_from       => wwv_flow.g_f01(i),',
'                p_lov_name_to       => wwv_flow.g_f02(i),',
'                p_lov_id_to         => l_lov_id,',
'                p_subscribe         => wwv_flow.g_f03(i) = ''SUBSCRIBE'' );',
'        end if;',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying List(s) of Values.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(202846810302732194)
,p_process_success_message=>'List(s) of Values copied.'
,p_internal_uid=>202854401582740437
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(574038084178616911)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_type=>'NEVER'
,p_process_success_message=>'List(s) of Values copied.'
,p_internal_uid=>574038084178616911
);
end;
/
prompt --application/pages/page_00144
begin
wwv_flow_imp_page.create_page(
 p_id=>144
,p_name=>'Create Page Template - New Templates'
,p_alias=>'CREATE-PAGE-TEMPLATE-NEW-TEMPLATES'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Page Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47953200410819832)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(177594010116613582)
,p_name=>'Create Page Templates'
,p_template=>wwv_flow_imp.id(42025417508627628)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'  id,',
'  flow_id,',
'  name from_name,',
'  wwv_flow_lang.system_message(''F4000.P158.COPY_OF'',name) to_name,',
'  ''N'' Sub',
'  from wwv_flow_templates ',
'  where flow_id = :F4000_P26_COPY_FROM_FLOW_ID ',
'  and security_group_id = :flow_security_group_id ',
'  and theme_id = :P225_COPY_FROM_THEME '))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'<font class="fielddata">No page template found.</font>'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(291256720911211008)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(291256825142211008)
,p_query_column_id=>2
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>2
,p_column_heading=>'Application'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(291256915856211009)
,p_query_column_id=>3
,p_column_alias=>'FROM_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'From Name'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(291257022937211009)
,p_query_column_id=>4
,p_column_alias=>'TO_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'To Name'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>40
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(291257105799211009)
,p_query_column_id=>5
,p_column_alias=>'SUB'
,p_column_display_sequence=>5
,p_column_heading=>'Copy?'
,p_use_as_row_header=>'N'
,p_display_as=>'SELECT_LIST_FROM_LOV'
,p_named_lov=>wwv_flow_imp.id(150847232623403358)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'NO'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(177690302851799341)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(320074633987)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(177596609148616902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47953200410819832)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(176868520698259014)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(47953200410819832)
,p_button_name=>'Copy'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy Page Templates'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(177600019537619931)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(47953200410819832)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(152009915943744349)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(589950068358621445)
,p_branch_action=>'f?p=&APP_ID.:225:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(177600019537619931)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(74507924042493708)
,p_name=>'P144_THEME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(177594010116613582)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Copy to Theme:'
,p_source=>'P225_COPY_TO_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies a collection of templates which define the look and feel of the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(291260905721235005)
,p_validation_name=>'IsOneSelected'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  for i in 1..wwv_flow.g_f01.count loop',
'    if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'') then',
'      return true;',
'    end if;',
'  end loop;',
'  return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'You must select at least one template to be copied.',
''))
,p_when_button_pressed=>wwv_flow_imp.id(176868520698259014)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(291261916456238121)
,p_validation_name=>'IsDupeName'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_found_name varchar2(2000) := null;',
'begin',
'for i in 1..wwv_flow.g_f01.count loop',
'   if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'')',
'      then',
'      for c1 in ( select name',
'                  from WWV_FLOW_TEMPLATES',
'                  where flow_id = :FB_FLOW_ID',
'                  and security_group_id = (select PROVISIONING_COMPANY_ID',
'                                           from wwv_flow_companies',
'                                           where SHORT_NAME = :COMPANY)',
'                  and name = wwv_flow.g_f02(i) ) loop',
'         if c1.name is not null then ',
'            if l_found_name is null then ',
'              l_found_name := c1.name;',
'            else ',
'              l_found_name := l_found_name||'', ''||c1.name;',
'            end if;',
'         end if;',
'      end loop;',
'   end if;',
'end loop;',
'',
'if l_found_name is not null then ',
'return wwv_flow_lang.system_message(''F4000.TEMPLATE_NAME_ALREADY_EXISTS'',',
'                                    l_found_name);',
'end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_when_button_pressed=>wwv_flow_imp.id(176868520698259014)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(589949878421621443)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(177596609148616902)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(589949918274621444)
,p_event_id=>wwv_flow_imp.id(589949878421621443)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(176869729127259084)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_template_id number;',
'begin',
'',
'for i in 1..wwv_flow.g_f01.count loop',
'  l_template_id := wwv_flow_id.next_val;',
'',
'  if wwv_flow.g_f03(i) = ''Y'' then',
'    wwv_flow_templates_util.copy_template (',
'      p_copy_from_flow_id    => :F4000_P26_COPY_FROM_FLOW_ID,',
'      p_flow_id              => :fb_flow_id,',
'      p_from_template_id     => wwv_flow.g_f01(i),',
'      p_to_template_name     => wwv_flow.g_f02(i),',
'      p_to_template_id       => l_template_id,',
'      p_to_theme_id          => :p144_theme,',
'      p_include_subscription => false',
'      );',
'  elsif wwv_flow.g_f03(i) = ''SUBSCRIBE'' then',
'    wwv_flow_templates_util.copy_template (',
'      p_copy_from_flow_id    => :F4000_P26_COPY_FROM_FLOW_ID,',
'      p_flow_id              => :fb_flow_id,',
'      p_from_template_id     => wwv_flow.g_f01(i),',
'      p_to_template_name     => wwv_flow.g_f02(i),',
'      p_to_template_id       => l_template_id,',
'      p_to_theme_id          => :p144_theme,',
'      p_include_subscription => true      ',
'      );',
'    wwv_flow_copy_metadata.subscribe_page_template (',
'      p_master_template_id         => wwv_flow.g_f01(i),',
'      p_subscribing_template_id    => l_template_id',
'      );',
'  end if;',
'end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying page template(s).'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(176868520698259014)
,p_process_success_message=>'Page template(s) copied.'
,p_internal_uid=>176869729127259084
);
end;
/
prompt --application/pages/page_00147
begin
wwv_flow_imp_page.create_page(
 p_id=>147
,p_name=>'Create Application Process - Identification'
,p_alias=>'CREATE-APPLICATION-PROCESS-IDENTIFICATION'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Application Process'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(91429205691059841)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'600'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldr_app_proc.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(25944302772206558)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(25941806450198106)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46528306282638612)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(195451713511262987)
,p_plug_name=>'Create Application Process'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_header=>'<p>Application Processes run PL/SQL logic at specific points for each page in an application or as defined by the conditions under which they are set to fire.  Note that "Ajax Callback" processes fire only when called from specific pages.</p>'
,p_plug_footer=>'<p>"Ajax Callback" processes should be declared at the page level whenever possible.  </p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(195471007455288048)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46528306282638612)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4410803830904111)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(46528306282638612)
,p_button_name=>'COPY_FROM_ANOTHER'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Copy from another app'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:4209:&SESSION.::&DEBUG.:4209:P4209_COPY_SOURCE:OTHER'
,p_button_css_classes=>'a-Button--noUI'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(195468429141284770)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(46528306282638612)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(195468816421284787)
,p_branch_action=>'148'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(195468429141284770)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(195626216635398270)
,p_name=>'F4000_P147_PROCESS_POINT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(195451713511262987)
,p_item_default=>'BEFORE_HEADER'
,p_prompt=>'Point'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'FLOW.PROCESS.TYPE'
,p_lov=>'.'||wwv_flow_imp.id(179311318624565491)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identify the point at which this process will run. Note the point of "Ajax Callback" will only fire when requested by a page process.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(195670026087439503)
,p_name=>'F4000_P4147_PROCESS_TYPE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(195451713511262987)
,p_item_default=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies what the process does, for example is it PL/SQL, or a "built-in" type.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(195677709481447180)
,p_name=>'F4000_P147_PROCESS_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(195451713511262987)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the name which identifies this application-level process.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(195708922463653857)
,p_name=>'F4000_P147_SEQUENCE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(195451713511262987)
,p_item_default=>'1'
,p_prompt=>'Sequence'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the sequence number for this process. The sequence number determines the order in which the process is evaluated relative to other process that execute at the same point.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(195755022580775425)
,p_validation_name=>'F4000_P147_PROCESS_NAME Not Null'
,p_validation_sequence=>10
,p_validation=>'F4000_P147_PROCESS_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Name must be specified.'
,p_associated_item=>wwv_flow_imp.id(195677709481447180)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 20-MAR-2002 16:19'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(195755313285775428)
,p_validation_name=>'F4000_P147_SEQUENCE Not Null'
,p_validation_sequence=>20
,p_validation=>'F4000_P147_SEQUENCE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Sequence must be specified.'
,p_associated_item=>wwv_flow_imp.id(195708922463653857)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 20-MAR-2002 16:19'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4021950434707433)
,p_validation_name=>'Process name unique'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_processing',
' where security_group_id = :WORKSPACE_ID ',
'   and flow_id           = :FB_FLOW_ID ',
'   and process_name      = :F4000_P147_PROCESS_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#LABEL# must be unique'
,p_when_button_pressed=>wwv_flow_imp.id(195468429141284770)
,p_associated_item=>wwv_flow_imp.id(195677709481447180)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(590011835254897511)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(195471007455288048)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(590011902307897512)
,p_event_id=>wwv_flow_imp.id(590011835254897511)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00148
begin
wwv_flow_imp_page.create_page(
 p_id=>148
,p_name=>'Create Application Process - Source'
,p_alias=>'CREATE-APPLICATION-PROCESS-SOURCE'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Application Process'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(91429205691059841)
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery(".a-Dialog-page, .a-Dialog, .a-Dialog-wrap, .a-Dialog-body, .a-Wizard-regionBody, .a-MonacoEditor").addClass("resize");',
'apex.jQuery("#F4000_P147_PROCESS_SQL_CONTAINER").addClass("resize").children(".a-Form-inputContainer").addClass("resize");',
'apex.jQuery(".a-Dialog-body, .a-Dialog-footer").css("position", "static");',
'apex.jQuery(".a-Dialog-body").css("overflow", "hidden");',
'apex.theme.pageResizeInit();',
''))
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'600'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldr_app_proc.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(25946216971210693)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(25941806450198106)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46686929212250797)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(195492418219306446)
,p_plug_name=>'Create Application Process'
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(195511810272317225)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(46686929212250797)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(195500921915311105)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46686929212250797)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(195505731612313874)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(46686929212250797)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(195501309948311108)
,p_branch_action=>'150'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(195500921915311105)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(195506110878313877)
,p_branch_action=>'147'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(195505731612313874)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2104701319799601)
,p_name=>'P148_LANGUAGE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(195492418219306446)
,p_prompt=>'Language'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select a language that is used to evaluate the entered programming code.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4836007603949294)
,p_name=>'P148_CHECK_SYNTAX'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(195492418219306446)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Do not validate code (parse code at runtime only).'
,p_source=>'NULL'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_restricted_characters=>'WEB_SAFE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'NO'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(195720222451669075)
,p_name=>'F4000_P147_PROCESS_SQL'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(195492418219306446)
,p_prompt=>'Code'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>30000
,p_cHeight=>16
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the code of your application process.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PAGE_ITEM'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_06=>'P148_LANGUAGE'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4833519791806883)
,p_validation_name=>'Syntax Check'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_code_exec_dev.check_code (',
'           p_type     => wwv_flow_code_exec_dev.c_check_block,',
'           p_code     => :F4000_P147_PROCESS_SQL,',
'           p_language => :P148_LANGUAGE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'nvl(:P148_CHECK_SYNTAX, ''YES'') = ''YES'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(195720222451669075)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(590012056700897513)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(195511810272317225)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(590012177831897514)
,p_event_id=>wwv_flow_imp.id(590012056700897513)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00149
begin
wwv_flow_imp_page.create_page(
 p_id=>149
,p_name=>'Confirm Publish Shared Component'
,p_alias=>'CONFIRM-PUBLISH'
,p_page_mode=>'MODAL'
,p_step_title=>'Confirm Publish'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#comp_grp_components_cr td .b-Badge {',
'    min-inline-size: 100px;',
'    justify-content: center;',
'}'))
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'auto'
,p_dialog_width=>'800'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:500'
,p_dialog_chained=>'N'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'25'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4799431182120940)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>420
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6612118756558826)
,p_plug_name=>'Publish this Component?'
,p_region_css_classes=>'a-Alert--inlineDialog  a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>430
,p_plug_item_display_point=>'BELOW'
,p_function_body_language=>'PLSQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_copy_metadata.get_publish_text (',
'    p_id             => :F4000_P149_ID,',
'    p_component_type => :F4000_P149_TEMPLATE_TYPE);'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(6611728957558822)
,p_name=>'Affected Shared Components'
,p_parent_plug_id=>wwv_flow_imp.id(6612118756558826)
,p_template=>wwv_flow_imp.id(208928010704475743)
,p_display_sequence=>430
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_copy_metadata.get_subscribed_components_sql (',
'    p_component_type => :F4000_P149_TEMPLATE_TYPE );'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(1041645002243406588)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(6612782655558832)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>10
,p_column_heading=>'Name'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(32116100316620836)
,p_name=>'Component Changes'
,p_region_name=>'comp_grp_components_cr'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>440
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select s.to_app_id,',
'       s.component_type,',
'       ( select c.name',
'           from wwv_flow_appl_export_comps c',
'          where c.workspace_id   = :WORKSPACE_ID',
'            and c.application_id = case when s.from_component_id is not null then',
'                                       s.from_app_id',
'                                   else',
'                                       s.to_app_id',
'                                   end',
'            and c.type_name      = s.component_type',
'            and c.id             = coalesce( s.from_component_id, s.to_component_id ) ) component,',
'       s.matching_status,',
'       case ',
'           when s.matching_status in ( ''FOUND'', ''NOT_FOUND'', ''UP_TO_DATE'' )',
'             or  ( s.matching_status = ''NEEDS_REFRESH'' and s.row_action is null ) then',
'               wwv_flow_lang.message(''COMP_GRP.MATCHING_STATUS.''||matching_status)',
'           when s.matching_status = ''NEEDS_REFRESH'' and s.row_action = ''ASSIGN'' then',
'               wwv_flow_lang.message(''COMP_GRP.REFRESH_ASSIGN'')',
'           when s.matching_status is null and s.row_action = ''UNASSIGN'' then',
'               wwv_flow_lang.message(''COMP_GRP.ROW_ACTION.UNASSIGN'')',
'       end matching_status_display,',
'       case s.matching_status',
'           when ''FOUND'' then ''danger''',
'           when ''NEEDS_REFRESH'' then ''warning''',
'           when ''NOT_FOUND'' then ''success''',
'           when ''UP_TO_DATE'' then ''info''',
'       end badge_state',
'  from wwv_flow_component_group_dev.preview_publish (',
'           p_master_id          => :F4000_P149_ID,',
'           p_master_app_id      => :FB_FLOW_ID ) s',
' order by',
'       case s.matching_status',
'           when ''FOUND'' then 1',
'           when ''NEEDS_REFRESH'' then 2',
'           when ''NOT_FOUND'' then 3',
'           when ''UP_TO_DATE'' then 4',
'           else 5',
'       end,',
'       s.to_app_id,',
'       s.component_type'))
,p_display_when_condition=>'F4000_P149_TEMPLATE_TYPE'
,p_display_when_cond2=>'COMPONENT_GROUP'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'There are no component changes in this component group.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7979140360516210)
,p_query_column_id=>1
,p_column_alias=>'TO_APP_ID'
,p_column_display_sequence=>10
,p_column_heading=>'Application'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7976798969516208)
,p_query_column_id=>2
,p_column_alias=>'COMPONENT_TYPE'
,p_column_display_sequence=>40
,p_column_heading=>'Component Type'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(5087092943835745)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7977134247516209)
,p_query_column_id=>3
,p_column_alias=>'COMPONENT'
,p_column_display_sequence=>70
,p_column_heading=>'Component'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7977534298516209)
,p_query_column_id=>4
,p_column_alias=>'MATCHING_STATUS'
,p_column_display_sequence=>50
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7977917228516210)
,p_query_column_id=>5
,p_column_alias=>'MATCHING_STATUS_DISPLAY'
,p_column_display_sequence=>30
,p_column_heading=>'Action'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{if MATCHING_STATUS_DISPLAY/}',
'{with/}',
'VALUE:=#MATCHING_STATUS_DISPLAY#',
'STATE:=#BADGE_STATE#',
'{apply THEME$BADGE/}',
'{endif/}'))
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7978392274516210)
,p_query_column_id=>6
,p_column_alias=>'BADGE_STATE'
,p_column_display_sequence=>60
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7215708863959643)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(4799431182120940)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Help'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6205:&SESSION.::&DEBUG.:::'
,p_button_condition=>'F4000_P149_TEMPLATE_TYPE'
,p_button_condition2=>'COMPONENT_GROUP'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4799691649120942)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(4799431182120940)
,p_button_name=>'PUBLISH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Publish'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4799526957120941)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(4799431182120940)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(6612226731558827)
,p_branch_name=>'Go to F4000_P149_PAGE_ID'
,p_branch_action=>'f?p=&APP_ID.:&F4000_P149_PAGE_ID.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_branch_condition=>'F4000_P149_TEMPLATE_TYPE'
,p_branch_condition_text=>'PAGE_TEMPLATE:REGION_TEMPLATE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(165820922595140347)
,p_name=>'F4000_P149_ID'
,p_item_sequence=>10
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(165893116303188811)
,p_name=>'F4000_P149_PAGE_ID'
,p_item_sequence=>20
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(166263802546672605)
,p_name=>'F4000_P149_TEMPLATE_TYPE'
,p_item_sequence=>30
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4800060450120946)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(4799526957120941)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4800150898120947)
,p_event_id=>wwv_flow_imp.id(4800060450120946)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(6612340468558828)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_EXECUTION_CHAIN'
,p_process_name=>'Publish Template'
,p_attribute_01=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>6612340468558828
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(6612451858558829)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_EXECUTION_CHAIN'
,p_process_name=>'Publish Shared Component'
,p_attribute_01=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>6612451858558829
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(7980490941529257)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Publish Component Group'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_component_group_dev.publish_component_group (',
'    p_master_id          => :F4000_P149_ID,',
'    p_master_app_id      => :FB_FLOW_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(4799691649120942)
,p_process_when=>'F4000_P149_TEMPLATE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'COMPONENT_GROUP'
,p_process_success_message=>'All subscribing component groups are refreshed.'
,p_internal_uid=>7980490941529257
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4799918534120945)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'F4000_P149_TEMPLATE_TYPE'
,p_process_when_type=>'VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST'
,p_process_when2=>'PAGE_TEMPLATE:REGION_TEMPLATE'
,p_internal_uid=>4799918534120945
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(78715904182727300)
,p_process_sequence=>10
,p_parent_process_id=>wwv_flow_imp.id(6612340468558828)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh All Button Templates'
,p_process_sql_clob=>'wwv_flow_copy_metadata.push_button_template(:F4000_P149_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error refreshing all subscribing button templates.'
,p_process_when_button_id=>wwv_flow_imp.id(4799691649120942)
,p_process_when=>'F4000_P149_TEMPLATE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'BUTTON_TEMPLATE'
,p_process_success_message=>'All subscribing button templates refreshed.'
,p_internal_uid=>78715904182727300
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(13248519415667098)
,p_process_sequence=>20
,p_parent_process_id=>wwv_flow_imp.id(6612340468558828)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh All Popup LOV Templates'
,p_process_sql_clob=>'wwv_flow_copy_metadata.push_popuplov_template(:F4000_P149_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error refreshing all subscribing popup LOV templates.'
,p_process_when_button_id=>wwv_flow_imp.id(4799691649120942)
,p_process_when=>'F4000_P149_TEMPLATE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'POPUP_LOV_TEMPLATE'
,p_process_success_message=>'All subscribing popup LOV templates refreshed.'
,p_internal_uid=>13248519415667098
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(13312015866790390)
,p_process_sequence=>30
,p_parent_process_id=>wwv_flow_imp.id(6612340468558828)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh All Breadcrumb Template'
,p_process_sql_clob=>'wwv_flow_copy_metadata.push_menu_template(:F4000_P149_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error refreshing all subscribing breadcrumb templates.'
,p_process_when_button_id=>wwv_flow_imp.id(4799691649120942)
,p_process_when=>'F4000_P149_TEMPLATE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'BREADCRUMB_TEMPLATE'
,p_process_success_message=>'All subscribing breadcrumb templates refreshed.'
,p_internal_uid=>13312015866790390
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(201131030266168028)
,p_process_sequence=>40
,p_parent_process_id=>wwv_flow_imp.id(6612451858558829)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh All NavBars'
,p_process_sql_clob=>'wwv_flow_copy_metadata.push_navbar(:F4000_P149_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error refreshing all subscribing navigation bars.'
,p_process_when_button_id=>wwv_flow_imp.id(4799691649120942)
,p_process_when=>'F4000_P149_TEMPLATE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'NAVBAR'
,p_process_success_message=>'All subscribing navigation bars refreshed.'
,p_internal_uid=>201131030266168028
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(202459101137902160)
,p_process_sequence=>50
,p_parent_process_id=>wwv_flow_imp.id(6612451858558829)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh All LOVs'
,p_process_sql_clob=>'wwv_flow_lov_dev.push_lov(:F4000_P149_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error refreshing all subscribing Lists of Values.'
,p_process_when_button_id=>wwv_flow_imp.id(4799691649120942)
,p_process_when=>'F4000_P149_TEMPLATE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'LOV'
,p_process_success_message=>'All subscribing Lists of Values refreshed.'
,p_internal_uid=>202459101137902160
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(178815716316127062)
,p_process_sequence=>60
,p_parent_process_id=>wwv_flow_imp.id(6612451858558829)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh All Security Scheme'
,p_process_sql_clob=>'wwv_flow_authorization_dev.push_security_scheme(:F4000_P149_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error refreshing all subscribing authorization schemes.'
,p_process_when_button_id=>wwv_flow_imp.id(4799691649120942)
,p_process_when=>'F4000_P149_TEMPLATE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'AUTHORIZATION'
,p_process_success_message=>'All subscribing authorization schemes refreshed.'
,p_internal_uid=>178815716316127062
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(185215322280557269)
,p_process_sequence=>70
,p_parent_process_id=>wwv_flow_imp.id(6612451858558829)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh All Shortcuts'
,p_process_sql_clob=>'wwv_flow_copy_metadata.push_shortcut(:F4000_P149_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error refreshing all subscribing shortcut(s).'
,p_process_when_button_id=>wwv_flow_imp.id(4799691649120942)
,p_process_when=>'F4000_P149_TEMPLATE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'SHORTCUT'
,p_process_success_message=>'All subscribing shortcut(s) refreshed.'
,p_internal_uid=>185215322280557269
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(165214120792064848)
,p_process_sequence=>80
,p_parent_process_id=>wwv_flow_imp.id(6612340468558828)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh All Page Templates'
,p_process_sql_clob=>'wwv_flow_copy_metadata.push_page_template(:F4000_P149_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error refreshing all subscribing page templates.'
,p_process_when_button_id=>wwv_flow_imp.id(4799691649120942)
,p_process_when=>'F4000_P149_TEMPLATE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'PAGE_TEMPLATE'
,p_process_success_message=>'All subscribing page templates refreshed.'
,p_internal_uid=>165214120792064848
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(166410608732019218)
,p_process_sequence=>90
,p_parent_process_id=>wwv_flow_imp.id(6612340468558828)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh All Region Templates'
,p_process_sql_clob=>'wwv_flow_copy_metadata.push_region_template(:F4000_P149_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error refreshing all subscribing region templates.'
,p_process_when_button_id=>wwv_flow_imp.id(4799691649120942)
,p_process_when=>'F4000_P149_TEMPLATE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'REGION_TEMPLATE'
,p_process_success_message=>'All subscribing region templates refreshed.'
,p_internal_uid=>166410608732019218
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(166426024882042160)
,p_process_sequence=>100
,p_parent_process_id=>wwv_flow_imp.id(6612340468558828)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh All List Templates'
,p_process_sql_clob=>'wwv_flow_copy_metadata.push_list_template(:F4000_P149_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error refreshing all subscribing list templates.'
,p_process_when_button_id=>wwv_flow_imp.id(4799691649120942)
,p_process_when=>'F4000_P149_TEMPLATE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'LIST_TEMPLATE'
,p_process_success_message=>'All subscribing list templates refreshed.'
,p_internal_uid=>166426024882042160
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(166432411079048488)
,p_process_sequence=>110
,p_parent_process_id=>wwv_flow_imp.id(6612340468558828)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh All Report Templates'
,p_process_sql_clob=>'wwv_flow_copy_metadata.push_report_template(:F4000_P149_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error refreshing all subscribing report templates.'
,p_process_when_button_id=>wwv_flow_imp.id(4799691649120942)
,p_process_when=>'F4000_P149_TEMPLATE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'REPORT_TEMPLATE'
,p_process_success_message=>'All subscribing report templates refreshed.'
,p_internal_uid=>166432411079048488
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(166440630692054609)
,p_process_sequence=>120
,p_parent_process_id=>wwv_flow_imp.id(6612340468558828)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh All Field Templates'
,p_process_sql_clob=>'wwv_flow_copy_metadata.push_field_template(:F4000_P149_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error refreshing all subscribing field templates.'
,p_process_when_button_id=>wwv_flow_imp.id(4799691649120942)
,p_process_when=>'F4000_P149_TEMPLATE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'FIELD_TEMPLATE'
,p_process_success_message=>'All subscribing field templates refreshed.'
,p_internal_uid=>166440630692054609
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(38657830885562441)
,p_process_sequence=>130
,p_parent_process_id=>wwv_flow_imp.id(6612340468558828)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh All Calendar Templates'
,p_process_sql_clob=>'wwv_flow_copy_metadata.push_calendar_template(:F4000_P149_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error refreshing all subscribing button templates.'
,p_process_when_button_id=>wwv_flow_imp.id(4799691649120942)
,p_process_when=>'F4000_P149_TEMPLATE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'CALENDAR_TEMPLATE'
,p_process_success_message=>'All subscribing calendar templates refreshed.'
,p_internal_uid=>38657830885562441
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(32746425111287723)
,p_process_sequence=>150
,p_parent_process_id=>wwv_flow_imp.id(6612451858558829)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh All Plug-in'
,p_process_sql_clob=>'wwv_flow_plugin_dev.push_plugin(:F4000_P149_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error refreshing all subscribing plug-ins.'
,p_process_when_button_id=>wwv_flow_imp.id(4799691649120942)
,p_process_when=>'F4000_P149_TEMPLATE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'PLUGIN'
,p_process_success_message=>'All subscribing plug-ins refreshed.'
,p_internal_uid=>32746425111287723
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(247726726938524633)
,p_process_sequence=>160
,p_parent_process_id=>wwv_flow_imp.id(6612451858558829)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh All REST Data Sources'
,p_process_sql_clob=>'wwv_flow_web_src_dev.push_web_src_module(:F4000_P149_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error refreshing all subscribing REST Data Sources.'
,p_process_when_button_id=>wwv_flow_imp.id(4799691649120942)
,p_process_when=>'F4000_P149_TEMPLATE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'WEB_SOURCE'
,p_process_success_message=>'All subscribing REST Data Sources refreshed.'
,p_internal_uid=>247726726938524633
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2102748395346925)
,p_process_sequence=>170
,p_parent_process_id=>wwv_flow_imp.id(6612451858558829)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh All Data Load'
,p_process_sql_clob=>'wwv_flow_data_loader_dev.push_data_load(:F4000_P149_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error refreshing all subscribing Data Load Definitions.'
,p_process_when_button_id=>wwv_flow_imp.id(4799691649120942)
,p_process_when=>'F4000_P149_TEMPLATE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'DATA_LOAD'
,p_process_success_message=>'All subscribing Data Load Definition refreshed.'
,p_internal_uid=>2102748395346925
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(98114752104433335)
,p_process_sequence=>180
,p_parent_process_id=>wwv_flow_imp.id(6612451858558829)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh All Search Configs'
,p_process_sql_clob=>'wwv_flow_search_dev.push_search_config(:F4000_P149_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error refreshing all subscribing Search Configurations.'
,p_process_when_button_id=>wwv_flow_imp.id(4799691649120942)
,p_process_when=>'F4000_P149_TEMPLATE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'SEARCH_CONFIG'
,p_process_success_message=>'All subscribing Search Configurations refreshed.'
,p_internal_uid=>98114752104433335
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(63808503867869208)
,p_process_sequence=>190
,p_parent_process_id=>wwv_flow_imp.id(6612451858558829)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh All Map Backgrounds'
,p_process_sql_clob=>'wwv_flow_map_region_dev.push_map_background(:F4000_P149_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error refreshing all subscribing Map Backgrounds.'
,p_process_when_button_id=>wwv_flow_imp.id(4799691649120942)
,p_process_when=>'F4000_P149_TEMPLATE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'MAP_BACKGROUND'
,p_process_success_message=>'All subscribing Map Backgrounds refreshed.'
,p_internal_uid=>63808503867869208
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(11400617548060301)
,p_process_sequence=>200
,p_parent_process_id=>wwv_flow_imp.id(6612451858558829)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh All Lists'
,p_process_sql_clob=>'wwv_flow_copy_metadata.push_list( p_list_id => :F4000_P149_ID );'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error refreshing all subscribing lists.'
,p_process_when_button_id=>wwv_flow_imp.id(4799691649120942)
,p_process_when=>'F4000_P149_TEMPLATE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'LIST'
,p_process_success_message=>'All subscribing lists are refreshed.'
,p_internal_uid=>11400617548060301
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5204022614040728)
,p_process_sequence=>210
,p_parent_process_id=>wwv_flow_imp.id(6612451858558829)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh All Patches'
,p_process_sql_clob=>'wwv_flow_copy_metadata.push_patch( p_patch_id => :F4000_P149_ID );'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error refreshing all subscribing build options.'
,p_process_when_button_id=>wwv_flow_imp.id(4799691649120942)
,p_process_when=>'F4000_P149_TEMPLATE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'BUILD_OPTION'
,p_process_success_message=>'All subscribing build options are refreshed.'
,p_internal_uid=>5204022614040728
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(8160401431443213)
,p_process_sequence=>220
,p_parent_process_id=>wwv_flow_imp.id(6612451858558829)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh All Application Items'
,p_process_sql_clob=>'wwv_flow_copy_metadata.push_app_item( p_item_id => :F4000_P149_ID );'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error refreshing all subscribing application items.'
,p_process_when_button_id=>wwv_flow_imp.id(4799691649120942)
,p_process_when=>'F4000_P149_TEMPLATE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'APP_ITEM'
,p_process_success_message=>'All subscribing application items are refreshed.'
,p_internal_uid=>8160401431443213
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3346949924623735)
,p_process_sequence=>230
,p_parent_process_id=>wwv_flow_imp.id(6612451858558829)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh All Application Processes'
,p_process_sql_clob=>'wwv_flow_copy_metadata.push_app_process( p_process_id => :F4000_P149_ID );'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error refreshing all subscribing application processes.'
,p_process_when_button_id=>wwv_flow_imp.id(4799691649120942)
,p_process_when=>'F4000_P149_TEMPLATE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'APP_PROCESS'
,p_process_success_message=>'All subscribing application processes are refreshed.'
,p_internal_uid=>3346949924623735
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3347978233623745)
,p_process_sequence=>240
,p_parent_process_id=>wwv_flow_imp.id(6612451858558829)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh All Application Computations'
,p_process_sql_clob=>'wwv_flow_copy_metadata.push_app_computation( p_computation_id => :F4000_P149_ID );'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error refreshing all subscribing application computations.'
,p_process_when_button_id=>wwv_flow_imp.id(4799691649120942)
,p_process_when=>'F4000_P149_TEMPLATE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'APP_COMPUTATION'
,p_process_success_message=>'All subscribing application computations are refreshed.'
,p_internal_uid=>3347978233623745
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2613413388441821)
,p_process_sequence=>250
,p_parent_process_id=>wwv_flow_imp.id(6612451858558829)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh All Text Messages'
,p_process_sql_clob=>'wwv_flow_copy_metadata.push_message( p_message_id => :F4000_P149_ID );'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error refreshing all subscribing text messages.'
,p_process_when_button_id=>wwv_flow_imp.id(4799691649120942)
,p_process_when=>'F4000_P149_TEMPLATE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'MESSAGE'
,p_process_success_message=>'All subscribing text messages are refreshed.'
,p_internal_uid=>2613413388441821
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4795552376120901)
,p_process_sequence=>260
,p_parent_process_id=>wwv_flow_imp.id(6612451858558829)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh All User Roles'
,p_process_sql_clob=>'wwv_flow_copy_metadata.push_user_group( p_user_group_id => :F4000_P149_ID );'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error refreshing all subscribing roles.'
,p_process_when_button_id=>wwv_flow_imp.id(4799691649120942)
,p_process_when=>'F4000_P149_TEMPLATE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'APP_ACL'
,p_process_success_message=>'All subscribing roles are refreshed.'
,p_internal_uid=>4795552376120901
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2635445709134115)
,p_process_sequence=>270
,p_parent_process_id=>wwv_flow_imp.id(6612451858558829)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh Email Templates'
,p_process_sql_clob=>'wwv_flow_mail_dev.push_email_template( p_email_template_id => :F4000_P149_ID );'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error refreshing all subscribing email templates.'
,p_process_when_button_id=>wwv_flow_imp.id(4799691649120942)
,p_process_when=>'F4000_P149_TEMPLATE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'EMAIL_TEMPLATE'
,p_process_success_message=>'All subscribing email templates are refreshed.'
,p_internal_uid=>2635445709134115
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3626286718310608)
,p_process_sequence=>280
,p_parent_process_id=>wwv_flow_imp.id(6612451858558829)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh Report Layouts'
,p_process_sql_clob=>'wwv_flow_copy_metadata.push_report_layout( p_report_layout_id => :F4000_P149_ID );'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error refreshing all subscribing report layouts.'
,p_process_when_button_id=>wwv_flow_imp.id(4799691649120942)
,p_process_when=>'F4000_P149_TEMPLATE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'REPORT_LAYOUT'
,p_process_success_message=>'All subscribing report layouts are refreshed.'
,p_internal_uid=>3626286718310608
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3629401218310640)
,p_process_sequence=>290
,p_parent_process_id=>wwv_flow_imp.id(6612451858558829)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh Application Settings'
,p_process_sql_clob=>'wwv_flow_copy_metadata.push_app_setting( p_setting_id => :F4000_P149_ID );'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error refreshing all subscribing application settings.'
,p_process_when_button_id=>wwv_flow_imp.id(4799691649120942)
,p_process_when=>'F4000_P149_TEMPLATE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'APP_SETTING'
,p_process_success_message=>'All subscribing application settings are refreshed.'
,p_internal_uid=>3629401218310640
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2522330180409110)
,p_process_sequence=>300
,p_parent_process_id=>wwv_flow_imp.id(6612451858558829)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh Component Settings'
,p_process_sql_clob=>'wwv_flow_copy_metadata.push_component_setting( p_setting_id => :F4000_P149_ID );'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error refreshing all subscribing component settings.'
,p_process_when_button_id=>wwv_flow_imp.id(4799691649120942)
,p_process_when=>'F4000_P149_TEMPLATE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'PLUGIN_SETTINGS'
,p_process_success_message=>'All subscribing component settings are refreshed.'
,p_internal_uid=>2522330180409110
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(11093359297588022)
,p_process_sequence=>310
,p_parent_process_id=>wwv_flow_imp.id(6612451858558829)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh Authentication Schemes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.push_authentication (',
'    p_authentication_id => :F4000_P149_ID );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error refreshing all authentications schemes.'
,p_process_when_button_id=>wwv_flow_imp.id(4799691649120942)
,p_process_when=>'F4000_P149_TEMPLATE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'AUTHENTICATION'
,p_process_success_message=>'All subscribing authentication schemes are refreshed.'
,p_internal_uid=>11093359297588022
);
end;
/
prompt --application/pages/page_00150
begin
wwv_flow_imp_page.create_page(
 p_id=>150
,p_name=>'Create Application Process - Conditionality'
,p_alias=>'CREATE-APPLICATION-PROCESS-CONDITIONALITY'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Application Process'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(91429205691059841)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'600'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldr_app_proc.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(25954318618230080)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(25941806450198106)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46696825880259308)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(195523607855326447)
,p_plug_name=>'Create Application Process'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(236699304404828727)
,p_plug_name=>'Information'
,p_parent_plug_id=>wwv_flow_imp.id(195523607855326447)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<p>Ajax Callback application-level processes will be created with the authorization scheme "Must Not Be Public User".</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'F4000_P147_PROCESS_POINT'
,p_plug_display_when_cond2=>'ON_DEMAND'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(195539232698342574)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(46696825880259308)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(195534819884338899)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(46696825880259308)
,p_button_name=>'CreateFlowProcess'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Process'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(195529124602330828)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46696825880259308)
,p_button_name=>'Back'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(195535230889338903)
,p_branch_action=>'4207'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(195534819884338899)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(195529527027330831)
,p_branch_action=>'148'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(195529124602330828)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1500978898824314)
,p_name=>'F4000_P150_PROCESS_WHEN_LANG'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(195523607855326447)
,p_prompt=>'Language'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select a language that is used to evaluate the entered programming code.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17810125791998856)
,p_name=>'F4000_P150_PROCESS_WHEN2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(195523607855326447)
,p_prompt=>'Expression 2'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>8
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Some condition types require two expressions for comparison. Enter the second expression or item here.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(195815600440226308)
,p_name=>'F4000_P150_PROCESS_WHEN'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(195523607855326447)
,p_prompt=>'Expression 1'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>8
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Use this attribute to conditionally control whether or not a component is rendered or processed. Enter values in this attribute based on the selected condition type. The component will be rendered or processed if the specified condition is met.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(195818329758227939)
,p_name=>'F4000_P150_PROCESS_WHEN_TYPE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(195523607855326447)
,p_prompt=>'Condition Type'
,p_source=>'F4000_P147_PROCESS_WHEN_TYPE'
,p_source_type=>'ITEM'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CONDITION_LIST'
,p_named_lov=>'STANDARD_CONDITION_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(13602414170805697)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Condition Type -'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Select a condition type from the list. This condition must be met in order for this component to be rendered or processed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'F4000_P150_PROCESS_WHEN'
,p_attribute_02=>'F4000_P150_PROCESS_WHEN2'
,p_attribute_04=>'F4000_P150_PROCESS_WHEN_CHECK'
,p_attribute_06=>'WIZARD'
,p_attribute_07=>'F4000_P150_PROCESS_WHEN_LANG'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(195907029523516671)
,p_name=>'F4000_P150_PROCESS_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(195523607855326447)
,p_use_cache_before_default=>'NO'
,p_source=>'F4000_P4147_PROCESS_TYPE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_help_text=>'Identifies the process type.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(195912532098530661)
,p_name=>'F4000_P150_PROCESS_POINT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(195523607855326447)
,p_use_cache_before_default=>'NO'
,p_source=>'F4000_P147_PROCESS_POINT'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_help_text=>'Identifies the process point.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(435032821193654756)
,p_name=>'F4000_P150_PROCESS_WHEN_CHECK'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(195523607855326447)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Do not validate code (parse code at runtime only).'
,p_source=>'NULL'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(590012271653897515)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(195539232698342574)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(590012348771897516)
,p_event_id=>wwv_flow_imp.id(590012271653897515)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(195787020990140788)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create flow process'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_imp_shared.create_flow_process (',
'    p_flow_id => :fb_flow_id,',
'    p_process_sequence       => :F4000_P147_SEQUENCE,',
'    p_process_point          => :F4000_P147_PROCESS_POINT,',
'    p_process_type           => :F4000_P4147_PROCESS_TYPE,',
'    p_process_name           => :F4000_P147_PROCESS_NAME,',
'    p_process_sql_clob       => :F4000_P147_PROCESS_SQL,',
'    p_process_clob_language  => :P148_LANGUAGE,',
'    p_error_display_location => case',
'                                  when :F4000_P147_PROCESS_POINT in (''ON_SUBMIT_BEFORE_COMPUTATION'', ''AFTER_SUBMIT'') then',
'                                      wwv_flow_error_api.c_inline_in_notification',
'                                  else',
'                                      wwv_flow_error_api.c_on_error_page',
'                                end,',
'    p_process_when           => :F4000_P150_PROCESS_WHEN,',
'    p_process_when_type      => replace(:F4000_P150_PROCESS_WHEN_TYPE,''%null%'',null),',
'    p_process_when2          => :F4000_P150_PROCESS_WHEN2,',
'    p_process_when_type2     => null,',
'    p_security_scheme        => case when :F4000_P147_PROCESS_POINT = ''ON_DEMAND'' then ''MUST_NOT_BE_PUBLIC_USER'' else null end,',
'    p_required_patch         => null );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error creating application level process.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(195534819884338899)
,p_process_success_message=>'Process created.'
,p_internal_uid=>195787020990140788
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(590012477246897517)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,F4000_LAST_VIEW'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(195534819884338899)
,p_process_success_message=>'Process created.'
,p_internal_uid=>590012477246897517
);
end;
/
prompt --application/pages/page_00152
begin
wwv_flow_imp_page.create_page(
 p_id=>152
,p_name=>'Computation History'
,p_alias=>'COMPUTATION-HISTORY1'
,p_step_title=>'Computation History'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_pg_comp.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17468530992581007)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>100
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(17446232715505772)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(251089817295332531)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>160
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.page_id,',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_STEP_COMPUTATIONS'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(251090013737332532)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251090119125332534)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251090211465332535)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Audit Comment'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251090302961332536)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Component Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251090421358332537)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251090502481332538)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Component Key'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251090617770332539)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Audit Date'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251090725010332540)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251335414356086391)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(251090802295332540)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1286424550536643'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'PAGE_ID:AUDIT_DATE:ACTION:DEVELOPER:COMPONENT_NAME'
,p_sort_column_1=>'AUDIT_DATE'
,p_sort_direction_1=>'DESC'
,p_sort_column_2=>'PAGE_ID'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(251197006725742003)
,p_plug_name=>'Computation History'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page displays recent modifications made to the Computations on the current page.</p>',
'<p>Remove the filter to view the history of all page Computations within the application.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(251092431279346040)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(251089817295332531)
,p_button_name=>'RESET_REPORT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:152:&SESSION.::&DEBUG.:152,RIR:IR_PAGE_ID:&FB_FLOW_PAGE_ID.'
);
end;
/
prompt --application/pages/page_00153
begin
wwv_flow_imp_page.create_page(
 p_id=>153
,p_name=>'Grid Edit Navigation Bar Entries'
,p_alias=>'GRID-EDIT-NAVIGATION-BAR-ENTRIES'
,p_step_title=>'Grid Edit Navigation Bar Entries'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213263531591941060)
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'nav_navbar.htm'
,p_page_component_map=>'01'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3146010964009901)
,p_plug_name=>'Wrapping  Navigation Bar Entries Landmark'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>110
,p_landmark_type=>'region'
,p_landmark_label=>'Navigation Bar Entries'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(166070830263906494)
,p_name=>'Edit Navigation Bar Entries'
,p_parent_plug_id=>wwv_flow_imp.id(3146010964009901)
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>130
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P4153a */',
'ID,',
'ICON_SEQUENCE,',
'ICON_IMAGE,',
'ICON_SUBTEXT,',
'ICON_IMAGE_ALT,',
'ICON_HEIGHT,',
'ICON_WIDTH,',
'ICON_TARGET,',
'ONCLICK',
'from WWV_FLOW_ICON_BAR',
'where flow_id = :fb_flow_id',
'and security_group_id = :flow_security_group_id',
'order by ICON_SEQUENCE'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
,p_comment=>'Region generated 23-JAN-2002 20:06:26'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48756731896772039)
,p_query_column_id=>1
,p_form_element_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48756823045772039)
,p_query_column_id=>2
,p_form_element_id=>2
,p_column_alias=>'ICON_SEQUENCE'
,p_column_display_sequence=>2
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT'
,p_column_width=>3
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48756910674772039)
,p_query_column_id=>3
,p_form_element_id=>3
,p_column_alias=>'ICON_IMAGE'
,p_column_display_sequence=>3
,p_column_heading=>'Image1'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT'
,p_column_width=>25
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48757000505772039)
,p_query_column_id=>4
,p_form_element_id=>4
,p_column_alias=>'ICON_SUBTEXT'
,p_column_display_sequence=>4
,p_column_heading=>'Sub-Text1'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT'
,p_column_width=>25
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48757108435772040)
,p_query_column_id=>5
,p_form_element_id=>5
,p_column_alias=>'ICON_IMAGE_ALT'
,p_column_display_sequence=>5
,p_column_heading=>'Alternate Text'
,p_use_as_row_header=>'Y'
,p_display_as=>'TEXT'
,p_column_width=>25
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48757205929772040)
,p_query_column_id=>6
,p_form_element_id=>6
,p_column_alias=>'ICON_HEIGHT'
,p_column_display_sequence=>6
,p_column_heading=>'Height'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT'
,p_column_width=>3
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48757311333772040)
,p_query_column_id=>7
,p_form_element_id=>7
,p_column_alias=>'ICON_WIDTH'
,p_column_display_sequence=>7
,p_column_heading=>'Width'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT'
,p_column_width=>3
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48757400782772040)
,p_query_column_id=>8
,p_form_element_id=>8
,p_column_alias=>'ICON_TARGET'
,p_column_display_sequence=>8
,p_column_heading=>'Target'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT'
,p_column_width=>30
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48757504207772040)
,p_query_column_id=>9
,p_column_alias=>'ONCLICK'
,p_column_display_sequence=>9
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(166071106869906496)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'HIDDEN'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(166071229705906496)
,p_column_sequence=>2
,p_query_column_name=>'ICON_SEQUENCE'
,p_display_as=>'TEXT'
,p_column_width=>8
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(166071316018906496)
,p_column_sequence=>3
,p_query_column_name=>'ICON_IMAGE'
,p_display_as=>'TEXT'
,p_column_width=>25
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(166071402290906496)
,p_column_sequence=>4
,p_query_column_name=>'ICON_SUBTEXT'
,p_display_as=>'TEXT'
,p_column_width=>25
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(166071502987906496)
,p_column_sequence=>5
,p_query_column_name=>'ICON_IMAGE_ALT'
,p_display_as=>'TEXT'
,p_column_width=>25
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(166071601538906497)
,p_column_sequence=>6
,p_query_column_name=>'ICON_HEIGHT'
,p_display_as=>'TEXT'
,p_column_width=>8
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(166071722147906497)
,p_column_sequence=>7
,p_query_column_name=>'ICON_WIDTH'
,p_display_as=>'TEXT'
,p_column_width=>8
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(176318218517966690)
,p_column_sequence=>8
,p_query_column_name=>'ICON_TARGET'
,p_display_as=>'TEXT'
,p_column_width=>30
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(166071813882906497)
,p_column_sequence=>9
,p_query_column_name=>'ONCLICK'
,p_display_as=>'ESCAPE_SC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(166113803812969530)
,p_plug_name=>' Navigation Bar Entries'
,p_parent_plug_id=>wwv_flow_imp.id(3146010964009901)
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--wizard:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>120
,p_landmark_type=>'exclude_landmark'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(166774401354873564)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>100
,p_list_id=>wwv_flow_imp.id(166766500720858594)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Classic Navigation Bar'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2159731444663655)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(166070830263906494)
,p_button_name=>'ADD'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Add Entry'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'javascript:addRow();'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(166072014030906498)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(166113803812969530)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'EDIT'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(166072904040906503)
,p_branch_action=>'153'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(166072014030906498)
,p_branch_sequence=>30
,p_branch_comment=>'Generated 23-JAN-2002 20:06:26'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3832732439560151)
,p_tabular_form_region_id=>wwv_flow_imp.id(166070830263906494)
,p_validation_name=>'ICON_SEQUENCE'
,p_validation_sequence=>10
,p_validation=>'ICON_SEQUENCE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#COLUMN_HEADER# must be specified.'
,p_associated_column=>'ICON_SEQUENCE'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(166072529422906502)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(166070830263906494)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'ApplyMRU'
,p_attribute_02=>'WWV_FLOW_ICON_BAR'
,p_attribute_03=>'ID'
,p_attribute_05=>'flow_id = :FB_FLOW_ID and security_group_id = :WORKSPACE_ID'
,p_process_error_message=>'Error processing update'
,p_process_when_button_id=>wwv_flow_imp.id(166072014030906498)
,p_process_success_message=>'#MRU_COUNT# Navigation Bar Entry(s) updated.'
,p_internal_uid=>166072529422906502
,p_process_comment=>'Generated 23-JAN-2002 20:06:26'
);
end;
/
prompt --application/pages/page_00154
begin
wwv_flow_imp_page.create_page(
 p_id=>154
,p_name=>'Install Application'
,p_alias=>'INSTALL-APPLICATION1'
,p_step_title=>'Install Application'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213300727323081712)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_install.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(51437001311244754)
,p_plug_name=>'Install Application Error'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>100
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The application could not be installed because it already exists in different workspace.  If you wish to install the application, please do the following:</p>',
'<ol>',
'<li>Remove the existing application from the workspace it currently exists in.</li>',
'</ol>',
'OR',
'<ol>',
'<li>Change the application ID in your export file.  An application ID that''s currently available you can use is &P154_FLOW_ID..</li>',
'<li>Upload the changed export file to the repository, and re-install your application.</li>',
'</ol>'))
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_security_group_id number := null;',
'begin',
'  for c1 in (select security_group_id',
'             from wwv_flows',
'             where id = :P49_NEW_FLOW_ID)',
'  loop',
'    l_security_group_id := c1.security_group_id;',
'  end loop;',
'  if l_security_group_id is not null then',
'    if l_security_group_id != :P49_LOGGED_IN_COMPANY then',
'       return true;    ',
'    end if;',
'  end if;',
'  return false;',
'end;'))
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(103586452520901305)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(249630630203034086)
,p_plug_name=>'Install Application Error'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>130
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p />The application could not be installed because its build status is <i>Run Application Only</i>. If you wish to install the application, you must first log in as a Workspace Administrator and change the application status using Workspace Utilitie'
||'s.',
'<p />'))
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows',
' where id                = :P49_NEW_FLOW_ID',
'   and build_status      = ''RUN_ONLY'' ',
'   and security_group_id = :P49_LOGGED_IN_COMPANY'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(103586577457901306)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(103586452520901305)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:49:&SESSION.::&DEBUG.:RP::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(51446112926361623)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(51437001311244754)
,p_button_name=>'EXPORT_REPOSITORY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Back to Export Repository'
,p_button_position=>'EDIT'
,p_grid_new_row=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(249718211482927579)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(249630630203034086)
,p_button_name=>'EXPORT_REPOSITORY2'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Back to Export Repository'
,p_button_position=>'EDIT'
,p_grid_new_row=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(51446409308361626)
,p_branch_action=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(51442830887338415)
,p_name=>'P154_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(51437001311244754)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(51444319244344517)
,p_computation_sequence=>10
,p_computation_item=>'P154_FLOW_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_utilities.minimum_free_flow'
,p_computation_error_message=>'Unable to compute item value.'
,p_compute_when_type=>'%null%'
);
end;
/
prompt --application/pages/page_00155
begin
wwv_flow_imp_page.create_page(
 p_id=>155
,p_name=>'Deinstall Supporting Objects'
,p_alias=>'DEINSTALL-SUPPORTING-OBJECTS'
,p_step_title=>'Deinstall Supporting Objects'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(24907316279669450)
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/* Add more spacing for checkboxes */',
'.apex-item-option {margin-bottom: 8px;margin-top: 4px;}',
'/* Floating radio group left so help icons shows correctly */',
'.apex-item-group {float: left;}'))
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_del.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(85794765234345702)
,p_plug_name=>'Deinstall'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>30
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(86068574232737354)
,p_plug_name=>'Deinstallation Message'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
'where flow_id = :FB_FLOW_ID and deinstall_message is not null'))
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(276131761882380158)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(399849897040726767)
,p_plug_display_sequence=>50
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(227753031474767408)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(971952811697342045)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(971952869494342046)
,p_plug_name=>'Deinstall Supporting Objects'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(48380550253598046)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(971952811697342045)
,p_button_name=>'DEINSTALL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Deinstall'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(48380972505598051)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(971952811697342045)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&P155_CANCEL_PAGE.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(48386122997598062)
,p_branch_name=>'Go To Page 2111'
,p_branch_action=>'f?p=&APP_ID.:2111:&SESSION.::&DEBUG.::::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(48380550253598046)
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48377060636598038)
,p_name=>'P155_PARSING_SCHEMA'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_imp.id(85794765234345702)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Parsing Schema'
,p_source=>'select owner from wwv_flows where id = :fb_flow_id and :fb_flow_id is not null'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'This identifies the default schema for you application.  The deinstallation script will also parse as this schema.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48377993629598039)
,p_name=>'P155_DEINSTALLATION_OPTIONS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(85794765234345702)
,p_prompt=>'Deinstallation Options'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'REMOVE SUPPORTING OBJECTS CONFIRM'
,p_lov=>'.'||wwv_flow_imp.id(48392517652618439)||'.'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Will run the deinstallation script defined in the supporting object definitions of application &FB_FLOW_ID..'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48378880912598040)
,p_name=>'P155_CANCEL_PAGE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(85794765234345702)
,p_item_default=>'1'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48379525713598043)
,p_name=>'P155_DEINSTALL_MESSAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(86068574232737354)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_utilities.esc_non_basic_tags(deinstall_message) from wwv_flow_install',
' where flow_id = :FB_FLOW_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(48382018936598055)
,p_computation_sequence=>10
,p_computation_item=>'P2111_DEINSTALL_SUCCESS_MESSAGE'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(deinstall_success_message,',
'         null, ',
'         wwv_flow_lang.system_message(''INSTALLER.DEINSTALL_SUCCESS_MESSAGE''),',
'         wwv_flow_utilities.esc_non_basic_tags(deinstall_success_message))',
'  from wwv_flow_install',
' where flow_id = :FB_FLOW_ID'))
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(48382427829598055)
,p_computation_sequence=>20
,p_computation_item=>'P2106_DEPLOYMENT_FLOW_ID'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'FB_FLOW_ID'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(48383210763598056)
,p_computation_sequence=>30
,p_computation_item=>'P2106_DEPLOYMENT_FLOW_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(48382807176598055)
,p_computation_sequence=>30
,p_computation_item=>'P155_CANCEL_PAGE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'nvl(:P155_CANCEL_PAGE,1)'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(48383632013598056)
,p_validation_name=>'P155_DEINSTALLATION_OPTIONS'
,p_validation_sequence=>10
,p_validation=>'P155_DEINSTALLATION_OPTIONS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'You must check the de-installation checkbox.'
,p_associated_item=>wwv_flow_imp.id(48377993629598039)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(48385128041598060)
,p_name=>'Deinstall'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(48380550253598046)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(48385613890598061)
,p_event_id=>wwv_flow_imp.id(48385128041598060)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'DEINSTALL'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(48383910898598056)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Deinstall Database Objects'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select id, owner from ',
'              (select id from wwv_flow_install where flow_id = :FB_FLOW_ID), ',
'              (select owner from wwv_flows where id = :FB_FLOW_ID))',
'loop',
'  wwv_flow_install_wizard.deinstall (',
'      p_install_id  => c1.id,',
'      p_flow_id     => :FB_FLOW_ID,',
'      p_schema      => c1.owner',
'      );',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to deinstall application.'
,p_process_when_button_id=>wwv_flow_imp.id(48380550253598046)
,p_process_when=>'DBOBJECTS'
,p_process_when_type=>'CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2'
,p_process_when2=>'P155_DEINSTALLATION_OPTIONS'
,p_process_success_message=>'Deinstall successful. '
,p_internal_uid=>48383910898598056
);
end;
/
prompt --application/pages/page_00156
begin
wwv_flow_imp_page.create_page(
 p_id=>156
,p_name=>'List Utilization'
,p_alias=>'LIST-UTILIZATION'
,p_step_title=>'List Utilization'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213210808239773454)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_list.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3702113071642994)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page displays all lists included in the current application.</p>',
'<p>To edit list entries, select the list name. To view the pages on which the list appears, click the number in the Pages column.</p>'))
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'-'
,p_plug_query_col_allignments=>'L:R'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3707632683649133)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(62973516530710918)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Lists'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(48551711725399629)
,p_plug_name=>'List Utilization'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select l.name as link,',
'      (',
'          select count(*)',
'            from wwv_flow_page_plugs p',
'           where p.list_id           = l.id',
'             and p.flow_id           = l.flow_id',
'             and p.security_group_id = l.security_group_id',
'      ) +',
'      (',
'          select count(*)',
'            from wwv_flow_steps s',
'           where s.navigation_list_id = l.id',
'             and s.flow_id            = l.flow_id',
'             and s.security_group_id  = l.security_group_id',
'      ) +',
'      (',
'          select count(*)',
'            from wwv_flows f',
'           where l.id in (f.navigation_list_id, f.nav_bar_list_id)',
'             and f.id                = l.flow_id',
'             and f.security_group_id = l.security_group_id',
'      ) +',
'      (',
'          select count(*)',
'            from wwv_flow_list_items sl',
'           where sl.sub_list_id       = l.id',
'             and sl.flow_id           = l.flow_id',
'             and sl.security_group_id = l.security_group_id',
'      ) as c,',
'      (',
'          select count(*)',
'            from wwv_flow_list_items li',
'           where li.list_id           = l.id',
'             and li.flow_id           = l.flow_id',
'             and li.security_group_id = l.security_group_id',
'      ) as list_item_count,',
'      l.id as list_id',
'  from wwv_flow_lists l',
' where l.flow_id = :fb_flow_id',
'   and l.security_group_id = :flow_security_group_id',
''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(48551809017399629)
,p_name=>'List Utilization'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(48552004606399636)
,p_db_column_name=>'LINK'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Name'
,p_column_link=>'f?p=&APP_ID.:4050:&SESSION.::&DEBUG.::F4000_P4050_LIST_ID:#LIST_ID#'
,p_column_linktext=>'#LINK#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(48552115184399639)
,p_db_column_name=>'C'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'References'
,p_column_link=>'f?p=&APP_ID.:417:&SESSION.::&DEBUG.:RIR,CIR:IR_LIST_ID,F4000_LAST_VIEW:#LIST_ID#,156'
,p_column_linktext=>'#C#'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(48552225361399641)
,p_db_column_name=>'LIST_ITEM_COUNT'
,p_display_order=>22
,p_column_identifier=>'C'
,p_column_label=>'List Entries'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(48552315666399642)
,p_db_column_name=>'LIST_ID'
,p_display_order=>32
,p_column_identifier=>'D'
,p_column_label=>'List_Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(48552523817400257)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1286528218536643'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'LINK:C:LIST_ITEM_COUNT'
,p_sort_column_1=>'LINK'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(188939407336885460)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(48551711725399629)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:156:&SESSION.::&DEBUG.:156,RIR::'
);
end;
/
prompt --application/pages/page_00158
begin
wwv_flow_imp_page.create_page(
 p_id=>158
,p_name=>'Create Region Template - New Templates'
,p_alias=>'CREATE-REGION-TEMPLATE-NEW-TEMPLATES'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Region Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47962017388900492)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(177853322975972315)
,p_name=>'Create Region Templates'
,p_template=>wwv_flow_imp.id(42025417508627628)
,p_display_sequence=>100
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  ',
'id,',
'flow_id, ',
'PAGE_PLUG_TEMPLATE_NAME from_name,',
'wwv_flow_lang.system_message(''F4000.P158.COPY_OF'',PAGE_PLUG_TEMPLATE_NAME) to_name,',
'''N'' Sub',
'from wwv_flow_page_plug_templates',
'where flow_id = :F4000_P4320_COPY_FROM_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'and theme_id = :P498_COPY_FROM_THEME'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'1'
,p_query_no_data_found=>'<font class="fielddata">No region templates found.</font>'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(150874821141661366)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(150874408588661365)
,p_query_column_id=>2
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>2
,p_column_heading=>'Application'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(291264412909256044)
,p_query_column_id=>3
,p_column_alias=>'FROM_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'From Name'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(150877308719670809)
,p_query_column_id=>4
,p_column_alias=>'TO_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'To Name'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>50
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(291264526399256044)
,p_query_column_id=>5
,p_column_alias=>'SUB'
,p_column_display_sequence=>5
,p_column_heading=>'Copy?'
,p_use_as_row_header=>'N'
,p_display_as=>'SELECT_LIST_FROM_LOV'
,p_named_lov=>wwv_flow_imp.id(150847232623403358)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'NO'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(177859514348976310)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(320074633987)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(177861716897978727)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47962017388900492)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(275752210)
,p_button_sequence=>2
,p_button_plug_id=>wwv_flow_imp.id(47962017388900492)
,p_button_name=>'Copy'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy Region Templates'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(177866831095982858)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(47962017388900492)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(279888699)
,p_branch_name=>'Go To Page 4003'
,p_branch_action=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.:RP:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(275752210)
,p_branch_sequence=>22
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(589948147255621426)
,p_branch_action=>'f?p=&APP_ID.:498:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(177866831095982858)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(74592512361547109)
,p_name=>'P158_THEME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(177853322975972315)
,p_prompt=>'Copy to Theme:'
,p_source=>'P498_COPY_TO_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies a collection of templates which define the look and feel of the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(291367819751276943)
,p_validation_name=>'IsOneSelected'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  for i in 1..wwv_flow.g_f01.count loop',
'    if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'') then',
'      return true;',
'    end if;',
'  end loop;',
'  return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'You must select at least one template to be copied.',
''))
,p_when_button_pressed=>wwv_flow_imp.id(275752210)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(291369800835280950)
,p_validation_name=>'IsDupeName'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_found_name varchar2(2000) := null;',
'begin',
'for i in 1..wwv_flow.g_f03.count loop',
'   if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'')',
'      then',
'      for c1 in ( select page_plug_template_name',
'                  from wwv_flow_page_plug_templates',
'                  where flow_id = :FB_FLOW_ID',
'                  and security_group_id = (select PROVISIONING_COMPANY_ID',
'                                           from wwv_flow_companies',
'                                           where SHORT_NAME = :COMPANY)',
'                  and page_plug_template_name = wwv_flow.g_f02(i) ) loop',
'         if c1.page_plug_template_name is not null then ',
'            if l_found_name is null then ',
'              l_found_name := c1.page_plug_template_name;',
'            else ',
'              l_found_name := l_found_name||'', ''||c1.page_plug_template_name;',
'            end if;',
'         end if;',
'      end loop;',
'   end if;',
'end loop;',
'',
'if l_found_name is not null then ',
'return wwv_flow_lang.system_message(''F4000.TEMPLATE_NAME_ALREADY_EXISTS'',',
'                                    l_found_name);',
'end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_when_button_pressed=>wwv_flow_imp.id(275752210)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(589947908221621424)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(177861716897978727)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(589948010092621425)
,p_event_id=>wwv_flow_imp.id(589947908221621424)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(278815634)
,p_process_sequence=>1
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Region Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_template_id number;',
'begin',
'',
'for i in 1..wwv_flow.g_f01.count loop',
'  l_template_id := wwv_flow_id.next_val;',
'',
'  if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'') then',
'    wwv_flow_templates_util.copy_plug (',
'      p_copy_from_flow_id    => :F4000_P4320_COPY_FROM_FLOW_ID,',
'      p_flow_id              => :FB_FLOW_ID,',
'      p_from_template_id     => wwv_flow.g_f01(i),',
'      p_to_template_name     => wwv_flow.g_f02(i),',
'      p_to_template_id       => l_template_id,',
'      p_to_theme_id          => :p158_theme,',
'      p_include_subscription => (wwv_flow.g_f03(i)=''SUBSCRIBE'')',
'      );',
'    if wwv_flow.g_f03(i) = ''SUBSCRIBE'' then',
'      wwv_flow_copy_metadata.subscribe_region_template (',
'        p_master_template_id      => wwv_flow.g_f01(i),',
'        p_subscribing_template_id => l_template_id',
'      );',
'    end if;    ',
'  end if;',
'end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying region template(s).#SQLERRM_TEXT#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(275752210)
,p_process_success_message=>'Region template(s) copied.'
,p_internal_uid=>278815634
);
end;
/
prompt --application/pages/page_00159
begin
wwv_flow_imp_page.create_page(
 p_id=>159
,p_name=>'Create List Template - New Templates'
,p_alias=>'CREATE-LIST-TEMPLATE-NEW-TEMPLATES'
,p_page_mode=>'MODAL'
,p_step_title=>'Create List Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(178279512234518293)
,p_name=>'Create List Template'
,p_template=>wwv_flow_imp.id(42025417508627628)
,p_display_sequence=>100
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'  id,',
'  flow_id, ',
'  list_template_name from_name,',
'  wwv_flow_lang.system_message(''F4000.P158.COPY_OF'',list_template_name) to_name,',
'  ''N'' sub',
'  from wwv_flow_list_templates ',
'  where flow_id = :F4000_P4069_COPY_FROM_FLOW_ID',
'  and security_group_id = :flow_security_group_id',
'  and theme_id = :P412_COPY_FROM_THEME'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'<font class="fielddata">No list template found.</font>'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(289893601622920030)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(289893710237920030)
,p_query_column_id=>2
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>2
,p_column_heading=>'Application'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(289893814618920030)
,p_query_column_id=>3
,p_column_alias=>'FROM_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'From Name'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(289893931542920031)
,p_query_column_id=>4
,p_column_alias=>'TO_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'To Name'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>40
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(289894002600920031)
,p_query_column_id=>5
,p_column_alias=>'SUB'
,p_column_display_sequence=>5
,p_column_heading=>'Copy?'
,p_use_as_row_header=>'N'
,p_display_as=>'SELECT_LIST_FROM_LOV'
,p_named_lov=>wwv_flow_imp.id(150847232623403358)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'NO'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(178283102961522594)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(320074633987)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(186374530491150301)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(178289517345529249)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_imp.id(186374530491150301)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(12260552258)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(186374530491150301)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy List Templates'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(178292114359537840)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(186374530491150301)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(154533528577128011)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(585125414403099817)
,p_branch_action=>'f?p=&APP_ID.:412:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(178292114359537840)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(74789601635619728)
,p_name=>'P159_THEME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(178279512234518293)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&P412_COPY_TO_THEME.'
,p_prompt=>'Copy to Theme:'
,p_source=>'&P412_COPY_TO_THEME.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies a collection of templates which define the look and feel of the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(289900226518974544)
,p_validation_name=>'template selected to copy'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  for i in 1..wwv_flow.g_f01.count loop',
'    if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'') then',
'      return true;',
'    end if;',
'  end loop;',
'  return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'You must select at least one template to be copied.'
,p_when_button_pressed=>wwv_flow_imp.id(12260552258)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(289918828615126548)
,p_validation_name=>'NoDupeNames'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_found_name varchar2(2000) := null;',
'begin',
'for i in 1..wwv_flow.g_f01.count loop',
'   if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'')',
'      then',
'      for c1 in ( select list_template_name',
'                  from WWV_FLOW_LIST_TEMPLATES',
'                  where flow_id = :FB_FLOW_ID',
'                  and security_group_id = (select PROVISIONING_COMPANY_ID',
'                                           from wwv_flow_companies',
'                                           where SHORT_NAME = :COMPANY)',
'                  and list_template_name = wwv_flow.g_f02(i) ) loop',
'         if c1.list_template_name is not null then ',
'            if l_found_name is null then ',
'              l_found_name := c1.list_template_name;',
'            else ',
'              l_found_name := l_found_name||'', ''||c1.list_template_name;',
'            end if;',
'         end if;',
'      end loop;',
'   end if;',
'end loop;',
'',
'if l_found_name is not null then ',
'return wwv_flow_lang.system_message(''F4000.TEMPLATE_NAME_ALREADY_EXISTS'',',
'                                    l_found_name);',
'end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_when_button_pressed=>wwv_flow_imp.id(12260552258)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(585125239274099815)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(178289517345529249)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(585125367701099816)
,p_event_id=>wwv_flow_imp.id(585125239274099815)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(12282618489)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'copy template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_template_id number;',
'begin',
'',
'for i in 1..wwv_flow.g_f01.count loop',
'  l_template_id := wwv_flow_id.next_val;',
'',
'  if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'') then',
'    wwv_flow_templates_util.copy_list_template (',
'      p_copy_from_flow_id => :F4000_P4069_COPY_FROM_FLOW_ID,',
'      p_to_flow_id => :FB_FLOW_ID,',
'      p_from_template_id => wwv_flow.g_f01(i),',
'      p_to_template_name => wwv_flow.g_f02(i),',
'      p_to_template_id   => l_template_id,',
'      p_to_theme_id      => :p159_theme, ',
'      p_include_subscription => (wwv_flow.g_f03(i)=''SUBSCRIBE'')',
'    );',
'    if wwv_flow.g_f03(i) = ''SUBSCRIBE'' then',
'      wwv_flow_copy_metadata.subscribe_list_template (',
'        p_master_template_id         => wwv_flow.g_f01(i),',
'        p_subscribing_template_id    => l_template_id',
'      );',
'    end if;',
'  end if;',
'end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying list template(s).'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(12260552258)
,p_process_success_message=>'List template(s) copied.'
,p_internal_uid=>12282618489
);
end;
/
prompt --application/pages/page_00160
begin
wwv_flow_imp_page.create_page(
 p_id=>160
,p_name=>'Dashboard'
,p_alias=>'DASHBOARD'
,p_step_title=>'Dashboard'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'No help is available for this page.'
,p_page_component_map=>'04'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(176250390163916903)
,p_plug_name=>'Native Region Component Utilization'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_location=>null
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_num_rows=>15
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(176250498555916904)
,p_region_id=>wwv_flow_imp.id(176250390163916903)
,p_chart_type=>'bar'
,p_animation_on_display=>'none'
,p_animation_on_data_change=>'none'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'none'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(176250538400916905)
,p_chart_id=>wwv_flow_imp.id(176250498555916904)
,p_seq=>10
,p_name=>'Native Component Utilization'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(',
'           trim(substr(plug_source_type,8)),',
'           ''STATIC'', wwv_flow_lang.system_message(''STATIC_REGION''),',
'           ''LIST'', wwv_flow_lang.system_message(''LIST_REGION''),',
'           ''SQL_REPORT'', wwv_flow_lang.system_message(''CLASSIC_REPORT''),',
'           ''IR'', wwv_flow_lang.system_message(''INTERACTIVE_REPORT''),',
'           ''IG'', wwv_flow_lang.system_message(''INTERACTIVE_GRID''),',
'           ''DISPLAY_SELECTOR'', wwv_flow_lang.system_message(''REGION_DISPLAY_SELECTOR''),',
'           ''TABFORM'', wwv_flow_lang.system_message(''TABULAR_FORM''),',
'           ''JET_CHART'', wwv_flow_lang.system_message(''JET_CHART''),',
'           ''JSTREE'', wwv_flow_lang.system_message(''JSTREE''),',
'           ''BREADCRUMB'', wwv_flow_lang.system_message(''BREADCRUMB_REGION''),',
'           ''CSS_CALENDAR'', wwv_flow_lang.system_message(''CSS_CALENDAR''),',
'           ''CALENDAR'', wwv_flow_lang.system_message(''CLASSIC_CALENDAR''),',
'           ''TREE'', wwv_flow_lang.system_message(''CLASSIC_TREE''),',
'           ''HELP_TEXT'', wwv_flow_lang.system_message(''HELP_TEXT''),',
'           ''JQM_COLUMN_TOGGLE'', wwv_flow_lang.system_message(''JQM COLUMN TOGGLE''),',
'           ''JQM_REFLOW'', wwv_flow_lang.system_message(''JQM REFLOW''),',
'           ''SVG_CHART'', wwv_flow_lang.system_message(''SVG CHART''),',
'           ''SIMPLE_CHART'', wwv_flow_lang.system_message(''SIMPLE_CHART''),',
'           ''PLSQL'', wwv_flow_lang.system_message(''PLSQL_REGION''),',
'           ''DATA_UPLOAD_COLUMN_MAPPING'',wwv_flow_lang.system_message(''DATA_UPLOAD_COLUMN_MAPPING''),',
'           ''JQM_LIST_VIEW'',wwv_flow_lang.system_message(''JQM_LIST_VIEW''),',
'           ''CARDS'',wwv_flow_lang.system_message(''REGION_NAME.NATIVE_CARDS''),',
'           ''FACETED_SEARCH'',wwv_flow_lang.system_message(''REGION_NAME.NATIVE_FACETED_SEARCH''),',
'           ''SMART_FILTERS'',wwv_flow_lang.system_message(''REGION_NAME.NATIVE_SMART_FILTERS''),',
'           ''FORM'',wwv_flow_lang.system_message(''FORM''),',
'           replace(substr(plug_source_type,8),''_'','' ''))',
'           region_type, ',
'       count(*) region_type_count',
'from   wwv_flow_page_plugs r',
'where  plug_source_type not like ''PLUGIN%'' and ',
'       security_group_id = :flow_security_group_id',
'group by substr(plug_source_type,8)',
'order by 2 desc',
''))
,p_max_row_count=>100
,p_items_value_column_name=>'REGION_TYPE_COUNT'
,p_items_label_column_name=>'REGION_TYPE'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>true
,p_items_label_position=>'auto'
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(176250637211916906)
,p_chart_id=>wwv_flow_imp.id(176250498555916904)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(176250798597916907)
,p_chart_id=>wwv_flow_imp.id(176250498555916904)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(698803155967413324)
,p_plug_name=>'Page Count by Application'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--shadowScroll:a-Region--noPadding:h480'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select application_id||'': ''||application_name d, (select count(*) from apex_application_pages p where p.application_id = a.application_id) c ',
'from apex_applications a',
'where WORKSPACE_ID = :FLOW_SECURITY_GROUP_ID ',
'order by 2 desc'))
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.HTML5_BAR_CHART'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'INITIALS',
  'attribute_02', 'D',
  'attribute_04', 'C',
  'attribute_11', 'VALUE',
  'attribute_14', '25',
  'attribute_15', 'TEXT',
  'attribute_16', 'ABSOLUTE',
  'attribute_17', 'DEFAULT',
  'attribute_18', 'AROUND')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(698804112339413334)
,p_plug_name=>'Applications'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_session varchar2(255) := :APP_SESSION;',
'    l_security_group_id number := :FLOW_SECURITY_GROUP_ID;',
'begin',
'    -- applications',
'    for c1 in ( select /* APEX4000160SR66 */ count(*) applications',
'                from wwv_flows',
'                where security_group_id = l_security_group_id',
'            ) loop',
'',
'            sys.htp.p(''<div class="a-BadgeChart">'');',
'            sys.htp.p(''  <a href="''|| wwv_flow_page_api.get_url ( p_page => 1500, p_session => l_session ) ||''" title="''||wwv_flow_lang.system_message(''F4000_APPLICATIONS'')||''" class="a-BadgeChart-link">'');',
'            sys.htp.p(''    <span class="a-BadgeChart-value">''||c1.applications||'' </span> '');',
'            sys.htp.p(''  </a>'');',
'            sys.htp.p(''  <div class="a-BadgeChart-text">'');',
'            sys.htp.p(''    <span class="a-BadgeChart-label">''||wwv_flow_lang.system_message(''F4000_APPLICATIONS'')||''</span>'');',
'            sys.htp.p(''    <span class="a-BadgeChart-desc">'');',
'            sys.htp.p(''    </span>'');',
'            sys.htp.p(''  </div>'');',
'            sys.htp.p(''</div>'');',
'    end loop;',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_column_width=>'apex-col--bottomBorder'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(698804288016413335)
,p_plug_name=>'Total Pages'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_session varchar2(255) := :APP_SESSION;',
'    l_security_group_id number := :FLOW_SECURITY_GROUP_ID;',
'begin',
'    -- applications',
'    for c1 in ( select /* APEX4000160SR66 */ count(*) pages',
'                from wwv_flow_steps',
'                where security_group_id = l_security_group_id',
'            ) loop',
'',
'            sys.htp.p(''<div class="a-BadgeChart">'');',
'            sys.htp.p(''  <a href="#" title="''||wwv_flow_lang.system_message(''CONFIRM.PAGES'')||''" class="a-BadgeChart-link">'');',
'            sys.htp.p(''    <span class="a-BadgeChart-value">''||to_char(c1.pages,''999G999G990'')||'' </span> '');',
'            sys.htp.p(''  </a>'');',
'            sys.htp.p(''  <div class="a-BadgeChart-text">'');',
'            sys.htp.p(''    <span class="a-BadgeChart-label">''||wwv_flow_lang.system_message(''PAGES'')||''</span>'');',
'            sys.htp.p(''    <span class="a-BadgeChart-desc">'');',
'            sys.htp.p(''    </span>'');',
'            sys.htp.p(''  </div>'');',
'            sys.htp.p(''</div>'');',
'    end loop;',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_column_width=>'apex-col--bottomBorder apex-col--leftBorder'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(713095952865315417)
,p_plug_name=>'Page Events'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--slimPadding:h480'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_location=>null
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_num_rows=>15
,p_plug_column_width=>'apex-col--bottomBorder apex-col--leftBorder'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(713096089636315418)
,p_region_id=>wwv_flow_imp.id(713095952865315417)
,p_chart_type=>'lineWithArea'
,p_height=>'414'
,p_animation_on_display=>'none'
,p_animation_on_data_change=>'none'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'none'
,p_stack=>'off'
,p_stack_label=>'off'
,p_spark_chart=>'N'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>false
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>false
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_time_axis_type=>'enabled'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(713096128083315419)
,p_chart_id=>wwv_flow_imp.id(713096089636315418)
,p_seq=>10
,p_name=>'Page Events'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  ',
'    to_date(to_char(time_stamp,''DDMMYYYYHH24''), ''DDMMYYYYHH24'') day,',
'    count(*) page_events',
'from WWV_FLOW_ACTIVITY_LOG l',
'where time_stamp > sysdate - 7 and security_group_id = :FLOW_SECURITY_GROUP_ID',
'group by to_date(to_char(time_stamp,''DDMMYYYYHH24''), ''DDMMYYYYHH24'')',
'order by 1'))
,p_items_value_column_name=>'PAGE_EVENTS'
,p_items_label_column_name=>'DAY'
,p_color=>'#EB4C4C'
,p_line_style=>'solid'
,p_line_type=>'auto'
,p_marker_rendered=>'auto'
,p_marker_shape=>'auto'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(713096385359315421)
,p_chart_id=>wwv_flow_imp.id(713096089636315418)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(713096232914315420)
,p_chart_id=>wwv_flow_imp.id(713096089636315418)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(713096464448315422)
,p_plug_name=>'Most Active Pages'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--slimPadding:h480'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_location=>null
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_num_rows=>15
,p_plug_column_width=>'apex-col--leftBorder'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(713096515470315423)
,p_region_id=>wwv_flow_imp.id(713096464448315422)
,p_chart_type=>'bar'
,p_height=>'414'
,p_animation_on_display=>'none'
,p_animation_on_data_change=>'none'
,p_orientation=>'vertical'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'none'
,p_stack=>'off'
,p_stack_label=>'off'
,p_spark_chart=>'N'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(713096608011315424)
,p_chart_id=>wwv_flow_imp.id(713096515470315423)
,p_seq=>10
,p_name=>'Page Hits'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * from (',
'    select /* APEX4350P190aMJH */',
'          flow_id||'':''||step_id d,',
'          rnk r,',
'          cnt, ',
'          round(( rtr * 100),2) rtr',
'      from(',
'        select flow_id,step_id,cnt,',
'               dense_rank() over(order by cnt desc) rnk,',
'               ratio_to_report(cnt) over () rtr',
'          from (',
'            select flow_id,step_id,count(*) cnt',
'              from wwv_flow_activity_log l',
'             where security_group_id = :FLOW_SECURITY_GROUP_ID and page_mode != ''A''',
'             group by flow_id,step_id',
'            having exists',
'                     (select 1',
'                        from wwv_flows',
'                       where id = l.flow_id',
'                         and security_group_id = :FLOW_SECURITY_GROUP_ID))',
'          ) xf',
'    order by 4 desc',
') where rownum < 6'))
,p_items_value_column_name=>'CNT'
,p_items_label_column_name=>'D'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(713096792414315425)
,p_chart_id=>wwv_flow_imp.id(713096515470315423)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_tick_label_rotation=>'auto'
,p_tick_label_position=>'outside'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(713096842246315426)
,p_chart_id=>wwv_flow_imp.id(713096515470315423)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_type=>'decimal'
,p_decimal_places=>0
,p_format_scaling=>'none'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'on'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(713096981940315427)
,p_plug_name=>'Developer Activity (Last 2 Days)'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--slimPadding:h480'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_location=>null
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_num_rows=>15
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(713097091860315428)
,p_region_id=>wwv_flow_imp.id(713096981940315427)
,p_chart_type=>'pie'
,p_height=>'414'
,p_animation_on_display=>'none'
,p_animation_on_data_change=>'none'
,p_data_cursor=>'auto'
,p_data_cursor_behavior=>'auto'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_connect_nulls=>'Y'
,p_value_position=>'auto'
,p_value_format_type=>'decimal'
,p_value_decimal_places=>0
,p_value_format_scaling=>'auto'
,p_sorting=>'label-asc'
,p_fill_multi_series_gaps=>true
,p_tooltip_rendered=>'Y'
,p_show_series_name=>true
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_pie_other_threshold=>0
,p_pie_selection_effect=>'highlight'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function( options ){ ',
'',
'    this.pieSliceLabel = function(dataContext){',
'        var percent = Math.round(dataContext.value/dataContext.totalValue*100);',
'        return dataContext.seriesData.name +" "+percent+"% ("+dataContext.value+")";',
'    }',
'',
'    options.dataLabel = pieSliceLabel; ',
'    return options; ',
'}',
'',
'',
'       '))
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(713097103881315429)
,p_chart_id=>wwv_flow_imp.id(713097091860315428)
,p_seq=>10
,p_name=>'New'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  flow_user developer,',
'  count(*) page_views',
'from   ',
'  wwv_flow_builder_audit_trail',
'where  ',
'  audit_date > sysdate - 2 and ',
'  security_group_id = :flow_security_group_id',
'group by ',
'  flow_user'))
,p_items_value_column_name=>'PAGE_VIEWS'
,p_items_label_column_name=>'DEVELOPER'
,p_items_label_rendered=>true
,p_items_label_position=>'outsideSlice'
,p_items_label_display_as=>'LABEL'
,p_threshold_display=>'onIndicator'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(787290833226287714)
,p_plug_name=>'About'
,p_region_css_classes=>'a-Region--stacked a-Region--padded a-Region--flush a-Region--sideRegion'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Metrics about applications in your workspace.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(787393288932481892)
,p_plug_name=>'Cross Application Reports'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(702923103587108064)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
end;
/
prompt --application/pages/page_00161
begin
wwv_flow_imp_page.create_page(
 p_id=>161
,p_name=>'Create Legacy Calendar Template - Create Method'
,p_alias=>'CREATE-LEGACY-CALENDAR-TEMPLATE-CREATE-METHOD'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Legacy Calendar Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(18898316360877050)
,p_plug_name=>'Create Legacy Calendar Template'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<p>You can create templates from scratch or copy them from another application. Copying a template provides you with a framework that you can modify.</p> '
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(18899106801877060)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(19035021988626357)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(186386405791285108)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(18899911747877068)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(186386405791285108)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(18900324527877072)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(186386405791285108)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(41910113670602318)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(186386405791285108)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(18910702334901555)
,p_branch_action=>'f?p=&FLOW_ID.:349:&SESSION.::&DEBUG.:RP,349::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(18900324527877072)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P161_TYPE'
,p_branch_condition_text=>'BLANK'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(38360630082953713)
,p_branch_action=>'f?p=&FLOW_ID.:468:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(18900324527877072)
,p_branch_sequence=>40
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P161_TYPE'
,p_branch_condition_text=>'COPY'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(589886436114923009)
,p_branch_action=>'f?p=&APP_ID.:162:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(41910113670602318)
,p_branch_sequence=>50
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18900707135877074)
,p_name=>'P161_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(18898316360877050)
,p_item_default=>'COPY'
,p_prompt=>'Create Calendar Template:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'CREATE.TEMPLATE.OPTS'
,p_lov=>'.'||wwv_flow_imp.id(88108326304250090)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_escape_on_http_output=>'N'
,p_help_text=>'Select the method by which you wish to create a new calendar template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(589886277488923007)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(18899911747877068)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(589886312228923008)
,p_event_id=>wwv_flow_imp.id(589886277488923007)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00162
begin
wwv_flow_imp_page.create_page(
 p_id=>162
,p_name=>'Create Template'
,p_alias=>'CREATE-TEMPLATE'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17578608235069855)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(106501409747300331)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(19408132682545305)
,p_plug_name=>'Create Template'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47945303593650508)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(19417212643567978)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47945303593650508)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(19415731905564047)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47945303593650508)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(19433615769644543)
,p_branch_action=>'P162_TEMPLATE_TYPE'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_URL_IDENT_BY_ITEM'
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(19411632467554734)
,p_name=>'P162_TEMPLATE_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(19408132682545305)
,p_prompt=>'Template Type:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''f?p=4000:920:&''||',
'       ''SESSION.:::920,921,922,923,924,26,144'' x ',
'from dual'))
,p_source_type=>'QUERY'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'TEMPLATE_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(84868022945400324)||'.'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the type of template you wish to create.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'S'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(589948349959621428)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(19417212643567978)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(589948446304621429)
,p_event_id=>wwv_flow_imp.id(589948349959621428)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00163
begin
wwv_flow_imp_page.create_page(
 p_id=>163
,p_name=>'Import - File Import Confirmation'
,p_alias=>'IMPORT-FILE-IMPORT-CONFIRMATION'
,p_step_title=>'Import - File Import Confirmation'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215592520464926917)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_install.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44690514705686202)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(53544817709944619)
,p_plug_name=>'Successfully Imported File'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The file has been imported successfully.</p>',
'<p>If you wish to install now, click the <strong>Next</strong> button. You can also install this file at a later time by',
'navigating to the Export Repository.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(226318928584082367)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(399849897040726767)
,p_plug_display_sequence=>30
,p_list_id=>wwv_flow_imp.id(38836703962860678)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747138052634138153)
,p_plug_name=>'Import'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(75642906699411821)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(44690514705686202)
,p_button_name=>'CANCEL1'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:1500:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(53562032001005557)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(44690514705686202)
,p_button_name=>'Install'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(217434614987057517)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(44690514705686202)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:460:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(53562303043005561)
,p_branch_action=>'f?p=&APP_ID.:49:&SESSION.::&DEBUG.:49:P49_FILE_ID:&P163_FILE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(53562032001005557)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P460_FILE_TYPE'
,p_branch_condition_text=>'FLOW_EXPORT'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(77826408668266575)
,p_branch_name=>'Go To Page 67'
,p_branch_action=>'f?p=&APP_ID.:67:&SESSION.::&DEBUG.::P67_FILE_ID:&P163_FILE_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(53562032001005557)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P460_FILE_TYPE'
,p_branch_condition_text=>'PAGE_EXPORT'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(141394706662121859)
,p_branch_action=>'f?p=&APP_ID.:253:&SESSION.::&DEBUG.::P253_FILE_ID:&P163_FILE_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(53562032001005557)
,p_branch_sequence=>50
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P460_FILE_TYPE'
,p_branch_condition_text=>'THEME'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(160720230953218415)
,p_branch_action=>'f?p=&APP_ID.:321:&SESSION.::&DEBUG.::P321_FILE_ID:&P163_FILE_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(53562032001005557)
,p_branch_sequence=>60
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P460_FILE_TYPE'
,p_branch_condition_text=>'UI_DEFAULTS'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(30416132128215446)
,p_branch_name=>'Go To Page 4450'
,p_branch_action=>'f?p=&APP_ID.:4450:&SESSION.::&DEBUG.:4450:P4450_FILE_ID:&P163_FILE_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(53562032001005557)
,p_branch_sequence=>80
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P460_FILE_TYPE'
,p_branch_condition_text=>'PLUGIN'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(472715209002804237)
,p_branch_action=>'f?p=&APP_ID.:929:&SESSION.::&DEBUG.::P929_FILE_ID:&P163_FILE_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>90
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P460_FILE_TYPE'
,p_branch_condition_text=>'FEEDBACK'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2717654105216211)
,p_branch_name=>'Go To Page 1966'
,p_branch_action=>'f?p=&APP_ID.:1966:&SESSION.::&DEBUG.:1966:P1966_FILE_ID:&P163_FILE_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>100
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P460_FILE_TYPE'
,p_branch_condition_text=>'CATALOG'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(53575930756090336)
,p_name=>'P163_FILE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(53544817709944619)
,p_prompt=>'File Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(53792028070788310)
,p_validation_name=>'only internal can import company'
,p_validation_sequence=>10
,p_validation=>':flow_security_group_id = 10'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Only internal workspace can install workspace information.'
,p_validation_condition=>'P460_FILE_TYPE'
,p_validation_condition2=>'COMPANY_EXPORT'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(53562032001005557)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00164
begin
wwv_flow_imp_page.create_page(
 p_id=>164
,p_name=>'Export Page'
,p_alias=>'EXPORT-PAGE'
,p_step_title=>'Export Page'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213300727323081712)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_export_pg.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6211767917501887)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(12802829107)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6610932338692101)
,p_plug_name=>'Export Page'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(14415268478998955)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Export the selected page. Pages may reference shared components to be exported. To export your entire application you need to do a complete application export. Exporting every page is not the same as exporting an application.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(63369314358236504)
,p_plug_name=>'Export Settings'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_plug_grid_column_span=>8
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(489128382244340195)
,p_plug_name=>'Choose Application'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_grid_column_span=>8
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_plug_read_only_when=>'FB_FLOW_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(6611021093692102)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(6610932338692101)
,p_button_name=>'reset_page'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:164:&SESSION.::&DEBUG.:164::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(47047810549366053)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(6610932338692101)
,p_button_name=>'ExportMultiplePages'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Export'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2806600154602626)
,p_branch_name=>'Go To Page 164'
,p_branch_action=>'f?p=&APP_ID.:164:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1809303338284935)
,p_name=>'P164_ORIGINAL_IDS'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(63369314358236504)
,p_item_default=>'N'
,p_prompt=>'Original IDs'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify whether the export file should contain the application component IDs as of now or as of the last import of this application. Available options include:',
'<p />',
'<ul>',
'<li><strong>On</strong> includes the IDs as of the last import.</li>',
'<li><strong>Off</strong> includes the current IDs of the components.</li>',
'</ul>',
'<p />',
'<p />',
'Using Original IDs can be beneficial for various purposes, including:',
'<p />',
'<ul>',
'<li><strong>Readable Format:</strong> Simplify comparisons between different versions of app components and pages. Minimize changes to version controlled export files.</li>',
'<li><strong>Shared Component Subscriptions:</strong> Ensure subscribed components stay linked to a source app when it is replaced with an updated version.</li>',
'</ul>',
'<p />'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2600659890771621)
,p_name=>'P164_INCLUDE_READABLE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(63369314358236504)
,p_item_default=>'N'
,p_prompt=>'Include Readable Format'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify whether the export file should include the human-readable (YAML) version of the page meta-data.',
'Use it to identify and review differences between versions of a page when checked into a Version Control System.',
'Available options include:',
'<p />',
'<ul>',
'<li><strong>On</strong> includes the human-readable file.</li>',
'<li><strong>Off</strong> excludes the human-readable file.</li>',
'</ul>',
'<p />'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2806207007602622)
,p_name=>'P164_MPAGE_FILE_CHARSET'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(63369314358236504)
,p_prompt=>'File Character Set'
,p_source=>'return lower(trim(sys.owa_util.get_cgi_env(''REQUEST_IANA_CHARSET'')));'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'I18N_IANA_CHARSET'
,p_lov=>'.'||wwv_flow_imp.id(144796827445692396)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the character set in which the export file will be encoded.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2806489626602624)
,p_name=>'P164_INCLUDE_SQL'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(63369314358236504)
,p_item_default=>'Y'
,p_prompt=>'Include Installable SQL File'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify whether the export file should include the installable SQL file for the page.',
'Available options include:',
'<p />',
'<ul>',
'<li><strong>On</strong> includes the installable SQL file.</li>',
'<li><strong>Off</strong> excludes the installable SQL file.</li>',
'</ul>',
'<p />'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2806531348602625)
,p_name=>'P164_FLASHBACK_MIN_AGO'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(63369314358236504)
,p_prompt=>'As of'
,p_post_element_text=>'<span class="fielddata">minutes ago</span>'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>4
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Specify a time in minutes to go to back to for your export. This option enables you to go back in time in your application, perhaps to get back a deleted object.</div>',
'',
'<div class="htmldbInfoBodyP">This utility uses the <code>dbms_flashback</code> package. The timestamp to SCN (system change number) mapping is refreshed approximately every 5 minutes, so you may have to wait that long to get to the version you are lo'
||'oking for. The time undo information is retained by the startup parameter <code>undo_retention</code> (default 3 hrs), but this only influences the size of the undo tablespace.</div>',
'<div class="htmldbInfoBodyP">While two databases may have the same <code>undo_retention</code> parameter, you can go back much further in time on the database with less transactions since the transactions are not filling the undo tablespace, forcing '
||'older data to be archived.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3805044853471212)
,p_name=>'P164_SPLIT'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(63369314358236504)
,p_item_default=>'N'
,p_prompt=>'Split into Multiple Files'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select this option to export separate SQL files for the page, shared components, and so forth.',
'Available options include:',
'<p />',
'<ul>',
'<li><strong>On</strong> to export as a ZIP archive with separate SQL files.</li>',
'<li><strong>Off</strong> to export as a single SQL file for the page.</li>',
'</ul>',
'<p />'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5935360614481330)
,p_name=>'P164_AUDIT_INFO'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(63369314358236504)
,p_item_default=>'NONE'
,p_prompt=>'Audit Information'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'AUDIT INFO DETAIL'
,p_lov=>'.'||wwv_flow_imp.id(1726678227351632)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'None'
,p_lov_null_value=>'NONE'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the Audit Information to include in the export file. ',
'Audit information includes the Created By User, Created On Date, Changed By User and Changed On Date.<ul> ',
'<li>By default, no audit information is included.</li>',
'<li>Choose Names and Dates to include all audit information.</li>',
'<li>Choose Dates Only to include date information and exclude user details.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(63370290827238547)
,p_name=>'P164_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(489128382244340195)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Application'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PICK_EXPORT_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flows f',
'where  ',
'       security_group_id = :flow_security_group_id and',
'       f.build_status != ''RUN_AND_HIDDEN'' and',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id is null and security_group_id = :flow_security_group_id )',
'       or',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id = f.id and security_group_id = :flow_security_group_id) ',
'order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Application -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the application that contains the page to be exported.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(63374716309262174)
,p_name=>'P164_MEXPORT_PAGE_ID'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(63369314358236504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Page'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST PAGES ESCAPED'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id || '' '' || wwv_flow_escape.html( name ) n, id',
'  from wwv_flow_steps',
' where flow_id           = nvl( :FB_FLOW_ID, :P164_APPLICATION )',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and is_page_pattern   = ''N''',
' order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Page -'
,p_lov_cascade_parent_items=>'P164_APPLICATION'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the page you wish to export.  You can select only one page for export at a time.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2805826092602618)
,p_validation_name=>'P164_APPLICATION Must Have Value'
,p_validation_sequence=>10
,p_validation=>'P164_APPLICATION'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'FB_FLOW_ID'
,p_validation_condition_type=>'ITEM_IS_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(47047810549366053)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3805626005471218)
,p_validation_name=>'must include something to export'
,p_validation_sequence=>20
,p_validation=>'''Y'' in (:P164_INCLUDE_SQL, :P164_INCLUDE_READABLE)'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Export must include at least either the Installable SQL File or the Readable Format.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4205432274056239)
,p_name=>'Display Export Page'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P164_APPLICATION'
,p_condition_element=>'P164_APPLICATION'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2805964923602619)
,p_event_id=>wwv_flow_imp.id(4205432274056239)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(63369314358236504)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2806066315602620)
,p_event_id=>wwv_flow_imp.id(4205432274056239)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(63369314358236504)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2804803140602608)
,p_name=>'Submit'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(47047810549366053)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2804920891602609)
,p_event_id=>wwv_flow_imp.id(2804803140602608)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'ExportMultiplePages'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3805407565471216)
,p_name=>'readable = Y'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P164_INCLUDE_READABLE'
,p_condition_element=>'P164_INCLUDE_READABLE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3805553516471217)
,p_event_id=>wwv_flow_imp.id(3805407565471216)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_name=>'set Original IDs = Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P164_ORIGINAL_IDS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3805784096471219)
,p_name=>'include SQL = Y'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P164_INCLUDE_SQL'
,p_condition_element=>'P164_INCLUDE_SQL'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3805808363471220)
,p_event_id=>wwv_flow_imp.id(3805784096471219)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'show Split'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P164_SPLIT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3805963790471221)
,p_event_id=>wwv_flow_imp.id(3805784096471219)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'hide Split'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P164_SPLIT'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(620127025)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Export Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_export_dev.export_page (',
'    p_application_id    => nvl(:FB_FLOW_ID, :P164_APPLICATION),',
'    p_page_id           => :P164_MEXPORT_PAGE_ID,',
'    p_include_sql       => :P164_INCLUDE_SQL = ''Y'',',
'    p_include_readable  => :P164_INCLUDE_READABLE = ''Y'',',
'    p_split             => :P164_SPLIT = ''Y'' and :P164_INCLUDE_SQL = ''Y'',',
'    p_with_original_ids => :P164_ORIGINAL_IDS = ''Y'',',
'    p_flashback_min_ago => :P164_FLASHBACK_MIN_AGO, ',
'    p_with_audit_info   => :P164_AUDIT_INFO);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error exporting page.'
,p_process_when_button_id=>wwv_flow_imp.id(47047810549366053)
,p_process_success_message=>'Page(s) exported.'
,p_internal_uid=>620127025
);
end;
/
prompt --application/pages/page_00168
begin
wwv_flow_imp_page.create_page(
 p_id=>168
,p_name=>'Create Report Template - New Templates'
,p_alias=>'CREATE-REPORT-TEMPLATE-NEW-TEMPLATES'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Report Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47969405492963267)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(178534708443203867)
,p_name=>'Create Report Template'
,p_template=>wwv_flow_imp.id(42025417508627628)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  id,',
'  flow_id,',
'  ROW_TEMPLATE_NAME from_name,',
'  wwv_flow_lang.system_message(''F4000.P158.COPY_OF'',ROW_TEMPLATE_NAME) to_name,',
'  ''N'' Sub',
'from wwv_flow_row_templates ',
'where flow_id = :F4000_P4321_COPY_FROM_FLOW_ID ',
'  and security_group_id = :flow_security_group_id ',
'  and theme_id = :P343_COPY_FROM_THEME '))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'<font class="fielddata">No report template found.</font>'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(289909810335026626)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(289909909719026626)
,p_query_column_id=>2
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>2
,p_column_heading=>'Application'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(289910015611026626)
,p_query_column_id=>3
,p_column_alias=>'FROM_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'From Name'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(289910105457026626)
,p_query_column_id=>4
,p_column_alias=>'TO_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'To Name'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>40
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(289910226324026626)
,p_query_column_id=>5
,p_column_alias=>'SUB'
,p_column_display_sequence=>5
,p_column_heading=>'Copy?'
,p_use_as_row_header=>'N'
,p_display_as=>'SELECT_LIST_FROM_LOV'
,p_named_lov=>wwv_flow_imp.id(150847232623403358)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'NO'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(178537831722208232)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(320074633987)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(178542728164213645)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47969405492963267)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(395455264)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(47969405492963267)
,p_button_name=>'Copy'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy Report Templates'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(178545305785216600)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(47969405492963267)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(152102513500942314)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(589946142770621406)
,p_branch_action=>'f?p=&APP_ID.:343:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(178545305785216600)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(74734020635596860)
,p_name=>'P168_THEME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(178534708443203867)
,p_prompt=>'Copy to Theme:'
,p_source=>'P343_COPY_TO_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies a collection of templates which define the look and feel of the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(289914212984093608)
,p_validation_name=>'template select to copy'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  for i in 1..wwv_flow.g_f01.count loop',
'    if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'') then',
'      return true;',
'    end if;',
'  end loop;',
'  return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'You must select at least one template to be copied.'
,p_when_button_pressed=>wwv_flow_imp.id(395455264)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(93415326260429643)
,p_validation_name=>'NoDupTemplateNames'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_found_name varchar2(2000) := null;',
'begin',
'for i in 1..wwv_flow.g_f01.count loop',
'   if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'')',
'      then',
'      for c1 in ( select row_template_name',
'                  from WWV_FLOW_ROW_TEMPLATES',
'                  where flow_id = :FB_FLOW_ID',
'                  and security_group_id = (select PROVISIONING_COMPANY_ID',
'                                           from wwv_flow_companies',
'                                           where SHORT_NAME = :COMPANY)',
'                  and row_template_name = wwv_flow.g_f02(i) ) loop',
'         if c1.row_template_name is not null then ',
'            if l_found_name is null then ',
'              l_found_name := c1.row_template_name;',
'            else ',
'              l_found_name := l_found_name||'', ''||c1.row_template_name;',
'            end if;',
'         end if;',
'      end loop;',
'   end if;',
'end loop;',
'',
'if l_found_name is not null then ',
'return wwv_flow_lang.system_message(''F4000.TEMPLATE_NAME_ALREADY_EXISTS'',',
'                                    l_found_name);',
'end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Error.'
,p_when_button_pressed=>wwv_flow_imp.id(395455264)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(589945954508621404)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(178542728164213645)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(589946053808621405)
,p_event_id=>wwv_flow_imp.id(589945954508621404)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(398503355)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Row Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_template_id number;',
'begin',
'',
'for i in 1..wwv_flow.g_f01.count loop',
'',
'  l_template_id := wwv_flow_id.next_val;',
'',
'  if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'') then',
'    wwv_flow_templates_util.copy_row_template (',
'    p_copy_from_flow_id    => :F4000_P4321_COPY_FROM_FLOW_ID,',
'    p_to_flow_id           => :FB_FLOW_ID,',
'    p_from_template_id     => wwv_flow.g_f01(i),',
'    p_to_template_name     => wwv_flow.g_f02(i),',
'    p_to_template_id       => l_template_id,',
'    p_to_theme_id          => :p168_theme,',
'    p_include_subscription => (wwv_flow.g_f03(i)=''SUBSCRIBE'')',
'    );',
'    if wwv_flow.g_f03(i) = ''SUBSCRIBE'' then',
'      wwv_flow_copy_metadata.subscribe_report_template (',
'        p_master_template_id         => wwv_flow.g_f01(i),',
'        p_subscribing_template_id    => l_template_id',
'      );',
'    end if;',
'  end if;',
'end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying report template(s).'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(395455264)
,p_process_success_message=>'Report template(s) copied.'
,p_internal_uid=>398503355
);
end;
/
prompt --application/pages/page_00169
begin
wwv_flow_imp_page.create_page(
 p_id=>169
,p_name=>'List of Values, Edit Null Text'
,p_alias=>'LIST-OF-VALUES-EDIT-NULL-TEXT'
,p_step_title=>'List of Values, Edit Null Text'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213211113434774960)
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
,p_page_component_map=>'01'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47154208064258102)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(203029530177365353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Lists of Values'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(81020318009647954)
,p_name=>'Edit List of Values Null Display Values'
,p_template=>wwv_flow_imp.id(646287526247383209)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P169a */',
'"ID",',
'"FLOW_STEP_ID",',
'"NAME",',
'DISPLAY_AS,',
'LOV_DISPLAY_NULL,',
'"LOV_NULL_TEXT",',
'"LOV_NULL_VALUE"',
'  from WWV_FLOW_STEP_ITEMS',
' where flow_id = :fb_flow_id ',
'   and security_group_id = :flow_security_group_id',
'   and lov is not null ',
'   and (:P169_LOV_NULL_TEXT_CONTAINS is null or',
'        instr(upper(lov_null_text),upper(:P169_LOV_NULL_TEXT_CONTAINS)) > 0) and',
'        (:P169_SHOW is null or :P169_SHOW = ''ALL'' or display_as = ''NATIVE_POPUP_LOV'')',
'   and (:P169_DISPLAY_NULL is null or :P169_DISPLAY_NULL = ''0'' or lov_display_null = :P169_DISPLAY_NULL)',
' order by flow_step_id, name'))
,p_translate_title=>'N'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_item=>'P169_ROWS'
,p_query_num_rows_type=>'ROW_RANGES'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
,p_comment=>'Region generated 14-JUL-2003 17:41:02'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(81020828595647963)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(81020927299647965)
,p_query_column_id=>2
,p_column_alias=>'FLOW_STEP_ID'
,p_column_display_sequence=>2
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&FLOW_ID.:4500:#FLOW_SESSION#::::FB_FLOW_PAGE_ID:#FLOW_STEP_ID#'
,p_column_linktext=>'#FLOW_STEP_ID#'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(81021007796647965)
,p_query_column_id=>3
,p_column_alias=>'NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Item'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(138202529261849308)
,p_query_column_id=>4
,p_column_alias=>'DISPLAY_AS'
,p_column_display_sequence=>4
,p_column_heading=>'Display As'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(29353308376249352)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(138207420645882790)
,p_query_column_id=>5
,p_column_alias=>'LOV_DISPLAY_NULL'
,p_column_display_sequence=>5
,p_column_heading=>'Display Null'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(84270019143507704)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(81021102346647965)
,p_query_column_id=>6
,p_column_alias=>'LOV_NULL_TEXT'
,p_column_display_sequence=>6
,p_column_heading=>'Null Text'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>30
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(81021229652647966)
,p_query_column_id=>7
,p_column_alias=>'LOV_NULL_VALUE'
,p_column_display_sequence=>7
,p_column_heading=>'Return Value'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(81025531237652930)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(81025620204652930)
,p_column_sequence=>2
,p_query_column_name=>'FLOW_STEP_ID'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(81025703546652930)
,p_column_sequence=>3
,p_query_column_name=>'NAME'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(138202221502849299)
,p_column_sequence=>4
,p_query_column_name=>'DISPLAY_AS'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(138207116991882788)
,p_column_sequence=>5
,p_query_column_name=>'LOV_DISPLAY_NULL'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(81025825527652930)
,p_column_sequence=>6
,p_query_column_name=>'LOV_NULL_TEXT'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(81025931301652930)
,p_column_sequence=>7
,p_query_column_name=>'LOV_NULL_VALUE'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(187935715440862725)
,p_plug_name=>'List of Value Filters'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-Form--labelsAbove:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(81043404057682918)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(187935715440862725)
,p_button_name=>'P169_GO'
,p_button_static_id=>'P169_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Go'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(188988724554984090)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(187935715440862725)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:169:&SESSION.::&DEBUG.:RP,169::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(81021414803647967)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(187935715440862725)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(81022232708647975)
,p_branch_action=>'f?p=&FLOW_ID.:169:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_comment=>'Generated 14-JUL-2003 17:41:03'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(81042425397679583)
,p_name=>'P169_LOV_NULL_TEXT_CONTAINS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(187935715440862725)
,p_prompt=>'Text Contains'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Search for list of values null text which contains this string. Enter a string and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(138224427514919344)
,p_name=>'P169_DISPLAY_NULL'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(187935715440862725)
,p_prompt=>'Display Null'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_YES_OR_NO'
,p_lov=>'.'||wwv_flow_imp.id(84270019143507704)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- All -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose <strong>Yes</strong> to show lists of values that include a null option. Choose <strong>No</strong> to show lists of values that do not include a null option.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(138229807606951438)
,p_name=>'P169_SHOW'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(187935715440862725)
,p_item_default=>'ALL'
,p_prompt=>'Show'
,p_source=>'ALL'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'SHOW ALL LOV'
,p_lov=>'.'||wwv_flow_imp.id(138231514317962802)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Filter by popup lists of values. Select <strong>Popup Only</strong> and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(180347417064585718)
,p_name=>'P169_ROWS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(187935715440862725)
,p_item_default=>'20'
,p_prompt=>'Rows'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAXIMUM ROWS PER PAGE'
,p_lov=>'.'||wwv_flow_imp.id(84800803131139158)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the number of entries to display and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(81021801411647970)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(81020318009647954)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'ApplyMRU'
,p_attribute_02=>'WWV_FLOW_STEP_ITEMS'
,p_attribute_03=>'ID'
,p_attribute_05=>'flow_id = :FB_FLOW_ID and security_group_id = :WORKSPACE_ID'
,p_process_error_message=>'Error processing update'
,p_process_when_button_id=>wwv_flow_imp.id(81021414803647967)
,p_process_success_message=>'#MRU_COUNT# row(s) updated.'
,p_internal_uid=>81021801411647970
,p_process_comment=>'Generated 14-JUL-2003 17:41:03'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(138223032232911292)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when_button_id=>wwv_flow_imp.id(81043404057682918)
,p_internal_uid=>138223032232911292
);
end;
/
prompt --application/pages/page_00170
begin
wwv_flow_imp_page.create_page(
 p_id=>170
,p_name=>'Web Service References'
,p_alias=>'WEB-SERVICE-REFERENCES'
,p_step_title=>'Web Service References'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11272929095288976)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(11271810048283515)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47844726510922430)
,p_plug_name=>'Web Service References'
,p_region_name=>'WS_REPORT'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'   name as e,',
'   decode( action,',
'           ''NEW_SCHOOL'', wwv_flow_utilities.prepare_url( ''f?p=4000:599:'' || :flow_SESSION || ''::NO::P599_ID:'' ||',
'                                                         wwv_flow_escape.html(ID) ),',
'           ''REST'', wwv_flow_utilities.prepare_url( ''f?p=4000:876:'' || :flow_SESSION || ''::NO:876:P876_ID:'' ||',
'                                                   wwv_flow_escape.html(ID) ),',
'           wwv_flow_utilities.prepare_url( ''f?p=4000:196:'' || :flow_SESSION || ''::NO:196:F4000_P196_ID:'' ||',
'                                           wwv_flow_escape.html(ID) )',
'         ) as e_link,',
'   decode( action,',
'           ''NEW_SCHOOL'', ''<a href="'' || wwv_flow_utilities.prepare_url( ''f?p=4000:589:'' || :flow_session || ''::NO:589:P589_ID:'' ||',
'                                                                        wwv_flow_escape.html(id) ) ||',
'                         ''" class="a-Button a-Button--small a-Button--noLabel a-Button--withIcon a-Button--noUI">'' ||',
'                         ''<span class="a-Icon icon-search"></span></a>'',',
'           '''') as n,',
'   URL,',
'   decode( action,',
'           ''NEW_SCHOOL'', wwv_flow_utilities.prepare_url( ''f?p=4000:588:'' || :flow_session ||',
'                                                         ''::NO:588:P588_ID:'' || wwv_flow_escape.html(id) ),',
'           ''REST'', wwv_flow_utilities.prepare_url( ''f?p=4000:875:'' || :flow_session || ''::NO:875:P875_ID:'' ||',
'                                                   wwv_flow_escape.html(id) ),',
'           wwv_flow_utilities.prepare_url( ''f?p=4000:226:'' || :flow_session || ''::NO:226:F4000_P226_ID:'' ||',
'                                           wwv_flow_escape.html(id) )',
'         ) as run,',
'   ''icon-sc-web-service'' as icon,',
'   name as alt,',
'   decode( action,',
'           ''NEW_SCHOOL'', wwv_flow_utilities.prepare_url( ''f?p=4000:599:'' || :flow_SESSION || ''::NO::P599_ID:'' || ID ),',
'           ''REST'', wwv_flow_utilities.prepare_url( ''f?p=4000:876:'' || :flow_SESSION || ''::NO:876:P876_ID:'' || ID ),',
'           wwv_flow_utilities.prepare_url( ''f?p=4000:196:'' || :flow_SESSION || ''::NO::F4000_P196_ID:'' || ID )',
'         ) as image_link,',
'LAST_UPDATED_BY, ',
'LAST_UPDATED_ON,',
'created_by,',
'created_on ',
'from   WWV_FLOW_SHARED_WEB_SERVICES',
'where SECURITY_GROUP_ID = :flow_security_group_id and FLOW_ID = :fb_flow_id ',
'order  by upper(name)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(47844825293922430)
,p_name=>'Web Service References'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>' '
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#IMAGE_LINK#" class="a-IRR-icon"><span class="a-Icon #ICON#"></span><span class="a-IRR-iconName">#ALT#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47845008893922438)
,p_db_column_name=>'E'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Name'
,p_column_link=>'#E_LINK#'
,p_column_linktext=>'#E#'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1143245000653567403)
,p_db_column_name=>'E_LINK'
,p_display_order=>11
,p_column_identifier=>'M'
,p_column_label=>'E link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47845210094922439)
,p_db_column_name=>'URL'
,p_display_order=>21
,p_column_identifier=>'C'
,p_column_label=>'URL'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47845324327922440)
,p_db_column_name=>'RUN'
,p_display_order=>31
,p_column_identifier=>'D'
,p_column_label=>'Test'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'TMPL_THEME_3$ACTIONS'
,p_column_alignment=>'CENTER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'ACTIONS_WRAP', 'N',
  'STYLE', 'b-InlineActions--simple')).to_clob
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47845106848922439)
,p_db_column_name=>'N'
,p_display_order=>41
,p_column_identifier=>'B'
,p_column_label=>'View'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47845513191922441)
,p_db_column_name=>'ALT'
,p_display_order=>51
,p_column_identifier=>'F'
,p_column_label=>'Alt'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47845609753922441)
,p_db_column_name=>'IMAGE_LINK'
,p_display_order=>61
,p_column_identifier=>'G'
,p_column_label=>'Image Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47852530842964278)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>71
,p_column_identifier=>'H'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47852601685964279)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>81
,p_column_identifier=>'I'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47852717475964279)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>91
,p_column_identifier=>'J'
,p_column_label=>'Created By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47852825783964280)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>101
,p_column_identifier=>'K'
,p_column_label=>'Created'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(646446985035509110)
,p_db_column_name=>'ICON'
,p_display_order=>111
,p_column_identifier=>'L'
,p_column_label=>'ICON'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(47846032049926790)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_type=>'REPORT'
,p_report_alias=>'1286608203536643'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_view_mode=>'ICON'
,p_report_columns=>'E:URL:RUN:N:LAST_UPDATED_BY:LAST_UPDATED_ON::E_LINK'
,p_sort_column_1=>'0'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'0'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(86327928867226192)
,p_plug_name=>'Web Service References'
,p_region_template_options=>'#DEFAULT#:a-Region--sideRegion:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The &PRODUCT_NAME. engine can use Web Service References to access a Web service across the network. The Web service performs',
'an action and then sends back a response.</p>',
'',
'<p>To edit an existing reference, click the reference name. To test a reference, click the <strong>Test</strong> icon. To view details',
'about a reference, click the <strong>View</strong> icon. Click the <strong>Create</strong> button to create a new Web reference.</p>',
'',
'<p><strong>Note:</strong> To view the <strong>Test</strong> and <strong>View</strong> icons, you must be in the report view and not the icon view. Click',
'the <strong>View Report</strong> button in the interactive report search bar.</p>',
'',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(188924027769191278)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(47844726510922430)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:170:&SESSION.::&DEBUG.:170,RIR::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(86304928130192435)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(47844726510922430)
,p_button_name=>'CREATE'
,p_button_static_id=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:870:&SESSION.::&DEBUG.:565,580,585,870,871,872,873,875,REST_INPUT_PARMS,REST_OUTPUT_PARMS,REST_HTTP_HEADERS::'
,p_icon_css_classes=>'icon-right-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(86305829110192440)
,p_branch_action=>'170'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
,p_branch_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(86305207738192437)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P196_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_comment=>'Set the value of the item conainting the primary key to null when asked to create a new row.'
,p_computation_error_message=>'Unable to compute item value.'
,p_compute_when=>'CREATE_ROW'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(620268917096646840)
,p_name=>'Create Button - Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'#CREATE, #WS_REPORT'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(620269213610646842)
,p_event_id=>wwv_flow_imp.id(620268917096646840)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_component_action(
 p_id=>wwv_flow_imp.id(1497259348970619)
,p_ir_column_id=>wwv_flow_imp.id(47845324327922440)
,p_position_id=>wwv_flow_imp.id(214437533860142316)
,p_display_sequence=>10
,p_template_id=>wwv_flow_imp.id(214438625365151034)
,p_label=>'Run'
,p_link_target_type=>'REDIRECT_URL'
,p_link_target=>'#RUN#'
,p_button_display_type=>'ICON'
,p_icon_css_classes=>'icon-run-script'
,p_is_hot=>false
,p_show_as_disabled=>false
);
end;
/
prompt --application/pages/page_00171
begin
wwv_flow_imp_page.create_page(
 p_id=>171
,p_name=>'Copy Item - New Page'
,p_alias=>'COPY-ITEM-NEW-PAGE'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Item'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_item.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46215312519471998)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(196860515637446705)
,p_plug_name=>'Copy Item'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(196951302407543996)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(179572716597169307)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(196866901048449192)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46215312519471998)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(196878501179458725)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(46215312519471998)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(196878906267458727)
,p_branch_action=>'172'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(196878501179458725)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(179139114511526452)
,p_branch_action=>'f?p=&APP_ID.:172:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(196960124177549112)
,p_branch_action=>'4500'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(196866901048449192)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(196882110664464177)
,p_name=>'F4000_P171_COPY_FROM_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(196860515637446705)
,p_prompt=>'F4000_P171_COPY_FROM_ID'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(196884905273466721)
,p_name=>'F4000_P171_COPY_FROM_PAGE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(196860515637446705)
,p_prompt=>'F4000_P171_COPY_FROM_PAGE_ID'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(196906129390501097)
,p_name=>'F4000_P171_COPY_TO_PAGE_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(196860515637446705)
,p_prompt=>'New Page'
,p_source=>'F4000_P171_COPY_FROM_PAGE_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d',
'  from wwv_flow_steps',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and is_page_pattern   = ''N''',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the page number to copy the item to.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(197091831718819158)
,p_validation_name=>'new page id not null'
,p_validation_sequence=>10
,p_validation=>'F4000_P171_COPY_TO_PAGE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'New Page ID must be specified.'
,p_associated_item=>wwv_flow_imp.id(196906129390501097)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(167035408817934715)
,p_validation_name=>'check page locks'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'for c1 in (select count(*) counter ',
'           from wwv_flow_lock_page ',
'           where OBJECT_ID = :F4000_P171_COPY_TO_PAGE_ID ',
'           and flow_id = :fb_flow_id',
'           and locked_by != :app_user) loop',
'if c1.counter > 0 then',
'  return false;',
'else ',
'  return true;',
'end if;',
'end loop;',
'return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Can not copy items to a page locked by another user.'
,p_when_button_pressed=>wwv_flow_imp.id(196878501179458725)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(590119711872572033)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(196866901048449192)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(590119817271572034)
,p_event_id=>wwv_flow_imp.id(590119711872572033)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00172
begin
wwv_flow_imp_page.create_page(
 p_id=>172
,p_name=>'Copy Item - New Item'
,p_alias=>'COPY-ITEM-NEW-ITEM'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Item'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_item.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46217516805482728)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(179585307096188874)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(179572716597169307)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(179651808242370756)
,p_plug_name=>'Copy Item'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(179503222227001843)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46217516805482728)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(179508106775006805)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(46217516805482728)
,p_button_name=>'Copy'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(179505531578004551)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(46217516805482728)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1300954621)
,p_branch_action=>'4500'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(179538715987124001)
,p_branch_action=>'4500'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(179503222227001843)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(179505903254004558)
,p_branch_action=>'171'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(179505531578004551)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1290748955)
,p_name=>'F4000_P172_COPY_TO_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(179651808242370756)
,p_item_default=>'P&F4000_P172_COPY_TO_PAGE_ID._'
,p_prompt=>'Item Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Enter a name for the item to be created. The App Builder will display the first portion of a name for you to edit, based on the name of the item it was copied from. Use this format to complete the name or type in a completely new name.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1291784778)
,p_name=>'F4000_P172_COPY_TO_SEQ'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(179651808242370756)
,p_use_cache_before_default=>'NO'
,p_item_default=>'10'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select max(item_sequence) + 10',
'',
'from wwv_flow_step_items',
'',
'where flow_id = :fb_flow_id',
'',
'and flow_step_id = :F4000_P171_COPY_TO_PAGE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>'Specify the sequence for this component.  The sequence determines the order of evaluation.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(177290142430915728)
,p_name=>'F4000_P172_COPY_TO_POSITION'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(179651808242370756)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select item_display_point',
'from wwv_flow_step_items',
'where id = :F4000_P171_COPY_FROM_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'<p>Identifies the region slot that this item is to be displayed within. Item display sequence is relative to the region slot.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(179685701217525886)
,p_name=>'F4000_P172_COPY_TO_PROMPT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(179651808242370756)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Label'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select prompt',
'',
'from wwv_flow_step_items',
'',
'where id = :F4000_P171_COPY_FROM_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>This attribute identifies the field label for the page item. The label displays on the page only if the item is displayed. The label will display in its own HTML table cell for some display setups and in the same cell for others depending on the l'
||'abel alignment.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(179690131169542372)
,p_name=>'F4000_P172_COPY_TO_REGION'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(179651808242370756)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Region'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select item_plug_id',
'from wwv_flow_step_items',
'where id = :F4000_P171_COPY_FROM_ID',
'and :F4000_P171_COPY_FROM_PAGE_ID = :F4000_P171_COPY_TO_PAGE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case when r.page_id = f.global_page_id then',
'           wwv_flow_lang.system_message(''LAYOUT.GLOBAL_PAGE_REGION_PREFIX'')',
'       end || r.plug_name || '' ('' || r.plug_display_sequence || '')'' as d,',
'       r.id as r',
'  from wwv_flow_steps p,',
'       wwv_flows f,',
'       wwv_flow_page_plugs r',
' where p.flow_id           = :FB_FLOW_ID',
'   and p.id                = :F4000_P171_COPY_TO_PAGE_ID',
'   and p.security_group_id = :WORKSPACE_ID',
'   and f.id                = p.flow_id',
'   and r.flow_id           = f.id',
'   and r.page_id          in (:F4000_P171_COPY_TO_PAGE_ID, f.global_page_id)',
' order by case when r.page_id = f.global_page_id then 2 else 1 end, r.plug_name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Region -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>'<p>Identifies the region that this item is to be displayed within. Item display sequence is relative to the region.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(196966932144560615)
,p_name=>'F4000_P172_COPY_TO_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(179651808242370756)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Page:'
,p_source=>'F4000_P171_COPY_TO_PAGE_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>'This attribute identifies the application page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(179936617765384312)
,p_validation_name=>'F4000_P172_COPY_TO_NAME Not Null'
,p_validation_sequence=>10
,p_validation=>'F4000_P172_COPY_TO_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Item Name must be specified.'
,p_associated_item=>wwv_flow_imp.id(1290748955)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 20-FEB-2002 14:28'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(179937219130384322)
,p_validation_name=>'F4000_P172_COPY_TO_SEQ Not Null'
,p_validation_sequence=>30
,p_validation=>'F4000_P172_COPY_TO_SEQ'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'New Item Sequence must be specified.'
,p_associated_item=>wwv_flow_imp.id(1291784778)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 20-FEB-2002 14:28'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(69375918759877491)
,p_validation_name=>'not dup flow or item name'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not wwv_flow_builder.is_item_name_used(p_flow=>:FB_FLOW_ID,',
'p_name=>upper(:F4000_P172_COPY_TO_NAME))'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Item name is already used by existing application item or page item.'
,p_when_button_pressed=>wwv_flow_imp.id(179508106775006805)
,p_associated_item=>wwv_flow_imp.id(1290748955)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(150731426429303925)
,p_validation_name=>'ValidItemName'
,p_validation_sequence=>70
,p_validation=>'F4000_P172_COPY_TO_NAME'
,p_validation_type=>'ITEM_IS_ALPHANUMERIC'
,p_error_message=>'Name may contain only alphanumeric characters and underscores "_".'
,p_when_button_pressed=>wwv_flow_imp.id(179508106775006805)
,p_associated_item=>wwv_flow_imp.id(1290748955)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2595317933246133)
,p_validation_name=>'Ensure the destination page is not a subscribed page pattern'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_component_group_dev.is_part_of_subscribed_comp_grp (',
'    p_component_id   => :F4000_P171_COPY_TO_PAGE_ID,',
'    p_component_type => wwv_flow_copy_metadata.c_page,',
'    p_app_id         => :FB_FLOW_ID ) = ''N'''))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'You cannot copy the item to a page pattern that is part of a subscribed component group.'
,p_when_button_pressed=>wwv_flow_imp.id(179508106775006805)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(590119424688572030)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(179503222227001843)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(590119535252572031)
,p_event_id=>wwv_flow_imp.id(590119424688572030)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1297916466)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Item'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.copy_page_item (',
'    p_copy_from_item_id     => :F4000_P171_COPY_FROM_ID,',
'    p_copy_to_page_id       => :F4000_P171_COPY_TO_PAGE_ID,',
'    p_copy_to_item_name     => :F4000_P172_COPY_TO_NAME,',
'    p_copy_to_item_sequence => :F4000_P172_COPY_TO_SEQ,',
'    p_copy_to_item_plug     => :F4000_P172_COPY_TO_REGION,',
'    p_copy_to_item_position => :F4000_P172_COPY_TO_POSITION,',
'    p_copy_to_prompt        => :F4000_P172_COPY_TO_PROMPT);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying page item.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Copied item to Page &F4000_P171_COPY_TO_PAGE_ID..'
,p_internal_uid=>1297916466
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(590119645628572032)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Copied item to Page &F4000_P171_COPY_TO_PAGE_ID..'
,p_internal_uid=>590119645628572032
);
end;
/
prompt --application/pages/page_00173
begin
wwv_flow_imp_page.create_page(
 p_id=>173
,p_name=>'Theme Reports'
,p_alias=>'THEME-REPORTS'
,p_step_title=>'Theme Reports'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879423075323511)
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_themes.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44085020552688568)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(58949101764235429)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Themes'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(44089632373720400)
,p_name=>'Theme Template Counts'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * from (',
'select /* APEX 4000P173b */ decode(lov_name,',
'         ''REPORT THEME CLASS ID'', wwv_flow_lang.system_message_lit(''REPORT''),',
'         ''MENU THEME CLASS ID'', wwv_flow_lang.system_message_lit(''F4000.MENU''),',
'         ''LIST THEME CLASS ID'', wwv_flow_lang.system_message_lit(''F4000.LIST_INITCAP''),',
'         ''LABEL THEME CLASS ID'', wwv_flow_lang.system_message_lit(''LABEL''),',
'         ''CALENDAR THEME CLASS ID'', wwv_flow_lang.system_message_lit(''LEGACY_CALENDAR''),',
'         ''PAGE THEME CLASS ID'', wwv_flow_lang.system_message_lit(''F4000.PAGE''),',
'         ''BUTTON THEME CLASS ID'',wwv_flow_lang.system_message_lit(''F4000.BUTTON''),',
'         ''REGION THEME CLASS ID'',wwv_flow_lang.system_message_lit(''F4000.REGION''),',
'         ''POPUP LOV TEMPLATE THEME CLASS ID'',wwv_flow_lang.system_message_lit(''F4000.P371.POPUP_LOV'')) template_type,',
'       lov_disp_value,',
'       lov_return_value,',
'       lov_disp_sequence,',
'       lov_id,',
'	   CASE',
'	     when lov_name = ''POPUP LOV TEMPLATE THEME CLASS ID'' then -- POPUP ',
'		   (select count(*) from wwv_flow_popup_lov_template where flow_id = :fb_flow_id and security_group_id = :flow_security_group_id and theme_class_id = lov_return_value',
'and (theme_id = :p173_theme or :p173_theme = 0))',
'	     when lov_name = ''PAGE THEME CLASS ID'' then -- PAGE ',
'		   (select count(*) from wwv_flow_templates where flow_id = :fb_flow_id and security_group_id = :flow_security_group_id and theme_class_id = lov_return_value',
'and (theme_id = :p173_theme or :p173_theme = 0))',
'	     when lov_name = ''REPORT THEME CLASS ID'' then -- REPORT ',
'		   (select count(*) from wwv_flow_row_templates where flow_id = :fb_flow_id and security_group_id = :flow_security_group_id and theme_class_id = lov_return_value',
'and (theme_id = :p173_theme or :p173_theme = 0))',
'	     when lov_name = ''MENU THEME CLASS ID'' then -- MENU ',
'		   (select count(*) from wwv_flow_menu_templates where flow_id = :fb_flow_id and security_group_id = :flow_security_group_id and theme_class_id = lov_return_value',
'and (theme_id = :p173_theme or :p173_theme = 0))',
'	     when lov_name = ''LIST THEME CLASS ID'' then -- LIST ',
'		   (select count(*) from wwv_flow_list_templates where flow_id = :fb_flow_id and security_group_id = :flow_security_group_id and theme_class_id = lov_return_value',
'and (theme_id = :p173_theme or :p173_theme = 0))',
'	     when lov_name = ''LABEL THEME CLASS ID'' then -- LABEL ',
'		   (select count(*) from wwv_flow_field_templates where flow_id = :fb_flow_id and security_group_id = :flow_security_group_id and theme_class_id = lov_return_value',
'and (theme_id = :p173_theme or :p173_theme = 0))',
'	     when lov_name = ''CALENDAR THEME CLASS ID'' then ',
'	   (select count(*) from wwv_flow_cal_templates where flow_id = :fb_flow_id and security_group_id = :flow_security_group_id and theme_class_id = lov_return_value',
'and (theme_id = :p173_theme or :p173_theme = 0))',
'	     when lov_name = ''BUTTON THEME CLASS ID'' then -- BUTTON ',
'		   (select count(*) from wwv_flow_button_templates where flow_id = :fb_flow_id and security_group_id = :flow_security_group_id and theme_class_id = lov_return_value',
'and (theme_id = :p173_theme or :p173_theme = 0))',
'	     when lov_name = ''REGION THEME CLASS ID'' then -- REGION ',
'		   (select count(*) from wwv_flow_page_plug_templates where flow_id = :fb_flow_id and security_group_id = :flow_security_group_id and theme_class_id = lov_return_value',
'and (theme_id = :p173_theme or :p173_theme = 0))',
'	   end counter ',
'from   wwv_flow_list_of_values_data d, WWV_FLOW_LISTS_OF_VALUES$ l,',
' (select wwv_flow.get_translated_app_id tflow_id from sys.dual) t',
'where  d.lov_id = l.id',
'  and l.flow_id =  t.tflow_id',
'  and lov_name in (',
'         ''PAGE THEME CLASS ID'' ,',
'         ''REPORT THEME CLASS ID'' ,',
'         ''MENU THEME CLASS ID'' ,',
'         ''LIST THEME CLASS ID'' ,',
'         ''LABEL THEME CLASS ID'' ,',
'         ''CALENDAR THEME CLASS ID'' , ',
'         ''BUTTON THEME CLASS ID'' , ',
'         ''REGION THEME CLASS ID'' ,',
'         ''POPUP LOV TEMPLATE THEME CLASS ID'' )',
'   and (:P173_SHOW_CUSTOM = ''1'' or lov_disp_sequence != 10)',
'union all',
'select wwv_flow_lang.system_message_lit(''F4000.TEMPLATE_COMPONENT'') as template_type,',
'       null,',
'       null,',
'       null,',
'       null,',
'       (select count(*) from wwv_flow_template_components where flow_id = :fb_flow_id and security_group_id = :flow_security_group_id and (theme_id = :p173_theme or :p173_theme = 0) )',
'  from sys.dual )',
'order by lov_id, lov_disp_sequence, lov_disp_value'))
,p_display_when_condition=>'P173_SHOW'
,p_display_when_cond2=>'2'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>50
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_type=>'ROW_RANGES'
,p_query_row_count_max=>20000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'Y'
,p_comment=>'vgonchar: number of rows set to 50 due to Chrome to be extremely slow when used with JAWS when more than 100 rows are shown. With 500 rows Chrome become not responding.'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(44090207125720421)
,p_query_column_id=>1
,p_column_alias=>'TEMPLATE_TYPE'
,p_column_display_sequence=>1
,p_column_heading=>'Template'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(44090332255720421)
,p_query_column_id=>2
,p_column_alias=>'LOV_DISP_VALUE'
,p_column_display_sequence=>2
,p_column_heading=>'Class'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(44090429962720421)
,p_query_column_id=>3
,p_column_alias=>'LOV_RETURN_VALUE'
,p_column_display_sequence=>3
,p_column_heading=>'Class ID'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(44103132073748731)
,p_query_column_id=>4
,p_column_alias=>'LOV_DISP_SEQUENCE'
,p_column_display_sequence=>4
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5003717657213901)
,p_query_column_id=>5
,p_column_alias=>'LOV_ID'
,p_column_display_sequence=>15
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48617529811154922)
,p_query_column_id=>6
,p_column_alias=>'COUNTER'
,p_column_display_sequence=>5
,p_column_heading=>'Template Count'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(45482402383915030)
,p_plug_name=>'Report Selector'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(48447115370583016)
,p_name=>'Application Templates'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P173a */',
'  decode(template_type,',
'  ''PAGE'',wwv_flow_lang.system_message_lit(''F4000.PAGE''),',
'  ''REGION'',wwv_flow_lang.system_message_lit(''F4000.REGION''),',
'  ''LABEL'',wwv_flow_lang.system_message_lit(''LABEL''),',
'  ''LIST'',wwv_flow_lang.system_message_lit(''F4000.LIST_INITCAP''),',
'  ''POPUP_LOV'',wwv_flow_lang.system_message_lit(''F4000.P371.POPUP_LOV''),',
'  ''CALENDAR'',wwv_flow_lang.system_message_lit(''LEGACY_CALENDAR''),',
'  ''MENU'',wwv_flow_lang.system_message_lit(''BREADCRUMB''),',
'  ''BUTTON'',wwv_flow_lang.system_message_lit(''F4000.BUTTON''),',
'  ''REPORT'',wwv_flow_lang.system_message_lit(''REPORT''),',
'  ''POPUP_LOV'',wwv_flow_lang.system_message_lit(''F4000.P371.POPUP_LOV''),',
'  ''TEMPLATE_COMPONENT'',wwv_flow_lang.system_message_lit(''F4000.TEMPLATE_COMPONENT''),',
'  ''trans-''||template_type) t, ',
'  template_name n,',
'  theme_class,',
'  theme_id',
'from (',
'select ',
'''POPUP_LOV'' template_type,',
'(select lov_disp_value',
'   from wwv_flow_list_of_values_data d,',
'        WWV_FLOW_LISTS_OF_VALUES$ l,',
'        (select wwv_flow.get_translated_app_id tflow_id from sys.dual) t',
'  where d.lov_id = l.id',
'    and l.flow_id =  t.tflow_id',
'    and d.security_group_id = :flow_security_group_id',
'    and l.security_group_id = :flow_security_group_id',
'    and lov_return_value = theme_class_id',
'    and lov_name = ''POPUP LOV TEMPLATE THEME CLASS ID'') theme_class,',
'''<a href="f?p=4000:251:''||:flow_session||''::NO:251:F4000_P251_ID:''||id||',
'''">Popup LOV</a>'' template_name,',
'last_updated_on, last_updated_by, null reference_id,',
'1 is_default,',
'0 preview,',
'theme_id',
'  from wwv_flow_popup_lov_template plt',
' where plt.flow_id = :fb_flow_id',
'   and plt.security_group_id = :flow_security_group_id',
'   and (theme_id = :p173_theme or :p173_theme = 0)',
'union all',
'select',
'''CALENDAR'' template_type,',
'(select lov_disp_value',
'   from wwv_flow_list_of_values_data d,',
'        WWV_FLOW_LISTS_OF_VALUES$ l,',
'        (select wwv_flow.get_translated_app_id tflow_id from sys.dual) t',
'  where d.lov_id = l.id',
'    and l.flow_id =  t.tflow_id',
'    and d.security_group_id = :flow_security_group_id',
'    and l.security_group_id = :flow_security_group_id',
'    and lov_return_value = theme_class_id',
'    and lov_name = ''CALENDAR THEME CLASS ID'' ) theme_class,',
'''<a href="f?p=4000:122:''||:FLOW_SESSION||''::NO:122:P122_ID:''||id||',
'''">''||wwv_flow_escape.html(NAME)||''</a>'' ',
'template_name,',
'last_updated_on, last_updated_by, reference_id,',
'0 is_default,',
'0 preview,',
'theme_id',
'  from wwv_flow_cal_templates c',
' where c.flow_id = :fb_flow_id  ',
'   and c.security_group_id = :flow_security_group_id',
'   and (c.theme_id = :p173_theme or :p173_theme = 0)',
'union all',
'select',
'''MENU'' template_type,',
'(select lov_disp_value',
'   from wwv_flow_list_of_values_data d,',
'        WWV_FLOW_LISTS_OF_VALUES$ l,',
'        (select wwv_flow.get_translated_app_id tflow_id from sys.dual) t',
'  where d.lov_id = l.id',
'    and l.flow_id =  t.tflow_id',
'    and d.security_group_id = :flow_security_group_id',
'    and l.security_group_id = :flow_security_group_id',
'    and lov_return_value = theme_class_id',
'    and lov_name = ''MENU THEME CLASS ID'' ) theme_class,',
'''<a href="f?p=4000:289:''||:FLOW_SESSION||''::NO:289:F4000_P289_ID:''||id||',
'''">''||wwv_flow_escape.html(NAME)||''</a>'' template_name,',
'last_updated_on, last_updated_by, reference_id,',
'(select count(*)',
'   from wwv_flow_themes t',
'  where flow_id = :fb_flow_id',
'    and security_group_id = :flow_security_group_id',
'    and theme_id = m.theme_id',
'    and default_menu_template = m.id ) is_default,',
'0 preview,',
'theme_id',
'  from wwv_flow_menu_templates m',
' where m.flow_id = :fb_flow_id    ',
'   and m.security_group_id = :flow_security_group_id',
'   and (m.theme_id = :p173_theme or :p173_theme = 0) ',
'union all',
'select ',
'''BUTTON'' template_type,',
'(select lov_disp_value',
'   from wwv_flow_list_of_values_data d,',
'        WWV_FLOW_LISTS_OF_VALUES$ l,',
'        (select wwv_flow.get_translated_app_id tflow_id from sys.dual) t',
'  where d.lov_id = l.id',
'    and l.flow_id =  t.tflow_id',
'    and d.security_group_id = :flow_security_group_id',
'    and l.security_group_id = :flow_security_group_id',
'    and lov_return_value = theme_class_id',
'    and lov_name = ''BUTTON THEME CLASS ID'' ) theme_class,',
'''<a href="f?p=4000:204:''||:FLOW_SESSION||''::NO:204:F4000_P204_ID:''||id||',
'''">''||wwv_flow_escape.html(TEMPLATE_NAME)||''</a>'' template_name,',
'last_updated_on, last_updated_by, reference_id,',
'(select count(*)',
'   from wwv_flow_themes t',
'  where flow_id = :fb_flow_id',
'    and security_group_id = :flow_security_group_id',
'    and theme_id = b.theme_id',
'    and default_button_template = b.id ) is_default,',
'0 preview,',
'theme_id',
'  from wwv_flow_button_templates b',
' where b.flow_id = :fb_flow_id',
'   and b.security_group_id = :flow_security_group_id',
'   and (b.theme_id = :p173_theme or :p173_theme = 0)',
'union all',
'select ''LABEL'' template_type,',
'(select lov_disp_value',
'   from wwv_flow_list_of_values_data d,',
'        WWV_FLOW_LISTS_OF_VALUES$ l,',
'        (select wwv_flow.get_translated_app_id tflow_id from sys.dual) t',
'  where d.lov_id = l.id',
'    and l.flow_id =  t.tflow_id',
'    and d.security_group_id = :flow_security_group_id',
'    and l.security_group_id = :flow_security_group_id',
'    and lov_return_value = theme_class_id',
'    and lov_name = ''LABEL THEME CLASS ID'' ) theme_class,',
'''<a href="f?p=4000:85:''||:flow_session||''::NO:85:F4000_P85_ID:''||id||',
'''">''||wwv_flow_escape.html(TEMPLATE_NAME)||''</a>'' template_name,',
'last_updated_on, last_updated_by, reference_id,',
'(select count(*)',
'   from wwv_flow_themes t',
'  where flow_id = :fb_flow_id',
'    and security_group_id = :flow_security_group_id',
'    and theme_id = f.theme_id',
'    and default_label_template = f.id ) is_default,',
'0 preview,',
'theme_id',
'  from wwv_flow_field_templates f',
' where f.flow_id = :fb_flow_id',
'   and f.security_group_id = :flow_security_group_id',
'   and (f.theme_id = :p173_theme or :p173_theme = 0)',
'union all ',
'select ',
'''LIST'' template_type,',
'(select lov_disp_value',
'   from wwv_flow_list_of_values_data d,',
'        WWV_FLOW_LISTS_OF_VALUES$ l,',
'        (select wwv_flow.get_translated_app_id tflow_id from sys.dual) t',
'  where d.lov_id = l.id',
'    and l.flow_id =  t.tflow_id',
'    and d.security_group_id = :flow_security_group_id',
'    and l.security_group_id = :flow_security_group_id',
'    and lov_return_value = theme_class_id',
'    and lov_name = ''LIST THEME CLASS ID'' ) theme_class,',
'''<a href="f?p=4000:4655:''||:FLOW_SESSION||''::NO:4655:F4000_P4655_ID:''||id||    ',
'''">''||wwv_flow_escape.html(l.LIST_TEMPLATE_NAME)||''</a>'' template_name,',
'last_updated_on, last_updated_by, reference_id,',
'(select count(*)',
'   from wwv_flow_themes t',
'  where flow_id = :fb_flow_id',
'    and security_group_id = :flow_security_group_id',
'    and theme_id = l.theme_id',
'    and default_list_template = l.id ) is_default,',
'0 preview,',
'theme_id',
'  from wwv_flow_list_templates l',
' where l.flow_id = :fb_flow_id',
'   and l.security_group_id = :flow_security_group_id',
'   and (l.theme_id = :p173_theme or :p173_theme = 0)',
'union all',
'select',
'''REPORT'' template_type,',
'(select lov_disp_value',
'   from wwv_flow_list_of_values_data d,',
'        WWV_FLOW_LISTS_OF_VALUES$ l,',
'        (select wwv_flow.get_translated_app_id tflow_id from sys.dual) t',
'  where d.lov_id = l.id',
'    and l.flow_id =  t.tflow_id',
'    and d.security_group_id = :flow_security_group_id',
'    and l.security_group_id = :flow_security_group_id',
'    and lov_return_value = theme_class_id',
'    and lov_name = ''REPORT THEME CLASS ID'' ) theme_class,',
'decode(ROW_TEMPLATE_TYPE,''GENERIC_COLUMNS'',',
'''<a href="f?p=4000:258:''||:flow_session||''::NO::F4000_P258_ID:''||id||''">'',',
'''<a href="f?p=4000:4654:''||:flow_session||''::NO:4654:F4000_P4654_ID:''||id||''">'')||',
'wwv_flow_escape.html(ROW_TEMPLATE_NAME)||''</a>'' template_name,',
'last_updated_on, last_updated_by, reference_id,',
'(select count(*)',
'   from wwv_flow_themes t',
'  where flow_id = :fb_flow_id',
'    and security_group_id = :flow_security_group_id',
'    and theme_id = ro.theme_id',
'    and default_report_template = ro.id ) is_default,',
'ro.id preview,',
'theme_id',
'  from wwv_flow_row_templates ro',
' where ro.flow_id = :fb_flow_id',
'   and ro.security_group_id = :flow_security_group_id',
'   and (ro.theme_id = :p173_theme or :p173_theme = 0)',
'union all',
'select',
'''PAGE'' template_type,',
'(select lov_disp_value',
'   from wwv_flow_list_of_values_data d,',
'        WWV_FLOW_LISTS_OF_VALUES$ l,',
'        (select wwv_flow.get_translated_app_id tflow_id from sys.dual) t',
'  where d.lov_id = l.id',
'    and l.flow_id =  t.tflow_id',
'    and d.security_group_id = :flow_security_group_id',
'    and l.security_group_id = :flow_security_group_id',
'    and lov_return_value = theme_class_id',
'    and lov_name = ''PAGE THEME CLASS ID'' ) theme_class,',
'''<a href="f?p=4000:4307:''||:FLOW_SESSION||''::NO:4307:F4000_P4307_ID:''||id||''">''||wwv_flow_escape.html(name)||''</a>'' template_name,',
'last_updated_on, last_updated_by, reference_id,',
'(select count(*)',
'   from wwv_flow_themes t',
'  where flow_id = :fb_flow_id',
'    and security_group_id = :flow_security_group_id',
'    and theme_id = p.theme_id',
'    and DEFAULT_PAGE_TEMPLATE=p.id ) is_default,',
'p.id preview,',
'theme_id',
'  from wwv_flow_templates p',
' where p.flow_id = :fb_flow_id',
'   and p.security_group_id = :flow_security_group_id',
'   and (p.theme_id = :p173_theme or :p173_theme = 0)',
'union all',
'select',
'''REGION'' template_type,',
'(select lov_disp_value',
'   from wwv_flow_list_of_values_data d,',
'        WWV_FLOW_LISTS_OF_VALUES$ l,',
'        (select wwv_flow.get_translated_app_id tflow_id from sys.dual) t',
' where d.lov_id = l.id',
'    and l.flow_id =  t.tflow_id',
'    and d.security_group_id = :flow_security_group_id',
'    and l.security_group_id = :flow_security_group_id',
'    and lov_return_value = theme_class_id',
'    and lov_name = ''REGION THEME CLASS ID'' ) theme_class,',
'''<a href="f?p=4000:4653:''||:flow_session||''::NO:4653:F4000_P4653_ID:''||id||''">''||wwv_flow_escape.html(PAGE_PLUG_TEMPLATE_NAME)||''</a>'' template_name,',
'last_updated_on, last_updated_by, reference_id,',
'(select count(*)',
'   from wwv_flow_themes t',
'  where flow_id = :fb_flow_id',
'    and security_group_id = :flow_security_group_id',
'    and theme_id = r.theme_id',
'    and default_region_template = r.id ) is_default,',
'r.id preview,',
'theme_id',
'  from wwv_flow_page_plug_templates r',
' where r.flow_id = :fb_flow_id',
'   and r.security_group_id = :flow_security_group_id',
'   and (r.theme_id = :p173_theme or nvl(:p173_theme,''0'') = ''0'')',
'union all',
'select',
'''TEMPLATE_COMPONENT'' template_type,',
'null theme_class,',
'''<a href="f?p=4000:4410:''||:flow_session||''::NO:4410:P4410_ID:''||id||''">''||wwv_flow_escape.html(builder_name)||''</a>'' template_name,',
'last_updated_on, last_updated_by, reference_id,',
'null is_default,',
'r.id preview,',
'theme_id',
'  from wwv_flow_template_components r',
' where r.flow_id = :fb_flow_id',
'   and r.security_group_id = :flow_security_group_id',
'   and (r.theme_id = :p173_theme or nvl(:p173_theme,''0'') = ''0'')',
') x ',
'where',
'(:P4003_FIND is null or instr(upper(template_name),upper(:P4003_FIND)) > 0)',
'order by 1, 2'))
,p_display_when_condition=>'P173_SHOW'
,p_display_when_cond2=>'1'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>50
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'1'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
,p_comment=>'vgonchar: number of rows set to 50 due to Chrome to be extremely slow when used with JAWS when more than 100 rows are shown. With 500 rows Chrome become not responding.'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48447409064583022)
,p_query_column_id=>1
,p_column_alias=>'T'
,p_column_display_sequence=>1
,p_column_heading=>'Template Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48447520266583022)
,p_query_column_id=>2
,p_column_alias=>'N'
,p_column_display_sequence=>2
,p_column_heading=>'Template Name'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48448221603584838)
,p_query_column_id=>3
,p_column_alias=>'THEME_CLASS'
,p_column_display_sequence=>4
,p_column_heading=>'Template Class'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48447600846583022)
,p_query_column_id=>4
,p_column_alias=>'THEME_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Theme'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(45488609571935985)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(45482402383915030)
,p_button_name=>'P173_GO'
,p_button_static_id=>'P173_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Go'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(205412114656611987)
,p_branch_action=>'f?p=&FLOW_ID.:435:&SESSION.::&DEBUG.:RP:P435_SHOW:FILE'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P173_SHOW'
,p_branch_condition_text=>'FILE'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(205427506738638013)
,p_branch_action=>'f?p=&FLOW_ID.:491:&SESSION.::&DEBUG.:RP:P491_SHOW:CLASS'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P173_SHOW'
,p_branch_condition_text=>'CLASS'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(205431332711645589)
,p_branch_action=>'f?p=&FLOW_ID.:492:&SESSION.::&DEBUG.:RP:P492_SHOW:TEMPLATE'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P173_SHOW'
,p_branch_condition_text=>'TEMPLATE'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(45488926884935992)
,p_branch_action=>'f?p=&FLOW_ID.:173:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(45490813165946457)
,p_name=>'P173_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(45482402383915030)
,p_item_default=>'0'
,p_prompt=>'Theme'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- All -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a theme and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48987918801575678)
,p_name=>'P173_SHOW'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(45482402383915030)
,p_item_default=>'1'
,p_prompt=>'Report'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P173_SHOW'
,p_lov=>'.'||wwv_flow_imp.id(48989614083583743)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a report type and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(135661018056004082)
,p_name=>'P173_SHOW_CUSTOM'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(45482402383915030)
,p_prompt=>'Show Custom'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_begin_on_new_line=>'N'
,p_display_when=>'P173_SHOW'
,p_display_when2=>'2'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select this option to include custom template classes in this report.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'1'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(44137715553876365)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'173'
,p_compute_when_type=>'%null%'
);
end;
/
prompt --application/pages/page_00174
begin
wwv_flow_imp_page.create_page(
 p_id=>174
,p_name=>'Create Shortcut - Shortcut Attributes'
,p_alias=>'CREATE-SHORTCUT-SHORTCUT-ATTRIBUTES'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Shortcut'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213468022923563047)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_cut.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(186264016206277053)
,p_plug_name=>'Source'
,p_region_name=>'SRC'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>125
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(186266114986277081)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(185305822581982553)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_plug_query_headings=>wwv_flow_string.join(wwv_flow_t_varchar2(
'blue_arrow_down.gif::blue_arrow_up.gif:|2,2,3\1|&nbsp;:',
'',
'<font color="black" class="nounderline">Name<font>:',
'',
'<font color="black" class="nounderline">Sequence</font>:',
'',
'<font color="black" class="nounderline">Type</font>'))
,p_plug_query_num_rows=>1500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'L:R:L:L:L:L:L'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(186266724136277086)
,p_plug_name=>'Name'
,p_region_name=>'N'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_header=>'<p>Shortcuts are a repository of shared static or dynamic HTML. By using a shortcut, you can avoid recoding the same HTML or PL/SQL function multiple times. Creating shortcuts on page item labels and page item post element text attributes can include'
||' the following substitution strings: #CURRENT_FORM_ELEMENT#, #CURRENT_ITEM_ID#, #CURRENT_ITEM_NAME#.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'generated 04-SEP-2000 16:36:50'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(186270332432277105)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>91
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_row_count_max=>5000
,p_plug_query_show_nulls_as=>'(null)'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(186270607721277109)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_imp.id(186270332432277105)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(186271512764277112)
,p_button_sequence=>4
,p_button_plug_id=>wwv_flow_imp.id(186270332432277105)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(186299015471307027)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(186270332432277105)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(186273314453277133)
,p_branch_action=>'4047'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>40
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'Create'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(186299432667307029)
,p_branch_action=>'131'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(186299015471307027)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2408108417709292)
,p_name=>'F4000_P174_SHORTCUT_LANG'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(186264016206277053)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Language'
,p_source=>'SHORTCUT_LANGUAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select a language that is used to evaluate the entered programming code.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_02=>'F4000_P174_SHORTCUT_TYPE'
,p_attribute_03=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(186264327799277061)
,p_name=>'F4000_P174_SHORTCUT_TYPE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(186264016206277053)
,p_use_cache_before_default=>'NO'
,p_item_default=>'HTML_TEXT'
,p_prompt=>'Type'
,p_source=>'SHORTCUT_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'SHORTCUT_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(84752421139794200)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Identifies the actual shortcut text that displays to the user. This field is required.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(186264630551277068)
,p_name=>'F4000_P174_SHORTCUT'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(186264016206277053)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Shortcut'
,p_source=>'SHORTCUT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>85
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'<p>Text of the shortcut. The shortcut must be less then 4000 characters in length. The text is processed based on the shortcut type.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(186264930390277070)
,p_name=>'F4000_P174_ERROR_TEXT'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(186264016206277053)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Error Text'
,p_source=>'ERROR_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>85
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'<p>Enter the text to display if an error should occur during the processing of a shortcut.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(186267002382277087)
,p_name=>'F4000_P174_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(186266724136277086)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(186267302163277089)
,p_name=>'F4000_P174_FLOW_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(186266724136277086)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'This attribute identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(186267623343277090)
,p_name=>'F4000_P174_SHORTCUT_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(186266724136277086)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>'SHORTCUT_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Name of the shortcut and the name by which the shortcut will be referenced.</p>',
'<p>To reference a shortcut use the syntax <strong>"SHORTCUT_NAME"</strong> wherever a shortcut is permitted. The name will automatically be converted into all uppercase. All references to shortcuts must display in uppercase.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(186362824817436410)
,p_validation_name=>'F4000_P174_SHORTCUT_TYPE Not Null'
,p_validation_sequence=>1
,p_validation=>'F4000_P174_SHORTCUT_TYPE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Type must be specified.'
,p_associated_item=>wwv_flow_imp.id(186264327799277061)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 04-MAR-2002 12:45'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(186363107795436411)
,p_validation_name=>'F4000_P174_SHORTCUT_NAME Not Null'
,p_validation_sequence=>2
,p_validation=>'F4000_P174_SHORTCUT_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Name must be specified.'
,p_associated_item=>wwv_flow_imp.id(186267623343277090)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 04-MAR-2002 12:45'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(373230829336848414)
,p_validation_name=>'check pl/sql'
,p_validation_sequence=>12
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_f4000_util.check_plsql(',
'    :F4000_P174_SHORTCUT,',
'    :FB_FLOW_ID,',
'    :FLOW_SECURITY_GROUP_ID',
');'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':F4000_P174_SHORTCUT_TYPE = ''FUNCTION_BODY'' and :F4000_P174_SHORTCUT_LANG = ''PLSQL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(186271512764277112)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(589950313785621448)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(186270607721277109)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(589950470539621449)
,p_event_id=>wwv_flow_imp.id(589950313785621448)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(186276332538277157)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_SHORTCUTS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_SHORTCUTS'
,p_attribute_03=>'F4000_P174_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_process_error_message=>'Error processing row.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(186271512764277112)
,p_process_success_message=>'Shortcut created.'
,p_internal_uid=>186276332538277157
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(589950563632621450)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,F4000_LAST_VIEW'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(186271512764277112)
,p_process_success_message=>'Shortcut created.'
,p_internal_uid=>589950563632621450
);
end;
/
prompt --application/pages/page_00177
begin
wwv_flow_imp_page.create_page(
 p_id=>177
,p_name=>'Theme Styles'
,p_alias=>'THEME-STYLES'
,p_step_title=>'Theme Styles'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'No help is available for this page.'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(366542826267187546)
,p_plug_name=>'Settings'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(366550824763408792)
,p_plug_name=>'Theme Styles'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>'Theme styles are CSS files that are referenced in the page template using the #THEME_STYLE_CSS# substitution string. The &PRODUCT_NAME. engine replaces this substitution string with the CSS file references defined in the theme style attributes. Use t'
||'heme styles to customize themes, to switch to a different color scheme, apply a flat look, or make a theme responsive. A theme can have multiple theme styles with one style set active.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(366551909488451625)
,p_plug_name=>'Theme Styles'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_04'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(387910631715294595)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1217752994466777301)
,p_plug_name=>'Comments'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1217753042936777302)
,p_plug_name=>'Theme Roller Attributes'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1791805889514360410)
,p_plug_name=>'Theme Roller JSON Configuration'
,p_parent_plug_id=>wwv_flow_imp.id(1217753042936777302)
,p_region_template_options=>'#DEFAULT#:is-expanded:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(689970285456172024)
,p_plug_display_sequence=>60
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(366543416075187549)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(366551909488451625)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:267:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(366543211381187548)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(366551909488451625)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.confirm(htmldb_delete_message,''DELETE'');'
,p_button_execute_validations=>'N'
,p_button_condition=>'P177_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(366543109584187548)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(366551909488451625)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P177_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(366543030051187548)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(366551909488451625)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>'P177_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(366544032567187552)
,p_branch_action=>'f?p=&APP_ID.:267:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>1
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(366544202510187555)
,p_name=>'P177_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(366542826267187546)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(93372822814585113)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(366544406952187564)
,p_name=>'P177_NAME'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(366542826267187546)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Provide a short descriptive name for the theme style, to distinguish it from other styles in the theme.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(366544601073187565)
,p_name=>'P177_CSS_FILE_URLS'
,p_item_sequence=>55
,p_item_plug_id=>wwv_flow_imp.id(366542826267187546)
,p_use_cache_before_default=>'NO'
,p_prompt=>'File URLs'
,p_source=>'CSS_FILE_URLS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>3
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter Cascading Style Sheet file URLs to be loaded on every page if the theme style is current. Each URL has to be written into a new line. If you provide a minified version of your file you can use the substitution string <code>#MIN#</code> to in'
||'clude <code>.min</code> or <code>#MIN_DIRECTORY#</code> to include <code>minified/</code> in your file URL for a regular page view and an empty string if the page is viewed in debug mode. You also have access to the substitution string <code>#APP_VER'
||'SION#</code> if you want to include the application''s version in the file URL.</p>',
'',
'<p>File URLs you enter here will replace the <code>#THEME_STYLE_CSS#</code> substitution string in the page template.</p>',
'',
'<p>Note: You do not need to include opening or closing <code>link</code> tags. Just include the file URL.</p>',
'',
'<p>',
'Examples:',
'<ul>',
'  <li>Standard file reference which loads the file from the theme directory.',
'      <pre>#THEME_IMAGES#main.css</pre>',
'  </li>',
'  <li>Standard file reference which loads the minified file main.min.css from /mycss/minified/ for regular page views and main.css from /mycss/ in debug mode.',
'      <pre>/mycss/#MIN_DIRECTORY#main#MIN#.css</pre>',
'  </li>',
'  <li>Conditional media query',
'      <pre>[media="only screen and (max-device-width: 480px)"]/mycss/smartphone.css</pre>',
'  </li>',
'  <li>File reference using a query string in the URL referencing the application version, such that when the application is upgraded (and the version is incremented), the browser is instructed to always load the new file and ignore any previously cac'
||'hed files.',
'      <pre>/mycss/main.css?version=#APP_VERSION#</pre>',
'  </li>',
'</ul>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(366544826936187569)
,p_name=>'P177_IS_CURRENT'
,p_is_required=>true
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_imp.id(366542826267187546)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Is Current'
,p_source=>'IS_CURRENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select whether this style is the current style used by the theme.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(366545027195187569)
,p_name=>'P177_COMPONENT_COMMENT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1217752994466777301)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comments'
,p_source=>'COMPONENT_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter any comments or notes here. These comments will never be displayed when running the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(366558014630816978)
,p_name=>'P177_FLOW_ID'
,p_item_sequence=>12
,p_item_plug_id=>wwv_flow_imp.id(366542826267187546)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(366558900815838536)
,p_name=>'P177_THEME_ID'
,p_item_sequence=>14
,p_item_plug_id=>wwv_flow_imp.id(366542826267187546)
,p_use_cache_before_default=>'NO'
,p_source=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(879701970656493841)
,p_name=>'P177_IS_PUBLIC'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_imp.id(366542826267187546)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Is Public'
,p_source=>'IS_PUBLIC'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select whether this style can be chosen by end users.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(879702088607493842)
,p_name=>'P177_IS_ACCESSIBLE'
,p_item_sequence=>45
,p_item_plug_id=>wwv_flow_imp.id(366542826267187546)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Accessibility Tested'
,p_source=>'IS_ACCESSIBLE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify if this Theme Style has been tested to the applicable accessibility guidelines. For Theme Styles created by Oracle, please see our product VPAT for the accessibility guidelines we follow.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1217753164876777303)
,p_name=>'P177_THEME_ROLLER_INPUT_FILE_URLS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1217753042936777302)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Input Parameter File URLs'
,p_source=>'THEME_ROLLER_INPUT_FILE_URLS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>3
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the LESS file URLs that will be used to generate this theme style when using Theme Roller.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1217753214828777304)
,p_name=>'P177_THEME_ROLLER_OUTPUT_FILE_URL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1217753042936777302)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Output CSS File URL'
,p_source=>'THEME_ROLLER_OUTPUT_FILE_URL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>82
,p_cMaxlength=>4000
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the URL for the CSS file that will be generated by Theme Roller for this theme style. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1217753366427777305)
,p_name=>'P177_THEME_ROLLER_READ_ONLY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1217753042936777302)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Read Only'
,p_source=>'THEME_ROLLER_READ_ONLY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select <strong>On</strong> to prevent any updates to the theme style. Select <strong>Off</strong> to allow the theme style to be edited and overwritten using Theme Roller.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1323587497460848827)
,p_name=>'P177_CSS_CLASSES'
,p_item_sequence=>65
,p_item_plug_id=>wwv_flow_imp.id(366542826267187546)
,p_use_cache_before_default=>'NO'
,p_prompt=>'CSS Classes'
,p_source=>'CSS_CLASSES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>82
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter CSS classes to be appended to the #PAGE_CSS_CLASSES# substitution string and applied to every page of the application if this Theme Style is currently active.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1791909606437372803)
,p_name=>'P177_THEME_ROLLER_CONFIG'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(1791805889514360410)
,p_use_cache_before_default=>'NO'
,p_prompt=>'JSON Configuration'
,p_source=>'THEME_ROLLER_CONFIG'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cHeight=>5
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The JSON configuration is generated by Theme Roller when the theme style is saved.</p>',
'<p>Oracle does not recommend manually updating the configuration. However, you can copy a JSON configuration from another theme style, such as a theme style in another application, to manually update the configuration.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1864600915247700701)
,p_name=>'P177_NOTE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(1791805889514360410)
,p_pre_element_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<strong>Note:</strong> Saving a theme style in Theme Roller will generate the JSON Configuration. <br/>',
'Manually updating a generated configuration may cause errors or unexpected results.'))
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1791988207698429412)
,p_validation_name=>'P177_CSS_FILE_URLS'
,p_validation_sequence=>10
,p_validation=>'P177_CSS_FILE_URLS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'A theme style file URL is required, unless Theme Roller is used and the Theme Roller input parameter file URL is defined.'
,p_validation_condition=>'P177_THEME_ROLLER_INPUT_FILE_URLS'
,p_validation_condition_type=>'ITEM_IS_NULL'
,p_associated_item=>wwv_flow_imp.id(366544601073187565)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1475883114853627440)
,p_validation_name=>'P177_CSS_FILE_URLS_1'
,p_validation_sequence=>20
,p_validation=>'P177_THEME_ROLLER_INPUT_FILE_URLS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'A Theme Roller input parameter file URL is required, unless a theme style file URL is defined.'
,p_validation_condition=>'P177_CSS_FILE_URLS'
,p_validation_condition_type=>'ITEM_IS_NULL'
,p_associated_item=>wwv_flow_imp.id(1217753164876777303)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(366545824442187570)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_THEME_STYLES'
,p_attribute_02=>'WWV_FLOW_THEME_STYLES'
,p_attribute_03=>'P177_ID'
,p_attribute_04=>'ID'
,p_attribute_11=>'I:U:D'
,p_internal_uid=>366545824442187570
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(366600703522413099)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'reset theme styles'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'update wwv_flow_theme_styles',
'set is_current = ''N''',
'where flow_id = :FB_FLOW_ID',
'and theme_id = :P177_THEME_ID',
'and id <> nvl(:P177_ID,0);',
'',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P177_IS_CURRENT'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'Y'
,p_internal_uid=>366600703522413099
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(366546027981187572)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_THEME_STYLES'
,p_attribute_02=>'WWV_FLOW_THEME_STYLES'
,p_attribute_03=>'P177_ID'
,p_attribute_04=>'ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>366546027981187572
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1909961414063636113)
,p_process_sequence=>35
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update current theme style'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_current_found boolean := false;',
'',
'begin',
'',
'  for c1 in (',
'    select * from wwv_flow_theme_styles',
'    where flow_id = :FB_FLOW_ID',
'    and theme_id = :P177_THEME_ID',
'    and is_current = ''Y''',
'  ) loop',
'    l_current_found := true;',
'  end loop;',
'  ',
'  if not l_current_found then',
'',
'    for c2 in (',
'      select * from wwv_flow_theme_styles',
'      where flow_id = :FB_FLOW_ID',
'      and theme_id = :P177_THEME_ID',
'      and rownum = 1',
'      order by id',
'    ) loop',
'',
'      update wwv_flow_theme_styles',
'      set is_current = ''Y''',
'      where flow_id = :FB_FLOW_ID',
'      and theme_id = :P177_THEME_ID',
'      and id = c2.id;',
'',
'    end loop;',
'',
'  end if;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>1909961414063636113
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(366546204770187572)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_CURRENT_PAGE'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(366543211381187548)
,p_internal_uid=>366546204770187572
);
end;
/
prompt --application/pages/page_00178
begin
wwv_flow_imp_page.create_page(
 p_id=>178
,p_name=>'List of Values Grid Edit'
,p_alias=>'LIST-OF-VALUES-GRID-EDIT'
,p_step_title=>'List of Values Grid Edit'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213211113434774960)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
,p_page_component_map=>'01'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7360030733387942)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>This page allows you to find and edit static list of value entries over all static lists of values.  Use this page to standardize display text.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(78381930700790807)
,p_name=>'Edit Static Display Entries'
,p_template=>wwv_flow_imp.id(646287526247383209)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P178a */',
'"ID",',
'"ID" pk1_DISPLAY,',
'lov_id fk,',
'(select wwv_flow_escape.html(lov_name) lov_name',
'   from WWV_FLOW_LISTS_OF_VALUES$ l',
'  where l.id = lov_id',
'    and l.security_group_id = :flow_security_group_id',
'  ) "LOV_ID",',
'"LOV_DISP_SEQUENCE",',
'"LOV_DISP_VALUE",',
'LOV_RETURN_VALUE',
'  from WWV_FLOW_LIST_OF_VALUES_DATA',
' where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and (:P178_NAME_CONTAINS is null or ',
'        instr(upper(lov_disp_value),upper(:P178_NAME_CONTAINS)) > 0)',
'   and (:P178_ITEM_NAME_DOES_NC is null or ',
'        instr(upper(lov_disp_value),upper(:P178_ITEM_NAME_DOES_NC)) = 0) ',
' order by lov_id, lov_disp_sequence, lov_disp_value'))
,p_translate_title=>'N'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>20
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
,p_comment=>'Region generated 10-JUL-2003 22:24:51'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(78382408978790814)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(78382519544790814)
,p_query_column_id=>2
,p_column_alias=>'PK1_DISPLAY'
,p_column_display_sequence=>2
,p_column_heading=>'Pk1'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(222727513847820017)
,p_query_column_id=>3
,p_column_alias=>'FK'
,p_column_display_sequence=>7
,p_column_heading=>'Foreign Key'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(78382621993790814)
,p_query_column_id=>4
,p_column_alias=>'LOV_ID'
,p_column_display_sequence=>3
,p_column_heading=>'List of Values Name'
,p_use_as_row_header=>'Y'
,p_column_link=>'f?p=4000:4111:&SESSION.::&DEBUG.:4111:F4000_P4111_ID:#FK#'
,p_column_linktext=>'#LOV_ID#'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(78382725441790814)
,p_query_column_id=>5
,p_column_alias=>'LOV_DISP_SEQUENCE'
,p_column_display_sequence=>4
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(78382804104790814)
,p_query_column_id=>6
,p_column_alias=>'LOV_DISP_VALUE'
,p_column_display_sequence=>5
,p_column_heading=>'Display Text'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>60
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(222721305994802392)
,p_query_column_id=>7
,p_column_alias=>'LOV_RETURN_VALUE'
,p_column_display_sequence=>6
,p_column_heading=>'Return Value'
,p_use_as_row_header=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(78385825643797902)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(78385931942797902)
,p_column_sequence=>2
,p_query_column_name=>'PK1_DISPLAY'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(222727012254820014)
,p_column_sequence=>3
,p_query_column_name=>'FK'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(78386014751797902)
,p_column_sequence=>4
,p_query_column_name=>'LOV_ID'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(78386127559797902)
,p_column_sequence=>5
,p_query_column_name=>'LOV_DISP_SEQUENCE'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(78386216052797903)
,p_column_sequence=>6
,p_query_column_name=>'LOV_DISP_VALUE'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(222721231402802382)
,p_column_sequence=>7
,p_query_column_name=>'LOV_RETURN_VALUE'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(184825020271437011)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(203029530177365353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Lists of Values'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(187936615571872203)
,p_plug_name=>'List of Value Filters'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(78389608936812053)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(187936615571872203)
,p_button_name=>'P178_GO'
,p_button_static_id=>'P178_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Go'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(188990116158000646)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(187936615571872203)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:178:&SESSION.::&DEBUG.:RP,178::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(78383012331790815)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(187936615571872203)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(78383925174790819)
,p_branch_action=>'f?p=&FLOW_ID.:178:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_comment=>'Generated 10-JUL-2003 22:24:51'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(78388828891808355)
,p_name=>'P178_NAME_CONTAINS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(187936615571872203)
,p_prompt=>'Display Text Contains'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Filer by name. Enter all or part of the list of values name you wish to find and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(78391123135816127)
,p_name=>'P178_ITEM_NAME_DOES_NC'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(187936615571872203)
,p_prompt=>'Display Text Does Not Contain'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Filer by name. Enter all or part of the lists of values name you do not wish to find and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(222729605908828323)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'178'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(78383503389790818)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(78381930700790807)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'ApplyMRU'
,p_attribute_02=>'WWV_FLOW_LIST_OF_VALUES_DATA'
,p_attribute_03=>'ID'
,p_attribute_05=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id'))
,p_process_error_message=>'Error processing update'
,p_process_when_button_id=>wwv_flow_imp.id(78383012331790815)
,p_exec_cond_for_each_row=>'Y'
,p_process_success_message=>'#MRU_COUNT# row(s) updated.'
,p_internal_uid=>78383503389790818
,p_process_comment=>'Generated 10-JUL-2003 22:24:51'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(78390315170813791)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'rp'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>78390315170813791
);
end;
/
prompt --application/pages/page_00179
begin
wwv_flow_imp_page.create_page(
 p_id=>179
,p_name=>'Switch Theme - Identify Theme'
,p_alias=>'SWITCH-THEME-IDENTIFY-THEME'
,p_step_title=>'Switch Theme - Identify Theme'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879423075323511)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_themes.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(20665725177591580)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(20663215911569971)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(57540512543180628)
,p_plug_name=>'Switch Theme'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in ( select count(*) counter from wwv_flow_themes where flow_id = :fb_flow_id) loop',
'  if c1.counter < 2 then ',
'    return false;',
'  else',
'    return true;',
'  end if;',
'end loop;'))
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>A theme is a collection of templates.  When you switch a theme, all templates assigned to components within one theme are assigned to templates in another theme. &PRODUCT_NAME. accomplishes template mapping through the assignment of template class'
||' identifiers.</p>',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(144843624145857063)
,p_plug_name=>'Switch Theme Error'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>30
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'You must have at least two themes installed to be able to switch. Please create a new theme and attempt this action again.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in ( select count(*) counter from wwv_flow_themes where flow_id = :fb_flow_id) loop',
'  if c1.counter < 2 then ',
'    return true;',
'  else',
'    return false;',
'  end if;',
'end loop;'))
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(200241204601309738)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747138472822138154)
,p_plug_name=>'Switch Theme'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(144849804667870344)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(200241204601309738)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(57541302915180632)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(200241204601309738)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in ( select count(*) counter from wwv_flow_themes where flow_id = :fb_flow_id) loop',
'  if c1.counter < 2 then ',
'    return false;',
'  else',
'    return true;',
'  end if;',
'end loop;'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'FUNCTION_BODY'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(57542602782180654)
,p_branch_name=>'Go To Page 386'
,p_branch_action=>'f?p=&FLOW_ID.:386:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57542128541180635)
,p_name=>'P179_NEW_THEME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(57540512543180628)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t_new.theme_id',
'  from wwv_flow_themes t_old,',
'       wwv_flow_themes t_new',
' where t_old.flow_id    = :FB_FLOW_ID',
'   and t_old.theme_id   = :P179_OLD_THEME',
'   and t_old.security_group_id = :WORKSPACE_ID',
'   and t_new.flow_id    = t_old.flow_id',
'   and t_new.theme_id  <> t_old.theme_id',
'   and t_new.security_group_id = :WORKSPACE_ID',
' order by t_new.theme_id',
' fetch first 1 row only'))
,p_item_default_type=>'SQL_QUERY'
,p_prompt=>'Switch to Theme:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t_new.theme_id||''. ''||t_new.theme_name as d,',
'       t_new.theme_id',
'  from wwv_flow_themes t_old,',
'       wwv_flow_themes t_new',
' where t_old.flow_id    = :FB_FLOW_ID',
'   and t_old.theme_id   = :P179_OLD_THEME',
'   and t_old.security_group_id = :WORKSPACE_ID',
'   and t_new.flow_id    = t_old.flow_id',
'   and t_new.theme_id  <> t_old.theme_id',
'   and t_new.security_group_id = :WORKSPACE_ID',
' order by t_new.theme_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select New Theme -'
,p_lov_cascade_parent_items=>'P179_OLD_THEME'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies a collection of templates which define the look and feel of the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57563303743234936)
,p_name=>'P179_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(57540512543180628)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application:'
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'This attribute identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57564313786237858)
,p_name=>'P179_OLD_THEME'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(57540512543180628)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.theme_id',
'  from wwv_flows f,',
'       wwv_flow_themes t',
' where f.id                = :FB_FLOW_ID',
'   and f.security_group_id = :WORKSPACE_ID',
'   and t.flow_id           = f.id',
'   and t.theme_id          = f.theme_id',
'   and t.security_group_id = :WORKSPACE_ID'))
,p_item_default_type=>'SQL_QUERY'
,p_prompt=>'Currently Active Theme:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES (ACTIVE)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.theme_id||''. '' ||t.theme_name as d,',
'       t.theme_id',
'  from wwv_flows f,',
'       wwv_flow_themes t',
' where f.id                = :FB_FLOW_ID',
'   and f.security_group_id = :WORKSPACE_ID',
'   and t.flow_id           = f.id',
'   and t.theme_id          = f.theme_id',
'   and t.security_group_id = :WORKSPACE_ID',
' order by t.theme_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Old Theme - '
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies a collection of templates which define the look and feel of the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1403861677396685859)
,p_name=>'P179_MATCHING_TEMPLATES_ONLY'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(57540512543180628)
,p_item_default=>'N'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'When switching to a new theme, App Builder maps all currently used templates to a template in the new theme',
'using the template class. When <strong>Match Template Class</strong> is set to <strong>No</strong>, then templates can be switched to any template',
'with the same type, but irrespective of the template class.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1403940863419758219)
,p_name=>'P179_RESET_GRID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(57540512543180628)
,p_item_default=>'ALL'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>When switching from one theme to another theme you have the option to reset the region and item grid settings. The grid settings define the positioning of your regions and items on a page. Regions might be positioned next to each other or you migh'
||'t have a form that has two or more items in a single row. Resetting the grid will remove these settings and render all regions and items stacked up vertically. </p>',
'',
'<p>When switching from a theme using a table-based grid, such as Theme 26 (Productivity Applications), to a theme using a DIV-based grid, like Theme 42 (Universal Theme) any regions that have a fixed position need to be reset, i.e. the "Reset fixed r'
||'egion positions" option needs to be selected.  </p>',
'',
'<p>When switching from one theme to another theme, where both themes use the same grid type, no reset is required, and the "Keep current region and item grid settings" option can be selected.</p>',
'',
'<p>It is also possible to reset the grid for all regions and items. This is useful when switching from an old theme to a newer, DIV-based theme in order to prepare for re-doing the page and form layout for all pages. Please note that all previous reg'
||'ion and item position settings will be lost when choosing this option.</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2123446896307517682)
,p_validation_name=>'theme compatible'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_theme_manager.is_theme_switch_allowed (',
'        p_flow_id    => :fb_flow_id,',
'        p_from_theme => :P179_OLD_THEME,',
'        p_to_theme   => :P179_NEW_THEME ',
');'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':P179_OLD_THEME is not null and :P179_NEW_THEME is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(57542128541180635)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00180
begin
wwv_flow_imp_page.create_page(
 p_id=>180
,p_name=>'Switch Theme - Confirm'
,p_alias=>'SWITCH-THEME-CONFIRM'
,p_step_title=>'Switch Theme - Confirm'
,p_allow_duplicate_submissions=>'N'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879423075323511)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_themes.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(20670800897981927)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(20663215911569971)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(57550105400205036)
,p_plug_name=>'Confirm Theme Switch'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<div class="htmldbInfoBodyP">Switching your theme may result in template issues if multiple templates are defined with the same template class identifier. Before switching a template, it is recommended you create a back up of your application before '
||'continuing.</div>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(200242619277323456)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747138588615138154)
,p_plug_name=>'Switch Theme'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(57551727484205045)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(200242619277323456)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:260:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(57550920594205040)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(200242619277323456)
,p_button_name=>'SWITCH_THEME'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Switch Theme'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(57551303628205044)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(200242619277323456)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:386:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(57553006772205064)
,p_branch_action=>'f?p=&FLOW_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57552132231205047)
,p_name=>'P180_CURRENTLY_ACTIVE_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(57550105400205036)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Currently Active Theme:'
,p_source=>'P179_OLD_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identifies a collection of templates which define the look and feel of the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57807623669054439)
,p_name=>'P180_SWITCH_TO_THEME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(57550105400205036)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Switch To Theme:'
,p_source=>'P179_NEW_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identifies a collection of templates which define the look and feel of the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57815203499067515)
,p_name=>'P180_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(57550105400205036)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application:'
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'This attribute identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(57552632028205061)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'switch theme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'',
'    wwv_flow.g_import_in_progress := true;',
'    wwv_flow_theme_manager.switch_theme (',
'        p_flow_id    => :fb_flow_id,',
'        p_from_theme => :P179_OLD_THEME,',
'        p_to_theme   => :P179_NEW_THEME );',
'    wwv_flow.g_import_in_progress := false;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to switch theme.'
,p_process_when_button_id=>wwv_flow_imp.id(57550920594205040)
,p_process_success_message=>'Active Theme Switched.'
,p_internal_uid=>57552632028205061
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1859459502655404972)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'reset grid'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'',
'    -- reset grid, either only for regions in fixed positions, or all regions and items, or none if reset not selected',
'',
'    if :P179_RESET_GRID = ''REGIONONLY'' then',
'',
'        update wwv_flow_page_plugs',
'           set plug_new_grid         = ''N'',',
'               plug_new_grid_row     = ''Y'',',
'               plug_new_grid_column  = ''Y'',',
'               plug_display_column   = null,',
'               plug_grid_column_span = null',
'         where flow_id = :fb_flow_id',
'           and plug_display_column is not null;',
'         ',
'    elsif :P179_RESET_GRID = ''ALL'' then',
'',
'        -- reset item grid',
'        update wwv_flow_step_items',
'           set new_grid            = ''N'',',
'               begin_on_new_line   = ''Y'',',
'               begin_on_new_field  = ''Y'',',
'               colspan             = null,',
'               rowspan             = null',
'         where flow_id = :fb_flow_id;',
'',
'        -- reset region grid',
'        update wwv_flow_page_plugs',
'           set plug_new_grid         = ''N'',',
'               plug_new_grid_row     = ''Y'',',
'               plug_new_grid_column  = ''Y'',',
'               plug_display_column   = null,',
'               plug_grid_column_span = null',
'         where flow_id = :fb_flow_id;',
'',
'    end if;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(57550920594205040)
,p_internal_uid=>1859459502655404972
);
end;
/
prompt --application/pages/page_00181
begin
wwv_flow_imp_page.create_page(
 p_id=>181
,p_name=>'Icon Picker'
,p_alias=>'ICON-PICKER'
,p_page_mode=>'MODAL'
,p_step_title=>'Icon Picker'
,p_autocomplete_on_off=>'OFF'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/* Init Modal */',
'initWizardModal = function() {',
'    function _initDialog() {',
'        var headerheight = $(''.a-Dialog-wizardSteps'').height(),',
'            footerheight = $(''.a-Dialog-footer'').height();',
'        $(''.a-Dialog-body'').css({',
'            ''top'':headerheight,',
'            ''bottom'':footerheight',
'        });',
'    }',
'    $(window).bind(''apexwindowresized'', function() {',
'        _initDialog();',
'    });',
'    _initDialog();',
'};',
'',
'',
'apex.create_app_wizard = apex.create_app_wizard || {};',
'',
'(function( $ ){',
'',
'	var icons = {},',
'		iconCont$;',
'',
'	var getIcons = function (){',
'        var data = {},',
'            links$ = $( ''a.a-PWIconPicker-link'' );',
'',
'        links$.each(function( index ) {',
'            var that$ = $( this )',
'            data[ that$.attr( ''id'' ) ] = that$.data( ''filters'' );',
'        });',
'',
'        return data;',
'    };',
'',
'    var search = function( key ){',
'    	var key = key.trim().toLowerCase(),',
'    		keyLen = key.length;',
'',
'    	var resetList = function(){',
'    		iconCont$',
'    			.removeClass( ''js-searching'' )',
'    			.find( ''.js-hit'' )',
'    			.removeClass( ''js-hit'' );',
'    	};',
'',
'    	resetList();',
'',
'    	if ( key.length >= 2 ) {',
'',
'    		iconCont$.addClass( ''js-searching'' );',
'',
'	    	for ( var k in icons ) {',
'	    		if ( icons.hasOwnProperty(k) ) {',
'	    			if ( k.indexOf( key ) != -1 || icons[k].indexOf( key ) != -1 ) {',
'	    				$( ''#'' + k )',
'	    					.parent()',
'	    					.addClass( ''js-hit'' );',
'	    			}',
'	    		}',
'	    	}',
'    	}',
'    };',
'',
'    var passBack = function( icon, passToUi, passToSave ) {',
'        ',
'        var parentWindow = parent.window,',
'            windowCount = parentWindow.length,',
'            // If it is only 1 level, the parent.window is the one that opens this dialog.',
'            // If this page in deeper than 1 dialog, we need to get to the dialog above it',
'            // by using parent.window[ windowCount - 2 ]',
'            jQueryInOtherDialog$ = windowCount > 1 ?  parentWindow[ windowCount - 2 ].apex.jQuery : parentWindow.apex.jQuery,',
'            iconSpan$ = jQueryInOtherDialog$( ''#'' + passToUi ).find( ''span.a-Icon'' ),',
'        	lastClass = iconSpan$.attr(''class'').split('' '').pop();',
'',
'        iconSpan$',
'            .removeClass( lastClass )',
'            .addClass( ''fa '' + icon );',
'',
'        jQueryInOtherDialog$( ''#'' + passToSave ).val( icon );',
'        apex.util.getTopApex().navigation.dialog.cancel(true);',
'    };',
'',
'	apex.create_app_wizard.initIconSearch = function( options ){',
'',
'		icons = getIcons(),',
'',
'		iconCont$ = $( ''#'' + options.container || ''icons'' );',
'',
'		iconCont$.on( ''click'', ''a.a-PWIconPicker-link'', function(){',
'	        var iconName = $( this ).attr( ''id'' );',
'	        passBack( iconName, options.passToUi, options.passToSave );',
'	    } );',
'	    ',
'	    $( ''#'' + options.searchField ).on( ''keyup'', function(){',
'	    	var k = this.value;',
'		    setTimeout(function() {',
'	        	search( k );',
'	        }, 500);',
'	    })',
'	};',
'',
'})( apex.jQuery );'))
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'initWizardModal();',
'',
'apex.create_app_wizard.initIconSearch({',
'    "container":     "icons",',
'    "searchField":   "P181_SEARCH",',
'    "passToUi":      "&P181_PASS_BACK_TO_UI.",',
'    "passToSave":    "&P181_PASS_BACK_TO_SAVE."',
'});'))
,p_css_file_urls=>'#FONT_APEX_LATEST_DIRECTORY#css/font-apex#MIN#.css'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.js-searching li {',
'    display: none;',
'}',
'',
'.js-searching li.js-hit {',
'    display: block;',
'}'))
,p_page_css_classes=>'a-PageWizard-dialog a-PageWizard-dialog--icons'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'440'
,p_dialog_width=>'400'
,p_dialog_attributes=>'resizable:true'
,p_dialog_chained=>'N'
,p_protection_level=>'C'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4800736592096903)
,p_plug_name=>'Search Bar'
,p_region_css_classes=>'a-PWIconPicker-search'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4801305408096909)
,p_plug_name=>'Icon List - PLSQL'
,p_region_name=>'icons'
,p_region_css_classes=>'icon-list'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'',
'    sys.htp.p( ''<ul class="a-PWIconPicker">'' );',
'    ',
'    for c1 in ( ',
'        select icon_name, ',
'               icon_filters,',
'               trim( regexp_replace(icon_name,''(^fa)|[\-]'','' '') ) as icon_description',
'          from wwv_flow_standard_icons',
'         where icon_library = ''FONTAPEX''',
'         order by icon_name )',
'    loop',
'',
'        sys.htp.p( ''<li class="a-PWIconPicker-item">''',
'            || ''<a href="javascript:void(0)" class="a-PWIconPicker-link" ''',
'            || ''id="'' || c1.icon_name || ''" ''',
'            || ''data-filters="'' || c1.icon_filters || ''" ''',
'            || ''aria-label="'' || wwv_flow_escape.html_attribute( c1.icon_description ) || ''" ''            ',
'            || ''>''',
'            || ''<span class="t-Icon fa '' || c1.icon_name || ''" aria-hidden="true"></span>''',
'            || ''</a></li>'' );',
'    end loop;',
'    ',
'    sys.htp.p( ''</ul>'' );',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_comment=>'TODO - Need to check how server caching can be utilized for this, may be based on theme refresh date?'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4800843869096904)
,p_name=>'P181_COUNT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(4800736592096903)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4800991446096905)
,p_name=>'P181_SEARCH'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(4800736592096903)
,p_prompt=>'Search Icons'
,p_placeholder=>'Search all &P181_COUNT. icons ...'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_css_classes=>'a-PWIconPicker-searchInput'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4801053411096906)
,p_name=>'P181_PASS_BACK_TO_UI'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(4800736592096903)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4801188847096907)
,p_name=>'P181_PASS_BACK_TO_SAVE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(4800736592096903)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4801220370096908)
,p_name=>'P181_SELECTED_ICON'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(4800736592096903)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4801460513096910)
,p_name=>'Cancel Enter'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P181_SEARCH'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'this.browserEvent.which === 13'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'keypress'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4801533343096911)
,p_event_id=>wwv_flow_imp.id(4801460513096910)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CANCEL_EVENT'
);
end;
/
prompt --application/pages/page_00182
begin
wwv_flow_imp_page.create_page(
 p_id=>182
,p_name=>'Workspace Utilities'
,p_alias=>'WORKSPACE-UTILITIES'
,p_step_title=>'Workspace Utilities'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(5507013954294272)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_utilties.htm'
,p_page_component_map=>'06'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(699056466931610167)
,p_plug_name=>'Workspace Utilities'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-MediaList--cols a-MediaList--2cols'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_list_id=>wwv_flow_imp.id(2778715503937249)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(693422331030340241)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(699448947770355317)
,p_plug_name=>'About'
,p_region_css_classes=>'a-Region--stacked a-Region--padded a-Region--flush a-Region--sideRegion'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page contains links to common workspace utilities such as defining Application Defaults, Managing News, Workspace Themes, and more.</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(702929143076173489)
,p_plug_name=>'Cross Application Reports'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>90
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(702923103587108064)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(699057074956610180)
,p_branch_action=>'f?p=&FLOW_ID.:182:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_00184
begin
wwv_flow_imp_page.create_page(
 p_id=>184
,p_name=>'Create Authorization Scheme - Creation Method'
,p_alias=>'CREATE-AUTHORIZATION-SCHEME-CREATION-METHOD'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Authorization Scheme'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213425326892450628)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_authorization.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46430908800978376)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(186773307550199098)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(186911322244744240)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_plug_query_headings=>'Flow:From Name:To Name:Copy'
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_no_data_found=>'<font class="fieldtitleleft">No Security Schemes Found.</font>'
,p_plug_query_show_nulls_as=>'(null)'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(186773601550199100)
,p_plug_name=>'Create Authorization Scheme'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<p>Specify how you want to create your authorization scheme. You can create an authorization scheme from scratch or copy it from another application. If you copy an authorization scheme, you can modify later.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(186773928558199101)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46430908800978376)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(186774212285199102)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(46430908800978376)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(186775126956199109)
,p_branch_action=>'185'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(186774212285199102)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND_TEXT'
,p_branch_condition=>'F4000_P184_WIZ_TYPE'
,p_branch_condition_text=>'COPY'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(186775404827199112)
,p_branch_action=>'188'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(186774212285199102)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND_TEXT'
,p_branch_condition=>'F4000_P184_WIZ_TYPE'
,p_branch_condition_text=>'BLANK'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(186775703907199113)
,p_branch_action=>'4070'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(186773928558199101)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(186774500955199104)
,p_name=>'F4000_P184_WIZ_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(186773601550199100)
,p_item_default=>'BLANK'
,p_prompt=>'Create Authorization Scheme:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'AUTH_WIZ_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(84347110372647083)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'<p>Select how you want to create your authorization scheme.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(574333632303476048)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(186773928558199101)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(574333701398476049)
,p_event_id=>wwv_flow_imp.id(574333632303476048)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00185
begin
wwv_flow_imp_page.create_page(
 p_id=>185
,p_name=>'Create Authorization Scheme - Copy From'
,p_alias=>'CREATE-AUTHORIZATION-SCHEME-COPY-FROM'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Authorization Scheme'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213425326892450628)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_authorization.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46432109623988163)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(186778011895202645)
,p_plug_name=>'Create Authorization Scheme'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>'<p>Use this page to copy authorization schemes from within the current application or between applications.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(186779818719202661)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(186904126354727159)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_plug_query_headings=>'Flow:From Name:To Name:Copy'
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_no_data_found=>'<font class="fieldtitleleft">No Security Schemes Found.</font>'
,p_plug_query_show_nulls_as=>'(null)'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(186778628039202649)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(46432109623988163)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(186778909954202650)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(46432109623988163)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(186778318308202647)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46432109623988163)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(186780722310202667)
,p_branch_action=>'186'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(186778909954202650)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(186780402454202665)
,p_branch_action=>'184'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(186778318308202647)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(186780102470202663)
,p_branch_action=>'4070'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(186778628039202649)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(186779206811202652)
,p_name=>'F4000_P185_COPY_FROM_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(186778011895202645)
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Copy From Application'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select an Application -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Select the application from which you want to copy an authorization schemes.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_item_comment=>'select name||'' (''||id||'')'', id from wwv_flows where id = v(''FB_FLOW_ID'')'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(186781009833202668)
,p_validation_name=>'F4000_P185_COPY_FROM_FLOW_ID Not Null'
,p_validation_sequence=>10
,p_validation=>'F4000_P185_COPY_FROM_FLOW_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Application ID must be specified.'
,p_associated_item=>wwv_flow_imp.id(186779206811202652)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 18-FEB-2002 15:48'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(574333490919476046)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(186778628039202649)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(574333519912476047)
,p_event_id=>wwv_flow_imp.id(574333490919476046)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00186
begin
wwv_flow_imp_page.create_page(
 p_id=>186
,p_name=>'Create Authorization Scheme - Names'
,p_alias=>'CREATE-AUTHORIZATION-SCHEME-NAMES'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Authorization Scheme'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213425326892450628)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_authorization.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46433406768006193)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(186783329924204965)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(186904126354727159)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_plug_query_headings=>'Flow:From Name:To Name:Copy'
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_no_data_found=>'<font class="fieldtitleleft">No Security Schemes Found.</font>'
,p_plug_query_show_nulls_as=>'(null)'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(186783619515204966)
,p_name=>'Create Authorization Scheme'
,p_template=>wwv_flow_imp.id(42025417508627628)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'       flow_id,',
'       name,',
'       wwv_flow_item.text(1,wwv_flow_lang.system_message(''F4000.P158.COPY_OF'',name),40) to_name,',
'       wwv_flow_item.select_list (',
'           2,',
'           ''N'',',
'           m_yes||'';Y,''||m_no||'';N,''||m_copy_sub||'';SUBSCRIBE'') copy_subscribe,',
'       wwv_flow_item.hidden(3,id) id',
'  from wwv_flow_security_schemes,',
'       ( select wwv_flow_lang.system_message(''F4000.YES'') m_yes,',
'                wwv_flow_lang.system_message(''F4000.NO'')  m_no,',
'                wwv_flow_lang.system_message(''F4000_COPY_AND_SUBSCRIBE'') m_copy_sub',
'           from dual',
'       )',
' where flow_id           = :F4000_P185_COPY_FROM_FLOW_ID ',
'   and security_group_id = :flow_security_group_id',
' order by 1,2'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>'Application &F4000_P185_COPY_FROM_FLOW_ID!HTML. contains no authorization schemes.'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(923576240862744008)
,p_query_column_id=>1
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Application'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(923576384367744009)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'From Name'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(923576461173744010)
,p_query_column_id=>3
,p_column_alias=>'TO_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'To Name'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(923576580191744011)
,p_query_column_id=>4
,p_column_alias=>'COPY_SUBSCRIBE'
,p_column_display_sequence=>4
,p_column_heading=>'Copy'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'#COPY_SUBSCRIBE##ID#'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(923576613084744012)
,p_query_column_id=>5
,p_column_alias=>'ID'
,p_column_display_sequence=>5
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(186784206001204969)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46433406768006193)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(186783919387204968)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(46433406768006193)
,p_button_name=>'Copy'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy'
,p_button_position=>'CREATE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_security_schemes',
'where flow_id = :F4000_P185_COPY_FROM_FLOW_ID',
'and security_group_id = :flow_security_group_id'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(186784501461204970)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(46433406768006193)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(186785416089204975)
,p_branch_action=>'4070'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(186783919387204968)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(186784819829204972)
,p_branch_action=>'4070'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(186784206001204969)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(186785105515204974)
,p_branch_action=>'185'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(186784501461204970)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1416506952923466)
,p_validation_name=>'No duplicate subscription'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_exists     varchar2(255);',
'    l_found_name varchar2(32767);',
'begin',
'    for i in 1..wwv_flow.g_f03.count loop',
'        if wwv_flow.g_f02(i) in (''SUBSCRIBE'') then',
'            -- see if a subscription already exists for the authorization scheme',
'            begin',
'                select name',
'                  into l_exists',
'                  from wwv_flow_security_schemes',
'                 where security_group_id = :WORKSPACE_ID',
'                   and flow_id = :FB_FLOW_ID',
'                   and reference_id = wwv_flow.g_f03(i);',
'',
'                -- if we get here then a duplicate name exists',
'                if l_found_name is null then ',
'                  l_found_name := l_exists;',
'                else ',
'                  l_found_name := l_found_name||'', ''||l_exists;',
'                end if;',
'            exception',
'                when no_data_found then',
'                    -- do nothing if no duplicate exists.',
'                    null; ',
'            end;',
'        end if;',
'    end loop;',
'',
'    if l_found_name is not null then ',
'        return wwv_flow_lang.system_message(''F4000.SEC_SCHEME_SUBSCRIPTION_ALREADY_EXISTS'',',
'                                            l_found_name);',
'    else',
'        return null;',
'    end if;    ',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_when_button_pressed=>wwv_flow_imp.id(186783919387204968)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4172009398198018)
,p_validation_name=>'No duplicate names'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_exists     varchar2(255);',
'    l_found_name varchar2(32767);',
'begin',
'    for i in 1..wwv_flow.g_f03.count loop',
'        if wwv_flow.g_f02(i) in (''Y'', ''SUBSCRIBE'') then',
'            -- see if a subscription already exists for the authorization scheme',
'            begin',
'                select name',
'                  into l_exists',
'                  from wwv_flow_security_schemes',
'                 where security_group_id = :WORKSPACE_ID',
'                   and flow_id = :FB_FLOW_ID',
'                   and name = nvl(wwv_flow.g_f01(i),''Copy of ''||i);',
'',
'                -- if we get here then a duplicate name exists',
'                if l_found_name is null then ',
'                  l_found_name := l_exists;',
'                else ',
'                  l_found_name := l_found_name||'', ''||l_exists;',
'                end if;',
'            exception',
'                when no_data_found then',
'                    -- do nothing if no duplicate exists.',
'                    null; ',
'            end;',
'        end if;',
'    end loop;',
'',
'    if l_found_name is not null then ',
'        return wwv_flow_lang.system_message(''F4000.SEC_SCHEME_NAME_ALREADY_EXISTS'',',
'                                            l_found_name);',
'    else',
'        return null;',
'    end if;    ',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_when_button_pressed=>wwv_flow_imp.id(186783919387204968)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(574333185197476043)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(186784206001204969)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(574333219235476044)
,p_event_id=>wwv_flow_imp.id(574333185197476043)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(186785732448204976)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Security Scheme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'wwv_flow_debug.enter (',
'   ''Copy Security Scheme'',',
'   ''g_f01.count'', wwv_flow.g_f01.count,',
'   ''g_f02.count'', wwv_flow.g_f02.count,',
'   ''g_f03.count'', wwv_flow.g_f03.count,',
'   ''g_f04.count'', wwv_flow.g_f04.count );',
'for i in 1..wwv_flow.g_f03.count loop',
'  if wwv_flow.g_f02(i) in (''Y'',''SUBSCRIBE'') then',
'    wwv_flow_copy_util.copy_security_scheme (',
'      p_copy_from_flow_id  => :F4000_P185_COPY_FROM_FLOW_ID,',
'      p_flow_id            => :fb_flow_id,',
'      p_from_scheme_id     => wwv_flow.g_f03(i),',
'      p_to_scheme_name     => nvl(wwv_flow.g_f01(i),''Copy of ''||i),',
'      p_subscribe          => (wwv_flow.g_f02(i) = ''SUBSCRIBE'') );',
'  end if;',
'end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying authorization scheme(s).'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(186783919387204968)
,p_process_success_message=>'Authorization scheme(s) copied.'
,p_internal_uid=>186785732448204976
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(574333355827476045)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,F4000_LAST_VIEW'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(186783919387204968)
,p_process_success_message=>'Authorization scheme(s) copied.'
,p_internal_uid=>574333355827476045
);
end;
/
prompt --application/pages/page_00188
begin
wwv_flow_imp_page.create_page(
 p_id=>188
,p_name=>'Create Authorization Scheme - Details'
,p_alias=>'CREATE-AUTHORIZATION-SCHEME-DETAILS'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Authorization Scheme'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213425326892450628)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_authorization.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(10823606153399570)
,p_plug_name=>'Add Javascript code for Plugins'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>200
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    -- create the onChange event for the F4000_P188_SCHEME_TYPE and',
'    -- also the initialization code for the dynamic attributes',
'    wwv_flow_plugin_dev.add_onload_code (',
'        p_plugin_type         => wwv_flow_plugin.c_plugin_type_authorization,',
'        p_type_page_item_name => ''F4000_P188_SCHEME_TYPE'',',
'        p_page_item_prefix    => ''P188_'',',
'        p_is_wizard           => true );',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(186970606141820893)
,p_plug_name=>'Evaluation Point'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>170
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(186971220738820895)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(186972714623820901)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(186911322244744240)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(186973018734820902)
,p_plug_name=>'Authorization Scheme'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>130
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_header=>'<p>Use this page to define an authorization scheme. By creating an authorization schemes, you can protect applications, pages, and application components and extend the security provided by your application authentication scheme. You can use authoriz'
||'ation schemes to identify additional security beyond simple user authentication. For example a user with administration rights may need access to more navigation bar icons, pages, and tabs than other users.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'generated 09-DEC-2000 21:06:40'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(186974225235820906)
,p_plug_name=>'Comments'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>180
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(186976325397820915)
,p_plug_name=>'Authorization  Scheme'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>140
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(186971513800820896)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(186971220738820895)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(186972400577820899)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(186971220738820895)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Authorization Scheme'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(187051016967915954)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(186971220738820895)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(186978129570820942)
,p_branch_action=>'4070'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(186972400577820899)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(187051403321915958)
,p_branch_action=>'184'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(187051016967915954)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(186979001171820946)
,p_branch_action=>'4070'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(186971513800820896)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10831832472407136)
,p_name=>'P188_ATTRIBUTE_01'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(186976325397820915)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_01'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10832028398407137)
,p_name=>'P188_ATTRIBUTE_02'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(186976325397820915)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_02'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10832230802407137)
,p_name=>'P188_ATTRIBUTE_03'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(186976325397820915)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_03'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10832432505407137)
,p_name=>'P188_ATTRIBUTE_04'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(186976325397820915)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_04'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10832617540407138)
,p_name=>'P188_ATTRIBUTE_05'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(186976325397820915)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_05'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10832831374407141)
,p_name=>'P188_ATTRIBUTE_06'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(186976325397820915)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_06'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10833001084407141)
,p_name=>'P188_ATTRIBUTE_07'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(186976325397820915)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_07'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10833221837407141)
,p_name=>'P188_ATTRIBUTE_08'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(186976325397820915)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_08'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10833404437407141)
,p_name=>'P188_ATTRIBUTE_09'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(186976325397820915)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_09'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10833616508407142)
,p_name=>'P188_ATTRIBUTE_10'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(186976325397820915)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_10'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10833819349407142)
,p_name=>'P188_ATTRIBUTE_11'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(186976325397820915)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_11'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10834002041407142)
,p_name=>'P188_ATTRIBUTE_12'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(186976325397820915)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_12'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10834218697407142)
,p_name=>'P188_ATTRIBUTE_13'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(186976325397820915)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_13'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10834415036407143)
,p_name=>'P188_ATTRIBUTE_14'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(186976325397820915)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_14'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10834622868407143)
,p_name=>'P188_ATTRIBUTE_15'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(186976325397820915)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_15'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(186970910581820894)
,p_name=>'F4000_P188_CACHING'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(186970606141820893)
,p_use_cache_before_default=>'NO'
,p_item_default=>'BY_USER_BY_SESSION'
,p_prompt=>'Validate authorization  scheme:'
,p_source=>'CACHING'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'AUTH_SCHEME_CACHING'
,p_lov=>'.'||wwv_flow_imp.id(84860700520374929)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Authorization schemes are evaluated on first use in a session.',
'The <em>Validate authorization scheme</em> attribute controls if future uses cause re-evaluations and when a memorized result can be taken instead.',
'The list below describes the available options:',
'</p>',
'<ul>',
'<li><strong>Once per session:</strong> Evaluate only once and always use the memorized result afterwards.</li>',
'<li><strong>Once per page view:</strong> Evaluate once for each request that is processed. Use the memorized result if the authorization scheme is referenced in more than one component on the page.</li>',
'<li><strong>Once per component:</strong> Evaluate once for each component that references the authorization scheme, but save the result in the session. Further requests to render or process the scheme use the memorized result.</li>',
'<li><strong>Always (No Caching):</strong> The authorization scheme will always be evaluated.</li>',
'</ul>',
'<p>',
'The default value <em>Once per session</em> is the most efficient.',
'You should choose another value if the authorization check depends on changing session state or other factors that are not consistent over an entire session.',
'The options <em>Once per component</em> and <em>Always (No Caching)</em> provide additional information about the component that is secured by the authorization scheme.',
'In authorization plugins, you can use the <em>component.type</em>, <em>component.id</em> and <em>component.name</em> attributes of the <em>t_authorization</em> parameter.',
'For the built-in <em>Exists SQL Query</em> and <em>PL/SQL Function</em> scheme types, equivalent bind variables <em>:APP_COMPONENT_TYPE</em>, <em>:APP_COMPONENT_ID</em> and <em>:APP_COMPONENT_NAME</em> are available.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(186973320389820903)
,p_name=>'F4000_P188_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(186973018734820902)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Application:'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LIST FLOWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'where  build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'order by 2'))
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'<p>Identifies the current application.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(186973612706820904)
,p_name=>'F4000_P188_NAME'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(186973018734820902)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter an unique name that identifies this authorization scheme.</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(186973925391820905)
,p_name=>'F4000_P188_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(186973018734820902)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(186974523106820907)
,p_name=>'F4000_P188_COMMENTS'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(186974225235820906)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comments'
,p_source=>'COMMENTS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'<p>Enter any comments or notes here.  These comments will never be displayed when running the application</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(186976606472820937)
,p_name=>'F4000_P188_SCHEME_TYPE'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(186976325397820915)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Scheme Type'
,p_source=>'SCHEME_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'AUTHORIZATION TYPE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,',
'       r',
'  from (',
'        select wwv_flow_lang.system_message(''AUTHORIZATION_NAME.''|| name_with_prefix) as d,',
'               name_with_prefix      as r',
'          from wwv_flow_native_plugins',
'         where plugin_type = ''AUTHORIZATION TYPE''',
'         union all',
'        select display_name || wwv_flow_lang.system_message(''PLUGIN.DISPLAY_NAME_POSTFIX'') as d,',
'               ''PLUGIN_'' || name     as r',
'          from wwv_flow_plugins',
'         where flow_id           = to_number(:FB_FLOW_ID)',
'           and security_group_id = to_number(:WORKSPACE_ID)',
'           and plugin_type       = ''AUTHORIZATION TYPE''',
'       )',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Authorization Scheme Type -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select how this authorization scheme will be applied. The following built-in types are supported:</p>',
'<ul>',
'<li><strong>Exists SQL Query:</strong> A query that causes the authorization scheme to pass if it returns at least one row and causes the scheme to fail if it returns no rows</li>',
'<li><strong>NOT Exists SQL Query:</strong> A query that causes the authorization scheme to pass if it returns no rows and causes the scheme to fail if it returns one or more rows</li>',
'<li><strong>PL/SQL Function Returning Boolean:</strong> A PL/SQL function body that returns true or false. A false value causes the authorization scheme to fail. A true value causes it to pass.</li>',
'<li><strong>Item in Expression 1 is null:</strong> Value of item named in expression 1 is null.</li>',
'<li><strong>Item in Expression 1 is not null:</strong> Value of item named in expression 1 is not null.</li>',
'<li><strong>Value of Preference in Expression 1 Equals Expression 2:</strong> Value of preference named in expression 1 equals expression 2.</li>',
'<li><strong>Value of Preference in Expression 1 Does Not Equal Expression 2:</strong> Value of preference named in expression 1 does not equal expression 2.</li>',
'<li><strong>Value of Item in Expression 1 Equals Expression 2:</strong> Value of item named in expression 1 equals expression 2.</li>',
'<li><strong>Value of Item in Expression 1 Does NOT Equal Expression 2:</strong> Value of item named in expression 1 does not equal expression 2.</li>',
'<li><strong>Is In Role or Group:</strong> Checks the provided comma-separated roles/groups names against the user''s roles/groups for which the source is configured with the application security attribute <strong>Source for Role or Group Schemes</stro'
||'ng>.',
'<p>If the source is set to <em>Access Control User Role Assignments</em>, the authorization process will only consider the user''s granted ACL roles.</p>',
'<p>Otherwise, it will check if the groups are enabled as dynamic groups for the session (see APEX_AUTHORIZATION.ENABLE_DYNAMIC_GROUPS). If the application uses an Authentication scheme configured with Real Security Application (RAS) this check will i'
||'nclude RAS session roles. if Oracle APEX Accounts Authentication is used, this check also includes workspace groups that are granted to the user. If Database Authentication is used, this check also includes database roles that are granted to the user'
||'.</p>',
'<p>The authorization scheme succeed, If the user is granted any of the designated roles/groups.</p>',
'</li>',
'<li><strong>Is Not In Group:</strong> Group is not enabled or granted to the user. See <strong>Is In Group</strong> for details.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(186977502755820940)
,p_name=>'F4000_P188_ERROR_MESSAGE'
,p_item_sequence=>380
,p_item_plug_id=>wwv_flow_imp.id(186976325397820915)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Identify error message displayed when scheme violated'
,p_source=>'ERROR_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This is the error text that displays when this authorization scheme is applied to a application or page.</p>',
'<p>If the authorization scheme fails (that is, the current user fails the security check) then this text displays.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(270558972915579257)
,p_validation_name=>'Name Unique'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from WWV_FLOW_SECURITY_SCHEMES',
'where security_group_id = :flow_security_group_id ',
'and   flow_id = :FB_FLOW_ID ',
'and   id != nvl(:F4000_P188_ID, -1)',
'and   name = :F4000_P188_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#LABEL# must be unique.'
,p_when_button_pressed=>wwv_flow_imp.id(186972400577820899)
,p_associated_item=>wwv_flow_imp.id(186973612706820904)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(186999700604845441)
,p_validation_name=>'naming convention on name'
,p_validation_sequence=>20
,p_validation=>'substr(:F4000_P188_NAME,1,1) not in (''!'',''0'',''1'',''2'',''3'',''4'',''5'',''6'',''7'',''8'',''9'','' '')'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Name must be specified.'
,p_associated_item=>wwv_flow_imp.id(186973612706820904)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 04-MAR-2002 16:40'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(10823531517387974)
,p_validation_name=>'Validate Plugin Attributes'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.validate_attribute_items (',
'        p_application_id    => :FB_FLOW_ID,',
'        p_plugin_type       => wwv_flow_plugin.c_plugin_type_authorization,',
'        p_plugin_name       => :F4000_P188_SCHEME_TYPE,',
'        p_attribute_scope   => wwv_flow_plugin.c_attribute_scope_component,',
'        p_page_item_prefix  => ''P188_'' );',
'end;'))
,p_validation_type=>'PLSQL_ERROR'
,p_error_message=>'Error'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(574333882181476050)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(186971513800820896)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(585123867968099801)
,p_event_id=>wwv_flow_imp.id(574333882181476050)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2250979484123294437)
,p_process_sequence=>5
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Convert Plugin Number Attributes for Storage'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.conv_number_fields_for_storage (',
'        p_application_id    => :FB_FLOW_ID,',
'        p_plugin_type       => wwv_flow_plugin.c_plugin_type_authorization,',
'        p_plugin_name       => :F4000_P188_SCHEME_TYPE,',
'        p_attribute_scope   => wwv_flow_plugin.c_attribute_scope_component,',
'        p_page_item_prefix  => ''P188_'' );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2250979484123294437
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(186981729774820956)
,p_process_sequence=>25
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_SECURITY_SCHEMES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_SECURITY_SCHEMES'
,p_attribute_03=>'F4000_P4008_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_process_error_message=>'Error processing row.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'COPY_TEMPLATE'
,p_process_when_type=>'REQUEST_NOT_IN_CONDITION'
,p_process_success_message=>'Action processed.'
,p_internal_uid=>186981729774820956
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(585123983398099802)
,p_process_sequence=>35
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,F4000_LAST_VIEW'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(186972400577820899)
,p_process_success_message=>'Action processed.'
,p_internal_uid=>585123983398099802
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2203930583112288837)
,p_process_sequence=>15
,p_process_point=>'BEFORE_BOX_BODY'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Convert Plugin Number Attributes for Display'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.conv_number_fields_for_display (',
'        p_application_id    => :FB_FLOW_ID,',
'        p_plugin_type       => wwv_flow_plugin.c_plugin_type_authorization,',
'        p_plugin_name       => :F4000_P188_SCHEME_TYPE,',
'        p_attribute_scope   => wwv_flow_plugin.c_attribute_scope_component,',
'        p_page_item_prefix  => ''P188_'' );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2203930583112288837
);
end;
/
prompt --application/pages/page_00191
begin
wwv_flow_imp_page.create_page(
 p_id=>191
,p_name=>'Copy Button - New Button'
,p_alias=>'COPY-BUTTON-NEW-BUTTON'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Button'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_but.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(45388811726521042)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(180771506850346588)
,p_plug_name=>'Copy Button'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_break_cols=>'1'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(181195014492291571)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(181185105878280365)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(180781500828351759)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(45388811726521042)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(180821926371378056)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(45388811726521042)
,p_button_name=>'Copy'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(180791218143356765)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(45388811726521042)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(180822309138378064)
,p_branch_action=>'4500'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(180821926371378056)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(180781915611351770)
,p_branch_action=>'4500'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(180781500828351759)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(180791619613356773)
,p_branch_action=>'231'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(180791218143356765)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(15196000144860545)
,p_name=>'F4000_P191_COPY_TO_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(180771506850346588)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Page:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id ||''. ''||name',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'and id = :F4000_P231_COPY_TO_PAGE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'This attribute identifies the application page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(177290258519915729)
,p_name=>'F4000_P191_COPY_TO_POSITION'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(180771506850346588)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select button_position',
'from wwv_flow_step_buttons',
'where id = :F4000_P231_COPY_FROM_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'<p>Identifies the region slot in which the button will display.</p> '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(180909522698475978)
,p_name=>'F4000_P191_COPY_TO_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(180771506850346588)
,p_prompt=>'Button Name'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select BUTTON_NAME',
'',
'from wwv_flow_step_buttons',
'',
'where id = :F4000_P231_COPY_FROM_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Internal application name for the button. Use this name to reference the button value. For example to implement a cancel button use a button name of <strong>CANCEL</strong>. Then you can branch to a specific page when the request equals <strong>CA'
||'NCEL</strong>.</p>',
'<p>Although the actual button text can be translated into other languages, the button will always be submitted with the name specified here. Note the button name sets the value of REQUEST.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(180912717091478628)
,p_name=>'F4000_P191_COPY_TO_REGION'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(180771506850346588)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Region'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select button_plug_id',
'from wwv_flow_step_buttons',
'where id = :F4000_P231_COPY_FROM_ID',
'and :F4000_P231_COPY_FROM_PAGE_ID = :F4000_P231_COPY_TO_PAGE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case when r.page_id = f.global_page_id then',
'           wwv_flow_lang.system_message(''LAYOUT.GLOBAL_PAGE_REGION_PREFIX'')',
'       end || r.plug_name || '' ('' || r.plug_display_sequence || '')'' as d,',
'       r.id as r',
'  from wwv_flow_steps p,',
'       wwv_flows f,',
'       wwv_flow_page_plugs r',
' where p.flow_id           = :FB_FLOW_ID',
'   and p.id                = :F4000_P231_COPY_TO_PAGE_ID',
'   and p.security_group_id = :WORKSPACE_ID',
'   and f.id                = p.flow_id',
'   and r.flow_id           = f.id',
'   and r.page_id          in (:F4000_P231_COPY_TO_PAGE_ID, f.global_page_id)',
' order by case when r.page_id = f.global_page_id then 2 else 1 end, r.plug_name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Region -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Identifies the region in which the button will display.</p> '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(180917507602482987)
,p_name=>'F4000_P191_COPY_TO_SEQ'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(180771506850346588)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select DECODE(max(button_sequence),NULL,0,max(button_sequence)) + 10',
'',
'from wwv_flow_step_buttons',
'',
'where flow_id = :fb_flow_id',
'',
'and flow_step_id = :F4000_P231_COPY_TO_PAGE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'<p>Specify the sequence for this component.  The sequence determines the order of evaluation.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(181132410734141286)
,p_name=>'F4000_P191_COPY_TO_LABEL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(180771506850346588)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Label'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select BUTTON_IMAGE_ALT',
'',
'from wwv_flow_step_buttons',
'',
'where id = :F4000_P231_COPY_FROM_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>If the button is text, this is the text that displays on the button. If the button is an image, then this text becomes the ALT tag. If this field is null, it will default to the button name.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(181216816371366640)
,p_validation_name=>'F4000_P191_COPY_TO_NAME Not Null'
,p_validation_sequence=>10
,p_validation=>'F4000_P191_COPY_TO_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Button Name must be specified.'
,p_associated_item=>wwv_flow_imp.id(180909522698475978)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 21-FEB-2002 09:52'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(181217110143366641)
,p_validation_name=>'F4000_P191_COPY_TO_LABEL Not Null'
,p_validation_sequence=>20
,p_validation=>'F4000_P191_COPY_TO_LABEL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Label must be specified.'
,p_associated_item=>wwv_flow_imp.id(181132410734141286)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 21-FEB-2002 09:52'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(181217721915366643)
,p_validation_name=>'F4000_P191_COPY_TO_SEQ Not Null'
,p_validation_sequence=>40
,p_validation=>'F4000_P191_COPY_TO_SEQ'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Button Sequence must be specified.'
,p_associated_item=>wwv_flow_imp.id(180917507602482987)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 21-FEB-2002 09:52'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(186008502136940308)
,p_validation_name=>'Validate valid button name'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_builder.is_valid_item_name ( ',
'    p_name => :F4000_P191_COPY_TO_NAME )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Button Name "&F4000_P191_COPY_TO_NAME." may not contain the characters :&,.+?%''" and spaces.'
,p_when_button_pressed=>wwv_flow_imp.id(180821926371378056)
,p_associated_item=>wwv_flow_imp.id(180909522698475978)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2594661318271681)
,p_validation_name=>'Ensure the destination page is not a subscribed page pattern'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_component_group_dev.is_part_of_subscribed_comp_grp (',
'    p_component_id   => :F4000_P231_COPY_TO_PAGE_ID,',
'    p_component_type => wwv_flow_copy_metadata.c_page,',
'    p_app_id         => :FB_FLOW_ID ) = ''N'''))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'You cannot copy the button to a page pattern that is part of a subscribed component group.'
,p_when_button_pressed=>wwv_flow_imp.id(180821926371378056)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(590120192174572037)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(180781500828351759)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(590120225645572038)
,p_event_id=>wwv_flow_imp.id(590120192174572037)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(110036124053898528)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'CopyButton'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.copy_button (',
'    p_button_id_from  => :F4000_P231_COPY_FROM_ID,',
'    p_button_name_to  => :F4000_P191_COPY_TO_NAME,',
'    p_button_text_to  => :F4000_P191_COPY_TO_LABEL,',
'    p_button_page_id_to  => :F4000_P231_COPY_TO_PAGE_ID,',
'    p_button_sequence_to => :F4000_P191_COPY_TO_SEQ,',
'    p_button_region_to => :F4000_P191_COPY_TO_REGION,',
'    p_button_position_to => :F4000_P191_COPY_TO_POSITION',
');'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying button.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Copied the button to page &F4000_P231_COPY_TO_PAGE_ID..'
,p_internal_uid=>110036124053898528
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(590120349816572039)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Copied the button to page &F4000_P231_COPY_TO_PAGE_ID..'
,p_internal_uid=>590120349816572039
);
end;
/
prompt --application/pages/page_00192
begin
wwv_flow_imp_page.create_page(
 p_id=>192
,p_name=>'Override Application Icon'
,p_alias=>'OVERRIDE-APPLICATION-ICON'
,p_page_mode=>'MODAL'
,p_step_title=>'Edit Application Icon'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#APEX_ERROR_MESSAGE {',
'    width: 100%;',
'}',
'',
'.a-Dialog-body {',
'  display: flex;',
'  align-items: center;',
'  flex-wrap: wrap;',
'}',
'',
'.flex-center, #P192_FILE_NAME_CONTAINER .a-Form-inputContainer {',
'  display: flex;',
'  justify-content: center;',
'  align-items: center;',
'}',
'',
'.align-items-center {',
'  align-items: center;',
'}'))
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'450'
,p_dialog_width=>'760'
,p_protection_level=>'C'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4239699230012904)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4240693135012914)
,p_plug_name=>'Icon'
,p_region_template_options=>'#DEFAULT#:a-Form--labelsAbove'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_column_width=>'flex-center'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4240860422012916)
,p_plug_name=>'Preview'
,p_region_css_classes=>'margin-top-md'
,p_region_template_options=>'#DEFAULT#:a-Form--labelsAbove'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_column_width=>'flex-center'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4239540992012903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(4239699230012904)
,p_button_name=>'CLOSE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Close'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4239490629012902)
,p_name=>'P192_ICON'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(4240860422012916)
,p_prompt=>'Icon'
,p_display_as=>'NATIVE_DISPLAY_IMAGE'
,p_tag_attributes=>'style="max-width:120px;"'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'align-items-center'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'SQL'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select file_content,',
'       :p192_icon_name as alt_text,',
'       file_name,',
'       mime_type',
'  from wwv_flow_static_files',
' where security_group_id = :workspace_id',
'   and flow_id           = :fb_flow_id',
'   and file_name         = :p192_file_name'))
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4239910197012907)
,p_name=>'P192_FILE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(4240860422012916)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4240180546012909)
,p_name=>'P192_FILE_BROWSE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(4240693135012914)
,p_prompt=>'File Browse'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'align-items-center'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'APEX_APPLICATION_TEMP_FILES'
,p_attribute_09=>'SESSION'
,p_attribute_10=>'N'
,p_attribute_11=>'image/png'
,p_attribute_12=>'DROPZONE_BLOCK'
,p_attribute_13=>'Upload a new &P192_ICON_NAME.'
,p_attribute_14=>'Ensure icon is a png and size is exactly &P192_FILE_SIZE.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4240545774012913)
,p_name=>'P192_FILE_SIZE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(4240693135012914)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8201394288942301)
,p_name=>'P192_ICON_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(4240860422012916)
,p_prompt=>'Icon name'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'align-items-center'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8201493131942302)
,p_name=>'P192_FILE_NAME_DISPLAY'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(4240860422012916)
,p_prompt=>'File name'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_file_editor_dev.get_file_reference (',
'    p_scope     => ''APP'',',
'    p_app_id    => :FB_FLOW_ID,',
'    p_file_name => :P192_FILE_NAME )'))
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'align-items-center'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(19395513624030931)
,p_validation_name=>'P192_FILE_BROWSE is invalid'
,p_validation_sequence=>10
,p_validation=>'return false;'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Invalid icon file.'
,p_validation_condition=>'SAVE_ICON_INVALID'
,p_validation_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_associated_item=>wwv_flow_imp.id(4240180546012909)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4239769245012905)
,p_name=>'onClick CLOSE'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(4239540992012903)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4239865793012906)
,p_event_id=>wwv_flow_imp.id(4239769245012905)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4240222561012910)
,p_name=>'onChange P192_FILE_BROWSE is valid'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P192_FILE_BROWSE'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'this.triggeringElement.files.length === 1'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4240342486012911)
,p_event_id=>wwv_flow_imp.id(4240222561012910)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'SAVE_ICON'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(19395416741030930)
,p_event_id=>wwv_flow_imp.id(4240222561012910)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'SAVE_ICON_INVALID'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4240430245012912)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Save icon'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in ( select blob_content,',
'                  name,',
'                  filename,',
'                  mime_type',
'             from wwv_flow_temp_files ',
'            where name = :P192_FILE_BROWSE ) loop',
'',
'    wwv_flow_imp_shared.create_app_static_file(',
'      p_flow_id      => :fb_flow_id,',
'      p_file_name    => :P192_FILE_NAME,',
'      p_mime_type    => i.mime_type,',
'      p_file_charset => ''utf-8'',',
'      p_file_content => i.blob_content );',
'',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'SAVE_ICON'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>4240430245012912
);
end;
/
prompt --application/pages/page_00194
begin
wwv_flow_imp_page.create_page(
 p_id=>194
,p_name=>'Copy Region - To Page'
,p_alias=>'COPY-REGION-TO-PAGE'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Region'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_region.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(45373922050344248)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(64181763072509002)
,p_name=>'Copy From Master Region'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>80
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select plug_display_sequence,',
'       plug_name',
'  from wwv_flow_page_plugs',
' where flow_id           = :FB_FLOW_ID',
'   and page_id           = :FB_FLOW_PAGE_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and id in (',
'          select master_region_id',
'            from wwv_flow_page_plugs',
'           where flow_id           = :FB_FLOW_ID',
'             and page_id           = :FB_FLOW_PAGE_ID',
'             and security_group_id = :FLOW_SECURITY_GROUP_ID',
'             and id = :F4000_P194_PLUG_ID_FROM )',
' order by plug_display_sequence, plug_name'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.has_region_master_region (',
'    p_region_id         => :F4000_P194_PLUG_ID_FROM,',
'    p_flow_id           => :FB_FLOW_ID,',
'    p_page_id           => :FB_FLOW_PAGE_ID,',
'    p_security_group_id => :FLOW_SECURITY_GROUP_ID )'))
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Region has no Sub Regions.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(64181955816509004)
,p_query_column_id=>1
,p_column_alias=>'PLUG_DISPLAY_SEQUENCE'
,p_column_display_sequence=>20
,p_column_heading=>'Display Sequence'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(64182085863509005)
,p_query_column_id=>2
,p_column_alias=>'PLUG_NAME'
,p_column_display_sequence=>30
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(81934329568650544)
,p_name=>'Copy From Region'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  flow_id,',
'  page_id,',
'  plug_name,',
'  plug_display_sequence,',
'  plug_source_type        ',
'from wwv_flow_page_plugs',
'where id = :F4000_P194_PLUG_ID_FROM'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(82408032331628644)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(81934724668650553)
,p_query_column_id=>1
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Application'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(81934830885650553)
,p_query_column_id=>2
,p_column_alias=>'PAGE_ID'
,p_column_display_sequence=>2
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(81934924932650553)
,p_query_column_id=>3
,p_column_alias=>'PLUG_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(81935028229650554)
,p_query_column_id=>4
,p_column_alias=>'PLUG_DISPLAY_SEQUENCE'
,p_column_display_sequence=>4
,p_column_heading=>'Display Sequence'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(81935310525650554)
,p_query_column_id=>5
,p_column_alias=>'PLUG_SOURCE_TYPE'
,p_column_display_sequence=>6
,p_column_heading=>'Source Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(32361488916)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(115839224419800245)
,p_name=>'Copy From Region Items'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ITEM_SEQUENCE,',
'       NAME,',
'       PROMPT',
'  from WWV_FLOW_STEP_ITEMS',
' where flow_id      = :fb_flow_id',
'   and flow_step_id = :fb_flow_page_id',
'   and security_group_id = :flow_security_group_id',
'   and item_plug_id in (',
'           select id',
'             from wwv_flow_page_plugs',
'            where flow_id           = :FB_FLOW_ID',
'              and page_id           = :FB_FLOW_PAGE_ID',
'              and security_group_id = :FLOW_SECURITY_GROUP_ID',
'            start with id = :F4000_P194_PLUG_ID_FROM',
'          connect by prior id = parent_plug_id )'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.has_region_items (',
'    p_region_id         => :F4000_P194_PLUG_ID_FROM,',
'    p_flow_id           => :FB_FLOW_ID,',
'    p_page_id           => :FB_FLOW_PAGE_ID,',
'    p_security_group_id => :FLOW_SECURITY_GROUP_ID )'))
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Region has no Items.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(115839513682800253)
,p_query_column_id=>1
,p_column_alias=>'ITEM_SEQUENCE'
,p_column_display_sequence=>1
,p_column_heading=>'Display Sequence'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(115839610576800253)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(115839717149800253)
,p_query_column_id=>3
,p_column_alias=>'PROMPT'
,p_column_display_sequence=>3
,p_column_heading=>'Label'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(162415522135065533)
,p_name=>'Recently Edited Pages'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>90
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||name p, id',
'from wwv_flow_steps',
'where security_group_id = :flow_security_group_id and',
'     flow_id = :fb_flow_id',
'order by last_updated_on desc'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(11667910335347890)
,p_query_num_rows=>8
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No Pages found.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>9
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(162415700932065535)
,p_query_column_id=>1
,p_column_alias=>'P'
,p_column_display_sequence=>1
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=4000:4500:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID:&FB_FLOW_ID.,#ID#'
,p_column_linktext=>'#P#'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(162415811080065535)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(170756904725276796)
,p_name=>'Copy From Sub Regions'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>70
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
' select level as hierarchy_level,',
'        plug_display_sequence,',
'        plug_name',
'   from wwv_flow_page_plugs',
'  where flow_id           = :FB_FLOW_ID',
'    and page_id           = :FB_FLOW_PAGE_ID',
'    and security_group_id = :FLOW_SECURITY_GROUP_ID',
'  start with parent_plug_id = :F4000_P194_PLUG_ID_FROM',
'connect by prior id = parent_plug_id',
'  order siblings by plug_display_sequence, plug_name'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.has_region_sub_regions (',
'    p_region_id         => :F4000_P194_PLUG_ID_FROM,',
'    p_flow_id           => :FB_FLOW_ID,',
'    p_page_id           => :FB_FLOW_PAGE_ID,',
'    p_security_group_id => :FLOW_SECURITY_GROUP_ID )'))
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Region has no Sub Regions.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(170757605726324406)
,p_query_column_id=>1
,p_column_alias=>'HIERARCHY_LEVEL'
,p_column_display_sequence=>1
,p_column_heading=>'Level'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(170757712731324406)
,p_query_column_id=>2
,p_column_alias=>'PLUG_DISPLAY_SEQUENCE'
,p_column_display_sequence=>2
,p_column_heading=>'Display Sequence'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(170757822550324406)
,p_query_column_id=>3
,p_column_alias=>'PLUG_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(197255110195041780)
,p_plug_name=>'Copy Region'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_header=>'<p>Identify page for new region.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(197271418377053263)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(197233420990021629)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(197283023632061317)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(45373922050344248)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(197291613027067689)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(45373922050344248)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(197292028437067692)
,p_branch_name=>'Go To Page 195'
,p_branch_action=>'f?p=&APP_ID.:195:&SESSION.::&DEBUG.:195::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(197291613027067689)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(178096212823209603)
,p_branch_action=>'f?p=&APP_ID.:194:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(197283407585061320)
,p_branch_action=>'4500'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(197283023632061317)
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7789519381452606)
,p_name=>'P194_COPY_VALIDATIONS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(197255110195041780)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Copy Validations:'
,p_source=>'N'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(84259319526460470)||'.'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.has_region_validations (',
'    p_region_id         => :F4000_P194_PLUG_ID_FROM,',
'    p_flow_id           => :FB_FLOW_ID,',
'    p_page_id           => :FB_FLOW_PAGE_ID,',
'    p_security_group_id => :FLOW_SECURITY_GROUP_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Determine if you would also like to copy the validations of this region. Select <strong>Yes</strong> or <strong>No</strong>.'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7790821936462730)
,p_name=>'P194_COPY_PROCESSES'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(197255110195041780)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Copy Processes:'
,p_source=>'N'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(84259319526460470)||'.'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.has_region_processes (',
'    p_region_id         => :F4000_P194_PLUG_ID_FROM,',
'    p_flow_id           => :FB_FLOW_ID,',
'    p_page_id           => :FB_FLOW_PAGE_ID,',
'    p_security_group_id => :FLOW_SECURITY_GROUP_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Determine if you would also like to copy the processes of this region. Select <strong>Yes</strong> or <strong>No</strong>.'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(64181624838509001)
,p_name=>'P194_COPY_MASTER_REGION'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(197255110195041780)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Copy Master Region:'
,p_source=>'N'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(84259319526460470)||'.'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.has_region_master_region (',
'    p_region_id         => :F4000_P194_PLUG_ID_FROM,',
'    p_flow_id           => :FB_FLOW_ID,',
'    p_page_id           => :FB_FLOW_PAGE_ID,',
'    p_security_group_id => :FLOW_SECURITY_GROUP_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Determine if you would also like to copy the master region of this region. Select <strong>Yes</strong> or <strong>No</strong>.'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(115830017100769784)
,p_name=>'P194_COPY_REGION_ITEMS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(197255110195041780)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- for form region, set Y for copy items options',
'for form in ( select 1',
'                from wwv_flow_page_plugs',
'               where page_id           = :F4000_P194_COPY_FROM_PAGE_ID',
'                 and flow_id           = :FB_FLOW_ID',
'                 and security_group_id = :WORKSPACE_ID',
'                 and id                = :F4000_P194_PLUG_ID_FROM',
'                 and plug_source_type  = ''NATIVE_FORM'' )',
'loop',
'    return ''Y'';',
'end loop;',
'-- for other regions, set N by default',
'return ''N'';'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Copy Region Items:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(84259319526460470)||'.'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.has_region_items (',
'    p_region_id         => :F4000_P194_PLUG_ID_FROM,',
'    p_flow_id           => :FB_FLOW_ID,',
'    p_page_id           => :FB_FLOW_PAGE_ID,',
'    p_security_group_id => :FLOW_SECURITY_GROUP_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Determine if you would also like to copy the items in this region. Select <strong>Yes</strong> or <strong>No</strong>.'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(170771909021363143)
,p_name=>'P194_COPY_SUB_REGIONS'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(197255110195041780)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Copy Sub Regions:'
,p_source=>'N'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(84259319526460470)||'.'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.has_region_sub_regions (',
'    p_region_id         => :F4000_P194_PLUG_ID_FROM,',
'    p_flow_id           => :FB_FLOW_ID,',
'    p_page_id           => :FB_FLOW_PAGE_ID,',
'    p_security_group_id => :FLOW_SECURITY_GROUP_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Determine if you would also like to copy the sub regions of this region. Select <strong>Yes</strong> or <strong>No</strong>.'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(197382112875192507)
,p_name=>'F4000_P194_PLUG_ID_FROM'
,p_item_sequence=>10
,p_item_display_point=>'LEGACY_ORPHAN_COMPONENTS'
,p_prompt=>'Copy Region'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(197403725358217145)
,p_name=>'F4000_P194_COPY_FROM_PAGE_ID'
,p_item_sequence=>20
,p_item_display_point=>'LEGACY_ORPHAN_COMPONENTS'
,p_prompt=>'F4000_P194_COPY_FROM_PAGE_ID'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(197410701204228348)
,p_name=>'F4000_P194_COPY_TO_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(197255110195041780)
,p_prompt=>'To Page'
,p_source=>'F4000_P194_COPY_FROM_PAGE_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d',
'  from wwv_flow_steps',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and is_page_pattern   = ''N''',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the page number to which this region will be copied.'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(224504126004676698)
,p_name=>'P194_COPY_BUTTONS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(197255110195041780)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Copy Buttons:'
,p_source=>'N'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(84259319526460470)||'.'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.has_region_buttons (',
'    p_region_id         => :F4000_P194_PLUG_ID_FROM,',
'    p_flow_id           => :FB_FLOW_ID,',
'    p_page_id           => :FB_FLOW_PAGE_ID,',
'    p_security_group_id => :FLOW_SECURITY_GROUP_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Determine if you would also like to copy the buttons in this region. Select <strong>Yes</strong> or <strong>No</strong>.'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(55668018204386734)
,p_validation_name=>'must choose existing page'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.page_exists (',
'    p_flow_id => :FB_FLOW_ID,',
'    p_page_id => :F4000_P194_COPY_TO_PAGE_ID )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Must specify an existing page.'
,p_validation_condition=>'Cancel,Previous'
,p_validation_condition_type=>'REQUEST_NOT_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(197410701204228348)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(197416008956239909)
,p_validation_name=>'new page id not null'
,p_validation_sequence=>20
,p_validation=>'F4000_P194_COPY_TO_PAGE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'New Page ID must be specified.'
,p_validation_condition=>'Cancel,Previous'
,p_validation_condition_type=>'REQUEST_NOT_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(197410701204228348)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(166834530924837051)
,p_validation_name=>'check page lock'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'for c1 in (select count(*) counter from wwv_flow_lock_page where OBJECT_ID = :F4000_P194_COPY_TO_PAGE_ID and flow_id = :fb_flow_id',
'and locked_by != :app_user) loop',
'if c1.counter > 0 then',
'  return false;',
'else ',
'  return true;',
'end if;',
'end loop;',
'return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Can not copy to a page locked by another user.'
,p_validation_condition=>'Cancel,Previous'
,p_validation_condition_type=>'REQUEST_NOT_IN_CONDITION'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(242410630611969213)
,p_validation_name=>'Only 1 Calendar Per Page'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
' from wwv_flow_cals c, wwv_flow_page_plugs p',
' where c.plug_id = p.id',
' and   p.flow_id = :FB_FLOW_ID',
' and   p.page_id = :F4000_P194_COPY_TO_PAGE_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Only one calendar is supported per page.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_page_plugs',
'where id = :F4000_P194_PLUG_ID_FROM',
'and   plug_source_type = ''NATIVE_CALENDAR''',
'and nvl(:REQUEST,''x'') not in (''Cancel'',''Previous'')'))
,p_validation_condition_type=>'EXISTS'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(115984121871266126)
,p_validation_name=>'verify new page if cp items'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P194_COPY_REGION_ITEMS = ''Y'' and :F4000_P194_COPY_TO_PAGE_ID = :fb_flow_page_id then ',
'    return false; ',
'else ',
'    return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'You may only copy items to a different page'
,p_when_button_pressed=>wwv_flow_imp.id(197291613027067689)
,p_associated_item=>wwv_flow_imp.id(115830017100769784)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(364974600023905138)
,p_validation_name=>'Allow IR'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :F4000_P194_COPY_TO_PAGE_ID is not null ',
'    and wwv_flow_wizard_api.page_exists ( ',
'            p_flow_id => :fb_flow_id, ',
'            p_page_id => :F4000_P194_COPY_TO_PAGE_ID) then',
'    return true;',
'else',
'    return false;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'An Interactive report can only be copied to a page with a Desktop user interface.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.ir_report_exists( ',
'    p_flow_id   => :FB_FLOW_ID, ',
'    p_page_id   => :FB_FLOW_PAGE_ID,',
'    p_region_id => :F4000_P194_PLUG_ID_FROM)'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(197291613027067689)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(364976810023067632)
,p_validation_name=>'Allow Tree'
,p_validation_sequence=>100
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :F4000_P194_COPY_TO_PAGE_ID is not null ',
'    and wwv_flow_wizard_api.page_exists ( ',
'            p_flow_id => :fb_flow_id, ',
'            p_page_id => :F4000_P194_COPY_TO_PAGE_ID) then',
'    return true;',
'else',
'    return false;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'A jsTree region can only be copied to a page with a Desktop user interface.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.jstree_exists( ',
'    p_flow_id   => :FB_FLOW_ID, ',
'    p_page_id   => :FB_FLOW_PAGE_ID,',
'    p_region_id => :F4000_P194_PLUG_ID_FROM)'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(197291613027067689)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(365040532511044779)
,p_validation_name=>'Allow Tabular Form'
,p_validation_sequence=>110
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :F4000_P194_COPY_TO_PAGE_ID is not null ',
'    and wwv_flow_wizard_api.page_exists ( ',
'            p_flow_id => :fb_flow_id, ',
'            p_page_id => :F4000_P194_COPY_TO_PAGE_ID) then',
'    return true;',
'else',
'    return false;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'A Tabular Form region can only be copied to a page with a Desktop user interface.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.tabular_form_exists( ',
'    p_flow_id   => :FB_FLOW_ID, ',
'    p_page_id   => :FB_FLOW_PAGE_ID,',
'    p_region_id => :F4000_P194_PLUG_ID_FROM)'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(197291613027067689)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(590120929031572045)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(197283023632061317)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(590121008915572046)
,p_event_id=>wwv_flow_imp.id(590120929031572045)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00195
begin
wwv_flow_imp_page.create_page(
 p_id=>195
,p_name=>'Copy Region - New Region'
,p_alias=>'COPY-REGION-NEW-REGION'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Region'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_region.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(45380423613382551)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(81942219188723227)
,p_name=>'Copy From Region'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  flow_id,',
'  page_id,',
'  plug_name,',
'  plug_display_sequence,',
'  plug_display_point,',
'  plug_source_type        ',
'from wwv_flow_page_plugs',
'where id = :F4000_P194_PLUG_ID_FROM'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(82408032331628644)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(81942631723723231)
,p_query_column_id=>1
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Application'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(81942723109723232)
,p_query_column_id=>2
,p_column_alias=>'PAGE_ID'
,p_column_display_sequence=>2
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(81942809816723232)
,p_query_column_id=>3
,p_column_alias=>'PLUG_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(81942909090723232)
,p_query_column_id=>4
,p_column_alias=>'PLUG_DISPLAY_SEQUENCE'
,p_column_display_sequence=>4
,p_column_heading=>'Display Sequence'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(81943116619723232)
,p_query_column_id=>5
,p_column_alias=>'PLUG_DISPLAY_POINT'
,p_column_display_sequence=>5
,p_column_heading=>'Display Point'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(131723061838)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(81943208962723232)
,p_query_column_id=>6
,p_column_alias=>'PLUG_SOURCE_TYPE'
,p_column_display_sequence=>6
,p_column_heading=>'Source Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(32361488916)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(171468430718689397)
,p_plug_name=>'Advanced'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(399849897040726767)
,p_plug_display_sequence=>20
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(197299403916075146)
,p_plug_name=>'Copy Region'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(197306822882081519)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(197233420990021629)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(197309504632084261)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(45380423613382551)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_execute_validations=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(197319129220091370)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(45380423613382551)
,p_button_name=>'Copy'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(197312114675087163)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(45380423613382551)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(197319531599091373)
,p_branch_action=>'4500'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(197319129220091370)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(197309902322084263)
,p_branch_action=>'4500'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(197309504632084261)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(197312513819087166)
,p_branch_action=>'194'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(197312114675087163)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7796205884524383)
,p_name=>'P195_COPY_VALIDATIONS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(197299403916075146)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Copy Validations:'
,p_source=>'&P194_COPY_VALIDATIONS.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(84259319526460470)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>'Determine if you would also like to copy the validations of this region.'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7797703245533024)
,p_name=>'P195_COPY_PROCESSES'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(197299403916075146)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Copy Processes:'
,p_source=>'&P194_COPY_PROCESSES.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(84259319526460470)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>'Determine if you would also like to copy the processes of this region.'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(64182152374509006)
,p_name=>'P195_COPY_MASTER_REGION'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(197299403916075146)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Copy Master Region:'
,p_source=>'&P194_COPY_MASTER_REGION.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(84259319526460470)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>'Determine if you would also like to copy the master region of this region.'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(115861009968852840)
,p_name=>'P195_COPY_REGION_ITEMS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(197299403916075146)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Copy Region Items:'
,p_source=>'&P194_COPY_REGION_ITEMS.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(84259319526460470)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>'Determine if you would like this regions items to be copied with the region.'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(163521714679993315)
,p_name=>'P195_COPY_FROM_PAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(197299403916075146)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Copy From Page:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id ||''. ''||name',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'and id = :FB_FLOW_PAGE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>'Identifies the page that the region is being copied from.'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(170775630248501772)
,p_name=>'P195_PARENT_PLUG_ID'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(197299403916075146)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Parent Region'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P195_PARENT_REGIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select plug_name || '' ('' || plug_display_sequence || '')'' as plug_name,',
'       id',
'  from wwv_flow_page_plugs p',
' where flow_id           = :FB_FLOW_ID',
'   and page_id           = :F4000_P194_COPY_TO_PAGE_ID',
'   and security_group_id = :WORKSPACE_ID',
' order by plug_name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select a Parent -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'Y'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>'Defines the parent region to which the new region belongs to.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(170778515582563761)
,p_name=>'P195_COPY_SUB_REGIONS'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(197299403916075146)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Copy Sub Regions:'
,p_source=>'&P194_COPY_SUB_REGIONS.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(84259319526460470)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>'Determine if you would also like to copy the sub regions of this region.'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(197428227250277038)
,p_name=>'F4000_P195_COPY_TO_PAGE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(197299403916075146)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Copy To Page:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id ||''. ''||name',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'and id = :F4000_P194_COPY_TO_PAGE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>'This attribute identifies the application page.'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(197433726806292377)
,p_name=>'F4000_P195_REGION_NAME'
,p_is_required=>true
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(197299403916075146)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Region Name'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select plug_name',
'from wwv_flow_page_plugs',
'where id = :F4000_P194_PLUG_ID_FROM'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The region name identifies the name of a region for application developers. It is also the name that is substituted for the #TITLE# substitution string identified in the region template.<p> ',
'</p>If no region template is selected, then the region title will not be shown. This region name can include &ITEM substitution strings.'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(197441222049309865)
,p_name=>'F4000_P195_DISPLAY_SEQ'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(197299403916075146)
,p_use_cache_before_default=>'NO'
,p_item_default=>'10'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(max(plug_display_sequence), 0) + 10',
'  from wwv_flow_page_plugs',
' where flow_id = :fb_flow_id',
'   and page_id = :F4000_P194_COPY_TO_PAGE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>'<p>Specify the sequence for this component.  The sequence determines the order of evaluation.</p>'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(197473727163383418)
,p_name=>'F4000_P195_DISPLAY_POINT'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(197299403916075146)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select plug_display_point',
'  from wwv_flow_page_plugs',
' where page_id           = :F4000_P194_COPY_FROM_PAGE_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and id                = :F4000_P194_PLUG_ID_FROM'))
,p_item_default_type=>'SQL_QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'<p>This attribute controls where the page regions display. Page regions can display at various points on a page.</p>'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(224522525171941394)
,p_name=>'P195_COPY_BUTTONS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(197299403916075146)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Copy Buttons:'
,p_source=>'&P194_COPY_BUTTONS.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(84259319526460470)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>'Determine if you would also like to copy the buttons in this region.'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(568325029966890739)
,p_name=>'P195_STATIC_ID'
,p_is_required=>true
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(197299403916075146)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Static ID'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select region_name',
'from wwv_flow_page_plugs',
'where id = :F4000_P194_PLUG_ID_FROM'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_page_plugs',
'where id = :F4000_P194_PLUG_ID_FROM',
'and region_name is not null'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>'Enter value to identify this region. You can reference this value using the substitution string #REGION_STATIC_ID#. Referencing this value can be useful when developing custom JavaScript.<p/>If a new static id is not entered, then this could lead to '
||'unexpected behavior of code which relies on the uniqueness of the static id. '
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2583462333425801)
,p_validation_name=>'Ensure the destination page is not a subscribed page pattern'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_component_group_dev.is_part_of_subscribed_comp_grp (',
'    p_component_id   => :F4000_P194_COPY_TO_PAGE_ID,',
'    p_component_type => wwv_flow_copy_metadata.c_page,',
'    p_app_id         => :FB_FLOW_ID ) = ''N'''))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'You cannot copy the region to a page pattern that is part of a subscribed component group.'
,p_when_button_pressed=>wwv_flow_imp.id(197319129220091370)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(171295425174344668)
,p_name=>'Parent Region'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P195_PARENT_PLUG_ID'
,p_condition_element=>'P195_PARENT_PLUG_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(171296019418352484)
,p_event_id=>wwv_flow_imp.id(171295425174344668)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P195_DISPLAY_POINT'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(171296606389358131)
,p_event_id=>wwv_flow_imp.id(171295425174344668)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P195_DISPLAY_POINT'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(590120639318572042)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(197309504632084261)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(590120788609572043)
,p_event_id=>wwv_flow_imp.id(590120639318572042)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(197377304476181228)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'copy region'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_page.a_region (',
'        p_flow_id_from         => :FB_FLOW_ID,   ',
'        p_page_id_from         => :FB_FLOW_PAGE_ID,',
'        p_region_id_from       => :F4000_P194_PLUG_ID_FROM,',
'        p_flow_id_to           => :FB_FLOW_ID,    ',
'        p_page_id_to           => :F4000_P194_COPY_TO_PAGE_ID, ',
'        p_plug_name_to         => :F4000_P195_REGION_NAME,',
'        p_parent_plug_id_to    => :P195_PARENT_PLUG_ID,    ',
'        p_display_seq_to       => :F4000_P195_DISPLAY_SEQ,',
'        p_display_point_to     => :F4000_P195_DISPLAY_POINT,',
'        p_copy_items           => (nvl(:P194_COPY_REGION_ITEMS,  ''N'') = ''Y''),',
'        p_copy_buttons         => (nvl(:P194_COPY_BUTTONS,       ''N'') = ''Y''),',
'        p_copy_validations     => (nvl(:P194_COPY_VALIDATIONS,   ''N'') = ''Y''),',
'        p_copy_processes       => (nvl(:P194_COPY_PROCESSES,     ''N'') = ''Y''),',
'        p_copy_sub_regions     => (nvl(:P194_COPY_SUB_REGIONS,   ''N'') = ''Y''),',
'        p_copy_master_region   => (nvl(:P194_COPY_MASTER_REGION, ''N'') = ''Y''),',
'        p_copy_filtered_region => true,',
'        p_region_name_to       => :P195_STATIC_ID);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying region(s) &F4000_P194_PLUG_ID_FROM. to page &F4000_P194_COPY_TO_PAGE_ID..'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(197319129220091370)
,p_process_success_message=>'Copied region(s) to page &F4000_P194_COPY_TO_PAGE_ID..'
,p_internal_uid=>197377304476181228
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(590120897674572044)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Copied region(s) to page &F4000_P194_COPY_TO_PAGE_ID..'
,p_internal_uid=>590120897674572044
);
end;
/
prompt --application/pages/page_00196
begin
wwv_flow_imp_page.create_page(
 p_id=>196
,p_name=>'Edit Web Service'
,p_alias=>'EDIT-WEB-SERVICE'
,p_step_title=>'Edit Web Service'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(31199123761425877)
,p_plug_name=>'SOAP Response'
,p_region_name=>'R6'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46167825315774873)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>20
,p_plug_new_grid=>true
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(86294025202192356)
,p_plug_name=>'Web Service'
,p_region_name=>'R1'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_row_template=>wwv_flow_imp.id(79387910442923002)
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'Region generated 31-JUL-2002 20:44:47'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(86333719809230389)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_row_template=>wwv_flow_imp.id(79387910442923002)
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(86372813302279015)
,p_plug_name=>'Service Description'
,p_region_name=>'R2'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(86373608558281192)
,p_plug_name=>'SOAP Envelope'
,p_region_name=>'R3'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(86408801200315023)
,p_plug_name=>'Web Services'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Simple Object Access Protocol (SOAP) is a World Wide Web Consortium http://www.w3.org/ (W3C) standard protocol for defining the format for Web service requests.</p> ',
'<p>SOAP messages are sent back and forth between the service provider and service user in SOAP envelopes. SOAP envelopes contain a request for some action and the result of that action and are formatted in XML, making them easy to decode.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(86294314768192362)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(86333719809230389)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(86294620751192362)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(86333719809230389)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
,p_button_condition=>'F4000_P196_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(86294409655192362)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(86333719809230389)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P196_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(86294501619192362)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(86333719809230389)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P196_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(86965711084064912)
,p_branch_action=>'170'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(29970604015456327)
,p_name=>'P196_BASIC_AUTH'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_imp.id(86372813302279015)
,p_item_default=>'N'
,p_prompt=>'Basic Authentication:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(84259319526460470)||'.'
,p_read_only_when=>'F4000_P196_ID'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose whether this Web service requires basic authentication. Basic authentication credentials are sent as part of the HTTP request in clear text. Web services that employ basic authentication usually also use the HTTPS (SSL) protocol since the user'
||'name and password are sent in clear text.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(31201426540502324)
,p_name=>'P196_RESPONSE_COLLECTION'
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_imp.id(31199123761425877)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Store Response in Collection'
,p_source=>'STATIC_PARM_03'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the name of a collection to store the Web service response. The response will be stored in the CLOB001 column of the collection entered here.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(86296104013192382)
,p_name=>'F4000_P196_ID'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_imp.id(86294025202192356)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(86296427033192396)
,p_name=>'F4000_P196_FLOW_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(86294025202192356)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'This attribute identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_item_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(86296701655192398)
,p_name=>'F4000_P196_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(86294025202192356)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>The name for this Web service within the context of the Builder. This name is only used within the App Builder tool.</p>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(86297317225192400)
,p_name=>'F4000_P196_URL'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(86372813302279015)
,p_use_cache_before_default=>'NO'
,p_prompt=>'URL'
,p_source=>'URL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify the URL used to post the SOAP request over HTTP. This corresponds to the soap:address location of a service',
'   port in WSDL. You may reference session state in the URL by using <code>&amp;ITEM_NAME.</code> convention.</p>',
'<p>For example:</p>',
'<code>http://s3.example.com/&amp;P2_BUCKET.</code>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(86297610683192401)
,p_name=>'F4000_P196_ACTION'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(86372813302279015)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Action'
,p_source=>'ACTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Indicates the intent of the SOAP HTTP request. The value is a URI identifying the intent.</p> <p>SOAP places no restrictions on the format or specificity of the URI or that it is resolvable.</p>',
'',
'',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(86298228587192403)
,p_name=>'F4000_P196_PROXY_OVERRIDE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(86372813302279015)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Proxy'
,p_source=>'PROXY_OVERRIDE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This overrides the system defined HTTP proxy for your request. The proxy may include an optional TCP/IP port number at',
'   which the proxy server listens.  Use the following syntax:</p>',
'<pre>[http://]host[:port][/]</pre>',
'<p>For example:</p>',
'<pre>www-proxy.example.com</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(86298826087192404)
,p_name=>'F4000_P196_SOAP_ENVELOPE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(86373608558281192)
,p_use_cache_before_default=>'NO'
,p_prompt=>'SOAP Envelope'
,p_source=>'SOAP_ENVELOPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>12
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify the SOAP envelope to be used for the SOAP request to the Web service. This envelope can contain item substitutions of the form #ITEM_NAME#.</p>',
'<p>For example:</p>',
'<pre>&lt;SOAP-ENV:Envelope',
'xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"',
'',
'  xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance"',
'',
'  xmlns:xsd="http://www.w3.org/1999/XMLSchema"',
'',
'  SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/">',
'',
'  &lt;SOAP-ENV:Body>&lt;LocalTimeByZipCode xmlns="http://www.alethea.net/webservices/">&lt;ZipCode xsi:type="xsd:string">#Fxxxx_Pyyy_ZIP_CODE#&lt;/ZipCode>&lt;/LocalTimeByZipCode></SOAP-ENV:Body>&lt;/SOAP-ENV:Envelope>',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_item_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(439439703858999767)
,p_name=>'P196_SOAP_VERSION'
,p_item_sequence=>95
,p_item_plug_id=>wwv_flow_imp.id(86372813302279015)
,p_use_cache_before_default=>'NO'
,p_item_default=>'1.1'
,p_prompt=>'SOAP Version:'
,p_source=>'SOAP_VERSION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WS_SOAP_VERSION'
,p_lov=>'.'||wwv_flow_imp.id(439439004288980949)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Choose the version of the SOAP specification that this Web service uses, either 1.1 or 1.2.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(30004122444717111)
,p_computation_sequence=>10
,p_computation_item=>'P196_BASIC_AUTH'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select null',
'             from wwv_flow_ws_operations',
'            where name = ''BASIC_AUTH''',
'              and ws_id = :F4000_P196_ID ) loop',
'  return ''Y'';',
'  exit;',
'end loop;',
'',
'return ''N'';'))
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(86499321996457354)
,p_validation_name=>'F4000_P196_NAME Not Null'
,p_validation_sequence=>1
,p_validation=>'F4000_P196_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Name must be specified.'
,p_validation_condition=>'CREATE:SAVE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(86296701655192398)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 31-JUL-2002 21:28'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(72395421424008219)
,p_validation_name=>'URL Not Null'
,p_validation_sequence=>10
,p_validation=>'F4000_P196_URL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'The URL of the Web Service must be specified.'
,p_validation_condition=>'CREATE:SAVE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(86297317225192400)
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(72398304717022294)
,p_validation_name=>'SOAP Envelope not null'
,p_validation_sequence=>10
,p_validation=>'F4000_P196_SOAP_ENVELOPE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'The SOAP Envelope associated with your Web Service must be specified.'
,p_validation_condition=>'CREATE:SAVE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(86298826087192404)
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(86302828338192418)
,p_process_sequence=>1
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_SHARED_WEB_SERVICES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_SHARED_WEB_SERVICES'
,p_attribute_03=>'F4000_P196_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error fetching row.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>86302828338192418
,p_process_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(86303119203192421)
,p_process_sequence=>1
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_SHARED_WEB_SERVICES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_SHARED_WEB_SERVICES'
,p_attribute_03=>'F4000_P196_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_09=>'F4000_P196_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error updating web service definition.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Web service definition updated.'
,p_internal_uid=>86303119203192421
,p_process_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(92606502028283804)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Preparse item substitutions'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_items clob;',
'begin',
'    l_items := wwv_flow_web_services.parse( :F4000_P196_SOAP_ENVELOPE );',
'',
'    update wwv_flow_shared_web_services ',
'       set flow_items_comma_delimited = l_items',
'     where id = :F4000_P196_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE,SAVE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_internal_uid=>92606502028283804
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(29995505719579902)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create basic auth operation'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_operations_id number;',
'  l_id number;',
'begin',
'',
'  l_operations_id := wwv_flow_id.next_val;',
'',
'  insert into wwv_flow_ws_operations (id, ws_id, name)     ',
'  values (l_operations_id, :F4000_P196_ID, ''BASIC_AUTH'');',
'                                                         ',
'  l_id := wwv_flow_id.next_val;                            ',
'                                                         ',
'  insert into wwv_flow_ws_parameters                       ',
'       (id, ws_opers_id, name, input_or_output)          ',
'  values (l_id, l_operations_id, ''username'', ''A'');         ',
'                                                         ',
'  l_id := wwv_flow_id.next_val;                            ',
'                                                         ',
'  insert into wwv_flow_ws_parameters                       ',
'       (id, ws_opers_id, name, input_or_output)          ',
'  values (l_id, l_operations_id, ''password'', ''A'');',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(86294409655192362)
,p_process_when=>':P196_BASIC_AUTH = ''Y'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>29995505719579902
);
end;
/
prompt --application/pages/page_00197
begin
wwv_flow_imp_page.create_page(
 p_id=>197
,p_name=>'Edit User Interface'
,p_alias=>'EDIT-USER-INTERFACE'
,p_step_title=>'Edit User Interface'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.app-icon-favicon {width: 16px;}',
'.app-icon-small {width: 48px;}',
'.app-icon-large {width: 96px;}'))
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_required_patch=>wwv_flow_imp.id(235700916833599805)
,p_help_text=>'No help is available for this page.'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4012191055396142)
,p_plug_name=>'Application icon'
,p_region_template_options=>'#DEFAULT#:js-dialog-size480x320'
,p_plug_template=>wwv_flow_imp.id(557449278618308550)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The &PRODUCT_NAME. application icon is used for the Favicon, the PWA icon, the Apple touch icon and the &PRODUCT_NAME. Builder icon.</p>',
'',
'<p>When using the <strong>Change Icon</strong> button, you are prompted to upload a single icon or choose from a list of icons. If you upload a custom icon, it will be resized to different formats and sizes and will be propagated to the appropriate p'
||'laces at runtime.</p>',
'',
'<p>If you wish to control the upload for all icon sizes, simply upload your icons to the <strong>Static Application Files</strong> and use those file paths:</p>',
'<ul>',
'    <li>&#35;APP_FILES&#35;icons/app-icon-32.png</li>',
'    <li>&#35;APP_FILES&#35;icons/app-icon-144-rounded.png</li>',
'    <li>&#35;APP_FILES&#35;icons/app-icon-192.png</li>',
'    <li>&#35;APP_FILES&#35;icons/app-icon-256-rounded.png</li>',
'    <li>&#35;APP_FILES&#35;icons/app-icon-512.png</li>',
'</ul>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4012276700396143)
,p_plug_name=>'Application logo'
,p_region_template_options=>'#DEFAULT#:js-dialog-size480x320'
,p_plug_template=>wwv_flow_imp.id(557449278618308550)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_source=>'The &PRODUCT_NAME. application logo is used in the top navigation bar.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(28154408216362812)
,p_plug_name=>'UI'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(461857790551605627)
,p_plug_display_sequence=>20
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOWS'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'u'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
,p_landmark_type=>'region'
,p_landmark_label=>'Displayed Regions'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1800615853692501)
,p_plug_name=>'Icon'
,p_parent_plug_id=>wwv_flow_imp.id(28154408216362812)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1801495118692509)
,p_plug_name=>'No Icon'
,p_parent_plug_id=>wwv_flow_imp.id(1800615853692501)
,p_region_css_classes=>'a-Alert--inline'
,p_region_template_options=>'#DEFAULT#:a-Alert--info:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>21
,p_plug_source=>'<p>Upload a new icon or use one of the &PRODUCT_NAME. stock icons to personalize this application.</p>'
,p_plug_display_condition_type=>'NOT_EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_static_files',
' where security_group_id = :workspace_id',
'   and flow_id           = :fb_flow_id',
'   and file_name         like ''icons/app-icon-%''',
'',
'union all',
'',
'select 1',
'  from wwv_flows',
' where security_group_id       = :workspace_id',
'   and id                      = :fb_flow_id',
'   and ( app_builder_icon_name is not null ',
'      or pwa_manifest_icon_url is not null )'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(1802876224692523)
,p_name=>'Icons'
,p_parent_plug_id=>wwv_flow_imp.id(1800615853692501)
,p_template=>wwv_flow_imp.id(208928010704475743)
,p_display_sequence=>31
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--horizontalBorders:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  ''icons/app-icon-32.png'' file_name,',
'        ''32x32'' file_size,',
'        coalesce ( ( select wwv_flow_file_editor_dev.get_file_reference (',
'                               p_scope     => ''APP'',',
'                               p_app_id    => :FB_FLOW_ID,',
'                               p_file_name => file_name )',
'                       from wwv_flow_static_files',
'                      where security_group_id = :WORKSPACE_ID',
'                        and flow_id           = :FB_FLOW_ID',
'                        and file_name         = ''icons/app-icon-32.png'' ), wwv_flow_lang.system_message(''UI.APP.ICON.NOT_FOUND'') ) reference,',
'        wwv_flow_lang.system_message(''UI.APP.ICON.FAVICON'') purpose,',
'        ( select ''<img class="app-icon-favicon"'' ||',
'                 wwv_flow_plugin_util.get_html_attr(',
'                     p_name  => ''aria-label'',',
'                     p_value => wwv_flow_lang.system_message( ''UI.APP.ICON.FAVICON'' ) ) ||',
'                 '' src="wwv_flow_file_mgr.get_file?p_security_group_id=&WORKSPACE_ID.&p_flow_id=&FB_FLOW_ID.&p_fname=''||file_name||''">''',
'            from wwv_flow_static_files',
'           where security_group_id = :WORKSPACE_ID',
'             and flow_id           = :FB_FLOW_ID',
'             and file_name         = ''icons/app-icon-32.png'' ) preview',
'  from sys.dual',
'',
'union all',
'',
'select  ''icons/app-icon-144-rounded.png'' file_name,',
'        ''144x144'' file_size,',
'        coalesce ( ( select wwv_flow_file_editor_dev.get_file_reference (',
'                               p_scope     => ''APP'',',
'                               p_app_id    => :FB_FLOW_ID,',
'                               p_file_name => file_name )',
'                       from wwv_flow_static_files',
'                      where security_group_id = :WORKSPACE_ID',
'                        and flow_id           = :FB_FLOW_ID',
'                        and file_name         = ''icons/app-icon-144-rounded.png'' ), wwv_flow_lang.system_message(''UI.APP.ICON.NOT_FOUND'') ) reference,',
'        wwv_flow_lang.system_message(''UI.APP.ICON.SMALL_ROUNDED_ICON'') purpose,',
'        ( select ''<img class="app-icon-small"'' ||',
'                 wwv_flow_plugin_util.get_html_attr(',
'                     p_name  => ''aria-label'',',
'                     p_value => wwv_flow_lang.system_message( ''UI.APP.ICON.SMALL_ROUNDED_ICON'' ) ) ||',
'                 '' src="wwv_flow_file_mgr.get_file?p_security_group_id=&WORKSPACE_ID.&p_flow_id=&FB_FLOW_ID.&p_fname=''||file_name||''">''',
'            from wwv_flow_static_files',
'           where security_group_id = :WORKSPACE_ID',
'             and flow_id           = :FB_FLOW_ID',
'             and file_name         = ''icons/app-icon-144-rounded.png'' ) preview',
'  from sys.dual',
'',
'union all',
'',
'select  ''icons/app-icon-192.png'' file_name,',
'        ''192x192'' file_size,',
'        coalesce ( ( select wwv_flow_file_editor_dev.get_file_reference (',
'                               p_scope     => ''APP'',',
'                               p_app_id    => :FB_FLOW_ID,',
'                               p_file_name => file_name )',
'                       from wwv_flow_static_files',
'                      where security_group_id = :WORKSPACE_ID',
'                        and flow_id           = :FB_FLOW_ID',
'                        and file_name         = ''icons/app-icon-192.png'' ), wwv_flow_lang.system_message(''UI.APP.ICON.NOT_FOUND'') ) reference,',
'        wwv_flow_lang.system_message(''UI.APP.ICON.SMALL_ICON'') purpose,',
'        ( select ''<img class="app-icon-small"'' ||',
'                 wwv_flow_plugin_util.get_html_attr(',
'                     p_name  => ''aria-label'',',
'                     p_value => wwv_flow_lang.system_message(''UI.APP.ICON.SMALL_ICON'') ) ||',
'                 '' src="wwv_flow_file_mgr.get_file?p_security_group_id=&WORKSPACE_ID.&p_flow_id=&FB_FLOW_ID.&p_fname=''||file_name||''">''',
'            from wwv_flow_static_files',
'           where security_group_id = :WORKSPACE_ID',
'             and flow_id           = :FB_FLOW_ID',
'             and file_name         = ''icons/app-icon-192.png'' ) preview',
'  from sys.dual',
'',
'union all',
'',
'select  ''icons/app-icon-256-rounded.png'' file_name,',
'        ''256x256'' file_size,',
'        coalesce ( ( select wwv_flow_file_editor_dev.get_file_reference (',
'                               p_scope     => ''APP'',',
'                               p_app_id    => :FB_FLOW_ID,',
'                               p_file_name => file_name )',
'                       from wwv_flow_static_files',
'                      where security_group_id = :WORKSPACE_ID',
'                        and flow_id           = :FB_FLOW_ID',
'                        and file_name         = ''icons/app-icon-256-rounded.png'' ), wwv_flow_lang.system_message(''UI.APP.ICON.NOT_FOUND'') ) reference,',
'        wwv_flow_lang.system_message(''UI.APP.ICON.LARGE_ROUNDED_ICON'') purpose,',
'        ( select ''<img class="app-icon-large"'' ||',
'                 wwv_flow_plugin_util.get_html_attr(',
'                     p_name  => ''aria-label'',',
'                     p_value => wwv_flow_lang.system_message( ''UI.APP.ICON.LARGE_ROUNDED_ICON'' ) ) ||',
'                 '' src="wwv_flow_file_mgr.get_file?p_security_group_id=&WORKSPACE_ID.&p_flow_id=&FB_FLOW_ID.&p_fname=''||file_name||''">''',
'            from wwv_flow_static_files',
'           where security_group_id = :WORKSPACE_ID',
'             and flow_id           = :FB_FLOW_ID',
'             and file_name         = ''icons/app-icon-256-rounded.png'' ) preview',
'  from sys.dual',
'',
'union all',
'',
'select  ''icons/app-icon-512.png'' file_name,',
'        ''512x512'' file_size,',
'        coalesce ( ( select wwv_flow_file_editor_dev.get_file_reference (',
'                               p_scope     => ''APP'',',
'                               p_app_id    => :FB_FLOW_ID,',
'                               p_file_name => file_name )',
'                       from wwv_flow_static_files',
'                      where security_group_id = :WORKSPACE_ID',
'                        and flow_id           = :FB_FLOW_ID',
'                        and file_name         = ''icons/app-icon-512.png'' ), wwv_flow_lang.system_message(''UI.APP.ICON.NOT_FOUND'') ) reference,',
'        wwv_flow_lang.system_message(''UI.APP.ICON.LARGE_ICON'') purpose,',
'        ( select ''<img class="app-icon-large"'' ||',
'                 wwv_flow_plugin_util.get_html_attr(',
'                     p_name  => ''aria-label'',',
'                     p_value => wwv_flow_lang.system_message( ''UI.APP.ICON.LARGE_ICON'' ) ) ||',
'                 '' src="wwv_flow_file_mgr.get_file?p_security_group_id=&WORKSPACE_ID.&p_flow_id=&FB_FLOW_ID.&p_fname=''||file_name||''">''',
'            from wwv_flow_static_files',
'           where security_group_id = :WORKSPACE_ID',
'             and flow_id           = :FB_FLOW_ID',
'             and file_name         = ''icons/app-icon-512.png'' ) preview',
'  from sys.dual'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_static_files',
' where security_group_id = :workspace_id',
'   and flow_id           = :fb_flow_id',
'   and file_name         like ''icons/app-icon-%'''))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4240065847012908)
,p_query_column_id=>1
,p_column_alias=>'FILE_NAME'
,p_column_display_sequence=>10
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5260269637466725)
,p_query_column_id=>2
,p_column_alias=>'FILE_SIZE'
,p_column_display_sequence=>20
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2942760300641630)
,p_query_column_id=>3
,p_column_alias=>'REFERENCE'
,p_column_display_sequence=>60
,p_column_heading=>'Reference'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2942850182641631)
,p_query_column_id=>4
,p_column_alias=>'PURPOSE'
,p_column_display_sequence=>50
,p_column_heading=>'Icon'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4012975099396150)
,p_query_column_id=>4
,p_column_alias=>'DERIVED$01'
,p_column_display_sequence=>70
,p_column_heading=>'Actions'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:192:&SESSION.::&DEBUG.:192:P192_FILE_NAME,P192_FILE_SIZE,P192_ICON_NAME:#FILE_NAME#,#FILE_SIZE#,#PURPOSE#'
,p_column_linktext=>'Edit'
,p_column_link_attr=>'role="button" aria-haspopup="dialog" class="a-Button a-Button--small" aria-description="Edit #PURPOSE#" title="Edit #PURPOSE#"'
,p_column_alignment=>'CENTER'
,p_derived_column=>'Y'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5260422839466727)
,p_query_column_id=>5
,p_column_alias=>'PREVIEW'
,p_column_display_sequence=>40
,p_column_heading=>'Preview'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(2943800823641641)
,p_name=>'This application uses legacy icons'
,p_parent_plug_id=>wwv_flow_imp.id(1800615853692501)
,p_template=>wwv_flow_imp.id(770240542605907344)
,p_display_sequence=>41
,p_region_css_classes=>'a-Alert--inline'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--horizontal'
,p_component_template_options=>'#DEFAULT#:a-Report--horizontalBorders:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  wwv_flow_file_editor_dev.get_file_reference (',
'            p_scope     => ''APP'',',
'            p_app_id    => :FB_FLOW_ID,',
'            p_file_name => app_builder_icon_name ) reference,',
'        wwv_flow_lang.system_message(''UI.APP.ICON.BUILDER_ICON'') purpose',
'  from wwv_flows',
' where security_group_id     = :WORKSPACE_ID',
'   and id                    = :FB_FLOW_ID',
'   and app_builder_icon_name is not null',
'',
'union all',
'',
'select  pwa_manifest_icon_url reference,',
'        wwv_flow_lang.system_message(''UI.APP.ICON.PWA_ICON'') purpose',
'  from wwv_flows',
' where security_group_id     = :WORKSPACE_ID',
'   and id                    = :FB_FLOW_ID',
'   and pwa_manifest_icon_url is not null',
'',
''))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flows',
' where security_group_id       = :workspace_id',
'   and id                      = :fb_flow_id',
'   and ( app_builder_icon_name is not null ',
'      or pwa_manifest_icon_url is not null ',
'      or favicons              is not null )'))
,p_display_condition_type=>'EXISTS'
,p_header=>'<p class="margin-top-sm margin-bottom-sm">Legacy icons still work as originally intended. If you are using the <strong>Change Icon</strong> button, legacy icons will be replaced.</p>'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2944496335641647)
,p_query_column_id=>1
,p_column_alias=>'REFERENCE'
,p_column_display_sequence=>20
,p_column_heading=>'Reference'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2944569390641648)
,p_query_column_id=>2
,p_column_alias=>'PURPOSE'
,p_column_display_sequence=>10
,p_column_heading=>'Icon'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(72766345492681456)
,p_plug_name=>'Attributes'
,p_parent_plug_id=>wwv_flow_imp.id(28154408216362812)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>510
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(314888924704274854)
,p_plug_name=>'Advanced'
,p_parent_plug_id=>wwv_flow_imp.id(28154408216362812)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>570
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(314912623768407097)
,p_plug_name=>'Logo'
,p_parent_plug_id=>wwv_flow_imp.id(28154408216362812)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>420
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(935666971301945228)
,p_name=>'Concatenated Files'
,p_region_name=>'cont_file'
,p_parent_plug_id=>wwv_flow_imp.id(28154408216362812)
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>560
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       combined_file_url,',
'       page_id,',
'       required_patch',
'  from wwv_flow_combined_files',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(28177847720421910)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(28178244311421912)
,p_query_column_id=>2
,p_column_alias=>'COMBINED_FILE_URL'
,p_column_display_sequence=>2
,p_column_heading=>'File URL'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:209:&SESSION.::&DEBUG.:RP,209:P209_ID:#ID#:'
,p_column_linktext=>'#COMBINED_FILE_URL#'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(28178634193421912)
,p_query_column_id=>3
,p_column_alias=>'PAGE_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Only for Page'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(28179064484421913)
,p_query_column_id=>4
,p_column_alias=>'REQUIRED_PATCH'
,p_column_display_sequence=>4
,p_column_heading=>'Build Option'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV'
,p_named_lov=>wwv_flow_imp.id(198057397)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(954613046208277179)
,p_plug_name=>'Navigation Menu'
,p_parent_plug_id=>wwv_flow_imp.id(28154408216362812)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>520
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_themes',
'  where flow_id = :fb_flow_id ',
'     and security_group_id = :flow_security_group_id ',
'     and navigation_type = ''L'''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(965345241777755622)
,p_plug_name=>'JavaScript'
,p_region_name=>'JAVASCRIPT'
,p_parent_plug_id=>wwv_flow_imp.id(28154408216362812)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>530
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(974623159349045062)
,p_plug_name=>'CSS'
,p_region_name=>'CSS'
,p_parent_plug_id=>wwv_flow_imp.id(28154408216362812)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>550
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1329538546154482129)
,p_plug_name=>'Navigation Bar'
,p_parent_plug_id=>wwv_flow_imp.id(28154408216362812)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>525
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(42237425257357106)
,p_plug_name=>'Application Attributes'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_04'
,p_list_id=>wwv_flow_imp.id(274897624522614662)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_landmark_type=>'navigation'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(42241822749375265)
,p_plug_name=>'Application &FB_FLOW_ID.'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>200
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_landmark_label=>'User Interface Actions'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(314914514202413808)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>600
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Edit the Application''s User Interface definitions.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(314916312648451181)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>300
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(28179438634421914)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(935666971301945228)
,p_button_name=>'CREATE_FILE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'Create Concatenated File'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:209:&SESSION.::&DEBUG.:RP,209:P209_FLOW_ID:&FB_FLOW_ID.'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1801214154692507)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1800615853692501)
,p_button_name=>'EDIT_ALL_ICON'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Change Icon'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:198:&SESSION.::&DEBUG.:198::'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_static_files',
' where security_group_id = :workspace_id',
'   and flow_id           = :fb_flow_id',
'   and file_name         like ''icons/app-icon-%''',
'',
'union all',
'',
'select 1',
'  from wwv_flows',
' where security_group_id       = :workspace_id',
'   and id                      = :fb_flow_id',
'   and ( app_builder_icon_name is not null ',
'      or pwa_manifest_icon_url is not null )'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4012329356396144)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1800615853692501)
,p_button_name=>'APPLICATION_ICON_HELP'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Application Icon Help'
,p_button_position=>'EDIT'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'icon-help'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4012636776396147)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(314912623768407097)
,p_button_name=>'APPLICATION_LOGO_HELP'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Application Logo Help'
,p_button_position=>'EDIT'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'icon-help'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(599202875978999630)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1801495118692509)
,p_button_name=>'UPLOAD_NEW_ICON'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Set Icon'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:198:&SESSION.::&DEBUG.:198::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(314915609111433272)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(42241822749375265)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(314915805876434764)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(42241822749375265)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'FB_FLOW_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(42566501117233036)
,p_branch_action=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:1::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>1
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow.g_request in (''Create'',''Delete'')'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(42465100256920542)
,p_branch_action=>'f?p=&APP_ID.:4001:&SESSION.::&DEBUG.:4001:FB_FLOW_ID:&FB_FLOW_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>11
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_DEFN'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(42459503205850081)
,p_branch_action=>'f?p=&APP_ID.:509:&SESSION.::&DEBUG.:509:FB_FLOW_ID:&FB_FLOW_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>31
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_SEC'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(42447608221572721)
,p_branch_action=>'f?p=&APP_ID.:506:&SESSION.::&DEBUG.:RP,506:FB_FLOW_ID:&FB_FLOW_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_GLOBAL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(6207830463993242)
,p_branch_name=>'Go To Page 507'
,p_branch_action=>'f?p=&APP_ID.:507:&SESSION.::&DEBUG.:RP,507:FB_FLOW_ID:&FB_FLOW_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_PWA'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1767809525833402)
,p_branch_name=>'Go To Page 523'
,p_branch_action=>'f?p=&APP_ID.:523:&SESSION.::&DEBUG.:523:FB_FLOW_ID:&FB_FLOW_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_AI'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1407141969590715)
,p_name=>'P197_AUTO_DISMISS_SUCCESS_MSG'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(72766345492681456)
,p_item_source_plug_id=>wwv_flow_imp.id(28154408216362812)
,p_item_default=>'N'
,p_prompt=>'Auto Dismiss Success Messages'
,p_source=>'AUTO_DISMISS_SUCCESS_MSG'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>When set to <strong>On</strong>, all success messages in this application will be dismissed automatically after 5 seconds. If a user interacts with a message before it is dismissed, the time will be reset and it will be another 5 seconds before th'
||'e message gets dismissed.</p>',
'<p>When set to <strong>Off</strong>, success messages will remain visible until the application user manually dismisses them.</p>',
'<p>Note that it is important to take into consideration the accessibility impact auto-dismiss could have on users. Some may not see or read a success message before it is dismissed, and could miss the information in the message. If turning auto-dismi'
||'ss on, consider providing users with settings that allow them to opt in or out of auto-dismiss, using the <a rel="noopener noreferrer" target="_blank" href="https://docs.oracle.com/en/database/oracle/apex/23.2/aexjs/apex.message.html#.setDismissPrefe'
||'rences">apex.message setDismissPreferences API</a>.</p>'))
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4240728571012915)
,p_name=>'P197_PREVIEW_SIZE'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(1800615853692501)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select rtrim(ltrim(file_name, ''icons/app-icon-''), ''.png'')||',
'       ''x''||',
'       rtrim(ltrim(file_name, ''icons/app-icon-''), ''.png'')',
'  from wwv_flow_static_files',
' where security_group_id = :workspace_id',
'   and flow_id           = :fb_flow_id',
'   and file_name         like ''icons/app-icon-%''',
'   order by file_name desc',
'   fetch first 1 row only'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(26446402851095196)
,p_name=>'P197_FILE_PREFIX'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(314888924704274854)
,p_item_source_plug_id=>wwv_flow_imp.id(28154408216362812)
,p_prompt=>'&num;APP_FILES&num; Path'
,p_source=>'FILE_PREFIX'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Determines the virtual path the Web server uses to point to the static files when using <code>&#35;APP_FILES&#35;</code> substitution string.</p>',
'',
'<p>Do not specify anything to reference files which are stored with your application definition in the database.</p>',
'',
'<p>For performance reasons you can also store your application files on your Web server or a Content Delivery Network (CDN). Use any valid URL to reference them.</p>',
'',
'<p>Examples:',
'<ul>',
'  <li>/myFiles/</li>',
'  <li>https://www.example.com/myFiles/</li>',
'</ul>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28133906624289590)
,p_name=>'P197_THEME_IDENTIFIER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(28154408216362812)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28136490921290947)
,p_name=>'P197_THEME_STYLE_BY_USER_PREF'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(72766345492681456)
,p_item_source_plug_id=>wwv_flow_imp.id(28154408216362812)
,p_prompt=>'Enable End Users to choose Theme Style'
,p_source=>'THEME_STYLE_BY_USER_PREF'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'When set to <strong>On</strong>, end users can choose a Theme Style for their sessions within a customization dialog. Only Theme Styles marked as "Public" are eligible for selection.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28137307244290947)
,p_name=>'P197_BUILT_WITH_LOVE'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(72766345492681456)
,p_item_source_plug_id=>wwv_flow_imp.id(28154408216362812)
,p_item_default=>'Y'
,p_prompt=>'Add "Built with APEX" to Footer'
,p_source=>'BUILT_WITH_LOVE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'When set to <strong>On</strong>, &PRODUCT_NAME. will add the text <em>Built with Love using &PRODUCT_NAME.</em> to the footer of every page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28138249354290948)
,p_name=>'P197_HOME_LINK'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(72766345492681456)
,p_item_source_plug_id=>wwv_flow_imp.id(28154408216362812)
,p_prompt=>'Home URL'
,p_source=>'HOME_LINK'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'PAGE URL'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||'' ''||name n, ''f?p=&''||''APP_ID.:''||id||'':&''||''SESSION.'' d',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 1'))
,p_cSize=>60
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Specify the home page of the application for the current user interface.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28139190467290948)
,p_name=>'P197_LOGIN_URL'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(72766345492681456)
,p_item_source_plug_id=>wwv_flow_imp.id(28154408216362812)
,p_prompt=>'Login URL'
,p_source=>'LOGIN_URL'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'PAGE URL'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||'' ''||name n, ''f?p=&''||''APP_ID.:''||id||'':&''||''SESSION.'' d',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 1'))
,p_cSize=>60
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Specify the login page of the application for the current user interface.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28140059122290949)
,p_name=>'P197_THEME_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(72766345492681456)
,p_item_source_plug_id=>wwv_flow_imp.id(28154408216362812)
,p_prompt=>'Theme:'
,p_source=>'THEME_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>'select theme_name d, theme_id r from wwv_flow_themes where flow_id = :FB_FLOW_ID'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Shows the theme currently associated with the user interface.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28140927579290949)
,p_name=>'P197_ACTIVE_STYLE'
,p_is_required=>true
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(72766345492681456)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'for c1 in (',
'select "ID"',
'from "WWV_FLOW_THEME_STYLES" ',
' where flow_id           = :P197_ID',
'   and theme_id          = :P197_THEME_ID',
'   and security_group_id = :WORKSPACE_ID  ',
'   and is_current = ''Y''',
') loop',
'return c1.id;',
'end loop;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Theme Style:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select "NAME", "ID"',
'from "WWV_FLOW_THEME_STYLES" ',
' where flow_id           = :P197_ID',
'   and theme_id          = :P197_THEME_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select a theme style -'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from "WWV_FLOW_THEME_STYLES" ',
' where flow_id           = :P197_ID',
'   and theme_id          = :P197_THEME_ID',
'   and security_group_id = :WORKSPACE_ID  '))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28141391013290950)
,p_name=>'P197_GLOBAL_PAGE_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(72766345492681456)
,p_item_source_plug_id=>wwv_flow_imp.id(28154408216362812)
,p_prompt=>'Global Page:'
,p_source=>'GLOBAL_PAGE_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Shows the global page of the application - if one is defined.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28163713099415366)
,p_name=>'P197_DISPLAY_NAV'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(954613046208277179)
,p_prompt=>'Display Navigation'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28164168624415366)
,p_name=>'P197_NAVIGATION_LIST_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(954613046208277179)
,p_item_source_plug_id=>wwv_flow_imp.id(28154408216362812)
,p_prompt=>'Navigation Menu List'
,p_source=>'NAVIGATION_LIST_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LISTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id ',
'  from wwv_flow_lists',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
' order by upper(name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Navigation List -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select the list utilized for the navigation menu for the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28165085833415367)
,p_name=>'P197_NAVIGATION_POSITION'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(954613046208277179)
,p_item_source_plug_id=>wwv_flow_imp.id(28154408216362812)
,p_prompt=>'Position'
,p_source=>'NAVIGATION_LIST_POSITION'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'NAV_MENU_POSITION_ICONS'
,p_lov=>'.'||wwv_flow_imp.id(1856613427542451349)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select the position where you would like your navigation menu to be placed on this application.  ',
'<br/><br/>',
'Setting the position to <strong>Side</strong> will render the navigation menu list template in the #SIDE_GLOBAL_NAVIGATION_LIST# position on your page template. ',
'<br/><br/>',
'Setting the position to <strong>Top</strong> will render the navigation menu list template in the #TOP_GLOBAL_NAVIGATION_LIST# position on your page template. ',
'<br/><br/>',
'For example, if you choose <strong>Side</strong>, your navigation could be rendered as a tree on the left side of your pages; and choosing <strong>Top</strong> can render your navigation as a menu bar in the header of your pages.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
,p_attribute_04=>'VERTICAL'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28165905363415367)
,p_name=>'P197_NAVIGATION_LIST_TEMPLATE'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(954613046208277179)
,p_item_source_plug_id=>wwv_flow_imp.id(28154408216362812)
,p_prompt=>'List Template'
,p_source=>'NAVIGATION_LIST_TEMPLATE_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_LIST_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''LIST''',
'and flow_id = :fb_flow_id ',
'and theme_id = :fb_theme_id',
'order by upper(name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'No Template'
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>'Select the List Template used to render the navigation menu for the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28166832707415368)
,p_name=>'P197_NAV_LIST_TEMPLATE_OPTIONS'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(954613046208277179)
,p_item_source_plug_id=>wwv_flow_imp.id(28154408216362812)
,p_prompt=>'Template Options'
,p_source=>'NAV_LIST_TEMPLATE_OPTIONS'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.TEMPALTE_OPT_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * from (',
'select o.display_name as d,',
'       o.css_classes as r,',
'       t.default_template_options,',
'       t.preset_template_options,',
'       o.help_text,',
'       (select display_name ',
'        from wwv_flow_template_opt_groups',
'        where o.group_id = id) group_name,',
'       (select is_advanced ',
'        from wwv_flow_template_opt_groups',
'        where o.group_id = id) advanced_group        ',
'  from wwv_flow_template_options o,',
'       wwv_flow_list_templates t',
' where o.flow_id = :FB_FLOW_ID',
'   and t.id = o.list_template_id',
'   and list_template_id = :P197_NAVIGATION_LIST_TEMPLATE',
'union',
'select o.display_name as d,',
'       o.css_classes as r,',
'       null default_template_options,',
'       null preset_template_options,',
'       o.help_text,',
'       (select display_name ',
'        from wwv_flow_template_opt_groups',
'        where o.group_id = id) group_name,',
'       (select is_advanced ',
'        from wwv_flow_template_opt_groups',
'        where o.group_id = id) advanced_group         ',
'  from wwv_flow_template_options o',
' where o.flow_id = :FB_FLOW_ID',
'   and o.virtual_template_id is null',
'   and o.template_types = ''LIST''',
') order by advanced_group nulls first,  group_name nulls first, d',
''))
,p_lov_cascade_parent_items=>'P197_NAVIGATION_LIST_TEMPLATE'
,p_ajax_optimize_refresh=>'Y'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Set Template Options for the List Template used for the navigation menu list for the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28167739385415369)
,p_name=>'P197_TOP_TEMPLATE_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(954613046208277179)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28168142425415369)
,p_name=>'P197_SIDE_TEMPLATE_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(954613046208277179)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28168866070417121)
,p_name=>'P197_NAV_BAR_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1329538546154482129)
,p_item_source_plug_id=>wwv_flow_imp.id(28154408216362812)
,p_item_default=>'NAVBAR'
,p_prompt=>'Implementation'
,p_source=>'NAV_BAR_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'NAV_BAR_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(1383750926477562234)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select how to you wish to implement the navigation bar in this application.  ',
'<br/><br/>',
'Setting to <strong>Classic</strong> will render the navigation bar as a classic navigation bar in the #NAVIGATION_BAR# position on your page template. ',
'<br/><br/>',
'Setting to <strong>List</strong> will render the navigation bar as a list, using the selected list and list template in the #NAVIGATION_BAR# position on your page template.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28169758250417121)
,p_name=>'P197_NAV_BAR_LIST_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1329538546154482129)
,p_item_source_plug_id=>wwv_flow_imp.id(28154408216362812)
,p_prompt=>'Navigation Bar List'
,p_source=>'NAV_BAR_LIST_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LISTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id ',
'  from wwv_flow_lists',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
' order by upper(name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Navigation List -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select the list utilized for the navigation bar on this application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28170642165417122)
,p_name=>'P197_NAV_BAR_LIST_TEMPLATE_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1329538546154482129)
,p_item_source_plug_id=>wwv_flow_imp.id(28154408216362812)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    r number null;',
'begin',
'    for c1 in (select default_nav_bar_list_template ',
'                 from wwv_flow_themes ',
'                where flow_id = :fb_flow_id',
'                  and theme_id = :fb_theme_id',
'                  and security_group_id = :flow_security_group_id)',
'    loop',
'        r := c1.default_nav_bar_list_template;',
'    end loop;',
'    return r;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'List Template'
,p_source=>'NAV_BAR_LIST_TEMPLATE_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_LIST_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''LIST''',
'and flow_id = :fb_flow_id ',
'and theme_id = :fb_theme_id',
'order by upper(name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'No Template'
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>'Select the List Template used to render the navigation bar on this application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28171558111417124)
,p_name=>'P197_NAV_BAR_TEMPLATE_OPTIONS'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(1329538546154482129)
,p_item_source_plug_id=>wwv_flow_imp.id(28154408216362812)
,p_prompt=>'Template Options'
,p_source=>'NAV_BAR_TEMPLATE_OPTIONS'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.TEMPALTE_OPT_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * from (',
'select o.display_name as d,',
'       o.css_classes as r,',
'       t.default_template_options,',
'       t.preset_template_options,',
'       o.help_text,',
'       (select display_name ',
'        from wwv_flow_template_opt_groups',
'        where o.group_id = id) group_name,',
'       (select is_advanced ',
'        from wwv_flow_template_opt_groups',
'        where o.group_id = id) advanced_group        ',
'  from wwv_flow_template_options o,',
'       wwv_flow_list_templates t',
' where o.flow_id = :FB_FLOW_ID',
'   and t.id = o.list_template_id',
'   and list_template_id = :P197_NAV_BAR_LIST_TEMPLATE_ID',
'union',
'select o.display_name as d,',
'       o.css_classes as r,',
'       null default_template_options,',
'       null preset_template_options,',
'       o.help_text,',
'       (select display_name ',
'        from wwv_flow_template_opt_groups',
'        where o.group_id = id) group_name,',
'       (select is_advanced ',
'        from wwv_flow_template_opt_groups',
'        where o.group_id = id) advanced_group         ',
'  from wwv_flow_template_options o',
' where o.flow_id = :FB_FLOW_ID',
'   and o.virtual_template_id is null',
'   and o.template_types = ''LIST''',
') order by advanced_group nulls first,  group_name nulls first, d'))
,p_lov_cascade_parent_items=>'P197_NAV_BAR_LIST_TEMPLATE_ID'
,p_ajax_optimize_refresh=>'Y'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Set Template Options for the List Template used for the navigation bar in this application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28173662495419386)
,p_name=>'P197_JAVASCRIPT_FILE_URLS'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(965345241777755622)
,p_item_source_plug_id=>wwv_flow_imp.id(28154408216362812)
,p_prompt=>'File URLs'
,p_source=>'JAVASCRIPT_FILE_URLS'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'a-Form-fieldContainer--fieldsetBlock'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_is_persistent=>'N'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter JavaScript file URLs for code to be loaded on every page. Each URL has to be written into a new line. If you provide a minified version of your file, you can use the substitution string <code>#MIN#</code> to include <code>.min</code> or <cod'
||'e>#MIN_DIRECTORY#</code> to include <code>minified/</code> in your file URL for a regular page view and an empty string if the page is viewed in debug mode.</p>',
'',
'<p>JavaScript file URLs you enter here replaces the <code>#APPLICATION_JAVASCRIPT#</code> substitution string in the page template.</p>',
'',
'<p>Note: You do not need to include opening or closing <code>script</code> tags. Just write the URL.',
'',
'<p>',
'Examples:',
'<ul>',
'  <li>Standard file reference:',
'      <pre>/myjs/main.js</pre>',
'  </li>',
'  <li>Standard file reference which loads the minified file main.min.js from /myjs/minified/ for regular page views and main.js from /myjs/ in debug mode:',
'      <pre>/myjs/#MIN_DIRECTORY#main#MIN#.js</pre>',
'  </li>',
'  <li>Use this syntax if the library is also used from a RequireJS require call. The define name must match what is used in the requirejs.config paths and the value must be the global symbol exposed by the library. Only applies when using RequireJS. '
||'This avoids RequireJS  loading that library a second time.',
'      <pre>[define hammerjs=Hammer]/myjs/hammer.js</pre>',
'  </li>',
'  <li>Use this syntax if the file has a dependency on RequireJS. This will automatically load RequireJS before this file.',
'      <pre>[require requirejs]/myjs/main.js</pre>',
'  </li>',
'  <li>Use this syntax if the file has a dependency on Oracle JET. This will automatically load RequireJS and the Oracle JET RequireJS configuration before this file.',
'      <pre>[require jet]/myjs/main.js</pre>',
'  </li>',
'</ul>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28174547620419386)
,p_name=>'P197_INCLUDE_LEGACY_JAVASCRIPT'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(965345241777755622)
,p_item_source_plug_id=>wwv_flow_imp.id(28154408216362812)
,p_prompt=>'Include Deprecated or Desupported Javascript Functions'
,p_source=>'INCLUDE_LEGACY_JAVASCRIPT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'INCLUDE_LEGACY_JAVASCRIPT'
,p_lov=>'.'||wwv_flow_imp.id(723325277005791161)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Specifies if deprecated or desupported JavaScript functions are included on every page in the application. The functions deprecated or desupported are listed in the Release Notes for every release. If you are confident your application does not conta'
||'in any references to those deprecated or desupported functions, don''t check any checkbox to reduce the overall size of the JavaScript files loaded.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'VERTICAL'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28175452091419387)
,p_name=>'P197_INCLUDE_JQUERY_MIGRATE'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(965345241777755622)
,p_item_source_plug_id=>wwv_flow_imp.id(28154408216362812)
,p_prompt=>'Include jQuery Migrate'
,p_source=>'INCLUDE_JQUERY_MIGRATE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specifies if the <strong>jQuery Migrate</strong> plug-in should be included on every page in the application.</p>',
'',
'<p>The plug-in restores deprecated features and behaviors of jQuery so that old JavaScript code and jQuery plug-ins will still run properly with the jQuery version loaded by &PRODUCT_NAME..</p>',
'',
'<p>If you are confident your application and any used jQuery plug-in does not contain any references to deprecated jQuery features, set this to <strong>Off</strong> to reduce the overall size of the JavaScript files loaded.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28176661045420819)
,p_name=>'P197_CSS_FILE_URLS'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(974623159349045062)
,p_item_source_plug_id=>wwv_flow_imp.id(28154408216362812)
,p_prompt=>'File URLs'
,p_source=>'CSS_FILE_URLS'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'a-Form-fieldContainer--fieldsetBlock'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter CSS file URLs to be loaded on every page. Each URL has to be written into a new line. If you provide a minified version of your file you can use the substitution string <code>#MIN#</code> to include <code>.min</code> or <code>#MIN_DIRECTORY#'
||'</code> to include <code>minified/</code> in your file URL for a regular page view and an empty string if the page is viewed in debug mode. You also have access to the substitution string <code>#APP_VERSION#</code> if you want to include the applicat'
||'ion''s version in the file URL.</p>',
'',
'<p>File URLs you enter here will replace the <code>#APPLICATION_CSS#</code> substitution string in the page template.</p>',
'',
'<p>Note: You do not need to include opening or closing <code>link</code> tags. Just include the file URL.</p>',
'',
'<p>',
'Examples:',
'<ul>',
'  <li>Standard file reference',
'      <pre>/mycss/main.css</pre>',
'  </li>',
'  <li>Standard file reference which loads the minified file main.min.css from /mycss/minified/ for regular page views and main.css from /mycss/ in debug mode.',
'      <pre>/mycss/#MIN_DIRECTORY#main#MIN#.css</pre>',
'  </li>',
'  <li>Conditional media query',
'      <pre>[media="only screen and (max-device-width: 480px)"]/mycss/smartphone.css</pre>',
'  </li>',
'  <li>File reference using a query string in the URL referencing the application version, such that when the application is upgraded (and the version is incremented), the browser is instructed to always load the new file and ignore any previously cac'
||'hed files.',
'      <pre>/mycss/main.css?version=#APP_VERSION#</pre>',
'  </li>',
'</ul>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28216151114136409)
,p_name=>'P197_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_is_query_only=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(28154408216362812)
,p_item_source_plug_id=>wwv_flow_imp.id(28154408216362812)
,p_item_default=>'FB_FLOW_ID'
,p_item_default_type=>'ITEM'
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(253749558706349701)
,p_name=>'P197_LOGO_CUSTOM'
,p_item_sequence=>740
,p_item_plug_id=>wwv_flow_imp.id(314912623768407097)
,p_prompt=>'Custom HTML'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The custom logo textarea can be used to have full control over the markup of your application''s logo. The value in this field will be inserted into the <code>#LOGO#</code> substitution string of your page template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(314889621071274857)
,p_name=>'F4000_P197_FLOW_IMAGE_PREFIX'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(314888924704274854)
,p_item_source_plug_id=>wwv_flow_imp.id(28154408216362812)
,p_prompt=>'&num;APEX_FILES&num; Path'
,p_source=>'FLOW_IMAGE_PREFIX'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Determines the virtual path the Web server uses to point to the images directory distributed with &PRODUCT_NAME.. During installation, the virtual path is typically configured as <code>/i/</code>. If you are unsure, contact your administrator.<p/>',
'',
'<p>When embedding an image in static text (for example, in page or region headers or footers), you can reference an image using the substitution string <code>&#35;APEX_FILES&#35;</code>. For example, to reference the image go.gif you would use the fo'
||'llowing syntax:',
'<pre>',
'&lt;img src="&#35;APEX_FILES&#35;go.gif"&gt;',
'</pre>',
'</p>',
'',
'<p>Note: If the entered image prefix is equal to the instance image prefix, then the application-level attribute will always be null. This easily facilities the movement of an application across different instances that may have different image prefi'
||'xes.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(314891625715274859)
,p_name=>'F4000_P197_MEDIA_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(314888924704274854)
,p_item_source_plug_id=>wwv_flow_imp.id(28154408216362812)
,p_prompt=>'Media Type'
,p_source=>'MEDIA_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the Internet media type. An Internet media type is two-part identifier for file formats on the Internet. A media type is composed of at least two parts: a type and a subtype, and one or more optional parameters. This media type is used in th'
||'e Content-Type HTTP header when rendering the page.</p>',
'',
'<p>If both the page-level and application-level values for Media Type are <code>NULL</code>, <code>text/html</code> is used.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(314912815596407098)
,p_name=>'P197_LOGO_TYPE'
,p_item_sequence=>710
,p_item_plug_id=>wwv_flow_imp.id(314912623768407097)
,p_prompt=>'Logo'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'APPLICATION LOGO IMAGE OR TEXT'
,p_lov=>'.'||wwv_flow_imp.id(210991102136588089)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'None'
,p_lov_null_value=>'NO'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Use this item to define the logo for your application. An application logo can be an image, text, image and text, or based on custom markup. To use this feature, your page template must include the #LOGO# substitution string.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'5'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(314913319176407098)
,p_name=>'P197_LOGO'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>720
,p_item_plug_id=>wwv_flow_imp.id(314912623768407097)
,p_item_source_plug_id=>wwv_flow_imp.id(28154408216362812)
,p_prompt=>'Image URL'
,p_source=>'LOGO'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Please enter the url for the image to be used as the logo, including the filename extension, for example:',
'',
'<pre><strong>#</strong><strong>APP_FILES</strong><strong>#</strong>my-logo.png</pre>',
'',
'Note that to use this feature, your page template must include the <code>#LOGO#</code> substitution string.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(314913802590407103)
,p_name=>'P197_LOGO_TEXT'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>730
,p_item_plug_id=>wwv_flow_imp.id(314912623768407097)
,p_item_source_plug_id=>wwv_flow_imp.id(28154408216362812)
,p_prompt=>'Text'
,p_source=>'LOGO_TEXT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the text that should be displayed in the application logo.',
'',
'Note that to use this feature, your page template must include the <code>#LOGO#</code> substitution string.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(879699985997493821)
,p_name=>'P197_FAVICONS'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2943800823641641)
,p_item_source_plug_id=>wwv_flow_imp.id(28154408216362812)
,p_prompt=>'Favicon HTML (Deprecated)'
,p_source=>'FAVICONS'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>5
,p_display_when=>'P197_FAVICONS'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_css_classes=>'a-Form-fieldContainer--noPadding a-Form-fieldContainer--stretch margin-top-sm'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<strong>This attribute is deprecated. Use the declarative icon picker instead.</strong>',
'<p>Provide additional HTML for the <code>&lt;head&gt;</code> element of the page. The <code>&lt;head&gt;</code> element is a container for metadata and is placed between the <code>&lt;html&gt;</code> tag and the <code>&lt;body&gt;</code> tag.</p>',
'<p>This is referenced by the page template using the <code>#FAVICONS#</code> substitution string.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(29175276403846594)
,p_computation_sequence=>30
,p_computation_item=>'P197_DISPLAY_NAV'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'Y'
,p_compute_when=>'P197_NAVIGATION_LIST_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(254002063678826501)
,p_validation_name=>'Logo Image Required'
,p_validation_sequence=>10
,p_validation=>'P197_LOGO'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Image URL cannot be left blank.'
,p_validation_condition=>'P197_LOGO_TYPE'
,p_validation_condition2=>'I:IT'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(254002182301826502)
,p_validation_name=>'Logo Text Required'
,p_validation_sequence=>20
,p_validation=>'P197_LOGO_TEXT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Logo Text cannot be left blank.'
,p_validation_condition=>'P197_LOGO_TYPE'
,p_validation_condition2=>'T:IT'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(254002275739826503)
,p_validation_name=>'Logo Custom HTML Required'
,p_validation_sequence=>30
,p_validation=>'P197_LOGO_CUSTOM'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Logo Custom HTML cannot be left blank.'
,p_validation_condition=>'P197_LOGO_TYPE'
,p_validation_condition2=>'C'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(28307521873928299)
,p_validation_name=>'Navigation List Template not null'
,p_validation_sequence=>40
,p_validation=>'P197_NAVIGATION_LIST_TEMPLATE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>'P197_NAVIGATION_LIST_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(314915805876434764)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(28307864308929545)
,p_validation_name=>'Must Select Navigation Bar List'
,p_validation_sequence=>50
,p_validation=>'P197_NAV_BAR_LIST_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'A Navigation Bar List must be selected.'
,p_validation_condition=>'P197_NAV_BAR_TYPE'
,p_validation_condition2=>'LIST'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(314915805876434764)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(253749681717349702)
,p_name=>'Toggle Logo Type Items'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P197_LOGO_TYPE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(253749712202349703)
,p_event_id=>wwv_flow_imp.id(253749681717349702)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var logoType    = $v(this.triggeringElement),',
'    itemImage   = apex.item(''P197_LOGO''),',
'    itemText    = apex.item(''P197_LOGO_TEXT''),',
'    itemCustom  = apex.item(''P197_LOGO_CUSTOM'');',
'',
'    // Hide All Items',
'    itemImage.hide();',
'    itemText.hide();',
'    itemCustom.hide();',
'',
'if ( logoType === ''I'' ) {',
'    // Image Logo',
'    itemImage.show();',
'} else if ( logoType === ''IT'' ) {',
'    // Image and Text Logo',
'    itemImage.show();',
'    itemText.show();',
'} else if ( logoType === ''T'' ) {',
'    // Text Only Logo',
'    itemText.show();',
'} else if ( logoType === ''C'' ) {',
'    // Custom Logo',
'    itemCustom.show();',
'}'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(28416496256556820)
,p_name=>'Manage Navigation Bar Settings'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P197_NAV_BAR_TYPE'
,p_condition_element=>'P197_NAV_BAR_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'LIST'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(28416895792556837)
,p_event_id=>wwv_flow_imp.id(28416496256556820)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P197_NAV_BAR_LIST_ID,P197_NAV_BAR_LIST_TEMPLATE_ID,P197_NAV_BAR_TEMPLATE_OPTIONS'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(28417396688556846)
,p_event_id=>wwv_flow_imp.id(28416496256556820)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P197_NAV_BAR_LIST_ID,P197_NAV_BAR_LIST_TEMPLATE_ID,P197_NAV_BAR_TEMPLATE_OPTIONS'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(28417713490559450)
,p_name=>'Handle No Navigation'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P197_DISPLAY_NAV'
,p_condition_element=>'P197_DISPLAY_NAV'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'N'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(28418160188559451)
,p_event_id=>wwv_flow_imp.id(28417713490559450)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P197_NAVIGATION_LIST_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(28418682069559451)
,p_event_id=>wwv_flow_imp.id(28417713490559450)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P197_NAVIGATION_LIST_ID,P197_NAVIGATION_LIST_TEMPLATE,P197_NAV_LIST_TEMPLATE_OPTIONS,P197_NAVIGATION_POSITION'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(28419106475559451)
,p_event_id=>wwv_flow_imp.id(28417713490559450)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P197_NAVIGATION_LIST_ID,P197_NAVIGATION_LIST_TEMPLATE,P197_NAV_LIST_TEMPLATE_OPTIONS,P197_NAVIGATION_POSITION'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(28419630855559452)
,p_event_id=>wwv_flow_imp.id(28417713490559450)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P197_NAVIGATION_POSITION'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'TOP'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(28420099206561302)
,p_name=>'Set List Template based on Position'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P197_NAVIGATION_POSITION'
,p_condition_element=>'P197_THEME_IDENTIFIER'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'UNIVERSAL_THEME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(28420474456561311)
,p_event_id=>wwv_flow_imp.id(28420099206561302)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var template$ = $("#P197_NAVIGATION_LIST_TEMPLATE");',
'if ($v(this.triggeringElement) == ''TOP'') {',
'    $s("P197_NAVIGATION_LIST_TEMPLATE",$v("P197_TOP_TEMPLATE_ID"));',
'} else if ($v(this.triggeringElement) == ''SIDE'') {',
'    $s("P197_NAVIGATION_LIST_TEMPLATE",$v("P197_SIDE_TEMPLATE_ID"));',
'}'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(28420850710563478)
,p_name=>'Refresh after Dialog Closed'
,p_event_sequence=>50
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(935666971301945228)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(28421217861563480)
,p_event_id=>wwv_flow_imp.id(28420850710563478)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(935666971301945228)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2942997062641632)
,p_name=>'onDialogClosed EDIT_ICON'
,p_event_sequence=>60
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1801214154692507)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2943029967641633)
,p_event_id=>wwv_flow_imp.id(2942997062641632)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'location.reload();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(599202977994999631)
,p_name=>'onDialogClosed UPLOAD_NEW_ICON'
,p_event_sequence=>70
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(599202875978999630)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(599203003906999632)
,p_event_id=>wwv_flow_imp.id(599202977994999631)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'location.reload();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4241746826012925)
,p_name=>'onDialogClosedOrCanceled Icons'
,p_event_sequence=>80
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(1802876224692523)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosecanceldialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4241829408012926)
,p_event_id=>wwv_flow_imp.id(4241746826012925)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1802876224692523)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4012416321396145)
,p_name=>'onClick APPLICATION_ICON_HELP'
,p_event_sequence=>90
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(4012329356396144)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4012524332396146)
,p_event_id=>wwv_flow_imp.id(4012416321396145)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(4012191055396142)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4012773200396148)
,p_name=>'onClick APPLICATION_LOGO_HELP'
,p_event_sequence=>100
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(4012636776396147)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4012893472396149)
,p_event_id=>wwv_flow_imp.id(4012773200396148)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(4012276700396143)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(314894006050297923)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'security'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.init;',
'sys.owa_util.redirect_url(v(''LOGOUT_URL''));'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(314915805876434764)
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'    from   wwv_flow_developers',
'    where  userid = :FLOW_USER ',
'       and',
'       security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and',
'       security_group_id = ',
'         (select security_group_id from wwv_flows where id=:FB_FLOW_ID)',
'       and',
'       instr(developer_role,''EDIT'') > 0 ',
'       and',
'       (flow_id = :FB_FLOW_ID or flow_id is null)  '))
,p_process_when_type=>'NOT_EXISTS'
,p_internal_uid=>314894006050297923
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(28217703706136425)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(28154408216362812)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process WWV_FLOWS'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(314915805876434764)
,p_process_success_message=>'User Interface updated.'
,p_internal_uid=>28217703706136425
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(253749806750349704)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update Logo'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_logo_type varchar2(2);',
'    l_logo      varchar2(4000);',
'    l_logo_text varchar2(4000);',
'begin',
'    -- Cache logo type',
'    l_logo_type := :P197_LOGO_TYPE;',
'    ',
'    -- Handle No Logo',
'    if l_logo_type = ''NO'' then ',
'        l_logo_type := null;',
'        l_logo      := null;',
'        l_logo_text := null;',
'    end if;',
'',
'    -- Set logo source based on type',
'    if l_logo_type = ''C'' then',
'        l_logo := :P197_LOGO_CUSTOM;',
'    elsif l_logo_type in (''I'',''IT'') then ',
'        l_logo := :P197_LOGO;',
'    end if;',
'    ',
'    -- Set logo text for text or image and text type',
'    if l_logo_type in (''T'',''IT'') then',
'        l_logo_text := :P197_LOGO_TEXT;',
'    end if;',
'',
'    -- Update logo',
'    update wwv_flows',
'    set ',
'        logo_type = l_logo_type,',
'        logo = l_logo,',
'        logo_text = l_logo_text',
'    where ',
'        id = :FB_FLOW_ID and',
'        security_group_id = :WORKSPACE_ID;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(314915805876434764)
,p_internal_uid=>253749806750349704
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(28308015494933849)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update theme style'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'update "WWV_FLOW_THEME_STYLES" ',
'set is_current = ''Y''',
' where security_group_id = :WORKSPACE_ID  ',
'   and flow_id = :P197_ID',
'   and id = :P197_ACTIVE_STYLE',
'   and theme_id = :P197_THEME_ID;',
'   ',
'update "WWV_FLOW_THEME_STYLES" ',
'set is_current = ''N''',
' where security_group_id = :WORKSPACE_ID  ',
'   and flow_id = :P197_ID',
'   and (id <> :P197_ACTIVE_STYLE or :P197_ACTIVE_STYLE is null)',
'   and theme_id = :P197_THEME_ID;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(314915805876434764)
,p_internal_uid=>28308015494933849
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(314893626697294425)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'security'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.init;',
'sys.owa_util.redirect_url(v(''LOGOUT_URL''));',
'wwv_flow.g_unrecoverable_error := true;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'    from   wwv_flow_developers',
'    where  userid = :FLOW_USER ',
'       and',
'       security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and',
'       security_group_id = ',
'         (select security_group_id from wwv_flows where id=:FB_FLOW_ID)',
'       and',
'       instr(developer_role,''EDIT'') > 0 ',
'       and',
'       (flow_id = :FB_FLOW_ID or flow_id is null)  '))
,p_process_when_type=>'NOT_EXISTS'
,p_internal_uid=>314893626697294425
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(28193838155607550)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Theme Identifier and Navigation Template Ids'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P197_ID := :FB_FLOW_ID;',
':P197_ACTIVE_STYLE := null;',
'',
'for c1 in (',
'    select f.theme_id,',
'           tm.id,',
'           tm.theme_internal_name',
'      from wwv_flows f, wwv_flow_themes tm',
'     where f.id = :FB_FLOW_ID and',
'           tm.theme_id = f.theme_id and',
'           tm.flow_id = f.id',
')',
'loop',
'  :FB_THEME_ID := c1.theme_id;',
'  :P197_THEME_IDENTIFIER := c1.theme_internal_name;',
'  ',
'  if :P197_THEME_IDENTIFIER = ''UNIVERSAL_THEME'' then',
'      for c2 in (',
'          select ',
'          (select id from wwv_flow_list_templates where theme_id = :FB_THEME_ID and flow_id = :FB_FLOW_ID and internal_name = ''TOP_NAVIGATION_MENU'') top_id,',
'          (select id from wwv_flow_list_templates where theme_id = :FB_THEME_ID and flow_id = :FB_FLOW_ID and internal_name = ''SIDE_NAVIGATION_MENU'') side_id',
'          from dual',
'      ) loop',
'        :P197_TOP_TEMPLATE_ID := c2.top_id;',
'        :P197_SIDE_TEMPLATE_ID := c2.side_id;',
'      end loop;',
'  end if;',
'  ',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>28193838155607550
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(28154588402362813)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(28154408216362812)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize WWV_FLOWS Form'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>28154588402362813
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(253750031521349706)
,p_process_sequence=>50
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Icon & Logo Items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'    select ',
'        logo,',
'        logo_type,',
'        logo_text',
'    from ',
'        wwv_flows',
'    where',
'        id = :FB_FLOW_ID and',
'        security_group_id = :WORKSPACE_ID',
') loop',
'    :P197_LOGO_TYPE := nvl(c1.logo_type,''NO'');',
'    ',
'    -- Reset all items to null',
'    :P197_LOGO_TEXT := null;',
'    :P197_LOGO_CUSTOM := null;',
'    :P197_LOGO := null;',
'',
'    -- Set page items based on logo type',
'    if c1.logo_type = ''C'' then',
'        :P197_LOGO_CUSTOM := c1.logo;',
'    end if;',
'    ',
'    if c1.logo_type in (''I'',''IT'') then ',
'        :P197_LOGO := c1.logo;',
'    end if;',
'    ',
'    if c1.logo_type in (''T'',''IT'') then ',
'        :P197_LOGO_TEXT := c1.logo_text;',
'    end if;',
'    ',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>253750031521349706
);
end;
/
prompt --application/pages/page_00198
begin
wwv_flow_imp_page.create_page(
 p_id=>198
,p_name=>'Edit Application Icon'
,p_alias=>'EDIT-APPLICATION-ICON'
,p_page_mode=>'MODAL'
,p_step_title=>'Edit Application Icon'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#widget.cropperEditor#MIN#.js',
'#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#widget.iconEditor#MIN#.js'))
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$.fn.removeClassWithPrefix = function (prefix) {',
'  $(this).removeClass(function (index, className) {',
'    return (className.match(new RegExp("\\S*" + prefix + "\\S*", ''g'')) || []).join('' '')',
'  });',
'  return this;',
'};'))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#P198_CUSTOM_ICON_DISPLAY {',
'  display: block;',
'  max-width: 100%;',
'  height:400px;',
'}',
'',
'#P198_CUSTOM_ICON_CONTAINER,',
'#P198_CUSTOM_ICON_DISPLAY_CONTAINER  {',
'    max-width: 512px!important;',
'    margin: auto!important;',
'}',
'',
'.cropper-face {',
'    border: 2px solid white !important;',
'    opacity: 1;',
'    background-color: transparent;',
'}'))
,p_page_css_classes=>'a-PageWizard-dialog a-PageWizard-dialog--appIconPicker'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'700'
,p_dialog_width=>'760'
,p_dialog_attributes=>'resizable:true'
,p_protection_level=>'C'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2939846690641601)
,p_plug_name=>'Icons'
,p_region_name=>'app_icons_gallery'
,p_region_css_classes=>'a-PageWizard-appIcons'
,p_region_template_options=>'#DEFAULT#:a-Form--labelsAbove'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2940905588641612)
,p_plug_name=>'Or pick an icon'
,p_parent_plug_id=>wwv_flow_imp.id(2939846690641601)
,p_region_css_classes=>'a-Region-title--separator'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_condition_type=>'ITEM_IS_NULL'
,p_plug_display_when_condition=>'P198_CUSTOM_ICON'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2940278237641605)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8201956433126604)
,p_plug_name=>'Crop Icon Help'
,p_region_template_options=>'#DEFAULT#:js-dialog-size600x400'
,p_plug_template=>wwv_flow_imp.id(557449278618308550)
,p_plug_display_sequence=>20
,p_plug_source=>'sys.htp.p(wwv_flow_lang.system_message(''ICON.EDITOR.CROPPER.HELPTEXT''));'
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2940449576641607)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(2940278237641605)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P198_CUSTOM_ICON'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7549213025640201)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(2940278237641605)
,p_button_name=>'RESET'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P198_CUSTOM_ICON'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_button_css_classes=>'a-Button--noUI'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2940574737641608)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(2940278237641605)
,p_button_name=>'USE_ICON'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Icon'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P198_CUSTOM_ICON'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2940636592641609)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(2940278237641605)
,p_button_name=>'USE_CUSTOM_ICON'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Icon'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P198_CUSTOM_ICON'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2940394836641606)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2940278237641605)
,p_button_name=>'BACK'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Back'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_button_condition=>'P198_CUSTOM_ICON'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8202021669126605)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(2940278237641605)
,p_button_name=>'HELP'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Help'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P198_CUSTOM_ICON'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2601814487331201)
,p_name=>'P198_ZOOM_SLIDER_LABEL'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2939846690641601)
,p_source=>'wwv_flow_lang.system_message(''ICON.EDITOR.CROPPER.ZOOM_SLIDER_LABEL'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2939926737641602)
,p_name=>'P198_CUSTOM_ICON'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2939846690641601)
,p_prompt=>'Upload your own icon'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>30
,p_read_only_when=>'P198_CUSTOM_ICON'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'APEX_APPLICATION_TEMP_FILES'
,p_attribute_09=>'SESSION'
,p_attribute_10=>'N'
,p_attribute_11=>'image/*'
,p_attribute_12=>'DROPZONE_INLINE'
,p_attribute_13=>'Upload your own icon'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2940064037641603)
,p_name=>'P198_CUSTOM_ICON_DISPLAY'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(2939846690641601)
,p_prompt=>'Crop your icon for a perfect fit'
,p_post_element_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="u-textCenter margin-top-md">',
'<input id="APEXCropperZoom" type="range" min="0" max="100" value="0" step="1">',
'<label class="u-vh" for="APEXCropperZoom">&P198_ZOOM_SLIDER_LABEL.</label>',
'</div>'))
,p_display_as=>'NATIVE_DISPLAY_IMAGE'
,p_display_when=>'P198_CUSTOM_ICON'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'SQL'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select blob_content,',
'       name,',
'       filename,',
'       mime_type',
'  from wwv_flow_temp_files ',
' where name = :P198_CUSTOM_ICON'))
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2940720129641610)
,p_name=>'P198_ICON_COLOR'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2940905588641612)
,p_prompt=>'Icon Color'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P198_ICON_COLORS'
,p_lov=>'.'||wwv_flow_imp.id(4016945210607359)||'.'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-PageWizard-appIconColorPicker'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_attribute_01=>'8'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2940829323641611)
,p_name=>'P198_ICON_PICKER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2940905588641612)
,p_prompt=>'Icon Picker'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'P198_ICON_CLASSES'
,p_lov=>'.'||wwv_flow_imp.id(4020363974607382)||'.'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-IconList--AppIcons'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_attribute_01=>'S'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(48017593150545402)
,p_validation_name=>'P198_CUSTOM_ICON is invalid'
,p_validation_sequence=>10
,p_validation=>'return false;'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Invalid icon file.'
,p_validation_condition=>'UPLOAD_ICON_INVALID'
,p_validation_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_associated_item=>wwv_flow_imp.id(2939926737641602)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2941045898641613)
,p_name=>'onChange P198_ICON_COLOR'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P198_ICON_COLOR'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2941142497641614)
,p_event_id=>wwv_flow_imp.id(2941045898641613)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'const colorClass = apex.jQuery(this.triggeringElement)',
'    .find("input[type=''radio'']:checked + label span")',
'    .attr("class")',
'    .split(" ")',
'    .pop();',
'',
'apex.jQuery("#app_icons_gallery")',
'    .removeClassWithPrefix("app-color")',
'    .addClass(colorClass);'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2941422040641617)
,p_name=>'onChange P198_CUSTOM_ICON is valid'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P198_CUSTOM_ICON'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'this.triggeringElement.files.length === 1'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2941563149641618)
,p_event_id=>wwv_flow_imp.id(2941422040641617)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'UPLOAD_ICON'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(48017466061545401)
,p_event_id=>wwv_flow_imp.id(2941422040641617)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'UPLOAD_ICON_INVALID'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2941665772641619)
,p_name=>'onClick CANCEL'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2940449576641607)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2941715842641620)
,p_event_id=>wwv_flow_imp.id(2941665772641619)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2941963420641622)
,p_name=>'onPageLoad Cropper'
,p_event_sequence=>40
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P198_CUSTOM_ICON'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2942000503641623)
,p_event_id=>wwv_flow_imp.id(2941963420641622)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.iconEditor.initCropper({ imageItemName: ''P198_CUSTOM_ICON_DISPLAY'' });'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2942143661641624)
,p_name=>'onClick USE_CUSTOM_ICON'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2940636592641609)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2942209177641625)
,p_event_id=>wwv_flow_imp.id(2942143661641624)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(async () => {',
'    apex.util.showSpinner();',
'    await apex.iconEditor.saveCustomIcon();',
'    apex.page.submit(''USE_CUSTOM_ICON'');',
'})();'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4241396003012921)
,p_name=>'onClick USE_ICON'
,p_event_sequence=>60
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2940574737641608)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4241421047012922)
,p_event_id=>wwv_flow_imp.id(4241396003012921)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(async () => {',
'    apex.util.showSpinner();',
'    await apex.iconEditor.saveStockIcon({',
'        iconClass: apex.items.P198_ICON_PICKER.value,',
'        iconColor: apex.items.P198_ICON_COLOR.value',
'    });',
'    apex.page.submit(''USE_ICON'');',
'})();'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2944680898641649)
,p_name=>'onPageLoad Set Icon'
,p_event_sequence=>70
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NULL'
,p_display_when_cond=>'P198_CUSTOM_ICON'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2944797297641650)
,p_event_id=>wwv_flow_imp.id(2944680898641649)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P198_ICON_COLOR'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(() => {',
'    const icons = $("[name=P198_ICON_COLOR]").get().map( el => el.value );',
'    return icons[Math.floor(Math.random() * icons.length)];',
'})()'))
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4241698830012924)
,p_event_id=>wwv_flow_imp.id(2944680898641649)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P198_ICON_PICKER'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(() => {',
'    const icons = $("#P198_ICON_PICKER_SELECTION li").get().map( el => $(el).data("value") );',
'    return icons[Math.floor(Math.random() * icons.length)];',
'})()'))
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(8202100904126606)
,p_name=>'onClick HELP'
,p_event_sequence=>80
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(8202021669126605)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8202204371126607)
,p_event_id=>wwv_flow_imp.id(8202100904126606)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(8201956433126604)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(7549375526640202)
,p_name=>'onClick RESET'
,p_event_sequence=>90
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(7549213025640201)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7549412947640203)
,p_event_id=>wwv_flow_imp.id(7549375526640202)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.iconEditor.resetCropper();'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2941854700641621)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Back'
,p_process_sql_clob=>':P198_CUSTOM_ICON := null;'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2940394836641606)
,p_internal_uid=>2941854700641621
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4011574451396136)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Nullify legacy icons'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'update wwv_flows',
'   set app_builder_icon_name = null,',
'       pwa_manifest_icon_url = null,',
'       favicons              = null',
' where security_group_id = :WORKSPACE_ID',
'   and id                = :FB_FLOW_ID;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'USE_ICON,USE_CUSTOM_ICON'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_internal_uid=>4011574451396136
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2942418030641627)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'USE_ICON,USE_CUSTOM_ICON'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_internal_uid=>2942418030641627
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(154749133657137305)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load CropperJS'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_css.add_3rd_party_library_file( p_library => wwv_flow_cdn.c_library_cropperjs );',
'wwv_flow_javascript.add_3rd_party_library_file( p_library => wwv_flow_cdn.c_library_cropperjs );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>154749133657137305
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2942302480641626)
,p_process_sequence=>10
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save_icon'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin  ',
'    wwv_flow_imp_shared.create_app_static_file(',
'        p_flow_id      => :fb_flow_id,',
'        p_file_name    => ''icons/app-icon-''||wwv_flow.g_x01||''.png'',',
'        p_mime_type    => ''image/png'',',
'        p_file_charset => ''utf-8'',',
'        p_file_content => wwv_flow_webservices_api.clobbase642blob( p_clob => wwv_flow.g_clob_01 ) );',
' ',
'    wwv_flow_json.open_object;',
'    wwv_flow_json.write( p_name => ''success'', p_value => true );',
'    wwv_flow_json.close_object;',
'exception',
'    when others then',
'        wwv_flow_json.open_object;',
'        wwv_flow_json.write( p_name => ''success'', p_value => false );',
'        wwv_flow_json.write( p_name => ''message'', p_value => sqlerrm );',
'        wwv_flow_json.close_object;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2942302480641626
);
end;
/
prompt --application/pages/page_00199
begin
wwv_flow_imp_page.create_page(
 p_id=>199
,p_name=>'Create Web Service Reference - Manual'
,p_alias=>'CREATE-WEB-SERVICE-REFERENCE-MANUAL'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Web Service Reference'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(741449156151373031)
,p_plug_name=>'Web Service'
,p_region_name=>'R1'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_row_template=>wwv_flow_imp.id(79387910442923002)
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Simple Object Access Protocol (SOAP) is a World Wide Web Consortium (W3C) standard protocol for defining the format',
'   for Web service requests.</p>',
'<p>SOAP messages are sent back and forth between the service provider and service user in SOAP envelopes. SOAP envelopes',
'   contain a request for some action and the result of that action and are formatted in XML, making them easy to decode.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'Region generated 31-JUL-2002 20:44:47'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(741450571308373035)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>2
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_row_template=>wwv_flow_imp.id(79387910442923002)
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(741451197014373036)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(741450571308373035)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P199_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(741466512945434197)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(741450571308373035)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(741450915625373035)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(741450571308373035)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(741458121571373069)
,p_branch_name=>'Go To Page 170'
,p_branch_action=>'170'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(741458571111373072)
,p_branch_action=>'870'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(741466512945434197)
,p_branch_sequence=>1
,p_branch_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(741448406937373016)
,p_name=>'P199_RESPONSE_COLLECTION'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(741449156151373031)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Store Response in Collection'
,p_source=>'STATIC_PARM_03'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the name of a collection to store the Web service response. The response will be stored in the CLOB001 column of the collection entered here.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(741449332749373034)
,p_name=>'F4000_P199_ID'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_imp.id(741449156151373031)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(741449525566373034)
,p_name=>'F4000_P199_FLOW_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(741449156151373031)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'This attribute identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_item_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(741450007131373034)
,p_name=>'F4000_P199_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(741449156151373031)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>The name for this Web service within the context of the Builder. This name is only used within the App Builder tool.</p>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(741451700842373037)
,p_name=>'F4000_P199_URL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(741449156151373031)
,p_use_cache_before_default=>'NO'
,p_prompt=>'URL'
,p_source=>'URL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify the URL used to post the SOAP request over HTTP. This corresponds to the soap:address location of a service port',
'   in WSDL. You may reference session state in the URL by using <code>&amp;ITEM_NAME.</code> convention.</p>',
'<p>For example:</p>',
'<code>http://s3.example.com/&amp;P2_BUCKET.</code>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_item_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(741452228277373038)
,p_name=>'F4000_P199_ACTION'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(741449156151373031)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Action'
,p_source=>'ACTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Indicates the intent of the SOAP HTTP request. The value is a URI identifying the intent.</p> <p>SOAP places no restrictions on the format or specificity of the URI or that it is resolvable.</p>',
'',
'',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_item_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(741452799822373039)
,p_name=>'F4000_P199_PROXY_OVERRIDE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(741449156151373031)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Proxy'
,p_source=>'PROXY_OVERRIDE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This overrides the system defined HTTP proxy for your request. The proxy may include an optional TCP/IP port number at which the proxy server listens.  Use the following syntax:</p>',
'<pre>[http://]host[:port][/]</pre>',
'<p>For example:</p>',
'<pre>www-proxy.example.com</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_item_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(741453221339373039)
,p_name=>'P199_SOAP_VERSION'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(741449156151373031)
,p_use_cache_before_default=>'NO'
,p_item_default=>'1.1'
,p_prompt=>'SOAP Version:'
,p_source=>'SOAP_VERSION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WS_SOAP_VERSION'
,p_lov=>'.'||wwv_flow_imp.id(439439004288980949)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Choose the version of the SOAP specification that this Web service uses, either 1.1 or 1.2.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(741453709212373039)
,p_name=>'P199_BASIC_AUTH'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(741449156151373031)
,p_item_default=>'N'
,p_prompt=>'Basic Authentication:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(84259319526460470)||'.'
,p_read_only_when=>'F4000_P199_ID'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose whether this Web service requires basic authentication. Basic authentication credentials are sent as part of the HTTP request in clear text. Web services that employ basic authentication usually also use the HTTPS (SSL) protocol since the user'
||'name and password are sent in clear text.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(741454415858373040)
,p_name=>'F4000_P199_SOAP_ENVELOPE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(741449156151373031)
,p_use_cache_before_default=>'NO'
,p_prompt=>'SOAP Envelope'
,p_source=>'SOAP_ENVELOPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>12
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify the SOAP envelope to be used for the SOAP request to the Web service. This envelope can contain item substitutions of the form #ITEM_NAME#.</p>',
'<p>For example:</p>',
'<pre>&lt;SOAP-ENV:Envelope',
'xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"',
'',
'  xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance"',
'',
'  xmlns:xsd="http://www.w3.org/1999/XMLSchema"',
'',
'  SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/">',
'',
'  &lt;SOAP-ENV:Body>&lt;LocalTimeByZipCode xmlns="http://www.alethea.net/webservices/">&lt;ZipCode xsi:type="xsd:string">#Fxxxx_Pyyy_ZIP_CODE#&lt;/ZipCode>&lt;/LocalTimeByZipCode></SOAP-ENV:Body>&lt;/SOAP-ENV:Envelope>',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_item_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(741455914202373045)
,p_computation_sequence=>10
,p_computation_item=>'P199_BASIC_AUTH'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select null',
'             from wwv_flow_ws_operations',
'            where name = ''BASIC_AUTH''',
'              and ws_id = :F4000_P199_ID ) loop',
'  return ''Y'';',
'  exit;',
'end loop;',
'',
'return ''N'';'))
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(741456190836373050)
,p_validation_name=>'F4000_P199_NAME Not Null'
,p_validation_sequence=>1
,p_validation=>'F4000_P199_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Name must be specified.'
,p_validation_condition=>'CREATE:SAVE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(741450007131373034)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 31-JUL-2002 21:28'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(741456335131373054)
,p_validation_name=>'URL Not Null'
,p_validation_sequence=>10
,p_validation=>'F4000_P199_URL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'The URL of the Web Service must be specified.'
,p_validation_condition=>'CREATE:SAVE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(741451700842373037)
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(741456527646373055)
,p_validation_name=>'SOAP Envelope not null'
,p_validation_sequence=>10
,p_validation=>'F4000_P199_SOAP_ENVELOPE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'The SOAP Envelope associated with your Web Service must be specified.'
,p_validation_condition=>'CREATE:SAVE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(741454415858373040)
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(741457687291373057)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(741450915625373035)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(741457946227373066)
,p_event_id=>wwv_flow_imp.id(741457687291373057)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(741456664292373055)
,p_process_sequence=>1
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_SHARED_WEB_SERVICES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_SHARED_WEB_SERVICES'
,p_attribute_03=>'F4000_P199_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error fetching row.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>741456664292373055
,p_process_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(741456884280373055)
,p_process_sequence=>1
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_SHARED_WEB_SERVICES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_SHARED_WEB_SERVICES'
,p_attribute_03=>'F4000_P199_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_09=>'F4000_P199_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error updating web service definition.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Web service definition updated.'
,p_internal_uid=>741456884280373055
,p_process_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(741457017889373055)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Preparse item substitutions'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_items clob;',
'begin',
'    l_items := wwv_flow_web_services.parse( :F4000_P199_SOAP_ENVELOPE );',
'',
'    update wwv_flow_shared_web_services ',
'       set flow_items_comma_delimited = l_items',
'     where id = :F4000_P199_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE,SAVE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_internal_uid=>741457017889373055
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(741457291525373056)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create basic auth operation'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_operations_id number;',
'  l_id number;',
'begin',
'',
'  l_operations_id := wwv_flow_id.next_val;',
'',
'  insert into wwv_flow_ws_operations (id, ws_id, name)     ',
'  values (l_operations_id, :F4000_P199_ID, ''BASIC_AUTH'');',
'                                                         ',
'  l_id := wwv_flow_id.next_val;                            ',
'                                                         ',
'  insert into wwv_flow_ws_parameters                       ',
'       (id, ws_opers_id, name, input_or_output)          ',
'  values (l_id, l_operations_id, ''username'', ''A'');         ',
'                                                         ',
'  l_id := wwv_flow_id.next_val;                            ',
'                                                         ',
'  insert into wwv_flow_ws_parameters                       ',
'       (id, ws_opers_id, name, input_or_output)          ',
'  values (l_id, l_operations_id, ''password'', ''A'');',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(741451197014373036)
,p_process_when=>':P199_BASIC_AUTH = ''Y'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>741457291525373056
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(741457447562373056)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE,SAVE,DELETE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>741457447562373056
);
end;
/
prompt --application/pages/page_00200
begin
wwv_flow_imp_page.create_page(
 p_id=>200
,p_name=>'Tab Utilization'
,p_alias=>'TAB-UTILIZATION'
,p_step_title=>'Tab Utilization'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213240607818867991)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4178830473922312)
,p_plug_name=>'Tab Utilization'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>This report lists the standard tabs used in the current application.</p>'
,p_plug_query_num_rows=>1500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_no_data_found=>'<font class="fielddata">No Utilization Found.</font>'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_break_cols=>'1'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(4180128748923137)
,p_name=>'Standard Tab Utilization'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q varchar2(32767) := null;',
'  l_not_referenced  varchar2(200);',
'begin',
'',
'select wwv_flow_lang.system_message(''F4000.NOT_REFERENCED'')',
'  into l_not_referenced',
'  from dual;',
'',
'  q:= ''select /* APEX 4000P200a */ s.tab_set, '';',
'  q:=q||''decode((select count(*) from wwv_flow_steps pg  '';',
'  q:=q||''where pg.tab_set = s.tab_set '';',
'  q:=q||''and pg.flow_id = :fb_flow_id and pg.security_group_id = :flow_security_group_id),0,''''''||l_not_referenced||'''''', '';',
'  q:=q||''(select count(*) from wwv_flow_steps pg  '';',
'  q:=q||''where pg.tab_set = s.tab_set '';',
'  q:=q||''and pg.flow_id = :fb_flow_id '';',
'  q:=q||''and pg.security_group_id = :flow_security_group_id)) u, '';       ',
'  q:=q||''htf.anchor(''''f?p=4000:4305:''''||:flow_session||''''::::F4000_P4305_ID:''''||s.id,wwv_flow_escape.html(s.tab_name)) name, '';',
'  q:=q||''wwv_flow_escape.html(s.tab_text), '';',
'  q:=q||''htf.anchor(''''f?p=4000:4500:''''||:flow_session||''''::NO::FB_FLOW_PAGE_ID:''''||s.tab_step,s.tab_step) step, '';',
'  q:=q||''tab_parent_tabset '';',
'  q:=q||''from wwv_flow_tabs s '';',
'  q:=q||''where s.flow_id = :fb_flow_id '';',
'  q:=q||''and s.security_group_id = :flow_security_group_id ''; ',
'  q:=q||''order by 1,2,3 '';',
'',
'  return q;',
'end;'))
,p_translate_title=>'N'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_plug_query_max_columns=>8
,p_query_num_rows=>5000
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'1:2'
,p_query_no_data_found=>'No Tabs used in the Application.'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48870004879772673)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_column_heading=>'Tab Set'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48870122525772673)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>2
,p_column_heading=>'Page References'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48870201528772673)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>3
,p_column_heading=>'Tab Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48870319980772673)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>4
,p_column_heading=>'Tab Text'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48870405543772673)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>5
,p_column_heading=>'Tab Page'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48870518648772673)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>6
,p_column_heading=>'Parent Tab Set'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48870604441772673)
,p_query_column_id=>7
,p_column_alias=>'COL07'
,p_column_display_sequence=>7
,p_column_heading=>'COL07'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48870710851772673)
,p_query_column_id=>8
,p_column_alias=>'COL08'
,p_column_display_sequence=>8
,p_column_heading=>'COL08'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4181922709925926)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(5297709875)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4184507280930534)
,p_branch_action=>'9000'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_00201
begin
wwv_flow_imp_page.create_page(
 p_id=>201
,p_name=>'Page History'
,p_alias=>'PHIST'
,p_step_title=>'Page History'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7124527812558841)
,p_plug_name=>'top bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>140
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(169482631222656580)
,p_plug_name=>'Page History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>150
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'   decode(t.page_id,',
'      null,s.a,',
'     p.a) component_type,',
'   t.flow_user,',
'   t.flow_id,',
'   t.page_id p, ',
'   t.audit_date d, ',
'   t.audit_date last_updated,',
'  initcap(',
'  replace(replace(replace(replace(replace(replace(replace(',
'  replace(replace(replace(replace(replace(t.flow_table,',
'     ''LIST_ITEMS'',''List Entry''),',
'     ''WWV_FLOWS'',''Application''),',
'     ''PAGE_DA_ACTIONS'', ''Dynamic Action Action''),',
'     ''PAGE_DA_EVENTS'', ''Dynamic Action Event''),',
'     ''WWV_FLOW_'',null),',
'     ''_'','' ''),',
'     ''FLOW'',''Application''),',
'     ''STEP'',''Page''),',
'     ''PLUG'',''Region''),',
'     ''OPTION'',''Entry''),',
'     ''MENU'',''Breadcrumb''),',
'     ''$'',null)',
'  ) flow_table, ',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) c,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name  ',
'from   wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u,',
'  (select wwv_flow_lang.system_message(''PAGE'') a from dual) p,',
'  (select wwv_flow_lang.system_message(''SHARED'') a from dual) s',
'where  t.security_group_id = :flow_security_group_id and',
'       t.flow_id = :fb_flow_id and ',
'(',
'       t.page_id = :fb_flow_page_id or ',
'       (:P201_INCLUDE_SC = ''Y'' and',
'        flow_table_pk in',
'(',
'',
'select distinct t.id',
'from wwv_flow_page_plugs p,',
'     WWV_FLOW_PAGE_PLUG_TEMPLATES t',
'where p.flow_id = :fb_flow_id and ',
'      p.page_id = :fb_flow_page_id and',
'      p.plug_template = t.id (+) and',
'      t.PAGE_PLUG_TEMPLATE_NAME is not null',
'union all',
'select distinct p.id',
'from wwv_flow_templates p',
'where p.flow_id = :fb_flow_id and ',
'      id = ( select wwv_flow_page_dev.get_template_id(:FB_FLOW_ID, :FB_FLOW_PAGE_ID) from dual )',
'union all',
'select distinct f.id',
'from wwv_flow_field_templates f,',
'     wwv_flow_step_items i',
'where ',
'      i.flow_id = :fb_flow_id and',
'     i.ITEM_FIELD_TEMPLATE = f.id(+) and',
'     i.flow_step_id = :fb_flow_page_id and',
'     template_name is not null',
'union all',
'select t.id',
'from WWV_FLOW_POPUP_LOV_TEMPLATE t',
'where flow_id = :FB_FLOW_ID ',
'and theme_id = (select theme_id from wwv_flows where id = :FB_FLOW_ID)',
'and exists (select 1',
'              from wwv_flow_step_items i',
'              where ',
'                    i.flow_id = :FB_FLOW_ID and',
'                    i.flow_step_id = :FB_FLOW_PAGE_ID and',
'                    display_as = ''NATIVE_POPUP_LOV'')',
'union all',
'select t.id    ',
'from wwv_flow_button_templates t,',
'     wwv_flow_step_buttons b',
'where b.flow_id = :FB_FLOW_ID',
'and b.flow_step_id = :FB_FLOW_PAGE_ID',
'and t.id = b.button_template_id',
'and t.security_group_id = b.security_group_id',
'union all',
'select t.id    ',
'from  wwv_flow_cal_templates t, ',
'      wwv_flow_cals c, ',
'      wwv_flow_page_plugs r',
'where t.flow_id = :FB_FLOW_ID and',
'      c.flow_id = :FB_FLOW_ID and',
'      c.plug_id = r.id and ',
'      r.page_id = :FB_FLOW_PAGE_ID and',
'      r.flow_Id = :FB_FLOW_ID and',
'      t.id      = c.template_id',
'union all',
'select t.id    ',
'from wwv_flow_menu_templates t, wwv_flow_page_plugs r',
'where t.flow_id = :FB_FLOW_ID and',
'      r.flow_id = :FB_FLOW_ID and',
'      r.page_id = :FB_FLOW_PAGE_ID and',
'      r.menu_template_id = t.id',
'union all',
'select ro.id',
'from wwv_flow_row_templates ro,',
'     wwv_flow_page_plugs r',
'where ro.flow_id = :FB_FLOW_ID and',
'      r.flow_id = :FB_FLOW_ID and',
'      r.page_id = :FB_FLOW_PAGE_ID and',
'      r.PLUG_QUERY_ROW_TEMPLATE = ro.id and',
'      r.plug_source_type in (''NATIVE_SQL_REPORT'', ''NATIVE_TABFORM'')',
'union all ',
'select t.id',
'from WWV_FLOW_LIST_TEMPLATES t, ',
'     wwv_flow_page_plugs r',
'where t.flow_id = :FB_FLOW_ID and',
'      r.flow_id = :FB_FLOW_ID and',
'      r.list_template_id = t.id and',
'      r.page_id = :FB_FLOW_PAGE_ID ',
'union all',
'select l.id',
'  from wwv_flow_lists l,',
'       wwv_flow_page_plugs p',
' where p.list_id = l.id',
'   and p.flow_id = :FB_FLOW_ID ',
'   and p.page_id = :FB_FLOW_PAGE_ID',
'union all',
'select o.id',
'from   WWV_FLOW_MENU_OPTIONS o, wwv_flow_menus m',
'where  m.flow_id = :FB_FLOW_ID and ',
'       o.page_id = :FB_FLOW_PAGE_ID and',
'       m.id = o.menu_id',
'union all',
'select id l',
'from   WWV_FLOW_LISTS_OF_VALUES$ l',
'where  flow_id = :FB_FLOW_ID and',
'       lov_name in ( select distinct named_lov',
'          from wwv_flow_step_items i',
'         where flow_id = :FB_FLOW_ID and ',
'               flow_step_id = :FB_FLOW_PAGE_ID and',
'               named_lov is not null ) ',
')',
')',
')',
''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(169482721810656581)
,p_name=>'Recent Changes'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(169482930972656589)
,p_db_column_name=>'FLOW_USER'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(169483015925656590)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(169483131870656591)
,p_db_column_name=>'P'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(169483213300656591)
,p_db_column_name=>'D'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Audit Date'
,p_column_type=>'DATE'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(169483507157656592)
,p_db_column_name=>'C'
,p_display_order=>6
,p_column_identifier=>'G'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(169483332551656592)
,p_db_column_name=>'LAST_UPDATED'
,p_display_order=>7
,p_column_identifier=>'E'
,p_column_label=>'Last Updated'
,p_column_type=>'DATE'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(169483421312656592)
,p_db_column_name=>'FLOW_TABLE'
,p_display_order=>8
,p_column_identifier=>'F'
,p_column_label=>'Component'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(169546809483832616)
,p_db_column_name=>'COMPONENT_TYPE'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Component Type'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(169578010269239638)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Component Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(250971123812404428)
,p_db_column_name=>'SCN'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(250971210994404432)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Audit Comment'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(250971308049404433)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Component Key'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(169484418827659303)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1286830765536643'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'D:C:FLOW_USER:FLOW_TABLE:COMPONENT_NAME:P:COMPONENT_TYPE'
,p_sort_column_1=>'D'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(251184621092708260)
,p_plug_name=>'Page History'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>This page displays recent modifications made to all the elements of the current page.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(257176801354807079)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(7124527812558841)
,p_button_name=>'P201_SET'
,p_button_static_id=>'P201_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Set'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(250973106113446610)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(7124527812558841)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:201:&SESSION.::&DEBUG.:201,RIR::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(169578405037285426)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(7124527812558841)
,p_button_name=>'APPLICATION_HISTORY'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'Application History'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=4350:42:&SESSION.'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(168251008194220440)
,p_branch_action=>'201'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(253851919909207001)
,p_name=>'P201_INCLUDE_SC'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(7124527812558841)
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'INCLUDE_SHARED_COMPONENTS_Y'
,p_lov=>'.'||wwv_flow_imp.id(417652505855073319)||'.'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(294769106665459666)
,p_name=>'P201_PAGE_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(7124527812558841)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Page Name:'
,p_source=>'select name from wwv_flow_steps where flow_id = :fb_flow_id and id = :fb_flow_page_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'<p>Identifies the name of the currently selected page.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(64312202468720232)
,p_name=>'New'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(250973106113446610)
,p_condition_element=>'P201_PAGE_NAME'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'sdf'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(64312332057720233)
,p_event_id=>wwv_flow_imp.id(64312202468720232)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(7124527812558841)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(64312456748720234)
,p_event_id=>wwv_flow_imp.id(64312202468720232)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P201_PAGE_NAME'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(127729823028905539)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'determine lock status'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'wwv_flow_region_layout.set_lock_status (p_flow=>:fb_flow_id, p_page=>:fb_flow_page_id);',
'exception when others then null;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>127729823028905539
);
end;
/
prompt --application/pages/page_00202
begin
wwv_flow_imp_page.create_page(
 p_id=>202
,p_name=>'Trees Utilization'
,p_alias=>'TREES-UTILIZATION'
,p_step_title=>'Tree Utilization'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213443923391496926)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tree.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4873732637361578)
,p_plug_name=>'Tree Utilization'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>This page identifies Trees used in the current application.</p>'
,p_plug_query_num_rows=>1500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_no_data_found=>'<font class="fielddata">No Utilization Found.</font>'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_break_cols=>'1'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4891407164403819)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(4884503079390537)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(48520116378288694)
,p_plug_name=>'Utilization'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P202a */ t.id,',
'       t.tree_name name, ',
'       (select count(distinct r.page_id) ',
'          from wwv_flow_page_plugs r ',
'         where r.flow_id = :fb_flow_id ',
'           and r.security_group_id = :flow_security_group_id ',
'           and r.plug_source_type = ''NATIVE_TREE'' ',
'           and sys.dbms_lob.instr(r.plug_source,t.id) > 0) util_cnt',
'  from wwv_flow_trees t ',
' where flow_id = :fb_flow_id ',
'   and security_group_id = :flow_security_group_id ',
' order by 1,2'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(48520212165288694)
,p_name=>'Utilization'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(48520424295288702)
,p_db_column_name=>'NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Name'
,p_column_link=>'f?p=&APP_ID.:27:&SESSION.::&DEBUG.::F4000_P27_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(48520616256288705)
,p_db_column_name=>'UTIL_CNT'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Page References'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(48521225987297309)
,p_db_column_name=>'ID'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(48520730012289018)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1286931898536643'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'NAME:TREE_TYPE:UTIL_CNT:ID'
,p_sort_column_1=>'NAME'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(188983424798851732)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(48520116378288694)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:202:&SESSION.::&DEBUG.:202,RIR::'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(48521730059317406)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'202'
,p_computation_error_message=>'Unable to compute item value.'
);
end;
/
prompt --application/pages/page_00203
begin
wwv_flow_imp_page.create_page(
 p_id=>203
,p_name=>'Build Option Utilization'
,p_alias=>'BUILD-OPTION-UTILIZATION'
,p_step_title=>'Build Option Utilization'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213481614528579568)
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_build_options.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(4974829597177484)
,p_name=>'Build Option Utilization'
,p_template=>wwv_flow_imp.id(646287526247383209)
,p_display_sequence=>150
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>'return wwv_flow_f4000_util.get_build_opt_util;'
,p_display_when_condition=>'F4000_P203_BUILDOPT'
,p_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_plug_query_max_columns=>2
,p_query_num_rows=>5000
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'1'
,p_query_no_data_found=>'<font class="fielddata">No utilization found.</font>'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48724125733771805)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_column_heading=>'Point'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48724213710771805)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>2
,p_column_heading=>'Description'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47914229316595621)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>95
,p_list_id=>wwv_flow_imp.id(47909111131552473)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Build Options'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(94765120703025917)
,p_plug_name=>'Build Option Selector'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>140
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5065412311021125)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(94765120703025917)
,p_button_name=>'F4000_P203_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Go'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(5094401072056730)
,p_branch_action=>'203'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>30
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'GO'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5063616840019071)
,p_name=>'F4000_P203_BUILDOPT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(94765120703025917)
,p_prompt=>'Build Option'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PATCHES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(patch_name) pn, id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'', wwv_flow_escape.html(patch_name))||',
'''} '' pn,0-id id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by pn'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Build Option -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select a build option for this component.</p>',
'<p>Build options are predefined settings that determine whether or not  components within an application are enabled.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(157083825594119867)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'203'
,p_compute_when_type=>'%null%'
);
end;
/
prompt --application/pages/page_00204
begin
wwv_flow_imp_page.create_page(
 p_id=>204
,p_name=>'Button Templates'
,p_alias=>'BUTTON-TEMPLATES'
,p_step_title=>'Edit Button Template'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'EXISTS'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_button_templates t, wwv_flow_themes th',
' where t.id                 = :F4000_P204_ID',
'   and t.flow_id            = th.flow_id',
'   and t.theme_id           = th.theme_id',
'   and t.security_group_id  = :WORKSPACE_ID',
'   and th.security_group_id = t.security_group_id',
'   and t.reference_id      is not null',
'   and th.reference_id     is not null '))
,p_help_text=>'ui_templt_but.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1405937555644001)
,p_plug_name=>'Landmark for Displayed Regions'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_landmark_type=>'region'
,p_landmark_label=>'Displayed Regions'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(13622079618684477)
,p_plug_name=>'Template Options'
,p_parent_plug_id=>wwv_flow_imp.id(1405937555644001)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9043595803647121)
,p_plug_name=>'Template Options'
,p_parent_plug_id=>wwv_flow_imp.id(13622079618684477)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.template_types,',
'       o.id,',
'       o.display_name,',
'       o.name,',
'       o.display_sequence,',
'       o.css_classes,',
'       o.flow_id,',
'       o.theme_id,',
'       o.help_text,',
'       o.group_id,',
'       o.button_template_id,',
'       ( select g.display_sequence from wwv_flow_template_opt_groups g where g.id = o.group_id ) group_display_sequence,',
'       ( select g.display_name     from wwv_flow_template_opt_groups g where g.id = o.group_id ) group_display_name',
'  from wwv_flow_template_options o',
' where o.flow_id            = :FB_FLOW_ID',
'   and o.theme_id           = :P204_THEME',
'   and o.security_group_id  = :WORKSPACE_ID',
'   and o.template_types     = ''BUTTON''',
'   and o.button_template_id = :F4000_P204_ID',
''))
,p_plug_source_type=>'NATIVE_IG'
,p_ajax_items_to_submit=>'P204_DEFAULT_TEMPLATE_OPTIONS,P204_THEME'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Template Options'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(9044374337647129)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>30
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(9044460486647130)
,p_name=>'DISPLAY_NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DISPLAY_NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>100
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_item_width=>30
,p_is_required=>true
,p_max_length=>30
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_static_id=>'COLUMN_DISPLAY_NAME'
,p_use_as_row_header=>true
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(9044509771647131)
,p_name=>'DISPLAY_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DISPLAY_SEQUENCE'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>'Sequence'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>120
,p_value_alignment=>'RIGHT'
,p_attribute_03=>'left'
,p_attribute_04=>'decimal'
,p_item_width=>5
,p_is_required=>true
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'1'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(9044625158647132)
,p_name=>'CSS_CLASSES'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'CSS_CLASSES'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Classes'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>130
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_max_length=>255
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(9044976794647135)
,p_name=>'APEX$ROW_ACTION'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>20
,p_use_as_row_header=>false
,p_display_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(9045026271647136)
,p_name=>'APEX$ROW_SELECTOR'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_use_as_row_header=>false
,p_display_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(9046060780647146)
,p_name=>'TEMPLATE_TYPES'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'TEMPLATE_TYPES'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>60
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'BUTTON'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(9046122296647147)
,p_name=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Identifier'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>110
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_attribute_06=>'UPPER'
,p_item_width=>30
,p_is_required=>true
,p_max_length=>30
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(9686813385802601)
,p_name=>'HELP_TEXT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'HELP_TEXT'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Help Text'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>150
,p_value_alignment=>'LEFT'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(9686915188802602)
,p_name=>'GROUP_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'GROUP_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Group'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>140
,p_value_alignment=>'LEFT'
,p_is_required=>false
,p_lov_type=>'SQL_QUERY'
,p_lov_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name,',
'       id',
'  from wwv_flow_template_opt_groups',
' where template_types = :TEMPLATE_TYPES',
'   and flow_id        = :FB_FLOW_ID',
'   and theme_id       = :P204_THEME'))
,p_lov_display_extra=>true
,p_lov_display_null=>true
,p_lov_cascade_parent_items=>'TEMPLATE_TYPES'
,p_ajax_items_to_submit=>'P204_THEME'
,p_ajax_optimize_refresh=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>false
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(9687010816802603)
,p_name=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FLOW_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>40
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'FB_FLOW_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(9687129980802604)
,p_name=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'THEME_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>50
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'P204_THEME'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(9687357414802606)
,p_name=>'BUTTON_TEMPLATE_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'BUTTON_TEMPLATE_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>70
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'F4000_P204_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(13086795122499024)
,p_name=>'GROUP_DISPLAY_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'GROUP_DISPLAY_SEQUENCE'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Group Sequence'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>80
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(13086895342499025)
,p_name=>'GROUP_DISPLAY_NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'GROUP_DISPLAY_NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Group Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>90
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>true
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(9044266540647128)
,p_internal_uid=>9044266540647128
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_add_row_if_empty=>false
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>true
,p_no_data_found_message=>'No template options.'
,p_show_toolbar=>true
,p_toolbar_buttons=>'SEARCH_FIELD:SAVE'
,p_add_button_label=>'Add Template Option'
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>false
,p_define_chart_view=>false
,p_enable_download=>false
,p_download_formats=>null
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function(config) {',
'    config.defaultGridViewOptions = {',
'        reorderColumns: false',
'    }',
'    return config;',
'}'))
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(9480233238785954)
,p_interactive_grid_id=>wwv_flow_imp.id(9044266540647128)
,p_static_id=>'94803'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(9480419256785955)
,p_report_id=>wwv_flow_imp.id(9480233238785954)
,p_view_type=>'GRID'
,p_stretch_columns=>true
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3296464020268)
,p_view_id=>wwv_flow_imp.id(9480419256785955)
,p_display_seq=>11
,p_column_id=>wwv_flow_imp.id(9687010816802603)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(4336271020274)
,p_view_id=>wwv_flow_imp.id(9480419256785955)
,p_display_seq=>12
,p_column_id=>wwv_flow_imp.id(9687129980802604)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(9480970478785961)
,p_view_id=>wwv_flow_imp.id(9480419256785955)
,p_display_seq=>2
,p_column_id=>wwv_flow_imp.id(9044374337647129)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(9481875438785968)
,p_view_id=>wwv_flow_imp.id(9480419256785955)
,p_display_seq=>4
,p_column_id=>wwv_flow_imp.id(9044460486647130)
,p_is_visible=>true
,p_is_frozen=>false
,p_sort_order=>4
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(9482757975785972)
,p_view_id=>wwv_flow_imp.id(9480419256785955)
,p_display_seq=>6
,p_column_id=>wwv_flow_imp.id(9044509771647131)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>105
,p_sort_order=>3
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(9483603548785977)
,p_view_id=>wwv_flow_imp.id(9480419256785955)
,p_display_seq=>7
,p_column_id=>wwv_flow_imp.id(9044625158647132)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(9486327159785986)
,p_view_id=>wwv_flow_imp.id(9480419256785955)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(9044976794647135)
,p_is_visible=>true
,p_is_frozen=>true
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(9692838629804986)
,p_view_id=>wwv_flow_imp.id(9480419256785955)
,p_display_seq=>10
,p_column_id=>wwv_flow_imp.id(9046060780647146)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(9693747340804992)
,p_view_id=>wwv_flow_imp.id(9480419256785955)
,p_display_seq=>5
,p_column_id=>wwv_flow_imp.id(9046122296647147)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(9697386844805004)
,p_view_id=>wwv_flow_imp.id(9480419256785955)
,p_display_seq=>8
,p_column_id=>wwv_flow_imp.id(9686813385802601)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(9698283613805007)
,p_view_id=>wwv_flow_imp.id(9480419256785955)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(9686915188802602)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(10274979697195288)
,p_view_id=>wwv_flow_imp.id(9480419256785955)
,p_display_seq=>13
,p_column_id=>wwv_flow_imp.id(9687357414802606)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(23623329771890446)
,p_view_id=>wwv_flow_imp.id(9480419256785955)
,p_display_seq=>14
,p_column_id=>wwv_flow_imp.id(13086795122499024)
,p_is_visible=>false
,p_is_frozen=>false
,p_sort_order=>1
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(23624126300890451)
,p_view_id=>wwv_flow_imp.id(9480419256785955)
,p_display_seq=>15
,p_column_id=>wwv_flow_imp.id(13086895342499025)
,p_is_visible=>false
,p_is_frozen=>false
,p_sort_order=>2
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(696556527150490874)
,p_name=>'Global Template Options'
,p_parent_plug_id=>wwv_flow_imp.id(13622079618684477)
,p_template=>wwv_flow_imp.id(689970285456172024)
,p_display_sequence=>230
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  o.id, ',
'  o.display_name,',
'  o.display_sequence, ',
'  o.css_classes, ',
'  g.display_name group_name',
'  from wwv_flow_template_options o,',
'       wwv_flow_template_opt_groups g',
' where o.flow_id              = :FB_FLOW_ID',
'   and o.virtual_template_id is null',
'   and o.template_types       = ''BUTTON''',
'   and o.BUTTON_TEMPLATE_ID  is null',
'   and o.security_group_id    = :WORKSPACE_ID',
'   and o.theme_id             = :P204_THEME',
'   and g.id (+)               = o.group_id',
' order by',
'       g.display_sequence,',
'       g.display_name,',
'       o.display_sequence,',
'       o.display_name'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P204_DEFAULT_TEMPLATE_OPTIONS,P204_THEME'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>200
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No template options defined.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8020360664022378)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8020784970022378)
,p_query_column_id=>2
,p_column_alias=>'DISPLAY_NAME'
,p_column_display_sequence=>21
,p_column_heading=>'Name'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8021174558022378)
,p_query_column_id=>3
,p_column_alias=>'DISPLAY_SEQUENCE'
,p_column_display_sequence=>31
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8021537111022379)
,p_query_column_id=>4
,p_column_alias=>'CSS_CLASSES'
,p_column_display_sequence=>41
,p_column_heading=>'Classes'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8021951075022379)
,p_query_column_id=>5
,p_column_alias=>'GROUP_NAME'
,p_column_display_sequence=>11
,p_column_heading=>'Group'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(33346500180901136)
,p_plug_name=>'Subscription'
,p_region_name=>'SUBSCRIPTION'
,p_parent_plug_id=>wwv_flow_imp.id(1405937555644001)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P204_THEME_IS_SUBSCRIBED'
,p_plug_display_when_cond2=>'NONE'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'WWV_FLOW_BUTTON_TEMPLATES',
  'attribute_02', 'TEMPLATE_NAME',
  'attribute_03', 'F4000_P204_ID',
  'attribute_04', 'F4000_P204_REFERENCE_ID',
  'attribute_05', 'SUBSCRIBE_TEMPLATE')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(77939612306912704)
,p_plug_name=>'Name'
,p_region_name=>'N'
,p_parent_plug_id=>wwv_flow_imp.id(1405937555644001)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'Region generated 17-JUL-2002 17:42:24'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(77962514350090426)
,p_plug_name=>'Comments'
,p_region_name=>'C'
,p_parent_plug_id=>wwv_flow_imp.id(1405937555644001)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(77971829434098596)
,p_plug_name=>'Definition'
,p_region_name=>'D'
,p_parent_plug_id=>wwv_flow_imp.id(1405937555644001)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(166069024164863346)
,p_plug_name=>'Substitution Strings'
,p_region_name=>'SS'
,p_parent_plug_id=>wwv_flow_imp.id(1405937555644001)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_templates_util.button_template_sub_str (',
'    p_template_id => :F4000_P204_ID);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'Substitution strings are used within sub templates to reference component values.  This report details substitution string usage for this template.'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(932806706613193711)
,p_plug_name=>'Subscription'
,p_parent_plug_id=>wwv_flow_imp.id(1405937555644001)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P204_THEME_IS_SUBSCRIBED = ''BOTH'' then',
'     sys.htp.p(wwv_flow_lang.system_message(''TEMPLATE_SUBSCRIPTION.THEME_AND_TEMPLATE_SUBSCRIBED''));',
'else',
'     sys.htp.p(wwv_flow_lang.system_message(''TEMPLATE_SUBSCRIPTION.THEME_SUBSCRIBED''));',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P204_THEME_IS_SUBSCRIBED'
,p_plug_display_when_cond2=>'NONE'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'N',
  'attribute_02', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46185929138892976)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(77963812193091410)
,p_plug_name=>'Edit Button Template'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--accessibleTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>90
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_landmark_label=>'Button Template Actions'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(77977209377107934)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use this page to edit a button template.</p>',
'<p>Button templates enable developers to customize the look and feel of a button. To build a button, you can use multiple images or HTML tags. Using button templates is optional.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(117330718143414549)
,p_plug_name=>'Hidden'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(617469813702046883)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_imp.id(29434107863295859)
,p_plug_display_sequence=>100
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from  WWV_FLOW_BUTTON_TEMPLATES',
'where id = :F4000_P204_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :F4000_P204_ID,',
'      p_component_type => ''Button Template'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(189810724719646927)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(77963812193091410)
,p_button_name=>'APPLY_CHANGES_GET_PREVIOUS_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'disabled=""'
,p_button_comment=>'javascript:htmldb_goSubmit(''GET_PREVIOUS_ID'')'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(189810618410646927)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(77963812193091410)
,p_button_name=>'APPLY_CHANGES_GET_NEXT_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Next'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'disabled=""'
,p_button_comment=>'javascript:htmldb_goSubmit(''GET_NEXT_ID'')'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(78588700805519814)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(33346500180901136)
,p_button_name=>'PUBLISH_TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Publish Template'
,p_button_position=>'COPY'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.::F4000_P149_ID,F4000_P149_PAGE_ID,F4000_P149_TEMPLATE_TYPE:&F4000_P204_ID.,&FLOW_PAGE_ID.,BUTTON_TEMPLATE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_button_templates',
' where reference_id      = :F4000_P204_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(78582924092507589)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(33346500180901136)
,p_button_name=>'COPY_TEMPLATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Refresh'
,p_button_position=>'COPY'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_button_templates',
' where id                = :F4000_P204_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and reference_id     is not null'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(77939901558912707)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(77963812193091410)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(77940205997912707)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(77963812193091410)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:502:&SESSION.::&DEBUG.::P502_ID:&F4000_P204_ID.'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P204_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(77940001894912707)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(77963812193091410)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P204_ID is null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(77940123945912707)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(77963812193091410)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P204_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8013306114022361)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_imp.id(13622079618684477)
,p_button_name=>'OPTION_GROUPS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Template Option Groups'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:81:&SESSION.::&DEBUG.:CR,81:P81_THEME_ID,P81_TEMPLATE_TYPE:&P204_THEME.,BUTTON'
,p_button_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(189815621525646981)
,p_branch_action=>'f?p=&APP_ID.:204:&SESSION.::&DEBUG.::F4000_P204_ID:&P204_ID_NEXT.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(189810618410646927)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(189816027230646985)
,p_branch_action=>'f?p=&APP_ID.:204:&SESSION.::&DEBUG.::F4000_P204_ID:&P204_ID_PREV.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(189810724719646927)
,p_branch_sequence=>20
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(78664025785671693)
,p_branch_name=>'Go To Page 204'
,p_branch_action=>'f?p=&APP_ID.:204:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(78582924092507589)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(27975409468659525)
,p_branch_action=>'f?p=&APP_ID.:204:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'F4000_P204_RETURN_TO_PAGE'
,p_branch_condition_text=>'YES'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(77941122437912714)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
,p_branch_comment=>'Generated 17-JUL-2002 17:42:24'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8013774046022364)
,p_name=>'P204_PRESET_TEMPLATE_OPTIONS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(13622079618684477)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Preset Template Options:'
,p_source=>'PRESET_TEMPLATE_OPTIONS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.TEMPALTE_OPT_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.display_name as d,',
'       o.css_classes as r,',
'       null default_template_options,',
'       null,',
'       o.help_text,',
'       g.display_name group_name,',
'       g.is_advanced advanced_group,',
'       g.null_text',
'  from wwv_flow_template_options o,',
'       wwv_flow_template_opt_groups g,',
'       wwv_flow_button_templates t',
' where o.flow_id           = :fb_flow_id',
'   and o.template_types    = ''BUTTON''',
'   and (button_template_id = :f4000_p204_id or button_template_id is null)',
'   and o.theme_id          = t.theme_id',
'   and t.id                = :f4000_p204_id',
'   and g.id            (+) = o.group_id',
' order by ',
'       g.is_advanced nulls first,',
'       g.display_sequence nulls first,',
'       g.display_name nulls first,',
'       o.display_sequence,',
'       o.display_name'))
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8014125555022368)
,p_name=>'P204_DEFAULT_TEMPLATE_OPTIONS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(13622079618684477)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Default Template Options:'
,p_source=>'DEFAULT_TEMPLATE_OPTIONS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.TEMPALTE_OPT_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.display_name as d,',
'       o.css_classes as r,',
'       t.default_template_options,',
'       null,',
'       o.help_text,',
'       g.display_name group_name',
'  from wwv_flow_template_options o,',
'       wwv_flow_template_opt_groups g,',
'       wwv_flow_button_templates t',
' where o.flow_id                = :fb_flow_id',
'   and t.id                     = o.button_template_id',
'   and o.button_template_id     = :F4000_P204_ID',
'   and g.id                 (+) = o.group_id',
'   and o.security_group_id      = :WORKSPACE_ID',
'   and g.security_group_id  (+) = o.security_group_id',
'   and t.security_group_id      = o.security_group_id',
' order by',
'       g.display_sequence nulls first,',
'       g.display_name nulls first,',
'       o.display_sequence,',
'       o.display_name'))
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8014589448022368)
,p_name=>'P204_PRESET_TMPLOPT_CHECK'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(13622079618684477)
,p_source=>'P204_PRESET_TEMPLATE_OPTIONS'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(24157228146562762)
,p_name=>'P204_TRANSLATABLE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(77939612306912704)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Translatable'
,p_source=>'TRANSLATE_THIS_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--noLabelCheckbox'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(27970213923632356)
,p_name=>'F4000_P204_RETURN_TO_PAGE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(77977209377107934)
,p_prompt=>'Stay on page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select this checkbox to stay on this page after applying changes.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'YES'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40820410352430418)
,p_name=>'P204_N'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(77963812193091410)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select TEMPLATE_NAME  ',
'  from WWV_FLOW_BUTTON_TEMPLATES ',
' where id                = :F4000_P204_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies template name'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(43573221294616569)
,p_name=>'P204_THEME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(77939612306912704)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Theme'
,p_source=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'THEME_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html( t.theme_name ) ||',
'       '' ('' || ',
'       t.theme_id || ',
'       '') <a href="'' || ',
'       apex_util.prepare_url( p_url => ''f?p=4000:'' || :THEME_NEXT_PAGE  || '':'' ||:APP_SESSION || ''::::P496_THEME:'' || t.id  ) ||',
'       ''"><img src="#IMAGE_PREFIX#f_spacer.gif" class="theme_'' ||',
'       t.theme_id ||',
'       ''"></a>'' display_value,',
'       to_char(t.id) theme_app_id',
'  from wwv_flow_themes t, wwv_flows f ',
' where t.security_group_id in (11,12) ',
'   and (t.THEME_SECURITY_GROUP_ID is null or t.THEME_SECURITY_GROUP_ID = :flow_security_group_id) ',
'   and t.flow_id in (',
'              select id from wwv_flows f',
'               where (',
'                    (:P496_SHOW = ''ALL''      and f.application_type in (''STANDARD'',''THEME'')) or ',
'                    (:P496_SHOW = ''CUSTOM''   and f.application_type = ''STANDARD'') or ',
'                    (:P496_SHOW = ''STANDARD'' and f.application_type = ''THEME'') or',
'                    (:P496_SHOW = ''LEGACY''   and f.application_type = ''THEME'')',
'               ) ',
'               and f.security_group_id in (11,12)',
'               )',
'   and (',
'          (:P496_SHOW = ''STANDARD'' and instr('',''||wwv_flow_platform.get_preference(''TOP_THEMES'')||'','','',''||t.theme_id||'','') > 0 ) or',
'          (:P496_SHOW in (''LEGACY'',''CUSTOM'' ) and instr('',''||wwv_flow_platform.get_preference(''TOP_THEMES'')||'','','',''||t.theme_id||'','') = 0 ) or',
'          (:P496_SHOW = ''ALL'')',
'        )  ',
'   and f.id       = t.flow_id',
'   and f.theme_id = t.theme_id',
' order by t.theme_id'))
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the theme to which this template is associated. A theme is a grouping of templates which together provide layout and style for an application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(43578820994644863)
,p_name=>'P204_THEME_CLASS_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(77939612306912704)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Template Class'
,p_source=>'THEME_CLASS_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'BUTTON THEME CLASS ID'
,p_lov=>'.'||wwv_flow_imp.id(43576623634636183)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Not Identified -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Identifies a specific usage for this template.</div>',
'<div class="htmldbInfoBodyP">When you switch to a new theme, all templates in one theme are assigned to corresponding templates in another theme. App Builder accomplishes this template mapping through the assignment of template class identifiers.</di'
||'v>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(77941726867912721)
,p_name=>'F4000_P204_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(117330718143414549)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 17-JUL-2002 17:42:24'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(77942316895912737)
,p_name=>'F4000_P204_TEMPLATE_NAME'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(77939612306912704)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>'TEMPLATE_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Identifies the name of the template. This attribute can be changed at any time and has no impact on the functionality of button templates.<p />',
'',
'Use the <strong>Translatable</strong> check box to indicate if the template contains text strings that require translation.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 17-JUL-2002 17:42:24'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(77942616804912740)
,p_name=>'F4000_P204_TEMPLATE'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(77971829434098596)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Normal Template'
,p_source=>'TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>40
,p_cMaxlength=>4000
,p_cHeight=>8
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Defines the button template that displays if the button type is ''Normal.'' You have the option of including standard application substitutions. For example, &amp;ITEM_NAME. values can be substituted at rendering time.</div'
||'>',
'<div class="htmldbInfoBodyP">Button templates support the following substitution strings:',
'<ul class="noIndent">',
'<li><code>#LABEL#</code> is replaced with a button label.</li>',
'<li><code>#LINK#</code> is replaced with generated JavaScript code to control the button''s behavior. Depending on a button''s action, this code could be either a call to <code>apex.submit</code> to submit the page, a <code>redirect</code> to a page, a'
||' <code>redirect</code> to some other URL supplied, execution of some custom JavaScript or <code>void(0)</code> to do nothing (where the behavior may be defined separately with Dynamic Actions). Note: The <code>#LINK#</code> prefixes the generated Jav'
||'aScript code with ''javascript:'', so should be used in an <code>href</code> attribute.</li>',
'<li><code>#JAVASCRIPT#</code> is replaced with generated JavaScript code to control the button''s behavior. Depending on a button''s Action, this code could be either a call to <code>apex.submit</code> to submit the page, a <code>redirect</code> to a p'
||'age, a <code>redirect</code> to some other URL supplied, execution of some custom JavaScript or <code>void(0)</code> to do nothing (where the behavior may be defined separately with Dynamic Actions). ',
'<p><strong>Note</strong>: The <code>#JAVASCRIPT#</code> does not prefix the generated JavaScript code with ''javascript:'', so should be used in an <code>onclick</code> attribute.</li>',
'<li><code>#ONCLICK#</code> indicates that the button has an onclick event with JavaScript code, which will be included in a script tag at the bottom of the page.</li>',
'<li><code>#BUTTON_ID#</code> is replaced with the ID for the button. This will be either the button''s Static ID if defined, or if not will be an internally generated ID in the format <pre>''B'' || [Internal Button ID]</pre></li>',
'<li><code>#BUTTON_CSS_CLASSES#</code> is replaced with the button CSS classes property from the button definition.</li>',
'<li><code>#BUTTON_ATTRIBUTES#</code> is replaced with the button attributes property from the button definition.</li>',
'<li><code>#ICON_CSS_CLASSES#</code> is replaced with the icon CSS classes property from the button definition.</li>',
'<li><code>#BUTTON_NAME#</code> is replaced with the name of the button from the button definition.</li>',
'</ul>',
'</div>',
'<div class="htmldbInfoBodyP">All substitution string must be in uppercase.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 17-JUL-2002 17:42:24'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(77942922701912740)
,p_name=>'F4000_P204_TEMPLATE_COMMENT'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(77962514350090426)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comments'
,p_source=>'TEMPLATE_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Developer comments or notes. These comments never display when the application is running.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_item_comment=>'Generated 17-JUL-2002 17:42:24'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(77943207379912743)
,p_name=>'F4000_P204_REFERENCE_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(33346500180901136)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Reference Master Template From'
,p_source=>'REFERENCE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FLOW_SUBSCRIBE_FROM_BUTTON_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''|| lower(wwv_flow_lang.system_message(''NO_TEMPLATE''))|| '' -'' d,',
'        0 r ',
'  from sys.dual union all',
'select flow_id||'' : ''||template_name||decode(theme_id,null,'''','' (''||theme_id||'')'') d, id r',
'  from wwv_flow_button_templates',
' where flow_id != nvl(:fb_flow_id,0) ',
'   and flow_id in ( select f.id',
'                      from wwv_main_apps_dev f',
'                     where security_group_id = :flow_security_group_id ',
'                       and build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') ',
'                       and exists ( select 1 ',
'                                      from wwv_flow_developers',
'                                     where userid            = :flow_user ',
'                                       and (flow_id = f.id or flow_id is null) ',
'                                       and security_group_id = :flow_security_group_id ) )',
'order by 1'))
,p_cSize=>60
,p_cMaxlength=>255
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">You may select an existing template in this workspace or another template in your workspace''s schema. By selecting an existing template, you become a subscriber to that template.</div>',
'<div class="htmldbInfoBodyP">To load a new copy of any master template, click <span class="fielddatabold">Refresh</span>.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
,p_item_comment=>'Generated 17-JUL-2002 17:42:24'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(78611122002551967)
,p_name=>'F4000_P204_REFRESH'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(33346500180901136)
,p_item_default=>'Y'
,p_prompt=>'Refresh'
,p_source=>'N'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_button_templates',
' where reference_id     is null',
'   and id                = :F4000_P204_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--noLabelCheckbox'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(189813421122646947)
,p_name=>'P204_ID_NEXT'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(117330718143414549)
,p_prompt=>'P204_ID_NEXT'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(189813832427646952)
,p_name=>'P204_ID_PREV'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(117330718143414549)
,p_prompt=>'P204_ID_PREV'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(189814223623646955)
,p_name=>'P204_ID_COUNT'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(77963812193091410)
,p_prompt=>'Button Template'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Edit a button template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(266602103340641101)
,p_name=>'P204_HOT_TEMPLATE'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(77971829434098596)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Hot Template'
,p_source=>'HOT_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>8
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Defines the button template that displays if the button type is ''Hot''. You have the option of including standard application substitutions. For example, &amp;ITEM_NAME. values can be substituted at rendering time.</div>',
'<div class="htmldbInfoBodyP">Button templates support the following substitution strings:',
'<ul class="noIndent">',
'<li><code>#LABEL#</code> is replaced with a button label.</li>',
'<li><code>#LINK#</code> is replaced with generated JavaScript code to control the button''s behavior. Depending on a button''s action, this code could be either a call to <code>apex.submit</code> to submit the page, a <code>redirect</code> to a page, a'
||' <code>redirect</code> to some other URL supplied, execution of some custom JavaScript or <code>void(0)</code> to do nothing (where the behavior may be defined separately with Dynamic Actions). Note : The <code>#LINK#</code> prefixes the generated Ja'
||'vaScript code with ''javascript:'', so should be used in an <code>href</code> attribute.</li>',
'<li><code>#JAVASCRIPT#</code> is replaced with generated JavaScript code to control the button''s behavior. Depending on a button''s Action, this code could be either a call to <code>apex.submit</code> to submit the page, a <code>redirect</code> to a p'
||'age, a <code>redirect</code> to some other URL supplied, execution of some custom JavaScript or <code>void(0)</code> to do nothing (where the behavior may be defined separately with Dynamic Actions). ',
'<p><strong>Note</strong>: The <code>#JAVASCRIPT#</code> does not prefix the generated JavaScript code with ''javascript:'', so should be used in an <code>onclick</code> attribute.</li>',
'<li><code>#ONCLICK#</code> indicates that the button has an onclick event with JavaScript code, which will be included in a script tag at the bottom of the page.</li>',
'<li><code>#BUTTON_ID#</code> is replaced with the ID for the button. This will be either the button''s Static ID if defined, or if not will be an internally generated ID in the format <pre>''B'' || [Internal Button ID]</pre></li>',
'<li><code>#BUTTON_CSS_CLASSES#</code> is replaced with the button CSS classes property from the button definition.</li>',
'<li><code>#BUTTON_ATTRIBUTES#</code> is replaced with the button attributes property from the button definition.</li>',
'<li><code>#ICON_CSS_CLASSES#</code> is replaced with the icon CSS classes property from the button definition.</li>',
'<li><code>#BUTTON_NAME#</code> is replaced with the name of the button from the button definition.</li>',
'</ul>',
'</div>',
'<div class="htmldbInfoBodyP">All substitution string must be in uppercase.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1007564634910031506)
,p_name=>'F4000_P204_INTERNAL_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(77939612306912704)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Identifier'
,p_source=>'INTERNAL_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Template identifier, this is used when switching and upgrading themes and cannot be modified.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'Generated 17-JUL-2002 17:42:24'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2104497288070349685)
,p_name=>'P204_THEME_IS_SUBSCRIBED'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(77939612306912704)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2104497860119358904)
,p_computation_sequence=>10
,p_computation_item=>'P204_THEME_IS_SUBSCRIBED'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'    l_is_subscribed varchar2(16) := ''NONE'';',
'begin',
'  ',
'    for c1 in (',
'        select t.reference_id template_ref_id, ',
'               th.reference_id theme_ref_id',
'          from wwv_flow_button_templates t, ',
'               wwv_flow_themes th',
'         where t.id                 = :F4000_P204_ID',
'           and t.flow_id            = th.flow_id',
'           and t.theme_id           = th.theme_id',
'           and t.security_group_id  = :WORKSPACE_ID',
'           and th.security_group_id = t.security_group_id',
'    ) loop',
'        if c1. theme_ref_id is not null then',
'            if c1.template_ref_id is not null then',
'                l_is_subscribed := ''BOTH'';',
'            else ',
'                l_is_subscribed := ''THEME'';',
'            end if;',
'        end if;    ',
'    end loop;',
'',
'    return l_is_subscribed;',
'',
'end;'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(78616127382564645)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P204_REFRESH'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'Unable to compute item value.'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(78620400855576959)
,p_validation_name=>'reference id not null'
,p_validation_sequence=>30
,p_validation=>'F4000_P204_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Reference ID must be specified to refresh the template.'
,p_when_button_pressed=>wwv_flow_imp.id(78582924092507589)
,p_associated_item=>wwv_flow_imp.id(77943207379912743)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(78628209241603451)
,p_validation_name=>'reference id not zero'
,p_validation_sequence=>40
,p_validation=>'F4000_P204_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_ZERO'
,p_error_message=>'Template to refresh must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(78582924092507589)
,p_associated_item=>wwv_flow_imp.id(77943207379912743)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(116570188447819658)
,p_validation_name=>'unique template name'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_button_templates ',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :WORKSPACE_ID',
'   and theme_id          = :P204_THEME',
'   and template_name     = :F4000_P204_TEMPLATE_NAME',
'   and id               != :F4000_P204_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Template name must be unique'
,p_associated_item=>wwv_flow_imp.id(77942316895912737)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(13088869341499045)
,p_tabular_form_region_id=>wwv_flow_imp.id(9043595803647121)
,p_validation_name=>'Template Options - No duplicates name'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_template_options',
' where flow_id              = :FB_FLOW_ID',
'   and theme_id             = :P204_THEME',
'   and button_template_id   = :F4000_P204_ID',
'   and security_group_id    = :WORKSPACE_ID',
'   and name                 = :NAME',
'   and template_types       = :TEMPLATE_TYPES',
'   and (:ID is null or id != :ID)'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#COLUMN_HEADER# must be unique.'
,p_validation_condition=>'F4000_P204_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_exec_cond_for_each_row=>'Y'
,p_associated_column=>'NAME'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(13089046355499047)
,p_tabular_form_region_id=>wwv_flow_imp.id(9043595803647121)
,p_validation_name=>'Template Options - No duplicates classes'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_template_options',
' where flow_id              = :FB_FLOW_ID',
'   and theme_id             = :P204_THEME',
'   and button_template_id   = :F4000_P204_ID',
'   and security_group_id    = :WORKSPACE_ID',
'   and css_classes          = :CSS_CLASSES',
'   and template_types       = :TEMPLATE_TYPES',
'   and (:ID is null or id != :ID)'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#COLUMN_HEADER# must be unique.'
,p_validation_condition=>'F4000_P204_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_exec_cond_for_each_row=>'Y'
,p_associated_column=>'CSS_CLASSES'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(397290708319396751)
,p_name=>'ENABLE PREVIOUS'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P204_ID_PREV'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(397291018780396751)
,p_event_id=>wwv_flow_imp.id(397290708319396751)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(189810724719646927)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(397291114553398584)
,p_name=>'ENABLE NEXT'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P204_ID_NEXT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(397291404568398584)
,p_event_id=>wwv_flow_imp.id(397291114553398584)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(189810618410646927)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(7429719005981845)
,p_name=>'upper case identifier'
,p_event_sequence=>30
,p_triggering_element_type=>'COLUMN'
,p_triggering_region_id=>wwv_flow_imp.id(9043595803647121)
,p_triggering_element=>'DISPLAY_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7429923343981847)
,p_event_id=>wwv_flow_imp.id(7429719005981845)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
':NAME := regexp_replace(',
'      srcstr     => :DISPLAY_NAME,',
'      pattern    => ''[^'' || wwv_flow_utilities.c_alnum || '']+'',',
'      replacestr => ''_'' );'))
,p_attribute_02=>'DISPLAY_NAME'
,p_attribute_03=>'NAME'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(9687558526802608)
,p_name=>'refresh template options on cancel'
,p_event_sequence=>40
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'body'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosecanceldialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(9687652194802609)
,p_event_id=>wwv_flow_imp.id(9687558526802608)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(9043595803647121)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(9687701870802610)
,p_event_id=>wwv_flow_imp.id(9687558526802608)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(696556527150490874)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3001607610333514)
,p_name=>'Show Publish Success Msg'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(78588700805519814)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3001764767333515)
,p_event_id=>wwv_flow_imp.id(3001607610333514)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ( this.data.successMessage ) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(77943627642912746)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_BUTTON_TEMPLATES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_BUTTON_TEMPLATES'
,p_attribute_03=>'F4000_P204_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error fetching row.'
,p_internal_uid=>77943627642912746
,p_process_comment=>'Generated 17-JUL-2002 17:42:24'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(189815222514646975)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_PAGINATION'
,p_process_name=>'Get Next or Previous Primary Key Value'
,p_attribute_02=>'WWV_FLOW_BUTTON_TEMPLATES'
,p_attribute_03=>'F4000_P204_ID'
,p_attribute_04=>'ID'
,p_attribute_09=>'P204_ID_NEXT'
,p_attribute_10=>'P204_ID_PREV'
,p_attribute_13=>'P204_ID_COUNT'
,p_attribute_14=>'flow_id = :fb_flow_id'
,p_process_error_message=>'Unable to run Get Next or Previous Primary Key Value process.'
,p_internal_uid=>189815222514646975
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(78639507288619482)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh template 1'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_button_template (',
'    p_master_template_id         => :F4000_P204_REFERENCE_ID,',
'    p_subscribing_template_id    => :F4000_P204_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying template.'
,p_process_when_button_id=>wwv_flow_imp.id(78582924092507589)
,p_process_when=>'F4000_P204_REFERENCE_ID'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_process_when2=>'0'
,p_process_success_message=>'Template copied.'
,p_internal_uid=>78639507288619482
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(77943909177912750)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_BUTTON_TEMPLATES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_BUTTON_TEMPLATES'
,p_attribute_03=>'F4000_P204_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error processing row.'
,p_process_when=>'COPY_TEMPLATE'
,p_process_when_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_process_success_message=>'Action processed.'
,p_internal_uid=>77943909177912750
,p_process_comment=>'Generated 17-JUL-2002 17:42:24'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(78643324744626650)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh template 2'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_button_template (',
'    p_master_template_id         => :F4000_P204_REFERENCE_ID,',
'    p_subscribing_template_id    => :F4000_P204_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying template.'
,p_process_when=>':F4000_P204_REFERENCE_ID is not null and :F4000_P204_REFRESH = ''Y'' and (upper(:request) like ''APPLY%'' or upper(:request) = ''SAVE'')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Template copied.'
,p_internal_uid=>78643324744626650
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1449463652826055539)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sync template option presets'
,p_process_sql_clob=>'wwv_flow_templates_util.sync_button_tmplopt_presets(:F4000_P204_ID);'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'nvl(:P204_PRESET_TEMPLATE_OPTIONS,''NOPRESETS'') <> nvl(:P204_PRESET_TMPLOPT_CHECK,''NOPRESETS'') '
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>1449463652826055539
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(78647110942633003)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove reference id as needed'
,p_process_sql_clob=>'wwv_flow_copy_metadata.remove_button_reference_id (:F4000_P204_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error setting template id to null.'
,p_process_when=>'F4000_P204_REFERENCE_ID'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'0'
,p_process_success_message=>'Reference id is removed.'
,p_internal_uid=>78647110942633003
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(9045145912647137)
,p_process_sequence=>80
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(9043595803647121)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Template Options - Save Interactive Grid Data'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>9045145912647137
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(13088726073499044)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_region_id=>wwv_flow_imp.id(9043595803647121)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'upper :name'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':NAME := REGEXP_REPLACE(',
'      srcstr     => :NAME,',
'      pattern    => ''[^'' || wwv_flow_utilities.c_alnum || '']+'',',
'      replacestr => ''_'' );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'F4000_P204_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_exec_cond_for_each_row=>'Y'
,p_internal_uid=>13088726073499044
);
end;
/
prompt --application/pages/page_00207
begin
wwv_flow_imp_page.create_page(
 p_id=>207
,p_name=>'Create Theme - Method'
,p_alias=>'CREATE-THEME-METHOD'
,p_step_title=>'Create Theme'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879423075323511)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_themes.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(41875032605399594)
,p_plug_name=>'Create Theme'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44546724673083504)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(106502626005441775)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(106473613360356705)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747138756852138155)
,p_plug_name=>'Create Theme'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(41879410011411999)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(44546724673083504)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(41879712202412002)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(44546724673083504)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(73940412712235913)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(44546724673083504)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(41935730864673440)
,p_branch_name=>'Go To Page 260'
,p_branch_action=>'f?p=&APP_ID.:260:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P207_ACTION'
,p_branch_condition_text=>'UNIVERSAL_THEME'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(59303916786317064)
,p_branch_action=>'f?p=4000:267:&SESSION.::NO:267::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P207_ACTION'
,p_branch_condition_text=>'NEW_THEME'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(245683510898508513)
,p_branch_name=>'Go To Page 460'
,p_branch_action=>'f?p=&APP_ID.:460:&SESSION.::&DEBUG.:460:P460_FILE_TYPE,P460_CANCEL_TARGET:THEME,207'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(41879712202412002)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P207_ACTION'
,p_branch_condition_text=>'IMPORT_THEME'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1215440895769246856)
,p_branch_action=>'f?p=&APP_ID.:401:&SESSION.::&DEBUG.:401::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(41879712202412002)
,p_branch_sequence=>40
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P207_ACTION'
,p_branch_condition_text=>'COPY'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(41878501007409351)
,p_name=>'P207_ACTION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(41875032605399594)
,p_item_default=>'COPY'
,p_prompt=>'How'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P207_CREATE_TEMPLATE'
,p_lov=>'.'||wwv_flow_imp.id(41876318884405056)||'.'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(73940506664235914)
,p_name=>'onChange P207_ACTION'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P207_ACTION'
,p_condition_element=>'P207_ACTION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'UNIVERSAL_THEME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(73940650350235915)
,p_event_id=>wwv_flow_imp.id(73940506664235914)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show CREATE'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(73940412712235913)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(73940900195235918)
,p_event_id=>wwv_flow_imp.id(73940506664235914)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show NEXT'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(41879712202412002)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(73940759345235916)
,p_event_id=>wwv_flow_imp.id(73940506664235914)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Hide NEXT'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(41879712202412002)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(73940824639235917)
,p_event_id=>wwv_flow_imp.id(73940506664235914)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Hide CREATE'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(73940412712235913)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(73940397607235912)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create UT'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    c_ut_theme_number constant number := 42;',
'    l_ut_theme_id number;',
'begin',
'    select id',
'      into l_ut_theme_id',
'      from wwv_flow_themes',
'     where security_group_id = 12',
'       and theme_id = c_ut_theme_number;',
'',
'    wwv_flow_theme_manager.add_theme_to_application (',
'        p_application_id => :fb_flow_id,',
'        p_theme_id       => l_ut_theme_id );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(73940412712235913)
,p_process_success_message=>'Universal Theme created.'
,p_internal_uid=>73940397607235912
);
end;
/
prompt --application/pages/page_00209
begin
wwv_flow_imp_page.create_page(
 p_id=>209
,p_name=>'Create/Edit Concatenated File'
,p_alias=>'CREATE-EDIT-CONCATENATED-FILE'
,p_page_mode=>'MODAL'
,p_step_title=>'Create/Edit Concatenated File'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
,p_step_template=>wwv_flow_imp.id(120871216744825711)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_protection_level=>'C'
,p_help_text=>'No help is available for this page.'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(907489970216523325)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(926153161992220060)
,p_plug_name=>'Concatenated File'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(926153579716220060)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(907489970216523325)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.confirm(htmldb_delete_message,''DELETE'');'
,p_button_execute_validations=>'N'
,p_button_condition=>'P209_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(926153433597220060)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(907489970216523325)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P209_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(926153373759220060)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(907489970216523325)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>'P209_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(926153664262220060)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(907489970216523325)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(926154799924220074)
,p_name=>'P209_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(926153161992220060)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(926154981029220083)
,p_name=>'P209_FLOW_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(926153161992220060)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(926155388199220084)
,p_name=>'P209_COMBINED_FILE_URL'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(926153161992220060)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Concatenated File URL'
,p_source=>'COMBINED_FILE_URL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>70
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Enter the file URL of the concatenated file to be loaded, instead of multiple single JavaScript or CSS files.',
'</p>',
'',
'<p>',
'Using a concatenated file can increase the performance of loading your page, because instead of issuing multiple HTTP requests for each single file, only one file has to be loaded by the browser.',
'It will also give you the freedom to use smaller, modular files during development, but where the single concatenated file will be used when running the application outside of the &PRODUCT_NAME. development environment.',
'</p>',
'',
'<p>Note: The concatenated file will be loaded as soon as the exact URL of a requested JavaScript or CSS file is encountered when rendering a page. For example if the file is defined in the <em>JavaScript File URLs</em> or <em>CSS File URLs</em> attri'
||'bute for the current page, or loaded by other means such as via the <code>apex_javascript</code> or <code>apex_css</code> APIs, or via another application level attribute where files can be included.</p>',
'',
'<p>',
'Example:',
'<pre>',
'&#35;APP_IMAGES&#35;js/all.min.js?version=&#35;APP_VERSION&#35;',
'</pre>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(926155519628220084)
,p_name=>'P209_SINGLE_FILE_URLS'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(926153161992220060)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Single File URLs'
,p_source=>'SINGLE_FILE_URLS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>12
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Enter multiple file URLs for which a concatenated file should be loaded instead. Each URL has to be written into a new line.',
'</p>',
'',
'<p>',
'The individual file URL should only be contained in one concatenated file, unless the concatenated file has been created for a specific page.',
'</p>',
'',
'<p>Note: The concatenated file will be loaded as soon as the exact URL of a requested JavaScript or CSS file is encountered when rendering a page. For example if the file is defined in the <em>JavaScript File URLs</em> or <em>CSS File URLs</em> attri'
||'bute for the current page, or loaded by other means such as via the <code>apex_javascript</code> or <code>apex_css</code> APIs, or via another application level attribute where files can be included.</p>',
'',
'<p>',
'Example:',
'<pre>',
'&#35;APP_IMAGES&#35;js/core.min.js?version=&#35;APP_VERSION&#35;',
'&#35;APP_IMAGES&#35;js/search.widget.min.js?version=&#35;APP_VERSION&#35;',
'&#35;APP_IMAGES&#35;js/profile.widget.min.js?version=&#35;APP_VERSION&#35;',
'</pre>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(926155989253220084)
,p_name=>'P209_PAGE_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(926153161992220060)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Only for Page'
,p_source=>'PAGE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d',
'  from wwv_flow_steps',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and is_page_pattern   = ''N''',
'order by 2'))
,p_lov_display_null=>'YES'
,p_cSize=>5
,p_cMaxlength=>20
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter a page number if the specified concatenated file should only be used on a particular page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1289129234639528128)
,p_name=>'P209_REQUIRED_PATCH'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(926153161992220060)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Build Option'
,p_source=>'REQUIRED_PATCH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PATCHES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(patch_name) pn, id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'', wwv_flow_escape.html(patch_name))||',
'''} '' pn,0-id id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by pn'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Build Option -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>'Select a build option for this component. Build options are predefined settings that determine whether or not components within an application are enabled.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1882906085240161210)
,p_validation_name=>'Page# exists'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_steps',
' where flow_id = :FB_FLOW_ID',
'   and id      = :P209_PAGE_ID'))
,p_validation_type=>'EXISTS'
,p_error_message=>'An existing page must be selected.'
,p_validation_condition=>'P209_PAGE_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_imp.id(926155989253220084)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(926153758142220060)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(926153664262220060)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(926154124596220069)
,p_event_id=>wwv_flow_imp.id(926153758142220060)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(926156492026220085)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_COMBINED_FILES'
,p_attribute_02=>'WWV_FLOW_COMBINED_FILES'
,p_attribute_03=>'P209_ID'
,p_attribute_04=>'ID'
,p_attribute_11=>'I:U:D'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>926156492026220085
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(926156662156220086)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_COMBINED_FILES'
,p_attribute_02=>'WWV_FLOW_COMBINED_FILES'
,p_attribute_03=>'P209_ID'
,p_attribute_04=>'ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>926156662156220086
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(926156893716220086)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_CURRENT_PAGE'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(926153579716220060)
,p_internal_uid=>926156893716220086
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(926157086192220087)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE,SAVE,DELETE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_internal_uid=>926157086192220087
);
end;
/
prompt --application/pages/page_00211
begin
wwv_flow_imp_page.create_page(
 p_id=>211
,p_name=>'Create Button Template - Creation Method'
,p_alias=>'CREATE-BUTTON-TEMPLATE-CREATION-METHOD'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Button Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(78824330215791185)
,p_plug_name=>'Create Button Template'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<p>You can create templates from scratch or copy them from another application. Copying a template provides you with a framework that you can modify.</p> '
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(78858022427825215)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(106501409747300331)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(186376431100169333)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(78831313955798012)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(186376431100169333)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(78836125383801282)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(186376431100169333)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(19626603886845412)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(186376431100169333)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(78836512822801284)
,p_branch_action=>'218'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(78836125383801282)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'F4000_P211_TYPE'
,p_branch_condition_text=>'BLANK'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(78984619309948262)
,p_branch_action=>'219'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(78836125383801282)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'F4000_P211_TYPE'
,p_branch_condition_text=>'COPY'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(585126298834099825)
,p_branch_action=>'f?p=&APP_ID.:162:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(19626603886845412)
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(78840318773811685)
,p_name=>'F4000_P211_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(78824330215791185)
,p_item_default=>'COPY'
,p_prompt=>'Create Button Template:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'CREATE.TEMPLATE.OPTS'
,p_lov=>'.'||wwv_flow_imp.id(88108326304250090)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_escape_on_http_output=>'N'
,p_help_text=>'Select the method by which you wish to create a new button template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(585126009190099823)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(78831313955798012)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(585126171503099824)
,p_event_id=>wwv_flow_imp.id(585126009190099823)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00218
begin
wwv_flow_imp_page.create_page(
 p_id=>218
,p_name=>'Create Button Template - Details'
,p_alias=>'CREATE-BUTTON-TEMPLATE-DETAILS'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Button Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(78872417886842560)
,p_plug_name=>'Create Button Template'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>130
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>'<p>Button templates enable application developers to customize the look and feel of a button. To build a button, you can use multiple images or HTML tags. No all buttons use button templates.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(79577608784165807)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(79547928409156701)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(186380405089209124)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>140
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(78875616688846128)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(186380405089209124)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(78881331579850437)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(186380405089209124)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(78878724999848545)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(186380405089209124)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(101874031088197573)
,p_branch_action=>'f?p=&FLOW_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(585127643545099839)
,p_branch_action=>'f?p=&APP_ID.:211:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(78878724999848545)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(105556709879210306)
,p_name=>'P218_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(78872417886842560)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identify button template name.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(106749420615213455)
,p_name=>'P218_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(78872417886842560)
,p_prompt=>'Theme'
,p_source=>'P4003_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify theme.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(108371203777218044)
,p_name=>'P218_THEME_CLASS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(78872417886842560)
,p_prompt=>'Theme Class'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'BUTTON THEME CLASS ID'
,p_lov=>'.'||wwv_flow_imp.id(43576623634636183)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify theme class.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(109295011396220235)
,p_validation_name=>'P218_NAME'
,p_validation_sequence=>10
,p_validation=>'P218_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(78881331579850437)
,p_associated_item=>wwv_flow_imp.id(105556709879210306)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(73942034699235929)
,p_validation_name=>'P218_NAME unique'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_button_templates',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :workspace_id',
'   and theme_id          = :P218_THEME',
'   and template_name     = :P218_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#LABEL# must be unique.'
,p_when_button_pressed=>wwv_flow_imp.id(78881331579850437)
,p_associated_item=>wwv_flow_imp.id(105556709879210306)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(110324219361222568)
,p_validation_name=>'P218_THEME'
,p_validation_sequence=>30
,p_validation=>'P218_THEME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(78881331579850437)
,p_associated_item=>wwv_flow_imp.id(106749420615213455)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(111449726979224768)
,p_validation_name=>'P218_THEME_CLASS'
,p_validation_sequence=>40
,p_validation=>'P218_THEME_CLASS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(78881331579850437)
,p_associated_item=>wwv_flow_imp.id(108371203777218044)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(585127471833099837)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(78875616688846128)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(585127528263099838)
,p_event_id=>wwv_flow_imp.id(585127471833099837)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(78955408550922792)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Button Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_imp_shared.create_button_templates (',
'    p_flow_id                       => :FB_FLOW_ID,',
'    p_template_name                 => :P218_NAME,',
'    p_template                      => ''<a href="#LINK#">#LABEL#</a>'',',
'    p_template_comment              => null,',
'    p_theme_id                      => :p218_theme,',
'    p_theme_class_id                => :p218_theme_class',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error creating button template.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(78881331579850437)
,p_process_success_message=>'Button template created.'
,p_internal_uid=>78955408550922792
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(585127382089099836)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(78881331579850437)
,p_process_success_message=>'Button template created.'
,p_internal_uid=>585127382089099836
);
end;
/
prompt --application/pages/page_00219
begin
wwv_flow_imp_page.create_page(
 p_id=>219
,p_name=>'Create Button Template - Copy From'
,p_alias=>'CREATE-BUTTON-TEMPLATE-COPY-FROM'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Button Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(78937032070896692)
,p_plug_name=>'Create Button Template'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_row_template=>wwv_flow_imp.id(79387910442923002)
,p_plug_query_num_rows=>20
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_header=>'<p>Select the application that contains the templates you wish to copy.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(78995810670967396)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(320074633987)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_plug_query_row_template=>wwv_flow_imp.id(79387910442923002)
,p_plug_query_headings=>wwv_flow_string.join(wwv_flow_t_varchar2(
'blue_arrow_down.gif::blue_arrow_up.gif:|3,3\1,2|',
'',
'<font color="black" class="nounderline">&nbsp;</font>:',
'',
'<font color="black" class="nounderline">&nbsp;</font>:',
'',
'<font color="black" class="nounderline">Flow</font>:',
'',
'<font color="black" class="nounderline">ExportTitle</font>:',
'',
'<font color="black" class="nounderline">MimeType</font>:',
'',
'<font color="black" class="nounderline">DocSize</font>:',
'',
'<font color="black" class="nounderline">CreatedBy</font>:',
'',
'<font color="black" class="nounderline">Created</font>:',
'',
'<font color="black" class="nounderline">FileType</font>'))
,p_plug_query_num_rows=>20
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(186377503311180257)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(78999724625971425)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(186377503311180257)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(79010714366977909)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(186377503311180257)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(79005805709975417)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(186377503311180257)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(154563201491214857)
,p_branch_action=>'f?p=&FLOW_ID.:413:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(585126507658099828)
,p_branch_action=>'f?p=&APP_ID.:211:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(79005805709975417)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(79016305482985032)
,p_name=>'F4000_P219_COPY_FROM_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(78937032070896692)
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Copy From Application'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select an Application -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the application from which you wish to copy the template.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(79020800306987465)
,p_validation_name=>'F4000_P219_COPY_FROM_FLOW_ID Not Null'
,p_validation_sequence=>1
,p_validation=>'F4000_P219_COPY_FROM_FLOW_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Copy From Application must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(79010714366977909)
,p_associated_item=>wwv_flow_imp.id(79016305482985032)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 18-JUL-2002 13:21'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(585126321257099826)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(78999724625971425)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(585126450569099827)
,p_event_id=>wwv_flow_imp.id(585126321257099826)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00221
begin
wwv_flow_imp_page.create_page(
 p_id=>221
,p_name=>'Delete Theme'
,p_alias=>'DELETE-THEME'
,p_step_title=>'Delete Theme'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879423075323511)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'ui_themes.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(57672322563700420)
,p_plug_name=>'Identify Theme to Delete'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in ( select count(*) counter from wwv_flow_themes where flow_id = :fb_flow_id) loop',
'  if c1.counter < 2 then ',
'    return false;',
'  else',
'    return true;',
'  end if;',
'end loop;'))
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(58439930744285175)
,p_plug_name=>'Delete Theme'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(399849897040726767)
,p_plug_display_sequence=>40
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>A theme is a collection of templates. You can only delete inactive themes. When you delete a theme, App Builder removes inactive templates.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(144906022460884948)
,p_plug_name=>'Delete Theme Error'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42027416946637016)
,p_plug_display_sequence=>30
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'There are no inactive themes to be deleted. Unable to continue this action.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NOT_EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_themes',
' where flow_id  = :fb_flow_id',
'   and theme_id not in ( select theme_id',
'                           from wwv_flows',
'                          where id = :fb_flow_id )'))
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(200244012959340575)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(928046614226850015)
,p_plug_name=>'Wizard Progress List'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_list_id=>wwv_flow_imp.id(1029750209782685847)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(928046821756850017)
,p_plug_name=>'Delete Theme'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(57673506818700425)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(200244012959340575)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(144906928001886565)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(200244012959340575)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:260:&SESSION.::&DEBUG.:RP:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(57675609157700443)
,p_branch_action=>'f?p=&FLOW_ID.:229:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57674318785700429)
,p_name=>'P221_REMOVE_THEME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(57672322563700420)
,p_prompt=>'Delete Theme:'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||theme_name as d,',
'       theme_id',
'  from wwv_flow_themes',
' where flow_id  = :fb_flow_id',
'   and theme_id not in ( select theme_id',
'                           from wwv_flows',
'                          where id = :fb_flow_id )',
' order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Select the theme to remove.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57674709683700434)
,p_name=>'P221_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(57672322563700420)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application:'
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_help_text=>'This attribute identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
end;
/
prompt --application/pages/page_00223
begin
wwv_flow_imp_page.create_page(
 p_id=>223
,p_name=>'Create Button Template - New Templates'
,p_alias=>'CREATE-BUTTON-TEMPLATE-NEW-TEMPLATES'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Button Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(79037325082006306)
,p_name=>'Create Button Template'
,p_template=>wwv_flow_imp.id(42025417508627628)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'  id,',
'  flow_id,',
'  template_name from_name,',
'  wwv_flow_lang.system_message(''F4000.P158.COPY_OF'',template_name) to_name,  ',
'  ''N'' Sub ',
'  from wwv_flow_button_templates ',
'  where flow_id = :F4000_P219_COPY_FROM_FLOW_ID ',
'  and security_group_id = :flow_security_group_id ',
'  and theme_id = :P413_COPY_FROM_THEME '))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'<font class="fielddata">No button templates found.</font>'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(291212700208110402)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(291212812720110403)
,p_query_column_id=>2
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>2
,p_column_heading=>'Application'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(291212910615110403)
,p_query_column_id=>3
,p_column_alias=>'FROM_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'From Name'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(291213012573110403)
,p_query_column_id=>4
,p_column_alias=>'TO_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'To Name'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>40
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(291213126199110403)
,p_query_column_id=>5
,p_column_alias=>'SUB'
,p_column_display_sequence=>5
,p_column_heading=>'Copy?'
,p_use_as_row_header=>'N'
,p_display_as=>'SELECT_LIST_FROM_LOV'
,p_named_lov=>wwv_flow_imp.id(150847232623403358)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'NO'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(79072408476013995)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(320074633987)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(186379505997200005)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(79075916968016548)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(186379505997200005)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(79082801516021503)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(186379505997200005)
,p_button_name=>'Copy'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy Button Templates'
,p_button_position=>'CREATE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_button_templates',
'where flow_id = :F4000_P219_COPY_FROM_FLOW_ID',
'and security_group_id = :flow_security_group_id'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(79079723548018440)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(186379505997200005)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(154569907771245074)
,p_branch_action=>'f?p=&FLOW_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(585127217510099835)
,p_branch_action=>'f?p=&APP_ID.:413:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(79079723548018440)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(74794830724628143)
,p_name=>'P223_THEME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(79037325082006306)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&P413_COPY_TO_THEME.'
,p_prompt=>'Copy to Theme:'
,p_source=>'P413_COPY_TO_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies a collection of templates which define the look and feel of the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(291219023888126752)
,p_validation_name=>'IsOneSelected'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  for i in 1..wwv_flow.g_f01.count loop',
'    if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'') then',
'      return true;',
'    end if;',
'  end loop;',
'  return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'You must select at least one template to be copied.',
''))
,p_when_button_pressed=>wwv_flow_imp.id(79082801516021503)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(291223520902135378)
,p_validation_name=>'IsDupeName'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_found_name varchar2(2000) := null;',
'begin',
'for i in 1..wwv_flow.g_f01.count loop',
'   if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'')',
'      then',
'      for c1 in ( select template_name',
'                  from wwv_flow_button_templates',
'                  where flow_id = :FB_FLOW_ID',
'                  and security_group_id = (select PROVISIONING_COMPANY_ID',
'                                           from wwv_flow_companies',
'                                           where SHORT_NAME = :COMPANY)',
'                  and template_name = wwv_flow.g_f02(i) ) loop',
'         if c1.template_name is not null then ',
'            if l_found_name is null then ',
'              l_found_name := c1.template_name;',
'            else ',
'              l_found_name := l_found_name||'', ''||c1.template_name;',
'            end if;',
'         end if;',
'      end loop;',
'   end if;',
'end loop;',
'',
'if l_found_name is not null then ',
'return wwv_flow_lang.system_message(''F4000.TEMPLATE_NAME_ALREADY_EXISTS'',',
'                                    l_found_name);',
'end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_when_button_pressed=>wwv_flow_imp.id(79082801516021503)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(585127098058099833)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(79075916968016548)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(585127103134099834)
,p_event_id=>wwv_flow_imp.id(585127098058099833)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(79487226696142335)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'copy button template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_template_id number;',
'begin',
'for i in 1..wwv_flow.g_f01.count loop',
'  l_template_id := wwv_flow_id.next_val;',
'  if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'') then   ',
'    wwv_flow_templates_util.copy_button_template (',
'      p_copy_from_flow_id    => :F4000_P219_COPY_FROM_FLOW_ID,',
'      p_flow_id              => :FB_FLOW_ID,',
'      p_from_template_id     => wwv_flow.g_f01(i),',
'      p_to_template_name     => wwv_flow.g_f02(i),',
'      p_to_template_id       => l_template_id,',
'      p_to_theme_id          => :p223_theme,',
'      p_include_subscription => (wwv_flow.g_f03(i)=''SUBSCRIBE'')',
'    );',
'    if wwv_flow.g_f03(i) in (''SUBSCRIBE'') then',
'      wwv_flow_copy_metadata.subscribe_button_template (',
'        p_master_template_id         => wwv_flow.g_f01(i),',
'        p_subscribing_template_id    => l_template_id',
'      );',
'    end if;',
'  end if;',
'end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying button template(s).'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(79082801516021503)
,p_process_success_message=>'Button template(s) copied.'
,p_internal_uid=>79487226696142335
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(585126957721099832)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(79082801516021503)
,p_process_success_message=>'Button template(s) copied.'
,p_internal_uid=>585126957721099832
);
end;
/
prompt --application/pages/page_00224
begin
wwv_flow_imp_page.create_page(
 p_id=>224
,p_name=>'Export Theme'
,p_alias=>'EXPORT-THEME'
,p_step_title=>'Export Theme'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213300727323081712)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'exprt_themes.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(60514600060460890)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(12802829107)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(60520626473525286)
,p_plug_name=>'Export Settings'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_plug_grid_column_span=>8
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(168864819843955649)
,p_plug_name=>'Export Theme'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(205603713223283346)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(205602222789276628)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(205606001233289349)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Use this page to export a theme definition to a file.  Once exported a theme can be imported.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(486280919368630117)
,p_plug_name=>'Choose Application'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_grid_column_span=>8
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_plug_read_only_when=>'FB_FLOW_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(486388619159589351)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(168864819843955649)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:224:&SESSION.::&DEBUG.:224::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(60527206911557455)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(168864819843955649)
,p_button_name=>'EXPORT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Export'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1800883479027250)
,p_name=>'P224_AUDIT_INFO'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(60520626473525286)
,p_item_default=>'NONE'
,p_prompt=>'Audit Information'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'AUDIT INFO DETAIL'
,p_lov=>'.'||wwv_flow_imp.id(1726678227351632)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'None'
,p_lov_null_value=>'NONE'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the Audit Information to include in the export file. ',
'Audit information includes the Created By User, Created On Date, Changed By User and Changed On Date.<ul> ',
'<li>By default, no audit information is included.</li>',
'<li>Choose Names and Dates to include all audit information.</li>',
'<li>Choose Dates Only to include date information and exclude user details.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(60522504786528459)
,p_name=>'P224_A'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(486280919368630117)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Application'
,p_source=>'&P224_A.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PICK_EXPORT_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flows f',
'where  ',
'       security_group_id = :flow_security_group_id and',
'       f.build_status != ''RUN_AND_HIDDEN'' and',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id is null and security_group_id = :flow_security_group_id )',
'       or',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id = f.id and security_group_id = :flow_security_group_id) ',
'order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Application -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the application that contains the theme to be exported.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(60525717169550955)
,p_name=>'P224_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(60520626473525286)
,p_prompt=>'Export Theme'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select a Theme -'
,p_lov_null_value=>'%null%'
,p_lov_cascade_parent_items=>'P224_A'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies a collection of templates which define the look and feel of the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(60541507435595404)
,p_name=>'P224_FILE_CHAR_SET'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(60520626473525286)
,p_use_cache_before_default=>'NO'
,p_prompt=>'File Character Set'
,p_source=>'return lower(trim(sys.owa_util.get_cgi_env(''REQUEST_IANA_CHARSET'')));'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'I18N_IANA_CHARSET'
,p_lov=>'.'||wwv_flow_imp.id(144796827445692396)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'The export file will be encoded in the specified character set.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(937788573544878610)
,p_validation_name=>'P244_THEME cannot be null'
,p_validation_sequence=>10
,p_validation=>'P224_THEME'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'#LABEL# must have some value.'
,p_always_execute=>'Y'
,p_when_button_pressed=>wwv_flow_imp.id(60527206911557455)
,p_associated_item=>wwv_flow_imp.id(60525717169550955)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(651511347740755606)
,p_name=>'Submit'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(60527206911557455)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(651511401227755607)
,p_event_id=>wwv_flow_imp.id(651511347740755606)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'EXPORT'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5629110035882801)
,p_name=>'P223_A Change'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P224_A'
,p_condition_element=>'P224_A'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5629238219882802)
,p_event_id=>wwv_flow_imp.id(5629110035882801)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show Export Preferences'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(60520626473525286)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5629343395882803)
,p_event_id=>wwv_flow_imp.id(5629110035882801)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Export Preferences'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(60520626473525286)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(61027317326538036)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'export theme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_export_dev.export_theme (',
'    p_application_id  => nvl(:FB_FLOW_ID, :P224_A),',
'    p_theme_id        => :P224_THEME,',
'    p_format          => ''UNIX'', ',
'    p_with_audit_info => :P224_AUDIT_INFO);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Theme Export Failed!'
,p_process_when_button_id=>wwv_flow_imp.id(60527206911557455)
,p_process_success_message=>'Theme Exported'
,p_internal_uid=>61027317326538036
);
end;
/
prompt --application/pages/page_00225
begin
wwv_flow_imp_page.create_page(
 p_id=>225
,p_name=>'Create Page Template - Identify Theme'
,p_alias=>'CREATE-PAGE-TEMPLATE-IDENTIFY-THEME'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Page Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47949104472764295)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(151702327009495805)
,p_plug_name=>'Create Page Template'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<p>A Theme is a named collection of Templates.  An Application can have one or more Themes.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(151702703807495809)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(320074633987)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(151703906460495813)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47949104472764295)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(151704732582495820)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(47949104472764295)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(151704327075495817)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(47949104472764295)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(151710117394495850)
,p_branch_action=>'f?p=&FLOW_ID.:144:&SESSION.::&DEBUG.:144::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(151704732582495820)
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(589949729811621442)
,p_branch_action=>'f?p=&APP_ID.:26:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(151704327075495817)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(151705110557495822)
,p_name=>'P225_X'
,p_item_sequence=>11
,p_item_plug_id=>wwv_flow_imp.id(151702327009495805)
,p_post_element_text=>'<br />'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(151705805378495835)
,p_name=>'P225_FROM_APP'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_imp.id(151702327009495805)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application:'
,p_source=>'F4000_P26_COPY_FROM_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identifies the application from which the theme will be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(151706501435495838)
,p_name=>'P225_COPY_TO'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_imp.id(151702327009495805)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application:'
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identifies the application to which the template will be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(151707203352495840)
,p_name=>'P225_F'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(151702327009495805)
,p_prompt=>'Copy From:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(151707901068495841)
,p_name=>'P225_TO'
,p_item_sequence=>12
,p_item_plug_id=>wwv_flow_imp.id(151702327009495805)
,p_prompt=>'Copy To:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(151708610122495842)
,p_name=>'P225_COPY_FROM_THEME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(151702327009495805)
,p_prompt=>'Theme'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(theme_name) d, theme_id',
'from   wwv_flow_themes',
'where  flow_id = :F4000_P26_COPY_FROM_FLOW_ID',
'order by 1'))
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the theme from which you wish to copy templates.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(151709323167495843)
,p_name=>'P225_COPY_TO_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(151702327009495805)
,p_prompt=>'Theme'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the theme to which the template will be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2461532381542560379)
,p_computation_sequence=>10
,p_computation_item=>'F4000_COPY_TO_THEME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P225_COPY_TO_THEME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(589949594060621440)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(151703906460495813)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(589949675059621441)
,p_event_id=>wwv_flow_imp.id(589949594060621440)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00226
begin
wwv_flow_imp_page.create_page(
 p_id=>226
,p_name=>'Web Services Testing'
,p_alias=>'WEB-SERVICES-TESTING'
,p_step_title=>'Web Services Testing'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30009431242804826)
,p_plug_name=>'SOAP Envelope'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_query_num_rows=>25
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30014321686887232)
,p_plug_name=>'Basic Authentication'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_ws_operations',
' where name = ''BASIC_AUTH''',
'   and ws_id = :F4000_P226_ID'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(86555214170536943)
,p_plug_name=>'Identify Service'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(86556512445537718)
,p_plug_name=>'Response'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_query_num_rows=>25
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(86575626438561642)
,p_plug_name=>'Web Services'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p />Select the Web service from the list to test.',
'<p />Enter a username and password for the Web service if the Basic Authentication region appears.',
'<p />Modify the SOAP Envelope as appropriate by replacing #ITEM# references with static values to test.',
'<p />Click Test to test the Web service with the SOAP Envelope in the text area. Inspect the results in the Result text area.',
'<p />Click Edit to edit the attributes of the Web service.'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(86560930207546868)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(86555214170536943)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:170:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(86642432640623325)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(86555214170536943)
,p_button_name=>'Clear'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Clear'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(86677212171664689)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(86555214170536943)
,p_button_name=>'Edit'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Edit'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(86571505188558575)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(86555214170536943)
,p_button_name=>'Test'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Test'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(190957021196827831)
,p_branch_action=>'f?p=&FLOW_ID.:196:&SESSION.::&DEBUG.::F4000_P196_ID:&F4000_P226_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(86677212171664689)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(94641014947653996)
,p_branch_action=>'f?p=&APP_ID.:226:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30010111287808515)
,p_name=>'P226_ENVELOPE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(30009431242804826)
,p_prompt=>'SOAP Envelope'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>10
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'This text area is populated with the SOAP Envelope associated with the Web reference. Replace #ITEM# substitutions with static values to test the service.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30016206233892256)
,p_name=>'P226_USERNAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(30014321686887232)
,p_prompt=>'Username'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the username to authenticate to this Web service.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30017114891894760)
,p_name=>'P226_PASSWORD'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(30014321686887232)
,p_prompt=>'Password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter the password to authenticate to this Web service.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(86565409629554218)
,p_name=>'F4000_P226_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(86555214170536943)
,p_prompt=>'Web Service'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_flow_shared_web_services a',
' where (action != ''NEW_SCHOOL'' or action is null)',
'   and security_group_id = :flow_security_group_id',
'   and flow_id = :FB_FLOW_ID',
' order by upper(name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Web Service -'
,p_cSize=>64
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Select Web service to test.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'REDIRECT_SET_VALUE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(86581914361567262)
,p_name=>'F4000_P226_RESULT'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(86556512445537718)
,p_prompt=>'Result'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>10
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'This text area displays the response from the Web service.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(86750631429787251)
,p_name=>'F4000_P226_FORMATTED'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(86555214170536943)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(30011808695845624)
,p_computation_sequence=>10
,p_computation_item=>'P226_ENVELOPE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select soap_envelope',
'             from wwv_flow_shared_web_services',
'            where id = :F4000_P226_ID ) loop',
'  return wwv_flow_utilities.clob_to_varchar2(c1.soap_envelope);',
'end loop;'))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(86649910430629809)
,p_validation_name=>'F4000_P226_ID Not Null'
,p_validation_sequence=>10
,p_validation=>'F4000_P226_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Web Service must be specified.'
,p_validation_condition=>'TEST,EDIT'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(86565409629554218)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 31-JUL-2002 21:57'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(86694028712682076)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'clear item'
,p_attribute_01=>'CLEAR_CACHE_FOR_ITEMS'
,p_attribute_03=>'F4000_P226_RESULT:F4000_P226_FORMATTED'
,p_process_error_message=>'Error clearing result.'
,p_process_when_button_id=>wwv_flow_imp.id(86642432640623325)
,p_process_success_message=>'Result cleared.'
,p_internal_uid=>86694028712682076
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(86593111545583751)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'process web service'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_response clob;',
'    l_response_var varchar2(32767);',
'    l_url varchar2(4000);',
'    l_action varchar2(4000);',
'    l_soap_version varchar2(30);',
'    l_proxy_override varchar2(4000);',
'    l_app_proxy varchar2(4000);',
'    l_wallet wwv_flow_security.t_wallet;',
'    l_env clob;',
'begin',
'',
'    l_env := :P226_ENVELOPE;',
'',
'    select url, action, nvl(soap_version,''1.1''), proxy_override ',
'      into l_url, l_action, l_soap_version, l_proxy_override',
'      from wwv_flow_shared_web_services',
'     where id = :f4000_p226_id;',
'    ',
'    l_app_proxy := wwv_flow_web_services.find_proxy(:FB_FLOW_ID);',
'',
'    l_wallet := wwv_flow_security.get_wallet;',
'',
'    if sys.dbms_lob.substr(l_env,5) != ''<?xml'' then',
'        l_env := ''<?xml version=''''1.0'''' encoding=''''UTF-8''''?>''||l_env;',
'    end if;',
'',
'    l_response := wwv_flow_web_services.make_request(',
'                      p_url            => l_url,',
'                      p_action         => l_action,',
'                      p_version        => l_soap_version,',
'                      p_envelope       => l_env,',
'                      p_username       => :P226_USERNAME,',
'                      p_password       => :P226_PASSWORD,',
'                      p_proxy_override => nvl(l_proxy_override,l_app_proxy),',
'                      p_wallet_path    => l_wallet.wallet_path,',
'                      p_wallet_pwd     => l_wallet.wallet_pwd);',
'    ',
'   l_response_var := wwv_flow_utilities.clob_to_varchar2(l_response);',
'   wwv_flow.update_cache_with_write(''F4000_P226_RESULT'',substr(l_response_var,1,32000));',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error testing service.'
,p_process_when_button_id=>wwv_flow_imp.id(86571505188558575)
,p_process_success_message=>'Service tested.'
,p_internal_uid=>86593111545583751
);
end;
/
prompt --application/pages/page_00229
begin
wwv_flow_imp_page.create_page(
 p_id=>229
,p_name=>'Delete Theme'
,p_alias=>'DELETE-THEME1'
,p_step_title=>'Delete Theme'
,p_allow_duplicate_submissions=>'N'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879423075323511)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'ui_themes.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(57687023301725935)
,p_plug_name=>'Confirm Delete Theme'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>131
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_footer=>'&nbsp;'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(200244914821350562)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>141
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(928047061287850019)
,p_plug_name=>'Delete Theme'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1029840900020751021)
,p_plug_name=>'Wizard Progress List'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>151
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_list_id=>wwv_flow_imp.id(1029750209782685847)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(57687802420725937)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(200244914821350562)
,p_button_name=>'REMOVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Delete Theme'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(57688224484725938)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(200244914821350562)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:221:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(57688618408725938)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(200244914821350562)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:260:&SESSION.::&DEBUG.:RP:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(928046994220850018)
,p_branch_name=>'Delete theme'
,p_branch_action=>'f?p=&APP_ID.:260:&SESSION.::&DEBUG.:RP:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(57687802420725937)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57689007735725939)
,p_name=>'P229_REMOVE_THEME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(57687023301725935)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Delete Theme:'
,p_source=>'P221_REMOVE_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>'select theme_id||''. ''||wwv_flow_escape.html(theme_name) d, theme_id r from wwv_flow_themes where flow_id = :fb_flow_id'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies a collection of templates which define the look and feel of the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(57689530579725943)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove theme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'wwv_flow_theme_manager.delete_theme(p_flow_id => :fb_flow_id, p_theme_id => :P221_REMOVE_THEME);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to remove theme.'
,p_process_when_button_id=>wwv_flow_imp.id(57687802420725937)
,p_process_success_message=>'Theme Removed.'
,p_internal_uid=>57689530579725943
);
end;
/
prompt --application/pages/page_00231
begin
wwv_flow_imp_page.create_page(
 p_id=>231
,p_name=>'Copy Button - New Page'
,p_alias=>'COPY-BUTTON-NEW-PAGE'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Button'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_but.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(15144819360777868)
,p_plug_name=>'Copy Button'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(15214209943995787)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(181185105878280365)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(45386429462431518)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(15147026417789395)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(45386429462431518)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(15149015120795592)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(45386429462431518)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(15149301379795595)
,p_branch_action=>'191'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(15149015120795592)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(15147314750789401)
,p_branch_action=>'4500'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(15147026417789395)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(15151821485806920)
,p_name=>'F4000_P231_COPY_FROM_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(15144819360777868)
,p_prompt=>'Copy From Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(15152400145810215)
,p_name=>'F4000_P231_COPY_FROM_PAGE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(15144819360777868)
,p_prompt=>'Copy From Page Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(15153410319822639)
,p_name=>'F4000_P231_COPY_TO_PAGE_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(15144819360777868)
,p_prompt=>'Target Page'
,p_source=>'F4000_P231_COPY_FROM_PAGE_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d',
'  from wwv_flow_steps',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and is_page_pattern   = ''N''',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the page number to which this button will be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(15154627634827604)
,p_validation_name=>'F4000_P231_COPY_TO_PAGE_ID Not Null'
,p_validation_sequence=>10
,p_validation=>'F4000_P231_COPY_TO_PAGE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'New Page ID must be specified.'
,p_associated_item=>wwv_flow_imp.id(15153410319822639)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 18-OCT-2002 11:50'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(167037203753942735)
,p_validation_name=>'check page locks'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'for c1 in (select count(*) counter ',
'           from wwv_flow_lock_page ',
'           where OBJECT_ID = :F4000_P231_COPY_TO_PAGE_ID ',
'           and flow_id = :fb_flow_id',
'           and locked_by != :app_user) loop',
'if c1.counter > 0 then',
'  return false;',
'else ',
'  return true;',
'end if;',
'end loop;',
'return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Can not copy to a page locked by another user.'
,p_when_button_pressed=>wwv_flow_imp.id(15149015120795592)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(590120424992572040)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(15147026417789395)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(590120588079572041)
,p_event_id=>wwv_flow_imp.id(590120424992572040)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00232
begin
wwv_flow_imp_page.create_page(
 p_id=>232
,p_name=>'Remove Components'
,p_alias=>'REMOVE-COMPONENTS'
,p_page_mode=>'MODAL'
,p_step_title=>'Remove Components'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213481614528579568)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'540'
,p_dialog_width=>'600'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(52410809441114515)
,p_plug_name=>'Remove Components'
,p_region_css_classes=>'a-Alert--inlineDialog a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>You are about to permanently remove all components associated with this build option.</p>',
'<p>Note: If you used the negated version of this build option (Eg. {Not {Build Option}}, those components will be updated to remove the reference to this build option.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(52410779965114514)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(52410809441114515)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Remove Components'
,p_button_position=>'CLOSE'
,p_button_cattributes=>'disabled'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(52412315756114530)
,p_branch_name=>'Branch to Build Option detail page'
,p_branch_action=>'f?p=&APP_ID.:4911:&SESSION.::&DEBUG.:RP,4911:F4000_P4911_ID:&F4000_P232_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(52411111658114518)
,p_name=>'F4000_P232_BUILDOPT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(52410809441114515)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(52411200670114519)
,p_name=>'F4000_P232_BUILDOPT_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(52410809441114515)
,p_prompt=>'Build Option'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(52411460330114521)
,p_name=>'P232_CONFIRM'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(52410809441114515)
,p_prompt=>'Yes - remove components'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(710589345112275246)
,p_name=>'F4000_P232_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(52410809441114515)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(52411383228114520)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P232_BUILDOPT_NAME'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select patch_name ',
'from wwv_flow_patches ',
'where flow_id = :FB_FLOW_ID and ',
'      id = :F4000_P232_ID'))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(52411930691114526)
,p_validation_name=>'Must Confirm'
,p_validation_sequence=>10
,p_validation=>'P232_CONFIRM'
,p_validation2=>'Y'
,p_validation_type=>'ITEM_IN_VALIDATION_EQ_STRING2'
,p_error_message=>'You must confirm this action to proceed.'
,p_associated_item=>wwv_flow_imp.id(52411460330114521)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(52411544208114522)
,p_name=>'Toggle Button'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P232_CONFIRM'
,p_condition_element=>'P232_CONFIRM'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(52411668022114523)
,p_event_id=>wwv_flow_imp.id(52411544208114522)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(52410779965114514)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(52411837673114525)
,p_event_id=>wwv_flow_imp.id(52411544208114522)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(52410779965114514)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(52412220252114529)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Remove Components'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_f4000_util.delete_build_option_references(',
'    p_build_option_id => :F4000_P232_ID,',
'    p_application_id  => :FB_FLOW_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Components removed.'
,p_internal_uid=>52412220252114529
);
end;
/
prompt --application/pages/page_00233
begin
wwv_flow_imp_page.create_page(
 p_id=>233
,p_name=>'Confirm Publish Theme'
,p_alias=>'CONFIRM-PUBLISH-THEME'
,p_page_mode=>'MODAL'
,p_step_title=>'Confirm Publish Theme'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_dialog_height=>'360'
,p_dialog_width=>'640'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'No help is available for this page.'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1403935393827712480)
,p_plug_name=>'Dialog Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1403935974802712489)
,p_plug_name=>'Confirm Publication'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Please confirm that you wish to publish the current theme to all of the applications listed below.</p>',
'<p>If you only wish to update a selection of the applications you can go into each application that needs updating, navigate to the theme, and press ''Refresh''.</p>',
'',
'',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(1119685869158584503)
,p_name=>'Applications referencing this theme'
,p_parent_plug_id=>wwv_flow_imp.id(1403935974802712489)
,p_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.flow_id||'' - ''||f.name application, t.theme_name theme',
'from wwv_flow_themes t, wwv_flows f',
'where t.flow_id = f.id ',
'and t.reference_id = :P267_ID',
'order by t.flow_id'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1119685953314584504)
,p_query_column_id=>1
,p_column_alias=>'APPLICATION'
,p_column_display_sequence=>1
,p_column_heading=>'Application'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1119686070366584505)
,p_query_column_id=>2
,p_column_alias=>'THEME'
,p_column_display_sequence=>2
,p_column_heading=>'Theme'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1403935783744712486)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1403935393827712480)
,p_button_name=>'Cancel'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1403935552807712484)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1403935393827712480)
,p_button_name=>'Publish'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Publish Theme'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1403936695369712499)
,p_branch_name=>'back to theme edit page'
,p_branch_action=>'f?p=&APP_ID.:267:&SESSION.::&DEBUG.:RP:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2411516663880763101)
,p_name=>'Publish'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1403935552807712484)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2411516786718763102)
,p_event_id=>wwv_flow_imp.id(2411516663880763101)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'PUBLISH'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1403936180836712491)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Cancel'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1403935783744712486)
,p_internal_uid=>1403936180836712491
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1403936356234712493)
,p_process_sequence=>20
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Publish Theme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in ( select id',
'              from wwv_flow_themes',
'             where reference_id = :P267_ID',
'               and security_group_id  = :WORKSPACE_ID',
'             order by flow_id, id',
') loop',
'    wwv_flow_copy_metadata.resubscribe_theme(',
'        p_master_theme_id      => :P267_ID,',
'        p_subscribing_theme_id => c1.id',
'    );',
'',
'    wwv_flow_copy_metadata.subscribe_theme (',
'        p_master_theme_id      => :P267_ID,',
'        p_subscribing_theme_id => c1.id',
'    );',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error publishing theme.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'PUBLISH'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>'Theme has been published.'
,p_internal_uid=>1403936356234712493
);
end;
/
prompt --application/pages/page_00235
begin
wwv_flow_imp_page.create_page(
 p_id=>235
,p_name=>'Delete Build Option'
,p_alias=>'DELETE-BUILD-OPTION'
,p_page_mode=>'MODAL'
,p_step_title=>'Delete Build Option'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213481614528579568)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'540'
,p_dialog_width=>'600'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(121338939969762742)
,p_plug_name=>'Remove Components'
,p_region_css_classes=>'a-Alert--inlineDialog a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Are you sure you want to delete this build option? Deleting a build option will not delete the components associated with this option.</p>',
'<p><em><strong>Note:</strong> Before deleting a build option, examine the application components under <strong>Associated Components</strong> to determine if the components should be removed before deleting this build option. To remove associated com'
||'ponents, click <strong>Remove Components</strong>.</em></p>',
'',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(68928811043648234)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(121338939969762742)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Delete Build Option'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(68933199182648259)
,p_branch_name=>'Branch to Build Options Page'
,p_branch_action=>'f?p=&APP_ID.:4910:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(68929293853648237)
,p_name=>'F4000_P235_BUILDOPT_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(121338939969762742)
,p_prompt=>'Build Option'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(68930012983648241)
,p_name=>'F4000_P235_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(121338939969762742)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(68930582704648255)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P235_BUILDOPT_NAME'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select patch_name ',
'from wwv_flow_patches ',
'where flow_id = :FB_FLOW_ID and ',
'      id = :F4000_P235_ID'))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(6611480825558819)
,p_validation_name=>'Prevent used build option deletetion'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * ',
'  from wwv_flow_build_opt_usage_dev',
'  -- security_group_id filter is applied in the view',
' where id            = :F4000_P235_ID',
'   and flow_id       = :FB_FLOW_ID',
'   and is_subscribed = ''Y'''))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'It is not possible to delete this build option as it is used in some of the shared components that are subscribed from other applications.'
,p_when_button_pressed=>wwv_flow_imp.id(68928811043648234)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2610335502433103)
,p_validation_name=>'Not part of component groups'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not wwv_flow_component_group_dev.is_part_of_comp_grp (',
'    p_component_id   => :F4000_P235_ID,',
'    p_component_type => wwv_flow_copy_metadata.c_build_option,',
'    p_app_id         => :FB_FLOW_ID )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Build Option cannot be deleted because it is part of a component group.'
,p_when_button_pressed=>wwv_flow_imp.id(68928811043648234)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(68931281860648255)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Build Option'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_f4000_util.update_build_option_references(',
'    p_build_option_id => :F4000_P235_ID,',
'    p_application_id  => :FB_FLOW_ID );',
'    ',
'delete wwv_flow_patches ',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and id                = :F4000_P235_ID;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(68928811043648234)
,p_process_success_message=>'Build Option Removed.'
,p_internal_uid=>68931281860648255
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4640072006698347)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Clear Subscriptions'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- when deleting the component, clear reference_id data from subscribing apps',
'--',
'wwv_flow_copy_metadata.clear_subscriptions (',
'    p_component_type => wwv_flow_copy_metadata.c_build_option,',
'    p_master_id      => :F4000_P235_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(68928811043648234)
,p_internal_uid=>4640072006698347
);
end;
/
prompt --application/pages/page_00238
begin
wwv_flow_imp_page.create_page(
 p_id=>238
,p_name=>'Create Breadcrumb Template - Creation Method'
,p_alias=>'CREATE-BREADCRUMB-TEMPLATE-CREATION-METHOD'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Breadcrumb Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(13969523414074532)
,p_plug_name=>'Create Breadcrumb Template'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>'<p>You can create templates from scratch or copy them from another application. Copying a template provides you with a framework that you can modify.</p> '
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(14261632075088500)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(106501409747300331)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(186381516995222024)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(13978319084082174)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(186381516995222024)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(13985114021090195)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(186381516995222024)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(19628203802864348)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(186381516995222024)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(14136003437250918)
,p_branch_action=>'240'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(13985114021090195)
,p_branch_sequence=>40
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND_TEXT'
,p_branch_condition=>'F4000_P238_TYPE'
,p_branch_condition_text=>'BLANK'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(14393112708310279)
,p_branch_action=>'241'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(13985114021090195)
,p_branch_sequence=>50
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND_TEXT'
,p_branch_condition=>'F4000_P238_TYPE'
,p_branch_condition_text=>'COPY'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(585127954462099842)
,p_branch_action=>'f?p=&APP_ID.:162:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(19628203802864348)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(13993128780102430)
,p_name=>'F4000_P238_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(13969523414074532)
,p_item_default=>'COPY'
,p_prompt=>'Create Breadcrumb Template:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'MENU_TEMPLATE_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(86077012626803751)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'N'
,p_escape_on_http_output=>'N'
,p_help_text=>'Select the method by which you wish to create a new breadcrumb template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(585127722299099840)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(13978319084082174)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(585127887333099841)
,p_event_id=>wwv_flow_imp.id(585127722299099840)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00240
begin
wwv_flow_imp_page.create_page(
 p_id=>240
,p_name=>'Create Breadcrumb Template - Name'
,p_alias=>'CREATE-BREADCRUMB-TEMPLATE-NAME'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Breadcrumb Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(14175805433447528)
,p_plug_name=>'Create Breadcrumb Template'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(14274001223118093)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(106501409747300331)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(186385628039272606)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(14181305971456820)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(186385628039272606)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(14189708180466946)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(186385628039272606)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(14183617745460281)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(186385628039272606)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(112031716983250230)
,p_branch_action=>'f?p=&FLOW_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(589886029832923005)
,p_branch_action=>'f?p=&APP_ID.:238:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(14183617745460281)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(112069011358267587)
,p_name=>'P240_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(14175805433447528)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identify the breadcrumb name.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(112072422786270823)
,p_name=>'P240_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(14175805433447528)
,p_prompt=>'Theme'
,p_source=>'P4003_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify theme.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(112074006987275731)
,p_name=>'P240_THEME_CLASS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(14175805433447528)
,p_prompt=>'Theme Class'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MENU THEME CLASS ID'
,p_lov=>'.'||wwv_flow_imp.id(43945521366272493)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify theme class.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(112075517723278843)
,p_validation_name=>'P240_NAME'
,p_validation_sequence=>10
,p_validation=>'P240_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(14189708180466946)
,p_associated_item=>wwv_flow_imp.id(112069011358267587)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(73942156428235930)
,p_validation_name=>'P240_NAME unique'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_menu_templates',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :workspace_id',
'   and theme_id          = :P240_THEME',
'   and name              = :P240_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#LABEL# must be unique.'
,p_when_button_pressed=>wwv_flow_imp.id(14189708180466946)
,p_associated_item=>wwv_flow_imp.id(112069011358267587)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(112076824649280811)
,p_validation_name=>'P240_THEME'
,p_validation_sequence=>30
,p_validation=>'P240_THEME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(14189708180466946)
,p_associated_item=>wwv_flow_imp.id(112072422786270823)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(112077931575282803)
,p_validation_name=>'P240_THEME_CLASS'
,p_validation_sequence=>40
,p_validation=>'P240_THEME_CLASS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(14189708180466946)
,p_associated_item=>wwv_flow_imp.id(112074006987275731)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(589885886073923003)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(14181305971456820)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(589885904729923004)
,p_event_id=>wwv_flow_imp.id(589885886073923003)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(14217027084862962)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Menu Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_imp_shared.create_menu_template (',
'    p_flow_id                  => :FB_FLOW_ID,',
'    p_name                     => :p240_name,',
'    p_before_first             => null,',
'    p_current_page_option      => ''#NAME#'',',
'    p_non_current_page_option  => ''<a href="#LINK#">#NAME#</a>'',',
'    p_menu_link_attributes     => null,',
'    p_between_levels           => ''&nbsp;&gt;&nbsp;'',',
'    p_after_last               => null,',
'    p_max_levels               => ''12'',',
'    p_start_with_node          => ''PARENT_TO_LEAF'',',
'    p_template_comments        => null,',
'    p_theme_id                 => :p240_theme,',
'    p_theme_class_id           => :p240_theme_class',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Template not created.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(14189708180466946)
,p_process_success_message=>'Template created.'
,p_internal_uid=>14217027084862962
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(589886105719923006)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(14189708180466946)
,p_process_success_message=>'Template created.'
,p_internal_uid=>589886105719923006
);
end;
/
prompt --application/pages/page_00241
begin
wwv_flow_imp_page.create_page(
 p_id=>241
,p_name=>'Create Breadcrumb Template - Copy From'
,p_alias=>'CREATE-BREADCRUMB-TEMPLATE-COPY-FROM'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Breadcrumb Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(14294921673154184)
,p_plug_name=>'Create Breadcrumb Template'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>'<p>Select the application that contains the templates you wish to copy.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(14405005147328943)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(320074633987)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(186382517472231644)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(14299931943164561)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(186382517472231644)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(14307302423174944)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(186382517472231644)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(14304726879172555)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(186382517472231644)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(154589123326372523)
,p_branch_action=>'f?p=&FLOW_ID.:415:&SESSION.::&DEBUG.:415::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(585128297727099845)
,p_branch_action=>'f?p=&APP_ID.:238:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(14304726879172555)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14312919048200907)
,p_name=>'F4000_P241_COPY_FROM_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(14294921673154184)
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Copy From Application'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select an Application -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select the application from which you wish to copy the template.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(14316405677207154)
,p_validation_name=>'F4000_P241_COPY_FROM_FLOW_ID Not Null'
,p_validation_sequence=>1
,p_validation=>'F4000_P241_COPY_FROM_FLOW_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Copy From Application must be specified.'
,p_associated_item=>wwv_flow_imp.id(14312919048200907)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 06-MAY-2002 14:33'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(585128061850099843)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(14299931943164561)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(585128114394099844)
,p_event_id=>wwv_flow_imp.id(585128061850099843)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00242
begin
wwv_flow_imp_page.create_page(
 p_id=>242
,p_name=>'Create Breadcrumb Template - New Templates'
,p_alias=>'CREATE-BREADCRUMB-TEMPLATE-NEW-TEMPLATES'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Breadcrumb Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(14328329375226565)
,p_name=>'Create Breadcrumb Template'
,p_template=>wwv_flow_imp.id(42025417508627628)
,p_display_sequence=>100
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  id,',
'  flow_id, ',
'  NAME from_name, ',
'  wwv_flow_lang.system_message(''F4000.P158.COPY_OF'',name) to_name,    ',
'  ''N'' sub  ',
'  from wwv_flow_menu_templates ',
'  where flow_id = :F4000_P241_COPY_FROM_FLOW_ID ',
'  and security_group_id = :flow_security_group_id ',
'  and theme_id = :P415_COPY_FROM_THEME '))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'<font class="fielddata">No menu template found.</font>'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(289924820743181091)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(289924904419181091)
,p_query_column_id=>2
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>2
,p_column_heading=>'Application'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(289925026455181091)
,p_query_column_id=>3
,p_column_alias=>'FROM_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'From Name'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(289925102472181092)
,p_query_column_id=>4
,p_column_alias=>'TO_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'To Name'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>40
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(289925221463181092)
,p_query_column_id=>5
,p_column_alias=>'SUB'
,p_column_display_sequence=>5
,p_column_heading=>'Copy?'
,p_use_as_row_header=>'N'
,p_display_as=>'SELECT_LIST_FROM_LOV'
,p_named_lov=>wwv_flow_imp.id(150847232623403358)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'NO'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(14407300618331077)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(320074633987)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(186384617042250444)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(14333306326232888)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(186384617042250444)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(14344019270246074)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(186384617042250444)
,p_button_name=>'Copy'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy Breadcrumb Template'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(14335916368235731)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(186384617042250444)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(154595529953402877)
,p_branch_action=>'f?p=&FLOW_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(589885623218923001)
,p_branch_action=>'f?p=&APP_ID.:415:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(14335916368235731)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(74799021851635044)
,p_name=>'P242_THEME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(14328329375226565)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&P415_COPY_TO_THEME.'
,p_prompt=>'Copy to Theme:'
,p_source=>'P415_COPY_TO_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies a collection of templates which define the look and feel of the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(150693609086071855)
,p_validation_name=>'MustSelectOne'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'begin',
'  for i in 1..wwv_flow.g_f01.count loop',
'    if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'') then',
'      return true;',
'    end if;',
'  end loop;',
'  return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'You must select at least one template to be copied.'
,p_when_button_pressed=>wwv_flow_imp.id(14344019270246074)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(106471827081351272)
,p_validation_name=>'TemplateNameNotNull'
,p_validation_sequence=>15
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'begin',
'  for i in 1..wwv_flow.g_f01.count loop',
'    if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'') then',
'      if wwv_flow.g_f02(i) is null then',
'        return false;',
'      end if;',
'    end if;',
'  end loop;',
'  return true;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'You must supply a template name for all templates chosen to be copied.'
,p_when_button_pressed=>wwv_flow_imp.id(14344019270246074)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(290023816157198599)
,p_validation_name=>'NoDupeNames'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_found_name varchar2(2000) := null;',
'begin',
'for i in 1..wwv_flow.g_f01.count loop',
'   if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'')',
'      then',
'      for c1 in ( select name',
'                  from wwv_flow_menu_templates ',
'                  where flow_id = :FB_FLOW_ID',
'                  and security_group_id = (select PROVISIONING_COMPANY_ID',
'                                           from wwv_flow_companies',
'                                           where SHORT_NAME = :COMPANY)',
'                  and name = wwv_flow.g_f02(i) ) loop',
'         if c1.name is not null then ',
'            if l_found_name is null then ',
'              l_found_name := c1.name;',
'            else ',
'              l_found_name := l_found_name||'', ''||c1.name;',
'            end if;',
'         end if;',
'      end loop;',
'   end if;',
'end loop;',
'',
'if l_found_name is not null then ',
'return wwv_flow_lang.system_message(''F4000.TEMPLATE_NAME_ALREADY_EXISTS'',',
'                                    l_found_name);',
'end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_when_button_pressed=>wwv_flow_imp.id(14344019270246074)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(585128652833099849)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(14333306326232888)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(585128729853099850)
,p_event_id=>wwv_flow_imp.id(585128652833099849)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(14419108154342723)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'copy menu templates'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_template_id number;',
'begin',
'',
'for i in 1..wwv_flow.g_f01.count loop',
'  l_template_id := wwv_flow_id.next_val;',
'',
'  if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'') then',
'    wwv_flow_templates_util.copy_menu_template (',
'      p_copy_from_flow_id    => :F4000_P241_COPY_FROM_FLOW_ID,',
'      p_flow_id              => :FB_FLOW_ID,',
'      p_from_template_id     => wwv_flow.g_f01(i),',
'      p_to_template_name     => wwv_flow.g_f02(i),',
'      p_to_template_id       => l_template_id,',
'      p_to_theme_id          => :p242_theme,',
'      p_include_subscription => (wwv_flow.g_f03(i)=''SUBSCRIBE''));',
'    if wwv_flow.g_f03(i) in (''SUBSCRIBE'') then',
'      wwv_flow_copy_metadata.subscribe_menu_template (',
'        p_master_template_id         => wwv_flow.g_f01(i),',
'        p_subscribing_template_id    => l_template_id',
'      );',
'    end if;',
'  end if;',
'end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying breadcrumb template(s).'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(14344019270246074)
,p_process_success_message=>'Breadcrumb template(s) copied.'
,p_internal_uid=>14419108154342723
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(589885733937923002)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(14344019270246074)
,p_process_success_message=>'Breadcrumb template(s) copied.'
,p_internal_uid=>589885733937923002
);
end;
/
prompt --application/pages/page_00246
begin
wwv_flow_imp_page.create_page(
 p_id=>246
,p_name=>'Item Finder'
,p_alias=>'ITEM-FINDER1'
,p_step_title=>'Item Finder'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function passBack(pValue)',
'{',
'  var lTargetField = window.opener.document.getElementById($v(''F4000_P246_CALLING_FIELD''));',
'  try {',
'    if ($v(''P246_APPEND'') === ''Y'') {',
'      opener.$s(lTargetField, lTargetField.value + ((lTargetField.value != "")?",":"") + pValue);',
'    } else {',
'      opener.$s(lTargetField, pValue);',
'    }',
'  } catch(e) {}',
'  lTargetField.focus();',
'  close();',
'};'))
,p_step_template=>wwv_flow_imp.id(19943204431962826)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_item.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(14708111879935279)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>100
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(14709513852935304)
,p_name=>'Items'
,p_template=>wwv_flow_imp.id(208928010704475743)
,p_display_sequence=>140
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name1 , t.msg t, 0 p',
'from wwv_flow_items, (select wwv_flow_lang.system_message(''F4000.APPLICATION_ITEM'') msg from dual) t',
'where (instr(name,upper(:F4000_P246_SEARCH)) > 0 OR :F4000_P246_SEARCH IS NULL) and',
'   :F4000_P246_PAGE is null',
'and flow_id = :fb_flow_id',
'union all',
'select ''<a href="javascript:passBack(''||wwv_flow_escape.js_literal(name)||'');">''||wwv_flow_escape.html(name)||''</a>'' name1 , t.msg t, flow_step_id p',
'from wwv_flow_step_items, (select wwv_flow_lang.system_message(''F4000.PAGE_ITEM'') msg from dual) t',
'where (instr(name,upper(:F4000_P246_SEARCH)) > 0 OR :F4000_P246_SEARCH IS NULL) and',
'   (:F4000_P246_PAGE is null or :F4000_P246_PAGE = flow_step_id)',
'and flow_id = :fb_flow_id',
'order by 1'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_num_rows_item=>'F4000_P246_MAX_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48614319501771198)
,p_query_column_id=>1
,p_column_alias=>'NAME1'
,p_column_display_sequence=>1
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48614431969771198)
,p_query_column_id=>2
,p_column_alias=>'T'
,p_column_display_sequence=>2
,p_column_heading=>'Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48614511956771198)
,p_query_column_id=>3
,p_column_alias=>'P'
,p_column_display_sequence=>3
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(14709231916935300)
,p_button_sequence=>119
,p_button_plug_id=>wwv_flow_imp.id(14708111879935279)
,p_button_name=>'F4000_P246_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Go'
,p_button_alignment=>'LEFT-CENTER'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(14711003638935348)
,p_branch_action=>'246'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>119
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6543623047119484)
,p_name=>'P246_APPEND'
,p_item_sequence=>129
,p_item_plug_id=>wwv_flow_imp.id(14709513852935304)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14708325447935287)
,p_name=>'F4000_P246_SEARCH'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(14708111879935279)
,p_prompt=>'Search'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_new_grid=>true
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Enter a case insensitive query and click <strong>Go</strong>. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14708614977935296)
,p_name=>'F4000_P246_PAGE'
,p_item_sequence=>22
,p_item_plug_id=>wwv_flow_imp.id(14708111879935279)
,p_item_default=>'FB_FLOW_PAGE_ID'
,p_item_default_type=>'ITEM'
,p_prompt=>'Page'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d',
'  from wwv_flow_steps',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and is_page_pattern   = ''N''',
'order by 2'))
,p_cSize=>6
,p_cMaxlength=>2000
,p_new_grid=>true
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies the application page number. To change the page number, select or enter a new number and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14708917076935296)
,p_name=>'F4000_P246_MAX_ROWS'
,p_item_sequence=>23
,p_item_plug_id=>wwv_flow_imp.id(14708111879935279)
,p_item_default=>'15'
,p_prompt=>'Rows'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAXIMUM ROWS PER PAGE'
,p_lov=>'.'||wwv_flow_imp.id(84800803131139158)||'.'
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_new_grid=>true
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Select the number of rows to display and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14718624586974892)
,p_name=>'F4000_P246_CALLING_FIELD'
,p_item_sequence=>109
,p_item_plug_id=>wwv_flow_imp.id(14709513852935304)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1410028720582325)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P246_PAGE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'     if REGEXP_LIKE(:F4000_P246_PAGE,''^[0-9]*$'')  then  ',
'        return :F4000_P246_PAGE;',
'     else',
'         return null;',
'     end if;',
'exception when others then ',
'   return null;',
'end ;'))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(14711323676935353)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pg'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>14711323676935353
);
end;
/
prompt --application/pages/page_00249
begin
wwv_flow_imp_page.create_page(
 p_id=>249
,p_name=>'Region Attributes'
,p_alias=>'REGION-ATTRIBUTES'
,p_step_title=>'Region Attributes'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(11501804013545635)
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_region.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1223327285547695)
,p_plug_name=>'Region Attributes'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>140
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select page_id, ',
'       (select name from wwv_flow_steps ',
'        where flow_id = p.flow_id and id = p.page_id) page_name,',
'       plug_header region_header,',
'       plug_footer region_footer,',
'       id region_id,',
'       p.flow_id application_id, ',
'       p.plug_name region_name,',
'       p.PLUG_SOURCE_TYPE,',
'   decode(replace(replace(',
'     PLUG_DISPLAY_CONDITION_TYPE,''%''||''null%'',null),''0'',null),',
'      null,''No'',''Yes'') is_conditional,',
'decode(plug_source_type,',
'''NATIVE_SQL_REPORT'',''SQL Report'',',
'''NATIVE_TABFORM'',''Tabular Form'',',
'''NATIVE_IR'',''Interactive Report'',',
'null) report_type,',
'decode(plug_source_type,',
'''NATIVE_SQL_REPORT'',''Yes'',',
'''NATIVE_TABFORM'',''Yes'',',
'''NATIVE_IR'',''Yes'',',
'''No'') is_report,',
'       p.PLUG_DISPLAY_SEQUENCE display_sequence,',
'       (select	 WWV_FLOW_ROW_TEMPLATES.ROW_TEMPLATE_NAME',
'        from     WWV_FLOW_ROW_TEMPLATES',
'        where    WWV_FLOW_ROW_TEMPLATES.ID = p.plug_query_row_template)',
'       report_template,',
'       p.plug_query_row_template report_template_id,',
'       PRN_OUTPUT,',
'       last_updated_on,',
'       last_updated_by,',
'       sys.dbms_lob.getlength(PLUG_SOURCE) source_size,',
'       sys.dbms_lob.substr(plug_source,50,1) source_snipit,',
'   PLUG_DISPLAY_POINT display_position,',
'   (select name from wwv_flow_templates where id = (select max(STEP_TEMPLATE) from wwv_flow_steps where flow_id = p.flow_id and id = p.page_id)) page_template',
'from wwv_flow_page_plugs p',
'where flow_id = :fb_flow_id',
'      and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(1223405038547695)
,p_name=>'Region Attributes'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1223610599547698)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Page'
,p_column_link=>'f?p=&FLOW_ID.:4500:#FLOW_SESSION#::::FB_FLOW_PAGE_ID:#PAGE_ID#'
,p_column_linktext=>'#PAGE_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1223815780547698)
,p_db_column_name=>'REGION_FOOTER'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Region Footer'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1223927577547698)
,p_db_column_name=>'REGION_ID'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Region ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1224029724547699)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1224130858547699)
,p_db_column_name=>'REGION_NAME'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Region Name'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE_ID##5110:#REGION_ID#'
,p_column_linktext=>'#REGION_NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1224215307547702)
,p_db_column_name=>'PLUG_SOURCE_TYPE'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Source Type'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(32361488916)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1224318844547702)
,p_db_column_name=>'DISPLAY_SEQUENCE'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Display Sequence'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1224412359547702)
,p_db_column_name=>'REPORT_TEMPLATE'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Report Template'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1224529572547702)
,p_db_column_name=>'REPORT_TEMPLATE_ID'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Report Template Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1224626388547702)
,p_db_column_name=>'PRN_OUTPUT'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Print Output'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1224715409547703)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1224805190547703)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1225215852554774)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Page Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1230724631841096)
,p_db_column_name=>'REGION_HEADER'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'Region Header'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1230816914841096)
,p_db_column_name=>'SOURCE_SIZE'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Source Size'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1230904790841096)
,p_db_column_name=>'SOURCE_SNIPIT'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Source'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1235810226922130)
,p_db_column_name=>'DISPLAY_POSITION'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Slot'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1235906069922130)
,p_db_column_name=>'PAGE_TEMPLATE'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Page Template'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1240715514980441)
,p_db_column_name=>'REPORT_TYPE'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Report Type'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1240811411980442)
,p_db_column_name=>'IS_REPORT'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>'Is Report'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1247600763061274)
,p_db_column_name=>'IS_CONDITIONAL'
,p_display_order=>22
,p_column_identifier=>'V'
,p_column_label=>'Is Conditional'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(1225317930555377)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1287224035536643'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'PAGE_ID:DISPLAY_SEQUENCE:REGION_NAME:REGION_SOURCE:REGION_FOOTER:PLUG_SOURCE_TYPE:REGION_HEADER:SOURCE_SIZE:SOURCE_SNIPIT:DISPLAY_POSITION'
,p_sort_column_1=>'PAGE_ID'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'DISPLAY_SEQUENCE'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193874805040575317)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>100
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(13987931263515071)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(193878400024611659)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1223327285547695)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:249:&SESSION.::&DEBUG.:249,RIR::'
);
end;
/
prompt --application/pages/page_00251
begin
wwv_flow_imp_page.create_page(
 p_id=>251
,p_name=>'Edit List of Values Template'
,p_alias=>'EDIT-LIST-OF-VALUESTEMPLATE'
,p_step_title=>'Edit Popup List of Values Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_read_only_when_type=>'EXISTS'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_popup_lov_template t, wwv_flow_themes th',
'where t.id                 = :F4000_P251_ID',
'  and t.flow_id            = th.flow_id',
'  and t.theme_id           = th.theme_id',
'  and t.security_group_id  = :workspace_id',
'  and th.security_group_id = t.security_group_id',
'  and t.reference_id      is not null',
'  and th.reference_id     is not null'))
,p_help_text=>'ui_templt_lov.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4546234880032501)
,p_plug_name=>'Landmark for Displayed Regions '
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_landmark_type=>'region'
,p_landmark_label=>'Displayed Regions'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6461528787495835)
,p_plug_name=>'Search Field'
,p_region_name=>'SEARCH'
,p_parent_plug_id=>wwv_flow_imp.id(4546234880032501)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>5000
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_no_data_found=>'<font class="fielddata">No Utilization found.</font>'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_break_cols=>'1'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'Region generated 26-APR-2002 16:27:53'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6579903580847814)
,p_plug_name=>'Icon'
,p_region_name=>'ICON'
,p_parent_plug_id=>wwv_flow_imp.id(4546234880032501)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6598112829873957)
,p_plug_name=>'Buttons'
,p_region_name=>'BUTTON'
,p_parent_plug_id=>wwv_flow_imp.id(4546234880032501)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6599410672874927)
,p_plug_name=>'Window'
,p_region_name=>'WINDOW'
,p_parent_plug_id=>wwv_flow_imp.id(4546234880032501)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6617813679888708)
,p_plug_name=>'Pagination'
,p_region_name=>'PAGE'
,p_parent_plug_id=>wwv_flow_imp.id(4546234880032501)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6624928116897254)
,p_plug_name=>'Page Attributes'
,p_region_name=>'PG'
,p_parent_plug_id=>wwv_flow_imp.id(4546234880032501)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>25
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'L:L:L:R:R:L'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7782616425041280)
,p_plug_name=>'Application'
,p_region_name=>'A'
,p_parent_plug_id=>wwv_flow_imp.id(4546234880032501)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11655301433858148)
,p_plug_name=>'Result Set'
,p_region_name=>'RS'
,p_parent_plug_id=>wwv_flow_imp.id(4546234880032501)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(33422401163164175)
,p_plug_name=>'Subscription'
,p_region_name=>'SUBSCRIPTION'
,p_parent_plug_id=>wwv_flow_imp.id(4546234880032501)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'IS_NOT_READ_ONLY'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'WWV_FLOW_POPUP_LOV_TEMPLATE',
  'attribute_02', 'wwv_flow_lang.system_message(''SUBSCRIBE_TEMPLATE.POPUP_LOV'')',
  'attribute_03', 'F4000_P251_ID',
  'attribute_04', 'F4000_P251_REFERENCE_ID',
  'attribute_05', 'SUBSCRIBE_TEMPLATE')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1660132543413741832)
,p_plug_name=>'Subscription'
,p_parent_plug_id=>wwv_flow_imp.id(4546234880032501)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>25
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'This template is subscribed to the corresponding template in the master theme. To modify this template, edit the master template and then refresh the theme. Alternatively you can create a local, unsubscribed copy of this template. Unsubscribed templa'
||'tes are editable and will not get overwritten by a theme refresh. '
,p_plug_query_num_rows=>15
,p_plug_display_condition_type=>'IS_READ_ONLY'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6571310709829366)
,p_plug_name=>'Edit Popup List of Values Template'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--accessibleTitle'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>130
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_landmark_label=>'Popup LOV Template Actions'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6693421116022054)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>This template controls how Popup Lists of Values display in this application for all items of type Popup LOV.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46189705609907184)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>140
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(92864020833518069)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(92837202675352059)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(617461808376035864)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(29434107863295859)
,p_plug_display_sequence=>100
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from  WWV_FLOW_POPUP_LOV_TEMPLATE',
'where id = :F4000_P251_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :F4000_P251_ID,',
'      p_component_type => ''PopUp LOV Template'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(13150422632483322)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(33422401163164175)
,p_button_name=>'PUBLISH_TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Publish Template'
,p_button_position=>'COPY'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.::F4000_P149_ID,F4000_P149_PAGE_ID,F4000_P149_TEMPLATE_TYPE:&F4000_P251_ID.,&FLOW_PAGE_ID.,POPUP_LOV_TEMPLATE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_popup_lov_template',
' where reference_id      = :F4000_P251_ID',
'   and security_group_id = :workspace_id'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(13134411073470549)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(33422401163164175)
,p_button_name=>'COPY_TEMPLATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Refresh'
,p_button_position=>'COPY'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_popup_lov_template',
' where id                = :F4000_P251_ID',
'   and security_group_id = :workspace_id',
'   and reference_id     is not null'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(6461810453495837)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(6571310709829366)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(6461903905495837)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(6571310709829366)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P251_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(11474930400495249)
,p_branch_action=>'251'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND_TEXT'
,p_branch_condition=>'F4000_P251_RTP'
,p_branch_condition_text=>'YES'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(13225603315583410)
,p_branch_action=>'251'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(13134411073470549)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(362990217517450053)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6463032173495845)
,p_name=>'F4000_P251_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(6461528787495835)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6463313051495848)
,p_name=>'F4000_P251_POPUP_ICON'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(6579903580847814)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Popup Icon'
,p_source=>'POPUP_ICON'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify an icon to display to the right of a form field for items of type POPUP. By default, the &PRODUCT_NAME. engine uses a CSS-based default icon.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6463625593495850)
,p_name=>'F4000_P251_POPUP_ICON_ATTR'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(6579903580847814)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Popup Icon Attr'
,p_source=>'POPUP_ICON_ATTR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify image attributes (such as height and width) used to display the Popup Icon.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6463931078495851)
,p_name=>'F4000_P251_PAGE_NAME'
,p_item_sequence=>360
,p_item_plug_id=>wwv_flow_imp.id(6624928116897254)
,p_use_cache_before_default=>'NO'
,p_source=>'PAGE_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6464200077495853)
,p_name=>'F4000_P251_PAGE_TITLE'
,p_item_sequence=>370
,p_item_plug_id=>wwv_flow_imp.id(6624928116897254)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Page Title'
,p_source=>'PAGE_TITLE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Defines the title of the popup page. This is the TITLE HTML page header attribute.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6464523496495855)
,p_name=>'F4000_P251_PAGE_HTML_HEAD'
,p_item_sequence=>380
,p_item_plug_id=>wwv_flow_imp.id(6624928116897254)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Page HTML Head'
,p_source=>'PAGE_HTML_HEAD'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Defines text to be included in the popup LOV page header. Use this area to include style sheets.  For example:',
'',
'<pre>',
'&lt;link rel="stylesheet" href="&#35;IMAGE_PREFIX&#35;platform2.css" type="text/css"&gt;',
'#THEME_CSS#',
'</pre>',
'</p>',
'',
'<p>The following substitution strings are supported:',
'',
'<ul>',
'<li>#THEME_CSS#</li>',
'</ul>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6464814784495856)
,p_name=>'F4000_P251_PAGE_BODY_ATTR'
,p_item_sequence=>390
,p_item_plug_id=>wwv_flow_imp.id(6624928116897254)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Page Body Attributes'
,p_source=>'PAGE_BODY_ATTR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>255
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Defines text that is added into the popup list of values HTML BODY.  Note the page includes a JavaScript called <code>first_field</code>.  For example: <pre>bgcolor="white" OnLoad="first_field()"</pre>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6465126989495857)
,p_name=>'F4000_P251_BEFORE_FIELD_TEXT'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(6461528787495835)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Before Field Text'
,p_source=>'BEFORE_FIELD_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Defines text to display before the popup list of values search field displays. For example:</div>',
'<pre>Search&lt;br&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6465406682495859)
,p_name=>'F4000_P251_FILTER_WIDTH'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(6461528787495835)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Filter Width'
,p_source=>'FILTER_WIDTH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Display the HTML INPUT TYPE = TEXT widget using this width.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6465709785495860)
,p_name=>'F4000_P251_FILTER_MAX_WIDTH'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(6461528787495835)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Filter Max Width'
,p_source=>'FILTER_MAX_WIDTH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Display the HTML INPUT TYPE = TEXT widget using this maximum width.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6466008764495862)
,p_name=>'F4000_P251_FILTER_TEXT_ATTR'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(6461528787495835)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Filter Text Attributes'
,p_source=>'FILTER_TEXT_ATTR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Display the HTML INPUT TYPE = TEXT widget using these attributes.  This will be included within the HTML input tag.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6466311744495863)
,p_name=>'F4000_P251_FIND_BUTTON_TEXT'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(6598112829873957)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Find Button Text'
,p_source=>'FIND_BUTTON_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Defines text that displays on the name of the button used to search on the popup page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6466604290495865)
,p_name=>'F4000_P251_FIND_BUTTON_IMAGE'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(6598112829873957)
,p_use_cache_before_default=>'NO'
,p_source=>'FIND_BUTTON_IMAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6466925590495866)
,p_name=>'F4000_P251_FIND_BUTTON_ATTR'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(6598112829873957)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Find Button Attributes'
,p_source=>'FIND_BUTTON_ATTR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct rtrim(BUTTON_CATTRIBUTES) ba, rtrim(BUTTON_CATTRIBUTES) r',
'  from wwv_flow_step_buttons',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :workspace_id',
' order by 1'))
,p_cSize=>80
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Defines additional attributes for the Find button.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6467218582495868)
,p_name=>'F4000_P251_CLOSE_BUTTON_TEXT'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(6598112829873957)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Close Button Text'
,p_source=>'CLOSE_BUTTON_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Defines the name of the close button. The close button dismisses the popup list of values page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6467511855495869)
,p_name=>'F4000_P251_CLOSE_BUTTON_IMAGE'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(6598112829873957)
,p_use_cache_before_default=>'NO'
,p_source=>'CLOSE_BUTTON_IMAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6467829509495871)
,p_name=>'F4000_P251_CLOSE_BUTTON_ATTR'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_imp.id(6598112829873957)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Close Button Attributes'
,p_source=>'CLOSE_BUTTON_ATTR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct rtrim(BUTTON_CATTRIBUTES) ba, rtrim(BUTTON_CATTRIBUTES) r',
'  from wwv_flow_step_buttons',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :workspace_id',
' order by 1'))
,p_cSize=>80
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Defines additional attributes of the Close button.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6468112415495872)
,p_name=>'F4000_P251_NEXT_BUTTON_TEXT'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_imp.id(6598112829873957)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Next Button Text'
,p_source=>'NEXT_BUTTON_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Defines the name of the Next button used when paginating result sets.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6468400865495874)
,p_name=>'F4000_P251_NEXT_BUTTON_IMAGE'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_imp.id(6598112829873957)
,p_use_cache_before_default=>'NO'
,p_source=>'NEXT_BUTTON_IMAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6468719065495875)
,p_name=>'F4000_P251_NEXT_BUTTON_ATTR'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_imp.id(6598112829873957)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Next Button Attr'
,p_source=>'NEXT_BUTTON_ATTR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct rtrim(BUTTON_CATTRIBUTES) ba, rtrim(BUTTON_CATTRIBUTES) r',
'  from wwv_flow_step_buttons',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :workspace_id',
' order by 1'))
,p_cSize=>80
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Defines additional attributes for the Next button.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6469027954495877)
,p_name=>'F4000_P251_PREV_BUTTON_TEXT'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_imp.id(6598112829873957)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Previous Button Text'
,p_source=>'PREV_BUTTON_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Defines the name of Previous page button. This button is used to paginate result sets.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6469302467495879)
,p_name=>'F4000_P251_PREV_BUTTON_IMAGE'
,p_item_sequence=>260
,p_item_plug_id=>wwv_flow_imp.id(6598112829873957)
,p_use_cache_before_default=>'NO'
,p_source=>'PREV_BUTTON_IMAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6469622652495880)
,p_name=>'F4000_P251_PREV_BUTTON_ATTR'
,p_item_sequence=>270
,p_item_plug_id=>wwv_flow_imp.id(6598112829873957)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Previous Button Attributes'
,p_source=>'PREV_BUTTON_ATTR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct rtrim(BUTTON_CATTRIBUTES) ba, rtrim(BUTTON_CATTRIBUTES) r',
'  from wwv_flow_step_buttons',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :workspace_id',
' order by 1'))
,p_cSize=>80
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Defines additional attributes of the Previous button.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6469906873495881)
,p_name=>'F4000_P251_AFTER_FIELD_TEXT'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(6461528787495835)
,p_use_cache_before_default=>'NO'
,p_prompt=>'After Field Text'
,p_source=>'AFTER_FIELD_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Display this text after displaying the search field, the search button, and the close button.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6470217455495883)
,p_name=>'F4000_P251_SCROLLBARS'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_imp.id(6599410672874927)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Scroll Bars'
,p_source=>'SCROLLBARS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Popup lists of values are executed using JavaScript. Use this attribute to control the values of <code>scrollbars=</code>. The default value is 1. Other valid values include 1 and 0.  A value of zero (0) indicates that the popup dialog window is not '
||'scrollable.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6470527953495884)
,p_name=>'F4000_P251_RESIZABLE'
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_imp.id(6599410672874927)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Resizable'
,p_source=>'RESIZABLE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Popup lists of values are executed using JavaScript. Use this attribute to control the value of <code>resizable=</code>.  The default value is 1. Other valid values include 1 and 0.  A value of zero indicates that the popup dialog window is not resiz'
||'able.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6470809525495886)
,p_name=>'F4000_P251_WIDTH'
,p_item_sequence=>300
,p_item_plug_id=>wwv_flow_imp.id(6599410672874927)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Width'
,p_source=>'WIDTH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Popup lists of values are executed using JavaScript. Use this attribute to control the values of <code>width=</code>. The default value is 450.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6471126752495887)
,p_name=>'F4000_P251_HEIGHT'
,p_item_sequence=>310
,p_item_plug_id=>wwv_flow_imp.id(6599410672874927)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Height'
,p_source=>'HEIGHT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Popup lists of values are executed using JavaScript. Use this attribute to control the values of <code>height=</code>. The default is 400.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6471400957495889)
,p_name=>'F4000_P251_RESULT_ROW_X_OF_Y'
,p_item_sequence=>320
,p_item_plug_id=>wwv_flow_imp.id(6617813679888708)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Result Row X Of Y'
,p_source=>'RESULT_ROW_X_OF_Y'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Defines how row count results display. Use the substitution strings #FIRST_ROW# and #LAST_ROW#.',
'</p>',
'<p>For Example</p>',
'<pre>#FIRST_ROW# - #LAST_ROW#</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6471712271495890)
,p_name=>'F4000_P251_RESULT_ROWS_PER_PG'
,p_item_sequence=>330
,p_item_plug_id=>wwv_flow_imp.id(6617813679888708)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Display'
,p_source=>'RESULT_ROWS_PER_PG'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Defines the number of rows per page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9448702712976950)
,p_name=>'F4000_P251_PAGE_HEADING_TEXT'
,p_item_sequence=>400
,p_item_plug_id=>wwv_flow_imp.id(6624928116897254)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Page Heading Text'
,p_source=>'PAGE_HEADING_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Defines text to display after opening the form, but before displaying any text. This text comes before the before field text.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9449530520979254)
,p_name=>'F4000_P251_PAGE_FOOTER_TEXT'
,p_item_sequence=>410
,p_item_plug_id=>wwv_flow_imp.id(6624928116897254)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Page Footer Text'
,p_source=>'PAGE_FOOTER_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Defines text to display after displaying the popup page including the search list results.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11471714238487514)
,p_name=>'F4000_P251_RTP'
,p_item_sequence=>420
,p_item_plug_id=>wwv_flow_imp.id(6693421116022054)
,p_prompt=>'Stay on page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select this checkbox to stay on this page after applying changes.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'YES'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11732328963936560)
,p_name=>'F4000_P251_AFTER_RESULT_SET'
,p_item_sequence=>350
,p_item_plug_id=>wwv_flow_imp.id(11655301433858148)
,p_use_cache_before_default=>'NO'
,p_prompt=>'After Result Set'
,p_source=>'AFTER_RESULT_SET'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Display this text after displaying the result set. The result set is the result of the list of values query.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11750522900969722)
,p_name=>'F4000_P251_BEFORE_RESULT_SET'
,p_item_sequence=>340
,p_item_plug_id=>wwv_flow_imp.id(11655301433858148)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Before Result Set'
,p_source=>'BEFORE_RESULT_SET'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Display this text before displaying the result set. The result set is the result of the list of values query.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(13162025590497159)
,p_name=>'F4000_P251_REFERENCE_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(33422401163164175)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Reference Master Template From'
,p_source=>'REFERENCE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FLOW_SUBSCRIBE_FROM_POPUPLOV_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- '' || lower(wwv_flow_lang.system_message(''NO_TEMPLATE'')) || '' -'' d, ',
'       0 r',
'  from sys.dual',
' union all',
'select flow_id||'' : ''||',
'       lower(wwv_flow_lang.system_message(''POPUP_LOV''))||'' ''||',
'       lower(wwv_flow_lang.system_message(''TEMPLATE''))||decode(theme_id,null,'''','' (''||theme_id||'')'') d,',
'       id r',
'  from wwv_flow_popup_lov_template',
' where flow_id != nvl(:fb_flow_id,0)',
'   and security_group_id = :WORKSPACE_ID',
'   and flow_id          in ( select f.id',
'                               from wwv_flow_visible_flows f',
'                              where build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'                                and security_group_id = :WORKSPACE_ID )',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">You may select an existing template in this workspace or another template in your workspace''s schema. By selecting an existing template, you become a subscriber to that template.</div>',
'<div class="htmldbInfoBodyP">To load a new copy of any master template, click <span class="fielddatabold">Refresh Template</span>.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(15972308994805131)
,p_name=>'P251_POPUP_ICON2'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(6579903580847814)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Popup Color Picker Icon'
,p_source=>'POPUP_ICON2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify an icon to display to the right of a form field for items of type Popup Color Picker. By default, the &PRODUCT_NAME. engine shows a color palette icon.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(15973216266807314)
,p_name=>'P251_POPUP_ICON_ATTR2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(6579903580847814)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Popup Color Picker Icon Attr'
,p_source=>'POPUP_ICON_ATTR2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify image attributes (such as height and width) used to display the Popup Color Picker Icon.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(24158632433573402)
,p_name=>'P251_TRANSLATABLE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(7782616425041280)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Translatable'
,p_source=>'TRANSLATE_THIS_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Indicate if this list of values template is translatable.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(35517702471777425)
,p_name=>'F4000_P251_REFRESH'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(33422401163164175)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Refresh'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from  WWV_FLOW_POPUP_LOV_TEMPLATE',
' where reference_id     is null',
'   and id                = :F4000_P251_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identify template refresh preference.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(58972605368321642)
,p_name=>'P251_THEME_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(7782616425041280)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Theme:'
,p_source=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Indicates the theme to which the template is a member'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(59399317937875688)
,p_name=>'P251_THEME_CLASS_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(7782616425041280)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Template Class'
,p_source=>'THEME_CLASS_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'POPUP LOV TEMPLATE THEME CLASS ID'
,p_lov=>'.'||wwv_flow_imp.id(59418530750879398)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Identifies a specific usage for this template.</div>',
'<div class="htmldbInfoBodyP">When you switch to a new theme, all templates in one theme are assigned to corresponding templates in another theme. App Builder accomplishes this template mapping through the assignment of template class identifiers.<p /'
||'>',
'Use the <strong>Translatable</strong> check box to indicate if this template contains text strings that require translation.',
'</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(35524002675792473)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P251_REFRESH'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'Unable to compute item value.'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(13200930513540445)
,p_validation_name=>'reference id not null'
,p_validation_sequence=>10
,p_validation=>'F4000_P251_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Reference ID must be specified to refresh the template.'
,p_when_button_pressed=>wwv_flow_imp.id(13134411073470549)
,p_associated_item=>wwv_flow_imp.id(13162025590497159)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(13205914985547651)
,p_validation_name=>'reference id not zero'
,p_validation_sequence=>20
,p_validation=>'F4000_P251_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_ZERO'
,p_error_message=>'Template to refresh must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(13134411073470549)
,p_associated_item=>wwv_flow_imp.id(13162025590497159)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3001826673333516)
,p_name=>'Show Publish Success Msg'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(13150422632483322)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3001989094333517)
,p_event_id=>wwv_flow_imp.id(3001826673333516)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ( this.data.successMessage ) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(6472104708495893)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_POPUP_LOV_TEMPLATE'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_POPUP_LOV_TEMPLATE'
,p_attribute_03=>'F4000_P251_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error fetching row.'
,p_internal_uid=>6472104708495893
,p_process_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(13216008072566081)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'referesh template 1'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_popuplov_template (',
'    p_master_template_id         => :F4000_P251_REFERENCE_ID,',
'    p_subscribing_template_id    => :F4000_P251_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying template.'
,p_process_when_button_id=>wwv_flow_imp.id(13134411073470549)
,p_process_when=>'F4000_P251_REFERENCE_ID'
,p_process_when_type=>'VALUE_OF_ITEM_IN_COND_1_NOT_EQ_COND_2'
,p_process_when2=>'0'
,p_process_success_message=>'Template copied.'
,p_internal_uid=>13216008072566081
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(6472416068495897)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_POPUP_LOV_TEMPLATE'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_POPUP_LOV_TEMPLATE'
,p_attribute_03=>'F4000_P251_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'U'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error processing row.'
,p_process_when=>'COPY_TEMPLATE'
,p_process_when_type=>'REQUEST_NOT_IN_CONDITION'
,p_process_success_message=>'Action processed.'
,p_internal_uid=>6472416068495897
,p_process_comment=>'Generated 26-APR-2002 16:27:53'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(35528815818801571)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh template 2'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_popuplov_template (',
'    p_master_template_id         => :F4000_P251_REFERENCE_ID,',
'    p_subscribing_template_id    => :F4000_P251_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying template.'
,p_process_when_button_id=>wwv_flow_imp.id(6461903905495837)
,p_process_when=>':F4000_P251_REFERENCE_ID is not null and :F4000_P251_REFRESH = ''Y'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Template copied.'
,p_internal_uid=>35528815818801571
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(13221817549576893)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove reference id as needed'
,p_process_sql_clob=>'wwv_flow_copy_metadata.remove_popuplov_reference_id (:F4000_P251_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error setting template id to null.'
,p_process_when_button_id=>wwv_flow_imp.id(6461903905495837)
,p_process_when=>'F4000_P251_REFERENCE_ID'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'0'
,p_process_success_message=>'Reset reference id.'
,p_internal_uid=>13221817549576893
);
end;
/
prompt --application/pages/page_00253
begin
wwv_flow_imp_page.create_page(
 p_id=>253
,p_name=>'Install Theme'
,p_alias=>'INSTALL-THEME'
,p_step_title=>'Install Theme'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879423075323511)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_install.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(38856906254201972)
,p_plug_name=>'import progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(37899301707472090)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47632929379498968)
,p_plug_name=>'Install Theme'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_imp_parser.get_theme_id(:P253_FILE_ID) is not null'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(79479717773383003)
,p_plug_name=>'Invalid File'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--danger:a-Alert--horizontal'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>30
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'File is not a valid &PRODUCT_NAME. theme import.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_imp_parser.get_theme_id(:P253_FILE_ID) is null'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(205167923987797584)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747139770527138157)
,p_plug_name=>'Install Theme'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(47637304969529815)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(205167923987797584)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(47638615358532854)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(205167923987797584)
,p_button_name=>'INSTALL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Install Theme'
,p_button_position=>'CREATE'
,p_button_condition=>'wwv_flow_imp_parser.get_theme_id(:P253_FILE_ID) is not null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2227104527399086)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(205167923987797584)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:163:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(47640408909540416)
,p_branch_action=>'f?p=&FLOW_ID.:260:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_IN_CONDITION'
,p_branch_condition=>'INSTALL:REPLACE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(73118923864773969)
,p_branch_action=>'f?p=&FLOW_ID.:253:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(143131410984185804)
,p_branch_action=>'f?p=&FLOW_ID.:73:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(47637304969529815)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(73107224679708035)
,p_branch_action=>'f?p=&FLOW_ID.:48:&SESSION.:THEME:&DEBUG.:::'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(47638615358532854)
,p_branch_sequence=>40
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P253_INSTALL_OPTION'
,p_branch_condition_text=>'REPLACE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(53701615454623779)
,p_name=>'P253_FILE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(47632929379498968)
,p_prompt=>'File Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(56513630434665841)
,p_name=>'P253_IMP_VERSION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(47632929379498968)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Imported Theme Version'
,p_source=>'wwv_flow_imp_parser.get_version(:p253_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies file version.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(72898709763530335)
,p_name=>'P253_NEW_FLOW_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(47632929379498968)
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Install Into Application'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST FLOWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'where  build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'You can install the theme into the same application it came from or into a different application in the workspace. Leave the Application ID as is or select another.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(142932124032631309)
,p_name=>'P253_NEW_THEME_PK'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(47632929379498968)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(142941623994678665)
,p_name=>'P253_ORIGINAL_FLOW_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(47632929379498968)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Exported From Application ID'
,p_source=>'wwv_flow_imp_parser.get_flow_id(:p253_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The ID of the application from which this theme was exported.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(142944625164688469)
,p_name=>'P253_ORIGINAL_THEME_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(47632929379498968)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Imported Theme ID'
,p_source=>'wwv_flow_imp_parser.get_theme_id(:p253_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The ID of the imported theme.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(142984030433945447)
,p_name=>'P253_INSTALL_OPTION'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(47632929379498968)
,p_use_cache_before_default=>'NO'
,p_item_default=>'CREATE'
,p_display_as=>'NATIVE_HIDDEN'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_themes ',
' where flow_id = :P253_NEW_FLOW_ID ',
'   and security_group_id = :WORKSPACE_ID',
'   and theme_id = :P253_ORIGINAL_THEME_ID ',
'   and :p253_original_theme_id != ( select nvl(theme_id,-1) from wwv_flows where id = :P253_NEW_FLOW_ID )'))
,p_display_when_type=>'EXISTS'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Refreshing a theme updates the theme and template definition of the current theme with the definition of the imported theme. This requires that both themes are compatible and use matching theme and template identifiers.</p>',
'<p>Creating a new theme installs the imported theme alongside the current theme, allowing to switch from the old theme to the new theme and manually mapping templates.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(143018502916051053)
,p_name=>'P253_ACTION'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(47632929379498968)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_original_theme_id number := wwv_flow_imp_parser.get_theme_id( :P253_FILE_ID );',
'begin',
'    if :P253_NEW_FLOW_ID is null and :P253_INSTALL_OPTION is null then',
'        for c1 in (',
'            select 1 from wwv_flow_themes ',
'             where flow_id           = :FB_FLOW_ID ',
'               and theme_id          = l_original_theme_id',
'               and security_group_id = :WORKSPACE_ID',
'               and not exists (',
'                    select 1 from wwv_flows ',
'                     where id                = :FB_FLOW_ID ',
'                       and security_group_id = :WORKSPACE_ID',
'                       and nvl(theme_id,-1)  = l_original_theme_id) ) ',
'        loop',
'            :P253_INSTALL_OPTION := ''REPLACE'';',
'            return wwv_flow_lang.system_message(''F4000.THEME_IMPORT_REPLACE'',:FB_FLOW_ID);',
'        end loop;',
'',
'        :P253_INSTALL_OPTION := ''CREATE'';',
'',
'        return wwv_flow_lang.system_message(''F4000.THEME_IMPORT_CREATE'',:FB_FLOW_ID);',
'    elsif :P253_NEW_FLOW_ID is not null and :P253_INSTALL_OPTION is null then',
'        for c1 in (',
'            select 1 from wwv_flow_themes ',
'             where flow_id           = :P253_NEW_FLOW_ID ',
'               and theme_id          = l_original_theme_id',
'               and security_group_id = :WORKSPACE_ID',
'               and not exists (',
'                   select 1 from wwv_flows ',
'                    where id                = :P253_NEW_FLOW_ID ',
'                      and security_group_id = :WORKSPACE_ID',
'                      and nvl(theme_id,-1)  = l_original_theme_id) ) ',
'        loop',
'            :P253_INSTALL_OPTION := ''REPLACE'';',
'            return wwv_flow_lang.system_message(''F4000.THEME_IMPORT_REPLACE'',:P253_NEW_FLOW_ID);',
'        end loop;',
'        ',
'        :P253_INSTALL_OPTION := ''CREATE'';',
'        ',
'        return wwv_flow_lang.system_message(''F4000.THEME_IMPORT_CREATE'',:P253_NEW_FLOW_ID);',
'    elsif :P253_NEW_FLOW_ID is not null and :P253_INSTALL_OPTION is not null then',
'        for c1 in (',
'            select 1 from wwv_flow_themes ',
'             where flow_id           = :P253_NEW_FLOW_ID ',
'               and theme_id          = l_original_theme_id',
'               and security_group_id = :WORKSPACE_ID',
'               and not exists (',
'                    select 1 from wwv_flows ',
'                    where id                = :P253_NEW_FLOW_ID ',
'                      and security_group_id = :WORKSPACE_ID',
'                      and nvl(theme_id,-1)  = l_original_theme_id)) ',
'        loop',
'            if :P253_INSTALL_OPTION = ''CREATE'' then',
'                return wwv_flow_lang.system_message(''F4000.THEME_IMPORT_CREATE'',:P253_NEW_FLOW_ID);',
'            else',
'                return wwv_flow_lang.system_message(''F4000.THEME_IMPORT_REPLACE'',:P253_NEW_FLOW_ID);',
'            end if;',
'        end loop;',
'          ',
'        :P253_INSTALL_OPTION := ''CREATE'';',
'        ',
'        return wwv_flow_lang.system_message(''F4000.THEME_IMPORT_CREATE'',:P253_NEW_FLOW_ID);  ',
'    elsif :P253_NEW_FLOW_ID is null and :P253_INSTALL_OPTION is not null  then',
'        :P253_INSTALL_OPTION := null;',
'        return null;',
'    end if;',
'',
'    return null;',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Identifies file version.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(146463506734195615)
,p_name=>'P253_THEME_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(47632929379498968)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Imported Theme Name'
,p_source=>'wwv_flow_imp_parser.get_theme_name(:p253_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The name of the imported theme.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(47812121666857963)
,p_validation_name=>'not valid import'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_imp_parser.get_theme_id(:P253_FILE_ID) is null then',
'   return false;',
'else',
'   return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'File is not a valid &PRODUCT_NAME. theme import.'
,p_when_button_pressed=>wwv_flow_imp.id(47638615358532854)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(56432910873347879)
,p_validation_name=>'version must be compatible'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_runtime_version varchar2(200); -- the date of the current runtime flows',
'  l_calling_version varchar2(200);',
'begin',
'    l_calling_version := replace(replace(replace(wwv_flow_imp_parser.get_version (p_file_id => :p253_file_id),''.'',null),''_'',null),''/'',null);',
'    l_runtime_version := replace(replace(replace(wwv_flows_version,''.'',null),''_'',null),''/'',null);',
'',
'    if l_calling_version > l_runtime_version then',
'        --',
'        -- version incompatability        ',
'        --',
'        ',
'        return false;',
'    else',
'        return true;',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'NOT COMPATIBLE (Your import may contain calls not supported by your application version.)'
,p_when_button_pressed=>wwv_flow_imp.id(47638615358532854)
,p_associated_item=>wwv_flow_imp.id(56513630434665841)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(46353812810485581)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'install theme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare l_create_theme boolean :=false;',
'begin',
'  if :P253_INSTALL_OPTION = ''CREATE'' then',
'    l_create_theme := true;',
'  end if;',
'  for c1 in (select owner from wwv_flows ',
'             where id              = :P253_NEW_FLOW_ID ',
'             and security_group_id = :flow_security_group_id) loop',
'      wwv_flow_imp_parser.parse (',
'         p_file_id          => :P253_FILE_ID,',
'         p_parse_as_schema  => c1.owner,',
'         p_install_as_flow  => :P253_NEW_FLOW_ID,',
'         p_original_flow_id => wwv_flow_imp_parser.get_flow_id(:P253_FILE_ID),',
'         p_adjust_offset    => true,',
'         p_create_theme     => l_create_theme',
'         );',
'  end loop;',
'  :FB_FLOW_ID := :P253_NEW_FLOW_ID;',
'  :F4000_P1_FLOW := :P253_NEW_FLOW_ID;',
'  :F4000_P1_PAGE := ''1'';',
'',
'  :P253_NEW_THEME_PK  := null;',
'  for c1 in (select id from wwv_flow_themes ',
'              where flow_id           = :P253_NEW_FLOW_ID ',
'                and theme_id          = wwv_flow.g_flow_theme_id',
'                and security_group_id = :WORKSPACE_ID ) loop',
'      :P253_NEW_THEME_PK := c1.id;',
'  end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error installing theme.'
,p_process_when=>'INSTALL:REPLACE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'Theme installed.'
,p_internal_uid=>46353812810485581
);
end;
/
prompt --application/pages/page_00258
begin
wwv_flow_imp_page.create_page(
 p_id=>258
,p_name=>'Edit Report Template'
,p_alias=>'EDIT-REPORT-TEMPLATE'
,p_step_title=>'Edit Report Template'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';',
'',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'EXISTS'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_row_templates t, wwv_flow_themes th',
' where t.id                 = :F4000_P258_ID',
'   and t.flow_id            = th.flow_id',
'   and t.theme_id           = th.theme_id',
'   and t.security_group_id  = :workspace_id',
'   and th.security_group_id = t.security_group_id',
'   and t.reference_id      is not null',
'   and th.reference_id     is not null'))
,p_help_text=>'ui_templt_report.htm'
,p_page_component_map=>'21'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1405873563631501)
,p_plug_name=>'Landmark for Displayed Regions'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_landmark_type=>'region'
,p_landmark_label=>'Displayed Regions'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2346347659089700)
,p_plug_name=>'Report Template'
,p_parent_plug_id=>wwv_flow_imp.id(1405873563631501)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2346347660092590)
,p_plug_name=>'Column Templates'
,p_region_name=>'ROW'
,p_parent_plug_id=>wwv_flow_imp.id(1405873563631501)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>180
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2346347661118096)
,p_plug_name=>'Comments'
,p_region_name=>'COM'
,p_parent_plug_id=>wwv_flow_imp.id(1405873563631501)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>250
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6669756982775382)
,p_plug_name=>'Pagination Subtemplate'
,p_region_name=>'PG'
,p_parent_plug_id=>wwv_flow_imp.id(1405873563631501)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>220
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8660015968075276)
,p_plug_name=>'After Each Row'
,p_region_name=>'AFTER'
,p_parent_plug_id=>wwv_flow_imp.id(1405873563631501)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>190
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(24697467219204882)
,p_plug_name=>'Template Options'
,p_parent_plug_id=>wwv_flow_imp.id(1405873563631501)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>130
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(20118983404167526)
,p_plug_name=>'Template Options'
,p_parent_plug_id=>wwv_flow_imp.id(24697467219204882)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.template_types,',
'       o.id,',
'       o.display_name,',
'       o.name,',
'       o.display_sequence,',
'       o.css_classes,',
'       o.flow_id,',
'       o.theme_id,',
'       o.help_text,',
'       o.group_id,',
'       o.report_template_id,',
'       ( select g.display_sequence from wwv_flow_template_opt_groups g where g.id = o.group_id ) group_display_sequence,',
'       ( select g.display_name     from wwv_flow_template_opt_groups g where g.id = o.group_id ) group_display_name',
'  from wwv_flow_template_options o',
' where o.flow_id            = :FB_FLOW_ID',
'   and o.theme_id           = :P258_THEME',
'   and o.template_types     = ''REPORT''',
'   and o.report_template_id = :F4000_P258_ID'))
,p_plug_source_type=>'NATIVE_IG'
,p_ajax_items_to_submit=>'P258_DEFAULT_TEMPLATE_OPTIONS,P258_THEME'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Template Options'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(9687834899802611)
,p_name=>'REPORT_TEMPLATE_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'REPORT_TEMPLATE_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>70
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'F4000_P258_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(13086978632499026)
,p_name=>'GROUP_DISPLAY_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'GROUP_DISPLAY_SEQUENCE'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Group Sequence'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>80
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(13087093965499027)
,p_name=>'GROUP_DISPLAY_NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'GROUP_DISPLAY_NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Group Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>90
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(20119761938167534)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>30
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(20119848087167535)
,p_name=>'DISPLAY_NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DISPLAY_NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>100
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_item_width=>30
,p_is_required=>true
,p_max_length=>30
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_static_id=>'COLUMN_DISPLAY_NAME'
,p_use_as_row_header=>true
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(20119897372167536)
,p_name=>'DISPLAY_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DISPLAY_SEQUENCE'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>'Sequence'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>120
,p_value_alignment=>'RIGHT'
,p_attribute_03=>'left'
,p_attribute_04=>'decimal'
,p_item_width=>5
,p_is_required=>true
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'1'
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(20120012759167537)
,p_name=>'CSS_CLASSES'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'CSS_CLASSES'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Classes'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>130
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_max_length=>255
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(20120364395167540)
,p_name=>'APEX$ROW_ACTION'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>20
,p_use_as_row_header=>false
,p_display_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(20120413872167541)
,p_name=>'APEX$ROW_SELECTOR'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_use_as_row_header=>false
,p_display_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(20121448381167551)
,p_name=>'TEMPLATE_TYPES'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'TEMPLATE_TYPES'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>60
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'REPORT'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(20121509897167552)
,p_name=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Identifier'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>110
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_attribute_06=>'UPPER'
,p_item_width=>30
,p_is_required=>true
,p_max_length=>30
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(20762200986323006)
,p_name=>'HELP_TEXT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'HELP_TEXT'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Help Text'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>150
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(20762302789323007)
,p_name=>'GROUP_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'GROUP_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Group'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>140
,p_value_alignment=>'LEFT'
,p_is_required=>false
,p_lov_type=>'SQL_QUERY'
,p_lov_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name,',
'       id',
'  from wwv_flow_template_opt_groups',
' where template_types = :TEMPLATE_TYPES',
'   and flow_id        = :FB_FLOW_ID',
'   and theme_id       = :P258_THEME'))
,p_lov_display_extra=>true
,p_lov_display_null=>true
,p_lov_cascade_parent_items=>'TEMPLATE_TYPES'
,p_ajax_items_to_submit=>'P258_THEME'
,p_ajax_optimize_refresh=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(20762398417323008)
,p_name=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FLOW_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>40
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'FB_FLOW_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(20762517581323009)
,p_name=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'THEME_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>50
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'P258_THEME'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(20119654141167533)
,p_internal_uid=>20119654141167533
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_add_row_if_empty=>false
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>true
,p_no_data_found_message=>'No template options.'
,p_show_toolbar=>true
,p_toolbar_buttons=>'SEARCH_FIELD:SAVE'
,p_add_button_label=>'Add Template Option'
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>false
,p_define_chart_view=>false
,p_enable_download=>false
,p_download_formats=>null
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function(config) {',
'    config.defaultGridViewOptions = {',
'        reorderColumns: false',
'    }',
'    return config;',
'}'))
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(20555620839306359)
,p_interactive_grid_id=>wwv_flow_imp.id(20119654141167533)
,p_static_id=>'94803'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(20555806857306360)
,p_report_id=>wwv_flow_imp.id(20555620839306359)
,p_view_type=>'GRID'
,p_stretch_columns=>true
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(11078684064540673)
,p_view_id=>wwv_flow_imp.id(20555806857306360)
,p_display_seq=>11
,p_column_id=>wwv_flow_imp.id(20762398417323008)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(11079723871540679)
,p_view_id=>wwv_flow_imp.id(20555806857306360)
,p_display_seq=>12
,p_column_id=>wwv_flow_imp.id(20762517581323009)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(11273658496578178)
,p_view_id=>wwv_flow_imp.id(20555806857306360)
,p_display_seq=>13
,p_column_id=>wwv_flow_imp.id(9687834899802611)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(20556358079306366)
,p_view_id=>wwv_flow_imp.id(20555806857306360)
,p_display_seq=>2
,p_column_id=>wwv_flow_imp.id(20119761938167534)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(20557263039306373)
,p_view_id=>wwv_flow_imp.id(20555806857306360)
,p_display_seq=>4
,p_column_id=>wwv_flow_imp.id(20119848087167535)
,p_is_visible=>true
,p_is_frozen=>false
,p_sort_order=>4
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(20558145576306377)
,p_view_id=>wwv_flow_imp.id(20555806857306360)
,p_display_seq=>6
,p_column_id=>wwv_flow_imp.id(20119897372167536)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>112
,p_sort_order=>3
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(20558991149306382)
,p_view_id=>wwv_flow_imp.id(20555806857306360)
,p_display_seq=>7
,p_column_id=>wwv_flow_imp.id(20120012759167537)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(20561714760306391)
,p_view_id=>wwv_flow_imp.id(20555806857306360)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(20120364395167540)
,p_is_visible=>true
,p_is_frozen=>true
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(20768226230325391)
,p_view_id=>wwv_flow_imp.id(20555806857306360)
,p_display_seq=>10
,p_column_id=>wwv_flow_imp.id(20121448381167551)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(20769134941325397)
,p_view_id=>wwv_flow_imp.id(20555806857306360)
,p_display_seq=>5
,p_column_id=>wwv_flow_imp.id(20121509897167552)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(20772774445325409)
,p_view_id=>wwv_flow_imp.id(20555806857306360)
,p_display_seq=>8
,p_column_id=>wwv_flow_imp.id(20762200986323006)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(20773671214325412)
,p_view_id=>wwv_flow_imp.id(20555806857306360)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(20762302789323007)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(23813291774910651)
,p_view_id=>wwv_flow_imp.id(20555806857306360)
,p_display_seq=>14
,p_column_id=>wwv_flow_imp.id(13086978632499026)
,p_is_visible=>false
,p_is_frozen=>false
,p_sort_order=>1
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(23814106450910655)
,p_view_id=>wwv_flow_imp.id(20555806857306360)
,p_display_seq=>15
,p_column_id=>wwv_flow_imp.id(13087093965499027)
,p_is_visible=>false
,p_is_frozen=>false
,p_sort_order=>2
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(707631914751011279)
,p_name=>'Global Template Options'
,p_parent_plug_id=>wwv_flow_imp.id(24697467219204882)
,p_template=>wwv_flow_imp.id(689970285456172024)
,p_display_sequence=>230
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  o.id, ',
'  o.display_name,',
'  o.display_sequence,',
'  o.css_classes,',
'  g.display_name group_name',
'  from wwv_flow_template_options o,',
'       wwv_flow_template_opt_groups g',
' where o.flow_id               = :FB_FLOW_ID',
'   and o.virtual_template_id  is null',
'   and o.template_types        = ''REPORT''',
'   and o.REPORT_TEMPLATE_ID   is null',
'   and o.security_group_id     = :WORKSPACE_ID',
'   and g.security_group_id (+) = o.security_group_id',
'   and o.theme_id              = :P258_THEME',
'   and g.id                (+) = o.group_id',
' order by',
'       g.display_sequence,',
'       g.display_name,',
'       o.display_sequence,',
'       o.display_name'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P258_DEFAULT_TEMPLATE_OPTIONS,P258_THEME'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>200
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No template options defined.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(11084932938520446)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(11085352412520448)
,p_query_column_id=>2
,p_column_alias=>'DISPLAY_NAME'
,p_column_display_sequence=>21
,p_column_heading=>'Name'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(11085747687520448)
,p_query_column_id=>3
,p_column_alias=>'DISPLAY_SEQUENCE'
,p_column_display_sequence=>31
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(11086113271520449)
,p_query_column_id=>4
,p_column_alias=>'CSS_CLASSES'
,p_column_display_sequence=>41
,p_column_heading=>'Classes'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(11086587504520449)
,p_query_column_id=>5
,p_column_alias=>'GROUP_NAME'
,p_column_display_sequence=>11
,p_column_heading=>'Group'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(28562360017818729)
,p_plug_name=>'Before Rows'
,p_region_name=>'BEFORE'
,p_parent_plug_id=>wwv_flow_imp.id(1405873563631501)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>150
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(31959320827513361)
,p_plug_name=>'Row Highlighting'
,p_region_name=>'HIGH'
,p_parent_plug_id=>wwv_flow_imp.id(1405873563631501)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>210
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(33633213596068637)
,p_plug_name=>'Subscription'
,p_region_name=>'SUBSCRIPTION'
,p_parent_plug_id=>wwv_flow_imp.id(1405873563631501)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>120
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P258_THEME_IS_SUBSCRIBED'
,p_plug_display_when_cond2=>'NONE'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'WWV_FLOW_ROW_TEMPLATES',
  'attribute_02', 'ROW_TEMPLATE_NAME',
  'attribute_03', 'F4000_P258_ID',
  'attribute_04', 'F4000_P258_REFERENCE_ID',
  'attribute_05', 'SUBSCRIBE_TEMPLATE')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(81716255746380489)
,p_plug_name=>'Column Headings'
,p_region_name=>'COL'
,p_parent_plug_id=>wwv_flow_imp.id(1405873563631501)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>160
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(202662218617305708)
,p_plug_name=>'Before Each Row'
,p_region_name=>'BER'
,p_parent_plug_id=>wwv_flow_imp.id(1405873563631501)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>170
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(202666727537327236)
,p_plug_name=>'After Rows'
,p_parent_plug_id=>wwv_flow_imp.id(1405873563631501)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>200
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(932807415022193718)
,p_plug_name=>'Subscription'
,p_parent_plug_id=>wwv_flow_imp.id(1405873563631501)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P258_THEME_IS_SUBSCRIBED = ''BOTH'' then',
'     sys.htp.p(wwv_flow_lang.system_message(''TEMPLATE_SUBSCRIPTION.THEME_AND_TEMPLATE_SUBSCRIBED''));',
'else',
'     sys.htp.p(wwv_flow_lang.system_message(''TEMPLATE_SUBSCRIPTION.THEME_SUBSCRIBED''));',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P258_THEME_IS_SUBSCRIBED'
,p_plug_display_when_cond2=>'NONE'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'N',
  'attribute_02', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1094586559791933034)
,p_plug_name=>'Cascading Style Sheet'
,p_parent_plug_id=>wwv_flow_imp.id(1405873563631501)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>240
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1094586653151933035)
,p_plug_name=>'JavaScript'
,p_parent_plug_id=>wwv_flow_imp.id(1405873563631501)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>230
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2346347658087535)
,p_plug_name=>'Edit Report Template'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--accessibleTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>140
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_landmark_label=>'Report Template Actions'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2346347662147428)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>130
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Report Templates provide you with control over the results of a row from a SQL query. This template defines a cell, not an entire row.</p>'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46188623746907178)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>150
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(92864800532521708)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>140
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(92837202675352059)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(168807056558718055)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(33633213596068637)
,p_button_name=>'PUBLISH_TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Publish Template'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.::F4000_P149_ID,F4000_P149_PAGE_ID,F4000_P149_TEMPLATE_TYPE:&F4000_P258_ID.,&FLOW_PAGE_ID.,REPORT_TEMPLATE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_row_templates',
' where reference_id      = :F4000_P258_ID',
'   and security_group_id = :workspace_id'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(166704164225630527)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(33633213596068637)
,p_button_name=>'COPY_TEMPLATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Refresh'
,p_button_position=>'CLOSE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_row_templates',
' where id                = :F4000_P258_ID',
'   and security_group_id = :workspace_id',
'   and reference_id     is not null'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(286272007882736617)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(2346347658087535)
,p_button_name=>'APPLY_CHANGES_GET_PREVIOUS_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'disabled=""'
,p_button_comment=>'javascript:htmldb_goSubmit(''GET_PREVIOUS_ID'')'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(286271918926736617)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_imp.id(2346347658087535)
,p_button_name=>'APPLY_CHANGES_GET_NEXT_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Next'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'disabled=""'
,p_button_comment=>'javascript:htmldb_goSubmit(''GET_NEXT_ID'')'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2346347629058231)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(2346347658087535)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2346347630058235)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(2346347658087535)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:505:&SESSION.::&DEBUG.::P505_ID:&F4000_P258_ID.'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P258_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2346347631058235)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(2346347658087535)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P258_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2346347632058235)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(2346347658087535)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P258_ID is null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(11075621906520422)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_imp.id(24697467219204882)
,p_button_name=>'OPTION_GROUPS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Template Option Groups'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:81:&SESSION.::&DEBUG.:CR,81:P81_THEME_ID,P81_TEMPLATE_TYPE:&P258_THEME.,REPORT'
,p_button_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(286284130594736673)
,p_branch_action=>'f?p=&APP_ID.:258:&SESSION.::&DEBUG.::F4000_P258_ID:&P258_ID_NEXT.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(286271918926736617)
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(286284513168736674)
,p_branch_action=>'f?p=&APP_ID.:258:&SESSION.::&DEBUG.::F4000_P258_ID:&P258_ID_PREV.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(286272007882736617)
,p_branch_sequence=>40
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2346398057989414)
,p_branch_name=>'Go To Page 258'
,p_branch_action=>'f?p=&APP_ID.:258:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'F4000_P258_RETUEN_TO_SELF'
,p_branch_condition_text=>'YES'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(166704548187630530)
,p_branch_name=>'Go To Page 258'
,p_branch_action=>'f?p=&APP_ID.:258:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(166704164225630527)
,p_branch_sequence=>60
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2346347634058243)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>70
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(837440512748841416)
,p_branch_name=>'Page Designer: Redirect to Column Template'
,p_branch_action=>'f?p=&APP_ID.:4654:&SESSION.::&DEBUG.:RP,4654:F4000_P4654_ID:&F4000_P258_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_HEADER'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_row_templates',
' where id                = :F4000_P258_ID',
'   and row_template_type = ''NAMED_COLUMNS''',
'   and security_group_id = :workspace_id'))
,p_branch_comment=>'This branch is needed for Page Designer which can''t distinguish between the different report template types, that''s why Page Designer always branches to the Generic Template page.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2346347636058249)
,p_name=>'F4000_P258_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>380
,p_item_plug_id=>wwv_flow_imp.id(2346347658087535)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2346347638058255)
,p_name=>'F4000_P258_ROW_TEMPLATE_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2346347659089700)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Template Name'
,p_source=>'ROW_TEMPLATE_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Identifies a name for this template.',
' ',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2346347639058255)
,p_name=>'F4000_P258_ROW_TEMPLATE1'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(2346347660092590)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Column Template 1'
,p_source=>'ROW_TEMPLATE1'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>32767
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Defines the column template. You can use these substitution strings here:',
'<ul class="noIndent">',
'<li>#COLUMN_VALUE# - Will be replaced with the value of a column</li>',
'<li>#ALIGNMENT# - Specified by the user, determines the alignment of a column</li>',
'<li>#COLNUM# - Current Column Number</li>',
'<li>#COLUMN_HEADER# - Column Header</li>',
'<li>#COLCOUNT# - Number of Columns</li>',
'<li>#ROWNUM# - Current Row Number</li>',
'<li>#ACCESSIBLE_HEADERS# - Adds the row and column headers for the cell</li>',
'</ul>',
'</div>',
'<div class="htmldbInfoBodyP">A typical example would be:</div>',
'<pre>&lt;td #ALIGNMENT#&gt;#COLUMN_VALUE#&lt;/td&gt;</pre>',
'',
'<div class="instructiontext">You can define up to four column templates, each of which can be conditional.  For example, you can have different background colors for even and odd rows, or highlight rows which meet a PL/SQL defined condition.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2346347640058257)
,p_name=>'F4000_P258_ROW_TEMPLATE_CONDITION1'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(2346347660092590)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Column Template 1 Expression'
,p_source=>'ROW_TEMPLATE_CONDITION1'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Used only when the column condition is set to Use Based on PL/SQL Expression. Enables you to format columns based on the data in that row.</div>',
'<div class="htmldbInfoBodyP">For example, if you wanted to display a value in bold if the salary was greater than 2000, you could use the following row template condition:</div>',
'<pre>',
':SAL &gt; 2000',
'</pre>',
'<div class="htmldbInfoBodyP">Note that column names should be referenced using bind variable syntax, that is, use :SAL rather than #SAL#. You can also use the substitution string #ROWNUM# here.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2346347641058257)
,p_name=>'F4000_P258_ROW_TEMPLATE2'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(2346347660092590)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Column Template 2 '
,p_source=>'ROW_TEMPLATE2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>32767
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Defines the column template. You can use these substitution strings here:',
'<ul class="noIndent">',
'<li>#COLUMN_VALUE# - Will be replaced with the value of a column</li>',
'<li>#ALIGNMENT# - Specified by the user, determines the alignment of a column</li>',
'<li>#COLNUM# - Current Column Number</li>',
'<li>#COLUMN_HEADER# - Column Header</li>',
'<li>#COLCOUNT# - Number of Columns</li>',
'<li>#ROWNUM# - Current Row Number</li>',
'<li>#ACCESSIBLE_HEADERS# - Adds the row and column headers for the cell</li>',
'</ul>',
'</div>',
'<div class="htmldbInfoBodyP">Defines the column template. A typical example would be:</div>',
'<pre>&lt;td #ALIGNMENT#&gt;#COLUMN_VALUE#&lt;/td&gt;</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2346347642058257)
,p_name=>'F4000_P258_ROW_TEMPLATE_CONDITION2'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(2346347660092590)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Column Template 2 Expression'
,p_source=>'ROW_TEMPLATE_CONDITION2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Used only when the column condition is set to Use Based on PL/SQL Expression. Enables you to format columns based on the data in that row.</div>',
'<div class="htmldbInfoBodyP">For example, if you wanted to display a value in bold if the salary was greater than 2000, you could use the following row template condition:</div>',
'<pre>',
':SAL &gt; 2000',
'</pre>',
'<div class="htmldbInfoBodyP">Note that column names should be referenced using bind variable syntax, that is, use :SAL rather than #SAL#. You can also use the substitution string #ROWNUM# here.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2346347643058258)
,p_name=>'F4000_P258_ROW_TEMPLATE3'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(2346347660092590)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Column Template 3'
,p_source=>'ROW_TEMPLATE3'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>32767
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Defines the column template. You can use these substitution strings here:',
'<ul class="NoIndent">',
'<li>#COLUMN_VALUE# - Will be replaced with the value of a column</li>',
'<li>#ALIGNMENT# - Specified by the user, determines the alignment of a column</li>',
'<li>#COLNUM# - Current Column Number</li>',
'<li>#COLUMN_HEADER# - Column Header</li>',
'<li>#COLCOUNT# - Number of Columns</li>',
'<li>#ROWNUM# - Current Row Number</li>',
'<li>#ACCESSIBLE_HEADERS# - Adds the row and column headers for the cell</li>',
'</ul>',
'</div>',
'<div class="htmldbInfoBodyP">A typical example would be:</div>',
'<pre>&lt;td #ALIGNMENT#&gt;#COLUMN_VALUE#&lt;/td&gt;</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2346347644058258)
,p_name=>'F4000_P258_ROW_TEMPLATE_CONDITION3'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_imp.id(2346347660092590)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Column Template 3 Expression'
,p_source=>'ROW_TEMPLATE_CONDITION3'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Used only when the column condition is set to Use Based on PL/SQL Expression. Enables you to format columns based on the data in that row.</div>',
'<div class="htmldbInfoBodyP">For example, if you wanted to display a value in bold if the salary was greater than 2000, you could use the following row template condition:</div>',
'<pre>',
':SAL &gt; 2000',
'</pre>',
'<div class="htmldbInfoBodyP">Note that column names should be referenced using bind variable syntax, that is. use :SAL rather than #SAL#. You can also use the substitution string #ROWNUM# here.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2346347645058258)
,p_name=>'F4000_P258_ROW_TEMPLATE4'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_imp.id(2346347660092590)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Column Template 4 '
,p_source=>'ROW_TEMPLATE4'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>32767
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Defines the column template. You can use these substitution strings here:',
'<ul class="noIndent">',
'<li>#COLUMN_VALUE# - Will be replaced with the value of a column</li>',
'<li>#ALIGNMENT# - Specified by the user, determines the alignment of a column</li>',
'<li>#COLNUM# - Current Column Number</li>',
'<li>#COLUMN_HEADER# - Column Header</li>',
'<li>#COLCOUNT# - Number of Columns</li>',
'<li>#ROWNUM# - Current Row Number</li>',
'<li>#ACCESSIBLE_HEADERS# - Adds the row and column headers for the cell</li>',
'</ul>',
'</div>',
'<div class="htmldbInfoBodyP">A typical example would be:</div>',
'<pre>&lt;td #ALIGNMENT#&gt;#COLUMN_VALUE#&lt;/td&gt;</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2346347646058259)
,p_name=>'F4000_P258_ROW_TEMPLATE_CONDITION4'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_imp.id(2346347660092590)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Column Template 4 Expression'
,p_source=>'ROW_TEMPLATE_CONDITION4'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Used only when the column condition is set to Use Based on PL/SQL Expression. Enables you to format columns based on the data in that row.</div>',
'<div class="htmldbInfoBodyP">For example, if you wanted to display a value in bold if the salary was greater than 2000, you could use the following row template condition:</div>',
'<pre>',
':SAL &gt; 2000',
'</pre>',
'<div class="htmldbInfoBodyP">Note that column names should be referenced using bind variable syntax, that is, use :SAL rather than #SAL#. You can also use the substitution string #ROWNUM# here.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2346347647058261)
,p_name=>'F4000_P258_ROW_TEMPLATE_COMMENT'
,p_item_sequence=>360
,p_item_plug_id=>wwv_flow_imp.id(2346347661118096)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comments'
,p_source=>'ROW_TEMPLATE_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>5
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'<div class="htmldbInfoBodyP">Developer comments or notes. These comments never display when the application is running.</div>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2346393976043681)
,p_name=>'F4000_P258_ROW_TEMPLATE_BEFORE_ROWS'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(28562360017818729)
,p_use_cache_before_default=>'NO'
,p_item_default=>'<table>'
,p_prompt=>'Before Rows'
,p_source=>'ROW_TEMPLATE_BEFORE_ROWS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter HTML which will be displayed one time at the beginning of a report template.</p>',
'<p>The most common use of this attribute is to open an HTML table:</p>',
'<pre>&lt;table&gt;</pre>',
'<p>If you want to display pagination above the reports, your template needs to specify the following substitution string:</p>',
'<pre>#TOP_PAGINATION#</pre>',
'<p>The #TOP_PAGINATION# substitution string will generate HTML which starts with an opening &lt;tr&gt; tag and ends with a closing &lt;/tr&gt; tag.  Ideally, you would include an open table tag and #TOP_PAGINATION# substitution string like so:</p>',
'<pre>&lt;table&gt;#TOP_PAGINATION#</pre>',
'<p>You can use the substitution string #CSV_LINK# if you wish to support exporting your report to CSV format for use in spreadsheets.</p>',
'<p>You can also use the substitution string #REPORT_ATTRIBUTES#.  This substitution string is set per report region on the report attributes page.</p>',
'<p>You can also use the substitution string #COMPONENT_CSS_CLASSES#.  This substitution string is set on the region edit page</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2346393977055422)
,p_name=>'F4000_P258_ROW_TEMPLATE_AFTER_ROWS'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_imp.id(202666727537327236)
,p_use_cache_before_default=>'NO'
,p_item_default=>'</table>'
,p_prompt=>'After Rows'
,p_source=>'ROW_TEMPLATE_AFTER_ROWS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">This text displays after the last row. Typically, you close the HTML table tag here.</div>',
'<div class="htmldbInfoBodyP">For example:</div>',
'<pre>&lt;/table&gt;</pre>',
'<div class="htmldbInfoBodyP">The following substitution strings are available:</div>',
'<ul class="noIndent">',
'<li>#PAGINATION# - Will be replaced with the pagination attribute</li>',
'<li>#COLCOUNT# - Number of HTML columns to span</li>',
'<li>#CSV_LINK# - Will be replaced with CSV download link if CSV export is enabled, otherwise string will not be shown</li>',
'<li>#EXTERNAL_LINK# - will be replaced with download link for exports using external processing engine for example, PDF export, if this feature is not enabled, the string will not be shown</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2346398056982355)
,p_name=>'F4000_P258_RETUEN_TO_SELF'
,p_item_sequence=>370
,p_item_plug_id=>wwv_flow_imp.id(2346347662147428)
,p_prompt=>'Stay on page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select this checkbox to stay on this page after applying changes.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'YES'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6670379838781921)
,p_name=>'F4000_P258_PAGINATION_TEMPLATE'
,p_item_sequence=>310
,p_item_plug_id=>wwv_flow_imp.id(6669756982775382)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Pagination Template'
,p_source=>'PAGINATION_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>32767
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">This attribute will be applied to the entire pagination subtemplate. You can further modify each item in the subtemplate below.</div>',
'<div class="htmldbInfoBodyP">For example:</div>',
'<pre>&lt;span class="instructiontext"&gt;#TEXT#&lt;/span&gt;</pre>',
'<div class="htmldbInfoBodyP">Use the substitution string #TEXT# where you want the pagination subtemplate to display</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6673749541811041)
,p_name=>'F4000_P258_NEXT_PAGE_TEMPLATE'
,p_item_sequence=>320
,p_item_plug_id=>wwv_flow_imp.id(6669756982775382)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Next Page Template'
,p_source=>'NEXT_PAGE_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>32767
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Enter HTML that will modify how the "Next Page" portion of the pagination subtemplate will appear.</div>',
'<div class="htmldbInfoBodyP">For example:</div>',
'<pre>&lt;a href="#LINK#"&gt;next&lt;/a&gt;</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6674565818815735)
,p_name=>'F4000_P258_PREV_PAGE_TEMPLATE'
,p_item_sequence=>330
,p_item_plug_id=>wwv_flow_imp.id(6669756982775382)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Previous Page Template'
,p_source=>'PREVIOUS_PAGE_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>32767
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Enter HTML that will modify how the "Previous Page" portion of the pagination subtemplate will appear.</div>',
'<div class="htmldbInfoBodyP">For example:</div>',
'<pre>&lt;a href="#LINK#"&gt;previous&lt;/a&gt;</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6675460061823585)
,p_name=>'F4000_P258_PREV_SET_TEMPLATE'
,p_item_sequence=>350
,p_item_plug_id=>wwv_flow_imp.id(6669756982775382)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Previous Set Template'
,p_source=>'PREVIOUS_SET_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>32767
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Enter HTML that will modify how the "Previous Set" portion of the pagination subtemplate will appear.</div>',
'<div class="htmldbInfoBodyP">For example:</div>',
'<pre>&lt;a href="#LINK#"&gt;previous set&lt;/a&gt;</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6676169065826187)
,p_name=>'F4000_P258_NEXT_SET_TEMPLATE'
,p_item_sequence=>340
,p_item_plug_id=>wwv_flow_imp.id(6669756982775382)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Next Set Template'
,p_source=>'NEXT_SET_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>32767
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Enter HTML that will modify how the "Next Set" portion of the pagination subtemplate will appear.</div>',
'<div class="htmldbInfoBodyP">For example:</div>',
'<pre>&lt;a href="#LINK#"&gt;next set&lt;/a&gt;</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11076072956520426)
,p_name=>'P258_PRESET_TEMPLATE_OPTIONS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(24697467219204882)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Preset Template Options:'
,p_source=>'PRESET_TEMPLATE_OPTIONS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.TEMPALTE_OPT_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  select o.display_name as d,',
'         o.css_classes as r,',
'         null default_template_options,',
'         null,',
'         o.help_text,',
'         (select display_name ',
'            from wwv_flow_template_opt_groups',
'           where o.group_id = id) group_name,',
'         (select is_advanced ',
'            from wwv_flow_template_opt_groups',
'           where o.group_id = id) advanced_group,',
'         (select null_text ',
'            from wwv_flow_template_opt_groups',
'           where o.group_id = id) null_text         ',
'    from wwv_flow_template_options o,',
'         wwv_flow_row_templates t',
'   where o.flow_id             = :FB_FLOW_ID',
'     and o.template_types      = ''REPORT''',
'     and (o.report_template_id = :F4000_P258_ID or report_template_id is NULL)',
'     and o.theme_id            = t.theme_id',
'     and t.id                  = :F4000_P258_ID        ',
'     and t.security_group_id   = :WORKSPACE_ID',
'     and o.security_group_id   = t.security_group_id',
'  order by advanced_group nulls first, group_name nulls first, display_sequence, display_name',
''))
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11076440387520430)
,p_name=>'P258_DEFAULT_TEMPLATE_OPTIONS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(24697467219204882)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Default Template Options:'
,p_source=>'DEFAULT_TEMPLATE_OPTIONS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.TEMPALTE_OPT_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.display_name as d,',
'       o.css_classes as r,',
'       t.default_template_options,',
'       null,',
'       o.help_text,',
'       (select display_name ',
'        from wwv_flow_template_opt_groups',
'        where o.group_id = id) group_name',
'  from wwv_flow_template_options o,',
'       wwv_flow_row_templates t',
' where o.flow_id           = :FB_FLOW_ID',
'   and t.id                = o.report_template_id',
'   and report_template_id  = :F4000_P258_ID',
'   and t.security_group_id = :WORKSPACE_ID',
'   and o.security_group_id = t.security_group_id',
' order by group_name nulls first, display_sequence, display_name'))
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11076834028520430)
,p_name=>'P258_PRESET_TMPLOPT_CHECK'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(24697467219204882)
,p_source=>'P258_PRESET_TEMPLATE_OPTIONS'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(24148405197499297)
,p_name=>'P258_TRANSLATABLE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(2346347659089700)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Translatable'
,p_source=>'TRANSLATE_THIS_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Indicate translatability.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28565851390822743)
,p_name=>'F4000_P258_ROW_TEMPLATE_BEFORE_FIRST'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(202662218617305708)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Before Each Row'
,p_source=>'ROW_TEMPLATE_BEFORE_FIRST'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Display this text before displaying all columns for the report. Use this attribute to open a new HTML row. Used for column templates only.</div>',
'<div class="htmldbInfoBodyP">For example:</div>',
'<pre>&lt;tr&gt;</pre>',
'<div class="htmldbInfoBodyP">Before Each Row supports the following substitution strings:</div>',
'<ul> ',
'<li>#ROWNUM# - Specifies the current row</li>',
'<li>#COLCOUNT# - Specifies the number of columns</li>',
'<li>#HIGHLIGHT_ROW# - Enables row highlighting</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28567177257825935)
,p_name=>'F4000_P258_ROW_TEMPLATE_AFTER_LAST'
,p_item_sequence=>270
,p_item_plug_id=>wwv_flow_imp.id(8660015968075276)
,p_use_cache_before_default=>'NO'
,p_prompt=>'After Each Row'
,p_source=>'ROW_TEMPLATE_AFTER_LAST'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Display this HTML after all columns for the report display. Typically used to close an HTML table row. Used with column templates only.</div>',
'<div class="htmldbInfoBodyP">For example:</div>',
'<pre>&lt;/tr&gt;</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(31963525591533693)
,p_name=>'P258_ROW_STYLE_CHECKED'
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_imp.id(31959320827513361)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Background color for checked row'
,p_source=>'ROW_STYLE_CHECKED'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'This attribute controls the background color of a report row when the row selector is checked.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(31968203128555576)
,p_name=>'P258_ROW_STYLE_MOUSE_OVER'
,p_item_sequence=>300
,p_item_plug_id=>wwv_flow_imp.id(31959320827513361)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Background color for current row'
,p_source=>'ROW_STYLE_MOUSE_OVER'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'This attribute controls the background color of a report row when the user moves the mouse over the row.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(36865470879655498)
,p_name=>'F4000_P258_REFRESH'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(33633213596068637)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Refresh'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_row_templates',
' where reference_id     is null',
'   and id                = :F4000_P258_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Check to refresh.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(44006313411345884)
,p_name=>'P258_THEME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(2346347659089700)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Theme'
,p_source=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the theme to which this template is associated. A theme is a grouping of templates which together provide layout and style for an application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(44032826187396906)
,p_name=>'P258_TEMPLATE_CLASS'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(2346347659089700)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Template Class'
,p_source=>'THEME_CLASS_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REPORT THEME CLASS ID'
,p_lov=>'.'||wwv_flow_imp.id(44022800298370465)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Not Identified -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Identifies a specific usage for this template.</div>',
'<div class="htmldbInfoBodyP">When you switch to a new theme, all templates in one theme are assigned to corresponding templates in another theme. App Builder accomplishes this template mapping through the assignment of template class identifiers.<p /'
||'p>',
'Use the <strong>Translatable</strong> check box to indicate the template contains text strings that require translation.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(81544764942145406)
,p_name=>'F4000_P258_ROW_TEMPLATE_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2346347659089700)
,p_use_cache_before_default=>'NO'
,p_item_default=>'NAMED_COLUMNS'
,p_prompt=>'Template Type'
,p_source=>'ROW_TEMPLATE_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'ROW_TEMPLATE_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(84775019904954668)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Displays the type of the template - either <span class="fielddatabold">Named columns</span> or <span class="fielddatabold">Generic Columns</strong>.</span>',
'<div class="htmldbInfoBodyP">Named Column templates reference column names in the template, whereas Generic Column Templates reference #COLUMN_VALUE# in the template.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(81562468534234915)
,p_name=>'F4000_P258_ROW_TEMPLATE_COND1'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(2346347660092590)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Column Template 1 Condition'
,p_source=>'ROW_TEMPLATE_DISPLAY_COND1'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ROW_TEMPLATE_COND2'
,p_lov=>'.'||wwv_flow_imp.id(84871821607428292)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Condition -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this);"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<div class="htmldbInfoBodyP">Optionally select a condition that must be met in order to apply this column template. You can select either even or odd row numbers, or supply a PL/SQL expression.</div>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(81567764209252138)
,p_name=>'F4000_P258_ROW_TEMPLATE_COND2'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(2346347660092590)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Column Template 2 Condition'
,p_source=>'ROW_TEMPLATE_DISPLAY_COND2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ROW_TEMPLATE_COND2'
,p_lov=>'.'||wwv_flow_imp.id(84871821607428292)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Condition -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this);"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<div class="htmldbInfoBodyP">Optionally select a condition that must be met in order to apply this column template. You can select either even or odd row numbers, or supply a PL/SQL expression.</div>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(81568460758253709)
,p_name=>'F4000_P258_ROW_TEMPLATE_COND3'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_imp.id(2346347660092590)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Column Template 3 Condition'
,p_source=>'ROW_TEMPLATE_DISPLAY_COND3'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ROW_TEMPLATE_COND2'
,p_lov=>'.'||wwv_flow_imp.id(84871821607428292)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Condition -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this);"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Optionally select a condition that must be met in order to apply this column template. You can select either even or odd row numbers, or supply a PL/SQL expression.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(81569158170254910)
,p_name=>'F4000_P258_ROW_TEMPLATE_COND4'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_imp.id(2346347660092590)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Column Template 4 Condition'
,p_source=>'ROW_TEMPLATE_DISPLAY_COND4'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ROW_TEMPLATE_COND2'
,p_lov=>'.'||wwv_flow_imp.id(84871821607428292)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Condition -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this);"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Optionally select a condition that must be met in order to apply this column template. You can select either even or odd row numbers, or supply a PL/SQL expression.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(81717373837402481)
,p_name=>'F4000_P258_COLUMN_HEADING_TEMPLATE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(81716255746380489)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Column Heading Template'
,p_source=>'COLUMN_HEADING_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">This attribute is only applicable to generic column templates. Use this template to colorize each column header cell. The text of this attribute must include Help to indicate where the cell heading text is to be colorized'
||'.</div>',
'<div class="htmldbInfoBodyP">For example:</div>',
'<pre>',
' &lt;th &gt;Item Help Text&lt;/th&gt;',
'</pre>',
'<div class="htmldbInfoBodyP">If you do not want any column headings, enter the following:</div>',
'<pre>',
'OMIT',
'</pre>',
'<div class="htmldbInfoBodyP">If you do use this attribute, &PRODUCT_NAME. engine applies the default column heading template.</div>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(121996405583446302)
,p_name=>'P258_BEFORE_COLUMN_HEADING'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(81716255746380489)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Before Column Heading'
,p_source=>'BEFORE_COLUMN_HEADING'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Display this text before report headings.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(121997415626449175)
,p_name=>'P258_AFTER_COLUMN_HEADING'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(81716255746380489)
,p_use_cache_before_default=>'NO'
,p_prompt=>'After Column Heading'
,p_source=>'AFTER_COLUMN_HEADING'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Display this text after report headings.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(166718960697643890)
,p_name=>'F4000_P258_REFERENCE_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(33633213596068637)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Reference Master Template From'
,p_source=>'REFERENCE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FLOW_SUBSCRIBE_FROM_REPORT_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- '' || lower(wwv_flow_lang.system_message(''NO_TEMPLATE'')) || '' -'' d,',
'       0 r ',
'  from sys.dual ',
' union all',
'select flow_id||'' : ''||row_template_name||decode(theme_id,',
'       null,',
'       '''',',
'       '' (''||theme_id||'')'') d, ',
'       id r',
'  from wwv_flow_row_templates',
' where flow_id != nvl(:fb_flow_id,0) ',
'   and flow_id in ( select f.id',
'                      from wwv_main_apps_dev f',
'                     where security_group_id = :flow_security_group_id ',
'                       and build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') ',
'                       and exists ( select 1 ',
'                                      from wwv_flow_developers',
'                                     where userid            = :flow_user ',
'                                       and ( flow_id is null or flow_id = f.id ) ',
'                                       and security_group_id = :flow_security_group_id)',
'    )',
'order by 1'))
,p_cSize=>60
,p_cMaxlength=>2000
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">You may select an existing template in this workspace or another template in your workspace''s schema. By selecting an existing template, you become a subscriber to that template.</div>',
'<div class="htmldbInfoBodyP">To load a new copy of any master template, click <span class="fielddatabold">Refresh</span>.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(286281925598736656)
,p_name=>'P258_ID_NEXT'
,p_item_sequence=>390
,p_item_plug_id=>wwv_flow_imp.id(2346347658087535)
,p_prompt=>'P258_ID_NEXT'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(286282327774736657)
,p_name=>'P258_ID_PREV'
,p_item_sequence=>400
,p_item_plug_id=>wwv_flow_imp.id(2346347658087535)
,p_prompt=>'P258_ID_PREV'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(286282700053736661)
,p_name=>'P258_ID_COUNT'
,p_item_sequence=>410
,p_item_plug_id=>wwv_flow_imp.id(2346347658087535)
,p_prompt=>'Report Template'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies report template'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1094586706434933036)
,p_name=>'P258_JAVASCRIPT_FILE_URLS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1094586653151933035)
,p_use_cache_before_default=>'NO'
,p_prompt=>'FILE URLs'
,p_source=>'JAVASCRIPT_FILE_URLS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter JavaScript file URLs for code to be loaded on this page. Each URL has to be written into a new line. If you provide a minified version of your file you can use the substitution string <code>#MIN#</code> to include <code>.min</code> or <code>'
||'#MIN_DIRECTORY#</code> to include <code>minified/</code> in your file URL for a regular page view and an empty string if the page is viewed in debug mode. You also have access to the substitution string <code>#APP_VERSION#</code> if you want to inclu'
||'de the application''s version in the file URL.</p>',
'',
'<p>Note: You do not need to include opening or closing <code>script</code> tags. Just write the URL.',
'',
'<p>',
'Examples:',
'<ul>',
'  <li>Standard file reference',
'      <pre>/myjs/main.js</pre>',
'  </li>',
'  <li>Standard file reference which loads the minified file main.min.js from /myjs/minified/ for regular page views and main.js from /myjs/ in debug mode.',
'      <pre>/myjs/#MIN_DIRECTORY#main#MIN#.js</pre>',
'  </li>',
'  <li>Use this syntax if the library is also used from a RequireJS require call. The define name must match what is used in the requirejs.config paths and the value must be the global symbol exposed by the library. Only applies when using RequireJS. '
||'This avoids RequireJS  loading that library a second time.',
'      <pre>[define hammerjs=Hammer]/myjs/hammer.js</pre>',
'  </li>',
'  <li>Use this syntax if the file has a dependency on RequireJS. This will automatically load RequireJS before this file.',
'      <pre>[require requirejs]/myjs/main.js</pre>',
'  </li>',
'  <li>Use this syntax if the file has a dependency on Oracle JET. This will automatically load RequireJS and the Oracle JET RequireJS configuration before this file.',
'      <pre>[require jet]/myjs/main.js</pre>',
'  </li>',
'  <li>File reference using a query string in the URL referencing the application version, such that when the application is upgraded (and the version is incremented), the browser will be instructed to always load the new file and ignore any previousl'
||'y cached files.',
'      <pre>/myjs/main.js?version=#APP_VERSION#</pre>',
'  </li>',
'</ul>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1094586832963933037)
,p_name=>'P258_JAVASCRIPT_CODE_ONLOAD'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1094586653151933035)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Execute when Page Loads'
,p_source=>'JAVASCRIPT_CODE_ONLOAD'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>15
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter JavaScript code to execute when the page loads. The code is executed after the JavaScript code generated by &PRODUCT_NAME..</p>',
'',
'<p>Note: You do not need to add any opening or closing <code>script</code> tags, just the JavaScript code.</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'JAVASCRIPT'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1094586966491933038)
,p_name=>'P258_CSS_FILE_URLS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1094586559791933034)
,p_use_cache_before_default=>'NO'
,p_prompt=>'File URLs'
,p_source=>'CSS_FILE_URLS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter Cascading Style Sheet file URLs to be loaded for this page template. Each URL has to be written into a new line. If you provide a minified version of your file you can use the substitution string <code>#MIN#</code> to include <code>.min</cod'
||'e> or <code>#MIN_DIRECTORY#</code> to include <code>minified/</code> in your file URL for a regular page view and an empty string if the page is viewed in debug mode. You also have access to the substitution string <code>#APP_VERSION#</code> if you w'
||'ant to include the application''s version in the file URL.</p>',
'',
'<p>Note: You do not need to include opening or closing <code>link</code> tags. Just include the file URL.</p>',
'',
'<p>',
'Examples:',
'<ul>',
'  <li>Standard file reference',
'      <pre>/mycss/main.css</pre>',
'  </li>',
'  <li>Standard file reference which loads the minified file main.min.css from /mycss/minified/ for regular page views and main.css from /mycss/ in debug mode.',
'      <pre>/mycss/#MIN_DIRECTORY#main#MIN#.css</pre>',
'  </li>',
'  <li>Conditional media query',
'      <pre>[media="only screen and (max-device-width: 480px)"]/mycss/smartphone.css</pre>',
'  </li>',
'  <li>File reference using a query string in the URL referencing the application version, such that when the application is upgraded (and the version is incremented), the browser will be instructed to always load the new file and ignore any previousl'
||'y cached files.',
'      <pre>/mycss/main.css?version=#APP_VERSION#</pre>',
'  </li>',
'</ul>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1331350164401223303)
,p_name=>'P258_INTERNAL_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2346347659089700)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Template Identifier'
,p_source=>'INTERNAL_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Template identifier, this is used when switching and upgrading themes and cannot be modified.',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2104771809517963281)
,p_name=>'P258_THEME_IS_SUBSCRIBED'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(2346347659089700)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(147424606635330192)
,p_computation_sequence=>10
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P258_THEME'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2104772167942969692)
,p_computation_sequence=>10
,p_computation_item=>'P258_THEME_IS_SUBSCRIBED'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'    l_is_subscribed varchar2(16) := ''NONE'';',
'begin',
'  ',
'    for c1 in (',
'        select t.reference_id template_ref_id, ',
'               th.reference_id theme_ref_id',
'          from wwv_flow_row_templates t, wwv_flow_themes th',
'         where t.id                 = :F4000_P258_ID',
'           and t.flow_id            = th.flow_id',
'           and t.theme_id           = th.theme_id',
'           and t.security_group_id  = :workspace_id',
'           and th.security_group_id = t.security_group_id',
'    ) loop',
'        if c1. theme_ref_id is not null then',
'            if c1.template_ref_id is not null then',
'                l_is_subscribed := ''BOTH'';',
'            else ',
'                l_is_subscribed := ''THEME'';',
'            end if;',
'        end if;    ',
'    end loop;',
'',
'    return l_is_subscribed;',
'',
'end;'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(36873662469659426)
,p_computation_sequence=>20
,p_computation_item=>'F4000_P258_REFRESH'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'Unable to compute item value.'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(166767555916691592)
,p_validation_name=>'reference id not null'
,p_validation_sequence=>10
,p_validation=>'F4000_P258_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Reference ID must be specified to refresh the template.'
,p_when_button_pressed=>wwv_flow_imp.id(166704164225630527)
,p_associated_item=>wwv_flow_imp.id(166718960697643890)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(166777376822697105)
,p_validation_name=>'reference id not zero'
,p_validation_sequence=>20
,p_validation=>'F4000_P258_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_ZERO'
,p_error_message=>'Template to refresh must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(166704164225630527)
,p_associated_item=>wwv_flow_imp.id(166718960697643890)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(82403813964612670)
,p_validation_name=>'NameNotNull'
,p_validation_sequence=>30
,p_validation=>'F4000_P258_ROW_TEMPLATE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Template Name must be provided.'
,p_when_button_pressed=>wwv_flow_imp.id(2346347631058235)
,p_associated_item=>wwv_flow_imp.id(2346347638058255)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(116603722777949604)
,p_validation_name=>'unique template name'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_row_templates ',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :workspace_id',
'   and theme_id          = :P258_THEME',
'   and row_template_name = :F4000_P258_ROW_TEMPLATE_NAME',
'   and id               != :F4000_P258_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Template name must be unique'
,p_associated_item=>wwv_flow_imp.id(2346347638058255)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(24047594688574802)
,p_tabular_form_region_id=>wwv_flow_imp.id(20118983404167526)
,p_validation_name=>'Template Options - No duplicates name'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_template_options',
' where flow_id              = :FB_FLOW_ID',
'   and theme_id             = :P258_THEME',
'   and report_template_id   = :F4000_P258_ID',
'   and security_group_id    = :WORKSPACE_ID',
'   and name                 = :NAME',
'   and template_types       = :TEMPLATE_TYPES',
'   and (:ID is null or id != :ID)'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#COLUMN_HEADER# must be unique.'
,p_validation_condition=>'F4000_P258_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_exec_cond_for_each_row=>'Y'
,p_associated_column=>'NAME'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(24047762352574804)
,p_tabular_form_region_id=>wwv_flow_imp.id(20118983404167526)
,p_validation_name=>'Template Options - No duplicates classes'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_template_options',
' where flow_id              = :FB_FLOW_ID',
'   and theme_id             = :P258_THEME',
'   and report_template_id   = :F4000_P258_ID',
'   and security_group_id    = :WORKSPACE_ID',
'   and css_classes          = :CSS_CLASSES',
'   and template_types       = :TEMPLATE_TYPES',
'   and (:ID is null or id != :ID)'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#COLUMN_HEADER# must be unique.'
,p_validation_condition=>'F4000_P258_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_exec_cond_for_each_row=>'Y'
,p_associated_column=>'CSS_CLASSES'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(397291918493409185)
,p_name=>'ENABLE PREVIOUS'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P258_ID_PREV'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(397292204618409185)
,p_event_id=>wwv_flow_imp.id(397291918493409185)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(286272007882736617)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(397292324380410866)
,p_name=>'ENABLE NEXT'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P258_ID_NEXT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(397292600298410866)
,p_event_id=>wwv_flow_imp.id(397292324380410866)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(286271918926736617)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(805660071958101245)
,p_name=>'Row Template Condition 1 Changes'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P258_ROW_TEMPLATE_COND1'
,p_condition_element=>'F4000_P258_ROW_TEMPLATE_COND1'
,p_triggering_condition_type=>'NOT_EQUALS'
,p_triggering_expression=>'NOT_CONDITIONAL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(805660125669101246)
,p_event_id=>wwv_flow_imp.id(805660071958101245)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P258_ROW_TEMPLATE_CONDITION1'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(805660228504101247)
,p_event_id=>wwv_flow_imp.id(805660071958101245)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P258_ROW_TEMPLATE_CONDITION1'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(805660387460101248)
,p_name=>'Row Template Condition 2 Changes'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P258_ROW_TEMPLATE_COND2'
,p_condition_element=>'F4000_P258_ROW_TEMPLATE_COND2'
,p_triggering_condition_type=>'NOT_EQUALS'
,p_triggering_expression=>'NOT_CONDITIONAL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(805660452134101249)
,p_event_id=>wwv_flow_imp.id(805660387460101248)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P258_ROW_TEMPLATE_CONDITION2'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(805660529092101250)
,p_event_id=>wwv_flow_imp.id(805660387460101248)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P258_ROW_TEMPLATE_CONDITION2'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(846215325705982701)
,p_name=>'Row Template Condition 3 Changes'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P258_ROW_TEMPLATE_COND3'
,p_condition_element=>'F4000_P258_ROW_TEMPLATE_COND3'
,p_triggering_condition_type=>'NOT_EQUALS'
,p_triggering_expression=>'NOT_CONDITIONAL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(846215445883982702)
,p_event_id=>wwv_flow_imp.id(846215325705982701)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P258_ROW_TEMPLATE_CONDITION3'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(846215520026982703)
,p_event_id=>wwv_flow_imp.id(846215325705982701)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P258_ROW_TEMPLATE_CONDITION3'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(846215660135982704)
,p_name=>'Row Template Condition 4 Changes'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P258_ROW_TEMPLATE_COND4'
,p_condition_element=>'F4000_P258_ROW_TEMPLATE_COND4'
,p_triggering_condition_type=>'NOT_EQUALS'
,p_triggering_expression=>'NOT_CONDITIONAL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(846215726551982705)
,p_event_id=>wwv_flow_imp.id(846215660135982704)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P258_ROW_TEMPLATE_CONDITION4'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(846215885918982706)
,p_event_id=>wwv_flow_imp.id(846215660135982704)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P258_ROW_TEMPLATE_CONDITION4'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(9687943248802612)
,p_name=>'upper case identifier'
,p_event_sequence=>90
,p_triggering_element_type=>'COLUMN'
,p_triggering_region_id=>wwv_flow_imp.id(20118983404167526)
,p_triggering_element=>'DISPLAY_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(9688129768802614)
,p_event_id=>wwv_flow_imp.id(9687943248802612)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
':NAME := regexp_replace(',
'      srcstr     => :DISPLAY_NAME,',
'      pattern    => ''[^'' || wwv_flow_utilities.c_alnum || '']+'',',
'      replacestr => ''_'' );'))
,p_attribute_02=>'DISPLAY_NAME'
,p_attribute_03=>'NAME'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(9688556804802618)
,p_name=>'refresh template options on cancel'
,p_event_sequence=>100
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'body'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosecanceldialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(9688601258802619)
,p_event_id=>wwv_flow_imp.id(9688556804802618)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(20118983404167526)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(9688760970802620)
,p_event_id=>wwv_flow_imp.id(9688556804802618)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(707631914751011279)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3002006450333518)
,p_name=>'Show Publish Success Msg'
,p_event_sequence=>110
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(168807056558718055)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3002195697333519)
,p_event_id=>wwv_flow_imp.id(3002006450333518)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ( this.data.successMessage ) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(286283716135736670)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_PAGINATION'
,p_process_name=>'Get Next or Previous Primary Key Value'
,p_attribute_02=>'WWV_FLOW_ROW_TEMPLATES'
,p_attribute_03=>'F4000_P258_ID'
,p_attribute_04=>'ID'
,p_attribute_07=>'THEME_ID'
,p_attribute_08=>'ROW_TEMPLATE_NAME'
,p_attribute_09=>'P258_ID_NEXT'
,p_attribute_10=>'P258_ID_PREV'
,p_attribute_13=>'P258_ID_COUNT'
,p_attribute_14=>'flow_id = :fb_flow_id and ROW_TEMPLATE_TYPE = ''GENERIC_COLUMNS'''
,p_process_error_message=>'Unable to run Get Next or Previous Primary Key Value process.'
,p_internal_uid=>286283716135736670
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(115831113618183762)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'WWV_FLOW_ROW_TEMPLATES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_ROW_TEMPLATES'
,p_attribute_03=>'F4000_P258_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_internal_uid=>115831113618183762
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(166801747924710582)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh template 1'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_report_template (',
'    p_master_template_id         => :F4000_P258_REFERENCE_ID,',
'    p_subscribing_template_id    => :F4000_P258_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying template.'
,p_process_when_button_id=>wwv_flow_imp.id(166704164225630527)
,p_process_when=>'F4000_P258_REFERENCE_ID'
,p_process_when_type=>'VALUE_OF_ITEM_IN_COND_1_NOT_EQ_COND_2'
,p_process_when2=>'0'
,p_process_success_message=>'Template Copied.'
,p_internal_uid=>166801747924710582
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2346347649058271)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process Row of WWV_FLOW_ROW_TEMPLATES'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select 1 from SYS.dual',
'where :F4000_P258_ID is null',
'or exists (select 1 from wwv_flow_row_templates',
'                   where security_group_id = :flow_security_group_id and',
'      flow_id = :FB_FLOW_ID and',
'      id = :F4000_P258_ID)) loop',
'wwv_flow_dml.process(',
'  p_action => wwv_flow.g_request,',
'  p_table_owner => ''#OWNER#'',',
'  p_table_name  => ''WWV_FLOW_ROW_TEMPLATES'',',
'  p_rowid       => v(''F4000_P258_ID''),',
'  p_alt_rowid   => ''ID'');',
'exit;',
'end loop;',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error processing row.'
,p_process_when=>'COPY_TEMPLATE'
,p_process_when_type=>'REQUEST_NOT_IN_CONDITION'
,p_process_success_message=>'Changes to row template &F4000_P258_ROW_TEMPLATE_NAME. processed.'
,p_internal_uid=>2346347649058271
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(36883275611668571)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh template 2'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_report_template (',
'    p_master_template_id         => :F4000_P258_REFERENCE_ID,',
'    p_subscribing_template_id    => :F4000_P258_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying template.'
,p_process_when=>':F4000_P258_REFERENCE_ID is not null and :F4000_P258_REFRESH = ''Y'' and upper(:request) like ''APPLY%'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Template Copied.'
,p_internal_uid=>36883275611668571
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1449462856927055531)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sync template option presets'
,p_process_sql_clob=>'wwv_flow_templates_util.sync_report_tmplopt_presets(:F4000_P258_ID);'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'nvl(:P258_PRESET_TEMPLATE_OPTIONS,''NOPRESETS'') <> nvl(:P258_PRESET_TMPLOPT_CHECK,''NOPRESETS'') '
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>1449462856927055531
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(11084279033520443)
,p_process_sequence=>80
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(20118983404167526)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Template Options - Save Interactive Grid Data'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>11084279033520443
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(166813158695720764)
,p_process_sequence=>80
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove reference id as needed'
,p_process_sql_clob=>'wwv_flow_copy_metadata.remove_report_reference_id (:F4000_P258_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error setting template id to null.'
,p_process_when=>'F4000_P258_REFERENCE_ID'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'0'
,p_internal_uid=>166813158695720764
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(24047459205574801)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_region_id=>wwv_flow_imp.id(20118983404167526)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'upper :name'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':NAME := REGEXP_REPLACE(',
'      srcstr     => :NAME,',
'      pattern    => ''[^'' || wwv_flow_utilities.c_alnum || '']+'',',
'      replacestr => ''_'' );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'F4000_P258_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_exec_cond_for_each_row=>'Y'
,p_internal_uid=>24047459205574801
);
end;
/
prompt --application/pages/page_00260
begin
wwv_flow_imp_page.create_page(
 p_id=>260
,p_name=>'Themes'
,p_alias=>'THEMES'
,p_step_title=>'Themes'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879423075323511)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_themes.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(40585504519890825)
,p_plug_name=>'Themes'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       theme_id,',
'       current_theme_id,',
'       theme_name || (case when theme_id = current_theme_id then '' *'' end) as theme_name,',
'       version_identifier,',
'       icon_class,',
'       wwv_flow_utilities.prepare_url( edit_link ) edit_link,',
'       case when theme_id = current_theme_id then ''Y'' else ''N'' end as is_current,',
'       case when theme_id = current_theme_id then ''icon-check'' end as is_current_css,',
'       wwv_flow_theme_dev.is_universal_theme_yn(p_theme_id => id) as is_universal_theme,',
'       case when wwv_flow_theme_dev.is_universal_theme_yn(p_theme_id => id)=''Y'' then ''icon-check'' end as is_universal_theme_css,',
'       subscribed_from,',
'       subscribers,',
'       page_templates + region_templates + button_templates + menu_templates + list_templates + label_templates + report_templates + cal_templates + popup_templates + template_components all_templates,',
'       page_templates,',
'       region_templates,',
'       button_templates,',
'       menu_templates,',
'       list_templates,',
'       label_templates,',
'       report_templates,',
'       cal_templates,',
'       popup_templates,',
'       template_components',
'from (',
'select id,',
'      theme_id,',
'      (select theme_id as current_theme_id from wwv_flows where id=:fb_flow_id) as current_theme_id,',
'      theme_name || '' - '' || theme_id as theme_name,',
'      version_identifier,',
'      ''icon-sc-theme'' icon_class,',
'      wwv_flow_page_api.get_url (',
'          p_page => 267,',
'          p_items => ''P267_ID'',',
'          p_values => id,',
'          p_clear_cache => 267 ) edit_link,',
'       case when reference_id is not null then',
'           coalesce ( ( select case',
'                                 when security_group_id in ( 11, 12 ) then wwv_flow_lang.system_message( ''SUBSCRIBED_FROM.THEME_REPOSITORY'' )',
'                                 else to_char( flow_id )',
'                               end',
'                          from wwv_flow_themes',
'                         where id                = t.reference_id',
'                           and security_group_id in ( :WORKSPACE_ID, 11, 12 )',
'                       ),',
'                       wwv_flow_lang.system_message( ''SUBSCRIBED_FROM.NONEXISTING_MASTER'' )',
'                    )',
'       end as subscribed_from,',
'       ( select case when count(*) > 0 then count(*) end',
'           from wwv_flow_themes',
'          where reference_id      = t.id',
'            and security_group_id = :WORKSPACE_ID',
'       ) as subscribers,',
'       (select count(*) from wwv_flow_templates where flow_id = :fb_flow_id and theme_id = t.theme_id) page_templates,',
'       (select count(*) from WWV_FLOW_PAGE_PLUG_TEMPLATES where flow_id = :fb_flow_id and theme_id = t.theme_id) region_templates,',
'       (select count(*) from WWV_FLOW_BUTTON_TEMPLATES where flow_id = :fb_flow_id and theme_id = t.theme_id) button_templates,',
'       (select count(*) from WWV_FLOW_MENU_TEMPLATES where flow_id = :fb_flow_id and theme_id = t.theme_id) menu_templates,',
'       (select count(*) from WWV_FLOW_LIST_TEMPLATES where flow_id = :fb_flow_id and theme_id = t.theme_id) list_templates,',
'       (select count(*) from WWV_FLOW_FIELD_TEMPLATES where flow_id = :fb_flow_id and theme_id = t.theme_id) label_templates,',
'       (select count(*) from WWV_FLOW_ROW_TEMPLATES where flow_id = :fb_flow_id and theme_id = t.theme_id) report_templates,',
'       (select count(*) from WWV_FLOW_CAL_TEMPLATES where flow_id = :fb_flow_id and theme_id = t.theme_id) cal_templates,',
'       (select count(*) from WWV_FLOW_POPUP_LOV_TEMPLATE where flow_id = :fb_flow_id and theme_id = t.theme_id) popup_templates,',
'       (select count(*) from wwv_flow_template_components where flow_id = :fb_flow_id and theme_id = t.theme_id) template_components',
'   from WWV_FLOW_THEMES t',
'  where flow_id           = :FB_FLOW_ID',
'    and security_group_id = :flow_security_group_id )'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(40585608941890825)
,p_name=>'Themes'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_pivot=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#EDIT_LINK#" class="a-IRR-icon"><span class="a-Icon #ICON_CLASS#"></span><span class="a-IRR-iconName">#THEME_NAME#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40585822448890851)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'&nbsp;'
,p_allow_pivot=>'N'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40585916838890854)
,p_db_column_name=>'THEME_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Number'
,p_allow_pivot=>'N'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40586030398890855)
,p_db_column_name=>'THEME_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Name'
,p_column_link=>'f?p=&APP_ID.:267:&SESSION.::&DEBUG.::P267_ID:#ID#'
,p_column_linktext=>'#THEME_NAME#'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40586308175890856)
,p_db_column_name=>'IS_CURRENT'
,p_display_order=>4
,p_column_identifier=>'F'
,p_column_label=>'Is Current'
,p_column_html_expression=>'<span class="a-Icon #IS_CURRENT_CSS#"><span class="u-VisuallyHidden">#IS_CURRENT#</span></span>'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_column_alignment=>'CENTER'
,p_rpt_named_lov=>wwv_flow_imp.id(84259319526460470)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(84538979289706815)
,p_db_column_name=>'IS_UNIVERSAL_THEME'
,p_display_order=>14
,p_column_identifier=>'W'
,p_column_label=>'Is Universal Theme'
,p_column_html_expression=>'<span class="a-Icon #IS_UNIVERSAL_THEME_CSS#"><span class="u-VisuallyHidden">#IS_UNIVERSAL_THEME#</span></span>'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_column_alignment=>'CENTER'
,p_rpt_named_lov=>wwv_flow_imp.id(84259319526460470)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1340562746768198337)
,p_db_column_name=>'SUBSCRIBED_FROM'
,p_display_order=>24
,p_column_identifier=>'U'
,p_column_label=>'Subscribed From'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1340562836919198338)
,p_db_column_name=>'SUBSCRIBERS'
,p_display_order=>34
,p_column_identifier=>'V'
,p_column_label=>'Subscribers'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40586211632890855)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>44
,p_column_identifier=>'E'
,p_column_label=>'Edit Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40586424494890856)
,p_db_column_name=>'PAGE_TEMPLATES'
,p_display_order=>64
,p_column_identifier=>'G'
,p_column_label=>'Page Templates'
,p_allow_pivot=>'N'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40586506938890856)
,p_db_column_name=>'REGION_TEMPLATES'
,p_display_order=>74
,p_column_identifier=>'H'
,p_column_label=>'Region Templates'
,p_allow_pivot=>'N'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40586618306890856)
,p_db_column_name=>'BUTTON_TEMPLATES'
,p_display_order=>84
,p_column_identifier=>'I'
,p_column_label=>'Button Templates'
,p_allow_pivot=>'N'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40586708548890856)
,p_db_column_name=>'MENU_TEMPLATES'
,p_display_order=>94
,p_column_identifier=>'J'
,p_column_label=>'Breadcrumb Templates'
,p_allow_pivot=>'N'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40586823212890856)
,p_db_column_name=>'LIST_TEMPLATES'
,p_display_order=>104
,p_column_identifier=>'K'
,p_column_label=>'List Templates'
,p_allow_pivot=>'N'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40586925234890857)
,p_db_column_name=>'LABEL_TEMPLATES'
,p_display_order=>114
,p_column_identifier=>'L'
,p_column_label=>'Label Templates'
,p_allow_pivot=>'N'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40587016960890857)
,p_db_column_name=>'REPORT_TEMPLATES'
,p_display_order=>124
,p_column_identifier=>'M'
,p_column_label=>'Report Templates'
,p_allow_pivot=>'N'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40587122871890857)
,p_db_column_name=>'CAL_TEMPLATES'
,p_display_order=>134
,p_column_identifier=>'N'
,p_column_label=>'Calendar Templates'
,p_allow_pivot=>'N'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(40587216109890857)
,p_db_column_name=>'POPUP_TEMPLATES'
,p_display_order=>144
,p_column_identifier=>'O'
,p_column_label=>'Popup Templates'
,p_allow_pivot=>'N'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1602538698824401)
,p_db_column_name=>'TEMPLATE_COMPONENTS'
,p_display_order=>154
,p_column_identifier=>'AA'
,p_column_label=>'Template Components'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(345065204888426150)
,p_db_column_name=>'CURRENT_THEME_ID'
,p_display_order=>164
,p_column_identifier=>'Q'
,p_column_label=>'Current Theme Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(718743949460466155)
,p_db_column_name=>'ICON_CLASS'
,p_display_order=>174
,p_column_identifier=>'R'
,p_column_label=>'ICON_CLASS'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(928046701514850016)
,p_db_column_name=>'ALL_TEMPLATES'
,p_display_order=>184
,p_column_identifier=>'S'
,p_column_label=>'Templates'
,p_column_link=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.:RP,4003,RIR:IR_THEME,P4003_THEME:#THEME_ID#,#THEME_ID#:'
,p_column_linktext=>'#ALL_TEMPLATES#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1143248183217567434)
,p_db_column_name=>'IS_CURRENT_CSS'
,p_display_order=>194
,p_column_identifier=>'T'
,p_column_label=>'IS_CURRENT_CSS'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(711860292864245730)
,p_db_column_name=>'IS_UNIVERSAL_THEME_CSS'
,p_display_order=>204
,p_column_identifier=>'Y'
,p_column_label=>'Is Universal Theme Css'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2892830635137314)
,p_db_column_name=>'VERSION_IDENTIFIER'
,p_display_order=>214
,p_column_identifier=>'AB'
,p_column_label=>'Version'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(40587517034894377)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_type=>'REPORT'
,p_report_alias=>'1287303371536643'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_view_mode=>'REPORT'
,p_report_columns=>'THEME_ID:THEME_NAME:VERSION_IDENTIFIER:IS_UNIVERSAL_THEME:IS_CURRENT:SUBSCRIBED_FROM:SUBSCRIBERS:ALL_TEMPLATES:PAGE_TEMPLATES:REGION_TEMPLATES:BUTTON_TEMPLATES:LIST_TEMPLATES:TEMPLATE_COMPONENTS:'
,p_sort_column_1=>'THEME_ID'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(58960202850264132)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(58949101764235429)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Themes'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(60309032282141216)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>A Theme is a named collection of templates used to define the user interface of an application.</p>',
'',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(60454821641357947)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(60448901162323653)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(35066701739635046)
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>'select 1 from wwv_flow_themes where flow_id = :fb_flow_id'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(188985409785913641)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(40585504519890825)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:260:&SESSION.::&DEBUG.:260,RIR::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(60462304634400305)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(40585504519890825)
,p_button_name=>'SWITCH'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Switch Theme'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:179:&SESSION.::&DEBUG.:179::'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare c pls_integer; begin',
'select count(*) into c from WWV_FLOW_THEMES t where FLOW_ID = :fb_flow_id;',
'if c > 1 then return true; else return false; end if;',
'end;'))
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(59115302349594269)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(40585504519890825)
,p_button_name=>'CREATE_THEME'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:207:&SESSION.::&DEBUG.:207::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(59118129146611490)
,p_computation_sequence=>20
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'260'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(928046448457850013)
,p_name=>'Themes report dialog closed'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(60454821641357947)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(928046526432850014)
,p_event_id=>wwv_flow_imp.id(928046448457850013)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(40585504519890825)
);
end;
/
prompt --application/pages/page_00263
begin
wwv_flow_imp_page.create_page(
 p_id=>263
,p_name=>'Create Breadcrumb Region - Breadcrumb Container Region'
,p_alias=>'CREATE-BREADCRUMB-REGION-BREADCRUMB-CONTAINER-REGION'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Breadcrumb Region'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213261028690930718)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_breadcrumb.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4214301685656288)
,p_plug_name=>'Create Breadcrumb Region'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>3
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_plug_header=>'<p>Use this wizard to create a breadcrumb user interface navigation control.  Start by defining the name, template, and placement of the breadcrumb region container.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'Region generated 04-DEC-2002 18:37:44'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(16150807852118283)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(16141621180084222)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46324232098941368)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4215226898656310)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46324232098941368)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4215518907656310)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(46324232098941368)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(16171505521174308)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(46324232098941368)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_condition=>'P181_REGION_TYPE'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4216430060656335)
,p_branch_action=>'481'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
,p_branch_comment=>'Generated 04-DEC-2002 18:37:44'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(574137709805781533)
,p_branch_action=>'f?p=&APP_ID.:181:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(16171505521174308)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4215029716656307)
,p_name=>'P263_REGION_TITLE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(4214301685656288)
,p_item_default=>'wwv_flow_lang.system_message(''BREADCRUMB'');'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Region Title'
,p_post_element_text=>' '
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'<p>Enter a title for this region.</p>'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 04-DEC-2002 18:37:44'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4227008512679725)
,p_name=>'P263_PAGE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(4214301685656288)
,p_prompt=>'Page:'
,p_source=>'FB_FLOW_PAGE_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'This attribute identifies the application page.'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4230126305694358)
,p_name=>'P263_REGION_TEMPLATE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(4214301685656288)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Region Template'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select DEFAULT_MENUR_TEMPLATE r ',
'from wwv_flow_themes ',
'where flow_id = :fb_flow_id and theme_id = :fb_theme_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REGION.TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.d, ',
'       t.r ',
'  from ( select wwv_flow_escape.html(page_plug_template_name) d, ',
'             id r',
'           from wwv_flow_page_plug_templates',
'          where security_group_id = :FLOW_SECURITY_GROUP_ID',
'            and flow_id           = :FB_FLOW_ID',
'            and (:FB_THEME_ID is null or theme_id = :FB_THEME_ID)',
'          order by upper(page_plug_template_name) ) t'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'No Template'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'<p>Select a region template.</p>'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4234201287706029)
,p_name=>'P263_DISPLAY_POINT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(4214301685656288)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_template_dev.get_breadcrumb_display_point (',
'    p_application_id   => :FB_FLOW_ID,',
'    p_theme_id         => :FB_THEME_ID )'))
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Slot'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select dp.name as d,',
'       dp.placeholder as r ',
'  from wwv_flow_page_tmpl_disp_points dp ',
' where dp.security_group_id  = :WORKSPACE_ID',
'   and dp.flow_id            = :FB_FLOW_ID',
'   and dp.has_region_support = ''Y''',
'   and dp.page_template_id   = ( select coalesce( p.step_template, ( select t.default_page_template',
'                                                                      from wwv_flows f,',
'                                                                           wwv_flow_themes t',
'                                                                     where f.security_group_id = dp.security_group_id ',
'                                                                       and f.id                = dp.flow_id',
'                                                                       and t.security_group_id = f.security_group_id ',
'                                                                       and t.flow_id           = f.id',
'                                                                       and t.theme_id          = f.theme_id ) )',
'                                 from wwv_flow_steps p',
'                                where p.security_group_id = dp.security_group_id ',
'                                  and p.flow_id           = dp.flow_id',
'                                  and p.id                = :FB_FLOW_PAGE_ID )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Slot -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the slot.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4236606959717166)
,p_name=>'P263_SEQUENCE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(4214301685656288)
,p_prompt=>'Sequence'
,p_post_element_text=>' '
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Specify the sequence for this component.  The sequence determines the order of evaluation.</p>'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4238000856724796)
,p_name=>'P263_REGION_TYPE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(4214301685656288)
,p_prompt=>'Breadcrumb'
,p_post_element_text=>' '
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4240603065734951)
,p_name=>'P263_MENU_TEMPLATE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(4214301685656288)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select default_menu_template from wwv_flow_themes where flow_id = :fb_flow_id and theme_id = :fb_theme_id and default_menu_template is not null) loop',
'   return c1.default_menu_template;',
'end loop;',
'return null;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Breadcrumb Template'
,p_post_element_text=>' '
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(165620013985308797)
,p_computation_sequence=>10
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_page_dev.get_theme_id (',
'    p_application_id => :FB_FLOW_ID,',
'    p_page_id        => :FB_FLOW_PAGE_ID )'))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(101054205105364788)
,p_validation_name=>'RegionTitleMand'
,p_validation_sequence=>10
,p_validation=>'P263_REGION_TITLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Region title must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(4215518907656310)
,p_associated_item=>wwv_flow_imp.id(4215029716656307)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(101057024151370342)
,p_validation_name=>'DisplayPointMand'
,p_validation_sequence=>20
,p_validation=>'P263_DISPLAY_POINT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Slot must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(4215518907656310)
,p_associated_item=>wwv_flow_imp.id(4234201287706029)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(101059000518382425)
,p_validation_name=>'SeqMand'
,p_validation_sequence=>30
,p_validation=>'P263_SEQUENCE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Sequence must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(4215518907656310)
,p_associated_item=>wwv_flow_imp.id(4236606959717166)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(574137535995781531)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(4215226898656310)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(574137687231781532)
,p_event_id=>wwv_flow_imp.id(574137535995781531)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00264
begin
wwv_flow_imp_page.create_page(
 p_id=>264
,p_name=>'Create Breadcrumb Region - Breadcrumb Entry'
,p_alias=>'CREATE-BREADCRUMB-REGION-BREADCRUMB-ENTRY'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Breadcrumb Region'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213261028690930718)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_breadcrumb.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4217004399656336)
,p_plug_name=>'Create Breadcrumb Region'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Region generated 04-DEC-2002 18:37:44',
'<p>Identify the breadcrumb entry that will be used to identify this page.  You also identify the page which is the hierarchical parent to this page.</p>'))
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(16147128715105369)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(16141621180084222)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47746823146842377)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4217911180656339)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47746823146842377)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4218004320656340)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(47746823146842377)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4218119404656340)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(47746823146842377)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4219616249656343)
,p_branch_action=>'286'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
,p_branch_comment=>'Generated 04-DEC-2002 18:37:44'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4219122423656342)
,p_branch_action=>'481'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(4218119404656340)
,p_branch_sequence=>20
,p_branch_comment=>'Generated 04-DEC-2002 18:37:44'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4217718329656339)
,p_name=>'P264_MENU_TEXT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(4217004399656336)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Breadcrumb Entry Label'
,p_source=>'select name from wwv_flow_steps where flow_id = :fb_flow_id and id = :fb_flow_page_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from WWV_FLOW_MENU_OPTIONS mo',
'where menu_id = to_number(substr(:P481_REGION_TYPE,2)) and ',
'      PAGE_ID = :FB_FLOW_PAGE_ID'))
,p_display_when_type=>'NOT_EXISTS'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Specify the label for this breadcrumb entry.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 04-DEC-2002 18:37:44'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4243410946756095)
,p_name=>'P264_MENU_LINK'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(4217004399656336)
,p_use_cache_before_default=>'NO'
,p_item_default=>'''f?p=&''||''FLOW_ID.:''||v(''FB_FLOW_PAGE_ID'')||'':&''||''SESSION.'''
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Breadcrumb Entry Link'
,p_source=>'''f?p=&''||''FLOW_ID.:''||v(''FB_FLOW_PAGE_ID'')||'':&''||''SESSION.'''
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>50
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4257707314792899)
,p_name=>'P264_PARENT_MENU'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(4217004399656336)
,p_prompt=>'Parent Entry'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(short_name)||'' (''||page_id||'')'' name, id',
'from wwv_flow_menu_options',
'where menu_id = ltrim(:P481_REGION_TYPE,''M'')',
'order by upper(short_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Parent -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from WWV_FLOW_MENU_OPTIONS mo',
'where menu_id = to_number(substr(:P481_REGION_TYPE,2)) and ',
'      PAGE_ID = :FB_FLOW_PAGE_ID'))
,p_display_when_type=>'NOT_EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Select this breadcrumb entry''s hierarchical parent.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114071712289039011)
,p_name=>'P264_PAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(4217004399656336)
,p_prompt=>'Page:'
,p_source=>'FB_FLOW_PAGE_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'This attribute identifies the application page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114083605981131862)
,p_name=>'P264_REGION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(4217004399656336)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Region to be created:'
,p_source=>'P263_REGION_TITLE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Identifies the region that is used as the container for the breadcrumb.  The region identifies the position on the page to place the breadcrumb.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(138187904182753297)
,p_name=>'P264_BREADCRUMB'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(4217004399656336)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&P481_REGION.'
,p_prompt=>'Breadcrumb:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name',
'from wwv_flow_menus',
'where flow_id = :fb_flow_id',
'and id = to_number(substr(:P481_REGION_TYPE,2))'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'This is the name of breadcrumb into which you are creating a breadcrumb entry.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(138206211080878248)
,p_name=>'P264_EXISTING_BREADCRUMB_LABEL'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(4217004399656336)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Existing Entry Label:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select SHORT_NAME breadcrumb_entry',
'from WWV_FLOW_MENU_OPTIONS mo',
'where menu_id = to_number(substr(:P481_REGION_TYPE,2)) and ',
'      PAGE_ID = :FB_FLOW_PAGE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from WWV_FLOW_MENU_OPTIONS mo',
'where menu_id = to_number(substr(:P481_REGION_TYPE,2)) and ',
'      PAGE_ID = :FB_FLOW_PAGE_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Creating a breadcrumb region will use this existing breadcrumb entry.  If you wish to change this breadcrumb entry label you can do so after the breadcrumb region has been created.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(138208119045880585)
,p_name=>'P264_EXISTING_PARENT'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(4217004399656336)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Existing Parent:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select (select short_name from wwv_flow_menu_options where id = mo.PARENT_ID) parent_breadcrumb',
'from WWV_FLOW_MENU_OPTIONS mo',
'where menu_id = to_number(substr(:P481_REGION_TYPE,2)) and ',
'      PAGE_ID = :FB_FLOW_PAGE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from WWV_FLOW_MENU_OPTIONS mo',
'where menu_id = to_number(substr(:P481_REGION_TYPE,2)) and ',
'      PAGE_ID = :FB_FLOW_PAGE_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Select this breadcrumb entry''s hierarchical parent.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(101134722410644210)
,p_validation_name=>'P264_MENU_TEXT Not Null'
,p_validation_sequence=>10
,p_validation=>'P264_MENU_TEXT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Menu Option Label must be specified.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from WWV_FLOW_MENU_OPTIONS mo',
'where menu_id = to_number(substr(:P481_REGION_TYPE,2)) and ',
'      PAGE_ID = :FB_FLOW_PAGE_ID'))
,p_validation_condition_type=>'NOT_EXISTS'
,p_when_button_pressed=>wwv_flow_imp.id(4218004320656340)
,p_associated_item=>wwv_flow_imp.id(4217718329656339)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 25-JUL-2003 12:00'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(101134928787644210)
,p_validation_name=>'P264_MENU_LINK Not Null'
,p_validation_sequence=>20
,p_validation=>'P264_MENU_LINK'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Menu Option Label must be specified.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from WWV_FLOW_MENU_OPTIONS mo',
'where menu_id = to_number(substr(:P481_REGION_TYPE,2)) and ',
'      PAGE_ID = :FB_FLOW_PAGE_ID'))
,p_validation_condition_type=>'NOT_EXISTS'
,p_when_button_pressed=>wwv_flow_imp.id(4218004320656340)
,p_associated_item=>wwv_flow_imp.id(4217718329656339)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 25-JUL-2003 12:00'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(574137062020781526)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(4217911180656339)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(574137134617781527)
,p_event_id=>wwv_flow_imp.id(574137062020781526)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00267
begin
wwv_flow_imp_page.create_page(
 p_id=>267
,p_name=>'Create / Edit Theme'
,p_alias=>'CREATE-EDIT-THEME'
,p_step_title=>'Create / Edit Theme'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879423075323511)
,p_javascript_code=>'htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_help_text=>'ui_themes.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1804606589697308)
,p_plug_name=>'Landmark for Displayed Regions '
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_landmark_type=>'region'
,p_landmark_label=>'Displayed Regions'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(22486830752876187)
,p_name=>'Files'
,p_region_name=>'FILES'
,p_parent_plug_id=>wwv_flow_imp.id(1804606589697308)
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>132
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       security_group_id,',
'       file_name,',
'       mime_type,',
'       htmldb_util.filesize_mask(sys.dbms_lob.getLength(file_content)) as file_size,',
'       sys.dbms_lob.getLength(file_content) as file_content,',
'       wwv_flow_file_editor_dev.get_file_reference (',
'           p_scope      => ''THEME'',',
'           p_app_id     => :FB_FLOW_ID,',
'           p_theme_id   => :P267_THEME_ID,',
'           p_file_name  => file_name ) as reference,',
'       wwv_flow_page_api.get_url(',
'           p_page        => 118,',
'           p_clear_cache => 118,',
'           p_items       => ''P118_SCOPE,P118_APP_ID,P118_THEME_ID,P118_ID'',',
'           p_values      => ''THEME,'' || flow_id || '','' || :P267_THEME_ID || '','' || id',
'        ) as edit_link,',
'       nvl(last_updated_on, created_on)                 as updated,',
'       nvl(lower(last_updated_by), lower(created_by))   as updated_by',
'  from ( select f.*, wwv_flow_string_util.get_file_extension(f.file_name) as file_ext from wwv_flow_theme_files f)',
' where flow_id           = :FB_FLOW_ID',
'   and theme_id          = :P267_THEME_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_display_when_condition=>'P267_ID'
,p_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P267_THEME_ID'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>150
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No Files found.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>9999
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22487000323876232)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3567043336979612)
,p_query_column_id=>2
,p_column_alias=>'SECURITY_GROUP_ID'
,p_column_display_sequence=>11
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22487110071876237)
,p_query_column_id=>3
,p_column_alias=>'FILE_NAME'
,p_column_display_sequence=>21
,p_column_heading=>'Name'
,p_use_as_row_header=>'Y'
,p_column_link=>'#EDIT_LINK#'
,p_column_linktext=>'#FILE_NAME#'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22487206680876237)
,p_query_column_id=>4
,p_column_alias=>'MIME_TYPE'
,p_column_display_sequence=>31
,p_column_heading=>'Mime Type'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22487310479876237)
,p_query_column_id=>5
,p_column_alias=>'FILE_SIZE'
,p_column_display_sequence=>51
,p_column_heading=>'File Size'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22487429427876239)
,p_query_column_id=>6
,p_column_alias=>'FILE_CONTENT'
,p_column_display_sequence=>81
,p_column_heading=>'File'
,p_use_as_row_header=>'N'
,p_column_format=>'DOWNLOAD:WWV_FLOW_THEME_FILES:FILE_CONTENT:ID:SECURITY_GROUP_ID:MIME_TYPE:FILE_NAME:LAST_UPDATED_ON:FILE_CHARSET:attachment:&APP_TEXT$DOWNLOAD.:'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(261793403347047683)
,p_query_column_id=>7
,p_column_alias=>'REFERENCE'
,p_column_display_sequence=>71
,p_column_heading=>'Reference'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3566613401979608)
,p_query_column_id=>8
,p_column_alias=>'EDIT_LINK'
,p_column_display_sequence=>91
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3566713476979609)
,p_query_column_id=>9
,p_column_alias=>'UPDATED'
,p_column_display_sequence=>101
,p_column_heading=>'Updated'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_column_alignment=>'CENTER'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3566842384979610)
,p_query_column_id=>10
,p_column_alias=>'UPDATED_BY'
,p_column_display_sequence=>111
,p_column_heading=>'Updated By'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(59029014305181516)
,p_plug_name=>'Name'
,p_region_name=>'THEME_NAME_REGION'
,p_parent_plug_id=>wwv_flow_imp.id(1804606589697308)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_read_only_when_type=>'EXISTS'
,p_plug_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_themes',
'where id = :P267_ID',
'and reference_id is not null',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'Region generated 11-JUN-2004 00:29:53'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(60494608771600292)
,p_plug_name=>'Component Defaults'
,p_region_name=>'COMPONENT_DEFAULTS'
,p_parent_plug_id=>wwv_flow_imp.id(1804606589697308)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>42
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P267_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'Specify component defaults by component type.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(73829002796853667)
,p_plug_name=>'Region Defaults'
,p_region_name=>'REGION_DEFAULTS'
,p_parent_plug_id=>wwv_flow_imp.id(1804606589697308)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>52
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P267_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'Specify region defaults by component type.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(366546306074187573)
,p_name=>'Styles'
,p_parent_plug_id=>wwv_flow_imp.id(1804606589697308)
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>122
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select "ID", ',
'       "NAME",',
'       decode("IS_CURRENT",''Y'',''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'','''') as is_current,',
'       decode("IS_PUBLIC",''Y'',''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'','''') as is_public,',
'       decode("IS_ACCESSIBLE",''Y'',''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'','''') as is_accessible',
'from "#OWNER#"."WWV_FLOW_THEME_STYLES" ',
' where flow_id           = :P267_FLOW_ID',
'   and theme_id          = :P267_THEME_ID',
'   and security_group_id = :WORKSPACE_ID  '))
,p_display_when_condition=>'P267_ID'
,p_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>9999
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No Theme Styles loaded.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(366546618955187578)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_when_cond_type=>'IS_NOT_READ_ONLY'
,p_derived_column=>'N'
,p_ref_schema=>'APEX_050000'
,p_ref_table_name=>'WWV_FLOW_THEME_STYLES'
,p_ref_column_name=>'ID'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(366546931290187586)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Name'
,p_use_as_row_header=>'Y'
,p_column_link=>'f?p=&APP_ID.:177:&SESSION.::&DEBUG.:RP,177:P177_ID:#ID#:'
,p_column_linktext=>'#NAME#'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_050000'
,p_ref_table_name=>'WWV_FLOW_THEME_STYLES'
,p_ref_column_name=>'NAME'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(366547125225187586)
,p_query_column_id=>3
,p_column_alias=>'IS_CURRENT'
,p_column_display_sequence=>3
,p_column_heading=>'Is Current'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_report_column_width=>100
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_050000'
,p_ref_table_name=>'WWV_FLOW_THEME_STYLES'
,p_ref_column_name=>'IS_CURRENT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(879702109115493843)
,p_query_column_id=>4
,p_column_alias=>'IS_PUBLIC'
,p_column_display_sequence=>4
,p_column_heading=>'Is Public'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_report_column_width=>100
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(879702291434493844)
,p_query_column_id=>5
,p_column_alias=>'IS_ACCESSIBLE'
,p_column_display_sequence=>5
,p_column_heading=>'Accessibility Tested'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_report_column_width=>100
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(697004804009046662)
,p_plug_name=>'Theme Subscription'
,p_parent_plug_id=>wwv_flow_imp.id(1804606589697308)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>12
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_query_num_rows=>15
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P267_ID'
,p_plug_read_only_when_type=>'EXISTS'
,p_plug_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_themes',
'where id = :P267_ID',
'and reference_id is not null',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'WWV_FLOW_THEMES',
  'attribute_02', 'THEME_NAME',
  'attribute_03', 'P267_ID',
  'attribute_04', 'P267_REFERENCE_ID',
  'attribute_05', 'SUBSCRIBE_THEME')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(925260747421540222)
,p_plug_name=>'Template Options'
,p_region_name=>'TEMPLATE_OPTIONS'
,p_parent_plug_id=>wwv_flow_imp.id(1804606589697308)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>82
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.template_types,',
'       o.id,',
'       o.display_name,',
'       o.name,',
'       o.display_sequence,',
'       o.css_classes,',
'       o.flow_id,',
'       o.security_group_id,',
'       o.theme_id,',
'       o.help_text,',
'       o.group_id,',
'       ( select g.display_sequence from wwv_flow_template_opt_groups g where g.id = o.group_id ) group_display_sequence,',
'       ( select g.display_name     from wwv_flow_template_opt_groups g where g.id = o.group_id ) group_display_name',
'  from wwv_flow_template_options o',
' where o.flow_id              = :FB_FLOW_ID',
'   and o.theme_id             = :P267_THEME_ID',
'   and o.security_group_id    = :WORKSPACE_ID',
'   and o.virtual_template_id is null'))
,p_plug_source_type=>'NATIVE_IG'
,p_ajax_items_to_submit=>'P267_THEME_ID'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P267_ID'
,p_plug_read_only_when_type=>'EXISTS'
,p_plug_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_themes',
' where id = :P267_ID',
'   and reference_id is not null',
''))
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2800559146512002)
,p_name=>'TEMPLATE_TYPES'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'TEMPLATE_TYPES'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Template Type'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>130
,p_value_alignment=>'LEFT'
,p_is_required=>false
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(655584409399418944)
,p_lov_display_extra=>true
,p_lov_display_null=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>true
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>false
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'BUTTON'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2800604693512003)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>40
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2800728608512004)
,p_name=>'DISPLAY_NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DISPLAY_NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>140
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_item_width=>30
,p_is_required=>true
,p_max_length=>30
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_static_id=>'COLUMN_DISPLAY_NAME'
,p_use_as_row_header=>true
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2800915664512006)
,p_name=>'DISPLAY_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DISPLAY_SEQUENCE'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>'Sequence'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>160
,p_value_alignment=>'RIGHT'
,p_attribute_03=>'left'
,p_attribute_04=>'decimal'
,p_item_width=>5
,p_is_required=>true
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'1'
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2801046543512007)
,p_name=>'CSS_CLASSES'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'CSS_CLASSES'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Classes'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>170
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_max_length=>255
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2801325479512010)
,p_name=>'APEX$ROW_ACTION'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>20
,p_use_as_row_header=>false
,p_display_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2801402291512011)
,p_name=>'APEX$ROW_SELECTOR'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_use_as_row_header=>false
,p_display_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5607099197662111)
,p_name=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Identifier'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>150
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_attribute_06=>'UPPER'
,p_item_width=>30
,p_is_required=>true
,p_max_length=>30
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5607171613662112)
,p_name=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FLOW_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>60
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'FB_FLOW_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5607247039662113)
,p_name=>'SECURITY_GROUP_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'SECURITY_GROUP_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>70
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'WORKSPACE_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5607319061662114)
,p_name=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'THEME_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>80
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'P267_THEME_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5607763373662118)
,p_name=>'GROUP_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'GROUP_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Group'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>180
,p_value_alignment=>'LEFT'
,p_is_required=>false
,p_lov_type=>'SQL_QUERY'
,p_lov_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name,',
'       id',
'  from wwv_flow_template_opt_groups',
' where template_types = :TEMPLATE_TYPES',
'   and flow_id        = :FB_FLOW_ID',
'   and theme_id       = :P267_THEME_ID'))
,p_lov_display_extra=>true
,p_lov_display_null=>true
,p_lov_cascade_parent_items=>'TEMPLATE_TYPES'
,p_ajax_items_to_submit=>'P267_THEME_ID'
,p_ajax_optimize_refresh=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5608909965662130)
,p_name=>'HELP_TEXT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'HELP_TEXT'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Help Text'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>190
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(13086589932499022)
,p_name=>'GROUP_DISPLAY_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'GROUP_DISPLAY_SEQUENCE'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Group Sequence'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>110
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(13086646149499023)
,p_name=>'GROUP_DISPLAY_NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'GROUP_DISPLAY_NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Group Name'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>120
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_include_in_export=>false
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(2800408295512001)
,p_internal_uid=>2800408295512001
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_add_row_if_empty=>false
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SET'
,p_show_total_row_count=>true
,p_no_data_found_message=>'No template options.'
,p_show_toolbar=>true
,p_toolbar_buttons=>'SEARCH_FIELD:SAVE'
,p_add_button_label=>'Add Template Option'
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>false
,p_define_chart_view=>false
,p_enable_download=>false
,p_download_formats=>null
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function(config) {',
'    config.defaultGridViewOptions = {',
'        reorderColumns: false',
'    }',
'    return config;',
'}'))
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(2807177378527946)
,p_interactive_grid_id=>wwv_flow_imp.id(2800408295512001)
,p_static_id=>'28072'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_rows_per_page=>20
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(2807365975527948)
,p_report_id=>wwv_flow_imp.id(2807177378527946)
,p_view_type=>'GRID'
,p_stretch_columns=>true
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2807827748527959)
,p_view_id=>wwv_flow_imp.id(2807365975527948)
,p_display_seq=>2
,p_column_id=>wwv_flow_imp.id(2800559146512002)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>150
,p_sort_order=>1
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2808732543527965)
,p_view_id=>wwv_flow_imp.id(2807365975527948)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(2800604693512003)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2809647265527969)
,p_view_id=>wwv_flow_imp.id(2807365975527948)
,p_display_seq=>5
,p_column_id=>wwv_flow_imp.id(2800728608512004)
,p_is_visible=>true
,p_is_frozen=>false
,p_sort_order=>5
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2811430246527976)
,p_view_id=>wwv_flow_imp.id(2807365975527948)
,p_display_seq=>7
,p_column_id=>wwv_flow_imp.id(2800915664512006)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>107
,p_sort_order=>4
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2812399073527979)
,p_view_id=>wwv_flow_imp.id(2807365975527948)
,p_display_seq=>8
,p_column_id=>wwv_flow_imp.id(2801046543512007)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2815089100527988)
,p_view_id=>wwv_flow_imp.id(2807365975527948)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(2801325479512010)
,p_is_visible=>true
,p_is_frozen=>true
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(6010993198997843)
,p_view_id=>wwv_flow_imp.id(2807365975527948)
,p_display_seq=>6
,p_column_id=>wwv_flow_imp.id(5607099197662111)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(6011819863997849)
,p_view_id=>wwv_flow_imp.id(2807365975527948)
,p_display_seq=>10
,p_column_id=>wwv_flow_imp.id(5607171613662112)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(6012789319997853)
,p_view_id=>wwv_flow_imp.id(2807365975527948)
,p_display_seq=>11
,p_column_id=>wwv_flow_imp.id(5607247039662113)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(6013659866997857)
,p_view_id=>wwv_flow_imp.id(2807365975527948)
,p_display_seq=>12
,p_column_id=>wwv_flow_imp.id(5607319061662114)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(6028039576230712)
,p_view_id=>wwv_flow_imp.id(2807365975527948)
,p_display_seq=>4
,p_column_id=>wwv_flow_imp.id(5607763373662118)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>200
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(7408797298360606)
,p_view_id=>wwv_flow_imp.id(2807365975527948)
,p_display_seq=>9
,p_column_id=>wwv_flow_imp.id(5608909965662130)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>220
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(23238118650646473)
,p_view_id=>wwv_flow_imp.id(2807365975527948)
,p_display_seq=>13
,p_column_id=>wwv_flow_imp.id(13086589932499022)
,p_is_visible=>false
,p_is_frozen=>false
,p_sort_order=>2
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(23239198832646477)
,p_view_id=>wwv_flow_imp.id(2807365975527948)
,p_display_seq=>14
,p_column_id=>wwv_flow_imp.id(13086646149499023)
,p_is_visible=>false
,p_is_frozen=>false
,p_sort_order=>3
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1253547956481954904)
,p_plug_name=>'Icons'
,p_region_name=>'ICONS'
,p_parent_plug_id=>wwv_flow_imp.id(1804606589697308)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>102
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P267_ID'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1253548287352954907)
,p_plug_name=>'JavaScript and Cascading Style Sheets'
,p_region_name=>'JS_CSS'
,p_parent_plug_id=>wwv_flow_imp.id(1804606589697308)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>22
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P267_ID'
,p_plug_read_only_when_type=>'EXISTS'
,p_plug_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_themes',
'where id = :P267_ID',
'and reference_id is not null',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1542908891918063223)
,p_plug_name=>'Dialog Defaults'
,p_region_name=>'DIALOG_DEFAULTS'
,p_parent_plug_id=>wwv_flow_imp.id(1804606589697308)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>55
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P267_ID'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(16228711370721645)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(111484730067981625)
,p_plug_name=>'Tasks'
,p_region_name=>'TASKS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(111435127334933550)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P267_ID'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(166329430439530196)
,p_plug_name=>'Theme'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>90
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_landmark_label=>'Theme Actions'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(615357704912673099)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(29434107863295859)
,p_plug_display_sequence=>142
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from WWV_FLOW_THEMES',
'where id = :P267_ID ',
'  and flow_id = :FB_FLOW_ID',
'  and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id                 => :P267_ID,',
'      p_component_type     => ''Theme'',',
'      p_last_updated_by    => c1.last_updated_by,',
'      p_last_updated_on    => c1.last_updated_on,',
'      p_created_by         => c1.created_by,',
'      p_created_on         => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P267_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1055906341587945591)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>A Theme is a named collection of templates used to define the user interface of an application.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1104687140829514413)
,p_plug_name=>'Re-Subscribing to a<br/>Built-In Theme'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This theme is currently unsubscribed. If you wish to return to a subscribed version of this theme you will need to follow these steps:</p>',
'<ol>',
'  <li>From Themes, click the Change Identification Number task (in the right-sidebar), and change this theme to a new number.</li>',
'  <li>Create this theme again from the repository.</li>',
'  <li>Switch your current application to use this new theme.</li>',
'  <li>Delete the original theme you renumbered.</li>',
'</ol>'))
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_themes',
'where id = :P267_ID',
'and nvl(reference_id,0) = 0',
'and :P267_THEME_ID < 100'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1119685727798584502)
,p_plug_name=>'Re-Subscribing to a<br/>Custom Theme'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This theme is currently unsubscribed. If you wish to return to a subscribed version of this theme from another application you will need to follow these steps:</p>',
'<ol>',
'  <li>Create a new theme as a copy from another application - the "master" application, ensuring that Subscribe Theme is set to Yes.</li>',
'  <li>Switch your application to use this new theme.</li>',
'  <li>Delete this existing theme.</li>',
'</ol>'))
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_themes',
'where id = :P267_ID',
'and nvl(reference_id,0) = 0',
'and :P267_THEME_ID >= 100'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1449459881694055501)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(697004804009046662)
,p_button_name=>'Verify'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Verify'
,p_button_position=>'CHANGE'
,p_button_redirect_url=>'f?p=&APP_ID.:83:&SESSION.::&DEBUG.::P75_THEME_ID,P75_REFERENCE_ID:&P267_ID.,&P267_REFERENCE_ID.'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_themes',
'where id = :P267_ID',
'and nvl(reference_id,0) <> 0'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1019537897835357487)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(697004804009046662)
,p_button_name=>'UNSUBSCRIBE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Unsubscribe'
,p_button_position=>'CHANGE'
,p_button_redirect_url=>'f?p=&APP_ID.:100:&SESSION.::&DEBUG.:RP:::'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_themes',
'where id = :P267_ID',
'and nvl(reference_id,0) <> 0'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(702515877843814128)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(697004804009046662)
,p_button_name=>'COPY_TEMPLATE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Refresh Theme'
,p_button_position=>'CHANGE'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_themes',
'where id = :P267_ID',
'and nvl(reference_id,0) <> 0'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(702513025194691919)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(697004804009046662)
,p_button_name=>'PUBLISH_TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Publish Theme'
,p_button_position=>'CHANGE'
,p_button_redirect_url=>'f?p=&APP_ID.:233:&SESSION.::&DEBUG.:RP::'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_themes',
'where reference_id = :P267_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30850316934009164)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(22486830752876187)
,p_button_name=>'FILES_DELETE_ALL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete All Files'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_theme_files',
' where flow_id           = :P267_FLOW_ID',
'   and theme_id          = :P267_THEME_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(59029406622181518)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(166329430439530196)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
,p_button_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30850514346010329)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(22486830752876187)
,p_button_name=>'FILES_DOWNLOAD_ZIP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Download as Zip'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:267:&SESSION.:FILES_DOWNLOAD_ZIP:&DEBUG.::P267_THEME_ID:&P267_THEME_ID.'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_theme_files',
' where flow_id           = :P267_FLOW_ID',
'   and theme_id          = :P267_THEME_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(59029604353181518)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(166329430439530196)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P267_ID is not null',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(22487529555876240)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(22486830752876187)
,p_button_name=>'CREATE_FILE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Create File'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:118:&SESSION.::&DEBUG.:118:P118_SCOPE,P118_APP_ID,P118_THEME_ID:THEME,&P267_FLOW_ID.,&P267_THEME_ID.'
,p_button_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(59029514259181518)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(166329430439530196)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P267_ID is null',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(366547523210187587)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(366546306074187573)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'Add Style'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:177:&SESSION.::&DEBUG.:177:P177_THEME_ID:&P267_THEME_ID.'
,p_button_condition_type=>'IS_NOT_READ_ONLY'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(687752411036355153)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_imp.id(925260747421540222)
,p_button_name=>'OPTION_GROUPS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Template Option Groups'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:81:&SESSION.::&DEBUG.:81:P81_THEME_ID:&P267_THEME_ID.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(30851608128017763)
,p_branch_name=>'Reset Pagination after delete all theme files'
,p_branch_action=>'f?p=&APP_ID.:267:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(30850316934009164)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(741112107076403632)
,p_branch_name=>'Refresh'
,p_branch_action=>'f?p=&APP_ID.:267:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(702515877843814128)
,p_branch_sequence=>15
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(741115537491559351)
,p_branch_name=>'Publish'
,p_branch_action=>'f?p=&APP_ID.:267:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(702513025194691919)
,p_branch_sequence=>16
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(59031929589181536)
,p_branch_action=>'f?p=&FLOW_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
,p_branch_comment=>'Generated 11-JUN-2004 00:29:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2892963419137315)
,p_name=>'P267_VERSION_IDENTIFIER'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(59029014305181516)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Version'
,p_source=>'VERSION_IDENTIFIER'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>30
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the current version of the theme.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22487708554876260)
,p_name=>'P267_FILE_PREFIX'
,p_item_sequence=>350
,p_item_plug_id=>wwv_flow_imp.id(22486830752876187)
,p_use_cache_before_default=>'NO'
,p_prompt=>'File Prefix'
,p_source=>'FILE_PREFIX'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Determines the virtual path the web server uses to point to the files of the theme. For performance reasons you can store your theme files on your web server instead of with your theme definition in the database. Use <code>&#35;APEX_FILES&#35;</co'
||'de> or any valid URL to reference them.</p>',
'',
'<p>Do not specify anything to reference files which are stored with your theme definition in the database. If you specify File Prefix and still wish to reference files stored with your theme in the database, use <code>&#35;THEME_DB_FILES&#35;</code> '
||'rather than <code>&#35;THEME_FILES&#35;</code> in your templates.</p>',
'',
'<p>Examples:',
'<ul>',
'  <li>/myFiles/</li>',
'  <li>https://example.com/myFiles/</li>',
'  <li>&#35;APEX_FILES&#35;myFiles/</li>',
'</li>',
'</p>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22513229999111559)
,p_name=>'P267_FILE_ID'
,p_item_sequence=>360
,p_item_plug_id=>wwv_flow_imp.id(22486830752876187)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(45364525279433521)
,p_name=>'P267_DEFAULT_DIALOG_TEMPLATE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(1542908891918063223)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Dialog Page'
,p_source=>'DEFAULT_DIALOG_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_DIALOG_PAGE_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name, id',
'from   wwv_flow_templates',
'where  flow_id = :FB_FLOW_ID ',
'and   (:fb_theme_id is null or theme_id = :fb_theme_id)',
'and    is_popup = ''Y''',
'order  by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Template -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specifies the default template for displaying modal or non-modal dialog pages. If a developer does not',
'explicitly choose a template then the &PRODUCT_NAME. engine uses the template specified here. This template will',
'also be used for errors that display on a separate page as opposed to those that display inline.'))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(59032321514181540)
,p_name=>'P267_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(59029014305181516)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
,p_item_comment=>'Generated 11-JUN-2004 00:29:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(59032717356181559)
,p_name=>'P267_THEME_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(59029014305181516)
,p_use_cache_before_default=>'NO'
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  for c1 in (select max(theme_id)+1 theme_id from wwv_flow_themes where flow_id = :fb_flow_id) loop',
'    if c1.theme_id > 100 then',
'      return c1.theme_id;',
'    else ',
'      return 101;',
'    end if;',
'   end loop;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Theme Number'
,p_source=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>10
,p_read_only_when=>'P267_ID'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'A number which identifies a collection of templates which define the user interface of an application.'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
,p_item_comment=>'Generated 11-JUN-2004 00:29:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(59033517263181567)
,p_name=>'P267_THEME_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(59029014305181516)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>'THEME_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Provides a short descriptive name for the theme.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 11-JUN-2004 00:29:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(59047223736269265)
,p_name=>'P267_FLOW_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(59029014305181516)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Application:'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'This attribute identifies the current application. '
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(60493329418596699)
,p_name=>'P267_DEFAULT_PAGE_TEMPLATE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(60494608771600292)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Page'
,p_source=>'DEFAULT_PAGE_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PAGE_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''PAGE''',
'and flow_id = :fb_flow_id and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Template -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specifies the default template for displaying pages. If a developer does not explicitly choose a template then the &PRODUCT_NAME. engine uses the template specified here. ',
''))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(62082221573064205)
,p_name=>'P267_ERROR_TEMPLATE'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(60494608771600292)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Error Page'
,p_source=>'ERROR_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PAGE_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''PAGE''',
'and flow_id = :fb_flow_id and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Template -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Optional. Specifies a page template to use for errors that display on a separate page as opposed to those that display inline. Leave this attribute blank if you do not wish to use a template designed to display errors.  This setting only applies to N'
||'ormal pages.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(62082515788064212)
,p_name=>'P267_PRINTER_FIENDLY_TEMPLATE'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(60494608771600292)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Printer Friendly Page'
,p_source=>'PRINTER_FRIENDLY_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PAGE_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''PAGE''',
'and flow_id = :fb_flow_id and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Template -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Identifies the template to be used when the &PRODUCT_NAME. engine is in printer friendly mode. When calling the &PRODUCT_NAME. to render a page, you have the option to identify a printer friendly attribute with values of '
||'YES or NO.</div>',
'<div class="htmldbInfoBodyP">If you select YES, then the page displays using a printer friendly template. The &PRODUCT_NAME. engine displays all text within HTML form fields as text. The printer friendly template does not need to have the <code>#FORM'
||'_OPEN#</code> or <code>#FORM_CLOSE#</code> tags. The objective is to be able to display information with few tables and in a format suitable for printing.</div>'))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(62083305677064214)
,p_name=>'P267_BUTTON_TEMPLATE'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(60494608771600292)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Button'
,p_source=>'DEFAULT_BUTTON_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_BUTTON_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''BUTTON''',
'and flow_id = :fb_flow_id and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Template -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specifies the default button template used when you create new button. You will be given an opportunity to override this default.',
''))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(62083725704064214)
,p_name=>'P267_REGION_TEMPLATE'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_imp.id(60494608771600292)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Region'
,p_source=>'DEFAULT_REGION_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_REGION_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''REGION''',
'and flow_id = :fb_flow_id  and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Template -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specifies the default region template used when you create new region. You will be given an opportunity to override this default.',
''))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(62084132531064215)
,p_name=>'P267_CHART_TEMPLATE'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(73829002796853667)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Charts'
,p_source=>'DEFAULT_CHART_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_REGION_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''REGION''',
'and flow_id = :fb_flow_id  and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Template -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specifies the default chart template used when you create a chart. You will be given an opportunity to override this default.',
''))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(62084501451064216)
,p_name=>'P267_FORM_TEMPLATE'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_imp.id(73829002796853667)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Forms'
,p_source=>'DEFAULT_FORM_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_REGION_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''REGION''',
'and flow_id = :fb_flow_id  and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Template -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specifies the default form template used when you create a form. You will be given an opportunity to override this default.',
''))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(62084903043064217)
,p_name=>'P267_REPORTR_TEMPLATE'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_imp.id(73829002796853667)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Reports'
,p_source=>'DEFAULT_REPORTR_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_REGION_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''REGION''',
'and flow_id = :fb_flow_id  and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Template -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specifies the default region template used when you create a report. You will be given an opportunity to override this default.',
''))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(62085714401064218)
,p_name=>'P267_WIZARD_TEMPLATE'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_imp.id(73829002796853667)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Wizards'
,p_source=>'DEFAULT_WIZARD_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_REGION_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''REGION''',
'and flow_id = :fb_flow_id  and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Template -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specifies the default region template used when you create a new wizard component. You will be given an opportunity to override this default.',
''))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(62086118351064219)
,p_name=>'P267_MENUR_TEMPLATE'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(73829002796853667)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Breadcrumbs'
,p_source=>'DEFAULT_MENUR_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_REGION_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''REGION''',
'and flow_id = :fb_flow_id  and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Template -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specifies the default region template used when you create a breadcrumb. You will be given an opportunity to override this default.',
''))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(62086526255064220)
,p_name=>'P267_LISTR_TEMPLATE'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_imp.id(73829002796853667)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Lists'
,p_source=>'DEFAULT_LISTR_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_REGION_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''REGION''',
'and flow_id = :fb_flow_id  and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Template -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specifies the default region template used when you create a list. You will be given an opportunity to override this default.',
''))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(73614116621280485)
,p_name=>'P267_REPORT_TEMPLATE'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_imp.id(60494608771600292)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Classic Report'
,p_source=>'DEFAULT_REPORT_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_REPORT_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''REPORT''',
'and flow_id = :fb_flow_id and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Template -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specifies the default region template used when you create a report. You will be given an opportunity to override this default.',
''))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(73614408283280487)
,p_name=>'P267_LABEL_TEMPLATE'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(60494608771600292)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Default Label'
,p_source=>'DEFAULT_LABEL_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_LABEL_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''LABEL''',
'and flow_id = :fb_flow_id and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Template -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specifies the default label template used when you create new label. You will be given an opportunity to override this default.',
''))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(73614806510280489)
,p_name=>'P267_MENU_TEMPLATE'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(60494608771600292)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Breadcrumb'
,p_source=>'DEFAULT_MENU_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_MENU_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''MENU''',
'and flow_id = :fb_flow_id and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Template -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specifies the default breadcrumb template used when you create new breadcrumb. You will be given an opportunity to override this default.',
''))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(73615217202280490)
,p_name=>'P267_CALENDAR_TEMPLATE'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(60494608771600292)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Legacy Calendar'
,p_source=>'DEFAULT_CALENDAR_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_CALENDAR_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''CALENDAR''',
'and flow_id = :fb_flow_id and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Template -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specifies the default calendar template used when you create new calendar. You will be given an opportunity to override this default.',
''))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(73615629679280490)
,p_name=>'P267_LIST_TEMPLATE'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_imp.id(60494608771600292)
,p_use_cache_before_default=>'NO'
,p_prompt=>'List'
,p_source=>'DEFAULT_LIST_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_LIST_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''LIST''',
'and flow_id = :fb_flow_id ',
'and theme_id = :fb_theme_id',
'order by upper(name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Template -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specifies the default list template used when you create new list. You will be given an opportunity to override this default.',
''))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(113806709842492190)
,p_name=>'P267_THEME_DESCRIPTION'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(59029014305181516)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Description'
,p_source=>'THEME_DESCRIPTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Provides a short description for the theme.'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_item_comment=>'Generated 11-JUN-2004 00:29:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(174542317951520703)
,p_name=>'P267_NAVIGATION_TYPE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(59029014305181516)
,p_use_cache_before_default=>'NO'
,p_item_default=>'L'
,p_prompt=>'Navigation Type'
,p_source=>'NAVIGATION_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'NAVIGATION TYPE'
,p_lov=>'.'||wwv_flow_imp.id(174541309940513694)||'.'
,p_cHeight=>1
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'v(''P267_ID'') is not null',
''))
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identifies the selected Navigation Type. Valid options include: Tabs or List.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(174544515757567360)
,p_name=>'P267_DEFAULT_TOP_NAV_LIST_TEMP'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(60494608771600292)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Navigation Menu List (Top)'
,p_source=>'DEFAULT_TOP_NAV_LIST_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_LIST_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''LIST''',
'and flow_id = :fb_flow_id ',
'and theme_id = :fb_theme_id',
'order by upper(name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Template -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specifies the default navigation menu list template used when you create a new list to be displayed on the top of the page. You will be given an opportunity to override this default.',
''))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(198271924908216321)
,p_name=>'P267_IRR_TEMPLATE'
,p_item_sequence=>260
,p_item_plug_id=>wwv_flow_imp.id(73829002796853667)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Interactive Reports'
,p_source=>'DEFAULT_IRR_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_REGION_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''REGION''',
'and flow_id = :fb_flow_id  and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Template -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specifies the default region template used when you create an interactive report. You will be given an opportunity to override this default.',
''))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(211564805306093452)
,p_name=>'P267_CALENDAR_ICON'
,p_item_sequence=>410
,p_item_plug_id=>wwv_flow_imp.id(1253547956481954904)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Date Picker Icon Name'
,p_source=>'CALENDAR_ICON'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the name and location of the image to be used when items of type Date Picker are displayed.',
'<p />',
'Example:',
'<p />',
'<pre>&#35;APEX_FILES&#35;new_cal.bmp</pre>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 11-JUN-2004 00:29:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(211570520853145252)
,p_name=>'P267_CALENDAR_ICON_ATTR'
,p_item_sequence=>420
,p_item_plug_id=>wwv_flow_imp.id(1253547956481954904)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Date Picker Icon Attributes'
,p_source=>'CALENDAR_ICON_ATTR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the image attributes for the Calendar Icon. ',
'<p />',
'Example: ',
'<p />',
'<pre>width="16" height="16" alt="Display Calendar"</pre>',
'',
''))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 11-JUN-2004 00:29:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(219204726283743802)
,p_name=>'P267_DEFAULT_HEADER_TEMPLATE'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_imp.id(60494608771600292)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Header Toolbar'
,p_source=>'DEFAULT_HEADER_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_REGION_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''REGION''',
'and flow_id = :fb_flow_id  and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Template -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Specifies the default header toolbar region template used when you create a new page  that includes a header or footer toolbars.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(219206630584756923)
,p_name=>'P267_DEFAULT_FOOTER_TEMPLATE'
,p_item_sequence=>260
,p_item_plug_id=>wwv_flow_imp.id(60494608771600292)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Footer Toolbar'
,p_source=>'DEFAULT_FOOTER_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_REGION_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''REGION''',
'and flow_id = :fb_flow_id  and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Template -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Specifies the default footer toolbar region template used when you create a new page  that includes a header or footer toolbars.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(389109186894297111)
,p_name=>'P267_DEFAULT_LOGIN_PAGE_TEMP'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(60494608771600292)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Login Page'
,p_source=>'LOGIN_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PAGE_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''PAGE''',
'and flow_id = :fb_flow_id and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Template -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specifies the default template for displaying pages. If a developer does not explicitly choose a template then the &PRODUCT_NAME. engine uses the template specified here. ',
''))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(389109259611297112)
,p_name=>'P267_OPTION_LABEL'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(60494608771600292)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Optional Label'
,p_source=>'DEFAULT_OPTION_LABEL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_LABEL_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''LABEL''',
'and flow_id = :fb_flow_id and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Template -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specifies the default optional label template used when you create new label. You will be given an opportunity to override this default.',
''))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(389109315089297113)
,p_name=>'P267_REQUIRED_LABEL'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_imp.id(60494608771600292)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Required Label'
,p_source=>'DEFAULT_REQUIRED_LABEL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_LABEL_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''LABEL''',
'and flow_id = :fb_flow_id and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Template -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specifies the default required label template used when you create new label. You will be given an opportunity to override this default.',
''))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(697009146472135165)
,p_name=>'P267_REFERENCE_ID'
,p_item_sequence=>370
,p_item_plug_id=>wwv_flow_imp.id(697004804009046662)
,p_use_cache_before_default=>'NO'
,p_source=>'REFERENCE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(946447335666624250)
,p_name=>'P267_DEFAULT_SIDE_NAV_LIST_TEM'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(60494608771600292)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Navigation Menu List (Side)'
,p_source=>'DEFAULT_SIDE_NAV_LIST_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_LIST_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''LIST''',
'and flow_id = :fb_flow_id ',
'and theme_id = :fb_theme_id',
'order by upper(name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Template -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specifies the default navigation menu list template used when you create a new list to be displayed on the side of the page. You will be given an opportunity to override this default.',
''))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(982227744761899601)
,p_name=>'P267_DEFAULT_NAV_LIST_POSITION'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(60494608771600292)
,p_use_cache_before_default=>'NO'
,p_item_default=>'TOP'
,p_prompt=>'Navigation Menu List Position'
,p_source=>'DEFAULT_NAV_LIST_POSITION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC:Top;TOP,Side;SIDE'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specifies the default navigation menu list position. You will be given an opportunity to override this default.',
''))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1252826171549086133)
,p_name=>'P267_NAV_BAR_TYPE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(59029014305181516)
,p_use_cache_before_default=>'NO'
,p_item_default=>'LIST'
,p_prompt=>'Navigation Bar Implementation'
,p_source=>'NAV_BAR_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'NAV_BAR_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(1383750926477562234)||'.'
,p_cHeight=>1
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'v(''P267_ID'') is not null',
''))
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identifies the selected Navigation Bar implementation. Valid options include: Classic or List.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1253548083481954905)
,p_name=>'P267_ICON_LIBRARY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1253547956481954904)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Library'
,p_source=>'ICON_LIBRARY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ICON_LIBRARIES'
,p_lov=>'.'||wwv_flow_imp.id(1284197032342757201)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Library -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select the icon library to be loaded when &PRODUCT_NAME. displays a page. The icons within the library will also be displayed in the icon picker in Page Designer.',
'<br><br>',
'Select <strong>Font APEX - Latest</strong> if you want to use a newer version of Font APEX than the one that is shipped with &PRODUCT_NAME.. You can get the most current version of Font APEX on GitHub, and then upload the files into the <code>librari'
||'es/font-apex/latest/</code> folder within the &PRODUCT_NAME. images directory.'))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1253548176122954906)
,p_name=>'P267_CUSTOM_ICON_CLASSES'
,p_item_sequence=>390
,p_item_plug_id=>wwv_flow_imp.id(1253547956481954904)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Custom Classes'
,p_source=>'CUSTOM_ICON_CLASSES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>3
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'a-Form-fieldContainer--fieldsetBlock'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Specify a comma delimited list of CSS class names which will be listed in the picker for Region and Button <strong>Icon CSS Classes</strong>, implemented within Page Designer.'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1284198878924776853)
,p_name=>'P267_CUSTOM_LIBRARY_FILE_URLS'
,p_item_sequence=>380
,p_item_plug_id=>wwv_flow_imp.id(1253547956481954904)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Custom Library File URLs'
,p_source=>'CUSTOM_LIBRARY_FILE_URLS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>3
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'a-Form-fieldContainer--fieldsetBlock'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter Cascading Style Sheet file URLs for custom icons to be loaded on every page. Each URL has to be written into a new line. If you provide a minified version of your file you can use the substitution string <code>#MIN#</code> to include <code>.'
||'min</code> or <code>#MIN_DIRECTORY#</code> to include <code>minified/</code> in your file URL for a regular page view and an empty string if the page is viewed in debug mode. You also have access to the substitution string <code>#APP_VERSION#</code> '
||'if you want to include the application''s version in the file URL.</p>',
'',
'<p>File URLs you enter here will replace the <code>#THEME_CSS#</code> substitution string in the page template.</p>',
'',
'<p>Note: You do not need to include opening or closing <code>link</code> tags. Just include the file URL.</p>',
'',
'<p>',
'Examples:',
'<ul>',
'  <li>Standard file reference which loads the file from the theme directory:',
'      <pre>#THEME_IMAGES#icons.css</pre>',
'  </li>',
'  <li>Standard file reference which loads the minified file icons.min.css from /mycss/minified/ for regular page views and icons.css from /mycss/ in debug mode.',
'      <pre>/mycss/#MIN_DIRECTORY#icons#MIN#.css</pre>',
'  </li>',
'  <li>Conditional media query:',
'      <pre>[media="only screen and (max-device-width: 480px)"]/mycss/smartphone_icons.css</pre>',
'  </li>',
'  <li>File reference using a query string in the URL referencing the application version, such that when the application is upgraded (and the version is incremented), the browser loads the new file and ignore any previously cached files:',
'      <pre>/mycss/icons.css?version=#APP_VERSION#</pre>',
'  </li>',
'</ul>',
'</p>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1284811815656337680)
,p_name=>'P267_JAVASCRIPT_FILE_URLS'
,p_item_sequence=>420
,p_item_plug_id=>wwv_flow_imp.id(1253548287352954907)
,p_use_cache_before_default=>'NO'
,p_prompt=>'JavaScript File URLs'
,p_source=>'JAVASCRIPT_FILE_URLS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'a-Form-fieldContainer--fieldsetBlock'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter JavaScript file URLs for code to be loaded on every page. Each URL has to be written into a new line. If you provide a minified version of your file, you can use the substitution string <code>#MIN#</code> to include <code>.min</code> or <cod'
||'e>#MIN_DIRECTORY#</code> to include <code>minified/</code> in your file URL for a regular page view and an empty string if the page is viewed in debug mode.</p>',
'',
'<p>JavaScript file URLs you enter here replaces the <code>#THEME_JAVASCRIPT#</code> substitution string in the page template.</p>',
'',
'<p>Note: You do not need to include opening or closing <code>script</code> tags. Just write the URL.',
'',
'<p>',
'Examples:',
'<ul>',
'  <li>Standard file reference which loads the file from the theme directory:',
'      <pre>#THEME_IMAGES#main.js</pre>',
'  </li>',
'  <li>Standard file reference which loads the minified file main.min.js from /myjs/minified/ for regular page views and main.js from /myjs/ in debug mode:',
'      <pre>/myjs/#MIN_DIRECTORY#main#MIN#.js</pre>',
'  </li>',
'  <li>Use this syntax if the library is also used from a RequireJS require call. The define name must match what is used in the requirejs.config paths and the value must be the global symbol exposed by the library. Only applies when using RequireJS. '
||'This avoids RequireJS  loading that library a second time.',
'      <pre>[define hammerjs=Hammer]/myjs/hammer.js</pre>',
'  </li>',
'  <li>Use this syntax if the file has a dependency on RequireJS. This will automatically load RequireJS before this file.',
'      <pre>[require requirejs]/myjs/main.js</pre>',
'  </li>',
'  <li>Use this syntax if the file has a dependency on Oracle JET. This will automatically load RequireJS and the Oracle JET RequireJS configuration before this file.',
'      <pre>[require jet]/myjs/main.js</pre>',
'  </li>',
'</ul>',
'</p>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1284812351123340641)
,p_name=>'P267_CSS_FILE_URLS'
,p_item_sequence=>430
,p_item_plug_id=>wwv_flow_imp.id(1253548287352954907)
,p_use_cache_before_default=>'NO'
,p_prompt=>'CSS File URLs'
,p_source=>'CSS_FILE_URLS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'a-Form-fieldContainer--fieldsetBlock'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter Cascading Style Sheet file URLs to be loaded on every page. Each URL has to be written into a new line. If you provide a minified version of your file you can use the substitution string <code>#MIN#</code> to include <code>.min</code> or <co'
||'de>#MIN_DIRECTORY#</code> to include <code>minified/</code> in your file URL for a regular page view and an empty string if the page is viewed in debug mode. You also have access to the substitution string <code>#APP_VERSION#</code> if you want to in'
||'clude the application''s version in the file URL.</p>',
'',
'<p>File URLs you enter here will replace the <code>#THEME_CSS#</code> substitution string in the page template.</p>',
'',
'<p>Note: You do not need to include opening or closing <code>link</code> tags. Just include the file URL.</p>',
'',
'<p>',
'Examples:',
'<ul>',
'  <li>Standard file reference which loads the file from the theme directory',
'      <pre>/mycss/main.css</pre>',
'  </li>',
'  <li>Standard file reference which loads the minified file main.min.css from /mycss/minified/ for regular page views and main.css from /mycss/ in debug mode.',
'      <pre>/mycss/#MIN_DIRECTORY#main#MIN#.css</pre>',
'  </li>',
'  <li>Conditional media query',
'      <pre>[media="only screen and (max-device-width: 480px)"]/mycss/smartphone.css</pre>',
'  </li>',
'  <li>File reference using a query string in the URL referencing the application version, such that when the application is upgraded (and the version is incremented), the browser is instructed to always load the new file and ignore any previously cac'
||'hed files.',
'      <pre>/mycss/main.css?version=#APP_VERSION#</pre>',
'  </li>',
'</ul>',
'</p>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1301370800500065017)
,p_name=>'P267_DEFAULT_NAV_BAR_LIST_TEMP'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(60494608771600292)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Navigation Bar List'
,p_source=>'DEFAULT_NAV_BAR_LIST_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_LIST_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''LIST''',
'and flow_id = :fb_flow_id ',
'and theme_id = :fb_theme_id',
'order by upper(name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Template -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specifies the default navigation bar list template used when you define the navigation bar type as List in your application. You will be given an opportunity to override this default in the User Interface settings at application level.',
''))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1331349974716223301)
,p_name=>'P267_THEME_INTERNAL_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(59029014305181516)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Identifier'
,p_source=>'THEME_INTERNAL_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specifies the internal theme identifier.'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_attribute_06=>'UPPER'
,p_item_comment=>'Generated 11-JUN-2004 00:29:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1499431470721055521)
,p_name=>'P267_CUSTOM_ICON_PREFIX_CLASS'
,p_item_sequence=>400
,p_item_plug_id=>wwv_flow_imp.id(1253547956481954904)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Custom Prefix Class'
,p_source=>'CUSTOM_ICON_PREFIX_CLASS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>30
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify a CSS class that will at runtime prefix the <em>Icon CSS Classes</em> defined for Regions, Buttons and Lists, if they are not using a class of the Icon Library.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1542908747630063222)
,p_name=>'P267_DIALOGR_TEMPLATE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1542908891918063223)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Dialog Content Region'
,p_source=>'DEFAULT_DIALOGR_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_REGION_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''REGION''',
'and flow_id = :fb_flow_id  and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Template -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specifies the default region template used when you create a content region on a Dialog. You will be given an opportunity to override this default.',
''))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1542909180149063226)
,p_name=>'P267_DIALOGBTNR_TEMPLATE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1542908891918063223)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Dialog Button Region'
,p_source=>'DEFAULT_DIALOGBTNR_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_REGION_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''REGION''',
'and flow_id = :fb_flow_id  and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Template -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specifies the default region template used when you create a button region on a Dialog. You will be given an opportunity to override this default.',
''))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(146912508847899403)
,p_computation_sequence=>10
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>'select theme_id from wwv_flow_themes where id = :P267_ID'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(144930106193955936)
,p_validation_name=>'P267_THEME_ID'
,p_validation_sequence=>10
,p_validation=>'P267_THEME_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Theme ID must be specified.'
,p_validation_condition=>'SAVE,CREATE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(59032717356181559)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(144933307840975374)
,p_validation_name=>'p267_theme_id not in use'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'for c1 in (select 1 from wwv_flow_themes where flow_id = :fb_flow_id and theme_id = :P267_THEME_ID) loop',
'  return false;',
'end loop;',
'return true;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Theme ID in use please specify another.'
,p_validation_condition=>'CREATE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(144936229789991157)
,p_validation_name=>'theme_id > 100'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'if :p267_theme_id < 100 then',
'  return false;',
'else ',
'  return true;',
'end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Theme Id''s < 100 are reserved for Oracle.'
,p_validation_condition=>'CREATE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(144947809665032627)
,p_validation_name=>'P267_THEME_NAME'
,p_validation_sequence=>40
,p_validation=>'P267_THEME_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Theme name must be specified.'
,p_validation_condition=>'SAVE,CREATE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(59033517263181567)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1917199210061795462)
,p_validation_name=>'P267_DEFAULT_PAGE_TEMPLATE'
,p_validation_sequence=>80
,p_validation=>'P267_DEFAULT_PAGE_TEMPLATE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'The default page template must be specified.'
,p_validation_condition=>'P267_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_imp.id(60493329418596699)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(24050626286574833)
,p_tabular_form_region_id=>wwv_flow_imp.id(925260747421540222)
,p_validation_name=>'Template Options - No duplicates names'
,p_validation_sequence=>130
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_template_options',
' where flow_id              = :FB_FLOW_ID',
'   and theme_id             = :P267_THEME_ID',
'   and security_group_id    = :WORKSPACE_ID',
'   and name                 = :NAME',
'   and template_types       = :TEMPLATE_TYPES',
'   and virtual_template_id is null',
'   and (:ID is null or id != :ID)'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#COLUMN_HEADER# must be unique.'
,p_validation_condition=>'P267_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_exec_cond_for_each_row=>'Y'
,p_associated_column=>'NAME'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(24050790730574834)
,p_tabular_form_region_id=>wwv_flow_imp.id(925260747421540222)
,p_validation_name=>'Template Options - No duplicates classes'
,p_validation_sequence=>140
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_template_options',
' where flow_id              = :FB_FLOW_ID',
'   and theme_id             = :P267_THEME_ID',
'   and security_group_id    = :WORKSPACE_ID',
'   and css_classes          = :CSS_CLASSES',
'   and template_types       = :TEMPLATE_TYPES',
'   and virtual_template_id is null',
'   and (:ID is null or id != :ID)'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#COLUMN_HEADER# must be unique.'
,p_validation_condition=>'P267_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_exec_cond_for_each_row=>'Y'
,p_associated_column=>'CSS_CLASSES'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(30850621156011988)
,p_name=>'Delete all Files'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(30850316934009164)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(30851123380011988)
,p_event_id=>wwv_flow_imp.id(30850621156011988)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'Do you really want to delete all files?'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(30850916991011988)
,p_event_id=>wwv_flow_imp.id(30850621156011988)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'FILES_DELETE_ALL'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(19392564826030901)
,p_name=>'onDialogClosed VERIFY'
,p_event_sequence=>70
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1449459881694055501)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(19392638214030902)
,p_event_id=>wwv_flow_imp.id(19392564826030901)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'location.reload();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(231752883045461226)
,p_name=>'onClick COPY_TEMPLATE'
,p_event_sequence=>80
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(702515877843814128)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(231752997849461227)
,p_event_id=>wwv_flow_imp.id(231752883045461226)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'COPY_TEMPLATE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2803189020512028)
,p_name=>'upper case identifier'
,p_event_sequence=>90
,p_triggering_element_type=>'COLUMN'
,p_triggering_region_id=>wwv_flow_imp.id(925260747421540222)
,p_triggering_element=>'DISPLAY_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2803390129512030)
,p_event_id=>wwv_flow_imp.id(2803189020512028)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
':NAME := regexp_replace(',
'      srcstr     => :DISPLAY_NAME,',
'      pattern    => ''[^'' || wwv_flow_utilities.c_alnum || '']+'',',
'      replacestr => ''_'' );'))
,p_attribute_02=>'DISPLAY_NAME'
,p_attribute_03=>'NAME'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5607806593662119)
,p_name=>'refresh template options on cancel'
,p_event_sequence=>100
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'body'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosecanceldialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5608039385662121)
,p_event_id=>wwv_flow_imp.id(5607806593662119)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(925260747421540222)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(59034405595181576)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_THEMES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_THEMES'
,p_attribute_03=>'P267_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_process_error_message=>'Unable to fetch row.'
,p_internal_uid=>59034405595181576
,p_process_comment=>'Generated 11-JUN-2004 00:29:53'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(59034817493181579)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_THEMES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_THEMES'
,p_attribute_03=>'P267_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Unable to process row of table WWV_FLOW_THEMES.'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>59034817493181579
,p_process_comment=>'Generated 11-JUN-2004 00:29:53'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(30851225658013316)
,p_process_sequence=>100
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete all theme files'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    delete wwv_flow_theme_files',
'     where flow_id           = :P267_FLOW_ID',
'       and theme_id          = :P267_THEME_ID',
'       and security_group_id = :WORKSPACE_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(30850316934009164)
,p_process_success_message=>'Files deleted'
,p_internal_uid=>30851225658013316
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(741112591835413522)
,p_process_sequence=>120
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh theme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.resubscribe_theme(',
'    p_master_theme_id      => :P267_REFERENCE_ID,',
'    p_subscribing_theme_id => :P267_ID',
');',
'wwv_flow_copy_metadata.subscribe_theme (',
'    p_master_theme_id      => :P267_REFERENCE_ID,',
'    p_subscribing_theme_id => :P267_ID',
');'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(702515877843814128)
,p_process_success_message=>'Templates and template options refreshed from master theme.'
,p_internal_uid=>741112591835413522
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(741114961538527739)
,p_process_sequence=>130
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'publish theme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'    select id from wwv_flow_themes',
'    where reference_id = :P267_ID',
'    and security_group_id  = :WORKSPACE_ID',
') loop',
'    wwv_flow_copy_metadata.resubscribe_theme(',
'        p_master_theme_id      => :P267_ID,',
'        p_subscribing_theme_id => c1.id',
'    );',
'',
'    wwv_flow_copy_metadata.subscribe_theme (',
'        p_master_theme_id      => :P267_ID,',
'        p_subscribing_theme_id => c1.id',
'    );',
'end loop;    '))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(702513025194691919)
,p_process_success_message=>'Template and template options published.'
,p_internal_uid=>741114961538527739
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2801522807512012)
,p_process_sequence=>140
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(925260747421540222)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Global Template Options - Save Interactive Grid Data'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2801522807512012
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(30851432238015200)
,p_process_sequence=>110
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_DOWNLOAD'
,p_process_name=>'Download Theme Files as Zip'
,p_attribute_01=>'Y'
,p_attribute_02=>'theme_&P267_THEME_ID._files.zip'
,p_attribute_04=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select file_content,',
'       file_name',
'  from wwv_flow_theme_files',
' where flow_id           = :FB_FLOW_ID',
'   and theme_id          = :P267_THEME_ID',
'   and security_group_id = :WORKSPACE_ID',
' order by file_name'))
,p_process_when=>'FILES_DOWNLOAD_ZIP'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>30851432238015200
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(13089114944499048)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_region_id=>wwv_flow_imp.id(925260747421540222)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'upper :name'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':NAME := REGEXP_REPLACE(',
'      srcstr     => :NAME,',
'      pattern    => ''[^'' || wwv_flow_utilities.c_alnum || '']+'',',
'      replacestr => ''_'' );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P267_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_exec_cond_for_each_row=>'Y'
,p_internal_uid=>13089114944499048
);
end;
/
prompt --application/pages/page_00268
begin
wwv_flow_imp_page.create_page(
 p_id=>268
,p_name=>'Referenced Database Objects'
,p_alias=>'REFERENCED-DATABASE-OBJECTS'
,p_step_title=>'Referenced Database Objects'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216995930363945283)
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_utilties.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(169481221098646108)
,p_plug_name=>'Page Database Object Dependencies'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>160
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'decode(c003,''NON-EXISTENT'',null,c001) c001,',
'  c002,',
'nvl(decode(decode(c003,',
'  ''TABLE'',c001,',
'  ''VIEW'',c001,''/1''),',
'   o.owner,',
'   decode(c003,''NON-EXISTENT'',c002,c002)),c002) name,',
'decode(c003,''NON-EXISTENT'',',
'  null,htmldb_item.text_from_lov(c003,''OBJECT.TYPES'')) ',
'  c003,',
'  c004,',
'  c005,',
'  c006,',
'  -- c007 source_code,',
'  c008 application',
'from htmldb_collections c,',
'     (select owner from wwv_flows where id = :fb_flow_id) o',
'where collection_name = ''PAGE_DEPENDENCIES'' and',
'      c008 = :fb_flow_id and',
'      (c005 = nvl(:P268_PAGE_ID,:FB_FLOW_PAGE_ID))',
'and c002 <> ''PLITBLM''',
'order by c001,c002,c003'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(169481329244646108)
,p_name=>'Page Database Object Dependencies'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(169481521031646113)
,p_db_column_name=>'C001'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Schema'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(169481620628646115)
,p_db_column_name=>'C002'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'C002'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(169481716950646116)
,p_db_column_name=>'NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Database Object'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(169481827228646116)
,p_db_column_name=>'C003'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Referenced Type'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(169539810260463865)
,p_db_column_name=>'C004'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'APEX Component'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(169539932554463866)
,p_db_column_name=>'C005'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Page'
,p_column_type=>'STRING'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(169540230823479301)
,p_db_column_name=>'C006'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Component ID'
,p_column_type=>'STRING'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(169540420192479303)
,p_db_column_name=>'APPLICATION'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Application'
,p_column_type=>'STRING'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(169482006921646390)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1287402922536643'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'C001:NAME:C003:C004:C005:C007:X'
,p_sort_column_1=>'NAME'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(180126220951957019)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>150
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(180180721578127550)
,p_name=>'Parsing Errors'
,p_template=>wwv_flow_imp.id(689970285456172024)
,p_display_sequence=>170
,p_region_template_options=>'#DEFAULT#:is-collapsed'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'c001,',
'c002,',
'c003,',
'c004,',
'c005,',
'c006,',
'c007,',
'c008,',
'c009,',
'c010,',
'c011,',
'c012',
'from htmldb_collections',
'where collection_name = ''PAGE_DEPENDENCIES_ERRORS'' and',
'   (:P268_PAGE_ID is null or c002 = :P268_PAGE_ID)'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from htmldb_collections',
'where collection_name = ''PAGE_DEPENDENCIES_ERRORS'' and',
'   (:p268_page is null or c002 = :p268_page)'))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>50000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No parsing errors found'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(180181316286127561)
,p_query_column_id=>1
,p_column_alias=>'C001'
,p_column_display_sequence=>1
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(180181420348127562)
,p_query_column_id=>2
,p_column_alias=>'C002'
,p_column_display_sequence=>2
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#C002#'
,p_column_linktext=>'#C002#'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(180181519892127562)
,p_query_column_id=>3
,p_column_alias=>'C003'
,p_column_display_sequence=>3
,p_column_heading=>'ID'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(180181611209127562)
,p_query_column_id=>4
,p_column_alias=>'C004'
,p_column_display_sequence=>4
,p_column_heading=>'SQL'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(180181701541127563)
,p_query_column_id=>5
,p_column_alias=>'C005'
,p_column_display_sequence=>5
,p_column_heading=>'Error'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(186081214616567896)
,p_query_column_id=>6
,p_column_alias=>'C006'
,p_column_display_sequence=>6
,p_column_heading=>'Application'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(186081301781567897)
,p_query_column_id=>7
,p_column_alias=>'C007'
,p_column_display_sequence=>7
,p_column_heading=>'Parse Method'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(186111529919752006)
,p_query_column_id=>8
,p_column_alias=>'C008'
,p_column_display_sequence=>8
,p_column_heading=>'Dependancies'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(186111630519752007)
,p_query_column_id=>9
,p_column_alias=>'C009'
,p_column_display_sequence=>9
,p_column_heading=>'Compiled As'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(186132522918844604)
,p_query_column_id=>10
,p_column_alias=>'C010'
,p_column_display_sequence=>10
,p_column_heading=>'Parsed As'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(186134427682864997)
,p_query_column_id=>11
,p_column_alias=>'C011'
,p_column_display_sequence=>11
,p_column_heading=>'Temp Object Status'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(186308608802222083)
,p_query_column_id=>12
,p_column_alias=>'C012'
,p_column_display_sequence=>12
,p_column_heading=>'Lines'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(194098214077747922)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(180126220951957019)
,p_button_name=>'P268_GO'
,p_button_static_id=>'P268_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Set'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(169699005490411200)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(180126220951957019)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:268:&SESSION.:COMPUTE:&DEBUG.:RIR::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(180128907364964599)
,p_branch_action=>'f?p=&APP_ID.:268:&SESSION.:COMPUTE:&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>90
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(194096215678738968)
,p_branch_action=>'f?p=&APP_ID.:268:&SESSION.:COMPUTE:&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(194098214077747922)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(194094826713713714)
,p_name=>'P268_PAGE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(180126220951957019)
,p_item_default=>'&fb_flow_page_id.'
,p_prompt=>'Page'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST PAGES ESCAPED'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id || '' '' || wwv_flow_escape.html( name ) n, id',
'  from wwv_flow_steps',
' where flow_id           = nvl( :FB_FLOW_ID, :P164_APPLICATION )',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and is_page_pattern   = ''N''',
' order by 2'))
,p_cSize=>64
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the page on which to view Referenced Database Objects.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(188301603081117526)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'compute page dependencies'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_theme_manager.find_object_dependencies(',
'  p_flow_id=>:fb_flow_id,',
'  p_page_id=>:P268_PAGE_ID);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to compute dependencies.'
,p_process_when=>'COMPUTE'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>188301603081117526
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(127729420258904747)
,p_process_sequence=>70
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'determine lock status'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'wwv_flow_region_layout.set_lock_status (p_flow=>:fb_flow_id, p_page=>:P23_PAGE_ID);',
'exception when others then null;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_required_patch=>wwv_flow_imp.id(170786031904296885)
,p_internal_uid=>127729420258904747
,p_process_comment=>'Set Build Option to "Commented Out" as part of APEX-1012.'
);
end;
/
prompt --application/pages/page_00273
begin
wwv_flow_imp_page.create_page(
 p_id=>273
,p_name=>'Item Finder'
,p_alias=>'ITEM-FINDER'
,p_step_title=>'Item Finder'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(19943204431962826)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_srch.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6208909558950279)
,p_plug_name=>'Finder Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_imp.id(6207014968942318)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17534823323057949)
,p_plug_name=>'top bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(48571526134501952)
,p_plug_name=>'Items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>40
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name ,  j.t t, null prompt, to_number(NULL) p',
'from wwv_flow_items, ',
'        (select wwv_flow_lang.system_message(''F4000.APPLICATION_ITEM'') t from dual) j',
'where ',
'   :F4000_P273_PAGE is null',
'and flow_id = :fb_flow_id',
'union all',
'select name , j.t t, prompt , flow_step_id p',
'from wwv_flow_step_items, ',
'        (select wwv_flow_lang.system_message(''F4000.PAGE_ITEM'') t from dual) j',
'where ',
'   (:F4000_P273_PAGE is null or :F4000_P273_PAGE = flow_step_id)',
'and flow_id = :fb_flow_id',
'order by 1'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(48571614952501952)
,p_name=>'Items'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(48571832657501958)
,p_db_column_name=>'NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(48572019090501960)
,p_db_column_name=>'PROMPT'
,p_display_order=>2
,p_column_identifier=>'C'
,p_column_label=>'Label'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(48571912947501959)
,p_db_column_name=>'T'
,p_display_order=>3
,p_column_identifier=>'B'
,p_column_label=>'Type'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(48572127726501960)
,p_db_column_name=>'P'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Page'
,p_column_link=>'f?p=&APP_ID.:273:&SESSION.::&DEBUG.::F4000_P273_PAGE:#P#'
,p_column_linktext=>'#P#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(48572307979502610)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1287525686536643'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_display_rows=>200
,p_report_columns=>'NAME:PROMPT:T:P'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(17540318418257745)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(17534823323057949)
,p_button_name=>'F4000_P273_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Set'
,p_button_alignment=>'LEFT-CENTER'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1080990491963523937)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(48571526134501952)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:273:&SESSION.::&DEBUG.:RP,RIR,273:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(164635429079721696)
,p_branch_action=>'f?p=&FLOW_ID.:273:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17561408257292898)
,p_name=>'F4000_P273_PAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(17534823323057949)
,p_prompt=>'Page'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d',
'  from wwv_flow_steps',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and is_page_pattern   = ''N''',
'order by 2'))
,p_cSize=>8
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies the application page number. To change the page number, select or enter a new number and click <strong>Set</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
end;
/
prompt --application/pages/page_00278
begin
wwv_flow_imp_page.create_page(
 p_id=>278
,p_name=>'Confirm Delete of List Template'
,p_alias=>'CONFIRM-DELETE-OF-LIST-TEMPLATE'
,p_step_title=>'Confirm Delete of List Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(49191031406782532)
,p_plug_name=>'Confirm Delete'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(49195501717830717)
,p_name=>'Template Utilization'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select page_id||'': ''||PLUG_NAME name',
'from WWV_FLOW_PAGE_PLUGS r',
'where r.flow_id = :fb_flow_id and',
'      r.list_template_id = :p278_id',
'and r.security_group_id = :flow_security_group_id',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(11667910335347890)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No references found.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(49196130505831149)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(317061106029827931)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747140069854138158)
,p_plug_name=>'Confirm Delete'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(49191829113791331)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(317061106029827931)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(49192117171791333)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(317061106029827931)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Delete'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(49200124489856249)
,p_branch_action=>'f?p=&FLOW_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(49198532670849112)
,p_name=>'P278_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(49191031406782532)
,p_prompt=>'List Template:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select LIST_TEMPLATE_NAME, id',
'from WWV_FLOW_LIST_TEMPLATES',
'where flow_id = :FB_FLOW_ID',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies name of template to be deleted.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(49215521298949920)
,p_name=>'P278_LIST_THEME_CLASS_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(49191031406782532)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Template Class:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_class_id',
'from WWV_FLOW_LIST_TEMPLATES ',
'where flow_id = :fb_flow_id and id = :p278_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LIST THEME CLASS ID'
,p_lov=>'.'||wwv_flow_imp.id(43918610013174571)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'The template class identifies a specific usage for this template.  The template class is used when switching themes.  When switching themes template classes are matched, thus allowing themes to be switched without manually mapping all templates.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(49220916842977042)
,p_name=>'P278_THEME_ID'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_imp.id(49191031406782532)
,p_prompt=>'Theme:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id',
'from WWV_FLOW_LIST_TEMPLATES ',
'where flow_id = :fb_flow_id and id = :p278_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies a collection of templates which define the look and feel of the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(49206601596896907)
,p_validation_name=>'P278_ID'
,p_validation_sequence=>10
,p_validation=>'P278_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_associated_item=>wwv_flow_imp.id(49198532670849112)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(49235823993045364)
,p_validation_name=>'Prevent deletion of used templates'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_page_plugs',
' where flow_id          = :fb_flow_id',
'   and list_template_id = :p278_id'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'You may not delete referenced templates.'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(49199317217854124)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete template'
,p_process_sql_clob=>'delete from WWV_FLOW_LIST_TEMPLATES where flow_id = :fb_flow_id and id = :p278_id'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to Delete Template.'
,p_process_when_button_id=>wwv_flow_imp.id(49192117171791333)
,p_process_success_message=>'Template Deleted.'
,p_internal_uid=>49199317217854124
);
end;
/
prompt --application/pages/page_00286
begin
wwv_flow_imp_page.create_page(
 p_id=>286
,p_name=>'Create Breadcrumb Region - Confirm'
,p_alias=>'CREATE-BREADCRUMB-REGION-CONFIRM'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Breadcrumb Region'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213261028690930718)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_breadcrumb.htm'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4285618469956601)
,p_plug_name=>'Create Breadcrumb Region Confirmation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wiz_confirm.create_breadcrumb_region (',
'    p_flow_id         => :fb_flow_id,',
'    p_page_id         => :fb_flow_page_id,',
'    p_region_type     => :P481_REGION_TYPE,',
'    p_region_template => :P263_REGION_TEMPLATE,',
'    p_menu_template   => replace(:P263_MENU_TEMPLATE,''%null''||''%'',null),',
'    p_menu_template2  => replace(:P481_MENU_TEMPLATE,''%null''||''%'',null),',
'    p_parent_menu     => replace(:P264_PARENT_MENU,''%null''||''%'',null),',
'    p_menu_text       => :P264_MENU_TEXT,',
'    p_display_point   => :P263_DISPLAY_POINT);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_comment=>'Region generated 04-DEC-2002 19:27:47'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(16146020057102865)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(16141621180084222)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47747823969852084)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4286527624956609)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47747823969852084)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4286825242956609)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(47747823969852084)
,p_button_name=>'FINISH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Finish'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4295403009980952)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47747823969852084)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(302164623681732478)
,p_branch_action=>'f?p=&APP_ID.:286:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4295729966980953)
,p_branch_action=>'264'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(4295403009980952)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4287218990956613)
,p_branch_action=>'4500'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(4286527624956609)
,p_branch_sequence=>1
,p_branch_comment=>'Generated 04-DEC-2002 19:27:47'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(574136706995781523)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(4286527624956609)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(574136829945781524)
,p_event_id=>wwv_flow_imp.id(574136706995781523)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4259203636801340)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create breadcrumb'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'  l_id number;',
'  l_region_template number;',
' l_preset_template_options varchar2(4000);',
'',
'begin',
'  l_id := wwv_flow_id.next_val;',
'',
'  l_preset_template_options := wwv_flow_wizard_api.get_preset_template_options (replace(v(''P481_MENU_TEMPLATE''),''%null''||''%'',null),''BREADCRUMB'');',
'',
'-- determine region or no region',
'  if :P263_REGION_TEMPLATE = 0 then ',
'      l_region_template := null;',
'  else',
'      l_region_template := :P263_REGION_TEMPLATE ;',
'  end if;',
'',
'  -- create region',
'  wwv_flow_imp_page.create_page_plug (',
'    p_id => l_id,',
'    p_flow_id => :FB_FLOW_ID,',
'    p_page_id => :FB_FLOW_PAGE_ID,',
'    p_plug_name => :P263_REGION_TITLE,',
'    p_plug_template => l_region_template,',
'    p_region_template_options     => wwv_flow_wizard_api.get_preset_template_options (l_region_template,''REGION''),                    ',
'    p_parent_plug_id => null,',
'    p_plug_display_sequence => nvl(:P263_SEQUENCE,''1''),',
'    p_plug_display_point =>:P263_DISPLAY_POINT,',
'    p_plug_source => null,',
'    p_plug_source_type => :P481_REGION_TYPE,',
'    p_plug_display_when_condition => null,',
'    p_plug_display_when_cond2 => null,',
'    p_plug_display_condition_type => null,',
'    p_plug_required_role=>null,',
'    p_menu_template_id => replace(v(''P481_MENU_TEMPLATE''),''%null''||''%'',null),',
'    p_component_template_options => l_preset_template_options);',
'',
'  -- handle breadcrumbs with no parent defined',
'  if :P264_PARENT_MENU = ''0'' or :P264_PARENT_MENU = ''%''||''null%'' then',
'     :P264_PARENT_MENU := null;',
'  end if;',
'',
'  -- add breadcrumb entry',
'  if :P264_MENU_TEXT is not null then',
'   begin',
'   insert into WWV_FLOW_MENU_OPTIONS (',
'     parent_id, menu_id, option_sequence, short_name, link, page_id)',
'     values (',
'     :P264_PARENT_MENU, to_number(ltrim(:P481_REGION_TYPE,''M'')),',
'     10, :P264_MENU_TEXT, :P264_MENU_LINK, :FB_FLOW_PAGE_ID);',
'   exception when others then null;',
'   end;',
'  end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error creating breadcrumb.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(4286825242956609)
,p_internal_uid=>4259203636801340
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(574136961495781525)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,REQUEST'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Breadcrumb created successfully.'
,p_internal_uid=>574136961495781525
);
end;
/
prompt --application/pages/page_00288
begin
wwv_flow_imp_page.create_page(
 p_id=>288
,p_name=>'Create Breadcrumb'
,p_alias=>'CREATE-BREADCRUMB'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Breadcrumb'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213261028690930718)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'nav_breadcrumb.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9504015503603271)
,p_plug_name=>'Breadcrumb'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_header=>'A Breadcrumb is a hierarchical list of links that can be included as a region.  Each Breadcrumb is a container for Breadcrumb Entries.  Once a Breadcrumb is created you can define breadcrumb entries associated with pages.  Each entry can optionally h'
||'ave a parent entry.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'Region generated 30-APR-2002 20:45:47'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47724226235616200)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(9504309370603273)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(47724226235616200)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(9504420728603273)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(47724226235616200)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P288_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(9505514566603278)
,p_branch_name=>'Go To Page 104'
,p_branch_action=>'f?p=&APP_ID.:104:&SESSION.::&DEBUG.:104:P104_MENU_ID:&F4000_P288_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9506127798603280)
,p_name=>'F4000_P288_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(9504015503603271)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 30-APR-2002 20:45:47'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9506412786603284)
,p_name=>'F4000_P288_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(9504015503603271)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Application:'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LIST FLOWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'where  build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'order by 2'))
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'Generated 30-APR-2002 20:45:47'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9506717288603286)
,p_name=>'F4000_P288_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(9504015503603271)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Breadcrumb Name'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Enter a name for this new breadcrumb. Once you create a named breadcrumb, you can then add breadcrumb entries. The breadcrumb name provides a way to name a collection of breadcrumb entries.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 30-APR-2002 20:45:47'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(60493229398757215)
,p_validation_name=>'menu name required'
,p_validation_sequence=>10
,p_validation=>'F4000_P288_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Menu name must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(9504420728603273)
,p_associated_item=>wwv_flow_imp.id(9506717288603286)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(574039705326616928)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(9504309370603273)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(574039850125616929)
,p_event_id=>wwv_flow_imp.id(574039705326616928)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(9507408747603290)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_MENUS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_MENUS'
,p_attribute_03=>'F4000_P288_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_09=>'F4000_P288_ID'
,p_attribute_11=>'I'
,p_attribute_12=>'Y'
,p_process_error_message=>'Error processing action.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Breadcrumb created.'
,p_internal_uid=>9507408747603290
,p_process_comment=>'Generated 30-APR-2002 20:45:47'
);
end;
/
prompt --application/pages/page_00289
begin
wwv_flow_imp_page.create_page(
 p_id=>289
,p_name=>'Breadcrumb Template'
,p_alias=>'BREADCRUMB-TEMPLATE'
,p_step_title=>'Edit Breadcrumb Template'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'EXISTS'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_menu_templates t, ',
'       wwv_flow_themes th',
' where t.id                 = :F4000_P289_ID',
'   and t.flow_id            = th.flow_id',
'   and t.theme_id           = th.theme_id',
'   and t.security_group_id  = :WORKSPACE_ID',
'   and th.security_group_id = t.security_group_id',
'   and t.reference_id      is not null',
'   and th.reference_id     is not null'))
,p_help_text=>'ui_templt_bread.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9811230937057829)
,p_plug_name=>'Edit Breadcrumb Template'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--accessibleTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_landmark_label=>'Breadcrumb Template Actions'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9884830382210051)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>A breadcrumb template controls the display of breadcrumb region types. You select a breadcrumb template when you create a region.</p>'
,p_plug_query_no_data_found=>'No templates found.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(12979520505625516)
,p_plug_name=>'Landmark for Displayed Regions '
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_landmark_type=>'region'
,p_landmark_label=>'Displayed Regions'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9800924894050598)
,p_plug_name=>'Name'
,p_region_name=>'ID'
,p_parent_plug_id=>wwv_flow_imp.id(12979520505625516)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_no_data_found=>'No templates found.'
,p_plug_query_show_nulls_as=>'(null)'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'Region generated 30-APR-2002 22:00:21'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9872218342170050)
,p_plug_name=>'Template Type'
,p_region_name=>'START'
,p_parent_plug_id=>wwv_flow_imp.id(12979520505625516)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9873515970171128)
,p_plug_name=>'Link Attributes'
,p_region_name=>'AT'
,p_parent_plug_id=>wwv_flow_imp.id(12979520505625516)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_no_data_found=>'No templates found.'
,p_plug_query_show_nulls_as=>'(null)'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11774220719001100)
,p_plug_name=>'Definition'
,p_region_name=>'OPT'
,p_parent_plug_id=>wwv_flow_imp.id(12979520505625516)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(14473614253795731)
,p_plug_name=>'Comments'
,p_region_name=>'C'
,p_parent_plug_id=>wwv_flow_imp.id(12979520505625516)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(26694134482158372)
,p_plug_name=>'Template Options'
,p_parent_plug_id=>wwv_flow_imp.id(12979520505625516)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22115650667121016)
,p_plug_name=>'Template Options'
,p_parent_plug_id=>wwv_flow_imp.id(26694134482158372)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.template_types,',
'       o.id,',
'       o.display_name,',
'       o.name,',
'       o.display_sequence,',
'       o.css_classes,',
'       o.flow_id,',
'       o.theme_id,',
'       o.help_text,',
'       o.group_id,',
'       o.breadcrumb_template_id,',
'       ( select g.display_sequence from wwv_flow_template_opt_groups g where g.id = o.group_id ) group_display_sequence,',
'       ( select g.display_name     from wwv_flow_template_opt_groups g where g.id = o.group_id ) group_display_name',
'  from wwv_flow_template_options o',
' where o.flow_id                = :FB_FLOW_ID',
'   and o.theme_id               = :P289_THEME',
'   and o.template_types         = ''BREADCRUMB''',
'   and o.breadcrumb_template_id = :F4000_P289_ID',
'   and o.security_group_id      = :workspace_id'))
,p_plug_source_type=>'NATIVE_IG'
,p_ajax_items_to_submit=>'P289_DEFAULT_TEMPLATE_OPTIONS,P289_THEME'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Template Options'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(9691665898802649)
,p_name=>'BREADCRUMB_TEMPLATE_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'BREADCRUMB_TEMPLATE_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>70
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'F4000_P289_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(13087952783499036)
,p_name=>'GROUP_DISPLAY_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'GROUP_DISPLAY_SEQUENCE'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Group Sequence'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>80
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(13088047188499037)
,p_name=>'GROUP_DISPLAY_NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'GROUP_DISPLAY_NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Group Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>90
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(22116429201121024)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>30
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(22116515350121025)
,p_name=>'DISPLAY_NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DISPLAY_NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>100
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_item_width=>30
,p_is_required=>true
,p_max_length=>30
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_static_id=>'COLUMN_DISPLAY_NAME'
,p_use_as_row_header=>true
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(22116564635121026)
,p_name=>'DISPLAY_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DISPLAY_SEQUENCE'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>'Sequence'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>120
,p_value_alignment=>'RIGHT'
,p_attribute_03=>'left'
,p_attribute_04=>'decimal'
,p_item_width=>5
,p_is_required=>true
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'1'
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(22116680022121027)
,p_name=>'CSS_CLASSES'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'CSS_CLASSES'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Classes'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>130
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_max_length=>255
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(22117031658121030)
,p_name=>'APEX$ROW_ACTION'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>20
,p_use_as_row_header=>false
,p_display_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(22117081135121031)
,p_name=>'APEX$ROW_SELECTOR'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_use_as_row_header=>false
,p_display_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(22118115644121041)
,p_name=>'TEMPLATE_TYPES'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'TEMPLATE_TYPES'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>60
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'BREADCRUMB'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(22118177160121042)
,p_name=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Identifier'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>110
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_attribute_06=>'UPPER'
,p_item_width=>30
,p_is_required=>true
,p_max_length=>30
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(22758868249276496)
,p_name=>'HELP_TEXT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'HELP_TEXT'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Help Text'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>150
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(22758970052276497)
,p_name=>'GROUP_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'GROUP_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Group'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>140
,p_value_alignment=>'LEFT'
,p_is_required=>false
,p_lov_type=>'SQL_QUERY'
,p_lov_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name,',
'       id',
'  from wwv_flow_template_opt_groups',
' where template_types = :TEMPLATE_TYPES',
'   and flow_id        = :FB_FLOW_ID',
'   and theme_id       = :P289_THEME'))
,p_lov_display_extra=>true
,p_lov_display_null=>true
,p_lov_cascade_parent_items=>'TEMPLATE_TYPES'
,p_ajax_items_to_submit=>'P289_THEME'
,p_ajax_optimize_refresh=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(22759065680276498)
,p_name=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FLOW_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>40
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'FB_FLOW_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(22759184844276499)
,p_name=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'THEME_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>50
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'P289_THEME'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(22116321404121023)
,p_internal_uid=>22116321404121023
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_add_row_if_empty=>false
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>true
,p_no_data_found_message=>'No template options.'
,p_show_toolbar=>true
,p_toolbar_buttons=>'SEARCH_FIELD:SAVE'
,p_add_button_label=>'Add Template Option'
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>false
,p_define_chart_view=>false
,p_enable_download=>false
,p_download_formats=>null
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function(config) {',
'    config.defaultGridViewOptions = {',
'        reorderColumns: false',
'    }',
'    return config;',
'}'))
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(22552288102259849)
,p_interactive_grid_id=>wwv_flow_imp.id(22116321404121023)
,p_static_id=>'94803'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(22552474120259850)
,p_report_id=>wwv_flow_imp.id(22552288102259849)
,p_view_type=>'GRID'
,p_stretch_columns=>true
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(13075351327494163)
,p_view_id=>wwv_flow_imp.id(22552474120259850)
,p_display_seq=>11
,p_column_id=>wwv_flow_imp.id(22759065680276498)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(13076391134494169)
,p_view_id=>wwv_flow_imp.id(22552474120259850)
,p_display_seq=>12
,p_column_id=>wwv_flow_imp.id(22759184844276499)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(13094956288524694)
,p_view_id=>wwv_flow_imp.id(22552474120259850)
,p_display_seq=>13
,p_column_id=>wwv_flow_imp.id(9691665898802649)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(22553025342259856)
,p_view_id=>wwv_flow_imp.id(22552474120259850)
,p_display_seq=>2
,p_column_id=>wwv_flow_imp.id(22116429201121024)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(22553930302259863)
,p_view_id=>wwv_flow_imp.id(22552474120259850)
,p_display_seq=>4
,p_column_id=>wwv_flow_imp.id(22116515350121025)
,p_is_visible=>true
,p_is_frozen=>false
,p_sort_order=>4
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(22554812839259867)
,p_view_id=>wwv_flow_imp.id(22552474120259850)
,p_display_seq=>6
,p_column_id=>wwv_flow_imp.id(22116564635121026)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>106
,p_sort_order=>3
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(22555658412259872)
,p_view_id=>wwv_flow_imp.id(22552474120259850)
,p_display_seq=>7
,p_column_id=>wwv_flow_imp.id(22116680022121027)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(22558382023259881)
,p_view_id=>wwv_flow_imp.id(22552474120259850)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(22117031658121030)
,p_is_visible=>true
,p_is_frozen=>true
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(22764893493278881)
,p_view_id=>wwv_flow_imp.id(22552474120259850)
,p_display_seq=>10
,p_column_id=>wwv_flow_imp.id(22118115644121041)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(22765802204278887)
,p_view_id=>wwv_flow_imp.id(22552474120259850)
,p_display_seq=>5
,p_column_id=>wwv_flow_imp.id(22118177160121042)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(22769441708278899)
,p_view_id=>wwv_flow_imp.id(22552474120259850)
,p_display_seq=>8
,p_column_id=>wwv_flow_imp.id(22758868249276496)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(22770338477278902)
,p_view_id=>wwv_flow_imp.id(22552474120259850)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(22758970052276497)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(23839933539991090)
,p_view_id=>wwv_flow_imp.id(22552474120259850)
,p_display_seq=>14
,p_column_id=>wwv_flow_imp.id(13087952783499036)
,p_is_visible=>false
,p_is_frozen=>false
,p_sort_order=>1
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(23840815690991093)
,p_view_id=>wwv_flow_imp.id(22552474120259850)
,p_display_seq=>15
,p_column_id=>wwv_flow_imp.id(13088047188499037)
,p_is_visible=>false
,p_is_frozen=>false
,p_sort_order=>2
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(709628582013964769)
,p_name=>'Global Template Options'
,p_parent_plug_id=>wwv_flow_imp.id(26694134482158372)
,p_template=>wwv_flow_imp.id(689970285456172024)
,p_display_sequence=>230
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.id,',
'       o.display_name,',
'       o.display_sequence,',
'       o.css_classes,',
'       g.display_name group_name',
'  from wwv_flow_template_options o,',
'       wwv_flow_template_opt_groups g',
' where o.flow_id                 = :FB_FLOW_ID',
'   and o.virtual_template_id    is null',
'   and o.template_types          = ''BREADCRUMB''',
'   and o.breadcrumb_template_id is null',
'   and o.security_group_id       = :WORKSPACE_ID',
'   and o.theme_id                = :P289_THEME',
'   and g.id (+)                  = o.group_id',
' order by',
'       g.display_sequence,',
'       g.display_name,',
'       o.display_sequence,',
'       o.display_name'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P289_DEFAULT_TEMPLATE_OPTIONS,P289_THEME'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>200
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No template options defined.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(13082074660473939)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(13082472825473940)
,p_query_column_id=>2
,p_column_alias=>'DISPLAY_NAME'
,p_column_display_sequence=>21
,p_column_heading=>'Name'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(13082892750473940)
,p_query_column_id=>3
,p_column_alias=>'DISPLAY_SEQUENCE'
,p_column_display_sequence=>31
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(13083276810473940)
,p_query_column_id=>4
,p_column_alias=>'CSS_CLASSES'
,p_column_display_sequence=>41
,p_column_heading=>'Classes'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(13083604278473940)
,p_query_column_id=>5
,p_column_alias=>'GROUP_NAME'
,p_column_display_sequence=>11
,p_column_heading=>'Group'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(33345632077863019)
,p_plug_name=>'Subscription'
,p_region_name=>'SUBSCRIPTION'
,p_parent_plug_id=>wwv_flow_imp.id(12979520505625516)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P289_THEME_IS_SUBSCRIBED'
,p_plug_display_when_cond2=>'NONE'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'WWV_FLOW_MENU_TEMPLATES',
  'attribute_02', 'NAME',
  'attribute_03', 'F4000_P289_ID',
  'attribute_04', 'F4000_P289_REFERENCE_ID',
  'attribute_05', 'SUBSCRIBE_TEMPLATE')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(166122506409151503)
,p_plug_name=>'Substitution Strings'
,p_region_name=>'SS'
,p_parent_plug_id=>wwv_flow_imp.id(12979520505625516)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_templates_util.breadcrumb_template_sub_str (',
'    p_template_id   => :F4000_P289_ID);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'Substitution strings are used within sub templates to reference component values.  This report details substitution string usage for this template.'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(932807070079193714)
,p_plug_name=>'Subscription'
,p_parent_plug_id=>wwv_flow_imp.id(12979520505625516)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P289_THEME_IS_SUBSCRIBED = ''BOTH'' then',
'     sys.htp.p(wwv_flow_lang.system_message(''TEMPLATE_SUBSCRIPTION.THEME_AND_TEMPLATE_SUBSCRIBED''));',
'else',
'     sys.htp.p(wwv_flow_lang.system_message(''TEMPLATE_SUBSCRIPTION.THEME_SUBSCRIBED''));',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P289_THEME_IS_SUBSCRIBED'
,p_plug_display_when_cond2=>'NONE'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'N',
  'attribute_02', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46191504863907188)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(92865607458523737)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>90
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(92837202675352059)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(117333521045424865)
,p_plug_name=>'Hidden'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(617475406214054171)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_imp.id(29434107863295859)
,p_plug_display_sequence=>110
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from  WWV_FLOW_MENU_TEMPLATES',
'where id = :F4000_P289_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :F4000_P289_ID,',
'      p_component_type => ''Breadcrumb Template'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(13341913412840293)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(33345632077863019)
,p_button_name=>'PUBLISH_TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Publish Template'
,p_button_position=>'COPY'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.::F4000_P149_ID,F4000_P149_PAGE_ID,F4000_P149_TEMPLATE_TYPE:&F4000_P289_ID.,&FLOW_PAGE_ID.,BREADCRUMB_TEMPLATE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_menu_templates',
' where reference_id      = :F4000_P289_ID',
'   and security_group_id = :workspace_id'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(13337407740829146)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(33345632077863019)
,p_button_name=>'COPY_TEMPLATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Refresh'
,p_button_position=>'COPY'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_menu_templates',
' where id                = :F4000_P289_ID',
'   and security_group_id = :workspace_id',
'   and reference_id     is not null'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(9801204174050599)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(9811230937057829)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(9801517626050599)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(9811230937057829)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:503:&SESSION.::&DEBUG.::P503_ID:&F4000_P289_ID.'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P289_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(9801410558050599)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(9811230937057829)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P289_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(9801317332050599)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(9811230937057829)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P289_ID is null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(13072318466473911)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_imp.id(26694134482158372)
,p_button_name=>'OPTION_GROUPS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Template Option Groups'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:81:&SESSION.::&DEBUG.:CR,81:P81_THEME_ID,P81_TEMPLATE_TYPE:&P289_THEME.,BREADCRUMB'
,p_button_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(285878231222665018)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(9811230937057829)
,p_button_name=>'GET_PREVIOUS_ID'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'javascript:htmldb_goSubmit(''GET_PREVIOUS_ID'')'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'disabled=""'
,p_button_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(285878100347665018)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_imp.id(9811230937057829)
,p_button_name=>'GET_NEXT_ID'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Next'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'javascript:htmldb_goSubmit(''GET_NEXT_ID'')'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'disabled=""'
,p_button_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(27993023901805561)
,p_branch_action=>'f?p=&FLOW_ID.:289:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'F_4000_P289_STAY_ON_PAGE'
,p_branch_condition_text=>'YES'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(13376225256907546)
,p_branch_name=>'Go To Page 289'
,p_branch_action=>'f?p=&APP_ID.:289:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(13337407740829146)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(9802405431050605)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_comment=>'Generated 30-APR-2002 22:00:21'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(285885622820665059)
,p_branch_action=>'f?p=&FLOW_ID.:289:&SESSION.::&DEBUG.::F4000_P289_ID:&P289_ID_PREV.'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(285878231222665018)
,p_branch_sequence=>40
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(285885232263665057)
,p_branch_action=>'f?p=&FLOW_ID.:289:&SESSION.::&DEBUG.::F4000_P289_ID:&P289_ID_NEXT.'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(285878100347665018)
,p_branch_sequence=>50
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9803002371050608)
,p_name=>'F4000_P289_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(117333521045424865)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 30-APR-2002 22:00:21'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9803615747050612)
,p_name=>'F4000_P289_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(9800924894050598)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Identifies a name for this template. <p />',
'Use the <strong>Translatable</strong> check box to indicate that the template contains text strings that require translation.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 30-APR-2002 22:00:21'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9803912448050613)
,p_name=>'F4000_P289_BEFORE_FIRST'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(11774220719001100)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Before First'
,p_source=>'BEFORE_FIRST'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Defines text that displays before the first breadcrumb entry. You can use the substitution string #COMPONENT_CSS_CLASSES# to apply a CSS class to your breadcrumb template. The component CSS classes are set on the region edit page.',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 30-APR-2002 22:00:21'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9804230611050615)
,p_name=>'F4000_P289_CURRENT_PAGE_OPTION'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(11774220719001100)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Current Page Breadcrumb Entry (Use #LINK#, #NAME#, #NAME_ESC_SC#, #LONG_NAME#)'
,p_source=>'CURRENT_PAGE_OPTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Use this attribute to define the look of a breadcrumb entry that corresponds to the current page. Use the following substitution strings:</div>',
'<div class="htmldbInfoBodyP">',
'<table border=1>',
'',
'<tr><td>#NAME#</td><td>The short name of the breadcrumb entry</td></tr>',
'',
'<tr><td>#LINK#</td><td>The anchor target of the breadcrumb entry</td></tr>',
'',
'<tr><td>#LONG_NAME#</td><td>The long name of the breadcrumb entry</td></tr>',
'</table>',
'</div>',
'<div class="htmldbInfoBodyP">For example:</div>',
'<pre>',
'&amp;lt;li&amp;gt;&amp;lt;a href="#LINK#"&amp;gt;#NAME#&amp;lt;/a&amp;gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 30-APR-2002 22:00:21'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9804530828050617)
,p_name=>'P289_NON_CURRENT_PAGE_OPTION'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(11774220719001100)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Non Current Page Breadcrumb Entry (Use #LINK#, #NAME#, #NAME_ESC_SC#, #LONG_NAME#)'
,p_source=>'NON_CURRENT_PAGE_OPTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Use this attribute to define the look of a breadcrumb entry that does not correspond to the current page. Use the following substitution strings:',
'<div class="htmldbInfoBodyP">',
'<table border=1>',
'',
'<tr><td>#NAME#</td><td>The short name of the breadcrumb entry</td></tr>',
'',
'<tr><td>#LINK#</td><td>The anchor target of the breadcrumb entry</td></tr>',
'',
'<tr><td>#LONG_NAME#</td><td>The long name of the breadcrumb entry</td></tr>',
'',
'</table>',
'</div>',
'<div class="htmldbInfoBodyP">For example:</div>',
'',
'<pre>',
'&amp;lt;li&amp;gt;&amp;lt;a href="#LINK#"&amp;gt;#NAME#&amp;lt;/a&amp;gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 30-APR-2002 22:00:21'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9804825163050618)
,p_name=>'P289_MENU_LINK_ATTRIBUTES'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(9873515970171128)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Breadcrumb Link Attributes'
,p_source=>'MENU_LINK_ATTRIBUTES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">To display the hypertext link for the breadcrumb entry, add the following text to the HTML anchor tag in the position of the "X":</div>',
'',
'<pre>',
'&amp;lt;A HREF="..." X&amp;gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_item_comment=>'Generated 30-APR-2002 22:00:21'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9805114296050619)
,p_name=>'F4000_P289_BETWEEN_LEVELS'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(11774220719001100)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Between Levels'
,p_source=>'BETWEEN_LEVELS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Defines text that displays between levels of breadcrumb entries.  For example, if your breadcrumbs had three levels this text would be displayed at the &quot;X&quot; in the example that follows:<p />',
'',
'<code>main X cars X porsche X 911</code>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 30-APR-2002 22:00:21'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9805422925050624)
,p_name=>'F4000_P289_AFTER_LAST'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(11774220719001100)
,p_use_cache_before_default=>'NO'
,p_prompt=>'After Last'
,p_source=>'AFTER_LAST'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Defines text that displays after the last breadcrumb entries.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 30-APR-2002 22:00:21'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9805713626050625)
,p_name=>'F4000_P289_MAX_LEVELS'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(11774220719001100)
,p_use_cache_before_default=>'NO'
,p_item_default=>'99'
,p_prompt=>'Maximum Levels'
,p_source=>'MAX_LEVELS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Use this attribute to specify the number of levels that appear when displaying breadcrumbs in a breadcrumb style.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 30-APR-2002 22:00:21'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9806029721050627)
,p_name=>'F4000_P289_START_WITH_NODE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(9872218342170050)
,p_use_cache_before_default=>'NO'
,p_item_default=>'PARENT_TO_LEAF'
,p_prompt=>'Start With'
,p_source=>'START_WITH_NODE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MENU_START_WITH'
,p_lov=>'.'||wwv_flow_imp.id(84876111826444446)||'.'
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select a breadcrumb template style. Available options include:',
'<ul>',
'<li><strong>Child breadcrumb</strong> displays all breadcrumb entries that are children of the current page parent breadcrumb (that is peers of the current breadcrumb).</li>',
'<li><strong>Current Breadcrumb</strong> displays all breadcrumb entries in sequence with a common parent</li>.',
'<li><strong>Parent Breadcrumb</strong> displays all breadcrumb entries for the current page''s parent breadcrumb (that is, one level up from current breadcrumb).</li>',
'<li><strong>Parent to Leaf (breadcrumb style)</strong> displays the current page breadcrumb entry, its parent to the left, and so on until the root node is reached.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_item_comment=>'Generated 30-APR-2002 22:00:21'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(13072774717473914)
,p_name=>'P289_PRESET_TEMPLATE_OPTIONS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(26694134482158372)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Preset Template Options:'
,p_source=>'PRESET_TEMPLATE_OPTIONS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.TEMPALTE_OPT_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.display_name as d,',
'       o.css_classes as r,',
'       null default_template_options,',
'       null,',
'       o.help_text,',
'       g.display_name group_name,',
'       g.is_advanced advanced_group,',
'       g.null_text',
'  from wwv_flow_template_options o,',
'       wwv_flow_template_opt_groups g,',
'       wwv_flow_menu_templates t',
' where o.flow_id                = :fb_flow_id',
'   and o.template_types         = ''BREADCRUMB''',
'   and (breadcrumb_template_id  = :f4000_p289_id or breadcrumb_template_id is null)',
'   and o.theme_id               = t.theme_id',
'   and t.id                     = :f4000_p289_id',
'   and g.id                 (+) = o.group_id',
'   and o.security_group_id      = :WORKSPACE_ID',
'   and g.security_group_id  (+) = o.security_group_id',
'   and t.security_group_id      = o.security_group_id',
' order by ',
'       g.is_advanced nulls first,',
'       g.display_sequence nulls first,',
'       g.display_name nulls first,',
'       o.display_sequence,',
'       o.display_name'))
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(13073119534473916)
,p_name=>'P289_DEFAULT_TEMPLATE_OPTIONS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(26694134482158372)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Default Template Options:'
,p_source=>'DEFAULT_TEMPLATE_OPTIONS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.TEMPALTE_OPT_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.display_name as d,',
'       o.css_classes as r,',
'       t.default_template_options,',
'       null,',
'       o.help_text,',
'       g.display_name group_name',
'  from wwv_flow_template_options o,',
'       wwv_flow_template_opt_groups g,',
'       wwv_flow_menu_templates t',
' where o.flow_id                = :fb_flow_id',
'   and t.id                     = o.breadcrumb_template_id',
'   and o.breadcrumb_template_id = :F4000_P289_ID',
'   and g.id                 (+) = o.group_id',
'   and o.security_group_id      = :WORKSPACE_ID',
'   and g.security_group_id  (+) = o.security_group_id',
'   and t.security_group_id      = o.security_group_id',
' order by',
'       g.display_sequence nulls first,',
'       g.display_name nulls first,',
'       o.display_sequence,',
'       o.display_name'))
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(13073520859473916)
,p_name=>'P289_PRESET_TMPLOPT_CHECK'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(26694134482158372)
,p_source=>'F4000_P289_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(13348005033856166)
,p_name=>'F4000_P289_REFERENCE_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(33345632077863019)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Reference Master Template From'
,p_source=>'REFERENCE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FLOW_SUBSCRIBE_FROM_MENU_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- '' || lower(wwv_flow_lang.system_message(''NO_TEMPLATE'')) || '' -'' d, ',
'        0 r ',
'  from sys.dual ',
' union all',
'select flow_id||'' : ''||name||decode(theme_id,',
'       null,',
'       '''',',
'       '' (''||theme_id||'')'') n, ',
'       id r',
'  from wwv_flow_menu_templates',
' where flow_id != nvl(:fb_flow_id,0) ',
'   and flow_id in ( select f.id',
'                      from wwv_main_apps_dev f',
'                     where security_group_id = :flow_security_group_id ',
'                       and build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') ',
'   and exists ( select 1 ',
'  from wwv_flow_developers',
' where userid            = :flow_user ',
'   and ( flow_id is null or flow_id = f.id ) ',
'   and security_group_id = :flow_security_group_id)',
')',
'order by 1'))
,p_cSize=>60
,p_cMaxlength=>2000
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Select an existing template in this application or another template in your workspace''s schema. By selecting an existing template, you become a subscriber to that template.</div>',
'<div class="htmldbInfoBodyP">To load a new copy of any master template, click <span class="fielddatabold">Refresh</span>.</div>',
' '))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14476901745801560)
,p_name=>'F4000_P289_TEMPLATE_COMMENT'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(14473614253795731)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comment'
,p_source=>'TEMPLATE_COMMENTS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>5
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Developer comments or notes. These comments never display when the application is running.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(24155801481555004)
,p_name=>'P289_TRANSLATABLE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(9800924894050598)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Translatable'
,p_source=>'TRANSLATE_THIS_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(27991703815799820)
,p_name=>'F_4000_P289_STAY_ON_PAGE'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(9884830382210051)
,p_prompt=>'Stay on page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select this checkbox to stay on this page after applying changes.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'YES'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(35475318048709434)
,p_name=>'F4000_P289_REFRESH'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(33345632077863019)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Refresh'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_menu_templates',
' where reference_id     is null',
'   and id                = :F4000_P289_ID',
'   and security_group_id = :workspace_id'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(43943313617260830)
,p_name=>'P289_THEME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(9800924894050598)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Theme'
,p_source=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the theme to which this template is associated. A theme is a grouping of templates which together provide layout and style for an application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(43994026870321361)
,p_name=>'P289_TEMPLATE_CLASS'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(9800924894050598)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Template Class'
,p_source=>'THEME_CLASS_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MENU THEME CLASS ID'
,p_lov=>'.'||wwv_flow_imp.id(43945521366272493)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Not Identified -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Identifies a specific usage for this template.</div>',
'<div class="htmldbInfoBodyP">When you switch to a new theme, all templates in one theme are assigned to corresponding templates in another theme. App Builder accomplishes this template mapping through the assignment of template class identifiers.</di'
||'v>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(285883021673665046)
,p_name=>'P289_ID_NEXT'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(117333521045424865)
,p_prompt=>'P289_ID_NEXT'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(285883432384665047)
,p_name=>'P289_ID_PREV'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(117333521045424865)
,p_prompt=>'P289_ID_PREV'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(285883804344665048)
,p_name=>'P289_ID_COUNT'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(9811230937057829)
,p_prompt=>'Breadcrumb Template'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'Identifies breadcrumb template'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1007564516671031505)
,p_name=>'F4000_P289_INTERNAL_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(9800924894050598)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Identifier'
,p_source=>'INTERNAL_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Template identifier, this is used when switching and upgrading themes and cannot be modified.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'Generated 30-APR-2002 22:00:21'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2104396921708021397)
,p_name=>'P289_THEME_IS_SUBSCRIBED'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(9800924894050598)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2104397276038036503)
,p_computation_sequence=>10
,p_computation_item=>'P289_THEME_IS_SUBSCRIBED'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'    l_is_subscribed varchar2(16) := ''NONE'';',
'begin',
'  ',
'    for c1 in (',
'        select t.reference_id template_ref_id, th.reference_id theme_ref_id',
'        from wwv_flow_menu_templates t, wwv_flow_themes th',
'        where t.id = :F4000_P289_ID',
'        and t.flow_id = th.flow_id',
'        and t.theme_id = th.theme_id',
'        and t.security_group_id = :workspace_id',
'    ) loop',
'        if c1. theme_ref_id is not null then',
'            if c1.template_ref_id is not null then',
'                l_is_subscribed := ''BOTH'';',
'            else ',
'                l_is_subscribed := ''THEME'';',
'            end if;',
'        end if;    ',
'    end loop;',
'',
'    return l_is_subscribed;',
'',
'end;'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(35486527081735646)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P289_REFRESH'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'Unable to compute item value.'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(9965629014301830)
,p_validation_name=>'F4000_P289_NAME Not Null'
,p_validation_sequence=>10
,p_validation=>'F4000_P289_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Name must be specified.'
,p_associated_item=>wwv_flow_imp.id(9803615747050612)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 30-APR-2002 22:42'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(13353812785867719)
,p_validation_name=>'reference id not null'
,p_validation_sequence=>20
,p_validation=>'F4000_P289_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Reference ID must be specified to refresh the template.'
,p_when_button_pressed=>wwv_flow_imp.id(13337407740829146)
,p_associated_item=>wwv_flow_imp.id(13348005033856166)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(13359330672874601)
,p_validation_name=>'reference id not zero'
,p_validation_sequence=>30
,p_validation=>'F4000_P289_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_ZERO'
,p_error_message=>'Template to refresh must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(13337407740829146)
,p_associated_item=>wwv_flow_imp.id(13348005033856166)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(116566530918758697)
,p_validation_name=>'unique template name'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_menu_templates ',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :workspace_id',
'   and theme_id          = :P289_THEME',
'   and name              = :F4000_P289_NAME',
'   and id               != :F4000_P289_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Template name must be unique'
,p_associated_item=>wwv_flow_imp.id(9803615747050612)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(24048884855574815)
,p_tabular_form_region_id=>wwv_flow_imp.id(22115650667121016)
,p_validation_name=>'Template Options - No duplicates name'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_template_options',
' where flow_id                 = :FB_FLOW_ID',
'   and theme_id                = :P289_THEME',
'   and breadcrumb_template_id  = :F4000_P289_ID',
'   and security_group_id       = :WORKSPACE_ID',
'   and name                    = :NAME',
'   and template_types          = :TEMPLATE_TYPES',
'   and (:ID is null or id != :ID)'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#COLUMN_HEADER# must be unique.'
,p_validation_condition=>'F4000_P289_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_exec_cond_for_each_row=>'Y'
,p_associated_column=>'NAME'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(24048911637574816)
,p_tabular_form_region_id=>wwv_flow_imp.id(22115650667121016)
,p_validation_name=>'Template Options - No duplicates classes'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_template_options',
' where flow_id                 = :FB_FLOW_ID',
'   and theme_id                = :P289_THEME',
'   and breadcrumb_template_id  = :F4000_P289_ID',
'   and security_group_id       = :WORKSPACE_ID',
'   and css_classes             = :CSS_CLASSES',
'   and template_types          = :TEMPLATE_TYPES',
'   and (:ID is null or id != :ID)'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#COLUMN_HEADER# must be unique.'
,p_validation_condition=>'F4000_P289_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_exec_cond_for_each_row=>'Y'
,p_associated_column=>'CSS_CLASSES'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(378312204028510813)
,p_name=>'ENABLE PREVIOUS'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P289_ID_PREV'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(378312530811510813)
,p_event_id=>wwv_flow_imp.id(378312204028510813)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(285878231222665018)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(378312611647513039)
,p_name=>'ENABLE NEXT'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P289_ID_NEXT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(378312909800513040)
,p_event_id=>wwv_flow_imp.id(378312611647513039)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(285878100347665018)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(9691746157802650)
,p_name=>'upper case identifier'
,p_event_sequence=>30
,p_triggering_element_type=>'COLUMN'
,p_triggering_region_id=>wwv_flow_imp.id(22115650667121016)
,p_triggering_element=>'DISPLAY_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(13084552097499002)
,p_event_id=>wwv_flow_imp.id(9691746157802650)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
':NAME := regexp_replace(',
'      srcstr     => :DISPLAY_NAME,',
'      pattern    => ''[^'' || wwv_flow_utilities.c_alnum || '']+'',',
'      replacestr => ''_'' );'))
,p_attribute_02=>'DISPLAY_NAME'
,p_attribute_03=>'NAME'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(13084620424499003)
,p_name=>'refresh template options on cancel'
,p_event_sequence=>40
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'body'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosecanceldialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(13084778836499004)
,p_event_id=>wwv_flow_imp.id(13084620424499003)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(22115650667121016)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(13084805499499005)
,p_event_id=>wwv_flow_imp.id(13084620424499003)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(709628582013964769)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3002244636333520)
,p_name=>'Show Publish Success Msg'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(13341913412840293)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3002318011333521)
,p_event_id=>wwv_flow_imp.id(3002244636333520)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ( this.data.successMessage ) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(9806421442050629)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_MENU_TEMPLATES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_MENU_TEMPLATES'
,p_attribute_03=>'F4000_P289_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error fetching row.'
,p_internal_uid=>9806421442050629
,p_process_comment=>'Generated 30-APR-2002 22:00:21'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(285884822062665055)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_PAGINATION'
,p_process_name=>'Get Next or Previous Primary Key Value'
,p_attribute_02=>'WWV_FLOW_MENU_TEMPLATES'
,p_attribute_03=>'F4000_P289_ID'
,p_attribute_04=>'ID'
,p_attribute_07=>'THEME_ID'
,p_attribute_08=>'NAME'
,p_attribute_09=>'P289_ID_NEXT'
,p_attribute_10=>'P289_ID_PREV'
,p_attribute_13=>'P289_ID_COUNT'
,p_attribute_14=>'flow_id = :fb_flow_id'
,p_process_error_message=>'Unable to run Get Next or Previous Primary Key Value process.'
,p_internal_uid=>285884822062665055
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(13366201774888006)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh template 1'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_menu_template (',
'    p_master_template_id         => :F4000_P289_REFERENCE_ID,',
'    p_subscribing_template_id    => :F4000_P289_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying template.'
,p_process_when_button_id=>wwv_flow_imp.id(13337407740829146)
,p_process_when=>'F4000_P289_REFERENCE_ID'
,p_process_when_type=>'VALUE_OF_ITEM_IN_COND_1_NOT_EQ_COND_2'
,p_process_when2=>'0'
,p_process_success_message=>'Template Copied.'
,p_internal_uid=>13366201774888006
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(9806725148050630)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_MENU_TEMPLATES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_MENU_TEMPLATES'
,p_attribute_03=>'F4000_P289_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error processing row.'
,p_process_when=>'COPY_TEMPLATE'
,p_process_when_type=>'REQUEST_NOT_IN_CONDITION'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>9806725148050630
,p_process_comment=>'Generated 30-APR-2002 22:00:21'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(13372203702902353)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove reference id as needed'
,p_process_sql_clob=>'wwv_flow_copy_metadata.remove_menu_reference_id (:F4000_P289_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error setting template id to null.'
,p_process_when_button_id=>wwv_flow_imp.id(9801410558050599)
,p_process_when=>'F4000_P289_REFERENCE_ID'
,p_process_when_type=>'VALUE_OF_ITEM_IN_COND_1_EQ_COND_2'
,p_process_when2=>'0'
,p_internal_uid=>13372203702902353
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(35491510691743218)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh template 2'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_menu_template (',
'    p_master_template_id         => :F4000_P289_REFERENCE_ID,',
'    p_subscribing_template_id    => :F4000_P289_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying template.'
,p_process_when_button_id=>wwv_flow_imp.id(9801410558050599)
,p_process_when=>':F4000_P289_REFERENCE_ID is not null and :F4000_P289_REFRESH = ''Y'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Template Copied.'
,p_internal_uid=>35491510691743218
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(13081369705473936)
,p_process_sequence=>80
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(22115650667121016)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Template Options - Save Interactive Grid Data'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>13081369705473936
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1449463211432055535)
,p_process_sequence=>80
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sync template option presets'
,p_process_sql_clob=>'wwv_flow_templates_util.sync_bc_tmplopt_presets(:F4000_P289_ID);'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'nvl(:P289_PRESET_TEMPLATE_OPTIONS,''NOPRESETS'') <> nvl(:P289_PRESET_TMPLOPT_CHECK,''NOPRESETS'') '
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>1449463211432055535
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(24048737643574814)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_region_id=>wwv_flow_imp.id(22115650667121016)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'upper :name'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':NAME := REGEXP_REPLACE(',
'      srcstr     => :NAME,',
'      pattern    => ''[^'' || wwv_flow_utilities.c_alnum || '']+'',',
'      replacestr => ''_'' );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'F4000_P289_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_exec_cond_for_each_row=>'Y'
,p_internal_uid=>24048737643574814
);
end;
/
prompt --application/pages/page_00291
begin
wwv_flow_imp_page.create_page(
 p_id=>291
,p_name=>'Page Locks'
,p_alias=>'PAGE-LOCKS'
,p_step_title=>'Page Locks'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213229021839834158)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_locks.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(37419214876657905)
,p_name=>'Locks by Developer'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_display_column=>1
,p_display_point=>'REGION_POSITION_03'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select locked_by locked_by,',
'       count(*) cnt',
'from wwv_flow_lock_page l, wwv_flow_steps p',
'where l.flow_id = :fb_flow_id and',
'      p.flow_id = :fb_flow_id and',
'      l.object_id = p.id',
'group by locked_by',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(11667910335347890)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(196323112284998552)
,p_query_column_id=>1
,p_column_alias=>'LOCKED_BY'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:291:&SESSION.::&DEBUG.:291,RIR:IR_LOCKED_BY:#LOCKED_BY#'
,p_column_linktext=>'#LOCKED_BY# #CNT#'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(196323206311998576)
,p_query_column_id=>2
,p_column_alias=>'CNT'
,p_column_display_sequence=>2
,p_column_heading=>'Cnt'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(37437117703762743)
,p_plug_name=>'Page Locks'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>11
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>To lock a page, select the check box corresponding to the page and click  <strong>Lock Checked</strong>.</p>',
'<p>To unlock a page, select the check box corresponding to the page and click <strong>Unlock Checked</strong>.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(195810813298176622)
,p_plug_name=>'Pages'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>130
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'  htmldb_item.checkbox(1, wwv_flow_escape.html(p.id), null,null,null,''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0''), wwv_flow_lang.system_message(''PAGE_LABEL'',wwv_flow_escape.html(p.name))) checkbox,',
'  p.id page_id,',
'  p.name, ',
'  nvl(l.locked_by,'' '') locked_by,',
'  l.locked_on,',
'  nvl(l.lock_comment,'' '') lock_comment,',
'  p.id object_id,',
'  decode(l.locked_by,null,',
'    ''<span class="a-Icon icon-unlock"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''PAGE_UNLOCKED'')||''</span>'',',
'    ''<span class="a-Icon icon-lock"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''PAGE_LOCKED'')||''</span>'' ) status,',
'   last_updated_on page_updated,',
'    l.id lock_id,',
'    p.last_updated_by, ',
'    m.v,',
'    p.flow_id',
'from wwv_flow_lock_page l,',
'     wwv_flow_steps p, (select wwv_flow_lang.system_message(''F4000.P291.VIEW_LOCK'') v from dual) m',
'where p.flow_id = :fb_flow_id and',
'      p.flow_id = l.flow_id(+) and',
'      l.object_id(+) = p.id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(195810900170176622)
,p_name=>'Pages'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(195829328011271089)
,p_db_column_name=>'CHECKBOX'
,p_display_order=>1
,p_column_identifier=>'K'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_rpt_show_filter_lov=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(195811724834176693)
,p_db_column_name=>'STATUS'
,p_display_order=>2
,p_column_identifier=>'G'
,p_column_label=>'Status'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_rpt_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''PAGE_LOCKED'') x from dual ',
'union all',
'select wwv_flow_lang.system_message(''PAGE_UNLOCKED'') x from dual'))
,p_rpt_show_filter_lov=>'C'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(195811126873176687)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>3
,p_column_identifier=>'A'
,p_column_label=>'Page'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE_ID#'
,p_column_linktext=>'#PAGE_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(195811228294176688)
,p_db_column_name=>'NAME'
,p_display_order=>4
,p_column_identifier=>'B'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(195811309285176689)
,p_db_column_name=>'LOCKED_BY'
,p_display_order=>5
,p_column_identifier=>'C'
,p_column_label=>'Locked By'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(195811417567176690)
,p_db_column_name=>'LOCKED_ON'
,p_display_order=>6
,p_column_identifier=>'D'
,p_column_label=>'Date Locked'
,p_column_type=>'DATE'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(195811821396176694)
,p_db_column_name=>'PAGE_UPDATED'
,p_display_order=>7
,p_column_identifier=>'H'
,p_column_label=>'Page Updated'
,p_column_type=>'DATE'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(195811522034176691)
,p_db_column_name=>'LOCK_COMMENT'
,p_display_order=>8
,p_column_identifier=>'E'
,p_column_label=>'Lock Comment'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(195811623509176692)
,p_db_column_name=>'OBJECT_ID'
,p_display_order=>9
,p_column_identifier=>'F'
,p_column_label=>'&nbsp;'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(195811923089176695)
,p_db_column_name=>'LOCK_ID'
,p_display_order=>10
,p_column_identifier=>'I'
,p_column_label=>'View Lock'
,p_column_link=>'f?p=&APP_ID.:337:&SESSION.::&DEBUG.:337:P337_ID,FB_FLOW_PAGE_ID:#LOCK_ID#,#OBJECT_ID#'
,p_column_linktext=>'<span class="a-Icon icon-search"></span><span class="u-VisuallyHidden">#V#</span>'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_column_type=>'NUMBER'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(195812017472176696)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>11
,p_column_identifier=>'J'
,p_column_label=>'LAST_UPDATED_BY'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1059808080930457617)
,p_db_column_name=>'V'
,p_display_order=>21
,p_column_identifier=>'L'
,p_column_label=>'V'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(176250977948916909)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>31
,p_column_identifier=>'M'
,p_column_label=>'Flow Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(195812207403177156)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1287717245536643'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'CHECKBOX:STATUS:PAGE_ID:NAME:LOCKED_BY:LOCKED_ON:PAGE_UPDATED:LOCK_COMMENT:LOCK_ID:V:FLOW_ID'
,p_sort_column_1=>'PAGE_ID'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(195838228460403664)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>91
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(34740016606195595)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_plug_required_role=>wwv_flow_imp.id(12511519296310366)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(34595125536874843)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(195810813298176622)
,p_button_name=>'UNLOCK'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Unlock Checked'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(34544605404490574)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(195810813298176622)
,p_button_name=>'LOCK'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'Lock Checked'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(37880920248115204)
,p_branch_name=>'Go To Page 444'
,p_branch_action=>'f?p=&APP_ID.:444:&SESSION.::&DEBUG.::::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(34544605404490574)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(34534825970425228)
,p_branch_action=>'f?p=&FLOW_ID.:291:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(37898729046202847)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'291'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(51831500213009272)
,p_validation_name=>'locking pages requires page selection'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if WWV_FLOW.G_F01.COUNT = 0 then',
'   return false;',
'else',
'   return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'You must select at least one page to lock.'
,p_when_button_pressed=>wwv_flow_imp.id(34544605404490574)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1059808123705457618)
,p_validation_name=>'unlocking pages requires page selection'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if WWV_FLOW.G_F01.COUNT = 0 then',
'   return false;',
'else',
'   return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'You must select at least one page to unlock.'
,p_when_button_pressed=>wwv_flow_imp.id(34595125536874843)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(113449032017001828)
,p_validation_name=>'dont allow locking already locked pages'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  c int := 0;',
'  l int := 0;',
'begin',
'FOR I in 1..WWV_FLOW.G_F01.COUNT LOOP',
'    select count(*) into l ',
'      from WWV_FLOW_LOCK_PAGE ',
'     where flow_id = :fb_flow_id and',
'           object_id = wwv_flow.g_f01(i) and',
'           locked_by is not null;',
'   c := c + l;',
'END LOOP;',
'if c = 0 then return true; else return false; end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'You may not lock pages that have already been locked.'
,p_when_button_pressed=>wwv_flow_imp.id(34544605404490574)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1059808256229457619)
,p_validation_name=>'dont allow unlocking already unlocked pages'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  c int := 0;',
'  l int := 0;',
'begin',
'FOR I in 1..WWV_FLOW.G_F01.COUNT LOOP',
'    select count(*) into l ',
'      from WWV_FLOW_LOCK_PAGE ',
'     where flow_id = :fb_flow_id and',
'           object_id = wwv_flow.g_f01(i);',
'   c := c + l;',
'END LOOP;',
'if c = 0 then return false; else return true; end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'You may not unlock pages that are not locked.'
,p_validation_condition=>'WWV_FLOW.G_F01.COUNT <> 0'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(34595125536874843)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1157779028285618635)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(195810813298176622)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1157779116700618636)
,p_event_id=>wwv_flow_imp.id(1157779028285618635)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(34565314595606825)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'lock page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  c int;',
'begin',
':P444_LOCK_COMMENT := null;',
':P444_LOCK_PAGES := null;',
'FOR I in 1..WWV_FLOW.G_F01.COUNT LOOP',
'    select count(*) a into c ',
'      from WWV_FLOW_LOCK_PAGE ',
'     where flow_id = :fb_flow_id and',
'           object_id = wwv_flow.g_f01(i) and',
'           locked_by is not null;',
'    if c = 0 then',
'       :P444_LOCK_PAGES := :P444_LOCK_PAGES||wwv_flow.g_f01(i)||'':'';',
'    end if;',
'END LOOP;',
':P444_LOCK_PAGES := rtrim(:P444_LOCK_PAGES,'':'');',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to lock page(s).'
,p_process_when_button_id=>wwv_flow_imp.id(34544605404490574)
,p_process_success_message=>'Page(s) Locked'
,p_internal_uid=>34565314595606825
,p_process_comment=>'identify the list of pages to be locked.'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(34603328053932355)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'unlock page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'FOR I in 1..WWV_FLOW.G_F01.COUNT LOOP',
'    delete from WWV_FLOW_LOCK_PAGE ',
'     where object_id = wwv_flow.g_f01(i) and',
'           flow_id = :fb_flow_id and',
'           locked_by = :app_user;',
'END LOOP;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to unlock page(s).'
,p_process_when_button_id=>wwv_flow_imp.id(34595125536874843)
,p_process_success_message=>'Page(s) Unlocked'
,p_internal_uid=>34603328053932355
);
end;
/
prompt --application/pages/page_00298
begin
wwv_flow_imp_page.create_page(
 p_id=>298
,p_name=>'Confirm Delete of Page Template'
,p_alias=>'CONFIRM-DELETE-OF-PAGE-TEMPLATE'
,p_step_title=>'Confirm Delete of Page Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(49253017607109811)
,p_name=>'Template Utilization'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||NAME n, id',
'  from WWV_FLOW_STEPS p',
' where p.flow_id       = :fb_flow_id',
'   and p.step_template = :p298_id',
'union all',
'select wwv_flow_lang.system_message(''DEFAULT_TEMPLATE'')||'': ''||name n, null id',
'  from WWV_FLOW_TEMPLATES pt,',
'       wwv_flow_themes t',
' where pt.id      = :p298_id',
'   and t.flow_id  = pt.flow_id',
'   and t.theme_id = pt.theme_id',
'  and t.default_page_template = :p298_id',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(11667910335347890)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No references found.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(49278928036188445)
,p_query_column_id=>1
,p_column_alias=>'N'
,p_column_display_sequence=>1
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#ID#'
,p_column_linktext=>'#N#'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(203841011183167634)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(49253503210109822)
,p_plug_name=>'Confirm Delete'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(200308903627839307)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747140365511138158)
,p_plug_name=>'Confirm Delete'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(49254328662109825)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(200308903627839307)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(49254710720109828)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(200308903627839307)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Delete'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(49258510761109860)
,p_branch_action=>'f?p=&FLOW_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(49255114396109830)
,p_name=>'P298_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(49253503210109822)
,p_prompt=>'Page Template:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LIST PAGETEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name, id',
'from   wwv_flow_templates',
'where  flow_id = :FB_FLOW_ID ',
'and   (:fb_theme_id is null or theme_id = :fb_theme_id)',
'and    is_popup = (case when :P4301_PAGE_MODE = ''NORMAL'' then ''N'' else ''Y'' end)',
'order  by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies name of template to be deleted.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(49255816003109839)
,p_name=>'P298_THEME_ID'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_imp.id(49253503210109822)
,p_prompt=>'Theme:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id',
'from WWV_FLOW_TEMPLATES ',
'where flow_id = :fb_flow_id and id = :p298_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies a collection of templates which define the look and feel of the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(49256510133109842)
,p_name=>'P298_LIST_THEME_CLASS_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(49253503210109822)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Template Class:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_class_id',
'from WWV_FLOW_TEMPLATES ',
'where flow_id = :fb_flow_id and id = :p298_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PAGE THEME CLASS ID'
,p_lov=>'.'||wwv_flow_imp.id(41972431732112027)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'The template class identifies a specific usage for this template.  The template class is used when switching themes.  When switching themes template classes are matched, thus allowing themes to be switched without manually mapping all templates.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(49257715041109851)
,p_validation_name=>'P298_ID'
,p_validation_sequence=>10
,p_validation=>'P298_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_associated_item=>wwv_flow_imp.id(49255114396109830)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(49257311083109847)
,p_validation_name=>'Prevent deletion of used templates'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_STEPS',
' where flow_id       = :fb_flow_id',
'   and STEP_TEMPLATE = :p298_id',
' union all',
'select 1',
'  from wwv_flow_themes',
' where flow_id = :fb_flow_id',
'   and default_page_template = :p298_id'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'You may not delete templates defined as default in the application''s theme.'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(49258108370109855)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete template'
,p_process_sql_clob=>'delete from WWV_FLOW_TEMPLATES where flow_id = :fb_flow_id and id = :p298_id'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to Delete Template.'
,p_process_when_button_id=>wwv_flow_imp.id(49254710720109828)
,p_process_success_message=>'Template Deleted.'
,p_internal_uid=>49258108370109855
);
end;
/
prompt --application/pages/page_00299
begin
wwv_flow_imp_page.create_page(
 p_id=>299
,p_name=>'Lock Administration'
,p_alias=>'LOCK-ADMINISTRATION'
,p_step_title=>'Lock Administration'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213229021839834158)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12511519296310366)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_locks.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22395215733416572)
,p_plug_name=>'Locked Pages'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>100
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'  HTMLDB_ITEM.CHECKBOX(1,wwv_flow_escape.html(p.id),null,null,null,''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0''), wwv_flow_lang.system_message(''PAGE_LABEL'',wwv_flow_escape.html(p.name))) cb,',
'  p.id page_id,',
'  p.name,',
'  l.locked_by,',
'  l.locked_on,',
'  nvl(l.lock_comment,'' '') lock_comment,',
'  ''<span class="a-Icon icon-lock"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''PAGE_LOCKED'')||''</span>''  status,',
'    last_updated_on page_updated,',
'    l.id lock_id, ',
'  m.e',
'from wwv_flow_lock_page l,',
'     wwv_flow_steps p, (select wwv_flow_lang.system_message(''EDIT'') e from dual) m',
'where p.flow_id = :fb_flow_id and',
'      p.flow_id = l.flow_id(+) and',
'      l.object_id(+) = p.id and',
'      l.locked_by is not null and',
'      p.security_group_id = :flow_security_group_id  '))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(22395308619416572)
,p_name=>'Locked Pages'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(22395515809416594)
,p_db_column_name=>'CB'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(22396318708416705)
,p_db_column_name=>'LOCK_ID'
,p_display_order=>2
,p_column_identifier=>'I'
,p_column_label=>'Edit'
,p_column_link=>'f?p=&APP_ID.:330:&SESSION.::&DEBUG.::P330_ID:#LOCK_ID#'
,p_column_linktext=>'<span class="a-Icon icon-edit"></span><span class="u-VisuallyHidden">#E#</span>'
,p_column_type=>'NUMBER'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(22396111171416704)
,p_db_column_name=>'STATUS'
,p_display_order=>3
,p_column_identifier=>'G'
,p_column_label=>'Status'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_rpt_lov=>'select wwv_flow_lang.system_message(''PAGE_LOCKED'') x from dual'
,p_rpt_show_filter_lov=>'C'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(22395601792416702)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>4
,p_column_identifier=>'B'
,p_column_label=>'Page'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE_ID#'
,p_column_linktext=>'#PAGE_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(22395724374416703)
,p_db_column_name=>'NAME'
,p_display_order=>5
,p_column_identifier=>'C'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(22395830635416703)
,p_db_column_name=>'LOCKED_BY'
,p_display_order=>6
,p_column_identifier=>'D'
,p_column_label=>'Locked By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(22395931257416703)
,p_db_column_name=>'LOCKED_ON'
,p_display_order=>7
,p_column_identifier=>'E'
,p_column_label=>'Date Locked'
,p_column_type=>'DATE'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'&DATE_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(22396222005416704)
,p_db_column_name=>'PAGE_UPDATED'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Page Updated'
,p_column_type=>'DATE'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(22396014516416704)
,p_db_column_name=>'LOCK_COMMENT'
,p_display_order=>9
,p_column_identifier=>'F'
,p_column_label=>'Lock Comment'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1059808798325457624)
,p_db_column_name=>'E'
,p_display_order=>19
,p_column_identifier=>'J'
,p_column_label=>'E'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(22396515190416914)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1287829743536643'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'CB:LOCK_ID:PAGE_ID:LOCK_COMMENT:STATUS:LOCKED_ON:PAGE_UPDATED:'
,p_sort_column_1=>'PAGE_ID'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(34915019176525555)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>91
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(34740016606195595)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(35076800837472468)
,p_plug_name=>'Lock Administration'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>31
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'This page allows workspace administrators to unlock pages locked by any workspace developer. Use this page to edit the lock owner and lock comment attributes.  To manage a lock on a specific page click the <strong>Edit</strong> icon.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(34926609836598547)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(22395215733416572)
,p_button_name=>'UNLOCKPAGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Unlock Page(s)'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(34927413645599678)
,p_branch_action=>'f?p=&FLOW_ID.:299:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1157779216107618637)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(22395215733416572)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1157779371601618638)
,p_event_id=>wwv_flow_imp.id(1157779216107618637)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(34937122396659003)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'unlock pages'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'FOR I in 1..wwv_flow.g_f01.count LOOP',
'    delete from WWV_FLOW_LOCK_PAGE ',
'     where object_id = to_number(wwv_flow.g_f01(i)) and',
'           flow_id = :fb_flow_id;',
'END LOOP;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to unlock page(s)'
,p_process_when_button_id=>wwv_flow_imp.id(34926609836598547)
,p_process_success_message=>'Page(s) unlocked'
,p_security_scheme=>wwv_flow_imp.id(12511519296310366)
,p_internal_uid=>34937122396659003
);
end;
/
prompt --application/pages/page_00301
begin
wwv_flow_imp_page.create_page(
 p_id=>301
,p_name=>'Copy Page - Page to Copy'
,p_alias=>'COPY-PAGE-PAGE-TO-COPY'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Page'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function getNewPageName( pSelectedPage )',
'{',
'    return pSelectedPage.substring( pSelectedPage.indexOf('':'') + 1 , pSelectedPage.length );',
'}'))
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_copy_pg.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(18344031106016009)
,p_plug_name=>'Copy Page'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'Region generated 06-JAN-2003 14:58:56'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(18569618340857662)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(18564606387816293)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44111408367534414)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(18344926854016042)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(44111408367534414)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(18345210914016042)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(44111408367534414)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(200994430208628102)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(44111408367534414)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:618:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(18346104732016063)
,p_branch_name=>'Go To Page 305'
,p_branch_action=>'305'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(18345210914016042)
,p_branch_sequence=>10
,p_branch_comment=>'Generated 06-JAN-2003 14:58:56'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(211843308225373247)
,p_branch_name=>'Go To Page 301'
,p_branch_action=>'f?p=&APP_ID.:301:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'P301_BREADCRUMB_ID'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18344702485016034)
,p_name=>'P301_COPY_FROM'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(18344031106016009)
,p_prompt=>'Copy From Page'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 06-JAN-2003 14:58:56'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18354700370037123)
,p_name=>'P301_COPY_TO'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(18344031106016009)
,p_prompt=>'New Page Number'
,p_source=>'wwv_flow_utilities.minimum_free_page(v(''FB_FLOW_ID''),1)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify a new page number.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18357026353120297)
,p_name=>'P301_COPY_TO_PAGE_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(18344031106016009)
,p_prompt=>'New Page Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a new page name.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18557102746777400)
,p_name=>'P301_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(18344031106016009)
,p_prompt=>'Application:'
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'This attribute identifies the current application.'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(200848014690872436)
,p_name=>'P301_CP_FROM_APP'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(18344031106016009)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Copy from Application'
,p_source=>'&FB_FLOW_PAGE_ID.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST FLOWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'where  build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'order by 2'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_attribute_01=>'SUBMIT'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(211801924399895365)
,p_name=>'P301_BREADCRUMB_ID'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(18344031106016009)
,p_prompt=>'Breadcrumb'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION.MENUS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name,',
'       id',
'  from wwv_flow_menus',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- do not use breadcrumbs on page -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select whether you want to use a breadcrumb navigation control on the new page, and which breadcrumb navigation control you want to use.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(211822711548289046)
,p_name=>'P301_BREADCRUMB_NAME'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(18344031106016009)
,p_prompt=>'Entry Name'
,p_source=>'P301_COPY_TO_PAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify the name of the breadcrumb entry.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(211836506231353711)
,p_name=>'P301_PARENT_ID'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(18344031106016009)
,p_prompt=>'Parent Entry'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with menu_options as (  ',
'        select short_name, page_id, parent_id, id, option_sequence ',
'          from wwv_flow_menu_options ',
'         where  menu_id = :P301_BREADCRUMB_ID ',
'           and flow_id = :FB_FLOW_ID ',
'           and exists ( ',
'               select 1 from wwv_flow_menus ',
'                where id = :P301_BREADCRUMB_ID and flow_id = :FB_FLOW_ID ',
'           ) ',
'    ) ',
'    select lpad('' '',indent,''.'')||short_name || '' ('' || ',
'        wwv_flow_lang.system_message(''PAGE'') || '' '' || page_id || '')'' short_name, id ',
'    from ( ',
'        select short_name, page_id, id, level indent ',
'        from menu_options ',
'        start with nvl(parent_id,0) = 0 ',
'        connect by prior id = parent_id ',
'        order siblings by short_name, option_sequence ',
'    )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'No parent entry'
,p_lov_cascade_parent_items=>'P301_BREADCRUMB_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'This item shows if a parent entry has been chosen for this breadcrumb entry and which one was selected.'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(211858203517457010)
,p_name=>'P301_COPY_FROM_S'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(18344031106016009)
,p_prompt=>'Copy From Page'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||'':''||wwv_flow_escape.html(name)',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID ',
'and security_group_id = :flow_security_group_id',
'and id = :FB_FLOW_PAGE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||name d, id||'':''||name r',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by id'))
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the page you want to copy.'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'Y'
,p_attribute_06=>'0'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(513679589099698847)
,p_name=>'P301_DISPLAY_COPY_PUB_RPT'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(18344031106016009)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(617278254247216833)
,p_name=>'P301_COPY_PUBLIC_REPORTS'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(18344031106016009)
,p_item_default=>'N'
,p_prompt=>'Copy Public Reports'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'All default reports are copied automatically without specifying whether they are public or private.  Available options include:',
'<p />',
'<ul>',
'<li><strong>On</strong> copy public reports with the page.</li>',
'<li><strong>Off</strong> do not copy public reports with the page.</li>',
'</ul>',
'<p />',
'Public reports are the public shared report settings saved by users from Interactive Report or Interactive Grid.'))
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1249072009558304099)
,p_name=>'P301_NAVIGATION_TYPE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(18344031106016009)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(211864515684488960)
,p_computation_sequence=>10
,p_computation_item=>'P301_COPY_FROM'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'substr(:P301_COPY_FROM_S,1,instr(:P301_COPY_FROM_S,'':'',1)-1)'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1249072374734307388)
,p_computation_sequence=>40
,p_computation_item=>'P301_NAVIGATION_TYPE'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select x.navigation_type',
'  from wwv_flow_themes x,',
'       wwv_flows f',
' where f.id                = :FB_FLOW_ID',
'   and f.security_group_id = :WORKSPACE_ID',
'   and x.flow_id           = f.id',
'   and x.theme_id          = f.theme_id',
' order by 1'))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(18357930508121563)
,p_validation_name=>'P301_COPY_FROM_S Not Null'
,p_validation_sequence=>10
,p_validation=>'P301_COPY_FROM_S'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Copy From Page must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(18345210914016042)
,p_associated_item=>wwv_flow_imp.id(211858203517457010)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 06-JAN-2003 15:16'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(18358100653121570)
,p_validation_name=>'P301_COPY_TO Not Null'
,p_validation_sequence=>20
,p_validation=>'P301_COPY_TO'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Copy To Page must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(18345210914016042)
,p_associated_item=>wwv_flow_imp.id(18354700370037123)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 06-JAN-2003 15:16'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(18358311033121570)
,p_validation_name=>'P301_COPY_TO_PAGE_NAME Not Null'
,p_validation_sequence=>30
,p_validation=>'P301_COPY_TO_PAGE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'New Page Name must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(18345210914016042)
,p_associated_item=>wwv_flow_imp.id(18357026353120297)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 06-JAN-2003 15:16'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(223855230993900068)
,p_validation_name=>'P301_BREADCRUMB_NAME Not Null'
,p_validation_sequence=>40
,p_validation=>'P301_BREADCRUMB_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Breadcrumb entry name must be specified.'
,p_validation_condition=>'P301_BREADCRUMB_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_ZERO'
,p_when_button_pressed=>wwv_flow_imp.id(18345210914016042)
,p_associated_item=>wwv_flow_imp.id(211822711548289046)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(223856421558916287)
,p_validation_name=>'P301_COPY_TO must be numeric'
,p_validation_sequence=>50
,p_validation=>'P301_COPY_TO'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Copy to page must be numeric.'
,p_when_button_pressed=>wwv_flow_imp.id(18345210914016042)
,p_associated_item=>wwv_flow_imp.id(18354700370037123)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(74579310409510853)
,p_validation_name=>'copy to page does not exist'
,p_validation_sequence=>60
,p_validation=>'select 1 from wwv_flow_steps where id = :P301_COPY_TO and flow_id = :fb_flow_id'
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'This page already exists.'
,p_when_button_pressed=>wwv_flow_imp.id(18345210914016042)
,p_associated_item=>wwv_flow_imp.id(18354700370037123)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(614681508581243380)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(18344926854016042)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(614681819848243380)
,p_event_id=>wwv_flow_imp.id(614681508581243380)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(513679326091698845)
,p_name=>'on copy from page change'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P301_COPY_FROM_S'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1904872323054604)
,p_event_id=>wwv_flow_imp.id(513679326091698845)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Set P301_COPY_TO_PAGE_NAME value'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P301_COPY_TO_PAGE_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'getNewPageName($v("P301_COPY_FROM_S"))'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(513679450314698846)
,p_event_id=>wwv_flow_imp.id(513679326091698845)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_display_copy_pub_rpt varchar2(1) := ''N'';',
'begin ',
'    :P301_COPY_FROM := substr( :P301_COPY_FROM_S, 1, instr(:P301_COPY_FROM_S,'':'',1)-1 );',
'    for l_region in (select null',
'                     from wwv_flow_page_plugs',
'                     where flow_id = :FB_FLOW_ID',
'                     and page_id = :P301_COPY_FROM',
'                     and plug_source_type in ( wwv_flow_region_native.c_ir, wwv_flow_region_native.c_ig ) )',
'    loop',
'        l_display_copy_pub_rpt := ''Y'';',
'        exit;',
'    end loop;',
'    :P301_DISPLAY_COPY_PUB_RPT := l_display_copy_pub_rpt;',
'end;'))
,p_attribute_02=>'P301_COPY_FROM_S,P301_COPY_FROM'
,p_attribute_03=>'P301_DISPLAY_COPY_PUB_RPT,P301_COPY_FROM'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(513679759976698849)
,p_name=>'if true show copy public report'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P301_DISPLAY_COPY_PUB_RPT'
,p_condition_element=>'P301_DISPLAY_COPY_PUB_RPT'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(513679806714698850)
,p_event_id=>wwv_flow_imp.id(513679759976698849)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P301_COPY_PUBLIC_REPORTS'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(617309055027937201)
,p_event_id=>wwv_flow_imp.id(513679759976698849)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P301_COPY_PUBLIC_REPORTS'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(881355460813941721)
,p_name=>'Show breadcrumb attributes'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P301_BREADCRUMB_ID'
,p_condition_element=>'P301_BREADCRUMB_ID'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(881355576409941722)
,p_event_id=>wwv_flow_imp.id(881355460813941721)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P301_BREADCRUMB_NAME,P301_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(881355669367941723)
,p_event_id=>wwv_flow_imp.id(881355460813941721)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P301_BREADCRUMB_NAME,P301_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(881355739693941724)
,p_name=>'Set breadcrumb name'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P301_COPY_TO_PAGE_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(881355893819941725)
,p_event_id=>wwv_flow_imp.id(881355739693941724)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P301_BREADCRUMB_NAME'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P301_COPY_TO_PAGE_NAME'
,p_attribute_07=>'P301_COPY_TO_PAGE_NAME'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(19699823582700405)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_collection.collection_exists(p_collection_name => ''COPY_PAGE_WIZARD_1'')',
'then',
'   wwv_flow_collection.delete_collection(p_collection_name => ''COPY_PAGE_WIZARD_1'');',
'end if;',
'if wwv_flow_collection.collection_exists(p_collection_name => ''COPY_PAGE_WIZARD_2'')',
'then',
'   wwv_flow_collection.delete_collection(p_collection_name => ''COPY_PAGE_WIZARD_2'');',
'end if; ',
'if wwv_flow_collection.collection_exists(p_collection_name => ''COPY_PAGE_WIZARD_3'')',
'then',
'   wwv_flow_collection.delete_collection(p_collection_name => ''COPY_PAGE_WIZARD_3'');',
'end if; ',
'if wwv_flow_collection.collection_exists(p_collection_name => ''COPY_PAGE_WIZARD_4'')',
'then',
'   wwv_flow_collection.delete_collection(p_collection_name => ''COPY_PAGE_WIZARD_4'');',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error deleting copy page wizard collections.'
,p_process_when_button_id=>wwv_flow_imp.id(18345210914016042)
,p_internal_uid=>19699823582700405
);
end;
/
prompt --application/pages/page_00302
begin
wwv_flow_imp_page.create_page(
 p_id=>302
,p_name=>'Copy Page - New Names'
,p_alias=>'COPY-PAGE-NEW-NAMES'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Page'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_copy_pg.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(18346717108016066)
,p_name=>'Copy Page'
,p_template=>wwv_flow_imp.id(42025417508627628)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q varchar2(32767) := null;',
'begin',
'if wwv_flow_collection.collection_exists(p_collection_name => ''COPY_PAGE_WIZARD_1'')',
'   OR wwv_flow_collection.collection_exists(p_collection_name => ''COPY_PAGE_WIZARD_2'')',
'   OR wwv_flow_collection.collection_exists(p_collection_name => ''COPY_PAGE_WIZARD_3'')',
'   OR wwv_flow_collection.collection_exists(p_collection_name => ''COPY_PAGE_WIZARD_4'')',
'then',
'  q:=''select wwv_flow_lang.system_message(''''F4000.REGION'''') c, ''; ',
'  q:=q||''wwv_flow_item.display_and_save(9,c003) o, ''; ',
'  q:=q||''wwv_flow_item.display_and_save(13,c004) s, ''; ',
'  q:=q||''wwv_flow_item.text(1,c001,35,255,''''title="''||wwv_flow_lang.system_message(''WS_NEW_VALUE'')||''"'''')||wwv_flow_item.hidden(5,c002) n, '';',
'  q:=q||''wwv_flow_item.text(14,c005,25,255,''''title="''||wwv_flow_lang.system_message(''COPY.PAGE.NEW_STATIC_ID'')||''"'''')||wwv_flow_item.hidden(15,c006) t '';',
'  q:=q||''from wwv_flow_collections '';',
'  q:=q||''where collection_name = ''''COPY_PAGE_WIZARD_1'''' '';  ',
'  q:=q||''union all '';',
'  q:=q||''select wwv_flow_lang.system_message(''''LAYOUT.T_ITEM2'''') c, ''; ',
'  q:=q||''wwv_flow_item.display_and_save(10,c003) o, ''; ',
'  q:=q||'' '''''''' s, '';',
'  q:=q||''wwv_flow_item.text(2,c001,35,255,''''title="''||wwv_flow_lang.system_message(''WS_NEW_VALUE'')||''"'''')||wwv_flow_item.hidden(6,c002) n, ''; ',
'  q:=q||'' '''''''' t '';',
'  q:=q||''from wwv_flow_collections '';',
'  q:=q||''where collection_name = ''''COPY_PAGE_WIZARD_2'''' '';',
'  q:=q||''union all '';',
'  q:=q||''select wwv_flow_lang.system_message(''''F4000.BUTTON'''') c, ''; ',
'  q:=q||''wwv_flow_item.display_and_save(11,c003) o, ''; ',
'  q:=q||'' '''''''' s, '';',
'  q:=q||''wwv_flow_item.text(3,c001,35,255,''''title="''||wwv_flow_lang.system_message(''WS_NEW_VALUE'')||''"'''')||wwv_flow_item.hidden(7,c002) n, ''; ',
'  q:=q||'' '''''''' t '';',
'  q:=q||''from wwv_flow_collections '';',
'  q:=q||''where collection_name = ''''COPY_PAGE_WIZARD_3'''' '';',
'  q:=q||''union all '';',
'  q:=q||''select wwv_flow_lang.system_message(''''LAYOUT.T_BRANCHING'''') c,  '';',
'  q:=q||''wwv_flow_item.display_and_save(12,c003) o, '';',
'  q:=q||'' '''''''' s, '';',
'  q:=q||''wwv_flow_item.textarea(4,c001,3,25,''''title="''||wwv_flow_lang.system_message(''WS_NEW_VALUE'')||''"'''')||wwv_flow_item.hidden(8,c002) n, ''; ',
'  q:=q||'' '''''''' t '';',
'  q:=q||''from wwv_flow_collections '';',
'  q:=q||''where collection_name = ''''COPY_PAGE_WIZARD_4'''' '';',
'  q:=q||''order by 1,2 '';    ',
'else   ',
'  q:=''select wwv_flow_lang.system_message(''''F4000.REGION'''') c, ''; ',
'  q:=q||''wwv_flow_item.display_and_save(9,plug_name) o, ''; ',
'  q:=q||''wwv_flow_item.display_and_save(13,region_name) s, ''; ',
'  q:=q||''wwv_flow_item.text(1,wwv_flow_copy_page.change_item_name('';',
'  q:=q||''  to_number(:FB_FLOW_ID), '';',
'  q:=q||''  to_number(:p301_copy_from), '';',
'  q:=q||''  to_number(:FB_FLOW_ID), '';    ',
'  q:=q||''  to_number(:p301_copy_to), '';',
'  q:=q||''  plug_name),35,255,''''title="''||wwv_flow_lang.system_message(''WS_NEW_VALUE'')||''"'''')||wwv_flow_item.hidden(5,id) n, '';',
'  q:=q||''wwv_flow_item.text(14,wwv_flow_copy_page.change_item_name('';',
'  q:=q||''  to_number(:FB_FLOW_ID), '';',
'  q:=q||''  to_number(:p301_copy_from), '';',
'  q:=q||''  to_number(:FB_FLOW_ID), '';    ',
'  q:=q||''  to_number(:p301_copy_to), '';',
'  q:=q||''  region_name),25,255,''''title="''||wwv_flow_lang.system_message(''COPY.PAGE.NEW_STATIC_ID'')||''"'''')||wwv_flow_item.hidden(15,id) t '';',
'  q:=q||''from WWV_FLOW_PAGE_PLUGS '';',
'  q:=q||''where flow_id = :fb_flow_id '';',
'  q:=q||''and page_id = :p301_copy_from '';',
'  q:=q||''union all '';',
'  q:=q||''select wwv_flow_lang.system_message(''''LAYOUT.T_ITEM2'''') c, ''; ',
'  q:=q||''wwv_flow_item.display_and_save(10,prompt) o, ''; ',
'  q:=q||'' '''''''' s, '';',
'  q:=q||''wwv_flow_item.text(2,wwv_flow_copy_page.change_item_name('';',
'  q:=q||''  to_number(:FB_FLOW_ID), '';',
'  q:=q||''  to_number(:p301_copy_from), '';',
'  q:=q||''  to_number(:FB_FLOW_ID), '';    ',
'  q:=q||''  to_number(:p301_copy_to), '';',
'  q:=q||''  prompt),35,255,''''title="''||wwv_flow_lang.system_message(''WS_NEW_VALUE'')||''"'''')||wwv_flow_item.hidden(6,id) n, ''; ',
'  q:=q||'' '''''''' t '';',
'  q:=q||''from WWV_FLOW_STEP_ITEMS '';',
'  q:=q||''where flow_id = :fb_flow_id '';',
'  q:=q||''and flow_step_id = :p301_copy_from '';',
'  q:=q||''and prompt is not null '';',
'  q:=q||''union all '';',
'  q:=q||''select wwv_flow_lang.system_message(''''F4000.BUTTON'''') c, ''; ',
'  q:=q||''wwv_flow_item.display_and_save(11,button_image_alt) o, ''; ',
'  q:=q||'' '''''''' s, '';',
'  q:=q||''wwv_flow_item.text(3,wwv_flow_copy_page.change_item_name('';',
'  q:=q||''  to_number(:FB_FLOW_ID), '';',
'  q:=q||''  to_number(:p301_copy_from), '';',
'  q:=q||''  to_number(:FB_FLOW_ID), '';    ',
'  q:=q||''  to_number(:p301_copy_to), '';',
'  q:=q||''  button_image_alt),35,255,''''title="''||wwv_flow_lang.system_message(''WS_NEW_VALUE'')||''"'''')||wwv_flow_item.hidden(7,id) n, ''; ',
'  q:=q||'' '''''''' t '';',
'  q:=q||''from WWV_FLOW_STEP_BUTTONS '';',
'  q:=q||''where flow_id = :fb_flow_id '';',
'  q:=q||''and flow_step_id = :p301_copy_from '';',
'  q:=q||''union all '';',
'  q:=q||''select wwv_flow_lang.system_message(''''LAYOUT.T_BRANCHING'''') c,  '';',
'  q:=q||''wwv_flow_item.display_and_save(12,branch_action) o, '';',
'  q:=q||'' '''''''' s, '';',
'  q:=q||''wwv_flow_item.textarea(4,wwv_flow_copy_page.change_page_id_in_branch('';',
'  q:=q||''  :p301_copy_from, '';',
'  q:=q||''  :p301_copy_to, '';',
'  q:=q||''wwv_flow_copy_page.change_item_name('';',
'  q:=q||''  to_number(:FB_FLOW_ID), '';',
'  q:=q||''  to_number(:p301_copy_from), '';',
'  q:=q||''  to_number(:FB_FLOW_ID), '';    ',
'  q:=q||''  to_number(:p301_copy_to), '';',
'  q:=q||''  branch_action)),3,25,''''title="''||wwv_flow_lang.system_message(''WS_NEW_VALUE'')||''"'''')||wwv_flow_item.hidden(8,id) n, ''; ',
'  q:=q||'' '''''''' t '';',
'  q:=q||''from WWV_FLOW_STEP_BRANCHES '';',
'  q:=q||''where flow_id = :fb_flow_id '';',
'  q:=q||''and flow_step_id = :p301_copy_from '';',
'  q:=q||''order by 1,2 '';',
'end if;  ',
'',
'return q;',
'end;'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_plug_query_max_columns=>8
,p_query_num_rows=>1500
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_query_break_cols=>'1'
,p_query_no_data_found=>'No new values needed.  The selected page has no regions, items, buttons, or branches.'
,p_query_row_count_max=>5000
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'Y'
,p_comment=>'Region generated 06-JAN-2003 14:58:56'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48795507458772263)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_column_heading=>'Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48795628485772263)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>2
,p_column_heading=>'Old Value'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<div style="width:200px;overflow:hidden;" title="#COL02#">#COL02#</div>'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48795730147772263)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>3
,p_column_heading=>'Static ID'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48795801255772263)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>4
,p_column_heading=>'New Value'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48795932190772263)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>5
,p_column_heading=>'New Static ID'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48796016406772263)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>6
,p_column_heading=>'COL06'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48796118466772263)
,p_query_column_id=>7
,p_column_alias=>'COL07'
,p_column_display_sequence=>7
,p_column_heading=>'COL07'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48796219310772263)
,p_query_column_id=>8
,p_column_alias=>'COL08'
,p_column_display_sequence=>8
,p_column_heading=>'COL08'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(18570225958859834)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(18564606387816293)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46184808850855937)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(18347605105016068)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46184808850855937)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(18347920038016069)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(46184808850855937)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(18347802037016069)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(46184808850855937)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(341751132064790577)
,p_branch_name=>'Close dialog'
,p_branch_action=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(18347920038016069)
,p_branch_sequence=>30
,p_branch_comment=>'Generated 06-JAN-2003 14:58:57'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(18348821540016070)
,p_branch_name=>'Go To Page 305'
,p_branch_action=>'f?p=&APP_ID.:305:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(18347802037016069)
,p_branch_sequence=>20
,p_branch_comment=>'Generated 06-JAN-2003 14:58:57'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(614680338054240706)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(18347605105016068)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(614680691887240706)
,p_event_id=>wwv_flow_imp.id(614680338054240706)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(19686629797550838)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow.g_f01.count > 0 then',
'   wwv_flow_collection.create_or_truncate_collection(',
'      p_collection_name => ''COPY_PAGE_WIZARD_1'');',
'end if;',
'if wwv_flow.g_f02.count > 0 then',
'   wwv_flow_collection.create_or_truncate_collection(',
'      p_collection_name => ''COPY_PAGE_WIZARD_2'');',
'end if;',
'if wwv_flow.g_f03.count > 0 then',
'   wwv_flow_collection.create_or_truncate_collection(',
'      p_collection_name => ''COPY_PAGE_WIZARD_3'');',
'end if;',
'if wwv_flow.g_f04.count > 0 then',
'   wwv_flow_collection.create_or_truncate_collection(',
'      p_collection_name => ''COPY_PAGE_WIZARD_4'');',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error creating copy page wizard collections.'
,p_process_when_button_id=>wwv_flow_imp.id(18347920038016069)
,p_internal_uid=>19686629797550838
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(19676120559406180)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'and add member'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_collection.collection_exists(p_collection_name => ''COPY_PAGE_WIZARD_1'') then',
'   wwv_flow_collection.add_members (',
'      p_collection_name => ''COPY_PAGE_WIZARD_1'',',
'      p_c001            => wwv_flow.g_f01,',
'      p_c002            => wwv_flow.g_f05,',
'      p_c003            => wwv_flow.g_f09,',
'      p_c004            => wwv_flow.g_f13,',
'      p_c005            => wwv_flow.g_f14,',
'      p_c006            => wwv_flow.g_f15);',
'end if;',
'if wwv_flow_collection.collection_exists(p_collection_name => ''COPY_PAGE_WIZARD_2'') then',
'   wwv_flow_collection.add_members (',
'      p_collection_name => ''COPY_PAGE_WIZARD_2'',',
'      p_c001            => wwv_flow.g_f02,',
'      p_c002            => wwv_flow.g_f06,',
'      p_c003            => wwv_flow.g_f10);',
'end if;',
'if wwv_flow_collection.collection_exists(p_collection_name => ''COPY_PAGE_WIZARD_3'') then',
'   wwv_flow_collection.add_members (',
'      p_collection_name => ''COPY_PAGE_WIZARD_3'',',
'      p_c001            => wwv_flow.g_f03,',
'      p_c002            => wwv_flow.g_f07,',
'      p_c003            => wwv_flow.g_f11);',
'end if;',
'if wwv_flow_collection.collection_exists(p_collection_name => ''COPY_PAGE_WIZARD_4'') then',
'   wwv_flow_collection.add_members (',
'      p_collection_name => ''COPY_PAGE_WIZARD_4'',',
'      p_c001            => wwv_flow.g_f04,',
'      p_c002            => wwv_flow.g_f08,',
'      p_c003            => wwv_flow.g_f12);',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error adding copy page wizard collection members.'
,p_process_when_button_id=>wwv_flow_imp.id(18347920038016069)
,p_internal_uid=>19676120559406180
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(881356176600941728)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'copy page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_new_region_title     wwv_flow_global.vc_arr2;',
'   l_new_item_label       wwv_flow_global.vc_arr2;',
'   l_new_button_label     wwv_flow_global.vc_arr2;',
'   l_new_branch_value     wwv_flow_global.vc_arr2;',
'   l_new_region_name      wwv_flow_global.vc_arr2;',
'begin',
'select c002||'',''||replace(c001,'','',''___'')',
'BULK COLLECT INTO',
'l_new_region_title',
'from wwv_flow_collections',
'where collection_name = ''COPY_PAGE_WIZARD_1'';',
'',
'select c006||'',''||replace(c005,'','',''___'')',
'BULK COLLECT INTO',
'l_new_region_name',
'from wwv_flow_collections',
'where collection_name = ''COPY_PAGE_WIZARD_1'';',
'',
'select c002||'',''||c001',
'BULK COLLECT INTO',
'l_new_item_label',
'from wwv_flow_collections',
'where collection_name = ''COPY_PAGE_WIZARD_2'';',
'',
'select c002||'',''||c001',
'BULK COLLECT INTO',
'l_new_button_label',
'from wwv_flow_collections',
'where collection_name = ''COPY_PAGE_WIZARD_3'';',
'',
'select c002||'',''||c001',
'BULK COLLECT INTO',
'l_new_branch_value',
'from wwv_flow_collections',
'where collection_name = ''COPY_PAGE_WIZARD_4'';',
'',
'for i in 1..l_new_branch_value.count loop',
'wwv_flow.debug (''copy page new branch value ''||i||'' = "''||wwv_flow_escape.html(l_new_branch_value(i))||''"'');',
'end loop;',
'',
'',
'wwv_flow_copy_page.copy ( ',
'    p_flow_id_from             => :FB_FLOW_ID,   ',
'    p_page_id_from             => :P301_COPY_FROM,',
'    p_flow_id_to               => :FB_FLOW_ID,    ',
'    p_page_id_to               => :P301_COPY_TO,',
'    p_page_name_to             => :P301_COPY_TO_PAGE_NAME,',
'    --       ',
'    p_breadcrumb_id            => :P301_BREADCRUMB_ID,',
'    p_breadcrumb_name          => :P301_BREADCRUMB_NAME,',
'    p_parent_id                => :P301_PARENT_ID,    ',
'    --',
'    p_new_region_title         => l_new_region_title,',
'    p_new_item_label           => l_new_item_label,',
'    p_new_button_label         => l_new_button_label,',
'    p_new_branch_value         => l_new_branch_value,',
'    p_new_region_name          => l_new_region_name,',
'    --',
'    p_tab_set                  => :P305_TAB_SET,',
'    p_tab_name                 => :P305_TAB_NAME,',
'    p_tab_label                => :P305_TAB_LABEL,',
'    --',
'    p_nav_list_id              => :P305_NAVLIST_ID,',
'    p_nav_list_parent_item_id  => :P305_NAVLIST_PARENT_ID,',
'    p_nav_list_child_item_name => :P305_NAVLIST_ENTRY_NAME,',
'    --',
'    p_copy_public_report       => ( :P301_COPY_PUBLIC_REPORTS = ''Y'' )',
'    );',
'',
'wwv_flow.update_cache_with_write(''FB_FLOW_PAGE_ID'',:P301_COPY_TO);',
'end;',
':F4000_RUN_EDIT_PAGE := :P301_COPY_TO;',
':FB_FLOW_PAGE_ID     := :P301_COPY_TO;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>881356176600941728
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(881356220282941729)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_collection.collection_exists(p_collection_name => ''COPY_PAGE_WIZARD_1'')',
'then',
'   wwv_flow_collection.delete_collection(p_collection_name => ''COPY_PAGE_WIZARD_1'');',
'end if;',
'if wwv_flow_collection.collection_exists(p_collection_name => ''COPY_PAGE_WIZARD_2'')',
'then',
'   wwv_flow_collection.delete_collection(p_collection_name => ''COPY_PAGE_WIZARD_2'');',
'end if; ',
'if wwv_flow_collection.collection_exists(p_collection_name => ''COPY_PAGE_WIZARD_3'')',
'then',
'   wwv_flow_collection.delete_collection(p_collection_name => ''COPY_PAGE_WIZARD_3'');',
'end if; ',
'if wwv_flow_collection.collection_exists(p_collection_name => ''COPY_PAGE_WIZARD_4'')',
'then',
'   wwv_flow_collection.delete_collection(p_collection_name => ''COPY_PAGE_WIZARD_4'');',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>881356220282941729
);
end;
/
prompt --application/pages/page_00303
begin
wwv_flow_imp_page.create_page(
 p_id=>303
,p_name=>'Create Summary Page - Confirm'
,p_alias=>'CREATE-SUMMARY-PAGE-CONFIRM'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Summary Page'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(214168830839927421)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_frm.htm'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7548209184810307)
,p_plug_name=>'Summary Page Confirmation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wiz_confirm.create_summary_page (',
'    p_flow_id         => :FB_FLOW_ID,',
'    p_page_id         => :F4000_P5100_PAGE_ID,',
'    p_page_name       => :F4000_P5100_PAGE_NAME,',
'    p_region_name     => :F4000_P5105_REGION_NAME,',
'    p_region_template => replace(:F4000_P5105_REGION_TEMPLATE,''%''||''null%''));'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_num_rows=>5000
,p_plug_query_num_rows_type=>'0'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'L:C:C:C:C:C'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7549532387817023)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(8771208191950732)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(204707517366848377)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7550723645833370)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(204707517366848377)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7562700976940434)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(204707517366848377)
,p_button_name=>'Addmore'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Add More'
,p_button_position=>'CREATE'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7551218694833371)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(204707517366848377)
,p_button_name=>'Finish'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7550929028833371)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(204707517366848377)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(7563027647940435)
,p_branch_action=>'5100'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(7562700976940434)
,p_branch_sequence=>42
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(7553101528855404)
,p_branch_action=>'5110'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(7550929028833371)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(403517925360698708)
,p_validation_name=>'Validate Group Name'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_utilities.is_valid_page_group_name (',
'  p_name => :P5100_GROUP_NAME);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P5100_GROUP_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(7551218694833371)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(549716182004753322)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(7550723645833370)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(549716286737753323)
,p_event_id=>wwv_flow_imp.id(549716182004753322)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2410124385917354)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'CREATE_SUMMARY'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  wwv_flow_wizard_api.create_summary_page(',
'      p_flow_id                  => :FB_FLOW_ID,',
'      p_page_id                  => :F4000_P5100_PAGE_ID,',
'      p_page_name                => :F4000_P5100_PAGE_NAME,',
'      p_group_name               => :P5100_GROUP_NAME,',
'      p_page_mode                => :P5100_PAGE_MODE,',
'      --',
'      p_tab_set                  => :P4716_TAB_SET,',
'      p_tab_name                 => :P4716_TAB_NAME,',
'      p_tab_text                 => :P4716_TAB_LABEL,',
'      --',
'      p_nav_list_id              => :P4716_NAVLIST_ID,',
'      p_nav_list_parent_item_id  => :P4716_NAVLIST_PARENT_ID,',
'      p_nav_list_child_item_name => :P4716_NAVLIST_ENTRY_NAME,',
'      --',
'      p_region_id                => replace(:F4000_P5105_REGION_ID,''%null%'',null),',
'      p_region_title             => :F4000_P5105_REGION_NAME,',
'      p_region_template          => replace(:F4000_P5105_REGION_TEMPLATE,''%null%'',null),',
'      p_field_template           => replace(:F4000_P5105_FIELD_TEMPLATE,''%null%'',null),',
'      p_label_align              => replace(:F4000_P5105_LABEL_ALIGNMENT,''%null%'',null),',
'      p_tag_attr                 => :F4000_P5105_TAG_ATTRIBUTES,',
'      p_field_align              => replace(:F4000_P5105_FIELD_ALIGNMENT,''%null%'',null)',
'  );',
'  ',
'  :fb_flow_page_id     := :F4000_P5100_PAGE_ID;',
'  :F4000_RUN_EDIT_PAGE := :F4000_P5100_PAGE_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2410124385917354
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(122284011368617191)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create breadcrumbs'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_wizard_api.create_breadcrumb_region (',
'        p_application_id             => :FB_FLOW_ID,',
'        p_page_id                    => :F4000_P5100_PAGE_ID,',
'        p_seq                        => 10,',
'        p_breadcrumb_id              => :P5100_BREADCRUMB_ID,',
'        p_breadcrumb_entry_name      => nvl(:P5100_BREADCRUMB_NAME, :F4000_P5100_PAGE_NAME),',
'        p_parent_breadcrumb_entry_id => :P5100_BREADCRUMB_PARENT_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>122284011368617191
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(549716329236753324)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(7551218694833371)
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>549716329236753324
);
end;
/
prompt --application/pages/page_00305
begin
wwv_flow_imp_page.create_page(
 p_id=>305
,p_name=>'Copy Page - Navigation Menu'
,p_alias=>'COPY-PAGE-NAVIGATION-MENU'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Page'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_copy_pg.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(18570801155862085)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(18564606387816293)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46202708251262627)
,p_plug_name=>'wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1248952503448115942)
,p_plug_name=>'Copy Page'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>50
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P301_NAVIGATION_TYPE'
,p_plug_display_when_cond2=>'L'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(1248955233972115955)
,p_name=>'Tabs'
,p_parent_plug_id=>wwv_flow_imp.id(1248952503448115942)
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<a title="click to set tab set" href="javascript:$x_Value(''''P305_TAB_SET'''',''''''||',
'       wwv_flow_javascript.escape(tab_set)||',
'       '''''');">''||',
'       wwv_flow_escape.html(tab_set)||',
'       ''</a>'' tab_set, ',
'       tab_step, ',
'       substr(tab_text,1,30) tab_text,',
'       replace(TAB_ALSO_CURRENT_FOR_PAGES,'','','', '') tacfp',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID and ',
'       security_group_id = :flow_security_group_id',
'order  by tab_set, TAB_SEQUENCE, tab_step'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>'No tabs or tab sets exist.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1248955498423115962)
,p_query_column_id=>1
,p_column_alias=>'TAB_SET'
,p_column_display_sequence=>1
,p_column_heading=>'Tab Set'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1248955518207115967)
,p_query_column_id=>2
,p_column_alias=>'TAB_STEP'
,p_column_display_sequence=>2
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1248955681517115967)
,p_query_column_id=>3
,p_column_alias=>'TAB_TEXT'
,p_column_display_sequence=>3
,p_column_heading=>'Tab'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1248955724972115967)
,p_query_column_id=>4
,p_column_alias=>'TACFP'
,p_column_display_sequence=>4
,p_column_heading=>'Also&nbsp;Current&nbsp;For'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1248955872528117612)
,p_plug_name=>'List Based Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_translate_title=>'N'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P301_NAVIGATION_TYPE'
,p_plug_display_when_cond2=>'L'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(18351011391016077)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46202708251262627)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(18351119390016077)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(46202708251262627)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(18351200192016077)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(46202708251262627)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(18352716941016092)
,p_branch_name=>'Go To Page 302'
,p_branch_action=>'f?p=&APP_ID.:302:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(18351119390016077)
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'Generated 06-JAN-2003 14:58:57'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(18352209365016091)
,p_branch_name=>'Go To Page 301'
,p_branch_action=>'f?p=&APP_ID.:301:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(18351200192016077)
,p_branch_sequence=>30
,p_branch_comment=>'Generated 06-JAN-2003 14:58:57'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1248953267717115951)
,p_name=>'P305_TAB_OPTIONS'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1248952503448115942)
,p_item_default=>'0'
,p_prompt=>'Tab Options:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.TAB.OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(35310611267199336)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Specify whether this page should have tabs and click <strong>Next</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1248953752909115952)
,p_name=>'P305_TAB_SET'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(1248952503448115942)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   t varchar2(4000);',
'begin',
'   for c1 in (',
'select tab_set, count(*) c',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID and ',
'       security_group_id = :flow_security_group_id',
'group  by tab_set',
'order by 2 desc) loop',
'return c1.tab_set;',
'exit;',
'end loop;',
'return null;',
'end;',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Tab Set'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_TABSETS'
,p_lov=>'select wwv_flow_escape.html(d) d, r from wwv_flow_tabset_view'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Tab Set -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Select the tab set you wish to use for this page.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1248954208190115954)
,p_name=>'P305_TAB_LABEL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(1248952503448115942)
,p_prompt=>'New Tab Label'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the label for the tab that will be created. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1248954743504115954)
,p_name=>'P305_TAB_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(1248952503448115942)
,p_prompt=>'Use Tab'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(TAB_NAME)||'': label="''||wwv_flow_escape.html(substr(TAB_TEXT,1,40))||''"'' tab_text,tab_name',
'from   wwv_flow_tabs',
'where  flow_id = :fb_flow_id and',
'       security_group_id = :flow_security_group_id and',
'       tab_set = :P305_TAB_SET'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Tab -'
,p_lov_cascade_parent_items=>'P305_TAB_SET'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Select the tab to be designated as "current" for this page.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1248956227336117617)
,p_name=>'P305_NAVLIST_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1248955872528117612)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1248956469784117618)
,p_name=>'P305_NEW_PARENT_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(1248955872528117612)
,p_prompt=>'Parent Navigation Menu Entry'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    case ',
'        when (nvl(list_item_link_target,''0'')=''0'' or parent_list_item_id is null)  then ',
'            lpad('' '',(4*(level-1)),''.'')||list_item_link_text',
'        else ',
'            lpad('' '',(4*(level-1)),''.'')||'' (''||list_item_link_text ||'')'' ',
'    end name,',
'    id',
'  from wwv_flow_list_items',
' start with parent_list_item_id is null',
'        and flow_id = :FB_FLOW_ID',
'        and list_id = :P305_NAVLIST_ID',
' connect by prior id = parent_list_item_id',
'        and prior list_id = list_id',
' order siblings by list_item_display_sequence',
'',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No parent selected - '
,p_cHeight=>7
,p_tag_css_classes=>'a-Form-select--multi'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select an existing menu control if you wish to add a menu entry for the new page to this menu control. ',
'When not selecting an existing menu control, a menu control for the new page will be created at the to level.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1248956971025117619)
,p_name=>'P305_NAVLIST_ENTRY_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1248955872528117612)
,p_prompt=>'New Navigation Menu Entry'
,p_source=>'P301_COPY_TO_PAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Enter a name for the new menu entry.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1248957636293117620)
,p_name=>'P305_NAVLIST_OPTIONS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1248955872528117612)
,p_item_default=>'NONE'
,p_prompt=>'Navigation Preference'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.NAVIGATIONLIST.OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(925221062390507339)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select how you want this page integrated into the Navigation Menu.<p/>',
'<ul>',
'    <li><strong>Do not associate this page with a Navigation Menu entry</strong> - The new page will not be current or highlighted for any menu entry.</li>',
'    <li><strong>Create a new Navigation Menu entry</strong> - Users will be able to navigate to the new page directly from the Navigation Menu. The new entry can be placed anywhere in the existing hierarchy.</li>',
'    <li><strong>Identify an existing Navigation Menu entry which will be current for this page</strong> - Use this option when you want the new page to highlight an existing, top level, menu entry. Users will not be able to navigate to the new page d'
||'irectly from the Navigation Menu. Therefore, You will need to create or define a navigation control on the top level page selected, such as a button, or link in a report, to go to this new page.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1554797717055340137)
,p_name=>'P305_EXISTING_PARENT_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(1248955872528117612)
,p_prompt=>'Existing Navigation Menu Entry'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    list_item_link_text name,',
'    id',
'from wwv_flow_list_items',
'where flow_id = :FB_FLOW_ID',
'and list_id = :P305_NAVLIST_ID',
'and parent_list_item_id is null',
'order by list_item_display_sequence',
'',
''))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Select an existing menu control to be shown as the active menu control when rendering the new page. ',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1554826395322464093)
,p_name=>'P305_NAVLIST_PARENT_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(1248955872528117612)
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select a navigation parent for your new page. When creating a new navigation item, the new item links to',
'the new page. The new item can be added at the top level, by not selecting any parent item, or shown as a child',
'of an existing item. </p>',
'',
'<p>When selecting item without creating a new item, the selected item determines which top level item is shown',
'as the "current" item.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1248980515223124847)
,p_computation_sequence=>50
,p_computation_item=>'P305_TAB_SET'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P305_TAB_OPTIONS'
,p_compute_when_text=>'0'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1248981221471127828)
,p_computation_sequence=>50
,p_computation_item=>'P305_TAB_NAME'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P305_TAB_OPTIONS'
,p_compute_when_text=>'1'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1248981931818137167)
,p_computation_sequence=>50
,p_computation_item=>'P305_TAB_LABEL'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P305_TAB_OPTIONS'
,p_compute_when_text=>'2:0'
,p_compute_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1248982214944138643)
,p_computation_sequence=>50
,p_computation_item=>'P305_NAVLIST_ENTRY_NAME'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P305_NAVLIST_OPTIONS'
,p_compute_when_text=>'NEW'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1554875940296583200)
,p_computation_sequence=>70
,p_computation_item=>'P305_NAVLIST_PARENT_ID'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P305_NEW_PARENT_ID'
,p_compute_when=>'P305_NAVLIST_OPTIONS'
,p_compute_when_text=>'NEW'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1554876177693584945)
,p_computation_sequence=>70
,p_computation_item=>'P305_NAVLIST_PARENT_ID'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P305_EXISTING_PARENT_ID'
,p_compute_when=>'P305_NAVLIST_OPTIONS'
,p_compute_when_text=>'EXISTING'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1264003127515339681)
,p_computation_sequence=>50
,p_computation_item=>'P305_NAVLIST_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select navigation_list_id',
'  from wwv_flows       ',
' where id = :FB_FLOW_ID'))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1248982514907143568)
,p_validation_name=>'tab set not null'
,p_validation_sequence=>50
,p_validation=>'P305_TAB_SET'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'P305_TAB_OPTIONS'
,p_validation_condition2=>'1:2'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_when_button_pressed=>wwv_flow_imp.id(18351119390016077)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1248982712083144731)
,p_validation_name=>'tab label not null'
,p_validation_sequence=>60
,p_validation=>'P305_TAB_LABEL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'P305_TAB_OPTIONS'
,p_validation_condition2=>'1'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(18351119390016077)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1248982936115145752)
,p_validation_name=>'tab name not null'
,p_validation_sequence=>70
,p_validation=>'P305_TAB_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'P305_TAB_OPTIONS'
,p_validation_condition2=>'2'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(18351119390016077)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1554885121522637677)
,p_validation_name=>'New Entry with no List'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''x''',
'from wwv_flow_list_items',
'where flow_id = :FB_FLOW_ID',
'and list_id = :P305_NAVLIST_ID',
'and parent_list_item_id is null',
'and rownum = 1'))
,p_validation_type=>'EXISTS'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'You must associate a navigation menu list to use this preference. Go to Shared Components, User Interface Attributes, select the appropriate User Interface, then select a Navigation Menu List.<br>',
'Alternatively, do not associate this page with a navigation menu entry.'))
,p_validation_condition=>'P305_NAVLIST_OPTIONS'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1248983562578147778)
,p_validation_name=>'P305_NAVLIST_ENTRY_NAME'
,p_validation_sequence=>90
,p_validation=>'P305_NAVLIST_ENTRY_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Entry name is required for new navigation items'
,p_validation_condition=>':P301_NAVIGATION_TYPE=''L'' and :P305_NAVLIST_OPTIONS=''NEW'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(18351119390016077)
,p_associated_item=>wwv_flow_imp.id(1248956971025117619)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1554887790954707970)
,p_validation_name=>'Existing Entry with no List'
,p_validation_sequence=>100
,p_validation=>'P305_EXISTING_PARENT_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'You must associate a navigation menu list to use this preference. Go to Shared Components, User Interface Attributes, select the appropriate User Interface, then select a Navigation Menu List.<br>',
'Alternatively, do not associate this page with a navigation menu entry.'))
,p_validation_condition=>'P305_NAVLIST_OPTIONS'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2947489650730700)
,p_validation_name=>'Navigation Menu not subscribed'
,p_validation_sequence=>110
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * ',
'  from wwv_flow_lists',
' where id                = :P305_NAVLIST_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and reference_id      is not null'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'&APP_TEXT$NAVIGATION_MENU_SUBSCRIBED!RAW.'
,p_validation_condition=>':P305_NAVLIST_OPTIONS in ( ''NEW'', ''EXISTING'' ) and :P305_NAVLIST_ID is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(1248957636293117620)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(614679604196237457)
,p_name=>'Cancel Dialog'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(18351011391016077)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(614679929284237457)
,p_event_id=>wwv_flow_imp.id(614679604196237457)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1249119521131791584)
,p_name=>'Tab Option 0 Settings'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P305_TAB_OPTIONS'
,p_condition_element=>'P305_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'0'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1249119859129791589)
,p_event_id=>wwv_flow_imp.id(1249119521131791584)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P305_TAB_SET,P305_TAB_LABEL,P305_TAB_NAME'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1249119989033793366)
,p_name=>'Tab Option 1 Settings'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P305_TAB_OPTIONS'
,p_condition_element=>'P305_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'1'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1249120258878793366)
,p_event_id=>wwv_flow_imp.id(1249119989033793366)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P305_TAB_SET,P305_TAB_LABEL'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1249120497798793367)
,p_event_id=>wwv_flow_imp.id(1249119989033793366)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P305_TAB_NAME'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1249120553266795028)
,p_name=>'Tab Option 2 Settings'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P305_TAB_OPTIONS'
,p_condition_element=>'P305_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'2'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1249120813596795028)
,p_event_id=>wwv_flow_imp.id(1249120553266795028)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P305_TAB_SET,P305_TAB_NAME'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1249121025618795028)
,p_event_id=>wwv_flow_imp.id(1249120553266795028)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P305_TAB_LABEL'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1249121172260796733)
,p_name=>'New Navlist Entry Name'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P305_NAVLIST_OPTIONS'
,p_condition_element=>'P305_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1249121601056796733)
,p_event_id=>wwv_flow_imp.id(1249121172260796733)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P305_NAVLIST_ENTRY_NAME,P305_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1249121430231796733)
,p_event_id=>wwv_flow_imp.id(1249121172260796733)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P305_NAVLIST_ENTRY_NAME,P305_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1554798154785352765)
,p_name=>'Existing NavList Entry'
,p_event_sequence=>95
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P305_NAVLIST_OPTIONS'
,p_condition_element=>'P305_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'EXISTING'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1554798427087352781)
,p_event_id=>wwv_flow_imp.id(1554798154785352765)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P305_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1554798665433352786)
,p_event_id=>wwv_flow_imp.id(1554798154785352765)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P305_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1249122312230800129)
,p_name=>'Update Tree'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P305_NAVLIST_OPTIONS'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1249122690443800130)
,p_event_id=>wwv_flow_imp.id(1249122312230800129)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'$("#P305_NAVLIST_PARENT_ID option:contains('' ('')").attr("disabled","disabled");'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1249121759611798356)
,p_name=>'Show Navigation Tree'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P305_NAVLIST_OPTIONS'
,p_condition_element=>'P305_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NONE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1249122080259798356)
,p_event_id=>wwv_flow_imp.id(1249121759611798356)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P305_NAVLIST_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1249122216414798356)
,p_event_id=>wwv_flow_imp.id(1249121759611798356)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P305_NAVLIST_PARENT_ID'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_00306
begin
wwv_flow_imp_page.create_page(
 p_id=>306
,p_name=>'Translate Text'
,p_alias=>'TRANSLATE-TEXT'
,p_step_title=>'Translate Text'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213331522315193801)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'11'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(162450423094619414)
,p_plug_name=>'Translate Text'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(694679637823238904)
,p_plug_name=>'Translate Text'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Typically, translations are performed using a professional translation service. You send the XLIFF file',
'for translation to a third party company, then integrate the returned translation file(s) and publish',
'the translated application(s).</p>',
'',
'<p>Alternatively, you can edit the XLIFF file yourself, or bypass XLIFF generation and upload altogether',
'and edit the translation repository directly.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(694679767912238905)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(694679863558238906)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(694679767912238905)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:4761:&SESSION.::&DEBUG.::::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(166469227943699113)
,p_branch_action=>'f?p=&APP_ID.:4761:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
end;
/
prompt --application/pages/page_00307
begin
wwv_flow_imp_page.create_page(
 p_id=>307
,p_name=>'Confirm Delete of Region Template'
,p_alias=>'CONFIRM-DELETE-OF-REGION-TEMPLATE'
,p_step_title=>'Confirm Delete of Region Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(49332904673072144)
,p_name=>'Template Utilization'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select page_id||'': ''||PLUG_NAME name',
'from WWV_FLOW_PAGE_PLUGS r',
'where r.flow_id = :fb_flow_id and',
'      r.PLUG_TEMPLATE = :p307_id',
'and r.security_group_id = :flow_security_group_id',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(11667910335347890)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No references found.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(49345701272325144)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(49333411517072148)
,p_plug_name=>'Confirm Delete'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(200328107792916236)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747140495476138159)
,p_plug_name=>'Confirm Delete'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(49334213861072151)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(200328107792916236)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(49334600263072154)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(200328107792916236)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Delete'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(49338419046072186)
,p_branch_action=>'f?p=&FLOW_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(49335032357072158)
,p_name=>'P307_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(49333411517072148)
,p_prompt=>'Region Template:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select PAGE_PLUG_TEMPLATE_NAME, id',
'from WWV_FLOW_PAGE_PLUG_TEMPLATES',
'where flow_id = :FB_FLOW_ID',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies name of template to be deleted.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(49335728578072167)
,p_name=>'P307_THEME_ID'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_imp.id(49333411517072148)
,p_prompt=>'Theme:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id',
'from WWV_FLOW_PAGE_PLUG_TEMPLATES',
'where flow_id = :fb_flow_id and id = :p307_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies a collection of templates which define the look and feel of the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(49336417925072170)
,p_name=>'P307_LIST_THEME_CLASS_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(49333411517072148)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Template Class:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_class_id',
'from WWV_FLOW_PAGE_PLUG_TEMPLATES',
'where flow_id = :fb_flow_id and id = :p307_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'REGION THEME CLASS ID'
,p_lov=>'.'||wwv_flow_imp.id(42003622222572861)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'The template class identifies a specific usage for this template.  The template class is used when switching themes.  When switching themes template classes are matched, thus allowing themes to be switched without manually mapping all templates.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(49337630525072175)
,p_validation_name=>'P307_ID'
,p_validation_sequence=>10
,p_validation=>'P307_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_associated_item=>wwv_flow_imp.id(49335032357072158)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(49337211746072174)
,p_validation_name=>'Prevent deletion of used templates'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 x',
'from WWV_FLOW_PAGE_PLUGS r',
'where r.flow_id = :fb_flow_id and r.PLUG_TEMPLATE = :p307_id'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'You may not delete referenced templates.'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(49338005752072180)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete template'
,p_process_sql_clob=>'delete from WWV_FLOW_PAGE_PLUG_TEMPLATES where flow_id = :fb_flow_id and id = :p307_id'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to Delete Template.'
,p_process_when_button_id=>wwv_flow_imp.id(49334600263072154)
,p_process_success_message=>'Template Deleted.'
,p_internal_uid=>49338005752072180
);
end;
/
prompt --application/pages/page_00312
begin
wwv_flow_imp_page.create_page(
 p_id=>312
,p_name=>'Static Workspace Files'
,p_alias=>'STATIC-WORKSPACE-FILES'
,p_step_title=>'Static Workspace Files'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(215592520464926917)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_file_upload.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17155265040224712)
,p_plug_name=>'Tasks'
,p_region_css_classes=>'margin-bottom-sm'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(10900130470111258)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(26482603110914170)
,p_plug_name=>'Static Workspace Files'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.checkbox(',
'           p_idx => 1,',
'           p_value => wwv_flow_escape.html( id ),',
'           p_attributes => wwv_flow_plugin_util.get_html_attr(',
'                               p_name  => ''aria-label'',',
'                               p_value => wwv_flow_lang.runtime_message( ''SELECT_ROW'' ) ) ) cb,',
'       id,',
'       security_group_id,',
'       null as icon,',
'       file_name,',
'       mime_type,',
'       htmldb_util.filesize_mask(sys.dbms_lob.getLength(file_content)) as file_size,',
'       round( sys.dbms_lob.getLength(file_content) / 1024 / 1024, 2 )  as file_size_in_mb,',
'       file_charset,',
'       sys.dbms_lob.getLength(file_content) as file_content,',
'       wwv_flow_file_editor_dev.get_file_reference (',
'            p_scope     => ''WORKSPACE'',',
'            p_file_name => file_name ) as reference,',
'       case when file_ext in (''html'', ''js'', ''css'', ''json'', ''xml'') then ''icon-file-'' || file_ext',
'            when lower(mime_type) like ''image/%'' then ''icon-ws-image''',
'            else ''icon-sc-file''',
'       end as icon_class,',
'       case when file_ext in (''html'', ''js'', ''css'', ''json'', ''xml'') then upper( file_ext )',
'            when lower(mime_type) like ''image/%'' then wwv_flow_lang.runtime_message( ''APEXDEV.ICON_LABEL.IMAGE_FILE'' )',
'            else wwv_flow_lang.runtime_message( ''APEXDEV.ICON_LABEL.OTHER_FILE'' )',
'       end as icon_class_label,',
'       wwv_flow_page_api.get_url (',
'           p_page        => 118,',
'           p_clear_cache => 118,',
'           p_items       => ''P118_ID,P118_SCOPE'',',
'           p_values      => id || '',WORKSPACE''',
'       ) as edit_link,',
'       last_updated_on          as updated,',
'       lower(last_updated_by)   as updated_by,',
'       created_on               as created,',
'       lower(created_by)        as created_by',
'  from ( select f.*, wwv_flow_string_util.get_file_extension(f.file_name) as file_ext from wwv_flow_company_static_files f)',
' where security_group_id = :WORKSPACE_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(26482817283914173)
,p_name=>'Files'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No Static Workspace Files found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#EDIT_LINK#" class="a-IRR-icon">',
'    <span class="a-Icon #ICON_CLASS#"></span>',
'    <span class="a-IRR-iconName">#FILE_NAME#</span>',
'</a>'))
,p_icon_view_columns_per_row=>5
,p_owner=>'SBKENNED'
,p_internal_uid=>26482817283914173
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(26482924107914174)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(26483610363914179)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>11
,p_column_identifier=>'I'
,p_column_label=>'Security Group Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4905025037807748)
,p_db_column_name=>'CB'
,p_display_order=>21
,p_column_identifier=>'T'
,p_column_label=>'&nbsp;'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(21698966710753941)
,p_db_column_name=>'ICON'
,p_display_order=>31
,p_column_identifier=>'O'
,p_column_label=>'Type'
,p_column_html_expression=>'<span class="a-Icon #ICON_CLASS#" role="img" aria-label="#ICON_CLASS_LABEL#"></span>'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(26483111701914176)
,p_db_column_name=>'FILE_NAME'
,p_display_order=>41
,p_column_identifier=>'D'
,p_column_label=>'Name'
,p_column_link=>'#EDIT_LINK#'
,p_column_linktext=>'#FILE_NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(26483012628914176)
,p_db_column_name=>'MIME_TYPE'
,p_display_order=>51
,p_column_identifier=>'C'
,p_column_label=>'Mime Type'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(26483222455914178)
,p_db_column_name=>'FILE_SIZE'
,p_display_order=>61
,p_column_identifier=>'E'
,p_column_label=>'Size'
,p_column_type=>'STRING'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30284310737103903)
,p_db_column_name=>'FILE_CHARSET'
,p_display_order=>71
,p_column_identifier=>'J'
,p_column_label=>'File Charset'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(144796827445692396)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(26483317617914178)
,p_db_column_name=>'FILE_CONTENT'
,p_display_order=>81
,p_column_identifier=>'F'
,p_column_label=>'File'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_column_type=>'NUMBER'
,p_column_alignment=>'CENTER'
,p_format_mask=>'DOWNLOAD:WWV_FLOW_COMPANY_STATIC_FILES:FILE_CONTENT:ID:SECURITY_GROUP_ID:MIME_TYPE:FILE_NAME::FILE_CHARSET:attachment:&APP_TEXT$DOWNLOAD.:'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(261792531167034701)
,p_db_column_name=>'REFERENCE'
,p_display_order=>91
,p_column_identifier=>'K'
,p_column_label=>'Reference'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(656833894631574713)
,p_db_column_name=>'ICON_CLASS'
,p_display_order=>101
,p_column_identifier=>'L'
,p_column_label=>'Icon Class'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1475071337476104)
,p_db_column_name=>'ICON_CLASS_LABEL'
,p_display_order=>106
,p_column_identifier=>'U'
,p_column_label=>'Icon Class Label'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(361062101563469306)
,p_db_column_name=>'FILE_SIZE_IN_MB'
,p_display_order=>111
,p_column_identifier=>'N'
,p_column_label=>'File Size in MB'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(656833965796574713)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>121
,p_column_identifier=>'M'
,p_column_label=>'Edit Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(21699075178753942)
,p_db_column_name=>'UPDATED'
,p_display_order=>131
,p_column_identifier=>'P'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(21699110120753943)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>141
,p_column_identifier=>'Q'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(21699225859753944)
,p_db_column_name=>'CREATED'
,p_display_order=>151
,p_column_identifier=>'R'
,p_column_label=>'Created'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(21699320828753945)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>161
,p_column_identifier=>'S'
,p_column_label=>'Created By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(26483725907914179)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_type=>'REPORT'
,p_report_alias=>'264838'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_view_mode=>'REPORT'
,p_report_columns=>'CB:ICON:FILE_NAME:MIME_TYPE:FILE_SIZE:REFERENCE:FILE_CONTENT:UPDATED:UPDATED_BY::ICON_CLASS_LABEL'
,p_sort_column_1=>'FILE_NAME'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'0'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(26484331581914182)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--sideRegion:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Static workspace files are available to all applications for a given workspace. Use <code><strong>&#35;WORKSPACE_FILES#</strong></code> in your application to reference a file.</p>',
'',
'<p>Use this page to create, edit, and delete static files.</p>',
'',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_plug_query_num_rows=>1500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'L:L:R'
,p_plug_query_break_cols=>'1'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(26483931279914180)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(26482603110914170)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:312:&SESSION.::&DEBUG.:40,RIR::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4905147900807749)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(26482603110914170)
,p_button_name=>'DELETE_CHECKED'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete Checked'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_company_static_files',
' where security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30822212442965618)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(26482603110914170)
,p_button_name=>'DELETE_ALL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete All'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_company_static_files',
' where security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30822015245964373)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(26482603110914170)
,p_button_name=>'DOWNLOAD_ZIP'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Download as Zip'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_company_static_files',
' where security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(26484101155914182)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(26482603110914170)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create File'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:118:&SESSION.::&DEBUG.:118:P118_SCOPE:WORKSPACE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(30824719032982998)
,p_branch_name=>'Reset Pagination after delete all'
,p_branch_action=>'f?p=&APP_ID.:312:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(30822212442965618)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3400201378192002)
,p_name=>'P312_WS_STATIC_FILE'
,p_item_sequence=>30
,p_source=>'wwv_flow_lang_dev.builder_message(''COMPONENT_TYPE.WS_STATIC_FILE'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4905204412807750)
,p_name=>'Delete Checked Files'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(4905147900807749)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6411997454218601)
,p_event_id=>wwv_flow_imp.id(4905204412807750)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'Do you really want to delete all checked files?'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6412060174218602)
,p_event_id=>wwv_flow_imp.id(4905204412807750)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'DELETE_CHECKED'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(30822500893968358)
,p_name=>'Delete All Files'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(30822212442965618)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(30823008096968366)
,p_event_id=>wwv_flow_imp.id(30822500893968358)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'Do you really want to delete all files?'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(30822814313968365)
,p_event_id=>wwv_flow_imp.id(30822500893968358)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'DELETE_ALL'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(6412150537218603)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Checked'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1 .. wwv_flow.g_f01.count loop',
'   wwv_flow_file_editor_dev.delete_file (',
'       p_id     => wwv_flow.g_f01(i),',
'       p_scope  => ''WORKSPACE'' );',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(4905147900807749)
,p_process_success_message=>'Files deleted'
,p_internal_uid=>6412150537218603
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(30823207126970082)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete All'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete wwv_flow_company_static_files',
' where security_group_id = :WORKSPACE_ID;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(30822212442965618)
,p_process_success_message=>'Files deleted'
,p_internal_uid=>30823207126970082
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(30823411282971295)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_DOWNLOAD'
,p_process_name=>'Download as Zip'
,p_attribute_01=>'Y'
,p_attribute_02=>'static_workspace_files.zip'
,p_attribute_04=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select file_content,',
'       file_name',
'  from wwv_flow_company_static_files',
' where security_group_id = :WORKSPACE_ID',
' order by file_name'))
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(30822015245964373)
,p_internal_uid=>30823411282971295
);
end;
/
prompt --application/pages/page_00321
begin
wwv_flow_imp_page.create_page(
 p_id=>321
,p_name=>'Install UI Defaults'
,p_alias=>'INSTALL-UI-DEFAULTS'
,p_step_title=>'Install UI Defaults'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213300727323081712)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_install.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(38857309371202842)
,p_plug_name=>'import progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(37899301707472090)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47632929379499289)
,p_plug_name=>'Install UI Defaults'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_imp_parser.get_ui_schema(:P321_FILE_ID) is not null or ',
'wwv_flow_imp_parser.get_attr_dict_workspace(:P321_FILE_ID) is not null'))
,p_plug_display_when_cond2=>'PLSQL'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>You can install a UI Defaults Table Dictionary into any schema provisioned in the workspace. When you install a Table Dictionary, the old defaults will be overwritten.</p>',
'<p>UI Defaults Attribute Dictionary imports will replace any matching attribute definitions that are found but will not remove any existing attribute definitions that are not contained in the import.</p>',
'<p>If the installation succeeds, the installation of the UI Defaults becomes permanent. If any errors are encountered, the actions are rolled back, resulting in no permanent changes.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(79479717773383324)
,p_plug_name=>'Invalid File'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--danger:a-Alert--horizontal'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>30
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_imp_parser.get_ui_schema(:P321_FILE_ID) is null and ',
'wwv_flow_imp_parser.get_attr_dict_workspace(:P321_FILE_ID) is null'))
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'File is not a valid &PRODUCT_NAME. UI Defaults import.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(205187226579460699)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747140815004138160)
,p_plug_name=>'Install UI Defaults'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(47637304969530136)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(205187226579460699)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(47638615358533175)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(205187226579460699)
,p_button_name=>'INSTALL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Install UI Defaults'
,p_button_position=>'CREATE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_imp_parser.get_ui_schema(:P321_FILE_ID) is not null or',
'wwv_flow_imp_parser.get_attr_dict_workspace(:P321_FILE_ID) is not null'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2227785264410013)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(205187226579460699)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:163:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(47640408909540737)
,p_branch_action=>'f?p=4500:813:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST = ''INSTALL'' or',
'(:REQUEST = ''REPLACE'' and ',
' (wwv_flow_imp_parser.get_ui_schema(:P321_FILE_ID) is not null or',
'  wwv_flow_imp_parser.get_attr_dict_workspace(:P321_FILE_ID) is not null) )'))
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(73118923864774290)
,p_branch_action=>'f?p=&FLOW_ID.:321:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(73107224679708356)
,p_branch_action=>'f?p=&APP_ID.:48:&SESSION.:UI_DEFAULTS:&DEBUG.:::'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(47638615358533175)
,p_branch_sequence=>30
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_HNT_TABLE_INFO',
' where schema = :P321_SCHEMA_NAME',
'   and wwv_flow_imp_parser.get_ui_schema(:P321_FILE_ID) is not null'))
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(24121328651623248)
,p_branch_action=>'f?p=&APP_ID.:48:&SESSION.:UI_DEFAULTS_AD:&DEBUG.:::'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(47638615358533175)
,p_branch_sequence=>40
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from WWV_FLOW_HNT_COLUMN_DICT',
' where security_group_id = :flow_security_group_id',
'   and wwv_flow_imp_parser.get_attr_dict_workspace(:P321_FILE_ID) is not null'))
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(53701615454624100)
,p_name=>'P321_FILE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(47632929379499289)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(146463506734195936)
,p_name=>'P321_SCHEMA_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(47632929379499289)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Imported From Schema'
,p_source=>'wwv_flow_imp_parser.get_ui_schema(:p321_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'wwv_flow_imp_parser.get_attr_dict_workspace(:P321_FILE_ID) is null'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The schema associated with the UI Defaults Table Dictionary.  This schema must be associated with the current workspace in order for the import to proceed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(160738417213422622)
,p_name=>'P321_ORIGINAL_SGID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(47632929379499289)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Imported From Workspace'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare l_file_sgid number := wwv_flow_imp_parser.get_security_group_id(:p321_file_id);',
'begin',
'  for c1 in (select short_name from wwv_flow_companies',
'    where provisioning_company_id = l_file_sgid) loop',
'    return c1.short_name||'' (''||to_char(l_file_sgid)||'')'';',
'  end loop;',
'return to_char(l_file_sgid);',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The unique identifier of the workspace from where these UI Defaults were imported.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(163265116213402450)
,p_name=>'P321_VERSION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(47632929379499289)
,p_prompt=>'Imported File Version'
,p_source=>'wwv_flow_imp_parser.get_version(:p321_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the imported file version.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(163273327828519313)
,p_validation_name=>'check version'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_runtime_version varchar2(200); -- the date of the current runtime flows',
'  l_calling_version varchar2(200);',
'begin',
'    l_calling_version := replace(replace(replace(wwv_flow_imp_parser.get_version (p_file_id => :p321_file_id),''.'',null),''_'',null),''/'',null);',
'    l_runtime_version := replace(replace(replace(wwv_flows_version,''.'',null),''_'',null),''/'',null);',
'',
'    if l_calling_version > l_runtime_version then',
'        --',
'        -- version incompatability        ',
'        --',
'        ',
'        return false;',
'    else',
'        return true;',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'NOT COMPATIBLE (Your import may contain calls not supported by your application version.)'
,p_when_button_pressed=>wwv_flow_imp.id(47638615358533175)
,p_associated_item=>wwv_flow_imp.id(163265116213402450)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(47812121666858284)
,p_validation_name=>'not valid import file'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_imp_parser.get_ui_schema(:P321_FILE_ID) is null and',
'   wwv_flow_imp_parser.get_attr_dict_workspace(:P321_FILE_ID) is null then',
'   return false;',
'else',
'   return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'File is not a valid &PRODUCT_NAME. UI Defaults import file.'
,p_when_button_pressed=>wwv_flow_imp.id(47638615358533175)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(628833325240746222)
,p_validation_name=>'file schema associated with workspace - for table defaults'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_exp_schema varchar(255) := wwv_flow_imp_parser.get_ui_schema(:P321_FILE_ID);',
'begin',
'   for c1 in (',
'      select c.schema',
'        from wwv_flow_company_schemas c,',
'             wwv_flow_fnd_user u',
'       where c.security_group_id = :flow_security_group_id and',
'             u.security_group_id = :flow_security_group_id and',
'             u.user_name = :flow_user and',
'             (u.ALLOW_ACCESS_TO_SCHEMAS is null or',
'              instr('':''||u.ALLOW_ACCESS_TO_SCHEMAS||'':'','':''||c.schema||'':'')>0) )',
'   loop',
'      if c1.schema = l_exp_schema then',
'         return true;',
'      end if;',
'   end loop;',
'',
'   return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Importing to schema not associated with the current workspace.'
,p_validation_condition=>'wwv_flow_imp_parser.get_ui_schema(:P321_FILE_ID) is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(47638615358533175)
,p_associated_item=>wwv_flow_imp.id(146463506734195936)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(46353812810485902)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'install ui defaults'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  wwv_flow_imp_parser.parse (',
'     p_file_id          => :P321_FILE_ID',
'     );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error installing UI Defaults.'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST = ''INSTALL'' or',
'(:REQUEST = ''REPLACE'' and ',
' (wwv_flow_imp_parser.get_ui_schema(:P321_FILE_ID) is not null or',
'  wwv_flow_imp_parser.get_attr_dict_workspace(:P321_FILE_ID) is not null) )'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'UI Defaults installed.'
,p_internal_uid=>46353812810485902
);
end;
/
prompt --application/pages/page_00328
begin
wwv_flow_imp_page.create_page(
 p_id=>328
,p_name=>'Script Properties'
,p_alias=>'SCRIPT-PROPERTIES'
,p_step_title=>'Script Properties'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(24897722063538624)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function pageSubmit(req) {',
'  apex.submit(req);',
'}',
''))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.db-ValidStatus {',
'    padding: 8px 16px;',
'    text-align: center;',
'}',
'.db-ValidStatus-status {',
'    padding: 8px;',
'    border-radius: 4px;',
'    text-align: center;',
'    box-shadow: 0 0 0 2px rgba(0,0,0,.1) inset;',
'    margin-bottom: 8px;',
'    color: #000;',
'}',
'.db-ValidStatus-status.green {',
'    background-color: #A3F079;',
'}',
'.db-ValidStatus-status.red {',
'    background-color: #F00000;',
'    color: #FFF;',
'}',
'.db-ValidStatus-status.yellow {',
'    background-color: #F3D834;',
'}',
'.db-ValidStatus-link {',
'    font-size: 11px;',
'    color: #707070;',
'}',
'.uSideRegion span.uButtonContainer {',
'display: block;',
'padding: 8px 16px;',
'}',
'.uSideRegion span.uButtonContainer .uButtonLarge {',
'    display: block;',
'}'))
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_read_only_when_type=>'EXPRESSION'
,p_read_only_when=>'not wwv_flow_lock.user_can_edit_script ( p_flow_id => :FB_FLOW_ID, p_script_id => :P328_ID )'
,p_read_only_when2=>'PLSQL'
,p_help_text=>'deployment.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(923623550470073)
,p_plug_name=>'Script: &P328_NAME.'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(933304732487769)
,p_plug_name=>'Script'
,p_region_name=>'SCRIPT'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>130
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_column=>false
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(952616047632959)
,p_plug_name=>'Conditions'
,p_region_name=>'CONDITIONS'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>140
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4853705393428023)
,p_plug_name=>'Script Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>0
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_04'
,p_list_id=>wwv_flow_imp.id(4852514958421306)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_lock.user_can_edit_script ( p_flow_id => :FB_FLOW_ID, p_script_id => :P328_ID ) and :P328_ID is not null'
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46235930672678964)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>13
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(925210867036339484)
,p_plug_name=>'Source'
,p_region_name=>'codeEditor'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_region_attributes=>'style="clear:both"'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>150
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_column=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select script',
'from wwv_flow_install_scripts',
'where flow_id = :FB_FLOW_ID',
'and security_group_id = :FLOW_SECURITY_GROUP_ID',
'and id = :P328_ID'))
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.CLOB_CODE_EDITOR'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'not wwv_flow_lock.user_can_edit_script ( p_flow_id => :FB_FLOW_ID, p_script_id => :P328_ID ) and :P328_ID is not null'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'DDL',
  'attribute_02', '20',
  'attribute_03', 'Y',
  'attribute_04', 'VARCHAR2')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(925329487962687617)
,p_plug_name=>'Locks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>160
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_lock.display_script_lock_info (',
'    p_flow_id   => :FB_FLOW_ID,',
'    p_script_id => :P328_ID);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'N',
  'attribute_02', 'TEXT',
  'attribute_03', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(925353646438874243)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(925329487962687617)
,p_button_name=>'LOCK'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Lock'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:16:&SESSION.::&DEBUG.:16:P16_LOCK_SCRIPT_ID:&P328_ID.'
,p_button_condition=>'not wwv_flow_lock.script_locked ( p_flow_id => :FB_FLOW_ID, p_script_id => :P328_ID ) and :P328_ID is not null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(925389882234951313)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(925329487962687617)
,p_button_name=>'UNLOCK'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Unlock'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:16:&SESSION.::&DEBUG.:16:P16_LOCK_SCRIPT_ID,P16_LOCK_ID:&P328_ID.,&P328_LOCK_ID.'
,p_button_condition=>'wwv_flow_lock.script_locked_by_user ( p_flow_id => :FB_FLOW_ID, p_script_id => :P328_ID ) and :P328_ID is not null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4783606441436244)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(933304732487769)
,p_button_name=>'EDIT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Edit'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:865:&SESSION.::&DEBUG.:865:P865_SCRIPT_ID:&P328_ID.'
,p_button_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(924109972470088)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(923623550470073)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(924030159470088)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(923623550470073)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(htmldb_delete_message,''DELETE'');'
,p_button_condition=>'wwv_flow_lock.user_can_edit_script ( p_flow_id => :FB_FLOW_ID, p_script_id => :P328_ID ) and :P328_ID is not null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(923906509470088)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(923623550470073)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'wwv_flow_lock.user_can_edit_script ( p_flow_id => :FB_FLOW_ID, p_script_id => :P328_ID ) and :P328_ID is not null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(923824997470087)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(923623550470073)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>'P328_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4869105748503820)
,p_branch_name=>'Go To Page 865'
,p_branch_action=>'f?p=&APP_ID.:865:&SESSION.::&DEBUG.:865:P865_SCRIPT_ID,P865_MODE:&P328_ID.,EDIT:&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_865'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(929196032807394224)
,p_branch_name=>'Go To Page 328'
,p_branch_action=>'f?p=&APP_ID.:328:&SESSION.::&DEBUG.:865:P865_SCRIPT_ID,P865_MODE:&P328_ID.,EDIT:&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_328'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(924710023470101)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(924904477470144)
,p_name=>'P328_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(923623550470073)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(925127884470161)
,p_name=>'P328_FLOW_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(923623550470073)
,p_use_cache_before_default=>'NO'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(925511458470194)
,p_name=>'P328_INSTALL_ID'
,p_item_sequence=>65
,p_item_plug_id=>wwv_flow_imp.id(923623550470073)
,p_use_cache_before_default=>'NO'
,p_source=>'INSTALL_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(925901158470200)
,p_name=>'P328_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(933304732487769)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The name of this installation script.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(926324801470201)
,p_name=>'P328_SEQUENCE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(933304732487769)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Sequence'
,p_source=>'SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>8
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The sequence number of this installation script.  Scripts run in order of ascending sequence number.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(927119812470203)
,p_name=>'P328_CONDITION_TYPE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(952616047632959)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Condition Type'
,p_source=>'CONDITION_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CONDITION_LIST'
,p_named_lov=>'INSTALL_CONDITION_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(2610902469203915)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Condition Type -'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a condition type from the list that determines whether this script is run during installation.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'P328_CONDITION'
,p_attribute_02=>'P328_CONDITION2'
,p_attribute_04=>'P328_CONDITION_CHECK'
,p_attribute_06=>'INSTALL'
,p_attribute_07=>'P328_CONDITION_LANG'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(927300256470204)
,p_name=>'P328_CONDITION'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(952616047632959)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Expression 1'
,p_source=>'CONDITION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Use this attribute to conditionally control whether the current script is run on installation.  Enter values in this attribute based on the specific condition type selected.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(927517644470204)
,p_name=>'P328_CONDITION2'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(952616047632959)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Expression 2'
,p_source=>'CONDITION2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Some condition types require two expressions for comparison. Enter the second expression here.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1672854271932288)
,p_name=>'P328_CONDITION_LANG'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(952616047632959)
,p_prompt=>'Language'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select a language that is used to evaluate the entered programming code.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57790318700946827)
,p_name=>'P328_SCRIPT_TYPE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(933304732487769)
,p_use_cache_before_default=>'NO'
,p_item_default=>'INSTALL'
,p_prompt=>'Script Type'
,p_source=>'SCRIPT_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'SUPPORTING OBJECT SCRIPT TYPES'
,p_lov=>'.'||wwv_flow_imp.id(57799129745997268)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identifies the type of this Supporting Object script.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(435033705614654759)
,p_name=>'P328_CONDITION_CHECK'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(952616047632959)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Do not validate code (parse code at runtime only).'
,p_source=>'NULL'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(573141089417686163)
,p_name=>'P328_SCRIPT'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(933304732487769)
,p_prompt=>'New Script'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select a file to upload to replace the existing script.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'WWV_FLOW_FILES'
,p_attribute_12=>'INLINE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(573141527634691114)
,p_name=>'P328_FILE_CHARSET'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(933304732487769)
,p_prompt=>'File Character Set'
,p_source=>'nvl(lower(trim(sys.owa_util.get_cgi_env(''REQUEST_IANA_CHARSET''))),''utf-8'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_IANA_CHARSET'
,p_lov=>'.'||wwv_flow_imp.id(144796827445692396)||'.'
,p_cSize=>64
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose the character set in which the script is encoded.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(929001219074024339)
,p_name=>'P328_LOCK_ID'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(923623550470073)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(929001419112034464)
,p_computation_sequence=>10
,p_computation_item=>'P328_LOCK_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'from wwv_flow_lock_script',
'where script_id = :P328_ID',
'and security_group_id = :FLOW_SECURITY_GROUP_ID',
'and flow_id = :FB_FLOW_ID',
'and locked_by = :APP_USER'))
,p_compute_when=>'wwv_flow_lock.script_locked_by_user ( p_flow_id => :FB_FLOW_ID, p_script_id => :P328_ID ) and :P328_ID is not null'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(926108808470201)
,p_validation_name=>'P328_NAME not null'
,p_validation_sequence=>50
,p_validation=>'P328_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Name must have some value.'
,p_associated_item=>wwv_flow_imp.id(925901158470200)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(926505451470202)
,p_validation_name=>'P328_SEQUENCE not null'
,p_validation_sequence=>60
,p_validation=>'P328_SEQUENCE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Sequence must have some value.'
,p_associated_item=>wwv_flow_imp.id(926324801470201)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(932842459462260186)
,p_name=>'RENDERING: Page - Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(925329487962687617)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(932842796470260190)
,p_event_id=>wwv_flow_imp.id(932842459462260186)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var lSuccessMsg = this.data.APEX_SUCCESS_MESSAGE,',
'      lUrl = ''f?p=&APP_ID.:328:&SESSION.::'',',
'      lVal = this.data[ ''REQUEST'' ]; ',
'',
'if ( lSuccessMsg ) {',
'   lUrl += ''&success_msg='' + lSuccessMsg;',
'}',
'setTimeout(function() {',
'    apex.navigation.redirect(lUrl);',
'}, 0);'))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(927707701470208)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_INSTALL_SCRIPTS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_INSTALL_SCRIPTS'
,p_attribute_03=>'P328_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Unable to fetch row.'
,p_internal_uid=>927707701470208
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(927923987470222)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_INSTALL_SCRIPTS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_INSTALL_SCRIPTS'
,p_attribute_03=>'P328_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Unable to process row of table WWV_FLOW_INSTALL_SCRIPTS.'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>927923987470222
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(928131752470223)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'328'
,p_process_when_button_id=>wwv_flow_imp.id(924030159470088)
,p_internal_uid=>928131752470223
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(537839307388118515)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update Script'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare l_clob clob;',
'begin',
'for c1 in (select *',
'             from wwv_flow_files ',
'            where name = :P328_SCRIPT)',
'loop',
'',
'  l_clob := wwv_flow_utilities.blob_to_clob( ',
'                p_blob => c1.blob_content, ',
'                p_charset => :P328_FILE_CHARSET );',
'                ',
'  update wwv_flow_install_scripts',
'     set script = l_clob',
'   where flow_id = :fb_flow_id',
'     and security_group_id = :flow_security_group_id',
'     and id = :P328_ID;',
'     ',
'  delete from wwv_flow_files where id = c1.id;     ',
'',
'end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'An error occurred attempting to replace the script.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(923906509470088)
,p_process_when=>'P328_SCRIPT'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_process_success_message=>'Script replaced.'
,p_internal_uid=>537839307388118515
);
end;
/
prompt --application/pages/page_00330
begin
wwv_flow_imp_page.create_page(
 p_id=>330
,p_name=>'Edit Page Lock'
,p_alias=>'EDIT-PAGE-LOCK'
,p_page_mode=>'MODAL'
,p_step_title=>'Edit Page Lock'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213229021839834158)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12511519296310366)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_locks.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(34977219677901638)
,p_plug_name=>'Edit Page Lock'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_header=>'This page allows workspace administrators to unlock any page.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'Region generated 23-MAY-2004 21:42:53'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1059809069083457627)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(34977605764901644)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(1059809069083457627)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:299:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(34977927457901644)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1059809069083457627)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Unlock'
,p_button_position=>'NEXT'
,p_button_condition=>'P330_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(34977816263901644)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1059809069083457627)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P330_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(34979600897901653)
,p_branch_action=>'f?p=&APP_ID.:299:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_comment=>'Generated 23-MAY-2004 21:42:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(34980027621901664)
,p_name=>'P330_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(34977219677901638)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 23-MAY-2004 21:42:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(34980418553901689)
,p_name=>'P330_OBJECT_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(34977219677901638)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Page:'
,p_source=>'OBJECT_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'This lock is for this page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'Generated 23-MAY-2004 21:42:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(34980814477901694)
,p_name=>'P330_LOCK_COMMENT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(34977219677901638)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comment'
,p_source=>'LOCK_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>10
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'As a workspace administrator you can edit lock comments by yourself as well as any other workspace developer.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_item_comment=>'Generated 23-MAY-2004 21:42:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(34995523029005767)
,p_name=>'P330_LOCKED_BY'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(34977219677901638)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Locked By'
,p_source=>'LOCKED_BY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(userid) d, userid r',
'from wwv_flow_developers',
'where (instr(developer_role,''ADMIN'') > 0 or',
'      instr(developer_role,''EDIT'') > 0)',
'and security_group_id = :flow_security_group_id',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'%'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'As a workspace administrator you can set the page to be locked by any valid application developer in the workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(35025211012134770)
,p_validation_name=>'P330_LOCKED_BY'
,p_validation_sequence=>10
,p_validation=>'P330_LOCKED_BY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_associated_item=>wwv_flow_imp.id(34995523029005767)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1059808873062457625)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(34977605764901644)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1059808907077457626)
,p_event_id=>wwv_flow_imp.id(1059808873062457625)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(34981300123901698)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_LOCK_PAGE'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_LOCK_PAGE'
,p_attribute_03=>'P330_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Unable to fetch row.'
,p_internal_uid=>34981300123901698
,p_process_comment=>'Generated 23-MAY-2004 21:42:53'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(34981708199901700)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_LOCK_PAGE'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_LOCK_PAGE'
,p_attribute_03=>'P330_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Unable to process row of table WWV_FLOW_LOCK_PAGE.'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>34981708199901700
,p_process_comment=>'Generated 23-MAY-2004 21:42:53'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(34982116880901701)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'330'
,p_process_when_button_id=>wwv_flow_imp.id(34977927457901644)
,p_internal_uid=>34982116880901701
);
end;
/
prompt --application/pages/page_00331
begin
wwv_flow_imp_page.create_page(
 p_id=>331
,p_name=>'Parent Tabs Grid Edit'
,p_alias=>'PARENT-TABS-GRID-EDIT'
,p_step_title=>'Edit Parent Tabs'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213240607818867991)
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
,p_page_component_map=>'01'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(32785704230533968)
,p_name=>'Edit Parent Tabs'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P331a */',
'    ID,',
'    TAB_SEQUENCE,',
'    TAB_NAME,',
'    TAB_TEXT,',
'    TAB_TARGET,',
'    LAST_UPDATED_BY,',
'    LAST_UPDATED_ON',
'from WWV_FLOW_TOPLEVEL_TABS',
'where flow_id = :fb_flow_id ',
'and (:P331_TABSET is null or :P331_TABSET = ''0'' or tab_set = :P331_TABSET)',
'and security_group_id = :flow_security_group_id',
'order by tab_set, tab_sequence, tab_name'))
,p_translate_title=>'N'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>500
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No Parent Tabs found.'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
,p_comment=>'Region generated 11-FEB-2003 14:24:40'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48575811244770989)
,p_query_column_id=>1
,p_form_element_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'<br />'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48575928440770989)
,p_query_column_id=>2
,p_form_element_id=>2
,p_column_alias=>'TAB_SEQUENCE'
,p_column_display_sequence=>2
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_column_width=>5
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48576002472770989)
,p_query_column_id=>3
,p_form_element_id=>3
,p_column_alias=>'TAB_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Name'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48576115826770989)
,p_query_column_id=>4
,p_form_element_id=>4
,p_column_alias=>'TAB_TEXT'
,p_column_display_sequence=>4
,p_column_heading=>'Text'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48576232078770990)
,p_query_column_id=>5
,p_form_element_id=>5
,p_column_alias=>'TAB_TARGET'
,p_column_display_sequence=>5
,p_column_heading=>'Target'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_column_width=>40
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48576303329770990)
,p_query_column_id=>6
,p_column_alias=>'LAST_UPDATED_BY'
,p_column_display_sequence=>6
,p_column_heading=>'Developer'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48576423268770990)
,p_query_column_id=>7
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>7
,p_column_heading=>'Date'
,p_use_as_row_header=>'N'
,p_column_format=>'&DATE_TIME_FORMAT.'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(32785920052533992)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'HIDDEN'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(32786027691533995)
,p_column_sequence=>2
,p_query_column_name=>'TAB_SEQUENCE'
,p_display_as=>'TEXT'
,p_column_width=>5
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(32786100900533995)
,p_column_sequence=>3
,p_query_column_name=>'TAB_NAME'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(32786226848533995)
,p_column_sequence=>4
,p_query_column_name=>'TAB_TEXT'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(32786330009533995)
,p_column_sequence=>5
,p_query_column_name=>'TAB_TARGET'
,p_display_as=>'TEXT'
,p_column_width=>40
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(32786401210533995)
,p_column_sequence=>6
,p_query_column_name=>'LAST_UPDATED_BY'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(32786518865533995)
,p_column_sequence=>7
,p_query_column_name=>'LAST_UPDATED_ON'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(36313406180556893)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(5297709875)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(48821014939974562)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(188145406667102404)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(48821014939974562)
,p_button_name=>'P331_GO'
,p_button_static_id=>'P331_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Go'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(32786908200534003)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(48821014939974562)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(32787828546534015)
,p_branch_action=>'331'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
,p_branch_comment=>'Generated 11-FEB-2003 14:24:40'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(188144726621098685)
,p_name=>'P331_TABSET'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(48821014939974562)
,p_prompt=>'Parent Tabset'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct wwv_flow_escape.html(TAB_SET) d, tab_set r ',
'  from WWV_FLOW_TOPLEVEL_TABS',
' where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- All Tab Sets -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies selected parent tab set.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(32787417128534011)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(32785704230533968)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'ApplyMRU'
,p_attribute_02=>'WWV_FLOW_TOPLEVEL_TABS'
,p_attribute_03=>'ID'
,p_attribute_05=>'flow_id = :FB_FLOW_ID and security_group_id = :WORKSPACE_ID'
,p_process_error_message=>'Error processing update.'
,p_process_when_button_id=>wwv_flow_imp.id(32786908200534003)
,p_process_success_message=>'#MRU_COUNT# row(s) updated.'
,p_internal_uid=>32787417128534011
,p_process_comment=>'Generated 11-FEB-2003 14:24:40'
);
end;
/
prompt --application/pages/page_00332
begin
wwv_flow_imp_page.create_page(
 p_id=>332
,p_name=>'Rename Parent Tab Set'
,p_alias=>'RENAME-PARENT-TAB-SET'
,p_step_title=>'Rename Parent Tab Set'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213240607818867991)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(32825430112636229)
,p_plug_name=>'Rename Parent Tab Set'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'Region generated 11-FEB-2003 14:41:42'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(32825826096636232)
,p_plug_name=>'Parent Tab Sets'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>This page enables you to rename an existing tab set.  A tab set is a collection of tabs that are displayed together.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'Region generated 11-FEB-2003 14:41:42'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(32826310509636240)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(32825430112636229)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:398:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(32826606609636240)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(32825430112636229)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(32827520364636251)
,p_branch_action=>'333'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(32826606609636240)
,p_branch_sequence=>10
,p_branch_comment=>'Generated 11-FEB-2003 14:41:42'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(32826123070636238)
,p_name=>'P332_TABSET'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(32825430112636229)
,p_prompt=>'Parent Tab Set to Rename'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct wwv_flow_escape.html(TAB_SET) d, tab_set r ',
'from WWV_FLOW_TOPLEVEL_TABS',
'where flow_id = :fb_flow_id ',
'order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the tab set to be renamed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_item_comment=>'Generated 11-FEB-2003 14:41:42'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(32854432668663509)
,p_name=>'P332_NEW_TAB_SET_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(32825430112636229)
,p_prompt=>'New Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a name for the new tab set.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(36261808567254780)
,p_validation_name=>'P332_TABSET Not Null'
,p_validation_sequence=>10
,p_validation=>'P332_TABSET'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Tab Set to Rename must be specified.'
,p_associated_item=>wwv_flow_imp.id(32826123070636238)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 13-FEB-2003 18:24'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(36262007852254783)
,p_validation_name=>'P332_NEW_TAB_SET_NAME Not Null'
,p_validation_sequence=>20
,p_validation=>'P332_NEW_TAB_SET_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'New Tab Set Name must be specified.'
,p_associated_item=>wwv_flow_imp.id(32854432668663509)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 13-FEB-2003 18:24'
);
end;
/
prompt --application/pages/page_00333
begin
wwv_flow_imp_page.create_page(
 p_id=>333
,p_name=>'Rename Parent Tab Set'
,p_alias=>'RENAME-PARENT-TAB-SET1'
,p_step_title=>'Rename Parent Tab Set'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213240607818867991)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(32828122646636252)
,p_plug_name=>'Confirm Request'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>100
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'Region generated 11-FEB-2003 14:41:42'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1119585806625190518)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(32829310850636256)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(1119585806625190518)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Rename Tab Set'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(32829200050636256)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1119585806625190518)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(32829003846636256)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1119585806625190518)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:398:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(32830715385636259)
,p_branch_action=>'398'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(32829310850636256)
,p_branch_sequence=>40
,p_branch_comment=>'Generated 11-FEB-2003 14:41:42'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(32830228699636258)
,p_branch_action=>'332'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(32829200050636256)
,p_branch_sequence=>10
,p_branch_comment=>'Generated 11-FEB-2003 14:41:42'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(36259009821245715)
,p_name=>'P333_FROM'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(32828122646636252)
,p_prompt=>'Rename parent tab set from:'
,p_source=>'P332_TABSET'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the previous parent tab set name.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(36260431292251898)
,p_name=>'P333_TO'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(32828122646636252)
,p_prompt=>'Rename parent tab set to:'
,p_source=>'P332_NEW_TAB_SET_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies a new parent tab set name.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(36269616626313916)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'rename tabset'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'update WWV_FLOW_TOPLEVEL_TABS',
'set TAB_SET = :P332_NEW_TAB_SET_NAME',
'where flow_id = :fb_flow_id and',
'      tab_set = :P332_TABSET and',
'      security_group_id = :flow_security_group_id;',
'',
'update wwv_flow_tabs',
'set TAB_PARENT_TABSET = :P332_NEW_TAB_SET_NAME',
'where flow_id = :fb_flow_id and',
'      TAB_PARENT_TABSET = :P332_TABSET and',
'      security_group_id = :flow_security_group_id;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error updating parent tab set.'
,p_process_when_button_id=>wwv_flow_imp.id(32829310850636256)
,p_process_success_message=>'Parent tab set updated.'
,p_internal_uid=>36269616626313916
);
end;
/
prompt --application/pages/page_00336
begin
wwv_flow_imp_page.create_page(
 p_id=>336
,p_name=>'Lock History'
,p_alias=>'LOCK-HISTORY'
,p_page_mode=>'MODAL'
,p_step_title=>'Lock History'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(24897722063538624)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_dialog_width=>'650'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'No help is available for this page.'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(932326115686786179)
,p_name=>'Lock History'
,p_template=>wwv_flow_imp.id(42025417508627628)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select l.action, lower(l.locked_by) locked_by, l.action_date, l.lock_comment',
'from wwv_flow_lock_script_log l',
'where l.flow_id = :fb_flow_id',
'and l.security_group_id = :flow_security_group_id',
'and l.script_id = :P336_LOCK_SCRIPT_ID',
'order by action_date desc'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No lock history found.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(932326437746786184)
,p_query_column_id=>1
,p_column_alias=>'ACTION'
,p_column_display_sequence=>1
,p_column_heading=>'Action'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(857850100888646856)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(932326545567786185)
,p_query_column_id=>2
,p_column_alias=>'LOCKED_BY'
,p_column_display_sequence=>2
,p_column_heading=>'By'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(932326676166786185)
,p_query_column_id=>3
,p_column_alias=>'ACTION_DATE'
,p_column_display_sequence=>3
,p_column_heading=>'Action Date'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(932326728746786185)
,p_query_column_id=>4
,p_column_alias=>'LOCK_COMMENT'
,p_column_display_sequence=>4
,p_column_heading=>'Lock Comment'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(932327391138794119)
,p_plug_name=>'wizard button'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--wizard'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(932327676838796840)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(932327391138794119)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(932327170924790782)
,p_name=>'P336_LOCK_SCRIPT_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(932326115686786179)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(932327958950799661)
,p_name=>'cancel dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(932327676838796840)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(932328249590799663)
,p_event_id=>wwv_flow_imp.id(932327958950799661)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00337
begin
wwv_flow_imp_page.create_page(
 p_id=>337
,p_name=>'Lock Details'
,p_alias=>'LOCK-DETAILS'
,p_page_mode=>'MODAL'
,p_step_title=>'Lock Details'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213229021839834158)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_locks.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(35038001734228620)
,p_plug_name=>'Edit Page Lock'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P337_ID'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'Region generated 23-MAY-2004 21:42:53'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(37642622063729156)
,p_name=>'Lock History'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(action) action, lower(developer) developer, action_date, lock_comment',
'from wwv_flow_lock_page_log',
'where lock_flow = :fb_flow_id and',
'      lock_page = :fb_flow_page_id',
'order by action_date desc'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No page lock history found'
,p_query_num_rows_type=>'ROW_RANGES'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(37643229670729206)
,p_query_column_id=>1
,p_column_alias=>'ACTION'
,p_column_display_sequence=>1
,p_column_heading=>'Action'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(37643314448729206)
,p_query_column_id=>2
,p_column_alias=>'DEVELOPER'
,p_column_display_sequence=>2
,p_column_heading=>'Developer'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(37643411172729206)
,p_query_column_id=>3
,p_column_alias=>'ACTION_DATE'
,p_column_display_sequence=>3
,p_column_heading=>'Date'
,p_use_as_row_header=>'N'
,p_column_format=>'&DATE_TIME_FORMAT.'
,p_column_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(37643524595729206)
,p_query_column_id=>4
,p_column_alias=>'LOCK_COMMENT'
,p_column_display_sequence=>4
,p_column_heading=>'Lock Comment'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(926587255728474692)
,p_plug_name=>'wizard buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--wizard'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>150
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(926699198839954689)
,p_plug_name=>'Edit Lock'
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>160
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1059808656537457623)
,p_plug_name=>'Edit Page Lock'
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'ITEM_IS_NULL'
,p_plug_display_when_condition=>'P337_ID'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(35038817480228623)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(926587255728474692)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(35039607193228627)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(926587255728474692)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Unlock'
,p_button_position=>'NEXT'
,p_button_condition=>'P337_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_security_scheme=>wwv_flow_imp.id(34674432490821717)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(41115600050764358)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(926587255728474692)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Lock Page'
,p_button_position=>'NEXT'
,p_button_condition=>'P337_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_security_scheme=>wwv_flow_imp.id(34674432490821717)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(35039214984228626)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(926587255728474692)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P337_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_security_scheme=>wwv_flow_imp.id(34674432490821717)
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(35044924947228653)
,p_branch_action=>'f?p=&FLOW_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>21
,p_branch_comment=>'Generated 23-MAY-2004 21:42:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(35040030743228629)
,p_name=>'P337_LOCKED_BY'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(35038001734228620)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Lock Owner:'
,p_source=>'LOCKED_BY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Indicates the name of the workspace developer who currently holds the page lock.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(35041123473228633)
,p_name=>'P337_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(35038001734228620)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 23-MAY-2004 21:42:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(35041517762228633)
,p_name=>'P337_OBJECT_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(35038001734228620)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Page:'
,p_source=>'OBJECT_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'This lock is for this page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'Generated 23-MAY-2004 21:42:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(35042222546228635)
,p_name=>'P337_LOCK_COMMENT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(35038001734228620)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comment'
,p_source=>'LOCK_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>8
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_escape_on_http_input=>'Y'
,p_help_text=>'As a workspace administrator you can edit lock comments by yourself as well as any other workspace developer.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_item_comment=>'Generated 23-MAY-2004 21:42:53'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(41133917112826111)
,p_name=>'P337_FLOW_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(35038001734228620)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1059808581493457622)
,p_name=>'P337_NO_LOCK_DETAILS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1059808656537457623)
,p_source=>'wwv_flow_lang.system_message(''F4000.P337.PAGE_UNLOCKED'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'P337_ID'
,p_display_when_type=>'ITEM_IS_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(35080423955498085)
,p_validation_name=>'P337_LOCK_COMMENT'
,p_validation_sequence=>20
,p_validation=>'P337_LOCK_COMMENT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_associated_item=>wwv_flow_imp.id(35042222546228635)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(41661607089787512)
,p_validation_name=>'fb flow id must = object id'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :fb_flow_page_id = :P337_OBJECT_ID then',
'  return true;',
'else',
'  return false;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'You may only lock the current page.'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1059808321924457620)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(35038817480228623)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1059808403267457621)
,p_event_id=>wwv_flow_imp.id(1059808321924457620)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(35043326331228646)
,p_process_sequence=>1
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_LOCK_PAGE'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_LOCK_PAGE'
,p_attribute_03=>'P337_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Unable to fetch row.'
,p_process_when=>'P337_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>35043326331228646
,p_process_comment=>'Generated 23-MAY-2004 21:42:53'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(35043702582228647)
,p_process_sequence=>1
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_LOCK_PAGE'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_LOCK_PAGE'
,p_attribute_03=>'P337_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Unable to process row of table WWV_FLOW_LOCK_PAGE.'
,p_process_success_message=>'Page lock processed.'
,p_security_scheme=>wwv_flow_imp.id(34674432490821717)
,p_internal_uid=>35043702582228647
,p_process_comment=>'Generated 23-MAY-2004 21:42:53'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(35044120969228648)
,p_process_sequence=>2
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'330'
,p_process_when_button_id=>wwv_flow_imp.id(35039607193228627)
,p_security_scheme=>wwv_flow_imp.id(34674432490821717)
,p_internal_uid=>35044120969228648
);
end;
/
prompt --application/pages/page_00339
begin
wwv_flow_imp_page.create_page(
 p_id=>339
,p_name=>'Delete Multiple Pages'
,p_alias=>'DELETE-MULTIPLE-PAGES1'
,p_step_title=>'Delete Multiple Pages'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_del_pg.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2822625211639047)
,p_plug_name=>'Delete Pages'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>100
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case when l.locked_by is not null and l.locked_by != :APP_USER',
'            then '' ''',
'            else HTMLDB_ITEM.CHECKBOX(1, ',
'                                    p.id,',
'                                    '''',',
'                                    null,',
'                                    '':'',',
'                                    ''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0'') ,',
'wwv_flow_lang.system_message(''PAGE_LABEL'',name) ) ',
'            end cb,',
'       p.id,',
'       name page_name,',
'       STEP_TITLE page_title,',
'       ALIAS,',
'       (select count(*) ',
'          from wwv_flow_page_plugs r ',
'         where r.page_id = p.id and r.flow_id = p.flow_id) regions,',
'       decode(REQUIRED_PATCH,null,null,(select PATCH_NAME ',
'                                          from WWV_FLOW_PATCHES b',
'                                         where b.id = p.required_patch)) build_option,',
'       TAB_SET,',
'       PAGE_IS_PUBLIC_Y_N,',
'       lower(created_by) created_by,',
'       last_updated_on last_updated,',
'       lower(last_updated_by) last_updated_by,',
'       decode(GROUP_ID, null, null, (select GROUP_NAME ',
'                                       from WWV_FLOW_PAGE_GROUPS g',
'                                      where p.group_id = g.id)) page_group,',
'       p.created_on,',
'       l.locked_by',
'  from wwv_flow_steps p,',
'       wwv_flow_lock_page l',
' where p.flow_id = :fb_flow_id',
'   and p.security_group_id = :flow_security_group_id',
'   and p.flow_id = l.flow_id (+)',
'   and p.id = l.object_id (+)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(2822731905639047)
,p_name=>'Delete Pages'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_highlight=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'N'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2822922773639050)
,p_db_column_name=>'CB'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Delete'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2823004949639051)
,p_db_column_name=>'ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2823102612639051)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2823225230639051)
,p_db_column_name=>'PAGE_TITLE'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Title'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2823312136639051)
,p_db_column_name=>'ALIAS'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Alias'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2823427832639051)
,p_db_column_name=>'REGIONS'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Regions'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2823528577639052)
,p_db_column_name=>'BUILD_OPTION'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Build Option'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2823610588639052)
,p_db_column_name=>'TAB_SET'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Tab Set'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2823705384639052)
,p_db_column_name=>'PAGE_IS_PUBLIC_Y_N'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Page is Public'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2823824066639052)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Created By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2875015332766145)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>11
,p_column_identifier=>'N'
,p_column_label=>'Created'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2823931544639052)
,p_db_column_name=>'LAST_UPDATED'
,p_display_order=>12
,p_column_identifier=>'K'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2824030107639052)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>13
,p_column_identifier=>'L'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2824113592639052)
,p_db_column_name=>'PAGE_GROUP'
,p_display_order=>14
,p_column_identifier=>'M'
,p_column_label=>'Page Group'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(25046606185745747)
,p_db_column_name=>'LOCKED_BY'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'Locked By'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(2824313975642778)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1287914434536643'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'CB:ID:PAGE_NAME:PAGE_TITLE:ALIAS:REGIONS:LOCKED_BY:CREATED_ON'
,p_sort_column_1=>'ID'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(25047605455792909)
,p_plug_name=>'Delete Multiple Pages'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>110
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Deleting a page deletes the corresponding tabs, breadcrumbs, and list entries. ',
'</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2872713292718295)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2822625211639047)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Delete Pages'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(25058619859061965)
,p_validation_name=>'must select something'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow.g_f01.count = 0',
'   then return false;',
'else return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'You must select at least one page to delete.'
,p_when_button_pressed=>wwv_flow_imp.id(2872713292718295)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2800713634820403)
,p_validation_name=>'Page not part of a component group'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count',
'loop',
'    if wwv_flow_component_group_dev.is_part_of_comp_grp (',
'           p_component_id   => to_number( wwv_flow.g_f01( i ) ),',
'           p_component_type => wwv_flow_copy_metadata.c_page,',
'           p_app_id         => :FB_FLOW_ID ) then',
'        return wwv_flow_lang.message(',
'               p_name => ''PAGE_CANT_BE_DELETED'',',
'               p0     => wwv_flow.g_f01( i ) );',
'    end if;   ',
'end loop;',
'',
'return null;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_when_button_pressed=>wwv_flow_imp.id(2872713292718295)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2875307068792146)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete pages'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count',
'loop',
'    wwv_flow_page_dev.delete_page (',
'        p_page_id                  => to_number(wwv_flow.g_f01(i)),',
'        p_application_id           => :FB_FLOW_ID );',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2872713292718295)
,p_process_success_message=>'Page(s) deleted.'
,p_internal_uid=>2875307068792146
);
end;
/
prompt --application/pages/page_00340
begin
wwv_flow_imp_page.create_page(
 p_id=>340
,p_name=>'Authorization Scheme Utilization'
,p_alias=>'AUTHORIZATION-SCHEME-UTILIZATION'
,p_step_title=>'Authorization Scheme Utilization'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(11501804013545635)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1906015152054616)
,p_plug_name=>'Filters'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>101
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(19655204688204178)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>For a component to be rendered it must pass authorization schemes placed on the component level, the page level, and at the application level.  This report lists all components within this application which have an associated authorization scheme.'
||'  </p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47956214199575140)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>91
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(180462022520306486)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Authorization Schemes'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47956823651585341)
,p_plug_name=>'Authorization Scheme Utilization'
,p_region_name=>'UTILIZATION'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>111
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select page_id, ',
'       name, ',
'       component_type, ',
'       authorization_scheme',
'  from wwv_flow_auth_scheme_usage_dev',
' where flow_id = :FB_FLOW_ID',
'   and (:P340_AUTHORIZATION_SCHEME is null ',
'    or authorization_scheme = to_char( :P340_AUTHORIZATION_SCHEME )',
'    or authorization_scheme = ''!'' || to_char( :P340_AUTHORIZATION_SCHEME ))'))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P340_AUTHORIZATION_SCHEME'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(47956924686585341)
,p_name=>'Authorization Schemes'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47957317726585362)
,p_db_column_name=>'COMPONENT_TYPE'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Component Type'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(19565023708932258)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47957222799585362)
,p_db_column_name=>'NAME'
,p_display_order=>4
,p_column_identifier=>'B'
,p_column_label=>'Component Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47957402207585363)
,p_db_column_name=>'AUTHORIZATION_SCHEME'
,p_display_order=>5
,p_column_identifier=>'D'
,p_column_label=>'Authorization Scheme'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(283664112341)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1905976407054615)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>15
,p_column_identifier=>'E'
,p_column_label=>'Page'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.:4500:FB_FLOW_PAGE_ID:#PAGE_ID#'
,p_column_linktext=>'#PAGE_ID#'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(47959101217609257)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1288018777536643'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'PAGE_ID:COMPONENT_TYPE:NAME:AUTHORIZATION_SCHEME:'
,p_sort_column_1=>'PAGE_ID'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'0'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(70568761299998703)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>121
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(62154210909909582)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1906280423054618)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1906015152054616)
,p_button_name=>'GO'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Go'
,p_warn_on_unsaved_changes=>null
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(188932628265702323)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47956823651585341)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:340:&SESSION.::&DEBUG.:340,RIR::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(8595323225122429)
,p_branch_action=>'f?p=&APP_ID.:340:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1906159221054617)
,p_name=>'P340_AUTHORIZATION_SCHEME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1906015152054616)
,p_prompt=>'Authorization Scheme'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST.SECURITY.SCHEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name, to_char(id) id',
'  from wwv_flow_security_schemes',
' where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''MUST_NOT_BE_PUBLIC_USER'' name, ''MUST_NOT_BE_PUBLIC_USER'' id',
'  from sys.dual',
' order by name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- All Authorization Schemes -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1906387530054619)
,p_name=>'Refresh Authorization Schemes'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1906280423054618)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1906402845054620)
,p_event_id=>wwv_flow_imp.id(1906387530054619)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(47956823651585341)
);
end;
/
prompt --application/pages/page_00342
begin
wwv_flow_imp_page.create_page(
 p_id=>342
,p_name=>'Steal Lock'
,p_alias=>'STEAL-LOCK'
,p_page_mode=>'MODAL'
,p_step_title=>'Steal Lock'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(24897722063538624)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'No help is available for this page.'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(932350705263198718)
,p_plug_name=>'wizard button'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--wizard'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(932375793685381903)
,p_plug_name=>'Steal Lock'
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>30
,p_plug_query_num_rows=>15
,p_plug_header=>'The lock will be stolen from the current locked by user.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(932565913341402529)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(932350705263198718)
,p_button_name=>'STEAL_LOCK'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Steal Lock'
,p_button_position=>'CREATE'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(932350949723198724)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(932350705263198718)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(932351794939198727)
,p_name=>'P342_LOCK_SCRIPT_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(932375793685381903)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(932565068738394698)
,p_name=>'P342_SCRIPT_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(932375793685381903)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Script Name'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name',
'from wwv_flow_install_scripts',
'where id = :P342_LOCK_SCRIPT_ID',
'and security_group_id = :flow_security_group_id',
'and flow_id = :fb_flow_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Name of the script that is locked.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(932565514419397753)
,p_name=>'P342_LOCK_COMMENT'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(932375793685381903)
,p_prompt=>'Comment'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>8
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Comment to be applied to the locked script.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(932567340075442874)
,p_name=>'P342_LOCKED_BY'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_imp.id(932375793685381903)
,p_prompt=>'Locked By'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_lov_display_extra=>'YES'
,p_help_text=>'The name of the developer who currently holds the script lock.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(932569185718481227)
,p_name=>'P342_LOCKED_ON'
,p_item_sequence=>37
,p_item_plug_id=>wwv_flow_imp.id(932375793685381903)
,p_prompt=>'Locked On'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_lov_display_extra=>'YES'
,p_help_text=>'The date when the script was locked.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(932351990173198731)
,p_name=>'cancel dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(932350949723198724)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(932352222213198732)
,p_event_id=>wwv_flow_imp.id(932351990173198731)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(932671798447588997)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'steal lock'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_lock.steal_lock(',
'    p_flow_id    => :FB_FLOW_ID,',
'    p_script_id  => :P342_LOCK_SCRIPT_ID,',
'    p_comment    => :P342_LOCK_COMMENT);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to steal the lock.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(932565913341402529)
,p_process_success_message=>'The lock stolen.'
,p_internal_uid=>932671798447588997
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(932842180489239150)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(932565913341402529)
,p_internal_uid=>932842180489239150
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(932568775173477906)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate script lock info items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select l.locked_by, l.locked_on',
'		   from wwv_flow_install_scripts s, wwv_flow_lock_script l',
'		   where s.id = l.script_id',
'		   and s.id = :P342_LOCK_SCRIPT_ID',
'		   and l.security_group_id = :flow_security_group_id',
'		   and l.flow_id = :fb_flow_id)',
'loop',
'	:P342_LOCKED_BY := lower(c1.locked_by);',
'	:P342_LOCKED_ON := htmldb_util.get_since(c1.locked_on);',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>932568775173477906
);
end;
/
prompt --application/pages/page_00343
begin
wwv_flow_imp_page.create_page(
 p_id=>343
,p_name=>'Create Report Template - Identify Theme'
,p_alias=>'CREATE-REPORT-TEMPLATE-IDENTIFY-THEME'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Report Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47967601898952736)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(152061404310867278)
,p_plug_name=>'Create Report Template'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<p>A Theme is a named collection of Templates.  An Application can have one or more Themes.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(152061821626867281)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(320074633987)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(152063003613867284)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47967601898952736)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(152063714231867302)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(47967601898952736)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(152063409581867301)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(47967601898952736)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(152069131260867326)
,p_branch_action=>'f?p=&FLOW_ID.:168:&SESSION.::&DEBUG.:168::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(152063714231867302)
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(589945853470621403)
,p_branch_action=>'f?p=&APP_ID.:4321:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(152063409581867301)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(152064114285867303)
,p_name=>'P343_X'
,p_item_sequence=>11
,p_item_plug_id=>wwv_flow_imp.id(152061404310867278)
,p_post_element_text=>'<br />'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(152064828426867310)
,p_name=>'P343_FROM_APP'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_imp.id(152061404310867278)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application:'
,p_source=>'F4000_P4321_COPY_FROM_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identifies the application from which the theme will be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(152065502897867312)
,p_name=>'P343_COPY_TO'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_imp.id(152061404310867278)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application:'
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identifies the application to which the template will be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(152066227803867316)
,p_name=>'P343_F'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(152061404310867278)
,p_prompt=>'Copy From:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the theme to copy from.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(152066927653867317)
,p_name=>'P343_TO'
,p_item_sequence=>12
,p_item_plug_id=>wwv_flow_imp.id(152061404310867278)
,p_prompt=>'Copy To:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the theme to which the template will be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(152067608440867319)
,p_name=>'P343_COPY_FROM_THEME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(152061404310867278)
,p_prompt=>'Theme'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(theme_name) d, theme_id',
'from   wwv_flow_themes',
'where  flow_id = :F4000_P4321_COPY_FROM_FLOW_ID',
'order by 1'))
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the theme from which you wish to copy templates.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(152068324244867320)
,p_name=>'P343_COPY_TO_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(152061404310867278)
,p_prompt=>'Theme'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the theme to which the template will be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2461600896483627038)
,p_computation_sequence=>10
,p_computation_item=>'F4000_COPY_TO_THEME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P343_COPY_TO_THEME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(589945604536621401)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(152063003613867284)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(589945733760621402)
,p_event_id=>wwv_flow_imp.id(589945604536621401)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00345
begin
wwv_flow_imp_page.create_page(
 p_id=>345
,p_name=>'Rename Standard Tab Set'
,p_alias=>'RENAME-STANDARD-TAB-SET'
,p_step_title=>'Rename Standard Tab Set'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213240607818867991)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(28924624104410484)
,p_name=>'Rename Standard Tab Set'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>121
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<a href="''',
'    ||htmldb_util.prepare_url(''f?p=4000:346:''||:flow_session||''::NO:346:P346_OLD_TABSET:''||wwv_flow_escape.html(tab_set))',
'    ||''">''||wwv_flow_escape.html(tab_set)||''</a>'' l, ',
'count(*) c ',
'from wwv_flow_tabs ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'group by tab_set'))
,p_header=>'Click the tab set name you wish to rename.<p/>'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_asc_image_attr=>' width="13" height="12" '
,p_query_desc_image=>'blue_arrow_up.gif'
,p_query_desc_image_attr=>' width="13" height="12" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48737113649771899)
,p_query_column_id=>1
,p_column_alias=>'L'
,p_column_display_sequence=>1
,p_column_heading=>'Tab Set'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48737212044771899)
,p_query_column_id=>2
,p_column_alias=>'C'
,p_column_display_sequence=>2
,p_column_heading=>'Count of Tabs'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(28926011768416383)
,p_plug_name=>'Tab Sets'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>31
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Tabs are grouped into collections called a <strong>tab set</strong>. Every tab must be part of a tab set. A tab can have a one-to-one relationship with a page, or a tab can be the "current tab" for a number of pages.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(28948631124469361)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(28924624104410484)
,p_button_name=>'cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:9000:&SESSION.::&DEBUG.:::'
);
end;
/
prompt --application/pages/page_00346
begin
wwv_flow_imp_page.create_page(
 p_id=>346
,p_name=>'Rename Standard Tab Set'
,p_alias=>'RENAME-STANDARD-TAB-SET1'
,p_step_title=>'Rename Standard Tab Set'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213240607818867991)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(28952122943476371)
,p_plug_name=>'Rename Standard Tab Set'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>121
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(29054424365129702)
,p_name=>'Tabs that Comprise Tab Set "&P346_OLD_TABSET."'
,p_template=>wwv_flow_imp.id(42025417508627628)
,p_display_sequence=>130
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'TAB_SEQUENCE, ',
'TAB_TEXT, ',
'TAB_STEP page, ',
'replace(TAB_ALSO_CURRENT_FOR_PAGES,'','','', '') tab_also_current_for_pages',
'from WWV_FLOW_TABS',
'where flow_id = :fb_flow_id ',
'and tab_set = :P346_OLD_TABSET',
'and security_group_id = :flow_security_group_id',
''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_asc_image_attr=>' width="13" height="12" '
,p_query_desc_image=>'blue_arrow_up.gif'
,p_query_desc_image_attr=>' width="13" height="12" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48961005426773306)
,p_query_column_id=>1
,p_column_alias=>'TAB_SEQUENCE'
,p_column_display_sequence=>1
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48961114580773306)
,p_query_column_id=>2
,p_column_alias=>'TAB_TEXT'
,p_column_display_sequence=>2
,p_column_heading=>'Tab'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48961228348773306)
,p_query_column_id=>3
,p_column_alias=>'PAGE'
,p_column_display_sequence=>3
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48961315681773306)
,p_query_column_id=>4
,p_column_alias=>'TAB_ALSO_CURRENT_FOR_PAGES'
,p_column_display_sequence=>4
,p_column_heading=>'Also Current for Pages'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(29072409708267400)
,p_plug_name=>'Tab Set Names'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>40
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Enter a new tab set name and click <strong>Next</strong> to confirm your request.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46527430261626586)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747140977892138160)
,p_plug_name=>'Rename Standard Tab Set'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(28954419611484907)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46527430261626586)
,p_button_name=>'cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:9000:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(28954900123484909)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(46527430261626586)
,p_button_name=>'next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(28954620319484908)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(46527430261626586)
,p_button_name=>'previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(29104828296414680)
,p_branch_action=>'347'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(28954900123484909)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(29104022409413021)
,p_branch_action=>'345'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(28954620319484908)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28956531039488244)
,p_name=>'P346_FLOW'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(28952122943476371)
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Application:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'This attribute identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28957516279493452)
,p_name=>'P346_OLD_TABSET'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(28952122943476371)
,p_prompt=>'Old Tab Set Name:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies selected old tab set name.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28958600134498243)
,p_name=>'P346_NEW_TABSET_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(28952122943476371)
,p_prompt=>'New Tab Set Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identify tab set.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(29073514210268748)
,p_validation_name=>'P346_NEW_TABSET_NAME Not Null'
,p_validation_sequence=>1
,p_validation=>'P346_NEW_TABSET_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'New Tab Set Name must be specified.'
,p_associated_item=>wwv_flow_imp.id(28958600134498243)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 04-FEB-2003 12:13'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(29419209864254529)
,p_validation_name=>'tabset not used'
,p_validation_sequence=>10
,p_validation=>'select 1 from wwv_flow_tabs where tab_set = :P346_NEW_TABSET_NAME and flow_id = :FB_FLOW_ID'
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Tabset name already used by a tabset.'
,p_associated_item=>wwv_flow_imp.id(28958600134498243)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00347
begin
wwv_flow_imp_page.create_page(
 p_id=>347
,p_name=>'Confirm Tab Set Rename'
,p_alias=>'CONFIRM-TAB-SET-RENAME'
,p_step_title=>'Rename Standard Tab Set'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213240607818867991)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
,p_page_component_map=>'11'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(29076009146276765)
,p_plug_name=>'Rename Standard Tab Set'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>100
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>You have requested to rename a standard tab set. Please confirm your request.</p>',
'<table class="htmldbStandard3" cellspacing="0" cellpadding="0" border="0" role="presentation">',
'<tr>',
'<td >Old tab set name:</td>',
'<td class="htmldbFDB">&P346_OLD_TABSET.</td>',
'</tr>',
'<tr>',
'<td>New tab set name:</td>',
'<td class="htmldbFDB">&P346_NEW_TABSET_NAME.</td>',
'</tr>',
'</table>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1119585903260190519)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(29078114376282475)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1119585903260190519)
,p_button_name=>'cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'f?p=&APP_ID.:9000:&SESSION.::&DEBUG.:::'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(29077804149282474)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1119585903260190519)
,p_button_name=>'confirm'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Rename Tab Set'
,p_button_position=>'NEXT'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(29077629232282473)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(1119585903260190519)
,p_button_name=>'previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(29106108341418454)
,p_branch_action=>'346'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(29077629232282473)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(29106716306420743)
,p_branch_action=>'9000'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>119
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(29431514282274684)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_imp_shared.rename_tabset(',
'  p_flow_id=>:FB_FLOW_ID,',
'  p_old_name=>:P346_OLD_TABSET,',
'  p_new_name=>:P346_NEW_TABSET_NAME);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error renaming tabset.'
,p_process_when_button_id=>wwv_flow_imp.id(29077804149282474)
,p_process_success_message=>'Tabset renamed.'
,p_internal_uid=>29431514282274684
);
end;
/
prompt --application/pages/page_00348
begin
wwv_flow_imp_page.create_page(
 p_id=>348
,p_name=>'Confirm Delete of Label Template'
,p_alias=>'CONFIRM-DELETE-OF-LABEL-TEMPLATE'
,p_step_title=>'Confirm Delete of Label Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(162623100482486503)
,p_plug_name=>'Confirm Delete'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>21
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(162626213988490450)
,p_name=>'Template Utilization'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>41
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select flow_step_id||'': ''||name temp_name ',
'  from wwv_flow_step_items ',
' where flow_id = :fb_flow_id ',
'   and ITEM_FIELD_TEMPLATE = :p348_id ',
' union all ',
'select ''0: Default Label Template'' temp_name',
'  from wwv_flow_themes ',
' where flow_id  = :fb_flow_id ',
'   and theme_id = :fb_theme_id',
'   and default_label_template = :p348_id ',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(11667910335347890)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No references found.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(164886307417632028)
,p_query_column_id=>1
,p_column_alias=>'TEMP_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Template Name'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(769836733955508001)
,p_plug_name=>'Confirm Delete'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>31
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(769836800315508002)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>51
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(164899914437690879)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(769836800315508002)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(164900619631692344)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(769836800315508002)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Delete'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(164901431059695672)
,p_branch_action=>'f?p=&FLOW_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(162649201830534289)
,p_name=>'P348_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(162623100482486503)
,p_prompt=>'Template:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'FIELDTEMPLATE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(template_name) d, id',
'from   wwv_flow_field_templates',
'where  flow_id = :fb_flow_id and ',
'       (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(162651009102536345)
,p_name=>'P348_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(162623100482486503)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Theme:'
,p_source=>'select theme_id from wwv_flow_field_templates where id = :p348_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identifies theme.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(162652519145539216)
,p_name=>'P348_THEME_CLASS_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(162623100482486503)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Theme Class:'
,p_source=>'select theme_class_id from wwv_flow_field_templates where id = :p348_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LABEL THEME CLASS ID'
,p_lov=>'.'||wwv_flow_imp.id(43828319065855502)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies theme class.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(164887221616636134)
,p_computation_sequence=>10
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>'select theme_id from wwv_flow_field_templates where id = :p348_id'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(164897029543685712)
,p_validation_name=>'no references '
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'for c1 in ( select count(*) counter from ',
'(select name||'' - Page ''||flow_step_id temp_name ',
'from wwv_flow_step_items ',
'where flow_id = :fb_flow_id ',
'and ITEM_FIELD_TEMPLATE = :p348_id ',
'union all ',
'select ''Default Label Template'' temp_name from wwv_flow_themes ',
'where flow_id = :fb_flow_id ',
'and default_label_template = :p348_id ',
'and theme_id = :fb_theme_id)) loop',
'if c1.counter = 0 then',
'   return true;',
'else',
'   return false;',
'end if;',
'end loop;',
'return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Can not delete template with references.'
,p_when_button_pressed=>wwv_flow_imp.id(164900619631692344)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(164914704010735174)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'delete from wwv_flow_field_templates where flow_id = :fb_flow_id and id = :p348_id;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Template not deleted.'
,p_process_when_button_id=>wwv_flow_imp.id(164900619631692344)
,p_process_success_message=>'Template deleted.'
,p_internal_uid=>164914704010735174
);
end;
/
prompt --application/pages/page_00349
begin
wwv_flow_imp_page.create_page(
 p_id=>349
,p_name=>'Create Legacy Calendar Template - Name'
,p_alias=>'CREATE-LEGACY-CALENDAR-TEMPLATE-NAME'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Legacy Calendar Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(112084125371301165)
,p_plug_name=>'Create Legacy Calendar Template'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(112084909639301168)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(106501409747300331)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(186390426401328828)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(112085307015301169)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(186390426401328828)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(112085703039301171)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(186390426401328828)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(112086122923301172)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(186390426401328828)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(112089421043301187)
,p_branch_action=>'f?p=&FLOW_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(589887780574923022)
,p_branch_action=>'f?p=&APP_ID.:161:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(112086122923301172)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(112086513801301173)
,p_name=>'P349_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(112084125371301165)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify calendar template name.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(112086918113301177)
,p_name=>'P349_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(112084125371301165)
,p_prompt=>'Theme'
,p_source=>'P4003_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies theme.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(112087327103301179)
,p_name=>'P349_THEME_CLASS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(112084125371301165)
,p_prompt=>'Theme Class'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CALENDAR THEME CLASS ID'
,p_lov=>'.'||wwv_flow_imp.id(43619531898960304)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify calendar template theme class.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(112087809540301181)
,p_validation_name=>'P349_NAME'
,p_validation_sequence=>10
,p_validation=>'P349_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(112085703039301171)
,p_associated_item=>wwv_flow_imp.id(112086513801301173)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(112088232480301182)
,p_validation_name=>'P349_THEME'
,p_validation_sequence=>20
,p_validation=>'P349_THEME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(112085703039301171)
,p_associated_item=>wwv_flow_imp.id(112086918113301177)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(112088601399301183)
,p_validation_name=>'P349_THEME_CLASS'
,p_validation_sequence=>30
,p_validation=>'P349_THEME_CLASS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(112085703039301171)
,p_associated_item=>wwv_flow_imp.id(112087327103301179)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(589887578559923020)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(112085307015301169)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(589887685585923021)
,p_event_id=>wwv_flow_imp.id(589887578559923020)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(112089032197301185)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Calendar Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_imp_shared.create_calendar_template (',
'    p_flow_id                     => :fb_flow_id,',
'    p_cal_template_name           => :p349_name,',
'    p_month_title_format          => ''<table cellspacing="0" cellpadding="0" border="0" role="presentation">',
' <tr>',
'   <td align="center" style="font-weight:bold;">#IMONTH# #YYYY#</td>',
' </tr>',
' <tr>',
' <td>'',',
'    p_day_of_week_format          => ''<th>#IDAY#</th>'',',
'    p_month_open_format           => ''<table border="1" cellpadding="1" cellspacing="1" role="presentation">'',',
'    p_month_close_format          => ''</table></td>',
'</tr>',
'</table>',
''',',
'    p_day_title_format            => ''<div>#DD#</div><br />'',',
'    p_day_open_format             => ''<td valign="top">'',',
'    p_day_close_format            => ''</td>'',',
'    p_today_open_format           => ''<td valign="top" bgcolor="#d3d3d3">'',',
'    p_weekend_title_format        => ''<div>#DD#</div>'',',
'    p_weekend_open_format         => ''<td valign="top">'',',
'    p_weekend_close_format        => ''</td>'',',
'    p_nonday_title_format         => ''<div>#DD#</div>'',',
'    p_nonday_open_format          => ''<td valign="top">'',',
'    p_nonday_close_format         => ''</td>'',',
'    p_week_title_format           => null,',
'    p_week_open_format            => ''<tr>'',',
'    p_week_close_format           => ''</tr> '',',
'    p_daily_title_format          => null,',
'    p_daily_open_format           => null,',
'    p_daily_close_format          => null,',
'    p_theme_id                    => :p349_theme,',
'    p_theme_class_id              => :p349_theme_class);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Template not created.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(112085703039301171)
,p_process_success_message=>'Template created.'
,p_internal_uid=>112089032197301185
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(589887808317923023)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(112085703039301171)
,p_process_success_message=>'Template created.'
,p_internal_uid=>589887808317923023
);
end;
/
prompt --application/pages/page_00350
begin
wwv_flow_imp_page.create_page(
 p_id=>350
,p_name=>'Create Popup Template'
,p_alias=>'CREATE-POPUP-TEMPLATE'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Popup Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(112117729525395900)
,p_plug_name=>'Create Popup Template'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(112118503768395902)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(106501409747300331)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(186391328264338847)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(112118900917395903)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(186391328264338847)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(112119332194395906)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(186391328264338847)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(112119716966395907)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(186391328264338847)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(112123024179395925)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(589888185156923026)
,p_branch_action=>'f?p=&APP_ID.:162:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(112119716966395907)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(112120124710395909)
,p_name=>'P350_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(112117729525395900)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify popup template name.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(112120507529395912)
,p_name=>'P350_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(112117729525395900)
,p_prompt=>'Theme'
,p_source=>'P4003_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify popup template theme.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(112120911351395914)
,p_name=>'P350_THEME_CLASS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(112117729525395900)
,p_prompt=>'Theme Class'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'POPUP LOV TEMPLATE THEME CLASS ID'
,p_lov=>'.'||wwv_flow_imp.id(59418530750879398)||'.'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify popup template theme class.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(112121424680395916)
,p_validation_name=>'P350_NAME'
,p_validation_sequence=>10
,p_validation=>'P350_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(112119332194395906)
,p_associated_item=>wwv_flow_imp.id(112120124710395909)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(112121800199395918)
,p_validation_name=>'P350_THEME'
,p_validation_sequence=>20
,p_validation=>'P350_THEME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(112119332194395906)
,p_associated_item=>wwv_flow_imp.id(112120507529395912)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(112122208090395919)
,p_validation_name=>'P350_THEME_CLASS'
,p_validation_sequence=>30
,p_validation=>'P350_THEME_CLASS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(112119332194395906)
,p_associated_item=>wwv_flow_imp.id(112120911351395914)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(112145520914535226)
,p_validation_name=>'no popups in selected theme'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  for c1 in ( select count(*) counter from wwv_flow_popup_lov_template where flow_id = :fb_flow_id and theme_id = :p350_theme) loop',
'  if c1.counter = 0 then ',
'    return true;',
'  else ',
'    return false;',
'  end if;',
'end loop;',
'  return true;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Popup LOV exists! Only one Popup per theme is supported.'
,p_when_button_pressed=>wwv_flow_imp.id(112119332194395906)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(589887936779923024)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(112118900917395903)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(589888085734923025)
,p_event_id=>wwv_flow_imp.id(589887936779923024)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(112122628763395922)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Popup Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_imp_shared.create_popup_lov_template (',
'    p_flow_id            => :fb_flow_id,',
'    p_popup_icon         => null,',
'    p_popup_icon_attr    => null,',
'    p_page_name          => :p350_name,',
'    p_page_title         => null,',
'    p_page_html_head     => null,',
'    p_page_body_attr     => null,',
'    p_before_field_text  => null,',
'    p_page_heading_text  => null,',
'    p_page_footer_text   => null,',
'    p_filter_width       => null,',
'    p_filter_max_width   => null,',
'    p_filter_text_attr   => null,',
'    p_find_button_text   => null,',
'    p_find_button_image  => null,',
'    p_find_button_attr   => null,',
'    p_close_button_text  => null,',
'    p_close_button_image => null,',
'    p_close_button_attr  => null,',
'    p_next_button_text   => null,',
'    p_next_button_image  => null,',
'    p_next_button_attr   => null,',
'    p_prev_button_text   => null,',
'    p_prev_button_image  => null,',
'    p_prev_button_attr   => null,',
'    p_after_field_text   => null,',
'    p_scrollbars         => null,',
'    p_resizable          => null,',
'    p_width              => null,',
'    p_height             => null,',
'    p_result_row_x_of_y  => null,',
'    p_result_rows_per_pg => null,',
'    p_before_result_set  => null,',
'    p_after_result_set   => null,',
'    p_when_no_data_found_message     => null,',
'    p_before_first_fetch_message     => null,',
'    p_minimum_characters_required    => null,',
'    p_theme_id                  => :p350_theme,',
'    p_theme_class_id            => :p350_theme_class);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Template not created.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(112119332194395906)
,p_process_success_message=>'Template created.'
,p_internal_uid=>112122628763395922
);
end;
/
prompt --application/pages/page_00353
begin
wwv_flow_imp_page.create_page(
 p_id=>353
,p_name=>'Create Item Template - Identify Theme'
,p_alias=>'CREATE-ITEM-TEMPLATE-IDENTIFY-THEME'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Item Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46355104431236089)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(152070700912872033)
,p_plug_name=>'Create Item Template'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<p>A Theme is a named collection of Templates.  An Application can have one or more Themes.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(152071105573872034)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(320074633987)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(152072315034872037)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46355104431236089)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(152073121403872040)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(46355104431236089)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(152072729986872040)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(46355104431236089)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(152078529763872051)
,p_branch_action=>'f?p=&FLOW_ID.:657:&SESSION.::&DEBUG.:657::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(152073121403872040)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(589889170720923036)
,p_branch_action=>'f?p=&APP_ID.:655:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(152072729986872040)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(152073513592872041)
,p_name=>'P353_X'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(152070700912872033)
,p_post_element_text=>'<br />'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(152074200119872043)
,p_name=>'P353_FROM_APP'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(152070700912872033)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application:'
,p_source=>'P655_COPY_FROM_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identifies the application from which the theme will be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(152074912195872044)
,p_name=>'P353_COPY_TO'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(152070700912872033)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application:'
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identifies the application to which the template will be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(152075624688872045)
,p_name=>'P353_F'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(152070700912872033)
,p_prompt=>'Copy From:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the theme to copy from.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(152076301888872047)
,p_name=>'P353_TO'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(152070700912872033)
,p_prompt=>'Copy To:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the theme to which the template will be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(152077001397872048)
,p_name=>'P353_COPY_FROM_THEME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(152070700912872033)
,p_prompt=>'Theme'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(theme_name) d, theme_id',
'from   wwv_flow_themes',
'where  flow_id = :P655_COPY_FROM_FLOW_ID ',
'order by 1'))
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the theme from which you wish to copy templates.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(152077702339872049)
,p_name=>'P353_COPY_TO_THEME'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(152070700912872033)
,p_prompt=>'Theme'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the theme to which the template will be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2346316259628914202)
,p_computation_sequence=>10
,p_computation_item=>'F4000_COPY_TO_THEME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P353_COPY_TO_THEME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(589888980609923034)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(152072315034872037)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(589889028682923035)
,p_event_id=>wwv_flow_imp.id(589888980609923034)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00358
begin
wwv_flow_imp_page.create_page(
 p_id=>358
,p_name=>'Change History'
,p_alias=>'CHANGE-HISTORY'
,p_step_title=>'Change History'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(11501804013545635)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_utilties.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47877909964995803)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(7285601119000778)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47878526316995807)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47878927519995809)
,p_plug_name=>'Change History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select   page_id,',
'         decode(audit_action,',
'         ''U'',wwv_flow_lang.system_message(''F4350.CHANGE''),',
'         ''I'',wwv_flow_lang.system_message(''F4350.CREATE''),',
'         ''D'',wwv_flow_lang.system_message(''F4350.DELETE''),',
'         ''M'',wwv_flow_lang.system_message(''F4350.MERGE''),',
'         audit_action) audit_action,',
'         developer,',
'         component_type,',
'         nvl(component_name,',
'             wwv_flow_lang.system_message(''F4350.UNKNOWN'')) as component_name,',
'         audit_date,',
'         audit_date date_of_action,',
'         audit_comment',
'from',
'(',
'select ',
'  page_id,',
'  audit_date,',
'  audit_action,',
'  t.flow_user developer,',
'  initcap(',
'  replace(replace(replace(replace(replace(replace(replace(replace(replace(',
'  replace(replace(replace(replace(t.flow_table,',
'     ''LIST_ITEMS'',''List Entry''),',
'     ''WWV_FLOWS'',''Application''),',
'     ''WWV_FLOW_'',null),''_'','' ''),',
'     ''FLOW'',''Application''),',
'     ''SECURITY SCHEMES'',''Authorization Scheme''),',
'     ''LOAD TABLES'',''Data Loading''),',
'     ''PLUGINS'',''Plug-in''),',
'     ''STEP'',''Page''),',
'     ''PLUG'',''Region''),',
'     ''OPTION'',''Entry''),',
'     ''MESSAGES$'',''Text Message''),',
'     ''MENU'',''Breadcrumb'')',
'  ) component_type,',
'  t.object_name as component_name,',
'  t.audit_comment',
'from   ',
'  wwv_flow_builder_audit_trail t',
'where  ',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_id = :fb_flow_id and',
'  t.audit_date >= (sysdate - nvl(:P358_SINCE,1))',
'  ) q'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(47879115102995816)
,p_name=>'Recent Changes'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No Changes found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47879627654995835)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>1
,p_column_identifier=>'E'
,p_column_label=>'Audit Date'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47879213576995831)
,p_db_column_name=>'AUDIT_ACTION'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>'Audit Action'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47879311218995834)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>3
,p_column_identifier=>'B'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47879430841995834)
,p_db_column_name=>'COMPONENT_TYPE'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>'Component Type'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47879516483995835)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>5
,p_column_identifier=>'D'
,p_column_label=>'Component Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47921427032680100)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(506148920133198539)
,p_db_column_name=>'DATE_OF_ACTION'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Date of Action'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(119479956067947239)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>17
,p_column_identifier=>'H'
,p_column_label=>'Comment'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(47879702005995836)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1288130074536643'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'AUDIT_DATE:PAGE_ID:AUDIT_ACTION:DEVELOPER:COMPONENT_TYPE:COMPONENT_NAME:AUDIT_COMMENT'
,p_sort_column_1=>'AUDIT_DATE'
,p_sort_direction_1=>'DESC'
,p_sort_column_2=>'0'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(47920714781667090)
,p_name=>'Filter By<br/>Recently Edited Pages'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_column=>false
,p_display_point=>'REGION_POSITION_03'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||name p, id',
'from wwv_flow_steps',
'where security_group_id = :flow_security_group_id and',
'     flow_id = :fb_flow_id',
'order by last_updated_on desc'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(11667910335347890)
,p_query_num_rows=>8
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No Pages found.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>9
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47920905426667092)
,p_query_column_id=>1
,p_column_alias=>'P'
,p_column_display_sequence=>1
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=4000:358:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID,IR_PAGE_ID:&FB_FLOW_ID.,#ID#,#ID#'
,p_column_linktext=>'#P#'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47921008570667093)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(445327224438602721)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(47878526316995807)
,p_button_name=>'P358_GO'
,p_button_static_id=>'P358_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Set'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(445325411840589586)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47878927519995809)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:358:&SESSION.::&DEBUG.:358,RIR::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(47881008850995877)
,p_branch_action=>'f?p=&APP_ID.:358:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47880019007995847)
,p_name=>'P358_SINCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(47878526316995807)
,p_item_default=>'1'
,p_prompt=>'Since'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RECENT TIME STATIC'
,p_lov=>'.'||wwv_flow_imp.id(94747000503182513)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Restrict the report to a specific time frame. Identify the amount of time to include in your report and click Set. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
end;
/
prompt --application/pages/page_00364
begin
wwv_flow_imp_page.create_page(
 p_id=>364
,p_name=>'Create Application Component'
,p_alias=>'CREATE-APPLICATION-COMPONENT'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Application Component'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_wiz.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(40391916445401575)
,p_plug_name=>'Create Shared Control'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(200340401633169901)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(40392532375406171)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(200340401633169901)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(40393019858406178)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(200340401633169901)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(40403406542483929)
,p_branch_name=>'Create List of Values'
,p_branch_action=>'f?p=&APP_ID.:137:&SESSION.::&DEBUG.:4004,4007,4014,137,138,139::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(40393019858406178)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'LOV'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(40403711044485219)
,p_branch_name=>'Create Standard Tab'
,p_branch_action=>'f?p=&APP_ID.:90:&SESSION.::&DEBUG.:92,94,95,96,4722,4723,4724::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(40393019858406178)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'STAB'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(40404014507486166)
,p_branch_name=>'Create Parent Tab'
,p_branch_action=>'f?p=&APP_ID.:4725:&SESSION.::&DEBUG.:4725,4726,4727::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(40393019858406178)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'PTAB'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(40405301132491820)
,p_branch_name=>'Create List'
,p_branch_action=>'f?p=&APP_ID.:427:&SESSION.::&DEBUG.:427::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(40393019858406178)
,p_branch_sequence=>60
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'LIST'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(40405605634493071)
,p_branch_action=>'f?p=4000:4050:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(40393019858406178)
,p_branch_sequence=>70
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'LIST_ITEM'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(40405910136494395)
,p_branch_name=>'Create Breadcrumb'
,p_branch_action=>'f?p=&APP_ID.:288:&SESSION.::&DEBUG.:288::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(40393019858406178)
,p_branch_sequence=>80
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'MENU'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(40406216024496121)
,p_branch_action=>'f?p=4000:287:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(40393019858406178)
,p_branch_sequence=>90
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'MENU_ITEM'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(40406827798499548)
,p_branch_action=>'f?p=4000:196:&SESSION.::NO:196'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(40393019858406178)
,p_branch_sequence=>110
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'WEB_SERVICE'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(40407100571501159)
,p_branch_action=>'f?p=4000:4003:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(40393019858406178)
,p_branch_sequence=>120
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'TEMPLATE'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(40407404380502220)
,p_branch_name=>'Create Build Option'
,p_branch_action=>'f?p=&APP_ID.:4911:&SESSION.::&DEBUG.:4911::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(40393019858406178)
,p_branch_sequence=>130
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'BUILD_OPT'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(40407709228503566)
,p_branch_action=>'f?p=4000:4070:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(40393019858406178)
,p_branch_sequence=>140
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'SECURITY'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(40419102181567825)
,p_branch_name=>'Create Navigation Bar Entry'
,p_branch_action=>'f?p=&APP_ID.:22:&SESSION.::&DEBUG.:22,4023,4024,4025,134,135::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(40393019858406178)
,p_branch_sequence=>150
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'NAVBAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(40423327030593952)
,p_branch_action=>'f?p=4000:4001:&SESSION.::NO:4001:FB_FLOW_ID:&FB_FLOW_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(40393019858406178)
,p_branch_sequence=>170
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'FLOW'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1155875498680661301)
,p_branch_name=>'Create Web Service Reference'
,p_branch_action=>'f?p=&APP_ID.:870:&SESSION.::&DEBUG.:565,580,585,870,871,872,873,875,REST_INPUT_PARMS,REST_OUTPUT_PARMS,REST_HTTP_HEADERS::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(40393019858406178)
,p_branch_sequence=>180
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'WS_REF'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1155876013176715575)
,p_branch_name=>'Create Report Query'
,p_branch_action=>'f?p=&APP_ID.:1110:&SESSION.::&DEBUG.:1110,1112,1113,1114,1115,1116,1117,1118,1119::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(40393019858406178)
,p_branch_sequence=>190
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'REP_QRY'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1155876934469728602)
,p_branch_name=>'Create Report Layout'
,p_branch_action=>'f?p=&APP_ID.:1401:&SESSION.::&DEBUG.:1401,1402,1406::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(40393019858406178)
,p_branch_sequence=>200
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'REP_LAYOUT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1155877516882738683)
,p_branch_name=>'Create Shortcut'
,p_branch_action=>'f?p=&APP_ID.:131:&SESSION.::&DEBUG.:131::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(40393019858406178)
,p_branch_sequence=>210
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'SHORTCUT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1155878629703759808)
,p_branch_name=>'Create Authorization Scheme'
,p_branch_action=>'f?p=&APP_ID.:184:&SESSION.::&DEBUG.:184,185,186,188::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(40393019858406178)
,p_branch_sequence=>220
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'AUTH_SCHEME'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1155879496164775394)
,p_branch_name=>'Create Text Message'
,p_branch_action=>'f?p=&APP_ID.:4009:&SESSION.::&DEBUG.:4009:P4009_MESSAGE_LANGUAGE:&P4009_MESSAGE_LANGUAGE.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(40393019858406178)
,p_branch_sequence=>230
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'TEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1155880114405787283)
,p_branch_name=>'Create Application Process'
,p_branch_action=>'f?p=&APP_ID.:147:&SESSION.::&DEBUG.:147,148,150::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(40393019858406178)
,p_branch_sequence=>240
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'APP_PROCESS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1155880907737803532)
,p_branch_name=>'Create Static Application File'
,p_branch_action=>'f?p=&APP_ID.:271:&SESSION.::&DEBUG.:271::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(40393019858406178)
,p_branch_sequence=>250
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'APP_FILE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1155881526440811728)
,p_branch_name=>'Create Static Workspace File'
,p_branch_action=>'f?p=&APP_ID.:314:&SESSION.::&DEBUG.:314::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(40393019858406178)
,p_branch_sequence=>260
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'WS_FILE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1155882191992821901)
,p_branch_name=>'Create Application Item'
,p_branch_action=>'f?p=&APP_ID.:4303:&SESSION.::&DEBUG.:4303::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(40393019858406178)
,p_branch_sequence=>270
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'APP_ITEM'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1155882661515833036)
,p_branch_name=>'Create Application Computation'
,p_branch_action=>'f?p=&APP_ID.:4304:&SESSION.::&DEBUG.:4304::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(40393019858406178)
,p_branch_sequence=>280
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'APP_COMPUTATION'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1155884294231888804)
,p_branch_name=>'Create Authentication Scheme'
,p_branch_action=>'f?p=&APP_ID.:815:&SESSION.::&DEBUG.:815, 4495::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(40393019858406178)
,p_branch_sequence=>290
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'AUTHENTICATION'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1155885383447906538)
,p_branch_name=>'Create Template'
,p_branch_action=>'f?p=&APP_ID.:162:&SESSION.::&DEBUG.:162::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(40393019858406178)
,p_branch_sequence=>300
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'TEMPLATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1155885885009914156)
,p_branch_name=>'Create Plug-in'
,p_branch_action=>'f?p=&APP_ID.:4410:&SESSION.::&DEBUG.:4410::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(40393019858406178)
,p_branch_sequence=>310
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P364_NEW'
,p_branch_condition_text=>'PLUGIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40397631944425047)
,p_name=>'P364_F'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(40391916445401575)
,p_prompt=>'Application:'
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'This attribute identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40399023680450979)
,p_name=>'P364_NEW'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(40391916445401575)
,p_item_default=>'LOV'
,p_prompt=>'Create a Shared Component for later inclusion on a page:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'NEW.FLOW.COMPONENT'
,p_lov=>'.'||wwv_flow_imp.id(56261603527740250)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Identify the type of Shared Component you wish to create.  Shared components are common elements that can display or be applied on any page within an application.<p/><p/>',
'Themes support either traditional tabs or navigation menu lists. The Parent Tab and Standard Tab options should only be used where the theme supports traditional tabs.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(574040091444616931)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(40392532375406171)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(574040150168616932)
,p_event_id=>wwv_flow_imp.id(574040091444616931)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00365
begin
wwv_flow_imp_page.create_page(
 p_id=>365
,p_name=>'Breadcrumb Utilization Report'
,p_alias=>'BREADCRUMB-UTILIZATION-REPORT'
,p_step_title=>'Breadcrumb Utilization'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213261028690930718)
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'nav_breadcrumb.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30202228732481190)
,p_plug_name=>'Breadcrumb Utilization'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  /* APEX 4000P365a */',
'       p.page_id,',
'       s.name,',
'       p.plug_name,',
'       mo.short_name,',
'       m.name menu_name,',
'       (select short_name from wwv_flow_menu_options where id = mo.parent_id) moparent',
'  from wwv_flow_menus m',
'  join wwv_flow_page_plugs p on (p.menu_id = m.id)',
'  join wwv_flow_steps s      on (s.id = p.page_id)',
'  left outer join wwv_flow_menu_options mo on (mo.menu_id = m.id and mo.page_id = p.page_id)',
' where p.flow_id           = :FB_FLOW_ID',
'   and p.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and s.flow_id           = :FB_FLOW_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(30202319058481190)
,p_name=>'Breadcrumb Utilization Report'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30202625787481195)
,p_db_column_name=>'NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Page Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30202703816481196)
,p_db_column_name=>'PLUG_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Region Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30202801547481196)
,p_db_column_name=>'SHORT_NAME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Breadcrumb Entry'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30202924453481196)
,p_db_column_name=>'MENU_NAME'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Breadcrumb Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2426900916300703)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>16
,p_column_identifier=>'H'
,p_column_label=>'Page'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE_ID#'
,p_column_linktext=>'#PAGE_ID#'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2428614102300720)
,p_db_column_name=>'MOPARENT'
,p_display_order=>26
,p_column_identifier=>'I'
,p_column_label=>'Parent Entry'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(30203321895482437)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1288215136536643'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'PAGE_ID:NAME:PLUG_NAME:MENU_NAME:SHORT_NAME:'
,p_sort_column_1=>'THE_PAGE'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(111621129766609422)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(111619820846587947)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Breadcrumbs'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(166963705763992521)
,p_name=>'Orphaned Breadcrumb Entries'
,p_template=>wwv_flow_imp.id(689970285456172024)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--flush:is-collapsed'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select m.id,',
'       m.flow_id,',
'       m.SHORT_NAME option_name,',
'       (select name',
'          from wwv_flow_menus m1',
'         where m1.id = menu_id',
'           and m1.security_group_id = m.security_group_id ) menu_name,',
'       page_id,',
'       menu_id',
'  from wwv_flow_menu_options m',
' where m.flow_id = :FB_FLOW_ID',
'   and m.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and not exists ( select 1',
'                      from wwv_flow_steps',
'                     where flow_id = m.flow_id',
'                       and security_group_id = m.security_group_id',
'                       and m.page_id = id )'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(167056300316047754)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>4
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166969521263015919)
,p_query_column_id=>2
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Flow Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166964216142992544)
,p_query_column_id=>3
,p_column_alias=>'OPTION_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Breadcrumb Entry'
,p_use_as_row_header=>'Y'
,p_column_link=>'f?p=&APP_ID.:104:&SESSION.::&DEBUG.:104:P104_ID,P104_MENU_ID:#ID#,#MENU_ID#'
,p_column_linktext=>'#OPTION_NAME#'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2427005748300704)
,p_query_column_id=>4
,p_column_alias=>'MENU_NAME'
,p_column_display_sequence=>14
,p_column_heading=>'Breadcrumb Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166964404169992544)
,p_query_column_id=>5
,p_column_alias=>'PAGE_ID'
,p_column_display_sequence=>2
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2427103947300705)
,p_query_column_id=>6
,p_column_alias=>'MENU_ID'
,p_column_display_sequence=>24
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8473756637051443)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(166963705763992521)
,p_button_name=>'DELETE_UNUSED'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Delete Unused'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_menu_options m',
' where m.flow_id = :FB_FLOW_ID',
'   and m.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and not exists ( select 1',
'                      from wwv_flow_steps',
'                     where flow_id = m.flow_id',
'                       and security_group_id = m.security_group_id',
'                       and m.page_id = id )'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(188946425746344946)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(30202228732481190)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:365:&SESSION.::&DEBUG.:365,RIR::'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(5385086238661972)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'365'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(8473880983051444)
,p_name=>'Delete Unused'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(8473756637051443)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8473965569051445)
,p_event_id=>wwv_flow_imp.id(8473880983051444)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'Do you want to delete all these breadcrumb entries associated with deleted pages? Please confirm.'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8474001731051446)
,p_event_id=>wwv_flow_imp.id(8473880983051444)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'DELETE_UNUSED'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(8474164479051447)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Unused Breadcrumb Entries'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete wwv_flow_menu_options m',
' where m.flow_id           = :FB_FLOW_ID',
'   and m.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and not exists ( select null',
'                      from wwv_flow_steps s',
'                      where s.flow_id           = m.flow_id',
'                        and s.security_group_id = m.security_group_id',
'                        and s.id                = m.page_id ); '))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(8473756637051443)
,p_process_success_message=>'Unused Breadcrumb Entries are deleted.'
,p_internal_uid=>8474164479051447
);
end;
/
prompt --application/pages/page_00368
begin
wwv_flow_imp_page.create_page(
 p_id=>368
,p_name=>'Template History'
,p_alias=>'TEMPLATE-HISTORY'
,p_step_title=>'Template History'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt_rpts.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7437102705390898)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(12437772301)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Templates'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193152223636410658)
,p_plug_name=>'Template History'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.a component_type,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from sys.dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from sys.dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from sys.dual) u,',
'  (select wwv_flow_lang.system_message(''PAGE_TEMPLATE'') a from sys.dual) t',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_TEMPLATES''',
'union',
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.a component_type,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from sys.dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from sys.dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from sys.dual) u,',
'  (select wwv_flow_lang.system_message(''CONFIRM.REGION_TEMPLATE'') a from sys.dual) t',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_PAGE_PLUG_TEMPLATES''',
'union',
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.a component_type,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from sys.dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from sys.dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from sys.dual) u,',
'  (select wwv_flow_lang.system_message(''F4000.TEMPLATE_COMPONENT'') a from sys.dual) t',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_TEMPLATE_COMPONENTS'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(193152421858410659)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193152526530410660)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193152625839410660)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Audit Comment'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193152711986410661)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Component Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193152829291410662)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193152917690410663)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Component Key'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193153022439410664)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Audit Date'
,p_column_type=>'DATE'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193153103626410664)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193169722083447990)
,p_db_column_name=>'COMPONENT_TYPE'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Component Type'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(193153232663410665)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1288304214536643'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'AUDIT_DATE:ACTION:DEVELOPER:COMPONENT_TYPE:COMPONENT_NAME'
,p_sort_column_1=>'AUDIT_DATE'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193153618573418570)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>This page displays recent modifications made to Page and Region Templates in this application.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(188986230825938608)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(193152223636410658)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:368:&SESSION.::&DEBUG.:368,RIR::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(7430130922340368)
,p_branch_action=>'368'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_00369
begin
wwv_flow_imp_page.create_page(
 p_id=>369
,p_name=>'Recent Breadcrumb Changes'
,p_alias=>'RECENT-BREADCRUMB-CHANGES'
,p_step_title=>'Breadcrumb History'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213261028690930718)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'nav_breadcrumb.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(111621726780618003)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(111619820846587947)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Breadcrumbs'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(180643301348622009)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>This page displays recent modifications made to Breadcrumb Entries in this application.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193060126557222274)
,p_plug_name=>'Breadcrumb History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P369a */',
'       t.flow_user developer, ',
'       t.audit_date,',
'       decode(audit_action,',
'              ''I'',i.a,',
'              ''D'',d.a,',
'              u.a) action,',
'       scn,',
'       audit_comment,',
'       flow_table_pk component_key,',
'       t.object_name component_name',
'  from wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
' where t.flow_ID = :FB_FLOW_ID',
'   and t.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and t.flow_table = ''WWV_FLOW_MENU_OPTIONS'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(193060302178222275)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193060428832222275)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193060516918222276)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Audit Comment'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193060628953222277)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Component Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193060728409222278)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193060803592222279)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Component Key'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193060916167222279)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Audit Date'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193061017034222280)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(193061127085222281)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1288424051536643'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'AUDIT_DATE:ACTION:DEVELOPER:COMPONENT_NAME'
,p_sort_column_1=>'AUDIT_DATE'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(188946915488351368)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(193060126557222274)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:369:&SESSION.::&DEBUG.:369,RIR::'
);
end;
/
prompt --application/pages/page_00376
begin
wwv_flow_imp_page.create_page(
 p_id=>376
,p_name=>'Validation'
,p_alias=>'VALIDATION'
,p_step_title=>'Validation'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(24897722063538624)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deployment.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(976423384825139)
,p_plug_name=>'Validation: &P376_N.'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(986905901847659)
,p_plug_name=>'Validation'
,p_region_name=>'VALIDATION'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>140
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(987613866849996)
,p_plug_name=>'Conditions'
,p_region_name=>'CONDITIONS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>150
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3171516384488337)
,p_plug_name=>'Validations'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'Use validations to ensure your application database objects and seed data can be successfully installed.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(12988913910652688)
,p_plug_name=>'Error Message'
,p_region_name=>'ERR_MSG'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>145
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46233719413678959)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>15
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(976925448825141)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(976423384825139)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:445:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(976801086825140)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(976423384825139)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(htmldb_delete_message,''DELETE'');'
,p_button_condition=>'P376_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(976706324825140)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(976423384825139)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P376_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(976626664825140)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(976423384825139)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>'P376_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(977523846825147)
,p_branch_action=>'f?p=&APP_ID.:445:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>21
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(977727157825157)
,p_name=>'P376_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(976423384825139)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(977901211825165)
,p_name=>'P376_FLOW_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(976423384825139)
,p_use_cache_before_default=>'NO'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(978308341825170)
,p_name=>'P376_INSTALL_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(976423384825139)
,p_use_cache_before_default=>'NO'
,p_source=>'INSTALL_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(978714542825171)
,p_name=>'P376_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(986905901847659)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify a name for this validation.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(979108013825172)
,p_name=>'P376_SEQUENCE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(986905901847659)
,p_use_cache_before_default=>'NO'
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select nvl(trunc(max(sequence)), 0) + 10 s',
'             from wwv_flow_install_checks ',
'            where flow_id = :FB_FLOW_ID',
'              and security_group_id = :flow_security_group_id)',
'loop',
'  return c1.s;',
'end loop;',
'return 10;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Sequence'
,p_source=>'SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>8
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the sequence for this validation. The sequence number determines the order of evaluation.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(979505692825173)
,p_name=>'P376_CHECK_TYPE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(986905901847659)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Type'
,p_source=>'CHECK_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CONDITION_LIST'
,p_named_lov=>'INSTALL_CONDITION_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(2610902469203915)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Validation Type -'
,p_lov_null_value=>'%null%'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a condition type from the list that must be met during installation before installation scripts are run.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'P376_CHECK_CONDITION'
,p_attribute_02=>'P376_CHECK_CONDITION2'
,p_attribute_04=>'P376_CHECK_CHECK'
,p_attribute_06=>'INSTALL'
,p_attribute_07=>'P376_CHECK_LANG'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(979707658825177)
,p_name=>'P376_CHECK_CONDITION'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(986905901847659)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Expression 1'
,p_source=>'CHECK_CONDITION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>8
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Use this attribute to conditionally control whether installation can continue. Enter values in this attribute based on the specific condition type selected.  Installation scripts will only be run if the specified condition is met.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(979920347825178)
,p_name=>'P376_CHECK_CONDITION2'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(986905901847659)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Expression 2'
,p_source=>'CHECK_CONDITION2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>6
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Some condition types require two expressions for comparison. Enter the second expression here.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(980330757825179)
,p_name=>'P376_FAILURE_MESSAGE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(12988913910652688)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Error Message'
,p_source=>'FAILURE_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter a message to be displayed when the conditions of this validation are not met.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(980505425825179)
,p_name=>'P376_CONDITION_TYPE'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(987613866849996)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Condition Type'
,p_source=>'CONDITION_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CONDITION_LIST'
,p_named_lov=>'INSTALL_CONDITION_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(2610902469203915)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Condition Type -'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a condition type from the list that conditionally controls whether this validation is performed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'P376_CONDITION'
,p_attribute_02=>'P376_CONDITION2'
,p_attribute_04=>'P376_CONDITION_CHECK'
,p_attribute_06=>'INSTALL'
,p_attribute_07=>'P376_CONDITION_LANG'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(980704738825180)
,p_name=>'P376_CONDITION'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(987613866849996)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Expression 1'
,p_source=>'CONDITION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>6
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter values in this attribute based on the specific condition type selected.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(980900431825192)
,p_name=>'P376_CONDITION2'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(987613866849996)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Expression 2'
,p_source=>'CONDITION2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>6
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Some condition types require two expressions for comparison. Enter the second expression here.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2319599403209541)
,p_name=>'P376_CHECK_LANG'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(986905901847659)
,p_prompt=>'Language'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select a language that is used to evaluate the entered programming code.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2319620358209542)
,p_name=>'P376_CHECK_CHECK'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(986905901847659)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Do not validate code (parse code at runtime only).'
,p_source=>'NULL'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2400212563621689)
,p_name=>'P376_CONDITION_LANG'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(987613866849996)
,p_prompt=>'Language'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select a language that is used to evaluate the entered programming code.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(66627402417442821)
,p_name=>'P376_N'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(976423384825139)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select NAME from wwv_flow_install_checks',
' where id = :P376_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_display_when=>'P376_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_help_text=>'Identifies this installation validation.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(435036115861654767)
,p_name=>'P376_CONDITION_CHECK'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(987613866849996)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Do not validate code (parse code at runtime only).'
,p_source=>'NULL'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(978926805825171)
,p_validation_name=>'P376_NAME not null'
,p_validation_sequence=>50
,p_validation=>'P376_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Name must have some value.'
,p_associated_item=>wwv_flow_imp.id(978714542825171)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(979308007825172)
,p_validation_name=>'P376_SEQUENCE not null'
,p_validation_sequence=>60
,p_validation=>'P376_SEQUENCE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Sequence must have some value.'
,p_associated_item=>wwv_flow_imp.id(979108013825172)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(12990807807660333)
,p_validation_name=>'P376_FAILURE_MESSAGE not null'
,p_validation_sequence=>70
,p_validation=>'P376_FAILURE_MESSAGE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Validation error message must be specified.'
,p_associated_item=>wwv_flow_imp.id(980330757825179)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(981320544825194)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_INSTALL_CHECKS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_INSTALL_CHECKS'
,p_attribute_03=>'P376_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Unable to process row of table WWV_FLOW_INSTALL_CHECKS.'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>981320544825194
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(981514353825195)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'376'
,p_process_when_button_id=>wwv_flow_imp.id(976801086825140)
,p_internal_uid=>981514353825195
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(981113826825193)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_INSTALL_CHECKS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_INSTALL_CHECKS'
,p_attribute_03=>'P376_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Unable to fetch row.'
,p_internal_uid=>981113826825193
);
end;
/
prompt --application/pages/page_00380
begin
wwv_flow_imp_page.create_page(
 p_id=>380
,p_name=>'Developer Comments'
,p_alias=>'DEVELOPER-COMMENTS'
,p_step_title=>'Developer Comments'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1290119987568937)
,p_plug_name=>'Application Developer Comments'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P380a */ ',
'    id, ',
'    flow_id,',
'    pages, ',
'    case when length(app_comment) > 200 then',
'        substr(app_comment,1,200)||''...''',
'    else',
'        app_comment',
'    end app_comment,',
'    created_on,',
'    created_by ',
'from',
'    WWV_FLOW_APP_COMMENTS',
'where',
'    security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(1290224695568937)
,p_name=>'Application Comments'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'C'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_detail_link=>'f?p=&APP_ID.:1236:&SESSION.::&DEBUG.:1236:P1236_ID:#ID#'
,p_detail_link_text=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="&EDIT." class="editDevComment" />'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1290432705568942)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'&nbsp;'
,p_column_link=>'javascript:popupURL(''f?p=&APP_ID.:1236:&SESSION.::&DEBUG.:1236:P1236_ID:#ID#'');'
,p_column_linktext=>'<img src="#IMAGE_PREFIX#e2.gif" border="0" alt="&EDIT." title="&EDIT.">'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1290530733568942)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1290620661568942)
,p_db_column_name=>'PAGES'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Page(s)'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1290728942568943)
,p_db_column_name=>'APP_COMMENT'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Comment'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1290831346568943)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Date Created'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1290916920568943)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(1292331949571682)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1288503444536643'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'ID:FLOW_ID:PAGES:APP_COMMENT:CREATED_ON:CREATED_BY'
,p_sort_column_1=>'CREATED_ON'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(702930329832197441)
,p_plug_name=>'Cross Application Reports'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(702923103587108064)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(131380611174316527)
,p_branch_action=>'f?p=&APP_ID.:380:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(829439611872671253)
,p_name=>'Submit Page on Create Dialog Close'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(386920635912182000)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(829439977477671287)
,p_event_id=>wwv_flow_imp.id(829439611872671253)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(829449136133674453)
,p_name=>'Submit Page on Edit/Delete Dialog Close'
,p_event_sequence=>20
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(1290119987568937)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(829449417861674455)
,p_event_id=>wwv_flow_imp.id(829449136133674453)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_02=>'Y'
);
end;
/
prompt --application/pages/page_00383
begin
wwv_flow_imp_page.create_page(
 p_id=>383
,p_name=>'Upgrade Application'
,p_alias=>'UPGRADE-APPLICATION1'
,p_step_title=>'Upgrade Application - Confirm'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(492679314807343127)
,p_plug_name=>'Wizard Menu'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(484017424976766961)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_plug_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(631657401702692346)
,p_plug_name=>'top bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(631721028330747384)
,p_plug_name=>'Confirm Upgrade'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747141278381138160)
,p_plug_name=>'Upgrade Application'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(615710003197842536)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(631657401702692346)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(493076421119174839)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(631657401702692346)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Upgrade'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(492680932512343273)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(631657401702692346)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:862:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(492682306513343396)
,p_branch_action=>'f?p=&APP_ID.:911:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(493076421119174839)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(631722209414751408)
,p_name=>'P383_V1_CNT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(631721028330747384)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Validations to be replaced with Item Settings:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*) cnt_validations ',
'  from wwv_flow_collections ',
' where collection_name = ''UPGRADE_VALIDATIONS'''))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(631722423877751409)
,p_name=>'P383_B_CNT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(631721028330747384)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Buttons to be set to Not Execute Validations:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*) cnt_buttons ',
'  from wwv_flow_collections ',
' where collection_name = ''UPGRADE_BUTTONS'''))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(631722624713751410)
,p_name=>'P383_V2_CNT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(631721028330747384)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Validations to be set to Always Execute:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*) cnt_validations2 ',
'  from wwv_flow_collections ',
' where collection_name = ''UPGRADE_VALIDATIONS2'''))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(631757815020932716)
,p_name=>'P383_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(631721028330747384)
,p_prompt=>'Page:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(492681922468343392)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Upgrade Objects'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_count number;',
'begin',
'    wwv_flow_collection.create_or_truncate_collection(',
'                      p_collection_name => ''OBJECTS_NOT_UPGRADED'');',
'   wwv_flow_upgrade_app.update_advanced (',
'       p_flow_id   => :FB_FLOW_ID,',
'       p_page_id   => :P383_PAGE_ID );',
'',
'    select count(*) into l_count ',
'      from wwv_flow_collections where collection_name = ''OBJECTS_NOT_UPGRADED'';',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to Upgrade selected Object(s).'
,p_process_when_button_id=>wwv_flow_imp.id(493076421119174839)
,p_process_success_message=>'Selected Object(s) Upgraded successfully.'
,p_internal_uid=>492681922468343392
);
end;
/
prompt --application/pages/page_00385
begin
wwv_flow_imp_page.create_page(
 p_id=>385
,p_name=>'Seed and Publish Translatable Text'
,p_alias=>'SEED-AND-PUBLISH-TRANSLATABLE-TEXT'
,p_step_title=>'Seed and Publish Translatable Text'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213331522315193801)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'global_process.htm'
,p_page_component_map=>'01'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(543179732397973700)
,p_name=>'Seed Translatable Text'
,p_template=>wwv_flow_imp.id(208928010704475743)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select m.id,',
'       m.primary_language_flow_id,',
'       m.translation_flow_id,',
'       m.translation_flow_language_code,',
'       tt.translatable_strings,',
'       tt.distinct_string_estimate,',
'       coalesce(',
'           ( select case when sign( app_diff.difference ) = -1',
'                        then ''Y''',
'                        else ''N''',
'                    end',
'               from (',
'                   select f2.created_on - f1.last_updated_on difference,',
'                          f2.id translated_app_id',
'                     from wwv_flows f1, wwv_flows f2',
'                    where f1.security_group_id = f2.security_group_id',
'                      and f1.id = m.primary_language_flow_id',
'                      and f2.id = m.translation_flow_id',
'                      and f1.id = :FB_FLOW_ID',
'                      and f1.security_group_id = :flow_security_group_id ) app_diff',
'              where app_diff.translated_app_id = m.translation_flow_id ),',
'            ''Y'') requires_synchronization,',
'       (select created_on',
'          from wwv_flows f',
'         where f.id = m.translation_flow_id',
'           and security_group_id = :flow_security_group_id ) translation_created',
'from wwv_flow_language_map m,',
'     (select count(*) translatable_strings,',
'             count(distinct sys.dbms_lob.substr(t.translate_from_text,1000,1)) distinct_string_estimate,',
'             t.translated_flow_id',
'        from wwv_flow_translatable_text$ t',
'       where t.security_group_id = :flow_security_group_id',
'         and t.flow_id = :fb_flow_id',
'       group by t.translated_flow_id) tt',
'where m.primary_language_flow_id = :fb_flow_id',
'  and m.security_group_id = :flow_security_group_id',
'  and tt.translated_flow_id (+)= m.translation_flow_id'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No translation mappings defined.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(543180021193973703)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_pk_col_source_type=>'T'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_ref_table_name=>'WWV_FLOW_LANGUAGE_MAP'
,p_ref_column_name=>'ID'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(543180107482973703)
,p_query_column_id=>2
,p_column_alias=>'PRIMARY_LANGUAGE_FLOW_ID'
,p_column_display_sequence=>4
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
,p_ref_schema=>'APEX_040200'
,p_ref_table_name=>'WWV_FLOW_LANGUAGE_MAP'
,p_ref_column_name=>'PRIMARY_LANGUAGE_FLOW_ID'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(543180217425973703)
,p_query_column_id=>3
,p_column_alias=>'TRANSLATION_FLOW_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Translated Application'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040200'
,p_ref_table_name=>'WWV_FLOW_LANGUAGE_MAP'
,p_ref_column_name=>'TRANSLATION_FLOW_ID'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(546196128741402106)
,p_query_column_id=>4
,p_column_alias=>'TRANSLATION_FLOW_LANGUAGE_CODE'
,p_column_display_sequence=>5
,p_column_heading=>'Language'
,p_use_as_row_header=>'Y'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(107899321117195063)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(547329826127708872)
,p_query_column_id=>5
,p_column_alias=>'TRANSLATABLE_STRINGS'
,p_column_display_sequence=>7
,p_column_heading=>'Strings'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(547329912295708872)
,p_query_column_id=>6
,p_column_alias=>'DISTINCT_STRING_ESTIMATE'
,p_column_display_sequence=>8
,p_column_heading=>'Distinct Strings'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(745728014438047227)
,p_query_column_id=>7
,p_column_alias=>'REQUIRES_SYNCHRONIZATION'
,p_column_display_sequence=>9
,p_column_heading=>'Requires Synchronization'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(84259319526460470)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(546655907173533417)
,p_query_column_id=>8
,p_column_alias=>'TRANSLATION_CREATED'
,p_column_display_sequence=>6
,p_column_heading=>'Published'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(544092226865047804)
,p_query_column_id=>9
,p_column_alias=>'CHECK$01'
,p_column_display_sequence=>1
,p_column_heading=>'Select Row'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'CHECKBOX'
,p_derived_column=>'Y'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(543312111534986540)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(543312226141986546)
,p_column_sequence=>2
,p_query_column_name=>'PRIMARY_LANGUAGE_FLOW_ID'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(543312331118986546)
,p_column_sequence=>3
,p_query_column_name=>'TRANSLATION_FLOW_ID'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(546196010161402105)
,p_column_sequence=>4
,p_query_column_name=>'TRANSLATION_FLOW_LANGUAGE_CODE'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(547329404312708868)
,p_column_sequence=>5
,p_query_column_name=>'TRANSLATABLE_STRINGS'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(547329509903708868)
,p_column_sequence=>6
,p_query_column_name=>'DISTINCT_STRING_ESTIMATE'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(745727821883047224)
,p_column_sequence=>7
,p_query_column_name=>'REQUIRES_SYNCHRONIZATION'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(546655713309533414)
,p_column_sequence=>8
,p_query_column_name=>'TRANSLATION_CREATED'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(544359011806081262)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(684188213520699939)
,p_plug_name=>'Publish'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The publish process will create a translated version of your application, combining the application definition of the primary language with the translated text from the translation text repository.',
'<p />',
'When any modification is made to your primary application, perform the "Seed" and "Publish" operations to recreate an updated version of your translated application(s).'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(684280303524725394)
,p_plug_name=>'Seed'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'Seeding the translation copies all translatable text into the translation text repository. Once the translatable text is seeded, you can begin the process of translating the text strings. '
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(739718405174507479)
,p_plug_name=>'Download'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'After seeding the translatable text, the XLIFF translation files can be downloaded for translation.  These files should remain encoded in UTF-8.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(162452530474645087)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(544359011806081262)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:4761:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(545681517852319631)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(544359011806081262)
,p_button_name=>'SEED'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Seed'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>':P385_ACTION = ''PUBLISH'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_css_classes=>'seed_btn'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(546875313508554884)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(544359011806081262)
,p_button_name=>'PUBLISH'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Publish'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>':P385_ACTION = ''SEED'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_css_classes=>'publish_btn'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(739516315993491691)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(544359011806081262)
,p_button_name=>'DOWNLOAD'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'Download'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:4750:&SESSION.::&DEBUG.:4750::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(683004802944583352)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(544359011806081262)
,p_button_name=>'SEED_HOT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Seed'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>':P385_ACTION = ''SEED'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_css_classes=>'seed_btn'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(683019810562585532)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(544359011806081262)
,p_button_name=>'PUBLISH_HOT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Publish'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>':P385_ACTION = ''PUBLISH'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_css_classes=>'publish_btn'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(162453400607655379)
,p_branch_action=>'f?p=&APP_ID.:385:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(162455006064675934)
,p_name=>'P385_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(544359011806081262)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Primary Language Application:'
,p_source=>':FB_FLOW_ID'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_help_text=>'The primary language to be translated from.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(682892320128578847)
,p_name=>'P385_ACTION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(543179732397973700)
,p_source=>'SEED'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(206352875617953001)
,p_name=>'Seed'
,p_event_sequence=>10
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'.seed_btn'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(206352976312953002)
,p_event_id=>wwv_flow_imp.id(206352875617953001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'SEED'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(206353023246953003)
,p_name=>'Publish'
,p_event_sequence=>20
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'.publish_btn'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(206353107024953004)
,p_event_id=>wwv_flow_imp.id(206353023246953003)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'PUBLISH'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(545420131479257324)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(543179732397973700)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Seed Translatable Text'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for lang_map in (',
'    select translation_flow_language_code',
'      from wwv_flow_language_map',
'     where id = :ID',
'       and security_group_id = :WORKSPACE_ID )',
'loop',
'    ',
'    wwv_flow_translation_utilities.seed_translations (',
'        p_flow_id     => :FB_FLOW_ID,',
'        p_language    => lang_map.translation_flow_language_code,',
'        p_insert_only => ''NO'');',
'',
'    exit;',
'',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error seeding translatable text.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'(:APEX$ROW_SELECTOR = ''X'' and :REQUEST in (''SEED'',''SEED_HOT''))'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_exec_cond_for_each_row=>'Y'
,p_only_for_changed_rows=>'N'
,p_process_success_message=>'Successfully seeded translatable text.'
,p_internal_uid=>545420131479257324
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(546982023944586238)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(543179732397973700)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Publish Translated Versions'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for lang_map in (',
'    select translation_flow_id,',
'           security_group_id',
'      from wwv_flow_language_map',
'     where id = :ID',
'       and security_group_id = :WORKSPACE_ID )',
'loop',
'',
'    wwv_flow_translation_utilities.publish_application (',
'        p_from_flow_id       => :FB_FLOW_ID,',
'        p_translated_flow_id => lang_map.translation_flow_id,',
'        p_security_group_id  => lang_map.security_group_id );',
'',
'    exit;',
'',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error publishing application(s).'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'(:APEX$ROW_SELECTOR = ''X'' and :REQUEST in (''PUBLISH'',''PUBLISH_HOT''))'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_exec_cond_for_each_row=>'Y'
,p_only_for_changed_rows=>'N'
,p_process_success_message=>'Successfully published application(s).'
,p_internal_uid=>546982023944586238
);
end;
/
prompt --application/pages/page_00386
begin
wwv_flow_imp_page.create_page(
 p_id=>386
,p_name=>'Switch Theme - Verify Compatibility'
,p_alias=>'SWITCH-THEME-VERIFY-COMPATIBILITY'
,p_step_title=>'Switch Theme - Verify Compatibility'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879423075323511)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_themes.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(20668725093610407)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(20663215911569971)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(59328013164429554)
,p_plug_name=>'Switch Theme'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">When you switch to a new theme, App Builder maps all currently used templates to a template in the new theme using the template class. This report displays these template mappings and allow for selecting alternate templat'
||'es when no templates with a matching template class exist.</div>',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(121204124843870496)
,p_name=>'Theme Compatibility'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_column=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'',
'select   decode(temp_type,',
'  ''PAGE'',wwv_flow_lang.system_message_lit(''F4000.PAGE''),',
'  ''REGION'',wwv_flow_lang.system_message_lit(''F4000.REGION''),',
'  ''LABEL'',wwv_flow_lang.system_message_lit(''LABEL''),',
'  ''LIST'',wwv_flow_lang.system_message_lit(''F4000.LIST_INITCAP''),',
'  ''POPUP_LOV'',wwv_flow_lang.system_message_lit(''F4000.P371.POPUP_LOV''),',
'  ''CALENDAR'',wwv_flow_lang.system_message_lit(''LEGACY_CALENDAR''),',
'  ''MENU'',wwv_flow_lang.system_message_lit(''F4000.MENU''),',
'  ''BUTTON'',wwv_flow_lang.system_message_lit(''F4000.BUTTON''),',
'  ''REPORT'',wwv_flow_lang.system_message_lit(''REPORT''),',
'  ''POPUP_LOV'',wwv_flow_lang.system_message_lit(''F4000.P371.POPUP_LOV''),',
'  ''trans-''||temp_type) temp_type, ',
'       theme_class_id ,',
'       from_template, ',
'       CASE',
'         when to_counter  > 1 then',
'             htmldb_item.hidden(1,id)||',
'             htmldb_item.hidden(2,temp_type)||',
'             HTMLDB_ITEM.SELECT_LIST_FROM_QUERY(',
'                 /*p_idx        =>*/ 3,',
'                 /*p_value      =>*/ wwv_flow_templates_util.get_default_template_id(',
'                                         p_flow_id => :fb_flow_id, ',
'                                         p_theme_id => :p179_new_theme, ',
'                                         p_template_type => temp_type',
'                                     ),',
'                 /*p_query      =>*/ ''SELECT name,id ',
'                                    FROM wwv_flow_templates_all ',
'                                   WHERE flow_id=:fb_flow_id''||',
'                                   '' AND theme_id = :p179_new_theme and (:P179_MATCHING_TEMPLATES_ONLY=''''N'''' or theme_class_id = ''||u.theme_class_id|| '')'' ||',
'                                   '' AND temp_type = ''''''||u.temp_type||'''''''',',
'                 /*p_attributes =>*/ ''title="''||wwv_flow_lang.system_message(''F4000.P622.TO_TEMPLATE'')||''"'',',
'                 /*p_show_null  =>*/ ''NO'',',
'                 /*p_null_value =>*/ ''%null%'',',
'                 /*p_null_text  =>*/ ''%'',',
'                 /*p_item_id    =>*/ null,',
'                 /*p_item_label =>*/ null,',
'                 /*p_show_extra =>*/ ''NO'' )',
'         when to_counter = 1 then',
'             htmldb_item.hidden(1,id)||',
'             htmldb_item.hidden(2,temp_type)||',
'             HTMLDB_ITEM.SELECT_LIST_FROM_QUERY(',
'                 /*p_idx        =>*/ 3,',
'                 /*p_value      =>*/ (select id ',
'                                    from wwv_flow_templates_all ',
'                                   where flow_id = :fb_flow_id ',
'                                     and theme_id = :p179_new_theme ',
'                                     and theme_class_id = u.THEME_CLASS_ID ',
'                                     and temp_type = u.TEMP_TYPE ',
'                                     and rownum = 1',
'                                 ),',
'                 /*p_query      =>*/ ''SELECT name,id ',
'                                    FROM wwv_flow_templates_all ',
'                                   WHERE flow_id=:fb_flow_id''||',
'                                   '' AND theme_id = :p179_new_theme and (:P179_MATCHING_TEMPLATES_ONLY=''''N'''' or theme_class_id = ''||u.theme_class_id|| '')'' ||',
'                                   '' AND temp_type = ''''''||u.temp_type||'''''''',',
'                 /*p_attributes =>*/ ''title="''||wwv_flow_lang.system_message(''F4000.P622.TO_TEMPLATE'')||''"'',',
'                 /*p_show_null  =>*/ ''NO'',',
'                 /*p_null_value =>*/ ''%null%'',',
'                 /*p_null_text  =>*/ ''%'',',
'                 /*p_item_id    =>*/ null,',
'                 /*p_item_label =>*/ null,',
'                 /*p_show_extra =>*/ ''NO'' )',
'         when to_counter = 0 then',
'             htmldb_item.hidden(1,id)||',
'             htmldb_item.hidden(2,temp_type)||',
'             HTMLDB_ITEM.SELECT_LIST_FROM_QUERY(',
'                 /*p_idx        =>*/ 3,',
'                 /*p_value      =>*/ wwv_flow_templates_util.get_default_template_id(',
'                                         p_flow_id => :fb_flow_id, ',
'                                         p_theme_id => :p179_new_theme, ',
'                                         p_template_type => temp_type',
'                                     ),',
'                 /*p_query      =>*/ ''SELECT name,id ',
'                                    FROM wwv_flow_templates_all ',
'                                   WHERE flow_id=:fb_flow_id''||',
'                                   '' AND theme_id = :p179_new_theme ''||',
'                                   '' AND temp_type = ''''''||u.temp_type||'''''''',',
'                 /*p_attributes =>*/ ''title="''||wwv_flow_lang.system_message(''F4000.P622.TO_TEMPLATE'')||''"'',',
'                 /*p_show_null  =>*/ ''NO'',',
'                 /*p_null_value =>*/ ''%null%'',',
'                 /*p_null_text  =>*/ ''%'',',
'                 /*p_item_id    =>*/ null,',
'                 /*p_item_label =>*/ null,',
'                 /*p_show_extra =>*/ ''NO'' )',
'       end lov, ',
'       CASE',
'         when to_counter > 1 then',
'             wwv_flow_lang.system_message_lit(''WARNING_MULTIPLE_MATCHES'')',
'         when to_counter = 1 then',
'           ''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''THEME.COMPATIBLE'')||''</span>''                                                          ',
'         when to_counter = 0 then',
'             wwv_flow_lang.system_message_lit(''WARNING_MISSING_CLASS'')',
'       end status',
' from ',
'( select distinct u.id,',
'           u.temp_type,',
'       u.theme_class_id ,',
'       u.name from_template, ',
'      (select count(*) xx from wwv_flow_templates_all where flow_id = :fb_flow_id and theme_id = :p179_new_theme and theme_class_id = u.THEME_CLASS_ID and temp_type = u.TEMP_TYPE) to_counter',
' from wwv_flow_templates_used u',
' where u.flow_id = :fb_flow_id',
' and u.theme_id = :p179_old_theme  ',
') u'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_type=>'ROWS_X_TO_Y'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'( select u.id,',
'  		 u.temp_type,',
'	   u.theme_class_id ,',
'	   u.name from_template, ',
'      (select count(*) xx from wwv_flow_templates_all where flow_id = :fb_flow_id and theme_id = :p179_new_theme and theme_class_id = u.THEME_CLASS_ID and temp_type = u.TEMP_TYPE) to_counter',
' from wwv_flow_templates_used u',
' where u.flow_id = :fb_flow_id ',
'  group by u.id,u.temp_type,',
'	   u.theme_class_id ,',
'	   u.name) u 	 '))
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(121204418996870526)
,p_query_column_id=>1
,p_column_alias=>'TEMP_TYPE'
,p_column_display_sequence=>1
,p_column_heading=>'Template Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(121204531498870529)
,p_query_column_id=>2
,p_column_alias=>'THEME_CLASS_ID'
,p_column_display_sequence=>2
,p_column_heading=>'Template Class'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(121204606152870529)
,p_query_column_id=>3
,p_column_alias=>'FROM_TEMPLATE'
,p_column_display_sequence=>3
,p_column_heading=>'From Template'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(121204811448870529)
,p_query_column_id=>4
,p_column_alias=>'LOV'
,p_column_display_sequence=>4
,p_column_heading=>'To Template'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(887629171909273326)
,p_query_column_id=>5
,p_column_alias=>'STATUS'
,p_column_display_sequence=>5
,p_column_heading=>'Status'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(200240121308295637)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(534066036689421417)
,p_plug_name=>'Warning'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--warning:a-Alert--horizontal'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>10
,p_plug_source=>'<strong>Please note that when switching from a theme using tabs to a theme using navigation menu lists, your application will be modified to support list based navigation. This includes migrating your tabs to a navigation menu list.</strong>'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_theme_manager.is_navigation_upgrade (',
'  p_flow_id    => :fb_flow_id,',
'  p_from_theme => :P179_OLD_THEME,',
'  p_to_theme   => :P179_NEW_THEME ',
')'))
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML',
  'show_line_breaks', 'N')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747141364450138161)
,p_plug_name=>'Switch Theme'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(59328819397431364)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(200240121308295637)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(59329520382431368)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(200240121308295637)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'for c1 in (select distinct u.id,',
'  		 u.temp_type,',
'	   u.theme_class_id ,',
'	   u.name from_template, ',
'      (select count(*) xx from wwv_flow_templates_all where flow_id = :fb_flow_id and theme_id = :p179_new_theme and temp_type = u.TEMP_TYPE) to_counter',
' from wwv_flow_templates_used u',
' where u.flow_id = :fb_flow_id) loop',
'if c1.to_counter = 0 then',
'   return true; ',
'end if;',
'end loop;',
'return true;',
'end;'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'FUNCTION_BODY'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(59329127894431367)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(200240121308295637)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:179:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(59330423899432629)
,p_branch_action=>'f?p=&APP_ID.:180:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(60063407396112165)
,p_name=>'P386_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(59328013164429554)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application:'
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'This attribute identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(60064519517115645)
,p_name=>'P386_ACTIVE_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(59328013164429554)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Currently Active Theme:'
,p_source=>'P179_OLD_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identifies a collection of templates which define the look and feel of the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(60067525189126702)
,p_name=>'P386_NEW_THEME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(59328013164429554)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Switch to Theme:'
,p_source=>'P179_NEW_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identifies a collection of templates which define the look and feel of the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(140793710305110434)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Handle Mapping'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'htmldb_collection.create_or_truncate_collection(p_collection_name => ''TEMPLATES'');',
'for i in 1..HTMLDB_APPLICATION.G_F01.count loop',
'  htmldb_collection.add_member(',
'    p_collection_name   => ''TEMPLATES'',',
'    p_c001              => HTMLDB_APPLICATION.G_F01(i),',
'    p_c002              => HTMLDB_APPLICATION.G_F02(i),',
'    p_c003              => HTMLDB_APPLICATION.G_F03(i),',
'    p_generate_md5      => ''YES'' );',
'end loop;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(59329520382431368)
,p_internal_uid=>140793710305110434
);
end;
/
prompt --application/pages/page_00390
begin
wwv_flow_imp_page.create_page(
 p_id=>390
,p_name=>'Edit Item Help'
,p_alias=>'EDIT-ITEM-HELP'
,p_step_title=>'Edit Item Help'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_item_pg_edit.htm'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(36852207337230693)
,p_plug_name=>'Edit Item Help'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(36861402058248073)
,p_plug_name=>' Edit Item Help'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_04'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(36923815554526450)
,p_plug_name=>'Subscription'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  i number := null;',
'  c number := 0;',
'begin',
'for c1 in (select reference_id ',
'           from wwv_flow_step_item_help ',
'           where flow_item_id = :P390_FLOW_ITEM_ID) loop',
'   i := c1.reference_id;',
'end loop;',
'',
'if i is not null then',
'  for c1 in (select flow_id, name ',
'             from wwv_flow_step_items',
'             where  id = i) loop',
'    sys.htp.p(''<div class="htmldbFieldTitleLeft">''||wwv_flow_lang.system_message(''SUBSCRIBE_ITEM_HELP.COPIED_FROM'')||'': ''||',
'          ''<strong>''||c1.flow_id||'', ''||wwv_flow_escape.html(c1.name)||''</strong></div><br />'');',
'  end loop;',
'else',
'    sys.htp.p(''<div class="htmldbFieldTitleLeft">''||wwv_flow_lang.system_message(''SUBSCRIBE_ITEM_HELP.MASTER'')||''</div><br />'');',
'end if;',
'',
'for c1 in (select i.flow_id, i.name ',
'             from wwv_flow_step_items i, wwv_flow_step_item_help h ',
'            where i.id = h.flow_item_id',
'            and h.reference_id = :P390_FLOW_ITEM_ID',
'            order by flow_id) loop',
'   c := c + 1;',
'   if c = 1 then',
'      sys.htp.p(''<div class="htmldbFieldTitleLeft">''||wwv_flow_lang.system_message(''SUBSCRIBE_ITEM_HELP.REFERENCE'')||'':</div><br />'');',
'      sys.htp.p(''<ul>'');',
'   end if;',
'   sys.htp.p(''<li> ''||c1.flow_id||'' - ''||',
'         wwv_flow_escape.html(c1.name)||''</li>'');',
'end loop;',
'if i is not null then',
'  sys.htp.p(''</ul>'');',
'end if;  ',
'',
'if c = 0 then',
'   if i is not null then',
'      sys.htp.p(''<br />'');',
'   end if;',
'   sys.htp.p(''<div class="htmldbFieldTitleLeft">''||',
'         wwv_flow_lang.system_message(''SUBSCRIBE_ITEM_HELP.NO_SUBSCRIPTION'')||',
'         ''</div>'');',
'end if;',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1059810786703457644)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(36949401674645381)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(36923815554526450)
,p_button_name=>'COPY_ITEM_HELP'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Refresh Item Help'
,p_button_position=>'CLOSE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_step_item_help',
'where flow_item_id = :P390_FLOW_ITEM_ID',
'and reference_id is not null'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(36947906953628051)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(36923815554526450)
,p_button_name=>'PUBLISH_ITEM_HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'Publish Item Help'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:449:&SESSION.::&DEBUG.::P449_ID,P449_PAGE_ID:&P390_FLOW_ITEM_ID.,&FLOW_PAGE_ID.'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_step_item_help',
'where reference_id = :P390_FLOW_ITEM_ID'))
,p_button_condition_type=>'EXISTS'
,p_icon_css_classes=>'i icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1059810375686457640)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(36861402058248073)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:389:&SESSION.::&DEBUG.:RP:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(36867307037259054)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(36861402058248073)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1059810627961457643)
,p_branch_name=>'Go to Page 389'
,p_branch_action=>'f?p=&APP_ID.:389:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(36867307037259054)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(36867612564259060)
,p_branch_name=>'Go To Page 390'
,p_branch_action=>'f?p=&FLOW_ID.:390:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(36856901234238370)
,p_name=>'P390_FLOW'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(36852207337230693)
,p_prompt=>'Application:'
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(36857807814240334)
,p_name=>'P390_PAGE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(36852207337230693)
,p_prompt=>'Page:'
,p_source=>'FB_FLOW_PAGE_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies the page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(36871026215274063)
,p_name=>'P390_PAGE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(36852207337230693)
,p_use_cache_before_default=>'NO'
,p_prompt=>'New'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select NAME',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID',
'and id = :FB_FLOW_PAGE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies name of the page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(36878010594316856)
,p_name=>'P390_ITEM'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(36852207337230693)
,p_prompt=>'Item:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select NAME',
'from wwv_flow_step_items',
'where flow_id = :FB_FLOW_ID',
'and FLOW_STEP_ID = :FB_FLOW_PAGE_ID',
'and id = :P390_FLOW_ITEM_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies the item name.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(36879319036328685)
,p_name=>'P390_FLOW_ITEM_ID'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_imp.id(36852207337230693)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(36892921254414540)
,p_name=>'P390_ITEM_LABEL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(36852207337230693)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Label:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select PROMPT',
'from wwv_flow_step_items',
'where flow_id = :FB_FLOW_ID and',
'flow_step_id = :FB_FLOW_PAGE_ID and',
'id = :P390_FLOW_ITEM_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies the item label.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(36895615844422381)
,p_name=>'P390_DISPLAY_AS'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(36852207337230693)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_as',
'from wwv_flow_step_items',
'where flow_id = :FB_FLOW_ID',
'and flow_step_id = :FB_FLOW_PAGE_ID',
'and id = :P390_FLOW_ITEM_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies the display method.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(36899723941434261)
,p_name=>'P390_HELP_TEXT'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(36852207337230693)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Help Text'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select HELP_TEXT',
'from wwv_flow_step_item_help',
'where flow_id = :fb_flow_id',
'and flow_item_id = :P390_FLOW_ITEM_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>32767
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'Specify item help text.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(36927826767539161)
,p_name=>'P390_REFERENCE_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(36923815554526450)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Reference Master Item Help From'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select REFERENCE_ID',
'from wwv_flow_step_item_help',
'where flow_id = :fb_flow_id',
'and flow_item_id = :P390_FLOW_ITEM_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FLOW_SUBSCRIBE_FROM_ITEM_HELP'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||',
'lower(wwv_flow_lang.system_message(''NO_ITEM''))||',
''' -''  d, 0 r from dual union all',
'select i.flow_id||'' : ''||i.name d, i.id r',
'from   wwv_flow_step_items i, wwv_flow_step_item_help h',
'where  i.id = h.flow_item_id',
'and i.flow_id = nvl(:fb_flow_id,0) and i.flow_id in (',
'select f.id',
'from   wwv_main_apps_dev f',
'where  security_group_id = :flow_security_group_id and',
'       build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') and',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id is null and security_group_id = :flow_security_group_id)',
'       or',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id = f.id and security_group_id = :flow_security_group_id )',
')',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'You may base the item help text on an existing item help text in this application or another application. You would then be a subscriber of that item help text. Just find a item you want to use, then press apply. A copy of the item help text is now a'
||'vailable for you to augment for your purposes. A refresh button is available for you to use to grab a new copy of the master item help text whenever you need to. Of course, you''ll have to make any changes to it that you might require.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(36951510462657423)
,p_name=>'P390_REFRESH'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(36923815554526450)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Refresh'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(37498226080133126)
,p_name=>'P390_ID'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_imp.id(36852207337230693)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(36960804023740741)
,p_validation_name=>'reference is not null'
,p_validation_sequence=>10
,p_validation=>'P390_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Reference ID must be specified to refresh the item help.'
,p_when_button_pressed=>wwv_flow_imp.id(36949401674645381)
,p_associated_item=>wwv_flow_imp.id(36927826767539161)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(36961623416746316)
,p_validation_name=>'reference id not zero'
,p_validation_sequence=>10
,p_validation=>'P390_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_ZERO'
,p_error_message=>'Item must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(36949401674645381)
,p_associated_item=>wwv_flow_imp.id(36927826767539161)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(40180022010393826)
,p_name=>'P390_HELP_TEXT'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P390_REFERENCE_ID'
,p_condition_element=>'P390_REFERENCE_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(40180131145393826)
,p_event_id=>wwv_flow_imp.id(40180022010393826)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P390_HELP_TEXT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(40180220823393826)
,p_event_id=>wwv_flow_imp.id(40180022010393826)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P390_HELP_TEXT'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(37065414833067166)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh Item Help 1'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_item_help (',
'    p_master_item_id         => :P390_REFERENCE_ID,',
'    p_subscribing_item_id    => :P390_FLOW_ITEM_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying item help.'
,p_process_when_button_id=>wwv_flow_imp.id(36949401674645381)
,p_process_when=>'P390_REFERENCE_ID'
,p_process_when_type=>'ITEM_IS_NOT_ZERO'
,p_process_success_message=>'Item help copied.'
,p_internal_uid=>37065414833067166
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(37989107350881957)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'process item help text'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'update wwv_flow_step_item_help',
'set  help_text = :P390_HELP_TEXT ',
'where  flow_item_id = :P390_FLOW_ITEM_ID',
'and flow_id = :FB_FLOW_ID; ',
'',
'--',
'-- if the item does not have any help text, insert ',
'--',
'if SQL%ROWCOUNT = 0 then',
'   -- delete any existing item help',
'   delete from wwv_flow_step_item_help',
'   where flow_item_id = :P390_FLOW_ITEM_ID',
'   and flow_id = :FB_FLOW_ID; ',
'   ',
'   insert into wwv_flow_step_item_help',
'      (flow_id,',
'       flow_item_id,',
'       help_text)',
'      values ',
'      (:FB_FLOW_ID,',
'       :P390_FLOW_ITEM_ID,',
'       :P390_HELP_TEXT);',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error processing item help.'
,p_process_when=>'COPY_ITEM_HELP'
,p_process_when_type=>'REQUEST_NOT_IN_CONDITION'
,p_process_success_message=>'Application &FB_FLOW_ID. item &P390_ITEM. help text processed.'
,p_internal_uid=>37989107350881957
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(37070826916117922)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh item help 2'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_item_help (',
'    p_master_item_id         => :P390_REFERENCE_ID,',
'    p_subscribing_item_id    => :P390_FLOW_ITEM_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying the item help.'
,p_process_when_button_id=>wwv_flow_imp.id(36867307037259054)
,p_process_when=>':P390_REFERENCE_ID is not null and :P390_REFRESH = ''Y'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Item help copied.'
,p_internal_uid=>37070826916117922
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(37072610901132232)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove reference id as needed'
,p_process_sql_clob=>'wwv_flow_copy_metadata.remove_item_help_reference_id (:P390_FLOW_ITEM_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error setting reference id to null.'
,p_process_when_button_id=>wwv_flow_imp.id(36867307037259054)
,p_process_when=>'P390_REFERENCE_ID'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'0'
,p_internal_uid=>37072610901132232
);
end;
/
prompt --application/pages/page_00391
begin
wwv_flow_imp_page.create_page(
 p_id=>391
,p_name=>'View Table Defaults'
,p_alias=>'VIEW-TABLE-DEFAULTS'
,p_step_title=>'View Table Defaults'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(262745606420610180)
,p_step_template=>wwv_flow_imp.id(19943204431962826)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(74725624313588476)
,p_help_text=>'AEUTL/sql_utl_user_def.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(61462903342942480)
,p_name=>'Table Defaults'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>100
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'SELECT SCHEMA,',
'       TABLE_NAME, ',
'       FORM_REGION_TITLE, ',
'       REPORT_REGION_TITLE',
'  FROM WWV_FLOW_HNT_TABLE_INFO',
' WHERE SCHEMA = :P391_SCHEMA',
'   AND TABLE_NAME = :P391_TABLE'))
,p_header=>'<p>UI Defaults allow AI interactions to understand the contents of your tables. They are also used to populate initial labels for forms and reports, providing consistency across multiple pages in an application or multiple applications.</p>'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'UI Defaults for Table not found.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(61464627556942549)
,p_query_column_id=>1
,p_column_alias=>'SCHEMA'
,p_column_display_sequence=>1
,p_column_heading=>'Schema:'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_table_name=>'WWV_FLOW_HNT_TABLE_INFO'
,p_ref_column_name=>'SCHEMA'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(61464809019942550)
,p_query_column_id=>2
,p_column_alias=>'TABLE_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Table Name:'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_table_name=>'WWV_FLOW_HNT_TABLE_INFO'
,p_ref_column_name=>'TABLE_NAME'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(61465029472942551)
,p_query_column_id=>3
,p_column_alias=>'FORM_REGION_TITLE'
,p_column_display_sequence=>3
,p_column_heading=>'Form Region Title:'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_table_name=>'WWV_FLOW_HNT_TABLE_INFO'
,p_ref_column_name=>'FORM_REGION_TITLE'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(61465226770942551)
,p_query_column_id=>4
,p_column_alias=>'REPORT_REGION_TITLE'
,p_column_display_sequence=>4
,p_column_heading=>'Report Region Title:'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_table_name=>'WWV_FLOW_HNT_TABLE_INFO'
,p_ref_column_name=>'REPORT_REGION_TITLE'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(61465913384945302)
,p_plug_name=>'HIDDEN'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>95
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(61609620853136751)
,p_name=>'Column-level UI Defaults'
,p_template=>wwv_flow_imp.id(208928010704475743)
,p_display_sequence=>130
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'SELECT c.TABLE_ID,',
'       c.COLUMN_ID, ',
'       case when g.group_name is null',
'            then 2',
'            else 1',
'            end ob,',
'       g.display_sequence group_display_seq,',
'       nvl(g.group_name,wwv_flow_lang.system_message(''NONE_SPECIFIED'')) group_name,',
'       c.COLUMN_NAME, ',
'       c.LABEL,',
'       decode(c.display_in_report,''Y'',''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'',null) display_in_report, ',
'       c.DISPLAY_SEQ_REPORT, ',
'       c.DISPLAY_AS_REPORT, -- need lov',
'       c.MASK_REPORT,',
'       c.ALIGNMENT,         -- need lov',
'       c.DISPLAY_AS_TAB_FORM,  -- need lov',
'       decode(wwv_flow_escape.html(c.display_in_form),''Y'',''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'',null) display_in_form, ',
'       c.DISPLAY_SEQ_FORM, ',
'       c.DISPLAY_AS_FORM,      -- need lov',
'       c.MASK_FORM,',
'       c.DEFAULT_VALUE, ',
'       c.DISPLAY_WIDTH, ',
'       c.MAX_WIDTH, ',
'       c.HEIGHT, ',
'       decode(c.required,''Y'',''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'',null) required, ',
'       (case when length(c.help_text) > 255 ',
'             then substr(c.help_text,1,255)||'' ...''',
'             else c.help_text',
'             end) help_text, ',
'       (case when length(c.lov_query) > 255 ',
'             then substr(c.LOV_QUERY,1,255)||'' ...''',
'             else c.lov_query',
'             end) lov_query,',
'       (case when length(WWV_FLOW_HINT.GET_STATIC_LOV_STRING(c.COLUMN_ID)) > 255',
'             then substr(WWV_FLOW_HINT.GET_STATIC_LOV_STRING(c.COLUMN_ID),1,255)||'' ...''',
'             else WWV_FLOW_HINT.GET_STATIC_LOV_STRING(c.COLUMN_ID)',
'             end) STATIC_LOV',
'  FROM WWV_FLOW_HNT_COLUMN_INFO c,',
'       wwv_flow_hnt_groups g',
' WHERE c.TABLE_ID = :P391_TABLE_ID',
'   and c.group_id = g.group_id (+)'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_type=>'ROW_RANGES'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(140628110221779238)
,p_query_column_id=>1
,p_column_alias=>'TABLE_ID'
,p_column_display_sequence=>23
,p_column_heading=>'Table Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_ref_schema=>'FLOWS_010600'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_ref_column_name=>'TABLE_ID'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(140628218574779240)
,p_query_column_id=>2
,p_column_alias=>'COLUMN_ID'
,p_column_display_sequence=>22
,p_column_heading=>'Column Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_ref_schema=>'FLOWS_010600'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_ref_column_name=>'COLUMN_ID'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(492768312997118761)
,p_query_column_id=>3
,p_column_alias=>'OB'
,p_column_display_sequence=>25
,p_column_heading=>'Ob'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(492768020354101979)
,p_query_column_id=>4
,p_column_alias=>'GROUP_DISPLAY_SEQ'
,p_column_display_sequence=>24
,p_column_heading=>'Group Display Seq'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(492762421805932106)
,p_query_column_id=>5
,p_column_alias=>'GROUP_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Group Name'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>3
,p_disable_sort_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(140628312545779240)
,p_query_column_id=>6
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Column Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>4
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_ref_column_name=>'COLUMN_NAME'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(140628417505779241)
,p_query_column_id=>7
,p_column_alias=>'LABEL'
,p_column_display_sequence=>3
,p_column_heading=>'Label'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_ref_column_name=>'LABEL'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(140628531719779241)
,p_query_column_id=>8
,p_column_alias=>'DISPLAY_IN_REPORT'
,p_column_display_sequence=>4
,p_column_heading=>'Display in<br />Report'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_ref_column_name=>'DISPLAY_IN_REPORT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(140628609039779241)
,p_query_column_id=>9
,p_column_alias=>'DISPLAY_SEQ_REPORT'
,p_column_display_sequence=>5
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_ref_column_name=>'DISPLAY_SEQ_REPORT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(140628708546779241)
,p_query_column_id=>10
,p_column_alias=>'DISPLAY_AS_REPORT'
,p_column_display_sequence=>6
,p_column_heading=>'Display As Report'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(285506029323635827)
,p_lov_show_nulls=>'YES'
,p_lov_display_extra=>'YES'
,p_ref_schema=>'FLOWS_010600'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_ref_column_name=>'DISPLAY_AS_REPORT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(140628806513779241)
,p_query_column_id=>11
,p_column_alias=>'MASK_REPORT'
,p_column_display_sequence=>7
,p_column_heading=>'Mask'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_ref_column_name=>'MASK_REPORT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(140628913251779241)
,p_query_column_id=>12
,p_column_alias=>'ALIGNMENT'
,p_column_display_sequence=>8
,p_column_heading=>'Alignment'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(200094129140149873)
,p_lov_show_nulls=>'YES'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_ref_column_name=>'ALIGNMENT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(140629304090779242)
,p_query_column_id=>13
,p_column_alias=>'DISPLAY_AS_TAB_FORM'
,p_column_display_sequence=>9
,p_column_heading=>'Display As<br>Tabular Form'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(285508811785635847)
,p_lov_show_nulls=>'YES'
,p_lov_display_extra=>'YES'
,p_ref_schema=>'FLOWS_010600'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_ref_column_name=>'DISPLAY_AS_TAB_FORM'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(140629430701779242)
,p_query_column_id=>14
,p_column_alias=>'DISPLAY_IN_FORM'
,p_column_display_sequence=>10
,p_column_heading=>'Display<br>In<br>Form'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_ref_schema=>'FLOWS_010600'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_ref_column_name=>'DISPLAY_IN_FORM'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(140629522467779242)
,p_query_column_id=>15
,p_column_alias=>'DISPLAY_SEQ_FORM'
,p_column_display_sequence=>11
,p_column_heading=>'Sequence<br>in<br>Form'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_ref_schema=>'FLOWS_010600'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_ref_column_name=>'DISPLAY_SEQ_FORM'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(140629628978779242)
,p_query_column_id=>16
,p_column_alias=>'DISPLAY_AS_FORM'
,p_column_display_sequence=>12
,p_column_heading=>'Display As Form'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(29544521926748713)
,p_lov_show_nulls=>'YES'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_ref_column_name=>'DISPLAY_AS_FORM'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(140629728080779242)
,p_query_column_id=>17
,p_column_alias=>'MASK_FORM'
,p_column_display_sequence=>13
,p_column_heading=>'Mask<br>Form'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_ref_column_name=>'MASK_FORM'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(140629801978779243)
,p_query_column_id=>18
,p_column_alias=>'DEFAULT_VALUE'
,p_column_display_sequence=>14
,p_column_heading=>'Default<br>Value'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_ref_column_name=>'DEFAULT_VALUE'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(140629907453779243)
,p_query_column_id=>19
,p_column_alias=>'DISPLAY_WIDTH'
,p_column_display_sequence=>15
,p_column_heading=>'Display<br>Width'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_ref_schema=>'FLOWS_010600'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_ref_column_name=>'DISPLAY_WIDTH'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(140630021271779243)
,p_query_column_id=>20
,p_column_alias=>'MAX_WIDTH'
,p_column_display_sequence=>16
,p_column_heading=>'Max<br>Width'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_ref_schema=>'FLOWS_010600'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_ref_column_name=>'MAX_WIDTH'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(140630126044779243)
,p_query_column_id=>21
,p_column_alias=>'HEIGHT'
,p_column_display_sequence=>17
,p_column_heading=>'Height'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_ref_schema=>'FLOWS_010600'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_ref_column_name=>'HEIGHT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(140630221296779243)
,p_query_column_id=>22
,p_column_alias=>'REQUIRED'
,p_column_display_sequence=>18
,p_column_heading=>'Required'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_ref_column_name=>'REQUIRED'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(140630314009779243)
,p_query_column_id=>23
,p_column_alias=>'HELP_TEXT'
,p_column_display_sequence=>19
,p_column_heading=>'Help Text'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_ref_schema=>'FLOWS_010600'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_ref_column_name=>'HELP_TEXT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(140630409244779244)
,p_query_column_id=>24
,p_column_alias=>'LOV_QUERY'
,p_column_display_sequence=>20
,p_column_heading=>'LOV Query'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_ref_schema=>'FLOWS_010600'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_ref_column_name=>'LOV_QUERY'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(140630509717779244)
,p_query_column_id=>25
,p_column_alias=>'STATIC_LOV'
,p_column_display_sequence=>21
,p_column_heading=>'Static LOV'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_ref_schema=>'FLOWS_010600'
,p_ref_table_name=>'WWV_FLOW_HNT_COLUMN_INFO'
,p_ref_column_name=>'STATIC_LOV'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(178256924733663285)
,p_plug_name=>'Warning - Columns Require List of Values'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>125
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_hint.check_lov_issues(:P391_TABLE_ID) is not null'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<img src="#IMAGE_PREFIX#htmldb/icons/alert_warning.gif" alt=""/> The following column(s) have display types that require list of values but there are no list of values defined.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(138112412580899990)
,p_branch_action=>'f?p=&FLOW_ID.:391:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(61467127929949530)
,p_name=>'P391_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(61465913384945302)
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(61467427689949532)
,p_name=>'P391_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(61465913384945302)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(61615430550139554)
,p_name=>'P391_TABLE_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(61465913384945302)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(178266403524676064)
,p_name=>'P391_LOV_ISSUES'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(178256924733663285)
,p_source=>'wwv_flow_hint.check_lov_issues(:P391_TABLE_ID)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(61660926871147913)
,p_computation_sequence=>10
,p_computation_item=>'P391_TABLE_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select table_id',
'  from wwv_flow_hnt_table_info',
' where :P391_SCHEMA = schema',
'   and :P391_TABLE  = table_name'))
,p_compute_when_type=>'%null%'
);
end;
/
prompt --application/pages/page_00394
begin
wwv_flow_imp_page.create_page(
 p_id=>394
,p_name=>'Navigation Bar Entry History'
,p_alias=>'NAVIGATION-BAR-ENTRY-HISTORY'
,p_step_title=>'Navigation Bar Entry History'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213263531591941060)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_navbar.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(10078523944553285)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(166766500720858594)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Classic Navigation Bar'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(181016801777003664)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>This page displays recent modifications made to Navigation Bar Entries in this application.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193081831199308752)
,p_plug_name=>'Navigation Bar Entry History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P394a */',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_ICON_BAR'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(193082012240308753)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193082111287308754)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193082212996308755)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Audit Comment'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193082326102308755)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Component Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193082401525308756)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193082523040308757)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Component Key'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193082611829308758)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Audit Date'
,p_column_type=>'DATE'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193082731593308758)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(193082822794308759)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1288729985536643'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'AUDIT_DATE:ACTION:DEVELOPER:COMPONENT_NAME:ID'
,p_sort_column_1=>'AUDIT_DATE'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(188985015541905789)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(193081831199308752)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:394:&SESSION.::&DEBUG.:394,RIR::'
);
end;
/
prompt --application/pages/page_00397
begin
wwv_flow_imp_page.create_page(
 p_id=>397
,p_name=>'Change Theme Identification Number'
,p_alias=>'CHANGE-THEME-IDENTIFICATION-NUMBER'
,p_step_title=>'Change Theme Identification Number - Theme Number'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879423075323511)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_themes.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(60191729831707231)
,p_plug_name=>'Change Theme Identification Number'
,p_region_template_options=>'#DEFAULT#:a-Form-fixedLabelsLarge'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<p>Each theme is identified by an identification number (or ID). Use this utility to change the theme identification number to another number.  Changing a theme identification number is useful when you need to export a theme with a different number.<'
||'/p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(106531510655579263)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(106512001249472508)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(200255730583392996)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747141408351138161)
,p_plug_name=>'Change Theme Identification Number'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(60192928679707235)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(200255730583392996)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(60193300146707238)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(200255730583392996)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(60195828763707263)
,p_branch_action=>'f?p=&FLOW_ID.:400:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(60194113481707242)
,p_name=>'P397_CHANGE_TO_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(60191729831707231)
,p_prompt=>'New Theme Identification Number'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Enter a new identification number for the current selected theme.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(60194514019707248)
,p_name=>'P397_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(60191729831707231)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application:'
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'This attribute identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(60194925620707252)
,p_name=>'P397_CHANGE_FROM_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(60191729831707231)
,p_prompt=>'Identify Theme'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(theme_name) d, theme_id r from wwv_flow_themes where flow_id = :fb_flow_id',
'order by theme_id'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the theme for which you wish to change the theme identification number.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(144913419390912494)
,p_validation_name=>'P397_CHANGE_TO_ID'
,p_validation_sequence=>10
,p_validation=>'P397_CHANGE_TO_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Theme ID must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(60193300146707238)
,p_associated_item=>wwv_flow_imp.id(60194113481707242)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(35691301057155548)
,p_validation_name=>'P397_CHANGE_TO_ID'
,p_validation_sequence=>20
,p_validation=>'P397_CHANGE_TO_ID'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Theme identification number must be numeric.'
,p_when_button_pressed=>wwv_flow_imp.id(60193300146707238)
,p_associated_item=>wwv_flow_imp.id(60194113481707242)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(60285216296032571)
,p_validation_name=>'theme_to is greater than 100'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'if :P397_CHANGE_TO_ID >= 100 or :app_security_group_id = 10  or :app_security_group_id = 20 or :app_security_group_id = 200000 then',
'  return true;',
'end if;',
'  return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Theme ID must be greater than 100.'
,p_validation_condition=>'P397_CHANGE_TO_ID'
,p_validation_condition_type=>'ITEM_IS_NUMERIC'
,p_when_button_pressed=>wwv_flow_imp.id(60193300146707238)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(60732408800844816)
,p_validation_name=>'Theme not in use'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'for c1 in (select 1 from wwv_flow_themes where flow_id = :fb_flow_id and theme_id = :P397_CHANGE_TO_ID) loop',
'  return false;',
'end loop;',
'return true;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Theme is in use please select another.'
,p_validation_condition=>'P397_CHANGE_TO_ID'
,p_validation_condition_type=>'ITEM_IS_NUMERIC'
,p_when_button_pressed=>wwv_flow_imp.id(60193300146707238)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(35685704258137583)
,p_validation_name=>'Theme ID must be whole numbers'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_round number := null;',
'begin',
'  if :P397_CHANGE_TO_ID > 100 then',
'    l_round := round(:P397_CHANGE_TO_ID);',
'    if l_round != :P397_CHANGE_TO_ID then',
'      return false;',
'    end if;',
'  end if;',
'  return true;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Theme identification number must be a whole number.'
,p_validation_condition=>'P397_CHANGE_TO_ID'
,p_validation_condition_type=>'ITEM_IS_NUMERIC'
,p_when_button_pressed=>wwv_flow_imp.id(60193300146707238)
,p_associated_item=>wwv_flow_imp.id(60194113481707242)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00398
begin
wwv_flow_imp_page.create_page(
 p_id=>398
,p_name=>'Parent Tab Report'
,p_alias=>'PARENT-TAB-REPORT'
,p_step_title=>'Parent Tab Report'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213240607818867991)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(31648722557137314)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>100
,p_list_id=>wwv_flow_imp.id(5297709875)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(31665218120315803)
,p_name=>'Parent Tabs'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>130
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'       p.tab_sequence||'': ''||p.tab_set ptset, ',
'       p.tab_text ptext, ',
'       p.CURRENT_ON_TABSET,',
'       s.TAB_SEQUENCE sseq, ',
'       s.TAB_TEXT     stext,',
'       s.id s_id,',
'       p.id p_id',
'from   wwv_flow_toplevel_tabs p, ',
'       wwv_flow_tabs s',
'where  s.flow_id (+) = :FB_FLOW_ID and',
'       p.flow_id = :fb_flow_id and',
'       s.tab_set (+) = p.CURRENT_ON_TABSET',
'order  by 1, 2, 3, 4, 5'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1:2:3'
,p_query_no_data_found=>'No parent tabs found.'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48653514844771463)
,p_query_column_id=>1
,p_column_alias=>'PTSET'
,p_column_display_sequence=>1
,p_column_heading=>'Tab Set'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48653601252771463)
,p_query_column_id=>2
,p_column_alias=>'PTEXT'
,p_column_display_sequence=>2
,p_column_heading=>'Parent Tab'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=#FLOW_ID#:4318:#FLOW_SESSION#::::F4000_P4318_ID:#P_ID#'
,p_column_linktext=>'#PTEXT#'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48653711021771463)
,p_query_column_id=>3
,p_column_alias=>'CURRENT_ON_TABSET'
,p_column_display_sequence=>3
,p_column_heading=>'Standard Tab Set'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48653819883771463)
,p_query_column_id=>4
,p_column_alias=>'SSEQ'
,p_column_display_sequence=>4
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48653909184771463)
,p_query_column_id=>5
,p_column_alias=>'STEXT'
,p_column_display_sequence=>5
,p_column_heading=>'Standard Tab'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48654008793771463)
,p_query_column_id=>6
,p_column_alias=>'S_ID'
,p_column_display_sequence=>6
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48654117539771463)
,p_query_column_id=>7
,p_column_alias=>'P_ID'
,p_column_display_sequence=>7
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(31680303715097026)
,p_plug_name=>'Parent Tabs'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'This page identifies the parent tabs and standard tabs defined for the current application.</p>',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(31682607141145273)
,p_plug_name=>'Parent Tab Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(165863110284077420)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(35089502899725260)
,p_plug_name=>'Standard Tab Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(165876716780098264)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(36279612648350571)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'398'
,p_computation_error_message=>'Unable to compute item value.'
);
end;
/
prompt --application/pages/page_00400
begin
wwv_flow_imp_page.create_page(
 p_id=>400
,p_name=>'Confirm Theme Identification Number Change'
,p_alias=>'CONFIRM-THEME-IDENTIFICATION-NUMBER-CHANGE'
,p_step_title=>'Change Theme Identification Number - Confirm'
,p_allow_duplicate_submissions=>'N'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879423075323511)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_themes.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(60212912924793599)
,p_plug_name=>'Change Theme Identification Number'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>131
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(106532720698582206)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>31
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(106512001249472508)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(200256605911404711)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>141
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747141585648138161)
,p_plug_name=>'Change Theme Identification Number'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(60214518168793605)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(200256605911404711)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:260:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(60213704598793603)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(200256605911404711)
,p_button_name=>'CHANGE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Change Theme ID'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(60214127171793604)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(200256605911404711)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:397:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(60215826657793625)
,p_branch_action=>'f?p=&FLOW_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(60220731506809852)
,p_name=>'P400_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(60212912924793599)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application:'
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'This attribute identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(60221408780812795)
,p_name=>'P400_CHANGE_THEME_FROM_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(60212912924793599)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Change Theme ID from:'
,p_source=>'P397_CHANGE_FROM_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the selected theme.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(60222117438815210)
,p_name=>'P400_CHANGE_TO_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(60212912924793599)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Change Theme ID to:'
,p_source=>'P397_CHANGE_TO_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>12
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies a new identification number (ID) for the selected theme.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(60215425602793620)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Change theme ID'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_theme_manager.renumber_theme(p_flow_id => :fb_flow_id, p_to_theme => :P397_CHANGE_TO_ID, p_from_theme => :P397_CHANGE_FROM_ID);',
'-- :P397_CHANGE_TO_ID',
'-- :P397_CHANGE_FROM_ID'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to change theme identifier.'
,p_process_when_button_id=>wwv_flow_imp.id(60213704598793603)
,p_process_success_message=>'Theme identifier changed.'
,p_internal_uid=>60215425602793620
);
end;
/
prompt --application/pages/page_00401
begin
wwv_flow_imp_page.create_page(
 p_id=>401
,p_name=>'Copy Theme'
,p_alias=>'COPY-THEME'
,p_step_title=>'Copy Theme'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879423075323511)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_themes.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(60244815188880674)
,p_plug_name=>'Copy Theme'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>21
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<p>Each theme is identified by a numeric identification number (ID). Use this to make a copy of an existing theme and specify a new theme ID.  Copying a theme is useful if you wish to export a theme with a different ID.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(106490527175408094)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>31
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(106491204103410821)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(200253521186361846)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>41
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747141678510138162)
,p_plug_name=>'Copy Theme'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(60246011183880677)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(200253521186361846)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(60246412285880679)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(200253521186361846)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(60248501926880695)
,p_branch_action=>'f?p=&FLOW_ID.:410:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(60247204839880682)
,p_name=>'P401_APPLICATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(60244815188880674)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application:'
,p_source=>':FB_FLOW_ID'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'This attribute identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(60247626161880688)
,p_name=>'P401_COPY_FROM_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(60244815188880674)
,p_prompt=>'Copy from Theme'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(theme_name) d, ',
'       theme_id r ',
'  from wwv_flow_themes ',
' where flow_id              = :P401_APPLICATION',
'   -- Feature APEX-3735, Bug 34348682 - Do not allow copying legacy themes',
'   and (    wwv_flow_platform.get_preference(''ALLOW_LEGACY_THEME_COPY'') = ''Y''',
'    or (    wwv_flow_platform.get_preference(''ALLOW_LEGACY_THEME_COPY'') = ''N'' ',
'        and theme_internal_name != ''JQUERY_MOBILE_SMARTPHONE'' ',
'        and theme_id not between 1 and 26 ) )',
' order by 2'))
,p_lov_cascade_parent_items=>'P401_APPLICATION'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the theme you wish to copy. A theme identifies a collection of templates which define the user interface of an application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(60248022935880689)
,p_name=>'P401_COPY_TO_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(60244815188880674)
,p_prompt=>'Copy to this Theme ID'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Enter a new numeric identification number (ID) for this theme. A theme identifies a collection of templates which define the user interface of an application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(941779181566559887)
,p_name=>'P401_SUBSCRIBE_THEME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(60244815188880674)
,p_prompt=>'Subscribe Theme'
,p_source=>'Y'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_YES_NO'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(141257203808789836)
,p_validation_name=>'P401_COPY_TO_ID'
,p_validation_sequence=>10
,p_validation=>'P401_COPY_TO_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Theme ID must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(60246412285880679)
,p_associated_item=>wwv_flow_imp.id(60248022935880689)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(141259929435797240)
,p_validation_name=>'Copy to > 100'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'if :WORKSPACE_ID=20 or :P401_COPY_TO_ID>=100 then',
'  return true;',
'else ',
'  return false;',
'end if;',
'exception when others then',
'return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Values under 100 are reserved for Oracle.'
,p_when_button_pressed=>wwv_flow_imp.id(60246412285880679)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(144917213072929581)
,p_validation_name=>'theme not in use'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'for c1 in (select 1 from wwv_flow_themes where flow_id = :fb_flow_id and theme_id = :P401_COPY_TO_ID) loop',
'  return false;',
'end loop;',
'return true;',
'exception when others then return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Theme is in use please choose another.'
,p_when_button_pressed=>wwv_flow_imp.id(60246412285880679)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00404
begin
wwv_flow_imp_page.create_page(
 p_id=>404
,p_name=>'Set Items'
,p_alias=>'SET-ITEMS'
,p_step_title=>'Set Items'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function passBackItemValues(){',
'    var items  = "",',
'        values = "";',
'',
'    if ($v("P404_ITEM1") != "") {',
'      items = $v("P404_ITEM1") + ",";',
'      values = $v("P404_VALUE1") + ",";',
'    }',
'    if ($v("P404_ITEM2") != "") {',
'      items = items + $v("P404_ITEM2") + ",";',
'      values = values + $v("P404_VALUE2") + ","; }',
'    if ($v("P404_ITEM3") != "") {',
'      items = items + $v("P404_ITEM3") + ",";',
'      values = values + $v("P404_VALUE3") + ","; ',
'    }',
'    if ($v("P404_ITEM4") != "") {',
'      items = items + $v("P404_ITEM4") + ",";',
'      values = values + $v("P404_VALUE4") + ","; ',
'    }',
'    if ($v("P404_ITEM5") != "") {',
'      items = items + $v("P404_ITEM5") + ",";',
'      values = values + $v("P404_VALUE5") + ","; ',
'    }',
'    if ($v("P404_ITEM6") != "") {',
'      items = items + $v("P404_ITEM6") + ",";',
'      values = values + $v("P404_VALUE6") + ","; ',
'    }',
'    if ($v("P404_ITEM7") != "") {',
'      items = items + $v("P404_ITEM7") + ",";',
'      values = values + $v("P404_VALUE7") + ","; ',
'    }',
'    if ($v("P404_ITEM8") != "") {',
'      items = items + $v("P404_ITEM8") + ",";',
'      values = values + $v("P404_VALUE8") + ","; ',
'    }',
'    if ($v("P404_ITEM9") != "") {',
'      items = items + $v("P404_ITEM9") + ",";',
'      values = values + $v("P404_VALUE9") + ","; ',
'    }',
'    if ($v("P404_ITEM10") != "") {',
'      items = items + $v("P404_ITEM10") + ",";',
'      values = values + $v("P404_VALUE10") + ","; ',
'    }',
'    items = items.substr(0,items.lastIndexOf(","));',
'    values = values.substr(0,values.lastIndexOf(","));',
'    ',
'    var return1 = $v(''P404_RETURN1''),',
'        return2 = $v(''P404_RETURN2''),',
'        target1 = window.opener.document.getElementById(return1),',
'        target2 = window.opener.document.getElementById(return2);',
'    window.opener.setValue(target1,items);',
'    window.opener.setValue(target2,values);',
'    target2.focus();',
'    window.close();',
'}',
'',
'function closePopup(){',
'    var target1 = window.opener.document.getElementById($v(''P404_RETURN1''));    ',
'    target1.focus();',
'    window.close();',
'}'))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'table.formlayout .a-Form-labelContainer {',
'    min-width: 0;',
'}',
'body {',
'padding: 0 !important;',
'}',
'table.formlayout td input[type="text"] {',
'  border-right-width: 0;',
'  border-radius: 2px 0 0 2px;',
'  box-shadow: 0 1px 1px rgba(0,0,0,.05) inset;',
'  border-color: #DBDBDB; ',
'}'))
,p_step_template=>wwv_flow_imp.id(19943204431962826)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_item.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(18105609595309302)
,p_plug_name=>'Item/Value Pairs'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(280300246206526845)
,p_plug_name=>'Buttons'
,p_region_attributes=>'style="margin: 8px;"'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4106223580403610)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(280300246206526845)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(18516214489107148)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(280300246206526845)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:passBackItemValues();'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18256106852603439)
,p_name=>'P404_RETURN1'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(18105609595309302)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18256712047604967)
,p_name=>'P404_RETURN2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(18105609595309302)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18265703173961925)
,p_name=>'P404_ITEM1'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(18105609595309302)
,p_prompt=>'1'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4000_246'
,p_attribute_03=>'Find Item'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18265925075961927)
,p_name=>'P404_ITEM2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(18105609595309302)
,p_prompt=>'2'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4000_246'
,p_attribute_03=>'Find Item'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18266232575961928)
,p_name=>'P404_ITEM3'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(18105609595309302)
,p_prompt=>'3'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4000_246'
,p_attribute_03=>'Find Item'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18266529203961929)
,p_name=>'P404_ITEM4'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(18105609595309302)
,p_prompt=>'4'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4000_246'
,p_attribute_03=>'Find Item'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18266820531961929)
,p_name=>'P404_ITEM5'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(18105609595309302)
,p_prompt=>'5'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4000_246'
,p_attribute_03=>'Find Item'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18267104910961930)
,p_name=>'P404_ITEM6'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(18105609595309302)
,p_prompt=>'6'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4000_246'
,p_attribute_03=>'Find Item'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18267407600961931)
,p_name=>'P404_ITEM7'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(18105609595309302)
,p_prompt=>'7'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4000_246'
,p_attribute_03=>'Find Item'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18267722929961931)
,p_name=>'P404_ITEM8'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(18105609595309302)
,p_prompt=>'8'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4000_246'
,p_attribute_03=>'Find Item'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18268013961961933)
,p_name=>'P404_ITEM9'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(18105609595309302)
,p_prompt=>'9'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4000_246'
,p_attribute_03=>'Find Item'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18268328527961933)
,p_name=>'P404_ITEM10'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(18105609595309302)
,p_prompt=>'10'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4000_246'
,p_attribute_03=>'Find Item'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18269313955993408)
,p_name=>'P404_VALUE1'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_imp.id(18105609595309302)
,p_prompt=>'Value 1'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(4923925522744860)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select or enter a value to be passed to the associated item.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4000_414'
,p_attribute_03=>'Find Item Substitution'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18269522678993408)
,p_name=>'P404_VALUE2'
,p_item_sequence=>45
,p_item_plug_id=>wwv_flow_imp.id(18105609595309302)
,p_prompt=>'Value 2'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(4923925522744860)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select or enter a value to be passed to the associated item.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4000_414'
,p_attribute_03=>'Find Item Substitution'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18269810275993409)
,p_name=>'P404_VALUE3'
,p_item_sequence=>55
,p_item_plug_id=>wwv_flow_imp.id(18105609595309302)
,p_prompt=>'Value 3'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(4923925522744860)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select or enter a value to be passed to the associated item.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4000_414'
,p_attribute_03=>'Find Item Substitution'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18270126260993409)
,p_name=>'P404_VALUE4'
,p_item_sequence=>65
,p_item_plug_id=>wwv_flow_imp.id(18105609595309302)
,p_prompt=>'Value 4'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(4923925522744860)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select or enter a value to be passed to the associated item.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4000_414'
,p_attribute_03=>'Find Item Substitution'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18270406424993410)
,p_name=>'P404_VALUE5'
,p_item_sequence=>75
,p_item_plug_id=>wwv_flow_imp.id(18105609595309302)
,p_prompt=>'Value 5'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(4923925522744860)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select or enter a value to be passed to the associated item.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4000_414'
,p_attribute_03=>'Find Item Substitution'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18270716902993414)
,p_name=>'P404_VALUE6'
,p_item_sequence=>85
,p_item_plug_id=>wwv_flow_imp.id(18105609595309302)
,p_prompt=>'Value 6'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(4923925522744860)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select or enter a value to be passed to the associated item.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4000_414'
,p_attribute_03=>'Find Item Substitution'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18271031351993414)
,p_name=>'P404_VALUE7'
,p_item_sequence=>95
,p_item_plug_id=>wwv_flow_imp.id(18105609595309302)
,p_prompt=>'Value 7'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(4923925522744860)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select or enter a value to be passed to the associated item.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4000_414'
,p_attribute_03=>'Find Item Substitution'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18271307333993416)
,p_name=>'P404_VALUE8'
,p_item_sequence=>105
,p_item_plug_id=>wwv_flow_imp.id(18105609595309302)
,p_prompt=>'Value 8'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(4923925522744860)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select or enter a value to be passed to the associated item.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4000_414'
,p_attribute_03=>'Find Item Substitution'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18271611876993416)
,p_name=>'P404_VALUE9'
,p_item_sequence=>115
,p_item_plug_id=>wwv_flow_imp.id(18105609595309302)
,p_prompt=>'Value 9'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(4923925522744860)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select or enter a value to be passed to the associated item.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4000_414'
,p_attribute_03=>'Find Item Substitution'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18271915789993417)
,p_name=>'P404_VALUE10'
,p_item_sequence=>125
,p_item_plug_id=>wwv_flow_imp.id(18105609595309302)
,p_prompt=>'Value 10'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(4923925522744860)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select or enter a value to be passed to the associated item.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4000_414'
,p_attribute_03=>'Find Item Substitution'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18632520787988973)
,p_name=>'P404_ITEMS'
,p_item_sequence=>23
,p_item_plug_id=>wwv_flow_imp.id(18105609595309302)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18633827713990946)
,p_name=>'P404_VALUES'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_imp.id(18105609595309302)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18783224248390375)
,p_name=>'P404_ITEM_HEADING'
,p_item_sequence=>27
,p_item_plug_id=>wwv_flow_imp.id(18105609595309302)
,p_source=>'''<span class="instructionText">''||wwv_flow_lang.system_message(''LAYOUT.T_ITEM'')||''</span>'''
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18783800830392998)
,p_name=>'P404_VAL_HEADING'
,p_item_sequence=>29
,p_item_plug_id=>wwv_flow_imp.id(18105609595309302)
,p_source=>'''<span class="instructionText">''||wwv_flow_lang.system_message(p_name=>''F4000.P404.VALUES'')||''</span>'''
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4106082779403608)
,p_name=>'Focus P404_ITEM1'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4106116665403609)
,p_event_id=>wwv_flow_imp.id(4106082779403608)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P404_ITEM1'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4106325177403611)
,p_name=>'Close Popup Window'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(4106223580403610)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4106436113403612)
,p_event_id=>wwv_flow_imp.id(4106325177403611)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'closePopup();'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(18658022013102856)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'pop items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_items wwv_flow_global.vc_arr2;',
'  l_item_count number;',
'begin',
'  l_items := wwv_flow_utilities.string_to_table(:P404_ITEMS,''~'');',
'  if l_items.count>10 then',
'    l_item_count := 10;',
'  else',
'    l_item_count := l_items.count;',
'  end if;',
'  for i in 1.. l_item_count loop',
'    wwv_flow.update_cache_with_write(''P404_ITEM''||i,l_items(i));',
'  end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P404_ITEMS'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>18658022013102856
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(18682513336299056)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'pop values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_values wwv_flow_global.vc_arr2;',
'  l_value_count number;',
'begin',
'  l_values := wwv_flow_utilities.string_to_table(:P404_VALUES,''~'');',
'  if l_values.count>10 then',
'    l_value_count := 10;',
'  else',
'    l_value_count := l_values.count;',
'  end if;',
'  for i in 1.. l_value_count loop',
'    wwv_flow.update_cache_with_write(''P404_VALUE''||i,l_values(i));',
'  end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P404_VALUES'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>18682513336299056
);
end;
/
prompt --application/pages/page_00405
begin
wwv_flow_imp_page.create_page(
 p_id=>405
,p_name=>'Lists'
,p_alias=>'LISTS'
,p_step_title=>'Lists'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213210808239773454)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_list.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3852226590687921)
,p_plug_name=>'Lists'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with messages as (',
'    select ( select wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_UP_TO_DATE'') from sys.dual ) up_to_date,',
'           ( select wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_NEEDS_REFRESH'') from sys.dual ) needs_refresh,',
'           ( select wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_UNKNOWN'') from sys.dual ) unknown_status,',
'           ( select wwv_flow_lang_dev.builder_message(''SUBSCRIBED_FROM.NONEXISTING_MASTER'') from sys.dual ) no_master,',
'           ( select wwv_flow_lang_dev.builder_message(''F4000.DYNAMIC'') from sys.dual ) "DYNAMIC",',
'           ( select wwv_flow_lang_dev.builder_message(''F4000.STATIC'') from sys.dual ) "STATIC"         ',
'      from sys.dual )',
'select l.id,',
'       l.name name,',
'       ( select count(*)',
'           from wwv_flow_list_items i',
'          where i.list_id           = l.id ',
'            and i.flow_id           = l.flow_id',
'            and i.security_group_id = l.security_group_id) entries,',
'       ( select count(*)',
'           from wwv_flow_page_plugs p',
'          where p.list_id           = l.id',
'            and p.flow_id           = l.flow_id',
'            and p.security_group_id = l.security_group_id ) +',
'       ( select count(*)',
'           from wwv_flow_steps s',
'          where s.navigation_list_id = l.id',
'            and s.flow_id            = l.flow_id',
'            and s.security_group_id  = l.security_group_id ) +',
'       ( select count(*)',
'           from wwv_flows f',
'          where l.id                 in (f.navigation_list_id, f.nav_bar_list_id)',
'            and f.id                 = l.flow_id',
'            and f.security_group_id  = l.security_group_id ) +',
'        ( select count(*)',
'            from wwv_flow_list_items sl',
'           where sl.sub_list_id       = l.id',
'             and sl.flow_id           = l.flow_id',
'             and sl.security_group_id = l.security_group_id) as ref,',
'       --',
'       coalesce(l.last_updated_on,l.created_on) list_last_updated,',
'       --',
'       decode(substr(l.list_query,1,1),null,messages."STATIC",decode(substr(upper(l.list_query),1,6),''STATIC'',',
'          messages."STATIC",messages."DYNAMIC")) list_type,',
'       --',
'       ( select patch_name',
'           from wwv_flow_patches p',
'          where security_group_id = :FLOW_SECURITY_GROUP_ID',
'            and flow_id           = :FB_FLOW_ID',
'            and p.id              = l.required_patch ) build_option,',
'       --',
'       l.list_comment,',
'       l.flow_id appliation_id,',
'       ''icon-sc-list'' icon_class,',
'       replace(replace(l.name,''_'','' ''),''.'','' '') icon_title,',
'       --',
'       wwv_flow_page_api.get_url(',
'            p_page               => ''4050'',',
'            p_clear_cache        => ''4050'',',
'            p_items              => ''F4000_P4050_LIST_ID'',',
'            p_values             => l.id ) as edit_link,',
'       --',
'       ( select decode(count(nav_bar_list_id),0,''N'',''Y'')',
'           from wwv_flows',
'          where id                = :FB_FLOW_ID',
'            and security_group_id = :FLOW_SECURITY_GROUP_ID',
'            and nav_bar_list_id   = l.id ) navbar,',
'       --',
'       ( select decode(count(nav_bar_list_id),0,0,1)',
'           from wwv_flows',
'          where id                = :FB_FLOW_ID',
'            and security_group_id = :FLOW_SECURITY_GROUP_ID',
'            and nav_bar_list_id   = l.id ) is_navbar,',
'       --',
'       case',
'         when exists ( select 1 ',
'                         from wwv_flows',
'                        where id                 = :FB_FLOW_ID',
'                          and security_group_id  = :FLOW_SECURITY_GROUP_ID',
'                          and navigation_list_id = l.id ) then ''Y''',
'         when exists ( select 1',
'                         from wwv_flow_steps',
'                        where flow_id            = :FB_FLOW_ID',
'                          and security_group_id  = :FLOW_SECURITY_GROUP_ID',
'                          and navigation_list_id = l.id ) then ''Y''',
'         else ''N''',
'       end global_nav,',
'       --',
'       case',
'         when exists ( select 1',
'                         from wwv_flows',
'                        where id                 = :FB_FLOW_ID',
'                          and security_group_id  = :FLOW_SECURITY_GROUP_ID',
'                          and navigation_list_id = l.id ) then 1',
'         when exists ( select 1',
'                         from wwv_flow_steps',
'                        where flow_id            = :FB_FLOW_ID',
'                          and security_group_id  = :FLOW_SECURITY_GROUP_ID',
'                          and navigation_list_id = l.id ) then 1',
'         else 0',
'       end is_navmenu,',
'       --',
'       case when l.reference_id is not null then',
'           coalesce ( to_char( master.flow_id ),',
'                       messages.no_master )',
'       end as subscribed_from,',
'       ( select case when count(*) > 0 then count(*) end',
'           from wwv_flow_lists sub',
'          where sub.reference_id      = l.id',
'            and sub.security_group_id = :WORKSPACE_ID ) as subscribers,',
'       case when l.reference_id is not null then',
'           case',
'               when master.version_scn = l.version_scn then',
'                   messages.up_to_date',
'               when master.version_scn != l.version_scn then',
'                   messages.needs_refresh',
'               else',
'                   messages.unknown_status',
'           end',
'       end subscription_status,',
'       --  ',
'       null action     ',
'  from wwv_flow_lists l,',
'       wwv_flow_lists master,',
'       messages',
' where l.flow_id                = :FB_FLOW_ID',
'   and l.security_group_id      = :WORKSPACE_ID',
'   and l.reference_id           = master.id (+)',
'   and l.security_group_id      = master.security_group_id (+)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(3852329031687921)
,p_name=>'Lists'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No lists found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#EDIT_LINK#" class="a-IRR-icon"><span class="a-Icon #ICON_CLASS#"></span><span class="a-IRR-iconName">#ICON_TITLE#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3852507644687930)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3852618182687936)
,p_db_column_name=>'NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Name'
,p_column_link=>'#EDIT_LINK#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10668316510182330)
,p_db_column_name=>'LIST_TYPE'
,p_display_order=>3
,p_column_identifier=>'R'
,p_column_label=>'Type'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3852724477687936)
,p_db_column_name=>'ENTRIES'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>'Entries'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3852807138687936)
,p_db_column_name=>'REF'
,p_display_order=>5
,p_column_identifier=>'D'
,p_column_label=>'References'
,p_column_link=>'f?p=&APP_ID.:417:&SESSION.::&DEBUG.:RP,RIR,CIR:IR_LIST_ID,F4000_LAST_VIEW:#ID#,405'
,p_column_linktext=>'#REF#'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3853302862687940)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>10
,p_column_identifier=>'I'
,p_column_label=>'Edit Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3856329660735645)
,p_db_column_name=>'LIST_LAST_UPDATED'
,p_display_order=>11
,p_column_identifier=>'J'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3915601776592979)
,p_db_column_name=>'LIST_COMMENT'
,p_display_order=>14
,p_column_identifier=>'M'
,p_column_label=>'Comment'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3915711641592979)
,p_db_column_name=>'APPLIATION_ID'
,p_display_order=>15
,p_column_identifier=>'N'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3915918201605603)
,p_db_column_name=>'BUILD_OPTION'
,p_display_order=>16
,p_column_identifier=>'O'
,p_column_label=>'Build Option'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(655605494227595993)
,p_db_column_name=>'ICON_CLASS'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Icon Class'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(655605591038595994)
,p_db_column_name=>'ICON_TITLE'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Icon Title'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1418271239087539235)
,p_db_column_name=>'NAVBAR'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>'Navigation Bar'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_column_alignment=>'CENTER'
,p_rpt_named_lov=>wwv_flow_imp.id(84259319526460470)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1418271394145539235)
,p_db_column_name=>'GLOBAL_NAV'
,p_display_order=>22
,p_column_identifier=>'V'
,p_column_label=>'Navigation Menu'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_column_alignment=>'CENTER'
,p_rpt_named_lov=>wwv_flow_imp.id(84259319526460470)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2328774080872211736)
,p_db_column_name=>'IS_NAVBAR'
,p_display_order=>32
,p_column_identifier=>'W'
,p_column_label=>'Show only lists being used as navigation bar list'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2328774126972211737)
,p_db_column_name=>'IS_NAVMENU'
,p_display_order=>42
,p_column_identifier=>'X'
,p_column_label=>'Show only lists being used as navigation menu'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15002223050753513)
,p_db_column_name=>'SUBSCRIBED_FROM'
,p_display_order=>52
,p_column_identifier=>'Y'
,p_column_label=>'Subscribed From'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15002370011753514)
,p_db_column_name=>'SUBSCRIBERS'
,p_display_order=>62
,p_column_identifier=>'Z'
,p_column_label=>'Subscribers'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1497971703970626)
,p_db_column_name=>'ACTION'
,p_display_order=>72
,p_column_identifier=>'AA'
,p_column_label=>'Copy'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'TMPL_THEME_3$ACTIONS'
,p_column_alignment=>'CENTER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'ACTIONS_WRAP', 'N',
  'STYLE', 'b-InlineActions--simple')).to_clob
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2525607128409143)
,p_db_column_name=>'SUBSCRIPTION_STATUS'
,p_display_order=>82
,p_column_identifier=>'AB'
,p_column_label=>'Subscription Status'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(3853503855690337)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_type=>'REPORT'
,p_report_alias=>'primary'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_display_rows=>100
,p_view_mode=>'REPORT'
,p_report_columns=>'NAME:LIST_TYPE:ENTRIES:REF:LIST_LAST_UPDATED:NAVBAR:GLOBAL_NAV:SUBSCRIBED_FROM:SUBSCRIPTION_STATUS:SUBSCRIBERS:ACTION:'
,p_sort_column_1=>'NAME'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9323824066192830)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(2205558900359981)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(16367103652607085)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--sideRegion:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>A List is a template driven, shared collection of links.  Use Lists to add navigation to your application.</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(16374602660635162)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(62973516530710918)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Lists'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(109454730738768028)
,p_name=>'Recently Edited'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>60
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'REGION_POSITION_03'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P405b */',
'replace(replace(l.name,''_'','' ''),''.'','' '') name, id',
'from ',
'     wwv_flow_lists l',
'where l.flow_id = :fb_flow_id',
'and LAST_UPDATED_ON is not null',
'and security_group_id = :flow_security_group_id',
'order by LAST_UPDATED_ON desc'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(11667910335347890)
,p_query_num_rows=>10
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No lists found'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>10
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_prn_format=>'PDF'
,p_prn_output_show_link=>'Y'
,p_prn_output_link_text=>'Print'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Application &FB_FLOW_ID.: &FB_FLOW_NAME.'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#ffffff'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'LEFT'
,p_prn_page_footer_alignment=>'LEFT'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(109455021661768062)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:4050:&SESSION.::&DEBUG.:4050:F4000_P4050_LIST_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'N'
,p_print_col_width=>'50'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(109456924766785289)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_column_heading=>'&nbsp;'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_include_in_export=>'Y'
,p_print_col_width=>'50'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(872115436319501416)
,p_plug_name=>'Developer Resources'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(26512283167477231)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(188938308113866785)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(3852226590687921)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:405:&SESSION.::&DEBUG.:405,RIR::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1500396565970650)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(3852226590687921)
,p_button_name=>'COPY'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Copy'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:663:&SESSION.::&DEBUG.:663::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(16385219339744086)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(3852226590687921)
,p_button_name=>'CreateNewList'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:427:&SESSION.::&DEBUG.:427,440,464,529,734::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(58978832688376841)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'405'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(590030329537081954)
,p_name=>'Create Button - Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(16385219339744086)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(590030624679081954)
,p_event_id=>wwv_flow_imp.id(590030329537081954)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3852226590687921)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2209575014420406)
,p_name=>'Refresh Subscriptions'
,p_event_sequence=>20
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(9323824066192830)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2209933599420413)
,p_event_id=>wwv_flow_imp.id(2209575014420406)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3852226590687921)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2210403063420417)
,p_event_id=>wwv_flow_imp.id(2209575014420406)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ( this.data.successMessage ) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
);
wwv_flow_imp_page.create_component_action(
 p_id=>wwv_flow_imp.id(1498012847970627)
,p_ir_column_id=>wwv_flow_imp.id(1497971703970626)
,p_position_id=>wwv_flow_imp.id(214437533860142316)
,p_display_sequence=>10
,p_template_id=>wwv_flow_imp.id(214438625365151034)
,p_label=>'Copy'
,p_link_target_type=>'REDIRECT_PAGE'
,p_link_target=>'f?p=&APP_ID.:663:&SESSION.::&DEBUG.:663:P663_COPY_SOURCE,P663_ID,P663_COPY_FROM_APPLICATION_ID:THIS,#ID#,&FB_FLOW_ID.'
,p_button_display_type=>'ICON'
,p_icon_css_classes=>'icon-copy'
,p_is_hot=>false
,p_show_as_disabled=>false
);
end;
/
prompt --application/pages/page_00408
begin
wwv_flow_imp_page.create_page(
 p_id=>408
,p_name=>'Edit Item Help Text'
,p_alias=>'EDIT-ITEM-HELP-TEXT'
,p_step_title=>'Edit Item Help Text'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_hlp_text.htm'
,p_page_component_map=>'01'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(83241904638634075)
,p_name=>'Item help for all items in application'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>100
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select h.id, i.flow_step_id flow_item_id, h.help_text,',
'       wwv_flow_escape.html(substr(prompt,1,200))||''<br>''||',
'       ''<a href="f?p=4000:4500:''||:flow_session||''::NO::FB_FLOW_PAGE_ID:''||',
'       i.flow_step_id||''#5120:''||i.id||''">''||wwv_flow_escape.html(i.name)||''</a>'' item_name,',
'       nvl(length(h.help_text),0) text_length, i.display_as display_as,',
'       prompt,',
'       t.template_name label_template',
'  from WWV_FLOW_STEP_ITEM_HELP h, ',
'       wwv_flow_step_items i,',
'       wwv_flow_field_templates t',
' where h.flow_id = :fb_flow_id',
'   and i.id = h.flow_item_id(+) ',
'   and i.item_field_template = t.id (+)',
'   and (:P408_HELP_CONTAINS is null or',
'        instr(upper(h.help_text),upper(:P408_HELP_CONTAINS)) > 0) ',
'   and(:P408_ITEM_LABEL_CONTAINS is null or',
'       exists (select 1 ',
'               from wwv_flow_step_items s ',
'               where upper(s.prompt) like',
'                       ''%''||upper(:P408_ITEM_LABEL_CONTAINS)||''%'' and ',
'                     s.id = h.flow_item_id)) and',
'                     nvl(:P408_min_page,0) <= ',
'                    (select flow_step_id ',
'                     from wwv_flow_step_items ',
'                     where id = h.flow_item_id) ',
'   and (nvl(:P408_LENGTH,''1'') = ''1'' or ',
'        length(h.help_text) >= :P408_LENGTH or ',
'        (:P408_LENGTH = ''0'' and h.help_text is null) )',
'   and (nvl(:P408_MAXIMUM_LENGTH,''4000'') = ''4000'' or ',
'        length(help_text) <= :P408_MAXIMUM_LENGTH or ',
'        (:P408_MAXIMUM_LENGTH = ''0'' and h.help_text is null))',
'order by i.flow_step_id'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_item=>'P408_ROWS'
,p_query_num_rows_type=>'ROW_RANGES'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
,p_comment=>'Region generated 16-JUL-2003 16:52:04'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(100575450196284412)
,p_query_column_id=>1
,p_column_alias=>'ROWID'
,p_column_display_sequence=>9
,p_column_heading=>'Rowid'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(83242409180634082)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(83242501757634082)
,p_query_column_id=>3
,p_column_alias=>'FLOW_ITEM_ID'
,p_column_display_sequence=>2
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&FLOW_ID.:4500:#FLOW_SESSION#::::FB_FLOW_PAGE_ID:#FLOW_ITEM_ID#'
,p_column_linktext=>'#FLOW_ITEM_ID#'
,p_column_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(83242601975634082)
,p_query_column_id=>4
,p_column_alias=>'HELP_TEXT'
,p_column_display_sequence=>4
,p_column_heading=>'Item Help Text'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXTAREA'
,p_column_width=>50
,p_column_height=>3
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(83382014198640933)
,p_query_column_id=>5
,p_column_alias=>'ITEM_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Item Label and Name'
,p_use_as_row_header=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(83277013096780953)
,p_query_column_id=>6
,p_column_alias=>'TEXT_LENGTH'
,p_column_display_sequence=>8
,p_column_heading=>'Text Length'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G990'
,p_column_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(86954914093835714)
,p_query_column_id=>7
,p_column_alias=>'DISPLAY_AS'
,p_column_display_sequence=>6
,p_column_heading=>'Display As'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(29353308376249352)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(232981709567058956)
,p_query_column_id=>8
,p_column_alias=>'PROMPT'
,p_column_display_sequence=>5
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(506338411372621393)
,p_query_column_id=>9
,p_column_alias=>'LABEL_TEMPLATE'
,p_column_display_sequence=>7
,p_column_heading=>'Label Template'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(83246323649640377)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(83246419054640380)
,p_column_sequence=>2
,p_query_column_name=>'FLOW_ITEM_ID'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(83246500178640380)
,p_column_sequence=>3
,p_query_column_name=>'HELP_TEXT'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(83381800922640931)
,p_column_sequence=>4
,p_query_column_name=>'ITEM_NAME'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(83276904305780951)
,p_column_sequence=>5
,p_query_column_name=>'TEXT_LENGTH'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(86954816677835705)
,p_column_sequence=>6
,p_query_column_name=>'DISPLAY_AS'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(232981609633058898)
,p_column_sequence=>7
,p_query_column_name=>'PROMPT'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(506338313380621387)
,p_column_sequence=>8
,p_query_column_name=>'LABEL_TEMPLATE'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(152757429221968450)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>93
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(194137629006054982)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>91
,p_list_id=>wwv_flow_imp.id(186703109122914661)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(83268213269713109)
,p_button_sequence=>62
,p_button_plug_id=>wwv_flow_imp.id(152757429221968450)
,p_button_name=>'P408_GO'
,p_button_static_id=>'P408_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Go'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(240660527917823543)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(152757429221968450)
,p_button_name=>'SEED_ITEM_HELP_TEXT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Seed Item Help Text'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:13:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(83242820615634083)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(152757429221968450)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_security_scheme=>wwv_flow_imp.id(34674432490821717)
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(83243726157634087)
,p_branch_action=>'f?p=&FLOW_ID.:408:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>21
,p_branch_comment=>'Generated 16-JUL-2003 16:52:04'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(83267109459712051)
,p_name=>'P408_HELP_CONTAINS'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(152757429221968450)
,p_prompt=>'Help Contains'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Enter a query to search for item help text and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(83384715158650375)
,p_name=>'P408_ITEM_LABEL_CONTAINS'
,p_item_sequence=>3
,p_item_plug_id=>wwv_flow_imp.id(152757429221968450)
,p_prompt=>'Item Label Contains'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Enter a query to search for item label text and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(83401518284727023)
,p_name=>'P408_ROWS'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(152757429221968450)
,p_item_default=>'20'
,p_prompt=>'Rows'
,p_source=>'20'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAXIMUM ROWS PER PAGE'
,p_lov=>'.'||wwv_flow_imp.id(84800803131139158)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identify the number of items to display in the report and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(83479318994928899)
,p_name=>'P408_MIN_PAGE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(152757429221968450)
,p_item_default=>'0'
,p_prompt=>'Minimum Page Number'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>8
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identify the minimum page number to be returned by this search.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(84374716671828683)
,p_name=>'P408_LENGTH'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(152757429221968450)
,p_item_default=>'1'
,p_prompt=>'Minimum Length'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>8
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identify the minimum length of item help strings to be returned by this search.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(85135225207965242)
,p_name=>'P408_MAXIMUM_LENGTH'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(152757429221968450)
,p_prompt=>'Maximum Length'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>8
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identify the maximum length of item help strings to be returned by this search.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(83243302489634085)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(83241904638634075)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'ApplyMRU'
,p_attribute_02=>'WWV_FLOW_STEP_ITEM_HELP'
,p_attribute_03=>'ID'
,p_attribute_05=>'flow_id = :FB_FLOW_ID and security_group_id = :WORKSPACE_ID'
,p_process_error_message=>'Error processing update.'
,p_process_when_button_id=>wwv_flow_imp.id(83242820615634083)
,p_process_success_message=>'#MRU_COUNT# row(s) updated.'
,p_security_scheme=>wwv_flow_imp.id(34674432490821717)
,p_internal_uid=>83243302489634085
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(83252621140658581)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'rp'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>83252621140658581
);
end;
/
prompt --application/pages/page_00410
begin
wwv_flow_imp_page.create_page(
 p_id=>410
,p_name=>'Confirm Copy Theme'
,p_alias=>'CONFIRM-COPY-THEME'
,p_step_title=>'Copy Theme'
,p_allow_duplicate_submissions=>'N'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879423075323511)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_themes.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(60297525857108229)
,p_plug_name=>'Confirm Theme Copy'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>131
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(106497805751430232)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>31
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(106491204103410821)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(200254321663371405)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>141
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747141822577138162)
,p_plug_name=>'Copy Theme'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(60299526820108242)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(200254321663371405)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(60298707061108240)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(200254321663371405)
,p_button_name=>'CHANGE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy Theme'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(60299103865108241)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(200254321663371405)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:401:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(60301629315108266)
,p_branch_action=>'f?p=&FLOW_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(60299912376108248)
,p_name=>'P410_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(60297525857108229)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application:'
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'This attribute identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(60300304760108257)
,p_name=>'P410_COPY_THEME_FROM_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(60297525857108229)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Copy Theme ID from:'
,p_source=>'P401_COPY_FROM_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies a collection of templates which define the look and feel of the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(60300708612108258)
,p_name=>'P410_COPY_TO_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(60297525857108229)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Copy Theme ID to:'
,p_source=>'P401_COPY_TO_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>12
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies a collection of templates which define the look and feel of the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(60301216009108264)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy theme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_theme_manager.copy_theme(',
'  p_from_flow_id    => :P401_APPLICATION, ',
'  p_to_flow_id      => :fb_flow_id, ',
'  p_from_theme      => :P401_COPY_FROM_ID , ',
'  p_to_theme        => :P401_COPY_TO_ID,',
'  p_subscribe_theme => (:P401_SUBSCRIBE_THEME=''Y'')',
');'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to copy theme.'
,p_process_when_button_id=>wwv_flow_imp.id(60298707061108240)
,p_process_success_message=>'Theme copied.'
,p_internal_uid=>60301216009108264
);
end;
/
prompt --application/pages/page_00412
begin
wwv_flow_imp_page.create_page(
 p_id=>412
,p_name=>'Create List Template - Identify Theme'
,p_alias=>'CREATE-LIST-TEMPLATE-IDENTIFY-THEME'
,p_page_mode=>'MODAL'
,p_step_title=>'Create List Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(152181100157104536)
,p_plug_name=>'Create List Template'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<p>A Theme is a named collection of Templates.  An Application can have one or more Themes.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(152181510374104540)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(320074633987)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(186373505426133557)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(152182729615104543)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(186373505426133557)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(152183524736104546)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(186373505426133557)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(152183120977104546)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(186373505426133557)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(152188902322104566)
,p_branch_action=>'f?p=&FLOW_ID.:159:&SESSION.::&DEBUG.:159::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(152183524736104546)
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(585125146735099814)
,p_branch_action=>'f?p=&APP_ID.:4069:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(152183120977104546)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(152183920997104548)
,p_name=>'P412_X'
,p_item_sequence=>11
,p_item_plug_id=>wwv_flow_imp.id(152181100157104536)
,p_post_element_text=>'<br />'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(152184603209104552)
,p_name=>'P412_FROM_APP'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_imp.id(152181100157104536)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application:'
,p_source=>'F4000_P4069_COPY_FROM_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identifies the application from which the theme will be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(152185312007104555)
,p_name=>'P412_COPY_TO'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_imp.id(152181100157104536)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application:'
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identifies the application to which the template will be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(152186006914104556)
,p_name=>'P412_F'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(152181100157104536)
,p_prompt=>'Copy From:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the theme to copy from.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(152186731846104557)
,p_name=>'P412_TO'
,p_item_sequence=>12
,p_item_plug_id=>wwv_flow_imp.id(152181100157104536)
,p_prompt=>'Copy To:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the theme to which the templates will be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(152187412516104559)
,p_name=>'P412_COPY_FROM_THEME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(152181100157104536)
,p_prompt=>'Theme'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(theme_name) d, theme_id',
'from   wwv_flow_themes',
'where  flow_id = :F4000_P4069_COPY_FROM_FLOW_ID  ',
'order by 1'))
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the theme from which you wish to copy templates.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(152188124711104560)
,p_name=>'P412_COPY_TO_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(152181100157104536)
,p_prompt=>'Theme'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the theme to which the template will be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2346316376971914203)
,p_computation_sequence=>10
,p_computation_item=>'F4000_COPY_TO_THEME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P412_COPY_TO_THEME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(585124902185099812)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(152182729615104543)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(585125087770099813)
,p_event_id=>wwv_flow_imp.id(585124902185099812)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00413
begin
wwv_flow_imp_page.create_page(
 p_id=>413
,p_name=>'Create Button Template - Identify Theme'
,p_alias=>'CREATE-BUTTON-TEMPLATE-IDENTIFY-THEME'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Button Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(154552725827206716)
,p_plug_name=>'Create Button Template'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<p>A Theme is a named collection of Templates.  An Application can have one or more Themes.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(154553132414206727)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(320074633987)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(186378501018189095)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(154554304247206734)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(186378501018189095)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(154555100740206743)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(186378501018189095)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(154554703210206743)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(186378501018189095)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(154560510194206783)
,p_branch_action=>'f?p=&FLOW_ID.:223:&SESSION.::&DEBUG.:223::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(154555100740206743)
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(585126834896099831)
,p_branch_action=>'f?p=&APP_ID.:219:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(154554703210206743)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(154555508995206745)
,p_name=>'P413_X'
,p_item_sequence=>11
,p_item_plug_id=>wwv_flow_imp.id(154552725827206716)
,p_post_element_text=>'<br />'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(154556224411206754)
,p_name=>'P413_FROM_APP'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_imp.id(154552725827206716)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application:'
,p_source=>'F4000_P219_COPY_FROM_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identifies the application from which the theme will be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(154556932617206758)
,p_name=>'P413_COPY_TO'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_imp.id(154552725827206716)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application:'
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identifies the application to which the template will be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(154557625846206759)
,p_name=>'P413_F'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(154552725827206716)
,p_prompt=>'Copy From:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the theme to copy from.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(154558319348206760)
,p_name=>'P413_TO'
,p_item_sequence=>12
,p_item_plug_id=>wwv_flow_imp.id(154552725827206716)
,p_prompt=>'Copy To:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the theme to which the template will be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(154559024463206761)
,p_name=>'P413_COPY_FROM_THEME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(154552725827206716)
,p_prompt=>'Theme'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(theme_name) d, theme_id',
'from   wwv_flow_themes',
'where  flow_id = :F4000_P219_COPY_FROM_FLOW_ID   ',
'order by 1'))
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the theme from which you wish to copy templates.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(154559729010206763)
,p_name=>'P413_COPY_TO_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(154552725827206716)
,p_prompt=>'Theme'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t_to.theme_id||''. '' ||t_to.theme_name as d,',
'       t_to.theme_id',
'  from wwv_flow_themes t_from,',
'       wwv_flow_themes t_to',
' where t_from.flow_id           = :F4000_P219_COPY_FROM_FLOW_ID',
'   and t_from.theme_id          = :P413_COPY_FROM_THEME',
'   and t_from.security_group_id = :WORKSPACE_ID  ',
'   and t_to.flow_id             = :fb_flow_id',
'   and t_to.security_group_id   = :WORKSPACE_ID  ',
' order by t_to.theme_id'))
,p_lov_cascade_parent_items=>'P413_COPY_FROM_THEME'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the theme to which the template will be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2346316420352914204)
,p_computation_sequence=>10
,p_computation_item=>'F4000_COPY_TO_THEME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P413_COPY_TO_THEME'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(201412702449870614)
,p_computation_sequence=>10
,p_computation_item=>'P413_COPY_FROM_THEME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id',
'from   wwv_flow_themes',
'where  flow_id = :F4000_P219_COPY_FROM_FLOW_ID   ',
'order by 1'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(585126648527099829)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(154554304247206734)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(585126707576099830)
,p_event_id=>wwv_flow_imp.id(585126648527099829)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00414
begin
wwv_flow_imp_page.create_page(
 p_id=>414
,p_name=>'Item Substitution Finder'
,p_alias=>'ITEM-SUBSTITUTION-FINDER'
,p_step_title=>'Item Substitution Finder'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript1.1" type="text/javascript">',
'function passBack(x)',
'{',
'    temp = document.getElementById(''P414_CALLING_FIELD'').value;',
'    targetField = window.opener.document.getElementById(temp);',
'    targetField.value = x;',
'    targetField.focus;',
'    close();',
'    //opener.document.forms["wwv_flow"].targetField.value = x;',
'    //opener.document.forms["wwv_flow"].targetField.focus();',
'    //close();',
'}',
'</script>'))
,p_step_template=>wwv_flow_imp.id(19943204431962826)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_item.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(19710231706789100)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>100
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(19710526685789103)
,p_name=>'Items'
,p_template=>wwv_flow_imp.id(208928010704475743)
,p_display_sequence=>140
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<a href="javascript:passBack(''''''||''\&''||wwv_flow_escape.html(name)||''.''||'''''');">&''||wwv_flow_escape.html(name)||''.</a>''  name1 , wwv_flow_lang.system_message(''F4000.APPLICATION_ITEM'') t, 0 p ,2 seq',
'from wwv_flow_items',
'where (instr(name,upper(:P414_SEARCH)) > 0 OR :P414_SEARCH IS NULL) and',
'   :P414_PAGE is null',
'and flow_id = :fb_flow_id',
'union all',
'select ''<a href="javascript:passBack(''''''||''\&''||wwv_flow_escape.html(name)||''.''||'''''');">&''||wwv_flow_escape.html(name)||''.</a>'' name1 , wwv_flow_lang.system_message(''F4000.PAGE_ITEM'') t, flow_step_id p, 2 seq',
'from wwv_flow_step_items',
'where (instr(name,upper(:P414_SEARCH)) > 0 OR :P414_SEARCH IS NULL) and',
'   (:P414_PAGE is null or :P414_PAGE = flow_step_id)',
'and flow_id = :fb_flow_id',
'order by seq,1'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_num_rows_item=>'P414_MAX_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48786014414772209)
,p_query_column_id=>1
,p_column_alias=>'NAME1'
,p_column_display_sequence=>1
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48786121240772209)
,p_query_column_id=>2
,p_column_alias=>'T'
,p_column_display_sequence=>2
,p_column_heading=>'Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48786224180772209)
,p_query_column_id=>3
,p_column_alias=>'P'
,p_column_display_sequence=>3
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(106619310130591618)
,p_query_column_id=>4
,p_column_alias=>'SEQ'
,p_column_display_sequence=>4
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(19712622853789146)
,p_button_sequence=>129
,p_button_plug_id=>wwv_flow_imp.id(19710231706789100)
,p_button_name=>'P414_GO'
,p_button_static_id=>'P414_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Go'
,p_button_alignment=>'LEFT-CENTER'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(19711719596789116)
,p_name=>'P414_SEARCH'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(19710231706789100)
,p_prompt=>'Search'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Enter a case insensitive query and click <strong>Go</strong>. To view all, leave the field blank and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(19712024851789143)
,p_name=>'P414_PAGE'
,p_item_sequence=>109
,p_item_plug_id=>wwv_flow_imp.id(19710231706789100)
,p_prompt=>'Page'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d',
'  from wwv_flow_steps',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and is_page_pattern   = ''N''',
'order by 2'))
,p_cSize=>8
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'To display only items on a particular page, select or enter a page number and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(19712322858789145)
,p_name=>'P414_MAX_ROWS'
,p_item_sequence=>119
,p_item_plug_id=>wwv_flow_imp.id(19710231706789100)
,p_item_default=>'15'
,p_prompt=>'Rows'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAXIMUM ROWS PER PAGE'
,p_lov=>'.'||wwv_flow_imp.id(84800803131139158)||'.'
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Select the number of rows to display on the report and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(19712930226789147)
,p_name=>'P414_CALLING_FIELD'
,p_item_sequence=>109
,p_item_plug_id=>wwv_flow_imp.id(19710526685789103)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(19713331669789167)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pg'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>19713331669789167
);
end;
/
prompt --application/pages/page_00415
begin
wwv_flow_imp_page.create_page(
 p_id=>415
,p_name=>'Create Breadcrumb Template - Identify Theme'
,p_alias=>'CREATE-BREADCRUMB-TEMPLATE-IDENTIFY-THEME'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Breadcrumb Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213261028690930718)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_breadcrumb.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(154578426244360407)
,p_plug_name=>'Create Breadcrumb Template'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<p>A Theme is a named collection of Templates.  An Application can have one or more Themes.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(154578800368360412)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(320074633987)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(186383515872240645)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(154580019749360416)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(186383515872240645)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(154580817404360420)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(186383515872240645)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(154580422398360420)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(186383515872240645)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(154586201863360441)
,p_branch_action=>'f?p=&FLOW_ID.:242:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(154580817404360420)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(585128528551099848)
,p_branch_action=>'f?p=&APP_ID.:241:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(154580422398360420)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(154581227773360422)
,p_name=>'P415_FROM_APP'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_imp.id(154578426244360407)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application:'
,p_source=>'F4000_P241_COPY_FROM_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identifies the application from which the theme will be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(154581908878360426)
,p_name=>'P415_COPY_TO'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_imp.id(154578426244360407)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application:'
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identifies the application to which template will be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(154582621781360427)
,p_name=>'P415_F'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(154578426244360407)
,p_prompt=>'Copy From:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the theme to copy from.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(154583307331360432)
,p_name=>'P415_TO'
,p_item_sequence=>12
,p_item_plug_id=>wwv_flow_imp.id(154578426244360407)
,p_prompt=>'Copy To:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the theme to which the template will be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(154584002607360433)
,p_name=>'P415_COPY_FROM_THEME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(154578426244360407)
,p_prompt=>'Theme'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(theme_name) d, theme_id',
'from   wwv_flow_themes',
'where  flow_id = :F4000_P241_COPY_FROM_FLOW_ID   ',
'order by 1'))
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the theme from which you wish to copy templates.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(154584731052360434)
,p_name=>'P415_COPY_TO_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(154578426244360407)
,p_prompt=>'Theme'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the theme to which the template will be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(154585420503360435)
,p_name=>'P415_X'
,p_item_sequence=>11
,p_item_plug_id=>wwv_flow_imp.id(154578426244360407)
,p_post_element_text=>'<br />'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2346316632669914206)
,p_computation_sequence=>10
,p_computation_item=>'F4000_COPY_TO_THEME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P415_COPY_TO_THEME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(585128342482099846)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(154580019749360416)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(585128408497099847)
,p_event_id=>wwv_flow_imp.id(585128342482099846)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00417
begin
wwv_flow_imp_page.create_page(
 p_id=>417
,p_name=>'List Utilization Page References'
,p_alias=>'LIST-UTILIZATION-PAGE-REFERENCES'
,p_step_title=>'List Utilization Page References'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_list.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7390729703813409)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>0
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(62973516530710918)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(161737509765957489)
,p_plug_name=>'List Utilization'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'This page identifies pages that reference the selected list.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(185271801825507433)
,p_plug_name=>'List Utilization Page References'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select l.name      as list_name,',
'       p.page_id,',
'       (',
'           select name',
'             from wwv_flow_steps',
'            where flow_id = :fb_flow_id',
'              and id      = p.page_id',
'       )           as page_name,',
'       p.plug_name as region_name,',
'       l.id        as list_id,',
'       null        as referenced_by,',
'       null        as referenced_by_item_id,',
'       null        as referenced_by_list_id',
'  from wwv_flow_page_plugs p,',
'       wwv_flow_lists l',
' where l.flow_id = :fb_flow_id',
'   and p.flow_id = :fb_flow_id',
'   and p.list_id = l.id',
'union all',
'select l.name as list_name,',
'       p.id   as page_id,',
'       p.name as page_name,',
'       null   as region_name,',
'       l.id   as list_id,',
'       null   as referenced_by,',
'       null   as referenced_by_item_id,',
'       null   as referenced_by_list_id',
'  from wwv_flow_steps p,',
'       wwv_flow_lists l',
' where l.flow_id            = :fb_flow_id',
'   and p.flow_id            = :fb_flow_id',
'   and p.navigation_list_id = l.id',
'union all',
'select l.name as list_name,',
'       null   as page_id,',
'       null   as page_name,',
'       null   as region_name,',
'       l.id   as list_id,',
'       null   as referenced_by,',
'       null   as referenced_by_item_id,',
'       null   as referenced_by_list_id',
'  from wwv_flows f,',
'       wwv_flow_lists l',
' where l.flow_id = :fb_flow_id',
'   and f.id      = :fb_flow_id',
'   and l.id in (f.navigation_list_id, f.nav_bar_list_id)',
'union all',
'select l.name                                 as list_name,',
'       null                                   as page_id,',
'       null                                   as page_name,',
'       null                                   as region_name,',
'       l.id                                   as list_id,',
'       r.name || '' \ '' || i.list_item_link_text as referenced_by,',
'       i.id                                   as referenced_by_item_id,',
'       r.id                                   as referenced_by_list_id',
'  from wwv_flow_lists l,',
'       wwv_flow_list_items i,',
'       wwv_flow_lists r',
' where l.flow_id     = :fb_flow_id',
'   and i.flow_id     = :fb_flow_id',
'   and i.sub_list_id = l.id',
'   and r.id          = i.list_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(185271900690507433)
,p_name=>'List Utilization Page References'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(185272130425507436)
,p_db_column_name=>'LIST_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'List Name'
,p_column_link=>'f?p=&APP_ID.:4050:&SESSION.::&DEBUG.:RP,4050:F4000_P4050_LIST_ID:#LIST_ID#'
,p_column_linktext=>'#LIST_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(185272424002507438)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(185272511819507439)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Page Name / User Interface'
,p_column_link=>'f?p=#FLOW_ID#:4500:#FLOW_SESSION#::::FB_FLOW_PAGE_ID:#PAGE_ID#'
,p_column_linktext=>'#PAGE_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(185272616709507440)
,p_db_column_name=>'REGION_NAME'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Region'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(185272706418507440)
,p_db_column_name=>'LIST_ID'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Selected List'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3001754283102312)
,p_db_column_name=>'REFERENCED_BY'
,p_display_order=>17
,p_column_identifier=>'H'
,p_column_label=>'Referenced by List Entry'
,p_column_link=>'f?p=&APP_ID.:4052:&SESSION.::&DEBUG.:4050,4052:F4000_P4052_id,F4000_P4050_LIST_ID:#REFERENCED_BY_ITEM_ID#,#REFERENCED_BY_LIST_ID#'
,p_column_linktext=>'#REFERENCED_BY#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3002874954102323)
,p_db_column_name=>'REFERENCED_BY_ITEM_ID'
,p_display_order=>27
,p_column_identifier=>'L'
,p_column_label=>'Referenced By Item Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3002959508102324)
,p_db_column_name=>'REFERENCED_BY_LIST_ID'
,p_display_order=>37
,p_column_identifier=>'M'
,p_column_label=>'Referenced By List Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(185272916759507952)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1288930707536643'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'LIST_NAME:ID:LIST_TEMPLATE_NAME:PAGE_ID:PAGE_NAME:REGION_NAME:LIST_ID:REFERENCED_BY:REFERENCED_BY_ITEM_ID:REFERENCED_BY_LIST_ID'
,p_sort_column_1=>'LIST_NAME'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'PAGE_ID'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(185274814728535753)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(185271801825507433)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(44051606540921535)
,p_branch_action=>'f?p=&FLOW_ID.:417:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(44074931033037275)
,p_name=>'P417_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(185271801825507433)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_00418
begin
wwv_flow_imp_page.create_page(
 p_id=>418
,p_name=>'Create Legacy Calendar Template - Identify Theme'
,p_alias=>'CREATE-LEGACY-CALENDAR-TEMPLATE-IDENTIFY-THEME'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Legacy Calendar Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(154611503855448015)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(320074633987)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(154611930364448016)
,p_plug_name=>'Create Legacy Calendar Template'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<p>A Theme is a named collection of Templates.  An Application can have one or more Themes.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(186388517828307448)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(154612323383448018)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(186388517828307448)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(154613117222448020)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(186388517828307448)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(154612726149448020)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(186388517828307448)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(154618523699448048)
,p_branch_action=>'f?p=&FLOW_ID.:469:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(154613117222448020)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(589887020729923015)
,p_branch_action=>'f?p=&APP_ID.:468:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(154612726149448020)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(154613515130448023)
,p_name=>'P418_FROM_APP'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_imp.id(154611930364448016)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application:'
,p_source=>'P468_COPY_FROM_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identifies the application from which the theme will be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(154614224756448033)
,p_name=>'P418_COPY_TO'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_imp.id(154611930364448016)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application:'
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identifies the application to which templates will be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(154614927630448035)
,p_name=>'P418_F'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(154611930364448016)
,p_prompt=>'Copy From:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the theme to copy from.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(154615607822448036)
,p_name=>'P418_TO'
,p_item_sequence=>12
,p_item_plug_id=>wwv_flow_imp.id(154611930364448016)
,p_prompt=>'Copy To:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the theme to copy templates to.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(154616323914448038)
,p_name=>'P418_COPY_FROM_THEME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(154611930364448016)
,p_prompt=>'Theme'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(theme_name) d, theme_id',
'from   wwv_flow_themes',
'where  flow_id = :P468_COPY_FROM_FLOW_ID  ',
'order by 1'))
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the theme from which you wish to copy templates.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(154617000825448039)
,p_name=>'P418_COPY_TO_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(154611930364448016)
,p_prompt=>'Theme'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the theme to which templates will be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(154617705762448042)
,p_name=>'P418_X'
,p_item_sequence=>11
,p_item_plug_id=>wwv_flow_imp.id(154611930364448016)
,p_post_element_text=>'<br />'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2346316795230914207)
,p_computation_sequence=>10
,p_computation_item=>'F4000_COPY_TO_THEME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P418_COPY_TO_THEME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(589886807208923013)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(154612323383448018)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(589886922936923014)
,p_event_id=>wwv_flow_imp.id(589886807208923013)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00419
begin
wwv_flow_imp_page.create_page(
 p_id=>419
,p_name=>'Locally Defined Lists of Values'
,p_alias=>'LOCALLY-DEFINED-LISTS-OF-VALUES'
,p_step_title=>'Locally Defined Lists of Values'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5092501799941838)
,p_plug_name=>'Locally Defined LOVs'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select flow_step_id,',
'       name,',
'       substr(lov,1,3000) lov,',
'       id,',
'       flow_id appl_id,',
'       id action,',
'       ''PAGE_ITEM'' source_type,',
'       ''PAGE_ITEM'' source_type_disp       ',
'  from wwv_flow_step_items',
' where flow_id = to_number(:FB_FLOW_ID)',
'   and security_group_id = to_number(:FLOW_SECURITY_GROUP_ID)',
'   and lov is not null',
'   and named_lov is null',
' union all',
'select page_id flow_step_id,',
'       name,',
'       substr(lov_source,1,3000) lov_source,',
'       id,',
'       flow_id appl_id,',
'       id action,',
'       ''IG_COLUMN'' source_type,',
'       ''IG_COLUMN'' source_type_disp       ',
'  from wwv_flow_region_columns',
' where flow_id = to_number(:FB_FLOW_ID)',
'   and security_group_id = to_number(:FLOW_SECURITY_GROUP_ID)',
'   and lov_source is not null',
'   and lov_id is null'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(5092616502941838)
,p_name=>'All items with a locally defined LOV in application'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5093117980941841)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'D'
,p_column_label=>'Edit'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5092818622941841)
,p_db_column_name=>'FLOW_STEP_ID'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5092909205941841)
,p_db_column_name=>'NAME'
,p_display_order=>3
,p_column_identifier=>'B'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5093026781941841)
,p_db_column_name=>'LOV'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>'List of Values'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5093221938941841)
,p_db_column_name=>'APPL_ID'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Appl_Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(676797610069887615)
,p_db_column_name=>'ACTION'
,p_display_order=>15
,p_column_identifier=>'F'
,p_column_label=>'Action'
,p_column_link=>'f?p=&APP_ID.:52:&SESSION.::&DEBUG.:RP,52:F4000_P52_SOURCE_ID,F4000_P52_SOURCE_TYPE:#ID#,#SOURCE_TYPE#'
,p_column_linktext=>'Convert'
,p_column_link_attr=>'class="a-Button a-Button--small"'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'NUMBER'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2701992394095217)
,p_db_column_name=>'SOURCE_TYPE'
,p_display_order=>25
,p_column_identifier=>'G'
,p_column_label=>'Type'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2702027978095218)
,p_db_column_name=>'SOURCE_TYPE_DISP'
,p_display_order=>35
,p_column_identifier=>'H'
,p_column_label=>'Type'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(3801130412459159)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(5093412475942218)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1289002855536644'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'FLOW_STEP_ID:NAME:SOURCE_TYPE_DISP:LOV:ACTION:'
,p_sort_column_1=>'FLOW_STEP_ID'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47155605424266875)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(203029530177365353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Lists of Values'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(240644224753794260)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Use this report to view all lists of values that are defined locally with the definition of the item or interactive grid column.  Lists of values that are usable by multiple pages can be converted into shared lists of values.  Converting locally d'
||'efined lists of values into a shared list of values promotes reuse.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(188989617066991407)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(5092501799941838)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:419:&SESSION.::&DEBUG.:419,RIR::'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(681995446457644709)
,p_name=>'Refresh on Dialog Close'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(5092501799941838)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(681995547673644710)
,p_event_id=>wwv_flow_imp.id(681995446457644709)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(5092501799941838)
);
end;
/
prompt --application/pages/page_00425
begin
wwv_flow_imp_page.create_page(
 p_id=>425
,p_name=>'Database Object Dependencies'
,p_alias=>'DATABASE-OBJECT-DEPENDENCIES'
,p_step_title=>'Database Object Dependencies'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216995930363945283)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_utilties.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(117041714963183518)
,p_plug_name=>'Dependencies Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>81
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(117039522797176386)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'1=2'
,p_plug_display_when_cond2=>'SQL'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(189978131357209480)
,p_name=>'Database Object Dependencies'
,p_template=>wwv_flow_imp.id(208928010704475743)
,p_display_sequence=>145
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_region_attributes=>'style="float:left;clear:both;"'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'decode(c003,''NON-EXISTENT'',wwv_flow_lang.system_message(''LAYOUT.T_PAGE_PUBLIC''),c001) c001,',
'c002,',
'decode(c003,''NON-EXISTENT'',c002, c002) name,',
'initcap(decode(c003,''NON-EXISTENT'',null,htmldb_item.text_from_lov(c003,''OBJECT.TYPES''))) c003,',
'count(*) c,',
'c012',
'from htmldb_collections',
'where collection_name = ''ALL_DEPENDENCIES''',
'  and c008 = :fb_flow_id',
'  and c002 <> ''PLITBLM''',
'group by c001,c002,c003,c012',
'order by 1,2,3'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from wwv_flow_collections',
'where collection_name = ''ALL_DEPENDENCIES_INIT'' and ',
'      c002 is null and ',
'      c001 = :fb_flow_id'))
,p_display_condition_type=>'EXISTS'
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>50000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1:2'
,p_query_no_data_found=>'No dependencies found'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
,p_comment=>'c003 != ''NON-EXISTENT'' and -- objects referenced through public synonyms'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(189978616640209486)
,p_query_column_id=>1
,p_column_alias=>'C001'
,p_column_display_sequence=>1
,p_column_heading=>'Owner'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(189978710291209486)
,p_query_column_id=>2
,p_column_alias=>'C002'
,p_column_display_sequence=>3
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(217916907698969155)
,p_query_column_id=>3
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Referenced Name'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(189978820234209486)
,p_query_column_id=>4
,p_column_alias=>'C003'
,p_column_display_sequence=>4
,p_column_heading=>'Referenced Type'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(189978515126209485)
,p_query_column_id=>5
,p_column_alias=>'C'
,p_column_display_sequence=>5
,p_column_heading=>'Reference Count'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:434:&SESSION.::&DEBUG.:RP,:P434_OBJECT_NAME,P434_OBJECT_OWNER:#C002#,#C001#'
,p_column_linktext=>'#C#'
,p_column_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(199906008859604604)
,p_query_column_id=>6
,p_column_alias=>'C012'
,p_column_display_sequence=>6
,p_column_heading=>'C012'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(189978930676209486)
,p_name=>'Parsing Errors'
,p_template=>wwv_flow_imp.id(689970285456172024)
,p_display_sequence=>151
,p_region_template_options=>'#DEFAULT#:is-collapsed'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'c001 obj_name,',
'c002,',
'c003,',
'c004,',
'c005,',
'c006,',
'c007,',
'c008,',
'c009,',
'c010,',
'c011,',
'c012',
'from htmldb_collections',
'where collection_name = ''ALL_DEPENDENCIES_ERRORS'''))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from wwv_flow_collections',
'where collection_name = ''ALL_DEPENDENCIES_INIT'' and ',
'      c002 is null and ',
'      c001 = :fb_flow_id'))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>50000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No parsing errors found'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1301369475015065003)
,p_query_column_id=>1
,p_column_alias=>'OBJ_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(189979403132209488)
,p_query_column_id=>2
,p_column_alias=>'C002'
,p_column_display_sequence=>2
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#C002#'
,p_column_linktext=>'#C002#'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(189979522257209488)
,p_query_column_id=>3
,p_column_alias=>'C003'
,p_column_display_sequence=>3
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(189979611762209488)
,p_query_column_id=>4
,p_column_alias=>'C004'
,p_column_display_sequence=>4
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(189979700821209489)
,p_query_column_id=>5
,p_column_alias=>'C005'
,p_column_display_sequence=>5
,p_column_heading=>'Error'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(189980304369209489)
,p_query_column_id=>6
,p_column_alias=>'C006'
,p_column_display_sequence=>6
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(189980417842209489)
,p_query_column_id=>7
,p_column_alias=>'C007'
,p_column_display_sequence=>7
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(189979827650209489)
,p_query_column_id=>8
,p_column_alias=>'C008'
,p_column_display_sequence=>8
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(189979909579209489)
,p_query_column_id=>9
,p_column_alias=>'C009'
,p_column_display_sequence=>9
,p_column_heading=>'Compiled As'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(189980212117209489)
,p_query_column_id=>10
,p_column_alias=>'C010'
,p_column_display_sequence=>10
,p_column_heading=>'Parsed As'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(189980015277209489)
,p_query_column_id=>11
,p_column_alias=>'C011'
,p_column_display_sequence=>11
,p_column_heading=>'Temp Object Status'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(189980130700209489)
,p_query_column_id=>12
,p_column_alias=>'C012'
,p_column_display_sequence=>12
,p_column_heading=>'Lines'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(189980503162209490)
,p_plug_name=>'top bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>90
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(189983008511209494)
,p_name=>'Report Parameters'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>91
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001,c002,c003,c004',
'from wwv_flow_collections',
'where collection_name = ''ALL_DEPENDENCIES_INIT'' and ',
' c002 is null and ',
' c001 = :fb_flow_id'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(82408032331628644)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(189983421297209495)
,p_query_column_id=>1
,p_column_alias=>'C001'
,p_column_display_sequence=>1
,p_column_heading=>'Application'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(189983524853209495)
,p_query_column_id=>2
,p_column_alias=>'C002'
,p_column_display_sequence=>2
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#C002#'
,p_column_linktext=>'#C002#'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(189983604131209495)
,p_query_column_id=>3
,p_column_alias=>'C003'
,p_column_display_sequence=>3
,p_column_heading=>'Report Date'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(189983722367209495)
,p_query_column_id=>4
,p_column_alias=>'C004'
,p_column_display_sequence=>4
,p_column_heading=>'Developer'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(199893827728572290)
,p_plug_name=>'Dependencies'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>71
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>This report identifies the database objects referenced by this application.  Click on the reference count value to view the components that reference a specific database object.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(189983829733209496)
,p_button_sequence=>3
,p_button_plug_id=>wwv_flow_imp.id(189980503162209490)
,p_button_name=>'COMPUTE_DEPENDENCIES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Compute Dependencies'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(189988600686209526)
,p_branch_action=>'f?p=&FLOW_ID.:425:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(189988201444209523)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate collection'
,p_process_sql_clob=>'wwv_flow_theme_manager.find_object_dependencies(p_flow_id=>:fb_flow_id,p_page_id=>null);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to populate collection.'
,p_process_when_button_id=>wwv_flow_imp.id(189983829733209496)
,p_internal_uid=>189988201444209523
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(189987812224209522)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pagination'
,p_attribute_01=>'THIS_PAGE'
,p_internal_uid=>189987812224209522
);
end;
/
prompt --application/pages/page_00427
begin
wwv_flow_imp_page.create_page(
 p_id=>427
,p_name=>'Create List - Name and Type'
,p_alias=>'CREATE-LIST-NAME-AND-TYPE'
,p_page_mode=>'MODAL'
,p_step_title=>'Create List'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213210808239773454)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'500'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'nav_list.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44559806328153978)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(169154800779310998)
,p_plug_name=>'Create List'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>'A list is a shared collection of links, each link is called a list entry. You control the appearance of a list through list templates. You add a list to a page by creating a list region.  Deleting a list will cause referencing regions to be removed.<'
||'br /><br />'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'generated 16-FEB-2000 23:59:43'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(169187328626601952)
,p_plug_name=>'create list train'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(169186610834587350)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(169155810046311006)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(44559806328153978)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(169156024918311006)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(44559806328153978)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(169190626904677153)
,p_branch_action=>'f?p=&APP_ID.:440:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':P427_LIST_TYPE = ''STATIC'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1433223199603862)
,p_branch_action=>'f?p=&APP_ID.:464:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(169156024918311006)
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':P427_LIST_TYPE = ''DYNAMIC'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1424823602357946)
,p_name=>'P427_LIST_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(169154800779310998)
,p_prompt=>'Type:'
,p_source=>'STATIC'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'LOV.TYPE'
,p_lov=>'.'||wwv_flow_imp.id(84909926183685150)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Select a type of list.</div>',
'<div class="htmldbInfoBodyP">A static list is based on predefined display and return values. A dynamic list is based on a SQL query or PL/SQL function, executed at runtime.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(169156618404311009)
,p_name=>'P427_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(169154800779310998)
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(169157114381311011)
,p_name=>'P427_NAME'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(169154800779310998)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Enter a name for the list you are creating.  Numeric or alphanumeric list names are permitted.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(169158504652311018)
,p_name=>'P427_REQUIRED_PATCH'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(169154800779310998)
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Select a build option for this component. Build options are predefined settings that determine whether or not  components within an application are enabled.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4171572772198013)
,p_validation_name=>'List name unique'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_lists',
' where security_group_id = :WORKSPACE_ID ',
'   and flow_id           = :FB_FLOW_ID ',
'   and name              = :P427_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#LABEL# must be unique'
,p_when_button_pressed=>wwv_flow_imp.id(169156024918311006)
,p_associated_item=>wwv_flow_imp.id(169157114381311011)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(574134511962781501)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(169155810046311006)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(574134636451781502)
,p_event_id=>wwv_flow_imp.id(574134511962781501)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00431
begin
wwv_flow_imp_page.create_page(
 p_id=>431
,p_name=>'Procedure Finder'
,p_alias=>'PROCEDURE-FINDER'
,p_step_title=>'Procedure Finder'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(5507600580299857)
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function refreshArguments(pObjectId, pSubprogramId) {',
'    $s(''P431_OBJECT_ID'', pObjectId);',
'    $s(''P431_SUBPROGRAM_ID'', pSubprogramId);',
'    apex.jQuery(''#ARGUMENTS'').trigger(''apexrefresh'');',
'}'))
,p_step_template=>wwv_flow_imp.id(19943204431962826)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_srch.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(794819025526089)
,p_plug_name=>'Finder Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>7
,p_plug_new_grid_column=>false
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(6207014968942318)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(60836911211955069)
,p_name=>'Arguments'
,p_region_name=>'ARGUMENTS'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select argument_name,',
'       in_out,',
'       coalesce (',
'           type_name||rtrim(''.''||type_subname, ''.''),',
'           pls_type,',
'           data_type ) data_type,',
'       case defaulted',
'       when ''Y'' then ''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''WWV_FLOW_CUSTOMIZE.T_DEFAULT'')||''</span>''',
'       end defaulted',
'  from sys.dba_arguments',
' where object_id             = :P431_OBJECT_ID',
'   and nvl(subprogram_id,-1) = nvl(:P431_SUBPROGRAM_ID,-1)',
'   and data_level            = 0',
'   and argument_name         is not null',
'order by position'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P431_OBJECT_ID,P431_SUBPROGRAM_ID'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1475461848194625323)
,p_query_column_id=>1
,p_column_alias=>'ARGUMENT_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Argument Name'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1475461944955625324)
,p_query_column_id=>2
,p_column_alias=>'IN_OUT'
,p_column_display_sequence=>2
,p_column_heading=>'In Out'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1475462026733625325)
,p_query_column_id=>3
,p_column_alias=>'DATA_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Data Type'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1475462123673625326)
,p_query_column_id=>4
,p_column_alias=>'DEFAULTED'
,p_column_display_sequence=>4
,p_column_heading=>'Default'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(478895921312673213)
,p_plug_name=>'Procedures'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select p.object_type,',
'       p.object_name,',
'       p.procedure_name,',
'       p.object_id, ',
'       p.subprogram_id,',
'       (select coalesce (',
'                   a.type_name||rtrim(''.''||a.type_subname, ''.''),',
'                   a.pls_type,',
'                   a.data_type )',
'          from sys.dba_arguments a',
'         where a.object_id             = p.object_id',
'           and nvl(a.subprogram_id,-1) = nvl(p.subprogram_id,-1)',
'           and a.data_level            = 0',
'           and a.argument_name         is null ) return_type,',
'       overload',
'  from sys.dba_procedures p',
' where p.owner = (select owner from wwv_flows',
'                   where id                = :fb_flow_id ',
'                     and security_group_id = :flow_security_group_id)',
'   and p.object_name not like ''BIN$%''',
'   and (p.procedure_name is not null',
'        or p.object_type in (''FUNCTION'', ''PROCEDURE''))',
' order by p.object_name, p.procedure_name, p.overload'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'old query',
'select distinct o.object_name as "NAME",',
'       o.object_id, ',
'       o.object_type "Type"',
'  from sys.dba_objects    o, ',
'       sys.dba_procedures p, ',
'       dba_arguments  a',
' Where o.owner = (select owner from wwv_flows',
'                   where id = :fb_flow_id ',
'                     and security_group_id = :flow_security_group_id)',
'   and a.object_id(+) = o.object_id',
'   and p.object_name = o.object_name',
'   and p.owner = o.owner'))
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(478896025956673213)
,p_name=>'Procedures'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'C'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_detail_link=>'javascript:refreshArguments(#OBJECT_ID#, #SUBPROGRAM_ID#)'
,p_detail_link_text=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="" />'
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(478896322057673356)
,p_db_column_name=>'OBJECT_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Object Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1475461276046625317)
,p_db_column_name=>'OBJECT_TYPE'
,p_display_order=>12
,p_column_identifier=>'D'
,p_column_label=>'Object Type'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1475461390426625318)
,p_db_column_name=>'OBJECT_NAME'
,p_display_order=>22
,p_column_identifier=>'E'
,p_column_label=>'Object Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1475461408661625319)
,p_db_column_name=>'PROCEDURE_NAME'
,p_display_order=>32
,p_column_identifier=>'F'
,p_column_label=>'Procedure Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1475461557329625320)
,p_db_column_name=>'SUBPROGRAM_ID'
,p_display_order=>42
,p_column_identifier=>'G'
,p_column_label=>'Subprogram id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1475462884043625333)
,p_db_column_name=>'RETURN_TYPE'
,p_display_order=>52
,p_column_identifier=>'L'
,p_column_label=>'Return Type'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1475462973461625334)
,p_db_column_name=>'OVERLOAD'
,p_display_order=>62
,p_column_identifier=>'M'
,p_column_label=>'Overload'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(478896612991674411)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1294929024536645'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'OBJECT_TYPE:OBJECT_NAME:PROCEDURE_NAME:SUBPROGRAM_ID:RETURN_TYPE:OVERLOAD'
,p_sort_column_1=>'NAME'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(478898901441737230)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(478895921312673213)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:431:&SESSION.::&DEBUG.:RIR,431::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(822730298218559)
,p_branch_action=>'f?p=&APP_ID.:431:&SESSION.:GO:&DEBUG.:RP:P431_OBJECT_ID,P431_PROC_ID:,'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(986304972715987)
,p_name=>'P431_OBJECT_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(478895921312673213)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1475461720321625322)
,p_name=>'P431_SUBPROGRAM_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(478895921312673213)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
end;
/
prompt --application/pages/page_00432
begin
wwv_flow_imp_page.create_page(
 p_id=>432
,p_name=>'Script'
,p_alias=>'SCRIPT'
,p_step_title=>'Script'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_component_map=>'11'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(394076544392764142)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(400150656448459196)
,p_plug_name=>'Script (plug-in)'
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''Rem''||chr(10)||',
'       ''Rem  ''||name||chr(10)||',
'       ''Rem''||chr(10)||',
'       script||chr(10) script_clob',
'from wwv_flow_install_scripts',
'where flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'and nvl(script_type,''INSTALL'') = ''INSTALL''',
'order by sequence, name'))
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.CLOB_CODE_EDITOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'DDL',
  'attribute_02', 'AUTO',
  'attribute_03', 'Y',
  'attribute_04', 'VARCHAR2')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(405358991162522181)
,p_plug_name=>'Installation Scripts'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>'Use installation scripts to create database objects, images, and seed data when this application installs.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(394077098167788720)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(394076544392764142)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:473:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(394077326193795820)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(394076544392764142)
,p_button_name=>'DOWNLOAD'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Download'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(394435235708863310)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'download install script'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_init_htp_buffer;',
'wwv_flow_utilities.print_download_header (',
'       p_mime_type     => ''application/x-sql'',',
'       p_mime_charset  => ''utf-8'',',
'       p_file_name     => ''install_script.sql'',',
'       p_is_attachment => true );',
'sys.owa_util.http_header_close;',
'',
'for c1 in (select * from wwv_flow_install_scripts',
'               where flow_id = :FB_FLOW_ID',
'               and security_group_id = :flow_security_group_id',
'               and nvl(script_type,''INSTALL'') = ''INSTALL''',
'               order by sequence, name)',
'loop',
'    sys.htp.p(''Rem'');',
'    sys.htp.p(''Rem  ''||c1.name);',
'    sys.htp.p(''Rem'');',
'    wwv_htp.print_clob(c1.script);',
'    sys.htp.p(chr(10));',
'end loop;',
'wwv_flow.stop_apex_engine;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to download the install scripts.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(394077326193795820)
,p_internal_uid=>394435235708863310
);
end;
/
prompt --application/pages/page_00434
begin
wwv_flow_imp_page.create_page(
 p_id=>434
,p_name=>'Application Database Object Dependencies - Page References'
,p_alias=>'APPLICATION-DATABASE-OBJECT-DEPENDENCIES-PAGE-REFERENCES'
,p_step_title=>'Page References'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(216995930363945283)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_utilties.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(190110104426683781)
,p_name=>'Object References by Page'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'c005 page,',
'(select max(name) name from wwv_flow_steps where id = to_number(c005) and flow_id = :fb_flow_id) page_name,',
'c004 component_name,',
'c010 component_type,',
'c011 component_class',
'from htmldb_collections',
'where collection_name = ''ALL_DEPENDENCIES'' and',
'      c008 = :fb_flow_id and',
'      (c001 = :P434_object_owner or :P434_object_owner = ''Public'') and',
'      c002 = :P434_object_name',
'order by to_number(c005), c002, c003, c004'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from wwv_flow_collections',
'where collection_name = ''ALL_DEPENDENCIES_INIT'' and ',
'      c002 is null and ',
'      c001 = :fb_flow_id'))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>50000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No dependencies found'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(190144201234777460)
,p_query_column_id=>1
,p_column_alias=>'PAGE'
,p_column_display_sequence=>1
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE#'
,p_column_linktext=>'#PAGE#'
,p_column_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(190150107729798233)
,p_query_column_id=>2
,p_column_alias=>'PAGE_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Page Name'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(190137221573759487)
,p_query_column_id=>3
,p_column_alias=>'COMPONENT_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Component Name'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(190137329391759487)
,p_query_column_id=>4
,p_column_alias=>'COMPONENT_TYPE'
,p_column_display_sequence=>4
,p_column_heading=>'Component Type'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(191684829238192510)
,p_query_column_id=>5
,p_column_alias=>'COMPONENT_CLASS'
,p_column_display_sequence=>5
,p_column_heading=>'Component Subtype'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(32361488916)
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(199887517077550275)
,p_plug_name=>'Object References'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'This report identifies the application components that reference the selected database object.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(199889607857557029)
,p_plug_name=>'context'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>1
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(190114730399691268)
,p_name=>'P434_OBJECT_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(199889607857557029)
,p_prompt=>'Object Owner:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identifies schema owning the database object.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(190116203171692846)
,p_name=>'P434_OBJECT_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(199889607857557029)
,p_prompt=>'Object Name:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the database object name that this report lists dependencies for.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
end;
/
prompt --application/pages/page_00435
begin
wwv_flow_imp_page.create_page(
 p_id=>435
,p_name=>'Theme Reports'
,p_alias=>'THEME-REPORTS1'
,p_step_title=>'Theme Reports'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879423075323511)
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_themes.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(135991313936355968)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(58949101764235429)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Themes'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(141776100493350165)
,p_name=>'File References'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'initcap(c001) c001,',
'c002,',
'c003,',
'c004,',
'c005,',
'decode(lower(c006),''js'','''',''css'','''',''<img src="''||c005||''" />'') image,',
'c007 page_id',
'from htmldb_collections',
'where collection_name = ''FILES'''))
,p_display_when_condition=>'P435_SHOW_FILES'
,p_display_when_cond2=>'CONTEXT'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>50
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'1:2:3'
,p_query_no_data_found=>'No templates found'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'Y'
,p_csv_output_link_text=>'Download'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'Y'
,p_comment=>'vgonchar: the region title is accessible and is used for: landmark, accessible header, accessible table name. This name matches the selected report name (visually shown in the report selector), and the other report with the same name., '
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(141776711956350201)
,p_query_column_id=>1
,p_column_alias=>'C001'
,p_column_display_sequence=>1
,p_column_heading=>'Component'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(141776816603350201)
,p_query_column_id=>2
,p_column_alias=>'C002'
,p_column_display_sequence=>2
,p_column_heading=>'Theme'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(141776922770350202)
,p_query_column_id=>3
,p_column_alias=>'C003'
,p_column_display_sequence=>3
,p_column_heading=>'Class'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(141777021286350202)
,p_query_column_id=>4
,p_column_alias=>'C004'
,p_column_display_sequence=>4
,p_column_heading=>'Component Name'
,p_use_as_row_header=>'Y'
,p_default_sort_column_sequence=>3
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(141777101497350202)
,p_query_column_id=>5
,p_column_alias=>'C005'
,p_column_display_sequence=>5
,p_column_heading=>'File'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(141783516816383262)
,p_query_column_id=>6
,p_column_alias=>'IMAGE'
,p_column_display_sequence=>6
,p_column_heading=>'Image'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(151997720960707992)
,p_query_column_id=>7
,p_column_alias=>'PAGE_ID'
,p_column_display_sequence=>7
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE_ID#'
,p_column_linktext=>'#PAGE_ID#'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(142975707446929316)
,p_plug_name=>'Report Selector'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>25
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(152136325714002617)
,p_name=>'File References'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'c005 file_name,',
'decode(lower(c006),''js'','''',''css'','''',''<img src="''||c005||''" />'') image',
'from htmldb_collections',
'where collection_name = ''FILES''',
'order by 1'))
,p_display_when_condition=>'P435_SHOW_FILES'
,p_display_when_cond2=>'NO_CONTEXT'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>50
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'Y'
,p_csv_output_link_text=>'Download'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'Y'
,p_comment=>'vgonchar: the region title is accessible and is used for: landmark, accessible header, accessible table name. This name matches the selected report name (visually shown in the report selector), and the other report with the same name., '
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(152136910946002953)
,p_query_column_id=>1
,p_column_alias=>'FILE_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'FILE_NAME'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(152137017683002953)
,p_query_column_id=>2
,p_column_alias=>'IMAGE'
,p_column_display_sequence=>2
,p_column_heading=>'IMAGE'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(142981418659942037)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_imp.id(142975707446929316)
,p_button_name=>'P435_GO'
,p_button_static_id=>'P435_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Go'
,p_button_position=>'NEXT'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(205457520384727173)
,p_branch_action=>'f?p=&FLOW_ID.:173:&SESSION.::&DEBUG.::P173_SHOW:1'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P435_SHOW'
,p_branch_condition_text=>'1'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(205461914628734984)
,p_branch_action=>'f?p=&FLOW_ID.:173:&SESSION.::&DEBUG.::P173_SHOW:2'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P435_SHOW'
,p_branch_condition_text=>'2'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(205464410949743302)
,p_branch_action=>'f?p=&FLOW_ID.:491:&SESSION.::&DEBUG.:RP:P491_SHOW:CLASS'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P435_SHOW'
,p_branch_condition_text=>'CLASS'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(205465222031746507)
,p_branch_action=>'f?p=&FLOW_ID.:492:&SESSION.::&DEBUG.:RP:P492_SHOW:TEMPLATE'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P435_SHOW'
,p_branch_condition_text=>'TEMPLATE'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(142981713415942042)
,p_branch_action=>'f?p=&FLOW_ID.:435:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1474729096476101)
,p_name=>'P435_SHOW_FILTERS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(142975707446929316)
,p_prompt=>'Show'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>'STATIC2:Templates;TEMPLATES,Shared Components;SHARED_COMPONENTS,Page Components;PAGE_COMPONENTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select the type of components to include in this report. If you do not make a selection, no results are returned.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(142977624415934264)
,p_name=>'P435_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(142975707446929316)
,p_prompt=>'Theme'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- All Themes -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select themes to include in the report and click <strong>Go</strong>. This report can include all themes, or you can select a specific theme.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(152118110083969780)
,p_name=>'P435_SHOW_FILES'
,p_item_sequence=>52
,p_item_plug_id=>wwv_flow_imp.id(142975707446929316)
,p_prompt=>'Show Files'
,p_source=>'CONTEXT'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'FIND FILES REPORT OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(152121930169975580)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select the type of report to view.<p/> ',
'<strong>With context</strong> displays the component, theme ID, component name, file location, the image (if applicable), and the relevant page number. Select the page number to link to a specific Page Definition.<p/> ',
'<strong>Without context</strong> displays only the file name and image (if applicable).',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(152396603690431534)
,p_name=>'P435_FILE_EXTENSIONS'
,p_item_sequence=>62
,p_item_plug_id=>wwv_flow_imp.id(142975707446929316)
,p_item_default=>'jpg:png:gif:js:ico:css:swf'
,p_prompt=>'File Extensions'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'FILE EXTENSIONS'
,p_lov=>'.'||wwv_flow_imp.id(152392614641425297)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Specify the type file extensions to search for. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'8'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(205437123969661910)
,p_name=>'P435_SHOW'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(142975707446929316)
,p_item_default=>'1'
,p_prompt=>'Report'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P173_SHOW'
,p_lov=>'.'||wwv_flow_imp.id(48989614083583743)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a report to view and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(141773827935339127)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_show_templates         varchar2(1) := ''N'';',
'  l_show_shared_components varchar2(1) := ''N'';',
'  l_show_PAGE_components   varchar2(1) := ''N'';',
'  l_gif                    varchar2(1) := ''N'';',
'  l_jpg                    varchar2(1) := ''N'';',
'  l_png                    varchar2(1) := ''N'';',
'  l_css                    varchar2(1) := ''N'';',
'  l_ico                    varchar2(1) := ''N'';',
'  l_js                     varchar2(1) := ''N'';',
'  l_swf                    varchar2(1) := ''N'';',
'begin',
'  if instr( :P435_SHOW_FILTERS, ''TEMPLATES'' ) > 0 then l_show_templates := ''Y''; end if;',
'  if instr( :P435_SHOW_FILTERS, ''SHARED_COMPONENTS'' ) > 0 then l_show_shared_components := ''Y''; end if;',
'  if instr( :P435_SHOW_FILTERS, ''PAGE_COMPONENTS'' ) > 0 then l_show_page_components := ''Y''; end if;',
'  --',
'  if instr(lower(:P435_FILE_EXTENSIONS)||'':'',''gif:'') >0 then l_gif := ''Y''; end if;',
'  if instr(lower(:P435_FILE_EXTENSIONS)||'':'',''jpg:'') >0 then l_jpg := ''Y''; end if;',
'  if instr(lower(:P435_FILE_EXTENSIONS)||'':'',''png:'') >0 then l_png := ''Y''; end if;',
'  if instr(lower(:P435_FILE_EXTENSIONS)||'':'',''css:'') >0 then l_css := ''Y''; end if;',
'  if instr(lower(:P435_FILE_EXTENSIONS)||'':'',''ico:'') >0 then l_ico := ''Y''; end if;',
'  if instr(lower(:P435_FILE_EXTENSIONS)||'':'',''js:'')  >0 then l_js  := ''Y''; end if;',
'  if instr(lower(:P435_FILE_EXTENSIONS)||'':'',''swf:'') >0 then l_swf := ''Y''; end if;',
'  --',
'  wwv_flow_theme_manager.find_template_files(',
'    p_flow_id => :fb_flow_id, ',
'    p_theme => :P435_THEME,',
'    p_show_templates => l_show_templates,',
'    p_show_page_components => l_show_page_components,',
'    p_show_components=> l_show_shared_components,',
'    p_show_gif => l_gif,',
'    p_show_jpg => l_jpg,',
'    p_show_png => l_png,',
'    p_show_css => l_css,',
'    p_show_js  => l_js,',
'    p_show_swf => l_swf,',
'    p_show_ico => l_ico',
'  );',
'  commit;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>141773827935339127
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(142984801475946549)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'rp'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>142984801475946549
);
end;
/
prompt --application/pages/page_00438
begin
wwv_flow_imp_page.create_page(
 p_id=>438
,p_name=>'Edit Region Titles'
,p_alias=>'EDIT-REGION-TITLES'
,p_step_title=>'Edit Region Titles'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_region.htm'
,p_page_component_map=>'01'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193875625472581190)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>91
,p_list_id=>wwv_flow_imp.id(13987931263515071)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(232844013154816966)
,p_name=>'Edit Region Titles'
,p_template=>wwv_flow_imp.id(208928010704475743)
,p_display_sequence=>100
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'ID,',
'PAGE_ID,',
'PLUG_NAME,',
'TRANSLATE_TITLE,',
'(select PAGE_PLUG_TEMPLATE_NAME from WWV_FLOW_PAGE_PLUG_TEMPLATES where id = r.plug_template) PLUG_TEMPLATE,',
'PLUG_DISPLAY_SEQUENCE',
'from WWV_FLOW_PAGE_PLUGS r',
'where r.flow_id = :fb_flow_id',
'and security_group_id = :flow_security_group_id',
'and (',
':P438_FIND is null or instr(upper(plug_name),upper(:P438_FIND)) > 0',
')'))
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' -'
,p_query_no_data_found=>'No regions found.'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(232844709865816990)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_column_width=>16
,p_pk_col_source_type=>'T'
,p_ref_schema=>'FLOWS_010600'
,p_ref_table_name=>'WWV_FLOW_PAGE_PLUGS'
,p_ref_column_name=>'ID'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(232845025935816991)
,p_query_column_id=>2
,p_column_alias=>'PAGE_ID'
,p_column_display_sequence=>2
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE_ID#'
,p_column_linktext=>'#PAGE_ID#'
,p_column_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_ref_schema=>'FLOWS_010600'
,p_ref_table_name=>'WWV_FLOW_PAGE_PLUGS'
,p_ref_column_name=>'PAGE_ID'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(232845120941816991)
,p_query_column_id=>3
,p_column_alias=>'PLUG_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Region Title'
,p_use_as_row_header=>'Y'
,p_default_sort_column_sequence=>3
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT'
,p_column_width=>35
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_ref_table_name=>'WWV_FLOW_PAGE_PLUGS'
,p_ref_column_name=>'PLUG_NAME'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(193885325178787173)
,p_query_column_id=>4
,p_column_alias=>'TRANSLATE_TITLE'
,p_column_display_sequence=>5
,p_column_heading=>'Translate Title'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'SELECT_LIST_FROM_LOV'
,p_named_lov=>wwv_flow_imp.id(84259319526460470)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'NO'
,p_include_in_export=>'Y'
,p_ref_table_name=>'WWV_FLOW_PAGE_PLUGS'
,p_ref_column_name=>'TRANSLATE_TITLE'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(232845226009816991)
,p_query_column_id=>5
,p_column_alias=>'PLUG_TEMPLATE'
,p_column_display_sequence=>6
,p_column_heading=>'Template'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_ref_schema=>'FLOWS_010600'
,p_ref_table_name=>'WWV_FLOW_PAGE_PLUGS'
,p_ref_column_name=>'PLUG_TEMPLATE'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(232845313819816991)
,p_query_column_id=>6
,p_column_alias=>'PLUG_DISPLAY_SEQUENCE'
,p_column_display_sequence=>3
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_ref_schema=>'FLOWS_010600'
,p_ref_table_name=>'WWV_FLOW_PAGE_PLUGS'
,p_ref_column_name=>'PLUG_DISPLAY_SEQUENCE'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(232849516674821185)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(232849710181821186)
,p_column_sequence=>2
,p_query_column_name=>'PAGE_ID'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(232849820395821186)
,p_column_sequence=>3
,p_query_column_name=>'PLUG_NAME'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(193885024829787170)
,p_column_sequence=>4
,p_query_column_name=>'TRANSLATE_TITLE'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(232849923662821186)
,p_column_sequence=>5
,p_query_column_name=>'PLUG_TEMPLATE'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(232850020411821187)
,p_column_sequence=>6
,p_query_column_name=>'PLUG_DISPLAY_SEQUENCE'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(232848310786819435)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>95
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(232871329880853379)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(232848310786819435)
,p_button_name=>'P438_GO'
,p_button_static_id=>'P438_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Go'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(232845507779816998)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(232848310786819435)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'EDIT'
,p_security_scheme=>wwv_flow_imp.id(34674432490821717)
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(232846728727817013)
,p_branch_action=>'f?p=&APP_ID.:438:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>21
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(232869223300851437)
,p_name=>'P438_FIND'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(232848310786819435)
,p_prompt=>'Region Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a case insensitive query and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(232846308727817005)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(232844013154816966)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'ApplyMRU'
,p_attribute_02=>'WWV_FLOW_PAGE_PLUGS'
,p_attribute_03=>'ID'
,p_attribute_05=>'flow_id = :FB_FLOW_ID and security_group_id = :WORKSPACE_ID'
,p_process_error_message=>'Unable to process update'
,p_process_when_button_id=>wwv_flow_imp.id(232845507779816998)
,p_process_success_message=>'#MRU_COUNT# row(s) updated, #MRI_COUNT# row(s) inserted.'
,p_security_scheme=>wwv_flow_imp.id(34674432490821717)
,p_internal_uid=>232846308727817005
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(232876922392860694)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>232876922392860694
);
end;
/
prompt --application/pages/page_00440
begin
wwv_flow_imp_page.create_page(
 p_id=>440
,p_name=>'Create List - Static Values'
,p_alias=>'CREATE-LIST-STATIC-VALUES'
,p_page_mode=>'MODAL'
,p_step_title=>'Create List'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'500'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'nav_list.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44562405074163065)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(169189407033661932)
,p_plug_name=>'create list train'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(169186610834587350)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(169190828420687064)
,p_plug_name=>'Create List'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(169191207773690545)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(44562405074163065)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(169191631872690550)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(44562405074163065)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(169191411012690550)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(44562405074163065)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(169195226997733967)
,p_branch_action=>'f?p=&APP_ID.:529:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(574134995697781505)
,p_branch_action=>'f?p=&APP_ID.:427:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(169191411012690550)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(169196418218797633)
,p_name=>'P440_ENTRY_NAME_01'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(169190828420687064)
,p_prompt=>'1'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'List Entry 1 Label'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(169196609416797637)
,p_name=>'P440_PAGE_01'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(169190828420687064)
,p_prompt=>'List Entry 1 Target Page ID or custom URL'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d',
'  from wwv_flow_steps',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and is_page_pattern   = ''N''',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(169196821588797638)
,p_name=>'P440_ENTRY_NAME_02'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(169190828420687064)
,p_prompt=>'2'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'List Entry 2 Label'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(169197031564797638)
,p_name=>'P440_PAGE_02'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(169190828420687064)
,p_prompt=>'List Entry 2 Target Page ID or custom URL'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d',
'  from wwv_flow_steps',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and is_page_pattern   = ''N''',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(169197215492797638)
,p_name=>'P440_ENTRY_NAME_03'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(169190828420687064)
,p_prompt=>'3'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'List Entry 3 Label'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(169197400812797638)
,p_name=>'P440_PAGE_03'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(169190828420687064)
,p_prompt=>'List Entry 3 Target Page ID or custom URL'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d',
'  from wwv_flow_steps',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and is_page_pattern   = ''N''',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(169197632441797638)
,p_name=>'P440_ENTRY_NAME_04'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(169190828420687064)
,p_prompt=>'4'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'List Entry 4 Label'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(169197818409797639)
,p_name=>'P440_PAGE_04'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(169190828420687064)
,p_prompt=>'List Entry 4 Target Page ID or custom URL'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d',
'  from wwv_flow_steps',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and is_page_pattern   = ''N''',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(169198031550797639)
,p_name=>'P440_ENTRY_NAME_05'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(169190828420687064)
,p_prompt=>'5'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'List Entry 5 Label'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(169198232173797639)
,p_name=>'P440_PAGE_05'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(169190828420687064)
,p_prompt=>'List Entry 5 Target Page ID or custom URL'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d',
'  from wwv_flow_steps',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and is_page_pattern   = ''N''',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(169200608184870408)
,p_name=>'P440_ENTRY_LABEL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(169190828420687064)
,p_source=>'wwv_flow_lang.system_message(''LIST_ENTRY_LABEL'');'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(169200816255870409)
,p_name=>'P440_ENTRY_TARGET'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(169190828420687064)
,p_source=>'wwv_flow_lang.system_message(''TARGET_PAGE_ID_OR_CUSTOM_URL'');'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(574134753422781503)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(169191207773690545)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(574134890803781504)
,p_event_id=>wwv_flow_imp.id(574134753422781503)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00444
begin
wwv_flow_imp_page.create_page(
 p_id=>444
,p_name=>'Lock Pages'
,p_alias=>'LOCK-PAGES'
,p_step_title=>'Lock Pages'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213229021839834158)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_locks.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(37875907041082998)
,p_plug_name=>'Lock Page'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<p>Locking a page will ensure no other developer will change the definition of a page you lock.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(926592801825554684)
,p_plug_name=>'wizard buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--wizard'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(926694488520890804)
,p_plug_name=>'Lock Page'
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(37891212507179194)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(926592801825554684)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(37891523270179199)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(926592801825554684)
,p_button_name=>'LOCK'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Lock Page(s)'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(37900625714211370)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(37877115699085509)
,p_name=>'P444_LOCK_PAGES'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(37875907041082998)
,p_prompt=>'Lock Pages:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'List of pages to be locked.  This list contains all pages which are available to be locked.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(37893006751186969)
,p_name=>'P444_LOCK_COMMENT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(37875907041082998)
,p_prompt=>'Comment'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>8
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'YES'
,p_help_text=>'Comment to be applied to all locked pages.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(37902918011228095)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'lock pages'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  pg wwv_flow_global.vc_arr2;',
'  c  int;',
'begin',
'  pg := wwv_flow_utilities.string_to_table2(:P444_LOCK_PAGES);',
'',
'  for i in 1..pg.count loop',
'',
'    select count(*) a into c from WWV_FLOW_LOCK_PAGE ',
'    where flow_id = :fb_flow_id and object_id = to_number(pg(i)) and locked_by is not null;',
'',
'    if c = 0 then',
'    insert into WWV_FLOW_LOCK_PAGE (',
'        flow_id,',
'        object_id,',
'        LOCK_COMMENT,',
'        locked_by,',
'        locked_on)',
'    values (',
'        :fb_flow_id,',
'        to_number(pg(i)),',
'        :P444_LOCK_COMMENT,',
'        :app_user,',
'        sysdate);',
'    end if;',
'  end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to Lock Pages'
,p_process_when_button_id=>wwv_flow_imp.id(37891523270179199)
,p_process_success_message=>'Page(s) locked'
,p_internal_uid=>37902918011228095
);
end;
/
prompt --application/pages/page_00445
begin
wwv_flow_imp_page.create_page(
 p_id=>445
,p_name=>'Validations'
,p_alias=>'VALIDATIONS'
,p_step_title=>'Validations'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(24897722063538624)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deployment.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22469712310268780)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>90
,p_list_id=>wwv_flow_imp.id(22452018965176093)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(22486816559326797)
,p_name=>'Validations'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>100
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_column=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select "ID", ',
'"NAME",',
'"SEQUENCE",',
'"CHECK_TYPE",',
'"CHECK_CONDITION", ',
'm.e',
'from #OWNER#.WWV_FLOW_INSTALL_CHECKS, (select wwv_flow_lang.system_message(''EDIT'') e from dual) m',
' where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'  '))
,p_header=>'<p>Use validations to ensure the database is capable of running the installation scripts.</p>'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>50000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No validations defined.'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22487000625326798)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Edit'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:376:&SESSION.::&DEBUG.::P376_ID:#ID#'
,p_column_linktext=>'<span class="a-Icon icon-edit"></span><span class="u-VisuallyHidden">#E#</span>'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22487101068326798)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_ref_schema=>'FLOWS_020200'
,p_ref_table_name=>'WWV_FLOW_INSTALL_CHECKS'
,p_ref_column_name=>'NAME'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22487212308326798)
,p_query_column_id=>3
,p_column_alias=>'SEQUENCE'
,p_column_display_sequence=>2
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_ref_schema=>'FLOWS_020200'
,p_ref_table_name=>'WWV_FLOW_INSTALL_CHECKS'
,p_ref_column_name=>'SEQUENCE'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22487303196326798)
,p_query_column_id=>4
,p_column_alias=>'CHECK_TYPE'
,p_column_display_sequence=>4
,p_column_heading=>'Validation Type'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(2610902469203915)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_ref_schema=>'FLOWS_020200'
,p_ref_table_name=>'WWV_FLOW_INSTALL_CHECKS'
,p_ref_column_name=>'CHECK_TYPE'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22487426901326798)
,p_query_column_id=>5
,p_column_alias=>'CHECK_CONDITION'
,p_column_display_sequence=>5
,p_column_heading=>'Condition'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_ref_schema=>'FLOWS_020200'
,p_ref_table_name=>'WWV_FLOW_INSTALL_CHECKS'
,p_ref_column_name=>'CHECK_CONDITION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1119204948525875910)
,p_query_column_id=>6
,p_column_alias=>'E'
,p_column_display_sequence=>6
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(24429712314913204)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(24172418538839346)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(34012108388929679)
,p_plug_name=>'Validations'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>95
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(22550015932506379)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(34012108388929679)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(22487922446328483)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(34012108388929679)
,p_button_name=>'CREATEVAL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:376:&SESSION.::&DEBUG.:376::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(29874403379605817)
,p_branch_name=>'Go To Page &P567_BRANCH_PAGE.'
,p_branch_action=>'f?p=&APP_ID.:&P567_BRANCH_PAGE.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'substr(:REQUEST,1,13) = ''APPLY_CHANGES'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(29873025412602748)
,p_computation_sequence=>10
,p_computation_item=>'P567_BRANCH_PAGE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'substr(v(''REQUEST''),15)'
,p_compute_when=>'substr(:REQUEST,1,13) = ''APPLY_CHANGES'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
end;
/
prompt --application/pages/page_00449
begin
wwv_flow_imp_page.create_page(
 p_id=>449
,p_name=>'Confirm Publish Item Help'
,p_alias=>'CONFIRM-PUBLISH-ITEM-HELP'
,p_step_title=>'Confirm Publish Item Help'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_item.htm'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(37116229602452911)
,p_plug_name=>'Publish Item Help Confirmation'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>100
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<p>''||wwv_flow_lang.system_message(p_name=>''PUBLISH_ITEM_HELP.CONFIRM'')||''</p>'');',
'sys.htp.p(''<ul>'');',
'for c in (select i.flow_id, i.name',
'          from wwv_flow_step_items i, wwv_flow_step_item_help h',
'          where i.id = h.flow_item_id',
'          and h.reference_id = :P449_ID) loop',
'   sys.htp.p(''<li>''||wwv_flow_escape.html(c.flow_id||'' - ''||c.name)||''</li>'');',
'end loop;',
'sys.htp.p(''</ul>'');',
'sys.htp.p(''<p/>'');',
'sys.htp.p(''<p>''||wwv_flow_lang.system_message(p_name=>''PUBLISH_ITEM_HELP.CONFIRM2'')||''</p>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1000723748661503619)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(37121313352452948)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1000723748661503619)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(37125802036452961)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1000723748661503619)
,p_button_name=>'REFRESH_ITEM_HELP'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Refresh All'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(37133015710452981)
,p_branch_action=>'&P449_PAGE_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(37125802036452961)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(37133311206452982)
,p_branch_action=>'&P449_PAGE_ID.'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(37121313352452948)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(37128403587452969)
,p_name=>'P449_ID'
,p_item_sequence=>10
,p_item_display_point=>'LEGACY_ORPHAN_COMPONENTS'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(37128732150452971)
,p_name=>'P449_PAGE_ID'
,p_item_sequence=>20
,p_item_display_point=>'LEGACY_ORPHAN_COMPONENTS'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(37131524318452978)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh All Item Helps'
,p_process_sql_clob=>'wwv_flow_copy_metadata.push_item_help (:P449_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error refreshing all subscribing page templates.'
,p_process_when_button_id=>wwv_flow_imp.id(37125802036452961)
,p_process_success_message=>'All subscribing page templates refreshed.'
,p_internal_uid=>37131524318452978
);
end;
/
prompt --application/pages/page_00457
begin
wwv_flow_imp_page.create_page(
 p_id=>457
,p_name=>'Upgrade Script'
,p_alias=>'UPGRADE-SCRIPT'
,p_step_title=>'Upgrade Script'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_component_map=>'11'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(403368042822913448)
,p_plug_name=>'Script (plug-in)'
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''Rem''||chr(10)||',
'       ''Rem  ''||name||chr(10)||',
'       ''Rem''||chr(10)||',
'       script||chr(10) script_clob',
'from wwv_flow_install_scripts',
'where flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'and nvl(script_type,''INSTALL'') = ''UPGRADE''',
'order by sequence, name'))
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.CLOB_CODE_EDITOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'DDL',
  'attribute_02', 'AUTO',
  'attribute_03', 'Y',
  'attribute_04', 'VARCHAR2')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(403368492129913449)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(405352281117027978)
,p_plug_name=>'Upgrade Scripts'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>'Use upgrade scripts to upgrade database objects, images, and seed data when upgrading to a new version of this application.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(403368610158913449)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(403368492129913449)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:667:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(403368819646913451)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(403368492129913449)
,p_button_name=>'DOWNLOAD'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Download'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(403369207759913453)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'download upgrade script'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_init_htp_buffer;',
'wwv_flow_utilities.print_download_header (',
'       p_mime_type     => ''application/x-sql'',',
'       p_mime_charset  => ''utf-8'',',
'       p_file_name     => ''upgrade_script.sql'',',
'       p_is_attachment => true );',
'sys.owa_util.http_header_close;',
'',
'for c1 in (select * from wwv_flow_install_scripts',
'               where flow_id = :FB_FLOW_ID',
'               and security_group_id = :flow_security_group_id',
'               and nvl(script_type,''INSTALL'') = ''UPGRADE''',
'               order by sequence, name)',
'loop',
'    sys.htp.p(''Rem'');',
'    sys.htp.p(''Rem  ''||c1.name);',
'    sys.htp.p(''Rem'');',
'    wwv_htp.print_clob(c1.script);',
'    sys.htp.p(chr(10));',
'end loop;',
'',
'',
'wwv_flow.stop_apex_engine;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to download the install scripts.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(403368819646913451)
,p_internal_uid=>403369207759913453
);
end;
/
prompt --application/pages/page_00459
begin
wwv_flow_imp_page.create_page(
 p_id=>459
,p_name=>'Region Count by Page Template Slot'
,p_alias=>'REGION-COUNT-BY-PAGE-TEMPLATE-SLOT'
,p_step_title=>'Region Count by Page Template Slot'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_region.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1219116120492032)
,p_plug_name=>'Regions by Page Template Slot'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>100
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'SELECT  ',
'    flow_id application,',
'    PLUG_DISPLAY_POINT,',
'    count(*) region_count,',
'    count(distinct page_id) pages_referenced,',
'    t.total_region_count,',
'    100*count(*)/t.total_region_count pct_of_total,',
'    100*count(*)/t.total_region_count graph',
'FROM ',
'   WWV_FLOW_PAGE_PLUGS p,',
'   (select count(*) total_region_count',
'    from wwv_flow_page_plugs ',
'    where flow_id = :fb_flow_id and ',
'          security_group_id = :FLOW_SECURITY_GROUP_ID) t',
'WHERE',
'   FLOW_ID = :fb_flow_id and',
'   security_group_id = :FLOW_SECURITY_GROUP_ID',
'group by flow_id, PLUG_DISPLAY_POINT, t.total_region_count'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(1219200708492032)
,p_name=>'Regions by Page Template Slot'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1219405392492035)
,p_db_column_name=>'APPLICATION'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1219507506492035)
,p_db_column_name=>'PLUG_DISPLAY_POINT'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>'Page Template Slot'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1219616354492036)
,p_db_column_name=>'REGION_COUNT'
,p_display_order=>2
,p_column_identifier=>'C'
,p_column_label=>'Regions Referenced'
,p_column_link=>'f?p=&APP_ID.:249:&SESSION.::&DEBUG.:RP,RIR,CIR:IR_DISPLAY_POSITION:#PLUG_DISPLAY_POINT#'
,p_column_linktext=>'#REGION_COUNT#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1219701780492036)
,p_db_column_name=>'PAGES_REFERENCED'
,p_display_order=>3
,p_column_identifier=>'D'
,p_column_label=>'Pages Referenced'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1245325042020983)
,p_db_column_name=>'TOTAL_REGION_COUNT'
,p_display_order=>4
,p_column_identifier=>'E'
,p_column_label=>'Total Region Count'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1245422157020984)
,p_db_column_name=>'PCT_OF_TOTAL'
,p_display_order=>5
,p_column_identifier=>'F'
,p_column_label=>'Percent of Total'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1245530350020984)
,p_db_column_name=>'GRAPH'
,p_display_order=>6
,p_column_identifier=>'G'
,p_column_label=>'Graph'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_format_mask=>'PCT_GRAPH:cccccc:777777:200'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(1219929133492352)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1295114282536645'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'APPLICATION:PLUG_DISPLAY_POINT:REGION_COUNT:PCT_OF_TOTAL:GRAPH'
,p_sort_column_1=>'REGION_COUNT'
,p_sort_direction_1=>'DESC'
,p_sum_columns_on_break=>'REGION_COUNT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193875830321582606)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>91
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(13987931263515071)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(193879015093653828)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1219116120492032)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:459:&SESSION.::&DEBUG.:459,RIR::'
);
end;
/
prompt --application/pages/page_00460
begin
wwv_flow_imp_page.create_page(
 p_id=>460
,p_name=>'Import - Specify File'
,p_alias=>'IMPORT'
,p_step_title=>'Import - Specify File'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213300727323081712)
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// If page came from the back-forward cache, reload it',
'apex.jQuery(window).bind("pageshow", function(event) {',
'  if (event.originalEvent.persisted) {',
'    if(window.location.href.indexOf(''wwv_flow.accept'') > 0) window.history.go(-1); ',
'    else window.location.reload();',
'  }',
'});',
''))
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// Set drag and drop labels',
'var fileUpload$ = apex.jQuery(''.apex-item-group--file:not(.upload-completed) .apex-item-file-dropzone'');',
'',
'fileUpload$.append("<span class=''a-FileDrop-heading''>" + apex.lang.getMessage("ITEM.FILE_UPLOAD.DRAG_DROP_FILE_HERE") + "</span> ");',
'fileUpload$.append("<span class=''a-FileDrop-action''>" + apex.lang.getMessage("ITEM.FILE_UPLOAD.CHOOSE_FILE") + "</span> ");',
'fileUpload$.append("<span class=''a-FileDrop-filename''></span>");',
'',
''))
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_css_classes=>'a-Page--wizardTop'
,p_help_text=>'deploy_import.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(42445018302528358)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>150
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(45313425484446190)
,p_plug_name=>'Specify File'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>130
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'Region generated 16-MAY-2003 17:18:02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747142504813138164)
,p_plug_name=>'Import'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(45314316560446194)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(42445018302528358)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&P460_CANCEL_TARGET.:&SESSION.::&DEBUG.:RP,::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1670603888557234719)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(42445018302528358)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Help'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'javascript:w=window.open(''&SYSTEM_HELP_URL.'');'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(45314626525446194)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(42445018302528358)
,p_button_name=>'NEXT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(45314506548446194)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(42445018302528358)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:461:&SESSION.::&DEBUG.:::'
,p_button_condition=>'P460_PREV_PAGE'
,p_button_condition2=>'459'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2106420015185421)
,p_branch_name=>'Go to page 49'
,p_branch_action=>'f?p=&APP_ID.:49:&SESSION.::&DEBUG.:49,WWV_FLOW_IMPORT_REMOTE_SERVERS,WWV_FLOW_IMPORT_CREDENTIALS:P49_FILE_ID:&P460_FILE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(45314626525446194)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P460_FILE_TYPE'
,p_branch_condition_text=>'FLOW_EXPORT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(45316031293446199)
,p_branch_name=>'Go To Page 163'
,p_branch_action=>'f?p=&APP_ID.:163:&SESSION.::&DEBUG.:WWV_FLOW_IMPORT_REMOTE_SERVERS,WWV_FLOW_IMPORT_CREDENTIALS::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(45314626525446194)
,p_branch_sequence=>20
,p_branch_comment=>'Generated 16-MAY-2003 17:18:02'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(317679409969112295)
,p_branch_action=>'f?p=4100:1:&SESSION.'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(45314316560446194)
,p_branch_sequence=>20
,p_branch_condition_type=>'ITEM_IS_NULL'
,p_branch_condition=>'FB_FLOW_ID'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(317708930532127660)
,p_branch_action=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(45314316560446194)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2106594515185422)
,p_name=>'P460_FILE_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(45313425484446190)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(45314128381446191)
,p_name=>'P460_FILE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(45313425484446190)
,p_prompt=>'Import file'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>40
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'margin-bottom-md margin-top-lg'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_attribute_01=>'WWV_FLOW_FILES'
,p_attribute_12=>'DROPZONE_INLINE'
,p_item_comment=>'Generated 16-MAY-2003 17:18:02'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47821015395903429)
,p_name=>'P460_FILE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(45313425484446190)
,p_item_default=>'FLOW_EXPORT'
,p_prompt=>'File Type:'
,p_source=>'FLOW_EXPORT'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXPORT_FILE_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(84829617133304005)||'.'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Indicate the type of export file to be imported.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(53940826768469260)
,p_name=>'P460_PREV_PAGE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(45313425484446190)
,p_prompt=>'Prev Page'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(144813309454701393)
,p_name=>'P460_FILE_CHARSET'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(45313425484446190)
,p_item_default=>'nvl(lower(trim(sys.owa_util.get_cgi_env(''REQUEST_IANA_CHARSET''))),''utf-8'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'File Character Set'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_IANA_CHARSET'
,p_lov=>'.'||wwv_flow_imp.id(144796827445692396)||'.'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Indicate the character set encoding of the file to be imported.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(195267362799182701)
,p_name=>'P460_CANCEL_TARGET'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(45313425484446190)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(195267477589182702)
,p_computation_sequence=>10
,p_computation_item=>'P460_CANCEL_TARGET'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'1500'
,p_computation_comment=>'By default, Cancel should branch to Page 1500'
,p_compute_when=>'P460_CANCEL_TARGET'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(47823429294935804)
,p_validation_name=>'file not null'
,p_validation_sequence=>10
,p_validation=>'P460_FILE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'File must be selected to upload.'
,p_when_button_pressed=>wwv_flow_imp.id(45314626525446194)
,p_associated_item=>wwv_flow_imp.id(45314128381446191)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(47824006569938696)
,p_validation_name=>'file type not null'
,p_validation_sequence=>20
,p_validation=>'P460_FILE_TYPE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'File type must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(45314626525446194)
,p_associated_item=>wwv_flow_imp.id(47821015395903429)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(341758707481969404)
,p_validation_name=>'file not 0 byte'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select id',
'             from wwv_flow_file_objects$',
'            where name = :P460_FILE',
'              and doc_size = 0',
'              and security_group_id = :WORKSPACE_ID)',
'loop',
'    delete from wwv_flow_file_objects$',
'     where id = c1.id',
'       and security_group_id = :flow_security_group_id;',
'',
'    return false;',
'end loop;',
'',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'The file does not have any content.'
,p_when_button_pressed=>wwv_flow_imp.id(45314626525446194)
,p_associated_item=>wwv_flow_imp.id(45314128381446191)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1003712203211784947)
,p_validation_name=>'is SQL or ZIP file'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_import_file in (select id, filename',
'                        from wwv_flow_file_objects$',
'                       where name = :P460_FILE',
'                         and security_group_id = :WORKSPACE_ID )',
'loop',
'    if lower( l_import_file.filename ) like ''%.sql'' or',
'       lower( l_import_file.filename ) like ''%.zip'' then',
'        return true;',
'    else',
'        delete from wwv_flow_file_objects$',
'         where id = l_import_file.id',
'           and security_group_id = :flow_security_group_id;',
'',
'        return false;',
'    end if;',
'end loop;',
'',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Invalid file type. Supported file types are SQL, ZIP.'
,p_validation_condition=>'P460_FILE'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(45314626525446194)
,p_associated_item=>wwv_flow_imp.id(45314128381446191)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(932669483786561044)
,p_name=>'Submit page'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(45314626525446194)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(932669597885561045)
,p_event_id=>wwv_flow_imp.id(932669483786561044)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'NEXT'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(46711932360845877)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'upload export file'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_imp_parser.upload_export_file (',
'    p_file               => :P460_FILE,',
'    p_file_type          => :P460_FILE_TYPE,',
'    p_security_group_id  => :flow_security_group_id,',
'    p_file_charset       => :P460_FILE_CHARSET,',
'    p_flow_user          => :flow_user',
');'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error uploading imported file.'
,p_process_when_button_id=>wwv_flow_imp.id(45314626525446194)
,p_process_success_message=>'Imported file uploaded.'
,p_internal_uid=>46711932360845877
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(53577809201103042)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set file id'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_file_id number := null;',
'begin',
'  for c1 in (select id',
'             from wwv_flow_file_objects$',
'             where name = :P460_FILE',
'               and security_group_id = :WORKSPACE_ID)',
'  loop',
'     l_file_id := c1.id;',
'  end loop;',
'',
'  -- set 4460 file id item based if it''s a app, page, or component export',
'  if :P460_FILE_TYPE = ''FLOW_EXPORT'' then',
'     :P460_FILE_ID := l_file_id;',
'  end if;',
'',
'  :P163_FILE_ID := l_file_id;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(45314626525446194)
,p_internal_uid=>53577809201103042
);
end;
/
prompt --application/pages/page_00461
begin
wwv_flow_imp_page.create_page(
 p_id=>461
,p_name=>'Export / Import'
,p_alias=>'EXPORT-IMPORT'
,p_step_title=>'Export / Import'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213300727323081712)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_how_to.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44664519703498420)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(45316711403446202)
,p_plug_name=>'Export / Import'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'Region generated 16-MAY-2003 17:18:02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747142625960138164)
,p_plug_name=>'What task would you like to perform?'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(45317600429446209)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(44664519703498420)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1670603923819234720)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(44664519703498420)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Help'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'javascript:w=window.open(''&SYSTEM_HELP_URL.'');'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(45317931133446209)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(44664519703498420)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(45403409535967018)
,p_branch_action=>'f?p=&FLOW_ID.:460:&SESSION.::&DEBUG.:460::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P461_EXPIMP'
,p_branch_condition_text=>'IMPORT'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2700881305358307)
,p_branch_name=>'Go to Page 4905'
,p_branch_action=>'f?p=&APP_ID.:4905:&SESSION.::&DEBUG.:RP,4905,4906::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>15
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P461_EXPIMP'
,p_branch_condition_text=>'DEPLOY'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(45422531624068012)
,p_branch_action=>'f?p=&FLOW_ID.:73:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P461_EXPIMP'
,p_branch_condition_text=>'REPOSITORY'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(171790426302478829)
,p_branch_action=>'f?p=&FLOW_ID.:76:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'NOT_EXISTS'
,p_branch_condition=>'select 1 from wwv_flows where security_group_id = :flow_security_group_id'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(45319322589446216)
,p_branch_action=>'f?p=&FLOW_ID.:4900:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(45317931133446209)
,p_branch_sequence=>40
,p_branch_comment=>'Generated 16-MAY-2003 17:18:02'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(45318305962446212)
,p_branch_action=>'f?p=&FLOW_ID.:1:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(45317600429446209)
,p_branch_sequence=>50
,p_branch_comment=>'Generated 16-MAY-2003 17:18:02'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(45317431786446206)
,p_name=>'P461_EXPIMP'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(45316711403446202)
,p_item_default=>'EXPORT'
,p_prompt=>'Select Task'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'EXPORT.OPTIONS WITH ICONS'
,p_lov=>'.'||wwv_flow_imp.id(805553919796597674)||'.'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-IconList--featured a-IconList--featured--wide'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'S'
,p_attribute_02=>'Y'
,p_item_comment=>'Generated 16-MAY-2003 17:18:02'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(513845106211177695)
,p_name=>'Add Featured Modifier Class to Icon List'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_da_event_comment=>'Currently the Icon List widget does not support having modifier classes applied via the Advanced CSS Class property for items. This dynamic action removes the "a-IconList--wizard" modifier and adds the class "a-IconList--featured" instead.'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(513845512307177716)
,p_event_id=>wwv_flow_imp.id(513845106211177695)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_REMOVE_CLASS'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'.a-IconList'
,p_attribute_01=>'a-IconList--wizard'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(513845950748177716)
,p_event_id=>wwv_flow_imp.id(513845106211177695)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ADD_CLASS'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'.a-IconList'
,p_attribute_01=>'a-IconList--featured'
);
end;
/
prompt --application/pages/page_00462
begin
wwv_flow_imp_page.create_page(
 p_id=>462
,p_name=>'Deinstall Script'
,p_alias=>'DEINSTALL-SCRIPT'
,p_step_title=>'Deinstall Script'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'No help is available for this page.'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(403373707864014016)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(403383791686349173)
,p_plug_name=>'Deinstall Script'
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_column=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select deinstall_script s',
'from WWV_FLOW_INSTALL',
'where flow_id = :fb_flow_id',
'and security_group_id = :flow_security_group_id',
'and nvl(sys.dbms_lob.getlength(deinstall_script),0) > 0',
'and instr(nvl(:P462_DOWNLOAD_OPTION,''DEINSTALL''),''DEINSTALL'') > 0',
'union all',
'select to_clob(',
'	    ''''||chr(10)||',
'       ''prompt -- Remove Application''||chr(10)||',
'       ''begin''||chr(10)||',
'       ''wwv_flow_imp.remove_application (p_application_id=>''||:fb_flow_id||'', p_workspace_id=>''||:flow_security_group_id||'');''||chr(10)||',
'       ''commit;''||chr(10)||',
'       ''end;''||chr(10)||',
'       ''/'') s',
'from dual',
'where instr(nvl(:P462_DOWNLOAD_OPTION,''DEINSTALL''),''APP_REMOVE'') > 0'))
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.CLOB_CODE_EDITOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'DDL',
  'attribute_02', 'AUTO',
  'attribute_03', 'Y',
  'attribute_04', 'VARCHAR2')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(403385345576385427)
,p_plug_name=>'Deinstall Script'
,p_region_template_options=>'#DEFAULT#:a-Region--sideRegion:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<p>Use deinstall script to drop database objects and static files that are created by the installation scripts.  You can download the deinstall script and include a call to remove the application.  This download can be used from the command-line to d'
||'einstall and remove the application.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(403373911537014017)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(403373707864014016)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:576:&SESSION.::&DEBUG.:::'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(403374195288014017)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(403373707864014016)
,p_button_name=>'DOWNLOAD'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Download'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(403385830623395386)
,p_name=>'P462_DOWNLOAD_OPTION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(403373707864014016)
,p_prompt=>'Download'
,p_source=>'DEINSTALL'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'P462_DOWNLOAD_OPTION'
,p_lov=>'.'||wwv_flow_imp.id(403387737278446376)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select what to include in the deinstall script download.  The download can include the deinstall script and remove application call.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(452937644381035341)
,p_name=>'refresh'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P462_DOWNLOAD_OPTION'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(452937928378035343)
,p_event_id=>wwv_flow_imp.id(452937644381035341)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(403384225997363413)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'download deinstall script'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_init_htp_buffer;',
'wwv_flow_utilities.print_download_header (',
'       p_mime_type     => ''application/x-sql'',',
'       p_mime_charset  => ''utf-8'',',
'       p_file_name     => ''f''||:fb_flow_id||''_deinstall_script.sql'',',
'       p_is_attachment => true );',
'sys.owa_util.http_header_close;',
'',
'sys.htp.p(''prompt -- Deinstall Supporting Objects'');',
'if instr(:P462_DOWNLOAD_OPTION,''DEINSTALL'') > 0 then',
'    for c1 in (select deinstall_script',
'               from WWV_FLOW_INSTALL',
'               where flow_id = :fb_flow_id',
'               and security_group_id = :flow_security_group_id',
'               and nvl(sys.dbms_lob.getlength(deinstall_script),0) > 0)',
'    loop',
'        wwv_htp.print_clob(c1.deinstall_script);',
'    end loop;',
'end if;',
'',
'if instr(:P462_DOWNLOAD_OPTION,''APP_REMOVE'') > 0 then',
'    sys.htp.p('''');',
'    sys.htp.p(''prompt -- Remove Application'');',
'    sys.htp.p(''begin'');',
'    sys.htp.p(''wwv_flow_imp.remove_application (p_application_id=>''||:fb_flow_id||'', p_workspace_id=>''||:flow_security_group_id||'');'');',
'    sys.htp.p(''commit;'');',
'    sys.htp.p(''end;'');',
'    sys.htp.p(''/'');',
'end if;',
'sys.htp.p(''prompt  ...done'');',
'',
'wwv_flow.stop_apex_engine;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to download the install scripts.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(403374195288014017)
,p_internal_uid=>403384225997363413
);
end;
/
prompt --application/pages/page_00464
begin
wwv_flow_imp_page.create_page(
 p_id=>464
,p_name=>'Create List - Query'
,p_alias=>'CREATE-LIST-QUERY'
,p_page_mode=>'MODAL'
,p_step_title=>'Create List'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213210808239773454)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_lov.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1434304280667092)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(169186610834587350)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1434503216667092)
,p_plug_name=>'Examples'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(399849897040726767)
,p_plug_display_sequence=>20
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Example 1: ',
'<pre>',
'SELECT null, ',
'       ENAME label, ',
'       null target, ',
'       ''YES'' is_current, ',
'       ''&#35;APP_IMAGES&#35;del.gif'' image, ',
'       ''width="20" height="20"'' image_attrib, ',
'       ENAME image_alt',
'FROM  emp ',
'ORDER BY ename',
'</pre>',
'Example 2 (using bind variable): ',
'<pre>',
'SELECT null, ',
'       ENAME label, ',
'       ''f?p=&amp;APP_ID.:1:''||:APP_SESSION||''::::P1_EMPNO:''||empno target, ',
'       null is_current',
'FROM  emp ',
'WHERE deptno = :MY_ITEM ',
'ORDER BY 1',
'</pre>',
'Example 3 (using hierarchical SQL query):',
'<pre>',
'select level, ',
'       ENAME label, ',
'       ''f?p=&amp;APP_ID.:1:''||:APP_SESSION||''::::P1_EMPNO:''||empno target,',
'       ''NO'' is_current,',
'       ''&#35;APP_IMAGES&#35;del.gif'' image',
'from EMP',
'start with MGR is null',
'connect by prior EMPNO = MGR',
'order siblings by ENAME',
'</pre>',
'Example 4 (using function that returns a SQL query):',
'<pre>',
'IF :MY_ITEM = ''10'' THEN',
'  RETURN ',
'  ''SELECT null, ename label''||',
'  ''FROM emp ''||',
'  ''WHERE deptno = 10 ORDER BY 1'';',
'ELSE',
'  RETURN ',
'  ''SELECT null, ename label''||',
'  ''FROM emp ''||',
'  ''WHERE deptno = :MY_ITEM ORDER BY 1'';',
'END IF;',
'</pre>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1434728122667093)
,p_plug_name=>'Create List'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47243831909526629)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(758615610992655706)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(1434728122667093)
,p_button_name=>'QUERY_BUILDER'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Build Query'
,p_button_redirect_url=>'f?p=&APP_ID.:542:&SESSION.::&DEBUG.:RP,542,701,719:P464_LIST_SOURCE_FIELD:P464_QUERY:'
,p_grid_new_row=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1434911958667093)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47243831909526629)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(11341627974749057)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(47243831909526629)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1435130280667096)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(47243831909526629)
,p_button_name=>'Back'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(11419509280286457)
,p_branch_action=>'f?p=&APP_ID.:734:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(11341627974749057)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1438607505667112)
,p_branch_action=>'f?p=&FLOW_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1438825916667112)
,p_branch_action=>'427'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(1435130280667096)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1435501565667096)
,p_name=>'P464_QUERY'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(1434728122667093)
,p_prompt=>'SQL Query:'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>9
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a list SQL Query or Function returning a SQL Query  to generate a dynamic list. Click <strong>Examples</strong> to view sample SQL queries.</p>',
'<strong>SQL Query Syntax:</strong>',
'<pre>',
'select level, labelValue label, ',
'       [targetValue]            target, ',
'       [is_current]             is_current_list_entry,',
'       [imageValue]             image, ',
'       [imageAttributeValue]    image_attribute,',
'       [imageAltValue]          image_alt_attribute,',
'       [attribute1]             attribute1,',
'       [attribute2]             attribute2,',
'       [attribute3]             attribute3,',
'       [attribute4]             attribute4,',
'       [attribute5]             attribute5,',
'       [attribute6]             attribute6,',
'       [attribute7]             attribute7,',
'       [attribute8]             attribute8,',
'       [attribute9]             attribute9,',
'       [attribute10]            attribute10',
'from ...',
'where ...',
'order by ...',
'</pre>',
'',
'<strong>Function Returning SQL Query Syntax:</strong>',
'<pre>',
'RETURN',
'''select level, labelValue label,''||',
'''       [targetValue]         target,''|| ',
'''       [is_current]          is_current_list_entry,''||',
'''       [imageValue]          image,''||',
'''       [imageAttributeValue] image_attribute, ''||',
'''       [imageAltValue]       image_alt_attribute,''||',
'''       [attribute1]          attribute1,''||',
'''       [attribute2]          attribute2,''||',
'''       [attribute3]          attribute3,''||',
'''       [attribute4]          attribute4,''||',
'''       [attribute5]          attribute5,''||',
'''       [attribute6]          attribute6,''||',
'''       [attribute7]          attribute7,''||',
'''       [attribute8]          attribute8,''||',
'''       [attribute9]          attribute9,''||',
'''       [attribute10]         attribute10''||',
'''from ...''||',
'''where ...''||',
'''order by ...'';',
'</pre>',
'',
'<strong>NOTE:</strong>The <i>is_current</i> column can be set to one of the following three values:<strong>''YES''</strong>,<strong>''NO''</strong> or <strong>NULL</strong>.  If set to NULL, the currency of the list entry will be based on the target page'
||' of the list entry.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PAGE_ITEM'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_06=>'P464_EDITOR_MODE'
,p_attribute_07=>'N'
,p_item_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Remove default value: ',
'select ENAME label, NULL target',
'from   EMP',
'order by EMPNO'))
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1437319745667106)
,p_name=>'P464_SHOW_PREVIEW'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1434728122667093)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10687702263549991)
,p_name=>'P464_QUERY_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1434728122667093)
,p_item_default=>'SQL_QUERY'
,p_prompt=>'Query Source Type'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'FLASH_CHART_QUERY_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(6026412205740110)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the query source type.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12831404929271461)
,p_name=>'P464_LIST_SOURCE_FIELD'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(1434728122667093)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(78408855239861204)
,p_name=>'P464_EDITOR_MODE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1434728122667093)
,p_use_cache_before_default=>'NO'
,p_source=>'case when :P464_QUERY_TYPE = ''SQL_QUERY'' then ''SQL'' else ''PLSQL_FUNCTION_BODY'' end'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1437810826667106)
,p_computation_sequence=>10
,p_computation_item=>'P464_SHOW_PREVIEW'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'YES'
,p_computation_error_message=>'Unable to compute item value.'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1438231567667110)
,p_validation_name=>'is_valid_list_query'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      return wwv_flow_f4000_util.is_valid_list_query(',
'                   p_query      => :P464_QUERY,',
'                   p_query_type => :P464_QUERY_TYPE);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'List query is invalid, a sequence, label and a target value are needed. If your query contains an in-line query, the first FROM clause in the SQL statement must not belong to the in-line query.'
,p_when_button_pressed=>wwv_flow_imp.id(11341627974749057)
,p_associated_item=>wwv_flow_imp.id(1435501565667096)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(574135074429781506)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1434911958667093)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(574135187287781507)
,p_event_id=>wwv_flow_imp.id(574135074429781506)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(78408942601861205)
,p_name=>'On P464_QUERY_TYPE Change'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P464_QUERY_TYPE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(78409022940861206)
,p_event_id=>wwv_flow_imp.id(78408942601861205)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P464_EDITOR_MODE'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'apex.item(''P464_QUERY_TYPE'').getValue() === ''SQL_QUERY'' ? ''SQL'' : ''PLSQL_FUNCTION_BODY'''
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
end;
/
prompt --application/pages/page_00467
begin
wwv_flow_imp_page.create_page(
 p_id=>467
,p_name=>'Edit Build Status'
,p_alias=>'EDIT-BUILD-STATUS'
,p_page_mode=>'MODAL'
,p_step_title=>'Edit Build Status'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12511519296310366)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(205259705444400875)
,p_plug_name=>'Edit Build and Application Status'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(846719915735214909)
,p_plug_name=>'Edit Build and Application Status'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(846720064004214910)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(205260101200400877)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(846720064004214910)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(205259924581400876)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(846720064004214910)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'CREATE'
,p_button_condition=>'P467_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(205260618787400882)
,p_branch_action=>'f?p=&APP_ID.:103:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(205260808758400883)
,p_name=>'P467_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(205259705444400875)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application: '
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(205261428525400894)
,p_name=>'P467_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(205259705444400875)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application Name:'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(205261801105400896)
,p_name=>'P467_FLOW_STATUS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(205259705444400875)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application Status'
,p_source=>'FLOW_STATUS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_FLOW_STATUS'
,p_lov=>'.'||wwv_flow_imp.id(634347472712995)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'Y'
,p_help_text=>'<div class="htmldbInfoBodyP">Specifies if the application is available or unavailable for use.<p />It can be available, available with Developer Toolbar (with the developer toolbar included on each page -- requires developer to be logged in to the Ap'
||'p Builder in the same browser session), or available to developers only (users who have accounts allowing them to run the App Builder), or available only to developers named (by account name) in the restricted developers list attribute on the applica'
||'tion attributes page. <p />The application can be unavailable also, meaning it cannot be run: Unavailable with no explanation, Unavailable with a message displayed (enter this in the attribute field designated for this), Unavailable with a URL to red'
||'irect users to (enter this in the same attribute field), or Unavailable with a message issued by PL/SQL entered in the same attribute field.</div>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(205262022833400897)
,p_name=>'P467_BUILD_STATUS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(205259705444400875)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Build Status'
,p_source=>'BUILD_STATUS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'BUILD_STATUS'
,p_lov=>'.'||wwv_flow_imp.id(84305510710571518)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select a Build Status. Options include:</p>',
'<ul>',
'<li><strong>Run Application Only</strong> - Developers can only run an application. Application will appear in the list of applications shown in the App Builder for the workspace, but cannot be edited in any way.</li>',
'<li><strong>Run and Build Application</strong> - Developers can both run and edit an application. Application will appear in the App Builder''s list of applications for the workspace.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(205261621674400895)
,p_validation_name=>'P467_NAME not null'
,p_validation_sequence=>10
,p_validation=>'P467_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Name must have some value.'
,p_associated_item=>wwv_flow_imp.id(205261428525400894)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(755297765041836843)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(205260101200400877)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(755297820747836844)
,p_event_id=>wwv_flow_imp.id(755297765041836843)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(205262230041400900)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOWS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOWS'
,p_attribute_03=>'P467_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Unable to fetch row.'
,p_internal_uid=>205262230041400900
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(205262424080400903)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOWS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOWS'
,p_attribute_03=>'P467_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'U'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Unable to process row of table WWV_FLOWS.'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>205262424080400903
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(755297606543836842)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>755297606543836842
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1600803266808875)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Unset flow IDs'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':FB_FLOW_ID := null;',
':FB_FLOW_PAGE_ID := null;',
':F4000_P1_FLOW := null;',
':F4000_P1_PAGE := null;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(205259924581400876)
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id from wwv_flows ',
' where id = :FB_FLOW_ID ',
'   and build_status = ''RUN_ONLY''',
'   and security_group_id = :flow_security_group_id'))
,p_process_when_type=>'EXISTS'
,p_internal_uid=>1600803266808875
);
end;
/
prompt --application/pages/page_00468
begin
wwv_flow_imp_page.create_page(
 p_id=>468
,p_name=>'Create Legacy Calendar Template - Copy From'
,p_alias=>'CREATE-LEGACY-CALENDAR-TEMPLATE-COPY-FROM'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Legacy Calendar Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(38349806306948665)
,p_plug_name=>'Create Legacy Calendar Template'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>'<p>Select the application that contains the templates you wish to copy.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(38350223905948666)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(320074633987)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(186387513541296806)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(38351004698948669)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(186387513541296806)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(38351822498948672)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(186387513541296806)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(38351423917948671)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(186387513541296806)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(154621222428457477)
,p_branch_action=>'f?p=&FLOW_ID.:418:&SESSION.::&DEBUG.:418::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(589886799247923012)
,p_branch_action=>'f?p=&APP_ID.:161:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(38351423917948671)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(38352211144948676)
,p_name=>'P468_COPY_FROM_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(38349806306948665)
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Copy From Application'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select an Application -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the application from which you wish to copy templates.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(38353006404948687)
,p_validation_name=>'P468_COPY_FROM_FLOW_ID Not Null'
,p_validation_sequence=>1
,p_validation=>'P468_COPY_FROM_FLOW_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Copy From Application must be specified.'
,p_associated_item=>wwv_flow_imp.id(38352211144948676)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 19-FEB-2002 11:14'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(589886564917923010)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(38351004698948669)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(589886679856923011)
,p_event_id=>wwv_flow_imp.id(589886564917923010)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00469
begin
wwv_flow_imp_page.create_page(
 p_id=>469
,p_name=>'Create Legacy Calendar Template - New Templates'
,p_alias=>'CREATE-LEGACY-CALENDAR-TEMPLATE-NEW-TEMPLATES'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Legacy Calendar Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(38368218867972334)
,p_name=>'Create Legacy Calendar Template'
,p_template=>wwv_flow_imp.id(42025417508627628)
,p_display_sequence=>100
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  id,',
'  flow_id,',
'name From_name,',
'  wwv_flow_lang.system_message(''F4000.P158.COPY_OF'',name) to_NAME,',
'  ''N'' sub',
'from wwv_flow_cal_templates',
'where flow_id = :P468_COPY_FROM_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'and theme_id = :P418_COPY_FROM_THEME'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No templates found.'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(289755409410534315)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(287707908141523402)
,p_query_column_id=>2
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>2
,p_column_heading=>'Application'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(289797223290765447)
,p_query_column_id=>3
,p_column_alias=>'FROM_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'From Name'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(289798101950768791)
,p_query_column_id=>4
,p_column_alias=>'TO_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'To Name'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>40
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(289754604561532905)
,p_query_column_id=>5
,p_column_alias=>'SUB'
,p_column_display_sequence=>5
,p_column_heading=>'Copy?'
,p_use_as_row_header=>'N'
,p_display_as=>'SELECT_LIST_FROM_LOV'
,p_named_lov=>wwv_flow_imp.id(150847232623403358)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(38371005236972344)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(320074633987)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(186389525924319236)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(38372227583972350)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(186389525924319236)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(38371807608972346)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(186389525924319236)
,p_button_name=>'Copy'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(38372614697972351)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(186389525924319236)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(154627711739482728)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(589887332468923018)
,p_branch_action=>'f?p=&APP_ID.:418:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(38372614697972351)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(74851015403642682)
,p_name=>'P469_THEME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(38368218867972334)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Copy to Theme:'
,p_source=>'P418_COPY_TO_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies a collection of templates which define the look and feel of the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(287700713635496617)
,p_name=>'P469_COPY_FROM_APPLICATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(38368218867972334)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Copy From Application:'
,p_source=>'&P468_COPY_FROM_FLOW_ID.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(38373107877972356)
,p_validation_name=>'NoDupTemplateNames'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_found_name varchar2(2000) := null;',
'begin',
'for i in 1..wwv_flow.g_f01.count',
'loop',
'   if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'')',
'      then',
'      for c1 in (',
'      select name',
'        from WWV_FLOW_cal_TEMPLATES',
'       where flow_id = :FB_FLOW_ID',
'         and security_group_id = (select PROVISIONING_COMPANY_ID',
'                                    from wwv_flow_companies',
'                                   where SHORT_NAME = :COMPANY)',
'         and name = wwv_flow.g_f02(i) )      loop',
'         if c1.name is not null',
'           then if l_found_name is null',
'                    then l_found_name := c1.name;',
'                 else l_found_name := l_found_name||'', ''||c1.name;',
'                 end if;',
'         end if;',
'      end loop;',
'   end if;',
'end loop;',
'',
'if l_found_name is not null',
'   then return wwv_flow_lang.system_message(''F4000.TEMPLATE_NAME_ALREADY_EXISTS'',l_found_name);',
'end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_when_button_pressed=>wwv_flow_imp.id(38371807608972346)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(290041508201271999)
,p_validation_name=>'OneToCopy'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  for i in 1..wwv_flow.g_f01.count loop',
'    if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'') then',
'      return true;',
'    end if;',
'  end loop;',
'  return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'You must select at least one template to be copied.',
''))
,p_when_button_pressed=>wwv_flow_imp.id(38371807608972346)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(589887167321923016)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(38372227583972350)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(589887225425923017)
,p_event_id=>wwv_flow_imp.id(589887167321923016)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(38373518186972361)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Calendar Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_template_id number;',
'  i             number := 0;',
'  l_from        number := :P468_COPY_FROM_FLOW_ID;',
'  l_to          number := :FB_FLOW_ID;',
'begin',
'for i in 1..wwv_flow.g_f01.count loop',
'  l_template_id := wwv_flow_id.next_val;',
'  if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'') then',
'    wwv_flow_templates_util.copy_calendar_template (',
'    p_copy_from_flow_id    => l_from,',
'    p_flow_id              => l_to,',
'    p_from_template_id     => wwv_flow.g_f01(i),',
'    p_to_template_name     => wwv_flow.g_f02(i),',
'    p_to_template_id       => l_template_id,',
'    p_to_theme_id          => :p469_theme,',
'    p_include_subscription => (wwv_flow.g_f03(i)=''SUBSCRIBE'')',
'    );',
'    if wwv_flow.g_f03(i) = ''SUBSCRIBE'' then',
'      wwv_flow_copy_metadata.subscribe_calendar_template (',
'        p_master_template_id         => wwv_flow.g_f01(i),',
'        p_subscribing_template_id    => l_template_id',
'      );',
'    end if;',
'  end if;',
'end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying calendar template(s).'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(38371807608972346)
,p_process_success_message=>'Calendar template(s) copied.'
,p_internal_uid=>38373518186972361
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(589887494227923019)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(38371807608972346)
,p_process_success_message=>'Calendar template(s) copied.'
,p_internal_uid=>589887494227923019
);
end;
/
prompt --application/pages/page_00473
begin
wwv_flow_imp_page.create_page(
 p_id=>473
,p_name=>'Installation Scripts'
,p_alias=>'INSTALLATION-SCRIPTS'
,p_step_title=>'Installation Scripts'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(24897722063538624)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deployment.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(12979519988497157)
,p_plug_name=>'Installation Scripts'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>60
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with upd as',
'( select id',
'    from wwv_flow_install_scripts a',
'   where a.security_group_id = :flow_security_group_id',
'     and a.flow_id           = :fb_flow_id',
'     and exists ( select 1',
'                    from sys.dba_objects b,',
'                         wwv_flow_install_objects c',
'                   where b.object_type   = c.object_type',
'                     and b.owner         = replace(c.object_owner,''#''||''OWNER''||''#'',wwv_flow_wizard_api.get_flow_owner)',
'                     and b.object_name   = c.object_name',
'                     and b.last_ddl_time > nvl(a.last_updated_on, a.created_on)',
'                     and a.id = c.script_id )',
'   union',
'  select distinct script_id id',
'    from wwv_flow_install_objects a',
'   where a.security_group_id = :flow_security_group_id',
'     and a.flow_id           = :fb_flow_id',
'     and not exists ( select 1',
'                        from sys.dba_objects',
'                       where owner       = replace(a.object_owner,''#''||''OWNER''||''#'',wwv_flow_wizard_api.get_flow_owner)',
'                         and object_type = a.object_type',
'                         and object_name = a.object_name ) ),',
'ob as',
'( select distinct script_id id',
'    from wwv_flow_install_objects a',
'   where a.security_group_id = :flow_security_group_id',
'     and a.flow_id           = :fb_flow_id )',
'select s.id,',
'       case when (l.locked_by is null) or (l.locked_by is not null and l.locked_by = :app_user) then',
'           ''<a href="''',
'           ||wwv_flow_page_api.get_url (',
'                 p_page        => 865,',
'                 p_clear_cache => ''865,INSTALL_SCRIPT'',',
'                 p_items       => ''P865_SCRIPT_ID,P865_MODE,F4000_LAST_VIEW'',',
'                 p_values      => s.id||'',EDIT,473'' )',
'           ||''">''',
'           ||''<img src="#IMAGE_PREFIX#menu/pencil2_16x16.gif" alt="''||sm.edit||''"></a>''',
'       end edit_link,',
'       s.name,',
'       s.sequence,',
'       lower(nvl(s.last_updated_by,s.created_by)) updated_by,',
'       nvl(s.last_updated_on,s.created_on) last_updated_on,',
'       sys.dbms_lob.substr(s.script,200,1)||(case when sys.dbms_lob.getlength(s.script) > 200 then ''...'' end) script,',
'       decode (ob.id, null, sm.manual, sm.database_object) source,',
'       decode (upd.id, null, null, sm.need_refresh) status,',
'       decode (ob.id, null, null, wwv_flow_item.checkbox(1,ob.id,''title="''||wwv_flow_lang.system_message(''SELECT_ROW_C'', wwv_flow_escape.html(s.name))||''"'')) refresh,',
'       case when l.locked_by is null then',
'           wwv_flow_lang.system_message(''SCRIPT_NAME_UNLOCKED'', wwv_flow_escape.html(s.name))',
'       else',
'           wwv_flow_lang.system_message(''SCRIPT_NAME_LOCKED'', wwv_flow_escape.html(s.name))',
'       end locked,',
'       case when l.locked_by is null then',
'           ''icon-unlock''',
'       else',
'           ''icon-lock''',
'       end lock_icon,',
'       l.id lock_id',
'  from "#OWNER#"."WWV_FLOW_INSTALL_SCRIPTS" s,',
'       upd,',
'       ob,',
'       wwv_flow_lock_script l,',
'       (select wwv_flow_lang.system_message(''MANUAL'') manual,',
'       	       wwv_flow_lang.system_message(''F4000_P473_DATABASE_OBJECT'') database_object,',
'       	       wwv_flow_lang.system_message(''P473_NEEDS_REFRESH'') need_refresh,',
'       	       wwv_flow_lang.system_message(''EDIT'') edit',
'          from sys.dual) sm',
' where s.flow_id                    = :FB_FLOW_ID',
'   and s.security_group_id          = :FLOW_SECURITY_GROUP_ID',
'   and s.id                         = ob.id(+)',
'   and s.id                         = upd.id(+)',
'   and s.id                         = l.script_id(+)',
'   and nvl(s.script_type,''INSTALL'') = ''INSTALL'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(12979631587497157)
,p_name=>'Installation Scripts'
,p_max_row_count=>'100000'
,p_max_row_count_message=>'This query returns more than #MAX_ROW_COUNT# rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No installation scripts found.'
,p_allow_report_categories=>'N'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'CBCHO'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(864390440370490068)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'N'
,p_column_label=>'ID'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(879352987753382191)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>20
,p_column_identifier=>'O'
,p_column_label=>'<br />'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12979918866497174)
,p_db_column_name=>'NAME'
,p_display_order=>30
,p_column_identifier=>'B'
,p_column_label=>'Name'
,p_column_link=>'f?p=&APP_ID.:328:&SESSION.::&DEBUG.:RP,328:P328_ID,F4000_LAST_VIEW:#ID#,473:'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12980005514497174)
,p_db_column_name=>'SEQUENCE'
,p_display_order=>40
,p_column_identifier=>'C'
,p_column_label=>'Sequence'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12980109021497174)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>50
,p_column_identifier=>'D'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12980210170497174)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>60
,p_column_identifier=>'E'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12980316805497174)
,p_db_column_name=>'SCRIPT'
,p_display_order=>70
,p_column_identifier=>'F'
,p_column_label=>'Script'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(621101874714076415)
,p_db_column_name=>'STATUS'
,p_display_order=>80
,p_column_identifier=>'G'
,p_column_label=>'Status'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(621103725734076434)
,p_db_column_name=>'SOURCE'
,p_display_order=>90
,p_column_identifier=>'H'
,p_column_label=>'Source'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(621103814768076435)
,p_db_column_name=>'REFRESH'
,p_display_order=>100
,p_column_identifier=>'I'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(857366481053253714)
,p_db_column_name=>'LOCKED'
,p_display_order=>120
,p_column_identifier=>'M'
,p_column_label=>'Lock'
,p_column_link=>'f?p=&APP_ID.:16:&SESSION.::&DEBUG.:Y,16:P16_LOCK_SCRIPT_ID,P16_LOCK_ID:#ID#,#LOCK_ID#'
,p_column_linktext=>'<span class="a-Icon #LOCK_ICON#" ></span><span class="u-VisuallyHidden">#LOCKED#</span>'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1803215975462331)
,p_db_column_name=>'LOCK_ICON'
,p_display_order=>130
,p_column_identifier=>'P'
,p_column_label=>'Lock Icon'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1803370507462332)
,p_db_column_name=>'LOCK_ID'
,p_display_order=>140
,p_column_identifier=>'Q'
,p_column_label=>'Lock Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(12983410815532326)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'129835'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_display_rows=>100
,p_report_columns=>'ID:EDIT_LINK:LOCKED:NAME:SEQUENCE:SCRIPT:STATUS:LAST_UPDATED_ON:UPDATED_BY:SOURCE:REFRESH::LOCK_ICON:LOCK_ID'
,p_sort_column_1=>'SEQUENCE'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'0'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22471221660271476)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(22452018965176093)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(24424029929889971)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(24172418538839346)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(22546618571497665)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(12979519988497157)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:RP::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(621103964030076436)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(12979519988497157)
,p_button_name=>'Refresh'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Refresh Checked'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(22467314949260024)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(12979519988497157)
,p_button_name=>'CREATESCRIPT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:850:&SESSION.::&DEBUG.:850:F4000_LAST_VIEW:473'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(29867215584590480)
,p_branch_name=>'Go To Page &P567_BRANCH_PAGE.'
,p_branch_action=>'f?p=&APP_ID.:&P567_BRANCH_PAGE.:&SESSION.::&DEBUG.:&P567_BRANCH_PAGE.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'substr(:REQUEST,1,13) = ''APPLY_CHANGES'''
,p_branch_condition_text=>'PLSQL'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(22546825278497667)
,p_branch_action=>'f?p=&APP_ID.:473:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(29869327359593875)
,p_computation_sequence=>10
,p_computation_item=>'P567_BRANCH_PAGE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'substr(v(''REQUEST''),15)'
,p_compute_when=>'substr(:REQUEST,1,13) = ''APPLY_CHANGES'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(857370469719484743)
,p_computation_sequence=>20
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'APP_PAGE_ID'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(535751809748150806)
,p_validation_name=>'must select one script'
,p_validation_sequence=>10
,p_validation=>'wwv_flow.g_f01.count > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'You must select at least one script to refresh.'
,p_when_button_pressed=>wwv_flow_imp.id(621103964030076436)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(933182140636833415)
,p_name=>'RENDERING: Page - Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(12979519988497157)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(933182491658833417)
,p_event_id=>wwv_flow_imp.id(933182140636833415)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var lSuccessMsg = this.data.APEX_SUCCESS_MESSAGE,',
'      lUrl = ''f?p=&APP_ID.:473:&SESSION.::'',',
'      lVal = this.data[ ''REQUEST'' ]; ',
'',
'if ( lSuccessMsg ) {',
'   lUrl += ''&success_msg='' + lSuccessMsg;',
'}',
'setTimeout(function() {',
'    apex.navigation.redirect(lUrl);',
'}, 0);'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1199172759230878403)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>20
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(12979519988497157)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1199172873524878404)
,p_event_id=>wwv_flow_imp.id(1199172759230878403)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(535751771019150805)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh Scripts'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_code          clob;',
'    l_object_types  varchar2(32767);',
'    l_objects       varchar2(32767);',
'    l_owner         wwv_flow_global.t_dbms_id;',
'    l_script_option varchar2(30);',
'begin',
'',
'    for i in 1.. wwv_flow.g_f01.count loop',
'',
'        l_object_types := null;',
'        l_objects := null;',
'        l_owner := null;',
'        l_script_option := null;',
'        l_code := empty_clob;',
'',
'        for c1 in (select script_option',
'                     from wwv_flow_install_scripts',
'                    where security_group_id = :WORKSPACE_ID',
'                      and flow_id = :FB_FLOW_ID',
'                      and id = wwv_flow.g_f01(i) ) loop',
'            l_script_option := c1.script_option;',
'        end loop;',
'',
'        for c1 in (select distinct replace(object_owner,''#''||''OWNER''||''#'',wwv_flow_wizard_api.get_flow_owner) object_owner',
'                     from wwv_flow_install_objects',
'                    where security_group_id = :WORKSPACE_ID',
'                      and flow_id = :FB_FLOW_ID',
'                      and script_id =  wwv_flow.g_f01(i) ) loop',
'',
'            for c2 in (select distinct object_type',
'                         from wwv_flow_install_objects',
'                        where replace(object_owner,''#''||''OWNER''||''#'',wwv_flow_wizard_api.get_flow_owner) = c1.object_owner',
'                          and security_group_id = :WORKSPACE_ID',
'                          and flow_id = :FB_FLOW_ID',
'                          and script_id = wwv_flow.g_f01(i) ) loop',
'                l_object_types := l_object_types||c2.object_type||'':'';',
'            end loop;',
'',
'            for c2 in (select object_name',
'                         from wwv_flow_install_objects',
'                        where replace(object_owner,''#''||''OWNER''||''#'',wwv_flow_wizard_api.get_flow_owner) = c1.object_owner',
'                          and security_group_id = :WORKSPACE_ID',
'                          and flow_id = :FB_FLOW_ID',
'                          and script_id = wwv_flow.g_f01(i) ) loop',
'                l_objects := l_objects||c2.object_name||'':'';',
'            end loop;',
'',
'            if nvl(l_script_option,''x'') in (''PACKAGE_SPEC'',''PACKAGE_BODY'') then',
'                l_object_types := l_script_option;',
'            else',
'                l_object_types := rtrim(l_object_types,'':'');',
'            end if;',
'',
'            l_code := wwv_flow_generate_ddl.get_ddl_supporting_objects(',
'                              p_schema      => c1.object_owner,',
'                              p_object_type => l_object_types,',
'                              p_objects     => rtrim(l_objects,'':''));',
'        end loop;',
'',
'        update wwv_flow_install_scripts',
'           set script = l_code',
'         where security_group_id = :WORKSPACE_ID',
'           and flow_id = :FB_FLOW_ID',
'           and id = wwv_flow.g_f01(i);',
'',
'    end loop;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error refreshing selected scripts. #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(621103964030076436)
,p_process_success_message=>'Selected scripts refreshed from database source.'
,p_internal_uid=>535751771019150805
);
end;
/
prompt --application/pages/page_00477
begin
wwv_flow_imp_page.create_page(
 p_id=>477
,p_name=>'Copy List Entries - Identify Copy Target'
,p_alias=>'COPY-LIST-ENTRIES-IDENTIFY-COPY-TARGET'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy List Entries'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213210808239773454)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'nav_list.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(33734524398549258)
,p_plug_name=>'Copy List Entries'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(33731702665524035)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(203453619807378527)
,p_plug_name=>'Copy List Entries'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'Region generated 07-JUL-2004 16:26:34'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(203523017988535682)
,p_name=>'List Entries to be copied'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select LIST_ITEM_DISPLAY_SEQUENCE, LIST_ITEM_LINK_TEXT, LIST_ITEM_LINK_TARGET',
'from WWV_FLOW_LIST_ITEMS',
'where flow_id = :fb_flow_id ',
'and list_id = :P477_COPY_LIST_FROM',
'and security_group_id = :flow_security_group_id',
'order by LIST_ITEM_DISPLAY_SEQUENCE, LIST_ITEM_LINK_TEXT'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(203523623383535699)
,p_query_column_id=>1
,p_column_alias=>'LIST_ITEM_DISPLAY_SEQUENCE'
,p_column_display_sequence=>1
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(203523728739535701)
,p_query_column_id=>2
,p_column_alias=>'LIST_ITEM_LINK_TEXT'
,p_column_display_sequence=>2
,p_column_heading=>'Label'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(203523824883535701)
,p_query_column_id=>3
,p_column_alias=>'LIST_ITEM_LINK_TARGET'
,p_column_display_sequence=>3
,p_column_heading=>'Target'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(205209709423692252)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747142823509138164)
,p_plug_name=>'Copy List Entries'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(203454830529378538)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(205209709423692252)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:4050:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(203455131762378538)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(205209709423692252)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(203455924104378545)
,p_branch_action=>'f?p=&APP_ID.:478:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(203455131762378538)
,p_branch_sequence=>10
,p_branch_comment=>'Generated 07-JUL-2004 16:26:34'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10915301321281856)
,p_name=>'P477_EXISTING_LIST_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(203453619807378527)
,p_prompt=>'Copy List Entries To'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'COPY LISTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id ',
'  from wwv_flow_lists ',
' where flow_id                 = :FB_FLOW_ID',
'   and security_group_id       = :WORKSPACE_ID',
'   and id                      <> :P477_COPY_LIST_FROM',
'   and nvl(list_type,''STATIC'') = ''STATIC''',
'   and reference_id            is null',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select List -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'The list where the entries will be copied to. Lists that are subscribed to other lists are not offered here for selection.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(203454100034378536)
,p_name=>'P477_COPY_LIST_FROM'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(203453619807378527)
,p_prompt=>'Copy List Entries From:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id',
'  from wwv_flow_lists',
' where id = :P477_COPY_LIST_FROM',
'   and security_group_id = :WORKSPACE_ID'))
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'The list where the entries will be copied from.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'Generated 07-JUL-2004 16:26:34'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(203496202657474468)
,p_validation_name=>'P477_COPY_TO_LIST_NAME'
,p_validation_sequence=>10
,p_validation=>'P477_EXISTING_LIST_ID'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'Value must be specified.'
,p_associated_item=>wwv_flow_imp.id(10915301321281856)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1059807888761457615)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(203454830529378538)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1059807902250457616)
,p_event_id=>wwv_flow_imp.id(1059807888761457615)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00478
begin
wwv_flow_imp_page.create_page(
 p_id=>478
,p_name=>'Copy List Entries - Confirm List Entry Copy'
,p_alias=>'COPY-LIST-ENTRIES-CONFIRM-LIST-ENTRY-COPY'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy List Entries'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213210808239773454)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'nav_list.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(33739122367577089)
,p_plug_name=>'Copy List Entries'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(33731702665524035)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(203456609096378547)
,p_plug_name=>'Copy List Entries'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'Region generated 07-JUL-2004 16:26:34'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(203532331625549056)
,p_name=>'Report of New Combined List'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select max_seq + i.LIST_ITEM_DISPLAY_SEQUENCE LIST_ITEM_DISPLAY_SEQUENCE, i.LIST_ITEM_LINK_TEXT, LIST_ITEM_LINK_TARGET',
'from WWV_FLOW_LIST_ITEMS i,',
'(select ceil(max(list_item_display_sequence)) max_seq ',
'  from   wwv_flow_list_items',
'  where flow_id = :fb_flow_id and list_id = :p477_copy_list_from) m',
'where flow_id = :fb_flow_id and list_id = :P478_COPY_LIST_FROM',
'union all',
'select LIST_ITEM_DISPLAY_SEQUENCE, LIST_ITEM_LINK_TEXT, LIST_ITEM_LINK_TARGET',
'from WWV_FLOW_LIST_ITEMS',
'where flow_id = :fb_flow_id and list_id = :P478_COPY_LIST_TO',
'order by LIST_ITEM_DISPLAY_SEQUENCE, LIST_ITEM_LINK_TEXT'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(203532627252549060)
,p_query_column_id=>1
,p_column_alias=>'LIST_ITEM_DISPLAY_SEQUENCE'
,p_column_display_sequence=>1
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(203532708330549060)
,p_query_column_id=>2
,p_column_alias=>'LIST_ITEM_LINK_TEXT'
,p_column_display_sequence=>2
,p_column_heading=>'Label'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(203532810108549060)
,p_query_column_id=>3
,p_column_alias=>'LIST_ITEM_LINK_TARGET'
,p_column_display_sequence=>3
,p_column_heading=>'Target'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(205211419597704717)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747142929235138164)
,p_plug_name=>'Copy List Entries'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(203457405854378548)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(205211419597704717)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:4050:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(203457528477378548)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(205211419597704717)
,p_button_name=>'FINISH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy List Entries'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(203457626747378548)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(205211419597704717)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:477:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(203459219016378556)
,p_branch_name=>'Go To Page 4050'
,p_branch_action=>'f?p=&APP_ID.:4050:&SESSION.::&DEBUG.::F4000_P4050_LIST_ID:&P477_EXISTING_LIST_ID.:&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(203457528477378548)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'Generated 07-JUL-2004 16:26:34'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(203457112181378548)
,p_name=>'P478_COPY_LIST_FROM'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(203456609096378547)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Copy List Entries From:'
,p_source=>'&P477_COPY_LIST_FROM.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>'select wwv_flow_escape.html(name) name, id from wwv_flow_lists where id = :P477_COPY_LIST_FROM'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'The list whose entries will be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'Generated 07-JUL-2004 16:26:34'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(203504724390499652)
,p_name=>'P478_COPY_LIST_TO'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(203456609096378547)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Copy List Entries To:'
,p_source=>'&P477_EXISTING_LIST_ID.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'COPY LISTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id ',
'  from wwv_flow_lists ',
' where flow_id                 = :FB_FLOW_ID',
'   and security_group_id       = :WORKSPACE_ID',
'   and id                      <> :P477_COPY_LIST_FROM',
'   and nvl(list_type,''STATIC'') = ''STATIC''',
'   and reference_id            is null',
' order by 1'))
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'The list where the list entries will be copied to.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1059807662526457613)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(203457405854378548)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1059807798603457614)
,p_event_id=>wwv_flow_imp.id(1059807662526457613)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(203516901235521392)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'copy list'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_id      number;',
'  l_offset  number;',
'  l_max_seq number;',
'begin',
'',
'  l_offset := wwv_flow_id.next_val;  ',
'',
'  l_id := :P477_EXISTING_LIST_ID;',
'',
'  select ceil(max(list_item_display_sequence)) into l_max_seq ',
'  from   wwv_flow_list_items',
'  where flow_id = :fb_flow_id and list_id = :p477_copy_list_from;',
'      ',
'  insert into wwv_flow_list_items(',
'    id,',
'    list_id,',
'    flow_id,',
'    parent_list_item_id,',
'    sub_list_id,',
'    list_item_type,',
'    list_item_status,',
'    item_displayed,',
'    list_item_display_sequence,',
'    list_item_link_text,',
'    list_item_link_target,',
'    list_item_icon,',
'    list_item_icon_attributes,',
'    list_item_icon_exp,',
'    list_item_icon_exp_attr,',
'    list_item_owner,',
'    list_item_current_for_pages,',
'    list_item_current_type,',
'    list_item_disp_cond_type,',
'    list_item_disp_condition,',
'    list_item_disp_cond_type2,',
'    list_item_disp_condition2,',
'    list_countclicks_y_n,',
'    list_countclicks_cat,',
'    list_text_01,',
'    list_text_02,',
'    list_text_03,',
'    list_text_04,',
'    list_text_05,',
'    list_text_06,',
'    list_text_07,',
'    list_text_08,',
'    list_text_09,',
'    list_text_10,',
'    list_text_11,',
'    list_text_12,',
'    list_text_13,',
'    list_text_14,',
'    list_text_15,',
'    list_text_16,',
'    list_text_17,',
'    list_text_18,',
'    list_text_19,',
'    list_text_20,',
'    required_patch,',
'    security_scheme',
'  ) select ',
'      id + l_offset,',
'      l_id,',
'      flow_id,',
'      parent_list_item_id + l_offset,',
'      sub_list_id,',
'      list_item_type,',
'      list_item_status,',
'      item_displayed,',
'      l_max_seq + list_item_display_sequence,',
'      list_item_link_text,',
'      list_item_link_target,',
'      list_item_icon,',
'      list_item_icon_attributes,',
'      list_item_icon_exp,',
'      list_item_icon_exp_attr,',
'      list_item_owner,',
'      list_item_current_for_pages,',
'      list_item_current_type,',
'      list_item_disp_cond_type,',
'      list_item_disp_condition,',
'      list_item_disp_cond_type2,',
'      list_item_disp_condition2,',
'      list_countclicks_y_n,',
'      list_countclicks_cat,',
'      list_text_01,',
'      list_text_02,',
'      list_text_03,',
'      list_text_04,',
'      list_text_05,',
'      list_text_06,',
'      list_text_07,',
'      list_text_08,',
'      list_text_09,',
'      list_text_10,',
'      list_text_11,',
'      list_text_12,',
'      list_text_13,',
'      list_text_14,',
'      list_text_15,',
'      list_text_16,',
'      list_text_17,',
'      list_text_18,',
'      list_text_19,',
'      list_text_20,',
'      required_patch,',
'      security_scheme ',
'    from wwv_flow_list_items',
'    where flow_id = :fb_flow_id and list_id = :p477_copy_list_from;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to copy list'
,p_process_when_button_id=>wwv_flow_imp.id(203457528477378548)
,p_process_success_message=>'List Copied'
,p_internal_uid=>203516901235521392
);
end;
/
prompt --application/pages/page_00479
begin
wwv_flow_imp_page.create_page(
 p_id=>479
,p_name=>'Export Table Dictionary'
,p_alias=>'EXPORT-TABLE-DICTIONARY'
,p_step_title=>'Export Table Dictionary'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213300727323081712)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_exprt_ui_def.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(145373602748456400)
,p_plug_name=>'Export Settings'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_plug_grid_column_span=>8
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(145375719024461151)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>When you export the Table Dictionary, all Defaults for the selected schema are exported to a single file.  You can use this file to import into another database with &PRODUCT_NAME. installed.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(145771104245665066)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(12802829107)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(168865624822966581)
,p_plug_name=>'Export UI Defaults'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(486429006597229058)
,p_plug_name=>'tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>50
,p_list_id=>wwv_flow_imp.id(486427731138207743)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(486289803110776745)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(168865624822966581)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:479:&SESSION.::&DEBUG.:479::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(145379311883468515)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(168865624822966581)
,p_button_name=>'EXPORT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Export'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(145571206791599566)
,p_branch_action=>'f?p=&FLOW_ID.:479:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(145388905565485646)
,p_name=>'P479_SCHEMA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(145373602748456400)
,p_prompt=>'Schema'
,p_source=>'wwv_flow_user_api.get_default_schema'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS2'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c.schema) d, c.schema r',
'',
'from   wwv_flow_company_schemas c,',
'',
'       wwv_flow_fnd_user u',
'',
'where  c.security_group_id = :flow_security_group_id and',
'',
'       u.security_group_id = :flow_security_group_id and',
'',
'       u.user_name = :flow_user and',
'',
'       (u.ALLOW_ACCESS_TO_SCHEMAS is null or    instr('':''||u.ALLOW_ACCESS_TO_SCHEMAS||'':'','':''||c.schema||'':'')>0)',
'',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Schema -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Select the name of the schema to be exported.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(145933206201731869)
,p_name=>'P479_FILE_CHARSET'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(145373602748456400)
,p_item_default=>'return lower(trim(sys.owa_util.get_cgi_env(''REQUEST_IANA_CHARSET'')));'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'File Character Set'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'I18N_IANA_CHARSET'
,p_lov=>'.'||wwv_flow_imp.id(144796827445692396)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'The export file will be encoded in the specified character set.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(145545923629594905)
,p_validation_name=>'Schema not null'
,p_validation_sequence=>10
,p_validation=>'P479_SCHEMA'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Schema must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(145379311883468515)
,p_associated_item=>wwv_flow_imp.id(145388905565485646)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(651512337100755616)
,p_name=>'Submit'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(145379311883468515)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(651512483074755617)
,p_event_id=>wwv_flow_imp.id(651512337100755616)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'EXPORT'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(145708826793624227)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'table_dict_export'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- set content disposition    ',
'sys.htp.init;',
'wwv_flow.g_page_text_generated := true;',
'wwv_flow_gen_hint.g_mime_shown := true;',
'',
'',
'wwv_flow_utilities.print_download_header(',
'  p_mime_type => ''application/x-sql'',',
'  p_is_attachment => true,',
'  p_file_name => lower(:P479_SCHEMA)||''_uidefaults.sql''',
');',
'',
'sys.owa_util.http_header_close;',
'',
'wwv_flow_gen_hint.export(',
'    p_schema => :P479_SCHEMA,',
'    p_format => ''UNIX'' );',
'wwv_flow.g_page_text_generated := true;',
'wwv_flow.g_unrecoverable_error := true;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error exporting &P479_SCHEMA. UI Defaults - Table Dictionary. #SQLERRM#'
,p_process_when_button_id=>wwv_flow_imp.id(145379311883468515)
,p_process_success_message=>'&P479_SCHEMA. Table Dictionary exported.'
,p_internal_uid=>145708826793624227
);
end;
/
prompt --application/pages/page_00480
begin
wwv_flow_imp_page.create_page(
 p_id=>480
,p_name=>'PL/SQL Regions'
,p_alias=>'PL-SQL-REGIONS'
,p_step_title=>'PL/SQL Regions'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(11501804013545635)
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_region.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1250431356107871)
,p_plug_name=>'Search region text for all pages in this application'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>131
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select page_id, ',
'       plug_name, ',
'       ''<div class="code_text">''||',
'       wwv_flow_escape.html_trunc(plug_source,3000)||',
'       ''</div>'' Source,',
'       id,',
'       page_id the_page_id,',
'       nvl(sys.dbms_lob.getlength(plug_source),0) plsql_length',
'from wwv_flow_page_plugs',
'where flow_id = :fb_flow_id and',
'      security_group_id = :flow_security_group_id and',
'      plug_source_type = ''NATIVE_PLSQL'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(1250523444107871)
,p_name=>'Search region text for all pages in this application'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1250730540107875)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Page'
,p_column_link=>'f?p=&FLOW_ID.:4500:#FLOW_SESSION#::::FB_FLOW_PAGE_ID:#PAGE_ID#'
,p_column_linktext=>'#PAGE_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1250805053107876)
,p_db_column_name=>'PLUG_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Region'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE_ID##5110:#ID#'
,p_column_linktext=>'#PLUG_NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1251232464107876)
,p_db_column_name=>'PLSQL_LENGTH'
,p_display_order=>3
,p_column_identifier=>'F'
,p_column_label=>'Bytes'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1250911460107876)
,p_db_column_name=>'SOURCE'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>'Source'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1251015205107876)
,p_db_column_name=>'ID'
,p_display_order=>5
,p_column_identifier=>'D'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1251106549107876)
,p_db_column_name=>'THE_PAGE_ID'
,p_display_order=>6
,p_column_identifier=>'E'
,p_column_label=>'The Page Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(1251400380108483)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1295413478536645'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'PAGE_ID:PLUG_NAME:PLSQL_LENGTH:SOURCE:ID:THE_PAGE_ID'
,p_sort_column_1=>'PAGE_ID'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'PLSQL_LENGTH'
,p_sort_direction_2=>'DESC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193875010235576795)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>91
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(13987931263515071)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(193878604011650692)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1250431356107871)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:480:&SESSION.::&DEBUG.:480,RIR::'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(171687225658399434)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'480'
);
end;
/
prompt --application/pages/page_00481
begin
wwv_flow_imp_page.create_page(
 p_id=>481
,p_name=>'Create Breadcrumb Region - Breadcrumb'
,p_alias=>'CREATE-BREADCRUMB-REGION-BREADCRUMB'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Breadcrumb Region'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(91429205691059841)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_breadcrumb.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46327923834967291)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(114044830167684689)
,p_plug_name=>'Create Breadcrumb Region'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<p>Identify the breadcrumb, the named hierarchical list of pages, that you wish to have displayed on this page.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(114047319609719461)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(16141621180084222)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(114054228706778846)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(46327923834967291)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(114052028229769270)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46327923834967291)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(114053313123774329)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(46327923834967291)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(114052218081769273)
,p_branch_action=>'f?p=&FLOW_ID.:264:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(114052028229769270)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(574137461899781530)
,p_branch_action=>'f?p=&APP_ID.:263:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(114053313123774329)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114055323428796274)
,p_name=>'P481_REGION_TYPE'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(114044830167684689)
,p_prompt=>'Breadcrumb'
,p_post_element_text=>' '
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select upper(wwv_flow_lang.system_message(''MENU''))||'': ''||wwv_flow_escape.html(name) D, ''M''||id R',
'from wwv_flow_menus where flow_id = :fb_flow_id',
'order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the Breadcrumb to be associated with this region.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114056203520828316)
,p_name=>'P481_MENU_TEMPLATE'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(114044830167684689)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select default_menu_template from wwv_flow_themes where flow_id = :fb_flow_id and theme_id = :fb_theme_id and default_menu_template is not null) loop',
'   return c1.default_menu_template;',
'end loop;',
'return null;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Breadcrumb Template'
,p_post_element_text=>' '
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MENU.TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id',
'  from wwv_flow_menu_templates',
' where flow_id = :fb_flow_id and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by upper(name)'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Identify breadcrumb template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114058005860847960)
,p_name=>'P481_PAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(114044830167684689)
,p_prompt=>'Page:'
,p_source=>'FB_FLOW_PAGE_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'This attribute identifies the application page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114082001002120956)
,p_name=>'P481_REGION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(114044830167684689)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Region to be created:'
,p_source=>'P263_REGION_TITLE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Identifies the region that is used as the container for the breadcrumb.  The region identifies the position on the page to place the breadcrumb.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(574137294511781528)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(114054228706778846)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(574137329405781529)
,p_event_id=>wwv_flow_imp.id(574137294511781528)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00482
begin
wwv_flow_imp_page.create_page(
 p_id=>482
,p_name=>'Process Utilities'
,p_alias=>'PROCESS-UTILITIES'
,p_step_title=>'Process Utilities'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_proc.htm'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193855426155283320)
,p_plug_name=>'Utilities'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'   select wwv_flow_lang.system_message(''F4000.UTILITIES.INFO'') msg',
'     from dual )',
'loop',
'   sys.htp.p(''<p>''||c1.msg||''</p>'');',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193855629265283328)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(11322022496485821)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193856216099283331)
,p_plug_name=>'Process Utilities'
,p_icon_css_classes=>'icon-util-gear'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(655568879441187677)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_imp.id(171773504090694644)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
end;
/
prompt --application/pages/page_00484
begin
wwv_flow_imp_page.create_page(
 p_id=>484
,p_name=>'Page Attributes'
,p_alias=>'PAGE-ATTRIBUTES'
,p_step_title=>'Page Attributes'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213220627333807318)
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'page_util.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1182112906345794)
,p_plug_name=>'Pages'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>130
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       name,',
'       alias,',
'       step_title,',
'       html_page_header,',
'       html_page_onload,',
'       page_comment,',
'       (select group_name',
'          from wwv_flow_page_groups',
'         where id = p.group_id) group_id,',
'       sys.dbms_lob.substr(help_text,4000,1) help_text,',
'       (select name',
'          from wwv_flow_templates',
'         where id = step_template) step_template,',
'       nvl((select name',
'              from wwv_flow_security_schemes',
'             where to_char(id) = required_role),required_role) required_role,',
'       p.page_type,',
'       (select count(*) c',
'          from wwv_flow_page_plugs',
'         where flow_id = p.flow_id',
'           and page_id = p.id) regions,',
'       (select count(*) c',
'          from wwv_flow_step_items',
'         where flow_id      = p.flow_id',
'           and flow_step_id = p.id) items,',
'       (select count(*) c',
'          from wwv_flow_step_buttons',
'         where flow_id      = p.flow_id',
'           and flow_step_id = p.id) buttons,',
'       (select count(*) c',
'          from wwv_flow_step_branches',
'         where flow_id      = p.flow_id',
'           and flow_step_id = p.id) branches,',
'       (select count(*) c',
'          from wwv_flow_step_validations',
'         where flow_id      = p.flow_id',
'           and flow_step_id = p.id) validations,',
'       (select count(*) c',
'          from wwv_flow_step_processing',
'         where flow_id      = p.flow_id',
'           and flow_step_id = p.id) processes,',
'       (select count(*) c',
'          from wwv_flow_step_computations',
'         where flow_id      = p.flow_id',
'           and flow_step_id = p.id) computations,',
'       (select count(*) c',
'          from wwv_flow_page_da_events',
'         where flow_id = p.flow_id',
'           and page_id = p.id) dynamic_actions',
'  from wwv_flow_pages_dev p',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(1182204928345794)
,p_name=>'Pages'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1182411833345797)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Page'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#ID#'
,p_column_linktext=>'#ID#'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1182501764345798)
,p_db_column_name=>'NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Page Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1182628690345798)
,p_db_column_name=>'ALIAS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Alias'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1182700111345798)
,p_db_column_name=>'STEP_TITLE'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Page Title'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1182831664345798)
,p_db_column_name=>'HTML_PAGE_HEADER'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'HTML Page Header'
,p_allow_sorting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_column_type=>'CLOB'
,p_rpt_show_filter_lov=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1182932223345798)
,p_db_column_name=>'HTML_PAGE_ONLOAD'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'HTML Page Onload'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1183030516345799)
,p_db_column_name=>'PAGE_COMMENT'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Comment'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1183100400345799)
,p_db_column_name=>'GROUP_ID'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Group'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1183200376345799)
,p_db_column_name=>'HELP_TEXT'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Help Text'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1183303595345799)
,p_db_column_name=>'STEP_TEMPLATE'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Template'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1183411741345799)
,p_db_column_name=>'REQUIRED_ROLE'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Required Role'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1185228274412904)
,p_db_column_name=>'REGIONS'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Regions'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1185332038412904)
,p_db_column_name=>'ITEMS'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Items'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1185412039412904)
,p_db_column_name=>'BUTTONS'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Buttons'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1185526368412904)
,p_db_column_name=>'BRANCHES'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'Branches'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1185613532412904)
,p_db_column_name=>'VALIDATIONS'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Validations'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1185730413412905)
,p_db_column_name=>'PROCESSES'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Processes'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1185818455412905)
,p_db_column_name=>'COMPUTATIONS'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Computations'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1185900835412905)
,p_db_column_name=>'DYNAMIC_ACTIONS'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Dynamic Actions'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(13186323314901739)
,p_db_column_name=>'PAGE_TYPE'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Page Type'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(1183625971346001)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1295601007536645'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'ID:NAME:STEP_TITLE:GROUP_ID:REGIONS:ITEMS:BUTTONS:BRANCHES:VALIDATIONS:PROCESSES:COMPUTATIONS:DYNAMIC_ACTIONS'
,p_sort_column_1=>'ID'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(194058513854631467)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1182112906345794)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:484:&SESSION.::&DEBUG.:484,RIR::'
);
end;
/
prompt --application/pages/page_00485
begin
wwv_flow_imp_page.create_page(
 p_id=>485
,p_name=>'Copy Navigation Bar Entry'
,p_alias=>'COPY-NAVIGATION-BAR-ENTRY'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Navigation Bar Entry'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(91429205691059841)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_navbar.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47722221340586399)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(114688611078148636)
,p_plug_name=>'Copy Navigation Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(114688822983148638)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47722221340586399)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(114689023642148642)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(47722221340586399)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(114690823003148661)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114689226033148644)
,p_name=>'P485_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(114688611078148636)
,p_prompt=>'Copy Navigation Bar Entry'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ICON_SEQUENCE||''. ''||wwv_flow_escape.html(nvl(ICON_SUBTEXT,ICON_IMAGE_ALT)) d, id',
'from WWV_FLOW_ICON_BAR',
'where flow_id = :fb_flow_id',
'order by icon_sequence'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify list to copy'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114700709735292976)
,p_name=>'P485_NAVBAR_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(114688611078148636)
,p_prompt=>'Navigation Bar Entry Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify new component name.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(115337707715713752)
,p_name=>'P485_NAVBAR_SEQUENCE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(114688611078148636)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Sequence'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(max(ICON_SEQUENCE),0) + 10 ms',
'from WWV_FLOW_ICON_BAR',
'where flow_id = :fb_flow_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the display sequence of this component.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(114690224089148652)
,p_validation_name=>'P485_ID'
,p_validation_sequence=>20
,p_validation=>'P485_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(114689023642148642)
,p_associated_item=>wwv_flow_imp.id(114689226033148644)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(114702327181307477)
,p_validation_name=>'P485_NAVBAR_NAME'
,p_validation_sequence=>30
,p_validation=>'P485_NAVBAR_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(114689023642148642)
,p_associated_item=>wwv_flow_imp.id(114700709735292976)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(115338616026716123)
,p_validation_name=>'P485_NAVBAR_SEQUENCE'
,p_validation_sequence=>40
,p_validation=>'P485_NAVBAR_SEQUENCE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(114689023642148642)
,p_associated_item=>wwv_flow_imp.id(115337707715713752)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(115339625723718993)
,p_validation_name=>'P485_NAVBAR_SEQUENCE'
,p_validation_sequence=>50
,p_validation=>'P485_NAVBAR_SEQUENCE'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Value must be numeric'
,p_when_button_pressed=>wwv_flow_imp.id(114689023642148642)
,p_associated_item=>wwv_flow_imp.id(115337707715713752)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(590012554459897518)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(114688822983148638)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(590012600251897519)
,p_event_id=>wwv_flow_imp.id(590012554459897518)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(114690628673148657)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Navigation Bar'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select * from WWV_FLOW_ICON_BAR where id = :P485_ID) loop',
'insert into WWV_FLOW_ICON_BAR (',
'    ID,',
'    FLOW_ID,',
'    ICON_SEQUENCE,',
'    ICON_IMAGE,',
'    ICON_IMAGE2,',
'    ICON_IMAGE3,',
'    ICON_SUBTEXT,',
'    ICON_SUBTEXT2,',
'    ICON_SUBTEXT3,',
'    ICON_TARGET,',
'    ICON_IMAGE_ALT,',
'    ICON_HEIGHT,',
'    ICON_WIDTH,',
'    ICON_HEIGHT2,',
'    ICON_WIDTH2,',
'    ICON_HEIGHT3,',
'    ICON_WIDTH3,',
'    ICON_BAR_DISP_COND,',
'    ICON_BAR_DISP_COND_TYPE,',
'    ICON_BAR_FLOW_COND_INSTR,',
'    BEGINS_ON_NEW_LINE,',
'    CELL_COLSPAN,',
'    ONCLICK,',
'    REQUIRED_PATCH,',
'    SECURITY_SCHEME,',
'    REFERENCE_ID,',
'    SECURITY_GROUP_ID,',
'    LAST_UPDATED_BY,',
'    LAST_UPDATED_ON,',
'    ICON_BAR_COMMENT)',
'values (',
'    wwv_flow.GET_UNIQUE_ID,',
'    c1.FLOW_ID,',
'    :P485_NAVBAR_SEQUENCE,',
'    c1.ICON_IMAGE,',
'    c1.ICON_IMAGE2,',
'    c1.ICON_IMAGE3,',
'    c1.ICON_SUBTEXT,',
'    c1.ICON_SUBTEXT2,',
'    c1.ICON_SUBTEXT3,',
'    c1.ICON_TARGET,',
'    :P485_NAVBAR_NAME,',
'    c1.ICON_HEIGHT,',
'    c1.ICON_WIDTH,',
'    c1.ICON_HEIGHT2,',
'    c1.ICON_WIDTH2,',
'    c1.ICON_HEIGHT3,',
'    c1.ICON_WIDTH3,',
'    c1.ICON_BAR_DISP_COND,',
'    c1.ICON_BAR_DISP_COND_TYPE,',
'    c1.ICON_BAR_FLOW_COND_INSTR,',
'    c1.BEGINS_ON_NEW_LINE,',
'    c1.CELL_COLSPAN,',
'    c1.ONCLICK,',
'    c1.REQUIRED_PATCH,',
'    c1.SECURITY_SCHEME,',
'    c1.REFERENCE_ID,',
'    :flow_security_group_id,',
'    :app_user,',
'    sysdate,',
'    c1.ICON_BAR_COMMENT);',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to copy Navigation Bar Entry'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(114689023642148642)
,p_process_success_message=>'Navigation Bar Entry Copied'
,p_internal_uid=>114690628673148657
);
end;
/
prompt --application/pages/page_00491
begin
wwv_flow_imp_page.create_page(
 p_id=>491
,p_name=>'Theme Reports - Class References'
,p_alias=>'THEME-REPORTS-CLASS-REFERENCES'
,p_step_title=>'Theme Reports'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879423075323511)
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_themes.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(149650701426899427)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(58949101764235429)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Themes'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(157973526515079682)
,p_name=>'Class References'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'initcap(c001) Component,',
'c002 theme,',
'c003 template_class,',
'c004 component_name,',
'c005 class,',
'c006 page_id',
'from htmldb_collections',
'where collection_name = ''CLASS_REFERENCE'''))
,p_display_when_condition=>'P491_SHOW_CLASSES'
,p_display_when_cond2=>'CONTEXT'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>50
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1:2:3'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'Y'
,p_csv_output_link_text=>'Download'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
,p_comment=>'vgonchar: the region title is accessible and is used for: landmark, accessible header, accessible table name. This name matches the selected report name (visually shown in the report selector), and the other report with the same name.,'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(157974014101079802)
,p_query_column_id=>1
,p_column_alias=>'COMPONENT'
,p_column_display_sequence=>1
,p_column_heading=>'Component'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(157974101773079803)
,p_query_column_id=>2
,p_column_alias=>'THEME'
,p_column_display_sequence=>2
,p_column_heading=>'Theme'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(157974216222079803)
,p_query_column_id=>3
,p_column_alias=>'TEMPLATE_CLASS'
,p_column_display_sequence=>4
,p_column_heading=>'Template Class'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(157974317106079803)
,p_query_column_id=>4
,p_column_alias=>'COMPONENT_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Component Name'
,p_use_as_row_header=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(157974420132079803)
,p_query_column_id=>5
,p_column_alias=>'CLASS'
,p_column_display_sequence=>5
,p_column_heading=>'Referenced Class'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(157974518065079803)
,p_query_column_id=>6
,p_column_alias=>'PAGE_ID'
,p_column_display_sequence=>6
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(157992124614116931)
,p_plug_name=>'Report Selector'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(158155710172245274)
,p_plug_name=>'show extra information or just files'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>40
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(158369011351680870)
,p_name=>'Class References'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>90
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'c005 class',
'from htmldb_collections',
'where collection_name = ''CLASS_REFERENCE''',
'order by 1'))
,p_display_when_condition=>'P491_SHOW_CLASSES'
,p_display_when_cond2=>'NO_CONTEXT'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>50
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'Y'
,p_csv_output_link_text=>'Download'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'Y'
,p_comment=>'vgonchar: the region title is accessible and is used for: landmark, accessible header, accessible table name. This name matches the selected report name (visually shown in the report selector), and the other report with the same name.,'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(158369628271680889)
,p_query_column_id=>1
,p_column_alias=>'CLASS'
,p_column_display_sequence=>1
,p_column_heading=>'Referenced Class'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(158184125541259101)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(157992124614116931)
,p_button_name=>'P491_GO'
,p_button_static_id=>'P491_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Go'
,p_button_position=>'NEXT'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(205472416406763879)
,p_branch_action=>'f?p=&FLOW_ID.:173:&SESSION.::&DEBUG.::P173_SHOW:1'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P491_SHOW'
,p_branch_condition_text=>'1'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(205473223332765882)
,p_branch_action=>'f?p=&FLOW_ID.:173:&SESSION.::&DEBUG.::P173_SHOW:2'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P491_SHOW'
,p_branch_condition_text=>'2'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(205474031990768344)
,p_branch_action=>'f?p=&FLOW_ID.:492:&SESSION.::&DEBUG.:RP:P492_SHOW:TEMPLATE'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P491_SHOW'
,p_branch_condition_text=>'TEMPLATE'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(205477712728772261)
,p_branch_action=>'f?p=&FLOW_ID.:435:&SESSION.::&DEBUG.::P435_SHOW:FILE'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P491_SHOW'
,p_branch_condition_text=>'FILE'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(158184420206259104)
,p_branch_action=>'f?p=&FLOW_ID.:491:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1474899666476102)
,p_name=>'P491_SHOW_FILTERS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(157992124614116931)
,p_prompt=>'Show'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>'STATIC2:Templates;TEMPLATES,Shared Components;SHARED_COMPONENTS,Page Components;PAGE_COMPONENTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select the type of class references to include in this report. If you do not make a selection, no results are returned.',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(157993331887119003)
,p_name=>'P491_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(157992124614116931)
,p_prompt=>'Theme'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- All Themes -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select which themes to include in this report and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(158371428320685793)
,p_name=>'P491_SHOW_CLASSES'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(157992124614116931)
,p_prompt=>'Show Class Name'
,p_source=>'CONTEXT'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'FIND FILES REPORT OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(152121930169975580)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select the type of report to view.<p/> ',
'<strong>With context</strong> displays the component, theme ID, component name, the referenced class, and the relevant page number. Select the page number to link to a Page Definition.<p/> ',
'<strong>Without context</strong>displays only the referenced class.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(205443516266678650)
,p_name=>'P491_SHOW'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(157992124614116931)
,p_item_default=>'1'
,p_prompt=>'Report'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P173_SHOW'
,p_lov=>'.'||wwv_flow_imp.id(48989614083583743)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a report to view and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(157986317904105564)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_show_templates         varchar2(1) := ''N'';',
'  l_show_shared_components varchar2(1) := ''N'';',
'  l_show_page_components   varchar2(1) := ''N'';',
'begin',
'  if instr( :P491_SHOW_FILTERS, ''TEMPLATES'' ) > 0 then l_show_templates := ''Y''; end if;',
'  if instr( :P491_SHOW_FILTERS, ''SHARED_COMPONENTS'' ) > 0 then l_show_shared_components := ''Y''; end if;',
'  if instr( :P491_SHOW_FILTERS, ''PAGE_COMPONENTS'' ) > 0 then l_show_page_components := ''Y''; end if;',
'  --',
'  wwv_flow_theme_manager.find_css_classes(',
'    p_flow_id => :fb_flow_id, ',
'    p_theme => :P491_THEME,',
'    p_show_templates => l_show_templates,',
'    p_show_page_components => l_show_page_components,',
'    p_show_components=> l_show_shared_components',
'  );',
'  commit;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to create collection on query.'
,p_internal_uid=>157986317904105564
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(158186001777261730)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'rp'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>158186001777261730
);
end;
/
prompt --application/pages/page_00492
begin
wwv_flow_imp_page.create_page(
 p_id=>492
,p_name=>'Theme Reports - Template Substitution Strings'
,p_alias=>'THEME-REPORTS-TEMPLATE-SUBSTITUTION-STRINGS'
,p_step_title=>'Theme Reports'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879423075323511)
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_themes.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(149656125227915223)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(58949101764235429)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Themes'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(166929206907896383)
,p_plug_name=>'Region Selector'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(166937227817911808)
,p_name=>'Template Substitution Strings'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'initcap(c001) Component,',
'c002 theme,',
'c003 template_class,',
'''<a href="''||wwv_flow_escape.html(c008)||''">''||wwv_flow_escape.html(c004)||''</a>'' component_name,',
'c005 string,',
'c006 attribute,',
'decode(wwv_flow_escape.html(c007),''N'','''',''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'') referenced,',
'decode(wwv_flow_escape.html(c009),''N'','''',''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'') required',
'from htmldb_collections',
'where collection_name = ''TEMPLATE_SUB_STRINGS''',
'and (:P492_FIND is null or ',
'     instr(upper(c001),upper(:P492_FIND))>0 or',
'     instr(upper(c003),upper(:P492_FIND))>0 or',
'     instr(upper(c004),upper(:P492_FIND))>0 or',
'     instr(upper(c005),upper(:P492_FIND))>0 or',
'     instr(upper(c006),upper(:P492_FIND))>0)',
'order by 1,2,3,4,5,6'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>50
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1:2:3'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'Y'
,p_comment=>'vgonchar: number of rows set to 50 due to Chrome to be extremely slow when used with JAWS when more than 100 rows are shown. With 500 rows Chrome become not responding.'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166937826276911878)
,p_query_column_id=>1
,p_column_alias=>'COMPONENT'
,p_column_display_sequence=>1
,p_column_heading=>'Component'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166938112082911893)
,p_query_column_id=>2
,p_column_alias=>'THEME'
,p_column_display_sequence=>2
,p_column_heading=>'Theme'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166938202014911893)
,p_query_column_id=>3
,p_column_alias=>'TEMPLATE_CLASS'
,p_column_display_sequence=>4
,p_column_heading=>'Template Class'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166938319941911893)
,p_query_column_id=>4
,p_column_alias=>'COMPONENT_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Component Name'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166938418059911893)
,p_query_column_id=>5
,p_column_alias=>'STRING'
,p_column_display_sequence=>5
,p_column_heading=>'Attribute'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166938517302911893)
,p_query_column_id=>6
,p_column_alias=>'ATTRIBUTE'
,p_column_display_sequence=>6
,p_column_heading=>'Substitution String'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(166938605789911893)
,p_query_column_id=>7
,p_column_alias=>'REFERENCED'
,p_column_display_sequence=>7
,p_column_heading=>'Referenced'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(167062920563061193)
,p_query_column_id=>8
,p_column_alias=>'REQUIRED'
,p_column_display_sequence=>8
,p_column_heading=>'Typical'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(167042513712964584)
,p_button_sequence=>4
,p_button_plug_id=>wwv_flow_imp.id(166929206907896383)
,p_button_name=>'P492_GO'
,p_button_static_id=>'P492_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Go'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(205480804894779454)
,p_branch_action=>'f?p=&FLOW_ID.:173:&SESSION.::&DEBUG.::P173_SHOW:1'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P492_SHOW'
,p_branch_condition_text=>'1'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(205481710088780967)
,p_branch_action=>'f?p=&FLOW_ID.:173:&SESSION.::&DEBUG.::P173_SHOW:2'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P492_SHOW'
,p_branch_condition_text=>'2'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(205482817361783076)
,p_branch_action=>'f?p=&FLOW_ID.:435:&SESSION.::&DEBUG.::P435_SHOW:FILE'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P492_SHOW'
,p_branch_condition_text=>'FILE'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(205484803639788594)
,p_branch_action=>'f?p=&FLOW_ID.:491:&SESSION.::&DEBUG.::P491_SHOW:CLASS'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P492_SHOW'
,p_branch_condition_text=>'CLASS'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(167042810927964593)
,p_branch_action=>'f?p=&FLOW_ID.:492:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(124733503998773902)
,p_name=>'P492_FIND'
,p_item_sequence=>3.5
,p_item_plug_id=>wwv_flow_imp.id(166929206907896383)
,p_prompt=>'Search'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a case insensitive query for a theme name and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(166930311063897571)
,p_name=>'P492_THEME'
,p_item_sequence=>3
,p_item_plug_id=>wwv_flow_imp.id(166929206907896383)
,p_prompt=>'Theme'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- All Themes -'
,p_lov_null_value=>'0'
,p_cSize=>64
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select which themes to include in this report. This report can include all themes, or you can select a specific theme.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(205444322153680349)
,p_name=>'P492_SHOW'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_imp.id(166929206907896383)
,p_item_default=>'1'
,p_prompt=>'Report'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P173_SHOW'
,p_lov=>'.'||wwv_flow_imp.id(48989614083583743)||'.'
,p_cSize=>64
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the report you wish to view and click <span class="fielddatabold">Go</span>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(167108531195281881)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'492'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(167043921330966783)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'rp'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>167043921330966783
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(166927427901892913)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_theme_manager.find_substitution_strings (',
'    p_flow_id  => :fb_flow_id,',
'    p_theme    => :p492_theme);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to populate collection'
,p_internal_uid=>166927427901892913
);
end;
/
prompt --application/pages/page_00493
begin
wwv_flow_imp_page.create_page(
 p_id=>493
,p_name=>'Copy Authorization Scheme'
,p_alias=>'COPY-AUTHORIZATION-SCHEME'
,p_step_title=>'Copy Authorization Scheme'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213425326892450628)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_authorization.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(114707503591354917)
,p_plug_name=>'Copy Authorization Scheme'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(886492598737981501)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(886492604073981502)
,p_plug_name=>'Copy Authorization Scheme'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(114707704022354918)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(886492598737981501)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(114707902322354920)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(886492598737981501)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(114709701442354927)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114708107056354921)
,p_name=>'P493_ID'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(114707503591354917)
,p_prompt=>'Copy Authorization Scheme'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select NAME d, id r',
'from  WWV_FLOW_SECURITY_SCHEMES',
'where flow_id = :fb_flow_ID',
'order by name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'-- Select Existing Scheme --'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify authorization scheme to copy'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114708624956354923)
,p_name=>'P493_SECURITY_SCHEME'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(114707503591354917)
,p_prompt=>'New Authorization Scheme Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identify new authorization scheme name.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1606548723661658)
,p_validation_name=>'Name Unique'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from WWV_FLOW_SECURITY_SCHEMES',
'where security_group_id = :WORKSPACE_ID ',
'  and flow_id           = :FB_FLOW_ID ',
'  and name              = :P493_SECURITY_SCHEME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#LABEL# must be unique.'
,p_when_button_pressed=>wwv_flow_imp.id(114707902322354920)
,p_associated_item=>wwv_flow_imp.id(114708624956354923)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(114709530282354925)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Security Scheme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_util.copy_security_scheme (',
'      p_copy_from_flow_id  => :fb_flow_id,',
'      p_flow_id            => :fb_flow_id,',
'      p_from_scheme_id     => :P493_ID,',
'      p_to_scheme_name     => :P493_security_scheme );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to copy authorization scheme.'
,p_process_when_button_id=>wwv_flow_imp.id(114707902322354920)
,p_process_success_message=>'Authorization scheme copied.'
,p_internal_uid=>114709530282354925
);
end;
/
prompt --application/pages/page_00498
begin
wwv_flow_imp_page.create_page(
 p_id=>498
,p_name=>'Create Region Template - Identify Theme'
,p_alias=>'CREATE-REGION-TEMPLATE-IDENTIFY-THEME'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Region Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879423075323511)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_themes.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47961005137887467)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(150850830508499550)
,p_plug_name=>'Create Region Template'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<div class="htmldbInfoBodyP">A Theme is a named collection of Templates. An Application can have one or more Themes.</div>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(150869430555527912)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(320074633987)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(150852002588500985)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47961005137887467)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(150852710366500986)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(47961005137887467)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(150852305484500986)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(47961005137887467)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(150859305143511165)
,p_branch_action=>'f?p=&FLOW_ID.:158:&SESSION.::&DEBUG.:158::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(150852710366500986)
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(589947870189621423)
,p_branch_action=>'f?p=&APP_ID.:4320:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(150852305484500986)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(150867515664523657)
,p_name=>'P498_COPY_FROM_THEME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(150850830508499550)
,p_prompt=>'Theme'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(theme_name) d, theme_id',
'from   wwv_flow_themes',
'where  flow_id = :F4000_P4320_COPY_FROM_FLOW_ID',
'order by 1'))
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the theme from which you wish to copy templates.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(150867822066523659)
,p_name=>'P498_COPY_TO_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(150850830508499550)
,p_prompt=>'Theme'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the theme to which the template will be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(150937226502659256)
,p_name=>'P498_FROM_APP'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_imp.id(150850830508499550)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application:'
,p_source=>'F4000_P4320_COPY_FROM_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identifies the application from which the theme will be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(150939115205665491)
,p_name=>'P498_COPY_TO'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_imp.id(150850830508499550)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application:'
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identifies the application to which the template will be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(151522121971131010)
,p_name=>'P498_X'
,p_item_sequence=>11
,p_item_plug_id=>wwv_flow_imp.id(150850830508499550)
,p_post_element_text=>'<br />'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(151524714830138481)
,p_name=>'P498_F'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(150850830508499550)
,p_prompt=>'Copy From:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the theme to copy from.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(151526826258141761)
,p_name=>'P498_TO'
,p_item_sequence=>12
,p_item_plug_id=>wwv_flow_imp.id(150850830508499550)
,p_prompt=>'Copy To:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the theme to which the template will be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2461538595174568023)
,p_computation_sequence=>10
,p_computation_item=>'F4000_COPY_TO_THEME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P498_COPY_TO_THEME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(589947617364621421)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(150852002588500985)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(589947797844621422)
,p_event_id=>wwv_flow_imp.id(589947617364621421)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00499
begin
wwv_flow_imp_page.create_page(
 p_id=>499
,p_name=>'Copy Application - Identify Copy Target'
,p_alias=>'COPY-APPLICATION-IDENTIFY-COPY-TARGET'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Application'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213220627333807318)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_copy_app.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(23837626511624502)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(23817524863605164)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46513214819007151)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(115189910267008017)
,p_plug_name=>'Copy Application'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(115190309182008023)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46513214819007151)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(115190615887008023)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(46513214819007151)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(115190927483008025)
,p_branch_action=>'f?p=&APP_ID.:611:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(115190615887008023)
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(115190113318008022)
,p_name=>'P499_OLD_APP_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(115189910267008017)
,p_prompt=>'Application ID:'
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies application ID to copy.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(115210214127053223)
,p_name=>'P499_OLD_APP_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(115189910267008017)
,p_prompt=>'Application Name:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name from wwv_flows',
'where id = :FB_FLOW_ID',
'and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies application name to copy.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(115251924357169706)
,p_name=>'P499_NEW_APP_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(115189910267008017)
,p_prompt=>'New Application ID'
,p_source=>'wwv_flow_utilities.minimum_free_flow'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter a unique integer value to identify the application. Note that application IDs between 3000 to 9000 are reserved for internal use by &PRODUCT_NAME..'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(115253814792176447)
,p_name=>'P499_NEW_APP_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(115189910267008017)
,p_prompt=>'New Application Name'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name',
'from wwv_flows',
'where id = :FB_FLOW_ID',
'and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a short descriptive name for the application to distinguish the new application in select lists and reports.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(115519132330298097)
,p_name=>'P499_COPY_DEPLOYMENT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(115189910267008017)
,p_item_default=>'N'
,p_prompt=>'Copy Supporting Object Definitions'
,p_source=>'select include_in_export_yn from wwv_flow_install where flow_id = :fb_flow_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install_scripts   where security_group_id = :flow_security_group_id and flow_id = :fb_flow_id union all',
'select 1 from wwv_flow_install_objects   where security_group_id = :flow_security_group_id and flow_id = :fb_flow_id union all',
'select 1 from wwv_flow_install_checks    where security_group_id = :flow_security_group_id and flow_id = :fb_flow_id union all',
'select 1 from wwv_flow_install_build_opt where security_group_id = :flow_security_group_id and flow_id = :fb_flow_id'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'You can copy supporting object definitions, configuration options, and scripts with your application. ',
'<p />',
'Select <strong>On</strong> to include database object definitions, image definitions, and seed data SQL statements encapsulated in a single file.',
'Select <strong>Off</strong> to not include supporting object definitions.',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(115258412545213654)
,p_validation_name=>'P499_NEW_APP_ID'
,p_validation_sequence=>10
,p_validation=>'P499_NEW_APP_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'New Application ID must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(115190615887008023)
,p_associated_item=>wwv_flow_imp.id(115251924357169706)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(115261712330223049)
,p_validation_name=>'P499_NEW_APP_NAME'
,p_validation_sequence=>20
,p_validation=>'P499_NEW_APP_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'New application name must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(115190615887008023)
,p_associated_item=>wwv_flow_imp.id(115253814792176447)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(115268807397240517)
,p_validation_name=>'P499_NEW_APP_ID'
,p_validation_sequence=>30
,p_validation=>'P499_NEW_APP_ID'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'New Application ID must be numeric.'
,p_validation_condition=>'P499_NEW_APP_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(115190615887008023)
,p_associated_item=>wwv_flow_imp.id(115251924357169706)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(115274504543258677)
,p_validation_name=>'new ID not same as old ID'
,p_validation_sequence=>40
,p_validation=>'ltrim(:P499_NEW_APP_ID,''0'') != nvl(:P499_OLD_APP_ID,-1)'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Specified new application ID must be different from the current Application ID.'
,p_validation_condition=>'P499_NEW_APP_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(115190615887008023)
,p_associated_item=>wwv_flow_imp.id(115251924357169706)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(115280305366268386)
,p_validation_name=>'Min APP ID'
,p_validation_sequence=>50
,p_validation=>':P499_NEW_APP_ID > 99'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'The minimum application ID number is 100.  Enter an application ID 100 or greater.'
,p_validation_condition=>'wwv_flow_utilities.is_numeric(:P499_NEW_APP_ID )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(115190615887008023)
,p_associated_item=>wwv_flow_imp.id(115251924357169706)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(115284107575278406)
,p_validation_name=>'reserved app id check'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_utilities.is_available_application_id(',
'    p_security_group_id => :flow_security_group_id,',
'    p_application_id    => :P499_NEW_APP_ID,',
'    p_check_reserved    => FALSE ) = FALSE then',
'    --',
'    return FALSE;',
'else',
'    return TRUE;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Application ID reserved.'
,p_validation_condition=>':flow_security_group_id != 10 and wwv_flow_utilities.is_numeric(:P499_NEW_APP_ID)'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(115190615887008023)
,p_associated_item=>wwv_flow_imp.id(115251924357169706)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(115289825022292912)
,p_validation_name=>'cannot copy invalid range flow'
,p_validation_sequence=>70
,p_validation=>':P499_NEW_APP_ID not between 4000 and 4999'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'The application you are trying to copy is reserved.'
,p_validation_condition=>'(:flow_security_group_id != 10) and (:P499_NEW_APP_ID is not null) and (wwv_flow_utilities.is_numeric(:P499_NEW_APP_ID))'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(115190615887008023)
,p_associated_item=>wwv_flow_imp.id(115251924357169706)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(115557302819384156)
,p_validation_name=>'no deployment exists'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from wwv_flow_install_scripts ',
'where flow_id = :fb_flow_id',
'and security_group_id = :flow_security_group_id'))
,p_validation_type=>'EXISTS'
,p_error_message=>'You must define at least one installation script to copy supporting object definitions.'
,p_validation_condition=>'P499_COPY_DEPLOYMENT'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(115190615887008023)
,p_associated_item=>wwv_flow_imp.id(115519132330298097)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(115647826143674765)
,p_validation_name=>'application ID exists'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flows',
'where id = :P499_NEW_APP_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Specified new application ID exists already.'
,p_validation_condition=>'wwv_flow_utilities.is_numeric(:P499_NEW_APP_ID) and ltrim(:P499_NEW_APP_ID,''0'') != nvl(:P499_OLD_APP_ID,-1)'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(115190615887008023)
,p_associated_item=>wwv_flow_imp.id(115251924357169706)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1617425155739257713)
,p_validation_name=>'New'
,p_validation_sequence=>100
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_utilities.is_valid_application_name (',
'  p_name => :P499_NEW_APP_NAME);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'error'
,p_associated_item=>wwv_flow_imp.id(115253814792176447)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(590117327753572009)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(115190309182008023)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(590117415002572010)
,p_event_id=>wwv_flow_imp.id(590117327753572009)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00500
begin
wwv_flow_imp_page.create_page(
 p_id=>500
,p_name=>'Create Login Page'
,p_alias=>'LOGINWIZARD'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Login Page'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213425326892450628)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_authentication.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(16069709378853765)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(15960618523591402)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(32946732190131198)
,p_plug_name=>'Create Login Page'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44599217082308425)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(32962716081438797)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(44599217082308425)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(32964311364446961)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(44599217082308425)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(279436002130267974)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(44599217082308425)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:2500:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(32964602511446962)
,p_branch_action=>'f?p=&FLOW_ID.:4500:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(32964311364446961)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(32963019980438798)
,p_branch_action=>'f?p=&FLOW_ID.:4500:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(32962716081438797)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(32950631328168828)
,p_name=>'P500_PAGE_ID'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(32946732190131198)
,p_use_cache_before_default=>'NO'
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select max(id) id',
'             from wwv_flow_steps',
'            where flow_id = :FB_FLOW_ID',
'              and security_group_id = :FLOW_SECURITY_GROUP_ID)',
'loop',
'   return (c1.id + 10);',
'   exit;',
'end loop;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Page Number'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>10
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Indicate the page number to be used for this login page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(32952221679194427)
,p_name=>'P500_NAME'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(32946732190131198)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in ( select name',
'              from wwv_flows',
'             where security_group_id = :flow_security_group_id',
'               and id = :fb_flow_id )',
'loop',
'    return wwv_flow_lang_dev.app_text( ''PAGE.LOGIN.TITLE'', c1.name );',
'end loop;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Identifies the name of the login page to be created.. This name is used in numerous &PRODUCT_NAME. pages and reports.',
' ',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(32954210606266955)
,p_name=>'P500_USERNAME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(32946732190131198)
,p_item_default=>'wwv_flow_lang.system_message(''WWV_FLOW_FND_USER_API.T_USERNAME'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Label for "Username" Field'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Enter the value to be displayed next to the prompt for the username value to be captured by this login page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(32955432423273228)
,p_name=>'P500_PASSWORD'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(32946732190131198)
,p_item_default=>'wwv_flow_lang.system_message(''WWV_FLOW_FND_USER_API.T_PASSWORD'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Label for "Password" Field'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Enter the value to be displayed next to the prompt for the password value to be captured by this login page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(32959421529383580)
,p_name=>'P500_COOKIE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(32946732190131198)
,p_item_default=>'Y'
,p_prompt=>'Save Username in a Cookie'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'CHECKBOX_Y_NOPROMPT'
,p_lov=>'.'||wwv_flow_imp.id(84715102189754797)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(165510806451937527)
,p_computation_sequence=>20
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.get_current_theme_id (',
'    p_application_id    => :FB_FLOW_ID )'))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(33278107478590751)
,p_validation_name=>'P500_PAGE_ID positive, whole number'
,p_validation_sequence=>1
,p_validation=>'P500_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>'Page Number must be a positive, whole number.'
,p_when_button_pressed=>wwv_flow_imp.id(32964311364446961)
,p_associated_item=>wwv_flow_imp.id(32950631328168828)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 23-APR-2003 17:15'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(548798368975867027)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(32962716081438797)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(548798653389867030)
,p_event_id=>wwv_flow_imp.id(548798368975867027)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(33020905280956123)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Login Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.create_login_page (',
'    p_flow_id              => :FB_FLOW_ID,',
'    p_page_id              => :P500_PAGE_ID,',
'    p_name                 => :P500_NAME,',
'    p_username             => :P500_USERNAME,',
'    p_password             => :P500_PASSWORD,',
'    p_save_username_cookie => :P500_COOKIE = ''Y'' );',
'',
':FB_FLOW_PAGE_ID := :P500_PAGE_ID;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Login page created.'
,p_internal_uid=>33020905280956123
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(548799808981876085)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Login page created.'
,p_internal_uid=>548799808981876085
);
end;
/
prompt --application/pages/page_00501
begin
wwv_flow_imp_page.create_page(
 p_id=>501
,p_name=>'Validations by Page'
,p_alias=>'VALIDATIONS-BY-PAGE'
,p_step_title=>'Validations by Page'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213220627333807318)
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(13182325167857933)
,p_plug_name=>'Item Validations by Page'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>100
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       name,',
'       (select count(*)',
'          from wwv_flow_step_items',
'         where flow_id      = :FB_FLOW_ID',
'           and flow_step_id = p.id) total_items,',
'       vi.validatable_items,',
'       (select count(*)',
'          from wwv_flow_step_validations',
'         where associated_item in (',
'                   select id',
'                     from wwv_flow_step_items',
'                    where flow_id      = :FB_FLOW_ID',
'                      and flow_step_id = p.id)) existing_validations,',
'       p.page_type',
'  from wwv_flow_pages_dev p,',
'       (select flow_step_id,',
'               count(*) validatable_items',
'          from wwv_flow_step_items i',
'         where (',
'           i.display_as in (''NATIVE_CHECKBOX'', ''NATIVE_FILE'', ''NATIVE_POPUP_LOV'', ''TEXT'', ''TEXT_WITH_ENTER_SUBMIT'', ''NATIVE_SHUTTLE'', ''NATIVE_RICH_TEXT_EDITOR'', ''NATIVE_TEXTAREA'', ''NATIVE_DATE_PICKER'', ''NATIVE_DATE_PICKER_CLASSIC'', ''NATIVE_SELECT_LIS'
||'T'', ''NATIVE_RADIOGROUP'' ))',
'           and flow_id = :FB_FLOW_ID',
'         group by flow_step_id) vi',
' where vi.flow_step_id = p.id and',
'       p.flow_id       = :FB_FLOW_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(13182414714857933)
,p_name=>'Item Validations by Page'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(13182616873857945)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Page'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#ID#'
,p_column_linktext=>'#ID#'
,p_column_link_attr=>'View Page Defin'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(13182709953857945)
,p_db_column_name=>'NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Page Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(13182803266857945)
,p_db_column_name=>'TOTAL_ITEMS'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>'Total Items'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(13182921425857945)
,p_db_column_name=>'VALIDATABLE_ITEMS'
,p_display_order=>5
,p_column_identifier=>'D'
,p_column_label=>'Validatable Items'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(13183026265857946)
,p_db_column_name=>'EXISTING_VALIDATIONS'
,p_display_order=>6
,p_column_identifier=>'E'
,p_column_label=>'Existing Validations'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(13184802966876927)
,p_db_column_name=>'PAGE_TYPE'
,p_display_order=>7
,p_column_identifier=>'F'
,p_column_label=>'Page Type'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(13183303743858273)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1295723064536645'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'ID:NAME:PAGE_COMPONENT_MAP:TOTAL_ITEMS:VALIDATABLE_ITEMS:EXISTING_VALIDATIONS:PAGE_TYPE'
,p_sort_column_1=>'ID'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193776917574991650)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>95
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(186826132498329280)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(193779603160996967)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(13182325167857933)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:501:&SESSION.::&DEBUG.:501,RIR::'
);
end;
/
prompt --application/pages/page_00502
begin
wwv_flow_imp_page.create_page(
 p_id=>502
,p_name=>'Confirm Delete of Button Template'
,p_alias=>'CONFIRM-DELETE-OF-BUTTON-TEMPLATE'
,p_step_title=>'Confirm Delete of Button Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(161930829844889424)
,p_plug_name=>'Confirm Delete'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(161932106772892299)
,p_name=>'Template Utilization'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>41
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select flow_step_id||'': ''||button_name bname',
'from   wwv_flow_step_buttons',
'where  flow_id = :fb_flow_id ',
'  and  button_template_id = :p502_id',
'union all',
'select ''0: Default Button Template'' ',
'  from wwv_flow_themes ',
'where  flow_id = :fb_flow_id ',
'  and default_button_template = :p502_id',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(11667910335347890)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No references found.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(162350202223212638)
,p_query_column_id=>1
,p_column_alias=>'BNAME'
,p_column_display_sequence=>1
,p_column_heading=>'Button Name'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(692818596424250947)
,p_plug_name=>'Confirm Delete'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(692818606378250948)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>51
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(161933417854895464)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(692818606378250948)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(161934222356896768)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(692818606378250948)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Delete'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(162472526558276493)
,p_branch_action=>'f?p=&FLOW_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(161997222272915675)
,p_name=>'P502_TEMPLATE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(161930829844889424)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Template:'
,p_source=>'select template_name from wwv_flow_button_templates where id = :p502_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_help_text=>'Identify the template name.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(162000710975921830)
,p_name=>'P502_THEME_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(161930829844889424)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Theme:'
,p_source=>'select theme_id from wwv_flow_button_templates where id = :p502_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the theme.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(162003824481925725)
,p_name=>'P502_THEME_CLASS_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(161930829844889424)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Theme Class:'
,p_source=>'select theme_class_id from wwv_flow_button_templates where id = :p502_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'BUTTON THEME CLASS ID'
,p_lov=>'.'||wwv_flow_imp.id(43576623634636183)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the template theme class.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(162059106314034093)
,p_name=>'P502_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(161930829844889424)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(162368407118242495)
,p_validation_name=>'no references'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'for c1 in ( select count(*) counter from (',
'select button_name||'' - Page ''||flow_step_id bname',
'from   wwv_flow_step_buttons',
'where  flow_id = :fb_flow_id ',
'  and  button_template_id = :p502_id',
'union all',
'select ''Default Button Template - Theme ''||theme_id ',
'  from wwv_flow_themes ',
'where  flow_id = :fb_flow_id ',
'  and default_button_template = :p502_id) ',
' ) loop',
'if c1.counter = 0 then ',
' return true;',
'else ',
' return false;',
'end if;',
'end loop;',
'return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'You cannot delete a button template with references.'
,p_when_button_pressed=>wwv_flow_imp.id(161934222356896768)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(162478916777292542)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'delete from wwv_flow_button_templates ',
'where flow_id = :fb_flow_id ',
'and id = :p502_id;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Template not deleted.'
,p_process_when_button_id=>wwv_flow_imp.id(161934222356896768)
,p_process_success_message=>'Template deleted.'
,p_internal_uid=>162478916777292542
);
end;
/
prompt --application/pages/page_00503
begin
wwv_flow_imp_page.create_page(
 p_id=>503
,p_name=>'Confirm Delete of Breadcrumb Template'
,p_alias=>'CONFIRM-DELETE-OF-BREADCRUMB-TEMPLATE'
,p_step_title=>'Confirm Delete of Breadcrumb Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213261028690930718)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_breadcrumb.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(162628331650495577)
,p_plug_name=>'Confirm Delete'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(162629602345496587)
,p_name=>'Template Utilization'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select page_id||'': ''||plug_name l_name ',
'from wwv_flow_page_plugs ',
'where flow_id = :fb_flow_id ',
'and menu_template_id = :p503_id',
'and security_group_id = :flow_security_group_id',
'union all',
'select ''0: Default Menu Template'' l_name ',
'from wwv_flow_themes ',
'where flow_id = :fb_flow_id ',
'and default_menu_template = :p503_id',
'and security_group_id = :flow_security_group_id',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(11667910335347890)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No references found.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(164946119126805787)
,p_query_column_id=>1
,p_column_alias=>'L_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Templates'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(836646663748559249)
,p_plug_name=>'Confirm Delete'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(836646711593559250)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(164929404487744770)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(836646711593559250)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(164930209336746166)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(836646711593559250)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Delete'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(164955918957843580)
,p_branch_action=>'f?p=&FLOW_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(164931221456749676)
,p_name=>'P503_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(162628331650495577)
,p_prompt=>'Template:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'MENU.TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id',
'  from wwv_flow_menu_templates',
' where flow_id = :fb_flow_id and',
'    (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by upper(name)'))
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(164932330114752169)
,p_name=>'P503_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(162628331650495577)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Theme:'
,p_source=>'select theme_id from wwv_flow_menu_templates where id = :p503_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identify theme.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(164933003579753989)
,p_name=>'P503_THEME_CLASS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(162628331650495577)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Theme Class:'
,p_source=>'select theme_class_id from wwv_flow_menu_templates where id = :p503_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'MENU THEME CLASS ID'
,p_lov=>'.'||wwv_flow_imp.id(43945521366272493)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies template theme class.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(164934422626759485)
,p_computation_sequence=>10
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>'select theme_id from wwv_flow_menu_templates where id = :p503_id'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(164951401511829071)
,p_validation_name=>'no references'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'for c1 in ( select count(*) counter from ',
'(select plug_name||'' Page - ''||page_id l_name ',
'from wwv_flow_page_plugs ',
'where flow_id = :fb_flow_id ',
'and menu_template_id = :p503_id',
'union all',
'select ''Default Menu Template'' l_name ',
'from wwv_flow_themes ',
'where flow_id = :fb_flow_id ',
'and default_menu_template = :p503_id)',
') loop',
'if c1.counter = 0 then',
'  return true;',
'else ',
'  return false;',
'end if;',
'end loop;',
'return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Can not delete a template that is referenced.'
,p_when_button_pressed=>wwv_flow_imp.id(164930209336746166)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(164953903720839117)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'delete from wwv_flow_menu_templates where flow_id = :fb_flow_id and id = :p503_id;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Template could not be deleted.'
,p_process_when_button_id=>wwv_flow_imp.id(164930209336746166)
,p_process_success_message=>'Template Deleted'
,p_internal_uid=>164953903720839117
);
end;
/
prompt --application/pages/page_00504
begin
wwv_flow_imp_page.create_page(
 p_id=>504
,p_name=>'Confirm Delete of Calendar Template'
,p_alias=>'CONFIRM-DELETE-OF-CALENDAR-TEMPLATE'
,p_step_title=>'Confirm Delete of Calendar Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(162631207193497958)
,p_plug_name=>'Confirm Delete'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(162637610656498924)
,p_name=>'Template Utilization'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select p.page_id||'': ''||p.plug_name ',
'from  WWV_FLOW_CALS c, wwv_flow_page_plugs p ',
'where p.id = c.plug_id',
'and c.template_id = :p504_id ',
'and c.flow_id = :fb_flow_id ',
'union all',
'select ''0: Default Calendar Template'' ',
'from wwv_flow_themes',
'where flow_id = :fb_flow_id ',
'and default_calendar_template = :p504_id',
'and theme_id = :fb_theme_id',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(11667910335347890)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No references found.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(165119422598232532)
,p_query_column_id=>1
,p_column_alias=>'P.PAGE_ID||'':''||P.PLUG_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(836646418778559247)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(836646524483559248)
,p_plug_name=>'Confirm Delete'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(164959713894851518)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(836646418778559247)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(164960519434853199)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(836646418778559247)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Delete'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(164998709541011159)
,p_branch_action=>'f?p=&FLOW_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(164961324975854787)
,p_name=>'P504_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(162631207193497958)
,p_prompt=>'Template:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||name d, id',
'from wwv_flow_cal_templates',
'where flow_id = :fb_flow_id and',
'(:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(164962432248856872)
,p_name=>'P504_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(162631207193497958)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Theme:'
,p_source=>'select theme_id from wwv_flow_cal_templates where id = :p504_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identifies theme.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(164963305021858402)
,p_name=>'P504_THEME_CLASS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(162631207193497958)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Theme Class:'
,p_source=>'select theme_class_id from wwv_flow_cal_templates where id = :p504_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'CALENDAR THEME CLASS ID'
,p_lov=>'.'||wwv_flow_imp.id(43619531898960304)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identifies template theme class.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(164965306537868313)
,p_computation_sequence=>10
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>'select theme_id from wwv_flow_cal_templates where id = :p504_id'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(164997005254000463)
,p_validation_name=>'no references'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'for c1 in (select count(*) counter from ',
'(select p.plug_name||'' - Page ''||page_id ',
'from  WWV_FLOW_CALS c, wwv_flow_page_plugs p ',
'where p.id = c.plug_id',
'and c.template_id = :p504_id ',
'and c.flow_id = :fb_flow_id ',
'union all',
'select ''Default Calendar Template'' ',
'from wwv_flow_themes',
'where flow_id = :fb_flow_id ',
'and default_calendar_template = :p504_id',
'and theme_id = :fb_theme_id',
')) loop',
'if c1.counter = 0 then ',
'   return true;',
'else ',
'   return false;',
'end if;',
'end loop;',
'return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'You may not delete templates defined as default in the application''s theme.'
,p_when_button_pressed=>wwv_flow_imp.id(164960519434853199)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(164997901576008848)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'delete from wwv_flow_cal_templates where id = :p504_id and flow_id = :fb_flow_id;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Template could not be deleted.'
,p_process_when_button_id=>wwv_flow_imp.id(164960519434853199)
,p_process_success_message=>'Template deleted.'
,p_internal_uid=>164997901576008848
);
end;
/
prompt --application/pages/page_00505
begin
wwv_flow_imp_page.create_page(
 p_id=>505
,p_name=>'Confirm Delete of Report Template'
,p_alias=>'CONFIRM-DELETE-OF-REPORT-TEMPLATE'
,p_step_title=>'Confirm Delete of Report Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(165026012341131763)
,p_plug_name=>'Confirm Delete'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(165026418570131765)
,p_name=>'Template Utilization'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select page_id||'': ''||plug_name',
'from wwv_flow_page_plugs ',
'where flow_id = :fb_flow_id ',
'and PLUG_QUERY_ROW_TEMPLATE = :p505_id',
'union all',
'select ''0: Default Report Template'' l_name',
'from wwv_flow_themes ',
'where flow_id = :fb_flow_id ',
'and default_report_template = :p505_id',
'and theme_id = :fb_theme_id',
'order by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(11667910335347890)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No references found.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(165098512592182326)
,p_query_column_id=>1
,p_column_alias=>'PAGE_ID||'':''||PLUG_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1059809832816457635)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1059809932018457636)
,p_plug_name=>'Confirmation'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(165026922855131770)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1059809832816457635)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(165027313458131773)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1059809832816457635)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(165030127843131805)
,p_branch_action=>'f?p=&FLOW_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(165027727732131775)
,p_name=>'P505_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1059809932018457636)
,p_prompt=>'Template:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'REPORT.TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME1'')  d,  1 r from sys.dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME2'')  d,  2 r from sys.dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME21'') d, 21 r from sys.dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME22'') d, 22 r from sys.dual union',
'select wwv_flow_lang.system_message(''CONFIRM.TEMPLATE'')||'' ''||theme_id||''. ''||wwv_flow_escape.html(row_template_name) d, id r',
'  from wwv_flow_row_templates ',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID ',
'   and (:FB_THEME_ID is null or theme_id = :FB_THEME_ID)',
' order by 1'))
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(165028116605131784)
,p_name=>'P505_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1059809932018457636)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Theme:'
,p_source=>'select theme_id from wwv_flow_row_templates where id = :p505_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identifies theme.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(165028520420131786)
,p_name=>'P505_THEME_CLASS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1059809932018457636)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Theme Class:'
,p_source=>'select theme_class_id from wwv_flow_row_templates where id = :p505_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'REPORT THEME CLASS ID'
,p_lov=>'.'||wwv_flow_imp.id(44022800298370465)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identifies template theme class.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(165029005550131791)
,p_computation_sequence=>10
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>'select theme_id from wwv_flow_row_templates where id = :p505_id'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(165029419464131796)
,p_validation_name=>'no references'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'for c1 in (select count(*) counter from ',
'(select page_id||'': ''||plug_name',
'from wwv_flow_page_plugs ',
'where flow_id = :fb_flow_id ',
'and PLUG_QUERY_ROW_TEMPLATE = :p505_id',
'and plug_source_type in ( wwv_flow_region_native.c_sql_report,',
'                          wwv_flow_region_native.c_tabform )',
'union all',
'select ''0: Default Report Template'' l_name',
'from wwv_flow_themes ',
'where flow_id = :fb_flow_id ',
'and default_report_template = :p505_id',
'and theme_id = :fb_theme_id)',
') loop',
'if c1.counter = 0 then ',
'   return true;',
'else ',
'   return false;',
'end if;',
'end loop;',
'return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Can not delete template with references.'
,p_when_button_pressed=>wwv_flow_imp.id(165027313458131773)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(165029828372131802)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'delete from wwv_flow_row_templates where id = :p505_id and flow_id = :fb_flow_id;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Template could not be deleted.'
,p_process_when_button_id=>wwv_flow_imp.id(165027313458131773)
,p_process_success_message=>'Template deleted.'
,p_internal_uid=>165029828372131802
);
end;
/
prompt --application/pages/page_00506
begin
wwv_flow_imp_page.create_page(
 p_id=>506
,p_name=>'Edit Globalization Attributes'
,p_alias=>'EDIT-GLOBALIZATION-ATTRIBUTES'
,p_step_title=>'Edit Globalization Attributes'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213220627333807318)
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_attr_global.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(107024218396385528)
,p_name=>'Globalization'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>99
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'SELECT ',
'   TRANSLATION_FLOW_ID, ',
'   TRANSLATION_COMMENTS, ',
'   PRIMARY_LANGUAGE_FLOW_ID,',
'   TRANSLATION_FLOW_LANGUAGE_CODE',
'FROM ',
'   WWV_FLOW_LANGUAGE_MAP',
'WHERE ((PRIMARY_LANGUAGE_FLOW_ID = :fb_flow_id))',
'and security_group_id = :flow_security_group_id',
''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No translations found.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(107024427914385532)
,p_query_column_id=>1
,p_column_alias=>'TRANSLATION_FLOW_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Translated As'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(107024526429385532)
,p_query_column_id=>2
,p_column_alias=>'TRANSLATION_COMMENTS'
,p_column_display_sequence=>2
,p_column_heading=>'Comments'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(107024626570385532)
,p_query_column_id=>3
,p_column_alias=>'PRIMARY_LANGUAGE_FLOW_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Primary Application'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(107024709542385532)
,p_query_column_id=>4
,p_column_alias=>'TRANSLATION_FLOW_LANGUAGE_CODE'
,p_column_display_sequence=>4
,p_column_heading=>'Language'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(107025223059385535)
,p_plug_name=>'Application &FB_FLOW_ID.'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_landmark_label=>'Globalization Attribute Actions'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(107153203979618418)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>57
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Identify the globalization attributes of your application.  Application translations are available by following the links provided below.<p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(274910513057658610)
,p_plug_name=>'Application Attributes'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>0
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(274897624522614662)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_landmark_type=>'navigation'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(107028714086385553)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_imp.id(107025223059385535)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(107028525118385553)
,p_button_sequence=>3
,p_button_plug_id=>wwv_flow_imp.id(107025223059385535)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'FB_FLOW_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(107071506373385695)
,p_branch_action=>'1'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow.g_request in (''Create'',''Delete'')'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(480964602957324528)
,p_branch_action=>'f?p=&APP_ID.:4001:&SESSION.::&DEBUG.:4001:FB_FLOW_ID:&FB_FLOW_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_DEFN'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(480964808844326218)
,p_branch_action=>'f?p=&APP_ID.:509:&SESSION.::&DEBUG.:509:FB_FLOW_ID,509_FB_UPD_ID:&FB_FLOW_ID.,&FB_FLOW_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>41
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_SEC'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(42447012808555142)
,p_branch_action=>'f?p=&APP_ID.:197:&SESSION.::&DEBUG.:197:FB_FLOW_ID:&FB_FLOW_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>51
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_USERINTERFACE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(106148155181610601)
,p_branch_name=>'Go To Page 507'
,p_branch_action=>'f?p=&APP_ID.:507:&SESSION.::&DEBUG.:507:FB_FLOW_ID:&FB_FLOW_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>61
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_PWA'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1616411650727105)
,p_branch_name=>'Go To Page 523'
,p_branch_action=>'f?p=&APP_ID.:523:&SESSION.::&DEBUG.:523:FB_FLOW_ID:&FB_FLOW_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>71
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_AI'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(107071701891385695)
,p_branch_name=>'Go To Page 1'
,p_branch_action=>'1'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>81
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(480965629669360586)
,p_branch_action=>'f?p=&APP_ID.:506:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>5
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_GLOBAL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(107071900797385696)
,p_branch_action=>'1'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(107028714086385553)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48813130253484262)
,p_name=>'P506_TIMESTAMP_FORMAT'
,p_item_sequence=>459
,p_item_plug_id=>wwv_flow_imp.id(107024218396385528)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application Timestamp Format'
,p_source=>'TIMESTAMP_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FORMAT_MASK_DYNAMIC_DATES_TIMESTAMPS_NO_SINCE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''D''',
'union all',
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''T''',
''))
,p_cSize=>40
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Determines the timestamp format to be used in the application.</p>',
'<p>This timestamp format is used to alter the <code>NLS_TIMESTAMP_FORMAT</code> database session setting prior to showing or submitting any page in the application. This value can be a literal string containing a valid Oracle timestamp format mask or'
||' an item reference using substitution syntax. If no value is specified, the default timestamp format is derived from the database session at runtime.</p>',
'Examples:',
'<ul>',
'<li><code>DD-MON-RR HH.MI.SSXFF AM</code></li>',
'<li><code>&amp;MY_TIMESTAMP_FORMAT.</code></li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48813609952487826)
,p_name=>'P506_TIMESTAMP_TZ_FORMAT'
,p_item_sequence=>469
,p_item_plug_id=>wwv_flow_imp.id(107024218396385528)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application Timestamp Time Zone Format'
,p_source=>'TIMESTAMP_TZ_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FORMAT_MASK_DYNAMIC_DATES_TIMESTAMPS_TZR_NO_SINCE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''D''',
'union all',
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''T''',
'union all',
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''Z'''))
,p_cSize=>40
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Determines the timestamp with time zone format to be used in the application.</p>',
'<p>This date format is used to alter the <code>NLS_TIMESTAMP_TZ_FORMAT</code> database session setting prior to showing or submitting any page in the application. This value can be a literal string containing a valid Oracle timestamp with time zone f'
||'ormat mask or an item reference using substitution syntax. If no value is specified, the default timestamp with time zone format is derived from the database session at runtime.</p>',
'Examples:',
'<ul>',
'<li><code>DD-MON-RR HH.MI.SSXFF AM TZR</code></li>',
'<li><code>&amp;MY_TIMESTAMP_TZ_FORMAT.</code></li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(104793711550033169)
,p_name=>'P506_DATE_FORMAT'
,p_item_sequence=>439
,p_item_plug_id=>wwv_flow_imp.id(107024218396385528)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application Date Format'
,p_source=>'DATE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FORMAT_MASK_DYNAMIC_DATES_NO_SINCE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''D'''))
,p_cSize=>40
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Determines the date format to be used in the application.</p>',
'<p>This date format is used to alter the <code>NLS_DATE_FORMAT</code> database session setting prior to showing or submitting any page in the application. This value can be a literal string containing a valid Oracle date format mask or an item refere'
||'nce using substitution syntax. If no value is specified, the default date format is derived from the database session at runtime.</p>',
'Examples:',
'<ul>',
'<li><code>Month DD, YYYY</code></li>',
'<li><code>&amp;MY_DATE_FORMAT.</code></li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(107046804236385616)
,p_name=>'P506_CHARSET'
,p_item_sequence=>65
,p_item_plug_id=>wwv_flow_imp.id(107024218396385528)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Character Set'
,p_source=>'CHARSET'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Commented out by JKallman on 14-OCT-2003.  Not used for 10g production.  The character set of the document is determined by the NLS_LANG setting of the Database Authentication Descriptor, and modplsql automatically includes this in the HTTP headers.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(107047019283385622)
,p_name=>'506_FB_UPD_FLOW_LANGUAGE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(107024218396385528)
,p_use_cache_before_default=>'NO'
,p_item_default=>'en'
,p_prompt=>'Application Primary Language'
,p_source=>'FLOW_LANGUAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_LANGUAGES_LOCALES'
,p_lov=>'.'||wwv_flow_imp.id(107899321117195063)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Primary Language -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Identifies the language in which an application is developed. This language is the base language from which all translations are made. For example, suppose application 100 was authored in English and then translated into '
||'French and published as application 101. The application ID would be transparent to the end user, thus all users regardless of language would access application 100.</div>',
'<div class="htmldbInfoBodyP">All modifications to an application should be made to the primary language specified here.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(107055010603385644)
,p_name=>'P506_FLOW_LANGUAGE_DERIVED_FROM'
,p_item_sequence=>419
,p_item_plug_id=>wwv_flow_imp.id(107024218396385528)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Application Language Derived From'
,p_source=>'FLOW_LANGUAGE_DERIVED_FROM'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LANGUAGE_DERIVED_FROM'
,p_lov=>'.'||wwv_flow_imp.id(73566910745435962)||'.'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specifies how &PRODUCT_NAME. derives the translated application language.  The application primary language can be static, derived from the Web browser language, or determined from a user preference or item. Available options include:',
'<ul>',
'<li><strong>No NLS (Application not translated)</strong> - Select this option if the application will not be translated.</li>',
'<li><strong>Application Primary Language</strong> - Determines the translated application language based on the Application Primary Language attribute.</li>',
'<li><strong>Browser (use browser language preference)</strong> - Determines the translated application language based on the user''s Web browser language.</li>',
'<li><strong>Application Preference (use FSP_LANGUAGE_PREFERENCE)</strong> - Determines the translated application language based on a value defined using the <code>APEX_UTIL.SET_PREFERENCE</code> API.  This option can be used to maintain a user''s lan'
||'guage preference across multiple logins.</li>',
'<li><strong>Item Preference (use item containing preference)</strong> - Determines the translated application language based on an application-level item called <code>FSP_LANGUAGE_PREFERENCE</code>. Using this option requires &PRODUCT_NAME. to determ'
||'ine the appropriate language preference every time the user logs in. </li>',
'<li><strong>Session</strong> - Determines the translated application language from the session setting.  The &PRODUCT_NAME. session language can be set via either the <code>APEX_UTIL.SET_SESSION_LANG</code> procedure or via the <code>P_LANG</code> pa'
||'rameter of the <code>F</code> procedure in the URL.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(123305189457447101)
,p_name=>'P506_DIRECTION_RIGHT_TO_LEFT'
,p_is_required=>true
,p_item_sequence=>429
,p_item_plug_id=>wwv_flow_imp.id(107024218396385528)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Document Direction'
,p_source=>'DIRECTION_RIGHT_TO_LEFT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RIGHT-TO-LEFT'
,p_lov=>'.'||wwv_flow_imp.id(124580607576171078)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Set document direction left-to-right or right-to-left.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(173210517040328373)
,p_name=>'P506_AUTO_TIME_ZONE'
,p_item_sequence=>499
,p_item_plug_id=>wwv_flow_imp.id(107024218396385528)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Automatic Time Zone'
,p_source=>'AUTO_TIME_ZONE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Controls the setting of the database session time zone. When set to <strong>On</strong>, the client time zone is derived from the client''s Web browser and set for the duration of the &PRODUCT_NAME. session. Subsequent page views will have the databas'
||'e session time zone set properly per page view. Once set, this setting can be overridden using <code>APEX_UTIL.SET_SESSION_TIME_ZONE</code>, or reset using <code>APEX_UTIL.RESET_SESSION_TIME_ZONE</code>. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(205066501107542043)
,p_name=>'P506_CSV_ENCODING'
,p_item_sequence=>509
,p_item_plug_id=>wwv_flow_imp.id(107024218396385528)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Automatic CSV Encoding'
,p_source=>'CSV_ENCODING'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Automatic CSV Encoding controls the encoding of all CSV report output in an application.  If Automatic CSV Encoding is enabled, CSV report output will be properly converted to a character set compatible with localized desktop applications.  The chara'
||'cter set for CSV Encoding will be determined by the specific application language setting.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(317542517791217201)
,p_name=>'P506_NLS_SORT'
,p_item_sequence=>479
,p_item_plug_id=>wwv_flow_imp.id(107024218396385528)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Character Value Comparison'
,p_source=>'NLS_SORT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Determines the collating sequence for character value comparison in various SQL operations and clauses, for example, <code>ORDER BY</code>, <code>LIKE</code>, <code>MIN</code>/<code>MAX</code>.</p>',
'<p>This value is used to alter <code>NLS_SORT</code> database session parameter for the execution of SQL queries in classic report, interactive report, and List view regions, as well as in plug-in API. If no value is specified, the default value is d'
||'erived from the database session at runtime.</p>',
'Examples:',
'<ul>',
'<li><code>BINARY</code></li>',
'<li><code>GERMAN</code></li>',
'<li><code>CANADIAN_M</code></li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(317693209361509808)
,p_name=>'P506_NLS_COMP'
,p_item_sequence=>489
,p_item_plug_id=>wwv_flow_imp.id(107024218396385528)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Character Value Comparison Behavior'
,p_source=>'NLS_COMP'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'nvl(:P506_NLS_COMP, ''0'')'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'GLOBALIZATION.NLS_COMP'
,p_lov=>'.'||wwv_flow_imp.id(326783910743783589)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Determines the collation behavior of SQL operations, for example, <code>LIKE</code>, <code>MIN</code>/<code>MAX</code>.</p>',
'<p>This value is used to alter <code>NLS_COMP</code> database session parameter for the execution of SQL queries in classic report, interactive report, and List view regions, as well as in plug-in API.</p>',
'Available options include:',
'<ul>',
'<li><strong>Database session NLS setting (default)</strong> - The <code>NLS_COMP</code> value is derived from the database session at runtime.</li>',
'<li><strong>Binary</strong> - Comparisons in <code>WHERE</code> clause and other SQL operations are binary.</li>',
'<li><strong>Linguistic</strong> - Comparisons in <code>WHERE</code> clause and other SQL operations use the linguistic sort specified in the Character Value Comparison attribute (<code>NLS_SORT</code>).</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(592046819599383895)
,p_name=>'P506_DATE_TIME_FORMAT'
,p_item_sequence=>449
,p_item_plug_id=>wwv_flow_imp.id(107024218396385528)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application Date Time Format'
,p_source=>'DATE_TIME_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FORMAT_MASK_DYNAMIC_DATES_NO_SINCE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r ',
'  from wwv_flow_format_masks',
' where t = ''D'''))
,p_cSize=>40
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify the date time format to be used in the application.</p>',
'<p>This date time format can be referenced in an application using the substitution reference <code>&amp;APP_DATE_TIME_FORMAT.</code>, or in PL/SQL via the function <code>v(''APP_DATE_TIME_FORMAT'')</code>.  This attribute does not alter any NLS settin'
||'gs.  This value can be a literal string containing a valid Oracle date format mask or an item reference using substitution syntax.  If this attribute value is not specified, then a reference to <code>APP_DATE_TIME_FORMAT</code> will return the NLS da'
||'tabase session date format and the NLS time format.</p>',
'Examples:',
'<ul>',
'<li><code>Month DD, RRRR HH24:MI</code></li>',
'<li><code>&amp;MY_DATE_TIME_FORMAT.</code></li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(340090121776885382)
,p_computation_sequence=>10
,p_computation_item=>'P506_NLS_COMP'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'nullif(:P506_NLS_COMP, ''0'')'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(317553711210357001)
,p_validation_name=>'P506_NLS_SORT valid'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_found boolean := false;',
'begin',
'    for c1 in (',
'        select null',
'          from sys.v_$nls_valid_values',
'         where parameter = ''SORT''',
'           and value = regexp_replace(upper(:P506_NLS_SORT), ''_(CI|AI)$'', '''')',
'    ) loop',
'        l_found := true;',
'        exit;',
'    end loop;',
'',
'    return l_found;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Enter a valid NLS_SORT value.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P506_NLS_SORT is not null',
'and instr(:P506_NLS_SORT, ''&'') = 0'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(317542517791217201)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(107070300471385689)
,p_process_sequence=>1
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOWS'
,p_attribute_03=>'FB_FLOW_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error fetching  row.'
,p_internal_uid=>107070300471385689
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(107070513727385691)
,p_process_sequence=>1
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'security'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.init;',
'sys.owa_util.redirect_url(v(''LOGOUT_URL''));'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'    from   wwv_flow_developers',
'    where  userid = :FLOW_USER ',
'       and',
'       security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and',
'       security_group_id = ',
'         (select security_group_id from wwv_flows where id=:FB_FLOW_ID)',
'       and',
'       instr(developer_role,''EDIT'') > 0 ',
'       and',
'       (flow_id = :FB_FLOW_ID or flow_id is null)  '))
,p_process_when_type=>'NOT_EXISTS'
,p_internal_uid=>107070513727385691
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(107070924366385693)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOWS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOWS'
,p_attribute_03=>'FB_FLOW_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'U'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error processing row.'
,p_process_success_message=>'Application &FB_UPD_ID. processed.'
,p_internal_uid=>107070924366385693
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(107071110644385693)
,p_process_sequence=>31
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'security'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.init;',
'sys.owa_util.redirect_url(v(''LOGOUT_URL''));',
'wwv_flow.g_unrecoverable_error := true;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'    from   wwv_flow_developers',
'    where  userid = :FLOW_USER ',
'       and',
'       security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and',
'       security_group_id = ',
'         (select security_group_id from wwv_flows where id=:FB_FLOW_ID)',
'       and',
'       instr(developer_role,''EDIT'') > 0 ',
'       and',
'       (flow_id = :FB_FLOW_ID or flow_id is null)  '))
,p_process_when_type=>'NOT_EXISTS'
,p_internal_uid=>107071110644385693
);
end;
/
prompt --application/pages/page_00507
begin
wwv_flow_imp_page.create_page(
 p_id=>507
,p_name=>'Edit Progressive Web App'
,p_alias=>'EDIT-PROGRESSIVE-WEB-APP'
,p_step_title=>'Edit Progressive Web App'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213220627333807318)
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#PRISMJS_DIRECTORY#prism.js',
'#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#f4000_p507#MIN#.js'))
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (typeof monaco === "object") {',
'    monaco.languages.typescript.javascriptDefaults.setDiagnosticsOptions({',
'        diagnosticCodesToIgnore: [6385]',
'    });',
'}'))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-ServiceWorker .a-Region {',
'    border-bottom: 0;',
'}',
'',
'.a-ServiceWorker .a-Region-title .a-Button {',
'    margin-top: 0;',
'    margin-bottom: 0;',
'    padding-top: 0;',
'    padding-bottom: 0;',
'}',
'',
'.a-PWAScreenshot-preview {',
'    max-width: 96px;',
'}',
'',
'.a-PWAShortcut-preview {',
'    max-width: 48px;',
'}',
'',
'.a-Region--simple {',
'    border-bottom: 0;',
'}',
'',
'.a-Form-inputContainer select[size="1"].selectlist,',
'.a-Form-inputContainer span.display_only {',
'    min-width: 200px;',
'}',
'',
'.a-Button--small {',
'    height: 24px;',
'}'))
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'No help is available for this page.'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1447696670584402)
,p_plug_name=>'Help - Event install'
,p_region_template_options=>'#DEFAULT#:js-dialog-size480x320'
,p_plug_template=>wwv_flow_imp.id(557449278618308550)
,p_plug_display_sequence=>130
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The install event of the service worker interface is fired as soon as the worker executes, and it''s only called once per service worker.</p>',
'<p>It can be used to populate a cache with a number of resources, which the service worker can then use to serve assets.</p>',
'<p>More info:</p>',
'<ul>',
'    <li><a rel="noopener noreferrer" href="https://developer.mozilla.org/en-US/docs/Web/API/ServiceWorkerGlobalScope/install_event">https://developer.mozilla.org/en-US/docs/Web/API/ServiceWorkerGlobalScope/install_event</a></li>',
'    <li><a rel="noopener noreferrer" href="https://developers.google.com/web/fundamentals/primers/service-workers/lifecycle#install">https://developers.google.com/web/fundamentals/primers/service-workers/lifecycle#install</a></li>',
'</ul>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1448731379584413)
,p_plug_name=>'Help - Event activate'
,p_region_template_options=>'#DEFAULT#:js-dialog-size480x320'
,p_plug_template=>wwv_flow_imp.id(557449278618308550)
,p_plug_display_sequence=>140
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The activate event of the service worker interface is fired when your service worker is ready to control clients and handle functional events like push and sync.</p>',
'<p>It can be used to update or clean existing caches.</p>',
'<p>More info:</p>',
'<ul>',
'    <li><a rel="noopener noreferrer" href="https://developer.mozilla.org/en-US/docs/Web/API/ServiceWorkerGlobalScope/activate_event">https://developer.mozilla.org/en-US/docs/Web/API/ServiceWorkerGlobalScope/activate_event</a></li>',
'    <li><a rel="noopener noreferrer" href="https://developers.google.com/web/fundamentals/primers/service-workers/lifecycle#activate">https://developers.google.com/web/fundamentals/primers/service-workers/lifecycle#activate</a></li>',
'</ul>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1448825540584414)
,p_plug_name=>'Help - Event push'
,p_region_template_options=>'#DEFAULT#:js-dialog-size480x320'
,p_plug_template=>wwv_flow_imp.id(557449278618308550)
,p_plug_display_sequence=>170
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The push event of the service worker interface is fired when a push message has been received. It contains the information sent from an application server to a push subcriber.</p>',
'<p>It can be used to display a notification on a device controlled by the service worker.</p>',
'<p>More info:</p>',
'<ul>',
'    <li><a rel="noopener noreferrer" href="https://developers.google.com/web/ilt/pwa/introduction-to-push-notifications">https://developers.google.com/web/ilt/pwa/introduction-to-push-notifications</a></li>',
'    <li><a rel="noopener noreferrer" href="https://developer.mozilla.org/en-US/docs/Web/API/PushEvent">https://developer.mozilla.org/en-US/docs/Web/API/PushEvent</a></li>',
'</ul>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1448945715584415)
,p_plug_name=>'Help - Event notificationclick'
,p_region_template_options=>'#DEFAULT#:js-dialog-size480x320'
,p_plug_template=>wwv_flow_imp.id(557449278618308550)
,p_plug_display_sequence=>190
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The notificationclick event of the service worker interface is fired when client clicks on a notification sent by the service worker.</p>',
'<p>It can be used to trigger actions or open pages when clicking a notification.</p>',
'<p>More info:</p>',
'<ul>',
'    <li><a rel="noopener noreferrer" href="https://developers.google.com/web/ilt/pwa/introduction-to-push-notifications#the_notificationclick_event">https://developers.google.com/web/ilt/pwa/introduction-to-push-notifications#the_notificationclick_ev'
||'ent</a></li>',
'    <li><a rel="noopener noreferrer" href="https://developer.mozilla.org/en-US/docs/Web/API/ServiceWorkerGlobalScope/notificationclick_event">https://developer.mozilla.org/en-US/docs/Web/API/ServiceWorkerGlobalScope/notificationclick_event</a></li>',
'</ul>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1449046848584416)
,p_plug_name=>'Help - Event fetch'
,p_region_template_options=>'#DEFAULT#:js-dialog-size480x320'
,p_plug_template=>wwv_flow_imp.id(557449278618308550)
,p_plug_display_sequence=>150
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The fetch event of the service worker interface is fired when a request is made from the client.</p>',
'<p>It can be used to determine what to do with the request before sending the request to a server. For example, the service worker can look for resources in the cache and serve those resources instead. Implementations of the fetch event can lead to f'
||'aster page loads and offline capabilities.</p>',
'<p>More info:</p>',
'<ul>',
'    <li><a rel="noopener noreferrer" href="https://developer.mozilla.org/en-US/docs/Web/API/Service_Worker_API/Using_Service_Workers">https://developer.mozilla.org/en-US/docs/Web/API/Service_Worker_API/Using_Service_Workers</a></li>',
'</ul>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1449136594584417)
,p_plug_name=>'Help - Event sync'
,p_region_template_options=>'#DEFAULT#:js-dialog-size480x320'
,p_plug_template=>wwv_flow_imp.id(557449278618308550)
,p_plug_display_sequence=>160
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The sync event of the service worker interface is fired when network connectivity comes available after being unavailable.</p>',
'<p>It can be used to send requests to the server that were unable to proceed when the client was offline.</p>',
'<p>More info:</p>',
'<ul>',
'    <li><a rel="noopener noreferrer" href="https://developer.mozilla.org/en-US/docs/Web/API/ServiceWorkerGlobalScope/sync_event">https://developer.mozilla.org/en-US/docs/Web/API/ServiceWorkerGlobalScope/sync_event</a></li>',
'    <li><a rel="noopener noreferrer" href="https://developers.google.com/web/updates/2015/12/background-sync">https://developers.google.com/web/updates/2015/12/background-sync</a></li>',
'</ul>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1449244061584418)
,p_plug_name=>'Help - Event canmakepayment'
,p_region_template_options=>'#DEFAULT#:js-dialog-size480x320'
,p_plug_template=>wwv_flow_imp.id(557449278618308550)
,p_plug_display_sequence=>210
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The canmakepayment event of the service worker interface is fired when the client requests the authorization status of the Payment Handler API.</p>',
'<p>It can be used to check if the browser supports at least one payment method.</p>',
'<p>More info:</p>',
'<ul>',
'    <li><a rel="noopener noreferrer" href="https://developer.mozilla.org/en-US/docs/Web/API/Payment_Request_API/Using_the_Payment_Request_API">https://developer.mozilla.org/en-US/docs/Web/API/Payment_Request_API/Using_the_Payment_Request_API</a></li>',
'    <li><a rel="noopener noreferrer" href="https://web.dev/web-payments-updates">https://web.dev/web-payments-updates</a>/</li>',
'    <li><a rel="noopener noreferrer" href="https://www.w3.org/TR/payment-handler/#handling-a-canmakepaymentevent">https://www.w3.org/TR/payment-handler/#handling-a-canmakepaymentevent</a></li>',
'</ul>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1449367005584419)
,p_plug_name=>'Help - Event notificationclose'
,p_region_template_options=>'#DEFAULT#:js-dialog-size480x320'
,p_plug_template=>wwv_flow_imp.id(557449278618308550)
,p_plug_display_sequence=>200
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The notificationclose event of the service worker interface is fired when a user dismisses a notification, such as a swipe on a mobile device.</p>',
'<p>It can be used to log the event to your analytics database, or log the event to avoid re-notifying the user of the same event.</p>',
'<p>More info:</p>',
'<ul>',
'    <li><a rel="noopener noreferrer" href="https://developers.google.com/web/ilt/pwa/introduction-to-push-notifications#the_notificationclose_event">https://developers.google.com/web/ilt/pwa/introduction-to-push-notifications#the_notificationclose_ev'
||'ent</a></li>',
'</ul>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1449497849584420)
,p_plug_name=>'Help - Event paymentrequest'
,p_region_template_options=>'#DEFAULT#:js-dialog-size480x320'
,p_plug_template=>wwv_flow_imp.id(557449278618308550)
,p_plug_display_sequence=>220
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The paymentrequest event of the service worker interface is fired when client chooses to pay with a web-based payment app.</p>',
'<p>It can be used to initiate a payment on a web app, using payment methods such as Google Pay.</p>',
'<p>More info:</p>',
'<ul>',
'    <li><a rel="noopener noreferrer" href="https://web.dev/how-payment-request-api-works/">https://web.dev/how-payment-request-api-works/</a></li>',
'    <li><a rel="noopener noreferrer" href="https://web.dev/orchestrating-payment-transactions/">https://web.dev/orchestrating-payment-transactions/</a></li>',
'</ul>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2100662725830897)
,p_plug_name=>'Application &FB_FLOW_ID.'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>140
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_landmark_label=>'Progressive Web App Actions'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2201664938388908)
,p_plug_name=>'Help - Screenshots'
,p_region_template_options=>'#DEFAULT#:js-dialog-size480x320'
,p_plug_template=>wwv_flow_imp.id(557449278618308550)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The &PRODUCT_NAME. Progressive Web App screenshots are used for promotional purposes when users are prompted to install the Progressive Web App.</p>',
'<p>For best results, all screenshots must have the same aspect ratio.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5401497597685413)
,p_plug_name=>'Help - Shortcuts'
,p_region_template_options=>'#DEFAULT#:js-dialog-size480x320'
,p_plug_template=>wwv_flow_imp.id(557449278618308550)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The &PRODUCT_NAME. Progressive Web App shortcuts are used for installed PWAs to allow users to get to a specific page of the application quickly.</p>',
'<p>For touch-enabled devices, shortcuts are accessible when doing a long-press on the application icon on the home screen.</p>',
'<p>For other devices, shortcuts are accessible when doing a right click on the application icon on the task bar.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(10409147636693205)
,p_plug_name=>'PWA Form'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOWS'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'u'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
,p_ajax_items_to_submit=>'FB_FLOW_ID'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(23104254952504538)
,p_plug_name=>'Friendly URL must be activated'
,p_region_template_options=>'#DEFAULT#:a-Alert--info:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>51
,p_plug_source=>'An Oracle APEX application can only use Progressive Web App features if it has enabled Friendly URLs.'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P507_FRIENDLY_URL'
,p_plug_display_when_cond2=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(48350770465556316)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>145
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(79232375469259813)
,p_plug_name=>'Landmark for Displayed Regions'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>61
,p_translate_title=>'N'
,p_landmark_type=>'region'
,p_landmark_label=>'Displayed Regions'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1801173018350501)
,p_plug_name=>'Push Notifications'
,p_parent_plug_id=>wwv_flow_imp.id(79232375469259813)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>91
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P507_FRIENDLY_URL'
,p_plug_display_when_cond2=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5501359206896821)
,p_plug_name=>'General'
,p_parent_plug_id=>wwv_flow_imp.id(79232375469259813)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>71
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P507_FRIENDLY_URL'
,p_plug_display_when_cond2=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(23101891067504514)
,p_plug_name=>'Installability'
,p_parent_plug_id=>wwv_flow_imp.id(79232375469259813)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>81
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P507_FRIENDLY_URL'
,p_plug_display_when_cond2=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2200905572388901)
,p_plug_name=>'Screenshots'
,p_parent_plug_id=>wwv_flow_imp.id(23101891067504514)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--simple'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>120
,p_plug_item_display_point=>'BELOW'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P507_PWA_IS_INSTALLABLE'
,p_plug_display_when_cond2=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2201761754388909)
,p_plug_name=>'No Screenshots'
,p_parent_plug_id=>wwv_flow_imp.id(2200905572388901)
,p_region_template_options=>'#DEFAULT#:a-Alert--info:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_source=>'<p>Upload a new screenshot.</p>'
,p_plug_display_condition_type=>'NOT_EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_pwa_screenshots',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(2202389608388915)
,p_name=>'Screenshots Report'
,p_region_name=>'ScreenshotsReport'
,p_parent_plug_id=>wwv_flow_imp.id(2200905572388901)
,p_template=>wwv_flow_imp.id(208928010704475743)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--horizontalBorders:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ps.id,',
'       ps.label,',
'       wwv_flow_file_editor_dev.get_file_reference (',
'                               p_scope     => ''APP'',',
'                               p_app_id    => :FB_FLOW_ID,',
'                               p_file_name => ps.screenshot_url ) screenshot_url,',
'       ps.display_sequence as display_sequence_screenshot,',
'       ( select ''<img class="a-PWAScreenshot-preview" aria-hidden="true" src="''||wwv_flow_escape.html_attribute(''wwv_flow_file_mgr.get_file?p_security_group_id=''||:WORKSPACE_ID||''&p_flow_id=''||:FB_FLOW_ID||''&p_fname=''||a.file_name||''&v=''||wwv_flows_r'
||'elease||f.shared_components_scn)||''" alt="''||wwv_flow_escape.html_attribute(ps.label)||''"/><br/><span class="a-PWAScreenshot-preview--ratio a-Alert--warning"></span>''',
'            from wwv_flow_static_files a',
'           where a.security_group_id = :WORKSPACE_ID',
'             and a.flow_id           = :FB_FLOW_ID',
'             and a.file_name         = ps.screenshot_url ) preview',
'  from wwv_flow_pwa_screenshots ps,',
'       wwv_flows f',
' where ps.flow_id           = :FB_FLOW_ID',
'   and ps.security_group_id = :WORKSPACE_ID',
'   and f.id                = ps.flow_id',
'   and f.security_group_id = ps.security_group_id',
' order by ps.display_sequence'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_pwa_screenshots',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(8205336641126638)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>10
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2202450873388916)
,p_query_column_id=>2
,p_column_alias=>'LABEL'
,p_column_display_sequence=>30
,p_column_heading=>'Description'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2202586516388917)
,p_query_column_id=>3
,p_column_alias=>'SCREENSHOT_URL'
,p_column_display_sequence=>50
,p_column_heading=>'Reference'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(17955496888165807)
,p_query_column_id=>4
,p_column_alias=>'DISPLAY_SEQUENCE_SCREENSHOT'
,p_column_display_sequence=>60
,p_column_heading=>'Display Sequence'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5400257947685401)
,p_query_column_id=>5
,p_column_alias=>'PREVIEW'
,p_column_display_sequence=>20
,p_column_heading=>'Screenshot'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5400378068685402)
,p_query_column_id=>5
,p_column_alias=>'DERIVED$01'
,p_column_display_sequence=>70
,p_column_heading=>'Actions'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:519:&SESSION.::&DEBUG.:519:P519_ID:#ID#'
,p_column_linktext=>'Edit'
,p_column_link_attr=>'class="a-Button a-Button--small" aria-label="Edit #LABEL#" title="Edit #LABEL#"'
,p_column_alignment=>'CENTER'
,p_derived_column=>'Y'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4403849360525913)
,p_plug_name=>'Screenshots Ratio'
,p_region_name=>'ScreenshotsRatio'
,p_parent_plug_id=>wwv_flow_imp.id(2200905572388901)
,p_region_css_classes=>'a-Alert--inline'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--warning:a-Alert--horizontal'
,p_region_attributes=>'style="display:none;"'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_source=>'<p>The screenshots below have different aspect ratios. Upload screenshots with the same aspect ratio for the best results.</p>'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_pwa_screenshots',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5400543544685404)
,p_plug_name=>'Shortcuts'
,p_parent_plug_id=>wwv_flow_imp.id(23101891067504514)
,p_region_css_classes=>'a-Report--stretch'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--simple'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>130
,p_plug_item_display_point=>'BELOW'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P507_PWA_IS_INSTALLABLE'
,p_plug_display_when_cond2=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3047844791097925)
,p_plug_name=>'Rejoin Sessions must be activated'
,p_parent_plug_id=>wwv_flow_imp.id(5400543544685404)
,p_region_template_options=>'#DEFAULT#:a-Alert--info:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>20
,p_plug_source=>'An Oracle APEX application can only use Progressive Web App Shortcuts if it has enabled Rejoin Sessions.'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P507_REJOIN_EXISTING_SESSIONS'
,p_plug_display_when_cond2=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3048258148097929)
,p_plug_name=>'Shortcuts Report'
,p_parent_plug_id=>wwv_flow_imp.id(5400543544685404)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>40
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P507_REJOIN_EXISTING_SESSIONS'
,p_plug_display_when_cond2=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5401546530685414)
,p_plug_name=>'No Shortcuts'
,p_parent_plug_id=>wwv_flow_imp.id(3048258148097929)
,p_region_css_classes=>'a-Alert--inline'
,p_region_template_options=>'#DEFAULT#:a-Alert--info:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>21
,p_plug_new_grid_row=>false
,p_plug_source=>'<p>Upload a new shortcut.</p>'
,p_plug_display_condition_type=>'NOT_EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_pwa_shortcuts',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(5401963275685418)
,p_name=>'Shortcuts Report'
,p_region_name=>'ShortcutsReport'
,p_parent_plug_id=>wwv_flow_imp.id(3048258148097929)
,p_template=>wwv_flow_imp.id(208928010704475743)
,p_display_sequence=>31
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--horizontalBorders:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ps.id,',
'       ps.name,',
'       ps.target_url,',
'       ps.display_sequence as display_sequence_shortcut,',
'       ( select ''<img class="a-PWAShortcut-preview" aria-hidden="true" src="''||wwv_flow_escape.html_attribute(''wwv_flow_file_mgr.get_file?p_security_group_id=&WORKSPACE_ID.&p_flow_id=&FB_FLOW_ID.&p_fname=''||a.file_name||''&v=''||wwv_flows_release||f.sh'
||'ared_components_scn)||''" alt="''||wwv_flow_escape.html_attribute(ps.name)||''" />''',
'            from wwv_flow_static_files a',
'           where a.security_group_id = :WORKSPACE_ID',
'             and a.flow_id           = :FB_FLOW_ID',
'             and a.file_name         = ps.icon_url ) icon',
'  from wwv_flow_pwa_shortcuts ps,',
'       wwv_flows f',
' where ps.flow_id           = :FB_FLOW_ID',
'   and ps.security_group_id = :WORKSPACE_ID',
'   and f.id                 = ps.flow_id',
'   and f.security_group_id  = ps.security_group_id',
' order by ps.display_sequence'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_pwa_shortcuts',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5402032303685419)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>10
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5402121704685420)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>30
,p_column_heading=>'Name'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(11364098853866142)
,p_query_column_id=>3
,p_column_alias=>'TARGET_URL'
,p_column_display_sequence=>40
,p_column_heading=>'Target URL'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(17955360547165806)
,p_query_column_id=>4
,p_column_alias=>'DISPLAY_SEQUENCE_SHORTCUT'
,p_column_display_sequence=>50
,p_column_heading=>'Display Sequence'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(11364156132866143)
,p_query_column_id=>5
,p_column_alias=>'ICON'
,p_column_display_sequence=>20
,p_column_heading=>'Icon'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(17955250711165805)
,p_query_column_id=>7
,p_column_alias=>'DERIVED$02'
,p_column_display_sequence=>60
,p_column_heading=>'Actions'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:508:&SESSION.::&DEBUG.:508:P508_ID:#ID#'
,p_column_linktext=>'Edit'
,p_column_link_attr=>'class="a-Button a-Button--small" aria-label="Edit #NAME#" title="Edit #NAME#"'
,p_column_alignment=>'CENTER'
,p_derived_column=>'Y'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(64313240212720242)
,p_plug_name=>'&PRODUCT_NAME. recommends having a maximum of 10 shortcuts.'
,p_parent_plug_id=>wwv_flow_imp.id(5400543544685404)
,p_region_css_classes=>'a-Alert--inline'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--warning:a-Alert--horizontal'
,p_region_attributes=>'style="display:none;"'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>30
,p_plug_source=>'<p>The number of visible shortcuts may vary depending on the browser and operating system.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(23102851875504524)
,p_plug_name=>'Service Worker Configuration'
,p_parent_plug_id=>wwv_flow_imp.id(79232375469259813)
,p_region_css_classes=>'a-ServiceWorker'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>101
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P507_FRIENDLY_URL'
,p_plug_display_when_cond2=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2843540275737903)
,p_plug_name=>'SW Section - Function and Variable Declaration'
,p_parent_plug_id=>wwv_flow_imp.id(23102851875504524)
,p_region_css_classes=>'a-SW-Section'
,p_region_template_options=>'#DEFAULT#:a-Form--labelsAbove:a-Region--paddedBody:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2805984800010029)
,p_plug_name=>'Function and Variable Declaration'
,p_parent_plug_id=>wwv_flow_imp.id(2843540275737903)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2806645046010036)
,p_plug_name=>'Preview'
,p_region_name=>'PreviewFunctions'
,p_parent_plug_id=>wwv_flow_imp.id(2843540275737903)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>12
,p_plug_new_grid_row=>false
,p_plug_source=>'<pre><code class="language-javascript"></code></pre>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2843690325737904)
,p_plug_name=>'SW Section - Event install'
,p_parent_plug_id=>wwv_flow_imp.id(23102851875504524)
,p_region_css_classes=>'a-SW-Section'
,p_region_template_options=>'#DEFAULT#:a-Form--labelsAbove:a-Region--paddedBody:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2804150498010011)
,p_plug_name=>'Preview'
,p_region_name=>'PreviewInstallEvent'
,p_parent_plug_id=>wwv_flow_imp.id(2843690325737904)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_source=>'<pre><code class="language-javascript"></code></pre>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(23104901751504545)
,p_plug_name=>'Event: install'
,p_parent_plug_id=>wwv_flow_imp.id(2843690325737904)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2844972326737917)
,p_plug_name=>'SW Section - Event activate'
,p_parent_plug_id=>wwv_flow_imp.id(23102851875504524)
,p_region_css_classes=>'a-SW-Section'
,p_region_template_options=>'#DEFAULT#:a-Form--labelsAbove:a-Region--paddedBody:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2845099437737918)
,p_plug_name=>'Event: activate'
,p_parent_plug_id=>wwv_flow_imp.id(2844972326737917)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2845729502737925)
,p_plug_name=>'Preview'
,p_region_name=>'PreviewActivateEvent'
,p_parent_plug_id=>wwv_flow_imp.id(2844972326737917)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_source=>'<pre><code class="language-javascript"></code></pre>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3136124777406009)
,p_plug_name=>'SW Section - Event fetch'
,p_parent_plug_id=>wwv_flow_imp.id(23102851875504524)
,p_region_css_classes=>'a-SW-Section'
,p_region_template_options=>'#DEFAULT#:a-Form--labelsAbove:a-Region--paddedBody:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>80
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3136210069406010)
,p_plug_name=>'Event: fetch'
,p_parent_plug_id=>wwv_flow_imp.id(3136124777406009)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3136847811406016)
,p_plug_name=>'Preview'
,p_region_name=>'PreviewFetchEvent'
,p_parent_plug_id=>wwv_flow_imp.id(3136124777406009)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_source=>'<pre><code class="language-javascript"></code></pre>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3139440939406042)
,p_plug_name=>'SW Section - Event sync'
,p_parent_plug_id=>wwv_flow_imp.id(23102851875504524)
,p_region_css_classes=>'a-SW-Section'
,p_region_template_options=>'#DEFAULT#:a-Form--labelsAbove:a-Region--paddedBody:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>130
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3139655632406044)
,p_plug_name=>'Event: sync'
,p_parent_plug_id=>wwv_flow_imp.id(3139440939406042)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3177642735906005)
,p_plug_name=>'Preview'
,p_region_name=>'PreviewSyncEvent'
,p_parent_plug_id=>wwv_flow_imp.id(3139440939406042)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_source=>'<pre><code class="language-javascript"></code></pre>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3178861450906017)
,p_plug_name=>'SW Section - Event push'
,p_parent_plug_id=>wwv_flow_imp.id(23102851875504524)
,p_region_css_classes=>'a-SW-Section'
,p_region_template_options=>'#DEFAULT#:a-Form--labelsAbove:a-Region--paddedBody:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>100
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3179371110906022)
,p_plug_name=>'Event: push'
,p_parent_plug_id=>wwv_flow_imp.id(3178861450906017)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3179762164906026)
,p_plug_name=>'Preview'
,p_region_name=>'PreviewPushEvent'
,p_parent_plug_id=>wwv_flow_imp.id(3178861450906017)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_source=>'<pre><code class="language-javascript"></code></pre>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3178925850906018)
,p_plug_name=>'SW Section - Event notificationclick'
,p_parent_plug_id=>wwv_flow_imp.id(23102851875504524)
,p_region_css_classes=>'a-SW-Section'
,p_region_template_options=>'#DEFAULT#:a-Form--labelsAbove:a-Region--paddedBody:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>110
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3179825058906027)
,p_plug_name=>'Event: notificationclick'
,p_parent_plug_id=>wwv_flow_imp.id(3178925850906018)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>80
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3180270704906031)
,p_plug_name=>'Preview'
,p_region_name=>'PreviewNotificationclickEvent'
,p_parent_plug_id=>wwv_flow_imp.id(3178925850906018)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>120
,p_plug_new_grid_row=>false
,p_plug_source=>'<pre><code class="language-javascript"></code></pre>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3179026643906019)
,p_plug_name=>'SW Section - Event notificationclose'
,p_parent_plug_id=>wwv_flow_imp.id(23102851875504524)
,p_region_css_classes=>'a-SW-Section'
,p_region_template_options=>'#DEFAULT#:a-Form--labelsAbove:a-Region--paddedBody:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>120
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3180392692906032)
,p_plug_name=>'Event: notificationclose'
,p_parent_plug_id=>wwv_flow_imp.id(3179026643906019)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>90
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3180731450906036)
,p_plug_name=>'Preview'
,p_region_name=>'PreviewNotificationcloseEvent'
,p_parent_plug_id=>wwv_flow_imp.id(3179026643906019)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>130
,p_plug_new_grid_row=>false
,p_plug_source=>'<pre><code class="language-javascript"></code></pre>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3179107749906020)
,p_plug_name=>'SW Section - Event canmakepayment'
,p_parent_plug_id=>wwv_flow_imp.id(23102851875504524)
,p_region_css_classes=>'a-SW-Section'
,p_region_template_options=>'#DEFAULT#:a-Form--labelsAbove:a-Region--paddedBody:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>140
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3180853613906037)
,p_plug_name=>'Event: canmakepayment'
,p_parent_plug_id=>wwv_flow_imp.id(3179107749906020)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>100
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3181261319906041)
,p_plug_name=>'Preview'
,p_region_name=>'PreviewCanmakepaymentEvent'
,p_parent_plug_id=>wwv_flow_imp.id(3179107749906020)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>140
,p_plug_new_grid_row=>false
,p_plug_source=>'<pre><code class="language-javascript"></code></pre>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3179297823906021)
,p_plug_name=>'SW Section - Event paymentrequest'
,p_parent_plug_id=>wwv_flow_imp.id(23102851875504524)
,p_region_css_classes=>'a-SW-Section'
,p_region_template_options=>'#DEFAULT#:a-Form--labelsAbove:a-Region--paddedBody:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>150
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3181300807906042)
,p_plug_name=>'Event: paymentrequest'
,p_parent_plug_id=>wwv_flow_imp.id(3179297823906021)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>110
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3181766600906046)
,p_plug_name=>'Preview'
,p_region_name=>'PreviewPaymentrequestEvent'
,p_parent_plug_id=>wwv_flow_imp.id(3179297823906021)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>150
,p_plug_new_grid_row=>false
,p_plug_source=>'<pre><code class="language-javascript"></code></pre>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(276999981208499728)
,p_plug_name=>'Application Attributes'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>130
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(274897624522614662)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_landmark_type=>'navigation'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(633650169938164583)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Edit the Progressive Web App attributes for this application.</p>',
'<p><a rel="noopener noreferrer" target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1803086861350520)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(1801173018350501)
,p_button_name=>'GENERATE_PUSH_CREDENTIALS'
,p_button_static_id=>'a-pwaGeneratePushCredentials'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'Generate Credentials'
,p_confirm_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Confirm to generate new credentials, including public and private keys.</p>',
'<p>Existing push subscriptions for this application will be invalidated.</p>',
'<p>Queued push notifications for this application will be removed.</p>'))
,p_confirm_style=>'information'
,p_button_css_classes=>'margin-top-sm margin-bottom-none'
,p_icon_css_classes=>'icon-plus'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2809641979194311)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(1801173018350501)
,p_button_name=>'REGENERATE_PUSH_CREDENTIALS'
,p_button_static_id=>'a-pwaRegeneratePushCredentials'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'Regenerate Credentials'
,p_confirm_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Confirm to regenerate the public and private keys for the selected credentials.</p>',
'<p>Existing push subscriptions for this application will be invalidated.</p>',
'<p>Queued push notifications for this application will be removed.</p>'))
,p_confirm_style=>'warning'
,p_button_css_classes=>'margin-top-sm margin-bottom-none margin-left-none'
,p_icon_css_classes=>'icon-refresh'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2401049197642108)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(1801173018350501)
,p_button_name=>'ADD_FEATURE_PAGE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'Add Settings Page'
,p_button_redirect_url=>'f?p=&APP_ID.:1318:&SESSION.::&DEBUG.:1318:P1318_PARENT_PAGE:&APP_PAGE_ID.'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_app_feature_v3.add_feature_page_allowed(',
'    p_app_id       => :FB_FLOW_ID,',
'    p_feature_name => wwv_flow_app_feature_v3.c_push_notifications ) and ',
'( ',
'    wwv_flow_theme_dev.is_universal_theme ( p_application_id => :FB_FLOW_ID ) or',
'    wwv_flow_theme_dev.is_redwood_theme   ( p_application_id => :FB_FLOW_ID )',
')'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_css_classes=>'margin-top-sm margin-bottom-none'
,p_icon_css_classes=>'icon-plus'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2201098733388902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2200905572388901)
,p_button_name=>'ADD_SCREENSHOT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Add Screenshot'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:519:&SESSION.::&DEBUG.:519::'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_pwa_screenshots',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5400812211685407)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(5400543544685404)
,p_button_name=>'ADD_SHORTCUT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Add Shortcut'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:508:&SESSION.::&DEBUG.:508::'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_pwa_shortcuts',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and :P507_REJOIN_EXISTING_SESSIONS != ''N'''))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2201330051388905)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(2200905572388901)
,p_button_name=>'SCREENSHOT_HELP'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Screenshot Help'
,p_button_position=>'EDIT'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'icon-help'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5401108296685410)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(5400543544685404)
,p_button_name=>'SHORTCUT_HELP'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Shortcut Help'
,p_button_position=>'EDIT'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'icon-help'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3612102128484601)
,p_button_sequence=>150
,p_button_plug_id=>wwv_flow_imp.id(23102851875504524)
,p_button_name=>'DOWNLOAD_HOOKS'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Download Configuration'
,p_button_position=>'EDIT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P507_SW_MODE'
,p_button_condition2=>'DECLARATIVE'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2101268853877352)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2100662725830897)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:RP,1::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2202082763388912)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2201761754388909)
,p_button_name=>'ADD_SCREENSHOT_FIRST'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Screenshot'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:519:&SESSION.::&DEBUG.:519::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5401652220685415)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(5401546530685414)
,p_button_name=>'ADD_SHORTCUT_FIRST'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Shortcut'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:508:&SESSION.::&DEBUG.:508::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(23104547470504541)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(23104254952504538)
,p_button_name=>'ENABLE_FRIENDLY_URL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Enable Friendly URLs'
,p_button_position=>'NEXT'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3047967767097926)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(3047844791097925)
,p_button_name=>'ENABLE_REJOIN_SESSIONS_PUBLIC'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Enable for Public Sessions'
,p_button_position=>'NEXT'
,p_confirm_message=>'Enable Rejoin Sessions for Public Sessions?'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2102037359877353)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(2100662725830897)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'FB_FLOW_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3048802636097935)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(3047844791097925)
,p_button_name=>'ENABLE_REJOIN_SESSIONS_ALL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Enable for All Sessions'
,p_button_position=>'NEXT'
,p_confirm_message=>'Enable Rejoin Sessions for All Sessions?'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1447588646584401)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_imp.id(23104901751504545)
,p_button_name=>'HELP_INSTALL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader:a-Button--padLeft'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Help Install'
,p_button_position=>'RIGHT_OF_TITLE'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'icon-help'
,p_button_cattributes=>'tabindex="-1"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1447902101584405)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_imp.id(2845099437737918)
,p_button_name=>'HELP_ACTIVATE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader:a-Button--padLeft'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Help Activate'
,p_button_position=>'RIGHT_OF_TITLE'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'icon-help'
,p_button_cattributes=>'tabindex="-1"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1448241515584408)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_imp.id(3136210069406010)
,p_button_name=>'HELP_FETCH'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader:a-Button--padLeft'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Help Fetch'
,p_button_position=>'RIGHT_OF_TITLE'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'icon-help'
,p_button_cattributes=>'tabindex="-1"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1448092376584406)
,p_button_sequence=>110
,p_button_plug_id=>wwv_flow_imp.id(3139655632406044)
,p_button_name=>'HELP_SYNC'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader:a-Button--padLeft'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Help Sync'
,p_button_position=>'RIGHT_OF_TITLE'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'icon-help'
,p_button_cattributes=>'tabindex="-1"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1448300678584409)
,p_button_sequence=>120
,p_button_plug_id=>wwv_flow_imp.id(3179371110906022)
,p_button_name=>'HELP_PUSH'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader:a-Button--padLeft'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Help Push'
,p_button_position=>'RIGHT_OF_TITLE'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'icon-help'
,p_button_cattributes=>'tabindex="-1"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1448109222584407)
,p_button_sequence=>130
,p_button_plug_id=>wwv_flow_imp.id(3179825058906027)
,p_button_name=>'HELP_NOTIFICATIONCLICK'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader:a-Button--padLeft'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Help Notificationclick'
,p_button_position=>'RIGHT_OF_TITLE'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'icon-help'
,p_button_cattributes=>'tabindex="-1"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1448479501584410)
,p_button_sequence=>140
,p_button_plug_id=>wwv_flow_imp.id(3180392692906032)
,p_button_name=>'HELP_NOTIFICATIONCLOSE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader:a-Button--padLeft'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Help Notificationclose'
,p_button_position=>'RIGHT_OF_TITLE'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'icon-help'
,p_button_cattributes=>'tabindex="-1"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1448596184584411)
,p_button_sequence=>150
,p_button_plug_id=>wwv_flow_imp.id(3180853613906037)
,p_button_name=>'HELP_CANMAKEPAYMENT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader:a-Button--padLeft'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Help Canmakepayment'
,p_button_position=>'RIGHT_OF_TITLE'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'icon-help'
,p_button_cattributes=>'tabindex="-1"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1448653750584412)
,p_button_sequence=>160
,p_button_plug_id=>wwv_flow_imp.id(3181300807906042)
,p_button_name=>'HELP_PAYMENTREQUEST'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader:a-Button--padLeft'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Help Paymentrequest'
,p_button_position=>'RIGHT_OF_TITLE'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'icon-help'
,p_button_cattributes=>'tabindex="-1"'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2501429715538242)
,p_branch_name=>'Go To Page 4001'
,p_branch_action=>'f?p=&APP_ID.:4001:&SESSION.::&DEBUG.:4001:FB_FLOW_ID:&FB_FLOW_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_DEFN'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2185476851877463)
,p_branch_name=>'Go To Page 509'
,p_branch_action=>'f?p=&APP_ID.:509:&SESSION.::&DEBUG.:509:FB_FLOW_ID,509_FB_UPD_ID:&FB_FLOW_ID.,&FB_FLOW_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_SEC'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2185885761877463)
,p_branch_name=>'Go To Page 506'
,p_branch_action=>'f?p=&APP_ID.:506:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_GLOBAL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2184680907877463)
,p_branch_name=>'Go To Page 197'
,p_branch_action=>'f?p=&APP_ID.:197:&SESSION.::&DEBUG.:197:FB_FLOW_ID:&FB_FLOW_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>70
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_USERINTERFACE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(23101723242504513)
,p_branch_name=>'Go To Page 507'
,p_branch_action=>'f?p=&APP_ID.:507:&SESSION.::&DEBUG.:507:FB_FLOW_ID:&FB_FLOW_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>80
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_PWA'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1767748012833401)
,p_branch_name=>'Go To Page 523'
,p_branch_action=>'f?p=&APP_ID.:523:&SESSION.::&DEBUG.:523:FB_FLOW_ID:&FB_FLOW_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>90
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_AI'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1743862280874605)
,p_name=>'P507_SW_PUSH_BEFORE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(3179371110906022)
,p_prompt=>'Before'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'lazy-load'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Available JavaScript parameters for this scope:</p>',
'<ul>',
'    <li>apex</li>',
'    <li>event</li>',
'</ul>'))
,p_attribute_01=>'JAVASCRIPT'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1743948559874606)
,p_name=>'P507_SW_PUSH_AFTER'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(3179371110906022)
,p_prompt=>'After'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'lazy-load'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Available JavaScript parameters for this scope:</p>',
'<ul>',
'    <li>apex</li>',
'    <li>event</li>',
'</ul>'))
,p_attribute_01=>'JAVASCRIPT'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1744836757874615)
,p_name=>'P507_SW_NOTIFICATIONCLICK_BEF'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(3179825058906027)
,p_prompt=>'Before'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'lazy-load'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Available JavaScript parameters for this scope:</p>',
'<ul>',
'    <li>apex</li>',
'    <li>event</li>',
'</ul>'))
,p_attribute_01=>'JAVASCRIPT'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1744957669874616)
,p_name=>'P507_SW_NOTIFICATIONCLICK_AFT'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(3179825058906027)
,p_prompt=>'After'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'lazy-load'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Available JavaScript parameters for this scope:</p>',
'<ul>',
'    <li>apex</li>',
'    <li>event</li>',
'</ul>'))
,p_attribute_01=>'JAVASCRIPT'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1801212113350502)
,p_name=>'P507_PWA_IS_PUSH_ENABLED'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1801173018350501)
,p_item_source_plug_id=>wwv_flow_imp.id(10409147636693205)
,p_item_default=>'N'
,p_prompt=>'Enable Push Notifications'
,p_source=>'PWA_IS_PUSH_ENABLED'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Web push notifications are a way for web apps to send notifications to a user''s device even when the user is not currently on the website. These notifications can be sent to a user''s desktop or mobile device, and can be used to alert the user to n'
||'ew content or events on the website, or to re-engage the user with the website.</p>',
'<p>Enabling this option will:</p>',
'<ul>',
'<li>Add a new navigation bar entry: User Settings</li>',
'<li>Allow users to subscribe and unsubscribe to push notifications.</li>',
'<li>When subscribed, users can receive push notifications from the APEX app.</li>',
'</ul>'))
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1801853695350508)
,p_name=>'P507_PWA_VAPID_CONTACT_INFO'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(1801173018350501)
,p_item_source_plug_id=>wwv_flow_imp.id(10409147636693205)
,p_prompt=>'Contact Email'
,p_source=>'PWA_VAPID_CONTACT_INFO'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'<p>Enter the email address to contact in case the push notification service provider (Google, Mozilla, Apple, etc.) wants to contact the owner of the application. We recommend using a group email so it''s not dependent on a single individual.</p>'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'EMAIL'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2133026982877392)
,p_name=>'P507_IS_PWA'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(5501359206896821)
,p_item_source_plug_id=>wwv_flow_imp.id(10409147636693205)
,p_item_default=>'N'
,p_prompt=>'Enable Progressive Web App'
,p_source=>'IS_PWA'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Progressive Web Apps are web applications designed to be capable, reliable, and installable.</p>',
'<p>Enabling this option will:</p>',
'<ul>',
'<li>Serve static files more efficiently using advanced caching</li>',
'<li>Enable more declarative Progressive Web App options</li>',
'</ul>'))
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2133996308877392)
,p_name=>'P507_PWA_IS_INSTALLABLE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(5501359206896821)
,p_item_source_plug_id=>wwv_flow_imp.id(10409147636693205)
,p_item_default=>'N'
,p_prompt=>'Installable'
,p_source=>'PWA_IS_INSTALLABLE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>A Progressive Web App can be installed on devices. When installing a Progressive Web App, an icon is added to the device home screen to feel like a native application.</p>',
'<p>Enabling this option will:</p>',
'<ul>',
'<li>Add a new navigation bar entry: Install App</li>',
'<li>Allow users to install this APEX app on devices</li>',
'</ul>'))
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2134855732877393)
,p_name=>'P507_PWA_MANIFEST_DESCRIPTION'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(23101891067504514)
,p_item_source_plug_id=>wwv_flow_imp.id(10409147636693205)
,p_prompt=>'App Description'
,p_source=>'PWA_MANIFEST_DESCRIPTION'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The app description explains what the application does.</p>',
'<p>This is used to provide more information to users when they are prompted to install the application.</p>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2135775024877394)
,p_name=>'P507_PWA_MANIFEST_DISPLAY'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(23101891067504514)
,p_item_source_plug_id=>wwv_flow_imp.id(10409147636693205)
,p_item_default=>'standalone'
,p_prompt=>'Display'
,p_source=>'PWA_MANIFEST_DISPLAY'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PWA_MANIFEST_DISPLAY'
,p_lov=>'.'||wwv_flow_imp.id(1687503362489571)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The display determines the preferred display mode for the application.</p>',
'<p>The display mode changes how much of browser UI is shown to the user.</p>',
'<ul>',
'    <li>Fullscreen: Opens the Progressive Web App without any browser UI. Takes the entirety of the screen or window.</li>',
'    <li>Standalone: Opens the Progressive Web App to look like a standalone application. The app runs in a distinct window, separate from the browser. Standard browser UI components like the URL bar and buttons are not visible.</li>',
'    <li>Minimal UI: Similar to standalone, except with browser controlling navigation buttons like back and refresh.</li>',
'    <li>Browser: Regular browser UI.</li>',
'</ul>',
'<p>Note: Some devices and browsers ignore this attribute. Oracle APEX is only relaying this information to the device which handles the Progressive Web App appropriately.</p>',
'<p>More information: <a rel="noopener noreferrer" href="https://web.dev/add-manifest/">https://web.dev/add-manifest/</a></p>'))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2136632433877394)
,p_name=>'P507_PWA_MANIFEST_ORIENTATION'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(23101891067504514)
,p_item_source_plug_id=>wwv_flow_imp.id(10409147636693205)
,p_item_default=>'any'
,p_prompt=>'Screen Orientation'
,p_source=>'PWA_MANIFEST_ORIENTATION'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PWA_MANIFEST_ORIENTATION'
,p_lov=>'.'||wwv_flow_imp.id(1689369179497016)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The preferred screen orientation when using this Progressive Web App. This applies mostly for mobile devices.</p>',
'<p>Note: Some devices and browsers ignore this attribute. Oracle APEX is only relaying this information to the device which handles the Progressive Web App appropriately.</p>'))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2137514567877395)
,p_name=>'P507_PWA_MANIFEST_THEME_COLOR'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(23101891067504514)
,p_item_source_plug_id=>wwv_flow_imp.id(10409147636693205)
,p_prompt=>'Custom Theme Color'
,p_source=>'PWA_MANIFEST_THEME_COLOR'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_COLOR_PICKER'
,p_cSize=>30
,p_cMaxlength=>128
,p_begin_on_new_line=>'N'
,p_colspan=>8
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'u-hidden'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'<p>This attribute defines the custom theme color for the Progressive Web App.</p>'
,p_attribute_01=>'N'
,p_attribute_02=>'FULL'
,p_attribute_03=>'COLOR_ONLY'
,p_attribute_04=>'THEME_STYLE'
,p_attribute_06=>'NONE'
,p_attribute_09=>'HEX'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2138407165877396)
,p_name=>'P507_PWA_BACKGROUND_COLOR'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(23101891067504514)
,p_item_source_plug_id=>wwv_flow_imp.id(10409147636693205)
,p_prompt=>'Custom Background Color'
,p_source=>'PWA_MANIFEST_BACKGROUND_COLOR'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_COLOR_PICKER'
,p_cSize=>30
,p_cMaxlength=>128
,p_begin_on_new_line=>'N'
,p_colspan=>8
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'u-hidden'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'<p>Select the custom background color for the application to display before its stylesheet is loaded.</p>'
,p_attribute_01=>'N'
,p_attribute_02=>'FULL'
,p_attribute_03=>'COLOR_ONLY'
,p_attribute_04=>'THEME_STYLE'
,p_attribute_06=>'NONE'
,p_attribute_09=>'HEX'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2140253052877397)
,p_name=>'P507_PWA_MANIFEST_CUSTOM'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(23101891067504514)
,p_item_source_plug_id=>wwv_flow_imp.id(10409147636693205)
,p_prompt=>'Custom Manifest'
,p_source=>'PWA_MANIFEST_CUSTOM'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The Custom Manifest is used to store additional JSON properties for the Web App Manifest file.</p>',
'<p>The properties found here will be used to extend the declarative options above, by overriding existing properties or appending new properties.</p>',
'<p>For more information on building your Custom Manifest, you can read the Web App Manifest specifications: <a rel="noopener noreferrer" href="https://www.w3.org/TR/appmanifest/">https://www.w3.org/TR/appmanifest/</a></p>'))
,p_attribute_01=>'json'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2400996182642107)
,p_name=>'P507_PWA_PUSH_FEATURE_PAGE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(1801173018350501)
,p_prompt=>'Settings Page'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_colspan=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>If this application already has the push notification feature page, the page number is shown here. If the application does not have the push notification feature page, it will show that the feature page is available to add.</p>'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2419611672768205)
,p_name=>'P507_PWA_MANIFEST_THEME_COLORP'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(23101891067504514)
,p_prompt=>'Theme Color'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Default;DEFAULT,Custom;CUSTOM'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This attribute defines the theme color for the Progressive Web App.</p>',
'<p>This affects how the OS displays the application (e.g., on Android''s task switcher, the theme color surrounds the application).</p>',
'<p>Note: Some devices and browsers ignore this attribute. Oracle APEX is only relaying this information to the device which handles the Progressive Web App appropriately.</p>'))
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2419723460768206)
,p_name=>'P507_PWA_MANIFEST_BG_COLORP'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(23101891067504514)
,p_prompt=>'Background Color'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Default;DEFAULT,Custom;CUSTOM'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The background color defines a placeholder background color for the application to display before its stylesheet is loaded.</p>',
'<p>Therefore background color should match the theme body background color for a smooth transition between launching the web application and loading the application content.</p>',
'<p>Note: Some devices and browsers ignore this attribute. Oracle APEX is only relaying this information to the device which handles the Progressive Web App appropriately.</p>'))
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2503231568610528)
,p_name=>'P507_FRIENDLY_URL'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>11
,p_item_plug_id=>wwv_flow_imp.id(10409147636693205)
,p_item_source_plug_id=>wwv_flow_imp.id(10409147636693205)
,p_source=>'FRIENDLY_URL'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2600309602453041)
,p_name=>'P507_PWA_PUSH_CREDENTIAL_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1801173018350501)
,p_item_source_plug_id=>wwv_flow_imp.id(10409147636693205)
,p_prompt=>'Credentials'
,p_source=>'PWA_PUSH_CREDENTIAL_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_credentials',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and authentication_type = ''KEY_PAIR''',
' order by name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_colspan=>5
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Credentials are required to setup push notification securely. A public and private key pair are used respectively to allow users to subscribe to push notifications on the client side, and for the server to send the notifications to the subscribers'
||'.</p>',
'<p>Select the credential to authenticate against. To edit the credential, navigate to <strong>Web Credentials</strong> in <strong>Workspace Utilities</strong></p>'))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2803125222010001)
,p_name=>'P507_SW_INSTALL_AFTER'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(23104901751504545)
,p_prompt=>'After'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'lazy-load'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Available JavaScript parameters for this scope:</p>',
'<ul>',
'    <li>apex</li>',
'    <li>event</li>',
'</ul>'))
,p_attribute_01=>'JAVASCRIPT'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2806079494010030)
,p_name=>'P507_SW_FUNCTION_VARIABLE_MODE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2805984800010029)
,p_prompt=>'Function and Variable Declaration Mode'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Default;DEFAULT,Configure Hooks;HOOK'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2806218311010032)
,p_name=>'P507_SW_FUNCTION_VARIABLE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2805984800010029)
,p_prompt=>'Function and Variable Declaration'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'lazy-load'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Available JavaScript parameters for this scope:</p>',
'<ul>',
'    <li>apex</li>',
'</ul>'))
,p_attribute_01=>'JAVASCRIPT'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2845289794737920)
,p_name=>'P507_SW_ACTIVATE_MODE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2845099437737918)
,p_prompt=>'Event activate mode'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Default;DEFAULT,Configure Hooks;HOOK,Custom;CUSTOM'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2845381155737921)
,p_name=>'P507_SW_ACTIVATE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2845099437737918)
,p_prompt=>'activate'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'lazy-load'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Available JavaScript parameters for this scope:</p>',
'<ul>',
'    <li>apex</li>',
'    <li>event</li>',
'</ul>'))
,p_attribute_01=>'JAVASCRIPT'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2845402507737922)
,p_name=>'P507_SW_ACTIVATE_BEFORE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(2845099437737918)
,p_prompt=>'Before'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'lazy-load'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Available JavaScript parameters for this scope:</p>',
'<ul>',
'    <li>apex</li>',
'    <li>event</li>',
'</ul>'))
,p_attribute_01=>'JAVASCRIPT'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2845535577737923)
,p_name=>'P507_SW_ACTIVATE_AFTER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(2845099437737918)
,p_prompt=>'After'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'lazy-load'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Available JavaScript parameters for this scope:</p>',
'<ul>',
'    <li>apex</li>',
'    <li>event</li>',
'</ul>'))
,p_attribute_01=>'JAVASCRIPT'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3048059485097927)
,p_name=>'P507_REJOIN_EXISTING_SESSIONS'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>21
,p_item_plug_id=>wwv_flow_imp.id(10409147636693205)
,p_item_source_plug_id=>wwv_flow_imp.id(10409147636693205)
,p_source=>'REJOIN_EXISTING_SESSIONS'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3048461938097931)
,p_name=>'P507_BROWSER_FRAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>31
,p_item_plug_id=>wwv_flow_imp.id(10409147636693205)
,p_item_source_plug_id=>wwv_flow_imp.id(10409147636693205)
,p_source=>'BROWSER_FRAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3136320125406011)
,p_name=>'P507_SW_FETCH_MODE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3136210069406010)
,p_prompt=>'Event fetch mode'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Default;DEFAULT,Configure Hooks;HOOK,Custom;CUSTOM'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3136417246406012)
,p_name=>'P507_SW_FETCH'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3136210069406010)
,p_prompt=>'fetch'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'lazy-load'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Available JavaScript parameters for this scope:</p>',
'<ul>',
'    <li>apex</li>',
'    <li>event</li>',
'</ul>'))
,p_attribute_01=>'JAVASCRIPT'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3136588872406013)
,p_name=>'P507_SW_FETCH_BEFORE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3136210069406010)
,p_prompt=>'Before'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'lazy-load'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Available JavaScript parameters for this scope:</p>',
'<ul>',
'    <li>apex</li>',
'    <li>event</li>',
'</ul>'))
,p_attribute_01=>'JAVASCRIPT'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3136692103406014)
,p_name=>'P507_SW_FETCH_CACHE_DEFINITION'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(3136210069406010)
,p_prompt=>'Cache Definition'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'lazy-load'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Available JavaScript parameters for this scope:</p>',
'<ul>',
'    <li>apex</li>',
'    <li>event</li>',
'    <li>cacheName</li>',
'</ul>'))
,p_attribute_01=>'JAVASCRIPT'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3138957626406037)
,p_name=>'P507_SW_FETCH_CACHE_RESPONSE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(3136210069406010)
,p_prompt=>'Cache Response'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'lazy-load'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Available JavaScript parameters for this scope:</p>',
'<ul>',
'    <li>apex</li>',
'    <li>event</li>',
'    <li>cache</li>',
'    <li>response</li>',
'</ul>'))
,p_attribute_01=>'JAVASCRIPT'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3139013826406038)
,p_name=>'P507_SW_FETCH_NETWORK_RESP_SUC'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(3136210069406010)
,p_prompt=>'Network Response Success'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'lazy-load'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Available JavaScript parameters for this scope:</p>',
'<ul>',
'    <li>apex</li>',
'    <li>event</li>',
'    <li>response</li>',
'</ul>'))
,p_attribute_01=>'JAVASCRIPT'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3139175128406039)
,p_name=>'P507_SW_FETCH_NETWORK_RESP_ERR'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(3136210069406010)
,p_prompt=>'Network Response Error'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'lazy-load'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Available JavaScript parameters for this scope:</p>',
'<ul>',
'    <li>apex</li>',
'    <li>event</li>',
'    <li>error</li>',
'</ul>'))
,p_attribute_01=>'JAVASCRIPT'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3139263542406040)
,p_name=>'P507_SW_FETCH_OFFLINE_PAGE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(3136210069406010)
,p_prompt=>'Offline Page'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'lazy-load'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Available JavaScript parameters for this scope:</p>',
'<ul>',
'    <li>apex</li>',
'    <li>event</li>',
'    <li>offlinePage</li>',
'</ul>'))
,p_attribute_01=>'JAVASCRIPT'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3139335348406041)
,p_name=>'P507_SW_FETCH_NETWORK_FALLBACK'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(3136210069406010)
,p_prompt=>'Network Fallback'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'lazy-load'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Available JavaScript parameters for this scope:</p>',
'<ul>',
'    <li>apex</li>',
'    <li>event</li>',
'</ul>'))
,p_attribute_01=>'JAVASCRIPT'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3139792034406045)
,p_name=>'P507_SW_SYNC_MODE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3139655632406044)
,p_prompt=>'Event sync mode'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Default;DEFAULT,Custom;CUSTOM'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3139811302406046)
,p_name=>'P507_SW_SYNC'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3139655632406044)
,p_prompt=>'sync'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'lazy-load'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Available JavaScript parameters for this scope:</p>',
'<ul>',
'    <li>apex</li>',
'    <li>event</li>',
'</ul>'))
,p_attribute_01=>'JAVASCRIPT'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3179471542906023)
,p_name=>'P507_SW_PUSH_MODE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3179371110906022)
,p_prompt=>'Event push mode'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Default;DEFAULT,Configure Hooks;HOOK,Custom;CUSTOM'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3179566594906024)
,p_name=>'P507_SW_PUSH'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3179371110906022)
,p_prompt=>'push'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'lazy-load'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Available JavaScript parameters for this scope:</p>',
'<ul>',
'    <li>apex</li>',
'    <li>event</li>',
'</ul>'))
,p_attribute_01=>'JAVASCRIPT'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3179933683906028)
,p_name=>'P507_SW_NOTIFICATIONCLICK_MODE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3179825058906027)
,p_prompt=>'Event notificationclick mode'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Default;DEFAULT,Configure Hooks;HOOK,Custom;CUSTOM'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3180022486906029)
,p_name=>'P507_SW_NOTIFICATIONCLICK'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3179825058906027)
,p_prompt=>'notificationclick'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'lazy-load'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Available JavaScript parameters for this scope:</p>',
'<ul>',
'    <li>apex</li>',
'    <li>event</li>',
'</ul>'))
,p_attribute_01=>'JAVASCRIPT'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3180427400906033)
,p_name=>'P507_SW_NOTIFICATIONCLOSE_MODE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3180392692906032)
,p_prompt=>'Event notificationclose mode'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Default;DEFAULT,Custom;CUSTOM'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3180539558906034)
,p_name=>'P507_SW_NOTIFICATIONCLOSE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3180392692906032)
,p_prompt=>'notificationclose'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'lazy-load'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Available JavaScript parameters for this scope:</p>',
'<ul>',
'    <li>apex</li>',
'    <li>event</li>',
'</ul>'))
,p_attribute_01=>'JAVASCRIPT'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3180951130906038)
,p_name=>'P507_SW_CANMAKEPAYMENT_MODE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3180853613906037)
,p_prompt=>'Event canmakepayment mode'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Default;DEFAULT,Custom;CUSTOM'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3181037675906039)
,p_name=>'P507_SW_CANMAKEPAYMENT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3180853613906037)
,p_prompt=>'canmakepayment'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'lazy-load'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Available JavaScript parameters for this scope:</p>',
'<ul>',
'    <li>apex</li>',
'    <li>event</li>',
'</ul>'))
,p_attribute_01=>'JAVASCRIPT'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3181498225906043)
,p_name=>'P507_SW_PAYMENTREQUEST_MODE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3181300807906042)
,p_prompt=>'Event paymentrequest mode'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Default;DEFAULT,Custom;CUSTOM'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3181531959906044)
,p_name=>'P507_SW_PAYMENTREQUEST'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3181300807906042)
,p_prompt=>'paymentrequest'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'lazy-load'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Available JavaScript parameters for this scope:</p>',
'<ul>',
'    <li>apex</li>',
'    <li>event</li>',
'</ul>'))
,p_attribute_01=>'JAVASCRIPT'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3606264956641503)
,p_name=>'P507_PWA_APPLE_STATUS_BAR_STYLE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(23101891067504514)
,p_item_source_plug_id=>wwv_flow_imp.id(10409147636693205)
,p_item_default=>'black-translucent'
,p_prompt=>'iOS Status Bar Style'
,p_source=>'PWA_APPLE_STATUS_BAR_STYLE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PWA_APPLE_STATUS_BAR_STYLE'
,p_lov=>'.'||wwv_flow_imp.id(3776418597747042)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The iOS Status Bar Style attribute is rendered as a meta tag on the page to control the appearance of the status bar in a web application when it is added to the home screen on an iOS device.</p>',
'<ul>',
'    <li><strong>Default</strong>: This is the default value and it displays the status bar in the usual way.</li>',
'    <li><strong>Black</strong>: This value makes the status bar black.</li>',
'    <li><strong>Translucent</strong>: This value makes the status bar translucent, allowing the content to be displayed behind it.</li>',
'</ul>',
'<p>Note: Only iOS devices use this attribute. Oracle APEX is only relaying this information to the device which handles',
'the Progressive Web App appropriately.</p>'))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3606435840641505)
,p_name=>'P507_SW_MODE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(23102851875504524)
,p_prompt=>'Service Worker'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Default;DEFAULT,Configure Hooks;DECLARATIVE,File URL;URL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Service workers are JavaScript files that can execute code even when the app is not in use.</p>',
'<p>It can listen to events like fetching resources or handling notifications.</p>',
'<p>Pick a service worker strategy that best fits your application''s needs.</p>',
'<ul>',
'    <li><span>Default: The &PRODUCT_NAME. engine will generate a service worker with the following strategy:</span>',
'        <ul>',
'            <li>Install and activate the service worker</li>',
'            <li>Serve resources from cache if cache exists</li>',
'            <li>Otherwise serve from network, then put resource in cache</li>',
'            <li>Serve an offline page if network fails</li>',
'        </ul>',
'    </li>',
'    <li>Configure Hooks: Fill in the placeholders in the service worker code to add your own. Hooks locations are provided by &PRODUCT_NAME.</li>',
'    <li>File URL: Provide a URL reference to a file that contains the service worker hooks interface. This is useful for sharing service worker hooks across multiple applications. If using the file reference, make sure to follow the interface archite'
||'cture appropriately or else the service worker will fail at runtime.</li>',
'</ul>'))
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3606573660641506)
,p_name=>'P507_SW_FILE_REFERENCE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(23102851875504524)
,p_prompt=>'File Reference URL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Provide a URL reference to a file that contains the service worker hooks interface. This is useful for sharing service worker hooks across multiple applications. If using the file reference, make sure to follow the interface architecture appropria'
||'tely or else the service worker will fail at runtime. Here is the interface structure:</p>',
'<pre><code class="language-javascript">',
'const swHooks = {',
'  FUNCTION_VARIABLE_DECLARATION: ({ apex })                         => { console.log(1, { apex }); },',
'  EVENT_INSTALL:                 ({ apex, event })                  => { console.log(2, { apex, event }); },',
'  EVENT_INSTALL_BEFORE:          ({ apex, event })                  => { console.log(3, { apex, event }); },',
'  EVENT_INSTALL_AFTER:           ({ apex, event })                  => { console.log(4, { apex, event }); },',
'  EVENT_ACTIVATE:                ({ apex, event })                  => { console.log(5, { apex, event }); },',
'  EVENT_ACTIVATE_BEFORE:         ({ apex, event })                  => { console.log(6, { apex, event }); },',
'  EVENT_ACTIVATE_AFTER:          ({ apex, event })                  => { console.log(7, { apex, event }); },',
'  EVENT_FETCH:                   ({ apex, event })                  => { console.log(8, { apex, event }); },',
'  EVENT_FETCH_BEFORE:            ({ apex, event })                  => { console.log(9, { apex, event }); },',
'  EVENT_FETCH_CACHE_DEFINITION:  ({ apex, event, cacheName })       => { console.log(10, { apex, event, cacheName }); },',
'  EVENT_FETCH_CACHE_RESPONSE:    ({ apex, event, cache, response }) => { console.log(11, { apex, event, cache, response }); },',
'  EVENT_FETCH_NETWORK_RESP_SUC:  ({ apex, event, response })        => { console.log(12, { apex, event, response }); },',
'  EVENT_FETCH_NETWORK_RESP_ERR:  ({ apex, event, error })           => { console.log(13, { apex, event, error }); },',
'  EVENT_FETCH_OFFLINE_PAGE:      ({ apex, event, offlinePage })     => { console.log(14, { apex, event, offlinePage }); },',
'  EVENT_FETCH_NETWORK_FALLBACK:  ({ apex, event })                  => { console.log(15, { apex, event }); },',
'  EVENT_SYNC:                    ({ apex, event })                  => { console.log(16, { apex, event }); },',
'  EVENT_PUSH:                    ({ apex, event })                  => { console.log(17, { apex, event }); },',
'  EVENT_NOTIFICATIONCLICK:       ({ apex, event })                  => { console.log(18, { apex, event }); },',
'  EVENT_NOTIFICATIONCLOSE:       ({ apex, event })                  => { console.log(19, { apex, event }); },',
'  EVENT_CANMAKEPAYMENT:          ({ apex, event })                  => { console.log(20, { apex, event }); },',
'  EVENT_PAYMENTREQUEST:          ({ apex, event })                  => { console.log(21, { apex, event }); },',
'};',
'</code></pre>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3612823716484608)
,p_name=>'P507_SW_HOOKS_URL'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(23102851875504524)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10409391815693207)
,p_name=>'P507_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(10409147636693205)
,p_item_source_plug_id=>wwv_flow_imp.id(10409147636693205)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(23103791612504533)
,p_name=>'P507_SW_INSTALL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(23104901751504545)
,p_prompt=>'install'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'lazy-load'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Available JavaScript parameters for this scope:</p>',
'<ul>',
'    <li>apex</li>',
'    <li>event</li>',
'</ul>'))
,p_attribute_01=>'JAVASCRIPT'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(23105309586504549)
,p_name=>'P507_SW_INSTALL_MODE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(23104901751504545)
,p_prompt=>'Event install mode'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Default;DEFAULT,Configure Hooks;HOOK,Custom;CUSTOM'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(23105434571504550)
,p_name=>'P507_SW_INSTALL_BEFORE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(23104901751504545)
,p_prompt=>'Before'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'lazy-load'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Available JavaScript parameters for this scope:</p>',
'<ul>',
'    <li>apex</li>',
'    <li>event</li>',
'</ul>'))
,p_attribute_01=>'JAVASCRIPT'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2162957050877444)
,p_computation_sequence=>70
,p_computation_item=>'P507_PWA_IS_INSTALLABLE'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'N'
,p_compute_when=>'P507_IS_PWA'
,p_compute_when_text=>'N'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1802596781350515)
,p_computation_sequence=>80
,p_computation_item=>'P507_PWA_IS_PUSH_ENABLED'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'N'
,p_compute_when=>'P507_IS_PWA'
,p_compute_when_text=>'N'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2162181449877444)
,p_computation_sequence=>90
,p_computation_item=>'P507_PWA_MANIFEST_DESCRIPTION'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'coalesce(:P507_PWA_IS_INSTALLABLE, ''N'') = ''N'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2163311845877444)
,p_computation_sequence=>100
,p_computation_item=>'P507_PWA_MANIFEST_DISPLAY'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'coalesce(:P507_PWA_IS_INSTALLABLE, ''N'') = ''N'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2163720889877445)
,p_computation_sequence=>110
,p_computation_item=>'P507_PWA_MANIFEST_ORIENTATION'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'coalesce(:P507_PWA_IS_INSTALLABLE, ''N'') = ''N'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2164132794877445)
,p_computation_sequence=>120
,p_computation_item=>'P507_PWA_MANIFEST_THEME_COLOR'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'coalesce(:P507_PWA_IS_INSTALLABLE, ''N'') = ''N'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2421063867768219)
,p_computation_sequence=>130
,p_computation_item=>'P507_PWA_MANIFEST_THEME_COLOR'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P507_PWA_MANIFEST_THEME_COLORP'
,p_compute_when_text=>'DEFAULT'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2164587839877445)
,p_computation_sequence=>140
,p_computation_item=>'P507_PWA_BACKGROUND_COLOR'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'coalesce(:P507_PWA_IS_INSTALLABLE, ''N'') = ''N'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2421130202768220)
,p_computation_sequence=>150
,p_computation_item=>'P507_PWA_BACKGROUND_COLOR'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P507_PWA_MANIFEST_BG_COLORP'
,p_compute_when_text=>'DEFAULT'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2165306006877445)
,p_computation_sequence=>160
,p_computation_item=>'P507_PWA_MANIFEST_CUSTOM'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'coalesce(:P507_PWA_IS_INSTALLABLE, ''N'') = ''N'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3606372597641504)
,p_computation_sequence=>170
,p_computation_item=>'P507_PWA_APPLE_STATUS_BAR_STYLE'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'coalesce(:P507_PWA_IS_INSTALLABLE, ''N'') = ''N'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(5401290876680401)
,p_computation_sequence=>180
,p_computation_item=>'P507_PWA_PUSH_CREDENTIAL_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'DUMMY'
,p_computation_comment=>'This exists to circumvent the required validation on P507_PWA_PUSH_CREDENTIAL_ID when a user clicks on GENERATE_PUSH_CREDENTIALS button, as it will be generated anyway.'
,p_compute_when=>'GENERATE_PUSH_CREDENTIALS'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2400552132642103)
,p_computation_sequence=>190
,p_computation_item=>'P507_PWA_PUSH_CREDENTIAL_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P507_PWA_IS_PUSH_ENABLED'
,p_compute_when_text=>'N'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2400601418642104)
,p_computation_sequence=>200
,p_computation_item=>'P507_PWA_PUSH_CREDENTIAL_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P507_PWA_IS_PUSH_ENABLED'
,p_compute_when_text=>'N'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1963659127170508)
,p_computation_sequence=>210
,p_computation_item=>'P507_PWA_VAPID_CONTACT_INFO'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P507_PWA_IS_PUSH_ENABLED'
,p_compute_when_text=>'N'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1452225350584448)
,p_computation_sequence=>220
,p_computation_item=>'P507_SW_MODE'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P507_IS_PWA'
,p_compute_when_text=>'N'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(23104759099504543)
,p_computation_sequence=>230
,p_computation_item=>'P507_FRIENDLY_URL'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'Y'
,p_compute_when=>'ENABLE_FRIENDLY_URL'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2420532636768214)
,p_computation_sequence=>20
,p_computation_item=>'P507_PWA_MANIFEST_THEME_COLORP'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P507_PWA_MANIFEST_THEME_COLOR is not null then',
'    return ''CUSTOM'';',
'else',
'    return ''DEFAULT'';',
'end if;',
''))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2420679999768215)
,p_computation_sequence=>30
,p_computation_item=>'P507_PWA_MANIFEST_BG_COLORP'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P507_PWA_BACKGROUND_COLOR is not null then',
'    return ''CUSTOM'';',
'else',
'    return ''DEFAULT'';',
'end if;',
''))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2401532882642113)
,p_computation_sequence=>40
,p_computation_item=>'P507_PWA_PUSH_FEATURE_PAGE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'QUERY_COLON'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select p.id || ''. '' || p.name',
'  from wwv_flow_steps p,',
'       wwv_flow_patches pa',
' where p.flow_id             = :FB_FLOW_ID',
'   and p.security_group_id   = :WORKSPACE_ID',
'   and pa.security_group_id  = p.security_group_id',
'   and pa.flow_id            = p.flow_id',
'   and pa.id                 = p.required_patch',
'   and pa.feature_identifier = ''APPLICATION_PUSH_NOTIFICATIONS'''))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(11617215609737341)
,p_computation_sequence=>10
,p_computation_item=>'P507_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'FB_FLOW_ID'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2167777284877448)
,p_validation_name=>'P507_PWA_MANIFEST_CUSTOM is valid JSON'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from sys.dual',
'where :P507_PWA_MANIFEST_CUSTOM is json'))
,p_validation_type=>'EXISTS'
,p_error_message=>'#LABEL# must be a valid JSON object.'
,p_validation_condition=>'P507_PWA_MANIFEST_CUSTOM'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_imp.id(2140253052877397)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1452443205584450)
,p_validation_name=>'P507_SW_FILE_REFERENCE is required'
,p_validation_sequence=>90
,p_validation=>'P507_SW_FILE_REFERENCE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P507_SW_MODE'
,p_validation_condition2=>'URL'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(3606573660641506)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2207147383031134)
,p_validation_name=>'Validate ENABLE_REJOIN_SESSIONS_PUBLIC'
,p_validation_sequence=>100
,p_validation=>'return wwv_flow_platform.get_preference(''REJOIN_EXISTING_SESSIONS'') in ( ''P'', ''Y'' );'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'The Rejoin Sessions setting of <em>Enabled for Public Sessions</em> is not supported on your &PRODUCT_NAME. instance.'
,p_when_button_pressed=>wwv_flow_imp.id(3047967767097926)
,p_associated_item=>wwv_flow_imp.id(3048059485097927)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3048601420097933)
,p_validation_name=>'Validate ENABLE_REJOIN_SESSIONS_ALL'
,p_validation_sequence=>110
,p_validation=>'return wwv_flow_platform.get_preference(''REJOIN_EXISTING_SESSIONS'') in ( ''Y'' );'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'The Rejoin Sessions setting of <em>Enabled for All Sessions</em> is not supported on your &PRODUCT_NAME. instance.'
,p_when_button_pressed=>wwv_flow_imp.id(3048802636097935)
,p_associated_item=>wwv_flow_imp.id(3048059485097927)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2207484374032334)
,p_validation_name=>'Validate ENABLE_REJOIN_SESSIONS_ALL against BROWSER_FRAME'
,p_validation_sequence=>120
,p_validation=>':P507_BROWSER_FRAME != ''A'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'The Rejoin Sessions setting of <em>Enabled for All Sessions</em> requires that <strong>Embed In Frames</strong> is set to <em>Allow from same origin</em> or to <em>Deny</em> for the application.'
,p_when_button_pressed=>wwv_flow_imp.id(3048802636097935)
,p_associated_item=>wwv_flow_imp.id(3048059485097927)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(11617497568737343)
,p_validation_name=>'P507_PWA_PUSH_CREDENTIAL_ID is not null'
,p_validation_sequence=>130
,p_validation=>'P507_PWA_PUSH_CREDENTIAL_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P507_PWA_IS_PUSH_ENABLED'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(2600309602453041)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6319573117058612)
,p_name=>'onKeyPress P507_SW_FUNCTION_VARIABLE'
,p_event_sequence=>1
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_SW_FUNCTION_VARIABLE'
,p_condition_element=>'P507_SW_FUNCTION_VARIABLE_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'HOOK'
,p_bind_type=>'bind'
,p_execution_type=>'DEBOUNCE'
,p_execution_time=>100
,p_execution_immediate=>false
,p_bind_event_type=>'keypress'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6319649914058613)
,p_event_id=>wwv_flow_imp.id(6319573117058612)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'sw.preview.functions.hooks();'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'sw.preview.functions.hooks();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2180099907877459)
,p_name=>'onChange P507_IS_PWA = Y'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_IS_PWA'
,p_condition_element=>'P507_IS_PWA'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1451690484584442)
,p_event_id=>wwv_flow_imp.id(2180099907877459)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_name=>'Show Region Installability'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(23101891067504514)
,p_client_condition_type=>'EQUALS'
,p_client_condition_element=>'P507_PWA_IS_INSTALLABLE'
,p_client_condition_expression=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1801308110350503)
,p_event_id=>wwv_flow_imp.id(2180099907877459)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_name=>'Show Region Push Notifications'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1801173018350501)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1451776508584443)
,p_event_id=>wwv_flow_imp.id(2180099907877459)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Show Region Service Worker Configuration'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(23102851875504524)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1452381717584449)
,p_event_id=>wwv_flow_imp.id(2180099907877459)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Region Installability'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(23101891067504514)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1743515070874602)
,p_event_id=>wwv_flow_imp.id(2180099907877459)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_name=>'Show Items P507_PWA_IS_INSTALLABLE'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P507_PWA_IS_INSTALLABLE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1801435156350504)
,p_event_id=>wwv_flow_imp.id(2180099907877459)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Region Push Notifications'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1801173018350501)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1451995966584445)
,p_event_id=>wwv_flow_imp.id(2180099907877459)
,p_event_result=>'FALSE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Region Service Worker Configuration'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(23102851875504524)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1743425993874601)
,p_event_id=>wwv_flow_imp.id(2180099907877459)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_name=>'Show Items P507_PWA_IS_PUSH_ENABLED'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P507_PWA_IS_PUSH_ENABLED'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1743662334874603)
,p_event_id=>wwv_flow_imp.id(2180099907877459)
,p_event_result=>'FALSE'
,p_action_sequence=>60
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Items P507_PWA_IS_INSTALLABLE'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P507_PWA_IS_INSTALLABLE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1743730520874604)
,p_event_id=>wwv_flow_imp.id(2180099907877459)
,p_event_result=>'FALSE'
,p_action_sequence=>70
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Items P507_PWA_IS_PUSH_ENABLED'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P507_PWA_IS_PUSH_ENABLED'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2181917254877460)
,p_name=>'onChange P507_PWA_IS_INSTALLABLE = Y'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_PWA_IS_INSTALLABLE'
,p_condition_element=>'P507_PWA_IS_INSTALLABLE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1451216036584438)
,p_event_id=>wwv_flow_imp.id(2181917254877460)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Region Installability'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(23101891067504514)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2182425233877460)
,p_event_id=>wwv_flow_imp.id(2181917254877460)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show Region Installability'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(23101891067504514)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1801511631350505)
,p_name=>'onChange P507_PWA_IS_PUSH_ENABLED = Y'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_PWA_IS_PUSH_ENABLED'
,p_condition_element=>'P507_PWA_IS_PUSH_ENABLED'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1801721961350507)
,p_event_id=>wwv_flow_imp.id(1801511631350505)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show P507_PWA_PUSH_CREDENTIAL_ID,P507_PWA_PUSH_FEATURE_PAGE,P507_PWA_VAPID_CONTACT_INFO'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P507_PWA_PUSH_CREDENTIAL_ID,P507_PWA_PUSH_FEATURE_PAGE,P507_PWA_VAPID_CONTACT_INFO'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1801655091350506)
,p_event_id=>wwv_flow_imp.id(1801511631350505)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Hide P507_PWA_PUSH_CREDENTIAL_ID,P507_PWA_PUSH_FEATURE_PAGE,P507_PWA_VAPID_CONTACT_INFO'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P507_PWA_PUSH_CREDENTIAL_ID,P507_PWA_PUSH_FEATURE_PAGE,P507_PWA_VAPID_CONTACT_INFO'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7601911292523809)
,p_event_id=>wwv_flow_imp.id(1801511631350505)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Show Button GENERATE_PUSH_CREDENTIALS'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ( apex.items.P507_PWA_PUSH_CREDENTIAL_ID.isEmpty() ) {',
'    $( "#a-pwaGeneratePushCredentials" ).show();',
'    $( "#a-pwaRegeneratePushCredentials" ).hide();',
'} else {',
'    $( "#a-pwaGeneratePushCredentials" ).hide();',
'    $( "#a-pwaRegeneratePushCredentials" ).show();',
'}'))
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7602087518523810)
,p_event_id=>wwv_flow_imp.id(1801511631350505)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Button GENERATE_PUSH_CREDENTIALS'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(1803086861350520)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7602157011523811)
,p_event_id=>wwv_flow_imp.id(1801511631350505)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Show Button ADD_FEATURE_PAGE'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(2401049197642108)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1963074455170502)
,p_event_id=>wwv_flow_imp.id(1801511631350505)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_name=>'Show Button GENERATE_PUSH_CREDENTIALS when P507_PWA_PUSH_CREDENTIAL_ID is null'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(1803086861350520)
,p_client_condition_type=>'NULL'
,p_client_condition_element=>'P507_PWA_PUSH_CREDENTIAL_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2809782121194312)
,p_event_id=>wwv_flow_imp.id(1801511631350505)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Button REGENERATE_PUSH_CREDENTIALS'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(2809641979194311)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7602235629523812)
,p_event_id=>wwv_flow_imp.id(1801511631350505)
,p_event_result=>'FALSE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Button ADD_FEATURE_PAGE'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(2401049197642108)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1963103759170503)
,p_event_id=>wwv_flow_imp.id(1801511631350505)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Button REGENERATE_PUSH_CREDENTIALS when P507_PWA_PUSH_CREDENTIAL_ID is null'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(2809641979194311)
,p_client_condition_type=>'NULL'
,p_client_condition_element=>'P507_PWA_PUSH_CREDENTIAL_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1963414839170506)
,p_event_id=>wwv_flow_imp.id(1801511631350505)
,p_event_result=>'TRUE'
,p_action_sequence=>70
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Button GENERATE_PUSH_CREDENTIALS when P507_PWA_PUSH_CREDENTIAL_ID is not null'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(1803086861350520)
,p_client_condition_type=>'NOT_NULL'
,p_client_condition_element=>'P507_PWA_PUSH_CREDENTIAL_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1963527286170507)
,p_event_id=>wwv_flow_imp.id(1801511631350505)
,p_event_result=>'TRUE'
,p_action_sequence=>80
,p_execute_on_page_init=>'Y'
,p_name=>'Show Button REGENERATE_PUSH_CREDENTIALS when P507_PWA_PUSH_CREDENTIAL_ID is not null'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(2809641979194311)
,p_client_condition_type=>'NOT_NULL'
,p_client_condition_element=>'P507_PWA_PUSH_CREDENTIAL_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2202689998388918)
,p_name=>'onDialogClosed Screenshots'
,p_event_sequence=>100
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(2202389608388915)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2202745700388919)
,p_event_id=>wwv_flow_imp.id(2202689998388918)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_name=>'Refresh Screenshots Report'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2202389608388915)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5402472312685423)
,p_name=>'onDialogClosed Shortcuts'
,p_event_sequence=>110
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(5401963275685418)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5402593149685424)
,p_event_id=>wwv_flow_imp.id(5402472312685423)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_name=>'Refresh Shortcuts Report'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(5401963275685418)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2201426971388906)
,p_name=>'onClick SCREENSHOT_HELP'
,p_event_sequence=>120
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2201330051388905)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2201574459388907)
,p_event_id=>wwv_flow_imp.id(2201426971388906)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2201664938388908)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5401219843685411)
,p_name=>'onClick SHORTCUT_HELP'
,p_event_sequence=>130
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(5401108296685410)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5401378236685412)
,p_event_id=>wwv_flow_imp.id(5401219843685411)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(5401497597685413)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2843880212737906)
,p_name=>'onChange P507_SW_MODE = DEFAULT'
,p_event_sequence=>140
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_SW_MODE'
,p_condition_element=>'P507_SW_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'DEFAULT'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3608086760641521)
,p_event_id=>wwv_flow_imp.id(2843880212737906)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Hide P507_SW_FILE_REFERENCE'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P507_SW_FILE_REFERENCE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1452013219584446)
,p_event_id=>wwv_flow_imp.id(2843880212737906)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Hide .a-SW-Section'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'.a-SW-Section'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3606882050641509)
,p_name=>'onChange P507_SW_MODE = DECLARATIVE'
,p_event_sequence=>150
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_SW_MODE'
,p_condition_element=>'P507_SW_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'DECLARATIVE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3606921594641510)
,p_event_id=>wwv_flow_imp.id(3606882050641509)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show .a-SW-Section'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'.a-SW-Section'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3612431967484604)
,p_event_id=>wwv_flow_imp.id(3606882050641509)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Button DOWNLOAD_HOOKS'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(3612102128484601)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3607009873641511)
,p_event_id=>wwv_flow_imp.id(3606882050641509)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Hide P507_SW_FILE_REFERENCE'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P507_SW_FILE_REFERENCE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3612303149484603)
,p_event_id=>wwv_flow_imp.id(3606882050641509)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Show Button DOWNLOAD_HOOKS'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(3612102128484601)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2419495218768203)
,p_event_id=>wwv_flow_imp.id(3606882050641509)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_name=>'$( ".a-MonacoEditor" ).trigger( "load-resume" );'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'$( ".a-MonacoEditor" ).trigger( "load-resume" );'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3608358468641524)
,p_name=>'onKeyPress P507_SW_INSTALL_*'
,p_event_sequence=>160
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_SW_INSTALL_BEFORE,P507_SW_INSTALL_AFTER'
,p_condition_element=>'P507_SW_INSTALL_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'HOOK'
,p_bind_type=>'bind'
,p_execution_type=>'DEBOUNCE'
,p_execution_time=>100
,p_execution_immediate=>false
,p_bind_event_type=>'keypress'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3608407556641525)
,p_event_id=>wwv_flow_imp.id(3608358468641524)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'sw.preview.install.hooks();'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'sw.preview.install.hooks();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3607520428641516)
,p_name=>'onChange P507_SW_MODE = URL'
,p_event_sequence=>170
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_SW_MODE'
,p_condition_element=>'P507_SW_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'URL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3607343707641514)
,p_event_id=>wwv_flow_imp.id(3607520428641516)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Hide .a-SW-Section'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'.a-SW-Section'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3607485519641515)
,p_event_id=>wwv_flow_imp.id(3607520428641516)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Show P507_SW_FILE_REFERENCE'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P507_SW_FILE_REFERENCE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2419578569768204)
,p_event_id=>wwv_flow_imp.id(3607520428641516)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_name=>'$( ".a-MonacoEditor" ).trigger( "load-resume" );'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'$( ".a-MonacoEditor" ).trigger( "load-resume" );'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3608516184641526)
,p_name=>'onKeyPress P507_SW_INSTALL'
,p_event_sequence=>180
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_SW_INSTALL'
,p_condition_element=>'P507_SW_INSTALL_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'CUSTOM'
,p_bind_type=>'bind'
,p_execution_type=>'DEBOUNCE'
,p_execution_time=>100
,p_execution_immediate=>false
,p_bind_event_type=>'keypress'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3608669954641527)
,p_event_id=>wwv_flow_imp.id(3608516184641526)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'sw.preview.install.custom();'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'sw.preview.install.custom();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2807466466010044)
,p_name=>'onChange P507_SW_FUNCTION_VARIABLE_MODE = DEFAULT'
,p_event_sequence=>190
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_SW_FUNCTION_VARIABLE_MODE'
,p_condition_element=>'P507_SW_FUNCTION_VARIABLE_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'DEFAULT'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2807557481010045)
,p_event_id=>wwv_flow_imp.id(2807466466010044)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Hide P507_SW_FUNCTION_VARIABLE'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P507_SW_FUNCTION_VARIABLE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2807828120010048)
,p_event_id=>wwv_flow_imp.id(2807466466010044)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Region Function and Variable Declaration Preview'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2806645046010036)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3135440705406002)
,p_name=>'onChange P507_SW_FUNCTION_VARIABLE_MODE = HOOK'
,p_event_sequence=>200
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_SW_FUNCTION_VARIABLE_MODE'
,p_condition_element=>'P507_SW_FUNCTION_VARIABLE_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'HOOK'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3135663322406004)
,p_event_id=>wwv_flow_imp.id(3135440705406002)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show P507_SW_FUNCTION_VARIABLE'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P507_SW_FUNCTION_VARIABLE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3136069539406008)
,p_event_id=>wwv_flow_imp.id(3135440705406002)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Show Region Function and Variable Declaration Preview'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2806645046010036)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6319478057058611)
,p_event_id=>wwv_flow_imp.id(3135440705406002)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_name=>'sw.preview.functions.hooks();'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'sw.preview.functions.hooks();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2803249852010002)
,p_name=>'onChange P507_SW_INSTALL_MODE = DEFAULT'
,p_event_sequence=>210
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_SW_INSTALL_MODE'
,p_condition_element=>'P507_SW_INSTALL_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'DEFAULT'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2803321962010003)
,p_event_id=>wwv_flow_imp.id(2803249852010002)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Hide P507_SW_INSTALL_*'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P507_SW_INSTALL,P507_SW_INSTALL_BEFORE,P507_SW_INSTALL_AFTER'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2805309046010023)
,p_event_id=>wwv_flow_imp.id(2803249852010002)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Region Install Preview'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2804150498010011)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2803889126010008)
,p_name=>'onChange P507_SW_INSTALL_MODE = HOOK'
,p_event_sequence=>220
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_SW_INSTALL_MODE'
,p_condition_element=>'P507_SW_INSTALL_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'HOOK'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2803968181010009)
,p_event_id=>wwv_flow_imp.id(2803889126010008)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show P507_SW_INSTALL_*'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P507_SW_INSTALL_BEFORE,P507_SW_INSTALL_AFTER'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2848026146737948)
,p_event_id=>wwv_flow_imp.id(2803889126010008)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Hide P507_SW_INSTALL'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P507_SW_INSTALL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2804793127010017)
,p_event_id=>wwv_flow_imp.id(2803889126010008)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Show Region Install Preview'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2804150498010011)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3608792834641528)
,p_event_id=>wwv_flow_imp.id(2803889126010008)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_name=>'sw.preview.install.hooks();'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'sw.preview.install.hooks();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2803525849010005)
,p_name=>'onChange P507_SW_INSTALL_MODE = CUSTOM'
,p_event_sequence=>230
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_SW_INSTALL_MODE'
,p_condition_element=>'P507_SW_INSTALL_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'CUSTOM'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2803605971010006)
,p_event_id=>wwv_flow_imp.id(2803525849010005)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show P507_SW_INSTALL'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P507_SW_INSTALL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2848128781737949)
,p_event_id=>wwv_flow_imp.id(2803525849010005)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Hide P507_SW_INSTALL_*'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P507_SW_INSTALL_BEFORE,P507_SW_INSTALL_AFTER'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2805633562010026)
,p_event_id=>wwv_flow_imp.id(2803525849010005)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_name=>'Show Region Install Preview'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2804150498010011)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3608809786641529)
,p_event_id=>wwv_flow_imp.id(2803525849010005)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'N'
,p_name=>'sw.preview.install.custom();'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'sw.preview.install.custom();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2845991785737927)
,p_name=>'onChange P507_SW_ACTIVATE_MODE = DEFAULT'
,p_event_sequence=>240
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_SW_ACTIVATE_MODE'
,p_condition_element=>'P507_SW_ACTIVATE_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'DEFAULT'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2846076676737928)
,p_event_id=>wwv_flow_imp.id(2845991785737927)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Hide P507_SW_ACTIVATE_*'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P507_SW_ACTIVATE,P507_SW_ACTIVATE_BEFORE,P507_SW_ACTIVATE_AFTER'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2846372454737931)
,p_event_id=>wwv_flow_imp.id(2845991785737927)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Region Activate Preview'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2845729502737925)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2847243841737940)
,p_name=>'onChange P507_SW_ACTIVATE_MODE = HOOK'
,p_event_sequence=>250
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_SW_ACTIVATE_MODE'
,p_condition_element=>'P507_SW_ACTIVATE_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'HOOK'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2847366832737941)
,p_event_id=>wwv_flow_imp.id(2847243841737940)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show P507_SW_ACTIVATE_*'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P507_SW_ACTIVATE_BEFORE,P507_SW_ACTIVATE_AFTER'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2848290849737950)
,p_event_id=>wwv_flow_imp.id(2847243841737940)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Hide P507_SW_ACTIVATE'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P507_SW_ACTIVATE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2847507762737943)
,p_event_id=>wwv_flow_imp.id(2847243841737940)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Show Region Activate Preview'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2845729502737925)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3609437921641535)
,p_event_id=>wwv_flow_imp.id(2847243841737940)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_name=>'sw.preview.activate.hooks();'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'sw.preview.activate.hooks();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1744319531874610)
,p_name=>'onChange P507_SW_PUSH_MODE = HOOK'
,p_event_sequence=>260
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_SW_PUSH_MODE'
,p_condition_element=>'P507_SW_PUSH_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'HOOK'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1744463117874611)
,p_event_id=>wwv_flow_imp.id(1744319531874610)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show P507_SW_PUSH_*'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P507_SW_PUSH_BEFORE,P507_SW_PUSH_AFTER'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1744530491874612)
,p_event_id=>wwv_flow_imp.id(1744319531874610)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Hide P507_SW_PUSH'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P507_SW_PUSH'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1744683220874613)
,p_event_id=>wwv_flow_imp.id(1744319531874610)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Show Region Push Preview'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3179762164906026)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1744769434874614)
,p_event_id=>wwv_flow_imp.id(1744319531874610)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_name=>'sw.preview.push.hooks();'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'sw.preview.push.hooks();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1745030358874617)
,p_name=>'onChange P507_SW_NOTIFICATIONCLICK_MODE = HOOK'
,p_event_sequence=>270
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_SW_NOTIFICATIONCLICK_MODE'
,p_condition_element=>'P507_SW_NOTIFICATIONCLICK_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'HOOK'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1745152738874618)
,p_event_id=>wwv_flow_imp.id(1745030358874617)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show P507_SW_NOTIFICATIONCLICK_*'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P507_SW_NOTIFICATIONCLICK_BEF,P507_SW_NOTIFICATIONCLICK_AFT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1745258202874619)
,p_event_id=>wwv_flow_imp.id(1745030358874617)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Hide P507_SW_NOTIFICATIONCLICK'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P507_SW_NOTIFICATIONCLICK'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1745335263874620)
,p_event_id=>wwv_flow_imp.id(1745030358874617)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Show Region Notificationclick Preview'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3180270704906031)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1745432276874621)
,p_event_id=>wwv_flow_imp.id(1745030358874617)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_name=>'sw.preview.notificationclick.hooks();'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'sw.preview.notificationclick.hooks();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2846656638737934)
,p_name=>'onChange P507_SW_ACTIVATE_MODE = CUSTOM'
,p_event_sequence=>280
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_SW_ACTIVATE_MODE'
,p_condition_element=>'P507_SW_ACTIVATE_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'CUSTOM'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2846711931737935)
,p_event_id=>wwv_flow_imp.id(2846656638737934)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show P507_SW_ACTIVATE'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P507_SW_ACTIVATE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3135300999406001)
,p_event_id=>wwv_flow_imp.id(2846656638737934)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Hide P507_SW_ACTIVATE_*'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P507_SW_ACTIVATE_BEFORE,P507_SW_ACTIVATE_AFTER'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2847105802737939)
,p_event_id=>wwv_flow_imp.id(2846656638737934)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_name=>'Show Region activate Preview'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2845729502737925)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3609546263641536)
,p_event_id=>wwv_flow_imp.id(2846656638737934)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'N'
,p_name=>'sw.preview.activate.custom();'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'sw.preview.activate.custom();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3609060433641531)
,p_name=>'onKeyPress P507_SW_ACTIVATE_*'
,p_event_sequence=>290
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_SW_ACTIVATE_BEFORE,P507_SW_ACTIVATE_AFTER'
,p_condition_element=>'P507_SW_ACTIVATE_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'HOOK'
,p_bind_type=>'bind'
,p_execution_type=>'DEBOUNCE'
,p_execution_time=>100
,p_execution_immediate=>false
,p_bind_event_type=>'keypress'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3609169151641532)
,p_event_id=>wwv_flow_imp.id(3609060433641531)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'sw.preview.activate.hooks();'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'sw.preview.activate.hooks();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1745515715874622)
,p_name=>'onKeyPress P507_SW_PUSH_*'
,p_event_sequence=>300
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_SW_PUSH_BEFORE,P507_SW_PUSH_AFTER'
,p_condition_element=>'P507_SW_PUSH_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'HOOK'
,p_bind_type=>'bind'
,p_execution_type=>'DEBOUNCE'
,p_execution_time=>100
,p_execution_immediate=>false
,p_bind_event_type=>'keypress'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1745678854874623)
,p_event_id=>wwv_flow_imp.id(1745515715874622)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'sw.preview.push.hooks();'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'sw.preview.push.hooks();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1745758422874624)
,p_name=>'onKeyPress P507_SW_NOTIFICATIONCLICK_*'
,p_event_sequence=>310
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_SW_NOTIFICATIONCLICK_BEF,P507_SW_NOTIFICATIONCLICK_AFT'
,p_condition_element=>'P507_SW_NOTIFICATIONCLICK_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'HOOK'
,p_bind_type=>'bind'
,p_execution_type=>'DEBOUNCE'
,p_execution_time=>100
,p_execution_immediate=>false
,p_bind_event_type=>'keypress'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1745859225874625)
,p_event_id=>wwv_flow_imp.id(1745758422874624)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'sw.preview.notificationclick.hooks();'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'sw.preview.notificationclick.hooks();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3137018824406018)
,p_name=>'onChange P507_SW_FETCH_MODE = DEFAULT'
,p_event_sequence=>320
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_SW_FETCH_MODE'
,p_condition_element=>'P507_SW_FETCH_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'DEFAULT'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3137127842406019)
,p_event_id=>wwv_flow_imp.id(3137018824406018)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Hide P507_SW_FETCH_*'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P507_SW_FETCH,P507_SW_FETCH_BEFORE,P507_SW_FETCH_CACHE_DEFINITION,P507_SW_FETCH_CACHE_RESPONSE,P507_SW_FETCH_NETWORK_RESP_SUC,P507_SW_FETCH_NETWORK_RESP_ERR,P507_SW_FETCH_OFFLINE_PAGE,P507_SW_FETCH_NETWORK_FALLBACK'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3137342344406021)
,p_event_id=>wwv_flow_imp.id(3137018824406018)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Region fetch Preview'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3136847811406016)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3609285861641533)
,p_name=>'onKeyPress P507_SW_ACTIVATE'
,p_event_sequence=>330
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_SW_ACTIVATE'
,p_condition_element=>'P507_SW_ACTIVATE_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'CUSTOM'
,p_bind_type=>'bind'
,p_execution_type=>'DEBOUNCE'
,p_execution_time=>100
,p_execution_immediate=>false
,p_bind_event_type=>'keypress'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3609321222641534)
,p_event_id=>wwv_flow_imp.id(3609285861641533)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'sw.preview.activate.custom();'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'sw.preview.activate.custom();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3610459650641545)
,p_name=>'onKeyPress P507_SW_FETCH_*'
,p_event_sequence=>340
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_SW_FETCH_BEFORE,P507_SW_FETCH_CACHE_DEFINITION,P507_SW_FETCH_CACHE_RESPONSE,P507_SW_FETCH_NETWORK_RESP_SUC,P507_SW_FETCH_NETWORK_RESP_ERR,P507_SW_FETCH_OFFLINE_PAGE,P507_SW_FETCH_NETWORK_FALLBACK'
,p_condition_element=>'P507_SW_FETCH_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'HOOK'
,p_bind_type=>'bind'
,p_execution_type=>'DEBOUNCE'
,p_execution_time=>100
,p_execution_immediate=>false
,p_bind_event_type=>'keypress'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3610528152641546)
,p_event_id=>wwv_flow_imp.id(3610459650641545)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'sw.preview.fetch.hooks();'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'sw.preview.fetch.hooks();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3610609197641547)
,p_name=>'onKeyPress P507_SW_FETCH'
,p_event_sequence=>350
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_SW_FETCH'
,p_condition_element=>'P507_SW_FETCH_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'CUSTOM'
,p_bind_type=>'bind'
,p_execution_type=>'DEBOUNCE'
,p_execution_time=>100
,p_execution_immediate=>false
,p_bind_event_type=>'keypress'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3610745991641548)
,p_event_id=>wwv_flow_imp.id(3610609197641547)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'sw.preview.fetch.custom();'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'sw.preview.fetch.custom();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3610874326641549)
,p_name=>'onKeyPress P507_SW_SYNC'
,p_event_sequence=>360
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_SW_SYNC'
,p_condition_element=>'P507_SW_SYNC_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'CUSTOM'
,p_bind_type=>'bind'
,p_execution_type=>'DEBOUNCE'
,p_execution_time=>100
,p_execution_immediate=>false
,p_bind_event_type=>'keypress'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3610997771641550)
,p_event_id=>wwv_flow_imp.id(3610874326641549)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'sw.preview.sync.custom();'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'sw.preview.sync.custom();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6318431671058601)
,p_name=>'onKeyPress P507_SW_PUSH'
,p_event_sequence=>370
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_SW_PUSH'
,p_condition_element=>'P507_SW_PUSH_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'CUSTOM'
,p_bind_type=>'bind'
,p_execution_type=>'DEBOUNCE'
,p_execution_time=>100
,p_execution_immediate=>false
,p_bind_event_type=>'keypress'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6318517297058602)
,p_event_id=>wwv_flow_imp.id(6318431671058601)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'sw.preview.push.custom();'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'sw.preview.push.custom();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6318627206058603)
,p_name=>'onKeyPress P507_SW_NOTIFICATIONCLICK'
,p_event_sequence=>380
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_SW_NOTIFICATIONCLICK'
,p_condition_element=>'P507_SW_NOTIFICATIONCLICK_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'CUSTOM'
,p_bind_type=>'bind'
,p_execution_type=>'DEBOUNCE'
,p_execution_time=>100
,p_execution_immediate=>false
,p_bind_event_type=>'keypress'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6318722312058604)
,p_event_id=>wwv_flow_imp.id(6318627206058603)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'sw.preview.notificationclick.custom();'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'sw.preview.notificationclick.custom();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6318828555058605)
,p_name=>'onKeyPress P507_SW_NOTIFICATIONCLOSE'
,p_event_sequence=>390
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_SW_NOTIFICATIONCLOSE'
,p_condition_element=>'P507_SW_NOTIFICATIONCLOSE_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'CUSTOM'
,p_bind_type=>'bind'
,p_execution_type=>'DEBOUNCE'
,p_execution_time=>100
,p_execution_immediate=>false
,p_bind_event_type=>'keypress'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6318953508058606)
,p_event_id=>wwv_flow_imp.id(6318828555058605)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'sw.preview.notificationclose.custom();'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'sw.preview.notificationclose.custom();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6319049724058607)
,p_name=>'onKeyPress P507_SW_CANMAKEPAYMENT'
,p_event_sequence=>400
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_SW_CANMAKEPAYMENT'
,p_condition_element=>'P507_SW_CANMAKEPAYMENT_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'CUSTOM'
,p_bind_type=>'bind'
,p_execution_type=>'DEBOUNCE'
,p_execution_time=>100
,p_execution_immediate=>false
,p_bind_event_type=>'keypress'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6319117597058608)
,p_event_id=>wwv_flow_imp.id(6319049724058607)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'sw.preview.canmakepayment.custom();'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'sw.preview.canmakepayment.custom();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6319288324058609)
,p_name=>'onKeyPress P507_SW_PAYMENTREQUEST'
,p_event_sequence=>410
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_SW_PAYMENTREQUEST'
,p_condition_element=>'P507_SW_PAYMENTREQUEST_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'CUSTOM'
,p_bind_type=>'bind'
,p_execution_type=>'DEBOUNCE'
,p_execution_time=>100
,p_execution_immediate=>false
,p_bind_event_type=>'keypress'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6319352158058610)
,p_event_id=>wwv_flow_imp.id(6319288324058609)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'sw.preview.paymentrequest.custom();'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'sw.preview.paymentrequest.custom();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3137547879406023)
,p_name=>'onChange P507_SW_FETCH_MODE = HOOK'
,p_event_sequence=>420
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_SW_FETCH_MODE'
,p_condition_element=>'P507_SW_FETCH_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'HOOK'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3137616259406024)
,p_event_id=>wwv_flow_imp.id(3137547879406023)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show P507_SW_FETCH_*'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P507_SW_FETCH_BEFORE,P507_SW_FETCH_CACHE_DEFINITION,P507_SW_FETCH_CACHE_RESPONSE,P507_SW_FETCH_NETWORK_RESP_SUC,P507_SW_FETCH_NETWORK_RESP_ERR,P507_SW_FETCH_OFFLINE_PAGE,P507_SW_FETCH_NETWORK_FALLBACK'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3137780134406025)
,p_event_id=>wwv_flow_imp.id(3137547879406023)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Hide P507_SW_FETCH'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P507_SW_FETCH'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3137888591406026)
,p_event_id=>wwv_flow_imp.id(3137547879406023)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Show Region fetch Preview'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3136847811406016)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3609646005641537)
,p_event_id=>wwv_flow_imp.id(3137547879406023)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'sw.preview.fetch.hooks();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3138142354406029)
,p_name=>'onChange P507_SW_FETCH_MODE = CUSTOM'
,p_event_sequence=>430
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_SW_FETCH_MODE'
,p_condition_element=>'P507_SW_FETCH_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'CUSTOM'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3138298164406030)
,p_event_id=>wwv_flow_imp.id(3138142354406029)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show P507_SW_FETCH'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P507_SW_FETCH'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3138386082406031)
,p_event_id=>wwv_flow_imp.id(3138142354406029)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Hide P507_SW_FETCH_*'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P507_SW_FETCH_BEFORE,P507_SW_FETCH_CACHE_DEFINITION,P507_SW_FETCH_CACHE_RESPONSE,P507_SW_FETCH_NETWORK_RESP_SUC,P507_SW_FETCH_NETWORK_RESP_ERR,P507_SW_FETCH_OFFLINE_PAGE,P507_SW_FETCH_NETWORK_FALLBACK'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3138650807406034)
,p_event_id=>wwv_flow_imp.id(3138142354406029)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_name=>'Show Region fetch Preview'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3136847811406016)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3609731181641538)
,p_event_id=>wwv_flow_imp.id(3138142354406029)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'N'
,p_name=>'sw.preview.fetch.custom();'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'sw.preview.fetch.custom();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3177731714906006)
,p_name=>'onChange P507_SW_SYNC_MODE = DEFAULT'
,p_event_sequence=>440
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_SW_SYNC_MODE'
,p_condition_element=>'P507_SW_SYNC_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'DEFAULT'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3177833130906007)
,p_event_id=>wwv_flow_imp.id(3177731714906006)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Hide P507_SW_SYNC'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P507_SW_SYNC'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3178097008906009)
,p_event_id=>wwv_flow_imp.id(3177731714906006)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Region sync Preview'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3177642735906005)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3178288342906011)
,p_name=>'onChange P507_SW_SYNC_MODE = CUSTOM'
,p_event_sequence=>450
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_SW_SYNC_MODE'
,p_condition_element=>'P507_SW_SYNC_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'CUSTOM'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3178328201906012)
,p_event_id=>wwv_flow_imp.id(3178288342906011)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show P507_SW_SYNC'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P507_SW_SYNC'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3178545433906014)
,p_event_id=>wwv_flow_imp.id(3178288342906011)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Show Region sync Preview'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3177642735906005)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3609851863641539)
,p_event_id=>wwv_flow_imp.id(3178288342906011)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_name=>'sw.preview.sync.custom();'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'sw.preview.sync.custom();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3226577711215309)
,p_name=>'onChange P507_SW_PUSH_MODE = DEFAULT'
,p_event_sequence=>460
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_SW_PUSH_MODE'
,p_condition_element=>'P507_SW_PUSH_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'DEFAULT'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3226685789215310)
,p_event_id=>wwv_flow_imp.id(3226577711215309)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Hide P507_SW_PUSH_*'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P507_SW_PUSH,P507_SW_PUSH_BEFORE,P507_SW_PUSH_AFTER'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3226806371215312)
,p_event_id=>wwv_flow_imp.id(3226577711215309)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Region Push Preview'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3179762164906026)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3226997446215313)
,p_name=>'onChange P507_SW_PUSH_MODE = CUSTOM'
,p_event_sequence=>470
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_SW_PUSH_MODE'
,p_condition_element=>'P507_SW_PUSH_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'CUSTOM'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(10408823511693202)
,p_event_id=>wwv_flow_imp.id(3226997446215313)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Hide P507_SW_PUSH_*'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P507_SW_PUSH_BEFORE,P507_SW_PUSH_AFTER'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3227082127215314)
,p_event_id=>wwv_flow_imp.id(3226997446215313)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Show P507_SW_PUSH'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P507_SW_PUSH'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3227154275215315)
,p_event_id=>wwv_flow_imp.id(3226997446215313)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Show Region Push Preview'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3179762164906026)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3609935367641540)
,p_event_id=>wwv_flow_imp.id(3226997446215313)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_name=>'sw.preview.push.custom();'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'sw.preview.push.custom();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3227307764215317)
,p_name=>'onChange P507_SW_NOTIFICATIONCLICK_MODE = DEFAULT'
,p_event_sequence=>480
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_SW_NOTIFICATIONCLICK_MODE'
,p_condition_element=>'P507_SW_NOTIFICATIONCLICK_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'DEFAULT'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3227406048215318)
,p_event_id=>wwv_flow_imp.id(3227307764215317)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Hide P507_SW_NOTIFICATIONCLICK*'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P507_SW_NOTIFICATIONCLICK,P507_SW_NOTIFICATIONCLICK_BEF,P507_SW_NOTIFICATIONCLICK_AFT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3227622998215320)
,p_event_id=>wwv_flow_imp.id(3227307764215317)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Region Notificationclick Preview'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3180270704906031)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3227769884215321)
,p_name=>'onChange P507_SW_NOTIFICATIONCLICK_MODE = CUSTOM'
,p_event_sequence=>490
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_SW_NOTIFICATIONCLICK_MODE'
,p_condition_element=>'P507_SW_NOTIFICATIONCLICK_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'CUSTOM'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(10409006406693204)
,p_event_id=>wwv_flow_imp.id(3227769884215321)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Hide P507_SW_NOTIFICATIONCLICK*'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P507_SW_NOTIFICATIONCLICK_BEF,P507_SW_NOTIFICATIONCLICK_AFT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3227832569215322)
,p_event_id=>wwv_flow_imp.id(3227769884215321)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Show P507_SW_NOTIFICATIONCLICK'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P507_SW_NOTIFICATIONCLICK'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3227920060215323)
,p_event_id=>wwv_flow_imp.id(3227769884215321)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Show Region Notificationclick Preview'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3180270704906031)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3610284861641543)
,p_event_id=>wwv_flow_imp.id(3227769884215321)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_name=>'sw.preview.notificationclick.custom();'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'sw.preview.notificationclick.custom();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3228192637215325)
,p_name=>'onChange P507_SW_NOTIFICATIONCLOSE_MODE = DEFAULT'
,p_event_sequence=>500
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_SW_NOTIFICATIONCLOSE_MODE'
,p_condition_element=>'P507_SW_NOTIFICATIONCLOSE_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'DEFAULT'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3228212010215326)
,p_event_id=>wwv_flow_imp.id(3228192637215325)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Hide P507_SW_NOTIFICATIONCLOSE'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P507_SW_NOTIFICATIONCLOSE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3228411591215328)
,p_event_id=>wwv_flow_imp.id(3228192637215325)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Region notificationclose Preview'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3180731450906036)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3228570159215329)
,p_name=>'onChange P507_SW_NOTIFICATIONCLOSE_MODE = CUSTOM'
,p_event_sequence=>510
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_SW_NOTIFICATIONCLOSE_MODE'
,p_condition_element=>'P507_SW_NOTIFICATIONCLOSE_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'CUSTOM'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3228672932215330)
,p_event_id=>wwv_flow_imp.id(3228570159215329)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show P507_SW_NOTIFICATIONCLOSE'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P507_SW_NOTIFICATIONCLOSE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3228784119215331)
,p_event_id=>wwv_flow_imp.id(3228570159215329)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Show Region notificationclose Preview'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3180731450906036)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3610116476641542)
,p_event_id=>wwv_flow_imp.id(3228570159215329)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_name=>'sw.preview.notificationclose.custom();'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'sw.preview.notificationclose.custom();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3228973869215333)
,p_name=>'onChange P507_SW_CANMAKEPAYMENT_MODE = DEFAULT'
,p_event_sequence=>520
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_SW_CANMAKEPAYMENT_MODE'
,p_condition_element=>'P507_SW_CANMAKEPAYMENT_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'DEFAULT'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3229013088215334)
,p_event_id=>wwv_flow_imp.id(3228973869215333)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Hide P507_SW_CANMAKEPAYMENT'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P507_SW_CANMAKEPAYMENT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3229221450215336)
,p_event_id=>wwv_flow_imp.id(3228973869215333)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Region canmakepayment Preview'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3181261319906041)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3229329751215337)
,p_name=>'onChange P507_SW_CANMAKEPAYMENT_MODE = CUSTOM'
,p_event_sequence=>530
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_SW_CANMAKEPAYMENT_MODE'
,p_condition_element=>'P507_SW_CANMAKEPAYMENT_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'CUSTOM'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3229463046215338)
,p_event_id=>wwv_flow_imp.id(3229329751215337)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show P507_SW_CANMAKEPAYMENT'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P507_SW_CANMAKEPAYMENT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3229557831215339)
,p_event_id=>wwv_flow_imp.id(3229329751215337)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Show Region canmakepayment Preview'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3181261319906041)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3610026017641541)
,p_event_id=>wwv_flow_imp.id(3229329751215337)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_name=>'sw.preview.canmakepayment.custom();'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'sw.preview.canmakepayment.custom();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3229739524215341)
,p_name=>'onChange P507_SW_PAYMENTREQUEST_MODE = DEFAULT'
,p_event_sequence=>540
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_SW_PAYMENTREQUEST_MODE'
,p_condition_element=>'P507_SW_PAYMENTREQUEST_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'DEFAULT'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3229835906215342)
,p_event_id=>wwv_flow_imp.id(3229739524215341)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Hide P507_SW_PAYMENTREQUEST'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P507_SW_PAYMENTREQUEST'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3230079155215344)
,p_event_id=>wwv_flow_imp.id(3229739524215341)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Region Payment Request Preview'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3181766600906046)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3230112104215345)
,p_name=>'onChange P507_SW_PAYMENTREQUEST_MODE = CUSTOM'
,p_event_sequence=>550
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_SW_PAYMENTREQUEST_MODE'
,p_condition_element=>'P507_SW_PAYMENTREQUEST_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'CUSTOM'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3230231447215346)
,p_event_id=>wwv_flow_imp.id(3230112104215345)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show P507_SW_PAYMENTREQUEST'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P507_SW_PAYMENTREQUEST'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3230320007215347)
,p_event_id=>wwv_flow_imp.id(3230112104215345)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Show Region Payment Request Preview'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3181766600906046)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3610370394641544)
,p_event_id=>wwv_flow_imp.id(3230112104215345)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_name=>'sw.preview.paymentrequest.custom();'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'sw.preview.paymentrequest.custom();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1447720310584403)
,p_name=>'onClick HELP_INSTALL'
,p_event_sequence=>560
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1447588646584401)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1447884441584404)
,p_event_id=>wwv_flow_imp.id(1447720310584403)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1447696670584402)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1449507384584421)
,p_name=>'onClick HELP_ACTIVATE'
,p_event_sequence=>570
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1447902101584405)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1449652447584422)
,p_event_id=>wwv_flow_imp.id(1449507384584421)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1448731379584413)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1449738312584423)
,p_name=>'onClick HELP_FETCH'
,p_event_sequence=>580
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1448241515584408)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1449895935584424)
,p_event_id=>wwv_flow_imp.id(1449738312584423)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1449046848584416)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1449900410584425)
,p_name=>'onClick HELP_SYNC'
,p_event_sequence=>590
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1448092376584406)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1450092736584426)
,p_event_id=>wwv_flow_imp.id(1449900410584425)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1449136594584417)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1450188348584427)
,p_name=>'onClick HELP_NOTIFICATIONCLOSE'
,p_event_sequence=>600
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1448479501584410)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1450268037584428)
,p_event_id=>wwv_flow_imp.id(1450188348584427)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1449367005584419)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1450349752584429)
,p_name=>'onClick HELP_CANMAKEPAYMENT'
,p_event_sequence=>610
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1448596184584411)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1450448875584430)
,p_event_id=>wwv_flow_imp.id(1450349752584429)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1449244061584418)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1450545317584431)
,p_name=>'onClick HELP_NOTIFICATIONCLICK'
,p_event_sequence=>620
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1448109222584407)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1450641624584432)
,p_event_id=>wwv_flow_imp.id(1450545317584431)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1448945715584415)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1450727334584433)
,p_name=>'onClick HELP_PUSH'
,p_event_sequence=>630
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1448300678584409)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1450837745584434)
,p_event_id=>wwv_flow_imp.id(1450727334584433)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1448825540584414)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1450943227584435)
,p_name=>'onClick HELP_PAYMENTREQUEST'
,p_event_sequence=>640
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1448653750584412)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1451089198584436)
,p_event_id=>wwv_flow_imp.id(1450943227584435)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1449497849584420)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3612998905484609)
,p_name=>'onClick DOWNLOAD_HOOKS'
,p_event_sequence=>650
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3612102128484601)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3613066972484610)
,p_event_id=>wwv_flow_imp.id(3612998905484609)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_name=>'Download file'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'const link = document.createElement("a");',
'link.href = apex.items.P507_SW_HOOKS_URL.value;',
'link.download = "sw-hooks.js";',
'link.click();'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6008311083664815)
,p_name=>'onDialogClosed ADD_SCREENSHOT'
,p_event_sequence=>660
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2201098733388902)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6008453247664816)
,p_event_id=>wwv_flow_imp.id(6008311083664815)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_name=>'Refresh Screenshots Report'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2202389608388915)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6008546828664817)
,p_name=>'onDialogClosed ADD_SCREENSHOT_FIRST'
,p_event_sequence=>670
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2202082763388912)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6008675660664818)
,p_event_id=>wwv_flow_imp.id(6008546828664817)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_name=>'location.reload();'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'location.reload();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6008746052664819)
,p_name=>'onDialogClosed ADD_SHORTCUT'
,p_event_sequence=>680
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(5400812211685407)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6008856904664820)
,p_event_id=>wwv_flow_imp.id(6008746052664819)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_name=>'Refresh Shortcuts Report'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(5401963275685418)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6008963833664821)
,p_name=>'onDialogClosed ADD_SHORTCUT_FIRST'
,p_event_sequence=>690
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(5401652220685415)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6009087945664822)
,p_event_id=>wwv_flow_imp.id(6008963833664821)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_name=>'location.reload();'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'location.reload();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(7010180680227201)
,p_name=>'afterRefresh ScreenshotsReport'
,p_event_sequence=>700
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(2202389608388915)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7010248774227202)
,p_event_id=>wwv_flow_imp.id(7010180680227201)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show aspect ratio (if needed)'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'const getAspectRatio = (image) => {',
'    return (image.naturalWidth / image.naturalHeight).toFixed(2);',
'}; ',
'',
'setTimeout(() => {',
'    const images = $(".a-PWAScreenshot-preview").get();',
'    const ratios = images.map(image => getAspectRatio(image));',
'    const allEqual = ratios.every(v => v === ratios[0]);',
'    if (!allEqual) {',
'        $(apex.region("ScreenshotsRatio")?.element).show();',
'        images.forEach((image) => {',
'            let ratioEl = $(image).closest("tr").find(".a-PWAScreenshot-preview--ratio");',
'            ratioEl.html(`<span class="a-Alert-icon a-Icon icon-warning"></span> <span class="">${image.naturalWidth}x${image.naturalHeight} (${getAspectRatio(image)})</span>`)',
'        });',
'    } else {',
'        $(apex.region("ScreenshotsRatio")?.element).hide();',
'        $(".a-PWAScreenshot-preview--ratio").html("");',
'    }',
'}, 1000);'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2419807207768207)
,p_name=>'onChange P507_PWA_MANIFEST_THEME_COLORP'
,p_event_sequence=>710
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_PWA_MANIFEST_THEME_COLORP'
,p_condition_element=>'P507_PWA_MANIFEST_THEME_COLORP'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'CUSTOM'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2419930356768208)
,p_event_id=>wwv_flow_imp.id(2419807207768207)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Remove Class u-hidden to #P507_PWA_MANIFEST_THEME_COLOR_CONTAINER'
,p_action=>'NATIVE_REMOVE_CLASS'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'#P507_PWA_MANIFEST_THEME_COLOR_CONTAINER'
,p_attribute_01=>'u-hidden'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2420861395768217)
,p_event_id=>wwv_flow_imp.id(2419807207768207)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Add Class u-hidden to #P507_PWA_MANIFEST_THEME_COLOR_CONTAINER'
,p_action=>'NATIVE_ADD_CLASS'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'#P507_PWA_MANIFEST_THEME_COLOR_CONTAINER'
,p_attribute_01=>'u-hidden'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2420154839768210)
,p_name=>'onChange P507_PWA_MANIFEST_BG_COLORP'
,p_event_sequence=>720
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_PWA_MANIFEST_BG_COLORP'
,p_condition_element=>'P507_PWA_MANIFEST_BG_COLORP'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'CUSTOM'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2420219288768211)
,p_event_id=>wwv_flow_imp.id(2420154839768210)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Remove Class u-hidden to #P507_PWA_BACKGROUND_COLOR_CONTAINER'
,p_action=>'NATIVE_REMOVE_CLASS'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'#P507_PWA_BACKGROUND_COLOR_CONTAINER'
,p_attribute_01=>'u-hidden'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2420900975768218)
,p_event_id=>wwv_flow_imp.id(2420154839768210)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Add Class u-hidden to #P507_PWA_BACKGROUND_COLOR_CONTAINER'
,p_action=>'NATIVE_ADD_CLASS'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'#P507_PWA_BACKGROUND_COLOR_CONTAINER'
,p_attribute_01=>'u-hidden'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2401859991642116)
,p_name=>'onChange P507_PWA_PUSH_CREDENTIAL_ID is null'
,p_event_sequence=>730
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P507_PWA_PUSH_CREDENTIAL_ID'
,p_condition_element=>'P507_PWA_PUSH_CREDENTIAL_ID'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2401943982642117)
,p_event_id=>wwv_flow_imp.id(2401859991642116)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show Button GENERATE_PUSH_CREDENTIALS'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(1803086861350520)
,p_client_condition_type=>'EQUALS'
,p_client_condition_element=>'P507_PWA_IS_PUSH_ENABLED'
,p_client_condition_expression=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2402075284642118)
,p_event_id=>wwv_flow_imp.id(2401859991642116)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Button GENERATE_PUSH_CREDENTIALS'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(1803086861350520)
,p_client_condition_type=>'EQUALS'
,p_client_condition_element=>'P507_PWA_IS_PUSH_ENABLED'
,p_client_condition_expression=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2809804660194313)
,p_event_id=>wwv_flow_imp.id(2401859991642116)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Button REGENERATE_PUSH_CREDENTIALS'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(2809641979194311)
,p_client_condition_type=>'EQUALS'
,p_client_condition_element=>'P507_PWA_IS_PUSH_ENABLED'
,p_client_condition_expression=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2809990695194314)
,p_event_id=>wwv_flow_imp.id(2401859991642116)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Show Button REGENERATE_PUSH_CREDENTIALS'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(2809641979194311)
,p_client_condition_type=>'EQUALS'
,p_client_condition_element=>'P507_PWA_IS_PUSH_ENABLED'
,p_client_condition_expression=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2402460913642122)
,p_name=>'onDialogClosed ADD_FEATURE_PAGE'
,p_event_sequence=>740
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2401049197642108)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2402591355642123)
,p_event_id=>wwv_flow_imp.id(2402460913642122)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P507_PWA_PUSH_FEATURE_PAGE'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select p.id || ''. '' || p.name',
'  from wwv_flow_steps p,',
'       wwv_flow_patches pa',
' where p.flow_id             = :FB_FLOW_ID',
'   and p.security_group_id   = :WORKSPACE_ID',
'   and pa.security_group_id  = p.security_group_id',
'   and pa.flow_id            = p.flow_id',
'   and pa.id                 = p.required_patch',
'   and pa.feature_identifier = ''APPLICATION_PUSH_NOTIFICATIONS'''))
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(10408768151693201)
,p_event_id=>wwv_flow_imp.id(2402460913642122)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_name=>'Hide Button ADD_FEATURE_PAGE'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(2401049197642108)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(64313520218720245)
,p_name=>'afterRefresh Shortcuts Report'
,p_event_sequence=>760
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(5401963275685418)
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$("#ShortcutsReport tbody tr").length > 10'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(64313678255720246)
,p_event_id=>wwv_flow_imp.id(64313520218720245)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(64313240212720242)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(64313863298720248)
,p_event_id=>wwv_flow_imp.id(64313520218720245)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(64313240212720242)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2170843534877450)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'post validation computations'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- this is required to reset the item to null, due to the page validation forcing Y or N',
':P507_PWA_IS_INSTALLABLE := null;',
':P507_PWA_IS_PUSH_ENABLED := null;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P507_IS_PWA'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'N'
,p_internal_uid=>2170843534877450
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2193639810144801)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'generate push credentials'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P507_PWA_PUSH_CREDENTIAL_ID := wwv_flow_pwa_dev.generate_push_credentials( ',
'                                    p_application_id => :FB_FLOW_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'GENERATE_PUSH_CREDENTIALS'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>2193639810144801
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2007594919982401)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'regenerate push credentials'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P507_PWA_PUSH_CREDENTIAL_ID := wwv_flow_pwa_dev.generate_push_credentials( ',
'                                    p_application_id => :FB_FLOW_ID,',
'                                    p_credential_id  => :P507_PWA_PUSH_CREDENTIAL_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'REGENERATE_PUSH_CREDENTIALS'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>2007594919982401
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3048553450097932)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'ENABLE_REJOIN_SESSIONS_ALL'
,p_process_sql_clob=>':P507_REJOIN_EXISTING_SESSIONS := ''Y'';'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3048802636097935)
,p_internal_uid=>3048553450097932
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3048732614097934)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'ENABLE_REJOIN_SESSIONS_PUBLIC'
,p_process_sql_clob=>':P507_REJOIN_EXISTING_SESSIONS := ''P'';'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3047967767097926)
,p_internal_uid=>3048732614097934
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2170036319877449)
,p_process_sequence=>80
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove pwa install list entry'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_pwa_dev.delete_pwa_install_list_entry (',
'    p_application_id => :FB_FLOW_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flows',
' where coalesce( :P507_PWA_IS_INSTALLABLE, ''N'' ) = ''N'' -- set to remove PWA',
'   and pwa_is_installable                        = ''Y'' -- app is curently a pwa',
'   and security_group_id                         = :WORKSPACE_ID',
'   and id                                        = :FB_FLOW_ID'))
,p_process_when_type=>'EXISTS'
,p_internal_uid=>2170036319877449
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2170460489877450)
,p_process_sequence=>90
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add pwa install list entry'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_pwa_dev.create_pwa_install_list_entry (',
'    p_application_id => :FB_FLOW_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flows',
' where coalesce( :P507_PWA_IS_INSTALLABLE, ''N'' ) = ''Y'' -- set to add PWA',
'   and coalesce( pwa_is_installable,       ''N'' ) = ''N'' -- app is not curently a pwa',
'   and security_group_id                         = :WORKSPACE_ID',
'   and id                                        = :FB_FLOW_ID'))
,p_process_when_type=>'EXISTS'
,p_internal_uid=>2170460489877450
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3230504125215349)
,p_process_sequence=>100
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save service worker'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_pwa_dev.save_service_worker( ',
'    p_application_id            => :FB_FLOW_ID,',
'    p_is_pwa                    => :P507_IS_PWA,',
'    p_sw_mode                   => :P507_SW_MODE,',
'    p_sw_file_reference         => :P507_SW_FILE_REFERENCE,',
'    p_sw_function_variable_mode => :P507_SW_FUNCTION_VARIABLE_MODE,',
'    p_sw_function_variable      => :P507_SW_FUNCTION_VARIABLE,',
'    p_sw_install_mode           => :P507_SW_INSTALL_MODE,',
'    p_sw_install_before         => :P507_SW_INSTALL_BEFORE,',
'    p_sw_install_after          => :P507_SW_INSTALL_AFTER,',
'    p_sw_install                => :P507_SW_INSTALL,',
'    p_sw_activate_mode          => :P507_SW_ACTIVATE_MODE,',
'    p_sw_activate_before        => :P507_SW_ACTIVATE_BEFORE,',
'    p_sw_activate_after         => :P507_SW_ACTIVATE_AFTER,',
'    p_sw_activate               => :P507_SW_ACTIVATE,',
'    p_sw_fetch_mode             => :P507_SW_FETCH_MODE,',
'    p_sw_fetch_before           => :P507_SW_FETCH_BEFORE,',
'    p_sw_fetch_cache_definition => :P507_SW_FETCH_CACHE_DEFINITION,',
'    p_sw_fetch_cache_response   => :P507_SW_FETCH_CACHE_RESPONSE,',
'    p_sw_fetch_network_resp_suc => :P507_SW_FETCH_NETWORK_RESP_SUC,',
'    p_sw_fetch_network_resp_err => :P507_SW_FETCH_NETWORK_RESP_ERR,',
'    p_sw_fetch_offline_page     => :P507_SW_FETCH_OFFLINE_PAGE,',
'    p_sw_fetch_network_fallback => :P507_SW_FETCH_NETWORK_FALLBACK,',
'    p_sw_fetch                  => :P507_SW_FETCH,',
'    p_sw_sync_mode              => :P507_SW_SYNC_MODE,',
'    p_sw_sync                   => :P507_SW_SYNC,',
'    p_sw_push_mode              => :P507_SW_PUSH_MODE,',
'    p_sw_push                   => :P507_SW_PUSH,',
'    p_sw_push_before            => :P507_SW_PUSH_BEFORE,',
'    p_sw_push_after             => :P507_SW_PUSH_AFTER,',
'    p_sw_notificationclick_mode => :P507_SW_NOTIFICATIONCLICK_MODE,',
'    p_sw_notificationclick      => :P507_SW_NOTIFICATIONCLICK,',
'    p_sw_notificationclick_bef  => :P507_SW_NOTIFICATIONCLICK_BEF,',
'    p_sw_notificationclick_aft  => :P507_SW_NOTIFICATIONCLICK_AFT,',
'    p_sw_notificationclose_mode => :P507_SW_NOTIFICATIONCLOSE_MODE,',
'    p_sw_notificationclose      => :P507_SW_NOTIFICATIONCLOSE,',
'    p_sw_canmakepayment_mode    => :P507_SW_CANMAKEPAYMENT_MODE,',
'    p_sw_canmakepayment         => :P507_SW_CANMAKEPAYMENT,',
'    p_sw_paymentrequest_mode    => :P507_SW_PAYMENTREQUEST_MODE,',
'    p_sw_paymentrequest         => :P507_SW_PAYMENTREQUEST );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2102037359877353)
,p_internal_uid=>3230504125215349
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(11617169389737340)
,p_process_sequence=>110
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(10409147636693205)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process Form'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'N'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Progressive Web App updated.'
,p_internal_uid=>11617169389737340
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(10409237096693206)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(10409147636693205)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize Form'
,p_internal_uid=>10409237096693206
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2804947346010019)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Init Service Worker'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_pwa_dev.init_service_worker (',
'    p_application_id               => :FB_FLOW_ID,',
'    p_sw_mode                      => :P507_SW_MODE,',
'    p_sw_hooks_url                 => :P507_SW_HOOKS_URL,',
'    p_sw_function_variable_mode    => :P507_SW_FUNCTION_VARIABLE_MODE,',
'    p_sw_install_mode              => :P507_SW_INSTALL_MODE,',
'    p_sw_activate_mode             => :P507_SW_ACTIVATE_MODE,',
'    p_sw_fetch_mode                => :P507_SW_FETCH_MODE,',
'    p_sw_sync_mode                 => :P507_SW_SYNC_MODE,',
'    p_sw_push_mode                 => :P507_SW_PUSH_MODE,',
'    p_sw_notificationclick_mode    => :P507_SW_NOTIFICATIONCLICK_MODE,',
'    p_sw_notificationclose_mode    => :P507_SW_NOTIFICATIONCLOSE_MODE,',
'    p_sw_canmakepayment_mode       => :P507_SW_CANMAKEPAYMENT_MODE,',
'    p_sw_paymentrequest_mode       => :P507_SW_PAYMENTREQUEST_MODE,',
'    p_file_reference               => :P507_SW_FILE_REFERENCE,',
'    p_funct_variable_declaration   => :P507_SW_FUNCTION_VARIABLE,',
'    p_event_install                => :P507_SW_INSTALL,',
'    p_event_install_before         => :P507_SW_INSTALL_BEFORE,',
'    p_event_install_after          => :P507_SW_INSTALL_AFTER,',
'    p_event_activate               => :P507_SW_ACTIVATE,',
'    p_event_activate_before        => :P507_SW_ACTIVATE_BEFORE,',
'    p_event_activate_after         => :P507_SW_ACTIVATE_AFTER,',
'    p_event_fetch                  => :P507_SW_FETCH,',
'    p_event_fetch_before           => :P507_SW_FETCH_BEFORE,',
'    p_event_fetch_cache_definition => :P507_SW_FETCH_CACHE_DEFINITION,',
'    p_event_fetch_cache_response   => :P507_SW_FETCH_CACHE_RESPONSE,',
'    p_event_fetch_network_resp_suc => :P507_SW_FETCH_NETWORK_RESP_SUC,',
'    p_event_fetch_network_resp_err => :P507_SW_FETCH_NETWORK_RESP_ERR,',
'    p_event_fetch_offline_page     => :P507_SW_FETCH_OFFLINE_PAGE,',
'    p_event_fetch_network_fallback => :P507_SW_FETCH_NETWORK_FALLBACK,',
'    p_event_sync                   => :P507_SW_SYNC,',
'    p_event_push                   => :P507_SW_PUSH,',
'    p_event_push_before            => :P507_SW_PUSH_BEFORE,',
'    p_event_push_after             => :P507_SW_PUSH_AFTER,',
'    p_event_notificationclick      => :P507_SW_NOTIFICATIONCLICK,',
'    p_event_notificationclick_bef  => :P507_SW_NOTIFICATIONCLICK_BEF,',
'    p_event_notificationclick_aft  => :P507_SW_NOTIFICATIONCLICK_AFT,',
'    p_event_notificationclose      => :P507_SW_NOTIFICATIONCLOSE,',
'    p_event_canmakepayment         => :P507_SW_CANMAKEPAYMENT,',
'    p_event_paymentrequest         => :P507_SW_PAYMENTREQUEST );'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>2804947346010019
);
end;
/
prompt --application/pages/page_00508
begin
wwv_flow_imp_page.create_page(
 p_id=>508
,p_name=>'PWA Shortcut'
,p_alias=>'PWA-SHORTCUT'
,p_page_mode=>'MODAL'
,p_step_title=>'PWA Shortcut'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_javascript_file_urls=>'#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#widget.cropperEditor#MIN#.js'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'const saveIcon = async function () {',
'    const opts = {',
'        width: 192,',
'        height: 192',
'    };',
'    ',
'    if ( !apex.items.P508_FILE_BROWSE_MIME_TYPE.isEmpty ) {',
'        opts.fileType = apex.items.P508_FILE_BROWSE_MIME_TYPE.value;',
'    }',
'',
'    await apex.server.process(''save_shortcut'', {',
'        x01: apex.items.P508_DISPLAY_SEQUENCE.value,',
'        x02: apex.items.P508_FILE_BROWSE_MIME_TYPE.value,',
'        p_clob_01: apex.cropperEditor.getDataURL(opts).split('';base64,'')[1]',
'    });',
'};'))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#P508_DISPLAY_SHORTCUT {',
'    max-height: 300px;',
'}',
'',
'.cropper-container {',
'    max-width: 100%;',
'    max-height: 350px;',
'}'))
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'590'
,p_dialog_width=>'800'
,p_protection_level=>'C'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5402899846685427)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11363387639866135)
,p_plug_name=>'Crop Shortcut Help'
,p_region_template_options=>'#DEFAULT#:js-dialog-size600x400'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(557449278618308550)
,p_plug_display_sequence=>30
,p_plug_source=>'sys.htp.p(wwv_flow_lang.message(''PWA.SHORTCUT.CROPPER.HELPTEXT''));'
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(73940016032235909)
,p_plug_name=>'Shortcuts'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_PWA_SHORTCUTS'
,p_include_rowid_column=>false
,p_is_editable=>false
,p_plug_source_type=>'NATIVE_FORM'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1812341612588301)
,p_plug_name=>'Cropper Buttons'
,p_parent_plug_id=>wwv_flow_imp.id(73940016032235909)
,p_region_css_classes=>'u-textCenter'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Form--labelsAbove:a-Region--noPadding:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11360755862866109)
,p_plug_name=>'Shortcut Data'
,p_parent_plug_id=>wwv_flow_imp.id(73940016032235909)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--slimPadding:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>80
,p_plug_grid_column_span=>7
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11362220079866124)
,p_plug_name=>'Shortcut Image'
,p_parent_plug_id=>wwv_flow_imp.id(73940016032235909)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Form--labelsAbove:a-Region--slimPadding:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_column_width=>'shortcut-align'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5402910335685428)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(1812341612588301)
,p_button_name=>'HELP'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Help'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P508_INIT_CROPPER_YN'
,p_button_condition2=>'Y'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_button_css_classes=>'a-Button--noUI'
,p_icon_css_classes=>'icon-help'
,p_grid_new_row=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(11361545123866117)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(1812341612588301)
,p_button_name=>'RESET'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P508_INIT_CROPPER_YN'
,p_button_condition2=>'Y'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_button_css_classes=>'a-Button--noUI'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(11361432659866116)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(5402899846685427)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_confirm_message=>'Delete this shortcut?'
,p_confirm_style=>'warning'
,p_button_condition=>'P508_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(11363724658866139)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(5402899846685427)
,p_button_name=>'CREATE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>':p508_id is null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5403080113685429)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(5402899846685427)
,p_button_name=>'SAVE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>':p508_id is not null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5404809567685447)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(5402899846685427)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>':p508_id is not null or :P508_INIT_CROPPER_YN = ''N'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5403488120685433)
,p_name=>'P508_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(73940016032235909)
,p_item_source_plug_id=>wwv_flow_imp.id(73940016032235909)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'S'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5403523993685434)
,p_name=>'P508_FLOW_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(73940016032235909)
,p_item_source_plug_id=>wwv_flow_imp.id(73940016032235909)
,p_item_default=>'FB_FLOW_ID'
,p_item_default_type=>'ITEM'
,p_source=>'FLOW_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_protection_level=>'S'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5403659832685435)
,p_name=>'P508_SECURITY_GROUP_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(73940016032235909)
,p_item_source_plug_id=>wwv_flow_imp.id(73940016032235909)
,p_item_default=>'WORKSPACE_ID'
,p_item_default_type=>'ITEM'
,p_source=>'SECURITY_GROUP_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5403741373685436)
,p_name=>'P508_NAME'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(11360755862866109)
,p_item_source_plug_id=>wwv_flow_imp.id(73940016032235909)
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>35
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identify the name of the PWA shortcut.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5403865155685437)
,p_name=>'P508_DISPLAY_SEQUENCE'
,p_source_data_type=>'NUMBER'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(11360755862866109)
,p_item_source_plug_id=>wwv_flow_imp.id(73940016032235909)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_display_sequence number;',
'begin',
'    select max(display_sequence)',
'      into l_display_sequence',
'      from wwv_flow_pwa_shortcuts',
'     where security_group_id = :workspace_id',
'       and flow_id           = :fb_flow_id;',
'',
'    return nvl(l_display_sequence, 0) + 10;',
'exception when others then',
'    return 10;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Sequence'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_source=>'DISPLAY_SEQUENCE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>35
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Identifies the display sequence used by this PWA shortcut.'
,p_attribute_03=>'left'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5403928088685438)
,p_name=>'P508_DESCRIPTION'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(11360755862866109)
,p_item_source_plug_id=>wwv_flow_imp.id(73940016032235909)
,p_prompt=>'Description'
,p_source=>'DESCRIPTION'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>35
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Description associated with this PWA shortcut.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5404024162685439)
,p_name=>'P508_TARGET_URL'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(11360755862866109)
,p_item_source_plug_id=>wwv_flow_imp.id(73940016032235909)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select home_link',
'    from wwv_flows',
'where id = :fb_flow_id',
'and security_group_id = :workspace_id'))
,p_item_default_type=>'SQL_QUERY'
,p_prompt=>'Target URL'
,p_source=>'TARGET_URL'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'PAGE URL'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||'' ''||name n, ''f?p=&''||''APP_ID.:''||id||'':&''||''SESSION.'' d',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Specify the page of the application for the current shortcut.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5404153989685440)
,p_name=>'P508_ICON_URL'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(73940016032235909)
,p_item_source_plug_id=>wwv_flow_imp.id(73940016032235909)
,p_source=>'ICON_URL'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'S'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5404294383685441)
,p_name=>'P508_BUILD_OPTION_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(11360755862866109)
,p_item_source_plug_id=>wwv_flow_imp.id(73940016032235909)
,p_prompt=>'Build Option'
,p_source=>'BUILD_OPTION_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PATCHES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(patch_name) pn, id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'', wwv_flow_escape.html(patch_name))||',
'''} '' pn,0-id id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by pn'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Build Option -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the build option that this PWA shortcut uses.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5404301579685442)
,p_name=>'P508_PWA_SHORTCUT_COMMENT'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(11360755862866109)
,p_item_source_plug_id=>wwv_flow_imp.id(73940016032235909)
,p_prompt=>'Comments'
,p_source=>'PWA_SHORTCUT_COMMENT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Developer comments associated with this PWA shortcut.'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11359987781866101)
,p_name=>'P508_FILE_BROWSE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(11360755862866109)
,p_prompt=>'Upload an icon'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>45
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_attribute_01=>'APEX_APPLICATION_TEMP_FILES'
,p_attribute_09=>'SESSION'
,p_attribute_10=>'N'
,p_attribute_11=>'image/*'
,p_attribute_12=>'DROPZONE_INLINE'
,p_attribute_13=>'Upload an icon'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11360642110866108)
,p_name=>'P508_FILE_BROWSE_MIME_TYPE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(11360755862866109)
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select mime_type ',
'  from wwv_flow_static_files ',
' where security_group_id = :workspace_id ',
'   and flow_id           = :fb_flow_id',
'   and file_name         = :p508_icon_url'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11361990118866121)
,p_name=>'P508_INIT_CROPPER_YN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(73940016032235909)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11362136913866123)
,p_name=>'P508_ZOOM_SLIDER_LABEL'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(73940016032235909)
,p_source=>'wwv_flow_lang.system_message(''SHORTCUT.EDITOR.CROPPER.ZOOM_SLIDER_LABEL'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11362318758866125)
,p_name=>'P508_DISPLAY_SHORTCUT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(11362220079866124)
,p_prompt=>'Crop your icon shortcut for a perfect fit'
,p_post_element_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="u-textCenter margin-top-md">',
'<input id="APEXCropperZoom" type="range" min="0" max="100" value="0" step="1">',
'<label class="u-vh" for="APEXCropperZoom">&P508_ZOOM_SLIDER_LABEL.</label>',
'</div>'))
,p_display_as=>'NATIVE_DISPLAY_IMAGE'
,p_display_when=>'P508_INIT_CROPPER_YN'
,p_display_when2=>'Y'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(4923925522744860)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'SQL'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select blob_content as blob_content,',
'       name         as alt_text,',
'       filename     as filename,',
'       mime_type    as mime_type',
'  from wwv_flow_temp_files ',
' where name = :p508_file_browse',
'   and :p508_file_browse is not null',
'',
' union all',
'',
'select sf.file_content as blob_content,',
'       :p508_name     as alt_text,',
'       sf.file_name    as filename,',
'       sf.mime_type    as mime_type',
'  from wwv_flow_pwa_shortcuts ps,',
'       wwv_flow_static_files sf',
' where ps.security_group_id = :workspace_id',
'   and ps.flow_id           = :fb_flow_id',
'   and ps.id                = :p508_id',
'   and sf.security_group_id = ps.security_group_id',
'   and sf.flow_id           = ps.flow_id',
'   and sf.file_name         = ps.icon_url',
'   and :p508_file_browse is null',
'   and :p508_id is not null'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(11361821035866120)
,p_computation_sequence=>10
,p_computation_item=>'P508_ICON_URL'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_extension varchar2(50);',
'begin',
'    if :P508_FILE_BROWSE_MIME_TYPE like ''%jpeg'' or :P508_FILE_BROWSE_MIME_TYPE like ''%jpg'' then',
'        l_extension := ''jpg'';',
'    else ',
'        l_extension := ''png'';',
'    end if;',
'',
'    return ''pwa/shortcut-icon-''||:p508_display_sequence||''.''||l_extension;',
'end;'))
,p_compute_when=>'P508_FILE_BROWSE_MIME_TYPE'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(11360822799866110)
,p_computation_sequence=>10
,p_computation_item=>'P508_INIT_CROPPER_YN'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P508_ID is not null and :P508_ICON_URL is not null then',
'    return ''Y'';',
'end if;',
'',
'for i in ( select 1',
'             from wwv_flow_temp_files ',
'            where name = :p508_file_browse )',
'loop',
'    return ''Y'';',
'end loop;',
'',
'return ''N'';'))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(11360018148866102)
,p_validation_name=>'P508_FILE_BROWSE is invalid'
,p_validation_sequence=>10
,p_validation=>'return false;'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Invalid shortcut file.'
,p_validation_condition=>'UPLOAD_SHORTCUT_INVALID'
,p_validation_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_associated_item=>wwv_flow_imp.id(11359987781866101)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5403115959685430)
,p_name=>'onClick SAVE'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(5403080113685429)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5403244385685431)
,p_event_id=>wwv_flow_imp.id(5403115959685430)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_name=>'saveIcon'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(async () => {',
'    const pageIsValid = apex.page.validate();',
'',
'    if ( pageIsValid ) {',
'        apex.util.showSpinner();',
'        await saveIcon(); ',
'        apex.page.submit(''SAVE'');',
'    }',
'})();'))
,p_server_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_server_condition_expr1=>'P508_INIT_CROPPER_YN'
,p_server_condition_expr2=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(17954871392165801)
,p_event_id=>wwv_flow_imp.id(5403115959685430)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_name=>'submit'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'SAVE'
,p_attribute_02=>'Y'
,p_server_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_server_condition_expr1=>'P508_INIT_CROPPER_YN'
,p_server_condition_expr2=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(11360132033866103)
,p_name=>'onChange P508_FILE_BROWSE is valid'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P508_FILE_BROWSE'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'this.triggeringElement.files.length === 1'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(11360374242866105)
,p_event_id=>wwv_flow_imp.id(11360132033866103)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'UPLOAD_SHORTCUT_INVALID'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(11364675662866148)
,p_event_id=>wwv_flow_imp.id(11360132033866103)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P508_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'apex.items.P508_FILE_BROWSE.value[0]'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_client_condition_type=>'NULL'
,p_client_condition_element=>'P508_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(11364523397866147)
,p_event_id=>wwv_flow_imp.id(11360132033866103)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P508_FILE_BROWSE_MIME_TYPE'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'apex.items.P508_FILE_BROWSE.node.files[0]?.type'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(11360210546866104)
,p_event_id=>wwv_flow_imp.id(11360132033866103)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'UPLOAD_SHORTCUT'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5404917567685448)
,p_name=>'onClick CANCEL'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(5404809567685447)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5405084029685449)
,p_event_id=>wwv_flow_imp.id(5404917567685448)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(11363812313866140)
,p_name=>'onClick CREATE'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(11363724658866139)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(11363922157866141)
,p_event_id=>wwv_flow_imp.id(11363812313866140)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_name=>'saveIcon'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(async () => {',
'    const pageIsValid = apex.page.validate();',
'',
'    if ( pageIsValid ) {',
'        apex.util.showSpinner();',
'        await saveIcon(); ',
'        apex.page.submit(''CREATE'');',
'    }',
'})();'))
,p_server_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_server_condition_expr1=>'P508_INIT_CROPPER_YN'
,p_server_condition_expr2=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(11364870468866150)
,p_event_id=>wwv_flow_imp.id(11363812313866140)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_name=>'submit'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'CREATE'
,p_attribute_02=>'Y'
,p_server_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_server_condition_expr1=>'P508_INIT_CROPPER_YN'
,p_server_condition_expr2=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(11362909174866131)
,p_name=>'onClick HELP'
,p_event_sequence=>70
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(5402910335685428)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(11363079150866132)
,p_event_id=>wwv_flow_imp.id(11362909174866131)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(11363387639866135)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(11361639257866118)
,p_name=>'onClick RESET'
,p_event_sequence=>80
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(11361545123866117)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(11361748910866119)
,p_event_id=>wwv_flow_imp.id(11361639257866118)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.cropperEditor.reset();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(11362700223866129)
,p_name=>'onPageLoad Cropper'
,p_event_sequence=>90
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_cond=>'P508_INIT_CROPPER_YN'
,p_display_when_cond2=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(11362817267866130)
,p_event_id=>wwv_flow_imp.id(11362700223866129)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_name=>'apex.cropperEditor.init'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'const cropperOptions = {',
'    aspectRatio: 1 //0.5 // 1/2',
'};',
'',
'apex.cropperEditor.init({ imageItemName: "P508_DISPLAY_SHORTCUT", cropperOptions });'))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(11363569550866137)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete file'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_file_id number;',
'begin',
'    select id ',
'      into l_file_id',
'      from wwv_flow_static_files ',
'     where security_group_id = :workspace_id ',
'       and flow_id           = :fb_flow_id',
'       and file_name         = :p508_icon_url;',
'',
'    wwv_flow_file_editor_dev.delete_file (',
'       p_id     => l_file_id,',
'       p_scope  => ''APP'',',
'       p_app_id => :fb_flow_id );',
'exception when others then ',
'    null; -- if anything happens don''t delete the file, that is fine',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(11361432659866116)
,p_internal_uid=>11363569550866137
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(11364310748866145)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(73940016032235909)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Shortcuts DML'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE,DELETE,SAVE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_internal_uid=>11364310748866145
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(11364429369866146)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Cleanup files'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_file_id number;',
'begin',
'    for i in ( select id ',
'                 into l_file_id',
'                 from wwv_flow_static_files sf',
'                where sf.security_group_id = :workspace_id ',
'                  and sf.flow_id           = :fb_flow_id',
'                  and sf.file_name         like ''pwa/shortcut-icon%''',
'                  and not exists ( select 1',
'                                     from wwv_flow_pwa_shortcuts ps',
'                                    where ps.security_group_id = sf.security_group_id ',
'                                      and ps.flow_id           = sf.flow_id',
'                                      and ps.icon_url          = sf.file_name ) )',
'    loop',
'        wwv_flow_file_editor_dev.delete_file (',
'           p_id     => i.id,',
'           p_scope  => ''APP'',',
'           p_app_id => :fb_flow_id );',
'    end loop;',
'exception when others then ',
'    null; -- if anything happens don''t delete the file, that is fine',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(5403080113685429)
,p_internal_uid=>11364429369866146
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(11361258397866114)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE,DELETE,SAVE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_internal_uid=>11361258397866114
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(11360928930866111)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load CropperJS'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_css.add_3rd_party_library_file( p_library => wwv_flow_cdn.c_library_cropperjs );',
'wwv_flow_javascript.add_3rd_party_library_file( p_library => wwv_flow_cdn.c_library_cropperjs );'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>11360928930866111
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5403393065685432)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(73940016032235909)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form PWA Shortcuts'
,p_internal_uid=>5403393065685432
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(11361121769866113)
,p_process_sequence=>10
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save_shortcut'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_extension varchar2(50);',
'begin',
'    if wwv_flow.g_x02 like ''%jpeg'' or wwv_flow.g_x02 like ''%jpg'' then',
'        l_extension := ''jpg'';',
'    else ',
'        l_extension := ''png'';',
'    end if;',
'',
'    wwv_flow_imp_shared.create_app_static_file(',
'        p_flow_id      => :fb_flow_id,',
'        p_file_name    => ''pwa/shortcut-icon-''||wwv_flow.g_x01||''.''||l_extension,',
'        p_mime_type    => nvl(wwv_flow.g_x02, ''image/png''),',
'        p_file_charset => ''utf-8'',',
'        p_file_content => wwv_flow_webservices_api.clobbase642blob( p_clob => wwv_flow.g_clob_01 ) );',
' ',
'    wwv_flow_json.open_object;',
'    wwv_flow_json.write( p_name => ''success'', p_value => true );',
'    wwv_flow_json.close_object;',
'exception',
'    when others then',
'        wwv_flow_json.open_object;',
'        wwv_flow_json.write( p_name => ''success'', p_value => false );',
'        wwv_flow_json.write( p_name => ''message'', p_value => sqlerrm );',
'        wwv_flow_json.close_object;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>11361121769866113
);
end;
/
prompt --application/pages/page_00509
begin
wwv_flow_imp_page.create_page(
 p_id=>509
,p_name=>'Edit Security Attributes'
,p_alias=>'EDIT-SECURITY-ATTRIBUTES'
,p_step_title=>'Edit Security Attributes'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213425326892450628)
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_attr_sec.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46227908343678943)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(79232417637259814)
,p_plug_name=>'Landmark for Displayed Regions'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_landmark_type=>'region'
,p_landmark_label=>'Displayed Regions'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2801064285081401)
,p_plug_name=>'Advanced'
,p_parent_plug_id=>wwv_flow_imp.id(79232417637259814)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6354406057147715)
,p_plug_name=>'Session Management'
,p_region_name=>'TIMEOUT'
,p_parent_plug_id=>wwv_flow_imp.id(79232417637259814)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(107178726415706930)
,p_plug_name=>'Authentication'
,p_region_name=>'A'
,p_parent_plug_id=>wwv_flow_imp.id(79232417637259814)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_plug_header=>'<p>Authentication is the process of establishing each user''s identify before they can access your application. You may define multiple authentication schemes for your application, however only one scheme can be current. The authentication logic of th'
||'e current scheme is used when your application is run.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(107179319972706932)
,p_plug_name=>'Database Session'
,p_region_name=>'DBSESSION'
,p_parent_plug_id=>wwv_flow_imp.id(79232417637259814)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(107179907066706934)
,p_plug_name=>'Authorization'
,p_region_name=>'AUTH'
,p_parent_plug_id=>wwv_flow_imp.id(79232417637259814)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_header=>'<p>Application authorization schemes control access to all pages within an application. Unauthorized access to the application, regardless of which page is requested, will cause an error page to be displayed.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(107273213161009008)
,p_plug_name=>'Session State Protection'
,p_region_name=>'PROTECT'
,p_parent_plug_id=>wwv_flow_imp.id(79232417637259814)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enabling Session State Protection can prevent hackers from tampering with URLs within your application. URL tampering can adversely affect program logic, session state contents, and information privacy.</p>',
'<p>To enable Session State Protection for your application, select <strong>Enabled</strong> from the Session State Protection list. Enabling Session State Protection turns on session state protection controls defined at the page and item level. To co'
||'nfigure Session State Protection, click <strong>Manage Session State Protection</strong>.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(875541626713267923)
,p_plug_name=>'Browser Security'
,p_region_name=>'BROWSER_SECURITY'
,p_parent_plug_id=>wwv_flow_imp.id(79232417637259814)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(107178925825706930)
,p_plug_name=>'Application &FB_FLOW_ID.'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_landmark_label=>'Security Attribute Actions'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(107249822848936141)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'Use this page to set application-wide security settings. Edit application components directly to manage more granular settings.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(274905123876642828)
,p_plug_name=>'Application Attributes'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>90
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(274897624522614662)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_landmark_type=>'navigation'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(620042929052352886)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_imp.id(29434107863295859)
,p_plug_display_sequence=>120
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from WWV_FLOWS',
'where id = :509_FB_UPD_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :509_FB_UPD_ID,',
'      p_component_type => ''Application Item'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'509_FB_UPD_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(107299610624150294)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(107178726415706930)
,p_button_name=>'DEFINE_AUTHENTICATION_SCHEMES'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'Define Authentication Schemes'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:801:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(107303526685164337)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(107179907066706934)
,p_button_name=>'DEFINE_AUTHORIZATION_SCHEMES'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'Define Authorization Schemes'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:4070:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(110151111854207273)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(107273213161009008)
,p_button_name=>'INVALIDATE_BOOKMARKS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Expire Bookmarks'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:517:&SESSION.::&DEBUG.:::'
,p_button_condition=>'P509_PAGE_PROTECTION_ENABLED'
,p_button_condition2=>'Y'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(107339232263468774)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(107273213161009008)
,p_button_name=>'MANAGE_SESSION_STATE_PROTECTION'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'Manage Session State Protection'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:510:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(107182428765706940)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(107178925825706930)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(107182222833706939)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(107178925825706930)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'FB_FLOW_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(480964126590312389)
,p_branch_action=>'f?p=&APP_ID.:4001:&SESSION.::&DEBUG.:4001:FB_FLOW_ID:&FB_FLOW_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_DEFN'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(480964331785313932)
,p_branch_action=>'f?p=&APP_ID.:506:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_GLOBAL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(42448405020590777)
,p_branch_action=>'f?p=&APP_ID.:197:&SESSION.::&DEBUG.:197:FB_FLOW_ID:&FB_FLOW_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_USERINTERFACE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(106148211301610602)
,p_branch_name=>'Go To Page 507'
,p_branch_action=>'f?p=&APP_ID.:507:&SESSION.::&DEBUG.:507:FB_FLOW_ID:&FB_FLOW_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_PWA'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1616525844727106)
,p_branch_name=>'Go To Page 523'
,p_branch_action=>'f?p=&APP_ID.:523:&SESSION.::&DEBUG.:523:FB_FLOW_ID:&FB_FLOW_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_AI'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(107225227543707025)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'&F4000_LAST_VIEW.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>60
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(107225418922707025)
,p_branch_action=>'1'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(107182428765706940)
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(480965818372366792)
,p_branch_action=>'f?p=&APP_ID.:509:&SESSION.::&DEBUG.:509:FB_FLOW_ID,509_FB_UPD_ID:&FB_FLOW_ID.,&FB_FLOW_ID.'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_SEC'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1875072844167005)
,p_name=>'P509_AUTH_CONFIG_PROCEDURE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(107178726415706930)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Configuration Procedure'
,p_source=>'AUTH_CONFIG_PROCEDURE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the name of a procedure which configures authentication at runtime.',
'The code below is for an application that implements multi-tenancy and supports',
'different variations of <em>Social Sign-In</em> for the tenants.',
'It uses the domain name in the URL to fetch configuration data (URLs are e.g. ',
'https://cust-01.example.com, https://cust-02.example.com, ...):',
'</p><pre><code>',
'procedure my_auth_config (',
'    p_conf in out nocopy apex_authentication.t_configuration )',
'is',
'    l_host varchar2(32767) := sys.owa_util.get_cgi_env(''HTTP_HOST'');',
'begin',
'    for i in ( select discovery_url,',
'                      auth_scheme_name,',
'                      credential,',
'                      tenant_id',
'                 from customer_tenants',
'                where hostname = l_host )',
'    loop',
'        p_conf.authentication_name := i.auth_scheme_name;',
'        p_conf.substitutions := apex_t_varchar2 (',
'                                    ''DISCOVERY_URL''       , i.discovery_url,',
'                                    ''CREDENTIAL_STATIC_ID'', i.credential );',
'        p_conf.tenant_id := i.tenant_id;',
'    end loop;',
'end my_auth_config;',
'</code></pre><p>',
'The procedure can change 3 attributes of the in/out parameter <code>p_conf</code>,',
'all of them are optional:',
'<ul>',
'    <li><code>authentication_name</code>:',
'    Assign the name of an authentication scheme in your application,',
'    which will be used instead of the default scheme.',
'    Note that <em>Switch In Session</em> must be enabled for that scheme.',
'    </li><li><code>substitutions</code>:',
'    Assign name/value pairs using <code>apex_t_varchar2</code>.',
'    &PRODUCT_NAME. substitutes each <code>#NAME#</code> in the authentication scheme ',
'    attributes with the associated value.',
'    The built-in <em>Social Sign-In</em> scheme uses <code>CREDENTIAL_STATIC_ID</code>',
'    to use the corresponding credential store instead of the one that was configured ',
'    in the scheme.',
'    </li><li><code>tenant_id</code>:',
'    Set this tenant id in the session (see <code>apex_session.set_tenant_id</code>).',
'    </li>',
'</ul>',
'</p><p>',
'In applications with an authentication configuration procedure,',
'the authentication scheme can not be changed via the URL (e.g. <code>f?p=100:1:1234:APEX_AUTHENTICATION=myauth</code>).',
'</p><p>',
'The authentication configuration procedure runs at least once per session, on the first request.    ',
'However, &PRODUCT_NAME. may need to also call it on other occasions.',
'In such cases, it must set the same values on each call.',
'</p>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2404415432409943)
,p_name=>'P509_SESSION_STATE_COMMITS'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(6354406057147715)
,p_use_cache_before_default=>'NO'
,p_item_default=>'END_OF_REQUEST'
,p_prompt=>'Session State Commits'
,p_source=>'SESSION_STATE_COMMITS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'SESSION_STATE_COMMITS'
,p_lov=>'.'||wwv_flow_imp.id(2404156723407174)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'&PRODUCT_NAME. maintains session state[<a rel="noopener noreferrer" href="#fn1">1</a>] both in PL/SQL global variables for quick access and in database tables.',
'Use this attribute to configure when session state gets written and committed to the database:',
'<ul><li><strong>Immediate</strong>: When state changes during request processing, for example because a PL/SQL process modified a bind variable,',
'immediately write these changes and commit. Note that this commits the main transaction,',
'which may contain changes to your application tables.',
'</li><li><strong>End Of Request</strong>: &PRODUCT_NAME. maintains a list of session state changes that occur during request processing',
'and applies them at the end of the request.',
'Use this value for better transaction control and Application Continuity in case of unplanned outages.',
'</li></ul>',
'<br/>',
'<div id="fn1">[1] In this context, session state includes item values and attributes of the session itself (for example the idle timeout).',
'While collections are also part of session state, they are not affected by the <em>Session State Commits</em> attribute.',
'</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2801148159081402)
,p_name=>'P509_PASS_ECID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2801064285081401)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Pass ECID'
,p_source=>'PASS_ECID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Indicates whether to pass the Execution Context ID (with a request header named <em>ECID-Context</em>) to the external web services for end-to-end tracing. This setting can be overwritten for individual REST calls in a REST Data Source definition or '
||'by using APEX_WEB_SERVICE.SET_REQUEST_ECID_CONTEXT.',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3017034838375337)
,p_name=>'P509_MLE_ENV'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(107179319972706932)
,p_use_cache_before_default=>'NO'
,p_prompt=>'MLE Environment'
,p_source=>'MLE_ENVIRONMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d,',
'       object_name r',
'  from (',
'         select case when o.owner != :P509_OWNER then o.owner || ''.'' end || object_name as object_name',
'          from ( select o.owner, o.owner as grantee, o.object_type, o.object_name',
'                   from sys.dba_objects o',
'                  union',
'                 select p.owner, p.grantee, p.type, p.table_name',
'                   from sys.dba_tab_privs p ) o',
'         where o.object_type = ''MLE ENVIRONMENT''',
'           and o.grantee in ( :P509_OWNER, ''PUBLIC'' )',
'       )',
'order by object_name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Default'
,p_lov_cascade_parent_items=>'P509_OWNER'
,p_ajax_optimize_refresh=>'N'
,p_cSize=>30
,p_cMaxlength=>255
,p_display_when=>'wwv_flow_db_version.c_has_mle_with_modules'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Specifies the MLE Environment in which to execute all snippets of MLE code in the application. If none is provided, the default environment will be used.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6357502772184607)
,p_name=>'P509_MAX_SESSION_LENGTH_SEC'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(6354406057147715)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Maximum Session Length in Seconds'
,p_source=>'MAX_SESSION_LENGTH_SEC'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'SECONDS'
,p_lov=>'.'||wwv_flow_imp.id(218750809842831008)||'.'
,p_cSize=>30
,p_cMaxlength=>6
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Defines how long (in seconds) sessions can exist and be used by this application.',
'',
'<ul>',
'    <li>Enter a positive integer to control how long a session can exist.</li>',
'    <li>Enter 0 to have sessions exist indefinitely.</li>',
'    <li>Leave the value empty in order to use the session duration defined at the workspace level or the instance level.</li>',
'</ul>',
'<br />'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6358230130192576)
,p_name=>'P509_MAX_SESSION_IDLE_SEC'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(6354406057147715)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Maximum Session Idle Time in Seconds'
,p_source=>'MAX_SESSION_IDLE_SEC'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'SECONDS'
,p_lov=>'.'||wwv_flow_imp.id(218750809842831008)||'.'
,p_cSize=>30
,p_cMaxlength=>6
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The Session Idle Time is the time between the last page request and the next page request.',
'<ul>',
'    <li>Enter a positive integer to control the idle time for sessions used by this application.</li>',
'    <li>Leave the value empty in order to use the idle time defined at the workspace level or the instance level.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6358614724225908)
,p_name=>'P509_ON_MAX_SESSION_TIMEOUT_URL'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(6354406057147715)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Session Timeout URL'
,p_source=>'ON_MAX_SESSION_TIMEOUT_URL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Enter an optional URL to redirect to when the maximum session lifetime has been exceeded.',
'The target page in this URL, if implemented in &PRODUCT_NAME., should be a public page.',
'A common use for this page would be to inform the user of the session expiration and to present a login link or other options.',
'If you do not enter a URL, users will see the message "Your session has timed out" and a link to the application home page.',
'If you enter #LOGOUT_URL#, &PRODUCT_NAME. will execute a logout, just like when the user clicked on the application''s logout link.',
'</p>',
'<p>',
'Only three substitution items are supported in this URL:',
'</p>',
'<ul>',
'<li>&amp;APP_SESSION.</li>',
'<li>&amp;SESSION.</li>',
'<li>&amp;APP_ID.</li>',
'</ul>',
'<p>',
'Because of the particular purpose of this URL, it is not necessary to include either &amp;APP_SESSION. or &amp;SESSION. in the link.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6359009660233908)
,p_name=>'P509_ON_MAX_IDLE_TIMEOUT_URL'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(6354406057147715)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Session Idle Timeout URL'
,p_source=>'ON_MAX_IDLE_TIMEOUT_URL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Enter an optional URL to be redirected to when the maximum session idle time has been exceeded.',
'The target page in this URL, if implemented in &PRODUCT_NAME., should be a public page.',
'A common use for this page would be to inform the user of the session expiration and to present a login link or other options.',
'If you do not enter a URL, users will see the message "Your session has timed out" and a link to the application home page.',
'If you enter #LOGOUT_URL#, &PRODUCT_NAME. will execute a logout, just like when the user clicked on the application''s logout link.',
'</p>',
'<p>',
'Only three substitution items are supported in this URL:',
'</p>',
'<ul>',
'<li>&amp;APP_SESSION.</li>',
'<li>&amp;SESSION.</li>',
'<li>&amp;APP_ID.</li>',
'</ul>',
'<p>',
'Because of the particular purpose of this URL, it is not necessary to include either &amp;APP_SESSION. or &amp;SESSION. in the link.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(16978325970274016)
,p_name=>'P509_AUTHORIZE_PUBLIC_PAGES_YN'
,p_is_required=>true
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_imp.id(107179907066706934)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Run on Public Pages'
,p_source=>'AUTHORIZE_PUBLIC_PAGES_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Controls whether the application-level authorization scheme is checked on public pages (that is, pages that do not require authorization). Options include:',
'</p>',
'<ul>',
'<li><strong>On</strong> - If you select <strong>On</strong> and the page is public, the application authorization is checked.</li>',
'<li><strong>Off</strong> - If you select <strong>Off</strong> and the page is public, the application authorization is ignored.</li>',
'</ul>',
'<p>',
'Note: This attribute is ignored if you select <strong>Must Not Be Public User</strong> as Authorization Scheme.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(34364122664343194)
,p_name=>'P509_DEEP_LINKING'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(6354406057147715)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Deep Linking'
,p_source=>'DEEP_LINKING'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DEEP_LINKING'
,p_lov=>'.'||wwv_flow_imp.id(34319101845334424)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This attribute enables or prevents deep linking to an application. Deep linking refers to the ability to link to an &PRODUCT_NAME. page out of context (for example, from a hyperlink in an email or workflow notification). Options include:</p>',
'<ul>',
'<li><strong>Enabled</strong> - If the URL references a specific page in an application, after authentication, &PRODUCT_NAME. automatically displays that specific page.</li>',
'<li><strong>Disabled</strong> - If the URL does not contain a valid session ID, &PRODUCT_NAME. redirects to the application''s home page.</li>',
'</ul><p/>',
'<p>For example, browsers often save the URLs of opened tabs and try to restore the sessions after a restart, causing a deep link. This behavior may be undesirable (for example if a URL points to a page in the middle of a multi-step wizard). By select'
||'ing <strong>Disabled</strong>, &PRODUCT_NAME. starts a new session and redirects to the application''s home page.</p>',
'<p>You can override this application setting at page level.</p>',
'<p>To simplify development, deep linking is always enabled if the user is also logged in to the development environment.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(94182360081544823)
,p_name=>'P509_SESSION_TIMEOUT_WARN_SEC'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(6354406057147715)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Session Timeout Warning in Seconds'
,p_source=>'SESSION_TIMEOUT_WARNING_SEC'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'SECONDS_SMALL'
,p_lov=>'.'||wwv_flow_imp.id(433752258048536863)||'.'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The session timeout warning time defines (in seconds) how long before a session times out (either maximum session length, or maximum session idle time), to warn the user. For the maximum session idle time warning, the user will have the opportunit'
||'y to extend the session. For maximum session length warning, the user will be prompted to save any work, to avoid loss of data when the session maximum time is reached.</p>',
'<ul>',
'    <li>Enter a positive integer to control the session timeout warning time for sessions used by this application.</li>',
'    <li>Enter 0 to switch off session timeout warnings for sessions used by this application.</li>',
'    <li>Leave the value empty in order to use the warning time defined at the workspace level or the instance level.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(95189813891614248)
,p_name=>'P509_POPULATE_ROLES'
,p_is_required=>true
,p_item_sequence=>300
,p_item_plug_id=>wwv_flow_imp.id(107179907066706934)
,p_use_cache_before_default=>'NO'
,p_item_default=>'R'
,p_prompt=>'Source for Role or Group Schemes'
,p_source=>'POPULATE_ROLES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APP_POPULATE_ROLES'
,p_lov=>'.'||wwv_flow_imp.id(177081808679947721)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Define what &PRODUCT_NAME. should use as the source for authorization schemes of type <em>Is In Role or Group</em>.',
'The available values are:',
'<ul>',
'<li><strong>Access Control User Role Assignments</strong> - Enable the user''s assigned roles (under Shared Components / Application Access Control).',
'</li>',
'<li><strong>Authentication Scheme</strong> - If the application''s authentication scheme is <em>&PRODUCT_NAME. Accounts</em>, enable the workspace user''s assigned groups.',
'If the application''s authentication scheme is <em>Database Accounts</em>, database roles are checked when the authorization scheme is enabled.',
'If the authentication scheme uses <em>Real Application Security</em>, enable <em>RAS Dynamic Roles</em>.',
'</li>',
'<li><strong>Custom Code</strong> - Call the <code>apex_authorization.enable_dynamic_groups</code> procedure in a Post-Authentication process to populate dynamic groups.',
'</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(107187022259706949)
,p_name=>'509_FB_UPD_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(107178726415706930)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Numeric identification number (ID) which identifies the application. Each application is uniquely identified by an ID.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(107202523267706980)
,p_name=>'P509_SECURITY_SCHEME'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(107179907066706934)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Authorization Scheme'
,p_source=>'SECURITY_SCHEME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REQUIRED_ROLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.d, a.r from (',
'    select wwv_flow_lang.system_message(''MUST_NOT_BE_PUBLIC_USER'') d,''MUST_NOT_BE_PUBLIC_USER'' r, 1',
'      from sys.dual',
'    union all',
'    select wwv_flow_escape.html(substr(name,1,50)),to_char(id), 1',
'      from wwv_flow_security_schemes',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID',
'    union all',
'    select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'',wwv_flow_escape.html(substr(name,1,50)))||''}'' d, ''!''||to_char(id) r, 2',
'      from wwv_flow_security_schemes',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID',
'    order by 3,1) a'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No application authorization required -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'N'
,p_help_text=>'Specify an authorization scheme for your application.  Application authorization schemes are defined for an application for the purpose of controlling access.  Setting a required authorization scheme here at the application level will require all pag'
||'es of the application to pass the defined authorization check.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(107203001185706981)
,p_name=>'P509_PAGE_PROTECTION_ENABLED'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(107273213161009008)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Session State Protection'
,p_source=>'PAGE_PROTECTION_ENABLED_Y_N'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ENABLED_DISABLED_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(91439803955181562)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">When you select <strong>Enabled</strong>, this feature uses the Page Access Protection page attribute and the Session State Protection item attributes in conjunction with checksums positioned in f?p= URLs. Enabling this f'
||'eature prevents URL tampering and unauthorized access to and alteration of session state.</div>',
'',
'<div class="htmldbInfoBodyP">When you select <strong>Disabled</strong>, the &PRODUCT_NAME. engine does not consider Page Access Protection page attributes or Session State Protection item attributes during the execution of your application and does n'
||'ot include checksums in the f?p= section of the URLs.</div>',
'',
'<div class="htmldbInfoBodyP">If this attribute is set to <strong>Enabled</strong>, changing it to <strong>Disabled</strong> disableS Session State Protection, but leaves the setting of all Page Access Protection page attributes and all Session State '
||'Protection item attributes intact.</div>',
'',
'<div class="htmldbInfoBodyP">If the attribute is set to <strong>Disabled</strong>, changing it to <strong>Enabled</strong> enables Session State Protection and leaves all Page Access Protection page attributes and all Session State Protection item at'
||'tributes intact, to be observed during the execution of your application.</div>',
'',
'<div class="htmldbInfoBodyP">An exception to the general rule about item Session State Protection attributes having effect only when Session State Protection is <strong>Enabled</strong>, is if an item''s attribute is set to <strong>Protected</strong>,'
||' that status is always in effect. Protected items cannot be set from the URL, regardless of whether or not Session State Protection is Enabled or Disabled.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(107203519523706982)
,p_name=>'P509_CHECKSUM_SALT_LAST_RESET'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_imp.id(107273213161009008)
,p_use_cache_before_default=>'NO'
,p_item_default=>'wwv_flow_lang.system_message(''NULL_IN_PAREN'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Allow URLs Created After'
,p_source=>'select to_char(CHECKSUM_SALT_LAST_RESET,''&DATE_TIME_FORMAT.'') from wwv_flows where id = :FB_FLOW_ID'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'P509_PAGE_PROTECTION_ENABLED'
,p_display_when2=>'Y'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP"><strong>Allows URLS Created After</strong> lists the date and time after which bookmarked links are useable to access pages in this application if the bookmarked link contains a checksum and Session State Protection is en'
||'abled for the application.',
'<p>',
'Bookmarks created before this date and time are not usable to access this application if the bookmarked link contains a checksum and Session State Protection is enabled for the application.',
'<p>',
'Bookmarks that do not contain checksums or bookmarks that contain checksums that are unnecessary are not affected by this attribute. Their usability is determined using other criteria.',
'<p>',
'A hidden application attribute (a checksum salt) is used during the computation and later verification of checksums included in <code>f?p=</code> URLs generated during page rendering. Checksums are included when Session State Protection is enabled fo'
||'r the application. You can reset this checksum salt attribute at any time by clicking the <strong>Expire Bookmarks</strong> button. Clicking this button causes any bookmarked URLs that contain previously generated checksums to fail when they are subs'
||'equently used to access the application.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(107204011001706983)
,p_name=>'P509_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(107179319972706932)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Parsing Schema'
,p_source=>'OWNER'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS_NO_ESCAPE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select schema d, schema r',
'from   wwv_flow_company_schemas',
'where  security_group_id = :flow_security_group_id',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Specifies the schema that all SQL and PL/SQL in the application will be parsed as. You may use <code>#OWNER#</code> to reference this value in SQL queries and PL/SQL (for example, in a region or a process).'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(107206000369706987)
,p_name=>'P509_PUBLIC_USER'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(107178726415706930)
,p_use_cache_before_default=>'NO'
,p_item_default=>'APEX_PUBLIC_USER'
,p_prompt=>'Public&nbsp;User'
,p_source=>'PUBLIC_USER'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Identifies the Oracle schema (or user) used to connect to the database through the Database Access Descriptor (DAD).</div>',
'<div class="htmldbInfoBodyP">Once a user has been identified, the &PRODUCT_NAME. engine keeps track of each user by setting the value of the built-in substitution string <code>APP_USER</code>. ',
'<div class="htmldbInfoBodyP">When <code>APP_USER</code> equals this value, the &PRODUCT_NAME. engine considers the current session to be a "public user" session. The &PRODUCT_NAME. engine supports the following built-in display conditions:</div>',
'<ul class="noIndent">',
'<li><code>USER_IS_PUBLIC_USER</code>',
'<li><code>USER_IS_NOT_PUBLIC_USER</code>',
'</ul>',
'<br>',
'<div class="htmldbInfoBodyP">If the current application user (<code>APP_USER</code>) equals the value of this attribute, then the user is logged on as a public user. Some applications have public (not logged in) and a private (logged in) modes. By de'
||'termining if the user is the public user, you can conditionally display or hide information.</div>',
'<div class="htmldbInfoBodyP">For example, you can show a login button if the user is the public user and a logout link if the user is not the public user. Reference this value in PL/SQL code using <code>APEX_APPLICATION.G_PUBLIC_USER</code> global va'
||'riable.</div>',
'<div class="htmldbInfoBodyP">The following are examples of valid syntax for referencing <code>APP_USER</code>:</div>',
'<ul class="noIndent">',
'<li><code>&amp;APP_USER.</code>',
'<li><code>:APP_USER</code>',
'<li><code>v(''APP_USER'')</code>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(107209004573706992)
,p_name=>'P509_VPD'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(107179319972706932)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Initialization PL/SQL Code'
,p_source=>'VPD'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>6
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use this attribute to enter a PL/SQL block that sets a context for the database session associated with the current "show page" or "accept page" request. The block you enter here is executed at a very early point during the page request, immediate'
||'ly after the <code>APP_USER</code> value is established. The value of <code>APP_USER</code> (using <code>:APP_USER</code> or <code>v(''APP_USER'')</code>) may be used within the block. Values of other items in session state may be referenced as well, b'
||'ut any such items must have been established in session state before the initiation of the current page request.',
'Consider the following example:',
'</p>',
'<pre>',
'dbms_session.set_context(''CTX_USER_QRY'',''USERPRIV'',my_package.my_function(:APP_USER));',
'</pre>',
'',
'<p>This example sets the value of <code>USERPRIV</code> in the context named <code>CTX_USER_QRY</code> to the value returned by the function <code>my_function</code> in package <code>my_package</code>. The function is passed the current value of <cod'
||'e>APP_USER</code> as an input argument. Presumably, the named context would be used in a VPD policy (created within the application''s parsing schema) to effect the generation of predicates appropriate to the authenticated user.</p>',
'',
'<p>Virtual Private Database, also know as Fine-Grained Access Control or FGAC, is an Oracle database feature that provides an application programming interface (API) that enables developers to assign security policies to database tables and views. Us'
||'ing PL/SQL, developers can create security policies with stored procedures and bind the procedures to a table or view by means of a call to an RDBMS package. Such policies are based on the content of application data stored within the database, or ba'
||'sed on context variables provided by Oracle database. In this way, VPD permits access security mechanisms to be removed from applications, and to be situated closer to particular schemas.</p>',
'',
'<p>The code entered here need not pertain to VPD/FGAC and may not be related to security at all. Any code that needs to be executed at the earliest point in a page request can be placed here. For example, the following code sets the database session '
||'time zone for every page request:</p>',
'',
'<pre>',
'BEGIN',
'   EXECUTE IMMEDIATE ''alter session set time_zone = ''''Australia/Sydney'''' '';',
'END;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PLSQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(107210615861706995)
,p_name=>'P509_AUTHENTICATION_ID'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(107178726415706930)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Authentication Scheme'
,p_source=>'AUTHENTICATION_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'AUTHENTICATION_SCHEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name as d,',
'       id   as r',
'  from wwv_flow_authentications',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :WORKSPACE_ID',
' order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'This attribute identifies the current authentication method used by this application.  The purpose of authentication is to determine the application users identity.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(209487341993906101)
,p_name=>'P509_AUTHORIZE_BATCH_JOB'
,p_is_required=>true
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_imp.id(107179907066706934)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Run on Background Job'
,p_source=>'AUTHORIZE_BATCH_JOB'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Controls whether the authorization schemes at application, page, region and column level are checked in the background job such as interactive report subscriptions. Options include:',
'</p>',
'<ul>',
'<li><strong>On</strong> - If you select <strong>On</strong>, the authorization is checked.</li>',
'<li><strong>Off</strong> - If you select <strong>Off</strong>, the authorization is ignored.</li>',
'</ul>',
'<p>',
'Note: The background job authorization check uses cloned session state instead of the current session state. The cloned session state does NOT include collection, report settings nor session state set during the post authentication process. The autho'
||'rization check may fail if session state in cloned session is not found.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(314984802983606044)
,p_name=>'P509_HTML_ESCAPING_MODE'
,p_is_required=>true
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_imp.id(875541626713267923)
,p_use_cache_before_default=>'NO'
,p_item_default=>'E'
,p_prompt=>'HTML Escaping Mode'
,p_source=>'HTML_ESCAPING_MODE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'HTML_ESCAPING_MODE'
,p_lov=>'.'||wwv_flow_imp.id(314983827117600277)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Defines how &PRODUCT_NAME. should escape special characters. Options include:',
'</p>',
'<ul>',
'<li><strong>Basic</strong> - Escape &amp;, &quot;, &lt; and &gt;</li>',
'<li><strong>Extended</strong> - Escape &amp;, &quot;, &lt;, &gt;, &#x27;, &#x2F; and non-ASCII characters if the database character set is not AL32UTF8</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(367969027064292100)
,p_name=>'P509_BOOKMARK_CS_FUNCTION'
,p_item_sequence=>310
,p_item_plug_id=>wwv_flow_imp.id(107273213161009008)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Bookmark Hash Function'
,p_source=>'BOOKMARK_CHECKSUM_FUNCTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'HASH_FUNCTION'
,p_lov=>'.'||wwv_flow_imp.id(367957504585280755)||'.'
,p_display_when=>'P509_PAGE_PROTECTION_ENABLED'
,p_display_when2=>'Y'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'The <strong>Bookmark Hash Function</strong> is used to create checksums for application level and user level checksums in bookmarkable URLs.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(384786066747553206)
,p_name=>'P509_HTTP_RESPONSE_HEADERS'
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_imp.id(875541626713267923)
,p_use_cache_before_default=>'NO'
,p_prompt=>'HTTP Response Headers'
,p_source=>'HTTP_RESPONSE_HEADERS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Enter additional application specific HTTP headers that &PRODUCT_NAME. should send on each response and that it does not support in another way (for example, <code>X-Frame-Options</code> using the Embed in Frames attribute).',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(384789975408553245)
,p_name=>'P509_REJOIN_EXISTING_SESSIONS'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(6354406057147715)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Rejoin Sessions'
,p_source=>'REJOIN_EXISTING_SESSIONS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REJOIN_EXISTING_SESSIONS'
,p_lov=>'.'||wwv_flow_imp.id(492680965578161495)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Use this attribute to control if &PRODUCT_NAME. should support application URLs that do not contain session IDs.',
'When rejoin sessions is enabled, &PRODUCT_NAME. attempts to use the session cookie to join an existing session,',
'when a URL does not contain a session ID.',
'</p>',
'<p>',
'A more restrictive instance level setting overrides this page level value.',
'</p>',
'<p>',
'    <strong>Note:</strong>',
'Enabling rejoin sessions exposes your application to possible security breaches, as it can enable attackers to take over existing end user sessions. To learn more, see the Rejoin Sessions sections in "Managing Application Security" in the App Builder'
||' User''s Guide.',
'</p>',
'',
'<p>',
'Available options include:    ',
'</p>',
'<ul>',
'    <li><strong>Application Default</strong> - ',
'    The application-level setting applies.',
'    </li>',
'    <li><strong>Disabled</strong> - ',
'    If the URL does not contain a session ID, &PRODUCT_NAME. creates a new session.',
'    </li>',
'    <li><strong>Enabled for Public Sessions</strong> - ',
'    If the URL goes to a public page and does not contain a session ID,',
'    &PRODUCT_NAME. attempts to utilize the existing session cookie established for that application.',
'    For applications with both public and authenticated pages, a session ID is defined after the end user authenticates.',
'    &PRODUCT_NAME. only joins using the cookie when the session is not yet authenticated.',
'    </li>',
'    <li><strong>Enabled for All Sessions</strong> - ',
'    If the URL does not contain a session ID, &PRODUCT_NAME. attempts to utilize the existing session cookie established for that application,',
'    providing the following conditions are met:',
'    <ul>',
'        <li>',
'        Session State Protection is enabled for the application and the URL includes a valid checksum.',
'        For public bookmarks,',
'        the most restrictive item level protection must be either <em>Unrestricted</em> or <em>Checksum Required - Application Level</em>.',
'        </li>',
'        <li>',
'        OR, the URL does not contain payload (a request parameter, clear cache or data value pairs).',
'        </li>',
'    </ul>',
'    This setting also requires that Embed In Frames is set to Allow from same origin or to Deny for the application.',
'    </li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(495347874477866239)
,p_name=>'P509_RUNTIME_API_USAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2801064285081401)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Runtime API Usage'
,p_source=>'RUNTIME_API_USAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'WWV_FLOW-RUNTIME_API_USAGE'
,p_lov=>'.'||wwv_flow_imp.id(561570937398567414)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Control how this application can access &PRODUCT_NAME. APIs that modify applications and workspace data, while it is running.',
'</p>',
'<ul>',
'<li>Modify This Application: The application can modify itself.</li>',
'<li>Modify Other Applications: The application can change other applications in the workspace.</li>',
'<li>Modify Workspace Repository: The application can change workspace users and groups.</li>    ',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(721525211605207324)
,p_name=>'P509_ACCEPT_OLD_CHECKSUMS'
,p_item_sequence=>320
,p_item_plug_id=>wwv_flow_imp.id(107273213161009008)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Accept pre-20.2 URL Checksums'
,p_source=>'ACCEPT_OLD_CHECKSUMS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>'P509_ACCEPT_OLD_CHECKSUMS'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Indicates whether APEX accepts bookmarks generated by APEX 20.1 and earlier. If disabled, those public and private bookmarks will raise checksum validation errors. If enabled, the bookmarks continue to work.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(815128529788112116)
,p_name=>'P509_REFERRER_POLICY'
,p_is_required=>true
,p_item_sequence=>270
,p_item_plug_id=>wwv_flow_imp.id(875541626713267923)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Referrer Policy'
,p_source=>'REFERRER_POLICY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REFERRER_POLICY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select x.column_value disp,',
'       x.column_value ret',
'  from table(wwv_flow_t_varchar2 (',
'                 ''no-referrer'',',
'                 ''no-referrer-when-downgrade'',',
'                 ''origin'',',
'                 ''origin-when-cross-origin'',',
'                 ''same-origin'',',
'                 ''strict-origin'',',
'                 ''strict-origin-when-cross-origin'',',
'                 ''unsafe-url'' )) x',
''))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'This attribute defines what &PRODUCT_NAME. sends in the <code>Referrer-Policy</code> HTTP response header.',
'<code>Referrer-Policy</code> controls what the browser sends to servers in the ',
'<code>Referer</code> and <code>Origin</code> request headers,',
'when users click on links or submit pages.',
'Normally, this information includes the full URL, including &PRODUCT_NAME. session IDs,',
'which should not be exposed to third parties.',
'New applications should use the value <code>strict-origin</code>,',
'unless there are specific business requirements for a different setting.',
'</p><p>',
'Please see the',
'<a rel="noopener noreferrer" href="https://www.w3.org/TR/referrer-policy/" referrerpolicy="no-referrer" target="_blank">',
'documentation for the Referrer-Policy header and its available values',
'</a>',
'for further information.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(875823623343323717)
,p_name=>'P509_BROWSER_CACHE'
,p_is_required=>true
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_imp.id(875541626713267923)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Cache'
,p_source=>'BROWSER_CACHE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'BROWSER_CACHE'
,p_lov=>'.'||wwv_flow_imp.id(875788205897309215)||'.'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flows',
' where id                  = :FB_FLOW_ID',
'   and compatibility_mode <> ''4.0''',
'   and security_group_id   = :flow_security_group_id'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use Cache to enable or disable browser caching of application page contents. If enabled, the browser saves the contents of pages for this application in its cache, both in memory and on disk. Typically when caching is enabled and the browser Back '
||'button is clicked, the page is loaded from the cache instead of from the server. If disabled, the browser is instructed not to save application page contents and to request the latest page content from the server whenever the URL changes. ',
'</p>',
'<p>To avoid the possibility of saving sensitive data, Oracle recommends that this attribute be disabled. Otherwise, it is possible to go back in the browser history after a logout and see cached content from a previous session. Disabling the browser '
||'cache also prevents issues with pages that use partial page refreshes, such as is the case with interactive reports.</p>',
'<p>If this attribute is set to <strong>Disabled</strong>, &PRODUCT_NAME. sends the HTTP header <em>Cache-Control: no-store</em>, which instructs the browser not to cache the page contents on disk or in memory.',
'</p>',
'<p>Note: This feature requires modern browsers that support the HTTP header response variable "Cache-Control".</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(885511105529258340)
,p_name=>'P509_VPD_TEARDOWN_CODE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(107179319972706932)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Cleanup PL/SQL Code'
,p_source=>'VPD_TEARDOWN_CODE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>6
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use this attribute to enter a PL/SQL block that runs at the end of page processing.',
'It can be used to free or clean up resources that were used, like VPD contexts or database links.',
'</p>',
'<p>Example 1:',
'<pre>',
'dbms_session.clear_context(''CTX_USER_QRY'');',
'</pre>',
'This call resets the application context named CTX_USER_QRY before the database session is given back to the session pool,',
'to ensure that no information will be leaked when it gets reused later on.',
'</p>',
'<p>Example 2:',
'<pre>',
'dbms_session.close_database_link(''SALES'');',
'</pre>',
'This call closes the database link SALES, which might have been opened in the "Initialization PL/SQL Code" or implicitly, just by querying data via the link.',
'Again, this frees resources and prevents resource leakage when the database session will be reused.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PLSQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1098121125859208369)
,p_name=>'P260_BROWSER_FRAME'
,p_is_required=>true
,p_item_sequence=>260
,p_item_plug_id=>wwv_flow_imp.id(875541626713267923)
,p_use_cache_before_default=>'NO'
,p_item_default=>'D'
,p_prompt=>'Embed in Frames'
,p_source=>'BROWSER_FRAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'BROWSER_FRAME'
,p_lov=>'.'||wwv_flow_imp.id(1098055005642193053)||'.'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flows',
' where id                  = :FB_FLOW_ID',
'   and compatibility_mode <> ''4.0''',
'   and security_group_id   = :flow_security_group_id'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Use this attribute to control if the browser is allowed to display your application''s pages within a frame:',
'<ul>',
'<li><strong>Deny</strong>: The page cannot be displayed in a frame, regardless of the site attempting to do so.</li>',
'<li><strong>Allow from same origin</strong>: The page can only be displayed in a frame on the same origin as the page itself.</li>',
'<li><strong>Allow</strong>: The page can be displayed in any frame.</li>',
'</ul>',
'</p>',
'<p>',
'Displaying pages within frames can be misused with "clickjacking" attacks.',
'In a clickjacking attack the attacker uses multiple layers to trick a user into clicking a button or link on another page when they were intending to click on the top level page.',
'Thus, the attacker is hijacking clicks (or keystrokes) meant for their page and routing them to another page.',
'</p>',
'<p>',
'Dialog pages are often displayed within an iframe,',
'which would normally not work with the attribute value "Deny".',
'A dialog page template''s attribute <em>Allow Embed In Frame</em> defines whether "Allow from same origin" should be used instead of "Deny",',
'for pages that use such a template.',
'To protect against clickjacking,',
'&PRODUCT_NAME. uses a page-specific checksum in dialog page URLs.',
'</p>',
'<p>',
'Note: This feature requires modern browsers that support the HTTP header response variable "X-Frame-Options".',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1143248434428567437)
,p_name=>'P509_INSTANCE_MAX_SESSION_IDLE_SEC'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(6354406057147715)
,p_use_cache_before_default=>'NO'
,p_prompt=>'P509_INSTANCE_MAX_SESSION_IDLE_SEC'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_lang.system_message(',
'    p_name => ''F4000.P509.INSTANCE_MAX_SESSION_IDLE_SEC'',',
'    p0     => nvl( wwv_flow_security.get_workspace(',
'                       p_security_group_id => wwv_flow_security.g_security_group_id ).max_session_idle_sec, 0 ) )'))
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'P509_MAX_SESSION_IDLE_SEC'
,p_display_when_type=>'ITEM_IS_NULL'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--postItemText'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1143248571179567438)
,p_name=>'P509_INSTANCE_MAX_SESSION_LENGTH_SEC'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(6354406057147715)
,p_use_cache_before_default=>'NO'
,p_prompt=>'P509_INSTANCE_MAX_SESSION_LENGTH_SEC'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_lang.system_message(',
'    p_name => ''F4000.P509.INSTANCE_MAX_SESSION_LENGTH_SEC'',',
'    p0     => nvl( wwv_flow_security.get_workspace(',
'                       p_security_group_id => wwv_flow_security.g_security_group_id ).max_session_length_sec, 0 ) )'))
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_display_when=>'P509_MAX_SESSION_LENGTH_SEC'
,p_display_when_type=>'ITEM_IS_NULL'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--postItemText'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(384790260914553248)
,p_validation_name=>'Validate REJOIN_EXISTING_SESSIONS'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    c_instance_value constant varchar2(4000) := wwv_flow_platform.get_preference(''REJOIN_EXISTING_SESSIONS'');',
'begin',
'    wwv_flow_debug.trace(''REJOIN.....%s'', :P509_REJOIN_EXISTING_SESSIONS||c_instance_value);',
'    return :P509_REJOIN_EXISTING_SESSIONS||c_instance_value in (''NN'', ''NP'', ''NY'',',
'                                                                ''PP'', ''PY'',',
'                                                                ''YY'');',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'This value is not supported on your &PRODUCT_NAME. instance.'
,p_associated_item=>wwv_flow_imp.id(384789975408553245)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(574348776255630522)
,p_validation_name=>'Validate REJOIN_EXISTING_SESSIONS against BROWSER_FRAME'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/*',
' * disallow rejoin all sessions when embedding in frames is allowed',
' */',
'not (    nvl(:P509_REJOIN_EXISTING_SESSIONS, ''N'') = ''Y''',
'     and nvl(:P260_BROWSER_FRAME           , ''D'') = ''A'' )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'The Rejoin Sessions setting of <em>Enabled for All Sessions</em> requires that <strong>Embed In Frames</strong> is set to <em>Allow from same origin</em> or to <em>Deny</em> for the application.'
,p_associated_item=>wwv_flow_imp.id(384789975408553245)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(107223216874707020)
,p_validation_name=>'validate schema'
,p_validation_sequence=>30
,p_validation=>'wwv_flow_security.current_company_can_build(p_in_schema=>:P509_OWNER)'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'No privilege to build in schema &P509_OWNER!HTML.  Use the list of values on the previous page to select a schema that you have privilege to build in.'
,p_associated_item=>wwv_flow_imp.id(107204011001706983)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(6373423169504345)
,p_validation_name=>'max session length a positive integer'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare x pls_integer;',
'begin',
'x := :P509_MAX_SESSION_LENGTH_SEC;',
'if x < 0 or to_number(:P509_MAX_SESSION_LENGTH_SEC) <> trunc(to_number(:P509_MAX_SESSION_LENGTH_SEC)) then',
'    return false;',
'else',
'    return true;',
'end if;',
'exception when others then',
'return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Value must be a positive integer.'
,p_associated_item=>wwv_flow_imp.id(6357502772184607)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(6373829188515554)
,p_validation_name=>'max session idle seconds a positive integer'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare x pls_integer;',
'begin',
'x := :P509_MAX_SESSION_IDLE_SEC;',
'if x < 0 or to_number(:P509_MAX_SESSION_IDLE_SEC) <> to_number(trunc(:P509_MAX_SESSION_IDLE_SEC)) then',
'    return false;',
'else',
'    return true;',
'end if;',
'exception when others then',
'return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Value must be a positive number.'
,p_associated_item=>wwv_flow_imp.id(6358230130192576)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(94182446784544824)
,p_validation_name=>'session timeout warning seconds a positive'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare x pls_integer;',
'begin',
'x := :P509_SESSION_TIMEOUT_WARN_SEC;',
'if x < 0 or to_number(:P509_SESSION_TIMEOUT_WARN_SEC) <> to_number(trunc(:P509_SESSION_TIMEOUT_WARN_SEC)) then',
'    return false;',
'else',
'    return true;',
'end if;',
'exception when others then',
'return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Value must be a positive number.'
,p_associated_item=>wwv_flow_imp.id(94182360081544823)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(13935275047530403)
,p_validation_name=>'Validate P509_VPD PL/SQL Code'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_code_exec_dev.check_code (',
'               p_code     => :P509_VPD,',
'               p_language => wwv_flow_code_exec.c_plsql );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P509_VPD'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_imp.id(107209004573706992)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(13935362791530404)
,p_validation_name=>'Validate P509_VPD_TEARDOWN_CODE PL/SQL Code'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_code_exec_dev.check_code (',
'               p_code     => :P509_VPD_TEARDOWN_CODE,',
'               p_language => wwv_flow_code_exec.c_plsql );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P509_VPD_TEARDOWN_CODE'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_imp.id(885511105529258340)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(495347589832866236)
,p_name=>'Show/Hide AUTHORIZE_PUBLIC_PAGES'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P509_SECURITY_SCHEME'
,p_condition_element=>'P509_SECURITY_SCHEME'
,p_triggering_condition_type=>'NOT_EQUALS'
,p_triggering_expression=>'MUST_NOT_BE_PUBLIC_USER'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(495347636738866237)
,p_event_id=>wwv_flow_imp.id(495347589832866236)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P509_AUTHORIZE_PUBLIC_PAGES_YN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(495347739700866238)
,p_event_id=>wwv_flow_imp.id(495347589832866236)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P509_AUTHORIZE_PUBLIC_PAGES_YN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(107223823728707022)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOWS'
,p_attribute_03=>'FB_FLOW_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Error fetching  row.'
,p_internal_uid=>107223823728707022
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(107224400935707023)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOWS'
,p_attribute_03=>'FB_FLOW_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'U'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error processing  row.'
,p_process_success_message=>'Application &FB_UPD_ID. processed.'
,p_security_scheme=>wwv_flow_imp.id(34674432490821717)
,p_internal_uid=>107224400935707023
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(107224620333707024)
,p_process_sequence=>50
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'security'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.init;',
'sys.owa_util.redirect_url(v(''LOGOUT_URL''));',
'wwv_flow.g_unrecoverable_error := true;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'    from   wwv_flow_developers',
'    where  userid = :FLOW_USER ',
'       and',
'       security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and',
'       security_group_id = ',
'         (select security_group_id from wwv_flows where id=:FB_FLOW_ID)',
'       and',
'       instr(developer_role,''EDIT'') > 0 ',
'       and',
'       (flow_id = :FB_FLOW_ID or flow_id is null)  '))
,p_process_when_type=>'NOT_EXISTS'
,p_internal_uid=>107224620333707024
);
end;
/
prompt --application/pages/page_00510
begin
wwv_flow_imp_page.create_page(
 p_id=>510
,p_name=>'Session State Protection'
,p_alias=>'SESSION-STATE-PROTECTION'
,p_step_title=>'Session State Protection'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(262753407599695606)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_session_protection.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(107375112935642905)
,p_plug_name=>'Application Session State Protection  Controls'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>130
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enabling Session State Protection can prevent hackers from tampering with the URLs within your application. URL tampering can adversely affect program logic, session state contents, and information privacy.',
'<p>To enable, disable, or configure Session State Protection using a wizard, click <strong>Set Protection</strong>.</p>'))
,p_plug_footer=>'<p />'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(722893162918355703)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>140
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(722893227881355704)
,p_plug_name=>'Application Session State Protection  Controls'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>140
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1301369887754065007)
,p_plug_name=>'Existing Session State Protection Settings'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--simple'
,p_region_attributes=>'style="border: 1px solid #E0E0E0; border-radius: 2px;"'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>140
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(1271240655472240403)
,p_name=>'Pages'
,p_parent_plug_id=>wwv_flow_imp.id(1301369887754065007)
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h240'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch:a-Report--rowHighlight'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(PROTECTION_LEVEL,''N'') protection',
',      count(''x'') as Count                    ',
'from   #OWNER#.WWV_FLOW_STEPS p',
'where flow_id = :fb_flow_id ',
'and   p.security_group_id = :flow_security_group_id',
'group by PROTECTION_LEVEL',
'order by PROTECTION_LEVEL'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'0'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(1271240655472240403)
,p_plug_column_width=>'apex-col--leftBorder apex-col--bottomBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1312309225232475801)
,p_query_column_id=>1
,p_column_alias=>'PROTECTION'
,p_column_display_sequence=>1
,p_column_heading=>'Page Access'
,p_use_as_row_header=>'Y'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(17255429593772638)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1271240807146240405)
,p_query_column_id=>2
,p_column_alias=>'COUNT'
,p_column_display_sequence=>2
,p_column_heading=>'Pages'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(1271240975440240406)
,p_name=>'Page Items'
,p_parent_plug_id=>wwv_flow_imp.id(1301369887754065007)
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h240'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch'
,p_new_grid_row=>false
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(PROTECTION_LEVEL,''N'') protection',
',      count(''x'') as Count                    ',
'from   #OWNER#.WWV_FLOW_STEP_ITEMS p',
'where flow_id = :fb_flow_id ',
'and   p.security_group_id = :flow_security_group_id',
'group by PROTECTION_LEVEL',
'order by PROTECTION_LEVEL'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(1271240975440240406)
,p_plug_column_width=>'apex-col--leftBorder apex-col--bottomBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1312309350363475802)
,p_query_column_id=>1
,p_column_alias=>'PROTECTION'
,p_column_display_sequence=>1
,p_column_heading=>'Item Access Level'
,p_use_as_row_header=>'Y'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(17287012676783081)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1271241137913240408)
,p_query_column_id=>2
,p_column_alias=>'COUNT'
,p_column_display_sequence=>2
,p_column_heading=>'Items'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(1271241223019240409)
,p_name=>'Application Items'
,p_parent_plug_id=>wwv_flow_imp.id(1301369887754065007)
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h240'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch'
,p_new_grid_row=>false
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(PROTECTION_LEVEL,''N'') protection',
',      count(''x'') as Count                    ',
'from   #OWNER#.WWV_FLOW_ITEMS p',
'where flow_id = :fb_flow_id ',
'and   p.security_group_id = :flow_security_group_id',
'group by PROTECTION_LEVEL',
'order by PROTECTION_LEVEL'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(1271241223019240409)
,p_plug_column_width=>'apex-col--leftBorder apex-col--rightBorder apex-col--bottomBorder'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1312309425282475803)
,p_query_column_id=>1
,p_column_alias=>'PROTECTION'
,p_column_display_sequence=>2
,p_column_heading=>'Item Access Level'
,p_use_as_row_header=>'Y'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(17287012676783081)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1271241482244240411)
,p_query_column_id=>2
,p_column_alias=>'COUNT'
,p_column_display_sequence=>3
,p_column_heading=>'Items'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1271241539938240412)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1271240975440240406)
,p_button_name=>'GOTOPAGESITEMS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Go To Pages'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:513:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1271241612371240413)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1271241223019240409)
,p_button_name=>'GOTOAPPITEMS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Go To Pages'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:518:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1362277728754195801)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1271240655472240403)
,p_button_name=>'GOTOPAGES'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Go To Pages'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:512:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(109597028644139221)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(722893162918355703)
,p_button_name=>'SET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Set Protection'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:525:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(107364120114588295)
,p_name=>'P510_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(107375112935642905)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application:'
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'This attribute identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(107369003192611794)
,p_name=>'P510_APPLICATION_SESSION_STATE_SECURITY'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(107375112935642905)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Session State Protection:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select PAGE_PROTECTION_ENABLED_Y_N',
'  from wwv_flows',
' where id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'ENABLED_DISABLED_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(91439803955181562)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p />',
'Indicates whether Session State Protection is enabled or disabled. When enabled, this feature, uses the <i>Page Access Protection</i> page attributes and the <i>Session State Protection</i> item attributes in conjunction with checksums positioned in '
||'"f?p=" URLs. The feature prevents URL tampering and unauthorized access to and alteration of session state. ',
'<p />',
'When this feature is disabled, the page and item attributes related to session state protection are ignored and checksums are not included checksums in generated "f?p=" URLs.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
end;
/
prompt --application/pages/page_00511
begin
wwv_flow_imp_page.create_page(
 p_id=>511
,p_name=>'Build Options'
,p_alias=>'INSTALL-BUILD-OPTIONS'
,p_step_title=>'Build Options'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(24897722063538624)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deployment.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(13724816425012921)
,p_plug_name=>'Build Options'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Identify the build options that a user may change when installing this application.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22517025703414506)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_list_id=>wwv_flow_imp.id(22452018965176093)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(24433530107927890)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(24172418538839346)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(34011006179919668)
,p_plug_name=>'Build Options'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_04'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(13725714531012925)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(34011006179919668)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(13725916424012927)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(34011006179919668)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
,p_button_condition_type=>'EXISTS'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(29855829820547296)
,p_branch_name=>'Go To Page &P567_BRANCH_PAGE.'
,p_branch_action=>'f?p=&APP_ID.:&P567_BRANCH_PAGE.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'substr(:REQUEST,1,13) = ''APPLY_CHANGES'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(13727714196012940)
,p_branch_action=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(13726325680012930)
,p_name=>'P511_BUILD_OPTS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(13724816425012921)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Prompt for Build Options:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'   l_value wwv_flow_global.vc_arr2;',
'begin ',
'   select build_opt_id ',
'   bulk collect into l_value ',
'   from wwv_flow_install_build_opt ',
'   where flow_id = :FB_FLOW_ID ',
'   and security_group_id = :flow_security_group_id;',
'',
'   return wwv_flow_utilities.table_to_string2(l_value,'':''); ',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'DEPLOYMENT BUILD OPTIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select patch_name||'' (''||wwv_flow_lang.system_message(patch_status)||'')'' d, id r ',
'  from wwv_flow_patches ',
' where flow_id = :FB_FLOW_ID'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Your application build options are listed below, along with the current setting for each.  Check the box next to a build option to allow a user installing the application to change the setting as part of the installation process.  The current setting'
||' will be the default for each build option.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(19383321640657223)
,p_name=>'P511_NO_BUILD_OPTIONS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(13724816425012921)
,p_prompt=>'This application has no build options.'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="fielddata"'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
,p_display_when_type=>'NOT_EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(29854320124544401)
,p_computation_sequence=>10
,p_computation_item=>'P567_BRANCH_PAGE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'substr(v(''REQUEST''),15)'
,p_compute_when=>'substr(:REQUEST,1,13) = ''APPLY_CHANGES'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(13726721533012932)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'process build opts'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_build_opts wwv_flow_global.vc_arr2;',
'begin',
'  l_build_opts := wwv_flow_utilities.string_to_table2(:P511_BUILD_OPTS);',
'  delete from wwv_flow_install_build_opt where flow_id = :FB_FLOW_ID;',
'  for i in 1..l_build_opts.count',
'  loop',
'    insert into wwv_flow_install_build_opt (build_opt_id) ',
'         values (l_build_opts(i));',
'  end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to update build option prompts.'
,p_process_when=>'substr(:REQUEST,1,13) = ''APPLY_CHANGES'' or :REQUEST = ''SAVE'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>13726721533012932
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(13727528196012940)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'17'
,p_internal_uid=>13727528196012940
);
end;
/
prompt --application/pages/page_00512
begin
wwv_flow_imp_page.create_page(
 p_id=>512
,p_name=>'Session State Protection by Page'
,p_alias=>'SESSION-STATE-PROTECTION-BY-PAGE'
,p_step_title=>'Session State Protection by Page'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(262753407599695606)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_session_protection.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(15563507922723490)
,p_plug_name=>'Page Level Session State Protection  Controls'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>130
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id as "PAGE",',
'	   name as "Name",',
'	   decode(',
'           nvl(PROTECTION_LEVEL,''N''),',
'           ''N'', m.n,',
'           ''C'', m.c,',
'           ''U'', m.u,',
'           ''D'', m.d,',
'           protection_level) as "Protection",',
'       (select count(*)',
'          from wwv_flow_step_items',
'         where flow_step_id      = p.id',
'           and flow_id           = :FB_FLOW_ID',
'           and security_group_id = :FLOW_SECURITY_GROUP_ID) page_items,',
'       id,',
'       p.page_type,',
'       nvl(last_updated_on,created_on) updated,',
'       nvl(last_updated_by,created_by) updated_by,',
'       decode(',
'           nvl(p.page_is_public_y_n,''N''),',
'           ''Y'', t_yes,',
'           ''N'', t_no) page_is_public_y_n,',
'       decode(nvl(p.allow_duplicate_submissions,''Y''),',
'          ''Y'', t_yes,',
'          ''N'', t_no) allow_duplicate_submissions',
'  from wwv_flow_pages_dev p,',
'       (select wwv_flow_lang.system_message(''UNRESTRICTED'') n,',
'               wwv_flow_lang.system_message(''ARGUMENTS_MUST_HAVE_CHECKSUM'') c,',
'               wwv_flow_lang.system_message(''NO_ARGUMENTS_ALLOWED'') u,',
'               wwv_flow_lang.system_message(''NO_URL_ACCESS'') d,',
'               wwv_flow_lang.system_message(''F4000.YES'') t_yes,',
'               wwv_flow_lang.system_message(''F4000.NO'') t_no',
'          from sys.dual) m',
' where p.flow_id           = :FB_FLOW_ID',
'   and p.security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(15563630191723490)
,p_name=>'Page Level Session State Protection  Controls'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15563809490723495)
,p_db_column_name=>'PAGE'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Page'
,p_column_link=>'f?p=&APP_ID.:515:&SESSION.::&DEBUG.:515:P515_FLOW_ID,P515_ID:&FB_FLOW_ID.,#ID#'
,p_column_linktext=>'#PAGE#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15563920668723498)
,p_db_column_name=>'Name'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15564001488723498)
,p_db_column_name=>'Protection'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Page Access Protection'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15564102704723498)
,p_db_column_name=>'PAGE_ITEMS'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Page Items'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15564213332723499)
,p_db_column_name=>'ID'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15566705831826913)
,p_db_column_name=>'PAGE_TYPE'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Page Type'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15567109771837456)
,p_db_column_name=>'UPDATED'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15567224214837461)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47982212654038334)
,p_db_column_name=>'PAGE_IS_PUBLIC_Y_N'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Page Is Public'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47982329750038342)
,p_db_column_name=>'ALLOW_DUPLICATE_SUBMISSIONS'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Allow Duplicate Submissions'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(15564413393724967)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_type=>'REPORT'
,p_report_alias=>'1295812939536645'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'PAGE:Name:Protection:PAGE_ITEMS:PAGE_TYPE'
,p_sort_column_1=>'PAGE'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'UPDATED'
,p_sort_direction_2=>'DESC'
,p_chart_type=>'pie'
,p_chart_label_column=>'Protection'
,p_chart_value_column=>'0'
,p_chart_aggregate=>'COUNT'
,p_chart_sorting=>'DEFAULT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(107379420123663984)
,p_plug_name=>'Application Session State Protection  Controls'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>100
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(468051002564332724)
,p_plug_name=>'Session State Protection'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>140
,p_plug_new_grid_row=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Use this page to report the Page Access Protection attributes for all pages in the application. Use the page link to select a specific page in order to report and set page and item session state protections attributes on that page.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(107404229668819788)
,p_branch_action=>'f?p=&FLOW_ID.:512:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(107380027050665989)
,p_name=>'P512_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(107379420123663984)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application:'
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'This attribute identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(107381105710669241)
,p_name=>'P512_APPLICATION_SESS_SEC'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(107379420123663984)
,p_item_default=>'N'
,p_prompt=>'Session State Protection:'
,p_source=>'select PAGE_PROTECTION_ENABLED_Y_N from wwv_flows where id = :fb_flow_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'ENABLED_DISABLED_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(91439803955181562)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p />',
'Indicates whether Session State Protection is enabled or disabled. When enabled, this feature, uses the <i>Page Access Protection</i> page attributes and the <i>Session State Protection</i> item attributes in conjunction with checksums positioned in '
||'"f?p=" URLs. The feature prevents URL tampering and unauthorized access to and alteration of session state. ',
'<p />',
'When this feature is disabled, the page and item attributes related to session state protection are ignored and checksums are not included checksums in generated "f?p=" URLs.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(107684910996777811)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'512'
,p_compute_when_type=>'%null%'
);
end;
/
prompt --application/pages/page_00513
begin
wwv_flow_imp_page.create_page(
 p_id=>513
,p_name=>'Protection By Item'
,p_alias=>'PROTECTION-BY-ITEM'
,p_step_title=>'Protection By Item'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(262753407599695606)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_session_protection.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(15568426358851702)
,p_plug_name=>'Item Session State Protection '
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P4513a */	 "WWV_FLOW_STEPS".ID as "ID",',
'	 "WWV_FLOW_STEPS".NAME as "Page",',
'	 nvl("WWV_FLOW_STEPS".PROTECTION_LEVEL,''N'') as "Page Protection",',
'	 "WWV_FLOW_STEP_ITEMS".NAME as "Item",',
'	 "WWV_FLOW_STEP_ITEMS".ITEM_SEQUENCE as "Sequence",',
'	 (select plug_name from wwv_flow_page_plugs where id = "WWV_FLOW_STEP_ITEMS".ITEM_PLUG_ID) as "Region",',
'	 nvl(WWV_FLOW_STEPS.PROTECTION_LEVEL,''N'') as "PAGE_PROTECTION",',
'	 nvl("WWV_FLOW_STEP_ITEMS".PROTECTION_LEVEL,''N'') as "PROTECTION_LEVEL",',
'         nvl(WWV_FLOW_STEP_ITEMS.last_updated_on,WWV_FLOW_STEP_ITEMS.created_on) updated,',
'         nvl(WWV_FLOW_STEP_ITEMS.last_updated_by,WWV_FLOW_STEP_ITEMS.created_by) updated_by ',
' from	 #OWNER#."WWV_FLOW_STEP_ITEMS" "WWV_FLOW_STEP_ITEMS",',
'	 #OWNER#."WWV_FLOW_STEPS" "WWV_FLOW_STEPS" ',
' where   WWV_FLOW_STEP_ITEMS.FLOW_STEP_ID=WWV_FLOW_STEPS.ID and',
'         WWV_FLOW_STEP_ITEMS.FLOW_ID = :fb_flow_id and',
'         WWV_FLOW_STEPS.FLOW_ID = :fb_flow_id and',
'         wwv_flow_steps.security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(15568515892851702)
,p_name=>'Item Session State Protection '
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15568709474851708)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Page'
,p_column_link=>'f?p=&APP_ID.:515:&SESSION.::&DEBUG.:515:P515_ID,P515_FLOW_ID:#ID#,&FB_FLOW_ID.'
,p_column_linktext=>'#ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15568800078851709)
,p_db_column_name=>'Page'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Page Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15568915133851709)
,p_db_column_name=>'Page Protection'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'URL Access Protection'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15569000539851709)
,p_db_column_name=>'Item'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Item Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15569132662851709)
,p_db_column_name=>'Sequence'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Sequence'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15569223797851709)
,p_db_column_name=>'Region'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Region'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15569326705851709)
,p_db_column_name=>'PROTECTION_LEVEL'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Item Session State Protection'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(109261519627066371)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15570520039906667)
,p_db_column_name=>'PAGE_PROTECTION'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Page Protection'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15573023895936154)
,p_db_column_name=>'UPDATED'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15573107965936154)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(15569527910852203)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1295925164536645'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'ID:Page:Item:Sequence:Region:PROTECTION_LEVEL:PAGE_PROTECTION'
,p_sort_column_1=>'ID'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'UPDATED'
,p_sort_direction_2=>'DESC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47985106468064841)
,p_plug_name=>'Page Items'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Use this page to report the session state protection levels for all page items in the application. Use the page link to select one page at a time in order to set the session state protection attributes for items on that page.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(107659716874703894)
,p_plug_name=>'Application Session State Protection  Controls'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(107671012548724159)
,p_branch_action=>'f?p=&FLOW_ID.:513:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(107660424839706153)
,p_name=>'P513_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(107659716874703894)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application:'
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'This attribute identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(107661831765708161)
,p_name=>'P513_APP_SESS_STATE_SEC'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(107659716874703894)
,p_item_default=>'N'
,p_prompt=>'Session State Protection:'
,p_source=>'select PAGE_PROTECTION_ENABLED_Y_N from wwv_flows where id = :fb_flow_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'ENABLED_DISABLED_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(91439803955181562)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p />',
'Indicates whether Session State Protection is enabled or disabled. When enabled, this feature, uses the <i>Page Access Protection</i> page attributes and the <i>Session State Protection</i> item attributes in conjunction with checksums positioned in '
||'"f?p=" URLs. The feature prevents URL tampering and unauthorized access to and alteration of session state. ',
'<p />',
'When this feature is disabled, the page and item attributes related to session state protection are ignored and checksums are not included checksums in generated "f?p=" URLs.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(107685719308780262)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'513'
,p_compute_when_type=>'%null%'
);
end;
/
prompt --application/pages/page_00514
begin
wwv_flow_imp_page.create_page(
 p_id=>514
,p_name=>'Table Finder'
,p_alias=>'TABLE-FINDER'
,p_step_title=>'Table Finder'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(19943204431962826)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_srch.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6217914052048898)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>60
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6218805138048905)
,p_plug_name=>'Finder Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>50
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(6207014968942318)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(6235410232149121)
,p_name=>'Columns'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>130
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name, data_type, data_length, data_precision, data_scale, nullable',
'from sys.user_tab_columns c',
'where table_name = :p514_table_name',
'order by column_id'))
,p_display_when_condition=>':P514_TABLE_NAME is not null and :P514_VIEW = ''COLUMNS'''
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>50000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_row_count_max=>50000
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'P514_APPLICATION_OWNER'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(6236424561162724)
,p_query_column_id=>1
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Column Name'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(6236526063162724)
,p_query_column_id=>2
,p_column_alias=>'DATA_TYPE'
,p_column_display_sequence=>2
,p_column_heading=>'Data Type'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(6236620800162724)
,p_query_column_id=>3
,p_column_alias=>'DATA_LENGTH'
,p_column_display_sequence=>3
,p_column_heading=>'Length'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(6236730789162724)
,p_query_column_id=>4
,p_column_alias=>'DATA_PRECISION'
,p_column_display_sequence=>4
,p_column_heading=>'Precision'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(6236829909162724)
,p_query_column_id=>5
,p_column_alias=>'DATA_SCALE'
,p_column_display_sequence=>5
,p_column_heading=>'Scale'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(33943015271890311)
,p_query_column_id=>6
,p_column_alias=>'NULLABLE'
,p_column_display_sequence=>6
,p_column_heading=>'Nullable'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(84259319526460470)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6243023354200253)
,p_plug_name=>'Query'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>140
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    q varchar2(32767);',
'begin',
'    q := ''&nbsp;<p />select'';',
'    for c1 in ( select column_name',
'                  from wwv_flow_table_columns_dev c',
'                 where table_name = :p514_table_name )',
'    loop',
'        q := q||''<br />'';',
'        q := q||''&nbsp;&nbsp;&nbsp;&nbsp;''||wwv_flow_escape.html(c1.column_name)||'','';',
'    end loop;',
'    q := rtrim(q,'','')||''<br />from ''||wwv_flow_escape.html(:p514_table_name);',
'    sys.htp.p(q);',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P514_TABLE_NAME is not null and :P514_VIEW = ''QUERY'''
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(478899929205775865)
,p_plug_name=>'Tables'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>100
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_id, table_name, num_rows, ',
'       t.last_analyzed, ''TABLE'' object_type',
'from sys.user_tables t, sys.user_objects o',
'where o.object_name = t.table_name',
'and   o.object_type = ''TABLE''',
'union all',
'select object_id, view_name table_name, null num_rows, ',
'       null last_analyzed, ''VIEW'' object_type',
'from sys.user_views v, sys.user_objects o',
'where o.object_name = v.view_name',
'and   o.object_type = ''VIEW'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_parse_override=>'P514_APPLICATION_OWNER'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P514_VIEW'
,p_plug_display_when_cond2=>'TABLES'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(478900029710775865)
,p_name=>'Tables'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(478900326931775900)
,p_db_column_name=>'TABLE_NAME'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>'Table Name'
,p_column_link=>'f?p=&APP_ID.:514:&SESSION.::&DEBUG.:RP:P514_OBJECT_ID,P514_VIEW:#OBJECT_ID#,COLUMNS'
,p_column_linktext=>'#TABLE_NAME#'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(478900401730775902)
,p_db_column_name=>'NUM_ROWS'
,p_display_order=>2
,p_column_identifier=>'C'
,p_column_label=>'Rows'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(478900510317775904)
,p_db_column_name=>'LAST_ANALYZED'
,p_display_order=>3
,p_column_identifier=>'D'
,p_column_label=>'Last Analyzed'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(478900627368775905)
,p_db_column_name=>'OBJECT_TYPE'
,p_display_order=>4
,p_column_identifier=>'E'
,p_column_label=>'Type'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(478900219899775899)
,p_db_column_name=>'OBJECT_ID'
,p_display_order=>5
,p_column_identifier=>'A'
,p_column_label=>'Object Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(478900807852776971)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1296031271536645'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'TABLE_NAME:NUM_ROWS:LAST_ANALYZED:OBJECT_TYPE:OBJECT_ID'
,p_sort_column_1=>'TABLE_NAME'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(478904616126826610)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(6217914052048898)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:514:&SESSION.::&DEBUG.:RIR,514::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(171289413896152205)
,p_branch_action=>'f?p=&APP_ID.:514:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6234831572145899)
,p_name=>'P514_TABLE_NAME'
,p_item_sequence=>75
,p_item_plug_id=>wwv_flow_imp.id(6217914052048898)
,p_prompt=>'Table:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'P514_TABLE_NAME'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Selected table or view.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(56560405022518846)
,p_name=>'P514_OBJECT_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(6235410232149121)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(171246514130594035)
,p_name=>'P514_VIEW'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(6217914052048898)
,p_prompt=>'Show'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'POPUP TABLE FINDER VIEW OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(171249216657727210)||'.'
,p_cSize=>64
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Allows you to change the display, once a table or view is selected.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(238734106943199432)
,p_name=>'P514_APPLICATION_OWNER'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(6217914052048898)
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(238734824951204611)
,p_computation_sequence=>20
,p_computation_item=>'P514_APPLICATION_OWNER'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select owner',
'  from wwv_flows',
' where id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(56561327532525319)
,p_computation_sequence=>30
,p_computation_item=>'P514_TABLE_NAME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name from sys.dba_objects',
'where object_id = :P514_OBJECT_ID',
'and   owner = (select owner from wwv_flows where id = :fb_flow_id)'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(171248724360710574)
,p_computation_sequence=>40
,p_computation_item=>'P514_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'TABLES'
,p_compute_when=>'P514_VIEW'
,p_compute_when_type=>'ITEM_IS_NULL'
);
end;
/
prompt --application/pages/page_00515
begin
wwv_flow_imp_page.create_page(
 p_id=>515
,p_name=>'Set Page and Item Protection'
,p_alias=>'SET-PAGE-AND-ITEM-PROTECTION'
,p_step_title=>'Set Page and Item Protection'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(262753407599695606)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_session_protection.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(107452431597085754)
,p_plug_name=>'Set Page and Item Protection'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>100
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(107455315318085771)
,p_name=>'Page Items (Form Items)'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>125
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'"ID",',
'"FLOW_ID",',
'"NAME",',
'"ITEM_SEQUENCE",',
'"ITEM_PLUG_ID",',
'"PROMPT",',
'"DISPLAY_AS",',
'"PROTECTION_LEVEL"',
'from "#OWNER#"."WWV_FLOW_STEP_ITEMS"',
'where "FLOW_ID" = :FB_FLOW_ID and flow_step_id = :p515_ID',
'and display_as not in (''NATIVE_DISPLAY_ONLY'', ''TEXT_DISABLED'', ''NATIVE_STOP_AND_START_HTML_TABLE'')'))
,p_display_when_condition=>':P515_FLOW_ID is not null and :P515_ITEM_TYPE=''FORM'''
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No data entry items on page.'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(107455621420085774)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>16
,p_pk_col_source_type=>'T'
,p_lov_display_extra=>'YES'
,p_ref_schema=>'FLOWS_020000'
,p_ref_table_name=>'WWV_FLOW_STEP_ITEMS'
,p_ref_column_name=>'ID'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(107455728607085774)
,p_query_column_id=>2
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>2
,p_column_heading=>'Application'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>16
,p_lov_display_extra=>'YES'
,p_ref_schema=>'FLOWS_020000'
,p_ref_table_name=>'WWV_FLOW_STEP_ITEMS'
,p_ref_column_name=>'FLOW_ID'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(107455828342085774)
,p_query_column_id=>3
,p_column_alias=>'NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Item Name'
,p_use_as_row_header=>'Y'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_ref_schema=>'FLOWS_020000'
,p_ref_table_name=>'WWV_FLOW_STEP_ITEMS'
,p_ref_column_name=>'NAME'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(107455925732085774)
,p_query_column_id=>4
,p_column_alias=>'ITEM_SEQUENCE'
,p_column_display_sequence=>5
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_ref_schema=>'FLOWS_020000'
,p_ref_table_name=>'WWV_FLOW_STEP_ITEMS'
,p_ref_column_name=>'ITEM_SEQUENCE'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(107456021564085774)
,p_query_column_id=>5
,p_column_alias=>'ITEM_PLUG_ID'
,p_column_display_sequence=>4
,p_column_heading=>'Region'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_inline_lov=>'select plug_name, id from wwv_flow_page_plugs where flow_id = :fb_flow_id and page_id = :p515_id'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_ref_schema=>'FLOWS_020000'
,p_ref_table_name=>'WWV_FLOW_STEP_ITEMS'
,p_ref_column_name=>'ITEM_PLUG_ID'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(107456110175085775)
,p_query_column_id=>6
,p_column_alias=>'PROMPT'
,p_column_display_sequence=>6
,p_column_heading=>'Label'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_ref_schema=>'FLOWS_020000'
,p_ref_table_name=>'WWV_FLOW_STEP_ITEMS'
,p_ref_column_name=>'PROMPT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(107456228953085775)
,p_query_column_id=>7
,p_column_alias=>'DISPLAY_AS'
,p_column_display_sequence=>7
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
,p_ref_schema=>'FLOWS_020000'
,p_ref_table_name=>'WWV_FLOW_STEP_ITEMS'
,p_ref_column_name=>'DISPLAY_AS'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(109376012088887101)
,p_query_column_id=>8
,p_column_alias=>'PROTECTION_LEVEL'
,p_column_display_sequence=>8
,p_column_heading=>'Item Session State Protection'
,p_use_as_row_header=>'N'
,p_display_as=>'SELECT_LIST_FROM_LOV'
,p_named_lov=>wwv_flow_imp.id(109314413723246310)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'NO'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(107470709706134079)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(107470807208134086)
,p_column_sequence=>2
,p_query_column_name=>'FLOW_ID'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(107470903911134086)
,p_column_sequence=>3
,p_query_column_name=>'NAME'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(107471020045134086)
,p_column_sequence=>4
,p_query_column_name=>'ITEM_SEQUENCE'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(107471123550134086)
,p_column_sequence=>5
,p_query_column_name=>'ITEM_PLUG_ID'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(107471225409134086)
,p_column_sequence=>6
,p_query_column_name=>'PROMPT'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(107471310390134086)
,p_column_sequence=>7
,p_query_column_name=>'DISPLAY_AS'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(109375825680887098)
,p_column_sequence=>8
,p_query_column_name=>'PROTECTION_LEVEL'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(109355116414409031)
,p_name=>'Page Items (Display-Only Items)'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>135
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'"ID",',
'"FLOW_ID",',
'"NAME",',
'"ITEM_SEQUENCE",',
'"ITEM_PLUG_ID",',
'"PROMPT",',
'"DISPLAY_AS",',
'"PROTECTION_LEVEL"',
'from "#OWNER#"."WWV_FLOW_STEP_ITEMS"',
'where "FLOW_ID" = :FB_FLOW_ID and flow_step_id = :p515_ID',
'and display_as in (''NATIVE_DISPLAY_ONLY'', ''TEXT_DISABLED'', ''NATIVE_STOP_AND_START_HTML_TABLE'')'))
,p_display_when_condition=>':P515_FLOW_ID is not null and :P515_ITEM_TYPE=''DISPLAY'''
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No display-only items on page.'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(109355410660409036)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>16
,p_pk_col_source_type=>'T'
,p_ref_schema=>'FLOWS_020000'
,p_ref_table_name=>'WWV_FLOW_STEP_ITEMS'
,p_ref_column_name=>'ID'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(109355501228409036)
,p_query_column_id=>2
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>2
,p_column_heading=>'Application'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>16
,p_ref_schema=>'FLOWS_020000'
,p_ref_table_name=>'WWV_FLOW_STEP_ITEMS'
,p_ref_column_name=>'FLOW_ID'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(109355614340409036)
,p_query_column_id=>3
,p_column_alias=>'NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Item Name'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_ref_schema=>'FLOWS_020000'
,p_ref_table_name=>'WWV_FLOW_STEP_ITEMS'
,p_ref_column_name=>'NAME'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(109355730378409037)
,p_query_column_id=>4
,p_column_alias=>'ITEM_SEQUENCE'
,p_column_display_sequence=>5
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_column_width=>16
,p_ref_schema=>'FLOWS_020000'
,p_ref_table_name=>'WWV_FLOW_STEP_ITEMS'
,p_ref_column_name=>'ITEM_SEQUENCE'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(109355813836409037)
,p_query_column_id=>5
,p_column_alias=>'ITEM_PLUG_ID'
,p_column_display_sequence=>4
,p_column_heading=>'Region'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_inline_lov=>'select plug_name, id from wwv_flow_page_plugs where flow_id = :fb_flow_id and page_id = :p515_id'
,p_lov_show_nulls=>'NO'
,p_column_width=>16
,p_ref_schema=>'FLOWS_020000'
,p_ref_table_name=>'WWV_FLOW_STEP_ITEMS'
,p_ref_column_name=>'ITEM_PLUG_ID'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(109355922567409037)
,p_query_column_id=>6
,p_column_alias=>'PROMPT'
,p_column_display_sequence=>6
,p_column_heading=>'Label'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_column_width=>16
,p_ref_schema=>'FLOWS_020000'
,p_ref_table_name=>'WWV_FLOW_STEP_ITEMS'
,p_ref_column_name=>'PROMPT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(109356030331409037)
,p_query_column_id=>7
,p_column_alias=>'DISPLAY_AS'
,p_column_display_sequence=>7
,p_column_heading=>'Display As'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_column_width=>12
,p_ref_schema=>'FLOWS_020000'
,p_ref_table_name=>'WWV_FLOW_STEP_ITEMS'
,p_ref_column_name=>'DISPLAY_AS'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(109377403449890174)
,p_query_column_id=>8
,p_column_alias=>'PROTECTION_LEVEL'
,p_column_display_sequence=>8
,p_column_heading=>'Item Session State Protection'
,p_use_as_row_header=>'N'
,p_display_as=>'SELECT_LIST_FROM_LOV'
,p_named_lov=>wwv_flow_imp.id(17287012676783081)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'NO'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(109357827281421629)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(109357932477421629)
,p_column_sequence=>2
,p_query_column_name=>'FLOW_ID'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(109358001740421629)
,p_column_sequence=>3
,p_query_column_name=>'NAME'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(109358100051421629)
,p_column_sequence=>4
,p_query_column_name=>'ITEM_SEQUENCE'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(109358202143421629)
,p_column_sequence=>5
,p_query_column_name=>'ITEM_PLUG_ID'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(109358315514421629)
,p_column_sequence=>6
,p_query_column_name=>'PROMPT'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(109358423336421629)
,p_column_sequence=>7
,p_query_column_name=>'DISPLAY_AS'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(109377206773890170)
,p_column_sequence=>8
,p_query_column_name=>'PROTECTION_LEVEL'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(179341427720175757)
,p_plug_name=>'Page and Item Protection'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>55
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'Use this page to report and set the Page Access Protection level for the current page and to report and set the Session State Protection level for each item on the page.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(886492704178981503)
,p_plug_name=>'Set Page and Item Protection'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(107452915725085755)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(886492704178981503)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(107452706382085755)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(886492704178981503)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P515_FLOW_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(109364307588794495)
,p_branch_name=>'Go To Page 515'
,p_branch_action=>'f?p=&APP_ID.:515:&SESSION.::&DEBUG.:RP::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>31
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'P515_ITEM_TYPE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(107458201488085786)
,p_branch_action=>'f?p=&APP_ID.:515:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>70
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(107453526628085757)
,p_name=>'P515_FLOW_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(107452431597085754)
,p_use_cache_before_default=>'NO'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(107453701465085759)
,p_name=>'P515_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(107452431597085754)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Page:'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'Identifies the current page number.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(107453904227085761)
,p_name=>'P515_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(107452431597085754)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name:'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'Identifies the current page name.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(107454319951085767)
,p_name=>'P515_PAGE_IS_PUBLIC_Y_N'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(107452431597085754)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Page Authentication '
,p_source=>'PAGE_IS_PUBLIC_Y_N'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE.PUBLIC'
,p_lov=>'.'||wwv_flow_imp.id(84921112902747500)||'.'
,p_cHeight=>1
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Indicates whether the page requires authentication or is a public page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(107454504672085768)
,p_name=>'P515_PROTECTION_LEVEL'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(107452431597085754)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Page Access Protection'
,p_source=>'PROTECTION_LEVEL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE PROTECTION LEVEL'
,p_lov=>'.'||wwv_flow_imp.id(17255429593772638)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select a Page Access Protection Level:',
'<ul>',
'<li><strong>Unrestricted</strong> - The page may be requested using an URL with or without session state arguments (Request, Clear Cache, Name/Values).</li>',
'<li><strong>Arguments Must Have Checksum</strong> - If Request, Clear Cache, or Name/Value arguments appear in the URL, a checksum must also be provided. The checksum type must be compatible with the most stringent Session State Protection attribute '
||'of all the items passed as arguments.</li>',
'<li><strong>No Arguments Allowed</strong> - A URL may be used to request the page but no Request, Clear Cache, or Name/Value arguments are allowed.</li>',
'<li><strong>No URL Access</strong> - The page may not be accessed using a URL, however the page may be the target of a Branch to Page branch type, which does not do a URL redirect.</li> ',
'</ul>    '))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(107646522668648728)
,p_name=>'P515_APP_SEC_STATE_SEC'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(107452431597085754)
,p_item_default=>'N'
,p_prompt=>'Session State Protection:'
,p_source=>'select PAGE_PROTECTION_ENABLED_Y_N from wwv_flows where id = :fb_flow_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'ENABLED_DISABLED_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(91439803955181562)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Indicates whether Session State Protection is enabled or disabled. ',
'<p>When <strong>enabled</strong>, this feature, uses the <i>Page Access Protection</i> page attributes and the <i>Session State Protection</i> item attributes in conjunction with checksums positioned in "f?p=" URLs. The feature prevents URL tampering'
||' and unauthorized access to and alteration of session state. ',
'<p>When this feature is <strong>disabled</strong>, the page and item attributes related to session state protection are ignored and checksums are not included checksums in generated "f?p=" URLs.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(109363408842785369)
,p_name=>'P515_ITEM_TYPE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(107452431597085754)
,p_item_default=>'FORM'
,p_prompt=>'Display Item Type:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'FORM_ITEM_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(276983704971116375)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_escape_on_http_output=>'N'
,p_help_text=>'Show individual reports of Data Entry items and Display-Only items. Data Entry items are items that can be altered using forms and include hidden items. Display-Only items are rendered only and are not submitted with the form.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(111788926376356410)
,p_name=>'P515_APPLICATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(107452431597085754)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application:'
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(107454714523085768)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_STEPS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_STEPS'
,p_attribute_03=>'P515_FLOW_ID'
,p_attribute_04=>'FLOW_ID'
,p_attribute_05=>'P515_ID'
,p_attribute_06=>'ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Unable to fetch row.'
,p_process_when=>'P515_FLOW_ID'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'&FB_FLOW_ID.'
,p_internal_uid=>107454714523085768
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(107457318076085783)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(109355116414409031)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'ApplyMRU'
,p_attribute_02=>'WWV_FLOW_STEP_ITEMS'
,p_attribute_03=>'ID'
,p_attribute_04=>'FLOW_ID'
,p_attribute_05=>'flow_id = :FB_FLOW_ID and security_group_id = :WORKSPACE_ID'
,p_process_error_message=>'Unable to process update.'
,p_process_when_button_id=>wwv_flow_imp.id(107452706382085755)
,p_exec_cond_for_each_row=>'Y'
,p_process_success_message=>'  #MRU_COUNT# row(s) updated, #MRI_COUNT# row(s) inserted.'
,p_internal_uid=>107457318076085783
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(107454925018085769)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_STEPS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_STEPS'
,p_attribute_03=>'P515_FLOW_ID'
,p_attribute_04=>'FLOW_ID'
,p_attribute_05=>'P515_ID'
,p_attribute_06=>'ID'
,p_attribute_11=>'U'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Unable to process row of table WWV_FLOW_STEPS.'
,p_process_when_button_id=>wwv_flow_imp.id(107452706382085755)
,p_process_when=>'P515_FLOW_ID'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'&FB_FLOW_ID.'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>107454925018085769
);
end;
/
prompt --application/pages/page_00516
begin
wwv_flow_imp_page.create_page(
 p_id=>516
,p_name=>'Page Finder'
,p_alias=>'PAGE-FINDER'
,p_step_title=>'Page Finder'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(19943204431962826)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_srch.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6257016079472811)
,p_plug_name=>'Finder Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>91
,p_list_id=>wwv_flow_imp.id(6207014968942318)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(478906730209866600)
,p_plug_name=>'Pages'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>140
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id, name, alias, page_mode,',
'       (select count(*) from wwv_flow_step_items ',
'         where flow_id = :fb_flow_id and flow_step_id = p.id) items, ',
'       step_title, tab_set,',
'       (select count(*) from wwv_flow_page_plugs ',
'         where flow_id = :fb_flow_id and page_id = p.id) regions',
'  from wwv_flow_steps p',
' where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(478906809191866600)
,p_name=>'Pages'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(478907026507866606)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Page'
,p_column_link=>'f?p=&APP_ID.:273:&SESSION.::&DEBUG.::F4000_P273_PAGE:#ID#'
,p_column_linktext=>'#ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(478907109093866607)
,p_db_column_name=>'NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(478907213582866609)
,p_db_column_name=>'ALIAS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Alias'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(478907412212866612)
,p_db_column_name=>'STEP_TITLE'
,p_display_order=>4
,p_column_identifier=>'E'
,p_column_label=>'Title'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(478907515351866613)
,p_db_column_name=>'TAB_SET'
,p_display_order=>5
,p_column_identifier=>'F'
,p_column_label=>'Tab Set'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(478907311087866610)
,p_db_column_name=>'ITEMS'
,p_display_order=>6
,p_column_identifier=>'D'
,p_column_label=>'Items'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(478907626758866615)
,p_db_column_name=>'REGIONS'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Regions'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(44906829156254720)
,p_db_column_name=>'PAGE_MODE'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Page Mode'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_imp.id(44400703264122475)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(478908119205874812)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1296114163536645'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'ID:NAME:ALIAS:STEP_TITLE:TAB_SET:ITEMS:REGIONS:PAGE_MODE'
,p_sort_column_1=>'ID'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(478909323838885640)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(478906730209866600)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:516:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(6259102851472823)
,p_branch_action=>'f?p=&APP_ID.:516:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
end;
/
prompt --application/pages/page_00517
begin
wwv_flow_imp_page.create_page(
 p_id=>517
,p_name=>'Confirm Request to Invalidate Bookmarked Links'
,p_alias=>'CONFIRM-REQUEST-TO-INVALIDATE-BOOKMARKED-LINKS'
,p_step_title=>'Confirm Invalidate Bookmarks'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213425326892450628)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'sec.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(109449704383328885)
,p_plug_name=>'Confirm Invalidate Bookmarks'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>100
,p_plug_header=>'You have requested that externally bookmarked links to pages in application &FB_FLOW_ID. be invalidated now. This will make any URLs that users have bookmarked and which contain checksums to cease to be valid for accessing this application. This appl'
||'ies only if your application has its Session State Protection attribute set to <i>Enabled</i>. Please confirm your request or cancel.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1119156585936390628)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(109454430617328913)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1119156585936390628)
,p_button_name=>'CONFIRM'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Invalidate Bookmarked Links'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(109454202683328908)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1119156585936390628)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:509:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(109474320921627003)
,p_branch_action=>'f?p=&APP_ID.:509:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(109454430617328913)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1146879622660737846)
,p_name=>'P517_BOOKMARK_HASH_FUNCTION'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(109449704383328885)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Bookmark Hash Function'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'coalesce (',
'    wwv_flow_platform.get_preference(''CHECKSUM_HASH_FUNCTION''),',
'    wwv_flow_crypto.c_hash_best )'))
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'HASH_FUNCTION'
,p_lov=>'.'||wwv_flow_imp.id(367957504585280755)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the hash function algorithm that should be used for bookmarkable URLs.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(109455826347328930)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Reset Checksum Salt'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_security.reset_app_checksum_salt (',
'    p_flow_id  => :FB_FLOW_ID,',
'    p_function => :P517_BOOKMARK_HASH_FUNCTION );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error during bookmark invalidation.'
,p_process_when_button_id=>wwv_flow_imp.id(109454430617328913)
,p_process_success_message=>'Bookmarks invalidated.'
,p_internal_uid=>109455826347328930
);
end;
/
prompt --application/pages/page_00518
begin
wwv_flow_imp_page.create_page(
 p_id=>518
,p_name=>'Protection By Application Item'
,p_alias=>'PROTECTION-BY-APPLICATION-ITEM'
,p_step_title=>'Protection by Application Item'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(262753407599695606)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_session_protection.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30844021035293190)
,p_plug_name=>'Application Level Items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select	/* APEX 4000P518a */  "WWV_FLOW_ITEMS".NAME,',
'	 "WWV_FLOW_ITEMS".ID,',
'	 decode(nvl("WWV_FLOW_ITEMS".PROTECTION_LEVEL,''N''),',
'          	''N'', ''Unrestricted'',',
'	        ''B'',''Checksum Required - Application Level'',',
'                ''P'',''Checksum Required - User Level'',	 	 ',
'	        ''S'',''Checksum Required - Session Level'',	 	 ',
'	        ''I'', ''Restricted - May not be set from browser'') protection_level',
' from	 "WWV_FLOW_ITEMS" "WWV_FLOW_ITEMS"',
'where flow_id = :fb_flow_id',
'and security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(30844101953293190)
,p_name=>'Application Level Items'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30844430051293195)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30844315176293193)
,p_db_column_name=>'NAME'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>'Application Item'
,p_column_link=>'f?p=&APP_ID.:4303:&SESSION.::&DEBUG.:4303:F4000_P4303_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30844525523293195)
,p_db_column_name=>'PROTECTION_LEVEL'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Item Session State Protection'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(30844726695293414)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1296230037536645'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'ID:NAME:PROTECTION_LEVEL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(107853421113386388)
,p_plug_name=>'Application Items'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'Application items are named session state variables that are not specific to a particular page. Use this page to report the Session State Protection attributes for application items.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(110188028299524278)
,p_plug_name=>'top bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_footer=>'<p />'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(107814429319308964)
,p_branch_action=>'f?p=&FLOW_ID.:518:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(110175312051396584)
,p_name=>'P518_APP_SEC_STATE_SEC'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(110188028299524278)
,p_item_default=>'N'
,p_prompt=>'Session State Protection:'
,p_source=>'select PAGE_PROTECTION_ENABLED_Y_N from wwv_flows where id = :fb_flow_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'ENABLED_DISABLED_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(91439803955181562)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p />',
'Indicates whether Session State Protection is enabled or disabled. When enabled, this feature, uses the <i>Page Access Protection</i> page attributes and the <i>Session State Protection</i> item attributes in conjunction with checksums positioned in '
||'"f?p=" URLs. The feature prevents URL tampering and unauthorized access to and alteration of session state. ',
'<p />',
'When this feature is disabled, the page and item attributes related to session state protection are ignored and checksums are not included checksums in generated "f?p=" URLs.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(110184315093492024)
,p_name=>'P518_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(110188028299524278)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application:'
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'This attribute identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(107842331325351415)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'518'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(107815521797310859)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pg'
,p_attribute_01=>'THIS_PAGE'
,p_internal_uid=>107815521797310859
);
end;
/
prompt --application/pages/page_00519
begin
wwv_flow_imp_page.create_page(
 p_id=>519
,p_name=>'PWA Screenshot'
,p_alias=>'PWA-SCREENSHOT'
,p_page_mode=>'MODAL'
,p_step_title=>'PWA Screenshot'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#P519_DISPLAY_SCREENSHOT {',
'    max-height: 350px;',
'    width: 100%;',
'    height: 100%;',
'    object-fit: contain;',
'}'))
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'530'
,p_protection_level=>'C'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2203008974388922)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(168181399315070830)
,p_plug_name=>'Screenshots'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_PWA_SCREENSHOTS'
,p_include_rowid_column=>false
,p_is_editable=>false
,p_plug_source_type=>'NATIVE_FORM'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8204291673126627)
,p_plug_name=>'Screenshot Image'
,p_region_name=>'ScreenshotImage'
,p_parent_plug_id=>wwv_flow_imp.id(168181399315070830)
,p_region_template_options=>'#DEFAULT#:a-Form--labelsAbove:a-Region--slimPadding:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_item_display_point=>'BELOW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8204332176126628)
,p_plug_name=>'Screenshot Data'
,p_parent_plug_id=>wwv_flow_imp.id(168181399315070830)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--slimPadding:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>80
,p_plug_grid_column_span=>8
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8205500452126640)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(2203008974388922)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_confirm_message=>'Delete this screenshot?'
,p_confirm_style=>'warning'
,p_button_condition=>'P519_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2205400334388946)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(2203008974388922)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>'P519_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3816198318116201)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(2203008974388922)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save'
,p_button_position=>'NEXT'
,p_button_condition=>'P519_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2204121045388933)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2203008974388922)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2204546720388937)
,p_name=>'P519_FILE_BROWSE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(8204332176126628)
,p_prompt=>'Screenshot'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>45
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_attribute_01=>'APEX_APPLICATION_TEMP_FILES'
,p_attribute_09=>'SESSION'
,p_attribute_10=>'N'
,p_attribute_11=>'image/*'
,p_attribute_12=>'DROPZONE_INLINE'
,p_attribute_13=>'Upload a Screenshot'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2205017152388942)
,p_name=>'P519_DISPLAY_SCREENSHOT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(8204291673126627)
,p_prompt=>'Crop your screenshot for a perfect fit'
,p_display_as=>'NATIVE_DISPLAY_IMAGE'
,p_field_template=>wwv_flow_imp.id(4923925522744860)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'SQL'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sf.file_content as blob_content,',
'       sf.file_name    as alt_text,',
'       sf.file_name    as filename,',
'       sf.mime_type    as mime_type',
'  from wwv_flow_pwa_screenshots ps,',
'       wwv_flow_static_files sf',
' where ps.security_group_id = :workspace_id',
'   and ps.flow_id           = :fb_flow_id',
'   and ps.id                = :p519_id',
'   and sf.security_group_id = ps.security_group_id',
'   and sf.flow_id           = ps.flow_id',
'   and sf.file_name         = ps.screenshot_url',
'   and :p519_file_browse    is null',
'   and :p519_id             is not null'))
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8202590856126610)
,p_name=>'P519_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(168181399315070830)
,p_item_source_plug_id=>wwv_flow_imp.id(168181399315070830)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'S'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8202812523126613)
,p_name=>'P519_LABEL'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(8204332176126628)
,p_item_source_plug_id=>wwv_flow_imp.id(168181399315070830)
,p_prompt=>'Description'
,p_source=>'LABEL'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>45
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identify the label of the PWA screenshot that is used for accessibility purposes when installing the PWA.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8202997924126614)
,p_name=>'P519_DISPLAY_SEQUENCE'
,p_source_data_type=>'NUMBER'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(8204332176126628)
,p_item_source_plug_id=>wwv_flow_imp.id(168181399315070830)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_display_sequence number;',
'begin',
'    select max(display_sequence)',
'      into l_display_sequence',
'      from wwv_flow_pwa_screenshots',
'     where security_group_id = :workspace_id',
'       and flow_id           = :fb_flow_id;',
'',
'    return nvl(l_display_sequence, 0) + 10;',
'exception when others then',
'    return 10;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Sequence'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_source=>'DISPLAY_SEQUENCE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>45
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Identifies the display sequence used by this PWA screenshot.'
,p_attribute_03=>'left'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8203162915126616)
,p_name=>'P519_BUILD_OPTION_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(8204332176126628)
,p_item_source_plug_id=>wwv_flow_imp.id(168181399315070830)
,p_prompt=>'Build Option'
,p_source=>'BUILD_OPTION_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PATCHES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(patch_name) pn, id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'', wwv_flow_escape.html(patch_name))||',
'''} '' pn,0-id id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by pn'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Build Option -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the build option that this PWA screenshot uses.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8203259054126617)
,p_name=>'P519_PWA_SCREENSHOT_COMMENT'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(8204332176126628)
,p_item_source_plug_id=>wwv_flow_imp.id(168181399315070830)
,p_prompt=>'Comments'
,p_source=>'PWA_SCREENSHOT_COMMENT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>35
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Developer comments associated with this PWA screenshot.'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8204927985126634)
,p_name=>'P519_SCREENSHOT_URL'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(168181399315070830)
,p_item_source_plug_id=>wwv_flow_imp.id(168181399315070830)
,p_source=>'SCREENSHOT_URL'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'S'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8205042067126635)
,p_name=>'P519_FLOW_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(168181399315070830)
,p_item_source_plug_id=>wwv_flow_imp.id(168181399315070830)
,p_item_default=>'FB_FLOW_ID'
,p_item_default_type=>'ITEM'
,p_source=>'FLOW_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_protection_level=>'S'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8205225267126637)
,p_name=>'P519_SECURITY_GROUP_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(168181399315070830)
,p_item_source_plug_id=>wwv_flow_imp.id(168181399315070830)
,p_item_default=>'WORKSPACE_ID'
,p_item_default_type=>'ITEM'
,p_source=>'SECURITY_GROUP_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_protection_level=>'S'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2204650730388938)
,p_validation_name=>'P519_FILE_BROWSE is invalid'
,p_validation_sequence=>10
,p_validation=>'return false;'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Invalid screenshot file.'
,p_validation_condition=>'UPLOAD_SCREENSHOT_INVALID'
,p_validation_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_associated_item=>wwv_flow_imp.id(2204546720388937)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(22348183549374601)
,p_validation_name=>'P519_FILE_BROWSE not null'
,p_validation_sequence=>20
,p_validation=>'P519_FILE_BROWSE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_when_button_pressed=>wwv_flow_imp.id(2205400334388946)
,p_associated_item=>wwv_flow_imp.id(2204546720388937)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2204758345388939)
,p_name=>'onChange P519_FILE_BROWSE'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P519_FILE_BROWSE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3816471211116204)
,p_event_id=>wwv_flow_imp.id(2204758345388939)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'$("#ScreenshotImage").html(`<img id="P519_DISPLAY_SCREENSHOT" src="${URL.createObjectURL(apex.items.P519_FILE_BROWSE.node.files[0])}" />`);'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1815223666588330)
,p_event_id=>wwv_flow_imp.id(2204758345388939)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P519_LABEL'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'apex.items.P519_FILE_BROWSE.node.files[0].name'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_client_condition_type=>'NULL'
,p_client_condition_element=>'P519_LABEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2204288581388934)
,p_name=>'onClick CANCEL'
,p_event_sequence=>40
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2204121045388933)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2204372681388935)
,p_event_id=>wwv_flow_imp.id(2204288581388934)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3816770605116207)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete file'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_file_id number;',
'begin',
'    select id ',
'      into l_file_id',
'      from wwv_flow_static_files ',
'     where security_group_id = :workspace_id ',
'       and flow_id           = :fb_flow_id',
'       and file_name         = :p519_screenshot_url;',
'',
'    wwv_flow_file_editor_dev.delete_file (',
'       p_id     => l_file_id,',
'       p_scope  => ''APP'',',
'       p_app_id => :fb_flow_id );',
'exception when others then ',
'    null; -- if anything happens don''t delete the file, that is fine',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(8205500452126640)
,p_internal_uid=>3816770605116207
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(8204156788126626)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Save file'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in ( select blob_content,',
'                      name,',
'                      filename,',
'                      mime_type',
'                 from wwv_flow_temp_files ',
'                where name = :p519_file_browse )',
'    loop',
'        :p519_screenshot_url := ''pwa/''||c1.filename;',
'',
'        wwv_flow_imp_shared.create_app_static_file(',
'            p_flow_id      => :fb_flow_id,',
'            p_file_name    => :p519_screenshot_url,',
'            p_mime_type    => c1.mime_type,',
'            p_file_charset => ''utf-8'',',
'            p_file_content => c1.blob_content );',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE,SAVE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_internal_uid=>8204156788126626
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(8204612871126631)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(168181399315070830)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Screenshots DML'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE,DELETE,SAVE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_internal_uid=>8204612871126631
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3816862233116208)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Cleanup files'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_file_id number;',
'begin',
'    for i in ( select id ',
'                 into l_file_id',
'                 from wwv_flow_static_files sf',
'                where sf.security_group_id = :workspace_id ',
'                  and sf.flow_id           = :fb_flow_id',
'                  and sf.file_name         like ''pwa/screenshot%''',
'                  and not exists ( select 1',
'                                     from wwv_flow_pwa_screenshots ps',
'                                    where ps.security_group_id = sf.security_group_id ',
'                                      and ps.flow_id           = sf.flow_id',
'                                      and ps.screenshot_url    = sf.file_name ) )',
'    loop',
'        wwv_flow_file_editor_dev.delete_file (',
'           p_id     => i.id,',
'           p_scope  => ''APP'',',
'           p_app_id => :fb_flow_id );',
'    end loop;',
'exception when others then ',
'    null; -- if anything happens don''t delete the file, that is fine',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3816198318116201)
,p_internal_uid=>3816862233116208
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(8204577798126630)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE,DELETE,SAVE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_internal_uid=>8204577798126630
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(8202486909126609)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(168181399315070830)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Add PWA Screenshots'
,p_internal_uid=>8202486909126609
);
end;
/
prompt --application/pages/page_00520
begin
wwv_flow_imp_page.create_page(
 p_id=>520
,p_name=>'Page Groups'
,p_alias=>'PAGE-GROUPS'
,p_step_title=>'Page Groups'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212903908539395030)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_group.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1386702222981723)
,p_plug_name=>'Page Groups'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>140
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id, ',
'       group_name, ',
'       group_desc, ',
'       referenced_pages,',
'       ''icon-sc-page-group'' icon_class,',
'       ''f?p=4000:521:''||:app_session||',
'       '':::521,RP,RIR:P521_ID:''||id edit_link,',
'       replace(group_name,''_'','' '')||',
'           '' (''||referenced_pages||'')'' icon_title, ',
'       round(100*referenced_pages/decode(t.total_pages,0,1,t.total_pages)) pct,',
'       round(100*referenced_pages/decode(t.total_pages,0,1,t.total_pages)) pct2',
'from',
'(',
'select id, ',
'       group_name, ',
'       group_desc,',
'       (select count(*) c ',
'        from wwv_flow_steps ',
'        where group_id = g.id and flow_id = :fb_flow_id) referenced_pages',
'from  wwv_flow_page_groups g',
'where flow_id = :fb_flow_id and',
'      security_group_id = :flow_security_group_id',
') r,',
'(',
'select sum((select count(*) c ',
'from wwv_flow_steps ',
'where group_id = g.id and ',
'      flow_id = :fb_flow_id and',
'      security_group_id = :flow_security_group_id',
'      )) total_pages',
'from wwv_flow_page_groups g',
'where flow_id = :fb_flow_id and',
'   security_group_id = :flow_security_group_id',
') t'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(1386831364981723)
,p_name=>'Page Groups'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#EDIT_LINK#" class="a-IRR-icon"><span class="a-Icon #ICON_CLASS#"></span><span class="a-IRR-iconName">#ICON_TITLE#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1387013953981742)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1387130716981748)
,p_db_column_name=>'GROUP_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Group Name'
,p_column_link=>'f?p=&APP_ID.:521:&SESSION.::&DEBUG.:RIR:P521_ID,FB_FLOW_ID:#ID#,&FB_FLOW_ID.'
,p_column_linktext=>'#GROUP_NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1387229198981748)
,p_db_column_name=>'GROUP_DESC'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Description'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1387319348981748)
,p_db_column_name=>'REFERENCED_PAGES'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Referenced Pages'
,p_column_link=>'f?p=&APP_ID.:522:&SESSION.::&DEBUG.:RP,RIR:IR_GROUP_ID:#ID#'
,p_column_linktext=>'#REFERENCED_PAGES#'
,p_column_link_attr=>'title="View Assigned Pages"'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1387701615981749)
,p_db_column_name=>'PCT'
,p_display_order=>5
,p_column_identifier=>'H'
,p_column_label=>'Percentage of Total'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1387801144981749)
,p_db_column_name=>'PCT2'
,p_display_order=>6
,p_column_identifier=>'I'
,p_column_label=>'Graph'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_format_mask=>'PCT_GRAPH:cccccc:777777:200'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(649534403931618327)
,p_db_column_name=>'ICON_CLASS'
,p_display_order=>17
,p_column_identifier=>'J'
,p_column_label=>'ICON_CLASS'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(649534563483618328)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>27
,p_column_identifier=>'K'
,p_column_label=>'EDIT_LINK'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(649534613128618329)
,p_db_column_name=>'ICON_TITLE'
,p_display_order=>37
,p_column_identifier=>'L'
,p_column_label=>'ICON_TITLE'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(1388113000982963)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1296313245536645'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_view_mode=>'ICON'
,p_report_columns=>'ID:GROUP_NAME:GROUP_DESC:REFERENCED_PAGES:PCT:PCT2:ICON_CLASS:EDIT_LINK:ICON_TITLE'
,p_sort_column_1=>'GROUP_NAME'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(212834105872176627)
,p_plug_name=>'Page Groups'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Page groups help you organize pages. To use page groups, create a group and then assign pages to the group.</p>',
'<p>To create a page group click the <strong>Create</strong> button.</p>',
'<p>To edit a page group click the group name.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(213349321501259866)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(213192710092707758)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(196747721437578989)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1386702222981723)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:520:&SESSION.::&DEBUG.:520,RIR::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(15587428311356568)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1386702222981723)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:521:&SESSION.::&DEBUG.:521::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(212870414132286994)
,p_branch_action=>'f?p=&FLOW_ID.:520:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(215671022120022009)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'520'
,p_compute_when_type=>'%null%'
);
end;
/
prompt --application/pages/page_00521
begin
wwv_flow_imp_page.create_page(
 p_id=>521
,p_name=>'Page Group'
,p_alias=>'PAGE-GROUP'
,p_step_title=>'Page Group'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212903908539395030)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>',
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_group.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1393403386406494)
,p_plug_name=>'Assigned Pages'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>150
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_page_api.get_url (',
'           p_page   => 4500,',
'           p_items  => ''FB_FLOW_PAGE_ID'',',
'           p_values => id) edit_link,',
'       id,',
'       name,',
'       (select count(*)',
'          from wwv_flow_page_plugs',
'         where flow_id = p.flow_id',
'           and page_id = p.id) regions,',
'       p.page_type,',
'       created_on,',
'       created_by,',
'       last_updated_on,',
'       last_updated_by',
'  from wwv_flow_pages_dev p',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and group_id          = :P521_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P521_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(1393503630406494)
,p_name=>'Assigned Pages'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_show_search_textbox=>'N'
,p_show_actions_menu=>'N'
,p_report_list_mode=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1393725221406495)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Edit Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1393832662406495)
,p_db_column_name=>'ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Page'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.:4500:FB_FLOW_ID,FB_FLOW_PAGE_ID:&FB_FLOW_ID.,#ID#'
,p_column_linktext=>'#ID#'
,p_column_type=>'NUMBER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1393910366406496)
,p_db_column_name=>'NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Page Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1394008392406496)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Created'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1394125625406496)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Created By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1394900111423947)
,p_db_column_name=>'PAGE_TYPE'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Page Type'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1395031397423952)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Updated On'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1395124079423953)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1399220936458325)
,p_db_column_name=>'REGIONS'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Regions'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(1394424437412015)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1296421355536645'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_display_rows=>100
,p_report_columns=>'ID:NAME:PAGE_TYPE:REGIONS:LAST_UPDATED_ON:LAST_UPDATED_BY'
,p_sort_column_1=>'ID'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(1404823772988940)
,p_name=>'All Groups'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>60
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'REGION_POSITION_03'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select GROUP_NAME, ID',
'from   WWV_FLOW_PAGE_GROUPS ',
'where  flow_id = :fb_flow_id and',
'       security_group_id = :flow_security_group_id',
'order  by group_name'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(11667910335347890)
,p_query_num_rows=>2000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No Groups Found'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>4000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1405125117988946)
,p_query_column_id=>1
,p_column_alias=>'GROUP_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Group Name'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:521:&SESSION.::&DEBUG.:521:P521_ID:#ID#'
,p_column_linktext=>'#GROUP_NAME#'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1410901663136800)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_column_heading=>'ID'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(212836709765187884)
,p_plug_name=>'Page Group'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>100
,p_plug_header=>'<p>Page groups help you organize pages. Once you create a page group, you assign pages to the group.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'Region generated 08-JUL-2004 19:41:27'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(212849630160212045)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>95
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(212837507908187898)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(212849630160212045)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(212837304346187886)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(212849630160212045)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'javascript:confirmDelete(htmldb_delete_message,''DELETE'');'
,p_button_condition=>'P521_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(212837226956187885)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(212849630160212045)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'CREATE'
,p_button_condition=>'P521_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(212837131436187885)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(212849630160212045)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
,p_button_condition=>'P521_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(215489832392634392)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(212849630160212045)
,p_button_name=>'GET_PREVIOUS_ID'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'javascript:htmldb_goSubmit(''GET_PREVIOUS_ID'')'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'disabled=""'
,p_button_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(215489722982634392)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(212849630160212045)
,p_button_name=>'GET_NEXT_ID'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Next'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'javascript:htmldb_goSubmit(''GET_NEXT_ID'')'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'disabled=""'
,p_button_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(212838811914187903)
,p_branch_action=>'f?p=&FLOW_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>21
,p_branch_comment=>'Generated 08-JUL-2004 19:41:28'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(215493125969634418)
,p_branch_action=>'f?p=&FLOW_ID.:521:&SESSION.::&DEBUG.::P521_ID:&P521_ID_NEXT.'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(215489722982634392)
,p_branch_sequence=>1
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(215493500892634420)
,p_branch_action=>'f?p=&FLOW_ID.:521:&SESSION.::&DEBUG.::P521_ID:&P521_ID_PREV.'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(215489832392634392)
,p_branch_sequence=>1
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(212839225443187910)
,p_name=>'P521_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(212836709765187884)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 08-JUL-2004 19:41:28'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(212839625948187930)
,p_name=>'P521_FLOW_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(212836709765187884)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_item_comment=>'Generated 08-JUL-2004 19:41:28'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(212840020341187932)
,p_name=>'P521_GROUP_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(212836709765187884)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>'GROUP_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identify the name of the page group.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 08-JUL-2004 19:41:28'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(212840818565187948)
,p_name=>'P521_GROUP_DESC'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(212836709765187884)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Description'
,p_source=>'GROUP_DESC'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a description for a page group.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_item_comment=>'Generated 08-JUL-2004 19:41:28'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(215491019029634401)
,p_name=>'P521_ID_NEXT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(212849630160212045)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(215491300319634403)
,p_name=>'P521_ID_PREV'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(212849630160212045)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(215491729195634405)
,p_name=>'P521_ID_COUNT'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(212849630160212045)
,p_prompt=>'Page Group: '
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'P521_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies page group.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(212840501756187945)
,p_validation_name=>'P521_GROUP_NAME not null'
,p_validation_sequence=>30
,p_validation=>'P521_GROUP_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Group Name must have some value.'
,p_associated_item=>wwv_flow_imp.id(212840020341187932)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(212886724029342739)
,p_validation_name=>'No references on delete'
,p_validation_sequence=>40
,p_validation=>'select 1 from wwv_flow_steps where group_id = :p521_id and flow_id = :fb_flow_id'
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'You can not delete a group with referenced pages.'
,p_when_button_pressed=>wwv_flow_imp.id(212837304346187886)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(46079001348093234)
,p_validation_name=>'Group Name not exists on create'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_page_groups',
' where upper(group_name) = upper(:P521_GROUP_NAME)',
'   and flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Group name already exists.'
,p_when_button_pressed=>wwv_flow_imp.id(212837131436187885)
,p_associated_item=>wwv_flow_imp.id(212840020341187932)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(46079404250103546)
,p_validation_name=>'Group name not exists on update'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_page_groups',
' where upper(group_name) = upper(:P521_GROUP_NAME)',
'   and id               != :P521_ID',
'   and flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Group name already exists.'
,p_when_button_pressed=>wwv_flow_imp.id(212837226956187885)
,p_associated_item=>wwv_flow_imp.id(212840020341187932)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(378314007060530635)
,p_name=>'ENABLE PREVIOUS'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P521_ID_PREV'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(378314305555530635)
,p_event_id=>wwv_flow_imp.id(378314007060530635)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(215489832392634392)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(378314415718533153)
,p_name=>'ENABLE NEXT'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P521_ID_NEXT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(378314720405533156)
,p_event_id=>wwv_flow_imp.id(378314415718533153)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(215489722982634392)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(212841329374187955)
,p_process_sequence=>1
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_PAGE_GROUPS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_PAGE_GROUPS'
,p_attribute_03=>'P521_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Unable to fetch row.'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from wwv_flow_page_groups',
'where flow_id = :fb_flow_id',
'and id = :P521_ID'))
,p_process_when_type=>'EXISTS'
,p_internal_uid=>212841329374187955
,p_process_comment=>'Generated 08-JUL-2004 19:41:28'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(215492723502634413)
,p_process_sequence=>11
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_PAGINATION'
,p_process_name=>'Get Next or Previous Primary Key Value'
,p_attribute_02=>'WWV_FLOW_PAGE_GROUPS'
,p_attribute_03=>'P521_ID'
,p_attribute_04=>'ID'
,p_attribute_07=>'GROUP_NAME'
,p_attribute_09=>'P521_ID_NEXT'
,p_attribute_10=>'P521_ID_PREV'
,p_attribute_13=>'P521_ID_COUNT'
,p_attribute_14=>'flow_id = :fb_flow_id'
,p_process_error_message=>'Unable to run Get Next or Previous Primary Key Value process.'
,p_internal_uid=>215492723502634413
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(212841712158187958)
,p_process_sequence=>1
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_PAGE_GROUPS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_PAGE_GROUPS'
,p_attribute_03=>'P521_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Unable to process row of table WWV_FLOW_PAGE_GROUPS.'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>212841712158187958
,p_process_comment=>'Generated 08-JUL-2004 19:41:28'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(212842106915187959)
,p_process_sequence=>2
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'521'
,p_process_when_button_id=>wwv_flow_imp.id(212837304346187886)
,p_internal_uid=>212842106915187959
);
end;
/
prompt --application/pages/page_00522
begin
wwv_flow_imp_page.create_page(
 p_id=>522
,p_name=>'Manage Page Group Assignments'
,p_alias=>'MANAGE-PAGE-GROUP-ASSIGNMENTS'
,p_step_title=>'Manage Page Group Assignments'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212903908539395030)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_group.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(95554303973076300)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(196855022613956448)
,p_plug_name=>'Group Pages'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.checkbox(1,wwv_flow_escape.html(id),''title="''||wwv_flow_lang.system_message(''SELECT_ROW_C'', wwv_flow_escape.html(name))||''"'') id2,',
'       id, ',
'       name,',
'       LAST_UPDATED_BY, ',
'       LAST_UPDATED_ON, ',
'       ALIAS, ',
'      (select count(*) from wwv_flow_page_plugs where flow_id = :fb_flow_id and page_id = p.id) regions,',
'      (select count(*) from wwv_flow_step_items where flow_id = :fb_flow_id and flow_step_id = p.id) items,',
'       group_id,',
'       decode(group_id,null,un.m,(select max(group_name) ',
'                                   from wwv_flow_page_groups',
'                                  where id = p.group_id)) Groupname',
'from  wwv_flow_steps p,',
'     (select wwv_flow_lang.system_message(''UNASSIGNED'') m from dual) un',
'where flow_id = :fb_flow_id    '))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(196855119881956448)
,p_name=>'Group Pages'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_detail_link_text=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="" />'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(196855315410956450)
,p_db_column_name=>'ID2'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(196855406400956492)
,p_db_column_name=>'ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Page'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#ID#'
,p_column_linktext=>'#ID#'
,p_column_link_attr=>'title="Edit Page Attributes"'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(196855524810956493)
,p_db_column_name=>'NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(196855829521956495)
,p_db_column_name=>'ALIAS'
,p_display_order=>4
,p_column_identifier=>'F'
,p_column_label=>'Alias'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(196856121094956497)
,p_db_column_name=>'GROUPNAME'
,p_display_order=>5
,p_column_identifier=>'I'
,p_column_label=>'Group'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(196856032083956497)
,p_db_column_name=>'ITEMS'
,p_display_order=>6
,p_column_identifier=>'H'
,p_column_label=>'Items'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(196855900555956496)
,p_db_column_name=>'REGIONS'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Regions'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(196855623804956493)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>8
,p_column_identifier=>'D'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(196855700830956494)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>9
,p_column_identifier=>'E'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(480517709820029682)
,p_db_column_name=>'GROUP_ID'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Selected Group'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(196856724946958466)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1296516475536645'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'ID2:ID:NAME:GROUPNAME:ITEMS:REGIONS:LAST_UPDATED_BY:LAST_UPDATED_ON:GROUP_ID'
,p_sort_column_1=>'ID'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'0'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(216318823962281044)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(213192710092707758)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(216323604401313211)
,p_plug_name=>'Page Group Assignments'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>To reassign pages to a group, select a new group, select the pages you wish to reassign, then click <strong>Assign Checked</strong>. To remove a page from a page group, select <strong>Unassign</strong> and then click <strong>Assign Checked</strong'
||'>.</p>',
'',
'<p>To view only unassigned pages, add a filter where "Group = Unassigned" (click the column heading on Group and select <strong>Unassigned</strong>).</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(196858827071987424)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(95554303973076300)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:522:&SESSION.::&DEBUG.:522,RIR::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(95756919390305619)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(95554303973076300)
,p_button_name=>'REASSIGN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Assign Checked'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(212938926480478794)
,p_branch_action=>'f?p=&FLOW_ID.:522:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(216980426199868369)
,p_name=>'P522_NEW_GROUP'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(95554303973076300)
,p_prompt=>'New Group'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'GROUP PICKER'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d, id ',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id',
'and security_group_id = :flow_security_group_id',
'order by upper(group_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Unassign -'
,p_lov_null_value=>'0'
,p_cSize=>64
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a group to reassign pages to.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(216317711842277515)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'522'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(95835116507796728)
,p_validation_name=>'Must have selected something'
,p_validation_sequence=>10
,p_validation=>'wwv_flow.g_f01.count > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'You must make a selection to perform this action.'
,p_when_button_pressed=>wwv_flow_imp.id(95756919390305619)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1199173576440878411)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(196855022613956448)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1199173679889878412)
,p_event_id=>wwv_flow_imp.id(1199173576440878411)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(212941413181481514)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'rp'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>212941413181481514
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(216987406637900551)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'reassign'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  p number;',
'begin',
'for i in 1..wwv_flow.g_f01.count loop',
'   p := wwv_flow.g_f01(i);',
'   if :P522_NEW_GROUP = 0 then',
'      update wwv_flow_steps ',
'         set group_id = null',
'       where flow_id = :fb_flow_id ',
'         and id = p;',
'   else',
'      update wwv_flow_steps ',
'         set group_id = :P522_NEW_GROUP ',
'       where flow_id = :fb_flow_id ',
'         and id = p;',
'   end if;',
'end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to reassign page groups.'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :REQUEST = ''REASSIGN'' and wwv_flow.g_f01.count > 0 then',
'   return true;',
'else',
'   return false;',
'end if;'))
,p_process_when_type=>'FUNCTION_BODY'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Page groups reassigned.'
,p_internal_uid=>216987406637900551
);
end;
/
prompt --application/pages/page_00523
begin
wwv_flow_imp_page.create_page(
 p_id=>523
,p_name=>'Edit AI'
,p_alias=>'EDIT-AI'
,p_step_title=>'Edit AI'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213220627333807318)
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'No help is available for this page.'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1800953845232001)
,p_plug_name=>'Warning Region'
,p_title=>'No AI Services available'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>71
,p_plug_source=>'No AI Services have been configured for this workspace. Navigate to <b>Workspace Utilities, Generative AI</b> in order to configure an AI Service first.'
,p_plug_display_condition_type=>'NOT_EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id ',
'  from wwv_remote_servers',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and server_type       = ''GENERATIVE_AI'''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3512232971545918)
,p_plug_name=>'Application &FB_FLOW_ID.'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>140
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_landmark_label=>'AI Service'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11820717882408226)
,p_plug_name=>'AI Form'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOWS'
,p_query_where=>'security_group_id = :FLOW_SECURITY_GROUP_ID'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'u'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
,p_ajax_items_to_submit=>'FB_FLOW_ID'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(80643945714974834)
,p_plug_name=>'Landmark for Displayed Regions'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>61
,p_translate_title=>'N'
,p_landmark_type=>'region'
,p_landmark_label=>'Displayed Regions'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6912929452611842)
,p_plug_name=>'Generative AI'
,p_parent_plug_id=>wwv_flow_imp.id(80643945714974834)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>71
,p_include_in_reg_disp_sel_yn=>'Y'
,p_location=>null
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'  from wwv_remote_servers ',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and server_type       = ''GENERATIVE_AI'''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(278411551454214749)
,p_plug_name=>'Application Attributes'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>130
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(274897624522614662)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_landmark_type=>'navigation'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(635061740183879604)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Edit the Generative AI attributes for this application.</p>',
'<p>A Generative AI Service must be configured in the workspace. If no Generative AI Service exists, you can configure one from this page.</p>',
'<p>Generative AI Services can be also configured from <strong>Workspace Utilities.</strong> ',
''))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(718082524464097695)
,p_plug_name=>'Learn More'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="padding: 0 12px 12px 12px;"'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>150
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'sys.htp.p(''<p><a href="&SYSTEM_HELP_URL." rel="noopener noreferrer" target="_blank">''||wwv_flow_lang.system_message(''LEARN MORE'')||'' ...</a></p>'');'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1801017294232002)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1800953845232001)
,p_button_name=>'CONFIGURE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Configure'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:9801:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1415369477715044)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(3512232971545918)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:RP,1::'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id ',
'  from wwv_remote_servers',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and server_type       = ''GENERATIVE_AI'''))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1415780778715045)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(3512232971545918)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'FB_FLOW_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1615345731715225)
,p_branch_name=>'Go To Page 4001'
,p_branch_action=>'f?p=&APP_ID.:4001:&SESSION.::&DEBUG.:4001:FB_FLOW_ID:&FB_FLOW_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_DEFN'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1614534355715225)
,p_branch_name=>'Go To Page 509'
,p_branch_action=>'f?p=&APP_ID.:509:&SESSION.::&DEBUG.:509:FB_FLOW_ID,509_FB_UPD_ID:&FB_FLOW_ID.,&FB_FLOW_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_SEC'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1614901715715225)
,p_branch_name=>'Go To Page 506'
,p_branch_action=>'f?p=&APP_ID.:506:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_GLOBAL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1614135475715224)
,p_branch_name=>'Go To Page 197'
,p_branch_action=>'f?p=&APP_ID.:197:&SESSION.::&DEBUG.:197:FB_FLOW_ID:&FB_FLOW_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>70
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_USERINTERFACE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1615759659715225)
,p_branch_name=>'Go To Page 507'
,p_branch_action=>'f?p=&APP_ID.:507:&SESSION.::&DEBUG.:507:FB_FLOW_ID:&FB_FLOW_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>80
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_PWA'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1616174922727102)
,p_branch_name=>'Go To Page 523'
,p_branch_action=>'f?p=&APP_ID.:523:&SESSION.::&DEBUG.:523:FB_FLOW_ID:&FB_FLOW_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>90
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_AI'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1616226905727103)
,p_name=>'P523_CONSENT_MESSAGE'
,p_data_type=>'CLOB'
,p_source_data_type=>'CLOB'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(6912929452611842)
,p_item_source_plug_id=>wwv_flow_imp.id(11820717882408226)
,p_prompt=>'Consent Message'
,p_source=>'AI_CONSENT_MESSAGE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cHeight=>10
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The consent message for the use of the selected AI Service.',
'If provided, the user will first be prompted with this message and must agree before being able to interact with the AI.',
'The user''s choice will be stored as a preference so they are only prompted once.',
'Use the <code>APEX_AI</code> package to programmatically set or clear user consent.</p>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'Y'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3561248798592452)
,p_name=>'P523_DEFAULT_AI_SERVICE'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(6912929452611842)
,p_item_source_plug_id=>wwv_flow_imp.id(11820717882408226)
,p_prompt=>'Service'
,p_source=>'AI_REMOTE_SERVER_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id',
'  from wwv_remote_servers',
' where server_type       = ''GENERATIVE_AI''',
'   and security_group_id = :WORKSPACE_ID',
' order by 1 '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'None'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The default AI Service for this application.</p>',
'<p>Select a Generative AI Service from the list of configured Generative AI Services for this application.</p>',
'<p>Generative AI Services can be configured from <strong>Workspace Utilities.</strong></p>',
''))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11826763493408254)
,p_name=>'P523_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(11820717882408226)
,p_item_source_plug_id=>wwv_flow_imp.id(11820717882408226)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1502418588715135)
,p_computation_sequence=>10
,p_computation_item=>'P523_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'FB_FLOW_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2371611392845509)
,p_name=>'Service Selected'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P523_DEFAULT_AI_SERVICE'
,p_condition_element=>'P523_DEFAULT_AI_SERVICE'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2371790554845510)
,p_event_id=>wwv_flow_imp.id(2371611392845509)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P523_CONSENT_MESSAGE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2371823040845511)
,p_event_id=>wwv_flow_imp.id(2371611392845509)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P523_CONSENT_MESSAGE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1420237113715052)
,p_process_sequence=>110
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(11820717882408226)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process Form'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'N'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Application AI attributes updated.'
,p_internal_uid=>1420237113715052
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1419880172715051)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(11820717882408226)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize Form'
,p_internal_uid=>1419880172715051
);
end;
/
prompt --application/pages/page_00525
begin
wwv_flow_imp_page.create_page(
 p_id=>525
,p_name=>'Set Application Protection'
,p_alias=>'SET-APPLICATION-PROTECTION'
,p_step_title=>'Set Application Protection'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(262753407599695606)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_session_protection.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(109507706670145855)
,p_name=>'Page Level Session State Protection Summary'
,p_template=>wwv_flow_imp.id(689970285456172024)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select	 ',
'	 nvl(PROTECTION_LEVEL,''N'') Protection,',
'         count(*) c',
' from	 WWV_FLOW_STEPS p',
'where flow_id = :fb_flow_id',
'and p.security_group_id = :flow_security_group_id',
'group by PROTECTION_LEVEL'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(109507930646145858)
,p_query_column_id=>1
,p_column_alias=>'PROTECTION'
,p_column_display_sequence=>1
,p_column_heading=>'Page Access Protection'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(17255429593772638)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(109508023981145858)
,p_query_column_id=>2
,p_column_alias=>'C'
,p_column_display_sequence=>2
,p_column_heading=>'Page Count'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(109509332296153238)
,p_plug_name=>'Set Session State Protection Attributes'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_plug_header=>'<p>Use this wizard to enable or disable Session State Protection and set page and item security attributes for the entire application. After running the wizard, you can also configure page and item security attributes manually by clicking the appropr'
||'iate icon on the Session State Protection page.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(109643822089754956)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(109642120442735590)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(110619630745303381)
,p_name=>'Page Item Session State Protection  Summary'
,p_template=>wwv_flow_imp.id(689970285456172024)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select	 ',
'	 flow_step_id "Page",',
'         nvl(PROTECTION_LEVEL,''N'') Protection,         ',
'         count(*) c',
' from	 WWV_FLOW_STEP_ITEMS p',
'where flow_id = :fb_flow_id',
'and security_group_id = :flow_security_group_id',
'group by flow_step_id, nvl(PROTECTION_LEVEL,''N'')'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(110627826898349572)
,p_query_column_id=>1
,p_column_alias=>'Page'
,p_column_display_sequence=>1
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(110619823321303385)
,p_query_column_id=>2
,p_column_alias=>'PROTECTION'
,p_column_display_sequence=>2
,p_column_heading=>'Item Session State Protection'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(17287012676783081)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(110619920413303385)
,p_query_column_id=>3
,p_column_alias=>'C'
,p_column_display_sequence=>3
,p_column_heading=>'Item Count'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_sum_column=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(110620605942305665)
,p_name=>'Application Item Session State Protection  Summary'
,p_template=>wwv_flow_imp.id(689970285456172024)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select	 ',
'	 nvl(PROTECTION_LEVEL,''N'') Protection, ',
'         count(*) c',
' from	 WWV_FLOW_ITEMS p',
'where flow_id = :fb_flow_id',
'and security_group_id = :flow_security_group_id',
'group by PROTECTION_LEVEL'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(110620818361305666)
,p_query_column_id=>1
,p_column_alias=>'PROTECTION'
,p_column_display_sequence=>1
,p_column_heading=>'Item Session State Protection'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(17287012676783081)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(110620907862305667)
,p_query_column_id=>2
,p_column_alias=>'C'
,p_column_display_sequence=>2
,p_column_heading=>'Page Count'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(110652627618576824)
,p_plug_name=>'Application Session State Protection  Controls'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_footer=>'<p />'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(207767015819710759)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747143286021138165)
,p_plug_name=>'Set Application Protection'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(109603504496189008)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(207767015819710759)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:510:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(109602624104185240)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(207767015819710759)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(109617108632388982)
,p_branch_action=>'f?p=&APP_ID.:9007:&SESSION.::&DEBUG.:9006::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(109602624104185240)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P525_LEVEL'
,p_branch_condition_text=>'ENABLE'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(165640711850202360)
,p_branch_action=>'f?p=&APP_ID.:9006:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(109602624104185240)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P525_LEVEL'
,p_branch_condition_text=>'ALL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(109617727679394450)
,p_branch_action=>'f?p=&APP_ID.:9008:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(109602624104185240)
,p_branch_sequence=>30
,p_branch_condition=>'P525_LEVEL'
,p_branch_condition_text=>'DISABLE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(109611814342352710)
,p_name=>'P525_LEVEL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(109509332296153238)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Select Action:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'for c1 in (select page_protection_enabled_y_n e from wwv_flows where id = :FB_FLOW_ID) loop',
'  if nvl(c1.e,''N'') = ''N'' then',
'     return ''ENABLE'';',
'  else',
'     return ''DISABLE'';',
'  end if;',
'end loop;',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'GLOBAL.SESSION.STATE.SECURITY'
,p_lov=>'.'||wwv_flow_imp.id(109607612170295323)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enabling Session State Protection is a two step process:',
'<ol>',
'<li>Enable the feature</li>',
'<li>Configure page and item security attributes</li>',
'</ol>',
'For Select Action, select one of the following and click <strong>Next</strong>:',
'<ul>',
'<li><strong>Disable</strong> - Disables Session State Protection. Note that disabling Session State Protection will not affect previously configured page and item security attributes.',
'<li><strong>Enable</strong> -  Enables Session State Protection. When enabled, Session State Protection, uses the <i>Page Access Protection</i> page attributes and the Session State Protection item attributes in conjunction with checksums positioned '
||'in "f?p=" URLs to prevent URL tampering and unauthorized access to and alteration of session state. ',
'<li><strong>Configure</strong> - Configure page and item security attributes and apply them to all pages and items within the application.',
'<p><strong>Note:</strong> You can also adjust page and item security attributes manually. Select <strong>Enable</strong>, return to the Session State Protection page, and click the appropriate icon.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(110654511127581587)
,p_name=>'P525_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(110652627618576824)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application:'
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'This attribute identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(110655424286585398)
,p_name=>'P525_APPLICATION_SESSION_STATE_SECURITY'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(110652627618576824)
,p_item_default=>'N'
,p_prompt=>'Session State Protection:'
,p_source=>'select PAGE_PROTECTION_ENABLED_Y_N from wwv_flows where id = :fb_flow_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'ENABLED_DISABLED_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(91439803955181562)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p />',
'Indicates whether Session State Protection is enabled or disabled. When enabled, this feature, uses the <i>Page Access Protection</i> page attributes and the <i>Session State Protection</i> item attributes in conjunction with checksums positioned in '
||'"f?p=" URLs. The feature prevents URL tampering and unauthorized access to and alteration of session state. ',
'<p />',
'When this feature is disabled, the page and item attributes related to session state protection are ignored and checksums are not included checksums in generated "f?p=" URLs.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
end;
/
prompt --application/pages/page_00527
begin
wwv_flow_imp_page.create_page(
 p_id=>527
,p_name=>'Query Finder'
,p_alias=>'QUERY-FINDER'
,p_step_title=>'Query Finder'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(19943204431962826)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_srch_query.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6282308008654572)
,p_plug_name=>'Finder Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>91
,p_list_id=>wwv_flow_imp.id(6207014968942318)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(478911017664917969)
,p_plug_name=>'Query Regions'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>140
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select p.id, p.name, r.plug_name region_name, r.plug_source',
'from wwv_flow_steps p, wwv_flow_page_plugs r',
'where p.flow_id = :fb_flow_id and',
'      r.flow_id = :fb_flow_id and',
'      p.id = r.page_id and',
'      plug_source_type in  ( ''NATIVE_CALENDAR'',''NATIVE_SQL_REPORT'',''NATIVE_TREE'')'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(478911116494917969)
,p_name=>'Query Regions'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(478911321184917975)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Page'
,p_column_link=>'f?p=&APP_ID.:273:&SESSION.::&DEBUG.::F4000_P273_PAGE:#ID#'
,p_column_linktext=>'#ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(478911400429917976)
,p_db_column_name=>'NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Page'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(478911507039917977)
,p_db_column_name=>'REGION_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Region'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(478911622794917978)
,p_db_column_name=>'PLUG_SOURCE'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Source'
,p_allow_sorting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_column_type=>'CLOB'
,p_tz_dependent=>'N'
,p_rpt_show_filter_lov=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(478911808086918993)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1296610517536645'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'ID:NAME:REGION_NAME:PLUG_SOURCE'
,p_sort_column_1=>'ID'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(478918616313940219)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(478911017664917969)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:527:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(6283921499654577)
,p_branch_action=>'f?p=&APP_ID.:527:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
end;
/
prompt --application/pages/page_00528
begin
wwv_flow_imp_page.create_page(
 p_id=>528
,p_name=>'Pages by Page Group'
,p_alias=>'PAGES-BY-PAGE-GROUP'
,p_step_title=>'Pages by Page Group'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212903908539395030)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_group.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(196840002224844435)
,p_plug_name=>'Page Groups'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>100
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'       nvl(g.group_name,un.m) group_name, ',
'       p.id,',
'       g.id group_id,',
'       p.name name, ',
'       p.page_comment, ',
'       p.HELP_TEXT',
'from wwv_flow_page_groups g,',
'     wwv_flow_steps p,',
'     (select wwv_flow_lang.system_message(''UNASSIGNED'') m from dual) un',
'where (g.flow_id = :fb_flow_id or g.flow_id is null) and',
'      p.group_id = g.id (+) and',
'      p.flow_id = :fb_flow_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(196840111859844435)
,p_name=>'Page Groups'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(196840328486844440)
,p_db_column_name=>'GROUP_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Group Name'
,p_column_link=>'f?p=&APP_ID.:521:&SESSION.::&DEBUG.:RP,521:P521_ID:#GROUP_ID#'
,p_column_linktext=>'#GROUP_NAME#'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(196840424148844512)
,p_db_column_name=>'ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Page'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#ID#'
,p_column_linktext=>'#ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(196840608981844513)
,p_db_column_name=>'NAME'
,p_display_order=>3
,p_column_identifier=>'D'
,p_column_label=>'Page Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(196840716490844514)
,p_db_column_name=>'PAGE_COMMENT'
,p_display_order=>4
,p_column_identifier=>'E'
,p_column_label=>'Page Comment'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(196840809479844515)
,p_db_column_name=>'HELP_TEXT'
,p_display_order=>5
,p_column_identifier=>'F'
,p_column_label=>'Help Text'
,p_allow_sorting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_column_type=>'CLOB'
,p_tz_dependent=>'N'
,p_rpt_show_filter_lov=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(196840501275844513)
,p_db_column_name=>'GROUP_ID'
,p_display_order=>6
,p_column_identifier=>'C'
,p_column_label=>'Group'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(196841025798845235)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1296723501536645'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'GROUP_NAME:ID:NAME:PAGE_COMMENT:HELP_TEXT:GROUP_ID'
,p_sort_column_1=>'GROUP_NAME'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'ID'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
,p_break_on=>'GROUP_NAME'
,p_break_enabled_on=>'GROUP_NAME'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(213310716345102284)
,p_plug_name=>'Page Groups'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Page groups help you organize pages.</p>',
'<p>Click the group name to edit the page group definition.</p>',
'<p>Click on the page number to edit the page and assign or reassign a page group.</p>',
'<p>Click on the page name to view the page definition.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(213327732443177876)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>90
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(213192710092707758)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(196839703719819869)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_imp.id(196840002224844435)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:528:&SESSION.::&DEBUG.:528,RIR::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(213311932385102288)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(196840002224844435)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:521:&SESSION.::&DEBUG.:RP,521::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(213313806698102303)
,p_branch_action=>'f?p=&FLOW_ID.:528:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(213341230458234011)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'528'
,p_compute_when_type=>'%null%'
);
end;
/
prompt --application/pages/page_00529
begin
wwv_flow_imp_page.create_page(
 p_id=>529
,p_name=>'Create List - Confirm'
,p_alias=>'CREATE-LIST-CONFIRM'
,p_page_mode=>'MODAL'
,p_step_title=>'Create List'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'500'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'nav_list.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44565501396171475)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(169193619433715962)
,p_plug_name=>'create list train'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(169186610834587350)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(169206124346767265)
,p_plug_name=>'Create List'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(169194006430715963)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(44565501396171475)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(169194410384715965)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(44565501396171475)
,p_button_name=>'create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create List'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(169194224414715965)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(44565501396171475)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(169195408774738159)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(574135813665781514)
,p_branch_name=>'Go To Page 440'
,p_branch_action=>'f?p=&APP_ID.:440:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(169194224414715965)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(169204428408711688)
,p_name=>'P529_DEPLOY'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(169206124346767265)
,p_prompt=>'Create List Regions?'
,p_source=>'N'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST DEPLOYMENT P529'
,p_lov=>'.'||wwv_flow_imp.id(169222400131754330)||'.'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select whether or not to create a list region and if so, whether to create on current page or each target page.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(169204609799711689)
,p_name=>'P529_REGION_POSITION'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(169206124346767265)
,p_prompt=>'Region Position'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE_DISPLAY_POINT'
,p_lov=>'.'||wwv_flow_imp.id(131723061838)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select region position for new region.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(169206420964767273)
,p_name=>'P529_ENTRY_LABEL'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(169206124346767265)
,p_source=>'wwv_flow_lang.system_message(''LIST_ENTRY_LABEL'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(169206614208767273)
,p_name=>'P529_ENTRY_TARGET'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(169206124346767265)
,p_source=>'wwv_flow_lang.system_message(''TARGET_PAGE_ID_OR_CUSTOM_URL'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(169206812369767273)
,p_name=>'P529_LIST_TEMPLATE_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(169206124346767265)
,p_use_cache_before_default=>'NO'
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select default_list_template from wwv_flow_themes ',
'where flow_id = :fb_flow_id ',
'and theme_id = :fb_theme_id',
'and default_list_template is not null) loop',
'',
'   return c1.default_list_template;',
'',
'end loop;',
'',
'return null;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'List Template:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_LIST_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''LIST''',
'and flow_id = :fb_flow_id ',
'and theme_id = :fb_theme_id',
'order by upper(name)'))
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Select the list template you would like to use to control the appearance of your list.</div>',
'<div class="htmldbInfoBodyP">You can specify default templates on the Define Theme page.</div>'))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(169207712806767345)
,p_name=>'P529_PAGE_01'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(169206124346767265)
,p_use_cache_before_default=>'NO'
,p_source=>'P440_PAGE_01'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(169207909437767345)
,p_name=>'P529_ENTRY_NAME_02'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(169206124346767265)
,p_use_cache_before_default=>'NO'
,p_prompt=>'2'
,p_source=>'P440_ENTRY_NAME_02'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(169208101824767345)
,p_name=>'P529_PAGE_02'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(169206124346767265)
,p_use_cache_before_default=>'NO'
,p_source=>'P440_PAGE_02'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(169208303017767345)
,p_name=>'P529_ENTRY_NAME_03'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(169206124346767265)
,p_use_cache_before_default=>'NO'
,p_prompt=>'3'
,p_source=>'P440_ENTRY_NAME_03'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(169208503336767345)
,p_name=>'P529_PAGE_03'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(169206124346767265)
,p_use_cache_before_default=>'NO'
,p_source=>'P440_PAGE_03'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(169208730806767346)
,p_name=>'P529_ENTRY_NAME_04'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(169206124346767265)
,p_use_cache_before_default=>'NO'
,p_prompt=>'4'
,p_source=>'P440_ENTRY_NAME_04'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(169208908580767346)
,p_name=>'P529_PAGE_04'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(169206124346767265)
,p_use_cache_before_default=>'NO'
,p_source=>'P440_PAGE_04'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(169209109388767346)
,p_name=>'P529_ENTRY_NAME_05'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(169206124346767265)
,p_use_cache_before_default=>'NO'
,p_prompt=>'5'
,p_source=>'P440_ENTRY_NAME_05'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(169209315242767346)
,p_name=>'P529_PAGE_05'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(169206124346767265)
,p_use_cache_before_default=>'NO'
,p_source=>'P440_PAGE_05'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(169209508319767347)
,p_name=>'P529_ENTRY_NAME_01'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(169206124346767265)
,p_use_cache_before_default=>'NO'
,p_prompt=>'1'
,p_source=>'P440_ENTRY_NAME_01'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'P440_ENTRY_NAME_01'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(169568028380027275)
,p_name=>'P529_REGION_TEMPLATE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(169206124346767265)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id ',
'  from wwv_flow_page_plug_templates ',
' where id =',
'    ( select default_region_template ',
'        from wwv_flow_themes ',
'       where security_group_id = :FLOW_SECURITY_GROUP_ID',
'         and flow_id = :FB_FLOW_ID ',
'         and (:FB_THEME_ID is null or theme_id = :FB_THEME_ID) )'))
,p_item_default_type=>'SQL_QUERY'
,p_prompt=>'Region Template'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REGION.TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.d, ',
'       t.r ',
'  from ( select wwv_flow_escape.html(page_plug_template_name) d, ',
'             id r',
'           from wwv_flow_page_plug_templates',
'          where security_group_id = :FLOW_SECURITY_GROUP_ID',
'            and flow_id           = :FB_FLOW_ID',
'            and (:FB_THEME_ID is null or theme_id = :FB_THEME_ID)',
'          order by upper(page_plug_template_name) ) t'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'No Template'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select region template for new region.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2238056824663815350)
,p_computation_sequence=>10
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id',
'  from wwv_flows',
' where id = :FB_FLOW_ID'))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(184114421131098722)
,p_validation_name=>'Region Position Must Be Selected'
,p_validation_sequence=>10
,p_validation=>'P529_REGION_POSITION'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'Region Position must be selected.'
,p_validation_condition=>'P529_DEPLOY'
,p_validation_condition2=>'CURRENT_PAGE:EACH_ENTRY'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_when_button_pressed=>wwv_flow_imp.id(169194410384715965)
,p_associated_item=>wwv_flow_imp.id(169204609799711689)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5394518734269553)
,p_name=>'List Region Creation Settings'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P529_DEPLOY'
,p_condition_element=>'P529_DEPLOY'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'CURRENT_PAGE,EACH_ENTRY'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5394821185269582)
,p_event_id=>wwv_flow_imp.id(5394518734269553)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P529_REGION_POSITION,P529_REGION_TEMPLATE,P529_LIST_TEMPLATE_ID'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5395010939269586)
,p_event_id=>wwv_flow_imp.id(5394518734269553)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P529_REGION_POSITION,P529_REGION_TEMPLATE,P529_LIST_TEMPLATE_ID'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(574135629149781512)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(169194006430715963)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(574135752063781513)
,p_event_id=>wwv_flow_imp.id(574135629149781512)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1542906604458063201)
,p_name=>'Visibility of Entry 5 name/page pairs'
,p_event_sequence=>30
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>':P440_ENTRY_NAME_05 is null and :P440_PAGE_05 is null'
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1542906723771063202)
,p_event_id=>wwv_flow_imp.id(1542906604458063201)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P529_PAGE_05,P529_ENTRY_NAME_05'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1542906957334063204)
,p_name=>'Visibility of Entry 4 name/page pairs'
,p_event_sequence=>40
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>':P440_ENTRY_NAME_04 is null and :P440_PAGE_04 is null'
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1542907030718063205)
,p_event_id=>wwv_flow_imp.id(1542906957334063204)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P529_PAGE_04,P529_ENTRY_NAME_04'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1542907141165063206)
,p_name=>'Visibility of Entry 3 name/page pairs'
,p_event_sequence=>50
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>':P440_ENTRY_NAME_03 is null and :P440_PAGE_03 is null'
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1542907270515063207)
,p_event_id=>wwv_flow_imp.id(1542907141165063206)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P529_PAGE_03,P529_ENTRY_NAME_03'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1542907341144063208)
,p_name=>'Visibility of Entry 2 name/page pairs'
,p_event_sequence=>60
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>':P440_ENTRY_NAME_02 is null and :P440_PAGE_02 is null'
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1542907436600063209)
,p_event_id=>wwv_flow_imp.id(1542907341144063208)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P529_PAGE_02,P529_ENTRY_NAME_02'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1542907554991063210)
,p_name=>'Visibility of Entry 1 name/page pairs'
,p_event_sequence=>70
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>':P440_ENTRY_NAME_01 is null and :P440_PAGE_01 is null'
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1542907627032063211)
,p_event_id=>wwv_flow_imp.id(1542907554991063210)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P529_PAGE_01,P529_ENTRY_NAME_01'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(169203919966699778)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create list'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.create_list (',
'    p_flow_id          => :FB_FLOW_ID,',
'    p_page_id          => :FB_FLOW_PAGE_ID,',
'    p_name             => :P427_NAME,',
'    p_entry_name_01    => :P440_ENTRY_NAME_01,',
'    p_page_01          => :P440_PAGE_01,',
'    p_entry_name_02    => :P440_ENTRY_NAME_02,',
'    p_page_02          => :P440_PAGE_02,',
'    p_entry_name_03    => :P440_ENTRY_NAME_03,',
'    p_page_03          => :P440_PAGE_03,',
'    p_entry_name_04    => :P440_ENTRY_NAME_04,',
'    p_page_04          => :P440_PAGE_04,',
'    p_entry_name_05    => :P440_ENTRY_NAME_05,',
'    p_page_05          => :P440_PAGE_05,',
'    p_deploy           => :P529_DEPLOY,',
'    p_region_template  => :P529_REGION_TEMPLATE,',
'    p_list_template_id => :P529_LIST_TEMPLATE_ID,',
'    p_region_position  => :P529_REGION_POSITION,',
'    p_required_patch   => :P427_REQUIRED_PATCH );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'List Created'
,p_internal_uid=>169203919966699778
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(574135998446781515)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'List Created'
,p_internal_uid=>574135998446781515
);
end;
/
prompt --application/pages/page_00533
begin
wwv_flow_imp_page.create_page(
 p_id=>533
,p_name=>'Application Item History'
,p_alias=>'APPLICATION-ITEM-HISTORY'
,p_step_title=>'Application Item History'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(91429205691059841)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_item_app.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(192553216982400527)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(47807005066095922)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Application Items'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(192553415132400529)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>This page displays recent modifications made to Application Items in this application.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(192554027727400537)
,p_plug_name=>'Application Item History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P4651a */',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'  ',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_ITEMS'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(192554218968400540)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192554510279400547)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192554616916400547)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Audit Comment'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192554819141400549)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Component Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192554930992400550)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192555104601400551)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Component Key'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192555225818400552)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Audit Date'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192555315861400553)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(192555416825400554)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1296907364536645'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'AUDIT_DATE:ACTION:DEVELOPER:COMPONENT_NAME'
,p_sort_column_1=>'AUDIT_DATE'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(192553818570400531)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(192554027727400537)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:533:&SESSION.::&DEBUG.:42,RIR::'
);
end;
/
prompt --application/pages/page_00535
begin
wwv_flow_imp_page.create_page(
 p_id=>535
,p_name=>'Build Option History'
,p_alias=>'BUILD-OPTION-HISTORY'
,p_step_title=>'Build Option History'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(91429205691059841)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_build_options.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(192561512772466675)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(47909111131552473)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Build Options'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(192561722239466675)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'This page displays recent modifications made to build options in this application.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(192562308149466677)
,p_plug_name=>'Build Option History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_PATCHES'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(192562531983466678)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_computation=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192562802062466682)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192562917191466683)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Audit Comment'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192563131687466685)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Component Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192563231050466686)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192563427149466687)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Component Key'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192563520629466688)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Audit Date'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192563625150466689)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(192563722494466690)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1297007395536645'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'AUDIT_DATE:ACTION:DEVELOPER:COMPONENT_NAME'
,p_sort_column_1=>'AUDIT_DATE'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(192562107198466677)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(192562308149466677)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:535:&SESSION.::&DEBUG.:42,RIR::'
);
end;
/
prompt --application/pages/page_00536
begin
wwv_flow_imp_page.create_page(
 p_id=>536
,p_name=>'Resequence List Entries'
,p_alias=>'RESEQUENCE-LIST-ENTRIES'
,p_step_title=>'Resequence List Entries'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_help_text=>'nav_list.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(170300908642409203)
,p_plug_name=>'Resequence List Entries'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_column=>false
,p_plug_header=>'<p>Resequence list entries, incrementing sequence numbers by 10.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1119156620289390629)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1119156734376390630)
,p_plug_name=>'Resequence List Entries'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(170303107172430644)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1119156620289390629)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Resequence'
,p_button_position=>'NEXT'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(170302917215430643)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1119156620289390629)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:4050:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(170305232284472776)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(170301229074415090)
,p_name=>'P536_LIST_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(170300908642409203)
,p_prompt=>'List:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id',
'from wwv_flow_lists',
'where flow_id = :FB_FLOW_ID',
'order by upper(name)'))
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(170302505441427237)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'resequence list entries'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   c pls_integer := 0;',
'begin',
'   for c1 in (',
'      select id ',
'      from WWV_FLOW_LIST_ITEMS ',
'      where flow_id = :fb_flow_id and ',
'                list_id = :P536_LIST_ID and',
'                security_group_id = :flow_security_group_id',
'      order by nvl(PARENT_LIST_ITEM_ID,0), list_item_display_sequence, list_item_link_text',
'      ) loop',
'      c := c + 10;',
'      update WWV_FLOW_LIST_ITEMS ',
'      set list_item_display_sequence = c',
'      where list_id = :P536_LIST_ID and',
'                id = c1.id and',
'                flow_id = :fb_flow_id and',
'                security_group_id = :flow_security_group_id;',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_success_message=>'List entries resequenced'
,p_internal_uid=>170302505441427237
);
end;
/
prompt --application/pages/page_00538
begin
wwv_flow_imp_page.create_page(
 p_id=>538
,p_name=>'Copy Template - New Template'
,p_alias=>'COPY-TEMPLATE-NEW-TEMPLATE'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46427514677904461)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(109555417045544112)
,p_plug_name=>'Copy Region Template'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(110747909741657571)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(399849897040726767)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_imp.id(110615031296644849)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(222834001588317852)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(222829818333256486)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':F4000_LAST_VIEW != 4003'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(109555620922544113)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46427514677904461)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(109555716876544113)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(46427514677904461)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy'
,p_button_position=>'CREATE'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(109557727058544127)
,p_branch_name=>'Go To Page 4003'
,p_branch_action=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(109555716876544113)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(109556510763544120)
,p_name=>'P538_FROM_TEMPLATE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(109555417045544112)
,p_prompt=>'From Template'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(109556901890544121)
,p_name=>'P538_TO_TEMPLATE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(109555417045544112)
,p_prompt=>'New Template Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter the name of the new template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(109579809097849909)
,p_name=>'P538_TEMPLATE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(109555417045544112)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Template:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select PAGE_PLUG_TEMPLATE_NAME ',
'from WWV_FLOW_PAGE_PLUG_TEMPLATES',
'where id = :P538_FROM_TEMPLATE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the template to be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1161094178658451301)
,p_name=>'P538_TO_INTERNAL_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(109555417045544112)
,p_prompt=>'New Template Identifier'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the name of the new template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(109582131738865990)
,p_validation_name=>'P538_TO_TEMPLATE_NAME'
,p_validation_sequence=>10
,p_validation=>'P538_TO_TEMPLATE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Template name must be specified'
,p_when_button_pressed=>wwv_flow_imp.id(109555716876544113)
,p_associated_item=>wwv_flow_imp.id(109556901890544121)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1161094454082451304)
,p_validation_name=>'P538_TO_INTERNAL_NAME'
,p_validation_sequence=>20
,p_validation=>'P538_TO_INTERNAL_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Template identifier must be specified'
,p_when_button_pressed=>wwv_flow_imp.id(109555716876544113)
,p_associated_item=>wwv_flow_imp.id(1161094178658451301)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1161094552650451305)
,p_validation_name=>'unique template name'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin ',
'    for c1 in (',
'        select theme_id',
'          from wwv_flow_page_plug_templates ',
'         where id = :P538_FROM_TEMPLATE_ID',
'           and flow_id = :fb_flow_id',
'           and security_group_id = wwv_flow_security.g_security_group_id',
'    ) loop',
'        for c2 in (',
'           select 1',
'             from wwv_flow_page_plug_templates',
'            where page_plug_template_name = :P538_TO_TEMPLATE_NAME',
'              and theme_id = c1.theme_id',
'              and flow_id = :fb_flow_id',
'              and security_group_id = wwv_flow_security.g_security_group_id',
'        ) loop',
'            return false;',
'        end loop;',
'',
'    end loop;        ',
'',
'    return true;',
'',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Template name must be unique'
,p_associated_item=>wwv_flow_imp.id(109556901890544121)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1161094692086451306)
,p_validation_name=>'unique internal name'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin ',
'    for c1 in (',
'        select theme_id',
'          from wwv_flow_page_plug_templates ',
'         where id = :P538_FROM_TEMPLATE_ID',
'           and flow_id = :fb_flow_id',
'           and security_group_id = wwv_flow_security.g_security_group_id',
'    ) loop',
'        for c2 in (',
'           select 1',
'             from wwv_flow_page_plug_templates',
'            where internal_name = :P538_TO_INTERNAL_NAME',
'              and theme_id = c1.theme_id',
'              and flow_id = :fb_flow_id',
'              and security_group_id = wwv_flow_security.g_security_group_id',
'        ) loop',
'            return false;',
'        end loop;',
'',
'    end loop;        ',
'',
'    return true;',
'',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Template identifier must be unique'
,p_associated_item=>wwv_flow_imp.id(1161094178658451301)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(614714486149623631)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(109555620922544113)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(614714782138623631)
,p_event_id=>wwv_flow_imp.id(614714486149623631)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1161094273110451302)
,p_name=>'set internal identifier'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P538_TO_TEMPLATE_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1161094380805451303)
,p_event_id=>wwv_flow_imp.id(1161094273110451302)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P538_TO_INTERNAL_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$x(''P538_TO_TEMPLATE_NAME'').value.toUpperCase().replace(/\s+/g, ''_'');'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(109557513697544124)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy region template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select theme_id from WWV_FLOW_PAGE_PLUG_TEMPLATES where id = :P538_FROM_TEMPLATE_ID and flow_id = :fb_flow_id) loop',
'#OWNER#.WWV_FLOW_TEMPLATES_UTIL.COPY_PLUG (',
'   P_COPY_FROM_FLOW_ID => :fb_flow_id,',
'   P_FLOW_ID => :fb_flow_id,',
'   P_FROM_TEMPLATE_ID => :P538_FROM_TEMPLATE_ID,',
'   P_TO_THEME_ID => c1.theme_id,',
'   P_TO_TEMPLATE_NAME => :P538_TO_TEMPLATE_NAME,',
'   P_TO_INTERNAL_NAME => :P538_TO_INTERNAL_NAME,',
'   P_TO_TEMPLATE_ID => wwv_flow.GET_UNIQUE_ID,',
'   P_SHOW_ERRORS =>false,',
'   p_include_subscription  =>false );',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Template was not copied successfully.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(109555716876544113)
,p_process_success_message=>'Template Copied'
,p_internal_uid=>109557513697544124
);
end;
/
prompt --application/pages/page_00540
begin
wwv_flow_imp_page.create_page(
 p_id=>540
,p_name=>'Unsubscribe Templates'
,p_alias=>'UNSUBSCRIBE-TEMPLATES'
,p_step_title=>'Unsubscribe Templates'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt_view.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(95657215085793481)
,p_plug_name=>'Unsubscribe Templates'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_column=>false
,p_plug_header=>'<p>To unsubscribe templates of a specific template type within the current theme, select the template type and click "Unsubscribe". Note that other themes will not be affected. A subscribed template is a template that has its definition maintained in'
||' another template, the referenced template.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(231651032658843722)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747143348832138165)
,p_plug_name=>'Unsubscribe Templates'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(95657928591797393)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(231651032658843722)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(95658129017797394)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(231651032658843722)
,p_button_name=>'unsubscribe'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Unsubscribe'
,p_button_position=>'CREATE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_themes',
'where flow_id = :FB_FLOW_ID',
'and theme_id = :P540_THEME',
'and reference_id is null'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(95660031970817273)
,p_branch_action=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(95658129017797394)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1449460519535055508)
,p_branch_action=>'f?p=&APP_ID.:540:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(95662614224831099)
,p_name=>'P540_TEMPLATE_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(95657215085793481)
,p_prompt=>'Template Type:'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'TEMPLATE TYPES RETURNING NAME'
,p_lov=>'.'||wwv_flow_imp.id(282026017647000169)||'.'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_themes',
'where flow_id = :FB_FLOW_ID',
'and theme_id = :P540_THEME',
'and reference_id is null'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Check all template types to be unsubscribed then click <strong>Unsubscribe</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(95684317874945672)
,p_name=>'P540_THEME'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_imp.id(95657215085793481)
,p_prompt=>'Theme:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Theme -'
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identifies the current application theme.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(95788716292456120)
,p_name=>'P540_APPLICATION'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_imp.id(95657215085793481)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Application:'
,p_source=>'&FB_FLOW_ID.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1449460625642055509)
,p_name=>'P540_THEME_IS_SUBSCRIBED'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(95657215085793481)
,p_prompt=>'Theme is subscribed'
,p_source=>'wwv_flow_lang.system_message(''THEME_IS_SUBSCRIBED'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_themes',
'where flow_id = :FB_FLOW_ID',
'and theme_id = :P540_THEME',
'and reference_id is not null'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(95666219896842245)
,p_validation_name=>'P540_TEMPLATE_TYPE'
,p_validation_sequence=>10
,p_validation=>'P540_TEMPLATE_TYPE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'At least one template type must be checked.'
,p_when_button_pressed=>wwv_flow_imp.id(95658129017797394)
,p_associated_item=>wwv_flow_imp.id(95662614224831099)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(95660614093821619)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Unsubscribe All Templates'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if instr(:P540_TEMPLATE_TYPE,''PAGE'') > 0 then',
'   update WWV_FLOW_TEMPLATES set REFERENCE_ID = null ',
'   where flow_id = :fb_flow_id and security_group_id = :flow_security_group_id and',
'         THEME_ID = (select theme_id from wwv_flows where id = :fb_flow_id);',
'end if;',
'if instr(:P540_TEMPLATE_TYPE,''REGION'') > 0 then',
'   update WWV_FLOW_PAGE_PLUG_TEMPLATES set REFERENCE_ID = null ',
'   where flow_id = :fb_flow_id and security_group_id = :flow_security_group_id and',
'         THEME_ID = (select theme_id from wwv_flows where id = :fb_flow_id);',
'end if;',
'if instr(:P540_TEMPLATE_TYPE,''LABEL'') > 0 then',
'   update WWV_FLOW_FIELD_TEMPLATES set REFERENCE_ID = null ',
'   where flow_id = :fb_flow_id and security_group_id = :flow_security_group_id and',
'         THEME_ID = (select theme_id from wwv_flows where id = :fb_flow_id);',
'end if;',
'if instr(:P540_TEMPLATE_TYPE,''LIST'') > 0 then',
'   update WWV_FLOW_LIST_TEMPLATES set REFERENCE_ID = null ',
'   where flow_id = :fb_flow_id and security_group_id = :flow_security_group_id and',
'         THEME_ID = (select theme_id from wwv_flows where id = :fb_flow_id);',
'end if;',
'if instr(:P540_TEMPLATE_TYPE,''POPUP_LOV'') > 0 then',
'   update WWV_FLOW_POPUP_LOV_TEMPLATE set REFERENCE_ID = null ',
'   where flow_id = :fb_flow_id and security_group_id = :flow_security_group_id and',
'         THEME_ID = (select theme_id from wwv_flows where id = :fb_flow_id);',
'end if;',
'if instr(:P540_TEMPLATE_TYPE,''CALENDAR'') > 0 then',
'   update WWV_FLOW_CAL_TEMPLATES set REFERENCE_ID = null ',
'   where flow_id = :fb_flow_id and security_group_id = :flow_security_group_id and',
'         THEME_ID = (select theme_id from wwv_flows where id = :fb_flow_id);',
'end if;',
'if instr(:P540_TEMPLATE_TYPE,''MENU'') > 0 then',
'   update WWV_FLOW_MENU_TEMPLATES set REFERENCE_ID = null ',
'   where flow_id = :fb_flow_id and security_group_id = :flow_security_group_id and',
'         THEME_ID = (select theme_id from wwv_flows where id = :fb_flow_id);',
'end if;',
'if instr(:P540_TEMPLATE_TYPE,''BUTTON'') > 0 then',
'   update WWV_FLOW_BUTTON_TEMPLATES set REFERENCE_ID = null ',
'   where flow_id = :fb_flow_id and security_group_id = :flow_security_group_id and',
'         THEME_ID = (select theme_id from wwv_flows where id = :fb_flow_id);',
'end if;',
'if instr(:P540_TEMPLATE_TYPE,''REPORT'') > 0 then',
'   update WWV_FLOW_ROW_TEMPLATES set REFERENCE_ID = null ',
'   where flow_id = :fb_flow_id and security_group_id = :flow_security_group_id and',
'         THEME_ID = (select theme_id from wwv_flows where id = :fb_flow_id);',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>95660614093821619
);
end;
/
prompt --application/pages/page_00541
begin
wwv_flow_imp_page.create_page(
 p_id=>541
,p_name=>'Export Attribute Dictionary'
,p_alias=>'EXPORT-ATTRIBUTE-DICTIONARY'
,p_step_title=>'Export Attribute Dictionary'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213300727323081712)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_exprt_ui_def.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(486421024925175481)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>When you export the Attribute Dictionary, all Defaults defined within the workspace are exported to a single file.  You can use this file to import into another database with &PRODUCT_NAME. installed.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(486421408779175483)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(12802829107)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(486421604042175484)
,p_plug_name=>'Export Settings'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_plug_grid_column_span=>8
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(486423025422175486)
,p_plug_name=>'Export UI Defaults'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(486428511661221024)
,p_plug_name=>'tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>50
,p_list_id=>wwv_flow_imp.id(486427731138207743)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(486423225837175487)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(486423025422175486)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:541:&SESSION.::&DEBUG.:541::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(486421804255175484)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(486423025422175486)
,p_button_name=>'EXPORT_ATTR_DICT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Export'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(486424531039175511)
,p_branch_action=>'f?p=&FLOW_ID.:541:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(486422523747175485)
,p_name=>'P541_ATTR_DICT_COUNT'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(486421604042175484)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Count of Columns:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*) count_of_objects',
'  from wwv_flow_hnt_col_dict_syn',
' where security_group_id = :flow_security_group_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The number of entries in the Attribute Dictionary.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(486424302941175509)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'attr_dict_export'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- set content disposition    ',
'sys.htp.init;',
'wwv_flow.g_page_text_generated := true;',
'wwv_flow_gen_hint.g_mime_shown := true;',
'   ',
'wwv_flow_utilities.print_download_header(',
'    p_mime_type => ''application/x-sql'',',
'    p_is_attachment => true,',
'    p_file_name => lower(wwv_flow.get_company_name(p_escape => false))||''_attr_dict.sql''',
');',
'   ',
'    ',
'sys.owa_util.http_header_close;',
'',
'wwv_flow_gen_hint.export_attr_dict(',
'    p_format => ''UNIX'' );',
'wwv_flow.g_page_text_generated := true;',
'wwv_flow.g_unrecoverable_error := true;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Failed to export Attribute Dictionary. #SQLERRM#'
,p_process_when_button_id=>wwv_flow_imp.id(486421804255175484)
,p_process_success_message=>'Attribute Dictionary exported.'
,p_internal_uid=>486424302941175509
);
end;
/
prompt --application/pages/page_00542
begin
wwv_flow_imp_page.create_page(
 p_id=>542
,p_name=>'Create Dynamic List'
,p_alias=>'CREATE-DYNAMIC-LIST'
,p_page_mode=>'NON_MODAL'
,p_step_title=>'Create Dynamic List'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213210808239773454)
,p_step_template=>wwv_flow_imp.id(120871216744825711)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'570'
,p_dialog_width=>'820'
,p_help_text=>'bldapp_lov.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1442429990800503)
,p_plug_name=>'Create Dynamic List'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(754560176195487446)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(754560286099487447)
,p_plug_name=>'Create Dynamic List'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1442832667800503)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(754560176195487446)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1442613116800503)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(754560176195487446)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1444716352800507)
,p_branch_action=>'f?p=&APP_ID.:701:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(1442832667800503)
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1443018948800503)
,p_name=>'P542_TABLE'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1442429990800503)
,p_prompt=>'Table or View'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d,',
'       object_name r',
'  from sys.dba_objects',
' where object_type in (''TABLE'', ''VIEW'')',
'   and owner = :P542_OWNER',
' order by 1'))
,p_lov_cascade_parent_items=>'P542_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>40
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Table or View that your list of values query will be based on.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET_FILTER'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1443511606800506)
,p_name=>'P542_OWNER'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1442429990800503)
,p_prompt=>'Table / View Owner'
,p_source=>'select owner from wwv_flows where id = :fb_flow_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_SCHEMAS_HAVE_PRIVS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(owner) d, owner v',
'  from wwv_flow_object_owners_dev',
'order by d                   '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Owner -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'The default selected owner for the table or view is the same owner as listed for your application. If the owner of your application has select privileges on tables or views in other schemas, you may choose another schema from this list.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1444010322800506)
,p_name=>'P542_RETURN'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(1442429990800503)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1444326626800506)
,p_validation_name=>'Does table/view exist'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_tables_views_dev',
' where owner        = :P542_OWNER',
'   and object_name  = :P542_TABLE'))
,p_validation_type=>'EXISTS'
,p_error_message=>'Table or View does not exist.'
,p_validation_condition=>'P542_TABLE'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(1442832667800503)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(754560565995487450)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1442613116800503)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(758615135297655701)
,p_event_id=>wwv_flow_imp.id(754560565995487450)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1444405527800507)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Upper table name (if necessary)'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'   select object_name',
'     from sys.dba_objects',
'    where object_type in (''TABLE'',''VIEW'')',
'      and object_name = upper(:P542_TABLE)',
'      and owner       = :P542_OWNER )',
'loop',
'    :P542_TABLE := c1.object_name;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(1442832667800503)
,p_process_when=>':P542_TABLE <> upper(:P542_TABLE)'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>1444405527800507
);
end;
/
prompt --application/pages/page_00546
begin
wwv_flow_imp_page.create_page(
 p_id=>546
,p_name=>'Breadcrumbs'
,p_alias=>'BREADCRUMBS'
,p_step_title=>'Breadcrumbs'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213261028690930718)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_breadcrumb.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30205218343531602)
,p_plug_name=>'Breadcrumbs'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P546a */ id, ',
'       name, ',
'       ''icon-sc-breadcrumb'' icon_class,',
'       replace(replace(name,''_'','' ''),''.'','' '') icon_title,',
'       wwv_flow_page_api.get_url(',
'              p_page   => 104,',
'              p_clear_cache => 104,',
'              p_items  => ''P104_MENU_ID'',',
'              p_values => id) edit_link,',
'       (select count(*) c ',
'          from wwv_flow_menu_options ',
'         where flow_id = :FB_FLOW_ID',
'           and menu_id = m.id) count_of_options,',
'       menu_comment,',
'       last_updated_by updated_by,',
'       last_updated_on updated,',
'       created_by created_by,',
'       created_on created,',
'       wwv_flow_lang.system_message(''EDIT'') edit_text',
'  from wwv_flow_menus m',
' where m.flow_id           = :FB_FLOW_ID',
'   and m.security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(30205316146531602)
,p_name=>'Breadcrumb'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#EDIT_LINK#" class="a-IRR-icon"><span class="a-Icon #ICON_CLASS#"></span><span class="a-IRR-iconName">#ICON_TITLE#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30205511791531605)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Edit'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30205609769531606)
,p_db_column_name=>'NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Name'
,p_column_link=>'f?p=&APP_ID.:104:&SESSION.::&DEBUG.:RP,104:P104_MENU_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30205709895531606)
,p_db_column_name=>'COUNT_OF_OPTIONS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Count of Entries'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30206609058551088)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Edit Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30206702341551089)
,p_db_column_name=>'MENU_COMMENT'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Comment'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30206816211551089)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30206905717551089)
,p_db_column_name=>'UPDATED'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30207009517551089)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Created By'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30207118361551089)
,p_db_column_name=>'CREATED'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Created'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(655628864775789336)
,p_db_column_name=>'ICON_CLASS'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Icon Class'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(655670554953831545)
,p_db_column_name=>'ICON_TITLE'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Icon Title'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1000722229930503604)
,p_db_column_name=>'EDIT_TEXT'
,p_display_order=>22
,p_column_identifier=>'M'
,p_column_label=>'EDIT_TEXT'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(30206031208532453)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_type=>'REPORT'
,p_report_alias=>'1297221428536645'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_view_mode=>'REPORT'
,p_report_columns=>'NAME:COUNT_OF_OPTIONS:UPDATED:UPDATED_BY:'
,p_sort_column_1=>'NAME'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(111620527557599389)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(111619820846587947)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Breadcrumbs'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(227955428882937168)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--sideRegion:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Breadcrumbs provide hierarchical navigation to any number of levels.  Once a breadcrumb is created, breadcrumb entries can be defined.  To define breadcrumb entries click on the breadcrumb name.</p>',
'',
'<p>Breadcrumb entries are associated with pages and also identify a parent page.  Breadcrumbs can be displayed on a page by adding a breadcrumb region using the create region wizard.</p>',
'',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(188944408169320872)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(30205218343531602)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:546:&SESSION.::&DEBUG.:546,RIR::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(227954421264934980)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(30205218343531602)
,p_button_name=>'CreateMenu'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Breadcrumb'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:288:&SESSION.::&DEBUG.:288::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(227952404295930008)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'546'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(574153085992054444)
,p_name=>'Create Button - Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(227954421264934980)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(574153354198054445)
,p_event_id=>wwv_flow_imp.id(574153085992054444)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_02=>'Y'
);
end;
/
prompt --application/pages/page_00547
begin
wwv_flow_imp_page.create_page(
 p_id=>547
,p_name=>'Page Items'
,p_alias=>'PAGE-ITEMS'
,p_step_title=>'Page Items'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213220627333807318)
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(12110822814570416)
,p_plug_name=>'Page Items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>140
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    p.id                            page_id,',
'    p.name                          page_name,',
'    --',
'    i.name                          item_name,',
'    i.display_as,',
'    i.ITEM_SEQUENCE                 display_sequence,',
'    (select plug_name',
'     from wwv_flow_page_plugs',
'     where id = i.ITEM_PLUG_ID)     region,',
'    i.item_plug_id                  region_id,',
'    --',
'    i.use_cache_before_default      source_used,',
'    i.ITEM_DEFAULT                  item_default,',
'    i.ITEM_DEFAULT_TYPE             item_default_type,',
'    --',
'    i.PROMPT                        label,',
'    i.PRE_ELEMENT_TEXT              pre_element_text,',
'    i.POST_ELEMENT_TEXT             post_element_text,',
'    i.FORMAT_MASK                   format_mask,',
'    (select template_name',
'     from   wwv_flow_field_templates',
'     where  id = to_char(i.ITEM_FIELD_TEMPLATE)',
'     and    flow_id = f.id)         item_label_template,',
'    i.ITEM_FIELD_TEMPLATE           item_label_template_id,',
'    i.SOURCE                        item_source,',
'    substr(i.source,1,50)           item_source_snipit,',
'    i.source_type                   item_source_type,',
'    i.SOURCE_POST_COMPUTATION       source_post_computation,',
'    -- read only conditionality',
'    i.read_only_when_type           read_only_condition_type,',
'    i.READ_ONLY_WHEN                read_only_condition_exp1,',
'    i.READ_ONLY_WHEN2               read_only_condition_exp2,',
'    i.READ_ONLY_DISP_ATTR           read_only_display_attr,',
'    --',
'    i.NAMED_LOV                     lov_named_lov,',
'    i.LOV                           lov_definition,',
'    i.lov_display_extra,',
'    i.lov_display_null,',
'    i.LOV_NULL_TEXT                 lov_null_text,',
'    i.LOV_NULL_VALUE                lov_null_value,',
'    i.lov_cascade_parent_items,',
'    i.ajax_items_to_submit          lov_items_to_submit,',
'    i.ajax_optimize_refresh         lov_optimize_refresh,',
'    --',
'    i.csize                         item_element_width,',
'    i.cmaxlength                    item_element_max_length,',
'    i.cheight                       item_element_height,',
'    --',
'    i.cattributes                   html_table_cell_attr_label,',
'    i.cattributes_element           html_table_cell_attr_element,',
'    i.tag_attributes                html_form_element_attributes,',
'    i.tag_attributes2               form_element_option_attributes,',
'    --',
'    i.button_image                  item_button_image,',
'    i.button_image_attr             item_button_image_attributes,',
'    --',
'    i.begin_on_new_line             begins_on_new_row,',
'    i.begin_on_new_field            begins_on_new_cell,',
'    i.COLSPAN                       column_span,',
'    i.ROWSPAN                       row_span,',
'    --',
'    i.label_alignment,',
'    i.field_alignment               item_alignment,',
'    --',
'    --i.FIELD_TEMPLATE,',
'    --',
'    i.display_when_type             condition_type,',
'    i.DISPLAY_WHEN                  condition_expression1,',
'    i.DISPLAY_WHEN2                 condition_expression2,',
'    --',
'    i.is_persistent                 maintain_session_state,',
'    nvl(i.protection_level, ''N'')    item_protection_level,',
'    --i.ESCAPE_ON_HTTP_INPUT',
'    i.escape_on_http_output,',
'    --',
'    decode(substr(i.SECURITY_SCHEME,1,1),''!'',''Not '')||',
'    nvl((select name',
'     from   wwv_flow_security_schemes',
'     where  to_char(id) = ltrim(i.SECURITY_SCHEME,''!'')',
'     and    flow_id = f.id),',
'     i.SECURITY_SCHEME)             authorization_scheme,',
'    i.security_scheme               authorization_scheme_id,',
'    (select case when p.required_patch > 0 then PATCH_NAME else ''{Not ''||PATCH_NAME||''}'' end PATCH_NAME',
'     from   wwv_flow_patches',
'     where  id =abs(i.REQUIRED_PATCH))   build_option,',
'    i.REQUIRED_PATCH                build_option_id,',
'    --',
'    (select max(help_text) h',
'    from wwv_flow_step_item_help',
'    where FLOW_ITEM_ID = i.id)      item_help_text,',
'    --',
'    i.LAST_UPDATED_BY               last_updated_by,',
'    i.LAST_UPDATED_ON               last_updated_on,',
'    i.ITEM_COMMENT                  component_comment,',
'    i.id                            item_id,',
'    nvl(i.encrypt_session_state_yn, ''N'') encrypt_state,',
'    nvl(p.autocomplete_on_off, ''ON'') autocomplete_on_off',
'from wwv_flow_step_items i,',
'     wwv_flow_steps p,',
'     wwv_flows f',
'where i.flow_step_id = p.id and',
'      i.flow_id = :fb_flow_id and',
'      i.security_group_id = :flow_security_group_id and',
'      i.flow_id = f.id and',
'      p.flow_id = i.flow_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(12110932631570416)
,p_name=>'Page Items'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12111122942570438)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Page'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID:&FB_FLOW_ID.,#PAGE_ID#'
,p_column_linktext=>'#PAGE_ID#'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12111231401570438)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Page Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12111315905570438)
,p_db_column_name=>'ITEM_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Item'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE_ID##5120:#ITEM_ID#'
,p_column_linktext=>'#ITEM_NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12111400669570438)
,p_db_column_name=>'DISPLAY_AS'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Display As'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(29353308376249352)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12111617563570438)
,p_db_column_name=>'DISPLAY_SEQUENCE'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Sequence'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12111714884570439)
,p_db_column_name=>'REGION'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Region'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12111825516570439)
,p_db_column_name=>'REGION_ID'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Region ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12111932346570439)
,p_db_column_name=>'SOURCE_USED'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Source Used'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(84930714296823567)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12112009227570439)
,p_db_column_name=>'ITEM_DEFAULT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Item Default'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12112108524570439)
,p_db_column_name=>'ITEM_DEFAULT_TYPE'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Item Default Type'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(38747715987262349)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12112209093570439)
,p_db_column_name=>'LABEL'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Label'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12112330730570440)
,p_db_column_name=>'PRE_ELEMENT_TEXT'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Pre Element Text'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12112421176570440)
,p_db_column_name=>'POST_ELEMENT_TEXT'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Post Element Text'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12112526405570440)
,p_db_column_name=>'FORMAT_MASK'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'Format Mask'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12112627315570440)
,p_db_column_name=>'ITEM_LABEL_TEMPLATE'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Item Label Template'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12112706734570440)
,p_db_column_name=>'ITEM_LABEL_TEMPLATE_ID'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Item Label Template Id'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12112810096570440)
,p_db_column_name=>'ITEM_SOURCE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Item Source'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12112917741570440)
,p_db_column_name=>'ITEM_SOURCE_TYPE'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Item Source Type'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(129889837649)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12113029451570441)
,p_db_column_name=>'SOURCE_POST_COMPUTATION'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Source Post Computation'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12113121033570441)
,p_db_column_name=>'READ_ONLY_CONDITION_TYPE'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>'Read Only Condition Type'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(13602414170805697)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12113214034570441)
,p_db_column_name=>'READ_ONLY_CONDITION_EXP1'
,p_display_order=>22
,p_column_identifier=>'V'
,p_column_label=>'Read Only Condition Expression 1'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12113319039570441)
,p_db_column_name=>'READ_ONLY_CONDITION_EXP2'
,p_display_order=>23
,p_column_identifier=>'W'
,p_column_label=>'Read Only Condition Expression 2'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12113401666570441)
,p_db_column_name=>'READ_ONLY_DISPLAY_ATTR'
,p_display_order=>24
,p_column_identifier=>'X'
,p_column_label=>'Read Only Display Attr'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12113508556570441)
,p_db_column_name=>'LOV_NAMED_LOV'
,p_display_order=>25
,p_column_identifier=>'Y'
,p_column_label=>'List of Values Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12113608005570441)
,p_db_column_name=>'LOV_DEFINITION'
,p_display_order=>26
,p_column_identifier=>'Z'
,p_column_label=>'LOV Definition'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12113803919570442)
,p_db_column_name=>'LOV_DISPLAY_EXTRA'
,p_display_order=>28
,p_column_identifier=>'AB'
,p_column_label=>'LOV Display Extra'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(84270019143507704)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12113931870570442)
,p_db_column_name=>'LOV_DISPLAY_NULL'
,p_display_order=>29
,p_column_identifier=>'AC'
,p_column_label=>'LOV Display Null'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(84270019143507704)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12114007219570442)
,p_db_column_name=>'LOV_NULL_TEXT'
,p_display_order=>30
,p_column_identifier=>'AD'
,p_column_label=>'LOV Null Text'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12114132755570442)
,p_db_column_name=>'LOV_NULL_VALUE'
,p_display_order=>31
,p_column_identifier=>'AE'
,p_column_label=>'LOV Null Value'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(455332720331039832)
,p_db_column_name=>'LOV_CASCADE_PARENT_ITEMS'
,p_display_order=>32
,p_column_identifier=>'BN'
,p_column_label=>'Cascading LOV Parent Item(s)'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(455332830146039838)
,p_db_column_name=>'LOV_ITEMS_TO_SUBMIT'
,p_display_order=>33
,p_column_identifier=>'BO'
,p_column_label=>'Page Items to Submit'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(455332917730039839)
,p_db_column_name=>'LOV_OPTIMIZE_REFRESH'
,p_display_order=>34
,p_column_identifier=>'BP'
,p_column_label=>'Optimize Refresh'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_imp.id(84259319526460470)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12114309836570443)
,p_db_column_name=>'ITEM_ELEMENT_WIDTH'
,p_display_order=>36
,p_column_identifier=>'AG'
,p_column_label=>'Item Element Width'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12114415498570443)
,p_db_column_name=>'ITEM_ELEMENT_MAX_LENGTH'
,p_display_order=>37
,p_column_identifier=>'AH'
,p_column_label=>'Item Element Max Length'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12114524688570444)
,p_db_column_name=>'ITEM_ELEMENT_HEIGHT'
,p_display_order=>38
,p_column_identifier=>'AI'
,p_column_label=>'Item Element Height'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12114617506570444)
,p_db_column_name=>'HTML_TABLE_CELL_ATTR_LABEL'
,p_display_order=>39
,p_column_identifier=>'AJ'
,p_column_label=>'HTML Table Cell Attr Label'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12114714129570444)
,p_db_column_name=>'HTML_TABLE_CELL_ATTR_ELEMENT'
,p_display_order=>40
,p_column_identifier=>'AK'
,p_column_label=>'HTML Table Cell Attr Element'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12114822645570444)
,p_db_column_name=>'HTML_FORM_ELEMENT_ATTRIBUTES'
,p_display_order=>41
,p_column_identifier=>'AL'
,p_column_label=>'HTML Form Element Attributes'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12114932615570444)
,p_db_column_name=>'FORM_ELEMENT_OPTION_ATTRIBUTES'
,p_display_order=>42
,p_column_identifier=>'AM'
,p_column_label=>'Form Element Option Attributes'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12115022733570444)
,p_db_column_name=>'ITEM_BUTTON_IMAGE'
,p_display_order=>43
,p_column_identifier=>'AN'
,p_column_label=>'Item Button Image'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12115114407570445)
,p_db_column_name=>'ITEM_BUTTON_IMAGE_ATTRIBUTES'
,p_display_order=>44
,p_column_identifier=>'AO'
,p_column_label=>'Item Button Image Attributes'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12115208792570445)
,p_db_column_name=>'BEGINS_ON_NEW_ROW'
,p_display_order=>45
,p_column_identifier=>'AP'
,p_column_label=>'Begins On New Row'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(84270019143507704)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12115331998570445)
,p_db_column_name=>'BEGINS_ON_NEW_CELL'
,p_display_order=>46
,p_column_identifier=>'AQ'
,p_column_label=>'Begins On New Cell'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(84270019143507704)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12115403021570445)
,p_db_column_name=>'COLUMN_SPAN'
,p_display_order=>47
,p_column_identifier=>'AR'
,p_column_label=>'Column Span'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12115500878570445)
,p_db_column_name=>'ROW_SPAN'
,p_display_order=>48
,p_column_identifier=>'AS'
,p_column_label=>'Row Span'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12115628426570445)
,p_db_column_name=>'LABEL_ALIGNMENT'
,p_display_order=>49
,p_column_identifier=>'AT'
,p_column_label=>'Label Alignment'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(84757522618851451)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12115721795570446)
,p_db_column_name=>'ITEM_ALIGNMENT'
,p_display_order=>50
,p_column_identifier=>'AU'
,p_column_label=>'Item Alignment'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(84354125395660958)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12115807735570446)
,p_db_column_name=>'CONDITION_TYPE'
,p_display_order=>51
,p_column_identifier=>'AV'
,p_column_label=>'Condition Type'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(13602414170805697)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12115920411570446)
,p_db_column_name=>'CONDITION_EXPRESSION1'
,p_display_order=>52
,p_column_identifier=>'AW'
,p_column_label=>'Condition Expression1'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12116004438570446)
,p_db_column_name=>'CONDITION_EXPRESSION2'
,p_display_order=>53
,p_column_identifier=>'AX'
,p_column_label=>'Condition Expression2'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12116106198570446)
,p_db_column_name=>'MAINTAIN_SESSION_STATE'
,p_display_order=>54
,p_column_identifier=>'AY'
,p_column_label=>'Maintain Session State'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(84831517957313758)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12116223562570446)
,p_db_column_name=>'ITEM_PROTECTION_LEVEL'
,p_display_order=>55
,p_column_identifier=>'AZ'
,p_column_label=>'Item Protection Level'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(109261519627066371)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12116306373570447)
,p_db_column_name=>'AUTHORIZATION_SCHEME'
,p_display_order=>56
,p_column_identifier=>'BA'
,p_column_label=>'Authorization Scheme'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12116425780570447)
,p_db_column_name=>'AUTHORIZATION_SCHEME_ID'
,p_display_order=>57
,p_column_identifier=>'BB'
,p_column_label=>'Authorization Scheme Id'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12116527637570447)
,p_db_column_name=>'BUILD_OPTION'
,p_display_order=>58
,p_column_identifier=>'BC'
,p_column_label=>'Build Option'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12116613636570447)
,p_db_column_name=>'BUILD_OPTION_ID'
,p_display_order=>59
,p_column_identifier=>'BD'
,p_column_label=>'Build Option ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12116719660570447)
,p_db_column_name=>'ITEM_HELP_TEXT'
,p_display_order=>60
,p_column_identifier=>'BE'
,p_column_label=>'Item Help Text'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12116825412570447)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>61
,p_column_identifier=>'BF'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12116924744570447)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>62
,p_column_identifier=>'BG'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12117018439570448)
,p_db_column_name=>'COMPONENT_COMMENT'
,p_display_order=>63
,p_column_identifier=>'BH'
,p_column_label=>'Component Comment'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12117127466570448)
,p_db_column_name=>'ITEM_ID'
,p_display_order=>64
,p_column_identifier=>'BI'
,p_column_label=>'Item ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(13188827647940806)
,p_db_column_name=>'ITEM_SOURCE_SNIPIT'
,p_display_order=>65
,p_column_identifier=>'BJ'
,p_column_label=>'Item Source Snippet'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15464926815520489)
,p_db_column_name=>'ENCRYPT_STATE'
,p_display_order=>66
,p_column_identifier=>'BK'
,p_column_label=>'Encrypt State'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(84259319526460470)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15605905604510826)
,p_db_column_name=>'AUTOCOMPLETE_ON_OFF'
,p_display_order=>67
,p_column_identifier=>'BL'
,p_column_label=>'Form Autocomplete'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(9165706597746719)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(450279831685422527)
,p_db_column_name=>'ESCAPE_ON_HTTP_OUTPUT'
,p_display_order=>68
,p_column_identifier=>'BM'
,p_column_label=>'Escape special characters'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_imp.id(84259319526460470)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(12131926001571445)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1297304754536645'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'PAGE_ID:PAGE_NAME:REGION:DISPLAY_SEQUENCE:ITEM_NAME:DISPLAY_AS:LABEL:ITEM_SOURCE_TYPE:ESCAPE_ON_HTTP_OUTPUT:ENCRYPT_STATE:LAST_UPDATED_ON:LOV_CASCADE_PARENT_ITEMS:LOV_ITEMS_TO_SUBMIT:LOV_OPTIMIZE_REFRESH'
,p_sort_column_1=>'PAGE_ID'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'REGION'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'DISPLAY_SEQUENCE'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47958212730593623)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>100
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(186703109122914661)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(194140607497096059)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(12110822814570416)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:547:&SESSION.::&DEBUG.:547,RIR::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(231107911777474051)
,p_branch_action=>'f?p=&FLOW_ID.:547:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(94966214009865985)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'547'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(231108818356475936)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'rp'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>231108818356475936
);
end;
/
prompt --application/pages/page_00548
begin
wwv_flow_imp_page.create_page(
 p_id=>548
,p_name=>'Page Buttons'
,p_alias=>'PAGE-BUTTONS'
,p_step_title=>'Page Buttons'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213220627333807318)
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(15359803954507631)
,p_plug_name=>'Buttons by Page'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''F4000.BUTTON'') button_type,',
'id, FLOW_STEP_ID page, ',
'BUTTON_SEQUENCE, ',
'(select plug_name from wwv_flow_page_plugs where id = b.button_plug_id) BUTTON_PLUG_ID, ',
'(select PAGE_PLUG_TEMPLATE_NAME from wwv_flow_page_plug_templates where flow_id = :fb_flow_id and id = (select PLUG_TEMPLATE from wwv_flow_page_plugs where id = b.button_plug_id)) region_template,',
'BUTTON_NAME, ',
'button_name request_value,',
'substr(button_image_alt,1,60) BUTTON_IMAGE_ALT,',
'decode(substr(button_image,1,8),''template'',''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'',null) template_based,',
'--',
'(select template_name from WWV_FLOW_BUTTON_TEMPLATES where security_group_id = :flow_security_group_id and flow_id = :fb_flow_id and id = ',
'b.button_template_id) template_id,',
'--',
'decode(button_image,null,''template'',''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'',null) html_based,',
'decode(substr(button_image,1,8),''template'',null,button_image,null,null,''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'') image_based,',
'BUTTON_POSITION,',
'substr(button_redirect_url,1,500) BUTTON_REDIRECT_URL, ',
'decode(button_condition_type,null,null,''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'') BUTTON_CONDITION_TYPE, ',
'BUTTON_IMAGE_ATTRIBUTES, ',
'BUTTON_CATTRIBUTES, ',
'wwv_flow_lang.system_message(database_action) DATABASE_ACTION',
'from WWV_FLOW_STEP_BUTTONS b',
'where flow_id = :fb_flow_id and',
'security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(15359928141507631)
,p_name=>'Buttons by Page'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15360209862507641)
,p_db_column_name=>'PAGE'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>'Page'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE#'
,p_column_linktext=>'#PAGE#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15360427120507641)
,p_db_column_name=>'BUTTON_PLUG_ID'
,p_display_order=>2
,p_column_identifier=>'D'
,p_column_label=>'Region'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15360316864507641)
,p_db_column_name=>'BUTTON_SEQUENCE'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Sequence'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15360503932507642)
,p_db_column_name=>'BUTTON_NAME'
,p_display_order=>4
,p_column_identifier=>'E'
,p_column_label=>'Name'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE##5130:#ID#'
,p_column_linktext=>'#BUTTON_NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15360611428507642)
,p_db_column_name=>'REQUEST_VALUE'
,p_display_order=>5
,p_column_identifier=>'F'
,p_column_label=>'Request Value'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15360718865507642)
,p_db_column_name=>'BUTTON_IMAGE_ALT'
,p_display_order=>6
,p_column_identifier=>'G'
,p_column_label=>'Label'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15361124068507643)
,p_db_column_name=>'BUTTON_POSITION'
,p_display_order=>7
,p_column_identifier=>'K'
,p_column_label=>'Position'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15361221580507643)
,p_db_column_name=>'BUTTON_REDIRECT_URL'
,p_display_order=>8
,p_column_identifier=>'L'
,p_column_label=>'Target'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15361332741507643)
,p_db_column_name=>'BUTTON_CONDITION_TYPE'
,p_display_order=>9
,p_column_identifier=>'M'
,p_column_label=>'Conditional'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15361410303507643)
,p_db_column_name=>'BUTTON_IMAGE_ATTRIBUTES'
,p_display_order=>10
,p_column_identifier=>'N'
,p_column_label=>'Image Attributes'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15361507374507643)
,p_db_column_name=>'BUTTON_CATTRIBUTES'
,p_display_order=>11
,p_column_identifier=>'O'
,p_column_label=>'Attributes'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15361601817507643)
,p_db_column_name=>'DATABASE_ACTION'
,p_display_order=>12
,p_column_identifier=>'P'
,p_column_label=>'Database Action'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15360127192507639)
,p_db_column_name=>'ID'
,p_display_order=>13
,p_column_identifier=>'A'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15360815188507642)
,p_db_column_name=>'TEMPLATE_BASED'
,p_display_order=>14
,p_column_identifier=>'H'
,p_column_label=>'Template Based'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15360918941507642)
,p_db_column_name=>'HTML_BASED'
,p_display_order=>15
,p_column_identifier=>'I'
,p_column_label=>'HTML Based'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15361026800507642)
,p_db_column_name=>'IMAGE_BASED'
,p_display_order=>16
,p_column_identifier=>'J'
,p_column_label=>'Image Based'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193801811724292700)
,p_db_column_name=>'BUTTON_TYPE'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Button Type'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(452287026429811718)
,p_db_column_name=>'TEMPLATE_ID'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Button Template'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(452294801607012758)
,p_db_column_name=>'REGION_TEMPLATE'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Region Template'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(15361818498508242)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1297408335536645'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'PAGE:BUTTON_PLUG_ID:BUTTON_TYPE:BUTTON_NAME:REQUEST_VALUE:BUTTON_IMAGE_ALT:BUTTON_CONDITION_TYPE:TEMPLATE_ID:REGION_TEMPLATE'
,p_sort_column_1=>'PAGE'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47960120957614972)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(16353308133052510)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(193799112576179451)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(15359803954507631)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:548:&SESSION.::&DEBUG.:548,RIR::'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(619286312340140864)
,p_computation_sequence=>30
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'548'
);
end;
/
prompt --application/pages/page_00549
begin
wwv_flow_imp_page.create_page(
 p_id=>549
,p_name=>'Computations By Page'
,p_alias=>'COMPUTATIONS-BY-PAGE'
,p_step_title=>'Computations By Page'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213220627333807318)
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193747111445072199)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>95
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(17446232715505772)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193747615970081181)
,p_plug_name=>'Computations by Page'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>100
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ID, ',
'FLOW_STEP_ID page, ',
'COMPUTATION_SEQUENCE, ',
'COMPUTATION_ITEM, ',
'COMPUTATION_POINT, ',
'COMPUTATION, ',
'decode(wwv_flow_escape.html(COMPUTE_WHEN),null,null,''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'') COMPUTE_WHEN ',
'from WWV_FLOW_STEP_COMPUTATIONS pc',
'where flow_id = :fb_flow_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(193747726257081181)
,p_name=>'Computations by Page'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193748007358081206)
,p_db_column_name=>'PAGE'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>'Page'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE#'
,p_column_linktext=>'#PAGE#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193748115094081206)
,p_db_column_name=>'COMPUTATION_SEQUENCE'
,p_display_order=>2
,p_column_identifier=>'C'
,p_column_label=>'Sequence'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193748222735081207)
,p_db_column_name=>'COMPUTATION_ITEM'
,p_display_order=>3
,p_column_identifier=>'D'
,p_column_label=>'Item'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE##5520:#ID#'
,p_column_linktext=>'#COMPUTATION_ITEM#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193748328195081208)
,p_db_column_name=>'COMPUTATION_POINT'
,p_display_order=>4
,p_column_identifier=>'E'
,p_column_label=>'Computation Point'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193748410997081209)
,p_db_column_name=>'COMPUTATION'
,p_display_order=>5
,p_column_identifier=>'F'
,p_column_label=>'Computation'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193748510253081210)
,p_db_column_name=>'COMPUTE_WHEN'
,p_display_order=>6
,p_column_identifier=>'G'
,p_column_label=>'Conditional'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193747927406081201)
,p_db_column_name=>'ID'
,p_display_order=>7
,p_column_identifier=>'A'
,p_column_label=>'&nbsp;'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(193748714000082390)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1297506164536645'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'PAGE:COMPUTATION_SEQUENCE:COMPUTATION_ITEM:COMPUTATION_POINT:COMPUTATION:COMPUTE_WHEN:ID'
,p_sort_column_1=>'PAGE'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'COMPUTATION_SEQUENCE'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(193749009629090584)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(193747615970081181)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:549:&SESSION.::&DEBUG.:549,RIR::'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(619285316665104248)
,p_computation_sequence=>20
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'549'
);
end;
/
prompt --application/pages/page_00552
begin
wwv_flow_imp_page.create_page(
 p_id=>552
,p_name=>'Processes by Page'
,p_alias=>'PROCESSES-BY-PAGE'
,p_step_title=>'Processes by Page'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213220627333807318)
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193860811817416442)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>91
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(11322022496485821)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193862432598433906)
,p_plug_name=>'Processes by Page'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>100
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'FLOW_STEP_ID page, ',
'"PROCESS_SEQUENCE", ',
'"PROCESS_POINT", ',
'wwv_flow_region_layout.get_process_type_desc(flow_id, PROCESS_TYPE) as process_type, ',
'"PROCESS_NAME", ',
'sys.dbms_lob.substr("PROCESS_SQL_CLOB",4000,1) "PROCESS_SQL_CLOB", ',
'decode(PROCESS_WHEN,null,n.a,y.a)  PROCESS_WHEN',
'from WWV_FLOW_STEP_PROCESSING,',
'  (select wwv_flow_lang.system_message(''YES'') a from dual) y,',
'  (select wwv_flow_lang.system_message(''NO'') a from dual) n',
'where flow_id = :fb_flow_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(193862517844433906)
,p_name=>'Processes by Page'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(617358829232197012)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'H'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193862708951433912)
,p_db_column_name=>'PAGE'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>'Page'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID:&FB_FLOW_ID.,#PAGE#'
,p_column_linktext=>'#PAGE#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193863130809433919)
,p_db_column_name=>'PROCESS_NAME'
,p_display_order=>12
,p_column_identifier=>'E'
,p_column_label=>'Name'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE##5530:#ID#'
,p_column_linktext=>'#PROCESS_NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193862901272433917)
,p_db_column_name=>'PROCESS_POINT'
,p_display_order=>22
,p_column_identifier=>'C'
,p_column_label=>'Process Point'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(842344044)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193862808000433916)
,p_db_column_name=>'PROCESS_SEQUENCE'
,p_display_order=>32
,p_column_identifier=>'B'
,p_column_label=>'Sequence'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193863001697433918)
,p_db_column_name=>'PROCESS_TYPE'
,p_display_order=>42
,p_column_identifier=>'D'
,p_column_label=>'Process Type'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193863222112433920)
,p_db_column_name=>'PROCESS_SQL_CLOB'
,p_display_order=>52
,p_column_identifier=>'F'
,p_column_label=>'Source'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193863314225433921)
,p_db_column_name=>'PROCESS_WHEN'
,p_display_order=>62
,p_column_identifier=>'G'
,p_column_label=>'Conditional'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(193863508962434449)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1297603118536645'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'PAGE:PROCESS_NAME:PROCESS_POINT:PROCESS_SEQUENCE:PROCESS_TYPE:PROCESS_SQL_CLOB:PROCESS_WHEN:'
,p_sort_column_1=>'PAGE'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'PROCESS_POINT'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'PROCESS_SEQUENCE'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(193863903206442285)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(193862432598433906)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:552:&SESSION.::&DEBUG.:552,RIR::'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(617488128059287518)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'552'
);
end;
/
prompt --application/pages/page_00553
begin
wwv_flow_imp_page.create_page(
 p_id=>553
,p_name=>'Cross Page Utilities'
,p_alias=>'CROSS-PAGE-UTILITIES'
,p_step_title=>'Cross Page Utilities'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'page_util.htm'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(492634805116616309)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'   select wwv_flow_lang.system_message(''F4000.UTILITIES.INFO'') msg',
'     from dual )',
'loop',
'   sys.htp.p(''<p>''||c1.msg||''</p>'');',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(492635405537616318)
,p_plug_name=>'Cross Page Utilities'
,p_icon_css_classes=>'icon-page-form-summary'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--shadowScroll:a-Region--paddedBody:h240'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(655568879441187677)
,p_plug_display_sequence=>140
,p_list_id=>wwv_flow_imp.id(492636810051679904)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
,p_plug_column_width=>'apex-col--rightBorder'
);
end;
/
prompt --application/pages/page_00554
begin
wwv_flow_imp_page.create_page(
 p_id=>554
,p_name=>'Authentication Scheme History'
,p_alias=>'AUTHENTICATION-SCHEME-HISTORY'
,p_step_title=>'Authentication Scheme History'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(91429205691059841)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_authentication.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(192762122423723510)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(180433926348108856)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Authentication Schemes'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(192762325780723514)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>This page displays recent modifications made to Authentication Schemes in this application.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(192762927286723522)
,p_plug_name=>'Authentication Scheme History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_AUTHENTICATIONS'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(192763109168723524)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192763430042723585)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192763524356723585)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Audit Comment'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192763714398723587)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Component Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192763822315723588)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192764014783723589)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Component Key'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192764112624723590)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Audit Date'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192764207475723591)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(192764308218723592)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1289107622536644'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'AUDIT_DATE:ACTION:DEVELOPER:COMPONENT_NAME'
,p_sort_column_1=>'AUDIT_DATE'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(192762705997723518)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(192762927286723522)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:554:&SESSION.::&DEBUG.:42,RIR::'
);
end;
/
prompt --application/pages/page_00556
begin
wwv_flow_imp_page.create_page(
 p_id=>556
,p_name=>'Conditional Lists of Values Entries'
,p_alias=>'CONDITIONAL-LISTS-OF-VALUES-ENTRIES'
,p_step_title=>'Conditional Lists of Values Entries'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_lov.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(188103509886859601)
,p_plug_name=>'Conditional Lists of Values Entries'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>100
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select	 "WWV_FLOW_LIST_OF_VALUES_DATA".LOV_DISP_VALUE as "LOV_DISP_VALUE",',
'	 "WWV_FLOW_LIST_OF_VALUES_DATA".LOV_RETURN_VALUE as "LOV_RETURN_VALUE",',
'	 "WWV_FLOW_LIST_OF_VALUES_DATA".ID as "ID",',
'	 "WWV_FLOW_LIST_OF_VALUES_DATA".LOV_DISP_COND_TYPE as "LOV_DISP_COND_TYPE",',
'	 "WWV_FLOW_LISTS_OF_VALUES$".LOV_NAME as "LOV_NAME",',
'	 "WWV_FLOW_LISTS_OF_VALUES$".FLOW_ID as "FLOW_ID" ,',
'         "WWV_FLOW_LISTS_OF_VALUES$".ID as LOV_ID,',
'         "WWV_FLOW_LIST_OF_VALUES_DATA".LOV_DISP_COND,',
'         "WWV_FLOW_LIST_OF_VALUES_DATA".LOV_DISP_COND2',
' from	 "WWV_FLOW_LISTS_OF_VALUES$" "WWV_FLOW_LISTS_OF_VALUES$",',
'	 "WWV_FLOW_LIST_OF_VALUES_DATA" "WWV_FLOW_LIST_OF_VALUES_DATA" ',
' where   WWV_FLOW_LIST_OF_VALUES_DATA.LOV_ID=WWV_FLOW_LISTS_OF_VALUES$.ID',
'   and   "WWV_FLOW_LISTS_OF_VALUES$".flow_id = :fb_flow_id',
'   and   "WWV_FLOW_LISTS_OF_VALUES$".security_group_id = :flow_security_group_id',
'   and   "WWV_FLOW_LIST_OF_VALUES_DATA".security_group_id = :flow_security_group_id',
'   and   "WWV_FLOW_LIST_OF_VALUES_DATA".LOV_DISP_COND_TYPE is not null',
'order by upper(LOV_NAME)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(188103615005859601)
,p_name=>'Conditional Lists of Values Entries'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(188104014311859606)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'C'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(188104212995859608)
,p_db_column_name=>'LOV_NAME'
,p_display_order=>2
,p_column_identifier=>'E'
,p_column_label=>'List of Values'
,p_column_link=>'f?p=&APP_ID.:4111:&SESSION.::&DEBUG.:RP,4111:F4000_P4111_ID:#LOV_ID#'
,p_column_linktext=>'#LOV_NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(188104110367859607)
,p_db_column_name=>'LOV_DISP_COND_TYPE'
,p_display_order=>3
,p_column_identifier=>'D'
,p_column_label=>'Condition Type'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(188103821806859604)
,p_db_column_name=>'LOV_DISP_VALUE'
,p_display_order=>4
,p_column_identifier=>'A'
,p_column_label=>'Display Value'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(188103914727859605)
,p_db_column_name=>'LOV_RETURN_VALUE'
,p_display_order=>5
,p_column_identifier=>'B'
,p_column_label=>'Return Value'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(188104332635859609)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(188104419805859609)
,p_db_column_name=>'LOV_ID'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(188104516997859610)
,p_db_column_name=>'LOV_DISP_COND'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Expression 1'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(188104632274859611)
,p_db_column_name=>'LOV_DISP_COND2'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Expression 2'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(188104818844859950)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1289201632536644'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'ID:LOV_NAME:LOV_DISP_COND_TYPE:LOV_DISP_VALUE:LOV_RETURN_VALUE:FLOW_ID:LOV_ID:LOV_DISP_COND:LOV_DISP_COND2'
,p_sort_column_1=>'LOV_NAME'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(188105211356867235)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>91
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(203029530177365353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Lists of Values'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(188990508324007825)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(188103509886859601)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:556:&SESSION.::&DEBUG.:556,RIR::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(188101031311832358)
,p_branch_action=>'f?p=&FLOW_ID.:556:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(188100804422832355)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when_button_id=>wwv_flow_imp.id(188990508324007825)
,p_internal_uid=>188100804422832355
);
end;
/
prompt --application/pages/page_00557
begin
wwv_flow_imp_page.create_page(
 p_id=>557
,p_name=>'Conditional List Entries'
,p_alias=>'CONDITIONAL-LIST-ENTRIES'
,p_step_title=>'Conditional List Entries'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213210808239773454)
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_list.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(188107132231881664)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(62973516530710918)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Lists'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(188111004901892263)
,p_plug_name=>'Conditional List Entries'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select	/* APEX 4000P557a */ "WWV_FLOW_LISTS".NAME as "LIST_NAME",',
'	 "WWV_FLOW_LISTS".ID as "ID",',
'	 "WWV_FLOW_LISTS".FLOW_ID as "application",',
'	 "WWV_FLOW_LIST_ITEMS".LIST_ITEM_LINK_TEXT as "entry",',
'	 "WWV_FLOW_LIST_ITEMS".LIST_ITEM_DISP_COND_TYPE as "condition_type",',
'	 "WWV_FLOW_LIST_ITEMS".LIST_ITEM_DISP_CONDITION as "Expression1",',
'	 "WWV_FLOW_LIST_ITEMS".LIST_ITEM_DISP_COND_TYPE2 as "Expression2" ',
' from	 "WWV_FLOW_LIST_ITEMS" "WWV_FLOW_LIST_ITEMS",',
'	 "WWV_FLOW_LISTS" "WWV_FLOW_LISTS" ',
' where   WWV_FLOW_LIST_ITEMS.LIST_ID=WWV_FLOW_LISTS.ID',
'   and   "WWV_FLOW_LISTS".FLOW_ID = :fb_flow_id',
'   and   "WWV_FLOW_LISTS".security_group_id = :flow_security_group_id',
'   and   "WWV_FLOW_LIST_ITEMS".security_group_id = :flow_security_group_id',
'   and   "WWV_FLOW_LIST_ITEMS".LIST_ITEM_DISP_COND_TYPE is not null',
'order by upper("WWV_FLOW_LISTS".NAME),',
'         upper("WWV_FLOW_LIST_ITEMS".LIST_ITEM_LINK_TEXT)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(188111124623892263)
,p_name=>'Conditional List Entries'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(188111331233892264)
,p_db_column_name=>'LIST_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'List Name'
,p_column_link=>'f?p=&APP_ID.:4050:&SESSION.::&DEBUG.:RP,4050:F4000_P4050_LIST_ID:#ID#'
,p_column_linktext=>'#LIST_NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(188111429105892265)
,p_db_column_name=>'ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(188111504602892266)
,p_db_column_name=>'application'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(188111628781892267)
,p_db_column_name=>'entry'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Entry'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(188111727076892268)
,p_db_column_name=>'condition_type'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Condition Type'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(13602414170805697)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(188111832343892268)
,p_db_column_name=>'Expression1'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Expression 1'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(188111906894892316)
,p_db_column_name=>'Expression2'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Expression 2'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(188112203092893275)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1289319871536644'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'LIST_NAME:ID:application:entry:condition_type:Expression1:Expression2'
,p_sort_column_1=>'LIST_NAME'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(188940401365902669)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(188111004901892263)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:557:&SESSION.::&DEBUG.:557,RIR::'
,p_grid_new_row=>'Y'
);
end;
/
prompt --application/pages/page_00558
begin
wwv_flow_imp_page.create_page(
 p_id=>558
,p_name=>'Authorization Scheme History'
,p_alias=>'AUTHORIZATION-SCHEME-HISTORY'
,p_step_title=>'Authorization Scheme History'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(91429205691059841)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_authorization.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(192781327431809021)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(180462022520306486)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Authorization Schemes'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(192781522471809024)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>This page displays recent modifications made to Authorization Schemes in this application.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(192782107490809027)
,p_plug_name=>'Authorization Scheme History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_SECURITY_SCHEMES'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(192782318329809028)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192782400829809029)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192782518580809029)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Audit Comment'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192782623046809030)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Component Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192782721898809033)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192782826848809034)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Component Key'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192782907987809035)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Audit Date'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(192783006661809035)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(192783107156809036)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1289404050536644'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'AUDIT_DATE:ACTION:DEVELOPER:COMPONENT_NAME'
,p_sort_column_1=>'AUDIT_DATE'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(192781924503809026)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(192782107490809027)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:558:&SESSION.::&DEBUG.:42,RIR::'
);
end;
/
prompt --application/pages/page_00562
begin
wwv_flow_imp_page.create_page(
 p_id=>562
,p_name=>'Conditional Tab Display'
,p_alias=>'CONDITIONAL-TAB-DISPLAY'
,p_step_title=>'Conditional Tab Display'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213240607818867991)
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(188149320078131278)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(5297709875)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(188149714542131280)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(188151202342139045)
,p_name=>'Conditional Tabs'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select	/* APEX 4000P562a */ FLOW_ID,',
'	 ID ,',
'	 TAB_NAME,',
'	 DISPLAY_CONDITION_TYPE,',
'	 TAB_PLSQL_CONDITION,',
'	 TAB_DISP_COND_TEXT ',
' from "WWV_FLOW_TABS" "WWV_FLOW_TABS"',
'where flow_id = :fb_flow_id',
'  and security_group_id = :flow_security_group_id',
'  and DISPLAY_CONDITION_TYPE is not null'))
,p_display_when_condition=>'P562_COMPONENT'
,p_display_when_cond2=>'TAB'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No Conditional Tabs Found'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(188151429707139046)
,p_query_column_id=>1
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>1
,p_column_heading=>'FLOW_ID'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(188151502822139046)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_column_heading=>'ID'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(188151630537139046)
,p_query_column_id=>3
,p_column_alias=>'TAB_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Tab'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(188151722185139046)
,p_query_column_id=>4
,p_column_alias=>'DISPLAY_CONDITION_TYPE'
,p_column_display_sequence=>4
,p_column_heading=>'Condition Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(13602414170805697)
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(188151808887139047)
,p_query_column_id=>5
,p_column_alias=>'TAB_PLSQL_CONDITION'
,p_column_display_sequence=>5
,p_column_heading=>'Expression 1'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(188151901610139047)
,p_query_column_id=>6
,p_column_alias=>'TAB_DISP_COND_TEXT'
,p_column_display_sequence=>6
,p_column_heading=>'Expression 2'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(188152006498140208)
,p_name=>'Conditional Parent Tabs'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select	/* APEX 4000P562b */ FLOW_ID,',
'	 ID ,',
'	 TAB_NAME,',
'	 DISPLAY_CONDITION_TYPE,',
'	 display_condition,',
'	 display_condition2 ',
' from	 wwv_flow_toplevel_tabs',
'where    flow_id = :fb_flow_id',
'   and   DISPLAY_CONDITION_TYPE is not null'))
,p_display_when_condition=>'P562_COMPONENT'
,p_display_when_cond2=>'PTAB'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No Conditional Parent Tabs Found'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(188152227119140210)
,p_query_column_id=>1
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>1
,p_column_heading=>'FLOW_ID'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(188152301973140210)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_column_heading=>'ID'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(188152410140140210)
,p_query_column_id=>3
,p_column_alias=>'TAB_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Parent Tab'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(188152517902140210)
,p_query_column_id=>4
,p_column_alias=>'DISPLAY_CONDITION_TYPE'
,p_column_display_sequence=>4
,p_column_heading=>'Condition Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(13602414170805697)
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(188152619955140210)
,p_query_column_id=>5
,p_column_alias=>'DISPLAY_CONDITION'
,p_column_display_sequence=>5
,p_column_heading=>'Expression 1'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(188152729042140210)
,p_query_column_id=>6
,p_column_alias=>'DISPLAY_CONDITION2'
,p_column_display_sequence=>6
,p_column_heading=>'Expression 2'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(188154729139156192)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(188149714542131280)
,p_button_name=>'P562_GO'
,p_button_static_id=>'P562_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Go'
,p_button_alignment=>'LEFT'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(188152815848142898)
,p_name=>'P562_COMPONENT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(188149714542131280)
,p_item_default=>'TAB'
,p_prompt=>'Tab Type'
,p_source=>'LOV'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'SHARED COMPONENT CONDITIONS'
,p_lov=>'.'||wwv_flow_imp.id(179567005218713166)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Display by tab type. Select a type and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
end;
/
prompt --application/pages/page_00563
begin
wwv_flow_imp_page.create_page(
 p_id=>563
,p_name=>'Branches by Page'
,p_alias=>'BRANCHES-BY-PAGE'
,p_step_title=>'Branches by Page'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213220627333807318)
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(194574019399976291)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>91
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(11286824340344465)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(194575422626987750)
,p_plug_name=>'Branches by Page'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>100
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'FLOW_STEP_ID page, ',
'BRANCH_ACTION, ',
'BRANCH_POINT,',
'BRANCH_TYPE, ',
'BRANCH_SEQUENCE,',
'branch_name,',
'decode(wwv_flow_escape.html(BRANCH_CONDITION_TYPE),null,null,''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'')  BRANCH_CONDITION_TYPE',
'from WWV_FLOW_STEP_BRANCHES',
'where flow_id = :fb_flow_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(194575528691987750)
,p_name=>'Branches by Page'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(617485826580230363)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'G'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194575702472987754)
,p_db_column_name=>'PAGE'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>'Page'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE#'
,p_column_linktext=>'#PAGE#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194575917406987756)
,p_db_column_name=>'BRANCH_POINT'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Branch Point'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194576118400987757)
,p_db_column_name=>'BRANCH_SEQUENCE'
,p_display_order=>4
,p_column_identifier=>'E'
,p_column_label=>'Sequence'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE##5540:#ID#'
,p_column_linktext=>'#BRANCH_SEQUENCE#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194576012426987757)
,p_db_column_name=>'BRANCH_TYPE'
,p_display_order=>5
,p_column_identifier=>'D'
,p_column_label=>'Branch Type'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194575803480987755)
,p_db_column_name=>'BRANCH_ACTION'
,p_display_order=>6
,p_column_identifier=>'B'
,p_column_label=>'Branch Action'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194576228284987758)
,p_db_column_name=>'BRANCH_CONDITION_TYPE'
,p_display_order=>7
,p_column_identifier=>'F'
,p_column_label=>'Conditional'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(16750604761338328)
,p_db_column_name=>'BRANCH_NAME'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Branch Name'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE##5540:#ID#'
,p_column_linktext=>'#BRANCH_NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(194576531650989331)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1289509092536644'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'PAGE:BRANCH_POINT:BRANCH_SEQUENCE:BRANCH_NAME:BRANCH_TYPE:BRANCH_ACTION:BRANCH_CONDITION_TYPE:'
,p_sort_column_1=>'PAGE'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'BRANCH_POINT'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'BRANCH_SEQUENCE'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(194574410346978279)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(194575422626987750)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:563:&SESSION.::&DEBUG.:563,RIR::'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(617488515031293282)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'563'
);
end;
/
prompt --application/pages/page_00564
begin
wwv_flow_imp_page.create_page(
 p_id=>564
,p_name=>'Copy Template'
,p_alias=>'COPY-TEMPLATE'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(132904725516756515)
,p_plug_name=>'Copy Calendar Template'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(132905109741756522)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(399849897040726767)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(110615031296644849)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(207957624673902588)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(222839726971457622)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(222829818333256486)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':F4000_LAST_VIEW != 4003'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(132905320737756523)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(207957624673902588)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(132905505502756525)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(207957624673902588)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy'
,p_button_position=>'CREATE'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(132907331656756546)
,p_branch_name=>'Go To Page 4003'
,p_branch_action=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(132905505502756525)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(132905719442756528)
,p_name=>'P564_FROM_TEMPLATE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(132904725516756515)
,p_prompt=>'From Template'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(132905924965756533)
,p_name=>'P564_TEMPLATE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(132904725516756515)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Template:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select NAME',
'from WWV_FLOW_CAL_TEMPLATES',
'where id = :P564_FROM_TEMPLATE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the template to be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(132906410349756535)
,p_name=>'P564_TO_TEMPLATE_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(132904725516756515)
,p_prompt=>'New Template Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the name of the new template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(757097392290899235)
,p_name=>'P564_TO_INTERNAL_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(132904725516756515)
,p_prompt=>'New Template Identifier'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the name of the new template identifier.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(132906916630756539)
,p_validation_name=>'P564_TO_TEMPLATE_NAME'
,p_validation_sequence=>10
,p_validation=>'P564_TO_TEMPLATE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Template name must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(132905505502756525)
,p_associated_item=>wwv_flow_imp.id(132906410349756535)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(757097645831899238)
,p_validation_name=>'P564_TO_INTERNAL_NAME'
,p_validation_sequence=>20
,p_validation=>'P564_TO_INTERNAL_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Template identifier must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(132905505502756525)
,p_associated_item=>wwv_flow_imp.id(757097392290899235)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(757097753569899239)
,p_validation_name=>'unique template name'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin ',
'    for c1 in (',
'        select theme_id',
'          from wwv_flow_cal_templates ',
'         where id = :P564_FROM_TEMPLATE_ID',
'           and flow_id = :fb_flow_id',
'           and security_group_id = wwv_flow_security.g_security_group_id',
'    ) loop',
'        for c2 in (',
'           select 1',
'             from wwv_flow_cal_templates',
'            where name = :P564_TO_TEMPLATE_NAME',
'              and theme_id = c1.theme_id',
'              and flow_id = :fb_flow_id',
'              and security_group_id = wwv_flow_security.g_security_group_id',
'        ) loop',
'            return false;',
'        end loop;',
'',
'    end loop;        ',
'',
'    return true;',
'',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Template name must be unique'
,p_associated_item=>wwv_flow_imp.id(132906410349756535)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(757097803039899240)
,p_validation_name=>'unique internal name'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin ',
'    for c1 in (',
'        select theme_id',
'          from wwv_flow_cal_templates ',
'         where id = :P564_FROM_TEMPLATE_ID',
'           and flow_id = :fb_flow_id',
'           and security_group_id = wwv_flow_security.g_security_group_id',
'    ) loop',
'        for c2 in (',
'           select 1',
'             from wwv_flow_cal_templates',
'            where internal_name = :P564_TO_INTERNAL_NAME',
'              and theme_id = c1.theme_id',
'              and flow_id = :fb_flow_id',
'              and security_group_id = wwv_flow_security.g_security_group_id',
'        ) loop',
'            return false;',
'        end loop;',
'',
'    end loop;        ',
'',
'    return true;',
'',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Template identifier must be unique'
,p_associated_item=>wwv_flow_imp.id(757097392290899235)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(614717174753668461)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(132905320737756523)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(614717407419668462)
,p_event_id=>wwv_flow_imp.id(614717174753668461)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(757097490235899236)
,p_name=>'set internal identifier'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P564_TO_TEMPLATE_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(757097588796899237)
,p_event_id=>wwv_flow_imp.id(757097490235899236)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P564_TO_INTERNAL_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$x(''P564_TO_TEMPLATE_NAME'').value.toUpperCase().replace(/\s+/g, ''_'');'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(132907106372756541)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Calendar Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select theme_id ',
'           from WWV_FLOW_CAL_TEMPLATES',
'           where id = :P564_FROM_TEMPLATE_ID and flow_id = :fb_flow_id) loop',
'',
'    wwv_flow_templates_util.copy_calendar_template (',
'       p_copy_from_flow_id   => :FB_FLOW_ID,',
'       p_flow_id             => :FB_FLOW_ID,',
'       p_from_template_id    => :P564_FROM_TEMPLATE_ID,',
'       p_to_template_name    => :P564_TO_TEMPLATE_NAME,',
'       p_to_internal_name    => :P564_TO_INTERNAL_NAME,',
'       p_to_template_id      => wwv_flow.GET_UNIQUE_ID,',
'       p_to_theme_id         => c1.theme_id,',
'       p_include_subscription  =>false ',
'    );',
'',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'#SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(132905505502756525)
,p_process_success_message=>'Template Copied'
,p_internal_uid=>132907106372756541
);
end;
/
prompt --application/pages/page_00567
begin
wwv_flow_imp_page.create_page(
 p_id=>567
,p_name=>'Supporting Object Messages'
,p_alias=>'SUPPORTING-OBJECT-MESSAGES'
,p_step_title=>'Supporting Object Messages'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(24897722063538624)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deployment.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8621301534284477)
,p_plug_name=>'Confirmation'
,p_region_name=>'CONFIRMATION'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>210
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8621702960284479)
,p_plug_name=>'Messages'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8621925857284480)
,p_plug_name=>'Welcome'
,p_region_name=>'WELCOME'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>130
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8622329958284481)
,p_plug_name=>'License'
,p_region_name=>'LICENSE'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>140
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8622520399284481)
,p_plug_name=>'Validations'
,p_region_name=>'VALIDATIONS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>165
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8622723142284482)
,p_plug_name=>'Post Installation'
,p_region_name=>'POST'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>220
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8623100529284484)
,p_plug_name=>'Deinstallation'
,p_region_name=>'DEINSTALL'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>250
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8946512814035107)
,p_plug_name=>'Application Substitutions'
,p_region_name=>'CONFIG'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>155
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22481913873307004)
,p_plug_name=>'Supporting Object Definition tabs'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>11
,p_plug_display_point=>'REGION_POSITION_08'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(22452018965176093)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(24426910798903348)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>180
,p_plug_new_grid=>true
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(24172418538839346)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(35832602590067354)
,p_plug_name=>'Build Options'
,p_region_name=>'BUILDOPTIONS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>160
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46239524385678972)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>30
,p_plug_new_grid=>true
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(57743832572752130)
,p_plug_name=>'Upgrade'
,p_region_name=>'UPGRADE'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>230
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8624000324284489)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(8621702960284479)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8624404341284491)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(8621702960284479)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P567_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(8632831286284538)
,p_branch_action=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(8624000324284489)
,p_branch_sequence=>21
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(396481798906910874)
,p_branch_name=>'Go To Page &P567_BRANCH_PAGE.'
,p_branch_action=>'f?p=&APP_ID.:&P567_BRANCH_PAGE.:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>31
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'substr(:REQUEST,1,13) = ''APPLY_CHANGES'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(29775621294204175)
,p_branch_action=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(8624404341284491)
,p_branch_sequence=>41
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8624809729284492)
,p_name=>'P567_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(8621702960284479)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8625421128284497)
,p_name=>'P567_WELCOME_MESSAGE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(8621925857284480)
,p_use_cache_before_default=>'NO'
,p_item_default=>'wwv_flow_lang.system_message(''INSTALLER.WELCOME_MESSAGE'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Message'
,p_source=>'WELCOME_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_tag_css_classes=>'stretch'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'After successfully importing and installing an application definition, the installation wizard prompts the user to install supporting objects for the application.<p /> ',
'Use this message to introduce the application and describe the actions of the installation scripts.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8625605364284503)
,p_name=>'P567_LICENSE_MESSAGE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(8622329958284481)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Message'
,p_source=>'LICENSE_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_css_classes=>'stretch'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'If the use of this application requires the user to accept a license, enter it here. The user will be prompted to accept the message before installing database objects.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8625820270284504)
,p_name=>'P567_VALIDATION_MESSAGE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(8622520399284481)
,p_use_cache_before_default=>'NO'
,p_item_default=>'wwv_flow_lang.system_message(''INSTALLER.VALIDATION_MESSAGE'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Message'
,p_source=>'VALIDATION_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_css_classes=>'stretch'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Enter a message to display above the list of installation validations when this application installs.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8626009286284504)
,p_name=>'P567_INSTALL_MESSAGE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(8621301534284477)
,p_use_cache_before_default=>'NO'
,p_item_default=>'wwv_flow_lang.system_message(''INSTALLER.CONFIRMATION_MESSAGE'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Message'
,p_source=>'INSTALL_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_css_classes=>'stretch'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Enter a message to display during installation confirmation before the installation scripts are run and configuration options are applied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8626207893284505)
,p_name=>'P567_INSTALL_SUCCESS_MESSAGE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(8622723142284482)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Install Success Message'
,p_source=>'INSTALL_SUCCESS_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_css_classes=>'stretch'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'YES'
,p_help_text=>'Enter a message to display after all installation scripts have run without errors.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8626416202284508)
,p_name=>'P567_INSTALL_FAILURE_MESSAGE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(8622723142284482)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Install Failure Message'
,p_source=>'INSTALL_FAILURE_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_css_classes=>'stretch'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'YES'
,p_help_text=>'Enter a message to display after installation scripts have been run with errors.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8631213639284522)
,p_name=>'P567_DEINSTALL_MESSAGE'
,p_item_sequence=>370
,p_item_plug_id=>wwv_flow_imp.id(8623100529284484)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Deinstall Message'
,p_source=>'DEINSTALL_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_css_classes=>'stretch'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Enter a message to display during deinstallation confirmation when this application is de-installed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8631423719284523)
,p_name=>'P567_DEINSTALL_SUCCESS_MESSAGE'
,p_item_sequence=>380
,p_item_plug_id=>wwv_flow_imp.id(8623100529284484)
,p_use_cache_before_default=>'NO'
,p_item_default=>'wwv_flow_lang.system_message(''INSTALLER.DEINSTALL_SUCCESS_MESSAGE'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Post-Deinstall Message'
,p_source=>'DEINSTALL_SUCCESS_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_css_classes=>'stretch'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Enter a message to display after all deinstallation scripts have run.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8947811214044111)
,p_name=>'P567_CONFIGURATION_MESSAGE'
,p_item_sequence=>400
,p_item_plug_id=>wwv_flow_imp.id(8946512814035107)
,p_use_cache_before_default=>'NO'
,p_item_default=>'wwv_flow_lang.system_message(''INSTALLER.CONFIGURATION_MESSAGE'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Message'
,p_source=>'CONFIGURATION_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_css_classes=>'stretch'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Enter a message to display above the application substitution prompts when this application installs.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(19106518608937289)
,p_name=>'P567_BUILD_OPTIONS_MESSAGE'
,p_item_sequence=>420
,p_item_plug_id=>wwv_flow_imp.id(35832602590067354)
,p_use_cache_before_default=>'NO'
,p_item_default=>'wwv_flow_lang.system_message(''INSTALLER.BUILD_OPTIONS_MESSAGE'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Message'
,p_source=>'BUILD_OPTIONS_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_css_classes=>'stretch'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Enter a message to display above the build option prompts when this application installs.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(29798324598318647)
,p_name=>'P567_BRANCH_PAGE'
,p_item_sequence=>430
,p_item_plug_id=>wwv_flow_imp.id(8621702960284479)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57747725907769185)
,p_name=>'P567_UPGRADE_MESSAGE'
,p_item_sequence=>440
,p_item_plug_id=>wwv_flow_imp.id(57743832572752130)
,p_use_cache_before_default=>'NO'
,p_item_default=>'wwv_flow_lang.system_message(''INSTALLER.UPGRADE_MESSAGE'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Welcome Message'
,p_source=>'UPGRADE_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_css_classes=>'stretch'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Enter a message to welcome message to display before this application''s supporting objects are upgraded.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(58009829276413400)
,p_name=>'P567_UPGRADE_SUCCESS_MESSAGE'
,p_item_sequence=>460
,p_item_plug_id=>wwv_flow_imp.id(57743832572752130)
,p_use_cache_before_default=>'NO'
,p_item_default=>'wwv_flow_lang.system_message(''INSTALLER.SUCCESS_MESSAGE'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Success Message'
,p_source=>'UPGRADE_SUCCESS_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_css_classes=>'stretch'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Enter a message to display after all upgrade scripts have run without errors.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(58013429753423014)
,p_name=>'P567_UPGRADE_FAILURE_MESSAGE'
,p_item_sequence=>470
,p_item_plug_id=>wwv_flow_imp.id(57743832572752130)
,p_use_cache_before_default=>'NO'
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_lang.system_message(''INSTALLER.FAILURE_MESSAGE'')',
''))
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Failure Message'
,p_source=>'UPGRADE_FAILURE_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_css_classes=>'stretch'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Enter a message to display after upgrade scripts have been run with errors.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(58015111877427365)
,p_name=>'P567_UPGRADE_CONFIRM_MESSAGE'
,p_item_sequence=>450
,p_item_plug_id=>wwv_flow_imp.id(57743832572752130)
,p_use_cache_before_default=>'NO'
,p_item_default=>'wwv_flow_lang.system_message(''INSTALLER.CONFIRMATION_MESSAGE'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Confirmation Message'
,p_source=>'UPGRADE_CONFIRM_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_css_classes=>'stretch'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Enter a message to display during upgrade confirmation before the upgrade scripts are run and configuration options are applied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(396481578653893676)
,p_computation_sequence=>10
,p_computation_item=>'P567_BRANCH_PAGE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'substr(v(''REQUEST''),15)'
,p_compute_when=>'substr(:REQUEST,1,13) = ''APPLY_CHANGES'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(8631817178284524)
,p_computation_sequence=>10
,p_computation_item=>'P567_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>'select id from wwv_flow_install where flow_id = :fb_flow_id and security_group_id = :flow_security_group_id'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(8632005234284527)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_INSTALL'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_INSTALL'
,p_attribute_03=>'P567_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Unable to fetch row.'
,p_internal_uid=>8632005234284527
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(8632223977284528)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_INSTALL'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_INSTALL'
,p_attribute_03=>'P567_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'U'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Unable to process row of table WWV_FLOW_INSTALL.'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>8632223977284528
);
end;
/
prompt --application/pages/page_00568
begin
wwv_flow_imp_page.create_page(
 p_id=>568
,p_name=>'Copy Template - New Template'
,p_alias=>'COPY-TEMPLATE-NEW-TEMPLATE1'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46425823288878522)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(110567702071443926)
,p_plug_name=>'Copy Page Template'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(110747005585656313)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(399849897040726767)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_imp.id(110615031296644849)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(222837515412444820)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(222829818333256486)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':F4000_LAST_VIEW != 4003'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(110568114205443944)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46425823288878522)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(110568323589443952)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(46425823288878522)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy'
,p_button_position=>'CREATE'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(110569514100444023)
,p_branch_name=>'Go To Page 4003'
,p_branch_action=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(110568323589443952)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(477696101755867210)
,p_branch_action=>'f?p=&APP_ID.:568:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(110568523931443956)
,p_name=>'P568_FROM_TEMPLATE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(110567702071443926)
,p_prompt=>'From Template'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(110568717548443973)
,p_name=>'P568_TEMPLATE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(110567702071443926)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Template:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select NAME template_name ',
'from WWV_FLOW_TEMPLATES',
'where id = :P568_FROM_TEMPLATE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the template to be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(110568918785443976)
,p_name=>'P568_TO_TEMPLATE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(110567702071443926)
,p_prompt=>'New Template Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the name of the new template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1004723881239877702)
,p_name=>'P568_TO_INTERNAL_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(110567702071443926)
,p_prompt=>'New Template Identifier'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the name of the new template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(110569110472443993)
,p_validation_name=>'P568_TO_TEMPLATE_NAME'
,p_validation_sequence=>10
,p_validation=>'P568_TO_TEMPLATE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Template name must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(110568323589443952)
,p_associated_item=>wwv_flow_imp.id(110568918785443976)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1004724149508877705)
,p_validation_name=>'P568_TO_INTERNAL_NAME'
,p_validation_sequence=>20
,p_validation=>'P568_TO_INTERNAL_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Template identifier must be specified.'
,p_associated_item=>wwv_flow_imp.id(1004723881239877702)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1004724235484877706)
,p_validation_name=>'Unique Name'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin ',
'    for c1 in (',
'        select theme_id',
'          from wwv_flow_templates ',
'         where id = :P568_FROM_TEMPLATE_ID',
'           and flow_id = :fb_flow_id',
'           and security_group_id = wwv_flow_security.g_security_group_id',
'    ) loop',
'        for c2 in (',
'           select 1',
'             from wwv_flow_templates',
'            where name = :P568_TO_TEMPLATE_NAME',
'              and theme_id = c1.theme_id',
'              and flow_id = :fb_flow_id',
'              and security_group_id = wwv_flow_security.g_security_group_id',
'        ) loop',
'            return false;',
'        end loop;',
'',
'    end loop;        ',
'',
'    return true;',
'',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Template name must be unique'
,p_associated_item=>wwv_flow_imp.id(1004723881239877702)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1004724304426877707)
,p_validation_name=>'Unique Identifier'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin ',
'    for c1 in (',
'        select theme_id',
'          from wwv_flow_templates ',
'         where id = :P568_FROM_TEMPLATE_ID',
'           and flow_id = :fb_flow_id',
'           and security_group_id = wwv_flow_security.g_security_group_id',
'    ) loop',
'        for c2 in (',
'           select 1',
'             from wwv_flow_templates',
'            where internal_name = :P568_TO_INTERNAL_NAME',
'              and theme_id = c1.theme_id',
'              and flow_id = :fb_flow_id',
'              and security_group_id = wwv_flow_security.g_security_group_id',
'        ) loop',
'            return false;',
'        end loop;',
'',
'    end loop;        ',
'',
'    return true;',
'',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Template identifier must be unique'
,p_associated_item=>wwv_flow_imp.id(1004723881239877702)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(614712992772570985)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(110568114205443944)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(614713265814570986)
,p_event_id=>wwv_flow_imp.id(614712992772570985)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1004723949030877703)
,p_name=>'Set internal name'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P568_TO_TEMPLATE_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1004724030717877704)
,p_event_id=>wwv_flow_imp.id(1004723949030877703)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P568_TO_INTERNAL_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$x(''P568_TO_TEMPLATE_NAME'').value.toUpperCase().replace(/\s+/g, ''_'');'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(110569307931444012)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Page Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select theme_id from WWV_FLOW_TEMPLATES where id = :P568_FROM_TEMPLATE_ID and flow_id = :fb_flow_id) loop',
'   wwv_flow_templates_util.copy_template (',
'      p_copy_from_flow_id    => :fb_flow_id,',
'      p_flow_id              => :fb_flow_id,',
'      p_from_template_id     => :P568_FROM_TEMPLATE_ID,',
'      p_to_template_name     => :P568_TO_TEMPLATE_NAME,',
'      p_to_internal_name     => :P568_TO_INTERNAL_NAME,       ',
'      p_to_template_id       => wwv_flow.GET_UNIQUE_ID,',
'      p_to_theme_id          => c1.theme_id,',
'      p_include_subscription => false',
'      );',
'',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Template was not copied successfully.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(110568323589443952)
,p_process_success_message=>'Template Copied'
,p_internal_uid=>110569307931444012
);
end;
/
prompt --application/pages/page_00569
begin
wwv_flow_imp_page.create_page(
 p_id=>569
,p_name=>'Copy Template'
,p_alias=>'COPY-TEMPLATE1'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46429329269937057)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(110587312216553035)
,p_plug_name=>'Copy Report Template'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(110666510995648435)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(399849897040726767)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_imp.id(110615031296644849)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(222838705500451466)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(222829818333256486)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':F4000_LAST_VIEW != 4003'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(110587707162553038)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46429329269937057)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(110587919455553040)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(46429329269937057)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy'
,p_button_position=>'CREATE'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(110589111730553046)
,p_branch_name=>'Go To Page 4003'
,p_branch_action=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(110588119329553041)
,p_name=>'P569_FROM_TEMPLATE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(110587312216553035)
,p_prompt=>'From Template'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(110588309615553042)
,p_name=>'P569_TEMPLATE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(110587312216553035)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Template:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ROW_TEMPLATE_NAME',
'from WWV_FLOW_ROW_TEMPLATES',
'where id = :P569_FROM_TEMPLATE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the template to be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(110588501576553042)
,p_name=>'P569_TO_TEMPLATE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(110587312216553035)
,p_prompt=>'New Template Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the name of the new template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1161094889250451308)
,p_name=>'P569_TO_INTERNAL_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(110587312216553035)
,p_prompt=>'New Template Identifier'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the name of the new template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(110588719302553043)
,p_validation_name=>'P569_TO_TEMPLATE_NAME'
,p_validation_sequence=>10
,p_validation=>'P569_TO_TEMPLATE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Template name must be specified'
,p_when_button_pressed=>wwv_flow_imp.id(110587919455553040)
,p_associated_item=>wwv_flow_imp.id(110588501576553042)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1161094757245451307)
,p_validation_name=>'P569_TO_INTERNAL_NAME'
,p_validation_sequence=>20
,p_validation=>'P569_TO_INTERNAL_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Template identifier must be specified'
,p_when_button_pressed=>wwv_flow_imp.id(110587919455553040)
,p_associated_item=>wwv_flow_imp.id(1161094889250451308)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1161094970121451309)
,p_validation_name=>'unique template name'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin ',
'    for c1 in (',
'        select theme_id',
'          from wwv_flow_row_templates ',
'         where id = :P569_FROM_TEMPLATE_ID',
'           and flow_id = :fb_flow_id',
'           and security_group_id = wwv_flow_security.g_security_group_id',
'    ) loop',
'        for c2 in (',
'           select 1',
'             from wwv_flow_row_templates',
'            where row_template_name = :P569_TO_TEMPLATE_NAME',
'              and theme_id = c1.theme_id',
'              and flow_id = :fb_flow_id',
'              and security_group_id = wwv_flow_security.g_security_group_id',
'        ) loop',
'            return false;',
'        end loop;',
'',
'    end loop;        ',
'',
'    return true;',
'',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Template name must be unique'
,p_associated_item=>wwv_flow_imp.id(110588501576553042)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1161095036285451310)
,p_validation_name=>'unique internal name'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin ',
'    for c1 in (',
'        select theme_id',
'          from wwv_flow_row_templates ',
'         where id = :P569_FROM_TEMPLATE_ID',
'           and flow_id = :fb_flow_id',
'           and security_group_id = wwv_flow_security.g_security_group_id',
'    ) loop',
'        for c2 in (',
'           select 1',
'             from wwv_flow_row_templates',
'            where internal_name = :P569_TO_INTERNAL_NAME',
'              and theme_id = c1.theme_id',
'              and flow_id = :fb_flow_id',
'              and security_group_id = wwv_flow_security.g_security_group_id',
'        ) loop',
'            return false;',
'        end loop;',
'',
'    end loop;        ',
'',
'    return true;',
'',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Template identifier must be unique'
,p_associated_item=>wwv_flow_imp.id(1161094889250451308)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(614715233612636470)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(110587707162553038)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(614715514807636470)
,p_event_id=>wwv_flow_imp.id(614715233612636470)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1161095172523451311)
,p_name=>'set internal identifier'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P569_TO_TEMPLATE_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1161095253248451312)
,p_event_id=>wwv_flow_imp.id(1161095172523451311)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P569_TO_INTERNAL_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$x(''P569_TO_TEMPLATE_NAME'').value.toUpperCase().replace(/\s+/g, ''_'');'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(110588923073553044)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Report Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select theme_id from WWV_FLOW_ROW_TEMPLATES where id = :P569_FROM_TEMPLATE_ID and flow_id = :fb_flow_id) loop',
'',
' wwv_flow_templates_util.copy_row_template (',
'    p_copy_from_flow_id   => :fb_flow_id,',
'    p_to_flow_id          => :FB_FLOW_ID,',
'    p_from_template_id    => :P569_FROM_TEMPLATE_ID,',
'    p_to_template_name    => :P569_TO_TEMPLATE_NAME,',
'    p_to_internal_name    => :P569_TO_INTERNAL_NAME,',
'    p_to_template_id      => wwv_flow.GET_UNIQUE_ID,',
'    p_to_theme_id         => c1.theme_id,',
'    p_include_subscription => false',
'    );',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'#SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(110587919455553040)
,p_process_success_message=>'Template Copied'
,p_internal_uid=>110588923073553044
);
end;
/
prompt --application/pages/page_00571
begin
wwv_flow_imp_page.create_page(
 p_id=>571
,p_name=>'Copy Template - New Template'
,p_alias=>'COPY-TEMPLATE-NEW-TEMPLATE2'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46419117373649718)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(110864501590722331)
,p_plug_name=>'Copy Button Template'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(110864903742722334)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(399849897040726767)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_imp.id(110615031296644849)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(222840721908465677)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(222829818333256486)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':F4000_LAST_VIEW != 4003'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(110865102559722335)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46419117373649718)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(110865330989722335)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(46419117373649718)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy'
,p_button_position=>'CREATE'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(110867112968722342)
,p_branch_name=>'Go To Page 4003'
,p_branch_action=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(110865330989722335)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(110865521391722336)
,p_name=>'P571_FROM_TEMPLATE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(110864501590722331)
,p_prompt=>'From Template'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(110865708782722336)
,p_name=>'P571_TEMPLATE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(110864501590722331)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Template:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select TEMPLATE_NAME',
'from WWV_FLOW_BUTTON_TEMPLATES',
'where id = :P571_FROM_TEMPLATE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the template to be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(110866224704722339)
,p_name=>'P571_TO_TEMPLATE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(110864501590722331)
,p_prompt=>'New Template Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the name of the new template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1004725142395877715)
,p_name=>'P571_TO_INTERNAL_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(110864501590722331)
,p_prompt=>'New Template Identifier'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the name of the new template identifier.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(110866728222722340)
,p_validation_name=>'P571_TO_TEMPLATE_NAME'
,p_validation_sequence=>10
,p_validation=>'P571_TO_TEMPLATE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Template name must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(110865330989722335)
,p_associated_item=>wwv_flow_imp.id(110866224704722339)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1004725443634877718)
,p_validation_name=>'P571_TO_INTERNAL_NAME'
,p_validation_sequence=>20
,p_validation=>'P571_TO_INTERNAL_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Template identifier must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(110865330989722335)
,p_associated_item=>wwv_flow_imp.id(1004725142395877715)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1007564351086031503)
,p_validation_name=>'unique template name'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin ',
'    for c1 in (',
'        select theme_id',
'          from wwv_flow_button_templates ',
'         where id = :P571_FROM_TEMPLATE_ID',
'           and flow_id = :fb_flow_id',
'           and security_group_id = wwv_flow_security.g_security_group_id',
'    ) loop',
'        for c2 in (',
'           select 1',
'             from wwv_flow_button_templates',
'            where template_name = :P571_TO_TEMPLATE_NAME',
'              and theme_id = c1.theme_id',
'              and flow_id = :fb_flow_id',
'              and security_group_id = wwv_flow_security.g_security_group_id',
'        ) loop',
'            return false;',
'        end loop;',
'',
'    end loop;        ',
'',
'    return true;',
'',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Template name must be unique'
,p_associated_item=>wwv_flow_imp.id(110866224704722339)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1007564450842031504)
,p_validation_name=>'unique internal name'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin ',
'    for c1 in (',
'        select theme_id',
'          from wwv_flow_button_templates ',
'         where id = :P571_FROM_TEMPLATE_ID',
'           and flow_id = :fb_flow_id',
'           and security_group_id = wwv_flow_security.g_security_group_id',
'    ) loop',
'        for c2 in (',
'           select 1',
'             from wwv_flow_button_templates',
'            where internal_name = :P571_TO_INTERNAL_NAME',
'              and theme_id = c1.theme_id',
'              and flow_id = :fb_flow_id',
'              and security_group_id = wwv_flow_security.g_security_group_id',
'        ) loop',
'            return false;',
'        end loop;',
'',
'    end loop;        ',
'',
'    return true;',
'',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Template name must be unique'
,p_associated_item=>wwv_flow_imp.id(1004725142395877715)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(614716214717663476)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(110865102559722335)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(614716549773663476)
,p_event_id=>wwv_flow_imp.id(614716214717663476)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1004725263558877716)
,p_name=>'set internal identifier'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P571_TO_TEMPLATE_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1004725323925877717)
,p_event_id=>wwv_flow_imp.id(1004725263558877716)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P571_TO_INTERNAL_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$x(''P571_TO_TEMPLATE_NAME'').value.toUpperCase().replace(/\s+/g, ''_'');'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(110866924321722341)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Button Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select theme_id ',
'           from WWV_FLOW_BUTTON_TEMPLATES ',
'           where id = :P571_FROM_TEMPLATE_ID and flow_id = :fb_flow_id) loop',
'',
'    wwv_flow_templates_util.copy_button_template (',
'      p_copy_from_flow_id  => :fb_flow_id,',
'      p_flow_id            => :FB_FLOW_ID,',
'      p_from_template_id   => :P571_FROM_TEMPLATE_ID,',
'      p_to_template_name   => :P571_TO_TEMPLATE_NAME,',
'      p_to_internal_name   => :P571_TO_INTERNAL_NAME,',
'      p_to_template_id     => wwv_flow.GET_UNIQUE_ID,',
'      p_to_theme_id        => c1.theme_id,',
'      p_include_subscription  =>false );',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Template was not copied successfully.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(110865330989722335)
,p_process_success_message=>'Button Template Copied.'
,p_internal_uid=>110866924321722341
);
end;
/
prompt --application/pages/page_00572
begin
wwv_flow_imp_page.create_page(
 p_id=>572
,p_name=>'Create Access Control Pages'
,p_alias=>'CREATE-ACCESS-CONTROL-PAGES'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Access Control Pages'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(24935825160088375)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_acc.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8683003615386510)
,p_plug_name=>'Create Access Control'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_plug_header=>'<p>This wizard creates pages to manage an access control list. Use the Application Access Control shared component to associate application roles with application users. This wizard also adds a <strong>reader</strong>, <strong>contributor</strong> an'
||'d <strong>administrator</strong> role and corresponding authorization scheme to your application. Apply these authorization schemes to pages and page components to manage access by user and role.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'Terri - Updated Header Text to adhere to Oracle Style. Removed references to the two tables that are created. It''s in the App Builder User''s Guide, "How Access Control Works."'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(59662218332417742)
,p_plug_name=>'Create Tab'
,p_parent_plug_id=>wwv_flow_imp.id(8683003615386510)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P2500_NAVIGATION_TYPE'
,p_plug_display_when_cond2=>'L'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(59661629762417740)
,p_name=>'Tabs'
,p_parent_plug_id=>wwv_flow_imp.id(59662218332417742)
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<a title="click to set tab set" href="javascript:$x_Value(''''P572_TAB_SET'''',''''''||',
'       wwv_flow_javascript.escape(tab_set)||',
'       '''''');">''||',
'       wwv_flow_escape.html(tab_set)||',
'       ''</a>'' tab_set, ',
'       tab_step, ',
'       substr(tab_text,1,30) tab_text,',
'       replace(TAB_ALSO_CURRENT_FOR_PAGES,'','','', '') tacfp',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID and ',
'       security_group_id = :flow_security_group_id',
'order  by tab_set, TAB_SEQUENCE, tab_step'))
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>'No tabs or tab sets exist.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(54227918011229738)
,p_query_column_id=>1
,p_column_alias=>'TAB_SET'
,p_column_display_sequence=>1
,p_column_heading=>'Tab Set'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(54228315226229739)
,p_query_column_id=>2
,p_column_alias=>'TAB_STEP'
,p_column_display_sequence=>2
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(54228723180229739)
,p_query_column_id=>3
,p_column_alias=>'TAB_TEXT'
,p_column_display_sequence=>3
,p_column_heading=>'Tab'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(54229189603229739)
,p_query_column_id=>4
,p_column_alias=>'TACFP'
,p_column_display_sequence=>4
,p_column_heading=>'Also&nbsp;Current&nbsp;For'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(979488861935772822)
,p_plug_name=>'Create List Entry'
,p_parent_plug_id=>wwv_flow_imp.id(8683003615386510)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>60
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P2500_NAVIGATION_TYPE'
,p_plug_display_when_cond2=>'L'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44610009033325069)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8683628773386514)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(44610009033325069)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8683805819386516)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(44610009033325069)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(279435611403263589)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(44610009033325069)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(100574840201284406)
,p_branch_action=>'f?p=&APP_ID.:575:&SESSION.::&DEBUG.:RP,575::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(548800697841882440)
,p_branch_name=>'Go To Page 2500'
,p_branch_action=>'f?p=&APP_ID.:2500:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(279435611403263589)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8685700067386531)
,p_name=>'P572_ADMIN_PAGE_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(8683003615386510)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.get_maximum_free_admin_page(:FB_FLOW_ID);',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Administration Page Number'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter an unused page number for the administration page.</p>',
'<p>The default is calculated as the first available page number that is divisible by 100, which is greater than the maximum page number within this application.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(54224099360229735)
,p_name=>'P572_TAB_OPTIONS'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(59662218332417742)
,p_item_default=>'0'
,p_prompt=>'Administration Page<br>Tab Options:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.TAB.OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(35310611267199336)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Specify whether the administration page should be included in tabs.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(54224953519229735)
,p_name=>'P572_TAB_SET'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(59662218332417742)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   t varchar2(4000);',
'begin',
'   for c1 in (',
'select tab_set, count(*) c',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID and ',
'       security_group_id = :flow_security_group_id',
'group  by tab_set',
'order by 2 desc) loop',
'return c1.tab_set;',
'exit;',
'end loop;',
'return null;',
'end;',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Tab Set'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_TABSETS'
,p_lov=>'select wwv_flow_escape.html(d) d, r from wwv_flow_tabset_view'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Tab Set -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Select the tab set you wish to use for this page.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(54225876288229737)
,p_name=>'P572_TAB_LABEL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(59662218332417742)
,p_prompt=>'New Tab Label'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the label for the tab that will be created. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(54226777928229737)
,p_name=>'P572_TAB_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(59662218332417742)
,p_prompt=>'Use Tab'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(TAB_NAME)||'': label="''||wwv_flow_escape.html(substr(TAB_TEXT,1,40))||''"'' tab_text,tab_name',
'from   wwv_flow_tabs',
'where  flow_id = :fb_flow_id and',
'       security_group_id = :flow_security_group_id and',
'       tab_set = :P572_TAB_SET'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Tab -'
,p_lov_cascade_parent_items=>'P572_TAB_SET'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Select the tab to be designated as "current" for this page.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(54230366604232620)
,p_name=>'P572_NAVLIST_OPTIONS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(979488861935772822)
,p_item_default=>'NONE'
,p_prompt=>'Administration Page<br>Navigation Preference'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.NAVIGATIONLIST.OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(925221062390507339)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select how you want this page integrated into the Navigation Menu.<p/>',
'<ul>',
'    <li><strong>Do not associate this page with a Navigation Menu entry</strong> - The new page will not be current or highlighted for any menu entry.</li>',
'    <li><strong>Create a new Navigation Menu entry</strong> - Users will be able to navigate to the new page directly from the Navigation Menu. The new entry can be placed anywhere in the existing hierarchy.</li>',
'    <li><strong>Identify an existing Navigation Menu entry which will be current for this page</strong> - Use this option when you want the new page to highlight an existing, top level, menu entry. Users will not be able to navigate to the new page d'
||'irectly from the Navigation Menu. Therefore, You will need to create or define a navigation control on the top level page selected, such as a button, or link in a report, to go to this new page.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(54231609099232622)
,p_name=>'P572_NAVLIST_ENTRY_NAME'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_imp.id(979488861935772822)
,p_prompt=>'New Navigation Menu Entry'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Enter a name for the new menu control.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(54232518111232622)
,p_name=>'P572_NAVLIST_PARENT_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(979488861935772822)
,p_display_as=>'NATIVE_HIDDEN'
,p_display_when_type=>'NEVER'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select a navigation parent for your new page. When creating a new navigation item, the new item links to',
'the new page. The new item can be added at the top level, by not selecting any parent item, or shown as a child',
'of an existing item. </p>',
'',
'<p>When selecting item without creating a new item, the selected item determines which top level item is shown',
'as the "current" item.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(54233472361232623)
,p_name=>'P572_NEW_PARENT_ID'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_imp.id(979488861935772822)
,p_prompt=>'Parent Navigation Menu Entry'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'NAVLIST_ENTRIES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case',
'           when (nvl(list_item_link_target,''0'')=''0'' or parent_list_item_id is',
'null) then',
'               lpad('' '',(4*(level-1)),''.'')||list_item_link_text',
'           else',
'               lpad('' '',(4*(level-1)),''.'')||'' (''||list_item_link_text ||'')''',
'       end name,',
'       id',
'  from wwv_flow_list_items',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and sub_list_id is null',
' start with list_id = :P2500_NAVLIST_ID and parent_list_item_id is null',
'connect by prior list_id = list_id and prior id = parent_list_item_id',
' order siblings by list_item_display_sequence'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No parent selected - '
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select an existing menu control if you wish to add a menu entry for the new page to this menu control. ',
'When not selecting an existing menu control, a menu control for the new page will be created at the top level.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(54234371003232623)
,p_name=>'P572_EXISTING_PARENT_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(979488861935772822)
,p_prompt=>'Existing Navigation Menu Entry'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'NAVLIST_ENTRIES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case',
'           when (nvl(list_item_link_target,''0'')=''0'' or parent_list_item_id is',
'null) then',
'               lpad('' '',(4*(level-1)),''.'')||list_item_link_text',
'           else',
'               lpad('' '',(4*(level-1)),''.'')||'' (''||list_item_link_text ||'')''',
'       end name,',
'       id',
'  from wwv_flow_list_items',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and sub_list_id is null',
' start with list_id = :P2500_NAVLIST_ID and parent_list_item_id is null',
'connect by prior list_id = list_id and prior id = parent_list_item_id',
' order siblings by list_item_display_sequence'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Select an existing menu control to be shown as the active menu control when rendering the new page. ',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(183322228918962193)
,p_name=>'P572_BUILD_OPTION'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(8683003615386510)
,p_prompt=>'Build Option'
,p_source=>'wwv_flow_lang.system_message(''FEATURE'')||'': ''||wwv_flow_lang.system_message(''FEATURE.ACCESS_CONTROL'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The listed build option(s) will be created to support this feature.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(403321768585284066)
,p_name=>'P572_GROUP_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(8683003615386510)
,p_prompt=>'Page Group'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE_GROUPS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d,',
'       id r',
'  from wwv_flow_page_groups',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
' order by upper(group_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Page Group -'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the name of the page group to associate with this page. Page groups help developers manage the pages within an application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(688505071411608708)
,p_name=>'P572_STARTING_PAGE_ID'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(8683003615386510)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.get_maximum_free_page(:FB_FLOW_ID);',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Starting Page Number'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter an unused starting page number. This feature will create multiple pages starting with the number specified.</p>',
'<p>The default is calculated as the first available page number that is divisible by 10, which is greater than the maximum page number within this application.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(688505187143608709)
,p_name=>'P572_ADMIN_PAGE_OPTION'
,p_is_required=>true
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(8683003615386510)
,p_item_default=>'EXISTING'
,p_prompt=>'Administration Page Preference'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.ADMINPAGE.OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(31963614629360602)||'.'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the administration page, that a list is added to, for this feature.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(688505278692608710)
,p_name=>'P572_ADMIN_PAGE_NAME'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(8683003615386510)
,p_item_default=>'wwv_flow_lang.system_message(''CA.ADMIN.ADMINISTRATION'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Administration Page Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify a name for the administration page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(688505392654608711)
,p_name=>'P572_EXISTING_PAGE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(8683003615386510)
,p_prompt=>'Existing Administration Page'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d',
'  from wwv_flow_steps',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and is_page_pattern   = ''N''',
'order by 2'))
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select an existing page used as the administration page in this application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1941077982091597347)
,p_computation_sequence=>70
,p_computation_item=>'P4716_NAVLIST_ENTRY_NAME'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return wwv_flow_lang.system_message(''WS_ACCESS_CONTROL'');'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(688506933307608727)
,p_validation_name=>'P572_STARTING_PAGE_ID positive, whole number'
,p_validation_sequence=>10
,p_validation=>'P572_STARTING_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>'#LABEL# must be a positive, whole number.'
,p_when_button_pressed=>wwv_flow_imp.id(8683805819386516)
,p_associated_item=>wwv_flow_imp.id(688505071411608708)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(275642313343510001)
,p_validation_name=>'P572_STARTING_PAGE_ID reserved'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.reserve_page (',
'    p_flow_id       => :FB_FLOW_ID,',
'    p_page_id       => :P572_STARTING_PAGE_ID,',
'    p_reuse         => TRUE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P572_STARTING_PAGE_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(8683805819386516)
,p_associated_item=>wwv_flow_imp.id(688505071411608708)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(484178723959534634)
,p_validation_name=>'P572_ADMIN_PAGE_ID positive, whole number'
,p_validation_sequence=>40
,p_validation=>'P572_ADMIN_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>'#LABEL# must be a positive, whole number.'
,p_validation_condition=>'P572_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(8683805819386516)
,p_associated_item=>wwv_flow_imp.id(8685700067386531)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(688507153431608729)
,p_validation_name=>'P572_ADMIN_PAGE_ID not null'
,p_validation_sequence=>50
,p_validation=>'P572_ADMIN_PAGE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P572_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(8683805819386516)
,p_associated_item=>wwv_flow_imp.id(8685700067386531)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(231172981311226020)
,p_validation_name=>'P572_ADMIN_PAGE_ID reserved'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.reserve_page (',
'    p_flow_id       => :FB_FLOW_ID,',
'    p_page_id       => :P572_ADMIN_PAGE_ID,',
'    p_reuse         => TRUE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P572_ADMIN_PAGE_OPTION = ''NEW''',
'and :P572_ADMIN_PAGE_ID is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(8683805819386516)
,p_associated_item=>wwv_flow_imp.id(8685700067386531)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(57926092508361532)
,p_validation_name=>'P572_STARTING_PAGE_ID and P572_ADMIN_PAGE_ID different'
,p_validation_sequence=>80
,p_validation=>':P572_STARTING_PAGE_ID <> :P572_ADMIN_PAGE_ID'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Starting Page Number and Administration Page Number must be different.'
,p_validation_condition=>'P572_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(8683805819386516)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(688507275343608730)
,p_validation_name=>'P572_ADMIN_PAGE_NAME not null'
,p_validation_sequence=>90
,p_validation=>'P572_ADMIN_PAGE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P572_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(8683805819386516)
,p_associated_item=>wwv_flow_imp.id(688505278692608710)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(688507396563608731)
,p_validation_name=>'P572_EXISTING_PAGE not null'
,p_validation_sequence=>100
,p_validation=>'P572_EXISTING_PAGE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P572_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(8683805819386516)
,p_associated_item=>wwv_flow_imp.id(688505392654608711)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(231171552720226006)
,p_validation_name=>'P572_EXISTING_PAGE available'
,p_validation_sequence=>110
,p_validation=>'return wwv_flow_wizard_api.page_exists( p_flow_id => :FB_FLOW_ID, p_page_id => :P572_EXISTING_PAGE );'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'#LABEL# is not a page in the application.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P572_ADMIN_PAGE_OPTION = ''EXISTING''',
'and :P572_EXISTING_PAGE is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(8683805819386516)
,p_associated_item=>wwv_flow_imp.id(688505392654608711)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(688509187662608749)
,p_validation_name=>'P572_TAB_SET not null'
,p_validation_sequence=>120
,p_validation=>'P572_TAB_SET'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P572_TAB_OPTIONS'
,p_validation_condition2=>'1:2'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_when_button_pressed=>wwv_flow_imp.id(8683805819386516)
,p_associated_item=>wwv_flow_imp.id(54224953519229735)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(688509256594608750)
,p_validation_name=>'P572_TAB_LABEL not null'
,p_validation_sequence=>130
,p_validation=>'P572_TAB_LABEL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P572_TAB_OPTIONS'
,p_validation_condition2=>'1'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(8683805819386516)
,p_associated_item=>wwv_flow_imp.id(54225876288229737)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(57826825676033901)
,p_validation_name=>'P572_TAB_NAME not null'
,p_validation_sequence=>140
,p_validation=>'P572_TAB_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P572_TAB_OPTIONS'
,p_validation_condition2=>'2'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(8683805819386516)
,p_associated_item=>wwv_flow_imp.id(54226777928229737)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(57827041602033903)
,p_validation_name=>'P572_NAVLIST_ENTRY_NAME not null'
,p_validation_sequence=>160
,p_validation=>'P572_NAVLIST_ENTRY_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P572_NAVLIST_OPTIONS'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(8683805819386516)
,p_associated_item=>wwv_flow_imp.id(54231609099232622)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(57839268074068376)
,p_validation_name=>'Existing Entry with no List'
,p_validation_sequence=>170
,p_validation=>'P572_EXISTING_PARENT_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P572_NAVLIST_OPTIONS'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(8683805819386516)
,p_associated_item=>wwv_flow_imp.id(54234371003232623)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2948019919785111)
,p_validation_name=>'Navigation Menu not subscribed'
,p_validation_sequence=>180
,p_validation=>'coalesce(:P2500_IS_NAVLIST_SUBSCRIBED,''N'') != ''Y'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'&APP_TEXT$NAVIGATION_MENU_SUBSCRIBED!RAW.'
,p_validation_condition=>':P572_NAVLIST_OPTIONS in ( ''NEW'', ''EXISTING'' ) and :P2500_NAVLIST_ID is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(54230366604232620)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(548800009409880871)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(8683628773386514)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(548800336854880872)
,p_event_id=>wwv_flow_imp.id(548800009409880871)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(688505459308608712)
,p_name=>'Show / Hide Admin Page Options'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P572_ADMIN_PAGE_OPTION'
,p_condition_element=>'P572_ADMIN_PAGE_OPTION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(688505559381608713)
,p_event_id=>wwv_flow_imp.id(688505459308608712)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P572_ADMIN_PAGE_ID,P572_ADMIN_PAGE_NAME,P572_TAB_OPTIONS,P572_NAVLIST_OPTIONS'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(688505801503608716)
,p_event_id=>wwv_flow_imp.id(688505459308608712)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P572_EXISTING_PAGE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(688505607238608714)
,p_event_id=>wwv_flow_imp.id(688505459308608712)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P572_EXISTING_PAGE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(688505702112608715)
,p_event_id=>wwv_flow_imp.id(688505459308608712)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P572_ADMIN_PAGE_ID,P572_ADMIN_PAGE_NAME,P572_TAB_OPTIONS,P572_NAVLIST_OPTIONS'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3775767087840368433)
,p_event_id=>wwv_flow_imp.id(688505459308608712)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P572_TAB_OPTIONS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'0'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3775767147542368434)
,p_event_id=>wwv_flow_imp.id(688505459308608712)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P572_NAVLIST_OPTIONS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'NONE'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(688507454630608732)
,p_name=>'Tab Option 0'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P572_TAB_OPTIONS'
,p_condition_element=>'P572_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'0'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(688507570638608733)
,p_event_id=>wwv_flow_imp.id(688507454630608732)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P572_TAB_SET,P572_TAB_LABEL,P572_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(57830656461033939)
,p_event_id=>wwv_flow_imp.id(688507454630608732)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(59661629762417740)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(688507675281608734)
,p_name=>'Tab Option 1'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P572_TAB_OPTIONS'
,p_condition_element=>'P572_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'1'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(688507760885608735)
,p_event_id=>wwv_flow_imp.id(688507675281608734)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P572_TAB_SET,P572_TAB_LABEL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(688507809895608736)
,p_event_id=>wwv_flow_imp.id(688507675281608734)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P572_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(57830766106033940)
,p_event_id=>wwv_flow_imp.id(688507675281608734)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(59661629762417740)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(688507900807608737)
,p_name=>'Tab Option 2'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P572_TAB_OPTIONS'
,p_condition_element=>'P572_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'2'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(688508052197608738)
,p_event_id=>wwv_flow_imp.id(688507900807608737)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P572_TAB_SET,P572_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(688508148436608739)
,p_event_id=>wwv_flow_imp.id(688507900807608737)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P572_TAB_LABEL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(57830885395033941)
,p_event_id=>wwv_flow_imp.id(688507900807608737)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(59661629762417740)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(688508230469608740)
,p_name=>'New List'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P572_NAVLIST_OPTIONS'
,p_condition_element=>'P572_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(688508334328608741)
,p_event_id=>wwv_flow_imp.id(688508230469608740)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P572_NAVLIST_ENTRY_NAME,P572_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(688508422298608742)
,p_event_id=>wwv_flow_imp.id(688508230469608740)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P572_NAVLIST_ENTRY_NAME,P572_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(688508559022608743)
,p_name=>'Existing List'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P572_NAVLIST_OPTIONS'
,p_condition_element=>'P572_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'EXISTING'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(688508694046608744)
,p_event_id=>wwv_flow_imp.id(688508559022608743)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P572_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(688508764454608745)
,p_event_id=>wwv_flow_imp.id(688508559022608743)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P572_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(688508873187608746)
,p_name=>'Set Tab and Nav List Names'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P572_ADMIN_PAGE_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(688508972592608747)
,p_event_id=>wwv_flow_imp.id(688508873187608746)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P572_NAVLIST_ENTRY_NAME,P572_TAB_LABEL'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P572_ADMIN_PAGE_NAME'
,p_attribute_07=>'P572_ADMIN_PAGE_NAME'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
end;
/
prompt --application/pages/page_00573
begin
wwv_flow_imp_page.create_page(
 p_id=>573
,p_name=>'Copy Template - New Template'
,p_alias=>'COPY-TEMPLATE-NEW-TEMPLATE3'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46424719348867887)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(110964014865104710)
,p_plug_name=>'Copy List Template'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(110964404438104713)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(399849897040726767)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_imp.id(110615031296644849)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(222841709572471595)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(222829818333256486)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':F4000_LAST_VIEW != 4003'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(110964612278104713)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46424719348867887)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(110964823358104714)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(46424719348867887)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy'
,p_button_position=>'CREATE'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(110966612860104719)
,p_branch_name=>'Go To Page 4003'
,p_branch_action=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(110964823358104714)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(110965030435104715)
,p_name=>'P573_FROM_TEMPLATE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(110964014865104710)
,p_prompt=>'From Template'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(110965223101104716)
,p_name=>'P573_TEMPLATE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(110964014865104710)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Template:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select LIST_TEMPLATE_NAME',
'from WWV_FLOW_LIST_TEMPLATES',
'where id = :P573_FROM_TEMPLATE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the template to be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(110965705182104717)
,p_name=>'P573_TO_TEMPLATE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(110964014865104710)
,p_prompt=>'New Template Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the name of the new template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1145991876860648501)
,p_name=>'P573_TO_INTERNAL_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(110964014865104710)
,p_prompt=>'New Template Identifier'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the name of the new template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(110966220912104718)
,p_validation_name=>'P573_TO_TEMPLATE_NAME'
,p_validation_sequence=>10
,p_validation=>'P573_TO_TEMPLATE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Template name must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(110964823358104714)
,p_associated_item=>wwv_flow_imp.id(110965705182104717)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1145992225996648505)
,p_validation_name=>'P573_TO_INTERNAL_NAME'
,p_validation_sequence=>20
,p_validation=>'P573_TO_INTERNAL_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Template identifier must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(110964823358104714)
,p_associated_item=>wwv_flow_imp.id(1145991876860648501)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1145992379900648506)
,p_validation_name=>'unique template name'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin ',
'    for c1 in (',
'        select theme_id',
'          from wwv_flow_list_templates ',
'         where id = :P573_FROM_TEMPLATE_ID',
'           and flow_id = :fb_flow_id',
'           and security_group_id = wwv_flow_security.g_security_group_id',
'    ) loop',
'        for c2 in (',
'           select 1',
'             from wwv_flow_list_templates',
'            where list_template_name = :P573_TO_TEMPLATE_NAME',
'              and theme_id = c1.theme_id',
'              and flow_id = :fb_flow_id',
'              and security_group_id = wwv_flow_security.g_security_group_id',
'        ) loop',
'            return false;',
'        end loop;',
'',
'    end loop;        ',
'',
'    return true;',
'',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Template name must be unique.'
,p_associated_item=>wwv_flow_imp.id(110965705182104717)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1145992488469648507)
,p_validation_name=>'unique internal name'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin ',
'    for c1 in (',
'        select theme_id',
'          from wwv_flow_list_templates ',
'         where id = :P573_FROM_TEMPLATE_ID',
'           and flow_id = :fb_flow_id',
'           and security_group_id = wwv_flow_security.g_security_group_id',
'    ) loop',
'        for c2 in (',
'           select 1',
'             from wwv_flow_list_templates',
'            where internal_name = :P573_TO_INTERNAL_NAME',
'              and theme_id = c1.theme_id',
'              and flow_id = :fb_flow_id',
'              and security_group_id = wwv_flow_security.g_security_group_id',
'        ) loop',
'            return false;',
'        end loop;',
'',
'    end loop;        ',
'',
'    return true;',
'',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Template identifier must be unique.'
,p_associated_item=>wwv_flow_imp.id(1145991876860648501)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(614718084334674334)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(110964612278104713)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(614718326912674335)
,p_event_id=>wwv_flow_imp.id(614718084334674334)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1145992052999648503)
,p_name=>'set internal identifier'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P573_TO_TEMPLATE_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1145992137039648504)
,p_event_id=>wwv_flow_imp.id(1145992052999648503)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P573_TO_INTERNAL_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$x(''P573_TO_TEMPLATE_NAME'').value.toUpperCase().replace(/\s+/g, ''_'');'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(110966400476104719)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy List Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select theme_id from WWV_FLOW_LIST_TEMPLATES where id = :P573_FROM_TEMPLATE_ID and flow_id = :fb_flow_id) loop',
'',
'',
'  wwv_flow_templates_util.copy_list_template (',
'      p_copy_from_flow_id => :fb_flow_id,',
'      p_to_flow_id        => :FB_FLOW_ID,',
'      p_from_template_id => :P573_FROM_TEMPLATE_ID,',
'      p_to_template_name => :P573_TO_TEMPLATE_NAME,',
'      p_to_internal_name => :P573_TO_INTERNAL_NAME,',
'      p_to_template_id   => wwv_flow.GET_UNIQUE_ID,',
'      p_to_theme_id      => c1.theme_id,',
'      p_include_subscription => false);',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Template was not copied successfully.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(110964823358104714)
,p_process_success_message=>'Template Copied'
,p_internal_uid=>110966400476104719
);
end;
/
prompt --application/pages/page_00574
begin
wwv_flow_imp_page.create_page(
 p_id=>574
,p_name=>'Copy Template'
,p_alias=>'COPY-TEMPLATE2'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46422416447857617)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(110984703629136051)
,p_plug_name=>'Copy Label Template'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(110985101967136053)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(399849897040726767)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_imp.id(110615031296644849)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(222842702084478894)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(222829818333256486)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':F4000_LAST_VIEW != 4003'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(110985300580136053)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46422416447857617)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(110985526152136054)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(46422416447857617)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy'
,p_button_position=>'CREATE'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(110987315868136060)
,p_branch_name=>'Go To Page 4003'
,p_branch_action=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(110985526152136054)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(110985704432136054)
,p_name=>'P574_FROM_TEMPLATE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(110984703629136051)
,p_prompt=>'From Template'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(110985920717136056)
,p_name=>'P574_TEMPLATE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(110984703629136051)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Template:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select TEMPLATE_NAME',
'from WWV_FLOW_FIELD_TEMPLATES',
'where id = :P574_FROM_TEMPLATE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the template to be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(110986427878136057)
,p_name=>'P574_TO_TEMPLATE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(110984703629136051)
,p_prompt=>'New Template Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the name of the new template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1127923127596976501)
,p_name=>'P574_TO_INTERNAL_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(110984703629136051)
,p_prompt=>'New Template Identifier'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the name of the new template identifier.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(110986922490136058)
,p_validation_name=>'P574_TO_TEMPLATE_NAME'
,p_validation_sequence=>10
,p_validation=>'P574_TO_TEMPLATE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Template name must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(110985526152136054)
,p_associated_item=>wwv_flow_imp.id(110986427878136057)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1127923424304976504)
,p_validation_name=>'P574_TO_INTERNAL_NAME'
,p_validation_sequence=>20
,p_validation=>'P574_TO_INTERNAL_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Template identifier must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(110985526152136054)
,p_associated_item=>wwv_flow_imp.id(1127923127596976501)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1127923582243976505)
,p_validation_name=>'unique template name'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin ',
'    for c1 in (',
'        select theme_id',
'          from wwv_flow_field_templates ',
'         where id = :P574_FROM_TEMPLATE_ID',
'           and flow_id = :fb_flow_id',
'           and security_group_id = wwv_flow_security.g_security_group_id',
'    ) loop',
'        for c2 in (',
'           select 1',
'             from wwv_flow_field_templates',
'            where template_name = :P574_TO_TEMPLATE_NAME',
'              and theme_id = c1.theme_id',
'              and flow_id = :fb_flow_id',
'              and security_group_id = wwv_flow_security.g_security_group_id',
'        ) loop',
'            return false;',
'        end loop;',
'',
'    end loop;        ',
'',
'    return true;',
'',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Template name must be unique'
,p_associated_item=>wwv_flow_imp.id(110986427878136057)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1127923650469976506)
,p_validation_name=>'unique internal name'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin ',
'    for c1 in (',
'        select theme_id',
'          from wwv_flow_field_templates ',
'         where id = :P574_FROM_TEMPLATE_ID',
'           and flow_id = :fb_flow_id',
'           and security_group_id = wwv_flow_security.g_security_group_id',
'    ) loop',
'        for c2 in (',
'           select 1',
'             from wwv_flow_field_templates',
'            where internal_name = :P574_TO_INTERNAL_NAME',
'              and theme_id = c1.theme_id',
'              and flow_id = :fb_flow_id',
'              and security_group_id = wwv_flow_security.g_security_group_id',
'        ) loop',
'            return false;',
'        end loop;',
'',
'    end loop;        ',
'',
'    return true;',
'',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Template identifier must be unique'
,p_associated_item=>wwv_flow_imp.id(1127923127596976501)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(614718695474677276)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(110985300580136053)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(614718983851677277)
,p_event_id=>wwv_flow_imp.id(614718695474677276)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1127923224241976502)
,p_name=>'set internal identifier'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P574_TO_TEMPLATE_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1127923333276976503)
,p_event_id=>wwv_flow_imp.id(1127923224241976502)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P574_TO_INTERNAL_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$x(''P574_TO_TEMPLATE_NAME'').value.toUpperCase().replace(/\s+/g, ''_'');'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(110987114685136059)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Label Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select theme_id from WWV_FLOW_FIELD_TEMPLATES where id = :P574_FROM_TEMPLATE_ID and flow_id = :fb_flow_id) loop',
'',
'    wwv_flow_templates_util.copy_field_template (',
'      p_copy_from_flow_id  => :fb_flow_id,',
'      p_flow_id            =>:fb_flow_id,',
'      p_from_template_id   => :P574_FROM_TEMPLATE_ID,',
'      p_to_template_name   => :P574_TO_TEMPLATE_NAME,',
'      p_to_internal_name   => :P574_TO_INTERNAL_NAME,',
'      p_to_template_id     => wwv_flow.GET_UNIQUE_ID,',
'      p_to_theme_id        => c1.theme_id,',
'      p_include_subscription => false);',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'#SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(110985526152136054)
,p_process_success_message=>'Template Copied'
,p_internal_uid=>110987114685136059
);
end;
/
prompt --application/pages/page_00575
begin
wwv_flow_imp_page.create_page(
 p_id=>575
,p_name=>'Create Access Control - Confirm'
,p_alias=>'CREATE-ACCESS-CONTROL-CONFIRM'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Access Control Pages - Confirmation'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(11511713242614593)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_page_comment=>'To be Deleted'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(336661900980368648)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(957479368832976483)
,p_plug_name=>'Confirmation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_wiz_confirm.create_acl (',
'        p_flow_id         => :FB_FLOW_ID,',
'        p_page_id         => :P572_STARTING_PAGE_ID,',
'        p_admin_page_id   => :P572_ADMIN_PAGE_ID,',
'        p_admin_page_name => :P572_ADMIN_PAGE_NAME,',
'        p_existing_page   => :P572_EXISTING_PAGE );',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(149559481006468683)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(336661900980368648)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(149559801419468685)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(336661900980368648)
,p_button_name=>'FINISH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(149560226721468686)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(336661900980368648)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:572:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(149562437874468720)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(149559481006468683)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(149562961887468722)
,p_event_id=>wwv_flow_imp.id(149562437874468720)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(149562030808468716)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create acl feature page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_admin_page wwv_flow_app_feature_v3.t_admin_page;',
'begin',
'    -- admin page',
'    l_admin_page.page_option                 := :P572_ADMIN_PAGE_OPTION;',
'    l_admin_page.new_page_id                 := :P572_ADMIN_PAGE_ID;',
'    l_admin_page.page_name                   := :P572_ADMIN_PAGE_NAME;',
'    l_admin_page.existing_page_id            := :P572_EXISTING_PAGE;',
'    -- tabs',
'    l_admin_page.tab_option                  := :P572_TAB_OPTIONS;',
'    l_admin_page.tab_set                     := :P572_TAB_SET;',
'    l_admin_page.tab_name                    := :P572_TAB_NAME;',
'    l_admin_page.tab_text                    := :P572_TAB_LABEL;',
'    -- nav list',
'    l_admin_page.nav_list_option             := :P572_NAVLIST_OPTIONS;',
'    l_admin_page.nav_list_id                 := :P2500_NAVLIST_ID;',
'    l_admin_page.nav_list_new_parent_id      := :P572_NEW_PARENT_ID;',
'    l_admin_page.nav_list_existing_parent_id := :P572_EXISTING_PARENT_ID;',
'    l_admin_page.nav_list_entry_name         := :P572_NAVLIST_ENTRY_NAME;',
'    ',
'    wwv_flow_app_feature_v3.add_feature_acl(',
'        p_app_id                     => :FB_FLOW_ID,',
'        p_starting_page_id           => :P572_STARTING_PAGE_ID,',
'        p_group_id                   => :P572_GROUP_ID,',
'        p_admin_page                 => l_admin_page );',
'    ',
'    :FB_FLOW_PAGE_ID := wwv_flow_app_feature_v3.get_admin_page_id( p_admin_page => l_admin_page);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to create page. #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(149559801419468685)
,p_internal_uid=>149562030808468716
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(149561615340468714)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,REQUEST'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Page created successfully.'
,p_internal_uid=>149561615340468714
);
end;
/
prompt --application/pages/page_00576
begin
wwv_flow_imp_page.create_page(
 p_id=>576
,p_name=>'Deinstall Script'
,p_alias=>'DEINSTALL-SCRIPT1'
,p_step_title=>'Deinstall Script'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(24897722063538624)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deployment.htm'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(12984929918641915)
,p_plug_name=>'Deinstall Script'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>131
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    sys.htp.p(''<pre class="code">'');',
'',
'    for c1 in (select id, deinstall_script',
'              from WWV_FLOW_INSTALL',
'              where flow_id = :fb_flow_id',
'                and security_group_id = :flow_security_group_id',
'                and nvl(sys.dbms_lob.getlength(deinstall_script),0) > 0)',
'    loop',
'        wwv_htp.print_clob(c1.deinstall_script);',
'    end loop;',
'    sys.htp.p(''</pre>'');',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<p>Define a script to drop database objects and static files that are created by the installation scripts.</p>'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22495516128345571)
,p_plug_name=>'Supporting Object Definition tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>90
,p_list_id=>wwv_flow_imp.id(22452018965176093)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(24431027552917688)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>41
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(24172418538839346)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(34016307311976695)
,p_plug_name=>'Deinstall Script'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>100
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(107279720885220346)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(34016307311976695)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:850:&SESSION.::&DEBUG.:850:P850_MODE,F4000_LAST_VIEW,P865_DEINSTALL_MODE:DEINSTALL,576,CREATE:'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and nvl(sys.dbms_lob.getlength(deinstall_script),0) > 0'))
,p_button_condition_type=>'NOT_EXISTS'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(12986006416663549)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(34016307311976695)
,p_button_name=>'EDIT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Edit'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:865:&SESSION.::&DEBUG.:865:P865_MODE,F4000_LAST_VIEW,P865_DEINSTALL_MODE:DEINSTALL,576,EDIT:'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and nvl(sys.dbms_lob.getlength(deinstall_script),0) > 0'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(22552102557511924)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(34016307311976695)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:RP::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(107433801107962172)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(34016307311976695)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'',''DELETE'');'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and nvl(sys.dbms_lob.getlength(deinstall_script),0) > 0'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(29885230653632646)
,p_branch_name=>'Go To Page &P567_BRANCH_PAGE.'
,p_branch_action=>'f?p=&APP_ID.:&P567_BRANCH_PAGE.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'substr(:REQUEST,1,13) = ''APPLY_CHANGES'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(107434019123962177)
,p_branch_action=>'f?p=&FLOW_ID.:576:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(107433801107962172)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(29884325112631016)
,p_computation_sequence=>10
,p_computation_item=>'P567_BRANCH_PAGE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'substr(v(''REQUEST''),15)'
,p_compute_when=>'substr(:REQUEST,1,13) = ''APPLY_CHANGES'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(107435407818973578)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete script'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'update wwv_flow_install',
'   set deinstall_script = empty_clob',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Deinstall script could not be deleted.'
,p_process_when_button_id=>wwv_flow_imp.id(107433801107962172)
,p_process_success_message=>'Deinstall script deleted.'
,p_internal_uid=>107435407818973578
);
end;
/
prompt --application/pages/page_00578
begin
wwv_flow_imp_page.create_page(
 p_id=>578
,p_name=>'Install Script'
,p_alias=>'INSTALL-SCRIPT'
,p_step_title=>'Install Script'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(24897722063538624)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deployment.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22662428733970080)
,p_plug_name=>'Install Script'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22692214560148486)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(4589709522084091)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(208096528753998313)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747143461108138166)
,p_plug_name=>'Install Script'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(22662909207970081)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(208096528753998313)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:473:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(22662616877970080)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(208096528753998313)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
,p_button_condition=>'P578_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(49898232193916120)
,p_branch_action=>'f?p=&APP_ID.:667:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(22662616877970080)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P578_SCRIPT_TYPE'
,p_branch_condition_text=>'UPGRADE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(22663513402970085)
,p_branch_action=>'f?p=&APP_ID.:473:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22663701104970087)
,p_name=>'P578_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(22662428733970080)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22663904229970095)
,p_name=>'P578_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(22662428733970080)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&P855_SCRIPT_NAME.'
,p_prompt=>'Name:'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'The name of the script.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22664315733970100)
,p_name=>'P578_SEQUENCE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(22662428733970080)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&P855_SCRIPT_SEQUENCE.'
,p_prompt=>'Sequence:'
,p_source=>'SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'The sequence number of the script.  Scripts run in order of increasing sequence number.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22664728016970101)
,p_name=>'P578_SCRIPT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(22662428733970080)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Install Script:'
,p_source=>'SCRIPT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>20
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Edit your installation script below.  When a user installs this application and chooses to run installation scripts, this script will run using that user''s database credentials.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(49845815721722235)
,p_name=>'P578_SCRIPT_TYPE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(22662428733970080)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&P850_MODE.'
,p_source=>'SCRIPT_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(22664907834970103)
,p_validation_name=>'P578_SCRIPT not null'
,p_validation_sequence=>10
,p_validation=>'P578_SCRIPT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Script must have some value.'
,p_associated_item=>wwv_flow_imp.id(22664728016970101)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(22665109300970104)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_INSTALL_SCRIPTS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_INSTALL_SCRIPTS'
,p_attribute_03=>'P578_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Unable to fetch row.'
,p_internal_uid=>22665109300970104
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(22665300372970108)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_INSTALL_SCRIPTS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_INSTALL_SCRIPTS'
,p_attribute_03=>'P578_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Unable to process row of table WWV_FLOW_INSTALL_SCRIPTS.'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>22665300372970108
);
end;
/
prompt --application/pages/page_00580
begin
wwv_flow_imp_page.create_page(
 p_id=>580
,p_name=>'Create Web Service Reference'
,p_alias=>'CREATE-WEB-SERVICE-REFERENCE'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Web Service Reference'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(13181024405676456)
,p_plug_name=>'Create Web Service Reference'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>'<p>Use this page to enter the URL to WSDL document that describes the service in detail.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'Region generated 19-APR-2004 13:34:33'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(20991903444706304)
,p_plug_name=>'Authentication'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>145
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'Region generated 19-APR-2004 13:34:33'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22492500298337049)
,p_plug_name=>'Navigation'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(22410710903630445)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(28361114075150413)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(399849897040726767)
,p_plug_display_sequence=>150
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(28359907580129646)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(204751120735142740)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>11
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(36499004331317665)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(204751120735142740)
,p_button_name=>'FINISH'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Finish'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(13182513932676458)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(204751120735142740)
,p_button_name=>'NEXT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(13182400685676458)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(204751120735142740)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(13182205592676458)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(204751120735142740)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(13184431855676463)
,p_branch_action=>'f?p=&FLOW_ID.:585:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'nvl(:REQUEST,''NEXT'') = ''NEXT'''
,p_branch_condition_text=>'PLSQL'
,p_branch_comment=>'Generated 19-APR-2004 13:34:33'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(13183011073676459)
,p_branch_action=>'f?p=&APP_ID.:170:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(13182205592676458)
,p_branch_sequence=>1
,p_branch_comment=>'Generated 19-APR-2004 13:34:33'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(13271707529806670)
,p_branch_action=>'f?p=&APP_ID.:870:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(13182400685676458)
,p_branch_sequence=>5
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(13181914584676457)
,p_name=>'P580_WSDL_URL'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(13181024405676456)
,p_prompt=>'WSDL Location'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the URL to the WSDL document.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_item_comment=>'Generated 19-APR-2004 13:34:33'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20992818335710661)
,p_name=>'P580_USERNAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(20991903444706304)
,p_prompt=>'Username'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the username required to access the WSDL. Some WSDL''s require basic authentication credentials in order to access them.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20993628378713565)
,p_name=>'P580_PASSWORD'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(20991903444706304)
,p_prompt=>'Password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter the password that is required to access the WSDL. Some WSDL''s require basic authentication credentials in order to access them.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(14176222735102420)
,p_validation_name=>'P580_WSDL_URL'
,p_validation_sequence=>10
,p_validation=>'P580_WSDL_URL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'You must supply the URL to the WSDL document.'
,p_validation_condition=>'nvl(:REQUEST,''NEXT'') in (''NEXT'',''FINISH'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(13181914584676457)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(26757703921481538)
,p_validation_name=>'retrieve and validate WSDL'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P550_UDDI = ''N'' and wwv_flow_collection.collection_exists(''UDDI_DETAILS'') then',
'  wwv_flow_collection.delete_collection(''UDDI_DETAILS'');',
'end if;',
'',
'return wwv_flow_web_services.WSDL_analyze(',
'    p_wsdl_url                      => :P580_WSDL_URL,',
'    p_flow_id                       => :FB_FLOW_ID,',
'    p_uddi_details_collection       => ''UDDI_DETAILS'',',
'    p_web_service_collection        => ''WEB_SERVICE'',',
'    p_operations_collection         => ''SERVICE_OPERATIONS'',',
'    p_inputs_collection             => ''SERVICE_OPERATION_INPUTS'',',
'    p_outputs_collection            => ''SERVICE_OPERATION_OUTPUTS'',',
'    p_username                      => :P580_USERNAME,',
'    p_password                      => :P580_PASSWORD );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Invalid WSDL document.'
,p_validation_condition=>':P580_WSDL_URL is not null and nvl(:REQUEST,''NEXT'') in (''NEXT'',''FINISH'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(43007117954781357)
,p_validation_name=>'name and URL enpoint not null'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select c001, c002',
'             from wwv_flow_collections',
'            where collection_name = ''WEB_SERVICE''',
'              and seq_id = 1 ) loop',
'  if c1.c001 is null or c1.c002 is null then',
'    return false;',
'  else',
'    return true;',
'  end if;',
'end loop;',
'',
'return false;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Could not determine the name of the service or the URL endpoint to the service from the WSDL document.  Click Next and enter this information on the next step.'
,p_when_button_pressed=>wwv_flow_imp.id(36499004331317665)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(614670108667188711)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(13182205592676458)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(614670278979188712)
,p_event_id=>wwv_flow_imp.id(614670108667188711)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1143247574459567428)
,p_name=>'Submit NEXT'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(13182513932676458)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1143247662744567429)
,p_event_id=>wwv_flow_imp.id(1143247574459567428)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'NEXT'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1143247747342567430)
,p_name=>'Submit FINISH'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(36499004331317665)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1143247891259567431)
,p_event_id=>wwv_flow_imp.id(1143247747342567430)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'FINISH'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(36589522872436626)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create web reference'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_basic_auth varchar2(1) := ''N'';',
'begin',
'for c1 in (select c001, c002, c003, c004, c005, c006',
'             from wwv_flow_collections',
'            where collection_name = ''WEB_SERVICE'' ) loop',
'  if :P580_USERNAME is not null then',
'    l_basic_auth := ''Y'';',
'  end if;',
'  wwv_flow_web_services.create_web_service(',
'    p_id                            => null,',
'    p_flow_id                       => :FB_FLOW_ID,',
'    p_name                          => nvl(c1.c001,''Web Reference''),',
'    p_url                           => c1.c002,',
'    p_target_ns                     => c1.c003,',
'    p_xsd_prefix                    => c1.c004,',
'    p_soap_style                    => c1.c005,',
'    p_soap_version                  => c1.c006,',
'    p_operations_collection         => ''SERVICE_OPERATIONS'',',
'    p_inputs_collection             => ''SERVICE_OPERATION_INPUTS'',',
'    p_outputs_collection            => ''SERVICE_OPERATION_OUTPUTS'',',
'    p_basic_auth                    => l_basic_auth);',
'   exit;',
'end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(36499004331317665)
,p_internal_uid=>36589522872436626
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(614670389334188713)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,F4000_LAST_VIEW'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(36499004331317665)
,p_process_success_message=>'Web reference created.'
,p_internal_uid=>614670389334188713
);
end;
/
prompt --application/pages/page_00583
begin
wwv_flow_imp_page.create_page(
 p_id=>583
,p_name=>'Copy Validation - Validation to Copy'
,p_alias=>'COPY-VALIDATION-VALIDATION-TO-COPY'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Validation'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_validate.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(45392602984537423)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(112369313902398470)
,p_plug_name=>'Copy Validation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(228170929393217573)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(228167614670175482)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(112370909447425534)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(45392602984537423)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(112371128124425540)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(45392602984537423)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(112372028494431052)
,p_branch_action=>'f?p=&APP_ID.:596:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(112370217974418578)
,p_name=>'P583_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(112369313902398470)
,p_prompt=>'Copy Validation'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select validation_sequence||''. ''||wwv_flow_escape.html(validation_name) vname, id',
'from wwv_flow_step_validations',
'where flow_id = :fb_flow_id and flow_step_id = :fb_flow_page_id',
'order by validation_sequence'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the component to copy.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(113086812335936587)
,p_name=>'P583_TARGET_PAGE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(112369313902398470)
,p_item_default=>'&FB_FLOW_PAGE_ID.'
,p_prompt=>'Target Page'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST_PAGES_EXCEPT_GLOBAL'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select step.name,',
'       step.id',
'  from wwv_flow_steps step',
' where step.flow_id           = :FB_FLOW_ID',
'   and step.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and is_page_pattern        = ''N''',
'   -- do not show global page',
'   and not exists (',
'       select 1',
'         from wwv_flows flow',
'        where flow.id                = :FB_FLOW_ID',
'          and flow.security_group_id = :FLOW_SECURITY_GROUP_ID',
'          and flow.global_page_id    = step.id )',
' order by 2'))
,p_cSize=>10
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the page number to which this component will be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(228232903005770785)
,p_name=>'P583_COPY_FROM'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(112369313902398470)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Copy From Page:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||wwv_flow_escape.html(name)',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'and id = :FB_FLOW_PAGE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Page that validation will be copied from.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(228236726517824864)
,p_validation_name=>'Target Page Exists'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.page_exists (',
'    p_flow_id => :FB_FLOW_ID,',
'    p_page_id => :P583_TARGET_PAGE )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'An existing page must be selected.'
,p_when_button_pressed=>wwv_flow_imp.id(112371128124425540)
,p_associated_item=>wwv_flow_imp.id(113086812335936587)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2075161702534462)
,p_validation_name=>'P583_TARGET_PAGE != Global Page'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flows flow',
' where flow.id                = :FB_FLOW_ID',
'   and flow.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow.global_page_id    = :P583_TARGET_PAGE'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Global page can''t be selected as #LABEL#.'
,p_when_button_pressed=>wwv_flow_imp.id(112371128124425540)
,p_associated_item=>wwv_flow_imp.id(113086812335936587)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(614708266540500257)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(112370909447425534)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(614708539995500258)
,p_event_id=>wwv_flow_imp.id(614708266540500257)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00585
begin
wwv_flow_imp_page.create_page(
 p_id=>585
,p_name=>'Create Web Service Reference - Confirm'
,p_alias=>'CREATE-WEB-SERVICE-REFERENCE-CONFIRM'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Web Service Reference'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(14293705410371886)
,p_plug_name=>'Create Web Service Reference'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_item_display_point=>'BELOW'
,p_plug_query_row_template=>wwv_flow_imp.id(82116118900238363)
,p_plug_query_num_rows_type=>'0'
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_break_cols=>'0'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_header=>'<p>Review the details of the Web service, and change the reference name or URL endpoint. The information displayed was derived from the WSDL document. You should only change the URL endpoint if you have knowledge that the WSDL document is incorrect.<'
||'/p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(14299723034424201)
,p_name=>'Operations'
,p_template=>wwv_flow_imp.id(42025417508627628)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 operation_name',
'  from wwv_flow_collections',
' where collection_name = ''SERVICE_OPERATIONS'''))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(82408032331628644)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>1000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
,p_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
', c002 input_message, ',
'       c003 output_message, c004 input_message_namespace, ',
'       c008 input_message_style,',
'       c005 output_message_namespace, c007 output_message_style, ',
'       c006 soap_action',
''))
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(14300401141424218)
,p_query_column_id=>1
,p_column_alias=>'OPERATION_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Operation Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(14302006674438465)
,p_name=>'Input Parameters'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select b.c001 operation, a.c002 parameter_name, ',
'       a.c003 parameter_type',
'  from wwv_flow_collections a, wwv_flow_collections b',
' where a.collection_name = ''SERVICE_OPERATION_INPUTS''',
'   and b.collection_name = ''SERVICE_OPERATIONS''',
'   and b.c002 = a.c001',
' order by a.seq_id'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'1'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>1000
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18551428198600212)
,p_query_column_id=>1
,p_column_alias=>'OPERATION'
,p_column_display_sequence=>1
,p_column_heading=>'Operation'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(14302702011438470)
,p_query_column_id=>2
,p_column_alias=>'PARAMETER_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Parameter Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(14302819684438470)
,p_query_column_id=>3
,p_column_alias=>'PARAMETER_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Parameter Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(14306409706458285)
,p_name=>'Output Parameters'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select b.c001 out_operation,',
'       a.c002 out_parameter_name, ',
'       a.c003 out_parameter_type',
'  from wwv_flow_collections a, wwv_flow_collections b',
' where a.collection_name = ''SERVICE_OPERATION_OUTPUTS''',
'   and b.collection_name = ''SERVICE_OPERATIONS''',
'   and a.c001 = b.c003',
' order by a.seq_id'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'1'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_row_count_max=>1000
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(923579413862744040)
,p_query_column_id=>1
,p_column_alias=>'OUT_OPERATION'
,p_column_display_sequence=>1
,p_column_heading=>'Operation'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(923579579584744041)
,p_query_column_id=>2
,p_column_alias=>'OUT_PARAMETER_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Parameter Name'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(923579615314744042)
,p_query_column_id=>3
,p_column_alias=>'OUT_PARAMETER_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Parameter Type'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22506915656625392)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(22410710903630445)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(29040514324610977)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(399849897040726767)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(28359907580129646)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(204761520052218198)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>11
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(13186615040676466)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(204761520052218198)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Reference'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(13186523001676466)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(204761520052218198)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(13186331337676466)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(204761520052218198)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(13187102140676467)
,p_branch_action=>'f?p=&APP_ID.:170:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(13186331337676466)
,p_branch_sequence=>1
,p_branch_comment=>'Generated 19-APR-2004 13:34:33'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(13187819442676468)
,p_branch_action=>'f?p=&APP_ID.:580:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(13186523001676466)
,p_branch_sequence=>10
,p_branch_comment=>'Generated 19-APR-2004 13:34:33'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22273922987240331)
,p_name=>'P585_BASIC_AUTH'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(14293705410371886)
,p_item_default=>'N'
,p_prompt=>'Basic Authentication:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(84259319526460470)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose whether this Web service requires basic authentication. Basic authentication credentials are sent as part of the HTTP request in clear text. Web services that employ basic authentication usually also use the HTTPS (SSL) protocol since the user'
||'name and password are sent in clear text.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(923578773433744033)
,p_name=>'P585_WEB_SERVICE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(14293705410371886)
,p_prompt=>'Web Service Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Name of the web service.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(923578884721744034)
,p_name=>'P585_SOAP_URL_ENDPOINT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(14293705410371886)
,p_prompt=>'Soap URL Endpoint'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'URL of the web service.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(923578937008744035)
,p_name=>'P585_SOAP_STYLE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(14293705410371886)
,p_prompt=>'SOAP Style'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(923579083180744036)
,p_name=>'P585_SOAP_VERSION'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(14293705410371886)
,p_prompt=>'SOAP Version'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(923579137221744037)
,p_name=>'P585_TARGET_NS'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(14293705410371886)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(923579217569744038)
,p_name=>'P585_XSD_PREFIX'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(14293705410371886)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(22275113075246930)
,p_computation_sequence=>10
,p_computation_item=>'P585_BASIC_AUTH'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'Y'
,p_compute_when=>'P580_USERNAME'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(42970206292636128)
,p_validation_name=>'name not null'
,p_validation_sequence=>10
,p_validation=>'length(:P585_WEB_SERVICE_NAME) > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'You must supply a name for the Web service reference.'
,p_when_button_pressed=>wwv_flow_imp.id(13186615040676466)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(42979610841665791)
,p_validation_name=>'url enpoint not null'
,p_validation_sequence=>20
,p_validation=>'length(:P585_SOAP_URL_ENDPOINT) > 11'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'You must supply a URL endpoint that invokes the Web service.'
,p_when_button_pressed=>wwv_flow_imp.id(13186615040676466)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(614671581818188725)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(13186331337676466)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(614671624606188726)
,p_event_id=>wwv_flow_imp.id(614671581818188725)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(15031128310575243)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create web service'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_web_services.create_web_service(',
'    p_id                            => null,',
'    p_flow_id                       => :FB_FLOW_ID,',
'    p_name                          => :P585_WEB_SERVICE_NAME,',
'    p_url                           => :P585_SOAP_URL_ENDPOINT,',
'    p_target_ns                     => :P585_TARGET_NS,',
'    p_xsd_prefix                    => :P585_XSD_PREFIX,',
'    p_soap_style                    => :P585_SOAP_STYLE, ',
'    p_soap_version                  => :P585_SOAP_VERSION,',
'    p_operations_collection         => ''SERVICE_OPERATIONS'',',
'    p_inputs_collection             => ''SERVICE_OPERATION_INPUTS'',',
'    p_outputs_collection            => ''SERVICE_OPERATION_OUTPUTS'',',
'    p_basic_auth                    => :P585_BASIC_AUTH);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error creating webservice.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(13186615040676466)
,p_internal_uid=>15031128310575243
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(614671751860188727)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,F4000_LAST_VIEW'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(13186615040676466)
,p_process_success_message=>'Web Service created successfully.'
,p_internal_uid=>614671751860188727
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(923579397400744039)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    select c001,',
'           c002,',
'           c003,',
'           c004,',
'           c005,',
'           c006',
'      into :P585_WEB_SERVICE_NAME,',
'           :P585_SOAP_URL_ENDPOINT,',
'           :P585_TARGET_NS,',
'           :P585_XSD_PREFIX,',
'           :P585_SOAP_STYLE,',
'           :P585_SOAP_VERSION',
'      from wwv_flow_collections',
'     where collection_name = ''WEB_SERVICE''',
'       and seq_id          = 1;',
'exception when no_data_found then',
'    :P585_WEB_SERVICE_NAME := null;',
'    :P585_SOAP_URL_ENDPOINT := null;',
'    :P585_TARGET_NS := null;',
'    :P585_XSD_PREFIX := null;',
'    :P585_SOAP_STYLE := null;',
'    :P585_SOAP_VERSION := null;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>923579397400744039
);
end;
/
prompt --application/pages/page_00587
begin
wwv_flow_imp_page.create_page(
 p_id=>587
,p_name=>'Copy Branch - Branch to Copy'
,p_alias=>'COPY-BRANCH-BRANCH-TO-COPY'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Branch'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_branch.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46038029088622281)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(228238624355843200)
,p_plug_name=>'Copy Branch'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(228244712627868153)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(228256415837925869)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(228239824555843209)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46038029088622281)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(228240005585843210)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(46038029088622281)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(112386803666606132)
,p_branch_action=>'f?p=&APP_ID.:685:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(228238814404843204)
,p_name=>'P587_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(228238624355843200)
,p_prompt=>'Copy Branch:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select substr(BRANCH_SEQUENCE||''. ''||wwv_flow_escape.html(nvl(branch_name, BRANCH_ACTION)),1,90) bname, id ',
'from WWV_FLOW_STEP_BRANCHES ',
'where flow_id = :fb_flow_id and flow_step_id = :fb_flow_page_id ',
'order by BRANCH_SEQUENCE'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Select the component to copy.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(228239314205843205)
,p_name=>'P587_COPY_TO_PAGE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(228238624355843200)
,p_item_default=>'&FB_FLOW_PAGE_ID.'
,p_prompt=>'Target Page'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST_PAGES_EXCEPT_GLOBAL'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select step.name,',
'       step.id',
'  from wwv_flow_steps step',
' where step.flow_id           = :FB_FLOW_ID',
'   and step.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and is_page_pattern        = ''N''',
'   -- do not show global page',
'   and not exists (',
'       select 1',
'         from wwv_flows flow',
'        where flow.id                = :FB_FLOW_ID',
'          and flow.security_group_id = :FLOW_SECURITY_GROUP_ID',
'          and flow.global_page_id    = step.id )',
' order by 2'))
,p_cSize=>10
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the page number to which this component will be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(228456009123715205)
,p_name=>'P587_COPY_FROM_PAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(228238624355843200)
,p_prompt=>'Copy From Page:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||name',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'and id = :FB_FLOW_PAGE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Page that branch will be copied from.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(229047329544045871)
,p_validation_name=>'P587_ID_not_null'
,p_validation_sequence=>10
,p_validation=>'P587_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Branch must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(228240005585843210)
,p_associated_item=>wwv_flow_imp.id(228238814404843204)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(228269629914996154)
,p_validation_name=>'Target Page Exists'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.page_exists (',
'    p_flow_id => :FB_FLOW_ID,',
'    p_page_id => :P587_COPY_TO_PAGE )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'An existing page must be selected.'
,p_when_button_pressed=>wwv_flow_imp.id(228240005585843210)
,p_associated_item=>wwv_flow_imp.id(228239314205843205)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2075697742543177)
,p_validation_name=>'P587_COPY_TO_PAGE != Global Page'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flows flow',
' where flow.id                = :FB_FLOW_ID',
'   and flow.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow.global_page_id    = :P587_COPY_TO_PAGE'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Global page can''t be selected as #LABEL#.'
,p_when_button_pressed=>wwv_flow_imp.id(228240005585843210)
,p_associated_item=>wwv_flow_imp.id(228239314205843205)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(614709153373528500)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(228239824555843209)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(614709455223528500)
,p_event_id=>wwv_flow_imp.id(614709153373528500)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00588
begin
wwv_flow_imp_page.create_page(
 p_id=>588
,p_name=>'Test Web Service'
,p_alias=>'TEST-WEB-SERVICE'
,p_step_title=>'Test Web Service Reference'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(15252327976163190)
,p_name=>'Input Parameters'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(input_or_output,''I'',wwv_flow_item.display_and_save(1,wwv_flow_escape.html(name)),wwv_flow_item.display_and_save(4,wwv_flow_escape.html(name))) name, ',
'       parm_type type, decode(input_or_output,''I'',wwv_flow_item.text(3,null,null,null,null,''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0''),wwv_flow_lang.system_message(''APEXIR_VALUE'')),wwv_flow_item.text(6,null,null,null,null,''f''||lpad(''''||1,'
||'2,''0'') || ''_'' || lpad(''''||rownum,4,''0''),wwv_flow_lang.system_message(''APEXIR_VALUE''))) value',
'  from wwv_flow_ws_parameters',
' where input_or_output in (''I'',''H'')',
'   and type_is_xsd = ''Y''',
'   and ws_opers_id = :P588_OPERATION',
' order by input_or_output, id'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>1000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(15252721884163193)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(20006920272526582)
,p_query_column_id=>2
,p_column_alias=>'TYPE'
,p_column_display_sequence=>2
,p_column_heading=>'Type'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(15252810352163194)
,p_query_column_id=>3
,p_column_alias=>'VALUE'
,p_column_display_sequence=>3
,p_column_heading=>'Value'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(15252903920163194)
,p_name=>'Web Service Reference Details'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, url URL_endpoint ',
'  from wwv_flow_shared_web_services',
' where id = :P588_ID'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(82408032331628644)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Report returned no rows.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(39149906858314052)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Name:'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<strong>#NAME#</strong>'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(15253300634163194)
,p_query_column_id=>2
,p_column_alias=>'URL_ENDPOINT'
,p_column_display_sequence=>2
,p_column_heading=>'URL Endpoint:&nbsp;'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<strong>#URL_ENDPOINT#</strong>'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(15253417733163195)
,p_plug_name=>'Messages'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(22295516454616910)
,p_name=>'Basic Authentication'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(a.name,''username'',wwv_flow_lang.system_message(''ACCESS_CONTROL_USERNAME''),''password'',wwv_flow_lang.system_message(''PASSWORD''),a.name) name, wwv_flow_item.text(7,null,null,null,null,''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0'')'
||',wwv_flow_lang.system_message(''APEXIR_VALUE'')) value',
'  from wwv_flow_ws_parameters a, wwv_flow_shared_web_services b,',
'       wwv_flow_ws_operations c',
' where input_or_output = ''A''',
'   and a.ws_opers_id = c.id',
'   and c.ws_id = b.id',
'   and b.id = :P588_ID',
'order by a.name desc '))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_ws_parameters a, wwv_flow_shared_web_services b,',
'       wwv_flow_ws_operations c',
' where input_or_output = ''A''',
'   and a.ws_opers_id = c.id',
'   and c.ws_id = b.id',
'   and b.id = :P588_ID'))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>1000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22295710841616911)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22295919836616911)
,p_query_column_id=>2
,p_column_alias=>'VALUE'
,p_column_display_sequence=>2
,p_column_heading=>'Value'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(42253430789485783)
,p_plug_name=>'Test Web Service Reference'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>To test the Web Service Reference, select an operation, supply input parameters if applicable, and click <strong>Test</strong> to test. Then you can inspect the request envelope and response envelope.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1142727844742397018)
,p_plug_name=>'Test Web Service Reference'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(15254207698163197)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1142727844742397018)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:170:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(15253807301163196)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1142727844742397018)
,p_button_name=>'TEST'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Test'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(15257000962163214)
,p_branch_action=>'f?p=&FLOW_ID.:588:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(15254605463163199)
,p_name=>'P588_OPERATION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(15252903920163194)
,p_prompt=>'Operation'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'  from wwv_flow_ws_operations',
' where name != ''BASIC_AUTH''',
'   and ws_id = :P588_ID',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Operation -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Select the operation (that is the method to execute) that you wish to test.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(15255006168163202)
,p_name=>'P588_REQUEST'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(15253417733163195)
,p_prompt=>'Request'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>10
,p_tag_attributes=>'class="instructiontext" readonly="readonly"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Below is the SOAP envelope that was created by the &PRODUCT_NAME. engine based on the Web service reference definition, and any input parameters you supplied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(15255305815163203)
,p_name=>'P588_RESPONSE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(15253417733163195)
,p_prompt=>'Response'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>10
,p_tag_attributes=>'class="instructiontext" readonly="readonly"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Below is the response SOAP envelope that was returned by the Web service.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(15258316479168000)
,p_name=>'P588_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(15252903920163194)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(15256210031163210)
,p_validation_name=>'P588_OPERATION'
,p_validation_sequence=>10
,p_validation=>'nvl(:P588_OPERATION,''0'') != ''0'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'You must choose an operation.'
,p_validation_condition=>'nvl(:REQUEST,''TEST'') = ''TEST'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(15254605463163199)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1143247398542567426)
,p_name=>'Submit page'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(15253807301163196)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1143247419242567427)
,p_event_id=>wwv_flow_imp.id(1143247398542567426)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'TEST'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(268346116450686734)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'clear request/response'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P588_REQUEST := null;',
':P588_RESPONSE := null;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P588_OPERATION'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>268346116450686734
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(15256618220163212)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'test webservice'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_soap_env clob;',
'  l_response clob;',
'  l_parm varchar2(4000);',
'  l_action varchar2(4000);',
'  l_url varchar2(4000);',
'  l_soap_version varchar2(30);',
'  l_target_ns varchar2(255);',
'  l_input_ns varchar2(255);',
'  l_input_msg_style varchar2(255);',
'  l_header_msg_style varchar2(255);',
'  l_operation varchar2(255);',
'  l_soap_style varchar2(255);',
'  i integer;',
'  l_response_var varchar2(32767);',
'  l_username varchar2(4000) := null;',
'  l_password varchar2(4000) := null;',
'  l_wallet wwv_flow_security.t_wallet;',
'begin',
'  if wwv_flow.g_f07.count > 0 then',
'    l_username := wwv_flow.g_f07(1);',
'    l_password := wwv_flow.g_f07(2);',
'  end if;',
'  --',
'  for c1 in (select a.url, nvl(a.soap_version,''1.1'') soap_version, a.static_parm_01, ',
'                    a.static_parm_02, b.soap_action, ',
'                    b.name, b.input_message_ns, ',
'                    b.input_message_style, b.header_message_style',
'               from wwv_flow_shared_web_services a, wwv_flow_ws_operations b',
'              where b.ws_id = a.id',
'                and a.id = :P588_ID',
'                and b.id = :P588_OPERATION ) loop',
'    l_url := c1.url;',
'    l_soap_version := c1.soap_version;',
'    l_operation := c1.name;',
'    l_soap_style := c1.static_parm_02;',
'    l_target_ns := c1.static_parm_01;',
'    l_input_ns := c1.input_message_ns;',
'    l_action := c1.soap_action;',
'    l_input_msg_style := c1.input_message_style;',
'    l_header_msg_style := c1.header_message_style;',
'    exit;',
'  end loop;',
'  --',
'  --',
'  wwv_flow_web_services.generate_header(',
'    p_process_id   => null,',
'    p_operation_id => :P588_OPERATION,',
'    p_in_msg_style => l_header_msg_style,',
'    p_ns           => nvl(l_input_ns,l_target_ns),',
'    p_soap_style   => l_soap_style,',
'    p_parm_name    => wwv_flow.g_f04,',
'    p_parm_value   => wwv_flow.g_f06);',
'  --',
'  wwv_flow_web_services.generate_body(',
'    p_process_id   => null,',
'    p_operation_id => :P588_OPERATION,',
'    p_in_msg_style => l_input_msg_style,',
'    p_soap_style   => l_soap_style,',
'    p_parm_name    => wwv_flow.g_f01,',
'    p_parm_value   => wwv_flow.g_f03);',
'',
'  l_soap_env := wwv_flow_web_services.generate_envelope(',
'                  p_operation => l_operation,',
'                  p_style     => l_soap_style,',
'                  p_ns        => nvl(l_input_ns,l_target_ns),',
'                  p_version   => l_soap_version,',
'                  p_body      => wwv_flow_web_services.g_body,',
'                  p_header    => wwv_flow_web_services.g_header );',
'',
'  :P588_REQUEST := l_soap_env;',
'',
'  l_wallet := wwv_flow_security.get_wallet;',
'',
'  l_response := wwv_flow_web_services.make_request(',
'                        p_url            => l_url,',
'                        p_action         => l_action,',
'                        p_version        => l_soap_version,',
'                        p_envelope       => l_soap_env,',
'                        p_username       => l_username,',
'                        p_password       => l_password,',
'                        p_proxy_override => wwv_flow_web_services.find_proxy(:FB_FLOW_ID),',
'                        p_wallet_path    => l_wallet.wallet_path,',
'                        p_wallet_pwd     => l_wallet.wallet_pwd );',
'  l_response_var := wwv_flow_utilities.clob_to_varchar2(l_response);',
'  wwv_flow.update_cache_with_write(''P588_RESPONSE'',substr(l_response_var,1,32000));',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'nvl(:REQUEST,''TEST'') = ''TEST'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>15256618220163212
);
end;
/
prompt --application/pages/page_00589
begin
wwv_flow_imp_page.create_page(
 p_id=>589
,p_name=>'View Web Reference'
,p_alias=>'VIEW-WEB-REFERENCE'
,p_step_title=>'View Web Service Reference'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(39010425453069021)
,p_name=>'Operations'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, soap_action, input_message_ns, input_message_style, ',
'       output_message_ns, output_message_style',
'  from wwv_flow_ws_operations',
' where name != ''BASIC_AUTH''',
'   and ws_id = :P589_ID'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(82408032331628644)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_row_count_max=>1000
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(39010906267069024)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Operation Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(39011015451069024)
,p_query_column_id=>2
,p_column_alias=>'SOAP_ACTION'
,p_column_display_sequence=>2
,p_column_heading=>'SOAP Action'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(39047531423155382)
,p_query_column_id=>3
,p_column_alias=>'INPUT_MESSAGE_NS'
,p_column_display_sequence=>4
,p_column_heading=>'Input Namespace'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(39048131287155383)
,p_query_column_id=>4
,p_column_alias=>'INPUT_MESSAGE_STYLE'
,p_column_display_sequence=>3
,p_column_heading=>'Input Style'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(39047716690155382)
,p_query_column_id=>5
,p_column_alias=>'OUTPUT_MESSAGE_NS'
,p_column_display_sequence=>6
,p_column_heading=>'Output Namespace'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(39010808948069024)
,p_query_column_id=>6
,p_column_alias=>'OUTPUT_MESSAGE_STYLE'
,p_column_display_sequence=>5
,p_column_heading=>'Output Style'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(39011118396069024)
,p_name=>'Input Parameters'
,p_template=>wwv_flow_imp.id(689970285456172024)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:is-expanded'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select b.name operation, a.name, a.parm_type',
'  from wwv_flow_ws_parameters a, wwv_flow_ws_operations b',
' where a.input_or_output = ''I''',
'   and a.ws_opers_id = b.id',
'   and b.ws_id = :P589_ID'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'1'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>1000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(39011929972069026)
,p_query_column_id=>1
,p_column_alias=>'OPERATION'
,p_column_display_sequence=>1
,p_column_heading=>'Operation'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(39011713652069026)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Parameter Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(39011819036069026)
,p_query_column_id=>3
,p_column_alias=>'PARM_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(39012004934069026)
,p_name=>'Output Parameters'
,p_template=>wwv_flow_imp.id(689970285456172024)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#:is-expanded'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select b.name operation_name, a.name param_name, a.parm_type type,',
'       wwv_flow_web_services.get_path(a.id) xpath',
'  from wwv_flow_ws_parameters a, wwv_flow_ws_operations b',
' where a.input_or_output = ''O''',
'   and a.ws_opers_id = b.id',
'   and b.ws_id = :P589_ID'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'1'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>1000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1142728299288397022)
,p_query_column_id=>1
,p_column_alias=>'OPERATION_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Operation'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1142728392182397023)
,p_query_column_id=>2
,p_column_alias=>'PARAM_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Paramater Name'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1142728426337397024)
,p_query_column_id=>3
,p_column_alias=>'TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Type'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(39012413295069028)
,p_query_column_id=>4
,p_column_alias=>'XPATH'
,p_column_display_sequence=>4
,p_column_heading=>'Xpath'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(39032520944110024)
,p_name=>'Web Service Reference'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, url, static_parm_01 target_namespace, static_parm_02 soap_style',
'  from wwv_flow_shared_web_services',
' where id = :P589_ID'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(82408032331628644)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Report returned no rows.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(39033415552110050)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(39033513034110050)
,p_query_column_id=>2
,p_column_alias=>'URL'
,p_column_display_sequence=>2
,p_column_heading=>'URL'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(39056620607185588)
,p_query_column_id=>3
,p_column_alias=>'TARGET_NAMESPACE'
,p_column_display_sequence=>3
,p_column_heading=>'Target Namespace'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(6671918493826792)
,p_query_column_id=>4
,p_column_alias=>'SOAP_STYLE'
,p_column_display_sequence=>4
,p_column_heading=>'SOAP Style'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1142727991277397019)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(39062523986205479)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1142727991277397019)
,p_button_name=>'CLOSE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Close'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:170:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(39046308786153781)
,p_name=>'P589_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(39032520944110024)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_00590
begin
wwv_flow_imp_page.create_page(
 p_id=>590
,p_name=>'Copy Process - Process to Copy'
,p_alias=>'COPY-PROCESS-PROCESS-TO-COPY'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Process'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_pg_procs.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(45408220083901963)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(112441801746840049)
,p_plug_name=>'Copy Process'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(227765405220939635)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(227766223920945009)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(112442216299840053)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(45408220083901963)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(112442422860840054)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(45408220083901963)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(112443924384840064)
,p_branch_action=>'f?p=&APP_ID.:645:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(112442615566840054)
,p_name=>'P590_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(112441801746840049)
,p_prompt=>'Copy Process'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select PROCESS_SEQUENCE||''. ''||wwv_flow_escape.html(PROCESS_NAME) pname, id',
'from WWV_FLOW_STEP_PROCESSING',
'where flow_id = :fb_flow_id and flow_step_id = :fb_flow_page_id',
'order by PROCESS_SEQUENCE'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the component to copy.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(113064105952773891)
,p_name=>'P590_COPY_TO_PAGE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(112441801746840049)
,p_item_default=>'&FB_FLOW_PAGE_ID.'
,p_prompt=>'Target Page'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST_PAGES_EXCEPT_GLOBAL'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select step.name,',
'       step.id',
'  from wwv_flow_steps step',
' where step.flow_id           = :FB_FLOW_ID',
'   and step.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and is_page_pattern        = ''N''',
'   -- do not show global page',
'   and not exists (',
'       select 1',
'         from wwv_flows flow',
'        where flow.id                = :FB_FLOW_ID',
'          and flow.security_group_id = :FLOW_SECURITY_GROUP_ID',
'          and flow.global_page_id    = step.id )',
' order by 2'))
,p_cSize=>10
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the page number to which this component will be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(228472404845780263)
,p_name=>'P590_COPY_FROM_PAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(112441801746840049)
,p_prompt=>'Copy From Page:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||name',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'and id = :FB_FLOW_PAGE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Page that process will be copied from.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(227793914205140961)
,p_validation_name=>'Target Page Exists'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.page_exists (',
'    p_flow_id => :FB_FLOW_ID,',
'    p_page_id => :P590_COPY_TO_PAGE )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'An existing page must be selected.'
,p_when_button_pressed=>wwv_flow_imp.id(112442422860840054)
,p_associated_item=>wwv_flow_imp.id(113064105952773891)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1806237775551113)
,p_validation_name=>'P590_COPY_TO_PAGE != Global Page'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flows flow',
' where flow.id                = :FB_FLOW_ID',
'   and flow.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow.global_page_id    = :P590_COPY_TO_PAGE'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Global page can''t be selected as #LABEL#.'
,p_when_button_pressed=>wwv_flow_imp.id(112442422860840054)
,p_associated_item=>wwv_flow_imp.id(113064105952773891)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(590119200148572028)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(112442216299840053)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(590119308022572029)
,p_event_id=>wwv_flow_imp.id(590119200148572028)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00591
begin
wwv_flow_imp_page.create_page(
 p_id=>591
,p_name=>'Copy Meta Tag'
,p_alias=>'COPY-META-TAG'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Meta Tag'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_pg_procs.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(150499159679187465)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(217532741342125551)
,p_plug_name=>'Copy Process'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(332856344816225137)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(227766223920945009)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(105091504094285523)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(150499159679187465)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(105091906197285524)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(150499159679187465)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(105097081409285545)
,p_branch_action=>'f?p=&APP_ID.:645:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(105092645778285531)
,p_name=>'P591_COPY_FROM_PAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(217532741342125551)
,p_prompt=>'Copy From Page:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||name',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'and id = :FB_FLOW_PAGE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Page that process will be copied from.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(105093539385285535)
,p_name=>'P591_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(217532741342125551)
,p_prompt=>'Copy Process'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select PROCESS_SEQUENCE||''. ''||wwv_flow_escape.html(PROCESS_NAME) pname, id',
'from WWV_FLOW_STEP_PROCESSING',
'where flow_id = :fb_flow_id and flow_step_id = :fb_flow_page_id',
'order by PROCESS_SEQUENCE'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the component to copy.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(105094471323285536)
,p_name=>'P591_COPY_TO_PAGE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(217532741342125551)
,p_item_default=>'&FB_FLOW_PAGE_ID.'
,p_prompt=>'Target Page'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d',
'  from wwv_flow_steps',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and is_page_pattern   = ''N''',
'order by 2'))
,p_cSize=>10
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the page number to which this component will be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(105095795691285541)
,p_validation_name=>'copy to page exists'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_wizard_api.page_exists (p_flow_id => :fb_flow_id, p_page_id => :P591_COPY_TO_PAGE) then',
'  return true;',
'else',
'  return false;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'An existing page must be selected.'
,p_when_button_pressed=>wwv_flow_imp.id(105091906197285524)
,p_associated_item=>wwv_flow_imp.id(105094471323285536)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(105096062469285543)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(105091504094285523)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(105096545890285544)
,p_event_id=>wwv_flow_imp.id(105096062469285543)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00592
begin
wwv_flow_imp_page.create_page(
 p_id=>592
,p_name=>'Copy Computation - Computation to Copy'
,p_alias=>'COPY-COMPUTATION-COMPUTATION-TO-COPY'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Computation'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldr_pg_comp.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46177830836824466)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(112460603081064282)
,p_plug_name=>'Copy Computation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(228267900824987700)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(228264919955974373)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(112460813571064283)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46177830836824466)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(112461004394064283)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(46177830836824466)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(112462827758064290)
,p_branch_action=>'f?p=&APP_ID.:597:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(112461212446064284)
,p_name=>'P592_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(112460603081064282)
,p_prompt=>'Copy Computation'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select COMPUTATION_SEQUENCE||''. ''||wwv_flow_escape.html(COMPUTATION_ITEM) comp, id',
'from wwv_flow_step_computations',
'where flow_id = :fb_flow_id and flow_step_id = :fb_flow_page_id',
'order by COMPUTATION_SEQUENCE'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the component to copy.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(228270616193001677)
,p_name=>'P592_COPY_FROM'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(112460603081064282)
,p_prompt=>'Copy From Page:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||name',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'and id = :FB_FLOW_PAGE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Page that computation will be copied from.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(228550409384084302)
,p_name=>'P592_TARGET_PAGE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(112460603081064282)
,p_item_default=>'&FB_FLOW_PAGE_ID.'
,p_prompt=>'Target Page'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST_PAGES_EXCEPT_GLOBAL'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select step.name,',
'       step.id',
'  from wwv_flow_steps step',
' where step.flow_id           = :FB_FLOW_ID',
'   and step.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and is_page_pattern        = ''N''',
'   -- do not show global page',
'   and not exists (',
'       select 1',
'         from wwv_flows flow',
'        where flow.id                = :FB_FLOW_ID',
'          and flow.security_group_id = :FLOW_SECURITY_GROUP_ID',
'          and flow.global_page_id    = step.id )',
' order by 2'))
,p_cSize=>10
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the page number to which this component will be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(228297004184206384)
,p_validation_name=>'Target Page Exists'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.page_exists (',
'    p_flow_id => :FB_FLOW_ID,',
'    p_page_id => :P592_TARGET_PAGE )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'An existing page must be selected.'
,p_when_button_pressed=>wwv_flow_imp.id(112461004394064283)
,p_associated_item=>wwv_flow_imp.id(228550409384084302)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2074431930525185)
,p_validation_name=>'P592_TARGET_PAGE != Global Page'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flows flow',
' where flow.id                = :FB_FLOW_ID',
'   and flow.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow.global_page_id    = :P592_TARGET_PAGE'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Global page can''t be selected as #LABEL#.'
,p_when_button_pressed=>wwv_flow_imp.id(112461004394064283)
,p_associated_item=>wwv_flow_imp.id(228550409384084302)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(614711943281555012)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(112460813571064283)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(614712211588555012)
,p_event_id=>wwv_flow_imp.id(614711943281555012)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00593
begin
wwv_flow_imp_page.create_page(
 p_id=>593
,p_name=>'Copy Page - Branches'
,p_alias=>'COPY-PAGE-BRANCHES'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Page - Branches'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_copy_pg.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44756111157054257)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(208019104267799361)
,p_name=>'Copy Branches'
,p_template=>wwv_flow_imp.id(42025417508627628)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q varchar2(32767) := null;',
'begin',
'if wwv_flow_collection.collection_exists(p_collection_name => ''COPY_PAGE_BRANCH'') and',
'   wwv_flow_collection.collection_member_count(p_collection_name => ''COPY_PAGE_BRANCH'') > 0',
'then  ',
'  q:=q||''select wwv_flow_item.display_and_save(3,c003) old_value, '';',
'	q:=q||''wwv_flow_item.textarea(2,c002,3,40) new_value, '';',
'	q:=q||''wwv_flow_item.hidden(1,c001) id '';	',
'  q:=q||''from htmldb_collections '';',
'  q:=q||''where collection_name = ''''COPY_PAGE_BRANCH'''''';	',
'else	 ',
'	q:=q||''select wwv_flow_item.display_and_save(3,branch_action) old_value, '';',
'	q:=q||''wwv_flow_item.textarea(2,'';',
'	q:=q||''wwv_flow_copy_page.change_page_id_in_branch('';',
'  q:=q||'':P621_COPY_FROM_PAGE_ID, '';',
'  q:=q||'':P621_COPY_TO_PAGE_ID, '';',
'	q:=q||''wwv_flow_copy_page.change_item_name('';',
'  q:=q||''to_number(:P621_COPY_FROM_FLOW_ID), '';',
'  q:=q||''to_number(:P621_COPY_FROM_PAGE_ID), '';',
'  q:=q||''to_number(:FB_FLOW_ID), '';    ',
'  q:=q||''to_number(:P621_COPY_TO_PAGE_ID), '';',
'  q:=q||''branch_action)),3,40, '''' title="''''||wwv_flow_lang.system_message(''''F4000.P593.NEW_BRANCH'''')||''''"'''') new_value, '';',
'  q:=q||''wwv_flow_item.hidden(1,id) id '';',
'  q:=q||''from wwv_flow_step_branches '';',
'  q:=q||''where flow_id = :P621_COPY_FROM_FLOW_ID '';',
'  q:=q||''and flow_step_id = :P621_COPY_FROM_PAGE_ID '';',
'  q:=q||''and security_group_id = :FLOW_SECURITY_GROUP_ID '';',
'  q:=q||''order by branch_sequence '';	',
'end if;  ',
'',
'return q;',
'end;'))
,p_header=>'<p>This report displays branches defined in the page you are copying from.  Review the report and update as necessary.</p>'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_plug_query_max_columns=>3
,p_query_num_rows=>5000
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1:2:3'
,p_query_no_data_found=>'No Branches defined.'
,p_query_num_rows_type=>'ROWS_X_TO_Y'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(208658025271239488)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>2
,p_column_heading=>'Branch'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_cattributes=>'valign="top"'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(208658119929239489)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>3
,p_column_heading=>'New Branch'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(210415019396725929)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(208020201892799364)
,p_plug_name=>'nav'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(202931703979545993)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(226864407571634523)
,p_plug_name=>'Copy Page'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(208020408590799364)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(44756111157054257)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(208020811179799366)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(44756111157054257)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(208020614039799366)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(44756111157054257)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(208021807556799373)
,p_branch_action=>'f?p=&APP_ID.:628:&SESSION.::&DEBUG.::P628_PREV_PAGE:593'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(208020811179799366)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(208021420780799371)
,p_branch_action=>'f?p=&APP_ID.:&P593_PREV_PAGE.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(208020614039799366)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(208028003513818767)
,p_name=>'P593_PREV_PAGE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(208019104267799361)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(614678224656227642)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(208020408590799364)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(614678544179227642)
,p_event_id=>wwv_flow_imp.id(614678224656227642)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(208021208434799368)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save page branch definition'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'htmldb_collection.create_or_truncate_collection(p_collection_name => ''COPY_PAGE_BRANCH'');',
'for i in 1..HTMLDB_APPLICATION.G_F01.count loop',
'  htmldb_collection.add_member(',
'    p_collection_name   => ''COPY_PAGE_BRANCH'',',
'    p_c001              => HTMLDB_APPLICATION.G_F01(i),',
'    p_c002              => HTMLDB_APPLICATION.G_F02(i),',
'    p_c003              => HTMLDB_APPLICATION.G_F03(i),',
'    p_generate_md5      => ''YES'' );',
'end loop;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(208020811179799366)
,p_internal_uid=>208021208434799368
);
end;
/
prompt --application/pages/page_00594
begin
wwv_flow_imp_page.create_page(
 p_id=>594
,p_name=>'Developer Comments Calendar'
,p_alias=>'DEVELOPER-COMMENTS-CALENDAR'
,p_step_title=>'Developer Comments Calendar'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_comment.htm'
,p_page_component_map=>'08'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(259483208258527049)
,p_plug_name=>'Disclaimer'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_source=>'sys.htp.p(''<p>This calendar displays a count of developer comments by comment date.</p>'');'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'CURRENT_LANG_EQ_COND1'
,p_plug_display_when_condition=>'en'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(702934977991239724)
,p_plug_name=>'Developer Comments'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select trunc(created_on) created_on, ',
'       to_char(created_on,''YYYY.MM.DD'') co, ',
'       lower(created_by) created_by,',
'       created_by link_created_by,',
'       count(*) c',
'from WWV_FLOW_APP_COMMENTS',
'where flow_id = :fb_flow_id',
'group by trunc(created_on), to_char(created_on,''YYYY.MM.DD''), ',
'         lower(created_by), created_by',
''))
,p_lazy_loading=>true
,p_plug_source_type=>'NATIVE_CSS_CALENDAR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'additional_calendar_views', 'month:list:navigation',
  'display_column', 'C',
  'maximum_events_day', '10',
  'multiple_line_event', 'Y',
  'show_time', 'N',
  'show_tooltip', 'N',
  'show_weekend', 'Y',
  'start_date_column', 'CREATED_ON')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(777400336397703807)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_imp.id(784788000174894142)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(217586224624429790)
,p_branch_action=>'f?p=&FLOW_ID.:594:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(217585230773429782)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Adjust Calendar Date -Previous'
,p_process_sql_clob=>' wwv_flow_utilities.decrement_calendar;'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error changing calendar date.'
,p_internal_uid=>217585230773429782
,p_process_comment=>'Generated 07-JUN-06'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(217585631815429787)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Adjust Calendar Date -Today'
,p_process_sql_clob=>' wwv_flow_utilities.today_calendar;'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error changing calendar date.'
,p_internal_uid=>217585631815429787
,p_process_comment=>'Generated 07-JUN-06'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(217586001377429788)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Adjust Calendar Date -Next'
,p_process_sql_clob=>' wwv_flow_utilities.increment_calendar;'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error changing calendar date.'
,p_internal_uid=>217586001377429788
,p_process_comment=>'Generated 07-JUN-06'
);
end;
/
prompt --application/pages/page_00596
begin
wwv_flow_imp_page.create_page(
 p_id=>596
,p_name=>'Copy Validation - Validation Options'
,p_alias=>'COPY-VALIDATION-VALIDATION-OPTIONS'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Validation'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_validate.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(45395027010553889)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(228174021252279715)
,p_plug_name=>'Copy Validation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(228174230898279716)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(228167614670175482)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(228200813219345309)
,p_name=>'Target Page Validations'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    v.validation_sequence, v.validation_name, v.validation_type, ',
'    (select i.name ',
'       from wwv_flow_step_items i ',
'      where v.associated_item = i.id',
'        and v.flow_id         = i.flow_id',
'        and i.flow_step_id    = v.flow_step_id) associated_item',
'from ',
'    wwv_flow_step_validations v',
'where ',
'    v.flow_step_id = :P583_TARGET_PAGE',
'and v.flow_id      = :fb_flow_id'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'There are currently no validations defined on the target page.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(228211922139366833)
,p_query_column_id=>1
,p_column_alias=>'VALIDATION_SEQUENCE'
,p_column_display_sequence=>1
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(228212009645366834)
,p_query_column_id=>2
,p_column_alias=>'VALIDATION_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(228212126142366834)
,p_query_column_id=>3
,p_column_alias=>'VALIDATION_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Type'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(131915151655)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(228212223516366835)
,p_query_column_id=>4
,p_column_alias=>'ASSOCIATED_ITEM'
,p_column_display_sequence=>4
,p_column_heading=>'Associated Item'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(228174913622279718)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(45395027010553889)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(228175125952279719)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(45395027010553889)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(228213623571395616)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(45395027010553889)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:583:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(228177405672279731)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7776802498028581)
,p_name=>'P596_REGION_ID'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(228174021252279715)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Editable Region'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select pp.plug_name,',
'       pp.id',
'  from wwv_flow_page_plugs pp',
' where pp.flow_id           = :FB_FLOW_ID',
'   and pp.page_id           = :P583_TARGET_PAGE',
'   and pp.security_group_id = :WORKSPACE_ID',
'   and pp.plug_source_type  = ''NATIVE_IG''',
'   -- only show IG regions with editing enabled',
'   and exists (',
'       select 1',
'         from wwv_flow_interactive_grids ig',
'        where ig.region_id = pp.id',
'          and ig.is_editable = ''Y'' )',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Region -'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_step_validations',
' where id                     = :P583_ID',
'   and tabular_form_region_id is not null'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a region from the target page to associate with this validation.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12403106689973102)
,p_name=>'P596_ASSOCIATED_ITEM'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(228174021252279715)
,p_prompt=>'Associated Item'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d,',
'       id r',
'  from wwv_flow_step_items',
' where flow_id           = :FB_FLOW_ID',
'   and flow_step_id      = :P583_TARGET_PAGE',
'   and security_group_id = :WORKSPACE_ID',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cSize=>30
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_step_validations',
' where id                     = :P583_ID',
'   and security_group_id      = :WORKSPACE_ID',
'   and associated_item        is not null'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the item where this validation error message displays.',
'If you select an item and the <em>Error message display location</em> includes "Inline with Field", the error message displays underneath the label of the specified item.',
'If the <em>Error message display location</em> does not include "Inline with Field", this attribute has no impact on the display of the error message.</p>'))
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(228175824249279724)
,p_name=>'P596_VALIDATION_NAME'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(228174021252279715)
,p_prompt=>'Target Validation Name'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select validation_name',
'from wwv_flow_step_validations',
'where id = :P583_ID and flow_id = :fb_flow_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the name for the new component.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(228176326836279725)
,p_name=>'P596_VALIDATION_SEQUENCE'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(228174021252279715)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Target Validation Sequence'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(max(validation_sequence), 0) + 10 as r',
'  from wwv_flow_step_validations',
' where flow_id      = :FB_FLOW_ID',
'   and flow_step_id = :P583_TARGET_PAGE'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>5
,p_cMaxlength=>10
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the sequence for this component. The sequence determines the order of evaluation.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(230804716954808682)
,p_name=>'P596_WHEN_BUTTON_PRESSED'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(228174021252279715)
,p_prompt=>'When Button Pressed'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select button_name,',
'       id',
'  from (',
'        /* all region buttons from current page and global page */',
'        select case when b.flow_step_id = f.global_page_id then',
'                   wwv_flow_lang.system_message(''LAYOUT.GLOBAL_PAGE_REGION_PREFIX'')',
'               end ||',
'               b.button_name ||',
'               '' ('' || b.button_image_alt || '')'' as button_name,',
'               b.id,',
'               b.button_name bn,',
'               case when b.flow_step_id = f.global_page_id then 2 else 1 end x',
'          from wwv_flow_steps p,',
'               wwv_flows f,',
'               wwv_flow_step_buttons b',
'         where p.flow_id      = :FB_FLOW_ID',
'           and p.id           = :P583_TARGET_PAGE',
'           and f.id          = p.flow_id',
'           and b.flow_id      = f.id',
'           and b.flow_step_id in (:P583_TARGET_PAGE, f.global_page_id)',
'         order by 4, 3 ',
'       )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Button Condition -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'This component will only be executed if a user clicks this button.',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231545918917701626)
,p_name=>'P596_COPY_FROM'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(228174021252279715)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Copy From Page:'
,p_source=>'P583_COPY_FROM'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Page that validation will be copied from.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231546810044708580)
,p_name=>'P596_COPY_FROM_VALIDATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(228174021252279715)
,p_prompt=>'Copy Validation:'
,p_source=>'P583_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select validation_sequence||''. ''||validation_name vname,id',
'from wwv_flow_step_validations',
'where flow_id = :fb_flow_id and flow_step_id = :fb_flow_page_id',
'order by validation_sequence'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Validation that will be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231547729091714017)
,p_name=>'P596_TARGET_PAGE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(228174021252279715)
,p_prompt=>'Target Page:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||wwv_flow_escape.html(name)',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'and id = :P583_TARGET_PAGE'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>10
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Page that validation will be copied to.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2599953830051027)
,p_validation_name=>'Ensure the destination page is not a subscribed page pattern'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_component_group_dev.is_part_of_subscribed_comp_grp (',
'    p_component_id   => :P583_TARGET_PAGE,',
'    p_component_type => wwv_flow_copy_metadata.c_page,',
'    p_app_id         => :FB_FLOW_ID ) = ''N'''))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'You cannot copy the validation to a page pattern that is part of a subscribed component group.'
,p_when_button_pressed=>wwv_flow_imp.id(228175125952279719)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(614707603588496332)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(228174913622279718)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(614707960374496334)
,p_event_id=>wwv_flow_imp.id(614707603588496332)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(228177219107279729)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Validation'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_page.a_validation(',
'    p_flow_id_from            => :FB_FLOW_ID,',
'    p_page_id_from            => :FB_FLOW_PAGE_ID,',
'    p_validation_id_from      => :P583_ID,',
'    p_flow_id_to              => :FB_FLOW_ID,',
'    p_page_id_to              => :P583_TARGET_PAGE,',
'    p_when_button_pressed     => :P596_WHEN_BUTTON_PRESSED,',
'    p_tabular_form_region_id  => :P596_REGION_ID,',
'    p_associated_item         => :P596_ASSOCIATED_ITEM,',
'    p_validation_sequence     => :P596_VALIDATION_SEQUENCE,',
'    p_validation_name         => :P596_VALIDATION_NAME );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to copy validation.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(228175125952279719)
,p_process_success_message=>'Validation copied.'
,p_internal_uid=>228177219107279729
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(614707321677493325)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(228175125952279719)
,p_process_success_message=>'Validation copied.'
,p_internal_uid=>614707321677493325
);
end;
/
prompt --application/pages/page_00597
begin
wwv_flow_imp_page.create_page(
 p_id=>597
,p_name=>'Copy Computation - Computation Options'
,p_alias=>'COPY-COMPUTATION-COMPUTATION-OPTIONS'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Computation'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_pg_comp.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46180427158832819)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(228277012259047608)
,p_plug_name=>'Copy Computation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(228277203418047610)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(228264919955974373)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(228277615545047611)
,p_name=>'Target Page Computations'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    c.computation_sequence, c.computation_item, c.computation_type, c.computation_point',
'from ',
'    wwv_flow_step_computations c',
'where ',
'    c.flow_step_id = :P592_TARGET_PAGE',
'and c.flow_id      = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id',
''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'There are currently no computations defined on the target page.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(228288402790130207)
,p_query_column_id=>1
,p_column_alias=>'COMPUTATION_SEQUENCE'
,p_column_display_sequence=>1
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(228288517835130209)
,p_query_column_id=>2
,p_column_alias=>'COMPUTATION_ITEM'
,p_column_display_sequence=>2
,p_column_heading=>'Item'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(228288630243130209)
,p_query_column_id=>3
,p_column_alias=>'COMPUTATION_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Type'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(62977815884897285)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(228878811574293141)
,p_query_column_id=>4
,p_column_alias=>'COMPUTATION_POINT'
,p_column_display_sequence=>4
,p_column_heading=>'Computation Point'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(62981024179015035)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'NO'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(228278715597047641)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46180427158832819)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(228278911799047642)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(46180427158832819)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(228279110230047642)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(46180427158832819)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:592:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(228280928917047661)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(228279302052047643)
,p_name=>'P597_COMPUTATION_SEQUENCE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(228277012259047608)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Target Computation Sequence'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select max(computation_sequence) + 10 r',
'from WWV_FLOW_STEP_COMPUTATIONS',
'where flow_id = :fb_flow_id and flow_step_id = :fb_flow_page_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the sequence for this component. The sequence determines the order of evaluation.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(228890316862351424)
,p_name=>'P597_TARGET_COMP_ITEM'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(228277012259047608)
,p_prompt=>'Target Item to be Computed'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify the item to be computed.'
,p_attribute_01=>'4000_246'
,p_attribute_03=>'Find Item'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231138803475732018)
,p_name=>'P597_COPY_FROM_PAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(228277012259047608)
,p_prompt=>'Copy From Page:'
,p_source=>'P592_COPY_FROM'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Page that the computation will be copied from.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231143804299741735)
,p_name=>'P597_COPY_COMPUTATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(228277012259047608)
,p_prompt=>'Copy From Computation:'
,p_source=>'P592_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select COMPUTATION_SEQUENCE||''. ''||COMPUTATION_ITEM comp, id',
'from wwv_flow_step_computations',
'where flow_id = :fb_flow_id and flow_step_id = :fb_flow_page_id',
'order by COMPUTATION_SEQUENCE'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Computation that will be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231146216766745390)
,p_name=>'P597_TARGET_PAGE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(228277012259047608)
,p_prompt=>'Target Page:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||wwv_flow_escape.html(name)',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'and id = :P592_TARGET_PAGE'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>10
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Page that the computation will be copied to.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(229750629393585134)
,p_validation_name=>'P597_TARGET_COMP_ITEM_not_null'
,p_validation_sequence=>10
,p_validation=>'P597_TARGET_COMP_ITEM'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Target Page Item must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(228278911799047642)
,p_associated_item=>wwv_flow_imp.id(228890316862351424)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(228280321676047646)
,p_validation_name=>'P597_COMPUTATION_SEQUENCE Not Null'
,p_validation_sequence=>20
,p_validation=>'P597_COMPUTATION_SEQUENCE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Computation Sequence must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(228278911799047642)
,p_associated_item=>wwv_flow_imp.id(228279302052047643)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2599159540074916)
,p_validation_name=>'Ensure the destination page is not a subscribed page pattern'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_component_group_dev.is_part_of_subscribed_comp_grp (',
'    p_component_id   => :P592_TARGET_PAGE,',
'    p_component_type => wwv_flow_copy_metadata.c_page,',
'    p_app_id         => :FB_FLOW_ID ) = ''N'''))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'You cannot copy the computation to a page pattern that is part of a subscribed component group.'
,p_when_button_pressed=>wwv_flow_imp.id(228278911799047642)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(614711135766549518)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(228278715597047641)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(614711410773549518)
,p_event_id=>wwv_flow_imp.id(614711135766549518)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(228280729656047660)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Computation'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_page.a_computation(',
'    p_flow_id_from            => :FB_FLOW_ID,',
'    p_page_id_from            => :FB_FLOW_PAGE_ID,',
'    p_computation_id_from     => :P592_ID,',
'    p_flow_id_to              => :FB_FLOW_ID,',
'    p_page_id_to              => :P592_TARGET_PAGE,',
'    p_computation_item        => :P597_TARGET_COMP_ITEM,',
'    p_computation_sequence    => :P597_COMPUTATION_SEQUENCE );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to copy computation.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(228278911799047642)
,p_process_success_message=>'Computation copied.'
,p_internal_uid=>228280729656047660
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(614711657299551659)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(228278911799047642)
,p_process_success_message=>'Computation copied.'
,p_internal_uid=>614711657299551659
);
end;
/
prompt --application/pages/page_00598
begin
wwv_flow_imp_page.create_page(
 p_id=>598
,p_name=>'Install Application Components'
,p_alias=>'INSTALL-APPLICATION-COMPONENTS'
,p_step_title=>'Install Application Components'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213300727323081712)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_install.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17571234826429322)
,p_plug_name=>'Unable to Install Application Components'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>20
,p_plug_source=>'You are trying to import components to an application that is not editable. Workspace Administrators can change the application status using Workspace Utilities.'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P598_INSTALL'
,p_plug_display_when_cond2=>'RUN_ONLY'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(202765631744772348)
,p_plug_name=>'Wizard buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(209189830803496670)
,p_plug_name=>'Export details'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>40
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(209190006085496675)
,p_plug_name=>'Install Components warning'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>30
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P598_INSTALL'
,p_plug_display_when_cond2=>'Y'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>When you install components from a component import file into an application, the existing components are first',
'   deleted and then the new components are installed.</p>',
'<p>If all statements are successful the install commits and the changes become permanent. If any errors are encountered,',
'   the install is rolled back, resulting in no permanent changes.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(209190421715496677)
,p_plug_name=>'import progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(37899301707472090)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747143554198138166)
,p_plug_name=>'Install Application Components'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(209190624600496680)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(202765631744772348)
,p_button_name=>'INSTALL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_button_condition=>'P598_INSTALL'
,p_button_condition2=>'Y'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(217743812889955852)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(202765631744772348)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:460:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(209190831733496684)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(202765631744772348)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(209196915844496731)
,p_branch_name=>'Go To Page 57'
,p_branch_action=>'f?p=&APP_ID.:57:&SESSION.:COMP:&DEBUG.::::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_IN_CONDITION'
,p_branch_condition=>'INSTALL:REPLACE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(209196708154496729)
,p_branch_name=>'Go To Page 48'
,p_branch_action=>'f?p=&APP_ID.:48:&SESSION.:COMP:&DEBUG.::P48_APPLICATION:&P598_NEW_FLOW_ID.'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(209190624600496680)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1600370785191111)
,p_name=>'P598_NEW_FLOW_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(209189830803496670)
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Install Into Application'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST FLOWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'where  build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'The application in which to install the application components.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(209191031588496687)
,p_name=>'P598_FILE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(209189830803496670)
,p_use_cache_before_default=>'NO'
,p_source=>'P49_FILE_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(209191210653496692)
,p_name=>'P598_LOGGED_IN_COMPANY2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(209189830803496670)
,p_item_default=>'&COMPANY.'
,p_prompt=>'Logged Into Workspace'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies current workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(209191718095496696)
,p_name=>'P598_LOGGED_IN_COMPANY'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(209189830803496670)
,p_source=>'&WORKSPACE_ID.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(209191905987496697)
,p_name=>'P598_IMP_COMPANY2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(209189830803496670)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&COMPANY.'
,p_prompt=>'Imported File Workspace'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'wwv_flow_imp_parser.get_security_group_id (p_file_id => :p598_file_id) = :flow_security_group_id'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Workspace name in the import file.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(209192413555496701)
,p_name=>'P598_IMP_COMPANY'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(209189830803496670)
,p_prompt=>'Imported File Workspace ID'
,p_source=>'wwv_flow_imp_parser.get_security_group_id (p_file_id => :p598_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Workspace ID in the import file.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(209192919490496703)
,p_name=>'P598_IMP_FLOW_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(209189830803496670)
,p_prompt=>'Imported File Application'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'This is the application ID contained in the import file.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(209193914713496705)
,p_name=>'P598_IMP_VERSION'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(209189830803496670)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Imported File Version'
,p_source=>'wwv_flow_imp_parser.get_version(:p598_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_help_text=>'Identifies the API version in the import file. This determines whether the import file is compatible with the current version of &PRODUCT_NAME..'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(209194925270496711)
,p_name=>'P598_PARSE_AS'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(209189830803496670)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(209195108937496712)
,p_name=>'P598_INSTALL'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(209189830803496670)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(209195311350496715)
,p_computation_sequence=>10
,p_computation_item=>'P598_PARSE_AS'
,p_computation_type=>'QUERY'
,p_computation=>'select owner from wwv_flows where id = :P598_IMP_FLOW_ID and security_group_id = :P598_LOGGED_IN_COMPANY;'
,p_computation_error_message=>'Unable to compute item value.'
,p_compute_when=>'INSTALL:REPLACE'
,p_compute_when_type=>'REQUEST_IN_CONDITION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(210918906294143586)
,p_computation_sequence=>20
,p_computation_item=>'P598_IMP_FLOW_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_imp_parser.get_flow_id (p_file_id => :p49_file_id)'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(210914002738085724)
,p_computation_sequence=>30
,p_computation_item=>'FB_FLOW_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P598_IMP_FLOW_ID'
,p_compute_when=>'select 1 from wwv_flows where id=:P598_IMP_FLOW_ID and security_group_id=:FLOW_SECURITY_GROUP_ID and :FB_FLOW_ID is null'
,p_compute_when_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(209195511077496719)
,p_validation_name=>'version must be compatible'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_runtime_version varchar2(200); -- the date of the current runtime flows',
'  l_calling_version varchar2(200);',
'begin',
'    l_calling_version := replace(replace(replace(wwv_flow_imp_parser.get_version (p_file_id => :p598_file_id),''.'',null),''_'',null),''/'',null);',
'    l_runtime_version := replace(replace(replace(wwv_flows_version,''.'',null),''_'',null),''/'',null);',
'',
'    if l_calling_version > l_runtime_version then',
'        --',
'        -- version incompatability        ',
'        --',
'        ',
'        return false;',
'    else',
'        return true;',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Not Compatible (Your import may contain calls not supported by your &PRODUCT_NAME. version.)'
,p_when_button_pressed=>wwv_flow_imp.id(209190624600496680)
,p_associated_item=>wwv_flow_imp.id(209193914713496705)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(209195715799496722)
,p_validation_name=>'valid export file'
,p_validation_sequence=>20
,p_validation=>':P598_IMP_COMPANY is not null and :P598_IMP_FLOW_ID is not null'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'File is not a valid &PRODUCT_NAME. component import file.'
,p_when_button_pressed=>wwv_flow_imp.id(209190624600496680)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1592515481545724)
,p_process_sequence=>10
,p_process_point=>'AFTER_FOOTER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Unset flow IDs'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':FB_FLOW_ID := null;',
':FB_FLOW_PAGE_ID := null;',
':F4000_P1_FLOW := null;',
':F4000_P1_PAGE := null;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id from wwv_flows ',
' where id = :FB_FLOW_ID ',
'   and build_status = ''RUN_ONLY''',
'   and security_group_id = :flow_security_group_id'))
,p_process_when_type=>'EXISTS'
,p_internal_uid=>1592515481545724
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(209196315059496725)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'determine page import company action'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_build_status wwv_flows.build_status%type;',
'begin',
'    begin',
'      select build_status ',
'        into l_build_status from wwv_flows ',
'       where id = :P598_NEW_FLOW_ID',
'         and security_group_id = :WORKSPACE_ID;',
'    exception when no_data_found then',
'        :P67_INSTALL := ''N'';',
'    end;',
'',
'    if l_build_status = ''RUN_ONLY'' then',
'      :P598_INSTALL := ''RUN_ONLY'';',
'    else',
'      :P598_INSTALL := ''Y'';',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>209196315059496725
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(209196524386496728)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'install components'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_security_group_id number  := wwv_flow_imp_parser.get_security_group_id(:p49_file_id);',
'    l_flow_id           number  := wwv_flow_imp_parser.get_flow_id(p_file_id => :p49_file_id);',
'    l_adjust_offset     boolean := :flow_security_group_id <> l_security_group_id ',
'                                   or :FB_FLOW_ID <> l_flow_id;',
'begin',
'    wwv_flow_imp_parser.parse(',
'        p_file_id          => :P598_FILE_ID,',
'        p_parse_as_schema  => :P598_PARSE_AS,',
'        p_install_as_flow  => :P598_NEW_FLOW_ID,',
'        p_original_flow_id => l_flow_id,',
'        p_adjust_offset    => l_adjust_offset',
'    );',
'',
'    -- get imported component id to redirect to the new component',
'    :FB_FLOW_ID := :P598_NEW_FLOW_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error installing application components'
,p_process_when=>'INSTALL:REPLACE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'Application components installed.'
,p_internal_uid=>209196524386496728
);
end;
/
prompt --application/pages/page_00599
begin
wwv_flow_imp_page.create_page(
 p_id=>599
,p_name=>'Update Web Service Reference'
,p_alias=>'UPDATE-WEB-SERVICE-REFERENCE'
,p_page_mode=>'MODAL'
,p_step_title=>'Edit Web Service Reference'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_step_template=>wwv_flow_imp.id(120871216744825711)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(15044202411659238)
,p_plug_name=>'Web Service Reference'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'Region generated 21-APR-2004 12:45:01'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(716353047314823637)
,p_plug_name=>'Wizard Button bar'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(15044804120659245)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(716353047314823637)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
,p_button_condition=>'P599_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(15044717260659245)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(716353047314823637)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P599_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(15044626319659245)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(716353047314823637)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(15046226715659255)
,p_branch_name=>'Go To Page 170'
,p_branch_action=>'f?p=&APP_ID.:170:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>21
,p_branch_comment=>'Generated 21-APR-2004 12:45:01'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(15045824324659250)
,p_branch_action=>'f?p=&APP_ID.:170:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(15044626319659245)
,p_branch_sequence=>1
,p_branch_comment=>'Generated 21-APR-2004 12:45:01'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(15046624430659260)
,p_name=>'P599_ID'
,p_item_sequence=>0
,p_item_plug_id=>wwv_flow_imp.id(15044202411659238)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 21-APR-2004 12:45:01'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(15047023078659274)
,p_name=>'P599_NAME'
,p_item_sequence=>4
,p_item_plug_id=>wwv_flow_imp.id(15044202411659238)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a name for the Web service reference.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 21-APR-2004 12:45:01'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(15047802065659282)
,p_name=>'P599_URL'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_imp.id(15044202411659238)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Endpoint URL'
,p_source=>'URL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the URL used to invoke the Web service. You may reference session state in the URL by using',
'<code>&amp;ITEM_NAME.</code> convention.</p>',
'<p>For example:</p>',
'<code>http://s3.example.com/&amp;P2_BUCKET.</code>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 21-APR-2004 12:45:01'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(31180714336167685)
,p_name=>'P599_BASIC_AUTH'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_imp.id(15044202411659238)
,p_prompt=>'Basic Authentication:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(84259319526460470)||'.'
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Indicates whether this Web service requires basic authentication. Basic authentication credentials are sent as part of the HTTP request in clear text. Web services that employ basic authentication usually also use the HTTPS (SSL) protocol since the u'
||'sername and password are sent in clear text.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(439442006590047844)
,p_name=>'P599_SOAP_VERSION'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_imp.id(15044202411659238)
,p_use_cache_before_default=>'NO'
,p_item_default=>'1.1'
,p_prompt=>'SOAP Version:'
,p_source=>'SOAP_VERSION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WS_SOAP_VERSION'
,p_lov=>'.'||wwv_flow_imp.id(439439004288980949)||'.'
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Choose the version of the SOAP specification that this Web service uses, either 1.1 or 1.2.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(31181815506177484)
,p_computation_sequence=>10
,p_computation_item=>'P599_BASIC_AUTH'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select null',
'             from wwv_flow_ws_operations',
'            where name = ''BASIC_AUTH''',
'              and ws_id = :P599_ID ) loop',
'  return ''Y'';',
'  exit;',
'end loop;',
'',
'return ''N'';'))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(15047500433659280)
,p_validation_name=>'P599_NAME not null'
,p_validation_sequence=>4
,p_validation=>'P599_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Name must have some value.'
,p_associated_item=>wwv_flow_imp.id(15047023078659274)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(15056100755728156)
,p_validation_name=>'P599_URL not null'
,p_validation_sequence=>14
,p_validation=>'P599_URL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'You must supply an endpoint URL.'
,p_when_button_pressed=>wwv_flow_imp.id(15044717260659245)
,p_associated_item=>wwv_flow_imp.id(15047802065659282)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(614672505360188735)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(15044626319659245)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(614672634381188736)
,p_event_id=>wwv_flow_imp.id(614672505360188735)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(15048607217659289)
,p_process_sequence=>1
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_SHARED_WEB_SERVICES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_SHARED_WEB_SERVICES'
,p_attribute_03=>'P599_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Unable to fetch row.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>15048607217659289
,p_process_comment=>'Generated 21-APR-2004 12:45:01'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(15049032385659292)
,p_process_sequence=>1
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_SHARED_WEB_SERVICES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_SHARED_WEB_SERVICES'
,p_attribute_03=>'P599_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Unable to process row of table WWV_FLOW_SHARED_WEB_SERVICES.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>15049032385659292
,p_process_comment=>'Generated 21-APR-2004 12:45:01'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(15049400508659292)
,p_process_sequence=>2
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'599'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(15044804120659245)
,p_internal_uid=>15049400508659292
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(614672738279188737)
,p_process_sequence=>12
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'SAVE,Delete'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>614672738279188737
);
end;
/
prompt --application/pages/page_00600
begin
wwv_flow_imp_page.create_page(
 p_id=>600
,p_name=>'Create Form on Web Service - Choose Web Service and Operation'
,p_alias=>'CREATE-FORM-ON-WEB-SERVICE-CHOOSE-WEB-SERVICE-AND-OPERATION'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Form on Web Service'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(15582816281678881)
,p_plug_name=>'Wizard Steps'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(15577802944637145)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(15583601521684042)
,p_plug_name=>'Create Form on Web Service'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(57085813432339838)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-LinksList--nowrap:a-LinksList--showArrow'
,p_plug_template=>wwv_flow_imp.id(399849897040726767)
,p_plug_display_sequence=>60
,p_list_id=>wwv_flow_imp.id(57083604297327751)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
,p_plug_display_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(204715020445896617)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(15584616543697813)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(204715020445896617)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(15585701437702997)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(204715020445896617)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(699462299166665144)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_imp.id(204715020445896617)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(15586127928703003)
,p_branch_name=>'Go To Page 884'
,p_branch_action=>'f?p=&APP_ID.:884:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(15585701437702997)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(15642829151786604)
,p_branch_name=>'Go To Page 600'
,p_branch_action=>'f?p=&FLOW_ID.:600:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(699462321918666727)
,p_branch_name=>'Go To Page 4716'
,p_branch_action=>'4716'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(699462299166665144)
,p_branch_sequence=>170
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(15597603824751001)
,p_name=>'P600_WS_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(15583601521684042)
,p_prompt=>'Web Service Reference'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P600_WEB_SERVICES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'  from wwv_flow_shared_web_services',
' where flow_id = :FB_FLOW_ID',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Service -'
,p_lov_null_value=>'0'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the name of the Web service reference.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(15601003955760429)
,p_name=>'P600_OPERATION_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(15583601521684042)
,p_prompt=>'Operation'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P600_SERVICE_OPERATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'  from wwv_flow_ws_operations',
' where name != ''BASIC_AUTH''',
'   and ws_id = :P600_WS_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'-- Select Operation --'
,p_lov_null_value=>'0'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when=>'nvl(:P600_WS_ID,''0'') != ''0'' and nvl(:P600_WEB_REF_TYPE,''MANUAL'') != ''MANUAL'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the operation.  The operation is the method that will be executed.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(191289820259315529)
,p_name=>'P600_WEB_REF_TYPE'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_imp.id(15583601521684042)
,p_prompt=>'Web Service Reference Type'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'P600_WEB_REF_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(191288700473281420)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when=>'nvl(:P600_WS_ID,''0'') != ''0'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the Web reference type - Manual, Based on a WSDL, or RESTful.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(308896009396895266)
,p_name=>'P600_OUTPUT_TYPE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(15583601521684042)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(191290216805390292)
,p_computation_sequence=>10
,p_computation_item=>'P600_WEB_REF_TYPE'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select nvl(action,''NONE'') act ',
'             from wwv_flow_shared_web_services',
'            where id = :P600_WS_ID ) loop',
'  if c1.act in (''REST'',''NEW_SCHOOL'') then',
'    --:P600_IS_REST := ''Y'';',
'    return c1.act;',
'  else',
'    return ''MANUAL'';',
'  end if;',
'end loop;'))
,p_compute_when=>'P600_WS_ID'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(504396922779505413)
,p_computation_sequence=>40
,p_computation_item=>'P600_OPERATION_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P600_WEB_REF_TYPE = ''REST'' then',
'  for c1 in (select id',
'             from wwv_flow_ws_operations',
'            where ws_id = :P600_WS_ID',
'              and name = ''doREST'' ) loop',
'    return c1.id;',
'  end loop;',
'else',
'  return null;',
'end if;'))
,p_compute_when=>'P600_WS_ID'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(309340112619908987)
,p_computation_sequence=>50
,p_computation_item=>'P600_OUTPUT_TYPE'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(static_parm_05 ,''x'')',
'  from wwv_flow_shared_web_services',
' where id = :P600_WS_ID'))
,p_compute_when=>'NEXT'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(15607611012771937)
,p_validation_name=>'P600_WS_ID'
,p_validation_sequence=>10
,p_validation=>'nvl(:P600_WS_ID,''0'') != ''0'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'You must choose a web service.'
,p_when_button_pressed=>wwv_flow_imp.id(15585701437702997)
,p_associated_item=>wwv_flow_imp.id(15597603824751001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(15639519108783722)
,p_validation_name=>'P600_OPERATION_ID'
,p_validation_sequence=>20
,p_validation=>'nvl(:P600_OPERATION_ID,''0'') != ''0'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'You must choose an operation.'
,p_validation_condition=>'nvl(:P600_WEB_REF_TYPE,''MANUAL'') != ''MANUAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(15585701437702997)
,p_associated_item=>wwv_flow_imp.id(15601003955760429)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(549716881405753329)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(15584616543697813)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(549716959456753330)
,p_event_id=>wwv_flow_imp.id(549716881405753329)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(17108307404622120)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'clean up collections'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_collection.collection_exists(''WS_INPUT_ITEMS'') then',
'  wwv_flow_collection.delete_collection(''WS_INPUT_ITEMS'');',
'end if;',
'if wwv_flow_collection.collection_exists(''WS_OUTPUT_ITEMS'') then',
'  wwv_flow_collection.delete_collection(''WS_OUTPUT_ITEMS'');',
'end if;',
'if wwv_flow_collection.collection_exists(''WS_AUTH_ITEMS'') then',
'  wwv_flow_collection.delete_collection(''WS_AUTH_ITEMS'');',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>17108307404622120
);
end;
/
prompt --application/pages/page_00603
begin
wwv_flow_imp_page.create_page(
 p_id=>603
,p_name=>'Copy List of Values'
,p_alias=>'COPY-LIST-OF-VALUES'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy List of Values'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(91429205691059841)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_lov.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44783904287156380)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(113879931093982483)
,p_plug_name=>'Copy List of Values'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(113880102948982483)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(44783904287156380)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(113880325340982485)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(44783904287156380)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(113882119110982502)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(113880529499982487)
,p_name=>'P603_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(113879931093982483)
,p_prompt=>'Copy List of Values'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select LOV_NAME||'' - ''||decode(substr(LOV_QUERY,1,1),''.'',m.s,m.d) n, id',
'from WWV_FLOW_LISTS_OF_VALUES$ lov,',
'  (select wwv_flow_lang.system_message(''F4000.DYNAMIC'') d,',
'          wwv_flow_lang.system_message(''F4000.STATIC'') s',
'   from dual) m',
'where flow_id = :fb_flow_id',
'order by upper(LOV_NAME)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'-- Select Existing List of Values --'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify list to copy'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(113881028384982490)
,p_name=>'P603_LIST_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(113879931093982483)
,p_prompt=>'New List of Values Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the name of the list you would like to create.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(113881529390982493)
,p_validation_name=>'P603_ID'
,p_validation_sequence=>10
,p_validation=>'P603_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(113880325340982485)
,p_associated_item=>wwv_flow_imp.id(113880529499982487)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(113881728480982496)
,p_validation_name=>'P603_LIST_NAME'
,p_validation_sequence=>20
,p_validation=>'P603_LIST_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(113880325340982485)
,p_associated_item=>wwv_flow_imp.id(113881028384982490)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(590015712860897550)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(113880102948982483)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(590116543450572001)
,p_event_id=>wwv_flow_imp.id(590015712860897550)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(113881917517982498)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'copy list of values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_lov_dev.copy_named_lov(',
'                    p_copy_from_flow_id => :FB_FLOW_ID,',
'                    p_flow_id     => :fb_flow_id,',
'                    p_lov_id_from => :P603_ID,',
'                    p_lov_name_to => upper(:P603_LIST_NAME),',
'                    p_lov_id_to   => wwv_flow.GET_UNIQUE_ID);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to copy List of Values'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(113880325340982485)
,p_process_success_message=>'List of Values copied.'
,p_internal_uid=>113881917517982498
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(590116663134572002)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(113880325340982485)
,p_process_when_type=>'NEVER'
,p_process_success_message=>'List of Values copied.'
,p_internal_uid=>590116663134572002
);
end;
/
prompt --application/pages/page_00605
begin
wwv_flow_imp_page.create_page(
 p_id=>605
,p_name=>'Create Form on Web Service - Page and Region Attributes'
,p_alias=>'CREATE-FORM-ON-WEB-SERVICE-PAGE-AND-REGION-ATTRIBUTES'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Form on Web Service'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(15442908402483978)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(15577802944637145)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(15443723344483985)
,p_plug_name=>'Create Form on Web Service'
,p_region_template_options=>'#DEFAULT#:#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>130
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(204723130367965699)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>160
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(15444526658483988)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_imp.id(204723130367965699)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(15444932518483990)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(204723130367965699)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(15445327883483990)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(204723130367965699)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:2500:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(34904519302002538)
,p_branch_name=>'Go To Page 4716'
,p_branch_action=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.::P4716_PREV_PAGE_ID:&APP_PAGE_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(15444932518483990)
,p_branch_sequence=>25
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(15451923580484038)
,p_branch_name=>'Go To Page 620'
,p_branch_action=>'f?p=&FLOW_ID.:620:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(15444932518483990)
,p_branch_sequence=>30
,p_branch_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(122028012317759802)
,p_branch_action=>'f?p=&APP_ID.:605:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'P605_BREADCRUMB_ID'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(15447123675484001)
,p_name=>'P605_PAGE_ID'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(15443723344483985)
,p_prompt=>'Page Number'
,p_source=>'wwv_flow_utilities.minimum_free_page(v(''FB_FLOW_ID''),1)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d',
'  from wwv_flow_steps',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and is_page_pattern   = ''N''',
'order by 2'))
,p_cSize=>10
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a page to contain the new form, or enter a new page number.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(15447712088484005)
,p_name=>'P605_PAGE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(15443723344483985)
,p_prompt=>'Page Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter a title for the page if it is being created.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(15448423106484007)
,p_name=>'P605_REGION_NAME'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_imp.id(15443723344483985)
,p_prompt=>'Region Title'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a title for the region in which the form will appear.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(15449111431484009)
,p_name=>'P605_REGION_TEMPLATE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(15443723344483985)
,p_prompt=>'Region Template'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl( default_form_template, default_region_template )',
'  from wwv_flow_themes',
' where flow_id           = :FB_FLOW_ID',
'   and theme_id          = :FB_THEME_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REGION.TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.d, ',
'       t.r ',
'  from ( select wwv_flow_escape.html(page_plug_template_name) d, ',
'             id r',
'           from wwv_flow_page_plug_templates',
'          where security_group_id = :FLOW_SECURITY_GROUP_ID',
'            and flow_id           = :FB_FLOW_ID',
'            and (:FB_THEME_ID is null or theme_id = :FB_THEME_ID)',
'          order by upper(page_plug_template_name) ) t'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'No Template'
,p_cHeight=>1
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a region template for the new form region.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22376114956149124)
,p_name=>'P605_WS_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(15443723344483985)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Web Service Reference:'
,p_source=>'P600_WS_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'P600_WEB_SERVICES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'  from wwv_flow_shared_web_services',
' where flow_id = :FB_FLOW_ID',
'order by 1'))
,p_tag_css_classes=>'fielddatabold'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Indicates the name of the Web service reference.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22377024999151938)
,p_name=>'P605_OPERATION_ID'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_imp.id(15443723344483985)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Operation:'
,p_source=>'P600_OPERATION_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'P600_SERVICE_OPERATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'  from wwv_flow_ws_operations',
' where name != ''BASIC_AUTH''',
'   and ws_id = :P600_WS_ID'))
,p_tag_css_classes=>'fielddatabold'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Indicates the operation. The operation is the method that will be executed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(34903811898990975)
,p_name=>'P605_IS_REST'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(15443723344483985)
,p_prompt=>'Is Rest'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(45237030953227737)
,p_name=>'P605_PAGE_MODE'
,p_item_sequence=>23
,p_item_plug_id=>wwv_flow_imp.id(15443723344483985)
,p_item_default=>'NORMAL'
,p_prompt=>'Page Mode'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DIALOG_PAGE_MODE_CREATE_WIZARD'
,p_lov=>'.'||wwv_flow_imp.id(1497542689968615899)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_user_interface_dev.dialog_page_template_exists(',
'                     p_application_id    => :FB_FLOW_ID ); '))
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Identify the page mode, based on the following options: <p/>',
'<ul>',
'<li><strong>Normal</strong>: The page is presented as a normal &PRODUCT_NAME. application page.</li>',
'<li><strong>Modal Dialog</strong>: The page is presented as a modal dialog. A modal dialog is an overlay window positioned within the viewport, which remains active and focused until the end user dismisses (closes) it. The underlying page is grayed o'
||'ut and the end user is prevented from interacting with the rest of the page until the dialog is closed.</li></ul>',
'<br><p>',
'Note that the Modal Dialog option will only be available for selection where the current application theme contains at least one page template of template type <strong>Dialog Page</strong>.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
,p_attribute_04=>'VERTICAL'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(122022025908744875)
,p_name=>'P605_BREADCRUMB_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(15443723344483985)
,p_item_default=>'0'
,p_prompt=>'Breadcrumb'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION.MENUS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name,',
'       id',
'  from wwv_flow_menus',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- do not use breadcrumbs on page -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select whether you want to use a breadcrumb navigation control on your page, and which breadcrumb navigation control you want to use.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(122024418675756604)
,p_name=>'P605_BREADCRUMB_NAME'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(15443723344483985)
,p_prompt=>'Entry Name'
,p_source=>'P605_PAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify the name of the breadcrumb entry.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(381726584092989012)
,p_name=>'P605_BREADCRUMB_PARENT_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(15443723344483985)
,p_prompt=>'Parent Entry'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov_language=>'PLSQL'
,p_lov=>'return wwv_flow_4000_ui.breadcrumb_parent_lov_sql( p_breadcrumb_item_name => ''P605_BREADCRUMB_ID'' )'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'No parent entry'
,p_lov_cascade_parent_items=>'P605_BREADCRUMB_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(404572689103900842)
,p_name=>'P605_GROUP_NAME'
,p_item_sequence=>24
,p_item_plug_id=>wwv_flow_imp.id(15443723344483985)
,p_prompt=>'Page Group'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE GROUP (RETURNS NAME)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d, group_name r ',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'order by upper(group_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Page Group -'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Identify the name of the page group you would like to associate with this page. Page groups help developers manage the pages within an application. To create a page group, enter the name.  To use an existing page group, select the name from the list '
||'of values.',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(15449916947484013)
,p_computation_sequence=>10
,p_computation_item=>'F4000_RUN_EDIT_PAGE'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P605_PAGE_ID'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1941061326797452757)
,p_computation_sequence=>60
,p_computation_item=>'P4716_NAVLIST_ENTRY_NAME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P605_PAGE_NAME'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(192326127586636396)
,p_computation_sequence=>5
,p_computation_item=>'P605_PAGE_NAME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>'select name from wwv_flow_shared_web_services where id = :P600_WS_ID'
,p_compute_when=>'P605_PAGE_NAME'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(165429626996801501)
,p_computation_sequence=>20
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.get_current_theme_id (',
'    p_application_id    => :FB_FLOW_ID )'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(192325310617631546)
,p_computation_sequence=>20
,p_computation_item=>'P605_REGION_NAME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_region_title varchar2(4000);',
'begin',
'  l_region_title := :P605_PAGE_NAME;',
'  for c1 in (select name from wwv_flow_ws_operations where id = :P600_OPERATION_ID ) loop',
'    l_region_title := c1.name;',
'  end loop;',
'  return l_region_title;',
'end;'))
,p_compute_when=>'P605_REGION_NAME'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(34904008220999424)
,p_computation_sequence=>30
,p_computation_item=>'P605_IS_REST'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'Y'
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_ws_operations',
' where name = ''doREST''',
'   and id = :P600_OPERATION_ID'))
,p_compute_when_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(15450304649484026)
,p_validation_name=>'P605_PAGE_ID positive, whole number'
,p_validation_sequence=>1
,p_validation=>'P605_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>'Page Number must be a positive, whole number.'
,p_when_button_pressed=>wwv_flow_imp.id(15444932518483990)
,p_associated_item=>wwv_flow_imp.id(15447123675484001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 10-MAR-2001 11:10'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(15450707544484027)
,p_validation_name=>'P605_PAGE_NAME Not Null'
,p_validation_sequence=>2
,p_validation=>'P605_PAGE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Page Title must be specified.'
,p_associated_item=>wwv_flow_imp.id(15447712088484005)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 10-MAR-2001 11:10'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(45237527287229458)
,p_validation_name=>'P605_PAGE_MODE Not Null'
,p_validation_sequence=>3
,p_validation=>'P605_PAGE_MODE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Page Mode must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(15444932518483990)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 10-MAR-2001 11:10'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(404573126780902107)
,p_validation_name=>'Validate Group Name'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_utilities.is_valid_page_group_name (',
'  p_name => :P605_GROUP_NAME);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P605_GROUP_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(15444932518483990)
,p_associated_item=>wwv_flow_imp.id(404572689103900842)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1136581968452333624)
,p_validation_name=>'P605_BREADCRUMB_NAME not null'
,p_validation_sequence=>30
,p_validation=>'P605_BREADCRUMB_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Breadcrumb entry name must be specified.'
,p_validation_condition=>'P605_BREADCRUMB_ID'
,p_validation_condition_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_when_button_pressed=>wwv_flow_imp.id(15444932518483990)
,p_associated_item=>wwv_flow_imp.id(122024418675756604)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(381728297354002062)
,p_name=>'Breadcrumb options'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P605_BREADCRUMB_ID'
,p_condition_element=>'P605_BREADCRUMB_ID'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(381728570785002062)
,p_event_id=>wwv_flow_imp.id(381728297354002062)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P605_BREADCRUMB_NAME,P605_BREADCRUMB_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(381728711832002063)
,p_event_id=>wwv_flow_imp.id(381728297354002062)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P605_BREADCRUMB_NAME,P605_BREADCRUMB_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(549717032947753331)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(15444526658483988)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(549717110949753332)
,p_event_id=>wwv_flow_imp.id(549717032947753331)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1941061625921454398)
,p_name=>'set region name'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P605_PAGE_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1941062598462454398)
,p_event_id=>wwv_flow_imp.id(1941061625921454398)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P605_REGION_NAME'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P605_PAGE_NAME'
,p_attribute_07=>'P605_PAGE_NAME'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1941062007640454398)
,p_event_id=>wwv_flow_imp.id(1941061625921454398)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P605_BREADCRUMB_NAME'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P605_PAGE_NAME'
,p_attribute_07=>'P605_PAGE_NAME'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
end;
/
prompt --application/pages/page_00606
begin
wwv_flow_imp_page.create_page(
 p_id=>606
,p_name=>'Developer Comments'
,p_alias=>'DEVELOPER-COMMENTS1'
,p_step_title=>'Developer Comments'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_comment.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5048802885667873)
,p_plug_name=>'Developer Comments'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       flow_id,',
'       pages, ',
'       case when length(app_comment) > 200 then',
'           substr(app_comment,1,200)||''...''',
'       else',
'          app_comment',
'       end app_comment,',
'       created_on,',
'       created_by,',
'       to_char(created_on,''YYYY.MM.DD'') linked_created_on',
'from WWV_FLOW_APP_COMMENTS',
'where flow_id = :fb_flow_id',
'and security_group_id = :flow_security_group_id',
''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(5048902946667873)
,p_name=>'Developer Comments'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'C'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_download_filename=>'application_comments.csv'
,p_enable_mail_download=>'Y'
,p_detail_link=>'f?p=&APP_ID.:1236:&SESSION.::&DEBUG.:RP,1236:P1236_ID:#ID#'
,p_detail_link_text=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="&EDIT." class="editDevComment" />'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5049122900667883)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'&nbsp;'
,p_column_link=>'javascript:popupURL(''f?p=&APP_ID.:1236:&SESSION.::&DEBUG.:1236:P1236_ID:#ID#'');'
,p_column_linktext=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" border="0" alt="&EDIT." title="&EDIT.">'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5049225811667884)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5049311933667887)
,p_db_column_name=>'PAGES'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Page(s)'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5049413199667887)
,p_db_column_name=>'APP_COMMENT'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Comment'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5049517685667888)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Date Created'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5049617086667888)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(185221631463398633)
,p_db_column_name=>'LINKED_CREATED_ON'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Created On'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(5049814562668523)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1289816013536644'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'ID:FLOW_ID:PAGES:APP_COMMENT:CREATED_ON:CREATED_BY:LINKED_CREATED_ON'
,p_sort_column_1=>'CREATED_ON'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(777399892767703802)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(784788000174894142)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(777400143178703805)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(786331487669013778)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from WWV_FLOW_APP_COMMENTS',
'where flow_id = :fb_flow_id',
'and security_group_id = :flow_security_group_id'))
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1000724887721503630)
,p_plug_name=>'Developer Comments'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>'Use Developer Comments to add comments to an application, a page, or a group of pages within an application.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1000724925921503631)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(5048802885667873)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:606:&SESSION.::&DEBUG.:606,RIR:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(125693123853892007)
,p_branch_action=>'f?p=&APP_ID.:606:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1000724477798503626)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'606'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(746162431239515825)
,p_name=>'Submit Page on Create Dialog Close'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(386920635912182000)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(746165249577534895)
,p_event_id=>wwv_flow_imp.id(746162431239515825)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(746227137432587695)
,p_name=>'Submit Page on Edit/Delete Dialog Close'
,p_event_sequence=>20
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(5048802885667873)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(746227441979587719)
,p_event_id=>wwv_flow_imp.id(746227137432587695)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_02=>'Y'
);
end;
/
prompt --application/pages/page_00611
begin
wwv_flow_imp_page.create_page(
 p_id=>611
,p_name=>'Copy Application - Confirm'
,p_alias=>'COPY-APPLICATION-CONFIRM'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Application'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213220627333807318)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_copy_app.htm'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(23839028027634444)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(23817524863605164)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46514529279030177)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(115191424096008027)
,p_plug_name=>'Copy Application'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wiz_confirm.copy_application (',
'    p_old_app_id    => :P499_OLD_APP_ID,',
'    p_old_app_name  => :P499_OLD_APP_NAME,',
'    p_new_app_id    => :P499_NEW_APP_ID,',
'    p_new_app_name  => :P499_NEW_APP_NAME,',
'    p_copy_deployment => nvl(:P499_COPY_DEPLOYMENT, ''N'')',
'    );'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(115191909919008029)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46514529279030177)
,p_button_name=>'COPY'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy Application'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(115192021865008029)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(46514529279030177)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(115191824495008029)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(46514529279030177)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1137943140511956660)
,p_branch_action=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(115192408479008031)
,p_branch_action=>'f?p=&APP_ID.:499:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(115192021865008029)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(590117084684572006)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(115191824495008029)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(590117138178572007)
,p_event_id=>wwv_flow_imp.id(590117084684572006)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1119157430779390637)
,p_name=>'Submit with Wait Indicator'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(115191909919008029)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1119157525112390638)
,p_event_id=>wwv_flow_imp.id(1119157430779390637)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'COPY'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1330465520218911739)
,p_process_sequence=>5
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'security'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.init;',
'sys.owa_util.redirect_url(v(''LOGOUT_URL''));',
'wwv_flow.g_unrecoverable_error := true;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(115191909919008029)
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
' select 1 ',
'   from wwv_flows',
'  where id = :P499_OLD_APP_ID',
'    and build_status = ''RUN_AND_HIDDEN'''))
,p_process_when_type=>'EXISTS'
,p_internal_uid=>1330465520218911739
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(115346504692769666)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'copy application'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_export_dev.copy_application (',
'    p_old_application_id => :P499_OLD_APP_ID,',
'    p_new_application_id => :P499_NEW_APP_ID,',
'    p_new_name           => :P499_NEW_APP_NAME,',
'    p_export_sup_objects => nvl(:P499_COPY_DEPLOYMENT, ''N'') );',
'',
':FB_FLOW_ID      := :P499_NEW_APP_ID;',
':FB_FLOW_PAGE_ID := ''1'';',
':F4000_P1_FLOW   := :P499_NEW_APP_ID;',
':F4000_P1_PAGE   := ''1'';  '))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to copy application &P499_OLD_APP_ID..'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(115191909919008029)
,p_internal_uid=>115346504692769666
);
end;
/
prompt --application/pages/page_00617
begin
wwv_flow_imp_page.create_page(
 p_id=>617
,p_name=>'Copy Shortcut'
,p_alias=>'COPY-SHORTCUT'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Shortcut'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(91429205691059841)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_cut.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47733924859691443)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(115644826701673864)
,p_plug_name=>'Copy Shortcut'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(115645017438673865)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47733924859691443)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(115645209511673866)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(47733924859691443)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(115647012720673880)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(115645432695673868)
,p_name=>'P617_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(115644826701673864)
,p_prompt=>'Copy Shortcut'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select SHORTCUT_NAME d, id',
'from WWV_FLOW_SHORTCUTS',
'where flow_id = :fb_flow_id',
'order by upper(SHORTCUT_NAME)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Shortcut -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify component to copy'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(115645926125673872)
,p_name=>'P617_SHORTCUT_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(115644826701673864)
,p_prompt=>'Shortcut Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify new component name.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(115646416690673876)
,p_validation_name=>'P617_ID'
,p_validation_sequence=>20
,p_validation=>'P617_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(115645209511673866)
,p_associated_item=>wwv_flow_imp.id(115645432695673868)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(115646610323673877)
,p_validation_name=>'P617_SHORTCUT_NAME'
,p_validation_sequence=>30
,p_validation=>'P617_SHORTCUT_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(115645209511673866)
,p_associated_item=>wwv_flow_imp.id(115645926125673872)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(590011504514897508)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(115645017438673865)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(590011687753897509)
,p_event_id=>wwv_flow_imp.id(590011504514897508)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(115646805024673879)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Shortcut'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_shortcut_id number;',
'begin',
'    l_shortcut_id := wwv_flow_copy_metadata.copy_component (',
'                         p_component_type       => wwv_flow_copy_metadata.c_shortcut,',
'                         p_from_id              => :P617_ID,',
'                         p_from_app_id          => :FB_FLOW_ID,',
'                         p_to_app_id            => :FB_FLOW_ID,',
'                         p_new_name             => :P617_SHORTCUT_NAME );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to copy Shortcut'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(115645209511673866)
,p_process_success_message=>'Shortcut Copied'
,p_internal_uid=>115646805024673879
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(590011781573897510)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(115645209511673866)
,p_process_success_message=>'Shortcut Copied'
,p_internal_uid=>590011781573897510
);
end;
/
prompt --application/pages/page_00618
begin
wwv_flow_imp_page.create_page(
 p_id=>618
,p_name=>'Copy Page - Copy Page Option'
,p_alias=>'COPY-PAGE-COPY-PAGE-OPTION'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Page'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_copy_pg.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44110105120524104)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(200885221418238033)
,p_plug_name=>'Copy Page'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(203598727799647411)
,p_plug_name=>'Navigation'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(18564606387816293)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(200885601455238055)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(44110105120524104)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(200885906224238055)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(44110105120524104)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(70071433912240750)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(44110105120524104)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:2500:&SESSION.::&DEBUG.:618::'
,p_button_condition=>'P618_LAST_VIEW'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(200906803039333407)
,p_branch_name=>'Go To Page 301'
,p_branch_action=>'f?p=&APP_ID.:301:&SESSION.::&DEBUG.:301,302,305,308,309,315::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P618_COPY_OPTION'
,p_branch_condition_text=>'SAME'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(200886204418238068)
,p_branch_name=>'Go To Page 621'
,p_branch_action=>'f?p=&APP_ID.:621:&SESSION.::&DEBUG.:621,622,623,625,627,628,671,677,COPY_PAGE_LOV,COPY_PAGE_LIST,COPY_PAGE_SECURITY,COPY_PAGE_BRANCH,COPY_PAGE_TEMPLATES::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(200885906224238055)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P618_COPY_OPTION'
,p_branch_condition_text=>'DIFF'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(70071328497240749)
,p_name=>'P618_LAST_VIEW'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(200885221418238033)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(200885432550238047)
,p_name=>'P618_COPY_OPTION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(200885221418238033)
,p_item_default=>'SAME'
,p_prompt=>'Create a page as a copy of:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'COPY_PAGE_OPTION'
,p_lov=>'.'||wwv_flow_imp.id(200992128346618114)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Specify how to copy a page. You can copy a page from the current application or from another application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
,p_attribute_04=>'VERTICAL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(614682128425246247)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(200885601455238055)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(614682467199246247)
,p_event_id=>wwv_flow_imp.id(614682128425246247)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00621
begin
wwv_flow_imp_page.create_page(
 p_id=>621
,p_name=>'Copy Page - Page to Copy'
,p_alias=>'COPY-PAGE-PAGE-TO-COPY1'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Page'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function getNewPageName( pSelectedPage )',
'{',
'    return pSelectedPage.substring( pSelectedPage.indexOf('':'') + 1 , pSelectedPage.length );',
'}'))
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_copy_pg.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44701729689747300)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(200888526697238079)
,p_plug_name=>'Copy Page'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(203150116324615743)
,p_plug_name=>'nav'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(202931703979545993)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(200888929176238082)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(44701729689747300)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(200889226645238082)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(44701729689747300)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(200889110035238082)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(44701729689747300)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(200889800023238085)
,p_branch_name=>'Tab Options'
,p_branch_action=>'f?p=&APP_ID.:671:&SESSION.::&DEBUG.:COPY_PAGE_LOV,COPY_PAGE_LIST,COPY_PAGE_SECURITY,COPY_PAGE_BRANCH,COPY_PAGE_TEMPLATES::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(200889226645238082)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(201036929833101189)
,p_branch_action=>'f?p=&APP_ID.:621:&SESSION.::&DEBUG.:COPY_PAGE_LOV,COPY_PAGE_LIST,COPY_PAGE_SECURITY,COPY_PAGE_BRANCH,COPY_PAGE_TEMPLATES::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'P621_BREADCRUMB_ID'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(200889527926238083)
,p_branch_action=>'f?p=&APP_ID.:618:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(200889110035238082)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(200912330098369680)
,p_name=>'P621_COPY_FROM_PAGE_S'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(200888526697238079)
,p_prompt=>'Copy From Page'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||'' ''||name d, id||'':''||name r',
'from wwv_flow_steps',
'where flow_id = :P621_COPY_FROM_FLOW_ID and security_group_id = :flow_security_group_id',
'order by id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Page -'
,p_lov_cascade_parent_items=>'P621_COPY_FROM_FLOW_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the page to copy.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'Y'
,p_attribute_06=>'0'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(200918128544407052)
,p_name=>'P621_COPY_TO_PAGE_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(200888526697238079)
,p_prompt=>'Copy To New Page Number'
,p_source=>'wwv_flow_utilities.minimum_free_page(:FB_FLOW_ID,1)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the page number for your new page.',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(200919109282410953)
,p_name=>'P621_COPY_TO_PAGE_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(200888526697238079)
,p_prompt=>'New Page Name'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name',
'from wwv_flow_steps',
'where flow_id = :P621_COPY_FROM_FLOW_ID',
'and id = :P621_COPY_FROM_PAGE_ID',
'and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the page name for your new page.',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(201020122290004353)
,p_name=>'P621_BREADCRUMB_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(200888526697238079)
,p_prompt=>'Breadcrumb'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION.MENUS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name,',
'       id',
'  from wwv_flow_menus',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- do not use breadcrumbs on page -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select whether you want to use a breadcrumb navigation control on the new page, and which breadcrumb navigation control you want to use.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(201025614156039833)
,p_name=>'P621_BREADCRUMB_NAME'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(200888526697238079)
,p_prompt=>'Entry Name'
,p_source=>'P621_COPY_TO_PAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify the name of the breadcrumb entry.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(201032519528079282)
,p_name=>'P621_PARENT_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(200888526697238079)
,p_prompt=>'Parent Entry'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with menu_options as (  ',
'        select short_name, page_id, parent_id, id, option_sequence ',
'          from wwv_flow_menu_options ',
'         where  menu_id = :P621_BREADCRUMB_ID ',
'           and flow_id = :FB_FLOW_ID ',
'           and exists ( ',
'               select 1 from wwv_flow_menus ',
'                where id = :P621_BREADCRUMB_ID and flow_id = :FB_FLOW_ID ',
'           ) ',
'    ) ',
'    select lpad('' '',indent,''.'')||short_name || '' ('' || ',
'        wwv_flow_lang.system_message(''PAGE'') || '' '' || page_id || '')'' short_name, id ',
'    from ( ',
'        select short_name, page_id, id, level indent ',
'        from menu_options ',
'        start with nvl(parent_id,0) = 0 ',
'        connect by prior id = parent_id ',
'        order siblings by short_name, option_sequence ',
'    )'))
,p_lov_display_null=>'YES'
,p_lov_cascade_parent_items=>'P621_BREADCRUMB_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(210197205404936550)
,p_name=>'P621_COPY_FROM_PAGE_ID'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(200888526697238079)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(213030604400880376)
,p_name=>'P621_COPY_FROM_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(200888526697238079)
,p_prompt=>'Copy From Application'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.id||'' ''||f.name d, f.id r',
'  from wwv_flow_visible_flows f',
' where id != :fb_flow_id',
'   and build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
' order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select an Application -'
,p_lov_null_value=>'0'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the application that contains the page you wish to copy.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'Y'
,p_attribute_06=>'0'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(617342549459532471)
,p_name=>'P621_COPY_PUBLIC_REPORTS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(200888526697238079)
,p_item_default=>'N'
,p_prompt=>'Copy Public Reports'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'All default reports are copied automatically without specifying, but if you wish to copy public reports, specify whether to copy public reports with the page. Available options include:',
'<p />',
'<ul>',
'<li><strong>On</strong> - Copy public reports with the page.</li>',
'<li><strong>Off</strong> - Do not copy public reports with the page.</li>',
'</ul>',
'<p />',
'Public reports are the public shared report settings saved by users from Interactive Reports or Interactive Grids.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(617343384352538544)
,p_name=>'P621_DISPLAY_COPY_PUB_RPT'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(200888526697238079)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1555955042909298943)
,p_name=>'P621_NAVIGATION_TYPE'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(200888526697238079)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(209717915047016923)
,p_computation_sequence=>10
,p_computation_item=>'P621_COPY_FROM_PAGE_ID'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'substr(:P621_COPY_FROM_PAGE_S,1,instr(:P621_COPY_FROM_PAGE_S,'':'',1)-1)'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1555955167333303850)
,p_computation_sequence=>70
,p_computation_item=>'P621_NAVIGATION_TYPE'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select x.navigation_type',
'  from wwv_flow_themes x,',
'       wwv_flows f',
' where x.flow_id           = :FB_FLOW_ID',
'   and f.security_group_id = :WORKSPACE_ID',
'   and x.flow_id           = f.id',
'   and f.theme_id          = x.theme_id',
' order by 1'))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(213206125094905243)
,p_validation_name=>'P621_COPY_FROM_FLOW_ID'
,p_validation_sequence=>10
,p_validation=>'P621_COPY_FROM_FLOW_ID'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'Copy from application must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(200889226645238082)
,p_associated_item=>wwv_flow_imp.id(213030604400880376)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(200921514261421811)
,p_validation_name=>'P621_COPY_FROM_PAGE_S'
,p_validation_sequence=>20
,p_validation=>'P621_COPY_FROM_PAGE_S'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Copy from page must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(200889226645238082)
,p_associated_item=>wwv_flow_imp.id(200912330098369680)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(200922629152426104)
,p_validation_name=>'P621_COPY_TO_PAGE_ID'
,p_validation_sequence=>30
,p_validation=>'P621_COPY_TO_PAGE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Copy to page must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(200889226645238082)
,p_associated_item=>wwv_flow_imp.id(200918128544407052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(200923707466429369)
,p_validation_name=>'P621_COPY_TO_PAGE_NAME'
,p_validation_sequence=>40
,p_validation=>'P621_COPY_TO_PAGE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'New page name must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(200889226645238082)
,p_associated_item=>wwv_flow_imp.id(200919109282410953)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(201035505246094051)
,p_validation_name=>'P621_BREADCRUMB_NAME'
,p_validation_sequence=>50
,p_validation=>'P621_BREADCRUMB_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Breadcrumb entry name must be specified.'
,p_validation_condition=>'P621_BREADCRUMB_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_ZERO'
,p_when_button_pressed=>wwv_flow_imp.id(200889226645238082)
,p_associated_item=>wwv_flow_imp.id(201025614156039833)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(204511228237472376)
,p_validation_name=>'P621_COPY_TO_PAGE_ID must be num'
,p_validation_sequence=>60
,p_validation=>'P621_COPY_TO_PAGE_ID'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Copy to page must be numeric.'
,p_when_button_pressed=>wwv_flow_imp.id(200889226645238082)
,p_associated_item=>wwv_flow_imp.id(200918128544407052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(200925032400436507)
,p_validation_name=>'copy to page does not exist'
,p_validation_sequence=>70
,p_validation=>'select 1 from wwv_flow_steps where id = :P621_COPY_TO_PAGE_ID and flow_id = :fb_flow_id'
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'This page already exists.'
,p_validation_condition=>'P621_COPY_TO_PAGE_ID'
,p_validation_condition_type=>'ITEM_IS_NUMERIC'
,p_when_button_pressed=>wwv_flow_imp.id(200889226645238082)
,p_associated_item=>wwv_flow_imp.id(200918128544407052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(614677601291224118)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(200888929176238082)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(614677951665224119)
,p_event_id=>wwv_flow_imp.id(614677601291224118)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(610892897500688724)
,p_name=>'on copy from app and page change'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P621_COPY_FROM_FLOW_ID,P621_COPY_FROM_PAGE_S'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(610892987273688725)
,p_event_id=>wwv_flow_imp.id(610892897500688724)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_display_copy_pub_rpt varchar2(1) := ''N'';',
'begin ',
'    :P621_COPY_FROM_PAGE_ID := substr(:P621_COPY_FROM_PAGE_S,1,instr(:P621_COPY_FROM_PAGE_S,'':'',1)-1);',
'    for l_region in (select null',
'                     from wwv_flow_page_plugs',
'                     where flow_id = :P621_COPY_FROM_FLOW_ID',
'                     and page_id = :P621_COPY_FROM_PAGE_ID',
'                     and plug_source_type in ( wwv_flow_region_native.c_ir, wwv_flow_region_native.c_ig ) )',
'    loop',
'        l_display_copy_pub_rpt := ''Y'';',
'        exit;',
'    end loop;',
'    :P621_DISPLAY_COPY_PUB_RPT :=  l_display_copy_pub_rpt;',
'end;'))
,p_attribute_02=>'P621_COPY_FROM_PAGE_S,P621_COPY_FROM_PAGE_ID'
,p_attribute_03=>'P621_COPY_FROM_PAGE_ID,P621_DISPLAY_COPY_PUB_RPT'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(610893080106688726)
,p_name=>'if display copy public report'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P621_DISPLAY_COPY_PUB_RPT'
,p_condition_element=>'P621_DISPLAY_COPY_PUB_RPT'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(610893145592688727)
,p_event_id=>wwv_flow_imp.id(610893080106688726)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P621_COPY_PUBLIC_REPORTS'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(610893208341688728)
,p_event_id=>wwv_flow_imp.id(610893080106688726)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P621_COPY_PUBLIC_REPORTS'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1331350277607223304)
,p_name=>'Show breadcrumb attributes'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P621_BREADCRUMB_ID'
,p_condition_element=>'P621_BREADCRUMB_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1331350355257223305)
,p_event_id=>wwv_flow_imp.id(1331350277607223304)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P621_PARENT_ID,P621_BREADCRUMB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1331350554621223307)
,p_event_id=>wwv_flow_imp.id(1331350277607223304)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P621_PARENT_ID,P621_BREADCRUMB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1905043137054606)
,p_name=>'Set P621_COPY_TO_PAGE_NAME value'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P621_COPY_FROM_PAGE_S'
,p_condition_element=>'P621_COPY_FROM_PAGE_S'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1905118583054607)
,p_event_id=>wwv_flow_imp.id(1905043137054606)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P621_COPY_TO_PAGE_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'getNewPageName( $v("P621_COPY_FROM_PAGE_S") )'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1905261653054608)
,p_event_id=>wwv_flow_imp.id(1905043137054606)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P621_COPY_TO_PAGE_NAME'
);
end;
/
prompt --application/pages/page_00622
begin
wwv_flow_imp_page.create_page(
 p_id=>622
,p_name=>'Copy Page - Templates'
,p_alias=>'COPY-PAGE-TEMPLATES'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Page'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_copy_pg.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44716807273797600)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(200890329488238085)
,p_plug_name=>'Copy Page'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(200956404695128712)
,p_name=>'Templates'
,p_template=>wwv_flow_imp.id(42025417508627628)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q varchar2(32767) := null;',
'begin',
'q:=q||''select decode(ttype, '';',
'q:=q||''  ''''PAGE'''',wwv_flow_lang.system_message_lit(''''F4000.PAGE''''), '';',
'q:=q||''  ''''REGION'''',wwv_flow_lang.system_message_lit(''''F4000.REGION''''), '';',
'q:=q||''  ''''LABEL'''',wwv_flow_lang.system_message_lit(''''LABEL''''), '';',
'q:=q||''  ''''LIST'''',wwv_flow_lang.system_message_lit(''''F4000.LIST_INITCAP''''), '';',
'q:=q||''  ''''POPUP_LOV'''',wwv_flow_lang.system_message_lit(''''F4000.P371.POPUP_LOV''''), '';',
'q:=q||''  ''''CALENDAR'''',wwv_flow_lang.system_message_lit(''''LEGACY_CALENDAR''''), '';',
'q:=q||''  ''''MENU'''',wwv_flow_lang.system_message_lit(''''F4000.MENU''''), '';',
'q:=q||''  ''''BUTTON'''',wwv_flow_lang.system_message_lit(''''F4000.BUTTON''''), '';',
'q:=q||''  ''''REPORT'''',wwv_flow_lang.system_message_lit(''''REPORT''''), '';',
'q:=q||''  ''''POPUP_LOV'''',wwv_flow_lang.system_message_lit(''''F4000.P371.POPUP_LOV''''), '';',
'q:=q||''  ''''trans-''''||ttype) temp_type, '';  ',
'q:=q||''  tname from_template, '';',
'	',
'  q:=q||''CASE '';',
'	q:=q||''when to_counter = 0 then '';',
'  q:=q||''(SELECT htmldb_item.hidden(1,x.id)||htmldb_item.hidden(2,ta.temp_type)||'';',
'  q:=q||''HTMLDB_ITEM.SELECT_LIST_FROM_QUERY_XL(3, '';',
'  q:=q||'' 	  ta.theme_class_id||'''':''''||ta.id, '';',
'  q:=q||'' 	  ''''SELECT wwv_flow_escape.html(name) d,theme_class_id||'''''''':''''''''||id v FROM wwv_flow_templates_all where flow_id=''''||:fb_flow_id|| '';',
'  q:=q||'' 		 '''' and theme_id in (select max(theme_id) from wwv_flows where id=''''||:fb_flow_id||'''') ''''|| '';    ',
'  q:=q||''  '''' and temp_type = ''''''''''''||x.ttype||'''''''''''' order by 1'''', '';',
'  q:=q||''  ''''title="''''||wwv_flow_lang.system_message(''''F4000.P622.TO_TEMPLATE'''')||''''"'''',''''NO'''',null,null,null,null,''''NO''''	 ) '';',
'  q:=q||'' from wwv_flow_templates_all ta '';',
'  q:=q||'' where ta.flow_id = :fb_flow_id '';',
'  q:=q||'' 	  and theme_id in (select max(theme_id) from wwv_flows where id = :fb_flow_id )'';    ',
'  q:=q||'' 	  and ta.temp_type = x.ttype and rownum = 1) '';',
'  ',
'  q:=q||''when to_counter = 1 then '';',
'  q:=q||''(SELECT htmldb_item.hidden(4,x.id)||htmldb_item.hidden(5,ta.temp_type)||htmldb_item.hidden(6,ta.theme_class_id||'''':''''||ta.id)||to_clob(wwv_flow_escape.html(ta.name)) '';',
'  q:=q||'' from wwv_flow_templates_all ta '';',
'  q:=q||'' where ta.flow_id = :fb_flow_id '';',
'  q:=q||'' 	  and theme_id = (select max(theme_id) from wwv_flows where id = :fb_flow_id ) '';  ',
'  q:=q||'' 	  and ta.theme_class_id = x.THEME_CLASS_ID '';',
'  q:=q||'' 	  and ta.temp_type = x.ttype and rownum = 1) '';',
'',
'  q:=q||''when to_counter > 1 then '';',
'  q:=q||''(SELECT htmldb_item.hidden(1,x.id)||htmldb_item.hidden(2,ta.temp_type)||'';',
'  q:=q||''HTMLDB_ITEM.SELECT_LIST_FROM_QUERY_XL(3, '';',
'  q:=q||''         (select theme_class_id||'''':''''||id from wwv_flow_templates_all where flow_id=:fb_flow_id and theme_class_id = x.THEME_CLASS_ID and name = x.tname and rownum = 1), '';',
'  q:=q||'' 	  ''''SELECT wwv_flow_escape.html(name) d,theme_class_id||'''''''':''''''''||id v FROM wwv_flow_templates_all where flow_id=''''||:fb_flow_id|| '';',
'  q:=q||'' 		 '''' and theme_id in (select max(theme_id) from wwv_flows where id=''''||:fb_flow_id||'''') ''''|| '';    ',
'  q:=q||''  '''' and temp_type = ''''''''''''||x.ttype||'''''''''''' order by 1'''', '';',
'  q:=q||''  ''''title="''''||wwv_flow_lang.system_message(''''F4000.P622.TO_TEMPLATE'''')||''''"'''',''''NO'''',null,null,null,null,''''NO''''	 ) '';',
'  q:=q||'' from wwv_flow_templates_all ta '';',
'  q:=q||'' where ta.flow_id = :fb_flow_id '';',
'  q:=q||'' 	  and theme_id in (select max(theme_id) from wwv_flows where id = :fb_flow_id) '';  ',
'  q:=q||'' 	  and ((ta.theme_class_id = x.THEME_CLASS_ID or ta.theme_class_id <> x.THEME_CLASS_ID ) or ta.theme_class_id = 0 or ta.theme_class_id is null) '';',
'  q:=q||'' 	  and ta.temp_type = x.ttype and rownum = 1) '';',
'  q:=q||''end to_template, ''; ',
'',
'   q:=q||''     CASE ''; ',
'   q:=q||''      when to_counter > 1 then '';',
'    q:=q||''         wwv_flow_lang.system_message_lit(''''WARNING_MULTIPLE_MATCHES'''') '';',
'   q:=q||''      when to_counter = 1 then '';',
'   q:=q||''        ''''<span class="a-Icon icon-check"></span>'''''';                                                          ',
'   q:=q||''      when to_counter = 0 then '';',
'  q:=q||''           wwv_flow_lang.system_message_lit(''''WARNING_MISSING_CLASS'''') '';',
'  q:=q||''     end status '';',
'',
'',
'--end if;',
'q:=q||''from ''; ',
'q:=q||''(select '';  ',
'q:=q||''  p.flow_id, '';',
'q:=q||''  ''''PAGE'''' ttype, '';',
'q:=q||''  wwv_flow_escape.html(p.name) tname, '';',
'q:=q||''  p.theme_id, '';',
'q:=q||''  p.theme_class_id, '';',
'q:=q||''  p.id, '';',
'q:=q||''(select count(*) xx from wwv_flow_templates_all where flow_id = :fb_flow_id and theme_id = (select max(theme_id) from wwv_flows where id = :fb_flow_id ) and theme_class_id = p.THEME_CLASS_ID and is_popup = p.is_popup and temp_type = ''''PAGE'''') '
||'to_counter '';',
'q:=q||''from wwv_flow_templates p '';',
'q:=q||''where p.flow_id = :P621_COPY_FROM_FLOW_ID and  '';',
'q:=q||''      id = nvl((select STEP_TEMPLATE from wwv_flow_steps where flow_id = :P621_COPY_FROM_FLOW_ID and id = :P621_COPY_FROM_PAGE_ID), '';',
'q:=q||''           (select t.default_page_template from wwv_flow_steps p, wwv_flows i, wwv_flow_themes t '';',
'q:=q||''             where p.flow_id  = :P621_COPY_FROM_FLOW_ID and p.id = :P621_COPY_FROM_PAGE_ID and i.id = p.flow_id '';',
'q:=q||''               and t.flow_id = i.id and t.theme_id = i.theme_id)) '';',
'q:=q||''union all '';',
'q:=q||''select distinct '';',
'q:=q||''p.flow_id, '';',
'q:=q||''''''REGION'''' ttype,  '';                                                                                                                    ',
'q:=q||''wwv_flow_escape.html(t.PAGE_PLUG_TEMPLATE_NAME) tname, '';',
'q:=q||''t.theme_id, '';',
'q:=q||''t.theme_class_id, '';',
'q:=q||''t.id, '';',
'q:=q||''(select count(*) xx from wwv_flow_templates_all where flow_id = :fb_flow_id and theme_id = (select max(theme_id) from wwv_flows where id = :fb_flow_id ) and theme_class_id = t.THEME_CLASS_ID and temp_type = ''''REGION'''') to_counter '';',
'q:=q||''from wwv_flow_page_plugs p, '';',
'q:=q||''     WWV_FLOW_PAGE_PLUG_TEMPLATES t '';',
'q:=q||''where p.flow_id = :P621_COPY_FROM_FLOW_ID and '';',
'q:=q||''      p.page_id = :P621_COPY_FROM_PAGE_ID and '';',
'q:=q||''      p.plug_template = t.id (+) and '';',
'q:=q||''      t.PAGE_PLUG_TEMPLATE_NAME is not null '';  ',
'q:=q||''union all '';',
'q:=q||''select      distinct i.flow_id, '';',
'q:=q||''''''LABEL'''' ttype, '';',
'q:=q||''wwv_flow_escape.html(f.TEMPLATE_NAME) tname, '';',
'q:=q||''f.theme_id, '';',
'q:=q||''f.theme_class_id, '';',
'q:=q||''f.id, '';',
'q:=q||''(select count(*) xx from wwv_flow_templates_all where flow_id = :fb_flow_id and theme_id = (select max(theme_id) from wwv_flows where id = :fb_flow_id ) and theme_class_id = f.THEME_CLASS_ID and temp_type = ''''LABEL'''') to_counter '';',
'q:=q||''from wwv_flow_field_templates f, '';',
'q:=q||''     wwv_flow_step_items i '';',
'q:=q||''where  '';',
'q:=q||''      i.flow_id = :P621_COPY_FROM_FLOW_ID and '';',
'q:=q||''     i.ITEM_FIELD_TEMPLATE = f.id(+) and '';',
'q:=q||''     i.flow_step_id = :P621_COPY_FROM_PAGE_ID and '';',
'q:=q||''     template_name is not null '';  ',
'q:=q||''union all '';',
'q:=q||''select a.flow_id, ''''POPUP_LOV'''' ttype, '';',
'q:=q||''wwv_flow_lang.system_message_lit(''''F4000.P371.POPUP_LOV'''') tname, '';',
'q:=q||''a.theme_id, '';',
'q:=q||''a.theme_class_id, '';',
'q:=q||''a.id, '';',
'q:=q||''(select count(*) xx from wwv_flow_templates_all where flow_id = :fb_flow_id and theme_id = (select max(theme_id) from wwv_flows where id = :fb_flow_id ) and theme_class_id = a.THEME_CLASS_ID and temp_type = ''''POPUP_LOV'''') to_counter '';',
'q:=q||''from WWV_FLOW_POPUP_LOV_TEMPLATE a '';',
'q:=q||''where a.flow_id = :P621_COPY_FROM_FLOW_ID  '';  ',
'q:=q||''and a.theme_id = (select max(theme_id) from wwv_flows where id =  :P621_COPY_FROM_FLOW_ID ) '';',
'q:=q||''and exists (select 1 '';',
'q:=q||''              from wwv_flow_step_items i '';',
'q:=q||''              where  '';',
'q:=q||''                    i.flow_id = :P621_COPY_FROM_FLOW_ID and '';',
'q:=q||''                    i.flow_step_id = :P621_COPY_FROM_PAGE_ID and '';',
'q:=q||''                    display_as like ''''POPUP%'''') '';  ',
'q:=q||''union all '';',
'q:=q||''select   distinct b.flow_id,''''BUTTON'''' ttype, '';',
'q:=q||''wwv_flow_escape.html(b.TEMPLATE_NAME) tname, '';',
'q:=q||''b.theme_id, '';',
'q:=q||''b.theme_class_id, '';',
'q:=q||''b.id, '';',
'q:=q||''(select count(*) xx from wwv_flow_templates_all where flow_id = :fb_flow_id and theme_id = (select max(theme_id) from wwv_flows where id = :fb_flow_id ) and theme_class_id = b.theme_class_id and temp_type = ''''BUTTON'''') to_counter '';',
'q:=q||''from wwv_flow_button_templates b, '';',
'q:=q||''(select button_template_id, button_name '';',
'q:=q||'' from WWV_FLOW_STEP_BUTTONS '';',
'q:=q||'' where flow_id = :P621_COPY_FROM_FLOW_ID and flow_step_id = :P621_COPY_FROM_PAGE_ID ) u '';',
'q:=q||''where b.flow_id = :P621_COPY_FROM_FLOW_ID and '';',
'q:=q||''      b.id = u.button_template_id ''; ',
'q:=q||''union all '';',
'q:=q||''select     distinct '';',
'q:=q||''t.flow_id, '';',
'q:=q||''''''CALENDAR'''' ttype, '';',
'q:=q||''wwv_flow_escape.html(t.NAME) tname, '';',
'q:=q||''t.theme_id, '';',
'q:=q||''t.theme_class_id, '';',
'q:=q||''t.id,  ''; ',
'q:=q||''(select count(*) xx from wwv_flow_templates_all where flow_id = :fb_flow_id and theme_id = (select max(theme_id) from wwv_flows where id = :fb_flow_id ) and theme_class_id = t.theme_class_id and temp_type = ''''CALENDAR'''') to_counter '';',
'q:=q||''from  wwv_flow_cal_templates t, ''; ',
'q:=q||''      wwv_flow_cals c, '';',
'q:=q||''      wwv_flow_page_plugs r '';',
'q:=q||''where t.flow_id = :P621_COPY_FROM_FLOW_ID and '';',
'q:=q||''      c.flow_id = :P621_COPY_FROM_FLOW_ID and '';',
'q:=q||''      c.plug_id = r.id and '';',
'q:=q||''      r.page_id = :P621_COPY_FROM_PAGE_ID and '';',
'q:=q||''      r.flow_Id = :P621_COPY_FROM_FLOW_ID and '';',
'q:=q||''      t.id      = c.template_id '';  ',
'q:=q||''union all '';',
'q:=q||''select     distinct '';',
'q:=q||''t.flow_id, '';',
'q:=q||''''''MENU'''' ttype, '';',
'q:=q||''wwv_flow_escape.html(t.NAME) tname, '';',
'q:=q||''t.theme_id, '';',
'q:=q||''t.theme_class_id, '';',
'q:=q||''t.id, '';',
'q:=q||''(select count(*) xx from wwv_flow_templates_all where flow_id = :fb_flow_id and theme_id = (select max(theme_id) from wwv_flows where id = :fb_flow_id ) and theme_class_id = t.theme_class_id and temp_type = ''''MENU'''') to_counter '';',
'q:=q||''from wwv_flow_menu_templates t, wwv_flow_page_plugs r '';',
'q:=q||''where t.flow_id = :P621_COPY_FROM_FLOW_ID and '';',
'q:=q||''      r.flow_id = :P621_COPY_FROM_FLOW_ID and '';',
'q:=q||''      r.page_id = :P621_COPY_FROM_PAGE_ID and '';',
'q:=q||''      r.menu_template_id = t.id ''; ',
'q:=q||''union all '';',
'q:=q||''select distinct '';',
'q:=q||''ro.flow_id, '';',
'q:=q||''''''REPORT'''' ttype, '';',
'q:=q||''wwv_flow_escape.html(ro.ROW_TEMPLATE_NAME) tname, '';',
'q:=q||''ro.theme_id, '';',
'q:=q||''ro.theme_class_id, '';',
'q:=q||''ro.id, '';',
'q:=q||''(select count(*) xx from wwv_flow_templates_all where flow_id = :fb_flow_id and theme_id = (select max(theme_id) from wwv_flows where id = :fb_flow_id ) and theme_class_id = ro.theme_class_id and temp_type = ''''REPORT'''') to_counter '';',
'q:=q||''from wwv_flow_row_templates ro, '';',
'q:=q||''     wwv_flow_page_plugs r '';',
'q:=q||''where ro.flow_id = :P621_COPY_FROM_FLOW_ID and '';',
'q:=q||''      r.flow_id = :P621_COPY_FROM_FLOW_ID and '';',
'q:=q||''      r.page_id = :P621_COPY_FROM_PAGE_ID and '';',
'q:=q||''      r.PLUG_QUERY_ROW_TEMPLATE = ro.id '';  ',
'q:=q||''union all '';',
'q:=q||''select distinct t.flow_id, '';',
'q:=q||''       ''''LIST'''' ttype, '';',
'q:=q||''       wwv_flow_escape.html(t.LIST_TEMPLATE_NAME) tname, '';',
'q:=q||''       t.theme_id, '';',
'q:=q||''       t.theme_class_id, '';',
'q:=q||''       t.id, '';',
'q:=q||''(select count(*) xx from wwv_flow_templates_all where flow_id = :fb_flow_id and theme_id = (select max(theme_id) from wwv_flows where id = :fb_flow_id ) and theme_class_id = t.theme_class_id and temp_type = ''''LIST'''') to_counter '';',
'q:=q||''from WWV_FLOW_LIST_TEMPLATES t, ''; ',
'q:=q||''     wwv_flow_page_plugs r '';',
'q:=q||''where t.flow_id = :P621_COPY_FROM_FLOW_ID and '';',
'q:=q||''      r.flow_id = :P621_COPY_FROM_FLOW_ID and '';',
'q:=q||''      r.page_id = :P621_COPY_FROM_PAGE_ID and '';',
'q:=q||''      r.list_template_id = t.id) x '';',
'q:=q||''order by 1 '';',
'return q;',
'end;'))
,p_header=>'<p>When you copy a page from another application, all the templates used by that page need to be mapped to templates in the current application. This report displays the templates in the page you are copying from. Review the report and map to the cor'
||'rect template.</p>'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>'No Templates referenced in the Page you copying from.'
,p_query_num_rows_type=>'ROWS_X_TO_Y'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200963301774317122)
,p_query_column_id=>1
,p_column_alias=>'TEMP_TYPE'
,p_column_display_sequence=>1
,p_column_heading=>'Template Type'
,p_use_as_row_header=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200963615975317123)
,p_query_column_id=>2
,p_column_alias=>'FROM_TEMPLATE'
,p_column_display_sequence=>2
,p_column_heading=>'From Template'
,p_use_as_row_header=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(205164829885245414)
,p_query_column_id=>3
,p_column_alias=>'TO_TEMPLATE'
,p_column_display_sequence=>3
,p_column_heading=>'To Template'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(359723632095392352)
,p_query_column_id=>4
,p_column_alias=>'STATUS'
,p_column_display_sequence=>4
,p_column_heading=>'Status'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(203151025674618429)
,p_plug_name=>'nav'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(202931703979545993)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(200890713171238086)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(44716807273797600)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(200891015733238086)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(44716807273797600)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(200890915007238086)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(44716807273797600)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(200891622822238088)
,p_branch_name=>'Go To Page 623'
,p_branch_action=>'f?p=&APP_ID.:623:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(200891015733238086)
,p_branch_sequence=>10
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_lov_usage_dev ',
' where flow_id = :P621_COPY_FROM_FLOW_ID ',
'   and page_id = :P621_COPY_FROM_PAGE_ID'))
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(203809932132686579)
,p_branch_name=>'Go To Page 625'
,p_branch_action=>'f?p=&APP_ID.:625:&SESSION.::&DEBUG.::P625_PREV_PAGE:622'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(200891015733238086)
,p_branch_sequence=>20
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_page_plugs p',
' where plug_source_type  = ''NATIVE_LIST''',
'   and page_id           = :P621_COPY_FROM_PAGE_ID ',
'   and flow_id           = :P621_COPY_FROM_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(203813002612696993)
,p_branch_name=>'Go To Page 627'
,p_branch_action=>'f?p=&APP_ID.:627:&SESSION.::&DEBUG.::P627_PREV_PAGE:622'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(200891015733238086)
,p_branch_sequence=>30
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_auth_scheme_usage_dev ',
' where flow_id = :P621_COPY_FROM_FLOW_ID',
'   and page_id = :P621_COPY_FROM_PAGE_ID',
'   and authorization_scheme is not null',
'   and replace(translate(authorization_scheme,''1234567890'',''0000000000''),''0'') is null'))
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(208037623645852924)
,p_branch_name=>'Go To Page 593'
,p_branch_action=>'f?p=&APP_ID.:593:&SESSION.::&DEBUG.::P593_PREV_PAGE:622'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(200891015733238086)
,p_branch_sequence=>40
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_step_branches',
' where flow_id           = :P621_COPY_FROM_FLOW_ID',
'   and flow_step_id      = :P621_COPY_FROM_PAGE_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(203821909454717884)
,p_branch_action=>'f?p=&APP_ID.:628:&SESSION.::&DEBUG.::P628_PREV_PAGE:622'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(200891015733238086)
,p_branch_sequence=>50
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(200891318893238087)
,p_branch_name=>'Tab Options'
,p_branch_action=>'f?p=&APP_ID.:671:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(200890915007238086)
,p_branch_sequence=>60
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(204092612383955288)
,p_name=>'P622_PREV_PAGE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(200956404695128712)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(614676415875216188)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(200890713171238086)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(614676731641216189)
,p_event_id=>wwv_flow_imp.id(614676415875216188)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(205147300802959476)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'handle template mapping'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  la_f03           wwv_flow_global.vc_arr2;',
'  la_f06           wwv_flow_global.vc_arr2;',
'  l_theme_class_id number := null;',
'  l_template_id    number := null;',
'begin',
'htmldb_collection.create_or_truncate_collection(p_collection_name => ''COPY_PAGE_TEMPLATES'');',
'',
'for i in 1..HTMLDB_APPLICATION.G_F04.count loop',
'  ',
'   la_f06 := wwv_flow_utilities.string_to_table2(htmldb_application.g_f06(i));	',
'	l_theme_class_id := la_f06(1);',
'	l_template_id    := la_f06(2);',
'',
'  htmldb_collection.add_member(',
'    p_collection_name   => ''COPY_PAGE_TEMPLATES'',',
'    p_c001              => HTMLDB_APPLICATION.G_F04(i),',
'    p_c002              => HTMLDB_APPLICATION.G_F05(i),',
'    p_c003              => l_template_id,',
'    p_c004              => l_theme_class_id,   ',
'    p_generate_md5      => ''YES'' );',
'end loop;',
'',
' for i in 1..HTMLDB_APPLICATION.G_F01.count loop',
'	-- since g_f03 value is theme_class_id||'':''||id, extract each value by turning into an array',
'	la_f03 := wwv_flow_utilities.string_to_table2(htmldb_application.g_f03(i));	',
'	l_theme_class_id := la_f03(1);',
'	l_template_id := la_f03(2);',
'',
'  htmldb_collection.add_member(',
'    p_collection_name   => ''COPY_PAGE_TEMPLATES'',',
'    p_c001              => HTMLDB_APPLICATION.G_F01(i),',
'    p_c002              => HTMLDB_APPLICATION.G_F02(i),',
'    p_c003              => l_template_id,',
'    p_c004              => l_theme_class_id,   ',
'    p_generate_md5      => ''YES'' );',
'end loop; ',
'commit;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to create template collection.'
,p_process_when_button_id=>wwv_flow_imp.id(200891015733238086)
,p_internal_uid=>205147300802959476
);
end;
/
prompt --application/pages/page_00623
begin
wwv_flow_imp_page.create_page(
 p_id=>623
,p_name=>'Copy Page - List of Values'
,p_alias=>'COPY-PAGE-LIST-OF-VALUES'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Page'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_copy_pg.htm'
,p_page_component_map=>'21'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3300361705465801)
,p_plug_name=>'Copy List of Values'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select seq_id,',
'       c001 copy_option,',
'       n001 new_lov,',
'       n002 old_lov_id,',
'       c002 old_lov_name,',
'       c003 lov_type',
'  from wwv_flow_collections',
' where collection_name = ''COPY_PAGE_LOV'''))
,p_plug_source_type=>'NATIVE_IG'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Copy List of Values'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
,p_plug_header=>'<p>This report displays named lists of values used in the page you are copying from.  Review the report and select a copy option.  If you select <strong>Use Existing</strong>, a list of values in the current Application must be selected.</p>'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3300521374465803)
,p_name=>'SEQ_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'SEQ_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>30
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3300608616465804)
,p_name=>'COPY_OPTION'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'COPY_OPTION'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Copy Option'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>40
,p_value_alignment=>'LEFT'
,p_is_required=>false
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(201061511357162008)
,p_lov_display_extra=>false
,p_lov_display_null=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3300711334465805)
,p_name=>'NEW_LOV'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'NEW_LOV'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Existing List of Values'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>50
,p_value_alignment=>'LEFT'
,p_is_required=>false
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(73045019699242595)
,p_lov_display_extra=>false
,p_lov_display_null=>true
,p_lov_null_text=>'- Select List of Values -'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3300888152465806)
,p_name=>'OLD_LOV_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'OLD_LOV_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>60
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3300941281465807)
,p_name=>'OLD_LOV_NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'OLD_LOV_NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'List of Values'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>70
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>true
,p_enable_sort_group=>true
,p_enable_control_break=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3301077623465808)
,p_name=>'LOV_TYPE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LOV_TYPE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Type'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>80
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3301257141465810)
,p_name=>'APEX$ROW_SELECTOR'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'N'
,p_attribute_03=>'Y'
,p_use_as_row_header=>false
,p_display_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(3300453917465802)
,p_internal_uid=>3300453917465802
,p_is_editable=>true
,p_edit_operations=>'u'
,p_lost_update_check_type=>'VALUES'
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SET'
,p_show_total_row_count=>false
,p_show_toolbar=>false
,p_toolbar_buttons=>null
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>false
,p_define_chart_view=>false
,p_enable_download=>false
,p_download_formats=>null
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(3401257036471317)
,p_interactive_grid_id=>wwv_flow_imp.id(3300453917465802)
,p_static_id=>'34013'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(3401499283471319)
,p_report_id=>wwv_flow_imp.id(3401257036471317)
,p_view_type=>'GRID'
,p_stretch_columns=>true
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3401967583471327)
,p_view_id=>wwv_flow_imp.id(3401499283471319)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(3300521374465803)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3402836467471333)
,p_view_id=>wwv_flow_imp.id(3401499283471319)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(3300608616465804)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3403703329471336)
,p_view_id=>wwv_flow_imp.id(3401499283471319)
,p_display_seq=>4
,p_column_id=>wwv_flow_imp.id(3300711334465805)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3404689364471338)
,p_view_id=>wwv_flow_imp.id(3401499283471319)
,p_display_seq=>4
,p_column_id=>wwv_flow_imp.id(3300888152465806)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3405596609471341)
,p_view_id=>wwv_flow_imp.id(3401499283471319)
,p_display_seq=>2
,p_column_id=>wwv_flow_imp.id(3300941281465807)
,p_is_visible=>true
,p_is_frozen=>false
,p_sort_order=>1
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3406452912471344)
,p_view_id=>wwv_flow_imp.id(3401499283471319)
,p_display_seq=>2
,p_column_id=>wwv_flow_imp.id(3301077623465808)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44737115041960719)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(203153712645624124)
,p_plug_name=>'nav'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(202931703979545993)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(226841702582547936)
,p_plug_name=>'Copy Page'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(200892522361238090)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(44737115041960719)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(200892627545238090)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(44737115041960719)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(200892718473238090)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(44737115041960719)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(200893424698238092)
,p_branch_name=>'Go To Page 625'
,p_branch_action=>'f?p=&APP_ID.:625:&SESSION.::&DEBUG.::P625_PREV_PAGE:623&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(200892627545238090)
,p_branch_sequence=>10
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_list_usage_dev',
' where page_id           = :P621_COPY_FROM_PAGE_ID',
'   and flow_id           = :P621_COPY_FROM_FLOW_ID',
'union all',
'-- lists referenced as sublists',
'select 1',
'  from wwv_flow_sublist_usage_dev',
' where page_id           = :P621_COPY_FROM_PAGE_ID',
'   and flow_id           = :P621_COPY_FROM_FLOW_ID'))
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(203827913525737935)
,p_branch_name=>'Go To Page 627'
,p_branch_action=>'f?p=&APP_ID.:627:&SESSION.::&DEBUG.::P627_PREV_PAGE:623'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(200892627545238090)
,p_branch_sequence=>20
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_auth_scheme_usage_dev ',
' where flow_id              = :P621_COPY_FROM_FLOW_ID',
'   and page_id              = :P621_COPY_FROM_PAGE_ID',
'   and authorization_scheme is not null',
'   and replace(translate(authorization_scheme,''1234567890'',''0000000000''),''0'') is null'))
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(208040117889860783)
,p_branch_name=>'Go To Page 593'
,p_branch_action=>'f?p=&APP_ID.:593:&SESSION.::&DEBUG.::P593_PREV_PAGE:623'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_step_branches',
' where flow_id           = :P621_COPY_FROM_FLOW_ID',
'   and flow_step_id      = :P621_COPY_FROM_PAGE_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(203829717335739012)
,p_branch_action=>'f?p=&APP_ID.:628:&SESSION.::&DEBUG.::P628_PREV_PAGE:623'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(200892627545238090)
,p_branch_sequence=>40
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(200893100762238091)
,p_branch_action=>'f?p=&APP_ID.:622:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(200892718473238090)
,p_branch_sequence=>50
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(226843922793547961)
,p_name=>'P623_PREV_PAGE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(226841702582547936)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3301794690465815)
,p_tabular_form_region_id=>wwv_flow_imp.id(3300361705465801)
,p_validation_name=>'Existing LOV must be selected'
,p_validation_sequence=>20
,p_validation=>'NEW_LOV'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Existing list of values must be selected.'
,p_validation_condition=>'COPY_OPTION'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(200892627545238090)
,p_exec_cond_for_each_row=>'Y'
,p_associated_column=>'NEW_LOV'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(614675866933213084)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(200892522361238090)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(614676156919213084)
,p_event_id=>wwv_flow_imp.id(614675866933213084)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3301469564465812)
,p_name=>'Enable/Disable NEW_LOV'
,p_event_sequence=>20
,p_triggering_element_type=>'COLUMN'
,p_triggering_region_id=>wwv_flow_imp.id(3300361705465801)
,p_triggering_element=>'COPY_OPTION'
,p_condition_element_type=>'COLUMN'
,p_condition_element=>'COPY_OPTION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'EXISTING'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3301519006465813)
,p_event_id=>wwv_flow_imp.id(3301469564465812)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'NEW_LOV'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3304111696465839)
,p_event_id=>wwv_flow_imp.id(3301469564465812)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'NEW_LOV'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3301672108465814)
,p_event_id=>wwv_flow_imp.id(3301469564465812)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'NEW_LOV'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3301381184465811)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(3300361705465801)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Copy List of Values - Save Interactive Grid Data'
,p_attribute_01=>'PLSQL_CODE'
,p_attribute_04=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.update_member (',
'    p_collection_name => ''COPY_PAGE_LOV'',',
'    p_seq             => :SEQ_ID,',
'    p_c001            => :COPY_OPTION,',
'    p_n001            => :NEW_LOV,',
'    p_n002            => :OLD_LOV_ID,',
'    p_c002            => :OLD_LOV_NAME,',
'    p_c003            => :LOV_TYPE );'))
,p_attribute_05=>'N'
,p_attribute_06=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(200892627545238090)
,p_internal_uid=>3301381184465811
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1803156436462330)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Initialize Collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_f4000_util.init_lov_collection (',
'    p_collection_name   => ''COPY_PAGE_LOV'',',
'    p_copy_from_flow_id => :P621_COPY_FROM_FLOW_ID,',
'    p_copy_from_page_id => :P621_COPY_FROM_PAGE_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>1803156436462330
);
end;
/
prompt --application/pages/page_00625
begin
wwv_flow_imp_page.create_page(
 p_id=>625
,p_name=>'Copy Page - Lists'
,p_alias=>'COPY-PAGE-LISTS'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Page'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_copy_pg.htm'
,p_page_component_map=>'21'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3301811989465816)
,p_plug_name=>'Copy Lists'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select seq_id, ',
'       c001 copy_option,',
'       n001 new_list,      ',
'       n002 list_id,      ',
'       c002 old_list_name  ',
'  from wwv_flow_collections',
' where collection_name = ''COPY_PAGE_LIST'''))
,p_plug_source_type=>'NATIVE_IG'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Copy Lists'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
,p_plug_header=>'<p>This report displays lists used in the page you are copying from.  Review the report and select a copy option.  If you select <strong>Use Existing</strong>, a list in the current Application must be selected.</p>'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3302079322465818)
,p_name=>'SEQ_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'SEQ_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>30
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3302193708465819)
,p_name=>'COPY_OPTION'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'COPY_OPTION'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Copy Option'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>40
,p_value_alignment=>'LEFT'
,p_is_required=>false
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(201061511357162008)
,p_lov_display_extra=>false
,p_lov_display_null=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3302282181465820)
,p_name=>'NEW_LIST'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'NEW_LIST'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Existing List'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>50
,p_value_alignment=>'LEFT'
,p_is_required=>false
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(158508012343182689)
,p_lov_display_extra=>false
,p_lov_display_null=>true
,p_lov_null_text=>'- Select List -'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3302379693465821)
,p_name=>'LIST_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>60
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3302414720465822)
,p_name=>'OLD_LIST_NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'OLD_LIST_NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'List Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>70
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>true
,p_enable_sort_group=>true
,p_enable_control_break=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3302627875465824)
,p_name=>'APEX$ROW_SELECTOR'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
,p_use_as_row_header=>false
,p_display_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(3301905619465817)
,p_internal_uid=>3301905619465817
,p_is_editable=>true
,p_edit_operations=>'u'
,p_lost_update_check_type=>'VALUES'
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SET'
,p_show_total_row_count=>false
,p_show_toolbar=>false
,p_toolbar_buttons=>null
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>false
,p_define_chart_view=>false
,p_enable_download=>false
,p_download_formats=>null
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(4401274844576043)
,p_interactive_grid_id=>wwv_flow_imp.id(3301905619465817)
,p_static_id=>'44013'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(4401432000576044)
,p_report_id=>wwv_flow_imp.id(4401274844576043)
,p_view_type=>'GRID'
,p_stretch_columns=>true
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(4401909796576050)
,p_view_id=>wwv_flow_imp.id(4401432000576044)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(3302079322465818)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(4402830155576056)
,p_view_id=>wwv_flow_imp.id(4401432000576044)
,p_display_seq=>2
,p_column_id=>wwv_flow_imp.id(3302193708465819)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(4403783077576059)
,p_view_id=>wwv_flow_imp.id(4401432000576044)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(3302282181465820)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(4404620089576062)
,p_view_id=>wwv_flow_imp.id(4401432000576044)
,p_display_seq=>4
,p_column_id=>wwv_flow_imp.id(3302379693465821)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(4405581002576064)
,p_view_id=>wwv_flow_imp.id(4401432000576044)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(3302414720465822)
,p_is_visible=>true
,p_is_frozen=>false
,p_sort_order=>1
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44745812580007335)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(203156023035627146)
,p_plug_name=>'nav'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(202931703979545993)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(226852323407582386)
,p_plug_name=>'Copy Page'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(201352124984500939)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(44745812580007335)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(201352300347500941)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(44745812580007335)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(201352520850500941)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(44745812580007335)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(201353123979500951)
,p_branch_name=>'Go To Page 627'
,p_branch_action=>'f?p=&APP_ID.:627:&SESSION.::&DEBUG.::P627_PREV_PAGE:625&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(201352300347500941)
,p_branch_sequence=>10
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_auth_scheme_usage_dev',
' where flow_id              = :P621_COPY_FROM_FLOW_ID',
'   and page_id              = :P621_COPY_FROM_PAGE_ID',
'   and authorization_scheme is not null',
'   and replace(translate(authorization_scheme,''1234567890'',''0000000000''),''0'') is null'))
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(208041606592866953)
,p_branch_name=>'Go To Page 593'
,p_branch_action=>'f?p=&APP_ID.:593:&SESSION.::&DEBUG.::P593_PREV_PAGE:625'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(201352300347500941)
,p_branch_sequence=>20
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_step_branches',
' where flow_id           = :P621_COPY_FROM_FLOW_ID',
'   and flow_step_id      = :P621_COPY_FROM_PAGE_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(204033930148742716)
,p_branch_action=>'f?p=&APP_ID.:628:&SESSION.::&DEBUG.::P628_PREV_PAGE:625'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(201352300347500941)
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(201352906357500950)
,p_branch_action=>'f?p=&APP_ID.:&P625_PREV_PAGE.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(201352520850500941)
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(204036211925746951)
,p_name=>'P625_PREV_PAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(226852323407582386)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(6300431912095281)
,p_tabular_form_region_id=>wwv_flow_imp.id(3301811989465816)
,p_validation_name=>'Existing List must be selected'
,p_validation_sequence=>20
,p_validation=>'NEW_LIST'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Existing list must be selected.'
,p_validation_condition=>'COPY_OPTION'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(201352300347500941)
,p_exec_cond_for_each_row=>'Y'
,p_associated_column=>'NEW_LIST'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(614675278893209770)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(201352124984500939)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(614675594907209770)
,p_event_id=>wwv_flow_imp.id(614675278893209770)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6800352250188001)
,p_name=>'Enable/Disable NEW_LIST'
,p_event_sequence=>20
,p_triggering_element_type=>'COLUMN'
,p_triggering_region_id=>wwv_flow_imp.id(3301811989465816)
,p_triggering_element=>'COPY_OPTION'
,p_condition_element_type=>'COLUMN'
,p_condition_element=>'COPY_OPTION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'EXISTING'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3304281509465840)
,p_event_id=>wwv_flow_imp.id(6800352250188001)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'NEW_LIST'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6800439766188002)
,p_event_id=>wwv_flow_imp.id(6800352250188001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'NEW_LIST'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6800574768188003)
,p_event_id=>wwv_flow_imp.id(6800352250188001)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'NEW_LIST'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3302752315465825)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(3301811989465816)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Copy Lists - Save Interactive Grid Data'
,p_attribute_01=>'PLSQL_CODE'
,p_attribute_04=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.update_member (',
'    p_collection_name => ''COPY_PAGE_LIST'',',
'    p_seq             => :SEQ_ID,',
'    p_c001            => :COPY_OPTION,',
'    p_n001            => :NEW_LIST,',
'    p_n002            => :LIST_ID,',
'    p_c002            => :OLD_LIST_NAME );'))
,p_attribute_05=>'N'
,p_attribute_06=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(201352300347500941)
,p_internal_uid=>3302752315465825
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4300413057500199)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Initialize Collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_f4000_util.init_list_collection (',
'    p_collection_name   => ''COPY_PAGE_LIST'',',
'    p_copy_from_flow_id => :P621_COPY_FROM_FLOW_ID,',
'    p_copy_from_page_id => :P621_COPY_FROM_PAGE_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>4300413057500199
);
end;
/
prompt --application/pages/page_00627
begin
wwv_flow_imp_page.create_page(
 p_id=>627
,p_name=>'Copy Page - Authorization Schemes'
,p_alias=>'COPY-PAGE-AUTHORIZATION-SCHEMES'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Page'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_copy_pg.htm'
,p_page_component_map=>'21'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3302884252465826)
,p_plug_name=>'Copy Authorization Schemes'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select seq_id,',
'       c001 copy_option,',
'       c002 new_auth,',
'       c003 scheme,',
'       c004 old_auth_name',
'  from wwv_flow_collections',
' where collection_name = ''COPY_PAGE_SECURITY'''))
,p_plug_source_type=>'NATIVE_IG'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Copy Authorization Schemes'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
,p_plug_header=>'<p>This report displays authorization schemes used in the page you are copying from.  Review the report and select a copy option.  If you select <strong>Use Existing</strong>, an authorization scheme in the current Application must be selected.</p>'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3303084312465828)
,p_name=>'SEQ_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'SEQ_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>30
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3303145182465829)
,p_name=>'COPY_OPTION'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'COPY_OPTION'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Copy Option'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>40
,p_value_alignment=>'LEFT'
,p_is_required=>false
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(201061511357162008)
,p_lov_display_extra=>false
,p_lov_display_null=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3303296877465830)
,p_name=>'NEW_AUTH'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'NEW_AUTH'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Existing Authorization'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>50
,p_value_alignment=>'LEFT'
,p_is_required=>false
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(283664112341)
,p_lov_display_extra=>false
,p_lov_display_null=>true
,p_lov_null_text=>'- Select Authorization Scheme -'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3303361461465831)
,p_name=>'SCHEME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'SCHEME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>60
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3303409304465832)
,p_name=>'OLD_AUTH_NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'OLD_AUTH_NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Authorization'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>70
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3303618211465834)
,p_name=>'APEX$ROW_SELECTOR'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
,p_use_as_row_header=>false
,p_display_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(3302999934465827)
,p_internal_uid=>3302999934465827
,p_is_editable=>true
,p_edit_operations=>'u'
,p_lost_update_check_type=>'VALUES'
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SET'
,p_show_total_row_count=>false
,p_show_toolbar=>false
,p_toolbar_buttons=>null
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>false
,p_define_chart_view=>false
,p_enable_download=>false
,p_download_formats=>null
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(7101796502583586)
,p_interactive_grid_id=>wwv_flow_imp.id(3302999934465827)
,p_static_id=>'71018'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(7101900986583586)
,p_report_id=>wwv_flow_imp.id(7101796502583586)
,p_view_type=>'GRID'
,p_stretch_columns=>true
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(7102400849583591)
,p_view_id=>wwv_flow_imp.id(7101900986583586)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(3303084312465828)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(7103283570583595)
,p_view_id=>wwv_flow_imp.id(7101900986583586)
,p_display_seq=>2
,p_column_id=>wwv_flow_imp.id(3303145182465829)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(7104199861583598)
,p_view_id=>wwv_flow_imp.id(7101900986583586)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(3303296877465830)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(7105007753583601)
,p_view_id=>wwv_flow_imp.id(7101900986583586)
,p_display_seq=>4
,p_column_id=>wwv_flow_imp.id(3303361461465831)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(7105940633583604)
,p_view_id=>wwv_flow_imp.id(7101900986583586)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(3303409304465832)
,p_is_visible=>true
,p_is_frozen=>false
,p_sort_order=>1
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44753121977038433)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(203363409660632762)
,p_plug_name=>'nav'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(202931703979545993)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(226858224016601431)
,p_plug_name=>'Copy Page'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(201376430653619703)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(44753121977038433)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(201376618526619704)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(44753121977038433)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(201376823646619704)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(44753121977038433)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(208034521783842920)
,p_branch_name=>'Go To Page 593'
,p_branch_action=>'f?p=&APP_ID.:593:&SESSION.::&DEBUG.::P593_PREV_PAGE:627'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(201376618526619704)
,p_branch_sequence=>10
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_step_branches',
'where flow_id = :P621_COPY_FROM_FLOW_ID',
'and flow_step_id = :P621_COPY_FROM_PAGE_ID',
'and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(201377420061619706)
,p_branch_action=>'f?p=&APP_ID.:628:&SESSION.::&DEBUG.::P628_PREV_PAGE:627&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(201376618526619704)
,p_branch_sequence=>20
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(201377217155619706)
,p_branch_action=>'f?p=&APP_ID.:&P627_PREV_PAGE.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(201376823646619704)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(204037719197749080)
,p_name=>'P627_PREV_PAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(226858224016601431)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(7201326045616848)
,p_tabular_form_region_id=>wwv_flow_imp.id(3302884252465826)
,p_validation_name=>'Existing LOV must be selected'
,p_validation_sequence=>20
,p_validation=>'NEW_AUTH'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Existing Authorization Scheme must be selected.'
,p_validation_condition=>'COPY_OPTION'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(201376618526619704)
,p_exec_cond_for_each_row=>'Y'
,p_associated_column=>'NEW_AUTH'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(614674695380200207)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(201376430653619703)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(614674972722200207)
,p_event_id=>wwv_flow_imp.id(614674695380200207)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3303862189465836)
,p_name=>'Enable/Disable NEW_AUTH'
,p_event_sequence=>20
,p_triggering_element_type=>'COLUMN'
,p_triggering_region_id=>wwv_flow_imp.id(3302884252465826)
,p_triggering_element=>'COPY_OPTION'
,p_condition_element_type=>'COLUMN'
,p_condition_element=>'COPY_OPTION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'EXISTING'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3303994746465837)
,p_event_id=>wwv_flow_imp.id(3303862189465836)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'NEW_AUTH'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3304344294465841)
,p_event_id=>wwv_flow_imp.id(3303862189465836)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'NEW_AUTH'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3304071291465838)
,p_event_id=>wwv_flow_imp.id(3303862189465836)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'NEW_AUTH'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3303713035465835)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(3302884252465826)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Copy Authorization Schemes - Save Interactive Grid Data'
,p_attribute_01=>'PLSQL_CODE'
,p_attribute_04=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.update_member (',
'    p_collection_name => ''COPY_PAGE_SECURITY'',',
'    p_seq             => :SEQ_ID,',
'    p_c001            => :COPY_OPTION,',
'    p_c002            => :NEW_AUTH,',
'    p_c003            => :SCHEME,',
'    p_c004            => :OLD_AUTH_NAME );'))
,p_attribute_05=>'N'
,p_attribute_06=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(201376618526619704)
,p_internal_uid=>3303713035465835
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(7001568715560717)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Initialize Collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_f4000_util.init_authorization_collection (',
'    p_collection_name   => ''COPY_PAGE_SECURITY'',',
'    p_copy_from_flow_id => :P621_COPY_FROM_FLOW_ID,',
'    p_copy_from_page_id => :P621_COPY_FROM_PAGE_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>7001568715560717
);
end;
/
prompt --application/pages/page_00628
begin
wwv_flow_imp_page.create_page(
 p_id=>628
,p_name=>'Copy Page - Confirm'
,p_alias=>'COPY-PAGE-CONFIRM'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Page'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_pgs.htm'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44758727911068532)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(203815402254708276)
,p_plug_name=>'Copy Page Confirmation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wiz_confirm.copy_page_other_app (',
'    p_flow_id_from             => :P621_COPY_FROM_FLOW_ID,',
'    p_page_id_from             => :P621_COPY_FROM_PAGE_ID,    ',
'    p_flow_id_to               => :FB_FLOW_ID,',
'    p_page_id_to               => :P621_COPY_TO_PAGE_ID,',
'    p_page_name_to             => :P621_COPY_TO_PAGE_NAME,',
'    p_navigation_type          => :P621_NAVIGATION_TYPE,',
'    --',
'    p_tab_options              => :P671_TAB_OPTIONS,',
'    p_tab_set                  => :P671_TAB_SET,',
'    p_tab_name                 => :P671_TAB_NAME,',
'    p_tab_label                => :P671_TAB_LABEL,',
'    --',
'    p_nav_list_id              => :P671_NAVLIST_ID,',
'    p_nav_list_parent_item_id  => :P671_NAVLIST_PARENT_ID,',
'    p_nav_list_child_item_name => :P671_NAVLIST_ENTRY_NAME,',
'    --',
'    p_breadcrumb_id            => :P621_BREADCRUMB_ID,',
'    p_breadcrumb_name          => :P621_BREADCRUMB_NAME,',
'    p_parent_breadcrumb        => :P621_PARENT_ID',
'    );'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(203820627331713556)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(202931703979545993)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(203816004651708282)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(44758727911068532)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(203816410327708286)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(44758727911068532)
,p_button_name=>'FINISH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Finish'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(203816214630708286)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(44758727911068532)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1556121670239652352)
,p_branch_name=>'Redirect to Page Designer/Component View'
,p_branch_action=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(203816410327708286)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(203817208428708304)
,p_branch_action=>'&P628_PREV_PAGE.'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(203816214630708286)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(203816618948708288)
,p_name=>'P628_PREV_PAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(203815402254708276)
,p_prompt=>'Prev Page'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(590121308257572049)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(203816004651708282)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(590121467366572050)
,p_event_id=>wwv_flow_imp.id(590121308257572049)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1331045919131583227)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'security'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.init;',
'sys.owa_util.redirect_url(v(''LOGOUT_URL''));',
'wwv_flow.g_unrecoverable_error := true;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(203816410327708286)
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'    from   wwv_flow_developers',
'    where  userid = :FLOW_USER ',
'       and',
'       security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and',
'       security_group_id = ',
'         (select security_group_id from wwv_flows where id=:P621_COPY_FROM_FLOW_ID or :P621_COPY_FROM_FLOW_ID is null)',
'       and',
'       instr(developer_role,''EDIT'') > 0 ',
'       and',
'       (flow_id = :P621_COPY_FROM_FLOW_ID or flow_id is null)  ',
'       and not exists (select 1 from wwv_flows',
'                    where id = :P621_COPY_FROM_FLOW_ID',
'                      and build_status = ''RUN_AND_HIDDEN'')'))
,p_process_when_type=>'NOT_EXISTS'
,p_internal_uid=>1331045919131583227
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(203816820266708299)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'copy page from another app'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_tab_name   varchar2(32767) := null;',
'  l_tab_set    varchar2(32767) := null;',
'  l_tab_text   varchar2(32767) := null;',
'begin',
'  if :P671_TAB_OPTIONS not in (''NO'') then	',
'     l_tab_name := replace(:P671_TAB_NAME,''%''||''null%'',null);',
'     l_tab_set  := replace(:P671_TAB_SET,''%''||''null%'',null);',
'     l_tab_text := :P671_TAB_LABEL;',
'  end if;',
'',
'  wwv_flow_copy_page.copy_from_other_app ( ',
'      p_flow_id_from             => :P621_COPY_FROM_FLOW_ID,   ',
'      p_page_id_from             => :P621_COPY_FROM_PAGE_ID,',
'      p_flow_id_to               => :FB_FLOW_ID,    ',
'      p_page_id_to               => :P621_COPY_TO_PAGE_ID,',
'      p_page_name_to             => :P621_COPY_TO_PAGE_NAME,',
'      --    ',
'      p_breadcrumb_id            => :P621_BREADCRUMB_ID,',
'      p_breadcrumb_name          => :P621_BREADCRUMB_NAME,',
'      p_parent_id                => :P621_PARENT_ID,',
'      --    ',
'      p_tab_set                  => l_tab_set,',
'      p_tab_name                 => l_tab_name,',
'      p_tab_label                => l_tab_text,',
'      --',
'      p_nav_list_id              => :P671_NAVLIST_ID,',
'      p_nav_list_parent_item_id  => :P671_NAVLIST_PARENT_ID,',
'      p_nav_list_child_item_name => :P671_NAVLIST_ENTRY_NAME,',
'      --',
'      p_lov_collection_name      => ''COPY_PAGE_LOV'',',
'      p_auth_collection_name     => ''COPY_PAGE_SECURITY'',',
'      p_branch_collection_name   => ''COPY_PAGE_BRANCH'',',
'      p_list_collection_name     => ''COPY_PAGE_LIST'',',
'      p_template_collection_name => ''COPY_PAGE_TEMPLATES'',',
'      p_copy_public_report       => ( :P621_COPY_PUBLIC_REPORTS = ''Y'' )',
'      );',
'  wwv_flow.update_cache_with_write(''FB_FLOW_PAGE_ID'',:P621_COPY_TO_PAGE_ID);',
'  ',
'  :F4000_RUN_EDIT_PAGE := :P621_COPY_TO_PAGE_ID;',
'  :FB_FLOW_PAGE_ID     := :P621_COPY_TO_PAGE_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying page.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(203816410327708286)
,p_process_success_message=>'Page copied successfully.'
,p_internal_uid=>203816820266708299
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(614669191570188701)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(203816410327708286)
,p_process_when_type=>'NEVER'
,p_process_success_message=>'Page copied successfully.'
,p_internal_uid=>614669191570188701
);
end;
/
prompt --application/pages/page_00631
begin
wwv_flow_imp_page.create_page(
 p_id=>631
,p_name=>'Prerequisites'
,p_alias=>'PREREQUISITES'
,p_step_title=>'Prerequisites'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(24897722063538624)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deployment.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9962502031090128)
,p_plug_name=>'Prerequisites'
,p_region_template_options=>'#DEFAULT#:a-Region--accessibleHeader:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>100
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22522507957428340)
,p_plug_name=>'Supporting Object Definition tabs'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>90
,p_list_id=>wwv_flow_imp.id(22452018965176093)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(24434810845931749)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(24172418538839346)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(34008209680873383)
,p_plug_name=>'Prerequisites'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>93
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(205236700530915015)
,p_plug_name=>'Objects that will be Installed'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>160
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>To avoid errors that may occur during the execution of the installation scripts due to pre-existing objects, we will check for the existence of objects with the names below.  If any of them exist, the install will not proceed and the user will be '
||'provided the details.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(9963004858090139)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(34008209680873383)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(9962827090090138)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(34008209680873383)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P631_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(9962710549090138)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(34008209680873383)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>'P631_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(29812512271400219)
,p_branch_name=>'Go To Page &P567_BRANCH_PAGE.'
,p_branch_action=>'f?p=&APP_ID.:&P567_BRANCH_PAGE.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>21
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'substr(:REQUEST,1,13) = ''APPLY_CHANGES'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(40437524893440060)
,p_branch_action=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(9962827090090138)
,p_branch_sequence=>22
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(9963622858090145)
,p_branch_action=>'f?p=&APP_ID.:631:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9963811782090145)
,p_name=>'P631_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(9962502031090128)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9964224420090154)
,p_name=>'P631_REQUIRED_NAMES_AVAILABLE'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(205236700530915015)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Object Names'
,p_source=>'REQUIRED_NAMES_AVAILABLE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_LIST_MANAGER'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name||'' (''||object_type||'')'' a, object_name b',
'from sys.dba_objects',
'where owner = (select owner from wwv_flows where id = :FB_FLOW_ID and security_group_id = :flow_security_group_id)',
'and object_name not like ''BIN$%''',
'and object_name not like ''DR$%''',
'and object_name not like ''SYS_%''',
'and object_type not in (''INDEX'')',
'order by object_name'))
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the object names that are created by this application''s installation scripts.  Installation is prevented if these objects already exist in the parsing schema.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'FIRST_ROWSET'
,p_attribute_02=>'Y'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9964409471090154)
,p_name=>'P631_REQUIRED_SYS_PRIVS'
,p_item_sequence=>300
,p_item_plug_id=>wwv_flow_imp.id(9962502031090128)
,p_use_cache_before_default=>'NO'
,p_item_default=>'CREATE TABLE:CREATE VIEW:CREATE PROCEDURE:CREATE TRIGGER'
,p_prompt=>'Required System Privileges:'
,p_source=>'REQUIRED_SYS_PRIVS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'REQUIRED SYSTEM PRIVIELGES'
,p_lov=>'.'||wwv_flow_imp.id(38912529512012913)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Identify the system privileges required to install this application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(38900417990952801)
,p_name=>'P631_REQUIRED_FREE_KB'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(9962502031090128)
,p_use_cache_before_default=>'NO'
,p_item_default=>'100'
,p_prompt=>'Required Free Space in KB:'
,p_source=>'REQUIRED_FREE_KB'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identify the freespace required to install this application. On installation, the parsing schema''s default tablespace is checked to ensure that this much space is available.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(29811630495396029)
,p_computation_sequence=>10
,p_computation_item=>'P567_BRANCH_PAGE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'substr(v(''REQUEST''),15)'
,p_compute_when=>'substr(:REQUEST,1,13) = ''APPLY_CHANGES'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(69950717341968699)
,p_computation_sequence=>20
,p_computation_item=>'P631_REQUIRED_FREE_KB'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'nvl(:P631_REQUIRED_FREE_KB,0)'
,p_compute_when=>'P631_REQUIRED_FREE_KB'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(102914229709649152)
,p_computation_sequence=>30
,p_computation_item=>'P631_REQUIRED_NAMES_AVAILABLE'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_names wwv_flow_global.vc_arr2;',
'begin',
'l_names := wwv_flow_utilities.string_to_table2(:P631_REQUIRED_NAMES_AVAILABLE);',
'for i in 1..l_names.count',
'loop',
'  if l_names(i) not like ''"%"'' then',
'    l_names(i) := upper(l_names(i));',
'  end if;',
'end loop;',
'return wwv_flow_utilities.table_to_string2(l_names);',
'end;'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(9984210865144639)
,p_computation_sequence=>10
,p_computation_item=>'P631_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>'select id from wwv_flow_install where flow_id = :fb_flow_id'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(38985023858503327)
,p_validation_name=>'P631_REQUIRED_FREE_KB'
,p_validation_sequence=>10
,p_validation=>'P631_REQUIRED_FREE_KB'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Value must be numeric'
,p_associated_item=>wwv_flow_imp.id(38900417990952801)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(9964618480090155)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_INSTALL'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_INSTALL'
,p_attribute_03=>'P631_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Unable to fetch row.'
,p_internal_uid=>9964618480090155
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(38963010680348186)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate hidden item with object list'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   v varchar2(32767) := null;',
'begin',
'   for i in 1..wwv_flow.g_f01.count loop',
'     if rtrim(ltrim(wwv_flow.g_f01(i))) is not null then',
'         if substr(wwv_flow.g_f01(i),1,1) != ''"'' then',
'             wwv_flow.g_f01(i) := upper(wwv_flow.g_f01(i));',
'         end if;',
'         v := v||ltrim(rtrim(wwv_flow.g_f01(i)))||'':'';',
'     end if;',
'   end loop;',
'   :P631_REQUIRED_NAMES_AVAILABLE := v;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to save list of object names.'
,p_process_when_type=>'NEVER'
,p_internal_uid=>38963010680348186
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(9964829919090156)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_INSTALL'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_INSTALL'
,p_attribute_03=>'P631_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Unable to process row of table WWV_FLOW_INSTALL.'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>9964829919090156
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(9965011083090156)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'631'
,p_internal_uid=>9965011083090156
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(38948503220232456)
,p_process_sequence=>80
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  t wwv_flow_global.vc_arr2;',
'begin',
'',
'  htmldb_collection.create_or_truncate_collection(p_collection_name=>''DBOBJ'');',
'',
'  for c1 in (select REQUIRED_NAMES_AVAILABLE from WWV_FLOW_INSTALL where flow_id = :fb_flow_id)',
'     loop',
'     t := wwv_flow_utilities.string_to_table2(c1.REQUIRED_NAMES_AVAILABLE);',
'    ',
'  end loop;',
'  for i in 1..t.count loop',
'     htmldb_collection.add_member(p_collection_name=>''DBOBJ'',p_c001=>t(i));',
'  end loop;',
'  commit;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_type=>'NEVER'
,p_internal_uid=>38948503220232456
);
end;
/
prompt --application/pages/page_00632
begin
wwv_flow_imp_page.create_page(
 p_id=>632
,p_name=>'Remove All Supporting Objects'
,p_alias=>'REMOVE-ALL-SUPPORTING-OBJECTS'
,p_step_title=>'Remove All Supporting Objects'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(24897722063538624)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deployment.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(10166819887036977)
,p_plug_name=>'Remove All Supporting Objects'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>100
,p_plug_header=>'<p>Are you sure you want to delete installation scripts, messages, and options currently associated with this application?</p>'
,p_plug_footer=>'<p />'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1119157353856390636)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(10167521234036979)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1119157353856390636)
,p_button_name=>'FINISH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Delete All'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(10167405855036979)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1119157353856390636)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(10168010923036981)
,p_branch_action=>'f?p=&APP_ID.:2:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(10167521234036979)
,p_branch_sequence=>21
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(23461726939721383)
,p_name=>'P632_CONFIRM'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(10166819887036977)
,p_prompt=>'Confirm'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select this checkbox to confirm the removal of this application''s supporting objects.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'CONFIRM'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(23464925469739821)
,p_validation_name=>'P632_CONFIRM'
,p_validation_sequence=>10
,p_validation=>'P632_CONFIRM'
,p_validation2=>'CONFIRM'
,p_validation_type=>'ITEM_IN_VALIDATION_EQ_STRING2'
,p_error_message=>'Please confirm the removal of this application''s supporting objects definition.'
,p_when_button_pressed=>wwv_flow_imp.id(10167521234036979)
,p_associated_item=>wwv_flow_imp.id(23461726939721383)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(10172027945057915)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete installer'
,p_process_sql_clob=>'delete from wwv_flow_install where flow_id = :fb_flow_id;'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to delete install definition.'
,p_process_when_button_id=>wwv_flow_imp.id(10167521234036979)
,p_process_success_message=>'Installer Definition Deleted'
,p_internal_uid=>10172027945057915
);
end;
/
prompt --application/pages/page_00633
begin
wwv_flow_imp_page.create_page(
 p_id=>633
,p_name=>'Export Status'
,p_alias=>'EXPORT-STATUS'
,p_step_title=>'Export Status'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(24897722063538624)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deployment.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(10192500937187120)
,p_plug_name=>'Export Status'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>100
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Determine if the deployment attributes will be exported with your application by default. You can override the default setting during export.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22530616877449806)
,p_plug_name=>'Supporting Object Definition tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>90
,p_list_id=>wwv_flow_imp.id(22452018965176093)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(24428124304907263)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(24172418538839346)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(34018430299992830)
,p_plug_name=>'Export'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>95
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(10192800789187121)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(34018430299992830)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(10192725590187121)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(34018430299992830)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'EDIT'
,p_button_condition=>'P633_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(29879809398617034)
,p_branch_name=>'Go To Page &P567_BRANCH_PAGE.'
,p_branch_action=>'f?p=&APP_ID.:&P567_BRANCH_PAGE.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'substr(:REQUEST,1,13) = ''APPLY_CHANGES'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(10193103948187122)
,p_branch_action=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10193330456187123)
,p_name=>'P633_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(10192500937187120)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10193526370187126)
,p_name=>'P633_INCLUDE_IN_EXPORT_YN'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(10192500937187120)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Include Supporting Object Definitions in Export'
,p_source=>'INCLUDE_IN_EXPORT_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'EXPORT_SUP_OBJ_OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(388231942990864305)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The supporting object definitions can be optionally exported with your application. These include all configuration options and scripts.</p>',
'<ul>',
'<li>',
'<strong>Yes</strong> Includes supporting object definitions in the application export. Does not automatically load supporting objects when invoked from a command line.',
'</li>',
'<li>',
'<strong>No</strong> Does not include the supporting object definitions in the export.',
'</li>',
'<li>',
'<strong>Yes and Install on Import Automatically</strong> Includes supporting object definitions and a call to install supporting objects in the application export. This option is valid only for command line installs. When application imports from the'
||' command line, it automatically installs or upgrades the supporting objects.',
'</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(29877832123614117)
,p_computation_sequence=>10
,p_computation_item=>'P567_BRANCH_PAGE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'substr(v(''REQUEST''),15)'
,p_compute_when=>'substr(:REQUEST,1,13) = ''APPLY_CHANGES'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(10196611210195014)
,p_computation_sequence=>10
,p_computation_item=>'P633_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>'select id from wwv_flow_install where flow_id = :fb_flow_id'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(10193712500187129)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_INSTALL'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_INSTALL'
,p_attribute_03=>'P633_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Unable to fetch row.'
,p_internal_uid=>10193712500187129
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(10193905630187132)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_INSTALL'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_INSTALL'
,p_attribute_03=>'P633_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'U'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Unable to process row of table WWV_FLOW_INSTALL.'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>10193905630187132
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(10194128177187132)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'633'
,p_internal_uid=>10194128177187132
);
end;
/
prompt --application/pages/page_00636
begin
wwv_flow_imp_page.create_page(
 p_id=>636
,p_name=>'Copy Template - New Template'
,p_alias=>'COPY-TEMPLATE-NEW-TEMPLATE4'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46420809455675807)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(223170121844454342)
,p_plug_name=>'Copy Breadcrumb Template'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(223170504670454347)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(399849897040726767)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_imp.id(110615031296644849)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(223170722855454347)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(222829818333256486)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':F4000_LAST_VIEW != 4003'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(223171431079454359)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46420809455675807)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(223171626357454362)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(46420809455675807)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy'
,p_button_position=>'CREATE'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(223173401602454396)
,p_branch_name=>'Go To Page 4003'
,p_branch_action=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(223171626357454362)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(223171822244454365)
,p_name=>'P636_FROM_TEMPLATE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(223170121844454342)
,p_prompt=>'From Template'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(223172000285454375)
,p_name=>'P636_TEMPLATE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(223170121844454342)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Template:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select NAME template_name ',
'from WWV_FLOW_MENU_TEMPLATES',
'where id = :P636_FROM_TEMPLATE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the template to be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(223172521342454378)
,p_name=>'P636_TO_TEMPLATE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(223170121844454342)
,p_prompt=>'New Template Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the name of the new template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1004724568137877709)
,p_name=>'P636_TO_INTERNAL_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(223170121844454342)
,p_prompt=>'New Template Identifier'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the name of the new template identifier.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(223173019610454385)
,p_validation_name=>'P636_TO_TEMPLATE_NAME'
,p_validation_sequence=>10
,p_validation=>'P636_TO_TEMPLATE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Template name must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(223171626357454362)
,p_associated_item=>wwv_flow_imp.id(223172521342454378)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1004724645615877710)
,p_validation_name=>'P636_TO_INTERNAL_NAME'
,p_validation_sequence=>20
,p_validation=>'P636_TO_INTERNAL_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Template identifier must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(223171626357454362)
,p_associated_item=>wwv_flow_imp.id(1004724568137877709)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1004724917422877713)
,p_validation_name=>'unique template name'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin ',
'    for c1 in (',
'        select theme_id',
'          from wwv_flow_menu_templates ',
'         where id = :P636_FROM_TEMPLATE_ID',
'           and flow_id = :fb_flow_id',
'           and security_group_id = wwv_flow_security.g_security_group_id',
'    ) loop',
'        for c2 in (',
'           select 1',
'             from wwv_flow_menu_templates',
'            where name = :P636_TO_TEMPLATE_NAME',
'              and theme_id = c1.theme_id',
'              and flow_id = :fb_flow_id',
'              and security_group_id = wwv_flow_security.g_security_group_id',
'        ) loop',
'            return false;',
'        end loop;',
'',
'    end loop;        ',
'',
'    return true;',
'',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Template name must be unique'
,p_associated_item=>wwv_flow_imp.id(223172521342454378)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1004725084693877714)
,p_validation_name=>'unique internal name'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin ',
'    for c1 in (',
'        select theme_id',
'          from wwv_flow_menu_templates ',
'         where id = :P636_FROM_TEMPLATE_ID',
'           and flow_id = :fb_flow_id',
'           and security_group_id = wwv_flow_security.g_security_group_id',
'    ) loop',
'        for c2 in (',
'           select 1',
'             from wwv_flow_menu_templates',
'            where internal_name = :P636_TO_INTERNAL_NAME',
'              and theme_id = c1.theme_id',
'              and flow_id = :fb_flow_id',
'              and security_group_id = wwv_flow_security.g_security_group_id',
'        ) loop',
'            return false;',
'        end loop;',
'',
'    end loop;        ',
'',
'    return true;',
'',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Template name must be unique'
,p_associated_item=>wwv_flow_imp.id(1004724568137877709)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(614719636571684667)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(223171431079454359)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(614719931228684667)
,p_event_id=>wwv_flow_imp.id(614719636571684667)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1004724704051877711)
,p_name=>'set internal name'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P636_TO_TEMPLATE_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1004724832203877712)
,p_event_id=>wwv_flow_imp.id(1004724704051877711)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P636_TO_INTERNAL_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$x(''P636_TO_TEMPLATE_NAME'').value.toUpperCase().replace(/\s+/g, ''_'');'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(223173230475454392)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Breadcrumb Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select theme_id from WWV_FLOW_MENU_TEMPLATES where id = :P636_FROM_TEMPLATE_ID and flow_id = :fb_flow_id) loop',
'   wwv_flow_templates_util.copy_menu_template(',
'      p_copy_from_flow_id   => :fb_flow_id,',
'      p_flow_id             => :fb_flow_id,',
'      p_from_template_id    => :P636_FROM_TEMPLATE_ID,',
'      p_to_template_name    => :P636_TO_TEMPLATE_NAME,',
'      p_to_internal_name    => :P636_TO_INTERNAL_NAME,',
'      p_to_template_id      => wwv_flow.GET_UNIQUE_ID,',
'      p_to_theme_id         => c1.theme_id,',
'      p_include_subscription  =>false ',
'      );',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Template was not copied successfully.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(223171626357454362)
,p_process_success_message=>'Template Copied'
,p_internal_uid=>223173230475454392
);
end;
/
prompt --application/pages/page_00637
begin
wwv_flow_imp_page.create_page(
 p_id=>637
,p_name=>'Export Page'
,p_alias=>'EXPORT-PAGE1'
,p_page_mode=>'MODAL'
,p_step_title=>'Export Page'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_chained=>'N'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5631835412882828)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(69618312989025068)
,p_plug_name=>'Export Settings'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(143900367183421704)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(5631835412882828)
,p_button_name=>'EXPORT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Export'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5631910352882829)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(5631835412882828)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2603180820794338)
,p_name=>'P637_INCLUDE_READABLE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(69618312989025068)
,p_item_default=>'N'
,p_prompt=>'Include Readable Format'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify whether the export file should include the human-readable (YAML) version of the page meta-data.',
'Use it to identify and review differences between versions of a page when checked into a Version Control System.',
'Available options include:',
'<p />',
'<ul>',
'<li><strong>On</strong> includes the human-readable file.</li>',
'<li><strong>Off</strong> excludes the human-readable file.</li>',
'</ul>',
'<p />'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3806098399471222)
,p_name=>'P637_SPLIT'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(69618312989025068)
,p_item_default=>'N'
,p_prompt=>'Split into Multiple Files'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select this option to export separate SQL files for the page, shared components, and so forth.',
'Available options include:',
'<p />',
'<ul>',
'<li><strong>On</strong> to export as a ZIP archive with separate SQL files.</li>',
'<li><strong>Off</strong> to export as a single SQL file for the page.</li>',
'</ul>',
'<p />'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3806193046471223)
,p_name=>'P637_ORIGINAL_IDS'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(69618312989025068)
,p_item_default=>'N'
,p_prompt=>'Original IDs'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify whether the export file should contain the application component IDs as of now or as of the last import of this application. Available options include:',
'<p />',
'<ul>',
'<li><strong>On</strong> includes the IDs as of the last import.</li>',
'<li><strong>Off</strong> includes the current IDs of the components.</li>',
'</ul>',
'<p />',
'<p />',
'Using Original IDs can be beneficial for various purposes, including:',
'<p />',
'<ul>',
'<li><strong>Readable Format:</strong> Simplify comparisons between different versions of app components and pages. Minimize changes to version controlled export files.</li>',
'<li><strong>Shared Component Subscriptions:</strong> Ensure subscribed components stay linked to a source app when it is replaced with an updated version.</li>',
'</ul>',
'<p />'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5936730925508030)
,p_name=>'P637_AUDIT_INFO'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(69618312989025068)
,p_item_default=>'NONE'
,p_prompt=>'Audit Information'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'AUDIT INFO DETAIL'
,p_lov=>'.'||wwv_flow_imp.id(1726678227351632)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'None'
,p_lov_null_value=>'NONE'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the Audit Information to include in the export file. ',
'Audit information includes the Created By User, Created On Date, Changed By User and Changed On Date.<ul> ',
'<li>By default, no audit information is included.</li>',
'<li>Choose Names and Dates to include all audit information.</li>',
'<li>Choose Dates Only to include date information and exclude user details.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9055443094391187)
,p_name=>'P637_MPAGE_FILE_CHARSET'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(69618312989025068)
,p_prompt=>'File Character Set'
,p_source=>'return lower(trim(sys.owa_util.get_cgi_env(''REQUEST_IANA_CHARSET'')));'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'I18N_IANA_CHARSET'
,p_lov=>'.'||wwv_flow_imp.id(144796827445692396)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the character set in which the export file will be encoded.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9055725713391189)
,p_name=>'P637_INCLUDE_SQL'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(69618312989025068)
,p_item_default=>'Y'
,p_prompt=>'Include Installable SQL File'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify whether the export file should include the installable SQL file for the page.',
'Available options include:',
'<p />',
'<ul>',
'<li><strong>On</strong> includes the installable SQL file.</li>',
'<li><strong>Off</strong> excludes the installable SQL file.</li>',
'</ul>',
'<p />'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9055767435391190)
,p_name=>'P637_FLASHBACK_MIN_AGO'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(69618312989025068)
,p_prompt=>'As of'
,p_post_element_text=>'<span class="fielddata">minutes ago</span>'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>4
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Specify a time in minutes to go to back to for your export. This option enables you to go back in time in your application, perhaps to get back a deleted object.</div>',
'',
'<div class="htmldbInfoBodyP">This utility uses the <code>dbms_flashback</code> package. The timestamp to SCN (system change number) mapping is refreshed approximately every 5 minutes, so you may have to wait that long to get to the version you are lo'
||'oking for. The time undo information is retained by the startup parameter <code>undo_retention</code> (default 3 hrs), but this only influences the size of the undo tablespace.</div>',
'<div class="htmldbInfoBodyP">While two databases may have the same <code>undo_retention</code> parameter, you can go back much further in time on the database with less transactions since the transactions are not filling the undo tablespace, forcing '
||'older data to be archived.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(69623952396050739)
,p_name=>'P637_MEXPORT_PAGE_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(69618312989025068)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_PAGE_ID.'
,p_prompt=>'Page'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LIST PAGES ESCAPED'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id || '' '' || wwv_flow_escape.html( name ) n, id',
'  from wwv_flow_steps',
' where flow_id           = nvl( :FB_FLOW_ID, :P164_APPLICATION )',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and is_page_pattern   = ''N''',
' order by 2'))
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'The page you wish to export.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(5632365677882833)
,p_computation_sequence=>10
,p_computation_item=>'FB_FLOW_PAGE_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare p number := 1;',
'begin',
'if wwv_flow.g_request = ''PREVIOUS'' then',
'  select max(id) into p from wwv_flow_steps where id < :FB_FLOW_PAGE_ID',
'  and flow_id = :FB_FLOW_ID;',
'  return p;',
'elsif wwv_flow.g_request = ''NEXT'' then',
'  select min(id) into p from wwv_flow_steps where id > :FB_FLOW_PAGE_ID',
'  and flow_id = :FB_FLOW_ID;',
'  return p;',
'end if;',
'end;'))
,p_compute_when=>'NEXT,PREVIOUS'
,p_compute_when_type=>'REQUEST_IN_CONDITION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3806716250471229)
,p_validation_name=>'must include something to export'
,p_validation_sequence=>10
,p_validation=>'''Y'' in (:P637_INCLUDE_SQL, :P637_INCLUDE_READABLE)'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Export must include at least either the Installable SQL File or the Readable Format.'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5632037022882830)
,p_name=>'on click Cancel'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(5631910352882829)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5632172691882831)
,p_event_id=>wwv_flow_imp.id(5632037022882830)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(143900470839421705)
,p_name=>'on click Export'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(143900367183421704)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
,p_da_event_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Note: there was a Close Dialog event on this button but if the download takes more than half a second, it was effectively cancelling the download and the client got no file.',
'Instead, I''ve added a CLOSE button, shown after the download has been requested.'))
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(143900515853421706)
,p_event_id=>wwv_flow_imp.id(143900470839421705)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_name=>'submit EXPORT (start download)'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'EXPORT'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3806250424471224)
,p_name=>'installable SQL = Y'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P637_INCLUDE_SQL'
,p_condition_element=>'P637_INCLUDE_SQL'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3806330319471225)
,p_event_id=>wwv_flow_imp.id(3806250424471224)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'show Split'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P637_SPLIT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3806420215471226)
,p_event_id=>wwv_flow_imp.id(3806250424471224)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'hide Split'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P637_SPLIT'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3806574031471227)
,p_name=>'readable = Y'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P637_INCLUDE_READABLE'
,p_condition_element=>'P637_INCLUDE_READABLE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3806610266471228)
,p_event_id=>wwv_flow_imp.id(3806574031471227)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_name=>'Original IDs := Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P637_ORIGINAL_IDS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5631321464882823)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Export Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_export_dev.export_page (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_page_id           => :P637_MEXPORT_PAGE_ID,',
'    p_include_sql       => :P637_INCLUDE_SQL = ''Y'',',
'    p_include_readable  => :P637_INCLUDE_READABLE = ''Y'',',
'    p_split             => :P637_SPLIT = ''Y'' and :P637_INCLUDE_SQL = ''Y'',',
'    p_with_original_ids => :P637_ORIGINAL_IDS = ''Y'',',
'    p_flashback_min_ago => :P637_FLASHBACK_MIN_AGO, ',
'    p_with_audit_info   => :P637_AUDIT_INFO );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error exporting page.'
,p_process_when_button_id=>wwv_flow_imp.id(143900367183421704)
,p_process_when=>'EXPORT'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'Page exported.'
,p_internal_uid=>5631321464882823
);
end;
/
prompt --application/pages/page_00638
begin
wwv_flow_imp_page.create_page(
 p_id=>638
,p_name=>'Cached Pages'
,p_alias=>'CACHED-PAGES'
,p_step_title=>'Cached Pages'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213220627333807318)
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(450364024461818534)
,p_plug_name=>'Pages'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<input type="checkbox" name="f01" value="''||p.id||''" title="''||wwv_flow_lang.system_message(''SELECT_ROW_C'', wwv_flow_escape.html(p.name))||''" />'' cb,',
'       :FB_FLOW_ID application,',
'       p.id, p.name, ',
'       c.LANGUAGE,',
'       c.CACHED_ON,',
'       p.cache_timeout_seconds, ',
'       round((sysdate - c.cached_on) * 3600 * 24,0) cache_age_in_seconds, ',
'       p.CACHE_TIMEOUT_SECONDS - ',
'          round((sysdate - c.cached_on) * 3600 * 24,0) max_age_in_seconds,',
'       decode(greatest((sysdate - c.cached_on) * 3600 * ',
'          24,p.CACHE_TIMEOUT_SECONDS),',
'          p.CACHE_TIMEOUT_SECONDS,m.Unexpired,m.Expired) cache_status,',
'       p.cache_mode, ',
'       decode(p.cache_when_condition_type,null,null,',
'          ''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'') cache_when_condition_type,',
'       sys.dbms_lob.getlength(c.PAGE_TEXT) page_size',
'  from WWV_FLOW_PAGE_CACHE c,',
'       wwv_flow_steps p,',
'(select',
'   wwv_flow_lang.system_message(''F4500_P2610_EXPIRED'') expired,',
'   wwv_flow_lang.system_message(''UNEXPIRED'') unexpired',
' from dual) m',
' where c.flow_id = :fb_flow_id',
'   and c.flow_id = p.flow_id',
'   and c.page_id = p.id',
'   and p.security_group_id = :flow_security_group_id',
'   and p.cache_mode <> ''NOCACHE'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(450364124712818534)
,p_name=>'Pages'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(450364308749818538)
,p_db_column_name=>'CB'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(450364414883818539)
,p_db_column_name=>'APPLICATION'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Application'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(450364516079818540)
,p_db_column_name=>'ID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Page'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#ID#'
,p_column_linktext=>'#ID#'
,p_column_type=>'NUMBER'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(450364618625818541)
,p_db_column_name=>'NAME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Page Name'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(450364818432818543)
,p_db_column_name=>'CACHE_TIMEOUT_SECONDS'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Timeout'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(450365024132818545)
,p_db_column_name=>'CACHE_WHEN_CONDITION_TYPE'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Conditional'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(450384024944934367)
,p_db_column_name=>'PAGE_SIZE'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Page Size'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(450388428501992168)
,p_db_column_name=>'LANGUAGE'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Language'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(450388621964992170)
,p_db_column_name=>'CACHED_ON'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Cached On'
,p_column_type=>'DATE'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(450398311372100663)
,p_db_column_name=>'CACHE_AGE_IN_SECONDS'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Cache Age'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(450398405692100664)
,p_db_column_name=>'MAX_AGE_IN_SECONDS'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'Max Age'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(450398510618100665)
,p_db_column_name=>'CACHE_STATUS'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Cache Status'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(672347912160250209)
,p_db_column_name=>'CACHE_MODE'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Cache Mode'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_imp.id(22602312173782467)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(450366702032823642)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1289926726536644'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'CB:APPLICATION:ID:NAME:LANGUAGE:PAGE_SIZE:CACHED_ON:CACHE_AGE_IN_SECONDS:CACHE_TIMEOUT_SECONDS:CACHE_STATUS:CACHE_WHEN_CONDITION_TYPE:CACHE_MODE'
,p_sort_column_1=>'ID'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(450368313937836519)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(450364024461818534)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:638:&SESSION.:RIR:&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(49295704055343012)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(450364024461818534)
,p_button_name=>'PURGE_EXPIRED'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Purge Expired'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(89572211986421497)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(450364024461818534)
,p_button_name=>'PURGE_CHECKED'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Purge Checked'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(225838030129269061)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(450364024461818534)
,p_button_name=>'PURGE_CACHE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Purge All'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(223952828999646839)
,p_branch_action=>'f?p=&APP_ID.:638:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1199173766685878413)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(450364024461818534)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1199173823733878414)
,p_event_id=>wwv_flow_imp.id(1199173766685878413)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(225840131776288464)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'purge cache'
,p_process_sql_clob=>'wwv_flow_page_cache_api.purge_by_application(p_application=>:fb_flow_id);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to purge cached pages.'
,p_process_when_button_id=>wwv_flow_imp.id(225838030129269061)
,p_process_success_message=>'Cached pages purged.'
,p_internal_uid=>225840131776288464
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(49297622063348213)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'purge expired'
,p_process_sql_clob=>'wwv_flow_page_cache_api.purge_stale(p_application=>:fb_flow_id);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to purge expired pages'
,p_process_when_button_id=>wwv_flow_imp.id(49295704055343012)
,p_process_success_message=>'Expired Pages Purged'
,p_internal_uid=>49297622063348213
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(89575629086435930)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Purge Checked'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for j in 1..wwv_flow.g_f01.count loop',
'    wwv_flow_page_cache_api.purge_by_page (',
'        p_application => :fb_flow_id,',
'        p_page => wwv_flow.g_f01(j));',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to purge pages'
,p_process_when_button_id=>wwv_flow_imp.id(89572211986421497)
,p_process_when=>'wwv_flow.g_f01.count > 0'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Pages Purged'
,p_internal_uid=>89575629086435930
);
end;
/
prompt --application/pages/page_00643
begin
wwv_flow_imp_page.create_page(
 p_id=>643
,p_name=>'Tabs'
,p_alias=>'TABS'
,p_step_title=>'Tabs'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<style type="text/css" media="screen"> ',
'',
'.tab-structure {',
'	margin: 0;',
'}',
'',
'.tab-structure ul {',
'	margin: 0;',
'	list-style: none;',
'}',
'',
'.tab-structure li {',
'	list-style: none;',
'}',
'',
'.tab-structure .tabset-item {',
'	float: left;',
'	display: block;',
'	clear: both;',
'	-moz-border-radius: 10px;',
'	-webkit-border-radius: 10px;',
'	background-color: #efefef;',
'	border: 1px solid #aaaaaa;',
'	font-size: 12px;',
'	line-height: 16px;',
'	margin: 8px 0;',
'	padding: 12px 0;',
'	min-width: 800px;',
'}',
'',
'.tab-structure .tabset-name {',
'	font-size: 16px;',
'	padding: 12px;',
'}',
'',
'.tab-structure .tabset-name b {',
'	font-size: 16px;',
'}',
'',
'.tab-structure .tab-item {',
'	float: left;',
'	display: block;',
'	clear: both;',
'	width: 100%;',
'	border-bottom: 1px solid #aaaaaa;',
'}',
'',
'.tab-structure .tab-item-last {',
'	float: left;',
'	display: block;',
'	clear: both;',
'	width: 100%;',
'	background-color: #efefef;',
'	margin: -1px 0 0 0;',
'}',
'',
'.tab-structure .tab-item-name {',
'	-moz-border-radius: 4px;',
'	-webkit-border-radius: 4px;',
'	background-color: #566687;',
'	border: 1px solid #2B323F;',
'	color: #FFFFFF;',
'	display: block;',
'	float: left;',
'	font-size: 14px;',
'	font-weight: bold;',
'	line-height: 18px;',
'	margin: 8px 12px 8px 12px;',
'	padding: 8px;',
'	width: 240px;',
'	overflow: none;',
'}',
'',
'.tab-structure .tab-item-name a {',
'	color: #FFFFFF;',
'	font-size: 14px;',
'	font-weight: bold;',
'}',
'',
'.tab-structure .tab-item-name a:hover {',
'	text-decoration: underline;',
'}',
'',
'.tab-structure .tab-item li {',
'	float: left;',
'	display: block;',
'	clear: both;',
'	margin: 4px 12px 4px 12px;',
'	line-height: 20px;',
'	background: url(#IMAGE_PREFIX#htmldb/icons/small_page.gif) no-repeat;',
'}',
'',
'.tab-structure .tab-item li span {',
'	padding-left: 24px;',
'}',
'',
'</style>'))
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46241429639678975)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(450481125832473824)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_list_id=>wwv_flow_imp.id(5297709875)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(450481508995478483)
,p_plug_name=>'Tabs'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_04'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(450482224363492350)
,p_name=>'Overview'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>180
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_display_point=>'REGION_POSITION_03'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P643b */ id,',
'       name,',
'       trim(to_char((',
'         select count(*) from wwv_flow_steps where flow_id = f.id),',
'         ''999G999G990'')) pages,',
'       (select count(*) ',
'        from wwv_flow_steps ',
'        where flow_id = f.id and TAB_SET is not null) pages_with_tabs,',
'       (select count(distinct tab_set) ',
'        from wwv_flow_steps ',
'        where flow_id = f.id and TAB_SET is not null) standard_tab_sets',
'from wwv_flows f',
'where id = :fb_flow_id and security_group_id = :flow_security_group_id'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(1041645860037406591)
,p_query_num_rows=>7
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No data found.'
,p_query_row_count_max=>7
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(450482412919492354)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(450482517310492355)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Application'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(450482631078492355)
,p_query_column_id=>3
,p_column_alias=>'PAGES'
,p_column_display_sequence=>3
,p_column_heading=>'Pages'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(452395519820632941)
,p_query_column_id=>4
,p_column_alias=>'PAGES_WITH_TABS'
,p_column_display_sequence=>4
,p_column_heading=>'Pages With Tabs'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(452396200127655616)
,p_query_column_id=>5
,p_column_alias=>'STANDARD_TAB_SETS'
,p_column_display_sequence=>5
,p_column_heading=>'Standard Tab Sets'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(454853911528009195)
,p_plug_name=>'About Tabs'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>130
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>An application can have pages with no tabs, one level of tabs, and two levels of tabs.</p>',
'<p><strong>Standard tabs</strong> enable you to display only one level of tabs. If you want to display two levels of tabs define both <strong>Parent tabs</strong> and <strong>Standard tabs</strong>.</p>',
''))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(454861110760103560)
,p_plug_name=>'Tab Sets'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>160
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'Tabs are grouped in collections called a tab set. Each tab must be part of a tab set. A standard tab can have a one-to-one relationship with a page, or a standard tab can be the "current tab" for a number of pages.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(454923029684875386)
,p_plug_name=>'Tabs'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(452396911340668339)
,p_plug_name=>'Tab Edit'
,p_parent_plug_id=>wwv_flow_imp.id(454923029684875386)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>60
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_4000_ui.show_tabs (',
'	p_application_id  => :fb_flow_id,',
'	p_security_group_id => :flow_security_group_id,',
'	p_session_id  => :app_session,',
'	p_parent_tabset => :P643_PARENT_TAB);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(455256204560571702)
,p_plug_name=>'Tab Search'
,p_parent_plug_id=>wwv_flow_imp.id(454923029684875386)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(455351729241335775)
,p_plug_name=>'Pages with no tabs'
,p_parent_plug_id=>wwv_flow_imp.id(454923029684875386)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>110
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   c number := 0;',
'begin',
'sys.htp.p(''<p><strong>''||wwv_flow_lang.system_message(''F4000_P643_PAGE_NO_TAB'')||'': ''||''</strong></p>'');',
'for c1 in (select id from wwv_flow_steps where security_group_id = :flow_security_group_id and flow_id = :fb_flow_id and tab_set is null and id != 0 order by 1) loop',
'    c := c + 1;',
'    if c < 51 then',
'    if c > 1 then',
'       sys.htp.prn('', ''||c1.id);',
'    else',
'       sys.htp.prn(c1.id);',
'    end if;',
'    end if;',
'end loop;',
'if c > 50 then',
'   sys.htp.prn(''...'');',
'   sys.htp.p(''<p>''||wwv_flow_lang.system_message(''F4000_P643_PAGE_NO_TAB_TTL'',to_char(c,''999G990''))||''</p>'');',
'end if;',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(455408006184290313)
,p_plug_name=>'Legend'
,p_parent_plug_id=>wwv_flow_imp.id(454923029684875386)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>70
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<p><strong>''||wwv_flow_lang.system_message(''F4000_P643_TAB_DISPLAY'')||''</strong>:</p>'');',
'sys.htp.p(''<ul>'');',
'sys.htp.p(''<li>''||''1 - ''||wwv_flow_lang.system_message(''F4000_P643_ONE_LVL'')||''</li>'');',
'sys.htp.p(''<li>''||''2 - ''||wwv_flow_lang.system_message(''F4000_P643_TWO_LVL'')||''</li>'');',
'sys.htp.p(''<li>''||''0 - ''||wwv_flow_lang.system_message(''F4000_P643_NO_TAB'')||''</li>'');',
'sys.htp.p(''<li>''||''* - ''||wwv_flow_lang.system_message(''F4000_P643_NO_PARENT'')||''</li>'');',
'sys.htp.p(''</ul>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(492143803418756709)
,p_plug_name=>'No tabs defined'
,p_parent_plug_id=>wwv_flow_imp.id(454923029684875386)
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>45
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'sys.htp.p(''<p>''||wwv_flow_lang.system_message(''NO_TABS_DEFINED'')||''</p>'');'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NOT_EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from WWV_FLOW_TABS',
'where flow_id = :fb_flow_id ',
'    and security_group_id = :flow_security_group_id'))
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(492147327790773200)
,p_plug_name=>'Tab Summary'
,p_parent_plug_id=>wwv_flow_imp.id(454923029684875386)
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>46
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  t number;',
'  pt number;',
'  ts number;',
'begin',
'  select count(*) into t from wwv_flow_tabs where security_group_id = :flow_security_group_id and flow_id = :fb_flow_id;',
'  select count(distinct tab_set) into ts from wwv_flow_tabs where security_group_id = :flow_security_group_id and flow_id = :fb_flow_id;',
'  select count(*) into pt from wwv_flow_toplevel_tabs where security_group_id = :flow_security_group_id and flow_id = :fb_flow_id;',
'sys.htp.p(''<p>''||wwv_flow_lang.system_message(',
'    ''DEFINED_TABS'',',
'    ''<a href="f?p=4000:123:''||:app_session||'':">''||to_char(t)||''</a>'',',
'    ts,',
'    ''<a href="f?p=4000:331:''||:app_session||'':">''||to_char(pt)||''</a>'')||''</p>'');',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from WWV_FLOW_TABS',
'where flow_id = :fb_flow_id ',
'    and security_group_id = :flow_security_group_id'))
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(454924416141918771)
,p_plug_name=>'Tab Display'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(454875603791440963)
,p_plug_name=>'Standard Tab Display'
,p_parent_plug_id=>wwv_flow_imp.id(454924416141918771)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>80
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_imp.id(454874132315440955)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(492140130336707768)
,p_plug_header=>'<p>A standard tab will display on a page if all of the following conditions are true.</p>'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(455042811664478946)
,p_plug_name=>'Parent Tab Display'
,p_parent_plug_id=>wwv_flow_imp.id(454924416141918771)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>90
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_imp.id(455042113172478942)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(492140130336707768)
,p_plug_header=>'<p>A parent tab will display on a page if all of the following conditions are true.</p>'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(454927020137033454)
,p_plug_name=>'Standard Tabs'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>140
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'Each standard tab is identified with one or more pages.  Each standard tab also defines a tab set.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(454928204169076179)
,p_name=>'Page Templates'
,p_template=>wwv_flow_imp.id(689970285456172024)
,p_display_sequence=>120
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P643a */ id, NAME, ',
'    decode(',
'        nvl(sys.dbms_lob.instr(box,''#TAB_CELLS#''),0), 0, m.n, m.y)',
'        supports_standard_tabs, ',
'    decode(',
'        nvl(sys.dbms_lob.instr(box,''#PARENT_TAB_CELLS#''),0), 0, m.n, m.y)',
'        Supports_parent_tabs,',
'    (select t.theme_id||''. ''||theme_name tn ',
'     from wwv_flow_themes x',
'     where x.flow_id = :fb_flow_id and t.theme_id= x.theme_id) theme_id,',
'    THEME_CLASS_ID class_id',
'from wwv_flow_templates t,',
'  (select wwv_flow_lang.system_message(''YES'') y,',
'            wwv_flow_lang.system_message(''NO'') n',
'   from dual) m',
'where security_group_id = :flow_security_group_id and',
'    flow_id = :fb_flow_id',
'order by 1'))
,p_footer=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>A page template will display <strong>Standard Tabs</strong> if the page template <strong>Template Body</strong> attribute includes the <strong>#TAB_CELLS#</strong> substitution string.</p>',
'',
'<p>A page template will display <strong>Parent Tabs</strong> if the page template <strong>Template Body</strong> attribute includes the <strong>#PARENT_TAB_CELLS#</strong> substitution string.</p>'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No Page Templates defined.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(454930426595101515)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(454928520697076183)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Page Template Name'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:4307:&SESSION.::&DEBUG.:4307:F4000_P4307_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(454930531456101516)
,p_query_column_id=>3
,p_column_alias=>'SUPPORTS_STANDARD_TABS'
,p_column_display_sequence=>3
,p_column_heading=>'Supports Standard Tabs'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(454936101857283579)
,p_query_column_id=>4
,p_column_alias=>'SUPPORTS_PARENT_TABS'
,p_column_display_sequence=>4
,p_column_heading=>'Supports Parent Tabs'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(454928721847076184)
,p_query_column_id=>5
,p_column_alias=>'THEME_ID'
,p_column_display_sequence=>5
,p_column_heading=>'Theme'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(454937512771324601)
,p_query_column_id=>6
,p_column_alias=>'CLASS_ID'
,p_column_display_sequence=>6
,p_column_heading=>'Template Class'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(41972431732112027)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(454936915279306395)
,p_plug_name=>'Lists'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>170
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'As an alternative to tabs, you can use lists to display tab controls.  List templates provide greater control over HTML generation.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(455063002164731164)
,p_plug_name=>'Parent Tabs'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>150
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'Parent tabs can control the display of standard tab sets.  Clicking a parent tab will display the corresponding standard tab, with the default page as the current page.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(455255631656560602)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(455256204560571702)
,p_button_name=>'P643_SET'
,p_button_static_id=>'P643_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Set'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from WWV_FLOW_TABS',
'where flow_id = :fb_flow_id ',
'    and security_group_id = :flow_security_group_id',
'    and TAB_PARENT_TABSET is not null'))
,p_button_condition_type=>'EXISTS'
,p_request_source=>'SET'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(454860614785095226)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(450481508995478483)
,p_button_name=>'CREATE_TAB'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Manage Tabs'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:9000:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(455243110523478875)
,p_name=>'P643_PARENT_TAB'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(455256204560571702)
,p_item_default=>'0'
,p_prompt=>'Parent Tab Set'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(d,null,''No Parent Tab Set Defined'',d) d, decode(d,null,''No Parent Tab Set Defined'',r) r',
'from (',
'select distinct TAB_PARENT_TABSET d, TAB_PARENT_TABSET r',
'from WWV_FLOW_TABS',
'where flow_id = :fb_flow_id ',
'    and security_group_id = :flow_security_group_id',
'    order by 1',
')'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Display All -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from WWV_FLOW_TABS',
'where flow_id = :fb_flow_id ',
'    and security_group_id = :flow_security_group_id',
'    and TAB_PARENT_TABSET is not null'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identify a parent tab set to limit this report to only tabs under the selected parent tab.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(454851716460991675)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'643'
);
end;
/
prompt --application/pages/page_00645
begin
wwv_flow_imp_page.create_page(
 p_id=>645
,p_name=>'Copy Process - Process Options'
,p_alias=>'COPY-PROCESS-PROCESS-OPTIONS'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Process'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_pg_procs.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(45409930519933332)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(227736926634696958)
,p_plug_name=>'Copy Process'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(227770125567964432)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(227766223920945009)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(227779306745025252)
,p_name=>'Target Page Processes'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select process_name,',
'       process_sequence,',
'       wwv_flow_region_layout.get_process_type_desc(flow_id, process_type) as process_type,',
'       process_point',
'from wwv_flow_step_processing',
'where flow_step_id = :P590_COPY_TO_PAGE',
'and flow_id = :fb_flow_id  ',
'and security_group_id = :flow_security_group_id',
''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'There are currently no processes defined on the target page.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(227782802290052363)
,p_query_column_id=>1
,p_column_alias=>'PROCESS_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(227782920366052364)
,p_query_column_id=>2
,p_column_alias=>'PROCESS_SEQUENCE'
,p_column_display_sequence=>1
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(227783026256052364)
,p_query_column_id=>3
,p_column_alias=>'PROCESS_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Type'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(227783118217052364)
,p_query_column_id=>4
,p_column_alias=>'PROCESS_POINT'
,p_column_display_sequence=>4
,p_column_heading=>'Process Point'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(842344044)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(227737802879696972)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(45409930519933332)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(227738024960696973)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(45409930519933332)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(227772707822978236)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(45409930519933332)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(227741024772696994)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(614622805028025586)
,p_branch_action=>'f?p=&APP_ID.:590:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(227772707822978236)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7770918597645303)
,p_name=>'P645_REGION_ID'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(227736926634696958)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Editable Region'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select pp.plug_name,',
'       pp.id',
'  from wwv_flow_page_plugs pp',
' where pp.flow_id           = :FB_FLOW_ID',
'   and pp.page_id           = :P590_COPY_TO_PAGE',
'   and pp.security_group_id = :WORKSPACE_ID',
'   and pp.plug_source_type  = ''NATIVE_IG''',
'   -- only show IG regions with editing enabled',
'   and exists (',
'       select 1',
'         from wwv_flow_interactive_grids ig',
'        where ig.region_id = pp.id',
'          and ig.is_editable = ''Y'' )   ',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Region -'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_step_processing sp',
'  join wwv_flow_page_plugs pp',
'    on ( pp.id = sp.region_id and pp.flow_id = sp.flow_id and pp.page_id = sp.flow_step_id )',
' where sp.id                = :P590_ID',
'   and sp.region_id         is not null',
'   and pp.plug_source_type  = ''NATIVE_IG'''))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a region from the target page to associate with this process.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(227739229332696983)
,p_name=>'P645_PROCESS_SEQUENCE'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(227736926634696958)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Target Page Process Sequence'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(max(process_sequence), 0) + 10 as r',
'  from wwv_flow_step_processing',
' where flow_id      = :FB_FLOW_ID',
'   and flow_step_id = :P590_COPY_TO_PAGE'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>5
,p_cMaxlength=>10
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the sequence for this component. The sequence determines the order of evaluation.'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(227739718553696984)
,p_name=>'P645_PROCESS_NAME'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(227736926634696958)
,p_prompt=>'Target Page Process Name'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select process_name',
'from wwv_flow_step_processing',
'where id = :P590_ID and flow_id = :fb_flow_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the name for the new component.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(229229810300201120)
,p_name=>'P645_WHEN_BUTTON_PRESSED'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(227736926634696958)
,p_prompt=>'When Button Pressed'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select button_name,',
'       id',
'  from (',
'        /* all region buttons from current page and global page */',
'        select case when b.flow_step_id = f.global_page_id then',
'                   wwv_flow_lang.system_message(''LAYOUT.GLOBAL_PAGE_REGION_PREFIX'')',
'               end ||',
'               b.button_name ||',
'               '' ('' || b.button_image_alt || '')'' as button_name,',
'               b.id,',
'               b.button_name bn,',
'               case when b.flow_step_id = f.global_page_id then 2 else 1 end x',
'          from wwv_flow_steps p,',
'               wwv_flows f,',
'               wwv_flow_step_buttons b',
'         where p.flow_id     = :FB_FLOW_ID',
'           and p.id          = :P590_COPY_TO_PAGE',
'           and f.id          = p.flow_id',
'           and b.flow_id     = f.id',
'           and b.flow_step_id in (:P590_COPY_TO_PAGE, f.global_page_id)',
'         order by 4, 3 ',
'       )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Button Condition -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'This component will only be executed if a user clicks this button.',
''))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231558429053761318)
,p_name=>'P645_COPY_FROM_PAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(227736926634696958)
,p_prompt=>'Copy From Page:'
,p_source=>'P590_COPY_FROM_PAGE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Page that process will be copied from.'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231559013947766469)
,p_name=>'P645_COPY_FROM_PROCESS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(227736926634696958)
,p_prompt=>'Copy Process:'
,p_source=>'P590_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select PROCESS_SEQUENCE||''. ''||PROCESS_NAME pname, id',
'from WWV_FLOW_STEP_PROCESSING',
'where flow_id = :fb_flow_id and flow_step_id = :fb_flow_page_id',
'order by PROCESS_SEQUENCE'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Process to be copied.'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231559928838770715)
,p_name=>'P645_COPY_TO_PAGE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(227736926634696958)
,p_prompt=>'Target Page:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||wwv_flow_escape.html(name)',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'and id = :P590_COPY_TO_PAGE'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>10
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Page that process will be copied to.'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2596027944216182)
,p_validation_name=>'Ensure the destination page is not a subscribed page pattern'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_component_group_dev.is_part_of_subscribed_comp_grp (',
'    p_component_id   => :P590_COPY_TO_PAGE,',
'    p_component_type => wwv_flow_copy_metadata.c_page,',
'    p_app_id         => :FB_FLOW_ID ) = ''N'''))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'You cannot copy the process to a page pattern that is part of a subscribed component group.'
,p_when_button_pressed=>wwv_flow_imp.id(227738024960696973)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(590119056293572026)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(227737802879696972)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(590119136231572027)
,p_event_id=>wwv_flow_imp.id(590119056293572026)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(227740800311696992)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Process'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_page.a_process(',
'    p_flow_id_from            => :FB_FLOW_ID,',
'    p_page_id_from            => :FB_FLOW_PAGE_ID,',
'    p_process_id_from         => :P590_ID,',
'    p_flow_id_to              => :FB_FLOW_ID,',
'    p_page_id_to              => :P590_COPY_TO_PAGE,',
'    p_process_name            => :P645_PROCESS_NAME,',
'    p_process_sequence        => :P645_PROCESS_SEQUENCE,',
'    p_region_id               => :P645_REGION_ID,',
'    p_process_when_button_id  => :P645_WHEN_BUTTON_PRESSED );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to copy process'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(227738024960696973)
,p_process_success_message=>'Process Copied'
,p_internal_uid=>227740800311696992
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(614621871751011271)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(227738024960696973)
,p_process_success_message=>'Process Copied'
,p_internal_uid=>614621871751011271
);
end;
/
prompt --application/pages/page_00646
begin
wwv_flow_imp_page.create_page(
 p_id=>646
,p_name=>'Upgrade Application'
,p_alias=>'UPGRADE-APPLICATION2'
,p_step_title=>'Upgrade Application - Select Buttons to Not Execute Validations'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(208108626900064044)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(492048321251709984)
,p_plug_name=>'Wizard Menu'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(484017424976766961)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
,p_plug_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(492048518882709988)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--scrollAuto:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select htmldb_item.checkbox(1, b.id,  ',
'          (select ''CHECKED'' ',
'             from wwv_flow_collections b ',
'            where collection_name = ''UPGRADE_BUTTONS'' ',
'              and n001 = b.id',
'          ),null, '':'', ''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0'') ,',
'     wwv_flow_lang.system_message(''BUTTON_LABEL'',b.button_name)) checked,',
'       b.button_name,',
'       b.button_image_alt button_label,',
'       decode(b.button_action,',
'                  ''SUBMIT'',           wwv_flow_lang.system_message(''DA_NAME.NATIVE_SUBMIT_PAGE''),',
'                  ''REDIRECT_PAGE'',    wwv_flow_lang.system_message(''REDIRECT_TO_PAGE_IN_THIS_APP''),',
'                  ''REDIRECT_URL'',     wwv_flow_lang.system_message(''REDIRECT_TO_URL''),',
'                  ''DEFINED_BY_DA'',    wwv_flow_lang.system_message(''DEFINED_BY_DA''),',
'                                      b.button_action)        button_action',
'  from wwv_flow_step_buttons b',
' where b.flow_id           = :FB_FLOW_ID ',
'   and b.security_group_id = :WORKSPACE_ID',
'   and b.flow_step_id      = :P86_PAGE_ID',
'   and b.button_action in (''SUBMIT'', ''REDIRECT_URL'', ''DEFINED_BY_DA'')',
'   and nvl(b.button_execute_validations,''Y'') = ''Y''                '))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(492048717947709990)
,p_name=>'Migration Objects'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No Buttons found on the page.'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_show_finder_drop_down=>'N'
,p_show_search_textbox=>'N'
,p_show_actions_menu=>'N'
,p_report_list_mode=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_enable_mail_download=>'N'
,p_owner=>'SATHISH'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(492049132636709998)
,p_db_column_name=>'BUTTON_NAME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Button Name'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(492056819041756734)
,p_db_column_name=>'BUTTON_LABEL'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Button Label'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(492610112719198102)
,p_db_column_name=>'CHECKED'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(26142329708050846)
,p_db_column_name=>'BUTTON_ACTION'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Button Action'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(492049310731709998)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1290011266536644'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'CHECKED:BUTTON_NAME:BUTTON_LABEL:BUTTON_ACTION'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(499670831354971940)
,p_plug_name=>'Upgrade Application'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_plug_source=>'Select buttons for which Execute Validations should be set to No (such as Cancel buttons that submit rather than redirecting and Delete buttons).'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(631547518877262184)
,p_plug_name=>'top bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747143942014138167)
,p_plug_name=>'Upgrade Application'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(615691929413717661)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(208108626900064044)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:674:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(492049727574710001)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(208108626900064044)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :p646_page is null then',
'  return true;',
'else',
'  for c1 in (select 1 x from wwv_flow_lock_page where locked_by is not null and flow_id = :fb_flow_id and object_id = :p646_page) loop',
'     return false;',
'  end loop;',
'end if;',
'return true;'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'FUNCTION_BODY'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(492069821006806282)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(208108626900064044)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:86:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(492051219028710016)
,p_branch_action=>'f?p=&APP_ID.:862:&SESSION.::&DEBUG.::P862_PAGE_ID:&P646_PAGE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(492049727574710001)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(631577928808406908)
,p_name=>'P646_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(631547518877262184)
,p_prompt=>'Page:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2045580750905367804)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(492048518882709988)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2045580803552367805)
,p_event_id=>wwv_flow_imp.id(2045580750905367804)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(492608422023172491)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Add Buttons'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_collection_status number;',
'   l_id                number;',
'   l_count             number;',
'begin',
'    wwv_flow_collection.create_or_truncate_collection(',
'        p_collection_name => ''UPGRADE_BUTTONS'');',
'    for i in 1..wwv_flow.g_f01.count',
'    loop',
'        l_id := wwv_flow.g_f01(i);',
'        select count(*) into l_count ',
'          from wwv_flow_collections ',
'         where n001            = l_id ',
'           and collection_name = ''UPGRADE_BUTTONS'';',
'        if l_count = 0 then ',
'            l_collection_status := wwv_flow_collection.add_member(',
'                 p_collection_name => ''UPGRADE_BUTTONS'',',
'                 p_n001            => l_id);',
'        end if;',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>492608422023172491
);
end;
/
prompt --application/pages/page_00651
begin
wwv_flow_imp_page.create_page(
 p_id=>651
,p_name=>'Publish Templates - References'
,p_alias=>'PUBLISH-TEMPLATES-REFERENCES'
,p_step_title=>'Publish Templates - References'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt_view.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(5830884083948628)
,p_name=>'Subscribed Templates'
,p_template=>wwv_flow_imp.id(208928010704475743)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  with messages as (',
'      select ''PAGE'' as msg_code,    wwv_flow_lang.system_message(''F4000.PAGE'') as msg        from sys.dual union all',
'      select ''REGION'',              wwv_flow_lang.system_message(''F4000.REGION'')             from sys.dual union all',
'      select ''REPORT'',              wwv_flow_lang.system_message(''REPORT'')                   from sys.dual union all',
'      select ''LIST'',                wwv_flow_lang.system_message(''F4000.LIST_INITCAP'')       from sys.dual union all',
'      select ''LABEL'',               wwv_flow_lang.system_message(''LABEL'')                    from sys.dual union all',
'      select ''BUTTON'',              wwv_flow_lang.system_message(''F4000.BUTTON'')             from sys.dual union all',
'      select ''MENU'',                wwv_flow_lang.system_message(''BREADCRUMB'')               from sys.dual union all',
'      select ''CALENDAR'',            wwv_flow_lang.system_message(''LEGACY_CALENDAR'')          from sys.dual union all',
'      select ''POPUP_LOV'',           wwv_flow_lang.system_message(''F4000.P371.POPUP_LOV'')     from sys.dual union all',
'      select ''TEMPLATE_COMPONENT'',  wwv_flow_lang.system_message(''F4000.TEMPLATE_COMPONENT'') from sys.dual )',
'select wwv_flow_item.checkbox(',
'           item_id,',
'           id,',
'           ''title="''||wwv_flow_lang.system_message(''SELECT_ROW_C'', ',
'           wwv_flow_escape.html(template_name))||''"'') as row_selector,',
'       ( select msg from messages where msg_code = rtype ) as template_type,',
'       template_name,',
'       flow_id,',
'       theme_id,',
'       cp_from',
'  from ( select 1 as item_id,',
'                id,',
'                name as template_name,',
'                flow_id,',
'                theme_id,',
'                ''PAGE'' rtype,',
'                (select wwv_flow_lang.system_message(''F4000_P801_FLOW'')||'' ''||flow_id||'', ''||wwv_flow_lang.system_message(''SUBSCRIBED_FROM.THEME'')||'' ''||theme_id||'', ''||wwv_flow_escape.html(name)',
'                   from wwv_flow_templates ',
'                  where id                  = :P651_REFERENCE_ID',
'                    and security_group_id   = :flow_security_group_id ) cp_from',
'           from wwv_flow_templates p',
'          where p.reference_id = :P651_REFERENCE_ID',
'            and p.security_group_id = :flow_security_group_id',
'            and nvl(:P651_TYPE,''PAGE'') = ''PAGE''',
'            and (  :P651_FIND is null',
'                or instr(upper(name),upper(:P651_FIND)) > 0 ',
'                or instr(id,:P651_FIND) > 0 )',
'          union all',
'         select 2,',
'                id,',
'                page_plug_template_name,',
'                flow_id,',
'                theme_id,',
'                ''REGION'' rtype,',
'                (select wwv_flow_lang.system_message(''F4000_P801_FLOW'')||'' ''||flow_id||'', ''||wwv_flow_lang.system_message(''SUBSCRIBED_FROM.THEME'')||'' ''||theme_id||'', ''||wwv_flow_escape.html(page_plug_template_name)',
'                   from wwv_flow_page_plug_templates ',
'                  where id                  = :P651_REFERENCE_ID',
'                    and security_group_id   = :flow_security_group_id ) cp_from',
'           from wwv_flow_page_plug_templates p',
'          where p.reference_id = :P651_REFERENCE_ID',
'            and p.security_group_id = :flow_security_group_id',
'            and :P651_TYPE = ''REGION''',
'            and (  :P651_FIND is null',
'                or instr(upper(page_plug_template_name),upper(:P651_FIND)) > 0 ',
'                or instr(id,:P651_FIND) > 0 )',
'          union all',
'         select 3,',
'                id,',
'                row_template_name,',
'                flow_id,',
'                theme_id,',
'                ''REPORT'' rtype,',
'                (select wwv_flow_lang.system_message(''F4000_P801_FLOW'')||'' ''||flow_id||'', ''||wwv_flow_lang.system_message(''SUBSCRIBED_FROM.THEME'')||'' ''||theme_id||'', ''||wwv_flow_escape.html(row_template_name)',
'                   from wwv_flow_row_templates ',
'                  where id                  = :P651_REFERENCE_ID',
'                    and security_group_id   = :flow_security_group_id ) cp_from',
'           from wwv_flow_row_templates p',
'          where p.reference_id = :P651_REFERENCE_ID',
'            and p.security_group_id = :flow_security_group_id',
'            and :P651_TYPE = ''REPORT''',
'            and (  :P651_FIND is null',
'                or instr(upper(row_template_name),upper(:P651_FIND)) > 0 ',
'                or instr(id,:P651_FIND) > 0 )',
'          union all',
'         select 4,',
'                id,',
'                list_template_name,',
'                flow_id,',
'                theme_id,',
'                ''LIST'' rtype,',
'                (select initcap(wwv_flow_lang.system_message(''F4000_P801_FLOW''))||'' ''||flow_id||'', ''||wwv_flow_lang.system_message(''SUBSCRIBED_FROM.THEME'')||'' ''||theme_id||'', ''||wwv_flow_escape.html(list_template_name)',
'                   from wwv_flow_list_templates ',
'                  where id                  = :P651_REFERENCE_ID',
'                    and security_group_id   = :flow_security_group_id ) cp_from',
'           from wwv_flow_list_templates p',
'          where p.reference_id = :P651_REFERENCE_ID',
'            and p.security_group_id = :flow_security_group_id',
'            and :P651_TYPE = ''LIST''',
'            and (  :P651_FIND is null',
'                or instr(upper(list_template_name),upper(:P651_FIND)) > 0 ',
'                or instr(id,:P651_FIND) > 0 )',
'          union all',
'         select 5,',
'                id,',
'                template_name,',
'                flow_id,',
'                theme_id,',
'                ''LABEL'' rtype,',
'                (select initcap(wwv_flow_lang.system_message(''F4000_P801_FLOW''))||'' ''||flow_id||'', ''||wwv_flow_lang.system_message(''SUBSCRIBED_FROM.THEME'')||'' ''||theme_id||'', ''||wwv_flow_escape.html(template_name)',
'                   from wwv_flow_field_templates ',
'                  where id                  = :P651_REFERENCE_ID',
'                    and security_group_id   = :flow_security_group_id ) cp_from',
'           from wwv_flow_field_templates p',
'          where p.reference_id = :P651_REFERENCE_ID',
'            and p.security_group_id = :flow_security_group_id',
'            and :P651_TYPE = ''LABEL''',
'            and (  :P651_FIND is null',
'                or instr(upper(template_name),upper(:P651_FIND)) > 0 ',
'                or instr(id,:P651_FIND) > 0 )',
'          union all',
'         select 6,',
'                id,',
'                template_name,',
'                flow_id,',
'                theme_id,',
'                ''BUTTON'' rtype,',
'                (select initcap(wwv_flow_lang.system_message(''F4000_P801_FLOW''))||'' ''||flow_id||'', ''||wwv_flow_lang.system_message(''SUBSCRIBED_FROM.THEME'')||'' ''||theme_id||'', ''||wwv_flow_escape.html(template_name)',
'                   from wwv_flow_button_templates ',
'                  where id                  = :P651_REFERENCE_ID',
'                    and security_group_id   = :flow_security_group_id ) cp_from',
'           from wwv_flow_button_templates p',
'          where p.reference_id = :P651_REFERENCE_ID',
'            and p.security_group_id = :flow_security_group_id',
'            and :P651_TYPE = ''BUTTON''',
'            and (  :P651_FIND is null',
'                or instr(upper(template_name),upper(:P651_FIND)) > 0 ',
'                or instr(id,:P651_FIND) > 0 )',
'          union all',
'         select 7,',
'                id,',
'                name,',
'                flow_id,',
'                theme_id,',
'                ''MENU'' rtype,',
'                (select initcap(wwv_flow_lang.system_message(''F4000_P801_FLOW''))||'' ''||flow_id||'', ''||wwv_flow_lang.system_message(''SUBSCRIBED_FROM.THEME'')||'' ''||theme_id||'', ''||wwv_flow_escape.html(name)',
'                   from wwv_flow_menu_templates ',
'                  where id                  = :P651_REFERENCE_ID',
'                    and security_group_id   = :flow_security_group_id ) cp_from',
'           from wwv_flow_menu_templates p',
'          where p.reference_id = :P651_REFERENCE_ID',
'            and p.security_group_id = :flow_security_group_id',
'            and :P651_TYPE = ''MENU''',
'            and (  :P651_FIND is null',
'                or instr(upper(name),upper(:P651_FIND)) > 0 ',
'                or instr(id,:P651_FIND) > 0 )',
'          union all',
'         select 8,',
'                id,',
'                name,',
'                flow_id,',
'                theme_id,',
'                ''CALENDAR'' rtype,',
'                (select initcap(wwv_flow_lang.system_message(''F4000_P801_FLOW''))||'' ''||flow_id||'', ''||wwv_flow_lang.system_message(''SUBSCRIBED_FROM.THEME'')||'' ''||theme_id||'', ''||wwv_flow_escape.html(name)',
'                   from wwv_flow_cal_templates ',
'                  where id                  = :P651_REFERENCE_ID',
'                    and security_group_id   = :flow_security_group_id ) cp_from',
'           from wwv_flow_cal_templates p',
'          where p.reference_id = :P651_REFERENCE_ID',
'            and p.security_group_id = :flow_security_group_id',
'            and :P651_TYPE = ''CALENDAR''',
'            and (  :P651_FIND is null',
'                or instr(upper(name),upper(:P651_FIND)) > 0 ',
'                or instr(id,:P651_FIND) > 0 )',
'          union all',
'         select 9,',
'                id,',
'                wwv_flow_lang.system_message(''F4000.P371.POPUP_LOV''),',
'                flow_id,',
'                theme_id,',
'                ''POPUP_LOV'' rtype,',
'                (select initcap(wwv_flow_lang.system_message(''F4000_P801_FLOW''))||'' ''||flow_id||'', ''||wwv_flow_lang.system_message(''SUBSCRIBED_FROM.THEME'')||'' ''||theme_id||'', ''||wwv_flow_escape.html(wwv_flow_lang.system_message(''F4000.P371.POPUP_LOV'''
||'))',
'                   from wwv_flow_popup_lov_template ',
'                  where id                  = :P651_REFERENCE_ID',
'                    and security_group_id   = :flow_security_group_id ) cp_from',
'           from wwv_flow_popup_lov_template p',
'          where p.reference_id = :P651_REFERENCE_ID',
'            and p.security_group_id = :flow_security_group_id',
'            and :P651_TYPE = ''POPUP_LOV''',
'            and (  :P651_FIND is null',
'                or instr(upper(wwv_flow_lang.system_message(''F4000.P371.POPUP_LOV'')),upper(:P651_FIND)) > 0 ',
'                or instr(id,:P651_FIND) > 0 )',
'          union all',
'         select 10,',
'                id,',
'                builder_name,',
'                flow_id,',
'                theme_id,',
'                ''TEMPLATE_COMPONENT'' rtype,',
'                (select initcap(wwv_flow_lang.system_message(''F4000_P801_FLOW''))||'' ''||flow_id||'', ''||wwv_flow_lang.system_message(''SUBSCRIBED_FROM.THEME'')||'' ''||theme_id||'', ''||wwv_flow_escape.html(builder_name)',
'                   from wwv_flow_template_components ',
'                  where id                  = :P651_REFERENCE_ID',
'                    and security_group_id   = :flow_security_group_id ) cp_from',
'           from wwv_flow_template_components p',
'          where p.reference_id = :P651_REFERENCE_ID',
'            and p.security_group_id = :flow_security_group_id',
'            and :P651_TYPE = ''TEMPLATE_COMPONENT''',
'            and (  :P651_FIND is null',
'                or instr(upper(builder_name),upper(:P651_FIND)) > 0 ',
'                or instr(id,:P651_FIND) > 0 )',
')'))
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No Subscribed Templates.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5832495480948644)
,p_query_column_id=>1
,p_column_alias=>'ROW_SELECTOR'
,p_column_display_sequence=>10
,p_column_heading=>'#CHECK_ALL_CHECKBOX#'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5832533318948645)
,p_query_column_id=>2
,p_column_alias=>'TEMPLATE_TYPE'
,p_column_display_sequence=>40
,p_column_heading=>'Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5832895693948648)
,p_query_column_id=>3
,p_column_alias=>'TEMPLATE_NAME'
,p_column_display_sequence=>50
,p_column_heading=>'Template'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5831022778948630)
,p_query_column_id=>4
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>20
,p_column_heading=>'Application'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5832962574948649)
,p_query_column_id=>5
,p_column_alias=>'THEME_ID'
,p_column_display_sequence=>30
,p_column_heading=>'Theme'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5832744044948647)
,p_query_column_id=>6
,p_column_alias=>'CP_FROM'
,p_column_display_sequence=>70
,p_column_heading=>'Copied From'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(98889805553830765)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_imp.id(12437772301)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(98890918020834332)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(98894515296861926)
,p_plug_name=>'Refresh'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page displays subscribing templates to the selected master template.</p>',
'<p>To refresh subscribing templates, select those you want to refresh and click <strong>Refresh Checked</strong>.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(108926723644619944)
,p_plug_name=>'hidden'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(98904029803913431)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(98890918020834332)
,p_button_name=>'P651_GO'
,p_button_static_id=>'P651_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Go'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(103304301819822790)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(98890918020834332)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Refresh Checked'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(98904221588913432)
,p_branch_action=>'f?p=&APP_ID.:651:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(98897332050876266)
,p_name=>'P651_FIND'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(98890918020834332)
,p_prompt=>'Find'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter case insensitive query criteria and press <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(98901629326903853)
,p_name=>'P651_ROWS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(98890918020834332)
,p_item_default=>'20'
,p_prompt=>'Rows'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAXIMUM ROWS PER PAGE'
,p_lov=>'.'||wwv_flow_imp.id(84800803131139158)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the number of rows to display and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(103295714230722294)
,p_name=>'P651_REFERENCE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(108926723644619944)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(103320806376278163)
,p_name=>'P651_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(108926723644619944)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4407751102798051)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(5830884083948628)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4408101196798069)
,p_event_id=>wwv_flow_imp.id(4407751102798051)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(103611114031000150)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- page',
'for i in 1..wwv_flow.g_f01.count',
'loop',
'  wwv_flow_copy_metadata.subscribe_page_template(    ',
'      p_master_template_id      => :P651_REFERENCE_ID,',
'      p_subscribing_template_id => wwv_flow.g_f01(i));',
'end loop;',
'-- region',
'for i in 1..wwv_flow.g_f02.count',
'loop',
'  wwv_flow_copy_metadata.subscribe_region_template(    ',
'      p_master_template_id      => :P651_REFERENCE_ID,',
'      p_subscribing_template_id => wwv_flow.g_f02(i));',
'end loop;',
'-- report',
'for i in 1..wwv_flow.g_f03.count',
'loop',
'  wwv_flow_copy_metadata.subscribe_report_template(    ',
'      p_master_template_id      => :P651_REFERENCE_ID,',
'      p_subscribing_template_id => wwv_flow.g_f03(i));',
'end loop;',
'-- list',
'for i in 1..wwv_flow.g_f04.count',
'loop',
'  wwv_flow_copy_metadata.subscribe_list_template(    ',
'      p_master_template_id      => :P651_REFERENCE_ID,',
'      p_subscribing_template_id => wwv_flow.g_f04(i));',
'end loop;',
'-- label',
'for i in 1..wwv_flow.g_f05.count',
'loop',
'  wwv_flow_copy_metadata.subscribe_field_template(    ',
'      p_master_template_id      => :P651_REFERENCE_ID,',
'      p_subscribing_template_id => wwv_flow.g_f05(i));',
'end loop;',
'-- button',
'for i in 1..wwv_flow.g_f06.count',
'loop',
'  wwv_flow_copy_metadata.subscribe_button_template(    ',
'      p_master_template_id      => :P651_REFERENCE_ID,',
'      p_subscribing_template_id => wwv_flow.g_f06(i));  ',
'end loop;',
'-- breadcrumb',
'for i in 1..wwv_flow.g_f07.count',
'loop',
'  wwv_flow_copy_metadata.subscribe_menu_template(    ',
'      p_master_template_id      => :P651_REFERENCE_ID,',
'      p_subscribing_template_id => wwv_flow.g_f07(i));',
'end loop;',
'-- calendar',
'for i in 1..wwv_flow.g_f08.count',
'loop',
'  wwv_flow_copy_metadata.subscribe_calendar_template(    ',
'      p_master_template_id      => :P651_REFERENCE_ID,',
'      p_subscribing_template_id => wwv_flow.g_f08(i));',
'end loop;',
'-- popup LOV',
'for i in 1..wwv_flow.g_f09.count',
'loop',
'  wwv_flow_copy_metadata.subscribe_popuplov_template(    ',
'      p_master_template_id      => :P651_REFERENCE_ID,',
'      p_subscribing_template_id => wwv_flow.g_f09(i));  ',
'end loop;',
'-- Template Component',
'for i in 1..wwv_flow.g_f10.count',
'loop',
'  wwv_flow_plugin_dev.subscribe_plugin(',
'      p_master_plugin_id      => :P651_REFERENCE_ID,',
'      p_subscribing_plugin_id => wwv_flow.g_f10(i));  ',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error refreshing selected subscribing templates.'
,p_process_when_button_id=>wwv_flow_imp.id(103304301819822790)
,p_process_success_message=>'Selected subscribing templates refreshed.'
,p_internal_uid=>103611114031000150
);
end;
/
prompt --application/pages/page_00652
begin
wwv_flow_imp_page.create_page(
 p_id=>652
,p_name=>'Create Item Template - Name'
,p_alias=>'CREATE-ITEM-TEMPLATE-NAME'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Item Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(91871626479901740)
,p_plug_name=>'Create Item Template'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(132576120832100122)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(165617402058355880)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(106501409747300331)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(91880811503916335)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(132576120832100122)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(91889113020926194)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(132576120832100122)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(91883830897921915)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(132576120832100122)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(91881127139916336)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(589889892427923043)
,p_branch_action=>'f?p=&APP_ID.:941:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(91883830897921915)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(87466312950832763)
,p_name=>'P652_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(91871626479901740)
,p_prompt=>'Theme'
,p_source=>'P4003_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies a collection of templates which define the look and feel of the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(87467627148836828)
,p_name=>'P652_THEME_CLASS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(91871626479901740)
,p_prompt=>'Template Class'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LABEL THEME CLASS ID'
,p_lov=>'.'||wwv_flow_imp.id(43828319065855502)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'The template class identifies a specific usage for this template.  The template class is used when switching themes.  When switching themes template classes are matched, thus allowing themes to be switched without manually mapping all templates.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(91873003407904527)
,p_name=>'P652_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(91871626479901740)
,p_prompt=>'Template Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a name for this item template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(87470326933846248)
,p_validation_name=>'P652_THEME'
,p_validation_sequence=>10
,p_validation=>'P652_THEME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(91889113020926194)
,p_associated_item=>wwv_flow_imp.id(87466312950832763)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(87472218753853322)
,p_validation_name=>'P652_NAME'
,p_validation_sequence=>20
,p_validation=>'P652_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(91889113020926194)
,p_associated_item=>wwv_flow_imp.id(91873003407904527)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(73941834180235927)
,p_validation_name=>'P652_NAME unique'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_field_templates',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :workspace_id',
'   and theme_id          = :P652_THEME',
'   and template_name     = :P652_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#LABEL# must be unique.'
,p_when_button_pressed=>wwv_flow_imp.id(91889113020926194)
,p_associated_item=>wwv_flow_imp.id(91873003407904527)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(87473505378858994)
,p_validation_name=>'P652_THEME_CLASS'
,p_validation_sequence=>40
,p_validation=>'P652_THEME_CLASS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(91889113020926194)
,p_associated_item=>wwv_flow_imp.id(87467627148836828)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(589889659188923041)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(91880811503916335)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(589889777673923042)
,p_event_id=>wwv_flow_imp.id(589889659188923041)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(91916500787064644)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Item Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_imp_shared.create_field_template(',
'    P_FLOW_ID                  => :FB_FLOW_ID,',
'    P_TEMPLATE_NAME            => :P652_NAME,            ',
'    P_TEMPLATE_BODY1           => ''<label for="#CURRENT_ITEM_NAME#" tabindex="999">'',',
'    P_TEMPLATE_BODY2           => ''</label>'',',
'    P_ON_ERROR_BEFORE_LABEL    => null,',
'    P_ON_ERROR_AFTER_LABEL     => ''<br/>#ERROR_MESSAGE#'',',
'    P_TEMPLATE_COMMENT         => null,',
'    P_THEME_ID                 => :P652_THEME,',
'    P_THEME_CLASS_ID           => :P652_THEME_CLASS);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Template created.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(91889113020926194)
,p_process_success_message=>'Item Template Created'
,p_internal_uid=>91916500787064644
);
end;
/
prompt --application/pages/page_00654
begin
wwv_flow_imp_page.create_page(
 p_id=>654
,p_name=>'Images'
,p_alias=>'IMAGES'
,p_step_title=>'Images'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script>',
'',
'function passBack(x, return_item){',
'opener.$x(return_item).value = x;',
'	opener.$x(return_item).focus()',
'	close();',
'}',
'',
'</script>'))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.fa-icon-block {',
'    display: inline-block;',
'}',
'.fa-icon-block a,',
'.fa-icon-block a:hover {',
'    text-decoration: none;',
'}',
'.fa-icon-block a {',
'    display: inline-block;',
'    width: 160px;',
'    padding: 8px;',
'    height: 90px;',
'    text-align: center;',
'    border-radius: 2px;',
'    vertical-align: top;',
'}',
'.fa-icon-block a:hover {',
'    background-color: #F8F8F8;',
'    box-shadow: 0 0 0 1px rgba(0,0,0,.1)',
'}',
'.fa-icon-block .fa {',
'    font-size: 42px;',
'    display: inline-block;',
'    color: #707070;',
'    line-height: 1.25;',
'}',
'.fa-icon-block .icon-label {',
'    font-size: 12px;',
'    line-height: 16px;',
'    display: block;',
'    color: #404040;',
'}'))
,p_step_template=>wwv_flow_imp.id(19943204431962826)
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(112406926141430926)
,p_plug_name=>'Images'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>100
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_f4000_util.show_popup_images(',
'    p_return_item => :P654_RETURN_ITEM, ',
'    p_image_size  => :P654_ICON_SIZE,',
'    p_show        => :P654_SHOW, ',
'    p_category    => :P654_ICON_CATEGORY);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(112644519924330778)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>92
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(112851914437483431)
,p_plug_name=>'Message'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>95
,p_translate_title=>'N'
,p_plug_header=>'<p>Click an image to select the image and close this window.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(112674814860338798)
,p_button_sequence=>4
,p_button_plug_id=>wwv_flow_imp.id(112644519924330778)
,p_button_name=>'P654_GO'
,p_button_static_id=>'P654_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Go'
,p_button_alignment=>'LEFT-CENTER'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(112884404235593950)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(112644519924330778)
,p_button_name=>'CLOSE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Close'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:window.close();'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(112674211051337641)
,p_branch_action=>'f?p=&APP_ID.:654:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2980900959967526)
,p_name=>'P654_RETURN_ITEM'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(112644519924330778)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(112659232391334369)
,p_name=>'P654_ICON_SIZE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(112644519924330778)
,p_item_default=>'64'
,p_prompt=>'Icon Size'
,p_source=>'64'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'STANDARD ICON SIZES 2'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''12x12''	 d, 12  r from dual union all',
'select ''16x16''	 d, 16  r from dual union all',
'select ''20x20''	 d, 20  r from dual union all',
'select ''32x32''	 d, 32  r from dual union all',
'select ''64x64''	 d, 64  r from dual union all',
'select ''128x128'' d, 128 r from dual union all',
'select ''140x90''	 d, 140 r from dual',
'order by 2'))
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_new_grid=>true
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>':P654_SHOW is null or :P654_SHOW = ''STANDARD'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select standard application image size.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(112869831762564119)
,p_name=>'P654_SHOW'
,p_item_sequence=>3
,p_item_plug_id=>wwv_flow_imp.id(112644519924330778)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_icon_library wwv_flow_themes.icon_library%type;',
'begin',
'    select min( icon_library )',
'      into l_icon_library',
'      from wwv_flow_themes t,',
'           wwv_flows f',
'     where f.id                = :FB_FLOW_ID',
'       and f.security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and t.flow_id           = f.id',
'       and t.theme_id          = f.theme_id',
'       and t.security_group_id = f.security_group_id;',
'',
'  return nvl( l_icon_library, ''STANDARD'' );',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Show'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'IMAGE PREVIEW REPOSITORY'
,p_lov=>'.'||wwv_flow_imp.id(2545625667361279)||'.'
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_help_text=>'Standard images are images that are part of the &PRODUCT_NAME. distribution and are available for all applications to use.  Workspace images are images available workspace wide.  Application images are only available to this application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1301369975206065008)
,p_name=>'P654_ICON_CATEGORY'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(112644519924330778)
,p_prompt=>'Category'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'FONT_CATEGORIES'
,p_lov=>'.'||wwv_flow_imp.id(1362022415318990531)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Category -'
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_new_grid=>true
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>':P654_SHOW is null or :P654_SHOW in ( ''FONTAPEX'', ''FONTAWESOME'' )'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select Font Awesome category.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
end;
/
prompt --application/pages/page_00655
begin
wwv_flow_imp_page.create_page(
 p_id=>655
,p_name=>'Create Item Template - Copy From'
,p_alias=>'CREATE-ITEM-TEMPLATE-COPY-FROM'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Item Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46354116636220743)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(91949529268203995)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(320074633987)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(91949814840203997)
,p_plug_name=>'Create Item Template'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_header=>'<p>Select the application that contains the templates you wish to copy.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(91950420086204002)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46354116636220743)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(91950712227204004)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(46354116636220743)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(91951032619204005)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(46354116636220743)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(152132728007993815)
,p_branch_action=>'f?p=&FLOW_ID.:353:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(589888846733923033)
,p_branch_action=>'f?p=&APP_ID.:941:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(91951032619204005)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(91951320021204006)
,p_name=>'P655_COPY_FROM_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(91949814840203997)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Copy From Application'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select an Application -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select the application from which you want to copy the template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(91952006284204015)
,p_validation_name=>'P655_COPY_FROM_FLOW_ID Not Null'
,p_validation_sequence=>10
,p_validation=>'P655_COPY_FROM_FLOW_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Copy From Application must be specified.'
,p_associated_item=>wwv_flow_imp.id(91951320021204006)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 06-MAY-2002 14:33'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(589888625871923031)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(91950420086204002)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(589888707934923032)
,p_event_id=>wwv_flow_imp.id(589888625871923031)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00656
begin
wwv_flow_imp_page.create_page(
 p_id=>656
,p_name=>'Cached Regions'
,p_alias=>'CACHED-REGIONS'
,p_step_title=>'Cached Regions'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213220627333807318)
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(196271102488602659)
,p_plug_name=>'Regions'
,p_region_name=>'cachedRegions'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>100
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'   ''<input type="checkbox" name="f01" value="''||r.id||''" title="''||wwv_flow_lang.system_message(''PURGE_LABEL'',wwv_flow_escape.html(r.plug_name))||''"/>'' cb,',
'   r.flow_id application_id,',
'   r.page_id page_id, ',
'   (select name from wwv_flow_steps where flow_id = r.flow_id and id = r.page_id) page_name,',
'   c.region_id, ',
'   r.plug_name region_name,',
'   case',
'     when r.plug_source_type like ''NATIVE%'' then wwv_flow_lang.system_message(''REGION_NAME.''||r.plug_source_type)',
'     else r.plug_source_type',
'   end region_type,',
'   c.language, ',
'  sys.dbms_lob.getlength(c.page_text) text_length, ',
'  cached_on, ',
'  round((sysdate - c.cached_on) * 3600 * 24,0) cache_age_in_seconds, ',
'    r.PLUG_CACHING_MAX_AGE_IN_SEC - round((sysdate - c.cached_on) * 3600 * 24,0) max_age_in_seconds,',
'  decode(greatest((sysdate - c.cached_on) * 3600 * 24,r.PLUG_CACHING_MAX_AGE_IN_SEC),r.PLUG_CACHING_MAX_AGE_IN_SEC,m.Unexpired,m.Expired) cache_status,',
'  r.PLUG_CACHING caching_method,',
'decode(decode(r.PLUG_CACHE_WHEN,null,''N'',''0'',''N'',''Y''),''N'',null,''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'')',
'   conditional,',
'  c.security_group_id',
'from wwv_flow_page_cache c,',
'     wwv_flow_page_plugs r,',
'(select',
'   wwv_flow_lang.system_message(''F4500_P2610_EXPIRED'') expired,',
'   wwv_flow_lang.system_message(''UNEXPIRED'') unexpired',
' from dual) m',
'where c.region_id(+) = r.id and',
'      c.flow_id(+) = r.flow_id and',
'      r.flow_id = :fb_flow_id and ',
'      r.security_group_id = :flow_security_group_id and ',
'      c.region_id is not null'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(196271205259602659)
,p_name=>'Regions'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_detail_link_text=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="" />'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(196271412473602672)
,p_db_column_name=>'CB'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
,p_column_comment=>'<input type="checkbox" title="&CHECK_ALL_MSG." onclick="html_CheckAll($x_UpTill(this,''TABLE''),this.checked)" />'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(196271528787602674)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(196271601599602676)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Page'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID:&FB_FLOW_ID.,#PAGE_ID#'
,p_column_linktext=>'#PAGE_ID#'
,p_column_type=>'NUMBER'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(196271730101602676)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Page Name'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(196271831948602677)
,p_db_column_name=>'REGION_ID'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Region Number'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(196271929758602678)
,p_db_column_name=>'REGION_NAME'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Region Name'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(196272010006602679)
,p_db_column_name=>'REGION_TYPE'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Region Type'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(196272109292602680)
,p_db_column_name=>'LANGUAGE'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Language'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(196272214250602680)
,p_db_column_name=>'TEXT_LENGTH'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Text Length'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(196272329219602681)
,p_db_column_name=>'CACHED_ON'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Cached On'
,p_column_type=>'DATE'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(196272423956602682)
,p_db_column_name=>'CACHE_AGE_IN_SECONDS'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Cache Age'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(196272519587602683)
,p_db_column_name=>'MAX_AGE_IN_SECONDS'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Timeout'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(196272609426602684)
,p_db_column_name=>'CACHE_STATUS'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Status'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(196272701873602684)
,p_db_column_name=>'CACHING_METHOD'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Method'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(196272928340602686)
,p_db_column_name=>'CONDITIONAL'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Conditional'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(196273015543602687)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Security_Group_Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(196273228562603123)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1290110402536644'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'CB:APPLICATION_ID:PAGE_ID:PAGE_NAME:REGION_ID:REGION_NAME:REGION_TYPE:LANGUAGE:TEXT_LENGTH:CACHED_ON:CACHE_AGE_IN_SECONDS:MAX_AGE_IN_SECONDS:CACHE_STATUS:CACHING_METHOD:CONDITIONAL:SECURITY_GROUP_ID'
,p_sort_column_1=>'APPLICATION_ID'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'PAGE_ID'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'REGION_NAME'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'LANGUAGE'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(196274501120614084)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_imp.id(196271102488602659)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:656:&SESSION.::&DEBUG.:656,RIR::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(31069420375930052)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(196271102488602659)
,p_button_name=>'PURGE_EXPIRED'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Purge Expired'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(32356202211381537)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(196271102488602659)
,p_button_name=>'PURGE_CHECKED'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Purge Checked'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(31042430351790472)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(196271102488602659)
,p_button_name=>'PURGE_CACHE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Purge All'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(31044802237790479)
,p_branch_action=>'f?p=&APP_ID.:656:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1194417247207758801)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(196271102488602659)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1194417336851758802)
,p_event_id=>wwv_flow_imp.id(1194417247207758801)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(31044502232790479)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'purge all'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P656_PAGE is null then',
'wwv_flow_page_cache_api.purge_regions_by_app(p_application=>:fb_flow_id);',
'else',
'for c1 in (',
'select id ',
'from wwv_flow_page_plugs ',
'where page_id = :P656_PAGE ',
'and flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id) loop',
'    wwv_flow_page_cache_api.purge_regions_by_id (',
'        p_application => :fb_flow_id,',
'        p_region_id => c1.id);',
'end loop;',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to purge cached pages.'
,p_process_when_button_id=>wwv_flow_imp.id(31042430351790472)
,p_process_success_message=>'Cached Regions Purged'
,p_internal_uid=>31044502232790479
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(31070211417955868)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'purge expired'
,p_process_sql_clob=>'wwv_flow_page_cache_api.purge_expired_regions (p_application => :fb_flow_id);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to Purge Expired Cached Regions'
,p_process_when_button_id=>wwv_flow_imp.id(31069420375930052)
,p_process_success_message=>'Expired Cached Regions Purged'
,p_internal_uid=>31070211417955868
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(32355328053379541)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'purge checked'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for j in 1..wwv_flow.g_f01.count loop',
'    wwv_flow_page_cache_api.purge_regions_by_id (',
'        p_application => :fb_flow_id,',
'        p_region_id => wwv_flow.g_f01(j));',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to purge selected region cache'
,p_process_when_button_id=>wwv_flow_imp.id(32356202211381537)
,p_process_success_message=>'Selected Region Caches Purged'
,p_internal_uid=>32355328053379541
);
end;
/
prompt --application/pages/page_00657
begin
wwv_flow_imp_page.create_page(
 p_id=>657
,p_name=>'Create Item Template - New Templates'
,p_alias=>'CREATE-ITEM-TEMPLATE-NEW-TEMPLATES'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Item Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46357218068249526)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(91957200231208656)
,p_name=>'Create Item Template'
,p_template=>wwv_flow_imp.id(42025417508627628)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'  id,',
'  flow_id,',
'  template_name from_name,',
'  wwv_flow_lang.system_message(''F4000.P158.COPY_OF'',template_name) to_name,',
'  ''N'' Sub',
'  from WWV_FLOW_FIELD_TEMPLATES ',
'  where flow_id = :P655_COPY_FROM_FLOW_ID ',
'  and security_group_id = :flow_security_group_id ',
'  and theme_id = :P353_COPY_FROM_THEME ',
' '))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_no_data_found=>'<font class="fielddata">No Item template found.</font>'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(291237529606166298)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(291237623454166298)
,p_query_column_id=>2
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>2
,p_column_heading=>'Application'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(291237703880166298)
,p_query_column_id=>3
,p_column_alias=>'FROM_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'From Name'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(291237830764166298)
,p_query_column_id=>4
,p_column_alias=>'TO_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'To Name'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>40
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(291237923679166298)
,p_query_column_id=>5
,p_column_alias=>'SUB'
,p_column_display_sequence=>5
,p_column_heading=>'Copy?'
,p_use_as_row_header=>'N'
,p_display_as=>'SELECT_LIST_FROM_LOV'
,p_named_lov=>wwv_flow_imp.id(150847232623403358)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'NO'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(91959331738208667)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(320074633987)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(91959515709208671)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46357218068249526)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(91959828764208671)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(46357218068249526)
,p_button_name=>'Copy'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy Item Templates'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(91960120001208672)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(46357218068249526)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(152145216972019088)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(589889427167923039)
,p_branch_action=>'f?p=&APP_ID.:353:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(91960120001208672)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(74786905313611371)
,p_name=>'P657_THEME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(91957200231208656)
,p_prompt=>'Copy to Theme:'
,p_source=>'P353_COPY_TO_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies a collection of templates which define the look and feel of the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(291246814285180721)
,p_validation_name=>'IsOneSelected'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  for i in 1..wwv_flow.g_f01.count loop',
'    if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'') then',
'      return true;',
'    end if;',
'  end loop;',
'  return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'You must select at least one template to be copied.',
''))
,p_when_button_pressed=>wwv_flow_imp.id(91959828764208671)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(291252520303191940)
,p_validation_name=>'IsDupeName'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_found_name varchar2(2000) := null;',
'begin',
'for i in 1..wwv_flow.g_f01.count loop',
'   if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'')',
'      then',
'      for c1 in ( select template_name',
'                  from WWV_FLOW_FIELD_TEMPLATES',
'                  where flow_id = :FB_FLOW_ID',
'                  and security_group_id = (select PROVISIONING_COMPANY_ID',
'                                           from wwv_flow_companies',
'                                           where SHORT_NAME = :COMPANY)',
'                  and template_name = wwv_flow.g_f02(i) ) loop',
'         if c1.template_name is not null then ',
'            if l_found_name is null then ',
'              l_found_name := c1.template_name;',
'            else ',
'              l_found_name := l_found_name||'', ''||c1.template_name;',
'            end if;',
'         end if;',
'      end loop;',
'   end if;',
'end loop;',
'',
'if l_found_name is not null then ',
'return wwv_flow_lang.system_message(''F4000.TEMPLATE_NAME_ALREADY_EXISTS'',',
'                                    l_found_name);',
'end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_when_button_pressed=>wwv_flow_imp.id(91959828764208671)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(589889284496923037)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(91959515709208671)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(589889352716923038)
,p_event_id=>wwv_flow_imp.id(589889284496923037)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(91960529335208674)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'copy item templates'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_template_id number;',
'begin',
'for i in 1..wwv_flow.g_f01.count loop',
'  l_template_id := wwv_flow_id.next_val;',
'',
'  if wwv_flow.g_f03(i) in (''Y'',''SUBSCRIBE'') then',
'    wwv_flow_templates_util.copy_field_template (',
'      p_copy_from_flow_id  => :P655_COPY_FROM_FLOW_ID,',
'      p_flow_id            => :FB_FLOW_ID,',
'      p_from_template_id   => wwv_flow.g_f01(i),',
'      p_to_template_name   => wwv_flow.g_f02(i),',
'      p_to_template_id     => l_template_id,',
'      p_to_theme_id        => :p657_theme,',
'      p_include_subscription => (wwv_flow.g_f03(i)=''SUBSCRIBE'')',
'    );',
'    if wwv_flow.g_f03(i) in (''SUBSCRIBE'') then',
'      wwv_flow_copy_metadata.subscribe_field_template (',
'        p_master_template_id         => wwv_flow.g_f01(i),',
'        p_subscribing_template_id    => l_template_id',
'      );',
'    end if;',
'  end if;',
'end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying item template(s).'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(91959828764208671)
,p_process_success_message=>'Item template(s) copied.'
,p_internal_uid=>91960529335208674
);
end;
/
prompt --application/pages/page_00660
begin
wwv_flow_imp_page.create_page(
 p_id=>660
,p_name=>'Create Static List of Values'
,p_alias=>'CREATE-STATIC-LIST-OF-VALUES'
,p_step_title=>'Create Static List of Values'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var globalPrefix = ''STATIC2:'';',
'',
'function returnStaticLOV () {',
'',
'    var lovString        = globalPrefix;',
'    var hasDisplayValues = 0;',
'',
'    var displayValues = document.wwv_flow.g_f01;',
'    var returnValues  = document.wwv_flow.g_f02',
'',
'    for ( i = 0; returnValues[i]; i++) {',
'        if (displayValues[i].value!='''') {',
'            hasDisplayValues = 1;',
'        }',
'    }',
'',
'    for ( i = 0; returnValues[i]; i++) {',
'        if (returnValues[i].value!='''') {',
'            if (i>0) {',
'                lovString = lovString + '','';',
'            }',
'            if (hasDisplayValues==1) {',
'                if (displayValues[i].value!='''') {',
'                    lovString = lovString + displayValues[i].value+'';'';',
'                } else {',
'                    lovString = lovString + returnValues[i].value+'';'';                    ',
'                }',
'            }',
'            lovString = lovString + returnValues[i].value;',
'        }',
'    }',
'    if (lovString != ''STATIC2:'') {',
'        var targetField = window.opener.$x($v(''P660_LOV_SOURCE_FIELD''));',
'        setValue(targetField,lovString);',
'        targetField.focus();',
'    }    ',
'',
'    window.close();',
'',
'}',
'',
'function parseLOV () {',
'    var l_seperator = '':'';',
'    var returnFieldName = document.getElementById(''P660_LOV_SOURCE_FIELD'').value;    ',
'    var lovSource = window.opener.document.getElementById(returnFieldName).value;',
'    var returnValues  = document.wwv_flow.g_f02;',
'    var displayValues = document.wwv_flow.g_f01;',
'',
'    if (lovSource.substring(0,6)==''STATIC'') {',
'        if (lovSource.substring(0,7)==''STATIC:'') {',
'            globalPrefix = ''STATIC:'';',
'           l_seperator = globalPrefix ;',
'        }  else if (lovSource.substring(0,8)== globalPrefix ) {',
'            l_seperator = globalPrefix  ;',
'        }',
'        var lovSourceComponents = lovSource.split(l_seperator);',
'        var lovItems = lovSourceComponents[1].split('','');',
'        for ( i = 0; lovItems[i]; i++) {',
'            if (lovItems[i].indexOf('';'')>0) {',
'                var lovItemComponents = lovItems[i].split('';'');',
'                displayValues[i].value = lovItemComponents[0];        ',
'                returnValues[i].value  = lovItemComponents[1];        ',
'            } else {',
'                returnValues[i].value = lovItems[i];        ',
'            }',
'        }',
'    }',
'}',
''))
,p_javascript_code_onload=>'parseLOV();'
,p_step_template=>wwv_flow_imp.id(19943204431962826)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_lov.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(42719813681816823)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>92
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(176420402139598395)
,p_name=>'Static List of Values'
,p_template=>wwv_flow_imp.id(42025417508627628)
,p_display_sequence=>100
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select i,',
'       ''<input type="text" size="32" maxlength="255" value="" name="g_f01" id ="g_f01">'' g01,',
'       ''<input type="text" size="32" maxlength="255" value="" name="g_f02" id ="g_f02">'' g02',
'from   wwv_flow_dual100',
'where  i < 16',
'order  by i'))
,p_header=>'Enter static display and return values.  Values will display in the order entered.  '
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(176812318528811250)
,p_query_column_id=>1
,p_column_alias=>'I'
,p_column_display_sequence=>1
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(176812406760811251)
,p_query_column_id=>2
,p_column_alias=>'G01'
,p_column_display_sequence=>2
,p_column_heading=>'Display Value'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(176812514344811251)
,p_query_column_id=>3
,p_column_alias=>'G02'
,p_column_display_sequence=>3
,p_column_heading=>'Return Value'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(177264010169548398)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(42719813681816823)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'javascript:window.close();'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(177113417386746223)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(42719813681816823)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'javascript:returnStaticLOV()'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(177248906565462250)
,p_name=>'P660_LOV_SOURCE_FIELD'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_imp.id(176420402139598395)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_00661
begin
wwv_flow_imp_page.create_page(
 p_id=>661
,p_name=>'Edit Calendar Template'
,p_alias=>'EDIT-CALENDAR-TEMPLATE2'
,p_step_title=>'Edit Calendar Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'EXISTS'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_cal_templates t, wwv_flow_themes th',
'where t.id = :F4000_P697_ID',
'and t.flow_id = th.flow_id',
'and t.theme_id = th.theme_id',
'and t.reference_id is not null',
'and th.reference_id is not null'))
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17909303167190934)
,p_plug_name=>'Month Formats'
,p_region_name=>'MON'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>210
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17909523758190936)
,p_plug_name=>'Hour  Formats'
,p_region_name=>'HOUR'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>310
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17909720651190936)
,p_plug_name=>'Page Button Button Box'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17909931810190937)
,p_plug_name=>'Weekday Formats'
,p_region_name=>'DAY'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>410
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17910129677190937)
,p_plug_name=>'Time Formats'
,p_region_name=>'TIME'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>510
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17910526042190937)
,p_plug_name=>'Calendar Templates'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>600
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Calendar templates control the appearance and placement of a calendar. Calendar templates frequently use HTML tables to arrange dates.</p>',
'<p>You place calendar attributes using substitution strings such as #DD# and  #MONTH#. Template substitution strings must be in upper case and begin and end with a pound sign (#).</p>'))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17910908424190938)
,p_plug_name=>'Substitution Strings'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>710
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The following date format substitution strings are available:</p>',
'<ul class="noIndent">',
'<li>DAY</li>',
'<li>DD</li>',
'<li>MON</li>',
'<li>YYYY</li>',
'<li>MM</li>',
'<li>MONTH</li>',
'<li>YY</li>',
'<li>RR</li>',
'<li>YEAR</li>',
'<li>WW</li>',
'<li>W</li>',
'<li>DDD</li>',
'<li>D</li>',
'<li>DY</li>',
'<li>DDSPTH</li>',
'<li>HH</li>',
'<li>HH12</li>',
'<li>HH24</li>',
'<li>AM</li>',
'<li>PM</li>',
'<li>MI</li>',
'<li>SYEAR</li>',
'<li>BC</li>',
'<li>CC</li>',
'<li>SCC</li>',
'<li>IYYY</li>',
'<li>Q</li>',
'<li>FMMONTH</li>',
'<li>RM</li>',
'<li>IW</li>',
'<li>FMDAY</li>',
'<li>DDTH</li>',
'<li>DDSPTH</li>',
'<li>J</li>',
'</ul>',
'<p>Placing an "I" in front of any string will INITCAP the text.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17911122903190939)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(12991522578387911)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46234415190678960)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>15
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(17913025405190949)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(17909720651190936)
,p_button_name=>'APPLY_CHANGES_GET_PREVIOUS_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'disabled=""'
,p_button_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(17912800607190949)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_imp.id(17909720651190936)
,p_button_name=>'APPLY_CHANGES_GET_NEXT_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Next'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'disabled=""'
,p_button_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(17912213681190947)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(17909720651190936)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(17912609970190949)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(17909720651190936)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:504:&SESSION.::&DEBUG.::P504_ID:&P661_ID.'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P697_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(17912019745190946)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(17909720651190936)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P697_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(17926419819190973)
,p_branch_action=>'f?p=&APP_ID.:661:&SESSION.::&DEBUG.::P661_ID:&P661_ID_NEXT.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(17912800607190949)
,p_branch_sequence=>21
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(17926617105190973)
,p_branch_action=>'f?p=&APP_ID.:661:&SESSION.::&DEBUG.::P661_ID:&P661_ID_PREV.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(17913025405190949)
,p_branch_sequence=>21
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(30776715995916612)
,p_branch_action=>'f?p=&APP_ID.:836:&SESSION.::&DEBUG.::P836_ID:&P661_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>35
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_CUSTOM_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(17933207317256955)
,p_branch_action=>'f?p=&APP_ID.:670:&SESSION.::&DEBUG.::P670_ID:&P661_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>37
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_WEEKLY_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(22157104709090132)
,p_branch_action=>'f?p=&APP_ID.:122:&SESSION.::&DEBUG.::P122_ID:&P661_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>38
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_MONTHLY_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3711628915280141)
,p_branch_action=>'f?p=&APP_ID.:80:&SESSION.::&DEBUG.::P80_ID:&P661_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>48
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_AGENDA_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(22190129784182548)
,p_branch_action=>'f?p=&APP_ID.:697:&SESSION.::&DEBUG.::F4000_P697_ID:&P661_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>59
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_CALENDAR_DEFINITION'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(17927030531190974)
,p_branch_action=>'f?p=&APP_ID.:661:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>110
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P661_STAY'
,p_branch_condition_text=>'YES'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(17927229518190974)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>139
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(17927426481190974)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>140
,p_branch_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17913220094190950)
,p_name=>'P661_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>0
,p_item_display_point=>'LEGACY_ORPHAN_COMPONENTS'
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17913408038190953)
,p_name=>'P661_DAILY_MONTH_TITLE_FORMAT'
,p_item_sequence=>8
,p_item_plug_id=>wwv_flow_imp.id(17909303167190934)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Month Title Format'
,p_source=>'DAILY_MONTH_TITLE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the format for the monthly title that appears at the top of each day. This is the first part of a calendar which is printed on the page.',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'&lt;table&gt;',
' &lt;tr&gt;',
'   &lt;td&gt;#MONTH#&lt;/td&gt;',
' &lt;/tr&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17913824377190955)
,p_name=>'P661_DAILY_DAY_OF_WEEK_FORMAT'
,p_item_sequence=>9
,p_item_plug_id=>wwv_flow_imp.id(17909303167190934)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Day Of Week Format'
,p_source=>'DAILY_DAY_OF_WEEK_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the format for the week day names which display as the column header for that day of the week.  ',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'   &lt;th width="14%"&gt;#IDAY#&lt;/th&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17914308300190955)
,p_name=>'P661_DAILY_MONTH_OPEN_FORMAT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(17909303167190934)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Month Open Format'
,p_source=>'DAILY_MONTH_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the HTML to be used to open a day.  This is printed immediately after the "Month Title Format".  Usually this would be an HTML tag which is a container such as a table.  ',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'   &lt;table  border="0" cellpadding="0" cellspacing="0" class="htmldbRowWithBorders" width="100%"&gt;&lt;tr&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17914818538190955)
,p_name=>'P661_DAILY_MONTH_CLOSE_FORMAT'
,p_item_sequence=>11
,p_item_plug_id=>wwv_flow_imp.id(17909303167190934)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Month Close Format'
,p_source=>'DAILY_MONTH_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the HTML to be used to close a day.  This is the last part printed so this should close any HTML tags which have been used such as the tag used in the "Month Open Format"',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'   &lt;/table&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17915316109190956)
,p_name=>'P661_DAILY_DAY_TITLE_FORMAT'
,p_item_sequence=>12
,p_item_plug_id=>wwv_flow_imp.id(17909931810190937)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Day Title Format'
,p_source=>'DAILY_DAY_TITLE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the HTML to be used for the day''s title which the first thing printed after the "Day Open Format" ',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'#DD#',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17915821985190956)
,p_name=>'P661_DAILY_DAY_OPEN_FORMAT'
,p_item_sequence=>13
,p_item_plug_id=>wwv_flow_imp.id(17909931810190937)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Day Open Format'
,p_source=>'DAILY_DAY_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the HTML to be used to opening a day. This is printed for each day. Usually this would be an HTML tag which is a container such as a td.  Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.'
||' For example:',
'<pre>',
' &lt;td&gt',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17916325419190956)
,p_name=>'P661_DAILY_DAY_CLOSE_FORMAT'
,p_item_sequence=>14
,p_item_plug_id=>wwv_flow_imp.id(17909931810190937)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Day Close Format'
,p_source=>'DAILY_DAY_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the HTML to be used to close a day.  This is the last part of each day printed so this should close any HTML tags which have been used such as the tag used in the "Day Open Format"',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'   &lt;/td&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17916821541190956)
,p_name=>'P661_DAILY_TODAY_OPEN_FORMAT'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_imp.id(17909931810190937)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Today Open Format'
,p_source=>'DAILY_TODAY_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the HTML to be used to open today. Usually this would be an HTML tag which is a container such as a td and would be different somehow from the "Day Open Format". Include substitution strings to include dynamic content. See the "Substitution Str'
||'ings" for the full list. For example:',
'<pre>',
'  &lt;td style="background:#c5d5c5"&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17918812994190958)
,p_name=>'P661_DAILY_TIME_TITLE_FORMAT'
,p_item_sequence=>19
,p_item_plug_id=>wwv_flow_imp.id(17910129677190937)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Time Title Format'
,p_source=>'DAILY_TIME_TITLE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter HTML used to format a Time title. For example, suppose you want to display hour with minute in the time column then you can use HH:MI.',
'<p> See the "Substitution Strings" for the full list. For example:',
'<pre>',
'  #HH#:#MI#',
'</pre>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17919324110190958)
,p_name=>'P661_DAILY_TIME_OPEN_FORMAT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(17910129677190937)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Time Open Format'
,p_source=>'DAILY_TIME_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter HTML to open a Time. ',
'',
'<p>Usually this would be an HTML tag which is a container such as a td. Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list. For example:',
'<pre>',
'  &lt;td&gt;',
'</pre>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17919829636190958)
,p_name=>'P661_DAILY_TIME_CLOSE_FORMAT'
,p_item_sequence=>21
,p_item_plug_id=>wwv_flow_imp.id(17910129677190937)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Time Close Format'
,p_source=>'DAILY_TIME_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the html which will close a Time.  ',
'<p>Usually this would be an HTML tag which closes the tag used in the "Time Open Format".',
' Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list. For example:',
'<pre>',
'  &lt;/td&gt;',
'</pre>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17920800891190959)
,p_name=>'P661_DAILY_HOUR_OPEN_FORMAT'
,p_item_sequence=>23
,p_item_plug_id=>wwv_flow_imp.id(17909523758190936)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Hour Open Format'
,p_source=>'DAILY_HOUR_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the HTML to be used to open a Hour. This is printed for each Hour. Usually this would be an HTML tag which is a container such as a tr. Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list. F'
||'or example:',
'<pre>',
' &lt;tr&gt;'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17921320545190959)
,p_name=>'P661_DAILY_HOUR_CLOSE_FORMAT'
,p_item_sequence=>24
,p_item_plug_id=>wwv_flow_imp.id(17909523758190936)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Hour Close Format'
,p_source=>'DAILY_HOUR_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the HTML to be used to close a Hour.  This is the last part printed so this should close any HTML tags which have been used such as the tag used in the "Hour Open Format"',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'   &lt;/tr&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17923308184190961)
,p_name=>'P661_STAY'
,p_item_sequence=>38
,p_item_plug_id=>wwv_flow_imp.id(17910526042190937)
,p_prompt=>'Stay on page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select this checkbox to stay on this page after applying changes.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'YES'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17923817764190961)
,p_name=>'P661_ID_NEXT'
,p_item_sequence=>88
,p_item_plug_id=>wwv_flow_imp.id(17909720651190936)
,p_prompt=>'P661_ID_NEXT'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17924020322190962)
,p_name=>'P661_ID_PREV'
,p_item_sequence=>98
,p_item_plug_id=>wwv_flow_imp.id(17909720651190936)
,p_prompt=>'P661_ID_PREV'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17924229786190963)
,p_name=>'P661_ID_COUNT'
,p_item_sequence=>108
,p_item_plug_id=>wwv_flow_imp.id(17909720651190936)
,p_prompt=>'Calendar Template: '
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies calendar template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(397293327628421296)
,p_name=>'ENABLE PREVIOUS'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P661_ID_PREV'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(397293620131421296)
,p_event_id=>wwv_flow_imp.id(397293327628421296)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(17913025405190949)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(397293701094423047)
,p_name=>'ENABLE NEXT'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P661_ID_NEXT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(397294005920423048)
,p_event_id=>wwv_flow_imp.id(397293701094423047)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(17912800607190949)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(17924929977190968)
,p_process_sequence=>1
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_CAL_TEMPLATES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_CAL_TEMPLATES'
,p_attribute_03=>'P661_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Unable to fetch row.'
,p_internal_uid=>17924929977190968
,p_process_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(17925127241190970)
,p_process_sequence=>11
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_PAGINATION'
,p_process_name=>'Get Next or Previous Primary Key Value'
,p_attribute_02=>'WWV_FLOW_CAL_TEMPLATES'
,p_attribute_03=>'P661_ID'
,p_attribute_04=>'ID'
,p_attribute_07=>'THEME_ID'
,p_attribute_08=>'NAME'
,p_attribute_09=>'P661_ID_NEXT'
,p_attribute_10=>'P661_ID_PREV'
,p_attribute_13=>'P661_ID_COUNT'
,p_attribute_14=>'flow_id = :fb_flow_id'
,p_process_error_message=>'Unable to run Get Next or Previous Primary Key Value process.'
,p_internal_uid=>17925127241190970
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(17925318273190970)
,p_process_sequence=>1
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_CAL_TEMPLATES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_CAL_TEMPLATES'
,p_attribute_03=>'P661_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Unable to process calendar template.'
,p_process_when=>'COPY_TEMPLATE'
,p_process_when_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>17925318273190970
,p_process_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(17925510113190971)
,p_process_sequence=>2
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'122'
,p_process_when_button_id=>wwv_flow_imp.id(17912609970190949)
,p_internal_uid=>17925510113190971
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(17925701932190971)
,p_process_sequence=>12
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh calendar template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_calendar_template (',
'    p_master_template_id         => :P661_REFERENCE_ID,',
'    p_subscribing_template_id    => :P661_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying template.'
,p_process_when=>'P661_REFERENCE_ID'
,p_process_when_type=>'NEVER'
,p_process_when2=>'0'
,p_process_success_message=>'Template copied.'
,p_internal_uid=>17925701932190971
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(17925903342190971)
,p_process_sequence=>12
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove reference id'
,p_process_sql_clob=>'wwv_flow_copy_metadata.remove_button_reference_id (:P661_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error setting template id to null.'
,p_process_when=>'P661_REFERENCE_ID'
,p_process_when_type=>'NEVER'
,p_process_when2=>'0'
,p_process_success_message=>'Reference id is removed.'
,p_internal_uid=>17925903342190971
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(17926104695190971)
,p_process_sequence=>32
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh calendar template 2'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_calendar_template (',
'    p_master_template_id         => :P661_REFERENCE_ID,',
'    p_subscribing_template_id    => :P661_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying template.'
,p_process_when_button_id=>wwv_flow_imp.id(17912019745190946)
,p_process_when=>':P661_REFERENCE_ID is not null and :P661_REFRESH = ''Y'''
,p_process_when_type=>'NEVER'
,p_process_success_message=>'Template copied.'
,p_internal_uid=>17926104695190971
);
end;
/
prompt --application/pages/page_00663
begin
wwv_flow_imp_page.create_page(
 p_id=>663
,p_name=>'Copy List'
,p_alias=>'COPY-LIST'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy List'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'nav_list_create.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46416204991627232)
,p_plug_name=>'Wizard Button'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(231161723063771921)
,p_plug_name=>'Copy List'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(231162304281771925)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46416204991627232)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(231162505796771925)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(46416204991627232)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(231190423832832583)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(231162505796771925)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(15001557276753506)
,p_name=>'P663_SUBSCRIBE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(231161723063771921)
,p_item_default=>'Y'
,p_prompt=>'Subscribe'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'While copying the list, you can also subscribe to it. Set Subscribe to <strong>On</strong> to subscribe to the list.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(15301156079832103)
,p_name=>'P663_COPY_SOURCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(231161723063771921)
,p_item_default=>'THIS'
,p_prompt=>'Copy From'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'COPY_SOURCE'
,p_lov=>'.'||wwv_flow_imp.id(9000141896148406)||'.'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose whether to copy the list from this application or from another application.'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(211669314246693889)
,p_name=>'P663_COPY_FROM_APPLICATION_ID'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(231161723063771921)
,p_prompt=>'Application'
,p_source=>'&FB_FLOW_ID.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d,',
'       f.id r',
'  from wwv_flow_visible_flows f',
' where (:P663_COPY_SOURCE = ''THIS''  and f.id = :FB_FLOW_ID)',
'    or (:P663_COPY_SOURCE = ''OTHER'' and f.id != :FB_FLOW_ID)',
' order by 2'))
,p_lov_cascade_parent_items=>'P663_COPY_SOURCE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Select the application from which you want to copy a list.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231179815605811273)
,p_name=>'P663_LIST_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(231161723063771921)
,p_prompt=>'New List Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identify the name of the list you would like to create.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231183131881815979)
,p_name=>'P663_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(231161723063771921)
,p_prompt=>'Copy List'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(NAME) ln, id',
'  from wwv_flow_lists',
' where flow_id           = :P663_COPY_FROM_APPLICATION_ID',
'   and security_group_id = :WORKSPACE_ID',
' order by upper(name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select List -'
,p_lov_null_value=>'0'
,p_lov_cascade_parent_items=>'P663_COPY_FROM_APPLICATION_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the list to copy.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(231205701416882820)
,p_validation_name=>'P663_ID Not Null'
,p_validation_sequence=>20
,p_validation=>'P663_ID'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'List must be selected.'
,p_when_button_pressed=>wwv_flow_imp.id(231162505796771925)
,p_associated_item=>wwv_flow_imp.id(231183131881815979)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 14-JUN-2006 17:19'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(231205930835882826)
,p_validation_name=>'P663_LIST_NAME Not Null'
,p_validation_sequence=>30
,p_validation=>'P663_LIST_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'New List Name must be specified.'
,p_validation_condition=>'P663_SUBSCRIBE'
,p_validation_condition2=>'N'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(231162505796771925)
,p_associated_item=>wwv_flow_imp.id(231179815605811273)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3211345923715478)
,p_validation_name=>'List name unique'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_lists',
' where security_group_id = :WORKSPACE_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and name              = :P663_LIST_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#LABEL# must be unique.'
,p_validation_condition=>'P663_SUBSCRIBE'
,p_validation_condition2=>'N'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(231162505796771925)
,p_associated_item=>wwv_flow_imp.id(231179815605811273)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4171950758198017)
,p_validation_name=>'Subscribed List name unique'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_lists',
' where security_group_id = :WORKSPACE_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and name              = (',
'       select name ',
'         from wwv_flow_lists',
'        where security_group_id = :WORKSPACE_ID',
'          and flow_id           = :P663_COPY_FROM_APPLICATION_ID',
'          and id                = :P663_ID )'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Unable to subscribe, the list already exists.'
,p_validation_condition=>'P663_SUBSCRIBE'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(231162505796771925)
,p_associated_item=>wwv_flow_imp.id(231183131881815979)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1408897980532084)
,p_validation_name=>'No duplicate subscription'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_lists',
' where security_group_id = :WORKSPACE_ID ',
'   and flow_id           = :FB_FLOW_ID ',
'   and reference_id      = :P663_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'There is another list in this application that is subscribed to the same master. Please select another master list.'
,p_validation_condition=>'P663_SUBSCRIBE'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(231162505796771925)
,p_associated_item=>wwv_flow_imp.id(231183131881815979)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(574136433748781520)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(231162304281771925)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(574136582739781521)
,p_event_id=>wwv_flow_imp.id(574136433748781520)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(15601382431279335)
,p_name=>'On Change of P663_COPY_SOURCE'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P663_COPY_SOURCE'
,p_condition_element=>'P663_COPY_SOURCE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'THIS'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(15601757038279606)
,p_event_id=>wwv_flow_imp.id(15601382431279335)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P663_COPY_FROM_APPLICATION_ID,P663_SUBSCRIBE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(15602178508279608)
,p_event_id=>wwv_flow_imp.id(15601382431279335)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P663_COPY_FROM_APPLICATION_ID,P663_SUBSCRIBE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(15602614849279609)
,p_event_id=>wwv_flow_imp.id(15601382431279335)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P663_COPY_FROM_APPLICATION_ID'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'&FB_FLOW_ID.'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(15001670157753507)
,p_event_id=>wwv_flow_imp.id(15601382431279335)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P663_SUBSCRIBE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(15603151010279609)
,p_event_id=>wwv_flow_imp.id(15601382431279335)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P663_COPY_FROM_APPLICATION_ID'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(15001726205753508)
,p_event_id=>wwv_flow_imp.id(15601382431279335)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P663_SUBSCRIBE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(15001881151753509)
,p_name=>'Toggle P663_LIST_NAME display'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P663_SUBSCRIBE'
,p_condition_element=>'P663_SUBSCRIBE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(15001941687753510)
,p_event_id=>wwv_flow_imp.id(15001881151753509)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P663_LIST_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(15002058907753511)
,p_event_id=>wwv_flow_imp.id(15001881151753509)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P663_LIST_NAME'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(231189513443829540)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create List'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_list_id   number;',
' begin    ',
'    wwv_flow_copy_metadata.copy_list_from_app (',
'        p_copy_from_app_id     => :P663_COPY_FROM_APPLICATION_ID,',
'        p_copy_from_list_id    => :P663_ID,',
'        p_new_list_name        => case when :P663_SUBSCRIBE != ''Y'' then :P663_LIST_NAME end,',
'        p_new_application_id   => :FB_FLOW_ID,',
'        p_include_subscription => :P663_SUBSCRIBE = ''Y'',',
'        p_new_list_id          => l_list_id );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to Copy List'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(231162505796771925)
,p_process_success_message=>'List Copied'
,p_internal_uid=>231189513443829540
);
end;
/
prompt --application/pages/page_00665
begin
wwv_flow_imp_page.create_page(
 p_id=>665
,p_name=>'Developer Comments Calendar'
,p_alias=>'DEVELOPER-COMMENTS-CALENDAR1'
,p_step_title=>'Developer Comments Calendar'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
,p_page_component_map=>'08'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(702933455360235067)
,p_plug_name=>'Cross Application Reports'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(702923103587108064)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(702935214678239724)
,p_plug_name=>'Application Comments'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4050P665a */',
'       trunc(created_on) created_on,',
'       flow_id || '': '' || created_by || '' - '' || count(*) as display_title',
'  from WWV_FLOW_APP_COMMENTS',
' where security_group_id = :flow_security_group_id',
' group by flow_id, trunc(created_on), created_by'))
,p_lazy_loading=>true
,p_plug_source_type=>'NATIVE_CSS_CALENDAR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'additional_calendar_views', 'month:list:navigation',
  'display_column', 'DISPLAY_TITLE',
  'maximum_events_day', '10',
  'multiple_line_event', 'Y',
  'show_time', 'N',
  'show_tooltip', 'N',
  'show_weekend', 'Y',
  'start_date_column', 'CREATED_ON')).to_clob
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(217704101671880031)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Adjust Calendar Date -Previous'
,p_process_sql_clob=>' wwv_flow_utilities.decrement_calendar;'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error changing calendar date.'
,p_internal_uid=>217704101671880031
,p_process_comment=>'Generated 07-JUN-06'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(217704512411880032)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Adjust Calendar Date -Next'
,p_process_sql_clob=>' wwv_flow_utilities.increment_calendar;'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error changing calendar date.'
,p_internal_uid=>217704512411880032
,p_process_comment=>'Generated 07-JUN-06'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(217704300757880032)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Adjust Calendar Date -Today'
,p_process_sql_clob=>' wwv_flow_utilities.today_calendar;'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error changing calendar date.'
,p_internal_uid=>217704300757880032
,p_process_comment=>'Generated 07-JUN-06'
);
end;
/
prompt --application/pages/page_00666
begin
wwv_flow_imp_page.create_page(
 p_id=>666
,p_name=>'Debug Messages'
,p_alias=>'DEBUG-MESSAGES'
,p_step_title=>'Debug Messages'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'debug.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(623982424231484061)
,p_plug_name=>'Debug Output'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select session_id, apex_user, page_view_id, message_timestamp, debug_entries, application_id, page_id, workflow_instance_id, elap elapsed from',
'(',
'select ',
'    session_id,',
'    max(apex_user) apex_user,',
'    page_view_id,',
'    min(message_timestamp) message_timestamp, ',
'    max(page_id) page_id,',
'    max(workflow_instance_id) workflow_instance_id,',
'    max(flow_id) application_id,',
'    count(*) debug_entries,',
'   max(elap) elap',
'from wwv_flow_debug_messages m',
'where security_group_id = :flow_security_group_id ',
'and flow_id = :fb_flow_id',
'group by session_id,  page_view_id',
'union all',
'select ',
'    session_id,',
'    max(apex_user) apex_user,',
'    page_view_id,',
'     min(message_timestamp) message_timestamp, ',
'    max(page_id) page_id,',
'    max(workflow_instance_id) workflow_instance_id,',
'    max(flow_id) application_id,',
'    count(*) debug_entries,',
'   max(elap) elap',
'from wwv_flow_debug_messages2 m',
'where security_group_id = :flow_security_group_id ',
'and flow_id = :fb_flow_id',
'group by session_id, page_view_id',
') x'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(623982508550484061)
,p_name=>'Debug Output - Disabled'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(623982725835484064)
,p_db_column_name=>'SESSION_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Session'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(623982829074484066)
,p_db_column_name=>'APEX_USER'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'User'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(623982931967484066)
,p_db_column_name=>'PAGE_VIEW_ID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'View Identifier'
,p_column_link=>'f?p=&APP_ID.:938:&SESSION.::&DEBUG.:RP,RIR:P938_PAGE_VIEW_ID:#PAGE_VIEW_ID#'
,p_column_linktext=>'#PAGE_VIEW_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(623983222335484067)
,p_db_column_name=>'DEBUG_ENTRIES'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Entries'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(623983314383484067)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(623983522277484067)
,p_db_column_name=>'ELAPSED'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Seconds'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G990D999'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(623984406719501366)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1803239854977030)
,p_db_column_name=>'WORKFLOW_INSTANCE_ID'
,p_display_order=>20
,p_column_identifier=>'L'
,p_column_label=>'Workflow Instance'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(623986004650576482)
,p_db_column_name=>'MESSAGE_TIMESTAMP'
,p_display_order=>30
,p_column_identifier=>'K'
,p_column_label=>'Timestamp'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(623985406251567425)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1290229496536644'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'PAGE_VIEW_ID:APEX_USER:APPLICATION_ID:PAGE_ID:DEBUG_ENTRIES:MESSAGE_TIMESTAMP:ELAPSED:'
,p_sort_column_1=>'MESSAGE_TIMESTAMP'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(623986821404590758)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(623982424231484061)
,p_button_name=>'RESET_REPORT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:666:&SESSION.::&DEBUG.:666,RIR::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(624014013653929040)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(623982424231484061)
,p_button_name=>'PURGE_DEBUG'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Purge Debug Messages'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:748:&SESSION.::&DEBUG.:748::'
);
end;
/
prompt --application/pages/page_00667
begin
wwv_flow_imp_page.create_page(
 p_id=>667
,p_name=>'Upgrade'
,p_alias=>'UPGRADE'
,p_step_title=>'Upgrade'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deployment.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(23543620471277777)
,p_plug_name=>'Supporting Object Definition tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(22452018965176093)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(24445623838690007)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(24172418538839346)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(24527100298108928)
,p_plug_name=>'Detect Existing Supporting Objects'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This query determines if supporting objects are already installed and in need of an upgrade.</p><p />',
'Identify the SQL query that returns at least one row if supporting objects exist.  The query should return no rows if no supporting objects exist.<p />'))
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>'select id from wwv_flow_install where flow_id = :fb_flow_id'
,p_plug_footer=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Example:',
'',
'SELECT OBJECT_NAME FROM SYS.USER_OBJECTS WHERE OBJECT_NAME = ''MY_APPLICATION_TABLE'''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(380035546592486164)
,p_plug_name=>'Upgrade Scripts'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>40
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select s.id,',
'       case when (l.locked_by is null) or (l.locked_by is not null and l.locked_by = :APP_USER) then',
'           ''<a href="''',
'           ||wwv_flow_page_api.get_url (',
'                 p_page        => 865,',
'                 p_clear_cache => 865,',
'                 p_items       => ''P865_SCRIPT_ID,P865_MODE,F4000_LAST_VIEW'',',
'                 p_values      => s.id||'',EDIT,667'' )',
'           ||''">''',
'           ||''<img src="#IMAGE_PREFIX#menu/pencil2_16x16.gif" alt="''||sm.edit||''"></a>''',
'       end edit_link,',
'       s.name,',
'       s.sequence,',
'       lower(nvl(s.last_updated_by,s.created_by)) last_updated_by,',
'       nvl(s.last_updated_on, s.created_on) "LAST_UPDATED_ON",',
'       sys.dbms_lob.substr(s.script,200,1)||(case when sys.dbms_lob.getlength(s.script) > 200 then ''...'' end) script,',
'       case when l.locked_by is null then',
'           wwv_flow_lang.system_message(''SCRIPT_NAME_UNLOCKED'', wwv_flow_escape.html(s.name))',
'       else',
'           wwv_flow_lang.system_message(''SCRIPT_NAME_LOCKED'', wwv_flow_escape.html(s.name))',
'       end locked,',
'       case when l.locked_by is null then',
'           ''icon-unlock''',
'       else',
'           ''icon-lock''',
'       end lock_icon,',
'       l.id lock_id',
'  from "#OWNER#"."WWV_FLOW_INSTALL_SCRIPTS" s,',
'       wwv_flow_lock_script l,',
'       (select wwv_flow_lang.system_message(''EDIT'') edit from dual) sm',
' where s.flow_id                    = :FB_FLOW_ID',
'   and s.security_group_id          = :FLOW_SECURITY_GROUP_ID',
'   and s.id                         = l.script_id(+)',
'   and nvl(s.script_type,''INSTALL'') = ''UPGRADE'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(380035630081486164)
,p_name=>'Upgrade Scripts'
,p_max_row_count=>'1000000'
,p_max_row_count_message=>'The maximum row count for this report is #MAX_ROW_COUNT# rows.  Please apply a filter to reduce the number of records in your query.'
,p_no_data_found_message=>'No upgrade scripts found.'
,p_allow_report_categories=>'N'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'CBCHO'
,p_internal_uid=>380035630081486164
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(380035832666486172)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(925398888994092867)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>11
,p_column_identifier=>'G'
,p_column_label=>'<br />'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(380035937423486177)
,p_db_column_name=>'NAME'
,p_display_order=>21
,p_column_identifier=>'B'
,p_column_label=>'Name'
,p_column_link=>'f?p=&APP_ID.:328:&SESSION.::&DEBUG.:328:P328_ID,F4000_LAST_VIEW:#ID#,667'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(380036038287486177)
,p_db_column_name=>'SEQUENCE'
,p_display_order=>31
,p_column_identifier=>'C'
,p_column_label=>'Sequence'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(380036162219486177)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>41
,p_column_identifier=>'D'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(380036238021486177)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>51
,p_column_identifier=>'E'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(380036320379486178)
,p_db_column_name=>'SCRIPT'
,p_display_order=>61
,p_column_identifier=>'F'
,p_column_label=>'Script'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(858630946975067912)
,p_db_column_name=>'LOCKED'
,p_display_order=>81
,p_column_identifier=>'H'
,p_column_label=>'Lock'
,p_column_link=>'f?p=&APP_ID.:16:&SESSION.::&DEBUG.:Y,16:P16_LOCK_SCRIPT_ID,P16_LOCK_ID:#ID#,#LOCK_ID#'
,p_column_linktext=>'<span class="a-Icon #LOCK_ICON#" ></span><span class="u-VisuallyHidden">#LOCKED#</span>'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1803428504462333)
,p_db_column_name=>'LOCK_ICON'
,p_display_order=>91
,p_column_identifier=>'J'
,p_column_label=>'Lock Icon'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1803515889462334)
,p_db_column_name=>'LOCK_ID'
,p_display_order=>101
,p_column_identifier=>'K'
,p_column_label=>'Lock Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(380036549255488918)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'3800366'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_display_rows=>100
,p_report_columns=>'EDIT_LINK:LOCKED:NAME:SEQUENCE:SCRIPT:LAST_UPDATED_ON:LAST_UPDATED_BY::LOCK_ICON:LOCK_ID'
,p_sort_column_1=>'SEQUENCE'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'0'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(24527314121108929)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(24527100298108928)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'CREATE'
,p_button_execute_validations=>'N'
,p_button_condition=>'P667_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(24442809434687128)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(380035546592486164)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:2:&SESSION.::&DEBUG.:RP::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(24443015336687128)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(380035546592486164)
,p_button_name=>'CREATESCRIPT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:850:&SESSION.::&DEBUG.:850:P850_MODE,F4000_LAST_VIEW:UPGRADE,667'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(24437723014680262)
,p_branch_name=>'Go To Page &P567_BRANCH_PAGE.'
,p_branch_action=>'f?p=&APP_ID.:&P567_BRANCH_PAGE.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>51
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'substr(:REQUEST,1,13) = ''APPLY_CHANGES'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(24527706002108929)
,p_branch_action=>'f?p=&APP_ID.:667:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(24527927496108929)
,p_name=>'P667_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(24527100298108928)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(24528104728108931)
,p_name=>'P667_QUERY'
,p_item_sequence=>690
,p_item_plug_id=>wwv_flow_imp.id(24527100298108928)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Query to Detect Existing Supporting Objects:'
,p_source=>'GET_VERSION_SQL_QUERY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>14
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Write a SQL query that returns at least one row if supporting objects exist for this application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(24437018512678938)
,p_computation_sequence=>20
,p_computation_item=>'P567_BRANCH_PAGE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'substr(v(''REQUEST''),15)'
,p_compute_when=>'substr(:REQUEST,1,13) = ''APPLY_CHANGES'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(24544519869152501)
,p_computation_sequence=>30
,p_computation_item=>'P667_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>'select id from wwv_flow_install where flow_id = :fb_flow_id and security_group_id = :flow_security_group_id'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(927015690197639630)
,p_computation_sequence=>30
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'667'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1119156918584390632)
,p_name=>'Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(380035546592486164)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1119157014259390633)
,p_event_id=>wwv_flow_imp.id(1119156918584390632)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(380035546592486164)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(24528413966108931)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_INSTALL'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_INSTALL'
,p_attribute_03=>'P667_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Unable to fetch row.'
,p_internal_uid=>24528413966108931
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(24528625968108931)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_INSTALL'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_INSTALL'
,p_attribute_03=>'P667_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'U'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Unable to process row of table WWV_FLOW_INSTALL.'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>24528625968108931
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(24528806756108931)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'667'
,p_internal_uid=>24528806756108931
);
end;
/
prompt --application/pages/page_00670
begin
wwv_flow_imp_page.create_page(
 p_id=>670
,p_name=>'Edit Calendar Template'
,p_alias=>'EDIT-CALENDAR-TEMPLATE3'
,p_step_title=>'Edit Calendar Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'EXISTS'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_cal_templates t, wwv_flow_themes th',
'where t.id = :F4000_P697_ID',
'and t.flow_id = th.flow_id',
'and t.theme_id = th.theme_id',
'and t.reference_id is not null',
'and th.reference_id is not null'))
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17284317885778633)
,p_plug_name=>'Page Button Button Box'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17284900057778634)
,p_plug_name=>'Month Formats'
,p_region_name=>'MON'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>210
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17285128475778635)
,p_plug_name=>'Hour  Formats'
,p_region_name=>'HOUR'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>310
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17285313089778635)
,p_plug_name=>'Weekday Formats'
,p_region_name=>'DAY'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>410
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17285502189778635)
,p_plug_name=>'Time Formats'
,p_region_name=>'TIME'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>510
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17285715096778635)
,p_plug_name=>'Weekend Formats'
,p_region_name=>'END'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>610
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17285906179778635)
,p_plug_name=>'Calendar Templates'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>600
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Calendar templates control the appearance and placement of a calendar. Calendar templates frequently use HTML tables to arrange dates.</p>',
'<p>You place calendar attributes using substitution strings such as #DD# and  #MONTH#. Template substitution strings must be in upper case and begin and end with a pound sign (#).</p>'))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17286520844778637)
,p_plug_name=>'Substitution Strings'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>710
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The following date format substitution strings are available:</p>',
'<ul class="noIndent">',
'<li>DAY</li>',
'<li>DD</li>',
'<li>MON</li>',
'<li>YYYY</li>',
'<li>MM</li>',
'<li>MONTH</li>',
'<li>YY</li>',
'<li>RR</li>',
'<li>YEAR</li>',
'<li>WW</li>',
'<li>W</li>',
'<li>DDD</li>',
'<li>D</li>',
'<li>DY</li>',
'<li>DDSPTH</li>',
'<li>HH</li>',
'<li>HH12</li>',
'<li>HH24</li>',
'<li>AM</li>',
'<li>PM</li>',
'<li>MI</li>',
'<li>SYEAR</li>',
'<li>BC</li>',
'<li>CC</li>',
'<li>SCC</li>',
'<li>IYYY</li>',
'<li>Q</li>',
'<li>FMMONTH</li>',
'<li>RM</li>',
'<li>IW</li>',
'<li>FMDAY</li>',
'<li>DDTH</li>',
'<li>DDSPTH</li>',
'<li>J</li>',
'<li>WTITLE</li>',
'</ul>',
'<p>Placing an "I" in front of any string will INITCAP the text.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17286900148778638)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(12991522578387911)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46237512121678967)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>15
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(17289018915778641)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(17284317885778633)
,p_button_name=>'APPLY_CHANGES_GET_PREVIOUS_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'disabled=""'
,p_button_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(17288816609778641)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_imp.id(17284317885778633)
,p_button_name=>'APPLY_CHANGES_GET_NEXT_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Next'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'disabled=""'
,p_button_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(17288201639778641)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(17284317885778633)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(17288607720778641)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(17284317885778633)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:504:&SESSION.::&DEBUG.::P504_ID:&P670_ID.'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P697_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(17288031005778641)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(17284317885778633)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P697_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(17305417854778663)
,p_branch_action=>'f?p=&APP_ID.:670:&SESSION.::&DEBUG.::P670_ID:&P670_ID_NEXT.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(17288816609778641)
,p_branch_sequence=>21
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(17305606451778663)
,p_branch_action=>'f?p=&APP_ID.:670:&SESSION.::&DEBUG.::P670_ID:&P670_ID_PREV.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(17289018915778641)
,p_branch_sequence=>21
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(17932209610248166)
,p_branch_action=>'f?p=&APP_ID.:661:&SESSION.::&DEBUG.::P661_ID:&P670_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>33
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_DAILY_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(22157828604097018)
,p_branch_action=>'f?p=&APP_ID.:122:&SESSION.::&DEBUG.::P122_ID:&P670_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>35
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_MONTHLY_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(30776531794911691)
,p_branch_action=>'f?p=&APP_ID.:836:&SESSION.::&DEBUG.::P836_ID:&P670_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>35
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_CUSTOM_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3710722551268819)
,p_branch_action=>'f?p=&APP_ID.:80:&SESSION.::&DEBUG.::P80_ID:&P670_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>45
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_AGENDA_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(22191119179188943)
,p_branch_action=>'f?p=&APP_ID.:697:&SESSION.::&DEBUG.::F4000_P697_ID:&P670_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>56
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_CALENDAR_DEFINITION'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(17306018604778663)
,p_branch_action=>'f?p=&APP_ID.:670:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>110
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P670_STAY'
,p_branch_condition_text=>'YES'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(17306217099778664)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>139
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(17306400038778664)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>140
,p_branch_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17289224574778642)
,p_name=>'P670_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>0
,p_item_display_point=>'LEGACY_ORPHAN_COMPONENTS'
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17290114977778644)
,p_name=>'P670_WEEKLY_TITLE_FORMAT'
,p_item_sequence=>8
,p_item_plug_id=>wwv_flow_imp.id(17284900057778634)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Month Title Format'
,p_source=>'WEEKLY_TITLE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the format for the month title that appears at the top of each week. This is the first part of a calendar which is printed on the page.',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'&lt;table&gt;',
' &lt;tr&gt;',
'   &lt;td&gt;#MONTH#&lt;/td&gt;',
' &lt;/tr&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17290605792778644)
,p_name=>'P670_WEEKLY_DAY_OF_WEEK_FORMAT'
,p_item_sequence=>9
,p_item_plug_id=>wwv_flow_imp.id(17284900057778634)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Day Of Week Format'
,p_source=>'WEEKLY_DAY_OF_WEEK_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the format for the week day names which display as the column header for that day of the week.  ',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'   &lt;th width="14%"&gt;#IDAY#&lt;/th&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17291125918778645)
,p_name=>'P670_WEEKLY_MONTH_OPEN_FORMAT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(17284900057778634)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Month Open Format'
,p_source=>'WEEKLY_MONTH_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the HTML to be used to open a month.  This is printed immediately after the "Month Title Format".  Usually this would be an HTML tag which is a container such as a table.  ',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'   &lt;table  border="0" cellpadding="0" cellspacing="0" class="htmldbRowWithBorders" width="100%"&gt;&lt;tr&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17291615433778645)
,p_name=>'P670_WEEKLY_MONTH_CLOSE_FORMAT'
,p_item_sequence=>11
,p_item_plug_id=>wwv_flow_imp.id(17284900057778634)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Month Close Format'
,p_source=>'WEEKLY_MONTH_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the HTML to be used to close a week.  This is the last part printed so this should close any HTML tags which have been used such as the tag used in the "Month Open Format"',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'   &lt;/table&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17292128629778645)
,p_name=>'P670_WEEKLY_DAY_TITLE_FORMAT'
,p_item_sequence=>12
,p_item_plug_id=>wwv_flow_imp.id(17285313089778635)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Day Title Format'
,p_source=>'WEEKLY_DAY_TITLE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the HTML to be used for the day''s title which the first thing printed after the "Day Open Format" ',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'#DD#',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17292632210778646)
,p_name=>'P670_WEEKLY_DAY_OPEN_FORMAT'
,p_item_sequence=>13
,p_item_plug_id=>wwv_flow_imp.id(17285313089778635)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Day Open Format'
,p_source=>'WEEKLY_DAY_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the HTML to be used to opening a day. This is printed for each day. Usually this would be an HTML tag which is a container such as a td.  Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.'
||' For example:',
'<pre>',
' &lt;td&gt',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17293126813778646)
,p_name=>'P670_WEEKLY_DAY_CLOSE_FORMAT'
,p_item_sequence=>14
,p_item_plug_id=>wwv_flow_imp.id(17285313089778635)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Day Close Format'
,p_source=>'WEEKLY_DAY_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the HTML to be used to close a day.  This is the last part of each day printed so this should close any HTML tags which have been used such as the tag used in the "Day Open Format"',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'   &lt;/td&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17293601124778646)
,p_name=>'P670_WEEKLY_TODAY_OPEN_FORMAT'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_imp.id(17285313089778635)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Today Open Format'
,p_source=>'WEEKLY_TODAY_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the HTML to be used to open today. Usually this would be an HTML tag which is a container such as a td and would be different somehow from the "Day Open Format". Include substitution strings to include dynamic content. See the "Substitution Str'
||'ings" for the full list. For example:',
'<pre>',
'  &lt;td style="background:#c5d5c5"&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17294118205778647)
,p_name=>'P670_WEEKLY_WEEKEND_TITLE_FORMAT'
,p_item_sequence=>16
,p_item_plug_id=>wwv_flow_imp.id(17285715096778635)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Weekend Title Format'
,p_source=>'WEEKLY_WEEKEND_TITLE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter HTML be used to for a day occurring on a weekend. ',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'#DD#',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17294601791778647)
,p_name=>'P670_WEEKLY_WEEKEND_OPEN_FORMAT'
,p_item_sequence=>17
,p_item_plug_id=>wwv_flow_imp.id(17285715096778635)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Weekend Open Format'
,p_source=>'WEEKLY_WEEKEND_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter HTML used to open a day which is on a weekend. Usually this would be an HTML tag which is a container such as a TD. Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list. For example:',
'<pre>',
' &lt;td&gt',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17295130193778647)
,p_name=>'P670_WEEKLY_WEEKEND_CLOSE_FORMAT'
,p_item_sequence=>18
,p_item_plug_id=>wwv_flow_imp.id(17285715096778635)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Weekend Close Format'
,p_source=>'WEEKLY_WEEKEND_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter HTML used to close a day which is on a weekend. This is the last part of each weekend day printed so this should close any HTML tags which have been used such as the tag used in the "Weekend Open Format"',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'   &lt;/td&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17295600187778647)
,p_name=>'P670_WEEKLY_TIME_TITLE_FORMAT'
,p_item_sequence=>19
,p_item_plug_id=>wwv_flow_imp.id(17285502189778635)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Time Title Format'
,p_source=>'WEEKLY_TIME_TITLE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter HTML used to format a Time title. ',
'<p> See the "Substitution Strings" for the full list. For example:',
'<pre>',
'  #HH:MI#',
'</pre>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17296115450778648)
,p_name=>'P670_WEEKLY_TIME_OPEN_FORMAT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(17285502189778635)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Time Open Format'
,p_source=>'WEEKLY_TIME_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter HTML to open a Time. ',
'',
'<p>Usually this would be an HTML tag which is a container such as a td. Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list. For example:',
'<pre>',
'  &lt;td&gt;',
'</pre>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17296606719778648)
,p_name=>'P670_WEEKLY_TIME_CLOSE_FORMAT'
,p_item_sequence=>21
,p_item_plug_id=>wwv_flow_imp.id(17285502189778635)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Time Close Format'
,p_source=>'WEEKLY_TIME_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the html which will close a Time.  ',
'<p>Usually this would be an HTML tag which closes the tag used in the "Time Open Format".',
' Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list. For example:',
'<pre>',
'  &lt;/td&gt;',
'</pre>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17297132581778648)
,p_name=>'P670_WEEK_TITLE_FORMAT'
,p_item_sequence=>22
,p_item_plug_id=>wwv_flow_imp.id(17285128475778635)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Week Title Format'
,p_source=>'WEEK_TITLE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'Enter the html which will be printed as the title for a weekly view calendar.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17297625218778649)
,p_name=>'P670_WEEKLY_HOUR_OPEN_FORMAT'
,p_item_sequence=>23
,p_item_plug_id=>wwv_flow_imp.id(17285128475778635)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Hour Open Format'
,p_source=>'WEEKLY_HOUR_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the HTML to be used to open a hour. This is printed for each hour. Usually this would be an HTML tag which is a container such as a tr. Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list. F'
||'or example:',
'<pre>',
' &lt;tr&gt;'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17298106208778649)
,p_name=>'P670_WEEKLY_HOUR_CLOSE_FORMAT'
,p_item_sequence=>24
,p_item_plug_id=>wwv_flow_imp.id(17285128475778635)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Hour Close Format'
,p_source=>'WEEKLY_HOUR_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the HTML to be used to close a hour.  This is the last part printed so this should close any HTML tags which have been used such as the tag used in the "Hour Open Format"',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'   &lt;/tr&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17298612993778649)
,p_name=>'P670_DAILY_TITLE_FORMAT'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_imp.id(17285313089778635)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Daily Title Format'
,p_source=>'DAILY_TITLE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'Enter the html which will be used as the title for a daily view calendar.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17299115769778650)
,p_name=>'P670_DAILY_OPEN_FORMAT'
,p_item_sequence=>26
,p_item_plug_id=>wwv_flow_imp.id(17285313089778635)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Daily Open Format'
,p_source=>'DAILY_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'Enter the html which will be used to open a day in a daily view calendar.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17299622977778650)
,p_name=>'P670_DAILY_CLOSE_FORMAT'
,p_item_sequence=>27
,p_item_plug_id=>wwv_flow_imp.id(17285313089778635)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Daily Close Format'
,p_source=>'DAILY_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'Enter the html which will be used to close a day in a daily view calendar.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17300627207778651)
,p_name=>'P670_STAY'
,p_item_sequence=>38
,p_item_plug_id=>wwv_flow_imp.id(17285906179778635)
,p_prompt=>'Stay on page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select this checkbox to stay on this page after applying changes.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'YES'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17302820384778654)
,p_name=>'P670_ID_NEXT'
,p_item_sequence=>88
,p_item_plug_id=>wwv_flow_imp.id(17284317885778633)
,p_prompt=>'P670_ID_NEXT'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17303002558778654)
,p_name=>'P670_ID_PREV'
,p_item_sequence=>98
,p_item_plug_id=>wwv_flow_imp.id(17284317885778633)
,p_prompt=>'P670_ID_PREV'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17303214665778654)
,p_name=>'P670_ID_COUNT'
,p_item_sequence=>108
,p_item_plug_id=>wwv_flow_imp.id(17284317885778633)
,p_prompt=>'Calendar Template: '
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies calendar template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(397294506419434043)
,p_name=>'ENABLE PREVIOUS'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P670_ID_PREV'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(397294831938434043)
,p_event_id=>wwv_flow_imp.id(397294506419434043)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(17289018915778641)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(397294912306435746)
,p_name=>'ENABLE NEXT'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P670_ID_NEXT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(397295227619435746)
,p_event_id=>wwv_flow_imp.id(397294912306435746)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(17288816609778641)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(17303930471778662)
,p_process_sequence=>1
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_CAL_TEMPLATES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_CAL_TEMPLATES'
,p_attribute_03=>'P670_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Unable to fetch row.'
,p_internal_uid=>17303930471778662
,p_process_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(17304107753778662)
,p_process_sequence=>11
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_PAGINATION'
,p_process_name=>'Get Next or Previous Primary Key Value'
,p_attribute_02=>'WWV_FLOW_CAL_TEMPLATES'
,p_attribute_03=>'P670_ID'
,p_attribute_04=>'ID'
,p_attribute_07=>'THEME_ID'
,p_attribute_08=>'NAME'
,p_attribute_09=>'P670_ID_NEXT'
,p_attribute_10=>'P670_ID_PREV'
,p_attribute_13=>'P670_ID_COUNT'
,p_attribute_14=>'flow_id = :fb_flow_id'
,p_process_error_message=>'Unable to run Get Next or Previous Primary Key Value process.'
,p_internal_uid=>17304107753778662
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(17304311080778662)
,p_process_sequence=>1
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_CAL_TEMPLATES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_CAL_TEMPLATES'
,p_attribute_03=>'P670_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Unable to process calendar template.'
,p_process_when=>'COPY_TEMPLATE'
,p_process_when_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>17304311080778662
,p_process_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(17304508027778662)
,p_process_sequence=>2
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'122'
,p_process_when_button_id=>wwv_flow_imp.id(17288607720778641)
,p_internal_uid=>17304508027778662
);
end;
/
prompt --application/pages/page_00671
begin
wwv_flow_imp_page.create_page(
 p_id=>671
,p_name=>'Copy Page - Tab Options'
,p_alias=>'COPY-PAGE-TAB-OPTIONS'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Page'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_pgs.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44706330167756937)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(204069723769908880)
,p_plug_name=>'Copy Page'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P621_NAVIGATION_TYPE'
,p_plug_display_when_cond2=>'L'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'Region generated 06-JAN-2003 14:58:57'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(204068913160908875)
,p_name=>'Tabs'
,p_parent_plug_id=>wwv_flow_imp.id(204069723769908880)
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select tab_set, ',
'       tab_step, ',
'       substr(wwv_flow_escape.html(tab_text),1,30) tab_text,',
'       replace(TAB_ALSO_CURRENT_FOR_PAGES,'','','', '') tacfp',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID and security_group_id = :flow_security_group_id',
'order  by tab_set, tab_sequence, tab_step'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>'No tabs or tab sets exist.'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(204069110497908879)
,p_query_column_id=>1
,p_column_alias=>'TAB_SET'
,p_column_display_sequence=>1
,p_column_heading=>'Tab Set'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(204069216097908879)
,p_query_column_id=>2
,p_column_alias=>'TAB_STEP'
,p_column_display_sequence=>2
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(204069308825908879)
,p_query_column_id=>3
,p_column_alias=>'TAB_TEXT'
,p_column_display_sequence=>3
,p_column_heading=>'Tab'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(204069429085908880)
,p_query_column_id=>4
,p_column_alias=>'TACFP'
,p_column_display_sequence=>4
,p_column_heading=>'Also&nbsp;Current&nbsp;For'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(204094503856962236)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(202931703979545993)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1556030029344334045)
,p_plug_name=>'List Based Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_translate_title=>'N'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P621_NAVIGATION_TYPE'
,p_plug_display_when_cond2=>'L'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(204070131230908882)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(44706330167756937)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(204070309177908883)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(44706330167756937)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(204070508754908883)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(44706330167756937)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(204073118771908901)
,p_branch_name=>'Go To Page 622'
,p_branch_action=>'f?p=&APP_ID.:622:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(204070309177908883)
,p_branch_sequence=>10
,p_branch_comment=>'Generated 06-JAN-2003 14:58:57'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(204072921980908901)
,p_branch_action=>'621'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(204070508754908883)
,p_branch_sequence=>30
,p_branch_comment=>'Generated 06-JAN-2003 14:58:57'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(204072401518908898)
,p_name=>'P671_TAB_OPTIONS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(204069723769908880)
,p_item_default=>'NO'
,p_prompt=>'Tab Options:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'TAB_SET_CHOICE_ALL'
,p_lov=>'.'||wwv_flow_imp.id(84778506791979282)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'<p>Select whether the new page should have tabs.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
,p_item_comment=>'Generated 06-JAN-2003 14:58:57'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(209392018927383072)
,p_name=>'P671_TAB_NAME'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(204069723769908880)
,p_prompt=>'Tab Name'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(TAB_NAME)||'' text="''||wwv_flow_escape.html(TAB_TEXT)||''"'' d,tab_name',
'from   wwv_flow_tabs',
'where  flow_id = :fb_flow_id and',
'       security_group_id = :flow_security_group_id and',
'       tab_set = :P671_TAB_SET'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Tab -'
,p_lov_null_value=>'0'
,p_lov_cascade_parent_items=>'P671_TAB_SET'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the tab designated as current for the new page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(209449011093390265)
,p_name=>'P671_TAB_LABEL'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(204069723769908880)
,p_prompt=>'New Tab Label'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter a tab label.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(209773604082407084)
,p_name=>'P671_TAB_SET'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(204069723769908880)
,p_prompt=>'Tab Set'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_TABSETS'
,p_lov=>'select wwv_flow_escape.html(d) d, r from wwv_flow_tabset_view'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Tab Set -'
,p_lov_null_value=>'0'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>A tab set identifies a collection of tabs. The current tab is identified by a tab in the tab set that identifies this page as "current" for that tab. The same tab can be "current" for many pages. If no page is current for a specific tab set, the t'
||'ab set displays without any tab identified as current.</p>',
'<p>Current tabs are typically displayed without a link.  Non current tabs are displayed with a link. Tabs that are not current are URL''s to other pages when the current page contains no form items. If the current page contains form items, the tab wil'
||'l submit the page.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1556030297649334047)
,p_name=>'P671_NAVLIST_OPTIONS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1556030029344334045)
,p_item_default=>'NONE'
,p_prompt=>'Navigation Preference'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.NAVIGATIONLIST.OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(925221062390507339)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select how you want this page integrated into the Navigation Menu.<p/>',
'<ul>',
'    <li><strong>Do not associate this page with a Navigation Menu entry</strong> - The new page will not be current or highlighted for any menu entry.</li>',
'    <li><strong>Create a new Navigation Menu entry</strong> - Users will be able to navigate to the new page directly from the Navigation Menu. The new entry can be placed anywhere in the existing hierarchy.</li>',
'    <li><strong>Identify an existing Navigation Menu entry which will be current for this page</strong> - Use this option when you want the new page to highlight an existing, top level, menu entry. Users will not be able to navigate to the new page d'
||'irectly from the Navigation Menu. Therefore, You will need to create or define a navigation control on the top level page selected, such as a button, or link in a report, to go to this new page.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1556030765732334048)
,p_name=>'P671_NAVLIST_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1556030029344334045)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1556030938615334048)
,p_name=>'P671_NAVLIST_ENTRY_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1556030029344334045)
,p_prompt=>'New Navigation Menu Entry'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Enter a name for the new menu entry.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1556031492872334048)
,p_name=>'P671_NAVLIST_PARENT_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(1556030029344334045)
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select a navigation parent for your new page. When creating a new navigation item, the new item links to',
'the new page. The new item can be added at the top level, by not selecting any parent item, or shown as a child',
'of an existing item. </p>',
'',
'<p>When selecting item without creating a new item, the selected item determines which top level item is shown',
'as the "current" item.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1556031970284334048)
,p_name=>'P671_NEW_PARENT_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(1556030029344334045)
,p_prompt=>'Parent Navigation Menu Entry'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    case ',
'        when (nvl(list_item_link_target,''0'')=''0'' or parent_list_item_id is null)  then ',
'            lpad('' '',(4*(level-1)),''.'')||list_item_link_text',
'        else ',
'            lpad('' '',(4*(level-1)),''.'')||'' (''||list_item_link_text ||'')'' ',
'    end name,',
'    id',
'  from wwv_flow_list_items',
' start with parent_list_item_id is null',
'        and flow_id = :FB_FLOW_ID',
'        and list_id = :P671_NAVLIST_ID',
' connect by prior id = parent_list_item_id',
'        and prior list_id = list_id',
' order siblings by list_item_display_sequence',
'',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No parent selected - '
,p_cHeight=>7
,p_tag_css_classes=>'a-Form-select--multi'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select an existing menu control if you wish to add a menu entry for the new page to this menu control. ',
'When not selecting an existing menu control, a menu control for the new page will be created at the to level.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1556032437879334049)
,p_name=>'P671_EXISTING_PARENT_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(1556030029344334045)
,p_prompt=>'Existing Navigation Menu Entry'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    list_item_link_text name,',
'    id',
'from wwv_flow_list_items',
'where flow_id = :FB_FLOW_ID',
'and list_id = :P671_NAVLIST_ID',
'and parent_list_item_id is null',
'order by list_item_display_sequence',
'',
''))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Select an existing menu control to be shown as the active menu control when rendering the new page. ',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1556098641748518831)
,p_computation_sequence=>80
,p_computation_item=>'P671_NAVLIST_ENTRY_NAME'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return null;'
,p_compute_when=>'P671_NAVLIST_OPTIONS'
,p_compute_when_text=>'NEW'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1556098914886525215)
,p_computation_sequence=>80
,p_computation_item=>'P671_NAVLIST_PARENT_ID'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P671_NEW_PARENT_ID'
,p_compute_when=>'P671_NAVLIST_OPTIONS'
,p_compute_when_text=>'NEW'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1556099109208526910)
,p_computation_sequence=>80
,p_computation_item=>'P671_NAVLIST_PARENT_ID'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P671_EXISTING_PARENT_ID'
,p_compute_when=>'P671_NAVLIST_OPTIONS'
,p_compute_when_text=>'EXISTING'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1556097769474498680)
,p_computation_sequence=>80
,p_computation_item=>'P671_NAVLIST_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select navigation_list_id',
'  from wwv_flows',
' where id = :FB_FLOW_ID'))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(210912824963545645)
,p_validation_name=>'P671_TAB_SET Not Null'
,p_validation_sequence=>10
,p_validation=>'P671_TAB_SET'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'Tab Set must be specified.'
,p_validation_condition=>'P671_TAB_OPTIONS'
,p_validation_condition2=>'EXISTING:EXISTING2'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_when_button_pressed=>wwv_flow_imp.id(204070309177908883)
,p_associated_item=>wwv_flow_imp.id(209773604082407084)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 10-JAN-2003 14:01'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(210931601892548412)
,p_validation_name=>'P671_TAB_LABEL Not Null'
,p_validation_sequence=>20
,p_validation=>'P671_TAB_LABEL'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'Tab Label must be specified.'
,p_validation_condition=>'P671_TAB_OPTIONS'
,p_validation_condition2=>'NEW:EXISTING'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_when_button_pressed=>wwv_flow_imp.id(204070309177908883)
,p_associated_item=>wwv_flow_imp.id(209449011093390265)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 07-JAN-2003 11:58'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(210949409511550603)
,p_validation_name=>'P671_TAB_NAME'
,p_validation_sequence=>30
,p_validation=>'P671_TAB_NAME'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'Tab Name must be specified.'
,p_validation_condition=>'P671_TAB_OPTIONS'
,p_validation_condition2=>'EXISTING2'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(204070309177908883)
,p_associated_item=>wwv_flow_imp.id(209392018927383072)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1556102525519621809)
,p_validation_name=>'New Entry with no List'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''x''',
'from wwv_flow_list_items',
'where flow_id = :FB_FLOW_ID',
'and list_id = :P671_NAVLIST_ID',
'and parent_list_item_id is null',
'and rownum = 1'))
,p_validation_type=>'EXISTS'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'You must associate a navigation menu list to use this preference. Go to Shared Components, User Interface Attributes, select the appropriate User Interface, then select a Navigation Menu List.<br>',
'Alternatively, do not associate this page with a navigation menu entry.'))
,p_validation_condition=>'P671_NAVLIST_OPTIONS'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(204070309177908883)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1556098268832507723)
,p_validation_name=>'P671_NAVLIST_ENTRY_NAME'
,p_validation_sequence=>70
,p_validation=>'P671_NAVLIST_ENTRY_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Entry name is required for new navigation menu entries.'
,p_validation_condition=>':P621_NAVIGATION_TYPE=''L'' and :P671_NAVLIST_OPTIONS=''NEW'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(1556030938615334048)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1556102873191626438)
,p_validation_name=>'Existing Entry with no List'
,p_validation_sequence=>70
,p_validation=>'P671_EXISTING_PARENT_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'You must associate a navigation menu list to use this preference. Go to Shared Components, User Interface Attributes, select the appropriate User Interface, then select a Navigation Menu List.<br>',
'Alternatively, do not associate this page with a navigation menu entry.'))
,p_validation_condition=>'P671_NAVLIST_OPTIONS'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(204070309177908883)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2947730994772599)
,p_validation_name=>'Navigation Menu not subscribed'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * ',
'  from wwv_flow_lists',
' where id                = :P671_NAVLIST_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and reference_id      is not null'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'&APP_TEXT$NAVIGATION_MENU_SUBSCRIBED!RAW.'
,p_validation_condition=>':P671_NAVLIST_OPTIONS in ( ''NEW'', ''EXISTING'' ) and :P671_NAVLIST_ID is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(1556030297649334047)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(210105928717442617)
,p_name=>'Tab Option NO Settings'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P671_TAB_OPTIONS'
,p_condition_element=>'P671_TAB_OPTIONS'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'NO'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(210106214625442619)
,p_event_id=>wwv_flow_imp.id(210105928717442617)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P671_TAB_NAME,P671_TAB_LABEL,P671_TAB_SET'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(210191517073448721)
,p_name=>'Tab Option EXISTING Settings'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P671_TAB_OPTIONS'
,p_condition_element=>'P671_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'EXISTING'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(210191801470448722)
,p_event_id=>wwv_flow_imp.id(210191517073448721)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P671_TAB_SET,P671_TAB_LABEL'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(210192026470448722)
,p_event_id=>wwv_flow_imp.id(210191517073448721)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P671_TAB_NAME'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(210218222268450250)
,p_name=>'Tab Option EXISTING2 Settings'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P671_TAB_OPTIONS'
,p_condition_element=>'P671_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'EXISTING2'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(210218531003450251)
,p_event_id=>wwv_flow_imp.id(210218222268450250)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P671_TAB_SET,P671_TAB_NAME'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(210218725408450251)
,p_event_id=>wwv_flow_imp.id(210218222268450250)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P671_TAB_LABEL'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(210237427462451704)
,p_name=>'Tab Option NEW Settings'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P671_TAB_OPTIONS'
,p_condition_element=>'P671_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(210237924346451705)
,p_event_id=>wwv_flow_imp.id(210237427462451704)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P671_TAB_LABEL'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(210237727768451705)
,p_event_id=>wwv_flow_imp.id(210237427462451704)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P671_TAB_SET,P671_TAB_NAME'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(614677057243219870)
,p_name=>'Cancel Dialog'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(204070131230908882)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(614677381640219871)
,p_event_id=>wwv_flow_imp.id(614677057243219870)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1556035574358352817)
,p_name=>'New Navlist Entry Name'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P671_NAVLIST_OPTIONS'
,p_condition_element=>'P671_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1556036091396352820)
,p_event_id=>wwv_flow_imp.id(1556035574358352817)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P671_NAVLIST_ENTRY_NAME,P671_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1556035871283352819)
,p_event_id=>wwv_flow_imp.id(1556035574358352817)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P671_NAVLIST_ENTRY_NAME,P671_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1556036296402356776)
,p_name=>'Existing NavList Entry'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P671_NAVLIST_OPTIONS'
,p_condition_element=>'P671_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'EXISTING'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1556036553909356777)
,p_event_id=>wwv_flow_imp.id(1556036296402356776)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P671_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1556036711743356777)
,p_event_id=>wwv_flow_imp.id(1556036296402356776)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P671_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1556036841063358415)
,p_name=>'Update Tree'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P671_NAVLIST_OPTIONS'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1556037103298358415)
,p_event_id=>wwv_flow_imp.id(1556036841063358415)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'$("#P671_NAVLIST_PARENT_ID option:contains('' ('')").attr("disabled","disabled");'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1556097177222495564)
,p_name=>'Show Navigation Tree'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P671_NAVLIST_OPTIONS'
,p_condition_element=>'P671_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NONE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1556097432228495567)
,p_event_id=>wwv_flow_imp.id(1556097177222495564)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P671_NAVLIST_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1556097682957495567)
,p_event_id=>wwv_flow_imp.id(1556097177222495564)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P671_NAVLIST_PARENT_ID'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_00674
begin
wwv_flow_imp_page.create_page(
 p_id=>674
,p_name=>'Utilities'
,p_alias=>'UTILITIES'
,p_step_title=>'Utilities'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_utilties.htm'
,p_page_component_map=>'06'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30785228682889678)
,p_plug_name=>'Interactive Report Utilities'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(30782715391876326)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(177895623943482376)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The Utilities page features links to summaries and reports that enable developers to view an application from various perspectives.</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(492633831728601029)
,p_plug_name=>'Page Specific Utilities'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(492631804585583697)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(693371896293328501)
,p_plug_name=>'Utilities'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-MediaList--cols a-MediaList--2cols'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(177830919883437702)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(693422331030340241)
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(177886613818301603)
,p_branch_action=>'f?p=&FLOW_ID.:674:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_00681
begin
wwv_flow_imp_page.create_page(
 p_id=>681
,p_name=>'Theme History'
,p_alias=>'THEME-HISTORY'
,p_step_title=>'Theme History'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(91429205691059841)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_themes.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193117419035374956)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(58949101764235429)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Themes'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193117618253374960)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>This page displays recent modifications made to Themes in this application.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193118212618374964)
,p_plug_name=>'Theme History'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P681a */',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_THEMES'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(193118416085374964)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193118532204374965)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193118629623374966)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Audit Comment'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193118730291374966)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Component Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193118832617374967)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193118905891374968)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Component Key'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193119003064374969)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Audit Date'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193119123342374974)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(193119209166374975)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1290332460536644'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'AUDIT_DATE:ACTION:DEVELOPER:COMPONENT_NAME'
,p_sort_column_1=>'AUDIT_DATE'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(193118011331374962)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(193118212618374964)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:681:&SESSION.::&DEBUG.:42,RIR::'
);
end;
/
prompt --application/pages/page_00685
begin
wwv_flow_imp_page.create_page(
 p_id=>685
,p_name=>'Copy Branch - Branch Options'
,p_alias=>'COPY-BRANCH-BRANCH-OPTIONS'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Branch'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_branch.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46133022676932616)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(228250020358897351)
,p_plug_name=>'Copy Branch'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(228250418726897353)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(228256415837925869)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(228250621991897354)
,p_name=>'Target Page Branches'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  branch_name, substr(branch_action, 1, 40) as branch_action, branch_sequence, branch_type, branch_point ',
'from wwv_flow_step_branches',
'where flow_step_id = :P587_COPY_TO_PAGE',
'and flow_id = :fb_flow_id  ',
'and security_group_id = :flow_security_group_id',
'order by branch_point, branch_sequence, id'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>'There are currently no branches defined on the target page.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'REPEAT_HEADINGS_ON_BREAK_1'
,p_break_repeat_heading_format=>'<strong>#COLUMN_VALUE#</strong>'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(15655931756563639)
,p_query_column_id=>1
,p_column_alias=>'BRANCH_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(228301823240287581)
,p_query_column_id=>2
,p_column_alias=>'BRANCH_ACTION'
,p_column_display_sequence=>5
,p_column_heading=>'Action'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(228301906282287581)
,p_query_column_id=>3
,p_column_alias=>'BRANCH_SEQUENCE'
,p_column_display_sequence=>2
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(228302028111287581)
,p_query_column_id=>4
,p_column_alias=>'BRANCH_TYPE'
,p_column_display_sequence=>4
,p_column_heading=>'Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(15652127549539076)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(228302129892287582)
,p_query_column_id=>5
,p_column_alias=>'BRANCH_POINT'
,p_column_display_sequence=>1
,p_column_heading=>'Branch Point'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(179397725241870240)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(228251206130897357)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46133022676932616)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(228251427191897359)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(46133022676932616)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(228251614614897359)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(46133022676932616)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:587:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(228253427580897372)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(228251823759897360)
,p_name=>'P685_BRANCH_SEQUENCE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(228250020358897351)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Target Page Branch Sequence'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select max(BRANCH_SEQUENCE) + 10',
'from WWV_FLOW_STEP_BRANCHES ',
'where flow_id = :fb_flow_id and flow_step_id = :fb_flow_page_id;'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the sequence for this component. The sequence determines the order of evaluation.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(228252327918897365)
,p_name=>'P685_BRANCH_POINT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(228250020358897351)
,p_prompt=>'Target Page Branch Point'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE.BRANCH.POINTS'
,p_lov=>'.'||wwv_flow_imp.id(179397725241870240)||'.'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify new process name'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(230867913201911662)
,p_name=>'P685_WHEN_BUTTON_PRESSED'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(228250020358897351)
,p_prompt=>'When Button Pressed'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select button_name,',
'       id',
'  from (',
'        /* all region buttons from current page and global page */',
'        select case when b.flow_step_id = f.global_page_id then',
'                   wwv_flow_lang.system_message(''LAYOUT.GLOBAL_PAGE_REGION_PREFIX'')',
'               end ||',
'               b.button_name ||',
'               '' ('' || b.button_image_alt || '')'' as button_name,',
'               b.id,',
'               b.button_name bn,',
'               case when b.flow_step_id = f.global_page_id then 2 else 1 end x',
'          from wwv_flow_steps p,',
'               wwv_flows f,',
'               wwv_flow_step_buttons b',
'         where p.flow_id      = :FB_FLOW_ID',
'           and p.id           = :P587_COPY_TO_PAGE',
'           and f.id           = p.flow_id',
'           and b.flow_id      = f.id',
'           and b.flow_step_id in (:P587_COPY_TO_PAGE, f.global_page_id)',
'         order by 4, 3 ',
'       )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Button Condition -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'This component will only be executed if a user clicks this button.',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231020304767325561)
,p_name=>'P685_COPY_BRANCH'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(228250020358897351)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Copy Branch:'
,p_source=>'P587_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select substr(BRANCH_SEQUENCE||''. ''||wwv_flow_escape.html(nvl(branch_name, BRANCH_ACTION)),1,90) bname, id ',
'from WWV_FLOW_STEP_BRANCHES ',
'where flow_id = :fb_flow_id and flow_step_id = :fb_flow_page_id ',
'order by BRANCH_SEQUENCE '))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Branch to be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231565318196824500)
,p_name=>'P685_COPY_FROM_PAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(228250020358897351)
,p_prompt=>'Copy From Page:'
,p_source=>'P587_COPY_FROM_PAGE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Page that branch will be copied to.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231573814172832766)
,p_name=>'P685_COPY_TO_PAGE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(228250020358897351)
,p_prompt=>'Target Page:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||wwv_flow_escape.html(name)',
'from wwv_flow_steps',
'where flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'and id = :P587_COPY_TO_PAGE'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>10
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="fieldtitlebold"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Page that branch will be copied to.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(228253015642897367)
,p_validation_name=>'P685_BRANCH_SEQUENCE_NOT_NULL'
,p_validation_sequence=>10
,p_validation=>'P685_BRANCH_SEQUENCE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Branch Sequence must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(228251427191897359)
,p_associated_item=>wwv_flow_imp.id(228251823759897360)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2600965589032605)
,p_validation_name=>'Ensure the destination page is not a subscribed page pattern'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_component_group_dev.is_part_of_subscribed_comp_grp (',
'    p_component_id   => :P587_COPY_TO_PAGE,',
'    p_component_type => wwv_flow_copy_metadata.c_page,',
'    p_app_id         => :FB_FLOW_ID ) = ''N'''))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'You cannot copy the branch to a page pattern that is part of a subscribed component group.'
,p_when_button_pressed=>wwv_flow_imp.id(228251427191897359)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(614709799857532193)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(228251206130897357)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(614710074419532194)
,p_event_id=>wwv_flow_imp.id(614709799857532193)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(228253204637897368)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Branch'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_page.a_branch(',
'    p_flow_id_from            => :FB_FLOW_ID,',
'    p_page_id_from            => :FB_FLOW_PAGE_ID,',
'    p_branch_id_from          => :P587_ID,',
'    p_flow_id_to              => :FB_FLOW_ID,',
'    p_page_id_to              => :P587_COPY_TO_PAGE,',
'    p_branch_when_button_id   => :P685_WHEN_BUTTON_PRESSED,',
'    p_branch_sequence         => :P685_BRANCH_SEQUENCE );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to copy Branch'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(228251427191897359)
,p_process_success_message=>'Branch Copied'
,p_internal_uid=>228253204637897368
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(614710219139534151)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(228251427191897359)
,p_process_success_message=>'Branch Copied'
,p_internal_uid=>614710219139534151
);
end;
/
prompt --application/pages/page_00686
begin
wwv_flow_imp_page.create_page(
 p_id=>686
,p_name=>'List of Values History'
,p_alias=>'LIST-OF-VALUES-HISTORY'
,p_step_title=>'List of Values History'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213240607818867991)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_lov.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193348132357403916)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>90
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(203029530177365353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Lists of Values'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193348316791403917)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>This page displays recent modifications made to Lists of Values in this application.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193348908796403919)
,p_plug_name=>'List of Values History'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>180
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.a object_type,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u,',
'  (select wwv_flow_lang.system_message(''LIST OF VALUES'') a from dual) t',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_LISTS_OF_VALUES$''',
'union',
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.a object_type,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u,',
'  (select wwv_flow_lang.system_message(''F4000.LOV_ENTRY'') a from dual) t',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_LIST_OF_VALUES_DATA'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(193349113387403920)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193349203981403921)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193349314233403922)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Audit Comment'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193349411468403923)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Component Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193349516741403923)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193349600400403924)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Component Key'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193349727164403925)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Audit Date'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193349800047403926)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193349906091403927)
,p_db_column_name=>'OBJECT_TYPE'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Object Type'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(193350031644403928)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1290411354536644'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'AUDIT_DATE:ACTION:DEVELOPER:OBJECT_TYPE:COMPONENT_NAME'
,p_sort_column_1=>'AUDIT_DATE'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(193348701585403918)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(193348908796403919)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:686:&SESSION.::&DEBUG.:58,RIR::'
);
end;
/
prompt --application/pages/page_00688
begin
wwv_flow_imp_page.create_page(
 p_id=>688
,p_name=>'Component Export'
,p_alias=>'COMPONENT-EXPORT'
,p_step_title=>'Export Component'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_export_comp.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4205923269056244)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>100
,p_plug_item_display_point=>'BELOW'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'N',
  'rds_mode', 'STANDARD',
  'remember_selection', 'NO')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5629603633882806)
,p_plug_name=>'Choose Application'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_plug_grid_column_span=>8
,p_plug_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_plug_read_only_when=>'FB_FLOW_ID'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(12821537526163125)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(12802829107)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(21628526763318898)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Export shared components or page components to another application or workspace, back up a component before editing it, or create an export that functions as a patch to another Oracle APEX instance.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(53966109039363852)
,p_plug_name=>'Export Settings'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_plug_grid_column_span=>8
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(176269246815280273)
,p_plug_name=>'Export Components'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(205852217711540402)
,p_plug_name=>'Application Components'
,p_region_name=>'APP_COMPONENTS'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'       case when sel.id is null then',
'           WWV_FLOW_ITEM.CHECKBOX(',
'               1,',
'               comps.id || '':'' || comps.type_name || '':'' || rawtohex(sys.utl_raw.cast_to_raw(comps.name)),',
'               '''',',
'               '''',',
'               '''',',
'               ''f01_'' || lpad(to_char(rownum), 4, ''0''),',
'               wwv_flow_lang.system_message(''COMPONENT_NAME_LABEL'', wwv_flow_escape.html(comps.name))',
'           )',
'           else '' ''',
'       end as id,',
'       comps.type_name,',
'       comps.name,',
'       wwv_flow_string.join( comps.used_on_pages, '','' ) used_on_pages,',
'       comps.last_updated_on last_updated_on,',
'       comps.last_updated_by',
'  from wwv_flow_appl_export_comps comps,',
'       ( select type_name,',
'                id',
'           from wwv_multi_component_export',
'          where flow_id = nvl(:FB_FLOW_ID, :P688_APPLICATION) ) sel',
' where (comps.application_id = nvl(:FB_FLOW_ID, :P688_APPLICATION) or comps.application_id is null)',
'   and comps.workspace_id    = :FLOW_SECURITY_GROUP_ID',
'   and comps.type_name       = sel.type_name (+)',
'   and comps.id              = sel.id        (+)'))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P688_APPLICATION'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Application Components'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(5633379337882843)
,p_max_row_count=>'1000000'
,p_show_nulls_as=>' - '
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'LEORODRI'
,p_internal_uid=>5633379337882843
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(6304621459459527)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'F'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_rpt_show_filter_lov=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(6304790889459528)
,p_db_column_name=>'TYPE_NAME'
,p_display_order=>20
,p_column_identifier=>'G'
,p_column_label=>'Component Type'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(377667910269420728)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(6304891185459529)
,p_db_column_name=>'NAME'
,p_display_order=>30
,p_column_identifier=>'H'
,p_column_label=>' Component Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(11802724544150202)
,p_db_column_name=>'USED_ON_PAGES'
,p_display_order=>40
,p_column_identifier=>'K'
,p_column_label=>'Used on Pages'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(6304953253459530)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>50
,p_column_identifier=>'I'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(6305058531459531)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>60
,p_column_identifier=>'J'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(6300998346442124)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'63010'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_display_rows=>10
,p_report_columns=>'ID:TYPE_NAME:NAME:USED_ON_PAGES:LAST_UPDATED_ON:LAST_UPDATED_BY:'
,p_sort_column_1=>'LAST_UPDATED_ON'
,p_sort_direction_1=>'DESC NULLS LAST'
,p_sort_column_2=>'TYPE_NAME'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'NAME'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(207469307328320096)
,p_name=>'Components to Export'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>140
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--simple'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select seq_id,',
'       type_name component_type,',
'       name      component_name',
'  from wwv_multi_component_export',
' where flow_id = to_number(nvl(:FB_FLOW_ID, :P688_APPLICATION))'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'FB_FLOW_ID,P688_APPLICATION'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>50000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No components selected.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(207469528022320200)
,p_query_column_id=>1
,p_column_alias=>'SEQ_ID'
,p_column_display_sequence=>1
,p_column_heading=>'<span class="u-VisuallyHidden">Remove</span>'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:688:&SESSION.:DELETE:&DEBUG.::P688_DEL:#SEQ_ID#'
,p_column_linktext=>'<span class="a-Icon icon-remove" role="img" aria-label="&APP_TEXT$REMOVE."></span>'
,p_column_link_attr=>'class="a-Button a-Button--small a-Button--noLabel a-Button--withIcon a-Button--noUI"'
,p_column_alignment=>'CENTER'
,p_report_column_width=>40
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(45394019607542208)
,p_query_column_id=>2
,p_column_alias=>'COMPONENT_TYPE'
,p_column_display_sequence=>2
,p_column_heading=>'Component Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(377667910269420728)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(45394304154547275)
,p_query_column_id=>3
,p_column_alias=>'COMPONENT_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Component Name'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(207509320403692876)
,p_plug_name=>'Hidden'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>50
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(228937206800547250)
,p_plug_name=>'Build Option Status'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>130
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'       case when exp.component_id is null then',
'           WWV_FLOW_ITEM.CHECKBOX(',
'               1,',
'               p.id || '':BUILD_OPTION_STATUS:''||rawtohex(sys.utl_raw.cast_to_raw(p.patch_name)),',
'               '''',',
'               '''',',
'               '''',',
'               ''f01_'' ||',
'                   lpad(to_char(rownum), 4, ''0''),',
'               wwv_flow_lang.system_message(''BUILD_OPTION_LABEL'',',
'                   wwv_flow_escape.html(p.patch_name))',
'           )',
'           else '' ''',
'       end as id,',
'       p.patch_name as build_option,',
'       p.patch_status as build_option_status',
'  from wwv_flow_patches p,',
'       (',
'           select id as component_id',
'             from wwv_multi_component_export',
'            where type_name = ''BUILD_OPTION_STATUS''',
'              and flow_id = nvl(:FB_FLOW_ID, :P688_APPLICATION)',
'       ) exp',
'where p.id = exp.component_id (+)',
'  and p.security_group_id = :FLOW_SECURITY_GROUP_ID',
'  and p.flow_id = nvl(:FB_FLOW_ID, :P688_APPLICATION)',
'order by p.patch_name'))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P688_APPLICATION'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Build Option Status'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(5633926744882849)
,p_max_row_count=>'1000000'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'LEORODRI'
,p_internal_uid=>5633926744882849
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5634030319882850)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_rpt_show_filter_lov=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(6302082408459501)
,p_db_column_name=>'BUILD_OPTION'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Build Option'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(6302117694459502)
,p_db_column_name=>'BUILD_OPTION_STATUS'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Status to Export'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(84357332667662999)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(6310559989467102)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'63106'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_display_rows=>10
,p_report_columns=>'ID:BUILD_OPTION:BUILD_OPTION_STATUS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7405954060338201)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(176269246815280273)
,p_button_name=>'reset_page'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:688:&SESSION.:NEW:&DEBUG.:::'
,p_button_cattributes=>'class="button8_69c" onMouseUp="javascript:this.disabled=false;"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(207483303013432369)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(207469307328320096)
,p_button_name=>'REMOVE_ALL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Remove All'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:688:&SESSION.:NEW:&DEBUG.:::'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_multi_component_export',
' where flow_id = to_number(nvl(:FB_FLOW_ID, :P688_APPLICATION))'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8006211505904123)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(176269246815280273)
,p_button_name=>'EXPORT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Export'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(45351808132160494)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(228937206800547250)
,p_button_name=>'ADD_TO_EXPORT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Add to Export'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(205852907944540404)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(205852217711540402)
,p_button_name=>'ADD_TO_EXPORT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Add to Export'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(205854421261540411)
,p_branch_action=>'f?p=&APP_ID.:688:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5629788023882807)
,p_name=>'P688_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(5629603633882806)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Application'
,p_source=>'&FB_FLOW_ID.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PICK_EXPORT_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flows f',
'where  ',
'       security_group_id = :flow_security_group_id and',
'       f.build_status != ''RUN_AND_HIDDEN'' and',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id is null and security_group_id = :flow_security_group_id )',
'       or',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id = f.id and security_group_id = :flow_security_group_id) ',
'order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Application -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'U'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the application that contains the components to be exported.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5922738488060003)
,p_name=>'P688_AUDIT_INFO'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(53966109039363852)
,p_item_default=>'NONE'
,p_prompt=>'Audit Information'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'AUDIT INFO DETAIL'
,p_lov=>'.'||wwv_flow_imp.id(1726678227351632)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'None'
,p_lov_null_value=>'NONE'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the Audit Information to include in the export file. ',
'Audit information includes the Created By User, Created On Date, Changed By User and Changed On Date.<ul> ',
'<li>By default, no audit information is included.</li>',
'<li>Choose Names and Dates to include all audit information.</li>',
'<li>Choose Dates Only to include date information and exclude user details.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8605712297141235)
,p_name=>'P688_EXPORT_TRANSLATIONS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(53966109039363852)
,p_item_default=>'N'
,p_prompt=>'Export Translations'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows f',
' where f.id in ( select m.translation_flow_id',
'                   from wwv_flow_language_map m',
'                  where m.primary_language_flow_id = :P688_APPLICATION )'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Choose <strong>On</strong> to export the selected components for the primary language application and all translated',
'applications. A single export file will be created, which can be loaded directly into another instance. Remember that',
'you need to synchronize the translated applications prior to exporting the translated components to ensure text strings and markup are up-to-date.',
'</p>',
'',
'<p>',
'Choose <strong>Off</strong> to only export the selected components for the primary language application.',
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8606663844141240)
,p_name=>'P688_EXPORT_ZIP'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(53966109039363852)
,p_item_default=>'N'
,p_prompt=>'Export Format'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC:SQL;N,ZIP;Y'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Choose <strong>ZIP</strong> to export the selected components as a ZIP archive containing separate SQL files for each component.</p>',
'',
'<p>',
'Choose <strong>SQL</strong> to export as a single SQL file containing all the selected components.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8607502410141240)
,p_name=>'P688_WITH_INSTALL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(53966109039363852)
,p_item_default=>'Y'
,p_prompt=>'Include installation files'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Choose <strong>On</strong> to generate a ZIP archive including installation files specifically for the exported components (for example, install.sql, set_environment.sql and end_environment.sql).</p>',
'<p>',
'Choose <strong>Off</strong> to generate a ZIP file without the installation files. This is recommended when saving the files to a version control system so that application installation files are not overwritten. ',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8608834129141241)
,p_name=>'P688_FLASHBACK_MIN_AGO'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(53966109039363852)
,p_prompt=>'As of'
,p_post_element_text=>'<span class="fielddata">minutes ago</span>'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>4
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Specify a time in minutes to go to back to for your export. This option enables you to go back in time in your',
'application, perhaps to get back a deleted object.',
'</p>',
'',
'<p>',
'This utility uses the <code>dbms_flashback</code> package. The timestamp to SCN (system change number) mapping is',
'refreshed approximately every 5 minutes, so you may have to wait that long to get to the version you are looking for.',
'The time undo information is retained by the startup parameter <code>undo_retention</code> (default 3 hours), but this',
'only influences the size of the undo tablespace.',
'</p>',
'',
'<p>',
'While two databases may have the same <code>undo_retention</code> parameter, you can go back much further in time',
'on the database with less transactions since the transactions are not filling the undo tablespace, forcing older',
'data to be archived.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8609707505141241)
,p_name=>'P688_MPAGE_FILE_CHARSET'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(53966109039363852)
,p_prompt=>'File Character Set'
,p_source=>'return lower(trim(sys.owa_util.get_cgi_env(''REQUEST_IANA_CHARSET'')));'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'I18N_IANA_CHARSET'
,p_lov=>'.'||wwv_flow_imp.id(144796827445692396)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the character set in which the export file will be encoded.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(207474713608350254)
,p_name=>'P688_DEL'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(207509320403692876)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(207510531138695929)
,p_name=>'P688_MODE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(207509320403692876)
,p_item_default=>'AC'
,p_source=>'AC'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(45377409845359617)
,p_validation_name=>'Components selected'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_multi_component_export',
' where flow_id = to_number(:P688_APPLICATION)'))
,p_validation_type=>'EXISTS'
,p_error_message=>'Select components to export.'
,p_when_button_pressed=>wwv_flow_imp.id(8006211505904123)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(6305507198459536)
,p_validation_name=>'P688_APPLICATION Must Have Value'
,p_validation_sequence=>20
,p_validation=>'P688_APPLICATION'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'FB_FLOW_ID'
,p_validation_condition_type=>'ITEM_IS_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(8006211505904123)
,p_associated_item=>wwv_flow_imp.id(5629788023882807)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6611530415692107)
,p_name=>'Toggle Installation Files'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P688_EXPORT_ZIP'
,p_condition_element=>'P688_EXPORT_ZIP'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6611609256692108)
,p_event_id=>wwv_flow_imp.id(6611530415692107)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P688_WITH_INSTALL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6611789674692109)
,p_event_id=>wwv_flow_imp.id(6611530415692107)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P688_WITH_INSTALL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6302218955459503)
,p_name=>'Display Export Settings'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P688_APPLICATION'
,p_condition_element=>'P688_APPLICATION'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6302720635459508)
,p_event_id=>wwv_flow_imp.id(6302218955459503)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show Build Option Status'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(228937206800547250)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6302868603459509)
,p_event_id=>wwv_flow_imp.id(6302218955459503)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Build Option Status'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(228937206800547250)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6302524624459506)
,p_event_id=>wwv_flow_imp.id(6302218955459503)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Show Application Components'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(205852217711540402)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6302631968459507)
,p_event_id=>wwv_flow_imp.id(6302218955459503)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Application Components'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(205852217711540402)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6302360319459504)
,p_event_id=>wwv_flow_imp.id(6302218955459503)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Show Export Settings'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(53966109039363852)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6302473321459505)
,p_event_id=>wwv_flow_imp.id(6302218955459503)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Export Settings'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(53966109039363852)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6302961580459510)
,p_event_id=>wwv_flow_imp.id(6302218955459503)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Components to Export'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(207469307328320096)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6303083205459511)
,p_event_id=>wwv_flow_imp.id(6302218955459503)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_name=>'Show Components to Export'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(207469307328320096)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6305697311459537)
,p_event_id=>wwv_flow_imp.id(6302218955459503)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(4205923269056244)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6303966706459520)
,p_event_id=>wwv_flow_imp.id(6302218955459503)
,p_event_result=>'TRUE'
,p_action_sequence=>70
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(205852217711540402)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6304020298459521)
,p_event_id=>wwv_flow_imp.id(6302218955459503)
,p_event_result=>'TRUE'
,p_action_sequence=>80
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(228937206800547250)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6304143996459522)
,p_event_id=>wwv_flow_imp.id(6302218955459503)
,p_event_result=>'TRUE'
,p_action_sequence=>90
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(207469307328320096)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6305143885459532)
,p_name=>'ADD CHECK ALL CHECKBOX - Application Components'
,p_event_sequence=>30
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(205852217711540402)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6305294932459533)
,p_event_id=>wwv_flow_imp.id(6305143885459532)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6305376611459534)
,p_name=>'ADD CHECK ALL CHECKBOX - Build Option Status'
,p_event_sequence=>40
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(228937206800547250)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6305459988459535)
,p_event_id=>wwv_flow_imp.id(6305376611459534)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(205854212430540411)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_internal_uid=>205854212430540411
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(206919602341115305)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Add components to collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_export_dev.add_to_component_export (',
'    p_application_id => nvl(:FB_FLOW_ID, :P688_APPLICATION),',
'    p_selected       => wwv_flow.g_f01 );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to add components to export'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST = ''ADD_TO_EXPORT''',
'and :P688_MODE in (''AC'',''PD'',''BO'')',
'and wwv_flow.g_f01.count > 0'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>206919602341115305
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(8612229637147008)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Export Components'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_components wwv_flow_export_dev.t_components;',
'begin',
'    -- Load selected components into array so we don''t have to query the collection for each language.',
'    select type_name as component,',
'           id        as component_id',
'           bulk collect into l_components',
'      from wwv_multi_component_export',
'     where flow_id   = :P688_APPLICATION',
'     order by type_name, seq_id;',
'     ',
'     wwv_flow_export_dev.export_components (',
'         p_application_id         => :P688_APPLICATION,',
'         p_components             => l_components,',
'         p_format                 => case ',
'                                     when :P688_EXPORT_ZIP = ''Y'' then ''ZIP_UNIX'' ',
'                                     else ''UNIX'' ',
'                                     end,',
'         p_export_translations_yn => :P688_EXPORT_TRANSLATIONS,',
'         p_flashback_min_ago      => :P688_FLASHBACK_MIN_AGO, ',
'                                     -- always include install when NOT a zip',
'         p_with_install           => :P688_EXPORT_ZIP != ''Y'' or ',
'                                     -- export install if requested when zip',
'                                     :P688_WITH_INSTALL = ''Y'', ',
'        p_with_audit_info         => :P688_AUDIT_INFO);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error exporting components.'
,p_process_when_button_id=>wwv_flow_imp.id(8006211505904123)
,p_process_success_message=>'Shared Component(s) exported.'
,p_internal_uid=>8612229637147008
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(207473519018342362)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete single member'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_collection.delete_member(',
'        p_collection_name => ''MULTI_COMPONENT_EXPORT'',',
'        p_seq             => :P688_DEL );',
'    commit;',
'',
'exception',
'    when others then null;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to remove component'
,p_process_when=>'DELETE'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>207473519018342362
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(207471519926333100)
,p_process_sequence=>50
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    c pls_integer;',
'begin',
'    select count(*) into c',
'      from wwv_flow_collections',
'     where collection_name = ''MULTI_COMPONENT_EXPORT''',
'       and n001 = :P688_APPLICATION',
'       and rownum = 1;',
'',
'    if :REQUEST = ''NEW'' or c = 0 then',
'        if :REQUEST = ''NEW'' then',
'            wwv_flow.g_print_success_message :=',
'                wwv_flow_lang.system_message(''WWV_FLOW_WIZARD_API.ACTION_PROCESSED'');',
'        end if;',
'',
'        wwv_flow_collection.create_or_truncate_collection(',
'            p_collection_name => ''MULTI_COMPONENT_EXPORT''',
'        );',
'        commit;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>207471519926333100
);
end;
/
prompt --application/pages/page_00689
begin
wwv_flow_imp_page.create_page(
 p_id=>689
,p_name=>'Export Feedback'
,p_alias=>'EXPORT-FEEDBACK'
,p_step_title=>'Export Feedback'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213300727323081712)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_export_feed.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(472184315384691387)
,p_plug_name=>'Export Settings'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_grid_column_span=>8
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(472186518392691417)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Export user-provided feedback from this &PRODUCT_NAME. instance. Then, you can import feedback into another instance and convert feedback entries into bugs, features, or to do entries.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(472186928058691420)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(12802829107)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(472187126773691421)
,p_plug_name=>'Export Feedback'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(486275824769546468)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(472187126773691421)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:689:&SESSION.::&DEBUG.:689::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(472187330406691438)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(472187126773691421)
,p_button_name=>'EXPORT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Export'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(472188419784691549)
,p_branch_action=>'f?p=&APP_ID.:689:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1803669709113417)
,p_name=>'P689_AUDIT_INFO'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(472184315384691387)
,p_item_default=>'NONE'
,p_prompt=>'Audit Information'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'AUDIT INFO DETAIL'
,p_lov=>'.'||wwv_flow_imp.id(1726678227351632)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'None'
,p_lov_null_value=>'NONE'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the Audit Information to include in the export file. ',
'Audit information includes the Created By User, Created On Date, Changed By User and Changed On Date.<ul> ',
'<li>By default, no audit information is included.</li>',
'<li>Choose Names and Dates to include all audit information.</li>',
'<li>Choose Dates Only to include date information and exclude user details.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(472184500698691395)
,p_name=>'P689_TO_DEPLOYMENT_SYSTEM'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(472184315384691387)
,p_prompt=>'Deployment System'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'       deployment_system as d,',
'       deployment_system as r',
'  from wwv_flow_feedback',
' where security_group_id = :WORKSPACE_ID',
'   and deployment_system is not null',
' order by 1'))
,p_cHeight=>1
,p_display_when=>'P689_EXPORT_TYPE'
,p_display_when2=>'TO_DEPLOYMENT'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the name of the deployment systems for which you want to export the feedback entries.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(472185930910691415)
,p_name=>'P689_FILE_CHARSET'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(472184315384691387)
,p_item_default=>'return lower(trim(sys.owa_util.get_cgi_env(''REQUEST_IANA_CHARSET'')));'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'File Character Set'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'I18N_IANA_CHARSET'
,p_lov=>'.'||wwv_flow_imp.id(144796827445692396)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'The export file will be encoded in the specified character set.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(472292730911200591)
,p_name=>'P689_EXPORT_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(472184315384691387)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Direction'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_feedback_from_others number;',
'begin',
'    -- check if we have already imported feedback from other systems, in that case it''s the development system',
'    select count(*)',
'      into l_feedback_from_others',
'      from sys.dual',
'     where exists ( select 1',
'                      from wwv_flow_feedback',
'                     where security_group_id = :WORKSPACE_ID',
'                       and deployment_system is not null',
'                  );',
'    if l_feedback_from_others > 0 then',
'        return ''TO_DEPLOYMENT'';',
'    else',
'        return ''TO_DEVELOPMENT'';',
'    end if;',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'EXPORT_FEEDBACK_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(472293315458205653)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Indicates the purpose of the feedback export.  Feedback can by synchronized between instances of &PRODUCT_NAME., this attribute controls how this feedback is exported.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(472297625941265405)
,p_name=>'P689_FROM_DEPLOYMENT_SYSTEM'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(472184315384691387)
,p_use_cache_before_default=>'NO'
,p_prompt=>'From Deployment System'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select source_identifier',
'  from wwv_flow_companies',
' where provisioning_company_id = :FLOW_SECURITY_GROUP_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'P689_EXPORT_TYPE'
,p_display_when2=>'TO_DEVELOPMENT'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the current system. This identifier can be changed by the instance administrator.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(472727114000966503)
,p_name=>'P689_SINCE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(472184315384691387)
,p_prompt=>'Changes Since'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_display_as=>'NATIVE_DATE_PICKER_APEX'
,p_cSize=>20
,p_cMaxlength=>20
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Export all feedback which has been created or changed since the specified date.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'POPUP'
,p_attribute_03=>'NONE'
,p_attribute_06=>'NONE'
,p_attribute_09=>'N'
,p_attribute_11=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(651512616928755619)
,p_name=>'Submit'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(472187330406691438)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(651512780688755620)
,p_event_id=>wwv_flow_imp.id(651512616928755619)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'EXPORT'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(472188228701691540)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'do export'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_export_dev.export_feedback (',
'    p_export_type       => :P689_EXPORT_TYPE,',
'    p_deployment_system => case :P689_EXPORT_TYPE',
'                           when ''TO_DEVELOPMENT'' then :P689_FROM_DEPLOYMENT_SYSTEM',
'                           else :P689_TO_DEPLOYMENT_SYSTEM',
'                           end,',
'    p_since             => to_date(:P689_SINCE, :DATE_TIME_FORMAT),',
'    p_format            => ''UNIX'', ',
'    p_with_audit_info   => :P689_AUDIT_INFO );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error exporting feedback. #SQLERRM#'
,p_process_when_button_id=>wwv_flow_imp.id(472187330406691438)
,p_process_success_message=>'Feedback exported.'
,p_internal_uid=>472188228701691540
);
end;
/
prompt --application/pages/page_00697
begin
wwv_flow_imp_page.create_page(
 p_id=>697
,p_name=>'Edit Calendar Template'
,p_alias=>'EDIT-CALENDAR-TEMPLATE4'
,p_step_title=>'Edit Calendar Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'EXISTS'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_cal_templates t, ',
'       wwv_flow_themes th',
' where t.id                 = :F4000_P697_ID',
'   and t.flow_id            = th.flow_id',
'   and t.theme_id           = th.theme_id',
'   and t.security_group_id  = :workspace_id',
'   and th.security_group_id = t.security_group_id',
'   and t.reference_id      is not null',
'   and th.reference_id     is not null'))
,p_help_text=>'ui_templt_cal.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22161207490144133)
,p_plug_name=>'Page Button Button Box'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22161419106144134)
,p_plug_name=>'Name'
,p_region_name=>'NAME'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22162817201144136)
,p_plug_name=>'Calendar Templates'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Calendar templates control the appearance and placement of a calendar. Calendar templates frequently use HTML tables to arrange dates.</p>',
'<p>You place calendar attributes using substitution strings such as #DD# and  #MONTH#. Template substitution strings must be in upper case and begin and end with a pound sign (#).</p>'))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22163405282144137)
,p_plug_name=>'Substitution Strings'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The following date format substitution strings are available:</p>',
'<ul class="noIndent">',
'<li>DAY</li>',
'<li>DD</li>',
'<li>MON</li>',
'<li>YYYY</li>',
'<li>MM</li>',
'<li>MONTH</li>',
'<li>YY</li>',
'<li>RR</li>',
'<li>YEAR</li>',
'<li>WW</li>',
'<li>W</li>',
'<li>DDD</li>',
'<li>D</li>',
'<li>DY</li>',
'<li>DDSPTH</li>',
'<li>HH</li>',
'<li>HH12</li>',
'<li>HH24</li>',
'<li>AM</li>',
'<li>PM</li>',
'<li>MI</li>',
'<li>SYEAR</li>',
'<li>BC</li>',
'<li>CC</li>',
'<li>SCC</li>',
'<li>IYYY</li>',
'<li>Q</li>',
'<li>FMMONTH</li>',
'<li>RM</li>',
'<li>IW</li>',
'<li>FMDAY</li>',
'<li>DDTH</li>',
'<li>DDSPTH</li>',
'<li>J</li>',
'</ul>',
'<p>Placing an "I" in front of any string will INITCAP the text.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22163600083144137)
,p_plug_name=>'Comments'
,p_region_name=>'C'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>130
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22163809613144137)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(12991522578387911)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(33418028849020737)
,p_plug_name=>'Subscription'
,p_region_name=>'SUBSCRIPTION'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>120
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_column=>false
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P697_THEME_IS_SUBSCRIBED'
,p_plug_display_when_cond2=>'NONE'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'WWV_FLOW_CAL_TEMPLATES',
  'attribute_02', 'NAME',
  'attribute_03', 'P697_ID',
  'attribute_04', 'P697_REFERENCE_ID',
  'attribute_05', 'SUBSCRIBE_TEMPLATE')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46233105873678957)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(620052512654414383)
,p_plug_name=>'History'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_imp.id(29434107863295859)
,p_plug_display_sequence=>140
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from  WWV_FLOW_CAL_TEMPLATES',
'where id = :F4000_P697_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :F4000_P697_ID,',
'      p_component_type => ''Button Template'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'F4000_P697_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(932807158581193715)
,p_plug_name=>'Subscription'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P697_THEME_IS_SUBSCRIBED = ''BOTH'' then',
'     sys.htp.p(wwv_flow_lang.system_message(''TEMPLATE_SUBSCRIPTION.THEME_AND_TEMPLATE_SUBSCRIBED''));',
'else',
'     sys.htp.p(wwv_flow_lang.system_message(''TEMPLATE_SUBSCRIPTION.THEME_SUBSCRIBED''));',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P697_THEME_IS_SUBSCRIBED'
,p_plug_display_when_cond2=>'NONE'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'N',
  'attribute_02', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(22165925902144142)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(22161207490144133)
,p_button_name=>'APPLY_CHANGES_GET_PREVIOUS_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'disabled=""'
,p_button_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(22165713747144142)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_imp.id(22161207490144133)
,p_button_name=>'APPLY_CHANGES_GET_NEXT_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Next'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'disabled=""'
,p_button_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(22164704556144141)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(33418028849020737)
,p_button_name=>'PUBLISH_TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Publish Template'
,p_button_position=>'COPY'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.::F4000_P149_ID,F4000_P149_PAGE_ID,F4000_P149_TEMPLATE_TYPE:&F4000_P697_ID.,&FLOW_PAGE_ID.,CALENDAR_TEMPLATE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_cal_templates',
' where reference_id      = :F4000_P697_ID',
'   and security_group_id = :workspace_id'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(22164521632144140)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(33418028849020737)
,p_button_name=>'COPY_TEMPLATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Refresh'
,p_button_position=>'COPY'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_cal_templates',
' where id                = :F4000_P697_ID',
'   and security_group_id = :workspace_id',
'   and reference_id     is not null'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(22165104505144141)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(22161207490144133)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(22165524161144142)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(22161207490144133)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:504:&SESSION.::&DEBUG.::P504_ID:&F4000_P697_ID.'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P697_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(22164914232144141)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(22161207490144133)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P697_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(22183328150144159)
,p_branch_action=>'f?p=&APP_ID.:697:&SESSION.::&DEBUG.::F4000_P697_ID:&P697_ID_NEXT.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(22165713747144142)
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(22183516143144159)
,p_branch_action=>'f?p=&APP_ID.:697:&SESSION.::&DEBUG.::F4000_P697_ID:&P697_ID_PREV.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(22165925902144142)
,p_branch_sequence=>40
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(22183714058144159)
,p_branch_action=>'f?p=&APP_ID.:697:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(22164521632144140)
,p_branch_sequence=>50
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(22182916096144158)
,p_branch_action=>'f?p=&APP_ID.:697:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P697_STAY'
,p_branch_condition_text=>'YES'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(22182329029144158)
,p_branch_action=>'f?p=&APP_ID.:670:&SESSION.::&DEBUG.::P670_ID:&F4000_P697_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>70
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_WEEKLY_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(22182525048144158)
,p_branch_action=>'f?p=&APP_ID.:661:&SESSION.::&DEBUG.::P661_ID:&F4000_P697_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>80
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_DAILY_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(30775807899904776)
,p_branch_action=>'f?p=&APP_ID.:836:&SESSION.::&DEBUG.::P836_ID:&F4000_P697_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>90
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_CUSTOM_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3709221250249513)
,p_branch_action=>'f?p=&APP_ID.:80:&SESSION.::&DEBUG.::P80_ID:&F4000_P697_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>100
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_AGENDA_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(22202122389246662)
,p_branch_action=>'f?p=&APP_ID.:122:&SESSION.::&DEBUG.::P122_ID:&F4000_P697_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>120
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_MONTHLY_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(22183107094144158)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>130
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22166114485144143)
,p_name=>'F4000_P697_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(22161419106144134)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cHeight=>1
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22166303452144144)
,p_name=>'P697_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(22161419106144134)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Defines a name that identifies the template. <p />',
'',
'Use the <strong>Translatable</strong> check box to indicate if the template contains text strings that require translation.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22166812605144144)
,p_name=>'P697_TRANSLATE_THIS_TEMPLATE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(22161419106144134)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Translatable'
,p_source=>'TRANSLATE_THIS_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22177028263144151)
,p_name=>'P697_REFERENCE_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(33418028849020737)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Reference Master Template From'
,p_source=>'REFERENCE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FLOW_SUBSCRIBE_FROM_CAL_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||lower(wwv_flow_lang.system_message(''NO_TEMPLATE''))||'' -'' d, ',
'        0 r from sys.dual',
' union all',
'select flow_id||'' : ''||name||decode(theme_id,',
'       null,',
'       '''',',
'       '' (''||theme_id||'')'') d,',
'       id r',
'  from wwv_flow_cal_templates',
' where flow_id          != nvl(:fb_flow_id,0)',
'   and security_group_id = :WORKSPACE_ID',
'   and flow_id          in ( select f.id',
'                               from wwv_main_apps_dev f',
'                              where security_group_id = :flow_security_group_id',
'                                and build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'                                and exists ( select 1 ',
'                                               from wwv_flow_developers',
'                                              where userid            = :flow_user ',
'                                                and (flow_id is null or flow_id = f.id)',
'                                                and security_group_id = :flow_security_group_id))',
''))
,p_cSize=>60
,p_cMaxlength=>255
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">You may select an existing template in this workspace or another template in your workspace''s schema. By selecting an existing template, you become a subscriber to that template.</div>',
'<div class="htmldbInfoBodyP">To load a new copy of any master template, click <span class="fielddatabold">Refresh</span>.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22177517891144152)
,p_name=>'P697_STAY'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(22162817201144136)
,p_prompt=>'Stay on page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select this checkbox to stay on this page after applying changes.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'YES'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22178016817144152)
,p_name=>'P697_REFRESH'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(33418028849020737)
,p_item_default=>'Y'
,p_prompt=>'Refresh'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_cal_templates',
' where reference_id is null',
'   and id = :F4000_P697_ID',
'   and security_group_id = :workspace_id'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22178228747144153)
,p_name=>'P697_THEME_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(22161419106144134)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Theme:'
,p_source=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_tag_css_classes=>'fielddatabold'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Indicates the theme to which the template is a member.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22178712052144153)
,p_name=>'P697_THEME_CLASS_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(22161419106144134)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Template Class'
,p_source=>'THEME_CLASS_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CALENDAR THEME CLASS ID'
,p_lov=>'.'||wwv_flow_imp.id(43619531898960304)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Not Identified -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Identifies a specific usage for this template.</div>',
'<div class="htmldbInfoBodyP">When you switch to a new theme, all templates in one theme are assigned to corresponding templates in another theme. App Builder accomplishes this template mapping through the assignment of template class identifiers.</di'
||'v>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22179222292144153)
,p_name=>'P697_TEMPLATE_COMMENTS'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(22163600083144137)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comments'
,p_source=>'TEMPLATE_COMMENTS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>5
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Developer comments or notes. These comments never display when the application is running.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22179727735144153)
,p_name=>'P697_ID_NEXT'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(22161207490144133)
,p_prompt=>'P697_ID_NEXT'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22179910067144154)
,p_name=>'P697_ID_PREV'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(22161207490144133)
,p_prompt=>'P697_ID_PREV'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22180124658144154)
,p_name=>'P697_ID_COUNT'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(22161207490144133)
,p_prompt=>'Calendar Template: '
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies calendar template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(757097111519899233)
,p_name=>'P697_INTERNAL_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(22161419106144134)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>'INTERNAL_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Template identifier, this is used when switching and upgrading themes and cannot be modified.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2104660226859556476)
,p_name=>'P697_THEME_IS_SUBSCRIBED'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(22161419106144134)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(189760927926997794)
,p_computation_sequence=>10
,p_computation_item=>'P697_TRANSLATE_THIS_TEMPLATE'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P697_TRANSLATE_THIS_TEMPLATE is null or :P697_TRANSLATE_THIS_TEMPLATE = '''' then ',
'    return ''N'';',
'else',
'    return :P697_TRANSLATE_THIS_TEMPLATE;',
'end if;'))
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2104660757231561659)
,p_computation_sequence=>20
,p_computation_item=>'P697_THEME_IS_SUBSCRIBED'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'    l_is_subscribed varchar2(16) := ''NONE'';',
'begin',
'  ',
'    for c1 in (',
'        select t.reference_id template_ref_id, ',
'               th.reference_id theme_ref_id',
'          from wwv_flow_cal_templates t, ',
'               wwv_flow_themes th',
'         where t.id                 = :F4000_P697_ID',
'           and t.flow_id            = th.flow_id',
'           and t.theme_id           = th.theme_id',
'           and t.security_group_id  = :workspace_id',
'           and th.security_group_id = t.security_group_id',
'    ) loop',
'        if c1. theme_ref_id is not null then',
'            if c1.template_ref_id is not null then',
'                l_is_subscribed := ''BOTH'';',
'            else ',
'                l_is_subscribed := ''THEME'';',
'            end if;',
'        end if;    ',
'    end loop;',
'',
'    return l_is_subscribed;',
'',
'end;'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(397295711399444974)
,p_name=>'ENABLE PREVIOUS'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P697_ID_PREV'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(397296002313444975)
,p_event_id=>wwv_flow_imp.id(397295711399444974)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(22165925902144142)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(397296116247446382)
,p_name=>'ENABLE NEXT'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P697_ID_NEXT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(397296427668446382)
,p_event_id=>wwv_flow_imp.id(397296116247446382)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(22165713747144142)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3002413637333522)
,p_name=>'Show Publish Success Msg'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(22164704556144141)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3002574856333523)
,p_event_id=>wwv_flow_imp.id(3002413637333522)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ( this.data.successMessage ) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(22180827718144156)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_CAL_TEMPLATES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_CAL_TEMPLATES'
,p_attribute_03=>'F4000_P697_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_15=>'D'
,p_process_error_message=>'Unable to fetch row.'
,p_internal_uid=>22180827718144156
,p_process_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(22181014425144156)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_PAGINATION'
,p_process_name=>'Get Next or Previous Primary Key Value'
,p_attribute_02=>'WWV_FLOW_CAL_TEMPLATES'
,p_attribute_03=>'F4000_P697_ID'
,p_attribute_04=>'ID'
,p_attribute_07=>'THEME_ID'
,p_attribute_08=>'NAME'
,p_attribute_09=>'P697_ID_NEXT'
,p_attribute_10=>'P697_ID_PREV'
,p_attribute_13=>'P697_ID_COUNT'
,p_attribute_14=>'flow_id = :fb_flow_id'
,p_process_error_message=>'Unable to run Get Next or Previous Primary Key Value process.'
,p_internal_uid=>22181014425144156
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(22181204218144156)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_CAL_TEMPLATES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_CAL_TEMPLATES'
,p_attribute_03=>'F4000_P697_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_process_error_message=>'Unable to process calendar template.'
,p_process_when=>'COPY_TEMPLATE'
,p_process_when_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>22181204218144156
,p_process_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(22181404137144157)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'122'
,p_process_when_button_id=>wwv_flow_imp.id(22165524161144142)
,p_internal_uid=>22181404137144157
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(22181631750144157)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh calendar template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_calendar_template (',
'    p_master_template_id         => :P697_REFERENCE_ID,',
'    p_subscribing_template_id    => :F4000_P697_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying template.'
,p_process_when_button_id=>wwv_flow_imp.id(22164521632144140)
,p_process_when=>'P697_REFERENCE_ID'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_process_when2=>'0'
,p_process_success_message=>'Template copied.'
,p_internal_uid=>22181631750144157
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(22181809002144157)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove reference id'
,p_process_sql_clob=>'wwv_flow_copy_metadata.remove_button_reference_id (:F4000_P697_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error setting template id to null.'
,p_process_when=>'P697_REFERENCE_ID'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'0'
,p_process_success_message=>'Reference id is removed.'
,p_internal_uid=>22181809002144157
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(22182005033144157)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh calendar template 2'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_calendar_template (',
'    p_master_template_id         => :P697_REFERENCE_ID,',
'    p_subscribing_template_id    => :F4000_P697_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying template.'
,p_process_when_button_id=>wwv_flow_imp.id(22164914232144141)
,p_process_when=>':P697_REFERENCE_ID is not null and :P697_REFRESH = ''Y'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Template copied.'
,p_internal_uid=>22182005033144157
);
end;
/
prompt --application/pages/page_00699
begin
wwv_flow_imp_page.create_page(
 p_id=>699
,p_name=>'Dynamic Action Utilities'
,p_alias=>'DYNAMIC-ACTION-UTILITIES'
,p_step_title=>'All Dynamic Actions'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(4518805581694342)
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_dynamic_actions.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47046221608720151)
,p_plug_name=>'Dynamic Actions'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>150
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  dynamic_action_id               dynamic_action_id,',
'        application_id                  application_id,',
'        page_id                         page,',
'        page_name                       page_name,',
'        dynamic_action_name             name,',
'        --',
'        when_event_name                 event,',
'        when_selection_type             element_type,',
'        case ',
'            when when_selection_type = ''Region'' then ',
'                wwv_flow_escape.html(when_region)',
'            when when_selection_type = ''Button'' then ',
'                wwv_flow_escape.html(when_button)',
'            else ',
'                replace(wwv_flow_escape.html(when_element), '','', ''<br />'')',
'        end element,',
'        when_condition || '' '' ||',
'            case when nvl(length(when_expression),0) < 50 then',
'                when_expression',
'            else ',
'                substr(when_expression,0,50) || ''...''',
'            end       triggering_condition,',
'        --',
'        decode(CONDITION_TYPE, null, '''',',
'                                     ''<span class="a-Icon icon-check">'' || wwv_flow_lang.system_message(''CONDITIONAL'') || ''</span>'')    conditional,',
'        build_option                    build_option,',
'        number_of_actions               actions,',
'        LAST_UPDATED_ON       updated,',
'        LAST_UPDATED_BY       updated_by',
' from   apex_application_page_da',
'where   application_id = :fb_flow_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(47046318950720151)
,p_name=>'Dynamic Actions'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'ANTHONY'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47046524054720174)
,p_db_column_name=>'DYNAMIC_ACTION_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Name'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47046632692720177)
,p_db_column_name=>'PAGE'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Page'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE#'
,p_column_linktext=>'#PAGE#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47046732176720178)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Page Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47046832629720178)
,p_db_column_name=>'NAME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Name'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE##5140:#DYNAMIC_ACTION_ID#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(499198316165945806)
,p_db_column_name=>'EVENT'
,p_display_order=>5
,p_column_identifier=>'Q'
,p_column_label=>'When Event'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47046908037720178)
,p_db_column_name=>'ELEMENT'
,p_display_order=>6
,p_column_identifier=>'E'
,p_column_label=>'When Element'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47047012897720179)
,p_db_column_name=>'ELEMENT_TYPE'
,p_display_order=>7
,p_column_identifier=>'F'
,p_column_label=>'When Selection Type'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47047321224720180)
,p_db_column_name=>'TRIGGERING_CONDITION'
,p_display_order=>10
,p_column_identifier=>'I'
,p_column_label=>'When Condition'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47047515865720182)
,p_db_column_name=>'CONDITIONAL'
,p_display_order=>12
,p_column_identifier=>'K'
,p_column_label=>'Conditional'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47047611027720182)
,p_db_column_name=>'BUILD_OPTION'
,p_display_order=>13
,p_column_identifier=>'L'
,p_column_label=>'Build Option'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47047731951720182)
,p_db_column_name=>'UPDATED'
,p_display_order=>14
,p_column_identifier=>'M'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47047808778720183)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>15
,p_column_identifier=>'N'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47048829360776083)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>16
,p_column_identifier=>'O'
,p_column_label=>'Application Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47050418288848647)
,p_db_column_name=>'ACTIONS'
,p_display_order=>17
,p_column_identifier=>'P'
,p_column_label=>'Actions'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(47047900654720547)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1290503702536644'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'PAGE:PAGE_NAME:NAME:EVENT:ELEMENT_TYPE:ELEMENT:TRIGGERING_CONDITION:CONDITIONAL:BUILD_OPTION:UPDATED:UPDATED_BY:ACTIONS'
,p_sort_column_1=>'PAGE'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(194145001657122752)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>130
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(28119925264668131)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(194145420808124166)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47046221608720151)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:699:&SESSION.::&DEBUG.:699,RIR::'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(4638212560334514)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'699'
,p_compute_when_type=>'%null%'
);
end;
/
prompt --application/pages/page_00700
begin
wwv_flow_imp_page.create_page(
 p_id=>700
,p_name=>'Create Form and Report on Web Service - Choose Service and Operation'
,p_alias=>'CREATE-FORM-AND-REPORT-ON-WEB-SERVICE-CHOOSE-SERVICE-AND-OPERATION'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Form and Report on Web Service'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_step_template=>wwv_flow_imp.id(120871216744825711)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30025016313145138)
,p_plug_name=>'Create Form and Report on Web Service'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<p>Select the web service definition and an operation on which to build the form. If you do not have a web service reference defined, expand the Tasks region and create one.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30025418800145140)
,p_plug_name=>'Wizard Steps'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(30094110886480012)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(57092125253371601)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-LinksList--nowrap:a-LinksList--showArrow'
,p_plug_template=>wwv_flow_imp.id(399849897040726767)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(57083604297327751)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(204742702765090184)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>140
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30025809110145143)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(204742702765090184)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30026205258145151)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(204742702765090184)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(699462838702674742)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(204742702765090184)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:2500:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(30030108458145205)
,p_branch_action=>'f?p=&FLOW_ID.:705:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(30026205258145151)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(30030524987145209)
,p_branch_action=>'f?p=&FLOW_ID.:700:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30026626676145154)
,p_name=>'P700_OPERATION_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(30025016313145138)
,p_prompt=>'Operation'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P700_SERVICE_OPERATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'  from wwv_flow_ws_operations',
' where name != ''BASIC_AUTH''',
'   and ws_id = :P700_WS_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Operation -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_display_when=>'nvl(:P700_WS_ID,''0'') != ''0'' and nvl(:P700_WEB_REF_TYPE,''MANUAL'') != ''MANUAL'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the operation.  The operation is the method that will be executed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30027313242145172)
,p_name=>'P700_OPERATION_ID_ORIG'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(30025016313145138)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30027719013145173)
,p_name=>'P700_WS_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(30025016313145138)
,p_prompt=>'Web Service Reference'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P600_WEB_SERVICES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'  from wwv_flow_shared_web_services',
' where flow_id = :FB_FLOW_ID',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Service -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the name of the Web service reference.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(193667204652329394)
,p_name=>'P700_WEB_REF_TYPE'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_imp.id(30025016313145138)
,p_prompt=>'Web Service Reference Type'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'P600_WEB_REF_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(191288700473281420)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'nvl(:P700_WS_ID,''0'') != ''0'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(309346715552014028)
,p_name=>'P700_OUTPUT_TYPE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(30025016313145138)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(193667421274334185)
,p_computation_sequence=>10
,p_computation_item=>'P700_WEB_REF_TYPE'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select nvl(action,''NONE'') act ',
'             from wwv_flow_shared_web_services',
'            where id = :P700_WS_ID ) loop',
'  if c1.act in (''REST'',''NEW_SCHOOL'') then',
'    return c1.act;',
'  else',
'    return ''MANUAL'';',
'  end if;',
'end loop;'))
,p_compute_when=>'P700_WS_ID'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(193922220810743532)
,p_computation_sequence=>30
,p_computation_item=>'P700_OPERATION_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P700_WEB_REF_TYPE = ''REST'' then',
'  for c1 in (select id',
'             from wwv_flow_ws_operations',
'            where ws_id = :P700_WS_ID',
'              and name = ''doREST'' ) loop',
'    return c1.id;',
'  end loop;',
'else',
'  return null;',
'end if;'))
,p_compute_when=>'P700_WS_ID'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(309347002664016405)
,p_computation_sequence=>60
,p_computation_item=>'P700_OUTPUT_TYPE'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(static_parm_05 ,''x'')',
'  from wwv_flow_shared_web_services',
' where id = :P700_WS_ID'))
,p_compute_when=>'NEXT'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(30028529013145178)
,p_computation_sequence=>10
,p_computation_item=>'P700_OPERATION_ID_ORIG'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P700_OPERATION_ID'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(30028911317145187)
,p_validation_name=>'P700_WS_ID'
,p_validation_sequence=>10
,p_validation=>'nvl(:P700_WS_ID,''0'') != ''0'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'You must choose a web service.'
,p_when_button_pressed=>wwv_flow_imp.id(30026205258145151)
,p_associated_item=>wwv_flow_imp.id(30027719013145173)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(30029321337145192)
,p_validation_name=>'P700_OPERATION_ID'
,p_validation_sequence=>20
,p_validation=>'nvl(:P700_OPERATION_ID,''0'') != ''0'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'You must choose an operation.'
,p_validation_condition=>'nvl(:P700_WEB_REF_TYPE,''MANUAL'') != ''MANUAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(30026205258145151)
,p_associated_item=>wwv_flow_imp.id(30026626676145154)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(549718349012753344)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(30025809110145143)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(549718455269753345)
,p_event_id=>wwv_flow_imp.id(549718349012753344)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(30029725598145198)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'clean up collections'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_collection.collection_exists(''WS_INPUT_ITEMS'') then',
'  wwv_flow_collection.delete_collection(''WS_INPUT_ITEMS'');',
'end if;',
'if wwv_flow_collection.collection_exists(''WS_OUTPUT_ITEMS'') then',
'  wwv_flow_collection.delete_collection(''WS_OUTPUT_ITEMS'');',
'end if;',
'if wwv_flow_collection.collection_exists(''WS_AUTH_ITEMS'') then',
'  wwv_flow_collection.delete_collection(''WS_AUTH_ITEMS'');',
'end if;',
'if wwv_flow_collection.collection_exists(''WS_ARRAY_PARMS'') then',
'  wwv_flow_collection.delete_collection(''WS_ARRAY_PARMS'');',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'nvl(:P700_OPERATION_ID_ORIG,''x'') != nvl(:P700_OPERATION_ID,''y'')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>30029725598145198
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(504399719148542232)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'clear cache on 705'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'705'
,p_process_when=>'P700_WS_ID'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>504399719148542232
);
end;
/
prompt --application/pages/page_00701
begin
wwv_flow_imp_page.create_page(
 p_id=>701
,p_name=>'Create Dynamic List'
,p_alias=>'CREATE-DYNAMIC-LIST1'
,p_page_mode=>'NON_MODAL'
,p_step_title=>'Create Dynamic List'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213415628923422845)
,p_step_template=>wwv_flow_imp.id(120871216744825711)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'570'
,p_dialog_width=>'820'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_lov.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1445515741805192)
,p_plug_name=>'Create Dynamic List'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(754560332977487448)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(754560470865487449)
,p_plug_name=>'Create Dynamic List'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1445904971805193)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(754560332977487448)
,p_button_name=>'FINISH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1446102220805193)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(754560332977487448)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1445706955805192)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(754560332977487448)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1448811862805196)
,p_branch_action=>'f?p=&APP_ID.:719:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(1445904971805193)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1448615775805196)
,p_branch_action=>'f?p=&APP_ID.:542:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(1446102220805193)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1446316855805193)
,p_name=>'P701_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1445515741805192)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Owner:'
,p_source=>'P542_OWNER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies the database schema owner.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1446827688805195)
,p_name=>'P701_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1445515741805192)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Table:'
,p_source=>'P542_TABLE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies the selected table.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1447824232805196)
,p_name=>'P701_LABEL_COLUMN'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(1445515741805192)
,p_prompt=>'Label Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc, column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P542_OWNER',
'   and table_name = :P542_TABLE'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- select value -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identify the column that will be the label value.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10730513062133082)
,p_name=>'P701_TARGET_COLUMN'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(1445515741805192)
,p_prompt=>'Target Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc, column_name',
'  from wwv_flow_table_columns_dev',
' where owner = :P542_OWNER',
'   and table_name = :P542_TABLE',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- select value -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identify the column that will be the target value.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10731020681135274)
,p_name=>'P701_TARGET_URL'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(1445515741805192)
,p_prompt=>'URL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identify the column that will be the returned value.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10731527261137176)
,p_name=>'P701_IMAGE_ATTR_COLUMN'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(1445515741805192)
,p_prompt=>'Image Attributes'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc, column_name',
'  from wwv_flow_table_columns_dev',
' where owner = :P542_OWNER',
'   and table_name = :P542_TABLE',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- select value -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identify the column that will be the image attribute value.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10733111462142119)
,p_name=>'P701_IMAGE_COLUMN'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(1445515741805192)
,p_prompt=>'Image Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc, column_name',
'  from wwv_flow_table_columns_dev',
' where owner = :P542_OWNER',
'   and table_name = :P542_TABLE',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- select value -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identify the column that will be the image value.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14424006325318187)
,p_name=>'P701_IMAGE_ALT_COLUMN'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(1445515741805192)
,p_prompt=>'Image Alt Attribute'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc, column_name',
'  from wwv_flow_table_columns_dev',
' where owner = :P542_OWNER',
'   and table_name = :P542_TABLE',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- select value -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identify the column that will be the image alt attribute value.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14426220439341167)
,p_name=>'P701_IS_CURRENT'
,p_item_sequence=>65
,p_item_plug_id=>wwv_flow_imp.id(1445515741805192)
,p_prompt=>'Is Current Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_YES_OR_NO'
,p_lov=>'.'||wwv_flow_imp.id(84270019143507704)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- select value -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identify whether the link entry is current to the current page.  If this item is not set, the target url will be assessed, to establish whether the list entry is current.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14429817500378158)
,p_name=>'P701_ATTRIBUTE_1'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(1445515741805192)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identify the column that will be the returned value.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14430323388379818)
,p_name=>'P701_ATTRIBUTE_2'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(1445515741805192)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identify the column that will be the returned value.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14430928929381511)
,p_name=>'P701_ATTRIBUTE_3'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(1445515741805192)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identify the column that will be the returned value.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14431502740383406)
,p_name=>'P701_ATTRIBUTE_4'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(1445515741805192)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identify the column that will be the returned value.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14432512091386086)
,p_name=>'P701_ATTRIBUTE_5'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(1445515741805192)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identify the column that will be the returned value.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14433018324387851)
,p_name=>'P701_ATTRIBUTE_6'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(1445515741805192)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identify the column that will be the returned value.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14433523519389369)
,p_name=>'P701_ATTRIBUTE_7'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(1445515741805192)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identify the column that will be the returned value.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14434029752391188)
,p_name=>'P701_ATTRIBUTE_8'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(1445515741805192)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identify the column that will be the returned value.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14434703910393159)
,p_name=>'P701_ATTRIBUTE_9'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(1445515741805192)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identify the column that will be the returned value.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14435210144394936)
,p_name=>'P701_ATTRIBUTE_10'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(1445515741805192)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identify the column that will be the returned value.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(10772627859497594)
,p_name=>'Target Setting'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P701_TARGET_COLUMN'
,p_condition_element=>'P701_TARGET_COLUMN'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(10772928254497600)
,p_event_id=>wwv_flow_imp.id(10772627859497594)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P701_TARGET_URL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(10773525220506235)
,p_event_id=>wwv_flow_imp.id(10772627859497594)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P701_TARGET_URL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(10773011714502314)
,p_name=>'Target URL Setting'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P701_TARGET_URL'
,p_condition_element=>'P701_TARGET_URL'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(10773317902502314)
,p_event_id=>wwv_flow_imp.id(10773011714502314)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P701_TARGET_COLUMN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(10773703880509585)
,p_event_id=>wwv_flow_imp.id(10773011714502314)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P701_TARGET_COLUMN'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(758615284358655702)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1445706955805192)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(758615371776655703)
,p_event_id=>wwv_flow_imp.id(758615284358655702)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1448304048805196)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'check privs'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_sw_api.check_priv_object(',
'    p_application_id => :fb_flow_id,',
'    p_schema => :P542_OWNER,',
'    p_object => :P542_TABLE);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Invalid Schema Owner'
,p_internal_uid=>1448304048805196
);
end;
/
prompt --application/pages/page_00702
begin
wwv_flow_imp_page.create_page(
 p_id=>702
,p_name=>'Translation Repository'
,p_alias=>'TRANSLATION-REPOSITORY'
,p_step_title=>'Translation Repository'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213331522315193801)
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'global_process.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(162445917180498617)
,p_plug_name=>'Translation Repository'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.id "ID", ',
'       t."TRANSLATED_FLOW_ID",',
'       t."PAGE_ID",',
'       t."TRANSLATE_TO_LANG_CODE",',
'       t."TRANSLATION_SPECIFIC_TO_ITEM",',
'       sys.dbms_lob.substr(t."TRANSLATE_TO_TEXT",255,1) "TRANSLATE_TO_TEXT",',
'       sys.dbms_lob.substr(t."TRANSLATE_FROM_TEXT",255,1) "TRANSLATE_FROM_TEXT",',
'       t.template_translatable,',
'       c.column_description,',
'       t.created_on created,',
'       t.created_by,',
'       nvl(t.last_updated_on,t.created_on) updated,',
'       nvl(t.last_updated_by,t.created_by) updated_by,',
'       case when ',
'           sys.dbms_lob.compare(translate_to_text,translate_from_text) != 0',
'           or nvl(length(translate_from_text),0) != nvl(length(translate_to_text),0) then ''Y''',
'           else ''N''',
'       end translated       ',
' from WWV_FLOW_TRANSLATABLE_TEXT$ t, ',
'      wwv_flow_translatable_cols$ c',
'where t.translate_from_flow_table = c.table_name',
'  and t.translate_from_flow_column = c.column_name',
'  and (c.template_translatable = ''N'' or (c.template_translatable = ''Y'' and t.template_translatable = ''Y''))',
'  and t.flow_id = :fb_flow_id ',
'  and t.security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(162446021231498617)
,p_name=>'Translatable Text'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No translatable text found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162446204401498620)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Edit'
,p_column_link=>'f?p=&APP_ID.:704:&SESSION.::&DEBUG.:704:P704_ID:#ID#'
,p_column_linktext=>'<span class="a-Icon icon-edit"></span>'
,p_column_link_attr=>'class="a-Button a-Button--small"'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162446322302498621)
,p_db_column_name=>'TRANSLATED_FLOW_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Translated Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162446413263498621)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162446503827498622)
,p_db_column_name=>'TRANSLATE_TO_LANG_CODE'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Language'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162446615134498622)
,p_db_column_name=>'TRANSLATION_SPECIFIC_TO_ITEM'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Specific To Item'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162446707251498623)
,p_db_column_name=>'TRANSLATE_TO_TEXT'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Translate To'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162446815541498623)
,p_db_column_name=>'TRANSLATE_FROM_TEXT'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Translate From'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162447020620498626)
,p_db_column_name=>'COLUMN_DESCRIPTION'
,p_display_order=>8
,p_column_identifier=>'I'
,p_column_label=>'Column Description'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162446915311498624)
,p_db_column_name=>'TEMPLATE_TRANSLATABLE'
,p_display_order=>9
,p_column_identifier=>'H'
,p_column_label=>'Template Translatable'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162448803107561521)
,p_db_column_name=>'CREATED'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Created'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162448912602561523)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Created By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162449031316561524)
,p_db_column_name=>'UPDATED'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162449108405561525)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(953242475566873701)
,p_db_column_name=>'TRANSLATED'
,p_display_order=>23
,p_column_identifier=>'N'
,p_column_label=>'Translated'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(84259319526460470)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(162447421583500586)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1290602803536644'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'ID:TRANSLATED_FLOW_ID:PAGE_ID:TRANSLATE_TO_LANG_CODE:TRANSLATE_FROM_TEXT:TRANSLATE_TO_TEXT:COLUMN_DESCRIPTION:TRANSLATED:CREATED:CREATED_BY:UPDATED:UPDATED_BY:'
,p_sort_column_1=>'PAGE_ID'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(188999808951178335)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(162445917180498617)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:702:&SESSION.::&DEBUG.:RP,702,RIR::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(327872113487555258)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(162445917180498617)
,p_button_name=>'GRID_EDIT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'Grid Edit'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:891:&SESSION.::&DEBUG.:RP,891::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(28700219818217334)
,p_branch_action=>'f?p=&APP_ID.:702:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_00704
begin
wwv_flow_imp_page.create_page(
 p_id=>704
,p_name=>'Edit Translatable Text'
,p_alias=>'EDIT-TRANSLATABLE-TEXT'
,p_page_mode=>'MODAL'
,p_step_title=>'Edit Translatable Text'
,p_reload_on_submit=>'A'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213331522315193801)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'span.apex-item-display-only.faux-textarea {',
'    display: block;',
'    font-weight: normal;',
'    font-size: 12px;',
'    line-height: 16px;',
'    width: 100%;',
'    font-family: ''Consolas'', ''Menlo'', monospace;',
'}'))
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(28652828679978612)
,p_plug_name=>'Translatable Text'
,p_region_template_options=>'#DEFAULT#:a-Form--fixedLabels'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(60924220131746701)
,p_plug_name=>'Wizard buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>92
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747144731158138169)
,p_plug_name=>'Edit Translatable Text'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(28653412999978613)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(60924220131746701)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:702:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(28653112910978612)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(60924220131746701)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P704_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(28653903725978614)
,p_branch_action=>'f?p=&APP_ID.:702:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>21
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28654116085978614)
,p_name=>'P704_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(28652828679978612)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28654301197978616)
,p_name=>'P704_TRANSLATED_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(28652828679978612)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Translated Application:'
,p_source=>'TRANSLATED_FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the new translated application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28654504346978617)
,p_name=>'P704_FLOW_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(28652828679978612)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application:'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the primary language application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28654906922978618)
,p_name=>'P704_PAGE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(28652828679978612)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Page:'
,p_source=>'PAGE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the page that corresponds to the component being translated.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28655122891978618)
,p_name=>'P704_TRANSLATE_FROM_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(28652828679978612)
,p_use_cache_before_default=>'NO'
,p_source=>'TRANSLATE_FROM_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28655320517978618)
,p_name=>'P704_TRANSLATE_TO_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(28652828679978612)
,p_use_cache_before_default=>'NO'
,p_source=>'TRANSLATE_TO_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_display_when_type=>'NEVER'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28656301880978619)
,p_name=>'P704_TRANSLATE_TO_TEXT'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(28652828679978612)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Translate To Text:'
,p_source=>'TRANSLATE_TO_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cMaxlength=>32767
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Identifies the translated text.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28656503901978619)
,p_name=>'P704_TRANSLATE_FROM_TEXT'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(28652828679978612)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Translate From Text:'
,p_source=>'TRANSLATE_FROM_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'faux-textarea'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the primary language text.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28656732239978619)
,p_name=>'P704_TEMPLATE_TRANSLATABLE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(28652828679978612)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Template Translatable:'
,p_source=>'TEMPLATE_TRANSLATABLE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(84259319526460470)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the translatability of template components'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(94701704408519820)
,p_name=>'P704_TRANSLATE_TO_LANGUAGE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(28652828679978612)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Translate To:'
,p_source=>'TRANSLATE_TO_LANG_CODE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'I18N_LANGUAGES_LOCALES'
,p_lov=>'.'||wwv_flow_imp.id(107899321117195063)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identifies the language this string will be translated to.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(416034016397152705)
,p_name=>'P704_COUNT'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(28652828679978612)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(416034313070152708)
,p_name=>'P704_UPDATE_ALL'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(28652828679978612)
,p_prompt=>'Update all &P704_COUNT. occurrences of this string'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_display_when=>'to_number(nvl(:P704_COUNT,0)) > 1'
,p_display_when2=>'SQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(416034283913152707)
,p_computation_sequence=>10
,p_computation_item=>'P704_COUNT'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*)',
'  from wwv_flow_translatable_text$',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id = :FB_FLOW_ID',
'   and sys.dbms_lob.compare(translate_from_text,to_clob(:P704_TRANSLATE_FROM_TEXT)) = 0',
'   and translate_to_lang_code = :P704_TRANSLATE_TO_LANGUAGE',
'   and translate_from_text is not null'))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(28657023841978620)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_TRANSLATABLE_TEXT$'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_TRANSLATABLE_TEXT$'
,p_attribute_03=>'P704_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Unable to fetch row.'
,p_internal_uid=>28657023841978620
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(60914420599680543)
,p_process_sequence=>35
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update Rows'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if nvl(:P704_UPDATE_ALL,''N'') = ''Y'' then',
'    --',
'    -- All rows where the string matches',
'    --',
'    update wwv_flow_translatable_text$',
'      set translate_to_text = :P704_TRANSLATE_TO_TEXT',
'    where security_group_id = :FLOW_SECURITY_GROUP_ID',
'      and flow_id = :FB_FLOW_ID',
'      and translate_to_lang_code = :P704_TRANSLATE_TO_LANGUAGE',
'      and sys.dbms_lob.compare(translate_from_text,to_clob(:P704_TRANSLATE_FROM_TEXT)) = 0',
'      and translate_from_text is not null;',
'else',
'    --',
'    -- Only update this specific string',
'    --',
'    update wwv_flow_translatable_text$',
'      set translate_to_text = :P704_TRANSLATE_TO_TEXT',
'    where security_group_id = :FLOW_SECURITY_GROUP_ID',
'      and flow_id = :FB_FLOW_ID',
'      and id = :P704_ID;',
'end if;',
'',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to process action.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(28653112910978612)
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>60914420599680543
);
end;
/
prompt --application/pages/page_00705
begin
wwv_flow_imp_page.create_page(
 p_id=>705
,p_name=>'Create Form and Report on Web Service - Page and Region Attributes'
,p_alias=>'CREATE-FORM-AND-REPORT-ON-WEB-SERVICE-PAGE-AND-REGION-ATTRIBUTES'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Form and Report on Web Service'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30032223951154262)
,p_plug_name=>'Create Form and Report on Web Service'
,p_region_template_options=>'#DEFAULT#:#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>130
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>'<p>Use this page to specify page and region information.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30033427191154267)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(30094110886480012)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(204744409476101591)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>160
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30033822808154267)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_imp.id(204744409476101591)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30034225253154268)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(204744409476101591)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30034607655154269)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(204744409476101591)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(34482328673179131)
,p_branch_action=>'f?p=&APP_ID.:880:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(30034225253154268)
,p_branch_sequence=>25
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P705_IS_REST'
,p_branch_condition_text=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(30041325602154288)
,p_branch_action=>'f?p=&FLOW_ID.:720:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(30034225253154268)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(122074902387965153)
,p_branch_action=>'f?p=&APP_ID.:705:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'P705_BREADCRUMB_ID'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(30041712258154291)
,p_branch_action=>'f?p=&FLOW_ID.:700:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(30034607655154269)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30035027504154269)
,p_name=>'P705_REGION_NAME'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_imp.id(30032223951154262)
,p_prompt=>'Form Region Title'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter a title for the region in which the form will appear.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30035705718154271)
,p_name=>'P705_REGION_TEMPLATE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(30032223951154262)
,p_prompt=>'Form Region Template'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(default_form_template,default_region_template)',
'  from wwv_flow_themes',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and theme_id          = :FB_THEME_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REGION.TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.d, ',
'       t.r ',
'  from ( select wwv_flow_escape.html(page_plug_template_name) d, ',
'             id r',
'           from wwv_flow_page_plug_templates',
'          where security_group_id = :FLOW_SECURITY_GROUP_ID',
'            and flow_id           = :FB_FLOW_ID',
'            and (:FB_THEME_ID is null or theme_id = :FB_THEME_ID)',
'          order by upper(page_plug_template_name) ) t'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'No Template'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a region template for the new form region.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30036403144154274)
,p_name=>'P705_PAGE_ID'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(30032223951154262)
,p_prompt=>'Page'
,p_source=>'wwv_flow_utilities.minimum_free_page(v(''FB_FLOW_ID''),1)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d',
'  from wwv_flow_steps',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and is_page_pattern   = ''N''',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a page to contain the new form, or enter a new page number.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30037118096154276)
,p_name=>'P705_PAGE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(30032223951154262)
,p_prompt=>'Page Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter a title for the page if it is being created.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30037802765154278)
,p_name=>'P705_WS_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(30032223951154262)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Web Service Reference:'
,p_source=>'P700_WS_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'P600_WEB_SERVICES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'  from wwv_flow_shared_web_services',
' where flow_id = :FB_FLOW_ID',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'The name of the selected Web service reference.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30038505464154279)
,p_name=>'P705_OPERATION_ID'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_imp.id(30032223951154262)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Operation:'
,p_source=>'P700_OPERATION_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'P700_SERVICE_OPERATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'  from wwv_flow_ws_operations',
' where name != ''BASIC_AUTH''',
'   and ws_id = :P700_WS_ID'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>':P700_WEB_REF_TYPE != ''MANUAL'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'The operation (or method) to be executed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30334907888513462)
,p_name=>'P705_REGION_NAME2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(30032223951154262)
,p_prompt=>'Report Region Title'
,p_source=>'Results'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter a title for the region in which the report will appear.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30335921394517434)
,p_name=>'P705_REGION_TEMPLATE2'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(30032223951154262)
,p_prompt=>'Report Region Template'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(default_reportr_template,default_region_template)',
'  from wwv_flow_themes',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and theme_id          = :FB_THEME_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REGION.TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.d, ',
'       t.r ',
'  from ( select wwv_flow_escape.html(page_plug_template_name) d, ',
'             id r',
'           from wwv_flow_page_plug_templates',
'          where security_group_id = :FLOW_SECURITY_GROUP_ID',
'            and flow_id           = :FB_FLOW_ID',
'            and (:FB_THEME_ID is null or theme_id = :FB_THEME_ID)',
'          order by upper(page_plug_template_name) ) t'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'No Template'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a region template for the report region.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30655522985850543)
,p_name=>'P705_REPORT_TEMPLATE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(30032223951154262)
,p_prompt=>'Report Template'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'    select default_report_template',
'      from wwv_flow_themes',
'     where security_group_id        = :FLOW_SECURITY_GROUP_ID',
'       and flow_id                  = :FB_FLOW_ID',
'       and theme_id                 = :FB_THEME_ID',
'       and default_report_template is not null ) ',
'loop',
'   return c1.default_report_template;',
'end loop;',
'return null;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REPORT.TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME1'')  d,  1 r from sys.dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME2'')  d,  2 r from sys.dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME21'') d, 21 r from sys.dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME22'') d, 22 r from sys.dual union',
'select wwv_flow_lang.system_message(''CONFIRM.TEMPLATE'')||'' ''||theme_id||''. ''||wwv_flow_escape.html(row_template_name) d, id r',
'  from wwv_flow_row_templates ',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID ',
'   and (:FB_THEME_ID is null or theme_id = :FB_THEME_ID)',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Report Template -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a report template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(34476611956117563)
,p_name=>'P705_IS_REST'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(30032223951154262)
,p_prompt=>'Is Rest'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(45239919985460770)
,p_name=>'P705_PAGE_MODE'
,p_item_sequence=>22
,p_item_plug_id=>wwv_flow_imp.id(30032223951154262)
,p_item_default=>'NORMAL'
,p_prompt=>'Page Mode'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DIALOG_PAGE_MODE_CREATE_WIZARD'
,p_lov=>'.'||wwv_flow_imp.id(1497542689968615899)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_user_interface_dev.dialog_page_template_exists(',
'                     p_application_id    => :FB_FLOW_ID ); '))
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Identify the page mode, based on the following options: <p/>',
'<ul>',
'<li><strong>Normal</strong>: The page is presented as a normal &PRODUCT_NAME. application page.</li>',
'<li><strong>Modal Dialog</strong>: The page is presented as a modal dialog. A modal dialog is an overlay window positioned within the viewport, which remains active and focused until the end user dismisses (closes) it. The underlying page is grayed o'
||'ut and the end user is prevented from interacting with the rest of the page until the dialog is closed.</li></ul>',
'<br><p>',
'Note that the Modal Dialog option will only be available for selection where the current application theme contains at least one page template of template type <strong>Dialog Page</strong>.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
,p_attribute_04=>'VERTICAL'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(122074027536962928)
,p_name=>'P705_BREADCRUMB_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(30032223951154262)
,p_item_default=>'0'
,p_prompt=>'Breadcrumb'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION.MENUS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name,',
'       id',
'  from wwv_flow_menus',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- do not use breadcrumbs on page -'
,p_lov_null_value=>'0'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from   wwv_flow_menus',
'where  flow_id = :fb_flow_id',
''))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select whether you want to use a breadcrumb navigation control on your page, and which breadcrumb navigation control you want to use.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(122078712805979341)
,p_name=>'P705_BREADCRUMB_NAME'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(30032223951154262)
,p_prompt=>'Entry Name'
,p_source=>'P705_PAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify the name of the breadcrumb entry.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(381733743271093757)
,p_name=>'P705_BREADCRUMB_PARENT_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(30032223951154262)
,p_prompt=>'Parent Entry'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov_language=>'PLSQL'
,p_lov=>'return wwv_flow_4000_ui.breadcrumb_parent_lov_sql( p_breadcrumb_item_name => ''P705_BREADCRUMB_ID'' )'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'No parent entry'
,p_lov_cascade_parent_items=>'P705_BREADCRUMB_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(404571468475850805)
,p_name=>'P705_GROUP_NAME'
,p_item_sequence=>23
,p_item_plug_id=>wwv_flow_imp.id(30032223951154262)
,p_prompt=>'Page Group'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE GROUP (RETURNS NAME)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d, group_name r ',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'order by upper(group_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Page Group -'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Identify the name of the page group you would like to associate with this page. Page groups help developers manage the pages within an application. To create a page group, enter the name.  To use an existing page group, select the name from the list '
||'of values.',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(30039331483154281)
,p_computation_sequence=>10
,p_computation_item=>'F4000_RUN_EDIT_PAGE'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P705_PAGE_ID'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1941064255539468179)
,p_computation_sequence=>70
,p_computation_item=>'P4716_NAVLIST_ENTRY_NAME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P605_PAGE_NAME'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(193673701123498654)
,p_computation_sequence=>5
,p_computation_item=>'P705_PAGE_NAME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name ',
'  from wwv_flow_shared_web_services ',
' where id = :P700_WS_ID'))
,p_compute_when=>'P705_PAGE_NAME'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(34476814512127753)
,p_computation_sequence=>20
,p_computation_item=>'P705_IS_REST'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'Y'
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_ws_operations',
' where name = ''doREST''',
'   and id   = :P700_OPERATION_ID'))
,p_compute_when_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(165437512151825638)
,p_computation_sequence=>20
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.get_current_theme_id (',
'    p_application_id => :FB_FLOW_ID )'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(193677214283502452)
,p_computation_sequence=>40
,p_computation_item=>'P705_REGION_NAME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_region_title varchar2(4000);',
'begin',
'  l_region_title := :P705_PAGE_NAME;',
'  for c1 in (select name ',
'               from wwv_flow_ws_operations ',
'              where id = :P700_OPERATION_ID ) ',
'  loop',
'    l_region_title := c1.name;',
'  end loop;',
'  return l_region_title;',
'end;'))
,p_compute_when=>'P705_REGION_NAME'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(30039728542154281)
,p_validation_name=>'P705_PAGE_ID positive, whole number'
,p_validation_sequence=>1
,p_validation=>'P705_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>'Page Number must be a positive, whole number.'
,p_when_button_pressed=>wwv_flow_imp.id(30034225253154268)
,p_associated_item=>wwv_flow_imp.id(30036403144154274)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 10-MAR-2001 11:10'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(30040126184154282)
,p_validation_name=>'P705_PAGE_NAME Not Null'
,p_validation_sequence=>2
,p_validation=>'P705_PAGE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Page Title must be specified.'
,p_associated_item=>wwv_flow_imp.id(30037118096154276)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 10-MAR-2001 11:10'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(45240415671462743)
,p_validation_name=>'P705_PAGE_MODE Not Null'
,p_validation_sequence=>3
,p_validation=>'P705_PAGE_MODE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Page Mode must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(30034225253154268)
,p_associated_item=>wwv_flow_imp.id(45239919985460770)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_validation_comment=>'generated 10-MAR-2001 11:10'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(30040907715154287)
,p_validation_name=>'P705_REGION_NAME Not Null'
,p_validation_sequence=>10
,p_validation=>'P705_REGION_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Region Title must be specified.'
,p_associated_item=>wwv_flow_imp.id(30035027504154269)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(404571964497851948)
,p_validation_name=>'Validate Group Name'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_utilities.is_valid_page_group_name (',
'  p_name => :P705_GROUP_NAME);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P705_GROUP_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(30034225253154268)
,p_associated_item=>wwv_flow_imp.id(404571468475850805)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(381734802587099972)
,p_name=>'Breadcrumb options'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P705_BREADCRUMB_ID'
,p_condition_element=>'P705_BREADCRUMB_ID'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(381735166854099973)
,p_event_id=>wwv_flow_imp.id(381734802587099972)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P705_BREADCRUMB_PARENT_ID,P705_BREADCRUMB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(381735363212099973)
,p_event_id=>wwv_flow_imp.id(381734802587099972)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P705_BREADCRUMB_PARENT_ID,P705_BREADCRUMB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(549718159643753342)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(30033822808154267)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(549718222051753343)
,p_event_id=>wwv_flow_imp.id(549718159643753342)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1941069532605508096)
,p_name=>'set region name'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P705_PAGE_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1941069943048508096)
,p_event_id=>wwv_flow_imp.id(1941069532605508096)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P705_REGION_NAME'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P705_PAGE_NAME'
,p_attribute_07=>'P705_PAGE_NAME'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1941070401268508097)
,p_event_id=>wwv_flow_imp.id(1941069532605508096)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P705_BREADCRUMB_NAME'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P705_PAGE_NAME'
,p_attribute_07=>'P705_PAGE_NAME'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
end;
/
prompt --application/pages/page_00707
begin
wwv_flow_imp_page.create_page(
 p_id=>707
,p_name=>'Template Utilization - References'
,p_alias=>'TEMPLATE-UTILIZATION-REFERENCES'
,p_step_title=>'Template Utilization - References'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(3405738497955649)
,p_name=>'Template Component References'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>110
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select p.builder_name                                         as template_name,',
'       p.id                                                   as template_id,',
'       pg.name                                                as page_name,',
'       r.plug_name                                            as region,',
'       r.page_id                                              as page,',
'       wwv_flow_lang.system_message(''F4000.REGION'')         as object_type,',
'       to_char(null)                                          as object_name',
'  from wwv_flow_template_components    p,',
'       wwv_flow_page_plugs           r,',
'       wwv_flow_steps                pg',
' where p.flow_id            = to_number(:FB_FLOW_ID)',
'   and p.security_group_id  = to_number(:WORKSPACE_ID)',
'   and p.theme_id           is not null',
'   and r.flow_id            = p.flow_id',
'   and r.security_group_id  = p.security_group_id',
'   and r.plug_source_type   = p.used_name',
'   and pg.flow_id           = r.flow_id',
'   and pg.id                = r.page_id',
'   and pg.security_group_id = r.security_group_id',
'   and (    :P707_FIND                                  is null ',
'         or instr(upper(r.plug_name),upper(:P707_FIND)) > 0',
'         or instr(r.page_id,:P707_FIND)                 > 0 )',
'union all',
'select p.builder_name                                         as template_name,',
'       p.id                                                   as template_id,',
'       pg.name                                                as page_name,',
'       r.plug_name                                            as region,',
'       c.page_id                                              as page,',
'       wwv_flow_lang.system_message(''F4000.REPORT_COLUMN'')    as object_type,',
'       c.db_column_name                                       as object_name',
'  from wwv_flow_template_components  p,',
'       wwv_flow_worksheet_columns    c,',
'       wwv_flow_worksheets           w,',
'       wwv_flow_page_plugs           r,',
'       wwv_flow_steps                pg',
' where p.flow_id            = to_number(:FB_FLOW_ID)',
'   and p.security_group_id  = to_number(:WORKSPACE_ID)',
'   and p.theme_id           is not null',
'   and c.flow_id            = p.flow_id',
'   and c.security_group_id  = p.security_group_id',
'   and c.display_text_as    = p.used_name',
'   and w.id                 = c.worksheet_id',
'   and w.flow_id            = p.flow_id',
'   and w.security_group_id  = p.security_group_id',
'   and r.id                 = w.region_id',
'   and r.flow_id            = p.flow_id',
'   and r.security_group_id  = p.security_group_id',
'   and pg.flow_id           = r.flow_id',
'   and pg.id                = r.page_id',
'   and pg.security_group_id = r.security_group_id',
'   and (    :P707_FIND                                  is null ',
'         or instr(upper(r.plug_name),upper(:P707_FIND)) > 0',
'         or instr(r.page_id,:P707_FIND)                 > 0 )'))
,p_display_when_condition=>'P707_TEMPLATE_TYPE'
,p_display_when_cond2=>'TEMPLATE_COMPONENT'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1:2:3'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_item=>'P707_ROWS'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3405822293955650)
,p_query_column_id=>1
,p_column_alias=>'TEMPLATE_NAME'
,p_column_display_sequence=>10
,p_column_heading=>'Template Name'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7472288579849704)
,p_query_column_id=>2
,p_column_alias=>'TEMPLATE_ID'
,p_column_display_sequence=>50
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7472051985849702)
,p_query_column_id=>3
,p_column_alias=>'PAGE_NAME'
,p_column_display_sequence=>30
,p_column_heading=>'Page Name'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7472181388849703)
,p_query_column_id=>4
,p_column_alias=>'REGION'
,p_column_display_sequence=>40
,p_column_heading=>'Region'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7471900502849601)
,p_query_column_id=>5
,p_column_alias=>'PAGE'
,p_column_display_sequence=>20
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID:&FB_FLOW_ID.,#PAGE#'
,p_column_linktext=>'#PAGE#'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7472391003849705)
,p_query_column_id=>6
,p_column_alias=>'OBJECT_TYPE'
,p_column_display_sequence=>60
,p_column_heading=>'Object Type'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7472416589849706)
,p_query_column_id=>7
,p_column_alias=>'OBJECT_NAME'
,p_column_display_sequence=>70
,p_column_heading=>'Object Name'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(90376501110749469)
,p_plug_name=>'Filter References'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(90376720437749469)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>5
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(12437772301)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Templates'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(90441604076983253)
,p_name=>'Page Template References'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name,',
'       id,',
'       page_template,',
'       page_type',
'  from (select p.name,',
'               p.id,',
'               (select name',
'                  from wwv_flow_templates',
'                 where id                = p.step_template',
'                   and flow_id           = :FB_FLOW_ID',
'                   and security_group_id = :FLOW_SECURITY_GROUP_ID) page_template,',
'               p.page_type',
'          from wwv_flow_pages_dev p',
'         where step_template     = :P707_TEMPLATE',
'           and flow_id           = :FB_FLOW_ID',
'           and security_group_id = :FLOW_SECURITY_GROUP_ID) x',
' where :P707_FIND is null',
'    or instr(upper(name),upper(:P707_FIND)) > 0',
'    or instr(upper(page_type),upper(:P707_FIND)) > 0',
'    or instr(id,:P707_FIND) > 0'))
,p_display_when_condition=>'P707_TEMPLATE_TYPE'
,p_display_when_cond2=>'PAGE'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'1'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_item=>'P707_ROWS'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(90441806080983279)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Page Name'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(90441909976983280)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.:4500:FB_FLOW_PAGE_ID,FB_FLOW_ID:#ID#,&FB_FLOW_ID.'
,p_column_linktext=>'#ID#'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(90442022844983280)
,p_query_column_id=>3
,p_column_alias=>'PAGE_TEMPLATE'
,p_column_display_sequence=>1
,p_column_heading=>'Template'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(90442109937983280)
,p_query_column_id=>4
,p_column_alias=>'PAGE_TYPE'
,p_column_display_sequence=>4
,p_column_heading=>'Page Type'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(5402514727348886)
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(90453125987046347)
,p_name=>'Item Label Template References'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select application, item_name, page_name, page_number, template, id',
'from (',
'select f.flow_id application, ',
'       i.name item_name, ',
'       (select name from wwv_flow_steps where id = i.flow_step_id and flow_id = i.flow_id) page_name,',
'       i.flow_step_id page_number,',
'       f.template_name template, ',
'       f.id',
'from wwv_flow_field_templates f,',
'     wwv_flow_step_items i',
'where',
'i.ITEM_FIELD_TEMPLATE = f.id and',
'i.flow_id = :fb_flow_id and',
'f.flow_id = :fb_flow_id and ',
'f.id = :P707_TEMPLATE and',
':P707_TEMPLATE_TYPE = ''LABEL'' and',
'f.security_group_id = :flow_security_group_id',
') x',
'where',
'(',
':P707_FIND is null or ',
'instr(upper(item_name),upper(:P707_FIND)) > 0 or',
'instr(upper(page_name),upper(:P707_FIND)) > 0 or',
'instr(page_number,:P707_FIND) > 0',
')'))
,p_display_when_condition=>'P707_TEMPLATE_TYPE'
,p_display_when_cond2=>'LABEL'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1:2:3'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_item=>'P707_ROWS'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>500000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(90465624274197175)
,p_query_column_id=>1
,p_column_alias=>'APPLICATION'
,p_column_display_sequence=>5
,p_column_heading=>'Application'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(90467014147213197)
,p_query_column_id=>2
,p_column_alias=>'ITEM_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Item Name'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(90465703320197175)
,p_query_column_id=>3
,p_column_alias=>'PAGE_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Page Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(90467101582213197)
,p_query_column_id=>4
,p_column_alias=>'PAGE_NUMBER'
,p_column_display_sequence=>2
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID:&FB_FLOW_ID.,#PAGE_NUMBER#'
,p_column_linktext=>'#PAGE_NUMBER#'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(90465800472197175)
,p_query_column_id=>5
,p_column_alias=>'TEMPLATE'
,p_column_display_sequence=>1
,p_column_heading=>'Template'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(90453508996046350)
,p_query_column_id=>6
,p_column_alias=>'ID'
,p_column_display_sequence=>6
,p_column_heading=>'ID'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(90472917919261593)
,p_name=>'List Template References'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select application_id, template_name, id, region_name, page_id, list_name, list_id, referenced_from',
'from ',
'(',
'select ',
'  l.flow_id application_id,',
'  l.list_template_name template_name,',
'  l.id,',
'  p.plug_name region_name,',
'  p.page_id page_id,',
'  null list_name,',
'  null list_id,',
'  m.m referenced_from',
'from ',
'  wwv_flow_list_templates l,',
'  wwv_flow_page_plugs p,',
' (select wwv_flow_lang.system_message(''REGIONS_LIST_TEMPLATE_OVERRIDE'') m from sys.dual) m',
'where ',
'  l.flow_id = :fb_flow_id and',
'  p.list_template_id = l.id and',
'  l.id = :p707_TEMPLATE and',
'  l.security_group_id = :flow_security_group_id',
') x',
'where',
'(',
':P707_FIND is null or ',
'instr(upper(region_name),upper(:P707_FIND)) > 0 or',
'instr(upper(list_name),upper(:P707_FIND)) > 0 or',
'instr(page_id,:P707_FIND) > 0',
')'))
,p_display_when_condition=>'P707_TEMPLATE_TYPE'
,p_display_when_cond2=>'LIST'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_header=>'<div class="padding-md">This report lists all lists that reference the selected template, as well as any page region which overrides the default list template.</div>'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'1:2:3'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_item=>'P707_ROWS'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>500000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(90485614334326770)
,p_query_column_id=>1
,p_column_alias=>'APPLICATION_ID'
,p_column_display_sequence=>7
,p_column_heading=>'Application'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(90485718736326770)
,p_query_column_id=>2
,p_column_alias=>'TEMPLATE_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Template Name'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(90473309495261594)
,p_query_column_id=>3
,p_column_alias=>'ID'
,p_column_display_sequence=>5
,p_column_heading=>'ID'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(90485807028326770)
,p_query_column_id=>4
,p_column_alias=>'REGION_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Region Name'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(90473532243261594)
,p_query_column_id=>5
,p_column_alias=>'PAGE_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID,FB_FLOW_ID:#PAGE_ID#,&FB_FLOW_ID.'
,p_column_linktext=>'#PAGE_ID#'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(90485915183326770)
,p_query_column_id=>6
,p_column_alias=>'LIST_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'List Name'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:4050:&SESSION.::&DEBUG.:4050:F4000_P4050_LIST_ID,FB_FLOW_ID:#LIST_ID#,&FB_FLOW_ID.'
,p_column_linktext=>'#LIST_NAME#'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(90487309963334953)
,p_query_column_id=>7
,p_column_alias=>'LIST_ID'
,p_column_display_sequence=>6
,p_column_heading=>'List'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(95257919193879204)
,p_query_column_id=>8
,p_column_alias=>'REFERENCED_FROM'
,p_column_display_sequence=>8
,p_column_heading=>'Referenced From'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(90524226735850736)
,p_name=>'Popup List of Values References'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>60
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  id,',
'  flow_id,',
'  wwv_flow_lang.system_message_lit(''F4000.P371.POPUP_LOV'') template_name',
' from WWV_FLOW_POPUP_LOV_TEMPLATE',
'where flow_id = :fb_flow_id and',
'security_group_id = :flow_security_group_id'))
,p_display_when_condition=>'P707_TEMPLATE_TYPE'
,p_display_when_cond2=>'POPUP_LOV'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_header=>'<p>Only one Popup List of Values template is available per application.</p>'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_item=>'P707_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(90527503579872357)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>3
,p_column_heading=>'ID'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(90526213491865754)
,p_query_column_id=>2
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Application'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(90526302991865754)
,p_query_column_id=>3
,p_column_alias=>'TEMPLATE_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Template'
,p_use_as_row_header=>'Y'
,p_column_link=>'f?p=&APP_ID.:251:&SESSION.::&DEBUG.:251:F4000_P251_ID,FB_FLOW_ID:#ID#,&FB_FLOW_ID.'
,p_column_linktext=>'#TEMPLATE_NAME#'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(90759007520249810)
,p_name=>'Calendar Template References'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>70
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
't.name,',
'r.plug_name      region_name,',
'r.page_id        page,',
'(select name from wwv_flow_steps where id = r.page_id and flow_id = r.flow_id) page_name',
'from wwv_flow_cal_templates t,',
'     WWV_FLOW_CALS c,',
'     wwv_flow_page_plugs r',
'where c.flow_id = :fb_flow_id and',
'c.plug_id = r.id and',
't.id = c.template_id and',
't.flow_id = :fb_flow_id and',
't.security_group_id = :flow_security_group_id and',
'(',
':P707_FIND is null or ',
'instr(upper(r.plug_name),upper(:P707_FIND)) > 0 or',
'instr(r.page_id,:P707_FIND) > 0',
')'))
,p_display_when_condition=>'P707_TEMPLATE_TYPE'
,p_display_when_cond2=>'CALENDAR'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1:2:3'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_item=>'P707_ROWS'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>10000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(90759306130249813)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Template'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(90760820680253613)
,p_query_column_id=>2
,p_column_alias=>'REGION_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Region'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(90759512274249814)
,p_query_column_id=>3
,p_column_alias=>'PAGE'
,p_column_display_sequence=>2
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID:&FB_FLOW_ID.,#PAGE#'
,p_column_linktext=>'#PAGE#'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(96139722167482459)
,p_query_column_id=>4
,p_column_alias=>'PAGE_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Page Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(90773716749318655)
,p_name=>'Breadcrumb Template References'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>80
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    t.name template_name,',
'    r.page_id page,',
'    r.plug_name region',
'from wwv_flow_menu_templates t,',
'     wwv_flow_page_plugs r',
'where t.flow_id = :fb_flow_id and',
'      r.menu_template_id = t.id and',
'      t.id = :P707_TEMPLATE and',
'      t.security_group_id = :flow_security_group_id and',
'(',
':P707_FIND is null or ',
'instr(upper(r.plug_name),upper(:P707_FIND)) > 0 or',
'instr(r.page_id,:P707_FIND) > 0',
')'))
,p_display_when_condition=>'P707_TEMPLATE_TYPE'
,p_display_when_cond2=>'MENU'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1:2'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_item=>'P707_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(90774021380318657)
,p_query_column_id=>1
,p_column_alias=>'TEMPLATE_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Template Name'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(90774122764318657)
,p_query_column_id=>2
,p_column_alias=>'PAGE'
,p_column_display_sequence=>2
,p_column_heading=>'Page'
,p_use_as_row_header=>'Y'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID:&FB_FLOW_ID.,#PAGE#'
,p_column_linktext=>'#PAGE#'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(90774212598318657)
,p_query_column_id=>3
,p_column_alias=>'REGION'
,p_column_display_sequence=>3
,p_column_heading=>'Region'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(92057426200364488)
,p_name=>'Button Template References'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>90
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select template_name, template_id, button_name, button_label, region, page',
'from',
'(',
'select ',
'  t.TEMPLATE_NAME template_name,',
'  t.id            template_id,',
'  b.BUTTON_NAME   button_name,',
'  b.button_image_alt button_label,',
'  r.plug_name     region,',
'  r.page_id       page',
'from wwv_flow_button_templates t,',
'     wwv_flow_step_buttons b,',
'     wwv_flow_page_plugs r',
'where ',
'button_template_id = t.id and',
'r.flow_id = :fb_flow_id and',
'b.flow_id = :fb_flow_id and',
't.flow_id = :fb_flow_id and',
'b.BUTTON_PLUG_ID = r.id and',
't.id = :P707_TEMPLATE and',
't.security_group_id = :flow_security_group_id',
') x',
'where',
'(',
':P707_FIND is null or ',
'instr(upper(button_name),upper(:P707_FIND)) > 0 or',
'instr(upper(button_label),upper(:P707_FIND)) > 0 or',
'instr(upper(region),upper(:P707_FIND)) > 0 or',
'instr(page,:P707_FIND) > 0',
')'))
,p_display_when_condition=>'P707_TEMPLATE_TYPE'
,p_display_when_cond2=>'BUTTON'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1:2:3'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_item=>'P707_ROWS'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(92057604806364490)
,p_query_column_id=>1
,p_column_alias=>'TEMPLATE_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Template Name'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(92058305468386886)
,p_query_column_id=>2
,p_column_alias=>'TEMPLATE_ID'
,p_column_display_sequence=>4
,p_column_heading=>'Template ID'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(92058422034386886)
,p_query_column_id=>3
,p_column_alias=>'BUTTON_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Button Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(92063018675419028)
,p_query_column_id=>4
,p_column_alias=>'BUTTON_LABEL'
,p_column_display_sequence=>6
,p_column_heading=>'Button Label'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(92057831051364491)
,p_query_column_id=>5
,p_column_alias=>'REGION'
,p_column_display_sequence=>3
,p_column_heading=>'Region'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(92057714956364491)
,p_query_column_id=>6
,p_column_alias=>'PAGE'
,p_column_display_sequence=>2
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID:&FB_FLOW_ID.,#PAGE#'
,p_column_linktext=>'#PAGE#'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(92065626425430729)
,p_name=>'Report Template References'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>100
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.ROW_TEMPLATE_NAME template_name,',
'       t.id            template_id,',
'       (select name from wwv_flow_steps ',
'         where id      = r.page_id',
'           and flow_id = r.flow_id) page_name,',
'       r.plug_name     region,',
'       r.page_id       page',
'  from WWV_FLOW_ROW_TEMPLATES t,',
'       wwv_flow_page_plugs r',
' where r.flow_id                 = :fb_flow_id',
'   and t.flow_id                 = :fb_flow_id',
'   and r.PLUG_QUERY_ROW_TEMPLATE = t.id',
'   and t.id                      = :P707_TEMPLATE',
'   and r.plug_source_type        in ( ''NATIVE_SQL_REPORT'',',
'                                      ''NATIVE_TABFORM'' )',
'   and t.security_group_id       = :flow_security_group_id',
'   and (    :P707_FIND                                  is null ',
'         or instr(upper(r.plug_name),upper(:P707_FIND)) > 0',
'         or instr(r.page_id,:P707_FIND)                 > 0 )'))
,p_display_when_condition=>'P707_TEMPLATE_TYPE'
,p_display_when_cond2=>'REPORT'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1:2:3'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_item=>'P707_ROWS'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(92066026416430729)
,p_query_column_id=>1
,p_column_alias=>'TEMPLATE_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Template Name'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(92065900788430729)
,p_query_column_id=>2
,p_column_alias=>'TEMPLATE_ID'
,p_column_display_sequence=>5
,p_column_heading=>'Template ID'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(96137417880471754)
,p_query_column_id=>3
,p_column_alias=>'PAGE_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Page Name'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(92066216103430729)
,p_query_column_id=>4
,p_column_alias=>'REGION'
,p_column_display_sequence=>4
,p_column_heading=>'Region'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(92066119673430729)
,p_query_column_id=>5
,p_column_alias=>'PAGE'
,p_column_display_sequence=>2
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID:&FB_FLOW_ID.,#PAGE#'
,p_column_linktext=>'#PAGE#'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(468075709995571377)
,p_name=>'Region Template References'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select (select max(PAGE_PLUG_TEMPLATE_NAME) x ',
'          from WWV_FLOW_PAGE_PLUG_TEMPLATES ',
'         where id = :P707_TEMPLATE) template_name,',
'       page_id p,',
'       (select name from wwv_flow_steps ',
'         where id = p.page_id and flow_id = p.flow_id) page_name,',
'       p.plug_name,',
'       p.flow_id',
'from   wwv_flow_page_plugs p',
'where  p.flow_id = :FB_FLOW_ID and ',
'       p.plug_template = :P707_TEMPLATE and',
'       p.security_group_id = :flow_security_group_id and',
'(',
':P707_FIND is null or ',
'instr(upper(p.plug_name),upper(:P707_FIND)) > 0 or',
'instr(page_id,:P707_FIND) > 0',
')'))
,p_display_when_condition=>'P707_TEMPLATE_TYPE'
,p_display_when_cond2=>'REGION'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>20
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'1:2:3'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_item=>'P707_ROWS'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(468076031026571380)
,p_query_column_id=>1
,p_column_alias=>'TEMPLATE_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Template'
,p_use_as_row_header=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(468076101280571590)
,p_query_column_id=>2
,p_column_alias=>'P'
,p_column_display_sequence=>2
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(468076226292571590)
,p_query_column_id=>3
,p_column_alias=>'PAGE_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Page Name'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(468076316488571590)
,p_query_column_id=>4
,p_column_alias=>'PLUG_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Region Name'
,p_use_as_row_header=>'Y'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(468076429662571590)
,p_query_column_id=>5
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>5
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(90378613017749475)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(90376501110749469)
,p_button_name=>'P707_GO'
,p_button_static_id=>'P707_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Go'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(90379121871749478)
,p_branch_action=>'f?p=&APP_ID.:707:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(90377625336749473)
,p_name=>'P707_TEMPLATE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(90376501110749469)
,p_prompt=>'Template:'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(90378115026749474)
,p_name=>'P707_ROWS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(90376501110749469)
,p_item_default=>'20'
,p_prompt=>'Rows'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAXIMUM ROWS PER PAGE'
,p_lov=>'.'||wwv_flow_imp.id(84800803131139158)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'U'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the number of items to display and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(90390006950766464)
,p_name=>'P707_TEMPLATE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(90376501110749469)
,p_prompt=>'Type:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'TEMPLATE.TYPES.ALL'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  wwv_flow_lang.system_message_lit(''F4000.PAGE'') d,''PAGE'' r from sys.dual',
'union all',
'select wwv_flow_lang.system_message_lit(''F4000.REGION'') d,''REGION'' r from sys.dual',
'union all',
'select wwv_flow_lang.system_message_lit(''LABEL'') d,''LABEL'' r from sys.dual',
'union all',
'select wwv_flow_lang.system_message_lit(''F4000.LIST_INITCAP'') d, ''LIST'' r from sys.dual',
'union all',
'select wwv_flow_lang.system_message_lit(''F4000.P371.POPUP_LOV'') d, ''POPUP_LOV'' r from sys.dual',
'union all',
'select wwv_flow_lang.system_message_lit(''LEGACY_CALENDAR'') d,''CALENDAR'' r from sys.dual',
'union all',
'select wwv_flow_lang.system_message_lit(''BREADCRUMB'') d,''MENU'' r from sys.dual',
'union all',
'select wwv_flow_lang.system_message_lit(''F4000.BUTTON'') d, ''BUTTON'' r from sys.dual',
'union all',
'select wwv_flow_lang.system_message_lit(''REPORT'') d, ''REPORT'' r from sys.dual',
'union all',
'select wwv_flow_lang.system_message_lit(''F4000.TEMPLATE_COMPONENT'') d, ''TEMPLATE_COMPONENT'' r from sys.dual'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'The type of template being displayed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(95927128271424531)
,p_name=>'P707_FIND'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(90376501110749469)
,p_prompt=>'Find'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter case insensitive query criteria and press <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(90378827079749477)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when_button_id=>wwv_flow_imp.id(90378613017749475)
,p_internal_uid=>90378827079749477
);
end;
/
prompt --application/pages/page_00708
begin
wwv_flow_imp_page.create_page(
 p_id=>708
,p_name=>'Replace Templates - Template Type'
,p_alias=>'REPLACE-TEMPLATES-TEMPLATE-TYPE'
,p_step_title=>'Replace Templates - Template Type'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt_view.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(90718104576082094)
,p_plug_name=>'Replace Templates'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_header=>'<p>This wizard enables you to update components that use one template with another template.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(168736217450381660)
,p_plug_name=>'replace templates train'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(168734227577365586)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(208129411943230093)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747144813989138169)
,p_plug_name=>'Replace Templates'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(90718529173082095)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(208129411943230093)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(90718803405082095)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(208129411943230093)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(90719227955082095)
,p_branch_action=>'f?p=&APP_ID.:711:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(90718803405082095)
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(90718420143082094)
,p_name=>'P708_TEMPLATE_TYPE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(90718104576082094)
,p_item_default=>'PAGE'
,p_prompt=>'Template Type:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TEMPLATE TYPES PAGE 708'
,p_lov=>'.'||wwv_flow_imp.id(168736405114387476)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the template type to be replaced.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
end;
/
prompt --application/pages/page_00711
begin
wwv_flow_imp_page.create_page(
 p_id=>711
,p_name=>'Replace Templates - Identify Templates'
,p_alias=>'REPLACE-TEMPLATES-IDENTIFY-TEMPLATES'
,p_step_title=>'Replace Templates - Identify Templates'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt_view.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(90719716967082096)
,p_plug_name=>'Replace Templates'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_header=>'<p>Identify the template you want to replace and the template you want to change to.  All template references for the selected template will be changed.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(168736011909379998)
,p_plug_name=>'replace templates train'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(168734227577365586)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(207429407218112199)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747144983803138169)
,p_plug_name=>'Replace Templates'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(90720129974082096)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(207429407218112199)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(90720418917082096)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(207429407218112199)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(90720308023082096)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(207429407218112199)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(90721124694082097)
,p_branch_action=>'f?p=&APP_ID.:713:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(90720418917082096)
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(90720825458082096)
,p_branch_action=>'f?p=&APP_ID.:708:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(90720308023082096)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(90720031816082096)
,p_name=>'P711_TEMPLATE_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(90719716967082096)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Template Type:'
,p_source=>'P708_TEMPLATE_TYPE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'TEMPLATE.TYPES.ALL'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  wwv_flow_lang.system_message_lit(''F4000.PAGE'') d,''PAGE'' r from sys.dual',
'union all',
'select wwv_flow_lang.system_message_lit(''F4000.REGION'') d,''REGION'' r from sys.dual',
'union all',
'select wwv_flow_lang.system_message_lit(''LABEL'') d,''LABEL'' r from sys.dual',
'union all',
'select wwv_flow_lang.system_message_lit(''F4000.LIST_INITCAP'') d, ''LIST'' r from sys.dual',
'union all',
'select wwv_flow_lang.system_message_lit(''F4000.P371.POPUP_LOV'') d, ''POPUP_LOV'' r from sys.dual',
'union all',
'select wwv_flow_lang.system_message_lit(''LEGACY_CALENDAR'') d,''CALENDAR'' r from sys.dual',
'union all',
'select wwv_flow_lang.system_message_lit(''BREADCRUMB'') d,''MENU'' r from sys.dual',
'union all',
'select wwv_flow_lang.system_message_lit(''F4000.BUTTON'') d, ''BUTTON'' r from sys.dual',
'union all',
'select wwv_flow_lang.system_message_lit(''REPORT'') d, ''REPORT'' r from sys.dual',
'union all',
'select wwv_flow_lang.system_message_lit(''F4000.TEMPLATE_COMPONENT'') d, ''TEMPLATE_COMPONENT'' r from sys.dual'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identifies the template type to be replaced.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(94008314352843268)
,p_name=>'P711_CONSOLIDATE_FROM'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(90719716967082096)
,p_prompt=>'Change From'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CONSOLIDATE_TEMPLATE_NAMES RETURNING ID'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select page_plug_template_name d, id',
'from wwv_flow_page_plug_templates',
'where flow_id = :FB_FLOW_ID and ',
'THEME_ID = (select theme_id from wwv_flows where id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''REGION''',
'union all',
'select name d, id ',
'from WWV_FLOW_TEMPLATES ',
'where flow_id = :FB_FLOW_ID and ',
'THEME_ID = (select theme_id from wwv_flows where id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''PAGE''',
'union all',
'select template_name d, id',
'from wwv_flow_field_templates f',
'where ',
'f.flow_id = :FB_FLOW_ID and ',
'THEME_ID = (select theme_id from wwv_flows where id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''LABEL''',
'union all',
'select ',
'l.list_template_name d, l.id',
'from ',
'wwv_flow_list_templates l',
'where ',
'l.flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flows where id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''LIST''',
'union all',
'select name d, id',
'from wwv_flow_cal_templates',
'where flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flows where id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''CALENDAR''',
'union all',
'select name d, id',
'from wwv_flow_menu_templates',
'where flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flows where id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''MENU''',
'union all',
'select template_name d, id',
'from WWV_FLOW_BUTTON_TEMPLATES',
'where flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flows where id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''BUTTON''',
'union all',
'select ''* ''||wwv_flow_lang.system_message(''HTML_BUTTON'') d, -1 id',
'from dual',
'where :P708_TEMPLATE_TYPE = ''BUTTON''',
'union all',
'select ROW_TEMPLATE_NAME d, id',
'from WWV_FLOW_ROW_TEMPLATES',
'where flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flows where id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''REPORT''',
'union all',
'select ''* ''||wwv_flow_lang.system_message(''REGION_TEMPLATES_NO_TEMPLATE'') d, -1 id',
'from dual',
'where :P708_TEMPLATE_TYPE in (''PAGE'',''REGION'')'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Template -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the template to be replaced.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(94009809981851445)
,p_name=>'P711_CONSOLIDATE_TO'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(90719716967082096)
,p_prompt=>'Change To'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CONSOLIDATE_TEMPLATE_NAMES RETURNING ID'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select page_plug_template_name d, id',
'from wwv_flow_page_plug_templates',
'where flow_id = :FB_FLOW_ID and ',
'THEME_ID = (select theme_id from wwv_flows where id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''REGION''',
'union all',
'select name d, id ',
'from WWV_FLOW_TEMPLATES ',
'where flow_id = :FB_FLOW_ID and ',
'THEME_ID = (select theme_id from wwv_flows where id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''PAGE''',
'union all',
'select template_name d, id',
'from wwv_flow_field_templates f',
'where ',
'f.flow_id = :FB_FLOW_ID and ',
'THEME_ID = (select theme_id from wwv_flows where id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''LABEL''',
'union all',
'select ',
'l.list_template_name d, l.id',
'from ',
'wwv_flow_list_templates l',
'where ',
'l.flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flows where id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''LIST''',
'union all',
'select name d, id',
'from wwv_flow_cal_templates',
'where flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flows where id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''CALENDAR''',
'union all',
'select name d, id',
'from wwv_flow_menu_templates',
'where flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flows where id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''MENU''',
'union all',
'select template_name d, id',
'from WWV_FLOW_BUTTON_TEMPLATES',
'where flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flows where id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''BUTTON''',
'union all',
'select ''* ''||wwv_flow_lang.system_message(''HTML_BUTTON'') d, -1 id',
'from dual',
'where :P708_TEMPLATE_TYPE = ''BUTTON''',
'union all',
'select ROW_TEMPLATE_NAME d, id',
'from WWV_FLOW_ROW_TEMPLATES',
'where flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flows where id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''REPORT''',
'union all',
'select ''* ''||wwv_flow_lang.system_message(''REGION_TEMPLATES_NO_TEMPLATE'') d, -1 id',
'from dual',
'where :P708_TEMPLATE_TYPE in (''PAGE'',''REGION'')'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Template -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the new template that will replace all occurrences of the selected template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(96738921415545316)
,p_validation_name=>'P711_CONSOLIDATE_FROM Not Null'
,p_validation_sequence=>1
,p_validation=>'P711_CONSOLIDATE_FROM'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'#LABEL# must be specified.'
,p_associated_item=>wwv_flow_imp.id(94008314352843268)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 06-NOV-2007 12:13'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(96739129733545322)
,p_validation_name=>'P711_CONSOLIDATE_TO Not Null'
,p_validation_sequence=>2
,p_validation=>'P711_CONSOLIDATE_TO'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'#LABEL# must be specified.'
,p_associated_item=>wwv_flow_imp.id(94009809981851445)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 06-NOV-2007 12:13'
);
end;
/
prompt --application/pages/page_00712
begin
wwv_flow_imp_page.create_page(
 p_id=>712
,p_name=>'Manage Orphaned List Entries'
,p_alias=>'MANAGE-ORPHANED-LIST-ENTRIES'
,p_step_title=>'Manage Orphaned List Entries'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_list.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(40749510927686102)
,p_name=>'List Entries'
,p_template=>wwv_flow_imp.id(208928010704475743)
,p_display_sequence=>100
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c, list_item_link_text, id, list_item_display_sequence, list_item_type, list_item_link_target, parent_list_item_id, last_updated_on, orphaned',
'from (',
'select',
'    htmldb_item.checkbox(1,id,''title="''||wwv_flow_lang.system_message(''F4000.P712.CLEAR_PARENT_ENTRY'')||'' ''||wwv_flow_escape.html(list_item_link_text)||''"'') c,',
'    list_item_link_text,  ',
'    id, ',
'    list_item_display_sequence, ',
'    list_item_type, ',
'    substr(list_item_link_target,1,50) list_item_link_target, ',
'    decode(parent_list_item_id,null,null,',
'    nvl((select list_item_link_text from wwv_flow_list_items where id = l.parent_list_item_id and list_id = l.list_id),parent_list_item_id)) parent_list_item_id,',
'    last_updated_on,',
'    decode(parent_list_item_id,null,''N'',decode((select count(*) o from wwv_flow_list_items where id = l.parent_list_item_id and list_id = l.list_id),0,''Y'',''N'')) Orphaned',
'  from   ',
'    wwv_flow_list_items l',
'  where  ',
'    list_id = to_number(replace(:P712_LIST_ID,''%''||''null%'',null)) and',
'    flow_id = :fb_flow_id and',
'    security_group_id = :flow_security_group_id)',
'x',
'where (nvl(:P712_SHOW,''O'') = ''O'' and orphaned = ''Y'') or (nvl(:P712_SHOW,''O'') =''A'')'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>50000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No list entries found'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(40895523205626283)
,p_query_column_id=>1
,p_column_alias=>'C'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(40749823708686105)
,p_query_column_id=>2
,p_column_alias=>'LIST_ITEM_LINK_TEXT'
,p_column_display_sequence=>3
,p_column_heading=>'Label'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(40749926611686105)
,p_query_column_id=>3
,p_column_alias=>'ID'
,p_column_display_sequence=>4
,p_column_heading=>'ID'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(40750025198686105)
,p_query_column_id=>4
,p_column_alias=>'LIST_ITEM_DISPLAY_SEQUENCE'
,p_column_display_sequence=>2
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(40750104670686105)
,p_query_column_id=>5
,p_column_alias=>'LIST_ITEM_TYPE'
,p_column_display_sequence=>5
,p_column_heading=>'List Item Type'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(40750217868686105)
,p_query_column_id=>6
,p_column_alias=>'LIST_ITEM_LINK_TARGET'
,p_column_display_sequence=>6
,p_column_heading=>'Target'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(40750315965686105)
,p_query_column_id=>7
,p_column_alias=>'PARENT_LIST_ITEM_ID'
,p_column_display_sequence=>7
,p_column_heading=>'Parent'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(40750627017686105)
,p_query_column_id=>8
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>8
,p_column_heading=>'Updated'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(40785926388106819)
,p_query_column_id=>9
,p_column_alias=>'ORPHANED'
,p_column_display_sequence=>9
,p_column_heading=>'Orphaned'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(84259319526460470)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(40755202185702453)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>92
,p_translate_title=>'N'
,p_plug_query_num_rows=>1500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_row_count_max=>5000
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_col_allignments=>'R:R:L:L:L:R'
,p_plug_query_sum_cols=>'NO:NO:NO:NO:NO:YES'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'generated 16-FEB-2000 23:59:43'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(40977612787446310)
,p_plug_name=>'Orphaned List Entries'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>An orphaned list entry is a list entry which has a parent, but the parent is no longer a member of the current list.  This is an uncommon situation but if a list entry does become orphaned, use this page to clear the parent from the entry.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(40756527128702454)
,p_button_sequence=>89
,p_button_plug_id=>wwv_flow_imp.id(40755202185702453)
,p_button_name=>'P712_GO'
,p_button_static_id=>'P712_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Go'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(40896605329630583)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(40755202185702453)
,p_button_name=>'UNPARENT_CHECKED'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Clear Parent Entry'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(40897308792631543)
,p_branch_action=>'f?p=&APP_ID.:712:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40755521107702453)
,p_name=>'P712_LIST_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(40755202185702453)
,p_item_default=>'0'
,p_prompt=>'List:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id',
'from wwv_flow_lists',
'where flow_id = :FB_FLOW_ID',
'order by upper(name)'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the selected list.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40964611645313579)
,p_name=>'P712_SHOW'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_imp.id(40755202185702453)
,p_item_default=>'O'
,p_prompt=>'Show'
,p_source=>'O'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ORPHANED_LISTS_DISPLAY'
,p_lov=>'.'||wwv_flow_imp.id(94838211998345101)||'.'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Show all list entries or show only orphaned list entries.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(40898220220634868)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'unparent checked'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count loop',
'   update wwv_flow_list_items ',
'   set parent_list_item_id = null',
'   where list_id = :P712_LIST_ID and ',
'         id = to_number(wwv_flow.g_f01(i)) and',
'         security_group_id = :flow_security_group_id and ',
'         flow_id = :fb_flow_id;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to process action.'
,p_process_when_button_id=>wwv_flow_imp.id(40896605329630583)
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>40898220220634868
);
end;
/
prompt --application/pages/page_00713
begin
wwv_flow_imp_page.create_page(
 p_id=>713
,p_name=>'Replace Templates - Confirm'
,p_alias=>'REPLACE-TEMPLATES-CONFIRM'
,p_step_title=>'Replace Templates - Confirm'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt_view.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(90721624290082097)
,p_plug_name=>'Replace Templates'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_header=>'<p>Press <strong>Finish</strong> to change all component references of the identified template to the new template.  Theme defaults will not be changed.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(168735027708375127)
,p_plug_name=>'replace templates train'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(168734227577365586)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(208154127798679391)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747145015750138170)
,p_plug_name=>'Replace Templates'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(90722023277082098)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(208154127798679391)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(90722105717082098)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(208154127798679391)
,p_button_name=>'FINISH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Finish'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(90722226490082098)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(208154127798679391)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(90723031296082098)
,p_branch_action=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(90722731998082098)
,p_branch_action=>'f?p=&APP_ID.:711:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(90722226490082098)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(94001128457790636)
,p_name=>'P713_TEMPLATE_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(90721624290082097)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Template Type:'
,p_source=>'P708_TEMPLATE_TYPE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'TEMPLATE.TYPES.ALL'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  wwv_flow_lang.system_message_lit(''F4000.PAGE'') d,''PAGE'' r from sys.dual',
'union all',
'select wwv_flow_lang.system_message_lit(''F4000.REGION'') d,''REGION'' r from sys.dual',
'union all',
'select wwv_flow_lang.system_message_lit(''LABEL'') d,''LABEL'' r from sys.dual',
'union all',
'select wwv_flow_lang.system_message_lit(''F4000.LIST_INITCAP'') d, ''LIST'' r from sys.dual',
'union all',
'select wwv_flow_lang.system_message_lit(''F4000.P371.POPUP_LOV'') d, ''POPUP_LOV'' r from sys.dual',
'union all',
'select wwv_flow_lang.system_message_lit(''LEGACY_CALENDAR'') d,''CALENDAR'' r from sys.dual',
'union all',
'select wwv_flow_lang.system_message_lit(''BREADCRUMB'') d,''MENU'' r from sys.dual',
'union all',
'select wwv_flow_lang.system_message_lit(''F4000.BUTTON'') d, ''BUTTON'' r from sys.dual',
'union all',
'select wwv_flow_lang.system_message_lit(''REPORT'') d, ''REPORT'' r from sys.dual',
'union all',
'select wwv_flow_lang.system_message_lit(''F4000.TEMPLATE_COMPONENT'') d, ''TEMPLATE_COMPONENT'' r from sys.dual'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identifies the template type to be replaced.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(94063602221114115)
,p_name=>'P713_CONSOLIDATE_FROM'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(90721624290082097)
,p_prompt=>'Change From:'
,p_source=>'&P711_CONSOLIDATE_FROM.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'CONSOLIDATE_TEMPLATE_NAMES RETURNING ID'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select page_plug_template_name d, id',
'from wwv_flow_page_plug_templates',
'where flow_id = :FB_FLOW_ID and ',
'THEME_ID = (select theme_id from wwv_flows where id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''REGION''',
'union all',
'select name d, id ',
'from WWV_FLOW_TEMPLATES ',
'where flow_id = :FB_FLOW_ID and ',
'THEME_ID = (select theme_id from wwv_flows where id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''PAGE''',
'union all',
'select template_name d, id',
'from wwv_flow_field_templates f',
'where ',
'f.flow_id = :FB_FLOW_ID and ',
'THEME_ID = (select theme_id from wwv_flows where id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''LABEL''',
'union all',
'select ',
'l.list_template_name d, l.id',
'from ',
'wwv_flow_list_templates l',
'where ',
'l.flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flows where id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''LIST''',
'union all',
'select name d, id',
'from wwv_flow_cal_templates',
'where flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flows where id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''CALENDAR''',
'union all',
'select name d, id',
'from wwv_flow_menu_templates',
'where flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flows where id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''MENU''',
'union all',
'select template_name d, id',
'from WWV_FLOW_BUTTON_TEMPLATES',
'where flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flows where id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''BUTTON''',
'union all',
'select ''* ''||wwv_flow_lang.system_message(''HTML_BUTTON'') d, -1 id',
'from dual',
'where :P708_TEMPLATE_TYPE = ''BUTTON''',
'union all',
'select ROW_TEMPLATE_NAME d, id',
'from WWV_FLOW_ROW_TEMPLATES',
'where flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flows where id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''REPORT''',
'union all',
'select ''* ''||wwv_flow_lang.system_message(''REGION_TEMPLATES_NO_TEMPLATE'') d, -1 id',
'from dual',
'where :P708_TEMPLATE_TYPE in (''PAGE'',''REGION'')'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the template to be changed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(94065016074118141)
,p_name=>'P713_CONSOLIDATE_TO'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(90721624290082097)
,p_prompt=>'Change To:'
,p_source=>'&P711_CONSOLIDATE_TO.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'CONSOLIDATE_TEMPLATE_NAMES RETURNING ID'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select page_plug_template_name d, id',
'from wwv_flow_page_plug_templates',
'where flow_id = :FB_FLOW_ID and ',
'THEME_ID = (select theme_id from wwv_flows where id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''REGION''',
'union all',
'select name d, id ',
'from WWV_FLOW_TEMPLATES ',
'where flow_id = :FB_FLOW_ID and ',
'THEME_ID = (select theme_id from wwv_flows where id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''PAGE''',
'union all',
'select template_name d, id',
'from wwv_flow_field_templates f',
'where ',
'f.flow_id = :FB_FLOW_ID and ',
'THEME_ID = (select theme_id from wwv_flows where id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''LABEL''',
'union all',
'select ',
'l.list_template_name d, l.id',
'from ',
'wwv_flow_list_templates l',
'where ',
'l.flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flows where id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''LIST''',
'union all',
'select name d, id',
'from wwv_flow_cal_templates',
'where flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flows where id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''CALENDAR''',
'union all',
'select name d, id',
'from wwv_flow_menu_templates',
'where flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flows where id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''MENU''',
'union all',
'select template_name d, id',
'from WWV_FLOW_BUTTON_TEMPLATES',
'where flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flows where id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''BUTTON''',
'union all',
'select ''* ''||wwv_flow_lang.system_message(''HTML_BUTTON'') d, -1 id',
'from dual',
'where :P708_TEMPLATE_TYPE = ''BUTTON''',
'union all',
'select ROW_TEMPLATE_NAME d, id',
'from WWV_FLOW_ROW_TEMPLATES',
'where flow_id = :FB_FLOW_ID and',
'THEME_ID = (select theme_id from wwv_flows where id = :FB_FLOW_ID) and',
':P708_TEMPLATE_TYPE = ''REPORT''',
'union all',
'select ''* ''||wwv_flow_lang.system_message(''REGION_TEMPLATES_NO_TEMPLATE'') d, -1 id',
'from dual',
'where :P708_TEMPLATE_TYPE in (''PAGE'',''REGION'')'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the new template that will replace all occurrences of the selected template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(95626402191214620)
,p_name=>'P713_TEMPLATES'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(90721624290082097)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Count of templates to be replaced:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return',
'wwv_flow_theme_manager.count_consolidation (',
' p_application_id   => :fb_flow_id,',
' p_consolidate_from => :P711_CONSOLIDATE_FROM,',
' p_consolidate_to   => :P711_CONSOLIDATE_TO,',
' p_template_type    => :P708_TEMPLATE_TYPE);'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'The number of template references that will be changed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(96745917746629481)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'consolidate'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_theme_manager.consolidate_templates (',
'   p_application_id   => :fb_flow_id,',
'   p_consolidate_from => :P711_CONSOLIDATE_FROM,',
'   p_consolidate_to   => :P711_CONSOLIDATE_TO,',
'   p_template_type    => :P708_TEMPLATE_TYPE);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to replace templates'
,p_process_when_button_id=>wwv_flow_imp.id(90722105717082098)
,p_process_success_message=>'Action Processed'
,p_internal_uid=>96745917746629481
);
end;
/
prompt --application/pages/page_00714
begin
wwv_flow_imp_page.create_page(
 p_id=>714
,p_name=>'APEX Views'
,p_alias=>'APEX-VIEWS'
,p_step_title=>'APEX Views'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(200467223102537626)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_utilties.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(200451220490287640)
,p_plug_name=>'APEX Views'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select APEX_VIEW_NAME,',
'       COMMENTS,',
'       PARENT_VIEW,',
'       ''f?p=4000:892:''||:APP_SESSION||',
'          '':::892,893,896:P892_LAST_PAGE,P892_VIEW_NAME,P893_VIEW_NAME,P896_VIEW_NAME:714,''||',
'          APEX_VIEW_NAME ||'',''||APEX_VIEW_NAME||'',''||APEX_VIEW_NAME link,',
'       ''icon-util-apex-views'' icon,',
'       replace(replace(replace(initcap(replace(apex_view_name,''_'','' '')),''Apex'',''APEX''),''Lov'',''LOV''),''Sql'',''SQL'') bname',
'  from APEX_DICTIONARY ',
' where column_id=0'))
,p_plug_source_type=>'NATIVE_IR'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(200451301656287640)
,p_name=>'Application Express Views'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_control_break=>'N'
,p_show_highlight=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#LINK#" class="a-IRR-icon"><span class="a-Icon #ICON#"></span><span class="a-IRR-iconName">#APEX_VIEW_NAME#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(200451523458287643)
,p_db_column_name=>'APEX_VIEW_NAME'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>'View'
,p_column_link=>'f?p=&APP_ID.:892:&SESSION.::&DEBUG.:892,893,896:P892_VIEW_NAME,P893_VIEW_NAME,P896_VIEW_NAME:#APEX_VIEW_NAME#,#APEX_VIEW_NAME#,#APEX_VIEW_NAME#'
,p_column_linktext=>'#APEX_VIEW_NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(200451615389287644)
,p_db_column_name=>'COMMENTS'
,p_display_order=>3
,p_column_identifier=>'B'
,p_column_label=>'Comment'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(200451703550287645)
,p_db_column_name=>'PARENT_VIEW'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>'Parent View'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(200817506506772361)
,p_db_column_name=>'BNAME'
,p_display_order=>6
,p_column_identifier=>'E'
,p_column_label=>'Bname'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(200818124036805640)
,p_db_column_name=>'LINK'
,p_display_order=>7
,p_column_identifier=>'F'
,p_column_label=>'Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1029936832389915801)
,p_db_column_name=>'ICON'
,p_display_order=>17
,p_column_identifier=>'G'
,p_column_label=>'Icon'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(200452123851291895)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_type=>'REPORT'
,p_report_alias=>'1290707450536644'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_view_mode=>'REPORT'
,p_report_columns=>'LINK:APEX_VIEW_NAME:COMMENTS:PARENT_VIEW:ICON'
,p_sort_column_1=>'APEX_VIEW_NAME'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(200464415221516479)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(200452609222306546)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(699069214410849616)
,p_plug_name=>'Workspace Utilities'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(2778715503937249)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(955889819902997309)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>'&PRODUCT_NAME. Views are data dictionary views that expose the metadata for applications. In &PRODUCT_NAME. Views, you cannot only see the view, but you can also see the data they contain.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(200554107948864388)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(200451220490287640)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:714:&SESSION.::&DEBUG.:714,RIR::'
);
end;
/
prompt --application/pages/page_00716
begin
wwv_flow_imp_page.create_page(
 p_id=>716
,p_name=>'Create Form and Report on Web Service'
,p_alias=>'CREATE-FORM-AND-REPORT-ON-WEB-SERVICE'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Form And Report On Web Service'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(22653722318934005)
,p_name=>'Basic Authentication'
,p_template=>wwv_flow_imp.id(42025417508627628)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select seq_id, c001 id, c002 name, c003 parm_type, ',
'       c004 item_name, c005 item_label, c006 include',
'  from wwv_flow_collections',
' where collection_name = ''WS_AUTH_ITEMS'''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No input parameters for this service.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>1000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22653920201934006)
,p_query_column_id=>1
,p_column_alias=>'SEQ_ID'
,p_column_display_sequence=>5
,p_column_heading=>'Seq Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22654028812934006)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>6
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22654108673934006)
,p_query_column_id=>3
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'DISPLAY_AND_SAVE'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22654231500934006)
,p_query_column_id=>4
,p_column_alias=>'PARM_TYPE'
,p_column_display_sequence=>2
,p_column_heading=>'Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'DISPLAY_AND_SAVE'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22654308690934006)
,p_query_column_id=>5
,p_column_alias=>'ITEM_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Item Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>20
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22654416499934006)
,p_query_column_id=>6
,p_column_alias=>'ITEM_LABEL'
,p_column_display_sequence=>4
,p_column_heading=>'Item Label'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>20
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22654508900934006)
,p_query_column_id=>7
,p_column_alias=>'INCLUDE'
,p_column_display_sequence=>7
,p_column_heading=>'Create'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_named_lov=>wwv_flow_imp.id(84259319526460470)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22654818424934007)
,p_plug_name=>'Wizard Steps'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(30094110886480012)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22655018672934007)
,p_plug_name=>'Form and Report on Web Service'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42027416946637016)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Identify the names and labels for items created based on this service''s authentication parameters.</p>',
'<p>If necessary, edit the item label.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(204748630516126595)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(22655919591934008)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(204748630516126595)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(22656330466934008)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(204748630516126595)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(22656525143934008)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(204748630516126595)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(34484027905273522)
,p_branch_action=>'f?p=&APP_ID.:880:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(22656525143934008)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P705_IS_REST'
,p_branch_condition_text=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(34484309335277590)
,p_branch_action=>'f?p=&APP_ID.:882:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(22656330466934008)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P705_IS_REST'
,p_branch_condition_text=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(790824814838546266)
,p_branch_action=>'f?p=&APP_ID.:842:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(22656330466934008)
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':P700_WEB_REF_TYPE = ''MANUAL'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(22657615559934009)
,p_branch_action=>'f?p=&FLOW_ID.:725:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(22656330466934008)
,p_branch_sequence=>50
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(22657810486934010)
,p_branch_action=>'f?p=&FLOW_ID.:720:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(22656525143934008)
,p_branch_sequence=>60
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(549740786805954508)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(22655919591934008)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(549740884771954509)
,p_event_id=>wwv_flow_imp.id(549740786805954508)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(22656912978934009)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.update_members(',
'  p_collection_name      => ''WS_AUTH_ITEMS'',',
'  p_seq                  => wwv_flow.g_f01,',
'  p_c001                 => wwv_flow.g_f02,',
'  p_c002                 => wwv_flow.g_f03,',
'  p_c003                 => wwv_flow.g_f04,',
'  p_c004                 => wwv_flow.g_f05,',
'  p_c005                 => wwv_flow.g_f06,',
'  p_c006                 => wwv_flow.g_f07 );'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>22656912978934009
);
end;
/
prompt --application/pages/page_00719
begin
wwv_flow_imp_page.create_page(
 p_id=>719
,p_name=>'Create Dynamic List'
,p_alias=>'CREATE-DYNAMIC-LIST2'
,p_page_mode=>'NON_MODAL'
,p_step_title=>'Create Dynamic List'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(120871216744825711)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'570'
,p_dialog_width=>'820'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1449700853810807)
,p_plug_name=>'Create Dynamic List'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(758615420776655704)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(758615519441655705)
,p_plug_name=>'Create Dynamic List'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1450106832810807)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(758615420776655704)
,p_button_name=>'FINISH'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Finish'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:$v_PopupReturn($v(''P719_LOV_SQL''),''&P464_LIST_SOURCE_FIELD!JS.'');'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1450310178810807)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(758615420776655704)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1449910073810807)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(758615420776655704)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1450806922810809)
,p_branch_action=>'f?p=&APP_ID.:701:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(1450310178810807)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1450513796810807)
,p_name=>'P719_LOV_SQL'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1449700853810807)
,p_use_cache_before_default=>'NO'
,p_item_default=>'select * from emp;'
,p_prompt=>'Query'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'  q varchar2(32767) := null;',
'begin',
'  ',
'  -- Label',
'  q := ''select null as level_value ''||chr(10)||''       , "''||:P701_LABEL_COLUMN||''" as label_value '';',
'  q := q||chr(10);',
' ',
'  -- Target',
'  if :P701_TARGET_COLUMN is not null then',
'      q := q||''       , "''||:P701_TARGET_COLUMN||''" as target_value'';',
'  else',
'      if :P701_TARGET_URL is not null then',
'          q := q||''       , ''''''||:P701_TARGET_URL||'''''' as target_value'';',
'      else',
'          q := q||''       , null as target_value'';',
'      end if;',
'  end if;',
'  q := q||chr(10);',
'  ',
'  -- Is Current',
'    if :P701_IS_CURRENT is not null then',
'        q := q||''       , ''''''||:P701_IS_CURRENT||'''''' as is_current '';',
'    else',
'        q := q||''       , null as is_current '';',
'    end if;',
'  q := q||chr(10);',
'',
'  -- Image',
'  if :P701_IMAGE_COLUMN is not null then',
'      q := q||''       , "''||:P701_IMAGE_COLUMN||''" as image_value '';',
'  else',
'      q := q||''       , null as image_value '';',
'  end if;',
'  q := q||chr(10);',
' ',
'  -- Image Attribute',
'  if :P701_IMAGE_ATTR_COLUMN is not null then',
'      q := q||''       , "''||:P701_IMAGE_ATTR_COLUMN||''" as image_attr_value '';',
'  else',
'      q := q||''       , null as image_attr_value '';      ',
'  end if;',
'  q := q||chr(10);',
'  ',
'  -- Image Alt Attribute',
'  if :P701_IMAGE_ALT_COLUMN is not null then',
'      q := q||''       , "''||:P701_IMAGE_ALT_COLUMN||''" as image_alt_value '';',
'  else',
'      q := q||''       , null as image_alt_value '';      ',
'  end if;',
'  q := q||chr(10);',
'  ',
'  ',
'  q := q||''from '';',
'',
'  for c1 in (select OWNER from wwv_flows where id = :fb_flow_id)',
'  loop',
'      if nvl(upper(c1.owner),''x'') != nvl(upper(:P542_OWNER),''y'') then',
'          -- include owner if it is different from the application owner',
'          q := q||''"''||:P542_OWNER||''".'';',
'      end if;',
'  end loop;',
'  if :P542_TABLE is not null then',
'      q := q||''"''||:P542_TABLE||''"'';',
'  end if;',
'  q := q||chr(10)||''order by 1'';',
'  return q;',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>32767
,p_cHeight=>10
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_item_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'ORIG CODE: 2-FEB-2011',
'',
'declare ',
'  q varchar2(32767) := null;',
'begin',
'  if :P701_DISPLAY_COLUMN != upper(:P701_DISPLAY_COLUMN) then',
'     q := ''select "''||:P701_DISPLAY_COLUMN||''" as display_value, '';',
'  else',
'     q := ''select ''||:P701_DISPLAY_COLUMN||'' as display_value, '';',
'  end if;',
'  if :P701_RETURN_COLUMN != upper(:P701_RETURN_COLUMN) then',
'     q := q||''"''||:P701_RETURN_COLUMN||''" as return_value '';',
'  else',
'     q := q||:P701_RETURN_COLUMN||'' as return_value '';',
'  end if;',
'  q := q||chr(10);',
'  q := q||''  from '';',
'  for c1 in (select OWNER from wwv_flows where id = :fb_flow_id) loop',
'     if nvl(upper(c1.owner),''x'') != nvl(upper(:P542_OWNER),''y'') then',
'         -- include owner if it is different from the application owner',
'         q := q||:P542_OWNER||''.'';',
'     end if;',
'  end loop;',
'  if :P542_TABLE != upper(:P542_TABLE) then',
'      q := q||''"''||:P542_TABLE||''"'';',
'  else   q := q||:P542_TABLE;',
'  end if;',
'  q := q||chr(10)||'' order by 1'';',
'  return q;',
'end;'))
);
end;
/
prompt --application/pages/page_00720
begin
wwv_flow_imp_page.create_page(
 p_id=>720
,p_name=>'Create Form and Report on Web Service - Input Items'
,p_alias=>'CREATE-FORM-AND-REPORT-ON-WEB-SERVICE-INPUT-ITEMS'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Form and Report on Web Service'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(30062402754215125)
,p_name=>'Create Form and Report on Web Service'
,p_template=>wwv_flow_imp.id(42025417508627628)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select seq_id, c001 id, c002 name, c003 parm_type, ',
'       c004 item_name, c005 item_label, c006 include',
'  from wwv_flow_collections',
' where collection_name = ''WS_INPUT_ITEMS'''))
,p_display_when_condition=>'P720_IS_ARRAY'
,p_display_when_cond2=>'N'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_header=>'<p>Identify the names and labels for items created based on this service''s input parameters. To include an item, select <strong>Yes</strong> in the Create column. Otherwise, select <strong>No</strong>. If necessary, edit the item label.</p>'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No input parameters for this service.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>1000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(30062830105215126)
,p_query_column_id=>1
,p_column_alias=>'SEQ_ID'
,p_column_display_sequence=>5
,p_column_heading=>'Seq Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(30062906809215126)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>6
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(30063019962215127)
,p_query_column_id=>3
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'DISPLAY_AND_SAVE'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(30063103634215127)
,p_query_column_id=>4
,p_column_alias=>'PARM_TYPE'
,p_column_display_sequence=>2
,p_column_heading=>'Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'DISPLAY_AND_SAVE'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(30063210649215127)
,p_query_column_id=>5
,p_column_alias=>'ITEM_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Item Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>20
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(30063300197215127)
,p_query_column_id=>6
,p_column_alias=>'ITEM_LABEL'
,p_column_display_sequence=>4
,p_column_heading=>'Item Label'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>20
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(38878713393887143)
,p_query_column_id=>7
,p_column_alias=>'INCLUDE'
,p_column_display_sequence=>7
,p_column_heading=>'Create'
,p_use_as_row_header=>'N'
,p_display_as=>'SELECT_LIST_FROM_LOV'
,p_named_lov=>wwv_flow_imp.id(84259319526460470)
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(38866022163747807)
,p_column_sequence=>1
,p_query_column_name=>'SEQ_ID'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(38866108729747810)
,p_column_sequence=>2
,p_query_column_name=>'ID'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(38866204791747811)
,p_column_sequence=>3
,p_query_column_name=>'NAME'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(38866303796747811)
,p_column_sequence=>4
,p_query_column_name=>'PARM_TYPE'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(38866405209747811)
,p_column_sequence=>5
,p_query_column_name=>'ITEM_NAME'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(38866510732747811)
,p_column_sequence=>6
,p_query_column_name=>'ITEM_LABEL'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30063827252215131)
,p_plug_name=>'Wizard Steps'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(30094110886480012)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(204745712723112011)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(215714610018520039)
,p_plug_name=>'Input Parameters Contain an Array Type'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>The input parameters for this service require an array type which cannot be represented by creating items. You will not be able to use the wizard to create a form on this Web service reference.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P720_IS_ARRAY'
,p_plug_display_when_cond2=>'Y'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30064611509215134)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(204745712723112011)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30065420346215136)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(204745712723112011)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30065011692215135)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(204745712723112011)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(22666527607976143)
,p_branch_action=>'f?p=&APP_ID.:716:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(30065420346215136)
,p_branch_sequence=>25
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''WS_AUTH_ITEMS'''))
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(38845031139523270)
,p_branch_action=>'f?p=&FLOW_ID.:705:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(30065011692215135)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(193720500842028374)
,p_branch_action=>'f?p=&APP_ID.:842:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(30065420346215136)
,p_branch_sequence=>35
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':P700_WEB_REF_TYPE = ''MANUAL'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(30067026361215143)
,p_branch_action=>'f?p=&APP_ID.:725:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(30065420346215136)
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(215716126986524926)
,p_name=>'P720_IS_ARRAY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(215714610018520039)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(549740994811954510)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(30064611509215134)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(549741067286954511)
,p_event_id=>wwv_flow_imp.id(549740994811954510)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(30066210996215141)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.update_members(',
'  p_collection_name      => ''WS_INPUT_ITEMS'',',
'  p_seq                  => wwv_flow.g_f01,',
'  p_c001                 => wwv_flow.g_f02,',
'  p_c002                 => wwv_flow.g_f03,',
'  p_c003                 => wwv_flow.g_f04,',
'  p_c004                 => wwv_flow.g_f05,',
'  p_c005                 => wwv_flow.g_f06,',
'  p_c006                 => wwv_flow.g_f07 );'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>30066210996215141
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(30065922327215137)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate input item collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    n   wwv_flow_global.vc_arr2;',
'    v   wwv_flow_global.vc_arr2;',
'begin',
'    n(1) := ''pg_id'';',
'    n(2) := ''op_id'';',
'    v(1) := :P705_PAGE_ID;',
'    v(2) := :P700_OPERATION_ID;',
'',
'    wwv_flow_collection.create_collection_from_query_b(',
'        p_collection_name => ''WS_INPUT_ITEMS'',',
'        p_query           => ''select a.id, a.name, a.parm_type,',
'''''P''''||:pg_id||''''_''''||upper(a.name), initcap(a.name), ''''Y'''' yes_no from wwv_flow_ws_parameters a where a.input_or_output in (''''I'''',''''H'''') and a.type_is_xsd = ''''Y'''' and a.ws_opers_id = :op_id order by a.input_or_output, a.id'',',
'    p_names           => n,',
'    p_values          => v);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'not wwv_flow_collection.collection_exists(''WS_INPUT_ITEMS'') and :P700_WEB_REF_TYPE = ''NEW_SCHOOL'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>30065922327215137
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(193695708208737264)
,p_process_sequence=>45
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate input item collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_clob  clob;',
'    l_off   number := 1;',
'    l_pos   number := 0;',
'    l_name  varchar2(4000);',
'begin',
'',
'    wwv_flow_collection.create_or_truncate_collection(',
'        p_collection_name => ''WS_INPUT_ITEMS'');',
'',
'    for c1 in (select flow_items_comma_delimited',
'                 from wwv_flow_shared_web_services',
'                where id = :P700_WS_ID ) loop',
'        l_clob := c1.flow_items_comma_delimited;',
'    end loop;',
'',
'    l_pos   := sys.dbms_lob.instr(l_clob,'','',1);',
'',
'    if l_pos = 0 then --there are no commas at all',
'        if sys.dbms_lob.getlength(l_clob) > 0 then',
'            l_name := sys.dbms_lob.substr(l_clob,sys.dbms_lob.getlength(l_clob),1);',
'            wwv_flow_collection.add_member(',
'                p_collection_name   => ''WS_INPUT_ITEMS'',',
'                p_c001              => ''MANUAL'',',
'                p_c002              => l_name,',
'                p_c003              => ''string'',',
'                p_c004              => upper(l_name),',
'                p_c005              => initcap(l_name),',
'                p_c006              => ''Y'' );',
'        end if;',
'    else',
'        loop',
'            exit when l_pos = 0;',
'',
'            l_name := sys.dbms_lob.substr(l_clob,l_pos-l_off,l_off);',
'            wwv_flow_collection.add_member(',
'                p_collection_name   => ''WS_INPUT_ITEMS'',',
'                p_c001              => ''MANUAL'',',
'                p_c002              => l_name,',
'                p_c003              => ''string'',',
'                p_c004              => upper(l_name),',
'                p_c005              => initcap(l_name),',
'                p_c006              => ''Y'' );',
'            l_off := l_pos + 1;',
'            l_pos := sys.dbms_lob.instr(l_clob,'','',l_off);',
'        end loop;',
'        --need to get the last one',
'        l_name := sys.dbms_lob.substr(l_clob,4000,l_off);',
'        wwv_flow_collection.add_member(',
'            p_collection_name   => ''WS_INPUT_ITEMS'',',
'            p_c001              => ''MANUAL'',',
'            p_c002              => l_name,',
'            p_c003              => ''string'',',
'            p_c004              => upper(l_name),',
'            p_c005              => initcap(l_name),',
'            p_c006              => ''Y'' );',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'not wwv_flow_collection.collection_exists(''WS_INPUT_ITEMS'') and :P700_WEB_REF_TYPE = ''MANUAL'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>193695708208737264
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(215719201622536514)
,p_process_sequence=>50
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate is_array'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_is_array varchar2(1) := ''N'';',
'begin',
'  for c1 in (select count(*), c004',
'               from wwv_flow_collections',
'              where collection_name = ''WS_INPUT_ITEMS''',
'              group by c004',
'             having count(*) > 1 ) loop',
'    l_is_array := ''Y'';',
'    exit;',
'  end loop;',
'  if :P720_WEB_REF_TYPE = ''NEW_SCHOOL'' then',
'    :P720_IS_ARRAY := l_is_array;',
'  else',
'    :P720_IS_ARRAY := ''N'';',
'  end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>215719201622536514
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(22664916048963322)
,p_process_sequence=>70
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate auth item collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    n   wwv_flow_global.vc_arr2;',
'    v   wwv_flow_global.vc_arr2;',
'begin',
'    n(1) := ''pg_id'';',
'    n(2) := ''ws_id'';',
'    v(1) := :P705_PAGE_ID;',
'    v(2) := :P700_WS_ID;',
'',
'    wwv_flow_collection.create_collection_from_query_b(',
'        p_collection_name => ''WS_AUTH_ITEMS'',',
'        p_query           => ''select a.id, decode(a.name,''''username'''',wwv_flow_lang.system_message(''''ACCESS_CONTROL_USERNAME''''),''''password'''',wwv_flow_lang.system_message(''''PASSWORD''''),a.name), wwv_flow_lang.system_message(''''AUTHENTICATION''''),',
'''''P''''||:pg_id||''''_''''||upper(decode(a.name,''''username'''',wwv_flow_lang.system_message(''''ACCESS_CONTROL_USERNAME''''),''''password'''',wwv_flow_lang.system_message(''''PASSWORD''''),a.name)), decode(a.name,''''username'''',wwv_flow_lang.system_message(''''ACCESS_CONTRO'
||'L_USERNAME''''),''''password'''',wwv_flow_lang.system_message(''''PASSWORD''''),a.name), ''''Y'''' y_or_n from wwv_flow_ws_parameters a, wwv_flow_ws_operations b, wwv_flow_shared_web_services c where input_or_output = ''''A'''' and a.ws_opers_id = b.id and b.ws_id = c'
||'.id and c.id = :ws_id order by a.name desc'',',
'    p_names           => n,',
'    p_values          => v);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'not wwv_flow_collection.collection_exists(''WS_AUTH_ITEMS'')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>22664916048963322
);
end;
/
prompt --application/pages/page_00722
begin
wwv_flow_imp_page.create_page(
 p_id=>722
,p_name=>'Application Groups'
,p_alias=>'APPLICATION-GROUPS'
,p_step_title=>'Application Groups'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(91139922499861568)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_appgroup.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(91619417266324331)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(91618427870317883)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(95535315411805254)
,p_plug_name=>'About'
,p_region_css_classes=>'a-Region--stacked a-Region--padded a-Region--flush a-Region--sideRegion'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Application groups enable you to organize your applications.</p>',
'<p>To use application groups, create a group by clicking <strong>Create</strong> and then assigning applications to that group.</p>',
'<p>To associate an application with an application group, click <strong>Manage Assignments</strong> on the Tasks list.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(445610404731601726)
,p_plug_name=>'Application Groups'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4050P722a */',
'       id, ',
'       group_name, ',
'       group_comment, ',
'       assigned_applications, ',
'       last_modified, ',
'       round(100*assigned_applications/decode(all_applications,0,1,all_applications)) pct_of_total,',
'       round(100*assigned_applications/decode(all_applications,0,1,all_applications)) graph,',
'       ''icon-util-page-group'' img, ''f?p=4000:726:''||:app_session||'':::RP:FB_FLOW_ID,P726_ID:''||:fb_flow_id||'',''||id img_link,',
'       replace(group_name,''_'','' '')||'' (''|| assigned_applications ||'')'' img_text',
'from ( select id, ',
'              group_name, ',
'              group_comment,',
'              ( select count(*)',
'                  from wwv_flows ',
'                 where security_group_id = :flow_security_group_id ',
'                   and group_id = g.id) Assigned_Applications, ',
'              nvl(updated_on,created_on) last_modified,',
'              a.all_applications',
'         from wwv_flow_application_groups g,',
'              ( select count(*) all_applications ',
'                  from wwv_flow_visible_flows f',
'                 where group_id is not null',
'                   and build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') ) a',
'        where security_group_id = :flow_security_group_id ) x'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(445610507272601726)
,p_name=>'Application Groups'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#IMG_LINK#" class="a-IRR-icon"><span class="a-Icon #IMG#"></span><span class="a-IRR-iconName">#GROUP_NAME#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(445610730447601759)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'&nbsp;'
,p_column_linktext=>'#ID#'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(445610809845601766)
,p_db_column_name=>'GROUP_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Group Name'
,p_column_link=>'f?p=&APP_ID.:726:&SESSION.::&DEBUG.:RP:P726_ID,FB_FLOW_ID:#ID#,&FB_FLOW_ID.'
,p_column_linktext=>'#GROUP_NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(445610903706601767)
,p_db_column_name=>'GROUP_COMMENT'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Description'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(445611122645601769)
,p_db_column_name=>'LAST_MODIFIED'
,p_display_order=>4
,p_column_identifier=>'E'
,p_column_label=>'Last Modified'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(445611020228601768)
,p_db_column_name=>'ASSIGNED_APPLICATIONS'
,p_display_order=>5
,p_column_identifier=>'D'
,p_column_label=>'Applications'
,p_column_link=>'f?p=&APP_ID.:1500:&SESSION.::&DEBUG.::IR_GROUPNAME,FB_FLOW_ID:#GROUP_NAME#,&FB_FLOW_ID.'
,p_column_linktext=>'#ASSIGNED_APPLICATIONS#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(445611422026601772)
,p_db_column_name=>'IMG'
,p_display_order=>7
,p_column_identifier=>'H'
,p_column_label=>'Img'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(445611513011601773)
,p_db_column_name=>'IMG_LINK'
,p_display_order=>8
,p_column_identifier=>'I'
,p_column_label=>'Img Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(445611623877601774)
,p_db_column_name=>'IMG_TEXT'
,p_display_order=>9
,p_column_identifier=>'J'
,p_column_label=>'Img Text'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(969098204076943070)
,p_db_column_name=>'PCT_OF_TOTAL'
,p_display_order=>10
,p_column_identifier=>'K'
,p_column_label=>'Percent of Total'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(969098310680943070)
,p_db_column_name=>'GRAPH'
,p_display_order=>11
,p_column_identifier=>'L'
,p_column_label=>'Graph'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'PCT_GRAPH:cccccc:777777:150'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(445612301870609108)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_type=>'REPORT'
,p_report_alias=>'1290823179536644'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_view_mode=>'REPORT'
,p_report_columns=>'GROUP_NAME:GROUP_COMMENT:ASSIGNED_APPLICATIONS:PCT_OF_TOTAL:GRAPH:'
,p_sort_column_1=>'GROUP_NAME'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(699068624658844542)
,p_plug_name=>'Workspace Utilities'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(2778715503937249)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(91039229518900853)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(445610404731601726)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:726:&SESSION.::&DEBUG.:726 :FB_FLOW_ID:,&FB_FLOW_ID.'
,p_icon_css_classes=>'icon-right-chevron'
);
end;
/
prompt --application/pages/page_00725
begin
wwv_flow_imp_page.create_page(
 p_id=>725
,p_name=>'Create Form and Report on Web Service - Web Service Results'
,p_alias=>'CREATE-FORM-AND-REPORT-ON-WEB-SERVICE-WEB-SERVICE-RESULTS'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Form and Report on Web Service'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30069027239226823)
,p_plug_name=>'Base Node'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_item_display_point=>'BELOW'
,p_plug_query_row_template=>wwv_flow_imp.id(79387910442923002)
,p_plug_query_num_rows=>1000
,p_plug_query_num_rows_type=>'0'
,p_plug_query_row_count_max=>1000
,p_plug_query_no_data_found=>'No data found.'
,p_plug_query_break_cols=>'0'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_ws_parameters a',
' where type_is_xsd = ''N''',
'   and input_or_output = ''O''',
'   and exists (select 1',
'                 from wwv_flow_ws_parameters',
'                where parent_id = a.id',
'                  and type_is_xsd = ''Y'')',
'   and ws_opers_id = :P700_OPERATION_ID'))
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_header=>'<p>Identify the name of a temporary result set in which to store the Web service result and select the result tree on which to create the report.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30070025233226825)
,p_plug_name=>'Wizard Steps'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(30094110886480012)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(204758221044190105)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(287124420639303467)
,p_plug_name=>'No Result Tree to Report On'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'This Web service does not have a result tree in its definition that is appropriate for a report. You may wish to run the Form on Web Service wizard instead.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NOT_EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_ws_parameters a',
' where type_is_xsd = ''N''',
'   and input_or_output = ''O''',
'   and exists (select 1',
'                 from wwv_flow_ws_parameters',
'                where parent_id = a.id',
'                  and type_is_xsd = ''Y'')',
'   and ws_opers_id = :P700_OPERATION_ID'))
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30071203933226827)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(204758221044190105)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30072031311226830)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(204758221044190105)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30071609780226828)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(204758221044190105)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(22667215271982081)
,p_branch_action=>'f?p=&APP_ID.:716:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(30071609780226828)
,p_branch_sequence=>25
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''WS_AUTH_ITEMS'''))
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(30073317744226833)
,p_branch_action=>'f?p=&FLOW_ID.:720:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(30071609780226828)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(30073719709226834)
,p_branch_action=>'f?p=&FLOW_ID.:730:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'nvl(:REQUEST,''NEXT'') = ''NEXT'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30165701694063969)
,p_name=>'P725_ARRAY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(30069027239226823)
,p_prompt=>'Result Tree to Report On:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P725_ARRAYS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name)||'' (''||wwv_flow_escape.html(parm_type)||'')'' d, id r',
'  from wwv_flow_ws_parameters a',
' where type_is_xsd = ''N''',
'   and input_or_output = ''O''',
'   and exists (select 1',
'                 from wwv_flow_ws_parameters',
'                where parent_id = a.id',
'                  and type_is_xsd = ''Y'') ',
'   and ws_opers_id = :P700_OPERATION_ID'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Select the portion of the resulting XML document that contains the information you want to include in the report.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30167715771134270)
,p_name=>'P725_COLLECTION_NAME'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_imp.id(30069027239226823)
,p_prompt=>'Temporary Result Set Name (Collection)'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''P''||:P705_PAGE_ID||''_''||upper(name)||''_RESULTS''',
'  from wwv_flow_ws_operations',
' where id = :P700_OPERATION_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter the name of the temporary result set to store the document in.  The temporary result set is stored in an &PRODUCT_NAME. collection in the CLOB001 column using the name provided here.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(30170319281163685)
,p_validation_name=>'P725_COLLECTION_NAME'
,p_validation_sequence=>10
,p_validation=>'P725_COLLECTION_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'You must supply the name of the collection to store the result in.'
,p_validation_condition=>'nvl(:REQUEST,''NEXT'') = ''NEXT'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(30167715771134270)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(30171425992175074)
,p_validation_name=>'validate collection name'
,p_validation_sequence=>20
,p_validation=>'P725_COLLECTION_NAME'
,p_validation_type=>'ITEM_IS_ALPHANUMERIC'
,p_error_message=>'Name may contain only alphanumeric characters and underscores "_".'
,p_validation_condition=>'nvl(:REQUEST,''NEXT'') = ''NEXT'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(30167715771134270)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(30188912775767402)
,p_validation_name=>'P725_ARRAY'
,p_validation_sequence=>30
,p_validation=>'P725_ARRAY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'You must choose an array.'
,p_validation_condition=>'nvl(:REQUEST,''NEXT'') = ''NEXT'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(30165701694063969)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(549741109138954512)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(30071203933226827)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(549741206341954513)
,p_event_id=>wwv_flow_imp.id(549741109138954512)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00726
begin
wwv_flow_imp_page.create_page(
 p_id=>726
,p_name=>'Create / Edit Application Group'
,p_alias=>'CREATE-EDIT-APPLICATION-GROUP'
,p_step_title=>'Create / Edit Application Group'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(91139922499861568)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_appgroup.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(91042818367932040)
,p_plug_name=>'Application Group'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(91058306861002658)
,p_plug_name=>'Page Button Button Box'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(95526603458763922)
,p_name=>'Assigned Applications'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'REGION_POSITION_03'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<a href="f?p=4000:1:''||:app_session||',
'       ''::::FB_FLOW_ID,F4000_P1_FLOW,P0_FLOWPAGE:''||',
'       id||'',''||id||'',''||',
'       ''">''||id||''</a> - ''||wwv_flow_escape.html(f.name) name',
'  from wwv_flow_visible_flows f',
' where group_id = :P726_ID',
'   and build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'   and (    :P726_FIND is null',
'         or instr(upper(name),upper(:P726_FIND)) > 0',
'         or instr(id,:P726_FIND) > 0 )'))
,p_display_when_condition=>'select 1 from wwv_flow_application_groups where security_group_id = :flow_security_group_id'
,p_display_condition_type=>'EXISTS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(11667910335347890)
,p_query_num_rows=>200
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No assigned Applications found.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>2000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(95527121687764155)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(886496476203981540)
,p_plug_name=>'Application Group'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>'<p>You can organize applications by assigning them to application groups. Use this page to define the application name and description.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(91043425813932041)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(91058306861002658)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:722:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(91043206209932041)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(91058306861002658)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(htmldb_delete_message,''DELETE'');'
,p_button_condition=>'P726_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(91043115632932041)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(91058306861002658)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P726_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(91043011263932041)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(91058306861002658)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>'P726_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(91044002139932043)
,p_branch_action=>'f?p=&APP_ID.:722:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>21
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(91044210601932044)
,p_name=>'P726_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(91042818367932040)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(91044430620932055)
,p_name=>'P726_GROUP_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(91042818367932040)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>'GROUP_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the name of the application group.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(91044828167932060)
,p_name=>'P726_GROUP_COMMENT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(91042818367932040)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Description'
,p_source=>'GROUP_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a description for this application group.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(91044715805932057)
,p_validation_name=>'P726_GROUP_NAME not null'
,p_validation_sequence=>20
,p_validation=>'P726_GROUP_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Group Name must have some value.'
,p_associated_item=>wwv_flow_imp.id(91044430620932055)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(91045121219932061)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_APPLICATION_GROUPS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_APPLICATION_GROUPS'
,p_attribute_03=>'P726_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Unable to fetch row.'
,p_internal_uid=>91045121219932061
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(91370517513741604)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'null deleted group_id'
,p_process_sql_clob=>'update wwv_flows set group_id = null where security_group_id = :flow_security_group_id and group_id = :P726_ID;'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unexpected Error in Processing Application Groups'
,p_process_when_button_id=>wwv_flow_imp.id(91043206209932041)
,p_internal_uid=>91370517513741604
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(91045305262932062)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_APPLICATION_GROUPS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_APPLICATION_GROUPS'
,p_attribute_03=>'P726_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Unable to process row of table WWV_FLOW_APPLICATION_GROUPS.'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>91045305262932062
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(91045508955932062)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'726'
,p_process_when_button_id=>wwv_flow_imp.id(91043206209932041)
,p_internal_uid=>91045508955932062
);
end;
/
prompt --application/pages/page_00727
begin
wwv_flow_imp_page.create_page(
 p_id=>727
,p_name=>'Publish Templates'
,p_alias=>'PUBLISH-TEMPLATES'
,p_step_title=>'Publish Templates'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt_view.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(94579821771173451)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>121
,p_list_id=>wwv_flow_imp.id(12437772301)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Templates'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(94580804933178097)
,p_plug_name=>'Template Actions'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>131
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(94591309182236106)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>41
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page displays templates that have been subscribed to by other templates in your workspace.</p>',
'<p>To publish master template content to subscribing templates, select those you want to publish and click <strong>Publish Checked</strong>.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(95255202093864810)
,p_name=>'master templates'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>151
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  with messages as (',
'      select ''PAGE'' as msg_code,    wwv_flow_lang.system_message(''F4000.PAGE'') as msg        from sys.dual union all',
'      select ''REGION'',              wwv_flow_lang.system_message(''F4000.REGION'')             from sys.dual union all',
'      select ''REPORT'',              wwv_flow_lang.system_message(''REPORT'')                   from sys.dual union all',
'      select ''LIST'',                wwv_flow_lang.system_message(''F4000.LIST_INITCAP'')       from sys.dual union all',
'      select ''LABEL'',               wwv_flow_lang.system_message(''LABEL'')                    from sys.dual union all',
'      select ''BUTTON'',              wwv_flow_lang.system_message(''F4000.BUTTON'')             from sys.dual union all',
'      select ''MENU'',                wwv_flow_lang.system_message(''BREADCRUMB'')               from sys.dual union all',
'      select ''CALENDAR'',            wwv_flow_lang.system_message(''LEGACY_CALENDAR'')          from sys.dual union all',
'      select ''POPUP_LOV'',           wwv_flow_lang.system_message(''F4000.P371.POPUP_LOV'')     from sys.dual union all',
'      select ''TEMPLATE_COMPONENT'',  wwv_flow_lang.system_message(''F4000.TEMPLATE_COMPONENT'') from sys.dual )',
'select id,',
'       wwv_flow_item.checkbox(item_id,id,''title="''||wwv_flow_lang.system_message(''SELECT_ROW_C'', wwv_flow_escape.html(template_name))||''"'') row_selector,',
'       ( select msg from messages where msg_code = rtype ) as template_type,',
'       rtype,',
'       theme_id,',
'       ''<a href="'' || wwv_flow_utilities.prepare_url( url ) || ''">'' || wwv_flow_escape.html(template_name) || ''</a>'' template_name,',
'       refs',
'  from ( select 1 as item_id,',
'                id,',
'                ''PAGE'' rtype,',
'                theme_id,',
'                name template_name,',
'                ''f?p=4000:4307:&APP_SESSION.::NO:4307:F4000_P4307_ID:''||id as url,',
'                (select count(*) ',
'                   from wwv_flow_templates',
'                  where reference_id = p.id ',
'                    and security_group_id = :flow_security_group_id) refs',
'           from wwv_flow_templates p',
'          where p.flow_id = :fb_flow_id',
'            and p.security_group_id = :flow_security_group_id ',
'            and (p.theme_id = :P727_THEME or :P727_THEME = 0)',
'            and (  :P727_SHOW = ''PAGE''',
'                or replace(:P727_SHOW,''0'',null) is null)',
'          union all',
'         select 3,',
'                id,',
'                ''REGION'' rtype,',
'                theme_id,',
'                page_plug_template_name template_name,',
'                ''f?p=4000:4653:&APP_SESSION.::NO:4653:F4000_P4653_ID:''||id as url,',
'                (select count(*) ',
'                   from wwv_flow_page_plug_templates ',
'                  where reference_id = p.id ',
'                    and security_group_id = :flow_security_group_id) refs',
'           from wwv_flow_page_plug_templates p',
'          where p.flow_id = :fb_flow_id',
'            and p.security_group_id = :flow_security_group_id',
'            and (p.theme_id = :P727_THEME or :P727_THEME = 0)',
'            and (  :P727_SHOW = ''REGION''',
'                or replace(:P727_SHOW,''0'',null) is null)',
'          union all',
'         select 5,',
'                id,',
'                ''REPORT'' rtype,',
'                theme_id,',
'                row_template_name template_name,',
'                ''f?p=4000:4654:&APP_SESSION.::NO:4654:F4000_P4654_ID:''||id as url,',
'                (select count(*) ',
'                   from wwv_flow_row_templates ',
'                  where reference_id = p.id ',
'                    and security_group_id = :flow_security_group_id) refs',
'           from wwv_flow_row_templates p',
'          where p.flow_id = :fb_flow_id',
'            and p.security_group_id = :flow_security_group_id',
'            and (p.theme_id = :P727_THEME or :P727_THEME = 0)',
'            and (  :P727_SHOW = ''REPORT''',
'                or replace(:P727_SHOW,''0'',null) is null)',
'          union all',
'         select 7,',
'                id,',
'                ''LIST'' rtype,',
'                theme_id,',
'                list_template_name template_name,',
'                ''f?p=4000:4655:&APP_SESSION.::NO:4655:F4000_P4655_ID:''||id as url,',
'                (select count(*) ',
'                   from wwv_flow_list_templates ',
'                  where reference_id = p.id ',
'                    and security_group_id = :flow_security_group_id) refs',
'           from wwv_flow_list_templates p',
'          where p.flow_id = :fb_flow_id',
'            and p.security_group_id = :flow_security_group_id',
'            and (p.theme_id = :P727_THEME or :P727_THEME = 0)',
'            and (  :P727_SHOW = ''LIST''',
'                or replace(:P727_SHOW,''0'',null) is null)',
'          union all',
'         select 9,',
'                id,',
'                ''LABEL'' rtype,',
'                theme_id,',
'                template_name,',
'                ''f?p=4000:85:&APP_SESSION.::NO:85:F4000_P85_ID:''||id as url,',
'                (select count(*) ',
'                   from wwv_flow_field_templates ',
'                  where reference_id = p.id ',
'                    and security_group_id = :flow_security_group_id) refs',
'           from wwv_flow_field_templates p',
'          where p.flow_id = :fb_flow_id',
'            and p.security_group_id = :flow_security_group_id',
'            and (p.theme_id = :P727_THEME or :P727_THEME = 0)',
'            and (  :P727_SHOW = ''LABEL''',
'                or replace(:P727_SHOW,''0'',null) is null)',
'          union all',
'         select 11,',
'                id,',
'                ''BUTTON'' rtype,',
'                theme_id,',
'                template_name,',
'                ''f?p=4000:204:&APP_SESSION.::NO:204:F4000_P204_ID:''||id as url,',
'                (select count(*) ',
'                   from wwv_flow_button_templates ',
'                  where reference_id = p.id ',
'                    and security_group_id = :flow_security_group_id) refs',
'           from wwv_flow_button_templates p',
'          where p.flow_id = :fb_flow_id',
'            and p.security_group_id = :flow_security_group_id',
'            and (p.theme_id = :P727_THEME or :P727_THEME = 0)',
'            and (  :P727_SHOW = ''BUTTON''',
'                or replace(:P727_SHOW,''0'',null) is null)',
'          union all',
'         select 13,',
'                id,',
'                ''MENU'' rtype,',
'                theme_id,',
'                name template_name,',
'                ''f?p=4000:289:&APP_SESSION.::NO:289:F4000_P289_ID:''||id as url,',
'                (select count(*) ',
'                   from wwv_flow_menu_templates ',
'                  where reference_id = p.id ',
'                    and security_group_id = :flow_security_group_id) refs',
'           from wwv_flow_menu_templates p',
'          where p.flow_id = :fb_flow_id',
'            and p.security_group_id = :flow_security_group_id',
'            and (p.theme_id = :P727_THEME or :P727_THEME = 0)',
'            and (  :P727_SHOW = ''MENU''',
'                or replace(:P727_SHOW,''0'',null) is null)',
'          union all',
'         select 15,',
'                id,',
'                ''CALENDAR'' rtype,',
'                theme_id,',
'                name template_name,',
'                ''f?p=4000:122:&APP_SESSION.::NO:122:P122_ID:''||id as url,',
'                (select count(*) ',
'                   from wwv_flow_cal_templates ',
'                  where reference_id = p.id ',
'                    and security_group_id = :flow_security_group_id) refs',
'           from wwv_flow_cal_templates p',
'          where p.flow_id = :fb_flow_id',
'            and p.security_group_id = :flow_security_group_id',
'            and (p.theme_id = :P727_THEME or :P727_THEME = 0)',
'            and (  :P727_SHOW = ''CALENDAR''',
'                or replace(:P727_SHOW,''0'',null) is null)',
'          union all',
'         select 17,',
'                id,',
'                ''POPUP_LOV'' rtype,',
'                theme_id,',
'                wwv_flow_lang.system_message(''F4000.P371.POPUP_LOV'') template_name,',
'                ''f?p=4000:251:&APP_SESSION.::NO:251:F4000_P251_ID:''||id as url,',
'                (select count(*) ',
'                   from wwv_flow_popup_lov_template ',
'                  where reference_id = p.id ',
'                    and security_group_id = :flow_security_group_id) refs',
'           from wwv_flow_popup_lov_template p',
'          where p.flow_id = :fb_flow_id',
'            and p.security_group_id = :flow_security_group_id',
'            and (p.theme_id = :P727_THEME or :P727_THEME = 0)',
'            and (  :P727_SHOW = ''POPUP_LOV''',
'                or replace(:P727_SHOW,''0'',null) is null)',
'          union all',
'         select 19,',
'                id,',
'                ''TEMPLATE_COMPONENT'' rtype,',
'                theme_id,',
'                builder_name template_name,',
'                ''f?p=4000:4410:&APP_SESSION.::NO:4410:P4410_ID:''||id as url,',
'                (select count(*) ',
'                   from wwv_flow_template_components ',
'                  where reference_id = p.id ',
'                    and security_group_id = :flow_security_group_id) refs',
'           from wwv_flow_template_components p',
'          where p.flow_id = :fb_flow_id',
'            and p.security_group_id = :flow_security_group_id',
'            and p.theme_id is not null',
'            and (p.theme_id = :P727_THEME or :P727_THEME = 0)',
'            and (  :P727_SHOW = ''TEMPLATE_COMPONENT''',
'                or replace(:P727_SHOW,''0'',null) is null)',
')',
'where refs > 0'))
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No templates available to publish.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(103296932022736910)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>20
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5830327618948623)
,p_query_column_id=>2
,p_column_alias=>'ROW_SELECTOR'
,p_column_display_sequence=>10
,p_column_heading=>'#CHECK_ALL_CHECKBOX#'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5830402203948624)
,p_query_column_id=>3
,p_column_alias=>'TEMPLATE_TYPE'
,p_column_display_sequence=>50
,p_column_heading=>'Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(103325312001610914)
,p_query_column_id=>4
,p_column_alias=>'RTYPE'
,p_column_display_sequence=>90
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(103741322462686546)
,p_query_column_id=>5
,p_column_alias=>'THEME_ID'
,p_column_display_sequence=>60
,p_column_heading=>'Theme'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5830594648948625)
,p_query_column_id=>6
,p_column_alias=>'TEMPLATE_NAME'
,p_column_display_sequence=>70
,p_column_heading=>'Template'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5830692970948626)
,p_query_column_id=>7
,p_column_alias=>'REFS'
,p_column_display_sequence=>80
,p_column_heading=>'References'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:651:&SESSION.::&DEBUG.::P651_REFERENCE_ID,P651_TYPE:#ID#,#RTYPE#'
,p_column_linktext=>'#REFS#'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(94588615153218815)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(94580804933178097)
,p_button_name=>'P727_GO'
,p_button_static_id=>'P727_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Go'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(95285920850974265)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(94580804933178097)
,p_button_name=>'PUBLISH_CHECKED'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Publish Checked'
,p_button_position=>'CREATE'
,p_button_condition=>'P727_DISPLAY_PUBLISH'
,p_button_condition2=>'Y'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(94588821917218816)
,p_branch_action=>'f?p=&APP_ID.:727:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(94585918139210245)
,p_name=>'P727_SHOW'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(94580804933178097)
,p_item_default=>'0'
,p_prompt=>'Show'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TEMPLATE TYPES RETURNING NAME'
,p_lov=>'.'||wwv_flow_imp.id(282026017647000169)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- All Types -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Restrict the results by selecting a template type and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(95247531566826047)
,p_name=>'P727_THEME'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_imp.id(94580804933178097)
,p_item_default=>'0'
,p_prompt=>'Theme'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- All -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a theme and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(103695122996100188)
,p_name=>'P727_DISPLAY_PUBLISH'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(94580804933178097)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1194417838142758807)
,p_validation_name=>'AtLeastOneSelected'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'   wwv_flow.g_f01.count > 0',
'or wwv_flow.g_f02.count > 0',
'or wwv_flow.g_f03.count > 0',
'or wwv_flow.g_f04.count > 0',
'or wwv_flow.g_f05.count > 0',
'or wwv_flow.g_f06.count > 0',
'or wwv_flow.g_f07.count > 0',
'or wwv_flow.g_f08.count > 0',
'or wwv_flow.g_f09.count > 0',
'or wwv_flow.g_f10.count > 0'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'You must select at least one template to publish.'
,p_when_button_pressed=>wwv_flow_imp.id(95285920850974265)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1194417497189758803)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(95255202093864810)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1194417513081758804)
,p_event_id=>wwv_flow_imp.id(1194417497189758803)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(103608501461864052)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'publish templates'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- page',
'for i in 1..wwv_flow.g_f01.count',
'loop',
'  wwv_flow_copy_metadata.push_page_template(p_template_id => wwv_flow.g_f01(i));',
'end loop;',
'-- region',
'for i in 1..wwv_flow.g_f02.count',
'loop',
'  wwv_flow_copy_metadata.push_region_template(p_template_id => wwv_flow.g_f02(i));',
'end loop;',
'-- report',
'for i in 1..wwv_flow.g_f03.count',
'loop',
'  wwv_flow_copy_metadata.push_report_template(p_template_id => wwv_flow.g_f03(i));',
'end loop;',
'-- list',
'for i in 1..wwv_flow.g_f04.count',
'loop',
'  wwv_flow_copy_metadata.push_list_template(p_template_id => wwv_flow.g_f04(i));',
'end loop;',
'-- label',
'for i in 1..wwv_flow.g_f05.count',
'loop',
'  wwv_flow_copy_metadata.push_field_template(p_template_id => wwv_flow.g_f05(i));',
'end loop;',
'-- button',
'for i in 1..wwv_flow.g_f06.count',
'loop',
'  wwv_flow_copy_metadata.push_button_template(p_template_id => wwv_flow.g_f06(i));  ',
'end loop;',
'-- breadcrumb',
'for i in 1..wwv_flow.g_f07.count',
'loop',
'  wwv_flow_copy_metadata.push_menu_template(p_template_id => wwv_flow.g_f07(i));',
'end loop;',
'-- calendar',
'for i in 1..wwv_flow.g_f08.count',
'loop',
'  wwv_flow_copy_metadata.push_calendar_template(p_template_id => wwv_flow.g_f08(i));',
'end loop;',
'-- popup LOV',
'for i in 1..wwv_flow.g_f09.count',
'loop',
'  wwv_flow_copy_metadata.push_popuplov_template(p_template_id => wwv_flow.g_f09(i));  ',
'end loop;',
'-- Template Component',
'for i in 1..wwv_flow.g_f10.count',
'loop',
'  wwv_flow_copy_metadata.push_template_component(p_template_id => wwv_flow.g_f10(i));  ',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error publishing selected templates.'
,p_process_when_button_id=>wwv_flow_imp.id(95285920850974265)
,p_process_success_message=>'Selected templates published.'
,p_internal_uid=>103608501461864052
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(103697000318131434)
,p_process_sequence=>50
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set flag for publish button'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_flag  varchar2(255) := ''N'';',
'  l_theme number := nvl(:P727_THEME,0);',
'begin',
'  if replace(:P727_SHOW,''0'',null) is null then',
'    for c1 in (',
'        select 1 from wwv_flow_templates',
'        where flow_id = :fb_flow_id',
'        and security_group_id = :flow_security_group_id             ',
'        and (theme_id = l_theme or l_theme = 0)',
'        and id in (select reference_id ',
'                   from wwv_flow_templates',
'                   where security_group_id = :flow_security_group_id)      ',
'        union all',
'        select 1 from wwv_flow_page_plug_templates',
'        where flow_id = :fb_flow_id',
'        and security_group_id = :flow_security_group_id             ',
'        and (theme_id = l_theme or l_theme = 0)',
'        and id in (select reference_id ',
'                   from wwv_flow_page_plug_templates',
'                   where security_group_id = :flow_security_group_id)',
'        union all',
'        select 1 from wwv_flow_row_templates',
'        where flow_id = :fb_flow_id',
'        and security_group_id = :flow_security_group_id             ',
'        and (theme_id = l_theme or l_theme = 0)',
'        and id in (select reference_id ',
'                   from wwv_flow_row_templates',
'                   where security_group_id = :flow_security_group_id)  ',
'        union all',
'        select 1 from wwv_flow_list_templates',
'        where flow_id = :fb_flow_id',
'        and security_group_id = :flow_security_group_id             ',
'        and (theme_id = l_theme or l_theme = 0)',
'        and id in (select reference_id ',
'                   from wwv_flow_list_templates',
'                   where security_group_id = :flow_security_group_id)      ',
'        union all',
'        select 1 from wwv_flow_field_templates',
'        where flow_id = :fb_flow_id',
'        and security_group_id = :flow_security_group_id             ',
'        and (theme_id = l_theme or l_theme = 0)',
'        and id in (select reference_id ',
'                   from wwv_flow_field_templates',
'                   where security_group_id = :flow_security_group_id)',
'         union all',
'        select 1 from wwv_flow_button_templates',
'        where flow_id = :fb_flow_id',
'        and security_group_id = :flow_security_group_id             ',
'        and (theme_id = l_theme or l_theme = 0)',
'        and id in (select reference_id ',
'                   from wwv_flow_button_templates',
'                   where security_group_id = :flow_security_group_id) ',
'        union all',
'        select 1 from wwv_flow_menu_templates',
'        where flow_id = :fb_flow_id',
'        and security_group_id = :flow_security_group_id             ',
'        and (theme_id = l_theme or l_theme = 0)',
'        and id in (select reference_id ',
'                   from wwv_flow_menu_templates',
'                   where security_group_id = :flow_security_group_id)',
'        union all',
'        select 1 from wwv_flow_cal_templates',
'        where flow_id = :fb_flow_id',
'        and security_group_id = :flow_security_group_id             ',
'        and (theme_id = l_theme or l_theme = 0)',
'        and id in (select reference_id ',
'                   from wwv_flow_cal_templates',
'                   where security_group_id = :flow_security_group_id)) loop',
'    --',
'        l_flag := ''Y'';',
'    end loop;    ',
'  else',
'    if :P727_SHOW = ''PAGE'' then',
'        for c1 in (select 1 from wwv_flow_templates',
'                   where flow_id = :fb_flow_id',
'                   and security_group_id = :flow_security_group_id             ',
'                   and (theme_id = l_theme or l_theme = 0)',
'                   and id in (select reference_id ',
'                              from wwv_flow_templates',
'                              where security_group_id = :flow_security_group_id))',
'        loop ',
'            l_flag := ''Y''; ',
'        end loop;         ',
'    elsif :P727_SHOW = ''REGION'' then',
'        for c1 in (select 1 from wwv_flow_page_plug_templates',
'                   where flow_id = :fb_flow_id',
'                   and security_group_id = :flow_security_group_id             ',
'                   and (theme_id = l_theme or l_theme = 0)',
'                   and id in (select reference_id ',
'                              from wwv_flow_page_plug_templates',
'                              where security_group_id = :flow_security_group_id))',
'        loop        ',
'            l_flag := ''Y''; ',
'        end loop;        ',
'    elsif :P727_SHOW = ''REPORT'' then',
'        for c1 in (select 1 from wwv_flow_row_templates',
'                   where flow_id = :fb_flow_id',
'                   and security_group_id = :flow_security_group_id             ',
'                   and (theme_id = l_theme or l_theme = 0)',
'                   and id in (select reference_id ',
'                              from wwv_flow_row_templates',
'                              where security_group_id = :flow_security_group_id))',
'        loop        ',
'            l_flag := ''Y''; ',
'        end loop;         ',
'    elsif :P727_SHOW = ''LIST'' then',
'        for c1 in (select 1 from wwv_flow_list_templates',
'                   where flow_id = :fb_flow_id',
'                   and security_group_id = :flow_security_group_id             ',
'                   and (theme_id = l_theme or l_theme = 0)',
'                   and id in (select reference_id ',
'                              from wwv_flow_list_templates',
'                              where security_group_id = :flow_security_group_id))',
'        loop         ',
'            l_flag := ''Y''; ',
'        end loop;         ',
'    elsif :P727_SHOW = ''LABEL'' then',
'        for c1 in (select 1 from wwv_flow_field_templates',
'                   where flow_id = :fb_flow_id',
'                   and security_group_id = :flow_security_group_id             ',
'                   and (theme_id = l_theme or l_theme = 0)',
'                   and id in (select reference_id ',
'                              from wwv_flow_field_templates',
'                              where security_group_id = :flow_security_group_id))',
'        loop ',
'            l_flag := ''Y''; ',
'        end loop;         ',
'    elsif :P727_SHOW = ''BUTTON'' then',
'        for c1 in (select 1 from wwv_flow_button_templates',
'                   where flow_id = :fb_flow_id',
'                   and security_group_id = :flow_security_group_id             ',
'                   and (theme_id = l_theme or l_theme = 0)',
'                   and id in (select reference_id ',
'                              from wwv_flow_button_templates',
'                              where security_group_id = :flow_security_group_id))',
'        loop        ',
'            l_flag := ''Y''; ',
'        end loop;         ',
'    elsif :P727_SHOW = ''MENU'' then',
'        for c1 in (select 1 from wwv_flow_menu_templates',
'                   where flow_id = :fb_flow_id',
'                   and security_group_id = :flow_security_group_id             ',
'                   and (theme_id = l_theme or l_theme = 0)',
'                   and id in (select reference_id ',
'                              from wwv_flow_menu_templates',
'                              where security_group_id = :flow_security_group_id))',
'        loop        ',
'            l_flag := ''Y''; ',
'        end loop;         ',
'    elsif :P727_SHOW = ''CALENDAR'' then',
'        for c1 in (select 1 from wwv_flow_cal_templates',
'                   where flow_id = :fb_flow_id',
'                   and security_group_id = :flow_security_group_id             ',
'                   and (theme_id = l_theme or l_theme = 0)',
'                   and id in (select reference_id ',
'                              from wwv_flow_cal_templates',
'                              where security_group_id = :flow_security_group_id))',
'        loop        ',
'            l_flag := ''Y''; ',
'        end loop;',
'    elsif :P727_SHOW = ''POPUP_LOV'' then',
'        for c1 in (select 1 from wwv_flow_popup_lov_template',
'                   where flow_id = :fb_flow_id',
'                   and security_group_id = :flow_security_group_id             ',
'                   and (theme_id = l_theme or l_theme = 0)',
'                   and id in (select reference_id ',
'                              from wwv_flow_popup_lov_template',
'                              where security_group_id = :flow_security_group_id))',
'        loop        ',
'            l_flag := ''Y''; ',
'        end loop;',
'    elsif :P727_SHOW = ''TEMPLATE_COMPONENT'' then',
'        for c1 in (select 1 from wwv_flow_template_components',
'                   where flow_id = :fb_flow_id',
'                   and security_group_id = :flow_security_group_id',
'                   and theme_id is not null',
'                   and (theme_id = l_theme or l_theme = 0)',
'                   and id in (select reference_id ',
'                                from wwv_flow_template_components',
'                               where security_group_id = :flow_security_group_id',
'                                 and theme_id is not null ))',
'        loop        ',
'            l_flag := ''Y''; ',
'        end loop;  ',
'    end if;    ',
'  end if;',
'  :P727_DISPLAY_PUBLISH := l_flag;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>103697000318131434
);
end;
/
prompt --application/pages/page_00730
begin
wwv_flow_imp_page.create_page(
 p_id=>730
,p_name=>'Create Form and Report on Web Service - Report Parameters'
,p_alias=>'CREATE-FORM-AND-REPORT-ON-WEB-SERVICE-REPORT-PARAMETERS'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Form and Report on Web Service'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript" language="JavaScript1.1">',
'    function ToggleAll(e){	if (e.checked) {	CheckAll();	}',
'    	else {	ClearAll();	}',
'    }',
'    function Check(e){	e.checked = true;}',
'    function Clear(e){	e.checked = false;}',
'    function CheckAll(){	',
'        var ml = document.wwv_flow;	',
'        var len = ml.elements.length;	',
'        for (var i = 0; i < len; i++) {',
'        var e = ml.elements[i];	',
'        if (e.name == "f01" ||e.name == "f03" ||e.name == "f05" || e.name == "f07" || e.name == "f09" ||e.name == "f11" ||e.name == "f13" || e.name == "f15" ) {',
'        Check(e);}',
'        }',
'        ml.f01.checked = true;',
'    }',
'    function ClearAll(){	',
'        var ml = document.wwv_flow;	',
'        var len = ml.elements.length;	',
'        for (var i = 0; i < len; i++) {	',
'          var e = ml.elements[i];	if (e.name == "f01" ||	e.name == "f03" ||e.name == "f05" ||e.name == "f07" ||e.name == "f09" ||e.name == "f11" ||e.name == "f13" ||e.name == "f15" ) {		Clear(e);	}',
'        	}',
'        	ml.f01.checked = false;',
'    }',
'</script>'))
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30098103492544130)
,p_plug_name=>'Wizard Steps'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(30094110886480012)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(30219624868893856)
,p_name=>'Result Parameters to Display'
,p_template=>wwv_flow_imp.id(42025417508627628)
,p_display_sequence=>150
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.checkbox(1,id,''title="''||wwv_flow_lang.system_message(''SELECT_ROW_C'', wwv_flow_escape.html(name))||''"'',:P730_CHECKED_ITEMS) x, ',
'       name, parm_type',
'  from wwv_flow_ws_parameters',
' where type_is_xsd = ''Y''',
'   and parent_id = :P725_ARRAY'))
,p_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the parameters to include in the report.</p>',
'<p>To select or deselect all parameters, select the check box in the column header.</p>',
''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>1000
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(30220326690893876)
,p_query_column_id=>1
,p_column_alias=>'X'
,p_column_display_sequence=>1
,p_column_heading=>'#CHECK_ALL_CHECKBOX#'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(30220402743893876)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(30298709143154335)
,p_query_column_id=>3
,p_column_alias=>'PARM_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Parameter Type'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(204756604983176009)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>160
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30243313187947333)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(204756604983176009)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30238010285936991)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(204756604983176009)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30235927469932529)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(204756604983176009)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(30238408044936997)
,p_branch_action=>'f?p=&FLOW_ID.:725:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(30238010285936991)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(30243718599947334)
,p_branch_name=>'Skip Navigation Menu / Tabs'
,p_branch_action=>'f?p=&FLOW_ID.:735:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(30243313187947333)
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow_wizard_api.page_exists (p_flow_id => :fb_flow_id, p_page_id => :P705_PAGE_ID) = true'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(38828410304413219)
,p_branch_name=>'Navigation Menu / Tabs'
,p_branch_action=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.:RP:P4716_PREV_PAGE_ID:&APP_PAGE_ID.:'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(30243313187947333)
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30287830427046886)
,p_name=>'P730_ARRAY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(30219624868893856)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Result Tree to Report On:'
,p_source=>'P725_ARRAY'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'P725_ARRAYS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name)||'' (''||wwv_flow_escape.html(parm_type)||'')'' d, id r',
'  from wwv_flow_ws_parameters a',
' where type_is_xsd = ''N''',
'   and input_or_output = ''O''',
'   and exists (select 1',
'                 from wwv_flow_ws_parameters',
'                where parent_id = a.id',
'                  and type_is_xsd = ''Y'') ',
'   and ws_opers_id = :P700_OPERATION_ID'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identify tree.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30294217445080992)
,p_name=>'P730_CHECKED_ITEMS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(30219624868893856)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(30304324343205980)
,p_computation_sequence=>10
,p_computation_item=>'P730_CHECKED_ITEMS'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_utilities.table_to_string(wwv_flow.g_f01)'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(38931109545633619)
,p_validation_name=>'P730_CHECKED_ITEMS'
,p_validation_sequence=>10
,p_validation=>'P730_CHECKED_ITEMS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'You must report on at least one parameter.'
,p_validation_condition=>'NEXT,FINISH'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(30294217445080992)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(549741376379954514)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(30235927469932529)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(549741437476954515)
,p_event_id=>wwv_flow_imp.id(549741376379954514)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1157780208270618647)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>20
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(30219624868893856)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1157780392904618648)
,p_event_id=>wwv_flow_imp.id(1157780208270618647)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(30223816126910289)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  i integer;',
'begin',
'  wwv_flow_collection.create_or_truncate_collection(''WS_ARRAY_PARMS'');',
'  for i in 1.. wwv_flow.g_f01.count loop',
'    wwv_flow_collection.add_member(',
'      p_collection_name => ''WS_ARRAY_PARMS'',',
'      p_c001            => wwv_flow.g_f01(i) );',
'  end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>30223816126910289
);
end;
/
prompt --application/pages/page_00733
begin
wwv_flow_imp_page.create_page(
 p_id=>733
,p_name=>'Application Status'
,p_alias=>'APPLICATION-STATUS'
,p_step_title=>'Application Status'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_hm.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(104385823445160068)
,p_plug_name=>'Application Status'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>121
,p_plug_footer=>'<p>This application is installed, but is not editable. Workspace Administrators can change the application status using Workspace Utilities.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(937789234997878617)
,p_plug_name=>'wizard buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>131
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(104398728780246802)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(937789234997878617)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:1500:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1154362780018168265)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(937789234997878617)
,p_button_name=>'RUN'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Run Application'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(104389520852197170)
,p_name=>'P733_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(104385823445160068)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application ID:'
,p_source=>'&FB_FLOW_ID.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the current application number'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(104396317913234157)
,p_name=>'P733_APPLICATION_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(104385823445160068)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application Name:'
,p_source=>'select name from wwv_flows where id = :fb_flow_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the name of the selected application'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1154363471558177955)
,p_name=>'P733_HOME_LINK'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(104385823445160068)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>4000
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1154364092879183971)
,p_computation_sequence=>10
,p_computation_item=>'P733_HOME_LINK'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_dev.get_run_url (p_application_id => :FB_FLOW_ID )'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2109056360185447)
,p_name=>'Run app in new tab'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1154362780018168265)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2109161649185448)
,p_event_id=>wwv_flow_imp.id(2109056360185447)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.builder.launchAppOrPage( $v( "P733_HOME_LINK" ) );'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(133809402516094387)
,p_process_sequence=>10
,p_process_point=>'BEFORE_FOOTER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'unset flow ids'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':FB_FLOW_ID := null;',
':FB_FLOW_PAGE_ID := null;',
':F4000_P1_FLOW := null;',
':F4000_P1_PAGE := null;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>133809402516094387
);
end;
/
prompt --application/pages/page_00734
begin
wwv_flow_imp_page.create_page(
 p_id=>734
,p_name=>'Create List'
,p_alias=>'CREATE-LIST'
,p_page_mode=>'MODAL'
,p_step_title=>'Create List'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_list.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11327922287610512)
,p_plug_name=>'create list train'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(169186610834587350)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11328305829610519)
,p_plug_name=>'Create List'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47256112975729331)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(11328524514610520)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47256112975729331)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(11328700955610522)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(47256112975729331)
,p_button_name=>'create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create List'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(11328911294610522)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(47256112975729331)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(11334732433610564)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(574135415655781510)
,p_branch_action=>'f?p=&APP_ID.:464:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(11328911294610522)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11329116792610523)
,p_name=>'P734_DEPLOY'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(11328305829610519)
,p_prompt=>'Create List Regions?'
,p_source=>'N'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST DEPLOYMENT P529'
,p_lov=>'.'||wwv_flow_imp.id(169222400131754330)||'.'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select whether or not to create a list region on current page.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11329615065610529)
,p_name=>'P734_REGION_POSITION'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(11328305829610519)
,p_prompt=>'Region Position'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE_DISPLAY_POINT'
,p_lov=>'.'||wwv_flow_imp.id(131723061838)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Slot -'
,p_lov_null_value=>'0'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select region position for new region.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11330304845610530)
,p_name=>'P734_ENTRY_QUERY'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(11328305829610519)
,p_use_cache_before_default=>'NO'
,p_prompt=>'List Query'
,p_source=>'P464_QUERY'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_attributes=>'style="white-space:pre;"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The query to be used to generate the list.'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11330531923610530)
,p_name=>'P734_LIST_TEMPLATE_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(11328305829610519)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select default_list_template from wwv_flow_themes ',
'where flow_id = :fb_flow_id ',
'and theme_id = :fb_theme_id',
'and default_list_template is not null) loop',
'',
'   return c1.default_list_template;',
'',
'end loop;',
'',
'return null;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'List Template:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_LIST_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'from   wwv_flow_templates_all',
'where temp_type = ''LIST''',
'and flow_id = :fb_flow_id ',
'and theme_id = :fb_theme_id',
'order by upper(name)'))
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'<div class="htmldbInfoBodyP">The list template to be used to control the appearance of your list.</div>'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11331031778610532)
,p_name=>'P734_LIST_NAME2'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(11328305829610519)
,p_use_cache_before_default=>'NO'
,p_prompt=>'List Name'
,p_source=>'&P427_NAME.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Name of list to be created.'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11333927013610541)
,p_name=>'P734_REGION_TEMPLATE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(11328305829610519)
,p_item_default=>'0'
,p_prompt=>'Region Template'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REGION.TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.d, ',
'       t.r ',
'  from ( select wwv_flow_escape.html(page_plug_template_name) d, ',
'             id r',
'           from wwv_flow_page_plug_templates',
'          where security_group_id = :FLOW_SECURITY_GROUP_ID',
'            and flow_id           = :FB_FLOW_ID',
'            and (:FB_THEME_ID is null or theme_id = :FB_THEME_ID)',
'          order by upper(page_plug_template_name) ) t'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'No Template'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select region template for new region.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(184438131566130150)
,p_validation_name=>'Region Position Must Be Selected'
,p_validation_sequence=>10
,p_validation=>'P734_REGION_POSITION'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'Region Position must be selected.'
,p_validation_condition=>'P734_DEPLOY'
,p_validation_condition2=>'EACH_ENTRY:CURRENT_PAGE'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_when_button_pressed=>wwv_flow_imp.id(11328700955610522)
,p_associated_item=>wwv_flow_imp.id(11329615065610529)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(12835122215749420)
,p_name=>'List Region Creation Settings'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P734_DEPLOY'
,p_condition_element=>'P734_DEPLOY'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'CURRENT_PAGE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(12835422514749425)
,p_event_id=>wwv_flow_imp.id(12835122215749420)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P734_REGION_POSITION,P734_REGION_TEMPLATE,P734_LIST_TEMPLATE_ID'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(12835600998749427)
,p_event_id=>wwv_flow_imp.id(12835122215749420)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P734_REGION_POSITION,P734_REGION_TEMPLATE,P734_LIST_TEMPLATE_ID'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(574135285411781508)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(11328524514610520)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(574135396509781509)
,p_event_id=>wwv_flow_imp.id(574135285411781508)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(11334921984614841)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create dynamic List'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_list_id        number;',
'   l_required_patch number;',
'   l_target_pages   varchar2(4000);',
'',
'',
'   procedure create_list_region (',
'      p_flow_id       in  number default null,',
'      p_page_id       in varchar2 default null,',
'      p_list_id       in number default null,',
'      p_display_point in varchar2 default null,',
'      p_list_name     in varchar2 default null)',
'   is',
'      l_max_seq number default null;',
'      p number;',
'      l_display_point varchar2(30) := ''REGION_POSITION_01'';',
'      l_region_template  number := null;',
'   begin',
'      if p_page_id is null or p_list_id is null then',
'         return;',
'      end if;',
'      if :P734_REGION_TEMPLATE is not null and :P734_REGION_TEMPLATE != ''0'' then',
'         l_region_template := :P734_REGION_TEMPLATE;',
'      end if;',
'      begin',
'         p := p_page_id;',
'      exception when others then',
'         p := null;',
'      end;',
'      if p is null then ',
'         return;',
'      end if;',
'      if p_display_point is not null and p_display_point != ''0'' then',
'         l_display_point := p_display_point;',
'      end if;',
'           ',
'      select nvl(max(PLUG_DISPLAY_SEQUENCE),0) + 10 into l_max_seq',
'      from wwv_flow_page_plugs ',
'      where flow_id = :fb_flow_id and page_id = p;',
'',
'        if l_max_seq is null then',
'           l_max_seq := 10;',
'        end if;',
'      wwv_flow_imp_page.create_page_plug (',
'        p_id                          => wwv_flow_id.next_val,',
'        p_flow_id                     => p_flow_id,',
'        p_page_id                     => p_page_id,',
'        p_plug_name                   => p_list_name,',
'        p_plug_template               => l_region_template,',
'        p_list_template_id            => :P734_LIST_TEMPLATE_ID,',
'        p_plug_display_sequence       => l_max_seq,',
'        p_plug_display_point          =>l_display_point,',
'        p_plug_source                 => null,',
'        p_plug_source_type            => p_list_id,',
'        p_plug_display_when_condition => null,',
'        p_plug_display_when_cond2     => null,',
'        p_plug_display_condition_type => null,',
'        p_plug_required_role          => null,',
'        p_menu_template_id            => null);',
'   end create_list_region;',
'',
'   ',
'',
'begin',
'    --',
'    -- create list',
'    --',
'    l_list_id := wwv_flow_id.next_val;',
' ',
'',
'    begin',
'        l_required_patch := :P427_REQUIRED_PATCH;',
'    exception when others then ',
'        l_required_patch := null;',
'    end;',
'    ',
'    wwv_flow_imp_shared.create_list (',
'            p_id                      => l_list_id,',
'            p_flow_id                 => nv(''FB_FLOW_ID''),',
'            p_name                    => v(''P427_NAME''),',
'            p_list_type               => v(''P464_QUERY_TYPE''),',
'            p_list_query              => v(''P464_QUERY''),',
'            p_list_status             => ''PUBLIC'',',
'            p_required_patch          => l_required_patch);',
'',
'    --',
'    -- create list regions',
'    --',
'    if :P734_DEPLOY = ''CURRENT_PAGE'' then',
'        create_list_region (p_flow_id       => nv(''FB_FLOW_ID''),',
'                            p_page_id       => :fb_flow_page_id, ',
'                            p_list_id       => l_list_id, ',
'                            p_display_point => :P734_REGION_POSITION, ',
'                            p_list_name     => :P427_NAME);',
'    end if;',
'',
'    commit;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error creating dynamic list.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(11328700955610522)
,p_process_success_message=>'Dynamic list created.'
,p_internal_uid=>11334921984614841
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(574135572295781511)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Dynamic list created.'
,p_internal_uid=>574135572295781511
);
end;
/
prompt --application/pages/page_00735
begin
wwv_flow_imp_page.create_page(
 p_id=>735
,p_name=>'Create Form and Report on Web Service - Confirm'
,p_alias=>'CREATE-FORM-AND-REPORT-ON-WEB-SERVICE-CONFIRM'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Form and Report on Web Service'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30075307042239861)
,p_plug_name=>'Form and Report on Web Service Confirmation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wiz_confirm.create_form_on_ws_rpt (',
'    p_flow_id            => :FB_FLOW_ID,',
'    p_region_template    => replace(:P705_REGION_TEMPLATE,''%''||''null%'',null),',
'    p_region_template2   => replace(:P705_REGION_TEMPLATE2,''%''||''null%'',null),',
'    p_report_template    => replace(:P705_REPORT_TEMPLATE,''%''||''null%'',null),',
'    p_page_id            => :P705_PAGE_ID,',
'    p_page_name          => :P705_PAGE_NAME,',
'    p_region_name        => :P705_REGION_NAME,',
'    p_region_name2       => :P705_REGION_NAME2,',
'    p_ws_id              => :P700_WS_ID,    ',
'    p_operation_id       => :P700_OPERATION_ID,    ',
'    p_collection_name    => nvl(nvl(:P725_COLLECTION_NAME,:P882_COLLECTION),:P848_RESULT_COLLECTION),',
'    p_array              => :P725_ARRAY',
'    );'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30075701781239865)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(30094110886480012)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(204755203813166192)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30076913490239872)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(204755203813166192)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30077704485239873)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(204755203813166192)
,p_button_name=>'Finish'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30077323233239873)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(204755203813166192)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(193723405053133699)
,p_branch_name=>'Skip Navigation Menu / Tabs'
,p_branch_action=>'848'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(30077323233239873)
,p_branch_sequence=>5
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.page_exists (p_flow_id => :fb_flow_id, p_page_id => :P705_PAGE_ID) = true',
'and :P700_WEB_REF_TYPE = ''MANUAL'''))
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(194249200055831918)
,p_branch_name=>'Skip Navigation Menu / Tabs'
,p_branch_action=>'882'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(30077323233239873)
,p_branch_sequence=>7
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.page_exists (p_flow_id => :fb_flow_id, p_page_id => :P705_PAGE_ID) = false',
'and :P700_WEB_REF_TYPE = ''REST'''))
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(30079406373239877)
,p_branch_name=>'Skip Navigation Menu / Tabs'
,p_branch_action=>'730'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(30077323233239873)
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow_wizard_api.page_exists (p_flow_id => :fb_flow_id, p_page_id => :P705_PAGE_ID) = true'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(38842117156509792)
,p_branch_name=>'Navigation Menu / Tabs'
,p_branch_action=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(30077323233239873)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(404572337440870613)
,p_validation_name=>'Validate Group Name'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_utilities.is_valid_page_group_name (',
'  p_name => :P705_GROUP_NAME);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P705_GROUP_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(30077704485239873)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(549741500110954516)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(30076913490239872)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(549741605048954517)
,p_event_id=>wwv_flow_imp.id(549741500110954516)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(30078215150239874)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Form on Web Service'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_array_parm varchar2(4000) := null;',
'  l_report_collection_name varchar2(4000) := null;',
'begin',
'  if :P705_IS_REST = ''Y'' then',
'    l_report_collection_name := :P882_COLLECTION;',
'  elsif :P700_WEB_REF_TYPE = ''MANUAL'' then',
'    l_report_collection_name := :P848_RESULT_COLLECTION;',
'  else',
'    l_array_parm := :P725_ARRAY;',
'    l_report_collection_name := :P725_COLLECTION_NAME;',
'  end if;',
'',
'  wwv_flow_wizard_api.create_form_on_ws_rpt (',
'    p_flow_id                  => :FB_FLOW_ID,',
'    p_page_id                  => :P705_PAGE_ID,',
'    p_ws_id                    => :P700_WS_ID,',
'    p_operation_id             => :P700_OPERATION_ID,',
'    p_page_name                => :P705_PAGE_NAME,',
'    p_group_name               => :P705_GROUP_NAME,',
'    p_page_mode                => :P705_PAGE_MODE,',
'    --',
'    p_tab_set                  => :P4716_TAB_SET,',
'    p_tab_name                 => :P4716_TAB_NAME,',
'    p_tab_text                 => :P4716_TAB_LABEL,',
'    --',
'    p_nav_list_id              => :P4716_NAVLIST_ID,',
'    p_nav_list_parent_item_id  => :P4716_NAVLIST_PARENT_ID,',
'    p_nav_list_child_item_name => :P4716_NAVLIST_ENTRY_NAME,',
'    --',
'    p_result_node              => :P842_NODE_PATH,',
'    p_soap_style               => :P842_SOAP_STYLE,',
'    p_message_format           => :P842_MESSAGE_FORMAT,',
'    p_namespace                => :P842_MESSAGE_NAMESPACE,',
'    --',
'    p_region_title             => :P705_REGION_NAME,',
'    p_region_template          => :P705_REGION_TEMPLATE,    ',
'    p_region_title2            => :P705_REGION_NAME2,',
'    p_region_template2         => :P705_REGION_TEMPLATE2,  ',
'    p_report_template          => :P705_REPORT_TEMPLATE,',
'    p_inputs_collection        => ''WS_INPUT_ITEMS'',',
'    p_auth_collection          => ''WS_AUTH_ITEMS'',',
'    p_array_parm               => l_array_parm,',
'    p_report_collection_name   => l_report_collection_name,',
'    p_array_parms_collection   => ''WS_ARRAY_PARMS'' );',
'',
'  :fb_flow_page_id := :P705_PAGE_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error creating form on a web service.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(30077704485239873)
,p_process_success_message=>'Form on a web service created successfully.'
,p_internal_uid=>30078215150239874
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(122099829969039336)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create breadcrumb'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_wizard_api.create_breadcrumb_region (',
'        p_application_id             => :FB_FLOW_ID,',
'        p_page_id                    => :P705_PAGE_ID,',
'        p_seq                        => 10,',
'        p_breadcrumb_id              => :P705_BREADCRUMB_ID,',
'        p_breadcrumb_entry_name      => nvl(:P705_BREADCRUMB_NAME, :P705_PAGE_NAME),',
'        p_parent_breadcrumb_entry_id => :P705_BREADCRUMB_PARENT_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(30077704485239873)
,p_internal_uid=>122099829969039336
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(549741743753954518)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,REQUEST'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>549741743753954518
);
end;
/
prompt --application/pages/page_00736
begin
wwv_flow_imp_page.create_page(
 p_id=>736
,p_name=>'Manage Application Group Assignments'
,p_alias=>'MANAGE-APPLICATION-GROUP-ASSIGNMENTS'
,p_step_title=>'Manage Application Group Assignments'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_appgroup.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(92250713575351601)
,p_plug_name=>'Finder Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>91
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(92255713144370366)
,p_name=>'Applications'
,p_template=>wwv_flow_imp.id(208928010704475743)
,p_display_sequence=>130
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'   htmldb_item.checkbox2(1,id,null,null,'':'',''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0''),wwv_flow_lang.system_message(''ASSIGN_LABEL'',wwv_flow_escape.html(name))) id, ',
'   id app_id,',
'  ''f?p=4000:1:''||:app_session||',
'     ''::''||:DEBUG||',
'    '':RP:FB_FLOW_ID,F4000_P1_FLOW,P0_FLOWPAGE:''||',
'    f.id||'',''||f.id||'','' link,',
'  name,',
'  owner,',
'  f.LAST_UPDATED_ON,',
'  f.group_id,',
'decode(group_id,null,null,(select max(group_name) n from wwv_flow_application_groups where id = f.group_id)) Groupname,',
'  alias',
'from   wwv_flow_visible_flows f,',
'       (select wwv_flow_lang.system_message(''RUN'') run from dual) sm',
' where build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'   and (   :P736_FIND is null',
'        or instr(upper(name),upper(:P736_FIND)) > 0',
'        or instr(upper(alias),upper(:P736_FIND)) > 0',
'        or instr(id,:P736_FIND) > 0 )',
'   and (   nvl(:P736_GROUP,0) = 0',
'        or group_id = :P736_GROUP',
'        or (group_id is null and nvl(:P736_GROUP,0)=-1))',
'   and (   nvl(:P736_SHOW,''0'')=''0''',
'        or (group_id is null and :P736_SHOW = ''UNASSIGNED'')',
'        or (group_id is not null and :P736_SHOW = ''ASSIGNED''))'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No Applications found.'
,p_query_num_rows_item=>'P736_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(92256015164370370)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Assign'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(92274923805468086)
,p_query_column_id=>2
,p_column_alias=>'APP_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Application'
,p_use_as_row_header=>'N'
,p_column_hit_highlight=>'&P736_FIND.'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(92256130607370371)
,p_query_column_id=>3
,p_column_alias=>'LINK'
,p_column_display_sequence=>2
,p_column_heading=>'Link'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(92256225634370371)
,p_query_column_id=>4
,p_column_alias=>'NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Application Name'
,p_use_as_row_header=>'N'
,p_column_hit_highlight=>'&P736_FIND.'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(92256302133370371)
,p_query_column_id=>5
,p_column_alias=>'OWNER'
,p_column_display_sequence=>7
,p_column_heading=>'Owner'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(92256422310370371)
,p_query_column_id=>6
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>8
,p_column_heading=>'Updated'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(92256522814370371)
,p_query_column_id=>7
,p_column_alias=>'GROUP_ID'
,p_column_display_sequence=>9
,p_column_heading=>'Group ID'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(92256609920370371)
,p_query_column_id=>8
,p_column_alias=>'GROUPNAME'
,p_column_display_sequence=>6
,p_column_heading=>'Group'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(95849815608881641)
,p_query_column_id=>9
,p_column_alias=>'ALIAS'
,p_column_display_sequence=>5
,p_column_heading=>'Alias'
,p_use_as_row_header=>'N'
,p_column_hit_highlight=>'&P736_FIND.'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(92315813481644870)
,p_plug_name=>'New Group'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>95
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(95832517976778251)
,p_plug_name=>'Application Groups'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>To search for an application, enter a case insensitive query for application name, alias or ID, select an application group, or select to display assigned, unassigned or all applications and then click <strong>Set</strong>.</p>',
'<p>To reassign an application to a new group, select a new group, select the applications, and click <strong>Assign Checked</strong>. To remove an application from an application group, select <strong>Unassign</strong>, select the application, then c'
||'lick <strong>Assign Checked</strong>.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(92254517861362245)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(92250713575351601)
,p_button_name=>'P736_GO'
,p_button_static_id=>'P736_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Set'
,p_button_alignment=>'LEFT'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(92286728269516607)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(92315813481644870)
,p_button_name=>'ASSIGN_SELECTED'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Assign Checked'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(92254732632362246)
,p_branch_action=>'f?p=&APP_ID.:736:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(92251621540353921)
,p_name=>'P736_FIND'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(92250713575351601)
,p_prompt=>'Application'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'To search for an application, enter a case insensitive query for the application name, alias, or ID and click <strong>Set</strong>. To view all applications, leave the field blank and click <strong>Set</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(92253308857359677)
,p_name=>'P736_GROUP'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(92250713575351601)
,p_prompt=>'Group'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'select group_name, id from wwv_flow_application_groups where security_group_id = :flow_security_group_id order by upper(group_name)'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- All -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Narrow the display by selecting an application group and clicking <strong>Set</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(92262622756392113)
,p_name=>'P736_ROWS'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_imp.id(92250713575351601)
,p_item_default=>'15'
,p_prompt=>'Rows'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAXIMUM ROWS PER PAGE'
,p_lov=>'.'||wwv_flow_imp.id(84800803131139158)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'U'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the number of applications to display and click <strong>Set</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(92269803803443316)
,p_name=>'P736_SHOW'
,p_item_sequence=>22
,p_item_plug_id=>wwv_flow_imp.id(92250713575351601)
,p_item_default=>'0'
,p_prompt=>'Show'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APP GROUPS ASSIGNED UNASSIGNED'
,p_lov=>'.'||wwv_flow_imp.id(92271115231446627)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'To filter the display, make a selection and then click <strong>Set</strong>. Available options include <strong>All</strong>, <strong>Assigned</strong>, and <strong>Unassigned</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(92318613265654258)
,p_name=>'P736_NEW_GROUP'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(92315813481644870)
,p_prompt=>'New Group'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'select group_name, id from wwv_flow_application_groups where security_group_id = :flow_security_group_id order by upper(group_name)'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Unassign -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'To assign an application to a group:',
'<ol>',
'<li>From New Group, select an application group.</li>',
'<li>Select the applications to assign.</li>',
'<li>Click <strong>Assign Checked</strong>.</li>',
'</ol>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(94702412176353303)
,p_validation_name=>'Must have selected something'
,p_validation_sequence=>10
,p_validation=>'wwv_flow.g_f01.count > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'You must make a selection to perform this action.'
,p_when_button_pressed=>wwv_flow_imp.id(92286728269516607)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(92291905806538512)
,p_process_sequence=>1
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'assign checked'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_id number;',
'begin',
'    for i in 1..wwv_flow.g_f01.count loop',
'        l_id := wwv_flow.g_f01(i);',
'        for c1 in ( select id ',
'                      from wwv_flow_visible_flows f',
'                     where f.id = l_id',
'                       and f.build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') )',
'        loop',
'            if :P736_NEW_GROUP = 0 then',
'                update wwv_flows ',
'                   set group_id = null',
'                 where id = c1.id;',
'            else',
'                update wwv_flows ',
'                   set group_id = :P736_NEW_GROUP ',
'                 where id = c1.id;',
'            end if;',
'        end loop;',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unexpected Error'
,p_process_when_button_id=>wwv_flow_imp.id(92286728269516607)
,p_process_when=>'P736_NEW_GROUP'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_process_success_message=>'Application Group Assigned.'
,p_internal_uid=>92291905806538512
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(92257016607371390)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when_button_id=>wwv_flow_imp.id(92254517861362245)
,p_internal_uid=>92257016607371390
);
end;
/
prompt --application/pages/page_00737
begin
wwv_flow_imp_page.create_page(
 p_id=>737
,p_name=>'Theme Counts by Application'
,p_alias=>'THEME-COUNTS-BY-APPLICATION'
,p_step_title=>'Theme Counts by Application'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1311312734739365)
,p_plug_name=>'Template Defaults by Application'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>130
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select application_id,',
'       application_name,',
'       theme_count,',
'       (select theme_name||'' - ''||theme_id from wwv_flow_themes where flow_id = x.application_id and theme_id = (select theme_id from wwv_flows where id = x.application_id)) default_theme,',
'(select count(*) from wwv_flow_steps where flow_id = x.application_id) application_pages',
'from',
'(',
'select f.id application_id, ',
'       f.name application_name,',
'       count(*) theme_count',
'  from wwv_flow_visible_flows f,',
'       wwv_flow_themes t',
' where f.id                = t.flow_id',
'   and f.security_group_id = t.security_group_id',
'   and f.build_status      != ''RUN_AND_HIDDEN''',
' group by f.id, ',
'          f.name',
') x'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(1311413219739365)
,p_name=>'Template Defaults by Application'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1311610011739366)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Application'
,p_column_link=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:RP,1:FB_FLOW_ID,F4000_P1_FLOW:#APPLICATION_ID#,#APPLICATION_ID#'
,p_column_linktext=>'#APPLICATION_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1311723031739367)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Application Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1311902498739367)
,p_db_column_name=>'DEFAULT_THEME'
,p_display_order=>3
,p_column_identifier=>'D'
,p_column_label=>'Default Theme'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1312007263739367)
,p_db_column_name=>'APPLICATION_PAGES'
,p_display_order=>4
,p_column_identifier=>'E'
,p_column_label=>'Application Pages'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1311814832739367)
,p_db_column_name=>'THEME_COUNT'
,p_display_order=>5
,p_column_identifier=>'C'
,p_column_label=>'Theme Count'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(1313003271743214)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1291028126536644'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'APPLICATION_ID:APPLICATION_NAME:APPLICATION_PAGES:DEFAULT_THEME:THEME_COUNT:'
,p_sort_column_1=>'APPLICATION_ID'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(702956070640535886)
,p_plug_name=>'Cross Application Reports'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>140
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(702923103587108064)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(139375331345217843)
,p_branch_action=>'f?p=&FLOW_ID.:737:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
end;
/
prompt --application/pages/page_00748
begin
wwv_flow_imp_page.create_page(
 p_id=>748
,p_name=>'Purge Debug'
,p_alias=>'PURGE-DEBUG'
,p_step_title=>'Purge Debug'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(624017424320959563)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(624022903012982746)
,p_plug_name=>'Purge Debug Message Data'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>30
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(624022717079977350)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(624017424320959563)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Purge'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(624017621421959564)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(624017424320959563)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:666:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(624022016854959581)
,p_branch_action=>'f?p=&APP_ID.:666:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(624018203447959566)
,p_name=>'P748_PAGE_VIEW_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(624022903012982746)
,p_prompt=>'View Identifier'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>12
,p_cMaxlength=>100
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Input the debug message page view identifier. The view identifiers are listed on the Debug page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(624025112540023370)
,p_name=>'P748_PURGE_OPTION'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(624022903012982746)
,p_item_default=>'ALL'
,p_prompt=>'Purge Option:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'PURGE_DEBUG_OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(624047408693069523)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the appropriate option to purge debug message data for the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(624025606353049983)
,p_name=>'P748_AGE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(624022903012982746)
,p_item_default=>'1'
,p_prompt=>'Older than'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PURGE_DEBUG_AGE'
,p_lov=>'.'||wwv_flow_imp.id(624059001579304056)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select how many days or weeks of debug message data you wish to purge for the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(624051020168101221)
,p_validation_name=>'P748_PAGE_VIEW_ID'
,p_validation_sequence=>20
,p_validation=>'P748_PAGE_VIEW_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P748_PURGE_OPTION'
,p_validation_condition2=>'IDENTIFIER'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(624022717079977350)
,p_associated_item=>wwv_flow_imp.id(624018203447959566)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(624028804406058827)
,p_name=>'Hide options'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P748_PURGE_OPTION'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(624029129584058828)
,p_event_id=>wwv_flow_imp.id(624028804406058827)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P748_AGE,P748_PAGE_VIEW_ID'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(624046026916065410)
,p_name=>'Show Age'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P748_PURGE_OPTION'
,p_condition_element=>'P748_PURGE_OPTION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'AGE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(624046315566065411)
,p_event_id=>wwv_flow_imp.id(624046026916065410)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P748_AGE'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(624046522941065412)
,p_event_id=>wwv_flow_imp.id(624046026916065410)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P748_AGE'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(624049628563084744)
,p_name=>'Show Identifier'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P748_PURGE_OPTION'
,p_condition_element=>'P748_PURGE_OPTION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'IDENTIFIER'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(624049906496084745)
,p_event_id=>wwv_flow_imp.id(624049628563084744)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P748_PAGE_VIEW_ID'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(624050131052084745)
,p_event_id=>wwv_flow_imp.id(624049628563084744)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P748_PAGE_VIEW_ID'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(624054125755131221)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Purge Data'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'BEGIN',
'  IF :P748_PURGE_OPTION = ''ALL'' THEN',
'    wwv_flow_debug.remove_debug_by_app(p_application_id => :FB_FLOW_ID);',
'  ELSIF :P748_PURGE_OPTION = ''SESSION'' THEN',
'    wwv_flow_debug.remove_session_messages(p_session => :FLOW_SESSION_ID);',
'  ELSIF :P748_PURGE_OPTION = ''AGE'' THEN',
'    wwv_flow_debug.remove_debug_by_age(  p_application_id => :FB_FLOW_ID',
'                                       , p_older_than_days => :P748_AGE);',
'  ELSIF :P748_PURGE_OPTION = ''IDENTIFIER'' THEN',
'    wwv_flow_debug.remove_debug_by_view(  p_application_id => :FB_FLOW_ID',
'                                        , p_view_id => :P748_PAGE_VIEW_ID);',
'  END IF; ',
'END;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>624054125755131221
);
end;
/
prompt --application/pages/page_00756
begin
wwv_flow_imp_page.create_page(
 p_id=>756
,p_name=>'Edit Workspace Theme'
,p_alias=>'EDIT-WORKSPACE-THEME'
,p_page_mode=>'MODAL'
,p_step_title=>'Edit Workspace Theme'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'ui_themes_public.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(136594104464406175)
,p_plug_name=>'Workspace Theme'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(231659227043936677)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747145339825138170)
,p_plug_name=>'Edit Workspace Theme'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(136594628781406177)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(231659227043936677)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(136594327822406176)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(231659227043936677)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'CREATE'
,p_button_condition=>'P756_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(136594408964406176)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(231659227043936677)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'javascript:confirmDelete(htmldb_delete_message,''DELETE'');'
,p_button_condition=>'P756_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1429075666603875902)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(231659227043936677)
,p_button_name=>'REFRESH'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Refresh Theme'
,p_button_position=>'EDIT'
,p_button_condition=>'P756_REFERENCE_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(136595100102406181)
,p_branch_name=>'Go To Page 763'
,p_branch_action=>'f?p=&APP_ID.:763:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1429075814189875904)
,p_branch_name=>'Refresh'
,p_branch_action=>'f?p=&APP_ID.:756:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(1429075666603875902)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(136595322825406182)
,p_name=>'P756_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(136594104464406175)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(136595528231406195)
,p_name=>'P756_THEME_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(136594104464406175)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Workspace Theme ID'
,p_source=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(136595900066406196)
,p_name=>'P756_THEME_NAME'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(136594104464406175)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Workspace Theme Name'
,p_source=>'THEME_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the workspace theme.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(136596300441406198)
,p_name=>'P756_THEME_DESCRIPTION'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(136594104464406175)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Description'
,p_source=>'THEME_DESCRIPTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'A short description of the theme.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1429075997513875905)
,p_name=>'P756_MASTER_THEME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(136594104464406175)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Master Theme'
,p_source=>'select theme_id || '' - '' || theme_name from wwv_flow_themes where id = :P756_REFERENCE_ID'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'P756_REFERENCE_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1814103094910228111)
,p_name=>'P756_REFERENCE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(136594104464406175)
,p_use_cache_before_default=>'NO'
,p_source=>'REFERENCE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1815997288324671101)
,p_name=>'P756_MASTER_APPLICATION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(136594104464406175)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Master Application'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select f.id || '' - '' || f.name ',
'from wwv_flow_themes t, wwv_flows f ',
'where t.id = :P756_REFERENCE_ID',
'and t.flow_id = f.id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'P756_REFERENCE_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(136595826300406196)
,p_validation_name=>'P756_THEME_ID not null'
,p_validation_sequence=>10
,p_validation=>'P756_THEME_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Theme Id must have some value.'
,p_associated_item=>wwv_flow_imp.id(136595528231406195)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(136596219162406197)
,p_validation_name=>'P756_THEME_NAME not null'
,p_validation_sequence=>20
,p_validation=>'P756_THEME_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Theme Name must have some value.'
,p_associated_item=>wwv_flow_imp.id(136595900066406196)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(887629385220273328)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(136594628781406177)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(887629454425273329)
,p_event_id=>wwv_flow_imp.id(887629385220273328)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1815997320922671102)
,p_name=>'Submit Refresh'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1429075666603875902)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1815997468500671103)
,p_event_id=>wwv_flow_imp.id(1815997320922671102)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(136596620130406198)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_THEMES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_THEMES'
,p_attribute_03=>'P756_ID'
,p_attribute_04=>'ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Unable to fetch row.'
,p_internal_uid=>136596620130406198
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(136604929183422809)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'apply changes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_theme_manager.change_workspace_theme (',
'   p_id               => :p756_ID,',
'   p_theme_name       => :P756_THEME_NAME,',
'   p_theme_number     => :P756_THEME_ID,',
'   p_theme_desc       => :P756_THEME_DESCRIPTION);'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(136594327822406176)
,p_process_success_message=>'Action Processed'
,p_internal_uid=>136604929183422809
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(136632316865580069)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete theme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_theme_manager.delete_workspace_theme (',
'p_id=>:P756_ID);'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(136594408964406176)
,p_process_success_message=>'Action Processed'
,p_internal_uid=>136632316865580069
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1429075777767875903)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_theme (',
'    p_master_theme_id      => :P756_REFERENCE_ID,',
'    p_subscribing_theme_id => :P756_ID',
');'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error refreshing theme'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1429075666603875902)
,p_process_success_message=>'Theme refreshed'
,p_internal_uid=>1429075777767875903
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(887629292092273327)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'REFRESH'
,p_process_when_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_internal_uid=>887629292092273327
);
end;
/
prompt --application/pages/page_00759
begin
wwv_flow_imp_page.create_page(
 p_id=>759
,p_name=>'Create Report Page'
,p_alias=>'CREATE-REPORT-PAGE'
,p_page_mode=>'MODAL'
,p_step_title=>'&P759_REPORT_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(93464502376707648)
,p_javascript_code_onload=>'apex.util.getTopApex().jQuery(".ui-dialog--apex .ui-dialog-title").text($v("P759_REPORT_TITLE"));'
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_rpt.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44390123981733271)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(92704600017846940)
,p_plug_name=>'Create &P759_REPORT_TITLE.'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(92838415529885430)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(92836304316872750)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(92706216163846947)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(44390123981733271)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(92706428338846949)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(44390123981733271)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(573462085456480668)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_imp.id(44390123981733271)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:2500:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(92712704681846963)
,p_branch_name=>'Navigation Menu / Tabs'
,p_branch_action=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.:RP:P4716_PREV_PAGE_ID:&APP_PAGE_ID.:&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(92706428338846949)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(92712924306846964)
,p_branch_name=>'Breadcrumb Selection'
,p_branch_action=>'f?p=&APP_ID.:759:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>90
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'P759_BREADCRUMB_ID'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(45248916207599281)
,p_name=>'P759_PAGE_MODE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(92704600017846940)
,p_item_default=>'NORMAL'
,p_prompt=>'Page Mode'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DIALOG_PAGE_MODE_CREATE_WIZARD'
,p_lov=>'.'||wwv_flow_imp.id(1497542689968615899)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_user_interface_dev.dialog_page_template_exists(',
'                     p_application_id    => :FB_FLOW_ID );'))
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Identify the page mode, based on the following options: <p/>',
'<ul>',
'<li><strong>Normal</strong>: The page is presented as a normal &PRODUCT_NAME. application page.</li>',
'<li><strong>Modal Dialog</strong>: The page is presented as a modal dialog. A modal dialog is an overlay window positioned within the viewport, which remains active and focused until the end user dismisses (closes) it. The underlying page is grayed o'
||'ut and the end user is prevented from interacting with the rest of the page until the dialog is closed.</li></ul>',
'<br><p>',
'Note that the Modal Dialog option will only be available for selection where the current application theme contains at least one page template of template type <strong>Dialog Page</strong>.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
,p_attribute_04=>'VERTICAL'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(92706609822846949)
,p_name=>'P759_PAGE_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(92704600017846940)
,p_prompt=>'Page Number'
,p_source=>'wwv_flow_utilities.minimum_free_page(:FB_FLOW_ID,1)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>30
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.page_exists (',
'    p_flow_id => :FB_FLOW_ID,',
'    p_page_id => :P759_PAGE_ID)'))
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'If you identify a new page number, the wizard creates a new page.<p />',
'',
'If you identify an existing page number, the wizard adds the component to that page.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(92707119545846952)
,p_name=>'P759_PAGE_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(92704600017846940)
,p_prompt=>'Page Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify a name for the page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(92707618796846953)
,p_name=>'P759_FLOW'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(92704600017846940)
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_help_text=>'Identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(92708116627846953)
,p_name=>'P759_BREADCRUMB_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(92704600017846940)
,p_item_default=>'0'
,p_prompt=>'Breadcrumb'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION.MENUS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name,',
'       id',
'  from wwv_flow_menus',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- do not use breadcrumbs on page -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select whether you want to use a breadcrumb navigation control on your page, and which breadcrumb navigation control you want to use.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(92708618504846954)
,p_name=>'P759_BREADCRUMB_NAME'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(92704600017846940)
,p_prompt=>'Entry Name'
,p_source=>'P759_PAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify the name of the breadcrumb entry.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(211132023275312611)
,p_name=>'P759_REPORT_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(92704600017846940)
,p_item_default=>'WEBSERVICE'
,p_prompt=>'Type'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'CREATE_PAGE_WIZ_REPORT_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(229526604906633214)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(253076828128538027)
,p_name=>'P759_REPORT_TITLE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(92704600017846940)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(381538927206153789)
,p_name=>'P759_BREADCRUMB_PARENT_ID'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(92704600017846940)
,p_prompt=>'Parent Entry'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov_language=>'PLSQL'
,p_lov=>'return wwv_flow_4000_ui.breadcrumb_parent_lov_sql( p_breadcrumb_item_name => ''P759_BREADCRUMB_ID'' )'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'No parent entry'
,p_lov_cascade_parent_items=>'P759_BREADCRUMB_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(403490885667351046)
,p_name=>'P759_GROUP_NAME'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(92704600017846940)
,p_display_as=>'NATIVE_HIDDEN'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id'))
,p_display_when_type=>'EXISTS'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the name of the page group you would like to associate with this page. ',
'  Page groups help developers identify and manage the pages within an application.</p>',
'<p>Note: To create Page Groups go to <strong>Utilities: Page Groups</strong> under Page Specific Utilities in the right side bar.</p>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1940930769336683734)
,p_computation_sequence=>20
,p_computation_item=>'P4716_NAVLIST_ENTRY_NAME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P759_PAGE_NAME'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(427932604455364939)
,p_computation_sequence=>10
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.get_current_theme_id (',
'    p_application_id    => :FB_FLOW_ID )'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(253076931760538028)
,p_computation_sequence=>20
,p_computation_item=>'P759_REPORT_TITLE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_title varchar(255);',
'begin',
'  if :P2500_PAGE_TYPE = ''WEBSERVICE'' then',
'     l_title := wwv_flow_lang.system_message(''WIZARD.CREATE.PAGE.WEBSERVICE'');',
'  else',
'     l_title := wwv_flow_lang.system_message(''WIZARD.CREATE.PAGE.REPORT'');',
'  end if;',
'  return l_title;',
'end;'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(721860869980555234)
,p_computation_sequence=>30
,p_computation_item=>'P759_PAGE_MODE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return wwv_flow_page_dev.get_page_mode(p_application_id => :FB_FLOW_ID, p_page_id => :P759_PAGE_ID);'
,p_compute_when=>'P759_PAGE_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(92711920286846960)
,p_validation_name=>'Page ID Not Null'
,p_validation_sequence=>10
,p_validation=>'P759_PAGE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Page ID must be specified.'
,p_associated_item=>wwv_flow_imp.id(92706609822846949)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(92712130932846961)
,p_validation_name=>'Page Name Not Null'
,p_validation_sequence=>20
,p_validation=>'P759_PAGE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Page Name must be specified.'
,p_validation_condition=>'select 1 from wwv_flow_steps where flow_id = :fb_flow_id and id = :P759_PAGE_ID'
,p_validation_condition_type=>'NOT_EXISTS'
,p_associated_item=>wwv_flow_imp.id(92707119545846952)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'Only verify page names for new pages.'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(92712320077846961)
,p_validation_name=>'P759_BREADCRUMB_NAME'
,p_validation_sequence=>30
,p_validation=>'P759_BREADCRUMB_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Breadcrumb entry name must be specified.'
,p_validation_condition=>'P759_BREADCRUMB_ID'
,p_validation_condition_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_when_button_pressed=>wwv_flow_imp.id(92706428338846949)
,p_associated_item=>wwv_flow_imp.id(92708618504846954)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(481362002157042306)
,p_validation_name=>'P759_PAGE_ID positive, whole number'
,p_validation_sequence=>70
,p_validation=>'trunc(abs(:P759_PAGE_ID)) = :P759_PAGE_ID'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Page Number must be a positive, whole number.'
,p_when_button_pressed=>wwv_flow_imp.id(92706428338846949)
,p_associated_item=>wwv_flow_imp.id(92706609822846949)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(403491318436353486)
,p_validation_name=>'Validate Group Name'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_utilities.is_valid_page_group_name (',
'  p_name => :P759_GROUP_NAME);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P759_GROUP_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(92706428338846949)
,p_associated_item=>wwv_flow_imp.id(403490885667351046)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(381544407876249072)
,p_name=>'breadcrumb options'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P759_BREADCRUMB_ID'
,p_condition_element=>'P759_BREADCRUMB_ID'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(381544708425249076)
,p_event_id=>wwv_flow_imp.id(381544407876249072)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P759_BREADCRUMB_PARENT_ID,P759_BREADCRUMB_NAME'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(381544997823249080)
,p_event_id=>wwv_flow_imp.id(381544407876249072)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P759_BREADCRUMB_PARENT_ID,P759_BREADCRUMB_NAME'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(549742250903954523)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(92706216163846947)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(549742334719954524)
,p_event_id=>wwv_flow_imp.id(549742250903954523)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(721860922904555235)
,p_name=>'Page Exists'
,p_event_sequence=>50
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.page_exists (',
'    p_flow_id => :FB_FLOW_ID,',
'    p_page_id => :P759_PAGE_ID)'))
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(721861042833555236)
,p_event_id=>wwv_flow_imp.id(721860922904555235)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P759_PAGE_MODE,P759_GROUP_NAME,P759_PAGE_NAME,P759_BREADCRUMB_ID,P759_BREADCRUMB_PARENT_ID,P759_BREADCRUMB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(651390457588654203)
,p_name=>'set breadcrumb name'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P759_PAGE_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(651390513563654204)
,p_event_id=>wwv_flow_imp.id(651390457588654203)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P759_BREADCRUMB_NAME'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P759_PAGE_NAME'
,p_attribute_07=>'P759_PAGE_NAME'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
end;
/
prompt --application/pages/page_00762
begin
wwv_flow_imp_page.create_page(
 p_id=>762
,p_name=>'Create Workspace Theme'
,p_alias=>'CREATE-WORKSPACE-THEME'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Workspace Theme'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(113748409598274541)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12511519296310366)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_themes_public.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(113593917826945781)
,p_plug_name=>'Create Workspace Theme'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(114836329343856450)
,p_plug_name=>'Progress'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(114829600122838504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(208150609528655110)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(113595526830948373)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(208150609528655110)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:763:&SESSION.::&DEBUG.:RP:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(113595911048948373)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(208150609528655110)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Workspace Theme'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(114803003922764001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(208150609528655110)
,p_button_name=>'REPLACE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Replace Workspace Theme'
,p_button_position=>'CREATE'
,p_button_condition=>'P753_CREATE_OR_REPLACE'
,p_button_condition2=>'REPLACE'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_required_patch=>wwv_flow_imp.id(170786031904296885)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(113595710630948373)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(208150609528655110)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:789:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(114771108321632793)
,p_branch_name=>'Go To Page 260'
,p_branch_action=>'f?p=&APP_ID.:763:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114743605495527921)
,p_name=>'P762_THEME_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(113593917826945781)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Theme Name:'
,p_source=>'&P789_THEME_NAME.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the name of the workspace theme.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114744410689529384)
,p_name=>'P762_THEME_NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(113593917826945781)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Theme Number:'
,p_source=>'&P789_THEME_NUMBER.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the theme number of the workspace theme.  These numbers are used to uniquely identify a theme within a workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(114769930700629816)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create workspace theme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_theme_manager.create_new_workspace_theme (',
'   p_app_id           => :P764_FLOW_ID,',
'   p_app_theme_id     => :P764_THEME,',
'   p_theme_name       => :P789_THEME_NAME,',
'   p_theme_number     => :P789_THEME_NUMBER,',
'   p_theme_desc       => :P789_DESCRIPTION,',
'   p_subscribe_theme  => :P764_SUBSCRIBE_THEME);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error'
,p_process_when_button_id=>wwv_flow_imp.id(113595911048948373)
,p_process_success_message=>'Workspace Theme Created'
,p_internal_uid=>114769930700629816
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(755296096860836826)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(113595911048948373)
,p_internal_uid=>755296096860836826
);
end;
/
prompt --application/pages/page_00763
begin
wwv_flow_imp_page.create_page(
 p_id=>763
,p_name=>'Workspace Themes'
,p_alias=>'WORKSPACE-THEMES'
,p_step_title=>'Workspace Themes'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(5507013954294272)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12511519296310366)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_themes_public.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(113759102026300755)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Workspace themes allow you to add to the theme repository.  They are available when you create an application or when you create a theme for an existing application.</p>',
'<p>You create a workspace theme by selecting a theme from within an application.  Once created, it cannot be edited directly.  To edit, create an application based off the theme, edit the theme within that application and then you can create a new wo'
||'rkspace theme with the updated application theme (and delete the old, if you no longer want it).</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(480600119537691519)
,p_plug_name=>'Workspace Themes'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4050P763a */',
'       t.id,',
'       t.theme_id,',
'       t.theme_name,',
'       ''<img src="''||decode(nvl(t.CUSTOM_IMAGE,''N''),''N'',',
'          m.ip||''htmldb/icons/ws_theme.png'',',
'         ''wwv_flow_utilities.get_theme_file?p_id=''||id||''&''||',
'         ''p_app_id=''||flow_id)||''" width="150" height="80" alt="" />''',
'       theme_image,',
'       t.theme_description,',
'       t.flow_id application_id,',
'       (select count(*) from wwv_flow_templates where flow_id = t.flow_id and security_group_id = 11 and theme_id = t.theme_id) page_templates,',
'       (select count(*) from WWV_FLOW_BUTTON_TEMPLATES where flow_id = t.flow_id and security_group_id = 11 and theme_id = t.theme_id) button_templates,',
'       (select count(*) from WWV_FLOW_CAL_TEMPLATES where flow_id = t.flow_id and security_group_id = 11 and theme_id = t.theme_id) calendar_templates,',
'       (select count(*) from WWV_FLOW_FIELD_TEMPLATES where flow_id = t.flow_id and security_group_id = 11 and theme_id = t.theme_id) label_templates,',
'       (select count(*) from WWV_FLOW_LIST_TEMPLATES where flow_id = t.flow_id and security_group_id = 11 and theme_id = t.theme_id) list_templates,',
'       (select count(*) from WWV_FLOW_MENU_TEMPLATES where flow_id = t.flow_id and security_group_id = 11 and theme_id = t.theme_id) breadcrumb_templates,',
'       (select count(*) from WWV_FLOW_PAGE_PLUG_TEMPLATES where flow_id = t.flow_id and security_group_id = 11 and theme_id = t.theme_id) region_templates,',
'       (select count(*) from WWV_FLOW_ROW_TEMPLATES where flow_id = t.flow_id and security_group_id = 11 and theme_id = t.theme_id) report_templates,',
'       (select count(*) from WWV_FLOW_POPUP_LOV_TEMPLATE where flow_id = t.flow_id and security_group_id = 11 and theme_id = t.theme_id) POPUP_LOV_template,',
'       (select count(*) from wwv_flow_template_components where flow_id = t.flow_id and security_group_id = 11 and theme_id = t.theme_id) template_component,',
'       decode(nvl(t.CUSTOM_IMAGE,''N''),''N'',',
'          m.ip||''htmldb/icons/ws_theme.png'',',
'         ''wwv_flow_utilities.get_theme_file?p_id=''||t.id||''&''||',
'         ''p_app_id=''||t.flow_id)',
'         img,',
'       t.theme_name img_alt,',
'       ''f?p=4000:756:''||:app_session||''::::P756_ID:''|| t.id img_url,',
'       t.theme_name||'' - ''||t.theme_id img_name',
'  from wwv_flow_themes t,',
'       (select v(''IMAGE_PREFIX'') ip from sys.dual) m',
' where theme_security_group_id = :WORKSPACE_ID',
'   and security_group_id = 11'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(480600211834691519)
,p_name=>'Workspace Themes'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_link_column=>'IMG_URL'
,p_icon_view_img_src_column=>'IMG'
,p_icon_view_label_column=>'IMG_NAME'
,p_icon_view_alt_text=>'#IMG_ALT#'
,p_icon_view_columns_per_row=>5
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(480600517421691535)
,p_db_column_name=>'THEME_ID'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>'Number'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(480600623697691536)
,p_db_column_name=>'THEME_NAME'
,p_display_order=>2
,p_column_identifier=>'C'
,p_column_label=>'Name'
,p_column_link=>'f?p=&APP_ID.:756:&SESSION.::&DEBUG.::P756_ID:#ID#'
,p_column_linktext=>'#THEME_NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(480600719859691537)
,p_db_column_name=>'THEME_IMAGE'
,p_display_order=>3
,p_column_identifier=>'D'
,p_column_label=>'Image'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(480600809657691538)
,p_db_column_name=>'THEME_DESCRIPTION'
,p_display_order=>4
,p_column_identifier=>'E'
,p_column_label=>'Description'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(480600913607691539)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>5
,p_column_identifier=>'F'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(480601010400691540)
,p_db_column_name=>'PAGE_TEMPLATES'
,p_display_order=>6
,p_column_identifier=>'G'
,p_column_label=>'Page<br />Templates'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(480601104779691542)
,p_db_column_name=>'BUTTON_TEMPLATES'
,p_display_order=>7
,p_column_identifier=>'H'
,p_column_label=>'Button<br />Templates'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(480601230102691543)
,p_db_column_name=>'CALENDAR_TEMPLATES'
,p_display_order=>8
,p_column_identifier=>'I'
,p_column_label=>'Calendar<br />Templates'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(480601311245691544)
,p_db_column_name=>'LABEL_TEMPLATES'
,p_display_order=>9
,p_column_identifier=>'J'
,p_column_label=>'Label<br />Templates'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(480601424800691545)
,p_db_column_name=>'LIST_TEMPLATES'
,p_display_order=>10
,p_column_identifier=>'K'
,p_column_label=>'List<br />Templates'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(480601504350691546)
,p_db_column_name=>'BREADCRUMB_TEMPLATES'
,p_display_order=>11
,p_column_identifier=>'L'
,p_column_label=>'Breadcrumb<br />Templates'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(480601606392691547)
,p_db_column_name=>'REGION_TEMPLATES'
,p_display_order=>12
,p_column_identifier=>'M'
,p_column_label=>'Region<br />Templates'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(480601723540691548)
,p_db_column_name=>'REPORT_TEMPLATES'
,p_display_order=>13
,p_column_identifier=>'N'
,p_column_label=>'Report<br />Templates'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(480601803967691549)
,p_db_column_name=>'POPUP_LOV_TEMPLATE'
,p_display_order=>14
,p_column_identifier=>'O'
,p_column_label=>'Popup LOV<br />Template'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1602689469824402)
,p_db_column_name=>'TEMPLATE_COMPONENT'
,p_display_order=>24
,p_column_identifier=>'U'
,p_column_label=>'Template Component'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(480600408568691534)
,p_db_column_name=>'ID'
,p_display_order=>34
,p_column_identifier=>'A'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(480601910183691550)
,p_db_column_name=>'IMG'
,p_display_order=>44
,p_column_identifier=>'P'
,p_column_label=>'Img'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(480602023059691551)
,p_db_column_name=>'IMG_ALT'
,p_display_order=>54
,p_column_identifier=>'Q'
,p_column_label=>'Img Alt'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(480602115440691552)
,p_db_column_name=>'IMG_URL'
,p_display_order=>64
,p_column_identifier=>'R'
,p_column_label=>'Img Url'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(480602212105691553)
,p_db_column_name=>'IMG_NAME'
,p_display_order=>74
,p_column_identifier=>'S'
,p_column_label=>'Img Name'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(480602703192699428)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1291203843536644'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'THEME_ID:THEME_NAME:THEME_DESCRIPTION:PAGE_TEMPLATES:BUTTON_TEMPLATES:CALENDAR_TEMPLATES:LABEL_TEMPLATES:LIST_TEMPLATES:BREADCRUMB_TEMPLATES:REGION_TEMPLATES:REPORT_TEMPLATES:POPUP_LOV_TEMPLATE::TEMPLATE_COMPONENT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(574351452965630549)
,p_plug_name=>'Workspace Utilities'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(2778715503937249)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(702957276965571301)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(480600119537691519)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Workspace Theme'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:764:&SESSION.::&DEBUG.:RP,764,789,762:::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(116367203339505930)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'763'
,p_computation_error_message=>'Unable to compute item value.'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(887628962065273324)
,p_name=>'WS Theme Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(480600119537691519)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(887629038218273325)
,p_event_id=>wwv_flow_imp.id(887628962065273324)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(480600119537691519)
);
end;
/
prompt --application/pages/page_00764
begin
wwv_flow_imp_page.create_page(
 p_id=>764
,p_name=>'Create Workspace Theme - Identify Theme'
,p_alias=>'CREATE-WORKSPACE-THEME-IDENTIFY-THEME'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Workspace Theme'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(113748409598274541)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12511519296310366)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'ui_themes_public.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(113640016491074142)
,p_plug_name=>'Create Workspace Theme'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_header=>'<p>Select an application theme to create within the workspace theme repository.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(114833708218850374)
,p_plug_name=>'Progress'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(114829600122838504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(208263500055418849)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(113640229824074144)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(208263500055418849)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(113640411055074145)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(208263500055418849)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(113641824311074151)
,p_branch_action=>'f?p=&APP_ID.:789:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(113640411055074145)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(113640631293074146)
,p_name=>'P764_THEME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(113640016491074142)
,p_prompt=>'Application Theme to Copy'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'from   wwv_flow_themes',
'where  flow_id = :P764_FLOW_ID',
'order by theme_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_lov_cascade_parent_items=>'P764_FLOW_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the theme you would like to copy to the workspace theme repository.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114796815650738962)
,p_name=>'P764_REPLACE_THEME'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(113640016491074142)
,p_prompt=>'Replace Theme'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'select ''some theme'' d, 1 r from dual'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cSize=>64
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_required_patch=>wwv_flow_imp.id(170786031904296885)
,p_help_text=>'Identifies the name of the workspace theme to be replaced with a new theme.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(702957336140571302)
,p_name=>'P764_CREATE_OR_REPLACE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(113640016491074142)
,p_item_default=>'CREATE'
,p_prompt=>'Process'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC:Create New Scheme;CREATE,Replace Existing Scheme;REPLACE'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_required_patch=>wwv_flow_imp.id(170786031904296885)
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(702957777293571306)
,p_name=>'P764_FLOW_ID'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(113640016491074142)
,p_prompt=>'Application'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||name d, id r',
'  from wwv_flow_visible_flows f',
' where f.build_status != ''RUN_AND_HIDDEN''',
' order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1429075521663875901)
,p_name=>'P764_SUBSCRIBE_THEME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(113640016491074142)
,p_item_default=>'Y'
,p_prompt=>'Subscribe Theme'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select whether to subscribe the workspace theme to the selected application theme. This allows for refreshing the workspace theme with changes made to the selected application theme.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(702957430369571303)
,p_name=>'Create or Replace Change'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P764_CREATE_OR_REPLACE'
,p_condition_element=>'P764_CREATE_OR_REPLACE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'CREATE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(702957559421571304)
,p_event_id=>wwv_flow_imp.id(702957430369571303)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P764_REPLACE_THEME'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(702957647814571305)
,p_event_id=>wwv_flow_imp.id(702957430369571303)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P764_REPLACE_THEME'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(887629650803273331)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(113640229824074144)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(887629754169273332)
,p_event_id=>wwv_flow_imp.id(887629650803273331)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00776
begin
wwv_flow_imp_page.create_page(
 p_id=>776
,p_name=>'Create Report on Web Service Result - Page and Region Attributes'
,p_alias=>'CREATE-REPORT-ON-WEB-SERVICE-RESULT-PAGE-AND-REGION-ATTRIBUTES'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Report on Web Service Result'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(93464502376707648)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_form.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44520323653884508)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(114027203797330126)
,p_plug_name=>'Create Report on Web Service Result'
,p_region_template_options=>'#DEFAULT#:#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>'Identify page number and name.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(114027401232330127)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(114018423833281484)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(114028311710330137)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(44520323653884508)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(114028123140330136)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(44520323653884508)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(699451484505457010)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_imp.id(44520323653884508)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:2500:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(114035817522330150)
,p_branch_action=>'4795'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(114028123140330136)
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow_wizard_api.page_exists (p_flow_id => :fb_flow_id, p_page_id => :P776_FLOW_STEP_ID) = true'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(114036009983330151)
,p_branch_name=>'Navigation Menu / Tabs'
,p_branch_action=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.:RP:P4716_PREV_PAGE_ID:&APP_PAGE_ID.:&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(114028123140330136)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(114036208849330151)
,p_branch_action=>'f?p=&APP_ID.:776:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'P776_BREADCRUMB_ID'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(45257317371024144)
,p_name=>'P776_PAGE_MODE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(114027203797330126)
,p_item_default=>'NORMAL'
,p_prompt=>'Page Mode'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DIALOG_PAGE_MODE_CREATE_WIZARD'
,p_lov=>'.'||wwv_flow_imp.id(1497542689968615899)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_user_interface_dev.dialog_page_template_exists(',
'                     p_application_id     => :FB_FLOW_ID ); '))
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Identify the page mode, based on the following options: <p/>',
'<ul>',
'<li><strong>Normal</strong>: The page is presented as a normal &PRODUCT_NAME. application page.</li>',
'<li><strong>Modal Dialog</strong>: The page is presented as a modal dialog. A modal dialog is an overlay window positioned within the viewport, which remains active and focused until the end user dismisses (closes) it. The underlying page is grayed o'
||'ut and the end user is prevented from interacting with the rest of the page until the dialog is closed.</li></ul>',
'<br><p>',
'Note that the Modal Dialog option will only be available for selection where the current application theme contains at least one page template of template type <strong>Dialog Page</strong>.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
,p_attribute_04=>'VERTICAL'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114028505109330138)
,p_name=>'P776_REGION_NAME'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(114027203797330126)
,p_prompt=>'Region Name'
,p_source=>'wwv_flow_lang.system_message(p_name=>''F4000_P4701_PAGE_NAME'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter a name for the region.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114029008982330139)
,p_name=>'P776_PAGE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(114027203797330126)
,p_prompt=>'Page Name'
,p_source=>'wwv_flow_lang.system_message(p_name=>''F4000_P4701_PAGE_NAME'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify a name for the page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114029509737330140)
,p_name=>'P776_FLOW'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(114027203797330126)
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_help_text=>'Identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114030004201330140)
,p_name=>'P776_PAGE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(114027203797330126)
,p_prompt=>'Page Number'
,p_source=>'wwv_flow_utilities.minimum_free_page(:FB_FLOW_ID,1)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'If you identify a new page number, the wizard creates a new page.<p />',
'',
'If you identify an existing page number, the wizard adds the component to that page.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114030502631330142)
,p_name=>'P776_BREADCRUMB_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(114027203797330126)
,p_item_default=>'0'
,p_prompt=>'Breadcrumb'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION.MENUS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name,',
'       id',
'  from wwv_flow_menus',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- do not use breadcrumbs on page -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select whether you want to use a breadcrumb navigation control on your page, and which breadcrumb navigation control you want to use.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114031023509330142)
,p_name=>'P776_BREADCRUMB_NAME'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(114027203797330126)
,p_prompt=>'Entry Name'
,p_source=>'P776_PAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify the name of the breadcrumb entry.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114034232623330146)
,p_name=>'P776_REGION_TEMPLATE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(114027203797330126)
,p_item_default=>'0'
,p_prompt=>'Region Template'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REGION.TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.d, ',
'       t.r ',
'  from ( select wwv_flow_escape.html(page_plug_template_name) d, ',
'             id r',
'           from wwv_flow_page_plug_templates',
'          where security_group_id = :FLOW_SECURITY_GROUP_ID',
'            and flow_id           = :FB_FLOW_ID',
'            and (:FB_THEME_ID is null or theme_id = :FB_THEME_ID)',
'          order by upper(page_plug_template_name) ) t'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'No Template'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a region template for the region in which this report is to appear.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(381582856061964532)
,p_name=>'P776_BREADCRUMB_PARENT_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(114027203797330126)
,p_prompt=>'Parent Entry'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov_language=>'PLSQL'
,p_lov=>'return wwv_flow_4000_ui.breadcrumb_parent_lov_sql( p_breadcrumb_item_name => ''P776_BREADCRUMB_ID'' )'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'No parent entry'
,p_lov_cascade_parent_items=>'P776_BREADCRUMB_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(403499162057490698)
,p_name=>'P776_GROUP_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(114027203797330126)
,p_prompt=>'Page Group'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE GROUP (RETURNS NAME)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d, group_name r ',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'order by upper(group_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Page Group -'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Identify the name of the page group you would like to associate with this page. Page groups help developers manage the pages within an application. To create a page group, enter the name.  To use an existing page group, select the name from the list '
||'of values.',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1940938788586728599)
,p_computation_sequence=>30
,p_computation_item=>'P4716_NAVLIST_ENTRY_NAME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P776_PAGE_NAME'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(114034814076330147)
,p_validation_name=>'Page ID Not Null'
,p_validation_sequence=>10
,p_validation=>'P776_PAGE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Page ID must be specified.'
,p_associated_item=>wwv_flow_imp.id(114030004201330140)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(114035004363330148)
,p_validation_name=>'Page Name Not Null'
,p_validation_sequence=>20
,p_validation=>'P776_PAGE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Page Name must be specified.'
,p_validation_condition=>'select 1 from wwv_flow_steps where flow_id = :fb_flow_id and id = :P776_PAGE_ID'
,p_validation_condition_type=>'NOT_EXISTS'
,p_associated_item=>wwv_flow_imp.id(114029008982330139)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'Only verify page names for new pages.'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(45257912411026435)
,p_validation_name=>'P776_PAGE_MODE Not Null'
,p_validation_sequence=>25
,p_validation=>'P776_PAGE_MODE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Page Mode must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(114028123140330136)
,p_associated_item=>wwv_flow_imp.id(45257317371024144)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_validation_comment=>'generated 10-MAR-2001 11:10'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(114035220069330148)
,p_validation_name=>'P776_BREADCRUMB_NAME'
,p_validation_sequence=>30
,p_validation=>'P776_BREADCRUMB_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Breadcrumb entry name must be specified.'
,p_validation_condition=>'P776_BREADCRUMB_ID'
,p_validation_condition_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_when_button_pressed=>wwv_flow_imp.id(114028123140330136)
,p_associated_item=>wwv_flow_imp.id(114031023509330142)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(114035606277330149)
,p_validation_name=>'P776_REGION_NAME not null'
,p_validation_sequence=>50
,p_validation=>'P776_REGION_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Region Name must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(114028123140330136)
,p_associated_item=>wwv_flow_imp.id(114028505109330138)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(481363823890067581)
,p_validation_name=>'P776_PAGE_ID positive, whole number'
,p_validation_sequence=>60
,p_validation=>'trunc(abs(:P776_PAGE_ID)) = :P776_PAGE_ID'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Page Number must be a positive, whole number.'
,p_when_button_pressed=>wwv_flow_imp.id(114028123140330136)
,p_associated_item=>wwv_flow_imp.id(114030004201330140)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(403499606407492351)
,p_validation_name=>'Validate Group Name'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_utilities.is_valid_page_group_name (',
'  p_name => :P776_GROUP_NAME);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P776_GROUP_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(114028123140330136)
,p_associated_item=>wwv_flow_imp.id(403499162057490698)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(381583827289993680)
,p_name=>'breadcrumb options'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P776_BREADCRUMB_ID'
,p_condition_element=>'P776_BREADCRUMB_ID'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(381584120685993680)
,p_event_id=>wwv_flow_imp.id(381583827289993680)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P776_BREADCRUMB_NAME,P776_BREADCRUMB_PARENT_ID'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(381584303907993681)
,p_event_id=>wwv_flow_imp.id(381583827289993680)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P776_BREADCRUMB_NAME,P776_BREADCRUMB_PARENT_ID'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(549743108592954532)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(114028311710330137)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(549743238352954533)
,p_event_id=>wwv_flow_imp.id(549743108592954532)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1940937423754727337)
,p_name=>'set region name'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P776_PAGE_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1940938392592727338)
,p_event_id=>wwv_flow_imp.id(1940937423754727337)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P776_REGION_NAME'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P776_PAGE_NAME'
,p_attribute_07=>'P776_PAGE_NAME'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1940937884132727338)
,p_event_id=>wwv_flow_imp.id(1940937423754727337)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P776_BREADCRUMB_NAME'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P776_PAGE_NAME'
,p_attribute_07=>'P776_PAGE_NAME'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
end;
/
prompt --application/pages/page_00778
begin
wwv_flow_imp_page.create_page(
 p_id=>778
,p_name=>'Create Report on Web Services'
,p_alias=>'CREATE-REPORT-ON-WEB-SERVICES'
,p_page_mode=>'MODAL'
,p_step_title=>'&P759_REPORT_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'advnc_web_services.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44531023054941145)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(114050828132368748)
,p_plug_name=>'Create &P759_REPORT_TITLE.'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(114051029470368749)
,p_plug_name=>'Wizard Steps'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(114018423833281484)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(114051918987368750)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(44531023054941145)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(114052117705368750)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(44531023054941145)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(114052317233368750)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(44531023054941145)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(114053300781368751)
,p_branch_action=>'P778_WEB_REF_TYPE'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_PAGE_IDENT_BY_ITEM'
,p_branch_when_button_id=>wwv_flow_imp.id(114052117705368750)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(114053110668368751)
,p_branch_name=>'Navigation Menu / Tabs'
,p_branch_action=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(114052317233368750)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114052515261368751)
,p_name=>'P778_WEB_REF_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(114050828132368748)
,p_item_default=>'860'
,p_prompt=>'Web Reference Type:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P778_WEBREF_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(114277222597792014)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Choose whether the Web reference was created manually or by supplying a WSDL document.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(253078626273538045)
,p_name=>'P778_REST_WS_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(114050828132368748)
,p_prompt=>'Web Service Reference'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REST_WEB_SERVICES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'  from wwv_flow_shared_web_services',
' where action = ''REST''',
'   and flow_id = :FB_FLOW_ID',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'-- Select Service --'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the name of the Web service reference.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(253078729884538046)
,p_name=>'P778_REST_OPERATION_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(114050828132368748)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(253078954868538048)
,p_name=>'P778_WSDL_WS_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(114050828132368748)
,p_prompt=>'Web Service Reference'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P779_WSDL_SERVICES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'  from wwv_flow_shared_web_services',
' where action = ''NEW_SCHOOL''',
'   and flow_id = :FB_FLOW_ID',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'-- Select Service --'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the name of the Web service reference.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(253079085401538049)
,p_name=>'P778_WSDL_OPERATION_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(114050828132368748)
,p_prompt=>'Operation'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'  from wwv_flow_ws_operations',
' where name != ''BASIC_AUTH''',
'   and ws_id = :P778_WSDL_WS_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'-- Select Operation --'
,p_lov_null_value=>'0'
,p_lov_cascade_parent_items=>'P778_WSDL_WS_ID'
,p_ajax_items_to_submit=>'P778_WSDL_WS_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the operation.  The operation is the method that will be executed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(253079152835538050)
,p_name=>'P778_WSDL_ARRAY'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(114050828132368748)
,p_prompt=>'Result Tree to Report On:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name)||'' (''||wwv_flow_escape.html(parm_type)||'')'' d, id r',
'  from wwv_flow_ws_parameters a',
' where type_is_xsd = ''N''',
'   and input_or_output = ''O''',
'   and exists (select 1',
'                 from wwv_flow_ws_parameters',
'                where parent_id = a.id',
'                  and type_is_xsd = ''Y'') ',
'   and ws_opers_id = :P778_WSDL_OPERATION_ID'))
,p_lov_cascade_parent_items=>'P778_WSDL_OPERATION_ID'
,p_ajax_items_to_submit=>'P778_WSDL_OPERATION_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(272277507404934701)
,p_name=>'P778_MAN_WS_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(114050828132368748)
,p_prompt=>'Web Service Reference'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEB SERVICES OLD'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r from wwv_flow_shared_web_services',
'',
'where nvl(action,''OLD_SCHOOL'') not in (''NEW_SCHOOL'',''REST'') and security_group_id = :flow_security_group_id and',
'',
'      flow_id = :fb_flow_id',
'',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'-- Select Service --'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the name of the Web service reference.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(272277677571934702)
,p_name=>'P778_MAN_SOAP_STYLE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(114050828132368748)
,p_item_default=>'document'
,p_prompt=>'SOAP Style:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P755.SOAP.STYLE'
,p_lov=>'.'||wwv_flow_imp.id(40229315139441290)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose the style of the SOAP response. The style can be determined from the style attribute of the soap:binding element from the WSDL for this operation.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(272277768861934703)
,p_name=>'P778_MAN_MSG_FORMAT'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(114050828132368748)
,p_item_default=>'literal'
,p_prompt=>'Message Format:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P755.MESSAGE.STYLE'
,p_lov=>'.'||wwv_flow_imp.id(40231925790463373)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose the message format. The encoding can be determined from the use attribute of the soap:body element of the output message in the WSDL for this operation.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(272277885166934704)
,p_name=>'P778_NODE_PATH'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(114050828132368748)
,p_prompt=>'Result Node Path (XPath)'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the XPath expression to the node of the response message that you are creating the report on. The node is a child of the soap:Body element. For example,',
'<p />/result/myNode'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(272277984965934705)
,p_name=>'P778_MAN_MSG_NAMESAPECE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(114050828132368748)
,p_prompt=>'Message Namespace'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the namespace for the response message. This can typically be determined by looking for the targetNamespace attribute of the WSDL.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(253078886025538047)
,p_computation_sequence=>10
,p_computation_item=>'P778_REST_OPERATION_ID'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'  from wwv_flow_ws_operations',
' where ws_id = :P778_REST_WS_ID',
'   and name = ''doREST'''))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(272278139063934707)
,p_validation_name=>'Rest Webservice not null'
,p_validation_sequence=>10
,p_validation=>'P778_REST_WS_ID'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'You must choose a web service.'
,p_validation_condition=>'P778_WEB_REF_TYPE'
,p_validation_condition2=>'860'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(272278276818934708)
,p_validation_name=>'WSDL Webservice not null'
,p_validation_sequence=>20
,p_validation=>'P778_WSDL_WS_ID'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'You must choose a web service.'
,p_validation_condition=>'P778_WEB_REF_TYPE'
,p_validation_condition2=>'782'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(272278576072934711)
,p_validation_name=>'WSDL Operation ID not null'
,p_validation_sequence=>30
,p_validation=>'nvl(:P778_WSDL_OPERATION_ID,''0'') != ''0'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'You must choose an operation.'
,p_validation_condition=>'P778_WEB_REF_TYPE'
,p_validation_condition2=>'782'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(272278414019934710)
,p_validation_name=>'WSDL Array not null'
,p_validation_sequence=>40
,p_validation=>'P778_WSDL_ARRAY'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'You must select the base node.'
,p_validation_condition=>'P778_WEB_REF_TYPE'
,p_validation_condition2=>'782'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(272278302865934709)
,p_validation_name=>'manual Webservice not'
,p_validation_sequence=>50
,p_validation=>'P778_MAN_WS_ID'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'You must choose a web service.'
,p_validation_condition=>'P778_WEB_REF_TYPE'
,p_validation_condition2=>'783'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(272278607658934712)
,p_validation_name=>'manual node path not null'
,p_validation_sequence=>60
,p_validation=>'P778_NODE_PATH'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'You must supply the XPath to the node to report on.'
,p_validation_condition=>'P778_WEB_REF_TYPE'
,p_validation_condition2=>'783'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(549884795809989004)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(114051918987368750)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(549884835102989005)
,p_event_id=>wwv_flow_imp.id(549884795809989004)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(272278768576934713)
,p_name=>'display REST items'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P778_WEB_REF_TYPE'
,p_condition_element=>'P778_WEB_REF_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'860'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(272278871699934714)
,p_event_id=>wwv_flow_imp.id(272278768576934713)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P778_REST_WS_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(272279000141934716)
,p_event_id=>wwv_flow_imp.id(272278768576934713)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P778_WSDL_WS_ID,P778_WSDL_OPERATION_ID,P778_WSDL_ARRAY,P778_MAN_WS_ID,P778_MAN_SOAP_STYLE,P778_MAN_MSG_FORMAT,P778_NODE_PATH,P778_MAN_MSG_NAMESAPECE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(272279240823934718)
,p_name=>'Display WSDL items'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P778_WEB_REF_TYPE'
,p_condition_element=>'P778_WEB_REF_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'782'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(272279331356934719)
,p_event_id=>wwv_flow_imp.id(272279240823934718)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P778_WSDL_WS_ID,P778_WSDL_OPERATION_ID,P778_WSDL_ARRAY'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(272279541790934721)
,p_event_id=>wwv_flow_imp.id(272279240823934718)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P778_REST_WS_ID,P778_MAN_WS_ID,P778_MAN_SOAP_STYLE,P778_MAN_MSG_FORMAT,P778_MAN_MSG_NAMESAPECE,P778_NODE_PATH'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(272279785977934723)
,p_name=>'display manual ittems'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P778_WEB_REF_TYPE'
,p_condition_element=>'P778_WEB_REF_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'783'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(272279817707934724)
,p_event_id=>wwv_flow_imp.id(272279785977934723)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P778_MAN_WS_ID,P778_MAN_SOAP_STYLE,P778_MAN_MSG_FORMAT,P778_NODE_PATH,P778_MAN_MSG_NAMESAPECE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(272280074378934726)
,p_event_id=>wwv_flow_imp.id(272279785977934723)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P778_REST_WS_ID,P778_WSDL_WS_ID,P778_WSDL_OPERATION_ID,P778_WSDL_ARRAY'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_00779
begin
wwv_flow_imp_page.create_page(
 p_id=>779
,p_name=>'Create &P759_REPORT_TITLE.'
,p_alias=>'CREATE-P759-REPORT-TITLE'
,p_page_mode=>'MODAL'
,p_step_title=>'Create &P759_REPORT_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'advnc_web_services.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44534604616954742)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(114059531046385729)
,p_plug_name=>'Wizard Steps'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(114018423833281484)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(114060107277385730)
,p_plug_name=>'Create &P759_REPORT_TITLE.'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(114061031636385731)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(44534604616954742)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(114061224849385731)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(44534604616954742)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(114060811620385731)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(44534604616954742)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(114063615063385734)
,p_branch_action=>'f?p=&APP_ID.:782:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(114061031636385731)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(114063807849385734)
,p_branch_action=>'f?p=&APP_ID.:778:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(114061224849385731)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(114064020861385734)
,p_branch_action=>'f?p=&FLOW_ID.:779:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114061409215385731)
,p_name=>'P779_OPERATION_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(114060107277385730)
,p_prompt=>'Operation'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P779_OPERATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'  from wwv_flow_ws_operations',
' where name != ''BASIC_AUTH''',
'   and ws_id = :P779_WS_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'-- Select Operation --'
,p_lov_null_value=>'0'
,p_lov_cascade_parent_items=>'P779_WS_ID'
,p_ajax_items_to_submit=>'P779_WS_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the operation.  The operation is the method that will be executed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114061916291385732)
,p_name=>'P779_WS_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(114060107277385730)
,p_prompt=>'Web Service Reference'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P779_WSDL_SERVICES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'  from wwv_flow_shared_web_services',
' where action = ''NEW_SCHOOL''',
'   and flow_id = :FB_FLOW_ID',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'-- Select Service --'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the name of the Web service reference.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114062422047385732)
,p_name=>'P779_ARRAY'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(114060107277385730)
,p_prompt=>'Result Tree to Report On:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P779_ARRAYS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name)||'' (''||wwv_flow_escape.html(parm_type)||'')'' d, id r',
'  from wwv_flow_ws_parameters a',
' where type_is_xsd = ''N''',
'   and input_or_output = ''O''',
'   and exists (select 1',
'                 from wwv_flow_ws_parameters',
'                where parent_id = a.id',
'                  and type_is_xsd = ''Y'') ',
'   and ws_opers_id = :P779_OPERATION_ID'))
,p_lov_cascade_parent_items=>'P779_OPERATION_ID'
,p_ajax_items_to_submit=>'P779_OPERATION_ID'
,p_ajax_optimize_refresh=>'Y'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Select the portion of the resulting XML document that contains the information you want to include in the report.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(114063018695385733)
,p_validation_name=>'P779_WS_ID'
,p_validation_sequence=>10
,p_validation=>'nvl(:P779_WS_ID,''0'') != ''0'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'You must choose a web service.'
,p_when_button_pressed=>wwv_flow_imp.id(114061031636385731)
,p_associated_item=>wwv_flow_imp.id(114061916291385732)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(114063200898385733)
,p_validation_name=>'P779_OPERATION_ID'
,p_validation_sequence=>20
,p_validation=>'nvl(:P779_OPERATION_ID,''0'') != ''0'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'You must choose an operation.'
,p_when_button_pressed=>wwv_flow_imp.id(114061031636385731)
,p_associated_item=>wwv_flow_imp.id(114061409215385731)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(114063411340385734)
,p_validation_name=>'P779_ARRAY'
,p_validation_sequence=>30
,p_validation=>'P779_ARRAY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'You must select the base node.'
,p_when_button_pressed=>wwv_flow_imp.id(114061031636385731)
,p_associated_item=>wwv_flow_imp.id(114062422047385732)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(549885393002989010)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(114060811620385731)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(549885460110989011)
,p_event_id=>wwv_flow_imp.id(549885393002989010)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00781
begin
wwv_flow_imp_page.create_page(
 p_id=>781
,p_name=>'Create &P759_REPORT_TITLE.'
,p_alias=>'CREATE-P759-REPORT-TITLE1'
,p_page_mode=>'MODAL'
,p_step_title=>'Create &P759_REPORT_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'advnc_web_services.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44541017569043691)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(114089415117408247)
,p_plug_name=>'Wizard Steps'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(114018423833281484)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(114089808659408248)
,p_plug_name=>'Create &P759_REPORT_TITLE.'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(114090903813408249)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(44541017569043691)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(114091128182408249)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(44541017569043691)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(114090728856408249)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(44541017569043691)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(114094315672408253)
,p_branch_action=>'f?p=&APP_ID.:783:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(114090903813408249)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(114094523407408253)
,p_branch_action=>'f?p=&APP_ID.:778:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(114091128182408249)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(114094701080408253)
,p_branch_action=>'f?p=&FLOW_ID.:781:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114091313742408250)
,p_name=>'P781_WS_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(114089808659408248)
,p_prompt=>'Web Service Reference'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEB SERVICES OLD'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r from wwv_flow_shared_web_services',
'',
'where nvl(action,''OLD_SCHOOL'') not in (''NEW_SCHOOL'',''REST'') and security_group_id = :flow_security_group_id and',
'',
'      flow_id = :fb_flow_id',
'',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'-- Select Service --'
,p_lov_null_value=>'0'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the name of the Web service reference.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114091802532408250)
,p_name=>'P781_SOAP_STYLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(114089808659408248)
,p_item_default=>'document'
,p_prompt=>'SOAP Style:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P755.SOAP.STYLE'
,p_lov=>'.'||wwv_flow_imp.id(40229315139441290)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Choose the style of the SOAP response. The style can be determined from the style attribute of the soap:binding element from the WSDL for this operation.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114092301300408251)
,p_name=>'P781_MESSAGE_FORMAT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(114089808659408248)
,p_item_default=>'literal'
,p_prompt=>'Message Format:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P755.MESSAGE.STYLE'
,p_lov=>'.'||wwv_flow_imp.id(40231925790463373)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Choose the message format. The encoding can be determined from the use attribute of the soap:body element of the output message in the WSDL for this operation.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114092828994408251)
,p_name=>'P781_MESSAGE_NAMESPACE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(114089808659408248)
,p_prompt=>'Message Namespace'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter the namespace for the response message. This can typically be determined by looking for the targetNamespace attribute of the WSDL.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114093302903408252)
,p_name=>'P781_NODE_PATH'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(114089808659408248)
,p_prompt=>'Result Node Path (XPath)'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the XPath expression to the node of the response message that you are creating the report on. The node is a child of the soap:Body element. For example,',
'<p />/result/myNode'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(114093930098408252)
,p_validation_name=>'P781_WS_ID'
,p_validation_sequence=>10
,p_validation=>'nvl(:P781_WS_ID,''0'') != ''0'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'You must choose a web service.'
,p_when_button_pressed=>wwv_flow_imp.id(114090903813408249)
,p_associated_item=>wwv_flow_imp.id(114091313742408250)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(114094103793408252)
,p_validation_name=>'P781_NODE_PATH'
,p_validation_sequence=>20
,p_validation=>'P781_NODE_PATH'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'You must supply the XPath to the node to report on.'
,p_when_button_pressed=>wwv_flow_imp.id(114090903813408249)
,p_associated_item=>wwv_flow_imp.id(114093302903408252)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(549885165163989008)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(114090728856408249)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(549885288346989009)
,p_event_id=>wwv_flow_imp.id(549885165163989008)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00782
begin
wwv_flow_imp_page.create_page(
 p_id=>782
,p_name=>'Create &P759_REPORT_TITLE.'
,p_alias=>'CREATE-P759-REPORT-TITLE2'
,p_page_mode=>'MODAL'
,p_step_title=>'Create &P759_REPORT_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript" language="JavaScript1.1">',
'    function ToggleAll(e){	if (e.checked) {	CheckAll();	}',
'    	else {	ClearAll();	}',
'    }',
'    function Check(e){	e.checked = true;}',
'    function Clear(e){	e.checked = false;}',
'    function CheckAll(){	',
'        var ml = document.wwv_flow;	',
'        var len = ml.elements.length;	',
'        for (var i = 0; i < len; i++) {',
'        var e = ml.elements[i];	',
'        if (e.name == "f01" ||e.name == "f03" ||e.name == "f05" || e.name == "f07" || e.name == "f09" ||e.name == "f11" ||e.name == "f13" || e.name == "f15" ) {',
'        Check(e);}',
'        }',
'        ml.f01.checked = true;',
'    }',
'    function ClearAll(){	',
'        var ml = document.wwv_flow;	',
'        var len = ml.elements.length;	',
'        for (var i = 0; i < len; i++) {	',
'          var e = ml.elements[i];	if (e.name == "f01" ||	e.name == "f03" ||e.name == "f05" ||e.name == "f07" ||e.name == "f09" ||e.name == "f11" ||e.name == "f13" ||e.name == "f15" ) {		Clear(e);	}',
'        	}',
'        	ml.f01.checked = false;',
'    }',
'</script>'))
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'advnc_web_services.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(114109628559435534)
,p_name=>'Create &P759_REPORT_TITLE.'
,p_template=>wwv_flow_imp.id(42025417508627628)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.checkbox(1,id,null,:P782_CHECKED_ITEMS) x, ',
'       name, parm_type',
'  from wwv_flow_ws_parameters',
' where type_is_xsd = ''Y''',
'   and parent_id = :P778_WSDL_ARRAY'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>1000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(114109806806435535)
,p_query_column_id=>1
,p_column_alias=>'X'
,p_column_display_sequence=>1
,p_column_heading=>'<input type="checkbox" value="x" onclick="ToggleAll(this)" />'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(114109909540435535)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(114110007823435535)
,p_query_column_id=>3
,p_column_alias=>'PARM_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Parameter Type'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(114110127018435535)
,p_plug_name=>'Wizard Steps'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(114018423833281484)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(114110302855435535)
,p_plug_name=>'SQL Report on Web Service Result'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42027416946637016)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify a temporary result set name and select the parameters from the array to include in the report.</p>',
'<p>To select and deselect all parameters, select the check box in the column header.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(206211417199416792)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(114111425081435537)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(206211417199416792)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(114111630838435537)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(206211417199416792)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(114111222731435536)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(206211417199416792)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(114115503474435543)
,p_branch_action=>'f?p=&APP_ID.:786:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(114111425081435537)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(114115322234435543)
,p_branch_name=>'Go To Page 778'
,p_branch_action=>'f?p=&APP_ID.:778:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(114111630838435537)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114111819134435537)
,p_name=>'P782_CHECKED_ITEMS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(114109628559435534)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114112010206435537)
,p_name=>'P782_ARRAY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(114109628559435534)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Result Tree to Report On:'
,p_source=>'P778_WSDL_ARRAY'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name)||'' (''||wwv_flow_escape.html(parm_type)||'')'' d, id r',
'  from wwv_flow_ws_parameters a',
' where type_is_xsd = ''N''',
'   and input_or_output = ''O''',
'   and exists (select 1',
'                 from wwv_flow_ws_parameters',
'                where parent_id = a.id',
'                  and type_is_xsd = ''Y'') ',
'   and ws_opers_id = :P778_WSDL_OPERATION_ID'))
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'This is the portion of the resulting XML document that contains the information you want to include in the report.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114112513527435538)
,p_name=>'P782_ROW_TEMPLATE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(114109628559435534)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select default_report_template from wwv_flow_themes where flow_id = :fb_flow_id and theme_id = :fb_theme_id and default_report_template is not null) loop',
'   return c1.default_report_template;',
'end loop;',
'return null;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Report Template'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REPORT.TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME1'')  d,  1 r from sys.dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME2'')  d,  2 r from sys.dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME21'') d, 21 r from sys.dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME22'') d, 22 r from sys.dual union',
'select wwv_flow_lang.system_message(''CONFIRM.TEMPLATE'')||'' ''||theme_id||''. ''||wwv_flow_escape.html(row_template_name) d, id r',
'  from wwv_flow_row_templates ',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID ',
'   and (:FB_THEME_ID is null or theme_id = :FB_THEME_ID)',
' order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Choose the report template to be used by this report region.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114113020191435538)
,p_name=>'P782_ROWS_PER_PAGE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(114109628559435534)
,p_item_default=>'15'
,p_prompt=>'Rows Per Page'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Select the number of rows to display per page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114113530441435539)
,p_name=>'P782_RESULT_COLLECTION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(114109628559435534)
,p_prompt=>'Result Stored in Collection'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the name of the temporary result set name where the Web service result is stored. The temporary result set is stored in an &PRODUCT_NAME. collection in the CLOB001 column.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(114114103063435541)
,p_computation_sequence=>10
,p_computation_item=>'P782_CHECKED_ITEMS'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_utilities.table_to_string(wwv_flow.g_f01)'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(114114308265435541)
,p_computation_sequence=>20
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.get_current_theme_id (',
'    p_application_id    => :FB_FLOW_ID )'))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(114114505374435541)
,p_validation_name=>'At least one parameter chosen'
,p_validation_sequence=>10
,p_validation=>'return wwv_flow.g_f01.count > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'You must choose at least one parameter for the report.'
,p_when_button_pressed=>wwv_flow_imp.id(114111425081435537)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(114114731167435542)
,p_validation_name=>'P782_RESULT_COLLECTION not null'
,p_validation_sequence=>20
,p_validation=>'P782_RESULT_COLLECTION'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'You must supply the name of the collection containing the Web service result.'
,p_when_button_pressed=>wwv_flow_imp.id(114111425081435537)
,p_associated_item=>wwv_flow_imp.id(114113530441435539)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(549885759101989014)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(114111222731435536)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(549885872378989015)
,p_event_id=>wwv_flow_imp.id(549885759101989014)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(114114811465435542)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  i integer;',
'begin',
'  wwv_flow_collection.create_or_truncate_collection(''WS_ARRAY_PARMS'');',
'  for i in 1.. wwv_flow.g_f01.count loop',
'    wwv_flow_collection.add_member(',
'      p_collection_name => ''WS_ARRAY_PARMS'',',
'      p_c001            => wwv_flow.g_f01(i) );',
'  end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>114114811465435542
);
end;
/
prompt --application/pages/page_00783
begin
wwv_flow_imp_page.create_page(
 p_id=>783
,p_name=>'Create &P759_REPORT_TITLE.'
,p_alias=>'CREATE-P759-REPORT-TITLE3'
,p_page_mode=>'MODAL'
,p_step_title=>'Create &P759_REPORT_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript" language="JavaScript1.1">',
'    function ToggleAll(e){	if (e.checked) {	CheckAll();	}',
'    	else {	ClearAll();	}',
'    }',
'    function Check(e){	e.checked = true;}',
'    function Clear(e){	e.checked = false;}',
'    function CheckAll(){	',
'        var ml = document.wwv_flow;	',
'        var len = ml.elements.length;	',
'        for (var i = 0; i < len; i++) {',
'        var e = ml.elements[i];	',
'        if (e.name == "f01" ||e.name == "f03" ||e.name == "f05" || e.name == "f07" || e.name == "f09" ||e.name == "f11" ||e.name == "f13" || e.name == "f15" ) {',
'        Check(e);}',
'        }',
'        ml.f01.checked = true;',
'    }',
'    function ClearAll(){	',
'        var ml = document.wwv_flow;	',
'        var len = ml.elements.length;	',
'        for (var i = 0; i < len; i++) {	',
'          var e = ml.elements[i];	if (e.name == "f01" ||	e.name == "f03" ||e.name == "f05" ||e.name == "f07" ||e.name == "f09" ||e.name == "f11" ||e.name == "f13" ||e.name == "f15" ) {		Clear(e);	}',
'        	}',
'        	ml.f01.checked = false;',
'    }',
'</script>'))
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'advnc_web_services.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(114125816665452273)
,p_name=>'Create &P759_REPORT_TITLE.'
,p_template=>wwv_flow_imp.id(42025417508627628)
,p_display_sequence=>150
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select seq_id id, c001 name',
'  from wwv_flow_collections',
' where collection_name = ''WS_REPORT_ITEMS'''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>1000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(114126016159452274)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(114126115123452274)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Parameter Names'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(114126231695452274)
,p_plug_name=>'Wizard Steps'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(114018423833281484)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(206215404264479273)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>160
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(114127304568452275)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(206215404264479273)
,p_button_name=>'ADDPARAMETER'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Add Parameter'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(114127714203452276)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(206215404264479273)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(114127930613452276)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(206215404264479273)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(114127505576452275)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(206215404264479273)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(114132024721452280)
,p_branch_name=>'Go To Page 778'
,p_branch_action=>'f?p=&APP_ID.:778:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(114127930613452276)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(114132211415452280)
,p_branch_action=>'f?p=&APP_ID.:786:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(114127714203452276)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(114132414590452281)
,p_branch_action=>'f?p=&FLOW_ID.:783:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(114127304568452275)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114128102951452276)
,p_name=>'P783_ARRAY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(114125816665452273)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Result Tree to Report On:'
,p_source=>'P778_NODE_PATH'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_help_text=>'This is the portion of the resulting XML document that contains the information you want to include in the report.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114128608360452277)
,p_name=>'P783_RESULT_COLLECTION'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_imp.id(114125816665452273)
,p_prompt=>'Result Stored in Collection'
,p_source=>'select static_parm_03 from wwv_flow_shared_web_services where id = :P778_MAN_WS_ID'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the name of the temporary result set name where the Web service result is stored. The temporary result set is stored in an &PRODUCT_NAME. collection in the CLOB001 column.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114129115967452277)
,p_name=>'P783_CHECKED_ITEMS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(114125816665452273)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114129328309452277)
,p_name=>'P783_ROW_TEMPLATE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(114125816665452273)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select default_report_template from wwv_flow_themes where flow_id = :fb_flow_id and theme_id = :fb_theme_id and default_report_template is not null) loop',
'   return c1.default_report_template;',
'end loop;',
'return null;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Report Template'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REPORT.TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME1'')  d,  1 r from sys.dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME2'')  d,  2 r from sys.dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME21'') d, 21 r from sys.dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME22'') d, 22 r from sys.dual union',
'select wwv_flow_lang.system_message(''CONFIRM.TEMPLATE'')||'' ''||theme_id||''. ''||wwv_flow_escape.html(row_template_name) d, id r',
'  from wwv_flow_row_templates ',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID ',
'   and (:FB_THEME_ID is null or theme_id = :FB_THEME_ID)',
' order by 1'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Choose the report template to be used by this report region.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114129802926452278)
,p_name=>'P783_ROWS_PER_PAGE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(114125816665452273)
,p_item_default=>'15'
,p_prompt=>'Rows Per Page'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Select the number of rows to display per page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(114130430593452278)
,p_computation_sequence=>10
,p_computation_item=>'P783_CHECKED_ITEMS'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_utilities.table_to_string(wwv_flow.g_f01)'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(114130619111452278)
,p_computation_sequence=>20
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.get_current_theme_id (',
'    p_application_id    => :FB_FLOW_ID )'))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(114130805495452279)
,p_validation_name=>'At least one parameter chosen'
,p_validation_sequence=>10
,p_validation=>'return wwv_flow.g_f01.count > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'You must choose at least on parameter for the report.'
,p_when_button_pressed=>wwv_flow_imp.id(114127714203452276)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(114131000490452279)
,p_validation_name=>'P783_RESULT_COLLECTION not null'
,p_validation_sequence=>20
,p_validation=>'P783_RESULT_COLLECTION'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'You must supply the name of the collection containing the Web service result.'
,p_when_button_pressed=>wwv_flow_imp.id(114127714203452276)
,p_associated_item=>wwv_flow_imp.id(114128608360452277)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(549884951288989006)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(114127505576452275)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(549885063865989007)
,p_event_id=>wwv_flow_imp.id(549884951288989006)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(114131115607452279)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.update_members(',
'  p_collection_name => ''WS_REPORT_ITEMS'',',
'  p_seq             => wwv_flow.g_f01,',
'  p_c001            => wwv_flow.g_f02 );'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>114131115607452279
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(114131322122452279)
,p_process_sequence=>15
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add parameter'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.add_member(',
'  p_collection_name => ''WS_REPORT_ITEMS'');'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(114127304568452275)
,p_internal_uid=>114131322122452279
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(114131721963452280)
,p_process_sequence=>60
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create WS_REPORT_ITEMS'
,p_process_sql_clob=>'wwv_flow_collection.create_collection_from_query(''WS_REPORT_ITEMS'',''select null from wwv_flow_dual100 where rownum < 11'');'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'not wwv_flow_collection.collection_exists(''WS_REPORT_ITEMS'')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>114131721963452280
);
end;
/
prompt --application/pages/page_00786
begin
wwv_flow_imp_page.create_page(
 p_id=>786
,p_name=>'Create Report on Web Service Result - Confirm'
,p_alias=>'CREATE-REPORT-ON-WEB-SERVICE-RESULT-CONFIRM'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Report on Web Service Result'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(93464502376707648)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_form.htm'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(114157723119504876)
,p_plug_name=>'Report on Web Service Result Confirmation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wiz_confirm.create_dynamic_query (',
'    p_flow_id         => :FB_FLOW_ID,',
'    p_page_id         => :P759_PAGE_ID,',
'    p_page_name       => :P759_PAGE_NAME,',
'    p_region_template => wwv_flow_theme_dev.get_region_template_id (',
'                             p_application_id => :FB_FLOW_ID,',
'                             p_theme_id       => :FB_THEME_ID,',
'                             p_page_type      => :P2500_CHOOSE_PAGE_TYPE),',
'    p_region_name     => :P759_PAGE_NAME );'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(114158102177504877)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(114018423833281484)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(206212504301431946)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(114159025887504878)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(206212504301431946)
,p_button_name=>'FINISH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(114159214433504879)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(206212504301431946)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:782:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(114158809792504878)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(206212504301431946)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(114424203419127075)
,p_branch_name=>'Go To Page 782'
,p_branch_action=>'f?p=&APP_ID.:782:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(114159214433504879)
,p_branch_sequence=>50
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P778_WEB_REF_TYPE'
,p_branch_condition_text=>'779'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(114426315886130712)
,p_branch_name=>'Go To Page 783'
,p_branch_action=>'f?p=&APP_ID.:783:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(114159214433504879)
,p_branch_sequence=>60
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P778_WEB_REF_TYPE'
,p_branch_condition_text=>'781'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(193965413499488745)
,p_branch_name=>'Go To Page 860'
,p_branch_action=>'f?p=&APP_ID.:860:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(114159214433504879)
,p_branch_sequence=>70
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P778_WEB_REF_TYPE'
,p_branch_condition_text=>'859'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(403500957361508757)
,p_validation_name=>'Validate Group Name'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_utilities.is_valid_page_group_name (',
'  p_name => :P776_GROUP_NAME);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P776_GROUP_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(114159025887504878)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(549743989214954540)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(114158809792504878)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(549744081882954541)
,p_event_id=>wwv_flow_imp.id(549743989214954540)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(114623110840640138)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create report on ws page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_report_temp  varchar2(4000) := null;',
'  l_rows_per_pg  varchar2(4000) := null;',
'  l_sql          varchar2(32000);',
'begin',
'  if :P778_WEB_REF_TYPE = ''782'' then',
'    ',
'    l_sql := wwv_flow_web_services.generate_query(',
'                p_operation_id              => :P778_WSDL_OPERATION_ID,',
'                p_array_parm                => :P778_WSDL_ARRAY,',
'                p_report_collection_name    => :P782_RESULT_COLLECTION,',
'                p_array_parms_collection    => ''WS_ARRAY_PARMS'' );  ',
'',
'    l_report_temp := :P782_ROW_TEMPLATE;       ',
'    l_rows_per_pg := :P782_ROWS_PER_PAGE;',
'',
'  elsif :P778_WEB_REF_TYPE = ''860'' then',
'    ',
'  l_sql := wwv_flow_web_services.generate_query(',
'                p_operation_id              => :P778_REST_OPERATION_ID,',
'                p_array_parm                => null,',
'                p_report_collection_name    => :P860_RESULT_COLLECTION,',
'                p_array_parms_collection    => ''WS_ARRAY_PARMS'' );',
'',
'    l_report_temp := :P860_ROW_TEMPLATE;       ',
'    l_rows_per_pg := :P860_ROWS_PER_PAGE;',
'',
'  else',
'',
'    l_sql := wwv_flow_web_services.generate_query_manual(',
'                p_result_node               => :P778_NODE_PATH,',
'                p_soap_style                => :P778_MAN_SOAP_STYLE,',
'                p_message_format            => :P778_MAN_MSG_FORMAT,',
'                p_namespace                 => :P778_MAN_MSG_NAMESAPECE,',
'                p_report_collection_name    => :P783_RESULT_COLLECTION,',
'                p_array_parms_collection    => ''WS_REPORT_ITEMS'');    ',
'',
'    l_report_temp := :P783_ROW_TEMPLATE;                 ',
'    l_rows_per_pg := :P783_ROWS_PER_PAGE;     ',
'               ',
'  end if;        ',
'  ',
'  ',
'  wwv_flow_wizard_api.create_report_on_ws(',
'      p_flow_id                  => :FB_FLOW_ID,',
'      p_page_id                  => :P759_PAGE_ID,',
'      p_page_name                => :P759_PAGE_NAME,',
'      p_group_name               => null,',
'      p_page_mode                => :P759_PAGE_MODE,',
'      p_region_name              => :P759_PAGE_NAME,',
'      p_region_template          => wwv_flow_theme_dev.get_region_template_id (',
'                                        p_application_id => :FB_FLOW_ID,',
'                                        p_theme_id       => :FB_THEME_ID,',
'                                        p_page_type      => :P2500_CHOOSE_PAGE_TYPE),',
'      --',
'      p_tab_set                  => :P4716_TAB_SET,',
'      p_tab_name                 => :P4716_TAB_NAME,',
'      p_tab_text                 => :P4716_TAB_LABEL,',
'      --',
'      p_nav_list_id              => :P4716_NAVLIST_ID,',
'      p_nav_list_parent_item_id  => :P4716_NAVLIST_PARENT_ID,',
'      p_nav_list_child_item_name => :P4716_NAVLIST_ENTRY_NAME,',
'      --',
'      p_report_template          => l_report_temp,',
'      p_rows_per_page            => nvl(l_rows_per_pg,''15''),',
'      --',
'      p_breadcrumb_id            => :P759_BREADCRUMB_ID,',
'      p_breadcrumb_name          => :P759_BREADCRUMB_NAME,',
'      p_parent_bc_id             => :P759_BREADCRUMB_PARENT_ID,',
'      --',
'      p_query                    => l_sql );',
'',
'  :fb_flow_page_id       := :P759_PAGE_ID;',
'  :F4000_RUN_EDIT_PAGE   := :P759_PAGE_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error creating Report on Web Service Result page.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(114159025887504878)
,p_process_success_message=>'Report on Web Service Result page created.'
,p_internal_uid=>114623110840640138
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(549744143238954542)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,REQUEST'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Report on Web Service Result page created.'
,p_internal_uid=>549744143238954542
);
end;
/
prompt --application/pages/page_00789
begin
wwv_flow_imp_page.create_page(
 p_id=>789
,p_name=>'Create Workspace Theme'
,p_alias=>'CREATE-WORKSPACE-THEME1'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Workspace Theme'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(113748409598274541)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12511519296310366)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_themes_public.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(114756403333593105)
,p_plug_name=>'Create Workspace Theme'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>'<p>You can change the name and number for the new workspace theme to be created.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(114834314105852056)
,p_plug_name=>'Progress'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(114829600122838504)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(137684003798400090)
,p_name=>'Existing Workspace Themes'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id,',
'       theme_name,',
'       theme_description',
'  from wwv_flow_themes',
' where theme_security_group_id = :WORKSPACE_ID',
'   and security_group_id = 11',
' order by theme_id'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_themes',
' where theme_security_group_id = :WORKSPACE_ID',
'   and security_group_id = 11'))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No existing Workspace Themes.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(137684332022400343)
,p_query_column_id=>1
,p_column_alias=>'THEME_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Number'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(137684414330400343)
,p_query_column_id=>2
,p_column_alias=>'THEME_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(137684524098400343)
,p_query_column_id=>3
,p_column_alias=>'THEME_DESCRIPTION'
,p_column_display_sequence=>3
,p_column_heading=>'Description'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(208166600149775444)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(114757517144593119)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(208166600149775444)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(114757131230593118)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(208166600149775444)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(114757315478593119)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(208166600149775444)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:764:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(114758708377593124)
,p_branch_action=>'f?p=&FLOW_ID.:762:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(114757131230593118)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114757716119593120)
,p_name=>'P789_THEME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(114756403333593105)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Selected Theme:'
,p_source=>'P764_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = :P764_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identifies the theme to be copied to the workspace theme repository.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114758213017593121)
,p_name=>'P789_THEME_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(114756403333593105)
,p_prompt=>'Theme Name'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_name',
'from   wwv_flow_themes',
'where  flow_id = :P764_FLOW_ID',
'and security_group_id = :flow_security_group_id and',
'theme_id = :P764_THEME'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the workspace theme, this name can be the same or different from the application theme name.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114758404070593122)
,p_name=>'P789_THEME_NUMBER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(114756403333593105)
,p_prompt=>'Theme Number'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(greatest(theme_id,99),99,theme_id+100,theme_id) theme_id',
'from   wwv_flow_themes',
'where  flow_id = :P764_FLOW_ID',
'and security_group_id = :flow_security_group_id and',
'theme_id = :P764_THEME'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The number uniquely identifies a theme within a workspace.  You must enter a value greater than 100.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(136505718888126524)
,p_name=>'P789_DESCRIPTION'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(114756403333593105)
,p_prompt=>'Description'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select THEME_DESCRIPTION',
'  from wwv_flow_themes',
' where flow_id = :P764_FLOW_ID',
'  and security_group_id = :flow_security_group_id ',
'  and theme_id = :P764_THEME'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'A short description of the theme.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(114780106075669981)
,p_validation_name=>'P789_THEME_NAME Not Null'
,p_validation_sequence=>10
,p_validation=>'P789_THEME_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_associated_item=>wwv_flow_imp.id(114758213017593121)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 28-NOV-2007 17:59'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(114780311700669982)
,p_validation_name=>'P789_THEME_NUMBER Not Null'
,p_validation_sequence=>20
,p_validation=>'P789_THEME_NUMBER'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_associated_item=>wwv_flow_imp.id(114758404070593122)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 28-NOV-2007 17:59'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(114778827761666818)
,p_validation_name=>'valid theme number'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'if :P789_THEME_NUMBER < 100 then',
'  return false;',
'else ',
'  return true;',
'end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Value must be 100 or greater.'
,p_when_button_pressed=>wwv_flow_imp.id(114757131230593118)
,p_associated_item=>wwv_flow_imp.id(114758404070593122)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(114865613768927599)
,p_validation_name=>'theme number unique (edit me)'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_themes',
' where theme_id = :P789_THEME_NUMBER',
'   and security_group_id = 11',
'   and theme_security_group_id = :WORKSPACE_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'The number must be unique within a workspace.'
,p_when_button_pressed=>wwv_flow_imp.id(114757131230593118)
,p_associated_item=>wwv_flow_imp.id(114758404070593122)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(887629817352273333)
,p_name=>'cancel dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(114757517144593119)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(887629982602273334)
,p_event_id=>wwv_flow_imp.id(887629817352273333)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00795
begin
wwv_flow_imp_page.create_page(
 p_id=>795
,p_name=>'Dynamic Action History'
,p_alias=>'DYNAMIC-ACTION-HISTORY'
,p_step_title=>'Dynamic Action History'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(4518805581694342)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_dynamic_actions.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30456101636900212)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>90
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(28119925264668131)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(251157000568945486)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>130
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.page_id,',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_PAGE_DA_EVENTS'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'%null%'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(251157208114945490)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251157302120945494)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251157417800945496)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Audit Comment'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251157524163945497)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Component Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251157601145945498)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251157715224945500)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Component Key'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251157813388945501)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Audit Date'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251157910594945502)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(251333828293071502)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(251158031618945504)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1291315471536644'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'PAGE_ID:AUDIT_DATE:ACTION:DEVELOPER:COMPONENT_NAME'
,p_sort_column_1=>'PAGE_ID'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'AUDIT_DATE'
,p_sort_direction_2=>'DESC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(251198113829781925)
,p_plug_name=>'Dynamic Action History'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page displays recent modifications made to the Dynamic Actions on the current page.</p>',
'<p>Remove the filter to view the history of all Dynamic Actions within the application.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(251159214897959158)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(251157000568945486)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:795:&SESSION.::&DEBUG.:795,RIR:IR_PAGE_ID:&FB_FLOW_PAGE_ID.'
);
end;
/
prompt --application/pages/page_00796
begin
wwv_flow_imp_page.create_page(
 p_id=>796
,p_name=>'Copy Dynamic Action - To Page'
,p_alias=>'COPY-DYNAMIC-ACTION-TO-PAGE'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Dynamic Action'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(4518805581694342)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_dynamic_actions.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47716515490537386)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>161
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(181515302476213202)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>11
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(181501623296103719)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(181515530106213204)
,p_plug_name=>'Copy Dynamic Action'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>131
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(185991323167292111)
,p_name=>'Copy from Dynamic Action'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>151
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select dynamic_action_name name,',
'       case when_selection_type ',
'           when ''Item'' then when_element ',
'           when ''Region'' then when_region',
'           when ''Button'' then when_button',
'           when ''DOM Object'' then when_element',
'           when ''jQuery Selector'' then when_element',
'           when ''JavaScript Expression'' then when_element',
'       end || '' ('' || when_selection_type || '')'' triggering_event_elements,',
'       when_event_name || '' ('' || when_event_scope || '')'' event_binding,',
'       when_condition || decode(when_expression,null,null,'': '' || when_expression) triggering_event_condition,',
'       number_of_actions',
'  from apex_application_page_da',
' where application_id = to_number(:FB_FLOW_ID)',
'   and page_id = to_number(:FB_FLOW_PAGE_ID)',
'   and dynamic_action_id = to_number(:F4000_P796_COPY_FROM_ID)'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(82408032331628644)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'no data found'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(185991500273292116)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(185991624932292116)
,p_query_column_id=>2
,p_column_alias=>'TRIGGERING_EVENT_ELEMENTS'
,p_column_display_sequence=>3
,p_column_heading=>'When Elements'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(185991719430292116)
,p_query_column_id=>3
,p_column_alias=>'EVENT_BINDING'
,p_column_display_sequence=>2
,p_column_heading=>'When Event'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(185991830368292116)
,p_query_column_id=>4
,p_column_alias=>'TRIGGERING_EVENT_CONDITION'
,p_column_display_sequence=>4
,p_column_heading=>'When Condition'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(185991910962292116)
,p_query_column_id=>5
,p_column_alias=>'NUMBER_OF_ACTIONS'
,p_column_display_sequence=>5
,p_column_heading=>'Actions'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(181515714690213204)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47716515490537386)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(181523305791386897)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47716515490537386)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(183291802535599097)
,p_branch_action=>'f?p=&APP_ID.:797:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(181523305791386897)
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(181517801235229773)
,p_name=>'F4000_P796_COPY_FROM_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(181515530106213204)
,p_prompt=>'P796 Copy From Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(181518003182229775)
,p_name=>'F4000_P796_COPY_FROM_PAGE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(181515530106213204)
,p_prompt=>'P796 Copy From Page Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(181524127049386903)
,p_name=>'F4000_P796_COPY_TO_PAGE_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(181515530106213204)
,p_prompt=>'Target Page'
,p_source=>'F4000_P796_COPY_FROM_PAGE_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d',
'  from wwv_flow_steps',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and is_page_pattern   = ''N''',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the page number to which this component will be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(496793207459087819)
,p_validation_name=>'F4000_P796_COPY_TO_PAGE_ID not null'
,p_validation_sequence=>20
,p_validation=>'F4000_P796_COPY_TO_PAGE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_when_button_pressed=>wwv_flow_imp.id(181523305791386897)
,p_associated_item=>wwv_flow_imp.id(181524127049386903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(496793532393094991)
,p_validation_name=>'F4000_P796_COPY_TO_PAGE_ID numeric'
,p_validation_sequence=>30
,p_validation=>'F4000_P796_COPY_TO_PAGE_ID'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'#LABEL# must be numeric'
,p_when_button_pressed=>wwv_flow_imp.id(181523305791386897)
,p_associated_item=>wwv_flow_imp.id(181524127049386903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(590118869511572024)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(181515714690213204)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(590118910256572025)
,p_event_id=>wwv_flow_imp.id(590118869511572024)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00797
begin
wwv_flow_imp_page.create_page(
 p_id=>797
,p_name=>'Copy Dynamic Action - New Dynamic Action'
,p_alias=>'COPY-DYNAMIC-ACTION-NEW-DYNAMIC-ACTION'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Dynamic Action'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(4518805581694342)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47717720123548186)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>201
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(183290209546582284)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>11
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(181501623296103719)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(183292527731625328)
,p_plug_name=>'Copy Dynamic Action'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>131
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(185891425321498078)
,p_plug_name=>'When'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42027416946637016)
,p_plug_display_sequence=>141
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(185994224730330476)
,p_name=>'Copy from Dynamic Action'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>181
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select dynamic_action_name name,',
'       case when_selection_type ',
'           when ''Item'' then when_element ',
'           when ''Region'' then when_region',
'           when ''Button'' then when_button',
'           when ''DOM Object'' then when_element',
'           when ''jQuery Selector'' then when_element',
'           when ''JavaScript Expression'' then when_element',
'       end || '' ('' || when_selection_type || '')'' triggering_event_elements,',
'       when_event_name,',
'       when_condition || decode(when_expression,null,null,'': '' || when_expression) triggering_event_condition,',
'       number_of_actions',
'  from apex_application_page_da',
' where application_id = to_number(:FB_FLOW_ID)',
'   and page_id = to_number(:FB_FLOW_PAGE_ID)',
'   and dynamic_action_id = to_number(:F4000_P796_COPY_FROM_ID)'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(82408032331628644)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'no data found'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(185994415979330480)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(185994519664330480)
,p_query_column_id=>2
,p_column_alias=>'TRIGGERING_EVENT_ELEMENTS'
,p_column_display_sequence=>4
,p_column_heading=>'When Elements'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(620194328401571937)
,p_query_column_id=>3
,p_column_alias=>'WHEN_EVENT_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'When Event Name'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(185994713840330480)
,p_query_column_id=>4
,p_column_alias=>'TRIGGERING_EVENT_CONDITION'
,p_column_display_sequence=>2
,p_column_heading=>'When Condition'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(185994809211330480)
,p_query_column_id=>5
,p_column_alias=>'NUMBER_OF_ACTIONS'
,p_column_display_sequence=>3
,p_column_heading=>'Number Of Actions'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(186034418786574670)
,p_name=>'Copy to Page Dynamic Actions'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>191
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select dynamic_action_name name,',
'       case when_selection_type ',
'           when ''Item'' then when_element ',
'           when ''Region'' then when_region',
'           when ''Button'' then when_button',
'           when ''DOM Object'' then when_element',
'           when ''jQuery Selector'' then when_element',
'           when ''JavaScript Expression'' then when_element',
'       end || '' ('' || when_selection_type || '')'' triggering_event_elements,',
'       when_event_name || '' ('' || when_event_scope || '')'' event_binding,',
'       when_condition || decode(when_expression,null,null,'': '' || when_expression) triggering_event_condition,',
'       number_of_actions',
'  from apex_application_page_da',
' where application_id = to_number(:FB_FLOW_ID)',
'   and page_id = to_number(:F4000_P796_COPY_TO_PAGE_ID)'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Target Page contains no Dynamic Actions.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(186034613409574676)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(186034721478574676)
,p_query_column_id=>2
,p_column_alias=>'TRIGGERING_EVENT_ELEMENTS'
,p_column_display_sequence=>3
,p_column_heading=>'When Elements'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(186034816428574676)
,p_query_column_id=>3
,p_column_alias=>'EVENT_BINDING'
,p_column_display_sequence=>2
,p_column_heading=>'When Event'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(186034904918574676)
,p_query_column_id=>4
,p_column_alias=>'TRIGGERING_EVENT_CONDITION'
,p_column_display_sequence=>4
,p_column_heading=>'When Condition'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(186035028668574676)
,p_query_column_id=>5
,p_column_alias=>'NUMBER_OF_ACTIONS'
,p_column_display_sequence=>5
,p_column_heading=>'Actions'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(183294013580649582)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47717720123548186)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(427636819611638021)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(47717720123548186)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(184548700439307574)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(47717720123548186)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(427637621473648031)
,p_branch_name=>'Go To Page 4500'
,p_branch_action=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(427636819611638021)
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(184549230567316278)
,p_branch_action=>'f?p=&APP_ID.:796:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(184548700439307574)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1569431692730466)
,p_name=>'P797_TRIGGERING_BUTTON_ID'
,p_item_sequence=>81
,p_item_plug_id=>wwv_flow_imp.id(185891425321498078)
,p_prompt=>'Button'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select button_name,',
'       id',
'  from (',
'        /* all region buttons from target page and global page */',
'        select case when b.flow_step_id = f.global_page_id then',
'                   wwv_flow_lang.system_message(''LAYOUT.GLOBAL_PAGE_REGION_PREFIX'')',
'               end ||',
'               b.button_name ||',
'               '' ('' || b.button_image_alt || '')'' as button_name,',
'               b.id,',
'               b.button_name bn,',
'               case when b.flow_step_id = f.global_page_id then 2 else 1 end x',
'          from wwv_flow_steps p,',
'               wwv_flows f,',
'               wwv_flow_step_buttons b',
'         where p.flow_id      = :FB_FLOW_ID',
'           and p.id           = :F4000_P796_COPY_TO_PAGE_ID',
'           and f.id           = p.flow_id',
'           and b.flow_id      = f.id',
'           and b.flow_step_id in (:F4000_P796_COPY_TO_PAGE_ID, f.global_page_id)',
'         order by x, bn ',
'       )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Button -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select the button that will trigger the dynamic action.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3969222860683766)
,p_name=>'P797_BIND_EVENT_TYPE_CUSTOM'
,p_item_sequence=>11
,p_item_plug_id=>wwv_flow_imp.id(185891425321498078)
,p_prompt=>'Custom Event'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>30
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'<p>Specify a custom JavaScript event name, if the declarative events provided are not sufficient.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(184550602086327013)
,p_name=>'P797_NAME'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(183292527731625328)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the name of the dynamic action for easy identification by developers.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(184550800961327015)
,p_name=>'P797_SEQUENCE'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(183292527731625328)
,p_use_cache_before_default=>'NO'
,p_item_default=>'10'
,p_prompt=>'Sequence'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select max(event_sequence) + 10',
'  from wwv_flow_page_da_events',
' where flow_id = :fb_flow_id',
'   and page_id = :F4000_P796_COPY_TO_PAGE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>3
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the sequence for this component. The sequence determines the order of evaluation.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(185889713631475757)
,p_name=>'P797_TRIGGERING_REGION_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(185891425321498078)
,p_prompt=>'Region'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case when r.page_id = f.global_page_id then',
'           wwv_flow_lang.system_message(''LAYOUT.GLOBAL_PAGE_REGION_PREFIX'')',
'       end || r.plug_name || '' ('' || r.plug_display_sequence || '')'' as d,',
'       r.id as r',
'  from wwv_flow_steps p,',
'       wwv_flows f,',
'       wwv_flow_page_plugs r',
' where p.flow_id           = :FB_FLOW_ID',
'   and p.id                = :F4000_P796_COPY_TO_PAGE_ID',
'   and p.security_group_id = :WORKSPACE_ID',
'   and f.id                = p.flow_id',
'   and r.flow_id           = f.id',
'   and r.page_id          in (:F4000_P796_COPY_TO_PAGE_ID, f.global_page_id)',
' order by case when r.page_id = f.global_page_id then 2 else 1 end, r.plug_name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Region -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>''Region'' has different meanings, depending on the ''Selection Type'' selected.</p>',
'<ul>',
'<li>When ''Selection Type'' is ''Region'', specify the name of a region that will trigger the dynamic action. For example this could be an ''Interactive Report'' region, used in conjunction with an ''afterRefresh'' event, to define a dynamic action that will'
||' fire whenever the report refreshes.</li>',
'<li>When ''Selection Type'' is ''Column'', specify the name of the tabular form region that contains the column you wish to specify.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(185892304374529884)
,p_name=>'P797_TRIGGERING_ELEMENT_TYPE'
,p_item_sequence=>31
,p_item_plug_id=>wwv_flow_imp.id(185891425321498078)
,p_prompt=>'Selection Type'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DYNAMIC ACTION TRIGG ELEM TYPE'
,p_lov=>'.'||wwv_flow_imp.id(34817614503562438)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Type -'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the selection type of the page elements that define when the dynamic action will fire. See help text on individual page items for further information and examples.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(424651302411323923)
,p_name=>'P797_TRIGGERING_ELEM_ITEM'
,p_item_sequence=>135
,p_item_plug_id=>wwv_flow_imp.id(185891425321498078)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Item(s)'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case when i.flow_step_id = f.global_page_id then',
'           wwv_flow_lang.system_message(''LAYOUT.GLOBAL_PAGE_REGION_PREFIX'')',
'       end || i.name || '' ('' || i.prompt || '')'' as d,',
'       i.name as r',
'  from wwv_flow_steps p,',
'       wwv_flows f,',
'       wwv_flow_step_items i',
' where p.flow_id           = :FB_FLOW_ID',
'   and p.id                = :F4000_P796_COPY_TO_PAGE_ID',
'   and p.security_group_id = :WORKSPACE_ID',
'   and f.id                = p.flow_id',
'   and i.flow_id           = f.id',
'   and i.flow_step_id     in (:F4000_P796_COPY_TO_PAGE_ID, f.global_page_id)',
' order by case when i.flow_step_id = f.global_page_id then 2 else 1 end, i.name',
''))
,p_cSize=>60
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the name of 1 or more page item that will trigger the dynamic action. For multiple, please separate page item names with a comma.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>','
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(424651510030326104)
,p_name=>'P797_TRIGGERING_ELEM_DOM'
,p_item_sequence=>145
,p_item_plug_id=>wwv_flow_imp.id(185891425321498078)
,p_use_cache_before_default=>'NO'
,p_prompt=>'DOM Object'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the ''ID'' of a DOM object that will trigger the dynamic action.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(424651719380328851)
,p_name=>'P797_TRIGGERING_ELEM_JQUERY'
,p_item_sequence=>165
,p_item_plug_id=>wwv_flow_imp.id(185891425321498078)
,p_use_cache_before_default=>'NO'
,p_prompt=>'jQuery Selector'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter jQuery Selector syntax to return one or more page elements to trigger the Dynamic Action. The jQuery library offers a very powerful selector syntax which provides a way to easily access one or more elements from a page.</p>',
'<p>Please see the official documentation available from the jQuery homepage for further information about the selector syntax.</p>',
'<h4>Examples</h4>',
'<dl>',
'    <dt>To select a page element with an DOM id of <code>my_id</code></dt>',
'    <dd><pre>#my_id</pre></dd>',
'    <dt>To select all the page elements with a class of <code>my_class</code></dt>',
'    <dd><pre>.my_class</pre></dd>',
'    <dt>To select all the page elements that are inputs</dt>',
'    <dd><pre>input</pre></dd>',
'</dl>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(496751013973559943)
,p_name=>'P797_BIND_EVENT_TYPE'
,p_is_required=>true
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(185891425321498078)
,p_prompt=>'Event'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.UI_COMPONENT_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,',
'       r,',
'       g',
'  from wwv_flow_javascript_events'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Event -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify the event that will cause the dynamic action to fire. For information about specific events, please see the relevant section in the User Guide. The events are categorized as follows:</p>',
'<ul>',
'<li><strong>Browser Events</strong> - Standard browser events.</li>',
'<li><strong>Framework Events</strong> - Framework events are triggered from within the &PRODUCT_NAME. framework.</li>',
'<li><strong>Component Events</strong> - Only available when there is a component available to your application that triggers a custom event. These events are triggered from either native components or plug-in components you have installed in your app'
||'lication.</li>',
'<li><strong>Custom Event</strong> - Any custom event triggered from your application.</li>',
'</ul></p>',
'<p>Note: The events displayed will be different according to the target page''s current ''User Interface'' type. If you wish to select an event that corresponds to a different type, then you have the option of selecting ''Show unsupported'', which will di'
||'splay all events including those that do not correspond to the current type.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'FB_FLOW_ID'
,p_attribute_02=>'F4000_P796_COPY_TO_PAGE_ID'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(626394418137495846)
,p_name=>'P797_TRIGGERING_ELEMENT'
,p_item_sequence=>41
,p_item_plug_id=>wwv_flow_imp.id(185891425321498078)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(855879959242026311)
,p_name=>'P797_TRIGGERING_ELEM_JS'
,p_item_sequence=>175
,p_item_plug_id=>wwv_flow_imp.id(185891425321498078)
,p_use_cache_before_default=>'NO'
,p_prompt=>'JavaScript Expression'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify the JavaScript Expression to be evaluated to return a single DOM object, an array of DOM objects or a jQuery object as the element(s) to trigger the dynamic action.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(626394923678497491)
,p_validation_name=>'Validate Triggering'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.validate_triggering (',
'        p_page_item_prefix => ''P797_'' );',
'end;'))
,p_validation_type=>'PLSQL_ERROR'
,p_error_message=>'Error'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2602566566983377)
,p_validation_name=>'Ensure the destination page is not a subscribed page pattern'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_component_group_dev.is_part_of_subscribed_comp_grp (',
'    p_component_id   => :F4000_P796_COPY_TO_PAGE_ID,',
'    p_component_type => wwv_flow_copy_metadata.c_page,',
'    p_app_id         => :FB_FLOW_ID ) = ''N'''))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'You cannot copy the dynamic action to a page pattern that is part of a subscribed component group.'
,p_when_button_pressed=>wwv_flow_imp.id(427636819611638021)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(496785431775000237)
,p_name=>'EVENT REQUIRES SELECTION TYPE'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P797_BIND_EVENT_TYPE'
,p_condition_element=>'P797_BIND_EVENT_TYPE'
,p_triggering_condition_type=>'NOT_IN_LIST'
,p_triggering_expression=>'apexbeforepagesubmit,unload,resize,ready,orientationchange'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(496785703928000239)
,p_event_id=>wwv_flow_imp.id(496785431775000237)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_TRIGGERING_ELEMENT_TYPE'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(496785916964000240)
,p_event_id=>wwv_flow_imp.id(496785431775000237)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_TRIGGERING_ELEMENT_TYPE'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(496786111513000241)
,p_event_id=>wwv_flow_imp.id(496785431775000237)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_TRIGGERING_ELEMENT_TYPE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3972000444734133)
,p_name=>'EVENT EQUALS CUSTOM'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P797_BIND_EVENT_TYPE'
,p_condition_element=>'P797_BIND_EVENT_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'custom'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3972305616734133)
,p_event_id=>wwv_flow_imp.id(3972000444734133)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_BIND_EVENT_TYPE_CUSTOM'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3972502984734134)
,p_event_id=>wwv_flow_imp.id(3972000444734133)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_BIND_EVENT_TYPE_CUSTOM'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3973609102736636)
,p_event_id=>wwv_flow_imp.id(3972000444734133)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_BIND_EVENT_TYPE_CUSTOM'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(496787622949035575)
,p_name=>'HIDE ALL ELEMENT TYPES'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P797_TRIGGERING_ELEMENT_TYPE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(496787926104035576)
,p_event_id=>wwv_flow_imp.id(496787622949035575)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_TRIGGERING_ELEM_ITEM,P797_TRIGGERING_REGION_ID,P797_TRIGGERING_ELEM_DOM,P797_TRIGGERING_ELEM_JQUERY,P797_TRIGGERING_BUTTON_ID,P797_TRIGGERING_ELEM_JS'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(496788113819035577)
,p_event_id=>wwv_flow_imp.id(496787622949035575)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_TRIGGERING_ELEM_ITEM,P797_TRIGGERING_REGION_ID,P797_TRIGGERING_ELEM_DOM,P797_TRIGGERING_ELEM_JQUERY,P797_TRIGGERING_BUTTON_ID,P797_TRIGGERING_ELEM_JS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(496788231391047398)
,p_name=>'TYPE = REGION'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P797_TRIGGERING_ELEMENT_TYPE'
,p_condition_element=>'P797_TRIGGERING_ELEMENT_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REGION'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(496788727240047401)
,p_event_id=>wwv_flow_imp.id(496788231391047398)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_TRIGGERING_REGION_ID'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(496788500440047400)
,p_event_id=>wwv_flow_imp.id(496788231391047398)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_TRIGGERING_REGION_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1572418326811757)
,p_name=>'TYPE = BUTTON'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P797_TRIGGERING_ELEMENT_TYPE'
,p_condition_element=>'P797_TRIGGERING_ELEMENT_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'BUTTON'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1572714667811813)
,p_event_id=>wwv_flow_imp.id(1572418326811757)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_TRIGGERING_BUTTON_ID'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1572908844811813)
,p_event_id=>wwv_flow_imp.id(1572418326811757)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_TRIGGERING_BUTTON_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(496788812822051515)
,p_name=>'TYPE = ITEM'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P797_TRIGGERING_ELEMENT_TYPE'
,p_condition_element=>'P797_TRIGGERING_ELEMENT_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'ITEM'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(496789313415051517)
,p_event_id=>wwv_flow_imp.id(496788812822051515)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_TRIGGERING_ELEM_ITEM'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(496789124366051516)
,p_event_id=>wwv_flow_imp.id(496788812822051515)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_TRIGGERING_ELEM_ITEM'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(496789724596054916)
,p_name=>'TYPE = DOM OBJECT'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P797_TRIGGERING_ELEMENT_TYPE'
,p_condition_element=>'P797_TRIGGERING_ELEMENT_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'DOM_OBJECT'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(496790221931054919)
,p_event_id=>wwv_flow_imp.id(496789724596054916)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_TRIGGERING_ELEM_DOM'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(496790017034054918)
,p_event_id=>wwv_flow_imp.id(496789724596054916)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_TRIGGERING_ELEM_DOM'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(496790331176056869)
,p_name=>'TYPE = JQUERY'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P797_TRIGGERING_ELEMENT_TYPE'
,p_condition_element=>'P797_TRIGGERING_ELEMENT_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'JQUERY_SELECTOR'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(496790831508056871)
,p_event_id=>wwv_flow_imp.id(496790331176056869)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_TRIGGERING_ELEM_JQUERY'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(496790612936056870)
,p_event_id=>wwv_flow_imp.id(496790331176056869)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_TRIGGERING_ELEM_JQUERY'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(855880028582026312)
,p_name=>'TYPE = JAVASCRIPT EXPRESSION'
,p_event_sequence=>120
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P797_TRIGGERING_ELEMENT_TYPE'
,p_condition_element=>'P797_TRIGGERING_ELEMENT_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'JAVASCRIPT_EXPRESSION'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(855880163419026313)
,p_event_id=>wwv_flow_imp.id(855880028582026312)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_TRIGGERING_ELEM_JS'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(855880287707026314)
,p_event_id=>wwv_flow_imp.id(855880028582026312)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_TRIGGERING_ELEM_JS'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(496790905680058934)
,p_name=>'condition requires expression'
,p_event_sequence=>130
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'797_TRIGGERING_CONDITION_TYPE'
,p_condition_element=>'797_TRIGGERING_CONDITION_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'NULL,NOT_NULL,%null%'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(496791430022058937)
,p_event_id=>wwv_flow_imp.id(496790905680058934)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_TRIGGERING_EXPRESSION'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(496791604987058937)
,p_event_id=>wwv_flow_imp.id(496790905680058934)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_TRIGGERING_EXPRESSION'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(496791208407058936)
,p_event_id=>wwv_flow_imp.id(496790905680058934)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_TRIGGERING_EXPRESSION'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(496791808793058938)
,p_event_id=>wwv_flow_imp.id(496790905680058934)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P797_TRIGGERING_EXPRESSION'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(590118122488572017)
,p_name=>'Cancel Dialog'
,p_event_sequence=>130
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(183294013580649582)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(590118261102572018)
,p_event_id=>wwv_flow_imp.id(590118122488572017)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(427641425161715311)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Dynamic Action'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_page.a_dynamic_action(',
'    p_flow_id_from            => to_number(:FB_FLOW_ID),',
'    p_page_id_from            => to_number(:F4000_P796_COPY_FROM_PAGE_ID),',
'    p_event_id_from           => to_number(:F4000_P796_COPY_FROM_ID),',
'    p_flow_id_to              => to_number(:FB_FLOW_ID),',
'    p_page_id_to              => to_number(:F4000_P796_COPY_TO_PAGE_ID),',
'    p_name                    => :P797_NAME,',
'    p_event_sequence          => :P797_SEQUENCE,',
'    p_bind_event_type         => :P797_BIND_EVENT_TYPE,',
'    p_bind_event_type_custom  => :P797_BIND_EVENT_TYPE_CUSTOM,',
'    p_triggering_element_type => :P797_TRIGGERING_ELEMENT_TYPE,',
'    p_triggering_region_id    => :P797_TRIGGERING_REGION_ID,',
'    p_triggering_button_id    => :P797_TRIGGERING_BUTTON_ID,',
'    p_triggering_element      => :P797_TRIGGERING_ELEMENT );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Failed to copy dynamic action.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(427636819611638021)
,p_process_success_message=>'Dynamic action copied.'
,p_internal_uid=>427641425161715311
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(590118383047572019)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Dynamic action copied.'
,p_internal_uid=>590118383047572019
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(186290730269799122)
,p_process_sequence=>50
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    select name,',
'           triggering_element_type,',
'           bind_event_type,',
'           bind_event_type_custom',
'      into :P797_NAME,',
'           :P797_TRIGGERING_ELEMENT_TYPE,',
'           :P797_BIND_EVENT_TYPE,',
'           :P797_BIND_EVENT_TYPE_CUSTOM',
'      from wwv_flow_page_da_events',
'     where flow_id = to_number(:FB_FLOW_ID)',
'       and page_id = to_number(:F4000_P796_COPY_FROM_PAGE_ID)',
'       and security_group_id = to_number(:WORKSPACE_ID)',
'       and id = to_number(:F4000_P796_COPY_FROM_ID);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>186290730269799122
);
end;
/
prompt --application/pages/page_00801
begin
wwv_flow_imp_page.create_page(
 p_id=>801
,p_name=>'Authentication Schemes'
,p_alias=>'AUTHENTICATION-SCHEMES'
,p_step_title=>'Authentication Schemes'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213425326892450628)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_authentication.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17436505551397155)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(4883690711914138)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47918318810645641)
,p_plug_name=>'Authentication Schemes'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with messages as (',
'    select ( select wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_UP_TO_DATE'') from sys.dual ) up_to_date,',
'           ( select wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_NEEDS_REFRESH'') from sys.dual ) needs_refresh,',
'           ( select wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_UNKNOWN'') from sys.dual ) unknown_status,',
'           ( select wwv_flow_lang_dev.builder_message(''SUBSCRIBED_FROM.NONEXISTING_MASTER'') from sys.dual ) no_master',
'      from sys.dual )',
'select ',
'       case',
'         when a.id = f.authentication_id then',
'            ''icon-sc-authentication-scheme-on''',
'         else',
'            ''icon-sc-authentication-scheme-off''',
'       end as icon_class,',
'       ''f?p=4000:4495:''||:APP_SESSION||'':::RP,4495:P4495_ID:''||a.id as edit_link,',
'       replace(a.name,''_'','' '') as icon_title,',
'       a.name,',
'       case',
'         when a.id = f.authentication_id ',
'         then ''Y'' ',
'         else ''N''',
'       end as is_current_yn,',
'       a.scheme_type,',
'       a.id,',
'       a.cookie_name,',
'       a.cookie_path,',
'       a.cookie_domain,',
'       a.use_secure_cookie_yn,',
'       a.help_text,',
'       case when a.reference_id is not null then',
'           coalesce ( to_char( master.flow_id ),',
'                      messages.no_master )',
'       end as subscribed_from,',
'       ( select case when count(*) > 0 then count(*) end',
'           from wwv_flow_authentications',
'          where reference_id      = a.id',
'            and security_group_id = :WORKSPACE_ID ) as subscribers,',
'       case when a.reference_id is not null then',
'           case',
'               when master.version_scn = a.version_scn then',
'                   messages.up_to_date',
'               when master.version_scn != a.version_scn then',
'                   messages.needs_refresh',
'               else',
'                   messages.unknown_status',
'           end',
'       end subscription_status,',
'       a.created_by,',
'       a.created_on,',
'       a.last_updated_by,',
'       a.last_updated_on',
'  from wwv_flow_authentications a,',
'       wwv_flow_authentications master,',
'       wwv_flows f,',
'       messages',
' where a.flow_id           = :FB_FLOW_ID',
'   and a.security_group_id = :WORKSPACE_ID',
'   and f.id                = a.flow_id',
'   and a.reference_id      = master.id (+)',
'   and a.security_group_id = master.security_group_id (+)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(47918412797645641)
,p_name=>'Authentication Schemes'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#EDIT_LINK#" class="a-IRR-icon"><span class="a-Icon #ICON_CLASS#"></span><span class="a-IRR-iconName">#ICON_TITLE#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(398863113666021219)
,p_db_column_name=>'NAME'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Name'
,p_column_link=>'f?p=&APP_ID.:4495:&SESSION.::&DEBUG.:RP,4495:P4495_ID:#ID#:'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(23491843305297501)
,p_db_column_name=>'IS_CURRENT_YN'
,p_display_order=>19
,p_column_identifier=>'Z'
,p_column_label=>'Is Current'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(84887415298521126)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(399114224317043174)
,p_db_column_name=>'SCHEME_TYPE'
,p_display_order=>29
,p_column_identifier=>'K'
,p_column_label=>'Scheme Type'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(346988529123216543)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1340562182342198331)
,p_db_column_name=>'SUBSCRIBED_FROM'
,p_display_order=>39
,p_column_identifier=>'T'
,p_column_label=>'Subscribed From'
,p_column_type=>'STRING'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1340562255618198332)
,p_db_column_name=>'SUBSCRIBERS'
,p_display_order=>49
,p_column_identifier=>'U'
,p_column_label=>'Subscribers'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(399006525571034147)
,p_db_column_name=>'ID'
,p_display_order=>59
,p_column_identifier=>'J'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(155898325604349752)
,p_db_column_name=>'COOKIE_NAME'
,p_display_order=>69
,p_column_identifier=>'L'
,p_column_label=>'Cookie Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(155898427979349755)
,p_db_column_name=>'COOKIE_PATH'
,p_display_order=>79
,p_column_identifier=>'M'
,p_column_label=>'Cookie Path'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(155898513392349755)
,p_db_column_name=>'COOKIE_DOMAIN'
,p_display_order=>89
,p_column_identifier=>'N'
,p_column_label=>'Cookie Domain'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(155898602987349755)
,p_db_column_name=>'USE_SECURE_COOKIE_YN'
,p_display_order=>99
,p_column_identifier=>'O'
,p_column_label=>'HTTPS Cookie'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(155898703994349756)
,p_db_column_name=>'HELP_TEXT'
,p_display_order=>109
,p_column_identifier=>'P'
,p_column_label=>'Help Text'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(656853828101717526)
,p_db_column_name=>'ICON_CLASS'
,p_display_order=>119
,p_column_identifier=>'Q'
,p_column_label=>'Icon Class'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(656853982117717526)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>129
,p_column_identifier=>'R'
,p_column_label=>'Edit Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(656859293293774521)
,p_db_column_name=>'ICON_TITLE'
,p_display_order=>139
,p_column_identifier=>'S'
,p_column_label=>'Icon Title'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(222858940690540017)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>149
,p_column_identifier=>'V'
,p_column_label=>'Created By'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(222859088703540018)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>159
,p_column_identifier=>'W'
,p_column_label=>'Created'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(222859136725540019)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>169
,p_column_identifier=>'X'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(222859219289540020)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>179
,p_column_identifier=>'Y'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5728620511070701)
,p_db_column_name=>'SUBSCRIPTION_STATUS'
,p_display_order=>189
,p_column_identifier=>'AA'
,p_column_label=>'Subscription Status'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(47921608032702994)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_type=>'REPORT'
,p_report_alias=>'1291429712536644'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_view_mode=>'REPORT'
,p_report_columns=>'NAME:IS_CURRENT_YN:SCHEME_TYPE:SUBSCRIBED_FROM:SUBSCRIPTION_STATUS:SUBSCRIBERS:LAST_UPDATED_ON:'
,p_sort_column_1=>'NAME'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'0'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(61795008932189803)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--sideRegion:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>An Authentication Scheme is saved configuration you can apply to your application.</p>',
'<p>To turn off authentication you must create and make current a <strong>No Authentication</strong> scheme.</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(180425906908074887)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(180433926348108856)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Authentication Schemes'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(188928627610654843)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(47918318810645641)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:801:&SESSION.::&DEBUG.:801,RIR::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(62399523648756214)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(47918318810645641)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:815:&SESSION.::&DEBUG.:4495:::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5737799683026030)
,p_name=>'Refresh Subscriptions'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(17436505551397155)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5738121420026028)
,p_event_id=>wwv_flow_imp.id(5737799683026030)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(47918318810645641)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5738626377026027)
,p_event_id=>wwv_flow_imp.id(5737799683026030)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ( this.data.successMessage ) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
);
end;
/
prompt --application/pages/page_00802
begin
wwv_flow_imp_page.create_page(
 p_id=>802
,p_name=>'Resequence Install Scripts'
,p_alias=>'RESEQUENCE-INSTALL-SCRIPTS'
,p_step_title=>'Resequence Install Scripts'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_pg_def_common.htm'
,p_page_component_map=>'11'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(236541617339568977)
,p_plug_name=>'Resequence'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>100
,p_plug_source=>'<p>Resequence installation scripts, incrementing sequence numbers by 10.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(236541808541568977)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(236541617339568977)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:473:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(236542010307568977)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(236541617339568977)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Resequence'
,p_button_position=>'CREATE'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(236543508820568984)
,p_branch_action=>'f?p=&APP_ID.:473:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(236543227474568981)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'resequence installation script'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  s number := 0;',
'begin',
'  for c1 in (',
'    select id, sequence',
'    from wwv_flow_install_scripts',
'    where flow_id = :fb_flow_id ',
'    and security_group_id = :flow_security_group_id',
'    and nvl(script_type,''INSTALL'') = ''INSTALL''',
'    order by sequence)',
'  loop',
'    s := s + 10;',
'    update wwv_flow_install_scripts',
'    set sequence = s',
'    where flow_id = :fb_flow_id ',
'    and security_group_id = :flow_security_group_id ',
'    and id = c1.id',
'    and sequence != s;',
'  end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(236542010307568977)
,p_process_success_message=>'Installation script cleaned up.'
,p_internal_uid=>236543227474568981
);
end;
/
prompt --application/pages/page_00815
begin
wwv_flow_imp_page.create_page(
 p_id=>815
,p_name=>'Create Authentication Scheme - Method'
,p_alias=>'CREATE-AUTHENTICATION-SCHEME-METHOD'
,p_step_title=>'Create Authentication Scheme'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213425326892450628)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_authentication.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8428524427164207)
,p_plug_name=>'Information'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(399849897040726767)
,p_plug_display_sequence=>20
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p class="instructiontext">',
'You may create a new authentication scheme by making a copy of one in this application or in another application in your workspace. Then you can edit the new scheme, changing the name to what you prefer and changing any of the settings to meet your r'
||'equirements.',
'</p>',
'<p class="instructiontext">',
'You may also select to add an authentication scheme to the current application by selecting one from the gallery of provided schemes.',
'</p>',
'<p class="instructiontext">',
'Alternately, you may create a new authentication scheme from scratch by stepping through the wizard and specifying all of the parameters.  To create an authentication scheme from scratch, select "Based on a pre-configured scheme from the gallery" and'
||' then select the scheme type of "Custom".',
'</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'Region generated 26-JUN-2002 03:01:48'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(62446113813791403)
,p_plug_name=>'Create Authentication Scheme'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_header=>'<p>When you create a new authentication scheme, you have several options. Most let you reuse implementations that already exist in your application or in other applications within your workspace. There are even some pretested schemes you can copy to '
||'get you up and running immediately.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(109995619468692916)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(109993128340686080)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(208125022192147884)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747145769384138171)
,p_plug_name=>'Create Authentication Scheme'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(62451616123810812)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(208125022192147884)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:801:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(713325171828085)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(208125022192147884)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(403061925280488166)
,p_branch_action=>'f?p=&APP_ID.:816:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(713325171828085)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'F4000_P815_ACTION'
,p_branch_condition_text=>'COPY'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(403164909828493232)
,p_branch_action=>'f?p=&APP_ID.:4495:&SESSION.::&DEBUG.:RP,4495::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(713325171828085)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'F4000_P815_ACTION'
,p_branch_condition_text=>'CREATE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(62464516123866306)
,p_name=>'F4000_P815_ACTION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(62446113813791403)
,p_item_default=>'CREATE'
,p_prompt=>'Create Scheme:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,r from (',
'    select wwv_flow_lang.system_message(''F4000_P815_SCRATCH'') d,''CREATE'' r,',
'      1 ob from dual',
'    union',
'    select wwv_flow_lang.system_message(''F4000_P815_COPY'') d, ''COPY'' r,',
'      2 ob from dual',
')',
'order by ob'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT-TOP'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_escape_on_http_output=>'N'
,p_help_text=>'Select the method by which you would like to create an authentication scheme.  Click the Information link below for more details.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
end;
/
prompt --application/pages/page_00816
begin
wwv_flow_imp_page.create_page(
 p_id=>816
,p_name=>'Create Authentication Scheme - Scheme'
,p_alias=>'CREATE-AUTHENTICATION-SCHEME-SCHEME'
,p_step_title=>'Create Authentication Scheme'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213425326892450628)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_authentication.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1251320063887658)
,p_plug_name=>'Create Authentication Scheme'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_header=>'<p>Use this page to copy an authentication scheme from another application.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(109997807824699042)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(109993128340686080)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(208126821630157159)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747145864397138172)
,p_plug_name=>'Create Authentication Scheme'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1251504424887662)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(208126821630157159)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:801:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1251804007887667)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(208126821630157159)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1257123264918315)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(208126821630157159)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1253617234887694)
,p_branch_action=>'818'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(1251804007887667)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1253003892887691)
,p_branch_action=>'815'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(1257123264918315)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1259804713073810)
,p_name=>'F4000_P816_COPY_FROM'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1251320063887658)
,p_prompt=>'Copy From Application'
,p_source=>'&FB_FLOW_ID.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'       f.id||'' ''||wwv_flow_escape.html(f.name) as d,',
'       f.id as rr',
'  from wwv_flows f',
' where f.security_group_id = :WORKSPACE_ID',
'   and exists ( select 1',
'                  from wwv_flow_authentications a',
'                 where a.flow_id = f.id',
'              )',
' order by f.id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select an Application -'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Select an application to copy the authentication scheme from.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
end;
/
prompt --application/pages/page_00818
begin
wwv_flow_imp_page.create_page(
 p_id=>818
,p_name=>'Create Authentication Scheme - Confirm'
,p_alias=>'CREATE-AUTHENTICATION-SCHEME-CONFIRM'
,p_step_title=>'Create Authentication Scheme'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213425326892450628)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_authentication.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(1270127414132552)
,p_name=>'Create Authentication Scheme'
,p_template=>wwv_flow_imp.id(42025417508627628)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select flow_id, ',
'       name, ',
'       ''<label for="ToName''||rownum||''" class="hideMe508">To Name</label>''||',
'       wwv_flow_item.text (',
'           1,',
'           wwv_flow_lang.system_message(''F4000.P158.COPY_OF'', name),',
'           40,',
'           255,',
'           ''id="ToName''||rownum||''"'') to_name,',
'       ''<label for="copy''||rownum||''" class="hideMe508">Copy</label>''||',
'       wwv_flow_item.select_list (',
'           2,',
'           ''N'',',
'           m_yes||'';Y,''||m_no||'';N''||case when :F4000_P816_COPY_FROM <> :FB_FLOW_ID then '',''||m_copy_sub||'';SUBSCRIBE'' end,',
'           ''id="copy''||rownum||''"'') copy_subscribe,',
'       wwv_flow_item.hidden(3,id) id',
'  from wwv_flow_authentications,',
'       ( select wwv_flow_lang.system_message(''F4000.YES'') m_yes,',
'                wwv_flow_lang.system_message(''F4000.NO'') m_no,',
'                wwv_flow_lang.system_message(''F4000_COPY_AND_SUBSCRIBE'') m_copy_sub',
'           from dual )',
'where flow_id           = :F4000_P816_COPY_FROM',
'  and security_group_id = :flow_security_group_id',
'order by 1, 2'))
,p_header=>'<p>You can choose to copy or copy and subscribe to an authentication scheme in the application you select as the copy source.  Subscribing to an authentication scheme puts a copy of it in your application but allows you to refresh it periodically to '
||'get the latest changes.</p>'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(923576727441744013)
,p_query_column_id=>1
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Application'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(923576842361744014)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'From Name'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(923576926294744015)
,p_query_column_id=>3
,p_column_alias=>'TO_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'To Name'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(923577080583744016)
,p_query_column_id=>4
,p_column_alias=>'COPY_SUBSCRIBE'
,p_column_display_sequence=>4
,p_column_heading=>'Copy'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'#COPY_SUBSCRIBE##ID#'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(923577196508744017)
,p_query_column_id=>5
,p_column_alias=>'ID'
,p_column_display_sequence=>5
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(110000800683706473)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(109993128340686080)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(208152522818668422)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747145962058138172)
,p_plug_name=>'Create Authentication Scheme'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1270316928132553)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(208152522818668422)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1270617619132554)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(208152522818668422)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy Scheme'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1270932119132555)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(208152522818668422)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(41480412040672877)
,p_branch_action=>'f?p=&FLOW_ID.:801:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1271922849132559)
,p_branch_action=>'801'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(1270316928132553)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1271615940132558)
,p_branch_action=>'816'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(1270932119132555)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1272501891132562)
,p_validation_name=>'flow id not null'
,p_validation_sequence=>10
,p_validation=>'F4000_P816_COPY_FROM'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Application ID must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(1270617619132554)
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(78629723361199740)
,p_validation_name=>'MustHaveSomethingToCopy'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'begin',
'for i in 1..wwv_flow.g_f03.count loop',
'  if wwv_flow.g_f02(i) in (''Y'',''SUBSCRIBE'')',
'     then return null;',
'  end if;',
'end loop;',
'return wwv_flow_lang.system_message(''F4000.P818.VALIDATION'');',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Must have something to copy.'
,p_when_button_pressed=>wwv_flow_imp.id(1270617619132554)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(8281153296864401)
,p_validation_name=>'No Duplicate Subscriptions'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f03.count loop',
'    if wwv_flow.g_f02(i) = ''SUBSCRIBE'' then',
'        for j in (',
'            select m.name',
'              from wwv_flow_authentications s,',
'                   wwv_flow_authentications m',
'             where s.flow_id           = :FB_FLOW_ID',
'               and s.security_group_id = :WORKSPACE_ID',
'               and s.reference_id      = wwv_flow.g_f03(i)',
'               and s.reference_id      = m.id',
'               and m.security_group_id = :WORKSPACE_ID )',
'        loop',
'            return wwv_flow_lang.system_message( ',
'                       p_name => ''F4000.P818.VALIDATION.NO_DUPLICATE_SUBSCRIPTION'',',
'                       p0     => j.name );',
'        end loop;               ',
'    end if;',
'end loop;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_when_button_pressed=>wwv_flow_imp.id(1270617619132554)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(8281285366864402)
,p_validation_name=>'No Duplicate Names'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'    l_name wwv_flow_authentications.name%type;',
'begin    ',
'    for i in 1..wwv_flow.g_f03.count loop',
'        if wwv_flow.g_f02(i) = ''SUBSCRIBE'' then',
'            select name ',
'              into l_name',
'              from wwv_flow_authentications',
'             where id                = wwv_flow.g_f03(i)',
'               and security_group_id = :WORKSPACE_ID;',
'        elsif wwv_flow.g_f02(i) = ''Y'' then ',
'            l_name := wwv_flow.g_f01(i);',
'        end if;',
'',
'        for j in (',
'            select name',
'              from wwv_flow_authentications s',
'             where s.flow_id           = :FB_FLOW_ID',
'               and s.security_group_id = :WORKSPACE_ID',
'               and s.name              = l_name )',
'        loop',
'            return wwv_flow_lang.system_message( ',
'                       p_name => ''F4000.P818.VALIDATION.NO_DUPLICATE_NAMES'',',
'                       p0     => l_name );',
'        end loop;               ',
'    end loop;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_when_button_pressed=>wwv_flow_imp.id(1270617619132554)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1287519501295760)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Auth Scheme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_authentication_id number;',
'begin',
'    for i in 1..wwv_flow.g_f03.count loop',
'        if wwv_flow.g_f02(i) in (''Y'',''SUBSCRIBE'') then',
'        l_authentication_id := wwv_flow_copy_metadata.copy_authentication (',
'                                   p_copy_from_flow_id      => :F4000_P816_COPY_FROM,',
'                                   p_flow_id                => :FB_FLOW_ID,',
'                                   p_from_authentication_id => wwv_flow.g_f03(i),                                   ',
'                                   p_to_authentication_name => nvl(wwv_flow.g_f01(i),''Copy of ''||i),',
'                                   p_subscribe              => (wwv_flow.g_f02(i) = ''SUBSCRIBE'') );',
'        end if;',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying  authentication scheme.'
,p_process_when_button_id=>wwv_flow_imp.id(1270617619132554)
,p_process_success_message=>'Authentication scheme copied.'
,p_internal_uid=>1287519501295760
);
end;
/
prompt --application/pages/page_00836
begin
wwv_flow_imp_page.create_page(
 p_id=>836
,p_name=>'Edit Calendar Template'
,p_alias=>'EDIT-CALENDAR-TEMPLATE5'
,p_step_title=>'Edit Calendar Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'EXISTS'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_cal_templates t, wwv_flow_themes th',
'where t.id = :F4000_P697_ID',
'and t.flow_id = th.flow_id',
'and t.theme_id = th.theme_id',
'and t.reference_id is not null',
'and th.reference_id is not null'))
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30736404037181311)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(12991522578387911)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30736610598181325)
,p_plug_name=>'Page Button Button Box'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>130
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30736820787181326)
,p_plug_name=>'Calendar Template'
,p_region_name=>'NAME'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_plug_display_condition_type=>'NEVER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30737221419181328)
,p_plug_name=>'Month Formats'
,p_region_name=>'MON'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30737408206181328)
,p_plug_name=>'Week  Formats'
,p_region_name=>'WEEK'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30737616215181329)
,p_plug_name=>'Weekday  Formats'
,p_region_name=>'DAY'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30737832425181329)
,p_plug_name=>'Non-Day  Formats'
,p_region_name=>'NON'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30738007980181329)
,p_plug_name=>'Weekend  Formats'
,p_region_name=>'END'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30738205604181329)
,p_plug_name=>'Calendar Templates'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>150
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Calendar templates control the appearance and placement of a calendar. Calendar templates frequently use HTML tables to arrange dates.</p>',
'<p>You place calendar attributes using substitution strings such as #DD# and  #MONTH#. Template substitution strings must be in upper case and begin and end with a pound sign (#).</p>'))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30738821398181332)
,p_plug_name=>'Substitution Strings'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>160
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The following date format substitution strings are available:</p>',
'<ul class="noIndent">',
'<li>DAY</li>',
'<li>DD</li>',
'<li>MON</li>',
'<li>YYYY</li>',
'<li>MM</li>',
'<li>MONTH</li>',
'<li>YY</li>',
'<li>RR</li>',
'<li>YEAR</li>',
'<li>WW</li>',
'<li>W</li>',
'<li>DDD</li>',
'<li>D</li>',
'<li>DY</li>',
'<li>DDSPTH</li>',
'<li>TIME</li>',
'<li>HH</li>',
'<li>HH12</li>',
'<li>HH24</li>',
'<li>AM</li>',
'<li>PM</li>',
'<li>MI</li>',
'<li>SYEAR</li>',
'<li>BC</li>',
'<li>CC</li>',
'<li>SCC</li>',
'<li>IYYY</li>',
'<li>Q</li>',
'<li>FMMONTH</li>',
'<li>RM</li>',
'<li>IW</li>',
'<li>FMDAY</li>',
'<li>DDTH</li>',
'<li>DDSPTH</li>',
'<li>J</li>',
'<li>FMHH</li>',
'<li>FMMI</li>',
'</ul>',
'<p>Placing an "I" in front of any string will INITCAP the text.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(32670615821238675)
,p_plug_name=>'Hour  Formats'
,p_region_name=>'HOUR'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(32672327596242041)
,p_plug_name=>'Time Formats'
,p_region_name=>'TIME'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(34021815937892872)
,p_plug_name=>'Day Attributes'
,p_region_name=>'DATT'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46249001042678993)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>140
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30741104924181363)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(30736610598181325)
,p_button_name=>'APPLY_CHANGES_GET_PREVIOUS_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'disabled=""'
,p_button_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30740911649181362)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_imp.id(30736610598181325)
,p_button_name=>'APPLY_CHANGES_GET_NEXT_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Next'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'disabled=""'
,p_button_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30740307605181362)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(30736610598181325)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30740726818181362)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(30736610598181325)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:504:&SESSION.::&DEBUG.::P504_ID:&P836_ID.'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P697_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30740132369181361)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(30736610598181325)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P697_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(30757501612181430)
,p_branch_action=>'f?p=&APP_ID.:836:&SESSION.::&DEBUG.::P836_ID:&P836_ID_NEXT.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(30740911649181362)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(30757728889181432)
,p_branch_action=>'f?p=&APP_ID.:836:&SESSION.::&DEBUG.::P836_ID:&P836_ID_PREV.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(30741104924181363)
,p_branch_sequence=>20
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(30758127950181432)
,p_branch_action=>'f?p=&APP_ID.:670:&SESSION.::&DEBUG.::P670_ID:&P836_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_WEEKLY_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(30758314701181433)
,p_branch_action=>'f?p=&APP_ID.:661:&SESSION.::&DEBUG.::P661_ID:&P836_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_DAILY_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(30780705699970362)
,p_branch_action=>'f?p=&APP_ID.:122:&SESSION.::&DEBUG.::P122_ID:&P836_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_MONTHLY_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3696802231121039)
,p_branch_action=>'f?p=&APP_ID.:80:&SESSION.::&DEBUG.::P80_ID:&P836_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_AGENDA_CALENDAR'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(30758530672181433)
,p_branch_action=>'f?p=&APP_ID.:697:&SESSION.::&DEBUG.::F4000_P697_ID:&P836_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>70
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_CALENDAR_DEFINITION'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(30758732438181433)
,p_branch_action=>'f?p=&APP_ID.:836:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>80
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P836_STAY'
,p_branch_condition_text=>'YES'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(30757906580181432)
,p_branch_name=>'Go To Page 836'
,p_branch_action=>'f?p=&APP_ID.:836:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>90
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(30758900723181433)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>100
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(30759106723181436)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>120
,p_branch_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30741325154181363)
,p_name=>'P836_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(30736820787181326)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30741530244181368)
,p_name=>'P836_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(30736820787181326)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Defines a name that identifies the template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30742209376181373)
,p_name=>'P836_CUSTOM_MONTH_TITLE_FORMAT'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(30737221419181328)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Month Title Format'
,p_source=>'CUSTOM_MONTH_TITLE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the format for the monthly title that appears at the top of each month. This is the first part of a calendar which is printed on the page.',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'&lt;table&gt;',
' &lt;tr&gt;',
'   &lt;td&gt;#MONTH#&lt;/td&gt;',
' &lt;/tr&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30742716410181374)
,p_name=>'P836_CUSTOM_DAY_OF_WEEK_FORMAT'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(30737221419181328)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Day Of Week Format'
,p_source=>'CUSTOM_DAY_OF_WEEK_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the format for the week day names which display as the column header for that day of the week.  ',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'   &lt;th width="14%"&gt;#IDAY#&lt;/th&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30743215850181375)
,p_name=>'P836_CUSTOM_MONTH_OPEN_FORMAT'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(30737221419181328)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Month Open Format'
,p_source=>'CUSTOM_MONTH_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the HTML to be used to open a month.  This is printed immediately after the "Month Title Format".  Usually this would be an HTML tag which is a container such as a table.  ',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'   &lt;table  border="0" cellpadding="0" cellspacing="0" class="htmldbRowWithBorders" width="100%"&gt;&lt;tr&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30743701101181375)
,p_name=>'P836_CUSTOM_MONTH_CLOSE_FORMAT'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(30737221419181328)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Month Close Format'
,p_source=>'CUSTOM_MONTH_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the HTML to be used to close a month.  This is the last part printed so this should close any HTML tags which have been used such as the tag used in the "Month Open Format"',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'   &lt;/table&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30744206412181376)
,p_name=>'P836_CUSTOM_DAY_TITLE_FORMAT'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_imp.id(30737616215181329)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Day Title Format'
,p_source=>'CUSTOM_DAY_TITLE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the HTML to be used for the day''s title which the first thing printed after the "Day Open Format" ',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'#DD#',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30744700766181377)
,p_name=>'P836_CUSTOM_DAY_OPEN_FORMAT'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_imp.id(30737616215181329)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Day Open Format'
,p_source=>'CUSTOM_DAY_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the HTML to be used to opening a day. This is printed for each day. Usually this would be an HTML tag which is a container such as a td.  Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.'
||' For example:',
'<pre>',
' &lt;td&gt',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30745225658181378)
,p_name=>'P836_CUSTOM_DAY_CLOSE_FORMAT'
,p_item_sequence=>260
,p_item_plug_id=>wwv_flow_imp.id(30737616215181329)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Day Close Format'
,p_source=>'CUSTOM_DAY_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the HTML to be used to close a day.  This is the last part of each day printed so this should close any HTML tags which have been used such as the tag used in the "Day Open Format"',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'   &lt;/td&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30745716938181378)
,p_name=>'P836_CUSTOM_TODAY_OPEN_FORMAT'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_imp.id(30737616215181329)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Today Open Format'
,p_source=>'CUSTOM_TODAY_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the HTML to be used to open today. Usually this would be an HTML tag which is a container such as a td and would be different somehow from the "Day Open Format". Include substitution strings to include dynamic content. See the "Substitution Str'
||'ings" for the full list. For example:',
'<pre>',
'  &lt;td style="background:#c5d5c5"&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30746228616181379)
,p_name=>'P836_CUSTOM_WEEKEND_TITLE_FORMAT'
,p_item_sequence=>360
,p_item_plug_id=>wwv_flow_imp.id(30738007980181329)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Weekend Title Format'
,p_source=>'CUSTOM_WEEKEND_TITLE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter HTML be used to for a day occurring on a weekend. ',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'#DD#',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30746721401181379)
,p_name=>'P836_CUSTOM_WEEKEND_OPEN_FORMAT'
,p_item_sequence=>380
,p_item_plug_id=>wwv_flow_imp.id(30738007980181329)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Weekend Open Format'
,p_source=>'CUSTOM_WEEKEND_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter HTML used to open a day which is on a weekend. Usually this would be an HTML tag which is a container such as a TD. Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list. For example:',
'<pre>',
' &lt;td&gt',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30747207758181380)
,p_name=>'P836_CUSTOM_WEEKEND_CLOSE_FORMAT'
,p_item_sequence=>400
,p_item_plug_id=>wwv_flow_imp.id(30738007980181329)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Weekend Close Format'
,p_source=>'CUSTOM_WEEKEND_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter HTML used to close a day which is on a weekend. This is the last part of each weekend day printed so this should close any HTML tags which have been used such as the tag used in the "Weekend Open Format"',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'   &lt;/td&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30747718454181380)
,p_name=>'P836_CUSTOM_NONDAY_TITLE_FORMAT'
,p_item_sequence=>330
,p_item_plug_id=>wwv_flow_imp.id(30737832425181329)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Non-Day Title Format'
,p_source=>'CUSTOM_NONDAY_TITLE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter HTML used to format a non-day title. For example, suppose the first of a month is a Monday, but the week starts on a Sunday. Since Sunday is not be part of the current month, Sunday would be a non-day.',
'<p> See the "Substitution Strings" for the full list. For example:',
'<pre>',
'  #DD#',
'</pre>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30748208700181381)
,p_name=>'P836_CUSTOM_NONDAY_OPEN_FORMAT'
,p_item_sequence=>340
,p_item_plug_id=>wwv_flow_imp.id(30737832425181329)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Non-Day Open Format'
,p_source=>'CUSTOM_NONDAY_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter HTML to open a non-day. For example, suppose the first of a month is a Monday, but the week starts on a Sunday. Since Sunday is not be part of the current month, Sunday would be a non-day.',
'',
'<p>Usually this would be an HTML tag which is a container such as a td. Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list. For example:',
'<pre>',
'  &lt;td&gt;',
'</pre>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30748717902181381)
,p_name=>'P836_CUSTOM_NONDAY_CLOSE_FORMAT'
,p_item_sequence=>350
,p_item_plug_id=>wwv_flow_imp.id(30737832425181329)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Non-Day Close Format'
,p_source=>'CUSTOM_NONDAY_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the html which will close a non-day.  For example, when the first of a month is on a Monday and the week starts on a Sunday, Sunday would not have a date in the current month and therefore be a non-day.',
'<p>Usually this would be an HTML tag which closes the tag used in the "Non-Day Open Format".',
' Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list. For example:',
'<pre>',
'  &lt;/td&gt;',
'</pre>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30749724235181382)
,p_name=>'P836_CUSTOM_WEEK_OPEN_FORMAT'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(30737408206181328)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Week Open Format'
,p_source=>'CUSTOM_WEEK_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the HTML to be used to open a week. This is printed for each week. Usually this would be an HTML tag which is a container such as a tr. Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list. F'
||'or example:',
'<pre>',
' &lt;tr&gt;'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30750211397181382)
,p_name=>'P836_CUSTOM_WEEK_CLOSE_FORMAT'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(30737408206181328)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Week Close Format'
,p_source=>'CUSTOM_WEEK_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the HTML to be used to close a week.  This is the last part printed so this should close any HTML tags which have been used such as the tag used in the "Week Open Format"',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'   &lt;/tr&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30752726031181390)
,p_name=>'P836_STAY'
,p_item_sequence=>550
,p_item_plug_id=>wwv_flow_imp.id(30738205604181329)
,p_prompt=>'Stay on page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select this checkbox to stay on this page after applying changes.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'YES'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30753426836181392)
,p_name=>'P836_THEME_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(30736820787181326)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Theme:'
,p_source=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Indicates the theme to which the template is a member.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30753906432181393)
,p_name=>'P836_THEME_CLASS_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(30736820787181326)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Template Class'
,p_source=>'THEME_CLASS_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CALENDAR THEME CLASS ID'
,p_lov=>'.'||wwv_flow_imp.id(43619531898960304)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Not Identified -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Identifies a specific usage for this template.</div>',
'<div class="htmldbInfoBodyP">When you switch to a new theme, all templates in one theme are assigned to corresponding templates in another theme. App Builder accomplishes this template mapping through the assignment of template class identifiers.</di'
||'v>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30754908612181407)
,p_name=>'P836_ID_NEXT'
,p_item_sequence=>520
,p_item_plug_id=>wwv_flow_imp.id(30736610598181325)
,p_prompt=>'P836_ID_NEXT'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30755120633181415)
,p_name=>'P836_ID_PREV'
,p_item_sequence=>530
,p_item_plug_id=>wwv_flow_imp.id(30736610598181325)
,p_prompt=>'P836_ID_PREV'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30755306801181415)
,p_name=>'P836_ID_COUNT'
,p_item_sequence=>540
,p_item_plug_id=>wwv_flow_imp.id(30736610598181325)
,p_prompt=>'Calendar Template: '
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies calendar template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(32671418985238695)
,p_name=>'P836_CUSTOM_HOUR_OPEN_FORMAT'
,p_item_sequence=>430
,p_item_plug_id=>wwv_flow_imp.id(32670615821238675)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Hour Open Format'
,p_source=>'CUSTOM_HOUR_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the HTML to be used to open a hour. This is printed for each hour. Usually this would be an HTML tag which is a container such as a tr. Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list. F'
||'or example:',
'<pre>',
' &lt;tr&gt;'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(32671916155238696)
,p_name=>'P836_CUSTOM_HOUR_CLOSE_FORMAT'
,p_item_sequence=>440
,p_item_plug_id=>wwv_flow_imp.id(32670615821238675)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Hour Close Format'
,p_source=>'CUSTOM_HOUR_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the HTML to be used to close a hour.  This is the last part printed so this should close any HTML tags which have been used such as the tag used in the "Hour Open Format"',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'   &lt;/tr&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(32672624745242044)
,p_name=>'P836_CUSTOM_TIME_TITLE_FORMAT'
,p_item_sequence=>450
,p_item_plug_id=>wwv_flow_imp.id(32672327596242041)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Time Title Format'
,p_source=>'CUSTOM_TIME_TITLE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter HTML used to format a Time title. ',
'<p> See the "Substitution Strings" for the full list. For example:',
'<pre>',
'  #HH:MI#',
'</pre>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(32673110345242044)
,p_name=>'P836_CUSTOM_TIME_OPEN_FORMAT'
,p_item_sequence=>460
,p_item_plug_id=>wwv_flow_imp.id(32672327596242041)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Time Open Format'
,p_source=>'CUSTOM_TIME_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter HTML to open a Time. ',
'',
'<p>Usually this would be an HTML tag which is a container such as a td. Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list. For example:',
'<pre>',
'  &lt;td&gt;',
'</pre>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(32673625667242044)
,p_name=>'P836_CUSTOM_TIME_CLOSE_FORMAT'
,p_item_sequence=>470
,p_item_plug_id=>wwv_flow_imp.id(32672327596242041)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Time Close Format'
,p_source=>'CUSTOM_TIME_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the html which will close a Time.  ',
'<p>Usually this would be an HTML tag which closes the tag used in the "Time Open Format".',
' Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list. For example:',
'<pre>',
'  &lt;/td&gt;',
'</pre>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(32971704043689629)
,p_name=>'P836_CUSTOM_WK_MONTH_TITLE_FORMAT'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(30737221419181328)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Alternate Month Title Format '
,p_source=>'CUSTOM_WK_MONTH_TITLE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the format for the monthly title that appears at the top of each month. This is the first part of a calendar which is printed on the page.',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'&lt;table&gt;',
' &lt;tr&gt;',
'   &lt;td&gt;#MONTH#&lt;/td&gt;',
' &lt;/tr&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(32972700842707637)
,p_name=>'P836_CUSTOM_WK_DAY_OF_WEEK_FORMAT'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(30737221419181328)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Alternate Day Of Week Format'
,p_source=>'CUSTOM_WK_DAY_OF_WEEK_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the format for the week day names which display as the column header for that day of the week.  ',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'   &lt;th width="14%"&gt;#IDAY#&lt;/th&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(32973207720721634)
,p_name=>'P836_CUSTOM_WK_MONTH_OPEN_FORMAT'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(30737221419181328)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Alternate Month Open Format'
,p_source=>'CUSTOM_WK_MONTH_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the HTML to be used to open a month.  This is printed immediately after the "Month Title Format".  Usually this would be an HTML tag which is a container such as a table.  ',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'   &lt;table  border="0" cellpadding="0" cellspacing="0" class="htmldbRowWithBorders" width="100%"&gt;&lt;tr&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(32973709929731745)
,p_name=>'P836_CUSTOM_WK_MONTH_CLOSE_FORMAT'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(30737221419181328)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Alternate Month Close Format'
,p_source=>'CUSTOM_WK_MONTH_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the HTML to be used to close a month.  This is the last part printed so this should close any HTML tags which have been used such as the tag used in the "Month Open Format"',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'   &lt;/table&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(32974629771869869)
,p_name=>'P836_CUSTOM_WK_WEEK_OPEN_FORMAT'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(30737408206181328)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Alternate Week Open Format'
,p_source=>'CUSTOM_WK_WEEK_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the HTML to be used to open a week. This is printed for each week. Usually this would be an HTML tag which is a container such as a tr. Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list. F'
||'or example:',
'<pre>',
' &lt;tr&gt;'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(32975113064883973)
,p_name=>'P836_CUSTOM_WK_WEEK_CLOSE_FORMAT'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_imp.id(30737408206181328)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Alternate Week Close Format'
,p_source=>'CUSTOM_WK_WEEK_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the HTML to be used to close a week.  This is the last part printed so this should close any HTML tags which have been used such as the tag used in the "Week Open Format"',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'   &lt;/tr&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33036502702808166)
,p_name=>'P836_CUSTOM_WK_DAY_TITLE_FORMAT'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_imp.id(30737616215181329)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Alternate Day Title Format'
,p_source=>'CUSTOM_WK_DAY_TITLE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the HTML to be used for the day''s title which the first thing printed after the "Day Open Format" ',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'#DD#',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33037624519814502)
,p_name=>'P836_CUSTOM_WK_DAY_OPEN_FORMAT'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_imp.id(30737616215181329)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Alternate Day Open Format'
,p_source=>'CUSTOM_WK_DAY_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the HTML to be used to opening a day. This is printed for each day. Usually this would be an HTML tag which is a container such as a td.  Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.'
||' For example:',
'<pre>',
' &lt;td&gt',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33038218070822099)
,p_name=>'P836_CUSTOM_WK_DAY_CLOSE_FORMAT'
,p_item_sequence=>270
,p_item_plug_id=>wwv_flow_imp.id(30737616215181329)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Alternate Day Close Format'
,p_source=>'CUSTOM_WK_DAY_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the HTML to be used to close a day.  This is the last part of each day printed so this should close any HTML tags which have been used such as the tag used in the "Day Open Format"',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'   &lt;/td&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33040711191848424)
,p_name=>'P836_CUSTOM_WK_TODAY_OPEN_FORMAT'
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_imp.id(30737616215181329)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Alternate Today Open Format'
,p_source=>'CUSTOM_WK_TODAY_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the HTML to be used to open today. Usually this would be an HTML tag which is a container such as a td and would be different somehow from the "Day Open Format". Include substitution strings to include dynamic content. See the "Substitution Str'
||'ings" for the full list. For example:',
'<pre>',
'  &lt;td style="background:#c5d5c5"&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33051806099979442)
,p_name=>'P836_CUSTOM_WK_WEEKEND_TITLE_FORMAT'
,p_item_sequence=>370
,p_item_plug_id=>wwv_flow_imp.id(30738007980181329)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Alternate Weekend Title Format'
,p_source=>'CUSTOM_WK_WEEKEND_TITLE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter HTML be used to for a day occurring on a weekend. ',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'#DD#',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33052319258983294)
,p_name=>'P836_CUSTOM_WK_WEEKEND_OPEN_FORMAT'
,p_item_sequence=>390
,p_item_plug_id=>wwv_flow_imp.id(30738007980181329)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Alternate Weekend Open Format'
,p_source=>'CUSTOM_WK_WEEKEND_OPEN_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter HTML used to open a day which is on a weekend. Usually this would be an HTML tag which is a container such as a TD. Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list. For example:',
'<pre>',
' &lt;td&gt',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33052800343987265)
,p_name=>'P836_CUSTOM_WK_WEEKEND_CLOSE_FORMAT'
,p_item_sequence=>410
,p_item_plug_id=>wwv_flow_imp.id(30738007980181329)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Alternate Weekend Close Format'
,p_source=>'CUSTOM_WK_WEEKEND_CLOSE_FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter HTML used to close a day which is on a weekend. This is the last part of each weekend day printed so this should close any HTML tags which have been used such as the tag used in the "Weekend Open Format"',
'Include substitution strings to include dynamic content. See the "Substitution Strings" for the full list.',
'',
'For example: ',
'<pre>',
'   &lt;/td&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
,p_item_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(34024631445991915)
,p_name=>'P836_CUSTOM_MONTH_DAY_HEIGHT_PIX'
,p_item_sequence=>480
,p_item_plug_id=>wwv_flow_imp.id(34021815937892872)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Day Height for Month (pixels)'
,p_source=>'CUSTOM_MONTH_DAY_HEIGHT_PIX'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>20
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter the Height of each day in pixels, this will be used for calculating the day height when there are less days to display.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(34025123958999262)
,p_name=>'P836_CUSTOM_MONTH_DAY_HEIGHT_PER'
,p_item_sequence=>490
,p_item_plug_id=>wwv_flow_imp.id(34021815937892872)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Day Height for Month (%)'
,p_source=>'CUSTOM_MONTH_DAY_HEIGHT_PER'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>20
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter the Height of each day in percentage, this will be used for calculating the day height when there are less days to display.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(34026110714014319)
,p_name=>'P836_CUSTOM_WEEK_DAY_WIDTH_PIX'
,p_item_sequence=>500
,p_item_plug_id=>wwv_flow_imp.id(34021815937892872)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Day width for Week (pixels)'
,p_source=>'CUSTOM_WEEK_DAY_WIDTH_PIX'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>20
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter the Width of each day in pixels, this will be used for calculating the day width when there are less days to display.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(34026628375019445)
,p_name=>'P836_CUSTOM_WEEK_DAY_WIDTH_PER'
,p_item_sequence=>510
,p_item_plug_id=>wwv_flow_imp.id(34021815937892872)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Day width for Week (%)'
,p_source=>'CUSTOM_WEEK_DAY_WIDTH_PER'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>20
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter the Width of each day in percentage, this will be used for calculating the day width when there are less days to display.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 29-APR-2004 14:41:37'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(397296916378455876)
,p_name=>'ENABLE PREVIOUS'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P836_ID_PREV'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(397297205455455876)
,p_event_id=>wwv_flow_imp.id(397296916378455876)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(30741104924181363)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(397297321226457274)
,p_name=>'ENABLE NEXT'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P836_ID_NEXT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(397297630811457274)
,p_event_id=>wwv_flow_imp.id(397297321226457274)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(30740911649181362)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(30756009163181421)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_CAL_TEMPLATES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_CAL_TEMPLATES'
,p_attribute_03=>'P836_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Unable to fetch row.'
,p_internal_uid=>30756009163181421
,p_process_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(30756206497181427)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_PAGINATION'
,p_process_name=>'Get Next or Previous Primary Key Value'
,p_attribute_02=>'WWV_FLOW_CAL_TEMPLATES'
,p_attribute_03=>'P836_ID'
,p_attribute_04=>'ID'
,p_attribute_07=>'THEME_ID'
,p_attribute_08=>'NAME'
,p_attribute_09=>'P836_ID_NEXT'
,p_attribute_10=>'P836_ID_PREV'
,p_attribute_13=>'P836_ID_COUNT'
,p_attribute_14=>'flow_id = :fb_flow_id'
,p_process_error_message=>'Unable to run Get Next or Previous Primary Key Value process.'
,p_internal_uid=>30756206497181427
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(30756410977181428)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_CAL_TEMPLATES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_CAL_TEMPLATES'
,p_attribute_03=>'P836_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Unable to process calendar template.'
,p_process_when=>'COPY_TEMPLATE'
,p_process_when_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>30756410977181428
,p_process_comment=>'Generated 29-APR-2004 14:41:38'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(30756627826181428)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'122'
,p_process_when_button_id=>wwv_flow_imp.id(30740726818181362)
,p_internal_uid=>30756627826181428
);
end;
/
prompt --application/pages/page_00841
begin
wwv_flow_imp_page.create_page(
 p_id=>841
,p_name=>'Plug-in History'
,p_alias=>'PLUG-IN-HISTORY'
,p_step_title=>'Plug-in History'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(91429205691059841)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_plugins.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193353032170451678)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(188993730020080349)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Plug-ins'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193353222689451681)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>This page displays recent modifications made to Plug-ins in this application.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193353829303451686)
,p_plug_name=>'Plug-in History'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select flow_user as developer, ',
'       audit_date,',
'       audit_action as action,',
'       scn,',
'       audit_comment,',
'       flow_table_pk as component_key,',
'       object_name   as component_name',
'  from wwv_flow_builder_audit_trail',
' where flow_ID           = :FB_FLOW_ID',
'   and flow_table        = ''WWV_FLOW_PLUGINS''',
'   and security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(193354005831451687)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193354119273451687)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193354213467451688)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Audit Comment'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193354324081451689)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Component Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193354412202451690)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193354507636451690)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Component Key'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193354621995451691)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Audit Date'
,p_column_type=>'DATE'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193354727150451692)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(192763415498955359)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(193354803157451693)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1291510951536644'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'AUDIT_DATE:ACTION:DEVELOPER:COMPONENT_NAME'
,p_sort_column_1=>'AUDIT_DATE'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(193353620177451682)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(193353829303451686)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:841:&SESSION.::&DEBUG.:841,RIR::'
);
end;
/
prompt --application/pages/page_00842
begin
wwv_flow_imp_page.create_page(
 p_id=>842
,p_name=>'Create Form and Report on Web Service - Web Service Results'
,p_alias=>'CREATE-FORM-AND-REPORT-ON-WEB-SERVICE-WEB-SERVICE-RESULTS1'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Form and Report on Web Service'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193700709314861099)
,p_plug_name=>'Create Form and Report on Web Service'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>130
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<p>Choose the SOAP style and the message format. Enter the XPath reference to the node of the result on which to report. Enter the namespace of the result message.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193704508096861117)
,p_plug_name=>'Wizard Steps'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(30094110886480012)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(204749728916135641)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>140
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(193700925482861101)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(204749728916135641)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(193701122640861103)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(204749728916135641)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(193701331678861104)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(204749728916135641)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(193705803048861160)
,p_branch_action=>'f?p=&APP_ID.:848:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(193701122640861103)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(193706019580861184)
,p_branch_action=>'f?p=&APP_ID.:720:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(193701331678861104)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(193706204117861184)
,p_branch_action=>'f?p=&FLOW_ID.:842:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(193701503397861104)
,p_name=>'P842_WS_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(193700709314861099)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Web Service Reference'
,p_source=>'P700_WS_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'WEB SERVICES OLD'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r from wwv_flow_shared_web_services',
'',
'where nvl(action,''OLD_SCHOOL'') not in (''NEW_SCHOOL'',''REST'') and security_group_id = :flow_security_group_id and',
'',
'      flow_id = :fb_flow_id',
'',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the name of the Web service reference.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(193702106131861109)
,p_name=>'P842_SOAP_STYLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(193700709314861099)
,p_item_default=>'document'
,p_prompt=>'SOAP Style:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P755.SOAP.STYLE'
,p_lov=>'.'||wwv_flow_imp.id(40229315139441290)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Choose the style of the SOAP response. The style can be determined from the style attribute of the soap:binding element from the WSDL for this operation.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(193702711384861110)
,p_name=>'P842_MESSAGE_FORMAT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(193700709314861099)
,p_item_default=>'literal'
,p_prompt=>'Message Format:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P755.MESSAGE.STYLE'
,p_lov=>'.'||wwv_flow_imp.id(40231925790463373)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Choose the message format. The encoding can be determined from the use attribute of the soap:body element of the output message in the WSDL for this operation.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(193703319465861111)
,p_name=>'P842_MESSAGE_NAMESPACE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(193700709314861099)
,p_prompt=>'Message Namespace'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter the namespace for the response message. This can typically be determined by looking for the targetNamespace attribute of the WSDL.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(193703901959861116)
,p_name=>'P842_NODE_PATH'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_imp.id(193700709314861099)
,p_prompt=>'Result Node Path (XPath)'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the XPath expression to the node of the response message that you are creating the report on. The node is a child of the soap:Body element. For example,',
'<p />/result/myNode'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(193705400375861132)
,p_validation_name=>'P842_WS_ID'
,p_validation_sequence=>10
,p_validation=>'nvl(:P842_WS_ID,''0'') != ''0'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'You must choose a web service.'
,p_when_button_pressed=>wwv_flow_imp.id(193701122640861103)
,p_associated_item=>wwv_flow_imp.id(193701503397861104)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(193705627684861160)
,p_validation_name=>'P842_NODE_PATH'
,p_validation_sequence=>20
,p_validation=>'P842_NODE_PATH'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'You must supply the XPath to the node to report on.'
,p_when_button_pressed=>wwv_flow_imp.id(193701122640861103)
,p_associated_item=>wwv_flow_imp.id(193703901959861116)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(549741862163954519)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(193700925482861101)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(549741938169954520)
,p_event_id=>wwv_flow_imp.id(549741862163954519)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00843
begin
wwv_flow_imp_page.create_page(
 p_id=>843
,p_name=>'Report Query History'
,p_alias=>'REPORT-QUERY-HISTORY'
,p_step_title=>'Report Query History'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213468022923563047)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_rpt_print.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193366300843375400)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>90
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(193369209650497455)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Report Queries'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193366701445375459)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>This page displays recent modifications made to Report Queries in this application.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193367318792375493)
,p_plug_name=>'Report Query History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>160
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_SHARED_QUERIES'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(193367506810375495)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193367619420375857)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193367726342375859)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Audit Comment'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193367802322375859)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Component Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193367932121375860)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193368017233375861)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Component Key'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'LEFT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193368102211375862)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Audit Date'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193368228310375862)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(193368314321375864)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1291618210536644'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'AUDIT_DATE:ACTION:DEVELOPER:COMPONENT_NAME'
,p_sort_column_1=>'AUDIT_DATE'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(193367117339375468)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(193367318792375493)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:843:&SESSION.::&DEBUG.:41,RIR::'
);
end;
/
prompt --application/pages/page_00844
begin
wwv_flow_imp_page.create_page(
 p_id=>844
,p_name=>'Report Layout History'
,p_alias=>'REPORT-LAYOUT-HISTORY'
,p_step_title=>'Report Layout History'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213468022923563047)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_rpt_print.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193371726595539439)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>90
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(193374517232546937)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Region Layouts'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193371920376539440)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>This page displays recent modifications made to Report Layouts in this application.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193372518912539444)
,p_plug_name=>'Report Layout History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>160
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_REPORT_LAYOUTS'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(193372710936539444)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193372822779539445)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193372912106539446)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Audit Comment'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193373009305539446)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Component Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193373112932539447)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193373213180539448)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Component Key'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'LEFT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193373302160539449)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Audit Date'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(193373407100539449)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(193373513220539450)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1291719799536644'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'AUDIT_DATE:ACTION:DEVELOPER:COMPONENT_NAME'
,p_sort_column_1=>'AUDIT_DATE'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(193372321247539443)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(193372518912539444)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:844:&SESSION.::&DEBUG.:41,RIR::'
);
end;
/
prompt --application/pages/page_00847
begin
wwv_flow_imp_page.create_page(
 p_id=>847
,p_name=>'Computation Utilities'
,p_alias=>'COMPUTATION-UTILITIES'
,p_step_title=>'Computation Utilities'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_pg_comp.htm'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193687119709601736)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(17446232715505772)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193688119533608034)
,p_plug_name=>'Computation Utilities'
,p_icon_css_classes=>'icon-util-gear'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(655568879441187677)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_imp.id(171769406383685886)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193723107000124788)
,p_plug_name=>'Utilities'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'   select wwv_flow_lang.system_message(''F4000.UTILITIES.INFO'') msg',
'     from dual )',
'loop',
'   sys.htp.p(''<p>''||c1.msg||''</p>'');',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
end;
/
prompt --application/pages/page_00848
begin
wwv_flow_imp_page.create_page(
 p_id=>848
,p_name=>'Create Form and Report on Web Service - Report Parameters'
,p_alias=>'CREATE-FORM-AND-REPORT-ON-WEB-SERVICE-REPORT-PARAMETERS2'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Form and Report on Web Service'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript" language="JavaScript1.1">',
'    function ToggleAll(e){	if (e.checked) {	CheckAll();	}',
'    	else {	ClearAll();	}',
'    }',
'    function Check(e){	e.checked = true;}',
'    function Clear(e){	e.checked = false;}',
'    function CheckAll(){	',
'        var ml = document.wwv_flow;	',
'        var len = ml.elements.length;	',
'        for (var i = 0; i < len; i++) {',
'        var e = ml.elements[i];	',
'        if (e.name == "f01" ||e.name == "f03" ||e.name == "f05" || e.name == "f07" || e.name == "f09" ||e.name == "f11" ||e.name == "f13" || e.name == "f15" ) {',
'        Check(e);}',
'        }',
'        ml.f01.checked = true;',
'    }',
'    function ClearAll(){	',
'        var ml = document.wwv_flow;	',
'        var len = ml.elements.length;	',
'        for (var i = 0; i < len; i++) {	',
'          var e = ml.elements[i];	if (e.name == "f01" ||	e.name == "f03" ||e.name == "f05" ||e.name == "f07" ||e.name == "f09" ||e.name == "f11" ||e.name == "f13" ||e.name == "f15" ) {		Clear(e);	}',
'        	}',
'        	ml.f01.checked = false;',
'    }',
'</script>'))
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(193707208478872103)
,p_name=>'Create Form and Report on Web Service'
,p_template=>wwv_flow_imp.id(42025417508627628)
,p_display_sequence=>150
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select seq_id id, c001 name',
'  from wwv_flow_collections',
' where collection_name = ''WS_ARRAY_PARMS'''))
,p_header=>'<p>Specify a temporary result set name and enter the parameter names from the result tree to include in the report. The collection name should already be populated. If it is not, you have not defined a collection to store the response of this Web ser'
||'vice. Edit the Web reference to identify this collection.</p>'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>1000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(193707402565872106)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(193707508072872106)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Parameter Names'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193711016260872114)
,p_plug_name=>'Wizard Steps'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(30094110886480012)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(204752001819146761)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>160
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(193707804604872108)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(204752001819146761)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(193707614865872106)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(204752001819146761)
,p_button_name=>'ADDPARAMETER'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Add Parameter'
,p_button_position=>'EDIT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(193708018756872108)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(204752001819146761)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(193708206471872108)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(204752001819146761)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(193713720764872130)
,p_branch_action=>'f?p=&APP_ID.:842:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(193708206471872108)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(193714122694872132)
,p_branch_action=>'f?p=&FLOW_ID.:848:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(193707614865872106)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(193722031410093979)
,p_branch_action=>'f?p=&FLOW_ID.:735:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(193708018756872108)
,p_branch_sequence=>50
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow_wizard_api.page_exists (p_flow_id => :fb_flow_id, p_page_id => :P705_PAGE_ID) = true'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(193722916912118174)
,p_branch_name=>'Navigation /Tabs Page'
,p_branch_action=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.::P4716_PREV_PAGE_ID:&APP_PAGE_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(193708018756872108)
,p_branch_sequence=>60
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(193708420928872108)
,p_name=>'P848_ARRAY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(193707208478872103)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Result Tree to Report On:'
,p_source=>'P842_NODE_PATH'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'This is the portion of the resulting XML document that contains the information you want to include in the report.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(193709032530872109)
,p_name=>'P848_RESULT_COLLECTION'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_imp.id(193707208478872103)
,p_prompt=>'Result Stored in Collection'
,p_source=>'select static_parm_03 from wwv_flow_shared_web_services where id = :P700_WS_ID'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter the name of the temporary result set name where the Web service result is stored. The temporary result set is stored in an &PRODUCT_NAME. collection in the CLOB001 column.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(193709613466872111)
,p_name=>'P848_CHECKED_ITEMS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(193707208478872103)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(193709810694872111)
,p_name=>'P848_ROW_TEMPLATE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(193707208478872103)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select default_report_template from wwv_flow_themes where flow_id = :fb_flow_id and theme_id = :fb_theme_id and default_report_template is not null) loop',
'   return c1.default_report_template;',
'end loop;',
'return null;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Report Template'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REPORT.TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME1'')  d,  1 r from sys.dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME2'')  d,  2 r from sys.dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME21'') d, 21 r from sys.dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME22'') d, 22 r from sys.dual union',
'select wwv_flow_lang.system_message(''CONFIRM.TEMPLATE'')||'' ''||theme_id||''. ''||wwv_flow_escape.html(row_template_name) d, id r',
'  from wwv_flow_row_templates ',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID ',
'   and (:FB_THEME_ID is null or theme_id = :FB_THEME_ID)',
' order by 1'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Choose the report template to be used by this report region.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(193712129655872120)
,p_computation_sequence=>10
,p_computation_item=>'P848_CHECKED_ITEMS'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_utilities.table_to_string(wwv_flow.g_f01)'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(193712522531872121)
,p_validation_name=>'At least one parameter chosen'
,p_validation_sequence=>10
,p_validation=>'return wwv_flow.g_f01.count > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'You must choose at least on parameter for the report.'
,p_when_button_pressed=>wwv_flow_imp.id(193708018756872108)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(193712725668872122)
,p_validation_name=>'P848_RESULT_COLLECTION not null'
,p_validation_sequence=>20
,p_validation=>'P848_RESULT_COLLECTION'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'You must supply the name of the collection containing the Web service result.'
,p_when_button_pressed=>wwv_flow_imp.id(193708018756872108)
,p_associated_item=>wwv_flow_imp.id(193709032530872109)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(549742002506954521)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(193707804604872108)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(549742150227954522)
,p_event_id=>wwv_flow_imp.id(549742002506954521)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(193712900925872126)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.update_members(',
'  p_collection_name => ''WS_ARRAY_PARMS'',',
'  p_seq             => wwv_flow.g_f01,',
'  p_c001            => wwv_flow.g_f02 );'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>193712900925872126
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(193713121381872127)
,p_process_sequence=>15
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add parameter'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.add_member(',
'  p_collection_name => ''WS_ARRAY_PARMS'');'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(193707614865872106)
,p_internal_uid=>193713121381872127
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(193713526101872129)
,p_process_sequence=>60
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create WS_REPORT_ITEMS'
,p_process_sql_clob=>'wwv_flow_collection.create_collection_from_query(''WS_ARRAY_PARMS'',''select null from wwv_flow_dual100 where rownum < 11'');'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'not wwv_flow_collection.collection_exists(''WS_ARRAY_PARMS'')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>193713526101872129
);
end;
/
prompt --application/pages/page_00849
begin
wwv_flow_imp_page.create_page(
 p_id=>849
,p_name=>'Create Feedback Page - Define'
,p_alias=>'CREATE-FEEDBACK-PAGE-DEFINE'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Feedback Pages'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'td_fb.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44683213273657428)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>130
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(196191122274857782)
,p_plug_name=>'Create Page'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_header=>'Provide a mechanism for end users to post general comments back to the application administrators and developers.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'Provide a mechanism for end users to post general comments back to the application administrators and developers. The posts include useful session state information to help determine where the end user sent the feedback from. Providing such an easy f'
||'eedback loop enhances communication between the user community and the application owners, which leads to greatly improved end user satisfaction.'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(233451171129837778)
,p_plug_name=>'Create Tab'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>150
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P2500_NAVIGATION_TYPE'
,p_plug_display_when_cond2=>'L'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(233450582559837776)
,p_name=>'Tabs'
,p_parent_plug_id=>wwv_flow_imp.id(233451171129837778)
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<a title="click to set tab set" href="javascript:$x_Value(''''P849_TAB_SET'''',''''''||',
'       wwv_flow_javascript.escape(tab_set)||',
'       '''''');">''||',
'       wwv_flow_escape.html(tab_set)||',
'       ''</a>'' tab_set, ',
'       tab_step, ',
'       substr(tab_text,1,30) tab_text,',
'       replace(TAB_ALSO_CURRENT_FOR_PAGES,'','','', '') tacfp',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID and ',
'       security_group_id = :flow_security_group_id',
'order  by tab_set, TAB_SEQUENCE, tab_step'))
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>'No tabs or tab sets exist.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(58000833527816318)
,p_query_column_id=>1
,p_column_alias=>'TAB_SET'
,p_column_display_sequence=>1
,p_column_heading=>'Tab Set'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(57999797672816317)
,p_query_column_id=>2
,p_column_alias=>'TAB_STEP'
,p_column_display_sequence=>2
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(58000190784816318)
,p_query_column_id=>3
,p_column_alias=>'TAB_TEXT'
,p_column_display_sequence=>3
,p_column_heading=>'Tab'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(58000438712816318)
,p_query_column_id=>4
,p_column_alias=>'TACFP'
,p_column_display_sequence=>4
,p_column_heading=>'Also&nbsp;Current&nbsp;For'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(505617408566993055)
,p_plug_name=>'Navigation Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1153295071514196955)
,p_plug_name=>'Create List Entry'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>160
,p_translate_title=>'N'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P2500_NAVIGATION_TYPE'
,p_plug_display_when_cond2=>'L'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3891704745946633046)
,p_plug_name=>'Admin Options'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>140
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(196191726308864525)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(44683213273657428)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(196192103639864527)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(44683213273657428)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(196191921844864527)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(44683213273657428)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(515939446961056895)
,p_branch_name=>'edit page'
,p_branch_action=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID,F4000_P1_FLOW,F4000_P1_PAGE:&FB_FLOW_ID.,&F4000_RUN_EDIT_PAGE.,&FB_FLOW_ID.,&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(196192103639864527)
,p_branch_sequence=>55
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(548811099702924177)
,p_branch_name=>'Go To Page 2500'
,p_branch_action=>'f?p=&APP_ID.:2500:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(196191921844864527)
,p_branch_sequence=>65
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57993403913813905)
,p_name=>'P849_ADMIN_PAGE_OPTION'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3891704745946633046)
,p_item_default=>'EXISTING'
,p_prompt=>'Administration Page Preference'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.ADMINPAGE.OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(31963614629360602)||'.'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the administration page, that a list is added to, for this feature.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57993876312813910)
,p_name=>'P849_ADMIN_PAGE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3891704745946633046)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.get_maximum_free_admin_page(:FB_FLOW_ID);',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Administration Page Number'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter an unused page number for the administration page.</p>',
'<p>The default is calculated as the first available page number that is divisible by 100, which is greater than the maximum page number within this application.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57994720403813912)
,p_name=>'P849_ADMIN_PAGE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3891704745946633046)
,p_item_default=>'wwv_flow_lang.system_message(''CA.ADMIN.ADMINISTRATION'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Administration Page Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a name for the administration page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57995198676813912)
,p_name=>'P849_EXISTING_PAGE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(3891704745946633046)
,p_prompt=>'Existing Administration Page'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d',
'  from wwv_flow_steps',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and is_page_pattern   = ''N''',
'order by 2'))
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select an existing page used as the administration page in this application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57995872087816314)
,p_name=>'P849_TAB_OPTIONS'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(233451171129837778)
,p_item_default=>'0'
,p_prompt=>'Administration Page<br>Tab Options:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.TAB.OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(35310611267199336)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Specify whether the administration page should be included in tabs.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57996779310816315)
,p_name=>'P849_TAB_SET'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(233451171129837778)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   t varchar2(4000);',
'begin',
'   for c1 in (',
'select tab_set, count(*) c',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID and ',
'       security_group_id = :flow_security_group_id',
'group  by tab_set',
'order by 2 desc) loop',
'return c1.tab_set;',
'exit;',
'end loop;',
'return null;',
'end;',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Tab Set'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_TABSETS'
,p_lov=>'select wwv_flow_escape.html(d) d, r from wwv_flow_tabset_view'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Tab Set -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Select the tab set you wish to use for this page.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57997607996816315)
,p_name=>'P849_TAB_LABEL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(233451171129837778)
,p_prompt=>'New Tab Label'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the label for the tab that will be created. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57998501330816316)
,p_name=>'P849_TAB_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(233451171129837778)
,p_prompt=>'Use Tab'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(TAB_NAME)||'': label="''||wwv_flow_escape.html(substr(TAB_TEXT,1,40))||''"'' tab_text,tab_name',
'from   wwv_flow_tabs',
'where  flow_id = :fb_flow_id and',
'       security_group_id = :flow_security_group_id and',
'       tab_set = :P849_TAB_SET'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Tab -'
,p_lov_cascade_parent_items=>'P849_TAB_SET'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Select the tab to be designated as "current" for this page.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(58001581838817623)
,p_name=>'P849_NAVLIST_OPTIONS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1153295071514196955)
,p_item_default=>'NONE'
,p_prompt=>'Administration Page<br> Navigation Preference'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.NAVIGATIONLIST.OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(925221062390507339)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select how you want this page integrated into the Navigation Menu.<p/>',
'<ul>',
'    <li><strong>Do not associate this page with a Navigation Menu entry</strong> - The new page will not be current or highlighted for any menu entry.</li>',
'    <li><strong>Create a new Navigation Menu entry</strong> - Users will be able to navigate to the new page directly from the Navigation Menu. The new entry can be placed anywhere in the existing hierarchy.</li>',
'    <li><strong>Identify an existing Navigation Menu entry which will be current for this page</strong> - Use this option when you want the new page to highlight an existing, top level, menu entry. Users will not be able to navigate to the new page d'
||'irectly from the Navigation Menu. Therefore, You will need to create or define a navigation control on the top level page selected, such as a button, or link in a report, to go to this new page.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(58002856620817624)
,p_name=>'P849_NAVLIST_ENTRY_NAME'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_imp.id(1153295071514196955)
,p_prompt=>'New Navigation Menu Entry'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Enter a name for the new menu control.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(58003795175817625)
,p_name=>'P849_NAVLIST_PARENT_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1153295071514196955)
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select a navigation parent for your new page. When creating a new navigation item, the new item links to',
'the new page. The new item can be added at the top level, by not selecting any parent item, or shown as a child',
'of an existing item. </p>',
'',
'<p>When selecting item without creating a new item, the selected item determines which top level item is shown',
'as the "current" item.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(58004629688817625)
,p_name=>'P849_NEW_PARENT_ID'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_imp.id(1153295071514196955)
,p_prompt=>'Parent Navigation Menu Entry'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'NAVLIST_ENTRIES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case',
'           when (nvl(list_item_link_target,''0'')=''0'' or parent_list_item_id is',
'null) then',
'               lpad('' '',(4*(level-1)),''.'')||list_item_link_text',
'           else',
'               lpad('' '',(4*(level-1)),''.'')||'' (''||list_item_link_text ||'')''',
'       end name,',
'       id',
'  from wwv_flow_list_items',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and sub_list_id is null',
' start with list_id = :P2500_NAVLIST_ID and parent_list_item_id is null',
'connect by prior list_id = list_id and prior id = parent_list_item_id',
' order siblings by list_item_display_sequence'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No parent selected - '
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select an existing menu control if you wish to add a menu entry for the new page to this menu control. ',
'When not selecting an existing menu control, a menu control for the new page will be created at the to level.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(58005553248817626)
,p_name=>'P849_EXISTING_PARENT_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(1153295071514196955)
,p_prompt=>'Existing Navigation Menu Entry'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'NAVLIST_ENTRIES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case',
'           when (nvl(list_item_link_target,''0'')=''0'' or parent_list_item_id is',
'null) then',
'               lpad('' '',(4*(level-1)),''.'')||list_item_link_text',
'           else',
'               lpad('' '',(4*(level-1)),''.'')||'' (''||list_item_link_text ||'')''',
'       end name,',
'       id',
'  from wwv_flow_list_items',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and sub_list_id is null',
' start with list_id = :P2500_NAVLIST_ID and parent_list_item_id is null',
'connect by prior list_id = list_id and prior id = parent_list_item_id',
' order siblings by list_item_display_sequence'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Select an existing menu control to be shown as the active menu control when rendering the new page. ',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(98083881973541955)
,p_name=>'P849_AUTHORIZATION_SCHEME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(3891704745946633046)
,p_prompt=>'Authorization Scheme'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REQUIRED_ROLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.d, a.r from (',
'    select wwv_flow_lang.system_message(''MUST_NOT_BE_PUBLIC_USER'') d,''MUST_NOT_BE_PUBLIC_USER'' r, 1',
'      from sys.dual',
'    union all',
'    select wwv_flow_escape.html(substr(name,1,50)),to_char(id), 1',
'      from wwv_flow_security_schemes',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID',
'    union all',
'    select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'',wwv_flow_escape.html(substr(name,1,50)))||''}'' d, ''!''||to_char(id) r, 2',
'      from wwv_flow_security_schemes',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID',
'    order by 3,1) a'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- None -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the authorization scheme used to limit access to the Administration page and the pages for this feature.</p>',
'<p><em>Note: The feedback entry page will not utilize the authorization scheme as it is intended to be accessible to all end users. The feedback maintenance page(s) accessed from the Administration page will include the authorization scheme.</em></p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(183307887602916627)
,p_name=>'P849_BUILD_OPTION'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(196191122274857782)
,p_prompt=>'Build Option'
,p_source=>'wwv_flow_lang.system_message(''FEATURE'')||'': ''||wwv_flow_lang.system_message(''FEATURE.FEEDBACK'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The listed build option(s) will be created to support this feature.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(196337210193224397)
,p_name=>'P849_NAV_BAR_ENTRY'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_imp.id(505617408566993055)
,p_item_default=>'return wwv_flow_lang.system_message(''FEEDBACK'');'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Navigation Bar Label'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the name of the new navigation bar entry used to access the new feedback page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(196337612472224398)
,p_name=>'P849_PAGE_NAME'
,p_is_required=>true
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_imp.id(196191122274857782)
,p_item_default=>'return wwv_flow_lang.system_message(''FEEDBACK'');'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Page Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a name for the feature page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(196337804152224399)
,p_name=>'P849_STARTING_PAGE_ID'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(196191122274857782)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.get_maximum_free_page(:FB_FLOW_ID);',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Starting Page Number'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter an unused starting page number. This feature will create multiple pages starting with the number specified.</p>',
'<p>The default is calculated as the first available page number that is divisible by 10, which is greater than the maximum page number within this application.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(403307849104218560)
,p_name=>'P849_GROUP_ID'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_imp.id(196191122274857782)
,p_prompt=>'Page Group'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE_GROUPS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d,',
'       id r',
'  from wwv_flow_page_groups',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
' order by upper(group_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Page Group -'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the name of the page group to associate with this page. Page groups help developers manage the pages within an application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(505638609287220338)
,p_name=>'P849_CREATE_NAV_BAR_ENTRY'
,p_item_sequence=>7
,p_item_plug_id=>wwv_flow_imp.id(505617408566993055)
,p_item_default=>'Y'
,p_prompt=>'Include in Navigation Bar?'
,p_source=>'Y'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select <strong>On</strong> to create a navigation bar entry within the current application to invoke your new feedback page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(196394428888552110)
,p_computation_sequence=>5
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.get_current_theme_id (',
'    p_application_id    => :FB_FLOW_ID )'))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(484181920767628316)
,p_validation_name=>'P849_STARTING_PAGE_ID positive, whole number'
,p_validation_sequence=>10
,p_validation=>'P849_STARTING_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>'#LABEL# must be a positive, whole number.'
,p_when_button_pressed=>wwv_flow_imp.id(196192103639864527)
,p_associated_item=>wwv_flow_imp.id(196337804152224399)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(58017503610845881)
,p_validation_name=>'P849_STARTING_PAGE_ID reserved'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.reserve_page (',
'    p_flow_id       => :FB_FLOW_ID,',
'    p_page_id       => :P849_STARTING_PAGE_ID,',
'    p_reuse         => TRUE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P849_STARTING_PAGE_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(196192103639864527)
,p_associated_item=>wwv_flow_imp.id(196337804152224399)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(505773113395893155)
,p_validation_name=>'P849_NAV_BAR_ENTRY not null when entry to be created'
,p_validation_sequence=>50
,p_validation=>'P849_NAV_BAR_ENTRY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'P849_CREATE_NAV_BAR_ENTRY'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(196192103639864527)
,p_associated_item=>wwv_flow_imp.id(196337210193224397)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(57828721007033920)
,p_validation_name=>'P849_ADMIN_PAGE_ID positive, whole number'
,p_validation_sequence=>60
,p_validation=>'P849_ADMIN_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>'#LABEL# must be a positive, whole number.'
,p_validation_condition=>'P849_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(196192103639864527)
,p_associated_item=>wwv_flow_imp.id(57993876312813910)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(57828869933033921)
,p_validation_name=>'P849_ADMIN_PAGE_ID reserved'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.reserve_page (',
'    p_flow_id       => :FB_FLOW_ID,',
'    p_page_id       => :P849_ADMIN_PAGE_ID,',
'    p_reuse         => TRUE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P849_ADMIN_PAGE_OPTION = ''NEW''',
'and :P849_ADMIN_PAGE_ID is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(196192103639864527)
,p_associated_item=>wwv_flow_imp.id(57993876312813910)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(58017893983850648)
,p_validation_name=>'P849_STARTING_PAGE_ID and P849_ADMIN_PAGE_ID different'
,p_validation_sequence=>80
,p_validation=>':P849_STARTING_PAGE_ID <> :P849_ADMIN_PAGE_ID'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Starting Page Number and Administration Page Number must be different.'
,p_validation_condition=>'P849_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(196192103639864527)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(57828906534033922)
,p_validation_name=>'P849_ADMIN_PAGE_NAME not null'
,p_validation_sequence=>90
,p_validation=>'P849_ADMIN_PAGE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P849_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(196192103639864527)
,p_associated_item=>wwv_flow_imp.id(57994720403813912)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(57829002043033923)
,p_validation_name=>'P849_EXISTING_PAGE not null'
,p_validation_sequence=>100
,p_validation=>'P849_EXISTING_PAGE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P849_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(196192103639864527)
,p_associated_item=>wwv_flow_imp.id(57995198676813912)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(235667199444448509)
,p_validation_name=>'P849_EXISTING_PAGE available'
,p_validation_sequence=>110
,p_validation=>'return wwv_flow_wizard_api.page_exists( p_flow_id => :FB_FLOW_ID, p_page_id => :P849_EXISTING_PAGE );'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'#LABEL# is not a page in the application.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P849_ADMIN_PAGE_OPTION = ''EXISTING''',
'and :P849_EXISTING_PAGE is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(196192103639864527)
,p_associated_item=>wwv_flow_imp.id(57995198676813912)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(57829155827033924)
,p_validation_name=>'P849_TAB_SET not null'
,p_validation_sequence=>120
,p_validation=>'P849_TAB_SET'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P849_TAB_OPTIONS'
,p_validation_condition2=>'1:2'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_when_button_pressed=>wwv_flow_imp.id(196192103639864527)
,p_associated_item=>wwv_flow_imp.id(57996779310816315)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(57829217046033925)
,p_validation_name=>'P849_TAB_LABEL not null'
,p_validation_sequence=>130
,p_validation=>'P849_TAB_LABEL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P849_TAB_OPTIONS'
,p_validation_condition2=>'1'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(196192103639864527)
,p_associated_item=>wwv_flow_imp.id(57997607996816315)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(57829341884033926)
,p_validation_name=>'P849_TAB_NAME not null'
,p_validation_sequence=>140
,p_validation=>'P849_TAB_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P849_TAB_OPTIONS'
,p_validation_condition2=>'2'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(196192103639864527)
,p_associated_item=>wwv_flow_imp.id(57998501330816316)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(57829458300033927)
,p_validation_name=>'P849_NAVLIST_ENTRY_NAME not null'
,p_validation_sequence=>160
,p_validation=>'P849_NAVLIST_ENTRY_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P849_NAVLIST_OPTIONS'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(196192103639864527)
,p_associated_item=>wwv_flow_imp.id(58002856620817624)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(58018491594854212)
,p_validation_name=>'Existing Entry with no List'
,p_validation_sequence=>170
,p_validation=>'P849_EXISTING_PARENT_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P849_NAVLIST_OPTIONS'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(196192103639864527)
,p_associated_item=>wwv_flow_imp.id(58005553248817626)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2948515563803015)
,p_validation_name=>'Navigation Menu not subscribed'
,p_validation_sequence=>180
,p_validation=>'coalesce(:P2500_IS_NAVLIST_SUBSCRIBED,''N'') != ''Y'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'&APP_TEXT$NAVIGATION_MENU_SUBSCRIBED!RAW.'
,p_validation_condition=>':P849_NAVLIST_OPTIONS in ( ''NEW'', ''EXISTING'' ) and :P2500_NAVLIST_ID is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(58001581838817623)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(505652625582376395)
,p_name=>'Hide nav bar entry'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P849_CREATE_NAV_BAR_ENTRY'
,p_condition_element=>'P849_CREATE_NAV_BAR_ENTRY'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'N'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(505652902719376397)
,p_event_id=>wwv_flow_imp.id(505652625582376395)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P849_NAV_BAR_ENTRY'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(505732107414834753)
,p_event_id=>wwv_flow_imp.id(505652625582376395)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P849_NAV_BAR_ENTRY'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(548810247147922081)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(196191726308864525)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(548810561140922081)
,p_event_id=>wwv_flow_imp.id(548810247147922081)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1941076716450577908)
,p_name=>'set region name'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P849_PAGE_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1941077183031577908)
,p_event_id=>wwv_flow_imp.id(1941076716450577908)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P849_NAV_BAR_ENTRY'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P849_PAGE_NAME'
,p_attribute_07=>'P849_PAGE_NAME'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(58006952471828381)
,p_name=>'Show / Hide Admin Options'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P849_ADMIN_PAGE_OPTION'
,p_condition_element=>'P849_ADMIN_PAGE_OPTION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(58007311785828382)
,p_event_id=>wwv_flow_imp.id(58006952471828381)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P849_ADMIN_PAGE_ID,P849_ADMIN_PAGE_NAME,P849_NAVLIST_OPTIONS,P849_TAB_OPTIONS,P849_AUTHORIZATION_SCHEME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(58008884056828382)
,p_event_id=>wwv_flow_imp.id(58006952471828381)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P849_EXISTING_PAGE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(58007815505828382)
,p_event_id=>wwv_flow_imp.id(58006952471828381)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P849_EXISTING_PAGE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(58008301616828382)
,p_event_id=>wwv_flow_imp.id(58006952471828381)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P849_ADMIN_PAGE_ID,P849_ADMIN_PAGE_NAME,P849_NAVLIST_OPTIONS,P849_TAB_OPTIONS,P849_AUTHORIZATION_SCHEME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3775767256140368435)
,p_event_id=>wwv_flow_imp.id(58006952471828381)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P849_TAB_OPTIONS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'0'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3775767323558368436)
,p_event_id=>wwv_flow_imp.id(58006952471828381)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P849_NAVLIST_OPTIONS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'NONE'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(58009501254830395)
,p_name=>'Set Tab and Nav List Names'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P849_ADMIN_PAGE_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(58009914669830396)
,p_event_id=>wwv_flow_imp.id(58009501254830395)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P849_NAVLIST_ENTRY_NAME,P849_TAB_LABEL'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P849_ADMIN_PAGE_NAME'
,p_attribute_07=>'P849_ADMIN_PAGE_NAME'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(58010458329832773)
,p_name=>'Tab Option 0'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P849_TAB_OPTIONS'
,p_condition_element=>'P849_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'0'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(58010893106832773)
,p_event_id=>wwv_flow_imp.id(58010458329832773)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P849_TAB_SET,P849_TAB_LABEL,P849_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(100574481045284402)
,p_event_id=>wwv_flow_imp.id(58010458329832773)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(233450582559837776)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(58012263163834259)
,p_name=>'Tab Option 1'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P849_TAB_OPTIONS'
,p_condition_element=>'P849_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'1'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(58012675531834260)
,p_event_id=>wwv_flow_imp.id(58012263163834259)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P849_TAB_SET,P849_TAB_LABEL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(58013191922834260)
,p_event_id=>wwv_flow_imp.id(58012263163834259)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P849_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(100574510348284403)
,p_event_id=>wwv_flow_imp.id(58012263163834259)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(233450582559837776)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(58013539769835761)
,p_name=>'Tab Option 2'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P849_TAB_OPTIONS'
,p_condition_element=>'P849_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'2'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(58013910707835761)
,p_event_id=>wwv_flow_imp.id(58013539769835761)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P849_TAB_SET,P849_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(58014463955835762)
,p_event_id=>wwv_flow_imp.id(58013539769835761)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P849_TAB_LABEL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(100574638032284404)
,p_event_id=>wwv_flow_imp.id(58013539769835761)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(233450582559837776)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(58014887759837448)
,p_name=>'New List'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P849_NAVLIST_OPTIONS'
,p_condition_element=>'P849_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(58015219871837448)
,p_event_id=>wwv_flow_imp.id(58014887759837448)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P849_NAVLIST_ENTRY_NAME,P849_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(58015782257837448)
,p_event_id=>wwv_flow_imp.id(58014887759837448)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P849_NAVLIST_ENTRY_NAME,P849_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(58016109018839003)
,p_name=>'Existing List'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P849_NAVLIST_OPTIONS'
,p_condition_element=>'P849_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'EXISTING'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(58016568916839004)
,p_event_id=>wwv_flow_imp.id(58016109018839003)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P849_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(58017062765839004)
,p_event_id=>wwv_flow_imp.id(58016109018839003)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P849_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(196196508000887588)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create feedback feature page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_admin_page wwv_flow_app_feature_v3.t_admin_page;',
'begin',
'    -- admin page',
'    l_admin_page.page_option                 := :P849_ADMIN_PAGE_OPTION;',
'    l_admin_page.new_page_id                 := :P849_ADMIN_PAGE_ID;',
'    l_admin_page.page_name                   := :P849_ADMIN_PAGE_NAME;',
'    l_admin_page.existing_page_id            := :P849_EXISTING_PAGE;',
'    -- tabs',
'    l_admin_page.tab_option                  := :P849_TAB_OPTIONS;',
'    l_admin_page.tab_set                     := :P849_TAB_SET;',
'    l_admin_page.tab_name                    := :P849_TAB_NAME;',
'    l_admin_page.tab_text                    := :P849_TAB_LABEL;',
'    -- nav list',
'    l_admin_page.nav_list_option             := :P849_NAVLIST_OPTIONS;',
'    l_admin_page.nav_list_id                 := :P2500_NAVLIST_ID;',
'    l_admin_page.nav_list_new_parent_id      := :P849_NEW_PARENT_ID;',
'    l_admin_page.nav_list_existing_parent_id := :P849_EXISTING_PARENT_ID;',
'    l_admin_page.nav_list_entry_name         := :P849_NAVLIST_ENTRY_NAME;',
'    ',
'    wwv_flow_app_feature_v3.add_feature_feedback(',
'        p_app_id                   => :FB_FLOW_ID,',
'        p_starting_page_id         => :P849_STARTING_PAGE_ID,',
'        p_group_id                 => :P849_GROUP_ID,',
'        p_auth_scheme_id           => :P849_AUTHORIZATION_SCHEME,',
'        --',
'        p_create_nav_bar_entry     => ( :P849_CREATE_NAV_BAR_ENTRY = ''Y'' ),',
'        p_nav_bar_entry_label      => :P849_NAV_BAR_ENTRY,',
'        --',
'        p_admin_page               => l_admin_page );',
'',
'    :FB_FLOW_PAGE_ID := wwv_flow_app_feature_v3.get_admin_page_id( p_admin_page => l_admin_page);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Page failed to be created.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(196192103639864527)
,p_process_success_message=>'Page Created.'
,p_internal_uid=>196196508000887588
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(548811767838930050)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Page Created.'
,p_internal_uid=>548811767838930050
);
end;
/
prompt --application/pages/page_00850
begin
wwv_flow_imp_page.create_page(
 p_id=>850
,p_name=>'Create Script - Method'
,p_alias=>'CREATE-SCRIPT-METHOD'
,p_step_title=>'Create Script'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(24897722063538624)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deployment.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4583405881045166)
,p_plug_name=>'Create Script'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4594017057105105)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(4589709522084091)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(186894901861367649)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747146047919138172)
,p_plug_name=>'Create Script'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4605011956160431)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(186894901861367649)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4605918535162327)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(186894901861367649)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4606104009162328)
,p_branch_name=>'Go To Page 855'
,p_branch_action=>'f?p=&APP_ID.:855:&SESSION.::&DEBUG.:855,857,858::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(4605918535162327)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_branch_condition=>'P850_SCRIPT_SOURCE'
,p_branch_condition_text=>'DATA'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(11952795244013811)
,p_branch_name=>'Go To Page 6000'
,p_branch_action=>'f?p=&APP_ID.:6000:&SESSION.::&DEBUG.:6000::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P850_SCRIPT_SOURCE'
,p_branch_condition_text=>'DATA'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4584906705054818)
,p_name=>'P850_SCRIPT_SOURCE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(4583405881045166)
,p_item_default=>'SCRATCH'
,p_prompt=>'Script source'
,p_source=>'SCRATCH'
,p_source_type=>'STATIC'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'CREATE INSTALL SCRIPT OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(4579300425024699)||'.'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'S'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(107247725930060963)
,p_name=>'P850_MODE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(4583405881045166)
,p_item_default=>'INSTALL'
,p_prompt=>'Script Type:'
,p_source=>'INSTALL'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'SUPPORTING OBJECT SCRIPT TYPES'
,p_lov=>'.'||wwv_flow_imp.id(57799129745997268)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the type of supporting object script you are creating.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
end;
/
prompt --application/pages/page_00851
begin
wwv_flow_imp_page.create_page(
 p_id=>851
,p_name=>'Validation Utilities'
,p_alias=>'VALIDATION-UTILITIES'
,p_step_title=>'Validation Utilities'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_pg_comp.htm'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193765510969904973)
,p_plug_name=>'Utilities'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'   select wwv_flow_lang.system_message(''F4000.UTILITIES.INFO'') msg',
'     from dual )',
'loop',
'   sys.htp.p(c1.msg);',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193765723236904975)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(186826132498329280)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193766306782904977)
,p_plug_name=>'Validation Utilities'
,p_icon_css_classes=>'icon-util-gear'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(655568879441187677)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_imp.id(171763620666671065)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
end;
/
prompt --application/pages/page_00852
begin
wwv_flow_imp_page.create_page(
 p_id=>852
,p_name=>'Button Utilities'
,p_alias=>'BUTTON-UTILITIES'
,p_step_title=>'Button Utilities'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_but.htm'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193780823937056410)
,p_plug_name=>'Utilities'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'   select wwv_flow_lang.system_message(''F4000.UTILITIES.INFO'') msg',
'     from dual )',
'loop',
'   sys.htp.p(''<p>''||c1.msg||''</p>'');',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193781022092056411)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(16353308133052510)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193781415325056414)
,p_plug_name=>'Button Utilities'
,p_icon_css_classes=>'icon-button-hot '
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(655568879441187677)
,p_plug_display_sequence=>30
,p_list_id=>wwv_flow_imp.id(171743703949609405)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
end;
/
prompt --application/pages/page_00853
begin
wwv_flow_imp_page.create_page(
 p_id=>853
,p_name=>'Region Utilities'
,p_alias=>'REGION-UTILITIES'
,p_step_title=>'Region Utilities'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_region.htm'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193868424530501578)
,p_plug_name=>'Utilities'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'   select wwv_flow_lang.system_message(''F4000.UTILITIES.INFO'') msg',
'     from dual )',
'loop',
'   sys.htp.p(''<p>''||c1.msg||''</p>'');',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193868629672501583)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>100
,p_list_id=>wwv_flow_imp.id(13987931263515071)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193869008528501584)
,p_plug_name=>'Region Utilities'
,p_icon_css_classes=>'icon-region-native '
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--shadowScroll:a-Region--paddedBody:h240'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(655568879441187677)
,p_plug_display_sequence=>140
,p_list_id=>wwv_flow_imp.id(171723423034567648)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
,p_plug_column_width=>'apex-col--rightBorder apex-col--bottomBorder'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193872009365538664)
,p_plug_name=>'Report Region Utilities'
,p_icon_css_classes=>'icon-page-ir '
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--shadowScroll:a-Region--paddedBody:h240'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(655568879441187677)
,p_plug_display_sequence=>160
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_imp.id(47104812669691866)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
,p_plug_column_width=>'apex-col--rightBorder'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(194259130362878464)
,p_plug_name=>'Region Counts'
,p_icon_css_classes=>'icon-util-page-views'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--shadowScroll:a-Region--paddedBody:h240'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(655568879441187677)
,p_plug_display_sequence=>170
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_imp.id(194250609883844198)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
end;
/
prompt --application/pages/page_00854
begin
wwv_flow_imp_page.create_page(
 p_id=>854
,p_name=>'Item Utilities'
,p_alias=>'ITEM-UTILITIES'
,p_step_title=>'Item Utilities'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_item_pg_edit.htm'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193914622944228841)
,p_plug_name=>'Utilities'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'   select wwv_flow_lang.system_message(''F4000.UTILITIES.INFO'') msg',
'     from dual )',
'loop',
'   sys.htp.p(''<p>''||c1.msg||''</p>'');',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193914802791228843)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>100
,p_list_id=>wwv_flow_imp.id(186703109122914661)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193915221635228844)
,p_plug_name=>'Item Utilities'
,p_icon_css_classes=>'icon-item-native-text-field '
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(655568879441187677)
,p_plug_display_sequence=>140
,p_list_id=>wwv_flow_imp.id(171752432131627079)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
end;
/
prompt --application/pages/page_00855
begin
wwv_flow_imp_page.create_page(
 p_id=>855
,p_name=>'Create Script - Script Attributes'
,p_alias=>'CREATE-SCRIPT-SCRIPT-ATTRIBUTES'
,p_step_title=>'Create Script'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(24897722063538624)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deployment.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4588418741077284)
,p_plug_name=>'Script Attributes'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4592328700099093)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(4589709522084091)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(4704822606882630)
,p_name=>'Existing Installation Scripts'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, sequence',
'  from wwv_flow_install_scripts',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
'   and nvl(script_type,''INSTALL'') = ''INSTALL''',
' order by sequence, name'))
,p_display_when_condition=>'nvl(:P850_MODE,''INSTALL'') = ''INSTALL'''
,p_display_when_cond2=>'SQL'
,p_display_condition_type=>'EXPRESSION'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No scripts found for application &FB_FLOW_ID..'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4705123472882638)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4705208778882638)
,p_query_column_id=>2
,p_column_alias=>'SEQUENCE'
,p_column_display_sequence=>1
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(80959031694279587)
,p_name=>'Existing Upgrade Scripts'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, sequence',
'  from wwv_flow_install_scripts',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
'   and nvl(script_type,''INSTALL'') = ''UPGRADE''',
' order by sequence, name'))
,p_display_when_condition=>'nvl(:P850_MODE,''INSTALL'') = ''UPGRADE'''
,p_display_when_cond2=>'SQL'
,p_display_condition_type=>'EXPRESSION'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No scripts found for application &FB_FLOW_ID..'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(80959208300279590)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(80959302238279591)
,p_query_column_id=>2
,p_column_alias=>'SEQUENCE'
,p_column_display_sequence=>1
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(186896132467385960)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747146198551138172)
,p_plug_name=>'Create Script'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4602223599154314)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(186896132467385960)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4632815784312931)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(186896132467385960)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4603300528157192)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(186896132467385960)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4653826444410616)
,p_branch_action=>'f?p=&APP_ID.:857:&SESSION.::&DEBUG.:857::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(4632815784312931)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P850_SCRIPT_SOURCE'
,p_branch_condition_text=>'FILE'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4775600114377655)
,p_branch_name=>'Go To Page 865'
,p_branch_action=>'f?p=&APP_ID.:865:&SESSION.::&DEBUG.:865:P865_SCRIPT_SEQUENCE,P865_MODE:&P855_SCRIPT_SEQUENCE.,NEW'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(4632815784312931)
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'(:P850_SCRIPT_SOURCE = ''SCRATCH'' and :P855_USE_EDITOR = ''Y'')'
,p_branch_condition_text=>'PLSQL'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(206385023862349178)
,p_branch_name=>'Go To Page 858'
,p_branch_action=>'f?p=&APP_ID.:858:&SESSION.::&DEBUG.:858::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(4632815784312931)
,p_branch_sequence=>40
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P850_SCRIPT_SOURCE'
,p_branch_condition_text=>'DB'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(22671613896025276)
,p_branch_action=>'f?p=&APP_ID.:578:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(4632815784312931)
,p_branch_sequence=>50
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(107251502081082457)
,p_branch_action=>'f?p=&APP_ID.:857:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_HEADER'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>70
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':P850_MODE = ''DEINSTALL'' and :P850_SCRIPT_SOURCE = ''FILE'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(107258308146122090)
,p_branch_action=>'f?p=&APP_ID.:865:&SESSION.::&DEBUG.::P865_MODE:DEINSTALL'
,p_branch_point=>'BEFORE_HEADER'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>80
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':P850_MODE = ''DEINSTALL'' and :P850_SCRIPT_SOURCE = ''SCRATCH'''
,p_branch_condition_text=>'PLSQL'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4603515223157195)
,p_branch_action=>'f?p=&APP_ID.:850:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(4603300528157192)
,p_branch_sequence=>90
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4596328401127352)
,p_name=>'P855_SCRIPT_SOURCE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(4588418741077284)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Script Source Type:'
,p_source=>'P850_SCRIPT_SOURCE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'INSTALL_SCRIPT_SOURCE'
,p_lov=>'.'||wwv_flow_imp.id(4626801323289842)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'This is the method you are using to create an installation script.  All installation scripts except Data Package are editable after they are created.  To change the script source type, go back to the first step of this wizard.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4598124722135781)
,p_name=>'P855_SCRIPT_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(4588418741077284)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter a name for the script you are creating.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4599409269140731)
,p_name=>'P855_SCRIPT_SEQUENCE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(4588418741077284)
,p_prompt=>'Sequence'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(trunc(max(sequence)), 0) + 10 ',
'  from wwv_flow_install_scripts ',
' where flow_id = :FB_FLOW_ID',
'   and nvl(script_type,''INSTALL'') = nvl(:P850_MODE,''INSTALL'')',
'   and security_group_id = :flow_security_group_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter a sequence number for the script you are creating.  The scripts will be run in order according to the sequence numbers.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22667909000995458)
,p_name=>'P855_USE_EDITOR'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(4588418741077284)
,p_item_default=>'Y'
,p_prompt=>'Use Editor'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_display_when=>'P850_SCRIPT_SOURCE'
,p_display_when2=>'SCRATCH'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Use built in editor to define script.  Uncheck to use a standard browser text area to define or edit your script.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57918312120294922)
,p_name=>'P855_SCRIPT_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(4588418741077284)
,p_item_default=>'INSTALL'
,p_prompt=>'Script Type:'
,p_source=>'P850_MODE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'SUPPORTING OBJECT SCRIPT TYPES'
,p_lov=>'.'||wwv_flow_imp.id(57799129745997268)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the type of supporting object script you are creating.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(534094819493786100)
,p_name=>'P855_OBJECT_OWNER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(4588418741077284)
,p_prompt=>'Object Owner:'
,p_source=>'wwv_flow_wizard_api.get_flow_owner'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'P850_SCRIPT_SOURCE'
,p_display_when2=>'DB'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Identifies the owner of the database object.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(535751394655150801)
,p_name=>'P855_OBJECT_TYPE'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(4588418741077284)
,p_prompt=>'Object Type'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct object_type d, object_type r',
'  from sys.dba_objects',
' where object_type in (',
'        ''FUNCTION'',',
'        ''INDEX'',',
'        ''PACKAGE'',',
'        ''PROCEDURE'',',
'        ''SEQUENCE'',',
'        ''SYNONYM'',',
'        ''TABLE'',',
'        ''TRIGGER'',',
'        ''VIEW'',',
'        ''DATABASE LINK'',',
'        ''TYPE'',',
'        ''MATERIALIZED VIEW'',',
'        ''MLE ENVIRONMENT'',',
'        ''MLE MODULE'' )',
'   and owner = :P855_OBJECT_OWNER',
' order by 1'))
,p_cHeight=>11
,p_display_when=>'P850_SCRIPT_SOURCE'
,p_display_when2=>'DB'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select one or more object types from the list.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4644709428377386)
,p_validation_name=>'P855_SCRIPT_NAME'
,p_validation_sequence=>10
,p_validation=>'P855_SCRIPT_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Please specify a name for your script.'
,p_when_button_pressed=>wwv_flow_imp.id(4632815784312931)
,p_associated_item=>wwv_flow_imp.id(4598124722135781)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4703926977874436)
,p_validation_name=>'Unique script name'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install_scripts',
' where name = :P855_SCRIPT_NAME',
'   and flow_id = :FB_FLOW_ID',
'   and nvl(script_type, ''INSTALL'') = nvl(:P850_MODE, ''INSTALL'')',
'   and security_group_id = :flow_security_group_id'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'A script with that name already exists.  Please enter a new name'
,p_when_button_pressed=>wwv_flow_imp.id(4632815784312931)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(22395021174836096)
,p_validation_name=>'P855_SCRIPT_SEQUENCE is numeric'
,p_validation_sequence=>30
,p_validation=>'P855_SCRIPT_SEQUENCE'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Sequence value must be numeric.'
,p_when_button_pressed=>wwv_flow_imp.id(4632815784312931)
,p_associated_item=>wwv_flow_imp.id(4599409269140731)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00857
begin
wwv_flow_imp_page.create_page(
 p_id=>857
,p_name=>'Create Script - Define Script'
,p_alias=>'CREATE-SCRIPT-DEFINE-SCRIPT'
,p_step_title=>'Create Script'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(24897722063538624)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deployment.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4647418550390545)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(4589709522084091)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4647622907390547)
,p_plug_name=>'Create Script'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>130
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<p>Select a file to upload as a script.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(186897304463406270)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>140
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747146382260138173)
,p_plug_name=>'Create Script'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4648223443390549)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(186897304463406270)
,p_button_name=>'CREATE_SCRIPT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Script'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4648028591390549)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(186897304463406270)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4647814293390548)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(186897304463406270)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(107575619357420647)
,p_branch_action=>'f?p=&APP_ID.:576:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(4648223443390549)
,p_branch_sequence=>25
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P850_MODE'
,p_branch_condition_text=>'DEINSTALL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(32345400816305515)
,p_branch_action=>'f?p=&APP_ID.:667:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(4648223443390549)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P850_MODE'
,p_branch_condition_text=>'UPGRADE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4648818072390558)
,p_branch_action=>'f?p=&APP_ID.:473:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(107281912704227457)
,p_branch_action=>'f?p=&APP_ID.:850:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(4648028591390549)
,p_branch_sequence=>5
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P850_MODE'
,p_branch_condition_text=>'DEINSTALL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4648607609390557)
,p_branch_action=>'f?p=&APP_ID.:855:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(4648028591390549)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4649730684392983)
,p_name=>'P857_SCRIPT_FILE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(4647622907390547)
,p_prompt=>'File'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select a file to upload and use as an installation script for the selected application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'APEX_APPLICATION_TEMP_FILES'
,p_attribute_09=>'REQUEST'
,p_attribute_12=>'INLINE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4685021286711920)
,p_name=>'P857_FILE_CHARSET'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(4647622907390547)
,p_prompt=>'File Character Set'
,p_source=>'nvl(lower(trim(sys.owa_util.get_cgi_env(''REQUEST_IANA_CHARSET''))),''utf-8'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_IANA_CHARSET'
,p_lov=>'.'||wwv_flow_imp.id(144796827445692396)||'.'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose the character set in which the script is encoded.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(56582111293173541)
,p_validation_name=>'P857_SCRIPT_FILE not null'
,p_validation_sequence=>10
,p_validation=>'P857_SCRIPT_FILE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Please specify a file'
,p_when_button_pressed=>wwv_flow_imp.id(4648223443390549)
,p_associated_item=>wwv_flow_imp.id(4649730684392983)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4665316850540386)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Script'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare l_clob clob;',
'begin',
'for c1 in (select *',
'             from wwv_flow_temp_files ',
'            where name = :P857_SCRIPT_FILE)',
'loop',
'',
'  l_clob := wwv_flow_utilities.blob_to_clob( ',
'                p_blob => c1.blob_content, ',
'                p_charset => :P857_FILE_CHARSET );',
'',
'  if :P850_MODE = ''DEINSTALL'' then',
'      update wwv_flow_install',
'         set deinstall_script = l_clob',
'       where flow_id = :fb_flow_id',
'         and security_group_id = :flow_security_group_id;',
'  elsif :P850_MODE = ''UPGRADE'' then',
'      insert into wwv_flow_install_scripts (name, sequence, script_type, script)',
'                                    values (:P855_SCRIPT_NAME,',
'                                            :P855_SCRIPT_SEQUENCE,',
'                                            ''UPGRADE'',',
'                                            l_clob);',
'  else                                            ',
'      insert into wwv_flow_install_scripts (name, sequence, script_type, script)',
'                                    values (:P855_SCRIPT_NAME, ',
'                                            :P855_SCRIPT_SEQUENCE,',
'                                            ''INSTALL'',',
'                                            l_clob);',
'  end if;',
'',
'end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to save the specified script. '
,p_process_when_button_id=>wwv_flow_imp.id(4648223443390549)
,p_internal_uid=>4665316850540386
);
end;
/
prompt --application/pages/page_00858
begin
wwv_flow_imp_page.create_page(
 p_id=>858
,p_name=>'Create Script - Select Objects'
,p_alias=>'CREATE-SCRIPT-SELECT-OBJECTS'
,p_step_title=>'Create Script'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(24897722063538624)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deployment.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(584635221052978322)
,p_plug_name=>'Script Attributes'
,p_region_name=>'Select Objects'
,p_region_template_options=>'#DEFAULT#:a-Form--fixedLabels'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(584638786957978335)
,p_plug_name=>'progress'
,p_region_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(4589709522084091)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(584639920493978339)
,p_plug_name=>'Wizard Buttons'
,p_region_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747146412307138173)
,p_plug_name=>'Create Script'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1842855562136354722)
,p_plug_name=>'Warning'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'The script will be generated based on the underlying Oracle Database version, using version specific syntax. If this application is to be  imported into earlier database versions you should test the script for backward compatibility. For example, if '
||'generating tables in Oracle Database 12c the script may contain IDENTITY Column clauses which will fail in Oracle Database 11g.'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(621103696869076433)
,p_button_sequence=>110
,p_button_plug_id=>wwv_flow_imp.id(584635221052978322)
,p_button_name=>'Clear'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Clear'
,p_button_redirect_url=>'f?p=&APP_ID.:858:&SESSION.::&DEBUG.:RP:P858_FILTER::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(584640153596978339)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(584639920493978339)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(584640350238978341)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(584639920493978339)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(584640541110978341)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(584639920493978339)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(590329370754334815)
,p_branch_name=>'Go To Page 865'
,p_branch_action=>'f?p=&APP_ID.:865:&SESSION.::&DEBUG.:865:P865_SCRIPT_SEQUENCE,P865_MODE:&P855_SCRIPT_SEQUENCE.,NEW'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(584640350238978341)
,p_branch_sequence=>100
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(584643384080978349)
,p_branch_name=>'Go To Page 855'
,p_branch_action=>'f?p=&APP_ID.:855:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(584640541110978341)
,p_branch_sequence=>90
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(584635482286978327)
,p_name=>'P858_SCRIPT_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(584635221052978322)
,p_item_default=>'INSTALL'
,p_prompt=>'Script Type:'
,p_source=>'P850_MODE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'SUPPORTING OBJECT SCRIPT TYPES'
,p_lov=>'.'||wwv_flow_imp.id(57799129745997268)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the type of supporting object script you are creating.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(584635909999978329)
,p_name=>'P858_SCRIPT_SOURCE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(584635221052978322)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Script Source Type:'
,p_source=>'P850_SCRIPT_SOURCE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'INSTALL_SCRIPT_SOURCE'
,p_lov=>'.'||wwv_flow_imp.id(4626801323289842)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'This is the method you are using to create an installation script.  All installation scripts are editable after they are created.  To change the script source type, go back to the first step of this wizard.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(584636425635978331)
,p_name=>'P858_SCRIPT_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(584635221052978322)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name:'
,p_source=>'P855_SCRIPT_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the name for the script you are creating.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(584636917673978332)
,p_name=>'P858_SCRIPT_SEQUENCE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(584635221052978322)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Sequence:'
,p_source=>'P855_SCRIPT_SEQUENCE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the sequence number for the script you are creating.  The scripts will be run in order according to the sequence numbers.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(584637922451978332)
,p_name=>'P858_OBJECT_OWNER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(584635221052978322)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Object Owner:'
,p_source=>'P855_OBJECT_OWNER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Identifies the owner of the database object.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(584638390816978333)
,p_name=>'P858_OBJECT_TYPE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(584635221052978322)
,p_prompt=>'Object Types:'
,p_source=>'replace(:P855_OBJECT_TYPE,'':'','', '')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the object types for this script.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(584638526915978333)
,p_name=>'P858_OBJECT'
,p_is_required=>true
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(584635221052978322)
,p_prompt=>'Object'
,p_display_as=>'NATIVE_SHUTTLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name||'' (''||object_type||'')'' d, object_name r',
'  from sys.dba_objects',
' where owner = :P855_OBJECT_OWNER',
'   and object_name not like ''SYS\_%'' escape ''\''',
'   and object_name not like ''APEX$%''',
'   and object_type in (select * from table(wwv_flow_string.split(:P855_OBJECT_TYPE,'':'')))',
'   and (instr(object_name,upper(:P858_FILTER)) > 0 or :P858_FILTER is null)',
' order by object_type, object_name'))
,p_lov_cascade_parent_items=>'P858_FILTER'
,p_ajax_items_to_submit=>'P858_FILTER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>15
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select one or more objects from the list.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ALL'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(621101924371076416)
,p_name=>'P858_PKG_OPTIONS'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(584635221052978322)
,p_item_default=>'PACKAGE_SPEC:PACKAGE_BODY'
,p_prompt=>'Package Options'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>'STATIC2:Package Specification;PACKAGE_SPEC,Package Body;PACKAGE_BODY'
,p_display_when=>'P858_OBJECT_TYPE'
,p_display_when2=>'PACKAGE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose whether the generate package specifications, package bodies, or both.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(621103222388076429)
,p_name=>'P858_FILTER'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(584635221052978322)
,p_prompt=>'Filter'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a filter criteria for the object list and press enter.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(621102099648076417)
,p_validation_name=>'pkg options not null'
,p_validation_sequence=>10
,p_validation=>'P858_PKG_OPTIONS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'You must select a package option.'
,p_validation_condition=>'P858_OBJECT_TYPE'
,p_validation_condition2=>'PACKAGE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(584640350238978341)
,p_associated_item=>wwv_flow_imp.id(621101924371076416)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00859
begin
wwv_flow_imp_page.create_page(
 p_id=>859
,p_name=>'Create Report on Web Services'
,p_alias=>'CREATE-REPORT-ON-WEB-SERVICES1'
,p_page_mode=>'MODAL'
,p_step_title=>'&P759_REPORT_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'advnc_web_services.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44544002248058173)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193937726065104070)
,p_plug_name=>'Create &P759_REPORT_TITLE.'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193939704734104079)
,p_plug_name=>'Wizard Steps'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(114018423833281484)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(193937910763104072)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(44544002248058173)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(193938106162104073)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(44544002248058173)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(193938311276104073)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(44544002248058173)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(193941032749104100)
,p_branch_action=>'f?p=&APP_ID.:860:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(193938106162104073)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(193941418491104103)
,p_branch_action=>'f?p=&APP_ID.:778:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(193938311276104073)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(193941200615104102)
,p_branch_action=>'f?p=&FLOW_ID.:859:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(193938521096104074)
,p_name=>'P859_OPERATION_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(193937726065104070)
,p_prompt=>'Operation'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(193939102525104078)
,p_name=>'P859_WS_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(193937726065104070)
,p_prompt=>'Web Service Reference'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REST_WEB_SERVICES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id r',
'  from wwv_flow_shared_web_services',
' where action = ''REST''',
'   and flow_id = :FB_FLOW_ID',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'-- Select Service --'
,p_lov_null_value=>'0'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the name of the Web service reference.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(193940620915104091)
,p_computation_sequence=>10
,p_computation_item=>'P859_OPERATION_ID'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'  from wwv_flow_ws_operations',
' where ws_id = :P859_WS_ID',
'   and name = ''doREST'''))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(193940813483104098)
,p_validation_name=>'P859_WS_ID'
,p_validation_sequence=>10
,p_validation=>'nvl(:P859_WS_ID,''0'') != ''0'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'You must choose a web service.'
,p_when_button_pressed=>wwv_flow_imp.id(193938106162104073)
,p_associated_item=>wwv_flow_imp.id(193939102525104078)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(549885518294989012)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(193937910763104072)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(549885632584989013)
,p_event_id=>wwv_flow_imp.id(549885518294989012)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00860
begin
wwv_flow_imp_page.create_page(
 p_id=>860
,p_name=>'Create Report on Web Services'
,p_alias=>'CREATE-REPORT-ON-WEB-SERVICES2'
,p_page_mode=>'MODAL'
,p_step_title=>'&P759_REPORT_TITLE.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript" language="JavaScript1.1">',
'    function ToggleAll(e){	if (e.checked) {	CheckAll();	}',
'    	else {	ClearAll();	}',
'    }',
'    function Check(e){	e.checked = true;}',
'    function Clear(e){	e.checked = false;}',
'    function CheckAll(){	',
'        var ml = document.wwv_flow;	',
'        var len = ml.elements.length;	',
'        for (var i = 0; i < len; i++) {',
'        var e = ml.elements[i];	',
'        if (e.name == "f01" ||e.name == "f03" ||e.name == "f05" || e.name == "f07" || e.name == "f09" ||e.name == "f11" ||e.name == "f13" || e.name == "f15" ) {',
'        Check(e);}',
'        }',
'        ml.f01.checked = true;',
'    }',
'    function ClearAll(){	',
'        var ml = document.wwv_flow;	',
'        var len = ml.elements.length;	',
'        for (var i = 0; i < len; i++) {	',
'          var e = ml.elements[i];	if (e.name == "f01" ||	e.name == "f03" ||e.name == "f05" ||e.name == "f07" ||e.name == "f09" ||e.name == "f11" ||e.name == "f13" ||e.name == "f15" ) {		Clear(e);	}',
'        	}',
'        	ml.f01.checked = false;',
'    }',
'</script>'))
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'advnc_web_services.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(193942426256118931)
,p_name=>'Create &P759_REPORT_TITLE.'
,p_template=>wwv_flow_imp.id(42025417508627628)
,p_display_sequence=>150
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.checkbox(1,id,''title="''||wwv_flow_lang.system_message(''SELECT_ROW_C'', wwv_flow_escape.html(name))||''"'',:P860_CHECKED_ITEMS) x, ',
'       name, parm_type',
'  from wwv_flow_ws_parameters',
' where ws_opers_id = :P778_REST_OPERATION_ID',
'   and input_or_output = ''O'''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>1000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(193942626753118933)
,p_query_column_id=>1
,p_column_alias=>'X'
,p_column_display_sequence=>1
,p_column_heading=>'#CHECK_ALL_CHECKBOX#'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(193942712204118933)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(193942817972118933)
,p_query_column_id=>3
,p_column_alias=>'PARM_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Parameter Type'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193945527367118942)
,p_plug_name=>'Wizard Steps'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(114018423833281484)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(206216524481494576)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>160
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(193942932393118933)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(206216524481494576)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(193943126410118934)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(206216524481494576)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(193943300739118935)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(206216524481494576)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(193947830781118958)
,p_branch_name=>'Go To Page 778'
,p_branch_action=>'f?p=&APP_ID.:778:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(193943300739118935)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(193948013025118960)
,p_branch_action=>'f?p=&APP_ID.:786:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(193943126410118934)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(193943508566118935)
,p_name=>'P860_CHECKED_ITEMS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(193942426256118931)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(193943713355118936)
,p_name=>'P860_ROW_TEMPLATE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(193942426256118931)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select default_report_template from wwv_flow_themes where flow_id = :fb_flow_id and theme_id = :fb_theme_id and default_report_template is not null) loop',
'   return c1.default_report_template;',
'end loop;',
'return null;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Report Template'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REPORT.TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME1'')  d,  1 r from sys.dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME2'')  d,  2 r from sys.dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME21'') d, 21 r from sys.dual union',
'select wwv_flow_lang.system_message(''CONFIRM.RPT_TEMPLATE_NAME22'') d, 22 r from sys.dual union',
'select wwv_flow_lang.system_message(''CONFIRM.TEMPLATE'')||'' ''||theme_id||''. ''||wwv_flow_escape.html(row_template_name) d, id r',
'  from wwv_flow_row_templates ',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID ',
'   and (:FB_THEME_ID is null or theme_id = :FB_THEME_ID)',
' order by 1'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Choose the report template to be used by this report region.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(193944330965118939)
,p_name=>'P860_ROWS_PER_PAGE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(193942426256118931)
,p_item_default=>'15'
,p_prompt=>'Rows Per Page'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Select the number of rows to display per page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(193944924004118940)
,p_name=>'P860_RESULT_COLLECTION'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_imp.id(193942426256118931)
,p_prompt=>'Result Stored in Collection'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the name of the temporary result set name where the Web service result is stored. The temporary result set is stored in an &PRODUCT_NAME. collection.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(193946620650118952)
,p_computation_sequence=>10
,p_computation_item=>'P860_CHECKED_ITEMS'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_utilities.table_to_string(wwv_flow.g_f01)'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(193946807990118953)
,p_computation_sequence=>20
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_page_dev.get_theme_id (',
'    p_application_id => :FB_FLOW_ID,',
'    p_page_id        => :FB_FLOW_PAGE_ID )'))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(193947217451118955)
,p_validation_name=>'At least one parameter chosen'
,p_validation_sequence=>10
,p_validation=>'return wwv_flow.g_f01.count > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'You must choose at least one parameter for the report.'
,p_when_button_pressed=>wwv_flow_imp.id(193943126410118934)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(193947013095118954)
,p_validation_name=>'P860_RESULT_COLLECTION not null'
,p_validation_sequence=>20
,p_validation=>'P860_RESULT_COLLECTION'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'You must supply the name of the collection containing the Web service result.'
,p_when_button_pressed=>wwv_flow_imp.id(193943126410118934)
,p_associated_item=>wwv_flow_imp.id(193944924004118940)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(549885914581989016)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(193942932393118933)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(549886098534989017)
,p_event_id=>wwv_flow_imp.id(549885914581989016)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1199172587508878401)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>20
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(193942426256118931)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1199172624183878402)
,p_event_id=>wwv_flow_imp.id(1199172587508878401)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(193947615142118958)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  i integer;',
'begin',
'  wwv_flow_collection.create_or_truncate_collection(''WS_ARRAY_PARMS'');',
'  for i in 1.. wwv_flow.g_f01.count loop',
'    wwv_flow_collection.add_member(',
'      p_collection_name => ''WS_ARRAY_PARMS'',',
'      p_c001            => wwv_flow.g_f01(i) );',
'  end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>193947615142118958
);
end;
/
prompt --application/pages/page_00862
begin
wwv_flow_imp_page.create_page(
 p_id=>862
,p_name=>'Upgrade Application'
,p_alias=>'UPGRADE-APPLICATION4'
,p_step_title=>'Upgrade Application - Select Validations to Always Execute'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(631609404846532631)
,p_plug_name=>'top bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>15
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(631610423265532635)
,p_plug_name=>'Wizard Menu'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(484017424976766961)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
,p_plug_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(631610822607532637)
,p_plug_name=>'Other Validations'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--scrollAuto:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>102
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select htmldb_item.checkbox( 1,v.id, (',
'          select ''CHECKED'' from wwv_flow_collections ',
'           where collection_name = ''UPGRADE_VALIDATIONS2'' ',
'             and n001 = v.id),null,'':'', ''f''||lpad(''''||1,2,''0'') || ''_'' || lpad(''''||rownum,4,''0'') ,',
'     wwv_flow_lang.system_message(''VALIDATION_LABEL'', v.validation_name)) checkbox,',
'       (select i.name',
'          from wwv_flow_step_items i',
'         where i.flow_id           = :FB_FLOW_ID',
'           and i.security_group_id = :WORKSPACE_ID',
'           and i.name         = v.validation',
'           and i.flow_id      = v.flow_id',
'           and i.flow_step_id = v.flow_step_id ) item_name,',
'       v.id              as validation_id,',
'       v.validation_name,',
'       v.validation_type,',
'       (select wwv_flow_escape.html(b.button_name)||'' (''||',
'               wwv_flow_escape.html(b.BUTTON_IMAGE_ALT)||'')'' button_name',
'          from wwv_flow_step_buttons b',
'         where b.flow_id = :FB_FLOW_ID',
'           and b.id = v.when_button_pressed ) button_name,',
'       v.validation_condition_type condition,',
'       v.validation_condition  cond_exp1,',
'       v.validation_condition2 cond_exp2',
'  from wwv_flow_step_validations v',
' where v.flow_id            = :FB_FLOW_ID',
'   and v.security_group_id  = :WORKSPACE_ID',
'   and v.flow_step_id       = :P862_PAGE_ID',
'   and v.always_execute     = ''N''',
'   and v.id not in (select n001 from wwv_flow_collections ',
'                     where collection_name = ''UPGRADE_VALIDATIONS'')'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(631611005074532639)
,p_name=>'Migration Objects'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No other Validations found on the page.'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_show_finder_drop_down=>'N'
,p_show_search_textbox=>'N'
,p_show_actions_menu=>'N'
,p_report_list_mode=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_enable_mail_download=>'N'
,p_owner=>'SATHISH'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(631611308815532645)
,p_db_column_name=>'CHECKBOX'
,p_display_order=>2
,p_column_identifier=>'F'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(631611131559532642)
,p_db_column_name=>'VALIDATION_NAME'
,p_display_order=>3
,p_column_identifier=>'B'
,p_column_label=>'Validation Name'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(631611231096532645)
,p_db_column_name=>'BUTTON_NAME'
,p_display_order=>5
,p_column_identifier=>'D'
,p_column_label=>'Associated Button'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(631611609350532646)
,p_db_column_name=>'ITEM_NAME'
,p_display_order=>8
,p_column_identifier=>'I'
,p_column_label=>'Associated Item'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(631611704254532646)
,p_db_column_name=>'VALIDATION_ID'
,p_display_order=>9
,p_column_identifier=>'J'
,p_column_label=>'Validation Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(631611819113532646)
,p_db_column_name=>'VALIDATION_TYPE'
,p_display_order=>10
,p_column_identifier=>'K'
,p_column_label=>'Validation Type'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_imp.id(630881727193397263)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(631611928399532647)
,p_db_column_name=>'CONDITION'
,p_display_order=>11
,p_column_identifier=>'L'
,p_column_label=>'Condition'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_imp.id(13602414170805697)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(631612002749532648)
,p_db_column_name=>'COND_EXP1'
,p_display_order=>12
,p_column_identifier=>'M'
,p_column_label=>'Expression 1'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(631612107668532648)
,p_db_column_name=>'COND_EXP2'
,p_display_order=>13
,p_column_identifier=>'N'
,p_column_label=>'Expression 2'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(631612225043532648)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1291910117536644'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'CHECKBOX:VALIDATION_NAME:VALIDATION_TYPE:ITEM_NAME:BUTTON_NAME:CONDITION:COND_EXP1:COND_EXP2'
,p_sort_column_1=>'VALIDATION_NAME'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'0'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(631612413780532650)
,p_plug_name=>'Upgrade Application'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_plug_source=>'Below are any other validations on your page which are not set to Always Execute.  If you set any buttons to Not Execute Validations, you may want to select some of these to set to Always Execute.  For example, if you have a Delete button that does n'
||'ot execute validations and you have a validation that does a privilege check, you would want that validation to Always Execute.'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747146503577138173)
,p_plug_name=>'Upgrade Application'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(631610011605532633)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(631609404846532631)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:674:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(631609825725532633)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(631609404846532631)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :p862_page is null then',
'  return true;',
'else',
'  for c1 in (select 1 x from wwv_flow_lock_page where locked_by is not null and flow_id = :fb_flow_id and object_id = :p862_page) loop',
'     return false;',
'  end loop;',
'end if;',
'return true;'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'FUNCTION_BODY'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(631609611212532632)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(631609404846532631)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:646:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(631613531793532662)
,p_branch_action=>'f?p=&APP_ID.:383:&SESSION.::&DEBUG.::P383_PAGE_ID:&P862_PAGE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(631609825725532633)
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(631610221942532634)
,p_name=>'P862_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(631612413780532650)
,p_prompt=>'Page:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2045580979987367806)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(631610822607532637)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2045581047849367807)
,p_event_id=>wwv_flow_imp.id(2045580979987367806)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(631613316747532659)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Add Validations'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_collection_status number;',
'   l_id                number;',
'   l_count             number;',
'begin',
'    wwv_flow_collection.create_or_truncate_collection(',
'        p_collection_name => ''UPGRADE_VALIDATIONS2'');',
'    for i in 1..wwv_flow.g_f01.count ',
'    loop',
'        l_id := wwv_flow.g_f01(i);',
'        select count(*) into l_count ',
'          from wwv_flow_collections ',
'         where n001            = l_id ',
'           and collection_name = ''UPGRADE_VALIDATIONS2'';',
'        if l_count = 0 then ',
'            l_collection_status := wwv_flow_collection.add_member(',
'                 p_collection_name => ''UPGRADE_VALIDATIONS2'',',
'                 p_n001            => l_id);',
'        end if;',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>631613316747532659
);
end;
/
prompt --application/pages/page_00864
begin
wwv_flow_imp_page.create_page(
 p_id=>864
,p_name=>'Conditional Regions'
,p_alias=>'CONDITIONAL-REGIONS'
,p_step_title=>'Conditional Regions'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213220627333807318)
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_region.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(194203124847418277)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>91
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(13987931263515071)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(194210703308436164)
,p_plug_name=>'Region Conditions'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>125
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select page_id, PLUG_NAME, ',
'PLUG_DISPLAY_WHEN_CONDITION, ',
'PLUG_DISPLAY_WHEN_COND2, ',
'PLUG_DISPLAY_CONDITION_TYPE,',
'id',
'from WWV_FLOW_PAGE_PLUGS',
'where ',
' flow_id = :fb_flow_id and',
' plug_display_condition_type is not null'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(194210801252436164)
,p_name=>'Region Conditions'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194211012826436166)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Page'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE_ID#'
,p_column_linktext=>'#PAGE_ID#'
,p_column_link_attr=>'title="View page definition"'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194211122123436167)
,p_db_column_name=>'PLUG_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Region'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE_ID##5110:#ID#'
,p_column_linktext=>'#PLUG_NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194211424024436169)
,p_db_column_name=>'PLUG_DISPLAY_CONDITION_TYPE'
,p_display_order=>3
,p_column_identifier=>'E'
,p_column_label=>'Condition Type'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(13602414170805697)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194211231307436168)
,p_db_column_name=>'PLUG_DISPLAY_WHEN_CONDITION'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>'Expression 1'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194211325028436168)
,p_db_column_name=>'PLUG_DISPLAY_WHEN_COND2'
,p_display_order=>5
,p_column_identifier=>'D'
,p_column_label=>'Expression 2'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(57831562322033948)
,p_db_column_name=>'ID'
,p_display_order=>15
,p_column_identifier=>'F'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(194211710829437614)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1292000913536644'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'PAGE_ID:PLUG_NAME:PLUG_DISPLAY_CONDITION_TYPE:PLUG_DISPLAY_WHEN_CONDITION:PLUG_DISPLAY_WHEN_COND2:'
,p_sort_column_1=>'PAGE_ID'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(194216828191471000)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(194210703308436164)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:864:&SESSION.::&DEBUG.:864,RIR::'
);
end;
/
prompt --application/pages/page_00865
begin
wwv_flow_imp_page.create_page(
 p_id=>865
,p_name=>'Script Editor'
,p_alias=>'SCRIPT-EDITOR'
,p_step_title=>'Script Editor'
,p_reload_on_submit=>'A'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(24897722063538624)
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'htmldb_null_script=''"NULL_SCRIPT"'';',
'htmldb_max_script_size=''"MAX_SCRIPT_SIZE"'';',
'function pageSubmit(req) {',
'    if ( $v(''P865_MODE'') !== ''DEINSTALL'' ) {',
'        apex.builder.plugin.codeEditor.saveSubmit("#P865_INSTALL_SCRIPT_widget", "f01", {request: req, showWait: true});',
'    } else {',
'        apex.builder.plugin.codeEditor.saveSubmit("#P865_DEINSTALL_SCRIPT_widget", "f01", {request: req, showWait: true});',
'    }',
'}',
''))
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery(".a-Body, .a-Main, .a-EditScreen, .a-EditScreen-body, .a-MonacoEditor").addClass("resize");',
'apex.jQuery(".a-Body").on("resize", function(event) {',
'    var main$, side$;',
'    if (event.target !== this) {',
'        return;',
'    }',
'    main$ = $(this).children(".a-Main");',
'    side$ = $(this).children(".a-Side");',
'    main$.css({display: "block", position: "absolute", top: 0, left: 0});',
'    side$.css({display: "block", position: "absolute", top: 0, right: 0});',
'    apex.util.setOuterHeight( side$, $(this).height() );',
'    apex.util.setOuterWidth( side$, side$.outerWidth() );',
'    apex.util.setOuterHeight( main$, $(this).height() );',
'    apex.util.setOuterWidth( main$, $(this).width() - side$.outerWidth() );',
'    event.stopPropagation();',
'    main$.trigger("resize");',
'    $(this).css({display: "block", position: "relative"});',
'});',
'apex.jQuery("#page_success_msg button").click(function() {',
'    $("body").trigger("resize");',
'});',
'apex.theme.pageResizeInit();'))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-Body {',
'    display: table;',
'    width: 100%;',
'}',
'.a-Main, .a-Side {',
'    display: table-cell;',
'}'))
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(857903402130335025)
,p_protection_level=>'C'
,p_help_text=>'deployment.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4874415838535180)
,p_plug_name=>'Script Tabs'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(4852514958421306)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P865_MODE'
,p_plug_display_when_cond2=>'EDIT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8320991744121632)
,p_plug_name=>'topbar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(133088306023461536)
,p_plug_name=>'Edit Script'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>110
,p_translate_title=>'N'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'not wwv_flow_sw_api.g_raise_errors'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(402533935348598952)
,p_plug_name=>'Edit Install Script'
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="clear:both"'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>80
,p_plug_display_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_plug_display_when_condition=>'P865_MODE'
,p_plug_display_when_cond2=>'EDIT:NEW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(402550986718150677)
,p_plug_name=>'Edit Deinstall Script'
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="clear:both"'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>100
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P865_MODE'
,p_plug_display_when_cond2=>'DEINSTALL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(537839780223118519)
,p_plug_name=>'Database Objects'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>50
,p_plug_display_condition_type=>'NEVER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(537840053704118522)
,p_name=>'Database Objects'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>60
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--noPadding:h180'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.checkbox(1,seq_id) seq_id,',
'       c002 object_owner,',
'       c003 object_type,',
'       c004 object_name,',
'       c006 status',
'  from wwv_flow_collections',
' where collection_name = ''INSTALL_OBJECTS''',
'   and nvl(c005,''0'') = ''0'''))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_install_objects',
' where script_id = :P865_SCRIPT_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and flow_id = :FB_FLOW_ID',
'   and :P865_MODE = ''EDIT''',
'    or (nvl(:P865_MODE,''x'') != ''EDIT'' and :P850_SCRIPT_SOURCE = ''DB'')'))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>9999
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'1:2'
,p_query_row_count_max=>9999
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(537840627188118528)
,p_query_column_id=>1
,p_column_alias=>'SEQ_ID'
,p_column_display_sequence=>5
,p_column_heading=>'<input type="checkbox" onclick="html_CheckAll($x_UpTill(this,''TABLE''),this.checked)" />'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_when_cond_type=>'ITEM_IS_NOT_NULL'
,p_display_when_condition=>'P865_OBJ_COLLECTION_CREATED'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(537840232920118524)
,p_query_column_id=>2
,p_column_alias=>'OBJECT_OWNER'
,p_column_display_sequence=>1
,p_column_heading=>'Object Owner'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(537840323291118525)
,p_query_column_id=>3
,p_column_alias=>'OBJECT_TYPE'
,p_column_display_sequence=>2
,p_column_heading=>'Object Type'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(537840457504118526)
,p_query_column_id=>4
,p_column_alias=>'OBJECT_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Object Name'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(621100784077076404)
,p_query_column_id=>5
,p_column_alias=>'STATUS'
,p_column_display_sequence=>4
,p_column_heading=>'Status'
,p_use_as_row_header=>'N'
,p_display_when_cond_type=>'ITEM_IS_NOT_NULL'
,p_display_when_condition=>'P865_OBJ_COLLECTION_CREATED'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(621102570778076422)
,p_plug_name=>'Information'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>'<strong>Note:</strong> If you add or delete database objects, or refresh, any manual changes you applied to the script will be lost.'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P865_OBJ_COLLECTION_CREATED'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(618947315266117442)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(537840053704118522)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Add Object'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:887:&SESSION.::&DEBUG.:887:P887_OBJECT_OWNER:&P865_OBJECT_OWNER.'
,p_button_condition=>'P865_OBJ_COLLECTION_CREATED'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(133524400160130453)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(8320991744121632)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(133099306975506413)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(8320991744121632)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'&P865_BUTTON_LABEL.'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(615012010767884573)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(537840053704118522)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete Checked'
,p_button_position=>'CREATE2'
,p_button_condition=>'P865_OBJ_COLLECTION_CREATED'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(537838745432118509)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(537840053704118522)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Refresh Script'
,p_button_position=>'CREATE2'
,p_button_condition=>'P865_OBJ_COLLECTION_CREATED'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(107283299301623866)
,p_branch_action=>'f?p=&APP_ID.:328:&SESSION.::&DEBUG.::P328_ID:&P865_SCRIPT_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_328'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(40463932174517858)
,p_branch_action=>'f?p=&APP_ID.:576:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P865_MODE'
,p_branch_condition_text=>'DEINSTALL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(32350120340320553)
,p_branch_action=>'f?p=&APP_ID.:667:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>65
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P865_MODE'
,p_branch_condition_text=>'UPGRADE'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(47927614335320671)
,p_branch_action=>'f?p=&APP_ID.:667:&SESSION.::&DEBUG.:RP::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>80
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P850_MODE'
,p_branch_condition_text=>'UPGRADE'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(537841142942118533)
,p_branch_name=>'Go to 865'
,p_branch_action=>'f?p=&APP_ID.:865:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>90
,p_branch_condition_type=>'REQUEST_IN_CONDITION'
,p_branch_condition=>'DELETE,REFRESH,DIALOG'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(80599326089398202)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>100
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(11488511416108892)
,p_branch_name=>'Go To Page 473'
,p_branch_action=>'f?p=&APP_ID.:473:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>110
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9291108602279927)
,p_name=>'P865_MODE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(133088306023461536)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40449916974466128)
,p_name=>'P865_SCRIPT_SEQUENCE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(133088306023461536)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(108549999222587142)
,p_name=>'P865_STORE_TEMP_SCRIPT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(133088306023461536)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(112466272709387124)
,p_name=>'P865_INSTALL_SCRIPT'
,p_data_type=>'CLOB'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(402533935348598952)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select clob001',
'  from wwv_flow_collections',
' where collection_name = ''INSTALL_SCRIPT_ORIG'''))
,p_source_type=>'QUERY'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_attribute_01=>'DDL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(112466340489387125)
,p_name=>'P865_DEINSTALL_SCRIPT'
,p_data_type=>'CLOB'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(402550986718150677)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select deinstall_script',
'  from wwv_flow_install',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_attribute_01=>'DDL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(112466861131387130)
,p_name=>'P865_REFRESH_SCRIPT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(133088306023461536)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(133367803441912715)
,p_name=>'P865_MAX_LENGTH'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(133088306023461536)
,p_source=>'nvl(wwv_flow_platform.get_preference(''MAX_SCRIPT_SIZE''),500000)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(133521606398123923)
,p_name=>'P865_SCRIPT_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(133088306023461536)
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(139588582590810349)
,p_name=>'P865_SCRIPT_NAME'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_imp.id(8320991744121632)
,p_prompt=>'Script Name:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'This is the name of the script you are editing.  You can change the script name by editing the script''s properties.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(537837987167118501)
,p_name=>'P865_COLLECTION_CREATED'
,p_item_sequence=>65
,p_item_plug_id=>wwv_flow_imp.id(8320991744121632)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(537838540178118507)
,p_name=>'P865_OBJECT_OWNER'
,p_item_sequence=>45
,p_item_plug_id=>wwv_flow_imp.id(537839780223118519)
,p_prompt=>'Object Owner:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'P865_OBJECT_OWNER'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(537841276105118534)
,p_name=>'P865_OBJ_COLLECTION_CREATED'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(537840053704118522)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(551194954402315302)
,p_name=>'P865_OBJECT_TYPE'
,p_item_sequence=>55
,p_item_plug_id=>wwv_flow_imp.id(537839780223118519)
,p_prompt=>'Object Type:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_display_when=>'P865_OBJECT_OWNER'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(551195139801322056)
,p_name=>'P865_OBJECT_NAME'
,p_item_sequence=>65
,p_item_plug_id=>wwv_flow_imp.id(537839780223118519)
,p_prompt=>'Object Name:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_display_when=>'P865_OBJECT_OWNER'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(621100502742076402)
,p_name=>'P865_BUTTON_LABEL'
,p_item_sequence=>55
,p_item_plug_id=>wwv_flow_imp.id(8320991744121632)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(621102298452076419)
,p_name=>'P865_SCRIPT_OPTION'
,p_item_sequence=>45
,p_item_plug_id=>wwv_flow_imp.id(8320991744121632)
,p_prompt=>'Script Option:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'P865_SCRIPT_OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(686919732026917492)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'P865_SCRIPT_OPTION'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'This items displays options for the script, whether to generate only package specifications, only package bodies, or generate DDL related to selected tables.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(955893854710997349)
,p_name=>'P865_DEINSTALL_MODE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(133088306023461536)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(621100690493076403)
,p_computation_sequence=>10
,p_computation_item=>'P865_BUTTON_LABEL'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if nvl(:P865_MODE,''x'') not in ( ''DEINSTALL'', ''EDIT'' ) or nvl(:P865_DEINSTALL_MODE,''x'') = ''CREATE'' then',
'    return wwv_flow_lang.system_message(''CREATE'');',
'else',
'    return wwv_flow_lang.system_message(''WWV_FLOW_CUSTOMIZE.T_APPLY'');',
'end if;'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(108506090659291320)
,p_computation_sequence=>10
,p_computation_item=>'P865_STORE_TEMP_SCRIPT'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_code        clob := empty_clob;',
'begin    ',
'    sys.dbms_lob.createtemporary( l_code, false, sys.dbms_lob.SESSION );',
'   ',
'    htmldb_collection.create_or_truncate_collection(',
'        p_collection_name => ''INSTALL_SCRIPT'');',
'',
'    for i in 1..wwv_flow.g_f01.count loop',
'        if wwv_flow.g_f01(i) is not null then',
'            sys.dbms_lob.writeappend(l_code,length(wwv_flow.g_f01(i)),wwv_flow.g_f01(i));      ',
'        end if;  ',
'    end loop;        ',
'    ',
'    htmldb_collection.add_member(',
'        p_collection_name => ''INSTALL_SCRIPT'',',
'        p_clob001         => l_code);',
'',
'    return null;        ',
'end;'))
,p_compute_when=>'CREATE,APPLY_CHANGES,APPLY_CHANGES_328,APPLY_CHANGES_865'
,p_compute_when_type=>'REQUEST_IN_CONDITION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(112467441743387136)
,p_computation_sequence=>20
,p_computation_item=>'P865_REFRESH_SCRIPT'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'Y'
,p_compute_when=>'REFRESH,DELETE,DIALOG'
,p_compute_when_type=>'REQUEST_IN_CONDITION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(537842773205118549)
,p_name=>'add object closed'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(618947315266117442)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(537842807838118550)
,p_event_id=>wwv_flow_imp.id(537842773205118549)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(621100860684076405)
,p_event_id=>wwv_flow_imp.id(537842773205118549)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(402533935348598952)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(621101768647076414)
,p_event_id=>wwv_flow_imp.id(537842773205118549)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'TRIGGERING_ELEMENT'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(929195875726394222)
,p_name=>'Apply'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(133099306975506413)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(929195971949394223)
,p_event_id=>wwv_flow_imp.id(929195875726394222)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'pageSubmit("APPLY_CHANGES");',
''))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(112466451289387126)
,p_name=>'Warn onCreate Install Script'
,p_event_sequence=>30
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXISTS'
,p_display_when_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_collections',
' where collection_name = ''INSTALL_SCRIPT_ORIG''',
'   and clob001 is not null',
'   and :P865_SCRIPT_ID is null'))
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(112466513021387127)
,p_event_id=>wwv_flow_imp.id(112466451289387126)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.items.P865_INSTALL_SCRIPT.value += " ";'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(112467259402387134)
,p_name=>'Warn onRefresh Install Script'
,p_event_sequence=>40
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_cond=>'P865_REFRESH_SCRIPT'
,p_display_when_cond2=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(112467326241387135)
,p_event_id=>wwv_flow_imp.id(112467259402387134)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.items.P865_INSTALL_SCRIPT.value +=  " ";'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(538434480548694551)
,p_process_sequence=>125
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Remove Collections'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_collection.collection_exists(''INSTALL_SCRIPT_ORIG'') then',
'    wwv_flow_collection.delete_collection(''INSTALL_SCRIPT_ORIG'');',
'end if;',
'if wwv_flow_collection.collection_exists(''INSTALL_OBJECTS'') then',
'    wwv_flow_collection.delete_collection(''INSTALL_OBJECTS'');',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P865_COLLECTION_CREATED'
,p_process_when_type=>'ITEM_IS_NULL'
,p_internal_uid=>538434480548694551
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(537838356552118505)
,p_process_sequence=>130
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate INSTALL_SCRIPT_ORIG'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_code        clob;',
'    l_obj_type    varchar2(4000);',
'begin',
'',
'    wwv_flow_collection.create_or_truncate_collection(',
'        p_collection_name => ''INSTALL_SCRIPT_ORIG'');',
'',
'    if :P865_MODE = ''EDIT'' then',
'        for c1 in (select script',
'                     from wwv_flow_install_scripts',
'                    where id = :P865_SCRIPT_ID',
'                      and security_group_id = :flow_security_group_id) loop',
'            l_code := c1.script;',
'        end loop;   ',
'    elsif :P850_SCRIPT_SOURCE = ''DB'' then',
'        if :P855_OBJECT_TYPE = ''PACKAGE'' and :P858_PKG_OPTIONS <> ''PACKAGE_SPEC:PACKAGE_BODY'' then',
'            l_obj_type := :P858_PKG_OPTIONS;',
'            :P865_SCRIPT_OPTION := l_obj_type;',
'        else',
'            l_obj_type := :P855_OBJECT_TYPE;',
'        end if;',
'        ',
'        l_code := wwv_flow_generate_ddl.get_ddl_supporting_objects(',
'                          p_schema      => :P855_OBJECT_OWNER,',
'                          p_object_type => l_obj_type,',
'                          p_objects     => :P858_OBJECT);',
'    end if;',
'',
'    wwv_flow_collection.add_member(',
'        p_collection_name => ''INSTALL_SCRIPT_ORIG'',',
'        p_clob001         => l_code);',
'        ',
'    :P865_COLLECTION_CREATED := ''Y'';        ',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>':P865_COLLECTION_CREATED is null and (:P865_MODE = ''EDIT'' or nvl(:P850_SCRIPT_SOURCE,''x'')=''DB'')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>537838356552118505
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(537839813572118520)
,p_process_sequence=>140
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate INSTALL_OBJECTS edit'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    n        wwv_flow_global.vc_arr2;',
'    v        wwv_flow_global.vc_arr2;',
'    l_sql    varchar2(32767);',
'begin',
'    n(1) := ''script_id'';',
'    n(2) := ''workspace_id'';',
'    n(3) := ''fb_flow_id'';',
'    v(1) := :P865_SCRIPT_ID;',
'    v(2) := :WORKSPACE_ID;',
'    v(3) := :FB_FLOW_ID;',
'    ',
'    if wwv_flow_collection.collection_exists(''INSTALL_OBJECTS'') then',
'        wwv_flow_collection.delete_collection(''INSTALL_OBJECTS'');',
'    end if;        ',
'    ',
'    l_sql := q''{select b.id, replace(b.object_owner,''#''||''OWNER''||''#'',wwv_flow_wizard_api.get_flow_owner) object_owner, b.object_type, b.object_name}''||',
'             ''  from wwv_flow_install_scripts a, wwv_flow_install_objects b''||',
'             '' where a.id = b.script_id''||',
'             ''   and b.script_id = :script_id''||',
'             ''   and a.security_group_id = :workspace_id''||',
'             ''   and a.flow_id = :fb_flow_id''||',
'             '' order by object_type, object_name'';',
'',
'    wwv_flow_collection.create_collection_from_query_b(',
'        p_collection_name => ''INSTALL_OBJECTS'',',
'        p_query           => l_sql,',
'        p_names           => n,',
'        p_values          => v);',
'        ',
'    --populate the object has changed message',
'    for c1 in (select seq_id',
'                 from wwv_flow_collections b',
'                where collection_name = ''INSTALL_OBJECTS''',
'                  and exists (select 1',
'                                from sys.dba_objects a',
'                               where a.owner = b.c002',
'                                 and a.object_type = b.c003',
'                                 and a.object_name = b.c004',
'                                 and b.c002 = :P865_OBJECT_OWNER',
'                                 and a.last_ddl_time > ',
'                                     (select nvl(last_updated_on,created_on)',
'                                       from wwv_flow_install_scripts',
'                                      where security_group_id = :WORKSPACE_ID',
'                                        and flow_id = :FB_FLOW_ID',
'                                        and id = :P865_SCRIPT_ID) ) ',
'    ) loop',
'     ',
'         wwv_flow_collection.update_member_attribute(',
'             p_collection_name => ''INSTALL_OBJECTS'',',
'             p_seq             => c1.seq_id,',
'             p_attr_number     => ''6'',',
'             p_attr_value      => wwv_flow_lang.system_message(''SUPPORTING_OBJECTS.OBJECT_DEF_CHANGED''));',
'             ',
'    end loop;             ',
'    ',
'    --populate object no longer exists',
'    for c1 in (select seq_id',
'                 from wwv_flow_collections a',
'                where collection_name = ''INSTALL_OBJECTS''',
'                  and not exists (select 1 ',
'                                    from sys.dba_objects',
'                                   where owner = a.c002',
'                                     and object_type = a.c003',
'                                     and object_name = a.c004) ',
'    ) loop',
'    ',
'         wwv_flow_collection.update_member_attribute(',
'             p_collection_name => ''INSTALL_OBJECTS'',',
'             p_seq             => c1.seq_id,',
'             p_attr_number     => ''6'',',
'             p_attr_value      => wwv_flow_lang.system_message(''SUPPORTING_OBJECTS.OBJECT_DELETED''));',
'             ',
'    end loop;',
'',
'    :P865_OBJ_COLLECTION_CREATED := ''Y'';',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_install_objects',
' where script_id = :P865_SCRIPT_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and flow_id = :FB_FLOW_ID',
'   and :P865_MODE = ''EDIT''',
'   and :P865_OBJ_COLLECTION_CREATED is null'))
,p_process_when_type=>'EXISTS'
,p_internal_uid=>537839813572118520
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(537839908148118521)
,p_process_sequence=>150
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate INSTALL_OBJECTS new'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_objects     wwv_flow_global.vc_arr2;',
'  l_object_type varchar2(30);',
'  i             number;',
'begin',
'',
'  l_objects := wwv_flow_utilities.string_to_table(:P858_OBJECT);',
'  ',
'  wwv_flow_collection.create_or_truncate_collection(''INSTALL_OBJECTS'');',
'  ',
'  for i in 1.. l_objects.count loop',
'      l_object_type := null;',
'      for c1 in (select object_type',
'                   from sys.dba_objects',
'                  where owner = :P865_OBJECT_OWNER',
'                    and object_name = l_objects(i)) loop',
'          l_object_type := replace(c1.object_type,'' BODY'',null);',
'          exit;',
'      end loop;',
'      wwv_flow_collection.add_member(',
'          p_collection_name => ''INSTALL_OBJECTS'',',
'          p_c001            => ''1'',',
'          p_c002            => :P865_OBJECT_OWNER,',
'          p_c003            => l_object_type,',
'          p_c004            => l_objects(i));',
'  end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'nvl(:P850_SCRIPT_SOURCE,''x'') = ''DB'' and nvl(:P865_MODE,''x'') <> ''EDIT'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>537839908148118521
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(537841025191118532)
,p_process_sequence=>3
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'do deletes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_code         clob;',
'    l_object_types varchar2(32767);',
'    l_objects      varchar2(32767);',
'begin',
'',
'    for i in 1..wwv_flow.g_f01.count loop',
'        wwv_flow_collection.update_member_attribute (',
'            p_collection_name => ''INSTALL_OBJECTS'',',
'            p_seq             => wwv_flow.g_f01(i),',
'            p_attr_number     => 5,',
'            p_attr_value      => ''1'' );',
'    end loop;',
'    ',
'    wwv_flow_collection.create_or_truncate_collection(',
'        p_collection_name => ''INSTALL_SCRIPT_ORIG'');',
'',
'    for c1 in (select distinct c003 object_type',
'                 from wwv_flow_collections',
'                where collection_name = ''INSTALL_OBJECTS''',
'                  and nvl(c005,''0'')= ''0'' ) loop',
'        l_object_types := l_object_types||c1.object_type||'':'';',
'    end loop;',
'    for c1 in (select c004 object_name',
'                 from wwv_flow_collections',
'                where collection_name = ''INSTALL_OBJECTS''',
'                  and nvl(c005,''0'')=''0'' ) loop',
'        l_objects := l_objects||c1.object_name||'':'';',
'    end loop;',
'    ',
'    if nvl(:P865_SCRIPT_OPTION,''x'') in (''PACKAGE_SPEC'',''PACKAGE_BODY'') then',
'        -- only set l_object_types if an object is still not deleted',
'        if length(l_objects) > 0 then',
'            l_object_types := :P865_SCRIPT_OPTION;',
'        end if;',
'    else',
'        l_object_types := rtrim(l_object_types,'':'');',
'    end if;',
'',
'    l_code := wwv_flow_generate_ddl.get_ddl_supporting_objects(',
'                      p_schema      => :P865_OBJECT_OWNER,',
'                      p_object_type => l_object_types,',
'                      p_objects     => rtrim(l_objects,'':''));',
'',
'    wwv_flow_collection.add_member(',
'        p_collection_name => ''INSTALL_SCRIPT_ORIG'',',
'        p_clob001         => l_code);',
'        ',
'        ',
'end;        '))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(615012010767884573)
,p_process_success_message=>'Objects removed from script.'
,p_internal_uid=>537841025191118532
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(537840506461118527)
,p_process_sequence=>5
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'process objects'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    --process the deletes',
'    for c1 in (select c001 id',
'                 from wwv_flow_collections',
'                where collection_name = ''INSTALL_OBJECTS''',
'                  and nvl(c005,''0'')=''1'' ) loop',
'        delete from wwv_flow_install_objects',
'         where security_group_id = :WORKSPACE_ID',
'           and flow_id = :FB_FLOW_ID',
'           and id = c1.id;',
'    end loop;',
'    ',
'    --process the inserts',
'    for c1 in (select c002 object_owner, c003 object_type, c004 object_name',
'                 from wwv_flow_collections',
'                where collection_name = ''INSTALL_OBJECTS''',
'                  and c001 = ''1'' ) loop',
'        insert into wwv_flow_install_objects (script_id, object_owner, object_type, object_name)',
'        values (:P865_SCRIPT_ID, c1.object_owner, c1.object_type, c1.object_name);',
'    end loop;',
'end;',
'        ',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'substr(:REQUEST,1,13) in (''APPLY_CHANGES'') and wwv_flow_collection.collection_exists(''INSTALL_OBJECTS'') and :P865_SCRIPT_ID is not null'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>537840506461118527
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(551323800628211346)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'repopulate INSTALL_SCRIPT_ORIG'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_code         clob;',
'    l_object_types varchar2(32767);',
'    l_objects      varchar2(32767);   ',
'begin',
'',
'    wwv_flow_collection.create_or_truncate_collection(',
'        p_collection_name => ''INSTALL_SCRIPT_ORIG'');',
'    ',
'    --process deletes for obj that don''t exist',
'    for c1 in (select seq_id',
'                 from wwv_flow_collections',
'                where collection_name = ''INSTALL_OBJECTS''',
'                  and nvl(c006,''x'') = wwv_flow_lang.system_message(''SUPPORTING_OBJECTS.OBJECT_DELETED'') ) loop',
'    ',
'        wwv_flow_collection.update_member_attribute(',
'            p_collection_name => ''INSTALL_OBJECTS'',',
'            p_seq             => c1.seq_id,',
'            p_attr_number     => ''5'',',
'            p_attr_value      => ''1'');',
'            ',
'    end loop;',
'    ',
'    for c1 in (select distinct c003 object_type',
'                 from wwv_flow_collections',
'                where collection_name = ''INSTALL_OBJECTS''',
'                  and nvl(c005,''0'')= ''0'' ) loop',
'        l_object_types := l_object_types||c1.object_type||'':'';',
'    end loop;',
'    for c1 in (select c004 object_name',
'                 from wwv_flow_collections',
'                where collection_name = ''INSTALL_OBJECTS''',
'                  and nvl(c005,''0'')=''0'' ) loop',
'        l_objects := l_objects||c1.object_name||'':'';',
'    end loop;',
'    ',
'    if nvl(:P865_SCRIPT_OPTION,''x'') in (''PACKAGE_SPEC'',''PACKAGE_BODY'') then',
'        l_object_types := :P865_SCRIPT_OPTION;',
'    else',
'        l_object_types := rtrim(l_object_types,'':'');',
'    end if;    ',
'    ',
'    l_code := wwv_flow_generate_ddl.get_ddl_supporting_objects(',
'                      p_schema      => :P865_OBJECT_OWNER,',
'                      p_object_type => l_object_types,',
'                      p_objects     => rtrim(l_objects,'':''));',
'                      ',
'    wwv_flow_collection.add_member(',
'        p_collection_name => ''INSTALL_SCRIPT_ORIG'',',
'        p_clob001         => l_code);',
'        ',
'    --clear the object changed messages',
'    for c1 in (select seq_id',
'                 from wwv_flow_collections',
'                where collection_name = ''INSTALL_OBJECTS''',
'                  and nvl(c006,''x'') = wwv_flow_lang.system_message(''SUPPORTING_OBJECTS.OBJECT_DEF_CHANGED'')) loop',
'        ',
'        wwv_flow_collection.update_member_attribute(',
'            p_collection_name => ''INSTALL_OBJECTS'',',
'            p_seq             => c1.seq_id,',
'            p_attr_number     => ''6'',',
'            p_attr_value      => null);',
'            ',
'    end loop;         ',
'            ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(537838745432118509)
,p_process_success_message=>'Script refreshed from object definitions in the database.'
,p_internal_uid=>551323800628211346
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(107297699656699733)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save script'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_clob   clob := empty_clob;',
'  l_object_owner varchar2(128) := null;',
'  l_object_type  varchar2(30) := null;',
'  l_script_id    number;',
'  i              number;',
'  l_objects      wwv_flow_global.vc_arr2;',
'begin',
'',
'  for c1 in (select clob001 script',
'             from htmldb_collections',
'             where collection_name = ''INSTALL_SCRIPT'') loop',
'    l_clob := c1.script;',
'  end loop;',
'',
'  if l_clob is not null then',
'    -- Three cases: User creating new install script, user ',
'    -- editing install script, or user editing deinstall script',
'',
'    if :P865_MODE = ''EDIT'' then',
'',
'      update wwv_flow_install_scripts ',
'         set script = l_clob',
'       where id = :P865_SCRIPT_ID',
'         and flow_id = :fb_flow_id',
'         and security_group_id = :flow_security_group_id;',
'',
'    elsif :P865_MODE = ''NEW'' then',
'',
'      if :P850_MODE = ''UPGRADE'' then ',
'        insert into wwv_flow_install_scripts (script, name, sequence, script_type)',
'        values (l_clob, :P865_SCRIPT_NAME, :P865_SCRIPT_SEQUENCE, ''UPGRADE'');',
'      else',
'        l_object_owner := :P865_OBJECT_OWNER;',
'        ',
'        insert into wwv_flow_install_scripts (script, name, sequence, script_type, script_option) ',
'        values (l_clob, :P865_SCRIPT_NAME, :P865_SCRIPT_SEQUENCE, ''INSTALL'', :P865_SCRIPT_OPTION) ',
'        returning id into l_script_id;',
'        ',
'        for c1 in (select c002 object_owner, c003 object_type, c004 object_name',
'                     from wwv_flow_collections',
'                    where collection_name = ''INSTALL_OBJECTS'') loop',
'            insert into wwv_flow_install_objects (script_id, object_owner, object_type, object_name)',
'            values (l_script_id, c1.object_owner, c1.object_type, c1.object_name);',
'        end loop;',
'      end if;',
'',
'    end if;',
'  end if;',
'',
'  if :P865_MODE = ''DEINSTALL'' then',
'',
'    update wwv_flow_install',
'       set deinstall_script = l_clob',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :flow_security_group_id;',
'',
'  end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to save script.'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_modified_clob  clob := empty_clob;',
'    l_initial_clob   clob := empty_clob;',
'begin',
'    if substr(:REQUEST,1,13) != ''APPLY_CHANGES'' then',
'        return false;',
'    end if;',
'    -- if this is being run against the APPLY_CHANGES button press ',
'    -- then return true',
'    if :REQUEST = ''APPLY_CHANGES'' then',
'        return true;',
'    end if;',
'    -- for switching between the Script Properties and Editor Tabs ',
'    -- check for any actual edits before returning true or false    ',
'    for c1 in (select clob001 script',
'                 from htmldb_collections',
'                where collection_name = ''INSTALL_SCRIPT'') loop',
'        l_modified_clob := c1.script;',
'    end loop;',
'    -- check if script was edited at all',
'    if :P865_MODE = ''EDIT'' then',
'',
'        select script into l_initial_clob ',
'          from  wwv_flow_install_scripts ',
'         where id = :P865_SCRIPT_ID',
'           and flow_id = :fb_flow_id',
'           and security_group_id = :flow_security_group_id;',
'',
'        if l_modified_clob = l_initial_clob then ',
'            return false;',
'        end if;',
'    end if;     ',
'    return true;',
'end;'))
,p_process_when_type=>'FUNCTION_BODY'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Script saved.'
,p_internal_uid=>107297699656699733
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4808801106699695)
,p_process_sequence=>120
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'show name and sequence'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P865_MODE = ''EDIT'' then',
'  for c1 in (select name, sequence, script_option',
'               from wwv_flow_install_scripts',
'              where id = :P865_SCRIPT_ID',
'                and flow_id = :FB_FLOW_ID',
'                and security_group_id = :flow_security_group_id)',
'  loop',
'    :P865_SCRIPT_NAME := c1.name;',
'    :P865_SCRIPT_OPTION := c1.script_option;',
'  end loop;',
'  for c1 in (select distinct replace(object_owner,''#''||''OWNER''||''#'',wwv_flow_wizard_api.get_flow_owner) object_owner, object_type',
'               from wwv_flow_install_objects',
'              where security_group_id = :WORKSPACE_ID',
'                and flow_id = :FB_FLOW_ID',
'                and script_id = :P865_SCRIPT_ID',
'              order by 2) loop',
'       if :P865_OBJECT_OWNER is null then',
'           :P865_OBJECT_OWNER := c1.object_owner;',
'       end if;',
'       :P865_OBJECT_TYPE := :P865_OBJECT_TYPE||c1.object_type||'', '';',
'  end loop;',
'  for c1 in (select object_name',
'               from wwv_flow_install_objects',
'              where security_group_id = :WORKSPACE_ID',
'                and flow_id = :FB_FLOW_ID',
'                and script_id = :P865_SCRIPT_ID',
'              order by 1) loop',
'      :P865_OBJECT_NAME := :P865_OBJECT_NAME||c1.object_name||'', '';',
'  end loop;',
'  :P865_OBJECT_TYPE := rtrim(:P865_OBJECT_TYPE,'', '');',
'  :P865_OBJECT_NAME := rtrim(:P865_OBJECT_NAME,'', '');',
'elsif :P865_MODE = ''DEINSTALL'' then',
'  :P865_SCRIPT_NAME := wwv_flow_lang.system_message(''INSTALLER.DEINSTALL'');',
'elsif :P865_MODE = ''NEW'' then',
'    :P865_SCRIPT_NAME := :P855_SCRIPT_NAME;',
'    :P865_OBJECT_OWNER := :P855_OBJECT_OWNER;',
'    :P865_OBJECT_TYPE := replace(:P855_OBJECT_TYPE,'':'','', '');',
'    :P865_OBJECT_NAME := replace(:P858_OBJECT,'':'','', '');  ',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>4808801106699695
);
end;
/
prompt --application/pages/page_00866
begin
wwv_flow_imp_page.create_page(
 p_id=>866
,p_name=>'Conditional Processes'
,p_alias=>'CONDITIONAL-PROCESSES'
,p_step_title=>'Conditional Processes'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213220627333807318)
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(194238612868788833)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>91
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(11322022496485821)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(194245028663804201)
,p_plug_name=>'Process Conditions'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>125
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select flow_step_id, PROCESS_NAME, ',
'PROCESS_WHEN_TYPE,',
'PROCESS_WHEN,',
'PROCESS_WHEN2,',
'id',
'from WWV_FLOW_STEP_PROCESSING',
'where FLOW_ID = :fb_flow_id and',
'process_when_type is not null'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(194245102805804201)
,p_name=>'Process Conditions'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194245306516804204)
,p_db_column_name=>'FLOW_STEP_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Page'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#FLOW_STEP_ID#'
,p_column_linktext=>'#FLOW_STEP_ID#'
,p_column_link_attr=>'title="View page definition"'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194245419236804205)
,p_db_column_name=>'PROCESS_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Process Name'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#FLOW_STEP_ID##5530:#ID#'
,p_column_linktext=>'#PROCESS_NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194245501983804205)
,p_db_column_name=>'PROCESS_WHEN_TYPE'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Condition Type'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_imp.id(13602414170805697)
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194245626379804206)
,p_db_column_name=>'PROCESS_WHEN'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Expression 1'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194245726209804207)
,p_db_column_name=>'PROCESS_WHEN2'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Expression 2'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(100576517207284423)
,p_db_column_name=>'ID'
,p_display_order=>15
,p_column_identifier=>'F'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(194247221133809599)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1292100886536644'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'FLOW_STEP_ID:PROCESS_NAME:PROCESS_WHEN_TYPE:PROCESS_WHEN:PROCESS_WHEN2:'
,p_sort_column_1=>'FLOW_STEP_ID'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'PROCESS_NAME'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(194238222518788832)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(194245028663804201)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:866:&SESSION.::&DEBUG.:866,RIR::'
);
end;
/
prompt --application/pages/page_00869
begin
wwv_flow_imp_page.create_page(
 p_id=>869
,p_name=>'Conditional Items'
,p_alias=>'CONDITIONAL-ITEMS'
,p_step_title=>'Conditional Items'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213220627333807318)
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(194518016467362474)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>91
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(186703109122914661)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(194529205806463891)
,p_plug_name=>'Item Conditions'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>125
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select flow_step_id page, NAME, ',
'DISPLAY_WHEN, ',
'DISPLAY_WHEN2, ',
'DISPLAY_WHEN_TYPE,',
'id',
'from WWV_FLOW_STEP_ITEMS',
'where FLOW_ID = :fb_flow_id and ',
'display_when_type is not null and ',
'display_when_type != ''%''||''null%'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(194529317355463891)
,p_name=>'Item Conditions'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194529529071463893)
,p_db_column_name=>'PAGE'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Page'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE#'
,p_column_linktext=>'#PAGE#'
,p_column_link_attr=>'title="View page definition"'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194529616580463894)
,p_db_column_name=>'NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Item'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE##5120:#ID#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194529712450463895)
,p_db_column_name=>'DISPLAY_WHEN'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>'Expression 1'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194529827201463896)
,p_db_column_name=>'DISPLAY_WHEN2'
,p_display_order=>5
,p_column_identifier=>'D'
,p_column_label=>'Expression 2'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(100575602366284414)
,p_db_column_name=>'DISPLAY_WHEN_TYPE'
,p_display_order=>15
,p_column_identifier=>'G'
,p_column_label=>'Display When Type'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(100575761452284415)
,p_db_column_name=>'ID'
,p_display_order=>25
,p_column_identifier=>'H'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(194530320288465672)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1292408162536644'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'PAGE:NAME:DISPLAY_WHEN:DISPLAY_WHEN2:DISPLAY_WHEN_TYPE'
,p_sort_column_1=>'PAGE'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'NAME'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(194517805082362472)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(194529205806463891)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:869:&SESSION.::&DEBUG.:869,RIR::'
);
end;
/
prompt --application/pages/page_00870
begin
wwv_flow_imp_page.create_page(
 p_id=>870
,p_name=>'Create Web Service Reference - Web Reference Type'
,p_alias=>'CREATE-WEB-SERVICE-REFERENCE-WEB-REFERENCE-TYPE'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Web Service Reference'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(33395014910549652)
,p_plug_name=>'Create Web Service Reference'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Web service references in &PRODUCT_NAME. can be created for RESTful style web services, SOAP web services based on a Web Services Description Language (WSDL) document, or manually. RESTful style web services and manual style web services require d'
||'etailed knowledge of the web service usually found in the documentation for the service. Web service references based on a WSDL only require knowledge of where the WSDL document is located.</p>',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'Region generated 19-APR-2004 13:34:33'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46713613329274661)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(33396322321549677)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46713613329274661)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(33396504974549678)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(46713613329274661)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(33397322889549691)
,p_branch_name=>'Manual'
,p_branch_action=>'f?p=&APP_ID.:199:&SESSION.::&DEBUG.:199::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(33396504974549678)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P870_WEB_REFERENCE_TYPE'
,p_branch_condition_text=>'MANUAL'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(33397529300549693)
,p_branch_name=>'WSDL'
,p_branch_action=>'f?p=&APP_ID.:580:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P870_WEB_REFERENCE_TYPE'
,p_branch_condition_text=>'WSDL'
,p_branch_comment=>'Generated 19-APR-2004 13:34:33'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(33401318496653812)
,p_branch_name=>'REST'
,p_branch_action=>'f?p=&APP_ID.:871:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P870_WEB_REFERENCE_TYPE'
,p_branch_condition_text=>'REST'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33396725785549679)
,p_name=>'P870_WEB_REFERENCE_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(33395014910549652)
,p_item_default=>'REST'
,p_prompt=>'What type of Web reference would you like to create?'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WEB_REFERENCE_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(33398606197612456)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Select the type of Web reference you want to create.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
,p_item_comment=>'Generated 19-APR-2004 13:34:33'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(614669987242188709)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(33396322321549677)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(614670079021188710)
,p_event_id=>wwv_flow_imp.id(614669987242188709)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00871
begin
wwv_flow_imp_page.create_page(
 p_id=>871
,p_name=>'Create REST Web Reference - REST Details'
,p_alias=>'CREATE-REST-WEB-REFERENCE-REST-DETAILS'
,p_page_mode=>'MODAL'
,p_step_title=>'Create REST Web Reference'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function p871_add_header(){',
'    var get = new htmldb_Get(null,$v(''pFlowId''),''APPLICATION_PROCESS=P872_ADD_PARAMETER'',0);',
'',
'    get.addParam(''x01'',''REST_HTTP_HEADERS'');',
'    apex.jQuery("input[name=f01]").each( function() {',
'        get.addParam(''f01'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f02]").each( function() {',
'        get.addParam(''f02'',apex.jQuery(this).val());',
'        });',
'',
'    gReturn = get.get();',
'    get = null;',
'',
'    apex.jQuery("#rest_http_headers").trigger("apexrefresh");',
'}',
'',
'function p871_remove_header(seqid){',
'    var get = new htmldb_Get(null,$v(''pFlowId''),''APPLICATION_PROCESS=P872_REMOVE_PARAMETER'',0);',
'',
'    get.addParam(''x01'',''REST_HTTP_HEADERS'');',
'    get.addParam(''x02'',seqid);',
'    apex.jQuery("input[name=f01]").each( function() {',
'        get.addParam(''f01'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f02]").each( function() {',
'        get.addParam(''f02'',apex.jQuery(this).val());',
'        });    ',
'    gReturn = get.get();',
'    get = null;',
'',
'    apex.jQuery("#rest_http_headers").trigger("apexrefresh");',
'}'))
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'advnc_web_services.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(33402719073674448)
,p_plug_name=>'Create REST Web Reference'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_row_template=>wwv_flow_imp.id(79387910442923002)
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>RESTful Web services rely on a simple resource-oriented architecture. The resource is identified by the URL and the',
'   method is described by the HTTP method. Inputs to the service are sometimes contained in the URL itself or in the HTTP',
'   payload. Inputs can also be read from HTTP headers sent with the request.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'Region generated 31-JUL-2002 20:44:47'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(33455017307559580)
,p_plug_name=>'Navigation'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(22410710903630445)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(34124924815112049)
,p_name=>'HTTP Request Headers'
,p_region_name=>'rest_http_headers'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>210
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--simple'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select seq_id,',
'       wwv_flow_item.hidden(1, seq_id) || wwv_flow_item.text(2, c001, 32) as name',
'  from wwv_flow_collections',
' where collection_name = ''REST_HTTP_HEADERS'''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No HTTP Request Headers defined.'
,p_query_row_count_max=>5000
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(34125107306112078)
,p_query_column_id=>1
,p_column_alias=>'SEQ_ID'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_use_as_row_header=>'N'
,p_column_link=>'javascript:p871_remove_header(''#SEQ_ID#'')'
,p_column_linktext=>'<span class="a-Icon icon-remove"></span><span class="u-VisuallyHidden">Remove</span>'
,p_column_link_attr=>'class="a-Button a-Button--small a-Button--noLabel a-Button--withIcon a-Button--noUI"'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_report_column_width=>40
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(34125227429112078)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(202597819671096996)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(33404811501674452)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(202597819671096996)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(34126127924112088)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(34124924815112049)
,p_button_name=>'ADD'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Add Header'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:p871_add_header()'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(33462606459698309)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(202597819671096996)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(33461201348677938)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(202597819671096996)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(33461514816677941)
,p_branch_action=>'f?p=&FLOW_ID.:870:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(33461201348677938)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(33462903589698459)
,p_branch_action=>'f?p=&FLOW_ID.:872:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(33462606459698309)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(33412022816674467)
,p_branch_action=>'170'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>40
,p_branch_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33405403626674452)
,p_name=>'P871_BASIC_AUTH'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_imp.id(33402719073674448)
,p_item_default=>'N'
,p_prompt=>'Basic Authentication:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(84259319526460470)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose whether this Web service requires basic authentication. Basic authentication credentials are sent as part of the HTTP request in clear text. Web services that employ basic authentication usually also use the HTTPS (SSL) protocol since the user'
||'name and password are sent in clear text.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33406603113674456)
,p_name=>'P871_FLOW_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(33402719073674448)
,p_prompt=>'Application:'
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LIST FLOWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'where  build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'order by 2'))
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'This attribute identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33407103289674459)
,p_name=>'P871_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(33402719073674448)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>The name for this Web service within the context of the Builder. This name is only used within the App Builder tool.</p>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33407619399674459)
,p_name=>'P871_URL'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(33402719073674448)
,p_prompt=>'URL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify the URL endpoint for the REST Web service. You may reference session state in the URL by using',
'   <code>&amp;ITEM_NAME.</code> convention.</p>',
'<p>For example:</p>',
'<code>http://s3.example.com/&amp;P2_BUCKET.</code>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_item_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33408115204674460)
,p_name=>'P871_METHOD'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(33402719073674448)
,p_item_default=>'GET'
,p_prompt=>'HTTP Method:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'REST_HTTP_METHOD'
,p_lov=>'.'||wwv_flow_imp.id(33996111639139709)||'.'
,p_cSize=>70
,p_cMaxlength=>255
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Choose the HTTP Method appropriate for the REST Web service. The HTTP method describes the method of the Web service.</p>',
'',
'',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'5'
,p_attribute_02=>'NONE'
,p_item_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33408620297674460)
,p_name=>'P871_PROXY_OVERRIDE'
,p_item_sequence=>65
,p_item_plug_id=>wwv_flow_imp.id(33402719073674448)
,p_prompt=>'Proxy'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This overrides the system defined HTTP proxy for your request. The proxy may include an optional TCP/IP port number at which the proxy server listens.  Use the following syntax:</p>',
'<pre>[http://]host[:port][/]</pre>',
'<p>For example:</p>',
'<pre>www-proxy.example.com</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'Generated 31-JUL-2002 20:44:48'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(33410429025674463)
,p_validation_name=>'P871_NAME Not Null'
,p_validation_sequence=>1
,p_validation=>'P871_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Name must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(33462606459698309)
,p_associated_item=>wwv_flow_imp.id(33407103289674459)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 31-JUL-2002 21:28'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(33410602557674464)
,p_validation_name=>'URL Not Null'
,p_validation_sequence=>10
,p_validation=>'P871_URL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'The URL of the Web Service must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(33462606459698309)
,p_associated_item=>wwv_flow_imp.id(33407619399674459)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(614669701177188707)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(33404811501674452)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(614669812302188708)
,p_event_id=>wwv_flow_imp.id(614669701177188707)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(34124530225104138)
,p_process_sequence=>50
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create headers collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.create_or_truncate_collection(''REST_HTTP_HEADERS'');',
'wwv_flow_collection.add_member(''REST_HTTP_HEADERS'');'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'not wwv_flow_collection.collection_exists(''REST_HTTP_HEADERS'') or wwv_flow_collection.collection_member_count(''REST_HTTP_HEADERS'') = 0;'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>34124530225104138
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(34124713387108788)
,p_process_sequence=>20
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.update_members(',
'  p_collection_name => ''REST_HTTP_HEADERS'',',
'  p_seq => wwv_flow.g_f01,',
'  p_c001 => wwv_flow.g_f02 );'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>34124713387108788
);
end;
/
prompt --application/pages/page_00872
begin
wwv_flow_imp_page.create_page(
 p_id=>872
,p_name=>'Create REST Web Reference - REST Inputs'
,p_alias=>'CREATE-REST-WEB-REFERENCE-REST-INPUTS'
,p_page_mode=>'MODAL'
,p_step_title=>'Create REST Web Reference'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_html_page_onload=>'onload="toggleInType();"'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function p872_add_parm(){',
'    var repid = apex.jQuery("#rest_input_parms").find("div[id^=report_]").attr("id").replace("report_","").replace("_catch","");',
'',
'    var get = new htmldb_Get(null,$v(''pFlowId''),''APPLICATION_PROCESS=P872_ADD_PARAMETER'',0);',
'',
'    get.addParam(''x01'',''REST_INPUT_PARMS'');',
'    apex.jQuery("input[name=f01]").each( function() {',
'        get.addParam(''f01'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f02]").each( function() {',
'        get.addParam(''f02'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("select[name=f03] option:selected").each(function (){',
'        get.addParam(''f03'',apex.jQuery(this).val());',
'        });',
'    gReturn = get.get();',
'    get = null;',
'',
'    apex.jQuery("#rest_input_parms").trigger("apexrefresh");',
'}',
'',
'function p872_remove_parm(seqid){',
'    var repid = apex.jQuery("#rest_input_parms").find("div[id^=report_]").attr("id").replace("report_","").replace("_catch","");',
'',
'    var get = new htmldb_Get(null,$v(''pFlowId''),''APPLICATION_PROCESS=P872_REMOVE_PARAMETER'',0);',
'',
'    get.addParam(''x01'',''REST_INPUT_PARMS'');',
'    get.addParam(''x02'',seqid);',
'    apex.jQuery("input[name=f01]").each( function() {',
'        get.addParam(''f01'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f02]").each( function() {',
'        get.addParam(''f02'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("select[name=f03] option:selected").each(function (){',
'        get.addParam(''f03'',apex.jQuery(this).val());',
'        });',
'    gReturn = get.get();',
'    get = null;',
'',
'    apex.jQuery("#rest_input_parms").trigger("apexrefresh");',
'}',
'',
'function toggleInType(){',
'    if ($v(''P872_INPUT_TYPE'') == ''body'' || $v(''P872_INPUT_TYPE'') == ''function''){',
'        apex.item(''P872_SOURCE'').show();',
'        $x_Hide(''rest_input_parms'');',
'        if ($v(''P872_INPUT_TYPE'') == ''function''){',
'          apex.item(''P872_CHECK_PLSQL1'').show();',
'        }',
'    } else if ($v(''P872_INPUT_TYPE'') == ''file''){',
'        $x_Hide(''rest_input_parms'');',
'        apex.item(''P872_SOURCE'').hide();',
'        apex.item(''P872_CHECK_PLSQL1'').hide();',
'    } else {',
'        apex.item(''P872_SOURCE'').hide();',
'        apex.item(''P872_CHECK_PLSQL1'').hide();',
'        $x_Show(''rest_input_parms'');',
'    }',
'}'))
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'advnc_web_services.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(33462315678691487)
,p_plug_name=>'Navigation'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>11
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(22410710903630445)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(33497325383470083)
,p_name=>'Input Parameters'
,p_region_name=>'rest_input_parms'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--simple'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select seq_id,',
'       wwv_flow_item.hidden(1,seq_id) || wwv_flow_item.text(2,c001,32) as name,',
'       wwv_flow_item.select_list_from_lov(3,nvl(c002,''string''),''REST_INPUT_PARAMETER_TYPES'', null, ''NO'', null, null) as type',
'  from wwv_flow_collections',
' where collection_name = ''REST_INPUT_PARMS'''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No REST Input Parameters defined.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(33497610076470104)
,p_query_column_id=>1
,p_column_alias=>'SEQ_ID'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_use_as_row_header=>'N'
,p_column_link=>'javascript:p872_remove_parm(''#SEQ_ID#'')'
,p_column_linktext=>'<span class="a-Icon icon-remove"></span><span class="u-VisuallyHidden">Remove</span>'
,p_column_link_attr=>'class="a-Button a-Button--small a-Button--noLabel a-Button--withIcon a-Button--noUI"'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_report_column_width=>40
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(33497717625470108)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(33497828033470108)
,p_query_column_id=>3
,p_column_alias=>'TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Type'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(202616810901236408)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>151
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1143245183239567404)
,p_plug_name=>'Information'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Choose the type of input parameters if the method chosen on the previous page is POST or PUT. Otherwise, the input',
'   type is assumed to be Name Value Pairs.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(33474505513104880)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(202616810901236408)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(33551019615219399)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(33497325383470083)
,p_button_name=>'ADD'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Add Parameter'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:p872_add_parm();'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(33475128846121112)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(202616810901236408)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(33474712439106854)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(202616810901236408)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(33475007138106857)
,p_branch_action=>'f?p=&FLOW_ID.:871:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(33474712439106854)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(33475409282121112)
,p_branch_action=>'f?p=&APP_ID.:873:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(33475128846121112)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48714130312488044)
,p_name=>'P872_INPUT_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1143245183239567404)
,p_item_default=>'nvp'
,p_prompt=>'Input Type:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P872_INPUT_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(48714213128492554)||'.'
,p_cHeight=>1
,p_tag_attributes=>'onchange="toggleInType();"'
,p_display_when=>'P871_METHOD'
,p_display_when2=>'POST:PUT'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specifies the type of input parameters that should be sent with the HTTP request. Options include:',
'<br /><br />',
'<ul>',
'    <li><strong>Name Value Pairs</strong> - Multiple name/value pairs of specified data type.</li>',
'    <li><strong>Specified Body with Substitutions</strong> - A text payload that can contain <code>#ITEM_NAME#</code>',
'        substitutions to send items in session state with the request.</li>',
'    <li><strong>File Upload Item</strong></li>',
'    <li><strong>Function Returning CLOB</strong> - A PL/SQL function body returning CLOB.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48753415719155541)
,p_name=>'P872_SOURCE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1143245183239567404)
,p_prompt=>'Source'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>5
,p_display_when=>'P871_METHOD'
,p_display_when2=>'POST:PUT'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Enter the source to use as the input of the Web service.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(173205910526156182)
,p_name=>'P872_CHECK_PLSQL1'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1143245183239567404)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Do not validate code (parse code at runtime only).'
,p_source=>'NULL'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_display_when=>'P871_METHOD'
,p_display_when2=>'POST:PUT'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'NO'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(173207103778192031)
,p_validation_name=>'check PL/SQL syntax'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_f4000_util.check_plsql(',
'    :P872_SOURCE,',
'    :FB_FLOW_ID,',
'    :FLOW_SECURITY_GROUP_ID',
');'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':P872_INPUT_TYPE = ''function'' AND (NVL(:P872_CHECK_PLSQL1,''YES'') <> ''NO'' )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(33475128846121112)
,p_associated_item=>wwv_flow_imp.id(48753415719155541)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(614670489787188714)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(33474505513104880)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(614670534064188715)
,p_event_id=>wwv_flow_imp.id(614670489787188714)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(33558206537946946)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.update_members(',
'  p_collection_name => ''REST_INPUT_PARMS'',',
'  p_seq => wwv_flow.g_f01,',
'  p_c001 => wwv_flow.g_f02,',
'  p_c002 => wwv_flow.g_f03 );',
''))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>33558206537946946
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(33496710922447058)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create inputs collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.create_or_truncate_collection(''REST_INPUT_PARMS'');',
'wwv_flow_collection.add_member(''REST_INPUT_PARMS'');'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'not wwv_flow_collection.collection_exists(''REST_INPUT_PARMS'') or wwv_flow_collection.collection_member_count(''REST_INPUT_PARMS'') = 0;'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>33496710922447058
);
end;
/
prompt --application/pages/page_00873
begin
wwv_flow_imp_page.create_page(
 p_id=>873
,p_name=>'Create REST Web Reference - REST Outputs'
,p_alias=>'CREATE-REST-WEB-REFERENCE-REST-OUTPUTS'
,p_page_mode=>'MODAL'
,p_step_title=>'Create REST Web Reference'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function p873_add_parm(){',
'    var get = new htmldb_Get(null,$v(''pFlowId''),''APPLICATION_PROCESS=P872_ADD_PARAMETER'',0);',
'',
'    get.addParam(''x01'',''REST_OUTPUT_PARMS'');',
'    apex.jQuery("input[name=f01]").each( function() {',
'        get.addParam(''f01'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f02]").each( function() {',
'        get.addParam(''f02'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("select[name=f03] option:selected").each(function (){',
'        get.addParam(''f03'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f06]").each( function() {',
'        get.addParam(''f06'',apex.jQuery(this).val());',
'        });',
'    gReturn = get.get();',
'    get = null;',
'',
'    apex.jQuery("#rest_output_parms").trigger("apexrefresh");',
'}',
'',
'function p873_remove_parm(seqid){',
'    var get = new htmldb_Get(null,$v(''pFlowId''),''APPLICATION_PROCESS=P872_REMOVE_PARAMETER'',0);',
'',
'    get.addParam(''x01'',''REST_OUTPUT_PARMS'');',
'    get.addParam(''x02'',seqid);',
'    apex.jQuery("input[name=f01]").each( function() {',
'        get.addParam(''f01'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f02]").each( function() {',
'        get.addParam(''f02'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("select[name=f03] option:selected").each(function (){',
'        get.addParam(''f03'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f06]").each( function() {',
'        get.addParam(''f06'',apex.jQuery(this).val());',
'        });',
'    gReturn = get.get();',
'    get = null;',
'',
'    apex.jQuery("#rest_output_parms").trigger("apexrefresh");',
'}',
'',
'function p873_popPath(seqid){',
'    if((apex.jQuery("input:radio[id^=P873_OUTPUT_FORMAT]:checked").val() == ''xml'') && (apex.jQuery("#path"+seqid).val() == '''')){',
'        apex.jQuery("#path"+seqid).val("/"+apex.jQuery("#name"+seqid).val());',
'    }',
'    else if (apex.jQuery("#path"+seqid).val() == ''''){',
'        apex.jQuery("#path"+seqid).val(seqid);',
'    }',
'}'))
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'advnc_web_services.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(33476926808168262)
,p_plug_name=>'Navigation'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>11
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(22410710903630445)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(33559732443824799)
,p_name=>'Output Parameters'
,p_region_name=>'rest_output_parms'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--simple'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select seq_id,',
'       wwv_flow_item.hidden(1,seq_id) ||',
'       wwv_flow_item.text(2,c001,25,255,null,''name''||seq_id, wwv_flow_lang.system_message(''NAME'')) as name,',
'       wwv_flow_item.text(6,c005,40,4000,''onfocus=p873_popPath(''||seq_id||'');'',''path''||seq_id,',
'                          wwv_flow_lang.system_message(''PATH'')) as path,',
'       wwv_flow_item.select_list_from_lov(3,nvl(c002,''string''),''REST_INPUT_PARAMETER_TYPES'', null, ''NO'', null, null,',
'                                          ''typ''||seq_id, wwv_flow_lang.system_message(''TYPE'')) as type',
'  from wwv_flow_collections',
' where collection_name = ''REST_OUTPUT_PARMS'''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No REST Output Parameters defined.'
,p_query_row_count_max=>5000
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(33559907016824838)
,p_query_column_id=>1
,p_column_alias=>'SEQ_ID'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_use_as_row_header=>'N'
,p_column_link=>'javascript:p873_remove_parm(''#SEQ_ID#'')'
,p_column_linktext=>'<span class="a-Icon icon-remove"></span><span class="u-VisuallyHidden">Remove</span>'
,p_column_link_attr=>'class="a-Button a-Button--small a-Button--noLabel a-Button--withIcon a-Button--noUI"'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_report_column_width=>40
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(33560013630824842)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(46859823955216633)
,p_query_column_id=>3
,p_column_alias=>'PATH'
,p_column_display_sequence=>3
,p_column_heading=>'Path'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(33560128616824842)
,p_query_column_id=>4
,p_column_alias=>'TYPE'
,p_column_display_sequence=>4
,p_column_heading=>'Type'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(202630420476305427)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>151
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1143245206000567405)
,p_plug_name=>'Create REST Web Reference'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>RESTful Web services typically respond with an XML or JSON document, or a text response. Some RESTful Web services allow',
'   the caller to specify how they would like to receive the response. Choose the output format from the list, then define',
'   output parameters as necessary. You can review the output from this Web service by clicking the <strong>Test</strong> button.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(33560310313824846)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(202630420476305427)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(345405901176990771)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(202630420476305427)
,p_button_name=>'TEST'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Test'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'javascript:popupURL(''f?p=&APP_ID.:975:&SESSION.::&DEBUG.:::'');'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(33560910527824847)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(33559732443824799)
,p_button_name=>'ADD'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Add Parameter'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:p873_add_parm();'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(33560711690824847)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(202630420476305427)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(33560506789824847)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(202630420476305427)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(33478307486168272)
,p_branch_action=>'f?p=&APP_ID.:872:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(33560506789824847)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33564412292989328)
,p_name=>'P873_OUTPUT_FORMAT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1143245206000567405)
,p_item_default=>'xml'
,p_prompt=>'Output Format:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'REST_OUTPUT_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(33563708997950496)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Choose the response format expected from the Web service. Options include:',
'<br /><br />',
'<ul>',
'    <li><strong>XML</strong> - The response will be stored in the named output parameters. Enter an XPath expression in',
'        the Path column to locate individual nodes.</li>',
'    <li><strong>Text</strong> - The response will be stored in the named output parameters. Enter a number in the Path',
'        column that corresponds to the position of each parameter.</li>',
'    <li><strong>JSON</strong> - The entire response will be stored in the <code>CLOB001</code> column of a collection',
'        you specify. The response can then be parsed with <code>APEX_JSON</code> PL/SQL API.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33564706190996940)
,p_name=>'P873_XPATH'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1143245206000567405)
,p_prompt=>'XPath to Output Parameters'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter an XPath expression to the relevant part of the response. Example:',
'',
'<pre>/ListBucketResult/Contents</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33564900087004734)
,p_name=>'P873_TEXT_DELIM'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1143245206000567405)
,p_item_default=>','
,p_prompt=>'Parameter Delimiter'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>5
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the character or sequence that separates parameters returned from the Web service. Use <strong>\n</strong> to indicate a new line and <strong>\t</strong> to indicate a tab character.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33573706845761396)
,p_name=>'P873_NEW_RECORD_DELIM'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(1143245206000567405)
,p_item_default=>'\n'
,p_prompt=>'New Record Delimiter'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>5
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the character or sequence that determines a new record in a text response from a Web service. Use <strong>\n</strong> to indicate a new line and <strong>\t</strong> to indicate a tab character. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(35066308999301412)
,p_name=>'P873_XMLNS'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_imp.id(1143245206000567405)
,p_prompt=>'Response Namespace'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the namespace corresponding to the Response XPath if necessary. Example:',
'',
'<pre>http://s3.example.com/doc/2006-03-01/</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(173538819801180850)
,p_validation_name=>'P873_XPATH not null'
,p_validation_sequence=>10
,p_validation=>'P873_XPATH'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'You must supply the XPath to the output parameters.'
,p_validation_condition=>'P873_OUTPUT_FORMAT'
,p_validation_condition2=>'xml'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(33560711690824847)
,p_associated_item=>wwv_flow_imp.id(33564706190996940)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(173500004134495140)
,p_name=>'Disable text if xml'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P873_OUTPUT_FORMAT'
,p_condition_element=>'P873_OUTPUT_FORMAT'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'xml'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(173500323922495142)
,p_event_id=>wwv_flow_imp.id(173500004134495140)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P873_NEW_RECORD_DELIM'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(173500500348495144)
,p_event_id=>wwv_flow_imp.id(173500004134495140)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P873_NEW_RECORD_DELIM'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(173501511884506833)
,p_event_id=>wwv_flow_imp.id(173500004134495140)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P873_TEXT_DELIM'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(173501723658510171)
,p_event_id=>wwv_flow_imp.id(173500004134495140)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P873_TEXT_DELIM'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(173504016517517590)
,p_event_id=>wwv_flow_imp.id(173500004134495140)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P873_XPATH'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(173504514224526434)
,p_event_id=>wwv_flow_imp.id(173500004134495140)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P873_XPATH'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(173504224135519839)
,p_event_id=>wwv_flow_imp.id(173500004134495140)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P873_XMLNS'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(173504825998529805)
,p_event_id=>wwv_flow_imp.id(173500004134495140)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P873_XMLNS'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(296133215779241284)
,p_name=>'disable all output items if json'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P873_OUTPUT_FORMAT'
,p_condition_element=>'P873_OUTPUT_FORMAT'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'json'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(296133502321241284)
,p_event_id=>wwv_flow_imp.id(296133215779241284)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P873_XPATH,P873_XMLNS,P873_TEXT_DELIM,P873_NEW_RECORD_DELIM'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1143245446814567407)
,p_event_id=>wwv_flow_imp.id(296133215779241284)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(33559732443824799)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1143245335774567406)
,p_event_id=>wwv_flow_imp.id(296133215779241284)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(33559732443824799)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(614670638501188716)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(33560310313824846)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(614670709990188717)
,p_event_id=>wwv_flow_imp.id(614670638501188716)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(33562221633916277)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.update_members(',
'  p_collection_name => ''REST_OUTPUT_PARMS'',',
'  p_seq => wwv_flow.g_f01,',
'  p_c001 => wwv_flow.g_f02,',
'  p_c002 => wwv_flow.g_f03,',
'  p_c005 => wwv_flow.g_f06 );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>33562221633916277
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(33588401705564025)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create REST web reference'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_xpath             varchar2(4000) := null;',
'    l_text_parm_delim   varchar2(4000) := null;',
'    l_text_record_delim varchar2(4000) := null;',
'    l_xmlns             varchar2(4000) := null;',
'    l_source            clob := empty_clob();',
'    l_id                number;',
'    l_items             clob;',
'begin',
'    l_id := wwv_flow_id.next_val;',
'    if :P873_OUTPUT_FORMAT = ''xml'' then',
'        l_xpath := :P873_XPATH;',
'        l_xmlns := :P873_XMLNS;',
'    else',
'        l_text_parm_delim := :P873_TEXT_DELIM;',
'        l_text_record_delim := :P873_NEW_RECORD_DELIM;',
'    end if;',
'',
'    if :P872_INPUT_TYPE in (''body'',''function'') then',
'      l_source := :P872_SOURCE;',
'    end if;',
'',
'    wwv_flow_web_services.create_rest_web_reference(',
'        p_id                            => l_id,',
'        p_flow_id                       => :FB_FLOW_ID,',
'        p_name                          => :P871_NAME,',
'        p_url                           => :P871_URL,',
'        p_proxy_override                => :P871_PROXY_OVERRIDE,',
'        p_http_method                   => :P871_METHOD,',
'        p_input_format                  => nvl(:P872_INPUT_TYPE,''nvp''),',
'        p_body                          => l_source,',
'        p_output_format                 => :P873_OUTPUT_FORMAT,',
'        p_xpath                         => l_xpath,',
'        p_xmlns                         => l_xmlns,',
'        p_text_parm_delim               => l_text_parm_delim,',
'        p_text_record_delim             => l_text_record_delim,',
'        p_inputs_collection             => ''REST_INPUT_PARMS'',',
'        p_outputs_collection            => ''REST_OUTPUT_PARMS'',',
'        p_headers_collection            => ''REST_HTTP_HEADERS'',',
'        p_basic_auth                    => :P871_BASIC_AUTH );',
'',
'  if :P872_INPUT_TYPE = ''body'' then',
'    l_items := wwv_flow_web_services.parse( l_source );',
'',
'    update wwv_flow_shared_web_services',
'       set flow_items_comma_delimited = l_items',
'     where id = l_id;',
'  end if;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(33560711690824847)
,p_internal_uid=>33588401705564025
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(614670838286188718)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,F4000_LAST_VIEW'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(33560711690824847)
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>614670838286188718
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(33562016785914925)
,p_process_sequence=>50
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create outputs collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.create_or_truncate_collection(''REST_OUTPUT_PARMS'');',
'wwv_flow_collection.add_member(''REST_OUTPUT_PARMS'');'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'not wwv_flow_collection.collection_exists(''REST_OUTPUT_PARMS'') or wwv_flow_collection.collection_member_count(''REST_OUTPUT_PARMS'') = 0;'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>33562016785914925
);
end;
/
prompt --application/pages/page_00875
begin
wwv_flow_imp_page.create_page(
 p_id=>875
,p_name=>'Test REST Web Reference'
,p_alias=>'TEST-REST-WEB-REFERENCE'
,p_step_title=>'Test REST Web Reference'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function p875_test_rest(){',
'',
'    var get = new htmldb_Get(null,$v(''pFlowId''),''APPLICATION_PROCESS=P875_TEST_REST'',0);',
'',
'    get.addParam(''x01'',$v(''P875_URL''));',
'    get.addParam(''x02'',$v(''P875_PROXY_OVERRIDE''));',
'    get.addParam(''x03'',$v(''P875_STATIC_PARM_04''));',
'    get.addParam(''x04'',$v(''P875_USERNAME''));',
'    get.addParam(''x05'',$v(''P875_PASSWORD''));',
'    get.addParam(''x06'',encodeURIComponent($v(''P875_SOURCE'')));',
'',
'    apex.jQuery("input[name=f01]").each( function() {',
'        get.addParam( ''f01'', apex.jQuery(this).val() );',
'        });',
'    apex.jQuery("input[name=f02]").each( function() {',
'        get.addParam( ''f02'', apex.jQuery(this).val() );',
'        });',
'    apex.jQuery("input[name=f03]").each( function() {',
'        get.addParam( ''f03'', apex.jQuery(this).val() );',
'        });',
'    apex.jQuery("input[name=f04]").each( function() {',
'        get.addParam( ''f04'', apex.jQuery(this).val() );',
'        });',
'',
'    gReturn = get.get();',
'    apex.jQuery("#rest_response").show();',
'    apex.jQuery("#rest_response_container").text(gReturn);',
'    get = null;',
'',
'}',
'',
'function clear_response(){',
'    apex.jQuery(''#rest_response_container'').html('' '');',
'}'))
,p_javascript_code_onload=>'apex.jQuery("#rest_response").hide();'
,p_inline_css=>'#rest_response_container:empty {display: none;}'
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(33595522715462216)
,p_plug_name=>'REST Web Service Details'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(33600829145653306)
,p_name=>'Input Parameters'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.display_and_save(1, c.name) name,',
'       wwv_flow_item.text(2, null, 32, null, ''title="''||wwv_flow_lang.system_message(''F4000.P875.INPUT_PARAM_VAL'',c.name)||''"'') value',
'  from wwv_flow_ws_parameters c, wwv_flow_ws_operations b,',
'       wwv_flow_shared_web_services a ',
' where a.id = :P875_ID ',
'   and b.ws_id = a.id ',
'   and c.ws_opers_id = b.id ',
'   and c.input_or_output = ''I'''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'There are no input parameters for this service.'
,p_query_row_count_max=>5000
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(33601118995653318)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(33807410653550307)
,p_query_column_id=>2
,p_column_alias=>'VALUE'
,p_column_display_sequence=>2
,p_column_heading=>'Value'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(33601419018669314)
,p_plug_name=>'Response'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<div class="a-Form-textarea a-Form-textarea--code" id="rest_response_container" style="white-space: pre-line; max-height: 300px; overflow: auto;"></div>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(33951108113208712)
,p_plug_name=>'Basic Authentication'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_ws_operations',
' where ws_id = :P875_ID',
'   and name = ''BASIC_AUTH'''))
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(35165822063015371)
,p_name=>'HTTP Headers'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.display_and_save(3, c.name) name,',
'       wwv_flow_item.text(4, null, 32, null, ''title="''||wwv_flow_lang.system_message(''F4000.P875.HTTP_HEADER_VAL'',c.name)||''"'') value',
'  from wwv_flow_ws_parameters c, wwv_flow_ws_operations b,',
'       wwv_flow_shared_web_services a ',
' where a.id = :P875_ID ',
'   and b.ws_id = a.id ',
'   and c.ws_opers_id = b.id ',
'   and c.input_or_output = ''H'''))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_ws_parameters c, wwv_flow_ws_operations b,',
'       wwv_flow_shared_web_services a ',
' where a.id = :P875_ID ',
'   and b.ws_id = a.id ',
'   and c.ws_opers_id = b.id ',
'   and c.input_or_output = ''H'''))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'There are no input parameters for this service.'
,p_query_row_count_max=>5000
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(35166017638015376)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(35166116947015377)
,p_query_column_id=>2
,p_column_alias=>'VALUE'
,p_column_display_sequence=>2
,p_column_heading=>'Value'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(176872608832700782)
,p_plug_name=>'Test REST Web Service'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'Use this page to test the reference of a REST Web service. Modify the URL to the service if it contains any references to session state. Enter a Proxy Override if you wish to use a specific one for the test you initiate on this page. Supply basic aut'
||'hentication credentials if it is required by the Web service. Enter values for required HTTP headers and Input Parameters and click Test. The response will appear in a scrollable region below the Input Parameters region.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1142727743638397017)
,p_plug_name=>'Web Service Reference: &P875_NAME.'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1143245926080567412)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(33595805137462218)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1142727743638397017)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:170:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(441373805154163796)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1142727743638397017)
,p_button_name=>'CLEAR'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Clear'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:clear_response();'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(33807630309574902)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(1142727743638397017)
,p_button_name=>'TEST'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Test'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(33595913096462220)
,p_branch_action=>'f?p=&APP_ID.:875:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>21
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33596118046462223)
,p_name=>'P875_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(33595522715462216)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33596710726462253)
,p_name=>'P875_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(33595522715462216)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Name of Web service reference.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33597115805462253)
,p_name=>'P875_URL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(33595522715462216)
,p_use_cache_before_default=>'NO'
,p_prompt=>'URL'
,p_source=>'URL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The URL endpoint of the Web service.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33597501386462254)
,p_name=>'P875_PROXY_OVERRIDE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(33595522715462216)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Proxy Override'
,p_source=>'PROXY_OVERRIDE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The proxy to be used in place of the proxy defined at the application level.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33597732766462255)
,p_name=>'P875_STATIC_PARM_04'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(33595522715462216)
,p_use_cache_before_default=>'NO'
,p_prompt=>'HTTP Method'
,p_source=>'STATIC_PARM_04'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The HTTP method used to make the request to the Web service.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33597931277462255)
,p_name=>'P875_STATIC_PARM_05'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(33595522715462216)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Response Format'
,p_source=>'STATIC_PARM_05'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The format of the response returned by the Web service.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33951422312212775)
,p_name=>'P875_USERNAME'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(33951108113208712)
,p_prompt=>'Username'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the username for HTTP Basic Authentication.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33951612746219471)
,p_name=>'P875_PASSWORD'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(33951108113208712)
,p_prompt=>'Password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter the password for HTTP Basic Authentication.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48946114500284528)
,p_name=>'P875_SOURCE'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(33600829145653306)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Source'
,p_source=>'SOAP_ENVELOPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>5
,p_display_when=>'P875_STATIC_PARM_10'
,p_display_when2=>'nvp'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the source to use as the input of the Web service.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48995230905698899)
,p_name=>'P875_STATIC_PARM_10'
,p_item_sequence=>135
,p_item_plug_id=>wwv_flow_imp.id(33595522715462216)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Input Format'
,p_source=>'STATIC_PARM_10'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'P872_INPUT_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(48714213128492554)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'The type of input expected by the Web service.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(48998213506712832)
,p_computation_sequence=>10
,p_computation_item=>'P875_SOURCE'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P875_STATIC_PARM_10'
,p_compute_when_text=>'function:file'
,p_compute_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1143245536772567408)
,p_name=>'Test web service'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(33807630309574902)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1143245638158567409)
,p_event_id=>wwv_flow_imp.id(1143245536772567408)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'p875_test_rest();'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(33598204436462256)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_SHARED_WEB_SERVICES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_SHARED_WEB_SERVICES'
,p_attribute_03=>'P875_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Unable to fetch row.'
,p_internal_uid=>33598204436462256
);
end;
/
prompt --application/pages/page_00876
begin
wwv_flow_imp_page.create_page(
 p_id=>876
,p_name=>'Edit REST Web Reference '
,p_alias=>'EDIT-REST-WEB-REFERENCE'
,p_step_title=>'Edit REST Web Reference '
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_html_page_onload=>'onload="p876_toggleInType();"'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'function p876_add_input_parm(){',
'    var get = new htmldb_Get(null,$v(''pFlowId''),''APPLICATION_PROCESS=P872_ADD_PARAMETER'',0);',
'',
'    get.addParam(''x01'',''REST_INPUT_PARMS'');',
'    apex.jQuery("input[name=f01]").each( function() {',
'        get.addParam(''f01'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f02]").each( function() {',
'        get.addParam(''f02'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("select[name=f03] option:selected").each(function (){',
'        get.addParam(''f03'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f09]").each( function() {',
'        get.addParam(''f04'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f10]").each( function() {',
'        get.addParam(''f05'',apex.jQuery(this).val());',
'        });',
'    gReturn = get.get();',
'    get = null;',
'',
'    apex.jQuery("#rest_input_parms").trigger("apexrefresh");',
'}',
'',
'function p876_add_output_parm(){',
'    var get = new htmldb_Get(null,$v(''pFlowId''),''APPLICATION_PROCESS=P872_ADD_PARAMETER'',0);',
'',
'    get.addParam(''x01'',''REST_OUTPUT_PARMS'');',
'    apex.jQuery("input[name=f04]").each( function() {',
'        get.addParam(''f01'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f05]").each( function() {',
'        get.addParam(''f02'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f15]").each( function() {',
'        get.addParam(''f06'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("select[name=f06] option:selected").each(function (){',
'        get.addParam(''f03'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f11]").each( function() {',
'        get.addParam(''f04'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f12]").each( function() {',
'        get.addParam(''f05'',apex.jQuery(this).val());',
'        });',
'    gReturn = get.get();',
'    get = null;',
'',
'    apex.jQuery("#rest_output_parms").trigger("apexrefresh");',
'}',
'',
'function p876_remove_input_parm(seqid){',
'    var get = new htmldb_Get(null,$v(''pFlowId''),''APPLICATION_PROCESS=P872_REMOVE_PARAMETER'',0);',
'',
'    get.addParam(''x01'',''REST_INPUT_PARMS'');',
'    get.addParam(''x02'',seqid);',
'    get.addParam(''x03'',''update'');',
'    apex.jQuery("input[name=f01]").each( function() {',
'        get.addParam(''f01'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f02]").each( function() {',
'        get.addParam(''f02'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("select[name=f03] option:selected").each(function (){',
'        get.addParam(''f03'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f09]").each( function() {',
'        get.addParam(''f04'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f10]").each( function() {',
'        get.addParam(''f05'',apex.jQuery(this).val());',
'        });',
'    gReturn = get.get();',
'    get = null;',
'',
'    apex.jQuery("#rest_input_parms").trigger("apexrefresh");',
'}',
'',
'function p876_remove_output_parm(seqid){',
'    var get = new htmldb_Get(null,$v(''pFlowId''),''APPLICATION_PROCESS=P872_REMOVE_PARAMETER'',0);',
'',
'    get.addParam(''x01'',''REST_OUTPUT_PARMS'');',
'    get.addParam(''x02'',seqid);',
'    get.addParam(''x03'',''update'');',
'    apex.jQuery("input[name=f04]").each( function() {',
'        get.addParam(''f01'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f05]").each( function() {',
'        get.addParam(''f02'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f15]").each( function() {',
'        get.addParam(''f06'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("select[name=f06] option:selected").each(function (){',
'        get.addParam(''f03'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f11]").each( function() {',
'        get.addParam(''f04'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f12]").each( function() {',
'        get.addParam(''f05'',apex.jQuery(this).val());',
'        });',
'    gReturn = get.get();',
'    get = null;',
'',
'    apex.jQuery("#rest_output_parms").trigger("apexrefresh");',
'}',
'',
'function p876_add_header(){',
'    var get = new htmldb_Get(null,$v(''pFlowId''),''APPLICATION_PROCESS=P872_ADD_PARAMETER'',0);',
'',
'    get.addParam(''x01'',''REST_HTTP_HEADERS'');',
'    apex.jQuery("input[name=f07]").each( function() {',
'        get.addParam(''f01'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f08]").each( function() {',
'        get.addParam(''f02'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f13]").each( function() {',
'        get.addParam(''f04'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f14]").each( function() {',
'        get.addParam(''f05'',apex.jQuery(this).val());',
'        });',
'    gReturn = get.get();',
'    get = null;',
'',
'    apex.jQuery("#rest_http_headers").trigger("apexrefresh");',
'}',
'',
'function p876_remove_header(seqid){',
'    var get = new htmldb_Get(null,$v(''pFlowId''),''APPLICATION_PROCESS=P872_REMOVE_PARAMETER'',0);',
'',
'    get.addParam(''x01'',''REST_HTTP_HEADERS'');',
'    get.addParam(''x02'',seqid);',
'    get.addParam(''x03'',''update'');',
'    apex.jQuery("input[name=f07]").each( function() {',
'        get.addParam(''f01'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f08]").each( function() {',
'        get.addParam(''f02'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f13]").each( function() {',
'        get.addParam(''f04'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f14]").each( function() {',
'        get.addParam(''f05'',apex.jQuery(this).val());',
'        });',
'    gReturn = get.get();',
'    get = null;',
'',
'    apex.jQuery("#rest_http_headers").trigger("apexrefresh");',
'}',
'',
'function p876_popPath(seqid){',
'    if((apex.jQuery("input:radio[id^=P876_OUTPUT_FORMAT]:checked").val() == ''xml'') && (apex.jQuery("#path"+seqid).val() == '''')){',
'        apex.jQuery("#path"+seqid).val("/"+apex.jQuery("#name"+seqid).val());',
'    }',
'    else if (apex.jQuery("#path"+seqid).val() == ''''){',
'        apex.jQuery("#path"+seqid).val(seqid);',
'    }',
'}',
'',
'function p876_toggleInType(){',
'    if ($v(''P876_INPUT_TYPE'') == ''body'' || $v(''P876_INPUT_TYPE'') == ''function''){',
'        apex.item(''P876_SOURCE'').show();',
'        $x_Hide(''report_34122700798821352_catch'');',
'    } else if ($v(''P876_INPUT_TYPE'') == ''file''){',
'        $x_Hide(''report_34122700798821352_catch'');',
'        apex.item(''P876_SOURCE'').hide();',
'    } else {',
'        apex.item(''P876_SOURCE'').hide();',
'        $x_Show(''report_34122700798821352_catch'');',
'    }',
'}',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_help_text=>'advnc_web_services.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(33987329567919152)
,p_plug_name=>'REST Web Reference'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(34122700798821352)
,p_name=>'REST Input Parameters'
,p_region_name=>'rest_input_parms'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>130
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<a href="#" onclick="p876_remove_input_parm(''||seq_id||'');"><span class="a-Icon icon-remove"></span>'' ||',
'       ''<span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''F4000.P876.DELETE_PARAM'',',
'                                                                       wwv_flow_escape.html( c001 ) ) ||',
'       ''</span></a>'' ||',
'       wwv_flow_item.hidden(1,seq_id)||wwv_flow_item.hidden(9,c003)||wwv_flow_item.hidden(10,c004) as seq_id,',
'       wwv_flow_item.text(2,c001) name,',
'       wwv_flow_item.select_list_from_lov(3,nvl(c002,''string''),''REST_INPUT_PARAMETER_TYPES'', null, ''NO'', null, null) type',
'  from wwv_flow_collections',
' where collection_name = ''REST_INPUT_PARMS''',
'   and c004 != ''D'''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No input parameters defined for this service'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(34122911854821356)
,p_query_column_id=>1
,p_column_alias=>'SEQ_ID'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_report_column_width=>40
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(34123025766821356)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(34123118019821356)
,p_query_column_id=>3
,p_column_alias=>'TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Type'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(34123206339822961)
,p_name=>'REST Output Parameters'
,p_region_name=>'rest_output_parms'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>140
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<a href="#" onclick="p876_remove_output_parm(''||seq_id||'');"><span class="a-Icon icon-remove"></span>'' ||',
'       ''<span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''F4000.P876.DELETE_PARAM'',',
'                                                                       wwv_flow_escape.html( c001 ) ) ||',
'       ''</span></a>'' ||',
'       wwv_flow_item.hidden(4,seq_id)||wwv_flow_item.hidden(11,c003)||wwv_flow_item.hidden(12,c004) as output_seq_id,',
'       wwv_flow_item.text(5,c001,30,255,null,''name''||seq_id) output_name,',
'       wwv_flow_item.text(15,c005,50,4000,''onfocus=p876_popPath(''||seq_id||'');'',''path''||seq_id) path,',
'       wwv_flow_item.select_list_from_lov(6,nvl(c002,''string''),''REST_INPUT_PARAMETER_TYPES'', null, ''NO'', null, null) output_type',
'  from wwv_flow_collections',
' where collection_name = ''REST_OUTPUT_PARMS''',
'   and c004 != ''D'''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No output parameters defined for this service'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1142728778959397027)
,p_query_column_id=>1
,p_column_alias=>'OUTPUT_SEQ_ID'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_report_column_width=>40
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1142728885541397028)
,p_query_column_id=>2
,p_column_alias=>'OUTPUT_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(46907806366867170)
,p_query_column_id=>3
,p_column_alias=>'PATH'
,p_column_display_sequence=>3
,p_column_heading=>'Path'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1142728917880397029)
,p_query_column_id=>4
,p_column_alias=>'OUTPUT_TYPE'
,p_column_display_sequence=>4
,p_column_heading=>'Type'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(34140521388763866)
,p_name=>'HTTP Request Headers'
,p_region_name=>'rest_http_headers'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>150
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<a href="#" onclick="p876_remove_header(''||seq_id||'');"><span class="a-Icon icon-remove"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''F4000.P876.DELETE_HEADER'')||''</span></a>''||',
'       wwv_flow_item.hidden(7,seq_id)||wwv_flow_item.hidden(13,c003)||wwv_flow_item.hidden(14,c004) header_seq_id,',
'       wwv_flow_item.text(8,c001) header_name',
'  from wwv_flow_collections',
' where collection_name = ''REST_HTTP_HEADERS''',
'   and c004 != ''D'''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No HTTP headers defined for this service'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1142729086479397030)
,p_query_column_id=>1
,p_column_alias=>'HEADER_SEQ_ID'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_report_column_width=>40
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1142729104343397031)
,p_query_column_id=>2
,p_column_alias=>'HEADER_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(620281521846925739)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>160
,p_plug_display_point=>'REGION_POSITION_04'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(741443157205225826)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>170
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(34141026153763869)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(34140521388763866)
,p_button_name=>'ADD'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Add Header'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'javascript:p876_add_header();'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(34168919637379005)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(34122700798821352)
,p_button_name=>'ADD_I'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Add Input Parameter'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'javascript:p876_add_input_parm();'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(34169300721383051)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(34123206339822961)
,p_button_name=>'ADD_O'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Add Output Parameter'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'javascript:p876_add_output_parm();'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(33988409371919172)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(620281521846925739)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(33988002257919170)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(620281521846925739)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(htmldb_delete_message,''DELETE'');'
,p_button_condition=>'P876_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(33988226918919172)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(620281521846925739)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P876_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(33991321484919185)
,p_branch_action=>'f?p=&APP_ID.:170:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>21
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33988614049919173)
,p_name=>'P876_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(33987329567919152)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33988820787919174)
,p_name=>'P876_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(33987329567919152)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>The name for this Web service within the context of the Builder. This name is only used within the App Builder tool.</p>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33989003279919175)
,p_name=>'P876_URL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(33987329567919152)
,p_use_cache_before_default=>'NO'
,p_prompt=>'URL'
,p_source=>'URL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify the URL endpoint for the REST Web service. You may reference session state in the URL by using',
'   <code>&amp;ITEM_NAME.</code> convention.</p>',
'<p>For example:</p>',
'<code>http://s3.example.com/&amp;P2_BUCKET.</code>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33989224451919175)
,p_name=>'P876_PROXY_OVERRIDE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(33987329567919152)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Proxy Override'
,p_source=>'PROXY_OVERRIDE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This overrides the system defined HTTP proxy for your request. The proxy may include an optional TCP/IP port number at',
'   which the proxy server listens.  Use the following syntax:</p>',
'<pre>[http://]host[:port][/]</pre>',
'<p>For example:</p>',
'<pre>www-proxy.example.com</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33989427517919175)
,p_name=>'P876_HTTP_METHOD'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(33987329567919152)
,p_use_cache_before_default=>'NO'
,p_prompt=>'HTTP Method'
,p_source=>'STATIC_PARM_04'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REST_HTTP_METHOD'
,p_lov=>'.'||wwv_flow_imp.id(33996111639139709)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Choose the HTTP Method appropriate for the REST Web service. The HTTP method describes the method of the Web service.</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33989609797919175)
,p_name=>'P876_OUTPUT_FORMAT'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(33987329567919152)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Output Format'
,p_source=>'STATIC_PARM_05'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REST_OUTPUT_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(33563708997950496)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Choose the response format expected from the Web service. Options include:',
'<br /><br />',
'<ul>',
'    <li><strong>XML</strong> - The response will be stored in the named output parameters. Enter an XPath expression in',
'        the Path column to locate individual nodes.</li>',
'    <li><strong>Text</strong> - The response will be stored in the named output parameters. Enter a number in the Path',
'        column that corresponds to the position of each parameter.</li>',
'    <li><strong>JSON</strong> - The entire response will be stored in the <code>CLOB001</code> column of a collection',
'        you specify. The response can then be parsed with <code>APEX_JSON</code> PL/SQL API.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33989831716919175)
,p_name=>'P876_XPATH'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(33987329567919152)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Response XPath'
,p_source=>'STATIC_PARM_06'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter an XPath expression to the relevant part of the response. Example:',
'',
'<pre>/ListBucketResult/Contents</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33990023486919176)
,p_name=>'P876_NEW_RECORD_DELIM'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(33987329567919152)
,p_use_cache_before_default=>'NO'
,p_prompt=>'New Record Delimiter'
,p_source=>'STATIC_PARM_07'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>5
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the character or sequence that determines a new record in a text response from a Web service. Use <strong>\n</strong> to indicate a new line and <strong>\t</strong> to indicate a tab character.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33990225879919178)
,p_name=>'P876_TEXT_DELIM'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(33987329567919152)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Parameter Delimiter'
,p_source=>'STATIC_PARM_08'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>5
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the character or sequence that separates parameters returned from the Web service. Use <strong>\n</strong> to indicate a new line and <strong>\t</strong> to indicate a tab character.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33993018341075457)
,p_name=>'P876_BASIC_AUTH'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(33987329567919152)
,p_item_default=>'N'
,p_prompt=>'Basic Authentication'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Choose whether this Web service requires basic authentication. Basic authentication credentials are sent as part of the HTTP request in clear text. Web services that employ basic authentication usually also use the HTTPS (SSL) protocol since the user'
||'name and password are sent in clear text.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(35066616748313126)
,p_name=>'P876_XMLNS'
,p_item_sequence=>155
,p_item_plug_id=>wwv_flow_imp.id(33987329567919152)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Response Namespace'
,p_source=>'STATIC_PARM_09'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the namespace corresponding to the Response XPath. Example:',
'',
'<pre>http://s3.example.com/doc/2006-03-01/</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48885832687277527)
,p_name=>'P876_INPUT_TYPE'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(34122700798821352)
,p_use_cache_before_default=>'NO'
,p_item_default=>'nvp'
,p_prompt=>'Input Type'
,p_source=>'STATIC_PARM_10'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P872_INPUT_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(48714213128492554)||'.'
,p_cHeight=>1
,p_tag_attributes=>'onchange="p876_toggleInType();"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specifies the type of input parameters that should be sent with the HTTP request. Options include:',
'<br /><br />',
'<ul>',
'    <li><strong>Name Value Pairs</strong> - Multiple name/value pairs of specified data type.</li>',
'    <li><strong>Specified Body with Substitutions</strong> - A text payload that can contain <code>#ITEM_NAME#</code>',
'        substitutions to send items in session state with the request.</li>',
'    <li><strong>File Upload Item</strong></li>',
'    <li><strong>Function Returning CLOB</strong> - A PL/SQL function body returning CLOB.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48886108623308420)
,p_name=>'P876_SOURCE'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(34122700798821352)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Source'
,p_source=>'SOAP_ENVELOPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the source to use as the input of the Web service.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(33998026493191359)
,p_computation_sequence=>20
,p_computation_item=>'P876_BASIC_AUTH'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'Y'
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_ws_operations',
' where name = ''BASIC_AUTH''',
'   and ws_id = :P876_ID'))
,p_compute_when_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(33990521548919181)
,p_validation_name=>'P876_NAME not null'
,p_validation_sequence=>40
,p_validation=>'P876_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Enter a name to identify this Web reference.'
,p_when_button_pressed=>wwv_flow_imp.id(33988226918919172)
,p_associated_item=>wwv_flow_imp.id(33988820787919174)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(177069020725438332)
,p_validation_name=>'P876_URL'
,p_validation_sequence=>50
,p_validation=>'P876_URL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Enter the URL to the Web service.'
,p_when_button_pressed=>wwv_flow_imp.id(33988226918919172)
,p_associated_item=>wwv_flow_imp.id(33989003279919175)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(177071212806464527)
,p_validation_name=>'P876_XPATH'
,p_validation_sequence=>60
,p_validation=>'P876_XPATH'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Enter an XPath expression to the relevant part of the response.'
,p_validation_condition=>'P876_OUTPUT_FORMAT'
,p_validation_condition2=>'xml'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(33988226918919172)
,p_associated_item=>wwv_flow_imp.id(33989831716919175)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(176971614437582277)
,p_name=>'output type actions'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P876_OUTPUT_FORMAT'
,p_condition_element=>'P876_OUTPUT_FORMAT'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'xml'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(176971902866582279)
,p_event_id=>wwv_flow_imp.id(176971614437582277)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P876_NEW_RECORD_DELIM'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(176972126701582280)
,p_event_id=>wwv_flow_imp.id(176971614437582277)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P876_NEW_RECORD_DELIM'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(176974203749607580)
,p_event_id=>wwv_flow_imp.id(176971614437582277)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P876_TEXT_DELIM'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(176988908728618446)
,p_event_id=>wwv_flow_imp.id(176971614437582277)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P876_TEXT_DELIM'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(176974411021609633)
,p_event_id=>wwv_flow_imp.id(176971614437582277)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P876_XPATH'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(176989415308620334)
,p_event_id=>wwv_flow_imp.id(176971614437582277)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P876_XPATH'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(176974620718612430)
,p_event_id=>wwv_flow_imp.id(176971614437582277)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P876_XMLNS'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(176989621195622001)
,p_event_id=>wwv_flow_imp.id(176971614437582277)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P876_XMLNS'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(176988132146615735)
,p_event_id=>wwv_flow_imp.id(176971614437582277)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.SHOWREQUIRED'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P876_XPATH'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(176989829160624334)
,p_event_id=>wwv_flow_imp.id(176971614437582277)
,p_event_result=>'FALSE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.HIDEREQUIRED'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P876_XPATH'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(295586221424675170)
,p_name=>'disable all output items if json'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P876_OUTPUT_FORMAT'
,p_condition_element=>'P876_OUTPUT_FORMAT'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'json'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(295586531813675170)
,p_event_id=>wwv_flow_imp.id(295586221424675170)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P876_XPATH,P876_XMLNS,P876_NEW_RECORD_DELIM,P876_TEXT_DELIM'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(295596231553833783)
,p_event_id=>wwv_flow_imp.id(295586221424675170)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(34123206339822961)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(295593504176831312)
,p_event_id=>wwv_flow_imp.id(295586221424675170)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(34123206339822961)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(33990612219919183)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_SHARED_WEB_SERVICES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_SHARED_WEB_SERVICES'
,p_attribute_03=>'P876_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Unable to fetch row.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>33990612219919183
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(34000814007386355)
,p_process_sequence=>30
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create collections'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_collection.collection_exists(''REST_INPUT_PARMS'') then',
'  wwv_flow_collection.delete_collection(''REST_INPUT_PARMS'');',
'end if;',
'if wwv_flow_collection.collection_exists(''REST_OUTPUT_PARMS'') then',
'  wwv_flow_collection.delete_collection(''REST_OUTPUT_PARMS'');',
'end if;',
'if wwv_flow_collection.collection_exists(''REST_HTTP_HEADERS'') then',
'  wwv_flow_collection.delete_collection(''REST_HTTP_HEADERS'');',
'end if;',
'',
'wwv_flow_collection.create_collection_from_query_b(',
'  p_collection_name => ''REST_INPUT_PARMS'',',
'  p_query => ''select c.name, c.parm_type, c.id, ''''O'''' from wwv_flow_ws_parameters c, wwv_flow_ws_operations b, wwv_flow_shared_web_services a where b.ws_id = a.id and c.ws_opers_id = b.id and c.input_or_output = ''''I'''' and b.name = ''''doREST'''' and a.id'
||' = (select v(''''P876_ID'''') from dual)'' );',
'',
'wwv_flow_collection.create_collection_from_query_b(',
'  p_collection_name => ''REST_OUTPUT_PARMS'',',
'  p_query => ''select c.name, c.parm_type, c.id, ''''O'''', c.path from wwv_flow_ws_parameters c, wwv_flow_ws_operations b, wwv_flow_shared_web_services a where b.ws_id = a.id and c.ws_opers_id = b.id and c.input_or_output = ''''O'''' and b.name = ''''doREST'''' '
||'and a.id = (select v(''''P876_ID'''') from dual)'' );',
'',
'wwv_flow_collection.create_collection_from_query_b(',
'  p_collection_name => ''REST_HTTP_HEADERS'',',
'  p_query => ''select c.name, c.parm_type, c.id, ''''O'''' from wwv_flow_ws_parameters c, wwv_flow_ws_operations b, wwv_flow_shared_web_services a where b.ws_id = a.id and c.ws_opers_id = b.id and c.input_or_output = ''''H'''' and b.name = ''''doREST'''' and a.id'
||' = (select v(''''P876_ID'''') from dual)'' );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>34000814007386355
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(34132610934231019)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update collection input parms'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.update_members(',
'  p_collection_name => ''REST_INPUT_PARMS'',',
'  p_seq => wwv_flow.g_f01,',
'  p_c001 => wwv_flow.g_f02,',
'  p_c002 => wwv_flow.g_f03,',
'  p_c003 => wwv_flow.g_f09,',
'  p_c004 => wwv_flow.g_f10 );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>34132610934231019
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(34132401930228406)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update collection http headers'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.update_members(',
'  p_collection_name => ''REST_HTTP_HEADERS'',',
'  p_seq => wwv_flow.g_f07,',
'  p_c001 => wwv_flow.g_f08,',
'  p_c003 => wwv_flow.g_f13,',
'  p_c004 => wwv_flow.g_f14  );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>34132401930228406
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(34132830327236657)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update collection output parms'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.update_members(',
'  p_collection_name => ''REST_OUTPUT_PARMS'',',
'  p_seq => wwv_flow.g_f04,',
'  p_c001 => wwv_flow.g_f05,',
'  p_c002 => wwv_flow.g_f06,',
'  p_c003 => wwv_flow.g_f11,',
'  p_c004 => wwv_flow.g_f12,',
'  p_c005 => wwv_flow.g_f15 );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>34132830327236657
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(34173429988779355)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update REST web reference'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_xpath             varchar2(4000) := null;',
'    l_text_parm_delim   varchar2(4000) := null;',
'    l_text_record_delim varchar2(4000) := null;',
'    l_xmlns             varchar2(4000) := null;',
'    l_source            clob := empty_clob();',
'    l_items             clob;',
'begin',
'    if :P876_OUTPUT_FORMAT = ''xml'' then',
'        l_xpath := :P876_XPATH;',
'        l_xmlns := :P876_XMLNS;',
'    else',
'        l_text_parm_delim := :P876_TEXT_DELIM;',
'        l_text_record_delim := :P876_NEW_RECORD_DELIM;',
'    end if;   ',
'',
'    if :P876_INPUT_TYPE in (''body'',''function'') then',
'      l_source := :P876_SOURCE;',
'    end if;     ',
'',
'    wwv_flow_web_services.update_rest_web_reference(',
'        p_id                            => :P876_ID,',
'        p_flow_id                       => :FB_FLOW_ID,',
'        p_name                          => :P876_NAME,',
'        p_url                           => :P876_URL,',
'        p_proxy_override                => :P876_PROXY_OVERRIDE,',
'        p_http_method                   => :P876_HTTP_METHOD,',
'        p_input_format                  => :P876_INPUT_TYPE,',
'        p_body                          => l_source,',
'        p_output_format                 => :P876_OUTPUT_FORMAT,',
'        p_xpath                         => l_xpath,',
'        p_xmlns                         => l_xmlns,',
'        p_text_parm_delim               => l_text_parm_delim,',
'        p_text_record_delim             => l_text_record_delim,',
'        p_inputs_collection             => ''REST_INPUT_PARMS'',',
'        p_outputs_collection            => ''REST_OUTPUT_PARMS'',',
'        p_headers_collection            => ''REST_HTTP_HEADERS'',',
'        p_basic_auth                    => :P876_BASIC_AUTH );',
'',
'  if :P876_INPUT_TYPE = ''body'' then',
'    l_items := wwv_flow_web_services.parse( l_source );',
'',
'    update wwv_flow_shared_web_services',
'       set flow_items_comma_delimited = l_items',
'     where id = :P876_ID;',
'  end if;',
'    ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error updating REST Web reference.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(33988226918919172)
,p_process_success_message=>'REST Web reference updated.'
,p_internal_uid=>34173429988779355
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(35187101191302684)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete reference'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from wwv_flow_shared_web_services',
' where id = :P876_ID',
'   and security_group_id = :flow_security_group_id;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error deleting Web Service Reference. #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'DELETE'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>'Web Service Reference deleted.'
,p_internal_uid=>35187101191302684
);
end;
/
prompt --application/pages/page_00877
begin
wwv_flow_imp_page.create_page(
 p_id=>877
,p_name=>'Conditional Computations'
,p_alias=>'CONDITIONAL-COMPUTATIONS'
,p_step_title=>'Conditional Computations'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213220627333807318)
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(194533823362486778)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>91
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(17446232715505772)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(194538321296502260)
,p_plug_name=>'Computation Conditions'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>125
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select flow_step_id page, COMPUTATION_ITEM, ',
'compute_WHEN_TYPE,',
'compute_WHEN,',
'compute_WHEN_text,',
'id',
'from WWV_FLOW_STEP_COMPUTATIONS',
'where FLOW_ID = :fb_flow_id and ',
'compute_when_type is not null and compute_when_type != ''%''||''null%'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(194538422938502260)
,p_name=>'Computation Conditions'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194538631724502264)
,p_db_column_name=>'PAGE'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Page'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE#'
,p_column_linktext=>'#PAGE#'
,p_column_link_attr=>'title="View page definition"'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194538710618502264)
,p_db_column_name=>'COMPUTATION_ITEM'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Item'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE##5520:#ID#'
,p_column_linktext=>'#COMPUTATION_ITEM#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194538806160502265)
,p_db_column_name=>'COMPUTE_WHEN_TYPE'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Condition Type'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194538920265502266)
,p_db_column_name=>'COMPUTE_WHEN'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Expression 1'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194539013016502267)
,p_db_column_name=>'COMPUTE_WHEN_TEXT'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Expression 2'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(100575878725284416)
,p_db_column_name=>'ID'
,p_display_order=>15
,p_column_identifier=>'F'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(194539419774503408)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1292511301536644'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'PAGE:COMPUTATION_ITEM:COMPUTE_WHEN_TYPE:COMPUTE_WHEN:COMPUTE_WHEN_TEXT:ID'
,p_sort_column_1=>'PAGE'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'COMPUTATION_ITEM'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(194533627761486776)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(194538321296502260)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:877:&SESSION.::&DEBUG.:877,RIR::'
);
end;
/
prompt --application/pages/page_00878
begin
wwv_flow_imp_page.create_page(
 p_id=>878
,p_name=>'Conditional Buttons'
,p_alias=>'CONDITIONAL-BUTTONS'
,p_step_title=>'Conditional Buttons'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213220627333807318)
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(194548307071571000)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>91
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(16353308133052510)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(194554903107601883)
,p_plug_name=>'Button Conditions'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>125
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,flow_step_id page, BUTTON_NAME, ',
'BUTTON_CONDITION_TYPE,',
'BUTTON_CONDITION, ',
'BUTTON_CONDITION2',
'from WWV_FLOW_STEP_BUTTONS',
'where ',
' flow_id = :fb_flow_id and',
' button_condition_type is not null'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(194555017964601883)
,p_name=>'Button Conditions'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194555209934601885)
,p_db_column_name=>'PAGE'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Page'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE#'
,p_column_linktext=>'#PAGE#'
,p_column_link_attr=>'title="View page definition"'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194555315632601886)
,p_db_column_name=>'BUTTON_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Button'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE##5130:#ID#'
,p_column_linktext=>'#BUTTON_NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194555407252601887)
,p_db_column_name=>'BUTTON_CONDITION_TYPE'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Condition Type'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194555503299601888)
,p_db_column_name=>'BUTTON_CONDITION'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Expression 1'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194555618628601889)
,p_db_column_name=>'BUTTON_CONDITION2'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Expression 2'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(100575268129284410)
,p_db_column_name=>'ID'
,p_display_order=>15
,p_column_identifier=>'F'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(194555905977603406)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1292620098536644'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'PAGE:BUTTON_NAME:BUTTON_CONDITION_TYPE:BUTTON_CONDITION:BUTTON_CONDITION2:ID'
,p_sort_column_1=>'PAGE'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'BUTTON_NAME'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(194549828979571012)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(194554903107601883)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:878:&SESSION.::&DEBUG.:878,RIR::'
);
end;
/
prompt --application/pages/page_00880
begin
wwv_flow_imp_page.create_page(
 p_id=>880
,p_name=>'Create Form and Report on Web Service - Input Items'
,p_alias=>'CREATE-FORM-AND-REPORT-ON-WEB-SERVICE-INPUT-ITEMS1'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Form and Report on Web Service'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(34477514962171596)
,p_name=>'Items for Input Parameters'
,p_template=>wwv_flow_imp.id(42025417508627628)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select seq_id, c001 id, c002 name, c003 parm_type, ',
'       c004 item_name, c005 item_label, c006 include',
'  from wwv_flow_collections',
' where collection_name = ''WS_INPUT_ITEMS'''))
,p_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Identify the names and labels for items created based on this service''s input parameters.</p>',
'<p>To include an item, select <strong>Yes</strong> in the Create column. Otherwise, select <strong>No</strong>. If necessary, edit the item label.</p>'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No input parameters for this service.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>1000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(34477729869171606)
,p_query_column_id=>1
,p_column_alias=>'SEQ_ID'
,p_column_display_sequence=>5
,p_column_heading=>'Seq Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(34477802880171609)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>6
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(34477911465171609)
,p_query_column_id=>3
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'DISPLAY_AND_SAVE'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(34478021180171609)
,p_query_column_id=>4
,p_column_alias=>'PARM_TYPE'
,p_column_display_sequence=>2
,p_column_heading=>'Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'DISPLAY_AND_SAVE'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(34478119515171610)
,p_query_column_id=>5
,p_column_alias=>'ITEM_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Item Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>20
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(34478221520171610)
,p_query_column_id=>6
,p_column_alias=>'ITEM_LABEL'
,p_column_display_sequence=>4
,p_column_heading=>'Item Label'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_lov_show_nulls=>'NO'
,p_column_width=>20
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(34478312348171610)
,p_query_column_id=>7
,p_column_alias=>'INCLUDE'
,p_column_display_sequence=>7
,p_column_heading=>'Create'
,p_use_as_row_header=>'N'
,p_display_as=>'SELECT_LIST_FROM_LOV'
,p_named_lov=>wwv_flow_imp.id(84259319526460470)
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(34478606505171611)
,p_plug_name=>'Wizard Steps'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(30094110886480012)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(204759821999209352)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(34479705207171630)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(204759821999209352)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(34480101031171636)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(204759821999209352)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(34480319447171637)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(204759821999209352)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(34481619425171645)
,p_branch_action=>'f?p=&APP_ID.:716:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(34480101031171636)
,p_branch_sequence=>25
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''WS_AUTH_ITEMS'''))
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(34481818026171646)
,p_branch_action=>'f?p=&FLOW_ID.:882:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(34480101031171636)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(34482016916171646)
,p_branch_action=>'f?p=&FLOW_ID.:705:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(34480319447171637)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(549740346539954504)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(34479705207171630)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(549740495150954505)
,p_event_id=>wwv_flow_imp.id(549740346539954504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(34480701279171641)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.update_members(',
'  p_collection_name      => ''WS_INPUT_ITEMS'',',
'  p_seq                  => wwv_flow.g_f01,',
'  p_c001                 => wwv_flow.g_f02,',
'  p_c002                 => wwv_flow.g_f03,',
'  p_c003                 => wwv_flow.g_f04,',
'  p_c004                 => wwv_flow.g_f05,',
'  p_c005                 => wwv_flow.g_f06,',
'  p_c006                 => wwv_flow.g_f07 );'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>34480701279171641
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(34480921974171643)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate input item collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    n   wwv_flow_global.vc_arr2;',
'    v   wwv_flow_global.vc_arr2;',
'begin',
'    n(1) := ''pg_id'';',
'    n(2) := ''op_id'';',
'    v(1) := :P705_PAGE_ID;',
'    v(2) := :P700_OPERATION_ID;',
'',
'    wwv_flow_collection.create_collection_from_query_b(',
'        p_collection_name => ''WS_INPUT_ITEMS'',',
'        p_query           => ''select a.id, decode(a.input_or_output,''''I'''',a.name,''''header:''''||a.name) name, a.parm_type,',
'''''P''''||:pg_id||''''_''''||upper(a.name), initcap(a.name), ''''Y'''' yes_no from wwv_flow_ws_parameters a where a.input_or_output in (''''I'''',''''H'''') and a.ws_opers_id = :op_id order by a.input_or_output, a.id'',',
'    p_names           => n,',
'    p_values          => v);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'not wwv_flow_collection.collection_exists(''WS_INPUT_ITEMS'')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>34480921974171643
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(34481300212171644)
,p_process_sequence=>70
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate auth item collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    n   wwv_flow_global.vc_arr2;',
'    v   wwv_flow_global.vc_arr2;',
'begin',
'    n(1) := ''pg_id'';',
'    n(2) := ''ws_id'';',
'    v(1) := :P705_PAGE_ID;',
'    v(2) := :P700_WS_ID;',
'',
'    wwv_flow_collection.create_collection_from_query_b(',
'        p_collection_name => ''WS_AUTH_ITEMS'',',
'        p_query           => ''select a.id, decode(a.name,''''username'''',wwv_flow_lang.system_message(''''ACCESS_CONTROL_USERNAME''''),''''password'''',wwv_flow_lang.system_message(''''PASSWORD''''),a.name), wwv_flow_lang.system_message(''''AUTHENTICATION''''),',
'''''P''''||:pg_id||''''_''''||upper(decode(a.name,''''username'''',wwv_flow_lang.system_message(''''ACCESS_CONTROL_USERNAME''''),''''password'''',wwv_flow_lang.system_message(''''PASSWORD''''),a.name)), decode(a.name,''''username'''',wwv_flow_lang.system_message(''''ACCESS_CONTRO'
||'L_USERNAME''''),''''password'''',wwv_flow_lang.system_message(''''PASSWORD''''),a.name), ''''Y'''' y_or_n from wwv_flow_ws_parameters a, wwv_flow_ws_operations b, wwv_flow_shared_web_services c where input_or_output = ''''A'''' and a.ws_opers_id = b.id and b.ws_id = c'
||'.id and c.id = :ws_id order by a.name desc'',',
'    p_names           => n,',
'    p_values          => v);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'not wwv_flow_collection.collection_exists(''WS_AUTH_ITEMS'')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>34481300212171644
);
end;
/
prompt --application/pages/page_00881
begin
wwv_flow_imp_page.create_page(
 p_id=>881
,p_name=>'Branch Utilities'
,p_alias=>'BRANCH-UTILITIES'
,p_step_title=>'Branch Utilities'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_branch.htm'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(194563519648908050)
,p_plug_name=>'Utilities'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'   select wwv_flow_lang.system_message(''F4000.UTILITIES.INFO'') msg',
'     from dual )',
'loop',
'   sys.htp.p(''<p>''||c1.msg||''</p>'');',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(194563731774908053)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(11286824340344465)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(194564102318908056)
,p_plug_name=>'Branch Utilities'
,p_icon_css_classes=>'icon-util-gear'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(655568879441187677)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_imp.id(194565421168929524)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
end;
/
prompt --application/pages/page_00882
begin
wwv_flow_imp_page.create_page(
 p_id=>882
,p_name=>'Create Form and Report on Web Service - Report Parameters'
,p_alias=>'CREATE-FORM-AND-REPORT-ON-WEB-SERVICE-REPORT-PARAMETERS1'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Form and Report on Web Service'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript" language="JavaScript1.1">',
'    function ToggleAll(e){	if (e.checked) {	CheckAll();	}',
'    	else {	ClearAll();	}',
'    }',
'    function Check(e){	e.checked = true;}',
'    function Clear(e){	e.checked = false;}',
'    function CheckAll(){	',
'        var ml = document.wwv_flow;	',
'        var len = ml.elements.length;	',
'        for (var i = 0; i < len; i++) {',
'        var e = ml.elements[i];	',
'        if (e.name == "f01" ||e.name == "f03" ||e.name == "f05" || e.name == "f07" || e.name == "f09" ||e.name == "f11" ||e.name == "f13" || e.name == "f15" ) {',
'        Check(e);}',
'        }',
'        ml.f01.checked = true;',
'    }',
'    function ClearAll(){	',
'        var ml = document.wwv_flow;	',
'        var len = ml.elements.length;	',
'        for (var i = 0; i < len; i++) {	',
'          var e = ml.elements[i];	if (e.name == "f01" ||	e.name == "f03" ||e.name == "f05" ||e.name == "f07" ||e.name == "f09" ||e.name == "f11" ||e.name == "f13" ||e.name == "f15" ) {		Clear(e);	}',
'        	}',
'        	ml.f01.checked = false;',
'    }',
'</script>'))
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(34485231095302983)
,p_plug_name=>'Wizard Steps'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(30094110886480012)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(34485806393302986)
,p_name=>'Result Parameters to Display'
,p_template=>wwv_flow_imp.id(42025417508627628)
,p_display_sequence=>150
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_region_attributes=>'style="width:100%; min-width:600px;"'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.checkbox(1,id,''title="''||wwv_flow_lang.system_message(''F4000.P765.SELECT_PARAM'',name)||''"'',:P882_CHECKED_ITEMS) x, ',
'       name, parm_type',
'  from wwv_flow_ws_parameters',
' where input_or_output = ''O''',
'   and ws_opers_id = :P700_OPERATION_ID and :P700_OUTPUT_TYPE != ''json'''))
,p_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the parameters to include in the report. To select or deselect all parameters, select the check box in the column header.</p>',
'<p>For JSON response you only need to supply the name of the collection to store the response.</p>',
''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No output parameters found or response is JSON.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>1000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(34486004340302986)
,p_query_column_id=>1
,p_column_alias=>'X'
,p_column_display_sequence=>1
,p_column_heading=>'#CHECK_ALL_CHECKBOX#'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(34486130346302986)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(34486205013302986)
,p_query_column_id=>3
,p_column_alias=>'PARM_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Parameter Type'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(204761317974217569)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>160
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(34486803108302987)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(204761317974217569)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(34487225180302988)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(204761317974217569)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(34487428901302989)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(204761317974217569)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(34489613335302999)
,p_branch_name=>'Skip Navigation Menu / Tabs'
,p_branch_action=>'f?p=&APP_ID.:735:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(34487225180302988)
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow_wizard_api.page_exists (p_flow_id => :fb_flow_id, p_page_id => :P705_PAGE_ID) = true'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(34490020741303000)
,p_branch_name=>'Navigation Menu / Tabs'
,p_branch_action=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.:RP:P4716_PREV_PAGE_ID:&APP_PAGE_ID.:'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(34487225180302988)
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(34489412567302999)
,p_branch_name=>'Go To Page 880'
,p_branch_action=>'f?p=&APP_ID.:880:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(34487428901302989)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(34488128291302991)
,p_name=>'P882_CHECKED_ITEMS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(34485806393302986)
,p_display_as=>'NATIVE_HIDDEN'
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(34510115867651363)
,p_name=>'P882_COLLECTION'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(34485806393302986)
,p_prompt=>'Store Results in Collection'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''P''||:P705_PAGE_ID||''_''||upper(name)||''_RESULTS''',
'  from wwv_flow_ws_operations',
' where id = :P700_OPERATION_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>40
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Enter the name of the temporary result set to store the document in.  The temporary result set is stored in an &PRODUCT_NAME. collection in the CLOB001 column using the name provided here.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(34488405250302992)
,p_computation_sequence=>10
,p_computation_item=>'P882_CHECKED_ITEMS'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_utilities.table_to_string(wwv_flow.g_f01)'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(34488609457302993)
,p_validation_name=>'P882_CHECKED_ITEMS'
,p_validation_sequence=>10
,p_validation=>'P882_CHECKED_ITEMS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'You must report on at least one parameter.'
,p_validation_condition=>':REQUEST in (''NEXT'',''FINISH'') and :P700_OUTPUT_TYPE != ''json'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(34488128291302991)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(549740177861954502)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(34486803108302987)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(549740213192954503)
,p_event_id=>wwv_flow_imp.id(549740177861954502)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1157780444509618649)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>20
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(34485806393302986)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1157780569612618650)
,p_event_id=>wwv_flow_imp.id(1157780444509618649)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(34488716382302996)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  i integer;',
'begin',
'  wwv_flow_collection.create_or_truncate_collection(''WS_ARRAY_PARMS'');',
'  for i in 1.. wwv_flow.g_f01.count loop',
'    wwv_flow_collection.add_member(',
'      p_collection_name => ''WS_ARRAY_PARMS'',',
'      p_c001            => wwv_flow.g_f01(i) );',
'  end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>34488716382302996
);
end;
/
prompt --application/pages/page_00883
begin
wwv_flow_imp_page.create_page(
 p_id=>883
,p_name=>'Conditional Validations'
,p_alias=>'CONDITIONAL-VALIDATIONS'
,p_step_title=>'Conditional Validations'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213220627333807318)
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(194569012468949016)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>91
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(186826132498329280)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(194569206617949017)
,p_plug_name=>'Validation Conditions'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>97
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select flow_step_id page, VALIDATION_NAME, ',
'validation_condition_type,',
'VALIDATION_CONDITION,',
'VALIDATION_CONDITION2,',
'id',
'from WWV_FLOW_STEP_VALIDATIONS',
'where FLOW_ID = :fb_flow_id and ',
'validation_condition_type is not null'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(194569432715949018)
,p_name=>'Validation Conditions'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194569509084949019)
,p_db_column_name=>'PAGE'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Page'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE#'
,p_column_linktext=>'#PAGE#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194569610218949020)
,p_db_column_name=>'VALIDATION_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Validation'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE##5510:#ID#'
,p_column_linktext=>'#VALIDATION_NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194569730953949020)
,p_db_column_name=>'VALIDATION_CONDITION_TYPE'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Condition Type'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(13602414170805697)
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194569803078949021)
,p_db_column_name=>'VALIDATION_CONDITION'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Expression 1'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194569912944949026)
,p_db_column_name=>'VALIDATION_CONDITION2'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Expression 2'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(100576178415284419)
,p_db_column_name=>'ID'
,p_display_order=>15
,p_column_identifier=>'F'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(194570026110949029)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1292709836536644'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'PAGE:VALIDATION_NAME:VALIDATION_CONDITION_TYPE:VALIDATION_CONDITION:VALIDATION_CONDITION2:ID'
,p_sort_column_1=>'PAGE'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(194570526842949031)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(194569206617949017)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:883:&SESSION.::&DEBUG.:883,RIR::'
);
end;
/
prompt --application/pages/page_00884
begin
wwv_flow_imp_page.create_page(
 p_id=>884
,p_name=>'Create Form on Web Service'
,p_alias=>'CREATE-FORM-ON-WEB-SERVICE'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Form on Web Service'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'advnc_web_services.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(34891102262899031)
,p_name=>'Items for Input Parameters'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.hidden(1, seq_id)||wwv_flow_item.hidden(2, c001)||wwv_flow_item.display_and_save(3, c002) name,',
'       wwv_flow_item.display_and_save(4, c003) parm_type, ',
'       wwv_flow_item.text(5, c004) item_name,',
'       wwv_flow_item.text(6, c005) item_label,',
'       wwv_flow_item.select_list_from_lov(7, c006, ''YES_NO_RETURNS_Y_OR_N'', null, ''NO'') include',
'  from wwv_flow_collections',
' where collection_name  = ''WS_INPUT_ITEMS'''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No input parameters for this service.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>1000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(34891521288899054)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(34891610471899057)
,p_query_column_id=>2
,p_column_alias=>'PARM_TYPE'
,p_column_display_sequence=>2
,p_column_heading=>'Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(34891723443899057)
,p_query_column_id=>3
,p_column_alias=>'ITEM_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Item Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(34891800425899057)
,p_query_column_id=>4
,p_column_alias=>'ITEM_LABEL'
,p_column_display_sequence=>4
,p_column_heading=>'Item Label'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(34891902533899057)
,p_query_column_id=>5
,p_column_alias=>'INCLUDE'
,p_column_display_sequence=>5
,p_column_heading=>'Create'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(34915405860878596)
,p_plug_name=>'Wizard Steps'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(15577802944637145)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(204727225911992852)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(268298157596420325)
,p_name=>'Items for output Parameters'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.hidden(11, seq_id)||wwv_flow_item.hidden(12, c001)||wwv_flow_item.display_and_save(13, c002) name,',
'       wwv_flow_item.display_and_save(14, c003) parm_type, ',
'       wwv_flow_item.text(15, c004) item_name,',
'       wwv_flow_item.text(16, c005) item_label,',
'       wwv_flow_item.select_list_from_lov(17, c006, ''YES_NO_RETURNS_Y_OR_N'', null, ''NO'') include',
'  from wwv_flow_collections',
' where collection_name = ''WS_OUTPUT_ITEMS'''))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P600_WEB_REF_TYPE != ''REST'' then',
'    for c1 in (select null',
'               from wwv_flow_collections',
'               where collection_name = ''WS_OUTPUT_ITEMS'')',
'    loop',
'        return true;',
'    end loop;',
'end if;',
'return false;'))
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'FUNCTION_BODY'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>200
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(268298473151420328)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(268298586757420329)
,p_query_column_id=>2
,p_column_alias=>'PARM_TYPE'
,p_column_display_sequence=>2
,p_column_heading=>'Parm type'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(268298693922420330)
,p_query_column_id=>3
,p_column_alias=>'ITEM_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Item name'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(268298735433420331)
,p_query_column_id=>4
,p_column_alias=>'ITEM_LABEL'
,p_column_display_sequence=>4
,p_column_heading=>'Item label'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(268298833957420332)
,p_query_column_id=>5
,p_column_alias=>'INCLUDE'
,p_column_display_sequence=>5
,p_column_heading=>'Include'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(280276082609341849)
,p_name=>'Items for output Parameters'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.hidden(11, seq_id)||wwv_flow_item.hidden(12, c001)||wwv_flow_item.display_and_save(13, c002) name,',
'       wwv_flow_item.display_and_save(14, c003) parm_type, ',
'       wwv_flow_item.text(15, c004) item_name,',
'       wwv_flow_item.text(16, c005) item_label,',
'       wwv_flow_item.select_list_from_lov(17, c006, ''YES_NO_RETURNS_Y_OR_N'', null, ''NO'') include',
'  from wwv_flow_collections',
' where collection_name = ''WS_OUTPUT_ITEMS'' and :P600_OUTPUT_TYPE != ''json'''))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P600_WEB_REF_TYPE = ''REST'' then',
'    return true;',
'end if;',
'return false;'))
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'FUNCTION_BODY'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>200
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'0'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(294925590197882202)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(294925683313882203)
,p_query_column_id=>2
,p_column_alias=>'PARM_TYPE'
,p_column_display_sequence=>2
,p_column_heading=>'Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(294925768210882204)
,p_query_column_id=>3
,p_column_alias=>'ITEM_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Item Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(294925801426882205)
,p_query_column_id=>4
,p_column_alias=>'ITEM_LABEL'
,p_column_display_sequence=>4
,p_column_heading=>'Item Label'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(294925960428882206)
,p_query_column_id=>5
,p_column_alias=>'INCLUDE'
,p_column_display_sequence=>5
,p_column_heading=>'Create'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(1136581154856333616)
,p_name=>'Basic Authentication'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.hidden(21, seq_id)||wwv_flow_item.hidden(22, c001)||wwv_flow_item.display_and_save(23, c002) name,',
'       wwv_flow_item.display_and_save(24, c003) parm_type, ',
'       wwv_flow_item.text(25, c004) item_name,',
'       wwv_flow_item.text(26, c005)||wwv_flow_item.hidden(27, c006) item_label',
'  from wwv_flow_collections',
' where collection_name = ''WS_AUTH_ITEMS'''))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''WS_AUTH_ITEMS'''))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1136581418880333619)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1136581598760333620)
,p_query_column_id=>2
,p_column_alias=>'PARM_TYPE'
,p_column_display_sequence=>2
,p_column_heading=>'Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1136581613488333621)
,p_query_column_id=>3
,p_column_alias=>'ITEM_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Item Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1136581751402333622)
,p_query_column_id=>4
,p_column_alias=>'ITEM_LABEL'
,p_column_display_sequence=>4
,p_column_heading=>'Item Label'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(34893116988899072)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(204727225911992852)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(34893314547899076)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(204727225911992852)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(34893523090899076)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(204727225911992852)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(34894431684899086)
,p_branch_action=>'f?p=&APP_ID.:703:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(34893314547899076)
,p_branch_sequence=>25
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''WS_AUTH_ITEMS'''))
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(294926495695882211)
,p_branch_name=>'Go To Page 600'
,p_branch_action=>'f?p=&APP_ID.:600:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(34893523090899076)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(294926113400882208)
,p_name=>'P884_RESPONSE_COLLECTION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(280276082609341849)
,p_prompt=>'Response Collection'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_display_when=>'P600_OUTPUT_TYPE'
,p_display_when2=>'json'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the name of the collection for the response.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(927693726038718450)
,p_validation_name=>'P884_RESPONSE_COLLECTION not null'
,p_validation_sequence=>10
,p_validation=>'P884_RESPONSE_COLLECTION'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'( :P600_WEB_REF_TYPE = ''REST'' ) and ( :P600_OUTPUT_TYPE = ''json'' )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(34893314547899076)
,p_associated_item=>wwv_flow_imp.id(294926113400882208)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1150182203403222902)
,p_validation_name=>'array input items, cannot create form'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- if WSDL, and contain same item name multiple times, this is array input item, raise validation',
'if :P600_WEB_REF_TYPE = ''NEW_SCHOOL'' then',
'    for c1 in (select count(*), c004',
'                 from wwv_flow_collections',
'                where collection_name = ''WS_INPUT_ITEMS''',
'                group by c004',
'               having count(*) > 1 )',
'    loop',
'        return false;',
'    end loop;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'The input parameters for this service require an array type which cannot be represented by creating items. You will not be able to use the wizard to create a form on this Web service reference.'
,p_when_button_pressed=>wwv_flow_imp.id(34893314547899076)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(549718717859753348)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(34893116988899072)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(549718847088753349)
,p_event_id=>wwv_flow_imp.id(549718717859753348)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(34893710601899078)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update input collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.update_members(',
'  p_collection_name      => ''WS_INPUT_ITEMS'',',
'  p_seq                  => wwv_flow.g_f01,',
'  p_c001                 => wwv_flow.g_f02,',
'  p_c002                 => wwv_flow.g_f03,',
'  p_c003                 => wwv_flow.g_f04,',
'  p_c004                 => wwv_flow.g_f05,',
'  p_c005                 => wwv_flow.g_f06,',
'  p_c006                 => wwv_flow.g_f07 );'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''WS_INPUT_ITEMS'''))
,p_process_when_type=>'EXISTS'
,p_internal_uid=>34893710601899078
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(617313606364937247)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update output collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.update_members(',
'  p_collection_name => ''WS_OUTPUT_ITEMS'',',
'  p_seq            => wwv_flow.g_f11,',
'  p_c001           => wwv_flow.g_f12,',
'  p_c002           => wwv_flow.g_f13,',
'  p_c003           => wwv_flow.g_f14,',
'  p_c004           => wwv_flow.g_f15,',
'  p_c005           => wwv_flow.g_f16,',
'  p_c006           => wwv_flow.g_f17 );'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''WS_OUTPUT_ITEMS'''))
,p_process_when_type=>'EXISTS'
,p_internal_uid=>617313606364937247
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1127760386939483961)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update auth collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.update_members(',
'  p_collection_name => ''WS_AUTH_ITEMS'',',
'  p_seq                  => wwv_flow.g_f21,',
'  p_c001                 => wwv_flow.g_f22,',
'  p_c002                 => wwv_flow.g_f23,',
'  p_c003                 => wwv_flow.g_f24,',
'  p_c004                 => wwv_flow.g_f25,',
'  p_c005                 => wwv_flow.g_f26,',
'  p_c006                 => wwv_flow.g_f27 );'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''WS_AUTH_ITEMS'''))
,p_process_when_type=>'EXISTS'
,p_internal_uid=>1127760386939483961
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1124190601999405685)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create form on ws'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  wwv_flow_wizard_api.create_form_on_ws (',
'    p_flow_id                 => :FB_FLOW_ID,',
'    p_page_id                 => :P605_PAGE_ID,',
'    p_ws_id                   => :P600_WS_ID,',
'    p_operation_id            => :P600_OPERATION_ID,',
'    p_page_name               => :P605_PAGE_NAME,',
'    p_group_name              => :P605_GROUP_NAME,',
'    p_page_mode               => :P605_PAGE_MODE,',
'    --',
'    p_tab_set                 => null,',
'    p_tab_name                => null,',
'    p_tab_text                => null,',
'    --',
'    p_region_title            => :P605_REGION_NAME,',
'    p_region_template         => :P605_REGION_TEMPLATE,    ',
'    p_inputs_collection       => ''WS_INPUT_ITEMS'',',
'    p_outputs_collection      => ''WS_OUTPUT_ITEMS'',',
'    p_auth_collection         => ''WS_AUTH_ITEMS'',',
'    p_report_collection_name  => :P884_RESPONSE_COLLECTION );',
'',
'  :fb_flow_page_id := :P605_PAGE_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(34893314547899076)
,p_internal_uid=>1124190601999405685
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1124191265052409526)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create breadcrumb'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_wizard_api.create_breadcrumb_region (',
'        p_application_id             => :FB_FLOW_ID,',
'        p_page_id                    => :P605_PAGE_ID,',
'        p_seq                        => 10,',
'        p_breadcrumb_id              => :P605_BREADCRUMB_ID,',
'        p_breadcrumb_entry_name      => nvl(:P605_BREADCRUMB_NAME, :P605_PAGE_NAME),',
'        p_parent_breadcrumb_entry_id => :P605_BREADCRUMB_PARENT_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(34893314547899076)
,p_internal_uid=>1124191265052409526
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1124190961199408020)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(34893314547899076)
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>1124190961199408020
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(34893913175899083)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate input item collection if REST'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    n   wwv_flow_global.vc_arr2;',
'    v   wwv_flow_global.vc_arr2;',
'begin',
'    n(1) := ''pg_id'';',
'    n(2) := ''op_id'';',
'    v(1) := :P605_PAGE_ID;',
'    v(2) := :P600_OPERATION_ID;',
'',
'wwv_flow_collection.create_collection_from_query_b(',
'    p_collection_name => ''WS_INPUT_ITEMS'',',
'    p_query           => ''select a.id, decode(a.input_or_output,''''I'''',a.name,''''header:''''||a.name) name, a.parm_type,',
'''''P''''||:pg_id||''''_''''||upper(a.name), initcap(a.name), ''''Y'''' yes_no from wwv_flow_ws_parameters a where a.input_or_output in (''''I'''',''''H'''') and a.ws_opers_id = :op_id order by a.input_or_output, a.id'',',
'    p_names           => n,',
'    p_values          => v);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'not wwv_flow_collection.collection_exists(''WS_INPUT_ITEMS'') and :P600_WEB_REF_TYPE = ''REST'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>34893913175899083
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(268297830369420322)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate input item collection if  WSDL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    n   wwv_flow_global.vc_arr2;',
'    v   wwv_flow_global.vc_arr2;',
'begin',
'    n(1) := ''pg_id'';',
'    n(2) := ''op_id'';',
'    v(1) := :P605_PAGE_ID;',
'    v(2) := :P600_OPERATION_ID;',
'',
'    wwv_flow_collection.create_collection_from_query_b(',
'        p_collection_name => ''WS_INPUT_ITEMS'',',
'        p_query           => ''select id, name, parm_type,',
'''''P''''||:pg_id||''''_''''||upper(name), initcap(name), ''''Y'''' y_or_n from wwv_flow_ws_parameters where input_or_output in (''''I'''',''''H'''') and type_is_xsd = ''''Y'''' and ws_opers_id = :op_id order by input_or_output, id'',',
'    p_names           => n,',
'    p_values          => v);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'not wwv_flow_collection.collection_exists(''WS_INPUT_ITEMS'') and :P600_WEB_REF_TYPE = ''NEW_SCHOOL'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>268297830369420322
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(268297988331420323)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate input item collection if  Manual'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_clob  clob;',
'    l_off   number := 1;',
'    l_pos   number := 0;',
'    l_name  varchar2(4000);',
'    l_item_name varchar2(4000);',
'begin',
'',
'    wwv_flow_collection.create_or_truncate_collection(',
'        p_collection_name => ''WS_INPUT_ITEMS'');',
'',
'    for c1 in (select flow_items_comma_delimited',
'                 from wwv_flow_shared_web_services',
'                where id = :P600_WS_ID ) loop',
'        l_clob := c1.flow_items_comma_delimited;',
'    end loop;',
'',
'    l_pos   := sys.dbms_lob.instr(l_clob,'','',1);',
'',
'    if l_pos = 0 then --there are no commas at all',
'        if sys.dbms_lob.getlength(l_clob) > 0 then',
'            l_name := sys.dbms_lob.substr(l_clob,sys.dbms_lob.getlength(l_clob),1);',
'            l_item_name := ''P''||:P605_PAGE_ID||''_''||l_name;',
'            wwv_flow_collection.add_member(',
'                p_collection_name   => ''WS_INPUT_ITEMS'',',
'                p_c001              => ''MANUAL'',',
'                p_c002              => l_name,',
'                p_c003              => ''string'',',
'                p_c004              => upper(l_item_name ),',
'                p_c005              => initcap(l_name),',
'                p_c006              => ''Y'' );',
'        end if;',
'    else',
'        loop',
'            exit when l_pos = 0;',
'',
'            l_name := sys.dbms_lob.substr(l_clob,l_pos-l_off,l_off);',
'            l_item_name := ''P''||:P605_PAGE_ID||''_''||l_name;',
'            wwv_flow_collection.add_member(',
'                p_collection_name   => ''WS_INPUT_ITEMS'',',
'                p_c001              => ''MANUAL'',',
'                p_c002              => l_name,',
'                p_c003              => ''string'',',
'                p_c004              => upper(l_item_name ),',
'                p_c005              => initcap(l_name),',
'                p_c006              => ''Y'' );',
'            l_off := l_pos + 1;',
'            l_pos := sys.dbms_lob.instr(l_clob,'','',l_off);',
'        end loop;',
'        --need to get the last one',
'        l_name := sys.dbms_lob.substr(l_clob,4000,l_off);',
'        l_item_name := ''P''||:P605_PAGE_ID||''_''||l_name;',
'        wwv_flow_collection.add_member(',
'            p_collection_name   => ''WS_INPUT_ITEMS'',',
'            p_c001              => ''MANUAL'',',
'            p_c002              => l_name,',
'            p_c003              => ''string'',',
'            p_c004              => upper(l_item_name),',
'            p_c005              => initcap(l_name),',
'            p_c006              => ''Y'' );',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'not wwv_flow_collection.collection_exists(''WS_INPUT_ITEMS'') and :P600_WEB_REF_TYPE = ''MANUAL'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>268297988331420323
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(34894117033899083)
,p_process_sequence=>70
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate auth item collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    n   wwv_flow_global.vc_arr2;',
'    v   wwv_flow_global.vc_arr2;',
'begin',
'    n(1) := ''pg_id'';',
'    n(2) := ''ws_id'';',
'    v(1) := :P605_PAGE_ID;',
'    v(2) := :P600_WS_ID;',
'    ',
'    wwv_flow_collection.create_collection_from_query_b(',
'        p_collection_name => ''WS_AUTH_ITEMS'',',
'        p_query           => ''select a.id, decode(a.name,''''username'''',wwv_flow_lang.system_message(''''ACCESS_CONTROL_USERNAME''''),''''password'''',wwv_flow_lang.system_message(''''PASSWORD''''),a.name), wwv_flow_lang.system_message(''''AUTHENTICATION''''),',
'''''P''''||:pg_id||''''_''''||upper(decode(a.name,''''username'''',wwv_flow_lang.system_message(''''ACCESS_CONTROL_USERNAME''''),''''password'''',wwv_flow_lang.system_message(''''PASSWORD''''),a.name)), decode(a.name,''''username'''',wwv_flow_lang.system_message(''''ACCESS_CONTRO'
||'L_USERNAME''''),''''password'''',wwv_flow_lang.system_message(''''PASSWORD''''),a.name), ''''Y'''' y_or_n from wwv_flow_ws_parameters a, wwv_flow_ws_operations b, wwv_flow_shared_web_services c where input_or_output = ''''A'''' and a.ws_opers_id = b.id and b.ws_id = c'
||'.id and c.id = :ws_id order by a.name desc'',',
'    p_names           => n,',
'    p_values          => v);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'not wwv_flow_collection.collection_exists(''WS_AUTH_ITEMS'')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>34894117033899083
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(280275959156341848)
,p_process_sequence=>80
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate outputs collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    n   wwv_flow_global.vc_arr2;',
'    v   wwv_flow_global.vc_arr2;',
'begin',
'    n(1) := ''pg_id'';',
'    n(2) := ''op_id'';',
'    v(1) := :P605_PAGE_ID;',
'    v(2) := :P600_OPERATION_ID;',
'   ',
'	if :P600_WEB_REF_TYPE = ''REST'' then',
'		wwv_flow_collection.create_collection_from_query_b(',
'			p_collection_name => ''WS_OUTPUT_ITEMS'',',
'			p_query           => ''select id, name, parm_type,',
'	''''P''''||:pg_id||''''_''''||upper(name), initcap(name), ''''Y'''' y_or_n from wwv_flow_ws_parameters where input_or_output = ''''O'''' and ws_opers_id = :op_id and parm_type!= ''''json'''''',',
'		p_names           => n,',
'		p_values          => v);',
'    else',
'		wwv_flow_collection.create_collection_from_query_b(',
'			p_collection_name => ''WS_OUTPUT_ITEMS'',',
'			p_query           => ''select id, name, parm_type,',
'	''''P''''||:pg_id||''''_''''||upper(name), initcap(name), ''''Y'''' y_or_n from wwv_flow_ws_parameters where input_or_output = ''''O'''' and type_is_xsd = ''''Y'''' and ws_opers_id = :op_id'',',
'		p_names           => n,',
'		p_values          => v);	',
'	end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'not wwv_flow_collection.collection_exists(''WS_OUTPUT_ITEMS'')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>280275959156341848
);
end;
/
prompt --application/pages/page_00885
begin
wwv_flow_imp_page.create_page(
 p_id=>885
,p_name=>'Conditional Branches'
,p_alias=>'CONDITIONAL-BRANCHES'
,p_step_title=>'Conditional Branches'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213220627333807318)
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(194579329745010939)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>91
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(11286824340344465)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(194582805564026135)
,p_plug_name=>'Branch Conditions'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>125
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select flow_step_id page, BRANCH_POINT, ',
'       BRANCH_TYPE, ',
'       BRANCH_SEQUENCE,',
'       branch_name,',
'BRANCH_CONDITION_TYPE,',
'BRANCH_CONDITION,',
'BRANCH_CONDITION_TEXT,',
'id',
'from WWV_FLOW_STEP_BRANCHES',
'where FLOW_ID = :fb_flow_id and',
'branch_condition_type is not null'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(194582923422026135)
,p_name=>'Branch Conditions'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194583115017026136)
,p_db_column_name=>'PAGE'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Page'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE#'
,p_column_linktext=>'#PAGE#'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194583219719026137)
,p_db_column_name=>'BRANCH_POINT'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Branch Point'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194583315654026138)
,p_db_column_name=>'BRANCH_TYPE'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Branch Type'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194583427780026139)
,p_db_column_name=>'BRANCH_SEQUENCE'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Sequence'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE##5540:#ID#'
,p_column_linktext=>'#BRANCH_SEQUENCE#'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194583528981026140)
,p_db_column_name=>'BRANCH_CONDITION_TYPE'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Condition Type'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194583603591026141)
,p_db_column_name=>'BRANCH_CONDITION'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Expression 1'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(194583726392026141)
,p_db_column_name=>'BRANCH_CONDITION_TEXT'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Expression 2'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(16751417190389279)
,p_db_column_name=>'BRANCH_NAME'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Branch Name'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE##5540:#ID#'
,p_column_linktext=>'#BRANCH_NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(100576721324284425)
,p_db_column_name=>'ID'
,p_display_order=>18
,p_column_identifier=>'I'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(194584032174027317)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1292824425536644'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'PAGE:BRANCH_POINT:BRANCH_SEQUENCE:BRANCH_NAME:BRANCH_TYPE:BRANCH_CONDITION_TYPE:BRANCH_CONDITION:BRANCH_CONDITION_TEXT::ID'
,p_sort_column_1=>'PAGE'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'BRANCH_POINT'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'BRANCH_SEQUENCE'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(194579700694010940)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(194582805564026135)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:885:&SESSION.::&DEBUG.:885,RIR::'
);
end;
/
prompt --application/pages/page_00887
begin
wwv_flow_imp_page.create_page(
 p_id=>887
,p_name=>'Supporting Objects - Add Database Object'
,p_alias=>'SUPPORTING-OBJECTS-ADD-DATABASE-OBJECT'
,p_page_mode=>'MODAL'
,p_step_title=>'Supporting Objects - Add Database Object'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(24897722063538624)
,p_step_template=>wwv_flow_imp.id(120871216744825711)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'No help is available for this page.'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(537841333876118535)
,p_plug_name=>'Add Database Object'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(537842656900118548)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(616090510052666313)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(537842656900118548)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(616091084340716088)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(537842656900118548)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Object'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(537841474050118536)
,p_name=>'P887_OBJECT_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(537841333876118535)
,p_prompt=>'Object Owner:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the owner of the database object.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(537841565766118537)
,p_name=>'P887_OBJECT_TYPE'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(537841333876118535)
,p_prompt=>'Object Type'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct object_type d, object_type r',
'  from sys.dba_objects',
' where object_type in (''FUNCTION'',''INDEX'',''PACKAGE'',''PROCEDURE'',''SEQUENCE'',''SYNONYM'',''TABLE'',''TRIGGER'',''VIEW'',''DATABASE LINK'',''TYPE'',''MATERIALIZED VIEW'')',
'   and owner = :P887_OBJECT_OWNER',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'-- Select Object Type --'
,p_cSize=>64
,p_cHeight=>1
,p_read_only_when=>'P865_SCRIPT_OPTION'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select an object type from the list.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(537841651115118538)
,p_name=>'P887_OBJECT_NAME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(537841333876118535)
,p_prompt=>'Object Name'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name r',
'  from sys.dba_objects a',
' where object_name not like ''SYS_%''',
'   and object_name not like ''APEX$_%''',
'   and owner = :P887_OBJECT_OWNER',
'   and object_type = :P887_OBJECT_TYPE',
'   and not exists (select 1',
'                     from wwv_flow_collections',
'                    where collection_name = ''INSTALL_OBJECTS''',
'                      and c002 = :P887_OBJECT_OWNER',
'                      and c003 = :P887_OBJECT_TYPE',
'                      and c004 = a.object_name',
'                      and nvl(c005,''0'') <> ''1'')',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'-- Select Object --'
,p_lov_cascade_parent_items=>'P887_OBJECT_TYPE'
,p_ajax_items_to_submit=>'P887_OBJECT_OWNER,P887_OBJECT_TYPE'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>64
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select an object from the list.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(621102498116076421)
,p_computation_sequence=>10
,p_computation_item=>'P887_OBJECT_TYPE'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if instr(:P865_SCRIPT_OPTION,''PACKAGE'') = 1 then',
'    return ''PACKAGE'';',
'elsif :P865_SCRIPT_OPTION = ''TABLE'' then',
'    return ''TABLE'';',
'else',
'    return null;',
'end if;'))
,p_compute_when=>'P865_SCRIPT_OPTION'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(537842288189118544)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(616090510052666313)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(537842345883118545)
,p_event_id=>wwv_flow_imp.id(537842288189118544)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(537841985859118541)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add object to collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_code         clob;',
'    l_object_types varchar2(32767);',
'    l_objects      varchar2(32767);',
'begin',
'',
'    wwv_flow_collection.add_member(',
'        p_collection_name => ''INSTALL_OBJECTS'',',
'        p_c001            => ''1'',',
'        p_c002            => :P887_OBJECT_OWNER,',
'        p_c003            => :P887_OBJECT_TYPE,',
'        p_c004            => :P887_OBJECT_NAME );',
'    ',
'    wwv_flow_collection.create_or_truncate_collection(',
'        p_collection_name => ''INSTALL_SCRIPT_ORIG'');',
'',
'    for c1 in (select distinct c003 object_type',
'                 from wwv_flow_collections',
'                where collection_name = ''INSTALL_OBJECTS''',
'                  and nvl(c005,''0'')= ''0'' ) loop',
'        l_object_types := l_object_types||c1.object_type||'':'';',
'    end loop;',
'    for c1 in (select c004 object_name',
'                 from wwv_flow_collections',
'                where collection_name = ''INSTALL_OBJECTS''',
'                  and nvl(c005,''0'')=''0'' ) loop',
'        l_objects := l_objects||c1.object_name||'':'';',
'    end loop;',
'    ',
'    if nvl(:P865_SCRIPT_OPTION,''x'') in (''PACKAGE_SPEC'',''PACKAGE_BODY'') then',
'        l_object_types := :P865_SCRIPT_OPTION;',
'    else',
'        l_object_types := rtrim(l_object_types,'':'');',
'    end if;        ',
'',
'    l_code := wwv_flow_generate_ddl.get_ddl_supporting_objects(',
'                      p_schema      => :P865_OBJECT_OWNER,',
'                      p_object_type => l_object_types,',
'                      p_objects     => rtrim(l_objects,'':''));',
'',
'    wwv_flow_collection.add_member(',
'        p_collection_name => ''INSTALL_SCRIPT_ORIG'',',
'        p_clob001         => l_code);',
'                ',
'end;        '))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(616091084340716088)
,p_process_success_message=>'Object added to script.'
,p_internal_uid=>537841985859118541
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(621033740192190310)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(616091084340716088)
,p_internal_uid=>621033740192190310
);
end;
/
prompt --application/pages/page_00888
begin
wwv_flow_imp_page.create_page(
 p_id=>888
,p_name=>'Text Messages - Grid Edit'
,p_alias=>'TEXT-MESSAGES-GRID-EDIT'
,p_step_title=>'Text Messages - Grid Edit'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213331522315193801)
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'No help is available for this page.'
,p_page_component_map=>'21'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2611833489441805)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use this page to grid edit text messages data or to bulk refresh text messages.</p><p> When Text Message is subscribed, then it is not possible to change any data.</p>',
'<p>Deletion of the <strong>master</strong> text message automatically clears the text message references from subscribing text messages.</p>',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2703891551095236)
,p_plug_name=>'Text Messages'
,p_region_name=>'subscribed_text_messages'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       flow_id,',
'       name,',
'       message_language,',
'       message_text,',
'       is_js_message,',
'       reference_id,',
'       message_comment',
'  from wwv_flow_messages$',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_plug_source_type=>'NATIVE_IG'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Text Messages'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
,p_landmark_label=>'Grid Edit Text Messages'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2611912920441806)
,p_name=>'REFERENCE_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'REFERENCE_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Subscribed From'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>100
,p_value_alignment=>'LEFT'
,p_attribute_02=>'LOV'
,p_attribute_05=>'PLAIN'
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(2620983194638992)
,p_lov_display_extra=>true
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2612526998441812)
,p_name=>'ALLOWED_OPERATIONS'
,p_source_type=>'SQL_EXPRESSION'
,p_source_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case   ',
'    when reference_id is null then',
'        case ',
'            when wwv_flow_component_group_dev.is_part_of_comp_grp_yn (',
'                     p_component_id   => ID,',
'                     p_component_type => ''MESSAGE'',',
'                     p_app_id         => FLOW_ID ) = ''Y'' then ''U''',
'            else ''UD''',
'        end',
'    when reference_id is not null ',
'     and wwv_flow_component_group_dev.is_part_of_comp_grp_yn (',
'             p_component_id   => ID,             ',
'             p_component_type => ''MESSAGE'',',
'             p_app_id         => FLOW_ID ) = ''N'' then',
'        ''D''',
'end'))
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>110
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2704054272095238)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>30
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2704251449095240)
,p_name=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Message'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>40
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_max_length=>255
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>true
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>'Enter a unique name for the message you are creating.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2704318157095241)
,p_name=>'MESSAGE_LANGUAGE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'MESSAGE_LANGUAGE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_POPUP_LOV'
,p_heading=>'Language'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>50
,p_value_alignment=>'LEFT'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'Y'
,p_attribute_06=>'0'
,p_is_required=>true
,p_max_length=>50
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(107899321117195063)
,p_lov_display_extra=>true
,p_lov_display_null=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_static_id=>'c_language'
,p_use_as_row_header=>true
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>'Select a language for which this message will be used.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2704487822095242)
,p_name=>'MESSAGE_TEXT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'MESSAGE_TEXT'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Text'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>60
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>true
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_static_id=>'c_text'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the text to be returned when this text message is called.</p>',
'<p>Example: Tax: %0 Total amount %1',
'</p>'))
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2704599582095243)
,p_name=>'IS_JS_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'IS_JS_MESSAGE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Used in JavaScript'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>70
,p_value_alignment=>'LEFT'
,p_is_required=>true
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(84259319526460470)
,p_lov_display_extra=>false
,p_lov_display_null=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'N'
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>'Select <strong>Yes</strong> if the message is used in <code>apex.lang.*</code> API calls in JavaScript code.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2705188388095249)
,p_name=>'MESSAGE_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'MESSAGE_COMMENT'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>80
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2705213737095250)
,p_name=>'APEX$ROW_ACTION'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>20
,p_use_as_row_header=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(4900475857688501)
,p_name=>'APEX$ROW_SELECTOR'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_use_as_row_header=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(4900989608688506)
,p_name=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FLOW_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Application'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>90
,p_value_alignment=>'LEFT'
,p_attribute_02=>'LOV'
,p_attribute_05=>'PLAIN'
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(138126827261)
,p_lov_display_extra=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'&FB_FLOW_ID.'
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>'This attribute identifies the current application.'
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(2703954144095237)
,p_internal_uid=>2703954144095237
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_edit_row_operations_column=>'ALLOWED_OPERATIONS'
,p_lost_update_check_type=>'VALUES'
,p_add_row_if_empty=>false
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SET'
,p_show_total_row_count=>true
,p_show_toolbar=>true
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>true
,p_define_chart_view=>true
,p_enable_download=>true
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(4880703591630918)
,p_interactive_grid_id=>wwv_flow_imp.id(2703954144095237)
,p_static_id=>'48808'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(4880978090630919)
,p_report_id=>wwv_flow_imp.id(4880703591630918)
,p_view_type=>'GRID'
,p_stretch_columns=>true
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(299704657174983)
,p_view_id=>wwv_flow_imp.id(4880978090630919)
,p_display_seq=>6
,p_column_id=>wwv_flow_imp.id(4900989608688506)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2625033186748353)
,p_view_id=>wwv_flow_imp.id(4880978090630919)
,p_display_seq=>13
,p_column_id=>wwv_flow_imp.id(2611912920441806)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2626131271770389)
,p_view_id=>wwv_flow_imp.id(4880978090630919)
,p_display_seq=>14
,p_column_id=>wwv_flow_imp.id(2612526998441812)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(4881450021630926)
,p_view_id=>wwv_flow_imp.id(4880978090630919)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(2704054272095238)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(4883150881630935)
,p_view_id=>wwv_flow_imp.id(4880978090630919)
,p_display_seq=>2
,p_column_id=>wwv_flow_imp.id(2704251449095240)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>300
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(4884039512630937)
,p_view_id=>wwv_flow_imp.id(4880978090630919)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(2704318157095241)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>250
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(4884955763630940)
,p_view_id=>wwv_flow_imp.id(4880978090630919)
,p_display_seq=>4
,p_column_id=>wwv_flow_imp.id(2704487822095242)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(4885884575630943)
,p_view_id=>wwv_flow_imp.id(4880978090630919)
,p_display_seq=>5
,p_column_id=>wwv_flow_imp.id(2704599582095243)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>120
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(4891209318630958)
,p_view_id=>wwv_flow_imp.id(4880978090630919)
,p_display_seq=>12
,p_column_id=>wwv_flow_imp.id(2705188388095249)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(4906414978694550)
,p_view_id=>wwv_flow_imp.id(4880978090630919)
,p_display_seq=>0
,p_column_id=>wwv_flow_imp.id(2705213737095250)
,p_is_visible=>true
,p_is_frozen=>true
,p_width=>50
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4901514894688512)
,p_tabular_form_region_id=>wwv_flow_imp.id(2703891551095236)
,p_validation_name=>'NAME must be unique within app'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_messages$',
' where upper(NAME)       = upper(:NAME)',
'   and message_language  = :MESSAGE_LANGUAGE',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   -- while updating ignore current row',
'   -- while inseting consider all rows',
'   and (id != :ID or :ID is null)'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Message name must be unique'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1401754141151303)
,p_name=>'update language '
,p_event_sequence=>10
,p_triggering_element_type=>'COLUMN'
,p_triggering_region_id=>wwv_flow_imp.id(2703891551095236)
,p_triggering_element=>'MESSAGE_LANGUAGE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1401801916151304)
,p_event_id=>wwv_flow_imp.id(1401754141151303)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.item("c_text").element.attr("lang",$v("c_language"));',
''))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4900597564688502)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(2703891551095236)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Grid Edit Text Messages - Save Interactive Grid Data'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Text messages changes are saved.'
,p_internal_uid=>4900597564688502
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4643948008749483)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(2703891551095236)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Clear Subscriptions'
,p_attribute_01=>'PLSQL_CODE'
,p_attribute_04=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :APEX$ROW_STATUS = ''D'' then',
'    wwv_flow_copy_metadata.clear_subscriptions (',
'        p_component_type => wwv_flow_copy_metadata.c_message,',
'        p_master_id      => :ID );',
'end if;'))
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>4643948008749483
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4901611953688513)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_region_id=>wwv_flow_imp.id(2703891551095236)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Calculate IS_JS_MESSAGE'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_is_js_message wwv_flow_messages$.is_js_message%type;',
'begin',
'    -- check if the name matches with one of the APEX system messages,',
'    -- in that case we use the same is_js_message setting because the',
'    -- developer just wants provide a different text message in their app.',
'    select is_js_message',
'      into l_is_js_message',
'      from wwv_flow_messages$',
'     where flow_id           = 4411',
'       and security_group_id = 10',
'       and name              = :NAME;',
'',
'    :IS_JS_MESSAGE := l_is_js_message;',
'exception when no_data_found then ',
'    -- do nothing',
'    null;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'FB_FLOW_ID'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_process_when2=>'4411'
,p_exec_cond_for_each_row=>'Y'
,p_internal_uid=>4901611953688513
);
end;
/
prompt --application/pages/page_00889
begin
wwv_flow_imp_page.create_page(
 p_id=>889
,p_name=>'Attribute Dictionary'
,p_alias=>'ATTRIBUTE-DICTIONARY'
,p_step_title=>'Attribute Dictionary'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(261841008861828406)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'mg_attribute_dict.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(253941101711283063)
,p_plug_name=>'Attribute Dictionary'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>You can use Page Item and Report Column definitions to update the Attribute Dictionary. You can also use the Attribute Dictionary to update Page Items and Report Columns.</p>',
'',
'<p>Hidden objects, those in hidden regions and button items are not counted in the number of candidate Items and Report Columns as these are not used in the updates.</p>',
'',
'<p>Select the page that you wish to work with.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(253961620789367687)
,p_plug_name=>'Select Page'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       the_flow,',
'       name,',
'       updated,',
'       last_updated_by,',
'       created_on,',
'       nvl(group_name,sm.t_unassigned) group_name,',
'       page_type,',
'       alias,',
'       page_title,',
'       nbr_items,',
'       nbr_report_cols',
'  from (select p.id,',
'               p.flow_id the_flow,',
'               name,',
'               last_updated_on updated,',
'               lower(last_updated_by) last_updated_by,',
'               created_on,',
'               g.group_name,',
'               page_component_map,',
'               alias,',
'               step_title page_title,',
'               p.page_type,',
'               (select count(*)',
'                  from wwv_flow_step_items i,',
'                       wwv_flow_page_plugs r',
'                 where nvl(i.display_when_type,''disp'') != ''NEVER''',
'                   and i.display_as not in (''NATIVE_HIDDEN'',''NATIVE_STOP_AND_START_HTML_TABLE'')',
'                   and i.security_group_id  = :FLOW_SECURITY_GROUP_ID',
'                   and i.flow_id            = p.flow_id',
'                   and i.flow_step_id       = p.id',
'                   and i.item_plug_id       = r.id',
'                   and nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'                   and r.security_group_id  = :FLOW_SECURITY_GROUP_ID',
'                   and r.flow_id            = p.flow_id',
'                   and r.page_id            = p.id) nbr_items,',
'               (select count(*)',
'                  from wwv_flow_region_report_column rc,',
'                       wwv_flow_page_plugs r',
'                 where rc.hidden_column = ''N''',
'                   and nvl(rc.display_when_cond_type,''disp'') != ''NEVER''',
'                   and rc.security_group_id = :FLOW_SECURITY_GROUP_ID',
'                   and rc.flow_id           = p.flow_id',
'                   and rc.region_id         = r.id',
'                   and nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'                   and r.security_group_id  = :FLOW_SECURITY_GROUP_ID',
'                   and r.flow_id            = p.flow_id',
'                   and r.page_id            = p.id',
'                   and substr(rc.column_alias,1,6) != ''CHECK$''',
'                   and substr(rc.column_alias,1,5) != ''LINK$''',
'                   and substr(rc.column_alias,1,8) != ''DERIVED$'') +',
'               (select count(*)',
'                  from wwv_flow_worksheet_columns wc,',
'                       wwv_flow_worksheets w,',
'                       wwv_flow_page_plugs r',
'                 where nvl(wc.display_text_as,''disp'') != ''HIDDEN''',
'                   and wc.security_group_id = :FLOW_SECURITY_GROUP_ID',
'                   and wc.flow_id           = p.flow_id',
'                   and wc.worksheet_id      = w.id',
'                   and w.security_group_id  = :FLOW_SECURITY_GROUP_ID',
'                   and w.flow_id            = p.flow_id',
'                   and w.page_id            = p.id',
'                   and w.region_id          = r.id',
'                   and nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'                   and r.security_group_id  = :FLOW_SECURITY_GROUP_ID',
'                   and r.flow_id            = p.flow_id',
'                   and r.page_id            = p.id) nbr_report_cols',
'          from wwv_flow_pages_dev p,',
'               wwv_flow_page_groups g',
'         where p.flow_id           = :FB_FLOW_ID',
'           and p.security_group_id = :FLOW_SECURITY_GROUP_ID',
'           and p.group_id          = g.id (+)),',
'       (select wwv_flow_lang.system_message(''Unassigned'') t_unassigned',
'          from dual) sm'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(253961723059367687)
,p_name=>'Select Page'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(253962024170367721)
,p_db_column_name=>'THE_FLOW'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>'The Flow'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(253961902109367715)
,p_db_column_name=>'ID'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>'Page'
,p_column_link=>'f?p=&APP_ID.:912:&SESSION.::&DEBUG.:912:FB_FLOW_PAGE_ID:#ID#'
,p_column_linktext=>'#ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(253962129492367722)
,p_db_column_name=>'NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(253962217597367722)
,p_db_column_name=>'UPDATED'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(253962332108367723)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(253962427376367724)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Created'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(253962528841367725)
,p_db_column_name=>'GROUP_NAME'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Group Name'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(253962620482367726)
,p_db_column_name=>'PAGE_TYPE'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Page Type'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(253962712422367730)
,p_db_column_name=>'ALIAS'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Alias'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(253962818123367731)
,p_db_column_name=>'PAGE_TITLE'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Page Title'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(428474402993209453)
,p_db_column_name=>'NBR_ITEMS'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Displayed Items'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(428474532345209455)
,p_db_column_name=>'NBR_REPORT_COLS'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Displayed Report Columns'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(253963809229374878)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1292903499536644'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'ID:NAME:PAGE_TYPE:GROUP_NAME:NBR_ITEMS:NBR_REPORT_COLS'
,p_sort_column_1=>'ID'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(261840224876814137)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(253961620789367687)
,p_button_name=>'RESET_REPORT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:889:&SESSION.::&DEBUG.:889,RIR::'
);
end;
/
prompt --application/pages/page_00890
begin
wwv_flow_imp_page.create_page(
 p_id=>890
,p_name=>'Update using Items'
,p_alias=>'UPDATE-USING-ITEMS'
,p_step_title=>'Update using Items'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(261841008861828406)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'mg_attribute_dict.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(253942829341283227)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>100
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(254039201964848724)
,p_name=>'Matched Items'
,p_template=>wwv_flow_imp.id(208928010704475743)
,p_display_sequence=>130
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select htmldb_item.checkbox(1,i.id||'',''||ad.column_id) chk,',
'       m.region ||'': ''|| r.plug_name region_name,',
'       --',
'       i.id i_id, ',
'       i.name i_name, ',
'       i.prompt i_label,',
'       case when length(h.help_text) > 20',
'             then ''<a href="''||htmldb_util.prepare_url(''f?p=4000:908:''||:APP_SESSION||',
'                  '':::908:P908_DISPLAY,P908_ID:IH,''||i.id)||''" alt="''||wwv_flow_escape.html(m.v||''" title="''||m.v)||''">''||wwv_flow_escape.html(substr(h.help_text,1,20))||''...</a>''',
'              else wwv_flow_escape.html(h.help_text)',
'              end i_help_text,',
'       i.format_mask i_format_mask,',
'       case when length(i.item_default) > 20',
'            then ''<a href="''||htmldb_util.prepare_url(''f?p=4000:908:''||:APP_SESSION||',
'                 '':::908:P908_DISPLAY,P908_ID:ID,''||i.id)||''" alt="''||wwv_flow_escape.html(m.v||''" title="''||m.v)||''">''||wwv_flow_escape.html(substr(i.item_default,1,20))||''...</a>''',
'            else wwv_flow_escape.html(i.item_default)',
'            end i_default,',
'       --',
'       i.format_mask i_format_mask2,',
'       i.cSize i_width,',
'       i.cHeight i_height,',
'       i.data_type i_data_type,',
'       --',
'       m.a from_ad,',
'       ad.column_id c_column_id,',
'       ads.syn_name c_column_name,',
'       ad.label c_label,',
'       case when length(ad.help_text) > 20',
'            then ''<a href="''||htmldb_util.prepare_url(''f?p=4000:908:''||:APP_SESSION||',
'                 '':::908:P908_DISPLAY,P908_ID:ADH,''||ad.column_id)||''" alt="''||wwv_flow_escape.html(m.v||''" title="''||m.v)||''">''||wwv_flow_escape.html(substr(ad.help_text,1,20))||''...</a>''',
'            else ad.help_text',
'            end c_help_text,',
'       ad.format_mask c_format_mask,',
'       case when length(ad.default_value) > 20',
'            then ''<a href="''||htmldb_util.prepare_url(''f?p=4000:908:''||:APP_SESSION||',
'                 '':::908:P908_DISPLAY,P908_ID:ADD,''||ad.column_id)||''" alt="''||wwv_flow_escape.html(m.v||''" title="''||m.v)||''">''||wwv_flow_escape.html(substr(ad.default_value,1,20))||''...</a>''',
'            else ad.default_value',
'            end c_default_value,',
'       --',
'       ad.form_format_mask c_form_format_mask,',
'       ad.form_display_width c_form_display_width,',
'       ad.form_display_height c_form_display_height,',
'       ad.form_data_type c_form_data_type,',
'       --',
'       case when upper(substr(i.name,1,2)) in (''P1'',''P2'',''P3'',''P4'',''P5'',''P6'',''P7'',''P8'',''P9'')',
'            then substr(i.name,instr(i.name,''_'')+1)',
'            else i.name',
'            end check_name',
'  from wwv_flow_page_plugs r,',
'       wwv_flow_step_items i,',
'       wwv_flow_step_item_help h,',
'       wwv_flow_hnt_column_dict ad,',
'       wwv_flow_hnt_col_dict_syn ads,',
'       (select wwv_flow_lang.system_message(''FROM_ATTRIBUTE_DICTIONARY'') a,',
'               wwv_flow_lang.system_message(''VIEW_FOR_ALT_TAG'') v,',
'               wwv_flow_lang.system_message(''UI_DEF_CUSTOM_ITEM_TYPE'') ct,',
'               wwv_flow_lang.system_message(''APEX_REGION'') region',
'               from dual) m',
' where nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'   and r.security_group_id  = :flow_security_group_id',
'   and r.flow_id            = :FB_FLOW_ID',
'   and r.page_id            = :FB_FLOW_PAGE_ID',
'   and r.id                 = i.item_plug_id',
'   and nvl(i.display_when_type,''disp'') != ''NEVER''',
'   and i.display_as not in (''NATIVE_HIDDEN'',''NATIVE_STOP_AND_START_HTML_TABLE'')',
'   and i.security_group_id  = :flow_security_group_id',
'   and i.flow_id            = :FB_FLOW_ID',
'   and i.flow_step_id       = :FB_FLOW_PAGE_ID',
'   and h.flow_item_id (+)   = i.id',
'   and ad.security_group_id = :flow_security_group_id',
'   and ad.column_id         = ads.column_id',
'   and ads.security_group_id = :flow_security_group_id',
'   and case when upper(substr(i.name,1,2)) in (''P1'',''P2'',''P3'',''P4'',''P5'',''P6'',''P7'',''P8'',''P9'')',
'            then substr(i.name,instr(i.name,''_'')+1)',
'            else i.name',
'            end = ads.syn_name',
'   and ((nvl(i.prompt,''0'') != nvl(ad.label,''0'') and',
'         i.prompt != ad.label||'':'') or',
'        nvl(h.help_text,''0'')    != nvl(ad.help_text,''0'') or',
'        nvl(i.format_mask,''0'')  != nvl(ad.format_mask,''0'') or',
'        nvl(i.item_default,''0'') != nvl(ad.default_value,''0'') or',
'        nvl(i.format_mask,''0'')  != nvl(ad.form_format_mask,''0'') or',
'        nvl(i.cSize,0)          != nvl(ad.form_display_width,0) or',
'        nvl(i.cHeight,0)        != nvl(ad.form_display_height,0) or',
'        nvl(i.data_type,''0'')    != nvl(ad.form_data_type,''0'') )'))
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No Items found.'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(254122310940324272)
,p_query_column_id=>1
,p_column_alias=>'CHK'
,p_column_display_sequence=>1
,p_column_heading=>'<input type="checkbox" onclick="html_CheckAll($x_UpTill(this,''TABLE''),this.checked)" />'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(254046313271918161)
,p_query_column_id=>2
,p_column_alias=>'REGION_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Source'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(254046418881918162)
,p_query_column_id=>3
,p_column_alias=>'I_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(254046506609918162)
,p_query_column_id=>4
,p_column_alias=>'I_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(254046630409918162)
,p_query_column_id=>5
,p_column_alias=>'I_LABEL'
,p_column_display_sequence=>5
,p_column_heading=>'Label'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(254046728112918162)
,p_query_column_id=>6
,p_column_alias=>'I_HELP_TEXT'
,p_column_display_sequence=>6
,p_column_heading=>'Help Text'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(254046828135918162)
,p_query_column_id=>7
,p_column_alias=>'I_FORMAT_MASK'
,p_column_display_sequence=>7
,p_column_heading=>'General Format Mask'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(254046902461918162)
,p_query_column_id=>8
,p_column_alias=>'I_DEFAULT'
,p_column_display_sequence=>9
,p_column_heading=>'Default'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(257323504601517587)
,p_query_column_id=>9
,p_column_alias=>'I_FORMAT_MASK2'
,p_column_display_sequence=>8
,p_column_heading=>'Form Format Mask'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(254047101494918162)
,p_query_column_id=>10
,p_column_alias=>'I_WIDTH'
,p_column_display_sequence=>10
,p_column_heading=>'Width'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(254047326056918163)
,p_query_column_id=>11
,p_column_alias=>'I_HEIGHT'
,p_column_display_sequence=>11
,p_column_heading=>'Height'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(254047428210918163)
,p_query_column_id=>12
,p_column_alias=>'I_DATA_TYPE'
,p_column_display_sequence=>12
,p_column_heading=>'Data Type'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(256978025494631439)
,p_query_column_id=>13
,p_column_alias=>'FROM_AD'
,p_column_display_sequence=>14
,p_column_heading=>'From Ad'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(254047529834918163)
,p_query_column_id=>14
,p_column_alias=>'C_COLUMN_ID'
,p_column_display_sequence=>13
,p_column_heading=>'Column Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(254047607544918163)
,p_query_column_id=>15
,p_column_alias=>'C_COLUMN_NAME'
,p_column_display_sequence=>15
,p_column_heading=>'Column Name'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(254047710364918163)
,p_query_column_id=>16
,p_column_alias=>'C_LABEL'
,p_column_display_sequence=>16
,p_column_heading=>'Label'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(254047827634918163)
,p_query_column_id=>17
,p_column_alias=>'C_HELP_TEXT'
,p_column_display_sequence=>17
,p_column_heading=>'Help Text'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(254047916575918163)
,p_query_column_id=>18
,p_column_alias=>'C_FORMAT_MASK'
,p_column_display_sequence=>18
,p_column_heading=>'Format Mask'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(254048015613918163)
,p_query_column_id=>19
,p_column_alias=>'C_DEFAULT_VALUE'
,p_column_display_sequence=>20
,p_column_heading=>'Default Value'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(254048210852918163)
,p_query_column_id=>20
,p_column_alias=>'C_FORM_FORMAT_MASK'
,p_column_display_sequence=>19
,p_column_heading=>'Form Format Mask'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(254048321608918163)
,p_query_column_id=>21
,p_column_alias=>'C_FORM_DISPLAY_WIDTH'
,p_column_display_sequence=>21
,p_column_heading=>'Form Display Width'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(254048411206918163)
,p_query_column_id=>22
,p_column_alias=>'C_FORM_DISPLAY_HEIGHT'
,p_column_display_sequence=>22
,p_column_heading=>'Form Display Height'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(254048507566918163)
,p_query_column_id=>23
,p_column_alias=>'C_FORM_DATA_TYPE'
,p_column_display_sequence=>23
,p_column_heading=>'Form Data Type'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(254041728575848753)
,p_query_column_id=>24
,p_column_alias=>'CHECK_NAME'
,p_column_display_sequence=>24
,p_column_heading=>'Check Name'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(428479909619589784)
,p_name=>'Items the same as Attribute Dictionary entries'
,p_template=>wwv_flow_imp.id(689970285456172024)
,p_display_sequence=>140
,p_region_template_options=>'#DEFAULT#:is-collapsed'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select i.id, i.name item_name, ads.syn_name attr_name',
'  from wwv_flow_page_plugs r,',
'       wwv_flow_step_items i,',
'       wwv_flow_step_item_help h,',
'       wwv_flow_hnt_column_dict ad,',
'       wwv_flow_hnt_col_dict_syn ads',
' where nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'   and r.security_group_id  = :flow_security_group_id',
'   and r.flow_id            = :FB_FLOW_ID',
'   and r.page_id            = :FB_FLOW_PAGE_ID',
'   and r.id                 = i.item_plug_id',
'   and nvl(i.display_when_type,''disp'') != ''NEVER''',
'   and i.display_as not in (''NATIVE_HIDDEN'',''NATIVE_STOP_AND_START_HTML_TABLE'')',
'   and i.security_group_id  = :flow_security_group_id',
'   and i.flow_id            = :FB_FLOW_ID',
'   and i.flow_step_id       = :FB_FLOW_PAGE_ID',
'   and h.flow_item_id (+)   = i.id',
'   and ad.security_group_id = :flow_security_group_id',
'   and ad.column_id         = ads.column_id',
'   and ads.security_group_id = :flow_security_group_id',
'   and case when upper(substr(i.name,1,2)) in (''P1'',''P2'',''P3'',''P4'',''P5'',''P6'',''P7'',''P8'',''P9'')',
'            then substr(i.name,instr(i.name,''_'')+1)',
'            else i.name',
'            end = ads.syn_name',
'   and (nvl(i.prompt,''0'') = nvl(ad.label,''0'') or',
'        i.prompt = ad.label||'':'')',
'   and nvl(h.help_text,''0'')    = nvl(ad.help_text,''0'')',
'   and nvl(i.format_mask,''0'')  = nvl(ad.format_mask,''0'')',
'   and nvl(i.item_default,''0'') = nvl(ad.default_value,''0'')',
'   and nvl(i.format_mask,''0'')  = nvl(ad.form_format_mask,''0'')',
'   and nvl(i.cSize,0)          = nvl(ad.form_display_width,0)',
'   and nvl(i.cHeight,0)        = nvl(ad.form_display_height,0)',
'   and nvl(i.data_type,''0'')    = nvl(ad.form_data_type,''0'')',
'order by i.name'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No Items found.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(428480231173589796)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(428480412174599939)
,p_query_column_id=>2
,p_column_alias=>'ITEM_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Item Name'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(428480509176599939)
,p_query_column_id=>3
,p_column_alias=>'ATTR_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Matches'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(445249911176766283)
,p_plug_name=>'Update Attribute Dictionary'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>150
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>The Items listed were matched to existing columns in the Attribute Dictionary.  Select those you wish to update and indicate which attributes you wish to include in the update.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(452543506210546710)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>160
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(445192614743849621)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(253943415250283229)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(253942829341283227)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:912:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(258528808540645263)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(253942829341283227)
,p_button_name=>'UPDATE_AD'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Update Attribute Dictionary'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(258529016347645266)
,p_branch_action=>'f?p=&APP_ID.:890:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(253943203971283228)
,p_name=>'P890_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(253942829341283227)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Page:'
,p_source=>'FB_FLOW_PAGE_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PAGES IN CURRENT APP'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id || '' - '' || name d, id r',
'  from wwv_flow_steps',
' where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
,p_tag_attributes=>'class="fieldtitlebold"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Selected page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(257364716984540128)
,p_name=>'P890_INCLUDE_IN_UPDATE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(253942829341283227)
,p_item_default=>'label:help_text:gen_format_mask:form_format_mask:default:width:height:data_type'
,p_prompt=>'Include in Update:'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>'STATIC2:Label;label,Help Text;help_text,General Format Mask;gen_format_mask,Form Format Mask;form_format_mask,Default;default,Width;width,Height;height,Data Type;data_type'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Select the attributes to include in the update.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(260798009855616314)
,p_validation_name=>'P890_INCLUDE_IN_UPDATE not null'
,p_validation_sequence=>5
,p_validation=>'P890_INCLUDE_IN_UPDATE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'You must select attributes to include in update.'
,p_when_button_pressed=>wwv_flow_imp.id(258528808540645263)
,p_associated_item=>wwv_flow_imp.id(257364716984540128)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(258529820791658234)
,p_validation_name=>'must select items to update'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if WWV_FLOW.G_F01.COUNT = 0 then',
'   return false;',
'else',
'   return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'You must select at least one item to update.'
,p_when_button_pressed=>wwv_flow_imp.id(258528808540645263)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(258533930282746140)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update AD'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_comma      number;',
'   l_item_id    number;',
'   l_column_id  number;',
'begin',
'   for i in 1..wwv_flow.g_f01.count loop',
'',
'      l_comma     := instr(wwv_flow.g_f01(i),'','');',
'      l_item_id   := substr(wwv_flow.g_f01(i),1,l_comma-1);',
'      l_column_id := substr(wwv_flow.g_f01(i),l_comma+1);',
'',
'      wwv_flow_hint.update_ad_from_items(',
'         p_application_id  => :FB_FLOW_ID,',
'         p_page_id         => :P890_PAGE_ID,',
'         p_item_id         => l_item_id,',
'         p_column_id       => l_column_id,',
'         p_attr_to_include => :P890_INCLUDE_IN_UPDATE );',
'',
'   end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Attribute Dictionary failed to be updated.'
,p_process_when_button_id=>wwv_flow_imp.id(258528808540645263)
,p_process_success_message=>'Attribute Dictionary Updated.'
,p_internal_uid=>258533930282746140
);
end;
/
prompt --application/pages/page_00891
begin
wwv_flow_imp_page.create_page(
 p_id=>891
,p_name=>'Translation Repository - Grid Edit'
,p_alias=>'TRANSLATION-REPOSITORY-GRID-EDIT'
,p_step_title=>'Translation Repository - Grid Edit'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213331522315193801)
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'No help is available for this page.'
,p_page_component_map=>'21'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4348306845399378538)
,p_plug_name=>'Translation Repository'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>25
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
't.id,',
't.id id_display,',
't.translated_flow_id,',
't.page_id,',
't.translate_to_lang_code,',
't.translate_from_text,',
'c.column_description,',
't.translate_to_text,',
't.last_updated_by,',
't.last_updated_on,',
't.created_by,',
't.created_on,',
'sys.dbms_lob.substr(t.translate_to_text,255,1) translate_to_text_partial,',
'sys.dbms_lob.substr(t.translate_from_text,255,1) translate_from_text_partial,',
'case when ',
'    sys.dbms_lob.compare(t.translate_to_text,t.translate_from_text) != 0',
'    or nvl(length(t.translate_from_text),0) != nvl(length(t.translate_to_text),0) then ''Y''',
'    else ''N''',
'end translated       ',
' from wwv_flow_translatable_text$ t, ',
'      wwv_flow_translatable_cols$ c',
'where t.translate_from_flow_table = c.table_name',
'  and t.translate_from_flow_column = c.column_name',
'  and (c.template_translatable = ''N'' or (c.template_translatable = ''Y'' and t.template_translatable = ''Y''))',
'  and t.flow_id = :fb_flow_id ',
'  and t.security_group_id = :flow_security_group_id '))
,p_plug_source_type=>'NATIVE_IG'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(389678680891049101)
,p_name=>'CREATED_ON'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'CREATED_ON'
,p_data_type=>'DATE'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Created'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>140
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_format_mask=>'SINCE'
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_date_ranges=>'ALL'
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(389678770692049102)
,p_name=>'APEX$ROW_ACTION'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>20
,p_use_as_row_header=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(389678874688049103)
,p_name=>'APEX$ROW_SELECTOR'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
,p_use_as_row_header=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(953242540514873702)
,p_name=>'TRANSLATED'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'TRANSLATED'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Translated'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>150
,p_value_alignment=>'LEFT'
,p_attribute_02=>'LOV'
,p_attribute_05=>'PLAIN'
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(84259319526460470)
,p_lov_display_extra=>true
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(953242610794873703)
,p_name=>'TRANSLATE_TO_TEXT_PARTIAL'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'TRANSLATE_TO_TEXT_PARTIAL'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Translate To (Partial)'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>160
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(953242759959873704)
,p_name=>'TRANSLATE_FROM_TEXT_PARTIAL'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'TRANSLATE_FROM_TEXT_PARTIAL'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Translate From (Partial)'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>170
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(4348307025263378540)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>30
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(4348307168452378541)
,p_name=>'ID_DISPLAY'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID_DISPLAY'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>40
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(4348307284563378542)
,p_name=>'TRANSLATED_FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'TRANSLATED_FLOW_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Translated Application'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>50
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(4348307373339378543)
,p_name=>'PAGE_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'PAGE_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Page'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>60
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(4348307475401378544)
,p_name=>'TRANSLATE_TO_LANG_CODE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'TRANSLATE_TO_LANG_CODE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Language'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>70
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(4348307588297378545)
,p_name=>'TRANSLATE_FROM_TEXT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'TRANSLATE_FROM_TEXT'
,p_data_type=>'CLOB'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Translate From'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>80
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(4348307659878378546)
,p_name=>'COLUMN_DESCRIPTION'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'COLUMN_DESCRIPTION'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Column Description'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>90
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(4348307785032378547)
,p_name=>'TRANSLATE_TO_TEXT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'TRANSLATE_TO_TEXT'
,p_data_type=>'CLOB'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Translate To'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>100
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>32767
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(4348307812335378548)
,p_name=>'LAST_UPDATED_BY'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LAST_UPDATED_BY'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Updated By'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>110
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(4348307906013378549)
,p_name=>'LAST_UPDATED_ON'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LAST_UPDATED_ON'
,p_data_type=>'DATE'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Updated'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>120
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_format_mask=>'SINCE'
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_date_ranges=>'ALL'
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(4348308041362378550)
,p_name=>'CREATED_BY'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'CREATED_BY'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Created By'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>130
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(4348306932996378539)
,p_internal_uid=>4348306932996378539
,p_is_editable=>true
,p_edit_operations=>'u'
,p_lost_update_check_type=>'VALUES'
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_show_nulls_as=>'-'
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>true
,p_show_toolbar=>true
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>false
,p_define_chart_view=>false
,p_enable_download=>true
,p_download_formats=>'HTML'
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(389684227354049446)
,p_interactive_grid_id=>wwv_flow_imp.id(4348306932996378539)
,p_static_id=>'5877'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(389684338844049446)
,p_report_id=>wwv_flow_imp.id(389684227354049446)
,p_view_type=>'GRID'
,p_stretch_columns=>true
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(389684887373049454)
,p_view_id=>wwv_flow_imp.id(389684338844049446)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(4348307025263378540)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(389685314197049469)
,p_view_id=>wwv_flow_imp.id(389684338844049446)
,p_display_seq=>2
,p_column_id=>wwv_flow_imp.id(4348307168452378541)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(389685899544049471)
,p_view_id=>wwv_flow_imp.id(389684338844049446)
,p_display_seq=>5
,p_column_id=>wwv_flow_imp.id(4348307284563378542)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>156
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(389686388783049473)
,p_view_id=>wwv_flow_imp.id(389684338844049446)
,p_display_seq=>6
,p_column_id=>wwv_flow_imp.id(4348307373339378543)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>90
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(389686841445049474)
,p_view_id=>wwv_flow_imp.id(389684338844049446)
,p_display_seq=>7
,p_column_id=>wwv_flow_imp.id(4348307475401378544)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>81
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(389687338544049476)
,p_view_id=>wwv_flow_imp.id(389684338844049446)
,p_display_seq=>4
,p_column_id=>wwv_flow_imp.id(4348307588297378545)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(389687855717049480)
,p_view_id=>wwv_flow_imp.id(389684338844049446)
,p_display_seq=>8
,p_column_id=>wwv_flow_imp.id(4348307659878378546)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(389688380292049481)
,p_view_id=>wwv_flow_imp.id(389684338844049446)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(4348307785032378547)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(389688826910049483)
,p_view_id=>wwv_flow_imp.id(389684338844049446)
,p_display_seq=>9
,p_column_id=>wwv_flow_imp.id(4348307812335378548)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(389689315405049484)
,p_view_id=>wwv_flow_imp.id(389684338844049446)
,p_display_seq=>10
,p_column_id=>wwv_flow_imp.id(4348307906013378549)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(389689843039049486)
,p_view_id=>wwv_flow_imp.id(389684338844049446)
,p_display_seq=>11
,p_column_id=>wwv_flow_imp.id(4348308041362378550)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(389690386707049488)
,p_view_id=>wwv_flow_imp.id(389684338844049446)
,p_display_seq=>12
,p_column_id=>wwv_flow_imp.id(389678680891049101)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(389882320854078995)
,p_view_id=>wwv_flow_imp.id(389684338844049446)
,p_display_seq=>0
,p_column_id=>wwv_flow_imp.id(389678770692049102)
,p_is_visible=>true
,p_is_frozen=>true
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(953730461640956987)
,p_view_id=>wwv_flow_imp.id(389684338844049446)
,p_display_seq=>13
,p_column_id=>wwv_flow_imp.id(953242540514873702)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(960355302653043631)
,p_view_id=>wwv_flow_imp.id(389684338844049446)
,p_display_seq=>14
,p_column_id=>wwv_flow_imp.id(953242610794873703)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(960356215446043639)
,p_view_id=>wwv_flow_imp.id(389684338844049446)
,p_display_seq=>15
,p_column_id=>wwv_flow_imp.id(953242759959873704)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(389678984963049104)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(4348306845399378538)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Translation Repository - Save Interactive Grid Data'
,p_attribute_01=>'PLSQL_CODE'
,p_attribute_04=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin ',
'    if :apex$row_status = ''U'' then',
'        update wwv_flow_translatable_text$',
'           set translate_to_text = :translate_to_text',
'         where id = :id',
'           and flow_id = :fb_flow_id',
'           and security_group_id = :flow_security_group_id;',
'    end if;',
'end;       '))
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>389678984963049104
);
end;
/
prompt --application/pages/page_00892
begin
wwv_flow_imp_page.create_page(
 p_id=>892
,p_name=>'APEX Views Select Columns'
,p_alias=>'APEX-VIEWS-SELECT-COLUMNS'
,p_step_title=>'APEX Views Select Columns'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(200467223102537626)
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_utilties.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(200466231975530694)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>95
,p_list_id=>wwv_flow_imp.id(200452609222306546)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(200466404055532100)
,p_plug_name=>'top bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>97
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(200772019591558371)
,p_plug_name=>'Select Columns'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>100
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(698583694744530519)
,p_plug_name=>'Column Comments'
,p_region_template_options=>'#DEFAULT#:is-collapsed'
,p_plug_template=>wwv_flow_imp.id(689970285456172024)
,p_plug_display_sequence=>140
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(200457126484365515)
,p_plug_name=>'Column Comments Report'
,p_parent_plug_id=>wwv_flow_imp.id(698583694744530519)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select COLUMN_ID,',
'       COLUMN_NAME,',
'       COMMENTS',
'  from apex_dictionary',
' where apex_view_name = :P892_VIEW_NAME',
'   and column_name is not null'))
,p_plug_source_type=>'NATIVE_IR'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(200457204682365515)
,p_name=>'Application Express View Columns'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(200457426539365553)
,p_db_column_name=>'COLUMN_NAME'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>'Column Name'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(200457522278365554)
,p_db_column_name=>'COMMENTS'
,p_display_order=>3
,p_column_identifier=>'B'
,p_column_label=>'Comments'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(200478202755816974)
,p_db_column_name=>'COLUMN_ID'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Display Order'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(200471204036730778)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1293001704536644'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'SELECTOR:COLUMN_NAME:COMMENTS'
,p_sort_column_1=>'COLUMN_ID'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(200815329006740821)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(200466404055532100)
,p_button_name=>'VIEWS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'Views'
,p_button_position=>'CREATE'
,p_button_css_classes=>'a-Button--iconLeft'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(200555600938881336)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(200466404055532100)
,p_button_name=>'FILTER'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'Filter'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(200663028586485267)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(200466404055532100)
,p_button_name=>'RESULTS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Results'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(955890280061997313)
,p_branch_name=>'Go to 714'
,p_branch_action=>'f?p=&APP_ID.:714:&SESSION.::&DEBUG.:RP:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(200815329006740821)
,p_branch_sequence=>1
,p_branch_condition_type=>'ITEM_IS_NULL'
,p_branch_condition=>'P892_LAST_PAGE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(955890345867997314)
,p_branch_name=>'Go to P892_LAST_PAGE'
,p_branch_action=>'P892_LAST_PAGE'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_PAGE_IDENT_BY_ITEM'
,p_branch_when_button_id=>wwv_flow_imp.id(200815329006740821)
,p_branch_sequence=>5
,p_branch_condition_type=>'ITEM_IS_NOT_NULL'
,p_branch_condition=>'P892_LAST_PAGE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(200555827926881337)
,p_branch_action=>'f?p=&APP_ID.:893:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(200555600938881336)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(200663203074485268)
,p_branch_name=>'Go To Page 896'
,p_branch_action=>'f?p=&APP_ID.:896:&SESSION.::&DEBUG.:RP,::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(200663028586485267)
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(200458414988374478)
,p_name=>'P892_VIEW_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(200466404055532100)
,p_prompt=>'Selected View:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The selected view.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(200569807958940111)
,p_name=>'P892_SELECTED_COLS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(200772019591558371)
,p_prompt=>'Select Columns'
,p_display_as=>'NATIVE_SHUTTLE'
,p_named_lov=>'P892_P893_APEX_VIEW_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name d, column_name r',
'  from apex_dictionary',
' where apex_view_name = :P892_VIEW_NAME',
'   and column_id > 0',
' order by column_id'))
,p_cHeight=>25
,p_tag_attributes=>'style="width:300px;"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the columns you wish to include in your results.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ALL'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(955890094181997311)
,p_name=>'P892_LAST_PAGE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(200466404055532100)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(200774700029590598)
,p_computation_sequence=>10
,p_computation_item=>'P892_SELECTED_COLS'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  r varchar2(4000) := null;',
'  c pls_integer := 0;',
'begin',
'for c1 in (',
'   select column_name ',
'     from apex_dictionary ',
'    where apex_view_name = nvl(:P892_VIEW_NAME,''APEX_APPLICATIONS'')',
'    order by column_id) loop',
'  c := c + 1;',
'  if c > 6 then ',
'     exit; ',
'  end if;',
'  r := r||c1.column_name||'':'';',
'end loop;',
'return ltrim(rtrim(r,'':''),'':'');',
'end;'))
,p_compute_when=>'P892_SELECTED_COLS'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(200776630897627867)
,p_validation_name=>'P892_SELECTED_COLS'
,p_validation_sequence=>10
,p_validation=>'P892_SELECTED_COLS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'You must select at least one column to display.'
,p_validation_condition=>'FILTER,RESULTS'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(200569807958940111)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
end;
/
prompt --application/pages/page_00893
begin
wwv_flow_imp_page.create_page(
 p_id=>893
,p_name=>'APEX Views Filter'
,p_alias=>'APEX-VIEWS-FILTER'
,p_step_title=>'APEX Views Filter'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(200467223102537626)
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_utilties.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(200557704370886862)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>95
,p_list_id=>wwv_flow_imp.id(200452609222306546)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(200557901291886867)
,p_plug_name=>'top bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>97
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(200631913713282323)
,p_plug_name=>'Filter'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>127
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(200816003988752540)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(200557901291886867)
,p_button_name=>'COLUMNS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'Columns'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:892:&SESSION.::&DEBUG.:::'
,p_button_css_classes=>'a-Button--iconLeft'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(200558324809886868)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(200557901291886867)
,p_button_name=>'RESULTS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Results'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(200560301814886921)
,p_branch_action=>'f?p=&APP_ID.:896:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(200558324809886868)
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(200558511959886868)
,p_name=>'P893_VIEW_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(200557901291886867)
,p_prompt=>'Selected View:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'The selected view.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(200633632330306659)
,p_name=>'P893_COL_01'
,p_item_sequence=>11
,p_item_plug_id=>wwv_flow_imp.id(200631913713282323)
,p_prompt=>'Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P892_P893_APEX_VIEW_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name d, column_name r',
'  from apex_dictionary',
' where apex_view_name = :P892_VIEW_NAME',
'   and column_id > 0',
' order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a column to be used in the filter.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(200633828011306660)
,p_name=>'P893_CONDITION_01'
,p_item_sequence=>12
,p_item_plug_id=>wwv_flow_imp.id(200631913713282323)
,p_prompt=>'Condition'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APEX VIEWS FILTER CONDITIONS'
,p_lov=>'.'||wwv_flow_imp.id(200640422229340739)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a condition to be used in the filter.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(200634013014306661)
,p_name=>'P893_VALUE_01'
,p_item_sequence=>13
,p_item_plug_id=>wwv_flow_imp.id(200631913713282323)
,p_prompt=>'Value'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a value to be used in the filter.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(200634225519306661)
,p_name=>'P893_COL_02'
,p_item_sequence=>14
,p_item_plug_id=>wwv_flow_imp.id(200631913713282323)
,p_prompt=>'Column 2'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P892_P893_APEX_VIEW_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name d, column_name r',
'  from apex_dictionary',
' where apex_view_name = :P892_VIEW_NAME',
'   and column_id > 0',
' order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(200634431529306662)
,p_name=>'P893_CONDITION_02'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_imp.id(200631913713282323)
,p_prompt=>'Condition 2'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APEX VIEWS FILTER CONDITIONS'
,p_lov=>'.'||wwv_flow_imp.id(200640422229340739)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(200634608093306662)
,p_name=>'P893_VALUE_02'
,p_item_sequence=>16
,p_item_plug_id=>wwv_flow_imp.id(200631913713282323)
,p_prompt=>'Value 2'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(200634823684306663)
,p_name=>'P893_COL_03'
,p_item_sequence=>17
,p_item_plug_id=>wwv_flow_imp.id(200631913713282323)
,p_prompt=>'Column 3'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P892_P893_APEX_VIEW_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name d, column_name r',
'  from apex_dictionary',
' where apex_view_name = :P892_VIEW_NAME',
'   and column_id > 0',
' order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(200635000831306663)
,p_name=>'P893_CONDITION_03'
,p_item_sequence=>18
,p_item_plug_id=>wwv_flow_imp.id(200631913713282323)
,p_prompt=>'Condition 3'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APEX VIEWS FILTER CONDITIONS'
,p_lov=>'.'||wwv_flow_imp.id(200640422229340739)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(200635219093306664)
,p_name=>'P893_VALUE_03'
,p_item_sequence=>19
,p_item_plug_id=>wwv_flow_imp.id(200631913713282323)
,p_prompt=>'Value 3'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(200635406697306664)
,p_name=>'P893_COL_04'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(200631913713282323)
,p_prompt=>'Column 4'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P892_P893_APEX_VIEW_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name d, column_name r',
'  from apex_dictionary',
' where apex_view_name = :P892_VIEW_NAME',
'   and column_id > 0',
' order by column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(200635632272306665)
,p_name=>'P893_CONDITION_04'
,p_item_sequence=>21
,p_item_plug_id=>wwv_flow_imp.id(200631913713282323)
,p_prompt=>'Condition 4'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APEX VIEWS FILTER CONDITIONS'
,p_lov=>'.'||wwv_flow_imp.id(200640422229340739)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(200635818857306665)
,p_name=>'P893_VALUE_04'
,p_item_sequence=>22
,p_item_plug_id=>wwv_flow_imp.id(200631913713282323)
,p_prompt=>'Value 4'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(721523065500207302)
,p_name=>'Condition 1 IS NULL / IS NOT NULL'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P893_CONDITION_01'
,p_condition_element=>'P893_CONDITION_01'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'IS NULL,IS NOT NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(721523183251207303)
,p_event_id=>wwv_flow_imp.id(721523065500207302)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P893_VALUE_01'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(721523293616207304)
,p_event_id=>wwv_flow_imp.id(721523065500207302)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P893_VALUE_01'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(721524741232207319)
,p_event_id=>wwv_flow_imp.id(721523065500207302)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P893_VALUE_01'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(721523306160207305)
,p_name=>'Condition 2 IS NULL / IS NOT NULL'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P893_CONDITION_02'
,p_condition_element=>'P893_CONDITION_02'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'IS NULL,IS NOT NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(721523454047207306)
,p_event_id=>wwv_flow_imp.id(721523306160207305)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P893_VALUE_02'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(721523538820207307)
,p_event_id=>wwv_flow_imp.id(721523306160207305)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P893_VALUE_02'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(721524624208207318)
,p_event_id=>wwv_flow_imp.id(721523306160207305)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P893_VALUE_02'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(721524154181207313)
,p_name=>'Condition 4 IS NULL / IS NOT NULL'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P893_CONDITION_04'
,p_condition_element=>'P893_CONDITION_04'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'IS NULL,IS NOT NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(721524205971207314)
,p_event_id=>wwv_flow_imp.id(721524154181207313)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P893_VALUE_04'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(721524308433207315)
,p_event_id=>wwv_flow_imp.id(721524154181207313)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P893_VALUE_04'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(721524415971207316)
,p_event_id=>wwv_flow_imp.id(721524154181207313)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P893_VALUE_04'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(721523691415207308)
,p_name=>'Condition 3 IS NULL / IS NOT NULL'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P893_CONDITION_03'
,p_condition_element=>'P893_CONDITION_03'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'IS NULL,IS NOT NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(721523754414207309)
,p_event_id=>wwv_flow_imp.id(721523691415207308)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P893_VALUE_03'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(721523870918207310)
,p_event_id=>wwv_flow_imp.id(721523691415207308)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P893_VALUE_03'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(721524514164207317)
,p_event_id=>wwv_flow_imp.id(721523691415207308)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P893_VALUE_03'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
end;
/
prompt --application/pages/page_00896
begin
wwv_flow_imp_page.create_page(
 p_id=>896
,p_name=>'APEX Views Results'
,p_alias=>'APEX-VIEWS-RESULTS'
,p_step_title=>'APEX Views Results'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(200467223102537626)
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_utilties.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(200566111015923801)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>95
,p_list_id=>wwv_flow_imp.id(200452609222306546)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(200566321249923802)
,p_plug_name=>'top bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>97
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(200581025544039760)
,p_name=>'Results'
,p_template=>wwv_flow_imp.id(208928010704475743)
,p_display_sequence=>130
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    q         varchar2(32767);',
'    l_first   boolean := true;  ',
'    l_columns wwv_flow_t_varchar2;',
'',
'    function assert_valid_condition( p_condition in varchar2 ) return varchar2',
'    is ',
'    begin',
'        if p_condition is null or p_condition in (''>'', ''<'', ''='', ''!='', ''LIKE'', ''NOT LIKE'', ''IS NULL'', ''IS NOT NULL'') then',
'            return p_condition;',
'        else',
'            wwv_flow_error.raise_internal_error( p_error_code => ''WWV_FLOW_F4000_UTIL.INVALID_QUERY_FILTER'' );',
'        end if;',
'    end assert_valid_condition;',
'',
'    procedure add_filter( p_filter in number )',
'    is',
'        l_cond varchar2(255) := assert_valid_condition( v( ''P893_CONDITION_0'' || p_filter ) );',
'        l_col  varchar2(255) := replace(v( ''P893_COL_0'' || p_filter ),''%''||''null%'',null);',
'    begin',
'        if l_col is not null and l_cond is not null then',
'            q := q || '' '' ',
'                   || case when l_first then ''where'' else ''and'' end',
'                   || '' '' ',
'                   || wwv_flow_assert.enquote_name( l_col )',
'                   || '' ''',
'                   || l_cond',
'                   || case when l_cond not in (''IS NULL'', ''IS NOT NULL'') then  '' :P893_VALUE_0'' || p_filter end;',
'                   ',
'            l_first := false;',
'        end if;',
'    end add_filter;',
'    ',
'    function do_escape( p_string in varchar2 ) return varchar2 ',
'    is',
'    begin',
'        return '''''''' || replace( p_string, '''''''', '''''''''''') || '''''''';',
'    end do_escape;',
'begin',
'    wwv_flow_sw_api.check_priv(:G_PARSE_AS_SCHEMA_OVERRIDE);',
'    l_columns := wwv_flow_string.split( nvl( :P892_SELECTED_COLS, ''WORKSPACE'' ), '':'' );',
'    wwv_flow_preferences.reset_sort_preference(p_page_id => :APP_PAGE_ID);',
'  ',
'    q:= ''select '';',
'    for i in 1 .. l_columns.count loop',
'        q := q || case when i > 1 then '','' end || wwv_flow_assert.enquote_name( l_columns( i ) );',
'    end loop;',
'    q := q || '' from ''|| wwv_flow_assert.enquote_name( nvl(:P892_VIEW_NAME,''APEX_WORKSPACES'') );',
'      ',
'    for f in 1 .. 4 loop',
'        add_filter( f );',
'    end loop;',
'    ',
'    :P896_QUERY := replace(replace(replace(replace(replace(replace(replace( ',
'                        q, ',
'                        '':P893_VALUE_01'', do_escape( :P893_VALUE_01 ) ),',
'                        '':P893_VALUE_02'', do_escape( :P893_VALUE_02 ) ),',
'                        '':P893_VALUE_03'', do_escape( :P893_VALUE_03 ) ),',
'                        '':P893_VALUE_04'', do_escape( :P893_VALUE_04 ) ),',
'                        '' from '',wwv_flow.LF||''  from ''),',
'                        '' where '',wwv_flow.LF||'' where ''),',
'                        '' and '',wwv_flow.LF||''   and '');',
'    return q;',
'end;',
''))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_plug_query_max_columns=>60
,p_query_headings_type=>'QUERY_COLUMNS'
,p_query_num_rows=>25
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'Y'
,p_csv_output_link_text=>'Download'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_exp_filename=>'meta.csv'
,p_plug_query_strip_html=>'Y'
,p_plug_query_parse_override=>'G_PARSE_AS_SCHEMA_OVERRIDE'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200583004335052558)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_column_heading=>'Col01'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200583118948052560)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>2
,p_column_heading=>'Col02'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200583229060052560)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>3
,p_column_heading=>'Col03'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200583327418052560)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>4
,p_column_heading=>'Col04'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200583420810052561)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>5
,p_column_heading=>'Col05'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200583507478052561)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>6
,p_column_heading=>'Col06'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200583606861052561)
,p_query_column_id=>7
,p_column_alias=>'COL07'
,p_column_display_sequence=>7
,p_column_heading=>'Col07'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200583732705052561)
,p_query_column_id=>8
,p_column_alias=>'COL08'
,p_column_display_sequence=>8
,p_column_heading=>'Col08'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200583816253052561)
,p_query_column_id=>9
,p_column_alias=>'COL09'
,p_column_display_sequence=>9
,p_column_heading=>'Col09'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200583902410052561)
,p_query_column_id=>10
,p_column_alias=>'COL10'
,p_column_display_sequence=>10
,p_column_heading=>'Col10'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200584013856052561)
,p_query_column_id=>11
,p_column_alias=>'COL11'
,p_column_display_sequence=>11
,p_column_heading=>'Col11'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200584128460052561)
,p_query_column_id=>12
,p_column_alias=>'COL12'
,p_column_display_sequence=>12
,p_column_heading=>'Col12'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200584223786052561)
,p_query_column_id=>13
,p_column_alias=>'COL13'
,p_column_display_sequence=>13
,p_column_heading=>'Col13'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200584307407052561)
,p_query_column_id=>14
,p_column_alias=>'COL14'
,p_column_display_sequence=>14
,p_column_heading=>'Col14'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200584418638052561)
,p_query_column_id=>15
,p_column_alias=>'COL15'
,p_column_display_sequence=>15
,p_column_heading=>'Col15'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200584517833052561)
,p_query_column_id=>16
,p_column_alias=>'COL16'
,p_column_display_sequence=>16
,p_column_heading=>'Col16'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200584601952052561)
,p_query_column_id=>17
,p_column_alias=>'COL17'
,p_column_display_sequence=>17
,p_column_heading=>'Col17'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200584718965052561)
,p_query_column_id=>18
,p_column_alias=>'COL18'
,p_column_display_sequence=>18
,p_column_heading=>'Col18'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200584813594052561)
,p_query_column_id=>19
,p_column_alias=>'COL19'
,p_column_display_sequence=>19
,p_column_heading=>'Col19'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200584925686052561)
,p_query_column_id=>20
,p_column_alias=>'COL20'
,p_column_display_sequence=>20
,p_column_heading=>'Col20'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200585002797052562)
,p_query_column_id=>21
,p_column_alias=>'COL21'
,p_column_display_sequence=>21
,p_column_heading=>'Col21'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200585131778052562)
,p_query_column_id=>22
,p_column_alias=>'COL22'
,p_column_display_sequence=>22
,p_column_heading=>'Col22'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200585223134052562)
,p_query_column_id=>23
,p_column_alias=>'COL23'
,p_column_display_sequence=>23
,p_column_heading=>'Col23'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200585304675052562)
,p_query_column_id=>24
,p_column_alias=>'COL24'
,p_column_display_sequence=>24
,p_column_heading=>'Col24'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200585412836052562)
,p_query_column_id=>25
,p_column_alias=>'COL25'
,p_column_display_sequence=>25
,p_column_heading=>'Col25'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200585509108052562)
,p_query_column_id=>26
,p_column_alias=>'COL26'
,p_column_display_sequence=>26
,p_column_heading=>'Col26'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200585625980052562)
,p_query_column_id=>27
,p_column_alias=>'COL27'
,p_column_display_sequence=>27
,p_column_heading=>'Col27'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200585702761052562)
,p_query_column_id=>28
,p_column_alias=>'COL28'
,p_column_display_sequence=>28
,p_column_heading=>'Col28'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200585818864052562)
,p_query_column_id=>29
,p_column_alias=>'COL29'
,p_column_display_sequence=>29
,p_column_heading=>'Col29'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200585905530052562)
,p_query_column_id=>30
,p_column_alias=>'COL30'
,p_column_display_sequence=>30
,p_column_heading=>'Col30'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200586023944052562)
,p_query_column_id=>31
,p_column_alias=>'COL31'
,p_column_display_sequence=>31
,p_column_heading=>'Col31'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200586101322052562)
,p_query_column_id=>32
,p_column_alias=>'COL32'
,p_column_display_sequence=>32
,p_column_heading=>'Col32'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200586214937052562)
,p_query_column_id=>33
,p_column_alias=>'COL33'
,p_column_display_sequence=>33
,p_column_heading=>'Col33'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200586323245052562)
,p_query_column_id=>34
,p_column_alias=>'COL34'
,p_column_display_sequence=>34
,p_column_heading=>'Col34'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200586414515052562)
,p_query_column_id=>35
,p_column_alias=>'COL35'
,p_column_display_sequence=>35
,p_column_heading=>'Col35'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200586529034052562)
,p_query_column_id=>36
,p_column_alias=>'COL36'
,p_column_display_sequence=>36
,p_column_heading=>'Col36'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200586610966052563)
,p_query_column_id=>37
,p_column_alias=>'COL37'
,p_column_display_sequence=>37
,p_column_heading=>'Col37'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200586718739052563)
,p_query_column_id=>38
,p_column_alias=>'COL38'
,p_column_display_sequence=>38
,p_column_heading=>'Col38'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200586801402052563)
,p_query_column_id=>39
,p_column_alias=>'COL39'
,p_column_display_sequence=>39
,p_column_heading=>'Col39'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200586926221052563)
,p_query_column_id=>40
,p_column_alias=>'COL40'
,p_column_display_sequence=>40
,p_column_heading=>'Col40'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200587021396052563)
,p_query_column_id=>41
,p_column_alias=>'COL41'
,p_column_display_sequence=>41
,p_column_heading=>'Col41'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200587101398052563)
,p_query_column_id=>42
,p_column_alias=>'COL42'
,p_column_display_sequence=>42
,p_column_heading=>'Col42'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200587229713052563)
,p_query_column_id=>43
,p_column_alias=>'COL43'
,p_column_display_sequence=>43
,p_column_heading=>'Col43'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200587332082052563)
,p_query_column_id=>44
,p_column_alias=>'COL44'
,p_column_display_sequence=>44
,p_column_heading=>'Col44'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200587428870052563)
,p_query_column_id=>45
,p_column_alias=>'COL45'
,p_column_display_sequence=>45
,p_column_heading=>'Col45'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200587518273052563)
,p_query_column_id=>46
,p_column_alias=>'COL46'
,p_column_display_sequence=>46
,p_column_heading=>'Col46'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200587619466052563)
,p_query_column_id=>47
,p_column_alias=>'COL47'
,p_column_display_sequence=>47
,p_column_heading=>'Col47'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200587705647052563)
,p_query_column_id=>48
,p_column_alias=>'COL48'
,p_column_display_sequence=>48
,p_column_heading=>'Col48'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200587832429052563)
,p_query_column_id=>49
,p_column_alias=>'COL49'
,p_column_display_sequence=>49
,p_column_heading=>'Col49'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200587932156052563)
,p_query_column_id=>50
,p_column_alias=>'COL50'
,p_column_display_sequence=>50
,p_column_heading=>'Col50'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200588006730052563)
,p_query_column_id=>51
,p_column_alias=>'COL51'
,p_column_display_sequence=>51
,p_column_heading=>'Col51'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200588116717052563)
,p_query_column_id=>52
,p_column_alias=>'COL52'
,p_column_display_sequence=>52
,p_column_heading=>'Col52'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200588211305052564)
,p_query_column_id=>53
,p_column_alias=>'COL53'
,p_column_display_sequence=>53
,p_column_heading=>'Col53'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200588311432052564)
,p_query_column_id=>54
,p_column_alias=>'COL54'
,p_column_display_sequence=>54
,p_column_heading=>'Col54'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200588409006052564)
,p_query_column_id=>55
,p_column_alias=>'COL55'
,p_column_display_sequence=>55
,p_column_heading=>'Col55'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200588519334052564)
,p_query_column_id=>56
,p_column_alias=>'COL56'
,p_column_display_sequence=>56
,p_column_heading=>'Col56'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200588612161052564)
,p_query_column_id=>57
,p_column_alias=>'COL57'
,p_column_display_sequence=>57
,p_column_heading=>'Col57'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200588709502052564)
,p_query_column_id=>58
,p_column_alias=>'COL58'
,p_column_display_sequence=>58
,p_column_heading=>'Col58'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200588825849052564)
,p_query_column_id=>59
,p_column_alias=>'COL59'
,p_column_display_sequence=>59
,p_column_heading=>'Col59'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(200588909565052564)
,p_query_column_id=>60
,p_column_alias=>'COL60'
,p_column_display_sequence=>60
,p_column_heading=>'Col60'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(200591119142075800)
,p_plug_name=>'Query'
,p_region_template_options=>'#DEFAULT#:is-collapsed'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689970285456172024)
,p_plug_display_sequence=>140
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(200816419572757053)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(200566321249923802)
,p_button_name=>'FILTER'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'Filter'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:893:&SESSION.::&DEBUG.:::'
,p_button_css_classes=>'a-Button--iconLeft'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(200566911694923803)
,p_name=>'P896_VIEW_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(200566321249923802)
,p_prompt=>'Selected View:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'The selected view.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(200591704728081053)
,p_name=>'P896_QUERY'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(200591119142075800)
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_attributes=>'style="white-space:pre;"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3692064821539)
,p_computation_sequence=>10
,p_computation_item=>'G_PARSE_AS_SCHEMA_OVERRIDE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'     l_owner varchar2(100);',
'begin',
'    if :FB_FLOW_ID is not null then',
'        for c1 in (select owner',
'                     from wwv_flows',
'                    where id = :FB_FLOW_ID',
'                      and security_group_id = :FLOW_SECURITY_GROUP_ID) loop',
'            l_owner := c1.owner;',
'            exit;',
'        end loop;        ',
'    else',
'        for c1 in (select first_schema_provisioned',
'                     from wwv_flow_companies',
'                    where provisioning_company_id = :FLOW_SECURITY_GROUP_ID) loop',
'            --',
'            for c2 in (select schema ',
'                         from wwv_flow_company_schemas',
'                        where security_group_id = :FLOW_SECURITY_GROUP_ID',
'                          and schema = c1.first_schema_provisioned) loop',
'                l_owner := c2.schema;',
'                exit;',
'            end loop;',
'        end loop;',
'        --  If null, use the first one found',
'        if l_owner is null then',
'            for c3 in (select schema',
'                         from wwv_flow_company_schemas',
'                        where security_group_id = :FLOW_SECURITY_GROUP_ID) loop',
'                l_owner := c3.schema;',
'                exit;',
'            end loop;',
'        end if;',
'    end if;',
'    --',
'    return l_owner;',
'end;'))
);
end;
/
prompt --application/pages/page_00897
begin
wwv_flow_imp_page.create_page(
 p_id=>897
,p_name=>'Update using Report Columns'
,p_alias=>'UPDATE-USING-REPORT-COLUMNS'
,p_step_title=>'Update using Report Columns'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(261841008861828406)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'mg_attribute_dict.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(253945008978283231)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>100
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(257015121469989867)
,p_name=>'Matched Report Columns'
,p_template=>wwv_flow_imp.id(208928010704475743)
,p_display_sequence=>140
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select htmldb_item.checkbox(1,''CR,''||rc.id||'',''||ad.column_id) chk,',
'       m.region ||'': ''|| r.plug_name region_name,',
'       --',
'       rc.id rc_id, ',
'       rc.column_alias rc_name, ',
'       rc.column_heading  rc_label,',
'       null rc_help_text,',
'       rc.column_format rc_format_mask,',
'       --',
'       rc.column_format rc_format_mask2,',
'       case when rc.column_alignment = ''LEFT'' then m.l',
'            when rc.column_alignment = ''CENTER'' then m.c',
'            when rc.column_alignment = ''RIGHT'' then m.r',
'            end rc_report_col_align,',
'       --',
'       m.a from_ad,',
'       ad.column_id c_column_id,',
'       ads.syn_name c_column_name,',
'       ad.label c_label,',
'       case when length(ad.help_text) > 20',
'            then ''<a href="''||htmldb_util.prepare_url(''f?p=4000:908:''||:APP_SESSION||',
'                 '':::908:P908_DISPLAY,P908_ID:ADH,''||ad.column_id)||''" alt="''||wwv_flow_escape.html(m.v||''" title="''||m.v)||''">''||wwv_flow_escape.html(substr(ad.help_text,1,20))||''...</a>''',
'            else wwv_flow_escape.html(ad.help_text)',
'            end c_help_text,',
'       ad.format_mask c_format_mask,',
'       --',
'       ad.report_format_mask c_report_format_mask,',
'       case when ad.report_col_alignment = ''LEFT'' then m.l',
'            when ad.report_col_alignment = ''CENTER'' then m.c',
'            when ad.report_col_alignment = ''RIGHT'' then m.r',
'            end c_report_col_align',
'  from wwv_flow_page_plugs r,',
'       wwv_flow_region_report_column rc,',
'       wwv_flow_hnt_column_dict ad,',
'       wwv_flow_hnt_col_dict_syn ads,',
'       (select wwv_flow_lang.system_message(''FROM_ATTRIBUTE_DICTIONARY'') a,',
'               wwv_flow_lang.system_message(''LEFT'') l,',
'               wwv_flow_lang.system_message(''CENTER'') c,',
'               wwv_flow_lang.system_message(''RIGHT'') r,',
'               wwv_flow_lang.system_message(''VIEW_FOR_ALT_TAG'') v,',
'               wwv_flow_lang.system_message(''APEX_REGION'') region',
'          from dual) m',
' where nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'   and r.security_group_id  = :flow_security_group_id',
'   and r.flow_id    = :FB_FLOW_ID',
'   and r.page_id    = :FB_FLOW_PAGE_ID',
'   and r.id         = rc.region_id',
'   and rc.hidden_column = ''N''',
'   and nvl(rc.display_when_cond_type,''disp'') != ''NEVER''',
'   and rc.security_group_id  = :flow_security_group_id',
'   and rc.flow_id            = :FB_FLOW_ID',
'   and rc.column_alias       =  ads.syn_name',
'   and ad.security_group_id  = :flow_security_group_id',
'   and ad.column_id          = ads.column_id',
'   and ads.security_group_id = :flow_security_group_id',
'   and (nvl(rc.column_heading,''0'')   != nvl(ad.label,''0'') or',
'        nvl(rc.column_format,''0'')    != nvl(ad.format_mask,''0'') or',
'        nvl(rc.column_format,''0'')    != nvl(ad.report_format_mask,''0'') or',
'        nvl(rc.column_alignment,''0'') != nvl(ad.report_col_alignment,''0'') )',
'union all',
'select htmldb_item.checkbox(1,''IR,''||rc.id||'',''||ad.column_id) chk,',
'       m.region ||'': ''|| r.plug_name region_name,',
'       --',
'       rc.id rc_id, ',
'       rc.db_column_name rc_name, ',
'       rc.report_label rc_label,',
'       case when length(rc.help_text) > 20',
'            then ''<a href="''||htmldb_util.prepare_url(''f?p=4000:908:''||:APP_SESSION||',
'                 '':::908:P908_DISPLAY,P908_ID:IRH,''||rc.id)||''" alt="''||wwv_flow_escape.html(m.v||''" title="''||m.v)||''">''||wwv_flow_escape.html(substr(rc.help_text,1,20))||''...</a>''',
'            else wwv_flow_escape.html(rc.help_text)',
'            end rc_help_text,',
'       rc.format_mask rc_format_mask,',
'       --',
'       rc.format_mask rc_format_mask2,',
'       case when rc.column_alignment = ''LEFT'' then m.l',
'            when rc.column_alignment = ''CENTER'' then m.c',
'            when rc.column_alignment = ''RIGHT'' then m.r',
'            end rc_report_col_align,',
'       --',
'       m.a from_ad,',
'       ad.column_id c_column_id,',
'       ads.syn_name c_column_name,',
'       ad.label c_label,',
'       case when length(ad.help_text) > 20',
'            then ''<a href="''||htmldb_util.prepare_url(''f?p=4000:908:''||:APP_SESSION||',
'                 '':::908:P908_DISPLAY,P908_ID:ADH,''||ad.column_id)||''" alt="''||wwv_flow_escape.html(m.v||''" title="''||m.v)||''">''||substr(ad.help_text,1,20)||''...</a>''',
'            else wwv_flow_escape.html(ad.help_text)',
'            end c_help_text,',
'       ad.format_mask c_format_mask,',
'       --',
'       ad.report_format_mask c_report_format_mask,',
'       case when ad.report_col_alignment = ''LEFT'' then m.l',
'            when ad.report_col_alignment = ''CENTER'' then m.c',
'            when ad.report_col_alignment = ''RIGHT'' then m.r',
'            end c_report_col_align',
'  from wwv_flow_worksheets w,',
'       wwv_flow_page_plugs r,',
'       wwv_flow_worksheet_columns rc,',
'       wwv_flow_hnt_column_dict ad,',
'       wwv_flow_hnt_col_dict_syn ads,',
'       (select wwv_flow_lang.system_message(''FROM_ATTRIBUTE_DICTIONARY'') a,',
'               wwv_flow_lang.system_message(''LEFT'') l,',
'               wwv_flow_lang.system_message(''CENTER'') c,',
'               wwv_flow_lang.system_message(''RIGHT'') r,',
'               wwv_flow_lang.system_message(''VIEW_FOR_ALT_TAG'') v,',
'               wwv_flow_lang.system_message(''APEX_REGION'') region',
'          from dual) m',
' where w.security_group_id = :flow_security_group_id',
'   and w.flow_id           = :FB_FLOW_ID',
'   and w.page_id           = :FB_FLOW_PAGE_ID',
'   and w.region_id         = r.id',
'   and r.security_group_id = :flow_security_group_id',
'   and r.flow_id           = :FB_FLOW_ID ',
'   and r.page_id           = :FB_FLOW_PAGE_ID',
'   and nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'   and w.id                = rc.worksheet_id',
'   and rc.display_text_as != ''HIDDEN''',
'   and nvl(rc.display_condition_type,''disp'') != ''NEVER''',
'   and rc.security_group_id  = :flow_security_group_id',
'   and rc.flow_id            = :FB_FLOW_ID',
'   and rc.db_column_name     =  ads.syn_name',
'   and ad.security_group_id  = :flow_security_group_id',
'   and ad.column_id          = ads.column_id',
'   and ads.security_group_id = :flow_security_group_id',
'   and (nvl(rc.report_label,''0'')     != nvl(ad.label,''0'') or',
'        nvl(rc.help_text,''0'')        != nvl(ad.help_text,''0'') or',
'        nvl(rc.format_mask,''0'')      != nvl(ad.format_mask,''0'') or',
'        nvl(rc.format_mask,''0'')      != nvl(ad.report_format_mask,''0'') or',
'        nvl(rc.column_alignment,''0'') != nvl(ad.report_col_alignment,''0'') )'))
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No Report Columns found.'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(257015424276989878)
,p_query_column_id=>1
,p_column_alias=>'CHK'
,p_column_display_sequence=>1
,p_column_heading=>'<input type="checkbox" onclick="html_CheckAll($x_UpTill(this,''TABLE''),this.checked)" />'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(257015521337989878)
,p_query_column_id=>2
,p_column_alias=>'REGION_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Source'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(257015603409989878)
,p_query_column_id=>3
,p_column_alias=>'RC_ID'
,p_column_display_sequence=>3
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(257015700651989878)
,p_query_column_id=>4
,p_column_alias=>'RC_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(257015823462989878)
,p_query_column_id=>5
,p_column_alias=>'RC_LABEL'
,p_column_display_sequence=>5
,p_column_heading=>'Label'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(259744228997628451)
,p_query_column_id=>6
,p_column_alias=>'RC_HELP_TEXT'
,p_column_display_sequence=>6
,p_column_heading=>'Help Text'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(257015914224989878)
,p_query_column_id=>7
,p_column_alias=>'RC_FORMAT_MASK'
,p_column_display_sequence=>7
,p_column_heading=>'Format Mask'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(257106420607377518)
,p_query_column_id=>8
,p_column_alias=>'RC_FORMAT_MASK2'
,p_column_display_sequence=>8
,p_column_heading=>'Report Format Mask'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(257016003282989878)
,p_query_column_id=>9
,p_column_alias=>'RC_REPORT_COL_ALIGN'
,p_column_display_sequence=>9
,p_column_heading=>'Report Column Alignment'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(257016132556989878)
,p_query_column_id=>10
,p_column_alias=>'FROM_AD'
,p_column_display_sequence=>10
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(257016220959989878)
,p_query_column_id=>11
,p_column_alias=>'C_COLUMN_ID'
,p_column_display_sequence=>11
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(257016311340989878)
,p_query_column_id=>12
,p_column_alias=>'C_COLUMN_NAME'
,p_column_display_sequence=>12
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(257016431008989878)
,p_query_column_id=>13
,p_column_alias=>'C_LABEL'
,p_column_display_sequence=>13
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(259744709520641753)
,p_query_column_id=>14
,p_column_alias=>'C_HELP_TEXT'
,p_column_display_sequence=>14
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(257016514865989878)
,p_query_column_id=>15
,p_column_alias=>'C_FORMAT_MASK'
,p_column_display_sequence=>15
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(257016610912989878)
,p_query_column_id=>16
,p_column_alias=>'C_REPORT_FORMAT_MASK'
,p_column_display_sequence=>16
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(257016722281989878)
,p_query_column_id=>17
,p_column_alias=>'C_REPORT_COL_ALIGN'
,p_column_display_sequence=>17
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(428491506165664497)
,p_name=>'Report Columns the same as Attribute Dictionary entries'
,p_template=>wwv_flow_imp.id(689970285456172024)
,p_display_sequence=>150
,p_region_template_options=>'#DEFAULT#:is-collapsed'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select r.plug_name region_name,',
'       rc.column_alias rc_name',
'  from wwv_flow_page_plugs r,',
'       wwv_flow_region_report_column rc,',
'       wwv_flow_hnt_column_dict ad,',
'       wwv_flow_hnt_col_dict_syn ads',
' where nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'   and r.security_group_id  = :flow_security_group_id',
'   and r.flow_id    = :FB_FLOW_ID',
'   and r.page_id    = :FB_FLOW_PAGE_ID',
'   and r.id         = rc.region_id',
'   and rc.hidden_column = ''N''',
'   and nvl(rc.display_when_cond_type,''disp'') != ''NEVER''',
'   and rc.security_group_id  = :flow_security_group_id',
'   and rc.flow_id            = :FB_FLOW_ID',
'   and rc.column_alias       =  ads.syn_name',
'   and ad.security_group_id  = :flow_security_group_id',
'   and ad.column_id          = ads.column_id',
'   and ads.security_group_id = :flow_security_group_id',
'   and nvl(rc.column_heading,''0'')   = nvl(ad.label,''0'')',
'   and nvl(rc.column_format,''0'')    = nvl(ad.format_mask,''0'')',
'   and nvl(rc.column_format,''0'')    = nvl(ad.report_format_mask,''0'')',
'   and nvl(rc.column_alignment,''0'') = nvl(ad.report_col_alignment,''0'') ',
'union all',
'select r.plug_name region_name,',
'       rc.db_column_name rc_name',
'  from wwv_flow_worksheets w,',
'       wwv_flow_page_plugs r,',
'       wwv_flow_worksheet_columns rc,',
'       wwv_flow_hnt_column_dict ad,',
'       wwv_flow_hnt_col_dict_syn ads',
' where w.security_group_id = :flow_security_group_id',
'   and w.flow_id           = :FB_FLOW_ID',
'   and w.page_id           = :FB_FLOW_PAGE_ID',
'   and w.region_id         = r.id',
'   and r.security_group_id = :flow_security_group_id',
'   and r.flow_id           = :FB_FLOW_ID ',
'   and r.page_id           = :FB_FLOW_PAGE_ID',
'   and nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'   and w.id                = rc.worksheet_id',
'   and rc.display_text_as != ''HIDDEN''',
'   and nvl(rc.display_condition_type,''disp'') != ''NEVER''',
'   and rc.security_group_id  = :flow_security_group_id',
'   and rc.flow_id            = :FB_FLOW_ID',
'   and rc.db_column_name     = ads.syn_name',
'   and ad.security_group_id  = :flow_security_group_id',
'   and ad.column_id          = ads.column_id',
'   and ads.security_group_id = :flow_security_group_id',
'   and nvl(rc.report_label,''0'')     = nvl(ad.label,''0'')',
'   and nvl(rc.help_text,''0'')        = nvl(ad.help_text,''0'')',
'   and nvl(rc.format_mask,''0'')      = nvl(ad.format_mask,''0'')',
'   and nvl(rc.format_mask,''0'')      = nvl(ad.report_format_mask,''0'')',
'   and nvl(rc.column_alignment,''0'') = nvl(ad.report_col_alignment,''0'')',
'order by 1, 2'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No Report Columns found.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(428491801147664504)
,p_query_column_id=>1
,p_column_alias=>'REGION_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Region'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(428491924749664504)
,p_query_column_id=>2
,p_column_alias=>'RC_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Report Column'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(445211916568256935)
,p_plug_name=>'Update Attribute Dictionary'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>160
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The Report Columns listed were matched to existing columns in the Attribute Dictionary.  Select those you wish to update and indicate which attributes you wish to include in the update.</p>',
'',
'<p>Note: Help Text is only available within Interactive Reports. If you are updating based upon a Standard Report, Help Text will not be used.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(452546030629591591)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>170
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(445192614743849621)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(253945624067283234)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(253945008978283231)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:912:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(259739808640528044)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(253945008978283231)
,p_button_name=>'UPDATE_AD'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Update Attribute Dictionary'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(259740018696528045)
,p_branch_action=>'f?p=&APP_ID.:897:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(257013416218884204)
,p_name=>'P897_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(253945008978283231)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Page:'
,p_source=>'FB_FLOW_PAGE_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PAGES IN CURRENT APP'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id || '' - '' || name d, id r',
'  from wwv_flow_steps',
' where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_attributes=>'class="fieldtitlebold"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Selected page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(257416719109572214)
,p_name=>'P897_INCLUDE_IN_UPDATE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(253945008978283231)
,p_item_default=>'label:help_text:gen_format_mask:rep_format_mask:rep_col_align'
,p_prompt=>'Include in Update:'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>'STATIC2:Label;label,Help Text;help_text,General Format Mask;gen_format_mask,Report Format Mask;rep_format_mask,Report Column Alignment;rep_col_align'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Select which attributes to update.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(260799525917630412)
,p_validation_name=>'P897_INCLUDE_IN_UPDATE not null'
,p_validation_sequence=>5
,p_validation=>'P897_INCLUDE_IN_UPDATE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'You must select attributes to include in update.'
,p_when_button_pressed=>wwv_flow_imp.id(259739808640528044)
,p_associated_item=>wwv_flow_imp.id(257416719109572214)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(259740218337530765)
,p_validation_name=>'must select rc to update'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if WWV_FLOW.G_F01.COUNT = 0 then',
'   return false;',
'else',
'   return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'You must select at least one report column to update.'
,p_when_button_pressed=>wwv_flow_imp.id(259739808640528044)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(259740423185532187)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update AD'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_comma2     number;',
'   l_rc_type    varchar2(2);',
'   l_rc_id      number;',
'   l_column_id  number;',
'begin',
'   for i in 1..wwv_flow.g_f01.count loop',
'',
'      l_comma2    := instr(wwv_flow.g_f01(i),'','',1,2);',
'      l_rc_type   := substr(wwv_flow.g_f01(i),1,2);',
'      l_rc_id     := substr(wwv_flow.g_f01(i),4,l_comma2-4);',
'      l_column_id := substr(wwv_flow.g_f01(i),l_comma2+1);',
'',
'      if l_rc_type = ''CR'' then',
'         wwv_flow_hint.update_ad_from_cr(',
'            p_application_id  => :FB_FLOW_ID,',
'            p_rc_id           => l_rc_id,',
'            p_column_id       => l_column_id,',
'            p_attr_to_include => :P897_INCLUDE_IN_UPDATE );',
'      elsif l_rc_type = ''IR'' then',
'         wwv_flow_hint.update_ad_from_ir(',
'            p_application_id  => :FB_FLOW_ID,',
'            p_rc_id           => l_rc_id,',
'            p_column_id       => l_column_id,',
'            p_attr_to_include => :P897_INCLUDE_IN_UPDATE );',
'      end if;',
'',
'   end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Attribute Dictionary failed to be updated.'
,p_process_when_button_id=>wwv_flow_imp.id(259739808640528044)
,p_process_success_message=>'Attribute Dictionary Updated.'
,p_internal_uid=>259740423185532187
);
end;
/
prompt --application/pages/page_00901
begin
wwv_flow_imp_page.create_page(
 p_id=>901
,p_name=>'Create Region Template - Creation Method'
,p_alias=>'CREATE-REGION-TEMPLATE-CREATION-METHOD'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Region Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47958532317857477)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>140
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(106483721658234044)
,p_plug_name=>'Create Region Template'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>130
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<p>You can create templates from scratch or copy them from another application. Copying a template provides you with a framework that you can modify.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(106508709951315405)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(106501409747300331)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(106521705986341929)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47958532317857477)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(106523917414345199)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(47958532317857477)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(19616211009686641)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(47958532317857477)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(177239400549919148)
,p_branch_action=>'4320'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(106523917414345199)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'F4000_P901_REGION_TEMPLATES'
,p_branch_condition_text=>'COPY'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(106554600554471715)
,p_branch_action=>'902'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(106523917414345199)
,p_branch_sequence=>50
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'F4000_P901_REGION_TEMPLATES'
,p_branch_condition_text=>'BLANK'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(589946940004621414)
,p_branch_action=>'f?p=&APP_ID.:162:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(19616211009686641)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(106486023371248399)
,p_name=>'F4000_P901_REGION_TEMPLATES'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(106483721658234044)
,p_item_default=>'COPY'
,p_prompt=>'Create Region Template:'
,p_source=>'COPY'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'REGION_TEMPLATE_WIZ'
,p_lov=>'.'||wwv_flow_imp.id(86595203201245715)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_escape_on_http_output=>'N'
,p_help_text=>'<p>Creating a template from the template repository is a quick way to create a new template.  Once you have created a template from the repository you can then edit the template to suit your needs. Creating a template from scratch requires you to cod'
||'e the entire template.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(106698729574838080)
,p_validation_name=>'TYPE'
,p_validation_sequence=>10
,p_validation=>'F4000_P901_REGION_TEMPLATES'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Region Template must be specified.'
,p_validation_condition=>'CANCEL'
,p_validation_condition_type=>'REQUEST_NOT_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(106486023371248399)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(589946769794621412)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(106521705986341929)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(589946864777621413)
,p_event_id=>wwv_flow_imp.id(589946769794621412)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(106721729297914206)
,p_process_sequence=>100
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'CLEAR_CACHE'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'901:902:903:904'
,p_process_when_button_id=>wwv_flow_imp.id(106521705986341929)
,p_internal_uid=>106721729297914206
);
end;
/
prompt --application/pages/page_00902
begin
wwv_flow_imp_page.create_page(
 p_id=>902
,p_name=>'Create Region Template - Confirm'
,p_alias=>'CREATE-REGION-TEMPLATE-CONFIRM'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Region Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47963414187918518)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(106539127080459471)
,p_plug_name=>'Create Region Template'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_no_data_found=>'No Page Template Found.'
,p_plug_query_show_nulls_as=>'(null)'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(106540621904461810)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(106501409747300331)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(106642203907691435)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47963414187918518)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(106647404038700884)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(47963414187918518)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
,p_button_cattributes=>'tabindex="1"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(106644818799695705)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(47963414187918518)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(93460221326014992)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(589947279002621417)
,p_branch_action=>'f?p=&APP_ID.:162:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(106644818799695705)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(98321416048032372)
,p_name=>'P902_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(106539127080459471)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identify new region template name.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(100010309599039923)
,p_name=>'P902_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(106539127080459471)
,p_prompt=>'Theme'
,p_source=>'P4003_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies a collection of templates which define the look and feel of the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(100084329338045600)
,p_name=>'P902_THEME_CLASS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(106539127080459471)
,p_prompt=>'Template Class'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REGION THEME CLASS ID'
,p_lov=>'.'||wwv_flow_imp.id(42003622222572861)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'The template class identifies a specific usage for this template.  The template class is used when switching themes.  When switching themes template classes are matched, thus allowing themes to be switched without manually mapping all templates.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(100085504189047811)
,p_validation_name=>'P902_NAME'
,p_validation_sequence=>10
,p_validation=>'P902_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(106647404038700884)
,p_associated_item=>wwv_flow_imp.id(98321416048032372)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(100087811808050032)
,p_validation_name=>'P902_THEME'
,p_validation_sequence=>20
,p_validation=>'P902_THEME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(106647404038700884)
,p_associated_item=>wwv_flow_imp.id(100010309599039923)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(73941629713235925)
,p_validation_name=>'P902_THEME unique'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_page_plug_templates',
' where flow_id                 = :fb_flow_id',
'   and security_group_id       = :workspace_id',
'   and theme_id                = :P902_THEME',
'   and page_plug_template_name = :P902_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#LABEL# must be unique.'
,p_when_button_pressed=>wwv_flow_imp.id(106647404038700884)
,p_associated_item=>wwv_flow_imp.id(100010309599039923)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(100089119080052181)
,p_validation_name=>'P902_THEME_CLASS'
,p_validation_sequence=>40
,p_validation=>'P902_THEME_CLASS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(106647404038700884)
,p_associated_item=>wwv_flow_imp.id(100084329338045600)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(589947022714621415)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(106642203907691435)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(589947198954621416)
,p_event_id=>wwv_flow_imp.id(589947022714621415)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(106971923719426285)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Region Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'wwv_flow_imp_shared.create_plug_template (',
'    p_flow_id                   => :fb_flow_id,',
'    p_page_plug_template_name   => :p902_name,',
'    p_template                  => ''#TITLE#<br />#BODY#'',',
'    p_plug_table_bgcolor        => null,',
'    p_plug_heading_bgcolor      => null,',
'    p_plug_font_size            => null,',
'    p_template_comment          => null,',
'    p_theme_id                  => :p902_theme,',
'    p_theme_class_id            => :p902_theme_class)',
'    ;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Template create failed.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(106647404038700884)
,p_process_success_message=>'Template created.'
,p_internal_uid=>106971923719426285
);
end;
/
prompt --application/pages/page_00905
begin
wwv_flow_imp_page.create_page(
 p_id=>905
,p_name=>'APEX Views'
,p_alias=>'APEX-VIEWS1'
,p_step_title=>'APEX Views'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(200467223102537626)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_utilties.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(201141632019659387)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(200452609222306546)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(201141806523661513)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(699077543075989890)
,p_plug_name=>'Workspace Utilities'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(2778715503937249)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(815124700232755186)
,p_plug_name=>'Tree'
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>50
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with data as (',
'select',
' APEX_VIEW_NAME as title,',
' APEX_VIEW_NAME as value,',
' PARENT_VIEW as parent',
'from "APEX_DICTIONARY"',
'where column_id = 0',
') ',
'select case when connect_by_isleaf = 1 then 0',
'            when level = 1             then 1',
'            else                           -1',
'       end as status, ',
'       level, ',
'       title as title, ',
'       ''icon-tree-branch'' as icon, ',
'      value as value, ',
'       null as tooltip, ',
'       ''f?p=&APP_ID.:892:''||:APP_SESSION||',
'          ''::NO:892,893,896:P892_LAST_PAGE,P892_VIEW_NAME,P893_VIEW_NAME,P896_VIEW_NAME:905,''|| ',
'          value ||'',''|| value ||'',''|| value as link ',
'from data',
'start with value = :P905_TREE_ROOT',
'connect by prior value = parent',
'order siblings by value'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_JSTREE'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'activate_node_link_with', 'S',
  'hierarchy_level_column', '"2"',
  'icon_css_class_column', '"4"',
  'link_column', '"7"',
  'node_label_column', '"3"',
  'node_status_column', '"1"',
  'node_value_column', '"5"',
  'selected_node_page_item', 'P892_VIEW_NAME',
  'static_tree_id', 'tree815124616117755186',
  'tooltip_column', '"6"',
  'tree_hierarchy', 'LEVEL',
  'tree_tooltip', 'N')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(955889910111997310)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>'&PRODUCT_NAME. Views are data dictionary views that expose the metadata for applications. In &PRODUCT_NAME. Views, you cannot only see the view, but you can also see the data they contain.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(201139918369650754)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(201141806523661513)
,p_button_name=>'COLLAPSE_ALL'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Collapse All'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.widget.tree.collapse_all(''tree815124616117755186'');'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(201140103684650755)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(201141806523661513)
,p_button_name=>'EXPAND_ALL'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Expand All'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.widget.tree.expand_all(''tree815124616117755186'');'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(201140308965650755)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(201141806523661513)
,p_button_name=>'RESET_TREE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset Tree'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:905:&SESSION.::&DEBUG.:905::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(201140712491650757)
,p_branch_action=>'f?p=&APP_ID.:905:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(201140511828650757)
,p_name=>'P905_TREE_ROOT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(201141806523661513)
,p_source=>'APEX_WORKSPACES'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_00906
begin
wwv_flow_imp_page.create_page(
 p_id=>906
,p_name=>'Update Attribute Dictionary - Items'
,p_alias=>'UPDATE-ATTRIBUTE-DICTIONARY-ITEMS'
,p_step_title=>'Update Attribute Dictionary - Items'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(261841008861828406)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'mg_attribute_dict.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(253947226137283239)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>100
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(257003828835698634)
,p_name=>'Unmatched Items'
,p_template=>wwv_flow_imp.id(208928010704475743)
,p_display_sequence=>140
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_column=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select htmldb_item.checkbox(1,i.id,''title="''||wwv_flow_lang.system_message(''WWV_FLOW_QUICK_FLOW.UPDATE'',wwv_flow_escape.html(i.name) )||''"'') chk,',
'       r.plug_name region_name,',
'       --',
'       i.id i_id, ',
'       i.name i_name, ',
'       i.prompt i_label,',
'       (select case when length(h.help_text) > 20',
'                    then wwv_flow_escape.html(substr(h.help_text,1,20))||',
'                         ''<a href="javascript:popupURL(''''f?p=4000:908:''||:APP_SESSION||',
'                         '':::908:P908_DISPLAY,P908_ID:IH,''||i.id||',
'                         '''''')" alt="''||wwv_flow_escape.html(m.v)||''" title="''||wwv_flow_escape.html(m.v)||''">...</a>''',
'                    else wwv_flow_escape.html(h.help_text)',
'                    end help_text',
'          from wwv_flow_step_item_help h',
'         where h.security_group_id  = :flow_security_group_id',
'           and h.flow_id      = :FB_FLOW_ID',
'           and h.flow_item_id = i.id ) i_help_text,',
'       i.format_mask i_format_mask,',
'       case when length(i.item_default) > 20',
'            then wwv_flow_escape.html(substr(i.item_default,1,20))||',
'                 ''<a href="javascript:popupURL(''''f?p=4000:908:''||:APP_SESSION||',
'                 '':::908:P908_DISPLAY,P908_ID:ID,''||i.id||',
'                 '''''')" alt="''||wwv_flow_escape.html(m.v)||''" title="''||wwv_flow_escape.html(m.v)||''">...</a>''',
'            else wwv_flow_escape.html(i.item_default)',
'            end i_default,',
'       --',
'       i.cSize i_width,',
'       i.cHeight i_height,',
'       i.data_type i_data_type,',
'       --',
'       case when upper(substr(i.name,1,2)) in (''P1'',''P2'',''P3'',''P4'',''P5'',''P6'',''P7'',''P8'',''P9'')',
'            then substr(i.name,instr(i.name,''_'')+1)',
'            else i.name',
'            end check_name',
'  from wwv_flow_page_plugs r,',
'       wwv_flow_step_items i,',
'       (select wwv_flow_lang.system_message(''VIEW_FOR_ALT_TAG'') v,',
'               wwv_flow_lang.system_message(''UI_DEF_CUSTOM_ITEM_TYPE'') ct',
'               from dual) m',
' where nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'   and r.security_group_id  = :flow_security_group_id',
'   and r.flow_id            = :FB_FLOW_ID',
'   and r.page_id            = :FB_FLOW_PAGE_ID',
'   and r.id                 = i.item_plug_id',
'   and nvl(i.display_when_type,''disp'') != ''NEVER''',
'   and i.display_as not in (''NATIVE_HIDDEN'',''NATIVE_STOP_AND_START_HTML_TABLE'')',
'   and i.security_group_id  = :flow_security_group_id',
'   and i.flow_id            = :FB_FLOW_ID',
'   and i.flow_step_id       = :FB_FLOW_PAGE_ID',
'   and case when upper(substr(i.name,1,2)) in (''P1'',''P2'',''P3'',''P4'',''P5'',''P6'',''P7'',''P8'',''P9'')',
'            then substr(i.name,instr(i.name,''_'')+1)',
'            else i.name',
'            end not in (select syn_name',
'                          from wwv_flow_hnt_col_dict_syn',
'                         where security_group_id  = :flow_security_group_id)'))
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No Items found.'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(257004129687698644)
,p_query_column_id=>1
,p_column_alias=>'CHK'
,p_column_display_sequence=>1
,p_column_heading=>'#CHECK_ALL_CHECKBOX#'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(257004209034698644)
,p_query_column_id=>2
,p_column_alias=>'REGION_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Region'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(257004305134698644)
,p_query_column_id=>3
,p_column_alias=>'I_ID'
,p_column_display_sequence=>3
,p_column_heading=>'I Id'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(257004402178698644)
,p_query_column_id=>4
,p_column_alias=>'I_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Item'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(257004502899698644)
,p_query_column_id=>5
,p_column_alias=>'I_LABEL'
,p_column_display_sequence=>6
,p_column_heading=>'Label'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(257004609478698645)
,p_query_column_id=>6
,p_column_alias=>'I_HELP_TEXT'
,p_column_display_sequence=>8
,p_column_heading=>'Help Text'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(257004721485698645)
,p_query_column_id=>7
,p_column_alias=>'I_FORMAT_MASK'
,p_column_display_sequence=>7
,p_column_heading=>'Format Mask'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(257004823434698645)
,p_query_column_id=>8
,p_column_alias=>'I_DEFAULT'
,p_column_display_sequence=>9
,p_column_heading=>'Default'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(257005008108698645)
,p_query_column_id=>9
,p_column_alias=>'I_WIDTH'
,p_column_display_sequence=>10
,p_column_heading=>'Width'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(257005111592698645)
,p_query_column_id=>10
,p_column_alias=>'I_HEIGHT'
,p_column_display_sequence=>11
,p_column_heading=>'Height'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(257005228658698645)
,p_query_column_id=>11
,p_column_alias=>'I_DATA_TYPE'
,p_column_display_sequence=>12
,p_column_heading=>'Data Type'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(257005314812698645)
,p_query_column_id=>12
,p_column_alias=>'CHECK_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Will Become'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(258512222599864074)
,p_plug_name=>'Update Attribute Dictionary'
,p_region_template_options=>'#DEFAULT#:a-Region--sideRegion:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>124
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_header=>'<p>The Items listed were not matched to existing columns or synonyms in the Attribute Dictionary.  Select those you wish to add and indicate which attributes you wish to include.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(452542626165543035)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>150
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(445192614743849621)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(253947802114283242)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(253947226137283239)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:912:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(253948107013283242)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(253947226137283239)
,p_button_name=>'UPDATE_AD'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Update Attribute Dictionary'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(253948005853283242)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(253947226137283239)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:890:&SESSION.::&DEBUG.:::'
,p_button_condition_type=>'NEVER'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(253948706612283243)
,p_branch_action=>'f?p=&APP_ID.:906:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(253948107013283242)
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(257005415114704150)
,p_name=>'P906_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(253947226137283239)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Page:'
,p_source=>'FB_FLOW_PAGE_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PAGES IN CURRENT APP'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id || '' - '' || name d, id r',
'  from wwv_flow_steps',
' where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_attributes=>'class="fieldtitlebold"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Selected page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(258512430132864079)
,p_name=>'P906_INCLUDE_IN_UPDATE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(253947226137283239)
,p_item_default=>'label:help_text:gen_format_mask:default:form_format_mask:width:height:data_type'
,p_prompt=>'Include in Update:'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>'STATIC2:Label;label,Help Text;help_text,General Format Mask;gen_format_mask,Default;default,Form Format Mask;form_format_mask,Width;width,Height;height,Data Type;data_type'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Identify which attributes to use in the insert.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(260798300290623018)
,p_validation_name=>'P906_INCLUDE_IN_UPDATE not null'
,p_validation_sequence=>5
,p_validation=>'P906_INCLUDE_IN_UPDATE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'You must select attributes to include in update.'
,p_when_button_pressed=>wwv_flow_imp.id(253948107013283242)
,p_associated_item=>wwv_flow_imp.id(258512430132864079)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(258534907734786941)
,p_validation_name=>'must select items to insert'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if WWV_FLOW.G_F01.COUNT = 0 then',
'   return false;',
'else',
'   return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'You must select at least one item to add.'
,p_when_button_pressed=>wwv_flow_imp.id(253948107013283242)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1157779803542618643)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(257003828835698634)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1157779965929618644)
,p_event_id=>wwv_flow_imp.id(1157779803542618643)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(258535216738789505)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Insert AD'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for i in 1..wwv_flow.g_f01.count loop',
'   wwv_flow_hint.insert_ad_from_items (',
'      p_application_id  => :FB_FLOW_ID,',
'      p_page_id         => :P906_PAGE_ID,',
'      p_item_id         => wwv_flow.g_f01(i),',
'      p_attr_to_include => :P906_INCLUDE_IN_UPDATE );',
'',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Attribute Dictionary failed to be updated.'
,p_process_when_button_id=>wwv_flow_imp.id(253948107013283242)
,p_process_success_message=>'Attribute Dictionary Updated.'
,p_internal_uid=>258535216738789505
);
end;
/
prompt --application/pages/page_00907
begin
wwv_flow_imp_page.create_page(
 p_id=>907
,p_name=>'Update Attribute Dictionary - Report Columns'
,p_alias=>'UPDATE-ATTRIBUTE-DICTIONARY-REPORT-COLUMNS'
,p_step_title=>'Update Attribute Dictionary - Report Columns'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(261841008861828406)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'mg_attribute_dict.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(253949400671283244)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>100
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(257303313315274101)
,p_name=>'Unmatched Report Columns'
,p_template=>wwv_flow_imp.id(208928010704475743)
,p_display_sequence=>140
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_column=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select htmldb_item.checkbox(1,''CR,''||rc.id,''title="''||wwv_flow_lang.system_message(''WWV_FLOW_QUICK_FLOW.UPDATE'',wwv_flow_escape.html(rc.column_alias) )||''"'') chk,',
'       r.plug_name region_name,',
'       --',
'       rc.id rc_id, ',
'       rc.column_alias rc_name, ',
'       rc.column_heading rc_label,',
'       null rc_help_text,',
'       rc.column_format rc_format_mask,',
'       --',
'       case when rc.column_alignment = ''LEFT'' then m.l',
'            when rc.column_alignment = ''CENTER'' then m.c',
'            when rc.column_alignment = ''RIGHT'' then m.r',
'            end rc_report_col_align,',
'       --',
'       m.u update_title',
'  from wwv_flow_page_plugs r,',
'       wwv_flow_region_report_column rc,',
'       (select wwv_flow_lang.system_message(''LEFT'') l,',
'               wwv_flow_lang.system_message(''CENTER'') c,',
'               wwv_flow_lang.system_message(''RIGHT'') r,',
'               wwv_flow_lang.system_message(''CONFIRM.UPDATE_PROCESS'') u',
'          from dual) m',
' where nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'   and r.security_group_id  = :flow_security_group_id',
'   and r.flow_id    = :FB_FLOW_ID',
'   and r.page_id    = :FB_FLOW_PAGE_ID',
'   and r.id         = rc.region_id',
'   and rc.hidden_column = ''N''',
'   and nvl(rc.display_when_cond_type,''disp'') != ''NEVER''',
'   and rc.security_group_id  = :flow_security_group_id',
'   and rc.flow_id            = :FB_FLOW_ID',
'   and rc.column_alias not in (',
'       select syn_name',
'         from wwv_flow_hnt_col_dict_syn',
'        where security_group_id  = :flow_security_group_id)',
'   and substr(rc.column_alias,1,6) != ''CHECK$''',
'   and substr(rc.column_alias,1,5) != ''LINK$''',
'   and substr(rc.column_alias,1,8) != ''DERIVED$''',
'union all',
'select htmldb_item.checkbox(1,''IR,''||rc.id,''title="''||wwv_flow_lang.system_message(''WWV_FLOW_QUICK_FLOW.UPDATE'',wwv_flow_escape.html(rc.db_column_name) )||''"'') chk,',
'       r.plug_name region_name,',
'       --',
'       rc.id rc_id, ',
'       rc.db_column_name rc_name, ',
'       rc.report_label rc_label,',
'       case when length(rc.help_text) > 20',
'            then wwv_flow_escape.html(substr(rc.help_text,1,20))||',
'                 ''<a href="javascript:popupURL(''''f?p=4000:908:''||:APP_SESSION||',
'                 '':::908:P908_DISPLAY,P908_ID:IRH,''||rc.id||',
'                 '''''')" alt="''||m.v||''" title="''||m.v||''">...</a>''',
'            else rc.help_text',
'            end rc_help_text,',
'       rc.format_mask rc_format_mask,',
'       --',
'       case when rc.column_alignment = ''LEFT'' then m.l',
'            when rc.column_alignment = ''CENTER'' then m.c',
'            when rc.column_alignment = ''RIGHT'' then m.r',
'            end rc_report_col_align,',
'       --',
'       m.u update_title',
'  from wwv_flow_worksheets w,',
'       wwv_flow_page_plugs r,',
'       wwv_flow_worksheet_columns rc,',
'       (select wwv_flow_lang.system_message(''LEFT'') l,',
'               wwv_flow_lang.system_message(''CENTER'') c,',
'               wwv_flow_lang.system_message(''RIGHT'') r,',
'               wwv_flow_lang.system_message(''VIEW_FOR_ALT_TAG'') v,',
'               wwv_flow_lang.system_message(''CONFIRM.UPDATE_PROCESS'') u',
'          from dual) m',
' where w.security_group_id = :flow_security_group_id',
'   and w.flow_id           = :FB_FLOW_ID',
'   and w.page_id           = :FB_FLOW_PAGE_ID',
'   and w.region_id         = r.id',
'   and r.security_group_id = :flow_security_group_id',
'   and r.flow_id           = :FB_FLOW_ID ',
'   and r.page_id           = :FB_FLOW_PAGE_ID',
'   and nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'   and w.id                = rc.worksheet_id',
'   and rc.display_text_as != ''HIDDEN''',
'   and nvl(rc.display_condition_type,''disp'') != ''NEVER''',
'   and rc.security_group_id  = :flow_security_group_id',
'   and rc.flow_id            = :FB_FLOW_ID',
'   and rc.db_column_name not in (',
'       select syn_name',
'         from wwv_flow_hnt_col_dict_syn',
'        where security_group_id  = :flow_security_group_id)'))
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No Report Columns found.'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(257303606632274112)
,p_query_column_id=>1
,p_column_alias=>'CHK'
,p_column_display_sequence=>1
,p_column_heading=>'#CHECK_ALL_CHECKBOX#'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(257303718577274112)
,p_query_column_id=>2
,p_column_alias=>'REGION_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Region'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(257303818094274112)
,p_query_column_id=>3
,p_column_alias=>'RC_ID'
,p_column_display_sequence=>3
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(257303926131274112)
,p_query_column_id=>4
,p_column_alias=>'RC_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(257304013660274113)
,p_query_column_id=>5
,p_column_alias=>'RC_LABEL'
,p_column_display_sequence=>5
,p_column_heading=>'Label'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(260804702826831888)
,p_query_column_id=>6
,p_column_alias=>'RC_HELP_TEXT'
,p_column_display_sequence=>6
,p_column_heading=>'Help Text'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(257304125154274113)
,p_query_column_id=>7
,p_column_alias=>'RC_FORMAT_MASK'
,p_column_display_sequence=>7
,p_column_heading=>'Format Mask'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(257304302138274113)
,p_query_column_id=>8
,p_column_alias=>'RC_REPORT_COL_ALIGN'
,p_column_display_sequence=>8
,p_column_heading=>'Report Column Alignment'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(940659599516194137)
,p_query_column_id=>9
,p_column_alias=>'UPDATE_TITLE'
,p_column_display_sequence=>9
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(445244432600744067)
,p_plug_name=>'Update Attribute Dictionary'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>150
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The Report Columns listed were not matched to existing columns or synonyms in the Attribute Dictionary.  Select those you wish to add and indicate which attributes you wish to include.</p>',
'',
'<p>Note: Help Text is only available within Interactive Reports. If you are inserting based upon a Standard Report, Help Text will not be used.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(452545823357589521)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>160
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(445192614743849621)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(253950009857283249)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(253949400671283244)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:912:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(253950306918283249)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(253949400671283244)
,p_button_name=>'UPDATE_AD'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Update Attribute Dictionary'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(253950920121283250)
,p_branch_action=>'f?p=&APP_ID.:907:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(257127102936646731)
,p_name=>'P907_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(253949400671283244)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Page:'
,p_source=>'FB_FLOW_PAGE_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PAGES IN CURRENT APP'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id || '' - '' || name d, id r',
'  from wwv_flow_steps',
' where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_attributes=>'class="fieldtitlebold"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Selected page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(258515324770921467)
,p_name=>'P907_INCLUDE_IN_UPDATE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(253949400671283244)
,p_item_default=>'label:help_text:gen_format_mask:rep_format_mask:rep_col_align'
,p_prompt=>'Include in Update:'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>'STATIC2:Label;label,Help Text;help_text,General Format Mask;gen_format_mask,Report Format Mask;rep_format_mask,Report Column Alignment;rep_col_align'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Identify which attributes to use in the insert.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'VERTICAL'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(260804931569840181)
,p_validation_name=>'P907_INCLUDE_IN_UPDATE not null'
,p_validation_sequence=>10
,p_validation=>'P907_INCLUDE_IN_UPDATE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'You must select attributes to include in update.'
,p_when_button_pressed=>wwv_flow_imp.id(253950306918283249)
,p_associated_item=>wwv_flow_imp.id(258515324770921467)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(260805318887846003)
,p_validation_name=>'must select rc to update'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if WWV_FLOW.G_F01.COUNT = 0 then',
'   return false;',
'else',
'   return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'You must select at least one report column to update.'
,p_when_button_pressed=>wwv_flow_imp.id(253950306918283249)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1157780090966618645)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(257303313315274101)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1157780127656618646)
,p_event_id=>wwv_flow_imp.id(1157780090966618645)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(260805523043847181)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update AD'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_rc_type    varchar2(2);',
'   l_rc_id      number;',
'begin',
'   for i in 1..wwv_flow.g_f01.count loop',
'',
'      l_rc_type   := substr(wwv_flow.g_f01(i),1,2);',
'      l_rc_id     := substr(wwv_flow.g_f01(i),4);',
'',
'      if l_rc_type = ''CR'' then',
'         wwv_flow_hint.insert_ad_from_cr(',
'            p_application_id  => :FB_FLOW_ID,',
'            p_rc_id           => l_rc_id,',
'            p_attr_to_include => :P907_INCLUDE_IN_UPDATE );',
'      elsif l_rc_type = ''IR'' then',
'         wwv_flow_hint.insert_ad_from_ir(',
'            p_application_id  => :FB_FLOW_ID,',
'            p_rc_id           => l_rc_id,',
'            p_attr_to_include => :P907_INCLUDE_IN_UPDATE );',
'      end if;',
'',
'   end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Attribute Dictionary failed to be updated.'
,p_process_when_button_id=>wwv_flow_imp.id(253950306918283249)
,p_process_success_message=>'Attribute Dictionary Updated.'
,p_internal_uid=>260805523043847181
);
end;
/
prompt --application/pages/page_00908
begin
wwv_flow_imp_page.create_page(
 p_id=>908
,p_name=>'View Attribute Dictionary Update Details'
,p_alias=>'VIEW-ATTRIBUTE-DICTIONARY-UPDATE-DETAILS'
,p_page_mode=>'MODAL'
,p_step_title=>'View Attribute Dictionary Update Details'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(261841008861828406)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'300'
,p_dialog_width=>'550'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'mg_attribute_dict.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(261974625502984560)
,p_plug_name=>'hidden'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>100
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(262095327045921693)
,p_name=>'Item Help Text'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>130
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select help_text',
'  from wwv_flow_step_item_help',
' where security_group_id = :flow_security_group_id',
'   and flow_id           = :FB_FLOW_ID',
'   and flow_item_id      = :P908_ID'))
,p_display_when_condition=>'P908_DISPLAY'
,p_display_when_cond2=>'IH'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(82408032331628644)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'no data found'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(262095609354921709)
,p_query_column_id=>1
,p_column_alias=>'HELP_TEXT'
,p_column_display_sequence=>1
,p_column_heading=>'Item Help Text'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(262095818519928660)
,p_name=>'Attribute Dictionary Column Help Text'
,p_template=>wwv_flow_imp.id(42025417508627628)
,p_display_sequence=>140
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select help_text',
'  from wwv_flow_hnt_column_dict',
' where security_group_id = :flow_security_group_id',
'   and column_id         = :P908_ID'))
,p_display_when_condition=>'P908_DISPLAY'
,p_display_when_cond2=>'ADH'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(82408032331628644)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'no data found'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(262096027026928673)
,p_query_column_id=>1
,p_column_alias=>'HELP_TEXT'
,p_column_display_sequence=>1
,p_column_heading=>'Attribute Dictionary Column Help Text'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(262096831810941953)
,p_name=>'Interactive Report Column Help Text'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>150
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select help_text',
'  from wwv_flow_worksheet_columns ',
' where security_group_id = :flow_security_group_id',
'   and flow_id           = :FB_FLOW_ID',
'   and id                = :P908_ID'))
,p_display_when_condition=>'P908_DISPLAY'
,p_display_when_cond2=>'IRH'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(82408032331628644)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'no data found'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(262097031111941959)
,p_query_column_id=>1
,p_column_alias=>'HELP_TEXT'
,p_column_display_sequence=>1
,p_column_heading=>'Interactive Report Column Help Text'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(262099000951980356)
,p_name=>'Item Default Value'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>160
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select item_default',
'  from wwv_flow_step_items',
' where security_group_id = :flow_security_group_id',
'   and flow_id           = :FB_FLOW_ID',
'   and id                = :P908_ID'))
,p_display_when_condition=>'P908_DISPLAY'
,p_display_when_cond2=>'ID'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(82408032331628644)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'no data found'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(262099402121990165)
,p_query_column_id=>1
,p_column_alias=>'ITEM_DEFAULT'
,p_column_display_sequence=>1
,p_column_heading=>'Item Default'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(262099512164993096)
,p_name=>'Attribute Dictionary Column Default Value'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>170
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select default_value',
'  from wwv_flow_hnt_column_dict',
' where security_group_id = :flow_security_group_id',
'   and column_id         = :P908_ID'))
,p_display_when_condition=>'P908_DISPLAY'
,p_display_when_cond2=>'ADD'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(82408032331628644)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'no data found'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(262100030172998264)
,p_query_column_id=>1
,p_column_alias=>'DEFAULT_VALUE'
,p_column_display_sequence=>1
,p_column_heading=>'Default Value'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1059809491578457631)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>180
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1059809557950457632)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1059809491578457631)
,p_button_name=>'Close'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Close'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(261975027889032552)
,p_name=>'P908_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(261974625502984560)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(261975226461032555)
,p_name=>'P908_DISPLAY'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(261974625502984560)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1059809663837457633)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1059809557950457632)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1059809795498457634)
,p_event_id=>wwv_flow_imp.id(1059809663837457633)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00911
begin
wwv_flow_imp_page.create_page(
 p_id=>911
,p_name=>'Upgrade Application'
,p_alias=>'UPGRADE-APPLICATION3'
,p_step_title=>'Upgrade Application'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_utilties.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(459818721194755532)
,p_plug_name=>'Upgrade Objects'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>40
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 checkbox,',
'       n001 page_id,',
'       c002 page_name,',
'       c003 group_name,',
'       c004 region_name,',
'       c005 name,',
'       c006 additional_info,',
'       c007 page_locked_by',
'  from wwv_flow_collections',
' where collection_name = ''UPGRADE_REPORT'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P911_UPGRADE_TYPE'
,p_plug_display_when_cond2=>'ADVANCED'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(459818932676755539)
,p_name=>'Migration Objects'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No objects found for upgrade.'
,p_max_rows_per_page=>'10000'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y_OF_Z'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_control_break=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_show_download=>'N'
,p_enable_mail_download=>'N'
,p_owner=>'SATHISH'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(459819218561755552)
,p_db_column_name=>'CHECKBOX'
,p_display_order=>1
,p_column_identifier=>'C'
,p_column_label=>'#CHECK_ALL_CHECKBOX#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_rpt_show_filter_lov=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(484840606450750527)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>2
,p_column_identifier=>'F'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(504037023650476602)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>3
,p_column_identifier=>'I'
,p_column_label=>'Page Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(504037122389476605)
,p_db_column_name=>'GROUP_NAME'
,p_display_order=>4
,p_column_identifier=>'J'
,p_column_label=>'Page Group'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(484840715006750529)
,p_db_column_name=>'REGION_NAME'
,p_display_order=>5
,p_column_identifier=>'G'
,p_column_label=>'Region'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(459840332076901035)
,p_db_column_name=>'NAME'
,p_display_order=>6
,p_column_identifier=>'E'
,p_column_label=>'Object Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(484840810594750529)
,p_db_column_name=>'ADDITIONAL_INFO'
,p_display_order=>7
,p_column_identifier=>'H'
,p_column_label=>'Additional Information'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(636376719124823054)
,p_db_column_name=>'PAGE_LOCKED_BY'
,p_display_order=>8
,p_column_identifier=>'K'
,p_column_label=>'Page Locked By'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(459819312528755553)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1293128772536644'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_display_rows=>10000
,p_report_columns=>'CHECKBOX:PAGE_ID:PAGE_NAME:REGION_NAME:NAME:ADDITIONAL_INFO:PAGE_LOCKED_BY'
,p_sort_column_1=>'PAGE_ID'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'REGION_NAME'
,p_sort_direction_2=>'ASC NULLS FIRST'
,p_sort_column_3=>'NAME'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(459819521566755556)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(459819916170755560)
,p_plug_name=>'Upgrade Application'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'To upgrade objects within the application, select the Upgrade Type, the objects you wish to upgrade, and click the Upgrade button.',
'</p>',
'<p>',
'Note that locked pages and items with unsupported date formats are not available for upgrade.',
'</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P911_UPGRADE_TYPE'
,p_plug_display_when_cond2=>'ADVANCED'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(629199521925023238)
,p_plug_name=>'Value Required updates'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The following items have unconditional NOT NULL validations.  If selected for Upgrade, the Value Required will be set to Yes and the now unnecessary NOT NULL validation will be deleted.</p>',
'<p>',
'Note that items on locked pages are not available for upgrade.',
'</p>'))
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P911_UPGRADE_TYPE'
,p_plug_display_when_cond2=>'REQUIRED'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(629201104395027632)
,p_plug_name=>'Numeric updates'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The following text items have unconditional Numeric validations.  If selected for Upgrade, the Display As will be updated to Number Field and the now unnecessary Numeric validation will be deleted.</p>',
'<p>',
'Note that items on locked pages are not available for upgrade.',
'</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P911_UPGRADE_TYPE'
,p_plug_display_when_cond2=>'NUMBER_FIELD'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(629368723063306478)
,p_plug_name=>'Advanced'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'You must review these validations by page to determine which you want remove and replace with Item settings.  The Not Null will set Value Required to Yes, the Numeric will change the Display As to number field and the Valid Date will change the item '
||'to a date picker (if it is not one already).  You will also identify if you want to update any buttons on the page to not execute validations (such as Cancel and Delete buttons) and identify any remaining validations that you want to set to always ex'
||'ecute.',
'</p>',
'<p>',
'Note that locked pages and items with unsupported date formats are not available for upgrade.',
'</p>',
'<p>',
'Select a page number to proceed.',
'</p>'))
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P911_UPGRADE_TYPE'
,p_plug_display_when_cond2=>'ADVANCED'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(629377227228383306)
,p_name=>'for Advanced'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>60
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 page,',
'       c002 page_name,',
'       c004 item_name,',
'       c006 validation_type,',
'       c005 validation_name,',
'       c007 button_name,',
'       c008 condition,',
'       c009 additional_info,',
'       c010 page_locked_by',
'  from wwv_flow_collections',
' where collection_name = ''ADV_UPGRADE_REPORT''',
' order by n001, c006, c004'))
,p_display_when_condition=>'P911_UPGRADE_TYPE'
,p_display_when_cond2=>'ADVANCED'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1:2:3'
,p_query_no_data_found=>'No objects found for upgrade.'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(636443117577336265)
,p_query_column_id=>1
,p_column_alias=>'PAGE'
,p_column_display_sequence=>1
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(629377704112383372)
,p_query_column_id=>2
,p_column_alias=>'PAGE_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Page Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(636443221541336265)
,p_query_column_id=>3
,p_column_alias=>'ITEM_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Item Name'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(630867829252246491)
,p_query_column_id=>4
,p_column_alias=>'VALIDATION_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Validation Type'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(630881727193397263)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(636443312566336265)
,p_query_column_id=>5
,p_column_alias=>'VALIDATION_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Validation Name'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(629378214516383372)
,p_query_column_id=>6
,p_column_alias=>'BUTTON_NAME'
,p_column_display_sequence=>6
,p_column_heading=>'Associated Button'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(629378319416383373)
,p_query_column_id=>7
,p_column_alias=>'CONDITION'
,p_column_display_sequence=>7
,p_column_heading=>'Condition'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(13602414170805697)
,p_lov_show_nulls=>'YES'
,p_lov_null_text=>'&nbsp;'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(636444526460405035)
,p_query_column_id=>8
,p_column_alias=>'ADDITIONAL_INFO'
,p_column_display_sequence=>9
,p_column_heading=>'Additional Information'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(636443420452336265)
,p_query_column_id=>9
,p_column_alias=>'PAGE_LOCKED_BY'
,p_column_display_sequence=>8
,p_column_heading=>'Page Locked By'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(615719720175923103)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(459819521566755556)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:89:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(459819723958755558)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(459819521566755556)
,p_button_name=>'UPGRADE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Upgrade'
,p_button_position=>'CREATE'
,p_button_condition=>'P911_UPGRADE_TYPE'
,p_button_condition2=>'ADVANCED'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(615549511693641827)
,p_branch_action=>'f?p=&APP_ID.:911:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>129
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(459822501986775349)
,p_name=>'P911_UPGRADE_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(459819521566755556)
,p_prompt=>'Upgrade Type'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'UPGRADE_APPLICATION_OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(484799616606261493)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the upgrade type to be performed.'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(459821216410755578)
,p_validation_name=>'Update requires object selection'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if WWV_FLOW.G_F01.COUNT = 0 then',
'   return false;',
'else',
'   return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'You must select at least one object to Upgrade.'
,p_when_button_pressed=>wwv_flow_imp.id(459819723958755558)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(617309980105937210)
,p_validation_name=>'upgrade tabular from to IG check'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_error_cnt pls_integer := 0;',
'begin',
'    if :P911_UPGRADE_TYPE = ''TABULAR_TO_IG'' then',
'        for i in 1..wwv_flow.g_f01.count',
'        loop',
'            for l_region in (select plug_source',
'                             from wwv_flow_page_plugs',
'                             where plug_source_type = wwv_flow_region_native.c_tabform',
'                             and flow_id = :fb_flow_id',
'                             and id = wwv_flow.g_f01(i)',
'                             and security_group_id = wwv_flow_security.g_security_group_id )',
'            loop',
'                if wwv_flow_f4000_util.is_query_with_order_by ( l_region.plug_source ) then',
'                    l_error_cnt := l_error_cnt + 1;',
'                end if;',
'            end loop;',
'        end loop;',
'    ',
'        -- raise error only if all selected tabular form region contains order by clause',
'        if l_error_cnt = wwv_flow.g_f01.count then',
'            return false;',
'        end if;',
'        return true;',
'    ',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'The selected tabular form contains order by clause and cannot upgrade to interactive grid.'
,p_when_button_pressed=>wwv_flow_imp.id(459819723958755558)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'NOTE: this validation was firing regardless of whether an IG upgrade was occurring, so I moved the "if l_error_cnt.." IF statement inside the main IF statement, to only fire when doing a Tabular Form to IG upgrade'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1952252380076322150)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(459818721194755532)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2045580452067367801)
,p_event_id=>wwv_flow_imp.id(1952252380076322150)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(459821423542755582)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update Selected Objects '
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_upgrade_app.update_selected_objects (',
'    p_flow_id       => :fb_flow_id,',
'    p_upgrade_type  => :P911_UPGRADE_TYPE',
');'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to upgrade selected Object(s). #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(459819723958755558)
,p_process_success_message=>'Selected Object(s) upgraded successfully.'
,p_internal_uid=>459821423542755582
,p_process_comment=>'identify the list of pages to be locked.'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(636374020677785631)
,p_process_sequence=>70
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load Report Collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P911_UPGRADE_TYPE = ''ADVANCED'' then',
'   wwv_flow_upgrade_app.create_adv_report_collection (',
'      p_app_id       => :FB_FLOW_ID,',
'      p_user         => :APP_USER,',
'      p_session_id   => :APP_SESSION);',
'else',
'   wwv_flow_upgrade_app.create_report_collection (',
'      p_upgrade_type => :P911_UPGRADE_TYPE,',
'      p_app_id       => :FB_FLOW_ID,',
'      p_user         => :APP_USER);',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>636374020677785631
);
end;
/
prompt --application/pages/page_00912
begin
wwv_flow_imp_page.create_page(
 p_id=>912
,p_name=>'Attribute Dictionary'
,p_alias=>'ATTRIBUTE-DICTIONARY1'
,p_step_title=>'Attribute Dictionary'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(262745606420610180)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'mg_attribute_dict.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(428477309029372008)
,p_plug_name=>'Manage Attribute Dictionary'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>15
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p/>',
'You can update the current page using the Attribute Dictionary or use the current page to update the Attribute Dictionary.  Only Items and Report Columns that have different values for at least one attribute will be shown.  You choose which objects t'
||'o insert or update and which attributes to include.',
'<p/>',
'The number of Items and Report Columns that can be used might be less than the total because hidden objects, objects in hidden regions, and button items are not included.'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(445128905572834709)
,p_plug_name=>'stats'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NEVER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(445193312547849631)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(445192614743849621)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(445264628987932285)
,p_plug_name=>'Page Items'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>2
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_column_width=>'apex-col--bottomBorder'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(428347522219852565)
,p_name=>'Summary'
,p_parent_plug_id=>wwv_flow_imp.id(445264628987932285)
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>25
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--simple'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select v(''P912_I_TOTAL_PAGE_ITEMS'') ti, ',
'       v(''P912_I_DISPLAYED_ITEMS'') ci,',
'       v(''P912_I_POTENTIAL_UPDATES'') mi,',
'       v(''P912_I_IDENTICAL_ATTRIBUTES'') fmi,',
'       v(''P912_I_POTENTIAL_NEW_ENTRIES'') ui',
'  from dual'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(1041645860037406591)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'no data found'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(428435702665010621)
,p_query_column_id=>1
,p_column_alias=>'TI'
,p_column_display_sequence=>1
,p_column_heading=>'Total Page Items'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(428435802326010621)
,p_query_column_id=>2
,p_column_alias=>'CI'
,p_column_display_sequence=>2
,p_column_heading=>'Displayed Items'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(428435907070010621)
,p_query_column_id=>3
,p_column_alias=>'MI'
,p_column_display_sequence=>4
,p_column_heading=>'Potential Updates'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(428436026329010621)
,p_query_column_id=>4
,p_column_alias=>'FMI'
,p_column_display_sequence=>5
,p_column_heading=>'Identical Attributes'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(428436125920010621)
,p_query_column_id=>5
,p_column_alias=>'UI'
,p_column_display_sequence=>3
,p_column_heading=>'Potential New Entries'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(444812425780707388)
,p_plug_name=>'Update Page'
,p_parent_plug_id=>wwv_flow_imp.id(445264628987932285)
,p_region_css_classes=>'a-Region--touchTop'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--simple'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>5
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_text  varchar2(4000);',
'begin',
'',
'   if :P912_I_POTENTIAL_UPDATES > 0 then',
'      l_text := ''<a href="f?p=4000:921:&APP_SESSION.:::921">'' ||',
'             wwv_flow_lang.system_message(''4000.912.REVIEW.N.ITEMS.FOR.UPDATE'',',
'             :P912_I_POTENTIAL_UPDATES) || ''</a>'';',
'   else',
'      l_text := wwv_flow_lang.system_message(''4000.912.0.ITEMS.FOR.UPDATE'');',
'   end if;',
'',
'   sys.htp.p(''<ul class="a-List a-List--links">'');',
'   sys.htp.p(''<li>'' || wwv_flow_escape.noop(l_text) || ''</li>'');',
'   sys.htp.p(''</ul>'');',
'',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(444827907959815706)
,p_plug_name=>'Update Attribute Dictionary'
,p_parent_plug_id=>wwv_flow_imp.id(445264628987932285)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--simple'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_text1  varchar2(4000);',
'   l_text2  varchar2(4000);',
'begin',
'',
'   if :P912_I_POTENTIAL_NEW_ENTRIES > 0 then',
'      l_text1 := ''<a class="a-LinksList-link"  href="f?p=4000:906:&APP_SESSION.:::906"><span class="a-LinksList-label">'' ||',
'      wwv_flow_lang.system_message(''4000:912:REVIEW.N.ITEMS.FOR.INSERT.INTO.AD'',',
'      :P912_I_POTENTIAL_NEW_ENTRIES) || ''</span></a>'';',
'   else l_text1 := ',
'        wwv_flow_lang.system_message(''4000.912.0.ITEMS.FOR.INSERT.INTO.AD'');',
'   end if;',
'',
'   if :P912_I_POTENTIAL_UPDATES > 0 then',
'      l_text2 := ''<a class="a-LinksList-link" href="f?p=4000:890:&APP_SESSION.:::890"><span class="a-LinksList-label">'' ||',
'      wwv_flow_lang.system_message(''4000:912:REVIEW.N.ITEMS.FOR.UPDATE.OF.AD'',',
'      :P912_I_POTENTIAL_UPDATES) || ''</span></a>'';',
'   else l_text2 := ',
'        wwv_flow_lang.system_message(''4000.912.0.ITEMS.FOR.UPDATE.OF.AD'');',
'   end if;',
'',
'   sys.htp.p(''<ul class="a-LinksList">'');',
'   sys.htp.p(''<li class="a-LinksList-item">'' || wwv_flow_escape.noop(l_text1) || ''</li>'');',
'   sys.htp.p(''<li class="a-LinksList-item">'' || wwv_flow_escape.noop(l_text2) || ''</li>'');',
'   sys.htp.p(''</ul>'');',
'',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(445264907647935567)
,p_plug_name=>'Report Columns'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>3
,p_plug_new_grid_row=>false
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_column_width=>'apex-col--leftBorder apex-col--bottomBorder'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(428433402956906644)
,p_name=>'Summary'
,p_parent_plug_id=>wwv_flow_imp.id(445264907647935567)
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--simple'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select v(''P912_RC_TOTAL_RC'') trc, ',
'       v(''P912_RC_DISPLAYED_RC'') crc,',
'       v(''P912_RC_POTENTIAL_UPDATES'') mrc,',
'       v(''P912_RC_IDENTICAL_ATTRIBUTES'') fmrc,',
'       v(''P912_RC_POTENTIAL_NEW_ENTRIES'')urc',
'  from dual',
''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(1041645860037406591)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'no data found'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(428434515862967193)
,p_query_column_id=>1
,p_column_alias=>'TRC'
,p_column_display_sequence=>1
,p_column_heading=>'Total Report Columns'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(428434630602967193)
,p_query_column_id=>2
,p_column_alias=>'CRC'
,p_column_display_sequence=>2
,p_column_heading=>'Displayed Report Columns'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(428434705097967194)
,p_query_column_id=>3
,p_column_alias=>'MRC'
,p_column_display_sequence=>4
,p_column_heading=>'Potential Updates'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(428434803867967194)
,p_query_column_id=>4
,p_column_alias=>'FMRC'
,p_column_display_sequence=>5
,p_column_heading=>'Identical Attributes'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(428434917315967195)
,p_query_column_id=>5
,p_column_alias=>'URC'
,p_column_display_sequence=>3
,p_column_heading=>'Potential New Entries'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(445206821107210969)
,p_plug_name=>'Update Attribute Dictionary'
,p_parent_plug_id=>wwv_flow_imp.id(445264907647935567)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--simple'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>21
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_text1  varchar2(4000);',
'   l_text2  varchar2(4000);',
'begin',
'',
'   if :P912_RC_POTENTIAL_NEW_ENTRIES > 0 then',
'      l_text1 := ''<a href="f?p=4000:907:&APP_SESSION.:::907">'' ||',
'      wwv_flow_lang.system_message(''4000:912:REVIEW.N.RC.FOR.INSERT.INTO.AD'',',
'      :P912_RC_POTENTIAL_NEW_ENTRIES) || ''</a>'';',
'   else l_text1 := ',
'        wwv_flow_lang.system_message(''4000.912.0.ITEMS.FOR.INSERT.INTO.AD'');',
'   end if;',
'',
'   if :P912_RC_POTENTIAL_UPDATES > 0 then',
'      l_text2 := ''<a href="f?p=4000:897:&APP_SESSION.:::897">'' ||',
'      wwv_flow_lang.system_message(''4000:912:REVIEW.N.RC.FOR.UPDATE.OF.AD'',',
'      :P912_RC_POTENTIAL_UPDATES) || ''</a>'';',
'   else l_text2 := ',
'        wwv_flow_lang.system_message(''4000.912.0.RC.FOR.UPDATE.OF.AD'');',
'   end if;',
'',
'   sys.htp.p(''<ul class="a-List a-List--links">'');',
'   sys.htp.p(''<li>'' || l_text1 || ''</li>'');',
'   sys.htp.p(''<li>'' || l_text2 || ''</li>'');',
'   sys.htp.p(''</ul>'');',
'',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(445234512365577430)
,p_plug_name=>'Update Page'
,p_parent_plug_id=>wwv_flow_imp.id(445264907647935567)
,p_region_css_classes=>'a-Region--touchTop'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--simple'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>7
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_text  varchar2(4000);',
'begin',
'',
'   if :P912_RC_POTENTIAL_UPDATES > 0 then',
'      l_text := ''<a href="f?p=4000:922:&APP_SESSION.:::922">'' ||',
'          wwv_flow_lang.system_message(''4000:912:REVIEW.N.RC.FOR.UPDATE'',',
'          :P912_RC_POTENTIAL_UPDATES) || ''</a>'';',
'   else',
'      l_text := wwv_flow_lang.system_message(''4000:912:0.RC.FOR.UPDATE'');',
'   end if;',
'',
'   sys.htp.p(''<ul class="a-List a-List--links">'');',
'   sys.htp.p(''<li>'' || wwv_flow_escape.noop(l_text) || ''</li>'');',
'   sys.htp.p(''</ul>'');',
'',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(445275611700154288)
,p_name=>'P912_I_TOTAL_PAGE_ITEMS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(445128905572834709)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(445275828494154346)
,p_name=>'P912_I_DISPLAYED_ITEMS'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(445128905572834709)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(445276028113154347)
,p_name=>'P912_I_POTENTIAL_NEW_ENTRIES'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(445128905572834709)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(445276211981154347)
,p_name=>'P912_I_POTENTIAL_UPDATES'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(445128905572834709)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(445276430394154348)
,p_name=>'P912_I_IDENTICAL_ATTRIBUTES'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(445128905572834709)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(445276623399154348)
,p_name=>'P912_RC_TOTAL_RC'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(445128905572834709)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(445276814596154349)
,p_name=>'P912_RC_DISPLAYED_RC'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(445128905572834709)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(445277023643154350)
,p_name=>'P912_RC_POTENTIAL_NEW_ENTRIES'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(445128905572834709)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(445277230235154351)
,p_name=>'P912_RC_POTENTIAL_UPDATES'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(445128905572834709)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(445277429291154351)
,p_name=>'P912_RC_IDENTICAL_ATTRIBUTES'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(445128905572834709)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(445136928953879226)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Compute Item Stats'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'',
'select ti.cnt ti, ',
'       di.cnt di,',
'       mi.cnt - fmi.cnt mi,',
'       fmi.cnt fmi,',
'       ui.cnt ui',
'  from',
'(select count(*) cnt',
'      from wwv_flow_step_items i,',
'           wwv_flow_page_plugs r',
'     where i.security_group_id  = :flow_security_group_id',
'       and i.flow_id            = :FB_FLOW_ID ',
'       and i.flow_step_id       = :FB_FLOW_PAGE_ID',
'       and i.item_plug_id       = r.id  ',
'       and r.security_group_id  = :flow_security_group_id',
'       and r.flow_id            = :FB_FLOW_ID ',
'       and r.page_id            = :FB_FLOW_PAGE_ID) ti,',
'(select count(*) cnt',
'      from wwv_flow_step_items i,',
'           wwv_flow_page_plugs r',
'     where nvl(i.display_when_type,''disp'') != ''NEVER''',
'       and i.display_as not in (''NATIVE_HIDDEN'',''NATIVE_STOP_AND_START_HTML_TABLE'')',
'       and i.security_group_id  = :flow_security_group_id',
'       and i.flow_id            = :FB_FLOW_ID ',
'       and i.flow_step_id       = :FB_FLOW_PAGE_ID',
'       and i.item_plug_id       = r.id  ',
'       and nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'       and r.security_group_id  = :flow_security_group_id',
'       and r.flow_id            = :FB_FLOW_ID ',
'       and r.page_id            = :FB_FLOW_PAGE_ID) di,',
'(select count(*) cnt',
'  from wwv_flow_page_plugs r,',
'       wwv_flow_step_items i,',
'       wwv_flow_hnt_column_dict ad,',
'       wwv_flow_hnt_col_dict_syn ads',
' where nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'   and r.security_group_id  = :flow_security_group_id',
'   and r.flow_id            = :FB_FLOW_ID',
'   and r.page_id            = :FB_FLOW_PAGE_ID',
'   and r.id                 = i.item_plug_id',
'   and nvl(i.display_when_type,''disp'') != ''NEVER''',
'   and i.display_as not in (''NATIVE_HIDDEN'',''NATIVE_STOP_AND_START_HTML_TABLE'')',
'   and i.security_group_id  = :flow_security_group_id',
'   and i.flow_id            = :FB_FLOW_ID',
'   and i.flow_step_id       = :FB_FLOW_PAGE_ID',
'   and ad.security_group_id = :flow_security_group_id',
'   and ad.column_id         = ads.column_id',
'   and ads.security_group_id = :flow_security_group_id',
'   and case when upper(substr(i.name,1,2)) in (''P1'',''P2'',''P3'',''P4'',''P5'',''P6'',''P7'',''P8'',''P9'')',
'            then substr(i.name,instr(i.name,''_'')+1)',
'            else i.name',
'            end = ads.syn_name) mi,',
'(select count(*) cnt',
'  from wwv_flow_page_plugs r,',
'       wwv_flow_step_items i,',
'       wwv_flow_step_item_help h,',
'       wwv_flow_hnt_column_dict ad,',
'       wwv_flow_hnt_col_dict_syn ads',
' where nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'   and r.security_group_id  = :flow_security_group_id',
'   and r.flow_id            = :FB_FLOW_ID',
'   and r.page_id            = :FB_FLOW_PAGE_ID',
'   and r.id                 = i.item_plug_id',
'   and nvl(i.display_when_type,''disp'') != ''NEVER''',
'   and i.display_as not in (''NATIVE_HIDDEN'',''NATIVE_STOP_AND_START_HTML_TABLE'')',
'   and i.security_group_id  = :flow_security_group_id',
'   and i.flow_id            = :FB_FLOW_ID',
'   and i.flow_step_id       = :FB_FLOW_PAGE_ID',
'   and h.flow_item_id (+)   = i.id',
'   and ad.security_group_id = :flow_security_group_id',
'   and ad.column_id         = ads.column_id',
'   and ads.security_group_id = :flow_security_group_id',
'   and case when upper(substr(i.name,1,2)) in (''P1'',''P2'',''P3'',''P4'',''P5'',''P6'',''P7'',''P8'',''P9'')',
'            then substr(i.name,instr(i.name,''_'')+1)',
'            else i.name',
'            end = ads.syn_name',
'   and (nvl(i.prompt,''0'') = nvl(ad.label,''0'') or ',
'        i.prompt = ad.label||'':'')',
'   and nvl(h.help_text,''0'')    = nvl(ad.help_text,''0'')',
'   and nvl(i.format_mask,''0'')  = nvl(ad.format_mask,''0'')',
'   and nvl(i.item_default,''0'') = nvl(ad.default_value,''0'')',
'   and nvl(i.format_mask,''0'')  = nvl(ad.form_format_mask,''0'')',
'   and nvl(i.cSize,0)          = nvl(ad.form_display_width,0)',
'   and nvl(i.cHeight,0)        = nvl(ad.form_display_height,0)',
'   and nvl(i.data_type,''0'')    = nvl(ad.form_data_type,''0'') ) fmi,',
'(select count(*) cnt',
'  from wwv_flow_page_plugs r,',
'       wwv_flow_step_items i',
' where nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'   and r.security_group_id  = :flow_security_group_id',
'   and r.flow_id            = :FB_FLOW_ID',
'   and r.page_id            = :FB_FLOW_PAGE_ID',
'   and r.id                 = i.item_plug_id',
'   and nvl(i.display_when_type,''disp'') != ''NEVER''',
'   and i.display_as not in (''NATIVE_HIDDEN'',''NATIVE_STOP_AND_START_HTML_TABLE'')',
'   and i.security_group_id  = :flow_security_group_id',
'   and i.flow_id            = :FB_FLOW_ID',
'   and i.flow_step_id       = :FB_FLOW_PAGE_ID',
'   and case when upper(substr(i.name,1,2)) in (''P1'',''P2'',''P3'',''P4'',''P5'',''P6'',''P7'',''P8'',''P9'')',
'            then substr(i.name,instr(i.name,''_'')+1)',
'            else i.name',
'            end not in (select syn_name',
'                          from wwv_flow_hnt_col_dict_syn',
'                         where security_group_id  = :flow_security_group_id) ) ui',
')',
'',
'loop',
'   :P912_I_TOTAL_PAGE_ITEMS      := c1.ti;',
'   :P912_I_DISPLAYED_ITEMS       := c1.di;',
'   :P912_I_POTENTIAL_NEW_ENTRIES := c1.ui;	',
'   :P912_I_POTENTIAL_UPDATES     := c1.mi;',
'   :P912_I_IDENTICAL_ATTRIBUTES  := c1.fmi;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>445136928953879226
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(445281727677187338)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Compute Report Column Stats'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'',
'select trc1.cnt + trc2.cnt trc, ',
'       crc1.cnt + crc2.cnt crc,',
'       mrc1.cnt + mrc2.cnt - fmrc1.cnt - fmrc2.cnt mrc,',
'       fmrc1.cnt + fmrc2.cnt fmrc,',
'       urc1.cnt + urc2.cnt urc',
'  from',
'(select count(*) cnt',
'      from wwv_flow_region_report_column rc,',
'           wwv_flow_page_plugs r',
'     where rc.security_group_id = :flow_security_group_id',
'       and rc.flow_id           = :FB_FLOW_ID',
'       and rc.region_id         = r.id',
'       and r.security_group_id  = :flow_security_group_id',
'       and r.flow_id            = :FB_FLOW_ID',
'       and r.page_id            = :FB_FLOW_PAGE_ID) trc1,',
'(select count(*) cnt',
'         from wwv_flow_worksheet_columns wc,',
'              wwv_flow_worksheets w,',
'              wwv_flow_page_plugs r',
'        where wc.security_group_id = :flow_security_group_id',
'          and wc.flow_id           = :FB_FLOW_ID',
'          and wc.worksheet_id      = w.id',
'          and w.security_group_id  = :flow_security_group_id',
'          and w.flow_id            = :FB_FLOW_ID',
'          and w.page_id            = :FB_FLOW_PAGE_ID',
'          and w.region_id          = r.id',
'          and r.security_group_id  = :flow_security_group_id',
'          and r.flow_id            = :FB_FLOW_ID',
'          and r.page_id            = :FB_FLOW_PAGE_ID) trc2,',
'(select count(*) cnt',
'      from wwv_flow_region_report_column rc,',
'           wwv_flow_page_plugs r',
'     where rc.hidden_column = ''N''',
'       and nvl(rc.display_when_cond_type,''disp'') != ''NEVER''',
'       and rc.security_group_id = :flow_security_group_id',
'       and rc.flow_id           = :FB_FLOW_ID',
'       and rc.region_id         = r.id',
'       and nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'       and r.security_group_id  = :flow_security_group_id',
'       and r.flow_id            = :FB_FLOW_ID',
'       and r.page_id            = :FB_FLOW_PAGE_ID',
'       and substr(rc.column_alias,1,6) != ''CHECK$''',
'       and substr(rc.column_alias,1,5) != ''LINK$''',
'       and substr(rc.column_alias,1,8) != ''DERIVED$'' ) crc1,',
'(select count(*) cnt',
'         from wwv_flow_worksheet_columns wc,',
'              wwv_flow_worksheets w,',
'              wwv_flow_page_plugs r',
'        where nvl(wc.display_text_as,''disp'') != ''HIDDEN''',
'          and wc.security_group_id = :flow_security_group_id',
'          and wc.flow_id           = :FB_FLOW_ID',
'          and wc.worksheet_id      = w.id',
'          and w.security_group_id  = :flow_security_group_id',
'          and w.flow_id            = :FB_FLOW_ID',
'          and w.page_id            = :FB_FLOW_PAGE_ID',
'          and w.region_id          = r.id',
'          and nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'          and r.security_group_id  = :flow_security_group_id',
'          and r.flow_id            = :FB_FLOW_ID',
'          and r.page_id            = :FB_FLOW_PAGE_ID) crc2,',
'(select count(*) cnt',
'  from wwv_flow_page_plugs r,',
'       wwv_flow_region_report_column rc,',
'       wwv_flow_hnt_column_dict ad,',
'       wwv_flow_hnt_col_dict_syn ads',
' where nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'   and r.security_group_id  = :flow_security_group_id',
'   and r.flow_id    = :FB_FLOW_ID',
'   and r.page_id    = :FB_FLOW_PAGE_ID',
'   and r.id         = rc.region_id',
'   and rc.hidden_column = ''N''',
'   and nvl(rc.display_when_cond_type,''disp'') != ''NEVER''',
'   and rc.security_group_id  = :flow_security_group_id',
'   and rc.flow_id            = :FB_FLOW_ID',
'   and rc.column_alias       =  ads.syn_name',
'   and substr(rc.column_alias,1,6) != ''CHECK$''',
'   and substr(rc.column_alias,1,5) != ''LINK$''',
'   and substr(rc.column_alias,1,8) != ''DERIVED$''',
'   and ad.security_group_id  = :flow_security_group_id',
'   and ad.column_id          = ads.column_id',
'   and ads.security_group_id = :flow_security_group_id ) mrc1,',
'(select  count(*) cnt',
'  from wwv_flow_worksheets w,',
'       wwv_flow_page_plugs r,',
'       wwv_flow_worksheet_columns rc,',
'       wwv_flow_hnt_column_dict ad,',
'       wwv_flow_hnt_col_dict_syn ads',
' where w.security_group_id = :flow_security_group_id',
'   and w.flow_id           = :FB_FLOW_ID',
'   and w.page_id           = :FB_FLOW_PAGE_ID',
'   and w.region_id         = r.id',
'   and r.security_group_id = :flow_security_group_id',
'   and r.flow_id           = :FB_FLOW_ID ',
'   and r.page_id           = :FB_FLOW_PAGE_ID',
'   and nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'   and w.id                = rc.worksheet_id',
'   and rc.display_text_as != ''HIDDEN''',
'   and nvl(rc.display_condition_type,''disp'') != ''NEVER''',
'   and rc.security_group_id  = :flow_security_group_id',
'   and rc.flow_id            = :FB_FLOW_ID',
'   and rc.db_column_name     =  ads.syn_name',
'   and ad.security_group_id  = :flow_security_group_id',
'   and ad.column_id          = ads.column_id',
'   and ads.security_group_id = :flow_security_group_id) mrc2,',
'(select count(*) cnt',
'  from wwv_flow_page_plugs r,',
'       wwv_flow_region_report_column rc,',
'       wwv_flow_hnt_column_dict ad,',
'       wwv_flow_hnt_col_dict_syn ads',
' where nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'   and r.security_group_id  = :flow_security_group_id',
'   and r.flow_id    = :FB_FLOW_ID',
'   and r.page_id    = :FB_FLOW_PAGE_ID',
'   and r.id         = rc.region_id',
'   and rc.hidden_column = ''N''',
'   and nvl(rc.display_when_cond_type,''disp'') != ''NEVER''',
'   and rc.security_group_id  = :flow_security_group_id',
'   and rc.flow_id            = :FB_FLOW_ID',
'   and rc.column_alias       =  ads.syn_name',
'   and substr(rc.column_alias,1,6) != ''CHECK$''',
'   and substr(rc.column_alias,1,5) != ''LINK$''',
'   and substr(rc.column_alias,1,8) != ''DERIVED$''',
'   and ad.security_group_id  = :flow_security_group_id',
'   and ad.column_id          = ads.column_id',
'   and ads.security_group_id = :flow_security_group_id',
'   and nvl(rc.column_heading,''0'')   = nvl(ad.label,''0'')',
'   and nvl(rc.column_format,''0'')    = nvl(ad.format_mask,''0'')',
'   and nvl(rc.column_format,''0'')    = nvl(ad.report_format_mask,''0'')',
'   and nvl(rc.column_alignment,''0'') = nvl(ad.report_col_alignment,''0'') ) fmrc1,',
'(select count(*) cnt',
'  from wwv_flow_worksheets w,',
'       wwv_flow_page_plugs r,',
'       wwv_flow_worksheet_columns rc,',
'       wwv_flow_hnt_column_dict ad,',
'       wwv_flow_hnt_col_dict_syn ads',
' where w.security_group_id = :flow_security_group_id',
'   and w.flow_id           = :FB_FLOW_ID',
'   and w.page_id           = :FB_FLOW_PAGE_ID',
'   and w.region_id         = r.id',
'   and r.security_group_id = :flow_security_group_id',
'   and r.flow_id           = :FB_FLOW_ID ',
'   and r.page_id           = :FB_FLOW_PAGE_ID',
'   and nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'   and w.id                = rc.worksheet_id',
'   and rc.display_text_as != ''HIDDEN''',
'   and nvl(rc.display_condition_type,''disp'') != ''NEVER''',
'   and rc.security_group_id  = :flow_security_group_id',
'   and rc.flow_id            = :FB_FLOW_ID',
'   and rc.db_column_name     = ads.syn_name',
'   and ad.security_group_id  = :flow_security_group_id',
'   and ad.column_id          = ads.column_id',
'   and ads.security_group_id = :flow_security_group_id',
'   and nvl(rc.report_label,''0'')     = nvl(ad.label,''0'')',
'   and nvl(rc.help_text,''0'')        = nvl(ad.help_text,''0'')',
'   and nvl(rc.format_mask,''0'')      = nvl(ad.format_mask,''0'')',
'   and nvl(rc.format_mask,''0'')      = nvl(ad.report_format_mask,''0'')',
'   and nvl(rc.column_alignment,''0'') = nvl(ad.report_col_alignment,''0'') ) fmrc2,',
'(select count(*) cnt',
'   from wwv_flow_page_plugs r,',
'        wwv_flow_region_report_column rc',
'  where nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'    and r.security_group_id  = :flow_security_group_id',
'    and r.flow_id    = :FB_FLOW_ID',
'    and r.page_id    = :FB_FLOW_PAGE_ID',
'    and r.id         = rc.region_id',
'    and rc.hidden_column = ''N''',
'    and nvl(rc.display_when_cond_type,''disp'') != ''NEVER''',
'    and rc.security_group_id  = :flow_security_group_id',
'    and rc.flow_id            = :FB_FLOW_ID',
'    and rc.column_alias not in (',
'        select syn_name',
'          from wwv_flow_hnt_col_dict_syn',
'         where security_group_id  = :flow_security_group_id)',
'    and substr(rc.column_alias,1,6) != ''CHECK$''',
'    and substr(rc.column_alias,1,5) != ''LINK$''',
'    and substr(rc.column_alias,1,8) != ''DERIVED$'' ) urc1,',
'(select count(*) cnt',
'   from wwv_flow_worksheets w,',
'        wwv_flow_page_plugs r,',
'        wwv_flow_worksheet_columns rc',
'  where w.security_group_id = :flow_security_group_id',
'    and w.flow_id           = :FB_FLOW_ID',
'    and w.page_id           = :FB_FLOW_PAGE_ID',
'    and w.region_id         = r.id',
'    and r.security_group_id = :flow_security_group_id',
'    and r.flow_id           = :FB_FLOW_ID ',
'    and r.page_id           = :FB_FLOW_PAGE_ID',
'    and nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'    and w.id                = rc.worksheet_id',
'    and rc.display_text_as != ''HIDDEN''',
'    and nvl(rc.display_condition_type,''disp'') != ''NEVER''',
'    and rc.security_group_id  = :flow_security_group_id',
'    and rc.flow_id            = :FB_FLOW_ID',
'    and rc.db_column_name not in (',
'        select syn_name',
'          from wwv_flow_hnt_col_dict_syn',
'         where security_group_id  = :flow_security_group_id)) urc2',
')',
'',
'loop',
'   :P912_RC_TOTAL_RC              := c1.trc;',
'   :P912_RC_DISPLAYED_RC          := c1.crc;',
'   :P912_RC_POTENTIAL_NEW_ENTRIES := c1.urc;	',
'   :P912_RC_POTENTIAL_UPDATES     := c1.mrc;',
'   :P912_RC_IDENTICAL_ATTRIBUTES  := c1.fmrc;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>445281727677187338
);
end;
/
prompt --application/pages/page_00920
begin
wwv_flow_imp_page.create_page(
 p_id=>920
,p_name=>'Create Page Template - Creation Method'
,p_alias=>'CREATE-PAGE-TEMPLATE-CREATION-METHOD'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Page Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47946831821696492)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(121962618064160338)
,p_plug_name=>'Create Page Template'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<p>You can create templates from scratch or copy them from another application. Once you create a template, you can modify it later.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(124526607285669191)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(106501409747300331)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(121969012024165564)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_imp.id(47946831821696492)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(121978026915169802)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(47946831821696492)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(19458625868751541)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47946831821696492)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(176917219768347992)
,p_branch_action=>'26'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(121978026915169802)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'F4000_P920_WIZ_TYPE'
,p_branch_condition_text=>'COPY'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(123695111891184070)
,p_branch_action=>'924'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(121978026915169802)
,p_branch_sequence=>40
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'F4000_P920_WIZ_TYPE'
,p_branch_condition_text=>'BLANK'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(589948785670621432)
,p_branch_action=>'f?p=&APP_ID.:162:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(19458625868751541)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(121993303171182395)
,p_name=>'F4000_P920_WIZ_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(121962618064160338)
,p_item_default=>'COPY'
,p_prompt=>'Create Page Template:'
,p_source=>'COPY'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'PAGE_TEMPLATE_WIZ'
,p_lov=>'.'||wwv_flow_imp.id(86592719346240927)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'valign="top"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_escape_on_http_output=>'N'
,p_help_text=>'Select the method by which you wish to create a new page template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
,p_attribute_04=>'VERTICAL'
,p_item_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,r from (',
'',
'',
'',
'    select ''Start with a default template'' d,''DEFAULT'' r,1 ob from dual',
'',
'',
'',
'    union',
'',
'',
'',
'    select ''Create a template from scratch'' d,''BLANK'' r, 2 ob from dual',
'',
'',
'',
'    union',
'',
'',
'',
'    select ''Create a copy of a template in another flow'' d, ''COPY'' r,3 ob from dual)',
'',
'',
'',
'order by ob'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(589948571712621430)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(121969012024165564)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(589948676689621431)
,p_event_id=>wwv_flow_imp.id(589948571712621430)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(122204211636376035)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'CLEAR_CACHE'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'920:922:924:925'
,p_process_when_button_id=>wwv_flow_imp.id(121969012024165564)
,p_internal_uid=>122204211636376035
);
end;
/
prompt --application/pages/page_00921
begin
wwv_flow_imp_page.create_page(
 p_id=>921
,p_name=>'Update Items using Attribute Dictionary'
,p_alias=>'UPDATE-ITEMS-USING-ATTRIBUTE-DICTIONARY'
,p_step_title=>'Update Items using Attribute Dictionary'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(261841008861828406)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'mg_attribute_dict.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(446025920706062430)
,p_name=>'Items the same as Attribute Dictionary entries'
,p_template=>wwv_flow_imp.id(689970285456172024)
,p_display_sequence=>140
,p_region_template_options=>'#DEFAULT#:is-collapsed'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select i.id, i.name item_name, ads.syn_name attr_name',
'  from wwv_flow_page_plugs r,',
'       wwv_flow_step_items i,',
'       wwv_flow_step_item_help h,',
'       wwv_flow_hnt_column_dict ad,',
'       wwv_flow_hnt_col_dict_syn ads',
' where nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'   and r.security_group_id  = :flow_security_group_id',
'   and r.flow_id            = :FB_FLOW_ID',
'   and r.page_id            = :FB_FLOW_PAGE_ID',
'   and r.id                 = i.item_plug_id',
'   and nvl(i.display_when_type,''disp'') != ''NEVER''',
'   and i.display_as not in (''NATIVE_HIDDEN'',''NATIVE_STOP_AND_START_HTML_TABLE'')',
'   and i.security_group_id  = :flow_security_group_id',
'   and i.flow_id            = :FB_FLOW_ID',
'   and i.flow_step_id       = :FB_FLOW_PAGE_ID',
'   and h.flow_item_id (+)   = i.id',
'   and ad.security_group_id = :flow_security_group_id',
'   and ad.column_id         = ads.column_id',
'   and ads.security_group_id = :flow_security_group_id',
'   and case when upper(substr(i.name,1,2)) in (''P1'',''P2'',''P3'',''P4'',''P5'',''P6'',''P7'',''P8'',''P9'')',
'            then substr(i.name,instr(i.name,''_'')+1)',
'            else i.name',
'            end = ads.syn_name',
'   and (nvl(i.prompt,''0'') = nvl(ad.label,''0'') or',
'        i.prompt = ad.label||'':'')',
'   and nvl(h.help_text,''0'')    = nvl(ad.help_text,''0'')',
'   and nvl(i.format_mask,''0'')  = nvl(nvl(ad.form_format_mask,ad.format_mask),''0'')',
'   and nvl(i.item_default,''0'') = nvl(ad.default_value,''0'')',
'   and nvl(i.cSize,0)          = nvl(ad.form_display_width,0)',
'   and nvl(i.cHeight,0)        = nvl(ad.form_display_height,0)',
'   and nvl(i.data_type,''0'')    = nvl(ad.form_data_type,''0'')',
'order by i.name'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No Items found.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(446026111263062434)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(446026218293062437)
,p_query_column_id=>2
,p_column_alias=>'ITEM_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Item Name'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(446026302912062437)
,p_query_column_id=>3
,p_column_alias=>'ATTR_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Matches'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(446026410403062438)
,p_plug_name=>'Update Items'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>150
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>The Page Items listed were matched to columns in the Attribute Dictionary.  Select those Items you wish to update and indicate which attributes you wish to include in the update.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(446026811272062441)
,p_name=>'Matched Items'
,p_template=>wwv_flow_imp.id(208928010704475743)
,p_display_sequence=>130
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select htmldb_item.checkbox(1,i.id||'',''||ad.column_id) chk,',
'       m.region ||'': ''|| r.plug_name region_name,',
'       --',
'       i.id i_id, ',
'       i.name i_name, ',
'       i.prompt i_label,',
'       case when length(h.help_text) > 20',
'             then wwv_flow_escape.html(substr(h.help_text,1,20))||',
'                  ''<a href="javascript:popupURL(''''f?p=4000:908:''||:APP_SESSION||',
'                  '':::908:P908_DISPLAY,P908_ID:IH,''||i.id||',
'                  '''''')" alt="''||m.v||''" title="''||m.v||''">...</a>''',
'              else wwv_flow_escape.html(h.help_text)',
'              end i_help_text,',
'       i.format_mask i_format_mask,',
'       case when length(i.item_default) > 20',
'            then wwv_flow_escape.html(substr(i.item_default,1,20))||',
'                 ''<a href="javascript:popupURL(''''f?p=4000:908:''||:APP_SESSION||',
'                 '':::908:P908_DISPLAY,P908_ID:ID,''||i.id||',
'                 '''''')" alt="''||m.v||''" title="''||m.v||''">...</a>''',
'            else wwv_flow_escape.html(i.item_default)',
'            end i_default,',
'       --',
'       i.cSize i_width,',
'       i.cHeight i_height,',
'       i.data_type i_data_type,',
'       --',
'       m.a from_ad,',
'       ad.column_id c_column_id,',
'       ads.syn_name c_column_name,',
'       ad.label c_label,',
'       case when length(ad.help_text) > 20',
'            then wwv_flow_escape.html(substr(ad.help_text,1,20))||',
'                 ''<a href="javascript:popupURL(''''f?p=4000:908:''||:APP_SESSION||',
'                 '':::908:P908_DISPLAY,P908_ID:ADH,''||ad.column_id||',
'                 '''''')" alt="''||wwv_flow_escape.html(m.v||''" title="''||m.v)||''">...</a>''',
'            else wwv_flow_escape.html(ad.help_text)',
'            end c_help_text,',
'       nvl(ad.form_format_mask,ad.format_mask) c_format_mask,',
'       case when length(ad.default_value) > 20',
'            then wwv_flow_escape.html(substr(ad.default_value,1,20))||',
'                 ''<a href="javascript:popupURL(''''f?p=4000:908:''||:APP_SESSION||',
'                 '':::908:P908_DISPLAY,P908_ID:ADD,''||ad.column_id||',
'                 '''''')" alt="''||wwv_flow_escape.html(m.v||''" title="''||m.v)||''">...</a>''',
'            else wwv_flow_escape.html(ad.default_value)',
'            end c_default_value,',
'       --',
'       ad.form_display_width c_form_display_width,',
'       ad.form_display_height c_form_display_height,',
'       ad.form_data_type c_form_data_type,',
'       --',
'       case when upper(substr(i.name,1,2)) in (''P1'',''P2'',''P3'',''P4'',''P5'',''P6'',''P7'',''P8'',''P9'')',
'            then substr(i.name,instr(i.name,''_'')+1)',
'            else i.name',
'            end check_name',
'  from wwv_flow_page_plugs r,',
'       wwv_flow_step_items i,',
'       wwv_flow_step_item_help h,',
'       wwv_flow_hnt_column_dict ad,',
'       wwv_flow_hnt_col_dict_syn ads,',
'       (select wwv_flow_lang.system_message(''FROM_ATTRIBUTE_DICTIONARY'') a,',
'               wwv_flow_lang.system_message(''VIEW_FOR_ALT_TAG'') v,',
'               wwv_flow_lang.system_message(''UI_DEF_CUSTOM_ITEM_TYPE'') ct,',
'               wwv_flow_lang.system_message(''APEX_REGION'') region',
'               from dual) m',
' where nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'   and r.security_group_id  = :flow_security_group_id',
'   and r.flow_id            = :FB_FLOW_ID',
'   and r.page_id            = :FB_FLOW_PAGE_ID',
'   and r.id                 = i.item_plug_id',
'   and nvl(i.display_when_type,''disp'') != ''NEVER''',
'   and i.display_as not in (''NATIVE_HIDDEN'',''NATIVE_STOP_AND_START_HTML_TABLE'')',
'   and i.security_group_id  = :flow_security_group_id',
'   and i.flow_id            = :FB_FLOW_ID',
'   and i.flow_step_id       = :FB_FLOW_PAGE_ID',
'   and h.flow_item_id (+)   = i.id',
'   and ad.security_group_id = :flow_security_group_id',
'   and ad.column_id         = ads.column_id',
'   and ads.security_group_id = :flow_security_group_id',
'   and case when upper(substr(i.name,1,2)) in (''P1'',''P2'',''P3'',''P4'',''P5'',''P6'',''P7'',''P8'',''P9'')',
'            then substr(i.name,instr(i.name,''_'')+1)',
'            else i.name',
'            end = ads.syn_name',
'   and ((nvl(i.prompt,''0'') != nvl(ad.label,''0'') and',
'         i.prompt != ad.label||'':'') or',
'        nvl(h.help_text,''0'')    != nvl(ad.help_text,''0'') or',
'        nvl(i.format_mask,''0'')  != nvl(nvl(ad.form_format_mask,ad.format_mask),''0'') or',
'        nvl(i.item_default,''0'') != nvl(ad.default_value,''0'') or',
'        nvl(i.cSize,0)          != nvl(ad.form_display_width,0) or',
'        nvl(i.cHeight,0)        != nvl(ad.form_display_height,0) or',
'        nvl(i.data_type,''0'')    != nvl(ad.form_data_type,''0'') )'))
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No Items found.'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(446027032557062449)
,p_query_column_id=>1
,p_column_alias=>'CHK'
,p_column_display_sequence=>1
,p_column_heading=>'<input type="checkbox" onclick="html_CheckAll($x_UpTill(this,''TABLE''),this.checked)" />'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(446027410678062449)
,p_query_column_id=>2
,p_column_alias=>'REGION_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Source'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(446027521691062449)
,p_query_column_id=>3
,p_column_alias=>'I_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(446027611519062449)
,p_query_column_id=>4
,p_column_alias=>'I_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(446027729118062449)
,p_query_column_id=>5
,p_column_alias=>'I_LABEL'
,p_column_display_sequence=>5
,p_column_heading=>'Label'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(446027803238062450)
,p_query_column_id=>6
,p_column_alias=>'I_HELP_TEXT'
,p_column_display_sequence=>6
,p_column_heading=>'Help Text'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(446027909816062450)
,p_query_column_id=>7
,p_column_alias=>'I_FORMAT_MASK'
,p_column_display_sequence=>7
,p_column_heading=>'Format Mask'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(446028022012062450)
,p_query_column_id=>8
,p_column_alias=>'I_DEFAULT'
,p_column_display_sequence=>8
,p_column_heading=>'Default'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(446028228843062451)
,p_query_column_id=>9
,p_column_alias=>'I_WIDTH'
,p_column_display_sequence=>9
,p_column_heading=>'Width'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(446028315488062451)
,p_query_column_id=>10
,p_column_alias=>'I_HEIGHT'
,p_column_display_sequence=>10
,p_column_heading=>'Height'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(446028423732062451)
,p_query_column_id=>11
,p_column_alias=>'I_DATA_TYPE'
,p_column_display_sequence=>11
,p_column_heading=>'Data Type'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(446027112848062449)
,p_query_column_id=>12
,p_column_alias=>'FROM_AD'
,p_column_display_sequence=>22
,p_column_heading=>'From Ad'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(446028527940062451)
,p_query_column_id=>13
,p_column_alias=>'C_COLUMN_ID'
,p_column_display_sequence=>12
,p_column_heading=>'Column Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(446028615811062451)
,p_query_column_id=>14
,p_column_alias=>'C_COLUMN_NAME'
,p_column_display_sequence=>13
,p_column_heading=>'Column Name'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(446028707110062451)
,p_query_column_id=>15
,p_column_alias=>'C_LABEL'
,p_column_display_sequence=>14
,p_column_heading=>'Label'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(446028816357062451)
,p_query_column_id=>16
,p_column_alias=>'C_HELP_TEXT'
,p_column_display_sequence=>15
,p_column_heading=>'Help Text'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(446028906697062451)
,p_query_column_id=>17
,p_column_alias=>'C_FORMAT_MASK'
,p_column_display_sequence=>16
,p_column_heading=>'Format Mask'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(446029018889062451)
,p_query_column_id=>18
,p_column_alias=>'C_DEFAULT_VALUE'
,p_column_display_sequence=>17
,p_column_heading=>'Default Value'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(446029326897062452)
,p_query_column_id=>19
,p_column_alias=>'C_FORM_DISPLAY_WIDTH'
,p_column_display_sequence=>20
,p_column_heading=>'Form Display Width'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(446029418751062452)
,p_query_column_id=>20
,p_column_alias=>'C_FORM_DISPLAY_HEIGHT'
,p_column_display_sequence=>18
,p_column_heading=>'Form Display Height'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(446029503256062452)
,p_query_column_id=>21
,p_column_alias=>'C_FORM_DATA_TYPE'
,p_column_display_sequence=>19
,p_column_heading=>'Form Data Type'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(446027313285062449)
,p_query_column_id=>22
,p_column_alias=>'CHECK_NAME'
,p_column_display_sequence=>21
,p_column_heading=>'Check Name'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(446029604289062452)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>100
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(452537332089497417)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>160
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(445192614743849621)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(446029805515062454)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(446029604289062452)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:912:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(446030020061062456)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(446029604289062452)
,p_button_name=>'UPDATE_ITEMS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Update Items'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(446032504266062505)
,p_branch_action=>'f?p=&APP_ID.:921:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(446030226172062456)
,p_name=>'P921_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(446029604289062452)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Page:'
,p_source=>'FB_FLOW_PAGE_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PAGES IN CURRENT APP'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id || '' - '' || name d, id r',
'  from wwv_flow_steps',
' where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_attributes=>'class="fieldtitlebold"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Selected page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(446030815183062464)
,p_name=>'P921_INCLUDE_IN_UPDATE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(446029604289062452)
,p_item_default=>'label:help_text:format_mask:default:width:height:data_type'
,p_prompt=>'Include in Update:'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>'STATIC2:Label;label,Help Text;help_text,Format Mask;format_mask,Default;default,Width;width,Height;height,Data Type;data_type'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Select the attributes to include in the update.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(446031906391062490)
,p_validation_name=>'P921_INCLUDE_IN_UPDATE not null'
,p_validation_sequence=>5
,p_validation=>'P921_INCLUDE_IN_UPDATE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'You must select attributes to include in update.'
,p_when_button_pressed=>wwv_flow_imp.id(446030020061062456)
,p_associated_item=>wwv_flow_imp.id(446030815183062464)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(446032101276062496)
,p_validation_name=>'must select items to update'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if WWV_FLOW.G_F01.COUNT = 0 then',
'   return false;',
'else',
'   return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'You must select at least one item to update.'
,p_when_button_pressed=>wwv_flow_imp.id(446030020061062456)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(446032315420062497)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update Items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_comma      number;',
'   l_item_id    number;',
'   l_column_id  number;',
'begin',
'   for i in 1..wwv_flow.g_f01.count loop',
'',
'      l_comma     := instr(wwv_flow.g_f01(i),'','');',
'      l_item_id   := substr(wwv_flow.g_f01(i),1,l_comma-1);',
'      l_column_id := substr(wwv_flow.g_f01(i),l_comma+1);',
'',
'      wwv_flow_hint.update_items_from_ad(',
'         p_application_id  => :FB_FLOW_ID,',
'         p_page_id         => :P921_PAGE_ID,',
'         p_item_id         => l_item_id,',
'         p_column_id       => l_column_id,',
'         p_attr_to_include => :P921_INCLUDE_IN_UPDATE );',
'',
'   end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Page Items failed to be updated.'
,p_process_when_button_id=>wwv_flow_imp.id(446030020061062456)
,p_process_success_message=>'Page Items Updated.'
,p_internal_uid=>446032315420062497
);
end;
/
prompt --application/pages/page_00922
begin
wwv_flow_imp_page.create_page(
 p_id=>922
,p_name=>'Update Report Columns using Attribute Dictionary'
,p_alias=>'UPDATE-REPORT-COLUMNS-USING-ATTRIBUTE-DICTIONARY'
,p_step_title=>'Update Report Columns using Attribute Dictionary'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(261841008861828406)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'mg_attribute_dict.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(446116420464960314)
,p_plug_name=>'Update Report Columns'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>160
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The Report Columns listed were matched to existing columns in the Attribute Dictionary.  Select those you wish to update and indicate which attributes you wish to include in the update.</p>',
'',
'<p>Note: Help Text is only available within Interactive Reports. If you are updating Columns in a Standard Report, Help Text is not shown.  For Standard Reports, if your column headings are based upon PL/SQL, they will not be overwritten, anything ot'
||'her than PL/SQL will be changed to Custom in order for the new column headings to be displayed.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(446116616462960318)
,p_name=>'Report Columns the same as Attribute Dictionary entries'
,p_template=>wwv_flow_imp.id(689970285456172024)
,p_display_sequence=>150
,p_region_template_options=>'#DEFAULT#:is-collapsed'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select r.plug_name region_name,',
'       rc.column_alias rc_name',
'  from wwv_flow_page_plugs r,',
'       wwv_flow_region_report_column rc,',
'       wwv_flow_hnt_column_dict ad,',
'       wwv_flow_hnt_col_dict_syn ads',
' where nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'   and r.security_group_id  = :flow_security_group_id',
'   and r.flow_id    = :FB_FLOW_ID',
'   and r.page_id    = :FB_FLOW_PAGE_ID',
'   and r.id         = rc.region_id',
'   and rc.hidden_column = ''N''',
'   and nvl(rc.display_when_cond_type,''disp'') != ''NEVER''',
'   and rc.security_group_id  = :flow_security_group_id',
'   and rc.flow_id            = :FB_FLOW_ID',
'   and rc.column_alias       =  ads.syn_name',
'   and ad.security_group_id  = :flow_security_group_id',
'   and ad.column_id          = ads.column_id',
'   and ads.security_group_id = :flow_security_group_id',
'   and nvl(rc.column_heading,''0'')   = nvl(ad.label,''0'')',
'   and nvl(rc.column_format,''0'')    = nvl(nvl(ad.report_format_mask,ad.format_mask),''0'')',
'   and nvl(rc.column_alignment,''0'') = nvl(ad.report_col_alignment,''0'') ',
'union all',
'select r.plug_name region_name,',
'       rc.db_column_name rc_name',
'  from wwv_flow_worksheets w,',
'       wwv_flow_page_plugs r,',
'       wwv_flow_worksheet_columns rc,',
'       wwv_flow_hnt_column_dict ad,',
'       wwv_flow_hnt_col_dict_syn ads',
' where w.security_group_id = :flow_security_group_id',
'   and w.flow_id           = :FB_FLOW_ID',
'   and w.page_id           = :FB_FLOW_PAGE_ID',
'   and w.region_id         = r.id',
'   and r.security_group_id = :flow_security_group_id',
'   and r.flow_id           = :FB_FLOW_ID ',
'   and r.page_id           = :FB_FLOW_PAGE_ID',
'   and nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'   and w.id                = rc.worksheet_id',
'   and rc.display_text_as != ''HIDDEN''',
'   and nvl(rc.display_condition_type,''disp'') != ''NEVER''',
'   and rc.security_group_id  = :flow_security_group_id',
'   and rc.flow_id            = :FB_FLOW_ID',
'   and rc.db_column_name     = ads.syn_name',
'   and ad.security_group_id  = :flow_security_group_id',
'   and ad.column_id          = ads.column_id',
'   and ads.security_group_id = :flow_security_group_id',
'   and nvl(rc.report_label,''0'')     = nvl(ad.label,''0'')',
'   and nvl(rc.help_text,''0'')        = nvl(ad.help_text,''0'')',
'   and nvl(rc.format_mask,''0'')      = nvl(nvl(ad.report_format_mask,ad.format_mask),''0'')',
'   and nvl(rc.column_alignment,''0'') = nvl(ad.report_col_alignment,''0'')',
'order by 1, 2'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No Report Columns found.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(446116827683960333)
,p_query_column_id=>1
,p_column_alias=>'REGION_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Region'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(446116927078960334)
,p_query_column_id=>2
,p_column_alias=>'RC_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Report Column'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(446117023142960334)
,p_name=>'Matched Report Columns'
,p_template=>wwv_flow_imp.id(208928010704475743)
,p_display_sequence=>140
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select htmldb_item.checkbox(1,''CR,''||rc.id||'',''||ad.column_id||'',''||r.id) chk,',
'       m.region ||'': ''|| r.plug_name region_name,',
'       --',
'       rc.id rc_id, ',
'       rc.column_alias rc_name, ',
'       rc.column_heading  rc_label,',
'       null rc_help_text,',
'       rc.column_format rc_format_mask,',
'       --',
'       case when rc.column_alignment = ''LEFT'' then m.l',
'            when rc.column_alignment = ''CENTER'' then m.c',
'            when rc.column_alignment = ''RIGHT'' then m.r',
'            end rc_report_col_align,',
'       --',
'       m.a from_ad,',
'       ad.column_id c_column_id,',
'       ads.syn_name c_column_name,',
'       ad.label c_label,',
'       null c_help_text,',
'       nvl(ad.report_format_mask,ad.format_mask) c_format_mask,',
'       --',
'       case when ad.report_col_alignment = ''LEFT'' then m.l',
'            when ad.report_col_alignment = ''CENTER'' then m.c',
'            when ad.report_col_alignment = ''RIGHT'' then m.r',
'            end c_report_col_align',
'  from wwv_flow_page_plugs r,',
'       wwv_flow_region_report_column rc,',
'       wwv_flow_hnt_column_dict ad,',
'       wwv_flow_hnt_col_dict_syn ads,',
'       (select wwv_flow_lang.system_message(''FROM_ATTRIBUTE_DICTIONARY'') a,',
'               wwv_flow_lang.system_message(''LEFT'') l,',
'               wwv_flow_lang.system_message(''CENTER'') c,',
'               wwv_flow_lang.system_message(''RIGHT'') r,',
'               wwv_flow_lang.system_message(''VIEW_FOR_ALT_TAG'') v,',
'               wwv_flow_lang.system_message(''APEX_REGION'') region',
'          from dual) m',
' where nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'   and r.security_group_id  = :flow_security_group_id',
'   and r.flow_id    = :FB_FLOW_ID',
'   and r.page_id    = :FB_FLOW_PAGE_ID',
'   and r.id         = rc.region_id',
'   and rc.hidden_column = ''N''',
'   and nvl(rc.display_when_cond_type,''disp'') != ''NEVER''',
'   and rc.security_group_id  = :flow_security_group_id',
'   and rc.flow_id            = :FB_FLOW_ID',
'   and rc.column_alias       =  ads.syn_name',
'   and ad.security_group_id  = :flow_security_group_id',
'   and ad.column_id          = ads.column_id',
'   and ads.security_group_id = :flow_security_group_id',
'   and (nvl(rc.column_heading,''0'')   != nvl(ad.label,''0'') or',
'        nvl(rc.column_format,''0'')    != nvl(nvl(ad.report_format_mask,ad.format_mask),''0'') or',
'        nvl(rc.column_alignment,''0'') != nvl(ad.report_col_alignment,''0'') )',
'union all',
'select htmldb_item.checkbox(1,''IR,''||rc.id||'',''||ad.column_id||'',''||r.id) chk,',
'       m.region ||'': ''|| r.plug_name region_name,',
'       --',
'       rc.id rc_id, ',
'       rc.db_column_name rc_name, ',
'       rc.report_label rc_label,',
'       case when length(rc.help_text) > 20',
'            then wwv_flow_escape.html(substr(rc.help_text,1,20))||',
'                 ''<a href="javascript:popupURL(''''f?p=4000:908:''||:APP_SESSION||',
'                 '':::908:P908_DISPLAY,P908_ID:IRH,''||rc.id||',
'                 '''''')" alt="''||m.v||''" title="''||m.v||''">...</a>''',
'            else wwv_flow_escape.html(rc.help_text)',
'            end rc_help_text,',
'       rc.format_mask rc_format_mask,',
'       --',
'       case when rc.column_alignment = ''LEFT'' then m.l',
'            when rc.column_alignment = ''CENTER'' then m.c',
'            when rc.column_alignment = ''RIGHT'' then m.r',
'            end rc_report_col_align,',
'       --',
'       m.a from_ad,',
'       ad.column_id c_column_id,',
'       ads.syn_name c_column_name,',
'       ad.label c_label,',
'       case when length(ad.help_text) > 20',
'            then wwv_flow_escape.html(substr(ad.help_text,1,20))||',
'                 ''<a href="javascript:popupURL(''''f?p=4000:908:''||:APP_SESSION||',
'                 '':::908:P908_DISPLAY,P908_ID:ADH,''||ad.column_id||',
'                 '''''')" alt="''||wwv_flow_escape.html(m.v||''" title="''||m.v)||''">...</a>''',
'            else ad.help_text',
'            end c_help_text,',
'       nvl(ad.report_format_mask,ad.format_mask) c_format_mask,',
'       --',
'       case when ad.report_col_alignment = ''LEFT'' then m.l',
'            when ad.report_col_alignment = ''CENTER'' then m.c',
'            when ad.report_col_alignment = ''RIGHT'' then m.r',
'            end c_report_col_align',
'  from wwv_flow_worksheets w,',
'       wwv_flow_page_plugs r,',
'       wwv_flow_worksheet_columns rc,',
'       wwv_flow_hnt_column_dict ad,',
'       wwv_flow_hnt_col_dict_syn ads,',
'       (select wwv_flow_lang.system_message(''FROM_ATTRIBUTE_DICTIONARY'') a,',
'               wwv_flow_lang.system_message(''LEFT'') l,',
'               wwv_flow_lang.system_message(''CENTER'') c,',
'               wwv_flow_lang.system_message(''RIGHT'') r,',
'               wwv_flow_lang.system_message(''VIEW_FOR_ALT_TAG'') v,',
'               wwv_flow_lang.system_message(''APEX_REGION'') region',
'          from dual) m',
' where w.security_group_id = :flow_security_group_id',
'   and w.flow_id           = :FB_FLOW_ID',
'   and w.page_id           = :FB_FLOW_PAGE_ID',
'   and w.region_id         = r.id',
'   and r.security_group_id = :flow_security_group_id',
'   and r.flow_id           = :FB_FLOW_ID ',
'   and r.page_id           = :FB_FLOW_PAGE_ID',
'   and nvl(r.plug_display_condition_type,''disp'') != ''NEVER''',
'   and w.id                = rc.worksheet_id',
'   and rc.display_text_as != ''HIDDEN''',
'   and nvl(rc.display_condition_type,''disp'') != ''NEVER''',
'   and rc.security_group_id  = :flow_security_group_id',
'   and rc.flow_id            = :FB_FLOW_ID',
'   and rc.db_column_name     =  ads.syn_name',
'   and ad.security_group_id  = :flow_security_group_id',
'   and ad.column_id          = ads.column_id',
'   and ads.security_group_id = :flow_security_group_id',
'   and (nvl(rc.report_label,''0'')     != nvl(ad.label,''0'') or',
'        nvl(rc.help_text,''0'')        != nvl(ad.help_text,''0'') or',
'        nvl(rc.format_mask,''0'')      != nvl(nvl(ad.report_format_mask,ad.format_mask),''0'') or',
'        nvl(rc.column_alignment,''0'') != nvl(ad.report_col_alignment,''0'') )'))
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No Report Columns found.'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(446117312948960337)
,p_query_column_id=>1
,p_column_alias=>'CHK'
,p_column_display_sequence=>1
,p_column_heading=>'<input type="checkbox" onclick="html_CheckAll($x_UpTill(this,''TABLE''),this.checked)" />'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(446117428955960337)
,p_query_column_id=>2
,p_column_alias=>'REGION_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Source'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(446117508279960339)
,p_query_column_id=>3
,p_column_alias=>'RC_ID'
,p_column_display_sequence=>3
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(446117630828960339)
,p_query_column_id=>4
,p_column_alias=>'RC_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(446117729426960339)
,p_query_column_id=>5
,p_column_alias=>'RC_LABEL'
,p_column_display_sequence=>5
,p_column_heading=>'Label'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(446117202877960336)
,p_query_column_id=>6
,p_column_alias=>'RC_HELP_TEXT'
,p_column_display_sequence=>6
,p_column_heading=>'Help Text'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(446117825635960339)
,p_query_column_id=>7
,p_column_alias=>'RC_FORMAT_MASK'
,p_column_display_sequence=>7
,p_column_heading=>'Format Mask'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(446117908404960339)
,p_query_column_id=>8
,p_column_alias=>'RC_REPORT_COL_ALIGN'
,p_column_display_sequence=>8
,p_column_heading=>'Report Column Alignment'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(446118026871960339)
,p_query_column_id=>9
,p_column_alias=>'FROM_AD'
,p_column_display_sequence=>9
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(446118128589960339)
,p_query_column_id=>10
,p_column_alias=>'C_COLUMN_ID'
,p_column_display_sequence=>10
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(446118205619960339)
,p_query_column_id=>11
,p_column_alias=>'C_COLUMN_NAME'
,p_column_display_sequence=>11
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(446118329695960339)
,p_query_column_id=>12
,p_column_alias=>'C_LABEL'
,p_column_display_sequence=>12
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(446118801214960340)
,p_query_column_id=>13
,p_column_alias=>'C_HELP_TEXT'
,p_column_display_sequence=>13
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(446118414103960339)
,p_query_column_id=>14
,p_column_alias=>'C_FORMAT_MASK'
,p_column_display_sequence=>14
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(446118619615960340)
,p_query_column_id=>15
,p_column_alias=>'C_REPORT_COL_ALIGN'
,p_column_display_sequence=>15
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(446119107931960341)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>100
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(452545618162588011)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>170
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(445192614743849621)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(446119305804960341)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(446119107931960341)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:912:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(446119503950960343)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(446119107931960341)
,p_button_name=>'UPDATE_RC'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Update Report Columns'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(446121630616960369)
,p_branch_action=>'f?p=&APP_ID.:922:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(446119730353960343)
,p_name=>'P922_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(446119107931960341)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Page:'
,p_source=>'FB_FLOW_PAGE_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PAGES IN CURRENT APP'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id || '' - '' || name d, id r',
'  from wwv_flow_steps',
' where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_attributes=>'class="fieldtitlebold"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Selected page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(446120328210960347)
,p_name=>'P922_INCLUDE_IN_UPDATE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(446119107931960341)
,p_item_default=>'label:help_text:format_mask:rep_col_align'
,p_prompt=>'Include in Update:'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>'STATIC2:Label;label,Help Text;help_text,Format Mask;format_mask,Report Column Alignment;rep_col_align'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Identify which attributes of the report columns you wish to update.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(446121004834960366)
,p_validation_name=>'P922_INCLUDE_IN_UPDATE not null'
,p_validation_sequence=>5
,p_validation=>'P922_INCLUDE_IN_UPDATE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'You must select attributes to include in update.'
,p_when_button_pressed=>wwv_flow_imp.id(446119503950960343)
,p_associated_item=>wwv_flow_imp.id(446120328210960347)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(446121216648960367)
,p_validation_name=>'must select rc to update'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if WWV_FLOW.G_F01.COUNT = 0 then',
'   return false;',
'else',
'   return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'You must select at least one report column to update.'
,p_when_button_pressed=>wwv_flow_imp.id(446119503950960343)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(446121406081960368)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update Report Columns'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_comma2     number;',
'   l_comma3     number;',
'   l_rc_type    varchar2(2);',
'   l_rc_id      number;',
'   l_column_id  number;',
'   l_region_id  number;',
'begin',
'   for i in 1..wwv_flow.g_f01.count loop',
'',
'      l_comma2    := instr(wwv_flow.g_f01(i),'','',1,2);',
'      l_comma3    := instr(wwv_flow.g_f01(i),'','',1,3);',
'      l_rc_type   := substr(wwv_flow.g_f01(i),1,2);',
'      l_rc_id     := substr(wwv_flow.g_f01(i),4,l_comma2-4);',
'      l_column_id := substr(wwv_flow.g_f01(i),l_comma2+1,l_comma3-l_comma2-1);',
'      l_region_id := substr(wwv_flow.g_f01(i),l_comma3+1);',
'',
'      if l_rc_type = ''CR'' and instr(:P922_INCLUDE_IN_UPDATE,''label'') > 0 then',
'         wwv_flow_hint.update_cr_ht_from_ad(',
'            p_application_id  => :FB_FLOW_ID,',
'            p_page_id         => :FB_FLOW_PAGE_ID,',
'            p_region_id       => l_region_id);',
'      end if;',
'',
'      if l_rc_type = ''CR'' then',
'         wwv_flow_hint.update_cr_from_ad(',
'            p_application_id  => :FB_FLOW_ID,',
'            p_page_id         => :FB_FLOW_PAGE_ID,',
'            p_region_id       => l_region_id,',
'            p_rc_id           => l_rc_id,',
'            p_column_id       => l_column_id,',
'            p_attr_to_include => :P922_INCLUDE_IN_UPDATE );',
'      elsif l_rc_type = ''IR'' then',
'         wwv_flow_hint.update_ir_from_ad(',
'            p_application_id  => :FB_FLOW_ID,',
'            p_rc_id           => l_rc_id,',
'            p_column_id       => l_column_id,',
'            p_attr_to_include => :P922_INCLUDE_IN_UPDATE );',
'      end if;',
'',
'   end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Report Columns failed to be updated.'
,p_process_when_button_id=>wwv_flow_imp.id(446119503950960343)
,p_process_success_message=>'Report Columns Updated.'
,p_internal_uid=>446121406081960368
);
end;
/
prompt --application/pages/page_00924
begin
wwv_flow_imp_page.create_page(
 p_id=>924
,p_name=>'Create Page Template - Name'
,p_alias=>'CREATE-PAGE-TEMPLATE-NAME'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Page Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47955417641843745)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(122592504098427901)
,p_plug_name=>'Create Page Template'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<p>Identify a unique name for your template.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(124560812436697184)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(106501409747300331)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(122604106641450804)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47955417641843745)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(122619509673470584)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(47955417641843745)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(122596106164441181)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(47955417641843745)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(75113514794973621)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:RP:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(589949079007621435)
,p_branch_action=>'f?p=&APP_ID.:920:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(122596106164441181)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(75073508457839337)
,p_name=>'P924_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(122592504098427901)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the template name.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(75093529545892703)
,p_name=>'P924_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(122592504098427901)
,p_prompt=>'Theme'
,p_source=>'P4003_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies a collection of templates which define the look and feel of the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(75095607297905270)
,p_name=>'P924_THEME_CLASS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(122592504098427901)
,p_prompt=>'Template Class'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE THEME CLASS ID'
,p_lov=>'.'||wwv_flow_imp.id(41972431732112027)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'The template class identifies a specific usage for this template.  The template class is used when switching themes.  When switching themes template classes are matched, thus allowing themes to be switched without manually mapping all templates.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(88128921579958266)
,p_validation_name=>'P924_NAME'
,p_validation_sequence=>10
,p_validation=>'P924_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(122619509673470584)
,p_associated_item=>wwv_flow_imp.id(75073508457839337)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(73941399520235922)
,p_validation_name=>'P924_NAME unique'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_templates',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :workspace_id',
'   and theme_id          = :P924_THEME',
'   and name              = :P924_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#LABEL# must be unique.'
,p_when_button_pressed=>wwv_flow_imp.id(122619509673470584)
,p_associated_item=>wwv_flow_imp.id(75073508457839337)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(88130531622961153)
,p_validation_name=>'P924_THEME'
,p_validation_sequence=>30
,p_validation=>'P924_THEME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(122619509673470584)
,p_associated_item=>wwv_flow_imp.id(75093529545892703)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(88131707165963502)
,p_validation_name=>'P924_THEME_CLASS'
,p_validation_sequence=>40
,p_validation=>'P924_THEME_CLASS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(122619509673470584)
,p_associated_item=>wwv_flow_imp.id(75095607297905270)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(589948875178621433)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(122604106641450804)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(589948948760621434)
,p_event_id=>wwv_flow_imp.id(589948875178621433)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(124205015113526014)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Page Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_imp_shared.create_template(',
'    P_ID                         => wwv_flow_id.next_val,',
'    P_FLOW_ID                    => :FB_FLOW_ID,',
'    P_THEME_ID                   => :P924_THEME,',
'    P_THEME_CLASS_ID             => :P924_THEME_CLASS,',
'    P_NAME                       => :P924_NAME,',
'    P_HEADER_TEMPLATE            => ',
'''<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">',
'<head>',
'#HEAD#',
'<title>#TITLE#</title>',
'</head>',
'<body #ONLOAD#>#FORM_OPEN#<a name="PAGETOP"></a>'',',
'    P_FOOTER_TEMPLATE            => ''#FORM_CLOSE#<a name="END"></a></body></html>'',',
'    P_SUCCESS_MESSAGE            => null,',
'    P_CURRENT_TAB                => null,',
'    P_CURRENT_TAB_FONT_ATTR      => null,',
'    P_NON_CURRENT_TAB            => null,',
'    P_NON_CURRENT_TAB_FONT_ATTR  => null,',
'    P_CURRENT_IMAGE_TAB          => null,',
'    P_NON_CURRENT_IMAGE_TAB      => null,',
'    P_TOP_CURRENT_TAB            => null,',
'    P_TOP_CURRENT_TAB_FONT_ATTR  => null,',
'    P_TOP_NON_CURR_TAB           => null,',
'    P_TOP_NON_CURR_TAB_FONT_ATTR => null,',
'    P_BOX                        => ''#BOX_BODY#'',',
'    P_NAVIGATION_BAR             => null,',
'    P_BODY_TITLE                 => null,',
'    P_NOTIFICATION_MESSAGE       => null,',
'    P_REGION_TABLE_CATTRIBUTES   => null, ',
'    P_ERROR_PAGE_TEMPLATE        => null,',
'    P_REQUIRED_PATCH             => null,',
'    P_TEMPLATE_COMMENT           => null',
')'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to create template'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(122619509673470584)
,p_process_success_message=>'Template Created'
,p_internal_uid=>124205015113526014
);
end;
/
prompt --application/pages/page_00929
begin
wwv_flow_imp_page.create_page(
 p_id=>929
,p_name=>'Import Feedback'
,p_alias=>'IMPORT-FEEDBACK'
,p_step_title=>'Import Feedback'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213300727323081712)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_install.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(208149926450631689)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(472699825850672243)
,p_plug_name=>'Invalid File'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--danger:a-Alert--horizontal'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>30
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_imp_parser.get_feedback_origin(:P929_FILE_ID) is null'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'File is not a valid &PRODUCT_NAME. feedback import file.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(472700016100672245)
,p_plug_name=>'import progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(37899301707472090)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(472700230157672246)
,p_plug_name=>'Import Feedback'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_imp_parser.get_feedback_origin(:P929_FILE_ID) is not null'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747146940864138174)
,p_plug_name=>'Import Feedback'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(472700425241672247)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(208149926450631689)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(472700607089672254)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(208149926450631689)
,p_button_name=>'IMPORT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Import Feedback'
,p_button_position=>'CREATE'
,p_button_condition=>'wwv_flow_imp_parser.get_feedback_origin(:P929_FILE_ID) is not null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2228004037414082)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(208149926450631689)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:163:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(472703918886672369)
,p_branch_action=>'f?p=&APP_ID.:1500:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(472700607089672254)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(472700829097672254)
,p_name=>'P929_FILE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(472700230157672246)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(472702231897672289)
,p_name=>'P929_VERSION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(472700230157672246)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Imported File Version'
,p_source=>'wwv_flow_imp_parser.get_version(:p929_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the import file version.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(472733510724079114)
,p_name=>'P929_FEEDBACK_ORIGIN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(472700230157672246)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Imported From'
,p_source=>'wwv_flow_imp_parser.get_feedback_origin(:p929_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies from which system the feedback has been imported.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(472703302044672348)
,p_validation_name=>'check version'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_runtime_version varchar2(200); -- the date of the current runtime flows',
'  l_calling_version varchar2(200);',
'begin',
'    l_calling_version := replace(replace(replace(wwv_flow_imp_parser.get_version (p_file_id => :p929_file_id),''.'',null),''_'',null),''/'',null);',
'    l_runtime_version := replace(replace(replace(wwv_flows_version,''.'',null),''_'',null),''/'',null);',
'',
'    if l_calling_version > l_runtime_version then',
'        --',
'        -- version incompatability        ',
'        --',
'        ',
'        return false;',
'    else',
'        return true;',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'NOT COMPATIBLE (Your import may contain calls not supported by your &PRODUCT_NAME. version.)'
,p_associated_item=>wwv_flow_imp.id(472702231897672289)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(472703531042672354)
,p_validation_name=>'not valid import file'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_imp_parser.get_feedback_origin(:P929_FILE_ID) is null then',
'   return false;',
'else',
'   return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'File is not a valid &PRODUCT_NAME. feedback import file.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(472703705055672355)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'import feedback'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_imp_parser.parse (',
'        p_file_id => :P929_FILE_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error importing feedback.'
,p_process_when_button_id=>wwv_flow_imp.id(472700607089672254)
,p_process_success_message=>'Feedback imported.'
,p_internal_uid=>472703705055672355
);
end;
/
prompt --application/pages/page_00931
begin
wwv_flow_imp_page.create_page(
 p_id=>931
,p_name=>'Create List Template - Creation Method'
,p_alias=>'CREATE-LIST-TEMPLATE-CREATION-METHOD'
,p_page_mode=>'MODAL'
,p_step_title=>'Create List Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(146431708903979941)
,p_plug_name=>'Create List Template'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<p>You can create templates from scratch or copy them from another application. Copying a template provides you with a framework that you can modify.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(148049528950021491)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(106501409747300331)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(177054803779114133)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(146436316525989142)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(177054803779114133)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(146439326914992121)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(177054803779114133)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(19625019685840569)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(177054803779114133)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(177373616310154911)
,p_branch_action=>'4069'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(146439326914992121)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND_TEXT'
,p_branch_condition=>'F4000_P931_SELECT'
,p_branch_condition_text=>'COPY'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(585124586039099808)
,p_branch_action=>'f?p=&APP_ID.:162:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(19625019685840569)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(147659632655442464)
,p_branch_action=>'935'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(146439326914992121)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND_TEXT'
,p_branch_condition=>'F4000_P931_SELECT'
,p_branch_condition_text=>'BLANK'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(146446301114013967)
,p_name=>'F4000_P931_SELECT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(146431708903979941)
,p_item_default=>'COPY'
,p_prompt=>'Create List Templates:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'LIST_TEMPLATE_WIZ'
,p_lov=>'.'||wwv_flow_imp.id(86596530905253701)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Select the method by which you wish to create a new list template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
,p_item_comment=>'Select Default Templates (recommended), or create a new template from scratch?'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(585124301509099806)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(146436316525989142)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(585124468241099807)
,p_event_id=>wwv_flow_imp.id(585124301509099806)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00935
begin
wwv_flow_imp_page.create_page(
 p_id=>935
,p_name=>'Create List Template - Name'
,p_alias=>'CREATE-LIST-TEMPLATE-NAME'
,p_page_mode=>'MODAL'
,p_step_title=>'Create List Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(147496023172173284)
,p_plug_name=>'Create List Template'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(148053315795027580)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(106501409747300331)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(186375503742161506)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(147509416259188851)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(186375503742161506)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(147517307386195706)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(186375503742161506)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(147513229764192676)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(186375503742161506)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(100180521813100225)
,p_branch_action=>'f?p=&FLOW_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(585125830797099821)
,p_branch_action=>'f?p=&APP_ID.:931:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(147513229764192676)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(100183932679112805)
,p_name=>'P935_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(147496023172173284)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identify new list template name.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(100185309954115766)
,p_name=>'P935_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(147496023172173284)
,p_prompt=>'Theme'
,p_source=>'P4003_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify theme.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(100186321382119006)
,p_name=>'P935_THEME_CLASS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(147496023172173284)
,p_prompt=>'Theme Class'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST THEME CLASS ID'
,p_lov=>'.'||wwv_flow_imp.id(43918610013174571)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify template theme class.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(100188102467123047)
,p_validation_name=>'P935_NAME'
,p_validation_sequence=>10
,p_validation=>'P935_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(147517307386195706)
,p_associated_item=>wwv_flow_imp.id(100183932679112805)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(73941947529235928)
,p_validation_name=>'P935_NAME unique'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_list_templates',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :workspace_id',
'   and theme_id          = :P935_THEME',
'   and list_template_name= :P935_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#LABEL# must be unique.'
,p_when_button_pressed=>wwv_flow_imp.id(147517307386195706)
,p_associated_item=>wwv_flow_imp.id(100183932679112805)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(100190114241126435)
,p_validation_name=>'P935_THEME'
,p_validation_sequence=>30
,p_validation=>'P935_THEME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(147517307386195706)
,p_associated_item=>wwv_flow_imp.id(100185309954115766)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(100191221860128658)
,p_validation_name=>'P935_THEME_CLASS'
,p_validation_sequence=>40
,p_validation=>'P935_THEME_CLASS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(147517307386195706)
,p_associated_item=>wwv_flow_imp.id(100186321382119006)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(585125654032099819)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(147509416259188851)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(585125754207099820)
,p_event_id=>wwv_flow_imp.id(585125654032099819)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(147895220712812627)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create List Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_imp_shared.create_list_template (',
'  p_flow_id                   => v(''fb_flow_id''),',
'  p_list_template_current     => null,',
'  p_list_template_noncurrent  => null,',
'  p_list_template_name        => :p935_name,',
'  p_list_template_before_rows => null,',
'  p_list_template_after_rows  => null,',
'  p_list_template_comment     => null,',
'  p_theme_id                  => :p935_theme,',
'  p_theme_class_id            => :p935_theme_class',
');'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Template not created.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(147517307386195706)
,p_process_success_message=>'Template created.'
,p_internal_uid=>147895220712812627
);
end;
/
prompt --application/pages/page_00938
begin
wwv_flow_imp_page.create_page(
 p_id=>938
,p_name=>'Debug Message Data'
,p_alias=>'DEBUG-MESSAGE-DATA1'
,p_step_title=>'Debug Message Data'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-IRR-table td {',
'    padding: 4px 8px;',
'}',
'.a-IRR-table td[headers=pct] {',
'    max-width: 120px;',
'}',
'.a-IRR-table td[headers=message] {',
'    max-width: 600px;',
'    overflow-x: auto;',
'}',
'pre {',
'    font-size: 11px;',
'    line-height: 14px;',
'    margin: 0;',
'}',
'.l1, .l2 {',
'    font-weight: bold;',
'    color: red;',
'}',
'.l3 {',
'    font-weight: bold;',
'}'))
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'debug.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(451218303882716102)
,p_plug_name=>'Debug Message Data'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select page_view_row_number as row_number,',
'       elapsed_seconds,',
'       execution_time,',
'       message,',
'       apex_user,',
'       message_level,',
'       percent_of_max,',
'       message_timestamp,',
'       call_stack',
'  from wwv_flow_debug_messages_v',
' where page_view_id      = :P938_PAGE_VIEW_ID',
'   and security_group_id = :flow_security_group_id',
''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(451218413886716102)
,p_name=>'Debug Message Data'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(624005414580721210)
,p_db_column_name=>'ROW_NUMBER'
,p_display_order=>1
,p_column_identifier=>'O'
,p_column_label=>'Row'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(451222708996789635)
,p_db_column_name=>'ELAPSED_SECONDS'
,p_display_order=>2
,p_column_identifier=>'I'
,p_column_label=>'Elapsed'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00000'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(624005504204721210)
,p_db_column_name=>'EXECUTION_TIME'
,p_display_order=>3
,p_column_identifier=>'P'
,p_column_label=>'Execution'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00000'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(451218729687716108)
,p_db_column_name=>'MESSAGE'
,p_display_order=>4
,p_column_identifier=>'B'
,p_column_label=>'Message'
,p_column_html_expression=>'<pre class="l#MESSAGE_LEVEL#">#MESSAGE#</pre>'
,p_column_type=>'STRING'
,p_static_id=>'message'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(451222805473789636)
,p_db_column_name=>'APEX_USER'
,p_display_order=>5
,p_column_identifier=>'J'
,p_column_label=>'User'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(451318931989675375)
,p_db_column_name=>'MESSAGE_LEVEL'
,p_display_order=>6
,p_column_identifier=>'N'
,p_column_label=>'Level'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(624005626313721211)
,p_db_column_name=>'PERCENT_OF_MAX'
,p_display_order=>7
,p_column_identifier=>'Q'
,p_column_label=>'Graph'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'PCT_GRAPH:#cccccc:#777777:100'
,p_static_id=>'pct'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(624005823644721211)
,p_db_column_name=>'MESSAGE_TIMESTAMP'
,p_display_order=>9
,p_column_identifier=>'S'
,p_column_label=>'Message Timestamp'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2510811144717781)
,p_db_column_name=>'CALL_STACK'
,p_display_order=>11
,p_column_identifier=>'U'
,p_column_label=>'Call Stack'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(451219221804716326)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1293319205536644'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'ROW_NUMBER:ELAPSED_SECONDS:EXECUTION_TIME:MESSAGE:MESSAGE_LEVEL:PERCENT_OF_MAX:CALL_STACK:'
,p_sort_column_1=>'ELAPSED_SECONDS'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'MESSAGE_TIMESTAMP'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(451245311743912092)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-Form--fixedLabels'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(451250530237002519)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(451245311743912092)
,p_button_name=>'PURGE_DEBUG_VIEW'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Purge Debug Messages'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:748:&SESSION.::&DEBUG.:748:P748_PURGE_OPTION,P748_PAGE_VIEW_ID:IDENTIFIER,&P938_PAGE_VIEW_ID.'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(451246326072925685)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(451218303882716102)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:938:&SESSION.::&DEBUG.:RIR,938::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(451250708607002526)
,p_branch_action=>'f?p=&FLOW_ID.:938:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(451250530237002519)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(451348818339465516)
,p_name=>'P938_APPLICATION'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(451245311743912092)
,p_prompt=>'Application:'
,p_source=>'&FB_FLOW_ID.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>'select id||''. ''||name d, id r from wwv_flows where id = :fb_flow_id and security_group_id = :flow_security_group_id'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Current Application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(624001717126655747)
,p_name=>'P938_PAGE_VIEW_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(451245311743912092)
,p_prompt=>'View Identifier'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the debug message page view identifier.  This is an ever increasing number.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(624002226823658552)
,p_name=>'P938_PAGE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(451245311743912092)
,p_prompt=>'Page:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Associated page number.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(624002701674660730)
,p_name=>'P938_ELAPSED_TIME'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(451245311743912092)
,p_prompt=>'Elapsed Time:'
,p_format_mask=>'999G999G999G999G990D00000'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Elapsed time during debug.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(624003212063663725)
,p_name=>'P938_MAX_EXECUTION_TIME'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(451245311743912092)
,p_prompt=>'Maximum Execution Time'
,p_format_mask=>'999G999G999G999G990D00000'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Maximum execution time of any step.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(624004905876690316)
,p_computation_sequence=>1
,p_computation_item=>'P938_APPLICATION'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select flow_id from wwv_flow_debug_messages where page_view_id = :P938_PAGE_VIEW_ID and security_group_id = :flow_security_group_id',
'union all',
'select flow_id from wwv_flow_debug_messages2 where page_view_id = :P938_PAGE_VIEW_ID and security_group_id = :flow_security_group_id'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(624004324314676748)
,p_computation_sequence=>10
,p_computation_item=>'P938_PAGE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select page_id from wwv_flow_debug_messages where page_view_id = :P938_PAGE_VIEW_ID and security_group_id = :flow_security_group_id and page_id is not null',
'union all',
'select page_id from wwv_flow_debug_messages2 where page_view_id = :P938_PAGE_VIEW_ID and security_group_id = :flow_security_group_id and page_id is not null'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(624004505399680737)
,p_computation_sequence=>10
,p_computation_item=>'P938_ELAPSED_TIME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select to_char(nvl(max(elap),0), ''999G999G999G999G990D00000'') from ',
'(',
'select nvl(max(elap),0) elap from wwv_flow_debug_messages where page_view_id = :P938_PAGE_VIEW_ID and security_group_id = :flow_security_group_id',
'union all',
'select nvl(max(elap),0) elap from wwv_flow_debug_messages2 where page_view_id = :P938_PAGE_VIEW_ID  and security_group_id = :flow_security_group_id',
') x'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(624004719943684917)
,p_computation_sequence=>10
,p_computation_item=>'P938_MAX_EXECUTION_TIME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select to_char(nvl(max(execution_time), 0), ''999G999G999G999G990D00000'')',
'  from ( select extract(second from (lead(message_timestamp) over (order by page_view_id, message_timestamp, session_id, flow_id, page_id) - message_timestamp)) +',
'                extract(minute from (lead(message_timestamp) over (order by page_view_id, message_timestamp, session_id, flow_id, page_id) - message_timestamp)) * 60 as execution_time',
'           from ( select *',
'                    from wwv_flow_debug_messages',
'                   where page_view_id      = :P938_PAGE_VIEW_ID',
'                     and security_group_id = :flow_security_group_id',
'                   union all',
'                  select *',
'                    from wwv_flow_debug_messages2',
'                   where page_view_id      = :P938_PAGE_VIEW_ID',
'                     and security_group_id = :flow_security_group_id    ',
'                )',
'       )'))
);
end;
/
prompt --application/pages/page_00939
begin
wwv_flow_imp_page.create_page(
 p_id=>939
,p_name=>'Debug Message Data'
,p_alias=>'DEBUG-MESSAGE-DATA2'
,p_step_title=>'Debug Message Data'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-IRR-table td {',
'    padding: 4px 8px;',
'}',
'.a-IRR-table td[headers=pct] {',
'    max-width: 120px;',
'}',
'.a-IRR-table td[headers=message] {',
'    max-width: 600px;',
'    overflow-x: auto;',
'}',
'pre {',
'    font-size: 11px;',
'    line-height: 14px;',
'    margin: 0;',
'}',
'.l1, .l2 {',
'    font-weight: bold;',
'    color: red;',
'}',
'.l3 {',
'    font-weight: bold;',
'}'))
,p_step_template=>wwv_flow_imp.id(19943204431962826)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'debug.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(451352513130603348)
,p_plug_name=>'Debug Message Data'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>50
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select page_view_row_number as row_number,',
'       elapsed_seconds,',
'       execution_time,',
'       message,',
'       apex_user,',
'       message_level,',
'       percent_of_max,',
'       to_char(message_timestamp, ''YYYYMMDDHH24MISS"."FF'') as message_anchor,',
'       message_timestamp,',
'       call_stack',
'  from wwv_flow_debug_messages_v',
' where page_view_id      = :P939_PAGE_VIEW_ID',
'   and security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Debug Message Data'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(451352700445603348)
,p_name=>'Debug Message Data'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(617483723716172788)
,p_db_column_name=>'ROW_NUMBER'
,p_display_order=>1
,p_column_identifier=>'AB'
,p_column_label=>'Row'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(451353331050603354)
,p_db_column_name=>'ELAPSED_SECONDS'
,p_display_order=>2
,p_column_identifier=>'I'
,p_column_label=>'Elapsed'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00000'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(498258020400635102)
,p_db_column_name=>'EXECUTION_TIME'
,p_display_order=>3
,p_column_identifier=>'AA'
,p_column_label=>'Execution'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990D00000'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(451352831764603349)
,p_db_column_name=>'MESSAGE'
,p_display_order=>4
,p_column_identifier=>'B'
,p_column_label=>'Message'
,p_column_html_expression=>'<a name="#MESSAGE_ANCHOR#"></a><pre class="l#MESSAGE_LEVEL#">#MESSAGE#</pre>'
,p_column_type=>'STRING'
,p_static_id=>'message'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(451353429972603354)
,p_db_column_name=>'APEX_USER'
,p_display_order=>5
,p_column_identifier=>'J'
,p_column_label=>'User'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(451353611951603356)
,p_db_column_name=>'MESSAGE_LEVEL'
,p_display_order=>6
,p_column_identifier=>'N'
,p_column_label=>'Level'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(467191202320715772)
,p_db_column_name=>'PERCENT_OF_MAX'
,p_display_order=>7
,p_column_identifier=>'W'
,p_column_label=>'Graph'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_column_type=>'NUMBER'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'PCT_GRAPH:::'
,p_static_id=>'pct'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(472243323140883667)
,p_db_column_name=>'MESSAGE_ANCHOR'
,p_display_order=>8
,p_column_identifier=>'Z'
,p_column_label=>'Message Anchor'
,p_report_label=>' '
,p_sync_form_label=>'N'
,p_column_link=>'#'
,p_column_linktext=>' '
,p_column_link_attr=>'name="#MESSAGE_ANCHOR#"'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(617483829429172789)
,p_db_column_name=>'MESSAGE_TIMESTAMP'
,p_display_order=>9
,p_column_identifier=>'AC'
,p_column_label=>'Message Timestamp'
,p_column_type=>'DATE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(200166824373034332)
,p_db_column_name=>'CALL_STACK'
,p_display_order=>10
,p_column_identifier=>'AD'
,p_column_label=>'Call Stack'
,p_column_html_expression=>'<pre>#CALL_STACK#</pre>'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(451353909559603360)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1293413339536644'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_display_rows=>100000
,p_report_columns=>'ELAPSED_SECONDS:EXECUTION_TIME:MESSAGE:MESSAGE_LEVEL:PERCENT_OF_MAX:'
,p_sort_column_1=>'ROW_NUMBER'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'ELAPSED_SECONDS'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(451354120578603361)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(451356414894615900)
,p_plug_name=>'Finder Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(6207014968942318)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(713094915430315407)
,p_plug_name=>'Debug Chart'
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_location=>null
,p_plug_source_type=>'NATIVE_JET_CHART'
,p_plug_query_num_rows=>15
,p_plug_footer=>'<p/>'
);
wwv_flow_imp_page.create_jet_chart(
 p_id=>wwv_flow_imp.id(713095083622315408)
,p_region_id=>wwv_flow_imp.id(713094915430315407)
,p_chart_type=>'combo'
,p_height=>'120'
,p_animation_on_display=>'none'
,p_animation_on_data_change=>'none'
,p_orientation=>'vertical'
,p_data_cursor=>'off'
,p_hover_behavior=>'dim'
,p_stack=>'off'
,p_stack_label=>'off'
,p_spark_chart=>'N'
,p_connect_nulls=>'N'
,p_value_position=>'auto'
,p_sorting=>'value-asc'
,p_fill_multi_series_gaps=>true
,p_zoom_and_scroll=>'off'
,p_tooltip_rendered=>'Y'
,p_show_series_name=>false
,p_show_group_name=>true
,p_show_value=>true
,p_show_label=>true
,p_show_row=>true
,p_show_start=>true
,p_show_end=>true
,p_show_progress=>true
,p_show_baseline=>true
,p_legend_rendered=>'off'
,p_legend_position=>'auto'
,p_overview_rendered=>'off'
,p_horizontal_grid=>'auto'
,p_vertical_grid=>'auto'
,p_gauge_orientation=>'circular'
,p_gauge_plot_area=>'on'
,p_show_gauge_value=>true
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(713095194948315409)
,p_chart_id=>wwv_flow_imp.id(713095083622315408)
,p_seq=>10
,p_name=>'Series 1'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''#''||to_char(message_timestamp, ''YYYYMMDDHH24MISS"."FF'') as link,',
'       page_view_row_number || '' - '' || substr(message, 1, 40) as label,',
'       sum(execution_time) over (order by page_view_row_number) execution_agg',
'  from wwv_flow_debug_messages_v',
' where page_view_id      = :P939_PAGE_VIEW_ID',
'   and security_group_id = :flow_security_group_id',
' order by page_view_row_number'))
,p_series_type=>'area'
,p_items_value_column_name=>'EXECUTION_AGG'
,p_items_label_column_name=>'LABEL'
,p_line_style=>'solid'
,p_line_type=>'auto'
,p_marker_rendered=>'off'
,p_assigned_to_y2=>'off'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_link_target=>'&LINK.'
,p_link_target_type=>'REDIRECT_URL'
);
wwv_flow_imp_page.create_jet_chart_series(
 p_id=>wwv_flow_imp.id(32660594179289201)
,p_chart_id=>wwv_flow_imp.id(713095083622315408)
,p_seq=>30
,p_name=>'Warnings/Errors'
,p_data_source_type=>'SQL'
,p_data_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''#''||to_char(message_timestamp, ''YYYYMMDDHH24MISS"."FF'') as link,',
'       page_view_row_number || '' - '' || substr(message, 1, 40) as label,',
'       1 warnings_errors',
'  from wwv_flow_debug_messages_v',
' where page_view_id      = :P939_PAGE_VIEW_ID',
'   and security_group_id = :flow_security_group_id',
'   and message_level <= 2',
' order by page_view_row_number'))
,p_series_type=>'line'
,p_items_value_column_name=>'WARNINGS_ERRORS'
,p_items_label_column_name=>'LABEL'
,p_color=>'#ff0000'
,p_line_style=>'solid'
,p_line_type=>'none'
,p_marker_rendered=>'on'
,p_marker_shape=>'circle'
,p_assigned_to_y2=>'on'
,p_items_label_rendered=>false
,p_items_label_display_as=>'PERCENT'
,p_threshold_display=>'onIndicator'
,p_link_target=>'&LINK.'
,p_link_target_type=>'REDIRECT_URL'
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(713095224174315410)
,p_chart_id=>wwv_flow_imp.id(713095083622315408)
,p_axis=>'x'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_major_tick_rendered=>'off'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'off'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(713095309706315411)
,p_chart_id=>wwv_flow_imp.id(713095083622315408)
,p_axis=>'y'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'min'
,p_position=>'auto'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'off'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_jet_chart_axis(
 p_id=>wwv_flow_imp.id(32660622988289202)
,p_chart_id=>wwv_flow_imp.id(713095083622315408)
,p_axis=>'y2'
,p_is_rendered=>'on'
,p_format_scaling=>'auto'
,p_scaling=>'linear'
,p_baseline_scaling=>'zero'
,p_position=>'auto'
,p_major_tick_rendered=>'on'
,p_minor_tick_rendered=>'off'
,p_tick_label_rendered=>'off'
,p_split_dual_y=>'auto'
,p_zoom_order_seconds=>false
,p_zoom_order_minutes=>false
,p_zoom_order_hours=>false
,p_zoom_order_days=>false
,p_zoom_order_weeks=>false
,p_zoom_order_months=>false
,p_zoom_order_quarters=>false
,p_zoom_order_years=>false
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(811009025873417496)
,p_plug_name=>'Help'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_f4000_util.show_help_link (',
'   p_lang           => ''en'',',
'   p_session_id     => :app_session,',
'   p_application_id => 4000,',
'   p_page_id        => wwv_flow.g_flow_step_id);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(451429503306426225)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(451354120578603361)
,p_button_name=>'P939_SET'
,p_button_static_id=>'P939_SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Set'
,p_button_alignment=>'LEFT-CENTER'
,p_request_source=>'Set'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(451881217044039156)
,p_button_sequence=>25
,p_button_plug_id=>wwv_flow_imp.id(451354120578603361)
,p_button_name=>'SELECT_IDENTIFIER'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--gapLeft'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Select Page View Identifier'
,p_button_alignment=>'LEFT-CENTER'
,p_button_redirect_url=>'f?p=&APP_ID.:19:&SESSION.::&DEBUG.:::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(451441315314921581)
,p_button_sequence=>26
,p_button_plug_id=>wwv_flow_imp.id(451354120578603361)
,p_button_name=>'SHOW_MOST_RECENT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_alignment=>'LEFT-CENTER'
,p_button_redirect_url=>'f?p=&APP_ID.:939:&SESSION.:SET_PAGE_ID:&DEBUG.:939,RIR::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(451429723882426229)
,p_branch_action=>'f?p=&FLOW_ID.:939:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(451426821267403030)
,p_name=>'P939_PAGE_VIEW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(451354120578603361)
,p_prompt=>'Page View Identifier'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the debug message page view identifier.  This is an ever increasing number.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(451950913747400594)
,p_name=>'P939_APPLICATION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(451354120578603361)
,p_prompt=>'Application:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Associated application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(451951119981402391)
,p_name=>'P939_PAGE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(451354120578603361)
,p_prompt=>'Page:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Associated page number.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(461291211053568408)
,p_name=>'P939_ELAPSED_TIME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(451354120578603361)
,p_prompt=>'Elapsed Time:'
,p_format_mask=>'999G999G999G999G990D00000'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Elapsed time during debug.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(467194201455792628)
,p_name=>'P939_MAX_EXECUTION_TIME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(451354120578603361)
,p_prompt=>'Maximum Execution Time'
,p_format_mask=>'999G999G999G999G990D00000'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Maximum execution time of any step.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(451427505815407951)
,p_computation_sequence=>10
,p_computation_item=>'P939_PAGE_VIEW_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select max(i) x',
'from',
'(',
'select max(page_view_id) i',
'from wwv_flow_debug_messages',
'where security_group_id = :flow_security_group_id',
'union all',
'select max(page_view_id) i',
'from wwv_flow_debug_messages2',
'where security_group_id = :flow_security_group_id',
')'))
,p_compute_when=>'SET_PAGE_ID'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(451951614702419771)
,p_computation_sequence=>20
,p_computation_item=>'P939_APPLICATION'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select flow_id from wwv_flow_debug_messages where page_view_id = :P939_PAGE_VIEW_ID and security_group_id = :flow_security_group_id',
'union all',
'select flow_id from wwv_flow_debug_messages2 where page_view_id = :P939_PAGE_VIEW_ID and security_group_id = :flow_security_group_id'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(451952001458434876)
,p_computation_sequence=>30
,p_computation_item=>'P939_PAGE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select page_id from wwv_flow_debug_messages where page_view_id = :P939_PAGE_VIEW_ID and security_group_id = :flow_security_group_id and page_id is not null',
'union all',
'select page_id from wwv_flow_debug_messages2 where page_view_id = :P939_PAGE_VIEW_ID and security_group_id = :flow_security_group_id and page_id is not null'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(461293113954578638)
,p_computation_sequence=>40
,p_computation_item=>'P939_ELAPSED_TIME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select to_char(nvl(max(elap),0), ''999G999G999G999G990D00000'') from ',
'(',
'select nvl(max(elap),0) elap from wwv_flow_debug_messages where page_view_id = :P939_PAGE_VIEW_ID and security_group_id = :flow_security_group_id',
'union all',
'select nvl(max(elap),0) elap from wwv_flow_debug_messages2 where page_view_id = :P939_PAGE_VIEW_ID  and security_group_id = :flow_security_group_id',
') x'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(467196512022833547)
,p_computation_sequence=>50
,p_computation_item=>'P939_MAX_EXECUTION_TIME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select to_char(nvl(max(execution_time), 0), ''999G999G999G999G990D00000'')',
'  from ( select extract(second from (lead(message_timestamp) over (order by page_view_id, message_timestamp, session_id, flow_id, page_id) - message_timestamp)) +',
'                extract(minute from (lead(message_timestamp) over (order by page_view_id, message_timestamp, session_id, flow_id, page_id) - message_timestamp)) * 60 as execution_time',
'           from ( select *',
'                    from wwv_flow_debug_messages',
'                   where page_view_id      = :P939_PAGE_VIEW_ID',
'                     and security_group_id = :flow_security_group_id',
'                   union all',
'                  select *',
'                    from wwv_flow_debug_messages2',
'                   where page_view_id      = :P939_PAGE_VIEW_ID',
'                     and security_group_id = :flow_security_group_id    ',
'                )',
'       )'))
);
end;
/
prompt --application/pages/page_00940
begin
wwv_flow_imp_page.create_page(
 p_id=>940
,p_name=>'Update Interactive Report Settings'
,p_alias=>'UPDATE-INTERACTIVE-REPORT-SETTINGS'
,p_step_title=>'Update Interactive Report Settings'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_rpt_int.htm'
,p_page_component_map=>'01'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(451360330860759321)
,p_name=>'Update Interactive Report Settings'
,p_template=>wwv_flow_imp.id(208928010704475743)
,p_display_sequence=>15
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_column=>false
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'id,',
'page_id,',
'(select p.name',
'   from wwv_flow_steps p',
'  where p.id = w.page_id',
'    and flow_id = :FB_FLOW_ID',
'    and security_group_id = :flow_security_group_id) page,',
'(select r.plug_name',
'   from wwv_flow_page_plugs r',
'  where r.id = w.region_id',
'    and flow_id = :FB_FLOW_ID',
'    and security_group_id = :flow_security_group_id) region,',
'--',
'SHOW_SEARCH_BAR,',
'SHOW_SEARCH_TEXTBOX,',
'SHOW_FINDER_DROP_DOWN,',
'REPORT_LIST_MODE, -- TABS = Y, NONE = N',
'SHOW_ROWS_PER_PAGE,',
'SHOW_DISPLAY_ROW_COUNT, --??',
'SHOW_ACTIONS_MENU,',
'--',
'SHOW_SELECT_COLUMNS,',
'SHOW_FILTER,',
'SHOW_SORT,',
'SHOW_CONTROL_BREAK,',
'SHOW_HIGHLIGHT,',
'SHOW_COMPUTATION,',
'SHOW_AGGREGATE,',
'SHOW_NOTIFY, -- Subscription',
'SHOW_CHART,',
'SHOW_GROUP_BY,',
'SHOW_PIVOT,',
'SHOW_FLASHBACK,',
'ALLOW_REPORT_SAVING,',
'SHOW_RESET,',
'SHOW_HELP,',
'SHOW_DOWNLOAD,',
'--',
'ALLOW_SAVE_RPT_PUBLIC,',
'SAVE_RPT_PUBLIC_AUTH_SCHEME, --REQUIRED_ROLE lov',
'--',
'SHOW_CALENDAR,  -- not implemented yet',
'download_formats, -- need multiselect checkboxes',
'search_button_label,',
'max_rows_per_page',
'from wwv_flow_worksheets w',
'where flow_id = :FB_FLOW_ID',
'  and security_group_id = :flow_security_group_id',
'  and (page_id = :P940_PAGE or :P940_PAGE is null)',
'  and (:P940_PAGE_NAME_CONTAINS is null or',
'       upper(:P940_PAGE_NAME_CONTAINS) like ',
'            (select ''%''||upper(p.name)||''%''',
'               from wwv_flow_steps p',
'              where p.id = w.page_id',
'                and flow_id = :FB_FLOW_ID',
'                and security_group_id = :flow_security_group_id) )'))
,p_footer=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p/>',
'* for authenticated pages only'))
,p_translate_title=>'N'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_plug_query_max_columns=>60
,p_query_num_rows=>10
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No interactive reports found.'
,p_query_num_rows_item=>'P940_ROWS'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(451360615717759324)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_column_width=>16
,p_pk_col_source_type=>'T'
,p_ref_schema=>'APEX_040000'
,p_ref_table_name=>'WWV_FLOW_WORKSHEETS'
,p_ref_column_name=>'ID'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(451360928423759325)
,p_query_column_id=>2
,p_column_alias=>'PAGE_ID'
,p_column_display_sequence=>2
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_column_width=>16
,p_ref_schema=>'APEX_040000'
,p_ref_table_name=>'WWV_FLOW_WORKSHEETS'
,p_ref_column_name=>'PAGE_ID'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(451367103866774764)
,p_query_column_id=>3
,p_column_alias=>'PAGE'
,p_column_display_sequence=>3
,p_column_heading=>'Page Name'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(451367218646774764)
,p_query_column_id=>4
,p_column_alias=>'REGION'
,p_column_display_sequence=>4
,p_column_heading=>'Region'
,p_use_as_row_header=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(451367328343774764)
,p_query_column_id=>5
,p_column_alias=>'SHOW_SEARCH_BAR'
,p_column_display_sequence=>5
,p_column_heading=>'Search Bar'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:Y,N'
,p_cattributes=>'title="Search Bar"'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(451367413033774765)
,p_query_column_id=>6
,p_column_alias=>'SHOW_SEARCH_TEXTBOX'
,p_column_display_sequence=>6
,p_column_heading=>'Search Field'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:Y,N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(451367518074774765)
,p_query_column_id=>7
,p_column_alias=>'SHOW_FINDER_DROP_DOWN'
,p_column_display_sequence=>7
,p_column_heading=>'Finder Drop Down'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:Y,N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(451367607783774765)
,p_query_column_id=>8
,p_column_alias=>'REPORT_LIST_MODE'
,p_column_display_sequence=>8
,p_column_heading=>'Reports Select List'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:TABS,NONE'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(451367711426774765)
,p_query_column_id=>9
,p_column_alias=>'SHOW_ROWS_PER_PAGE'
,p_column_display_sequence=>13
,p_column_heading=>'Rows Per Page'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:Y,N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(451367805277774765)
,p_query_column_id=>10
,p_column_alias=>'SHOW_DISPLAY_ROW_COUNT'
,p_column_display_sequence=>9
,p_column_heading=>'Rows Per Page Selector'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:Y,N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(451367917681774765)
,p_query_column_id=>11
,p_column_alias=>'SHOW_ACTIONS_MENU'
,p_column_display_sequence=>10
,p_column_heading=>'Actions Menu'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:Y,N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(451368006968774765)
,p_query_column_id=>12
,p_column_alias=>'SHOW_SELECT_COLUMNS'
,p_column_display_sequence=>11
,p_column_heading=>'Select Columns'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:Y,N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(451368109759774765)
,p_query_column_id=>13
,p_column_alias=>'SHOW_FILTER'
,p_column_display_sequence=>12
,p_column_heading=>'Filter'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:Y,N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(451368210963774765)
,p_query_column_id=>14
,p_column_alias=>'SHOW_SORT'
,p_column_display_sequence=>14
,p_column_heading=>'Sort'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:Y,N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(451368323960774765)
,p_query_column_id=>15
,p_column_alias=>'SHOW_CONTROL_BREAK'
,p_column_display_sequence=>15
,p_column_heading=>'Control Break'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:Y,N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(451368410299774765)
,p_query_column_id=>16
,p_column_alias=>'SHOW_HIGHLIGHT'
,p_column_display_sequence=>16
,p_column_heading=>'Highlight'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:Y,N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(451368529474774765)
,p_query_column_id=>17
,p_column_alias=>'SHOW_COMPUTATION'
,p_column_display_sequence=>17
,p_column_heading=>'Compute'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:Y,N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(451368629136774765)
,p_query_column_id=>18
,p_column_alias=>'SHOW_AGGREGATE'
,p_column_display_sequence=>18
,p_column_heading=>'Aggregate'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:Y,N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(451368705374774765)
,p_query_column_id=>19
,p_column_alias=>'SHOW_NOTIFY'
,p_column_display_sequence=>29
,p_column_heading=>'Subscription *'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:Y,N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(451368820181774765)
,p_query_column_id=>20
,p_column_alias=>'SHOW_CHART'
,p_column_display_sequence=>19
,p_column_heading=>'Chart'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:Y,N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(451368905727774766)
,p_query_column_id=>21
,p_column_alias=>'SHOW_GROUP_BY'
,p_column_display_sequence=>20
,p_column_heading=>'Group By'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:Y,N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(973962080599400230)
,p_query_column_id=>22
,p_column_alias=>'SHOW_PIVOT'
,p_column_display_sequence=>21
,p_column_heading=>'Pivot'
,p_use_as_row_header=>'N'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:Y,N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(451369010379774766)
,p_query_column_id=>23
,p_column_alias=>'SHOW_FLASHBACK'
,p_column_display_sequence=>22
,p_column_heading=>'Flashback'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:Y,N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(451369121929774766)
,p_query_column_id=>24
,p_column_alias=>'ALLOW_REPORT_SAVING'
,p_column_display_sequence=>23
,p_column_heading=>'Save Report *'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:Y,N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(451369232103774766)
,p_query_column_id=>25
,p_column_alias=>'SHOW_RESET'
,p_column_display_sequence=>26
,p_column_heading=>'Reset'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:Y,N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(451369322080774766)
,p_query_column_id=>26
,p_column_alias=>'SHOW_HELP'
,p_column_display_sequence=>27
,p_column_heading=>'Help'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:Y,N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(451369401233774766)
,p_query_column_id=>27
,p_column_alias=>'SHOW_DOWNLOAD'
,p_column_display_sequence=>28
,p_column_heading=>'Download'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:Y,N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(451369509385774767)
,p_query_column_id=>28
,p_column_alias=>'ALLOW_SAVE_RPT_PUBLIC'
,p_column_display_sequence=>24
,p_column_heading=>'Save Public Report *'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'SIMPLE_CHECKBOX'
,p_inline_lov=>'STATIC:Y,N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(451369603610774767)
,p_query_column_id=>29
,p_column_alias=>'SAVE_RPT_PUBLIC_AUTH_SCHEME'
,p_column_display_sequence=>25
,p_column_heading=>'Save Public Report Authorization'
,p_use_as_row_header=>'N'
,p_display_as=>'SELECT_LIST_FROM_LOV'
,p_named_lov=>wwv_flow_imp.id(283664112341)
,p_lov_show_nulls=>'YES'
,p_lov_null_text=>'- No Authorization Required -'
,p_derived_column=>'N'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(451369719750774767)
,p_query_column_id=>30
,p_column_alias=>'SHOW_CALENDAR'
,p_column_display_sequence=>30
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(498113714685254746)
,p_query_column_id=>31
,p_column_alias=>'DOWNLOAD_FORMATS'
,p_column_display_sequence=>31
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(633638913941561250)
,p_query_column_id=>32
,p_column_alias=>'SEARCH_BUTTON_LABEL'
,p_column_display_sequence=>32
,p_column_heading=>'Search Button Label'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT'
,p_column_width=>10
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(633639002235561250)
,p_query_column_id=>33
,p_column_alias=>'MAX_ROWS_PER_PAGE'
,p_column_display_sequence=>33
,p_column_heading=>'Maximum Rows Per Page'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT'
,p_column_width=>10
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(451364208118774759)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(451364319885774759)
,p_column_sequence=>2
,p_query_column_name=>'PAGE_ID'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(451364408964774759)
,p_column_sequence=>3
,p_query_column_name=>'PAGE'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(451364522591774759)
,p_column_sequence=>4
,p_query_column_name=>'REGION'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(451364600097774759)
,p_column_sequence=>5
,p_query_column_name=>'SHOW_SEARCH_BAR'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(451364713313774759)
,p_column_sequence=>6
,p_query_column_name=>'SHOW_SEARCH_TEXTBOX'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(451364814103774759)
,p_column_sequence=>7
,p_query_column_name=>'SHOW_FINDER_DROP_DOWN'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(451364926397774759)
,p_column_sequence=>8
,p_query_column_name=>'REPORT_LIST_MODE'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(451365012728774759)
,p_column_sequence=>9
,p_query_column_name=>'SHOW_ROWS_PER_PAGE'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(451365117911774759)
,p_column_sequence=>10
,p_query_column_name=>'SHOW_DISPLAY_ROW_COUNT'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(451365204754774759)
,p_column_sequence=>11
,p_query_column_name=>'SHOW_ACTIONS_MENU'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(451365320060774759)
,p_column_sequence=>12
,p_query_column_name=>'SHOW_SELECT_COLUMNS'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(451365419136774759)
,p_column_sequence=>13
,p_query_column_name=>'SHOW_FILTER'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(451365530135774759)
,p_column_sequence=>14
,p_query_column_name=>'SHOW_SORT'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(451365605544774759)
,p_column_sequence=>15
,p_query_column_name=>'SHOW_CONTROL_BREAK'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(451365719796774759)
,p_column_sequence=>16
,p_query_column_name=>'SHOW_HIGHLIGHT'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(451365811467774759)
,p_column_sequence=>17
,p_query_column_name=>'SHOW_COMPUTATION'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(451365928441774759)
,p_column_sequence=>18
,p_query_column_name=>'SHOW_AGGREGATE'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(451366012327774759)
,p_column_sequence=>19
,p_query_column_name=>'SHOW_NOTIFY'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(451366131287774759)
,p_column_sequence=>20
,p_query_column_name=>'SHOW_CHART'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(451366226022774759)
,p_column_sequence=>21
,p_query_column_name=>'SHOW_GROUP_BY'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(451366321190774759)
,p_column_sequence=>22
,p_query_column_name=>'SHOW_FLASHBACK'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(451366409799774759)
,p_column_sequence=>23
,p_query_column_name=>'ALLOW_REPORT_SAVING'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(451366510316774759)
,p_column_sequence=>24
,p_query_column_name=>'SHOW_RESET'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(451366608710774759)
,p_column_sequence=>25
,p_query_column_name=>'SHOW_HELP'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(451366720115774760)
,p_column_sequence=>26
,p_query_column_name=>'SHOW_DOWNLOAD'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(451366809139774762)
,p_column_sequence=>27
,p_query_column_name=>'ALLOW_SAVE_RPT_PUBLIC'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(451366900362774762)
,p_column_sequence=>28
,p_query_column_name=>'SAVE_RPT_PUBLIC_AUTH_SCHEME'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(451367015409774762)
,p_column_sequence=>29
,p_query_column_name=>'SHOW_CALENDAR'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(498113603476254744)
,p_column_sequence=>30
,p_query_column_name=>'DOWNLOAD_FORMATS'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(633638206182561248)
,p_column_sequence=>31
,p_query_column_name=>'BUTTON_TEMPLATE'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(633638317134561248)
,p_column_sequence=>32
,p_query_column_name=>'FINDER_ICON'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(633610408135533264)
,p_column_sequence=>33
,p_query_column_name=>'ACTIONS_MENU_ICON'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(633638516207561248)
,p_column_sequence=>34
,p_query_column_name=>'SEARCH_BUTTON_LABEL'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(633638611605561248)
,p_column_sequence=>35
,p_query_column_name=>'MAX_ROWS_PER_PAGE'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(622840620376915872)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_source=>'Quickly update your Interactive Report Settings across your application. Note that if you turn off the Search Bar, your selections for items that are within the search bar will have no effect. Similarly, if you turn off the Actions Menu, your selecti'
||'ons that are within the actions menu will have no effect.'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(636405722520344289)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>4
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(636406623360344305)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(636405722520344289)
,p_button_name=>'P940_GO'
,p_button_static_id=>'P940_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Go'
,p_button_alignment=>'LEFT'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(636405931187344293)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(636405722520344289)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'CREATE'
,p_security_scheme=>wwv_flow_imp.id(34674432490821717)
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(451362706591759341)
,p_branch_action=>'f?p=&APP_ID.:940:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>1
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(636406126780344298)
,p_name=>'P940_PAGE_NAME_CONTAINS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(636405722520344289)
,p_prompt=>'Page Name Contains'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Enter a case insensitive query and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(636406826434344306)
,p_name=>'P940_PAGE'
,p_item_sequence=>4
,p_item_plug_id=>wwv_flow_imp.id(636405722520344289)
,p_prompt=>'Page'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d',
'  from wwv_flow_steps',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and is_page_pattern   = ''N''',
'order by 2'))
,p_cSize=>12
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Filter by page number. Enter the page number and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(636407306561344310)
,p_name=>'P940_ROWS'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_imp.id(636405722520344289)
,p_item_default=>'20'
,p_prompt=>'Rows'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC2:10,15,20,25,50,100'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Select the number of rows to display and click <span class="fielddatabold">Go</span>.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(636413410840397735)
,p_validation_name=>'P940_PAGE'
,p_validation_sequence=>10
,p_validation=>'P940_PAGE'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Page must be numeric.'
,p_associated_item=>wwv_flow_imp.id(636406826434344306)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(451362532494759340)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(451360330860759321)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'ApplyMRU'
,p_attribute_02=>'WWV_FLOW_WORKSHEETS'
,p_attribute_03=>'ID'
,p_process_error_message=>'Unable to process update.'
,p_process_when_button_id=>wwv_flow_imp.id(636405931187344293)
,p_process_success_message=>'#MRU_COUNT# row(s) updated, #MRI_COUNT# row(s) inserted.'
,p_security_scheme=>wwv_flow_imp.id(34674432490821717)
,p_internal_uid=>451362532494759340
);
end;
/
prompt --application/pages/page_00941
begin
wwv_flow_imp_page.create_page(
 p_id=>941
,p_name=>'Create Item Template - Creation Method'
,p_alias=>'CREATE-ITEM-TEMPLATE-CREATION-METHOD'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Item Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(86610101308085044)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(148117308807137199)
,p_plug_name=>'Create Item Template'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<p>You can create templates from scratch or copy them from another application. Copying a template provides you with a framework that you can modify.</p> '
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(148381109361516794)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(106501409747300331)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(148128521527145987)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_imp.id(86610101308085044)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(148133204343150523)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(86610101308085044)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(19623623448813225)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(86610101308085044)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(148387027895523446)
,p_branch_action=>'652'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(148133204343150523)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND_TEXT'
,p_branch_condition=>'F4000_P941_TYPE'
,p_branch_condition_text=>'BLANK'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(177436032410238661)
,p_branch_action=>'655'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(148133204343150523)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND_TEXT'
,p_branch_condition=>'F4000_P941_TYPE'
,p_branch_condition_text=>'COPY'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(589888574427923030)
,p_branch_action=>'f?p=&APP_ID.:162:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(19623623448813225)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(148146316762163878)
,p_name=>'F4000_P941_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(148117308807137199)
,p_item_default=>'COPY'
,p_prompt=>'Create Item Templates:'
,p_source=>'COPY'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'LABEL_TEMPLATE_WIZ'
,p_lov=>'.'||wwv_flow_imp.id(86598309219256908)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Select the method by which you wish to create a new template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
,p_item_comment=>'Select Default Templates (recommended), or create a new template from scratch?'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(589888306940923028)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(148128521527145987)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(589888417636923029)
,p_event_id=>wwv_flow_imp.id(589888306940923028)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00951
begin
wwv_flow_imp_page.create_page(
 p_id=>951
,p_name=>'Create Report Template - Creation Method'
,p_alias=>'CREATE-REPORT-TEMPLATE-CREATION-METHOD'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Report Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47964415357928278)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(148597900148976938)
,p_plug_name=>'Create Report Template'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<p>You can create templates from scratch or copy them from another application. Copying a template provides you with a framework that you can modify.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(149016402386939520)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(106501409747300331)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(148602015872986544)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47964415357928278)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(148604600073991469)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(47964415357928278)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(19618028371720074)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(47964415357928278)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(178523509749187981)
,p_branch_action=>'4321'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(148604600073991469)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND_TEXT'
,p_branch_condition=>'F4000_P951_TYPE'
,p_branch_condition_text=>'COPY'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(148891919392703708)
,p_branch_action=>'955'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(148604600073991469)
,p_branch_sequence=>50
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND_TEXT'
,p_branch_condition=>'F4000_P951_TYPE'
,p_branch_condition_text=>'BLANK'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(589890226272923047)
,p_branch_action=>'f?p=&APP_ID.:162:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(19618028371720074)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(148609728147009503)
,p_name=>'F4000_P951_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(148597900148976938)
,p_item_default=>'COPY'
,p_prompt=>'Create Report Template:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'REPORT_WIZ_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(86600327227262164)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_escape_on_http_output=>'N'
,p_help_text=>'Select the method by which you wish to create a new template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(589890043944923045)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(148602015872986544)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(589890169784923046)
,p_event_id=>wwv_flow_imp.id(589890043944923045)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_00955
begin
wwv_flow_imp_page.create_page(
 p_id=>955
,p_name=>'Create Report Template - Name'
,p_alias=>'CREATE-REPORT-TEMPLATE-NAME'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Report Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47970609433973826)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(148824528851471404)
,p_plug_name=>'Create Report Template'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(148848329905501340)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(106501409747300331)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(148830511689475923)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47970609433973826)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(148837904548483281)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(47970609433973826)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(148834024502479671)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(47970609433973826)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(87051729414600976)
,p_branch_action=>'f?p=&FLOW_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(589946591749621410)
,p_branch_action=>'f?p=&APP_ID.:951:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(148834024502479671)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(87278328637619624)
,p_name=>'P955_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(148824528851471404)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identify new report template name.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(87350923920627724)
,p_name=>'P955_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(148824528851471404)
,p_prompt=>'Theme'
,p_source=>'P4003_THEME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies a collection of templates which define the look and feel of the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(87352618163635541)
,p_name=>'P955_THEME_CLASS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(148824528851471404)
,p_prompt=>'Template Class'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REPORT THEME CLASS ID'
,p_lov=>'.'||wwv_flow_imp.id(44022800298370465)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'The template class identifies a specific usage for this template.  The template class is used when switching themes.  When switching themes template classes are matched, thus allowing themes to be switched without manually mapping all templates.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(87420722899778867)
,p_name=>'P955_TYPE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(148824528851471404)
,p_item_default=>'GENERIC_COLUMNS'
,p_prompt=>'Template Type:'
,p_source=>'GENERIC_COLUMNS'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'ROW_TEMPLATE_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(84775019904954668)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Identify report template type.  Generic column templates use the same formatting for every column in a report.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(87353605135641235)
,p_validation_name=>'P955_NAME'
,p_validation_sequence=>10
,p_validation=>'P955_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(148837904548483281)
,p_associated_item=>wwv_flow_imp.id(87278328637619624)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(73941776788235926)
,p_validation_name=>'P955_NAME unique'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_row_templates',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :workspace_id',
'   and theme_id          = :P955_THEME',
'   and row_template_name = :P955_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#LABEL# must be unique.'
,p_when_button_pressed=>wwv_flow_imp.id(148837904548483281)
,p_associated_item=>wwv_flow_imp.id(87278328637619624)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(87362316563644512)
,p_validation_name=>'P955_THEME'
,p_validation_sequence=>30
,p_validation=>'P955_THEME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(148837904548483281)
,p_associated_item=>wwv_flow_imp.id(87350923920627724)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(87367326952647501)
,p_validation_name=>'P955_THEME_CLASS'
,p_validation_sequence=>40
,p_validation=>'P955_THEME_CLASS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(148837904548483281)
,p_associated_item=>wwv_flow_imp.id(87352618163635541)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(87422105369783290)
,p_validation_name=>'P955_TYPE'
,p_validation_sequence=>50
,p_validation=>'P955_TYPE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(148837904548483281)
,p_associated_item=>wwv_flow_imp.id(87420722899778867)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(589946351512621408)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(148830511689475923)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(589946447940621409)
,p_event_id=>wwv_flow_imp.id(589946351512621408)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(148871312337631008)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Report Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'wwv_flow_imp_shared.create_row_template(',
' p_flow_id                    => v(''fb_flow_id''),',
' p_row_template_name          => :P955_NAME,',
' p_theme_id                   => :P955_THEME,',
' p_theme_class_id             => :P955_THEME_CLASS,',
' p_row_template_type          => :P955_TYPE,',
' p_column_heading_template    => NULL,',
' p_row_template1              => NULL,',
' p_row_template_condition1    => NULL,',
' p_row_template_display_cond1 => NULL,',
' p_row_template2              => NULL,',
' p_row_template_condition2    => NULL,',
' p_row_template_display_cond2 => NULL,',
' p_row_template3              => NULL,',
' p_row_template_condition3    => NULL,',
' p_row_template_display_cond3 => NULL,',
' p_row_template4              => NULL,',
' p_row_template_condition4    => NULL,',
' p_row_template_display_cond4 => NULL,',
' p_row_template_before_rows   => NULL,',
' p_row_template_after_rows    => NULL,',
' p_row_template_table_attr    => NULL,',
' p_row_template_comment       => NULL',
');',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to create template.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(148837904548483281)
,p_process_success_message=>'Template created.'
,p_internal_uid=>148871312337631008
);
end;
/
prompt --application/pages/page_00959
begin
wwv_flow_imp_page.create_page(
 p_id=>959
,p_name=>'Errors'
,p_alias=>'ERRORS'
,p_step_title=>'Errors'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(19943204431962826)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'debug.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(483658311307883464)
,p_plug_name=>'Finder Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(6207014968942318)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(483659515251898467)
,p_plug_name=>'Errors'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select	 SQLERRM,',
'	 USERID,',
'	 STEP_ID page,',
'	 SESSION_ID,',
'	 TIME_STAMP,',
'         sqlerrm_component_type,',
'         sqlerrm_component_name',
' from WWV_FLOW_ACTIVITY_LOG',
'where   security_group_id = :flow_security_group_id and',
'  flow_id = :fb_flow_id and',
'  sqlerrm is not null and',
'  time_stamp >= sysdate - 1'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(483659607062898467)
,p_name=>'Errors'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(483659823278898476)
,p_db_column_name=>'SQLERRM'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Error Message'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(483659926102898479)
,p_db_column_name=>'USERID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'User'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(483660104728898484)
,p_db_column_name=>'PAGE'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(483660213584898484)
,p_db_column_name=>'SESSION_ID'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Session'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(483660326568898485)
,p_db_column_name=>'TIME_STAMP'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Date'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(483660406911898485)
,p_db_column_name=>'SQLERRM_COMPONENT_TYPE'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Type'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(483660532050898485)
,p_db_column_name=>'SQLERRM_COMPONENT_NAME'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Component'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(483660631524898748)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1293522566536644'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'SQLERRM:USERID:APPLICATION:PAGE:TIME_STAMP'
,p_sort_column_1=>'TIME_STAMP'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1080990589859523938)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(483659515251898467)
,p_button_name=>'Reset'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:959:&SESSION.::&DEBUG.:RP,RIR,959:::'
);
end;
/
prompt --application/pages/page_00970
begin
wwv_flow_imp_page.create_page(
 p_id=>970
,p_name=>'Workspace Backups'
,p_alias=>'WORKSPACE-BACKUPS'
,p_step_title=>'Workspace Backups'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(5507013954294272)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(62926426521985347)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_display_condition_type=>'NEVER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(91648426238781268)
,p_plug_name=>'Backup Repository'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'    f.id as application_id, ',
'    f.security_group_id,',
'    f.name as application_name, ',
'    nvl(b.number_of_backups, 0) as number_of_backups, ',
'    b.last_backup_date, ',
'    f.last_updated_on,',
'    ''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'' as application_exists, ',
'    b.last_size',
'from wwv_flows f',
'left join ',
'(',
'    select ',
'        b.application_id, ',
'        count(*) over (partition by b.application_id) as number_of_backups,',
'        max(b.created_on) over (partition by b.application_id) as last_backup_date,',
'        last_value(o.doc_size) over (partition by application_id order by b.created_on RANGE BETWEEN UNBOUNDED PRECEDING AND UNBOUNDED FOLLOWING) as last_size        ',
'        from wwv_flow_backups$ b',
'        join wwv_flow_file_objects$ o on (o.id = b.object_id)',
'        where b.backup_type != ''RESTORE''',
'        and b.security_group_id = :flow_security_group_id',
') b on (b.application_id = f.id)',
'where f.build_status != ''RUN_AND_HIDDEN''    -- don''t back up packaged apps',
'and f.name is not null                      -- don''t back up un-named apps',
'and f.security_group_id = :flow_security_group_id',
'and not exists (select null ',
'                  from wwv_flow_language_map m ',
'                 where m.translation_flow_id = f.id ',
'                   and m.security_group_id = f.security_group_id) ',
'union ',
'select distinct',
'    b.application_id, ',
'    b.security_group_id,',
'    b.application_name, ',
'    count(*) over (partition by b.application_id) as number_of_backups,',
'    max(b.created_on) over (partition by b.application_id) as last_backup_date,',
'    null as last_updated_on, ',
'    null as application_exists, ',
'    last_value(o.doc_size) over (partition by application_id order by b.created_on RANGE BETWEEN UNBOUNDED PRECEDING AND UNBOUNDED FOLLOWING) as last_size',
'from wwv_flow_backups$ b',
'join wwv_flow_file_objects$ o on (o.id = b.object_id)',
'where b.backup_type != ''RESTORE''',
'and b.security_group_id = :flow_security_group_id',
'and not exists (select 1 from wwv_flows ne where ne.id = b.application_id and ne.security_group_id = b.security_group_id)',
'order by application_id',
';'))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_plug_comment=>'generated 31-JUL-2001 13:40:41'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(9766127603736090)
,p_max_row_count=>'1000000'
,p_show_nulls_as=>' '
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'DBLISS'
,p_internal_uid=>9766127603736090
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2257131525636740)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>10
,p_column_identifier=>'F'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(7516361140099436)
,p_db_column_name=>'NUMBER_OF_BACKUPS'
,p_display_order=>30
,p_column_identifier=>'D'
,p_column_label=>'# Backups'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2257237951636741)
,p_db_column_name=>'LAST_BACKUP_DATE'
,p_display_order=>40
,p_column_identifier=>'G'
,p_column_label=>'Last Backup'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(13154548816187519)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>50
,p_column_identifier=>'H'
,p_column_label=>'Application Name'
,p_column_link=>'f?p=&APP_ID.:971:&SESSION.::&DEBUG.:RP:P971_APPLICATION_ID,FB_FLOW_ID,F4000_P1_FLOW,P0_FLOWPAGE,RECENT_PAGES:#APPLICATION_ID#,#APPLICATION_ID#,#APPLICATION_ID#,#APPLICATION_ID#,'
,p_column_linktext=>'#APPLICATION_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(70878880123225909)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>60
,p_column_identifier=>'I'
,p_column_label=>'Last Updated'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(29200189239902101)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>70
,p_column_identifier=>'J'
,p_column_label=>'Security Group Id'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(70879896892225919)
,p_db_column_name=>'APPLICATION_EXISTS'
,p_display_order=>80
,p_column_identifier=>'K'
,p_column_label=>'Application Exists'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(396497640807282701)
,p_db_column_name=>'LAST_SIZE'
,p_display_order=>90
,p_column_identifier=>'L'
,p_column_label=>'Last Size'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(13441434626944710)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'75171'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'APPLICATION_ID:APPLICATION_NAME:LAST_SIZE:LAST_BACKUP_DATE:LAST_UPDATED_ON:APPLICATION_EXISTS:NUMBER_OF_BACKUPS:'
,p_sort_column_1=>'LAST_BACKUP_DATE'
,p_sort_direction_1=>'DESC'
,p_sort_column_2=>'APPLICATION_ID'
,p_sort_direction_2=>'ASC'
,p_sum_columns_on_break=>'NUMBER_OF_BACKUPS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(196343840029240189)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Automated backups are performed as part of daily maintenance. Only applications that have been modified will be backed up.</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(239695113641405231)
,p_plug_name=>'Report Current Application'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_06'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :fb_flow_id is null then',
'    sys.htp.prn(''<span class="htmldbRunEdit">''||',
'       wwv_flow_lang.system_message(''no_application_selected'')||''&nbsp;</span>'');',
'else',
'   sys.htp.prn(''<span class="htmldbRunEdit">''||',
'    wwv_flow_lang.system_message(''application'')||'': ''||:fb_flow_id||''&nbsp;</span>'');',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(254938142249716219)
,p_plug_name=>'Settings'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Only the &P970_MAX. most recent application backups are retained. Older backups will be deleted to make room for new ones.</p>',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7511352165099409)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(62926426521985347)
,p_button_name=>'P970_GO'
,p_button_static_id=>'P73_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Set'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7511783097099411)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(62926426521985347)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete Checked'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7512145213099413)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(62926426521985347)
,p_button_name=>'IMPORT_FILE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Import File'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:460:&SESSION.::&DEBUG.:459,460:P461_EXPIMP:IMPORT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(395885750682084615)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(91648426238781268)
,p_button_name=>'reset_report'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:970:&SESSION.::&DEBUG.:RR,970::'
,p_icon_css_classes=>'icon-undo'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(7520283268099458)
,p_branch_action=>'f?p=&APP_ID.:970:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7512526384099415)
,p_name=>'P970_FIND'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(62926426521985347)
,p_prompt=>'Find'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a case insensitive query and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7513492728099422)
,p_name=>'P970_SHOW'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(62926426521985347)
,p_prompt=>'Show'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'EXPORT_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(84313028848586180)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- All -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a content type and then click <span class="fielddatabold">Go</span>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7514359210099423)
,p_name=>'P970_OWNER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(62926426521985347)
,p_prompt=>'Owner'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct created_by d, created_by r',
'from WWV_FLOW_FILE_OBJECTS$',
'where security_group_id = :flow_security_group_id and',
'deleted_as_of = to_date(''01.01.0001'',''MM.DD.YYYY'') and ',
'       created_by != ''HTMLDB_PUBLIC_USER'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- All Owners -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a owner and then click <span class="fielddatabold">Go</span>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(184061262969498747)
,p_name=>'P970_MAX'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(254938142249716219)
,p_source=>'return wwv_flow_backup.backup_limit();'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(7518148009099449)
,p_validation_name=>'File Selection Not Null'
,p_validation_sequence=>10
,p_validation=>'wwv_flow_utilities.table_to_string2(wwv_flow.g_f01) is not null'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Select the files to delete.'
,p_when_button_pressed=>wwv_flow_imp.id(7511783097099411)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(7519360245099452)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(91648426238781268)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7519704290099455)
,p_event_id=>wwv_flow_imp.id(7519360245099452)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(7518900424099451)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Checked'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'forall i in 1..wwv_flow.g_f01.count',
'    delete from wwv_flow_file_objects$',
'     where id = wwv_flow.g_f01(i) and',
'           security_group_id = :flow_security_group_id',
'   ;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error deleting file(s).'
,p_process_when_button_id=>wwv_flow_imp.id(7511783097099411)
,p_process_success_message=>'File(s) deleted.'
,p_internal_uid=>7518900424099451
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(7518579045099450)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>7518579045099450
);
end;
/
prompt --application/pages/page_00971
begin
wwv_flow_imp_page.create_page(
 p_id=>971
,p_name=>'Manage Application Backups'
,p_alias=>'MANAGE-APPLICATION-BACKUPS'
,p_step_title=>'Manage Backups'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(5507013954294272)
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// Note how generic this code is. The only thing specific to the example is',
'// the name of the menu (ir_context_menu) and the button class (ir-actions-btn).',
'// It could easily be turned into a function and moved to a JavaScript file to',
'// be used from any number of reports.',
'var i, item,',
'    items = $("#mb_context_menu").menu("option").items, ',
'    // for some reason the list options are getting double encoded when referencing application pages so ',
'    // I had to create two sets of regular expressions to make this work.',
'    regLong =  /\\u002524\w+\\u002524/,',
'    regLongG = /\\u002524(\w+)\\u002524/g,',
'    regDollar = /\$\w+\$/,',
'    regDollarG = /\$(\w+)\$/g;',
'',
'// The URLs used in the menu are not complete as is.',
'// They have $attr$ substitution symbols that act as a template. This code',
'// moves decodes the $ symbol and copies the href to hrefTemplate property',
'// so it can be used each time the menu opens',
'for (i = 0; i < items.length; i++) {',
'    item = items[i];',
'    if ( (item.href && regLong.exec(item.href)) || (item.href && regDollar.exec(item.href)) ) {',
'        console.log(item.href);',
'        item.hrefTemplate = item.href;',
'    }',
'}',
'',
'// When the menu opens',
'$("#mb_context_menu").on("menubeforeopen", function(event, data) {',
'    var i, item, disabled,',
'        items = data.menu.items,',
'        // This is how to get the context. Would be nice if the beforeopen',
'        // event could tell you directly what button opened it',
'        context$ = $(".ir-actions-btn.is-active"); ',
'    // for each menu item',
'    for( i = 0; i < items.length; i++ ) {',
'        item = items[i];',
'        item.disabled = false;',
'        // if it has a template href with the long pattern',
'        if (item.hrefTemplate && regLong.exec(item.hrefTemplate)) {',
'            // This replace function will replace all $name$ tokens with the',
'            // value of attribute "data-name" on the context element.',
'            // If a context attribute doesn''t exist then disable the menu item',
'            item.href = item.hrefTemplate.replace(regLongG, function(m, token) {',
'                var data = context$.attr("data-" + token);',
'                //if (data === undefined || data === "") {',
'                //    item.disabled = true;',
'                //}',
'                return data;',
'            });',
'        }',
'        // if it has a template href with the dollar-sign pattern',
'        if (item.hrefTemplate && regDollar.exec(item.hrefTemplate)) {',
'            // This replace function will replace all $name$ tokens with the',
'            // value of attribute "data-name" on the context element.',
'            // If a context attribute doesn''t exist then disable the menu item',
'            item.href = item.hrefTemplate.replace(regDollarG, function(m, token) {',
'                var data = context$.attr("data-" + token);',
'                //if (data === undefined || data === "") {',
'                //    item.disabled = true;',
'                //}',
'                return data;',
'            });',
'        }',
'    }',
'});'))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.t-Body-inlineDialogs {border: 0;clip: rect(0 0 0 0);height: 1px;margin: -1px;overflow: hidden;padding: 0;position: absolute;width: 1px;}',
''))
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3848902975631028)
,p_plug_name=>'Maximum Number Of Backups Locked'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--info:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'There are &P971_MAX. or more application backups locked. No new backups will be created.'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'to_number(:P971_BACKUP_COUNT) >= to_number(:P971_MAX)'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(12521305294219513)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Automated backups are performed as part of daily maintenance. Only applications that have been modified will be backed up.</p>',
'<p>To manually back up the application, outside of daily maintenance, click <strong>Create Backup</strong>.</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(15097015004914465)
,p_plug_name=>'Backup Report'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'  b.id as backup_id, ',
'  case ',
'  when b.backup_type = ''RESTORE'' then',
'      ''<span class="a-Icon icon-undo" aria-hidden="true"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''BU.RESTORED'', b.application_id, b.revision)||''</span>''',
'  when b.backup_status = ''COMPLETE'' and b.locked_on is null then',
'      ''<span class="a-Icon icon-unlock" aria-hidden="true"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''BU.UNLOCKED'')||''</span>''',
'  when b.backup_status = ''COMPLETE'' and b.locked_on is not null then',
'      ''<span class="a-Icon icon-lock" aria-hidden="true"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''BU.LOCKED'')||''</span>''',
'  when b.backup_status = ''ERROR'' then ',
'      ''<span class="a-Icon icon-warning" aria-hidden="true"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''BU.APPLICATION_ERROR'', b.revision)||''</span>''',
'  when b.backup_status = ''IN PROGRESS'' then ',
'      ''<span class="a-Icon icon-gear-alt" aria-hidden="true"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''BU.IN_PROGRESS'')||''</span>''',
'  else',
'    b.backup_status',
'  end as status_icon, ',
'  case ',
'  when b.backup_type = ''RESTORE'' then',
'      wwv_flow_lang.system_message(''BU.RESTORED'', b.application_id, b.revision)',
'  when b.backup_status = ''COMPLETE'' and b.locked_on is null then',
'      wwv_flow_lang.system_message(''BU.UNLOCKED'')',
'  when b.backup_status = ''COMPLETE'' and b.locked_on is not null then',
'     wwv_flow_lang.system_message(''BU.LOCKED'')',
'  when b.backup_status = ''ERROR'' then ',
'      wwv_flow_lang.system_message(''BU.APPLICATION_ERROR'', b.revision)',
'  when b.backup_status = ''IN PROGRESS'' then ',
'      wwv_flow_lang.system_message(''BU.IN_PROGRESS'')',
'  else',
'    b.backup_status',
'  end as status_message, ',
'  b.id, ',
'  b.application_id as backup_app_id, ',
'  b.application_name, ',
'  wwv_flow_backup.format_manifest(b.manifest) as manifest, ',
'  b.description, ',
'  b.created_on, ',
'  case when b.backup_type = ''AUTO'' then ''Automated Backup'' else b.created_by end as created_by, ',
'  nvl(o.doc_size, 0) as doc_size, ',
'  to_char(b.revision) as revision,',
'  case when backup_type = ''RESTORE'' then ',
'    null',
'  else',
'  ''<button type="button" title="'' || m.msg_actions || ''" aria-label="'' || m.msg_actions || ''" class="a-Button a-Button--noLabel a-Button--iconTextButton a-Button--noUI ir-actions-btn js-menuButton"',
'        data-menu="mb_context_menu"',
'        data-backupid="''||b.id||''"',
'        data-objectid="''||b.object_id||''"',
'        data-flowid="''||b.application_id||''">',
'    <span class="a-Icon icon-menu" aria-hidden="true"></span>',
'    <span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span>',
'</button>''',
'  end',
'  as action,',
'  b.backup_type, ',
'  b.backup_status, ',
'  b.locked_on, ',
'  b.locked_by',
' from wwv_flow_backups$ b',
' left join wwv_flow_file_objects$ o on (o.id = b.object_id)',
'cross join (select wwv_flow_escape.html_attribute(wwv_flow_lang.system_message(''ACTIONS'')) as msg_actions',
'              from sys.dual',
'             where rownum = 1) m',
'where b.application_id = :fb_flow_id',
'  and b.security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(9832206744401027)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'No backups have been created for application &FB_FLOW_ID.'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'DBLISS'
,p_internal_uid=>9832206744401027
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(7576718880764309)
,p_db_column_name=>'DESCRIPTION'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Description'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(7577118490764309)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>'Date'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(7577955644764310)
,p_db_column_name=>'MANIFEST'
,p_display_order=>70
,p_column_identifier=>'G'
,p_column_label=>'Change Summary'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'CLOB'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'LEFT'
,p_rpt_show_filter_lov=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(7583525815012114)
,p_db_column_name=>'BACKUP_TYPE'
,p_display_order=>90
,p_column_identifier=>'I'
,p_column_label=>'Type'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(7584052922012119)
,p_db_column_name=>'BACKUP_STATUS'
,p_display_order=>120
,p_column_identifier=>'M'
,p_column_label=>'Backup Status'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(7584891515012127)
,p_db_column_name=>'ID'
,p_display_order=>140
,p_column_identifier=>'O'
,p_column_label=>'ID'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'NUMBER'
,p_column_alignment=>'CENTER'
,p_static_id=>'actions_col'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(7587179848012150)
,p_db_column_name=>'BACKUP_APP_ID'
,p_display_order=>160
,p_column_identifier=>'R'
,p_column_label=>'Backup App ID'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12523386582219533)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>180
,p_column_identifier=>'U'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12523467966219534)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>190
,p_column_identifier=>'V'
,p_column_label=>'Created By'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12523594230219535)
,p_db_column_name=>'DOC_SIZE'
,p_display_order=>200
,p_column_identifier=>'W'
,p_column_label=>'Size'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'FILESIZE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12523694029219536)
,p_db_column_name=>'LOCKED_ON'
,p_display_order=>210
,p_column_identifier=>'X'
,p_column_label=>'Locked On'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12523746197219537)
,p_db_column_name=>'LOCKED_BY'
,p_display_order=>220
,p_column_identifier=>'Y'
,p_column_label=>'Locked By'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(12523868201219538)
,p_db_column_name=>'STATUS_ICON'
,p_display_order=>230
,p_column_identifier=>'Z'
,p_column_label=>'Status'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(8000903790535604)
,p_db_column_name=>'REVISION'
,p_display_order=>270
,p_column_identifier=>'AF'
,p_column_label=>'Revision'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(70878553581225906)
,p_db_column_name=>'ACTION'
,p_display_order=>280
,p_column_identifier=>'AG'
,p_column_label=>'Action'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(70878777381225908)
,p_db_column_name=>'STATUS_MESSAGE'
,p_display_order=>300
,p_column_identifier=>'AI'
,p_column_label=>'Status'
,p_column_html_expression=>'#STATUS_ICON!RAW#'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(7508133414098828)
,p_db_column_name=>'BACKUP_ID'
,p_display_order=>310
,p_column_identifier=>'AJ'
,p_column_label=>'Backup ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(15125345793568912)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'75783'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'APPLICATION_NAME:REVISION:CREATED_ON:MANIFEST:CREATED_BY:DOC_SIZE:STATUS_MESSAGE:ACTION:'
,p_sort_column_1=>'CREATED_ON'
,p_sort_direction_1=>'DESC'
,p_sum_columns_on_break=>'DOC_SIZE'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(25804736597574802)
,p_plug_name=>'Inline Dialog Container'
,p_region_css_classes=>'t-Body-inlineDialogs'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(25804682224574801)
,p_plug_name=>'Backup Menu'
,p_region_name=>'mb_context'
,p_parent_plug_id=>wwv_flow_imp.id(25804736597574802)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(461857790551605627)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_imp.id(25800649414501670)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(3712705120335)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(70878332483225904)
,p_plug_name=>'Settings'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>'<p>Only the &P971_MAX. most recent application backups are retained. Older backups will be deleted to make room for new ones.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(70878988109225910)
,p_plug_name=>'Application'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<p>'');',
'for c in (select last_updated_on from wwv_flows where id = :FB_FLOW_ID) loop',
'    sys.htp.p(wwv_flow_lang.system_message(''BU.LAST_UPDATE'', htmldb_util.get_since(c.last_updated_on)));',
'end loop;',
'sys.htp.p(''<br/>'');',
'for c in (select max(last_updated_on) as last_updated_on from  wwv_flow_backups$ where application_id = :FB_FLOW_ID) loop',
'    sys.htp.p(wwv_flow_lang.system_message(''BU.LAST_BACKUP'', htmldb_util.get_since(c.last_updated_on)));',
'end loop;',
'sys.htp.p(''</p>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(70879913317225920)
,p_plug_name=>'Application not installed'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'Application &FB_FLOW_ID. does not exist in the current workspace. Use the Restore action to reinstall the application from a backup.'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_imp_parser.flow_exists(:fb_flow_id) = 0'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(70880084338225921)
,p_plug_name=>'Resources'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(392874975855473167)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(397024265857344325)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(15097015004914465)
,p_button_name=>'reset_report'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:971:&SESSION.::&DEBUG.:RR,971::'
,p_icon_css_classes=>'icon-undo'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7510314911098850)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(15097015004914465)
,p_button_name=>'REMOVE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Remove All'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:978:&SESSION.::&DEBUG.::P978_FLOW_ID:&FB_FLOW_ID.'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7578784909764318)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(15097015004914465)
,p_button_name=>'BACKUP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Backup'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:972:&SESSION.::&DEBUG.:RP,972::'
,p_button_condition=>'wwv_flow_imp_parser.flow_exists(:fb_flow_id) = 1'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3848718166631026)
,p_name=>'P971_BACKUP_COUNT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(15097015004914465)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7579129666764322)
,p_name=>'P971_APPLICATION_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(15097015004914465)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(13153488865187508)
,p_name=>'P971_MAX'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(15097015004914465)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3849033873631029)
,p_computation_sequence=>10
,p_computation_item=>'P971_BACKUP_COUNT'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*) ',
' from wwv_flow_backups$ b',
' where b.application_id = :fb_flow_id',
'  and b.security_group_id = :flow_security_group_id',
'  and b.locked_on is not null;'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3849193050631030)
,p_computation_sequence=>20
,p_computation_item=>'P971_MAX'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_backup.backup_limit()'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3849209410631031)
,p_name=>'Disable Create Backup'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>'to_number(:P971_BACKUP_COUNT) >= to_number(:P971_MAX)'
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3849311042631032)
,p_event_id=>wwv_flow_imp.id(3849209410631031)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(7578784909764318)
);
end;
/
prompt --application/pages/page_00972
begin
wwv_flow_imp_page.create_page(
 p_id=>972
,p_name=>'Create a Backup'
,p_alias=>'CREATE-A-BACKUP'
,p_page_mode=>'MODAL'
,p_step_title=>'Create a Backup'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(5507013954294272)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7582294140012101)
,p_plug_name=>'Backup'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P972_SHOW_BACKUP = ''Y'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7582467942012103)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(12524123798219541)
,p_plug_name=>'Nothing to backup'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>There have been no changes to the application since the last backup.',
'</p>'))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P972_SHOW_NOTHING = ''Y'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7592513034173735)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(7582467942012103)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7582588184012104)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(7582467942012103)
,p_button_name=>'BACKUP'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Backup'
,p_button_position=>'NEXT'
,p_button_condition=>':P972_SHOW_BACKUP = ''Y'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(7583072854012109)
,p_branch_name=>'Refresh Application Backups'
,p_branch_action=>'f?p=&APP_ID.:971:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7582378527012102)
,p_name=>'P972_COMMENTS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(7582294140012101)
,p_prompt=>'Comments'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7591604665165989)
,p_name=>'P972_F'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(7582294140012101)
,p_prompt=>'Application'
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_help_text=>'This attribute identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12524225591219542)
,p_name=>'P972_SHOW_BACKUP'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(7582467942012103)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12524599749219545)
,p_name=>'P972_SHOW_NOTHING'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(7582467942012103)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(7582681841012105)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(7592513034173735)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7582722399012106)
,p_event_id=>wwv_flow_imp.id(7582681841012105)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(12524422084219544)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'INIT'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_last_backup   date;',
'  l_last_modified date;',
'  l_backups       number;',
'  l_locks         number;',
'  l_max           number;',
'begin',
'  null;',
'    l_max := wwv_flow_backup.backup_limit(); ',
'    begin    ',
'    select ',
'      max(b.created_on)                              as last_backup_date, ',
'      f.last_updated_on                              as last_modified_date,',
'      count(*)                                       as number_of_backups, ',
'      nvl(sum(decode(b.locked_on, null, 0, 1)), 0)   as number_of_locks ',
'    into ',
'      l_last_backup,',
'      l_last_modified,',
'      l_backups, ',
'      l_locks',
'    from wwv_flow_backups$ b',
'    join wwv_flows f on (f.id = b.application_id)',
'    where b.application_id = :FB_FLOW_ID',
'    group by f.last_updated_on;',
'    exception',
'      when others then ',
'        l_last_backup := null;',
'    end;',
'    ',
'    -- determine which fields and buttons are displayed depending upon the values returned',
'    if l_last_backup is null or l_last_backup < l_last_modified then ',
'      :P972_SHOW_BACKUP  := ''Y'';',
'      :P972_SHOW_NOTHING := ''N'';',
'    else ',
'      :P972_SHOW_BACKUP  := ''N'';',
'      :P972_SHOW_NOTHING := ''Y'';',
'    end if;',
'    ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>12524422084219544
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(7582994315012108)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Backup Application'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  wwv_flow_backup.main(:FB_FLOW_ID, :P972_COMMENTS);',
'end;',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(7582588184012104)
,p_process_success_message=>'Application &FB_FLOW_ID. backup submitted'
,p_internal_uid=>7582994315012108
);
end;
/
prompt --application/pages/page_00973
begin
wwv_flow_imp_page.create_page(
 p_id=>973
,p_name=>'Backup Details'
,p_alias=>'BACKUP-DETAILS'
,p_page_mode=>'MODAL'
,p_step_title=>'Backup Details'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(5507013954294272)
,p_step_template=>wwv_flow_imp.id(120871216744825711)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(7508268365098829)
,p_name=>'Backup Details'
,p_template=>wwv_flow_imp.id(42025417508627628)
,p_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with manifest_summary as (',
'    select wwv_flow_lang.system_message(e.component_type) as component_type,',
'           wwv_flow_lang.system_message(e.action) as action,',
'           e.component_name,',
'           e.last_updated_by, ',
'           to_date(e.last_updated_on, ''YYYYMMDD HH24:MI:SS'') as last_updated_on',
'    from wwv_flow_backups$ j, xmltable(',
'        ''/json/details/row''',
'        passing wwv_flow_json.to_xmltype( j.manifest )',
'        columns',
'            component_type    varchar2(100)   path ''component_type/text()'',',
'            action            varchar2(100)   path ''action/text()'',',
'            component_name    varchar2(1000)  path ''component_name/text()'',',
'            last_updated_by   varchar2(100)   path ''last_updated_by/text()'',',
'            last_updated_on   varchar2(100)   path ''last_updated_on/text()'' ) e',
'    where  j.id = :P973_ID',
'    and j.security_group_id = wwv_flow.get_security_group_id()',
'    and j.manifest like ''{%''',
')',
'select * from manifest_summary;'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_backups$ j',
'where  j.id = :P973_ID',
'and j.security_group_id = wwv_flow.get_security_group_id()',
'and j.manifest like ''{%'''))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'<p>Application properties have been updated. No other components have been updated.</p>'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7508387117098830)
,p_query_column_id=>1
,p_column_alias=>'COMPONENT_TYPE'
,p_column_display_sequence=>1
,p_column_heading=>'Component Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7508436368098831)
,p_query_column_id=>2
,p_column_alias=>'ACTION'
,p_column_display_sequence=>3
,p_column_heading=>'Action'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7508568209098832)
,p_query_column_id=>3
,p_column_alias=>'COMPONENT_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Component Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7508634386098833)
,p_query_column_id=>4
,p_column_alias=>'LAST_UPDATED_BY'
,p_column_display_sequence=>4
,p_column_heading=>'Developer'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(7508730704098834)
,p_query_column_id=>5
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>5
,p_column_heading=>'Date'
,p_use_as_row_header=>'N'
,p_column_format=>'&DATE_TIME_FORMAT.'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7508858356098835)
,p_plug_name=>'BUTTONS'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(239630035198602786)
,p_plug_name=>'Initial Application Backup'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_manifest wwv_flow_backups$.manifest%type;',
'begin',
'    select j.manifest',
'    into l_manifest',
'    from wwv_flow_backups$ j',
'    where j.id = :P973_ID',
'    and j.security_group_id = wwv_flow.get_security_group_id();',
'',
'    sys.htp.p(''<p>''||l_manifest||''</p>'');',
'end;',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'NOT_EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_backups$ j',
'where  j.id = :P973_ID',
'and j.security_group_id = wwv_flow.get_security_group_id()',
'and j.manifest like ''{%'''))
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(21205281332555992)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(7508858356098835)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12361412704400654)
,p_name=>'P973_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(239630035198602786)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(7508981142098836)
,p_name=>'Close Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(21205281332555992)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7509088511098837)
,p_event_id=>wwv_flow_imp.id(7508981142098836)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
);
end;
/
prompt --application/pages/page_00974
begin
wwv_flow_imp_page.create_page(
 p_id=>974
,p_name=>'Restore Application'
,p_alias=>'RESTORE-APPLICATION'
,p_page_mode=>'MODAL'
,p_step_title=>'Restore Application'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(5507013954294272)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7585208326012131)
,p_plug_name=>'Restore Options'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Restoring an application using the original Application ID will overwrite the existing application with the backup.     ',
'</p>',
'<p>',
'Specify a new Application ID to restore without overwriting the existing application.    ',
'</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7585680269012135)
,p_plug_name=>'BUTTONS'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7585709308012136)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(7585680269012135)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7586250418012141)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(7585680269012135)
,p_button_name=>'RESTORE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Restore Application'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(12520960164219509)
,p_branch_name=>'Go Home'
,p_branch_action=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:RP,974:FB_FLOW_ID,F4000_P1_FLOW,P0_FLOWPAGE,RECENT_PAGES:&P974_NEW_FLOW_ID.,&P974_NEW_FLOW_ID.,&P974_NEW_FLOW_ID.,&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7585326200012132)
,p_name=>'P974_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(7585208326012131)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7586026210012139)
,p_name=>'P974_NEW_FLOW_OPT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(7585208326012131)
,p_item_default=>'REUSE'
,p_prompt=>'Install As Application'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Restore Application ID &FB_FLOW_ID.;REUSE,Auto Assign New Application ID;AUTO,Change Application ID;SPECIFY'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select how to restore this application. Available options include:</p>',
'',
'<ul>',
'<li><strong>Restore Application ID</strong> - The existing application ID will be used.</li>',
'<li><strong>Auto Assign New Application ID</strong> - A new application ID will be created for you.</li>',
'<li><strong>Change Application ID</strong> - Specify a new application ID.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7586376275012142)
,p_name=>'P974_NEW_FLOW_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(7585208326012131)
,p_prompt=>'New Application'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>8
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify a new application ID, which is an integer value that identifies the application.  The application ID must be unique within your &PRODUCT_NAME. instance.',
'<br><br>',
'Application IDs in the range of 3000 to 9000 are reserved for internal use by &PRODUCT_NAME.<br>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7586923102012148)
,p_name=>'P974_FLOW_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(7585208326012131)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(13153611075187510)
,p_name=>'P974_BACKUP_FIRST'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(7585208326012131)
,p_prompt=>'Backup before restoring'
,p_source=>'Y'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_display_when=>'P974_SHOW_BACKUP'
,p_display_when2=>'Y'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(13154179781187515)
,p_name=>'P974_SHOW_BACKUP'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(7585208326012131)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(13154217996187516)
,p_name=>'P974_SHOW_NOTHING'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(7585208326012131)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(13154391769187517)
,p_name=>'P974_NOTHING'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(7585208326012131)
,p_source=>'There have been no changes to the application since the last backup.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'P974_SHOW_NOTHING'
,p_display_when2=>'Y'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(12520158687219501)
,p_computation_sequence=>10
,p_computation_item=>'P974_NEW_FLOW_ID'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P974_FLOW_ID'
,p_computation_error_message=>'Unable to compute item value.'
,p_compute_when=>'P974_NEW_FLOW_OPT'
,p_compute_when_text=>'REUSE'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(12520234638219502)
,p_computation_sequence=>20
,p_computation_item=>'P974_NEW_FLOW_ID'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return wwv_flow_utilities.minimum_free_flow();'
,p_computation_error_message=>'Unable to compute item value.'
,p_compute_when=>':P974_NEW_FLOW_OPT = ''AUTO'' and :REQUEST = ''RESTORE'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(12520340327219503)
,p_validation_name=>'New Flow ID Not Null'
,p_validation_sequence=>20
,p_validation=>'P974_NEW_FLOW_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'New Application must be specified.'
,p_validation_condition=>'P974_NEW_FLOW_OPT'
,p_validation_condition2=>'SPECIFY'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(7586250418012141)
,p_associated_item=>wwv_flow_imp.id(7586376275012142)
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(12520502118219505)
,p_validation_name=>'specify new flow not same flow'
,p_validation_sequence=>30
,p_validation=>'ltrim(:P974_NEW_FLOW_ID,''0'') != nvl(:P974_FLOW_ID,-1)'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'New Application ID must be different from the original Application ID when using this option. To use the same application ID again, use the ''Restore Application ID &P974_FLOW_ID.'' radio button.'
,p_validation_condition=>':P974_NEW_FLOW_OPT = ''SPECIFY'' and wwv_flow_utilities.is_numeric(:P974_NEW_FLOW_ID)'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(7586250418012141)
,p_associated_item=>wwv_flow_imp.id(7586376275012142)
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(12520605977219506)
,p_validation_name=>'reserved flow id check'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_utilities.get_app_id_reserved_reason (',
'           p_security_group_id => :FLOW_SECURITY_GROUP_ID,',
'           p_application_id    => :P974_NEW_FLOW_ID );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':P974_NEW_FLOW_OPT = ''SPECIFY'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(7586250418012141)
,p_associated_item=>wwv_flow_imp.id(7586376275012142)
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(12520783627219507)
,p_validation_name=>'cannot import invalid range flow'
,p_validation_sequence=>50
,p_validation=>':P974_NEW_FLOW_ID not between 4000 and 4999'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'The application you are trying to restore is reserved.'
,p_validation_condition=>'(:flow_security_group_id != 10) and (:P974_FLOW_ID is not null) and (wwv_flow_utilities.is_numeric(:P974_NEW_FLOW_ID) = true)'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(7586250418012141)
,p_associated_item=>wwv_flow_imp.id(7586376275012142)
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(12520876989219508)
,p_validation_name=>'P974_NEW_FLOW_ID positive, whole number'
,p_validation_sequence=>60
,p_validation=>'P974_NEW_FLOW_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>'Application Number must be a positive, whole number.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P974_NEW_FLOW_ID is not null and',
':P974_NEW_FLOW_OPT = ''SPECIFY'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(7586250418012141)
,p_associated_item=>wwv_flow_imp.id(7586376275012142)
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(7585817710012137)
,p_name=>'Cancel'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(7585709308012136)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7585949689012138)
,p_event_id=>wwv_flow_imp.id(7585817710012137)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(7586491178012143)
,p_name=>'Toggle New Flow ID'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P974_NEW_FLOW_OPT'
,p_condition_element=>'P974_NEW_FLOW_OPT'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SPECIFY'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7586530962012144)
,p_event_id=>wwv_flow_imp.id(7586491178012143)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P974_NEW_FLOW_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7586620776012145)
,p_event_id=>wwv_flow_imp.id(7586491178012143)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P974_NEW_FLOW_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(13153734280187511)
,p_name=>'Toggle Backup First'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P974_NEW_FLOW_OPT'
,p_condition_element=>'P974_NEW_FLOW_OPT'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REUSE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(13153856988187512)
,p_event_id=>wwv_flow_imp.id(13153734280187511)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P974_BACKUP_FIRST'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(13153910875187513)
,p_event_id=>wwv_flow_imp.id(13153734280187511)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P974_BACKUP_FIRST'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(7586855429012147)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Restore'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_new_flow_id number;',
'begin',
'  case when :P974_NEW_FLOW_OPT = ''REUSE'' then ',
'    l_new_flow_id := :P974_FLOW_ID;',
'  else -- AUTO',
'    l_new_flow_id := :P974_NEW_FLOW_ID;',
'  end case;',
'',
'  wwv_flow_backup.restore(:P974_ID, :P974_FLOW_ID, l_new_flow_id, nvl(:P974_BACKUP_FIRST, ''N'') = ''Y'');',
'end;',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(7586250418012141)
,p_internal_uid=>7586855429012147
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(13154042218187514)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'INIT'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_last_backup   date;',
'  l_last_modified date;',
'  l_backups       number;',
'  l_locks         number;',
'begin',
'    select ',
'      max(b.created_on)                              as last_backup_date, ',
'      f.last_updated_on                              as last_modified_date,',
'      count(*)                                       as number_of_backups, ',
'      nvl(sum(decode(b.locked_on, null, 0, 1)), 0)   as number_of_locks ',
'    into ',
'      l_last_backup,',
'      l_last_modified,',
'      l_backups, ',
'      l_locks',
'    from wwv_flow_backups$ b',
'    left join wwv_flows f on (f.id = b.application_id)',
'    where b.application_id = :FB_FLOW_ID',
'    and b.security_group_id = :flow_security_group_id',
'    group by f.last_updated_on;',
'    ',
'    -- determine which fields and buttons are displayed depending upon the values returned',
'    if l_last_backup is null or l_last_backup < l_last_modified then ',
'      :P974_SHOW_BACKUP  := ''Y'';',
'      :P974_SHOW_NOTHING := ''N'';',
'    else ',
'      :P974_SHOW_BACKUP  := ''N'';',
'      :P974_SHOW_NOTHING := ''Y'';',
'    end if;',
'    ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>13154042218187514
);
end;
/
prompt --application/pages/page_00975
begin
wwv_flow_imp_page.create_page(
 p_id=>975
,p_name=>'Test REST Web Reference'
,p_alias=>'TEST-REST-WEB-REFERENCE1'
,p_step_title=>'Test REST Web Reference'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="javascript">',
'',
'function p975_test_rest(){',
'',
'    var get = new htmldb_Get(null,$v(''pFlowId''),''APPLICATION_PROCESS=P875_TEST_REST'',0);',
'',
'    get.addParam(''x01'',$v(''P975_URL''));',
'    get.addParam(''x02'',$v(''P975_PROXY_OVERRIDE''));',
'    get.addParam(''x03'',$v(''P975_STATIC_PARM_04''));',
'    get.addParam(''x04'',$v(''P975_USERNAME''));',
'    get.addParam(''x05'',$v(''P975_PASSWORD''));',
'    get.addParam(''x06'',encodeURIComponent($v(''P975_SOURCE'')));',
'',
'    apex.jQuery("input[name=f01]").each( function() {',
'        get.addParam(''f01'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f02]").each( function() {',
'        get.addParam(''f02'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f03]").each( function() {',
'        get.addParam(''f03'',apex.jQuery(this).val());',
'        });',
'    apex.jQuery("input[name=f04]").each( function() {',
'        get.addParam(''f04'',apex.jQuery(this).val());',
'        });',
'',
'    gReturn = get.get();',
'    apex.jQuery("#rest_response").show();',
'    apex.jQuery("#rest_response_container").text(gReturn);',
'    get = null;',
'',
'}',
'function clear_response(){',
'    apex.jQuery(''#rest_response_container'').html('' '');',
'}',
'</script>',
''))
,p_javascript_code_onload=>'apex.jQuery("#rest_response").hide();'
,p_inline_css=>'#rest_response_container:empty {display: none;}'
,p_step_template=>wwv_flow_imp.id(19943204431962826)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_web_services.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(259646728667715702)
,p_plug_name=>'REST Web Service Details'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>100
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Use this page to test the reference of a REST Web service. ',
'<p>Modify the URL to the service if it contains any references to session state. Enter a Proxy Override if you wish to use a specific one for the test you initiate on this page. Supply basic authentication credentials if it is required by the Web ser'
||'vice. Enter values for required HTTP headers and Input Parameters and click Test. The response will appear in a scrollable region below the Input Parameters region.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(259650714124715708)
,p_name=>'Input Parameters'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>130
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.display_and_save(1, c.c001) name,',
'       wwv_flow_item.text(2, null, null, null, null, ''input''||seq_id, wwv_flow_lang.system_message(''F4000_P975_VALUE_FOR'',c.c001)) value',
'  from wwv_flow_collections c',
' where collection_name = ''REST_INPUT_PARMS''',
'   and nvl(:P872_INPUT_TYPE,''nvp'') = ''nvp'''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_headings_type=>'QUERY_COLUMNS'
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'There are no input parameters for this service.'
,p_query_row_count_max=>5000
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(259650913301715711)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(259651000339715711)
,p_query_column_id=>2
,p_column_alias=>'VALUE'
,p_column_display_sequence=>2
,p_column_heading=>'Value'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(259651607175715711)
,p_plug_name=>'Response'
,p_region_name=>'rest_respose'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>140
,p_plug_source=>'<div class="a-Form-textarea a-Form-textarea--code" id="rest_response_container" style="white-space: pre-line; max-height: 300px; overflow: auto;"></div>'
,p_translate_title=>'N'
,p_plug_footer=>'</div>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(259651816639715713)
,p_plug_name=>'Basic Authentication'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>125
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P871_BASIC_AUTH'
,p_plug_display_when_cond2=>'Y'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(259653006116715715)
,p_name=>'HTTP Headers'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>127
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.display_and_save(3, c.c001) name,',
'       wwv_flow_item.text(4, null, null, null, null, ''header''||seq_id, wwv_flow_lang.system_message(''F4000_P975_VALUE_FOR'',c.c001)) value',
'  from wwv_flow_collections c',
' where collection_name = ''REST_HTTP_HEADERS'''))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null from wwv_flow_collections c',
' where collection_name = ''REST_HTTP_HEADERS''',
'   and c001 is not null'))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_headings_type=>'QUERY_COLUMNS'
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'There are no input parameters for this service.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(259653213006715715)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(259653326608715715)
,p_query_column_id=>2
,p_column_alias=>'VALUE'
,p_column_display_sequence=>2
,p_column_heading=>'Value'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(754559883128487443)
,p_plug_name=>'REST Web Service Details'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>150
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(259646922211715703)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(754559883128487443)
,p_button_name=>'CLOSE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Close'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:window.close();'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(259647127606715703)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(754559883128487443)
,p_button_name=>'CLEAR'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Clear'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:clear_response();'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(259647329730715704)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(754559883128487443)
,p_button_name=>'TEST'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Test'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:p975_test_rest();'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(259647727867715705)
,p_name=>'P975_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(259646728667715702)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>'P871_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Name of Web service reference.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(259648221853715705)
,p_name=>'P975_URL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(259646728667715702)
,p_use_cache_before_default=>'NO'
,p_prompt=>'URL'
,p_source=>'P871_URL'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The URL endpoint of the Web service.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(259648716285715706)
,p_name=>'P975_PROXY_OVERRIDE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(259646728667715702)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Proxy Override'
,p_source=>'P871_PROXY_OVERRIDE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The proxy to be used in place of the proxy defined at the application level.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(259649208273715706)
,p_name=>'P975_STATIC_PARM_04'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(259646728667715702)
,p_use_cache_before_default=>'NO'
,p_prompt=>'HTTP Method'
,p_source=>'P871_METHOD'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The HTTP method used to make the request to the Web service.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(259650200278715707)
,p_name=>'P975_STATIC_PARM_10'
,p_item_sequence=>135
,p_item_plug_id=>wwv_flow_imp.id(259646728667715702)
,p_use_cache_before_default=>'NO'
,p_item_default=>'nvp'
,p_prompt=>'Input Format'
,p_source=>'P872_INPUT_TYPE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'P872_INPUT_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(48714213128492554)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'The type of input expected by the Web service.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(259651131119715711)
,p_name=>'P975_SOURCE'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(259650714124715708)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Source'
,p_source=>'P872_SOURCE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>5
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_display_when=>'nvl(:P872_INPUT_TYPE,''nvp'') != ''nvp'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the source to use as the input of the Web service.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(259652023086715714)
,p_name=>'P975_USERNAME'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(259651816639715713)
,p_prompt=>'Username'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the username for HTTP Basic Authentication.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(259652526427715714)
,p_name=>'P975_PASSWORD'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(259651816639715713)
,p_prompt=>'Password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter the password for HTTP Basic Authentication.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_00976
begin
wwv_flow_imp_page.create_page(
 p_id=>976
,p_name=>'Manage Backup Lock'
,p_alias=>'MANAGE-BACKUP-LOCK'
,p_page_mode=>'MODAL'
,p_step_title=>'Manage Backup Lock'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(5507013954294272)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(13152956436187503)
,p_plug_name=>'Unlock Info'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P976_LOCKED'
,p_plug_display_when_cond2=>'Y'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Unlocking a backup will allow it to be deleted during daily maintenance. Only the &P976_MAX.  most recent application backups are retained. ',
'Older backups will be deleted to make room for new ones.</p>',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(20720572618631293)
,p_plug_name=>'Lock Info'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P976_LOCKED'
,p_plug_display_when_cond2=>'N'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Lock a backup to keep it from being deleted during daily maintenance.</p>',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(20721044561631297)
,p_plug_name=>'BUTTONS'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(13138965569619171)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(20721044561631297)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(13139354387619171)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(20721044561631297)
,p_button_name=>'LOCK'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Lock Backup'
,p_button_position=>'NEXT'
,p_button_condition=>'P976_LOCKED'
,p_button_condition2=>'N'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(13152732491187501)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(20721044561631297)
,p_button_name=>'UNLOCK'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Unlock Backup'
,p_button_position=>'NEXT'
,p_button_condition=>'P976_LOCKED'
,p_button_condition2=>'Y'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(12525043347219550)
,p_branch_name=>'Refresh Parent Page'
,p_branch_action=>'f?p=&APP_ID.:971:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_IN_CONDITION'
,p_branch_condition=>'LOCK,UNLOCK'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(13137836202619170)
,p_name=>'P976_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(20721044561631297)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(13138223089619170)
,p_name=>'P976_LOCKED'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(20721044561631297)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(13153363997187507)
,p_name=>'P976_MAX'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(20721044561631297)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(13142972226619176)
,p_name=>'Cancel'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(13138965569619171)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(13143332879619177)
,p_event_id=>wwv_flow_imp.id(13142972226619176)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(13143890964619177)
,p_name=>'Toggle New Flow ID'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P976_NEW_FLOW_OPT'
,p_condition_element=>'P976_NEW_FLOW_OPT'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SPECIFY'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(13144223288619178)
,p_event_id=>wwv_flow_imp.id(13143890964619177)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P976_NEW_FLOW_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(13144702178619178)
,p_event_id=>wwv_flow_imp.id(13143890964619177)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P976_NEW_FLOW_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(12524803461219548)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Lock Backup'
,p_process_sql_clob=>'wwv_flow_backup.lock_backup(:P976_ID, :APP_USER);'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(13139354387619171)
,p_internal_uid=>12524803461219548
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(13152876615187502)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Unlock'
,p_process_sql_clob=>'wwv_flow_backup.unlock_backup(:P976_ID);'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(13152732491187501)
,p_internal_uid=>13152876615187502
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(13153266232187506)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'INIT'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'',
'  :P976_MAX := wwv_flow_backup.backup_limit(); ',
'  ',
'  select decode(locked_on, null, ''N'', ''Y'') ',
'  into :P976_LOCKED ',
'  from wwv_flow_backups$ ',
'  where id = :P976_ID;',
'exception',
'when others then ',
'  :P976_LOCKED := ''Y'';',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>13153266232187506
);
end;
/
prompt --application/pages/page_00977
begin
wwv_flow_imp_page.create_page(
 p_id=>977
,p_name=>'Delete Backup'
,p_alias=>'DELETE-BACKUP'
,p_page_mode=>'MODAL'
,p_step_title=>'Delete Backup'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(5507013954294272)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(48923393357919167)
,p_plug_name=>'Confirmation'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Are you sure you want to delete this backup?</p>',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(48923865300919171)
,p_plug_name=>'BUTTONS'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(28203933976287923)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(48923865300919171)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(28204309221287924)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(48923865300919171)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Delete Backup'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(28209953254287955)
,p_branch_name=>'Refresh Parent Page'
,p_branch_action=>'f?p=&APP_ID.:971:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(28204309221287924)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(27600598960736905)
,p_name=>'P977_FLOW_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(48923865300919171)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28205105805287925)
,p_name=>'P977_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(48923865300919171)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(28207562545287951)
,p_name=>'Cancel'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(28203933976287923)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(28208042657287954)
,p_event_id=>wwv_flow_imp.id(28207562545287951)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(28208405819287954)
,p_name=>'Toggle New Flow ID'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P977_NEW_FLOW_OPT'
,p_condition_element=>'P977_NEW_FLOW_OPT'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SPECIFY'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(28208997691287954)
,p_event_id=>wwv_flow_imp.id(28208405819287954)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P977_NEW_FLOW_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(28209461077287955)
,p_event_id=>wwv_flow_imp.id(28208405819287954)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P977_NEW_FLOW_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(27600493201736904)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Backup'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_backup.remove',
'(',
'    p_application_id    => :P977_FLOW_ID, ',
'    p_security_group_id => wwv_flow_security.g_security_group_id, ',
'    p_backup_id         => :P977_ID',
');'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>27600493201736904
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(27600801265736908)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Verify Access'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    i number;',
'begin',
'    -- Because the Manage Backups page uses context sensitive menus, the ID an FLOW_ID items are not protected by a checksum.',
'    -- This query will raise an error if a user attempts to access a backup that he is not authorized to access.',
'    select 1',
'    into i',
'    from wwv_flow_backups$ ',
'    where id = :P977_ID',
'    and application_id = :P977_FLOW_ID',
'    and security_group_id = wwv_flow.get_security_group_id();',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>27600801265736908
);
end;
/
prompt --application/pages/page_00978
begin
wwv_flow_imp_page.create_page(
 p_id=>978
,p_name=>'Remove All Backups'
,p_alias=>'REMOVE-ALL-BACKUPS'
,p_page_mode=>'MODAL'
,p_step_title=>'Remove All Backups'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(5507013954294272)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(78324472039929637)
,p_plug_name=>'Confirmation'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Are you sure you want to delete all backups for Application &P978_FLOW_ID.?</p>',
'<p>This operation is not reversable. Choose Remove All Backups to proceed.</p>',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(78324943982929641)
,p_plug_name=>'BUTTONS'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(29401860173010517)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(78324943982929641)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(29402206780010518)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(78324943982929641)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Remove All Backups'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(29406625170010558)
,p_branch_name=>'Refresh Parent Page'
,p_branch_action=>'f?p=&APP_ID.:971:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(29402206780010518)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(29403077328010522)
,p_name=>'P978_FLOW_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(78324943982929641)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(29405672004010556)
,p_name=>'Cancel'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(29401860173010517)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(29406110541010557)
,p_event_id=>wwv_flow_imp.id(29405672004010556)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(29404273458010552)
,p_name=>'Toggle New Flow ID'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P978_NEW_FLOW_OPT'
,p_condition_element=>'P978_NEW_FLOW_OPT'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SPECIFY'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(29404725299010555)
,p_event_id=>wwv_flow_imp.id(29404273458010552)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P978_NEW_FLOW_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(29405223656010556)
,p_event_id=>wwv_flow_imp.id(29404273458010552)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P978_NEW_FLOW_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(29403449469010550)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Backup'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_backup.remove_all',
'(',
'    p_application_id    => :P978_FLOW_ID, ',
'    p_security_group_id => wwv_flow_security.g_security_group_id',
');'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>29403449469010550
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(29403825347010551)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Verify Access'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    i number;',
'begin',
'    -- Because the Manage Backups page uses context sensitive menus, the ID an FLOW_ID items are not protected by a checksum.',
'    -- This query will raise an error if a user attempts to access a backup that he is not authorized to access.',
'    select 1',
'    into i',
'    from wwv_flow_backups$ ',
'    where application_id = :P978_FLOW_ID',
'    and security_group_id = :flow_security_group_id',
'    and rownum = 1;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>29403825347010551
);
end;
/
prompt --application/pages/page_00979
begin
wwv_flow_imp_page.create_page(
 p_id=>979
,p_name=>'All Backup Details'
,p_alias=>'ALL-BACKUP-DETAILS'
,p_page_mode=>'MODAL'
,p_step_title=>'All Backup Details'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(5507013954294272)
,p_step_template=>wwv_flow_imp.id(120871216744825711)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(489623016951494467)
,p_name=>'Backup Details'
,p_template=>wwv_flow_imp.id(42025417508627628)
,p_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with manifest_summary as (',
'    select wwv_flow_lang.system_message(e.component_type) as component_type,',
'           wwv_flow_lang.system_message(e.action) as action,',
'           e.component_name,',
'           e.last_updated_by, ',
'           to_date(e.last_updated_on, ''YYYYMMDD HH24:MI:SS'') as last_updated_on',
'    from wwv_flow_backups$ j, xmltable(',
'        ''/json/details/row''',
'        passing wwv_flow_json.to_xmltype( j.manifest )',
'        columns',
'            component_type    varchar2(100)   path ''component_type/text()'',',
'            action            varchar2(100)   path ''action/text()'',',
'            component_name    varchar2(1000)  path ''component_name/text()'',',
'            last_updated_by   varchar2(100)   path ''last_updated_by/text()'',',
'            last_updated_on   varchar2(100)   path ''last_updated_on/text()'' ) e',
'    where  j.application_id = :FB_FLOW_ID',
'    and j.security_group_id = wwv_flow.get_security_group_id()',
'    and j.manifest like ''{%''',
')',
'select * from manifest_summary;'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'<p>Application properties have been updated. No other components have been updated.</p>'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(482115364127395639)
,p_query_column_id=>1
,p_column_alias=>'COMPONENT_TYPE'
,p_column_display_sequence=>1
,p_column_heading=>'Component Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(482115728191395640)
,p_query_column_id=>2
,p_column_alias=>'ACTION'
,p_column_display_sequence=>3
,p_column_heading=>'Action'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(482116176773395640)
,p_query_column_id=>3
,p_column_alias=>'COMPONENT_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Component Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(482116566000395640)
,p_query_column_id=>4
,p_column_alias=>'LAST_UPDATED_BY'
,p_column_display_sequence=>4
,p_column_heading=>'Developer'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(482116959440395640)
,p_query_column_id=>5
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>5
,p_column_heading=>'Date'
,p_use_as_row_header=>'N'
,p_column_format=>'&DATE_TIME_FORMAT.'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(489623606942494473)
,p_plug_name=>'BUTTONS'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(482117679369395642)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(489623606942494473)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(482118799477395644)
,p_name=>'Close Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(482117679369395642)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(482119260892395645)
,p_event_id=>wwv_flow_imp.id(482118799477395644)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
);
end;
/
prompt --application/pages/page_01000
begin
wwv_flow_imp_page.create_page(
 p_id=>1000
,p_name=>'Run Page'
,p_alias=>'RUN_PAGE'
,p_step_title=>'Branch To Page'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_pg.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(26658621021615392)
,p_plug_name=>'items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(26648532552401082)
,p_branch_name=>'Branch To Page Identified By Item'
,p_branch_action=>'FB_FLOW_PAGE_ID'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_PAGE_IDENT_BY_ITEM'
,p_branch_sequence=>30
,p_branch_condition_type=>'FUNCTION_BODY'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P1000_DIRECT_BRANCH = ''TRUE'' then',
'  wwv_flow.g_flow_id := :FB_FLOW_ID;',
'  wwv_flow_security.g_curr_flow_security_group_id := null;',
'  return true;',
'else',
'  return false;',
'end if;'))
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(26660119336643241)
,p_branch_name=>'Go To Page &FB_FLOW_PAGE_ID.'
,p_branch_action=>'return wwv_flow_dev.get_run_url ('||wwv_flow.LF||
'           p_application_id => :FB_FLOW_ID,'||wwv_flow.LF||
'           p_page_id        => :FB_FLOW_PAGE_ID,'||wwv_flow.LF||
'           p_debug          => :P1000_DEBUG );'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_FUNCTION_RETURNING_URL'
,p_branch_language=>'PLSQL'
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(26659210201631136)
,p_name=>'P1000_DIRECT_BRANCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(26658621021615392)
,p_display_as=>'NATIVE_HIDDEN'
,p_restricted_characters=>'WEB_SAFE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(310413445435299407)
,p_name=>'P1000_DEBUG'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(26658621021615392)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(26650103378411579)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set flow ID'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1000_DIRECT_BRANCH := ''FALSE'';',
'for c1 in (',
'  select 1 from wwv_flows f, wwv_flow_steps s ',
'  where f.id = s.flow_id',
'  and f.id = :FB_FLOW_ID',
'  and s.id = :FB_FLOW_PAGE_ID ',
'  and s.protection_level = ''D'' ',
'  and f.PAGE_PROTECTION_ENABLED_Y_N = ''Y'') loop',
'  --',
'  :P1000_DIRECT_BRANCH := ''TRUE'';',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>26650103378411579
);
end;
/
prompt --application/pages/page_01100
begin
wwv_flow_imp_page.create_page(
 p_id=>1100
,p_name=>'Report Queries'
,p_alias=>'REPORT-QUERIES'
,p_step_title=>'Report Queries'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(22569212548659511)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_rpt_print.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(48249767190061345)
,p_plug_name=>'Report Queries are not supported.'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'Native printing is configured for this application. A Remote Print Server is required to use Report Queries.'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_print_util.get_print_server( p_flow_id => :FB_FLOW_ID ).server_type = ''NONE'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(62890902382644553)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--sideRegion:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>A report query is a printable document, which can be integrated with an application using buttons, list items, branches or any other navigational components that allow for using URLs as targets.</p>',
'',
'<p>A report query is based on a standard SQL query. ',
'',
'<ul>',
'    <li>When using Oracle BI Publisher as the print server, it can be downloaded as a PDF document, a Word document (RTF based), an Excel Spreadsheet (HTML based) or as an HTML file. The layout of a report query is customizable using RTF or XSL-FO te'
||'mplates.</li>',
'    <li>When using Oracle Document Generator Pre-Built Function as the print server, it can be downloaded as a PDF document.</li>',
'</ul>',
'</p>',
'',
'<p>Note that to use this feature, your application must use a remote print server.</p>',
'',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(188062721932626087)
,p_plug_name=>'Stored Report Queries'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       name,',
'       nvl(last_updated_on,created_on) last_modified,',
'       query_text,',
'       ''icon-sc-reports'' icon_class,',
'       name icon_title,',
'       ''f?p=4000:1116:''||:app_session||'':::1116,1117,1112:P1116_ID:''||id edit_link,',
'       replace(name,''_'','' '') image_text,',
'       ( select count(*)',
'           from wwv_flow_page_da_actions a',
'          where a.flow_id           = q.flow_id',
'            and a.report_query_id   = q.id',
'            and a.security_group_id = q.security_group_id',
'       ) +',
'       ( select count(*)',
'           from wwv_flow_step_processing p',
'          where p.flow_id           = q.flow_id',
'            and p.report_query_id   = q.id',
'            and p.security_group_id = q.security_group_id',
'       ) as ref',
'  from wwv_flow_shared_queries q',
' where flow_id              = :FB_FLOW_ID ',
'   and security_group_id    = :FLOW_SECURITY_GROUP_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(188062805545626087)
,p_name=>'Stored Queries '
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#EDIT_LINK#" class="a-IRR-icon"><span class="a-Icon #ICON_CLASS#"></span><span class="a-IRR-iconName">#ICON_TITLE#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(188063017618626118)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'&nbsp;'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(188063117876626121)
,p_db_column_name=>'NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Query Name'
,p_column_link=>'f?p=&APP_ID.:1116:&SESSION.::&DEBUG.:1116,1117,1112:P1116_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(188063322079626122)
,p_db_column_name=>'QUERY_TEXT'
,p_display_order=>3
,p_column_identifier=>'D'
,p_column_label=>'Query Text'
,p_allow_sorting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_column_type=>'CLOB'
,p_rpt_show_filter_lov=>'N'
,p_display_condition_type=>'NEVER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(188063228925626121)
,p_db_column_name=>'LAST_MODIFIED'
,p_display_order=>4
,p_column_identifier=>'C'
,p_column_label=>'Last Modified'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(188063904045632190)
,p_db_column_name=>'IMAGE_TEXT'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Image Text'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(656845777352609914)
,p_db_column_name=>'ICON_CLASS'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Icon Class'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(656845895582609915)
,p_db_column_name=>'ICON_TITLE'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Icon Title'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(656845917763609915)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Edit Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1716357469892626)
,p_db_column_name=>'REF'
,p_display_order=>21
,p_column_identifier=>'L'
,p_column_label=>'References'
,p_column_link=>'f?p=&APP_ID.:1130:&SESSION.::&DEBUG.:1130,CIR:IR_DISPLAY_NAME:\#NAME#\'
,p_column_linktext=>'#REF#'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(188067100209684276)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1293615907536644'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_view_mode=>'ICON'
,p_report_columns=>'NAME:LAST_MODIFIED:REF:'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(193370709913516416)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(193369209650497455)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Report Queries'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(188995926604107717)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(188062721932626087)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1100:&SESSION.::&DEBUG.:1100,RIR::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(62964404787843921)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(188062721932626087)
,p_button_name=>'COPY'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Copy'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1121:&SESSION.::&DEBUG.:1121::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(11547728103324503)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(188062721932626087)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1105:&SESSION.::&DEBUG.:1105,1110,1112,1113,1114,1115,1116,1117,1118,1119::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(11544726731301615)
,p_branch_action=>'f?p=&APP_ID.:1100:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1837795393910090)
,p_computation_sequence=>30
,p_computation_item=>'F4000_PRINT_SERVER_TYPE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_print_util.get_print_server( p_flow_id => :FB_FLOW_ID ).server_type'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(590044949387250709)
,p_name=>'Create Button - Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(11547728103324503)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(590045284921250710)
,p_event_id=>wwv_flow_imp.id(590044949387250709)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(188062721932626087)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(590045397449252903)
,p_name=>'Copy Button - Dialog Closed'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(62964404787843921)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(590045604333252903)
,p_event_id=>wwv_flow_imp.id(590045397449252903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(188062721932626087)
);
end;
/
prompt --application/pages/page_01105
begin
wwv_flow_imp_page.create_page(
 p_id=>1105
,p_name=>'Create Report Query'
,p_alias=>'CREATE-REPORT-QUERY'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Report Query'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(22569212548659511)
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function toggleItemSelector(includeItems) {',
'    if (includeItems==''APEX'') {',
'        apex.item(''P1110_ITEMS'').show();',
'    } else {',
'        apex.item(''P1110_ITEMS'').hide();',
'    }',
'}'))
,p_javascript_code_onload=>'toggleItemSelector($v(''P1110_XML_STRUCTURE''));'
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'600'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_rpt_print.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(27548095939402128)
,p_plug_name=>'Create Report Query'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_item_display_point=>'BELOW'
,p_plug_header=>'<p>Specify a name for your report query and select the report layout.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(27635681512676590)
,p_plug_name=>'Create Shared Query'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(22638505565903517)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(211246299061418655)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4994953208752181)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(211246299061418655)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4995345831752181)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(211246299061418655)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(5000347193752183)
,p_branch_name=>'Go To Page 1110'
,p_branch_action=>'f?p=&APP_ID.:1110:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(4995345831752181)
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(27674206615806065)
,p_name=>'P1105_NAME'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_imp.id(27548095939402128)
,p_prompt=>'Report Query Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a name to identify the report query. When referencing a report query as a link target, the report query name is part of the request string.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114278340550790488)
,p_name=>'P1105_REPORT_LAYOUT_ID'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_imp.id(27548095939402128)
,p_prompt=>'Report Layout'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REPORT_LAYOUTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id, report_layout_name ',
'  from wwv_flow_report_layouts ',
' where flow_id              = :FB_FLOW_ID ',
'   and security_group_id    = :WORKSPACE_ID',
'   and (    ( :F4000_PRINT_SERVER_TYPE = ''DOCUMENT_GENERATOR'' and report_layout_type = ''DOCX_FILE'' )',
'        or  ( :F4000_PRINT_SERVER_TYPE = ''ADVANCED'' and report_layout_type in (''XSL_GENERIC'', ''RTF_FILE'', ''XSL_FILE'' ) )',
'        or  ( :F4000_PRINT_SERVER_TYPE = ''STANDARD'' and report_layout_type in (''XSL_GENERIC'', ''XSL_FILE'' ) ) )',
'        or  ( :F4000_PRINT_SERVER_TYPE = ''AOP'' and report_layout_type in (''DOCX_FILE'',',
'                                                                          ''XLSX_FILE'',',
'                                                                          ''PPTX_FILE'',',
'                                                                          ''HTML_FILE'',',
'                                                                          ''MARKDOWN_FILE'',',
'                                                                          ''CSV_FILE'',',
'                                                                          ''TXT_FILE'',',
'                                                                          ''ODT_FILE'',',
'                                                                          ''ODS_FILE'',',
'                                                                          ''ODP_FILE'' ) )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Report Layout -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose one of the Report Layouts defined in the application. If you have not yet created a Report Layout, you can specify one later.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4997297920752182)
,p_validation_name=>'P1105_NAME Not Null'
,p_validation_sequence=>2
,p_validation=>'P1105_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Name must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(4995345831752181)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 12-DEC-2006 13:25'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4996844140752182)
,p_validation_name=>'name unique'
,p_validation_sequence=>12
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_shared_queries',
' where name                 = :P1105_NAME',
'   and flow_id              = :fb_flow_id',
'   and security_group_id    = :FLOW_SECURITY_GROUP_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'The name "&P1105_NAME." is already used for an existing report query in this application.'
,p_when_button_pressed=>wwv_flow_imp.id(4995345831752181)
,p_associated_item=>wwv_flow_imp.id(27674206615806065)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4997900409752182)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(4994953208752181)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4998413657752182)
,p_event_id=>wwv_flow_imp.id(4997900409752182)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1720534022642129)
,p_name=>'On switch'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1105_USE_GENERIC_LAYOUT'
,p_condition_element=>'P1105_USE_GENERIC_LAYOUT'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'N'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_display_when_cond=>'F4000_PRINT_SERVER_TYPE'
,p_display_when_cond2=>'DOCUMENT_GENERATOR'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1720673462642130)
,p_event_id=>wwv_flow_imp.id(1720534022642129)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1105_REPORT_LAYOUT_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1720795124642131)
,p_event_id=>wwv_flow_imp.id(1720534022642129)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1105_REPORT_LAYOUT_ID'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4997552106752182)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'reset collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if htmldb_collection.collection_exists(''REPORT_QUERIES'') then',
'  htmldb_collection.delete_collection(''REPORT_QUERIES'');',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P1105_NAME'
,p_process_when_type=>'ITEM_IS_NULL'
,p_internal_uid=>4997552106752182
);
end;
/
prompt --application/pages/page_01110
begin
wwv_flow_imp_page.create_page(
 p_id=>1110
,p_name=>'Create Report Query - Report Query Definition'
,p_alias=>'CREATE-REPORT-QUERY-REPORT-QUERY-DEFINITION'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Report Query'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(22569212548659511)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'600'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_rpt_print.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22559326834649953)
,p_plug_name=>'Create Report Query'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_item_display_point=>'BELOW'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    The name of the report query will be part of the request string in the URL used to download the report query. ',
'    You can include session state of your current application in your report. ',
'    Select this when you want to show additional data with your report. ',
'    For example, you might want to include order header information along with order details in an order form.',
'</p>',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22646912407924415)
,p_plug_name=>'Create Shared Query'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(22638505565903517)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(206257529956666480)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5008267874849911)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(206257529956666480)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:1105:&SESSION.::&DEBUG.:::'
,p_button_condition=>'P1119_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(22559726847649953)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(206257529956666480)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(22560019529649953)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(206257529956666480)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(22560401601649954)
,p_branch_name=>'Go To Page 1119'
,p_branch_action=>'f?p=&APP_ID.:1119:&SESSION.::&DEBUG.::P1119_PREV_PAGE:1110&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(22560019529649953)
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(108841010551095869)
,p_name=>'P1110_OUTPUT_FORMAT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(22559326834649953)
,p_item_default=>'PDF'
,p_prompt=>'Output Format'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PRN_FORMAT'
,p_lov=>'.'||wwv_flow_imp.id(16950902829395371)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Derive from Item'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_read_only_when=>'F4000_PRINT_SERVER_TYPE'
,p_read_only_when2=>'DOCUMENT_GENERATOR'
,p_read_only_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the report output format. Supported formats include PDF, Microsoft Word (RTF format), Microsoft Excel (HTML format), XML and HTML. You can also have the output format specified by an item.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(108842216784097579)
,p_name=>'P1110_FORMAT_ITEM'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(22559326834649953)
,p_prompt=>'Item'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LISTALLITEMS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''CONFIRM.APPLICATION'')||',
''': ''||name a, name b ',
'from wwv_flow_items',
'where flow_id = :FB_FLOW_ID',
'union all',
'select initcap(wwv_flow_lang.system_message(''PAGE''))||',
''': ''||flow_step_id||'': ''||name a, name b',
'',
'from wwv_flow_step_items',
'',
'where flow_id = :FB_FLOW_ID',
'',
'order by 1'))
,p_cSize=>25
,p_cMaxlength=>2000
,p_display_when=>'F4000_PRINT_SERVER_TYPE'
,p_display_when2=>'DOCUMENT_GENERATOR'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Determines the output format at runtime. Select the item that will hold the format value. Valid values are PDF, RTF (to open the document in Microsoft Word), XLS (to open the document in Microsoft Excel) and HTM (to download the document as an HTML f'
||'ile).'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(112563323088659987)
,p_name=>'P1110_ITEMS'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(22559326834649953)
,p_prompt=>'Select Items'
,p_display_as=>'NATIVE_LIST_MANAGER'
,p_named_lov=>'PRINT_ITEMS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name || '' ('' || t || '') '' d,name r from (',
'select name ,  j.t t, null prompt, to_number(NULL) p',
'from wwv_flow_items, (select wwv_flow_lang.system_message(''F4000.APPLICATION_ITEM'') t from dual) j',
'where  flow_id = :fb_flow_id',
'union all',
'select name , j.t t, prompt , flow_step_id p',
'from wwv_flow_step_items, (select wwv_flow_lang.system_message(''F4000.PAGE_ITEM'') t from dual) j',
'where flow_id = :fb_flow_id',
'order by 4 asc nulls first, 1 asc',
')'))
,p_tag_attributes=>'style="width:250px"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the items you wish to reference in your query.  Click the up arrow and select an item from the list. Then click <strong>Add</strong> to move the item to the text box. To remove an item, click it in the text box and then click <strong>Remove</'
||'strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'FIRST_ROWSET'
,p_attribute_02=>'N'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(112574231839719263)
,p_name=>'P1110_INCLUDE_SESSION_STATE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(22559326834649953)
,p_prompt=>'Include Application and Session Information'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enabling the "Session State" option allows you to reference session state values, such as the values of page items, in the output of your report query.',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(137951911350272633)
,p_name=>'P1110_CONTENT_DISPOSITION'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(22559326834649953)
,p_use_cache_before_default=>'NO'
,p_item_default=>'ATTACHMENT'
,p_prompt=>'View File As'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CONTENT_DISPOSITION'
,p_lov=>'.'||wwv_flow_imp.id(137375920403903467)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Using the <strong>View File As</strong> attribute, you can instruct the browser to either display a <strong>file open / save</strong> dialog when clicking on the report query download button, or to display the report query document inside the browser'
||' window. This selection is included in the http header of the document, using the content-disposition attribute.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(590012819421897521)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(22559726847649953)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(590012961505897522)
,p_event_id=>wwv_flow_imp.id(590012819421897521)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(846218045726982728)
,p_name=>'Output Format Changes'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1110_OUTPUT_FORMAT'
,p_condition_element=>'P1110_OUTPUT_FORMAT'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(846218164951982729)
,p_event_id=>wwv_flow_imp.id(846218045726982728)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1110_FORMAT_ITEM'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(846218273749982730)
,p_event_id=>wwv_flow_imp.id(846218045726982728)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1110_FORMAT_ITEM'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4084829211454924)
,p_name=>'On Include Session State'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1110_INCLUDE_SESSION_STATE'
,p_condition_element=>'P1110_INCLUDE_SESSION_STATE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4084991538454925)
,p_event_id=>wwv_flow_imp.id(4084829211454924)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1110_ITEMS'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4085040612454926)
,p_event_id=>wwv_flow_imp.id(4084829211454924)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1110_ITEMS'
);
end;
/
prompt --application/pages/page_01112
begin
wwv_flow_imp_page.create_page(
 p_id=>1112
,p_name=>'Set Bind Values'
,p_alias=>'REPORT-QUERY-SET-BIND-VALUES'
,p_page_mode=>'MODAL'
,p_step_title=>'Set Bind Values'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(22569212548659511)
,p_step_template=>wwv_flow_imp.id(120871216744825711)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_chained=>'N'
,p_help_text=>'bldapp_rpt_print.htm'
,p_page_component_map=>'21'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1720199343642125)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>170
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(115636830645483045)
,p_plug_name=>'Bind Variables'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>150
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select seq_id,',
'       c001 as bind_variable,',
'       c002 as bind_value',
'  from wwv_flow_collections ',
' where collection_name = ''SET_BIND_VALUES'''))
,p_plug_source_type=>'NATIVE_IG'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Bind Variables'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1719448353642118)
,p_name=>'SEQ_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'SEQ_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>30
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1719556884642119)
,p_name=>'BIND_VARIABLE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'BIND_VARIABLE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Bind Variable'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>40
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>false
,p_use_as_row_header=>true
,p_enable_sort_group=>true
,p_enable_control_break=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1719611148642120)
,p_name=>'BIND_VALUE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'BIND_VALUE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Value'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>50
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(1719150223642115)
,p_internal_uid=>1719150223642115
,p_is_editable=>true
,p_edit_operations=>'u'
,p_lost_update_check_type=>'VALUES'
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>false
,p_no_data_found_message=>'No Bind Variables found'
,p_show_toolbar=>false
,p_toolbar_buttons=>null
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>false
,p_define_chart_view=>false
,p_enable_download=>false
,p_download_formats=>null
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(1753045942786709)
,p_interactive_grid_id=>wwv_flow_imp.id(1719150223642115)
,p_static_id=>'17531'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(1753215956786710)
,p_report_id=>wwv_flow_imp.id(1753045942786709)
,p_view_type=>'GRID'
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1753710600786713)
,p_view_id=>wwv_flow_imp.id(1753215956786710)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(1719448353642118)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1754602650786718)
,p_view_id=>wwv_flow_imp.id(1753215956786710)
,p_display_seq=>2
,p_column_id=>wwv_flow_imp.id(1719556884642119)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1755590487786721)
,p_view_id=>wwv_flow_imp.id(1753215956786710)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(1719611148642120)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1720306773642127)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1720199343642125)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Submit'
,p_button_position=>'CREATE'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1719015176642114)
,p_name=>'P1112_SHARED_QUERY_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(115636830645483045)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1719956629642123)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(115636830645483045)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Bind Variables- Save Interactive Grid Data'
,p_attribute_01=>'PLSQL_CODE'
,p_attribute_04=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if :APEX$ROW_STATUS = ''U'' then',
'        wwv_flow_collection.update_member(',
'            p_collection_name => ''SET_BIND_VALUES'',',
'            p_seq             => :SEQ_ID,',
'            p_c001            => :BIND_VARIABLE,',
'            p_c002            => :BIND_VALUE );',
'    end if;',
'end;'))
,p_attribute_05=>'Y'
,p_attribute_06=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>1719956629642123
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1720093948642124)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>1720093948642124
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1718949765642113)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch bind variables'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_bind_values   wwv_flow_global.vc_map;',
'    l_binds         wwv_flow_report_query.t_binds;',
'    l_bind_name     varchar2( 255 );',
'begin',
'',
'    for bind_variable in (',
'        select c001 as name,',
'               c002 as value',
'          from wwv_flow_collections ',
'         where collection_name = ''SET_BIND_VALUES'' )',
'    loop',
'        l_bind_values( bind_variable.name ) := bind_variable.value;',
'    end loop;',
'',
'    l_binds := ',
'        wwv_flow_report_query.get_report_query_binds(',
'            p_shared_query_id   => :P1112_SHARED_QUERY_ID,',
'            p_flow_id           => :FB_FLOW_ID );',
'',
'    wwv_flow_collection.create_or_truncate_collection(',
'        p_collection_name => ''SET_BIND_VALUES'');',
'    ',
'    l_bind_name := l_binds.first;',
'    ',
'    while l_bind_name is not null loop ',
'        ',
'        wwv_flow_collection.add_member(',
'             p_collection_name => ''SET_BIND_VALUES'',',
'             p_c001            => l_bind_name,',
'             p_c002            => case ',
'                                  when l_bind_values.exists( l_bind_name )',
'                                  then l_bind_values( l_bind_name )',
'                                  end);',
'        ',
'        l_bind_name := l_binds.next( l_bind_name );',
'    ',
'    end loop;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>1718949765642113
);
end;
/
prompt --application/pages/page_01114
begin
wwv_flow_imp_page.create_page(
 p_id=>1114
,p_name=>'Create Report Query - Confirm'
,p_alias=>'CREATE-REPORT-QUERY-CONFIRM'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Report Query'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(22569212548659511)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'600'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_rpt_print.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(29654907329843282)
,p_plug_name=>'Create Shared Query'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(22638505565903517)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(29655310507843282)
,p_plug_name=>'Create Shared Query'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_item_display_point=>'BELOW'
,p_plug_header=>'<p>To integrate the document with you application, you can select the report query as the target for buttons or list items or integrate it in other places using the download URL as the target.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(206270919230739081)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(29656009263843283)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(206270919230739081)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(29656429580843284)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(206270919230739081)
,p_button_name=>'FINISH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(29656205789843283)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(206270919230739081)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1115:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(29656614235843284)
,p_name=>'P1114_QUERY_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(29655310507843282)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Query Name'
,p_source=>'P1105_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Selected query.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(41765305345249007)
,p_name=>'P1114_REPORT_LAYOUT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(29655310507843282)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Report Layout'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_name varchar2( 32767 );',
'begin',
'    if :P1105_REPORT_LAYOUT_ID is not null then',
'        select report_layout_name',
'          into l_name',
'          from wwv_flow_report_layouts',
'         where id                   = :P1105_REPORT_LAYOUT_ID',
'           and security_group_id    = :WORKSPACE_ID;',
'    else',
'        l_name := wwv_flow_lang.system_message(''NO_LAYOUT'');',
'    end if;',
'    return l_name;',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Selected report layout.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(41771711017260137)
,p_name=>'P1114_OUTPUT_FORMAT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(29655310507843282)
,p_item_default=>'PDF'
,p_prompt=>'Output Format'
,p_source=>'P1110_OUTPUT_FORMAT'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PRN_FORMAT'
,p_lov=>'.'||wwv_flow_imp.id(16950902829395371)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'The format attribute specifies the download format for the report query. Report queries can be downloaded as PDF documents, Word documents (RTF based), Excel Spreadsheets (HTML based) or as HTML files. To determine the download format at runtime of t'
||'he application, choose "Derive from Page Item".'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(41788801760314194)
,p_name=>'P1114_URL'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(29655310507843282)
,p_use_cache_before_default=>'NO'
,p_prompt=>'URL (To integrate this report, use the URL as target for buttons, list items, etc)'
,p_source=>'''f?p=&''||''APP_ID.:0:&''||''SESSION.:PRINT_REPORT=''||wwv_flow_utilities.escape_url(:P1105_NAME)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>2000
,p_tag_attributes=>'onClick="this.select();"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Report queries can be integrated with an application by using the URL shown as the target for buttons, navigation list entries, list items, or any other type of link. Click into the URL field to copy & paste the URL.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(74681128230118297)
,p_name=>'P1114_FORMAT_ITEM'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(29655310507843282)
,p_prompt=>'Derive from Item'
,p_source=>'P1110_FORMAT_ITEM'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LISTALLITEMS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''CONFIRM.APPLICATION'')||',
''': ''||name a, name b ',
'from wwv_flow_items',
'where flow_id = :FB_FLOW_ID',
'union all',
'select initcap(wwv_flow_lang.system_message(''PAGE''))||',
''': ''||flow_step_id||'': ''||name a, name b',
'',
'from wwv_flow_step_items',
'',
'where flow_id = :FB_FLOW_ID',
'',
'order by 1'))
,p_display_when=>'P1110_FORMAT_ITEM'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'To determine the output format at runtime, specify which page item holds the format information.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(590013543562897528)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(29656009263843283)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(590013617329897529)
,p_event_id=>wwv_flow_imp.id(590013543562897528)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(29656816156843284)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Report Query'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_id    number;',
'begin',
'    ',
'    l_id := wwv_flow_report_query_dev.create_report_query (',
'        p_flow_id                   => :FB_FLOW_ID,',
'        p_report_query_name         => :P1105_NAME, ',
'        p_report_layout_id          => :P1105_REPORT_LAYOUT_ID,',
'        p_output_format             => replace(:P1110_OUTPUT_FORMAT,''%n''||''ull%'',null),',
'        p_format_item               => :P1110_FORMAT_ITEM,',
'        p_file_name                 => :P1105_NAME, ',
'        p_include_session_state     => :P1110_INCLUDE_SESSION_STATE,',
'        p_items                     => :P1110_ITEMS,',
'        p_content_disposition       => :P1110_CONTENT_DISPOSITION );',
'',
'    wwv_flow_report_query_dev.create_sources(',
'        p_collection_name     => ''REPORT_QUERIES'',',
'        p_application_id      => :FB_FLOW_ID,',
'        p_report_query_id     => l_id );',
'        ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to Create Report Query'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(29656429580843284)
,p_process_success_message=>'Report Query Created'
,p_internal_uid=>29656816156843284
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(590013763194897530)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,F4000_LAST_VIEW'
,p_attribute_02=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(29656429580843284)
,p_internal_uid=>590013763194897530
);
end;
/
prompt --application/pages/page_01115
begin
wwv_flow_imp_page.create_page(
 p_id=>1115
,p_name=>'Create Report Query - Download Definition'
,p_alias=>'CREATE-REPORT-QUERY-DOWNLOAD-DEFINITION'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Report Query'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(22569212548659511)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'',
'    function saveBinds(){',
'',
'       var get = new htmldb_Get(null,4000,''SAVE_BINDS'',1111, null, ''wwv_flow.accept'');',
'',
'       if (document.wwv_flow.f01.value) {',
'            get.addParam(''f01'', document.wwv_flow.f01.value);',
'            get.addParam(''f02'', document.wwv_flow.f02.value);',
'',
'       } else {',
'    ',
'            var bindNames  = new Array();',
'            var bindValues = new Array();        ',
'        ',
'            bindNames  = document.wwv_flow.f01;    ',
'            bindValues = document.wwv_flow.f02;    ',
'        ',
'    			     for ( i = 0; i <= bindNames.length-1; i++ ) {',
'                get.addParam(''f01'', bindNames[i].value);',
'                get.addParam(''f02'', bindValues[i].value);',
'	      	    }',
'	      }	    ',
'	      	        ',
'       var x = get.get(''FULL'');',
'    ',
'    }',
'',
'    function testQuery(){',
'        if (document.wwv_flow.f01) {',
'            saveBinds();',
'        }   ',
'        popUp2(''f?p=4000:1120:&SESSION.::&DEBUG.::P1120_QUERY_SOURCE:ITEM'',''800'',''600'');',
'    }    ',
'            ',
'</script>    '))
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'600'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_rpt_print.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(104932408900744298)
,p_plug_name=>'Create Shared Query'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(22638505565903517)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(104937812288761942)
,p_name=>'Source Queries'
,p_template=>wwv_flow_imp.id(42025417508627628)
,p_display_sequence=>170
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c.seq_id, ',
'       c.c001 name,',
'       c.c002 query_source,',
'       c.c003 location',
'  from wwv_flow_collections c',
' where c.collection_name = ''REPORT_QUERIES'''))
,p_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>A report query can contain multiple source queries if you want to combine several different result sets in your report layout. Click the <strong>Add Query</strong> button to add additional source queries. </p>',
''))
,p_footer=>'<br />'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>255
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No Source Query defined.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(104938125631761948)
,p_query_column_id=>1
,p_column_alias=>'SEQ_ID'
,p_column_display_sequence=>21
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2011835269979416)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>11
,p_column_heading=>'Name'
,p_use_as_row_header=>'Y'
,p_column_link=>'f?p=&APP_ID.:1119:&SESSION.::&DEBUG.::P1119_SEQ_ID,P1119_PREV_PAGE:#SEQ_ID#,1115'
,p_column_linktext=>'#NAME#'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2011125709979409)
,p_query_column_id=>3
,p_column_alias=>'QUERY_SOURCE'
,p_column_display_sequence=>51
,p_column_heading=>'Source'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2011294495979410)
,p_query_column_id=>4
,p_column_alias=>'LOCATION'
,p_column_display_sequence=>41
,p_column_heading=>'Location'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(3842073961668883)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(206259627101684610)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>180
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(104933717307744313)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(206259627101684610)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(104934112938744313)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(206259627101684610)
,p_button_name=>'ADD_QUERY'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Add Query'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:1119:&SESSION.::&DEBUG.:1119:P1119_PREV_PAGE:1115'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(104933913371744313)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(206259627101684610)
,p_button_name=>'NEXT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1114:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(105021106869044190)
,p_name=>'P1115_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(104937812288761942)
,p_prompt=>'Report Query Name:'
,p_source=>'P1105_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_help_text=>'When referencing a report query as a link target, the report query name is part of the request string.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(590013398921897526)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(104933717307744313)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(590013437146897527)
,p_event_id=>wwv_flow_imp.id(590013398921897526)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_01116
begin
wwv_flow_imp_page.create_page(
 p_id=>1116
,p_name=>'Edit Report Query'
,p_alias=>'EDIT-REPORT-QUERY'
,p_step_title=>'Edit Report Query'
,p_reload_on_submit=>'A'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(22569212548659511)
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_rpt_print.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(29601743822686179)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(1730363137427210)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46250704400678997)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>70
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(61420914244617042)
,p_plug_name=>'Report Query Attributes'
,p_region_name=>'ATTR'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(61421116921617043)
,p_plug_name=>'Report Query'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(62894422945659915)
,p_plug_name=>'Report Queries'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Report queries are rendered using a custom built RTF layout, if no report layout is selected, a generic report layout is used. Report queries can be downloaded as  PDF documents, Word documents (RTF based), Excel Spreadsheets (HTML based) or as HT'
||'ML files. This download format can be pre-defined on this page, or can be derived at runtime based on an application item. </p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(74700110634292978)
,p_plug_name=>'Session State'
,p_region_name=>'SST'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(114243709381684138)
,p_name=>'Source Queries'
,p_region_name=>'QRY'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       name,',
'       location,',
'       wwv_flow_report_query_dev.get_display_name(',
'            p_location               => location,',
'            -- Local',
'            p_source_type            => query_type,',
'            p_table_name             => query_table,',
'            p_sql_query              => sql_statement,',
'            p_function_body          => sql_statement,',
'            p_graph_name             => query_table,',
'            -- REST data source',
'            p_web_src_module_id      => web_src_module_id,',
'            -- REST enabled SQL',
'            p_remote_source_type     => query_type,',
'            p_remote_sql_query       => sql_statement,',
'            p_remote_table_name      => query_table ) query_source',
'  from wwv_flow_shared_qry_sql_stmts',
' where shared_query_id      = :P1116_ID',
'   and security_group_id    = :FLOW_SECURITY_GROUP_ID',
' order by display_sequence'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>255
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No Source Queries found.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2012754471979425)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>10
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2012489404979422)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>20
,p_column_heading=>'Name'
,p_use_as_row_header=>'Y'
,p_column_link=>'f?p=&APP_ID.:1117:&SESSION.::&DEBUG.:1117:P1117_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2012531678979423)
,p_query_column_id=>3
,p_column_alias=>'LOCATION'
,p_column_display_sequence=>30
,p_column_heading=>'Location'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(3842073961668883)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2012687730979424)
,p_query_column_id=>4
,p_column_alias=>'QUERY_SOURCE'
,p_column_display_sequence=>40
,p_column_heading=>'Source'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(620054021059473578)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(29434107863295859)
,p_plug_display_sequence=>40
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from WWV_FLOW_SHARED_QUERIES',
'where id = :P1116_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :P1116_ID,',
'      p_component_type => ''Application Item'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P1116_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3008928816169719)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(114243709381684138)
,p_button_name=>'P1116_BINDS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Set Bind Values'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:1112:&SESSION.::&DEBUG.::P1112_SHARED_QUERY_ID:&P1116_ID.'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(114308413949865280)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(114243709381684138)
,p_button_name=>'P1116_DOWNLOAD'
,p_button_static_id=>'P1116_DOWNLOAD'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Download'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(146484601467540614)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(114243709381684138)
,p_button_name=>'P1116_TEST_REPORT'
,p_button_static_id=>'P1116_TEST_REPORT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Test Report'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(141909011538546623)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(114243709381684138)
,p_button_name=>'ADD_QUERY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Add Query'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(61422418015617054)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(61421116921617043)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1100:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(61422210232617052)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(61421116921617043)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_confirm_message=>'&APP_TEXT$DELETE_MSG!RAW.'
,p_confirm_style=>'danger'
,p_button_condition=>'P1116_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(61422630926617054)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(61421116921617043)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P1116_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(61425717065617060)
,p_branch_action=>'f?p=&APP_ID.:1100:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(61422630926617054)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(63366930432352758)
,p_branch_action=>'f?p=&APP_ID.:1100:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(61422210232617052)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(136667504014973717)
,p_branch_name=>'Go To Page 1117'
,p_branch_action=>'f?p=&APP_ID.:1117:&SESSION.::&DEBUG.::P1117_SHARED_QUERY_ID:&P1116_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(141909011538546623)
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1772514557352324)
,p_name=>'P1116_REPORT_LAYOUT_TYPE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(61420914244617042)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2220652936674305)
,p_name=>'P1116_STATIC_ID'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(61420914244617042)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Static ID'
,p_source=>'STATIC_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Static ID for this report query. The static ID is used when referencing the report query in API Calls.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4085705260454933)
,p_name=>'P1116_PRINT_SERVER_TYPE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(61420914244617042)
,p_use_cache_before_default=>'NO'
,p_source=>'F4000_PRINT_SERVER_TYPE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(61423216748617054)
,p_name=>'P1116_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(61420914244617042)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(61423411181617055)
,p_name=>'P1116_NAME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(61420914244617042)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Report Query Name'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_tag_attributes=>'onChange="document.getElementById(''P1116_URL'').value=''f?p=&''+''APP_ID.:0:&''+''SESSION.:PRINT_REPORT=''+escape(this.value)"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The report query name identifies the report query. When referencing a report query as a link target, the report query name is part of the request string. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(61423621795617055)
,p_name=>'P1116_QUERY_TEXT'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(61420914244617042)
,p_use_cache_before_default=>'NO'
,p_source=>'QUERY_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(61462132728826639)
,p_name=>'P1116_REPORT_LAYOUT_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(61420914244617042)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Report Layout'
,p_source=>'REPORT_LAYOUT_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REPORT_LAYOUTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id, report_layout_name ',
'  from wwv_flow_report_layouts ',
' where flow_id              = :FB_FLOW_ID ',
'   and security_group_id    = :WORKSPACE_ID',
'   and (    ( :F4000_PRINT_SERVER_TYPE = ''DOCUMENT_GENERATOR'' and report_layout_type = ''DOCX_FILE'' )',
'        or  ( :F4000_PRINT_SERVER_TYPE = ''ADVANCED'' and report_layout_type in (''XSL_GENERIC'', ''RTF_FILE'', ''XSL_FILE'' ) )',
'        or  ( :F4000_PRINT_SERVER_TYPE = ''STANDARD'' and report_layout_type in (''XSL_GENERIC'', ''XSL_FILE'' ) ) )',
'        or  ( :F4000_PRINT_SERVER_TYPE = ''AOP'' and report_layout_type in (''DOCX_FILE'',',
'                                                                          ''XLSX_FILE'',',
'                                                                          ''PPTX_FILE'',',
'                                                                          ''HTML_FILE'',',
'                                                                          ''MARKDOWN_FILE'',',
'                                                                          ''CSV_FILE'',',
'                                                                          ''TXT_FILE'',',
'                                                                          ''ODT_FILE'',',
'                                                                          ''ODS_FILE'',',
'                                                                          ''ODP_FILE'' ) )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Report Layout -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose the report layout you want to use for formatting the report query result. Generic report layouts typically work with any report query. Named Column layouts work only with the report query they were created for or report queries that have a com'
||'patible list of columns.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(61478124351994536)
,p_name=>'P1116_FORMAT'
,p_is_required=>true
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(61420914244617042)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Output Format'
,p_source=>'FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PRN_FORMAT'
,p_lov=>'.'||wwv_flow_imp.id(16950902829395371)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Derive from Item'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the report output format. Supported formats include PDF, Microsoft Word (RTF format), Microsoft Excel (HTML format), and HTML. You can also have the output format specified by an item.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(61484825998014000)
,p_name=>'P1116_FORMAT_ITEM'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(61420914244617042)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Item'
,p_source=>'FORMAT_ITEM'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LISTALLITEMS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''CONFIRM.APPLICATION'')||',
''': ''||name a, name b ',
'from wwv_flow_items',
'where flow_id = :FB_FLOW_ID',
'union all',
'select initcap(wwv_flow_lang.system_message(''PAGE''))||',
''': ''||flow_step_id||'': ''||name a, name b',
'',
'from wwv_flow_step_items',
'',
'where flow_id = :FB_FLOW_ID',
'',
'order by 1'))
,p_cSize=>17
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Determines the output format at runtime. Select the item that will hold the format value. Valid values are PDF, RTF (to open the document in Microsoft Word), XLS (to open the document in Microsoft Excel) and HTM (to download the document as an HTML f'
||'ile).'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(61487309853018711)
,p_name=>'P1116_FILE_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(61420914244617042)
,p_use_cache_before_default=>'NO'
,p_item_default=>':P1116_NAME'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_source=>'OUTPUT_FILE_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(63342015700234973)
,p_name=>'P1116_URL'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(61420914244617042)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Print URL'
,p_source=>'''f?p=&''||''APP_ID.:0:&''||''SESSION.:PRINT_REPORT=''||wwv_flow_utilities.escape_url(:P1116_NAME)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>2000
,p_tag_attributes=>'onClick="this.select();"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Report queries can be integrated with an application by using the URL shown as the target for buttons, navigation list entries, list items, or any other type of link.  Click into the Print URL field to copy and paste the URL.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(74698930242289156)
,p_name=>'P1116_SESSION_STATE_ITEMS'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(74700110634292978)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Select Items'
,p_source=>'SESSION_STATE_ITEMS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_LIST_MANAGER'
,p_named_lov=>'PRINT_ITEMS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name || '' ('' || t || '') '' d,name r from (',
'select name ,  j.t t, null prompt, to_number(NULL) p',
'from wwv_flow_items, (select wwv_flow_lang.system_message(''F4000.APPLICATION_ITEM'') t from dual) j',
'where  flow_id = :fb_flow_id',
'union all',
'select name , j.t t, prompt , flow_step_id p',
'from wwv_flow_step_items, (select wwv_flow_lang.system_message(''F4000.PAGE_ITEM'') t from dual) j',
'where flow_id = :fb_flow_id',
'order by 4 asc nulls first, 1 asc',
')'))
,p_tag_attributes=>'style="width:250px"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Add application and page items to the list of items that should be included with the report query. The actually session state of those items will only be rendered if they are defined in the report layout. The built-in generic layouts do not include a'
||'ny session state. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'FIRST_ROWSET'
,p_attribute_02=>'N'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(75125720206462246)
,p_name=>'P1116_INCLUDE_SESSION_STATE'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(74700110634292978)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Include application and session information'
,p_source=>'INCLUDE_SESSION_STATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Report Queries are processed as XML or JSON files using report layouts for formatting. The data can optionally include application specific information and session state. Use the standard XML Structure for maximum compatibility with RTF templates fro'
||'m BI Publisher and use the advanced XML Structure for including &PRODUCT_NAME. specific data.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114305804252862421)
,p_name=>'P1116_SOURCE_TYPE'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(114243709381684138)
,p_item_default=>'case when :F4000_PRINT_SERVER_TYPE in ( ''DOCUMENT_GENERATOR'', ''AOP'' ) then ''JSON'' else ''XML'' end'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Source for Report Layout'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case  ',
'    when :P1116_PRINT_SERVER_TYPE in (''DOCUMENT_GENERATOR'', ''AOP'') then ''JSON''',
'    else ''XML''',
'end'))
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'REPORT_QUERY_SOURCE_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(112611429059992822)||'.'
,p_tag_attributes=>'class="fielddata"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Select the filetype you want to export your report definition to. Which types are available depends on the type of the report layout.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(115599109220264779)
,p_name=>'P1116_SEQ_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(61420914244617042)
,p_prompt=>'Seq Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(137949312258263470)
,p_name=>'P1116_CONTENT_DISPOSITION'
,p_is_required=>true
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(61420914244617042)
,p_use_cache_before_default=>'NO'
,p_item_default=>'ATTACHMENT'
,p_prompt=>'View File As'
,p_source=>'CONTENT_DISPOSITION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CONTENT_DISPOSITION'
,p_lov=>'.'||wwv_flow_imp.id(137375920403903467)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Using the <strong>View File As</strong> attribute, you can instruct the browser to either display a <strong>file open / save</strong> dialog when clicking on the report query download button, or to display the report query document inside the browser'
||' window. This selection is included in the http header of the document, using the content-disposition attribute.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1772608859352325)
,p_computation_sequence=>10
,p_computation_item=>'P1116_REPORT_LAYOUT_TYPE'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select report_layout_type',
'  from wwv_flow_report_layouts',
' where id                   = :P1116_REPORT_LAYOUT_ID',
'   and security_group_id    = :WORKSPACE_ID'))
,p_compute_when=>'P1116_REPORT_LAYOUT_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(62300016478816112)
,p_computation_sequence=>20
,p_computation_item=>'P1116_FILE_NAME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P1116_NAME'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2221215800674311)
,p_computation_sequence=>30
,p_computation_item=>'P1116_FORMAT'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'PDF'
,p_compute_when=>'P1116_REPORT_LAYOUT_TYPE'
,p_compute_when_text=>'DOCX_FILE'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(61424719356617058)
,p_validation_name=>'P1116_NAME not null'
,p_validation_sequence=>10
,p_validation=>'P1116_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Name must have some value.'
,p_associated_item=>wwv_flow_imp.id(61423411181617055)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1728344887376926)
,p_validation_name=>'Still in use?'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_page_da_actions',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and report_query_id   = :P1116_ID',
'union all',
'select 1',
'  from wwv_flow_step_processing',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and report_query_id   = :P1116_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Report Query is still in use! Use the Utilization link in Tasks to edit this occurrences before you delete the Report Query.'
,p_when_button_pressed=>wwv_flow_imp.id(61422210232617052)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2221422213674313)
,p_validation_name=>'Report layout required'
,p_validation_sequence=>30
,p_validation=>'P1116_REPORT_LAYOUT_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'A Report Layout is required in order to test the Report Query.'
,p_validation_condition=>'P1116_PRINT_SERVER_TYPE'
,p_validation_condition2=>'DOCUMENT_GENERATOR'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(146484601467540614)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(846218310550982731)
,p_name=>'Format Changes'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1116_FORMAT'
,p_condition_element=>'P1116_FORMAT'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(846218474469982732)
,p_event_id=>wwv_flow_imp.id(846218310550982731)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1116_FORMAT_ITEM'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(846218522346982733)
,p_event_id=>wwv_flow_imp.id(846218310550982731)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1116_FORMAT_ITEM'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4085152917454927)
,p_name=>'On Include Session State'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1116_INCLUDE_SESSION_STATE'
,p_condition_element=>'P1116_INCLUDE_SESSION_STATE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4085236339454928)
,p_event_id=>wwv_flow_imp.id(4085152917454927)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1116_SESSION_STATE_ITEMS'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4085307359454929)
,p_event_id=>wwv_flow_imp.id(4085152917454927)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1116_SESSION_STATE_ITEMS'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1772773060352326)
,p_name=>'On Layout Change'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1116_REPORT_LAYOUT_ID'
,p_condition_element=>'P1116_REPORT_LAYOUT_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1772841329352327)
,p_event_id=>wwv_flow_imp.id(1772773060352326)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1116_REPORT_LAYOUT_TYPE'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select report_layout_type',
'  from wwv_flow_report_layouts',
' where id                   = :P1116_REPORT_LAYOUT_ID',
'   and security_group_id    = :WORKSPACE_ID'))
,p_attribute_07=>'P1116_REPORT_LAYOUT_ID'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1773345991352332)
,p_event_id=>wwv_flow_imp.id(1772773060352326)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1116_REPORT_LAYOUT_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'XSL_GENERIC'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_server_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_server_condition_expr1=>'F4000_PRINT_SERVER_TYPE'
,p_server_condition_expr2=>'DOCUMENT_GENERATOR'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4085688542454932)
,p_event_id=>wwv_flow_imp.id(1772773060352326)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1116_REPORT_LAYOUT_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'JSON'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_server_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_server_condition_expr1=>'F4000_PRINT_SERVER_TYPE'
,p_server_condition_expr2=>'DOCUMENT_GENERATOR'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(61425014892617059)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'UPDATE_WWV_FLOW_STORED_QUERIES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_SHARED_QUERIES'
,p_attribute_03=>'P1116_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Unable to process row of table WWV_FLOW_STORED_QUERIES.'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>61425014892617059
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(61522428142194322)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Test Report'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_report_query_dev.test_report (',
'    p_application_id        => :fb_flow_id,',
'    p_report_query_name     => :P1116_NAME,',
'    p_include_session_state => :P1116_INCLUDE_SESSION_STATE = ''Y'',',
'    p_format                => case :P1116_PRINT_SERVER_TYPE ',
'                                    when ''DOCUMENT_GENERATOR'' then ''PDF''',
'                                    else :P1116_FORMAT',
'                                end );'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(146484601467540614)
,p_internal_uid=>61522428142194322
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(62879230114529570)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Download'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_report_query_dev.test_report (',
'    p_application_id        => :fb_flow_id,',
'    p_report_query_name     => :P1116_NAME,',
'    p_include_session_state => :P1116_INCLUDE_SESSION_STATE = ''Y'',',
'    p_format                => :P1116_SOURCE_TYPE );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(114308413949865280)
,p_internal_uid=>62879230114529570
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(61424812868617059)
,p_process_sequence=>60
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_STORED_QUERIES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_SHARED_QUERIES'
,p_attribute_03=>'P1116_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Unable to fetch row.'
,p_internal_uid=>61424812868617059
);
end;
/
prompt --application/pages/page_01117
begin
wwv_flow_imp_page.create_page(
 p_id=>1117
,p_name=>'Report Source'
,p_alias=>'REPORT-SOURCE'
,p_step_title=>'Report Source'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(22569212548659511)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
'    htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'    function downloadXML(){',
'        doSubmit(''DOWNLOAD_XML'');',
'    }       ',
' ',
'    function testReport(){',
'        doSubmit(''TEST_REPORT'');',
'    }   ',
'    ',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_rpt_print.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3607047868896004)
,p_plug_name=>'Settings'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_SHARED_QRY_SQL_STMTS'
,p_include_rowid_column=>false
,p_is_editable=>false
,p_plug_source_type=>'NATIVE_FORM'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4083292619454908)
,p_plug_name=>'Report Source'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_04'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8102323873847846)
,p_plug_name=>'Source'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5512768197119659)
,p_plug_name=>'Local Data Source'
,p_parent_plug_id=>wwv_flow_imp.id(8102323873847846)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3606862734896002)
,p_plug_name=>'Table'
,p_parent_plug_id=>wwv_flow_imp.id(5512768197119659)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>280
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3610146274896035)
,p_plug_name=>'SQL Query'
,p_parent_plug_id=>wwv_flow_imp.id(5512768197119659)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>300
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3610227685896036)
,p_plug_name=>'Function Body Returning SQL'
,p_parent_plug_id=>wwv_flow_imp.id(5512768197119659)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>310
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3610311727896037)
,p_plug_name=>'Graph'
,p_parent_plug_id=>wwv_flow_imp.id(5512768197119659)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>320
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'sys.dbms_db_version.version >= 23'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4033026375134831)
,p_plug_name=>'Optimizer Hint'
,p_parent_plug_id=>wwv_flow_imp.id(5512768197119659)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>340
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5512955324119661)
,p_plug_name=>'REST Data Source'
,p_parent_plug_id=>wwv_flow_imp.id(8102323873847846)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6403047177080356)
,p_plug_name=>'REST Source Details'
,p_parent_plug_id=>wwv_flow_imp.id(5512955324119661)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4031136052134812)
,p_plug_name=>'Where Clause'
,p_parent_plug_id=>wwv_flow_imp.id(6403047177080356)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>190
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4031269389134813)
,p_plug_name=>'SQL Query'
,p_parent_plug_id=>wwv_flow_imp.id(6403047177080356)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>200
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4031391992134814)
,p_plug_name=>'Function Body Returning SQL Query'
,p_parent_plug_id=>wwv_flow_imp.id(6403047177080356)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>210
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6220902957565972)
,p_plug_name=>'REST Source Parameters'
,p_parent_plug_id=>wwv_flow_imp.id(6403047177080356)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select cp.id, ',
'       pa.name,',
'       pa.data_type,',
'       cp.value_type,',
'       cp.value_language,',
'       cp.value,',
'       cp.format_mask',
'  from wwv_flow_web_src_comp_params cp, wwv_flow_web_src_params pa',
' where pa.id                = cp.web_src_param_id',
'   and pa.flow_id           = cp.flow_id',
'   and pa.security_group_id = cp.security_group_id ',
'    -- ',
'   and cp.search_config_id  = :P1117_ID',
'   and cp.security_group_id = :WORKSPACE_ID',
'   and cp.flow_id           = :FB_FLOW_ID',
'   and pa.is_query_param    = ''N'''))
,p_plug_source_type=>'NATIVE_IG'
,p_ajax_items_to_submit=>'P1117_ID'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_web_src_comp_params cp, ',
'       wwv_flow_web_src_params pa',
' where pa.id                = cp.web_src_param_id',
'   and pa.flow_id           = cp.flow_id',
'   and pa.security_group_id = cp.security_group_id',
'    -- ',
'   and cp.security_group_id = :WORKSPACE_ID',
'   and cp.flow_id           = :FB_FLOW_ID',
'   and cp.search_config_id  = :P1117_ID',
'   and pa.is_query_param    = ''N'''))
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'REST Source Parameters'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6221021062565974)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>30
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6221133406565975)
,p_name=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'REST Source Parameter Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>40
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_include_in_export=>true
,p_help_text=>'Identifies the <em>Name</em> of the REST Data Source Parameter.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6221254448565976)
,p_name=>'VALUE_TYPE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'VALUE_TYPE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Value Type'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>60
,p_value_alignment=>'LEFT'
,p_is_required=>true
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(358243382603181986)
,p_lov_display_extra=>false
,p_lov_display_null=>false
,p_enable_filter=>false
,p_filter_is_required=>false
,p_static_id=>'COLUMN_ITEM_FOR_VALUE_TYPE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select how this parameter is populated.</p><p>Available options include:</p>',
'<ul>',
'    <li><strong>Static Value</strong>: Set to the text entered into <em>Static Value</em>.</li>',
'    <li><strong>Item</strong>: Set to the value held in session state for the <em>Item</em> specified.</li>',
'    <li><strong>SQL Query (return single value)</strong>: Set to the first value returned from the <em>SQL Query</em> entered.</li>',
'    <li><strong>PL/SQL Expression</strong>: Set to the value that results from executing the <em>PL/SQL Expression</em> entered.</li>',
'    <li><strong>PL/SQL Function Body</strong>: Set to the value returned from the <em>PL/SQL Function Body</em> entered.</li>',
'    <li><strong>Collection (CLOB)</strong>: Set to the CLOB column value of the first row from the <em>Collection</em> entered.</li>',
'    <li><strong>Preference</strong>: Set to the value of the <em>Preference</em> entered.</li>',
'    <li><strong>Null</strong>: Set to null as no value specified.</li>',
'</ul>',
''))
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6221356413565977)
,p_name=>'VALUE_LANGUAGE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'VALUE_LANGUAGE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>80
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6221449026565978)
,p_name=>'VALUE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'VALUE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Expression'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>90
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
,p_help_text=>'Provide the expression here, based on the <strong>Value Type</strong> column.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6221602686565979)
,p_name=>'APEX$ROW_ACTION'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>20
,p_use_as_row_header=>false
,p_display_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6221680591565980)
,p_name=>'APEX$ROW_SELECTOR'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_use_as_row_header=>false
,p_display_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6487103380005179)
,p_name=>'DATA_TYPE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DATA_TYPE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Parameter Data Type'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>50
,p_value_alignment=>'LEFT'
,p_is_required=>false
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(2225637019805602)
,p_lov_display_extra=>true
,p_lov_display_null=>true
,p_enable_filter=>false
,p_filter_is_required=>false
,p_static_id=>'COLUMN_ITEM_FOR_DATA_TYPE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_include_in_export=>true
,p_readonly_condition_type=>'ALWAYS'
,p_readonly_for_each_row=>false
,p_help_text=>'Data Type of the REST Source Parameter.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6487155854005180)
,p_name=>'FORMAT_MASK'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FORMAT_MASK'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_POPUP_LOV'
,p_heading=>'Format Mask'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>70
,p_value_alignment=>'LEFT'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
,p_is_required=>false
,p_max_length=>255
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(32743907454195192)
,p_lov_display_extra=>true
,p_lov_display_null=>true
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>'Format mask to convert the <strong>Static</strong> or <strong>Item</strong> value to the data type of the REST Source Parameter.'
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(6220918322565973)
,p_internal_uid=>6220918322565973
,p_is_editable=>true
,p_edit_operations=>'u'
,p_lost_update_check_type=>'VALUES'
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>false
,p_no_data_found_message=>'No Parameters defined.'
,p_show_toolbar=>false
,p_toolbar_buttons=>null
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>false
,p_define_chart_view=>false
,p_enable_download=>false
,p_download_formats=>null
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(6324920292350498)
,p_interactive_grid_id=>wwv_flow_imp.id(6220918322565973)
,p_static_id=>'25242'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(6325176770350500)
,p_report_id=>wwv_flow_imp.id(6324920292350498)
,p_view_type=>'GRID'
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5424503204698092)
,p_view_id=>wwv_flow_imp.id(6325176770350500)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(6487103380005179)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5425364147698085)
,p_view_id=>wwv_flow_imp.id(6325176770350500)
,p_display_seq=>7
,p_column_id=>wwv_flow_imp.id(6487155854005180)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(6325624700350513)
,p_view_id=>wwv_flow_imp.id(6325176770350500)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(6221021062565974)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(6326506223350540)
,p_view_id=>wwv_flow_imp.id(6325176770350500)
,p_display_seq=>2
,p_column_id=>wwv_flow_imp.id(6221133406565975)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(6327340288350545)
,p_view_id=>wwv_flow_imp.id(6325176770350500)
,p_display_seq=>4
,p_column_id=>wwv_flow_imp.id(6221254448565976)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(6328248421350550)
,p_view_id=>wwv_flow_imp.id(6325176770350500)
,p_display_seq=>5
,p_column_id=>wwv_flow_imp.id(6221356413565977)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(6329176222350555)
,p_view_id=>wwv_flow_imp.id(6325176770350500)
,p_display_seq=>6
,p_column_id=>wwv_flow_imp.id(6221449026565978)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(6330068926350560)
,p_view_id=>wwv_flow_imp.id(6325176770350500)
,p_display_seq=>0
,p_column_id=>wwv_flow_imp.id(6221602686565979)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5513050872119662)
,p_plug_name=>'Remote Data Source'
,p_parent_plug_id=>wwv_flow_imp.id(8102323873847846)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5809771528765064)
,p_plug_name=>'Remote Data Source Detail'
,p_parent_plug_id=>wwv_flow_imp.id(5513050872119662)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3610497369896038)
,p_plug_name=>'Table'
,p_parent_plug_id=>wwv_flow_imp.id(5809771528765064)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>240
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3610524770896039)
,p_plug_name=>'SQL Query'
,p_parent_plug_id=>wwv_flow_imp.id(5809771528765064)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>260
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3610624517896040)
,p_plug_name=>'Function Body Returning SQL'
,p_parent_plug_id=>wwv_flow_imp.id(5809771528765064)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>270
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8102307663847845)
,p_plug_name=>'Location'
,p_parent_plug_id=>wwv_flow_imp.id(8102323873847846)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(62830324040414239)
,p_plug_name=>'Report Source'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>35
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>A Report Source is based on different data sources of either Local Database, REST Enabled SQL or REST Data Source.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4083340275454909)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(4083292619454908)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4083402565454910)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(4083292619454908)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'CREATE'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4083508555454911)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(4083292619454908)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'CREATE'
,p_button_condition=>'P1117_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4083665174454912)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(4083292619454908)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
,p_button_condition=>'P1117_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(62290306866794393)
,p_branch_name=>'Go To Page 1112'
,p_branch_action=>'f?p=&APP_ID.:1112:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>35
,p_required_patch=>wwv_flow_imp.id(170786031904296885)
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4084484572454920)
,p_branch_name=>'Return to Page'
,p_branch_action=>'f?p=&APP_ID.:1117:&SESSION.::&DEBUG.:1117:P1117_ID:&P1117_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>109
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':REQUEST = ''SAVE'' and :P1117_RETURN_TO_PAGE = ''Y'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(145909220006217307)
,p_branch_name=>'Go To Page 1116'
,p_branch_action=>'f?p=&APP_ID.:1116:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1424293349052741)
,p_name=>'P1117_WEB_SRC_ARRAY_COL_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(5512955324119661)
,p_item_source_plug_id=>wwv_flow_imp.id(3607047868896004)
,p_prompt=>'Array Column'
,p_source=>'WEB_SRC_ARRAY_COL_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select dpc.display_name,',
'       dpc.id',
'  from wwv_flow_web_src_arr_cols_dev dpc',
' where dpc.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and dpc.flow_id           = :FB_FLOW_ID',
'   and dpc.web_src_module_id = :P1117_WEB_SRC_MODULE_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'None'
,p_lov_cascade_parent_items=>'P1119_WEB_SRC_MODULE_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Denotes the Array Column, within the <em>Data Profile</em> of the REST Data Source, to be used for this Report Source.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1718603903642110)
,p_name=>'P1117_DATA_LOOP_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(3607047868896004)
,p_item_source_plug_id=>wwv_flow_imp.id(3607047868896004)
,p_prompt=>'Data Loop Name'
,p_source=>'DATA_LOOP_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'The data loop name is used as name for the rows array of the JSON data. This attribute is only used by the Oracle Document Generator Pre-Built Function print server.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3607210141896006)
,p_name=>'P1117_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3607047868896004)
,p_item_source_plug_id=>wwv_flow_imp.id(3607047868896004)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_protection_level=>'S'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3607310842896007)
,p_name=>'P1117_FLOW_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3607047868896004)
,p_item_source_plug_id=>wwv_flow_imp.id(3607047868896004)
,p_item_default=>'FB_FLOW_ID'
,p_item_default_type=>'ITEM'
,p_source=>'FLOW_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3607439140896008)
,p_name=>'P1117_SHARED_QUERY_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3607047868896004)
,p_item_source_plug_id=>wwv_flow_imp.id(3607047868896004)
,p_source=>'SHARED_QUERY_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3607663027896010)
,p_name=>'P1117_NAME'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(3607047868896004)
,p_item_source_plug_id=>wwv_flow_imp.id(3607047868896004)
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Name of this Report Source.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5005105601231636)
,p_name=>'P1117_RETURN_TO_PAGE'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(62830324040414239)
,p_prompt=>'Stay on Page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5438528119360361)
,p_name=>'P1117_GRAPH_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3610311727896037)
,p_prompt=>'Graph Name'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select g.graph_name d, ',
'       g.graph_name r',
'  from sys.dba_property_graphs    g,',
'       wwv_flow_object_owners_dev o',
' where o.owner = g.owner',
'   and g.owner = (select coalesce( :P1117_QUERY_OWNER, upper(wwv_flow_wizard_api.get_flow_owner(:FB_FLOW_ID)) )',
'                    from sys.dual )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Value -'
,p_lov_cascade_parent_items=>'P1117_QUERY_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Pick the Property Graph from the list.'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5438698162360362)
,p_name=>'P1117_PQL_MATCH_CLAUSE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3610311727896037)
,p_item_source_plug_id=>wwv_flow_imp.id(3607047868896004)
,p_prompt=>'Match Clause'
,p_source=>'QUERY_MATCH'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>3
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a path pattern to find on the property graph. In order to find all edges in your graph, use the following: <strong>(a) - [e] -> (b)</strong>. In addition to this, use <em>label constraints</em> to restrict the types of vertices or edges of i'
||'nterest.</p>',
'<p><strong>Examples</strong></p>',
'<dl>',
'<dt>Find all persons who bought cars.</dt><dd><pre>(p is person) - [t is buys] -> (c is car)</pre></dd>',
'<dt>Find all employees working in departments.</dt><dd><pre>(e is employees) - [is works_at] -> (d is departments)</pre></dd>',
'<dt>Find all employees working in departments who bought cars.</dt><dd><pre>(e is employees) - [is works_at] -> (d is departments), (e is employees) - [t is buys] -> (c is car)</pre></dd>',
'</dl>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5438806878360363)
,p_name=>'P1117_PQL_COLUMNS_CLAUSE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3610311727896037)
,p_item_source_plug_id=>wwv_flow_imp.id(3607047868896004)
,p_prompt=>'Columns Clause'
,p_source=>'QUERY_COLUMNS'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>3
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Define the query return columns. Those are properties of vertices or edges or expressions using them.</p>',
'<p><strong>Example</strong></p>',
'<dl>',
'<dt>Return <strong>NAME</strong>, <strong>BRAND</strong> and <strong>TOTAL_COST</strong> columns, the latter is the <strong>COST</strong> column, multiplied by 100.</dt>',
'<dd><pre>p.name, c.brand, t.cost * 100 as total_cost</pre></dd>',
'</dl>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5438859823360364)
,p_name=>'P1117_PQL_WHERE_CLAUSE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(3610311727896037)
,p_prompt=>'Where Clause'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cHeight=>3
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter an optional WHERE clause to restrict the returned rows. Columns must use a vertex or edge alias.</p>',
'<p><strong>Example</strong></p>',
'<dl>',
'<dt>Only include those employees which have a manager or have a job of salesman.</dt>',
'<dd><pre>( e.mgr is not null or e.job = ''SALESMAN'' )</pre></dd>',
'</dl>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5565633083228153)
,p_name=>'P1117_QUERY_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(5512768197119659)
,p_item_source_plug_id=>wwv_flow_imp.id(3607047868896004)
,p_item_default=>'TABLE'
,p_prompt=>'Source Type'
,p_source=>'QUERY_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXEC_SQL_DATA_SOURCE_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(601107956819795211)||'.'
,p_tag_css_classes=>'apex-button-group is-query'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Specify the source type of the search configuration. A search configuration can be based on a Table, SQL Query, Function Body returning SQL Query, or (on Oracle Database 23ai and later) on a Property Graph.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5566051485228153)
,p_name=>'P1117_QUERY_SQL'
,p_source_data_type=>'CLOB'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3610146274896035)
,p_item_source_plug_id=>wwv_flow_imp.id(3607047868896004)
,p_prompt=>'Enter a SQL SELECT statement'
,p_source=>'SQL_STATEMENT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>60
,p_cMaxlength=>32767
,p_cHeight=>8
,p_tag_css_classes=>'a-Form-textarea--code is-query'
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the SQL Query that will be used as source of the search configuration:',
'<pre>',
'select [col1], [col2], [col3], ...',
'  from ...',
' where ...',
' order by ...',
'</pre>',
'',
'For example:',
'<pre>',
'select empno, ename, job, hiredate, sal',
'  from emp ',
' where deptno = :my_item ',
' order by 1',
'</pre>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5566830588228155)
,p_name=>'P1117_QUERY_OWNER'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3606862734896002)
,p_item_source_plug_id=>wwv_flow_imp.id(3607047868896004)
,p_prompt=>'Table / View Owner'
,p_source=>'QUERY_OWNER'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_SCHEMAS_HAVE_PRIVS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(owner) d, owner v',
'  from wwv_flow_object_owners_dev',
'order by d                   '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Parsing Schema -'
,p_cHeight=>1
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select the owner of the table on which you are basing this search configuration.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5567259230228156)
,p_name=>'P1117_QUERY_TABLE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3606862734896002)
,p_item_source_plug_id=>wwv_flow_imp.id(3607047868896004)
,p_prompt=>'Table / View Name'
,p_source=>'QUERY_TABLE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = coalesce( :P1117_QUERY_OWNER, upper(wwv_flow_wizard_api.get_flow_owner(:FB_FLOW_ID)))'))
,p_lov_cascade_parent_items=>'P1117_QUERY_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>60
,p_cMaxlength=>128
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the table or view that will be used as source of the search configuration.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5567690293228158)
,p_name=>'P1117_QUERY_WHERE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3606862734896002)
,p_item_source_plug_id=>wwv_flow_imp.id(3607047868896004)
,p_prompt=>'Where Clause'
,p_source=>'QUERY_WHERE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>2
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter a valid SQL where condition, used to limit the records retrieved.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5568492123228162)
,p_name=>'P1117_OPTIMIZER_HINT'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(4033026375134831)
,p_item_source_plug_id=>wwv_flow_imp.id(3607047868896004)
,p_prompt=>'Optimizer Hint'
,p_source=>'OPTIMIZER_HINT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the Oracle Optimizer hint which is added to the top-level statement when executing the SQL query. A hint is an instruction to the Optimizer. When writing SQL, you may know information about the data unknown to the Optimizer. Hints enable you'
||' to make decisions normally made by the Optimizer, sometimes causing the Optimizer to select a plan that it sees as higher cost.</p>',
'',
'<p>For example, you might know that a certain index is more selective for certain queries. Based on this information, you might be able to choose a more efficient execution plan than the Optimizer. In such a case, use hints to force the Optimizer to '
||'use the optimal execution plan.</p>',
'',
'<p>Example:</p>',
'<p>When accessing the table <code>employees</code>, try to use the index <code>emp_department_ix</code>:</p>',
'<pre>INDEX (employees emp_department_ix)</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5571592862228179)
,p_name=>'P1117_QUERY_ORDER_BY'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3606862734896002)
,p_item_source_plug_id=>wwv_flow_imp.id(3607047868896004)
,p_prompt=>'Order By Clause'
,p_source=>'QUERY_ORDER_BY'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>255
,p_cHeight=>2
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter a valid SQL ORDER BY expression, used to sort the records retrieved.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5578813873228162)
,p_name=>'P1117_WEB_SRC_MODULE_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(5512955324119661)
,p_item_source_plug_id=>wwv_flow_imp.id(3607047868896004)
,p_prompt=>'REST Data Source'
,p_source=>'WEB_SRC_MODULE_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APP_WEB_SOURCES_FOR_REPORTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_flow_web_src_modules m',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and exists ( select 1 ',
'                  from wwv_flow_web_src_operations',
'                 where web_src_module_id = m.id',
'                   and database_operation = ''FETCH_COLLECTION'' )',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a REST Data Source that will be used as source of the search configuration.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5586716123228173)
,p_name=>'P1117_POST_PROC_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(6403047177080356)
,p_item_source_plug_id=>wwv_flow_imp.id(3607047868896004)
,p_item_default=>'NONE'
,p_prompt=>'Post Processing Type'
,p_source=>'SOURCE_POST_PROCESSING'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXEC_WEB_SOURCE_POST_PROCESSING'
,p_lov=>'.'||wwv_flow_imp.id(601113045750817318)||'.'
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select how to post process the retrieved REST source data in the local database.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5587533464228178)
,p_name=>'P1117_EXTERNAL_FILTER_EXPR'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(6403047177080356)
,p_item_source_plug_id=>wwv_flow_imp.id(3607047868896004)
,p_prompt=>'External Filter'
,p_source=>'EXTERNAL_FILTER_EXPR'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Provide a filter expression to be passed to the external REST service. The expression will be passed to the remote server as-is. The syntax depends on the type of the REST Data Source. For instance, Oracle REST Data Services (ORDS) expects JSON sy'
||'ntax.</p>',
'<dl><dt>Example: For an ORDS REST Service, filter out all records with the "sal" attribute less than 3000.</dt>',
'<dd><pre>',
'{"sal": {"$lt": 3000}}',
'</pre></dd>',
'</dl>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5587915380228179)
,p_name=>'P1117_WEB_SRC_FUNCTION'
,p_item_sequence=>125
,p_item_plug_id=>wwv_flow_imp.id(6403047177080356)
,p_prompt=>'REST Data Source Function'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the name of a PL/SQL function to convert the end user query to filter syntax specific to the REST Source. This is required when the REST Source expects a specific query parameter and a specific query syntax.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5604262178228182)
,p_name=>'P1117_REMOTE_SERVER_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(5513050872119662)
,p_item_source_plug_id=>wwv_flow_imp.id(3607047868896004)
,p_prompt=>'REST Enabled SQL Service'
,p_source=>'REMOTE_SERVER_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REMOTE_SQL_SERVERS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_remote_servers',
' where server_type = ''REMOTE_SQL''',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a REST Enabled SQL service that will be used as source of the search configuration.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5620415000228187)
,p_name=>'P1117_LOCATION'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(8102307663847845)
,p_item_source_plug_id=>wwv_flow_imp.id(3607047868896004)
,p_item_default=>'LOCAL'
,p_prompt=>'Data Source'
,p_source=>'LOCATION'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXEC_LOCATION'
,p_lov=>'.'||wwv_flow_imp.id(3842073961668883)||'.'
,p_tag_css_classes=>'apex-button-group is-query'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    The <em>Data Source</em> type selected when this Search Configuration was created.',
'</p>',
'<ul>',
'    <li><strong>Local Database</strong><br>',
'    Data is sourced from the local database.</li>',
'    <li><strong>REST Enabled SQL Service</strong><br>',
'    Data is sourced from a remote database, where the connection is defined using REST Enabled SQL. To create or maintain REST Enabled SQL references, navigate to Shared Components, REST Enabled SQL.',
'    </li>',
'    <li><strong>REST Data Source</strong><br>',
'    Data is sourced from a RESTful web service defined using REST Data Sources. To create or maintain REST Data Sources, navigate to Shared Components, REST Data Sources.',
'    </li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5825500223765097)
,p_name=>'P1117_OLD_WEB_SRC_MODULE_ID'
,p_item_sequence=>105
,p_item_plug_id=>wwv_flow_imp.id(5512955324119661)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5830748937765103)
,p_name=>'P1117_POST_PROC_FUNC_BODY'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(4031391992134814)
,p_prompt=>'Function Body returning SQL Query'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>60
,p_cMaxlength=>32767
,p_cHeight=>6
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a Function Body, where the SQL query returned transforms the data retrieved from the REST Source. The SQL query returned by the Function Body must select from the #APEX$SOURCE_DATA# pseudo-table and read columns available in the data profile. S'
||'ubquery factoring using the SQL WITH clause is not supported here.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PAGE_ITEM'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_06=>'P1117_POST_PROC_FUNC_LANG'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5856973433765115)
,p_name=>'P1117_REMOTE_FUNC_BODY_LANG'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3610624517896040)
,p_prompt=>'Language'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5857061686765116)
,p_name=>'P1117_REMOTE_FUNC_BODY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3610624517896040)
,p_prompt=>'Enter a Function Body returning a SQL Query'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>60
,p_cMaxlength=>32767
,p_cHeight=>8
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify a function body returning a SQL Query that will be used as source of the search configuration, for example:',
'<pre>',
'return q''~',
'select ename, empno',
'  from emp',
'~'';',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PAGE_ITEM'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_05=>'P1117_REMOTE_SERVER_ID'
,p_attribute_06=>'P1117_REMOTE_FUNC_BODY_LANG'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5865103477765092)
,p_name=>'P1117_OLD_LOCATION'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(8102307663847845)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6405290357080380)
,p_name=>'P1117_QUERY_FUNC_LANG'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3610227685896036)
,p_item_source_plug_id=>wwv_flow_imp.id(3607047868896004)
,p_prompt=>'Language'
,p_source=>'FUNCTION_BODY_LANGUAGE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Select a language that is used to evaluate the entered programming code.'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6405381030080381)
,p_name=>'P1117_QUERY_FUNC_BODY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3610227685896036)
,p_prompt=>'Enter a Function Body returning a SQL Query'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>60
,p_cMaxlength=>8000
,p_cHeight=>8
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify a function body returning a SQL Query that will be used as source of the search configuration, for example:',
'<pre>',
'return q''~',
'select ename, empno',
'  from emp',
'~'';',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PAGE_ITEM'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_06=>'P1117_QUERY_FUNC_LANG'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6422897760080384)
,p_name=>'P1117_POST_PROC_WHERE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(4031136052134812)
,p_prompt=>'Where Clause'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a valid SQL Where condition, used to limit the records retrieved.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6424840066080403)
,p_name=>'P1117_POST_PROC_ORDER_BY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(4031136052134812)
,p_prompt=>'Order By Clause'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>2
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a valid SQL Order By clause, used to sort the records retrieved.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6424889927080404)
,p_name=>'P1117_POST_PROC_SQL'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(4031269389134813)
,p_prompt=>'SQL Query'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>6
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a SQL Query to transform the data retrieved from the REST Data Source. Select from the pseudo-table #APEX$SOURCE_DATA# and specify columns available in the data profile. Subquery factoring using the SQL WITH clause is not supported here.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6424988200080405)
,p_name=>'P1117_POST_PROC_FUNC_LANG'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(4031391992134814)
,p_prompt=>'Language'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6452410155080428)
,p_name=>'P1117_REMOTE_SOURCE_TYPE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(5809771528765064)
,p_item_default=>'TABLE'
,p_prompt=>'Source Type'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXEC_REMOTE_SQL_DATA_SOURCE_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(1766286067212864)||'.'
,p_tag_css_classes=>'apex-button-group is-query'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the source of the REST Enabled SQL Service. REST Enabled SQL Service can be based on tables, SQL queries or PL/SQL functions returning a SQL query. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6452529203080429)
,p_name=>'P1117_REMOTE_SQL'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3610524770896039)
,p_prompt=>'Enter a SQL SELECT statement'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>60
,p_cMaxlength=>32767
,p_cHeight=>8
,p_tag_css_classes=>'a-Form-textarea--code is-query'
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the SQL Query that will be used as source of the search configuration:',
'<pre>',
'select [col1], [col2], [col3], ...',
'  from ...',
' where ...',
' order by ...',
'</pre>',
'',
'For example:',
'<pre>',
'select empno, ename, job, hiredate, sal',
'  from emp ',
' where deptno = :my_item ',
' order by 1',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_05=>'P1117_REMOTE_SERVER_ID'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6452619560080430)
,p_name=>'P1117_REMOTE_TABLE_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3610497369896038)
,p_prompt=>'Table / View Owner'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value d, column_value r',
'  from table( wwv_flow_remote_server_dev.get_available_objects( :P1117_REMOTE_SERVER_ID, ''SCHEMAS''))',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Current Schema'
,p_lov_cascade_parent_items=>'P1117_REMOTE_SERVER_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the owner of the table on which you are basing this search configuration.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6452672674080431)
,p_name=>'P1117_REMOTE_TABLE_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3610497369896038)
,p_prompt=>'Table / View Name'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value d, column_value r',
'  from table( wwv_flow_remote_server_dev.get_available_objects( :P1117_REMOTE_SERVER_ID, ''TABLE'', :P1117_REMOTE_TABLE_OWNER ))',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table or View -'
,p_lov_cascade_parent_items=>'P1117_REMOTE_TABLE_OWNER'
,p_ajax_items_to_submit=>'P1117_REMOTE_SERVER_ID'
,p_ajax_optimize_refresh=>'N'
,p_cSize=>30
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the table or view on which the search configuration will be based.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6452835924080432)
,p_name=>'P1117_REMOTE_WHERE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3610497369896038)
,p_prompt=>'Where Clause'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>2
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a valid SQL where condition, used to limit the records retrieved.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6452867681080433)
,p_name=>'P1117_REMOTE_ORDER_BY'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3610497369896038)
,p_prompt=>'Order By Clause'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>255
,p_cHeight=>2
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Provide an order by expression to be passed to the REST Enabled SQL Service.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(4084249855454918)
,p_computation_sequence=>10
,p_computation_item=>'P1117_OLD_LOCATION'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P1117_LOCATION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(4084331827454919)
,p_computation_sequence=>20
,p_computation_item=>'P1117_OLD_WEB_SRC_MODULE_ID'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P1117_WEB_SRC_MODULE_ID'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2417230202306375)
,p_validation_name=>'P1117_NAME is unique'
,p_validation_sequence=>150
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_shared_qry_sql_stmts',
' where name                 = :P1117_NAME',
'   and shared_query_id      = :P1117_SHARED_QUERY_ID',
'   and security_group_id    = :WORKSPACE_ID',
'   and id                   != :P1117_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#LABEL# must be unique.'
,p_validation_condition=>'CREATE,SAVE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(3607663027896010)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1721026899642134)
,p_validation_name=>'is valid query'
,p_validation_sequence=>160
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- validate_source_query also validates that required items actually contain',
'-- a value (e.g. Table Name for Query Type = TABLE)',
'declare',
'    l_query_type        varchar2( 32767 );',
'    l_query_owner       varchar2( 32767 );',
'    l_query_table       varchar2( 32767 );',
'    l_query_where       varchar2( 32767 );',
'    l_query_sql         varchar2( 32767 );',
'    l_query_order_by    varchar2( 32767 );',
'    l_query_func_body   varchar2( 32767 );',
'    l_query_func_lang   varchar2( 32767 );',
'begin',
'',
'    if :P1117_LOCATION = ''REMOTE'' then',
'        l_query_type        := :P1117_REMOTE_SOURCE_TYPE;',
'        l_query_owner       := :P1117_REMOTE_TABLE_OWNER;',
'        l_query_table       := :P1117_REMOTE_TABLE_NAME;',
'        l_query_where       := :P1117_REMOTE_WHERE;',
'        l_query_order_by    := :P1117_REMOTE_ORDER_BY;',
'        l_query_sql         := :P1117_REMOTE_SQL;',
'        l_query_func_body   := :P1117_REMOTE_FUNC_BODY;',
'        l_query_func_lang   := :P1117_REMOTE_FUNC_BODY_LANG;',
'    else',
'        ',
'        case :P1117_POST_PROC_TYPE ',
'            when ''WHERE_ORDER_BY_CLAUSE'' then',
'                l_query_where       := :P1117_POST_PROC_WHERE;',
'                l_query_order_by    := :P1117_POST_PROC_ORDER_BY;',
'            when ''SQL'' then',
'                l_query_sql         := :P1117_POST_PROC_SQL;',
'            when ''FUNC_BODY_RETURNING_SQL'' then',
'                l_query_func_body   := :P1117_POST_PROC_FUNC_BODY;',
'                l_query_func_lang   := :P1117_POST_PROC_FUNC_LANG;',
'            else',
'                l_query_order_by    := :P1117_QUERY_ORDER_BY;',
'                l_query_where       := case ',
'                                        when :P1117_QUERY_TYPE = ''GRAPH'' ',
'                                        then :P1117_PQL_WHERE_CLAUSE ',
'                                        else :P1117_QUERY_WHERE ',
'                                       end;',
'                l_query_sql         := :P1117_QUERY_SQL;',
'                l_query_func_body   := :P1117_QUERY_FUNC_BODY;',
'                l_query_func_lang   := :P1117_QUERY_FUNC_LANG;',
'        end case;',
'',
'        l_query_type        := :P1117_QUERY_TYPE;',
'        l_query_owner       := :P1117_QUERY_OWNER;',
'        l_query_table       := :P1117_QUERY_TABLE;',
'    end if;',
'',
'    return wwv_flow_exec_dev.validate_query (',
'               p_application_id         => :FB_FLOW_ID,',
'               p_location               => :P1117_LOCATION,',
'               p_remote_server_id       => :P1117_REMOTE_SERVER_ID,',
'               p_web_src_module_id      => :P1117_WEB_SRC_MODULE_ID,',
'               --  ',
'               p_query_type             => l_query_type,',
'               p_table_owner            => l_query_owner,',
'               p_table_name             => l_query_table,',
'               p_where_clause           => l_query_where,',
'               p_match_clause           => :P1117_PQL_MATCH_CLAUSE,',
'               p_columns_clause         => :P1117_PQL_COLUMNS_CLAUSE,',
'               p_order_by_clause        => l_query_order_by,',
'               p_sql_query              => l_query_sql,',
'               p_function_body          => l_query_func_body,',
'               p_function_body_language => l_query_func_lang,',
'               p_optimizer_hint         => :P1117_OPTIMIZER_HINT,',
'               --  ',
'               p_post_processing_type   => :P1117_POST_PROC_TYPE );',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':REQUEST in ( ''CREATE'', ''SAVE'' )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3839378687047183)
,p_tabular_form_region_id=>wwv_flow_imp.id(6220902957565972)
,p_validation_name=>'Web Source Parameters: Validate NON-NULL'
,p_validation_sequence=>170
,p_validation=>'VALUE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#COLUMN_HEADER# must have a value.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST         = ''SAVE'' and ',
':VALUE_TYPE     != ''NULL'' and',
':P1117_LOCATION  = ''WEB_SOURCE'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_exec_cond_for_each_row=>'Y'
,p_associated_column=>'VALUE'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3840167615047184)
,p_tabular_form_region_id=>wwv_flow_imp.id(6220902957565972)
,p_validation_name=>'Web Source Parameters: Validate Code'
,p_validation_sequence=>180
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_web_src_dev.validate_web_src_param_value(',
'           p_application_id => :FB_FLOW_ID,',
'           p_data_type      => :DATA_TYPE,',
'           p_value_type     => :VALUE_TYPE,',
'           p_value_lang     => :VALUE_LANGUAGE,',
'           p_expression     => :VALUE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST        = ''SAVE'' and',
':P1117_LOCATION =  ''WEB_SOURCE'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_exec_cond_for_each_row=>'Y'
,p_associated_column=>'VALUE'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3839736701047184)
,p_tabular_form_region_id=>wwv_flow_imp.id(6220902957565972)
,p_validation_name=>'Web Source Parameters: Validate NULL'
,p_validation_sequence=>190
,p_validation=>':VALUE is NULL'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'The NULL value type cannot have a value.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST        = ''SAVE'' and ',
':VALUE_TYPE     = ''NULL'' and',
':P1117_LOCATION = ''WEB_SOURCE'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_exec_cond_for_each_row=>'Y'
,p_associated_column=>'VALUE'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2875509036311932)
,p_name=>'SOURCE TYPE = SQL'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1117_QUERY_TYPE'
,p_condition_element=>'P1117_QUERY_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SQL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3610746037896041)
,p_event_id=>wwv_flow_imp.id(2875509036311932)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3610146274896035)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4033646950134837)
,p_event_id=>wwv_flow_imp.id(2875509036311932)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(4033026375134831)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3610987822896043)
,p_event_id=>wwv_flow_imp.id(2875509036311932)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3610146274896035)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4033595543134836)
,p_event_id=>wwv_flow_imp.id(2875509036311932)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(4033026375134831)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2876319844313152)
,p_name=>'SOURCE TYPE = TABLE'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1117_QUERY_TYPE'
,p_condition_element=>'P1117_QUERY_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TABLE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3611066360896044)
,p_event_id=>wwv_flow_imp.id(2876319844313152)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3606862734896002)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3611178236896045)
,p_event_id=>wwv_flow_imp.id(2876319844313152)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3606862734896002)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2877195646314728)
,p_name=>'SOURCE TYPE = FUNC_BODY'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1117_QUERY_TYPE'
,p_condition_element=>'P1117_QUERY_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FUNC_BODY_RETURNING_SQL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3611252877896046)
,p_event_id=>wwv_flow_imp.id(2877195646314728)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3610227685896036)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3611356583896047)
,p_event_id=>wwv_flow_imp.id(2877195646314728)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3610227685896036)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2877918841315859)
,p_name=>'SOURCE TYPE = GRAPH'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1117_QUERY_TYPE'
,p_condition_element=>'P1117_QUERY_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'GRAPH'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3611426904896048)
,p_event_id=>wwv_flow_imp.id(2877918841315859)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3610311727896037)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3642138599567001)
,p_event_id=>wwv_flow_imp.id(2877918841315859)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3610311727896037)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2878732453316978)
,p_name=>'Location "LOCAL"'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1117_LOCATION'
,p_condition_element=>'P1117_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'LOCAL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4030591934134806)
,p_event_id=>wwv_flow_imp.id(2878732453316978)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(5512768197119659)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4030613846134807)
,p_event_id=>wwv_flow_imp.id(2878732453316978)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(5512768197119659)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2221100461674310)
,p_event_id=>wwv_flow_imp.id(2878732453316978)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1117_QUERY_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'TABLE'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_client_condition_type=>'NULL'
,p_client_condition_element=>'P1117_QUERY_TYPE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2880064156317894)
,p_name=>'Location "REMOTE"'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1117_LOCATION'
,p_condition_element=>'P1117_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REMOTE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4030736079134808)
,p_event_id=>wwv_flow_imp.id(2880064156317894)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(5513050872119662)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4030889923134809)
,p_event_id=>wwv_flow_imp.id(2880064156317894)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(5513050872119662)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2881357474318759)
,p_name=>'Location "WEB_SRC"'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1117_LOCATION'
,p_condition_element=>'P1117_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'WEB_SOURCE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4030995581134810)
,p_event_id=>wwv_flow_imp.id(2881357474318759)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(5512955324119661)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4031052852134811)
,p_event_id=>wwv_flow_imp.id(2881357474318759)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(5512955324119661)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4083092345454906)
,p_event_id=>wwv_flow_imp.id(2881357474318759)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(5809771528765064)
,p_client_condition_type=>'NULL'
,p_client_condition_element=>'P1117_REMOTE_SERVER_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4034967751134850)
,p_name=>'REMOTE SOURCE TYPE = SQL'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1117_REMOTE_SOURCE_TYPE'
,p_condition_element=>'P1117_REMOTE_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SQL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4082585868454901)
,p_event_id=>wwv_flow_imp.id(4034967751134850)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3610524770896039)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4082689254454902)
,p_event_id=>wwv_flow_imp.id(4034967751134850)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3610524770896039)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3611679348896050)
,p_name=>'REMOTE SOURCE TYPE = TABLE'
,p_event_sequence=>120
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1117_REMOTE_SOURCE_TYPE'
,p_condition_element=>'P1117_REMOTE_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TABLE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4030048327134801)
,p_event_id=>wwv_flow_imp.id(3611679348896050)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3610497369896038)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4030123039134802)
,p_event_id=>wwv_flow_imp.id(3611679348896050)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3610497369896038)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4030271917134803)
,p_name=>'REMOTE SOURCE TYPE = FUNC_BODY'
,p_event_sequence=>130
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1117_REMOTE_SOURCE_TYPE'
,p_condition_element=>'P1117_REMOTE_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FUNC_BODY_RETURNING_SQL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4030333064134804)
,p_event_id=>wwv_flow_imp.id(4030271917134803)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3610624517896040)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4030449647134805)
,p_event_id=>wwv_flow_imp.id(4030271917134803)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3610624517896040)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2884909014321576)
,p_name=>'Remote Server chosen'
,p_event_sequence=>140
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1117_REMOTE_SERVER_ID'
,p_condition_element=>'P1117_REMOTE_SERVER_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2886338198321577)
,p_event_id=>wwv_flow_imp.id(2884909014321576)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1117_REMOTE_SOURCE_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'TABLE'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_server_condition_type=>'ITEM_IS_NULL'
,p_server_condition_expr1=>'P1117_REMOTE_SOURCE_TYPE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4083189160454907)
,p_event_id=>wwv_flow_imp.id(2884909014321576)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(5809771528765064)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2885861744321576)
,p_event_id=>wwv_flow_imp.id(2884909014321576)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(5809771528765064)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4083832234454914)
,p_name=>'REST Data Source chosen'
,p_event_sequence=>150
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1117_WEB_SRC_MODULE_ID'
,p_condition_element=>'P1117_WEB_SRC_MODULE_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4084002770454916)
,p_event_id=>wwv_flow_imp.id(4083832234454914)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(6403047177080356)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4084113484454917)
,p_event_id=>wwv_flow_imp.id(4083832234454914)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(6403047177080356)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4031410396134815)
,p_name=>'POST PROC TYPE = WHERE_ORDER_BY_CLAUSE'
,p_event_sequence=>160
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1117_POST_PROC_TYPE'
,p_condition_element=>'P1117_POST_PROC_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'WHERE_ORDER_BY_CLAUSE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4031580870134816)
,p_event_id=>wwv_flow_imp.id(4031410396134815)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(4031136052134812)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4031668561134817)
,p_event_id=>wwv_flow_imp.id(4031410396134815)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(4031136052134812)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4031789666134818)
,p_name=>'POST PROC TYPE = SQL'
,p_event_sequence=>170
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1117_POST_PROC_TYPE'
,p_condition_element=>'P1117_POST_PROC_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SQL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4031865945134819)
,p_event_id=>wwv_flow_imp.id(4031789666134818)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(4031269389134813)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4031987299134820)
,p_event_id=>wwv_flow_imp.id(4031789666134818)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(4031269389134813)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4032038733134821)
,p_name=>'POST PROC TYPE = FUNC_BODY_RETURNING_SQL'
,p_event_sequence=>180
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1117_POST_PROC_TYPE'
,p_condition_element=>'P1117_POST_PROC_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FUNC_BODY_RETURNING_SQL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4032161355134822)
,p_event_id=>wwv_flow_imp.id(4032038733134821)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(4031391992134814)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4032294986134823)
,p_event_id=>wwv_flow_imp.id(4032038733134821)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(4031391992134814)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1718706923642111)
,p_name=>'On Change Name'
,p_event_sequence=>190
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1117_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1718892940642112)
,p_event_id=>wwv_flow_imp.id(1718706923642111)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Set Static ID'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1117_DATA_LOOP_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>wwv_flow_string.join(wwv_flow_t_varchar2(
'this.triggeringElement.value',
'    .toLowerCase()',
'    .replace( /\W/g, "_" )',
'    .replace( /\_*$/g, "" );'))
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_client_condition_type=>'NULL'
,p_client_condition_element=>'P1117_DATA_LOOP_NAME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1424921496055512)
,p_name=>'Web Source Module is not null'
,p_event_sequence=>200
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1117_WEB_SRC_MODULE_ID'
,p_condition_element=>'P1117_WEB_SRC_MODULE_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1425338223055513)
,p_event_id=>wwv_flow_imp.id(1424921496055512)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1117_WEB_SRC_ARRAY_COL_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1425870567055513)
,p_event_id=>wwv_flow_imp.id(1424921496055512)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1117_WEB_SRC_ARRAY_COL_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1426387336055513)
,p_event_id=>wwv_flow_imp.id(1424921496055512)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1117_WEB_SRC_ARRAY_COL_ID'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4083774204454913)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(3607047868896004)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Save form Report Source'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>4083774204454913
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3840868383047185)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(6220902957565972)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set REST Source Parameters - VALUE_LANGUAGE'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    -- Web Source Parameters should always be handled as PL/SQL,',
'    -- in an IG it''s to complicated having a dynamic languages column',
'    if :VALUE_TYPE in ( ''FUNCTION_BODY'', ''EXPRESSION'' ) then',
'        :VALUE_LANGUAGE := ''PLSQL'';',
'    else',
'        :VALUE_LANGUAGE := null;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1799745296181261)
,p_internal_uid=>3840868383047185
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3840445930047184)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(6220902957565972)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'REST Source Parameters - Save Interactive Grid Data'
,p_attribute_01=>'TABLE'
,p_attribute_03=>'WWV_FLOW_WEB_SRC_COMP_PARAMS'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1799745296181261)
,p_internal_uid=>3840445930047184
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3404822692379540)
,p_process_sequence=>10
,p_process_point=>'BEFORE_BOX_BODY'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Distribute Items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'',
'    if :P1117_LOCATION = ''REMOTE'' then',
'        :P1117_REMOTE_TABLE_OWNER      := :P1117_QUERY_OWNER;',
'        :P1117_REMOTE_TABLE_NAME       := :P1117_QUERY_TABLE;',
'        :P1117_REMOTE_SOURCE_TYPE      := :P1117_QUERY_TYPE;',
'        :P1117_REMOTE_WHERE            := :P1117_QUERY_WHERE;',
'        :P1117_REMOTE_ORDER_BY         := :P1117_QUERY_ORDER_BY;',
'',
'        case :P1117_REMOTE_SOURCE_TYPE',
'            when ''SQL''                     then :P1117_REMOTE_SQL := :P1117_QUERY_SQL;',
'            when ''FUNC_BODY_RETURNING_SQL'' then',
'                :P1117_REMOTE_FUNC_BODY      := :P1117_QUERY_SQL; ',
'                :P1117_REMOTE_FUNC_BODY_LANG := :P1117_QUERY_FUNC_LANG;',
'            else null;',
'        end case;',
'        -- :P1117_REMOTE_INCLUDE_ROWID   := :P1117_INCLUDE_ROWID_COLUMN;',
'        :P1117_QUERY_SQL        := null;',
'        :P1117_QUERY_TABLE      := null;',
'        :P1117_QUERY_OWNER      := null;',
'        :P1117_QUERY_WHERE      := null;',
'        :P1117_QUERY_ORDER_BY   := null;',
'        :P1117_QUERY_TYPE       := null;',
'        ',
'    elsif :P1117_LOCATION = ''LOCAL'' then',
'        case :P1117_QUERY_TYPE',
'            when ''FUNC_BODY_RETURNING_SQL'' then :P1117_QUERY_FUNC_BODY  := :P1117_QUERY_SQL;',
'            when ''GRAPH''                   then :P1117_GRAPH_NAME       := :P1117_QUERY_TABLE;',
'                                                :P1117_PQL_WHERE_CLAUSE := :P1117_QUERY_WHERE;',
'            else null;',
'        end case;',
'        ',
'    elsif :P1117_LOCATION = ''WEB_SOURCE'' then',
'        if :P1117_POST_PROC_TYPE = ''WHERE_ORDER_BY_CLAUSE'' then',
'            :P1117_POST_PROC_WHERE          := :P1117_QUERY_WHERE;',
'            :P1117_POST_PROC_ORDER_BY       := :P1117_QUERY_ORDER_BY;',
'        elsif :P1117_POST_PROC_TYPE = ''SQL'' then',
'            :P1117_POST_PROC_SQL            := :P1117_QUERY_SQL;',
'        elsif :P1117_POST_PROC_TYPE = ''FUNC_BODY_RETURNING_SQL'' then',
'            :P1117_POST_PROC_FUNC_LANG      := :P1117_QUERY_FUNC_LANG;',
'            :P1117_POST_PROC_FUNC_BODY      := :P1117_QUERY_SQL;',
'        end if;',
'',
'        :P1117_POST_PROC_TYPE := coalesce( :P1117_POST_PROC_TYPE, ''NONE'' );',
'',
'        :P1117_QUERY_SQL        := null;',
'        :P1117_QUERY_TABLE      := null;',
'        :P1117_QUERY_OWNER      := null;',
'        :P1117_QUERY_WHERE      := null;',
'        :P1117_QUERY_ORDER_BY   := null;',
'        :P1117_QUERY_TYPE       := null;',
'    end if;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>3404822692379540
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3607165025896005)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(3607047868896004)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Report Source'
,p_internal_uid=>3607165025896005
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4401248646857651)
,p_process_sequence=>70
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Consolidate Item Values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    procedure clear_web_source is',
'    begin',
'        :P1117_EXTERNAL_FILTER_EXPR := null;',
'        :P1117_WEB_SRC_FUNCTION     := null;',
'        :P1117_POST_PROC_TYPE       := null;',
'        :P1117_WEB_SRC_MODULE_ID    := null;',
'    end clear_web_source;',
'',
'    procedure clear_unused_query_params is',
'    begin',
'        if :P1117_QUERY_TYPE  = ''TABLE'' then',
'            :P1117_QUERY_SQL          := null;',
'            :P1117_QUERY_FUNC_LANG    := null;',
'            :P1117_OPTIMIZER_HINT     := null;',
'            :P1117_PQL_COLUMNS_CLAUSE := null;',
'            :P1117_PQL_MATCH_CLAUSE   := null;',
'',
'        elsif :P1117_QUERY_TYPE = ''GRAPH'' then',
'            :P1117_QUERY_SQL          := null;',
'            :P1117_QUERY_FUNC_LANG    := null;',
'            :P1117_OPTIMIZER_HINT     := null;',
'        else',
'            :P1117_QUERY_TABLE        := null;',
'            :P1117_QUERY_OWNER        := null;',
'            :P1117_QUERY_WHERE        := null;',
'            :P1117_QUERY_ORDER_BY     := null;',
'            :P1117_PQL_COLUMNS_CLAUSE := null;',
'            :P1117_PQL_MATCH_CLAUSE   := null;',
'',
'            if :P1117_QUERY_TYPE = ''SQL'' then ',
'                :P1117_QUERY_FUNC_LANG := null; ',
'            end if;',
'        end if;',
'',
'    end clear_unused_query_params;',
'',
'    procedure clear_remote_source is',
'    begin',
'        :P1117_REMOTE_SERVER_ID    := null;',
'    end clear_remote_source;',
'begin',
'    ',
'    if :P1117_LOCATION = ''LOCAL'' then',
'    ',
'        :P1117_QUERY_TYPE      := coalesce( :P1117_QUERY_TYPE, ''TABLE'' );',
'        :P1117_QUERY_SQL       := case :P1117_QUERY_TYPE',
'                                      when ''SQL''                     then :P1117_QUERY_SQL',
'                                      when ''FUNC_BODY_RETURNING_SQL'' then :P1117_QUERY_FUNC_BODY ',
'                                  end;',
'        :P1117_QUERY_FUNC_LANG := case ',
'                                      when :P1117_QUERY_TYPE = ''FUNC_BODY_RETURNING_SQL'' then :P1117_QUERY_FUNC_LANG ',
'                                  end;',
'',
'        if :P1117_QUERY_TYPE = ''GRAPH'' then',
'            :P1117_QUERY_TABLE     := :P1117_GRAPH_NAME;',
'            :P1117_QUERY_WHERE     := :P1117_PQL_WHERE_CLAUSE;',
'        end if;',
'',
'        clear_unused_query_params;',
'        clear_remote_source;',
'        clear_web_source;',
'',
'    elsif :P1117_LOCATION = ''REMOTE'' then',
'',
'        :P1117_REMOTE_SOURCE_TYPE := coalesce( :P1117_REMOTE_SOURCE_TYPE, ''TABLE'' );',
'        --',
'        :P1117_QUERY_TYPE          := :P1117_REMOTE_SOURCE_TYPE;',
'        :P1117_QUERY_ORDER_BY      := :P1117_REMOTE_ORDER_BY;',
'        ',
'        if :P1117_REMOTE_SOURCE_TYPE = ''TABLE'' then',
'            :P1117_QUERY_OWNER     := :P1117_REMOTE_TABLE_OWNER;',
'            :P1117_QUERY_TABLE     := :P1117_REMOTE_TABLE_NAME;',
'            :P1117_QUERY_WHERE     := :P1117_REMOTE_WHERE;',
'        else',
'            :P1117_QUERY_SQL       := case :P1117_REMOTE_SOURCE_TYPE',
'                                          when ''SQL''                     then :P1117_REMOTE_SQL',
'                                          when ''FUNC_BODY_RETURNING_SQL'' then :P1117_REMOTE_FUNC_BODY ',
'                                      end;',
'            :P1117_QUERY_FUNC_LANG := case ',
'                                          when :P1117_REMOTE_SOURCE_TYPE = ''FUNC_BODY_RETURNING_SQL'' then :P1117_REMOTE_FUNC_BODY_LANG ',
'                                      end;',
'        end if;',
'',
'        clear_unused_query_params;',
'        clear_web_source;',
'            ',
'    elsif :P1117_LOCATION = ''WEB_SOURCE'' then',
'',
'        if :P1117_OLD_WEB_SRC_MODULE_ID = :P1117_WEB_SRC_MODULE_ID then',
'            if :P1117_POST_PROC_TYPE = ''WHERE_ORDER_BY_CLAUSE'' then',
'                :P1117_QUERY_WHERE     := :P1117_POST_PROC_WHERE;',
'                :P1117_QUERY_ORDER_BY  := :P1117_POST_PROC_ORDER_BY;',
'                :P1117_QUERY_FUNC_LANG := null;',
'            elsif :P1117_POST_PROC_TYPE = ''SQL'' then',
'                :P1117_QUERY_SQL       := :P1117_POST_PROC_SQL;',
'                :P1117_QUERY_FUNC_LANG := null;',
'            elsif :P1117_POST_PROC_TYPE = ''FUNC_BODY_RETURNING_SQL'' then',
'                :P1117_QUERY_SQL       := :P1117_POST_PROC_FUNC_BODY;',
'                :P1117_QUERY_FUNC_LANG := :P1117_POST_PROC_FUNC_LANG;',
'            end if;',
'        else',
'             :P1117_POST_PROC_TYPE  := null;',
'             :P1117_QUERY_FUNC_LANG := null;',
'        end if;',
'        ',
'        :P1117_POST_PROC_TYPE := nullif ( :P1117_POST_PROC_TYPE, ''NONE'' );',
'        :P1117_QUERY_TYPE := null;',
'        clear_remote_source;',
'       ',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>4401248646857651
);
end;
/
prompt --application/pages/page_01119
begin
wwv_flow_imp_page.create_page(
 p_id=>1119
,p_name=>'Create Report Query - Source Queries'
,p_alias=>'CREATE-REPORT-QUERY-SOURCE-QUERIES1'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Report Query'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(22569212548659511)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'600'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_rpt_print.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(104950908448856922)
,p_plug_name=>'Create Shared Query'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(22638505565903517)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(157916288664345637)
,p_plug_name=>'Create '
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>60
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(66803713582240263)
,p_plug_name=>'Create for local data source'
,p_parent_plug_id=>wwv_flow_imp.id(157916288664345637)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(66803798996240264)
,p_plug_name=>'Create Report Query on REST Data Source'
,p_parent_plug_id=>wwv_flow_imp.id(157916288664345637)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(68594453426848191)
,p_plug_name=>'Create Report Query on Remote SQL'
,p_parent_plug_id=>wwv_flow_imp.id(157916288664345637)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(206258323161673966)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(104951832307856926)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(206258323161673966)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(107941612855695604)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(206258323161673966)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_condition=>'P1119_SEQ_ID'
,p_button_condition_type=>'ITEM_NOT_NULL_OR_ZERO'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(104952004592856926)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(206258323161673966)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_button_condition=>'P1119_SEQ_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(107729406464757103)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(206258323161673966)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>'P1119_SEQ_ID'
,p_button_condition2=>'0'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(105070420262189947)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(206258323161673966)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P1119_SEQ_ID'
,p_button_condition_type=>'ITEM_NOT_NULL_OR_ZERO'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(104967212953885063)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(206258323161673966)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&P1119_PREV_PAGE.:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(107729732682757111)
,p_branch_name=>'Go To Page 1115'
,p_branch_action=>'f?p=&APP_ID.:1115:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1419638242009122)
,p_name=>'P1119_WEB_SRC_ARRAY_COL_ID'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(66803798996240264)
,p_prompt=>'Array Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select dpc.display_name,',
'       dpc.id',
'  from wwv_flow_web_src_arr_cols_dev dpc',
' where dpc.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and dpc.flow_id           = :FB_FLOW_ID',
'   and dpc.web_src_module_id = :P1119_WEB_SRC_MODULE_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'None'
,p_lov_cascade_parent_items=>'P1119_WEB_SRC_MODULE_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Denotes the Array Column, within the <em>Data Profile</em> of the REST Data Source, to be used for this Report Source.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2011618274979414)
,p_name=>'P1119_PREV_PAGE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(157916288664345637)
,p_item_default=>'1110'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3997261860182130)
,p_name=>'P1119_GRAPH_NAME'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(66803713582240263)
,p_prompt=>'Graph Name'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select g.graph_name d, ',
'       g.graph_name r',
'  from sys.dba_property_graphs        g,',
'       wwv_flow_object_owners_dev o',
' where o.owner = g.owner',
'   and g.owner = :P1119_TABLE_OWNER'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_lov_cascade_parent_items=>'P1119_TABLE_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_display_when=>'sys.dbms_db_version.version >= 23'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the Property Graph on which the Report Query will be based.'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3997364018182131)
,p_name=>'P1119_PQL_MATCH_CLAUSE'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(66803713582240263)
,p_prompt=>'Match Clause'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cHeight=>2
,p_display_when=>'sys.dbms_db_version.version >= 23'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a path pattern to find on the property graph. In order to find all edges in your graph, use the following: <strong>(a) - [e] -> (b)</strong>. In addition to this, use <em>label constraints</em> to restrict the types of vertices or edges of i'
||'nterest.</p>',
'<p><strong>Examples</strong></p>',
'<dl>',
'<dt>Find all persons who bought cars.</dt><dd><pre>(p is person) - [t is buys] -> (c is car)</pre></dd>',
'<dt>Find all employees working in departments.</dt><dd><pre>(e is employees) - [is works_at] -> (d is departments)</pre></dd>',
'<dt>Find all employees working in departments who bought cars.</dt><dd><pre>(e is employees) - [is works_at] -> (d is departments), (e is employees) - [t is buys] -> (c is car)</pre></dd>',
'</dl>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3997456868182132)
,p_name=>'P1119_PQL_COLUMNS_CLAUSE'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(66803713582240263)
,p_prompt=>'Columns Clause'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cHeight=>2
,p_display_when=>'sys.dbms_db_version.version >= 23'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Define the query return columns. Those are properties of vertices or edges or expressions using them.</p>',
'<p><strong>Example</strong></p>',
'<dl>',
'<dt>Return <strong>NAME</strong>, <strong>BRAND</strong> and <strong>TOTAL_COST</strong> columns, the latter is the <strong>COST</strong> column, multiplied by 100.</dt>',
'<dd><pre>p.name, c.brand, t.cost * 100 as total_cost</pre></dd>',
'</dl>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4025284336763399)
,p_name=>'P1119_FUNC_BODY_LANG'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(66803713582240263)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Language'
,p_source=>'SHORTCUT_LANGUAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select a language that is used to evaluate the entered programming code.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4118954243195701)
,p_name=>'P1119_NAME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(157916288664345637)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_count     number;',
'begin',
'',
'    select count(*)',
'      into l_count',
'      from wwv_flow_collections',
'     where collection_name = ''REPORT_QUERIES'';',
'',
'    return',
'        case l_count ',
'            when 0 then :P1105_NAME',
'            else null',
'        end;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(25534117966448344)
,p_name=>'P1119_FUNC_BODY'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(66803713582240263)
,p_prompt=>'Enter a Function Body returning a SQL query'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>6
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the SQL query that will produce the results for your Report Query, for example:',
'<pre>',
'return q''~',
'select ename, empno',
'  from emp',
'~'';',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PAGE_ITEM'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_06=>'P1119_FUNC_BODY_LANG'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(65028830998292689)
,p_name=>'P1119_LOCATION'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(157916288664345637)
,p_item_default=>'LOCAL'
,p_prompt=>'Data Source'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXEC_LOCATION'
,p_lov=>'.'||wwv_flow_imp.id(3842073961668883)||'.'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    This picks the <em>Data Source</em> type for the new Report Query.',
'</p>',
'<ul>',
'    <li><strong>Local Database</strong><br>',
'    Data is sourced from the local database.</li>',
'    <li><strong>REST Enabled SQL Service</strong><br>',
'    Data is sourced from a remote database, where the connection is defined using REST Enabled SQL. To create or maintain REST Enabled SQL references, navigate to Shared Components, REST Enabled SQL.',
'    </li>',
'    <li><strong>REST Data Source</strong><br>',
'    Data is sourced from a RESTful web service defined using REST Data Sources. REST Data Sources are created or maintained in Shared Components.',
'    </li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(65031630361292705)
,p_name=>'P1119_SOURCE_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(66803713582240263)
,p_item_default=>'TABLE'
,p_prompt=>'Source Type'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXEC_SQL_DATA_SOURCE_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(601107956819795211)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Report Query using a Data Source of Local Database ',
'can be based on a Table, SQL Query, PL/SQL Function Returning SQL, or (on Oracle Database 23ai and later) on a Property Graph.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(65032851472292706)
,p_name=>'P1119_TABLE_OWNER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(66803713582240263)
,p_prompt=>'Table / View Owner'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_SCHEMAS_HAVE_PRIVS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(owner) d, owner v',
'  from wwv_flow_object_owners_dev',
'order by d                   '))
,p_lov_cascade_parent_items=>'P1119_SOURCE_TYPE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the owner of the table on which you are building a Report Query.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(65033783132292708)
,p_name=>'P1119_TABLE_NAME'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(66803713582240263)
,p_prompt=>'Table / View Name'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = :P1119_TABLE_OWNER',
'   and :P1119_SOURCE_TYPE = ''TABLE'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Value -'
,p_lov_cascade_parent_items=>'P1119_TABLE_OWNER,P1119_SOURCE_TYPE'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the table or view on which the Report Query will be based.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(65036939225292711)
,p_name=>'P1119_SQL'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(66803713582240263)
,p_prompt=>'Enter a SQL SELECT statement'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>6
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a SQL statement to define the report query. You can enter the statement directly or click <strong>Query</strong> to build a SQL statement by clicking and pointing. To reference application and page items, reference them as bind variables.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(65051483704292747)
,p_name=>'P1119_WEB_SRC_MODULE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(66803798996240264)
,p_prompt=>'REST Data Source'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APP_WEB_SOURCES_FOR_REPORTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_flow_web_src_modules m',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and exists ( select 1 ',
'                  from wwv_flow_web_src_operations',
'                 where web_src_module_id = m.id',
'                   and database_operation = ''FETCH_COLLECTION'' )',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the REST Data Source which supports fetching a collection.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(65054338814292749)
,p_name=>'P1119_REMOTE_SERVER_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(68594453426848191)
,p_prompt=>'REST Enabled SQL Service'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REMOTE_SQL_SERVERS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_remote_servers',
' where server_type = ''REMOTE_SQL''',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the remote database server.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(65054709828292749)
,p_name=>'P1119_REMOTE_SOURCE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(68594453426848191)
,p_item_default=>'TABLE'
,p_prompt=>'Source Type'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Table;TABLE,SQL Query;SQL'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Specify the source of the data for the Report Query. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(65055596597292750)
,p_name=>'P1119_REMOTE_SQL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(68594453426848191)
,p_prompt=>'Enter a SQL SELECT statement'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>6
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the SQL query that will produce the results for your Report Query, for example:',
'<pre>',
'select ename, empno',
'  from emp',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_05=>'P1119_REMOTE_SERVER_ID'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(65056527854292751)
,p_name=>'P1119_REMOTE_TABLE_OWNER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(68594453426848191)
,p_prompt=>'Table / View Owner'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value d, column_value r',
'  from table( wwv_flow_remote_server_dev.get_available_objects( :P1119_REMOTE_SERVER_ID, ''SCHEMAS''))',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Current Schema'
,p_lov_cascade_parent_items=>'P1119_REMOTE_SERVER_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the owner of the table on which you are building a Report Query.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(65057403564292751)
,p_name=>'P1119_REMOTE_TABLE_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(68594453426848191)
,p_prompt=>'Table / View Name'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value d, column_value r',
'  from table( wwv_flow_remote_server_dev.get_available_objects( :P1119_REMOTE_SERVER_ID, ''TABLE'', :P1119_REMOTE_TABLE_OWNER ))',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table or View -'
,p_lov_cascade_parent_items=>'P1119_REMOTE_TABLE_OWNER'
,p_ajax_items_to_submit=>'P1119_REMOTE_SERVER_ID'
,p_ajax_optimize_refresh=>'N'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the table or view on which the Report Query will be based.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(105037026355106518)
,p_name=>'P1119_SEQ_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(157916288664345637)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2375584114308071)
,p_validation_name=>'SQL Not Null'
,p_validation_sequence=>40
,p_validation=>'P1119_SQL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'SQL must be specified.'
,p_validation_condition=>':P1119_SOURCE_TYPE = ''SQL'' and :P1119_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(104952004592856926)
,p_associated_item=>wwv_flow_imp.id(65036939225292711)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2375851825310406)
,p_validation_name=>'Function Body Not Null'
,p_validation_sequence=>50
,p_validation=>'P1119_FUNC_BODY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Function Body must be specified.'
,p_validation_condition=>':P1119_SOURCE_TYPE = ''FUNC_BODY_RETURNING_SQL'' and :P1119_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(104952004592856926)
,p_associated_item=>wwv_flow_imp.id(25534117966448344)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2376159262312994)
,p_validation_name=>'is valid query'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_describe_result wwv_flow_exec_dev.t_describe_result;',
'begin',
'    l_describe_result := wwv_flow_exec_dev.check_and_describe (',
'                            p_location             => wwv_flow_exec_api.c_location_local_db,',
'                            p_query_type           => wwv_flow_exec_api.c_query_type_sql_query,',
'                            p_sql_query            => :P1119_SQL );',
'                            ',
'    return l_describe_result.error_message;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':P1119_SOURCE_TYPE = ''SQL'' and :P1119_LOCATION = ''LOCAL'' and :P1119_SQL is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(104952004592856926)
,p_associated_item=>wwv_flow_imp.id(65036939225292711)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2376425795317190)
,p_validation_name=>'is valid code'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_describe_result wwv_flow_exec_dev.t_describe_result;',
'begin',
'    l_describe_result := wwv_flow_exec_dev.check_and_describe (',
'                            p_location               => wwv_flow_exec_api.c_location_local_db,',
'                            p_query_type             => wwv_flow_exec_api.c_query_type_func_return_sql,',
'                            p_function_body          => :P1119_FUNC_BODY,',
'                            p_function_body_language => :P1119_FUNC_BODY_LANG );',
'                            ',
'    return l_describe_result.error_message;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1119_SOURCE_TYPE = ''FUNC_BODY_RETURNING_SQL'' and',
':P1119_LOCATION = ''LOCAL'' and ',
':P1119_FUNC_BODY is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(104952004592856926)
,p_associated_item=>wwv_flow_imp.id(25534117966448344)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2376737896318772)
,p_validation_name=>'is valid Graph Query'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_describe_result wwv_flow_exec_dev.t_describe_result;',
'begin',
'    l_describe_result := wwv_flow_exec_dev.check_and_describe (',
'                            p_location               => wwv_flow_exec_api.c_location_local_db,',
'                            p_query_type             => wwv_flow_exec_api.c_query_type_graph,',
'                            p_owner                  => :P1119_TABLE_OWNER,',
'                            p_table_name             => :P1119_GRAPH_NAME,',
'                            p_columns_clause         => :P1119_PQL_COLUMNS_CLAUSE,',
'                            p_match_clause           => :P1119_PQL_MATCH_CLAUSE );',
'                            ',
'    return l_describe_result.error_message;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    :P1119_SOURCE_TYPE         = ''GRAPH''',
'and :P1119_LOCATION            = ''LOCAL''',
'and :P1119_GRAPH_NAME         is not null',
'and :P1119_PQL_COLUMNS_CLAUSE is not null',
'and :P1119_PQL_MATCH_CLAUSE   is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(104952004592856926)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2377052472320406)
,p_validation_name=>'P1119_TABLE_OWNER is not null'
,p_validation_sequence=>90
,p_validation=>'P1119_TABLE_OWNER'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Table owner must be specified.'
,p_validation_condition=>':P1119_SOURCE_TYPE = ''TABLE'' and :P1119_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(104952004592856926)
,p_associated_item=>wwv_flow_imp.id(65032851472292706)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2377379652322878)
,p_validation_name=>'P1119_TABLE_NAME is not null'
,p_validation_sequence=>100
,p_validation=>'P1119_TABLE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Table name must be specified.'
,p_validation_condition=>':P1119_SOURCE_TYPE = ''TABLE'' and :P1119_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(104952004592856926)
,p_associated_item=>wwv_flow_imp.id(65033783132292708)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2377658353324651)
,p_validation_name=>'P1119_REMOTE_TABLE_NAME is not null'
,p_validation_sequence=>110
,p_validation=>'P1119_REMOTE_TABLE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Table name must be specified.'
,p_validation_condition=>':P1119_REMOTE_SOURCE_TYPE = ''TABLE'' and :P1119_LOCATION = ''REMOTE'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(104952004592856926)
,p_associated_item=>wwv_flow_imp.id(65057403564292751)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2377958077327112)
,p_validation_name=>'P1119_REMOTE_SQL is not null'
,p_validation_sequence=>120
,p_validation=>'P1119_REMOTE_SQL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'SQL name must be specified.'
,p_validation_condition=>':P1119_REMOTE_SOURCE_TYPE = ''SQL'' and :P1119_LOCATION = ''REMOTE'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(104952004592856926)
,p_associated_item=>wwv_flow_imp.id(65055596597292750)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2378241951329226)
,p_validation_name=>'P1119_WEB_SRC_MODULE_ID is not null'
,p_validation_sequence=>130
,p_validation=>'P1119_WEB_SRC_MODULE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1119_LOCATION'
,p_validation_condition2=>'WEB_SOURCE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(104952004592856926)
,p_associated_item=>wwv_flow_imp.id(65051483704292747)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2378589671335039)
,p_validation_name=>'P1119_REMOTE_SERVER_ID is not null'
,p_validation_sequence=>140
,p_validation=>'P1119_REMOTE_SERVER_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1119_LOCATION'
,p_validation_condition2=>'REMOTE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(104952004592856926)
,p_associated_item=>wwv_flow_imp.id(65054338814292749)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2378858274336745)
,p_validation_name=>'P1119_GRAPH_NAME is not null'
,p_validation_sequence=>150
,p_validation=>'P1119_GRAPH_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1119_SOURCE_TYPE'
,p_validation_condition2=>'GRAPH'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(104952004592856926)
,p_associated_item=>wwv_flow_imp.id(3997261860182130)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2379134321338363)
,p_validation_name=>'P1119_PQL_MATCH_CLAUSE is not null'
,p_validation_sequence=>160
,p_validation=>'P1119_PQL_MATCH_CLAUSE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1119_SOURCE_TYPE'
,p_validation_condition2=>'GRAPH'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(104952004592856926)
,p_associated_item=>wwv_flow_imp.id(3997364018182131)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2379481758340238)
,p_validation_name=>'P1119_PQL_COLUMNS_CLAUSE is not null'
,p_validation_sequence=>170
,p_validation=>'P1119_PQL_COLUMNS_CLAUSE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1119_SOURCE_TYPE'
,p_validation_condition2=>'GRAPH'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(104952004592856926)
,p_associated_item=>wwv_flow_imp.id(3997456868182132)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2011947535979417)
,p_validation_name=>'P1119_NAME is unique'
,p_validation_sequence=>180
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_collections',
' where c001             = :P1119_NAME',
'   and ( :P1119_SEQ_ID is null or seq_id != :P1119_SEQ_ID )',
'   and collection_name  = ''REPORT_QUERIES'''))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#LABEL# must be unique.'
,p_validation_condition=>'APPLY_CHANGES,CREATE,NEXT'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(4118954243195701)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(590013018468897523)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(104951832307856926)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(590013186205897524)
,p_event_id=>wwv_flow_imp.id(590013018468897523)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2346943117131169)
,p_name=>'SOURCE TYPE CHANGE HIDE ALL'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1119_SOURCE_TYPE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2347304534131171)
,p_event_id=>wwv_flow_imp.id(2346943117131169)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1119_SQL,P1119_FUNC_BODY_LANG,P1119_FUNC_BODY,P1119_SQL,P1119_TABLE_OWNER,P1119_TABLE_NAME,P1119_GRAPH_NAME,P1119_PQL_MATCH_CLAUSE,P1119_PQL_COLUMNS_CLAUSE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2348229625134889)
,p_name=>'SOURCE TYPE = SQL'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1119_SOURCE_TYPE'
,p_condition_element=>'P1119_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SQL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2348651247134889)
,p_event_id=>wwv_flow_imp.id(2348229625134889)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1119_SQL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2349519524136917)
,p_name=>'SOURCE TYPE = TABLE'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1119_SOURCE_TYPE'
,p_condition_element=>'P1119_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TABLE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2349911322136917)
,p_event_id=>wwv_flow_imp.id(2349519524136917)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1119_TABLE_OWNER,P1119_TABLE_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2350345561138063)
,p_name=>'SOURCE TYPE = FUNC_BODY'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1119_SOURCE_TYPE'
,p_condition_element=>'P1119_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FUNC_BODY_RETURNING_SQL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2350788139138063)
,p_event_id=>wwv_flow_imp.id(2350345561138063)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1119_FUNC_BODY_LANG,P1119_FUNC_BODY'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2351118373139635)
,p_name=>'SOURCE TYPE = GRAPH'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1119_SOURCE_TYPE'
,p_condition_element=>'P1119_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'GRAPH'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2351506687139636)
,p_event_id=>wwv_flow_imp.id(2351118373139635)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1119_GRAPH_NAME,P1119_PQL_MATCH_CLAUSE,P1119_PQL_COLUMNS_CLAUSE,P1119_TABLE_OWNER'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2351930559141716)
,p_name=>'Location "LOCAL"'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1119_LOCATION'
,p_condition_element=>'P1119_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'LOCAL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2352364460141717)
,p_event_id=>wwv_flow_imp.id(2351930559141716)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(66803713582240263)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2352895615141717)
,p_event_id=>wwv_flow_imp.id(2351930559141716)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(66803713582240263)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2353263607142830)
,p_name=>'Location "REMOTE"'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1119_LOCATION'
,p_condition_element=>'P1119_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REMOTE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2353681224142830)
,p_event_id=>wwv_flow_imp.id(2353263607142830)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(68594453426848191)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2354147357142830)
,p_event_id=>wwv_flow_imp.id(2353263607142830)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(68594453426848191)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2354598642143928)
,p_name=>'Location "WEB_SRC"'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1119_LOCATION'
,p_condition_element=>'P1119_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'WEB_SOURCE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2354947109143928)
,p_event_id=>wwv_flow_imp.id(2354598642143928)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(66803798996240264)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2355435527143928)
,p_event_id=>wwv_flow_imp.id(2354598642143928)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(66803798996240264)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2355895842145941)
,p_name=>'REMOTE SOURCE TYPE = SQL'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1119_REMOTE_SOURCE_TYPE'
,p_condition_element=>'P1119_REMOTE_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SQL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2356257105145941)
,p_event_id=>wwv_flow_imp.id(2355895842145941)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1119_REMOTE_SQL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2357299396145941)
,p_event_id=>wwv_flow_imp.id(2355895842145941)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1119_REMOTE_TABLE_OWNER,P1119_REMOTE_TABLE_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2357757099145941)
,p_event_id=>wwv_flow_imp.id(2355895842145941)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1119_REMOTE_TABLE_OWNER,P1119_REMOTE_TABLE_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2358714692145942)
,p_event_id=>wwv_flow_imp.id(2355895842145941)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1119_REMOTE_SQL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2359196820149491)
,p_name=>'Remote Server chosen'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1119_REMOTE_SERVER_ID'
,p_condition_element=>'P1119_REMOTE_SERVER_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2359532416149492)
,p_event_id=>wwv_flow_imp.id(2359196820149491)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1119_REMOTE_SOURCE_TYPE,P1119_REMOTE_SQL,P1119_REMOTE_TABLE_OWNER,P1119_REMOTE_TABLE_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2360067615149492)
,p_event_id=>wwv_flow_imp.id(2359196820149491)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1119_REMOTE_SOURCE_TYPE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2011590101979413)
,p_event_id=>wwv_flow_imp.id(2359196820149491)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1119_REMOTE_SOURCE_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'TABLE'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1420548389013280)
,p_name=>'Web Source Module is not null'
,p_event_sequence=>120
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1119_WEB_SRC_MODULE_ID'
,p_condition_element=>'P1119_WEB_SRC_MODULE_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1420997339013281)
,p_event_id=>wwv_flow_imp.id(1420548389013280)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1119_WEB_SRC_ARRAY_COL_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1421425795013282)
,p_event_id=>wwv_flow_imp.id(1420548389013280)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1119_WEB_SRC_ARRAY_COL_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1421975094013282)
,p_event_id=>wwv_flow_imp.id(1420548389013280)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1119_WEB_SRC_ARRAY_COL_ID'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2011075214979408)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update Report Query'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_report_query_dev.merge_collection_member(',
'    p_seq                       => :P1119_SEQ_ID,',
'    p_collection_name           => ''REPORT_QUERIES'',',
'    p_name                      => :P1119_NAME,',
'    p_location                  => :P1119_LOCATION,',
'    -- Local',
'    p_source_type               => :P1119_SOURCE_TYPE,',
'    p_table_owner               => :P1119_TABLE_OWNER,',
'    p_table_name                => :P1119_TABLE_NAME,',
'    p_sql_query                 => :P1119_SQL,',
'    p_function_body_language    => :P1119_FUNC_BODY_LANG,',
'    p_function_body             => :P1119_FUNC_BODY,',
'    p_graph_name                => :P1119_GRAPH_NAME,',
'    p_match_clause              => :P1119_PQL_MATCH_CLAUSE,',
'    p_columns_clause            => :P1119_PQL_COLUMNS_CLAUSE,',
'    -- REST data source',
'    p_web_src_module_id         => :P1119_WEB_SRC_MODULE_ID,',
'    p_web_src_array_column_id   => :P1119_WEB_SRC_ARRAY_COL_ID,',
'    -- REST enabled SQL',
'    p_remote_server_id          => :P1119_REMOTE_SERVER_ID,',
'    p_remote_source_type        => :P1119_REMOTE_SOURCE_TYPE,',
'    p_remote_sql_query          => :P1119_REMOTE_SQL,',
'    p_remote_table_owner        => :P1119_REMOTE_TABLE_OWNER,',
'    p_remote_table_name         => :P1119_REMOTE_TABLE_NAME );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error saving SQL query'
,p_process_when=>'APPLY_CHANGES,CREATE,NEXT'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'SQL query saved'
,p_internal_uid=>2011075214979408
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(107946525238718110)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Query'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    htmldb_collection.delete_member(',
'      p_collection_name => ''REPORT_QUERIES'',',
'      p_seq             => :P1119_SEQ_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error deleting query'
,p_process_when_button_id=>wwv_flow_imp.id(107941612855695604)
,p_process_success_message=>'Query deleted'
,p_internal_uid=>107946525238718110
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(269891415356562349)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Reset Collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if htmldb_collection.collection_exists(''SET_BIND_VALUES'') then',
'    htmldb_collection.delete_collection(''SET_BIND_VALUES'');',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>269891415356562349
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2011415257979412)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch Source Query'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_report_query_dev.get_collection_member(',
'    p_seq                       => :P1119_SEQ_ID,',
'    p_collection_name           => ''REPORT_QUERIES'',',
'    p_name                      => :P1119_NAME,',
'    p_location                  => :P1119_LOCATION,',
'    -- Local',
'    p_source_type               => :P1119_SOURCE_TYPE,',
'    p_table_owner               => :P1119_TABLE_OWNER,',
'    p_table_name                => :P1119_TABLE_NAME,',
'    p_sql_query                 => :P1119_SQL,',
'    p_function_body_language    => :P1119_FUNC_BODY_LANG,',
'    p_function_body             => :P1119_FUNC_BODY,',
'    p_graph_name                => :P1119_GRAPH_NAME,',
'    p_match_clause              => :P1119_PQL_MATCH_CLAUSE,',
'    p_columns_clause            => :P1119_PQL_COLUMNS_CLAUSE,',
'    -- REST data source',
'    p_web_src_module_id         => :P1119_WEB_SRC_MODULE_ID,',
'    p_web_src_array_column_id   => :P1119_WEB_SRC_ARRAY_COL_ID,',
'    -- REST enabled SQL',
'    p_remote_server_id          => :P1119_REMOTE_SERVER_ID,',
'    p_remote_source_type        => :P1119_REMOTE_SOURCE_TYPE,',
'    p_remote_sql_query          => :P1119_REMOTE_SQL,',
'    p_remote_table_owner        => :P1119_REMOTE_TABLE_OWNER,',
'    p_remote_table_name         => :P1119_REMOTE_TABLE_NAME );'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P1119_SEQ_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>2011415257979412
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2375137414305538)
,p_process_sequence=>40
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'Clear Graph items'
,p_attribute_01=>'CLEAR_CACHE_FOR_ITEMS'
,p_attribute_03=>'P1119_GRAPH_NAME,P1119_PQL_MATCH_CLAUSE,P1119_PQL_COLUMNS_CLAUSE'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(104952004592856926)
,p_process_when=>'P1119_SOURCE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_process_when2=>'GRAPH'
,p_internal_uid=>2375137414305538
);
end;
/
prompt --application/pages/page_01121
begin
wwv_flow_imp_page.create_page(
 p_id=>1121
,p_name=>'Copy Report Query'
,p_alias=>'COPY-REPORT-QUERY'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Report Query'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_rpt_print.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(62967104563852575)
,p_plug_name=>'Copy Report Query'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(590046711508270381)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(62968016369852582)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(590046711508270381)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(62968213315852583)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(590046711508270381)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(62970104801852589)
,p_branch_action=>'f?p=&APP_ID.:1100:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(62968418713852584)
,p_name=>'P1121_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(62967104563852575)
,p_prompt=>'Copy Report Query'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id',
'from WWV_FLOW_SHARED_QUERIES',
'where flow_id = :fb_flow_id',
'order by upper(name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Report Query -  '
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify component to copy'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(62968931766852587)
,p_name=>'P1121_REPORT_QUERY_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(62967104563852575)
,p_prompt=>'Report Query Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify new component name.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(62969518966852588)
,p_validation_name=>'P1121_ID'
,p_validation_sequence=>20
,p_validation=>'P1121_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(62968213315852583)
,p_associated_item=>wwv_flow_imp.id(62968418713852584)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(62969719439852588)
,p_validation_name=>'P1121_REPORT_QUERY_NAME'
,p_validation_sequence=>30
,p_validation=>'P1121_REPORT_QUERY_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'New report query name must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(62968213315852583)
,p_associated_item=>wwv_flow_imp.id(62968931766852587)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(590014022087897533)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(62968016369852582)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(590014169890897534)
,p_event_id=>wwv_flow_imp.id(590014022087897533)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(62969810792852588)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Report Query'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_report_query_dev.copy_report_query(',
'    p_application_id            => :FB_FLOW_ID,',
'    p_report_query_id           => :P1121_ID,',
'    p_to_name                   => :P1121_REPORT_QUERY_NAME );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to copy Report Query'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(62968213315852583)
,p_process_success_message=>'Report Query Copied'
,p_internal_uid=>62969810792852588
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(590014217600897535)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(62968213315852583)
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>590014217600897535
);
end;
/
prompt --application/pages/page_01122
begin
wwv_flow_imp_page.create_page(
 p_id=>1122
,p_name=>'Copy Report Layout'
,p_alias=>'COPY-REPORT-LAYOUT'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Report Layout'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'auto'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_rpt_print.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(63108814517977364)
,p_plug_name=>'Copy Report Layout'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(590050704413351910)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(63109718403977365)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(590050704413351910)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2636248831134123)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(590050704413351910)
,p_button_name=>'COPY_FROM_ANOTHER'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Copy from another app'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:1122:&SESSION.::&DEBUG.:1122:P1122_COPY_SOURCE:OTHER'
,p_button_condition=>'P1122_COPY_SOURCE'
,p_button_condition2=>'THIS'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_button_css_classes=>'a-Button--noUI'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(63109919558977365)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(590050704413351910)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy Report Layout'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3611444848028738)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(63109919558977365)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2635815847134119)
,p_name=>'P1122_COPY_SOURCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(63108814517977364)
,p_item_default=>'THIS'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2635922906134120)
,p_name=>'P1122_COPY_FROM_APPLICATION_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(63108814517977364)
,p_prompt=>'Application'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST OTHER FLOWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'  from   wwv_flow_visible_flows f',
' where id != :FB_FLOW_ID',
'   and build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'order by 2'))
,p_cHeight=>1
,p_display_when=>'P1122_COPY_SOURCE'
,p_display_when2=>'OTHER'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Select the application from which you want to copy a report layout.</p>'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2636075458134121)
,p_name=>'P1122_SUBSCRIBE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(63108814517977364)
,p_item_default=>'Y'
,p_prompt=>'Subscribe'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>'P1122_COPY_SOURCE'
,p_display_when2=>'OTHER'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'While copying the report layout, you can also subscribe to it. Set Subscribe to <strong>On</strong> to subscribe to the report layout.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2636117121134122)
,p_name=>'P1122_NEW_REPORT_LAYOUT_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(63108814517977364)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(63110108579977365)
,p_name=>'P1122_ID'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(63108814517977364)
,p_prompt=>'Copy Report Layout'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select report_layout_name d, id r',
'  from wwv_flow_report_layouts',
' where flow_id           = :P1122_COPY_FROM_APPLICATION_ID',
'   and security_group_id = :WORKSPACE_ID',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Report Layout - '
,p_lov_cascade_parent_items=>'P1122_COPY_FROM_APPLICATION_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_read_only_when=>'P1122_ID'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify a report layout to copy.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'Y'
,p_attribute_06=>'0'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(63110614427977366)
,p_name=>'P1122_REPORT_LAYOUT_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(63108814517977364)
,p_prompt=>'New Report Layout Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the name of the report layout. Report layout name must be unique within the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(63111431811977366)
,p_validation_name=>'P1122_REPORT_LAYOUT_NAME not null'
,p_validation_sequence=>30
,p_validation=>'P1122_REPORT_LAYOUT_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>':P1122_COPY_SOURCE = ''THIS'' or :P1122_SUBSCRIBE = ''N'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(63109919558977365)
,p_associated_item=>wwv_flow_imp.id(63110614427977366)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(146010218325637204)
,p_validation_name=>'REPORT_LAYOUT_NAME unique'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_report_layouts',
' where report_layout_name = :P1122_REPORT_LAYOUT_NAME',
'   and flow_id            = :FB_FLOW_ID',
'   and security_group_id  = :WORKSPACE_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'A report layout already exists with the same name. Please enter a different name.'
,p_validation_condition=>':P1122_COPY_SOURCE = ''THIS'' or :P1122_SUBSCRIBE = ''N'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(63109919558977365)
,p_associated_item=>wwv_flow_imp.id(63110614427977366)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2636844252134129)
,p_validation_name=>'No duplicate subscription'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_report_layouts',
' where security_group_id = :WORKSPACE_ID ',
'   and flow_id           = :FB_FLOW_ID ',
'   and reference_id      = :P1122_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'There is another report layout in this application that is subscribed to the same master. Please select another master report layout.'
,p_validation_condition=>'P1122_SUBSCRIBE'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(63109919558977365)
,p_associated_item=>wwv_flow_imp.id(63110108579977365)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(590015076897897543)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(63109718403977365)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(590015184436897544)
,p_event_id=>wwv_flow_imp.id(590015076897897543)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2636386210134124)
,p_name=>'Toggle P1122_REPORT_LAYOUT_NAME display'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1122_SUBSCRIBE'
,p_condition_element=>'P1122_SUBSCRIBE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_cond=>'P1122_COPY_SOURCE'
,p_display_when_cond2=>'OTHER'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2636482823134125)
,p_event_id=>wwv_flow_imp.id(2636386210134124)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1122_REPORT_LAYOUT_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2636501827134126)
,p_event_id=>wwv_flow_imp.id(2636386210134124)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1122_REPORT_LAYOUT_NAME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2636654260134127)
,p_name=>'Set New Name'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1122_ID'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_cond=>'P1122_COPY_SOURCE'
,p_display_when_cond2=>'OTHER'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2636762503134128)
,p_event_id=>wwv_flow_imp.id(2636654260134127)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1122_REPORT_LAYOUT_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'apex.item("P1122_ID").displayValueFor($v("P1122_ID"))'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(63111507604977366)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Report Layout'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1122_NEW_REPORT_LAYOUT_ID := wwv_flow_copy_metadata.copy_component (',
'    p_component_type       => wwv_flow_copy_metadata.c_report_layout,',
'    p_from_id              => :P1122_ID,',
'    p_from_app_id          => :P1122_COPY_FROM_APPLICATION_ID,',
'    p_to_app_id            => :FB_FLOW_ID,',
'    p_new_name             => :P1122_REPORT_LAYOUT_NAME,',
'    p_subscribe            => :P1122_SUBSCRIBE = ''Y'' );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to copy the report layout.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(63109919558977365)
,p_process_success_message=>'Report layout copied.'
,p_internal_uid=>63111507604977366
);
end;
/
prompt --application/pages/page_01130
begin
wwv_flow_imp_page.create_page(
 p_id=>1130
,p_name=>'Report Query Utilization'
,p_alias=>'REPORT-QUERY-UTILIZATION'
,p_step_title=>'Report Query Utilization'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(22569212548659511)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_plugins.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(29593922937316124)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page displays the page processes and dynamic actions that will print the selected Report Query in the current application.</p>',
'',
'<p>To edit page processes or dynamic actions, click the component name.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(29597505295420549)
,p_plug_name=>'Report Query Utilization'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name,',
'       object_type,',
'       ''f?p=4000:4500:''||:APP_SESSION||''::NO:1:FB_FLOW_ID,FB_FLOW_PAGE_ID,F4000_P1_FLOW,F4000_P1_PAGE:''||app_id||'',''||page_id||'',''||app_id||'',''||page_id||''#''||component_type||'':''||component_id as object_url,',
'       object_name,',
'       page_id,',
'       page_name',
'  from (',
'        select q.name                                               as display_name,',
'               wwv_flow_lang.system_message(''F4000.DYNAMIC ACTION'') as object_type,',
'               e.name                                               as object_name,',
'               5150                                                 as component_type,',
'               a.id                                                 as component_id,',
'               a.flow_id                                            as app_id,',
'               e.page_id                                            as page_id,',
'               pg.name                                              as page_name',
'          from wwv_flow_shared_queries  q,',
'               wwv_flow_page_da_events  e,',
'               wwv_flow_page_da_actions a,',
'               wwv_flow_steps           pg',
'         where q.flow_id            = :FB_FLOW_ID',
'           and q.security_group_id  = :WORKSPACE_ID',
'           and e.flow_id            = q.flow_id',
'           and e.security_group_id  = q.security_group_id',
'           and a.security_group_id  = q.security_group_id',
'           and pg.security_group_id = q.security_group_id',
'           and a.event_id           = e.id',
'           and a.report_query_id    = q.id',
'           and pg.flow_id           = e.flow_id',
'           and pg.id                = e.page_id',
'        union all',
'        select q.name                                        as display_name,',
'               wwv_flow_lang.system_message(''PAGE PROCESS'')  as object_type,',
'               pr.process_name                               as object_name,',
'               5530                                          as component_type,',
'               pr.id                                         as component_id,',
'               pr.flow_id                                    as app_id,',
'               pr.flow_step_id                               as page_id,',
'               pg.name                                       as page_name',
'          from wwv_flow_shared_queries  q,',
'               wwv_flow_step_processing pr,',
'               wwv_flow_steps           pg',
'         where q.flow_id            = :FB_FLOW_ID',
'           and q.security_group_id  = :WORKSPACE_ID',
'           and pr.security_group_id = q.security_group_id',
'           and pg.security_group_id = q.security_group_id',
'           and pr.flow_id           = q.flow_id',
'           and pr.report_query_id   = q.id',
'           and pg.flow_id           = pr.flow_id',
'           and pg.id                = pr.flow_step_id',
'    )'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_prn_output_show_link=>'Y'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#ffffff'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'LEFT'
,p_prn_page_footer_alignment=>'LEFT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(29597619896420550)
,p_name=>'xxx'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'PATRICK'
,p_internal_uid=>29597619896420550
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(29603109911453755)
,p_db_column_name=>'DISPLAY_NAME'
,p_display_order=>1
,p_column_identifier=>'G'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(35198009014612797)
,p_db_column_name=>'OBJECT_NAME'
,p_display_order=>2
,p_column_identifier=>'J'
,p_column_label=>'Component Name'
,p_column_link=>'#OBJECT_URL#'
,p_column_linktext=>'#OBJECT_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(35197802294612792)
,p_db_column_name=>'OBJECT_TYPE'
,p_display_order=>3
,p_column_identifier=>'H'
,p_column_label=>'Component Type'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(29598122771420557)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(29598198502420557)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Page Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(35200117017654831)
,p_db_column_name=>'OBJECT_URL'
,p_display_order=>7
,p_column_identifier=>'K'
,p_column_label=>'Component Url'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(29617519213128191)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1306600121536647'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'DISPLAY_NAME:OBJECT_NAME:OBJECT_TYPE:PAGE_ID:PAGE_NAME'
,p_sort_column_1=>'DISPLAY_NAME'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'PAGE_ID'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'OBJECT_NAME'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(190734320801078393)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(193369209650497455)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Plug-ins'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1743015076989247)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(29597505295420549)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1130:&SESSION.::&DEBUG.:4420,RIR::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1744128446989261)
,p_branch_action=>'f?p=&FLOW_ID.:1130:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_01234
begin
wwv_flow_imp_page.create_page(
 p_id=>1234
,p_name=>'Developer Comments - Create Comments'
,p_alias=>'DEVELOPER-COMMENTS-CREATE-COMMENTS'
,p_page_mode=>'MODAL'
,p_step_title=>'Developer Comments'
,p_allow_duplicate_submissions=>'N'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_comment.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(123537523367900100)
,p_plug_name=>'Developer Comments'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_header=>'Use this page to add comments to an application, a page, or a group of pages.<p />'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(123547514466030042)
,p_plug_name=>'comments'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>91
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(123545913988020430)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(716353419229823641)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(232634827416535370)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(716353419229823641)
,p_button_name=>'CREATE_AGAIN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Create and Create Another'
,p_button_position=>'NEXT'
,p_button_condition=>'P1234_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(123537731742900109)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(716353419229823641)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>'P1234_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(123538026288900109)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(716353419229823641)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(232636826854544630)
,p_branch_action=>'f?p=&APP_ID.:1234:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(232634827416535370)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(123538626655900116)
,p_branch_action=>'f?p=&APP_ID.:1235:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(123538824973900121)
,p_name=>'P1234_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(123537523367900100)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(123539019004900121)
,p_name=>'P1234_FLOW_ID'
,p_item_sequence=>11
,p_item_plug_id=>wwv_flow_imp.id(123537523367900100)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Application'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(123539227801900122)
,p_name=>'P1234_PAGES'
,p_item_sequence=>21
,p_item_plug_id=>wwv_flow_imp.id(123537523367900100)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_PAGE_ID.'
,p_prompt=>'Relevant Page(s)'
,p_source=>'PAGES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>2
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the pages to which this comment applies. To enter a comment that:',
'<ul>',
'<li>Applies to a specific page, enter the page number</li>',
'<li>Applies to multiple pages, enter a comma delimited list of pages, for example:</li>',
'<pre>1,2,3</pre>',
'<li>Does not apply to a page or group of pages, leave this field blank.</li>',
'<ul>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_show_quick_picks=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(123539426852900122)
,p_name=>'P1234_APP_COMMENT'
,p_item_sequence=>41
,p_item_plug_id=>wwv_flow_imp.id(123537523367900100)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comment'
,p_source=>'APP_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Enter a comment of up to 4000 characters.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1142730559897397045)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'1234'
,p_compute_when_type=>'NEVER'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(223964818557185973)
,p_validation_name=>'Relevant pages'
,p_validation_sequence=>5
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'l_pages_string wwv_flow_global.vc_arr2;',
'l_flag boolean := false;',
'l_count number;',
'begin',
'    l_pages_string := wwv_flow_utilities.string_to_table(to_char(:P1234_PAGES),'','');',
'    if l_pages_string.count > 0 then',
'       for i in 1..l_pages_string.count loop',
'            select 1 into l_count from dual where exists (select 1',
'              from wwv_flow_steps',
'             where flow_id = :FB_FLOW_ID ',
'               and security_group_id = :flow_security_group_id',
'               and (to_char(id) = l_pages_string(i) or lower(name) = lower(l_pages_string(i))));',
'            if l_count <> 0 then',
'              l_flag := true;',
'            else',
'              l_flag := false;',
'              exit;',
'            end if;',
'       end loop;',
'    end if;',
'    return l_flag;',
'exception when no_data_found then return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Not a valid page.'
,p_validation_condition=>'P1234_PAGES'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_imp.id(123539227801900122)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(123605305440616599)
,p_validation_name=>'P1234_APP_COMMENT Not Null'
,p_validation_sequence=>10
,p_validation=>'P1234_APP_COMMENT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Comment must be specified.'
,p_associated_item=>wwv_flow_imp.id(123539426852900122)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 14-APR-2006 01:31'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(486766762279194440)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(123538026288900109)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(486766849310194441)
,p_event_id=>wwv_flow_imp.id(486766762279194440)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(123539830205900124)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_APP_COMMENTS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_APP_COMMENTS'
,p_attribute_03=>'P1234_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Unable to process row of table WWV_FLOW_APP_COMMENTS.'
,p_process_success_message=>'Comment Created.'
,p_internal_uid=>123539830205900124
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(486766908372194442)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(123537731742900109)
,p_process_success_message=>'Comment Created.'
,p_internal_uid=>486766908372194442
);
end;
/
prompt --application/pages/page_01235
begin
wwv_flow_imp_page.create_page(
 p_id=>1235
,p_name=>'Developer Comments - View Comments'
,p_alias=>'DEVELOPER-COMMENTS-VIEW-COMMENTS'
,p_page_mode=>'MODAL'
,p_step_title=>'View Developer Comments'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_comment.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(123554528709102911)
,p_plug_name=>'comments'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>91
,p_plug_new_grid_column=>false
,p_list_id=>wwv_flow_imp.id(123545913988020430)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(480642308464787876)
,p_plug_name=>'Developer Comments'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>100
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.id, ',
'       a.flow_id, ',
'       a.pages, ',
'       a.app_comment, ',
'       a.created_on, ',
'       a.created_by,',
'       m.e',
'from WWV_FLOW_APP_COMMENTS a, (select wwv_flow_lang.system_message(''EDIT'') e from dual) m',
'where a.flow_id = :fb_flow_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(480642409196787876)
,p_name=>'Application Comments'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_max_rows_per_page=>'5'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_detail_link_text=>'<img src="#IMAGE_PREFIX#menu/pencil16x16.gif" alt="" />'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(480642618294787884)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Edit'
,p_column_link=>'f?p=&APP_ID.:1236:&SESSION.::&DEBUG.:1236:P1236_ID:#ID#'
,p_column_linktext=>'<img src="#IMAGE_PREFIX#menu/pencil2_16x16.gif" alt="#E#">'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_hide=>'N'
,p_column_type=>'NUMBER'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(480642701443787886)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(480642810738787887)
,p_db_column_name=>'PAGES'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Page(s)'
,p_column_type=>'STRING'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(480642917569787888)
,p_db_column_name=>'APP_COMMENT'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Comment'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(480643023768787889)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Date Created'
,p_column_type=>'DATE'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(480643110041787890)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1142730609563397046)
,p_db_column_name=>'E'
,p_display_order=>16
,p_column_identifier=>'G'
,p_column_label=>'E'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(480643318916789165)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1293726102536644'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'ID:FLOW_ID:PAGES:APP_COMMENT:CREATED_ON:CREATED_BY:E'
,p_sort_column_1=>'CREATED_ON'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1142730365473397043)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(480648000309840576)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1142730365473397043)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(480648917755855006)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(480642308464787876)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1235:&SESSION.::&DEBUG.:RIR::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(123575520425262395)
,p_branch_action=>'f?p=&FLOW_ID.:1235:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1474234592148765837)
,p_branch_name=>'Go To Page 1235'
,p_branch_action=>'f?p=&APP_ID.:1235:&SESSION.::&DEBUG.:RP,CIR,1235,1234:IR_PAGES:&FB_FLOW_PAGE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_HEADER'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'SET_CURRENT_PAGE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1142730470924397044)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'1235'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(692816214967250924)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(480648000309840576)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(692816344529250925)
,p_event_id=>wwv_flow_imp.id(692816214967250924)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1000724298923503624)
,p_name=>'Edit Comment - Dialog Closed'
,p_event_sequence=>20
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(480642308464787876)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1000724344409503625)
,p_event_id=>wwv_flow_imp.id(1000724298923503624)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(480642308464787876)
);
end;
/
prompt --application/pages/page_01236
begin
wwv_flow_imp_page.create_page(
 p_id=>1236
,p_name=>'Edit Developer Comment'
,p_alias=>'EDIT-DEVELOPER-COMMENT'
,p_page_mode=>'MODAL'
,p_step_title=>'Edit Developer Comment'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'400'
,p_dialog_width=>'700'
,p_dialog_max_width=>'1000'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_comment.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(123556230616110490)
,p_plug_name=>'Developer Comment'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(123556415458110491)
,p_plug_name=>'comments'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>91
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(1284942185735713564)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_plug_display_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1000723973714503621)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(123557226812110495)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(1000723973714503621)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(123557031897110494)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1000723973714503621)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(htmldb_delete_message,''DELETE'');'
,p_button_condition=>'P1236_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(123556820381110494)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1000723973714503621)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P1236_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1000724569434503627)
,p_branch_name=>'Return to Parent Page'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:RP:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(123557431204110497)
,p_name=>'P1236_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(123556230616110490)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(123557621406110499)
,p_name=>'P1236_FLOW_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(123556230616110490)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Application:'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(123557826993110501)
,p_name=>'P1236_PAGES'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(123556230616110490)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Relevant Page(s):'
,p_source=>'PAGES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>2
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the pages to which this comment applies. To enter a comment that:',
'<ul>',
'<li>Applies to a specific page, enter the page number</li>',
'<li>Applies to multiple pages, enter a comma delimited list of pages, for example:</li>',
'<pre>1,2,3</pre>',
'<li>Does not apply to a page or group of pages, leave this field blank.</li>',
'<ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(123558020518110501)
,p_name=>'P1236_APP_COMMENT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(123556230616110490)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comment:'
,p_source=>'APP_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>6
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Enter or revise this comment. A comment can consist of up to 4000 characters.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(223968027739226404)
,p_validation_name=>'Relevant pages'
,p_validation_sequence=>5
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'l_pages_string wwv_flow_global.vc_arr2;',
'l_flag boolean := false;',
'l_count number;',
'begin',
'    l_pages_string := wwv_flow_utilities.string_to_table(to_char(:P1236_PAGES),'','');',
'    if l_pages_string.count > 0 then',
'       for i in 1..l_pages_string.count loop',
'            select 1 into l_count from dual where exists (select 1',
'              from wwv_flow_steps',
'             where flow_id = :FB_FLOW_ID ',
'               and security_group_id = :flow_security_group_id',
'               and (to_char(id) = l_pages_string(i) or lower(name) = lower(l_pages_string(i))));',
'            if l_count <> 0 then',
'              l_flag := true;',
'            else',
'              l_flag := false;',
'              exit;',
'            end if;',
'       end loop;',
'    end if;',
'    return true;',
'exception when no_data_found then return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Not a valid relevant page'
,p_when_button_pressed=>wwv_flow_imp.id(123556820381110494)
,p_associated_item=>wwv_flow_imp.id(123557826993110501)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(124035417798389112)
,p_validation_name=>'P1236_APP_COMMENT'
,p_validation_sequence=>10
,p_validation=>'P1236_APP_COMMENT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(123556820381110494)
,p_associated_item=>wwv_flow_imp.id(123558020518110501)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1000724078717503622)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(123557226812110495)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1000724178029503623)
,p_event_id=>wwv_flow_imp.id(1000724078717503622)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(123558218597110505)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_APP_COMMENTS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_APP_COMMENTS'
,p_attribute_03=>'P1236_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Unable to fetch row.'
,p_internal_uid=>123558218597110505
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(123558429165110506)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_APP_COMMENTS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_APP_COMMENTS'
,p_attribute_03=>'P1236_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Unable to process row of table WWV_FLOW_APP_COMMENTS.'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>123558429165110506
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(123558621993110506)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'1234'
,p_process_when_button_id=>wwv_flow_imp.id(123557031897110494)
,p_internal_uid=>123558621993110506
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(694385070619237844)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_type=>'NEVER'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>694385070619237844
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(746156952208367929)
,p_process_sequence=>60
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog on Cancel'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(123557226812110495)
,p_internal_uid=>746156952208367929
);
end;
/
prompt --application/pages/page_01237
begin
wwv_flow_imp_page.create_page(
 p_id=>1237
,p_name=>'Delete Comments - Comment Actions'
,p_alias=>'DELETE-COMMENTS-COMMENT-ACTIONS'
,p_page_mode=>'MODAL'
,p_step_title=>'Delete Comments'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12511519296310366)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_comment.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(125606014398318403)
,p_plug_name=>'Developer Comments'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>30
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(125611220070329594)
,p_plug_name=>'comments'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_imp.id(1284942185735713564)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_plug_display_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(125623624628434962)
,p_name=>'Comments by Developer'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select	 CREATED_BY, count(*) c',
' from	 WWV_FLOW_APP_COMMENTS',
'where    flow_id = :fb_flow_id',
'and security_group_id = :flow_security_group_id',
'group    by created_by'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>50
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No Comments found.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(125623918473434970)
,p_query_column_id=>1
,p_column_alias=>'CREATED_BY'
,p_column_display_sequence=>1
,p_column_heading=>'Developer'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(125624022696434970)
,p_query_column_id=>2
,p_column_alias=>'C'
,p_column_display_sequence=>2
,p_column_heading=>'Comments'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(125625719218442826)
,p_name=>'Comments by Day'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select	 trunc(created_on) CREATED_ON, count(*) c',
' from	 WWV_FLOW_APP_COMMENTS',
'where    flow_id = :fb_flow_id',
'and security_group_id = :flow_security_group_id',
'group    by trunc(created_on)'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>50
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No Comments found.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(125626402726447548)
,p_query_column_id=>1
,p_column_alias=>'CREATED_ON'
,p_column_display_sequence=>1
,p_column_heading=>'Date Created'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(125625901435442830)
,p_query_column_id=>2
,p_column_alias=>'C'
,p_column_display_sequence=>2
,p_column_heading=>'Comments'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(754559227164487437)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>150
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2321634135249176500)
,p_plug_name=>'comments'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(123545913988020430)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(125618309905392893)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(754559227164487437)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(125618510962392895)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(754559227164487437)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(125628521904462571)
,p_branch_action=>'f?p=&APP_ID.:1238:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(125618309905392893)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(125629125367463594)
,p_branch_action=>'f?p=&APP_ID.:1237:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(125613619901367332)
,p_name=>'P1237_COMMENT_ACTIONS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(125606014398318403)
,p_item_default=>'DATE'
,p_prompt=>'Action:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'COMMENT MGT'
,p_lov=>'.'||wwv_flow_imp.id(131122619933750813)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Select an action and click <strong>Next</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(754559639707487441)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(125618510962392895)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(754559719302487442)
,p_event_id=>wwv_flow_imp.id(754559639707487441)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_01238
begin
wwv_flow_imp_page.create_page(
 p_id=>1238
,p_name=>'Developer Comments - Delete Comments'
,p_alias=>'DEVELOPER-COMMENTS-DELETE-COMMENTS'
,p_page_mode=>'MODAL'
,p_step_title=>'Delete Comments'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(12511519296310366)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_comment.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(125615526048372333)
,p_plug_name=>'Developer Comments'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(754559304329487438)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2321636842147201443)
,p_plug_name=>'comments'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(123545913988020430)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(125639426631530146)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(754559304329487438)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Delete Comments'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(125638513125526226)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(754559304329487438)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1237:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(125666323617661740)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(754559304329487438)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(125639609772530148)
,p_branch_name=>'Go To Previous Page'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(125639426631530146)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(125636509877515824)
,p_name=>'P1238_DEVELOPER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(125615526048372333)
,p_prompt=>'Delete Comments by Developer:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct CREATED_BY display_value, CREATED_BY return_value',
'from WWV_FLOW_APP_COMMENTS',
'where flow_id = :fb_flow_id',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Developer -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_display_when=>'P1237_COMMENT_ACTIONS'
,p_display_when2=>'DEVELOPER'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the comments created by developer.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(125642702436551532)
,p_name=>'P1238_TIME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(125615526048372333)
,p_prompt=>'Delete comments created on or before the selected date:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct trunc(CREATED_ON) display_value, to_char(trunc(CREATED_ON) ,''YYYY.MM.DD'') return_value',
'from WWV_FLOW_APP_COMMENTS',
'where flow_id = :fb_flow_id',
'order by 1 desc'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Date -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_display_when=>'P1237_COMMENT_ACTIONS'
,p_display_when2=>'DATE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the distinct dates on which comments were created.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(125644810186563230)
,p_name=>'P1238_COUNT'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(125615526048372333)
,p_prompt=>'Count of Comments:'
,p_source=>'select count(*) from wwv_flow_app_comments where flow_id = :fb_flow_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the total number of comments logged for this application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(125659932097626337)
,p_validation_name=>'P1238_DEVELOPER'
,p_validation_sequence=>10
,p_validation=>'P1238_DEVELOPER'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'Developer must be specified.'
,p_validation_condition=>'P1237_COMMENT_ACTIONS'
,p_validation_condition2=>'DEVELOPER'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(125639426631530146)
,p_associated_item=>wwv_flow_imp.id(125636509877515824)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(125661119068632040)
,p_validation_name=>'P1238_TIME'
,p_validation_sequence=>20
,p_validation=>'P1238_TIME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Date must be specified.'
,p_validation_condition=>'P1237_COMMENT_ACTIONS'
,p_validation_condition2=>'DATE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(125639426631530146)
,p_associated_item=>wwv_flow_imp.id(125642702436551532)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(754559420603487439)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(125666323617661740)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(754559520263487440)
,p_event_id=>wwv_flow_imp.id(754559420603487439)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(125640604252533114)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete comments'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P1237_COMMENT_ACTIONS = ''ALL'' then',
'   delete from wwv_flow_app_comments ',
'   where flow_id = :fb_flow_id;',
'elsif :P1237_COMMENT_ACTIONS = ''DEVELOPER'' then',
'   delete from wwv_flow_app_comments ',
'   where flow_id = :fb_flow_id and created_by = :P1238_DEVELOPER;',
'elsif :P1237_COMMENT_ACTIONS = ''DATE'' then',
'   delete from wwv_flow_app_comments ',
'   where flow_id = :fb_flow_id and trunc(created_on) <= to_date(:P1238_TIME,''YYYY.MM.DD'');',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to delete comments'
,p_process_success_message=>'Comments deleted.'
,p_internal_uid=>125640604252533114
);
end;
/
prompt --application/pages/page_01300
begin
wwv_flow_imp_page.create_page(
 p_id=>1300
,p_name=>'Application Comparison'
,p_alias=>'APPLICATION-COMPARISON'
,p_step_title=>'Application Comparison'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(15039604745449200)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(493047621227940477)
,p_plug_name=>'Application Comparison'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="float:left;clear:both;"'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P1300a */',
'component,',
'page_id,',
'page_name,',
'component_name,',
'component_signature,',
'decode(application_1,0,null,''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'') application_1,',
'decode(application_2,0,null,''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'') application_2,',
'decode(application_1,0,null,''X'') a_1,',
'decode(application_2,0,null,''X'') a_2',
'from (',
'select page_id,',
'page_name,',
'component,',
'component_name,',
'component_signature,',
'application_1,',
'application_2',
'from apex_component_signatures) q',
'where ',
'(nvl(:P1300_SHOW_DIFFERENCES,''Y'')=''N'' or ',
'(nvl(:P1300_SHOW_DIFFERENCES,''Y'')=''Y'' and application_1 != application_2))'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'nvl(:REQUEST,''X'')            != ''NORUN'' and ',
'nvl(:APEX_APPLICATION_1,''0'') != ''0''     and',
'nvl(:APEX_APPLICATION_2,''0'') != ''0'''))
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(493047720816940477)
,p_name=>'Application Comparison'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(493047930668941285)
,p_db_column_name=>'COMPONENT'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Component'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_imp.id(15166510896787111)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(493048010071941286)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(493048117478941287)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Page Name'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(493048231120941287)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Component Name'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(493048303393941287)
,p_db_column_name=>'COMPONENT_SIGNATURE'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Details'
,p_allow_sorting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(493048430576941288)
,p_db_column_name=>'APPLICATION_1'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Application 1'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(493048510158941288)
,p_db_column_name=>'APPLICATION_2'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Application 2'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(493048607117941289)
,p_db_column_name=>'A_1'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Application 1'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(493048714149941289)
,p_db_column_name=>'A_2'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Application 2'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(493049214511945815)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1293821876536644'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'COMPONENT:PAGE_ID:PAGE_NAME:COMPONENT_NAME:APPLICATION_1:APPLICATION_2:A_1:A_2'
,p_sort_column_1=>'COMPONENT'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'PAGE_ID'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'COMPONENT_NAME'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(702937747004311901)
,p_plug_name=>'Cross Application Reports'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(702923103587108064)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(15045710117488602)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(15039604745449200)
,p_button_name=>'P1300_GO'
,p_button_static_id=>'P1300_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Go'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(27862932602152407)
,p_branch_name=>'Redirect to self (RP)'
,p_branch_action=>'f?p=&APP_ID.:1300:&SESSION.::&DEBUG.:RP::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(15045710117488602)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(15040616173452553)
,p_name=>'APEX_APPLICATION_1'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(15039604745449200)
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Application 1'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||name d, id r',
'  from wwv_flow_visible_flows f',
' where f.build_status != ''RUN_AND_HIDDEN''',
' order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Application -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select an application to compare and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(15040822645452554)
,p_name=>'APEX_APPLICATION_2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(15039604745449200)
,p_prompt=>'Application 2'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||name d, id r',
'  from wwv_flow_visible_flows f',
' where f.build_status != ''RUN_AND_HIDDEN''',
' order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Application -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select an application to compare and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(15068211230744414)
,p_name=>'P1300_SHOW_DIFFERENCES'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(15039604745449200)
,p_item_default=>'Y'
,p_prompt=>'Show Only Differences'
,p_display_as=>'NATIVE_YES_NO'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies whether to show only differences or all data.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(15158420902487243)
,p_name=>'APEX_COMPONENT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(15039604745449200)
,p_prompt=>'Component'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APP DIFF COMPONENTS'
,p_lov=>'.'||wwv_flow_imp.id(15166510896787111)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- All Components -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the specific component to compare and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
end;
/
prompt --application/pages/page_01301
begin
wwv_flow_imp_page.create_page(
 p_id=>1301
,p_name=>'Application Comparison Counts'
,p_alias=>'APPLICATION-COMPARISON-COUNTS'
,p_step_title=>'Application Comparison Counts'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(17189801948394308)
,p_name=>'Application Comparison'
,p_template=>wwv_flow_imp.id(646287526247383209)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P1301a */',
'component,',
'sum(application_1) application_1_count,',
'sum(application_2) application_2_count,',
'sum(decode(application_2,0,0,decode(application_1,application_2,0,1))) deltas',
'from apex_component_signatures',
'group by component'))
,p_display_when_condition=>'NORUN'
,p_display_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Report contains no data'
,p_query_num_rows_item=>'P1301_ROWS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>50000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_report_total_text_format=>'&nbsp;'
,p_csv_output=>'Y'
,p_csv_output_link_text=>'Download'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(17190631538394312)
,p_query_column_id=>1
,p_column_alias=>'COMPONENT'
,p_column_display_sequence=>1
,p_column_heading=>'Component'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(15166510896787111)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(17195718044399138)
,p_query_column_id=>2
,p_column_alias=>'APPLICATION_1_COUNT'
,p_column_display_sequence=>2
,p_column_heading=>'Application 1'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(17195812258399139)
,p_query_column_id=>3
,p_column_alias=>'APPLICATION_2_COUNT'
,p_column_display_sequence=>3
,p_column_heading=>'Application 2'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(17536704069529009)
,p_query_column_id=>4
,p_column_alias=>'DELTAS'
,p_column_display_sequence=>4
,p_column_heading=>'Differences'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17190904236394312)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17197222677409954)
,p_plug_name=>'set state'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
':APEX_COMPONENT := :1301_APEX_COMPONENT;',
':APEX_APPLICATION_1 := :1301_APEX_APPLICATION_1;',
':APEX_APPLICATION_2 := :1301_APEX_APPLICATION_2;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(702947203320429957)
,p_plug_name=>'Cross Application Reports'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(702923103587108064)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(17194026633394324)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(17190904236394312)
,p_button_name=>'P1301_GO'
,p_button_static_id=>'P1301_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Go'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17192519038394324)
,p_name=>'1301_APEX_COMPONENT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(17190904236394312)
,p_prompt=>'Component'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APP DIFF COMPONENTS'
,p_lov=>'.'||wwv_flow_imp.id(15166510896787111)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- All Components -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the specific component to compare and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17193000172394324)
,p_name=>'1301_APEX_APPLICATION_1'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(17190904236394312)
,p_prompt=>'Application 1'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||name d, id r',
'  from wwv_flow_visible_flows f',
' where f.build_status != ''RUN_AND_HIDDEN''',
' order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select an application to compare and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17193525392394324)
,p_name=>'1301_APEX_APPLICATION_2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(17190904236394312)
,p_prompt=>'Application 2'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||name d, id r',
'  from wwv_flow_visible_flows f',
' where f.build_status != ''RUN_AND_HIDDEN''',
' order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select an application to compare and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17194422693394325)
,p_name=>'P1301_ROWS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(17190904236394312)
,p_item_default=>'50'
,p_prompt=>'Rows'
,p_source=>'50'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'MAXIMUM ROWS PER PAGE'
,p_lov=>'.'||wwv_flow_imp.id(84800803131139158)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the number of applications to display and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(17194911948394327)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when_button_id=>wwv_flow_imp.id(17194026633394324)
,p_internal_uid=>17194911948394327
);
end;
/
prompt --application/pages/page_01310
begin
wwv_flow_imp_page.create_page(
 p_id=>1310
,p_name=>'Create Activity Reporting Pages'
,p_alias=>'CREATE-ACTIVITY-REPORTING-PAGES'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Activity Reporting Pages'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213425326892450628)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'sec_authentication.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(117507451964569407)
,p_plug_name=>'Create Tab'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>30
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P2500_NAVIGATION_TYPE'
,p_plug_display_when_cond2=>'L'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(117506863394569405)
,p_name=>'Tabs'
,p_parent_plug_id=>wwv_flow_imp.id(117507451964569407)
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<a title="click to set tab set" href="javascript:$x_Value(''''P1310_TAB_SET'''',''''''||',
'       wwv_flow_javascript.escape(tab_set)||',
'       '''''');">''||',
'       wwv_flow_escape.html(tab_set)||',
'       ''</a>'' tab_set, ',
'       tab_step, ',
'       substr(tab_text,1,30) tab_text,',
'       replace(TAB_ALSO_CURRENT_FOR_PAGES,'','','', '') tacfp',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID and ',
'       security_group_id = :flow_security_group_id',
'order  by tab_set, TAB_SEQUENCE, tab_step'))
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>'No tabs or tab sets exist.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(57849493242151676)
,p_query_column_id=>1
,p_column_alias=>'TAB_SET'
,p_column_display_sequence=>1
,p_column_heading=>'Tab Set'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(57849874872151679)
,p_query_column_id=>2
,p_column_alias=>'TAB_STEP'
,p_column_display_sequence=>2
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(57850292252151679)
,p_query_column_id=>3
,p_column_alias=>'TAB_TEXT'
,p_column_display_sequence=>3
,p_column_heading=>'Tab'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(57850673145151679)
,p_query_column_id=>4
,p_column_alias=>'TACFP'
,p_column_display_sequence=>4
,p_column_heading=>'Also&nbsp;Current&nbsp;For'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(758884905432798283)
,p_plug_name=>'Create Activity Reporting Pages'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_plug_header=>'Include numerous reports on end user activity for your application. Determine the most active users, the most used pages, the performance of pages, and errors raised, to better understand how your application is being utilized and areas for improveme'
||'nt.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(770537390324975510)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1037339875012925919)
,p_plug_name=>'Create List Entry'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>40
,p_translate_title=>'N'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P2500_NAVIGATION_TYPE'
,p_plug_display_when_cond2=>'L'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3775766002223368423)
,p_plug_name=>'Admin Options'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(725944806732667144)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(770537390324975510)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(725945204229667146)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(770537390324975510)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(725945679123667146)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(770537390324975510)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(725948665922667162)
,p_branch_action=>'f?p=&FLOW_ID.:4500:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(725944806732667144)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(725949400695667162)
,p_branch_name=>'Go To Page 2500'
,p_branch_action=>'f?p=&APP_ID.:2500:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(725945679123667146)
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(32413796851551883)
,p_name=>'P1310_ADMIN_PAGE_OPTION'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3775766002223368423)
,p_item_default=>'EXISTING'
,p_prompt=>'Administration Page Preference'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.ADMINPAGE.OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(31963614629360602)||'.'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the administration page, that a list is added to, for this feature.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(32414153599551883)
,p_name=>'P1310_ADMIN_PAGE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3775766002223368423)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.get_maximum_free_admin_page(:FB_FLOW_ID);',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Administration Page Number'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter an unused page number for the administration page.</p>',
'<p>The default is calculated as the first available page number that is divisible by 100, which is greater than the maximum page number within this application.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(32415079559551884)
,p_name=>'P1310_ADMIN_PAGE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3775766002223368423)
,p_item_default=>'wwv_flow_lang.system_message(''CA.ADMIN.ADMINISTRATION'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Administration Page Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a name for the administration page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(32415451462551884)
,p_name=>'P1310_EXISTING_PAGE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(3775766002223368423)
,p_prompt=>'Existing Administration Page'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d',
'  from wwv_flow_steps',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and is_page_pattern   = ''N''',
'order by 2'))
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select an existing page used as the administration page in this application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57844562845149244)
,p_name=>'P1310_GROUP_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(758884905432798283)
,p_prompt=>'Page Group'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE_GROUPS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d,',
'       id r',
'  from wwv_flow_page_groups',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
' order by upper(group_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Page Group -'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_page_groups ',
' where flow_id           = :fb_flow_id ',
'   and security_group_id = :flow_security_group_id'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Identify the name of the page group to associate with this page. Page groups help developers manage the pages within an application.',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57845591955151667)
,p_name=>'P1310_TAB_OPTIONS'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(117507451964569407)
,p_item_default=>'0'
,p_prompt=>'Administration Page<br>Tab Options:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.TAB.OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(35310611267199336)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Specify whether the administration page should be included in tabs.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57846425479151670)
,p_name=>'P1310_TAB_SET'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(117507451964569407)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   t varchar2(4000);',
'begin',
'   for c1 in (',
'select tab_set, count(*) c',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID and ',
'       security_group_id = :flow_security_group_id',
'group  by tab_set',
'order by 2 desc) loop',
'return c1.tab_set;',
'exit;',
'end loop;',
'return null;',
'end;',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Tab Set'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_TABSETS'
,p_lov=>'select wwv_flow_escape.html(d) d, r from wwv_flow_tabset_view'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Tab Set -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Select the tab set you wish to use for this page.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57847312389151672)
,p_name=>'P1310_TAB_LABEL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(117507451964569407)
,p_prompt=>'New Tab Label'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the label for the tab that will be created. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57848287610151673)
,p_name=>'P1310_TAB_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(117507451964569407)
,p_prompt=>'Use Tab'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(TAB_NAME)||'': label="''||wwv_flow_escape.html(substr(TAB_TEXT,1,40))||''"'' tab_text,tab_name',
'from   wwv_flow_tabs',
'where  flow_id = :fb_flow_id and',
'       security_group_id = :flow_security_group_id and',
'       tab_set = :P1310_TAB_SET'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Tab -'
,p_lov_cascade_parent_items=>'P1310_TAB_SET'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Select the tab to be designated as "current" for this page.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57851384099153099)
,p_name=>'P1310_NAVLIST_OPTIONS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1037339875012925919)
,p_item_default=>'NONE'
,p_prompt=>'Administration Page<br> Navigation Preference'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.NAVIGATIONLIST.OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(925221062390507339)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select how you want this page integrated into the Navigation Menu.<p/>',
'<ul>',
'    <li><strong>Do not associate this page with a Navigation Menu entry</strong> - The new page will not be current or highlighted for any menu entry.</li>',
'    <li><strong>Create a new Navigation Menu entry</strong> - Users will be able to navigate to the new page directly from the Navigation Menu. The new entry can be placed anywhere in the existing hierarchy.</li>',
'    <li><strong>Identify an existing Navigation Menu entry which will be current for this page</strong> - Use this option when you want the new page to highlight an existing, top level, menu entry. Users will not be able to navigate to the new page d'
||'irectly from the Navigation Menu. Therefore, You will need to create or define a navigation control on the top level page selected, such as a button, or link in a report, to go to this new page.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57852629105153100)
,p_name=>'P1310_NAVLIST_ENTRY_NAME'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_imp.id(1037339875012925919)
,p_prompt=>'New Navigation Menu Entry'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Enter a name for the new menu control.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57853584127153102)
,p_name=>'P1310_NAVLIST_PARENT_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1037339875012925919)
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select a navigation parent for your new page. When creating a new navigation item, the new item links to',
'the new page. The new item can be added at the top level, by not selecting any parent item, or shown as a child',
'of an existing item. </p>',
'',
'<p>When selecting item without creating a new item, the selected item determines which top level item is shown',
'as the "current" item.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57854406244153103)
,p_name=>'P1310_NEW_PARENT_ID'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_imp.id(1037339875012925919)
,p_prompt=>'Parent Navigation Menu Entry'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'NAVLIST_ENTRIES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case',
'           when (nvl(list_item_link_target,''0'')=''0'' or parent_list_item_id is',
'null) then',
'               lpad('' '',(4*(level-1)),''.'')||list_item_link_text',
'           else',
'               lpad('' '',(4*(level-1)),''.'')||'' (''||list_item_link_text ||'')''',
'       end name,',
'       id',
'  from wwv_flow_list_items',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and sub_list_id is null',
' start with list_id = :P2500_NAVLIST_ID and parent_list_item_id is null',
'connect by prior list_id = list_id and prior id = parent_list_item_id',
' order siblings by list_item_display_sequence'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No parent selected - '
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select an existing menu control if you wish to add a menu entry for the new page to this menu control. ',
'When not selecting an existing menu control, a menu control for the new page will be created at the to level.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57855363083153105)
,p_name=>'P1310_EXISTING_PARENT_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(1037339875012925919)
,p_prompt=>'Existing Navigation Menu Entry'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'NAVLIST_ENTRIES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case',
'           when (nvl(list_item_link_target,''0'')=''0'' or parent_list_item_id is',
'null) then',
'               lpad('' '',(4*(level-1)),''.'')||list_item_link_text',
'           else',
'               lpad('' '',(4*(level-1)),''.'')||'' (''||list_item_link_text ||'')''',
'       end name,',
'       id',
'  from wwv_flow_list_items',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and sub_list_id is null',
' start with list_id = :P2500_NAVLIST_ID and parent_list_item_id is null',
'connect by prior list_id = list_id and prior id = parent_list_item_id',
' order siblings by list_item_display_sequence'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Select an existing menu control to be shown as the active menu control when rendering the new page. ',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(130089413134346976)
,p_name=>'P1310_AUTHORIZATION_SCHEME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(3775766002223368423)
,p_prompt=>'Authorization Scheme'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REQUIRED_ROLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.d, a.r from (',
'    select wwv_flow_lang.system_message(''MUST_NOT_BE_PUBLIC_USER'') d,''MUST_NOT_BE_PUBLIC_USER'' r, 1',
'      from sys.dual',
'    union all',
'    select wwv_flow_escape.html(substr(name,1,50)),to_char(id), 1',
'      from wwv_flow_security_schemes',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID',
'    union all',
'    select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'',wwv_flow_escape.html(substr(name,1,50)))||''}'' d, ''!''||to_char(id) r, 2',
'      from wwv_flow_security_schemes',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID',
'    order by 3,1) a'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- None -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the authorization scheme used to limit access to the Administration page and the pages for this feature.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(183306875103905192)
,p_name=>'P1310_BUILD_OPTION'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(758884905432798283)
,p_prompt=>'Build Option'
,p_source=>'wwv_flow_lang.system_message(''FEATURE'')||'': ''||wwv_flow_lang.system_message(''FEATURE.ACTIVITY_REPORTING'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The listed build option(s) will be created to support this feature.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(725939161009667132)
,p_name=>'P1310_STARTING_PAGE_ID'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(758884905432798283)
,p_use_cache_before_default=>'NO'
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.get_maximum_free_page(:FB_FLOW_ID);',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Starting Page Number'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>10
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter an unused starting page number. This feature will create multiple pages starting with the number specified.</p>',
'<p>The default is calculated as the first available page number that is divisible by 10, which is greater than the maximum page number within this application.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(725946192631667153)
,p_computation_sequence=>20
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.get_current_theme_id (',
'    p_application_id => :FB_FLOW_ID )'))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(725946560428667154)
,p_validation_name=>'P1310_STARTING_PAGE_ID positive, whole number'
,p_validation_sequence=>1
,p_validation=>'P1310_STARTING_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>'#LABEL# must be a positive, whole number.'
,p_when_button_pressed=>wwv_flow_imp.id(725945204229667146)
,p_associated_item=>wwv_flow_imp.id(725939161009667132)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 23-APR-2003 17:15'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3775765906333368422)
,p_validation_name=>'P1310_STARTING_PAGE_ID reserved'
,p_validation_sequence=>11
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.reserve_page (',
'    p_flow_id       => :FB_FLOW_ID,',
'    p_page_id       => :P1310_STARTING_PAGE_ID,',
'    p_reuse         => TRUE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P1310_STARTING_PAGE_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(725945204229667146)
,p_associated_item=>wwv_flow_imp.id(725939161009667132)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(688506607794608724)
,p_validation_name=>'P1310_ADMIN_PAGE_ID positive, whole number'
,p_validation_sequence=>21
,p_validation=>'P1310_ADMIN_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>'#LABEL# must be a positive, whole number.'
,p_validation_condition=>'P1310_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(725945204229667146)
,p_associated_item=>wwv_flow_imp.id(32414153599551883)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 23-APR-2003 17:15'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3775765767170368420)
,p_validation_name=>'P1310_ADMIN_PAGE_ID not null'
,p_validation_sequence=>31
,p_validation=>'P1310_ADMIN_PAGE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1310_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(725945204229667146)
,p_associated_item=>wwv_flow_imp.id(32415079559551884)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3775765826745368421)
,p_validation_name=>'P1310_ADMIN_PAGE_ID reserved'
,p_validation_sequence=>51
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.reserve_page (',
'    p_flow_id       => :FB_FLOW_ID,',
'    p_page_id       => :P1310_ADMIN_PAGE_ID,',
'    p_reuse         => TRUE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1310_ADMIN_PAGE_OPTION = ''NEW''',
'and :P1310_ADMIN_PAGE_ID is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(725945204229667146)
,p_associated_item=>wwv_flow_imp.id(32414153599551883)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(688506838451608726)
,p_validation_name=>'P1310_STARTING_PAGE_ID and P1310_ADMIN_PAGE_ID different'
,p_validation_sequence=>61
,p_validation=>':P1310_STARTING_PAGE_ID <> :P1310_ADMIN_PAGE_ID'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Starting Page Number and Administration Page Number must be different.'
,p_validation_condition=>'P1310_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(725945204229667146)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(688506568227608723)
,p_validation_name=>'P1310_ADMIN_PAGE_NAME not null'
,p_validation_sequence=>71
,p_validation=>'P1310_ADMIN_PAGE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1310_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(725945204229667146)
,p_associated_item=>wwv_flow_imp.id(32415079559551884)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(688506734462608725)
,p_validation_name=>'P1310_EXISTING_PAGE not null'
,p_validation_sequence=>81
,p_validation=>'P1310_EXISTING_PAGE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1310_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(725945204229667146)
,p_associated_item=>wwv_flow_imp.id(32415451462551884)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(235669185981464945)
,p_validation_name=>'P1310_EXISTING_PAGE available'
,p_validation_sequence=>91
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    return wwv_flow_wizard_api.page_exists( p_flow_id => :FB_FLOW_ID, p_page_id => :P1310_EXISTING_PAGE );',
'exception',
'    when value_error then return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'#LABEL# is not a page in the application.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1310_ADMIN_PAGE_OPTION = ''EXISTING''',
'and :P1310_EXISTING_PAGE is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(725945204229667146)
,p_associated_item=>wwv_flow_imp.id(32415451462551884)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(57827287067033905)
,p_validation_name=>'P1310_TAB_SET not null'
,p_validation_sequence=>101
,p_validation=>'P1310_TAB_SET'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1310_TAB_OPTIONS'
,p_validation_condition2=>'1:2'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_when_button_pressed=>wwv_flow_imp.id(725945204229667146)
,p_associated_item=>wwv_flow_imp.id(57846425479151670)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(57827377374033906)
,p_validation_name=>'P1310_TAB_LABEL not null'
,p_validation_sequence=>111
,p_validation=>'P1310_TAB_LABEL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1310_TAB_OPTIONS'
,p_validation_condition2=>'1'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(725945204229667146)
,p_associated_item=>wwv_flow_imp.id(57847312389151672)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(57827484879033907)
,p_validation_name=>'P1310_TAB_NAME not null'
,p_validation_sequence=>121
,p_validation=>'P1310_TAB_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1310_TAB_OPTIONS'
,p_validation_condition2=>'2'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(725945204229667146)
,p_associated_item=>wwv_flow_imp.id(57848287610151673)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(57827501722033908)
,p_validation_name=>'P1310_NAVLIST_ENTRY_NAME not null'
,p_validation_sequence=>141
,p_validation=>'P1310_NAVLIST_ENTRY_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1310_NAVLIST_OPTIONS'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(725945204229667146)
,p_associated_item=>wwv_flow_imp.id(57852629105153100)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(57932454307393997)
,p_validation_name=>'Existing Entry with no List'
,p_validation_sequence=>151
,p_validation=>'P1310_EXISTING_PARENT_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1310_NAVLIST_OPTIONS'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(725945204229667146)
,p_associated_item=>wwv_flow_imp.id(57855363083153105)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2948841564812657)
,p_validation_name=>'Navigation Menu not subscribed'
,p_validation_sequence=>161
,p_validation=>'coalesce(:P2500_IS_NAVLIST_SUBSCRIBED,''N'') != ''Y'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'&APP_TEXT$NAVIGATION_MENU_SUBSCRIBED!RAW.'
,p_validation_condition=>':P1310_NAVLIST_OPTIONS in ( ''NEW'', ''EXISTING'' ) and :P2500_NAVLIST_ID is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(57851384099153099)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(725947657473667158)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(725944806732667144)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(725948102099667160)
,p_event_id=>wwv_flow_imp.id(725947657473667158)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(688506008357608718)
,p_name=>'Show / Hide Admin Options'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1310_ADMIN_PAGE_OPTION'
,p_condition_element=>'P1310_ADMIN_PAGE_OPTION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(688506181417608719)
,p_event_id=>wwv_flow_imp.id(688506008357608718)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1310_ADMIN_PAGE_ID,P1310_ADMIN_PAGE_NAME,P1310_NAVLIST_OPTIONS,P1310_TAB_OPTIONS,P1310_AUTHORIZATION_SCHEME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(688506450037608722)
,p_event_id=>wwv_flow_imp.id(688506008357608718)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1310_EXISTING_PAGE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(688506272493608720)
,p_event_id=>wwv_flow_imp.id(688506008357608718)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1310_EXISTING_PAGE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(688506329171608721)
,p_event_id=>wwv_flow_imp.id(688506008357608718)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1310_ADMIN_PAGE_ID,P1310_ADMIN_PAGE_NAME,P1310_NAVLIST_OPTIONS,P1310_TAB_OPTIONS,P1310_AUTHORIZATION_SCHEME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3775766865982368431)
,p_event_id=>wwv_flow_imp.id(688506008357608718)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1310_TAB_OPTIONS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'0'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3775766973344368432)
,p_event_id=>wwv_flow_imp.id(688506008357608718)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1310_NAVLIST_OPTIONS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'NONE'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(57892622623296391)
,p_name=>'Set Tab and Nav List Names'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1310_ADMIN_PAGE_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(57893060748296393)
,p_event_id=>wwv_flow_imp.id(57892622623296391)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1310_NAVLIST_ENTRY_NAME,P1310_TAB_LABEL'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P1310_ADMIN_PAGE_NAME'
,p_attribute_07=>'P1310_ADMIN_PAGE_NAME'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(57895673839302787)
,p_name=>'Tab Option 0'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1310_TAB_OPTIONS'
,p_condition_element=>'P1310_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'0'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(57896046343302788)
,p_event_id=>wwv_flow_imp.id(57895673839302787)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1310_TAB_SET,P1310_TAB_LABEL,P1310_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3775768630210368449)
,p_event_id=>wwv_flow_imp.id(57895673839302787)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(117506863394569405)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(57897241787304815)
,p_name=>'Tab Option 1'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1310_TAB_OPTIONS'
,p_condition_element=>'P1310_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'1'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(57897689348304816)
,p_event_id=>wwv_flow_imp.id(57897241787304815)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1310_TAB_SET,P1310_TAB_LABEL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(57898147773304819)
,p_event_id=>wwv_flow_imp.id(57897241787304815)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1310_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3775768734085368450)
,p_event_id=>wwv_flow_imp.id(57897241787304815)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(117506863394569405)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(57898750786306363)
,p_name=>'Tab Option 2'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1310_TAB_OPTIONS'
,p_condition_element=>'P1310_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'2'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(57899173336306366)
,p_event_id=>wwv_flow_imp.id(57898750786306363)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1310_TAB_SET,P1310_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(57899616494306366)
,p_event_id=>wwv_flow_imp.id(57898750786306363)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1310_TAB_LABEL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(100574310072284401)
,p_event_id=>wwv_flow_imp.id(57898750786306363)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(117506863394569405)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(57900043912308424)
,p_name=>'New List'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1310_NAVLIST_OPTIONS'
,p_condition_element=>'P1310_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(57900406198308425)
,p_event_id=>wwv_flow_imp.id(57900043912308424)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1310_NAVLIST_ENTRY_NAME,P1310_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(57900914267308425)
,p_event_id=>wwv_flow_imp.id(57900043912308424)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1310_NAVLIST_ENTRY_NAME,P1310_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(57901361679309862)
,p_name=>'Existing List'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1310_NAVLIST_OPTIONS'
,p_condition_element=>'P1310_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'EXISTING'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(57901741829309862)
,p_event_id=>wwv_flow_imp.id(57901361679309862)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1310_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(57902296922309863)
,p_event_id=>wwv_flow_imp.id(57901361679309862)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1310_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(725946878775667156)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create activity report feature page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_admin_page wwv_flow_app_feature_v3.t_admin_page;',
'begin',
'    -- admin page',
'    l_admin_page.page_option                 := :P1310_ADMIN_PAGE_OPTION;',
'    l_admin_page.new_page_id                 := :P1310_ADMIN_PAGE_ID;',
'    l_admin_page.page_name                   := :P1310_ADMIN_PAGE_NAME;',
'    l_admin_page.existing_page_id            := :P1310_EXISTING_PAGE;',
'    -- tabs',
'    l_admin_page.tab_option                  := :P1310_TAB_OPTIONS;',
'    l_admin_page.tab_set                     := :P1310_TAB_SET;',
'    l_admin_page.tab_name                    := :P1310_TAB_NAME;',
'    l_admin_page.tab_text                    := :P1310_TAB_LABEL;',
'    -- nav list',
'    l_admin_page.nav_list_option             := :P1310_NAVLIST_OPTIONS;',
'    l_admin_page.nav_list_id                 := :P2500_NAVLIST_ID;',
'    l_admin_page.nav_list_new_parent_id      := :P1310_NEW_PARENT_ID;',
'    l_admin_page.nav_list_existing_parent_id := :P1310_EXISTING_PARENT_ID;',
'    l_admin_page.nav_list_entry_name         := :P1310_NAVLIST_ENTRY_NAME;',
'    ',
'    wwv_flow_app_feature_v3.add_feature_activity_rpt(',
'        p_app_id                   => :FB_FLOW_ID,',
'        p_starting_page_id         => :P1310_STARTING_PAGE_ID,',
'        p_group_id                 => :P1310_GROUP_ID,',
'        p_auth_scheme_id           => :P1310_AUTHORIZATION_SCHEME,',
'        --',
'        p_admin_page               => l_admin_page );',
'',
'    :FB_FLOW_PAGE_ID := wwv_flow_app_feature_v3.get_admin_page_id( p_admin_page => l_admin_page);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Login page created.'
,p_internal_uid=>725946878775667156
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(725947242002667158)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(725945204229667146)
,p_process_success_message=>'Feature pages created.'
,p_internal_uid=>725947242002667158
);
end;
/
prompt --application/pages/page_01311
begin
wwv_flow_imp_page.create_page(
 p_id=>1311
,p_name=>'Create Configuration Options Page'
,p_alias=>'CREATE-CONFIGURATION-OPTIONS-PAGE'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Configuration Options Page'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213425326892450628)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'sec_authentication.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(175455605188021464)
,p_plug_name=>'Create Tab'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>80
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P2500_NAVIGATION_TYPE'
,p_plug_display_when_cond2=>'L'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(175455016618021462)
,p_name=>'Tabs'
,p_parent_plug_id=>wwv_flow_imp.id(175455605188021464)
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<a title="click to set tab set" href="javascript:$x_Value(''''P1311_TAB_SET'''',''''''||',
'       wwv_flow_javascript.escape(tab_set)||',
'       '''''');">''||',
'       wwv_flow_escape.html(tab_set)||',
'       ''</a>'' tab_set, ',
'       tab_step, ',
'       substr(tab_text,1,30) tab_text,',
'       replace(TAB_ALSO_CURRENT_FOR_PAGES,'','','', '') tacfp',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID and ',
'       security_group_id = :flow_security_group_id',
'order  by tab_set, TAB_SEQUENCE, tab_step'))
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>'No tabs or tab sets exist.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(57953519211452065)
,p_query_column_id=>1
,p_column_alias=>'TAB_SET'
,p_column_display_sequence=>1
,p_column_heading=>'Tab Set'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(57952315539452064)
,p_query_column_id=>2
,p_column_alias=>'TAB_STEP'
,p_column_display_sequence=>2
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(57952794285452065)
,p_query_column_id=>3
,p_column_alias=>'TAB_TEXT'
,p_column_display_sequence=>3
,p_column_heading=>'Tab'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(57953176559452065)
,p_query_column_id=>4
,p_column_alias=>'TACFP'
,p_column_display_sequence=>4
,p_column_heading=>'Also&nbsp;Current&nbsp;For'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1095293779404379332)
,p_plug_name=>'Create List Entry'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>90
,p_translate_title=>'N'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P2500_NAVIGATION_TYPE'
,p_plug_display_when_cond2=>'L'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1484850213243557971)
,p_plug_name=>'Create Page'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enables application administrators to enable or disable specific functionality within the application. This feature is useful if you select features that need additional development effort before they can be used by end users.<br>',
'This feature can also be expanded to application-specific features. If developers define additional build options and associate them with specific functionality throughout the application, then they can be added to the configuration settings for admi'
||'nistrators. '))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1496502698135735198)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3833711597190819143)
,p_plug_name=>'Admin Options'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(725968183767759694)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1496502698135735198)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(725968532713759695)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1496502698135735198)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(725968925563759695)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(1496502698135735198)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(725971942192759705)
,p_branch_action=>'f?p=&FLOW_ID.:4500:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(725968183767759694)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(725972790096759706)
,p_branch_name=>'Go To Page 2500'
,p_branch_action=>'f?p=&APP_ID.:2500:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(725968925563759695)
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57940639200441461)
,p_name=>'P1311_GROUP_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1484850213243557971)
,p_prompt=>'Page Group'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE_GROUPS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d,',
'       id r',
'  from wwv_flow_page_groups',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
' order by upper(group_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Page Group -'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the name of the page group to associate with this page. Page groups help developers manage the pages within an application. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57945850496450722)
,p_name=>'P1311_ADMIN_PAGE_OPTION'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3833711597190819143)
,p_item_default=>'EXISTING'
,p_prompt=>'Administration Page Preference'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.ADMINPAGE.OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(31963614629360602)||'.'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the administration page, that a list is added to, for this feature.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57946249248450723)
,p_name=>'P1311_ADMIN_PAGE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3833711597190819143)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.get_maximum_free_admin_page(:FB_FLOW_ID);',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Administration Page Number'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter an unused page number for the administration page.</p>',
'<p>The default is calculated as the first available page number that is divisible by 100, which is greater than the maximum page number within this application.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57947137375450723)
,p_name=>'P1311_ADMIN_PAGE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3833711597190819143)
,p_item_default=>'wwv_flow_lang.system_message(''CA.ADMIN.ADMINISTRATION'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Administration Page Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a name for the administration page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57947589907450724)
,p_name=>'P1311_EXISTING_PAGE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(3833711597190819143)
,p_prompt=>'Existing Administration Page'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d',
'  from wwv_flow_steps',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and is_page_pattern   = ''N''',
'order by 2'))
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select an existing page used as the administration page in this application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57948402962452058)
,p_name=>'P1311_TAB_OPTIONS'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(175455605188021464)
,p_item_default=>'0'
,p_prompt=>'Administration Page<br>Tab Options:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.TAB.OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(35310611267199336)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Specify whether the administration page should be included in tabs.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57949397235452061)
,p_name=>'P1311_TAB_SET'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(175455605188021464)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   t varchar2(4000);',
'begin',
'   for c1 in (',
'select tab_set, count(*) c',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID and ',
'       security_group_id = :flow_security_group_id',
'group  by tab_set',
'order by 2 desc) loop',
'return c1.tab_set;',
'exit;',
'end loop;',
'return null;',
'end;',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Tab Set'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_TABSETS'
,p_lov=>'select wwv_flow_escape.html(d) d, r from wwv_flow_tabset_view'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Tab Set -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Select the tab set you wish to use for this page.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57950200490452062)
,p_name=>'P1311_TAB_LABEL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(175455605188021464)
,p_prompt=>'New Tab Label'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the label for the tab that will be created. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57951181711452062)
,p_name=>'P1311_TAB_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(175455605188021464)
,p_prompt=>'Use Tab'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(TAB_NAME)||'': label="''||wwv_flow_escape.html(substr(TAB_TEXT,1,40))||''"'' tab_text,tab_name',
'from   wwv_flow_tabs',
'where  flow_id = :fb_flow_id and',
'       security_group_id = :flow_security_group_id and',
'       tab_set = :P1311_TAB_SET'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Tab -'
,p_lov_cascade_parent_items=>'P1311_TAB_SET'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Select the tab to be designated as "current" for this page.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57954288923453413)
,p_name=>'P1311_NAVLIST_OPTIONS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1095293779404379332)
,p_item_default=>'NONE'
,p_prompt=>'Administration Page<br> Navigation Preference'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.NAVIGATIONLIST.OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(925221062390507339)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select how you want this page integrated into the Navigation Menu.<p/>',
'<ul>',
'    <li><strong>Do not associate this page with a Navigation Menu entry</strong> - The new page will not be current or highlighted for any menu entry.</li>',
'    <li><strong>Create a new Navigation Menu entry</strong> - Users will be able to navigate to the new page directly from the Navigation Menu. The new entry can be placed anywhere in the existing hierarchy.</li>',
'    <li><strong>Identify an existing Navigation Menu entry which will be current for this page</strong> - Use this option when you want the new page to highlight an existing, top level, menu entry. Users will not be able to navigate to the new page d'
||'irectly from the Navigation Menu. Therefore, You will need to create or define a navigation control on the top level page selected, such as a button, or link in a report, to go to this new page.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57955509258453417)
,p_name=>'P1311_NAVLIST_ENTRY_NAME'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_imp.id(1095293779404379332)
,p_prompt=>'New Navigation Menu Entry'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Enter a name for the new menu control.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57956480050453417)
,p_name=>'P1311_NAVLIST_PARENT_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1095293779404379332)
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select a navigation parent for your new page. When creating a new navigation item, the new item links to',
'the new page. The new item can be added at the top level, by not selecting any parent item, or shown as a child',
'of an existing item. </p>',
'',
'<p>When selecting item without creating a new item, the selected item determines which top level item is shown',
'as the "current" item.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57957333505453418)
,p_name=>'P1311_NEW_PARENT_ID'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_imp.id(1095293779404379332)
,p_prompt=>'Parent Navigation Menu Entry'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'NAVLIST_ENTRIES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case',
'           when (nvl(list_item_link_target,''0'')=''0'' or parent_list_item_id is',
'null) then',
'               lpad('' '',(4*(level-1)),''.'')||list_item_link_text',
'           else',
'               lpad('' '',(4*(level-1)),''.'')||'' (''||list_item_link_text ||'')''',
'       end name,',
'       id',
'  from wwv_flow_list_items',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and sub_list_id is null',
' start with list_id = :P2500_NAVLIST_ID and parent_list_item_id is null',
'connect by prior list_id = list_id and prior id = parent_list_item_id',
' order siblings by list_item_display_sequence'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No parent selected - '
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select an existing menu control if you wish to add a menu entry for the new page to this menu control. ',
'When not selecting an existing menu control, a menu control for the new page will be created at the to level.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57958190651453419)
,p_name=>'P1311_EXISTING_PARENT_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(1095293779404379332)
,p_prompt=>'Existing Navigation Menu Entry'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'NAVLIST_ENTRIES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case',
'           when (nvl(list_item_link_target,''0'')=''0'' or parent_list_item_id is',
'null) then',
'               lpad('' '',(4*(level-1)),''.'')||list_item_link_text',
'           else',
'               lpad('' '',(4*(level-1)),''.'')||'' (''||list_item_link_text ||'')''',
'       end name,',
'       id',
'  from wwv_flow_list_items',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and sub_list_id is null',
' start with list_id = :P2500_NAVLIST_ID and parent_list_item_id is null',
'connect by prior list_id = list_id and prior id = parent_list_item_id',
' order siblings by list_item_display_sequence'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Select an existing menu control to be shown as the active menu control when rendering the new page. ',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(98082697095531901)
,p_name=>'P1311_AUTHORIZATION_SCHEME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(3833711597190819143)
,p_prompt=>'Authorization Scheme'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REQUIRED_ROLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.d, a.r from (',
'    select wwv_flow_lang.system_message(''MUST_NOT_BE_PUBLIC_USER'') d,''MUST_NOT_BE_PUBLIC_USER'' r, 1',
'      from sys.dual',
'    union all',
'    select wwv_flow_escape.html(substr(name,1,50)),to_char(id), 1',
'      from wwv_flow_security_schemes',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID',
'    union all',
'    select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'',wwv_flow_escape.html(substr(name,1,50)))||''}'' d, ''!''||to_char(id) r, 2',
'      from wwv_flow_security_schemes',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID',
'    order by 3,1) a'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- None -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the authorization scheme used to limit access to the Administration page and the page for this feature.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(183306074030824890)
,p_name=>'P1311_BUILD_OPTION'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(1484850213243557971)
,p_prompt=>'Build Option'
,p_source=>'wwv_flow_lang.system_message(''FEATURE'')||'': ''||wwv_flow_lang.system_message(''FEATURE.CONFIGURATION_OPTIONS'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The listed build option(s) will be created to support this feature.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(725966072267759691)
,p_name=>'P1311_PAGE_ID'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1484850213243557971)
,p_use_cache_before_default=>'NO'
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.get_maximum_free_page(:FB_FLOW_ID);',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Page Number'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>10
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter an unused starting page number.</p>',
'<p>The default is calculated as the first available page number that is divisible by 10, which is greater than the maximum page number within this application.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(725966936213759693)
,p_name=>'P1311_NAME'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1484850213243557971)
,p_item_default=>'wwv_flow_lang.system_message(''APEX.PAGE_NAME.CONFIGURATION_OPTIONS'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter a name for the feature page.',
' ',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(725969424188759697)
,p_computation_sequence=>20
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.get_current_theme_id (',
'    p_application_id    => :FB_FLOW_ID )'))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(725969802989759697)
,p_validation_name=>'P1311_PAGE_ID positive, whole number'
,p_validation_sequence=>21
,p_validation=>'P1311_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>'#LABEL# must be a positive, whole number.'
,p_when_button_pressed=>wwv_flow_imp.id(725968532713759695)
,p_associated_item=>wwv_flow_imp.id(725966072267759691)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 23-APR-2003 17:15'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(57973882456510114)
,p_validation_name=>'P1311_PAGE_ID reserved'
,p_validation_sequence=>31
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.reserve_page (',
'    p_flow_id       => :FB_FLOW_ID,',
'    p_page_id       => :P1311_PAGE_ID,',
'    p_reuse         => TRUE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P1311_PAGE_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(725968532713759695)
,p_associated_item=>wwv_flow_imp.id(725966072267759691)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(57827744200033910)
,p_validation_name=>'P1311_ADMIN_PAGE_ID positive, whole number'
,p_validation_sequence=>41
,p_validation=>'P1311_ADMIN_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>'#LABEL# must be a positive, whole number.'
,p_validation_condition=>'P1311_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(725968532713759695)
,p_associated_item=>wwv_flow_imp.id(57946249248450723)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 23-APR-2003 17:15'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(57827833382033911)
,p_validation_name=>'P1311_ADMIN_PAGE_ID not null'
,p_validation_sequence=>51
,p_validation=>'P1311_ADMIN_PAGE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1311_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(725968532713759695)
,p_associated_item=>wwv_flow_imp.id(57946249248450723)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 23-APR-2003 17:15'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(57827968640033912)
,p_validation_name=>'P1311_ADMIN_PAGE_ID reserved'
,p_validation_sequence=>61
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.reserve_page (',
'    p_flow_id       => :FB_FLOW_ID,',
'    p_page_id       => :P1311_ADMIN_PAGE_ID,',
'    p_reuse         => TRUE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1311_ADMIN_PAGE_OPTION = ''NEW''',
'and :P1311_ADMIN_PAGE_ID is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(725968532713759695)
,p_associated_item=>wwv_flow_imp.id(57946249248450723)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(57974729385525116)
,p_validation_name=>'P1311_PAGE_ID and P1311_ADMIN_PAGE_ID different'
,p_validation_sequence=>71
,p_validation=>':P1311_PAGE_ID <> :P1311_ADMIN_PAGE_ID'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Starting Page Number and Administration Page Number must be different.'
,p_validation_condition=>'P1311_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(725968532713759695)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(57828044521033913)
,p_validation_name=>'P1311_ADMIN_PAGE_NAME not null'
,p_validation_sequence=>81
,p_validation=>'P1311_ADMIN_PAGE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1311_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(725968532713759695)
,p_associated_item=>wwv_flow_imp.id(57947137375450723)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 23-APR-2003 17:15'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(57828108676033914)
,p_validation_name=>'P1311_EXISTING_PAGE not null'
,p_validation_sequence=>91
,p_validation=>'P1311_EXISTING_PAGE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1311_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(725968532713759695)
,p_associated_item=>wwv_flow_imp.id(57947589907450724)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 23-APR-2003 17:15'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(235672067631481561)
,p_validation_name=>'P1311_EXISTING_PAGE available'
,p_validation_sequence=>101
,p_validation=>'return wwv_flow_wizard_api.page_exists( p_flow_id => :FB_FLOW_ID, p_page_id => :P1311_EXISTING_PAGE );'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'#LABEL# is not a page in the application.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1311_ADMIN_PAGE_OPTION = ''EXISTING''',
'and :P1311_EXISTING_PAGE is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(725968532713759695)
,p_associated_item=>wwv_flow_imp.id(57947589907450724)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(57828216769033915)
,p_validation_name=>'P1311_TAB_SET not null'
,p_validation_sequence=>111
,p_validation=>'P1311_TAB_SET'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1311_TAB_OPTIONS'
,p_validation_condition2=>'1:2'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_when_button_pressed=>wwv_flow_imp.id(725968532713759695)
,p_associated_item=>wwv_flow_imp.id(57949397235452061)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 23-APR-2003 17:15'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(57828353861033916)
,p_validation_name=>'P1311_TAB_LABEL not null'
,p_validation_sequence=>121
,p_validation=>'P1311_TAB_LABEL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1311_TAB_OPTIONS'
,p_validation_condition2=>'1'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(725968532713759695)
,p_associated_item=>wwv_flow_imp.id(57950200490452062)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 23-APR-2003 17:15'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(57828420931033917)
,p_validation_name=>'P1311_TAB_NAME not null'
,p_validation_sequence=>131
,p_validation=>'P1311_TAB_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1311_TAB_OPTIONS'
,p_validation_condition2=>'2'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(725968532713759695)
,p_associated_item=>wwv_flow_imp.id(57951181711452062)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 23-APR-2003 17:15'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(57828540910033918)
,p_validation_name=>'P1311_NAVLIST_ENTRY_NAME not null'
,p_validation_sequence=>151
,p_validation=>'P1311_NAVLIST_ENTRY_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1311_NAVLIST_OPTIONS'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(725968532713759695)
,p_associated_item=>wwv_flow_imp.id(57955509258453417)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 23-APR-2003 17:15'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(57981957151565841)
,p_validation_name=>'Existing Entry with no List'
,p_validation_sequence=>161
,p_validation=>'P1311_EXISTING_PARENT_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1311_NAVLIST_OPTIONS'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(725968532713759695)
,p_associated_item=>wwv_flow_imp.id(57958190651453419)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2949131665817531)
,p_validation_name=>'Navigation Menu not subscribed'
,p_validation_sequence=>171
,p_validation=>'coalesce(:P2500_IS_NAVLIST_SUBSCRIBED,''N'') != ''Y'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'&APP_TEXT$NAVIGATION_MENU_SUBSCRIBED!RAW.'
,p_validation_condition=>':P1311_NAVLIST_OPTIONS in ( ''NEW'', ''EXISTING'' ) and :P2500_NAVLIST_ID is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(57954288923453413)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(725970982994759701)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(725968183767759694)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(725971403928759701)
,p_event_id=>wwv_flow_imp.id(725970982994759701)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(57959165537463346)
,p_name=>'Show / Hide Admin Options'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1311_ADMIN_PAGE_OPTION'
,p_condition_element=>'P1311_ADMIN_PAGE_OPTION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(57959547648463347)
,p_event_id=>wwv_flow_imp.id(57959165537463346)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1311_ADMIN_PAGE_ID,P1311_ADMIN_PAGE_NAME,P1311_NAVLIST_OPTIONS,P1311_TAB_OPTIONS,P1311_AUTHORIZATION_SCHEME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(57961010285463348)
,p_event_id=>wwv_flow_imp.id(57959165537463346)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1311_EXISTING_PAGE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(57960044425463347)
,p_event_id=>wwv_flow_imp.id(57959165537463346)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1311_EXISTING_PAGE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(57960517728463347)
,p_event_id=>wwv_flow_imp.id(57959165537463346)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1311_ADMIN_PAGE_ID,P1311_ADMIN_PAGE_NAME,P1311_NAVLIST_OPTIONS,P1311_TAB_OPTIONS,P1311_AUTHORIZATION_SCHEME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3775766685742368429)
,p_event_id=>wwv_flow_imp.id(57959165537463346)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1311_TAB_OPTIONS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'0'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3775766770619368430)
,p_event_id=>wwv_flow_imp.id(57959165537463346)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1311_NAVLIST_OPTIONS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'NONE'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(57961477486465370)
,p_name=>'Set Tab and Nav List Names'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1311_ADMIN_PAGE_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(57961888433465371)
,p_event_id=>wwv_flow_imp.id(57961477486465370)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1311_NAVLIST_ENTRY_NAME,P1311_TAB_LABEL'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P1311_ADMIN_PAGE_NAME'
,p_attribute_07=>'P1311_ADMIN_PAGE_NAME'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(57962464171467502)
,p_name=>'Tab Option 0'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1311_TAB_OPTIONS'
,p_condition_element=>'P1311_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'0'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(57962803728467503)
,p_event_id=>wwv_flow_imp.id(57962464171467502)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1311_TAB_SET,P1311_TAB_LABEL,P1311_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3775768389108368446)
,p_event_id=>wwv_flow_imp.id(57962464171467502)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(175455016618021462)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(57963213460469214)
,p_name=>'Tab Option 1'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1311_TAB_OPTIONS'
,p_condition_element=>'P1311_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'1'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(57963682376469214)
,p_event_id=>wwv_flow_imp.id(57963213460469214)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1311_TAB_SET,P1311_TAB_LABEL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(57964108652469214)
,p_event_id=>wwv_flow_imp.id(57963213460469214)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1311_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3775768441731368447)
,p_event_id=>wwv_flow_imp.id(57963213460469214)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(175455016618021462)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(57964760647470703)
,p_name=>'Tab Option 2'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1311_TAB_OPTIONS'
,p_condition_element=>'P1311_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'2'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(57965145620470703)
,p_event_id=>wwv_flow_imp.id(57964760647470703)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1311_TAB_SET,P1311_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(57965637287470704)
,p_event_id=>wwv_flow_imp.id(57964760647470703)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1311_TAB_LABEL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3775768556655368448)
,p_event_id=>wwv_flow_imp.id(57964760647470703)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(175455016618021462)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(57966059286472616)
,p_name=>'New List'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1311_NAVLIST_OPTIONS'
,p_condition_element=>'P1311_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(57966430023472616)
,p_event_id=>wwv_flow_imp.id(57966059286472616)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1311_NAVLIST_ENTRY_NAME,P1311_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(57966976523472616)
,p_event_id=>wwv_flow_imp.id(57966059286472616)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1311_NAVLIST_ENTRY_NAME,P1311_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(57967375011474799)
,p_name=>'Existing List'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1311_NAVLIST_OPTIONS'
,p_condition_element=>'P1311_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'EXISTING'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(57967742665474800)
,p_event_id=>wwv_flow_imp.id(57967375011474799)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1311_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(57968220379474800)
,p_event_id=>wwv_flow_imp.id(57967375011474799)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1311_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(725970143592759700)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create configuration feature page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_admin_page wwv_flow_app_feature_v3.t_admin_page;',
'begin',
'    -- admin page',
'    l_admin_page.page_option                 := :P1311_ADMIN_PAGE_OPTION;',
'    l_admin_page.new_page_id                 := :P1311_ADMIN_PAGE_ID;',
'    l_admin_page.page_name                   := :P1311_ADMIN_PAGE_NAME;',
'    l_admin_page.existing_page_id            := :P1311_EXISTING_PAGE;',
'    -- tabs',
'    l_admin_page.tab_option                  := :P1311_TAB_OPTIONS;',
'    l_admin_page.tab_set                     := :P1311_TAB_SET;',
'    l_admin_page.tab_name                    := :P1311_TAB_NAME;',
'    l_admin_page.tab_text                    := :P1311_TAB_LABEL;',
'    -- nav list',
'    l_admin_page.nav_list_option             := :P1311_NAVLIST_OPTIONS;',
'    l_admin_page.nav_list_id                 := :P2500_NAVLIST_ID;',
'    l_admin_page.nav_list_new_parent_id      := :P1311_NEW_PARENT_ID;',
'    l_admin_page.nav_list_existing_parent_id := :P1311_EXISTING_PARENT_ID;',
'    l_admin_page.nav_list_entry_name         := :P1311_NAVLIST_ENTRY_NAME;',
'    ',
'    wwv_flow_app_feature_v3.add_feature_configuration(',
'        p_app_id                     => :FB_FLOW_ID,',
'        p_page_id                    => :P1311_PAGE_ID,',
'        p_page_name                  => :P1311_NAME,',
'        p_group_id                   => :P1311_GROUP_ID,',
'        p_auth_scheme_id             => :P1311_AUTHORIZATION_SCHEME,',
'        --',
'        p_admin_page                 => l_admin_page );',
'',
'    :FB_FLOW_PAGE_ID := wwv_flow_app_feature_v3.get_admin_page_id( p_admin_page => l_admin_page);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Login page created.'
,p_internal_uid=>725970143592759700
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(725970550953759700)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(725968532713759695)
,p_process_success_message=>'Feature page created.'
,p_internal_uid=>725970550953759700
);
end;
/
prompt --application/pages/page_01312
begin
wwv_flow_imp_page.create_page(
 p_id=>1312
,p_name=>'Create Theme Style Selection Page'
,p_alias=>'CREATE-THEME-STYLE-SELECTION-PAGE'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Theme Style Selection Page'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213425326892450628)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'sec_authentication.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(233497677400063868)
,p_plug_name=>'Create Tab'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>80
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P2500_NAVIGATION_TYPE'
,p_plug_display_when_cond2=>'L'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(233497088830063866)
,p_name=>'Tabs'
,p_parent_plug_id=>wwv_flow_imp.id(233497677400063868)
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<a title="click to set tab set" href="javascript:$x_Value(''''P1312_TAB_SET'''',''''''||',
'       wwv_flow_javascript.escape(tab_set)||',
'       '''''');">''||',
'       wwv_flow_escape.html(tab_set)||',
'       ''</a>'' tab_set, ',
'       tab_step, ',
'       substr(tab_text,1,30) tab_text,',
'       replace(TAB_ALSO_CURRENT_FOR_PAGES,'','','', '') tacfp',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID and ',
'       security_group_id = :flow_security_group_id',
'order  by tab_set, TAB_SEQUENCE, tab_step'))
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>'No tabs or tab sets exist.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(58047447581042409)
,p_query_column_id=>1
,p_column_alias=>'TAB_SET'
,p_column_display_sequence=>1
,p_column_heading=>'Tab Set'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(58046201219042408)
,p_query_column_id=>2
,p_column_alias=>'TAB_STEP'
,p_column_display_sequence=>2
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(58046652869042408)
,p_query_column_id=>3
,p_column_alias=>'TAB_TEXT'
,p_column_display_sequence=>3
,p_column_heading=>'Tab'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(58047025837042408)
,p_query_column_id=>4
,p_column_alias=>'TACFP'
,p_column_display_sequence=>4
,p_column_heading=>'Also&nbsp;Current&nbsp;For'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1153341591174422866)
,p_plug_name=>'Create List Entry'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>90
,p_translate_title=>'N'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P2500_NAVIGATION_TYPE'
,p_plug_display_when_cond2=>'L'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2212130901624527116)
,p_plug_name=>'Create Theme Style Page'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_plug_header=>'Enables administrators to select a default color scheme (theme style) for the application. Administrators can also choose to allow end users to choose their own theme style. End users can simply click on the Customize button at the bottom of the home'
||' page, and select from the available theme styles. For example, users with visual impairment may prefer to utilize the Vista theme style which has a much higher color contrast.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2223783386516704343)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3891751001453859884)
,p_plug_name=>'Admin Options'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(727283456825969155)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2223783386516704343)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(727283838280969156)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(2223783386516704343)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(727284206876969156)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(2223783386516704343)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(727287216593969161)
,p_branch_action=>'f?p=&FLOW_ID.:4500:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(727283456825969155)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(727288010733969161)
,p_branch_name=>'Go To Page 2500'
,p_branch_action=>'f?p=&APP_ID.:2500:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(727284206876969156)
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(58037866782038434)
,p_name=>'P1312_GROUP_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2212130901624527116)
,p_prompt=>'Page Group'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE_GROUPS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d,',
'       id r',
'  from wwv_flow_page_groups',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
' order by upper(group_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Page Group -'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the name of the page group to associate with this page. Page groups help developers manage the pages within an application. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(58039702853040742)
,p_name=>'P1312_ADMIN_PAGE_OPTION'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3891751001453859884)
,p_item_default=>'EXISTING'
,p_prompt=>'Administration Page Preference'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.ADMINPAGE.OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(31963614629360602)||'.'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the administration page, that a list is added to, for this feature.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(58040195920040742)
,p_name=>'P1312_ADMIN_PAGE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3891751001453859884)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.get_maximum_free_admin_page(:FB_FLOW_ID);',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Administration Page Number'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter an unused page number for the administration page.</p>',
'<p>The default is calculated as the first available page number that is divisible by 100, which is greater than the maximum page number within this application.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(58041087428040747)
,p_name=>'P1312_ADMIN_PAGE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3891751001453859884)
,p_item_default=>'wwv_flow_lang.system_message(''CA.ADMIN.ADMINISTRATION'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Administration Page Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a name for the administration page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(58041423801040747)
,p_name=>'P1312_EXISTING_PAGE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(3891751001453859884)
,p_prompt=>'Existing Administration Page'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d',
'  from wwv_flow_steps',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and is_page_pattern   = ''N''',
'order by 2'))
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select an existing page used as the administration page in this application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(58042379158042405)
,p_name=>'P1312_TAB_OPTIONS'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(233497677400063868)
,p_item_default=>'0'
,p_prompt=>'Administration Page<br>Tab Options:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.TAB.OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(35310611267199336)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Specify whether the administration page should be included in tabs.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(58043207170042406)
,p_name=>'P1312_TAB_SET'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(233497677400063868)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   t varchar2(4000);',
'begin',
'   for c1 in (',
'select tab_set, count(*) c',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID and ',
'       security_group_id = :flow_security_group_id',
'group  by tab_set',
'order by 2 desc) loop',
'return c1.tab_set;',
'exit;',
'end loop;',
'return null;',
'end;',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Tab Set'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_TABSETS'
,p_lov=>'select wwv_flow_escape.html(d) d, r from wwv_flow_tabset_view'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Tab Set -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Select the tab set you wish to use for this page.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(58044132387042406)
,p_name=>'P1312_TAB_LABEL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(233497677400063868)
,p_prompt=>'New Tab Label'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the label for the tab that will be created. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(58045087574042407)
,p_name=>'P1312_TAB_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(233497677400063868)
,p_prompt=>'Use Tab'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(TAB_NAME)||'': label="''||wwv_flow_escape.html(substr(TAB_TEXT,1,40))||''"'' tab_text,tab_name',
'from   wwv_flow_tabs',
'where  flow_id = :fb_flow_id and',
'       security_group_id = :flow_security_group_id and',
'       tab_set = :P1312_TAB_SET'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Tab -'
,p_lov_cascade_parent_items=>'P1312_TAB_SET'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Select the tab to be designated as "current" for this page.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(58048125152043535)
,p_name=>'P1312_NAVLIST_OPTIONS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1153341591174422866)
,p_item_default=>'NONE'
,p_prompt=>'Administration Page<br> Navigation Preference'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.NAVIGATIONLIST.OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(925221062390507339)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select how you want this page integrated into the Navigation Menu.<p/>',
'<ul>',
'    <li><strong>Do not associate this page with a Navigation Menu entry</strong> - The new page will not be current or highlighted for any menu entry.</li>',
'    <li><strong>Create a new Navigation Menu entry</strong> - Users will be able to navigate to the new page directly from the Navigation Menu. The new entry can be placed anywhere in the existing hierarchy.</li>',
'    <li><strong>Identify an existing Navigation Menu entry which will be current for this page</strong> - Use this option when you want the new page to highlight an existing, top level, menu entry. Users will not be able to navigate to the new page d'
||'irectly from the Navigation Menu. Therefore, You will need to create or define a navigation control on the top level page selected, such as a button, or link in a report, to go to this new page.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(58049449811043536)
,p_name=>'P1312_NAVLIST_ENTRY_NAME'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_imp.id(1153341591174422866)
,p_prompt=>'New Navigation Menu Entry'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Enter a name for the new menu control.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(58050368217043540)
,p_name=>'P1312_NAVLIST_PARENT_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1153341591174422866)
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select a navigation parent for your new page. When creating a new navigation item, the new item links to',
'the new page. The new item can be added at the top level, by not selecting any parent item, or shown as a child',
'of an existing item. </p>',
'',
'<p>When selecting item without creating a new item, the selected item determines which top level item is shown',
'as the "current" item.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(58051218725043541)
,p_name=>'P1312_NEW_PARENT_ID'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_imp.id(1153341591174422866)
,p_prompt=>'Parent Navigation Menu Entry'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'NAVLIST_ENTRIES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case',
'           when (nvl(list_item_link_target,''0'')=''0'' or parent_list_item_id is',
'null) then',
'               lpad('' '',(4*(level-1)),''.'')||list_item_link_text',
'           else',
'               lpad('' '',(4*(level-1)),''.'')||'' (''||list_item_link_text ||'')''',
'       end name,',
'       id',
'  from wwv_flow_list_items',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and sub_list_id is null',
' start with list_id = :P2500_NAVLIST_ID and parent_list_item_id is null',
'connect by prior list_id = list_id and prior id = parent_list_item_id',
' order siblings by list_item_display_sequence'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No parent selected - '
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select an existing menu control if you wish to add a menu entry for the new page to this menu control. ',
'When not selecting an existing menu control, a menu control for the new page will be created at the to level.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(58052146949043542)
,p_name=>'P1312_EXISTING_PARENT_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(1153341591174422866)
,p_prompt=>'Existing Navigation Menu Entry'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'NAVLIST_ENTRIES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case',
'           when (nvl(list_item_link_target,''0'')=''0'' or parent_list_item_id is',
'null) then',
'               lpad('' '',(4*(level-1)),''.'')||list_item_link_text',
'           else',
'               lpad('' '',(4*(level-1)),''.'')||'' (''||list_item_link_text ||'')''',
'       end name,',
'       id',
'  from wwv_flow_list_items',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and sub_list_id is null',
' start with list_id = :P2500_NAVLIST_ID and parent_list_item_id is null',
'connect by prior list_id = list_id and prior id = parent_list_item_id',
' order siblings by list_item_display_sequence'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Select an existing menu control to be shown as the active menu control when rendering the new page. ',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(130095148505362875)
,p_name=>'P1312_AUTHORIZATION_SCHEME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(3891751001453859884)
,p_prompt=>'Authorization Scheme'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REQUIRED_ROLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.d, a.r from (',
'    select wwv_flow_lang.system_message(''MUST_NOT_BE_PUBLIC_USER'') d,''MUST_NOT_BE_PUBLIC_USER'' r, 1',
'      from sys.dual',
'    union all',
'    select wwv_flow_escape.html(substr(name,1,50)),to_char(id), 1',
'      from wwv_flow_security_schemes',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID',
'    union all',
'    select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'',wwv_flow_escape.html(substr(name,1,50)))||''}'' d, ''!''||to_char(id) r, 2',
'      from wwv_flow_security_schemes',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID',
'    order by 3,1) a'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- None -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the authorization scheme used to limit access to the Administration page and the page for this feature.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(183321432256945121)
,p_name=>'P1312_BUILD_OPTION'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(2212130901624527116)
,p_prompt=>'Build Option'
,p_source=>'wwv_flow_lang.system_message(''FEATURE'')||'': ''||wwv_flow_lang.system_message(''FEATURE.THEME_STYLE_SELECTION'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The listed build option(s) will be created to support this feature.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(727281388437969153)
,p_name=>'P1312_PAGE_ID'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2212130901624527116)
,p_use_cache_before_default=>'NO'
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.get_maximum_free_page(:FB_FLOW_ID);',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Page Number'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>10
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter an unused starting page number.</p>',
'<p>The default is calculated as the first available page number that is divisible by 10, which is greater than the maximum page number within this application.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(727282298700969154)
,p_name=>'P1312_NAME'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2212130901624527116)
,p_item_default=>'wwv_flow_lang.system_message(''APEX.PAGE_NAME.THEME_STYLE_SELECTION'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter a name for the feature page.',
' ',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(727284779158969158)
,p_computation_sequence=>20
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.get_current_theme_id (',
'    p_application_id    => :FB_FLOW_ID )'))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(727285131292969158)
,p_validation_name=>'P1312_PAGE_ID positive, whole number'
,p_validation_sequence=>1
,p_validation=>'P1312_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>'#LABEL# must be a positive, whole number.'
,p_when_button_pressed=>wwv_flow_imp.id(727283838280969156)
,p_associated_item=>wwv_flow_imp.id(727281388437969153)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 23-APR-2003 17:15'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(58077174040062073)
,p_validation_name=>'P1312_PAGE_ID reserved'
,p_validation_sequence=>21
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.reserve_page (',
'    p_flow_id       => :FB_FLOW_ID,',
'    p_page_id       => :P1312_PAGE_ID,',
'    p_reuse         => TRUE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P1312_PAGE_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(727283838280969156)
,p_associated_item=>wwv_flow_imp.id(727281388437969153)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(57829615819033929)
,p_validation_name=>'P1312_ADMIN_PAGE_ID positive, whole number'
,p_validation_sequence=>41
,p_validation=>'P1312_ADMIN_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>'#LABEL# must be a positive, whole number.'
,p_validation_condition=>'P1312_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(727283838280969156)
,p_associated_item=>wwv_flow_imp.id(58040195920040742)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 23-APR-2003 17:15'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(57829895326033931)
,p_validation_name=>'P1312_ADMIN_PAGE_ID not null'
,p_validation_sequence=>51
,p_validation=>'P1312_ADMIN_PAGE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1312_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(727283838280969156)
,p_associated_item=>wwv_flow_imp.id(58040195920040742)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(57829736831033930)
,p_validation_name=>'P1312_ADMIN_PAGE_ID reserved'
,p_validation_sequence=>71
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.reserve_page (',
'    p_flow_id       => :FB_FLOW_ID,',
'    p_page_id       => :P1312_ADMIN_PAGE_ID,',
'    p_reuse         => TRUE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1312_ADMIN_PAGE_OPTION = ''NEW''',
'and :P1312_ADMIN_PAGE_ID is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(727283838280969156)
,p_associated_item=>wwv_flow_imp.id(58040195920040742)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(58077451901064593)
,p_validation_name=>'P1312_PAGE_ID and P1312_ADMIN_PAGE_ID different'
,p_validation_sequence=>81
,p_validation=>':P1312_PAGE_ID <> :P1312_ADMIN_PAGE_ID'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Page Number and Administration Page Number must be different.'
,p_validation_condition=>'P1312_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(727283838280969156)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(290807415682640034)
,p_validation_name=>'P1312_ADMIN_PAGE_NAME not null'
,p_validation_sequence=>91
,p_validation=>'P1312_ADMIN_PAGE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1312_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(727283838280969156)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(57829963157033932)
,p_validation_name=>'P1312_EXISTING_PAGE not null'
,p_validation_sequence=>101
,p_validation=>'P1312_EXISTING_PAGE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1312_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(727283838280969156)
,p_associated_item=>wwv_flow_imp.id(58041423801040747)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(235674976042492981)
,p_validation_name=>'P1312_EXISTING_PAGE available'
,p_validation_sequence=>111
,p_validation=>'return wwv_flow_wizard_api.page_exists( p_flow_id => :FB_FLOW_ID, p_page_id => :P1312_EXISTING_PAGE );'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'#LABEL# is not a page in the application.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1312_ADMIN_PAGE_OPTION = ''EXISTING''',
'and :P1312_EXISTING_PAGE is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(727283838280969156)
,p_associated_item=>wwv_flow_imp.id(58041423801040747)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(57830063242033933)
,p_validation_name=>'P1312_TAB_SET not null'
,p_validation_sequence=>121
,p_validation=>'P1312_TAB_SET'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1312_TAB_OPTIONS'
,p_validation_condition2=>'1:2'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_when_button_pressed=>wwv_flow_imp.id(727283838280969156)
,p_associated_item=>wwv_flow_imp.id(58043207170042406)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(57830115124033934)
,p_validation_name=>'P1312_TAB_LABEL not null'
,p_validation_sequence=>131
,p_validation=>'P1312_TAB_LABEL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1312_TAB_OPTIONS'
,p_validation_condition2=>'1'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(727283838280969156)
,p_associated_item=>wwv_flow_imp.id(58044132387042406)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(57830213244033935)
,p_validation_name=>'P1312_TAB_NAME not null'
,p_validation_sequence=>141
,p_validation=>'P1312_TAB_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1312_TAB_OPTIONS'
,p_validation_condition2=>'2'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(727283838280969156)
,p_associated_item=>wwv_flow_imp.id(58045087574042407)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(57830314642033936)
,p_validation_name=>'P1312_NAVLIST_ENTRY_NAME not null'
,p_validation_sequence=>161
,p_validation=>'P1312_NAVLIST_ENTRY_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1312_NAVLIST_OPTIONS'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(727283838280969156)
,p_associated_item=>wwv_flow_imp.id(58049449811043536)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(58078082658067939)
,p_validation_name=>'Existing Entry with no List'
,p_validation_sequence=>171
,p_validation=>'P1312_EXISTING_PARENT_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1312_NAVLIST_OPTIONS'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(727283838280969156)
,p_associated_item=>wwv_flow_imp.id(58052146949043542)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2949416525826840)
,p_validation_name=>'Navigation Menu not subscribed'
,p_validation_sequence=>181
,p_validation=>'coalesce(:P2500_IS_NAVLIST_SUBSCRIBED,''N'') != ''Y'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'&APP_TEXT$NAVIGATION_MENU_SUBSCRIBED!RAW.'
,p_validation_condition=>':P1312_NAVLIST_OPTIONS in ( ''NEW'', ''EXISTING'' ) and :P2500_NAVLIST_ID is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(58048125152043535)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(727286261525969160)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(727283456825969155)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(727286759939969160)
,p_event_id=>wwv_flow_imp.id(727286261525969160)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(58053517721048933)
,p_name=>'Show / Hide Admin Options'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1312_ADMIN_PAGE_OPTION'
,p_condition_element=>'P1312_ADMIN_PAGE_OPTION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(58053958404048933)
,p_event_id=>wwv_flow_imp.id(58053517721048933)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1312_ADMIN_PAGE_ID,P1312_ADMIN_PAGE_NAME,P1312_NAVLIST_OPTIONS,P1312_TAB_OPTIONS,P1312_AUTHORIZATION_SCHEME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(58055423042048934)
,p_event_id=>wwv_flow_imp.id(58053517721048933)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1312_EXISTING_PAGE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(58054460362048934)
,p_event_id=>wwv_flow_imp.id(58053517721048933)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1312_EXISTING_PAGE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(58054975835048934)
,p_event_id=>wwv_flow_imp.id(58053517721048933)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1312_ADMIN_PAGE_ID,P1312_ADMIN_PAGE_NAME,P1312_NAVLIST_OPTIONS,P1312_TAB_OPTIONS,P1312_AUTHORIZATION_SCHEME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(57830565327033938)
,p_event_id=>wwv_flow_imp.id(58053517721048933)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1312_TAB_OPTIONS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'0'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(57830488084033937)
,p_event_id=>wwv_flow_imp.id(58053517721048933)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1312_NAVLIST_OPTIONS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'NONE'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(58069687584050435)
,p_name=>'Set Tab and Nav List Names'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1312_ADMIN_PAGE_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(58070004902050436)
,p_event_id=>wwv_flow_imp.id(58069687584050435)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1312_NAVLIST_ENTRY_NAME,P1312_TAB_LABEL'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P1312_ADMIN_PAGE_NAME'
,p_attribute_07=>'P1312_ADMIN_PAGE_NAME'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(58070879694052138)
,p_name=>'Tab Option 0'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1312_TAB_OPTIONS'
,p_condition_element=>'P1312_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'0'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(58071255668052138)
,p_event_id=>wwv_flow_imp.id(58070879694052138)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1312_TAB_SET,P1312_TAB_LABEL,P1312_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3775768048691368443)
,p_event_id=>wwv_flow_imp.id(58070879694052138)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(233497088830063866)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(58071675265053432)
,p_name=>'Tab Option 1'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1312_TAB_OPTIONS'
,p_condition_element=>'P1312_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'1'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(58072090847053432)
,p_event_id=>wwv_flow_imp.id(58071675265053432)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1312_TAB_SET,P1312_TAB_LABEL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(58072531177053432)
,p_event_id=>wwv_flow_imp.id(58071675265053432)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1312_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3775768148485368444)
,p_event_id=>wwv_flow_imp.id(58071675265053432)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(233497088830063866)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(58072919646054904)
,p_name=>'Tab Option 2'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1312_TAB_OPTIONS'
,p_condition_element=>'P1312_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'2'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(58073384604054905)
,p_event_id=>wwv_flow_imp.id(58072919646054904)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1312_TAB_SET,P1312_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(58073855254054905)
,p_event_id=>wwv_flow_imp.id(58072919646054904)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1312_TAB_LABEL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3775768205215368445)
,p_event_id=>wwv_flow_imp.id(58072919646054904)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(233497088830063866)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(58074328977056549)
,p_name=>'New List'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1312_NAVLIST_OPTIONS'
,p_condition_element=>'P1312_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(58074761708056549)
,p_event_id=>wwv_flow_imp.id(58074328977056549)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1312_NAVLIST_ENTRY_NAME,P1312_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(58075289656056552)
,p_event_id=>wwv_flow_imp.id(58074328977056549)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1312_NAVLIST_ENTRY_NAME,P1312_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(58075705488057960)
,p_name=>'Existing List'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1312_NAVLIST_OPTIONS'
,p_condition_element=>'P1312_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'EXISTING'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(58076113928057960)
,p_event_id=>wwv_flow_imp.id(58075705488057960)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1312_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(58076642967057960)
,p_event_id=>wwv_flow_imp.id(58075705488057960)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1312_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(727285430453969159)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create theme style feature page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_admin_page wwv_flow_app_feature_v3.t_admin_page;',
'begin',
'    -- admin page',
'    l_admin_page.page_option                 := :P1312_ADMIN_PAGE_OPTION;',
'    l_admin_page.new_page_id                 := :P1312_ADMIN_PAGE_ID;',
'    l_admin_page.page_name                   := :P1312_ADMIN_PAGE_NAME;',
'    l_admin_page.existing_page_id            := :P1312_EXISTING_PAGE;',
'    -- tabs',
'    l_admin_page.tab_option                  := :P1312_TAB_OPTIONS;',
'    l_admin_page.tab_set                     := :P1312_TAB_SET;',
'    l_admin_page.tab_name                    := :P1312_TAB_NAME;',
'    l_admin_page.tab_text                    := :P1312_TAB_LABEL;',
'    -- nav list',
'    l_admin_page.nav_list_option             := :P1312_NAVLIST_OPTIONS;',
'    l_admin_page.nav_list_id                 := :P2500_NAVLIST_ID;',
'    l_admin_page.nav_list_new_parent_id      := :P1312_NEW_PARENT_ID;',
'    l_admin_page.nav_list_existing_parent_id := :P1312_EXISTING_PARENT_ID;',
'    l_admin_page.nav_list_entry_name         := :P1312_NAVLIST_ENTRY_NAME;',
'    ',
'    wwv_flow_app_feature_v3.add_feature_theme_style(',
'        p_app_id                     => :FB_FLOW_ID,',
'        p_page_id                    => :P1312_PAGE_ID,',
'        p_page_name                  => :P1312_NAME,',
'        p_group_id                   => :P1312_GROUP_ID,',
'        p_auth_scheme_id             => :P1312_AUTHORIZATION_SCHEME,',
'        --',
'        p_admin_page                 => l_admin_page );',
'',
'    :FB_FLOW_PAGE_ID := wwv_flow_app_feature_v3.get_admin_page_id( p_admin_page => l_admin_page);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Login page created.'
,p_internal_uid=>727285430453969159
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(727285898477969159)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Feature page created.'
,p_internal_uid=>727285898477969159
);
end;
/
prompt --application/pages/page_01313
begin
wwv_flow_imp_page.create_page(
 p_id=>1313
,p_name=>'Create About Page'
,p_alias=>'CREATE-ABOUT-PAGE'
,p_page_mode=>'MODAL'
,p_step_title=>'Create About Page'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213425326892450628)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'sec_authentication.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2939575574725549837)
,p_plug_name=>'Create About Page'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_plug_header=>'Include an about this application page which features a description of the application, the application version, and a page count.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2951228059617727064)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(727447497665022723)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2951228059617727064)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(727447816157022725)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(2951228059617727064)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(727448206474022725)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(2951228059617727064)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(727451628069022728)
,p_branch_action=>'f?p=&FLOW_ID.:4500:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(727447816157022725)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(727451251429022728)
,p_branch_action=>'f?p=&FLOW_ID.:4500:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(727447497665022723)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(727452093442022728)
,p_branch_name=>'Go To Page 2500'
,p_branch_action=>'f?p=&APP_ID.:2500:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(727448206474022725)
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57831086038033943)
,p_name=>'P1313_BUILD_OPTION'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_imp.id(2939575574725549837)
,p_prompt=>'Build Option'
,p_source=>'wwv_flow_lang.system_message(''FEATURE'')||'': ''||wwv_flow_lang.system_message(''FEATURE.ABOUT_PAGE'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The listed build option(s) will be created to support this feature.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(58029539721963290)
,p_name=>'P1313_NAV_BAR_ENTRY'
,p_item_sequence=>55
,p_item_plug_id=>wwv_flow_imp.id(2939575574725549837)
,p_prompt=>'Navigation Bar Label'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the name of the new navigation bar entry used to access the new about page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(58030363964966516)
,p_name=>'P1313_PAGE_GROUP'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_imp.id(2939575574725549837)
,p_prompt=>'Page Group'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE_GROUPS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d,',
'       id r',
'  from wwv_flow_page_groups',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
' order by upper(group_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Page Group -'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the name of the page group to associate with this page. Page groups help developers manage the pages within an application. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(688504922919608707)
,p_name=>'P1313_INCLUDE_NAV_BAR'
,p_is_required=>true
,p_item_sequence=>45
,p_item_plug_id=>wwv_flow_imp.id(2939575574725549837)
,p_item_default=>'Y'
,p_prompt=>'Include in Navigation Bar?'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select <strong>On</strong> to create a navigation bar entry within the current application to invoke your new about page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(727445370563022722)
,p_name=>'P1313_PAGE_ID'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2939575574725549837)
,p_use_cache_before_default=>'NO'
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.get_maximum_free_page(:FB_FLOW_ID);',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Page Number'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>10
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter an unused starting page number.</p>',
'<p>The default is calculated as the first available page number that is divisible by 10, which is greater than the maximum page number within this application.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(727446261435022722)
,p_name=>'P1313_NAME'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2939575574725549837)
,p_item_default=>'wwv_flow_lang.system_message(''APEX.PAGE_NAME.ABOUT_THIS_APP'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Page Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify a name for the page.',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(727448708057022725)
,p_computation_sequence=>20
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.get_current_theme_id (',
'    p_application_id    => :FB_FLOW_ID )'))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(727449147120022726)
,p_validation_name=>'P1313_PAGE_ID positive, whole number'
,p_validation_sequence=>20
,p_validation=>'P1313_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>'#LABEL# must be a positive, whole number.'
,p_when_button_pressed=>wwv_flow_imp.id(727447816157022725)
,p_associated_item=>wwv_flow_imp.id(727445370563022722)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 23-APR-2003 17:15'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(42006414364842992)
,p_validation_name=>'P1313_PAGE_ID reserved'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.reserve_page (',
'    p_flow_id       => :FB_FLOW_ID,',
'    p_page_id       => :P1313_PAGE_ID,',
'    p_reuse         => TRUE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P1313_PAGE_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(727447816157022725)
,p_associated_item=>wwv_flow_imp.id(727445370563022722)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(727450286164022727)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(727447497665022723)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(727450704769022727)
,p_event_id=>wwv_flow_imp.id(727450286164022727)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3775766195821368424)
,p_name=>'Show / Hide Nav Bar Entry'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1313_INCLUDE_NAV_BAR'
,p_condition_element=>'P1313_INCLUDE_NAV_BAR'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3775766231701368425)
,p_event_id=>wwv_flow_imp.id(3775766195821368424)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1313_NAV_BAR_ENTRY'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3775766348795368426)
,p_event_id=>wwv_flow_imp.id(3775766195821368424)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1313_NAV_BAR_ENTRY'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3775766457731368427)
,p_name=>'Set Nav Bar Entry'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1313_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3775766594596368428)
,p_event_id=>wwv_flow_imp.id(3775766457731368427)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1313_NAV_BAR_ENTRY'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P1313_NAME'
,p_attribute_07=>'P1313_NAME'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(727449482983022726)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_app_feature_v3.add_feature_about_page(',
'    p_app_id                   => :FB_FLOW_ID,',
'    p_page_id                  => :P1313_PAGE_ID,',
'    p_name                     => :P1313_NAME,',
'    p_group_id                 => :P1313_PAGE_GROUP,',
'    --',
'    p_create_nav_bar_entry     => ( :P1313_INCLUDE_NAV_BAR = ''Y'' ),',
'    p_nav_bar_entry_label      => :P1313_NAV_BAR_ENTRY );',
'    ',
':FB_FLOW_PAGE_ID       := :P1313_PAGE_ID;',
':F4000_RUN_EDIT_PAGE   := :P1313_PAGE_ID;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Page &P1313_PAGE_ID. created.'
,p_internal_uid=>727449482983022726
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(727449812755022726)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Feature page created.'
,p_internal_uid=>727449812755022726
);
end;
/
prompt --application/pages/page_01314
begin
wwv_flow_imp_page.create_page(
 p_id=>1314
,p_name=>'Create Email Reporting Page'
,p_alias=>'CREATE-EMAIL-REPORTING-PAGE'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Email Reporting Page'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213425326892450628)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'sec_authentication.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(214194682349417261)
,p_plug_name=>'Create Tab'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>30
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P2500_NAVIGATION_TYPE'
,p_plug_display_when_cond2=>'L'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(214194093779417259)
,p_name=>'Tabs'
,p_parent_plug_id=>wwv_flow_imp.id(214194682349417261)
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<a title="click to set tab set" href="javascript:$x_Value(''''P1314_TAB_SET'''',''''''||',
'       wwv_flow_javascript.escape(tab_set)||',
'       '''''');">''||',
'       wwv_flow_escape.html(tab_set)||',
'       ''</a>'' tab_set, ',
'       tab_step, ',
'       substr(tab_text,1,30) tab_text,',
'       replace(TAB_ALSO_CURRENT_FOR_PAGES,'','','', '') tacfp',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID and ',
'       security_group_id = :flow_security_group_id',
'order  by tab_set, TAB_SEQUENCE, tab_step'))
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>'No tabs or tab sets exist.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(96699085843847887)
,p_query_column_id=>1
,p_column_alias=>'TAB_SET'
,p_column_display_sequence=>1
,p_column_heading=>'Tab Set'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(96697831897847886)
,p_query_column_id=>2
,p_column_alias=>'TAB_STEP'
,p_column_display_sequence=>2
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(96698274674847886)
,p_query_column_id=>3
,p_column_alias=>'TAB_TEXT'
,p_column_display_sequence=>3
,p_column_heading=>'Tab'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(96698652798847886)
,p_query_column_id=>4
,p_column_alias=>'TACFP'
,p_column_display_sequence=>4
,p_column_heading=>'Also&nbsp;Current&nbsp;For'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(855572135817646137)
,p_plug_name=>'Create Email Reporting Page'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_plug_header=>'Include numerous reports on emails queued from this application, emails sent, and errors sending emails.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(867224620709823364)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1134027105397773773)
,p_plug_name=>'Create List Entry'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>40
,p_translate_title=>'N'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P2500_NAVIGATION_TYPE'
,p_plug_display_when_cond2=>'L'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3872453232608216277)
,p_plug_name=>'Admin Options'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(96692407707847877)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(867224620709823364)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(96692887646847878)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(867224620709823364)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(96693205214847879)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(867224620709823364)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(96723627959847908)
,p_branch_action=>'f?p=&FLOW_ID.:4500:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(96692407707847877)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(96724051314847908)
,p_branch_name=>'Go To Page 2500'
,p_branch_action=>'f?p=&APP_ID.:2500:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(96693205214847879)
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(96687930854847870)
,p_name=>'P1314_ADMIN_PAGE_OPTION'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3872453232608216277)
,p_item_default=>'EXISTING'
,p_prompt=>'Administration Page Preference'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.ADMINPAGE.OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(31963614629360602)||'.'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the administration page, that a list is added to, for this feature.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(96688364159847871)
,p_name=>'P1314_ADMIN_PAGE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3872453232608216277)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.get_maximum_free_admin_page(:FB_FLOW_ID);',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Administration Page Number'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter an unused page number for the administration page.</p>',
'<p>The default is calculated as the first available page number that is divisible by 100, which is greater than the maximum page number within this application.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(96689210952847872)
,p_name=>'P1314_ADMIN_PAGE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3872453232608216277)
,p_item_default=>'wwv_flow_lang.system_message(''CA.ADMIN.ADMINISTRATION'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Administration Page Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a name for the administration page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(96689608753847872)
,p_name=>'P1314_EXISTING_PAGE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(3872453232608216277)
,p_prompt=>'Existing Administration Page'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d',
'  from wwv_flow_steps',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and is_page_pattern   = ''N''',
'order by 2'))
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select an existing page used as the administration page in this application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(96690396693847876)
,p_name=>'P1314_PAGE_ID'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(855572135817646137)
,p_use_cache_before_default=>'NO'
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.get_maximum_free_page(:FB_FLOW_ID);',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Page Number'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>10
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter an unused page number.</p>',
'<p>The default is calculated as the first available page number that is divisible by 10, which is greater than the maximum page number within this application.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(96691214064847876)
,p_name=>'P1314_GROUP_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(855572135817646137)
,p_prompt=>'Page Group'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE_GROUPS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d,',
'       id r',
'  from wwv_flow_page_groups',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
' order by upper(group_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Page Group -'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the name of the page group to associate with this page. Page groups help developers manage the pages within an application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(96693976141847880)
,p_name=>'P1314_TAB_OPTIONS'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(214194682349417261)
,p_item_default=>'0'
,p_prompt=>'Administration Page<br>Tab Options:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.TAB.OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(35310611267199336)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Specify whether the administration page should be included in tabs.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(96694800011847880)
,p_name=>'P1314_TAB_SET'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(214194682349417261)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   t varchar2(4000);',
'begin',
'   for c1 in (',
'select tab_set, count(*) c',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID and ',
'       security_group_id = :flow_security_group_id',
'group  by tab_set',
'order by 2 desc) loop',
'return c1.tab_set;',
'exit;',
'end loop;',
'return null;',
'end;',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Tab Set'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_TABSETS'
,p_lov=>'select wwv_flow_escape.html(d) d, r from wwv_flow_tabset_view'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Tab Set -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Select the tab set you wish to use for this page.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(96695721325847881)
,p_name=>'P1314_TAB_LABEL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(214194682349417261)
,p_prompt=>'New Tab Label'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the label for the tab that will be created. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(96696692489847882)
,p_name=>'P1314_TAB_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(214194682349417261)
,p_prompt=>'Use Tab'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(TAB_NAME)||'': label="''||wwv_flow_escape.html(substr(TAB_TEXT,1,40))||''"'' tab_text,tab_name',
'from   wwv_flow_tabs',
'where  flow_id = :fb_flow_id and',
'       security_group_id = :flow_security_group_id and',
'       tab_set = :P1314_TAB_SET'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Tab -'
,p_lov_cascade_parent_items=>'P1314_TAB_SET'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Select the tab to be designated as "current" for this page.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(96699730934847887)
,p_name=>'P1314_NAVLIST_OPTIONS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1134027105397773773)
,p_item_default=>'NONE'
,p_prompt=>'Administration Page<br> Navigation Preference'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.NAVIGATIONLIST.OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(925221062390507339)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select how you want this page integrated into the Navigation Menu.<p/>',
'<ul>',
'    <li><strong>Do not associate this page with a Navigation Menu entry</strong> - The new page will not be current or highlighted for any menu entry.</li>',
'    <li><strong>Create a new Navigation Menu entry</strong> - Users will be able to navigate to the new page directly from the Navigation Menu. The new entry can be placed anywhere in the existing hierarchy.</li>',
'    <li><strong>Identify an existing Navigation Menu entry which will be current for this page</strong> - Use this option when you want the new page to highlight an existing, top level, menu entry. Users will not be able to navigate to the new page d'
||'irectly from the Navigation Menu. Therefore, You will need to create or define a navigation control on the top level page selected, such as a button, or link in a report, to go to this new page.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(96701089663847888)
,p_name=>'P1314_NAVLIST_ENTRY_NAME'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_imp.id(1134027105397773773)
,p_prompt=>'New Navigation Menu Entry'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Enter a name for the new menu control.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(96701954235847889)
,p_name=>'P1314_NAVLIST_PARENT_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1134027105397773773)
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select a navigation parent for your new page. When creating a new navigation item, the new item links to',
'the new page. The new item can be added at the top level, by not selecting any parent item, or shown as a child',
'of an existing item. </p>',
'',
'<p>When selecting item without creating a new item, the selected item determines which top level item is shown',
'as the "current" item.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(96702877554847889)
,p_name=>'P1314_NEW_PARENT_ID'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_imp.id(1134027105397773773)
,p_prompt=>'Parent Navigation Menu Entry'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'NAVLIST_ENTRIES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case',
'           when (nvl(list_item_link_target,''0'')=''0'' or parent_list_item_id is',
'null) then',
'               lpad('' '',(4*(level-1)),''.'')||list_item_link_text',
'           else',
'               lpad('' '',(4*(level-1)),''.'')||'' (''||list_item_link_text ||'')''',
'       end name,',
'       id',
'  from wwv_flow_list_items',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and sub_list_id is null',
' start with list_id = :P2500_NAVLIST_ID and parent_list_item_id is null',
'connect by prior list_id = list_id and prior id = parent_list_item_id',
' order siblings by list_item_display_sequence'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No parent selected - '
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select an existing menu control if you wish to add a menu entry for the new page to this menu control. ',
'When not selecting an existing menu control, a menu control for the new page will be created at the to level.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(96703763223847890)
,p_name=>'P1314_EXISTING_PARENT_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(1134027105397773773)
,p_prompt=>'Existing Navigation Menu Entry'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'NAVLIST_ENTRIES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case',
'           when (nvl(list_item_link_target,''0'')=''0'' or parent_list_item_id is',
'null) then',
'               lpad('' '',(4*(level-1)),''.'')||list_item_link_text',
'           else',
'               lpad('' '',(4*(level-1)),''.'')||'' (''||list_item_link_text ||'')''',
'       end name,',
'       id',
'  from wwv_flow_list_items',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and sub_list_id is null',
' start with list_id = :P2500_NAVLIST_ID and parent_list_item_id is null',
'connect by prior list_id = list_id and prior id = parent_list_item_id',
' order siblings by list_item_display_sequence'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Select an existing menu control to be shown as the active menu control when rendering the new page. ',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(98081774597529028)
,p_name=>'P1314_AUTHORIZATION_SCHEME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(3872453232608216277)
,p_prompt=>'Authorization Scheme'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REQUIRED_ROLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.d, a.r from (',
'    select wwv_flow_lang.system_message(''MUST_NOT_BE_PUBLIC_USER'') d,''MUST_NOT_BE_PUBLIC_USER'' r, 1',
'      from sys.dual',
'    union all',
'    select wwv_flow_escape.html(substr(name,1,50)),to_char(id), 1',
'      from wwv_flow_security_schemes',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID',
'    union all',
'    select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'',wwv_flow_escape.html(substr(name,1,50)))||''}'' d, ''!''||to_char(id) r, 2',
'      from wwv_flow_security_schemes',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID',
'    order by 3,1) a'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- None -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the authorization scheme used to limit access to the Administration page and the pages for this feature.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(234206014974800339)
,p_name=>'P1314_BUILD_OPTION'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(855572135817646137)
,p_prompt=>'Build Option'
,p_source=>'wwv_flow_lang.system_message(''FEATURE'')||'': ''||wwv_flow_lang.system_message(''FEATURE.EMAIL_REPORT'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The listed build option(s) will be created to support this feature.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(96705128780847897)
,p_computation_sequence=>20
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.get_current_theme_id (',
'    p_application_id    => :FB_FLOW_ID )'))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(96709551441847900)
,p_validation_name=>'P1314_PAGE_ID positive, whole number'
,p_validation_sequence=>20
,p_validation=>'P1314_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>'#LABEL# must be a positive, whole number.'
,p_when_button_pressed=>wwv_flow_imp.id(96692887646847878)
,p_associated_item=>wwv_flow_imp.id(96690396693847876)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 23-APR-2003 17:15'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(96710760538847900)
,p_validation_name=>'P1314_PAGE_ID reserved'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.reserve_page (',
'    p_flow_id       => :FB_FLOW_ID,',
'    p_page_id       => :P1314_PAGE_ID,',
'    p_reuse         => TRUE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P1314_PAGE_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(96692887646847878)
,p_associated_item=>wwv_flow_imp.id(96690396693847876)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(96708348929847899)
,p_validation_name=>'P1314_ADMIN_PAGE_ID positive, whole number'
,p_validation_sequence=>40
,p_validation=>'P1314_ADMIN_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>'#LABEL# must be a positive, whole number.'
,p_validation_condition=>'P1314_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(96692887646847878)
,p_associated_item=>wwv_flow_imp.id(96688364159847871)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 23-APR-2003 17:15'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(96709956939847900)
,p_validation_name=>'P1314_ADMIN_PAGE_ID not null'
,p_validation_sequence=>50
,p_validation=>'P1314_ADMIN_PAGE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1314_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(96692887646847878)
,p_associated_item=>wwv_flow_imp.id(96689210952847872)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(96710378935847900)
,p_validation_name=>'P1314_ADMIN_PAGE_ID reserved'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.reserve_page (',
'    p_flow_id       => :FB_FLOW_ID,',
'    p_page_id       => :P1314_ADMIN_PAGE_ID,',
'    p_reuse         => TRUE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1314_ADMIN_PAGE_OPTION = ''NEW''',
'and :P1314_ADMIN_PAGE_ID is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(96692887646847878)
,p_associated_item=>wwv_flow_imp.id(96688364159847871)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(96709120419847899)
,p_validation_name=>'P1314_PAGE_ID and P1314_ADMIN_PAGE_ID different'
,p_validation_sequence=>70
,p_validation=>':P1314_PAGE_ID <> :P1314_ADMIN_PAGE_ID'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Starting Page Number and Administration Page Number must be different.'
,p_validation_condition=>'P1314_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(96692887646847878)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(96707982126847899)
,p_validation_name=>'P1314_ADMIN_PAGE_NAME not null'
,p_validation_sequence=>80
,p_validation=>'P1314_ADMIN_PAGE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1314_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(96692887646847878)
,p_associated_item=>wwv_flow_imp.id(96689210952847872)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(96708762070847899)
,p_validation_name=>'P1314_EXISTING_PAGE not null'
,p_validation_sequence=>90
,p_validation=>'P1314_EXISTING_PAGE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1314_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(96692887646847878)
,p_associated_item=>wwv_flow_imp.id(96689608753847872)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(235676931256502841)
,p_validation_name=>'P1314_EXISTING_PAGE available'
,p_validation_sequence=>100
,p_validation=>'return wwv_flow_wizard_api.page_exists( p_flow_id => :FB_FLOW_ID, p_page_id => :P1314_EXISTING_PAGE );'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'#LABEL# is not a page in the application.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1314_ADMIN_PAGE_OPTION = ''EXISTING''',
'and :P1314_EXISTING_PAGE is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(96692887646847878)
,p_associated_item=>wwv_flow_imp.id(96689608753847872)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(96705531993847897)
,p_validation_name=>'P1314_TAB_SET not null'
,p_validation_sequence=>110
,p_validation=>'P1314_TAB_SET'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1314_TAB_OPTIONS'
,p_validation_condition2=>'1:2'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_when_button_pressed=>wwv_flow_imp.id(96692887646847878)
,p_associated_item=>wwv_flow_imp.id(96694800011847880)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(96705979309847898)
,p_validation_name=>'P1314_TAB_LABEL not null'
,p_validation_sequence=>120
,p_validation=>'P1314_TAB_LABEL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1314_TAB_OPTIONS'
,p_validation_condition2=>'1'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(96692887646847878)
,p_associated_item=>wwv_flow_imp.id(96695721325847881)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(96706320181847898)
,p_validation_name=>'P1314_TAB_NAME not null'
,p_validation_sequence=>130
,p_validation=>'P1314_TAB_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1314_TAB_OPTIONS'
,p_validation_condition2=>'2'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(96692887646847878)
,p_associated_item=>wwv_flow_imp.id(96696692489847882)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(96706752755847898)
,p_validation_name=>'P1314_NAVLIST_ENTRY_NAME not null'
,p_validation_sequence=>150
,p_validation=>'P1314_NAVLIST_ENTRY_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1314_NAVLIST_OPTIONS'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(96692887646847878)
,p_associated_item=>wwv_flow_imp.id(96701089663847888)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(96707564692847899)
,p_validation_name=>'Existing Entry with no List'
,p_validation_sequence=>160
,p_validation=>'P1314_EXISTING_PARENT_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1314_NAVLIST_OPTIONS'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(96692887646847878)
,p_associated_item=>wwv_flow_imp.id(96703763223847890)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2949727609828302)
,p_validation_name=>'Navigation Menu not subscribed'
,p_validation_sequence=>170
,p_validation=>'coalesce(:P2500_IS_NAVLIST_SUBSCRIBED,''N'') != ''Y'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'&APP_TEXT$NAVIGATION_MENU_SUBSCRIBED!RAW.'
,p_validation_condition=>':P1314_NAVLIST_OPTIONS in ( ''NEW'', ''EXISTING'' ) and :P2500_NAVLIST_ID is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(96699730934847887)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(96713252979847903)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(96692407707847877)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(96713749279847903)
,p_event_id=>wwv_flow_imp.id(96713252979847903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(96714164241847903)
,p_name=>'Show / Hide Admin Options'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1314_ADMIN_PAGE_OPTION'
,p_condition_element=>'P1314_ADMIN_PAGE_OPTION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(96714619579847903)
,p_event_id=>wwv_flow_imp.id(96714164241847903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1314_ADMIN_PAGE_ID,P1314_ADMIN_PAGE_NAME,P1314_NAVLIST_OPTIONS,P1314_TAB_OPTIONS,P1314_AUTHORIZATION_SCHEME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(96716135795847904)
,p_event_id=>wwv_flow_imp.id(96714164241847903)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1314_EXISTING_PAGE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(96715171882847904)
,p_event_id=>wwv_flow_imp.id(96714164241847903)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1314_EXISTING_PAGE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(96715613814847904)
,p_event_id=>wwv_flow_imp.id(96714164241847903)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1314_ADMIN_PAGE_ID,P1314_ADMIN_PAGE_NAME,P1314_NAVLIST_OPTIONS,P1314_TAB_OPTIONS,P1314_AUTHORIZATION_SCHEME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(96716653564847904)
,p_event_id=>wwv_flow_imp.id(96714164241847903)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1314_TAB_OPTIONS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'0'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(96717109444847905)
,p_event_id=>wwv_flow_imp.id(96714164241847903)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1314_NAVLIST_OPTIONS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'NONE'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(96717524158847905)
,p_name=>'Set Tab and Nav List Names'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1314_ADMIN_PAGE_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(96718082956847905)
,p_event_id=>wwv_flow_imp.id(96717524158847905)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1314_NAVLIST_ENTRY_NAME,P1314_TAB_LABEL'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P1314_ADMIN_PAGE_NAME'
,p_attribute_07=>'P1314_ADMIN_PAGE_NAME'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(96718413125847905)
,p_name=>'Tab Option 0'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1314_TAB_OPTIONS'
,p_condition_element=>'P1314_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'0'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(96718959554847906)
,p_event_id=>wwv_flow_imp.id(96718413125847905)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1314_TAB_SET,P1314_TAB_LABEL,P1314_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3775767731503368440)
,p_event_id=>wwv_flow_imp.id(96718413125847905)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(214194093779417259)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(96711806440847901)
,p_name=>'Tab Option 1'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1314_TAB_OPTIONS'
,p_condition_element=>'P1314_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'1'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(96712305784847902)
,p_event_id=>wwv_flow_imp.id(96711806440847901)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1314_TAB_SET,P1314_TAB_LABEL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(96712864909847903)
,p_event_id=>wwv_flow_imp.id(96711806440847901)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1314_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3775767850041368441)
,p_event_id=>wwv_flow_imp.id(96711806440847901)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(214194093779417259)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(96719338813847906)
,p_name=>'Tab Option 2'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1314_TAB_OPTIONS'
,p_condition_element=>'P1314_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'2'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(96719883918847906)
,p_event_id=>wwv_flow_imp.id(96719338813847906)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1314_TAB_SET,P1314_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(96720343552847906)
,p_event_id=>wwv_flow_imp.id(96719338813847906)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1314_TAB_LABEL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3775767989151368442)
,p_event_id=>wwv_flow_imp.id(96719338813847906)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(214194093779417259)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(96720781040847906)
,p_name=>'New List'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1314_NAVLIST_OPTIONS'
,p_condition_element=>'P1314_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(96721218721847907)
,p_event_id=>wwv_flow_imp.id(96720781040847906)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1314_NAVLIST_ENTRY_NAME,P1314_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(96721728161847907)
,p_event_id=>wwv_flow_imp.id(96720781040847906)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1314_NAVLIST_ENTRY_NAME,P1314_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(96722145237847907)
,p_name=>'Existing List'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1314_NAVLIST_OPTIONS'
,p_condition_element=>'P1314_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'EXISTING'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(96722607752847907)
,p_event_id=>wwv_flow_imp.id(96722145237847907)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1314_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(96723195870847908)
,p_event_id=>wwv_flow_imp.id(96722145237847907)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1314_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(305244353579023870)
,p_process_sequence=>5
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set proper values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P1314_ADMIN_PAGE_OPTION = ''EXISTING'' then',
'   :P1314_ADMIN_PAGE_ID   := null;',
'   :P1314_ADMIN_PAGE_NAME := null;',
'end if;',
'',
'-- NONE',
'if nvl(:P1314_TAB_OPTIONS,0) = 0 then',
'   :P1314_TAB_SET   := null;',
'   :P1314_TAB_LABEL := null;',
'   :P1314_TAB_NAME  := null;',
'-- NEW TAB ',
'elsif :P1314_TAB_OPTIONS = 1 then',
'   :P1314_TAB_NAME  := null;',
'-- EXISTING TAB',
'elsif :P1314_TAB_OPTIONS = 2 then',
'   :P1314_TAB_LABEL := null;',
'end if;',
'',
'if nvl(:P1314_NAVLIST_OPTIONS,''NONE'') = ''NONE'' then',
'   :P1314_NAVLIST_ENTRY_NAME := null;',
'   :P1314_NAVLIST_PARENT_ID  := null;',
'   :P1314_NEW_PARENT_ID      := null;',
'   :P1314_EXISTING_PARENT_ID := null;',
'elsif :P1314_NAVLIST_OPTIONS = ''NEW'' then',
'   :P1314_NAVLIST_PARENT_ID  := null;',
'   :P1314_EXISTING_PARENT_ID := null;',
'elsif :P1314_NAVLIST_OPTIONS = '' EXISTING'' then',
'   :P1314_NAVLIST_ENTRY_NAME := null;',
'   :P1314_NAVLIST_PARENT_ID  := null;',
'   :P1314_NEW_PARENT_ID      := null;',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(96692887646847878)
,p_internal_uid=>305244353579023870
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(96711032039847901)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_admin_page wwv_flow_app_feature_v3.t_admin_page;',
'begin',
'    -- admin page',
'    l_admin_page.page_option                 := :P1314_ADMIN_PAGE_OPTION;',
'    l_admin_page.new_page_id                 := :P1314_ADMIN_PAGE_ID;',
'    l_admin_page.page_name                   := :P1314_ADMIN_PAGE_NAME;',
'    l_admin_page.existing_page_id            := :P1314_EXISTING_PAGE;',
'    -- tabs',
'    l_admin_page.tab_option                  := :P1314_TAB_OPTIONS;',
'    l_admin_page.tab_set                     := :P1314_TAB_SET;',
'    l_admin_page.tab_name                    := :P1314_TAB_NAME;',
'    l_admin_page.tab_text                    := :P1314_TAB_LABEL;',
'    -- nav list',
'    l_admin_page.nav_list_option             := :P1314_NAVLIST_OPTIONS;',
'    l_admin_page.nav_list_id                 := :P2500_NAVLIST_ID;',
'    l_admin_page.nav_list_new_parent_id      := :P1314_NEW_PARENT_ID;',
'    l_admin_page.nav_list_existing_parent_id := :P1314_EXISTING_PARENT_ID;',
'    l_admin_page.nav_list_entry_name         := :P1314_NAVLIST_ENTRY_NAME;',
'    ',
'    wwv_flow_app_feature_v3.add_email_monitor_page (',
'        p_app_id                   => :FB_FLOW_ID,',
'        p_page_id                  => :P1314_PAGE_ID,',
'        p_group_id                 => :P1314_GROUP_ID,',
'        p_authorization_scheme     => :P1314_AUTHORIZATION_SCHEME,',
'        --',
'        p_admin_page               => l_admin_page );',
'',
'    :FB_FLOW_PAGE_ID := wwv_flow_app_feature_v3.get_admin_page_id( p_admin_page => l_admin_page);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(96692887646847878)
,p_process_success_message=>'Email Reporting page created.'
,p_internal_uid=>96711032039847901
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(96711475766847901)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(96692887646847878)
,p_process_success_message=>'Feature pages created.'
,p_internal_uid=>96711475766847901
);
end;
/
prompt --application/pages/page_01315
begin
wwv_flow_imp_page.create_page(
 p_id=>1315
,p_name=>'Create Job Reporting Pages'
,p_alias=>'CREATE-JOB-REPORTING-PAGES'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Job Reporting Pages'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213425326892450628)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'sec_authentication.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(310971007820289272)
,p_plug_name=>'Create Tab'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>40
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P2500_NAVIGATION_TYPE'
,p_plug_display_when_cond2=>'L'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(310970419250289270)
,p_name=>'Tabs'
,p_parent_plug_id=>wwv_flow_imp.id(310971007820289272)
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<a title="click to set tab set" href="javascript:$x_Value(''''P1315_TAB_SET'''',''''''||',
'       wwv_flow_javascript.escape(tab_set)||',
'       '''''');">''||',
'       wwv_flow_escape.html(tab_set)||',
'       ''</a>'' tab_set, ',
'       tab_step, ',
'       substr(tab_text,1,30) tab_text,',
'       replace(TAB_ALSO_CURRENT_FOR_PAGES,'','','', '') tacfp',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID and ',
'       security_group_id = :flow_security_group_id',
'order  by tab_set, TAB_SEQUENCE, tab_step'))
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>'No tabs or tab sets exist.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(96788083238872024)
,p_query_column_id=>1
,p_column_alias=>'TAB_SET'
,p_column_display_sequence=>1
,p_column_heading=>'Tab Set'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(96786875261872023)
,p_query_column_id=>2
,p_column_alias=>'TAB_STEP'
,p_column_display_sequence=>2
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(96787248621872023)
,p_query_column_id=>3
,p_column_alias=>'TAB_TEXT'
,p_column_display_sequence=>3
,p_column_heading=>'Tab'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(96787646460872023)
,p_query_column_id=>4
,p_column_alias=>'TACFP'
,p_column_display_sequence=>4
,p_column_heading=>'Also&nbsp;Current&nbsp;For'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(952348461288518148)
,p_plug_name=>'Create Job Reporting Pages'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_plug_header=>'Include reports on jobs and job run details within the schema associated with this application.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(964000946180695375)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1230803430868645784)
,p_plug_name=>'Create List Entry'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>50
,p_translate_title=>'N'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P2500_NAVIGATION_TYPE'
,p_plug_display_when_cond2=>'L'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3969229558079088288)
,p_plug_name=>'Admin Options'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(96781473344872019)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(964000946180695375)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(96781833745872019)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(964000946180695375)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(96782294745872020)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(964000946180695375)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(96812683145872037)
,p_branch_action=>'f?p=&FLOW_ID.:4500:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(96781473344872019)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(96813060514872037)
,p_branch_name=>'Go To Page 2500'
,p_branch_action=>'f?p=&APP_ID.:2500:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(96782294745872020)
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(96777062012872013)
,p_name=>'P1315_ADMIN_PAGE_OPTION'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3969229558079088288)
,p_item_default=>'EXISTING'
,p_prompt=>'Administration Page Preference'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.ADMINPAGE.OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(31963614629360602)||'.'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the administration page, that a list is added to, for this feature.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(96777413170872014)
,p_name=>'P1315_ADMIN_PAGE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3969229558079088288)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.get_maximum_free_admin_page(:FB_FLOW_ID);',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Administration Page Number'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter an unused page number for the administration page.</p>',
'<p>The default is calculated as the first available page number that is divisible by 100, which is greater than the maximum page number within this application.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(96778359949872016)
,p_name=>'P1315_ADMIN_PAGE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3969229558079088288)
,p_item_default=>'wwv_flow_lang.system_message(''CA.ADMIN.ADMINISTRATION'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Administration Page Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a name for the administration page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(96778704715872016)
,p_name=>'P1315_EXISTING_PAGE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(3969229558079088288)
,p_prompt=>'Existing Administration Page'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d',
'  from wwv_flow_steps',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and is_page_pattern   = ''N''',
'order by 2'))
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select an existing page used as the administration page in this application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(96779455937872018)
,p_name=>'P1315_STARTING_PAGE_ID'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(952348461288518148)
,p_use_cache_before_default=>'NO'
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.get_maximum_free_page(:FB_FLOW_ID);',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Starting Page Number'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>10
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter an unused starting page number. This feature will create multiple pages starting with the number specified.</p>',
'<p>The default is calculated as the first available page number that is divisible by 10, which is greater than the maximum page number within this application.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(96780291717872018)
,p_name=>'P1315_GROUP_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(952348461288518148)
,p_prompt=>'Page Group'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE_GROUPS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d,',
'       id r',
'  from wwv_flow_page_groups',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
' order by upper(group_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Page Group -'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the name of the page group to associate with this page. Page groups help developers manage the pages within an application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(96782964110872020)
,p_name=>'P1315_TAB_OPTIONS'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(310971007820289272)
,p_item_default=>'0'
,p_prompt=>'Administration Page<br>Tab Options:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.TAB.OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(35310611267199336)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Specify whether the administration page should be included in tabs.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(96783864269872021)
,p_name=>'P1315_TAB_SET'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(310971007820289272)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   t varchar2(4000);',
'begin',
'   for c1 in (',
'select tab_set, count(*) c',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID and ',
'       security_group_id = :flow_security_group_id',
'group  by tab_set',
'order by 2 desc) loop',
'return c1.tab_set;',
'exit;',
'end loop;',
'return null;',
'end;',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Tab Set'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_TABSETS'
,p_lov=>'select wwv_flow_escape.html(d) d, r from wwv_flow_tabset_view'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Tab Set -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Select the tab set you wish to use for this page.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(96784790739872021)
,p_name=>'P1315_TAB_LABEL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(310971007820289272)
,p_prompt=>'New Tab Label'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the label for the tab that will be created. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(96785664512872022)
,p_name=>'P1315_TAB_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(310971007820289272)
,p_prompt=>'Use Tab'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(TAB_NAME)||'': label="''||wwv_flow_escape.html(substr(TAB_TEXT,1,40))||''"'' tab_text,tab_name',
'from   wwv_flow_tabs',
'where  flow_id = :fb_flow_id and',
'       security_group_id = :flow_security_group_id and',
'       tab_set = :P1315_TAB_SET'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Tab -'
,p_lov_cascade_parent_items=>'P1315_TAB_SET'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Select the tab to be designated as "current" for this page.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(96788741619872024)
,p_name=>'P1315_NAVLIST_OPTIONS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1230803430868645784)
,p_item_default=>'NONE'
,p_prompt=>'Administration Page<br> Navigation Preference'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.NAVIGATIONLIST.OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(925221062390507339)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select how you want this page integrated into the Navigation Menu.<p/>',
'<ul>',
'    <li><strong>Do not associate this page with a Navigation Menu entry</strong> - The new page will not be current or highlighted for any menu entry.</li>',
'    <li><strong>Create a new Navigation Menu entry</strong> - Users will be able to navigate to the new page directly from the Navigation Menu. The new entry can be placed anywhere in the existing hierarchy.</li>',
'    <li><strong>Identify an existing Navigation Menu entry which will be current for this page</strong> - Use this option when you want the new page to highlight an existing, top level, menu entry. Users will not be able to navigate to the new page d'
||'irectly from the Navigation Menu. Therefore, You will need to create or define a navigation control on the top level page selected, such as a button, or link in a report, to go to this new page.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(96790010129872025)
,p_name=>'P1315_NAVLIST_ENTRY_NAME'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_imp.id(1230803430868645784)
,p_prompt=>'New Navigation Menu Entry'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Enter a name for the new menu control.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(96790957138872025)
,p_name=>'P1315_NAVLIST_PARENT_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1230803430868645784)
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select a navigation parent for your new page. When creating a new navigation item, the new item links to',
'the new page. The new item can be added at the top level, by not selecting any parent item, or shown as a child',
'of an existing item. </p>',
'',
'<p>When selecting item without creating a new item, the selected item determines which top level item is shown',
'as the "current" item.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(96791862924872026)
,p_name=>'P1315_NEW_PARENT_ID'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_imp.id(1230803430868645784)
,p_prompt=>'Parent Navigation Menu Entry'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'NAVLIST_ENTRIES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case',
'           when (nvl(list_item_link_target,''0'')=''0'' or parent_list_item_id is',
'null) then',
'               lpad('' '',(4*(level-1)),''.'')||list_item_link_text',
'           else',
'               lpad('' '',(4*(level-1)),''.'')||'' (''||list_item_link_text ||'')''',
'       end name,',
'       id',
'  from wwv_flow_list_items',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and sub_list_id is null',
' start with list_id = :P2500_NAVLIST_ID and parent_list_item_id is null',
'connect by prior list_id = list_id and prior id = parent_list_item_id',
' order siblings by list_item_display_sequence'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No parent selected - '
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select an existing menu control if you wish to add a menu entry for the new page to this menu control. ',
'When not selecting an existing menu control, a menu control for the new page will be created at the to level.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(96792785030872026)
,p_name=>'P1315_EXISTING_PARENT_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(1230803430868645784)
,p_prompt=>'Existing Navigation Menu Entry'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'NAVLIST_ENTRIES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case',
'           when (nvl(list_item_link_target,''0'')=''0'' or parent_list_item_id is',
'null) then',
'               lpad('' '',(4*(level-1)),''.'')||list_item_link_text',
'           else',
'               lpad('' '',(4*(level-1)),''.'')||'' (''||list_item_link_text ||'')''',
'       end name,',
'       id',
'  from wwv_flow_list_items',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and sub_list_id is null',
' start with list_id = :P2500_NAVLIST_ID and parent_list_item_id is null',
'connect by prior list_id = list_id and prior id = parent_list_item_id',
' order siblings by list_item_display_sequence'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Select an existing menu control to be shown as the active menu control when rendering the new page. ',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(98076203074505870)
,p_name=>'P1315_SCHEDULER_JOBS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(952348461288518148)
,p_prompt=>'Jobs'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select job_name d, job_name r',
'  from wwv_flow_jobs_dev',
' where owner = (select owner',
'                  from wwv_flows',
'                 where id = :FB_FLOW_ID',
'                   and security_group_id = :FLOW_SECURITY_GROUP_ID)',
' order by 1'))
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_help_text=>'If selected, the resulting reports will be limited to just the selected jobs.  If nothing is selected, all jobs within the parsing schema for the application will be displayed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(98077141546505871)
,p_name=>'P1315_AUTHORIZATION_SCHEME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(3969229558079088288)
,p_prompt=>'Authorization Scheme'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REQUIRED_ROLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.d, a.r from (',
'    select wwv_flow_lang.system_message(''MUST_NOT_BE_PUBLIC_USER'') d,''MUST_NOT_BE_PUBLIC_USER'' r, 1',
'      from sys.dual',
'    union all',
'    select wwv_flow_escape.html(substr(name,1,50)),to_char(id), 1',
'      from wwv_flow_security_schemes',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID',
'    union all',
'    select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'',wwv_flow_escape.html(substr(name,1,50)))||''}'' d, ''!''||to_char(id) r, 2',
'      from wwv_flow_security_schemes',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID',
'    order by 3,1) a'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- None -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the authorization scheme used to limit access to the Administration page and the pages for this feature.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(234207917095803396)
,p_name=>'P1315_BUILD_OPTION'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(952348461288518148)
,p_prompt=>'Build Option'
,p_source=>'wwv_flow_lang.system_message(''FEATURE'')||'': ''||wwv_flow_lang.system_message(''FEATURE.JOB_REPORT'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The listed build option(s) will be created to support this feature.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(96794196789872027)
,p_computation_sequence=>20
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.get_current_theme_id (',
'    p_application_id    => :FB_FLOW_ID )'))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(96798551568872030)
,p_validation_name=>'P1315_STARTING_PAGE_ID positive, whole number'
,p_validation_sequence=>20
,p_validation=>'P1315_STARTING_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>'#LABEL# must be a positive, whole number.'
,p_when_button_pressed=>wwv_flow_imp.id(96781833745872019)
,p_associated_item=>wwv_flow_imp.id(96779455937872018)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 23-APR-2003 17:15'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(96799743898872030)
,p_validation_name=>'P1315_STARTING_PAGE_ID reserved'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.reserve_page (',
'    p_flow_id       => :FB_FLOW_ID,',
'    p_page_id       => :P1315_STARTING_PAGE_ID,',
'    p_reuse         => TRUE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P1315_STARTING_PAGE_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(96781833745872019)
,p_associated_item=>wwv_flow_imp.id(96779455937872018)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(96797365501872029)
,p_validation_name=>'P1315_ADMIN_PAGE_ID positive, whole number'
,p_validation_sequence=>40
,p_validation=>'P1315_ADMIN_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>'#LABEL# must be a positive, whole number.'
,p_validation_condition=>'P1315_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(96781833745872019)
,p_associated_item=>wwv_flow_imp.id(96777413170872014)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 23-APR-2003 17:15'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(96798929833872030)
,p_validation_name=>'P1315_ADMIN_PAGE_ID not null'
,p_validation_sequence=>50
,p_validation=>'P1315_ADMIN_PAGE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1315_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(96781833745872019)
,p_associated_item=>wwv_flow_imp.id(96778359949872016)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(96799351988872030)
,p_validation_name=>'P1315_ADMIN_PAGE_ID reserved'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.reserve_page (',
'    p_flow_id       => :FB_FLOW_ID,',
'    p_page_id       => :P1315_ADMIN_PAGE_ID,',
'    p_reuse         => TRUE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1315_ADMIN_PAGE_OPTION = ''NEW''',
'and :P1315_ADMIN_PAGE_ID is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(96781833745872019)
,p_associated_item=>wwv_flow_imp.id(96777413170872014)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(96798154709872030)
,p_validation_name=>'P1315_STARTING_PAGE_ID and P1315_ADMIN_PAGE_ID different'
,p_validation_sequence=>70
,p_validation=>':P1315_STARTING_PAGE_ID <> :P1315_ADMIN_PAGE_ID'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Starting Page Number and Administration Page Number must be different.'
,p_validation_condition=>'P1315_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(96781833745872019)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(96796917097872029)
,p_validation_name=>'P1315_ADMIN_PAGE_NAME not null'
,p_validation_sequence=>80
,p_validation=>'P1315_ADMIN_PAGE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1315_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(96781833745872019)
,p_associated_item=>wwv_flow_imp.id(96778359949872016)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(96797799030872029)
,p_validation_name=>'P1315_EXISTING_PAGE not null'
,p_validation_sequence=>90
,p_validation=>'P1315_EXISTING_PAGE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1315_ADMIN_PAGE_OPTION'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(96781833745872019)
,p_associated_item=>wwv_flow_imp.id(96778704715872016)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(235680040104517312)
,p_validation_name=>'P1315_EXISTING_PAGE available'
,p_validation_sequence=>100
,p_validation=>'return wwv_flow_wizard_api.page_exists( p_flow_id => :FB_FLOW_ID, p_page_id => :P1315_EXISTING_PAGE );'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'#LABEL# is not a page in the application.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1315_ADMIN_PAGE_OPTION = ''EXISTING''',
'and :P1315_EXISTING_PAGE is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(96781833745872019)
,p_associated_item=>wwv_flow_imp.id(96778704715872016)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(96794597583872028)
,p_validation_name=>'P1315_TAB_SET not null'
,p_validation_sequence=>110
,p_validation=>'P1315_TAB_SET'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1315_TAB_OPTIONS'
,p_validation_condition2=>'1:2'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_when_button_pressed=>wwv_flow_imp.id(96781833745872019)
,p_associated_item=>wwv_flow_imp.id(96783864269872021)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(96794908811872028)
,p_validation_name=>'P1315_TAB_LABEL not null'
,p_validation_sequence=>120
,p_validation=>'P1315_TAB_LABEL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1315_TAB_OPTIONS'
,p_validation_condition2=>'1'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(96781833745872019)
,p_associated_item=>wwv_flow_imp.id(96784790739872021)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(96795336201872028)
,p_validation_name=>'P1315_TAB_NAME not null'
,p_validation_sequence=>130
,p_validation=>'P1315_TAB_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1315_TAB_OPTIONS'
,p_validation_condition2=>'2'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(96781833745872019)
,p_associated_item=>wwv_flow_imp.id(96785664512872022)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(96795707760872028)
,p_validation_name=>'P1315_NAVLIST_ENTRY_NAME not null'
,p_validation_sequence=>150
,p_validation=>'P1315_NAVLIST_ENTRY_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1315_NAVLIST_OPTIONS'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(96781833745872019)
,p_associated_item=>wwv_flow_imp.id(96790010129872025)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(96796561972872029)
,p_validation_name=>'Existing Entry with no List'
,p_validation_sequence=>160
,p_validation=>'P1315_EXISTING_PARENT_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1315_NAVLIST_OPTIONS'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(96781833745872019)
,p_associated_item=>wwv_flow_imp.id(96792785030872026)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2950067792829462)
,p_validation_name=>'Navigation Menu not subscribed'
,p_validation_sequence=>170
,p_validation=>'coalesce(:P2500_IS_NAVLIST_SUBSCRIBED,''N'') != ''Y'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'&APP_TEXT$NAVIGATION_MENU_SUBSCRIBED!RAW.'
,p_validation_condition=>':P1315_NAVLIST_OPTIONS in ( ''NEW'', ''EXISTING'' ) and :P2500_NAVLIST_ID is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(96788741619872024)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(96802214468872032)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(96781473344872019)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(96802742487872032)
,p_event_id=>wwv_flow_imp.id(96802214468872032)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(96803115438872032)
,p_name=>'Show / Hide Admin Options'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1315_ADMIN_PAGE_OPTION'
,p_condition_element=>'P1315_ADMIN_PAGE_OPTION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(96803691701872033)
,p_event_id=>wwv_flow_imp.id(96803115438872032)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1315_ADMIN_PAGE_ID,P1315_ADMIN_PAGE_NAME,P1315_NAVLIST_OPTIONS,P1315_TAB_OPTIONS,P1315_AUTHORIZATION_SCHEME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(96805112746872033)
,p_event_id=>wwv_flow_imp.id(96803115438872032)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1315_EXISTING_PAGE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(96804137611872033)
,p_event_id=>wwv_flow_imp.id(96803115438872032)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1315_EXISTING_PAGE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(96804605196872033)
,p_event_id=>wwv_flow_imp.id(96803115438872032)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1315_ADMIN_PAGE_ID,P1315_ADMIN_PAGE_NAME,P1315_NAVLIST_OPTIONS,P1315_TAB_OPTIONS,P1315_AUTHORIZATION_SCHEME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(96805691249872034)
,p_event_id=>wwv_flow_imp.id(96803115438872032)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1315_TAB_OPTIONS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'0'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(96806171616872034)
,p_event_id=>wwv_flow_imp.id(96803115438872032)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1315_NAVLIST_OPTIONS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'NONE'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(96806586684872034)
,p_name=>'Set Tab and Nav List Names'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1315_ADMIN_PAGE_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(96807059995872034)
,p_event_id=>wwv_flow_imp.id(96806586684872034)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1315_NAVLIST_ENTRY_NAME,P1315_TAB_LABEL'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P1315_ADMIN_PAGE_NAME'
,p_attribute_07=>'P1315_ADMIN_PAGE_NAME'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(96807492402872034)
,p_name=>'Tab Option 0'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1315_TAB_OPTIONS'
,p_condition_element=>'P1315_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'0'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(96807982319872035)
,p_event_id=>wwv_flow_imp.id(96807492402872034)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1315_TAB_SET,P1315_TAB_LABEL,P1315_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3775767445490368437)
,p_event_id=>wwv_flow_imp.id(96807492402872034)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(310970419250289270)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(96800844122872031)
,p_name=>'Tab Option 1'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1315_TAB_OPTIONS'
,p_condition_element=>'P1315_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'1'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(96801312849872031)
,p_event_id=>wwv_flow_imp.id(96800844122872031)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1315_TAB_SET,P1315_TAB_LABEL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(96801846571872032)
,p_event_id=>wwv_flow_imp.id(96800844122872031)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1315_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3775767565619368438)
,p_event_id=>wwv_flow_imp.id(96800844122872031)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(310970419250289270)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(96808354035872035)
,p_name=>'Tab Option 2'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1315_TAB_OPTIONS'
,p_condition_element=>'P1315_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'2'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(96808850015872035)
,p_event_id=>wwv_flow_imp.id(96808354035872035)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1315_TAB_SET,P1315_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(96809325523872035)
,p_event_id=>wwv_flow_imp.id(96808354035872035)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1315_TAB_LABEL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3775767612788368439)
,p_event_id=>wwv_flow_imp.id(96808354035872035)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(310970419250289270)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(96809737251872035)
,p_name=>'New List'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1315_NAVLIST_OPTIONS'
,p_condition_element=>'P1315_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(96810297068872036)
,p_event_id=>wwv_flow_imp.id(96809737251872035)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1315_NAVLIST_ENTRY_NAME,P1315_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(96810758546872036)
,p_event_id=>wwv_flow_imp.id(96809737251872035)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1315_NAVLIST_ENTRY_NAME,P1315_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(96811179588872036)
,p_name=>'Existing List'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1315_NAVLIST_OPTIONS'
,p_condition_element=>'P1315_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'EXISTING'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(96811624441872036)
,p_event_id=>wwv_flow_imp.id(96811179588872036)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1315_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(96812166000872037)
,p_event_id=>wwv_flow_imp.id(96811179588872036)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1315_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2440118531965605)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set proper values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P1315_ADMIN_PAGE_OPTION = ''EXISTING'' then',
'   :P1315_ADMIN_PAGE_ID   := null;',
'   :P1315_ADMIN_PAGE_NAME := null;',
'end if;',
'',
'-- NONE',
'if nvl(:P1315_TAB_OPTIONS,0) = 0 then',
'   :P1315_TAB_SET   := null;',
'   :P1315_TAB_LABEL := null;',
'   :P1315_TAB_NAME  := null;',
'-- NEW TAB ',
'elsif :P1315_TAB_OPTIONS = 1 then',
'   :P1315_TAB_NAME  := null;',
'-- EXISTING TAB',
'elsif :P1315_TAB_OPTIONS = 2 then',
'   :P1315_TAB_LABEL := null;',
'end if;',
'',
'if nvl(:P1315_NAVLIST_OPTIONS,''NONE'') = ''NONE'' then',
'   :P1315_NAVLIST_ENTRY_NAME := null;',
'   :P1315_NAVLIST_PARENT_ID  := null;',
'   :P1315_NEW_PARENT_ID      := null;',
'   :P1315_EXISTING_PARENT_ID := null;',
'elsif :P1315_NAVLIST_OPTIONS = ''NEW'' then',
'   :P1315_NAVLIST_PARENT_ID  := null;',
'   :P1315_EXISTING_PARENT_ID := null;',
'elsif :P1315_NAVLIST_OPTIONS = '' EXISTING'' then',
'   :P1315_NAVLIST_ENTRY_NAME := null;',
'   :P1315_NAVLIST_PARENT_ID  := null;',
'   :P1315_NEW_PARENT_ID      := null;',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(96781833745872019)
,p_internal_uid=>2440118531965605
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(96800012658872031)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_admin_page wwv_flow_app_feature_v3.t_admin_page;',
'begin',
'    -- admin page',
'    l_admin_page.page_option                 := :P1315_ADMIN_PAGE_OPTION;',
'    l_admin_page.new_page_id                 := :P1315_ADMIN_PAGE_ID;',
'    l_admin_page.page_name                   := :P1315_ADMIN_PAGE_NAME;',
'    l_admin_page.existing_page_id            := :P1315_EXISTING_PAGE;',
'    -- tabs',
'    l_admin_page.tab_option                  := :P1315_TAB_OPTIONS;',
'    l_admin_page.tab_set                     := :P1315_TAB_SET;',
'    l_admin_page.tab_name                    := :P1315_TAB_NAME;',
'    l_admin_page.tab_text                    := :P1315_TAB_LABEL;',
'    -- nav list',
'    l_admin_page.nav_list_option             := :P1315_NAVLIST_OPTIONS;',
'    l_admin_page.nav_list_id                 := :P2500_NAVLIST_ID;',
'    l_admin_page.nav_list_new_parent_id      := :P1315_NEW_PARENT_ID;',
'    l_admin_page.nav_list_existing_parent_id := :P1315_EXISTING_PARENT_ID;',
'    l_admin_page.nav_list_entry_name         := :P1315_NAVLIST_ENTRY_NAME;',
'    ',
'    wwv_flow_app_feature_v3.add_job_monitoring (',
'        p_app_id                   => :FB_FLOW_ID,',
'        p_starting_page_id         => :P1315_STARTING_PAGE_ID,',
'        p_group_id                 => :P1315_GROUP_ID,',
'        p_authorization_scheme     => :P1315_AUTHORIZATION_SCHEME,',
'        --',
'        p_job_list                 => :P1315_SCHEDULER_JOBS,',
'        --',
'        p_admin_page               => l_admin_page );',
'',
'    :FB_FLOW_PAGE_ID := wwv_flow_app_feature_v3.get_admin_page_id( p_admin_page => l_admin_page);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(96781833745872019)
,p_process_success_message=>'Job Reporting pages created.'
,p_internal_uid=>96800012658872031
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(96800444570872031)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(96781833745872019)
,p_process_success_message=>'Feature pages created.'
,p_internal_uid=>96800444570872031
);
end;
/
prompt --application/pages/page_01316
begin
wwv_flow_imp_page.create_page(
 p_id=>1316
,p_name=>'Create Page Warning'
,p_alias=>'CREATE-PAGE-WARNING'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Page Warning'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213425326892450628)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'sec_authentication.htm'
,p_page_component_map=>'11'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1078344169909827185)
,p_plug_name=>'Theme Compatibility'
,p_region_css_classes=>'a-Alert--inlineDialog a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'This feature requires a Universal Theme based application. ',
'Oracle recommends updating to the Univeral Theme. To learn more, see the <a rel="noopener noreferrer" href="https://apex.oracle.com/ut" target="_blank">Universal Theme App</a>.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1089996654802004412)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(126004204630309072)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1089996654802004412)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(126005099464309073)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(1089996654802004412)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:2500:&SESSION.::&DEBUG.:RP,::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(126016999508309092)
,p_computation_sequence=>20
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.get_current_theme_id (',
'    p_application_id    => :FB_FLOW_ID )'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(126025518425309099)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(126004204630309072)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(126026007238309100)
,p_event_id=>wwv_flow_imp.id(126025518425309099)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(126026469218309100)
,p_name=>'Show / Hide Admin Options'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1316_ADMIN_PAGE_OPTION'
,p_condition_element=>'P1316_ADMIN_PAGE_OPTION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(126026912614309100)
,p_event_id=>wwv_flow_imp.id(126026469218309100)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1316_ADMIN_PAGE_ID,P1316_ADMIN_PAGE_NAME,P1316_NAVLIST_OPTIONS,P1316_TAB_OPTIONS'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(126028455418309101)
,p_event_id=>wwv_flow_imp.id(126026469218309100)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1316_EXISTING_PAGE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(126027414411309100)
,p_event_id=>wwv_flow_imp.id(126026469218309100)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1316_EXISTING_PAGE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(126027972234309101)
,p_event_id=>wwv_flow_imp.id(126026469218309100)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1316_ADMIN_PAGE_ID,P1316_ADMIN_PAGE_NAME,P1316_NAVLIST_OPTIONS,P1316_TAB_OPTIONS'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(126028951250309101)
,p_event_id=>wwv_flow_imp.id(126026469218309100)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1316_TAB_OPTIONS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'0'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(126029440125309101)
,p_event_id=>wwv_flow_imp.id(126026469218309100)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1316_NAVLIST_OPTIONS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'NONE'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(126029836496309102)
,p_name=>'Set Tab and Nav List Names'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1316_ADMIN_PAGE_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(126030346144309102)
,p_event_id=>wwv_flow_imp.id(126029836496309102)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1316_NAVLIST_ENTRY_NAME,P1316_TAB_LABEL'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P1316_ADMIN_PAGE_NAME'
,p_attribute_07=>'P1316_ADMIN_PAGE_NAME'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(126030794807309102)
,p_name=>'Tab Option 0'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1316_TAB_OPTIONS'
,p_condition_element=>'P1316_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'0'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(126031765683309103)
,p_event_id=>wwv_flow_imp.id(126030794807309102)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1316_TAB_SET,P1316_TAB_LABEL,P1316_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(126023601757309096)
,p_name=>'Tab Option 1'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1316_TAB_OPTIONS'
,p_condition_element=>'P1316_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'1'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(126024666657309099)
,p_event_id=>wwv_flow_imp.id(126023601757309096)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1316_TAB_SET,P1316_TAB_LABEL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(126025100219309099)
,p_event_id=>wwv_flow_imp.id(126023601757309096)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1316_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(126032187220309103)
,p_name=>'Tab Option 2'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1316_TAB_OPTIONS'
,p_condition_element=>'P1316_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'2'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(126033165089309103)
,p_event_id=>wwv_flow_imp.id(126032187220309103)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1316_TAB_SET,P1316_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(126033677354309104)
,p_event_id=>wwv_flow_imp.id(126032187220309103)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1316_TAB_LABEL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(126034071004309104)
,p_name=>'New List'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1316_NAVLIST_OPTIONS'
,p_condition_element=>'P1316_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(126034543410309104)
,p_event_id=>wwv_flow_imp.id(126034071004309104)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1316_NAVLIST_ENTRY_NAME,P1316_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(126035002672309104)
,p_event_id=>wwv_flow_imp.id(126034071004309104)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1316_NAVLIST_ENTRY_NAME,P1316_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(126035439436309105)
,p_name=>'Existing List'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1316_NAVLIST_OPTIONS'
,p_condition_element=>'P1316_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'EXISTING'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(126035924766309105)
,p_event_id=>wwv_flow_imp.id(126035439436309105)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1316_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(126036440135309105)
,p_event_id=>wwv_flow_imp.id(126035439436309105)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1316_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_01317
begin
wwv_flow_imp_page.create_page(
 p_id=>1317
,p_name=>'Feature Already Exists'
,p_alias=>'FEATURE-ALREADY-EXISTS'
,p_page_mode=>'MODAL'
,p_step_title=>'Feature Already Exists'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213425326892450628)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'sec_authentication.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1312877352198970103)
,p_plug_name=>'Feature Exists'
,p_region_css_classes=>'a-Alert--inlineDialog a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This feature already exists in your application. If you wish to reinstall this feature, you must first remove the existing page(s), shared components and  <strong>&P1317_BUILD_OPTION.</strong> build option. To remove the components perform the fol'
||'lowing steps:',
'<ol>',
'  <li>Go to Shared Components.</li>',
'  <li>Go to Application Logic, Build Options.</li>',
'  <li>Click <strong>&P1317_BUILD_OPTION.</strong>.</li>',
'  <li>Click <strong>Remove Components</strong>.<br>',
'    &nbsp;&nbsp;Click the checkbox for <em>Yes - remove components</em>.<br>',
'    &nbsp;&nbsp;Click <strong>Remove Components</strong>.</li>',
'  <li>On Create / Edit Build Option, click <strong>Delete</strong>.<br>',
'    &nbsp;&nbsp;Click <strong>Delete Build Option</strong>.</li>',
'</ol>',
'</p>',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1324529837091147330)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(234534057995142929)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1324529837091147330)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(234534405523142929)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(1324529837091147330)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:2500:&SESSION.::&DEBUG.:RP,::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(231171661894226007)
,p_name=>'P1317_BUILD_OPTION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1312877352198970103)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(234534996782142938)
,p_computation_sequence=>20
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.get_current_theme_id (',
'    p_application_id    => :FB_FLOW_ID )'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(231172029727226011)
,p_computation_sequence=>30
,p_computation_item=>'P1317_BUILD_OPTION'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_return varchar2(4000) := wwv_flow_lang.system_message(''FEATURE'')||'': '';',
'begin',
'  if :P2500_PAGE_TYPE = wwv_flow_app_feature_v3.c_acl then',
'    l_return := l_return || wwv_flow_lang.system_message(''FEATURE.ACCESS_CONTROL'');',
'  elsif :P2500_PAGE_TYPE = wwv_flow_app_feature_v3.c_feedback then',
'    l_return := l_return || wwv_flow_lang.system_message(''FEATURE.FEEDBACK'');',
'  elsif :P2500_PAGE_TYPE = wwv_flow_app_feature_v3.c_activity_report then',
'    l_return := l_return || wwv_flow_lang.system_message(''FEATURE.ACTIVITY_REPORTING'');',
'  elsif :P2500_PAGE_TYPE = wwv_flow_app_feature_v3.c_email_report then',
'    l_return := l_return || wwv_flow_lang.system_message(''FEATURE.EMAIL_REPORT'');',
'  elsif :P2500_PAGE_TYPE = wwv_flow_app_feature_v3.c_job_report then',
'    l_return := l_return || wwv_flow_lang.system_message(''FEATURE.JOB_REPORT'');',
'  elsif :P2500_PAGE_TYPE = wwv_flow_app_feature_v3.c_about_page then',
'    l_return := l_return || wwv_flow_lang.system_message(''FEATURE.ABOUT_PAGE'');',
'  elsif :P2500_PAGE_TYPE = wwv_flow_app_feature_v3.c_configuration then',
'    l_return := l_return || wwv_flow_lang.system_message(''FEATURE.CONFIGURATION_OPTIONS'');',
'  elsif :P2500_PAGE_TYPE = wwv_flow_app_feature_v3.c_theme_style then',
'    l_return := l_return || wwv_flow_lang.system_message(''FEATURE.THEME_STYLE_SELECTION'');',
'  elsif :P2500_PAGE_TYPE = wwv_flow_app_feature_v3.c_push_notifications then',
'    l_return := l_return || wwv_flow_lang.system_message(''FEATURE.PUSH_NOTIFICATIONS'');',
'  end if;',
'',
'  return l_return;',
'end;',
''))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(234536663044142941)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(234534057995142929)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(234537171563142942)
,p_event_id=>wwv_flow_imp.id(234536663044142941)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(234537516694142942)
,p_name=>'Show / Hide Admin Options'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1317_ADMIN_PAGE_OPTION'
,p_condition_element=>'P1317_ADMIN_PAGE_OPTION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(234538016816142943)
,p_event_id=>wwv_flow_imp.id(234537516694142942)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1317_ADMIN_PAGE_ID,P1317_ADMIN_PAGE_NAME,P1317_NAVLIST_OPTIONS,P1317_TAB_OPTIONS'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(234539528796142944)
,p_event_id=>wwv_flow_imp.id(234537516694142942)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1317_EXISTING_PAGE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(234538588607142943)
,p_event_id=>wwv_flow_imp.id(234537516694142942)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1317_EXISTING_PAGE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(234539021275142944)
,p_event_id=>wwv_flow_imp.id(234537516694142942)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1317_ADMIN_PAGE_ID,P1317_ADMIN_PAGE_NAME,P1317_NAVLIST_OPTIONS,P1317_TAB_OPTIONS'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(234540005101142944)
,p_event_id=>wwv_flow_imp.id(234537516694142942)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1317_TAB_OPTIONS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'0'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(234540525516142945)
,p_event_id=>wwv_flow_imp.id(234537516694142942)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1317_NAVLIST_OPTIONS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'NONE'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(234540977452142945)
,p_name=>'Set Tab and Nav List Names'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1317_ADMIN_PAGE_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(234541444806142945)
,p_event_id=>wwv_flow_imp.id(234540977452142945)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1317_NAVLIST_ENTRY_NAME,P1317_TAB_LABEL'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':P1317_ADMIN_PAGE_NAME'
,p_attribute_07=>'P1317_ADMIN_PAGE_NAME'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(234541855230142945)
,p_name=>'Tab Option 0'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1317_TAB_OPTIONS'
,p_condition_element=>'P1317_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'0'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(234542358953142946)
,p_event_id=>wwv_flow_imp.id(234541855230142945)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1317_TAB_SET,P1317_TAB_LABEL,P1317_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(234535258277142939)
,p_name=>'Tab Option 1'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1317_TAB_OPTIONS'
,p_condition_element=>'P1317_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'1'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(234535747667142940)
,p_event_id=>wwv_flow_imp.id(234535258277142939)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1317_TAB_SET,P1317_TAB_LABEL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(234536293616142940)
,p_event_id=>wwv_flow_imp.id(234535258277142939)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1317_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(234542701132142946)
,p_name=>'Tab Option 2'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1317_TAB_OPTIONS'
,p_condition_element=>'P1317_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'2'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(234543237413142946)
,p_event_id=>wwv_flow_imp.id(234542701132142946)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1317_TAB_SET,P1317_TAB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(234543784311142946)
,p_event_id=>wwv_flow_imp.id(234542701132142946)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1317_TAB_LABEL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(234544143100142946)
,p_name=>'New List'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1317_NAVLIST_OPTIONS'
,p_condition_element=>'P1317_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(234544676243142947)
,p_event_id=>wwv_flow_imp.id(234544143100142946)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1317_NAVLIST_ENTRY_NAME,P1317_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(234545115688142947)
,p_event_id=>wwv_flow_imp.id(234544143100142946)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1317_NAVLIST_ENTRY_NAME,P1317_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(234545586806142947)
,p_name=>'Existing List'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1317_NAVLIST_OPTIONS'
,p_condition_element=>'P1317_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'EXISTING'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(234546014965142947)
,p_event_id=>wwv_flow_imp.id(234545586806142947)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1317_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(234546590771142948)
,p_event_id=>wwv_flow_imp.id(234545586806142947)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1317_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_01318
begin
wwv_flow_imp_page.create_page(
 p_id=>1318
,p_name=>'Create Push Notification Settings Page'
,p_alias=>'CREATE-PUSH-NOTIFICATION-SETTINGS-PAGE'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Push Notification Settings Page'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213425326892450628)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2241397983573702)
,p_plug_name=>'Feature description'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>11
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This feature consists of two pages:</p> ',
'<ul>',
'    <li>A user settings page</li>',
'    <li>A push notifications settings page</li>',
'</ul>',
'<p>Users can manage their push notification subscription settings.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2232331405407767639)
,p_plug_name=>'Push Notifications Settings Page'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>31
,p_plug_item_display_point=>'BELOW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2243983890299944866)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3911951505237100407)
,p_plug_name=>'User Settings Page'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>21
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(20215524965240609)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2243983890299944866)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(20215994890240611)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(2243983890299944866)
,p_button_name=>'CREATE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(20216338305240611)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(2243983890299944866)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:2500:&SESSION.::&DEBUG.:::'
,p_button_condition=>'P1318_PARENT_PAGE'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2402133061642119)
,p_name=>'P1318_PARENT_PAGE'
,p_item_sequence=>1
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20211652972240607)
,p_name=>'P1318_PAGE_ID'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2232331405407767639)
,p_use_cache_before_default=>'NO'
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.get_maximum_free_page( ',
'           p_flow_id     => :FB_FLOW_ID,',
'           p_min_page_id => 20000 );'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Page Number'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>10
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter an unused starting page number.</p>',
'<p>The default is calculated as the first available page number that is divisible by 10, which is greater than the maximum page number within this application.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20217035273240612)
,p_name=>'P1318_USER_SETTINGS_PAGE_TYPE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3911951505237100407)
,p_item_default=>'NEW'
,p_prompt=>'Page Source'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.ADMINPAGE.OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(31963614629360602)||'.'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the user settings page, that a list is added to, for this feature.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20217905206240613)
,p_name=>'P1318_USER_SETTINGS_PAGE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3911951505237100407)
,p_item_default=>'return wwv_flow_wizard_api.get_maximum_free_user_page(:FB_FLOW_ID);'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Page Number'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter an unused page number for the user settings page.</p>',
'<p>The default is calculated as the first available page number that is divisible by 100, which is greater than the maximum page number within this application.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20220601434240614)
,p_name=>'P1318_EXISTING_PAGE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(3911951505237100407)
,p_prompt=>'Page Number'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d',
'  from wwv_flow_steps',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and is_page_pattern   = ''N''',
'order by 2'))
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select an existing page used as the user settings page in this application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(20221658139240632)
,p_computation_sequence=>20
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.get_current_theme_id (',
'    p_application_id    => :FB_FLOW_ID )'))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(20227212269240635)
,p_validation_name=>'P1318_PAGE_ID positive, whole number'
,p_validation_sequence=>1
,p_validation=>'P1318_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>'#LABEL# must be a positive, whole number.'
,p_when_button_pressed=>wwv_flow_imp.id(20215994890240611)
,p_associated_item=>wwv_flow_imp.id(20211652972240607)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 23-APR-2003 17:15'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(20225214815240634)
,p_validation_name=>'P1318_PAGE_ID reserved'
,p_validation_sequence=>21
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.reserve_page (',
'    p_flow_id       => :FB_FLOW_ID,',
'    p_page_id       => :P1318_PAGE_ID,',
'    p_reuse         => TRUE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P1318_PAGE_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(20215994890240611)
,p_associated_item=>wwv_flow_imp.id(20211652972240607)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(20222071452240633)
,p_validation_name=>'P1318_USER_SETTINGS_PAGE_ID positive, whole number'
,p_validation_sequence=>41
,p_validation=>'P1318_USER_SETTINGS_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>'#LABEL# must be a positive, whole number.'
,p_validation_condition=>'P1318_USER_SETTINGS_PAGE_TYPE'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(20215994890240611)
,p_associated_item=>wwv_flow_imp.id(20217905206240613)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 23-APR-2003 17:15'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(20222836012240633)
,p_validation_name=>'P1318_USER_SETTINGS_PAGE_ID not null'
,p_validation_sequence=>51
,p_validation=>'P1318_USER_SETTINGS_PAGE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1318_USER_SETTINGS_PAGE_TYPE'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(20215994890240611)
,p_associated_item=>wwv_flow_imp.id(20217905206240613)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(20222471177240633)
,p_validation_name=>'P1318_USER_SETTINGS_PAGE_ID reserved'
,p_validation_sequence=>71
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_wizard_api.reserve_page (',
'    p_flow_id       => :FB_FLOW_ID,',
'    p_page_id       => :P1318_USER_SETTINGS_PAGE_ID,',
'    p_reuse         => TRUE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1318_USER_SETTINGS_PAGE_TYPE = ''NEW''',
'and :P1318_USER_SETTINGS_PAGE_ID is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(20215994890240611)
,p_associated_item=>wwv_flow_imp.id(20217905206240613)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(20225612685240634)
,p_validation_name=>'P1318_PAGE_ID and P1318_USER_SETTINGS_PAGE_ID different'
,p_validation_sequence=>81
,p_validation=>':P1318_PAGE_ID <> :P1318_USER_SETTINGS_PAGE_ID'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Page Number and User Settings Page Number must be different.'
,p_validation_condition=>'P1318_USER_SETTINGS_PAGE_TYPE'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(20215994890240611)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(20223255954240634)
,p_validation_name=>'P1318_EXISTING_PAGE not null'
,p_validation_sequence=>101
,p_validation=>'P1318_EXISTING_PAGE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P1318_USER_SETTINGS_PAGE_TYPE'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(20215994890240611)
,p_associated_item=>wwv_flow_imp.id(20220601434240614)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(20226425150240635)
,p_validation_name=>'P1318_EXISTING_PAGE available'
,p_validation_sequence=>111
,p_validation=>'return wwv_flow_wizard_api.page_exists( p_flow_id => :FB_FLOW_ID, p_page_id => :P1318_EXISTING_PAGE );'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'#LABEL# is not a page in the application.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1318_USER_SETTINGS_PAGE_TYPE = ''EXISTING''',
'and :P1318_EXISTING_PAGE is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(20215994890240611)
,p_associated_item=>wwv_flow_imp.id(20220601434240614)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(20228304010240637)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(20215524965240609)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(20228887123240639)
,p_event_id=>wwv_flow_imp.id(20228304010240637)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(20229264023240639)
,p_name=>'onChange P1318_USER_SETTINGS_PAGE_TYPE = NEW'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1318_USER_SETTINGS_PAGE_TYPE'
,p_condition_element=>'P1318_USER_SETTINGS_PAGE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(20229794519240639)
,p_event_id=>wwv_flow_imp.id(20229264023240639)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show P1318_USER_SETTINGS_PAGE_ID,P1318_NAVLIST_OPTIONS'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1318_USER_SETTINGS_PAGE_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(20230228090240640)
,p_event_id=>wwv_flow_imp.id(20229264023240639)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show P1318_EXISTING_PAGE'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1318_EXISTING_PAGE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(20230760212240640)
,p_event_id=>wwv_flow_imp.id(20229264023240639)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Hide P1318_EXISTING_PAGE'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1318_EXISTING_PAGE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(20231219726240640)
,p_event_id=>wwv_flow_imp.id(20229264023240639)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Hide P1318_USER_SETTINGS_PAGE_ID,P1318_NAVLIST_OPTIONS'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1318_USER_SETTINGS_PAGE_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2402201045642120)
,p_name=>'onClick CREATE'
,p_event_sequence=>90
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(20215994890240611)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2402343787642121)
,p_event_id=>wwv_flow_imp.id(2402201045642120)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_name=>'Submit (with spinner)'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'CREATE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(20227560024240635)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Add feature push notifications'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    declare',
'    l_feature_page       wwv_flow_app_feature_v3.t_feature_page;',
'    l_user_settings_page wwv_flow_app_feature_v3.t_user_settings_page;',
'    l_credentials_id     number;',
'begin',
'    l_feature_page.page_id := :P1318_PAGE_ID;',
'',
'    if :P1318_USER_SETTINGS_PAGE_TYPE = ''NEW'' then',
'        l_user_settings_page.page_id := :P1318_USER_SETTINGS_PAGE_ID;',
'    elsif :P1318_USER_SETTINGS_PAGE_TYPE = ''EXISTING'' then',
'        l_user_settings_page.page_id := :P1318_EXISTING_PAGE;',
'    end if;',
'',
'    l_user_settings_page.include_in_navbar := ( :P1318_USER_SETTINGS_PAGE_TYPE = ''NEW'' );',
'',
'    wwv_flow_app_feature_v3.add_feature_push_notifications(',
'        p_app_id             => :FB_FLOW_ID,',
'        p_feature_page       => l_feature_page,',
'        p_user_settings_page => l_user_settings_page );',
'',
'    :FB_FLOW_PAGE_ID := l_user_settings_page.page_id;',
'',
'    l_credentials_id := wwv_flow_pwa_dev.generate_push_credentials (',
'                            p_application_id  => :FB_FLOW_ID );',
'',
'    update wwv_flows',
'       set pwa_is_push_enabled = ''Y''',
'     where id                  = :FB_FLOW_ID',
'       and security_group_id   = :WORKSPACE_ID',
'       and pwa_is_push_enabled = ''N'';',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(20215994890240611)
,p_process_success_message=>'Push notification settings page created.'
,p_internal_uid=>20227560024240635
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(20227942620240636)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Feature page created.'
,p_internal_uid=>20227942620240636
);
end;
/
prompt --application/pages/page_01400
begin
wwv_flow_imp_page.create_page(
 p_id=>1400
,p_name=>'Report Layouts'
,p_alias=>'REPORT-LAYOUTS'
,p_step_title=>'Report Layouts'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_rpt_print.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8417745140294264)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>151
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(3621584740178712)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(19186430842313531)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>121
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(193374517232546937)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Report Layouts'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(19219825628510750)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--sideRegion:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>41
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use Report Layouts in conjunction with a report region or report query to render data in a printer-friendly format which the remote print server supports. Depending on the type of remote print server, a report layout can be designed using:',
'<ul>',
'<li>the Template Builder Word plug-in and uploaded as a file of type RTF or XSL-FO.</li>',
'<li> a Word document using a special template syntax.</li>',
'</ul>',
'</p>  ',
'<p>Note that to use this feature, your application must use a remote print server.</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(112427855874401296)
,p_plug_name=>'Report Layouts are not supported.'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>131
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'Native printing is configured for this application. A Remote Print Server is required to use Report Layouts.'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'F4000_PRINT_SERVER_TYPE'
,p_plug_display_when_cond2=>'NONE'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(188068612597706426)
,p_plug_name=>'Report Layouts Report'
,p_title=>'Report Layouts'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>141
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select l.id,',
'       l.report_layout_name,',
'       l.report_layout_type,',
'       l.last_updated_on,',
'       ''icon-sc-report-layout'' icon_class,',
'       wwv_flow_page_api.get_url(',
'           p_page        => 1405,',
'           p_clear_cache => 1405,',
'           p_items       => ''P1405_ID'',',
'           p_values      => l.id ) edit_link,',
'       replace(replace(l.report_layout_name,''_'','' ''),''.'','' '') icon_title,',
'       --',
'       case when l.reference_id is not null then',
'           coalesce ( to_char( master.flow_id ),',
'                       wwv_flow_lang_dev.builder_message( ''SUBSCRIBED_FROM.NONEXISTING_MASTER'' ) )',
'       end as subscribed_from,',
'       ( select case when count(*) > 0 then count(*) end',
'           from wwv_flow_report_layouts sub',
'          where sub.reference_id      = l.id',
'            and sub.security_group_id = :WORKSPACE_ID',
'       ) as subscribers,',
'       case when l.reference_id is not null then',
'           case',
'               when master.version_scn = l.version_scn then',
'                   wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_UP_TO_DATE'')',
'               when master.version_scn != l.version_scn then',
'                   wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_NEEDS_REFRESH'')',
'               else',
'                   wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_UNKNOWN'')',
'           end',
'       end subscription_status,',
'       --',
'       null as actions,',
'       case',
'         when    (  :F4000_PRINT_SERVER_TYPE = ''STANDARD'' ',
'                and l.report_layout_type in ( ''XSL_GENERIC'', ''XSL_FILE'' ) )',
'              or (  :F4000_PRINT_SERVER_TYPE = ''ADVANCED'' ',
'                and l.report_layout_type in ( ''XSL_GENERIC'', ''XSL_FILE'', ''RTF_FILE'' ) )',
'              or (  :F4000_PRINT_SERVER_TYPE = ''DOCUMENT_GENERATOR'' ',
'                and l.report_layout_type = ''DOCX_FILE'' ) ',
'         then ''Y'' ',
'         else ''N''',
'       end as is_compatible',
'  from wwv_flow_report_layouts l,',
'       wwv_flow_report_layouts master',
' where l.flow_id                = :FB_FLOW_ID',
'   and l.security_group_id      = :WORKSPACE_ID',
'   and l.reference_id           = master.id (+)',
'   and l.security_group_id      = master.security_group_id (+)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(188068703311706426)
,p_name=>'Report Layouts'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#EDIT_LINK#" class="a-IRR-icon"><span class="a-Icon #ICON_CLASS#"></span><span class="a-IRR-iconName">#ICON_TITLE#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(188068904394706429)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'&nbsp;'
,p_column_link=>'f?p=&APP_ID.:1405:&SESSION.::&DEBUG.:1405:P1405_ID:#ID#'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(188069015305706430)
,p_db_column_name=>'REPORT_LAYOUT_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Report Layout Name'
,p_column_link=>'f?p=&APP_ID.:1405:&SESSION.::&DEBUG.:1405:P1405_ID:#ID#'
,p_column_linktext=>'#REPORT_LAYOUT_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(188069121317706430)
,p_db_column_name=>'REPORT_LAYOUT_TYPE'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Report Layout Type'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(19274704924460373)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(188069214487706431)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>23
,p_column_identifier=>'D'
,p_column_label=>'Last Modified'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(656847718379640338)
,p_db_column_name=>'ICON_CLASS'
,p_display_order=>33
,p_column_identifier=>'E'
,p_column_label=>'Icon Class'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(656847890431640338)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>43
,p_column_identifier=>'F'
,p_column_label=>'Edit Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(656847913801640338)
,p_db_column_name=>'ICON_TITLE'
,p_display_order=>53
,p_column_identifier=>'G'
,p_column_label=>'Icon Title'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2637020595134131)
,p_db_column_name=>'SUBSCRIBED_FROM'
,p_display_order=>63
,p_column_identifier=>'H'
,p_column_label=>'Subscribed From'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2637105343134132)
,p_db_column_name=>'SUBSCRIBERS'
,p_display_order=>73
,p_column_identifier=>'I'
,p_column_label=>'Subscribers'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2637204743134133)
,p_db_column_name=>'SUBSCRIPTION_STATUS'
,p_display_order=>83
,p_column_identifier=>'J'
,p_column_label=>'Subscription Status'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2181264889145902)
,p_db_column_name=>'ACTIONS'
,p_display_order=>93
,p_column_identifier=>'L'
,p_column_label=>'Copy'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'TMPL_THEME_3$ACTIONS'
,p_column_alignment=>'CENTER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'ACTIONS_WRAP', 'N',
  'STYLE', 'b-InlineActions--simple')).to_clob
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1772224473352321)
,p_db_column_name=>'IS_COMPATIBLE'
,p_display_order=>103
,p_column_identifier=>'N'
,p_column_label=>'Is Compatible'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(84887415298521126)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(188071931554731203)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_type=>'REPORT'
,p_report_alias=>'1293911862536644'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_view_mode=>'REPORT'
,p_report_columns=>'REPORT_LAYOUT_NAME:REPORT_LAYOUT_TYPE:IS_COMPATIBLE:SUBSCRIBED_FROM:SUBSCRIPTION_STATUS:SUBSCRIBERS:LAST_UPDATED_ON:ACTIONS:'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(188996420417134295)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_imp.id(188068612597706426)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1400:&SESSION.::&DEBUG.:1400,RIR::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(19212314456481465)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(188068612597706426)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1401:&SESSION.::&DEBUG.:1401,1402,1406,1410,1420::'
,p_button_condition=>'F4000_PRINT_SERVER_TYPE'
,p_button_condition2=>'NONE'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(64802508667967798)
,p_branch_action=>'f?p=&APP_ID.:1400:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2636954630134130)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'1400'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1771997318352318)
,p_computation_sequence=>20
,p_computation_item=>'F4000_PRINT_SERVER_TYPE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_print_util.get_print_server( p_flow_id => :FB_FLOW_ID ).server_type'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(590049721385341777)
,p_name=>'Create Button - Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(19212314456481465)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(590050089668341778)
,p_event_id=>wwv_flow_imp.id(590049721385341777)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(188068612597706426)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3722003921178853)
,p_name=>'Refresh Subscriptions'
,p_event_sequence=>20
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(8417745140294264)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3722445799178880)
,p_event_id=>wwv_flow_imp.id(3722003921178853)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(188068612597706426)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3722952817178880)
,p_event_id=>wwv_flow_imp.id(3722003921178853)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ( this.data.successMessage ) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
);
wwv_flow_imp_page.create_component_action(
 p_id=>wwv_flow_imp.id(2181361173145903)
,p_ir_column_id=>wwv_flow_imp.id(2181264889145902)
,p_position_id=>wwv_flow_imp.id(214437533860142316)
,p_display_sequence=>10
,p_template_id=>wwv_flow_imp.id(214438625365151034)
,p_label=>'Copy'
,p_link_target_type=>'REDIRECT_PAGE'
,p_link_target=>'f?p=&APP_ID.:1122:&SESSION.::&DEBUG.:1122:P1122_COPY_SOURCE,P1122_ID,P1122_COPY_FROM_APPLICATION_ID:THIS,#ID#,&FB_FLOW_ID.'
,p_button_display_type=>'ICON'
,p_icon_css_classes=>'icon-copy'
,p_is_hot=>false
,p_show_as_disabled=>false
);
end;
/
prompt --application/pages/page_01401
begin
wwv_flow_imp_page.create_page(
 p_id=>1401
,p_name=>'Create Report Layout - Layout Type'
,p_alias=>'CREATE-REPORT-LAYOUT-LAYOUT-TYPE'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Report Layout'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_rpt_print.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(19262412000273146)
,p_plug_name=>'Create Report Layout'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>121
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(19267316951407102)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>21
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(19263904166280419)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(206251930124628625)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>132
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(19270027602429073)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(206251930124628625)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1725303334680636)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(206251930124628625)
,p_button_name=>'COPY_FROM_ANOTHER'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Copy from another app'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:1122:&SESSION.::&DEBUG.:1122:P1122_COPY_SOURCE:OTHER'
,p_button_css_classes=>'a-Button--noUI'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(19273508125442354)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(206251930124628625)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(19273821194442355)
,p_branch_name=>'Go To Page 1402'
,p_branch_action=>'f?p=&APP_ID.:1402:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(19273508125442354)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1401_LAYOUT_TYPE'
,p_branch_condition_text=>'GENERIC'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(87922012615914366)
,p_branch_name=>'Go To Page 1406'
,p_branch_action=>'f?p=&APP_ID.:1406:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(19273508125442354)
,p_branch_sequence=>40
,p_branch_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_branch_condition=>'P1401_LAYOUT_TYPE'
,p_branch_condition_text=>'FILE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1724572248675623)
,p_name=>'P1401_LAYOUT_NAME'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(19262412000273146)
,p_prompt=>'Layout Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a name for this Report Layout.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2220800374674307)
,p_name=>'P1401_STATIC_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(19262412000273146)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(19276201938468960)
,p_name=>'P1401_LAYOUT_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(19262412000273146)
,p_item_default=>'XSL_GENERIC'
,p_prompt=>'Report Layout Type'
,p_source=>'XSL_GENERIC'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'REPORT.LAYOUT.GENERIC_OR_FILE'
,p_lov=>'.'||wwv_flow_imp.id(1805850678716417)||'.'
,p_read_only_when=>':F4000_PRINT_SERVER_TYPE in ( ''DOCUMENT_GENERATOR'', ''AOP'' )'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select the type of report layout that you want to create:',
'<ul>',
'<li><strong>Generic Columns</strong> uses the default template to populate the report. In the next step, you can customize the default code.',
'</li>',
'<li><strong>Named Columns</strong> requires that you upload a file in the next step.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2220942855674308)
,p_computation_sequence=>10
,p_computation_item=>'P1401_STATIC_ID'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'replace( upper( substr( :P1401_LAYOUT_NAME, 1, 255 ) ), '' '', ''_'' )'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1772094273352319)
,p_computation_sequence=>10
,p_computation_item=>'P1401_LAYOUT_TYPE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case',
'    when :F4000_PRINT_SERVER_TYPE in ( ''DOCUMENT_GENERATOR'', ''AOP'' ) then ''FILE''',
'    else ''GENERIC''',
'end'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(590014310420897536)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(19270027602429073)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(590014489798897537)
,p_event_id=>wwv_flow_imp.id(590014310420897536)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_01402
begin
wwv_flow_imp_page.create_page(
 p_id=>1402
,p_name=>'Create Report Layout - Layout Source'
,p_alias=>'CREATE-REPORT-LAYOUT-LAYOUT-SOURCE'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Report Layout'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_rpt_print.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22672623482009564)
,p_plug_name=>'Create Report Layout'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>121
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22672823029009564)
,p_plug_name=>'Report Layout'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(399849897040726767)
,p_plug_display_sequence=>122
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'A <strong>generic report layout</strong> can be used for different reports. The number of columns and column headings are derived from the report definition and automatically adjusted when generating the printable document. A number of report layout '
||'attributes can be defined declaratively for report regions using the built-in XSL-FO default layout. This wizard allows for creating customizable copies of the built-in default XSL-FO layout, if additional control over the page layout is needed.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22673222331009565)
,p_plug_name=>'Progress Indicator'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>21
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(19263904166280419)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(206253106145640649)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>131
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(22674122579009566)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(206253106145640649)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(22673914622009565)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(206253106145640649)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Layout'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(22701918098086891)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(206253106145640649)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1401:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(22674617596009566)
,p_branch_action=>'f?p=&APP_ID.:1400:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(22674122579009566)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22707029480145653)
,p_name=>'P1402_PRINT_TEMPLATE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(22672623482009564)
,p_prompt=>'Report Layout:'
,p_source=>'wwv_flow_utilities.clob_to_varchar2(wwv_render_report3.g_prn_template);'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>8
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">The report layout is the XSL-FO based definition of the page formatting. All attributes defining page size, orientation, fonts, styles, and so forth, are defined in this section. </div>',
'',
'<div class="htmldbInfoBodyP">The following are valid substitution strings: </div>',
'<ul class="noIndent">',
'<li>#PAGE_HEADER#</li>',
'<li>#PAGE_HEADERFONT_COLOR#</li>',
'<li>#PAGE_HEADER_FONT_FAMILY#</li>',
'<li>#PAGE_HEADER_FONT_SIZE#</li>',
'<li>#PAGE_HEADER_FONT_WEIGHT#</li>',
'<li>#PAGE_FOOTER#</li>',
'<li>#PAGE_FOOTER_FONT_COLOR#</li>',
'<li>#PAGE_FOOTER_FONT_FAMILY#</li>',
'<li>#PAGE_FOOTER_FONT_SIZE#</li>',
'<li>#PAGE_FOOTER_FONT_WEIGHT#</li>',
'<li>#PAGE_WIDTH#</li>',
'<li>#PAGE_HEIGHT#</li>',
'<li>#HEADER_BG_COLOR#</li>',
'<li>#HEADER_FONT_COLOR#</li>',
'<li>#HEADER_FONT_FAMILY#</li>',
'<li>#HEADER_FONT_SIZE#</li>',
'<li>#HEADER_FONT_WEIGHT#</li>',
'<li>#BODY_BG_COLOR#</li>',
'<li>#BODY_FONT_COLOR#</li>',
'<li>#BODY_FONT_FAMILY#</li>',
'<li>#BODY_FONT_SIZE#</li>',
'<li>#BODY_FONT_WEIGHT#</li>',
'<li>#BORDER_WIDTH#</li>',
'</ul>',
'<div class="htmldbInfoBodyP">In order to make the report layout generic, there are additional sub templates defined that specify the layout for each individual column, column heading and column width. At runtime, those sub templates are dynamically a'
||'ssembled and included in the main report layout automatically by substituting the following strings: </div>',
'<ul class="noIndent">',
'<li>#PRN_TABLE_CELLS#</li>',
'<li>#PRN_TEMPLATE_BODY_ROW#</li>',
'<li>#PRN_TEMPLATE_HEADER_ROW#</li>',
'</ul>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22707214514145653)
,p_name=>'P1402_REPORT_COLUMN_HEADING'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(22672623482009564)
,p_prompt=>'Report Column Heading:'
,p_source=>'wwv_render_report3.g_prn_template_header_col'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The report column heading defines the look of each cell in the report heading row.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22707427995145653)
,p_name=>'P1402_REPORT_COLUMN'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(22672623482009564)
,p_prompt=>'Report Column:'
,p_source=>'wwv_render_report3.g_prn_template_body_col'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The report column defines the look of each cell for all report rows. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22707605511145653)
,p_name=>'P1402_REPORT_COLUMN_WIDTH'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(22672623482009564)
,p_prompt=>'Report Column Width:'
,p_source=>'wwv_render_report3.g_prn_template_table_cell'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>2
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The report column width is computed at runtime time or can be derived from the report column definition of a report region. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(102690721829277876)
,p_validation_name=>'P1402_PRINT_TEMPLATE'
,p_validation_sequence=>20
,p_validation=>'P1402_PRINT_TEMPLATE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Layout must be specified.'
,p_validation_condition=>'P1401_LAYOUT_TYPE'
,p_validation_condition2=>'XSL_GENERIC'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(22673914622009565)
,p_associated_item=>wwv_flow_imp.id(22707029480145653)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(102709025339307349)
,p_validation_name=>'P1402_REPORT_COLUMN_HEADING'
,p_validation_sequence=>30
,p_validation=>'P1402_REPORT_COLUMN_HEADING'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Column Heading must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(22673914622009565)
,p_associated_item=>wwv_flow_imp.id(22707214514145653)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(102710531226309015)
,p_validation_name=>'P1402_REPORT_COLUMN'
,p_validation_sequence=>40
,p_validation=>'P1402_REPORT_COLUMN'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Column must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(22673914622009565)
,p_associated_item=>wwv_flow_imp.id(22707427995145653)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(102711905384311046)
,p_validation_name=>'P1402_REPORT_COLUMN_WIDTH'
,p_validation_sequence=>50
,p_validation=>'P1402_REPORT_COLUMN_WIDTH'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Column Width must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(22673914622009565)
,p_associated_item=>wwv_flow_imp.id(22707605511145653)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(590014539571897538)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(22674122579009566)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(590014601233897539)
,p_event_id=>wwv_flow_imp.id(590014539571897538)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(23576703960481102)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create report layout'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_imp_shared.create_report_layout (',
'    p_flow_id                     => nv(''FB_FLOW_ID''),',
'    p_report_layout_name          => :P1401_LAYOUT_NAME,',
'    p_report_layout_type          => ''XSL_GENERIC'',',
'    p_page_template               => :P1402_PRINT_TEMPLATE,',
'    p_xslfo_column_heading        => :P1402_REPORT_COLUMN_HEADING,',
'    p_xslfo_column_template       => :P1402_REPORT_COLUMN,',
'    p_xslfo_column_template_width => :P1402_REPORT_COLUMN_WIDTH',
');'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(22673914622009565)
,p_internal_uid=>23576703960481102
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(590015265155897545)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,F4000_LAST_VIEW'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(22673914622009565)
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>590015265155897545
);
end;
/
prompt --application/pages/page_01405
begin
wwv_flow_imp_page.create_page(
 p_id=>1405
,p_name=>'Edit Report Layout'
,p_alias=>'EDIT-REPORT-LAYOUT'
,p_step_title=>'Edit Report Layout'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_read_only_when=>'P1405_REFERENCE_ID'
,p_help_text=>'bldapp_rpt_print.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(19760723807975372)
,p_plug_name=>'Subscription'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P1405_ID'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'WWV_FLOW_REPORT_LAYOUTS',
  'attribute_02', 'REPORT_LAYOUT_NAME',
  'attribute_03', 'P1405_ID',
  'attribute_04', 'P1405_REFERENCE_ID',
  'attribute_05', 'SUBSCRIBE_REPORT_LAYOUT',
  'attribute_06', 'VERSION_SCN')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(24414923466637064)
,p_plug_name=>'Report Layout Attributes'
,p_region_name=>'L'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(24429902451664898)
,p_plug_name=>'Report Layout'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_REPORT_LAYOUTS_DEV'
,p_query_where=>'security_group_id = :WORKSPACE_ID'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'u:d'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(24435001197674011)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p><strong>Generic column report layouts</strong> can be edited on this page. The page template specifies the overall look and feel of the formatted document. The report column heading, report column and column width sub templates are used to further'
||' customize how column headings and columns are formatted.</p>',
'',
'<p><strong>Named column report layouts</strong> are file based. To change, download the current file using the download button on this page, then modify the file as needed. Afterwards, upload the modified file as a new report layout.</p>',
'<p>When report layout is subscribed, then it is not possible to change any data.</p>',
'<p>Deletion of the <strong>master</strong> report layout automatically clears the report layout references from subscribing report layouts.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(24466514104734503)
,p_plug_name=>'Comments'
,p_region_name=>'C'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46251916439678999)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>70
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(73493529825371212)
,p_plug_name=>'Report Layout'
,p_region_name=>'F'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P1405_REPORT_LAYOUT_TYPE'
,p_plug_display_when_cond2=>'XSL_GENERIC'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(620059301928486921)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_imp.id(29434107863295859)
,p_plug_display_sequence=>60
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from WWV_FLOW_REPORT_LAYOUTS',
'where id = :P1405_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :P1405_ID,',
'      p_component_type => ''Application Item'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P1405_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3636996927315967)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_imp.id(19760723807975372)
,p_button_name=>'UNSUBSCRIBE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Unsubscribe'
,p_button_position=>'EDIT'
,p_button_condition=>':P1405_REFERENCE_ID is not null and :P1405_SUBSCRIBED_COMP_GRP = ''N'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3637319540315968)
,p_button_sequence=>110
,p_button_plug_id=>wwv_flow_imp.id(19760723807975372)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Refresh Report Layout'
,p_button_position=>'EDIT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1405_REFERENCE_ID is not null ',
'and ( :P1405_VERSION_SCN != :P1405_MASTER_VERSION_SCN or :P1405_VERSION_SCN is null )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3637768468315968)
,p_button_sequence=>120
,p_button_plug_id=>wwv_flow_imp.id(19760723807975372)
,p_button_name=>'PUBLISH'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Publish'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.:149:F4000_P149_ID,F4000_P149_TEMPLATE_TYPE,F4000_P149_PAGE_ID:&P1405_ID.,REPORT_LAYOUT,1405'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * ',
'  from wwv_flow_report_layouts',
' where reference_id      = :P1405_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(24415815491637074)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(24429902451664898)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1400:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(24416028989637075)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(24429902451664898)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_confirm_message=>'&DELETE_MSG.'
,p_confirm_style=>'danger'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1405_ID is not null',
'and ( :P1405_REFERENCE_ID is null or :P1405_SUBSCRIBED_COMP_GRP = ''N'' )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(24416206163637075)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(24429902451664898)
,p_button_name=>'SAVE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>':P1405_ID is not null and :P1405_REFERENCE_ID is null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2220542262674304)
,p_branch_name=>'Go To Page 1405'
,p_branch_action=>'f?p=&APP_ID.:1405:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1405_RETURN_TO_PAGE'
,p_branch_condition_text=>'YES'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(88131709189566174)
,p_branch_name=>'Go To Page 1400'
,p_branch_action=>'f?p=&APP_ID.:1400:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1770299790352301)
,p_name=>'P1405_FILE_CONTENT'
,p_source_data_type=>'BLOB'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(24414923466637064)
,p_item_source_plug_id=>wwv_flow_imp.id(24429902451664898)
,p_prompt=>'File'
,p_source=>'FILE_CONTENT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>30
,p_display_when=>'P1405_REPORT_LAYOUT_TYPE'
,p_display_when2=>'XSL_GENERIC'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Select the file containing the report layout you want to add.'
,p_attribute_01=>'DB_COLUMN'
,p_attribute_02=>'MIME_TYPE'
,p_attribute_03=>'FILE_NAME'
,p_attribute_06=>'Y'
,p_attribute_08=>'attachment'
,p_attribute_11=>'&P1405_FILE_TYPES.'
,p_attribute_12=>'DROPZONE_INLINE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1771188666352310)
,p_name=>'P1405_FILE_TYPES'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(24414923466637064)
,p_item_source_plug_id=>wwv_flow_imp.id(24429902451664898)
,p_source=>'FILE_TYPES'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2207652009697442)
,p_name=>'P1405_DATA_LOOP_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(24414923466637064)
,p_item_source_plug_id=>wwv_flow_imp.id(24429902451664898)
,p_prompt=>'Data Loop Name'
,p_source=>'DATA_LOOP_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_display_when=>'P1405_REPORT_LAYOUT_TYPE'
,p_display_when2=>'RTF_FILE:XSL_FILE:XSL_GENERIC'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Speficy the name of the data loop in the report layout. ',
'This name is used as the name the rows array of the JSON data when printing report regions with the report layout.',
'If no name is specified, the identifier <strong>items</strong> is used.'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2220433789674303)
,p_name=>'P1405_ETAG'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(24414923466637064)
,p_item_source_plug_id=>wwv_flow_imp.id(24429902451664898)
,p_source=>'ETAG'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2221045275674309)
,p_name=>'P1405_STATIC_ID'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(24414923466637064)
,p_item_source_plug_id=>wwv_flow_imp.id(24429902451664898)
,p_prompt=>'Static ID'
,p_source=>'STATIC_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>500
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Static ID for this report layout. The static ID is used when referencing the report layout in API Calls.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2359875552667343)
,p_name=>'P1405_SUBSCRIBED_COMP_GRP'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(19760723807975372)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2638363559134144)
,p_name=>'P1405_REFERENCE_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(19760723807975372)
,p_item_source_plug_id=>wwv_flow_imp.id(24429902451664898)
,p_prompt=>'Subscribe From'
,p_source=>'REFERENCE_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FLOW_SUBSCRIBE_FROM_REPORT_LAYOUTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select b.flow_id ||'' ''||f.name||'' - ''|| b.report_layout_name d,',
'       b.id r',
'  from wwv_flow_report_layouts b,',
'       wwv_flows f',
' where b.flow_id          != nvl(:FB_FLOW_ID,0)',
'   and b.flow_id           = f.id',
'   and f.build_status      not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'   and b.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and f.security_group_id = :FLOW_SECURITY_GROUP_ID',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Subscription -'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a master report layout to subscribe from. When you select a master report layout and click on the <strong>Apply Changes</strong> button, the report layout details will be automatically refreshed from the selected master.<br /><br />If the repo'
||'rt layout is already subscribed, then click on the <strong>Refresh Report Layout</strong> button to refresh the report layout details from the master report layout.'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'Y'
,p_attribute_06=>'0'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2638433614134145)
,p_name=>'P1405_VERSION_SCN'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(24414923466637064)
,p_item_source_plug_id=>wwv_flow_imp.id(24429902451664898)
,p_source=>'VERSION_SCN'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3625797852310603)
,p_name=>'P1405_REFERENCE_ID_INIT'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(19760723807975372)
,p_use_cache_before_default=>'NO'
,p_item_default=>'P1405_REFERENCE_ID'
,p_item_default_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3625835180310604)
,p_name=>'P1405_MASTER_VERSION_SCN'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(19760723807975372)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select version_scn ',
'  from wwv_flow_report_layouts',
' where id                = :P1405_REFERENCE_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8639496076538649)
,p_name=>'P1405_RETURN_TO_PAGE'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(24435001197674011)
,p_prompt=>'Stay on Page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_display_when=>'P1405_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_read_only_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_help_text=>'Select this checkbox to stay on this page after applying changes.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'YES'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(24416407333637076)
,p_name=>'P1405_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(24414923466637064)
,p_item_source_plug_id=>wwv_flow_imp.id(24429902451664898)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(24416601650637076)
,p_name=>'P1405_FLOW_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(24414923466637064)
,p_item_source_plug_id=>wwv_flow_imp.id(24429902451664898)
,p_item_default=>'&FB_FLOW_ID.'
,p_source=>'FLOW_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(24416825978637077)
,p_name=>'P1405_REPORT_LAYOUT_NAME'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(24414923466637064)
,p_item_source_plug_id=>wwv_flow_imp.id(24429902451664898)
,p_prompt=>'Report Layout Name'
,p_source=>'REPORT_LAYOUT_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter a name to identify the report layout when associating it with a report query or report region. Saved report layouts appear under Shared Components.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(24417002849637077)
,p_name=>'P1405_REPORT_LAYOUT_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(24414923466637064)
,p_item_source_plug_id=>wwv_flow_imp.id(24429902451664898)
,p_prompt=>'Report Layout Type'
,p_source=>'REPORT_LAYOUT_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'REPORT.LAYOUT.TYPES'
,p_lov=>'.'||wwv_flow_imp.id(19274704924460373)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Type of report layout.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(24417403259637077)
,p_name=>'P1405_XSLFO_COL_HEADING_TEMP'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(73493529825371212)
,p_item_source_plug_id=>wwv_flow_imp.id(24429902451664898)
,p_prompt=>'Report Column Heading:'
,p_source=>'XSLFO_COLUMN_HEADING_TEMPLATE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>8
,p_display_when=>'P1405_REPORT_LAYOUT_TYPE'
,p_display_when2=>'XSL_GENERIC'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_is_persistent=>'N'
,p_help_text=>'The report column heading defines the look of each cell in the report heading row.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(24417613138637077)
,p_name=>'P1405_XSLFO_COLUMN_TEMPLATE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(73493529825371212)
,p_item_source_plug_id=>wwv_flow_imp.id(24429902451664898)
,p_prompt=>'Column Template:'
,p_source=>'XSLFO_COLUMN_TEMPLATE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>8
,p_display_when=>'P1405_REPORT_LAYOUT_TYPE'
,p_display_when2=>'XSL_GENERIC'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_is_persistent=>'N'
,p_help_text=>'The report column defines the look of each cell for all report rows. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(24417815077637077)
,p_name=>'P1405_REPORT_LAYOUT_COMMENT'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(24466514104734503)
,p_item_source_plug_id=>wwv_flow_imp.id(24429902451664898)
,p_prompt=>'Report Layout Comment'
,p_source=>'REPORT_LAYOUT_COMMENT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_is_persistent=>'N'
,p_help_text=>'Enter any comments or notes here. These comments will never be displayed when running the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(24418014686637078)
,p_name=>'P1405_XSLFO_COL_TEMPLATE_WID'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(73493529825371212)
,p_item_source_plug_id=>wwv_flow_imp.id(24429902451664898)
,p_prompt=>'Column Template Width:'
,p_source=>'XSLFO_COLUMN_TEMPLATE_WIDTH'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_display_when=>'P1405_REPORT_LAYOUT_TYPE'
,p_display_when2=>'XSL_GENERIC'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_is_persistent=>'N'
,p_help_text=>'The report column width is computed at runtime time or can be derived from the report column definition of a report region. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(80051121794611628)
,p_name=>'P1405_PAGE_TEMPLATE'
,p_data_type=>'CLOB'
,p_source_data_type=>'CLOB'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(73493529825371212)
,p_item_source_plug_id=>wwv_flow_imp.id(24429902451664898)
,p_prompt=>'Page Template:'
,p_source=>'PAGE_TEMPLATE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>12
,p_display_when=>'P1405_REPORT_LAYOUT_TYPE'
,p_display_when2=>'XSL_GENERIC'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">The report layout is the XSL-FO based definition of the page formatting. All attributes defining page size, orientation, fonts, styles, and so forth, are defined in this section. </div>',
'',
'<div class="htmldbInfoBodyP">The following are valid substitution strings: </div>',
'<ul class="noIndent">',
'<li>#PAGE_HEADER#</li>',
'<li>#PAGE_HEADERFONT_COLOR#</li>',
'<li>#PAGE_HEADER_FONT_FAMILY#</li>',
'<li>#PAGE_HEADER_FONT_SIZE#</li>',
'<li>#PAGE_HEADER_FONT_WEIGHT#</li>',
'<li>#PAGE_FOOTER#</li>',
'<li>#PAGE_FOOTER_FONT_COLOR#</li>',
'<li>#PAGE_FOOTER_FONT_FAMILY#</li>',
'<li>#PAGE_FOOTER_FONT_SIZE#</li>',
'<li>#PAGE_FOOTER_FONT_WEIGHT#</li>',
'<li>#PAGE_WIDTH#</li>',
'<li>#PAGE_HEIGHT#</li>',
'<li>#HEADER_BG_COLOR#</li>',
'<li>#HEADER_FONT_COLOR#</li>',
'<li>#HEADER_FONT_FAMILY#</li>',
'<li>#HEADER_FONT_SIZE#</li>',
'<li>#HEADER_FONT_WEIGHT#</li>',
'<li>#BODY_BG_COLOR#</li>',
'<li>#BODY_FONT_COLOR#</li>',
'<li>#BODY_FONT_FAMILY#</li>',
'<li>#BODY_FONT_SIZE#</li>',
'<li>#BODY_FONT_WEIGHT#</li>',
'<li>#BORDER_WIDTH#</li>',
'</ul>',
'<div class="htmldbInfoBodyP">In order to make the report layout generic, there are additional sub templates defined that specify the layout for each individual column, column heading and column width. At runtime, those sub templates are dynamically a'
||'ssembled and included in the main report layout automatically by substituting the following strings: </div>',
'<ul class="noIndent">',
'<li>#PRN_TABLE_CELLS#</li>',
'<li>#PRN_TEMPLATE_BODY_ROW#</li>',
'<li>#PRN_TEMPLATE_HEADER_ROW#</li>',
'</ul>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2359916413667344)
,p_computation_sequence=>10
,p_computation_item=>'P1405_SUBSCRIBED_COMP_GRP'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_component_group_dev.is_part_of_subscribed_comp_grp (',
'    p_component_id   => :P1405_ID,',
'    p_component_type => wwv_flow_copy_metadata.c_report_layout,',
'    p_app_id         => :FB_FLOW_ID )'))
,p_compute_when=>'P1405_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(24418506917637079)
,p_validation_name=>'P1405_REPORT_LAYOUT_NAME not null'
,p_validation_sequence=>10
,p_validation=>'P1405_REPORT_LAYOUT_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Report Layout Name must have some value.'
,p_associated_item=>wwv_flow_imp.id(24416825978637077)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(102647402511177723)
,p_validation_name=>'P1405_REPORT_LAYOUT_NAME'
,p_validation_sequence=>20
,p_validation=>'P1405_REPORT_LAYOUT_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Report layout name must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(24416206163637075)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(102649828484185269)
,p_validation_name=>'REPORT_LAYOUT_NAME UNIQUE'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_report_layouts',
' where report_layout_name = :P1405_REPORT_LAYOUT_NAME',
'   and id                 <> :P1405_ID',
'   and flow_id            = :FB_FLOW_ID',
'   and security_group_id  = :WORKSPACE_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Report layout name must be unique, a report layout called &P1405_REPORT_LAYOUT_NAME. already exists. '
,p_when_button_pressed=>wwv_flow_imp.id(24416206163637075)
,p_associated_item=>wwv_flow_imp.id(24416825978637077)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(102383802296837045)
,p_validation_name=>'P1405_PAGE_TEMPLATE'
,p_validation_sequence=>40
,p_validation=>'P1405_PAGE_TEMPLATE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Page template must be specified. '
,p_validation_condition=>':P1405_REPORT_LAYOUT_TYPE = ''XSL_GENERIC'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(24416206163637075)
,p_associated_item=>wwv_flow_imp.id(80051121794611628)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(102488518460983606)
,p_validation_name=>'P1405_XSLFO_COL_HEADING_TEMP not null'
,p_validation_sequence=>50
,p_validation=>'P1405_XSLFO_COL_HEADING_TEMP'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Column heading must be specified.'
,p_validation_condition=>':P1405_REPORT_LAYOUT_TYPE = ''XSL_GENERIC'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(24416206163637075)
,p_associated_item=>wwv_flow_imp.id(24417403259637077)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(102490530927987245)
,p_validation_name=>'P1405_XSLFO_COLUMN_TEMPLATE'
,p_validation_sequence=>60
,p_validation=>'P1405_XSLFO_COLUMN_TEMPLATE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'A column template must be specified.'
,p_validation_condition=>':P1405_REPORT_LAYOUT_TYPE = ''XSL_GENERIC'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(24416206163637075)
,p_associated_item=>wwv_flow_imp.id(24417613138637077)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(102492204392989060)
,p_validation_name=>'P1405_XSLFO_COL_TEMPLATE_WID not null'
,p_validation_sequence=>70
,p_validation=>'P1405_XSLFO_COL_TEMPLATE_WID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Column width must be specified.'
,p_validation_condition=>':P1405_REPORT_LAYOUT_TYPE = ''XSL_GENERIC'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(24416206163637075)
,p_associated_item=>wwv_flow_imp.id(24418014686637078)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3651812485593526)
,p_validation_name=>'No duplicate subscription'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_report_layouts',
' where security_group_id = :WORKSPACE_ID ',
'   and flow_id           = :FB_FLOW_ID ',
'   and reference_id      = :P1405_REFERENCE_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'An existing report layout in this application is subscribed to the same master. Please select another master report layout.'
,p_validation_condition=>':P1405_REFERENCE_ID is not null and :P1405_REFERENCE_ID_INIT is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(24416206163637075)
,p_associated_item=>wwv_flow_imp.id(2638363559134144)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3916264547238640)
,p_validation_name=>'Not part of component groups'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not wwv_flow_component_group_dev.is_part_of_comp_grp (',
'    p_component_id   => :P1405_ID,',
'    p_component_type => wwv_flow_copy_metadata.c_report_layout,',
'    p_app_id         => :FB_FLOW_ID )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Report Layout cannot be deleted because it is part of a component group.'
,p_when_button_pressed=>wwv_flow_imp.id(24416028989637075)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3625994245310605)
,p_name=>'Hide P1405_REFERENCE_ID'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P1405_REFERENCE_ID'
,p_da_event_comment=>'We can hide this item P1405_REFERENCE_ID using server side condition for the item. But, when item is hidden using item''s serverside condition, then "Refresh" process won''t work. Because refresh process is using P1405_REFERENCE_ID item and the item va'
||'lue will not be available during serverside processing when item is hidden from server side during rendering. Point to be noted, this is happening because P1405_REFERENCE_ID item is part of form region.'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3626092768310606)
,p_event_id=>wwv_flow_imp.id(3625994245310605)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1405_REFERENCE_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2360086457667345)
,p_name=>'Save'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(24416206163637075)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2360126202667346)
,p_event_id=>wwv_flow_imp.id(2360086457667345)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'Are you sure you want to subscribe? This will overwrite the current report layout data with the selected master report layout.'
,p_attribute_03=>'warning'
,p_attribute_06=>'Subscribe'
,p_attribute_07=>'Cancel'
,p_client_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_client_condition_expression=>'$v(''P1405_REFERENCE_ID'') !== "" && $v(''P1405_REFERENCE_ID_INIT'') === ""'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2360243267667347)
,p_event_id=>wwv_flow_imp.id(2360086457667345)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'SAVE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3625628518310602)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(24429902451664898)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process form Report Layout'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'SAVE,DELETE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'Report Layout saved.'
,p_internal_uid=>3625628518310602
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3652269686611324)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh Report Layout'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.refresh_component (',
'    p_component_type     => wwv_flow_copy_metadata.c_report_layout,',
'    p_master_id          => :P1405_REFERENCE_ID,',
'    p_subscribing_id     => :P1405_ID,',
'    p_subscribing_app_id => :FB_FLOW_ID );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error during report layout refresh.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST = ''REFRESH''',
'or ( :REQUEST = ''SAVE'' and :P1405_REFERENCE_ID is not null and :P1405_REFERENCE_ID_INIT is null )'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Report layout refreshed from the master.'
,p_internal_uid=>3652269686611324
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3652729511670207)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Unsubscribe'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.unsubscribe_component (',
'    p_component_type  => wwv_flow_copy_metadata.c_report_layout,',
'    p_component_id    => :P1405_ID,',
'    p_app_id          => :FB_FLOW_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3636996927315967)
,p_process_success_message=>'Report layout has been unsubscribed.'
,p_internal_uid=>3652729511670207
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3653221730680950)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Clear Subscriptions'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- when deleting the component, clear reference_id data from subscribing apps',
'--',
'wwv_flow_copy_metadata.clear_subscriptions (',
'    p_component_type => wwv_flow_copy_metadata.c_report_layout,',
'    p_master_id      => :P1405_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(24416028989637075)
,p_internal_uid=>3653221730680950
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2637478707134135)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(24429902451664898)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Edit Report Layout'
,p_internal_uid=>2637478707134135
);
end;
/
prompt --application/pages/page_01406
begin
wwv_flow_imp_page.create_page(
 p_id=>1406
,p_name=>'Create Report Query - Layout Source'
,p_alias=>'CREATE-REPORT-QUERY-LAYOUT-SOURCE'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Report Query'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(22569212548659511)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_rpt_print.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(87894608610830159)
,p_plug_name=>'Create Shared Query'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(19263904166280419)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(87895011130830160)
,p_plug_name=>'Create Report Query Layout'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_item_display_point=>'BELOW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1771311826352312)
,p_plug_name=>'Oracle Analytics Publisher'
,p_parent_plug_id=>wwv_flow_imp.id(87895011130830160)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'F4000_PRINT_SERVER_TYPE'
,p_plug_display_when_cond2=>'ADVANCED'
,p_plug_header=>'<p>Upload the report layout as a RTF or XSL-FO file. RTF files can be created using the Oracle BI Publisher plug-in for MS Word, which makes report layout design easy by providing a simple drag & drop interface. This plug-in uses a XML version of the'
||' report result set as source data. This XML data can be downloaded from the report query edit page.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1771444305352313)
,p_plug_name=>'External (Apache FOP)'
,p_parent_plug_id=>wwv_flow_imp.id(87895011130830160)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'F4000_PRINT_SERVER_TYPE'
,p_plug_display_when_cond2=>'STANDARD'
,p_plug_header=>'<p>Upload the report layout as an XSL-FO file. This report layout uses an XML version of the report result set as source data. This XML data can be downloaded from the report query edit page.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1771502989352314)
,p_plug_name=>'Oracle Document Generator Pre-built Function'
,p_parent_plug_id=>wwv_flow_imp.id(87895011130830160)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'F4000_PRINT_SERVER_TYPE'
,p_plug_display_when_cond2=>'DOCUMENT_GENERATOR'
,p_plug_header=>'<p>Upload the report layout as a DOCX file. This report layout uses a JSON version of the report result set as source data. This JSON data can be downloaded from the report query edit page.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1771670490352315)
,p_plug_name=>'Upload File'
,p_parent_plug_id=>wwv_flow_imp.id(87895011130830160)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(206255614587652551)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(87895909442830167)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(206255614587652551)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(87896302874830169)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(206255614587652551)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Layout'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(87896124686830169)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(206255614587652551)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1401:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1771728947352316)
,p_name=>'P1406_FILE_TYPES'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1771670490352315)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(87898511267830172)
,p_name=>'P1406_LAYOUT_FILE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1771670490352315)
,p_prompt=>'Report Layout File'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select the file containing the report layout you want to add.'
,p_attribute_01=>'APEX_APPLICATION_TEMP_FILES'
,p_attribute_09=>'SESSION'
,p_attribute_10=>'N'
,p_attribute_11=>'&P1406_FILE_TYPES.'
,p_attribute_12=>'DROPZONE_INLINE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1771845829352317)
,p_computation_sequence=>10
,p_computation_item=>'P1406_FILE_TYPES'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_report_layout_dev.get_supported_mime_types( :F4000_PRINT_SERVER_TYPE )'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(102326711244735599)
,p_validation_name=>'P1406_LAYOUT_FILE'
,p_validation_sequence=>20
,p_validation=>'P1406_LAYOUT_FILE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Report layout file must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(87896302874830169)
,p_associated_item=>wwv_flow_imp.id(87898511267830172)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(590014726329897540)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(87895909442830167)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(590014812036897541)
,p_event_id=>wwv_flow_imp.id(590014726329897540)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(87899507927830176)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create layout'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_report_layout_dev.create_layout(',
'    p_application_id    => :FB_FLOW_ID,',
'    p_layout_name       => :P1401_LAYOUT_NAME,',
'    p_static_id         => :P1401_STATIC_ID,',
'    p_file_name         => :P1406_LAYOUT_FILE );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(87896302874830169)
,p_process_when=>'P1406_REPORT_LAYOUT_ID'
,p_process_when_type=>'ITEM_IS_NULL_OR_ZERO'
,p_internal_uid=>87899507927830176
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(590014925962897542)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,F4000_LAST_VIEW'
,p_attribute_02=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(87896302874830169)
,p_process_success_message=>'Report Layout created.'
,p_internal_uid=>590014925962897542
);
end;
/
prompt --application/pages/page_01500
begin
wwv_flow_imp_page.create_page(
 p_id=>1500
,p_name=>'App Builder'
,p_alias=>'APPS'
,p_step_title=>'Applications - App Builder'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213220627333807318)
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.theme.defaultStickyTop = function() {',
'   return $("#apps_irr_wrap_toolbar").outerHeight();',
'}'))
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/* Developer Toolbar integration */',
'apex.builder.nameBuilderWindow();',
'apex.jQuery(''#apps_irr_toolbar'').wrap(''<div class="a-IRR-toolbarWrap" id="apps_irr_wrap_toolbar"></div>'');',
'apex.builder.initStickyHeader(''apps_irr_wrap_toolbar'');'))
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_hm.htm'
,p_page_component_map=>'13'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(2774522728910972)
,p_name=>'Recent'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_display_point=>'REGION_POSITION_03'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select substr(name,1,20)||'' - ''||id name, id',
'from wwv_flow_visible_flows f',
'where build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'  and f.id not in ( select id ',
'                      from wwv_working_copy_apps_dev ',
'                     where security_group_id = f.security_group_id )',
'order by last_updated_on desc'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(11667910335347890)
,p_query_num_rows=>8
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No Applications found.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>90
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2777108446925756)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=4000:1:&SESSION.::&DEBUG.:RP:FB_FLOW_ID,F4000_P1_FLOW,RECENT_PAGES:#ID#,#ID#,'
,p_column_linktext=>'#NAME#'
,p_column_link_attr=>'alt="&EDIT." title="&EDIT."'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2774923910910975)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2779905591943838)
,p_plug_name=>'Workspace Utilities'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#:a-LinksList--nowrap:a-LinksList--showArrow'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(2778715503937249)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
,p_plug_display_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3519628466105919)
,p_plug_name=>'Applications'
,p_region_name=>'apps_irr'
,p_region_css_classes=>'a-IRR-region--responsiveIconViewWide a-IRR-region--showTopBorder a-AppCards a-AppCards--slim a-AppCards--irr'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'app_id,',
'id,',
'img,',
'authentication_scheme,',
'link,',
'name,',
'app_name,',
'owner as app_owner,',
'nvl( image_class, '' '' ) as image_class,',
'case when image_class is null and app_builder_icon_name is null then wwv_flow_4000_ui.get_app_initials( app_name, app_id )',
'     else '' ''',
'end as app_initials,',
'case when image_class is null  and app_builder_icon_name is null then ''u-color-'' || to_char( ora_hash( app_name, 44 ) + 1 ) || ''-bg''',
'     else '' ''',
'end as app_color,',
'case ',
'   when app_builder_icon_name is null then '' ''',
'   else ''<span class="a-AppCards-icon-img" style="background-image: url('''''' ||',
'        wwv_flow_utilities.get_friendly_app_url (',
'            p_application_id    => id,',
'            p_security_group_id => security_group_id,',
'            p_url               => ''files/static/v'' || files_version || ''/'' ) ||',
'        wwv_flow_escape.html_attribute(app_builder_icon_name) ||',
'        '''''');"></span>'' ',
'end app_builder_icon_name,',
'build_status,',
'flow_status status,',
'last_updated_on,',
'page_count,',
'manage,',
'updated,',
'last_updated_by,',
'created,',
'created_by,',
'action_buttons,',
'groupname,',
'application_security_scheme,',
'alias,',
'logging,',
'flow_version,',
'global_notification,',
'page_protection_enabled_y_n,',
'rejoin_existing_sessions,',
'flow_language,',
'application_comments,',
'application_type,',
'case ',
'    when working_copy_count = 1 then wwv_flow_lang.system_message(''APEXDEV.DIFF.WORKING_COPY.COUNT'', working_copy_count)',
'    when working_copy_count > 1 then wwv_flow_lang.system_message(''APEXDEV.DIFF.WORKING_COPY.COUNT.PLURAL'', working_copy_count)',
'    else null',
'end working_copy_info,',
'case ',
'    when working_copy_count > 0 then ''has-working-copy''',
'    else null',
'end working_copy_class,',
'working_copy_count,',
'run_link,',
'--',
'null as actions',
'from (',
'    select',
'        f.id app_id,',
'        f.id,',
'        f.security_group_id,',
'        -- 2',
'        ''#IMAGE_PREFIX#f_spacer.gif'' img,',
'        -- 3',
'        (select max(name)',
'           from wwv_flow_authentications a',
'          where a.id = f.authentication_id',
'        ) as authentication_scheme,',
'        -- 4',
'        decode(f.build_status,',
'          ''RUN_ONLY'',',
'          wwv_flow_utilities.prepare_url(',
'              p_url => ''f?p=4000:733:''||:app_session||''::::FB_FLOW_ID:''||f.id ),',
'          wwv_flow_utilities.prepare_url(',
'              p_url => ''f?p=4000:1:''||:app_session||''::''||:debug||'':RP:FB_FLOW_ID,F4000_P1_FLOW,P0_FLOWPAGE,RECENT_PAGES:''||f.id||'',''||f.id||'',''||f.id )',
'        ) link,',
'        --',
'        f.name||decode(f.build_status,''RUN_ONLY'','' - ''||sm.run_only,null) name,',
'        --',
'        f.name as app_name,',
'        --f.id||''. ''||f.name||decode(build_status,''RUN_ONLY'','' - ''||sm.run_only,null) app_name,',
'        -- 5',
'        coalesce(f.app_builder_icon_name, icon512.file_name) app_builder_icon_name,',
'        f.files_version,',
'        f.owner,',
'        null as image_class,',
'        -- 6',
'        decode(f.build_status,',
'          ''RUN_AND_BUILD'', sm.run_and_build,',
'          ''RUN_ONLY'',sm.run_only,',
'          f.build_status) build_status,',
'        -- 6.5',
'        decode(f.flow_status, ',
'            ''AVAILABLE'', sm.available,',
'            ''AVAILABLE_W_EDIT_LINK'', sm.available_with_edit_links,',
'            ''DEVELOPERS_ONLY'', sm.available_to_developers_only,',
'            ''UNAVAILABLE_URL'', sm.unavailable_redirect_to_url, ',
'            ''UNAVAILABLE_PLSQL'', sm.unavailable_plsql,',
'            ''RESTRICTED_ACCESS'', sm.restricted_access,',
'            ''UNAVAILABLE'', sm.unavailable,',
'            f.flow_status) flow_status,',
'        -- 7',
'        f.LAST_UPDATED_ON,',
'        -- 8',
'        (select count(*)',
'          from wwv_flow_steps',
'          where flow_id = f.id)',
'          page_count,',
'        -- 9',
'        f.id manage,',
'        -- 10',
'        f.last_updated_on updated,',
'        lower(f.last_updated_by) last_updated_by,',
'        f.created_on created,',
'        lower(f.created_by) created_by,',
'        -- 16',
'        decode(group_id,null,sm.t_unassigned,',
'            (select max(group_name) n',
'            from wwv_flow_application_groups',
'            where id = f.group_id))',
'          Groupname,',
'       decode(f.build_status,',
'            ''RUN_ONLY'',',
'            ''<button type="button" data-link="''||wwv_flow_dev.get_run_url(f.id)||''" class="launch-aut a-Button a-Button--noUI a-AppCards-button" title="''||sm.run||''" aria-label="''||sm.run||''">''||',
'            ''<span class="a-Icon icon-run-page"></span></button>'',',
'            ''RUN_AND_HIDDEN'',',
'              ''<span class="a-Button a-Button--noUI a-AppCards-button" title="''||sm.locked||''" aria-label="''||sm.locked||''"><span class="a-Icon icon-lock"></span><span class="u-VisuallyHidden">''||sm.locked||''</span></span>''||',
'              ''<button type="button" data-link="''||wwv_flow_dev.get_run_url(f.id)||''" class="launch-aut a-Button a-Button--noUI a-AppCards-button" title="''||sm.run||''" aria-label="''||sm.run||''">''||',
'              ''<span class="a-Icon icon-run-page"></span></button>'',',
'            ''<button onclick="apex.navigation.redirect('''''' || wwv_flow_utilities.prepare_url(',
'              p_url => ''f?p=4000:1:''||:app_session||''::''||:DEBUG||'':RP:FB_FLOW_ID,F4000_P1_FLOW,P0_FLOWPAGE,RECENT_PAGES:''||f.id||'',''||',
'              f.id||'',''||f.id)||'''''');" type="button" class="a-Button a-Button--noUI a-AppCards-button" title="''||sm.edit||''" aria-label="''||sm.edit||''" aria-describedby="card-header-''||f.id||''"><span class="a-Icon icon-edit"></span></button>''||',
'            ''<button type="button" data-link="''||wwv_flow_dev.get_run_url(f.id)||''" class="launch-aut a-Button a-Button--noUI a-AppCards-button" title="''||sm.run||''" aria-label="''||sm.run||''" aria-describedby="card-header-''||f.id||''">''||',
'              ''<span class="a-Icon icon-run-page"></span></button>''',
'        ) action_buttons,',
'        wwv_flow_dev.get_run_url( f.id ) as run_link,',
'        -- 17',
'        (select max(name)',
'           from   wwv_flow_security_schemes',
'           where flow_id = f.id and to_char(id) = f.SECURITY_SCHEME)',
'           application_security_scheme,',
'        -- 18',
'        f.ALIAS,',
'        -- 20',
'        f.WEBDB_LOGGING logging,',
'        -- 21',
'        f.FLOW_VERSION,',
'        -- 22',
'        f.GLOBAL_NOTIFICATION,',
'        -- 23',
'        decode(f.PAGE_PROTECTION_ENABLED_Y_N,',
'          ''Y'',sm.t_yes,',
'          ''N'',sm.t_no,',
'          sm.t_no)',
'          PAGE_PROTECTION_ENABLED_Y_N,',
'        -- 24',
'        decode(f.REJOIN_EXISTING_SESSIONS,',
'          ''Y'',sm.t_yes,',
'          ''N'',sm.t_no,',
'          REJOIN_EXISTING_SESSIONS)',
'          REJOIN_EXISTING_SESSIONS,',
'        -- 25',
'        f.FLOW_LANGUAGE,',
'        -- 26',
'        (select sys.dbms_lob.substr(banner,1000,1) from wwv_flow_banner b where id = f.id) application_comments,',
'        -- 28',
'        sm.app_type_database application_type,',
'        -- 29',
'        (select count(*)',
'           from wwv_working_copy_apps_dev',
'          where import_orig_app_id = f.id',
'            and security_group_id = f.security_group_id',
'        ) working_copy_count',
'    from   wwv_flow_visible_flows f,',
'           wwv_flow_static_files icon512,',
'          (select wwv_flow_lang.system_message(''RUN'') run,',
'                  wwv_flow_lang.system_message(''EDIT'') edit,',
'                  wwv_flow_lang.system_message(''RUN_ONLY'') run_only,',
'                  wwv_flow_lang.system_message(''F4000_F1500_LOCKED'') locked,',
'                  wwv_flow_lang.system_message(''RUN_AND_BUILD'') run_and_build,',
'                  wwv_flow_lang.system_message(''F4000.YES'') t_yes,',
'                  wwv_flow_lang.system_message(''F4000.NO'') t_no,',
'                  wwv_flow_lang.system_message(''Unassigned'') t_unassigned,',
'                  wwv_flow_lang.system_message(''APP_TYPE_DATABASE'') app_type_database,',
'                  wwv_flow_lang.system_message(''APP_TYPE_PACKAGED'') app_type_packaged,',
'                  wwv_flow_lang.system_message(''AVAILABLE'') available,',
'                  wwv_flow_lang.system_message(''AVAILABLE_WITH_EDIT_LINKS'') available_with_edit_links,',
'                  wwv_flow_lang.system_message(''AVAILABLE_TO_DEVELOPERS_ONLY'') available_to_developers_only,',
'                  wwv_flow_lang.system_message(''RESTRICTED_ACCESS'') restricted_access,',
'                  wwv_flow_lang.system_message(''UNAVAILABLE_STATUS_SHOWN_WITH_PLSQL'') unavailable_plsql,',
'                  wwv_flow_lang.system_message(''UNAVAILABLE_REDIRECT_TO_URL'') unavailable_redirect_to_url,                            ',
'                  wwv_flow_lang.system_message(''UNAVAILABLE'') unavailable',
'           from sys.dual) sm',
'    where icon512.security_group_id (+) = f.security_group_id',
'      and icon512.flow_id           (+) = f.id',
'      and icon512.file_name         (+) = ''icons/app-icon-512.png''',
'      and f.id not in ( select id ',
'                          from wwv_working_copy_apps_dev ',
'                         where security_group_id = f.security_group_id )',
')'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from   wwv_flow_visible_flows f'))
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_prn_output_show_link=>'Y'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#ffffff'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'LEFT'
,p_prn_page_footer_alignment=>'LEFT'
,p_plug_comment=>'decode(greatest(length(f.id),12),12,f.id,substr(f.id,length(f.id)-2))||''. ''||'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(3519715528105919)
,p_name=>'Applications'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No applications found.'
,p_allow_report_categories=>'N'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_highlight=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="a-AppCards-item #WORKING_COPY_CLASS#">',
'  <div class="a-AppCards-itemContainer">',
'    <a href="#LINK#" class="a-AppCards-link">',
'    <div class="a-AppCards-iconContainer">',
'      <span class="a-AppCards-icon a-AppCards-icon--initials #IMAGE_CLASS# #APP_COLOR#" aria-hidden="true">#APP_INITIALS# #APP_BUILDER_ICON_NAME#</span>',
'    </div>',
'    <div class="a-AppCards-contentContainer" id="card-content-#APP_ID#">',
'      <div class="a-AppCards-name" id="card-header-#APP_ID#">#APP_NAME#</div>',
'      <div class="a-AppCards-info">#ID#</div>',
'      <div class="a-AppCards-info">#WORKING_COPY_INFO#</div>',
'    </div>',
'    </a>',
'    <div class="a-AppCards-actionsContainer">#ACTION_BUTTONS#</div>',
'  </div>',
'</div>'))
,p_icon_view_columns_per_row=>4
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3519905658105931)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3520017814105932)
,p_db_column_name=>'LINK'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3520113521105932)
,p_db_column_name=>'NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Name'
,p_column_link=>'#LINK#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3520318233105933)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>4
,p_column_identifier=>'E'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3520423605105934)
,p_db_column_name=>'PAGE_COUNT'
,p_display_order=>5
,p_column_identifier=>'F'
,p_column_label=>'Pages'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3520529322105934)
,p_db_column_name=>'MANAGE'
,p_display_order=>6
,p_column_identifier=>'G'
,p_column_label=>'Manage'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3520621184105934)
,p_db_column_name=>'UPDATED'
,p_display_order=>7
,p_column_identifier=>'H'
,p_column_label=>'Updated Date'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3520703738105934)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>8
,p_column_identifier=>'I'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3520902515105935)
,p_db_column_name=>'GROUPNAME'
,p_display_order=>10
,p_column_identifier=>'K'
,p_column_label=>'Group'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3520811936105934)
,p_db_column_name=>'ACTIONS'
,p_display_order=>11
,p_column_identifier=>'J'
,p_column_label=>'Run'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'TMPL_THEME_3$ACTIONS'
,p_column_alignment=>'CENTER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'ACTIONS_WRAP', 'N',
  'STYLE', 'b-InlineActions--simple')).to_clob
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3523831823141678)
,p_db_column_name=>'IMG'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Application Image'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3537807039295421)
,p_db_column_name=>'APP_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Application and Name'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3542603454360548)
,p_db_column_name=>'AUTHENTICATION_SCHEME'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Authentication Scheme'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3551214030477137)
,p_db_column_name=>'BUILD_STATUS'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'Build Status'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3581532429261162)
,p_db_column_name=>'APPLICATION_SECURITY_SCHEME'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Application Security Scheme'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3582423125286836)
,p_db_column_name=>'ALIAS'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Alias'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3582600555286836)
,p_db_column_name=>'LOGGING'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Logging'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3582723933286837)
,p_db_column_name=>'FLOW_VERSION'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Version'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3582821814286837)
,p_db_column_name=>'GLOBAL_NOTIFICATION'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>'Global Notification'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3584127543307048)
,p_db_column_name=>'PAGE_PROTECTION_ENABLED_Y_N'
,p_display_order=>22
,p_column_identifier=>'V'
,p_column_label=>'Page Protection Enabled'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3585305688348052)
,p_db_column_name=>'REJOIN_EXISTING_SESSIONS'
,p_display_order=>23
,p_column_identifier=>'W'
,p_column_label=>'Rejoin Existing Sessions'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3586309891377567)
,p_db_column_name=>'FLOW_LANGUAGE'
,p_display_order=>24
,p_column_identifier=>'X'
,p_column_label=>'Language'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3821105214186324)
,p_db_column_name=>'APPLICATION_COMMENTS'
,p_display_order=>28
,p_column_identifier=>'AB'
,p_column_label=>'Comments'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3929918685985572)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>30
,p_column_identifier=>'AD'
,p_column_label=>'Created By'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3942125613042968)
,p_db_column_name=>'CREATED'
,p_display_order=>31
,p_column_identifier=>'AE'
,p_column_label=>'Created'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(181276524421267982)
,p_db_column_name=>'APPLICATION_TYPE'
,p_display_order=>34
,p_column_identifier=>'AH'
,p_column_label=>'Type'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(22888825718150978)
,p_db_column_name=>'IMAGE_CLASS'
,p_display_order=>36
,p_column_identifier=>'AJ'
,p_column_label=>'IMAGE_CLASS'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(33317208953356542)
,p_db_column_name=>'APP_ID'
,p_display_order=>37
,p_column_identifier=>'AK'
,p_column_label=>'APP_ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(373158432475904924)
,p_db_column_name=>'ACTION_BUTTONS'
,p_display_order=>40
,p_column_identifier=>'AN'
,p_column_label=>'ACTION_BUTTONS'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(7056917561001344)
,p_db_column_name=>'APP_OWNER'
,p_display_order=>41
,p_column_identifier=>'AO'
,p_column_label=>'Parsing Schema'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(402738956454884729)
,p_db_column_name=>'STATUS'
,p_display_order=>43
,p_column_identifier=>'AQ'
,p_column_label=>'Status'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(932667963082561029)
,p_db_column_name=>'APP_COLOR'
,p_display_order=>53
,p_column_identifier=>'AS'
,p_column_label=>' APP_COLOR'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(932668000526561030)
,p_db_column_name=>'APP_INITIALS'
,p_display_order=>63
,p_column_identifier=>'AT'
,p_column_label=>' APP_INITIALS'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(879700787009493829)
,p_db_column_name=>'APP_BUILDER_ICON_NAME'
,p_display_order=>73
,p_column_identifier=>'AV'
,p_column_label=>'App builder icon name'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3522318356042619)
,p_db_column_name=>'WORKING_COPY_INFO'
,p_display_order=>83
,p_column_identifier=>'AW'
,p_column_label=>'Working Copy Info'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3522432696042620)
,p_db_column_name=>'WORKING_COPY_COUNT'
,p_display_order=>93
,p_column_identifier=>'AX'
,p_column_label=>'Working Copies'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(119476946814947209)
,p_db_column_name=>'WORKING_COPY_CLASS'
,p_display_order=>103
,p_column_identifier=>'AY'
,p_column_label=>'Working Copy Class'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2182623754145916)
,p_db_column_name=>'RUN_LINK'
,p_display_order=>123
,p_column_identifier=>'BA'
,p_column_label=>'Run Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(3521529006112497)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_type=>'REPORT'
,p_report_alias=>'1294014348536644'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_display_rows=>100
,p_view_mode=>'ICON'
,p_report_columns=>'ID:NAME:PAGE_COUNT:LAST_UPDATED_BY:LAST_UPDATED_ON:WORKING_COPY_COUNT:ACTIONS::WORKING_COPY_CLASS:RUN_LINK'
,p_sort_column_1=>'NAME'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'ID'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'LAST_UPDATED_ON'
,p_sort_direction_3=>'DESC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(29130217457479689)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(63310734885303893)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
,p_plug_required_role=>wwv_flow_imp.id(12510423405283164)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(48529419219231981)
,p_plug_name=>'About'
,p_region_css_classes=>'a-Region--stacked a-Region--padded a-Region--flush a-Region--sideRegion'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The App Builder enables you to design, develop and deploy applications which are beautiful and responsive.</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(72199818188550801)
,p_plug_name=>'Learn More Region'
,p_region_css_classes=>'a-ButtonRegion--banner apex-app-builder'
,p_region_template_options=>'a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>50
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<div class="a-MediaBlock">'');',
'sys.htp.p(''    <div class="a-MediaBlock-graphic">'');',
'sys.htp.p(''        <span class="icon-get-started" aria-hidden="true"></span>'');',
'sys.htp.p(''    </div>'');',
'sys.htp.p(''    <div class="a-MediaBlock-content">'');',
'sys.htp.p(''        <h2>''||wwv_flow_lang.system_message(''LEARN_MORE_APP_BUILDER'')||''</h2>'');',
'sys.htp.p(''    </div>'');',
'sys.htp.p(''</div>'');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_platform.get_preference(''GETTING_STARTED_ENABLED'') = ''Y'''
,p_plug_display_when_cond2=>'PLSQL'
,p_landmark_label=>'Learn More'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(187075905864335205)
,p_plug_name=>'Home Page Tabs'
,p_region_sub_css_classes=>'app-builder'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_imp.id(787106333147859999)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(481294291606549740)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Actions'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(583532143777956101)
,p_plug_name=>'Get Started Now'
,p_region_css_classes=>'u-Block--hero'
,p_region_sub_css_classes=>'a-MediaList--buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-MediaList--cols a-MediaList--2cols'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(583541659513985598)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(693422331030340241)
,p_plug_required_role=>wwv_flow_imp.id(12510423405283164)
,p_plug_display_condition_type=>'NOT_EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from   wwv_flow_visible_flows f'))
,p_plug_header=>'<h1 class="u-Block-title">Get Started Now</h1>'
,p_landmark_type=>'region'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(72199919976550802)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(72199818188550801)
,p_button_name=>'GET_STARTED'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Get Started'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.navigation.openInNewWindow(''https://apex.oracle.com/go/get_started_app_builder'');'
,p_button_css_classes=>'a-Button--dark'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1338904799030874)
,p_button_sequence=>51
,p_button_plug_id=>wwv_flow_imp.id(3519628466105919)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_css_classes=>' a-Button--strongLabel'
,p_security_scheme=>wwv_flow_imp.id(12472323342703137)
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(42239228505367502)
,p_branch_name=>'Create Application'
,p_branch_action=>'f?p=&APP_ID.:56:&SESSION.::&DEBUG.:56,103,104,106,130,131,35,227,3020,3000,3001:FB_FLOW_ID,FB_FLOW_PAGE_ID:1,'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(1338904799030874)
,p_branch_sequence=>1
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1317920298973522)
,p_branch_action=>'f?p=&FLOW_ID.:1500:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1318808861975245)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'reset pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>':request = ''GO'' or :request is null'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>1318808861975245
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(879700937980493831)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Reset Friendly URL Cache'
,p_process_sql_clob=>'wwv_flow_utilities.reset_friendly_url_cache;'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>879700937980493831
);
wwv_flow_imp_page.create_component_action(
 p_id=>wwv_flow_imp.id(2182971815145919)
,p_ir_column_id=>wwv_flow_imp.id(3520811936105934)
,p_position_id=>wwv_flow_imp.id(214437533860142316)
,p_display_sequence=>10
,p_template_id=>wwv_flow_imp.id(583874857767349098)
,p_label=>'Run'
,p_link_target_type=>'REDIRECT_URL'
,p_link_target=>'#RUN_LINK#'
,p_button_display_type=>'ICON'
,p_icon_css_classes=>'icon-run-page'
,p_action_css_classes=>'launch-aut'
,p_is_hot=>false
,p_show_as_disabled=>false
);
end;
/
prompt --application/pages/page_01600
begin
wwv_flow_imp_page.create_page(
 p_id=>1600
,p_name=>'REST Enabled SQL'
,p_alias=>'REST-ENABLED-SQL'
,p_step_title=>'REST Enabled SQL'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(158563443147585227)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(153971260438479912)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--sideRegion:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="border-bottom-width: 0;"'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Create a <strong>REST Enabled SQL</strong> service to execute SQL or PL/SQL defined in &PRODUCT_NAME. components on a remote Oracle database.</p>',
'',
'<p><strong>Requirement:</strong> The remote database must include Oracle REST Data Services (ORDS) release 20.3 or later on the front-end and have the <em>REST Enabled SQL</em> feature enabled. All SQL and PL/SQL is sent to the ORDS instance which ex'
||'ecutes it on the remote database.</p>',
'',
'<p>REST Enabled SQL references are stored at the workspace level and therefore visible in all applications.</p>',
'',
'<p>When you export an application, used REST Enabled SQL references are added to the export file. If you export an application and import it into another workspace, &PRODUCT_NAME. checks whether the target workspace already contains REST Enabled SQL '
||'references with the same <strong>static ID</strong>. If a REST Enabled SQL reference already exists, the application uses the existing reference. If the reference does not exist, it is created in the target workspace.</p>'))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(353023904549052201)
,p_plug_name=>'Learn More'
,p_parent_plug_id=>wwv_flow_imp.id(153971260438479912)
,p_region_attributes=>'style="padding: 0 12px 12px 12px;"'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'sys.htp.p(''<p><a href="&SYSTEM_HELP_URL." target="_blank">''||wwv_flow_lang.system_message(''LEARN MORE'')||'' ...</a></p>'');'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(157709882691474177)
,p_plug_name=>'REST Enabled SQL Servers'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       server_name,',
'       --',
'       -- Usable',
'       case when remote_sql_database_type is not null then ''check'' else ''remove'' end as is_usable_icon,',
'       wwv_flow_lang_dev.builder_message( ''WWV_FLOW_EXEC_REMOTE.SERVER_IS_'' || case when remote_sql_database_type is null then ''UN'' end || ''USABLE'' ) as is_usable_text,',
'       --',
'       base_url,',
'       authentication_type,',
'       --',
'       -- REST Enabled SQL database details',
'       remote_sql_database_type,',
'       case when remote_sql_database_type is not null ',
'            then nullif( ',
'                     json_value( remote_sql_database_info, ''$.database_major_version'' ) ',
'                     || ''.''',
'                     || json_value( remote_sql_database_info, ''$.database_minor_version'' ),',
'                    ''.'' ) ',
'       end as remote_sql_database_version,',
'       case when remote_sql_database_type is not null ',
'            then remote_sql_default_schema ',
'       end as remote_sql_default_schema,',
'       --',
'       -- Icon View',
'       wwv_flow_utilities.prepare_url(''f?p=4000:1601:'' || :APP_SESSION || '':::1601:P1601_ID:'' || id ) as link,',
'       ''icon-admin-workspace-preferences'' as img,',
'       --',
'       -- Test Button',
'       wwv_flow_utilities.prepare_url(''f?p=4000:1605:'' || :APP_SESSION || ''::''|| :DEBUG || '':1605:P1605_ID:'' || id) as test_link',
'  from wwv_remotesql_servers_dev ',
' where security_group_id = :flow_security_group_id',
'       '))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(157709960601474178)
,p_name=>'Build Options'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No REST Enabled SQL services are defined for this application'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#LINK#" class="a-IRR-icon"><span class="a-Icon #IMG#"></span><span class="a-IRR-iconName">#SERVER_NAME#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'MIKE'
,p_internal_uid=>157709960601474178
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2012902072126708)
,p_db_column_name=>'IS_USABLE_TEXT'
,p_display_order=>10
,p_column_identifier=>'AQ'
,p_column_label=>'Usable'
,p_column_html_expression=>'<span class="a-Icon icon-#IS_USABLE_ICON#" aria-hidden="true"n title="#IS_USABLE_TEXT#"</span>'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3052575721563938907)
,p_db_column_name=>'SERVER_NAME'
,p_display_order=>20
,p_column_identifier=>'AI'
,p_column_label=>'Name'
,p_column_link=>'f?p=&APP_ID.:1601:&SESSION.::&DEBUG.:RP,1601:P1601_ID:#ID#'
,p_column_linktext=>'#SERVER_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2012426348126703)
,p_db_column_name=>'REMOTE_SQL_DATABASE_TYPE'
,p_display_order=>30
,p_column_identifier=>'AL'
,p_column_label=>'Database Type'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(1803812385387219)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2012602487126705)
,p_db_column_name=>'REMOTE_SQL_DATABASE_VERSION'
,p_display_order=>50
,p_column_identifier=>'AN'
,p_column_label=>'Version'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(153984861179443609)
,p_db_column_name=>'BASE_URL'
,p_display_order=>60
,p_column_identifier=>'AF'
,p_column_label=>'Base URL'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2012535729126704)
,p_db_column_name=>'REMOTE_SQL_DEFAULT_SCHEMA'
,p_display_order=>70
,p_column_identifier=>'AM'
,p_column_label=>'Default Schema'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3052578113918938931)
,p_db_column_name=>'AUTHENTICATION_TYPE'
,p_display_order=>80
,p_column_identifier=>'AJ'
,p_column_label=>'Authentication'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(154078822199034715)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(154842584477613405)
,p_db_column_name=>'TEST_LINK'
,p_display_order=>100
,p_column_identifier=>'AK'
,p_column_label=>'Test'
,p_column_link=>'#TEST_LINK#'
,p_column_linktext=>'<span class="a-Icon icon-run-script" aria-hidden="true"></span>'
,p_column_link_attr=>'class="a-Button a-Button--noLabel a-Button--withIcon" title="Test REST Enabled SQL service"'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(153973855601423124)
,p_db_column_name=>'ID'
,p_display_order=>110
,p_column_identifier=>'E'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(153984992820443610)
,p_db_column_name=>'IMG'
,p_display_order=>120
,p_column_identifier=>'AG'
,p_column_label=>'Img'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(153985068941443611)
,p_db_column_name=>'LINK'
,p_display_order=>130
,p_column_identifier=>'AH'
,p_column_label=>'Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2012829293126707)
,p_db_column_name=>'IS_USABLE_ICON'
,p_display_order=>140
,p_column_identifier=>'AP'
,p_column_label=>'Is Usable Icon'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(157712384670549138)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_type=>'REPORT'
,p_report_alias=>'1539814'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'SERVER_NAME:IS_USABLE_TEXT:REMOTE_SQL_DATABASE_TYPE:REMOTE_SQL_DATABASE_VERSION:REMOTE_SQL_DEFAULT_SCHEMA:BASE_URL:TEST_LINK'
,p_sort_column_1=>'PATCH_NAME'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(201881278673987178)
,p_plug_name=>'tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(154051976265844427)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'REST Enabled SQL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(153981816740423137)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(157709882691474177)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1600:&SESSION.::&DEBUG.:1600,RIR::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(153982299781423142)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(157709882691474177)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1615:&SESSION.::&DEBUG.:1601,1605,1615,1616,1617::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(153983771122423173)
,p_branch_name=>'Go To Page 1600'
,p_branch_action=>'f?p=&APP_ID.:1600:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2013110226126710)
,p_name=>'Refresh Report after dialog close'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(157709882691474177)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2013246959126711)
,p_event_id=>wwv_flow_imp.id(2013110226126710)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(157709882691474177)
);
end;
/
prompt --application/pages/page_01601
begin
wwv_flow_imp_page.create_page(
 p_id=>1601
,p_name=>'Edit REST Enabled SQL Service'
,p_alias=>'EDIT-REST-ENABLED-SQL-SERVICE'
,p_step_title=>'Edit REST Enabled SQL Service'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(158563443147585227)
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2013032555126709)
,p_plug_name=>'Unknown Database Type'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>10
,p_plug_source=>'The database type of this REST Enabled SQL reference is unknown. Click the <strong>Save and Test</strong> button to test the REST Enabled SQL server and to determine the database type.'
,p_plug_display_condition_type=>'ITEM_IS_NULL'
,p_plug_display_when_condition=>'P1601_DATABASE_TYPE'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5016984986372427)
,p_plug_name=>'Database Version Not Supported'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'The <strong>&P1601_DATABASE_TYPE!HTML.</strong> database version (&P1601_DATABASE_VERSION.) of this REST Enabled SQL Reference is not supported by &PRODUCT_NAME.. Components will not work properly.'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_exec_remote.is_supported( :P1601_ID ) = ''N'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(153986959989443630)
,p_plug_name=>'Authentication'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(153988550198443646)
,p_plug_name=>'Advanced'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(154005373611060238)
,p_plug_name=>'REST Enabled SQL'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_query_num_rows=>15
,p_plug_query_show_nulls_as=>'(null)'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(333897496146382780)
,p_plug_name=>'REST Enabled SQL'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p><strong>REST Enabled SQL</strong>  references enable you to execute SQL or PL/SQL in &PRODUCT_NAME. components on a remote database.</p>',
'<p>The remote database must include Oracle REST Data Services (ORDS) release 17.3 or later on the front-end and have the REST Enabled SQL feature enabled. All SQL and PL/SQL is sent to the ORDS instance which executes it on the remote database.</p>',
''))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(522797333502429241)
,p_plug_name=>'Session'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P1601_DATABASE_TYPE'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2109723019647641)
,p_plug_name=>'No Default Database Set'
,p_parent_plug_id=>wwv_flow_imp.id(522797333502429241)
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'Please choose a default database to execute SQL for. When no default database is chosen, all database objects need to be prefixed with the MySQL database name.'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P1601_DATABASE_TYPE = ''MYSQL'' and :P1601_DEFAULT_DATABASE is null'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2109872001647642)
,p_plug_name=>'Items'
,p_parent_plug_id=>wwv_flow_imp.id(522797333502429241)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(769522898980777165)
,p_plug_name=>'REST Enabled SQL'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(154012466182512518)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(769522898980777165)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1600:&SESSION.::&DEBUG.:RP,1601::'
,p_button_condition=>'P1601_BACK_TO_PAGE'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2110377631647647)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(769522898980777165)
,p_button_name=>'CANCEL_BACK_TO_PAGE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&P1601_BACK_TO_PAGE.:&SESSION.::&DEBUG.:RP,1601::'
,p_button_condition=>'P1601_BACK_TO_PAGE'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(154012811972512518)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(769522898980777165)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
,p_button_condition=>'P1601_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(154013205409512518)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(769522898980777165)
,p_button_name=>'Update'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P1601_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(153985174039443612)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(769522898980777165)
,p_button_name=>'APPLY_CHANGES_TEST'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel:a-Button--primary:a-Button--gapRight'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Save and Test'
,p_button_position=>'NEXT'
,p_button_condition=>'P1601_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(154013634117512519)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(769522898980777165)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>'P1601_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(241341925211308330)
,p_branch_name=>'Go To Page 1605'
,p_branch_action=>'f?p=&APP_ID.:1605:&SESSION.::&DEBUG.:RP:P1605_ID,P1605_BACK_TO_PAGE:&P1601_ID.,&APP_PAGE_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(153985174039443612)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(154016320786512532)
,p_branch_name=>'Go To Page 1600'
,p_branch_action=>'f?p=&APP_ID.:1600:&SESSION.::&DEBUG.:RP,1600::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow.g_request in (''Create'',''Delete'',''Update'') and :P1601_BACK_TO_PAGE is null'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2110253896647646)
,p_branch_name=>'Go To "Back to Page"'
,p_branch_action=>'f?p=&APP_ID.:&P1601_BACK_TO_PAGE.:&SESSION.::&DEBUG.:RP,1601::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow.g_request in (''Create'',''Delete'',''Update'') and :P1601_BACK_TO_PAGE is not null'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(154016749703512532)
,p_branch_name=>'Go To Page 1601'
,p_branch_action=>'f?p=&APP_ID.:1601:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(310375518625241826)
,p_branch_name=>'Go To Page 1621'
,p_branch_action=>'f?p=&APP_ID.:1621:&SESSION.::&DEBUG.:RP:P1621_ID,P1621_BACK_TO_PAGE:&P1601_CRED_STORE.,&APP_PAGE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'EDIT_CREDENTIAL'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2001110922879509)
,p_name=>'P1601_DATABASE_TYPE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(154005373611060238)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Database Type'
,p_source=>'REMOTE_SQL_DATABASE_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'REMOTE_SQL_DATABASE_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(1803812385387219)||'.'
,p_display_when=>'P1601_DATABASE_TYPE'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identifies the database vendor of this REST Enabled SQL Service. Currently, MySQL and Oracle Databases are supported.'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2001277884879510)
,p_name=>'P1601_DATABASE_INFO'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(153988550198443646)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Database Info'
,p_source=>'REMOTE_SQL_DATABASE_INFO'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cHeight=>7
,p_display_when=>'P1601_DATABASE_TYPE'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'json'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2001324342879511)
,p_name=>'P1601_DEFAULT_DATABASE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2109872001647642)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Default Database'
,p_source=>'REMOTE_SQL_DEFAULT_SCHEMA'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value d, column_value r',
'  from table( wwv_flow_remote_server_dev.get_available_objects(',
'                  p_remote_server_id => :P1601_ID,',
'                  p_object_type      => ''SCHEMAS'' ));'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cSize=>30
,p_display_when=>'P1601_DATABASE_TYPE'
,p_display_when2=>'MYSQL'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identify the <em>default database</em> to use when executing SQL against the remote MySQL database. Objects in other databases can also be accessed by prefixing them with the database name.'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2013710734126716)
,p_name=>'P1601_DATABASE_VERSION'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(154005373611060238)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2110181368647645)
,p_name=>'P1601_BACK_TO_PAGE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(154005373611060238)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48102664737492249)
,p_name=>'P1601_CREDENTIALS_STATIC_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(153986959989443630)
,p_use_cache_before_default=>'NO'
,p_source=>'CREDENTIAL_STATIC_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(150058447361607443)
,p_name=>'P1601_MYSQL_SQL_MODES'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(2109872001647642)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Override SQL Modes'
,p_source=>'MYSQL_SQL_MODES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cHeight=>3
,p_display_when=>'P1601_DATABASE_TYPE'
,p_display_when2=>'MYSQL'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the <em>SQL Modes</em> to use for connections to this MySQL REST Enabled SQL reference. ',
'If nothing is specified, the global SQL Modes, configured at the MySQL server, will be used. ',
'Click <strong>Save and Test</strong> to see the currently active SQL Modes.</p>',
'<p>See <strong>Server SQL Modes</strong> in the MySQL documentation for more details.</p>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(153984709487443608)
,p_name=>'P1601_CRED_STORE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(154005373611060238)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Credentials'
,p_post_element_text=>'<a href="#" id="P1601_EDIT_CREDENTIAL_BUTTON" class="a-Button a-Button--noLabel a-Button--small a-Button--withIcon" onClick="apex.page.submit(''EDIT_CREDENTIAL'')" tabindex="0"><span class="a-Icon icon-edit"></span><span class="u-VisuallyHidden">Edit C'
||'redential</span></a>'
,p_source=>'CREDENTIAL_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LOV_CREDENTIAL_STORES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_credentials',
' where security_group_id    = :FLOW_SECURITY_GROUP_ID',
'   and authentication_type != ''KEY_PAIR'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Enter new Credentials -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the credential to authenticate against. To edit the credential, navigate to <strong>Web Credentials</strong> in <strong>Shared Components</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(153985439821443615)
,p_name=>'P1601_CLIENT_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(153986959989443630)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Client ID or Username'
,p_source=>'CLIENT_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'For Basic Authentication, enter the database user name. For OAuth2, enter the client ID. This information will not be encrypted. User names for Basic Authentication are converted to upper case. To include a case-sensitive user name, prefix it with th'
||'e exclamation mark (!).'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(153985529999443616)
,p_name=>'P1601_SECRET'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(153986959989443630)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Client Secret or Password'
,p_source=>'CLIENT_SECRET'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter the password or OAuth2 Client Secret. This information is stored encrypted and cannot be retrieved in clear text.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(153985605261443617)
,p_name=>'P1601_SECRET_VERIFY'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(153986959989443630)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Verify Client Secret or Password'
,p_source=>'CLIENT_SECRET_VERIFY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter the password or client secret again to verify your input. When the two values are not identical, an error message displays.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(153985789234443618)
,p_name=>'P1601_CREDENTIALS_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(153986959989443630)
,p_use_cache_before_default=>'NO'
,p_item_default=>'OAUTH2_CLIENT_CREDENTIALS'
,p_prompt=>'Authentication Type'
,p_source=>'AUTHENTICATION_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CREDENTIALS_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(154078822199034715)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the Authentication type. Oracle APEX supports Basic Authentication and the OAuth2 Client credentials flows.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(153987628718443637)
,p_name=>'P1601_AUTH_REQUIRED'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(154005373611060238)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Authentication Required'
,p_source=>'AUTH_REQUIRED'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_read_only_when=>'P1601_AUTH_REQUIRED'
,p_read_only_when2=>'Y'
,p_read_only_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(153988391997443644)
,p_name=>'P1601_CREDENTIALS_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(153986959989443630)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Credential Name'
,p_source=>'CREDENTIAL_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a descriptive name for the credentials.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(154006048431512498)
,p_name=>'P1601_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(154005373611060238)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(154007391988512510)
,p_name=>'P1601_REMOTE_SERVER_NAME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(154005373611060238)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>'SERVER_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>59
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a descriptive name for this REST Enabled SQL service.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(154008223755512511)
,p_name=>'P1601_BASE_URL'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(154005373611060238)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Endpoint URL'
,p_source=>'BASE_URL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>59
,p_cMaxlength=>500
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the base URL for this REST Enabled SQL service. Include the ORDS context root and schema URL prefix, but do <strong>not</strong> add <code>/_/sql</code>. For example:',
'<pre>',
'https://{host}:{port}/ords/{schema}',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(154010015683512514)
,p_name=>'P1601_PROMPT_ON_INSTALL'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(154005373611060238)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Prompt On Install'
,p_source=>'PROMPT_ON_INSTALL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Choose whether prompts for this REST Enabled SQL service should be displayed when the application is being imported on another &PRODUCT_NAME. instance.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(154010941690512516)
,p_name=>'P1601_COMMENT'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(153988550198443646)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comments'
,p_source=>'SERVER_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>75
,p_cMaxlength=>32767
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Enter any comments or notes here. These comments never display when running the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(249347881467883022)
,p_name=>'P1601_HTTPS_HOST'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(153988550198443646)
,p_use_cache_before_default=>'NO'
,p_prompt=>'HTTPS Host Name'
,p_source=>'HTTPS_HOST'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>59
,p_cMaxlength=>500
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The host name to be matched against the common name (CN) of the remote server''s certificate for an HTTPS request. It can also be a domain name like *.example.com. If NULL, the host name in the given URL will be used.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(348489209217006010)
,p_name=>'P1601_ORDS_TIMEZONE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(153988550198443646)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Server Time Zone'
,p_source=>'ORDS_TIMEZONE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_display_when=>'P1601_ORDS_TIMEZONE'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Time Zone which the REST Enabled SQL service uses to decode DATE and TIMESTAMP values. This value will be updated with each <strong>Test Service</strong> operation.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(522796518715429233)
,p_name=>'P1601_STATIC_ID'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(153988550198443646)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Static ID'
,p_source=>'SERVER_STATIC_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>59
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Use the Static ID to reference the Remote Server in API calls. Static IDs are also used to identify an existing Remote Server when the application is being exported and imported to another workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(522797185889429239)
,p_name=>'P1601_ORDS_INIT_CODE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2109872001647642)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Initialization Code'
,p_source=>'ORDS_INIT_CODE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>75
,p_cMaxlength=>4000
,p_cHeight=>4
,p_display_when=>'P1601_DATABASE_TYPE'
,p_display_when2=>'ORACLE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter code to be executed immediately after connecting to the REST Enabled SQL service and before the component SQL is being executed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(522797255228429240)
,p_name=>'P1601_ORDS_CLEANUP_CODE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2109872001647642)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Cleanup Code'
,p_source=>'ORDS_CLEANUP_CODE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>75
,p_cMaxlength=>4000
,p_cHeight=>4
,p_display_when=>'P1601_DATABASE_TYPE'
,p_display_when2=>'ORACLE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter code to be executed immediately after the component SQL is being executed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(153988290843443643)
,p_computation_sequence=>10
,p_computation_item=>'P1601_CRED_STORE'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P1601_AUTH_REQUIRED'
,p_compute_when_text=>'N'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(310377232133241843)
,p_computation_sequence=>20
,p_computation_item=>'P1601_CLIENT_ID'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'case when substr( :P1601_CLIENT_ID, 1, 1 ) = ''!'' then substr( :P1601_CLIENT_ID, 2 ) else upper( :P1601_CLIENT_ID ) end'
,p_compute_when=>'P1601_CREDENTIALS_TYPE'
,p_compute_when_text=>'BASIC'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(153988642196443647)
,p_computation_sequence=>10
,p_computation_item=>'P1601_AUTH_REQUIRED'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'case when :P1601_CRED_STORE is null then ''N'' else ''Y'' end'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2013897062126717)
,p_computation_sequence=>20
,p_computation_item=>'P1601_DATABASE_VERSION'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nullif( ',
'            json_value( remote_sql_database_info, ''$.database_major_version'' ) ',
'            || ''.''',
'            || json_value( remote_sql_database_info, ''$.database_minor_version'' ),',
'        ''.'' ) as db_version',
'  from wwv_remote_servers',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and id                = :P1601_ID'))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(154843302877613413)
,p_validation_name=>'Client ID is required'
,p_validation_sequence=>10
,p_validation=>'P1601_CLIENT_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Client ID or Username is required.'
,p_validation_condition=>'wwv_flow.g_request in ( ''Create'', ''Update'' ) and :P1601_AUTH_REQUIRED = ''Y'' and :P1601_CRED_STORE is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(153985439821443615)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(249282048443575834)
,p_validation_name=>'Credential name is required'
,p_validation_sequence=>20
,p_validation=>'P1601_CREDENTIALS_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Credential name is required.'
,p_validation_condition=>'wwv_flow.g_request in ( ''Create'', ''Update'' ) and :P1601_AUTH_REQUIRED = ''Y'' and :P1601_CRED_STORE is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(153988391997443644)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(249282161166575835)
,p_validation_name=>'Credential name must be unique'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'  from wwv_credentials',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and name              = :P1601_CREDENTIALS_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Credential name must be unique within the application.'
,p_validation_condition=>'wwv_flow.g_request in ( ''Create'', ''Update'' ) and :P1601_AUTH_REQUIRED = ''Y'' and :P1601_CRED_STORE is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(153988391997443644)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(154843465078613414)
,p_validation_name=>'Client Secret required'
,p_validation_sequence=>40
,p_validation=>'P1601_SECRET'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Client Secret or Password is required.'
,p_validation_condition=>'wwv_flow.g_request in (''Create'',''Update'') and :P1601_AUTH_REQUIRED =''Y''  and :P1601_CRED_STORE is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(153985529999443616)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3052576145524938911)
,p_validation_name=>'Client Secret = Client Secret Verify'
,p_validation_sequence=>50
,p_validation=>'P1601_SECRET'
,p_validation2=>'&P1601_SECRET_VERIFY.'
,p_validation_type=>'ITEM_IN_VALIDATION_EQ_STRING2'
,p_error_message=>'Client Secrets does not match.'
,p_validation_condition=>'wwv_flow.g_request in (''Create'',''Update'') and :P1601_AUTH_REQUIRED = ''Y'' and :P1601_CRED_STORE is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(153985529999443616)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(537042265155394615)
,p_validation_name=>'Cannot delete used REST Enabled SQL reference'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select s.id',
'  from wwv_remote_servers s',
' where exists (',
'     select id from wwv_flow_page_plugs         where remote_server_id = s.id   union all (',
'     select id from wwv_flow_step_processing    where remote_server_id = s.id ) union all (',
'     select id from wwv_flow_lists_of_values$   where remote_server_id = s.id ) union all (',
'     select id from wwv_flow_jet_chart_series   where remote_server_id = s.id ) union all (',
'     select id from wwv_flow_automation_actions where remote_server_id = s.id ) union all (',
'     select id from wwv_flow_automations        where remote_server_id = s.id ) union all (',
'     select id from wwv_flow_processing         where remote_server_id = s.id )',
' ) ',
'  and server_type = ''REMOTE_SQL''',
'  and security_group_id = :FLOW_SECURITY_GROUP_ID',
'  and s.id = :P1601_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'REST Enabled SQL service is in use and cannot be deleted.'
,p_when_button_pressed=>wwv_flow_imp.id(154012811972512518)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(153987372769443634)
,p_name=>'Show / Hide Credential region'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1601_CRED_STORE'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'apex.item("P1601_AUTH_REQUIRED").getValue() === ''N'' || apex.item("P1601_CRED_STORE").getValue() !== ""'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'custom'
,p_bind_event_type_custom=>'credentialchange'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(153987508434443636)
,p_event_id=>wwv_flow_imp.id(153987372769443634)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(153986959989443630)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(310375366720241824)
,p_event_id=>wwv_flow_imp.id(153987372769443634)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'#P1601_EDIT_CREDENTIAL_BUTTON'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(310375257040241823)
,p_event_id=>wwv_flow_imp.id(153987372769443634)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'#P1601_EDIT_CREDENTIAL_BUTTON'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(48102799568492250)
,p_event_id=>wwv_flow_imp.id(153987372769443634)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1601_CREDENTIALS_STATIC_ID'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(153987404389443635)
,p_event_id=>wwv_flow_imp.id(153987372769443634)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(153986959989443630)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3052578068380938930)
,p_event_id=>wwv_flow_imp.id(153987372769443634)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1601_CLIENT_ID,P1601_SECRET,P1601_SECRET_VERIFY,P1601_CREDENTIALS_NAME'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(153987715029443638)
,p_name=>'Authentication Required'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1601_AUTH_REQUIRED'
,p_condition_element=>'P1601_AUTH_REQUIRED'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(153987839204443639)
,p_event_id=>wwv_flow_imp.id(153987715029443638)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1601_CRED_STORE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(153987969302443640)
,p_event_id=>wwv_flow_imp.id(153987715029443638)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1601_CRED_STORE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3052577727217938927)
,p_event_id=>wwv_flow_imp.id(153987715029443638)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.event.trigger($("#P1601_CRED_STORE"), "credentialchange")'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3052577805703938928)
,p_event_id=>wwv_flow_imp.id(153987715029443638)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.event.trigger($("#P1601_CRED_STORE"), "credentialchange")'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3052577311421938923)
,p_name=>'Credentials changed'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1601_CRED_STORE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3052577423757938924)
,p_event_id=>wwv_flow_imp.id(3052577311421938923)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.event.trigger($("#P1601_CRED_STORE"), "credentialchange")'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(249347938803883023)
,p_name=>'Show / Hide HTTPS_HOST'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1601_BASE_URL'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$v("P1601_BASE_URL").startsWith("https://")'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(249348034183883024)
,p_event_id=>wwv_flow_imp.id(249347938803883023)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1601_HTTPS_HOST'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(249348116012883025)
,p_event_id=>wwv_flow_imp.id(249347938803883023)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1601_HTTPS_HOST'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(249348214178883026)
,p_event_id=>wwv_flow_imp.id(249347938803883023)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1601_HTTPS_HOST'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(154015043647512524)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from FLOW_REMOTESQL_SERVERS_DEV'
,p_attribute_02=>'WWV_REMOTESQL_SERVERS_DEV'
,p_attribute_03=>'P1601_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id = :FLOW_SECURITY_GROUP_ID'
,p_process_error_message=>'Error fetching row.'
,p_internal_uid=>154015043647512524
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(154015466867512528)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_REMOTESQL_SERVERS_DEV'
,p_attribute_02=>'WWV_REMOTESQL_SERVERS_DEV'
,p_attribute_03=>'P1601_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id = :FLOW_SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_process_error_message=>'Error processing action.'
,p_process_success_message=>'Action processed.'
,p_internal_uid=>154015466867512528
);
end;
/
prompt --application/pages/page_01602
begin
wwv_flow_imp_page.create_page(
 p_id=>1602
,p_name=>'REST Enabled SQL Utilization'
,p_alias=>'REST-ENABLED-SQL-UTILIZATION'
,p_step_title=>'REST Enabled SQL Utilization'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(158563443147585227)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(533155296022172840)
,p_plug_name=>'Unused REST Enabled SQL References'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select s.id,',
'       s.name remote_server_name',
'  from wwv_remote_servers s',
' where not exists (',
'     select id from wwv_flow_page_plugs         where remote_server_id = s.id   union all (',
'     select id from wwv_flow_step_processing    where remote_server_id = s.id ) union all (',
'     select id from wwv_flow_jet_chart_series   where remote_server_id = s.id ) union all (',
'     select id from wwv_flow_lists_of_values$   where remote_server_id = s.id ) union all (',
'     select id from wwv_flow_automations        where remote_server_id = s.id ) union all (',
'     select id from wwv_flow_automation_actions where remote_server_id = s.id ) union all (',
'     select id from wwv_flow_processing         where remote_server_id = s.id )',
' ) ',
'  and server_type = ''REMOTE_SQL''',
'  and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select s.id,',
'       s.name remote_server_name',
'  from wwv_remote_servers s',
' where not exists (',
'     select id from wwv_flow_page_plugs         where remote_server_id = s.id   union all (',
'     select id from wwv_flow_step_processing    where remote_server_id = s.id ) union all (',
'     select id from wwv_flow_jet_chart_series   where remote_server_id = s.id ) union all (',
'     select id from wwv_flow_lists_of_values$   where remote_server_id = s.id ) union all (',
'     select id from wwv_flow_automations        where remote_server_id = s.id ) union all (',
'     select id from wwv_flow_automation_actions where remote_server_id = s.id ) union all (',
'     select id from wwv_flow_processing         where remote_server_id = s.id )',
' ) ',
'  and server_type = ''REMOTE_SQL''',
'  and security_group_id = :FLOW_SECURITY_GROUP_ID'))
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(533155433132172842)
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No unused references to REST Enabled SQL services found.'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_show_search_bar=>'N'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_enable_mail_download=>'N'
,p_owner=>'CARSTEN'
,p_internal_uid=>533155433132172842
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(533155541909172843)
,p_db_column_name=>'REMOTE_SERVER_NAME'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Unused REST Enabled SQL Service'
,p_column_link=>'f?p=&APP_ID.:1601:&SESSION.::&DEBUG.:RP:P1601_ID:#ID#'
,p_column_linktext=>'#REMOTE_SERVER_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(533155644412172844)
,p_db_column_name=>'ID'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(537037396117367161)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'5370374'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'REMOTE_SERVER_NAME:ID'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(582915147453077309)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(154051976265844427)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_landmark_type=>'navigation'
,p_landmark_label=>'REST Enabled SQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(582915356920077309)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>This page displays where a REST Enabled SQL Service is being used within this workspace.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(582915942830077311)
,p_plug_name=>'REST Enabled SQL Reference Utilization'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="padding-bottom: 20px"'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select s.id,',
'       p.flow_id                                            the_application,',
'       wwv_flow_page_api.get_url (',
'           p_page        => 4500,',
'           p_items       => ''FB_FLOW_PAGE_ID,FB_FLOW_ID'',',
'           p_values      => r.page_id||'',''||p.flow_id ) the_page,',
'       ''#''                                                  the_shared_component,',
'       r.page_id                                            page_id,',
'       p.name                                               page_name,',
'       r.plug_source_type                                   plug_source_type,',
'       r.plug_name                                          plug_name,',
'       null                                                 shared_comp_name,',
'       s.name                                               remote_server_name',
'  from wwv_flow_page_plugs r,',
'       wwv_flow_steps p,',
'       wwv_remote_servers s',
' where s.id                = r.remote_server_id',
'   and r.page_id           = p.id',
'   and r.flow_id           = p.flow_id',
'   and s.server_type       = ''REMOTE_SQL''',
'   and s.security_group_id = p.security_group_id',
'   and p.security_group_id = :flow_security_group_id',
'   and not exists ( select 1 from wwv_flow_language_map where translation_flow_id = p.flow_id )',
'union all (',
'select rs.id,',
'       p.flow_id                                            the_application,',
'       wwv_flow_page_api.get_url (',
'           p_page        => 4500,',
'           p_items       => ''FB_FLOW_PAGE_ID,FB_FLOW_ID'',',
'           p_values      => r.page_id||'',''||p.flow_id ) the_page,',
'       ''#''                                                  the_shared_component,',
'       r.page_id                                            page_id,',
'       p.name                                               page_name,',
'       r.plug_source_type                                   plug_source_type,',
'       r.plug_name || '' - '' || s.name                       plug_name,',
'       null                                                 shared_comp_name,',
'       rs.name                                              remote_server_name',
'  from wwv_flow_jet_chart_series s,',
'       wwv_flow_jet_charts c,',
'       wwv_flow_page_plugs r,',
'       wwv_flow_steps p,',
'       wwv_remote_servers rs',
' where rs.id               = s.remote_server_id',
'   and rs.server_type      = ''REMOTE_SQL''',
'   and p.flow_id           = r.flow_id',
'   and s.chart_id          = c.id',
'   and c.region_id         = r.id',
'   and r.page_id           = p.id',
'   and r.flow_id           = p.flow_id',
'   and p.security_group_id = :flow_security_group_id',
'   and not exists (select 1 from wwv_flow_language_map where translation_flow_id = p.flow_id ) )',
'union all (',
'select s.id,',
'       l.flow_id                                            the_application,',
'       ''#''                                                  the_page,',
'       wwv_flow_page_api.get_url (',
'           p_page        => 4111,',
'           p_clear_cache => 4111,',
'           p_items       => ''F4000_P4111_ID,FB_FLOW_ID'',',
'           p_values      => l.id||'',''||l.flow_id ) the_shared_component,',
'       null                                                 page_id,',
'       null                                                 page_name,',
'       wwv_flow_lang.system_message( ''SHARED DYNAMIC LOV'' ) plug_source_type,',
'       null                                                 plug_name,',
'       l.lov_name                                           shared_comp_name,',
'       s.name                                               remote_server_name',
'  from wwv_flow_lists_of_values$ l,',
'       wwv_remote_servers s',
' where s.id = l.remote_server_id',
'   and s.server_type       = ''REMOTE_SQL''',
'   and s.security_group_id = l.security_group_id',
'   and l.security_group_id = :flow_security_group_id',
'   and not exists (select 1 from wwv_flow_language_map where translation_flow_id = l.flow_id ) )',
'union all (',
'select s.id,',
'       a.flow_id                                            the_application,',
'       ''#''                                                  the_page,',
'       wwv_flow_page_api.get_url (',
'           p_page        => 7021,',
'           p_clear_cache => 7021,',
'           p_items       => ''FB_FLOW_ID,P7021_ID'',',
'           p_values      => a.flow_id||'',''||a.id ) the_shared_component,',
'       null                                                 page_id,',
'       null                                                 page_name,',
'       wwv_flow_lang.system_message( ''AUTOMATIONS'' )        plug_source_type,',
'       null                                                 plug_name,',
'       a.name                                               shared_comp_name,',
'       s.name                                               remote_server_name',
'  from wwv_flow_automations a,',
'       wwv_remote_servers s',
' where s.id = a.remote_server_id',
'   and s.server_type       = ''REMOTE_SQL''',
'   and s.security_group_id = a.security_group_id',
'   and a.security_group_id = :flow_security_group_id',
'   and not exists (select 1 from wwv_flow_language_map where translation_flow_id = a.flow_id ) )',
'union all (',
'select s.id,',
'       a.flow_id                                            the_application,',
'       ''#''                                                  the_page,',
'       wwv_flow_page_api.get_url (',
'           p_page        => 7022,',
'           p_clear_cache => 7022,',
'           p_items       => ''FB_FLOW_ID,P7022_ID'',',
'           p_values      => a.flow_id||'',''||a.id ) the_shared_component,',
'       null                                                 page_id,',
'       null                                                 page_name,',
'       wwv_flow_lang.system_message( ''AUTOMATION_ACTIONS'' ) plug_source_type,',
'       null                                                 plug_name,',
'       a.name                                               shared_comp_name,',
'       s.name                                               remote_server_name',
'  from wwv_flow_automation_actions a,',
'       wwv_remote_servers s',
' where s.id = a.remote_server_id',
'   and s.server_type       = ''REMOTE_SQL''',
'   and s.security_group_id = a.security_group_id',
'   and a.security_group_id = :flow_security_group_id',
'   and not exists (select 1 from wwv_flow_language_map where translation_flow_id = a.flow_id ) )'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(582916166664077312)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No used REST Enabled SQL references found in this workspace.'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_chart=>'N'
,p_show_pivot=>'N'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_show_download=>'N'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>582916166664077312
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(236247135587284206)
,p_db_column_name=>'REMOTE_SERVER_NAME'
,p_display_order=>10
,p_column_identifier=>'X'
,p_column_label=>'REST Enabled SQL Service'
,p_column_link=>'f?p=&APP_ID.:1601:&SESSION.::&DEBUG.:RP:P1601_ID:#ID#'
,p_column_linktext=>'#REMOTE_SERVER_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(236246731553284202)
,p_db_column_name=>'THE_PAGE'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'The page'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(236246894348284203)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>30
,p_column_identifier=>'U'
,p_column_label=>'Page ID'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(236246947872284204)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>40
,p_column_identifier=>'V'
,p_column_label=>'Page Name'
,p_column_link=>'#THE_PAGE#'
,p_column_linktext=>'#PAGE_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(236247053654284205)
,p_db_column_name=>'PLUG_NAME'
,p_display_order=>50
,p_column_identifier=>'W'
,p_column_label=>'Component Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(90115721183448606)
,p_db_column_name=>'SHARED_COMP_NAME'
,p_display_order=>60
,p_column_identifier=>'AB'
,p_column_label=>'Shared Component Name'
,p_column_link=>'#THE_SHARED_COMPONENT#'
,p_column_linktext=>'#SHARED_COMP_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(522796475346429232)
,p_db_column_name=>'THE_APPLICATION'
,p_display_order=>70
,p_column_identifier=>'Z'
,p_column_label=>'Application ID'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(90115872380448607)
,p_db_column_name=>'PLUG_SOURCE_TYPE'
,p_display_order=>80
,p_column_identifier=>'AC'
,p_column_label=>'Component Type'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(538211928069052506)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(90115697906448605)
,p_db_column_name=>'THE_SHARED_COMPONENT'
,p_display_order=>90
,p_column_identifier=>'AA'
,p_column_label=>'The Shared Component'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(236247216460284207)
,p_db_column_name=>'ID'
,p_display_order=>100
,p_column_identifier=>'Y'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(582917357175077324)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_type=>'REPORT'
,p_report_alias=>'2362973'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_view_mode=>'REPORT'
,p_report_columns=>'REMOTE_SERVER_NAME:THE_APPLICATION:PLUG_SOURCE_TYPE:SHARED_COMP_NAME:PAGE_ID:PAGE_NAME:PLUG_NAME:'
,p_sort_column_1=>'REMOTE_SERVER_NAME'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'PAGE_ID'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(533155331173172841)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(533155296022172840)
,p_button_name=>'DELETE_UNUSED'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Delete Unused'
,p_button_position=>'DELETE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(533155748387172845)
,p_name=>'Click'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(533155331173172841)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(533155862905172846)
,p_event_id=>wwv_flow_imp.id(533155748387172845)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'Do you really want to delete all unused REST Enabled SQL references in your workspace?'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(533155919210172847)
,p_event_id=>wwv_flow_imp.id(533155748387172845)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'DELETE_UNUSED'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(525231820034218528)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete unused references'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete wwv_remote_servers s',
' where not exists (',
'     select id from wwv_flow_page_plugs         where remote_server_id = s.id   union all (',
'     select id from wwv_flow_step_processing    where remote_server_id = s.id ) union all (',
'     select id from wwv_flow_lists_of_values$   where remote_server_id = s.id ) union all (',
'     select id from wwv_flow_jet_chart_series   where remote_server_id = s.id ) union all (',
'     select id from wwv_flow_automation_actions where remote_server_id = s.id ) union all (',
'     select id from wwv_flow_automations        where remote_server_id = s.id ) union all (',
'     select id from wwv_flow_processing         where remote_server_id = s.id )',
'  ) ',
'  and server_type = ''REMOTE_SQL''',
'  and security_group_id = :FLOW_SECURITY_GROUP_ID;',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(533155331173172841)
,p_process_success_message=>'Unused REST Enabled SQL references deleted.'
,p_internal_uid=>525231820034218528
);
end;
/
prompt --application/pages/page_01603
begin
wwv_flow_imp_page.create_page(
 p_id=>1603
,p_name=>'REST Enabled SQL History'
,p_alias=>'REST-ENABLED-SQL-HISTORY'
,p_step_title=>'REST Enabled SQL History'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(158563443147585227)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(346621888234349034)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(154051976265844427)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_landmark_type=>'navigation'
,p_landmark_label=>'REST Enabled SQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(346622097701349034)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>This page displays recent modifications made to REST Enabled SQL Services in this workspace.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(346622683611349036)
,p_plug_name=>'REST Enabled SQL History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_REMOTESQL_SERVERS_DEV'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(346622907445349037)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>346622907445349037
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(154061684970882361)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(154062080353882361)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Audit Comment'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(154062492908882362)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'REST Enabled SQL Service'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(154062805095882363)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(154063275261882363)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Component Key'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(154063656584882363)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Audit Date'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(154064007812882364)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(346624097956349049)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1540644'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'AUDIT_DATE:ACTION:DEVELOPER:COMPONENT_NAME'
,p_sort_column_1=>'AUDIT_DATE'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(154064875136882365)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(346622683611349036)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1603:&SESSION.::&DEBUG.:1603,RIR::'
);
end;
/
prompt --application/pages/page_01605
begin
wwv_flow_imp_page.create_page(
 p_id=>1605
,p_name=>'Test REST Enabled SQL Service'
,p_alias=>'TEST-REST-ENABLED-SQL-SERVICE'
,p_page_mode=>'MODAL'
,p_step_title=>'Test REST Enabled SQL Service'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(158563443147585227)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2013624502126715)
,p_plug_name=>'Database Version Not Supported'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'The <strong>&P1605_DATABASE_TYPE!HTML.</strong> database version (&P1605_DATABASE_VERSION..x) of this REST Enabled SQL Reference is not supported by &PRODUCT_NAME.. Components will not work properly on this database.'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P1605_SERVER_STATUS = wwv_flow_exec_remote.c_server_ok and wwv_flow_exec_remote.is_supported( :P1605_ID ) = ''N'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(154842416459613404)
,p_plug_name=>'Failed'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The HTTP request to the REST Enabled SQL service was unsuccessful. See the below error message for details and review the attributes of your REST Enabled SQL service.</p>',
'<pre>',
'&P1605_SQL_RESPONSE.</pre>'))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P1605_SERVER_STATUS = wwv_flow_exec_remote.c_server_no_restsql and ( :P1605_HTTP_STATUS is null or :P1605_HTTP_STATUS != 200 ) and :P1605_SQLCODE is not null'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(241342072681308331)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3052579079717938940)
,p_plug_name=>'Items'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'NEVER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3052579796272938947)
,p_plug_name=>'Failed'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'This Server has been removed or the definition has changed.'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P1605_SERVER_STATUS = wwv_flow_exec_remote.c_server_no_metadata'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3052579879184938948)
,p_plug_name=>'Success'
,p_region_template_options=>'#DEFAULT#:a-Alert--success:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The REST Enabled SQL service of the <strong>&P1605_DATABASE_TYPE!HTML.</strong> type is available. The test query returned the following result:</p>',
'<pre>',
'&P1605_SQL_RESPONSE.',
'</pre>'))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P1605_SERVER_STATUS = wwv_flow_exec_remote.c_server_ok and :P1605_SQLCODE is null'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2001622259879514)
,p_plug_name=>'Set Default Database'
,p_parent_plug_id=>wwv_flow_imp.id(3052579879184938948)
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--noIcon:a-Alert--info:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P1605_DATABASE_TYPE = ''MYSQL'' and wwv_flow_exec_remote.is_supported( :P1605_ID ) = ''Y'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(150058352645607442)
,p_plug_name=>'Unsupported SQL Modes'
,p_parent_plug_id=>wwv_flow_imp.id(3052579879184938948)
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--noIcon:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This REST Enabled SQL Reference uses the <strong>NO_BACKSLASH_ESCAPES</strong> or <strong>ANSI_QUOTES</strong> SQL Modes, which are not supported by Oracle APEX. ',
'Edit the REST Enabled SQL Reference to set SQL Modes without <strong>NO_BACKSLASH_ESCAPES</strong> and <strong>ANSI_QUOTES</strong>.',
'</p>'))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1605_DATABASE_TYPE = ''MYSQL'' and wwv_flow_exec_remote.is_supported( :P1605_ID ) = ''Y''',
'and ( ',
'       instr(upper( :P1605_MYSQL_SQL_MODES ), ''ANSI_QUOTES''          ) > 0 ',
'    or instr(upper( :P1605_MYSQL_SQL_MODES ), ''NO_BACKSLASH_ESCAPES'' ) > 0 )'))
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(150058510956607444)
,p_plug_name=>'SQL Modes'
,p_parent_plug_id=>wwv_flow_imp.id(3052579879184938948)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Current SQL Modes:</p>',
'<pre>',
'&P1605_MYSQL_SQL_MODES!HTML.</pre> '))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P1605_DATABASE_TYPE = ''MYSQL'' and wwv_flow_exec_remote.is_supported( :P1605_ID ) = ''Y'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3052579950534938949)
,p_plug_name=>'Failed'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The URL of this remote server does not point to a REST Enabled SQL service. Please check the details of your REST Enabled SQL service definition.</p>',
'<pre>',
'</pre>'))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P1605_SERVER_STATUS = wwv_flow_exec_remote.c_server_no_restsql'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3052580029732938950)
,p_plug_name=>'Failed'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'Authentication failure. Please check authentication credentials.'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P1605_SERVER_STATUS = wwv_flow_exec_remote.c_server_no_auth'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(241342118679308332)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(241342072681308331)
,p_button_name=>'CLOSE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Close'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P1605_BACK_TO_PAGE'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(241342727074308338)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(241342072681308331)
,p_button_name=>'CLOSE_BACK'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Close'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&P1605_BACK_TO_PAGE.:&SESSION.::&DEBUG.:RP::'
,p_button_condition=>'P1605_BACK_TO_PAGE'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(310374134945241812)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(241342072681308331)
,p_button_name=>'EDIT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Edit Rest Enabled SQL Service'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1601:&SESSION.::&DEBUG.:RP:P1601_ID:&P1605_ID.'
,p_button_condition=>'not ( :P1605_SERVER_STATUS = wwv_flow_exec_remote.c_server_ok and :P1605_HTTP_STATUS = 200 and :P1605_SQLCODE is null ) and :P1605_BACK_TO_PAGE is null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2001921354879517)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(2001622259879514)
,p_button_name=>'SAVE_DEFAULT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Set Default Database'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2002173447879519)
,p_branch_action=>'f?p=&APP_ID.:1600:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2001921354879517)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2001478883879512)
,p_name=>'P1605_DATABASE_TYPE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(3052579079717938940)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2001826522879516)
,p_name=>'P1605_DEFAULT_DATABASE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2001622259879514)
,p_prompt=>'Default Database'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value d, column_value r',
'  from table( wwv_flow_remote_server_dev.get_available_objects(',
'                  p_remote_server_id => :P1605_ID,',
'                  p_object_type      => ''SCHEMAS'' ))'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Set the <strong>Default Database</strong> to use for operations on this MySQL REST Enabled SQL Reference.'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2002127701092415)
,p_name=>'P1605_SERVER_STATUS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3052579079717938940)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2013429219126713)
,p_name=>'P1605_DATABASE_VERSION'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(3052579079717938940)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(150058187842607440)
,p_name=>'P1605_MYSQL_SQL_MODES'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(3052579079717938940)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(241342689452308337)
,p_name=>'P1605_BACK_TO_PAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3052579079717938940)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3052579187874938941)
,p_name=>'P1605_SQL_RESPONSE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(3052579079717938940)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3052579266494938942)
,p_name=>'P1605_HTTP_STATUS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(3052579079717938940)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3052579342329938943)
,p_name=>'P1605_SQLCODE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(3052579079717938940)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3052579621631938946)
,p_name=>'P1605_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3052579079717938940)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(241342271342308333)
,p_name=>'Close Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(241342118679308332)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(241342387912308334)
,p_event_id=>wwv_flow_imp.id(241342271342308333)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2002064417879518)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set MySQL Default Database'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'update wwv_remote_servers',
'   set remote_sql_default_schema = :P1605_DEFAULT_DATABASE',
' where id                = :P1605_ID',
'   and security_group_id = :WORKSPACE_ID;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2001921354879517)
,p_process_when=>'P1605_DATABASE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'MYSQL'
,p_process_success_message=>'Default Database set to &P1605_DEFAULT_DATABASE!HTML..'
,p_internal_uid=>2002064417879518
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3052579561518938945)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Test ORDS Remote SQL Server'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_test_result wwv_flow_exec_remote.t_server_test_result;',
'',
'begin',
'    wwv_flow_exec_remote.test_remote_sql_server(',
'        p_remote_server_id => :P1605_ID,',
'        p_test_result      => l_test_result );',
'',
'    :P1605_SQL_RESPONSE     := l_test_result.message;',
'    :P1605_SQLCODE          := l_test_result.sql_error_code;',
'    :P1605_HTTP_STATUS      := l_test_result.http_status_code;',
'    :P1605_SERVER_STATUS    := l_test_result.server_status;',
'',
'    :P1605_DATABASE_TYPE    := case l_test_result.remote_server.database_type',
'                                   when wwv_flow_exec_api.c_database_oracle then ''ORACLE''',
'                                   when wwv_flow_exec_api.c_database_mysql  then ''MYSQL''',
'                               end;',
'    :P1605_DEFAULT_DATABASE := l_test_result.remote_server.default_schema;',
'    :P1605_DATABASE_VERSION := l_test_result.remote_server.database_version;',
'    :P1605_MYSQL_SQL_MODES  := replace( l_test_result.mysql_sql_modes, '','', '', '' );',
'end;',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>3052579561518938945
);
end;
/
prompt --application/pages/page_01615
begin
wwv_flow_imp_page.create_page(
 p_id=>1615
,p_name=>'Create REST Enabled SQL Service'
,p_alias=>'CREATE-REST-ENABLED-SQL-SERVICE'
,p_page_mode=>'MODAL'
,p_step_title=>'Create REST Enabled SQL Service'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(158563443147585227)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'550'
,p_dialog_width=>'60%'
,p_dialog_attributes=>'resizable:true'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(242269813348871847)
,p_plug_name=>'General'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_header=>'Provide a descriptive name and the URL endpoint of your REST Enabled SQL service.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(242270108216871850)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_list_id=>wwv_flow_imp.id(249355742923907578)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(249345749056883001)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(249345985030883003)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(249345749056883001)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(249345829405883002)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(249345749056883001)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(249346071188883004)
,p_branch_name=>'Goto Page 1616'
,p_branch_action=>'f?p=&APP_ID.:1616:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(242269986356871848)
,p_name=>'P1615_NAME'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(242269813348871847)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter a descriptive name for this REST Enabled SQL service.',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(242270099779871849)
,p_name=>'P1615_ENDPOINT_URL'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(242269813348871847)
,p_prompt=>'Endpoint URL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the base URL for this REST Enabled SQL service. Include the ORDS context root and schema URL prefix, but do <strong>not</strong> add <code>/_/sql</code>. For example:',
'<pre>',
'https://{host}:{port}/ords/{schema}',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(14161061341159702)
,p_computation_sequence=>10
,p_computation_item=>'P1615_ENDPOINT_URL'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'regexp_replace( :P1615_ENDPOINT_URL, ''_/sql/?$'' )'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(249346149543883005)
,p_validation_name=>'Name is unique within the workspace'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id ',
'  from wwv_remote_servers',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and name              = :P1615_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Remote server name must be unique within the workspace.'
,p_when_button_pressed=>wwv_flow_imp.id(249345985030883003)
,p_associated_item=>wwv_flow_imp.id(242269986356871848)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(9470895266569849)
,p_validation_name=>'Static ID is unique within the workspace'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'  select id ',
'  from wwv_remote_servers',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and static_id         = regexp_replace( lower( :P1615_NAME ), ''[^abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890]+'', ''_'' )'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The remote server name "&P1615_NAME!HTML." will lead to a static ID which is already taken. Choose a different name.',
''))
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id ',
'  from wwv_remote_servers',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and name              = :P1615_NAME'))
,p_validation_condition_type=>'NOT_EXISTS'
,p_when_button_pressed=>wwv_flow_imp.id(249345985030883003)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(249346298169883006)
,p_validation_name=>'Starts with HTTP or HTTPS'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'regexp_like( ',
'    srcstr   => :P1615_ENDPOINT_URL, ',
'    pattern  => ''^https?://'', ',
'    modifier => ''i'' )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'The endpoint URL must begin with http:// or https://.'
,p_when_button_pressed=>wwv_flow_imp.id(249345985030883003)
,p_associated_item=>wwv_flow_imp.id(242270099779871849)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(249347718788883021)
,p_validation_name=>'Do not append /_/sql to the URL'
,p_validation_sequence=>40
,p_validation=>'not regexp_like( :P1615_ENDPOINT_URL, ''_/sql/?$'' )'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Do not append /_/sql to the ORDS Remote Server endpoint URL.'
,p_when_button_pressed=>wwv_flow_imp.id(249345985030883003)
,p_associated_item=>wwv_flow_imp.id(242270099779871849)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(249346309377883007)
,p_validation_name=>'URL after http:// must exist'
,p_validation_sequence=>50
,p_validation=>'length( :P1615_ENDPOINT_URL ) > 10'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Please provide a valid URL endpoint.'
,p_associated_item=>wwv_flow_imp.id(242270099779871849)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(323224988460171028)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(249345829405883002)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(323225007135171029)
,p_event_id=>wwv_flow_imp.id(323224988460171028)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_01616
begin
wwv_flow_imp_page.create_page(
 p_id=>1616
,p_name=>'Create REST Enabled SQL Service - Authentication'
,p_alias=>'CREATE-REST-ENABLED-SQL-SERVICE-AUTHENTICATION'
,p_page_mode=>'MODAL'
,p_step_title=>'Create REST Enabled SQL Service - Authentication'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(158563443147585227)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(403349869788379589)
,p_plug_name=>'Authentication'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_plug_header=>'Provide authentication information for this REST Enabled SQL service. Enter new credentials for Basic Authentication, or choose an already existing Web Credential.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(190995235628372720)
,p_plug_name=>'Credential Details'
,p_parent_plug_id=>wwv_flow_imp.id(403349869788379589)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(491628643988804839)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_list_id=>wwv_flow_imp.id(249355742923907578)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(498704284828815990)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(249362037539932994)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(498704284828815990)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(249361654285932993)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(498704284828815990)
,p_button_name=>'BACK'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Back'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1615:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(271596699404112726)
,p_branch_name=>'Go To Page 1605'
,p_branch_action=>'f?p=&APP_ID.:1605:&SESSION.::&DEBUG.:RP:P1605_ID:&P1616_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(249362037539932994)
,p_branch_sequence=>5
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':P1605_BACK_TO_PAGE is not null and nvl(:P1616_EMPTY_CREDENTIAL,''N'') = ''N'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(348489784702006015)
,p_branch_name=>'Go To Page 1605'
,p_branch_action=>'f?p=&APP_ID.:1605:&SESSION.::&DEBUG.:RP:P1605_ID,P1605_BACK_TO_PAGE:&P1616_ID.,1600&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(249362037539932994)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1616_EMPTY_CREDENTIAL'
,p_branch_condition_text=>'N'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(271596706004112727)
,p_branch_name=>'Goto return page'
,p_branch_action=>'f?p=&APP_ID.:&P1605_BACK_TO_PAGE.:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'ITEM_IS_NOT_NULL'
,p_branch_condition=>'P1605_BACK_TO_PAGE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(249347627785883020)
,p_branch_name=>'Goto Page 1600'
,p_branch_action=>'f?p=&APP_ID.:1600:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1505575679184443)
,p_name=>'P1616_CLIENT_ID_CASE_SENS'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(190995235628372720)
,p_prompt=>'Case Sensitive User Name'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enable this switch to store a case-sensitive User Name. Otherwise the user name will be converted to upper case. While user names are typically in upper case on Oracle databases, MySQL user names are most often in lower case.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(190995149344372719)
,p_name=>'P1616_EMPTY_CREDENTIAL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(403349869788379589)
,p_item_default=>'N'
,p_prompt=>'Store Credentials'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'When turned off, the named credential will be created, with empty values stored as <em>Username</em> and <em>Password</em>. To use the REST Enabled SQL Reference, credentials must be set for the APEX Session, with the <strong>APEX_CREDENTIAL.SET_SESS'
||'ION_CREDENTIALS</strong> procedure.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(249363261773935959)
,p_name=>'P1616_CREDENTIALS_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(403349869788379589)
,p_prompt=>'Credential Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a descriptive name for the Web Credential.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(249365097716935960)
,p_name=>'P1616_CLIENT_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(190995235628372720)
,p_prompt=>'User Name'
,p_post_element_text=>'<div id="P1616_CLIENT_ID_SUFFIX"></div>'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'For Basic Authentication, enter the database user name. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(249365988841935961)
,p_name=>'P1616_SECRET'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(190995235628372720)
,p_prompt=>'Password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>255
,p_tag_attributes=>'autocomplete="new-password"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter the password. This information is stored encrypted and cannot be retrieved in clear text.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(249366856266935963)
,p_name=>'P1616_SECRET_VERIFY'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(190995235628372720)
,p_prompt=>'Verify Password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter the password again to verify your input. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(249373581170994236)
,p_name=>'P1616_CRED_STORE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(403349869788379589)
,p_prompt=>'Credentials'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LOV_CREDENTIAL_STORES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_credentials',
' where security_group_id    = :FLOW_SECURITY_GROUP_ID',
'   and authentication_type != ''KEY_PAIR'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Enter new -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the Web Credential to use for authentication. To edit the credential, navigate to <strong>Web Credentials</strong> in <strong>Shared Components</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(348489523387006013)
,p_name=>'P1616_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(403349869788379589)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(310377185455241842)
,p_computation_sequence=>10
,p_computation_item=>'P1616_CLIENT_ID'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case when :P1616_CLIENT_ID_CASE_SENS = ''Y'' then :P1616_CLIENT_ID else upper(  :P1616_CLIENT_ID ) end',
''))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(249346894956883012)
,p_validation_name=>'Credential Name must be unique'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'  from wwv_credentials',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and name              = :P1616_CREDENTIALS_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Credential name must be unique within the application. This name is already being used.'
,p_validation_condition=>'P1616_CRED_STORE'
,p_validation_condition_type=>'ITEM_IS_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(249362037539932994)
,p_associated_item=>wwv_flow_imp.id(249363261773935959)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(9470935922569850)
,p_validation_name=>'Credential Static ID must be unique'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'  from wwv_credentials',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and static_id         = regexp_replace( lower( :P1616_CREDENTIALS_NAME ), ''[^abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890]+'', ''_'' )'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The credential name "&P1616_CREDENTIALS_NAME!HTML." will lead to a static ID which is already taken. Choose a different name.',
''))
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_result number;',
'begin',
'    l_result := case when :P1616_CRED_STORE is not null then 1 end;',
'',
'    if l_result is null then',
'        begin',
'            select 1',
'              into l_result',
'              from wwv_credentials',
'             where security_group_id = :FLOW_SECURITY_GROUP_ID',
'               and name              = :P1616_CREDENTIALS_NAME',
'               and rownum            = 1;',
'        exception',
'            when NO_DATA_FOUND then null;',
'        end;',
'    end if;',
'',
'    return l_result is null;',
'end;'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'FUNCTION_BODY'
,p_when_button_pressed=>wwv_flow_imp.id(249362037539932994)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(249346956295883013)
,p_validation_name=>'CLIENT_ID is not null'
,p_validation_sequence=>30
,p_validation=>'P1616_CLIENT_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>':P1616_CRED_STORE is null and :P1616_EMPTY_CREDENTIAL = ''N'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(249362037539932994)
,p_associated_item=>wwv_flow_imp.id(249365097716935960)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(249347012214883014)
,p_validation_name=>'CLIENT_SECRET is not null'
,p_validation_sequence=>40
,p_validation=>'P1616_SECRET'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>':P1616_CRED_STORE is null and :P1616_EMPTY_CREDENTIAL = ''N'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(249362037539932994)
,p_associated_item=>wwv_flow_imp.id(249365988841935961)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(249347140280883015)
,p_validation_name=>'CLIENT_SECRET_VERIFY is not null'
,p_validation_sequence=>50
,p_validation=>'P1616_SECRET_VERIFY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>':P1616_CRED_STORE is null and :P1616_EMPTY_CREDENTIAL = ''N'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(249366856266935963)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(249347208222883016)
,p_validation_name=>'Client Secrets must match'
,p_validation_sequence=>60
,p_validation=>':P1616_SECRET = :P1616_SECRET_VERIFY'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Password does not match verification.'
,p_validation_condition=>':P1616_CRED_STORE is null and :P1616_EMPTY_CREDENTIAL = ''N'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(249362037539932994)
,p_associated_item=>wwv_flow_imp.id(249366856266935963)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(249281995624575833)
,p_validation_name=>'Credential Name required'
,p_validation_sequence=>70
,p_validation=>'P1616_CREDENTIALS_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Credentials name must have a value.'
,p_validation_condition=>'P1616_CRED_STORE'
,p_validation_condition_type=>'ITEM_IS_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(249362037539932994)
,p_associated_item=>wwv_flow_imp.id(249363261773935959)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(249346595632883009)
,p_name=>'Credential Chosen'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1616_CRED_STORE'
,p_condition_element=>'P1616_CRED_STORE'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(249346660574883010)
,p_event_id=>wwv_flow_imp.id(249346595632883009)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1616_CREDENTIALS_NAME,P1616_CLIENT_ID,P1616_SECRET,P1616_SECRET_VERIFY,P1616_EMPTY_CREDENTIAL,P1616_CLIENT_ID_CASE_SENS'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(249346755909883011)
,p_event_id=>wwv_flow_imp.id(249346595632883009)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1616_CREDENTIALS_NAME,P1616_CLIENT_ID,P1616_SECRET,P1616_SECRET_VERIFY,P1616_EMPTY_CREDENTIAL,P1616_CLIENT_ID_CASE_SENS'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(249347335051883017)
,p_event_id=>wwv_flow_imp.id(249346595632883009)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1616_CREDENTIALS_NAME,P1616_CLIENT_ID,P1616_SECRET,P1616_SECRET_VERIFY'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(784739671147781448)
,p_event_id=>wwv_flow_imp.id(249346595632883009)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1616_CREDENTIALS_NAME'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>'wwv_flow_lang_dev.builder_message(''WWV_FLOW_CREDENTIAL_DEV.CREDENTIALS_FOR'', :P1615_NAME )'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(713444194371412423)
,p_event_id=>wwv_flow_imp.id(249346595632883009)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1616_EMPTY_CREDENTIAL'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case when client_id is null then ''Y'' else ''N'' end ',
'  from wwv_credentials ',
' where id                = :P1616_CRED_STORE',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
''))
,p_attribute_07=>'P1616_CRED_STORE'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(784739734208781449)
,p_event_id=>wwv_flow_imp.id(249346595632883009)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1616_CREDENTIALS_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'BASIC'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(190995330941372721)
,p_name=>'Show / Hide Credential Details'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1616_EMPTY_CREDENTIAL'
,p_condition_element=>'P1616_EMPTY_CREDENTIAL'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(190995493861372722)
,p_event_id=>wwv_flow_imp.id(190995330941372721)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(190995235628372720)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(190995512230372723)
,p_event_id=>wwv_flow_imp.id(190995330941372721)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(190995235628372720)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(249347549250883019)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create REST Enabled SQL Reference'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    insert into wwv_remotesql_servers_dev (',
'        server_name,',
'        base_url,',
'        credential_id,',
'        auth_required,',
'        credential_name,',
'        authentication_type,',
'        client_id,',
'        client_secret,',
'        client_secret_verify,',
'        prompt_on_install )',
'    values (',
'        :P1615_NAME,',
'        :P1615_ENDPOINT_URL,',
'        :P1616_CRED_STORE,',
'        ''Y'',',
'        :P1616_CREDENTIALS_NAME,',
'        ''BASIC'',',
'        :P1616_CLIENT_ID,',
'        :P1616_SECRET,',
'        :P1616_SECRET_VERIFY,',
'        ''Y'' );',
'        ',
'    select id into :P1616_ID',
'      from wwv_remotesql_servers_dev',
'     where server_name = :P1615_NAME',
'       and security_group_id = :FLOW_SECURITY_GROUP_ID;',
'       ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(249362037539932994)
,p_process_success_message=>'REST Enabled SQL service created.'
,p_internal_uid=>249347549250883019
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1758450926531732)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Adjust P1616_EMPTY_CREDENTIAL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1616_EMPTY_CREDENTIAL := case when :P1616_CRED_STORE is not null',
'                                then ''N''',
'                                else :P1616_EMPTY_CREDENTIAL ',
'                           end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>1758450926531732
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(784739578500781447)
,p_process_sequence=>10
,p_process_point=>'BEFORE_BOX_BODY'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set a default Web Credential Name'
,p_process_sql_clob=>':P1616_CREDENTIALS_NAME := wwv_flow_lang_dev.builder_message(''WWV_FLOW_CREDENTIAL_DEV.CREDENTIALS_FOR'', :P1615_NAME );'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>784739578500781447
);
end;
/
prompt --application/pages/page_01620
begin
wwv_flow_imp_page.create_page(
 p_id=>1620
,p_name=>'Credentials'
,p_alias=>'CREDENTIALS'
,p_step_title=>'Credentials'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(158563552508587748)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(308538337233045967)
,p_plug_name=>'Web Credentials'
,p_region_template_options=>'#DEFAULT#:a-Region--sideRegion:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="border-bottom-width: 0;"'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use <strong>Web Credentials</strong> to connect to REST Enabled SQL or other external REST services. &PRODUCT_NAME. securely stores and encrypts these credentials for use by &PRODUCT_NAME. components and API. Credentials cannot be retrieved back i'
||'n clear text.</p>',
'<p>Credentials are stored at the workspace level and therefore are visible in all applications. When you export an application, used credentials are added to the export file.</p>',
'<p>When you import the application into another workspace, &PRODUCT_NAME. checks whether the target workspace already contains credentials with the same static ID. If a credential already exists, the application uses it. Otherwise the credential from'
||' the import file is created in the target workspace.</p>'))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(312276959486040232)
,p_plug_name=>'Credentials'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'   id,',
'   name,',
'   static_id,',
'   authentication_type,',
'   wwv_flow_utilities.prepare_url( ''f?p=4000:1621:'' || :APP_SESSION || '':::1621:P1621_BACK_TO_PAGE,P1621_ID:1620,'' || id ) as link,',
'   ''icon-util-security-profiles'' as img,',
'   LAST_UPDATED_BY updated_by,',
'   LAST_UPDATED_ON updated,',
'   created_by,',
'   created_on created',
' from wwv_credentials_dev ',
'where security_group_id = :flow_security_group_id',
'       '))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(312277037396040233)
,p_name=>'Build Options'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No credentials are defined within this workspace.'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#LINK#" class="a-IRR-icon"><span class="a-Icon #IMG#"></span><span class="a-IRR-iconName">#NAME#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'MIKE'
,p_internal_uid=>312277037396040233
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(154574062197566123)
,p_db_column_name=>'AUTHENTICATION_TYPE'
,p_display_order=>40
,p_column_identifier=>'AJ'
,p_column_label=>'Authentication'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(154078822199034715)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(154568407972566117)
,p_db_column_name=>'ID'
,p_display_order=>110
,p_column_identifier=>'E'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(154568895716566117)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>120
,p_column_identifier=>'I'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(154569248272566117)
,p_db_column_name=>'UPDATED'
,p_display_order=>130
,p_column_identifier=>'J'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(154569674943566118)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>140
,p_column_identifier=>'S'
,p_column_label=>'Created By'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(154570003312566118)
,p_db_column_name=>'CREATED'
,p_display_order=>150
,p_column_identifier=>'T'
,p_column_label=>'Created'
,p_column_type=>'DATE'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(154572862302566121)
,p_db_column_name=>'IMG'
,p_display_order=>160
,p_column_identifier=>'AG'
,p_column_label=>'Img'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(154573283118566122)
,p_db_column_name=>'LINK'
,p_display_order=>170
,p_column_identifier=>'AH'
,p_column_label=>'Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3052578210569938932)
,p_db_column_name=>'NAME'
,p_display_order=>180
,p_column_identifier=>'AK'
,p_column_label=>'Name'
,p_column_link=>'#LINK#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(397074171521399217)
,p_db_column_name=>'STATIC_ID'
,p_display_order=>190
,p_column_identifier=>'AL'
,p_column_label=>'Static Identifier'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(312279461465115193)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_type=>'REPORT'
,p_report_alias=>'1545744'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'NAME:AUTHENTICATION_TYPE:STATIC_ID:'
,p_sort_column_1=>'PATCH_NAME'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(356448355468553233)
,p_plug_name=>'tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(154583731613661573)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(712704827760087678)
,p_plug_name=>'Learn More'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="padding: 0 12px 12px 12px;"'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'sys.htp.p(''<p><a href="&SYSTEM_HELP_URL." target="_blank">''||wwv_flow_lang.system_message(''LEARN MORE'')||'' ...</a></p>'');'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(154574801131566132)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(312276959486040232)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1620:&SESSION.::&DEBUG.:1600,RIR::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(154575240742566136)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(312276959486040232)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1621:&SESSION.::&DEBUG.:1621:P1621_BACK_TO_PAGE:&APP_PAGE_ID.'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(154576707576566147)
,p_branch_action=>'1620'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_01621
begin
wwv_flow_imp_page.create_page(
 p_id=>1621
,p_name=>'Create/Edit Credential'
,p_alias=>'CREATE-EDIT-CREDENTIAL'
,p_step_title=>'Create/Edit Credential'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(158563552508587748)
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1755362132531701)
,p_plug_name=>'Database Credential'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_db_version.c_has_utl_http_credential'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1757859804531726)
,p_plug_name=>'Advanced'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1759448228531742)
,p_plug_name=>'Prompt On Install Region'
,p_parent_plug_id=>wwv_flow_imp.id(1757859804531726)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1759772136531745)
,p_plug_name=>'Comments Region'
,p_parent_plug_id=>wwv_flow_imp.id(1757859804531726)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>30
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(117793092137505918)
,p_plug_name=>'Stored Tokens'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P1621_CREDENTIALS_TYPE'
,p_plug_display_when_cond2=>'OAUTH2_CLIENT_CREDENTIALS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(117792038112505908)
,p_name=>'Credential Tokens'
,p_parent_plug_id=>wwv_flow_imp.id(117793092137505918)
,p_template=>wwv_flow_imp.id(208928010704475743)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--horizontalBorders:a-Report--stretch'
,p_new_grid_row=>false
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl( sum( case when value_type = ''ACCESS_TOKEN'' then 1 else 0 end ), 0 ) as access_tokens,',
'       nvl( sum( case when value_type = ''REFRESH_TOKEN'' then 1 else 0 end ), 0 ) as refresh_tokens,',
'       nvl( sum( case when value_type = ''ID_TOKEN'' then 1 else 0 end ), 0 ) as id_tokens   ',
'  from wwv_credential_instances',
' where credential_id = :P1621_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and session_id is null'))
,p_header=>'Count of Access, Refresh and ID tokens valid for all sessions.'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(82408032331628644)
,p_query_num_rows=>1
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(117792259930505910)
,p_query_column_id=>1
,p_column_alias=>'ACCESS_TOKENS'
,p_column_display_sequence=>1
,p_column_heading=>'Access Tokens'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(117792310894505911)
,p_query_column_id=>2
,p_column_alias=>'REFRESH_TOKENS'
,p_column_display_sequence=>2
,p_column_heading=>'Refresh Tokens'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(117792420077505912)
,p_query_column_id=>3
,p_column_alias=>'ID_TOKENS'
,p_column_display_sequence=>3
,p_column_heading=>'ID Tokens'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(117792568458505913)
,p_name=>'Session Tokens'
,p_parent_plug_id=>wwv_flow_imp.id(117793092137505918)
,p_template=>wwv_flow_imp.id(208928010704475743)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--horizontalBorders:a-Report--stretch'
,p_new_grid_row=>false
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count( distinct session_id ) as distinct_sessions ,',
'       nvl( sum( case when value_type = ''ACCESS_TOKEN'' then 1 else 0 end ), 0 ) as access_tokens,',
'       nvl( sum( case when value_type = ''REFRESH_TOKEN'' then 1 else 0 end ), 0 ) as refresh_tokens,',
'       nvl( sum( case when value_type = ''ID_TOKEN'' then 1 else 0 end ), 0 ) as id_tokens   ',
'  from wwv_credential_instances',
' where credential_id = :P1621_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and session_id is not null'))
,p_header=>'Count of Access, Refresh or ID tokens valid for a specific session only.'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(82408032331628644)
,p_query_num_rows=>1
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(117792965575505917)
,p_query_column_id=>1
,p_column_alias=>'DISTINCT_SESSIONS'
,p_column_display_sequence=>1
,p_column_heading=>'Tokens for Sessions'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(117792685837505914)
,p_query_column_id=>2
,p_column_alias=>'ACCESS_TOKENS'
,p_column_display_sequence=>2
,p_column_heading=>'Access Tokens (Session)'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(117792766698505915)
,p_query_column_id=>3
,p_column_alias=>'REFRESH_TOKENS'
,p_column_display_sequence=>3
,p_column_heading=>'Refresh Tokens (Session)'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(117792829592505916)
,p_query_column_id=>4
,p_column_alias=>'ID_TOKENS'
,p_column_display_sequence=>4
,p_column_heading=>'ID Tokens (Session)'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(308592151420746764)
,p_plug_name=>'Attributes'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_query_num_rows=>15
,p_plug_query_show_nulls_as=>'(null)'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(488484273956069306)
,p_plug_name=>'Web Credentials'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Store authentication credentials for external REST services or REST Enabled SQL services.</p>',
'<p>The Client Secret will be stored encrypted, and it can only be used by &PRODUCT_NAME. and cannot be retrieved in clear text.</p>',
'<p>Also, credential information will not be included in application export files. After importing an application into the target workspace, prompts will be displayed to re-enter the credentials.</p>'))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(924109676790463691)
,p_plug_name=>'Web Credentials'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(154599371603686563)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(924109676790463691)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&P1621_BACK_TO_PAGE.:&SESSION.::&DEBUG.:RP,1621::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(154599745454686565)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(924109676790463691)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
,p_button_condition=>'P1621_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(154600176572686567)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(924109676790463691)
,p_button_name=>'Update'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P1621_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(154600589325686567)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(924109676790463691)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>'P1621_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(117791341683505901)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(924109676790463691)
,p_button_name=>'CLEAR_TOKENS'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Clear Tokens'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P1621_CREDENTIALS_TYPE'
,p_button_condition2=>'OAUTH2_CLIENT_CREDENTIALS'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(310375757614241828)
,p_branch_name=>'Go To Page &P1621_BACK_TO_PAGE.'
,p_branch_action=>'f?p=&APP_ID.:&P1621_BACK_TO_PAGE.:&SESSION.::&DEBUG.:RP,1621::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'ITEM_IS_NOT_NULL'
,p_branch_condition=>'P1621_BACK_TO_PAGE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(154611279857686609)
,p_branch_name=>'Go To Page 1620'
,p_branch_action=>'f?p=&APP_ID.:1620:&SESSION.::&DEBUG.:RP,1620::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow.g_request in (''Create'',''Delete'',''Update'')'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(154611602684686609)
,p_branch_name=>'Go To Page 1621'
,p_branch_action=>'f?p=&APP_ID.:1621:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1342962966822914)
,p_name=>'P1621_OCI_USER_ID'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(308592151420746764)
,p_prompt=>'OCI User ID'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Enter the Oracle Cloud Infrastructure <em>User OCID</em>. &PRODUCT_NAME. does not store this information encrypted.</p> <p><a rel="noopener noreferrer" target="_blank" href="https://docs.cloud.oracle.com/iaas/Content/API/Concepts/apisigningkey.htm'
||'">Oracle Cloud Infrastructure Documentation</a></p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1343058530822915)
,p_name=>'P1621_OCI_PRIVATE_KEY'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(308592151420746764)
,p_prompt=>'OCI Private Key'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Enter the private key in PEM format for OCI authentication. &PRODUCT_NAME. stores this information encrypted and secure, so it cannot be retrieved back in clear text.</p><p><a rel="noopener noreferrer" target="_blank" href="https://docs.cloud.orac'
||'le.com/iaas/Content/API/Concepts/apisigningkey.htm">Oracle Cloud Infrastructure Documentation</a></p>'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1343124181822916)
,p_name=>'P1621_OCI_NAMESPACE'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(308592151420746764)
,p_use_cache_before_default=>'NO'
,p_prompt=>'OCI Tenancy ID'
,p_source=>'NAMESPACE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the Oracle Cloud Infrastructure <em>Tenancy''s OCID</em>.</p>',
'<p><a rel="noopener noreferrer" target="_blank" href="https://docs.cloud.oracle.com/iaas/Content/API/Concepts/apisigningkey.htm">Oracle Cloud Infrastructure Documentation</a></p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1343282077822917)
,p_name=>'P1621_OCI_FINGERPRINT'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(308592151420746764)
,p_use_cache_before_default=>'NO'
,p_prompt=>'OCI Public Key Fingerprint'
,p_source=>'FINGERPRINT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'<p>Enter the <em>public RSA key fingerprint</em> for OCI authentication. </p><p><a rel="noopener noreferrer" target="_blank" href="https://docs.cloud.oracle.com/iaas/Content/API/Concepts/apisigningkey.htm">Oracle Cloud Infrastructure Documentation</a'
||'></p>'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1701886111678401)
,p_name=>'P1621_CERTIFICATE'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(308592151420746764)
,p_prompt=>'Certificate'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the Certificate in PEM format.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1701904410678402)
,p_name=>'P1621_CERT_PRIVATE_KEY'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(308592151420746764)
,p_prompt=>'Private Key'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the private key in PEM format. &PRODUCT_NAME. stores this information encrypted and secure, so it cannot be retrieved back in clear text.'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1755422406531702)
,p_name=>'P1621_SCHEMA_DB_CRED_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(1755362132531701)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>128
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Provide the case-sensitive name of the database credential. The database credential must be accessible to ',
'    the <em>application parsing schema</em>, without using',
'    a schema qualifier. That means that a <em>synonym</em> is required if the credential resides within ',
'    another database schema.</p>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1755533107531703)
,p_name=>'P1621_DB_CREDENTIAL_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1755362132531701)
,p_item_default=>'SCHEMA'
,p_prompt=>'Accessible by'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DB_CREDENTIAL_ACCESS_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(3027178558775923)||'.'
,p_display_when=>'wwv_flow_platform.get_preference( ''INSTANCE_DBMS_CREDENTIAL_ENABLED'' ) = ''Y'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Indicate whether the database credential is available to the workspace schema, or to',
'    the APEX Engine.',
'</p>',
'<dl>',
'    <dt>Schema</dt>',
'    <dd>The database credential is accessible to one of the workspace schemas. When the',
'        credential is used by an application, the <em>application parsing schema</em>',
'        must be able to access the database credential.</dd>',
'    <dt>Instance</dt>',
'    <dd>The database credential is accessible to the APEX engine, to the',
'        <code>APEX_NNNNNN</code> schema. Once this option is selected, the first',
'        available database credential is pre-selected into the <strong>Name</strong>',
'        attribute.</dd>',
'</dl>'))
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1759810826531746)
,p_name=>'P1621_INSTANCE_DB_CRED_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(1755362132531701)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select credential_name',
'  from sys.all_credentials',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cSize=>80
,p_cMaxlength=>128
,p_display_when=>'wwv_flow_platform.get_preference( ''INSTANCE_DBMS_CREDENTIAL_ENABLED'' ) = ''Y'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Provide the case-sensitive name of the database credential. The database credential must be accessible to the APEX engine ',
'    schema (<code>APEX_NNNNNN</code>), without using ',
'    a schema qualifier. That means that a <em>synonym</em> is required if the credential resides within ',
'    another database schema.</p>'))
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1802202074350512)
,p_name=>'P1621_PUBLIC_KEY'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(308592151420746764)
,p_prompt=>'Public Key'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the public key for for the key pair credentials. &PRODUCT_NAME. does not store this information encrypted.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1802346339350513)
,p_name=>'P1621_PRIVATE_KEY'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(308592151420746764)
,p_prompt=>'Private Key'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter the private key for the key pair credentials. &PRODUCT_NAME. stores this information encrypted, so it cannot be retrieved back in clear text.'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1802400191350514)
,p_name=>'P1621_PRIVATE_KEY_VERIFY'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(308592151420746764)
,p_prompt=>'Verify Private Key'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter the private key again, to verify your input.'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2545228608236501)
,p_name=>'P1621_USE_DB_CREDENTIAL'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(308592151420746764)
,p_prompt=>'Use Database Credential'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>'wwv_flow_db_version.c_has_utl_http_credential'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Enable to use the secrets stored within a database credential.',
'    Available credentials can be obtained from the <strong>ALL_CREDENTIALS</strong>',
'    dictionary view. Use the <strong>DBMS_CREDENTIAL</strong> package ',
'    to maintain database credentials.</p>',
'<p>',
'    <em>Using a database credential changes the behavior of HTTP requests being done and how Web Credentials work:</em></p>',
'<ul>',
'    <li>',
'        If a database credential is used, all HTTP requests will be done in the ',
'        context of the application''s parsing schema, and not in the context of the',
'        APEX engine. That means that <em>PL/SQL network ACLs</em> must be granted',
'        to the application''s parsing schema. See the documentation for the',
'        <strong>DBMS_NETWORK_ACL_ADMIN</strong> for more details.</li>',
'    <li>',
'        A database credential is completely maintained by the database, &PRODUCT_NAME.',
'        does not have access to the stored secrets. As &PRODUCT_NAME. thus cannot enforce ',
'        the <strong>Valid for URLs</strong> attribute, this attribute is disabled when a',
'        database credential is used.</li>',
'</ul>'))
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2991518693431206)
,p_name=>'P1621_DB_CRED_IS_INSTANCE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1755362132531701)
,p_use_cache_before_default=>'NO'
,p_source=>'DB_CREDENTIAL_IS_INSTANCE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2992259103431213)
,p_name=>'P1621_DB_CREDENTIAL_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1755362132531701)
,p_use_cache_before_default=>'NO'
,p_source=>'DB_CREDENTIAL_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3366837426004641)
,p_name=>'P1621_GENERIC_NAME'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_imp.id(308592151420746764)
,p_prompt=>'Credential Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Provide the name of the HTTP Header or URL Query String parameter to use for this credential.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3366993821004642)
,p_name=>'P1621_GENERIC_VALUE'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_imp.id(308592151420746764)
,p_prompt=>'Credential Secret'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Provide the (secret) value of the credential.'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3367384134004646)
,p_name=>'P1621_VALID_FOR_URLS'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_imp.id(308592151420746764)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Valid for URLs'
,p_source=>'VALID_FOR_URLS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>&PRODUCT_NAME. will check whether the URL, for which the credential is being used at run time, matches one of the URLs within this list. If the URL does not match, &PRODUCT_NAME. will raise an error.</p>',
'<p>Enter each URL on a new line. The URL endpoint being used must start with one of the URLs provided here.</p>',
'<p>Example:</p>',
'<pre>',
'https://www.example.com/restapis/my-protected-api',
'https://www.example.com/allowed-urls',
'</pre>',
'<p>If the credential is used to invoke a REST service at <strong>https://www.example.com/restapis/my-protected-api/restendpoint</strong> or <strong>https://www.example.com/allowed-urls/page1</strong>, the credential can be used and the call will succ'
||'eed.</p>',
'<p>If the credential is used to invoke a REST service at <strong>https://localhost/myapis/test</strong> or <strong>https://dev.example.com/myapis/test</strong>, the credential <em>cannot</em> be used and &PRODUCT_NAME. will raise an error.</p>',
'<p>Example:</p>',
'<pre>',
'ldap://ldap.mycompany.com',
'ldaps://ldap.mycompany.com:389',
'</pre>',
'<p>ldap:// and ldaps:// is the "protocol" to specify the allowed URLs for an LDAP server.</p>',
'<p>Note that changing this value requires re-entering the client secret.</p>'))
,p_inline_help_text=>'Note that changing this value requires re-entering the client secret.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(55557897779883020)
,p_name=>'P1621_SCOPE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(308592151420746764)
,p_use_cache_before_default=>'NO'
,p_prompt=>'OAuth Scope'
,p_source=>'SCOPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Permissions represented by the Access Token in OAuth 2.0 terms are known as scopes. The scope parameter allows the application to express the desired scope of the access request. ',
'</p>',
'<p>',
'    If your authentication server requires a scope to be specified for the access token request, provide it here. The OAuth2 access token will then be requested with the following request body:',
'<pre>',
'grant_type=client_credentials&amp;scope=<strong>{scope}</strong>',
'</pre>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(154587431457686543)
,p_name=>'P1621_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(308592151420746764)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(154589647585686551)
,p_name=>'P1621_PROMPT_ON_INSTALL'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1759448228531742)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Prompt On Install'
,p_source=>'PROMPT_ON_INSTALL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Choose whether prompts for this credential should be displayed when the application is being imported on another &PRODUCT_NAME. instance. Since &PRODUCT_NAME. never exports Passwords or Client Secrets, installation prompts are <em>always</em> generat'
||'ed when a Client ID or Username are provided.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(154593032746686556)
,p_name=>'P1621_CREDENTIALS_NAME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(308592151420746764)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a descriptive name for the Credentials. This name must be unique within the workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(154593935882686557)
,p_name=>'P1621_CREDENTIALS_TYPE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(308592151420746764)
,p_use_cache_before_default=>'NO'
,p_item_default=>'BASIC'
,p_prompt=>'Authentication Type'
,p_source=>'AUTHENTICATION_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CREDENTIALS_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(154078822199034715)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify the authentication type here. &PRODUCT_NAME. supports the following authentication types:</p>',
'<ul>',
'    <li><strong>Basic Authentication</strong> - Sends username and password in Base64-encoded form as the <strong>Authorization</strong> request header.',
'    </li>',
'    <li><strong>OAuth2 Client Credentials</strong> - &PRODUCT_NAME. exchanges the client ID and client secret for an <strong>Access Token</strong> using a token server URL. The access token is then used to perform the actual request. If the access to'
||'ken is expired, &PRODUCT_NAME. will transparently request a new one.</li>',
'    <li><strong>OCI Native Authentication</strong> - &PRODUCT_NAME. signs requests to the <em>Oracle Cloud Infrastructure (OCI)</em> REST API, as described in the <a rel="noopener noreferrer" href="https://docs.cloud.oracle.com/en-us/iaas/Content/API'
||'/Concepts/signingrequests.htm">OCI Documentation</a>. This type is only available in Oracle Database 18c and higher.</li>',
'    <li><strong>HTTP Header</strong> - The credential is added to the REST request as an HTTP Header. The name of the credential is used as the HTTP Header name, and the Secret of the credential is used as the HTTP Header value. &PRODUCT_NAME. does n'
||'ot add these secrets to the Debug log or any other logs.</li>',
'    <li><strong>URL Query String</strong> -  The credential is added to the URL of the REST request as a <em>Query String</em> Parameter (for example: <strong>?name=value</strong>). This option can be useful with API keys. &PRODUCT_NAME. does not add'
||' these secrets to the Debug log or any other logs. However, web proxy or other intermediate servers may record these credentials in their log files.</li>',
'    <li><strong>Key Pair</strong> - A key pair credential consists of a public key, openly shared for encrypting data, and a private key, securely kept secret for decrypting data, together ensuring a secure data exchange.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(154594835374686558)
,p_name=>'P1621_CLIENT_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(308592151420746764)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Client ID or Username'
,p_source=>'CLIENT_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the Username for Basic Authentication and the Client ID for the OAuth2 Client Credentials flow. &PRODUCT_NAME. does not store this information encrypted.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(154595724346686559)
,p_name=>'P1621_SECRET'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(308592151420746764)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Client Secret or Password'
,p_source=>'CLIENT_SECRET'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_tag_attributes=>'autocomplete="new-password"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter the Password for Basic Authentication and the Client Secret for the OAuth2 Client Credentials flow. &PRODUCT_NAME. stores this information encrypted, so it cannot be retrieved back in clear text.'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(154596677053686559)
,p_name=>'P1621_SECRET_VERIFY'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(308592151420746764)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Verify Client Secret or Password'
,p_source=>'CLIENT_SECRET_VERIFY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_tag_attributes=>'autocomplete="new-password"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter the Password or Client Secret again, to verify your input.'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(154597893068686561)
,p_name=>'P1621_COMMENT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1759772136531745)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comments'
,p_source=>'CREDENTIAL_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Enter any comments or notes here. These comments never display when running the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(310375632284241827)
,p_name=>'P1621_BACK_TO_PAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(308592151420746764)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(397074296277399218)
,p_name=>'P1621_CREDENTIALS_STATIC_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(308592151420746764)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Static ID'
,p_source=>'STATIC_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Use the Static ID to reference the credential in API calls. If no value is provided, the static ID will be derived from the credential name.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(537388993086764713)
,p_name=>'P1621_ALWAYS_PROMPT_ON_INSTALL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1759448228531742)
,p_prompt=>'Prompt On Install'
,p_source=>'Y'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_YES_NO'
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Choose whether prompts for this credential should be displayed when the application is being imported on another &PRODUCT_NAME. instance. Since &PRODUCT_NAME. never exports Passwords or Client Secrets, installation prompts are <em>always</em> generat'
||'ed when a Client ID or Username is provided.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1802535129352614)
,p_computation_sequence=>10
,p_computation_item=>'P1621_PROMPT_ON_INSTALL'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'N'
,p_compute_when=>'P1621_CREDENTIALS_TYPE'
,p_compute_when_text=>'KEY_PAIR'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(537388624465764710)
,p_computation_sequence=>10
,p_computation_item=>'P1621_PROMPT_ON_INSTALL'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'case when :P1621_CLIENT_ID is not null then ''Y'' else :P1621_PROMPT_ON_INSTALL end'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1344321356822928)
,p_computation_sequence=>20
,p_computation_item=>'P1621_OCI_USER_ID'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P1621_CLIENT_ID'
,p_compute_when=>'P1621_CREDENTIALS_TYPE'
,p_compute_when_text=>'OCI'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1702074064678403)
,p_computation_sequence=>30
,p_computation_item=>'P1621_CERTIFICATE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P1621_CLIENT_ID'
,p_compute_when=>'P1621_CREDENTIALS_TYPE'
,p_compute_when_text=>'CERTIFICATE_PAIR'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3367561173004648)
,p_computation_sequence=>40
,p_computation_item=>'P1621_GENERIC_NAME'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P1621_CLIENT_ID'
,p_compute_when=>'P1621_CREDENTIALS_TYPE'
,p_compute_when_text=>'HTTP_HEADER:HTTP_QUERY_STRING'
,p_compute_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1741707179494510)
,p_computation_sequence=>50
,p_computation_item=>'P1621_PUBLIC_KEY'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P1621_CLIENT_ID'
,p_compute_when=>'P1621_CREDENTIALS_TYPE'
,p_compute_when_text=>'KEY_PAIR'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(154603538915686583)
,p_validation_name=>'Client Secret = Client Secret Verify'
,p_validation_sequence=>30
,p_validation=>'P1621_SECRET'
,p_validation2=>'&P1621_SECRET_VERIFY.'
,p_validation_type=>'ITEM_IN_VALIDATION_EQ_STRING2'
,p_error_message=>'Client Secrets or Passwords do not match.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow.g_request in (''Create'',''Update'')',
'and ( :P1621_SECRET is not null or :P1621_SECRET_VERIFY is not null)'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(154595724346686559)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3367418617004647)
,p_validation_name=>'Valid for URLs start with http(s) or ldap(s)'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_credential.assert_urls_valid (',
'        p_allowed_urls => wwv_flow_string.split (',
'                              p_str => replace(:P1621_VALID_FOR_URLS, wwv_flow.crlf, wwv_flow.lf), ',
'                              p_sep => wwv_flow.lf) );',
'end;'))
,p_validation_type=>'PLSQL_ERROR'
,p_error_message=>'All URLs in the #LABEL# list must start with http://, https://, ldap:// or ldaps://'
,p_validation_condition=>'Create:Update'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(3367384134004646)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(537042170469394614)
,p_validation_name=>'Delete only unused credentials'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_credentials c',
' where c.security_group_id = :flow_security_group_id',
'   and c.id                = :p1621_id',
'   and exists(',
'           select 1',
'             from wwv_flow_web_credential_usage cu',
'            where cu.security_group_id = :flow_security_group_id',
'              and cu.credential_id     = c.id',
'       )'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Credential is in use and cannot be deleted. Review Credential usage on the <strong>Utilization</strong> page.'
,p_when_button_pressed=>wwv_flow_imp.id(154599745454686565)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(21464631148466402)
,p_validation_name=>'Credential Name is unique'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'  from wwv_credentials',
' where security_group_id  = :FLOW_SECURITY_GROUP_ID',
'   and name               = :P1621_CREDENTIALS_NAME',
'   and ( id != :P1621_ID or :P1621_ID is null )'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Credential name must be unique within the application. This name is already being used.',
''))
,p_validation_condition=>'Create:Update'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(154593032746686556)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(21464803891466404)
,p_validation_name=>'Credential Static ID is unique'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'  from wwv_credentials',
' where security_group_id  = :FLOW_SECURITY_GROUP_ID',
'   and static_id         = regexp_replace( lower( nvl( :P1621_CREDENTIALS_STATIC_ID,:P1621_CREDENTIALS_NAME ) ), ''[^abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890]+'', ''_'' )',
'   and ( id != :P1621_ID or :P1621_ID is null )'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'The credential Static ID (provided or derived from the name) must be unique within the application.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_result number;',
'begin',
'    l_result := case when :REQUEST in (''Update'',''Create'') then null else 1 end;',
'',
'    if l_result is null then',
'        begin',
'            select 1',
'              into l_result',
'              from wwv_credentials',
'             where security_group_id = :FLOW_SECURITY_GROUP_ID',
'               and name              = :P1621_CREDENTIALS_NAME',
'               and ( id != :P1621_ID or :P1621_ID is null )',
'               and rownum            = 1;',
'        exception',
'            when NO_DATA_FOUND then null;',
'        end;',
'    end if;',
'',
'    return l_result is null;',
'end;'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'FUNCTION_BODY'
,p_associated_item=>wwv_flow_imp.id(385808740658243612)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2545788183236506)
,p_validation_name=>'DB Credential name NOT NULL'
,p_validation_sequence=>80
,p_validation=>'P1621_SCHEMA_DB_CRED_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'The name of a database credential, accessible to the workspace schema, must be provided.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    wwv_flow_db_version.c_has_utl_http_credential',
'and :REQUEST                  in ( ''Create'',''Update'')',
'and :P1621_CREDENTIALS_TYPE   in (''BASIC'',''OAUTH2_CLIENT_CREDENTIALS'')',
'and :P1621_DB_CREDENTIAL_TYPE  = ''SCHEMA''',
'and :P1621_USE_DB_CREDENTIAL   = ''Y'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(1755422406531702)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2991825621431209)
,p_validation_name=>'DB Instance Credential name NOT NULL'
,p_validation_sequence=>90
,p_validation=>'P1621_INSTANCE_DB_CRED_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'The name of a database credential, accessible to the APEX engine, must be provided.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    wwv_flow_db_version.c_has_utl_http_credential',
'and :REQUEST                  in ( ''Create'',''Update'')',
'and :P1621_CREDENTIALS_TYPE   in (''BASIC'',''OAUTH2_CLIENT_CREDENTIALS'')',
'and :P1621_DB_CREDENTIAL_TYPE  = ''INSTANCE''',
'and :P1621_USE_DB_CREDENTIAL   = ''Y'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(1759810826531746)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1758037153531728)
,p_validation_name=>'Is the Credential accessible?'
,p_validation_sequence=>100
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_schema varchar2(128);',
'begin',
'    l_schema := wwv_flow_credential.find_schema_for_db_credential( ',
'                    p_db_credential_name        => :P1621_SCHEMA_DB_CRED_NAME,',
'                    p_db_credential_is_instance => false );',
'    return true;',
'exception',
'    when others then',
'        return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Database Credential "&P1621_SCHEMA_DB_CRED_NAME." does not exist or is not accessible by this workspace.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    wwv_flow_db_version.c_has_utl_http_credential',
'and :REQUEST in ( ''Create'',''Update'')',
'and :P1621_USE_DB_CREDENTIAL                   = ''Y''',
'and :P1621_SCHEMA_DB_CRED_NAME          is not null',
'and nvl(:P1621_DB_CREDENTIAL_TYPE, ''SCHEMA'' )  = ''SCHEMA'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(1755422406531702)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1758249497531730)
,p_validation_name=>'Is the Instance Credential accessible?'
,p_validation_sequence=>110
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_schema varchar2(128);',
'begin',
'    l_schema := wwv_flow_credential.find_schema_for_db_credential( ',
'                    p_db_credential_name        => :P1621_INSTANCE_DB_CRED_NAME,',
'                    p_db_credential_is_instance => true );',
'    return true;',
'exception',
'    when others then',
'        return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Database Credential "&P1621_INSTANCE_DB_CRED_NAME." does not exist or is not accessible by the APEX engine.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    wwv_flow_db_version.c_has_utl_http_credential',
'and :REQUEST in ( ''Create'',''Update'')',
'and :P1621_USE_DB_CREDENTIAL                   = ''Y''',
'and :P1621_INSTANCE_DB_CRED_NAME        is not null',
'and nvl(:P1621_DB_CREDENTIAL_TYPE, ''SCHEMA'' )  = ''INSTANCE'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(1759810826531746)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1343355644822918)
,p_name=>'OCI Auth chosen'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1621_CREDENTIALS_TYPE'
,p_condition_element=>'P1621_CREDENTIALS_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'OCI'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1757411338531722)
,p_event_id=>wwv_flow_imp.id(1343355644822918)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(117793092137505918)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1343599206822920)
,p_event_id=>wwv_flow_imp.id(1343355644822918)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_OCI_USER_ID,P1621_OCI_PRIVATE_KEY,P1621_OCI_NAMESPACE,P1621_OCI_FINGERPRINT'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1343453914822919)
,p_event_id=>wwv_flow_imp.id(1343355644822918)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_OCI_USER_ID,P1621_OCI_PRIVATE_KEY,P1621_OCI_NAMESPACE,P1621_OCI_FINGERPRINT'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1702150779678404)
,p_name=>'Credential Pair chosen'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1621_CREDENTIALS_TYPE'
,p_condition_element=>'P1621_CREDENTIALS_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'CERTIFICATE_PAIR'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1757554028531723)
,p_event_id=>wwv_flow_imp.id(1702150779678404)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(117793092137505918)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1703048758678413)
,p_event_id=>wwv_flow_imp.id(1702150779678404)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_CERTIFICATE,P1621_CERT_PRIVATE_KEY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1702244998678405)
,p_event_id=>wwv_flow_imp.id(1702150779678404)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_CERTIFICATE,P1621_CERT_PRIVATE_KEY'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(537388104582764705)
,p_name=>'Set prompt on Install'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1621_CLIENT_ID'
,p_condition_element=>'P1621_CLIENT_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(537389104318764715)
,p_event_id=>wwv_flow_imp.id(537388104582764705)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_ALWAYS_PROMPT_ON_INSTALL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(537388337509764707)
,p_event_id=>wwv_flow_imp.id(537388104582764705)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_PROMPT_ON_INSTALL'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(537388827863764712)
,p_event_id=>wwv_flow_imp.id(537388104582764705)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_PROMPT_ON_INSTALL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(537388735583764711)
,p_event_id=>wwv_flow_imp.id(537388104582764705)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_PROMPT_ON_INSTALL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(537389086493764714)
,p_event_id=>wwv_flow_imp.id(537388104582764705)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_ALWAYS_PROMPT_ON_INSTALL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(55557938281883021)
,p_name=>'OAuth2 Auth Type chosen'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1621_CREDENTIALS_TYPE'
,p_condition_element=>'P1621_CREDENTIALS_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'OAUTH2_CLIENT_CREDENTIALS'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1703171612678414)
,p_event_id=>wwv_flow_imp.id(55557938281883021)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_SCOPE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(55558097396883022)
,p_event_id=>wwv_flow_imp.id(55557938281883021)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_SCOPE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1702627895678409)
,p_name=>'BASIC or OAuth2 Type chosen'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1621_CREDENTIALS_TYPE'
,p_condition_element=>'P1621_CREDENTIALS_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'BASIC,OAUTH2_CLIENT_CREDENTIALS'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1702997118678412)
,p_event_id=>wwv_flow_imp.id(1702627895678409)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_CLIENT_ID,P1621_SECRET,P1621_SECRET_VERIFY'
,p_client_condition_type=>'NOT_EQUALS'
,p_client_condition_element=>'P1621_USE_DB_CREDENTIAL'
,p_client_condition_expression=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1756540752531713)
,p_event_id=>wwv_flow_imp.id(1702627895678409)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_USE_DB_CREDENTIAL'
,p_server_condition_type=>'EXPRESSION'
,p_server_condition_expr1=>'wwv_flow_db_version.c_has_utl_http_credential'
,p_server_condition_expr2=>'PLSQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1756499778531712)
,p_event_id=>wwv_flow_imp.id(1702627895678409)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_USE_DB_CREDENTIAL'
,p_server_condition_type=>'EXPRESSION'
,p_server_condition_expr1=>'wwv_flow_db_version.c_has_utl_http_credential'
,p_server_condition_expr2=>'PLSQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1756627619531714)
,p_event_id=>wwv_flow_imp.id(1702627895678409)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_USE_DB_CREDENTIAL'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_server_condition_type=>'EXPRESSION'
,p_server_condition_expr1=>'wwv_flow_db_version.c_has_utl_http_credential'
,p_server_condition_expr2=>'PLSQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1703243291678415)
,p_event_id=>wwv_flow_imp.id(1702627895678409)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_CLIENT_ID,P1621_SECRET,P1621_SECRET_VERIFY'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(117791661876505904)
,p_name=>'Confirm Delete Tokens'
,p_event_sequence=>60
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(117791341683505901)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(117791743717505905)
,p_event_id=>wwv_flow_imp.id(117791661876505904)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'All stored tokens assigned to this credential will be cleared and will have to be re-obtained from the authentication servers. Do you want to proceed?'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(117791863403505906)
,p_event_id=>wwv_flow_imp.id(117791661876505904)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'CLEAR_TOKENS'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3367077227004643)
,p_name=>'Generic Type chosen '
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1621_CREDENTIALS_TYPE'
,p_condition_element=>'P1621_CREDENTIALS_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'HTTP_HEADER,HTTP_QUERY_STRING'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3367136779004644)
,p_event_id=>wwv_flow_imp.id(3367077227004643)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_GENERIC_NAME,P1621_GENERIC_VALUE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3367261517004645)
,p_event_id=>wwv_flow_imp.id(3367077227004643)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_GENERIC_NAME,P1621_GENERIC_VALUE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1757679087531724)
,p_event_id=>wwv_flow_imp.id(3367077227004643)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(117793092137505918)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1801985239350509)
,p_name=>'Key Pair type chosen'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1621_CREDENTIALS_TYPE'
,p_condition_element=>'P1621_CREDENTIALS_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'KEY_PAIR'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1802004326350510)
,p_event_id=>wwv_flow_imp.id(1801985239350509)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_PUBLIC_KEY,P1621_PRIVATE_KEY,P1621_PRIVATE_KEY_VERIFY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1802357061352612)
,p_event_id=>wwv_flow_imp.id(1801985239350509)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show P1621_ALWAYS_PROMPT_ON_INSTALL'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_ALWAYS_PROMPT_ON_INSTALL'
,p_client_condition_type=>'NOT_NULL'
,p_client_condition_element=>'P1621_CLIENT_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1757758256531725)
,p_event_id=>wwv_flow_imp.id(1801985239350509)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(117793092137505918)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1802472831352613)
,p_event_id=>wwv_flow_imp.id(1801985239350509)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Show P1621_PROMPT_ON_INSTALL'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_PROMPT_ON_INSTALL'
,p_client_condition_type=>'NULL'
,p_client_condition_element=>'P1621_CLIENT_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1741691913494509)
,p_event_id=>wwv_flow_imp.id(1801985239350509)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Show P1621_VALID_FOR_URLS'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_VALID_FOR_URLS'
,p_client_condition_type=>'NOT_EQUALS'
,p_client_condition_element=>'P1621_USE_DB_CREDENTIAL'
,p_client_condition_expression=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2809505144194310)
,p_event_id=>wwv_flow_imp.id(1801985239350509)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_PROMPT_ON_INSTALL'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1802139328350511)
,p_event_id=>wwv_flow_imp.id(1801985239350509)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_PUBLIC_KEY,P1621_PRIVATE_KEY,P1621_PRIVATE_KEY_VERIFY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1830566288729801)
,p_event_id=>wwv_flow_imp.id(1801985239350509)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_VALID_FOR_URLS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1741536592494508)
,p_event_id=>wwv_flow_imp.id(1801985239350509)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_VALID_FOR_URLS'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1802215856352611)
,p_event_id=>wwv_flow_imp.id(1801985239350509)
,p_event_result=>'TRUE'
,p_action_sequence=>70
,p_execute_on_page_init=>'Y'
,p_name=>'Hide P1621_PROMPT_ON_INSTALL,P1621_ALWAYS_PROMPT_ON_INSTALL'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_PROMPT_ON_INSTALL,P1621_ALWAYS_PROMPT_ON_INSTALL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2545336277236502)
,p_name=>'Use DB Credential'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1621_USE_DB_CREDENTIAL'
,p_condition_element=>'P1621_USE_DB_CREDENTIAL'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1759674921531744)
,p_event_id=>wwv_flow_imp.id(2545336277236502)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1759448228531742)
,p_client_condition_type=>'IN_LIST'
,p_client_condition_element=>'P1621_CREDENTIALS_TYPE'
,p_client_condition_expression=>'BASIC,OAUTH2_CLIENT_CREDENTIALS'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2545455672236503)
,p_event_id=>wwv_flow_imp.id(2545336277236502)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1755362132531701)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1755995473531707)
,p_event_id=>wwv_flow_imp.id(2545336277236502)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_SECRET,P1621_SECRET_VERIFY,P1621_CLIENT_ID,P1621_VALID_FOR_URLS'
,p_client_condition_type=>'IN_LIST'
,p_client_condition_element=>'P1621_CREDENTIALS_TYPE'
,p_client_condition_expression=>'BASIC,OAUTH2_CLIENT_CREDENTIALS'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1757375228531721)
,p_event_id=>wwv_flow_imp.id(2545336277236502)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_OCI_USER_ID,P1621_OCI_PRIVATE_KEY,P1621_OCI_NAMESPACE,P1621_OCI_FINGERPRINT,P1621_VALID_FOR_URLS'
,p_client_condition_type=>'EQUALS'
,p_client_condition_element=>'P1621_CREDENTIALS_TYPE'
,p_client_condition_expression=>'OCI'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1759593067531743)
,p_event_id=>wwv_flow_imp.id(2545336277236502)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1759448228531742)
,p_client_condition_type=>'IN_LIST'
,p_client_condition_element=>'P1621_CREDENTIALS_TYPE'
,p_client_condition_expression=>'BASIC,OAUTH2_CLIENT_CREDENTIALS'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2545535075236504)
,p_event_id=>wwv_flow_imp.id(2545336277236502)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1755362132531701)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1757026202531718)
,p_event_id=>wwv_flow_imp.id(2545336277236502)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_SECRET,P1621_SECRET_VERIFY,P1621_CLIENT_ID,P1621_VALID_FOR_URLS'
,p_client_condition_type=>'IN_LIST'
,p_client_condition_element=>'P1621_CREDENTIALS_TYPE'
,p_client_condition_expression=>'BASIC,OAUTH2_CLIENT_CREDENTIALS'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1757299645531720)
,p_event_id=>wwv_flow_imp.id(2545336277236502)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_SECRET,P1621_SECRET_VERIFY,P1621_CLIENT_ID,P1621_VALID_FOR_URLS'
,p_client_condition_type=>'IN_LIST'
,p_client_condition_element=>'P1621_CREDENTIALS_TYPE'
,p_client_condition_expression=>'BASIC,OAUTH2_CLIENT_CREDENTIALS'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1756972651531717)
,p_event_id=>wwv_flow_imp.id(2545336277236502)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_OCI_USER_ID,P1621_OCI_PRIVATE_KEY,P1621_OCI_NAMESPACE,P1621_OCI_FINGERPRINT,P1621_VALID_FOR_URLS'
,p_client_condition_type=>'EQUALS'
,p_client_condition_element=>'P1621_CREDENTIALS_TYPE'
,p_client_condition_expression=>'OCI'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2545671134236505)
,p_event_id=>wwv_flow_imp.id(2545336277236502)
,p_event_result=>'FALSE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_SCHEMA_DB_CRED_NAME,,P1621_INSTANCE_DB_CRED_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1757130298531719)
,p_event_id=>wwv_flow_imp.id(2545336277236502)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_OCI_USER_ID,P1621_OCI_PRIVATE_KEY,P1621_OCI_NAMESPACE,P1621_OCI_FINGERPRINT,P1621_VALID_FOR_URLS'
,p_client_condition_type=>'EQUALS'
,p_client_condition_element=>'P1621_CREDENTIALS_TYPE'
,p_client_condition_expression=>'OCI'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2992373425431214)
,p_event_id=>wwv_flow_imp.id(2545336277236502)
,p_event_result=>'FALSE'
,p_action_sequence=>60
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_DB_CREDENTIAL_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'SCHEMA'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1759943328531747)
,p_name=>'Schema Level Credential'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1621_DB_CREDENTIAL_TYPE'
,p_condition_element=>'P1621_DB_CREDENTIAL_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SCHEMA'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>'wwv_flow_platform.get_preference( ''INSTANCE_DBMS_CREDENTIAL_ENABLED'' ) = ''Y'''
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1760033143531748)
,p_event_id=>wwv_flow_imp.id(1759943328531747)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_SCHEMA_DB_CRED_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1760141074531749)
,p_event_id=>wwv_flow_imp.id(1759943328531747)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_INSTANCE_DB_CRED_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1760232682531750)
,p_event_id=>wwv_flow_imp.id(1759943328531747)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_INSTANCE_DB_CRED_NAME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2991038066431201)
,p_name=>'Instance Level Credential'
,p_event_sequence=>120
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1621_DB_CREDENTIAL_TYPE'
,p_condition_element=>'P1621_DB_CREDENTIAL_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'INSTANCE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>'wwv_flow_platform.get_preference( ''INSTANCE_DBMS_CREDENTIAL_ENABLED'' ) = ''Y'''
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2991184850431202)
,p_event_id=>wwv_flow_imp.id(2991038066431201)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_INSTANCE_DB_CRED_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2991267282431203)
,p_event_id=>wwv_flow_imp.id(2991038066431201)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_SCHEMA_DB_CRED_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2991354117431204)
,p_event_id=>wwv_flow_imp.id(2991038066431201)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_SCHEMA_DB_CRED_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2991798387431208)
,p_event_id=>wwv_flow_imp.id(2991038066431201)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_name=>'Get First Instance Credential Name'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1621_INSTANCE_DB_CRED_NAME'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select credential_name',
'  from sys.all_credentials ',
' where rownum = 1'))
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(154604211844686583)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_CREDENTIALS_DEV'
,p_attribute_02=>'WWV_CREDENTIALS_DEV'
,p_attribute_03=>'P1621_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id = :FLOW_SECURITY_GROUP_ID'
,p_process_error_message=>'Error fetching row.'
,p_internal_uid=>154604211844686583
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1758194942531729)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Adjust DB Credential Items on Save'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1621_DB_CRED_IS_INSTANCE :=',
'     case',
'          when :P1621_USE_DB_CREDENTIAL = ''Y''',
'          then case ',
'                    when wwv_flow_platform.get_preference( ''INSTANCE_DBMS_CREDENTIAL_ENABLED'' ) = ''Y''',
'                    then case when :P1621_DB_CREDENTIAL_TYPE = ''INSTANCE'' then ''Y'' else ''N'' end',
'                    else ''N''',
'               end',
'     end;',
'',
'',
':P1621_DB_CREDENTIAL_NAME := ',
'     case',
'          when :P1621_USE_DB_CREDENTIAL = ''Y''',
'          then case when :P1621_DB_CREDENTIAL_TYPE = ''INSTANCE'' ',
'                    then :P1621_INSTANCE_DB_CRED_NAME',
'                    else :P1621_SCHEMA_DB_CRED_NAME',
'               end',
'     end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'wwv_flow_db_version.c_has_utl_http_credential'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>1758194942531729
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(154604617634686587)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_CREDENTIALS_DEV'
,p_attribute_02=>'WWV_CREDENTIALS_DEV'
,p_attribute_03=>'P1621_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id = :FLOW_SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_process_error_message=>'Error processing action.'
,p_process_success_message=>'Action processed.'
,p_internal_uid=>154604617634686587
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(117791908045505907)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Clear Tokens'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_credential.delete_tokens( p_credential_id => :P1621_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(117791341683505901)
,p_process_success_message=>'All access, refresh and ID tokens for credential "&P1621_CREDENTIALS_NAME." cleared.'
,p_internal_uid=>117791908045505907
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(117793132334505919)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Clear Tokens on Update'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_credential.delete_tokens( p_credential_id => :P1621_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(154600176572686567)
,p_process_when=>'P1621_SECRET'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>117793132334505919
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2992187177431212)
,p_process_sequence=>10
,p_process_point=>'BEFORE_BOX_BODY'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Adjust DB Credential Items on Load'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    :P1621_USE_DB_CREDENTIAL := case when :P1621_DB_CREDENTIAL_NAME is not null then ''Y'' else ''N'' end;',
'',
'    if :P1621_DB_CRED_IS_INSTANCE = ''Y'' then',
'        :P1621_INSTANCE_DB_CRED_NAME := :P1621_DB_CREDENTIAL_NAME;',
'        :P1621_SCHEMA_DB_CRED_NAME   := null;',
'    else ',
'        :P1621_INSTANCE_DB_CRED_NAME := null;',
'        :P1621_SCHEMA_DB_CRED_NAME   := :P1621_DB_CREDENTIAL_NAME;',
'    end if;',
'',
'    :P1621_DB_CREDENTIAL_TYPE := case :P1621_DB_CRED_IS_INSTANCE ',
'                                     when ''Y'' then ''INSTANCE''',
'                                     when ''N'' then ''SCHEMA''',
'                                 end;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'wwv_flow_db_version.c_has_utl_http_credential'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>2992187177431212
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1703466871678417)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Populate Client ID / Client Secret when not displayed'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case :P1621_CREDENTIALS_TYPE',
'when ''OCI'' then',
'    :P1621_CLIENT_ID := nvl(:P1621_OCI_USER_ID     ,:P1621_CLIENT_ID);',
'    :P1621_SECRET    := nvl(:P1621_OCI_PRIVATE_KEY ,:P1621_SECRET);',
'when ''CERTIFICATE_PAIR'' then',
'    :P1621_CLIENT_ID := nvl(:P1621_CERTIFICATE     ,:P1621_CLIENT_ID);',
'    :P1621_SECRET    := nvl(:P1621_CERT_PRIVATE_KEY,:P1621_SECRET);',
'when ''HTTP_HEADER'' then',
'    :P1621_CLIENT_ID := nvl(:P1621_GENERIC_NAME,    :P1621_CLIENT_ID);',
'    :P1621_SECRET    := nvl(:P1621_GENERIC_VALUE,   :P1621_SECRET);',
'when ''HTTP_QUERY_STRING'' then',
'    :P1621_CLIENT_ID := nvl(:P1621_GENERIC_NAME,    :P1621_CLIENT_ID);',
'    :P1621_SECRET    := nvl(:P1621_GENERIC_VALUE,   :P1621_SECRET);',
'when ''KEY_PAIR'' then',
'    :P1621_CLIENT_ID     := nvl(:P1621_PUBLIC_KEY,         :P1621_CLIENT_ID);',
'    :P1621_SECRET        := nvl(:P1621_PRIVATE_KEY,        :P1621_SECRET);',
'end case;',
'',
'case :P1621_CREDENTIALS_TYPE',
'when ''KEY_PAIR'' then',
'    :P1621_SECRET_VERIFY := :P1621_PRIVATE_KEY_VERIFY;',
'else',
'    :P1621_SECRET_VERIFY := :P1621_SECRET;',
'end case;',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P1621_CREDENTIALS_TYPE'
,p_process_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_process_when2=>'OCI:CERTIFICATE_PAIR:HTTP_HEADER:HTTP_QUERY_STRING:KEY_PAIR'
,p_internal_uid=>1703466871678417
);
end;
/
prompt --application/pages/page_01622
begin
wwv_flow_imp_page.create_page(
 p_id=>1622
,p_name=>'Credential Utilization'
,p_alias=>'CREDENTIAL-UTILIZATION'
,p_step_title=>'Credential Utilization'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(158563552508587748)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(105844114589396301)
,p_plug_name=>'Credential Utilization'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>170
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select credential_name,',
'       wwv_flow_lang.system_message(component_type) as component_type,',
'       flow_id as application_id,',
'       coalesce(component_name, wwv_flow_lang.system_message(component_type)) as component_name,',
'       target_page,',
'       id_item,',
'       component_id',
'  from wwv_flow_web_credential_usage',
' where security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(105844297785396302)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'No used credentials found in this workspace.'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_pivot=>'N'
,p_show_notify=>'Y'
,p_show_flashback=>'N'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'OTTMAR'
,p_internal_uid=>105844297785396302
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(105844905049396309)
,p_db_column_name=>'CREDENTIAL_NAME'
,p_display_order=>30
,p_column_identifier=>'A'
,p_column_label=>'Credential'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(105845134411396311)
,p_db_column_name=>'COMPONENT_TYPE'
,p_display_order=>40
,p_column_identifier=>'B'
,p_column_label=>'Component Type'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(105845875483396318)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>50
,p_column_identifier=>'I'
,p_column_label=>'Application ID'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(105845393028396313)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>60
,p_column_identifier=>'D'
,p_column_label=>'Component Name'
,p_column_link=>'f?p=&APP_ID.:#TARGET_PAGE#:&SESSION.::&DEBUG.:#TARGET_PAGE#:FB_FLOW_ID,#ID_ITEM#:#APPLICATION_ID#,#COMPONENT_ID#'
,p_column_linktext=>'#COMPONENT_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(105845405133396314)
,p_db_column_name=>'TARGET_PAGE'
,p_display_order=>70
,p_column_identifier=>'E'
,p_column_label=>'Target Page'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(105845593169396315)
,p_db_column_name=>'ID_ITEM'
,p_display_order=>80
,p_column_identifier=>'F'
,p_column_label=>'Id Item'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(105845789891396317)
,p_db_column_name=>'COMPONENT_ID'
,p_display_order=>90
,p_column_identifier=>'H'
,p_column_label=>'Component Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(105860150414862030)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1058602'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'CREDENTIAL_NAME:COMPONENT_TYPE:APPLICATION_ID:COMPONENT_NAME:'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(202606216123391382)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>95
,p_list_id=>wwv_flow_imp.id(154583731613661573)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(533156043524172848)
,p_plug_name=>'Unused Credentials'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>180
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c.name as credential_name',
'  from wwv_credentials c',
' where c.security_group_id = :flow_security_group_id',
'   and not exists(',
'           select 1',
'             from wwv_flow_web_credential_usage cu',
'            where cu.security_group_id = :flow_security_group_id',
'              and cu.credential_id     = c.id',
'       )'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c.name as credential_name',
'  from wwv_credentials c',
' where c.security_group_id = :flow_security_group_id',
'   and not exists(',
'           select 1',
'             from wwv_flow_web_credential_usage cu',
'            where cu.security_group_id = :flow_security_group_id',
'              and cu.credential_id     = c.id',
'       )'))
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(533156144563172849)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'This credential store is not used within the application.'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'CARSTEN'
,p_internal_uid=>533156144563172849
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(537041300458394606)
,p_db_column_name=>'CREDENTIAL_NAME'
,p_display_order=>70
,p_column_identifier=>'A'
,p_column_label=>'Credential'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(537047886332414501)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'5370479'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'CREDENTIAL_NAME'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3052578742581938937)
,p_plug_name=>'Utilization'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Review where Credentials are used.</p>',
'<p>Credentials are stored at the workspace level and therefore are visible in all applications.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(537041508664394608)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(533156043524172848)
,p_button_name=>'DELETE_UNUSED'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete Unused'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(154696027791795849)
,p_branch_name=>'Go To Page 1622'
,p_branch_action=>'f?p=&APP_ID.:1622:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(537041677042394609)
,p_name=>'Click'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(537041508664394608)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(537041724290394610)
,p_event_id=>wwv_flow_imp.id(537041677042394609)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'Do you really want to delete all unused Credentials in your workspace?'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(537041826589394611)
,p_event_id=>wwv_flow_imp.id(537041677042394609)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'DELETE_UNUSED'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(537041973698394612)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Unused'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete wwv_credentials c',
' where c.security_group_id = :flow_security_group_id',
'   and not exists(',
'           select 1',
'             from wwv_flow_web_credential_usage cu',
'            where cu.security_group_id = :flow_security_group_id',
'              and cu.credential_id = c.id',
'       );',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(537041508664394608)
,p_process_success_message=>'Unused credentials deleted.'
,p_internal_uid=>537041973698394612
);
end;
/
prompt --application/pages/page_01623
begin
wwv_flow_imp_page.create_page(
 p_id=>1623
,p_name=>'Credentials History'
,p_alias=>'CREDENTIALS-HISTORY'
,p_step_title=>'Credentials History'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(158563552508587748)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(501253027122110949)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(154583731613661573)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(501253236589110949)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>This page displays recent modifications made to Credentials in this workspace.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(501253822499110951)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_CREDENTIALS'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(501254046333110952)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>501254046333110952
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(154632334332761933)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(154632772618761935)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Audit Comment'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(154633199059761936)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Component Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(154633526324761936)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(154633932118761936)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Component Key'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(154634312885761937)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Audit Date'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(154634716401761937)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(501255236844110964)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1546351'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'AUDIT_DATE:ACTION:DEVELOPER:COMPONENT_NAME'
,p_sort_column_1=>'AUDIT_DATE'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(154635508943761948)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(501253822499110951)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1623:&SESSION.::&DEBUG.:1623,RIR::'
);
end;
/
prompt --application/pages/page_01624
begin
wwv_flow_imp_page.create_page(
 p_id=>1624
,p_name=>'TEMP PAGE FOR APEX-4577'
,p_alias=>'TEMP-PAGE-FOR-APEX-4577'
,p_page_mode=>'MODAL'
,p_step_title=>'TEMP PAGE FOR APEX-4577'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'11'
);
end;
/
prompt --application/pages/page_01700
begin
wwv_flow_imp_page.create_page(
 p_id=>1700
,p_name=>'Create Legacy Data Loading'
,p_alias=>'CREATE-LEGACY-DATA-LOADING'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Legacy Data Loading'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(423953526918849791)
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$("#P1700_LABEL_CASE_SENS_CONTAINER .a-Form-labelContainer").css("display", "none");',
'',
'$("#F4000_P1700_UK_CASE_1_CONTAINER .a-Form-labelContainer").css("display", "none");',
'$("#F4000_P1700_UK_CASE_2_CONTAINER .a-Form-labelContainer").css("display", "none");',
'$("#F4000_P1700_UK_CASE_3_CONTAINER .a-Form-labelContainer").css("display", "none");'))
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17007612242242623)
,p_plug_name=>'Progress'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>11
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(16993520375207189)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17009804108278139)
,p_plug_name=>'Create Legacy Data Loading'
,p_region_template_options=>'#DEFAULT#:a-Form--fixedLabels'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<p>Data Loading pages reference a legacy data load definition.  To create a new legacy data load definition, specify a name and select a schema owner, target table, and up to three columns that uniquely identify a row.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44731705373834941)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>31
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(17011221424283170)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(44731705373834941)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(17011413590290370)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(44731705373834941)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(279439302524313294)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(44731705373834941)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:2500:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(305343028968743639)
,p_branch_action=>'f?p=&APP_ID.:1700:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(17011413590290370)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1700_EXISTS'
,p_branch_condition_text=>'TRUE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(305377426675752473)
,p_branch_action=>'f?p=&APP_ID.:1702:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(17011413590290370)
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(582265480613682825)
,p_branch_name=>'Go To Page 1704 (existing Load selected)'
,p_branch_action=>'f?p=&APP_ID.:1704:&SESSION.::&DEBUG.:RP:F4000_P1700_NAME,P1700_EXISTS:&P1700_EXISTING_DATALOAD.,yes&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(17011413590290370)
,p_branch_sequence=>60
,p_branch_condition_type=>'ITEM_IS_NOT_NULL'
,p_branch_condition=>'P1700_EXISTING_DATALOAD'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17078810027219284)
,p_name=>'F4000_P1700_OWNER'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(17009804108278139)
,p_item_default=>'wwv_flow_security.flow_owner( p_flow_id => :FB_FLOW_ID, p_security_group_id => :WORKSPACE_ID )'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Owner'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_SCHEMAS_HAVE_PRIVS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(owner) d, owner v',
'  from wwv_flow_object_owners_dev',
'order by d                   '))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the owner of the table on which the form will be based.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17079222588279743)
,p_name=>'F4000_P1700_TABLE_NAME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(17009804108278139)
,p_prompt=>'Table Name'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = :F4000_P1700_OWNER'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table -'
,p_lov_cascade_parent_items=>'F4000_P1700_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select the table to be used for data loading.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17079422157298547)
,p_name=>'F4000_P1700_UK_1'
,p_is_required=>true
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(17009804108278139)
,p_prompt=>'Column 1'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1700_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :F4000_P1700_OWNER',
'   and table_name = :F4000_P1700_TABLE_NAME',
'   and data_type <> ''BLOB'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'F4000_P1700_TABLE_NAME'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_tag_attributes=>'aria-labelledby="P1700_LABEL_UNIQUE_COLUMN_LABEL F4000_P1700_UK_1_LABEL"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17079603934302695)
,p_name=>'F4000_P1700_UK_2'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(17009804108278139)
,p_prompt=>'Column 2'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1700_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :F4000_P1700_OWNER',
'   and table_name = :F4000_P1700_TABLE_NAME',
'   and data_type <> ''BLOB'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'F4000_P1700_TABLE_NAME'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_tag_attributes=>'aria-labelledby="P1700_LABEL_UNIQUE_COLUMN_LABEL F4000_P1700_UK_2_LABEL"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17079819171307130)
,p_name=>'F4000_P1700_UK_3'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(17009804108278139)
,p_prompt=>'Column 3'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1700_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :F4000_P1700_OWNER',
'   and table_name = :F4000_P1700_TABLE_NAME',
'   and data_type <> ''BLOB'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'F4000_P1700_TABLE_NAME'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_tag_attributes=>'aria-labelledby="P1700_LABEL_UNIQUE_COLUMN_LABEL F4000_P1700_UK_3_LABEL"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17080011684314403)
,p_name=>'F4000_P1700_UK_CASE_1'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(17009804108278139)
,p_item_default=>'N'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DATA LOAD CASE SENSITIVITY OPTION'
,p_lov=>'.'||wwv_flow_imp.id(15543021487067885)||'.'
,p_cHeight=>1
,p_tag_attributes=>'aria-labelledby="P1700_LABEL_CASE_SENS_LABEL F4000_P1700_UK_1_LABEL"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17080218048325659)
,p_name=>'F4000_P1700_UK_CASE_2'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(17009804108278139)
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DATA LOAD CASE SENSITIVITY OPTION'
,p_lov=>'.'||wwv_flow_imp.id(15543021487067885)||'.'
,p_cHeight=>1
,p_tag_attributes=>'aria-labelledby="P1700_LABEL_CASE_SENS_LABEL F4000_P1700_UK_2_LABEL"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17080408136332286)
,p_name=>'F4000_P1700_UK_CASE_3'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(17009804108278139)
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DATA LOAD CASE SENSITIVITY OPTION'
,p_lov=>'.'||wwv_flow_imp.id(15543021487067885)||'.'
,p_cHeight=>1
,p_tag_attributes=>'aria-labelledby="P1700_LABEL_CASE_SENS_LABEL F4000_P1700_UK_3_LABEL"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(146989019358502142)
,p_name=>'P1700_EXISTS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(17009804108278139)
,p_item_default=>'no'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(391306559759598024)
,p_name=>'P1700_LABEL_UNIQUE_COLUMN'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(17009804108278139)
,p_prompt=>'Unique Column'
,p_source=>'wwv_flow_lang.system_message(''DATA_LOAD.LABEL_UNIQUE_COLUMN'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identify the column name(s) to be used as the primary unique key column during the data load process. You can define up to 3 unique key columns.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(582265015802682821)
,p_name=>'P1700_EXISTING_DATALOAD'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(17009804108278139)
,p_prompt=>'Legacy Data Load'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    name || '' ('' || wwv_flow_lang.system_message(''WIZARD.FORM.TABLE'') || '' '' || wwv_flow_data_upload.get_owner_name(owner, :FB_FLOW_ID) || ''.'' || table_name || '')'' d, ',
'    name r',
'from wwv_flow_load_tables',
'where flow_id = :FB_FLOW_ID',
'and data_profile_id is null'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Create New'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose whether to create a new or to re-use an existing Legacy Data Load definition.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(616343314202812231)
,p_name=>'F4000_P1700_NAME'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(17009804108278139)
,p_prompt=>'Definition Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a name for the data load definition.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4227543636818913710)
,p_name=>'P1700_LABEL_CASE_SENS'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(17009804108278139)
,p_prompt=>'Case Sensitive'
,p_source=>'wwv_flow_lang.system_message(''DATA_LOAD.LABEL_CASE_SENSITIVE'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_begin_on_new_line=>'N'
,p_grid_column=>7
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identify whether the selected unique key column is case sensitive.  By default, this is set to <strong>No</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(510176221330777162)
,p_validation_name=>'F4000_P1700_UK_1 Must Be Different to UK2 or UK3'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :F4000_P1700_UK_1 <> :F4000_P1700_UK_2 then',
'   return true;',
'else',
'   return false;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'You must select a unique column for #LABEL#.'
,p_validation_condition=>':F4000_P1700_UK_1 is not null and :F4000_P1700_UK_2 is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(17011413590290370)
,p_associated_item=>wwv_flow_imp.id(17079603934302695)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(510405116660813658)
,p_validation_name=>'F4000_P1700_UK_2 Must Be Different to UK3'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :F4000_P1700_UK_2 <> :F4000_P1700_UK_3 then',
'   return true;',
'else',
'   return false;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'You must select a unique column for #LABEL#.'
,p_validation_condition=>':F4000_P1700_UK_2 is not null and :F4000_P1700_UK_3 is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(17011413590290370)
,p_associated_item=>wwv_flow_imp.id(17079819171307130)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(510547117961833003)
,p_validation_name=>'F4000_P1700_UK_2 Must be Selected'
,p_validation_sequence=>60
,p_validation=>'F4000_P1700_UK_2'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be selected.'
,p_validation_condition=>':F4000_P1700_UK_3 is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(17011413590290370)
,p_associated_item=>wwv_flow_imp.id(17079603934302695)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(900569203178913546)
,p_validation_name=>'F4000_P1700_NAME must be unique within application'
,p_validation_sequence=>70
,p_validation=>'select name from wwv_flow_load_tables where upper(name) = upper(:F4000_P1700_NAME) and flow_id = :fb_flow_id'
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#LABEL# already exists.'
,p_when_button_pressed=>wwv_flow_imp.id(17011413590290370)
,p_associated_item=>wwv_flow_imp.id(616343314202812231)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(549005050996212189)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(17011221424283170)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(549005377580212189)
,p_event_id=>wwv_flow_imp.id(549005050996212189)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(557592255654827101)
,p_name=>'Show/Hide UK_3'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P1700_UK_2'
,p_condition_element=>'F4000_P1700_UK_2'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(557592373362827102)
,p_event_id=>wwv_flow_imp.id(557592255654827101)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1700_UK_3,F4000_P1700_UK_CASE_3'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(557592405077827103)
,p_event_id=>wwv_flow_imp.id(557592255654827101)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1700_UK_3,F4000_P1700_UK_CASE_3'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(557592596684827104)
,p_name=>'Enable / Disable UK_2'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P1700_UK_1'
,p_condition_element=>'F4000_P1700_UK_1'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(557592608096827105)
,p_event_id=>wwv_flow_imp.id(557592596684827104)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1700_UK_2,F4000_P1700_UK_CASE_2'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(557592829119827107)
,p_event_id=>wwv_flow_imp.id(557592596684827104)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1700_UK_2,F4000_P1700_UK_3'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(557592762226827106)
,p_event_id=>wwv_flow_imp.id(557592596684827104)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1700_UK_2,F4000_P1700_UK_CASE_2'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(557592900486827108)
,p_name=>'Enable / Disable UK_1'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P1700_TABLE_NAME'
,p_condition_element=>'F4000_P1700_TABLE_NAME'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(557593082587827109)
,p_event_id=>wwv_flow_imp.id(557592900486827108)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1700_UK_1,F4000_P1700_UK_CASE_1'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(557593135430827110)
,p_event_id=>wwv_flow_imp.id(557592900486827108)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1700_UK_1,F4000_P1700_UK_CASE_1'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(582265159844682822)
,p_name=>'Show / Hide Create Data Load Definition'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1700_EXISTING_DATALOAD'
,p_condition_element=>'P1700_EXISTING_DATALOAD'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(582265235500682823)
,p_event_id=>wwv_flow_imp.id(582265159844682822)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1700_NAME,F4000_P1700_OWNER,F4000_P1700_TABLE_NAME,F4000_P1700_UK_1,F4000_P1700_UK_CASE_1,F4000_P1700_UK_2,F4000_P1700_UK_CASE_2'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(582265387176682824)
,p_event_id=>wwv_flow_imp.id(582265159844682822)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1700_NAME,F4000_P1700_OWNER,F4000_P1700_TABLE_NAME,F4000_P1700_UK_1,F4000_P1700_UK_CASE_1,F4000_P1700_UK_2,F4000_P1700_UK_CASE_2,F4000_P1700_UK_3,F4000_P1700_UK_CASE_3'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(582265633365682827)
,p_event_id=>wwv_flow_imp.id(582265159844682822)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1700_OWNER,F4000_P1700_TABLE_NAME,F4000_P1700_UK_1,F4000_P1700_UK_CASE_1,F4000_P1700_UK_CASE_2,F4000_P1700_UK_3,F4000_P1700_UK_CASE_3'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(17083127080555411)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create load_tables collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.create_or_truncate_collection(''DATA_LOAD_TABLES'');',
'wwv_flow_collection.create_or_truncate_collection(''DATA_LOAD_TABLE_LOOKUPS'');',
'wwv_flow_collection.create_or_truncate_collection(''DATA_LOAD_TABLE_RULES'');',
'wwv_flow_collection.add_member(',
'      p_collection_name => ''DATA_LOAD_TABLES'',',
'      p_c001            => :F4000_P1700_OWNER,',
'      p_c002            => :F4000_P1700_TABLE_NAME,',
'      p_c003            => :F4000_P1700_UK_1,',
'      p_c004            => :F4000_P1700_UK_CASE_1,',
'      p_c005            => :F4000_P1700_UK_2,',
'      p_c006            => :F4000_P1700_UK_CASE_2,',
'      p_c007            => :F4000_P1700_UK_3,',
'      p_c008            => :F4000_P1700_UK_CASE_3);'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(17011413590290370)
,p_internal_uid=>17083127080555411
);
end;
/
prompt --application/pages/page_01701
begin
wwv_flow_imp_page.create_page(
 p_id=>1701
,p_name=>'Create Legacy Data Loading'
,p_alias=>'CREATE-LEGACY-DATA-LOADING1'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Legacy Data Loading'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(423953526918849791)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17012831513314497)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>11
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(16993520375207189)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17083325742583369)
,p_plug_name=>'Add New Table Lookup'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>31
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(18834028855263521)
,p_name=>'Create Legacy Data Loading'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>11
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select seq_id sequence, ',
'       c003 as "COLUMN",',
'       c004 as "TABLE_OWNER",',
'       c005 as "TABLE_LOOKUP", ',
'       c006 as "COLUMN_KEY", ',
'       c007 as "COLUMN_DIS",',
'       c008 as "ALT_COLUMN_DIS_1", ',
'       c009 as "ALT_COLUMN_DIS_2",',
'       ''<a href="''||htmldb_util.prepare_url(''f?p=&APP_ID.:1701:''||:app_session||',
'       '':DELETE:::P1701_DELETE_LOOKUP:''||seq_id)||''" class="a-Icon icon-remove"></a>'' remove_lookup',
'from wwv_flow_collections where collection_name = ''DATA_LOAD_TABLE_LOOKUPS''',
'order by seq_id'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Table Lookups allow you to match an uploaded value against another table and use the associated key value, instead of the uploaded value.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(145205131395174371)
,p_query_column_id=>1
,p_column_alias=>'SEQUENCE'
,p_column_display_sequence=>8
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18834525068263534)
,p_query_column_id=>2
,p_column_alias=>'COLUMN'
,p_column_display_sequence=>1
,p_column_heading=>'Lookup Column'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(618636017823399891)
,p_query_column_id=>3
,p_column_alias=>'TABLE_OWNER'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18834601325263534)
,p_query_column_id=>4
,p_column_alias=>'TABLE_LOOKUP'
,p_column_display_sequence=>3
,p_column_heading=>'Lookup Table'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'#TABLE_OWNER#.#TABLE_LOOKUP#'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18834719651263534)
,p_query_column_id=>5
,p_column_alias=>'COLUMN_KEY'
,p_column_display_sequence=>4
,p_column_heading=>'Return Column'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18834807885263534)
,p_query_column_id=>6
,p_column_alias=>'COLUMN_DIS'
,p_column_display_sequence=>5
,p_column_heading=>'Upload Column'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(46095213859693533)
,p_query_column_id=>7
,p_column_alias=>'ALT_COLUMN_DIS_1'
,p_column_display_sequence=>6
,p_column_heading=>'Upload Column 2'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(46095330768693535)
,p_query_column_id=>8
,p_column_alias=>'ALT_COLUMN_DIS_2'
,p_column_display_sequence=>7
,p_column_heading=>'Upload Column 3'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(137127718049356842)
,p_query_column_id=>9
,p_column_alias=>'REMOVE_LOOKUP'
,p_column_display_sequence=>9
,p_column_heading=>'Delete'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44736412832950645)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>51
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(716353221929823639)
,p_plug_name=>'Lookup Definition'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>41
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(618312317852276909)
,p_plug_name=>'Alternative Keys'
,p_parent_plug_id=>wwv_flow_imp.id(716353221929823639)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(399849897040726767)
,p_plug_display_sequence=>41
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NEVER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(17013801647324744)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(44736412832950645)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(17083505094586916)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(44736412832950645)
,p_button_name=>'ADD'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Lookup'
,p_button_position=>'CREATE'
,p_button_execute_validations=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(17014223810331135)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(44736412832950645)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(17014016884329187)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(44736412832950645)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(17014506626335664)
,p_branch_action=>'f?p=&APP_ID.:1704:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(17014223810331135)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(549008680008317431)
,p_branch_action=>'f?p=&APP_ID.:1702:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(17014016884329187)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9081704488448881)
,p_name=>'F4000_P1701_ALT_KEY_COL_2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(716353221929823639)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9081914185451609)
,p_name=>'F4000_P1701_ALT_DIS_COL_2'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(716353221929823639)
,p_prompt=>'Upload Column 3'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :F4000_P1701_LOOKUP_OWNER',
'   and table_name = :F4000_P1701_LOOKUP_TABLE',
'   and data_type <> ''BLOB'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'F4000_P1701_LOOKUP_TABLE'
,p_ajax_items_to_submit=>'F4000_P1701_LOOKUP_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select the name of the third column to be uploaded to uniquely identify the return column if necessary.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17083929120603307)
,p_name=>'P1701_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(17083325742583369)
,p_item_default=>'&F4000_P1700_OWNER.'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Identifies the schema that owns the table on which the data load is to be based.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17084528044650347)
,p_name=>'P1701_TABLE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(17083325742583369)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&F4000_P1700_TABLE_NAME.'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Identifies the table on which the data load is to be based.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17084708875710964)
,p_name=>'F4000_P1701_COLUMN_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(17083325742583369)
,p_prompt=>'Add new table lookup for Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c.column_name_esc a, c.column_name b ',
'  from wwv_flow_table_columns_dev c ',
' where c.table_name = :P1701_TABLE_NAME ',
'   and owner = :P1701_OWNER ',
' order by c.column_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the column on which the table lookup definition is to be based.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17084920650714420)
,p_name=>'F4000_P1701_LOOKUP_KEY'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(716353221929823639)
,p_prompt=>'Return Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :F4000_P1701_LOOKUP_OWNER',
'   and table_name = :F4000_P1701_LOOKUP_TABLE',
'   and data_type <> ''BLOB'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'F4000_P1701_LOOKUP_TABLE'
,p_ajax_items_to_submit=>'F4000_P1701_LOOKUP_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the name of the column returned by the table lookup. This value will be inserted into the load column specified, and is generally the key value of the parent in a foreign key relationship. For example: DEPTNO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17085104504719190)
,p_name=>'F4000_P1701_LOOKUP_DIS_COL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(716353221929823639)
,p_prompt=>'Upload Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :F4000_P1701_LOOKUP_OWNER',
'   and table_name = :F4000_P1701_LOOKUP_TABLE',
'   and data_type <> ''BLOB'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'F4000_P1701_LOOKUP_TABLE'
,p_ajax_items_to_submit=>'F4000_P1701_LOOKUP_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select the name of the column end users will upload instead of the return column. This is the column that contains the display value from the lookup table. ',
'For example: DNAME'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17085318357723221)
,p_name=>'F4000_P1701_LOOKUP_TABLE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(716353221929823639)
,p_prompt=>'Lookup Table Name'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = :F4000_P1701_LOOKUP_OWNER'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table -'
,p_lov_cascade_parent_items=>'F4000_P1701_LOOKUP_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the table to be used for this table lookup definition.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(137454508961373080)
,p_name=>'P1701_DELETE_LOOKUP'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(716353221929823639)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(616691423253843189)
,p_name=>'F4000_P1701_LOOKUP_OWNER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(716353221929823639)
,p_item_default=>':F4000_P1700_OWNER'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Lookup Table Owner'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_SCHEMAS_HAVE_PRIVS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(owner) d, owner v',
'  from wwv_flow_object_owners_dev',
'order by d                   '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Owner -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select the owner of the lookup table.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(618491915783352012)
,p_name=>'F4000_P1701_ALT_KEY_COL_1'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(716353221929823639)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(618544123533363765)
,p_name=>'F4000_P1701_ALT_DIS_COL_1'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(716353221929823639)
,p_prompt=>'Upload Column 2'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :F4000_P1701_LOOKUP_OWNER',
'   and table_name = :F4000_P1701_LOOKUP_TABLE',
'   and data_type <> ''BLOB'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'F4000_P1701_LOOKUP_TABLE'
,p_ajax_items_to_submit=>'F4000_P1701_LOOKUP_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select the name of the second column to be uploaded to uniquely identify the return column if necessary. For example, to uniquely identify a State Code it may be necessary to upload the State Name and Country.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(940659192303194133)
,p_name=>'P1701_NEW'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(716353221929823639)
,p_source=>'wwv_flow_lang.system_message(''F4000.P1701.LOOKUP_DEFINITION'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(509218212429556965)
,p_validation_name=>'F4000_P1701_COLUMN_NAME Must Be Selected'
,p_validation_sequence=>10
,p_validation=>'F4000_P1701_COLUMN_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be selected.'
,p_when_button_pressed=>wwv_flow_imp.id(17083505094586916)
,p_associated_item=>wwv_flow_imp.id(17084708875710964)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(509285709790565660)
,p_validation_name=>'F4000_P1701_LOOKUP_TABLE Must Be Selected'
,p_validation_sequence=>20
,p_validation=>'F4000_P1701_LOOKUP_TABLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be selected.'
,p_when_button_pressed=>wwv_flow_imp.id(17083505094586916)
,p_associated_item=>wwv_flow_imp.id(17085318357723221)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(509335517540577346)
,p_validation_name=>'F4000_P1701_LOOKUP_KEY Must Be Selected'
,p_validation_sequence=>30
,p_validation=>'F4000_P1701_LOOKUP_KEY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be selected.'
,p_when_button_pressed=>wwv_flow_imp.id(17083505094586916)
,p_associated_item=>wwv_flow_imp.id(17084920650714420)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(509377407282583877)
,p_validation_name=>'F4000_P1701_LOOKUP_DIS_COL Must be Selected'
,p_validation_sequence=>40
,p_validation=>'F4000_P1701_LOOKUP_DIS_COL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be selected.'
,p_when_button_pressed=>wwv_flow_imp.id(17083505094586916)
,p_associated_item=>wwv_flow_imp.id(17085104504719190)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(549007712950312217)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(17013801647324744)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(549008023577312217)
,p_event_id=>wwv_flow_imp.id(549007712950312217)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(557593203070827111)
,p_name=>'Show / Hide Upload Col 3'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P1701_ALT_DIS_COL_1'
,p_condition_element=>'F4000_P1701_ALT_DIS_COL_1'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(557593390219827112)
,p_event_id=>wwv_flow_imp.id(557593203070827111)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1701_ALT_DIS_COL_2'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(557594439552827123)
,p_event_id=>wwv_flow_imp.id(557593203070827111)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1701_ALT_DIS_COL_2'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(557593466267827113)
,p_event_id=>wwv_flow_imp.id(557593203070827111)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1701_ALT_DIS_COL_2'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(557593544743827114)
,p_name=>'Show / Hide Lookup Definiton'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P1701_COLUMN_NAME'
,p_condition_element=>'F4000_P1701_COLUMN_NAME'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(557593687169827115)
,p_event_id=>wwv_flow_imp.id(557593544743827114)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(716353221929823639)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(557593965380827118)
,p_event_id=>wwv_flow_imp.id(557593544743827114)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(17083505094586916)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(557593733833827116)
,p_event_id=>wwv_flow_imp.id(557593544743827114)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(716353221929823639)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(557593859136827117)
,p_event_id=>wwv_flow_imp.id(557593544743827114)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(17083505094586916)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(557594004878827119)
,p_name=>'Enable / Disable Upload COL 1'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P1701_LOOKUP_DIS_COL'
,p_condition_element=>'F4000_P1701_LOOKUP_DIS_COL'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(557594103722827120)
,p_event_id=>wwv_flow_imp.id(557594004878827119)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1701_ALT_DIS_COL_1'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(557594325255827122)
,p_event_id=>wwv_flow_imp.id(557594004878827119)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1701_ALT_DIS_COL_1,F4000_P1701_ALT_DIS_COL_2'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(557594268295827121)
,p_event_id=>wwv_flow_imp.id(557594004878827119)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1701_ALT_DIS_COL_1'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(17088427155810906)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update table_lookups collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_exists boolean := false;',
'begin',
'    if wwv_flow_collection.collection_exists(''DATA_LOAD_TABLE_LOOKUPS'') = FALSE then',
'        wwv_flow_collection.create_collection(''DATA_LOAD_TABLE_LOOKUPS'');',
'    end if;',
'    l_exists := true;',
'    for c2 in (select c001, c002, c003, c004 from wwv_flow_collections where collection_name = ''DATA_LOAD_TABLE_LOOKUPS'') ',
'    loop',
'        if (c2.c001 = :P1701_OWNER AND c2.c002 = :P1701_TABLE_NAME AND c2.c003 = :F4000_P1701_COLUMN_NAME) THEN',
'            l_exists := false; ',
'        end if;',
'    end loop;',
'    if l_exists then',
'        wwv_flow_collection.add_member(',
'               p_collection_name => ''DATA_LOAD_TABLE_LOOKUPS'',',
'               p_c001            => :P1701_OWNER,',
'               p_c002            => :P1701_TABLE_NAME,',
'               p_c003            => :F4000_P1701_COLUMN_NAME,',
'               p_c004            => :F4000_P1701_LOOKUP_OWNER,',
'               p_c005            => :F4000_P1701_LOOKUP_TABLE,',
'               p_c006            => :F4000_P1701_LOOKUP_KEY,',
'               p_c007            => :F4000_P1701_LOOKUP_DIS_COL,',
'               p_c008            => :F4000_P1701_ALT_DIS_COL_1,',
'               p_c009            => :F4000_P1701_ALT_DIS_COL_2);',
'    end if;',
'',
'    -- Reset Items',
'    :F4000_P1701_COLUMN_NAME    := null;',
'    :F4000_P1701_LOOKUP_OWNER   := null; ',
'    :F4000_P1701_LOOKUP_KEY     := null;',
'    :F4000_P1701_LOOKUP_DIS_COL := null;',
'    :F4000_P1701_LOOKUP_DIS_COL := null;',
'    :F4000_P1701_ALT_KEY_COL_1  := null;',
'    :F4000_P1701_ALT_DIS_COL_1  := null;',
'    :F4000_P1701_ALT_KEY_COL_2  := null;',
'    :F4000_P1701_ALT_DIS_COL_2  := null;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(17083505094586916)
,p_internal_uid=>17088427155810906
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(136562502241286039)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove table lookup from the collection'
,p_process_sql_clob=>'wwv_flow_collection.delete_member(''DATA_LOAD_TABLE_LOOKUPS'', :P1701_DELETE_LOOKUP);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'DELETE'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>136562502241286039
);
end;
/
prompt --application/pages/page_01702
begin
wwv_flow_imp_page.create_page(
 p_id=>1702
,p_name=>'Create Legacy Data Loading'
,p_alias=>'CREATE-LEGACY-DATA-LOADING2'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Legacy Data Loading'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(423953526918849791)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17016401048381388)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>11
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(16993520375207189)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17016720441386960)
,p_plug_name=>'Add Transformation Rule'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>51
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44742603098995181)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>61
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(141953803036768756)
,p_name=>'Create Legacy Data Loading'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>31
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select seq_id, ',
'       c003 as "COLUMN", ',
'       c004 as "SEQUENCE", ',
'       c005 as "TYPE", ',
'       c006 as "NAME",',
'       c007 as "EXPRESSION_1",',
'       c008 as "EXPRESSION_2",',
'       ''<a href="''||htmldb_util.prepare_url(''f?p=4000:1702:''||:app_session||',
'       '':DELETE:::P1702_DELETE_RULE:''||seq_id)||''" class="a-Icon icon-remove"></a>'' remove_rule',
'from wwv_flow_collections where collection_name = ''DATA_LOAD_TABLE_RULES'''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Transformation Rules allow you to change the data being uploaded before it is inserted into the base table.  You select the column to transform and then the desired rule to apply to it.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(141954117841768758)
,p_query_column_id=>1
,p_column_alias=>'SEQ_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Seq Id'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(141954211204768758)
,p_query_column_id=>2
,p_column_alias=>'COLUMN'
,p_column_display_sequence=>5
,p_column_heading=>'Column(s)'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(141954330925768758)
,p_query_column_id=>3
,p_column_alias=>'SEQUENCE'
,p_column_display_sequence=>3
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(738619628788343951)
,p_query_column_id=>4
,p_column_alias=>'TYPE'
,p_column_display_sequence=>4
,p_column_heading=>'Type'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(141003727830690827)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(738619706308343952)
,p_query_column_id=>5
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Rule Name'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(240259131041254615)
,p_query_column_id=>6
,p_column_alias=>'EXPRESSION_1'
,p_column_display_sequence=>6
,p_column_heading=>'Expression 1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(240259208323254615)
,p_query_column_id=>7
,p_column_alias=>'EXPRESSION_2'
,p_column_display_sequence=>7
,p_column_heading=>'Expression 2'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(141954627598768758)
,p_query_column_id=>8
,p_column_alias=>'REMOVE_RULE'
,p_column_display_sequence=>8
,p_column_heading=>'Delete'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(240063320929645313)
,p_plug_name=>'PLSQL Expression Syntax'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(399849897040726767)
,p_plug_display_sequence=>71
,p_plug_source=>'sys.htp.p(wwv_flow_lang.system_message(''DATA_LOAD.RULES_PLSQL_EXPRESSION_EXAMPLES''));'
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(240065413095652559)
,p_plug_name=>'PLSQL Function Body Syntax'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(399849897040726767)
,p_plug_display_sequence=>81
,p_plug_source=>'sys.htp.p(wwv_flow_lang.system_message(''DATA_LOAD.RULES_PLSQL_FUNCTION_EXAMPLES''));'
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(240066800067658259)
,p_plug_name=>'SQL query syntax'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(399849897040726767)
,p_plug_display_sequence=>91
,p_plug_source=>'sys.htp.p(wwv_flow_lang.system_message(''DATA_LOAD.RULES_SQL_QUERY_EXAMPLES''));'
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(17017106373392379)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(44742603098995181)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(142502913125800120)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(44742603098995181)
,p_button_name=>'ADD'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Transformation'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(17017828190398660)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(44742603098995181)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(17017319879396246)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(44742603098995181)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(17020414993442164)
,p_branch_action=>'f?p=&APP_ID.:1701:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(17017828190398660)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(549006813591231832)
,p_branch_action=>'f?p=&APP_ID.:1700:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(17017319879396246)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(23853215218692051)
,p_name=>'F4000_P1702_RULE_EXPR3'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(17016720441386960)
,p_prompt=>'Trim Condition'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TRIM_CONDITIONS'
,p_lov=>'.'||wwv_flow_imp.id(23846801132546001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(140768001464654766)
,p_name=>'P1702_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(17016720441386960)
,p_item_default=>'&F4000_P1700_OWNER.'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Identifies the schema that owns the table on which the data load is to be based.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(140832516355659076)
,p_name=>'P1702_TABLE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(17016720441386960)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&F4000_P1700_TABLE_NAME.'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Identifies the table on which the data load is to be based.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(140939528260672040)
,p_name=>'F4000_P1702_COLUMN_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(17016720441386960)
,p_prompt=>'Select Column(s) to create a transformation rule'
,p_display_as=>'NATIVE_SHUTTLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c.column_name_esc a, c.column_name b from wwv_flow_table_columns_dev c where c.table_name = :P1702_TABLE_NAME and owner = :P1702_OWNER',
'order by c.column_id'))
,p_cHeight=>10
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identify the column on which the transformation rule definition is to be based.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ALL'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(141126609737704498)
,p_name=>'F4000_P1702_RULE_TYPE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(17016720441386960)
,p_prompt=>'Type'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DATA LOADING RULES TYPES'
,p_lov=>'.'||wwv_flow_imp.id(141003727830690827)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Rule Type -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the type of transformation rule to be created.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(141182629608719737)
,p_name=>'F4000_P1702_RULE_EXPR1'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(17016720441386960)
,p_prompt=>'Expression 1'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Define the above transformation rule'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(141209008268723011)
,p_name=>'F4000_P1702_RULE_EXPR2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(17016720441386960)
,p_prompt=>'Expression 2'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Define the above transformation rule'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(141341407014732076)
,p_name=>'F4000_P1702_RULE_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(17016720441386960)
,p_prompt=>'Rule Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a name for the transformation rule to be created.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(142171014249781490)
,p_name=>'P1702_DELETE_RULE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(17016720441386960)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(143049231788852803)
,p_name=>'F4000_P1702_RULE_SEQ'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(17016720441386960)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Sequence'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    s number;',
'begin',
'    select max(c004) into s',
'      from wwv_flow_collections ',
'     where collection_name = ''DATA_LOAD_TABLE_RULES'';',
'   s := nvl(s,0);',
'   s := trunc(s) + 10;',
'   return s;',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>6
,p_cMaxlength=>6
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify the sequence for the transformation rule. The sequence determines the order of evaluation.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(508876218092492363)
,p_validation_name=>'F4000_P1702_RULE_SEQ Must Be Selected'
,p_validation_sequence=>10
,p_validation=>'F4000_P1702_RULE_SEQ'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_when_button_pressed=>wwv_flow_imp.id(142502913125800120)
,p_associated_item=>wwv_flow_imp.id(143049231788852803)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(509013516276510740)
,p_validation_name=>'F4000_P1702_RULE_TYPE Must Be Selected'
,p_validation_sequence=>20
,p_validation=>'F4000_P1702_RULE_TYPE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(142502913125800120)
,p_associated_item=>wwv_flow_imp.id(141126609737704498)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(509051332553515472)
,p_validation_name=>'F4000_P1702_RULE_NAME Must Be Specified'
,p_validation_sequence=>30
,p_validation=>'F4000_P1702_RULE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_when_button_pressed=>wwv_flow_imp.id(142502913125800120)
,p_associated_item=>wwv_flow_imp.id(141341407014732076)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(509096717446520559)
,p_validation_name=>'F4000_P1702_COLUMN_NAME Must Be Selected'
,p_validation_sequence=>40
,p_validation=>'F4000_P1702_COLUMN_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be selected.'
,p_when_button_pressed=>wwv_flow_imp.id(142502913125800120)
,p_associated_item=>wwv_flow_imp.id(140939528260672040)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(326744006079467860)
,p_validation_name=>'F4000_P1702_RULE_EXPR1'
,p_validation_sequence=>50
,p_validation=>'F4000_P1702_RULE_EXPR1'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>':F4000_P1702_RULE_TYPE in (''PLSQL_FUNCTION_BODY'',''PLSQL_EXPRESSION'',''SQL_QUERY_SINGLE_VALUE'', ''SQL_QUERY_SEMI_COLON'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(142502913125800120)
,p_associated_item=>wwv_flow_imp.id(141182629608719737)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1337910750100622328)
,p_validation_name=>'Validate PLSQL function body'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_f4000_util.check_plsql(',
'     :F4000_P1702_RULE_EXPR1,',
'     :FB_FLOW_ID,',
'     :FLOW_SECURITY_GROUP_ID',
' );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':REQUEST = ''ADD'' and :F4000_P1702_RULE_TYPE = ''PLSQL_FUNCTION_BODY'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(142502913125800120)
,p_associated_item=>wwv_flow_imp.id(141182629608719737)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(557594554385827124)
,p_validation_name=>'Validate SQL Query, SQL and PLSQL expressions'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_f4000_util.validate_plsql_expressions(',
'     :F4000_P1702_RULE_EXPR1,',
'    :F4000_P1702_RULE_TYPE',
');'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':REQUEST = ''ADD'' and :F4000_P1702_RULE_TYPE in (''PLSQL_EXPRESSION'',''SQL_QUERY_SINGLE_VALUE'', ''SQL_QUERY_SEMI_COLON'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(142502913125800120)
,p_associated_item=>wwv_flow_imp.id(141182629608719737)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(486082505592249567)
,p_name=>'Rule Expression 1'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P1702_RULE_TYPE'
,p_condition_element=>'F4000_P1702_RULE_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'REPLACE,PLSQL_EXPRESSION,REGULAR_EXPRESSION, SQL_QUERY_SINGLE_VALUE, SQL_QUERY_SEMI_COLON, PLSQL_FUNCTION_BODY, TRIM, LTRIM, RTRIM'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(486082805977249571)
,p_event_id=>wwv_flow_imp.id(486082505592249567)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1702_RULE_EXPR1'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(486083004232249572)
,p_event_id=>wwv_flow_imp.id(486082505592249567)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1702_RULE_EXPR1'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(486101913557251786)
,p_name=>'Rule Expression 2'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P1702_RULE_TYPE'
,p_condition_element=>'F4000_P1702_RULE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REPLACE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(486102201017251925)
,p_event_id=>wwv_flow_imp.id(486101913557251786)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1702_RULE_EXPR2'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(486102424449251925)
,p_event_id=>wwv_flow_imp.id(486101913557251786)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1702_RULE_EXPR2'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(23853832534696991)
,p_name=>'Transformation Rule (trim condition)'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P1702_RULE_TYPE'
,p_condition_element=>'F4000_P1702_RULE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TRIM'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(23854127612696991)
,p_event_id=>wwv_flow_imp.id(23853832534696991)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1702_RULE_EXPR3'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(23854317588696992)
,p_event_id=>wwv_flow_imp.id(23853832534696991)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1702_RULE_EXPR3'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(549006234878229114)
,p_name=>'Cancel Dialog'
,p_event_sequence=>40
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(17017106373392379)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(549006551963229120)
,p_event_id=>wwv_flow_imp.id(549006234878229114)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(557594748831827126)
,p_name=>'Show Hide'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P1702_COLUMN_NAME'
,p_condition_element=>'F4000_P1702_COLUMN_NAME'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(557594800619827127)
,p_event_id=>wwv_flow_imp.id(557594748831827126)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1702_RULE_SEQ,F4000_P1702_RULE_NAME,F4000_P1702_RULE_TYPE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(557595036628827129)
,p_event_id=>wwv_flow_imp.id(557594748831827126)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(142502913125800120)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(557595790203827136)
,p_event_id=>wwv_flow_imp.id(557594748831827126)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(240066800067658259)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(557595285362827131)
,p_event_id=>wwv_flow_imp.id(557594748831827126)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(240063320929645313)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(557595625710827135)
,p_event_id=>wwv_flow_imp.id(557594748831827126)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(240065413095652559)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(557595366660827132)
,p_event_id=>wwv_flow_imp.id(557594748831827126)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(240065413095652559)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(557595505860827134)
,p_event_id=>wwv_flow_imp.id(557594748831827126)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(240063320929645313)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(557595115672827130)
,p_event_id=>wwv_flow_imp.id(557594748831827126)
,p_event_result=>'FALSE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(142502913125800120)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(557595499312827133)
,p_event_id=>wwv_flow_imp.id(557594748831827126)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(240066800067658259)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(557594983480827128)
,p_event_id=>wwv_flow_imp.id(557594748831827126)
,p_event_result=>'FALSE'
,p_action_sequence=>60
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P1702_RULE_SEQ,F4000_P1702_RULE_NAME,F4000_P1702_RULE_TYPE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(12685612286745845)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'get plsql_expression_2'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_position     number;',
'   l_expr_string   varchar2(4000) := null;',
'   type l_arr_int_cols is table of varchar2(255) index by binary_integer;',
'   type l_arr_position is table of number index by binary_integer;',
'   l_arr_pos      l_arr_position;',
'   l_int_cols     l_arr_int_cols;',
'   i              pls_integer := 0;',
'begin',
'    if :F4000_P1702_RULE_TYPE in (''PLSQL_EXPRESSION'', ''PLSQL_FUNCTION_BODY'', ''SQL_QUERY_SINGLE_VALUE'', ''SQL_QUERY_SEMI_COLON'', ''REGULAR_EXPRESSION'') then',
'        for c1 in (select column_name',
'                      from wwv_flow_table_columns_dev',
'                     where table_name = :P1702_TABLE_NAME',
'                      and owner = :P1702_OWNER )',
'        loop',
'            l_position := instr(:F4000_P1702_RULE_EXPR1, '':''||c1.column_name, 1);',
'                while l_position > 0',
'                loop',
'                     if l_int_cols.exists(l_position) = false then',
'                        i := i + 1;',
'                        l_arr_pos(i) := l_position;',
'                        l_int_cols(l_position) := c1.column_name;',
'                    else',
'                        if instr(c1.column_name, l_int_cols(l_position), 1) > 0 then',
'                            l_int_cols(l_position) := c1.column_name;',
'                        end if;',
'                    end if;',
'                    l_position := instr(:F4000_P1702_RULE_EXPR1,'':''||c1.column_name,l_position + 1);',
'                end loop;',
'        end loop;',
'        for i in 1..l_arr_pos.count',
'        loop',
'            l_expr_string := l_expr_string||'':''||l_int_cols(l_arr_pos(i));',
'        end loop;',
'    :F4000_P1702_RULE_EXPR2 := l_expr_string;',
'    end if;',
'    if :F4000_P1702_RULE_TYPE = ''TRIM'' then',
'       :F4000_P1702_RULE_EXPR2 := :F4000_P1702_RULE_EXPR3;',
'    end if;',
' end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(142502913125800120)
,p_internal_uid=>12685612286745845
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(142843330834833638)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update table_rules collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_exists boolean := false;',
'begin',
'    if wwv_flow_collection.collection_exists(''DATA_LOAD_TABLE_RULES'') = FALSE then',
'        wwv_flow_collection.create_collection(''DATA_LOAD_TABLE_RULES'');',
'    end if;',
'    ',
'    l_exists := true;',
'',
'    for c2 in (select c001, c002, c003, c004 from wwv_flow_collections where collection_name = ''DATA_LOAD_TABLE_RULES'') ',
'    loop',
'        if (c2.c001 = :P1702_OWNER AND c2.c002 = :P1702_TABLE_NAME AND c2.c003 = :F4000_P1702_COLUMN_NAME) THEN',
'            l_exists := false; ',
'        end if;',
'    end loop;',
'',
'    if l_exists then',
'        wwv_flow_collection.add_member(',
'                p_collection_name => ''DATA_LOAD_TABLE_RULES'',',
'                p_c001            => :P1702_OWNER,',
'                p_c002            => :P1702_TABLE_NAME,',
'                p_c003            => :F4000_P1702_COLUMN_NAME,',
'                p_c004            => :F4000_P1702_RULE_SEQ,',
'                p_c005            => :F4000_P1702_RULE_TYPE,',
'                p_c006            => :F4000_P1702_RULE_NAME,',
'                p_c007            => :F4000_P1702_RULE_EXPR1,',
'                p_c008            => :F4000_P1702_RULE_EXPR2);',
'    end if;',
'',
'    -- Reset Values To Null',
'    :F4000_P1702_COLUMN_NAME := null;',
'    :F4000_P1702_RULE_SEQ    := null;',
'    :F4000_P1702_RULE_TYPE   := null;',
'    :F4000_P1702_RULE_NAME   := null;',
'    :F4000_P1702_RULE_EXPR1  := null;',
'    :F4000_P1702_RULE_EXPR2  := null;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(142502913125800120)
,p_internal_uid=>142843330834833638
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(142381616111791513)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove table rule from the collection'
,p_process_sql_clob=>'wwv_flow_collection.delete_member(''DATA_LOAD_TABLE_RULES'', :P1702_DELETE_RULE);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'DELETE'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>142381616111791513
);
end;
/
prompt --application/pages/page_01704
begin
wwv_flow_imp_page.create_page(
 p_id=>1704
,p_name=>'Create Legacy Data Loading'
,p_alias=>'CREATE-LEGACY-DATA-LOADING3'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Legacy Data Loading'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(423953526918849791)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17037621507614405)
,p_plug_name=>'Create Legacy Data Loading'
,p_region_css_classes=>'a-Form--fixedLabelsSmall'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>11
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<p>This page provides a short descriptive name for each page of the data load wizard to be created. Please provide the page name, number, and region names to use in the data load wizard.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17038732028626860)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>21
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(16993520375207189)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44760107956072262)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>51
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(17037901899618123)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(44760107956072262)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(17038319214623199)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(44760107956072262)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(581438578421388810)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(44760107956072262)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1701:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(17040932037702539)
,p_branch_name=>'Navigation Menu / Tabs'
,p_branch_action=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.:RP:P4716_PREV_PAGE_ID:&APP_PAGE_ID.:'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(17038319214623199)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17089918440054409)
,p_name=>'F4000_P1704_STEP_1'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(17037621507614405)
,p_prompt=>'Step 1 Page Number'
,p_source=>'wwv_flow_utilities.minimum_free_page(v(''FB_FLOW_ID''),1)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>255
,p_begin_on_new_line=>'N'
,p_colspan=>2
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17090131946058289)
,p_name=>'F4000_P1704_STEP_2'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(17037621507614405)
,p_prompt=>'Step 2 Page Number'
,p_source=>'wwv_flow_utilities.minimum_free_page(v(''FB_FLOW_ID''),1)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>255
,p_begin_on_new_line=>'N'
,p_colspan=>2
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17090311645061905)
,p_name=>'F4000_P1704_STEP_3'
,p_is_required=>true
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(17037621507614405)
,p_prompt=>'Step 3 Page Number'
,p_source=>'wwv_flow_utilities.minimum_free_page(v(''FB_FLOW_ID''),1)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>255
,p_begin_on_new_line=>'N'
,p_colspan=>2
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17090522727065107)
,p_name=>'F4000_P1704_STEP_4'
,p_is_required=>true
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(17037621507614405)
,p_prompt=>'Step 4 Page Number'
,p_source=>'wwv_flow_utilities.minimum_free_page(v(''FB_FLOW_ID''),1)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>255
,p_begin_on_new_line=>'N'
,p_colspan=>2
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(45293322305583986)
,p_name=>'P1704_PAGE_MODE'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(17037621507614405)
,p_item_default=>'NORMAL'
,p_prompt=>'Page Mode'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DIALOG_PAGE_MODE_CREATE_WIZARD'
,p_lov=>'.'||wwv_flow_imp.id(1497542689968615899)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_user_interface_dev.dialog_page_template_exists( ',
'                     p_application_id    => :FB_FLOW_ID ); '))
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Identify the page mode, based on the following options: <p/>',
'<ul>',
'<li><strong>Normal</strong>: The page is presented as a normal &PRODUCT_NAME. application page.</li>',
'<li><strong>Modal Dialog</strong>: The page is presented as a modal dialog. A modal dialog is an overlay window positioned within the viewport, which remains active and focused until the end user dismisses (closes) it. The underlying page is grayed o'
||'ut and the end user is prevented from interacting with the rest of the page until the dialog is closed.</li></ul>',
'<br><p>',
'Note that the Modal Dialog option will only be available for selection where the current application theme contains at least one page template of template type <strong>Dialog Page</strong>.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
,p_attribute_04=>'VERTICAL'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(306718601132076249)
,p_name=>'F4000_P1704_LABEL_STEP_1'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(17037621507614405)
,p_item_default=>'wwv_flow_lang.system_message(''DATA_LOAD.SOURCE'');'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>' Step 1'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_colspan=>7
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the page name and number to be used for step 1, the Data Load Source step of the wizard.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(306745612560079584)
,p_name=>'F4000_P1704_LABEL_STEP_2'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(17037621507614405)
,p_item_default=>'wwv_flow_lang.system_message(''DATA_LOAD.MAPPING'');'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>' Step 2'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_colspan=>7
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the page name and number to be used for step 2, the Data / Table Mapping step of the wizard.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(306772620871082020)
,p_name=>'F4000_P1704_LABEL_STEP_3'
,p_is_required=>true
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(17037621507614405)
,p_item_default=>'wwv_flow_lang.system_message(''DATA_LOAD.VALIDATION'');'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>' Step 3'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_colspan=>7
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the page name and number to be used for step 3, the Data Validation step of the wizard.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(306799630914084925)
,p_name=>'F4000_P1704_LABEL_STEP_4'
,p_is_required=>true
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(17037621507614405)
,p_item_default=>'wwv_flow_lang.system_message(''DATA_LOAD.UPLOAD_RESULTS'');'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>' Step 4'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_colspan=>7
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the page name and number to be used for step 4, the Uploading results step of the wizard.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(307157215517194031)
,p_name=>'P1704_BREADCRUMB_ID'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(17037621507614405)
,p_item_default=>'0'
,p_prompt=>'Breadcrumb'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION.MENUS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name,',
'       id',
'  from wwv_flow_menus',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- do not add breadcrumb region to page -'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select whether you want to use a breadcrumb navigation control on your page, and which breadcrumb navigation control you want to use.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(307326122415318969)
,p_name=>'P1704_BREADCRUMB_NAME'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(17037621507614405)
,p_item_default=>'wwv_flow_lang.system_message(''DATA_LOAD.DATA_LOADING'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Breadcrumb Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identify the name of this breadcrumb entry.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(381603152133221289)
,p_name=>'P1704_BREADCRUMB_PARENT_ID'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(17037621507614405)
,p_prompt=>'Parent Entry'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov_language=>'PLSQL'
,p_lov=>'return wwv_flow_4000_ui.breadcrumb_parent_lov_sql( p_breadcrumb_item_name => ''P1704_BREADCRUMB_ID'' )'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'No parent entry'
,p_lov_cascade_parent_items=>'P1704_BREADCRUMB_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(402688644236475854)
,p_name=>'P1704_GROUP_NAME'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(17037621507614405)
,p_prompt=>'Page Group'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE GROUP (RETURNS NAME)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d, group_name r ',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'order by upper(group_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Page Group -'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Identify the name of the page group you would like to associate with this page. Page groups help developers manage the pages within an application. To create a page group, enter the name.  To use an existing page group, select the name from the list '
||'of values.',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(426368401356372331)
,p_name=>'P1704_PAGE_NAME_LABEL'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(17037621507614405)
,p_source=>'wwv_flow_lang.system_message(''F4000.PAGE_NAME'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_begin_on_new_line=>'N'
,p_colspan=>7
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'Enter a title for the page being created.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(426425401487381808)
,p_name=>'P1704_PAGE_ID_LABEL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(17037621507614405)
,p_prompt=>'Page Number'
,p_source=>'wwv_flow_lang.system_message(''CONFIRM.DATA_LOAD_PAGE'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_begin_on_new_line=>'N'
,p_colspan=>2
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'Enter a unique page number for the page being created.'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1941075897639553145)
,p_computation_sequence=>70
,p_computation_item=>'P4716_NAVLIST_ENTRY_NAME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P1704_BREADCRUMB_NAME'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(4501863895479002)
,p_computation_sequence=>20
,p_computation_item=>'P2500_NAVIGATION_TYPE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select x.navigation_type',
'  from wwv_flow_themes x,',
'       wwv_flows f',
' where f.id                = :FB_FLOW_ID',
'   and f.security_group_id = :WORKSPACE_ID',
'   and x.flow_id           = f.id',
'   and x.security_group_id = f.security_group_id',
'   and x.theme_id          = f.theme_id',
' order by 1'))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(510898624980891789)
,p_validation_name=>'Unique Page Numbers Must be Specified'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_result boolean := TRUE;',
'begin',
'    for c1 in (select NULL',
'                 from wwv_flow_steps ',
'                where id in (:F4000_P1704_STEP_1,:F4000_P1704_STEP_2,:F4000_P1704_STEP_3,:F4000_P1704_STEP_4)',
'                  and flow_id = :FB_FLOW_ID ',
'                  and security_group_id = wwv_flow_security.g_security_group_id) loop',
'        l_result := FALSE;',
'        exit;',
'    end loop;',
'    return l_result;',
'    --',
'    exception',
'        when others then',
'            return FALSE;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Unique numeric page numbers which are not already used by application "&FB_FLOW_ID." must be specified.'
,p_associated_item=>wwv_flow_imp.id(426425401487381808)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(512164022893165569)
,p_validation_name=>'Page Numbers Cannot Be the same'
,p_validation_sequence=>100
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (  :F4000_P1704_STEP_1=:F4000_P1704_STEP_2',
'   or :F4000_P1704_STEP_1=:F4000_P1704_STEP_3 ',
'   or :F4000_P1704_STEP_1=:F4000_P1704_STEP_4',
'   or :F4000_P1704_STEP_2=:F4000_P1704_STEP_3',
'   or :F4000_P1704_STEP_2=:F4000_P1704_STEP_4',
'   or :F4000_P1704_STEP_3=:F4000_P1704_STEP_4 )',
'then',
'    return false;',
'else',
'    return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Unique numeric page numbers must be specified for each of the pages to be created.'
,p_validation_condition=>':F4000_P1704_STEP_1 is not null and :F4000_P1704_STEP_2 is not null and :F4000_P1704_STEP_3 is not null and :F4000_P1704_STEP_4 is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(45293818854585647)
,p_validation_name=>'P1704_PAGE_MODE Not Null'
,p_validation_sequence=>110
,p_validation=>'P1704_PAGE_MODE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Page Mode must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(17038319214623199)
,p_associated_item=>wwv_flow_imp.id(45293322305583986)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_validation_comment=>'generated 10-MAR-2001 11:10'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(402736362564769662)
,p_validation_name=>'Validate Group Name'
,p_validation_sequence=>120
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_utilities.is_valid_page_group_name (',
'  p_name => :P1704_GROUP_NAME);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P1704_GROUP_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(17038319214623199)
,p_associated_item=>wwv_flow_imp.id(402688644236475854)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(381604915818238072)
,p_name=>'breadcrumb options'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1704_BREADCRUMB_ID'
,p_condition_element=>'P1704_BREADCRUMB_ID'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(381605259963238072)
,p_event_id=>wwv_flow_imp.id(381604915818238072)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1704_BREADCRUMB_PARENT_ID,P1704_BREADCRUMB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(381605462662238072)
,p_event_id=>wwv_flow_imp.id(381604915818238072)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1704_BREADCRUMB_PARENT_ID,P1704_BREADCRUMB_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(549009521070329464)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(17037901899618123)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(549009804675329464)
,p_event_id=>wwv_flow_imp.id(549009521070329464)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_01706
begin
wwv_flow_imp_page.create_page(
 p_id=>1706
,p_name=>'Create Legacy Data Loading'
,p_alias=>'CREATE-LEGACY-DATA-LOADING4'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Legacy Data Loading'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(423953526918849791)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44782926666153356)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>31
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(307918531793548759)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>11
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(16993520375207189)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_plug_query_row_template=>wwv_flow_imp.id(506168724401357441)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(308035630108576675)
,p_plug_name=>'Create Legacy Data Loading'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>21
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(308069925391584807)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(44782926666153356)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(308116127946595025)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(44782926666153356)
,p_button_name=>'FINISH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(308093010631589969)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(44782926666153356)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4501981608479003)
,p_branch_name=>'Go to edit page'
,p_branch_action=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:&FB_FLOW_PAGE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(308116127946595025)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(538265446997852394)
,p_branch_name=>'Navigation Menu / Tabs'
,p_branch_action=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(308093010631589969)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(308196116088610526)
,p_name=>'F4000_P1706_CANCEL_LABEL'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(308035630108576675)
,p_item_default=>'wwv_flow_lang.system_message(''CANCEL'');'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Cancel Button Label'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Enter text to display on the Cancel button.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(308253830642690345)
,p_name=>'F4000_P1706_CANCEL_BRANCH'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(308035630108576675)
,p_prompt=>'Cancel Button Branch to Page'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d',
'  from wwv_flow_steps',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and is_page_pattern   = ''N''',
'order by 2'))
,p_cSize=>6
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the page number to branch to when the user clicks Cancel.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(308292132504700384)
,p_name=>'F4000_P1706_NEXT_LABEL'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(308035630108576675)
,p_item_default=>'wwv_flow_lang.system_message(''NEXT'');'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Next Button Label'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter text to display on the Next button.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(308319111511703745)
,p_name=>'F4000_P1706_PREVIOUS_LABEL'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(308035630108576675)
,p_item_default=>'wwv_flow_lang.system_message(''PREVIOUS'');'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Previous Button Label'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter text to display on the Previous button.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(308347306447711803)
,p_name=>'F4000_P1706_SUBMIT_LABEL'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(308035630108576675)
,p_item_default=>'wwv_flow_lang.system_message(''F4000.P4731.FINISH'');'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Finish Button Label'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Enter text to display on the Submit button.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(308382132074719136)
,p_name=>'F4000_P1706_SUBMIT_BRANCH'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(308035630108576675)
,p_prompt=>'Finish Button Branch to Page'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d',
'  from wwv_flow_steps',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and is_page_pattern   = ''N''',
'order by 2'))
,p_cSize=>6
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the number of the page to branch to. You can choose to branch back to the same page or any other page in your application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(549011384662348198)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(308069925391584807)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(549011662632348199)
,p_event_id=>wwv_flow_imp.id(549011384662348198)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(618358026360311325)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create data load wizard'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_wizard_api.create_data_load_wizard (',
'        p_flow_id              => :FB_FLOW_ID,',
'        --',
'        p_name                     => :F4000_P1700_NAME,',
'        p_owner                    => :F4000_P1700_OWNER,',
'        p_table_name               => :F4000_P1700_TABLE_NAME,',
'        p_exists                   => :P1700_EXISTS,',
'        p_page_mode                => :P1704_PAGE_MODE,',
'        p_group_name               => :P1704_GROUP_NAME,',
'        --',
'        p_tab_set                  => :P4716_TAB_SET,',
'        p_tab_name                 => :P4716_TAB_NAME,',
'        p_tab_label                => :P4716_TAB_LABEL,',
'        --',
'        p_nav_list_id              => :P4716_NAVLIST_ID,',
'        p_nav_list_parent_item_id  => :P4716_NAVLIST_PARENT_ID,',
'        p_nav_list_child_item_name => :P4716_NAVLIST_ENTRY_NAME,',
'        --    ',
'        p_breadcrumb_id            => :P1704_BREADCRUMB_ID,',
'        p_breadcrumb_name          => :P1704_BREADCRUMB_NAME,',
'        p_parent_breadcrumb_id     => :P1704_BREADCRUMB_PARENT_ID,',
'        --',
'        p_page_step_1              => :F4000_P1704_STEP_1,',
'        p_page_step_2              => :F4000_P1704_STEP_2,',
'        p_page_step_3              => :F4000_P1704_STEP_3,',
'        p_page_step_4              => :F4000_P1704_STEP_4,',
'        --',
'        p_page_label_step_1        => :F4000_P1704_LABEL_STEP_1,',
'        p_page_label_step_2        => :F4000_P1704_LABEL_STEP_2,',
'        p_page_label_step_3        => :F4000_P1704_LABEL_STEP_3,',
'        p_page_label_step_4        => :F4000_P1704_LABEL_STEP_4,',
'        --',
'        p_region_name_step_1       => :F4000_P1704_LABEL_STEP_1,',
'        p_region_name_step_2       => :F4000_P1704_LABEL_STEP_2,',
'        p_region_name_step_3       => :F4000_P1704_LABEL_STEP_3,',
'        p_region_name_step_4       => :F4000_P1704_LABEL_STEP_4,',
'        --',
'        p_page_next_label          => :F4000_P1706_NEXT_LABEL,',
'        p_page_previous_label      => :F4000_P1706_PREVIOUS_LABEL,',
'        p_page_cancel_label        => :F4000_P1706_CANCEL_LABEL,',
'        p_page_cancel_branch       => :F4000_P1706_CANCEL_BRANCH,',
'        p_page_finish_label        => :F4000_P1706_SUBMIT_LABEL,',
'        p_page_finish_branch       => :F4000_P1706_SUBMIT_BRANCH );',
'',
'   -- Set Application Items To First New Page of Data Load Wizard - for use on Success Page',
'   :FB_FLOW_PAGE_ID       := :F4000_P1704_STEP_1;',
'   :F4000_RUN_EDIT_PAGE   := :F4000_P1704_STEP_1;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error creating legacy data loading.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(308116127946595025)
,p_process_success_message=>'Legacy data loading created successfully.'
,p_internal_uid=>618358026360311325
);
end;
/
prompt --application/pages/page_01800
begin
wwv_flow_imp_page.create_page(
 p_id=>1800
,p_name=>'Data Load Definitions'
,p_alias=>'DATA-LOAD-DEFINITIONS'
,p_step_title=>'Data Load Definitions'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(1449603451873552)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2563810357654036)
,p_plug_name=>'Legacy Data Load'
,p_region_template_options=>'#DEFAULT#:is-expanded:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(689970285456172024)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'from wwv_flow_load_tables',
'where flow_id = :fb_flow_id',
'and security_group_id = :flow_security_group_id',
'and data_profile_id is null'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1451393743911801)
,p_plug_name=>'Legacy Data Load'
,p_parent_plug_id=>wwv_flow_imp.id(2563810357654036)
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  id,',
'  name,',
'  table_name,',
'  ''icon-sc-data-loading'' icon_class,',
'       ''f?p=4000:1801:''||:app_session||',
'           ''::NO:1801:P1801_ID:''||id edit_link,',
'  unique_column_1, ',
'  is_uk1_case_sensitive, ',
'  unique_column_2, ',
'  is_uk2_case_sensitive, ',
'  unique_column_3, ',
'  is_uk3_case_sensitive, ',
'  unique_column_1||',
'      decode(unique_column_2,null,null,'', ''||unique_column_2)||',
'      decode(unique_column_3,null,null,'', ''||unique_column_3) key_columns,',
'(select count(*) from wwv_flow_load_table_lookups s where s.load_table_id = l.id ) lookups, ',
'(select count(*) from wwv_flow_load_table_rules s where s.load_table_id = l.id ) rules, ',
'  l.created_on table_created,',
'  l.created_by table_created_by, ',
'  l.last_updated_on, ',
'  l.last_updated_by',
'  from wwv_flow_load_tables l',
' where l.flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and data_profile_id is null'))
,p_plug_source_type=>'NATIVE_IR'
,p_landmark_type=>'exclude_landmark'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(1451634485911804)
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than #MAX_ROW_COUNT# rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#EDIT_LINK#" class="a-IRR-icon"><span class="a-Icon #ICON_CLASS#"></span><span class="a-IRR-iconName">#NAME#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'CBCHO'
,p_internal_uid=>1451634485911804
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1451753816911805)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1451804330911806)
,p_db_column_name=>'TABLE_NAME'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Table Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1451923828911807)
,p_db_column_name=>'LOOKUPS'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Lookups'
,p_sync_form_label=>'N'
,p_column_link=>'f?p=&APP_ID.:1801:&SESSION.::&DEBUG.:1801:P1801_ID:#ID#'
,p_column_linktext=>'#LOOKUPS#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1452018251911808)
,p_db_column_name=>'RULES'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Rules'
,p_column_link=>'f?p=&APP_ID.:1801:&SESSION.::&DEBUG.:1801:P1801_ID:#ID#'
,p_column_linktext=>'#RULES#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1452156160911809)
,p_db_column_name=>'TABLE_CREATED'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>'Created'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1452230103911810)
,p_db_column_name=>'TABLE_CREATED_BY'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>'Created By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1452320118911811)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>70
,p_column_identifier=>'G'
,p_column_label=>'Last Modified'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1452445712911812)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>80
,p_column_identifier=>'H'
,p_column_label=>'Last Modified By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1452531754911813)
,p_db_column_name=>'KEY_COLUMNS'
,p_display_order=>90
,p_column_identifier=>'I'
,p_column_label=>'Key Columns'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1452654514911814)
,p_db_column_name=>'IS_UK1_CASE_SENSITIVE'
,p_display_order=>100
,p_column_identifier=>'J'
,p_column_label=>'Is Uk1 Case Sensitive'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1452767596911815)
,p_db_column_name=>'IS_UK2_CASE_SENSITIVE'
,p_display_order=>110
,p_column_identifier=>'K'
,p_column_label=>'Is Uk2 Case Sensitive'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1452848018911816)
,p_db_column_name=>'IS_UK3_CASE_SENSITIVE'
,p_display_order=>120
,p_column_identifier=>'L'
,p_column_label=>'Is Uk3 Case Sensitive'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1452939389911817)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>130
,p_column_identifier=>'M'
,p_column_label=>'Edit Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1453019461911818)
,p_db_column_name=>'UNIQUE_COLUMN_1'
,p_display_order=>140
,p_column_identifier=>'N'
,p_column_label=>'Unique Column 1'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1453118131911819)
,p_db_column_name=>'UNIQUE_COLUMN_2'
,p_display_order=>150
,p_column_identifier=>'O'
,p_column_label=>'Unique Column 2'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1453208917911820)
,p_db_column_name=>'UNIQUE_COLUMN_3'
,p_display_order=>160
,p_column_identifier=>'P'
,p_column_label=>'Unique Column 3'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1453382525911821)
,p_db_column_name=>'NAME'
,p_display_order=>170
,p_column_identifier=>'Q'
,p_column_label=>'Name'
,p_column_link=>'f?p=&APP_ID.:1801:&SESSION.::&DEBUG.:1801:P1801_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1453419214911822)
,p_db_column_name=>'ICON_CLASS'
,p_display_order=>180
,p_column_identifier=>'R'
,p_column_label=>'Icon Class'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(1462135990917052)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_type=>'REPORT'
,p_report_alias=>'14622'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_view_mode=>'ICON'
,p_report_columns=>'NAME:TABLE_NAME:KEY_COLUMNS:LOOKUPS:RULES:LAST_UPDATED_ON:UNIQUE_COLUMN_1:UNIQUE_COLUMN_2:UNIQUE_COLUMN_3'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(15136824324283148)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(15132926917246073)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Data Load Definitions'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(15698603515328105)
,p_plug_name=>'Data Load Definitions'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with messages as (',
'    select ( select wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_UP_TO_DATE'') from sys.dual ) up_to_date,',
'           ( select wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_NEEDS_REFRESH'') from sys.dual ) needs_refresh,',
'           ( select wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_UNKNOWN'') from sys.dual ) unknown_status,',
'           ( select wwv_flow_lang_dev.builder_message(''SUBSCRIBED_FROM.NONEXISTING_MASTER'') from sys.dual ) no_master',
'      from sys.dual )',
'select ',
'  l.id,',
'  l.name,',
'  l.target_type,',
'  case l.target_type',
'  when ''TABLE'' then',
'      l.table_name',
'  when ''COLLECTION'' then',
'      l.collection_name',
'  end target_name,',
'  ''icon-sc-data-loading'' icon_class,',
'       ''f?p=4000:1820:''||:app_session||',
'           ''::NO:1820:P1820_ID:''||l.id edit_link,',
'  --',
'       case when l.reference_id is not null then',
'           coalesce ( to_char( master.flow_id ),',
'                       messages.no_master )',
'       end as subscribed_from,',
'       ( select case when count(*) > 0 then count(*) end',
'           from wwv_flow_load_tables sub',
'          where sub.reference_id      = l.id',
'            and sub.security_group_id = :WORKSPACE_ID ) as subscribers,',
'       case when l.reference_id is not null then',
'           case',
'               when master.version_scn = l.version_scn then',
'                   messages.up_to_date',
'               when master.version_scn != l.version_scn then',
'                   messages.needs_refresh',
'               else',
'                   messages.unknown_status',
'           end',
'       end subscription_status,',
'       --',
'  coalesce( l.last_updated_on, l.created_on ) last_updated,',
'  coalesce( l.last_updated_by, l.created_by ) last_updated_by',
'  from wwv_flow_load_tables l,',
'       wwv_flow_load_tables master,',
'       wwv_flow_data_profiles p,',
'       messages',
' where p.id = l.data_profile_id',
'   and l.flow_id                = :FB_FLOW_ID',
'   and l.security_group_id      = :WORKSPACE_ID',
'   and l.reference_id           = master.id (+)',
'   and l.security_group_id      = master.security_group_id (+)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(15698721914328105)
,p_name=>'Tables Report'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than #MAX_ROW_COUNT# rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No Data Load Definitions are defined within this application.'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#EDIT_LINK#" class="a-IRR-icon"><span class="a-Icon #ICON_CLASS#"></span><span class="a-IRR-iconName">#NAME#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'PMANIRAHO'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15698923904328108)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1453501874911823)
,p_db_column_name=>'TARGET_TYPE'
,p_display_order=>11
,p_column_identifier=>'AJ'
,p_column_label=>'Target Type'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(1633774479940540)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1453664171911824)
,p_db_column_name=>'TARGET_NAME'
,p_display_order=>21
,p_column_identifier=>'AK'
,p_column_label=>'Target Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(480757507141288937)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>31
,p_column_identifier=>'AD'
,p_column_label=>'Edit Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(675987101392870246)
,p_db_column_name=>'NAME'
,p_display_order=>41
,p_column_identifier=>'AH'
,p_column_label=>'Name'
,p_column_link=>'f?p=&APP_ID.:1820:&SESSION.::&DEBUG.:1820:P1820_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(656869556441815422)
,p_db_column_name=>'ICON_CLASS'
,p_display_order=>51
,p_column_identifier=>'AI'
,p_column_label=>'Icon Class'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(18355931688248864)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>71
,p_column_identifier=>'V'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5730594150070720)
,p_db_column_name=>'SUBSCRIBED_FROM'
,p_display_order=>101
,p_column_identifier=>'AN'
,p_column_label=>'Subscribed From'
,p_column_type=>'STRING'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5730643134070721)
,p_db_column_name=>'SUBSCRIBERS'
,p_display_order=>111
,p_column_identifier=>'AO'
,p_column_label=>'Subscribers'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5730705448070722)
,p_db_column_name=>'SUBSCRIPTION_STATUS'
,p_display_order=>121
,p_column_identifier=>'AP'
,p_column_label=>'Subscription Status'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(11092455294588013)
,p_db_column_name=>'LAST_UPDATED'
,p_display_order=>131
,p_column_identifier=>'AQ'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(15700317824328377)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_type=>'REPORT'
,p_report_alias=>'1294102896536645'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_view_mode=>'ICON'
,p_report_columns=>'NAME:TARGET_TYPE:TARGET_NAME:SUBSCRIBED_FROM:SUBSCRIBERS:SUBSCRIPTION_STATUS:LAST_UPDATED:LAST_UPDATED_BY:'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17988296763694202)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(10878966511822167)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(500681507068475106)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>A Data Load Definition is comprised of a Data Load Definition, Data Profile and Data Profile Columns.  Data can be loaded either to an existing table in your schema or to a collection.  You can define SQL Expression, SQL Query, Lookups or Transfor'
||'mation Rules for each data profile column.  These definitions are used in the Native Data Loading page process type. </p>',
'',
'<p>When you create a Data Load Definition, the wizard allows you to optionally add a Data Loading page in your application.  If a Data Load definition exists, you can use Create Page wizard to add a Data Loading page.  A single page will be created w'
||'ith Native Data Loading page process to provide the ability to upload data from a file or by copy and paste, and then upload the data. This page allows end users to manage the loading of data. This page can be customized after it is created to meet t'
||'he needs of your application.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2312248175756780281)
,p_plug_name=>'Learn More'
,p_parent_plug_id=>wwv_flow_imp.id(500681507068475106)
,p_region_attributes=>'style="padding: 0 12px 12px 12px;"'
,p_plug_display_sequence=>70
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'sys.htp.p(''<p><a href="&SYSTEM_HELP_URL." target="_blank">''||wwv_flow_lang.system_message(''LEARN MORE'')||'' ...</a></p>'');'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(656871080203834340)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(15698603515328105)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:&APP_PAGE_ID.:&SESSION.::&DEBUG.:&APP_PAGE_ID.,RR::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1619219349859208)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(15698603515328105)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1815:&SESSION.::&DEBUG.:1815::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(10872122675888671)
,p_name=>'Refresh Subscriptions'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(17988296763694202)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(10872591669888669)
,p_event_id=>wwv_flow_imp.id(10872122675888671)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(15698603515328105)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(10873077144888669)
,p_event_id=>wwv_flow_imp.id(10872122675888671)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ( this.data.successMessage ) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
);
end;
/
prompt --application/pages/page_01801
begin
wwv_flow_imp_page.create_page(
 p_id=>1801
,p_name=>'Edit Legacy Data Load'
,p_alias=>'EDIT-LEGACY-DATA-LOAD'
,p_step_title=>'Edit Legacy Data Load'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46335131200026266)
,p_plug_name=>'Column Name Aliases'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>End users may have issues with correctly identifying the columns to upload based on the table''s column names. Therefore, you can define aliases for each column. These will be displayed to the end user while uploading the spreadsheet data.</p>',
'<p>If a list of values is created, the aliases will automatically be picked up by the application during data column mapping, otherwise the application will use the table column names. Once created, the list of values can also be edited and a column '
||'can be removed from the list.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(96308428780065452)
,p_plug_name=>'Legacy Data Load'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(96986111642098411)
,p_plug_name=>'Comments'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(129367214868475906)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(212980031120458358)
,p_plug_name=>'Manage Concurrency'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This option gives the developer the option to specify a column that can used to check against the version of the data in the underlying table. This is particularly important if uploading into a table that is regularly updated.</p>',
'<p>For any updates, the column used to check concurrency will be queried and compared against the database value, for that column, before committing the record. If between the time the record is queried and the data upload is processed the concurrent'
||' column is changed, then the record will be flagged and not committed. If the concurrency column is not specified then the data upload will always update all records, potentially overwriting any changes made by other users.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(493074815148585066)
,p_name=>'Table Lookups'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id, ',
'       flow_id, ',
'       load_table_id, ',
'       (select table_name from wwv_flow_load_tables where id = l.load_table_id) table_name, ',
'       load_column_name,',
'       LOOKUP_TABLE_NAME, ',
'       KEY_COLUMN, ',
'       DISPLAY_COLUMN, ',
'       ALTERNATIVE_KEY_COLUMN1, ',
'       ALTERNATIVE_DISPLAY_COLUMN1, ',
'       ALTERNATIVE_KEY_COLUMN2, ',
'       ALTERNATIVE_DISPLAY_COLUMN2, ',
'       INSERT_NEW_VALUE, ',
'       ERROR_MESSAGE,',
'       CREATED_ON, ',
'       CREATED_BY, ',
'       LAST_UPDATED_ON, ',
'       LAST_UPDATED_BY ',
'from WWV_FLOW_LOAD_TABLE_LOOKUPS l',
'where FLOW_ID = :fb_flow_id ',
'and security_group_id = :flow_security_group_id ',
'and LOAD_TABLE_ID = (select ID from WWV_FLOW_LOAD_TABLES where flow_id = :fb_flow_id and name = :P1801_NAME)'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No Lookup Table definitions defined.'
,p_query_num_rows_type=>'ROW_RANGES'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(493075123218585071)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(493075217658585071)
,p_query_column_id=>2
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Flow Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(493075310107585071)
,p_query_column_id=>3
,p_column_alias=>'LOAD_TABLE_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Load Table Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(493075431004585071)
,p_query_column_id=>4
,p_column_alias=>'TABLE_NAME'
,p_column_display_sequence=>4
,p_column_heading=>'Table Name'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(493075523172585071)
,p_query_column_id=>5
,p_column_alias=>'LOAD_COLUMN_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Column Name'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:1802:&SESSION.::&DEBUG.:1802:P1802_ID:#ID#:'
,p_column_linktext=>'#LOAD_COLUMN_NAME#'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(493075604560585071)
,p_query_column_id=>6
,p_column_alias=>'LOOKUP_TABLE_NAME'
,p_column_display_sequence=>6
,p_column_heading=>'Lookup Table'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(493075732365585071)
,p_query_column_id=>7
,p_column_alias=>'KEY_COLUMN'
,p_column_display_sequence=>7
,p_column_heading=>'Return Column'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(493075804800585071)
,p_query_column_id=>8
,p_column_alias=>'DISPLAY_COLUMN'
,p_column_display_sequence=>8
,p_column_heading=>'Upload Column'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(662086205614215009)
,p_query_column_id=>9
,p_column_alias=>'ALTERNATIVE_KEY_COLUMN1'
,p_column_display_sequence=>17
,p_column_heading=>'Alternative Key Column1'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(662086300832215009)
,p_query_column_id=>10
,p_column_alias=>'ALTERNATIVE_DISPLAY_COLUMN1'
,p_column_display_sequence=>9
,p_column_heading=>'Upload Column 2'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(38883709640369558)
,p_query_column_id=>11
,p_column_alias=>'ALTERNATIVE_KEY_COLUMN2'
,p_column_display_sequence=>18
,p_column_heading=>'Alternative Key Column2'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(38883829752369558)
,p_query_column_id=>12
,p_column_alias=>'ALTERNATIVE_DISPLAY_COLUMN2'
,p_column_display_sequence=>10
,p_column_heading=>'Upload Column 3'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(493076120606585073)
,p_query_column_id=>13
,p_column_alias=>'INSERT_NEW_VALUE'
,p_column_display_sequence=>11
,p_column_heading=>'Insert New Value'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(84259319526460470)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(493076223605585073)
,p_query_column_id=>14
,p_column_alias=>'ERROR_MESSAGE'
,p_column_display_sequence=>12
,p_column_heading=>'Error Message'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(493076314985585073)
,p_query_column_id=>15
,p_column_alias=>'CREATED_ON'
,p_column_display_sequence=>13
,p_column_heading=>'Created On'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(493076423974585073)
,p_query_column_id=>16
,p_column_alias=>'CREATED_BY'
,p_column_display_sequence=>14
,p_column_heading=>'Created By'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(493076506398585073)
,p_query_column_id=>17
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>15
,p_column_heading=>'Last Updated On'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(493076607011585073)
,p_query_column_id=>18
,p_column_alias=>'LAST_UPDATED_BY'
,p_column_display_sequence=>16
,p_column_heading=>'Last Updated By'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(493385303214695103)
,p_name=>'Transformation Rules'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select	 c.ID ID, c.FLOW_ID FLOW_ID,',
'	 c.LOAD_TABLE_ID LOAD_TABLE_ID,',
'	 c.LOAD_COLUMN_NAME LOAD_COLUMN_NAME,',
'	 c.RULE_NAME RULE_NAME,',
'	 c.RULE_TYPE RULE_TYPE,',
'         c.RULE_SEQUENCE RULE_SEQUENCE,',
'	 c.RULE_EXPRESSION1 RULE_EXPRESSION1,',
'	 c.RULE_EXPRESSION2 RULE_EXPRESSION2,',
'         c.ERROR_MESSAGE ERROR_MESSAGE,',
'	 c.CREATED_BY CREATED_BY,',
'	 c.CREATED_ON CREATED_ON,',
'	 c.LAST_UPDATED_BY LAST_UPDATED_BY,',
'	 c.LAST_UPDATED_ON LAST_UPDATED_ON ',
' from	 WWV_FLOW_LOAD_TABLE_RULES c',
'where c.FLOW_ID = :fb_flow_id and security_group_id = :flow_security_group_id and c.load_table_id = (select ID from WWV_FLOW_LOAD_TABLES where flow_id = :fb_flow_id and name = :P1801_NAME)'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No Transformation Rules defined.'
,p_query_num_rows_type=>'ROW_RANGES'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(493385515152695105)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(493385605250695105)
,p_query_column_id=>2
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Flow Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(493385731027695105)
,p_query_column_id=>3
,p_column_alias=>'LOAD_TABLE_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Load Table Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(493385906416695105)
,p_query_column_id=>4
,p_column_alias=>'LOAD_COLUMN_NAME'
,p_column_display_sequence=>7
,p_column_heading=>'Column Name'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(493435222261700674)
,p_query_column_id=>5
,p_column_alias=>'RULE_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Rule Name'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:1804:&SESSION.::&DEBUG.:1804:P1804_ID:#ID#:'
,p_column_linktext=>'#RULE_NAME#'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(493435303291700675)
,p_query_column_id=>6
,p_column_alias=>'RULE_TYPE'
,p_column_display_sequence=>6
,p_column_heading=>'Rule Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(141003727830690827)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(493435412279700675)
,p_query_column_id=>7
,p_column_alias=>'RULE_SEQUENCE'
,p_column_display_sequence=>4
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(493435511268700675)
,p_query_column_id=>8
,p_column_alias=>'RULE_EXPRESSION1'
,p_column_display_sequence=>13
,p_column_heading=>'Expression 1'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(493435622610700675)
,p_query_column_id=>9
,p_column_alias=>'RULE_EXPRESSION2'
,p_column_display_sequence=>14
,p_column_heading=>'Expression 2'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(493386617850695106)
,p_query_column_id=>10
,p_column_alias=>'ERROR_MESSAGE'
,p_column_display_sequence=>8
,p_column_heading=>'Error Message'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(493386810369695106)
,p_query_column_id=>11
,p_column_alias=>'CREATED_BY'
,p_column_display_sequence=>10
,p_column_heading=>'Created By'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(493386707074695106)
,p_query_column_id=>12
,p_column_alias=>'CREATED_ON'
,p_column_display_sequence=>9
,p_column_heading=>'Created On'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(493387011522695106)
,p_query_column_id=>13
,p_column_alias=>'LAST_UPDATED_BY'
,p_column_display_sequence=>12
,p_column_heading=>'Last Updated By'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(493386918910695106)
,p_query_column_id=>14
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>11
,p_column_heading=>'Last Updated On'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(675812623094852885)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(675812107017852883)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(686207505452915171)
,p_plug_name=>'Data Load Definition'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(937792233418878647)
,p_plug_name=>'Unique Keys'
,p_parent_plug_id=>wwv_flow_imp.id(686207505452915171)
,p_region_css_classes=>'a-Form--floatColsLeft'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>12
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(937792496146878649)
,p_plug_name=>'Table Owner and Name'
,p_parent_plug_id=>wwv_flow_imp.id(686207505452915171)
,p_region_template_options=>'#DEFAULT#:a-Form--fixedLabels'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(498862119040967671)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(493385303214695103)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'Create Transformation Rule'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:1804:&SESSION.::&DEBUG.:1804:P1804_LOAD_TABLE_ID:&P1801_ID.'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(498809524103959661)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(493074815148585066)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'Create Table Lookup'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:1802:&SESSION.::&DEBUG.:RP,1802:P1802_LOAD_TABLE_ID:&P1801_ID.'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(217833922942091197)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(46335131200026266)
,p_button_name=>'EDIT_COLUMN_NAMES'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'Edit  List of Values'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:1805:&SESSION.::&DEBUG.:1805:F4000_P1805_LIST_ID:&P1801_LOV_NAME.'
,p_button_condition=>'P1801_LOV_NAME'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(46336314970049909)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_imp.id(46335131200026266)
,p_button_name=>'CREATE_COLUMN_NAMES'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'Create List of Values'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:1805:&SESSION.::&DEBUG.:1805:P1805_TABLE_ID:&P1801_ID.'
,p_button_condition=>'P1801_LOV_NAME'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(686208102280915173)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(96308428780065452)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1800:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(686207925691915173)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(96308428780065452)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.confirm(htmldb_delete_message,''DELETE'');'
,p_button_execute_validations=>'N'
,p_button_condition=>'P1801_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(686207815836915173)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(96308428780065452)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P1801_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(686207714765915173)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(96308428780065452)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>'P1801_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(686208702198915174)
,p_branch_action=>'f?p=&APP_ID.:1800:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(187824532164864910)
,p_name=>'P1801_LOV_NAME'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(46335131200026266)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Column Alias List Of Values:'
,p_source=>'COLUMN_NAMES_LOV_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>'select lov_name, id from WWV_FLOW_LISTS_OF_VALUES$ where flow_id = :FB_FLOW_ID'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'The List of Values for Data Loading column aliases. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(212981105990472890)
,p_name=>'P1801_VERSION_COLUMN_NAME'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(212980031120458358)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Concurrency Column Name'
,p_source=>'VERSION_COLUMN_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1801_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P1801_OWNER',
'   and table_name = :P1801_TABLE_NAME'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Column Selected-'
,p_lov_cascade_parent_items=>'P1801_TABLE_NAME'
,p_ajax_items_to_submit=>'P1801_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'You can choose the column which will be used as concurrency management column by data loading feature'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(380392782865619476)
,p_name=>'P1801_SKIP_VALIDATION'
,p_is_required=>true
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(686207505452915171)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Skip Validation'
,p_source=>'SKIP_VALIDATION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DATA LOAD SKIP VALIDATION'
,p_lov=>'.'||wwv_flow_imp.id(380391855980609161)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'One of the steps in data loading, is to validate actions to be taken on records to be uploaded. Most of the time, the end user might want just to upload his records directly to the table without going through the validation step especially if uploadi'
||'ng thousands of records.',
'Set this value to Yes if you would like to skip validation.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(686208932694915176)
,p_name=>'P1801_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(686207505452915171)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(686212913230915182)
,p_name=>'P1801_FLOW_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(686207505452915171)
,p_use_cache_before_default=>'NO'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(686213118811915183)
,p_name=>'P1801_NAME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(686207505452915171)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The name for the data load definition.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(686213328710915184)
,p_name=>'P1801_OWNER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(686207505452915171)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Owner'
,p_source=>'OWNER'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_data_upload.get_owner_name(',
'                        p_owner_name    => :P1801_OWNER,',
'                        p_flow_id       => :FB_FLOW_ID);'))
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The owner of the table on which the data load definition will be based on.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(686213508347915185)
,p_name=>'P1801_TABLE_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(686207505452915171)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Table Name'
,p_source=>'TABLE_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The underlying table to be used for data load definition.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(686213725156915185)
,p_name=>'P1801_UNIQUE_COLUMN_1'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(686207505452915171)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Unique Column 1'
,p_source=>'UNIQUE_COLUMN_1'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1801_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P1801_OWNER',
'   and table_name = :P1801_TABLE_NAME'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'-Select Column-'
,p_lov_cascade_parent_items=>'P1801_TABLE_NAME'
,p_ajax_items_to_submit=>'P1801_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'The column name to be used as the primary unique key column during the data load process.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(686213919369915185)
,p_name=>'P1801_IS_UK1_CASE_SENSITIVE'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(686207505452915171)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Case Sensitive'
,p_source=>'IS_UK1_CASE_SENSITIVE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DATA LOAD CASE SENSITIVITY OPTION'
,p_lov=>'.'||wwv_flow_imp.id(15543021487067885)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>' a-Form--floatColsLeft'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Identify whether the selected unique key column 1 is case sensitive.  By default, this is set to <strong>No</strong>.',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(686214112898915185)
,p_name=>'P1801_UNIQUE_COLUMN_2'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(686207505452915171)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Unique Column 2'
,p_source=>'UNIQUE_COLUMN_2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1801_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P1801_OWNER',
'   and table_name = :P1801_TABLE_NAME'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'-Select Column-'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'If the unique key definition of the selected table is a compound key, consisting of 2 or more columns, this column name is to be used as the second unique key column during the data load process.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(686214328418915185)
,p_name=>'P1801_IS_UK2_CASE_SENSITIVE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(686207505452915171)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Case Sensitive'
,p_source=>'IS_UK2_CASE_SENSITIVE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DATA LOAD CASE SENSITIVITY OPTION'
,p_lov=>'.'||wwv_flow_imp.id(15543021487067885)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Identify whether the selected unique key column 2 is case sensitive.  By default, this is set to <strong>No</strong>.',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(686214509669915185)
,p_name=>'P1801_UNIQUE_COLUMN_3'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(686207505452915171)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Unique Column 3'
,p_source=>'UNIQUE_COLUMN_3'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1801_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P1801_OWNER',
'   and table_name = :P1801_TABLE_NAME'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'-Select Column-'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'If the unique key definition of the selected table is a compound key, consisting of 2 or more columns, this column name is to be used as the third unique key column during the data load process.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(686214719744915185)
,p_name=>'P1801_IS_UK3_CASE_SENSITIVE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(686207505452915171)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Case Sensitive'
,p_source=>'IS_UK3_CASE_SENSITIVE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DATA LOAD CASE SENSITIVITY OPTION'
,p_lov=>'.'||wwv_flow_imp.id(15543021487067885)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Identify whether the selected unique key column 3 is case sensitive.  By default, this is set to <strong>No</strong>.',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(686215100763915186)
,p_name=>'P1801_COMMENTS'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(96986111642098411)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comments'
,p_source=>'COMMENTS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(219503727051655078)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'1801'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(386755397326132356)
,p_name=>'skip validation TR option'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1801_SKIP_VALIDATION'
,p_condition_element=>'P1801_SKIP_VALIDATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(386755669179132358)
,p_event_id=>wwv_flow_imp.id(386755397326132356)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(493385303214695103)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(386755891151132360)
,p_event_id=>wwv_flow_imp.id(386755397326132356)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(493385303214695103)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(386756063741143719)
,p_name=>'skip validation DL option'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1801_SKIP_VALIDATION'
,p_condition_element=>'P1801_SKIP_VALIDATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(386756383317143719)
,p_event_id=>wwv_flow_imp.id(386756063741143719)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(493074815148585066)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(386756594594143719)
,p_event_id=>wwv_flow_imp.id(386756063741143719)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(493074815148585066)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(386756680636151834)
,p_name=>'skip validation Concurrency option'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1801_SKIP_VALIDATION'
,p_condition_element=>'P1801_SKIP_VALIDATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(386756929759151835)
,p_event_id=>wwv_flow_imp.id(386756680636151834)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(212980031120458358)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(386757198881151835)
,p_event_id=>wwv_flow_imp.id(386756680636151834)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(212980031120458358)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(686215415998915186)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_LOAD_TABLES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_LOAD_TABLES'
,p_attribute_03=>'P1801_ID'
,p_attribute_04=>'ID'
,p_attribute_14=>'N'
,p_internal_uid=>686215415998915186
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(686215619212915187)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_LOAD_TABLES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_LOAD_TABLES'
,p_attribute_03=>'P1801_ID'
,p_attribute_04=>'ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>686215619212915187
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(686215813462915187)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'1801'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(686207925691915173)
,p_internal_uid=>686215813462915187
);
end;
/
prompt --application/pages/page_01802
begin
wwv_flow_imp_page.create_page(
 p_id=>1802
,p_name=>'Add / Edit Table Lookups'
,p_alias=>'ADD-EDIT-TABLE-LOOKUPS'
,p_step_title=>'Add / Edit Table Lookups'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(693382831264736379)
,p_plug_name=>'Data Load Table'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(693546805900748049)
,p_plug_name=>'Table Lookup'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(693572011787749755)
,p_plug_name=>'Error Message'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(693673315035760103)
,p_plug_name=>'Where Clause'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(694531718385903026)
,p_plug_name=>'Table Lookup'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(694621618170912396)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>11
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(693383431777736379)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(694531718385903026)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1801:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(693383226454736379)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(694531718385903026)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.confirm(htmldb_delete_message,''DELETE'');'
,p_button_execute_validations=>'N'
,p_button_condition=>'P1802_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(693383102459736379)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(694531718385903026)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P1802_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(693383013235736379)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(694531718385903026)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>'P1802_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(693384017518736381)
,p_branch_action=>'f?p=&APP_ID.:1801:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(693383013235736379)
,p_branch_sequence=>1
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(780702422748930727)
,p_branch_action=>'f?p=&APP_ID.:1801:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(693383102459736379)
,p_branch_sequence=>11
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(693384228748736382)
,p_name=>'P1802_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(693382831264736379)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(693384417125736388)
,p_name=>'P1802_FLOW_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(693382831264736379)
,p_use_cache_before_default=>'NO'
,p_item_default=>':fb_flow_id'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(693384600650736389)
,p_name=>'P1802_LOAD_TABLE_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(693382831264736379)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Data Load Table Name'
,p_source=>'LOAD_TABLE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select TABLE_NAME as display_value, ID as return_value ',
'  from WWV_FLOW_LOAD_TABLES',
'where flow_id = :fb_flow_id',
' order by 1'))
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'The underlying Table for data load definition.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(693384808496736389)
,p_name=>'P1802_LOAD_COLUMN_NAME'
,p_is_required=>true
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(693382831264736379)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Column Name'
,p_source=>'LOAD_COLUMN_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc a, column_name b',
'  from wwv_flow_table_columns_dev',
' where table_name = (',
'      select table_name ',
'        from wwv_flow_load_tables ',
'       where id                = :P1802_LOAD_TABLE_ID',
'         and security_group_id = :FLOW_SECURITY_GROUP_ID ) ',
'   and owner = ( ',
'      select wwv_flow_data_upload.get_owner_name( p_owner_name => owner, p_flow_id => :FB_FLOW_ID ) ',
'        from wwv_flow_load_tables ',
'       where id                = :P1802_LOAD_TABLE_ID',
'         and security_group_id = :FLOW_SECURITY_GROUP_ID ) ',
' order by column_id',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'-Select Column-'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'The table column on which the table lookup definition is to be based.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(693385009989736389)
,p_name=>'P1802_LOOKUP_OWNER'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(693546805900748049)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Owner'
,p_source=>'LOOKUP_OWNER'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_data_upload.get_owner_name(',
'                        p_owner_name    => :P1802_LOOKUP_OWNER,',
'                        p_flow_id       => :FB_FLOW_ID);'))
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_SCHEMAS_HAVE_PRIVS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(owner) d, owner v',
'  from wwv_flow_object_owners_dev',
'order by d                   '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Owner -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The table owner of the lookup table.',
'',
'During data loading, a lookup can be done to retrieve value from another table. '))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(693385223779736390)
,p_name=>'P1802_LOOKUP_TABLE_NAME'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(693546805900748049)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Table Name'
,p_source=>'LOOKUP_TABLE_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = :P1802_LOOKUP_OWNER'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table -'
,p_lov_cascade_parent_items=>'P1802_LOOKUP_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Choose the lookup table.',
'',
'During data loading, a lookup can be done to retrieve value from another table. ',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(693385400997736390)
,p_name=>'P1802_KEY_COLUMN'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(693546805900748049)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Return Column'
,p_source=>'KEY_COLUMN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1802_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P1802_LOOKUP_OWNER',
'   and table_name = :P1802_LOOKUP_TABLE_NAME',
'   and data_type <> ''BLOB'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1802_LOOKUP_TABLE_NAME'
,p_ajax_items_to_submit=>'P1802_LOOKUP_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select the name of the column returned by the table lookup. This value will be inserted into the load column specified, and is generally the key value of the parent in a foreign key relationship. For example: DEPTNO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(693385608923736390)
,p_name=>'P1802_DISPLAY_COLUMN'
,p_is_required=>true
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(693546805900748049)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Upload Column'
,p_source=>'DISPLAY_COLUMN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1802_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P1802_LOOKUP_OWNER',
'   and table_name = :P1802_LOOKUP_TABLE_NAME',
'   and data_type <> ''BLOB'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1802_LOOKUP_TABLE_NAME'
,p_ajax_items_to_submit=>'P1802_LOOKUP_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select the name of the column end users will upload instead of the return column. This is the column that contains the display value from the lookup table. For example: DNAME'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(693385811322736390)
,p_name=>'P1802_ALTERNATIVE_KEY_COLUMN1'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(693546805900748049)
,p_use_cache_before_default=>'NO'
,p_source=>'ALTERNATIVE_KEY_COLUMN1'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(693386031030736390)
,p_name=>'P1802_ALT_DISPLAY_COL1'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(693546805900748049)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Upload Column 2'
,p_source=>'ALTERNATIVE_DISPLAY_COLUMN1'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1802_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P1802_LOOKUP_OWNER',
'   and table_name = :P1802_LOOKUP_TABLE_NAME',
'   and data_type <> ''BLOB'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1802_LOOKUP_TABLE_NAME'
,p_ajax_items_to_submit=>'P1802_LOOKUP_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select the name of the second column to be uploaded to uniquely identify the return column if necessary. For example, to uniquely identify a State Code it may be necessary to upload the State Name and Country.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(693386200297736390)
,p_name=>'P1802_ALTERNATIVE_KEY_COLUMN2'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(693546805900748049)
,p_use_cache_before_default=>'NO'
,p_source=>'ALTERNATIVE_KEY_COLUMN2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(693386423451736390)
,p_name=>'P1802_ALT_DISPLAY_COL2'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(693546805900748049)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Upload Column 3'
,p_source=>'ALTERNATIVE_DISPLAY_COLUMN2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1802_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P1802_LOOKUP_OWNER',
'   and table_name = :P1802_LOOKUP_TABLE_NAME',
'   and data_type <> ''BLOB'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1802_LOOKUP_TABLE_NAME'
,p_ajax_items_to_submit=>'P1802_LOOKUP_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select the name of the third column to be uploaded to uniquely identify the return column if necessary.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(693386631295736390)
,p_name=>'P1802_WHERE_CLAUSE'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(693673315035760103)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Where Clause'
,p_source=>'WHERE_CLAUSE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The where clause will be used as part of the SQL used to retrieve the Return Column from the lookup table.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(693386801659736391)
,p_name=>'P1802_INSERT_NEW_VALUE'
,p_is_required=>true
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(693546805900748049)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Insert New Value'
,p_source=>'INSERT_NEW_VALUE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DATA LOAD CASE SENSITIVITY OPTION'
,p_lov=>'.'||wwv_flow_imp.id(15543021487067885)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'If set to ''No'' (the default) then a new record will not be created in the lookup table if the lookup column value(s) entered do not already exist. If set to ''Yes'' then a record will be created in the lookup table using the upload column(s) and the Up'
||'load Key Column will be retrieved from the newly created record.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(693387030446736391)
,p_name=>'P1802_ERROR_MESSAGE'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(693572011787749755)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Error Message'
,p_source=>'ERROR_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The error message will be displayed to end users when an error occurs with trying to retrieve the return column from the lookup table using the lookup column(s) provided.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(693387320562736391)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_LOAD_TABLE_LOOKUPS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_LOAD_TABLE_LOOKUPS'
,p_attribute_03=>'P1802_ID'
,p_attribute_04=>'ID'
,p_attribute_14=>'N'
,p_internal_uid=>693387320562736391
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(419130103326690553)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'schema owner or not'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1802_LOOKUP_OWNER := wwv_flow_wizard_api.get_owner(',
'                             p_flow_id     => :FB_FLOW_ID,',
'                             p_owner       => :P1802_LOOKUP_OWNER );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>419130103326690553
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(693387521154736392)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_LOAD_TABLE_LOOKUPS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_LOAD_TABLE_LOOKUPS'
,p_attribute_03=>'P1802_ID'
,p_attribute_04=>'ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>693387521154736392
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(693387716404736392)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'1802'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(693383226454736379)
,p_internal_uid=>693387716404736392
);
end;
/
prompt --application/pages/page_01804
begin
wwv_flow_imp_page.create_page(
 p_id=>1804
,p_name=>'Add / Edit Table Rule'
,p_alias=>'ADD-EDIT-TABLE-RULE'
,p_step_title=>'Add / Edit Table Rule'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(68017006978066809)
,p_plug_name=>'Error Message'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(68109728449073006)
,p_plug_name=>'Data Load Table'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(68143608148076596)
,p_plug_name=>'Transformation Rule'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(68460701484093657)
,p_plug_name=>'Transformation Rule'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(68799700969131291)
,p_plug_name=>'Region Display Selector'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(68017604467066810)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(68460701484093657)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1801:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(68017424045066810)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(68460701484093657)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.confirm(htmldb_delete_message,''DELETE'');'
,p_button_execute_validations=>'N'
,p_button_condition=>'P1804_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(68017318691066810)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(68460701484093657)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P1804_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(68017210156066810)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(68460701484093657)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>'P1804_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(68018229295066812)
,p_branch_action=>'f?p=&APP_ID.:1801:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(68017210156066810)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(780763005218935144)
,p_branch_action=>'f?p=&APP_ID.:1801:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(68017318691066810)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(15288428943315710)
,p_branch_action=>'f?p=&APP_ID.:1801:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(68017424045066810)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(23843007488481588)
,p_name=>'P1804_RULE_EXPRESSION3'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(68143608148076596)
,p_prompt=>'Trim Condition'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TRIM_CONDITIONS'
,p_lov=>'.'||wwv_flow_imp.id(23846801132546001)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Based on the specific transformation rule type selected above, enter the appropriate value.',
'Refer to the examples given below'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(68018411168066814)
,p_name=>'P1804_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(68109728449073006)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(68018627136066821)
,p_name=>'P1804_FLOW_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(68109728449073006)
,p_use_cache_before_default=>'NO'
,p_item_default=>':fb_flow_id'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(68018831291066823)
,p_name=>'P1804_LOAD_TABLE_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(68109728449073006)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Table Name'
,p_source=>'LOAD_TABLE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select TABLE_NAME display_value, ID return_value ',
'from WWV_FLOW_LOAD_TABLES',
'where flow_id = :fb_flow_id',
'order by 1'))
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'The underlying Table for data load definition.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(68019017653066823)
,p_name=>'P1804_LOAD_COLUMN_NAME'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(68109728449073006)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Column Name'
,p_source=>'LOAD_COLUMN_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SHUTTLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc a, column_name b from wwv_flow_table_columns_dev',
'where table_name = (select table_name from wwv_flow_load_tables where id = :P1804_LOAD_TABLE_ID) ',
'and owner = :P1804_OWNER',
'order by column_id'))
,p_lov_cascade_parent_items=>'P1804_LOAD_TABLE_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>10
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose the table column on which the transformation rule will be applied to.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ALL'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(68019231622066823)
,p_name=>'P1804_RULE_NAME'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(68143608148076596)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Rule Name'
,p_source=>'RULE_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the name of this transformation rule.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(68019416006066823)
,p_name=>'P1804_RULE_TYPE'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(68143608148076596)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Rule Type'
,p_source=>'RULE_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DATA LOADING RULES TYPES'
,p_lov=>'.'||wwv_flow_imp.id(141003727830690827)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select the type of transformation rule to be created.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(68019625975066824)
,p_name=>'P1804_RULE_SEQUENCE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(68143608148076596)
,p_use_cache_before_default=>'NO'
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   s number := 0;',
'begin',
'',
'   for c1 in (select max(RULE_SEQUENCE) s',
'              from   wwv_flow_load_table_rules',
'              where  flow_id = nv(''FB_FLOW_ID'') ',
'              and    load_table_id = v(''P1804_LOAD_TABLE_ID'') or v(''P1804_LOAD_TABLE_ID'') is null)loop',
'              s := c1.s;',
'   end loop;',
'      s := nvl(s,0);',
'   return trunc(s) + 10;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Rule Sequence'
,p_source=>'RULE_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>6
,p_cMaxlength=>6
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify the sequence for the transformation rule. The sequence determines the order of evaluation.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(68019822836066824)
,p_name=>'P1804_RULE_EXPRESSION1'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(68143608148076596)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Expression 1'
,p_source=>'RULE_EXPRESSION1'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Based on the specific transformation rule type selected above, enter the appropriate value.',
'Refer to the examples given below'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(68020003943066824)
,p_name=>'P1804_RULE_EXPRESSION2'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(68143608148076596)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Expression 2'
,p_source=>'RULE_EXPRESSION2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Based on the specific transformation rule type selected above, enter the appropriate value.',
'Refer to the examples given below'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(68020228499066824)
,p_name=>'P1804_ERROR_MESSAGE'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(68017006978066809)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Error Message'
,p_source=>'ERROR_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Enter the text to be displayed in the event the transformation rule fails.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(122019130902703516)
,p_name=>'P1804_OWNER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(68109728449073006)
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_owner   varchar2(255) := null;',
'begin',
'  select owner into l_owner from wwv_flow_load_tables where id = :P1804_LOAD_TABLE_ID;',
'  l_owner := wwv_flow_data_upload.get_owner_name(',
'                        p_owner_name    => l_owner,',
'                        p_flow_id       => :FB_FLOW_ID);',
'  return l_owner;',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(582267193131682842)
,p_validation_name=>'Validate PL/SQL Function Body'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_f4000_util.check_plsql(',
'     :P1804_RULE_EXPRESSION1,',
'     :FB_FLOW_ID,',
'     :FLOW_SECURITY_GROUP_ID',
' );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':REQUEST in (''SAVE'',''CREATE'') and :P1804_RULE_TYPE = ''PLSQL_FUNCTION_BODY'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(68019822836066824)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(582267272162682843)
,p_validation_name=>'Validate PL/SQL and SQL Expressions'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_f4000_util.validate_plsql_expressions(',
'    :P1804_RULE_EXPRESSION1,',
'    :P1804_RULE_TYPE',
');'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':REQUEST in (''SAVE'',''CREATE'') and :P1804_RULE_TYPE  in (''PLSQL_EXPRESSION'', ''SQL_QUERY_SINGLE_VALUE'', ''SQL_QUERY_SEMI_COLON'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(68019822836066824)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(23849423736609348)
,p_name=>'Rule Expression 1'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1804_RULE_TYPE'
,p_condition_element=>'P1804_RULE_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'REPLACE,PLSQL_EXPRESSION,REGULAR_EXPRESSION, SQL_QUERY_SINGLE_VALUE, SQL_QUERY_SEMI_COLON, PLSQL_FUNCTION_BODY, TRIM, LTRIM, RTRIM'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(23849720138609348)
,p_event_id=>wwv_flow_imp.id(23849423736609348)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1804_RULE_EXPRESSION1'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(23849903215609348)
,p_event_id=>wwv_flow_imp.id(23849423736609348)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1804_RULE_EXPRESSION1'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(23845419786522966)
,p_name=>'Rule Expression 2'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1804_RULE_TYPE'
,p_condition_element=>'P1804_RULE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REPLACE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(23845709644522966)
,p_event_id=>wwv_flow_imp.id(23845419786522966)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1804_RULE_EXPRESSION2'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(23845909697522966)
,p_event_id=>wwv_flow_imp.id(23845419786522966)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1804_RULE_EXPRESSION2'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(23846207581538445)
,p_name=>'Rule Expression (trim conditions)'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1804_RULE_TYPE'
,p_condition_element=>'P1804_RULE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TRIM'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(23846509201538445)
,p_event_id=>wwv_flow_imp.id(23846207581538445)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1804_RULE_EXPRESSION3'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(23846709717538445)
,p_event_id=>wwv_flow_imp.id(23846207581538445)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1804_RULE_EXPRESSION3'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(68020510214066825)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_LOAD_TABLE_RULES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_LOAD_TABLE_RULES'
,p_attribute_03=>'P1804_ID'
,p_attribute_04=>'ID'
,p_attribute_14=>'N'
,p_internal_uid=>68020510214066825
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1832889557995266926)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Trim Rule for TRIM Transformations'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P1804_RULE_TYPE = ''TRIM'' then',
'   :P1804_RULE_EXPRESSION3 := :P1804_RULE_EXPRESSION2;',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>1832889557995266926
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(23851620712665155)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'if trim set expression 2'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P1804_RULE_TYPE = ''TRIM'' then',
'   :P1804_RULE_EXPRESSION2 := :P1804_RULE_EXPRESSION3;',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_type=>'NEVER'
,p_internal_uid=>23851620712665155
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(12643223518559838)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'plsql_expression_rules'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_expr_string   varchar2(4000) := null;',
'    l_owner         varchar2(255);',
'    l_table_name    varchar2(255);',
'    l_lov_id        number;',
'    l_position      number;',
'    type l_arr_int_cols is table of varchar2(255) index by binary_integer;',
'    type l_arr_position is table of number index by binary_integer;',
'    l_arr_pos      l_arr_position;',
'    l_int_cols     l_arr_int_cols;',
'    i              pls_integer := 0;',
'begin',
' if :P1804_RULE_TYPE in (''PLSQL_EXPRESSION'', ''PLSQL_FUNCTION_BODY'', ''SQL_QUERY_SINGLE_VALUE'', ''SQL_QUERY_SEMI_COLON'', ''REGULAR_EXPRESSION'') then',
'    select owner, table_name, COLUMN_NAMES_LOV_ID into l_owner, l_table_name, l_lov_id',
'     from wwv_flow_load_tables',
'    where id = :P1804_LOAD_TABLE_ID;',
'    if ( instr(l_owner,''#'') = 1 and instr(l_owner,''#'',2) = 7 ) then',
'        select owner into l_owner from wwv_flows where id = :FB_FLOW_ID;',
'    end if;',
'    if l_lov_id is not null then',
'        for c1 in (select lov_return_value  ',
'                    from wwv_flow_list_of_values_data ',
'                   where lov_id = l_lov_id )',
'        loop',
'            l_position := instr(:P1804_RULE_EXPRESSION1, '':''||c1.lov_return_value, 1);',
'            while l_position > 0',
'            loop',
'                if l_int_cols.exists(l_position) = false then',
'                    i := i + 1;',
'                    l_arr_pos(i) := l_position;',
'                    l_int_cols(l_position) := c1.lov_return_value;',
'                else',
'                    if instr(c1.lov_return_value, l_int_cols(l_position), 1) > 0 then',
'                        l_int_cols(l_position) := c1.lov_return_value;',
'                    end if;',
'                end if;',
'                l_position := instr(:P1804_RULE_EXPRESSION1, '':''||c1.lov_return_value, l_position + 1);',
'            end loop;',
'        end loop;    ',
'    else',
'        for c1 in (select column_name',
'                   from wwv_flow_table_columns_dev',
'                    where table_name = l_table_name',
'                     and owner = l_owner)',
'        loop',
'            l_position := instr(:P1804_RULE_EXPRESSION1, '':''||c1.column_name, 1);',
'            while l_position > 0',
'            loop',
'                if l_int_cols.exists(l_position) = false then',
'                    i := i + 1;',
'                    l_arr_pos(i) := l_position;',
'                    l_int_cols(l_position) := c1.column_name;',
'                else',
'                    if instr(c1.column_name, l_int_cols(l_position), 1) > 0 then',
'                        l_int_cols(l_position) := c1.column_name;',
'                    end if;',
'                end if;',
'                l_position := instr(:P1804_RULE_EXPRESSION1, '':''||c1.column_name, l_position + 1);',
'            end loop;',
'        end loop;',
'    end if;',
'    for i in 1..l_arr_pos.count',
'    loop',
'        l_expr_string := l_expr_string||'':''||l_int_cols(l_arr_pos(i));',
'    end loop; ',
'    :P1804_RULE_EXPRESSION2 := l_expr_string;',
' elsif :P1804_RULE_TYPE = ''TRIM'' then',
'   :P1804_RULE_EXPRESSION2 := :P1804_RULE_EXPRESSION3;',
' end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>12643223518559838
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(68020719781066825)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_LOAD_TABLE_RULES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_LOAD_TABLE_RULES'
,p_attribute_03=>'P1804_ID'
,p_attribute_04=>'ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>68020719781066825
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(68020926766066825)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'1804'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(68017424045066810)
,p_internal_uid=>68020926766066825
);
end;
/
prompt --application/pages/page_01805
begin
wwv_flow_imp_page.create_page(
 p_id=>1805
,p_name=>'Add / Edit Column Names Aliases'
,p_alias=>'ADD-EDIT-COLUMN-NAMES-ALIASES'
,p_step_title=>'Add / Edit Column Names Aliases'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'No help is available for this page.'
,p_page_component_map=>'01'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46338707145132827)
,p_plug_name=>'Column Names Aliases'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'   l_owner       varchar(255);',
'   l_table_name  varchar(255);',
'   i pls_integer := 0;',
'begin',
'   select owner , table_name into l_owner, l_table_name  ',
'       from wwv_flow_load_tables ',
'       where id = :P1805_TABLE_ID;',
'   if instr(l_owner, ''#'', 2) > 0 then',
'       if instr(l_owner, ''OWNER'') > 0 then',
'           for c1 in (select owner',
'                     from wwv_flows',
'                     where id = :FB_FLOW_ID',
'                     and security_group_id = wwv_flow_security.g_security_group_id)',
'           loop',
'              l_owner := c1.owner;',
'           end loop;',
'       end if;',
'   end if;',
'   sys.htp.p(''<table class="u-Report" cellspacing="0" cellpadding="0" aria-label="''||wwv_flow_lang.system_message(''DATA_LOAD.COLUMN_NAME_ALIASES'')||''">'');',
'   sys.htp.p(''<tr>'');',
'   sys.htp.p(''<th scope="col">''||wwv_flow_lang.system_message(''DATA_LOAD.RETURN'')||''</th>'');',
'   sys.htp.p(''<th scope="col">''||wwv_flow_lang.system_message(''DATA_LOAD.DISPLAY'')||''</th>'');',
'   sys.htp.p(''<th scope="col">''||wwv_flow_lang.system_message(''DATA_LOAD.SEQUENCE'')||''</th>'');',
'   sys.htp.p(''</tr>'');',
'   ',
'   for c1 in ((select column_name d, column_name r ',
'              from wwv_flow_table_columns_dev',
'              where owner = l_owner and table_name = l_table_name)',
'              --union',
'              --(select ''* ''||lookup_table_name||'' - ''||display_column d, load_column_name r ',
'              --from apex_appl_load_table_lookups where load_table_id = :P1805_TABLE_ID )',
'              union',
'              (select ''* ''||lookup_table_name||'' - ''||alternative_display_column1 d, ''* *''||alternative_display_column1 r ',
'               from apex_appl_load_table_lookups where load_table_id = :P1805_TABLE_ID and alternative_display_column1 is not null)',
'              union',
'              (select ''* ''||lookup_table_name||'' - ''||alternative_display_column2 d, ''* *''||alternative_display_column2 r ',
'               from apex_appl_load_table_lookups where load_table_id = :P1805_TABLE_ID and alternative_display_column2 is not null))',
'    loop',
'      i := i + 1;',
'      sys.htp.p(''<tr><th scope="row" align="left">'');',
'      sys.htp.p(',
'         wwv_flow_ITEM.DISPLAY_AND_SAVE(',
'               p_idx         => 1,',
'               p_value       => c1.r)',
'         );',
'     sys.htp.p(''</th><td colspan="1" rowspan="1" align="left">'');',
'     sys.htp.p(',
'        wwv_flow_ITEM.TEXT(',
'             p_idx         => 2,',
'             p_value       => c1.d,',
'             p_size        => 40,',
'             p_maxlength   => 50,',
'             p_attributes  => ''aria-label="''||wwv_flow_lang.system_message(''DATA_LOAD.DISPLAY'')||'': ''||wwv_flow_escape.html(c1.r)||''"'')',
'          );',
'     sys.htp.p(''</td><td colspan="1" rowspan="1" align="right">'');',
'     sys.htp.p(',
'         wwv_flow_ITEM.TEXT(',
'               p_idx         => 3,',
'               p_value       => (i*10),',
'               p_size        => 8,',
'               p_maxlength   => 10,',
'             p_attributes  => ''aria-label="''||wwv_flow_lang.system_message(''DATA_LOAD.SEQUENCE'')||'': ''||wwv_flow_escape.html(c1.r)||''"'')',
'         );',
'     sys.htp.p(''</td></tr>'');',
'   end loop;',
'   sys.htp.p(''</table>'');',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NULL'
,p_plug_display_when_condition=>'F4000_P1805_LIST_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(217639726548776936)
,p_plug_name=>'Column Name Aliases'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_04'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(320717723983124046)
,p_name=>'Column Names Aliases'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'"ID",',
'"ID" ID_DISPLAY,',
'"LOV_ID",',
'"FLOW_ID",',
'"LOV_DISP_SEQUENCE",',
'"LOV_DISP_VALUE",',
'"LOV_RETURN_VALUE"',
'from "#OWNER#"."WWV_FLOW_LIST_OF_VALUES_DATA"',
'where LOV_ID = :F4000_P1805_LIST_ID'))
,p_display_when_condition=>'F4000_P1805_LIST_ID'
,p_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>10
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No Column Name Aliases found.'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(320720730361124052)
,p_query_column_id=>1
,p_column_alias=>'CHECK$01'
,p_column_display_sequence=>1
,p_column_heading=>'Select Row'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'CHECKBOX'
,p_derived_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(320718021735124049)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_column_width=>16
,p_pk_col_source_type=>'T'
,p_ref_schema=>'APEX_040200'
,p_ref_table_name=>'WWV_FLOW_LIST_OF_VALUES_DATA'
,p_ref_column_name=>'ID'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(320718121772124049)
,p_query_column_id=>3
,p_column_alias=>'ID_DISPLAY'
,p_column_display_sequence=>3
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_hidden_column=>'Y'
,p_column_width=>16
,p_ref_schema=>'APEX_040200'
,p_ref_table_name=>'WWV_FLOW_LIST_OF_VALUES_DATA'
,p_ref_column_name=>'ID_DISPLAY'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(320718230571124049)
,p_query_column_id=>4
,p_column_alias=>'LOV_ID'
,p_column_display_sequence=>4
,p_column_heading=>'Lov Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_column_width=>16
,p_ref_schema=>'APEX_040200'
,p_ref_table_name=>'WWV_FLOW_LIST_OF_VALUES_DATA'
,p_ref_column_name=>'LOV_ID'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(320718307946124049)
,p_query_column_id=>5
,p_column_alias=>'FLOW_ID'
,p_column_display_sequence=>5
,p_column_heading=>'Flow Id'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_column_width=>16
,p_ref_schema=>'APEX_040200'
,p_ref_table_name=>'WWV_FLOW_LIST_OF_VALUES_DATA'
,p_ref_column_name=>'FLOW_ID'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(320718422984124049)
,p_query_column_id=>6
,p_column_alias=>'LOV_DISP_SEQUENCE'
,p_column_display_sequence=>7
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT'
,p_column_width=>16
,p_ref_schema=>'APEX_040200'
,p_ref_table_name=>'WWV_FLOW_LIST_OF_VALUES_DATA'
,p_ref_column_name=>'LOV_DISP_SEQUENCE'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(320718515827124049)
,p_query_column_id=>7
,p_column_alias=>'LOV_DISP_VALUE'
,p_column_display_sequence=>8
,p_column_heading=>'Display Value'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT'
,p_column_width=>16
,p_ref_schema=>'APEX_040200'
,p_ref_table_name=>'WWV_FLOW_LIST_OF_VALUES_DATA'
,p_ref_column_name=>'LOV_DISP_VALUE'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(320718620503124049)
,p_query_column_id=>8
,p_column_alias=>'LOV_RETURN_VALUE'
,p_column_display_sequence=>6
,p_column_heading=>'Return Value'
,p_use_as_row_header=>'Y'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040200'
,p_ref_table_name=>'WWV_FLOW_LIST_OF_VALUES_DATA'
,p_ref_column_name=>'LOV_RETURN_VALUE'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(320721604429131930)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(320721730230131930)
,p_column_sequence=>2
,p_query_column_name=>'ID_DISPLAY'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(320721826718131930)
,p_column_sequence=>3
,p_query_column_name=>'LOV_ID'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(320721904503131930)
,p_column_sequence=>4
,p_query_column_name=>'FLOW_ID'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(320722032434131930)
,p_column_sequence=>5
,p_query_column_name=>'LOV_DISP_SEQUENCE'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(320722116503131930)
,p_column_sequence=>6
,p_query_column_name=>'LOV_DISP_VALUE'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(320722224482131930)
,p_column_sequence=>7
,p_query_column_name=>'LOV_RETURN_VALUE'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(362060515624359711)
,p_plug_name=>'Multiple Spreadsheet Columns'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>To Upload Multiple Spreadsheet Columns into One Table Column.</p>',
'<p>Choose the Table Column and specify the number of columns you would like to upload to this column.</p>',
'<p>For example if you would like to upload FirstName and LastName columns of the spreadsheet into ENAME of emp table</p>',
'<p>Select ENAME and type number 2 as "Number of Columns", two column aliases will be added to the list above with prefix APXMC_ </p>',
'<p>Then you will able to rename and assign any name you would like the end user to see</p>'))
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'F4000_P1805_LIST_ID'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3702506016906)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(362060515624359711)
,p_button_name=>'NEW_MULTIPLE_COLUMN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'New Multiple Columns'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(217640107285780858)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(217639726548776936)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CREATE'
,p_button_condition=>'F4000_P1805_LIST_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(320718717374124051)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(217639726548776936)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:1801:&SESSION.::&DEBUG.:::'
,p_button_condition=>'F4000_P1805_LIST_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(320718919930124051)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(217639726548776936)
,p_button_name=>'MULTI_ROW_DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'javascript:apex.confirm(htmldb_delete_message,''MULTI_ROW_DELETE'');'
,p_button_execute_validations=>'N'
,p_button_condition=>'F4000_P1805_LIST_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(217640811357800937)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(217639726548776936)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
,p_button_condition=>'F4000_P1805_LIST_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(320718805036124051)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(217639726548776936)
,p_button_name=>'SUBMIT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'CREATE'
,p_button_condition=>'F4000_P1805_LIST_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(202544309116870023)
,p_branch_action=>'f?p=&APP_ID.:1805:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(320718919930124051)
,p_branch_sequence=>10
,p_branch_condition_type=>'ITEM_IS_NOT_NULL'
,p_branch_condition=>'F4000_P1805_LIST_ID'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(937788020192878605)
,p_branch_name=>'Go To Page 1805'
,p_branch_action=>'f?p=&APP_ID.:1805:&SESSION.::&DEBUG.:RP:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(3702506016906)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(320720824944124052)
,p_branch_name=>'Go To Page 1801'
,p_branch_action=>'f?p=&APP_ID.:1801:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(46502724403801670)
,p_name=>'P1805_TABLE_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(46338707145132827)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(274511517617900256)
,p_name=>'P1805_OWNER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(46338707145132827)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(274511707912904810)
,p_name=>'P1805_TABLE_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(46338707145132827)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(320850819932155106)
,p_name=>'F4000_P1805_LIST_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(217639726548776936)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(362061303507543654)
,p_name=>'P1805_TABLE_COLUMN'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(362060515624359711)
,p_prompt=>'Choose Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'"LOV_RETURN_VALUE" d,',
'"LOV_RETURN_VALUE" r',
'from "#OWNER#"."WWV_FLOW_LIST_OF_VALUES_DATA"',
'where LOV_ID = :F4000_P1805_LIST_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(362061618578567033)
,p_name=>'P1805_COLUMN_ALIAS'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(362060515624359711)
,p_prompt=>'Number of Columns'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(320719811830124051)
,p_tabular_form_region_id=>wwv_flow_imp.id(320717723983124046)
,p_validation_name=>'LOV_DISP_SEQUENCE not null'
,p_validation_sequence=>50
,p_validation=>'LOV_DISP_SEQUENCE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#COLUMN_HEADER# must have a value.'
,p_when_button_pressed=>wwv_flow_imp.id(320718805036124051)
,p_associated_column=>'LOV_DISP_SEQUENCE'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(320720001066124051)
,p_tabular_form_region_id=>wwv_flow_imp.id(320717723983124046)
,p_validation_name=>'LOV_DISP_SEQUENCE must be numeric'
,p_validation_sequence=>50
,p_validation=>'LOV_DISP_SEQUENCE'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'#COLUMN_HEADER# must be numeric.'
,p_when_button_pressed=>wwv_flow_imp.id(320718805036124051)
,p_associated_column=>'LOV_DISP_SEQUENCE'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(320720223287124052)
,p_tabular_form_region_id=>wwv_flow_imp.id(320717723983124046)
,p_validation_name=>'LOV_DISP_VALUE not null'
,p_validation_sequence=>60
,p_validation=>'LOV_DISP_VALUE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#COLUMN_HEADER# must have a value.'
,p_when_button_pressed=>wwv_flow_imp.id(320718805036124051)
,p_associated_column=>'LOV_DISP_VALUE'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(864569033590731010)
,p_validation_name=>'Must Specify Column for Multiple Spreadsheet Column Use'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (:P1805_TABLE_COLUMN is null and :P1805_COLUMN_ALIAS is not null) then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'You must choose a column you wish to use for multiple spreadsheet uploading.'
,p_when_button_pressed=>wwv_flow_imp.id(3702506016906)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(864569290078731012)
,p_validation_name=>'Must Specify Number for Multiple Spreadsheet Column Use'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (:P1805_TABLE_COLUMN is not null and :P1805_COLUMN_ALIAS is null) then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'You must specify the number of columns you wish to use for multiple spreadsheet uploading.'
,p_when_button_pressed=>wwv_flow_imp.id(3702506016906)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(864569100183731011)
,p_validation_name=>'Must Specify Info  Multiple Spreadsheet Column Use'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (:P1805_TABLE_COLUMN is null and :P1805_COLUMN_ALIAS is null) then',
'  return false;',
'else',
'  return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'You must choose a column and specify the number of columns you would like to upload to that chosen column.'
,p_when_button_pressed=>wwv_flow_imp.id(3702506016906)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(202524620065775431)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create lov of column names'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'  l_lov_id    number := null;',
'  l_lov_name  varchar2(255); ',
'begin',
'  l_lov_name := upper(''LOV_DATALOAD_'');',
'  for c1 in (select name, column_names_lov_id ',
'            from wwv_flow_load_tables',
'            where id = :P1805_TABLE_ID)',
'  loop',
'      l_lov_id := c1.column_names_lov_id;',
'      l_lov_name := l_lov_name ||upper(c1.name);',
'  end loop;',
'',
'  if l_lov_id is not null then',
'      delete from wwv_flow_list_of_values_data',
'      where lov_id = l_lov_id;',
'  else',
'    l_lov_id := wwv_flow_id.next_val;',
'       wwv_flow_imp_shared.create_list_of_values (',
'           p_id       => l_lov_id,',
'           p_flow_id  => :FB_FLOW_ID,',
'           p_lov_name => l_lov_name,',
'           p_lov_query=> ''.''||to_char(l_lov_id)||''.'');',
'    update wwv_flow_load_tables set column_names_lov_id = l_lov_id where id = :P1805_TABLE_ID;',
'   end if;',
'  for i in 1..wwv_flow.g_f01.count',
'  loop',
'     wwv_flow_imp_shared.create_static_lov_data (',
'               p_lov_id            => l_lov_id,',
'               p_lov_disp_sequence => wwv_flow.g_f03(i),',
'               p_lov_disp_value    => wwv_flow.g_f02(i),',
'               p_lov_return_value  => wwv_flow.g_f01(i));',
'  end loop;',
'  :F4000_P1805_LIST_ID := l_lov_id;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(217640811357800937)
,p_process_success_message=>'Column Names List of Values has been successfully created.'
,p_internal_uid=>202524620065775431
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(320720317631124052)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(320717723983124046)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'ApplyMRU'
,p_attribute_02=>'WWV_FLOW_LIST_OF_VALUES_DATA'
,p_attribute_03=>'ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(320718805036124051)
,p_process_success_message=>'#MRU_COUNT# row(s) updated, #MRI_COUNT# row(s) inserted.'
,p_internal_uid=>320720317631124052
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(320720525397124052)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(320717723983124046)
,p_process_type=>'NATIVE_TABFORM_DELETE'
,p_process_name=>'ApplyMRD'
,p_attribute_02=>'WWV_FLOW_LIST_OF_VALUES_DATA'
,p_attribute_03=>'ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'MULTI_ROW_DELETE'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>'#MRD_COUNT# row(s) deleted.'
,p_internal_uid=>320720525397124052
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(348064900625832396)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete lov if no data'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_lov_is_empty boolean := true;',
'begin',
'    for c2 in (',
'        select lov_id ',
'          from wwv_flow_list_of_values_data',
'         where flow_id = :FB_FLOW_ID',
'           and lov_id  = :F4000_P1805_LIST_ID',
'           and rownum  = 1 )',
'    loop',
'        l_lov_is_empty := false;',
'    end loop;',
'    ',
'    if l_lov_is_empty then',
'        delete from wwv_flow_lists_of_values$ where id = :F4000_P1805_LIST_ID;',
'        :F4000_P1805_LIST_ID := null;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(320718919930124051)
,p_internal_uid=>348064900625832396
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3702520197661)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create New Multiple Columns'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_id   number;',
'   l_seq  number;',
'   l_cols number;',
'begin',
'   l_cols := to_number(:P1805_COLUMN_ALIAS);',
'   ',
'   select max(lov_disp_sequence) into l_seq',
'          from wwv_flow_list_of_values_data',
'          where lov_id = :F4000_P1805_LIST_ID',
'          and flow_id = :FB_FLOW_ID;',
'   for i in 1..l_cols',
'   loop',
'       l_id   := wwv_flow_id.next_val;',
'       l_seq  := l_seq + 10;',
'       insert into wwv_flow_list_of_values_data (id, lov_id, lov_disp_value, lov_return_value, LOV_DISP_SEQUENCE ) ',
'          values (l_id, :F4000_P1805_LIST_ID, ''APXMC_''||i||:P1805_TABLE_COLUMN, ''APXMC_''||i||:P1805_TABLE_COLUMN, l_seq);',
'   end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3702506016906)
,p_internal_uid=>3702520197661
);
end;
/
prompt --application/pages/page_01808
begin
wwv_flow_imp_page.create_page(
 p_id=>1808
,p_name=>'Data Load Definition History'
,p_alias=>'DATA-LOAD-DEFINITION-HISTORY'
,p_step_title=>'Data Load Definition History'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(15156216771460781)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(15132926917246073)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Data Load Definitions'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(437956428495190433)
,p_plug_name=>'Data Load Definition History'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  l.a object_type,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u,',
'  (select wwv_flow_lang.system_message(''DATA.LOAD.DEFINITION'') a from dual) l',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_LOAD_TABLES''',
'union',
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  l.a object_type,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u,',
'  (select wwv_flow_lang.system_message(''DATA.LOAD.DATA_PROFILE'') a from dual) l',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_DATA_PROFILES''',
'union',
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  l.a object_type,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u,',
'  (select wwv_flow_lang.system_message(''DATA.LOAD.DATA_PROFILE_COLS'') a from dual) l',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_DATA_PROFILE_COLS'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(437956620220190440)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(437956720911190443)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(437956816339190444)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Audit Comment'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(437956920060190444)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Component Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(437957020870190444)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(437957104464190444)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Component Key'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'LEFT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(437957206794190445)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Audit Date'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(437957307466190445)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(437957423887190445)
,p_db_column_name=>'OBJECT_TYPE'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Object Type'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(437957530880190446)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1294307143536645'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'AUDIT_DATE:ACTION:DEVELOPER:OBJECT_TYPE:COMPONENT_NAME'
,p_sort_column_1=>'AUDIT_DATE'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(438175120146235308)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>This page displays recent modifications made to Data Load definitions in this application.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
end;
/
prompt --application/pages/page_01810
begin
wwv_flow_imp_page.create_page(
 p_id=>1810
,p_name=>'Create Data Load'
,p_alias=>'CREATE-DATA-LOAD'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Data Load'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(1449603451873552)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'600'
,p_dialog_width=>'80%'
,p_dialog_max_width=>'1000'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1620277601859218)
,p_plug_name=>'Copy and Paste'
,p_region_name=>'data'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2566068517581311)
,p_plug_name=>'Pasted Data'
,p_parent_plug_id=>wwv_flow_imp.id(1620277601859218)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P1810_DATA'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2566115723581312)
,p_plug_name=>'Copy and Paste Data'
,p_parent_plug_id=>wwv_flow_imp.id(1620277601859218)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_display_condition_type=>'ITEM_IS_NULL'
,p_plug_display_when_condition=>'P1810_DATA'
,p_plug_header=>'Create data load definitions from a sample CSV data'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1907748512746109)
,p_plug_name=>'Source'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2565134205581302)
,p_plug_name=>'File'
,p_region_name=>'file'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1620150868859217)
,p_plug_name=>'Upload a File'
,p_parent_plug_id=>wwv_flow_imp.id(2565134205581302)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_display_condition_type=>'ITEM_IS_NULL'
,p_plug_display_when_condition=>'P1810_FILE'
,p_plug_header=>'Create data load definitions from a sample file'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2565280041581303)
,p_plug_name=>'File Loaded'
,p_parent_plug_id=>wwv_flow_imp.id(2565134205581302)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P1810_FILE'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3852284745950931045)
,p_plug_name=>'Create Data Load'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_list_id=>wwv_flow_imp.id(4115808439009126)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3852284764378931046)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1611375322809372)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(3852284764378931046)
,p_button_name=>'NEXT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2305524855304240)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(3852284764378931046)
,p_button_name=>'BACK'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Back'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1811:&SESSION.::&DEBUG.:RP,::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1619609476859212)
,p_branch_name=>'Go To Page 1812'
,p_branch_action=>'f?p=&APP_ID.:1812:&SESSION.::&DEBUG.::P1812_FIRST_LINE:HEADERS&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(1611375322809372)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1619577536859211)
,p_name=>'P1810_FILE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(1620150868859217)
,p_prompt=>'Sample File'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(4923925522744860)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'APEX_APPLICATION_TEMP_FILES'
,p_attribute_09=>'SESSION'
,p_attribute_10=>'N'
,p_attribute_12=>'DROPZONE_BLOCK'
,p_attribute_13=>'Drag and drop sample file here'
,p_attribute_14=>'Supported formats csv, xlsx, txt, xml, json'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1619947374859215)
,p_name=>'P1810_DATA'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(2566115723581312)
,p_prompt=>'Sample CSV Data'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>120
,p_cHeight=>10
,p_field_template=>wwv_flow_imp.id(4923925522744860)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Copy and Paste delimited data.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1622652636859242)
,p_name=>'P1810_SOURCE_TYPE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1907748512746109)
,p_item_default=>'FILE'
,p_prompt=>'Source Type'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DATA.LOAD.SAMPLE_SOURCE_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(1805213661837379)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'A new data load definition will be created based on some uploaded sample data. Select whether this sample data will be uploaded as a file, or using copy and paste of delimited text data.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2104588196499743)
,p_name=>'P1810_MIME_TYPE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(2565280041581303)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2104697976499744)
,p_name=>'P1810_DATA_PASTED'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2566068517581311)
,p_item_default=>'wwv_flow_lang.system_message(''DATA.LOAD.PASTED_DATA'')'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Sample Data'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2565324303581304)
,p_name=>'P1810_FILE_NAME'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(2565280041581303)
,p_prompt=>'Sample File'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1908357768746115)
,p_validation_name=>'file required'
,p_validation_sequence=>10
,p_validation=>'P1810_FILE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified'
,p_validation_condition=>'P1810_SOURCE_TYPE'
,p_validation_condition2=>'FILE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(1611375322809372)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1908498133746116)
,p_validation_name=>'data required'
,p_validation_sequence=>20
,p_validation=>'P1810_DATA'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified'
,p_validation_condition=>'P1810_SOURCE_TYPE'
,p_validation_condition2=>'COPY_PASTE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(1611375322809372)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(607607176710279801)
,p_validation_name=>'invalid file'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_data_parser.assert_file_type(',
'    p_file_name => :P1810_FILE,',
'    p_file_type => wwv_flow_data_parser.c_file_type_csv ) or',
'wwv_flow_data_parser.assert_file_type(',
'    p_file_name => :P1810_FILE,',
'    p_file_type => wwv_flow_data_parser.c_file_type_xlsx ) or',
'wwv_flow_data_parser.assert_file_type(',
'    p_file_name => :P1810_FILE,',
'    p_file_type => wwv_flow_data_parser.c_file_type_xml ) or',
'wwv_flow_data_parser.assert_file_type(',
'    p_file_name => :P1810_FILE,',
'    p_file_type => wwv_flow_data_parser.c_file_type_json )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Uploaded file is invalid or has wrong extension.'
,p_validation_condition=>':P1810_SOURCE_TYPE = ''FILE'' and :P1810_FILE is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1907814178746110)
,p_name=>'toggle file or copy paste'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1810_SOURCE_TYPE'
,p_condition_element=>'P1810_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FILE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1907992057746111)
,p_event_id=>wwv_flow_imp.id(1907814178746110)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2565134205581302)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1908061139746112)
,p_event_id=>wwv_flow_imp.id(1907814178746110)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2565134205581302)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1908289840746114)
,p_event_id=>wwv_flow_imp.id(1907814178746110)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1620277601859218)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1908181265746113)
,p_event_id=>wwv_flow_imp.id(1907814178746110)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1620277601859218)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2401278819372912)
,p_name=>'clear file and data'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1810_SOURCE_TYPE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2401953067372919)
,p_event_id=>wwv_flow_imp.id(2401278819372912)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1810_FILE := null;',
':P1810_FILE_NAME := null;',
':P1810_DATA := null;',
'',
'-- clear column mapping page items',
'htmldb_util.clear_page_cache( p_page_id => 1812 );',
'',
'-- clear columns collection',
'wwv_flow_collection.create_or_truncate_collection( p_collection_name => ''APEX$DATALOAD'' );',
'wwv_flow_collection.create_or_truncate_collection( p_collection_name => ''APEX$DATALOAD_COLUMNS'' );'))
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2402146791372921)
,p_event_id=>wwv_flow_imp.id(2401278819372912)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1909245256746124)
,p_name=>'toggle table or collection'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1810_TARGET_TYPE'
,p_condition_element=>'P1810_TARGET_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TABLE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1909342107746125)
,p_event_id=>wwv_flow_imp.id(1909245256746124)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1810_TABLE_OWNER,P1810_TABLE_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1909480643746126)
,p_event_id=>wwv_flow_imp.id(1909245256746124)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1810_TABLE_OWNER,P1810_TABLE_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1909515253746127)
,p_event_id=>wwv_flow_imp.id(1909245256746124)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1810_COLLECTION_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1909689678746128)
,p_event_id=>wwv_flow_imp.id(1909245256746124)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1810_COLLECTION_NAME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3755598750775414)
,p_name=>'submit page NEXT and show progress if file'
,p_event_sequence=>90
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1611375322809372)
,p_condition_element=>'P1810_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FILE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3755622138775415)
,p_event_id=>wwv_flow_imp.id(3755598750775414)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'NEXT'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1003711736967784942)
,p_name=>'submit page NEXT if copy paste'
,p_event_sequence=>100
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1611375322809372)
,p_condition_element=>'P1810_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'COPY_PASTE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1003711897796784943)
,p_event_id=>wwv_flow_imp.id(1003711736967784942)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.widget.textareaClob.uploadNonEmpty(''P1810_DATA'', ''NEXT'');'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2565509421581306)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'get filename'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- get the file name',
'select filename, mime_type',
'into :P1810_FILE_NAME, :P1810_MIME_TYPE',
'from wwv_flow_temp_files ',
'where name = :P1810_FILE;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1611375322809372)
,p_process_when=>'P1810_SOURCE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'FILE'
,p_internal_uid=>2565509421581306
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2400456962372904)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'save copy and paste data to collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_seq_id number;',
'    l_clob   clob;',
'begin',
'    select seq_id, ',
'           clob001',
'      into l_seq_id, ',
'           l_clob',
'      from wwv_flow_collections',
'     where collection_name = ''CLOB_CONTENT'';',
'    ',
'    wwv_flow_collection.update_member(',
'        p_collection_name => ''CLOB_CONTENT'',',
'        p_seq             => l_seq_id,',
'        p_clob001         => l_clob,',
'        p_blob001         => wwv_flow_utilities.clob_to_blob( p_clob => l_clob ) );',
'end; '))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1611375322809372)
,p_process_when=>'P1810_SOURCE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'COPY_PASTE'
,p_internal_uid=>2400456962372904
);
end;
/
prompt --application/pages/page_01811
begin
wwv_flow_imp_page.create_page(
 p_id=>1811
,p_name=>'Create Data Load'
,p_alias=>'CREATE-DATA-LOAD1'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Data Load'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(1449603451873552)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'600'
,p_dialog_width=>'80%'
,p_dialog_max_width=>'1000'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3853921091276281832)
,p_plug_name=>'Target Type'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3853921583171281837)
,p_plug_name=>'Create Data Load'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_list_id=>wwv_flow_imp.id(4115808439009126)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3853921601599281838)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1640946071350811)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(3853921601599281838)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2102195965346919)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(3853921601599281838)
,p_button_name=>'BACK'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Back'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1815:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1909732795746129)
,p_branch_name=>'Go To Page 1810'
,p_branch_action=>'f?p=&APP_ID.:1810:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1637416551350807)
,p_name=>'P1811_NAME'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3853921091276281832)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a name for the data load definition.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1637748609350808)
,p_name=>'P1811_TARGET_TYPE'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3853921091276281832)
,p_item_default=>'TABLE'
,p_prompt=>'Target Type'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DATA.LOAD.TARGET_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(1633774479940540)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify whether the data will be uploaded to a table or an &PRODUCT_NAME. collection. Collections are typically used if the uploaded data needs to be processed before storing to the target tables.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1638143746350808)
,p_name=>'P1811_TABLE_OWNER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3853921091276281832)
,p_item_default=>'wwv_flow_security.flow_owner( p_flow_id => :FB_FLOW_ID, p_security_group_id => :WORKSPACE_ID )'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Table Owner'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_SCHEMAS_HAVE_PRIVS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(owner) d, owner v',
'  from wwv_flow_object_owners_dev',
'order by d                   '))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the owner of the table to load data. If nothing is selected, the application parsing schema will be used.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1639027070350809)
,p_name=>'P1811_TABLE_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(3853921091276281832)
,p_prompt=>'Table Name'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = :P1811_TABLE_OWNER'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table -'
,p_lov_cascade_parent_items=>'P1811_TABLE_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select the table, to which the data will be loaded. When entering manually, note that the table name is case sensitive.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1639981814350809)
,p_name=>'P1811_COLLECTION_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(3853921091276281832)
,p_prompt=>'Collection Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_tag_attributes=>'style="text-transform: uppercase;"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the collection name to load the data to.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1910326174746135)
,p_validation_name=>'owner required'
,p_validation_sequence=>10
,p_validation=>'P1811_TABLE_OWNER'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABLE# must be specified.'
,p_validation_condition=>'P1811_TARGET_TYPE'
,p_validation_condition2=>'TABLE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1910479432746136)
,p_validation_name=>'table required'
,p_validation_sequence=>20
,p_validation=>'P1811_TABLE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified'
,p_validation_condition=>'P1811_TARGET_TYPE'
,p_validation_condition2=>'TABLE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1910532104746137)
,p_validation_name=>'collection name required'
,p_validation_sequence=>30
,p_validation=>'P1811_COLLECTION_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified'
,p_validation_condition=>'P1811_TARGET_TYPE'
,p_validation_condition2=>'COLLECTION'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1803812151557118)
,p_validation_name=>'Name is unique'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_load_tables',
' where name              = :P1811_NAME',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'The name is already used by another data load definition.'
,p_associated_item=>wwv_flow_imp.id(1637416551350807)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(21464543160466401)
,p_validation_name=>'Static ID is unique'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_load_tables',
' where static_id         = regexp_replace( lower( :P1811_NAME ), ''[^abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890]+'', ''_'' )',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The name "&P1811_NAME!HTML." will lead to a static ID which is already taken. Choose a different name.',
''))
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_load_tables',
' where name              = :P1811_NAME',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_validation_condition_type=>'NOT_EXISTS'
,p_associated_item=>wwv_flow_imp.id(1637416551350807)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(607707446113483812)
,p_validation_name=>'Chosen Table Exists'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_tables_views_dev',
' where object_name = :P1811_TABLE_NAME',
'   and owner       = :P1811_TABLE_OWNER'))
,p_validation_type=>'EXISTS'
,p_error_message=>'Table &P1811_TABLE_NAME!HTML. does not exist. Note that the table name is case-sensitive.'
,p_validation_condition=>':P1811_TARGET_TYPE = ''TABLE'' and :P1811_TABLE_NAME is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(1639027070350809)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1909052388746122)
,p_name=>'Refresh on First Line Headers Change'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1811_FIRST_LINE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1909148382746123)
,p_event_id=>wwv_flow_imp.id(1909052388746122)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1909883187746130)
,p_name=>'toggle table or collection'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1811_TARGET_TYPE'
,p_condition_element=>'P1811_TARGET_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TABLE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1909912135746131)
,p_event_id=>wwv_flow_imp.id(1909883187746130)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1811_TABLE_OWNER,P1811_TABLE_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1910047169746132)
,p_event_id=>wwv_flow_imp.id(1909883187746130)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1811_TABLE_OWNER,P1811_TABLE_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1910181420746133)
,p_event_id=>wwv_flow_imp.id(1909883187746130)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1811_COLLECTION_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1910264969746134)
,p_event_id=>wwv_flow_imp.id(1909883187746130)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1811_COLLECTION_NAME'
);
end;
/
prompt --application/pages/page_01812
begin
wwv_flow_imp_page.create_page(
 p_id=>1812
,p_name=>'Create Data Load'
,p_alias=>'CREATE-DATA-LOAD2'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Data Load'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(1449603451873552)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'600'
,p_dialog_width=>'80%'
,p_dialog_max_width=>'1000'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_page_component_map=>'21'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3304651691587419)
,p_plug_name=>'Column Mapping'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with',
'  l_columns as (',
'    select ',
'        fc.column_position,    ',
'        case when :P1812_FIRST_LINE = ''HEADERS'' then',
'            fc.column_name',
'        else ',
'            ''COL'' || lpad( rownum,3,''0'')',
'        end as column_name,',
'        case when :P1812_FIRST_LINE = ''HEADERS'' and :P1811_TARGET_TYPE = ''TABLE'' then',
'            ( select tc.column_name ',
'              from sys.dba_tab_columns tc',
'              where tc.owner = :P1811_TABLE_OWNER',
'              and tc.table_name = :P1811_TABLE_NAME',
'              and tc.column_name = fc.column_name )',
'        end as map_tab_col_name,',
'        case when :P1811_TARGET_TYPE = ''COLLECTION'' then',
'            case when fc.column_position <= 50 then',
'                ''C''||lpad( to_char(fc.column_position), 3, ''0'')',
'            end',
'        end as map_collection_col_name,',
'        fc.data_type, ',
'        fc.format_mask,',
'        fc.detected_group_char group_char,',
'        fc.detected_decimal_char decimal_char,',
'        ''N'' is_pk',
'    from wwv_flow_temp_files f,',
'         table( wwv_flow_data_parser.get_columns(',
'                      wwv_flow_data_parser.discover(',
'                          p_content   => f.blob_content,',
'                          p_file_name => f.filename,',
'                          p_xlsx_sheet_name   => ( case when :P1812_FILE_TYPE = 1 and :P1812_XLSX_SHEET is not null then :P1812_XLSX_SHEET end ),',
'                          p_csv_col_delimiter => replace(:P1812_CSV_COL_DELIMITER, ''tab'', chr(9) ),',
'                          p_file_charset      => coalesce( :P1812_FILE_CHARSET, ''AL32UTF8'' ),',
'                          p_max_rows          => 200,',
'                          p_skip_rows         => :P1812_SKIP_ROWS,',
'                          p_csv_enclosed      => nullif( :P1812_CSV_ENCLOSED, ''None'' ) ) ) ) fc',
'    where f.name = :P1810_FILE',
'    and :P1810_SOURCE_TYPE = ''FILE''',
'  union all',
'  select ',
'        fc.column_position,    ',
'        case when :P1812_FIRST_LINE = ''HEADERS'' then',
'            fc.column_name',
'        else ',
'            ''COL'' || lpad( rownum,3,''0'')',
'        end as column_name,',
'        case when :P1812_FIRST_LINE = ''HEADERS'' and :P1811_TARGET_TYPE = ''TABLE'' then',
'            ( select tc.column_name ',
'              from sys.dba_tab_columns tc',
'              where tc.owner = :P1811_TABLE_OWNER',
'              and tc.table_name = :P1811_TABLE_NAME',
'              and tc.column_name = fc.column_name )',
'        end as map_tab_col_name,',
'        case when :P1811_TARGET_TYPE = ''COLLECTION'' then',
'            case when fc.column_position < 50 then',
'                ''C''||lpad( to_char(fc.column_position), 3, ''0'')',
'            end',
'        end as map_collection_col_name,',
'        fc.data_type, ',
'        fc.format_mask,',
'        fc.detected_group_char group_char,',
'        fc.detected_decimal_char decimal_char,',
'        ''N'' is_pk',
'    from wwv_flow_collections c,',
'         table( wwv_flow_data_parser.get_columns(',
'                      wwv_flow_data_parser.discover(',
'                          p_content   => c.blob001,',
'                          p_file_name => ''copy_pate_data.csv'',',
'                          p_xlsx_sheet_name  => ( case when :P1812_FILE_TYPE = 1 and :P1812_XLSX_SHEET is not null then :P1812_XLSX_SHEET end ),',
'                          p_csv_col_delimiter => replace(:P1812_CSV_COL_DELIMITER, ''tab'', chr(9) ),',
'                          p_file_charset      => coalesce( :P1812_FILE_CHARSET, ''AL32UTF8'' ),',
'                          p_max_rows          => 200,',
'                          p_skip_rows         => :P1812_SKIP_ROWS,',
'                          p_csv_enclosed      => nullif( :P1812_CSV_ENCLOSED, ''None'' ) )) ) fc',
'    where c.collection_name=''CLOB_CONTENT''',
'    and :P1810_SOURCE_TYPE = ''COPY_PASTE''  )',
'select',
'    m.seq_id      as column_seq,',
'    c.column_name as column_name,',
'    c.column_name|| '' (''|| initcap(c.data_type) || '')'' as column_name_disp,',
'    m.c002 as tab_col_map,',
'    m.c002 as collection_col_map,',
'    m.c003 as format_mask,',
'    m.c004 as group_char,',
'    m.c005 as decimal_char,',
'    m.c006 as is_pk',
'from l_columns c, wwv_flow_collections m',
'where c.column_name = m.c001 (+)',
'and wwv_flow_collection.collection_member_count( p_collection_name => ''APEX$DATALOAD_COLUMNS'' ) > 0',
'union',
'select',
'    c.column_position as column_seq,',
'    c.column_name     as column_name,',
'    c.column_name|| '' (''|| initcap(c.data_type) || '')'' as  column_name_disp,',
'    c.map_tab_col_name        as tab_col_map,',
'    c.map_collection_col_name as collection_col_map,',
'    c.format_mask             as format_mask,',
'    c.group_char              as group_char,',
'    c.decimal_char            as decimal_char,',
'    c.is_pk                   as is_pk       ',
'from l_columns c',
'where wwv_flow_collection.collection_member_count( p_collection_name => ''APEX$DATALOAD_COLUMNS'' ) = 0'))
,p_plug_source_type=>'NATIVE_IG'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3304948301587422)
,p_name=>'COLUMN_SEQ'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'COLUMN_SEQ'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3305016704587423)
,p_name=>'COLUMN_NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'COLUMN_NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>20
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3305192221587424)
,p_name=>'COLUMN_NAME_DISP'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'COLUMN_NAME_DISP'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Source Column'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>30
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3305292927587425)
,p_name=>'TAB_COL_MAP'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'TAB_COL_MAP'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Map To'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>40
,p_value_alignment=>'LEFT'
,p_is_required=>false
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(2132493628676085)
,p_lov_display_extra=>false
,p_lov_display_null=>true
,p_lov_null_text=>'- Unmapped Column -'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_condition=>'P1811_TARGET_TYPE'
,p_display_condition2=>'TABLE'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3305354292587426)
,p_name=>'COLLECTION_COL_MAP'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'COLLECTION_COL_MAP'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_POPUP_LOV'
,p_heading=>'Map To'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>50
,p_value_alignment=>'LEFT'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
,p_is_required=>false
,p_max_length=>4000
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(3007625702757031)
,p_lov_display_extra=>false
,p_lov_display_null=>true
,p_lov_null_text=>'- Unmapped Column -'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_condition=>'P1811_TARGET_TYPE'
,p_display_condition2=>'COLLECTION'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3305446101587427)
,p_name=>'FORMAT_MASK'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FORMAT_MASK'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Format Mask'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>60
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3305586512587428)
,p_name=>'GROUP_CHAR'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'GROUP_CHAR'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Group Separator'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>70
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3305674635587429)
,p_name=>'DECIMAL_CHAR'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DECIMAL_CHAR'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Decimal Character'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>80
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3305733664587430)
,p_name=>'IS_PK'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'IS_PK'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SINGLE_CHECKBOX'
,p_heading=>'Primary Key'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>90
,p_value_alignment=>'CENTER'
,p_attribute_01=>'Y'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(3304881916587421)
,p_internal_uid=>3304881916587421
,p_is_editable=>true
,p_edit_operations=>'u'
,p_lost_update_check_type=>'VALUES'
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>false
,p_show_toolbar=>false
,p_toolbar_buttons=>null
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>false
,p_define_chart_view=>false
,p_enable_download=>false
,p_download_formats=>null
,p_enable_mail_download=>true
,p_fixed_header=>'REGION'
,p_fixed_header_max_height=>400
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(3903492105430583)
,p_interactive_grid_id=>wwv_flow_imp.id(3304881916587421)
,p_static_id=>'39035'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(3903699724430584)
,p_report_id=>wwv_flow_imp.id(3903492105430583)
,p_view_type=>'GRID'
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3904149012430591)
,p_view_id=>wwv_flow_imp.id(3903699724430584)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(3304948301587422)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3905067191430596)
,p_view_id=>wwv_flow_imp.id(3903699724430584)
,p_display_seq=>2
,p_column_id=>wwv_flow_imp.id(3305016704587423)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3905936694430599)
,p_view_id=>wwv_flow_imp.id(3903699724430584)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(3305192221587424)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3906879735430603)
,p_view_id=>wwv_flow_imp.id(3903699724430584)
,p_display_seq=>4
,p_column_id=>wwv_flow_imp.id(3305292927587425)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3907625574430606)
,p_view_id=>wwv_flow_imp.id(3903699724430584)
,p_display_seq=>5
,p_column_id=>wwv_flow_imp.id(3305354292587426)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3908533487430609)
,p_view_id=>wwv_flow_imp.id(3903699724430584)
,p_display_seq=>6
,p_column_id=>wwv_flow_imp.id(3305446101587427)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3909436858430612)
,p_view_id=>wwv_flow_imp.id(3903699724430584)
,p_display_seq=>7
,p_column_id=>wwv_flow_imp.id(3305586512587428)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3910379187430615)
,p_view_id=>wwv_flow_imp.id(3903699724430584)
,p_display_seq=>8
,p_column_id=>wwv_flow_imp.id(3305674635587429)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3911211906430618)
,p_view_id=>wwv_flow_imp.id(3903699724430584)
,p_display_seq=>9
,p_column_id=>wwv_flow_imp.id(3305733664587430)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3902531076112663)
,p_plug_name=>'get file profile and save'
,p_parent_plug_id=>wwv_flow_imp.id(3304651691587419)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_profile             clob;',
'    l_file_content        blob;',
'    l_profile_record      wwv_flow_data_parser.t_file_profile;',
'begin',
'    l_profile        := wwv_flow_data_parser.get_file_profile;',
'    l_profile_record := wwv_flow_data_parser.json_to_profile( l_profile );',
'  ',
'    if :P1812_FIRST_LINE is null or :P1812_FIRST_LINE != ''HEADERS'' then',
'        for i in 1 .. l_profile_record.file_columns.count loop',
'            l_profile_record.file_columns( i ).name := ''COL'' || lpad( i,3,''0'');',
'        end loop;',
'        l_profile := wwv_flow_data_parser.profile_to_json(l_profile_record);',
'    end if;',
'    ',
'    -- save file profile in collection for later use',
'    wwv_flow_collection.create_or_truncate_collection( ''APEX$DATALOAD'' );',
'    wwv_flow_collection.add_member( ''APEX$DATALOAD'', p_clob001 => l_profile );',
'    ',
'    :P1812_FILE_TYPE           := l_profile_record.file_type;',
'    :P1812_CSV_COL_DELIMITER   := l_profile_record.csv_delimiter;',
'    :P1812_NEW_COL_DELIMITER   := ( case when l_profile_record.csv_delimiter = chr(9) then ''tab'' else l_profile_record.csv_delimiter end );',
'    :P1812_PARSED_ROW_COUNT    := l_profile_record.parsed_rows;',
'    ',
'    if l_profile_record.file_columns.count <= 10 then',
'        :P1812_PARSED_COLUMN_COUNT := l_profile_record.file_columns.count;',
'    else',
'        :P1812_PARSED_COLUMN_COUNT := 10;',
'    end if;',
'',
'    :P1812_FILE_COLUMN_COUNT   := l_profile_record.file_columns.count;',
'    :P1812_FILE_INVALID        := ''N'';',
'exception',
'    when others then',
'        :P1812_FILE_INVALID := ''Y'';',
'        wwv_flow_collection.create_or_truncate_collection( ''APEX$DATALOAD'' );',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3616624889225788)
,p_plug_name=>'Settings'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3616723432225789)
,p_plug_name=>'Preview'
,p_region_css_classes=>'a-DataLoad-preview'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3616791386225790)
,p_plug_name=>'Preview Information'
,p_parent_plug_id=>wwv_flow_imp.id(3616723432225789)
,p_region_css_classes=>'a-Alert--noTitle a-Alert--DataLoadPreview'
,p_icon_css_classes=>'icon-report'
,p_region_template_options=>'#DEFAULT#:a-Alert--info:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p class="desc">Parsed first <span id="placeholder_P1812_PARSED_ROW_COUNT">&P1812_PARSED_ROW_COUNT.</span> rows to sample the column types. The preview below only displays the first <span id="placeholder_P1812_PARSED_COLUMN_COUNT">&P1812_PARSED_COLUM'
||'N_COUNT.</span> columns and 5 rows.</p>',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(3616934009225791)
,p_name=>'Parsed Data'
,p_region_name=>'preview_table'
,p_parent_plug_id=>wwv_flow_imp.id(3616723432225789)
,p_template=>wwv_flow_imp.id(208928010704475743)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_data_loader_dev.get_10by5_preview_query(',
'    p_source_type           => :P1810_SOURCE_TYPE,',
'    p_file_name             => :P1810_FILE,',
'    --',
'    p_max_rows              => 200,',
'    p_csv_delimiter         => replace(:P1812_CSV_COL_DELIMITER, ''tab'', chr(9) ),',
'    p_csv_enclosed          => nullif( :P1812_CSV_ENCLOSED, ''None'' ),',
'    p_skip_rows             => :P1812_SKIP_ROWS,',
'    p_file_charset          => coalesce( :P1812_FILE_CHARSET, ''AL32UTF8'' ),',
'    p_xlsx_sheet_name       => case when :P1812_FILE_TYPE = wwv_flow_data_parser.c_file_type_xlsx',
'                               and :P1812_XLSX_SHEET is not null then',
'                                   :P1812_XLSX_SHEET',
'                               end );'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_plug_query_max_columns=>11
,p_query_num_rows=>15
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3307794064587450)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>10
,p_column_heading=>'Line'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1802138236557101)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>20
,p_column_heading=>'COL001'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1802254688557102)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>30
,p_column_heading=>'COL002'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1802350253557103)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>40
,p_column_heading=>'COL003'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1802489994557104)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>50
,p_column_heading=>'COL004'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1802573708557105)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>60
,p_column_heading=>'COL005'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1802602585557106)
,p_query_column_id=>7
,p_column_alias=>'COL07'
,p_column_display_sequence=>70
,p_column_heading=>'COL006'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1802786615557107)
,p_query_column_id=>8
,p_column_alias=>'COL08'
,p_column_display_sequence=>80
,p_column_heading=>'COL007'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1802843919557108)
,p_query_column_id=>9
,p_column_alias=>'COL09'
,p_column_display_sequence=>90
,p_column_heading=>'COL008'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1802988319557109)
,p_query_column_id=>10
,p_column_alias=>'COL10'
,p_column_display_sequence=>100
,p_column_heading=>'COL009'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1803007910557110)
,p_query_column_id=>11
,p_column_alias=>'COL11'
,p_column_display_sequence=>110
,p_column_heading=>'COL010'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3902593886112664)
,p_plug_name=>'Load Information'
,p_parent_plug_id=>wwv_flow_imp.id(3616723432225789)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3618415348225806)
,p_plug_name=>'RDS'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'N',
  'rds_mode', 'STANDARD',
  'remember_selection', 'NO')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3855917059569648398)
,p_plug_name=>'Create Data Load'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_list_id=>wwv_flow_imp.id(4115808439009126)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3855917077997648399)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3306310777587436)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(3855917077997648399)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Create Data Load'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1999513044366605)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(3855917077997648399)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create and Add Page'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1999902952366608)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(3855917077997648399)
,p_button_name=>'BACK'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Back'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1810:&SESSION.::&DEBUG.:RP,::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2403673594372936)
,p_branch_name=>'Go To Page 2501'
,p_branch_action=>'f?p=&APP_ID.:2501:&SESSION.::&DEBUG.:2501:P2501_DATA_LOAD_ID,P2501_PREV_PAGE,P2501_CLOSE_DIALOG:&P1812_DATA_LOAD_ID.,2500,N'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(1999513044366605)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3306580911587438)
,p_branch_action=>'f?p=&APP_ID.:1800:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(3306310777587436)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2000921822366611)
,p_name=>'P1812_FIRST_LINE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3616624889225788)
,p_prompt=>'Column Headers'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'DATA.LOAD.FIRST_LINE'
,p_lov=>'.'||wwv_flow_imp.id(1311667928909742)||'.'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P1810_SOURCE_TYPE = ''FILE'' then',
'    if wwv_flow_data_parser.get_file_type( p_file_name => :P1810_FILE) not in (wwv_flow_data_parser.c_file_type_xml, wwv_flow_data_parser.c_file_type_json) then',
'        return true;',
'    end if;',
'elsif :P1810_SOURCE_TYPE = ''COPY_PASTE'' then',
'    return true;',
'end if;',
'return false;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select this option if your data contains column names in the first row.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2001830944366614)
,p_name=>'P1812_XLSX_SHEET'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3616624889225788)
,p_prompt=>'Select Sheet'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sheet_file_name',
'from wwv_flow_temp_files f, ',
'     table( wwv_flow_data_parser.get_xlsx_worksheets( ',
'                p_content => f.blob_content ) )',
'where f.name = :P1810_FILE and lower( :P1810_FILE ) like ''%.xls_''',
'  and sys.dbms_lob.substr( f.blob_content, 4, 1 ) = hextoraw( ''504B0304'' )',
'  and rownum = 1',
'order by sheet_sequence'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sheet_display_name, sheet_file_name',
'from wwv_flow_temp_files f, ',
'     table( wwv_flow_data_parser.get_xlsx_worksheets( ',
'                p_content => f.blob_content ) )',
'where f.name = :P1810_FILE and lower( :P1810_FILE ) like ''%.xls_''',
'  and sys.dbms_lob.substr( f.blob_content, 4, 1 ) = hextoraw( ''504B0304'' )',
'order by sheet_sequence;'))
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_sheet_cnt number := 0;',
'begin',
'    -- shortcut: return immediately when we don''t have an XLSX file, since invoking wwv_flow_data_parser.get_xlsx_worksheets',
'    -- is an expensive operation leading to nothing',
'    if lower( :P1810_FILE ) not like ''%.xls_'' then',
'        return false;',
'    end if;',
'',
'    select count(*)',
'    into l_sheet_cnt',
'    from wwv_flow_temp_files f, ',
'         table( wwv_flow_data_parser.get_xlsx_worksheets( ',
'                    p_content => f.blob_content ) )',
'    where f.name = :P1810_FILE and lower( :P1810_FILE ) like ''%.xls_''',
'      and sys.dbms_lob.substr( f.blob_content, 4, 1 ) = hextoraw( ''504B0304'' );',
'    ',
'    -- if there is multiple sheets, display',
'    if ( l_sheet_cnt > 1 ) then',
'        return true;',
'    else',
'        return false;',
'    end if;',
'exception',
'    when others then ',
'        return false;',
'end;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Your XLSX file contains multiple worksheets. Select the worksheet which should be used to create the data load definition. Note that the worksheet is a dynamic attribute of the Data Loading page process, thus it can be selected by the end user on dat'
||'a upload.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2002702586366615)
,p_name=>'P1812_CSV_COL_DELIMITER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(3616624889225788)
,p_prompt=>'Column Delimiter'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'DATA.LOAD.CSV_COL_DELIMITER'
,p_lov=>'.'||wwv_flow_imp.id(1963861252255121)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'None (Auto-Detect)'
,p_cSize=>30
,p_tag_css_classes=>'apex-button-group'
,p_begin_on_new_line=>'N'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P1810_SOURCE_TYPE = ''FILE'' then',
'    if wwv_flow_data_parser.get_file_type( p_file_name => :P1810_FILE) = wwv_flow_data_parser.c_file_type_csv then',
'        return true;',
'    end if;',
'elsif :P1810_SOURCE_TYPE = ''COPY_PASTE'' then',
'    return true;',
'end if;',
'return false;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select a column delimiter character.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2003630333366616)
,p_name=>'P1812_CSV_ENCLOSED'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(3616624889225788)
,p_item_default=>'"'
,p_prompt=>'Enclosed By'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'DATA.LOAD.CSV_ENCLOSED_BY'
,p_lov=>'.'||wwv_flow_imp.id(1966044064255150)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'None'
,p_cSize=>30
,p_tag_css_classes=>'apex-button-group'
,p_begin_on_new_line=>'N'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P1810_SOURCE_TYPE = ''FILE'' then',
'    if wwv_flow_data_parser.get_file_type( p_file_name => :P1810_FILE) = wwv_flow_data_parser.c_file_type_csv then',
'        return true;',
'    end if;',
'elsif :P1810_SOURCE_TYPE = ''COPY_PASTE'' then',
'    return true;',
'end if;',
'return false;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select the character, which optionally encloses column values.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2004564263366617)
,p_name=>'P1812_FILE_CHARSET'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(3616624889225788)
,p_item_default=>'AL32UTF8'
,p_prompt=>'File Encoding'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_IANA_DB_CHARSET'
,p_lov=>'.'||wwv_flow_imp.id(144802427115692411)||'.'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose the characterset in which the file is encoded.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2011367079366634)
,p_name=>'P1812_FILE_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3902593886112664)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2011742280366636)
,p_name=>'P1812_NEW_COL_DELIMITER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3902593886112664)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2012147299366636)
,p_name=>'P1812_PARSED_ROW_COUNT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3902593886112664)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2012583229366637)
,p_name=>'P1812_PARSED_COLUMN_COUNT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(3902593886112664)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2012924785366637)
,p_name=>'P1812_FILE_COLUMN_COUNT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(3902593886112664)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3304550936587418)
,p_name=>'P1812_FILE_INVALID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(3902593886112664)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3304738644587420)
,p_name=>'P1812_MAPPED_COLUMN_COUNT_1'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3304651691587419)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5504487765609244)
,p_name=>'P1812_DATA_LOAD_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(3616624889225788)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(886117878614273007)
,p_name=>'P1812_SKIP_ROWS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3616624889225788)
,p_prompt=>'Skip Rows'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>30
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter how many rows to skip from the beginning of the file, before data parsing starts.'
,p_attribute_01=>'0'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2104464513499742)
,p_computation_sequence=>10
,p_computation_item=>'P1812_FILE_CHARSET'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_bom       raw(4);',
'    l_file_blob blob;',
'    l_charset   varchar2(20) := ''WE8ISO8859P1'';',
'begin ',
'    select f.blob_content',
'      into l_file_blob',
'      from wwv_flow_temp_files f ',
'     where f.name = :P1810_FILE',
'       and :P1810_SOURCE_TYPE = ''FILE'';',
'',
'    if sys.dbms_lob.getlength( l_file_blob ) > 2 then',
'        l_bom := sys.dbms_lob.substr( lob_loc => l_file_blob, amount => 3, offset => 1 );',
'        if l_bom = hextoraw(''EFBBBF'') then',
'            -- UTF-8 BOM',
'            l_charset := ''AL32UTF8'';',
'        else',
'            -- UTF-16 BOM',
'            if sys.utl_raw.substr(l_bom, 1, 2) = hextoraw(''FEFF'') then ',
'                l_charset := ''AL16UTF16''; ',
'            elsif sys.utl_raw.substr(l_bom, 1, 2) = hextoraw(''FFFE'') then ',
'                l_charset := ''AL16UTF16LE''; ',
'            end if; ',
'        end if;',
'    end if;',
'    return l_charset;',
'exception',
'    when NO_DATA_FOUND then',
'        return null;',
'end;'))
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P1810_SOURCE_TYPE   = ''FILE''    and ',
'   :P1810_FILE          is not null and ',
'   :P1812_FILE_CHARSET  is null and',
'   substr( lower ( :P1810_FILE ), -4 ) in ( ''.txt'', ''.csv'', ''.tsv'' ) ',
'then',
'    return true;',
'else',
'    return false;',
'end if;'))
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'FUNCTION_BODY'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3306015189587433)
,p_validation_name=>'validate mapping'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_column_maps   wwv_flow_t_varchar2;',
'    l_table_col_cnt number := 0;',
'begin',
'    -- get column mapping user configured',
'    for l_configure in (',
'        select',
'            c001   column_name,',
'            c002   mapped_column,',
'            c004   group_char,',
'            c005   decimal_char',
'        from wwv_flow_collections',
'        where collection_name = ''APEX$DATALOAD_COLUMNS''',
'        and ( c002 != ''0'' or c002 is not null ))',
'    loop',
'        if l_configure.mapped_column member of l_column_maps then',
'            return wwv_flow_lang.system_message ( ''DATA_LOAD.DUPLICATE_MAPPING'', l_configure.mapped_column );',
'        end if;',
'',
'        -- if group separator defined, decimal character must be defined',
'        if l_configure.group_char is not null then',
'            if l_configure.decimal_char is null then',
'                return wwv_flow_lang.system_message ( ''DATA_LOAD.DECIMAL_CHAR_REQUIRED'', l_configure.mapped_column );',
'            end if;',
'        end if;',
'',
'        wwv_flow_string.push (',
'            p_table => l_column_maps,',
'            p_value => l_configure.mapped_column );',
'    end loop;',
'    ',
'    if l_column_maps is null then',
'        return wwv_flow_lang.system_message( ''DATA.LOAD.COLUMN_MAPPING_REQUIRED'' );',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':REQUEST in ( ''NEXT'', ''CREATE'' )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2013374679366639)
,p_name=>'Shade Headers on Load'
,p_event_sequence=>50
,p_condition_element=>'P1812_FIRST_LINE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'HEADERS'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'lower(:P1810_FILE) like ''%.csv'' or',
'lower(:P1810_FILE) like ''%.txt'' or',
'lower(:P1810_FILE) like ''%.xls_'' or',
':P1810_SOURCE_TYPE = ''COPY_PASTE'''))
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2013899414366643)
,p_event_id=>wwv_flow_imp.id(2013374679366639)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'$("#preview_table").addClass("first-row-headers");'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2014361836366644)
,p_event_id=>wwv_flow_imp.id(2013374679366639)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'$("#preview_table").removeClass("first-row-headers");'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2014790674366644)
,p_name=>'Shade Headers for XML, JSON'
,p_event_sequence=>60
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'lower(:P1810_FILE) like ''%.xml'' or',
'lower(:P1810_FILE) like ''%.json'''))
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2015269367366645)
,p_event_id=>wwv_flow_imp.id(2014790674366644)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'$("#preview_table").addClass("first-row-headers");'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1003712372264784948)
,p_name=>'Refresh on First Line Headers Change'
,p_event_sequence=>75
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1812_FIRST_LINE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1003712442024784949)
,p_event_id=>wwv_flow_imp.id(1003712372264784948)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2404599271372945)
,p_name=>'Refresh XLSX sheet change'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1812_XLSX_SHEET'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2404663336372946)
,p_event_id=>wwv_flow_imp.id(2404599271372945)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2404949653372949)
,p_name=>'Refresh Enclosed By Change'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1812_CSV_ENCLOSED'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2405096652372950)
,p_event_id=>wwv_flow_imp.id(2404949653372949)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3302835519587401)
,p_name=>'Refresh File Charset Change'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1812_FILE_CHARSET'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3302954793587402)
,p_event_id=>wwv_flow_imp.id(3302835519587401)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3304088210587413)
,p_name=>'Adjust display of UI items after page load'
,p_event_sequence=>120
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3304179297587414)
,p_event_id=>wwv_flow_imp.id(3304088210587413)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// replace column count placeholders in header text of parsed data preview region',
'$( "#placeholder_P1812_PARSED_COLUMN_COUNT" ).text( $v( "P1812_PARSED_COLUMN_COUNT" ) );',
'$( "#placeholder_P1812_PARSED_ROW_COUNT"    ).text( $v( "P1812_PARSED_ROW_COUNT"    ) );',
'',
'// set the column delimiter to the actual value, which ',
'// is being determined *after* the item has been rendered, so the browser does not have the correct state.',
'$s( "P1812_CSV_COL_DELIMITER", $v("P1812_NEW_COL_DELIMITER") );',
''))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3304349937587416)
,p_name=>'Refresh column delimiter change'
,p_event_sequence=>130
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1812_CSV_COL_DELIMITER'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3304409171587417)
,p_event_id=>wwv_flow_imp.id(3304349937587416)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(886117909085273008)
,p_name=>'Refresh Skip Rows Change'
,p_event_sequence=>140
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1812_SKIP_ROWS'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(886118014165273009)
,p_event_id=>wwv_flow_imp.id(886117909085273008)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3306607635587439)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create data load'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_data_load_id number;',
'begin',
'    l_data_load_id := wwv_flow_data_loader_dev.create_data_load(',
'                        p_application_id      => :FB_FLOW_ID,',
'                        --',
'                        p_column_collection   => ''APEX$DATALOAD_COLUMNS'',',
'                        p_profile_collection  => ''APEX$DATALOAD'',',
'                        --',
'                        p_use_selector_type   => case when :P1812_FIRST_LINE = ''HEADERS'' then',
'                                                     wwv_flow_plugin_api.c_selector_name',
'                                                 else',
'                                                     wwv_flow_plugin_api.c_selector_seq',
'                                                 end,',
'                        --',
'                        p_data_load_name      => :P1811_NAME,',
'                        p_target_type         => :P1811_TARGET_TYPE,',
'                        p_target_schema       => case :P1811_TARGET_TYPE',
'                                                 when ''TABLE'' then',
'                                                     :P1811_TABLE_OWNER',
'                                                 when ''COLLECTION'' then',
'                                                     :OWNER',
'                                                 end,',
'                        p_target_name         => case :P1811_TARGET_TYPE',
'                                                 when ''TABLE'' then',
'                                                     :P1811_TABLE_NAME',
'                                                 when ''COLLECTION'' then',
'                                                     :P1811_COLLECTION_NAME',
'                                                 end );',
'',
'    :P1812_DATA_LOAD_ID := l_data_load_id;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE, NEXT'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'Data load definition created.'
,p_internal_uid=>3306607635587439
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4613432590691750)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Initialize Create Page Wizard'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_page_type_display     wwv_flow_page_types_dev.page_type_display%type;',
'    l_ut_nav_icon           wwv_flow_page_types_dev.ut_nav_icon%type;',
'    l_navigation_type       wwv_flow_themes.navigation_type%type;',
'    l_navlist_id            wwv_flows.navigation_list_id%type;',
'    l_is_navlist_subscribed varchar2(1);',
'    l_navbar_id             wwv_flows.nav_bar_list_id%type;',
'    l_theme_id              number;',
'    l_is_ut_based           varchar2(1);',
'    l_is_rw_based           varchar2(1);',
'    l_is_font_apex          varchar2(1);',
'begin',
'    htmldb_util.clear_page_cache(2500);',
'',
'    wwv_flow_wizard_api.init_create_page_wiz(',
'        p_application_id        => :FB_FLOW_ID,',
'        p_navigation_type       => l_navigation_type,',
'        p_navlist_id            => l_navlist_id,',
'        p_is_navlist_subscribed => l_is_navlist_subscribed,',
'        p_navbar_id             => l_navbar_id,',
'        p_theme_id              => l_theme_id,',
'        p_is_ut_based           => l_is_ut_based,',
'        p_is_rw_based           => l_is_rw_based,',
'        p_is_font_apex          => l_is_font_apex );',
'',
'    select page_type_display,',
'           case when l_is_ut_based = ''Y'' and l_is_font_apex = ''Y'' then ut_nav_icon end',
'      into l_page_type_display,',
'           l_ut_nav_icon',
'      from wwv_flow_page_types_dev',
'     where page_type = ''DATALOAD'';',
'',
'    htmldb_util.set_session_state( ''P2500_NAVIGATION_TYPE'', l_navigation_type );',
'    htmldb_util.set_session_state( ''P2500_NAVLIST_ID'', l_navlist_id );',
'    htmldb_util.set_session_state( ''P2500_IS_NAVLIST_SUBSCRIBED'', l_is_navlist_subscribed );    ',
'    htmldb_util.set_session_state( ''P2500_NAVBAR_ID'', l_navbar_id );',
'    htmldb_util.set_session_state( ''FB_THEME_ID'', l_theme_id );',
'    htmldb_util.set_session_state( ''P2500_IS_UT_BASED'', l_is_ut_based );',
'    htmldb_util.set_session_state( ''P2500_IS_RW_BASED'', l_is_rw_based );',
'    htmldb_util.set_session_state( ''P2500_IS_FONT_APEX'', l_is_font_apex );',
'    htmldb_util.set_session_state( ''P2500_PAGE_TYPE'', ''DATALOAD'' );',
'    htmldb_util.set_session_state( ''P2500_PAGE_TYPE_DISPLAY'', l_page_type_display );',
'    htmldb_util.set_session_state( ''P2500_UT_NAV_ICON'', l_ut_nav_icon );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1999513044366605)
,p_internal_uid=>4613432590691750
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2403840993372938)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'init columns collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_data_loader_dev.init_column_collection(',
'    p_column_collection   => ''APEX$DATALOAD_COLUMNS'',',
'    p_profile_collection  => ''APEX$DATALOAD'',',
'    --',
'    p_target_type         => :P1811_TARGET_TYPE,',
'    p_target_schema       => case :P1811_TARGET_TYPE',
'                             when ''TABLE'' then',
'                                 :P1811_TABLE_OWNER',
'                             when ''COLLECTION'' then',
'                                 :OWNER',
'                             end,',
'    p_target_name        => case :P1811_TARGET_TYPE',
'                             when ''TABLE'' then',
'                                 :P1811_TABLE_NAME',
'                             when ''COLLECTION'' then',
'                                 ''WWV_FLOW_COLLECTIONS''',
'                             end );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST in ( ''NEXT'', ''CREATE'' ) and wwv_flow_collection.collection_member_count(',
'    p_collection_name => ''APEX$DATALOAD_COLUMNS'' ) = 0'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>2403840993372938
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2404064341372940)
,p_process_sequence=>40
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_region_id=>wwv_flow_imp.id(3304651691587419)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update Table Column Mapping - IG Data'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.update_member(',
'        p_collection_name => ''APEX$DATALOAD_COLUMNS'',',
'        p_seq             => :COLUMN_SEQ,',
'        p_c001            => :COLUMN_NAME,        -- column_name',
'        p_c002            => :TAB_COL_MAP,        -- mapped table column',
'        p_c003            => :FORMAT_MASK,        -- format mask',
'        p_c004            => :GROUP_CHAR,         -- group char',
'        p_c005            => :DECIMAL_CHAR,       -- decimal char',
'        p_c006            => :IS_PK               -- is PK      ',
'        );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST in ( ''NEXT'', ''CREATE'' ) and wwv_flow_collection.collection_member_count(',
'    p_collection_name => ''APEX$DATALOAD_COLUMNS'' ) > 0 and :P1811_TARGET_TYPE = ''TABLE'''))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>2404064341372940
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2404140697372941)
,p_process_sequence=>50
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_region_id=>wwv_flow_imp.id(3304651691587419)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update Collection Column Mapping - IG Data'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.update_member(',
'        p_collection_name => ''APEX$DATALOAD_COLUMNS'',',
'        p_seq             => :COLUMN_SEQ,',
'        p_c001            => :COLUMN_NAME,        -- column_name',
'        p_c002            => :COLLECTION_COL_MAP,  -- mapped collection column',
'        p_c003            => :FORMAT_MASK,        -- format mask',
'        p_c004            => :GROUP_CHAR,         -- group char',
'        p_c005            => :DECIMAL_CHAR,       -- decimal char',
'        p_c006            => :IS_PK               -- is PK      ',
'        );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST in ( ''NEXT'', ''CREATE'' ) and wwv_flow_collection.collection_member_count(',
'    p_collection_name => ''APEX$DATALOAD_COLUMNS'' ) > 0 and :P1811_TARGET_TYPE = ''COLLECTION'''))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>2404140697372941
);
end;
/
prompt --application/pages/page_01815
begin
wwv_flow_imp_page.create_page(
 p_id=>1815
,p_name=>'Create Data Load - Method'
,p_alias=>'CREATE-DATA-LOAD-METHOD'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Data Load - Method'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213425326892450628)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'600'
,p_dialog_width=>'80%'
,p_dialog_max_width=>'1000'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'sec_authentication.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1685074406077372082)
,p_plug_name=>'Create Data Load'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_header=>'<p>When you create a new Data Load Definition, you have two options. You can create a new Data Load Definition from scratch or reuse implementations that already exist in your application or in other applications within your workspace.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1685075086116372098)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(3306223094711954)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1685075334902372098)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1685075947472372104)
,p_plug_name=>'Create Data Load'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3302651020698256)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1685075334902372098)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3303013063698258)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1685075334902372098)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3304756298698280)
,p_branch_name=>'Go To Page Copy'
,p_branch_action=>'f?p=&APP_ID.:1816:&SESSION.::&DEBUG.:1816,1817::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(3303013063698258)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1815_CREATE_METHOD'
,p_branch_condition_text=>'COPY'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3305193299698282)
,p_branch_name=>'Go To Page Create'
,p_branch_action=>'f?p=&APP_ID.:1811:&SESSION.::&DEBUG.:RP,1810,1811,1812,1813,APEX$DATALOAD,APEX$DATALOAD_COLUMNS::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(3303013063698258)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1815_CREATE_METHOD'
,p_branch_condition_text=>'CREATE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3301171893698248)
,p_name=>'P1815_CREATE_METHOD'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1685074406077372082)
,p_item_default=>'CREATE'
,p_prompt=>'Create Data Load:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DATA.LOAD.CREATE_METHOD'
,p_lov=>'.'||wwv_flow_imp.id(3313626961776680)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_escape_on_http_output=>'N'
,p_help_text=>'Select the method by which you would like to create the Data Load Definition.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3303732434698278)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3302651020698256)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3304294513698279)
,p_event_id=>wwv_flow_imp.id(3303732434698278)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_01816
begin
wwv_flow_imp_page.create_page(
 p_id=>1816
,p_name=>'Create Data Load - Application'
,p_alias=>'CREATE-DATA-LOAD-APPLICATION'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Data Load - Application'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213425326892450628)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'600'
,p_dialog_width=>'80%'
,p_dialog_max_width=>'1000'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'sec_authentication.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1685206841715648152)
,p_plug_name=>'Create Data Load'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_header=>'<p>Use this page to copy a Data Load Definition from another application.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1685207560420648153)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(3306223094711954)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1685207770081648153)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1685208543132648155)
,p_plug_name=>'Create Data Load'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3368967070872566)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(1685207770081648153)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3369340085872567)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1685207770081648153)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1815:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3370130567872582)
,p_branch_name=>'Go To Page 1817'
,p_branch_action=>'f?p=&APP_ID.:1817:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(3368967070872566)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3367499518872563)
,p_name=>'P1816_COPY_FROM'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1685206841715648152)
,p_prompt=>'Copy From Application'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'       f.id||'' ''||f.name as d,',
'       f.id as rr',
'  from wwv_flows f',
' where f.security_group_id = :WORKSPACE_ID',
'   and exists ( select 1',
'                  from wwv_flow_load_tables a',
'                 where a.flow_id = f.id',
'                 and data_profile_id is not null',
'              )',
' order by f.id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select an Application -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Select an application to copy the data load definition from.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
end;
/
prompt --application/pages/page_01817
begin
wwv_flow_imp_page.create_page(
 p_id=>1817
,p_name=>'Create Data Load - As Copy'
,p_alias=>'CREATE-DATA-LOAD-COPY'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Data Load - As Copy'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213425326892450628)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'600'
,p_dialog_width=>'80%'
,p_dialog_max_width=>'1000'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'sec_authentication.htm'
,p_page_component_map=>'01'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(1591625356552601822)
,p_name=>'Create Data Load'
,p_template=>wwv_flow_imp.id(42025417508627628)
,p_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ROWID,',
'       id,',
'       name,',
'       case when reference_id is not null then ''Y'' else ''N'' end as is_subscribed,',
'       case',
'         when reference_id is null and :P1816_COPY_FROM = :FB_FLOW_ID then wwv_flow_lang.system_message( ''F4000.P158.COPY_OF'', name )',
'         else name',
'       end as new_name,',
'       case',
'         when :P1816_COPY_FROM = :FB_FLOW_ID then ''N''',
'         when reference_id is not null       then ''Y''',
'         else ''SUBSCRIBE''',
'       end as action',
'  from wwv_flow_load_tables a',
' where flow_id           = :P1816_COPY_FROM',
'   and security_group_id = :WORKSPACE_ID',
'   and data_profile_id is not null',
'   and (',
'       -- Don''t show subscribed data load, because they can''t be copied',
'          (   :P1816_COPY_FROM = :FB_FLOW_ID',
'          and reference_id is null',
'          )',
'       -- Don''t show data load in which have already been copied from another application',
'       or (   :P1816_COPY_FROM <> :FB_FLOW_ID',
'          and not exists ( select 1',
'                             from wwv_flow_load_tables b',
'                            where b.flow_id           = :FB_FLOW_ID',
'                              and b.security_group_id = :WORKSPACE_ID',
'                              and data_profile_id is not null',
'                              and b.name              = a.name',
'                         )',
'          )',
'       )',
' order by name',
''))
,p_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Identify the Data Load Definition to be copied and select the copy option. Copy options include:</p>',
'<ul>',
'    <li><strong>Yes.</strong> Copy the Data Load.</li>',
'    <li><strong>No.</strong> Do not copy this Data Load.</li>',
'    <li><strong>Copy and Subscribe.</strong> Subscribing to a Data Load puts a copy of it in your application and sets the Data Load master reference.</li>',
'</ul>',
''))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3374614647928817)
,p_query_column_id=>1
,p_column_alias=>'ROWID'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3375021491928819)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3375444452928819)
,p_query_column_id=>3
,p_column_alias=>'NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Name'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3375851531928819)
,p_query_column_id=>4
,p_column_alias=>'IS_SUBSCRIBED'
,p_column_display_sequence=>4
,p_column_heading=>'Subscribed'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(84259319526460470)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3376246078928819)
,p_query_column_id=>5
,p_column_alias=>'NEW_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'To Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_column_width=>40
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3376662401928820)
,p_query_column_id=>6
,p_column_alias=>'ACTION'
,p_column_display_sequence=>6
,p_column_heading=>'Action'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'SELECT_LIST_FROM_LOV'
,p_named_lov=>wwv_flow_imp.id(3387269549000655)
,p_lov_show_nulls=>'NO'
,p_derived_column=>'N'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1685229289886778919)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(3306223094711954)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1685229473163778920)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1685230254950778922)
,p_plug_name=>'Create Data Load'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3379115342928822)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1685229473163778920)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy Data Load Definition'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3379547540928822)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(1685229473163778920)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1816:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3379971972928823)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(1685229473163778920)
,p_button_name=>'DESELECT_ALL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--padLeft'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Deselect All'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3381606484928825)
,p_branch_name=>'Go To Page Data Load Definitions'
,p_branch_action=>'f?p=&APP_ID.:1800:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3377131920928820)
,p_tabular_form_region_id=>wwv_flow_imp.id(1591625356552601822)
,p_validation_name=>'Name must be unique'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_load_tables',
' where security_group_id  = :FLOW_SECURITY_GROUP_ID',
'   and flow_id            = :FB_FLOW_ID',
'   and data_profile_id   is not null',
'   and name               = :NEW_NAME ',
'   and :ACTION           in (''Y'', ''SUBSCRIBE'')'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'This name is already used by an existing Data Load Definition.'
,p_when_button_pressed=>wwv_flow_imp.id(3379115342928822)
,p_only_for_changed_rows=>'N'
,p_associated_column=>'NEW_NAME'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3377508710928821)
,p_tabular_form_region_id=>wwv_flow_imp.id(1591625356552601822)
,p_validation_name=>'Static ID must be unique'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_load_tables',
' where security_group_id  = :FLOW_SECURITY_GROUP_ID',
'   and flow_id            = :FB_FLOW_ID',
'   and data_profile_id   is not null',
'   and static_id          = regexp_replace( lower( :NEW_NAME ), ''[^abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890]+'', ''_'' )',
'   and :ACTION           in (''Y'', ''SUBSCRIBE'')'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'The REST Source name "&NEW_NAME!HTML." will lead to a static ID which is already taken by another Data Load Definition.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_load_tables',
' where security_group_id  = :FLOW_SECURITY_GROUP_ID',
'   and flow_id            = :FB_FLOW_ID',
'   and data_profile_id   is not null',
'   and name               = :NEW_NAME ',
'   and :ACTION           in (''Y'', ''SUBSCRIBE'')'))
,p_validation_condition_type=>'NOT_EXISTS'
,p_when_button_pressed=>wwv_flow_imp.id(3379115342928822)
,p_exec_cond_for_each_row=>'Y'
,p_only_for_changed_rows=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3380673082928824)
,p_name=>'Deselect All'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3379971972928823)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3381156489928825)
,p_event_id=>wwv_flow_imp.id(3380673082928824)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'td[headers=ACTION] select'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3377800779928821)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(1591625356552601822)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Data Load Definition'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_id   number;',
'begin',
'   if :ACTION in (''Y'', ''SUBSCRIBE'') then',
'        l_id := wwv_flow_data_loader_dev.copy_data_load (',
'                    p_from_application_id => :P1816_COPY_FROM,',
'                    p_from_data_load_id   => :ID,',
'                    p_to_application_id   => :FB_FLOW_ID,',
'                    p_to_name             => :NEW_NAME,',
'                    p_subscribe           => ( :ACTION = ''SUBSCRIBE'' ));',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to copy Data Load Definition.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(247699430129474724)
,p_only_for_changed_rows=>'N'
,p_process_success_message=>'Data Load Definition copied.'
,p_internal_uid=>3377800779928821
);
end;
/
prompt --application/pages/page_01820
begin
wwv_flow_imp_page.create_page(
 p_id=>1820
,p_name=>'Edit Data Load'
,p_alias=>'EDIT-DATA-LOAD'
,p_step_title=>'Edit Data Load'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(1449603451873552)
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_read_only_when=>'P1820_REFERENCE_ID'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2102240269346920)
,p_plug_name=>'Subscription'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'WWV_FLOW_LOAD_TABLES',
  'attribute_02', 'NAME',
  'attribute_03', 'P1820_ID',
  'attribute_04', 'P1820_REFERENCE_ID',
  'attribute_05', 'SUBSCRIBE_DATA_LOAD',
  'attribute_06', 'VERSION_SCN')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2561095520654008)
,p_plug_name=>'Settings'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2561562676654013)
,p_plug_name=>'Target'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4804039483918701)
,p_plug_name=>'No Profile Cols Match Target Table Warning'
,p_parent_plug_id=>wwv_flow_imp.id(2561562676654013)
,p_region_css_classes=>'a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--danger:a-Alert--horizontal'
,p_region_attributes=>'style="display:none;"'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'There is no data profile column(s) match the target table columns.  Loading data using this definition will raise an error.  Please select the table matching the data profile column or edit the data profile column to match the target table column nam'
||'e.'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P1820_TARGET_TYPE'
,p_plug_display_when_cond2=>'TABLE'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2561680773654014)
,p_plug_name=>'Error Handling'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(97783562090282000)
,p_plug_name=>'Data Load'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(98461244952314959)
,p_plug_name=>'Comments'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(130842348178692454)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(494860436524911651)
,p_name=>'Data Profile'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-BadgeList--fixed:a-BadgeList--xlarge'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    dp.format,',
'    --dp.csv_separator,',
'    --dp.csv_enclosed,',
'    --dp.default_xlsx_sheet_name,',
'    count( dc.id ) as column_cnt',
'from wwv_flow_data_profiles dp, wwv_flow_data_profile_cols dc',
'where dc.data_profile_id (+) = dp.id',
'  and dp.flow_id           = :FB_FLOW_ID',
'  and dp.security_group_id = :FLOW_SECURITY_GROUP_ID',
'  and dp.id                = :P1820_DATA_PROFILE_ID',
'group by dp.format'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P1820_DATA_PROFILE_ID'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(1041640454953406573)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No data profile defined.'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1526499224234220)
,p_query_column_id=>1
,p_column_alias=>'FORMAT'
,p_column_display_sequence=>32
,p_column_heading=>'Format'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2560372526654001)
,p_query_column_id=>2
,p_column_alias=>'COLUMN_CNT'
,p_column_display_sequence=>82
,p_column_heading=>'Columns'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(617080575279095222)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_imp.id(29434107863295859)
,p_plug_display_sequence=>90
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'    select last_updated_by, last_updated_on, created_by, created_on ',
'    from  wwv_flow_load_tables',
'    where id = :P1820_ID',
'    and flow_id = :fb_flow_id',
'    and security_group_id = :flow_security_group_id)',
'loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :P1820_ID,',
'      p_component_type => ''Data Load'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(687682638763131719)
,p_plug_name=>'Data Load'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_LOAD_TABLES'
,p_query_where=>'security_group_id = :WORKSPACE_ID and flow_id = :FB_FLOW_ID'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'u:d'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1491435915216601)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(494860436524911651)
,p_button_name=>'EDIT_DATA_PROFILE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'Edit Data Profile'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'javascript:apex.submit({request:"APPLY_CHANGES_EDIT_DATA_PROFILE"});'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1505175224216609)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(97783562090282000)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1800:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1505506467216610)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(97783562090282000)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.confirm(htmldb_delete_message,''DELETE'');'
,p_button_execute_validations=>'N'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1820_ID is not null',
'and ( :P1820_REFERENCE_ID is null or :P1820_SUBSCRIBED_COMP_GRP = ''N'' )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1505976442216610)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(97783562090282000)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    :P1820_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3509768116216430)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(2102240269346920)
,p_button_name=>'PUBLISH'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Publish'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.:RP,:F4000_P149_ID,F4000_P149_PAGE_ID,F4000_P149_TEMPLATE_TYPE:&P1820_ID.,&APP_PAGE_ID.,DATA_LOAD'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_load_tables',
' where reference_id = :P1820_ID',
' and data_profile_id is not null'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3510368465219185)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(2102240269346920)
,p_button_name=>'UNSUBSCRIBE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Unsubscribe'
,p_button_position=>'NEXT'
,p_button_condition=>':P1820_REFERENCE_ID is not null and :P1820_SUBSCRIBED_COMP_GRP = ''N'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3510049858217959)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_imp.id(2102240269346920)
,p_button_name=>'REFRESH_SUB'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Refresh'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1820_REFERENCE_ID is not null ',
'and ( :P1820_VERSION_SCN != :P1820_MASTER_VERSION_SCN or :P1820_VERSION_SCN is null )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2242701251021533)
,p_branch_name=>'Go To Page 1925'
,p_branch_action=>'f?p=&APP_ID.:1925:&SESSION.::&DEBUG.::P1925_DATA_PROFILE_ID,P1925_BACK_TO_PAGE,P1925_REFERENCE_ID:&P1820_DATA_PROFILE_ID.,1820,&P1820_REFERENCE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_EDIT_DATA_PROFILE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1512622436216633)
,p_branch_name=>'Go To Page 1800'
,p_branch_action=>'f?p=&APP_ID.:1800:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'REQUEST_IN_CONDITION'
,p_branch_condition=>'SAVE, DELETE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1417093864012508)
,p_name=>'P1820_SUBSCRIBED_COMP_GRP'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(2102240269346920)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1475715572216581)
,p_name=>'P1820_COMMENTS'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(98461244952314959)
,p_item_source_plug_id=>wwv_flow_imp.id(687682638763131719)
,p_prompt=>'Comments'
,p_source=>'COMMENTS'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter any developer comments or notes here. These comments only display within App Builder and never display when running the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1492406330216602)
,p_name=>'P1820_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(687682638763131719)
,p_item_source_plug_id=>wwv_flow_imp.id(687682638763131719)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1493297589216602)
,p_name=>'P1820_NAME'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(687682638763131719)
,p_item_source_plug_id=>wwv_flow_imp.id(687682638763131719)
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'The name for the data load definition.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1494187761216602)
,p_name=>'P1820_TABLE_OWNER'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2561562676654013)
,p_item_source_plug_id=>wwv_flow_imp.id(687682638763131719)
,p_prompt=>'Table Owner'
,p_source=>'OWNER'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_SCHEMAS_HAVE_PRIVS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(owner) d, owner v',
'  from wwv_flow_object_owners_dev',
'order by d                   '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Parsing Schema -'
,p_cHeight=>1
,p_display_when=>'P1820_TARGET_TYPE'
,p_display_when2=>'TABLE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'The owner of the table, which the data will be loaded to.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1495007758216603)
,p_name=>'P1820_TABLE_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(2561562676654013)
,p_item_source_plug_id=>wwv_flow_imp.id(687682638763131719)
,p_prompt=>'Table Name'
,p_source=>'TABLE_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = coalesce( :P1820_TABLE_OWNER, upper(wwv_flow_wizard_api.get_flow_owner(:FB_FLOW_ID)))'))
,p_lov_cascade_parent_items=>'P1820_TABLE_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>60
,p_cMaxlength=>255
,p_display_when=>'P1820_TARGET_TYPE'
,p_display_when2=>'TABLE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'The name of the table, which the data will be loaded to.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1524598699234201)
,p_name=>'P1820_ERROR_COLLECTION_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(2561680773654014)
,p_item_source_plug_id=>wwv_flow_imp.id(687682638763131719)
,p_prompt=>'Error Collection Name'
,p_source=>'ERROR_COLLECTION_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>128
,p_tag_attributes=>'style="text-transform: uppercase;"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Enter the &PRODUCT_NAME. collection name. When an error occurs during data loading, &PRODUCT_NAME. will store the error message and the row sequence (within the uploaded file) as the <strong>C001</strong> and <strong>N001</strong> collection members.'
||' ',
'</p>',
'<p>',
'Use the APEX_COLLECTIONS view to retrieve and process this information within the APEX application.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1535267752420629)
,p_name=>'P1820_BREADCRUMB_NAME'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(687682638763131719)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1806227022557142)
,p_name=>'P1820_STATIC_ID'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(687682638763131719)
,p_item_source_plug_id=>wwv_flow_imp.id(687682638763131719)
,p_prompt=>'Static ID'
,p_source=>'STATIC_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Use the Static ID to reference the Data Load definition in API Calls.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1806396205557143)
,p_name=>'P1820_TARGET_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2561562676654013)
,p_item_source_plug_id=>wwv_flow_imp.id(687682638763131719)
,p_prompt=>'Target Type'
,p_source=>'TARGET_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DATA.LOAD.TARGET_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(1633774479940540)||'.'
,p_read_only_when=>'P1820_ID'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select whether data is to be loaded into a table or an &PRODUCT_NAME. collection.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1806612235557146)
,p_name=>'P1820_COLLECTION_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(2561562676654013)
,p_item_source_plug_id=>wwv_flow_imp.id(687682638763131719)
,p_prompt=>'Collection Name'
,p_source=>'COLLECTION_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>128
,p_tag_attributes=>'style="text-transform: uppercase;"'
,p_display_when=>'P1820_TARGET_TYPE'
,p_display_when2=>'COLLECTION'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter the &PRODUCT_NAME. collection name to temporarily store the data for the session.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1806779933557147)
,p_name=>'P1820_DATA_PROFILE_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(687682638763131719)
,p_item_source_plug_id=>wwv_flow_imp.id(687682638763131719)
,p_source=>'DATA_PROFILE_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1806886337557148)
,p_name=>'P1820_LOADING_METHOD'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(2561095520654008)
,p_item_source_plug_id=>wwv_flow_imp.id(687682638763131719)
,p_prompt=>'Loading Method'
,p_source=>'LOADING_METHOD'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DATA.LOAD.METHOD'
,p_lov=>'.'||wwv_flow_imp.id(2101544010414427)||'.'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Specify the loading method to use. Possible values are:',
'</p>',
'<ul>',
'    <li><strong>Append</strong>: Append rows to the table or collection. If one or more primary key columns are defined in the <em>Data Profile</em>, existing rows will not be changed, and new rows will be appended. If the data profile has no primary'
||' key definition, all rows will be simply appended.</li>',
'    <li><strong>Merge</strong>: Merge rows into the table. The data profile must have a <em>Primary Key</em> defined to use this option. If a row for the given primary key value exists, the row will be updated, otherwise the row will be created. This'
||' is only available for loading data into tables.</li>',
'    <li><strong>Replace</strong>: Existing data in the target table or collection will be removed before new data is loaded.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1806971649557149)
,p_name=>'P1820_COMMIT_INTERVAL'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(2561095520654008)
,p_item_source_plug_id=>wwv_flow_imp.id(687682638763131719)
,p_prompt=>'Commit Interval'
,p_source=>'COMMIT_INTERVAL'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>10
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Specify the commit interval to use during data load. If no commit interval is specified, the whole data load will be in one transaction, with a commit after the last row. If an interval is specified, &PRODUCT_NAME. will commit each time after the spe'
||'cified amount of rows have been processed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'100'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1807078271557150)
,p_name=>'P1820_ERROR_HANDLING'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(2561680773654014)
,p_item_source_plug_id=>wwv_flow_imp.id(687682638763131719)
,p_prompt=>'When on Error'
,p_source=>'ERROR_HANDLING'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DATA.LOAD.ERROR_HANDLING'
,p_lov=>'.'||wwv_flow_imp.id(2102956113429319)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Specify how to handle errors during data load. Possible values are:',
'</p>',
'<ul>',
'    <li><strong>Ignore</strong>: The error rows are silently ignored, and Data Loading simply continues.</li>',
'    <li><strong>Stop</strong>: The data loading stops on the first error and raises an error message.</li>',
'    <li><strong>Log into Collection</strong>: Error rows are logged into an &PRODUCT_NAME. collection.</li>',
'    <li><strong>Log into Error Log</strong>: Error rows are logged into a DML error logging table using the <strong>DML Error Logging</strong> database functionality. This is only available when loading into a table, and only if the <strong>Append</s'
||'trong> method is used <em>without</em> a primary key.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2102356851346921)
,p_name=>'P1820_REFERENCE_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(2102240269346920)
,p_item_source_plug_id=>wwv_flow_imp.id(687682638763131719)
,p_source=>'REFERENCE_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2563578393654033)
,p_name=>'P1820_FLOW_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(687682638763131719)
,p_item_source_plug_id=>wwv_flow_imp.id(687682638763131719)
,p_source=>'FLOW_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4700971218940005)
,p_name=>'P1820_TABLE_ERR_LOG_NAME'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(2561680773654014)
,p_prompt=>'Error Logging Table'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = coalesce( :P1820_TABLE_OWNER, upper(wwv_flow_wizard_api.get_flow_owner(:FB_FLOW_ID)))',
' and object_type = ''TABLE'''))
,p_lov_cascade_parent_items=>'P1820_TABLE_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>60
,p_cMaxlength=>128
,p_tag_attributes=>'style="text-transform: uppercase;"'
,p_display_when=>'P1820_TARGET_TYPE'
,p_display_when2=>'TABLE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the name of the <em>DML Error Logging Table</em>, which has been created for the selected target table before. Use <strong>DBMS_ERRLOG.CREATE_ERROR_LOG</strong> to create the error logging table.',
'</p>',
'<p>Example:</p>',
'<pre>',
'begin',
'    dbms_errlog.create_error_log(',
'        dml_table_name => ''<em>{target table}</em>'' );',
'end;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4804111899918702)
,p_name=>'P1820_PROFILE_COL_MATCH_CNT'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(2561562676654013)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11094092852588029)
,p_name=>'P1820_VERSION_SCN'
,p_source_data_type=>'NUMBER'
,p_is_query_only=>true
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(2102240269346920)
,p_item_source_plug_id=>wwv_flow_imp.id(687682638763131719)
,p_source=>'VERSION_SCN'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11094147409588030)
,p_name=>'P1820_MASTER_VERSION_SCN'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(2102240269346920)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select version_scn ',
'  from wwv_flow_load_tables',
' where id                = :P1820_REFERENCE_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11094371063588032)
,p_name=>'P1820_REFERENCE_ID_INIT'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(687682638763131719)
,p_item_default=>'P1820_REFERENCE_ID'
,p_item_default_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1417164213012509)
,p_computation_sequence=>10
,p_computation_item=>'P1820_SUBSCRIBED_COMP_GRP'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_component_group_dev.is_part_of_subscribed_comp_grp (',
'    p_component_id   => :P1820_ID,',
'    p_component_type => wwv_flow_copy_metadata.c_data_load,',
'    p_app_id         => :FB_FLOW_ID )'))
,p_compute_when=>'P1820_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(4701469159940010)
,p_computation_sequence=>10
,p_computation_item=>'P1820_ERROR_COLLECTION_NAME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P1820_TABLE_ERR_LOG_NAME'
,p_compute_when=>':REQUEST = ''SAVE'' and :P1820_TARGET_TYPE = ''TABLE'' and :P1820_ERROR_HANDLING = ''ERROR_LOG'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1535310478420630)
,p_computation_sequence=>10
,p_computation_item=>'P1820_BREADCRUMB_NAME'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P1820_NAME'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1506812163216627)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'&APP_PAGE_ID.'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2561149919654009)
,p_validation_name=>'valid static ID'
,p_validation_sequence=>10
,p_validation=>'P1820_STATIC_ID'
,p_validation_type=>'ITEM_IS_ALPHANUMERIC'
,p_error_message=>'Identifier may only contain alphanumeric characters and "_".'
,p_when_button_pressed=>wwv_flow_imp.id(1505976442216610)
,p_associated_item=>wwv_flow_imp.id(1806227022557142)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3100518337092967)
,p_validation_name=>'name exists'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /*+ NO_INDEX( wwv_flow_load_tables wwv_flow_load_tab_uk2 ) */ 1',
'from wwv_flow_load_tables',
'where name = :P1820_NAME',
'and flow_id = :FB_FLOW_ID',
'and security_group_id = :WORKSPACE_ID',
'and id != :P1820_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'The name is already used by another data load definition.'
,p_when_button_pressed=>wwv_flow_imp.id(1505976442216610)
,p_associated_item=>wwv_flow_imp.id(1493297589216602)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5268996876575503)
,p_validation_name=>'static ID exists'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /*+ NO_INDEX( wwv_flow_load_tables wwv_flow_load_tab_uk2 ) */ 1',
'from wwv_flow_load_tables',
'where static_id = :P1820_STATIC_ID',
'and flow_id = :FB_FLOW_ID',
'and security_group_id = :WORKSPACE_ID',
'and id != :P1820_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'The Static ID is already used by another data load definition.'
,p_when_button_pressed=>wwv_flow_imp.id(1505976442216610)
,p_associated_item=>wwv_flow_imp.id(1806227022557142)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3100833842094692)
,p_validation_name=>'table required'
,p_validation_sequence=>40
,p_validation=>'P1820_TABLE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified'
,p_validation_condition=>'P1820_TARGET_TYPE'
,p_validation_condition2=>'TABLE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(1505976442216610)
,p_associated_item=>wwv_flow_imp.id(1495007758216603)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(47649011248672701)
,p_validation_name=>'Chosen Table Exists'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_tables_views_dev',
' where object_name = :P1820_TABLE_NAME',
'   and owner       = coalesce( :P1820_TABLE_OWNER, upper(wwv_flow_wizard_api.get_flow_owner(:FB_FLOW_ID)))'))
,p_validation_type=>'EXISTS'
,p_error_message=>'Table &P1820_TABLE_NAME!HTML. does not exist. Note that the table name is case-sensitive.'
,p_validation_condition=>':P1820_TARGET_TYPE = ''TABLE'' and :P1820_TABLE_NAME is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(1505976442216610)
,p_associated_item=>wwv_flow_imp.id(1495007758216603)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3101182690095855)
,p_validation_name=>'collection name required'
,p_validation_sequence=>60
,p_validation=>'P1820_COLLECTION_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified'
,p_validation_condition=>'P1820_TARGET_TYPE'
,p_validation_condition2=>'COLLECTION'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(1505976442216610)
,p_associated_item=>wwv_flow_imp.id(1806612235557146)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2561788610654015)
,p_validation_name=>'error collection name required'
,p_validation_sequence=>70
,p_validation=>'P1820_ERROR_COLLECTION_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified'
,p_validation_condition=>'P1820_ERROR_HANDLING'
,p_validation_condition2=>'LOG_ROWS'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(1505976442216610)
,p_associated_item=>wwv_flow_imp.id(1524598699234201)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4701068399940006)
,p_validation_name=>'error log name required'
,p_validation_sequence=>80
,p_validation=>'P1820_TABLE_ERR_LOG_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified'
,p_validation_condition=>'P1820_ERROR_HANDLING'
,p_validation_condition2=>'ERROR_LOG'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(1505976442216610)
,p_associated_item=>wwv_flow_imp.id(4700971218940005)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4504760236479031)
,p_validation_name=>'error log not supported'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P1820_LOADING_METHOD = ''APPEND'' and',
'   wwv_flow_data_loader_dev.is_pk_profile_col_defined(',
'       p_application_id => :FB_FLOW_ID,',
'       p_data_load_id   => :P1820_ID )',
'then',
'    -- if APPEND and PK defined, DML error log not supported',
'    return false;',
'elsif :P1820_LOADING_METHOD = ''MERGE''  then',
'    -- DML error log not supported for MERGE load',
'    return false;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Log into Error Log not supported for Merge loading method nor Append loading method if a primary key column defined.'
,p_validation_condition=>'P1820_ERROR_HANDLING'
,p_validation_condition2=>'ERROR_LOG'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(1505976442216610)
,p_associated_item=>wwv_flow_imp.id(1807078271557150)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4320117509183303)
,p_validation_name=>'Data Load still referenced'
,p_validation_sequence=>100
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not wwv_flow_data_loader_dev.is_data_load_used(',
'    p_application_id => :FB_FLOW_ID,',
'    p_data_load_id   => :P1820_ID )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'This Data Load definition is being referenced by application components, so you cannot delete it.'
,p_when_button_pressed=>wwv_flow_imp.id(1505506467216610)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5268836072575502)
,p_validation_name=>'loading method not null'
,p_validation_sequence=>110
,p_validation=>'P1820_LOADING_METHOD'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(1505976442216610)
,p_associated_item=>wwv_flow_imp.id(1806886337557148)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4504695891479030)
,p_validation_name=>'MERGE, pk required'
,p_validation_sequence=>120
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_data_loader_dev.is_pk_profile_col_defined(',
'    p_application_id => :FB_FLOW_ID,',
'    p_data_load_id   => :P1820_ID )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'The data profile does not have any primary key column defined. Merge loading method must have a primary key column.'
,p_validation_condition=>'P1820_LOADING_METHOD'
,p_validation_condition2=>'MERGE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(1505976442216610)
,p_associated_item=>wwv_flow_imp.id(1806886337557148)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2612684817473996)
,p_validation_name=>'Not part of component groups'
,p_validation_sequence=>130
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not wwv_flow_component_group_dev.is_part_of_comp_grp (',
'    p_component_id   => :P1820_ID,',
'    p_component_type => wwv_flow_copy_metadata.c_data_load,',
'    p_app_id         => :FB_FLOW_ID )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Data Load cannot be deleted because it is part of a component group.'
,p_when_button_pressed=>wwv_flow_imp.id(1505506467216610)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2561213772654010)
,p_name=>'toggle error collection'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1820_ERROR_HANDLING'
,p_condition_element=>'P1820_ERROR_HANDLING'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'LOG_ROWS'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2561355377654011)
,p_event_id=>wwv_flow_imp.id(2561213772654010)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1820_ERROR_COLLECTION_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2561487062654012)
,p_event_id=>wwv_flow_imp.id(2561213772654010)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1820_ERROR_COLLECTION_NAME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4701123962940007)
,p_name=>'toggle error log if target is table'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1820_ERROR_HANDLING'
,p_condition_element=>'P1820_ERROR_HANDLING'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'ERROR_LOG'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4701279994940008)
,p_event_id=>wwv_flow_imp.id(4701123962940007)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1820_TABLE_ERR_LOG_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4701309464940009)
,p_event_id=>wwv_flow_imp.id(4701123962940007)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1820_TABLE_ERR_LOG_NAME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4804282490918703)
,p_name=>'compute profile col match count'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1820_TABLE_NAME'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.item("P1820_TARGET_TYPE").getValue() === "TABLE" &&',
'!apex.item("P1820_TABLE_NAME").isEmpty()'))
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4804365822918704)
,p_event_id=>wwv_flow_imp.id(4804282490918703)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*)',
'into :P1820_PROFILE_COL_MATCH_CNT',
'from wwv_flow_data_profile_cols p, wwv_flow_table_columns_dev t',
'where flow_id = :FB_FLOW_ID',
'and security_group_id = :WORKSPACE_ID',
'and data_profile_id = :P1820_DATA_PROFILE_ID',
'and p.name = t.column_name',
'and owner = coalesce( :P1820_TABLE_OWNER, upper(wwv_flow_wizard_api.get_flow_owner(:FB_FLOW_ID)))',
'and table_name = :P1820_TABLE_NAME;'))
,p_attribute_02=>'P1820_TABLE_OWNER,P1820_TABLE_NAME,P1820_DATA_PROFILE_ID'
,p_attribute_03=>'P1820_PROFILE_COL_MATCH_CNT'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4805558988918716)
,p_name=>'show no profile col match error'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1820_TABLE_NAME,P1820_PROFILE_COL_MATCH_CNT'
,p_condition_element=>'P1820_PROFILE_COL_MATCH_CNT'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'0'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4805648152918717)
,p_event_id=>wwv_flow_imp.id(4805558988918716)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(4804039483918701)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4805864336918719)
,p_event_id=>wwv_flow_imp.id(4805558988918716)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(4804039483918701)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(691709681702978123)
,p_name=>'Edit Data Profile'
,p_event_sequence=>120
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(494860436524911651)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(691709780126978124)
,p_event_id=>wwv_flow_imp.id(691709681702978123)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(494860436524911651)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2563778350654035)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'delete data profile'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from wwv_flow_data_profiles',
'where id = :P1820_DATA_PROFILE_ID',
'and flow_id = :FB_FLOW_ID',
'and security_group_id = :FLOW_SECURITY_GROUP_ID;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1505506467216610)
,p_internal_uid=>2563778350654035
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4994373880587605)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Data Load Definition'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_data_loader_dev.delete_data_load_definition(',
'    p_data_load_id   => :P1820_ID,',
'    p_application_id => :P1820_FLOW_ID);'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1505506467216610)
,p_process_success_message=>'Data load definition deleted.'
,p_internal_uid=>4994373880587605
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1526209123234218)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(687682638763131719)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process form Data Load Definition'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'SAVE,APPLY_CHANGES_EDIT_DATA_PROFILE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_internal_uid=>1526209123234218
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1507948497216628)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'1801'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1505506467216610)
,p_internal_uid=>1507948497216628
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2102883628346926)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh Data Load'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_data_loader_dev.refresh_data_load (',
'    p_data_load_id => :P1820_ID);'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3510049858217959)
,p_process_success_message=>'The subscription refreshed.'
,p_internal_uid=>2102883628346926
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2102943246346927)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Unsubscribe Data Load'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.unsubscribe_component (',
'    p_component_type  => wwv_flow_copy_metadata.c_data_load,',
'    p_component_id    => :P1820_ID,',
'    p_app_id          => :FB_FLOW_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3510368465219185)
,p_process_when=>'P1820_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_process_success_message=>'Data Load unsubscribed.'
,p_internal_uid=>2102943246346927
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1805877755557138)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(687682638763131719)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Edit Data Load'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>1805877755557138
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4701813134940014)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set non-dml item values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_data_load in (',
'    select target_type,',
'           loading_method,',
'           error_handling,',
'           error_collection_name',
'    from wwv_flow_load_tables',
'    where id = :P1820_ID',
'    and flow_id = :FB_FLOW_ID',
'    and security_group_id = :FLOW_SECURITY_GROUP_ID )',
'loop',
'    if l_data_load.target_type = ''TABLE'' and l_data_load.error_handling = ''ERROR_LOG'' then',
'        :P1820_TABLE_ERR_LOG_NAME := l_data_load.error_collection_name;',
'    end if;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P1820_ERROR_HANDLING'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'ERROR_LOG'
,p_internal_uid=>4701813134940014
);
end;
/
prompt --application/pages/page_01821
begin
wwv_flow_imp_page.create_page(
 p_id=>1821
,p_name=>'Data Load Utilization'
,p_alias=>'DATA-LOAD-UTILIZATION'
,p_step_title=>'Data Load Utilization'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(1449603451873552)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2101165717346909)
,p_plug_name=>'Data Load Utilization'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  ',
'    d.id,',
'    d.name data_load_name,',
'    pr.process_name,',
'    wwv_flow_utilities.prepare_url(''f?p=4000:4500:''||:flow_session||''::::FB_FLOW_PAGE_ID:''||p.id) page_target,',
'    p.id page_id,',
'    p.name page_name',
'from wwv_flow_steps p,',
'     wwv_flow_step_processing pr,',
'     wwv_flow_load_tables d',
'where p.id = pr.flow_step_id',
'  and p.flow_id = pr.flow_id',
'  and d.flow_id = p.flow_id',
'  and d.id = pr.attribute_01',
'  and p.flow_id = :fb_flow_id',
'  and p.security_group_id = :flow_security_group_id',
'  and pr.process_type = ''NATIVE_DATA_LOADING''',
'  and d.data_profile_id is not null'))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Data Load Utilization'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(2101269384346910)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'Data Load Definitions are NOT used in the application.'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'CBCHO'
,p_internal_uid=>2101269384346910
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2101393918346911)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2101446231346912)
,p_db_column_name=>'DATA_LOAD_NAME'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Data Load Name'
,p_column_link=>'f?p=&APP_ID.:1820:&SESSION.::&DEBUG.:1820:P1820_ID:#ID#'
,p_column_linktext=>'#DATA_LOAD_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2101680699346914)
,p_db_column_name=>'PROCESS_NAME'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Process Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2101794737346915)
,p_db_column_name=>'PAGE_TARGET'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>'Page Target'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2101889920346916)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2101958264346917)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>70
,p_column_identifier=>'G'
,p_column_label=>'Page Name'
,p_column_link=>'#PAGE_TARGET#'
,p_column_linktext=>'#PAGE_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(2905456323024449)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'29055'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'ID:DATA_LOAD_NAME:PROCESS_NAME:PAGE_TARGET:PAGE_ID:PAGE_NAME'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2102040646346918)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>'<p>This page displays where <strong>Data Load Definitions</strong> are being used within the application.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(18038874165191067)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(15132926917246073)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Data Load Definitions'
);
end;
/
prompt --application/pages/page_01850
begin
wwv_flow_imp_page.create_page(
 p_id=>1850
,p_name=>'Add Remote File Storage'
,p_alias=>'ADD-REMOTE-FILE-STORAGE'
,p_page_mode=>'MODAL'
,p_step_title=>'Add Remote File Storage'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'550'
,p_dialog_width=>'60%'
,p_dialog_attributes=>'resizable:true'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2410791450988423)
,p_plug_name=>'OCI Credential Required'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>30
,p_plug_source=>'An Oracle Cloud Infrastructure (OCI) credential is required. Click the Create Credential button below.'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P1850_CRED_COUNT = 0'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(612090117580974131)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(612109101966174795)
,p_plug_name=>'Add Remote File Storage'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P1850_CRED_COUNT > 0'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3201511717533267)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(612090117580974131)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3201930538533269)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(612090117580974131)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'CREATE'
,p_button_condition=>':P1850_CRED_COUNT > 0'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2003716958668734)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(612090117580974131)
,p_button_name=>'CREATE_CRED'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Create Credential'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:1621:&SESSION.::&DEBUG.:1621:P1621_CREDENTIALS_TYPE,P1621_BACK_TO_PAGE:OCI,4001'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3212863083533298)
,p_branch_name=>'Go To Page 1851'
,p_branch_action=>'f?p=&APP_ID.:1851:&SESSION.::&DEBUG.:CR,1951::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(3201930538533269)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1605884800373516)
,p_name=>'P1850_CREDENTIAL_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(612109101966174795)
,p_prompt=>'OCI Credential'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'OCI_CREDENTIALS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id',
'  from wwv_credentials',
' where authentication_type = ''OCI''',
'   and security_group_id = :WORKSPACE_ID'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the OCI Web Credential from the list.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2001183146668708)
,p_name=>'P1850_NEW_OR_EXISTING'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(612109101966174795)
,p_item_default=>'NEW'
,p_prompt=>'Create bucket'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'NEW'
,p_attribute_04=>'EXISTING'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2001221133668709)
,p_name=>'P1850_COMPARTMENT_OCID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(612109101966174795)
,p_prompt=>'Compartment OCID'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>500
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the OCID of the compartment for this bucket. The compartment OCID can be found in the Oracle Cloud Infrastructure (OCI) console under Identity, Compartments. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2001322120668710)
,p_name=>'P1850_BUCKET_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(612109101966174795)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2409500588988411)
,p_name=>'P1850_BASE_URL'
,p_item_sequence=>45
,p_item_plug_id=>wwv_flow_imp.id(612109101966174795)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2410647730988422)
,p_name=>'P1850_CRED_COUNT'
,p_data_type=>'NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(612090117580974131)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(612092349948974180)
,p_name=>'P1850_BUCKET_URL'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(612109101966174795)
,p_prompt=>'Bucket URL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>75
,p_cMaxlength=>500
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the endpoint URL of the file storage bucket. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(612094345753974200)
,p_name=>'P1850_NAME'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(612109101966174795)
,p_use_cache_before_default=>'NO'
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_return varchar2(4000);',
'    l_cnt    number;',
'begin',
'    l_return := :FB_FLOW_ID||''_BUCKET'';',
'',
'    select count(*) into l_cnt',
'      from wwv_remote_servers',
'     where name = l_return',
'       and security_group_id = :FLOW_SECURITY_GROUP_ID;',
'',
'    if l_cnt > 0 then',
'        wwv_flow_exec_web_src_utils.add_or_increase_seq_suffix(l_return);',
'    end if;',
' ',
'return l_return;',
'end;',
'    '))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a name for the remote server object here. Remote Server names must be unique within the workspace.'
,p_inline_help_text=>'Name to identify file server'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(612094473300974201)
,p_name=>'P1850_STATIC_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(612109101966174795)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2409442256988410)
,p_computation_sequence=>10
,p_computation_item=>'P1850_STATIC_ID'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'replace(upper(:P1850_NAME),'' '',''_'')'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2409660255988412)
,p_computation_sequence=>10
,p_computation_item=>'P1850_BASE_URL'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_base_url varchar2(32000);',
'begin',
'    l_base_url := substr(:P1850_BUCKET_URL,1,instr(:P1850_BUCKET_URL,''/b/'')+2);',
'    --if the URL provided doesn''t inlcude /b/, but could be valid',
'    if instr(l_base_url,''https'') != 1 then',
'       l_base_url := :P1850_BUCKET_URL;',
'    end if;',
'',
'    return l_base_url;',
'end;'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2409787100988413)
,p_computation_sequence=>10
,p_computation_item=>'P1850_BUCKET_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'rtrim(substr(:P1850_BUCKET_URL,instr(:P1850_BUCKET_URL,''/b/'')+3),''/'')'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2411032172988426)
,p_computation_sequence=>10
,p_computation_item=>'P1850_CRED_COUNT'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*)',
'  from wwv_credentials',
' where authentication_type = ''OCI''',
'   and security_group_id = :WORKSPACE_ID'))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3207012982533292)
,p_validation_name=>'Name must be unique'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'  from wwv_remote_servers',
' where name = :P1850_NAME',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Remote Server name must be unique'
,p_associated_item=>wwv_flow_imp.id(612094345753974200)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3207812033533293)
,p_validation_name=>'URL must start with https'
,p_validation_sequence=>30
,p_validation=>'substr( :P1850_BUCKET_URL, 1, 8 ) = ''https://'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Bucket URL must start with https://'
,p_associated_item=>wwv_flow_imp.id(612092349948974180)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(291587253243361501)
,p_validation_name=>'Compartment OCID is required'
,p_validation_sequence=>40
,p_validation=>'P1850_COMPARTMENT_OCID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# is required when creating a new bucket.'
,p_validation_condition=>'P1850_NEW_OR_EXISTING'
,p_validation_condition2=>'NEW'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(2001221133668709)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3209036038533296)
,p_name=>'Set Base URL'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1850_PRINT_SERVER_TYPE'
,p_condition_element=>'P1850_PRINT_SERVER_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'AOP'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'ITEM_IS_NULL'
,p_display_when_cond=>'P1850_BUCKET_URL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3209504105533296)
,p_event_id=>wwv_flow_imp.id(3209036038533296)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1850_BUCKET_URL'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'https://api.apexofficeprint.com/apex/'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3210041552533297)
,p_event_id=>wwv_flow_imp.id(3209036038533296)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1850_BUCKET_URL'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3211801444533297)
,p_name=>'Cancel Dialog'
,p_event_sequence=>60
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3201511717533267)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3212395670533298)
,p_event_id=>wwv_flow_imp.id(3211801444533297)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(8401037792370309)
,p_name=>'show hide comp ocid'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1850_NEW_OR_EXISTING'
,p_condition_element=>'P1850_NEW_OR_EXISTING'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8401112005370310)
,p_event_id=>wwv_flow_imp.id(8401037792370309)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1850_COMPARTMENT_OCID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8401251961370311)
,p_event_id=>wwv_flow_imp.id(8401037792370309)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1850_COMPARTMENT_OCID'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2004119805668738)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Save Remote File Storage'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_server_id         number;',
'begin',
'',
'    if :P1850_NEW_OR_EXISTING = ''NEW'' then  ',
'        wwv_flow_object_store.create_bucket(',
'            p_path           => :P1850_BASE_URL,',
'            p_bucket_name    => :P1850_BUCKET_NAME,',
'            p_compartment_id => :P1850_COMPARTMENT_OCID,',
'            p_credential_id  => :P1850_CREDENTIAL_ID);',
'    end if;',
'',
'    insert into wwv_remote_servers (',
'        name,',
'        static_id,',
'        base_url,',
'        server_type,',
'        prompt_on_install,',
'        credential_id',
'    ) values (',
'        :P1850_NAME,',
'        :P1850_STATIC_ID,',
'        :P1850_BASE_URL||:P1850_BUCKET_NAME||''/o/'',',
'        ''CLOUD_OBJECT_STORE'',',
'        ''Y'',',
'        :P1850_CREDENTIAL_ID',
'        )',
'    returning id into l_server_id;',
'',
'    update wwv_flows',
'       set file_storage           = ''OBJECT_STORE'',',
'           file_remote_server_id  = l_server_id',
'     where id                     = :FB_FLOW_ID',
'       and security_group_id      = :FLOW_SECURITY_GROUP_ID;',
'',
'    if wwv_flow_collection.collection_exists(''F4000_OB_FILES'') then',
'        wwv_flow_collection.delete_collection(''F4000_OB_FILES'');',
'    end if;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2004119805668738
);
end;
/
prompt --application/pages/page_01851
begin
wwv_flow_imp_page.create_page(
 p_id=>1851
,p_name=>'Add Remote File Storage'
,p_alias=>'ADD-REMOTE-FILE-STORAGE-CREDENTIALS'
,p_page_mode=>'MODAL'
,p_step_title=>'Add Remote File Storage'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2004281450668739)
,p_plug_name=>'Success'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P1851_RESULT'
,p_plug_display_when_cond2=>'success'
,p_landmark_type=>'exclude_landmark'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(291118887404449701)
,p_plug_name=>'Success'
,p_parent_plug_id=>wwv_flow_imp.id(2004281450668739)
,p_region_template_options=>'#DEFAULT#:a-Alert--success:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>20
,p_plug_source=>'The Remote File Storage reference to the bucket was created and successfully accessed.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(291118984521449702)
,p_plug_name=>'Options'
,p_parent_plug_id=>wwv_flow_imp.id(2004281450668739)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>40
,p_landmark_type=>'exclude_landmark'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8401554253370314)
,p_plug_name=>'Warning'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>40
,p_plug_source=>'<pre>&P1851_RESULT!HTML.</pre>'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P1851_RESULT'
,p_plug_display_when_cond2=>'success'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(612690677483988737)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3801122087547848)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(612690677483988737)
,p_button_name=>'FINISH'
,p_button_static_id=>'CREATE_AND_APPLY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Finish'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8401680283370315)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(612690677483988737)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1850:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3812558312547880)
,p_branch_name=>'Branch To 4001'
,p_branch_action=>'f?p=&APP_ID.:4001:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2410893895988424)
,p_name=>'P1851_MIGRATE_FILES'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(291118984521449702)
,p_item_default=>'Y'
,p_prompt=>'Migrate Files to Object Storage'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_static_files',
' where security_group_id = :WORKSPACE_ID',
'   and flow_id = :FB_FLOW_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'This option will migrate existing static application files from the database to Object Storage. If you choose not to migrate files at this time, you can use the Sync option under Tasks in the Static Application Files Shared Components page.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8401313673370312)
,p_name=>'P1851_RESULT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(612690677483988737)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(8401494978370313)
,p_computation_sequence=>10
,p_computation_item=>'P1851_RESULT'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return wwv_flow_object_store.test_bucket(:FB_FLOW_ID);'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2410971611988425)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'migrate to object storage'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_sum_bytes number;',
'begin',
'    select sum(sys.dbms_lob.getlength(file_content))',
'      into l_sum_bytes',
'      from wwv_flow_static_files',
'     where security_group_id = :WORKSPACE_ID',
'       and flow_id = :FB_FLOW_ID;',
'',
'    if l_sum_bytes > wwv_flow_object_store.c_max_sync_bytes then --background',
'        wwv_flow_object_store.migrate_bg(',
'            p_app_id       => :FB_FLOW_ID,',
'            p_session_id   => :FLOW_SESSION,',
'            p_workspace_id => :WORKSPACE_ID );',
'    else',
'        wwv_flow_object_store.migrate(',
'            p_app_id       => :FB_FLOW_ID,',
'            p_workspace_id => :WORKSPACE_ID );       ',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'#SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3801122087547848)
,p_process_when=>'P1851_MIGRATE_FILES'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'Y'
,p_process_success_message=>'Files migrated to Object Storage.'
,p_internal_uid=>2410971611988425
);
end;
/
prompt --application/pages/page_01852
begin
wwv_flow_imp_page.create_page(
 p_id=>1852
,p_name=>'Synchronize Files'
,p_alias=>'MIGRATE-TO-OBJECT-STORAGE'
,p_page_mode=>'MODAL'
,p_step_title=>'Synchronize Files'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'25'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2411193518988427)
,p_plug_name=>'Sync Files'
,p_region_css_classes=>'a-Alert--noTitle mxw480 margin-auto margin-top-md'
,p_region_template_options=>'#DEFAULT#:a-Alert--info:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>30
,p_plug_item_display_point=>'BELOW'
,p_function_body_language=>'PLSQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P1852_TOTAL_BYTES > wwv_flow_object_store.c_max_sync_bytes then',
'    return wwv_flow_lang_dev.builder_message(',
'        p_name => ''OBSTORE.SYNC_BACKGROUND'',',
'        p0     => :P1852_FILE_COUNT,',
'        p1     => nvl(htmldb_util.filesize_mask(:P1852_TOTAL_BYTES),''0'') );',
'else',
'    return wwv_flow_lang_dev.builder_message(',
'        p_name => ''OBSTORE.SYNC_IMMEDIATE'',',
'        p0     => :P1852_FILE_COUNT,',
'        p1     => nvl(htmldb_util.filesize_mask(:P1852_TOTAL_BYTES),''0'') );',
'end if;'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8402990363370328)
,p_plug_name=>'Actions'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(291119087538449703)
,p_plug_name=>'Options'
,p_region_css_classes=>'margin-top-md'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_landmark_type=>'exclude_landmark'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(291119110390449704)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(8402990363370328)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2411945842988435)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(8402990363370328)
,p_button_name=>'Sync'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Synchronize Files'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-refresh'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2412044361988436)
,p_branch_name=>'go to 40'
,p_branch_action=>'f?p=&APP_ID.:40:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2411945842988435)
,p_branch_sequence=>5
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2411843692988434)
,p_branch_name=>'branch back '
,p_branch_action=>'f?p=&APP_ID.:1852:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2411287985988428)
,p_name=>'P1852_FILES_TO'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(291119087538449703)
,p_item_default=>'OBJECT_STORE'
,p_prompt=>'Synchronize Files'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'FILE_STORAGE_SYNC_OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(575661404207029763)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_attribute_01=>'1'
,p_attribute_02=>'SUBMIT'
,p_attribute_03=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2411396097988429)
,p_name=>'P1852_FILE_COUNT'
,p_data_type=>'NUMBER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2411193518988427)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2411442278988430)
,p_name=>'P1852_TOTAL_BYTES'
,p_data_type=>'NUMBER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2411193518988427)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(291119298292449705)
,p_name=>'Cancel'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(291119110390449704)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(291119355218449706)
,p_event_id=>wwv_flow_imp.id(291119298292449705)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2411614510988432)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if nvl(:P1852_FILES_TO, wwv_flow_object_store.c_file_storage_object_store) ',
'       = wwv_flow_object_store.c_file_storage_object_store then',
'    select count(*), sum(sys.dbms_lob.getlength(file_content))',
'      into :P1852_FILE_COUNT, :P1852_TOTAL_BYTES',
'      from wwv_flow_static_files',
'     where security_group_id = :WORKSPACE_ID',
'       and flow_id = :FB_FLOW_ID;',
'else',
'    select count(*), sum(n002)',
'      into :P1852_FILE_COUNT, :P1852_TOTAL_BYTES',
'      from wwv_flow_collections',
'     where collection_name = ''F4000_OB_FILES''',
'       and n001 = :FB_FLOW_ID;',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>2411614510988432
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3008160546630923)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'migrate to object storage'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin   ',
'    wwv_flow_object_store.migrate(',
'        p_app_id       => :FB_FLOW_ID, ',
'        p_session_id   => null,',
'        p_workspace_id => :WORKSPACE_ID );',
'    wwv_flow_collection.delete_collection (p_collection_name => ''F4000_OB_FILES'' );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'#SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2411945842988435)
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1852_TOTAL_BYTES <= wwv_flow_object_store.c_max_sync_bytes ',
'    and :P1852_FILES_TO = wwv_flow_object_store.c_file_storage_object_store'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Files synchronized to Object Storage.'
,p_internal_uid=>3008160546630923
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3008412291633354)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'migrate to object storage bg'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin   ',
'    wwv_flow_object_store.migrate_bg(',
'        p_app_id       => :FB_FLOW_ID, ',
'        p_session_id   => :APP_SESSION,',
'        p_workspace_id => :WORKSPACE_ID );',
'    wwv_flow_collection.delete_collection (p_collection_name => ''F4000_OB_FILES'' );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'#SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2411945842988435)
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1852_TOTAL_BYTES > wwv_flow_object_store.c_max_sync_bytes',
'    and :P1852_FILES_TO = wwv_flow_object_store.c_file_storage_object_store'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Files synchronizing to Object Storage in the background.'
,p_internal_uid=>3008412291633354
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3008799390638493)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'move to local storage'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin   ',
'    wwv_flow_object_store.move(p_app_id          => :FB_FLOW_ID,',
'                               p_session_id      => null,',
'                               p_workspace_id    => :WORKSPACE_ID,',
'                               p_collection_name => ''F4000_OB_FILES'' );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'#SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2411945842988435)
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1852_TOTAL_BYTES <= wwv_flow_object_store.c_max_sync_bytes',
'    and :P1852_FILES_TO != wwv_flow_object_store.c_file_storage_object_store'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Files synchronized from Object Storage to Local Database.'
,p_internal_uid=>3008799390638493
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3009085401645739)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'move to local storage bg'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin   ',
'    wwv_flow_object_store.move_bg(p_app_id          => :FB_FLOW_ID,',
'                                  p_session_id      => :APP_SESSION,',
'                                  p_workspace_id    => :WORKSPACE_ID,',
'                                  p_collection_name => ''F4000_OB_FILES'' );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'#SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2411945842988435)
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1852_TOTAL_BYTES > wwv_flow_object_store.c_max_sync_bytes',
'    and :P1852_FILES_TO != wwv_flow_object_store.c_file_storage_object_store'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Files synchronizing from Object Storage to Local Database in the background.'
,p_internal_uid=>3009085401645739
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(415638712792428354)
,p_process_sequence=>60
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Populate F4000_OB_FILES'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_object_store.populate_object_collection (',
'    p_app_id            => :FB_FLOW_ID,',
'    p_collection_name   => ''F4000_OB_FILES'',',
'    p_limit             => ''1000'',',
'    p_search            => :P1852_OB_SEARCH );'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_cnt number;',
'begin',
'',
'    select count(*) into l_cnt',
'      from wwv_flow_collections',
'     where collection_name = ''F4000_OB_FILES''',
'       and n001 = :FB_FLOW_ID;',
'',
'    return l_cnt = 0;',
'end;'))
,p_process_when_type=>'FUNCTION_BODY'
,p_process_when2=>'PLSQL'
,p_internal_uid=>415638712792428354
);
end;
/
prompt --application/pages/page_01853
begin
wwv_flow_imp_page.create_page(
 p_id=>1853
,p_name=>'Object Storage Files'
,p_alias=>'OBJECT-STORAGE-FILES'
,p_page_mode=>'MODAL'
,p_step_title=>'Object Storage Files'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>'.a-Alert-title { display: none; }'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_width=>'80%'
,p_dialog_chained=>'N'
,p_protection_level=>'C'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(417622987213919219)
,p_name=>'Object Storage Files'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>30
,p_region_css_classes=>'a-Report--stretch'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.checkbox(1, seq_id) cb,',
'       c001 file_name,',
'       c006 mime_type,',
'       n002 file_size,',
'       c005 reference,',
'       c007 url,',
'       cast( to_timestamp_tz( nvl(c004,c003), ''FXYYYY-MM-DD"T"HH24:MI:SS.FXFF9TZR'' ) as timestamp with local time zone ) modified',
'  from wwv_flow_collections',
' where collection_name = ''F4000_OB_FILES'''))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No Object Storage files found.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(415620535147250497)
,p_query_column_id=>1
,p_column_alias=>'CB'
,p_column_display_sequence=>5
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(415620997144250497)
,p_query_column_id=>2
,p_column_alias=>'FILE_NAME'
,p_column_display_sequence=>10
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(415621385516250498)
,p_query_column_id=>3
,p_column_alias=>'MIME_TYPE'
,p_column_display_sequence=>15
,p_column_heading=>'Mime Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(415621709924250498)
,p_query_column_id=>4
,p_column_alias=>'FILE_SIZE'
,p_column_display_sequence=>20
,p_column_heading=>'Size'
,p_use_as_row_header=>'N'
,p_column_format=>'FILESIZE'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(415622152904250498)
,p_query_column_id=>5
,p_column_alias=>'REFERENCE'
,p_column_display_sequence=>25
,p_column_heading=>'Reference'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(415622516268250499)
,p_query_column_id=>6
,p_column_alias=>'URL'
,p_column_display_sequence=>27
,p_column_heading=>'File'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<a href="#URL#" target="_new">Download</a>'
,p_column_alignment=>'CENTER'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(415622938913250499)
,p_query_column_id=>7
,p_column_alias=>'MODIFIED'
,p_column_display_sequence=>37
,p_column_heading=>'Modified'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(424006858815450048)
,p_plug_name=>'Actions'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(415606532071079736)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(424006858815450048)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(415606180656079736)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(424006858815450048)
,p_button_name=>'SYNC'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Synchronize Files'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1852:&SESSION.::&DEBUG.::P1852_FILES_TO:DB'
,p_icon_css_classes=>'icon-refresh'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(415610491737079746)
,p_branch_name=>'go to 40'
,p_branch_action=>'f?p=&APP_ID.:40:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(415606532071079736)
,p_branch_sequence=>5
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(415610012118079745)
,p_branch_name=>'branch back '
,p_branch_action=>'f?p=&APP_ID.:1853:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(418032618266238907)
,p_name=>'P1853_OB_SEARCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(417622987213919219)
,p_prompt=>'Name starts with'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(415609162330079743)
,p_name=>'Cancel'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(415606532071079736)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(415609659108079744)
,p_event_id=>wwv_flow_imp.id(415609162330079743)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(415626029978295041)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'reset F4000_OB_FILES collection'
,p_process_sql_clob=>'wwv_flow_collection.delete_collection (p_collection_name => ''F4000_OB_FILES'' );'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P1853_OB_SEARCH'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>415626029978295041
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(415617421146209602)
,p_process_sequence=>60
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Populate F4000_OB_FILES'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_object_store.populate_object_collection (',
'    p_app_id            => :FB_FLOW_ID,',
'    p_collection_name   => ''F4000_OB_FILES'',',
'    p_limit             => ''1000'',',
'    p_search            => :P1853_OB_SEARCH );'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_cnt number;',
'begin',
'',
'    select count(*) into l_cnt',
'      from wwv_flow_collections',
'     where collection_name = ''F4000_OB_FILES''',
'       and n001 = :FB_FLOW_ID;',
'',
'    return l_cnt = 0;',
'end;'))
,p_process_when_type=>'FUNCTION_BODY'
,p_process_when2=>'PLSQL'
,p_internal_uid=>415617421146209602
);
end;
/
prompt --application/pages/page_01901
begin
wwv_flow_imp_page.create_page(
 p_id=>1901
,p_name=>'REST Data Sources'
,p_alias=>'REST-DATA-SOURCES'
,p_step_title=>'REST Data Sources'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3290535781489430)
,p_plug_name=>'REST Data Sources'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with messages as (',
'    select ( select wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_UP_TO_DATE'') from sys.dual ) up_to_date,',
'           ( select wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_NEEDS_REFRESH'') from sys.dual ) needs_refresh,',
'           ( select wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_UNKNOWN'') from sys.dual ) unknown_status,',
'           ( select wwv_flow_lang_dev.builder_message(''SUBSCRIBED_FROM.NONEXISTING_MASTER'') from sys.dual ) no_master',
'      from sys.dual )',
'select m.id,',
'       m.name,',
'       m.name as name_link,',
'       rtrim(r.base_url,''/'') || ''/'' || ltrim(m.url_path_prefix, ''/'') as endpoint_url,',
'       count( o.id )                                                 as operations_count,',
'       case when m.credential_id is not null then ''Y'' else ''N'' end   as authentication_required,',
'       r.name                                                        as remote_server_name,',
'       ''icon-sc-web-services''                                        as icon_class_name,',
'       wwv_flow_utilities.prepare_url( ''f?p='' || :APP_ID || '':1921:'' || :APP_SESSION || ''::::P1921_WEB_SRC_MODULE_ID:'' || m.id ) as link,',
'       --',
'       case when m.reference_id is not null then',
'           coalesce ( to_char( master.flow_id ),',
'                       messages.no_master )',
'       end as subscribed_from,',
'       ( select case when count(*) > 0 then count(*) end',
'           from wwv_flow_web_src_modules sub',
'          where sub.reference_id      = m.id',
'            and sub.security_group_id = :WORKSPACE_ID ) as subscribers,',
'       case when m.reference_id is not null then',
'           case',
'               when master.version_scn = m.version_scn then',
'                   messages.up_to_date',
'               when master.version_scn != m.version_scn then',
'                   messages.needs_refresh',
'               else',
'                   messages.unknown_status',
'           end',
'       end subscription_status,',
'       --',
'       coalesce( m.last_updated_on, m.created_on ) last_updated,',
'       coalesce( m.last_updated_by, m.created_by ) last_updated_by,',
'       --',
'       wwv_flow_lang.system_message( case when m.sync_table_name is not null then ''YES'' else ''NO'' end ) as is_synchronized',
'  from wwv_flow_web_src_modules m,',
'       wwv_flow_web_src_modules master,',
'       wwv_flow_web_src_operations o,',
'       wwv_remote_servers r,',
'       messages',
' where o.web_src_module_id (+) = m.id',
'   and m.remote_server_id      = r.id',
'   and m.flow_id               = :FB_FLOW_ID',
'   and m.security_group_id     = :WORKSPACE_ID',
'   and m.reference_id          = master.id (+)',
'   and m.security_group_id     = master.security_group_id (+)',
' group by m.id, m.name, m.credential_id, r.name, r.base_url, m.url_path_prefix, m.reference_id, m.last_updated_on, m.sync_table_name,',
'         --',
'         master.flow_id, messages.no_master, master.version_scn, m.version_scn, messages.up_to_date, messages.needs_refresh, messages.unknown_status, m.last_updated_on, m.created_on, ',
'         m.last_updated_by, m.created_by'))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(3290607658489431)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'No REST Data Sources are defined within this application.'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#LINK#" class="a-IRR-icon"><span class="a-Icon icon-sc-web-service"></span><span class="a-IRR-iconName">#NAME#</span></a>'
,p_icon_view_columns_per_row=>6
,p_owner=>'ADMIN'
,p_internal_uid=>3290607658489431
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3290785910489432)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(236246600064284201)
,p_db_column_name=>'NAME_LINK'
,p_display_order=>20
,p_column_identifier=>'I'
,p_column_label=>'REST Source Name'
,p_column_link=>'#LINK#'
,p_column_linktext=>'#NAME_LINK#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3290879918489433)
,p_db_column_name=>'NAME'
,p_display_order=>30
,p_column_identifier=>'B'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3290912419489434)
,p_db_column_name=>'OPERATIONS_COUNT'
,p_display_order=>40
,p_column_identifier=>'C'
,p_column_label=>'Operations'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3291066768489435)
,p_db_column_name=>'AUTHENTICATION_REQUIRED'
,p_display_order=>50
,p_column_identifier=>'D'
,p_column_label=>'Authentication'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_column_alignment=>'CENTER'
,p_rpt_named_lov=>wwv_flow_imp.id(84887415298521126)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3291121378489436)
,p_db_column_name=>'REMOTE_SERVER_NAME'
,p_display_order=>60
,p_column_identifier=>'E'
,p_column_label=>'Remote Server Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3291251817489437)
,p_db_column_name=>'ENDPOINT_URL'
,p_display_order=>70
,p_column_identifier=>'F'
,p_column_label=>'Endpoint URL'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3291329775489438)
,p_db_column_name=>'ICON_CLASS_NAME'
,p_display_order=>80
,p_column_identifier=>'G'
,p_column_label=>'Icon class name'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3291442427489439)
,p_db_column_name=>'LINK'
,p_display_order=>90
,p_column_identifier=>'H'
,p_column_label=>'Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(247726827518524634)
,p_db_column_name=>'SUBSCRIBED_FROM'
,p_display_order=>100
,p_column_identifier=>'J'
,p_column_label=>'Subscribed From'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(247726933892524635)
,p_db_column_name=>'SUBSCRIBERS'
,p_display_order=>110
,p_column_identifier=>'K'
,p_column_label=>'Subscribers'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(546917247163857725)
,p_db_column_name=>'IS_SYNCHRONIZED'
,p_display_order=>130
,p_column_identifier=>'M'
,p_column_label=>'Synchronized'
,p_column_link=>'f?p=&APP_ID.:1951:&SESSION.::&DEBUG.:1951:P1951_WEB_SRC_MODULE_ID:#ID#'
,p_column_linktext=>'#IS_SYNCHRONIZED#'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(11092571624588014)
,p_db_column_name=>'SUBSCRIPTION_STATUS'
,p_display_order=>140
,p_column_identifier=>'N'
,p_column_label=>'Subscription Status'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(11092653636588015)
,p_db_column_name=>'LAST_UPDATED'
,p_display_order=>150
,p_column_identifier=>'O'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(11092725076588016)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>160
,p_column_identifier=>'P'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(3451665554620404)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'34517'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'NAME_LINK:IS_SYNCHRONIZED:OPERATIONS_COUNT:ENDPOINT_URL:AUTHENTICATION_REQUIRED:SUBSCRIBED_FROM:SUBSCRIPTION_STATUS:SUBSCRIBERS:LAST_UPDATED:'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(20179700929957575)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(13061782984169455)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(241339500601308306)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p><strong>REST Data Sources</strong> act as a reference to one or multiple external web (REST) services. A <strong>REST Data Source</strong> can contain one or many <strong>Operations</strong> which are the references to a concrete external web serv'
||'ice. Configurations at the REST source level are shared across all contained operations.',
'</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1112588947745742893)
,p_plug_name=>'Learn More'
,p_parent_plug_id=>wwv_flow_imp.id(241339500601308306)
,p_region_attributes=>'style="padding: 0 12px 12px 12px;"'
,p_plug_display_sequence=>30
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<p><a href="&SYSTEM_HELP_URL." target="_blank">''||wwv_flow_lang.system_message(''LEARN MORE'')||'' ...</a></p>'');',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(241339699794308307)
,p_plug_name=>'tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_imp.id(241353531173849237)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'REST Data Sources'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(529221957637107539)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(3290535781489430)
,p_button_name=>'COPY'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Copy'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1904:&SESSION.::&DEBUG.:RP,1904::'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_web_src_modules',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3291561610489440)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(3290535781489430)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1905:&SESSION.::&DEBUG.:RP,1941,1942,1943,1944,1945,1946,1905::'
,p_icon_css_classes=>'i icon-right-chevron'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(13063577805153129)
,p_name=>'Refresh Subscriptions'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(20179700929957575)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(13063991711153127)
,p_event_id=>wwv_flow_imp.id(13063577805153129)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3290535781489430)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(13064437270153126)
,p_event_id=>wwv_flow_imp.id(13063577805153129)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ( this.data.successMessage ) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
);
end;
/
prompt --application/pages/page_01902
begin
wwv_flow_imp_page.create_page(
 p_id=>1902
,p_name=>'REST Data Source Utilization'
,p_alias=>'REST-SOURCE-UTILIZATION'
,p_step_title=>'REST Data Source Utilization'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(244646616245363335)
,p_plug_name=>'REST Data Source Utilization'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select m.id,',
'       wwv_flow_page_api.get_url (',
'           p_page        => 4500,',
'           p_items       => ''FB_FLOW_PAGE_ID'',',
'           p_values      => r.page_id ) the_page,',
'       ''#'' the_shared_component,',
'       r.page_id,',
'       p.name page_name,',
'       r.plug_name,',
'       r.plug_source_type,',
'       m.name module_name',
'  from wwv_flow_page_plugs r,',
'       wwv_flow_steps p,',
'       wwv_flow_web_src_modules m',
' where m.id                = r.web_src_module_id',
'   and r.page_id           = p.id',
'   and r.flow_id           = p.flow_id',
'   and m.flow_id           = p.flow_id',
'   and p.flow_id           = :FB_FLOW_ID',
'   and p.security_group_id = :FLOW_SECURITY_GROUP_ID',
'union all (',
'select m.id,',
'       wwv_flow_page_api.get_url (',
'           p_page        => 4500,',
'           p_items       => ''FB_FLOW_PAGE_ID'',',
'           p_values      => r.flow_step_id ) the_page,',
'       ''#'' the_shared_component,',
'       r.flow_step_id,',
'       p.name page_name,',
'       r.process_name,',
'       wwv_flow_lang.system_message(''PROCESS.'' || r.process_type) plug_source_type,',
'       m.name module_name',
'  from wwv_flow_step_processing r,',
'       wwv_flow_steps p,',
'       wwv_flow_web_src_modules m',
' where m.id                = r.web_src_module_id',
'   and r.flow_step_id      = p.id',
'   and r.flow_id           = p.flow_id',
'   and m.flow_id           = p.flow_id',
'   and p.flow_id           = :FB_FLOW_ID',
'   and p.security_group_id = :FLOW_SECURITY_GROUP_ID )',
'union all (',
'select m.id,',
'       wwv_flow_page_api.get_url (',
'           p_page        => 4500,',
'           p_items       => ''FB_FLOW_PAGE_ID'',',
'           p_values      => r.page_id ) the_page,',
'       ''#'' the_shared_component,',
'       r.page_id,',
'       p.name page_name,',
'       r.plug_name || '' - '' || s.name plug_name,',
'       r.plug_source_type,',
'       m.name module_name',
'  from wwv_flow_jet_chart_series s,',
'       wwv_flow_jet_charts c,',
'       wwv_flow_page_plugs r,',
'       wwv_flow_steps p,',
'       wwv_flow_web_src_modules m',
' where m.id        = s.web_src_module_id',
'   and m.flow_id   = p.flow_id',
'   --',
'   and s.chart_id  = c.id',
'   and c.region_id = r.id',
'   --',
'   and r.page_id   = p.id',
'   and r.flow_id   = p.flow_id',
'   --',
'   and p.flow_id           = :FB_FLOW_ID',
'   and p.security_group_id = :FLOW_SECURITY_GROUP_ID )',
'union all (',
'select m.id,',
'       wwv_flow_page_api.get_url (',
'           p_page        => 4500,',
'           p_items       => ''FB_FLOW_PAGE_ID'',',
'           p_values      => r.page_id ) the_page,',
'       ''#'' the_shared_component,',
'       r.page_id,',
'       p.name page_name,',
'       r.plug_name || '' - '' || l.name plug_name,',
'       r.plug_source_type,',
'       m.name module_name',
'  from wwv_flow_map_region_layers l,',
'       wwv_flow_map_regions ma,',
'       wwv_flow_page_plugs r,',
'       wwv_flow_steps p,',
'       wwv_flow_web_src_modules m',
' where m.id                = l.web_src_module_id',
'   and m.flow_id           = p.flow_id',
'   --',
'   and l.map_region_id     = ma.id',
'   and ma.region_id        = r.id',
'   --',
'   and r.page_id           = p.id',
'   and r.flow_id           = p.flow_id',
'   --',
'   and p.flow_id           = :FB_FLOW_ID',
'   and p.security_group_id = :FLOW_SECURITY_GROUP_ID )',
'union all (',
'select m.id,',
'       ''#'' the_page,',
'       wwv_flow_page_api.get_url (',
'           p_page        => 4111,',
'           p_clear_cache => 4111,',
'           p_items       => ''F4000_P4111_ID'',',
'           p_values      => r.id ) the_shared_component,',
'       null page_id,',
'       null page_name,',
'       lov_name plug_name,',
'       wwv_flow_lang.system_message(''SHARED DYNAMIC LOV'') plug_source_type,',
'       m.name module_name',
'  from wwv_flow_lists_of_values$ r,',
'       wwv_flow_web_src_modules m',
' where m.id                = r.web_src_module_id',
'   and m.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and m.flow_id           = r.flow_id',
'   and m.flow_id           = :FB_FLOW_ID )',
'union all (',
'select m.id,',
'       ''#'' the_page,',
'       wwv_flow_page_api.get_url (',
'           p_page        => 3120,',
'           p_clear_cache => 3120,',
'           p_items       => ''P3120_ID'',',
'           p_values      => s.id ) the_shared_component,',
'       null page_id,',
'       null page_name,',
'       s.label plug_name,',
'       wwv_flow_lang.system_message(''SEARCH CONFIG'') plug_source_type,',
'       m.name module_name',
'  from wwv_flow_search_configs s,',
'       wwv_flow_web_src_modules m',
' where m.id                = s.web_src_module_id',
'   and m.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and m.flow_id           = s.flow_id',
'   and m.flow_id           = :FB_FLOW_ID )',
'union all (',
'select m.id,',
'       ''#'' the_page,',
'       wwv_flow_page_api.get_url (',
'           p_page        => 7021,',
'           p_clear_cache => 7021,',
'           p_items       => ''P7021_ID'',',
'           p_values      => a.id ) the_shared_component,',
'       null page_id,',
'       null page_name,',
'       a.name plug_name,',
'       wwv_flow_lang.system_message(''AUTOMATIONS'') plug_source_type,',
'       m.name module_name',
'  from wwv_flow_automations a,',
'       wwv_flow_web_src_modules m',
' where m.id                = a.web_src_module_id',
'   and m.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and m.flow_id           = a.flow_id',
'   and m.flow_id           = :FB_FLOW_ID )'))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(244646688122363336)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'No REST Data Source utilizations found.'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'ADMIN'
,p_internal_uid=>244646688122363336
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(241356732342873944)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(241339714716308308)
,p_db_column_name=>'THE_PAGE'
,p_display_order=>20
,p_column_identifier=>'J'
,p_column_label=>'The page'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(241340112476308312)
,p_db_column_name=>'MODULE_NAME'
,p_display_order=>30
,p_column_identifier=>'N'
,p_column_label=>'REST Data Source'
,p_column_link=>'f?p=&APP_ID.:1921:&SESSION.::&DEBUG.:RP:P1921_WEB_SRC_MODULE_ID:#ID#'
,p_column_linktext=>'#MODULE_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(241340092009308311)
,p_db_column_name=>'PLUG_NAME'
,p_display_order=>60
,p_column_identifier=>'M'
,p_column_label=>'Component Name'
,p_column_link=>'#THE_SHARED_COMPONENT#'
,p_column_linktext=>'#PLUG_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(241340200546308313)
,p_db_column_name=>'PLUG_SOURCE_TYPE'
,p_display_order=>70
,p_column_identifier=>'O'
,p_column_label=>'Component Type'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(538211928069052506)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(241339884405308309)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>80
,p_column_identifier=>'K'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(241339940558308310)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>90
,p_column_identifier=>'L'
,p_column_label=>'Page Name'
,p_column_link=>'#THE_PAGE#'
,p_column_linktext=>'#PAGE_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(90115588907448604)
,p_db_column_name=>'THE_SHARED_COMPONENT'
,p_display_order=>100
,p_column_identifier=>'P'
,p_column_label=>'The Shared Component'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(244807746018494309)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'2413603'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'MODULE_NAME:PLUG_SOURCE_TYPE:PLUG_NAME:PAGE_ID:PAGE_NAME:'
,p_sort_column_1=>'MODULE_NAME'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'PAGE_ID'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(482695581065182211)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page displays where <strong>REST Data Sources</strong> are being used within the application.',
'</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(482695780258182212)
,p_plug_name=>'tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_imp.id(241353531173849237)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'REST Data Sources'
);
end;
/
prompt --application/pages/page_01903
begin
wwv_flow_imp_page.create_page(
 p_id=>1903
,p_name=>'REST Data Source History'
,p_alias=>'REST-DATA-SOURCE-HISTORY'
,p_step_title=>'REST Data Source History'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(492434589593706643)
,p_plug_name=>'REST Data Source History'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_WEB_SRC_MODULES'''))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(492434661470706644)
,p_max_row_count=>'1000000'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'ADMIN'
,p_internal_uid=>492434661470706644
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(247727080561524636)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>10
,p_column_identifier=>'P'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(247727143136524637)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>20
,p_column_identifier=>'Q'
,p_column_label=>'Audit date'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(247727210680524638)
,p_db_column_name=>'ACTION'
,p_display_order=>30
,p_column_identifier=>'R'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(247727390643524639)
,p_db_column_name=>'SCN'
,p_display_order=>40
,p_column_identifier=>'S'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(247727425025524640)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>50
,p_column_identifier=>'T'
,p_column_label=>'Audit comment'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(247727588179524641)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>60
,p_column_identifier=>'U'
,p_column_label=>'Component Key'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(247727684741524642)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>70
,p_column_identifier=>'V'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(492595719366837617)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'2477914'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'DEVELOPER:COMPONENT_NAME:AUDIT_DATE:ACTION:'
,p_sort_column_1=>'MODULE_NAME'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'PAGE_ID'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(730483554413525519)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>'<p>This page displays recent modifications made to REST Data Sources in this application.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(730483753606525520)
,p_plug_name=>'tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_imp.id(241353531173849237)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'REST Data Sources'
);
end;
/
prompt --application/pages/page_01904
begin
wwv_flow_imp_page.create_page(
 p_id=>1904
,p_name=>'Copy REST Data Source'
,p_alias=>'COPY-REST-DATA-SOURCE'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy REST Data Source'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(91429205691059841)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(529220070888107520)
,p_plug_name=>'Copy REST Data Source'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(529222064541107540)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(529221216685107532)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(529222064541107540)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(529221325191107533)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(529222064541107540)
,p_button_name=>'CLOSE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Close'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(529222372081107543)
,p_branch_action=>'f?p=&APP_ID.:1921:&SESSION.::&DEBUG.:RP:P1921_WEB_SRC_MODULE_ID:&P1904_NEW_WEB_SOURCE_MODULE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(529220132877107521)
,p_name=>'P1904_WEB_SOURCE_MODULE_ID'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(529220070888107520)
,p_prompt=>'Copy REST Data Source'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEB_SOURCE_MODULES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name as d,',
'       id as r',
'  from wwv_flow_web_src_modules',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select existing REST Data Source -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(529221188532107531)
,p_name=>'P1904_NEW_WEB_SOURCE_NAME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(529220070888107520)
,p_prompt=>'New REST Data Source Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>65
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(529222291853107542)
,p_name=>'P1904_NEW_WEB_SOURCE_MODULE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(529220070888107520)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(161024959158385211)
,p_validation_name=>'REST Source name must be unique'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_web_src_modules',
' where flow_id            = :FB_FLOW_ID',
'   and security_group_id  = :FLOW_SECURITY_GROUP_ID',
'   and name               = :P1904_NEW_WEB_SOURCE_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'This name is already taken by another REST Source.'
,p_when_button_pressed=>wwv_flow_imp.id(529221216685107532)
,p_associated_item=>wwv_flow_imp.id(529221188532107531)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(161025215689385214)
,p_validation_name=>'REST Source Static ID must be unique'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_web_src_modules',
' where flow_id            = :FB_FLOW_ID',
'   and security_group_id  = :FLOW_SECURITY_GROUP_ID',
'   and static_id          = regexp_replace( lower( :P1904_NEW_WEB_SOURCE_NAME ), ''[^abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890]+'', ''_'' )'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'The REST Source name "&P1904_NEW_WEB_SOURCE_NAME!HTML." will lead to a Static ID which is already taken by another REST Source.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_web_src_modules',
' where flow_id            = :FB_FLOW_ID',
'   and security_group_id  = :FLOW_SECURITY_GROUP_ID',
'   and name               = :P1904_NEW_WEB_SOURCE_NAME'))
,p_validation_condition_type=>'NOT_EXISTS'
,p_when_button_pressed=>wwv_flow_imp.id(529221216685107532)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(529221475979107534)
,p_name=>'Click'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(529221325191107533)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(529221593174107535)
,p_event_id=>wwv_flow_imp.id(529221475979107534)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(529222160982107541)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy REST Data Source'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1904_NEW_WEB_SOURCE_MODULE_ID := wwv_flow_web_src_dev.copy_web_src_module(',
'    p_from_application_id    => :FB_FLOW_ID,',
'    p_from_web_src_module_id => :P1904_WEB_SOURCE_MODULE_ID,',
'    p_to_application_id      => :FB_FLOW_ID,',
'    p_to_name                => :P1904_NEW_WEB_SOURCE_NAME );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to copy REST Data Source.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(529221216685107532)
,p_process_success_message=>'REST Data Source copied.'
,p_internal_uid=>529222160982107541
);
end;
/
prompt --application/pages/page_01905
begin
wwv_flow_imp_page.create_page(
 p_id=>1905
,p_name=>'Create REST Data Source - Method'
,p_alias=>'CREATE-REST-DATA-SOURCE-METHOD'
,p_page_mode=>'MODAL'
,p_step_title=>'Create REST Data Source - Method'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_css_classes=>'ui-dialog--stretch'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true'
,p_help_text=>'sec_authentication.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1681773853744673868)
,p_plug_name=>'Create REST Data Source'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_header=>'<p>When you create a new REST Data Source, you have two options. You can create a new REST Data Source from scratch or you reuse implementations that already exist in your application or in other applications within your workspace.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1681774533783673884)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(249385562937130742)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1681774782569673884)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1681775395139673890)
,p_plug_name=>'Create REST Data Source'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(247672514274352485)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1681774782569673884)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(247672912889352487)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1681774782569673884)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(247674088776352498)
,p_branch_name=>'Go To Page 1906'
,p_branch_action=>'f?p=&APP_ID.:1906:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(247672912889352487)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1905_ACTION'
,p_branch_condition_text=>'COPY'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(247674411405352498)
,p_branch_name=>'Go To Page 1941'
,p_branch_action=>'f?p=&APP_ID.:1941:&SESSION.::&DEBUG.:RP,1941::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(247672912889352487)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1905_ACTION'
,p_branch_condition_text=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(28032815028072741)
,p_branch_name=>'Go To Page 1908'
,p_branch_action=>'f?p=&APP_ID.:1908:&SESSION.::&DEBUG.:RP,1908::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(247672912889352487)
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':P1905_ACTION = ''CATALOG'' and :P1905_SINGLE_CATALOG_ID is null'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1467580088002245)
,p_branch_name=>'Go To Page 1911'
,p_branch_action=>'f?p=&APP_ID.:1911:&SESSION.::&DEBUG.:RP,1908,1911:P1911_SOURCE_ID,P1911_TYPE:&P1905_SINGLE_CATALOG_ID.,CATALOG'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(247672912889352487)
,p_branch_sequence=>40
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':P1905_ACTION = ''CATALOG'' and :P1905_SINGLE_CATALOG_ID is not null'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1467491143002244)
,p_name=>'P1905_SINGLE_CATALOG_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1681773853744673868)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(247671152448352476)
,p_name=>'P1905_ACTION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1681773853744673868)
,p_item_default=>'CREATE'
,p_prompt=>'Create REST Data Source:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P1905_ACTIONS'
,p_lov=>'.'||wwv_flow_imp.id(247678451096396264)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_escape_on_http_output=>'N'
,p_help_text=>'Select the method by which you would like to create the REST Data Source.'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(247656983767093707)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(247672514274352485)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(247657093654093708)
,p_event_id=>wwv_flow_imp.id(247656983767093707)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4705533119428540)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Prepare to create from Catalog'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_name          varchar2(25) := ''REST_CATALOG_SELECTIONS'';',
'    l_first_catalog boolean      := true;',
'begin',
'    wwv_flow_collection.create_or_truncate_collection( l_name );',
'',
'    <<catalog_with_services_loop>>',
'    for i in (',
'        select c.id,',
'               count( s.id ) as services_count',
'          from wwv_web_src_catalogs c,',
'               wwv_web_src_catalog_services s',
'         where c.id                = s.catalog_id',
'           and c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'           and c.security_group_id = s.security_group_id',
'         group by c.id )',
'    loop',
'        if l_first_catalog then',
'            :P1905_SINGLE_CATALOG_ID := i.id;',
'            l_first_catalog          := false;',
'        else ',
'            :P1905_SINGLE_CATALOG_ID := null;',
'            exit catalog_with_services_loop;',
'        end if;',
'    end loop catalog_with_services_loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(247672912889352487)
,p_process_when=>'P1905_ACTION'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'CATALOG'
,p_internal_uid=>4705533119428540
);
end;
/
prompt --application/pages/page_01906
begin
wwv_flow_imp_page.create_page(
 p_id=>1906
,p_name=>'Create REST Data Source - Application'
,p_alias=>'CREATE-REST-DATA-SOURCE-APPLICATION'
,p_page_mode=>'MODAL'
,p_step_title=>'Create REST Data Source - Application'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213425326892450628)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true'
,p_help_text=>'sec_authentication.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1681839970065775603)
,p_plug_name=>'Create REST Data Source'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_header=>'<p>Use this page to copy a REST Data Source from another application.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1681840688770775604)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(249385562937130742)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1681840898431775604)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1681841671482775606)
,p_plug_name=>'Create REST Data Source'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(247684236544424706)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(1681840898431775604)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(247684634985424706)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1681840898431775604)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(247685776109424710)
,p_branch_name=>'Go To Page 1907'
,p_branch_action=>'f?p=&APP_ID.:1907:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(247684236544424706)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(247686121964424710)
,p_branch_name=>'Go To Page 1905'
,p_branch_action=>'f?p=&APP_ID.:1905:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(247684634985424706)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(247682301374424702)
,p_name=>'P1906_COPY_FROM'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1681839970065775603)
,p_prompt=>'Copy From Application'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'       f.id||'' ''||f.name as d,',
'       f.id as rr',
'  from wwv_flows f',
' where f.security_group_id = :WORKSPACE_ID',
'   and exists ( select 1',
'                  from wwv_flow_web_src_modules a',
'                 where a.flow_id = f.id',
'              )',
' order by f.id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select an Application -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Select an application to copy the plug-ins from.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
end;
/
prompt --application/pages/page_01907
begin
wwv_flow_imp_page.create_page(
 p_id=>1907
,p_name=>'Create REST Data Source - Copy'
,p_alias=>'CREATE-REST-DATA-SOURCE-COPY'
,p_page_mode=>'MODAL'
,p_step_title=>'Create REST Data Source - Copy'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213425326892450628)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true'
,p_help_text=>'sec_authentication.htm'
,p_page_component_map=>'01'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(1588251353348673008)
,p_name=>'Create REST Data Source'
,p_template=>wwv_flow_imp.id(42025417508627628)
,p_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ROWID,',
'       id,',
'       name,',
'       case when reference_id is not null then ''Y'' else ''N'' end as is_subscribed,',
'       case',
'         when reference_id is null and :P1906_COPY_FROM = :FB_FLOW_ID then wwv_flow_lang.system_message( ''F4000.P158.COPY_OF'', name )',
'         else name',
'       end as new_name,',
'       case',
'         when :P1906_COPY_FROM = :FB_FLOW_ID then ''N''',
'         when reference_id is not null       then ''Y''',
'         else ''SUBSCRIBE''',
'       end as action',
'  from wwv_flow_web_src_modules a',
' where flow_id           = :P1906_COPY_FROM',
'   and security_group_id = :WORKSPACE_ID',
'   and (',
'       -- Don''t show subscribed REST Data Source, because they can''t be copied',
'          (   :P1906_COPY_FROM = :FB_FLOW_ID',
'          and reference_id is null',
'          )',
'       -- Don''t show REST Data Source ins which have already been copied from another application',
'       or (   :P1906_COPY_FROM <> :FB_FLOW_ID',
'          and not exists ( select 1',
'                             from wwv_flow_web_src_modules b',
'                            where b.flow_id           = :FB_FLOW_ID',
'                              and b.security_group_id = :WORKSPACE_ID',
'                              and b.name              = a.name',
'                         )',
'          )',
'       )',
' order by name',
''))
,p_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Identify the REST Data Source to be copied and select the copy option. Copy options include:</p>',
'<ul>',
'    <li><strong>Yes.</strong> Copy the REST Data Source.</li>',
'    <li><strong>No.</strong> Do not copy this REST Data Source.</li>',
'    <li><strong>Copy and Subscribe.</strong> Subscribing to a REST Data Source puts a copy of it in your application and sets the REST Data Source master reference.</li>',
'</ul>',
''))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(161025749003385219)
,p_query_column_id=>1
,p_column_alias=>'ROWID'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(247724961632524615)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(247725572553524621)
,p_query_column_id=>3
,p_column_alias=>'NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Name'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(247725234313524618)
,p_query_column_id=>4
,p_column_alias=>'IS_SUBSCRIBED'
,p_column_display_sequence=>4
,p_column_heading=>'Subscribed'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(84259319526460470)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(247725613315524622)
,p_query_column_id=>5
,p_column_alias=>'NEW_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'To Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT'
,p_column_width=>40
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(247725472450524620)
,p_query_column_id=>6
,p_column_alias=>'ACTION'
,p_column_display_sequence=>6
,p_column_heading=>'Action'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'SELECT_LIST_FROM_LOV'
,p_named_lov=>wwv_flow_imp.id(247782857688295098)
,p_lov_show_nulls=>'NO'
,p_derived_column=>'N'
,p_lov_display_extra=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1588253035120673025)
,p_plug_name=>'Buttons'
,p_parent_plug_id=>wwv_flow_imp.id(1588251353348673008)
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1681855286682850105)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(249385562937130742)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1681855469959850106)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1681856251746850108)
,p_plug_name=>'Create REST Data Source'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(247699430129474724)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1681855469959850106)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy REST Data Sources'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(247699828884474724)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(1681855469959850106)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(247698055269474721)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(1681855469959850106)
,p_button_name=>'DESELECT_ALL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--padLeft'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Deselect All'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(247701814528474726)
,p_branch_name=>'Go To Page 1901'
,p_branch_action=>'f?p=&APP_ID.:1901:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(247702256077474726)
,p_branch_name=>'Go To Page 1906'
,p_branch_action=>'f?p=&APP_ID.:1906:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(247699828884474724)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(161025581910385217)
,p_tabular_form_region_id=>wwv_flow_imp.id(1588251353348673008)
,p_validation_name=>'REST Source Name must be unique'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'  from wwv_flow_web_src_modules',
' where name = :NEW_NAME and :ACTION in (''Y'', ''SUBSCRIBE'')',
'   and flow_id = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'This name is already used by an existing REST Data Source.'
,p_when_button_pressed=>wwv_flow_imp.id(247699430129474724)
,p_only_for_changed_rows=>'N'
,p_associated_column=>'NEW_NAME'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(161025995961385221)
,p_tabular_form_region_id=>wwv_flow_imp.id(1588251353348673008)
,p_validation_name=>'REST Source Static ID must be unique'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_web_src_modules',
' where flow_id            = :FB_FLOW_ID',
'   and security_group_id  = :FLOW_SECURITY_GROUP_ID',
'   and static_id          = regexp_replace( lower( :NEW_NAME ), ''[^abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890]+'', ''_'' )',
'   and :ACTION           in (''Y'', ''SUBSCRIBE'')'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'The REST Source name "&NEW_NAME!HTML." will lead to a static ID which is already taken. Choose a different name.'
,p_when_button_pressed=>wwv_flow_imp.id(247699430129474724)
,p_only_for_changed_rows=>'N'
,p_associated_column=>'NEW_NAME'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(247725702391524623)
,p_name=>'Deselect All'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(247698055269474721)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(247725886042524624)
,p_event_id=>wwv_flow_imp.id(247725702391524623)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'td[headers=ACTION] select'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(247697323436474718)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(1588251353348673008)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy REST Data Sources'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_id   number;',
'begin',
'    if :ACTION in (''Y'', ''SUBSCRIBE'') then           ',
'        l_id := wwv_flow_web_src_dev.copy_web_src_module (',
'            p_from_application_id    => :P1906_COPY_FROM,',
'            p_from_web_src_module_id => :ID,',
'            p_to_application_id      => :FB_FLOW_ID,',
'            p_to_name                => :NEW_NAME,',
'            p_subscribe              => ( :ACTION = ''SUBSCRIBE'' ) );',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to copy REST Data Source.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(247699430129474724)
,p_only_for_changed_rows=>'N'
,p_process_success_message=>'REST Data Sources copied.'
,p_internal_uid=>247697323436474718
);
end;
/
prompt --application/pages/page_01908
begin
wwv_flow_imp_page.create_page(
 p_id=>1908
,p_name=>'Create REST Data Source - Catalog'
,p_alias=>'CREATE-REST-DATA-SOURCE-CATALOG'
,p_page_mode=>'MODAL'
,p_step_title=>'Create REST Data Source - Catalog'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_css_file_urls=>'#FONT_APEX_LATEST_DIRECTORY#css/font-apex#MIN#.css'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-CardView-icon.fa,',
'.a-CardView-icon.fa.fa-lg,',
'.a-CardView-icon.a-Icon {',
'  font-size: 32px',
'}',
'',
'.a-CardView-icon {',
'  padding: 0',
'}',
'',
'.a-CardView-body {',
'  padding-top: 0',
'}',
'',
'.a-CardView-mainContent {',
'  display: -webkit-box;',
'  -webkit-box-orient: vertical;',
'  overflow: hidden;',
'  text-overflow: ellipsis;',
'  -webkit-line-clamp: 3;',
'}',
'',
'.a-FA-cards {',
'  --a-cv-header-padding-y: 12px;',
'  --a-cv-body-padding-x: 12px;',
'  --a-cv-maincontent-font-size: 13px;',
'  --a-cv-title-font-size: 16px;',
'}',
'',
'.a-FA-cards .a-CardView-header {',
'  flex-grow: 0;',
'  font-size: 14px;',
'}',
'',
'.a-FA-cards .a-CardView-title {',
'    margin-bottom: 6px;',
'}'))
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'23'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(28033106525072744)
,p_plug_name=>'REST Source Catalogs'
,p_region_name=>'icons'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_grid_column_span=>10
,p_plug_display_column=>2
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''CATALOG''                     as source_type,',
'       g.id                          as group_id, ',
'       g.name                        as group_name, ',
'       c.id                          as source_id, ',
'       c.name                        as catalog_name, ',
'       substr(c.description, 1, 200) as catalog_description, ',
'       c.version, ',
'       count(s.id)                   as service_count',
'  from WWV_WEB_SRC_CATALOG_GROUPS g,',
'       WWV_WEB_SRC_CATALOGS       c,',
'       wwv_web_src_catalog_services s',
' where c.security_group_id = g.security_group_id',
'   and s.security_group_id = g.security_group_id',
'   and s.catalog_id        = c.id',
'   and c.catalog_group_id  = g.id',
'   and g.security_group_id = :WORKSPACE_ID',
' group by g.id,',
'          g.name, ',
'          c.id, ',
'          c.name, ',
'          c.description, ',
'          c.version',
' '))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_CARDS'
,p_plug_query_num_rows_type=>'SCROLL'
,p_show_total_row_count=>false
);
wwv_flow_imp_page.create_card(
 p_id=>wwv_flow_imp.id(28033258362072745)
,p_region_id=>wwv_flow_imp.id(28033106525072744)
,p_layout_type=>'GRID'
,p_component_css_classes=>'a-FA-cards'
,p_title_adv_formatting=>false
,p_title_column_name=>'CATALOG_NAME'
,p_sub_title_adv_formatting=>true
,p_sub_title_html_expr=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<strong>&GROUP_NAME.</strong>',
'<br>',
'<br>',
'{case SERVICE_COUNT/}',
'{when 0/}',
'Contains no Services.',
'{when 1/}',
'Contains 1 Service.',
'{otherwise/}',
'Contains &SERVICE_COUNT. Services.',
'{endcase/}',
''))
,p_body_adv_formatting=>false
,p_body_column_name=>'CATALOG_DESCRIPTION'
,p_second_body_adv_formatting=>false
,p_badge_column_name=>'VERSION'
,p_media_adv_formatting=>false
,p_pk1_column_name=>'SOURCE_ID'
);
wwv_flow_imp_page.create_card_action(
 p_id=>wwv_flow_imp.id(28033486619072747)
,p_card_id=>wwv_flow_imp.id(28033258362072745)
,p_action_type=>'TITLE'
,p_display_sequence=>20
,p_link_target_type=>'REDIRECT_PAGE'
,p_link_target=>'f?p=&APP_ID.:1911:&SESSION.::&DEBUG.:1911:P1911_SOURCE_ID,P1911_TYPE:&SOURCE_ID.,&SOURCE_TYPE.'
);
wwv_flow_imp_page.create_card_action(
 p_id=>wwv_flow_imp.id(6176128763901812)
,p_card_id=>wwv_flow_imp.id(28033258362072745)
,p_action_type=>'BUTTON'
,p_position=>'PRIMARY'
,p_display_sequence=>30
,p_label=>'Add All '
,p_link_target_type=>'REDIRECT_PAGE'
,p_link_target=>'f?p=&APP_ID.:1910:&SESSION.:SELECT_ALL:&DEBUG.::P1910_SOURCE_ID,P1910_TYPE:&SOURCE_ID.,&SOURCE_TYPE.'
,p_button_display_type=>'TEXT'
,p_is_hot=>false
);
wwv_flow_imp_page.create_card_action(
 p_id=>wwv_flow_imp.id(4004069838287608)
,p_card_id=>wwv_flow_imp.id(28033258362072745)
,p_action_type=>'BUTTON'
,p_position=>'SECONDARY'
,p_display_sequence=>40
,p_label=>'Browse'
,p_link_target_type=>'REDIRECT_PAGE'
,p_link_target=>'f?p=&APP_ID.:1911:&SESSION.::&DEBUG.:1911:P1911_SOURCE_ID,P1911_TYPE:&SOURCE_ID.,&SOURCE_TYPE.'
,p_button_display_type=>'TEXT'
,p_is_hot=>true
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1686174764143052945)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(249385562937130742)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1686252753195997266)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4412518378221665)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1686252753195997266)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1905:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
end;
/
prompt --application/pages/page_01909
begin
wwv_flow_imp_page.create_page(
 p_id=>1909
,p_name=>'Create REST Data Source - Catalog Services'
,p_alias=>'CREATE-REST-DATA-SOURCE-CATALOG-SERVICES'
,p_page_mode=>'MODAL'
,p_step_title=>'Create REST Data Source - Catalog Services'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213425326892450628)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'11'
);
end;
/
prompt --application/pages/page_01910
begin
wwv_flow_imp_page.create_page(
 p_id=>1910
,p_name=>'Create REST Data Source - Catalog Details'
,p_alias=>'CREATE-REST-DATA-SOURCE-CATALOG-DETAILS'
,p_page_mode=>'MODAL'
,p_step_title=>'Create REST Data Source - Catalog Details'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_css_file_urls=>'#FONT_APEX_LATEST_DIRECTORY#css/font-apex#MIN#.css'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-CardView-icon.fa, .a-CardView-icon.fa.fa-lg, .a-CardView-icon.a-Icon {font-size: 32px}',
'.a-CardView-icon {padding:0}',
'.a-CardView-body {padding-top:0}',
'.a-ContentRowReport-itemActions {display: none}'))
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1926927304132410)
,p_plug_name=>'Authentication'
,p_region_template_options=>'#DEFAULT#:a-Alert--noIcon:a-Alert--info:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null ',
'  from wwv_web_src_catalog_services cs,',
'       wwv_flow_collections         so',
' where cs.id                = so.n001',
'   and cs.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and cs.authentication_type is not null',
'   and so.collection_name   = ''REST_CATALOG_SELECTIONS''',
'   and so.c002              = ''CATALOG'''))
,p_plug_header=>'<p>Some of the chosen catalog services require authentication. Choose an existing <strong>Web Credential</strong>, or have &PRODUCT_NAME. create a new one.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(4007469840287642)
,p_name=>'Review Selected Catalog Services'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with service_operations as (',
'    select /*+ RESULT_CACHE */ cs.id, ',
'           listagg (op.operation, '','' ) within group ( order by op.operation ) as operations',
'      from wwv_web_src_catalog_services cs, ',
'           json_table( cs.details_json,',
'                       ''$.operations[*]''',
'                       columns ( operation  varchar2(255) path ''$.operation'' ) ) op',
'    where cs.security_group_id = :WORKSPACE_ID',
'      and cs.id in (',
'                     select c.n001 as id',
'                       from wwv_flow_collections c',
'                      where collection_name = ''REST_CATALOG_SELECTIONS''',
'                        and c.c002          = ''CATALOG'' )',
'                      group by cs.id',
')',
'select null as cb, ',
'       cs.catalog_id, ',
'       cs.id, ',
'       cs.name, ',
'       cs.icon, ',
'       substr(cs.description, 1, 200) || case when length(cs.description) > 200 then ''...'' else null end as description,',
'       cs.version,',
'       wwv_flow_lang.runtime_message( ''WEB.SOURCE.SERVICE_FROM_CATALOG'' ) as link_title,',
'       decode(instr(so.operations, ''GET''),    0, '''', ''<span class="a-IssueLabel label-color-13">GET</span>'')    ||',
'       decode(instr(so.operations, ''POST''),   0, '''', ''<span class="a-IssueLabel label-color-14">POST</span>'')   || ',
'       decode(instr(so.operations, ''PUT''),    0, '''', ''<span class="a-IssueLabel label-color-15">PUT</span>'')    || ',
'       decode(instr(so.operations, ''PATCH''),  0, '''', ''<span class="a-IssueLabel label-color-15">PATCH</span>'')  || ',
'       decode(instr(so.operations, ''DELETE''), 0, '''', ''<span class="a-IssueLabel label-color-16">DELETE</span>'') as operations_html',
'  from wwv_web_src_catalog_services cs,',
'       service_operations           so',
' where so.id                = cs.id',
'   and cs.security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>true
,p_query_row_template=>wwv_flow_imp.id(4900642989550776)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4007522253287643)
,p_query_column_id=>1
,p_column_alias=>'CB'
,p_column_display_sequence=>10
,p_column_heading=>'Cb'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4007625220287644)
,p_query_column_id=>2
,p_column_alias=>'CATALOG_ID'
,p_column_display_sequence=>20
,p_column_heading=>'Catalog Id'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4007777652287645)
,p_query_column_id=>3
,p_column_alias=>'ID'
,p_column_display_sequence=>30
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4007820421287646)
,p_query_column_id=>4
,p_column_alias=>'NAME'
,p_column_display_sequence=>40
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4007914294287647)
,p_query_column_id=>5
,p_column_alias=>'ICON'
,p_column_display_sequence=>50
,p_column_heading=>'Icon'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4008021812287648)
,p_query_column_id=>6
,p_column_alias=>'DESCRIPTION'
,p_column_display_sequence=>60
,p_column_heading=>'Description'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4008190566287649)
,p_query_column_id=>7
,p_column_alias=>'VERSION'
,p_column_display_sequence=>70
,p_column_heading=>'Version'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2600195888934101)
,p_query_column_id=>8
,p_column_alias=>'LINK_TITLE'
,p_column_display_sequence=>90
,p_column_heading=>'Link Title'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4008210715287650)
,p_query_column_id=>9
,p_column_alias=>'OPERATIONS_HTML'
,p_column_display_sequence=>80
,p_column_heading=>'Operations Html'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1688230994460735294)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(249385562937130742)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1690861990302251926)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4609573941254660)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(1690861990302251926)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create REST Data Sources'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4609984718254661)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1690861990302251926)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1911:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(6176618035901817)
,p_branch_action=>'f?p=&APP_ID.:1901:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6176315851901814)
,p_name=>'P1910_SOURCE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1690861990302251926)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
,p_item_comment=>'The Source ID and Catalog Type will only be used if the developer choose Select All on Page 1908. If the developer choose specific services from different applications/catalogs then the type really has no purpose because the items will already be inc'
||'luded in the collection.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6176446254901815)
,p_name=>'P1910_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1690861990302251926)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
,p_item_comment=>'The Source ID and Catalog Type will only be used if the developer choose Select All on Page 1908. If the developer choose specific services from different applications/catalogs then the type really has no purpose because the items will already be inc'
||'luded in the collection.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6814528733316805)
,p_name=>'P1910_CREDENTIAL_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1926927304132410)
,p_prompt=>'Web Credential'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LOV_CREDENTIAL_STORES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_credentials',
' where security_group_id    = :FLOW_SECURITY_GROUP_ID',
'   and authentication_type != ''KEY_PAIR'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Create New -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose an existing Web Credential for the REST Data Source. A new Web Credential will be created if one of the catalog services requires authentication and an existing value is not selected.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(6176534622901816)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create REST from Catalog'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'    l_installed_plugins           wwv_flow_t_varchar2;',
'begin',
'    for c in ( ',
'        select c.n001 as id, ',
'               c.c002 as source_type, ',
'               c.n003 as source_id, ',
'               m.name as service_name, ',
'               l.name as catalog_name',
'          from wwv_flow_collections         c,',
'               wwv_web_src_catalog_services m,',
'               wwv_web_src_catalogs         l',
'         where c.n001              = m.id',
'           and m.catalog_id        = l.id',
'           and m.security_group_id = :FLOW_SECURITY_GROUP_ID',
'           and l.security_group_id = :FLOW_SECURITY_GROUP_ID',
'           and c.collection_name   = ''REST_CATALOG_SELECTIONS''',
'           and c.c002              = ''CATALOG'' ) ',
'    loop',
'        if c.source_type = ''CATALOG'' then ',
'            wwv_web_src_catalog.rest_source_from_catalog(',
'                p_catalog_id                  => c.source_id,',
'                p_service_id                  => c.id,',
'                p_application_id              => :FB_FLOW_ID,',
'                p_rest_source_name            => c.service_name,',
'                p_credential_id               => :P1910_CREDENTIAL_ID,',
'                p_installed_plugins           => l_installed_plugins  );',
'        end if;',
'    end loop;',
'end;',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(4609573941254660)
,p_process_success_message=>'REST Data Sources created successfully'
,p_internal_uid=>6176534622901816
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(6176279155901813)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Select All'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- if select all was chosen on the Catalog/Application page (1908) ',
'-- then assume that the user wants only the services chosen and ',
'-- not any others that may have been in the cart. Perhaps this is a bad assumption',
'-- but that is what I''m going with. :-D ',
'declare',
'    l_name varchar2(25) := ''REST_CATALOG_SELECTIONS'';',
'begin',
'    -- truncate the collection',
'    WWV_FLOW_COLLECTION.CREATE_OR_TRUNCATE_COLLECTION(l_name);',
'',
'    if :P1910_TYPE = ''CATALOG'' then ',
'        -- loop over the application or catalog and add all of the services to the collection',
'        for c in (',
'            select :P1910_SOURCE_ID as catalog_id, ',
'                s.id,',
'                s.name',
'            from wwv_web_src_catalog_services s',
'            join wwv_web_src_catalogs c on (c.id = s.catalog_id)',
'            where c.security_group_id = :WORKSPACE_ID',
'            and c.id                = :P1910_SOURCE_ID            ',
'        ) loop',
'            -- since the collection was just truncated, don''t worry about checking for duplicates.',
'            -- maybe I should also have an action???   ',
'            wwv_flow_collection.add_member(',
'                p_collection_name => l_name,',
'                p_n001 => c.id,              -- ID: the REST_MODULE_ID or CATALOG_SERVICE_ID  ',
'                p_c002 => :P1910_TYPE,       -- SOURCE_TYPE: either ''APPLICATION'' or ''CATALOG''',
'                p_n003 => :P1910_SOURCE_ID   -- SOURCE_ID: the APPLICATION_ID or CATALOG_ID',
'                );',
'        end loop;',
'    else',
'        -- loop over the application or catalog and add all of the services to the collection',
'        for c in (',
'            select :P1909_SOURCE_ID as flow_id, ',
'                m.id,',
'                m.name',
'            from wwv_flow_web_src_modules m',
'            where m.flow_id         = :P1910_SOURCE_ID',
'            and m.security_group_id = :WORKSPACE_ID',
'            order by m.name      ',
'        ) loop',
'            -- since the collection was just truncated, don''t worry about checking for duplicates.',
'            -- maybe I should also have an action???   ',
'            wwv_flow_collection.add_member(',
'                p_collection_name => l_name,',
'                p_n001 => c.id,              -- ID: the REST_MODULE_ID or CATALOG_SERVICE_ID  ',
'                p_c002 => :P1910_TYPE,       -- SOURCE_TYPE: either ''APPLICATION'' or ''CATALOG''',
'                p_n003 => :P1910_SOURCE_ID   -- SOURCE_ID: the APPLICATION_ID or CATALOG_ID',
'                );',
'        end loop;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'SELECT_ALL'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>6176279155901813
);
end;
/
prompt --application/pages/page_01911
begin
wwv_flow_imp_page.create_page(
 p_id=>1911
,p_name=>'Create REST Data Source - Catalog Services'
,p_alias=>'CREATE-REST-DATA-SOURCE-CATALOG-SERVICES1'
,p_page_mode=>'MODAL'
,p_step_title=>'Create REST Data Source - Catalog Services'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-Dialog--wizard .a-Dialog-body {',
'  padding: 0;',
'  display: flex;',
'  flex-direction: column;',
'} ',
'',
'.a-RestCatalog-panel .a-Region-header {',
'  min-height: 48px;',
'}'))
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'22'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(513831557843753001)
,p_plug_name=>'Container'
,p_region_css_classes=>'a-RestCatalog-container'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4703569920428520)
,p_plug_name=>'Left Container'
,p_region_name=>'P1911_LEFT_COL'
,p_parent_plug_id=>wwv_flow_imp.id(513831557843753001)
,p_region_css_classes=>'a-RestCatalog-panel'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(5162137573346398)
,p_name=>'Available Catalog Services'
,p_region_name=>'P1911_RESULTS'
,p_parent_plug_id=>wwv_flow_imp.id(4703569920428520)
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with service_operations as (',
'    select /*+ RESULT_CACHE */ ',
'           cs.id, ',
'           listagg (op.operation, '','' ) within group ( order by op.operation ) as operations',
'      from wwv_web_src_catalog_services cs, ',
'           json_table( cs.details_json,',
'                       ''$.operations[*]''',
'                       columns ( operation varchar2(255) path ''$.operation'' ) ) op',
'     where cs.catalog_id        = :P1911_SOURCE_ID     ',
'       and cs.security_group_id = :FLOW_SECURITY_GROUP_ID',
'     group by cs.id)',
'select cs.catalog_id, ',
'       cs.id, ',
'       cs.name, ',
'       cs.icon, ',
'       substr(cs.description, 1, 200) || case when length(cs.description) > 200 then ''...'' else null end as description,',
'       cs.version,',
'       wwv_flow_lang.runtime_message( ''WEB.SOURCE.ADD_FROM_CATALOG'', cs.name ) as link_title,',
'       decode(instr(so.operations, ''GET''),    0, '''', ''<span class="a-IssueLabel label-color-13">GET</span>'')    ||',
'       decode(instr(so.operations, ''POST''),   0, '''', ''<span class="a-IssueLabel label-color-14">POST</span>'')   || ',
'       decode(instr(so.operations, ''PUT''),    0, '''', ''<span class="a-IssueLabel label-color-15">PUT</span>'')    || ',
'       decode(instr(so.operations, ''PATCH''),  0, '''', ''<span class="a-IssueLabel label-color-15">PATCH</span>'')  || ',
'       decode(instr(so.operations, ''DELETE''), 0, '''', ''<span class="a-IssueLabel label-color-16">DELETE</span>'') as operations_html, ',
'       ''icon-plus'' as icon_class -- used by the report to determine what icon to show ',
'  from wwv_web_src_catalog_services cs,',
'       service_operations           so',
' where so.id               = cs.id',
'   and cs.catalog_id       = :P1911_SOURCE_ID     ',
'   and cs.security_group_id = :FLOW_SECURITY_GROUP_ID ',
'   and not exists (',
'                    select null ',
'                      from wwv_flow_collections c',
'                     where collection_name = ''REST_CATALOG_SELECTIONS''',
'                       and c.c002          = ''CATALOG''',
'                       and c.n001          = cs.id ) ',
''))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(4900642989550776)
,p_query_num_rows=>50
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No services to select'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_prn_format=>'PDF'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4004943022287617)
,p_query_column_id=>1
,p_column_alias=>'CATALOG_ID'
,p_column_display_sequence=>40
,p_column_heading=>'Catalog Id'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5164163458346407)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>20
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5164548760346408)
,p_query_column_id=>3
,p_column_alias=>'NAME'
,p_column_display_sequence=>30
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4005067896287618)
,p_query_column_id=>4
,p_column_alias=>'ICON'
,p_column_display_sequence=>50
,p_column_heading=>'Icon'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4005186018287619)
,p_query_column_id=>5
,p_column_alias=>'DESCRIPTION'
,p_column_display_sequence=>60
,p_column_heading=>'Description'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4005262517287620)
,p_query_column_id=>6
,p_column_alias=>'VERSION'
,p_column_display_sequence=>70
,p_column_heading=>'Version'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1467936331002249)
,p_query_column_id=>7
,p_column_alias=>'LINK_TITLE'
,p_column_display_sequence=>100
,p_column_heading=>'Link Title'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4005372853287621)
,p_query_column_id=>8
,p_column_alias=>'OPERATIONS_HTML'
,p_column_display_sequence=>80
,p_column_heading=>'Operations Html'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4006361019287631)
,p_query_column_id=>9
,p_column_alias=>'ICON_CLASS'
,p_column_display_sequence=>90
,p_column_heading=>'Icon Class'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5162260383346398)
,p_plug_name=>'Search'
,p_parent_plug_id=>wwv_flow_imp.id(4703569920428520)
,p_region_template_options=>'a-Region--noPadding:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'NATIVE_FACETED_SEARCH'
,p_filtered_region_id=>wwv_flow_imp.id(5162137573346398)
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'batch_facet_search', 'N',
  'compact_numbers_threshold', '10000',
  'show_charts', 'N',
  'show_current_facets', 'N',
  'show_total_row_count', 'N')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4703659840428521)
,p_plug_name=>'Right Container'
,p_region_name=>'P1911_RIGHT_COL'
,p_parent_plug_id=>wwv_flow_imp.id(513831557843753001)
,p_region_css_classes=>'a-RestCatalog-panel'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(4005498207287622)
,p_name=>'Selected Catalog Services'
,p_region_name=>'P1911_SELECTED'
,p_parent_plug_id=>wwv_flow_imp.id(4703659840428521)
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with service_operations as (',
'    select /*+ RESULT_CACHE */ ',
'           cs.id, ',
'           listagg (op.operation, '','' ) within group ( order by op.operation ) as operations',
'      from wwv_web_src_catalog_services cs, ',
'           json_table( cs.details_json,',
'                       ''$.operations[*]''',
'                       columns ( operation  varchar2(255) path ''$.operation'' ) ) op',
'     where cs.catalog_id        = :P1911_SOURCE_ID     ',
'       and cs.security_group_id = :WORKSPACE_ID',
'     group by cs.id',
'),',
'catalog_selections as (',
'    select c.n001 as id, ',
'           c.seq_id',
'      from wwv_flow_collections c',
'     where collection_name = ''REST_CATALOG_SELECTIONS''',
'       and c.c002          = ''CATALOG''',
')',
'select s.seq_id,',
'       cs.catalog_id, ',
'       cs.id, ',
'       cs.name, ',
'       cs.icon, ',
'       substr(cs.description, 1, 200) || case when length(cs.description) > 200 then ''...'' else null end as description,',
'       cs.version,',
'       wwv_flow_lang.runtime_message( ''WEB.SOURCE.UNADD_FROM_CATALOG'', cs.name ) as link_title,',
'       decode(instr(so.operations, ''GET''),    0, '''', ''<span class="a-IssueLabel label-color-13">GET</span>'')    ||',
'       decode(instr(so.operations, ''POST''),   0, '''', ''<span class="a-IssueLabel label-color-14">POST</span>'')   || ',
'       decode(instr(so.operations, ''PUT''),    0, '''', ''<span class="a-IssueLabel label-color-15">PUT</span>'')    || ',
'       decode(instr(so.operations, ''PATCH''),  0, '''', ''<span class="a-IssueLabel label-color-15">PATCH</span>'')  || ',
'       decode(instr(so.operations, ''DELETE''), 0, '''', ''<span class="a-IssueLabel label-color-16">DELETE</span>'') as operations_html, ',
'       ''icon-remove'' as icon_class -- used by the report to determine what icon to show ',
'  from wwv_web_src_catalog_services cs,',
'       service_operations           so,',
'       catalog_selections           s',
' where so.id                = cs.id',
'   and s.id                 = cs.id',
'   and cs.security_group_id = :WORKSPACE_ID',
''))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>true
,p_query_row_template=>wwv_flow_imp.id(4900642989550776)
,p_query_num_rows=>50
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No services selected.'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4005507153287623)
,p_query_column_id=>1
,p_column_alias=>'SEQ_ID'
,p_column_display_sequence=>10
,p_column_heading=>'Seq Id'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4005688202287624)
,p_query_column_id=>2
,p_column_alias=>'CATALOG_ID'
,p_column_display_sequence=>20
,p_column_heading=>'Catalog Id'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4005724426287625)
,p_query_column_id=>3
,p_column_alias=>'ID'
,p_column_display_sequence=>30
,p_column_heading=>'Id'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4005869465287626)
,p_query_column_id=>4
,p_column_alias=>'NAME'
,p_column_display_sequence=>40
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4005983809287627)
,p_query_column_id=>5
,p_column_alias=>'ICON'
,p_column_display_sequence=>50
,p_column_heading=>'Icon'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4006060972287628)
,p_query_column_id=>6
,p_column_alias=>'DESCRIPTION'
,p_column_display_sequence=>60
,p_column_heading=>'Description'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4006192809287629)
,p_query_column_id=>7
,p_column_alias=>'VERSION'
,p_column_display_sequence=>70
,p_column_heading=>'Version'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1468060544002250)
,p_query_column_id=>8
,p_column_alias=>'LINK_TITLE'
,p_column_display_sequence=>100
,p_column_heading=>'Link Title'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4006280777287630)
,p_query_column_id=>9
,p_column_alias=>'OPERATIONS_HTML'
,p_column_display_sequence=>80
,p_column_heading=>'Operations Html'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4006440627287632)
,p_query_column_id=>10
,p_column_alias=>'ICON_CLASS'
,p_column_display_sequence=>90
,p_column_heading=>'Icon Class'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1693231109379146639)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(249385562937130742)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1696025924545599580)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5165329416352612)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(1696025924545599580)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5165773943352613)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1696025924545599580)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1908:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1465712347002227)
,p_branch_action=>'f?p=&APP_ID.:1910:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4006750780287635)
,p_name=>'P1911_ACTION_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1696025924545599580)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
,p_item_comment=>'Item used by dynamic actions to add or remove services from the selected list. The item is not Value Protected because JavaScript is used to set the value and send to the server for further processing. '
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5162771560346398)
,p_name=>'P1911_SEARCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(5162260383346398)
,p_prompt=>'Search'
,p_source=>'NAME'
,p_source_type=>'FACET_COLUMN'
,p_display_as=>'NATIVE_SEARCH'
,p_attribute_01=>'ROW'
,p_attribute_02=>'FACET'
,p_fc_show_label=>false
,p_fc_collapsible=>true
,p_fc_initial_collapsed=>false
,p_fc_filter_values=>false
,p_fc_show_chart=>false
,p_fc_actions_filter=>false
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5166147826352619)
,p_name=>'P1911_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1696025924545599580)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
,p_item_comment=>'TYPE values should be CATALOG or APPLICATION. '
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5166508289352621)
,p_name=>'P1911_SOURCE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1696025924545599580)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
,p_item_comment=>'The source id will either be an Application Id or a REST Catalog Id depending upon the type.'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1465625664002226)
,p_validation_name=>'Must have services selected to proceed'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    select 1',
'      from wwv_flow_collections c',
'     where collection_name = ''REST_CATALOG_SELECTIONS''',
'       and c.c002          = ''CATALOG'''))
,p_validation_type=>'EXISTS'
,p_error_message=>'Please select REST sources from the catalog in order to proceed.'
,p_when_button_pressed=>wwv_flow_imp.id(5165329416352612)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5004358735368697)
,p_name=>'Add Service to Selected'
,p_event_sequence=>20
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'#P1911_LEFT_COL #P1911_RESULTS .a-ContentRowReport-itemWrap'
,p_bind_type=>'live'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5006162837368732)
,p_event_id=>wwv_flow_imp.id(5004358735368697)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1911_ACTION_ID'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'this.triggeringElement.id.substring(8, this.triggeringElement.id.length);'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_da_action_comment=>'Use P1911_ACTION_ID to add the service to the collection. Same item used to remove a selected service.'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5004749188368730)
,p_event_id=>wwv_flow_imp.id(5004358735368697)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    c_name   constant varchar2(25) := ''REST_CATALOG_SELECTIONS'';',
'    l_exists          number := 0;',
'begin',
'    -- if the collection does not exist then create it, should never happen',
'    if not wwv_flow_collection.collection_exists(c_name) then',
'        wwv_flow_collection.create_collection(c_name);',
'    end if;',
'',
'    -- add selected values to the collection',
'    -- do I need logic here to prevent duplicates? yes or I could just add a distinct to the cart query',
'    begin',
'        select 1 ',
'          into l_exists ',
'          from wwv_flow_collections c',
'         where collection_name = c_name',
'           and n001            = :P1911_ACTION_ID',
'           and rownum          = 1;',
'    exception',
'        when no_data_found then',
'            l_exists := 0;',
'    end;',
'',
'    if l_exists = 0 then ',
'        wwv_flow_collection.add_member(',
'            p_collection_name => c_name,',
'            p_n001            => :P1911_ACTION_ID, -- ID: the REST_MODULE_ID or CATALOG_SERVICE_ID  ',
'            p_c002            => :P1911_TYPE,       -- SOURCE_TYPE: either ''APPLICATION'' or ''CATALOG''',
'            p_n003            => :P1911_SOURCE_ID   -- SOURCE_ID: the APPLICATION_ID or CATALOG_ID',
'            );',
'    end if;',
'end;'))
,p_attribute_02=>'P1911_ACTION_ID'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5005145702368731)
,p_event_id=>wwv_flow_imp.id(5004358735368697)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(5162137573346398)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5005623005368731)
,p_event_id=>wwv_flow_imp.id(5004358735368697)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(4005498207287622)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4006937351287637)
,p_name=>'Remove Service from Selected'
,p_event_sequence=>30
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'#P1911_RIGHT_COL #P1911_SELECTED .a-ContentRowReport-itemWrap'
,p_bind_type=>'live'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4007010027287638)
,p_event_id=>wwv_flow_imp.id(4006937351287637)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1911_ACTION_ID'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'this.triggeringElement.id.substring(8, this.triggeringElement.id.length);'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_da_action_comment=>'Use P1911_ACTION_ID to remove the service to the collection. Same item used to add a selected service.'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4007188202287639)
,p_event_id=>wwv_flow_imp.id(4006937351287637)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'    c_name   constant varchar2(25) := ''REST_CATALOG_SELECTIONS'';',
'    l_seq_id          number;',
'begin',
'    -- determine the seq_id of the collection member',
'    select c.seq_id',
'      into l_seq_id',
'      from wwv_flow_collections c',
'     where collection_name = c_name',
'       and c.n001           = :P1911_ACTION_ID',
'       and rownum           = 1;',
'',
'    -- :P1909_SEQ_ID gets set in the dynamic action javascript code',
'    -- remove the service from the collection using the sequence id',
'    wwv_flow_collection.delete_member (',
'        p_collection_name => c_name,',
'        p_seq             => l_seq_id);',
'exception',
'    when no_data_found then',
'        null; -- if the collection does not contain anything, there is also nothing to remove',
'end;'))
,p_attribute_02=>'P1911_ACTION_ID'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4007228926287640)
,p_event_id=>wwv_flow_imp.id(4006937351287637)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(5162137573346398)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4007397123287641)
,p_event_id=>wwv_flow_imp.id(4006937351287637)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(4005498207287622)
);
end;
/
prompt --application/pages/page_01921
begin
wwv_flow_imp_page.create_page(
 p_id=>1921
,p_name=>'REST Data Source'
,p_alias=>'REST-DATA-SOURCE'
,p_step_title=>'REST Data Source'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_read_only_when=>'P1921_REFERENCE_ID'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1503302531184421)
,p_plug_name=>'REST Source Catalog'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>130
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_web_src_catalogs         c',
' where c.security_group_id = :WORKSPACE_ID'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2600997936934109)
,p_plug_name=>'No Catalog'
,p_parent_plug_id=>wwv_flow_imp.id(1503302531184421)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'This REST Data Source does not reference a REST Source Catalog.'
,p_plug_display_condition_type=>'ITEM_IS_NULL'
,p_plug_display_when_condition=>'P1921_CATALOG_ID'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2108820037647632)
,p_plug_name=>'REST Enabled SQL Query'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2503931255903936)
,p_plug_name=>'Open API'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>140
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(3291693434489441)
,p_name=>'Operations'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.id operation_id,',
'       o.name,',
'       o.operation,',
'       nullif(o.url_pattern, '' '') as url_pattern,',
'       o.database_operation,',
'       (select name',
'          from wwv_flow_data_profile_cols dpc',
'         where dpc.security_group_id = o.security_group_id',
'           and dpc.flow_id           = o.flow_id',
'           and dpc.data_profile_id   = m.data_profile_id',
'           and dpc.id                = o.data_profile_array_col_id ) as array_column_name,',
'       nullif((select count(id) ',
'         from wwv_flow_web_src_params p',
'        where p.web_src_module_id = m.id and web_src_operation_id = o.id',
'          and p.security_group_id = m.security_group_id ',
'          and p.flow_id           = m.flow_id ),0) as parameter_count,',
'       case when m.web_source_type = ''NATIVE_ORDS'' and m.attribute_01 = ''Y'' and o.legacy_ords_fixed_page_size is null then ''<span style="color: red" title="'' || wwv_flow_lang.system_message(''apex.websrc.unknown_ords2_fixed_page_size'')||''" class="a-Ic'
||'on icon-error"></span>''',
'            when m.web_source_type = ''NATIVE_ORDS'' and m.attribute_01 = ''Y'' and o.legacy_ords_fixed_page_size < 50    then ''<span style="color: #FFCB3D" title="'' || wwv_flow_lang.system_message(''apex.websrc.small_ords2_fixed_page_size'')||''" class="a-'
||'Icon icon-warning"></span>''',
'            else null',
'       end as warning_icon_class,',
'       wwv_flow_lang.system_message(''apex.websrc.test_operation'') as test_operation_msg,',
'       o.last_updated_on',
'  from wwv_flow_web_src_operations o, ',
'       wwv_flow_web_src_modules m',
' where m.id                = o.web_src_module_id',
'   and o.web_src_module_id = :P1921_WEB_SRC_MODULE_ID',
'   and o.flow_id           = :FB_FLOW_ID',
'   and m.flow_id           = o.flow_id',
'   and m.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and o.security_group_id = m.security_group_id',
'       ',
'   '))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>'No operations defined.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(117793904241505927)
,p_query_column_id=>1
,p_column_alias=>'OPERATION_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Edit'
,p_use_as_row_header=>'N'
,p_column_link=>'javascript:apex.submit({request:"APPLY_CHANGES_EDIT_1922_ID",set:{"P1921_OPERATION_ID":"#OPERATION_ID#"}});'
,p_column_linktext=>'<span class="a-Icon icon-edit" aria-hidden="true"></span><span class="u-VisuallyHidden">Edit Operation</span>'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23466266711366201)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>11
,p_column_heading=>'Name'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3291802638489443)
,p_query_column_id=>3
,p_column_alias=>'OPERATION'
,p_column_display_sequence=>21
,p_column_heading=>'Operation'
,p_use_as_row_header=>'Y'
,p_column_html_expression=>'#OPERATION# #WARNING_ICON_CLASS#'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3292217489489447)
,p_query_column_id=>4
,p_column_alias=>'URL_PATTERN'
,p_column_display_sequence=>31
,p_column_heading=>'URL Pattern'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3291913060489444)
,p_query_column_id=>5
,p_column_alias=>'DATABASE_OPERATION'
,p_column_display_sequence=>41
,p_column_heading=>'Database Action'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(225834585600778166)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1720235670469935)
,p_query_column_id=>6
,p_column_alias=>'ARRAY_COLUMN_NAME'
,p_column_display_sequence=>51
,p_column_heading=>'Array Column'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(345457234158487513)
,p_query_column_id=>7
,p_column_alias=>'PARAMETER_COUNT'
,p_column_display_sequence=>71
,p_column_heading=>'Parameter Count'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(249280242462575816)
,p_query_column_id=>8
,p_column_alias=>'WARNING_ICON_CLASS'
,p_column_display_sequence=>91
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23466492193366203)
,p_query_column_id=>9
,p_column_alias=>'TEST_OPERATION_MSG'
,p_column_display_sequence=>101
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(23466552848366204)
,p_query_column_id=>9
,p_column_alias=>'DERIVED$01'
,p_column_display_sequence=>81
,p_column_heading=>'Test Operation'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{case DATABASE_OPERATION/}',
'{when FETCH_COLLECTION/}',
'    <span onclick=(apex.submit({request:"APPLY_CHANGES_CREATE_1927_TEST_OPERATION",set:{"P1922_ID":"#OPERATION_ID#","P1921_OPERATION_ID":"#OPERATION_ID#"}}))',
'        class="a-Button a-Button--noLabel a-Button--withIcon">',
'        <span class="a-Icon icon-run-script" aria-hidden="true"></span>',
'        <span class="u-VisuallyHidden">#TEST_OPERATION_MSG#</span>',
'    </span>',
'{endcase/}'))
,p_column_alignment=>'CENTER'
,p_derived_column=>'Y'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1720339380469936)
,p_query_column_id=>10
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>111
,p_column_heading=>'Last Updated'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3292099913489445)
,p_plug_name=>'REST Data Source'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3467424016842409)
,p_plug_name=>'Advanced'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>150
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3467516310842410)
,p_plug_name=>'Authentication'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3469297412842427)
,p_plug_name=>'RDS'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3469364086842428)
,p_plug_name=>'REST Data Source'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_04'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3802287696901511)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(4900739432788654)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Tasks'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5902041740682520)
,p_plug_name=>'Synchronization'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P1921_LOCAL_TABLE_NAME'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1373556285674225)
,p_plug_name=>'Synchronization Table does not match Data Profile'
,p_parent_plug_id=>wwv_flow_imp.id(5902041740682520)
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'Synchronization for this REST Data Source is active, but the table does not match the Data Profile. Navigate to <strong>Manage Synchronization</strong> for details.'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1921_SYNC_LOCAL_TABLE_NAME is not null and :P1921_SYNC_STATUS in (',
'    wwv_flow_web_src_sync.c_columns_cannot_be_synced,',
'    wwv_flow_web_src_sync.c_columns_can_be_synced )'))
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1373683531674226)
,p_plug_name=>'Details'
,p_parent_plug_id=>wwv_flow_imp.id(5902041740682520)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1373753236674227)
,p_plug_name=>'Synchronization Table does not exist'
,p_parent_plug_id=>wwv_flow_imp.id(5902041740682520)
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'Synchronization for this REST Data Source is active, but the table does not exist. Navigate to <strong>Manage Synchronization</strong> for details.'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P1921_SYNC_LOCAL_TABLE_NAME is not null and :P1921_SYNC_STATUS = wwv_flow_web_src_sync.c_table_does_not_exist'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1855034187679335708)
,p_plug_name=>'Fetch Rows operation does not exist'
,p_parent_plug_id=>wwv_flow_imp.id(5902041740682520)
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'Synchronization for this REST Data Source is active, but there is no operation mapped to the <strong>Fetch Rows</strong> database operation. Thus synchronization will not work.'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P1921_SYNC_LOCAL_TABLE_NAME is not null and :P1921_SYNC_STATUS = wwv_flow_web_src_sync.c_no_fetch_rows_operation'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(226074768846270104)
,p_name=>'Parameters'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch:a-Report--rowHighlight'
,p_new_grid_row=>false
,p_new_grid_column=>false
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       direction,',
'       name,',
'       param_type,',
'       value,',
'       is_required,',
'       is_query_param',
'  from wwv_flow_web_src_params',
' where web_src_module_id = :P1921_WEB_SRC_MODULE_ID',
'   and web_src_operation_id is null',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P1921_WEB_SRC_MODULE_ID'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>'No Parameters defined.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(226074849985270105)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Edit'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:1923:&SESSION.::&DEBUG.:RP:P1923_ID:#ID#'
,p_column_linktext=>'<span class="a-Icon icon-edit" aria-hidden="true"></span><span class="u-VisuallyHidden">Edit Parameter</span>'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(226075646160270113)
,p_query_column_id=>2
,p_column_alias=>'DIRECTION'
,p_column_display_sequence=>4
,p_column_heading=>'Direction'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(226101569473456167)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(226075245354270109)
,p_query_column_id=>3
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Name'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(226075337267270110)
,p_query_column_id=>4
,p_column_alias=>'PARAM_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(226045111811519566)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(226075442837270111)
,p_query_column_id=>5
,p_column_alias=>'VALUE'
,p_column_display_sequence=>5
,p_column_heading=>'Default Value'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(226075568678270112)
,p_query_column_id=>6
,p_column_alias=>'IS_REQUIRED'
,p_column_display_sequence=>6
,p_column_heading=>'Required'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(84259319526460470)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(510292996514814503)
,p_query_column_id=>7
,p_column_alias=>'IS_QUERY_PARAM'
,p_column_display_sequence=>7
,p_column_heading=>'Use for Row Search'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(84259319526460470)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(226688576185475247)
,p_plug_name=>'REST Data Sources'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p><strong>REST Data Sources</strong> act as a reference to one or multiple external web services. A REST Data Source can contain one or many <strong>Operations</strong> which are the references to a concrete external web service. Configurations at t'
||'he top level are shared across all operations.',
'</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(247725953433524625)
,p_plug_name=>'Subscription'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>120
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'WWV_FLOW_WEB_SRC_MODULES',
  'attribute_02', 'NAME',
  'attribute_03', 'P1921_WEB_SRC_MODULE_ID',
  'attribute_04', 'P1921_REFERENCE_ID',
  'attribute_05', 'SUBSCRIBE_WEB_SRC',
  'attribute_06', 'VERSION_SCN')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(310374200946241813)
,p_name=>'Data Profile'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-BadgeList--fixed:a-BadgeList--xlarge'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'    dp.format,',
'    case when dp.is_single_row = ''Y'' then wwv_flow_lang.system_message(''APEX.WEBSRC.DATAPROFILE.ONE'') else wwv_flow_lang.system_message(''APEX.WEBSRC.DATAPROFILE.MANY'') end as is_single_row,',
'    count( dc.id ) as column_cnt,',
'    count( case when dc.is_hidden = ''Y'' then null else dc.id end ) as visible_column_cnt,',
'    count( dc.expression1 ) as derived_column_cnt',
'from wwv_flow_data_profiles dp, wwv_flow_data_profile_cols dc',
'where dc.data_profile_id (+) = dp.id',
'  and dp.flow_id           = :FB_FLOW_ID',
'  and dp.security_group_id = :FLOW_SECURITY_GROUP_ID',
'  and dp.id                = :P1921_DATA_PROFILE_ID',
'group by dp.format, dp.is_single_row',
'    '))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P1921_DATA_PROFILE_ID'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(1041640454953406573)
,p_query_num_rows=>1
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(310374313473241814)
,p_query_column_id=>1
,p_column_alias=>'FORMAT'
,p_column_display_sequence=>1
,p_column_heading=>'Response Format'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(310374424389241815)
,p_query_column_id=>2
,p_column_alias=>'IS_SINGLE_ROW'
,p_column_display_sequence=>2
,p_column_heading=>'Returns'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(310374547332241816)
,p_query_column_id=>3
,p_column_alias=>'COLUMN_CNT'
,p_column_display_sequence=>3
,p_column_heading=>'Columns'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(310374644698241817)
,p_query_column_id=>4
,p_column_alias=>'VISIBLE_COLUMN_CNT'
,p_column_display_sequence=>4
,p_column_heading=>'Visible'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(310374743849241818)
,p_query_column_id=>5
,p_column_alias=>'DERIVED_COLUMN_CNT'
,p_column_display_sequence=>5
,p_column_heading=>'Derived'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(347000660418384441)
,p_plug_name=>'Settings'
,p_region_name=>'SETTINGS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="color:#FFFFFF;display:none;"'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(347012236147385572)
,p_plug_name=>'Add Javascript code for Plugins'
,p_region_name=>'PLUGIN'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>70
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    -- create the onChange event for the P1921_SCHEME_TYPE and',
'    -- also the initialization code for the dynamic attributes',
'    wwv_flow_plugin_dev.add_onload_code (',
'        p_plugin_type         => wwv_flow_plugin.c_plugin_type_web_source,',
'        p_type_page_item_name => ''P1921_WEB_SOURCE_TYPE'',',
'        p_page_item_prefix    => ''P1921_'',',
'        p_is_wizard           => false',
'    );',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1512474197173406282)
,p_plug_name=>'Learn More'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="padding: 0 12px 12px 12px;"'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<p><a href="&SYSTEM_HELP_URL." target="_blank">''||wwv_flow_lang.system_message(''LEARN MORE'')||'' ...</a></p>'');',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(247726334107524629)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(247725953433524625)
,p_button_name=>'PUBLISH'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Publish'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.:RP,:F4000_P149_ID,F4000_P149_PAGE_ID,F4000_P149_TEMPLATE_TYPE:&P1921_WEB_SRC_MODULE_ID.,&APP_PAGE_ID.,WEB_SOURCE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_web_src_modules',
' where reference_id      = :P1921_WEB_SRC_MODULE_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(310374985011241820)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(3291693434489441)
,p_button_name=>'ADD_OPERATION'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Add Operation'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.submit({request:"APPLY_CHANGES_CREATE_1922_ADD_OPERATION"});'
,p_button_condition=>'P1921_REFERENCE_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(310375040315241821)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(226074768846270104)
,p_button_name=>'ADD_PARAMETER'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Add Parameter'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1923:&SESSION.::&DEBUG.:RP,1923:P1923_WEB_SRC_MODULE_ID,P1923_WEB_SRC_OPERATION_ID:&P1921_WEB_SRC_MODULE_ID.,'
,p_button_condition=>'P1921_REFERENCE_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2600249135934102)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1503302531184421)
,p_button_name=>'SAVE_TO_CATALOG'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Save to Catalog'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1924:&SESSION.::&DEBUG.:RR,1924:P1924_MODULE_ID:&P1921_WEB_SRC_MODULE_ID.'
,p_button_condition=>'P1921_CATALOG_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(225951037719615714)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(3469364086842428)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'', ''DELETE'');'
,p_button_condition=>':P1921_REFERENCE_ID is null or :P1921_SUBSCRIBED_COMP_GRP = ''N'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(310374855235241819)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(310374200946241813)
,p_button_name=>'EDIT_DATA_PROFILE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Edit Data Profile'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.submit({request:"APPLY_CHANGES_EDIT_DATA_PROFILE"});'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(538532741160939913)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(247725953433524625)
,p_button_name=>'UNSUBSCRIBE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Unsubscribe'
,p_button_position=>'NEXT'
,p_button_condition=>':P1921_REFERENCE_ID is not null and :P1921_SUBSCRIBED_COMP_GRP = ''N'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2600342020934103)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(1503302531184421)
,p_button_name=>'SAVE_TO_CATALOG_1'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Save to Catalog'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1924:&SESSION.::&DEBUG.:RR,1924:P1924_MODULE_ID:&P1921_WEB_SRC_MODULE_ID.'
,p_button_condition=>'P1921_CATALOG_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3466756328842402)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(3469364086842428)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    :P1921_FLOW_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(247726194903524627)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(247725953433524625)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Refresh'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1921_REFERENCE_ID is not null ',
'and ( :P1921_VERSION_SCN != :P1921_MASTER_VERSION_SCN or :P1921_VERSION_SCN is null )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1504290766184430)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(1503302531184421)
,p_button_name=>'REFRESH_CATALOG'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Refresh from Catalog'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1928:&SESSION.::&DEBUG.:RR,1928:P1928_MODULE_ID:&P1921_WEB_SRC_MODULE_ID.'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_web_src_modules     m,',
'       wwv_web_src_catalogs         c,',
'       wwv_web_src_catalog_services s',
' where c.internal_name     = m.catalog_internal_name ',
'   and s.name              = m.catalog_service_name ',
'   and c.security_group_id = m.security_group_id',
'   and c.id                = s.catalog_id',
'   and s.security_group_id = m.security_group_id',
'   --',
'   and m.id                = :P1921_WEB_SRC_MODULE_ID',
'   and m.flow_id           = :FB_FLOW_ID',
'   and m.security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(55558637026883028)
,p_branch_name=>'Go To Page 1932 - EDIT_AUTH_REMOTE_SERVER'
,p_branch_action=>'f?p=&APP_ID.:1932:&SESSION.::&DEBUG.:RP:P1932_ID,P1932_BACK_TO_PAGE:&P1921_AUTH_REMOTE_SERVER_ID.,1921&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_EDIT_AUTH_REMOTE_SERVER'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(55558378056883025)
,p_branch_name=>'Go To Page 1932 - EDIT_REMOTE_SERVER'
,p_branch_action=>'f?p=&APP_ID.:1932:&SESSION.::&DEBUG.:RP:P1932_ID,P1932_BACK_TO_PAGE:&P1921_REMOTE_SERVER_ID.,1921&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':REQUEST = ''APPLY_CHANGES_EDIT_REMOTE_SERVER'' and :P1921_WEB_SOURCE_TYPE != wwv_flow_exec_web_src.c_native_web_src_restsql'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2241531179021521)
,p_branch_name=>'Go To Page 1925 - EDIT_DATA_PROFILE'
,p_branch_action=>'f?p=&APP_ID.:1925:&SESSION.::&DEBUG.:RP,:P1925_BACK_TO_PAGE,P1925_DATA_PROFILE_ID,P1925_REFERENCE_ID:1921,&P1921_DATA_PROFILE_ID.,&P1921_REFERENCE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_EDIT_DATA_PROFILE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2109916656647643)
,p_branch_name=>'Go To Page 1601'
,p_branch_action=>'f?p=&APP_ID.:1601:&SESSION.::&DEBUG.:RP,:P1601_ID,P1601_BACK_TO_PAGE:&P1921_REMOTE_SERVER_ID.,1921&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':REQUEST = ''APPLY_CHANGES_EDIT_REMOTE_SERVER'' and :P1921_WEB_SOURCE_TYPE = wwv_flow_exec_web_src.c_native_web_src_restsql'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(310376674243241837)
,p_branch_name=>'Go To Page 1621'
,p_branch_action=>'f?p=&APP_ID.:1621:&SESSION.::&DEBUG.:RP:P1621_ID,P1621_BACK_TO_PAGE:&P1921_CREDENTIAL_ID.,&APP_PAGE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_EDIT_CREDENTIAL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3469622984842431)
,p_branch_name=>'Go To Page 1921'
,p_branch_action=>'f?p=&APP_ID.:1921:&SESSION.::&DEBUG.:RP,::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(3466756328842402)
,p_branch_sequence=>60
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1921_RETURN_TO_PAGE'
,p_branch_condition_text=>'YES'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1976414824539731)
,p_branch_name=>'Go To Page 1901'
,p_branch_action=>'f?p=&APP_ID.:1901:&SESSION.::&DEBUG.:RP,1901,1921,1922,1923::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>70
,p_branch_condition_type=>'REQUEST_IN_CONDITION'
,p_branch_condition=>'SAVE,DELETE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1616395326502304)
,p_branch_name=>'Go To Page 1922 - ADD'
,p_branch_action=>'f?p=&APP_ID.:1922:&SESSION.::&DEBUG.:RP,1922:P1922_WEB_SRC_MODULE_ID:&P1921_WEB_SRC_MODULE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>80
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_CREATE_1922_ADD_OPERATION'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1616523207502306)
,p_branch_name=>'Go To Page 1922 - EDIT'
,p_branch_action=>'f?p=&APP_ID.:1922:&SESSION.::&DEBUG.:RP,:P1922_ID:&P1921_OPERATION_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>90
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_EDIT_1922_ID'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(23466605276366205)
,p_branch_name=>'Go To Page 1927'
,p_branch_action=>'f?p=&APP_ID.:1927:&SESSION.::&DEBUG.::P1927_WEB_SRC_OPERATION_ID:&P1921_OPERATION_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>100
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_CREATE_1927_TEST_OPERATION'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1219382380332158)
,p_name=>'P1921_ATTRIBUTE_01'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(347000660418384441)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_01'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 1, :P1921_ATTRIBUTE_01 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1219711993332170)
,p_name=>'P1921_ATTRIBUTE_02'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(347000660418384441)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_02'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 2, :P1921_ATTRIBUTE_02 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1220156930332170)
,p_name=>'P1921_ATTRIBUTE_03'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(347000660418384441)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_03'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 3, :P1921_ATTRIBUTE_03 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1220526393332170)
,p_name=>'P1921_ATTRIBUTE_04'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(347000660418384441)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_04'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 4, :P1921_ATTRIBUTE_04 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1220956210332170)
,p_name=>'P1921_ATTRIBUTE_05'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(347000660418384441)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_05'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 5, :P1921_ATTRIBUTE_05 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1221393338332171)
,p_name=>'P1921_ATTRIBUTE_06'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(347000660418384441)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_06'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 6, :P1921_ATTRIBUTE_06 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1221754136332171)
,p_name=>'P1921_ATTRIBUTE_07'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(347000660418384441)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_07'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 7, :P1921_ATTRIBUTE_07 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1222161949332171)
,p_name=>'P1921_ATTRIBUTE_08'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(347000660418384441)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_08'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 8, :P1921_ATTRIBUTE_08 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1222515743332171)
,p_name=>'P1921_ATTRIBUTE_09'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(347000660418384441)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_09'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 9, :P1921_ATTRIBUTE_09 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1222922686332171)
,p_name=>'P1921_ATTRIBUTE_10'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(347000660418384441)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_10'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 10, :P1921_ATTRIBUTE_10 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1223326620332172)
,p_name=>'P1921_ATTRIBUTE_11'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(347000660418384441)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_11'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 11, :P1921_ATTRIBUTE_11 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1223776894332172)
,p_name=>'P1921_ATTRIBUTE_12'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(347000660418384441)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_12'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 12, :P1921_ATTRIBUTE_12 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1224195139332173)
,p_name=>'P1921_ATTRIBUTE_13'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(347000660418384441)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_13'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 13, :P1921_ATTRIBUTE_13 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1224527544332174)
,p_name=>'P1921_ATTRIBUTE_14'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(347000660418384441)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_14'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 14, :P1921_ATTRIBUTE_14 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1224882896332174)
,p_name=>'P1921_ATTRIBUTE_15'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_imp.id(347000660418384441)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_15'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 15, :P1921_ATTRIBUTE_15 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1373359126674223)
,p_name=>'P1921_SYNC_STATUS'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(3292099913489445)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1373494095674224)
,p_name=>'P1921_SYNC_LOCAL_TABLE_NAME'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(3292099913489445)
,p_use_cache_before_default=>'NO'
,p_source=>'SYNC_TABLE_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1417212912012510)
,p_name=>'P1921_SUBSCRIBED_COMP_GRP'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(247725953433524625)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1503497845184422)
,p_name=>'P1921_CATALOG_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1503302531184421)
,p_prompt=>'Catalog Name'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name',
'  from wwv_web_src_catalogs',
' where internal_name     = :P1921_CATALOG_INTERNAL_NAME',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'P1921_CATALOG_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the REST Source Catalog from which this REST Data Source was created.'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1503502195184423)
,p_name=>'P1921_CATALOG_SERVICE_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(1503302531184421)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Catalog Service '
,p_source=>'CATALOG_SERVICE_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'P1921_CATALOG_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the service within the REST Source Catalog, from which this REST Data Source was created.'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1503631857184424)
,p_name=>'P1921_CATALOG_INTERNAL_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1503302531184421)
,p_use_cache_before_default=>'NO'
,p_source=>'CATALOG_INTERNAL_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1503864881184426)
,p_name=>'P1921_CATALOG_LAST_REFRESH'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(1503302531184421)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Last Refreshed'
,p_format_mask=>'SINCE'
,p_source=>'LAST_REFRESHED'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'P1921_CATALOG_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies when this REST Data Source was last refreshed from the catalog.'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1504178929184429)
,p_name=>'P1921_CATALOG_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1503302531184421)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1616401824502305)
,p_name=>'P1921_OPERATION_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3291693434489441)
,p_display_as=>'NATIVE_HIDDEN'
,p_warn_on_unsaved_changes=>'I'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1976325140539730)
,p_name=>'P1921_RETURN_TO_PAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(226688576185475247)
,p_prompt=>'Stay on page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select this checkbox to stay on this page after applying changes.'
,p_attribute_01=>'N'
,p_attribute_02=>'YES'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2108946408647633)
,p_name=>'P1921_REST_SQL_QUERY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2108820037647632)
,p_prompt=>'SQL Query'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cHeight=>10
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the SQL Query to execute on the REST Enabled SQL Reference.'
,p_attribute_01=>'SQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'P1921_REMOTE_SERVER_ID'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2501732229903914)
,p_name=>'P1921_OPENAPI_URL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(2503931255903936)
,p_use_cache_before_default=>'NO'
,p_prompt=>'OpenAPI URL'
,p_source=>'OPENAPI_URL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the URL where the OpenAPI information is available. This can be an absolute URL or an URL relative to the Base URL of the service.'
,p_inline_help_text=>'Enter the URL where the OpenAPI information is available.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'URL'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2501892230903915)
,p_name=>'P1921_USE_OPENAPI'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2503931255903936)
,p_item_default=>'N'
,p_prompt=>'Use OpenAPI'
,p_source=>'case when :P1921_OPENAPI_URL is null then ''N'' else ''Y'' end'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Choose whether the REST Data Source uses OpenAPI/Swagger for discovery.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2501947980903916)
,p_name=>'P1921_OPENAPI_URL_IS_RELATIVE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2503931255903936)
,p_item_default=>'N'
,p_prompt=>'Endpoint is relative to Base URL'
,p_source=>'case when not regexp_like( :P1921_OPENAPI_URL, ''^https?://'' ) then ''Y'' else ''N'' end'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Choose whether the OpenAPI Endpoint is relative to the Base URL of the Remote Server.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2502195437903918)
,p_name=>'P1921_OPENAPI_BASE_URL'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(2503931255903936)
,p_prompt=>'Base URL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3292189350489446)
,p_name=>'P1921_WEB_SRC_MODULE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3292099913489445)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3292408887489449)
,p_name=>'P1921_NAME'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(3292099913489445)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>75
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a name of the REST Data Source.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3292574859489450)
,p_name=>'P1921_WEB_SOURCE_TYPE'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(3292099913489445)
,p_use_cache_before_default=>'NO'
,p_prompt=>'REST Data Source Type'
,p_source=>'WEB_SOURCE_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEB_SOURCE_MODULE_TYPES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,',
'       r',
'  from (',
'         select wwv_flow_lang.system_message(''WEB_SOURCE.''|| name_with_prefix) as d,',
'               name_with_prefix as r',
'          from wwv_flow_native_plugins',
'         where plugin_type = ''WEB SOURCE TYPE''',
'         union all',
'        select display_name || wwv_flow_lang.system_message(''PLUGIN.DISPLAY_NAME_POSTFIX'') as d,',
'               ''PLUGIN_'' || name     as r',
'          from wwv_flow_plugins',
'         where flow_id           = to_number(:FB_FLOW_ID)',
'           and security_group_id = to_number(:WORKSPACE_ID)',
'           and plugin_type       = ''WEB SOURCE TYPE''',
'       )',
' order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Determines the REST Data Source type.',
'<ul>',
'<li><strong>Simple HTTP</strong> denotes simple HTTP data feeds. &PRODUCT_NAME. assumes that all data is returned with the first request and that the server does not support server-side filtering, ordering or other advanced REST service feature. All '
||'invocation details and parameters must be configured manually.</li>',
'<li><strong>Oracle REST Data Services</strong> (ORDS) denotes RESTful Services provided by ORDS. These REST services follow the <em>Oracle REST standard</em>, which means that GET, POST, PUT or DELETE operations are standardized. Server-side filterin'
||'g and ordering are supported. &PRODUCT_NAME. can leverage these features by delegating report order-bys and filters to the REST service.</li>',
'<li><strong>REST Enabled SQL Query</strong> denotes a REST Source on top of a SQL Query executed on a REST Enabled SQL Reference. &PRODUCT_NAME. supports filtering and pagination, but no DML on these endpoints.</li>',
'<li><strong>Oracle Cloud Applications (SaaS) REST Service</strong> denotes RESTful services provided by Oracle Cloud Applications (SaaS). Use this web service type to integrate Oracle SaaS REST Services into your &PRODUCT_NAME. application. &PRODUCT_'
||'NAME. supports pagination for these Services.</li>',
'<li><strong>Oracle Cloud Infrastructure (OCI) REST Service</strong> denotes RESTful web services provided by Oracle Cloud Infrastructure. Use this web service type to integrate OCI REST Services (for example, accessing the Object Store) into your &PR'
||'ODUCT_NAME. application. &PRODUCT_NAME. supports pagination for these Services.</li>',
'<li><strong>OData REST Service</strong> denotes a REST service which implements the Open Data (OData) protocol, which is an ISO/IEC approved, OASIS standard that defines a set of best practices for building and consuming RESTful APIs. <em>&PRODUCT_NA'
||'ME. currently only supports the <em>Fetch</em> APIs (read data); DML operations for OData are not yet supported.</em></li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3466961035842404)
,p_name=>'P1921_DATA_PROFILE_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(3292099913489445)
,p_use_cache_before_default=>'NO'
,p_source=>'DATA_PROFILE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3467008942842405)
,p_name=>'P1921_URL_PATH_PREFIX'
,p_is_required=>true
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(3292099913489445)
,p_use_cache_before_default=>'NO'
,p_prompt=>'URL Path Prefix'
,p_source=>'URL_PATH_PREFIX'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>65
,p_cMaxlength=>500
,p_read_only_when=>'P1921_WEB_SOURCE_TYPE'
,p_read_only_when2=>'NATIVE_REST_ENABLED_SQL_QUERY'
,p_read_only_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    The URL Path Prefix is specific to this REST Data Source. The URL Endpoints of all operations within the REST Data Source share the same URL Path Prefix. When the REST Data Source is invoked, &PRODUCT_NAME. builds the URL as follows:',
'</p>',
'<ol>',
'    <li><strong>Base URL</strong> of the <strong>Remote Server</strong> object</li> ',
'    <li><strong>URL Path Prefix</strong> of the <strong>REST Data Source</strong></li>',
'    <li><strong>URL Pattern</strong> defined in the REST Data Sources <strong>Operation</strong></li>',
'</ol>',
'<div>',
'    <p>Example:</p>',
'    <p>',
'        REST Data Sources:',
'        <ol>',
'            <li><code>http://api.example.com:8080/root/<strong>service1/</strong>method1</code></li>',
'            <li><code>http://api.example.com:8080/root/<strong>service2/</strong>method1</code></li>',
'            <li><code>http://api.example.com:8080/root/<strong>service2/</strong>method4</code></li>',
'        </ol> ',
'    </p>',
'    <p>',
'        The <strong>service1/</strong> or <strong>service2/</strong> URL parts are common to one REST Data Source, so these will be used as the <strong>URL Path Prefix</strong>.',
'    </p>',
'</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3467120952842406)
,p_name=>'P1921_REMOTE_SERVER_ID'
,p_is_required=>true
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(3292099913489445)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Remote Server'
,p_post_element_text=>'<a id="P1921_EDIT_REMOTE_SERVER_BUTTON" class="a-Button a-Button--noLabel a-Button--small a-Button--withIcon" href="#" onClick="apex.page.submit(''APPLY_CHANGES_EDIT_REMOTE_SERVER'');" tabindex="0" ><span class="a-Icon icon-edit" aria-hidden="true"></s'
||'pan><span class="u-VisuallyHidden">Edit Remote Server</span></a>'
,p_source=>'REMOTE_SERVER_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_remote_servers',
' where server_type = case when :P1921_WEB_SOURCE_TYPE = ''NATIVE_REST_ENABLED_SQL_QUERY'' then ''REMOTE_SQL'' else ''WEB_SERVICE'' end',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Choose a <strong>Remote Server</strong> object for this REST Data Source. &PRODUCT_NAME. splits the URL endpoint into the first (Remote Server) and the second (service-specific) part. One <strong>Remote Server</strong> object can contain multiple'
||' ',
'    Service endpoints. It''s recommended to assign the same remote server object to REST Data Sources, when they share the',
'    same server, port and URL path prefixes.',
'</p>',
'<div>',
'    <p>Example:</p>',
'    <p>',
'        REST Data Sources:',
'        <ol>',
'            <li><code><strong>http://api.example.com:8080/root/</strong>service1/method1</code></li>',
'            <li><code><strong>http://api.example.com:8080/root/</strong>service2/method1</code></li>',
'            <li><code><strong>http://api.example.com:8080/root/</strong>service2/method4</code></li>',
'        </ol> ',
'    </p>',
'    <p>',
'        The <strong>http://api.example.com:8080/root/</strong> URL part is common to all three REST Data Sources,',
'        so that can be used as the Remote Server object and given a name. If, at a later point in time, those three REST Data Sources should be moved to another server, one only has to change the Remote Server object.',
'    </p>',
'</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3467321476842408)
,p_name=>'P1921_MODULE_COMMENT'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(3467424016842409)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comments'
,p_source=>'MODULE_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Enter any developer comments or notes here. These comments only display within App Builder and never display when running the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3467662661842411)
,p_name=>'P1921_CREDENTIAL_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3467516310842410)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Credentials'
,p_post_element_text=>'<a href="#" id="P1921_EDIT_CREDENTIAL_BUTTON" class="a-Button a-Button--noLabel a-Button--small a-Button--withIcon" onClick="apex.page.submit(''APPLY_CHANGES_EDIT_CREDENTIAL'');" tabindex="0"><span class="a-Icon icon-edit"></span><span class="u-Visuall'
||'yHidden">Edit Credential</span></a>'
,p_source=>'CREDENTIAL_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LOV_CREDENTIAL_STORES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_credentials',
' where security_group_id    = :FLOW_SECURITY_GROUP_ID',
'   and authentication_type != ''KEY_PAIR'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose stored Credentials for Authentication.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3467713606842412)
,p_name=>'P1921_AUTH_REMOTE_SERVER_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3467516310842410)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Authentication Server'
,p_post_element_text=>'<a href="#" id="P1921_EDIT_AUTH_REMOTE_SERVER_BUTTON" class="a-Button a-Button--noLabel a-Button--small a-Button--withIcon" onClick="apex.page.submit(''APPLY_CHANGES_EDIT_AUTH_REMOTE_SERVER'');" tabindex="0"><span class="a-Icon icon-edit"></span><span '
||'class="u-VisuallyHidden">Edit Remote Server</span></a>'
,p_source=>'AUTH_REMOTE_SERVER_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEB_SOURCE_AUTHENT_SERVERS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_remote_servers',
' where server_type = ''AUTHENTICATION''',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    If authentication has to be done on a (different) <em>Authentication Server</em>, create a <strong>Remote Server</strong> object for this and choose it here. &PRODUCT_NAME. splits the URL endpoint into the first (Remote Server) and the second (se'
||'rvice-specific) part. One <strong>Remote Server</strong> object can contain multiple ',
'    Service endpoints. It''s recommended to assign the same remote server object to REST Data Sources, when they share the',
'    same server, port and URL path prefixes.',
'</p>',
'<div>',
'    <p>',
'    Example:        ',
'    </p>',
'    <ol>',
'        <li><code><strong>http://api.example.com:8080/root/</strong>auth/token</code></li>',
'        <li><code><strong>http://api.example.com:8080/root/</strong>auth-prod/token</code></li>',
'    </ol> ',
'    <p>',
'        The <strong>http://api.example.com:8080/root/</strong> URL part is common to both of the authentication endpoints,',
'        so that can be used as the named Remote Server object.',
'    </p>',
'</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3467822098842413)
,p_name=>'P1921_AUTH_URL_PATH_PREFIX'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(3467516310842410)
,p_use_cache_before_default=>'NO'
,p_prompt=>'URL Path'
,p_source=>'AUTH_URL_PATH_PREFIX'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>65
,p_cMaxlength=>500
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    If authentication has to be done on a (different) <em>Authentication Server</em>, create a <strong>Remote Server</strong> object for this and choose it here. &PRODUCT_NAME. splits the URL endpoint into the first (Remote Server) and the second (se'
||'rvice-specific) part. One <strong>Remote Server</strong> object can contain multiple ',
'    Service endpoints. It''s recommended to assign the same remote server object to REST Data Sources, when they share the',
'    same server, port and URL path prefixes.',
'</p>',
'<div>',
'    <p>',
'    Example:        ',
'    </p>',
'    <ol>',
'        <li><code>http://api.example.com:8080/root/<strong>auth/token</strong></code></li>',
'        <li><code>http://api.example.com:8080/root/<strong>auth-prod/token</strong></code></li>',
'    </ol> ',
'    <p>',
'        The <strong>auth/token</strong> and <strong>auth-prod/token</strong> URL parts are specific to the individual authentication service and should the used as the <strong>URL Path Prefix</strong>.',
'    </p>',
'</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3468182432842416)
,p_name=>'P1921_AUTH_REMOTE_SERVER_BASEURL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3467516310842410)
,p_prompt=>'Base URL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3468650820842421)
,p_name=>'P1921_REMOTE_SERVER_BASEURL'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(3292099913489445)
,p_prompt=>'Base URL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5901995307682519)
,p_name=>'P1921_NEXT_SYNC_TIMESTAMP'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(1373683531674226)
,p_prompt=>'Next Synchronization'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_begin_on_new_line=>'N'
,p_display_when=>'P1921_NEXT_SYNC_TIMESTAMP'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Indicates when the next scheduled synchronization is due. Note that synchronizations are kicked off every 10 minutes, starting at the top of the hour. So a synchronization can start at minute 0, 10, 20, 30, 40 or 50, but not in between.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5902173551682521)
,p_name=>'P1921_LOCAL_TABLE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1373683531674226)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Local Table Name'
,p_source=>'SYNC_TABLE_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Data is currently synchronized to this table.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5902312154682523)
,p_name=>'P1921_LAST_SYNC_TIMESTAMP'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1373683531674226)
,p_prompt=>'Last Synchronization'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'P1921_LAST_SYNC_TIMESTAMP'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Indicates when the last synchronization to the local table happened.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11093086337588019)
,p_name=>'P1921_VERSION_SCN'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(247725953433524625)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select version_scn ',
'  from wwv_flow_web_src_modules',
' where id                = :P1921_WEB_SRC_MODULE_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11093195722588020)
,p_name=>'P1921_MASTER_VERSION_SCN'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(247725953433524625)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select version_scn ',
'  from wwv_flow_web_src_modules',
' where id                = :P1921_REFERENCE_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11093240307588021)
,p_name=>'P1921_REFERENCE_ID_INIT'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(3292099913489445)
,p_item_default=>'P1921_REFERENCE_ID'
,p_item_default_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(49976474948957518)
,p_name=>'P1921_LOCAL_TABLE_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1373683531674226)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Local Table Owner'
,p_source=>'SYNC_TABLE_OWNER'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS2'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c.schema) d, c.schema r',
'',
'from   wwv_flow_company_schemas c,',
'',
'       wwv_flow_fnd_user u',
'',
'where  c.security_group_id = :flow_security_group_id and',
'',
'       u.security_group_id = :flow_security_group_id and',
'',
'       u.user_name = :flow_user and',
'',
'       (u.ALLOW_ACCESS_TO_SCHEMAS is null or    instr('':''||u.ALLOW_ACCESS_TO_SCHEMAS||'':'','':''||c.schema||'':'')>0)',
'',
'order by 1'))
,p_display_when=>'P1921_LOCAL_TABLE_OWNER'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Data is currently synchronized to a table in this schema.'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(238756151563331834)
,p_name=>'P1921_TIMEOUT'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(3467424016842409)
,p_use_cache_before_default=>'NO'
,p_prompt=>'HTTP Transfer Timeout (seconds)'
,p_source=>'TIMEOUT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Specify the transfer timeout for all future HTTP requests that are attempted while reading the HTTP response from the Web server or proxy server.</p><p>This timeout value can be used to avoid the application from being blocked by busy Web servers '
||'or heavy network traffic while retrieving responses. See the documentation for <strong>UTL_HTTP.SET_TRANSFER_TIMEOUT</strong>.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'0'
,p_attribute_03=>'right'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(247726058933524626)
,p_name=>'P1921_REFERENCE_ID'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(3292099913489445)
,p_use_cache_before_default=>'NO'
,p_source=>'REFERENCE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(619336473312855719)
,p_name=>'P1921_PASS_ECID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3467424016842409)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Pass ECID'
,p_source=>'PASS_ECID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(84259319526460470)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Use Application Setting'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Indicates whether to pass the Execution Context ID (with a request header named <em>ECID-Context</em>) to the external web services for end-to-end tracing. Also see the application setting under <em>Shared Components, Security Attributes, Advanced, P'
||'ass ECID</em>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(619336542244855720)
,p_name=>'P1921_STATIC_ID'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3467424016842409)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Static ID'
,p_source=>'STATIC_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Use the Static ID to reference the REST Data Source in API Calls.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3403061807595708635)
,p_name=>'P1921_BREADCRUMB_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3292099913489445)
,p_source=>'P1921_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3632687031037912650)
,p_name=>'P1921_FLOW_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3292099913489445)
,p_use_cache_before_default=>'NO'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1417378045012511)
,p_computation_sequence=>10
,p_computation_item=>'P1921_SUBSCRIBED_COMP_GRP'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_component_group_dev.is_part_of_subscribed_comp_grp (',
'    p_component_id   => :P1921_WEB_SRC_MODULE_ID,',
'    p_component_type => wwv_flow_copy_metadata.c_web_src_module,',
'    p_app_id         => :FB_FLOW_ID )'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3403062190966708638)
,p_computation_sequence=>10
,p_computation_item=>'P1921_BREADCRUMB_NAME'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P1921_NAME'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2109103042647635)
,p_computation_sequence=>20
,p_computation_item=>'P1921_REST_SQL_QUERY'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P1921_ATTRIBUTE_01'
,p_compute_when=>'P1921_WEB_SOURCE_TYPE'
,p_compute_when_text=>'NATIVE_REST_ENABLED_SQL_QUERY'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1373252285674222)
,p_computation_sequence=>30
,p_computation_item=>'P1921_SYNC_STATUS'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_web_src_sync.get_table_ddl_sync_status(:P1921_WEB_SRC_MODULE_ID)'
,p_compute_when=>'P1921_SYNC_LOCAL_TABLE_NAME'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(225853558146926501)
,p_computation_sequence=>10
,p_computation_item=>'P1921_FLOW_ID'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'FB_FLOW_ID'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2109097551647634)
,p_computation_sequence=>20
,p_computation_item=>'P1921_ATTRIBUTE_01'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P1921_REST_SQL_QUERY'
,p_compute_when=>'P1921_WEB_SOURCE_TYPE'
,p_compute_when_text=>'NATIVE_REST_ENABLED_SQL_QUERY'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(4000219387275820)
,p_computation_sequence=>20
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'&APP_PAGE_ID.'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(310377087034241841)
,p_validation_name=>'REST Data Source still referenced'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_web_src_module_usage',
' where web_src_module_id = :P1921_WEB_SRC_MODULE_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and rownum            = 1',
'union all (',
'select 1 ',
'  from wwv_flow_step_processing',
' where web_src_module_id = :P1921_WEB_SRC_MODULE_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and rownum            = 1',
')'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'This REST Data Source is being referenced by application components, so you cannot delete it.'
,p_when_button_pressed=>wwv_flow_imp.id(225951037719615714)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(6182751216565130)
,p_validation_name=>'Validate Plugin Attributes'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.validate_attribute_items (',
'        p_application_id    => :FB_FLOW_ID,',
'        p_plugin_type       => wwv_flow_plugin.c_plugin_type_web_source,',
'        p_plugin_name       => :P1921_WEB_SOURCE_TYPE,',
'        p_attribute_scope   => wwv_flow_plugin.c_attribute_scope_component,',
'        p_page_item_prefix  => ''P1921_'' );',
'end;'))
,p_validation_type=>'PLSQL_ERROR'
,p_error_message=>'Error'
,p_validation_condition=>':REQUEST != ''DELETE'' and :P1921_WEB_SOURCE_TYPE != ''NATIVE_REST_ENABLED_SQL_QUERY'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2502000041903917)
,p_validation_name=>'OpenAPI URL required'
,p_validation_sequence=>30
,p_validation=>'P1921_OPENAPI_URL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'OpenAPI URL must have a value'
,p_validation_condition=>':P1921_USE_OPENAPI = ''Y'' and :P1921_OPENAPI_URL is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(2501732229903914)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3958187821517303)
,p_validation_name=>'Not part of component groups'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not wwv_flow_component_group_dev.is_part_of_comp_grp (',
'    p_component_id   => :P1921_WEB_SRC_MODULE_ID,',
'    p_component_type => wwv_flow_copy_metadata.c_web_src_module,',
'    p_app_id         => :FB_FLOW_ID )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'REST Data Source cannot be deleted because it is part of a component group.'
,p_when_button_pressed=>wwv_flow_imp.id(225951037719615714)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3468240510842417)
,p_name=>'Auth Remote Server changed'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1921_AUTH_REMOTE_SERVER_ID'
,p_condition_element=>'P1921_AUTH_REMOTE_SERVER_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3468333311842418)
,p_event_id=>wwv_flow_imp.id(3468240510842417)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1921_AUTH_REMOTE_SERVER_BASEURL,P1921_AUTH_URL_PATH_PREFIX'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1251855445061756047)
,p_event_id=>wwv_flow_imp.id(3468240510842417)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'#P1921_EDIT_AUTH_REMOTE_SERVER_BUTTON'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3468501882842420)
,p_event_id=>wwv_flow_imp.id(3468240510842417)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1921_AUTH_REMOTE_SERVER_BASEURL,P1921_AUTH_URL_PATH_PREFIX'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1251855336233756046)
,p_event_id=>wwv_flow_imp.id(3468240510842417)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'#P1921_EDIT_AUTH_REMOTE_SERVER_BUTTON'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3468453503842419)
,p_event_id=>wwv_flow_imp.id(3468240510842417)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1921_AUTH_REMOTE_SERVER_BASEURL'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select base_url',
'  from wwv_remote_servers',
' where id = :P1921_AUTH_REMOTE_SERVER_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_attribute_07=>'P1921_AUTH_REMOTE_SERVER_ID'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3468707643842422)
,p_name=>'Remote Server Changed'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1921_REMOTE_SERVER_ID'
,p_condition_element=>'P1921_REMOTE_SERVER_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3468862131842423)
,p_event_id=>wwv_flow_imp.id(3468707643842422)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1921_REMOTE_SERVER_BASEURL,P1921_OPENAPI_BASE_URL'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select base_url',
'  from wwv_remote_servers',
' where id = :P1921_REMOTE_SERVER_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_attribute_07=>'P1921_REMOTE_SERVER_ID'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3469122215842426)
,p_event_id=>wwv_flow_imp.id(3468707643842422)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1921_REMOTE_SERVER_BASEURL,P1921_URL_PATH_PREFIX'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3468984328842424)
,p_event_id=>wwv_flow_imp.id(3468707643842422)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1921_REMOTE_SERVER_BASEURL,P1921_URL_PATH_PREFIX'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(691709405214978021)
,p_name=>'Edit Data Profile'
,p_event_sequence=>35
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(310374200946241813)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(691709505751978022)
,p_event_id=>wwv_flow_imp.id(691709405214978021)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(310374200946241813)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(225854073471926506)
,p_name=>'Edit Operation'
,p_event_sequence=>40
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(3291693434489441)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(225854175481926507)
,p_event_id=>wwv_flow_imp.id(225854073471926506)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3291693434489441)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(226078596643270142)
,p_name=>'Edit Parameter'
,p_event_sequence=>50
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(226074768846270104)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(226078666151270143)
,p_event_id=>wwv_flow_imp.id(226078596643270142)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(226074768846270104)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(241339064992308301)
,p_name=>'Credential chosen'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1921_CREDENTIAL_ID'
,p_condition_element=>'P1921_CREDENTIAL_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(241339146987308302)
,p_event_id=>wwv_flow_imp.id(241339064992308301)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1921_AUTH_REMOTE_SERVER_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4388690452043556148)
,p_event_id=>wwv_flow_imp.id(241339064992308301)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1921_AUTH_REMOTE_SERVER_ID'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(310376411987241835)
,p_event_id=>wwv_flow_imp.id(241339064992308301)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'#P1921_EDIT_CREDENTIAL_BUTTON'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(310376580727241836)
,p_event_id=>wwv_flow_imp.id(241339064992308301)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'#P1921_EDIT_CREDENTIAL_BUTTON'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(241339212609308303)
,p_event_id=>wwv_flow_imp.id(241339064992308301)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1921_AUTH_REMOTE_SERVER_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2109219301647636)
,p_name=>'REST Enabled SQL Query'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1921_WEB_SOURCE_TYPE'
,p_condition_element=>'P1921_WEB_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NATIVE_REST_ENABLED_SQL_QUERY'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2109366932647637)
,p_event_id=>wwv_flow_imp.id(2109219301647636)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2108820037647632)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2109652443647640)
,p_event_id=>wwv_flow_imp.id(2109219301647636)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(347000660418384441)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2109448550647638)
,p_event_id=>wwv_flow_imp.id(2109219301647636)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2108820037647632)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2109572807647639)
,p_event_id=>wwv_flow_imp.id(2109219301647636)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(347000660418384441)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2502293458903919)
,p_name=>'OpenAPI is relative changed'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1921_OPENAPI_URL_IS_RELATIVE'
,p_condition_element=>'P1921_OPENAPI_URL_IS_RELATIVE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2502342744903920)
,p_event_id=>wwv_flow_imp.id(2502293458903919)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1921_OPENAPI_BASE_URL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2504382512903940)
,p_event_id=>wwv_flow_imp.id(2502293458903919)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Set P1921_OPENAPI_URL'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1921_OPENAPI_URL'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>'case when not regexp_like( :P1921_OPENAPI_URL, ''^https?://'' ) then :P1921_OPENAPI_BASE_URL end || :P1921_OPENAPI_URL'
,p_attribute_07=>'P1921_OPENAPI_URL,P1921_OPENAPI_BASE_URL'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2503070621903927)
,p_event_id=>wwv_flow_imp.id(2502293458903919)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Set P1921_OPENAPI_BASE_URL'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1921_OPENAPI_BASE_URL'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select base_url',
'  from wwv_remote_servers',
' where id = :P1921_REMOTE_SERVER_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_attribute_07=>'P1921_REMOTE_SERVER_ID'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2504297315903939)
,p_event_id=>wwv_flow_imp.id(2502293458903919)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'UnSet P1921_OPENAPI_BASE_URL'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1921_OPENAPI_BASE_URL'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>'null;'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2502469041903921)
,p_event_id=>wwv_flow_imp.id(2502293458903919)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1921_OPENAPI_BASE_URL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2504117920903938)
,p_event_id=>wwv_flow_imp.id(2502293458903919)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Set P1921_OPENAPI_URL'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1921_OPENAPI_URL'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>'case when :P1921_OPENAPI_BASE_URL is not null and :P1921_OPENAPI_URL like :P1921_OPENAPI_BASE_URL || ''%'' then substr( :P1921_OPENAPI_URL, length( :P1921_OPENAPI_BASE_URL ) + 1 ) else :P1921_OPENAPI_URL end'
,p_attribute_07=>'P1921_OPENAPI_URL,P1921_OPENAPI_BASE_URL'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2502554067903922)
,p_name=>'Use OpenAPI changed'
,p_event_sequence=>120
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1921_USE_OPENAPI'
,p_condition_element=>'P1921_USE_OPENAPI'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2502615417903923)
,p_event_id=>wwv_flow_imp.id(2502554067903922)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1921_OPENAPI_URL_IS_RELATIVE,P1921_OPENAPI_URL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2502751647903924)
,p_event_id=>wwv_flow_imp.id(2502554067903922)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1921_OPENAPI_URL_IS_RELATIVE,P1921_OPENAPI_BASE_URL,P1921_OPENAPI_URL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2502899659903925)
,p_event_id=>wwv_flow_imp.id(2502554067903922)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_name=>'Set P1921_OPENAPI_URL'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1921_OPENAPI_URL'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2502971991903926)
,p_event_id=>wwv_flow_imp.id(2502554067903922)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_name=>'Set P1921_OPENAPI_URL_IS_RELATIVE'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1921_OPENAPI_URL_IS_RELATIVE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2504065698903937)
,p_name=>'Make OpenAPI URL relative'
,p_event_sequence=>130
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1921_OPENAPI_BASE_URL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(99963701727536509)
,p_name=>'Simple HTTP'
,p_event_sequence=>140
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1921_WEB_SOURCE_TYPE'
,p_condition_element=>'P1921_WEB_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NATIVE_HTTP'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(99963845776536510)
,p_event_id=>wwv_flow_imp.id(99963701727536509)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show Open API'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2503931255903936)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(99963973873536511)
,p_event_id=>wwv_flow_imp.id(99963701727536509)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Open API'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2503931255903936)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(99964098264536512)
,p_event_id=>wwv_flow_imp.id(99963701727536509)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Clear Open API URL'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1921_OPENAPI_URL'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3469537577842430)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process row of WWV_FLOW_WEB_SRC_MODULES'
,p_attribute_02=>'WWV_FLOW_WEB_SRC_MODULES'
,p_attribute_03=>'P1921_WEB_SRC_MODULE_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id = :FLOW_SECURITY_GROUP_ID'
,p_attribute_11=>'U'
,p_attribute_12=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'SAVE,APPLY_CHANGES_CREATE_1922_ADD_OPERATION,APPLY_CHANGES_EDIT_1922_ID,APPLY_CHANGES_CREATE_1927_TEST_OPERATION,APPLY_CHANGES_EDIT_CREDENTIAL,APPLY_CHANGES_EDIT_REMOTE_SERVER,APPLY_CHANGES_EDIT_AUTH_REMOTE_SERVER,APPLY_CHANGES_EDIT_DATA_PROFILE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_internal_uid=>3469537577842430
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3403061790443708634)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete REST Data Source'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_web_src_dev.remove_web_src_module(',
'        p_web_src_module_id    => :P1921_WEB_SRC_MODULE_ID,',
'        p_application_id       => :FB_FLOW_ID,',
'        p_remove_remote_server => true,',
'        p_remove_data_profile  => true );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(225951037719615714)
,p_process_success_message=>'REST Data Source deleted.'
,p_internal_uid=>3403061790443708634
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(247726242664524628)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh REST Data Source'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_web_src_dev.subscribe_web_src_module (',
'    p_web_src_module_id        => :P1921_WEB_SRC_MODULE_ID,',
'    p_master_web_src_module_id => :P1921_REFERENCE_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(247726194903524627)
,p_internal_uid=>247726242664524628
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(538532867300939914)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Unsubscribe REST Data Source'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.unsubscribe_component (',
'    p_component_type  => wwv_flow_copy_metadata.c_web_src_module,',
'    p_component_id    => :P1921_WEB_SRC_MODULE_ID,',
'    p_app_id          => :FB_FLOW_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(538532741160939913)
,p_process_when=>'P1921_WEB_SRC_MODULE_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_process_success_message=>'REST Data Source unsubscribed.'
,p_internal_uid=>538532867300939914
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3466697539842401)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row of WWV_FLOW_WEB_SRC_MODULES'
,p_attribute_02=>'WWV_FLOW_WEB_SRC_MODULES'
,p_attribute_03=>'P1921_WEB_SRC_MODULE_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id = :FLOW_SECURITY_GROUP_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>3466697539842401
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5902281160682522)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch last and next sync timestamps'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with sync_timestamps as (',
'    select sync_last_run_timestamp,',
'           case when sync_next_run_timestamp is not null then',
'               wwv_flow_web_src_sync_dev.get_actual_execution_timestamp( sync_next_run_timestamp ) at time zone ''00:00''',
'           end as sync_next_run_timestamp',
'      from wwv_flow_web_src_modules',
'     where id                = :P1921_WEB_SRC_MODULE_ID',
'       and security_group_id = :FLOW_SECURITY_GROUP_ID )',
'select case ',
'           when sync_next_run_timestamp is not null then',
'               to_char(sync_next_run_timestamp, ''Mon fmdd, '' ) ||',
'               to_char(sync_next_run_timestamp, ''HH24:MI '' ) ||',
'               decode(to_char(sync_next_run_timestamp, ''TZR'' ), ''+00:00'', ''UTC'', to_char(sync_next_run_timestamp, ''TZR'' ) ) ||',
'               '' ('' || htmldb_util.get_since( sync_next_run_timestamp ) || '')''',
'       end,',
'       case',
'           when sync_last_run_timestamp is not null then',
'                      htmldb_util.get_since( sync_last_run_timestamp )',
'       end',
'  into :P1921_NEXT_SYNC_TIMESTAMP,',
'       :P1921_LAST_SYNC_TIMESTAMP',
'  from sync_timestamps;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>5902281160682522
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2600618999934106)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Catalog ID'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if :P1921_CATALOG_INTERNAL_NAME is null then',
'        :P1921_CATALOG_ID := null;',
'    else',
'        begin',
'            select id',
'              into :P1921_CATALOG_ID',
'              from wwv_web_src_catalogs',
'             where internal_name     = :P1921_CATALOG_INTERNAL_NAME',
'               and security_group_id = :FLOW_SECURITY_GROUP_ID',
'               and rownum            = 1;',
'        exception',
'            when no_data_found then',
'                 :P1921_CATALOG_ID := null;',
'        end;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2600618999934106
);
end;
/
prompt --application/pages/page_01922
begin
wwv_flow_imp_page.create_page(
 p_id=>1922
,p_name=>'REST Source Operation'
,p_alias=>'REST-SOURCE-OPERATION'
,p_step_title=>'Edit REST Source Operation'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_read_only_when=>'P1921_REFERENCE_ID'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3469784605842432)
,p_plug_name=>'Advanced'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3500552115076908)
,p_plug_name=>'Operation'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3501284674076916)
,p_plug_name=>'REST Source Operation'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(242268510007871834)
,p_plug_name=>'Operations'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
' A REST Source <strong>Operation</strong> contains the actual information about the external web service handler. For REST services, an operation is made from the combination of a URL pattern and an HTTP verb (GET, POST). A REST Data Source can conta'
||'in multiple operations.',
' </p>',
' <p>Operations can be mapped to <strong>Database Operations</strong> which enables &PRODUCT_NAME. components to pick up the correct operation. Reports, interactive reports or CSS calendars will pick up the operation which is mapped to the <em>Fetch R'
||'ows</em> database operation.</p>',
'<p>',
'Settings defined at the module-level are shared among all operations within the REST Data Source. Settings at the operation-level only apply to this operation.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(249280093175575814)
,p_plug_name=>'ORDS Legacy JSON REST Source: Unknown Fixed Page Size'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>20
,p_plug_source=>'<p>This ORDS REST source uses the <em>Legacy JSON syntax</em>; data is being returned page-wise with a fixed page size determined by the server. In order to render &PRODUCT_NAME. components correctly, the <em>Page Size</em> must be known to &PRODUCT_'
||'NAME.. Please navigate to the <strong>Advanced</strong> section and set the page size accordingly. Contact the administrator of the REST service to get that information.'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from ',
'wwv_flow_web_src_modules',
'where security_group_id = :FLOW_SECURITY_GROUP_ID and id = :P1922_WEB_SRC_MODULE_ID and web_source_type=''NATIVE_ORDS'' and attribute_01 = ''Y'' and :P1922_ORDS_FIXED_PAGE_SIZE is null and :P1922_ID is not null'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(249280151163575815)
,p_plug_name=>'ORDS Legacy JSON REST Source: Small Fixed Page Size'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>30
,p_plug_source=>'<p>This ORDS REST Data Source uses the <em>Legacy JSON syntax</em>; data is being returned page-wise with a fixed page size of &P1922_ORDS_FIXED_PAGE_SIZE., determined by the server. For reports with larger page sizes, multiple HTTP requests to the R'
||'EST service will be needed in order to render a page. Consider contacting the REST service administrator in order to provide a larger page size.'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from ',
'wwv_flow_web_src_modules',
'where security_group_id = :FLOW_SECURITY_GROUP_ID and id = :P1922_WEB_SRC_MODULE_ID and web_source_type=''NATIVE_ORDS''',
'  and attribute_01 = ''Y''',
'  and :P1922_ORDS_FIXED_PAGE_SIZE < 50'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(310375138083241822)
,p_plug_name=>'RDS'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(922351464945024904)
,p_name=>'Operation Parameters'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch:a-Report--rowHighlight'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       direction,',
'       name,',
'       param_type,',
'       value,',
'       is_required,',
'       is_static,',
'       last_updated_on',
'  from wwv_flow_web_src_params',
' where web_src_module_id    = :P1922_WEB_SRC_MODULE_ID',
'   and web_src_operation_id = :P1922_ID',
'   and flow_id              = :FB_FLOW_ID',
'   and security_group_id    = :FLOW_SECURITY_GROUP_ID'))
,p_display_when_condition=>'P1922_ID'
,p_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P1922_WEB_SRC_MODULE_ID,P1922_ID'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>'No Parameters defined.'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(348143672277890310)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:1923:&SESSION.::&DEBUG.:RP:P1923_ID:#ID#'
,p_column_linktext=>'<span class="a-Icon icon-edit" aria-hidden="true"></span><span class="u-VisuallyHidden">Edit Parameter</span>'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(348144051871890311)
,p_query_column_id=>2
,p_column_alias=>'DIRECTION'
,p_column_display_sequence=>4
,p_column_heading=>'Direction'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(226101569473456167)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(348144427352890311)
,p_query_column_id=>3
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Name'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(348144819984890311)
,p_query_column_id=>4
,p_column_alias=>'PARAM_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(226045111811519566)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(348145273337890312)
,p_query_column_id=>5
,p_column_alias=>'VALUE'
,p_column_display_sequence=>5
,p_column_heading=>'Default Value'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(348145636845890312)
,p_query_column_id=>6
,p_column_alias=>'IS_REQUIRED'
,p_column_display_sequence=>6
,p_column_heading=>'Required'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(84259319526460470)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2007483928904829)
,p_query_column_id=>7
,p_column_alias=>'IS_STATIC'
,p_column_display_sequence=>16
,p_column_heading=>'Static'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(84259319526460470)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2007528710904830)
,p_query_column_id=>8
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>26
,p_column_heading=>'Last Updated'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_column_alignment=>'CENTER'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3632686677195912646)
,p_plug_name=>'Caching'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_companies ',
' where provisioning_company_id = :FLOW_SECURITY_GROUP_ID ',
'   and coalesce( content_cache_size_target, to_number(wwv_flow_instance_admin.get_parameter(''CONTENT_CACHE_SIZE_TARGET'') ) ) > 0'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(91187183548358248)
,p_name=>'Cache Contents'
,p_parent_plug_id=>wwv_flow_imp.id(3632686677195912646)
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--slimPadding:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#:a-BadgeList--fixed:a-BadgeList--large'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count( case when user_name  is not null and valid_until > sysdate then 1 end ) as cached_by_user,',
'       count( case when session_id is not null and valid_until > sysdate then 1 end ) as cached_by_session,',
'       count( case when user_name  is null and session_id is null and valid_until > sysdate then 1 end ) as cached_all_users,',
'       count( case when valid_until <= sysdate then 1 end) as stale_entries',
'from wwv_flow_content_cache1$',
'where component_id = :P1922_ID',
'  and component_type = 1 -- wwv_flow_content_cache.c_comp_web_source',
'   '))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_content_cache1$',
'where component_type = 1 -- wwv_flow_content_cache.c_comp_web_source',
'  and component_id = :P1922_ID'))
,p_display_condition_type=>'EXISTS'
,p_footer=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Stale Entries are not used by &PRODUCT_NAME. any more. These entries will be purged with the next run of the nightly APEX maintenance job.',
'</p>'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(1041640454953406573)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(91187294651358249)
,p_query_column_id=>1
,p_column_alias=>'CACHED_BY_USER'
,p_column_display_sequence=>1
,p_column_heading=>'Entries Cached By User'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(91187390594358250)
,p_query_column_id=>2
,p_column_alias=>'CACHED_BY_SESSION'
,p_column_display_sequence=>2
,p_column_heading=>'Entries Cached By Session'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(218526975872706501)
,p_query_column_id=>3
,p_column_alias=>'CACHED_ALL_USERS'
,p_column_display_sequence=>3
,p_column_heading=>'Entries Cached For All Users'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(218527126424706503)
,p_query_column_id=>4
,p_column_alias=>'STALE_ENTRIES'
,p_column_display_sequence=>4
,p_column_heading=>'Stale Entries'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(218527070654706502)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(3632686677195912646)
,p_button_name=>'PURGE_CACHE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Purge Cache'
,p_button_position=>'CREATE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_content_cache1$',
'where component_type = 1 -- wwv_flow_content_cache.c_comp_web_source',
'  and component_id = :P1922_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2006785939904822)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(922351464945024904)
,p_button_name=>'APPLY_CHANGES_SYNC_PARAMS'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Synchronize with Body'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'not wwv_flow_page.is_read_only and :P1922_ID is not null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3501688362076916)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(3501284674076916)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1921:&SESSION.::&DEBUG.:RP,1922::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3501137717076916)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(3501284674076916)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_confirm_message=>'Would you like to delete this REST Source Operation?'
,p_confirm_style=>'danger'
,p_button_condition=>'not wwv_flow_page.is_read_only and :P1922_ID is not null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(348146097833890312)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(922351464945024904)
,p_button_name=>'ADD_PARAMETER'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Add Parameter'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1923:&SESSION.::&DEBUG.:RP,1923:P1923_WEB_SRC_MODULE_ID,P1923_WEB_SRC_OPERATION_ID:&P1922_WEB_SRC_MODULE_ID.,&P1922_ID.'
,p_button_condition=>'P1921_REFERENCE_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3501080431076915)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(3501284674076916)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'not wwv_flow_page.is_read_only and :P1922_ID is not null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3500934236076915)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(3501284674076916)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>'not wwv_flow_page.is_read_only and :P1922_ID is null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(218527317192706505)
,p_branch_name=>'Go To Page 1922'
,p_branch_action=>'f?p=&APP_ID.:1922:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_IN_CONDITION'
,p_branch_condition=>'PURGE_CACHE,APPLY_CHANGES_SYNC_PARAMS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1977075738539737)
,p_branch_name=>'Go To Page 1922'
,p_branch_action=>'f?p=&APP_ID.:1922:&SESSION.::&DEBUG.:RP,::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(3501080431076915)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1922_RETURN_TO_PAGE'
,p_branch_condition_text=>'YES'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(226688662282475248)
,p_branch_name=>'Go To Page 1921'
,p_branch_action=>'f?p=&APP_ID.:1921:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1418382946635714)
,p_name=>'P1922_FORCE_RAISE_404_ERROR'
,p_is_required=>true
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(3469784605842432)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Force Raise HTTP-404 Error'
,p_source=>'FORCE_ERROR_FOR_HTTP_404'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'If the HTTP request, executed by the <strong>Fetch Rows</strong> database operation, receives the ',
'<strong>404</strong> HTTP status code ("Not Found"), APEX treats this as a "No Rows Found" situation - and does thus not raise an error (an error is raised only when <em>Debug</em> is enabled). Enabling this switch forces APEX to <em>always</em> sign'
||'al HTTP-404 situations as errors.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1719293568469925)
,p_name=>'P1922_DATA_PROFILE_ARRAY_ID'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(3500552115076908)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Use for Array Column'
,p_source=>'DATA_PROFILE_ARRAY_COL_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select dpc.display_name,',
'       dpc.id',
'  from wwv_flow_web_src_arr_cols_dev dpc',
' where dpc.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and dpc.flow_id           = :FB_FLOW_ID',
'   and dpc.data_profile_id   = :P1922_DATA_PROFILE_ID   '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'All'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    If the operation is mapped to an Array Column, all &PRODUCT_NAME. components, ',
'    which are using the same array column, will select this operation.</p>',
'<p> ',
'    Note that, for each database operation, the REST Data Source must contain at least one operation',
'    not mapped to an array column.</p>'))
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1976939351539736)
,p_name=>'P1922_RETURN_TO_PAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(242268510007871834)
,p_prompt=>'Stay on page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_display_when=>'P1922_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select this checkbox to stay on this page after applying changes.'
,p_attribute_01=>'N'
,p_attribute_02=>'YES'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3504053275076922)
,p_name=>'P1922_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3500552115076908)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3505105036076971)
,p_name=>'P1922_WEB_SRC_MODULE_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(3500552115076908)
,p_use_cache_before_default=>'NO'
,p_source=>'WEB_SRC_MODULE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3505592693076972)
,p_name=>'P1922_DATA_PROFILE_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(3500552115076908)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3506301333076973)
,p_name=>'P1922_DATABASE_OPERATION'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(3500552115076908)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Database Operation'
,p_source=>'DATABASE_OPERATION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEB_SOURCE_DATABASE_OPERATIONS'
,p_lov=>'.'||wwv_flow_imp.id(225834585600778166)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Not mapped -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Assign a <strong>Database Operation</strong> to this HTTP operation. The database operation is important for &PRODUCT_NAME. components to work with the REST Data Source. An &PRODUCT_NAME. component is assigned a REST Data Source (and not an opera'
||'tion), thus it looks up the HTTP operation based on the required database operation. ',
'</p>',
'<ul>',
'    <li>Visualization components like report, charts, CSS calendar and others, will always use the HTTP operation assigned to the <strong>Fetch Rows</strong> database operation. <strong>APEX_EXEC.OPEN_WEB_SOURCE_QUERY</strong> will also use the Fetch'
||' Rows database operation.</li>',
'    <li>When a Form component inserts, updates or deletes rows, it will use the operations assigned to the <strong>Insert Row</strong>, <strong>Update Row</strong> or <strong>Delete Row</strong>, respectively. In PL/SQL, <strong>APEX_EXEC.OPEN_WEB_SO'
||'URCE_DML_CONTEXT</strong> is the equivalent to a form.</li>',
'    <li>The <strong>Fetch Single Row</strong> database operation is used by the Form component when lost update detection or the allowed operations check is performed. The form then uses this operation to re-fetch the row from the REST service before'
||' doing the actual DML operation.</li>',
'    <li>Operations which are not mapped to a database operation, will not be used by &PRODUCT_NAME. components. Use the <strong>APEX_EXEC.EXECUTE_WEB_SOURCE</strong> PL/SQL procedure to execute these from a PL/SQL context.</li>',
'</ul>',
'<p>',
'    <br>',
'    For instance, the report or chart components of &PRODUCT_NAME. require a collection of rows. When working with',
'    a REST Data Source, &PRODUCT_NAME. will look up the <strong>Fetch rows</strong> database operation and  execute',
'    the assigned HTTP operation at runtime. A Form will look for Insert Row, Update Row or Delete Row database operations.',
'</p>',
'<p>',
'    Each database operation can be assigned only once within a REST Data Source. This abstraction of the &PRODUCT_NAME. component from the actual HTTP operation allows to create a new operation with different behavior and assign that to the database '
||'operation. All components will then transparently use the new HTTP operation.',
'</p>',
'<p>',
'    There is no restriction on which HTTP operation (GET, POST, PUT, DELETE) can be mapped to which database operation. A POST HTTP operation can be mapped to the Fetch Rows database operation. However, for clarity and maintainability, it is recommen'
||'ded to design REST APIs to use GET for fetch operations and to use POST, PUT, DELETE to change data.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3506734544076973)
,p_name=>'P1922_URL_PATTERN'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(3500552115076908)
,p_use_cache_before_default=>'NO'
,p_prompt=>'URL Pattern'
,p_source=>'URL_PATTERN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>500
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    The <strong>URL Pattern</strong> is the last part of the Web Service endpoint URL. The combination of URL pattern and HTTP Operation (GET, POST, PUT, DELETE) identifies the operation within a REST Data Source. A REST Data Source may contain the s'
||'ame URL pattern for different HTTP operations and different URL patterns for the same HTTP operation.',
'    The URL pattern can also be empty, use a <em>dot</em> (.) to identify this case. ',
'</p>',
'<p>',
'        When the REST Data Source is invoked, &PRODUCT_NAME. builds the URL as follows:',
'</p>',
'<p>',
'    The URL Pattern can also contain parameters. These are denoted by :param-name or {param-name}. In this case, the parameter must be added to the <strong>REST Source Parameters</strong>, either at the Module or at the Operation level.',
'</p>',
'<ol>',
'    <li><strong>Base URL</strong> of the <strong>Remote Server</strong> object</li> ',
'    <li><strong>URL Path Prefix</strong> of the <strong>REST Data Source</strong></li>',
'    <li><strong>URL Pattern</strong> defined in the REST Data Source''s <strong>Operation</strong></li>',
'</ol>',
'<p>',
'    <br>',
'    Example for URL Patterns:',
'</p>',
'<ul>',
'    <li><strong>GET</strong> for <code>http://api.example.com:8080/root/service1/<strong>method1</strong></code></li>',
'    <li><strong>PUT</strong> for <code>http://api.example.com:8080/root/service1/<strong>method1</strong></code></li>',
'    <li><strong>GET</strong> for <code>http://api.example.com:8080/root/service1/<strong>method2</strong></code></li>',
'</ul> ',
'<p>',
'    <br>',
'    URL Patterns with Parameters:',
'</p>',
'<ul>',
'    <li>',
'        The URL pattern contains a parameter <strong>id</strong>:<br>',
'        <strong>GET</strong> for <code>http://api.example.com:8080/root/service1/<strong>:id</strong></code></li>',
'    <li>The URL pattern is empty:<br>',
'        <strong>GET</strong> for <code>http://api.example.com:8080/root/service1/<strong>.</strong></code></li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3507196808076973)
,p_name=>'P1922_REQUEST_BODY_TEMPLATE'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(3500552115076908)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Request Body Template'
,p_post_element_text=>'<a id="P1922_GENERATE_BODY_TEMPLATE" class="a-Button a-Button--noLabel a-Button--small a-Button--withIcon" href="#"><span class="a-Icon icon-refresh"></span> Generate</a>'
,p_source=>'REQUEST_BODY_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>100
,p_cMaxlength=>32760
,p_cHeight=>8
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Enter the request body template to be used for HTTP POST, PUT, PATCH or DELETE requests. Within the template, you can use placeholders (<em>#placeholder-name#</em>). Use the <strong>!RAW</strong> modifier to suppress escaping when &PRODUCT_NAME. '
||'performs substitutions.',
'    Use the <strong>!NULL</strong> modifier to replace empty values with the <strong>null</strong> JSON keyword.',
'</p>',
'<ul>',
'    <li>for REST Source Parameters of type <strong>Request / Response body</strong>. These will be executed for all operations.</li>',
'    <li>for Data Profile columns. These will be replaced when the Insert Row, Update Row or Delete Row database operations are executed.</li>',
'</ul> ',
'<p>',
'    <br>',
'    Note that Automatic DML processes (form region on a REST service) will replace placeholders with <em>data-type aware, quoted and escaped</em> values. Custom PL/SQL Processes (when APEX_EXEC.EXECUTE_WEB_SOURCE is used) will replace plain placehold'
||'ers with escaped string values. Placeholders with the <strong>!RAW</strong> modifier will be replaced with unescaped values. Thus, for usage with APEX_EXEC.EXECUTE_WEB_SOURCE, you have to enquote placeholders in the template. For usage with declarati'
||'ve forms, placeholders must not be enquoted, and values will always be escaped.',
'</p>',
'<p>',
'    Example Request Body template: Simple JSON structure to pass an object. For the Insert Row, Update Row or Delete Row database operations, the placeholders will be replaced by Data Profile columns. The REST Data Source is to be used with a form re'
||'gion, so placeholders are not enquoted.',
'</p>',
'<pre>',
'{"empno": #EMPNO#, "ename": #ENAME#, "job": #JOB#, "sal": #SAL#, "comm": #COMM#, "hiredate": #HIREDATE#, "deptno": #DEPTNO#}',
'</pre>',
'<p>',
'    Example Request Body template: More complex JSON structure to pass an object. For the Insert Row, Update Row or Delete Row database operations, the placeholders will be replaced by Data Profile columns. The REST Data Source is to be used with for'
||' custom PL/SQL usage, so placeholders are enquoted. Additional placeholders can be used for <strong>REST Source Parameters</strong>. Make sure to define these as parameters of the <strong>Request / Response Body</strong> type at the Module or Operati'
||'on level.',
'</p>',
'<pre>',
'{ "passed-by": "#USERID#",',
'  "client-id": "APEX-#APEX_INSTANCE#",',
'  "object": {',
'      "empno": #EMPNO#, ',
'      "ename": "#ENAME#", ',
'      "job": "#JOB#", ',
'      "sal": #SAL#, ',
'      "comm": #COMM#, ',
'      "hiredate": "#HIREDATE#", ',
'      "deptno": #DEPTNO# } }',
'</pre>',
'<p>',
'    Click the <strong><span class="a-Icon icon-refresh"></span> Generate</strong> button in order to generate a request body template from the <em>Data Profile</em> within the REST Data Source definition (the button only appears when the text area is'
||' empty).',
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'Y'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3507516611076974)
,p_name=>'P1922_CACHING'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3632686677195912646)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Caching'
,p_source=>'CACHING'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CACHING_MODE'
,p_lov=>'.'||wwv_flow_imp.id(225840272947805161)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Disabled'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Select how the &PRODUCT_NAME. engine can cache REST Source responses on the server side. If caching can be used, the component will be rendered based on cached results instead of fetching from the web service again. Only HTTP "GET" requests will '
||'be cached, which will cut down expensive HTTP requests. This feature is unrelated to the browser''s caching capabilities.</p>',
'<p>',
'    Available options include:',
'</p>',
'<ul>',
'    <li><strong>Disabled</strong>: Content is not cached and fetched from the REST source for each request.</li>',
'    <li><strong>For all users</strong>: Content is cached and utilized by all users.</li>',
'    <li><strong>By User</strong>: Content is cached specifically for each user.</li>',
'    <li><strong>By Session</strong>: Content is cached specifically for each session.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3507960502076974)
,p_name=>'P1922_INVALIDATE_WHEN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3632686677195912646)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Invalidate When'
,p_source=>'INVALIDATE_WHEN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Specify when cached content is to be invalidated. Provide either the amount of minutes or a "DBMS_SCHEDULER Calendaring Expression". ',
'    With the latter, cached content can be invalidated using flexible intervals, for instance at the top of the hour, at midnight, or another specific recurring point in time.',
'</p> ',
'<p>',
'    Use a value of zero to only cache contents in memory, for the current page processing.',
'</p>',
'<p>Examples:</p>',
'<ul>',
'    <li><strong>15</strong>: The content will expire 15 minutes after it has been cached.</li>',
'    <li><strong>FREQ=HOURLY;BYMINUTE=0;BYSECOND=0</strong>: The content will be cached until the next top of the hour.</li>',
'    <li><strong>FREQ=DAILY;BYHOUR=0;BYMINUTE=0;BYSECOND=0</strong>: The content will be cached until midnight.</li>',
'    <li><strong>0</strong>: The content will be cached only in memory, for the current page processing.</li>',
'</ul>',
'<p></p>',
'<p>See the documentation on <code>DBMS_SCHEDULER.EVALUATE_CALENDAR_STRING</code> for more details.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3508303664076974)
,p_name=>'P1922_SECURITY_SCHEME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3469784605842432)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Security Scheme'
,p_source=>'SECURITY_SCHEME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REQUIRED_ROLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.d, a.r from (',
'    select wwv_flow_lang.system_message(''MUST_NOT_BE_PUBLIC_USER'') d,''MUST_NOT_BE_PUBLIC_USER'' r, 1',
'      from sys.dual',
'    union all',
'    select wwv_flow_escape.html(substr(name,1,50)),to_char(id), 1',
'      from wwv_flow_security_schemes',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID',
'    union all',
'    select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'',wwv_flow_escape.html(substr(name,1,50)))||''}'' d, ''!''||to_char(id) r, 2',
'      from wwv_flow_security_schemes',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID',
'    order by 3,1) a'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_required_patch=>wwv_flow_imp.id(170786031904296885)
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3508789886076975)
,p_name=>'P1922_OPERATION_COMMENT'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(3469784605842432)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Operation Comment'
,p_source=>'OPERATION_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter any developer comments or notes here. These comments only display within App Builder and never display when running the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5048714094992926)
,p_name=>'P1922_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(3500552115076908)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Provide an optional name for this REST Operation.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5048835483992927)
,p_name=>'P1922_STATIC_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(3469784605842432)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Static ID'
,p_source=>'STATIC_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Provide a static ID for programmatic access to this REST Operation.</p>',
'<p>The static ID will be converted to lower case, and all non-alphanumeric or special characters will be replaced with an underscore ("_").</p>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225853650468926502)
,p_name=>'P1922_FLOW_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3500552115076908)
,p_use_cache_before_default=>'NO'
,p_item_default=>'FB_FLOW_ID'
,p_item_default_type=>'ITEM'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(238756237141331835)
,p_name=>'P1922_ALLOW_FETCH_ALL_ROWS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(3469784605842432)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Allow Fetching All Rows'
,p_source=>'ALLOW_FETCH_ALL_ROWS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from ',
'wwv_flow_web_src_modules',
'where id = :P1922_WEB_SRC_MODULE_ID and :P1922_DATABASE_OPERATION = ''FETCH_COLLECTION''',
''))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Specify whether &PRODUCT_NAME. components are allowed to fetch all rows, thus executing multiple HTTP requests, from this REST source operation. ',
'</p>',
'<p>',
'   This applies for REST sources which return their data page-wise, like Oracle REST Data Services does. For instance, a chart or the Group By view of Interactive Reports need to access all rows to compute correct results. When the REST service retur'
||'n their data page-wise, this requires multiple HTTP requests to the REST service. ',
'</p>',
'<p>',
'    If the REST source only returns a few pages, which can be fetched in a few seconds, this is acceptable for most use-cases. For these services, set this attribute to <strong>On</strong>. On the other hand, when the REST service returns thousands o'
||'f rows in hundreds of pages, fetching all rows would take too much time to complete - for such services, set this attribute to <strong>Off</strong>.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(238756354056331836)
,p_name=>'P1922_FETCH_ALL_ROWS_TIMEOUT'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(3469784605842432)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Fetch All Rows Timeout '
,p_post_element_text=>'&nbsp;(in Seconds)'
,p_source=>'FETCH_ALL_ROWS_TIMEOUT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>30
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from ',
'wwv_flow_web_src_modules',
'where id = :P1922_WEB_SRC_MODULE_ID and :P1922_DATABASE_OPERATION = ''FETCH_COLLECTION''',
''))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify the timeout value (in seconds) for a "fetch all rows" operation. Since multiple pages will be requested, this timeout value should be higher than the single-request timeout value specified at the module level. Make sure to set it high enough '
||'to allow executing multiple HTTP requests but low enough to prevent hanging pages for end users.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3403059783178708614)
,p_name=>'P1922_ORDS_FIXED_PAGE_SIZE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(3469784605842432)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Fixed Page Size'
,p_source=>'LEGACY_ORDS_FIXED_PAGE_SIZE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Enter the size of the REST service''s pagination window. The pagination for a resource handler HTTP operation GET method, equates to the number of rows to return on each page of a JSON format result set based on a database query.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'10000'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3632686706193912647)
,p_name=>'P1922_MODULE_BASE_URL'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(3500552115076908)
,p_prompt=>'REST Source Base URL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select rtrim(s.base_url, ''/'' ) || ''/'' || ltrim( m.url_path_prefix, ''/'' )',
'  from wwv_remote_servers s, ',
'       wwv_flow_web_src_modules m',
' where s.id      = m.remote_server_id ',
'   and m.id      = :P1922_WEB_SRC_MODULE_ID',
'   and m.flow_id = :FB_FLOW_ID',
'   and m.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and s.security_group_id = m.security_group_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3632686934550912649)
,p_name=>'P1922_REST_OPERATION'
,p_is_required=>true
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(3500552115076908)
,p_use_cache_before_default=>'NO'
,p_prompt=>'HTTP Method'
,p_source=>'OPERATION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEB_SOURCE_HTTP_METHODS'
,p_lov=>'.'||wwv_flow_imp.id(225847729464891335)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    HTTP Operation or <em>Method</em> (GET, POST, PUT, DELETE) to be executed on the REST Web Service. The combination of URL pattern and HTTP Operation identifies the operation within a REST Data Source. A REST Data Source may contain the same URL p'
||'attern for different HTTP operations and different URL patterns for the same HTTP operation.',
'</p>',
'<p>',
'    Following is a brief explanation of HTTP methods and their usage in REST services. Note this this is all convention - REST services should adhere to this, but real implementations can be different. Always check the documentation of the REST servi'
||'ce you plan to access on which methods can be called and how they work.',
'</p>',
'<ul>',
'    <li>',
'        <strong>GET</strong> to fetch data from the REST service. GET is supposed to be idempotent; it''s invocation does not change anything at the server side. For this reason, GET requests can be typically be cached or called multiple times. GET re'
||'quests do also <em>not</em> have a request body in normal cases.',
'    </li>',
'    <li>',
'        <strong>POST</strong> is typically used to create a new resource on the server. However, in practice, POST requests can',
'        do all sort of things. POST requests typically require a request body to be sent.',
'    </li>',
'    <li>',
'        <strong>PUT</strong> is typically used to <em>replace</em> a new resource on the server. A request body is typically required. Note that you need to pass <em>all</em> attributes to the server - missing attributes are likely to be written as n'
||'ull or empty values.',
'    </li>',
'    <li>',
'        <strong>DELETE</strong> is typically used to remove a resource on the server. A request body is typically not required.',
'    </li>',
'    <li>',
'        <strong>PATCH</strong> is typically used to <em>change</em> a new resource on the server. Not all REST services provide PATCH endpoints. A request body, containing information on which attribute to change to which value, is required. PATCH th'
||'us allows to do partial updates on a server resource. Note that there is no standard on how the request body for a PATCH endpoint should look like - check the documentation of your REST service before invoking it. ',
'    </li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1720190982469934)
,p_computation_sequence=>10
,p_computation_item=>'P1922_DATA_PROFILE_ARRAY_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P1922_DATABASE_OPERATION'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(987817765017252925)
,p_computation_sequence=>20
,p_computation_item=>'P1922_INVALIDATE_WHEN'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P1922_CACHING'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3632686826845912648)
,p_computation_sequence=>30
,p_computation_item=>'P1922_URL_PATTERN'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'.'
,p_compute_when=>'P1922_URL_PATTERN'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(5049099475992929)
,p_computation_sequence=>40
,p_computation_item=>'P1922_STATIC_ID'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'regexp_replace( ',
'    srcstr     => lower( :P1922_STATIC_ID ),',
'    pattern    => ''[^'' || wwv_flow_utilities.c_alnum || '']+'', ',
'    replacestr => ''_'' )',
''))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1719384900469926)
,p_computation_sequence=>10
,p_computation_item=>'P1922_DATA_PROFILE_ID'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select data_profile_id',
'  from wwv_flow_web_src_modules',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and id                = :P1922_WEB_SRC_MODULE_ID'))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1719672963469929)
,p_validation_name=>'Validate REST Operation integrity rules'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'return wwv_flow_web_src_dev.validate_web_src_operations(',
'           p_security_group_id      => :FLOW_SECURITY_GROUP_ID,',
'           p_flow_id                => :FB_FLOW_ID,',
'           p_web_src_module_id      => :P1922_WEB_SRC_MODULE_ID,',
'           p_dml_operation          => case :REQUEST',
'                                           when ''CREATE'' then wwv_flow_exec_api.c_dml_operation_insert',
'                                           when ''SAVE''   then wwv_flow_exec_api.c_dml_operation_update',
'                                           when ''DELETE'' then wwv_flow_exec_api.c_dml_operation_delete',
'                                       end,',
'           p_operation_id           => :P1922_ID,',
'           p_static_id              => :P1922_STATIC_ID,',
'           p_url_pattern            => :P1922_URL_PATTERN,',
'           p_operation              => :P1922_REST_OPERATION,',
'           p_database_operation     => :P1922_DATABASE_OPERATION,',
'           p_array_column_id        => :P1922_DATA_PROFILE_ARRAY_ID );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'CREATE,SAVE,DELETE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(987817675354252924)
,p_validation_name=>'Validate Calendaring Expression'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_next_run_timestamp timestamp with time zone;',
'    l_minutes            number;',
'begin',
'    begin',
'        l_minutes := to_number( :P1922_INVALIDATE_WHEN );',
'        return null;',
'    exception',
'        -- if not a number, then proceed with validating the calendaring expression',
'        when others then null;',
'    end;',
'',
'    begin',
'        sys.dbms_scheduler.evaluate_calendar_string(',
'            calendar_string   => :P1922_INVALIDATE_WHEN,',
'            start_date        => systimestamp,',
'            return_date_after => systimestamp,',
'            next_run_date     => l_next_run_timestamp );',
'    exception',
'        when others then',
'            return sqlerrm;',
'    end;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':P1922_CACHING is not null and :REQUEST in (''CREATE'', ''SAVE'' )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(3507960502076974)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3501742358076916)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3501688362076916)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3502563773076919)
,p_event_id=>wwv_flow_imp.id(3501742358076916)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(238756406686331837)
,p_name=>'Fetch All Rows changed'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1922_ALLOW_FETCH_ALL_ROWS'
,p_condition_element=>'P1922_ALLOW_FETCH_ALL_ROWS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(238756599332331838)
,p_event_id=>wwv_flow_imp.id(238756406686331837)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1922_FETCH_ALL_ROWS_TIMEOUT'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(238756628982331839)
,p_event_id=>wwv_flow_imp.id(238756406686331837)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1922_FETCH_ALL_ROWS_TIMEOUT'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(345457032984487511)
,p_name=>'Parameter Dialog closed'
,p_event_sequence=>30
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(922351464945024904)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(345457154129487512)
,p_event_id=>wwv_flow_imp.id(345457032984487511)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(922351464945024904)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(619336627441855721)
,p_name=>'GET Operation'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1922_REST_OPERATION'
,p_condition_element=>'P1922_REST_OPERATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'GET'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(619336738818855722)
,p_event_id=>wwv_flow_imp.id(619336627441855721)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1922_REQUEST_BODY_TEMPLATE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(619336834522855723)
,p_event_id=>wwv_flow_imp.id(619336627441855721)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1922_REQUEST_BODY_TEMPLATE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(619336971358855724)
,p_event_id=>wwv_flow_imp.id(619336627441855721)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1922_REQUEST_BODY_TEMPLATE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(55558820931883030)
,p_name=>'Generate Request Body Template'
,p_event_sequence=>50
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'#P1922_GENERATE_BODY_TEMPLATE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(55558979476883031)
,p_event_id=>wwv_flow_imp.id(55558820931883030)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    :P1922_REQUEST_BODY_TEMPLATE := wwv_flow_web_src_dev.f4000_build_body_template(',
'        p_web_src_module_id    => :P1922_WEB_SRC_MODULE_ID );',
'end;'))
,p_attribute_02=>'P1922_ID,P1922_WEB_SRC_MODULE_ID'
,p_attribute_03=>'P1922_REQUEST_BODY_TEMPLATE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(55559015041883032)
,p_name=>'Show / Hide Generate Request Body'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1922_REQUEST_BODY_TEMPLATE'
,p_condition_element=>'P1922_REQUEST_BODY_TEMPLATE'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2007298851904827)
,p_event_id=>wwv_flow_imp.id(55559015041883032)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(2006785939904822)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(55559151045883033)
,p_event_id=>wwv_flow_imp.id(55559015041883032)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'#P1922_GENERATE_BODY_TEMPLATE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2007148178904826)
,p_event_id=>wwv_flow_imp.id(55559015041883032)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(2006785939904822)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(55559261345883034)
,p_event_id=>wwv_flow_imp.id(55559015041883032)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'#P1922_GENERATE_BODY_TEMPLATE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(987817891902252926)
,p_name=>'Show / Hide Cache Expression'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1922_CACHING'
,p_condition_element=>'P1922_CACHING'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(987817915289252927)
,p_event_id=>wwv_flow_imp.id(987817891902252926)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1922_INVALIDATE_WHEN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(987818042507252928)
,p_event_id=>wwv_flow_imp.id(987817891902252926)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1922_INVALIDATE_WHEN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(987818108910252929)
,p_event_id=>wwv_flow_imp.id(987817891902252926)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1922_INVALIDATE_WHEN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1418473148635715)
,p_name=>'Fetch Rows database operation chosen'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1922_DATABASE_OPERATION'
,p_condition_element=>'P1922_DATABASE_OPERATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FETCH_COLLECTION'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1418511379635716)
,p_event_id=>wwv_flow_imp.id(1418473148635715)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1922_FORCE_RAISE_404_ERROR'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1418665066635717)
,p_event_id=>wwv_flow_imp.id(1418473148635715)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1922_FORCE_RAISE_404_ERROR'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2006851243904823)
,p_name=>'Synchronize Parameters'
,p_event_sequence=>90
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2006785939904822)
,p_condition_element=>'P1922_REQUEST_BODY_TEMPLATE'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2007373355904828)
,p_event_id=>wwv_flow_imp.id(2006851243904823)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    This will synchronize parameters of the <strong>Request Body</strong> type with ',
'    the placeholders used in the request body template. ',
'</p>',
'<p>    ',
'    <strong>In</strong> parameters',
'    of the <strong>Request Body</strong> type, for which',
'    there is no placeholder, will be deleted.',
'</p>',
'    '))
,p_attribute_03=>'information'
,p_attribute_06=>'OK'
,p_attribute_07=>'Cancel'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2007099025904825)
,p_event_id=>wwv_flow_imp.id(2006851243904823)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'APPLY_CHANGES_SYNC_PARAMS'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1719716404469930)
,p_name=>'Any Database Operation chosen'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1922_DATABASE_OPERATION'
,p_condition_element=>'P1922_DATABASE_OPERATION'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1719802615469931)
,p_event_id=>wwv_flow_imp.id(1719716404469930)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1922_DATA_PROFILE_ARRAY_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1719950030469932)
,p_event_id=>wwv_flow_imp.id(1719716404469930)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1922_DATA_PROFILE_ARRAY_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1720099942469933)
,p_event_id=>wwv_flow_imp.id(1719716404469930)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1922_DATA_PROFILE_ARRAY_ID'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3511185561076981)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_WEB_SRC_OPERATIONS'
,p_attribute_02=>'WWV_FLOW_WEB_SRC_OPERATIONS'
,p_attribute_03=>'P1922_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id = :FLOW_SECURITY_GROUP_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>3511185561076981
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(218527273890706504)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Purge Cache'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_content_cache.purge_cache(',
'        p_application_id => :FB_FLOW_ID,',
'        p_component_type => wwv_flow_content_cache.c_comp_web_source,',
'        p_component_id   => :P1922_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(218527070654706502)
,p_process_success_message=>'REST Data Source cache purged.'
,p_internal_uid=>218527273890706504
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3511548576076982)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_WEB_SRC_OPERATIONS'
,p_attribute_02=>'WWV_FLOW_WEB_SRC_OPERATIONS'
,p_attribute_03=>'P1922_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id = :FLOW_SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>3511548576076982
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2007853985904833)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Synchronize Patameters with Body'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_web_src_dev.sync_parameters_from_body(',
'        p_flow_id               => :P1922_FLOW_ID,',
'        p_web_src_module_id     => :P1922_WEB_SRC_MODULE_ID,',
'        p_web_src_operation_id  => :P1922_ID,',
'        p_request_body_template => :P1922_REQUEST_BODY_TEMPLATE );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2006785939904822)
,p_process_when=>'P1922_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>2007853985904833
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2006664911904821)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Synchronize Operation Parameters to Components'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_web_src_dev.sync_operation_attributes(',
'        p_application_id       => :FB_FLOW_ID,',
'        p_web_src_operation_id => :P1922_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3501080431076915)
,p_internal_uid=>2006664911904821
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3511918173076982)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_CURRENT_PAGE'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3501137717076916)
,p_internal_uid=>3511918173076982
);
end;
/
prompt --application/pages/page_01923
begin
wwv_flow_imp_page.create_page(
 p_id=>1923
,p_name=>'Edit REST Data Source Parameter'
,p_alias=>'EDIT-REST-DATA-SOURCE-PARAMETER'
,p_page_mode=>'MODAL'
,p_step_title=>'Edit REST Data Source Parameter'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'600'
,p_dialog_width=>'80%'
,p_dialog_max_width=>'1000'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_read_only_when=>'P1921_REFERENCE_ID'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(226075893470270115)
,p_plug_name=>'Parameter'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2228816282790505)
,p_plug_name=>'Data Type'
,p_parent_plug_id=>wwv_flow_imp.id(226075893470270115)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>120
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2228992349790506)
,p_plug_name=>'Parameter'
,p_parent_plug_id=>wwv_flow_imp.id(226075893470270115)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>110
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(226077123308270128)
,p_plug_name=>'Advanced'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1718557886469918)
,p_plug_name=>'Comments'
,p_parent_plug_id=>wwv_flow_imp.id(226077123308270128)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>170
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1718664379469919)
,p_plug_name=>'Advanced Attributes'
,p_parent_plug_id=>wwv_flow_imp.id(226077123308270128)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>160
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(226077286521270129)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(249350328246883047)
,p_plug_name=>'Information'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--simple:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_plug_source=>'<p>Use this dialog to configure <em>REST Data Source parameters</em>. Parameters enable support for dynamic URL parts or to pass additional HTTP request headers or a specific request body to the web service. &PRODUCT_NAME. components assign values to'
||' the parameters before invoking the web service.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(226077814596270135)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(226077286521270129)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Add Parameter'
,p_button_position=>'CREATE'
,p_button_condition=>'not wwv_flow_page.is_read_only and :P1923_ID is null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(206266263324173845)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(226077286521270129)
,p_button_name=>'CREATE_AND_ANOTHER'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Add and Add another'
,p_button_position=>'CREATE'
,p_button_condition=>'not wwv_flow_page.is_read_only and :P1923_ID is null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(226077706432270134)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(226077286521270129)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply changes'
,p_button_position=>'CREATE'
,p_button_condition=>'not wwv_flow_page.is_read_only and :P1923_ID is not null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(226077919824270136)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(226077286521270129)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'DELETE'
,p_button_condition=>'not wwv_flow_page.is_read_only and :P1923_ID is not null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(226077306786270130)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(226077286521270129)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(206266439752173847)
,p_branch_action=>'f?p=&APP_ID.:1923:&SESSION.::&DEBUG.:RP,1923:P1923_FLOW_ID,P1923_WEB_SRC_MODULE_ID,P1923_WEB_SRC_OPERATION_ID:&P1923_FLOW_ID.,&P1923_WEB_SRC_MODULE_ID.,&P1923_WEB_SRC_OPERATION_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(206266263324173845)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1417954702635710)
,p_name=>'P1923_ARRAY_SEPARATOR_CHAR'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(1718664379469919)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Value Separator'
,p_source=>'ARRAY_SEPARATOR_CHAR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the separator character to use for splitting up the value. If empty, values will be separated by the colon character (":").'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1716859903469901)
,p_name=>'P1923_PROFILE_COLUMN'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(2228992349790506)
,p_prompt=>'Data Profile Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c.name d,',
'       c.name r',
'  from wwv_flow_data_profile_cols c,',
'       wwv_flow_data_profiles     p,',
'       wwv_flow_web_src_modules   w',
' where c.data_profile_id   = p.id',
'   and c.flow_id           = p.flow_id',
'   and c.security_group_id = p.security_group_id',
'   and w.data_profile_id   = p.id',
'   and w.flow_id           = p.flow_id',
'   and w.security_group_id = p.security_group_id',
'    --',
'   and w.id                = :P1923_WEB_SRC_MODULE_ID',
'   and p.flow_id           = :FB_FLOW_ID',
'   and p.security_group_id = :FLOW_SECURITY_GROUP_ID',
' order by c.sequence'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2228496871790501)
,p_name=>'P1923_DATA_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2228816282790505)
,p_use_cache_before_default=>'NO'
,p_item_default=>'VARCHAR2'
,p_prompt=>'Data Type'
,p_source=>'DATA_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEB_SOURCE_PARAM_DATA_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(2225637019805602)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Choose the data type of the parameter value. When a non-VARCHAR2 value ',
'    is sent to the REST API, it will be converted to a string using the ',
'    <strong>Output Format Mask</strong>.',
'</p>',
'<p>Options include</p>',
'<dl>',
'    <dt>String</dt>',
'    <dd>String values contain alphanumeric data.</dt>',
'    <dt>Numeric</dt>',
'    <dd>Numeric values are decimal or integer values.</dd>',
'    <dt>Date</dt>',
'    <dd>Date values contain date and time, but neither fractional seconds nor time zone information.</dd>',
'    <dt>Timestamp</dt>',
'    <dd>Timestamp values contain date and time (including fractional seconds), but no time zone information.</dd>',
'    <dt>Timestamp with Time Zone</dt>',
'    <dd>Timestamp with Time Zone values contain date and time (including fractional seconds), as well as time zone information.</dd>',
'    <dt>Boolean</dt>',
'    <dd>Boolean values contain <strong>true</strong> or <strong>false</strong>.</dd>',
'    <dt>Binary</dt>',
'    <dd>Binary content contains non-text (image, raw bytes) data, and are represented as a String in <em>Base64</em> format.</dd>',
'</dl>',
''))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2229186069790508)
,p_name=>'P1923_FORMAT_MASK'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2228816282790505)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Output Format Mask'
,p_source=>'OUTPUT_FORMAT_MASK'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'DATA_PROFILE_DATE_FORMAT_MASKS'
,p_lov=>'.'||wwv_flow_imp.id(225940310284555905)||'.'
,p_lov_display_null=>'YES'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'<em>Output</em> format mask to convert the value of the parameter to a string (VARCHAR2) representation before sending to the REST endpoint as the parameter type specified in <strong>Type</strong>.'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2229259558790509)
,p_name=>'P1923_VALIDATION_REGEXP'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(2228816282790505)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Validation Regular Expression'
,p_source=>'VALIDATION_REGEXP'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Regular expression to validate the value of this parameter before processing and sending to the REST endpoint.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3160742739926707)
,p_name=>'P1923_BOOLEAN_TRUE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2228816282790505)
,p_prompt=>'True Value Output'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Value to be sent to the REST API for a <code>TRUE</code> boolean value. If nothing is specified, <code>''TRUE''</code> will be emitted.</p>'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3160890284926708)
,p_name=>'P1923_BOOLEAN_FALSE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(2228816282790505)
,p_prompt=>'False Value Output'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Value to be sent to the REST API for a <code>FALSE</code> boolean value. If nothing is specified, <code>''FALSE''</code> will be emitted.</p>'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(226075903797270116)
,p_name=>'P1923_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2228992349790506)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(226076164807270118)
,p_name=>'P1923_WEB_SRC_MODULE_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(2228992349790506)
,p_use_cache_before_default=>'NO'
,p_source=>'WEB_SRC_MODULE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(226076259637270119)
,p_name=>'P1923_WEB_SRC_OPERATION_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(2228992349790506)
,p_use_cache_before_default=>'NO'
,p_source=>'WEB_SRC_OPERATION_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(226076393541270120)
,p_name=>'P1923_NAME'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(2228992349790506)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>'STATIC:Accept;Accept,Content-Type;Content-Type,Authorization;Authorization,id;id,query;query,User-Agent;User-Agent'
,p_lov_display_null=>'YES'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Enter the name of the parameter. Do not prefix parameters of <strong>URL Pattern</strong> with ":" and do not enclose with "{" and "}".'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
,p_item_comment=>'The HTTP Header names in the static LOV are *not* to be translated; thus we can use the Inline Static LOV here.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(226076489414270121)
,p_name=>'P1923_PARAM_TYPE'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(2228992349790506)
,p_use_cache_before_default=>'NO'
,p_item_default=>'URL_PATTERN'
,p_prompt=>'Type'
,p_source=>'PARAM_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEB_SOURCE_PARAM_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(226045111811519566)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Choose the type of this REST Source Parameter. Available values are:',
'</p>',
'<dl>',
'<dt>URL Pattern (IN)</dt>',
'<dd>Replace placeholders in the endpoint URL with parameter values.</dd>',
'<dt>URL Query String (IN)</dt>',
'<dd>Add parameter name and value to the URL, as the query string</dd>',
'<dt>HTTP Header (IN, OUT)</dt>',
'<dd>Send the parameter as a HTTP Request Header, or receive from the Response Headers</dd>',
'<dt>Cookie (IN, OUT)</dt>',
'<dd>Send the parameter as a cookie, or receive from the response cookies</dd>',
'<dt>Data Profile Column (OUT)</dt>',
'<dd>Parse the response using the data profile and use the column value. This type is only supported in the <strong>Invoke API</strong> process type.</dd>',
'<dt>Request or Response Body (IN, OUT)</dt>',
'<dd>Perform placeholder substitutions in the request body with the parameter value. For OUT parameters, the <em>full response</em> will be retrieved.</dd>',
'<dt>Status Code (OUT)</dt>',
'<dd>Receive the HTTP Status Code</dd>',
'<dt>Reason Phrase (OUT)</dt>',
'<dd>Receive the HTTP Reason Phrase</dd>',
'</dl>',
'<p>',
'    Example for Parameters of type <strong>URL Pattern</strong>',
'</p>',
'<ul>',
'    <li>URL Endpoint: <code>http://{server}:{port}/ords/:schema/emp/:deptno</code></li>',
'    <li>Parameter 1: <em>URL Pattern Variable</em> "deptno" with a value of "10"</li>',
'    <li>Parameter 2: <em>URL Pattern Variable</em> "schema" with a value of "scott"</li>',
'</ul>',
'<p>',
'<br>',
'    Do <em>not</em> add the colon (:) to the parameter name. &PRODUCT_NAME. will build the URL to invoke as follows:<br>',
'    <code>http://{server}:{port}/ords/<strong>scott</strong>/emp/<strong>10</strong></code>',
'</p>',
'<p>',
'    Example for Parameters of type <strong>Query String</strong>',
'</p>',
'<ul>',
'    <li>URL Endpoint: <code>http://{server}:{port}/ords/scott/emp</code></li>',
'    <li>Parameter 1: <em>Query String Variable</em> "query_filter" with a value of "KING"</li>',
'</ul>',
'<p>',
'<br>',
'    &PRODUCT_NAME. will build the URL to invoke as follows:<br>',
'    <code>http://{server}:{port}/ords/scott/emp?<strong>query_filter</strong>=<strong>KING</strong></code>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_show_quick_picks=>'Y'
,p_quick_pick_label_01=>'URL Pattern'
,p_quick_pick_value_01=>'URL_PATTERN'
,p_quick_pick_label_02=>'URL Query String'
,p_quick_pick_value_02=>'QUERY_STRING'
,p_quick_pick_label_03=>'HTTP Header'
,p_quick_pick_value_03=>'HEADER'
,p_quick_pick_label_04=>'Data Profile'
,p_quick_pick_value_04=>'DATA_PROFILE'
,p_quick_pick_label_05=>'Body'
,p_quick_pick_value_05=>'BODY'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(226076588682270122)
,p_name=>'P1923_IS_REQUIRED'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1718664379469919)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Required'
,p_source=>'IS_REQUIRED'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Choose whether this parameter is required (must always be set) or not.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(226076695853270123)
,p_name=>'P1923_DIRECTION'
,p_is_required=>true
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(2228992349790506)
,p_use_cache_before_default=>'NO'
,p_item_default=>'IN'
,p_prompt=>'Direction'
,p_source=>'DIRECTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WEB_SOURCE_PARAM_DIRECTIONS'
,p_lov=>'.'||wwv_flow_imp.id(226101569473456167)||'.'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_web_src_module_usage',
' where security_group_id  = :FLOW_SECURITY_GROUP_ID',
'   and flow_id            = :FB_FLOW_ID',
'   and web_src_module_id  = :P1923_WEB_SRC_MODULE_ID',
'   and :P1923_ID         is not null',
'union all (',
'    select 1 ',
'      from wwv_flow_web_src_modules',
'     where security_group_id  = :FLOW_SECURITY_GROUP_ID',
'       and flow_id            = :FB_FLOW_ID      ',
'       and id                 = :P1923_WEB_SRC_MODULE_ID',
'       and sync_table_name   is not null',
'       and :P1923_ID         is not null )',
''))
,p_read_only_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    <strong>In</strong> parameters are being sent to the REST Data Source, ',
'    <strong>Out</strong> parameters are only received from the REST Data Source ',
'    and <strong>In/Out</strong> parameters are both.',
'</p>',
'<p>',
'    This attribute can only be changed as long as the REST Source is <em>not</em> being',
'    used by other components. If that is the case, delete and recreate the parameter to change',
'    this attribute. Note, that this will <em>clear out all parameter settings made in APEX components</em>.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(226076748969270124)
,p_name=>'P1923_VALUE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(2228992349790506)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Default Value'
,p_source=>'VALUE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>50
,p_cMaxlength=>4000
,p_cHeight=>2
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the default value of the parameter. When the <strong>Static</strong> attribute is set to <strong>Yes</strong>, this value cannot be overridden in &PRODUCT_NAME. components.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(226076814483270125)
,p_name=>'P1923_IS_STATIC'
,p_is_required=>true
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(2228992349790506)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Static'
,p_source=>'IS_STATIC'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_web_src_module_usage',
' where security_group_id  = :FLOW_SECURITY_GROUP_ID',
'   and flow_id            = :FB_FLOW_ID',
'   and web_src_module_id  = :P1923_WEB_SRC_MODULE_ID',
'   and :P1923_ID         is not null',
'union all (',
'    select 1 ',
'      from wwv_flow_web_src_modules',
'     where security_group_id  = :FLOW_SECURITY_GROUP_ID',
'       and flow_id            = :FB_FLOW_ID      ',
'       and id                 = :P1923_WEB_SRC_MODULE_ID',
'       and sync_table_name   is not null',
'       and :P1923_ID         is not null )',
''))
,p_read_only_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Determine whether the parameter can be overridden by &PRODUCT_NAME. components or not.',
'</p>',
'<p>',
'    This attribute can only be changed as long as the REST Source is <em>not</em> being',
'    used by other components. If that is the case, delete and recreate the parameter to change',
'    this attribute. Note, that this will <em>clear out all parameter settings made in APEX components</em>.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
,p_attribute_03=>'Yes'
,p_attribute_04=>'N'
,p_attribute_05=>'No'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(226076951612270126)
,p_name=>'P1923_IS_ARRAY'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(1718664379469919)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Multiple Values'
,p_source=>'IS_ARRAY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Determine whether this query string parameter supports multiple values. If enabled, then the URL query string will contain one parameter for each element of the colon-separated value list.',
'</p>',
'<p>',
'    Example for parameter value <strong>A:B:C</strong>',
'</p>',
'<ul>',
'    <li>Multiple set to <strong>On</strong>:<br>http://api.example.com/url/path?param=A&amp;param=B&amp;param=C</li>',
'    <li>Multiple set to <strong>Off</strong>:<br>http://api.example.com/url/path?param=A:B:C</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(226077077301270127)
,p_name=>'P1923_PARAM_COMMENT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1718557886469918)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comment'
,p_source=>'PARAM_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_item_comment=>'Enter any developer comments or notes here. These comments only display within App Builder and never display when running the application.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(226078297307270139)
,p_name=>'P1923_FLOW_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2228992349790506)
,p_use_cache_before_default=>'NO'
,p_item_default=>'FB_FLOW_ID'
,p_item_default_type=>'ITEM'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(310206188885961946)
,p_name=>'P1923_OMIT_WHEN_NULL'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(1718664379469919)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Omit when value is empty'
,p_source=>'OMIT_WHEN_NULL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    If set to <strong>On</strong>, &PRODUCT_NAME. will only add the parameter to the request, when the value is not empty. When set to <strong>Off</strong>, the parameter will always be added to the request. This only applies to parameters of the <em'
||'>Query String</em>, <em>Cookie</em> or <em>HTTP Header</em> type. ',
'</p>',
'<p>',
'    Example for a parameter <strong>param2</strong> of type Query String with an empty value.',
'</p>',
'<ul>',
'    <li>Omit when value is empty set to <strong>Off</strong>:<br>',
'    http://api.example.com/url/path?param1=value1&amp;param2=</li>',
'    <li>Omit when value is empty set to <strong>On</strong>:<br>',
'    http://api.example.com/url/path?param1=value1</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(473241645223135113)
,p_name=>'P1923_IS_QUERY_PARAM'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1718664379469919)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Use for Row Search'
,p_source=>'IS_QUERY_PARAM'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>'P1923_WEB_SRC_OPERATION_ID'
,p_display_when_type=>'ITEM_IS_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    If <strong>Use for Row Search</strong> is enabled for a REST Data Source parameter, <em>Row Search</em> queries (from Interactive Reports, Interactive Grids or Popup LOVs) will be passed to the Web Service using this parameter. This is useful if '
||'your REST service supports <em>search</em> or <em>query</em> parameters.',
'</p>',
'<p>Example:</p>',
'<p>',
'    A REST service endpoint is invoked using a query parameter "q", e.g. <code>http://{server}/path/to/service?p={search-term}</code>. The REST Data Source will have the <strong>q</strong> query string parameter defined. If the <strong>Use for Row Se'
||'arch</strong> is enabled, search terms from Interactive Report or Interactive Grid row searches will be passed to the REST service as the <strong>q</strong> parameter.',
'</p>',
'<p>Only Parameters defined at the REST Source level can be used for Row Search.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1717676791469909)
,p_computation_sequence=>10
,p_computation_item=>'P1923_NAME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P1923_PROFILE_COLUMN'
,p_compute_when=>'P1923_PARAM_TYPE'
,p_compute_when_text=>'DATA_PROFILE'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2232893313790545)
,p_computation_sequence=>20
,p_computation_item=>'P1923_DATA_TYPE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case ',
'    when    :P1923_PARAM_TYPE not in ( ''HEADER'', ''COOKIE'', ''URL_PATTERN'', ''QUERY_STRING'', ''BODY'' )',
'         or :P1923_DIRECTION = ''OUT''',
'    then null',
'    else coalesce( :P1923_DATA_TYPE, ''VARCHAR2'' )',
'end'))
,p_compute_when=>'APPLY_CHANGES,CREATE,CREATE_AND_ANOTHER'
,p_compute_when_type=>'REQUEST_IN_CONDITION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3161301742926713)
,p_computation_sequence=>30
,p_computation_item=>'P1923_FORMAT_MASK'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case when    :P1923_BOOLEAN_FALSE is not null',
'          or :P1923_BOOLEAN_TRUE is not null',
'     then :P1923_BOOLEAN_TRUE || '','' || :P1923_BOOLEAN_FALSE',
'end'))
,p_compute_when=>'P1923_DATA_TYPE'
,p_compute_when_text=>'BOOLEAN'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1717483734469907)
,p_computation_sequence=>10
,p_computation_item=>'P1923_PROFILE_COLUMN'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P1923_NAME'
,p_compute_when=>'P1923_PARAM_TYPE'
,p_compute_when_text=>'DATA_PROFILE'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3161498249926714)
,p_computation_sequence=>20
,p_computation_item=>'P1923_BOOLEAN_TRUE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'substr( :P1923_FORMAT_MASK, 1, instr( :P1923_FORMAT_MASK, '','' ) - 1 )',
''))
,p_compute_when=>'P1923_DATA_TYPE'
,p_compute_when_text=>'BOOLEAN'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3161534595926715)
,p_computation_sequence=>30
,p_computation_item=>'P1923_BOOLEAN_FALSE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case when instr( :P1923_FORMAT_MASK, '','' ) > 0 ',
'     then substr( :P1923_FORMAT_MASK, instr( :P1923_FORMAT_MASK, '','' ) + 1 )',
'end'))
,p_compute_when=>'P1923_DATA_TYPE'
,p_compute_when_text=>'BOOLEAN'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(226077610861270133)
,p_validation_name=>'Static value provided'
,p_validation_sequence=>10
,p_validation=>'P1923_VALUE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be provided for Static parameters.'
,p_validation_condition=>':REQUEST in (''APPLY_CHANGES'', ''CREATE'' ) and :P1923_IS_STATIC = ''Y'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(226076748969270124)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(122066804258718211)
,p_validation_name=>'Data Type required'
,p_validation_sequence=>20
,p_validation=>'P1923_DATA_TYPE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    :REQUEST in (''CREATE'', ''CREATE_AND_ANOTHER'', ''APPLY_CHANGES'') ',
'and :P1923_PARAM_TYPE in ( ''HEADER'', ''COOKIE'', ''URL_PATTERN'', ''QUERY_STRING'', ''BODY'' )',
'and :P1923_DIRECTION  in ( ''IN'', ''IN_OUT'' )'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(2228496871790501)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1718789243469920)
,p_validation_name=>'Name required'
,p_validation_sequence=>30
,p_validation=>'P1923_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST in (''APPLY_CHANGES'', ''CREATE_AND_ANOTHER'', ''CREATE'' )',
'and :P1923_PARAM_TYPE != ''DATA_PROFILE'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(226076748969270124)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2005950886904814)
,p_validation_name=>'Value provided for Required  Parameters'
,p_validation_sequence=>40
,p_validation=>'P1923_VALUE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Default value must be provided for required parameters, as the REST Source is in use.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_result number;',
'begin',
'    if :REQUEST in (''APPLY_CHANGES'', ''CREATE'', ''CREATE_AND_ANOTHER'' ) and :P1923_IS_REQUIRED = ''Y'' then',
'        begin',
'            select result ',
'              into l_result',
'              from (',
'                     select 1 as result',
'                       from wwv_flow_web_src_module_usage',
'                      where security_group_id  = :FLOW_SECURITY_GROUP_ID',
'                        and flow_id            = :FB_FLOW_ID',
'                        and web_src_module_id  = :P1923_WEB_SRC_MODULE_ID',
'                        and :P1923_ID         is  null',
'                     union all (',
'                         select 1 as result',
'                           from wwv_flow_web_src_modules',
'                          where security_group_id  = :FLOW_SECURITY_GROUP_ID',
'                            and flow_id            = :FB_FLOW_ID      ',
'                            and id                 = :P1923_WEB_SRC_MODULE_ID',
'                            and sync_table_name   is not null',
'                            and :P1923_ID         is  null ) )',
'             where rownum = 1;',
'             return true;',
'        exception',
'            when no_data_found then',
'                null;',
'        end;',
'',
'    end if;',
'',
'    return false;',
'end;'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'FUNCTION_BODY'
,p_associated_item=>wwv_flow_imp.id(226076748969270124)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(510293007042814504)
,p_validation_name=>'Only one parameter can be IS_QUERY_PARAM'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_web_src_params',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and web_src_module_id = :P1923_WEB_SRC_MODULE_ID',
'   and is_query_param    = ''Y''',
'   and (id               != :P1923_ID or :P1923_ID is null)'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Only one parameter can be used for Row Search. Check the other REST Data Source parameters.'
,p_validation_condition=>':REQUEST in ( ''APPLY_CHANGES'', ''CREATE'', ''CREATE_AND_ANOTHER'') and :P1923_IS_QUERY_PARAM = ''Y'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(473241645223135113)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1717788401469910)
,p_validation_name=>'Profile Column must be chosen '
,p_validation_sequence=>60
,p_validation=>'P1923_PROFILE_COLUMN'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Data Profile column must be chosen'
,p_validation_condition=>':REQUEST in (''CREATE'', ''CREATE_AND_ANOTHER'', ''APPLY_CHANGES'') and :P1923_PARAM_TYPE = ''DATA_PROFILE'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(1716859903469901)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1718853744469921)
,p_validation_name=>'Parameter name is already taken  in this module'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_web_src_params',
' where name                  = :P1923_NAME',
'   and direction             = :P1923_DIRECTION',
'   and web_src_module_id     = :P1923_WEB_SRC_MODULE_ID',
'   and flow_id               = :FB_FLOW_ID',
'   and security_group_id     = :FLOW_SECURITY_GROUP_ID',
'   and web_src_operation_id is null',
'   and ( id != :P1923_ID or :P1923_ID is null )'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'The module parameter &P1923_NAME!HTML. is already in use.'
,p_validation_condition=>':REQUEST in (''CREATE'', ''CREATE_AND_ANOTHER'', ''APPLY_CHANGES'') and :P1923_WEB_SRC_OPERATION_ID is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1718983553469922)
,p_validation_name=>'Parameter name is already taken in this operation'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_web_src_params',
' where name                  = :P1923_NAME',
'   and direction             = :P1923_DIRECTION',
'   and web_src_module_id     = :P1923_WEB_SRC_MODULE_ID',
'   and flow_id               = :FB_FLOW_ID',
'   and security_group_id     = :FLOW_SECURITY_GROUP_ID',
'   and web_src_operation_id  = :P1923_WEB_SRC_OPERATION_ID',
'   and ( id != :P1923_ID or :P1923_ID is null )'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'The operation parameter &P1923_NAME!HTML. is already in use.'
,p_validation_condition=>':REQUEST in (''CREATE'', ''CREATE_AND_ANOTHER'', ''APPLY_CHANGES'') and :P1923_WEB_SRC_OPERATION_ID is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2231072186790527)
,p_validation_name=>'Default Value matches Validation Expression'
,p_validation_sequence=>90
,p_validation=>'regexp_like( :P1923_VALUE, :P1923_VALIDATION_REGEXP )'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Value does not match the validation expression provided.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    :REQUEST in (''CREATE'', ''CREATE_AND_ANOTHER'', ''APPLY_CHANGES'') ',
'and :P1923_VALUE is not null ',
'and :P1923_VALIDATION_REGEXP is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(226076748969270124)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1716965933469902)
,p_name=>'Data Profile Parameters'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1923_PARAM_TYPE'
,p_condition_element=>'P1923_PARAM_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'DATA_PROFILE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1717024452469903)
,p_event_id=>wwv_flow_imp.id(1716965933469902)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_PROFILE_COLUMN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1717312628469906)
,p_event_id=>wwv_flow_imp.id(1716965933469902)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1717219506469905)
,p_event_id=>wwv_flow_imp.id(1716965933469902)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_PROFILE_COLUMN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1717160524469904)
,p_event_id=>wwv_flow_imp.id(1716965933469902)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1718028424469913)
,p_event_id=>wwv_flow_imp.id(1716965933469902)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_VALUE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2004676412904801)
,p_event_id=>wwv_flow_imp.id(1716965933469902)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'Y'
,p_name=>'Set Direction to OUT'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_DIRECTION'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'OUT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1717880702469911)
,p_event_id=>wwv_flow_imp.id(1716965933469902)
,p_event_result=>'TRUE'
,p_action_sequence=>70
,p_execute_on_page_init=>'Y'
,p_name=>'Hide "Value" and "Is Static"'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_VALUE,P1923_IS_STATIC'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(226077490257270131)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(226077306786270130)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(226077543820270132)
,p_event_id=>wwv_flow_imp.id(226077490257270131)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1824006382134549)
,p_name=>'HTTP Status Code and Reason Phrase'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1923_PARAM_TYPE'
,p_condition_element=>'P1923_PARAM_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'STATUS_CODE,REASON_PHRASE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1824182287134550)
,p_event_id=>wwv_flow_imp.id(1824006382134549)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Hide "Value" and "Is Static"'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_VALUE,P1923_IS_STATIC'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1717978097469912)
,p_event_id=>wwv_flow_imp.id(1824006382134549)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_name=>'Set Direction to OUT'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_DIRECTION'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'OUT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2005854604904813)
,p_event_id=>wwv_flow_imp.id(1824006382134549)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_name=>'Set Parameter Name'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>wwv_flow_string.join(wwv_flow_t_varchar2(
'( ',
'    apex.item( "P1923_NAME" ).getValue() !== "" ',
'    ?',
'    apex.item( "P1923_NAME" ).getValue()',
'    : (',
'        apex.item( this.triggeringElement.name ).getValue() === "STATUS_CODE" ',
'        ?',
'        "status-code" ',
'        : (',
'            apex.item( this.triggeringElement.name ).getValue() === "REASON_PHRASE" ',
'            ?',
'            "reason-phrase"',
'            :',
'            ""',
'        )',
'    )',
')'))
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2004746403904802)
,p_event_id=>wwv_flow_imp.id(1824006382134549)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'N'
,p_name=>'Clear Value'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_VALUE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(348488612236006004)
,p_name=>'Parameter is Static'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1923_IS_STATIC'
,p_condition_element=>'P1923_IS_STATIC'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(348488797469006005)
,p_event_id=>wwv_flow_imp.id(348488612236006004)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1718664379469919)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(348488847622006006)
,p_event_id=>wwv_flow_imp.id(348488612236006004)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1718664379469919)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(348488976783006007)
,p_name=>'Direction OUT'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1923_DIRECTION'
,p_condition_element=>'P1923_DIRECTION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'OUT'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(348489196596006009)
,p_event_id=>wwv_flow_imp.id(348488976783006007)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_IS_STATIC,P1923_IS_REQUIRED,P1923_IS_QUERY_PARAM,P1923_VALUE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(510293102095814505)
,p_event_id=>wwv_flow_imp.id(348488976783006007)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_IS_QUERY_PARAM'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2005769164904812)
,p_event_id=>wwv_flow_imp.id(348488976783006007)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_VALUE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(348489051273006008)
,p_event_id=>wwv_flow_imp.id(348488976783006007)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_IS_STATIC,P1923_IS_REQUIRED,P1923_IS_QUERY_PARAM,P1923_VALUE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1718172556469914)
,p_name=>'Parameters which can be IN or IN OUT as well'
,p_event_sequence=>35
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1923_PARAM_TYPE'
,p_condition_element=>'P1923_PARAM_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'URL_PATTERN,URL_QUERY_STRING,BODY,HEADER,COOKIE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2004825223904803)
,p_event_id=>wwv_flow_imp.id(1718172556469914)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show "Value" and "Is Static"'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_VALUE,P1923_DIRECTION,P1923_IS_STATIC'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2004939300904804)
,p_name=>'URL Parameters are always IN'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1923_PARAM_TYPE'
,p_condition_element=>'P1923_PARAM_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'QUERY_STRING,URL_PATTERN'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2005179193904806)
,p_event_id=>wwv_flow_imp.id(2004939300904804)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Clear Direction'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_DIRECTION'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'IN'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(310206286551961947)
,p_name=>'IN Parameter can be omitted'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1923_PARAM_TYPE,P1923_DIRECTION'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'   [ "HEADER", "COOKIE", "QUERY_STRING" ].includes( apex.item("P1923_PARAM_TYPE").getValue() )',
'&& [ "IN", "IN_OUT" ].includes( apex.item("P1923_DIRECTION").getValue() )'))
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(310206327469961948)
,p_event_id=>wwv_flow_imp.id(310206286551961947)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_OMIT_WHEN_NULL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(310206564014961950)
,p_event_id=>wwv_flow_imp.id(310206286551961947)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_OMIT_WHEN_NULL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(91182456895358201)
,p_event_id=>wwv_flow_imp.id(310206286551961947)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_OMIT_WHEN_NULL'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2005392688904808)
,p_name=>'Hide Direction for always IN or OUT parameters'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1923_PARAM_TYPE'
,p_condition_element=>'P1923_PARAM_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'STATUS_CODE,URL_PATTERN,QUERY_STRING,REASON_PHRASE,DATA_PROFILE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2005408489904809)
,p_event_id=>wwv_flow_imp.id(2005392688904808)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Hide "Direction"'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_DIRECTION'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2005587262904810)
,p_event_id=>wwv_flow_imp.id(2005392688904808)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show "Direction"'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_DIRECTION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1418002466635711)
,p_name=>'Is Array'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1923_IS_ARRAY'
,p_condition_element=>'P1923_IS_ARRAY'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1418133970635712)
,p_event_id=>wwv_flow_imp.id(1418002466635711)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_ARRAY_SEPARATOR_CHAR'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1418281293635713)
,p_event_id=>wwv_flow_imp.id(1418002466635711)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_ARRAY_SEPARATOR_CHAR'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(190996669959372734)
,p_name=>'Show Multiple'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1923_PARAM_TYPE,P1923_OMIT_WHEN_NULL'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$v("P1923_PARAM_TYPE") === "QUERY_STRING" && $v("P1923_OMIT_WHEN_NULL") === "Y"'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(190996736162372735)
,p_event_id=>wwv_flow_imp.id(190996669959372734)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_IS_ARRAY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(190996813862372736)
,p_event_id=>wwv_flow_imp.id(190996669959372734)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_IS_ARRAY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(190996989632372737)
,p_event_id=>wwv_flow_imp.id(190996669959372734)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_IS_ARRAY'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2228674674790503)
,p_name=>'Show/Hide Data Types'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1923_PARAM_TYPE,P1923_DIRECTION'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'   [ "HEADER", "COOKIE", "URL_PATTERN", "QUERY_STRING", "BODY"].includes( $v( "P1923_PARAM_TYPE" ) )',
'&& [ "IN", "IN_OUT" ].includes( $v( "P1923_DIRECTION" ) )'))
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2228705315790504)
,p_event_id=>wwv_flow_imp.id(2228674674790503)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2228816282790505)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2229038771790507)
,p_event_id=>wwv_flow_imp.id(2228674674790503)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2228816282790505)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2230877670790525)
,p_event_id=>wwv_flow_imp.id(2228674674790503)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_FORMAT_MASK,P1923_VALIDATION_REGEXP,P1923_DATA_TYPE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2229393675790510)
,p_name=>'Data Type = VARCHAR2'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1923_DATA_TYPE'
,p_condition_element=>'P1923_DATA_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'VARCHAR2'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2229444420790511)
,p_event_id=>wwv_flow_imp.id(2229393675790510)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_VALIDATION_REGEXP'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2229544130790512)
,p_event_id=>wwv_flow_imp.id(2229393675790510)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_FORMAT_MASK,P1923_BOOLEAN_TRUE,P1923_BOOLEAN_FALSE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2229655519790513)
,p_event_id=>wwv_flow_imp.id(2229393675790510)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_FORMAT_MASK,P1923_BOOLEAN_TRUE,P1923_BOOLEAN_FALSE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2230480857790521)
,p_name=>'Data Type = NUMBER,DATE,TIMESTAMP'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1923_DATA_TYPE'
,p_condition_element=>'P1923_DATA_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'DATE,NUMBER,TIMESTAMP,TIMESTAMP WITH TIME ZONE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2230547640790522)
,p_event_id=>wwv_flow_imp.id(2230480857790521)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_VALIDATION_REGEXP,P1923_BOOLEAN_TRUE,P1923_BOOLEAN_FALSE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2230607221790523)
,p_event_id=>wwv_flow_imp.id(2230480857790521)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_FORMAT_MASK'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2230741994790524)
,p_event_id=>wwv_flow_imp.id(2230480857790521)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_VALIDATION_REGEXP,P1923_FORMAT_MASK,P1923_BOOLEAN_TRUE,P1923_BOOLEAN_FALSE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1684595799640312)
,p_name=>'Data Type = BLOB'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1923_DATA_TYPE'
,p_condition_element=>'P1923_DATA_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'BLOB'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1684602869640313)
,p_event_id=>wwv_flow_imp.id(1684595799640312)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_VALIDATION_REGEXP,P1923_FORMAT_MASK,P1923_BOOLEAN_TRUE,P1923_BOOLEAN_FALSE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1684816057640315)
,p_event_id=>wwv_flow_imp.id(1684595799640312)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_VALIDATION_REGEXP,P1923_FORMAT_MASK,P1923_BOOLEAN_TRUE,P1923_BOOLEAN_FALSE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3160942969926709)
,p_name=>'Data Type = BOOLEAN'
,p_event_sequence=>120
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1923_DATA_TYPE'
,p_condition_element=>'P1923_DATA_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'BOOLEAN'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3161084751926710)
,p_event_id=>wwv_flow_imp.id(3160942969926709)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_VALIDATION_REGEXP,P1923_FORMAT_MASK'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3161168083926711)
,p_event_id=>wwv_flow_imp.id(3160942969926709)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_VALIDATION_REGEXP,P1923_FORMAT_MASK'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3161229648926712)
,p_event_id=>wwv_flow_imp.id(3160942969926709)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1923_BOOLEAN_TRUE,P1923_BOOLEAN_FALSE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(226078185590270138)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process row of WWV_FLOW_WEB_SRC_PARAMS'
,p_attribute_02=>'WWV_FLOW_WEB_SRC_PARAMS'
,p_attribute_03=>'P1923_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id = :FLOW_SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>226078185590270138
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(348489893226006016)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Synchronize parameters to components'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P1923_ID is not null then',
'    wwv_flow_web_src_dev.check_and_remove_comp_param(',
'        p_application_id    => :FB_FLOW_ID,',
'        p_web_src_param_id  => :P1923_ID );         ',
'end if;',
'',
'if :P1923_WEB_SRC_OPERATION_ID is null then',
'    wwv_flow_web_src_dev.sync_module_attributes(',
'        p_application_id    => :FB_FLOW_ID,',
'        p_web_src_module_id => :P1923_WEB_SRC_MODULE_ID );',
'else ',
'    wwv_flow_web_src_dev.sync_operation_attributes(',
'        p_application_id    => :FB_FLOW_ID,',
'        p_web_src_operation_id => :P1923_WEB_SRC_OPERATION_ID );',
'end if;',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE,CREATE_AND_ANOTHER,APPLY_CHANGES'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_internal_uid=>348489893226006016
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(226078405734270141)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE_AND_ANOTHER'
,p_process_when_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_internal_uid=>226078405734270141
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(226076090077270117)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch row from WWV_FLOW_WEB_SRC_PARAMS'
,p_attribute_02=>'WWV_FLOW_WEB_SRC_PARAMS'
,p_attribute_03=>'P1923_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id = :FLOW_SECURITY_GROUP_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>226076090077270117
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2005665514904811)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Adjust Direction, if required'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1923_DIRECTION := case :P1923_PARAM_TYPE',
'                        when ''STATUS_CODE''   then ''OUT''',
'                        when ''REASON_PHRASE'' then ''OUT''',
'                        when ''DATA_PROFILE''  then ''OUT''',
'                        when ''URL_PATTERN''   then ''IN''',
'                        when ''QUERY_STRING''  then ''IN''',
'                        else :P1923_DIRECTION',
'                    end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'APPLY_CHANGES,CREATE,CREATE_AND_ANOTHER'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_internal_uid=>2005665514904811
);
end;
/
prompt --application/pages/page_01924
begin
wwv_flow_imp_page.create_page(
 p_id=>1924
,p_name=>'Save to REST Source Catalog'
,p_alias=>'SAVE-TO-REST-CATALOG'
,p_page_mode=>'MODAL'
,p_step_title=>'Save to REST Source Catalog'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1466666125002236)
,p_plug_name=>'REST Data Source already exists in a Catalog'
,p_region_template_options=>'#DEFAULT#:a-Alert--info:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'When saved back, the entry in the <strong>&P1924_EXIST_CATALOG_NAME!HTML.</strong> catalog will be overwritten with this REST Data Source.'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P1924_CATALOG_SERVICE_ID'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(228564397587963139)
,p_plug_name=>'Catalog Details'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(228600104593880675)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(228656736076645009)
,p_plug_name=>'Information'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Save the REST Data Source to a REST Source Catalog. Catalogs simplify the process of ',
'creating REST Data Sources. If a REST Data Source was previously saved to a catalog, then it will be updated',
'with the latest changes.',
'</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2701279242636205)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(228600104593880675)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2701535619636209)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(228600104593880675)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save to Catalog'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(28032755854072740)
,p_branch_name=>'Close Dialog and Show Message'
,p_branch_action=>'f?p=&APP_ID.:1921:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1466593217002235)
,p_name=>'P1924_CATALOG_SERVICE_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(228564397587963139)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1466789611002237)
,p_name=>'P1924_EXIST_CATALOG_NAME'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(228564397587963139)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28031165517072724)
,p_name=>'P1924_CATALOG_GROUP_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(228564397587963139)
,p_prompt=>'Catalog Group'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CATALOG_GROUPS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name as dv, id as rv',
'from WWV_WEB_SRC_CATALOG_GROUPS',
'where security_group_id = :WORKSPACE_ID',
'order by name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Add a new Catalog Group'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from WWV_WEB_SRC_CATALOG_GROUPS ',
'where security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Catalog Groups are used for organizing REST Source Catalogs. Choose Add a new Catalog Group if the service will not be added to an existing catalog.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28031264728072725)
,p_name=>'P1924_CATALOG_GROUP_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(228564397587963139)
,p_prompt=>'New Catalog Group Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Catalog groups names are unique to a Workspace. Specify a name that does not already exist. '
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28031386371072726)
,p_name=>'P1924_CATALOG_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(228564397587963139)
,p_prompt=>'Catalog'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'from wwv_web_src_catalogs',
'where security_group_id = :FLOW_SECURITY_GROUP_ID',
'and catalog_group_id = :P1924_CATALOG_GROUP_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Add a new Catalog'
,p_lov_cascade_parent_items=>'P1924_CATALOG_GROUP_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from WWV_WEB_SRC_CATALOG_GROUPS ',
'where security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the Catalog to which the service will be added. Choose Add a new Catalog if the service will not be added to an existing catalog.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28031435029072727)
,p_name=>'P1924_CATALOG_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(228564397587963139)
,p_prompt=>'New Catalog Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Catalog names are unique to a Workspace. Specify a name that does not already exist. '
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28031580237072728)
,p_name=>'P1924_MODULE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(228564397587963139)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28032538814072738)
,p_name=>'P1924_SERVICE_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(228564397587963139)
,p_prompt=>'REST Source Name'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The name under which the REST Data Source will be listed in the Catalog. If the catalog already contains a service with that name, it will be overwritten.'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(28030948212072722)
,p_name=>'Cancel Button'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2701279242636205)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(28031014763072723)
,p_event_id=>wwv_flow_imp.id(28030948212072722)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(28031795691072730)
,p_name=>'Catalog Group ID is null'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1924_CATALOG_GROUP_ID'
,p_condition_element=>'P1924_CATALOG_GROUP_ID'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(28032148853072734)
,p_event_id=>wwv_flow_imp.id(28031795691072730)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1924_CATALOG_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(28031838631072731)
,p_event_id=>wwv_flow_imp.id(28031795691072730)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1924_CATALOG_GROUP_NAME,P1924_CATALOG_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(28031977845072732)
,p_event_id=>wwv_flow_imp.id(28031795691072730)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1924_CATALOG_GROUP_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(28032033019072733)
,p_event_id=>wwv_flow_imp.id(28031795691072730)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1924_CATALOG_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(28032255431072735)
,p_name=>'Catalog Changed'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1924_CATALOG_ID'
,p_condition_element=>'P1924_CATALOG_ID'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(28032387107072736)
,p_event_id=>wwv_flow_imp.id(28032255431072735)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1924_CATALOG_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(28032467891072737)
,p_event_id=>wwv_flow_imp.id(28032255431072735)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1924_CATALOG_NAME'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(28031695172072729)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Import from REST Source'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- there are three scenarios that can happen:',
'-- 1. New Group and New Catalog',
'-- 2. Existing Group and New Catalog',
'-- 3. Existing Group and Existing Catalog ',
'if :P1924_CATALOG_GROUP_ID is null and :P1924_CATALOG_ID is null then',
'    wwv_web_src_catalog.import_from_rest_source (',
'        p_module_id             => :P1924_MODULE_ID,',
'        --',
'        p_group_name            => :P1924_CATALOG_GROUP_NAME,',
'        p_catalog_name          => :P1924_CATALOG_NAME, ',
'        p_catalog_internal_name => :P1924_CATALOG_NAME',
'        );',
'elsif :P1924_CATALOG_GROUP_ID is not null and :P1924_CATALOG_ID is null then',
'    wwv_web_src_catalog.import_from_rest_source (',
'        p_module_id             => :P1924_MODULE_ID,',
'        --',
'        p_group_id              => :P1924_CATALOG_GROUP_ID,',
'        p_catalog_name          => :P1924_CATALOG_NAME, ',
'        p_catalog_internal_name => :P1924_CATALOG_NAME',
'        );',
'else',
'    wwv_web_src_catalog.import_from_rest_source (',
'        p_module_id             => :P1924_MODULE_ID,',
'        p_catalog_id            => :P1924_CATALOG_ID',
'        );',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2701535619636209)
,p_process_success_message=>'REST Data Source added to catalog successfully'
,p_internal_uid=>28031695172072729
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(28032677310072739)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Initialize Defaults'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_catalog_internal_name wwv_flow_web_src_modules.catalog_internal_name%type;',
'    l_catalog_service_name  wwv_flow_web_src_modules.catalog_service_name%type;',
'    --',
'    l_catalog_id            wwv_web_src_catalogs.id%type;',
'    l_catalog_service_id    wwv_web_src_catalog_services.id%type;',
'    l_group_id              wwv_web_src_catalog_groups.id%type;',
'begin',
'    --',
'    -- default the service name to be the same as the module name. Also determine whether this',
'    -- service actually was created based on the catalog. Then we will likely want to save it back',
'    -- to the same catalog.',
'    -- ',
'    select name, ',
'           catalog_internal_name, ',
'           catalog_service_name',
'      into :P1924_SERVICE_NAME, ',
'           l_catalog_internal_name,',
'           l_catalog_service_name',
'      from wwv_flow_web_src_modules ',
'     where id                = :P1924_MODULE_ID',
'       and flow_id           = :FB_FLOW_ID',
'       and security_group_id = :FLOW_SECURITY_GROUP_ID;',
'',
'    --',
'    -- If the REST Source points to a catalog, let''s fetch its details.',
'    --',
'    if l_catalog_internal_name is not null and l_catalog_service_name is not null then',
'        begin',
'            select id, ',
'                   catalog_group_id,',
'                   name',
'              into l_catalog_id, ',
'                   l_group_id,',
'                   :P1924_EXIST_CATALOG_NAME',
'              from wwv_web_src_catalogs',
'             where internal_name     = l_catalog_internal_name',
'               and security_group_id = :FLOW_SECURITY_GROUP_ID;',
'        exception',
'            when no_data_found then',
'                null; -- the referenced catalog is not present in the workspace; do nothing.',
'        end;',
'        if l_catalog_id is not null then',
'            begin',
'                select id',
'                  into l_catalog_service_id',
'                  from wwv_web_src_catalog_services',
'                 where name              = l_catalog_service_name',
'                   and catalog_id        = l_catalog_id',
'                   and security_group_id = :FLOW_SECURITY_GROUP_ID;',
'            exception',
'                when no_data_found then',
'                    null; -- the catalog is there, but the referenced service does not exist; do nothing.',
'            end;',
'        end if;',
'    end if;',
'    --',
'    -- we did not find the catalog service, which the REST Data Source points to.',
'    --',
'    if l_catalog_id is null or l_group_id is null then',
'        begin',
'            select id, ',
'                   catalog_group_id',
'              into l_catalog_id, ',
'                   l_group_id',
'              from wwv_web_src_catalogs',
'             where security_group_id = :FLOW_SECURITY_GROUP_ID',
'               and rownum = 1;',
'        exception',
'            when no_data_found then',
'                null; -- we don''t have any catalog or group, so all variables remain empty.',
'        end;       ',
'    end if;',
'',
'    :P1924_CATALOG_GROUP_ID   := l_group_id;',
'    :P1924_CATALOG_ID         := l_catalog_id;',
'    :P1924_CATALOG_SERVICE_ID := l_catalog_service_id;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>28032677310072739
);
end;
/
prompt --application/pages/page_01925
begin
wwv_flow_imp_page.create_page(
 p_id=>1925
,p_name=>'Data Profile'
,p_alias=>'DATA-PROFILE'
,p_step_title=>'Data Profile'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$(function() {',
'    // listen for view change events to find out when grid views are created ',
'    $("#profile_columns").on("interactivegridviewchange", function(event, data) {',
'        if ( data.view === "grid" && data.created ) {',
'            var view = apex.region("profile_columns").widget().interactiveGrid("getViews", "grid"),',
'                menu$ = view.selActionMenu$;',
'',
'            menu$.menu("option").items.push({',
'                type:"action",',
'                label:apex.lang.formatMessage("APEX.WEBSRC.HIDE_COLUMNS"),',
'                action: function(menu, element) {',
'                    var i, records = view.getSelectedRecords(),',
'                        total = 0;',
'                    for ( i = 0; i < records.length; i++) {',
'                        view.model.setValue(records[i], "IS_HIDDEN", "Y" );',
'                    }',
'                }',
'            });',
'            menu$.menu("option").items.push({',
'                type:"action",',
'                label:apex.lang.formatMessage("APEX.WEBSRC.SHOW_COLUMNS"),',
'                action: function(menu, element) {',
'                    var i, records = view.getSelectedRecords(),',
'                        total = 0;',
'                    for ( i = 0; i < records.length; i++) {',
'                        view.model.setValue(records[i], "IS_HIDDEN", "N" );',
'                    }',
'                }',
'            });',
'',
'        }',
'    });',
'});'))
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_css_classes=>'ui-dialog--stretch'
,p_page_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_read_only_when=>'P1925_REFERENCE_ID'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1643198339019603)
,p_plug_name=>'Rediscovery'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P1925_IS_WEB_SRC_PROFILE'
,p_plug_display_when_cond2=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2241366915021519)
,p_plug_name=>'RDS'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>5
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'USER')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6739830352595387)
,p_plug_name=>'Data Profile'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_04'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(225857161514926537)
,p_plug_name=>'Columns'
,p_region_name=>'profile_columns'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c.id,',
'       c.rowid,',
'       c.flow_id,',
'       c.data_profile_id,',
'       c.name,',
'       c.sequence,',
'       c.is_primary_key,',
'       c.is_hidden,',
'       c.is_common,',
'       c.data_type,',
'       c.max_length,',
'       c.column_type,',
'       (select pc.name ',
'          from wwv_flow_data_profile_cols pc',
'         where pc.security_group_id = :FLOW_SECURITY_GROUP_ID',
'           and pc.data_profile_id   = :P1925_DATA_PROFILE_ID',
'           and pc.id                = c.parent_column_id ) as parent_column,',
'       c.selector_type,',
'       c.selector as definition,',
'       case when :P1925_CAN_DELETE_COLUMNS = ''N'' then ''U'' else ''UD'' end as allowed_operations',
'  from wwv_flow_data_profile_cols c',
' where c.flow_id           = :FB_FLOW_ID',
'   and c.data_profile_id   = :P1925_DATA_PROFILE_ID',
'   and c.security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_plug_source_type=>'NATIVE_IG'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1534804987420625)
,p_name=>'IS_COMMON'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'IS_COMMON'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_YES_NO'
,p_heading=>'Common'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>110
,p_value_alignment=>'LEFT'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
,p_attribute_03=>'Yes'
,p_attribute_04=>'N'
,p_attribute_05=>'No'
,p_is_required=>true
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'Y'
,p_duplicate_value=>true
,p_include_in_export=>true
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_condition=>'P1925_IS_WEB_SRC_PROFILE'
,p_display_condition2=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Determines whether this column is a common column. ',
'The &PRODUCT_NAME. Create Page wizards will only consider common columns when creating a new component. ',
'However, Page Designer will always work with all visible columns.'))
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1686123153640328)
,p_name=>'MAX_LENGTH'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'MAX_LENGTH'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>170
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2242321304021529)
,p_name=>'PARENT_COLUMN'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'PARENT_COLUMN'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Parent Column'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>180
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>true
,p_display_condition_type=>'EXPRESSION'
,p_display_condition=>':P1925_IS_WEB_SRC_PROFILE = ''Y'' and :P1925_FORMAT = ''JSON'''
,p_display_condition2=>'PLSQL'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Name of the <em>parent array column</em>, if this column represents an attribute ',
'    of a <em>Nested Array</em> in the JSON response.</p>'))
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(4703873828940034)
,p_name=>'SELECTOR_TYPE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'SELECTOR_TYPE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Selector Type'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>140
,p_value_alignment=>'LEFT'
,p_is_required=>false
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(5203249727555533)
,p_lov_display_extra=>false
,p_lov_display_null=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'NAME'
,p_duplicate_value=>true
,p_include_in_export=>true
,p_display_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_display_condition=>'P1925_FORMAT'
,p_display_condition2=>'CSV:XLSX'
,p_readonly_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_readonly_condition=>'COLUMN_TYPE'
,p_readonly_condition2=>'DATA'
,p_readonly_for_each_row=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(90119705622448646)
,p_name=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FLOW_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>160
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'FB_FLOW_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(226686705372475229)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_LINK'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>10
,p_value_alignment=>'CENTER'
,p_link_target=>'javascript:apex.submit({request:"APPLY_CHANGES_CREATE_1926_ID",set:{"P1925_COLUMN_ID":"&ID."}});'
,p_link_text=>'<span class="a-Icon icon-edit" aria-hidden="true"></span><span class="u-VisuallyHidden">Edit Column</span>'
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>false
,p_include_in_export=>false
,p_escape_on_http_output=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(226686811546475230)
,p_name=>'DATA_PROFILE_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DATA_PROFILE_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>50
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'P1925_DATA_PROFILE_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(226686952304475231)
,p_name=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>60
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_max_length=>128
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>true
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>'<p>Name under which the column is exposed to &PRODUCT_NAME. components.</p>'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(226687058522475232)
,p_name=>'SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'SEQUENCE'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>'Sequence'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>80
,p_value_alignment=>'RIGHT'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
,p_is_required=>true
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(226687176121475233)
,p_name=>'IS_PRIMARY_KEY'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'IS_PRIMARY_KEY'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_YES_NO'
,p_heading=>'Primary Key'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>90
,p_value_alignment=>'LEFT'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
,p_attribute_03=>'Yes'
,p_attribute_04=>'N'
,p_attribute_05=>'No'
,p_is_required=>true
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'N'
,p_duplicate_value=>true
,p_include_in_export=>false
,p_help_text=>'Specify whether this is a primary key column. A primary key can consist of multiple columns.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(226687236762475234)
,p_name=>'DATA_TYPE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DATA_TYPE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Data Type'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>70
,p_value_alignment=>'LEFT'
,p_is_required=>true
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(225929676126476839)
,p_lov_display_extra=>false
,p_lov_display_null=>true
,p_lov_null_text=>'- Select -'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Data type of the column which is exposed to APEX components.</p>'))
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(226687365646475235)
,p_name=>'ROWID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ROWID'
,p_data_type=>'ROWID'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>40
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_control_break=>false
,p_enable_hide=>true
,p_is_primary_key=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(226687497143475236)
,p_name=>'APEX$ROW_ACTION'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>30
,p_use_as_row_header=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(226687542527475237)
,p_name=>'APEX$ROW_SELECTOR'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>20
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_use_as_row_header=>false
,p_enable_hide=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(238756746319331840)
,p_name=>'COLUMN_TYPE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'COLUMN_TYPE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Column Type'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>130
,p_value_alignment=>'LEFT'
,p_is_required=>false
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(242159593404725778)
,p_lov_display_extra=>false
,p_lov_display_null=>true
,p_lov_null_text=>'- Select -'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'DATA'
,p_duplicate_value=>true
,p_include_in_export=>true
,p_readonly_condition_type=>'ALWAYS'
,p_readonly_for_each_row=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Type of the profile column. Possible Values are:',
'</p>',
'<ul>',
'    <li><strong>Data</strong> column values are directly extracted from the source data (uploaded data or REST Source response). A <strong>Data</strong> column always requires the <strong>Selector</strong> attribute to be set.</li>',
'    <li><strong>Lookup</strong> columns are used to "look up" a value from a table, based on (another) <strong>Data</strong> column. For instance, a lookup can be defined to return the <strong>DEPTNO</strong> value from the <strong>DEPT</strong> tabl'
||'e, based on the value of the <strong>DNAME</strong> Data Column.',
'    </li>',
'    <li><strong>SQL Expression</strong> columns compute a value based on other <strong>Data Columns</strong> using a SQL Expression.</li>',
'    <li><strong>SQL Query</strong> columns will execute a SQL query, which references other <strong>Data Columns</strong> in order to retrieve a value.</li>',
'</ul> '))
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(241340995165308320)
,p_name=>'ALLOWED_OPERATIONS'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ALLOWED_OPERATIONS'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>120
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(241343315925308344)
,p_name=>'DEFINITION'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DEFINITION'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Selector'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>150
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>255
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_readonly_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_readonly_condition=>'COLUMN_TYPE'
,p_readonly_condition2=>'DATA'
,p_readonly_for_each_row=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The <strong>Selector</strong> expression is being used to extract the column value from the source data.',
'<ul>',
'    <li>For <strong>XML</strong> and <strong>JSON</strong> formats, this selector is <em>relative</em> to the <strong>Row Selector</strong> which is configured at the data profile level. Use XPath-Syntax for XML, and JSON path expressions for JSON fo'
||'rmats.</li>',
'    <li>For <strong>CSV</strong> or <strong>XLSX</strong>, use the column name, sequence or a regular expression, based on the <strong>Selector Type</strong> attribute. Note that column names and regular expressions are matched in a <em>case-insensit'
||'ive</em> manner for CSV and XLSX files.</li> ',
'</ul>'))
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3403059846974708615)
,p_name=>'IS_HIDDEN'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'IS_HIDDEN'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_YES_NO'
,p_heading=>'Visible'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>100
,p_value_alignment=>'LEFT'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'Yes'
,p_attribute_04=>'Y'
,p_attribute_05=>'No'
,p_is_required=>true
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'N'
,p_duplicate_value=>true
,p_include_in_export=>true
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_condition=>'P1925_IS_WEB_SRC_PROFILE'
,p_display_condition2=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify whether this is <em>visible</em> or not. ',
'Invisible columns will not be displayed in Page Designer and can therefore ',
'not be chosen for &PRODUCT_NAME. components. However, if an invisible column is ',
'being referenced by a component, the component will work as expected.',
''))
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(226686688953475228)
,p_internal_uid=>226686688953475228
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_edit_row_operations_column=>'ALLOWED_OPERATIONS'
,p_lost_update_check_type=>'VALUES'
,p_add_row_if_empty=>false
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>true
,p_no_data_found_message=>'No columns defined.'
,p_show_toolbar=>true
,p_toolbar_buttons=>'SEARCH_FIELD'
,p_add_button_label=>'Add Data Column'
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>false
,p_define_chart_view=>false
,p_enable_download=>true
,p_download_formats=>'HTML'
,p_enable_mail_download=>false
,p_fixed_header=>'REGION'
,p_fixed_header_max_height=>500
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(229170045038968477)
,p_interactive_grid_id=>wwv_flow_imp.id(226686688953475228)
,p_static_id=>'6539'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(229170133297968486)
,p_report_id=>wwv_flow_imp.id(229170045038968477)
,p_view_type=>'GRID'
,p_stretch_columns=>true
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1499647437543838)
,p_view_id=>wwv_flow_imp.id(229170133297968486)
,p_display_seq=>15
,p_column_id=>wwv_flow_imp.id(1686123153640328)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3336345838335793)
,p_view_id=>wwv_flow_imp.id(229170133297968486)
,p_display_seq=>17
,p_column_id=>wwv_flow_imp.id(2242321304021529)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3945040870148932)
,p_view_id=>wwv_flow_imp.id(229170133297968486)
,p_display_seq=>16
,p_column_id=>wwv_flow_imp.id(1534804987420625)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5214117909877661)
,p_view_id=>wwv_flow_imp.id(229170133297968486)
,p_display_seq=>8
,p_column_id=>wwv_flow_imp.id(4703873828940034)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(119643154305445325)
,p_view_id=>wwv_flow_imp.id(229170133297968486)
,p_display_seq=>14
,p_column_id=>wwv_flow_imp.id(90119705622448646)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(229170664432968510)
,p_view_id=>wwv_flow_imp.id(229170133297968486)
,p_display_seq=>2
,p_column_id=>wwv_flow_imp.id(226686705372475229)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>54
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(229171193545968522)
,p_view_id=>wwv_flow_imp.id(229170133297968486)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(226686811546475230)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(229171662739968525)
,p_view_id=>wwv_flow_imp.id(229170133297968486)
,p_display_seq=>5
,p_column_id=>wwv_flow_imp.id(226686952304475231)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(229172110145968527)
,p_view_id=>wwv_flow_imp.id(229170133297968486)
,p_display_seq=>4
,p_column_id=>wwv_flow_imp.id(226687058522475232)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>102
,p_sort_order=>1
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(229172615629968529)
,p_view_id=>wwv_flow_imp.id(229170133297968486)
,p_display_seq=>10
,p_column_id=>wwv_flow_imp.id(226687176121475233)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(229173101952968531)
,p_view_id=>wwv_flow_imp.id(229170133297968486)
,p_display_seq=>7
,p_column_id=>wwv_flow_imp.id(226687236762475234)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(229175048984977346)
,p_view_id=>wwv_flow_imp.id(229170133297968486)
,p_display_seq=>11
,p_column_id=>wwv_flow_imp.id(226687365646475235)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(229175447879977349)
,p_view_id=>wwv_flow_imp.id(229170133297968486)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(226687497143475236)
,p_is_visible=>true
,p_is_frozen=>true
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(229388045023266054)
,p_view_id=>wwv_flow_imp.id(229170133297968486)
,p_display_seq=>12
,p_column_id=>wwv_flow_imp.id(3403059846974708615)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(241876077152231221)
,p_view_id=>wwv_flow_imp.id(229170133297968486)
,p_display_seq=>13
,p_column_id=>wwv_flow_imp.id(241340995165308320)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(242161531022729786)
,p_view_id=>wwv_flow_imp.id(229170133297968486)
,p_display_seq=>6
,p_column_id=>wwv_flow_imp.id(238756746319331840)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(310156322427385906)
,p_view_id=>wwv_flow_imp.id(229170133297968486)
,p_display_seq=>9
,p_column_id=>wwv_flow_imp.id(241343315925308344)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(225858059630926546)
,p_plug_name=>'Settings'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(225897994729244504)
,p_plug_name=>'Advanced'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(225899174154244516)
,p_plug_name=>'Data Profile'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'<strong>Data Profiles</strong> describe how Data Source format are being parsed and converted to rows and columns. For XML or JSON data format, the <strong>Row Selector</strong> attribute stores an XML or JSON path expression pointing to the node con'
||'taining the collection of rows. <strong>Data Profile Columns</strong> determine how one row is parsed and converted to multiple columns.',
'</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(225950605461615710)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(225857161514926537)
,p_button_name=>'RESEQUENCE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Resequence Columns'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'javascript:apex.submit({request:"APPLY_CHANGES_RESEQUENCE"});'
,p_confirm_message=>'Data Profile columns will be re-sequenced by steps of 10. Do you want to continue?'
,p_confirm_style=>'information'
,p_button_condition=>'P1925_REFERENCE_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(529291733256976411)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1643198339019603)
,p_button_name=>'REDISCOVER'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Rediscover Data Profile'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'javascript:apex.submit({request:"APPLY_CHANGES_REDISCOVER"});'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_web_src_operations',
' where web_src_module_id  = :P1921_WEB_SRC_MODULE_ID',
'   and flow_id            = :FB_FLOW_ID',
'   and security_group_id  = :FLOW_SECURITY_GROUP_ID',
'   and database_operation = ''FETCH_COLLECTION''',
'   and :P1925_REFERENCE_ID is null'))
,p_button_condition_type=>'EXISTS'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3403059643022708613)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(225857161514926537)
,p_button_name=>'ADD'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'Add Column'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'javascript:apex.submit({request:"APPLY_CHANGES_CREATE_1926_ADD"});'
,p_button_condition=>'P1925_REFERENCE_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(226688443210475246)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(6739830352595387)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&P1925_BACK_TO_PAGE.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(225899226130244517)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(6739830352595387)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>':P1925_DATA_PROFILE_ID is not null and not wwv_flow_page.is_read_only'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(119651831201549902)
,p_branch_name=>'Go To Page 1926 - ADD'
,p_branch_action=>'f?p=&APP_ID.:1926:&SESSION.::&DEBUG.:1926:P1926_DATA_PROFILE_ID,P1926_FLOW_ID,P1926_REFERENCE_ID:&P1925_DATA_PROFILE_ID.,&P1925_FLOW_ID.,&P1925_REFERENCE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_CREATE_1926_ADD'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(529291992121976413)
,p_branch_name=>'Go To Page 1948'
,p_branch_action=>'f?p=&APP_ID.:1948:&SESSION.::&DEBUG.:RP:P1948_WEB_SRC_MODULE_ID:&P1921_WEB_SRC_MODULE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_REDISCOVER'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1616163446502302)
,p_branch_name=>'Go To Page 1926 - EDIT'
,p_branch_action=>'f?p=&APP_ID.:1926:&SESSION.::&DEBUG.:RP,1926:P1926_DATA_PROFILE_ID,P1926_DATA_PROFILE_COLUMN_ID,P1926_REFERENCE_ID:&P1925_DATA_PROFILE_ID.,&P1925_COLUMN_ID.,&P1925_REFERENCE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_CREATE_1926_ID'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1976643656539733)
,p_branch_name=>'Go to page 1925'
,p_branch_action=>'f?p=&APP_ID.:1925:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(225899226130244517)
,p_branch_sequence=>40
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1925_RETURN_TO_PAGE'
,p_branch_condition_text=>'YES'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2242453673021530)
,p_branch_name=>'Go To Page &P1925_BACK_TO_PAGE.'
,p_branch_action=>'f?p=&APP_ID.:&P1925_BACK_TO_PAGE.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(225899226130244517)
,p_branch_sequence=>50
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1616213830502303)
,p_name=>'P1925_COLUMN_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(225857161514926537)
,p_display_as=>'NATIVE_HIDDEN'
,p_warn_on_unsaved_changes=>'I'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1643010183019602)
,p_name=>'P1925_SAMPLE_RESPONSE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1643198339019603)
,p_prompt=>'Sample Response'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'When rediscovering the Data Profile, a sample of the REST service response can be uploaded here. &PRODUCT_NAME. will parse this response instead of reaching out to the REST service. This can be used if the REST service cannot be reached or if require'
||'d authentication is not available during design time.'
,p_attribute_01=>'APEX_APPLICATION_TEMP_FILES'
,p_attribute_09=>'REQUEST'
,p_attribute_10=>'N'
,p_attribute_12=>'INLINE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1813920010055316)
,p_name=>'P1925_SINGLE_ROW_SELECTOR'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(225897994729244504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Single Row Selector'
,p_source=>'SINGLE_ROW_SELECTOR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>255
,p_display_when=>'P1925_IS_WEB_SRC_PROFILE'
,p_display_when2=>'Y'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    This is used for REST Services which return a JSON array or a simple object, based on the actual request. Enter the selector expression to select a single row from the REST Data Source response. ',
'</p>',
'<p>',
'    Example:',
'</p>',
'<ul>',
'    <li>A REST Service Endpoint returns a JSON array - the data profile returns a <strong>Table</strong><br>',
'        <code>http://{server}/path/service/emp</code><br>',
'        <pre>',
'{ "header": { "generated": "2018-10-19", "version": "1.0" },',
'  "body": { "items": [',
'          { "ename": "SMITH", "sal": 200 },',
'          { "ename": "SCOTT", "sal": 100 } ] } }        ',
'        </pre>',
'    </li>',
'    <li>When an identifier is added to the URL, only one row is returned:<br>',
'        <code>http://{server}/path/service/emp/<strong>SMITH</strong></code><br>',
'        <pre>',
'{ "header": { "generated": "2018-10-19", "version": "1.0" },',
'  "body":   { "ename": "SMITH", "sal": 200 } }',
'        </pre>',
'    </li>',
'</ul>',
'<p>',
'    In this case, use <strong>body</strong> as the <strong>Single Row Selector</strong>. The <strong>Row Selector</strong> attribute (above) should be set to <strong>body.items</strong>.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1976579617539732)
,p_name=>'P1925_RETURN_TO_PAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(225899174154244516)
,p_prompt=>'Stay on page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select this checkbox to stay on this page after applying changes.'
,p_attribute_01=>'N'
,p_attribute_02=>'YES'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2241459934021520)
,p_name=>'P1925_BACK_TO_PAGE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(225858059630926546)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2563962992654037)
,p_name=>'P1925_IS_WEB_SRC_PROFILE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(225858059630926546)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5525887347830105)
,p_name=>'P1925_USE_RAW_JSON_SELECTORS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(225897994729244504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Use Raw Selectors'
,p_source=>'USE_RAW_JSON_SELECTORS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    If enabled, &PRODUCT_NAME. will not sanitize row and column selectors when generating the SQL query for JSON parsing. ',
'    All selectors will be used exactly as specified.',
'</p>'))
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7124783422468901)
,p_name=>'P1925_CSV_SEPARATOR'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(225897994729244504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Column Delimiter'
,p_source=>'CSV_SEPARATOR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'DATA.LOAD.CSV_COL_DELIMITER'
,p_lov=>'.'||wwv_flow_imp.id(1963861252255121)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'None (Auto Detect)'
,p_cSize=>20
,p_cMaxlength=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Select a column delimiter character. If not specified, &PRODUCT_NAME. will automatically detect one of the following characters, based on the occurrence count in the first line.',
'</p>',
'<ul>',
'<li>;</li>',
'<li>,</li>',
'<li>|</li>',
'<li>#</li>',
'<li>[tab]</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7124845259468902)
,p_name=>'P1925_CSV_ENCLOSED'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(225897994729244504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Optionally Enclosed By'
,p_source=>'CSV_ENCLOSED'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'DATA.LOAD.CSV_ENCLOSED_BY'
,p_lov=>'.'||wwv_flow_imp.id(1966044064255150)||'.'
,p_cSize=>20
,p_cMaxlength=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select a column enclosed by character.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7124913659468903)
,p_name=>'P1925_DEFAULT_XLSX_SHEET_NAME'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(225897994729244504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Default Sheet Name'
,p_source=>'DEFAULT_XLSX_SHEET_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the name of the XLSX worksheet to parse by default. If not defined, data loading will use the first worksheet found.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7125069346468904)
,p_name=>'P1925_SKIP_ROWS'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(225897994729244504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Skip Rows'
,p_source=>'SKIP_ROWS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>5
,p_cMaxlength=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Enter how many rows to skip from the beginning of the file, before data parsing starts.</p> '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7125133422468905)
,p_name=>'P1925_HAS_HEADER_ROW'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(225897994729244504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'First Line Contains Headers'
,p_source=>'HAS_HEADER_ROW'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enable this option for CSV or XLSX data profiles, if the data contains column names in the first row.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(16494794969178008)
,p_name=>'P1925_REFERENCE_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(225858059630926546)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225858181421926547)
,p_name=>'P1925_DATA_PROFILE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(225858059630926546)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225858472747926550)
,p_name=>'P1925_FLOW_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(225858059630926546)
,p_use_cache_before_default=>'NO'
,p_item_default=>'FB_FLOW_ID'
,p_item_default_type=>'ITEM'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225897751791244502)
,p_name=>'P1925_NAME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(225858059630926546)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a name for the data profile.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225897810804244503)
,p_name=>'P1925_FORMAT'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(225858059630926546)
,p_use_cache_before_default=>'NO'
,p_item_default=>'JSON'
,p_prompt=>'Format'
,p_source=>'FORMAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1925_DATA_PROFILE_FORMAT'
,p_lov=>'.'||wwv_flow_imp.id(607713258081514419)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P1925_IS_WEB_SRC_PROFILE = ''N'' then',
'    for l_data_load in (',
'        select id',
'        from wwv_flow_load_tables',
'        where data_profile_id = :P1925_DATA_PROFILE_ID',
'        and flow_id = :FB_FLOW_ID',
'        and security_group_id = :WORKSPACE_ID )',
'    loop',
'        if wwv_flow_data_loader_dev.is_data_load_used(',
'            p_application_id => :FB_FLOW_ID,',
'            p_data_load_id   => l_data_load.id ) then',
'            return true;',
'        end if;',
'    end loop;',
'end if;',
'return false;'))
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Choose the data format. For Data Loading, CSV, JSON, XLSX and XML formats are supported. For REST Data Sources, JSON, XML and CSV can be chosen.',
'    </p>',
'    <p>For usage with a REST Data Source, the CSV response must contain column headers as the first row.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225898074590244505)
,p_name=>'P1925_ENCODING'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(225897994729244504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Encoding'
,p_source=>'ENCODING'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_IANA_CHARSET'
,p_lov=>'.'||wwv_flow_imp.id(144796827445692396)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Default -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose an encoding of the data. Use <strong>Default</strong> to treat the file as encoded in the <em>database character set</em>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225898168261244506)
,p_name=>'P1925_DECIMAL_CHARACTERS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(225897994729244504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Numeric Characters'
,p_source=>'DECIMAL_CHARACTERS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>2
,p_cMaxlength=>2
,p_tag_attributes=>'style="font-family: monospace"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Enter the numeric characters to be used for parsing numeric data types. If nothing is specified, "." will be used as the decimal character for XML and JSON data profiles, and the session defaults will be used for CSV and XLSX data profiles. ',
'</p>',
'<p>',
'This attribute acts as a default for all columns; each column can have individual overrides.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225898285554244507)
,p_name=>'P1925_IS_SINGLE_ROW'
,p_is_required=>true
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(225858059630926546)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Contains Single Row'
,p_source=>'IS_SINGLE_ROW'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>'P1925_IS_WEB_SRC_PROFILE'
,p_display_when2=>'Y'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Choose <strong>On</strong> if the response <em>always</em> contains only one row - and no collection. Choose <strong>Off</strong> if the response contains a collection of rows.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225898330426244508)
,p_name=>'P1925_XML_NAMESPACES'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(225897994729244504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'XML Namespaces'
,p_source=>'XML_NAMESPACES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Enter namespace information to parse XML responses here. Use the following format:',
'</p>',
'<pre>',
'<em>namespace-uri-1</em>=<em>namespace-prefix-1</em><em>CR</em>',
'<em>namespace-uri-2</em>=<em>namespace-prefix-2</em><em>CR</em>',
':',
'</pre>',
'<h2>',
'    Example:',
'</h2>',
'<pre>',
'http://xmlns.oracle.com/xdb=<strong>xdb</strong>',
'http://www.w3.org/2005/Atom=<strong>atom</strong>',
'</pre>',
'<p>',
'    Defined namespace prefixes can be used in data profile row and column selectors.',
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225898750991244512)
,p_name=>'P1925_PROFILE_COMMENT'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(225897994729244504)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Profile Comment'
,p_source=>'PROFILE_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter any developer comments or notes here. These comments only display within App Builder and never display when running the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(226131367554626803)
,p_name=>'P1925_ROW_SELECTOR'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(225858059630926546)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Row Selector'
,p_source=>'ROW_SELECTOR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    For a data profile returning a table, enter the expression to select the collection of rows within the Data Source. The rows collection is typically a JSON array or XML <em>collection</em> (in XML a sequence of tags with the same name). Nested ar'
||'rays or nested XML <em>collections</em> are not supported.',
'</p>',
'<p>',
'    If the row selector ',
'    references a single JSON object or an XML tag which is not a collection, the <strong>Contains Single Row</strong> data profile attribute must be set to <strong>Yes</strong>. Leave the attribute empty or enter <strong>"."</strong>, if the JSON arr'
||'ay or object is at the root level. ',
'</p>',
'<h2>',
'    Example 1:',
'</h2>',
'<pre>',
'{ "items": [',
'    { "ename": "SMITH", "sal": 200 },',
'    { "ename": "SCOTT", "sal": 100 } ] }',
'</pre>',
'<p>',
'    The JSON attribute contains an array in the <strong>items</strong> attribute, so choose that as the row selector. An element within that array will be considered as a row and each attribute will be considered as a column.',
'</p>',
'<h2>',
'    Example 2:',
'</h2>',
'<pre>',
'{ "header": { "generated": "2018-10-19", "version": "1.0" },',
'  "body": { "items": [',
'          { "ename": "SMITH", "sal": 200 },',
'          { "ename": "SCOTT", "sal": 100 } ] } }',
'</pre>',
'<p>',
'    The JSON attribute contains an array in the <strong>body.items</strong> attribute, so choose that as the row selector. An element within that array will be considered as a row and each attribute will be considered as a column.',
'</p>',
' <h2>',
'    Example 3:',
'</h2>',
'<pre>',
'&lt;xml-document&gt;',
'  &lt;row&gt;',
'    &lt;ename&gt;SMITH&lt;/ename&gt;&lt;sal&gt;200&lt;/sal&gt;',
'  &lt;/row&gt;',
'  &lt;row&gt;',
'    &lt;ename&gt;SCOTT&lt;/ename&gt;&lt;sal&gt;100&lt;/sal&gt;',
'  &lt;/row&gt;',
'&lt;xml-document&gt;',
'</pre>   ',
'    <p>',
'    The XML tag attribute <strong>/xml-document/row</strong> contains a <em>collection</em>, so choose that as the row selector. Each <strong>row</strong> object will be considered as a row and each child tag of &lt;row&gt; will be considered as a co'
||'lumn.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(241340865499308319)
,p_name=>'P1925_CAN_DELETE_COLUMNS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(225857161514926537)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(7127782300468931)
,p_computation_sequence=>20
,p_computation_item=>'P1925_CSV_ENCLOSED'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P1925_CSV_ENCLOSED'
,p_compute_when_text=>'None'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(4502694639479010)
,p_computation_sequence=>30
,p_computation_item=>'P1925_CSV_SEPARATOR'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'chr(9)'
,p_compute_when=>'P1925_CSV_SEPARATOR'
,p_compute_when_text=>'tab'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2564014108654038)
,p_computation_sequence=>10
,p_computation_item=>'P1925_IS_WEB_SRC_PROFILE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_web_src in (',
'    select id ',
'    from wwv_flow_web_src_modules',
'    where flow_id = :FB_FLOW_ID',
'    and security_group_id = :FLOW_SECURITY_GROUP_ID',
'    and data_profile_id = :P1925_DATA_PROFILE_ID )',
'loop',
'    return ''Y'';',
'end loop;',
'return ''N'';'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(241341016963308321)
,p_computation_sequence=>10
,p_computation_item=>'P1925_CAN_DELETE_COLUMNS'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''N'' as can_delete from dual where  exists( ',
'    select r.id ',
'      from wwv_flow_page_plugs r, wwv_flow_web_src_modules m',
'     where m.data_profile_id   = :P1925_DATA_PROFILE_ID',
'       and m.id                = r.web_src_module_id',
'       and m.security_group_id = r.security_group_id',
'       and m.flow_id           = r.flow_id',
'       and m.flow_id           = :FB_FLOW_ID )    '))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(225950528415615709)
,p_validation_name=>'Numeric Characters have length of 2'
,p_validation_sequence=>10
,p_validation=>'length( :P1925_DECIMAL_CHARACTERS ) = 2'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Numeric Characters must be exactly two characters, e.g. ".,"'
,p_associated_item=>wwv_flow_imp.id(225898168261244506)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(7126144693468915)
,p_validation_name=>'header row cannot be N if name selector exists'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_data_profile_cols',
'where flow_id = :FB_FLOW_ID',
'and security_group_id = :FLOW_SECURITY_GROUP_ID',
'and data_profile_id = :P1925_DATA_PROFILE_ID',
'and :P1925_FORMAT in ( ''CSV'', ''XLSX'' )',
'and column_type = ''DATA''',
'and selector_type = ''NAME'''))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'First Line Contains Headers cannot be disabled as there are columns based on Name selector type.'
,p_validation_condition=>'P1925_HAS_HEADER_ROW'
,p_validation_condition2=>'N'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(7125133422468905)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4502932146479013)
,p_tabular_form_region_id=>wwv_flow_imp.id(225857161514926537)
,p_validation_name=>'selector must be num and 1 to 300'
,p_validation_sequence=>40
,p_validation=>'wwv_flow_utilities.is_number( p_number => :DEFINITION ) and :DEFINITION between 1 and 300'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Selector must be numeric and number between 1 and 300.'
,p_validation_condition=>':DEFINITION is not null and :SELECTOR_TYPE = ''SEQ'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_exec_cond_for_each_row=>'Y'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(119651723174549901)
,p_tabular_form_region_id=>wwv_flow_imp.id(225857161514926537)
,p_validation_name=>'Selector must be non-NULL'
,p_validation_sequence=>50
,p_validation=>'DEFINITION'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>':COLUMN_TYPE  = ''DATA'' and nvl( :SELECTOR_TYPE, ''NAME'' ) in ( ''NAME'', ''SEQ'', ''REGEXP'' )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(225899226130244517)
,p_exec_cond_for_each_row=>'Y'
,p_associated_column=>'DEFINITION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1534985669420626)
,p_tabular_form_region_id=>wwv_flow_imp.id(225857161514926537)
,p_validation_name=>'ARRAY columns only allowed for JSON Data Profiles'
,p_validation_sequence=>60
,p_validation=>'DATA_TYPE'
,p_validation2=>'ARRAY'
,p_validation_type=>'ITEM_IN_VALIDATION_NOT_EQ_STRING2'
,p_error_message=>'Array Columns are only allowed for REST Sources returning JSON data.'
,p_validation_condition=>':P1925_FORMAT != ''JSON'' or :P1925_IS_WEB_SRC_PROFILE = ''N'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_exec_cond_for_each_row=>'Y'
,p_associated_column=>'DATA_TYPE'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(225898414627244509)
,p_name=>'XML Format chosen'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1925_FORMAT'
,p_condition_element=>'P1925_FORMAT'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'XML'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(225898564652244510)
,p_event_id=>wwv_flow_imp.id(225898414627244509)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1925_XML_NAMESPACES'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(225898648442244511)
,p_event_id=>wwv_flow_imp.id(225898414627244509)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1925_XML_NAMESPACES'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1814057496055317)
,p_name=>'Single Row Profile chosen'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1925_IS_SINGLE_ROW'
,p_condition_element=>'P1925_IS_SINGLE_ROW'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1814127997055318)
,p_event_id=>wwv_flow_imp.id(1814057496055317)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1925_SINGLE_ROW_SELECTOR'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1814244454055319)
,p_event_id=>wwv_flow_imp.id(1814057496055317)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1925_SINGLE_ROW_SELECTOR'
,p_client_condition_type=>'NOT_EQUALS'
,p_client_condition_element=>'P1925_FORMAT'
,p_client_condition_expression=>'CSV'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1814309221055320)
,p_event_id=>wwv_flow_imp.id(1814057496055317)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1925_SINGLE_ROW_SELECTOR'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5270198022575515)
,p_name=>'XML or JSON Format chosen'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1925_FORMAT'
,p_condition_element=>'P1925_FORMAT'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'XML, JSON'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5270202558575516)
,p_event_id=>wwv_flow_imp.id(5270198022575515)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1925_ROW_SELECTOR,P1925_IS_SINGLE_ROW,P1925_SINGLE_ROW_SELECTOR'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5270357968575517)
,p_event_id=>wwv_flow_imp.id(5270198022575515)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1925_ROW_SELECTOR'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(607706988479483807)
,p_event_id=>wwv_flow_imp.id(5270198022575515)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1925_IS_SINGLE_ROW'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(7125279847468906)
,p_name=>'CSV or XLSX Format chosen'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1925_FORMAT'
,p_condition_element=>'P1925_FORMAT'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'CSV, XLSX'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7125373053468907)
,p_event_id=>wwv_flow_imp.id(7125279847468906)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1925_SKIP_ROWS,P1925_HAS_HEADER_ROW'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7125459858468908)
,p_event_id=>wwv_flow_imp.id(7125279847468906)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1925_SKIP_ROWS,P1925_HAS_HEADER_ROW'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(7125568806468909)
,p_name=>'CSV Format chosen'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1925_FORMAT'
,p_condition_element=>'P1925_FORMAT'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'CSV'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7125673086468910)
,p_event_id=>wwv_flow_imp.id(7125568806468909)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1925_CSV_SEPARATOR,P1925_CSV_ENCLOSED'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7125723899468911)
,p_event_id=>wwv_flow_imp.id(7125568806468909)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1925_CSV_SEPARATOR,P1925_CSV_ENCLOSED'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(607706855360483806)
,p_event_id=>wwv_flow_imp.id(7125568806468909)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1925_IS_SINGLE_ROW,P1925_SINGLE_ROW_SELECTOR'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(7125845900468912)
,p_name=>'XLSX Format chosen'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1925_FORMAT'
,p_condition_element=>'P1925_FORMAT'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'XLSX'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7125920195468913)
,p_event_id=>wwv_flow_imp.id(7125845900468912)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1925_DEFAULT_XLSX_SHEET_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7126005707468914)
,p_event_id=>wwv_flow_imp.id(7125845900468912)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1925_DEFAULT_XLSX_SHEET_NAME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1736665844070603)
,p_name=>'JSON Format chosen'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1925_FORMAT'
,p_condition_element=>'P1925_FORMAT'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'JSON'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1736764655070604)
,p_event_id=>wwv_flow_imp.id(1736665844070603)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1925_USE_RAW_JSON_SELECTORS'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1736869274070605)
,p_event_id=>wwv_flow_imp.id(1736665844070603)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1925_USE_RAW_JSON_SELECTORS'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4502739754479011)
,p_name=>'set to tab if CSV sep is chr(9)'
,p_event_sequence=>90
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4502843850479012)
,p_event_id=>wwv_flow_imp.id(4502739754479011)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1925_CSV_SEPARATOR'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'tab'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_server_condition_type=>'EXPRESSION'
,p_server_condition_expr1=>':P1925_CSV_SEPARATOR = chr(9)'
,p_server_condition_expr2=>'PLSQL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1686265781640329)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(225857161514926537)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Handle MAX_LENGTH column'
,p_process_sql_clob=>':MAX_LENGTH := case when :DATA_TYPE = ''VARCHAR2'' then 4000 else null end;'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'SAVE,RESEQUENCE,ADD,REDISCOVER'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_exec_cond_for_each_row=>'Y'
,p_internal_uid=>1686265781640329
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(226687617423475238)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(225857161514926537)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Columns - Save Interactive Grid Data'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'SAVE,RESEQUENCE,ADD,REDISCOVER'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_exec_cond_for_each_row=>'Y'
,p_process_success_message=>'Data Profile column changes saved.'
,p_internal_uid=>226687617423475238
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(225950708073615711)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Re-Sequence Columns'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_data_profile_dev.resequence_columns(',
'        p_data_profile_id => :P1925_DATA_PROFILE_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'APPLY_CHANGES_RESEQUENCE'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>'Columns re-sequenced.'
,p_internal_uid=>225950708073615711
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1736975820070606)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set use_raw_selector value'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1925_USE_RAW_JSON_SELECTORS := case when :P1925_FORMAT = ''JSON'' then',
'                                     nvl( :P1925_USE_RAW_JSON_SELECTORS, ''N'' )',
'                                 end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>1736975820070606
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(225950382039615707)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process row of WWV_FLOW_DATA_PROFILES'
,p_attribute_02=>'WWV_FLOW_DATA_PROFILES'
,p_attribute_03=>'P1925_DATA_PROFILE_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id = :FLOW_SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Data Profile changes saved.'
,p_internal_uid=>225950382039615707
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(529291815946976412)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Rediscover'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_sample_response blob;',
'begin',
'    if :P1925_SAMPLE_RESPONSE is not null then',
'        select blob_content',
'          into l_sample_response',
'          from wwv_flow_temp_files',
'         where name = :P1925_SAMPLE_RESPONSE;',
'    end if;',
'    ',
'    wwv_flow_web_src_dev.rediscover( ',
'        p_web_src_module_id => :P1921_WEB_SRC_MODULE_ID,',
'        p_sample_response   => l_sample_response );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'APPLY_CHANGES_REDISCOVER'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>529291815946976412
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(225897653516244501)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch row of WWV_FLOW_DATA_PROFILES'
,p_attribute_02=>'WWV_FLOW_DATA_PROFILES'
,p_attribute_03=>'P1925_DATA_PROFILE_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id = :FLOW_SECURITY_GROUP_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>225897653516244501
);
end;
/
prompt --application/pages/page_01926
begin
wwv_flow_imp_page.create_page(
 p_id=>1926
,p_name=>'Data Profile Column'
,p_alias=>'DATA-PROFILE-COLUMN'
,p_step_title=>'Data Profile Column'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_css_classes=>'ui-dialog--stretch'
,p_page_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_read_only_when=>'P1926_REFERENCE_ID'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1922763094324838)
,p_plug_name=>'Settings'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2241689031021522)
,p_plug_name=>'Numeric Characters'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2849083857619015)
,p_plug_name=>'Comments'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>300
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4321474631183316)
,p_plug_name=>'Lookup'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(10039897504270539)
,p_plug_name=>'Data Profile Column'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>130
,p_plug_display_point=>'REGION_POSITION_04'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(225899656946244521)
,p_plug_name=>'Column'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(225900987898244534)
,p_plug_name=>'Data Profile Column'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Configure attributes of a single <strong>Data Profile Column</strong>: <strong>Data</strong> columns have a <strong>Selector</strong> and contain values directly extracted from source data. <strong>SQL Expression</strong>, <strong>SQL Query</stron'
||'g> or <strong>Lookup</strong> columns contain values derived from data columns using SQL expressions, SQL Queries or table lookups.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(225901106053244536)
,p_plug_name=>'Source'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4701992042940015)
,p_plug_name=>'Transformation'
,p_parent_plug_id=>wwv_flow_imp.id(225901106053244536)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>100
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(225902044106244545)
,p_plug_name=>'Advanced'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P1925_IS_WEB_SRC_PROFILE'
,p_plug_display_when_cond2=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2848941659619014)
,p_plug_name=>'Advanced Column Attributes'
,p_parent_plug_id=>wwv_flow_imp.id(225902044106244545)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1241617405377502706)
,p_plug_name=>'RDS'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(225901013547244535)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(10039897504270539)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1925:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(225902553246244550)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(10039897504270539)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1926_DATA_PROFILE_COLUMN_ID is null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1241617649309502708)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(225899656946244521)
,p_button_name=>'GET_PREV_COLUMN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Save and go to previous Column'
,p_button_position=>'NEXT'
,p_button_condition=>'P1926_PREV_COLUMN_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(225902339905244548)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(10039897504270539)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_confirm_message=>'Do you really want to delete this column?'
,p_confirm_style=>'danger'
,p_button_condition=>':P1926_DATA_PROFILE_COLUMN_ID is not null and :P1925_CAN_DELETE_COLUMNS is null and not wwv_flow_page.is_read_only'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1241617589928502707)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(225899656946244521)
,p_button_name=>'GET_NEXT_COLUMN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Save and go to next Column'
,p_button_position=>'NEXT'
,p_button_condition=>'P1926_NEXT_COLUMN_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(225902408094244549)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(10039897504270539)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1926_DATA_PROFILE_COLUMN_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1241618061274502712)
,p_branch_name=>'Next Column: Go to Page 1926'
,p_branch_action=>'f?p=&APP_ID.:1926:&SESSION.::&DEBUG.::P1926_DATA_PROFILE_COLUMN_ID:&P1926_NEXT_COLUMN_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(1241617589928502707)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1241618132666502713)
,p_branch_name=>'Prev Column: Go to Page 1926'
,p_branch_action=>'f?p=&APP_ID.:1926:&SESSION.::&DEBUG.::P1926_DATA_PROFILE_COLUMN_ID:&P1926_PREV_COLUMN_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(1241617649309502708)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1976840002539735)
,p_branch_name=>'Go To Page 1926'
,p_branch_action=>'f?p=&APP_ID.:1926:&SESSION.::&DEBUG.:RP,::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(225902408094244549)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1926_RETURN_TO_PAGE'
,p_branch_condition_text=>'YES'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(225950281133615706)
,p_branch_name=>'Go To Page 1925'
,p_branch_action=>'f?p=&APP_ID.:1925:&SESSION.::&DEBUG.:RP,1926::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1719176547469924)
,p_name=>'P1926_PARENT_COLUMN'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(225899656946244521)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Parent Column'
,p_source=>'PARENT_COLUMN_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select dpc.display_name,',
'       dpc.id',
'  from wwv_flow_web_src_arr_cols_dev dpc',
' where dpc.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and dpc.flow_id           = :FB_FLOW_ID',
'   and dpc.data_profile_id   = :P1926_DATA_PROFILE_ID   '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'None'
,p_cHeight=>1
,p_display_when=>'P1926_FORMAT'
,p_display_when2=>'JSON'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>If this column represents an attribute of a <em>Nested Array</em> in the JSON response, pick the array column this column belongs to.</p>',
'<p><em>Recursive nested arrays are not supported in a Data Profile.</em></p>'))
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1976797173539734)
,p_name=>'P1926_RETURN_TO_PAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(225900987898244534)
,p_prompt=>'Stay on page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_display_when=>'P1926_DATA_PROFILE_COLUMN_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select this checkbox to stay on this page after applying changes.'
,p_attribute_01=>'N'
,p_attribute_02=>'YES'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2103442653254230)
,p_name=>'P1926_IS_FILTERABLE'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(1922763094324838)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Filterable'
,p_source=>'IS_FILTERABLE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_colspan=>4
,p_display_when=>'P1925_IS_WEB_SRC_PROFILE'
,p_display_when2=>'Y'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Determines whether this column can be filtered on the server. '
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2242187235021527)
,p_name=>'P1926_IS_COMMON'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(1922763094324838)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Common'
,p_source=>'IS_COMMON'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_colspan=>4
,p_display_when=>'P1925_IS_WEB_SRC_PROFILE'
,p_display_when2=>'Y'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Determines whether this column is a common column. ',
'The &PRODUCT_NAME. Create Page wizards will only consider common columns when creating a new component. ',
'However, Page Designer will always work with all visible columns.'))
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2268458787169762)
,p_name=>'P1926_VALIDATION_REGEXP'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(225899656946244521)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Validation Regular Expression'
,p_source=>'VALIDATION_REGEXP'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>75
,p_cMaxlength=>255
,p_display_when=>'P1925_IS_WEB_SRC_PROFILE'
,p_display_when2=>'Y'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Regular expression to validate the value of this column before processing and sending to the REST endpoint in a DML operation.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2847725221619002)
,p_name=>'P1926_IS_LINE_NUMBER'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(1922763094324838)
,p_item_default=>'N'
,p_prompt=>'Line Number'
,p_display_as=>'NATIVE_YES_NO'
,p_colspan=>4
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_data_profiles',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and id                = :P1926_DATA_PROFILE_ID',
'   and format            in (''XML'', ''JSON'' )',
'   and is_single_row     = ''Y'''))
,p_display_when_type=>'NOT_EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Indicates that this column returns the line number of row in the source data. For an XLSX or CSV file, this is the row within the file, for XML or JSON files this is the row''s array index.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2850224834619027)
,p_name=>'P1926_TABLE_SELECTOR_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(225901106053244536)
,p_use_cache_before_default=>'NO'
,p_source=>'SELECTOR_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4129758754556618)
,p_name=>'P1926_ADDITIONAL_INFO'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(2848941659619014)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Additional Information'
,p_source=>'ADDITIONAL_INFO'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>75
,p_cMaxlength=>4000
,p_display_when=>'P1925_IS_WEB_SRC_PROFILE'
,p_display_when2=>'Y'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'If specified, this additional information may be used by REST Plug-in implementations to inform how they interact with the REST endpoint. For example, a data profile column of an Oracle Cloud Applications (SaaS) REST Service data source may use a com'
||'ma-separated list of case-sensitive tags like <code>RemotePK</code>, <code>HasDefault</code>, <code>Required</code>, and either <code>CreateOnly</code> or <code>ReadOnly</code>.',
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4321281549183314)
,p_name=>'P1926_DECIMAL_CHAR'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2241689031021522)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Decimal Character'
,p_source=>'DECIMAL_CHAR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>5
,p_cMaxlength=>1
,p_tag_attributes=>'style="font-family: monospace"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Enter the decimal character to be used for parsing numeric data types. This value overrides the <strong>Numeric Characters</strong> attribute specified at the data profile level. ',
'</p>',
'<p>',
'If nothing is specified, "." will be used for XML and JSON data profiles, and the current session NLS settings will be used for CSV and XLSX data profiles. ',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4321336252183315)
,p_name=>'P1926_GROUP_CHAR'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2241689031021522)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Group Character'
,p_source=>'GROUP_CHAR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>5
,p_cMaxlength=>1
,p_tag_attributes=>'style="font-family: monospace"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Enter the group character to be used for parsing numeric data types. This value overrides the <strong>Numeric Characters</strong> attribute specified at the data profile level. ',
'</p>',
'<p>',
'If nothing is specified, no value will be used for XML and JSON data profiles, and the current session NLS settings will be used for CSV and XLSX data profiles. ',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4321508502183317)
,p_name=>'P1926_LOOKUP_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(4321474631183316)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Owner'
,p_source=>'LOOKUP_OWNER'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_SCHEMAS_HAVE_PRIVS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(owner) d, owner v',
'  from wwv_flow_object_owners_dev',
'order by d                   '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Parsing Schema -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Specify the owner of the lookup table.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4321628443183318)
,p_name=>'P1926_LOOKUP_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(4321474631183316)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Table Name'
,p_source=>'LOOKUP_TABLE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = coalesce( :P1926_LOOKUP_OWNER, upper(wwv_flow_wizard_api.get_flow_owner(:FB_FLOW_ID)))'))
,p_lov_display_null=>'YES'
,p_lov_cascade_parent_items=>'P1926_LOOKUP_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>60
,p_cMaxlength=>128
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify the name of the lookup table.</p>',
'<p><strong>Example:</strong></p>',
'<pre>',
'ENAME  EMPNO  SAL    DNAME',
'------ ------ ------ ------------',
'  7839 KING     5000 ACCOUNTING',
'  7788 SCOTT    3000 RESEARCH',
'     : :           : :',
'</pre>',
'<ul>',
'<li>Configure the <strong>DNAME_LOADED</strong> column, as a <strong>Data</strong> column with the selector of <strong>DNAME</strong>, or <strong>4</strong> (based on the selector type).</li>',
'<li>Use <strong>DEPTNO</strong> as the data profile column name and <strong>Lookup</strong> as the column type.</li>',
'<li>Use <strong>DEPT</strong> as the <strong>Table Name</strong></li>',
'<li>Use <strong>DEPTNO</strong> as the <strong>Return Column</strong></li>',
'<li>Use <strong>DNAME</strong> is the <strong>Table Column 1</strong></li>',
'<li><strong>DNAME_LOADED</strong> is the <strong>Data Column 1</strong>. Note that this references the data profile column which contains the actually uploaded data.</li>',
'</ul>',
'<p>',
'<br>',
'As a result, &PRODUCT_NAME. will look up <strong>DEPTNO</strong> values from the <strong>DEPT</strong> table, using the uploaded <strong>DNAME</strong> values. These will be uploaded as the <strong>DEPTNO</strong> column of the target table.',
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4321734839183319)
,p_name=>'P1926_LOOKUP_KEY_COLUMN'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(4321474631183316)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Return Column'
,p_source=>'LOOKUP_KEY_COLUMN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1926_LOOKUP_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = coalesce( :P1926_LOOKUP_OWNER, upper(wwv_flow_wizard_api.get_flow_owner(:FB_FLOW_ID)))',
'   and table_name = :P1926_LOOKUP_TABLE',
'   and data_type <> ''BLOB'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P1926_LOOKUP_TABLE'
,p_ajax_items_to_submit=>'P1926_LOOKUP_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Select the column value to be returned and loaded to the target table. This value is typically the primary key value of the parent in a foreign key relationship.',
'</p>',
'<p><strong>Example:</strong></p>',
'<pre>',
'ENAME  EMPNO  SAL    DNAME',
'------ ------ ------ ------------',
'  7839 KING     5000 ACCOUNTING',
'  7788 SCOTT    3000 RESEARCH',
'     : :           : :',
'</pre>',
'<ul>',
'<li>Configure the <strong>DNAME_LOADED</strong> column, as a <strong>Data</strong> column with the selector of <strong>DNAME</strong>, or <strong>4</strong> (based on the selector type).</li>',
'<li>Use <strong>DEPTNO</strong> as the data profile column name and <strong>Lookup</strong> as the column type.</li>',
'<li>Use <strong>DEPT</strong> as the <strong>Table Name</strong></li>',
'<li>Use <strong>DEPTNO</strong> as the <strong>Return Column</strong></li>',
'<li>Use <strong>DNAME</strong> is the <strong>Table Column 1</strong></li>',
'<li><strong>DNAME_LOADED</strong> is the <strong>Data Column 1</strong>. Note that this references the data profile column which contains the actually uploaded data.</li>',
'</ul>',
'<p>',
'<br>',
'As a result, &PRODUCT_NAME. will look up <strong>DEPTNO</strong> values from the <strong>DEPT</strong> table, using the uploaded <strong>DNAME</strong> values. These will be uploaded as the <strong>DEPTNO</strong> column of the target table.',
'</p>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4321894045183320)
,p_name=>'P1926_LOOKUP_COLUMN1'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(4321474631183316)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Table Column 1'
,p_source=>'LOOKUP_COLUMN1'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1926_LOOKUP_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = coalesce( :P1926_LOOKUP_OWNER, upper(wwv_flow_wizard_api.get_flow_owner(:FB_FLOW_ID)))',
'   and table_name = :P1926_LOOKUP_TABLE',
'   and data_type <> ''BLOB'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_lov_cascade_parent_items=>'P1926_LOOKUP_TABLE'
,p_ajax_items_to_submit=>'P1926_LOOKUP_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the first column name to be used to retrieve the return column from the lookup table.</p>',
'<p><strong>Example:</strong></p>',
'<pre>',
'ENAME  EMPNO  SAL    DNAME',
'------ ------ ------ ------------',
'  7839 KING     5000 ACCOUNTING',
'  7788 SCOTT    3000 RESEARCH',
'     : :           : :',
'</pre>',
'<ul>',
'<li>Configure the <strong>DNAME_LOADED</strong> column, as a <strong>Data</strong> column with the selector of <strong>DNAME</strong>, or <strong>4</strong> (based on the selector type).</li>',
'<li>Use <strong>DEPTNO</strong> as the data profile column name and <strong>Lookup</strong> as the column type.</li>',
'<li>Use <strong>DEPT</strong> as the <strong>Table Name</strong></li>',
'<li>Use <strong>DEPTNO</strong> as the <strong>Return Column</strong></li>',
'<li>Use <strong>DNAME</strong> is the <strong>Table Column 1</strong></li>',
'<li><strong>DNAME_LOADED</strong> is the <strong>Data Column 1</strong>. Note that this references the data profile column which contains the actually uploaded data.</li>',
'</ul>',
'<p>',
'<br>',
'As a result, &PRODUCT_NAME. will look up <strong>DEPTNO</strong> values from the <strong>DEPT</strong> table, using the uploaded <strong>DNAME</strong> values. These will be uploaded as the <strong>DEPTNO</strong> column of the target table.',
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4322015218183322)
,p_name=>'P1926_LOOKUP_COLUMN2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(4321474631183316)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Table Column 2'
,p_source=>'LOOKUP_COLUMN2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1926_LOOKUP_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = coalesce( :P1926_LOOKUP_OWNER, upper(wwv_flow_wizard_api.get_flow_owner(:FB_FLOW_ID)))',
'   and table_name = :P1926_LOOKUP_TABLE',
'   and data_type <> ''BLOB'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_lov_cascade_parent_items=>'P1926_LOOKUP_TABLE'
,p_ajax_items_to_submit=>'P1926_LOOKUP_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Select the second column name to be used to retrieve the return column from the lookup table. See <strong>Table Column 1</strong> for an example.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4322104981183323)
,p_name=>'P1926_LOOKUP_COLUMN3'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(4321474631183316)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Table Column 3'
,p_source=>'LOOKUP_COLUMN3'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1926_LOOKUP_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = coalesce( :P1926_LOOKUP_OWNER, upper(wwv_flow_wizard_api.get_flow_owner(:FB_FLOW_ID)))',
'   and table_name = :P1926_LOOKUP_TABLE',
'   and data_type <> ''BLOB'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_lov_cascade_parent_items=>'P1926_LOOKUP_TABLE'
,p_ajax_items_to_submit=>'P1926_LOOKUP_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Select the third column name to be used to retrieve the return column from the lookup table. See <strong>Table Column 1</strong> for an example.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4322217347183324)
,p_name=>'P1926_LOOKUP_VALUE1'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(4321474631183316)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Data Column 1'
,p_source=>'LOOKUP_VALUE1'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1926_DATA_PROFILE_COLS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name',
'from wwv_flow_data_profile_cols',
'where data_profile_id = :P1925_DATA_PROFILE_ID',
'and flow_id = :FB_FLOW_ID',
'and security_group_id = :FLOW_SECURITY_GROUP_ID',
'order by sequence'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Select the data profile column that matches the first lookup table column value.',
'</p>',
'<p><strong>Example:</strong></p>',
'<pre>',
'ENAME  EMPNO  SAL    DNAME',
'------ ------ ------ ------------',
'  7839 KING     5000 ACCOUNTING',
'  7788 SCOTT    3000 RESEARCH',
'     : :           : :',
'</pre>',
'<ul>',
'<li>Configure the <strong>DNAME_LOADED</strong> column, as a <strong>Data</strong> column with the selector of <strong>DNAME</strong>, or <strong>4</strong> (based on the selector type).</li>',
'<li>Use <strong>DEPTNO</strong> as the data profile column name and <strong>Lookup</strong> as the column type.</li>',
'<li>Use <strong>DEPT</strong> as the <strong>Table Name</strong></li>',
'<li>Use <strong>DEPTNO</strong> as the <strong>Return Column</strong></li>',
'<li>Use <strong>DNAME</strong> is the <strong>Table Column 1</strong></li>',
'<li><strong>DNAME_LOADED</strong> is the <strong>Data Column 1</strong>. Note that this references the data profile column which contains the actually uploaded data.</li>',
'</ul>',
'<p>',
'<br>',
'As a result, &PRODUCT_NAME. will look up <strong>DEPTNO</strong> values from the <strong>DEPT</strong> table, using the uploaded <strong>DNAME</strong> values. These will be uploaded as the <strong>DEPTNO</strong> column of the target table.',
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4322312876183325)
,p_name=>'P1926_LOOKUP_VALUE2'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(4321474631183316)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Data Column 2'
,p_source=>'LOOKUP_VALUE2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1926_DATA_PROFILE_COLS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name',
'from wwv_flow_data_profile_cols',
'where data_profile_id = :P1925_DATA_PROFILE_ID',
'and flow_id = :FB_FLOW_ID',
'and security_group_id = :FLOW_SECURITY_GROUP_ID',
'order by sequence'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Select the data profile column that matches the second lookup table column value. See <strong>Data Column 1</strong> for an example.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4322430949183326)
,p_name=>'P1926_LOOKUP_VALUE3'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(4321474631183316)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Data Column 3'
,p_source=>'LOOKUP_VALUE3'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P1926_DATA_PROFILE_COLS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name',
'from wwv_flow_data_profile_cols',
'where data_profile_id = :P1925_DATA_PROFILE_ID',
'and flow_id = :FB_FLOW_ID',
'and security_group_id = :FLOW_SECURITY_GROUP_ID',
'order by sequence'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Select the data profile column that matches the third lookup table column value. See <strong>Data Column 1</strong> for an example.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4322522889183327)
,p_name=>'P1926_LOOKUP_WHERE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(4321474631183316)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Where Clause'
,p_source=>'LOOKUP_WHERE_CLAUSE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Additional WHERE clause to be applied to the lookup query.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4702017184940016)
,p_name=>'P1926_TRANSFORM_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(4701992042940015)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Value Transformation'
,p_source=>'TRANSFORM_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DATA.LOAD.TRANSFORM_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(4818478622110870)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Select a simple transformation rule to change the uploaded value. For example, if the source data contains column data in mixed case format, the <strong>To Lower Case</strong> or <strong>To Upper Case</strong> allow to convert the data to the des'
||'ired case.',
'    </p>',
'<ul>',
'    <li><strong>Left Trim</strong>, <strong>Right Trim</strong> and <strong>Trim</strong>:<br> Trim characters specified in <strong>Expression 1</strong> from the left side, the right side or from both sides of the uploaded data value.</li>',
'    <li><strong>Replace</strong>:<br> Simple replacement of <strong>Expression&nbsp;1</strong> occurrences with <strong>Expression&nbsp;2</strong>.</li>',
'    <li><strong>To Upper Case</strong>:<br> Convert the value to upper case.</li>',
'    <li><strong>To Lower Case</strong>:<br> Convert the value to lower case.</li>',
'    <li><strong>Null If</strong>:<br> If the uploaded value equals the string specified in <strong>Expression&nbsp;1</strong>, the value will be uploaded as NULL.</li>',
'    <li><strong>Regular Expression Replace</strong>:<br> Apply the regular expression specified in <strong>Expression&nbsp;1</strong>, and replace all matches with <strong>Expression&nbsp;2</strong>.</li>',
'    <li><strong>Regular Expression Null If</strong>:<br> If the regular expression specified in <strong>Expression&nbsp;1</strong> matches, upload the column value as NULL.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4703763733940033)
,p_name=>'P1926_SELECTOR_TYPE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(225901106053244536)
,p_item_default=>'NAME'
,p_prompt=>'Selector Type'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DATA.LOAD.SELECTOR_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(5203249727555533)||'.'
,p_display_when=>'P1926_FORMAT'
,p_display_when2=>'CSV:XLSX'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    For <strong>CSV</strong> or <strong>XLSX</strong> data profiles, specify whether the column value is referenced by the (numeric) column sequence, by the column name or by a regular expression. The <strong>Name</strong> or <strong>Regular Expressi'
||'on</strong> options require the CSV or XLSX data to contain column names in the first row. ',
'    The <strong>Regular Expression</strong> option is useful if the column names in uploaded data are likely to change.',
'</p>',
'<p>',
'The <strong>Sequence</strong> option has a performance advantage, since &PRODUCT_NAME. does not need to determine column names and positions before loading the data. However use this option only if the uploaded data always has the same columns in the'
||' same sequence. ',
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5269072110575504)
,p_name=>'P1926_TRANSFORM_EXPRESSION1'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(4701992042940015)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Expression 1'
,p_source=>'EXPRESSION1'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Provide "<strong>Expression 1</strong>" for this transformation type. The expression supports substitutions such as Application, Page Items and System Variables. The semantics depends on the chosen transformation rule; see <strong>Rule Type</strong> '
||'help for more information.',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5269198002575505)
,p_name=>'P1926_TRANSFORM_EXPRESSION2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(4701992042940015)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Expression 2'
,p_source=>'EXPRESSION2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Provide "<strong>Expression 2</strong>" for this transformation type. The expression supports substitutions such as Application, Page Items and System Variables. The semantics depends on the chosen transformation rule; see <strong>Rule Type</strong> '
||'help for more information.',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5270481138575518)
,p_name=>'P1926_SQL_QUERY'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(225901106053244536)
,p_prompt=>'SQL Query'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the SQL Query to compute the value of this column. The SQL query must return a single value and can reference data profile columns of the <strong>Data</strong> column type.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(16494865388178009)
,p_name=>'P1926_REFERENCE_ID'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(225899656946244521)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225899863718244523)
,p_name=>'P1926_FLOW_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(225899656946244521)
,p_use_cache_before_default=>'NO'
,p_item_default=>'FB_FLOW_ID'
,p_item_default_type=>'ITEM'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225899980204244524)
,p_name=>'P1926_DATA_PROFILE_COLUMN_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(225899656946244521)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225900013374244525)
,p_name=>'P1926_NAME'
,p_is_required=>true
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(225899656946244521)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>75
,p_cMaxlength=>128
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Name under which the column is exposed to &PRODUCT_NAME. components.</p>',
'<p>If the data profile is part of a <em>Data Load Definition</em>, this name is used to map data profile columns to the target table. For instance, the <strong>ENAME</strong> data profile column will be loaded to the <strong>ENAME</strong> column of '
||'the target table. If the profile column does <em>not exist</em> in the target table, it will be ignored during data load.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225900168616244526)
,p_name=>'P1926_SEQUENCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1922763094324838)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Sequence'
,p_source=>'SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>10
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Sequence number to determine the order of columns. If left blank, the column will be stored as the last column.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'0'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225900212164244527)
,p_name=>'P1926_IS_PRIMARY_KEY'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1922763094324838)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Primary Key '
,p_source=>'IS_PRIMARY_KEY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_colspan=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Determines whether this is a primary key column. A primary key can consist of multiple columns.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225900372390244528)
,p_name=>'P1926_DATA_TYPE'
,p_is_required=>true
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(225899656946244521)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Data Type'
,p_source=>'DATA_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DATA_PROFILE_DATA_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(225929676126476839)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Data type of the column which is exposed to APEX components.</p>',
'<p>',
'<p>Notes:</p>',
'<ul>',
'<li>The <strong>JSON Document</strong> type is <em>only</em> available for JSON data profiles.</li>',
'<li>The <strong>Array</strong> type is <em>only</em> available for JSON data profiles, and only for REST Data Sources.</li>',
'<li>The <strong>BLOB</strong> type requires the response to contain the data in <em>Base64</em> format and is <em>only</em> available for <strong>REST Data Sources</strong>, with JSON and XML data profiles. Data Load Definitions do not support BLOB c'
||'olumns.</li>',
'<li>For XLSX and CSV data profiles, the contents of <strong>CLOB</strong> columns are limited to 32,767 bytes.</li>',
'</ul>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225900441757244529)
,p_name=>'P1926_MAX_LENGTH'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(225899656946244521)
,p_use_cache_before_default=>'NO'
,p_item_default=>'4000'
,p_prompt=>'Length'
,p_source=>'MAX_LENGTH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>5
,p_cMaxlength=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Length attribute for VARCHAR2 data profile columns.</p>',
'<p>For XLSX and CSV data profiles, values can range from 1 to <strong>4000</strong>. For XML and JSON data profiles, the maximum depends on the <strong>MAX_STRING_SIZE</strong> database parameter: If set to <strong>EXTENDED</strong>; values can range'
||' from 1 to <strong>32767</strong>, otherwise from 1 to <strong>4000</strong>.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225900888129244533)
,p_name=>'P1926_DATA_PROFILE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(225899656946244521)
,p_use_cache_before_default=>'NO'
,p_source=>'DATA_PROFILE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225901294817244537)
,p_name=>'P1926_FORMAT_MASK'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(225899656946244521)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Format mask'
,p_source=>'FORMAT_MASK'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'DATA_PROFILE_DATE_FORMAT_MASKS'
,p_lov=>'.'||wwv_flow_imp.id(225940310284555905)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Format mask to be used for NUMBER, DATE and TIMESTAMP columns. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225901683035244541)
,p_name=>'P1926_HAS_TIME_ZONE'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(225899656946244521)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Has Time Zone'
,p_source=>'HAS_TIME_ZONE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Indicates whether the DATE or TIMESTAMP value in the <em>source data (REST Source response or uploaded data)</em> contains timestamp information. If enabled, &PRODUCT_NAME. respects the time zone and converts the value to the local application ti'
||'me zone. If not, the value is taken as-is.',
'</p>',
'<p>',
'   Examples:    ',
'</p>',
'<ul>',
'    <li><code>2019-01-01T20:00:00Z</code> does contain time zone information</li>',
'    <li><code>2019-01-01T20:00:00 Europe/Berlin</code> does contain time zone information</li>',
'    <li><code>2019-01-01T20:00:00</code> does not contain time zone information</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225901911120244544)
,p_name=>'P1926_SELECTOR'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(225901106053244536)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Selector'
,p_source=>'SELECTOR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>75
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The <strong>Selector</strong> expression is being used to extract the column value from the source data.',
'<ul>',
'    <li><p>For <strong>XML</strong> and <strong>JSON</strong> formats, this selector is <em>relative</em> to the <strong>Row Selector</strong> which is configured at the data profile level. Use XPath-Syntax for XML, and JSON path expressions for JSON'
||' formats.</p><p>Note: When using the <strong>APEX_EXEC</strong> package to access data within <em>Array</em> columns using PL/SQL, <em>only simple selectors</em>, i.e. without filter expressions or array indexes are allowed.</p></li>',
'    <li>For <strong>CSV</strong> or <strong>XLSX</strong>, use the column name, sequence or a regular expression, based on the <strong>Selector Type</strong> attribute. Note that column names and regular expressions are matched in a <em>case-insensit'
||'ive</em> manner for CSV and XLSX files.</li> ',
'</ul>',
'<p>',
'<br><strong>JSON Example:</strong>',
'</p>',
'<pre>',
'{ "items": [',
'    { "ename": "SMITH", "sal": 200 },',
'    { "ename": "SCOTT", "sal": 100 } ] }',
'</pre>',
'<p>',
'    <strong>items</strong> is used as the <strong>Row Selector</strong> attribute, so choose <strong>ename</strong> as the selector for the ENAME column and <strong>sal</strong> as the selector for the SAL column. Note that the selector must not refe'
||'rence a JSON array.',
'</p>',
'<p>',
'<br><strong>CSV Example:</strong></p>',
'<pre>',
'EMPNO   ENAME   SAL ',
'------- ------- --------',
'   7839 KING        5000',
'   7844 FORD        2850',
'      : :              :',
'</pre>',
'<p>',
'    If <strong>Name</strong> is used as the Selector Type, use the column names from the first line of CSV or XLSX data: <strong>EMPNO</strong>, <strong>ENAME</strong> or <strong>SAL</strong>. If the selector type is <strong>Sequence</strong>, use <s'
||'trong>1</strong>, <strong>2</strong> or <strong>3</strong>, to reference the column by its sequence number. The same semantics applies for XLSX data profiles.',
'</p>',
'<p>',
'Note that the <strong>Sequence</strong> option has a performance advantage, since &PRODUCT_NAME. does not need to determine column names and positions before loading the data. However use this option only if the uploaded data always has the same colu'
||'mns in the same sequence. ',
'</p> '))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225902140907244546)
,p_name=>'P1926_REMOTE_ATTRIBUTE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2848941659619014)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Remote Attribute Name'
,p_source=>'REMOTE_ATTRIBUTE_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>75
,p_cMaxlength=>255
,p_display_when=>'P1925_IS_WEB_SRC_PROFILE'
,p_display_when2=>'Y'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'When the column name is sent to the REST Data Source server for order by, filter or DML requests, &PRODUCT_NAME. uses the <strong>Selector</strong> as the attribute name. This attribute allows to configure an alternative name for the case that Select'
||'or and Attribute names are different. If unsure, leave this value blank.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225902211933244547)
,p_name=>'P1926_COLUMN_COMMENT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(2849083857619015)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comment'
,p_source=>'COLUMN_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter any developer comments or notes here. These comments only display within App Builder and never display when running the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(238756893364331841)
,p_name=>'P1926_COLUMN_TYPE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(225899656946244521)
,p_use_cache_before_default=>'NO'
,p_item_default=>'DATA'
,p_prompt=>'Column Type'
,p_source=>'COLUMN_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DATA_PROFILE_COL_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(242159593404725778)||'.'
,p_cHeight=>1
,p_read_only_when=>'P1926_DATA_PROFILE_COLUMN_ID'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Specify the column type. Possible Values are:',
'</p>',
'<ul>',
'    <li><strong>Data</strong> column values are directly extracted from the source data (uploaded data or REST Source response). A <strong>Data</strong> column always requires the <strong>Selector</strong> attribute to be set.</li>',
'    <li><strong>Lookup</strong> columns are used to "look up" a value from a table, based on (another) <strong>Data</strong> column. For instance, a lookup can be defined to return the <strong>DEPTNO</strong> value from the <strong>DEPT</strong> tabl'
||'e, based on the value of the <strong>DNAME</strong> Data Column.',
'    </li>',
'    <li><strong>SQL Expression</strong> columns compute a value based on other <strong>Data Columns</strong> using a SQL Expression.</li>',
'    <li><strong>SQL Query</strong> columns will execute a SQL query, which references other <strong>Data Columns</strong> in order to retrieve a value.</li>',
'</ul> '))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(238756939388331842)
,p_name=>'P1926_SQL_EXPRESSION'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(225901106053244536)
,p_prompt=>'SQL Expression'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the SQL Expression to compute the value of this column. The SQL expression can reference data profile columns of the <strong>Data</strong> column type.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(242269636643871845)
,p_name=>'P1926_FORMAT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(225899656946244521)
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select format ',
'  from wwv_flow_data_profiles',
'where id = :P1926_DATA_PROFILE_ID',
'  and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1120461520324744304)
,p_name=>'P1926_REMOTE_DATA_TYPE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(2848941659619014)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Remote Data Type'
,p_source=>'REMOTE_DATA_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>75
,p_cMaxlength=>255
,p_display_when=>'P1925_IS_WEB_SRC_PROFILE'
,p_display_when2=>'Y'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'If specified, this data type is used by REST Source Plug-In implementations, when doing server-side filtering ',
'or ordering. This is useful if the column''s actual data type, at the REST site, is not available in &PRODUCT_NAME.,',
'for instance <strong>Boolean</strong> data types. ',
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1241617887855502710)
,p_name=>'P1926_NEXT_COLUMN_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(225899656946244521)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1241617941618502711)
,p_name=>'P1926_PREV_COLUMN_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(225899656946244521)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3403060029900708617)
,p_name=>'P1926_IS_HIDDEN'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1922763094324838)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Visible'
,p_source=>'IS_HIDDEN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_colspan=>4
,p_display_when=>'P1925_IS_WEB_SRC_PROFILE'
,p_display_when2=>'Y'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify whether this is <em>visible</em> or not. ',
'Invisible columns will not be displayed in Page Designer and can therefore ',
'not be chosen for &PRODUCT_NAME. components. However, if an invisible column is ',
'being referenced by a component, the component will work as expected.',
''))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'No'
,p_attribute_04=>'Y'
,p_attribute_05=>'Yes'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(241343754111308348)
,p_computation_sequence=>20
,p_computation_item=>'P1926_SEQUENCE'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl( max(sequence) + 10, 10 )',
'  from wwv_flow_data_profile_cols',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and data_profile_id = :P1926_DATA_PROFILE_ID'))
,p_compute_when=>'P1926_SEQUENCE'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(4702891801940024)
,p_computation_sequence=>30
,p_computation_item=>'P1926_MAX_LENGTH'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P1926_DATA_TYPE'
,p_compute_when_text=>'VARCHAR2'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2849516577619020)
,p_computation_sequence=>80
,p_computation_item=>'P1926_TABLE_SELECTOR_TYPE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case when :P1926_IS_LINE_NUMBER = ''Y'' then ''LINE#'' ',
'     when :P1926_COLUMN_TYPE != ''DATA'' then null',
'     else :P1926_SELECTOR_TYPE ',
' end'))
,p_compute_when=>':REQUEST in (''CREATE'', ''APPLY_CHANGES'')'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2849479546619019)
,p_computation_sequence=>90
,p_computation_item=>'P1926_SELECTOR'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>':REQUEST in (''CREATE'', ''APPLY_CHANGES'') and ( :P1926_IS_LINE_NUMBER = ''Y'' or :P1926_COLUMN_TYPE != ''DATA'' )'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2849654005619021)
,p_computation_sequence=>100
,p_computation_item=>'P1926_DATA_TYPE'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'NUMBER'
,p_compute_when=>':REQUEST in (''CREATE'', ''APPLY_CHANGES'') and :P1926_IS_LINE_NUMBER = ''Y'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2850345191619028)
,p_computation_sequence=>10
,p_computation_item=>'P1926_SELECTOR_TYPE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'nullif( :P1926_TABLE_SELECTOR_TYPE, ''LINE#'' )'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2849117516619016)
,p_computation_sequence=>20
,p_computation_item=>'P1926_IS_LINE_NUMBER'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'case when :P1926_TABLE_SELECTOR_TYPE = ''LINE#'' then ''Y'' else ''N'' end'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(225950102642615705)
,p_validation_name=>'VARCHAR2 has length attribute'
,p_validation_sequence=>10
,p_validation=>'( :P1926_DATA_TYPE = ''VARCHAR2'' and :P1926_MAX_LENGTH is not null ) or :P1926_DATA_TYPE != ''VARCHAR2'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'#LABEL# must be specified'
,p_validation_condition=>'CREATE,APPLY_CHANGES'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(225900441757244529)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(7236251665718401)
,p_validation_name=>'VARCHAR2 length is within limits'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'to_number( :P1926_MAX_LENGTH ) <= case ',
'                                  when :P1926_FORMAT in (''XML'', ''JSON'') ',
'                                      then case ',
'                                           when wwv_flow_db_version.c_has_extended_string_size',
'                                               then 32767',
'                                               else 4000 ',
'                                           end',
'                                  else 4000',
'                                  end'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'#LABEL# exceeds the allowed maximum'
,p_validation_condition=>':P1926_DATA_TYPE = ''VARCHAR2'' and :P1926_MAX_LENGTH is not null and :REQUEST in ( ''CREATE'',''APPLY_CHANGES'' )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(225900441757244529)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5272404876575538)
,p_validation_name=>'DATA column for CSV, XLSX,  selector type not null'
,p_validation_sequence=>30
,p_validation=>'P1926_SELECTOR_TYPE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified'
,p_validation_condition=>':P1926_FORMAT in (''CSV'',''XLSX'') and :P1926_COLUMN_TYPE = ''DATA'' and :P1926_IS_LINE_NUMBER = ''N'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(4703763733940033)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1516496892800801)
,p_validation_name=>'BLOB Data Type only for JSON and XML'
,p_validation_sequence=>40
,p_validation=>'P1926_DATA_TYPE'
,p_validation2=>'BLOB'
,p_validation_type=>'ITEM_IN_VALIDATION_NOT_EQ_STRING2'
,p_error_message=>'BLOB data type is only allowed for XML and JSON data profiles.'
,p_validation_condition=>':P1926_FORMAT in (''CSV'',''XLSX'') and :P1926_COLUMN_TYPE = ''DATA'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(225900372390244528)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5272397133575537)
,p_validation_name=>'DATA column selector not null'
,p_validation_sequence=>50
,p_validation=>'P1926_SELECTOR'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified'
,p_validation_condition=>':P1926_COLUMN_TYPE = ''DATA'' and nvl( :P1926_TABLE_SELECTOR_TYPE, ''NAME'' ) in (''NAME'',''SEQ'',''REGEXP'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(225901911120244544)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5271560440575529)
,p_validation_name=>'SQL Expression is not null'
,p_validation_sequence=>60
,p_validation=>'P1926_SQL_EXPRESSION'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified'
,p_validation_condition=>':P1926_COLUMN_TYPE = ''SQL_EXPRESSION'' and :REQUEST in (''CREATE'', ''APPLY_CHANGES'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(238756939388331842)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(236247753632284212)
,p_validation_name=>'SQL Expression is valid'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_data_profile_dev.check_sql_expression( ',
'    p_data_profile_id => :P1925_DATA_PROFILE_ID,',
'    p_array_column_id => :P1926_PARENT_COLUMN,',
'    p_sql_expression  => :P1926_SQL_EXPRESSION );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':P1926_COLUMN_TYPE = ''SQL_EXPRESSION'' and :P1926_SQL_EXPRESSION is not null and :REQUEST in (''CREATE'', ''APPLY_CHANGES'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(238756939388331842)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5271680763575530)
,p_validation_name=>'SQL Query is not null'
,p_validation_sequence=>80
,p_validation=>'P1926_SQL_QUERY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified'
,p_validation_condition=>':P1926_COLUMN_TYPE = ''SQL_QUERY'' and :REQUEST in (''CREATE'', ''APPLY_CHANGES'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(5270481138575518)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5270569183575519)
,p_validation_name=>'SQL Query is valid'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_data_profile_dev.check_sql_expression( ',
'    p_data_profile_id => :P1925_DATA_PROFILE_ID,',
'    p_array_column_id => :P1926_PARENT_COLUMN,',
'    p_sql_expression  => :P1926_SQL_QUERY );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':P1926_COLUMN_TYPE = ''SQL_QUERY'' and :P1926_SQL_QUERY is not null and :REQUEST in (''CREATE'', ''APPLY_CHANGES'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(5270481138575518)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5271909332575533)
,p_validation_name=>'lookup table not null'
,p_validation_sequence=>100
,p_validation=>'P1926_LOOKUP_TABLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified'
,p_validation_condition=>'P1926_COLUMN_TYPE'
,p_validation_condition2=>'LOOKUP'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(4321628443183318)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5272011392575534)
,p_validation_name=>'lookup return column not null'
,p_validation_sequence=>110
,p_validation=>'P1926_LOOKUP_KEY_COLUMN'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified'
,p_validation_condition=>'P1926_COLUMN_TYPE'
,p_validation_condition2=>'LOOKUP'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(4321734839183319)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3754862439775407)
,p_validation_name=>'lookup column, data column not null'
,p_validation_sequence=>120
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ( :P1926_LOOKUP_COLUMN1 is not null and :P1926_LOOKUP_VALUE1 is null ) OR',
'( :P1926_LOOKUP_COLUMN1 is null and :P1926_LOOKUP_VALUE1 is not null ) OR',
'( :P1926_LOOKUP_COLUMN2 is not null and :P1926_LOOKUP_VALUE2 is null ) OR',
'( :P1926_LOOKUP_COLUMN2 is null and :P1926_LOOKUP_VALUE2 is not null ) OR',
'( :P1926_LOOKUP_COLUMN3 is not null and :P1926_LOOKUP_VALUE3 is null ) OR',
'( :P1926_LOOKUP_COLUMN3 is null and :P1926_LOOKUP_VALUE3 is not null ) then',
'    return false;',
'else',
'    return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Both lookup table column and data column must be specified.'
,p_validation_condition=>'P1926_COLUMN_TYPE'
,p_validation_condition2=>'LOOKUP'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5272117937575535)
,p_validation_name=>'transform expr1 not null'
,p_validation_sequence=>130
,p_validation=>'P1926_TRANSFORM_EXPRESSION1'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified'
,p_validation_condition=>'P1926_TRANSFORM_TYPE'
,p_validation_condition2=>'REPLACE:NULLIF:REGEXP_NULLIF:REGEXP_REPLACE'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_associated_item=>wwv_flow_imp.id(5269072110575504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(7127616359468930)
,p_validation_name=>'selector type cannot be NAME if has header row = N'
,p_validation_sequence=>140
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_data_profiles',
' where flow_id            = :FB_FLOW_ID',
'   and security_group_id  = :FLOW_SECURITY_GROUP_ID',
'   and id                 = :P1926_DATA_PROFILE_ID',
'   and :P1926_FORMAT     in ( ''CSV'', ''XLSX'' )',
'   and has_header_row     = ''N'''))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Selector Type cannot be set to Name as First Line Contains Header is disabled for this data profile.'
,p_validation_condition=>':P1926_SELECTOR_TYPE = ''NAME'' and :P1926_COLUMN_TYPE = ''DATA'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(4703763733940033)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4503080488479014)
,p_validation_name=>'selector must be numeric and 1 and 300 if selector type SEQ'
,p_validation_sequence=>150
,p_validation=>'wwv_flow_utilities.is_number( p_number => :P1926_SELECTOR ) and :P1926_SELECTOR between 1 and 300'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Selector must be numeric and number between 1 and 300.'
,p_validation_condition=>':P1926_SELECTOR is not null and :P1926_SELECTOR_TYPE = ''SEQ'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(225901911120244544)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4805970719918720)
,p_validation_name=>'name exists'
,p_validation_sequence=>160
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_data_profile_cols',
'where flow_id = :FB_FLOW_ID',
'and security_group_id = :WORKSPACE_ID',
'and data_profile_id = :P1926_DATA_PROFILE_ID',
'and ( id != :P1926_DATA_PROFILE_COLUMN_ID OR :P1926_DATA_PROFILE_COLUMN_ID is null )',
'and name = :P1926_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'The name is already used by another column.'
,p_validation_condition=>'CREATE,APPLY_CHANGES'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(225900013374244525)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1535033901420627)
,p_validation_name=>'Array Column only allowed for JSON Profiles'
,p_validation_sequence=>170
,p_validation=>'P1926_DATA_TYPE'
,p_validation2=>'ARRAY'
,p_validation_type=>'ITEM_IN_VALIDATION_NOT_EQ_STRING2'
,p_error_message=>'Array Columns are only allowed for REST Sources returning JSON data.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST in ( ''CREATE'', ''APPLY_CHANGES'' )',
'and ( :P1926_FORMAT != ''JSON'' or :P1925_IS_WEB_SRC_PROFILE = ''N'' )'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(225900372390244528)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2242559901021531)
,p_validation_name=>'No Cycles in Array Columns'
,p_validation_sequence=>180
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with profile_cols as (',
'         select id,',
'                parent_column_id,',
'                data_type',
'           from wwv_flow_data_profile_cols',
'          where security_group_id = :FLOW_SECURITY_GROUP_ID',
'            and data_profile_id   = :P1926_DATA_PROFILE_ID    ',
'            and id               != :P1926_DATA_PROFILE_COLUMN_ID',
'          union all ',
'         select to_number(:P1926_DATA_PROFILE_COLUMN_ID) as id,',
'                to_number(:P1926_PARENT_COLUMN)          as parent_column_id,',
'                :P1926_DATA_TYPE                         as data_type',
'           from sys.dual',
')',
'select 1 ',
'  from (',
'         select id, ',
'                connect_by_iscycle is_cycle',
'           from profile_cols',
'          start with data_type      = ''ARRAY''',
'        connect by nocycle prior id = parent_column_id )',
' where is_cycle = 1'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Array columns must not have cyclical references.'
,p_when_button_pressed=>wwv_flow_imp.id(225902408094244549)
,p_associated_item=>wwv_flow_imp.id(1719176547469924)
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2242615169021532)
,p_validation_name=>'Array Column with children must not be deleted'
,p_validation_sequence=>190
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_data_profile_cols',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and data_profile_id   = :P1926_DATA_PROFILE_ID',
'   and parent_column_id  = :P1926_DATA_PROFILE_COLUMN_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Other columns are referencing this column as their parent column.'
,p_validation_condition=>':REQUEST = ''DELETE'' or ( :REQUEST = ''APPLY_CHANGES'' and :P1926_DATA_TYPE != wwv_flow_data_profile.c_datatype_array_vc )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(225900510735244530)
,p_name=>'Data Type VARCHAR2'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1926_DATA_TYPE'
,p_condition_element=>'P1926_DATA_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'VARCHAR2'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(225900611710244531)
,p_event_id=>wwv_flow_imp.id(225900510735244530)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_MAX_LENGTH'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(225900741631244532)
,p_event_id=>wwv_flow_imp.id(225900510735244530)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_MAX_LENGTH'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2231321114790530)
,p_name=>'Column Type = DATA and Data Type VARCHAR2'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1926_DATA_TYPE,P1926_COLUMN_TYPE'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$v( "P1926_DATA_TYPE" ) === "VARCHAR2" && $v( "P1926_COLUMN_TYPE" ) === "DATA"'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2231474985790531)
,p_event_id=>wwv_flow_imp.id(2231321114790530)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_VALIDATION_REGEXP'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2231597861790532)
,p_event_id=>wwv_flow_imp.id(2231321114790530)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_VALIDATION_REGEXP'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2231682240790533)
,p_event_id=>wwv_flow_imp.id(2231321114790530)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_VALIDATION_REGEXP'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(225901338954244538)
,p_name=>'Data Type NUMBER, DATE or TIMESTAMP'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1926_DATA_TYPE'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'":NUMBER:DATE:TIMESTAMP:TIMESTAMP WITH TIME ZONE:TIMESTAMP WITH LOCAL TIME ZONE:".indexOf(":" + $v("P1926_DATA_TYPE") + ":") !== -1 && $v("P1926_COLUMN_TYPE") === "DATA"'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(225901451818244539)
,p_event_id=>wwv_flow_imp.id(225901338954244538)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_FORMAT_MASK'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(225901549610244540)
,p_event_id=>wwv_flow_imp.id(225901338954244538)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_FORMAT_MASK'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2241787854021523)
,p_name=>'Data Type NUMBER'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1926_DATA_TYPE'
,p_condition_element=>'P1926_DATA_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NUMBER'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2241828675021524)
,p_event_id=>wwv_flow_imp.id(2241787854021523)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2241689031021522)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2242055686021526)
,p_event_id=>wwv_flow_imp.id(2241787854021523)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2241689031021522)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4320784742183309)
,p_name=>'Data Type DATE or TIMESTAMP'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1926_DATA_TYPE'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'":DATE:TIMESTAMP:TIMESTAMP WITH TIME ZONE:TIMESTAMP WITH LOCAL TIME ZONE:".indexOf(":" + $v("P1926_DATA_TYPE") + ":") !== -1 && $v("P1926_COLUMN_TYPE") === "DATA"'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4320998470183311)
,p_event_id=>wwv_flow_imp.id(4320784742183309)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_HAS_TIME_ZONE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4321130525183313)
,p_event_id=>wwv_flow_imp.id(4320784742183309)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_HAS_TIME_ZONE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(238757030110331843)
,p_name=>'Column Type Data'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1926_COLUMN_TYPE'
,p_condition_element=>'P1926_COLUMN_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'DATA'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2852247966619047)
,p_event_id=>wwv_flow_imp.id(238757030110331843)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_IS_LINE_NUMBER'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(238757121915331844)
,p_event_id=>wwv_flow_imp.id(238757030110331843)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_IS_LINE_NUMBER,P1926_SELECTOR_TYPE,P1926_SELECTOR'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4702148169940017)
,p_event_id=>wwv_flow_imp.id(238757030110331843)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(225901106053244536)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1923022604324841)
,p_event_id=>wwv_flow_imp.id(238757030110331843)
,p_event_result=>'TRUE'
,p_action_sequence=>70
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(4701992042940015)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2848794994619012)
,p_event_id=>wwv_flow_imp.id(238757030110331843)
,p_event_result=>'TRUE'
,p_action_sequence=>80
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2848941659619014)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2851890004619043)
,p_event_id=>wwv_flow_imp.id(238757030110331843)
,p_event_result=>'TRUE'
,p_action_sequence=>90
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(4321474631183316)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2851904352619044)
,p_event_id=>wwv_flow_imp.id(238757030110331843)
,p_event_result=>'TRUE'
,p_action_sequence=>100
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_SQL_EXPRESSION,P1926_SQL_QUERY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2852341606619048)
,p_event_id=>wwv_flow_imp.id(238757030110331843)
,p_event_result=>'TRUE'
,p_action_sequence=>110
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_DATA_TYPE,P1926_SELECTOR'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(241342851401308339)
,p_name=>'Get SQL Expression Data Type'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1926_SQL_EXPRESSION'
,p_condition_element=>'P1926_SQL_EXPRESSION'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(241342995965308340)
,p_event_id=>wwv_flow_imp.id(241342851401308339)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    :P1926_DATA_TYPE := wwv_flow_data_profile_dev.get_sql_expr_datatype( ',
'        p_data_profile_id => :P1925_DATA_PROFILE_ID,',
'        p_array_column_id => :P1926_PARENT_COLUMN,',
'        p_sql_expression  => :P1926_SQL_EXPRESSION );',
'    if :P1926_DATA_TYPE = wwv_flow_data_profile.c_datatype_varchar2_vc then ',
'        :P1926_MAX_LENGTH := coalesce(:P1926_MAX_LENGTH, 4000 );',
'    end if;',
'end;'))
,p_attribute_02=>'P1926_DATA_PROFILE_ID,P1926_SQL_EXPRESSION,P1926_MAX_LENGTH,P1926_PARENT_COLUMN'
,p_attribute_03=>'P1926_DATA_TYPE,P1926_MAX_LENGTH'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5270821132575522)
,p_name=>'Get SQL Query data type'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1926_SQL_QUERY'
,p_condition_element=>'P1926_SQL_QUERY'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5270918729575523)
,p_event_id=>wwv_flow_imp.id(5270821132575522)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    :P1926_DATA_TYPE := wwv_flow_data_profile_dev.get_sql_expr_datatype( ',
'        p_data_profile_id => :P1925_DATA_PROFILE_ID,',
'        p_array_column_id => :P1926_PARENT_COLUMN,',
'        p_sql_expression  => :P1926_SQL_QUERY );',
'    if :P1926_DATA_TYPE = wwv_flow_data_profile.c_datatype_varchar2_vc then ',
'        :P1926_MAX_LENGTH := coalesce(:P1926_MAX_LENGTH, 4000 );',
'    end if;',
'    ',
'end;'))
,p_attribute_02=>'P1926_DATA_PROFILE_ID,P1926_SQL_QUERY,P1926_MAX_LENGTH,P1926_PARENT_COLUMN'
,p_attribute_03=>'P1926_DATA_TYPE,P1926_MAX_LENGTH'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(658285003836841737)
,p_name=>'Set selector'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1926_NAME'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.item("P1926_SELECTOR").getValue() === "" && ',
'apex.item("P1926_COLUMN_TYPE").getValue() === "DATA"'))
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(658285184388841738)
,p_event_id=>wwv_flow_imp.id(658285003836841737)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_SELECTOR'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$v("P1926_NAME").toLowerCase()'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4702915689940025)
,p_name=>'Column Type Lookup'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1926_COLUMN_TYPE'
,p_condition_element=>'P1926_COLUMN_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'LOOKUP'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1003712082371784945)
,p_event_id=>wwv_flow_imp.id(4702915689940025)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_SELECTOR'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4703072995940026)
,p_event_id=>wwv_flow_imp.id(4702915689940025)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(4321474631183316)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2851516860619040)
,p_event_id=>wwv_flow_imp.id(4702915689940025)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(225901106053244536)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2851664681619041)
,p_event_id=>wwv_flow_imp.id(4702915689940025)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2848941659619014)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2851743631619042)
,p_event_id=>wwv_flow_imp.id(4702915689940025)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_IS_LINE_NUMBER,P1926_FORMAT_MASK'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4703250422940028)
,p_name=>'Column Type SQL Expression'
,p_event_sequence=>120
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1926_COLUMN_TYPE'
,p_condition_element=>'P1926_COLUMN_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SQL_EXPRESSION'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4703359732940029)
,p_event_id=>wwv_flow_imp.id(4703250422940028)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_SQL_EXPRESSION'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4703540626940031)
,p_event_id=>wwv_flow_imp.id(4703250422940028)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(4321474631183316)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4703635938940032)
,p_event_id=>wwv_flow_imp.id(4703250422940028)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(4701992042940015)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2852520152619050)
,p_event_id=>wwv_flow_imp.id(4703250422940028)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2848941659619014)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2852002033619045)
,p_event_id=>wwv_flow_imp.id(4703250422940028)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_IS_LINE_NUMBER,P1926_SELECTOR_TYPE,P1926_SELECTOR,P1926_SQL_QUERY,P1926_FORMAT_MASK'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5271000694575524)
,p_name=>'Column Type SQL Query'
,p_event_sequence=>130
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1926_COLUMN_TYPE'
,p_condition_element=>'P1926_COLUMN_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SQL_QUERY'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5271113004575525)
,p_event_id=>wwv_flow_imp.id(5271000694575524)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_SQL_QUERY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5271345272575527)
,p_event_id=>wwv_flow_imp.id(5271000694575524)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(4321474631183316)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5271448985575528)
,p_event_id=>wwv_flow_imp.id(5271000694575524)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(4701992042940015)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4519251397255802)
,p_event_id=>wwv_flow_imp.id(5271000694575524)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2848941659619014)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2852138192619046)
,p_event_id=>wwv_flow_imp.id(5271000694575524)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_IS_LINE_NUMBER,P1926_SELECTOR_TYPE,P1926_SELECTOR,P1926_SQL_EXPRESSION,P1926_FORMAT_MASK'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5269276602575506)
,p_name=>'display expression1'
,p_event_sequence=>140
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1926_TRANSFORM_TYPE'
,p_condition_element=>'P1926_TRANSFORM_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'LTRIM, RTRIM, TRIM, REPLACE, NULLIF, REGEXP_NULLIF, REGEXP_REPLACE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5269346711575507)
,p_event_id=>wwv_flow_imp.id(5269276602575506)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_TRANSFORM_EXPRESSION1'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5269430276575508)
,p_event_id=>wwv_flow_imp.id(5269276602575506)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_TRANSFORM_EXPRESSION1'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5269509269575509)
,p_name=>'display expression2'
,p_event_sequence=>150
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1926_TRANSFORM_TYPE'
,p_condition_element=>'P1926_TRANSFORM_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'REGEXP_REPLACE, REPLACE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5269692476575510)
,p_event_id=>wwv_flow_imp.id(5269509269575509)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_TRANSFORM_EXPRESSION2'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5269735215575511)
,p_event_id=>wwv_flow_imp.id(5269509269575509)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_TRANSFORM_EXPRESSION2'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5271781203575531)
,p_name=>'Get Lookup Key Column Data Type'
,p_event_sequence=>160
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1926_LOOKUP_KEY_COLUMN'
,p_condition_element=>'P1926_LOOKUP_KEY_COLUMN'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5271863947575532)
,p_event_id=>wwv_flow_imp.id(5271781203575531)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for l_col in (',
'        select data_type',
'        from wwv_flow_table_columns_dev',
'        where owner = coalesce( :P1926_LOOKUP_OWNER, upper(wwv_flow_wizard_api.get_flow_owner(:FB_FLOW_ID)))',
'        and table_name = :P1926_LOOKUP_TABLE',
'        and column_name = :P1926_LOOKUP_KEY_COLUMN',
'        and data_type <> ''BLOB'' )',
'    loop',
'        :P1926_DATA_TYPE := l_col.data_type;',
'    end loop;',
'',
'    if :P1926_DATA_TYPE = wwv_flow_data_profile.c_datatype_varchar2_vc then ',
'        :P1926_MAX_LENGTH := 4000;',
'    end if;',
'end;'))
,p_attribute_02=>'P1926_LOOKUP_OWNER,P1926_LOOKUP_TABLE,P1926_LOOKUP_KEY_COLUMN'
,p_attribute_03=>'P1926_DATA_TYPE,P1926_MAX_LENGTH'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4503113942479015)
,p_name=>'set selector to null if type change'
,p_event_sequence=>170
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1926_SELECTOR_TYPE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4503230245479016)
,p_event_id=>wwv_flow_imp.id(4503113942479015)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_SELECTOR'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3754677352775405)
,p_name=>'Set visible to Yes if adding data load column'
,p_event_sequence=>180
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>':P1925_IS_WEB_SRC_PROFILE = ''N'' and :P1926_DATA_PROFILE_COLUMN_ID is null'
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3754701720775406)
,p_event_id=>wwv_flow_imp.id(3754677352775405)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_IS_HIDDEN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2847869787619003)
,p_name=>'Line Number Column'
,p_event_sequence=>190
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1926_IS_LINE_NUMBER'
,p_condition_element=>'P1926_IS_LINE_NUMBER'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2851200410619037)
,p_event_id=>wwv_flow_imp.id(2847869787619003)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_DATA_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'NUMBER'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2851440881619039)
,p_event_id=>wwv_flow_imp.id(2847869787619003)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(225901106053244536)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2848617313619011)
,p_event_id=>wwv_flow_imp.id(2847869787619003)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2848941659619014)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2850594325619030)
,p_event_id=>wwv_flow_imp.id(2847869787619003)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_SELECTOR_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2848407637619009)
,p_event_id=>wwv_flow_imp.id(2847869787619003)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(4701992042940015)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2851022513619035)
,p_event_id=>wwv_flow_imp.id(2847869787619003)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(225901106053244536)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1922985670324840)
,p_event_id=>wwv_flow_imp.id(2847869787619003)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_DATA_TYPE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2848347578619008)
,p_event_id=>wwv_flow_imp.id(2847869787619003)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(225901106053244536)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2848587712619010)
,p_event_id=>wwv_flow_imp.id(2847869787619003)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2848941659619014)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2852489377619049)
,p_event_id=>wwv_flow_imp.id(2847869787619003)
,p_event_result=>'FALSE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_DATA_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1922819489324839)
,p_event_id=>wwv_flow_imp.id(2847869787619003)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_DATA_TYPE,P1926_FORMAT_MASK,P1926_HAS_TIME_ZONE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1516741300800804)
,p_name=>'Data Type BLOB, ARRAY, SDO_GEOMETRY'
,p_event_sequence=>200
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1926_DATA_TYPE'
,p_condition_element=>'P1926_DATA_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'BLOB,SDO_GEOMETRY,ARRAY'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1516855389800805)
,p_event_id=>wwv_flow_imp.id(1516741300800804)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_TRANSFORM_TYPE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1517190895800808)
,p_event_id=>wwv_flow_imp.id(1516741300800804)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_TRANSFORM_TYPE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1517094792800807)
,p_event_id=>wwv_flow_imp.id(1516741300800804)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1926_TRANSFORM_TYPE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5269945498575513)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set transform type if col type SQL Expression or Query'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P1926_COLUMN_TYPE in ( ''SQL_EXPRESSION'', ''SQL_QUERY'' ) then',
'    :P1926_TRANSFORM_TYPE := :P1926_COLUMN_TYPE;',
'',
'    if :P1926_COLUMN_TYPE = ''SQL_EXPRESSION'' then',
'        :P1926_TRANSFORM_EXPRESSION1 := :P1926_SQL_EXPRESSION;',
'    elsif :P1926_COLUMN_TYPE = ''SQL_QUERY'' then',
'        :P1926_TRANSFORM_EXPRESSION1 := :P1926_SQL_QUERY;',
'    end if;',
'end if;',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>5269945498575513
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(225949808232615702)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process row of WWV_FLOW_DATA_PROFILE_COLS'
,p_attribute_02=>'WWV_FLOW_DATA_PROFILE_COLS'
,p_attribute_03=>'P1926_DATA_PROFILE_COLUMN_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id = :FLOW_SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Action processed.'
,p_internal_uid=>225949808232615702
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(225899759263244522)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch row from WWV_FLOW_DATA_PROFILE_COLS'
,p_attribute_02=>'WWV_FLOW_DATA_PROFILE_COLS'
,p_attribute_03=>'P1926_DATA_PROFILE_COLUMN_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id = :FLOW_SECURITY_GROUP_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>225899759263244522
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5270088765575514)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'fetch non-dml item'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_prof_col in (',
'    select * from (',
'        select id                                      as column_id,',
'               column_type,',
'               expression1,',
'               lag( id )  over (order by sequence asc) as prev_column_id,',
'               lead( id ) over (order by sequence asc) as next_column_id',
'          from wwv_flow_data_profile_cols',
'         where flow_id           = :FB_FLOW_ID',
'           and security_group_id = :FLOW_SECURITY_GROUP_ID',
'           and data_profile_id   = :P1926_DATA_PROFILE_ID )',
'    where column_id  = :P1926_DATA_PROFILE_COLUMN_ID )',
'loop',
'    :P1926_NEXT_COLUMN_ID := l_prof_col.next_column_id;',
'    :P1926_PREV_COLUMN_ID := l_prof_col.prev_column_id;',
'    if l_prof_col.column_type = ''SQL_EXPRESSION'' then',
'        :P1926_SQL_EXPRESSION := l_prof_col.expression1;',
'    elsif l_prof_col.column_type = ''SQL_QUERY'' then',
'        :P1926_SQL_QUERY := l_prof_col.expression1;',
'    end if;',
'end loop;',
'',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>5270088765575514
);
end;
/
prompt --application/pages/page_01927
begin
wwv_flow_imp_page.create_page(
 p_id=>1927
,p_name=>'Test REST Data Source'
,p_alias=>'TEST-REST-DATA-SOURCE'
,p_step_title=>'REST Data Source'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(310376765790241838)
,p_plug_name=>'Test Results'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>'<p>This page shows test results for the REST Data Source Operation. The <strong>Response Body</strong> tab shows the raw response received from the web service; the <strong>Data</strong> the results after parsing the raw response using the <em>Data p'
||'rofile</em> meta data. The <strong>Response Headers</strong> tab allows to review the HTTP Response Headers received from the web service.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(468890865757100776)
,p_plug_name=>'Success'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="max-width: 85vw"'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>30
,p_plug_display_condition_type=>'ITEM_IS_NULL'
,p_plug_display_when_condition=>'P1927_STATUS_CODE'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1402163502748306)
,p_plug_name=>'Response Body'
,p_parent_plug_id=>wwv_flow_imp.id(468890865757100776)
,p_region_template_options=>'#DEFAULT#:a-Alert--info:a-Alert--horizontal'
,p_region_attributes=>'style="max-width: 100vw;"'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'to_number( :P1927_RESPONSE_LENGTH default 1000 on conversion error ) >= to_number( :F4000_MAX_RESPONSE_SIZE_KB default 500 on conversion error )'
,p_plug_display_when_cond2=>'PLSQL'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The response body of &P1927_RESPONSE_LENGTH.KB is too large to display. The maximum allowed size is &F4000_MAX_RESPONSE_SIZE_KB.KB.',
'<br> <br>',
'&P1927_BODY_PART.'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(471997775944546730)
,p_plug_name=>'Response Body'
,p_parent_plug_id=>wwv_flow_imp.id(468890865757100776)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--scrollAuto:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_region_attributes=>'style="max-width: 100vw;"'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'select wwv_flow_web_src_dev.get_formatted_response( p_response_type => :P1927_RESPONSE_TYPE ) from sys.dual'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.CLOB_CODE_EDITOR'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'to_number(:P1927_RESPONSE_LENGTH default 1000 on conversion error ) < to_number( :F4000_MAX_RESPONSE_SIZE_KB default 500 on conversion error )'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'PAGE_ITEM',
  'attribute_02', 'AUTO',
  'attribute_03', 'Y',
  'attribute_06', 'P1927_RESPONSE_TYPE')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(472057526085098017)
,p_name=>'Parsed Data'
,p_parent_plug_id=>wwv_flow_imp.id(468890865757100776)
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--scrollAuto:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch:a-Report--rowHighlight'
,p_region_attributes=>'style="max-width: 100vw"'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_sql varchar2(32767);',
'    l_cnt pls_integer;',
'begin',
'    select count(*) into l_cnt',
'     from wwv_flow_collections',
'    where collection_name = ''WEB_SOURCE_INFO''',
'      and c001            = ''DATA_PROFILE_COLUMNS''',
'      and rownum <= 40;',
'      ',
'    if l_cnt = 0 then l_cnt := 1; end if;',
'',
'    l_sql := ''select '';',
'',
'    for i in 1 .. l_cnt loop',
'        l_sql := l_sql ||',
'            case when i > 1 then '','' end ||',
'            ''c'' || lpad( i, 3, ''0'' );',
'    end loop;',
'    l_sql := l_sql || '' from wwv_flow_collections where collection_name = ''''WEB_SOURCE_DATA'''''';',
'    return l_sql;',
'end;'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_plug_query_max_columns=>40
,p_query_headings=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_headings varchar2(32767);',
'begin',
'    for c in ( select * from (',
'                   select c002 ',
'                     from wwv_flow_collections',
'                    where collection_name = ''WEB_SOURCE_INFO''',
'                      and c001            = ''DATA_PROFILE_COLUMNS''',
'                    order by seq_id asc ) ',
'               where rownum <= 40 ) loop',
'       l_headings := l_headings || initcap(c.c002) || '':'';',
'    end loop;',
'    return substr( l_headings, 1, length( l_headings ) - 1 );',
'end;'))
,p_query_headings_type=>'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST'
,p_query_num_rows=>15
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_query_no_data_found=>'Found no data while parsing the service response.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(236250954871284244)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_column_heading=>'Col01'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(236251066214284245)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>2
,p_column_heading=>'Col02'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(236251105342284246)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>3
,p_column_heading=>'Col03'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(236251244450284247)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>4
,p_column_heading=>'Col04'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(236251310108284248)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>5
,p_column_heading=>'Col05'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(236251464504284249)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>6
,p_column_heading=>'Col06'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(236251523583284250)
,p_query_column_id=>7
,p_column_alias=>'COL07'
,p_column_display_sequence=>7
,p_column_heading=>'Col07'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(242265296200871801)
,p_query_column_id=>8
,p_column_alias=>'COL08'
,p_column_display_sequence=>8
,p_column_heading=>'Col08'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(242265311214871802)
,p_query_column_id=>9
,p_column_alias=>'COL09'
,p_column_display_sequence=>9
,p_column_heading=>'Col09'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(242265455537871803)
,p_query_column_id=>10
,p_column_alias=>'COL10'
,p_column_display_sequence=>10
,p_column_heading=>'Col10'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(242265584542871804)
,p_query_column_id=>11
,p_column_alias=>'COL11'
,p_column_display_sequence=>11
,p_column_heading=>'Col11'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(242265635773871805)
,p_query_column_id=>12
,p_column_alias=>'COL12'
,p_column_display_sequence=>12
,p_column_heading=>'Col12'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(242265719484871806)
,p_query_column_id=>13
,p_column_alias=>'COL13'
,p_column_display_sequence=>13
,p_column_heading=>'Col13'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(242265889098871807)
,p_query_column_id=>14
,p_column_alias=>'COL14'
,p_column_display_sequence=>14
,p_column_heading=>'Col14'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(242265995438871808)
,p_query_column_id=>15
,p_column_alias=>'COL15'
,p_column_display_sequence=>15
,p_column_heading=>'Col15'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(242266073967871809)
,p_query_column_id=>16
,p_column_alias=>'COL16'
,p_column_display_sequence=>16
,p_column_heading=>'Col16'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(242266153731871810)
,p_query_column_id=>17
,p_column_alias=>'COL17'
,p_column_display_sequence=>17
,p_column_heading=>'Col17'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(242266214097871811)
,p_query_column_id=>18
,p_column_alias=>'COL18'
,p_column_display_sequence=>18
,p_column_heading=>'Col18'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(242266374630871812)
,p_query_column_id=>19
,p_column_alias=>'COL19'
,p_column_display_sequence=>19
,p_column_heading=>'Col19'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(242266481784871813)
,p_query_column_id=>20
,p_column_alias=>'COL20'
,p_column_display_sequence=>20
,p_column_heading=>'Col20'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(242266577112871814)
,p_query_column_id=>21
,p_column_alias=>'COL21'
,p_column_display_sequence=>21
,p_column_heading=>'Col21'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(242266697578871815)
,p_query_column_id=>22
,p_column_alias=>'COL22'
,p_column_display_sequence=>22
,p_column_heading=>'Col22'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(242266756378871816)
,p_query_column_id=>23
,p_column_alias=>'COL23'
,p_column_display_sequence=>23
,p_column_heading=>'Col23'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(242266899545871817)
,p_query_column_id=>24
,p_column_alias=>'COL24'
,p_column_display_sequence=>24
,p_column_heading=>'Col24'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(242266960143871818)
,p_query_column_id=>25
,p_column_alias=>'COL25'
,p_column_display_sequence=>25
,p_column_heading=>'Col25'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(242267094550871819)
,p_query_column_id=>26
,p_column_alias=>'COL26'
,p_column_display_sequence=>26
,p_column_heading=>'Col26'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(242267186646871820)
,p_query_column_id=>27
,p_column_alias=>'COL27'
,p_column_display_sequence=>27
,p_column_heading=>'Col27'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(242267279147871821)
,p_query_column_id=>28
,p_column_alias=>'COL28'
,p_column_display_sequence=>28
,p_column_heading=>'Col28'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(242267375873871822)
,p_query_column_id=>29
,p_column_alias=>'COL29'
,p_column_display_sequence=>29
,p_column_heading=>'Col29'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(242267400443871823)
,p_query_column_id=>30
,p_column_alias=>'COL30'
,p_column_display_sequence=>30
,p_column_heading=>'Col30'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(242267554898871824)
,p_query_column_id=>31
,p_column_alias=>'COL31'
,p_column_display_sequence=>31
,p_column_heading=>'Col31'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(242267674725871825)
,p_query_column_id=>32
,p_column_alias=>'COL32'
,p_column_display_sequence=>32
,p_column_heading=>'Col32'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(242267764665871826)
,p_query_column_id=>33
,p_column_alias=>'COL33'
,p_column_display_sequence=>33
,p_column_heading=>'Col33'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(242267828445871827)
,p_query_column_id=>34
,p_column_alias=>'COL34'
,p_column_display_sequence=>34
,p_column_heading=>'Col34'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(242267931593871828)
,p_query_column_id=>35
,p_column_alias=>'COL35'
,p_column_display_sequence=>35
,p_column_heading=>'Col35'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(242268083303871829)
,p_query_column_id=>36
,p_column_alias=>'COL36'
,p_column_display_sequence=>36
,p_column_heading=>'Col36'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(242268105007871830)
,p_query_column_id=>37
,p_column_alias=>'COL37'
,p_column_display_sequence=>37
,p_column_heading=>'Col37'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(242268216896871831)
,p_query_column_id=>38
,p_column_alias=>'COL38'
,p_column_display_sequence=>38
,p_column_heading=>'Col38'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(242268342279871832)
,p_query_column_id=>39
,p_column_alias=>'COL39'
,p_column_display_sequence=>39
,p_column_heading=>'Col39'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(242268454785871833)
,p_query_column_id=>40
,p_column_alias=>'COL40'
,p_column_display_sequence=>40
,p_column_heading=>'Col40'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(694765349523438236)
,p_name=>'Response Headers'
,p_parent_plug_id=>wwv_flow_imp.id(468890865757100776)
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--scrollAuto:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch:a-Report--rowHighlight'
,p_region_attributes=>'style="max-width: 100vw"'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c002 as header_name,',
'       c003 as header_value',
'  from wwv_flow_collections',
' where collection_name = ''WEB_SOURCE_INFO''',
'   and c001            = ''RESPONSE_HEADERS''',
' order by seq_id asc',
''))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(242218489290625631)
,p_query_column_id=>1
,p_column_alias=>'HEADER_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Header name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(242218874796625631)
,p_query_column_id=>2
,p_column_alias=>'HEADER_VALUE'
,p_column_display_sequence=>2
,p_column_heading=>'Header value'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(468890962246100777)
,p_plug_name=>'Failure'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P1927_STATUS_CODE'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3055962461758108)
,p_plug_name=>'HTTP Status'
,p_parent_plug_id=>wwv_flow_imp.id(468890962246100777)
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_header=>'Server responded with &P1927_STATUS_CODE.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(468891038148100778)
,p_name=>'Server Response'
,p_parent_plug_id=>wwv_flow_imp.id(468890962246100777)
,p_template=>wwv_flow_imp.id(689970285456172024)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sys.dbms_lob.substr( clob001, 4000, 1 ) as response',
'  from wwv_flow_collections ',
' where collection_name = ''WEB_SOURCE_INFO''',
'   and c001            = ''ERROR''',
''))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(242219858030625633)
,p_query_column_id=>1
,p_column_alias=>'RESPONSE'
,p_column_display_sequence=>1
,p_column_heading=>'Response'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(472057438250098016)
,p_plug_name=>'RDS'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_display_condition_type=>'ITEM_IS_NULL'
,p_plug_display_when_condition=>'P1927_STATUS_CODE'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'N',
  'rds_mode', 'STANDARD',
  'remember_selection', 'NO')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(472098857550311892)
,p_plug_name=>'Test Results'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(310376862836241839)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(472098857550311892)
,p_button_name=>'BACK'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Go Back'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1921:&SESSION.::&DEBUG.:RP,1927,1922::'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1401695607748301)
,p_name=>'P1927_RESPONSE_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(468890865757100776)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1401853198748303)
,p_name=>'P1927_RESPONSE_LENGTH'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(468890865757100776)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1401959648748304)
,p_name=>'P1927_BODY_PART'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(468890865757100776)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(236248174846284216)
,p_name=>'P1927_WEB_SRC_OPERATION_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(472098857550311892)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(242220240098625634)
,p_name=>'P1927_STATUS_CODE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(468891038148100778)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(242268601782871835)
,p_computation_sequence=>10
,p_computation_item=>'P1927_STATUS_CODE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c002',
'  from wwv_flow_collections ',
' where collection_name = ''WEB_SOURCE_INFO''',
'   and c001            = ''ERROR''',
'   and rownum          = 1;',
'   ',
''))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1401718781748302)
,p_computation_sequence=>20
,p_computation_item=>'P1927_RESPONSE_TYPE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
' select c004',
'   from wwv_flow_collections ',
'  where collection_name = ''WEB_SOURCE_INFO''',
'    and c001            = ''DATA_PROFILE'';'))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(236247904415284214)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Test REST Data Source'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin    wwv_flow_web_src_dev.test_web_src_operation(',
'        p_web_src_module_id    => :P1921_WEB_SRC_MODULE_ID,',
'        p_web_src_operation_id => :P1927_WEB_SRC_OPERATION_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>236247904415284214
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1402073230748305)
,p_process_sequence=>10
,p_process_point=>'BEFORE_BOX_BODY'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Init Values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    select round(sys.dbms_lob.getlength(clob001) / 1000), -- transform to kilobytes',
'           substr(clob001, 1, 500)',
'      into :P1927_RESPONSE_LENGTH,',
'           :P1927_BODY_PART',
'      from wwv_flow_collections ',
'     where collection_name = ''WEB_SOURCE_INFO'' ',
'       and c001            = ''DATA'' ',
'       and rownum          = 1;',
'exception',
'    when no_data_found then',
'        null;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>1402073230748305
);
end;
/
prompt --application/pages/page_01928
begin
wwv_flow_imp_page.create_page(
 p_id=>1928
,p_name=>'Refresh from REST Source Catalog'
,p_alias=>'REFRESH-FROM-CATALOG'
,p_page_mode=>'MODAL'
,p_step_title=>'Refresh from REST Source Catalog'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_dialog_height=>'400'
,p_dialog_width=>'640'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'No help is available for this page.'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(936806476498447829)
,p_plug_name=>'Dialog Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(936806856479447833)
,p_plug_name=>'Refresh from REST Source Catalog'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Please confirm that you wish to refresh the REST Data Source from the REST Source Catalog. Note that any changes made to the REST Data Source will be replaced after the refresh.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4001102700254175)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(936806476498447829)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4001571807254178)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(936806476498447829)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Refresh from Service Catalog'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4003078653254221)
,p_branch_name=>'Back to REST Data Source'
,p_branch_action=>'f?p=&APP_ID.:1921:&SESSION.::&DEBUG.:RP:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(4001571807254178)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2983286949967549)
,p_name=>'P1928_MODULE_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(936806856479447833)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4003482633287602)
,p_name=>'P1928_SERVICE_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(936806856479447833)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4003524501287603)
,p_name=>'P1928_CATALOG_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(936806856479447833)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4003684124287604)
,p_name=>'P1928_CATALOG_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(936806856479447833)
,p_prompt=>'Catalog'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Name of the Catalog from which this REST Data Source will be refreshed.'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4003742135287605)
,p_name=>'P1928_SERVICE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(936806856479447833)
,p_prompt=>'Service'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Name of the service within the Catalog, from which this REST Data Source will be refreshed.'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2983337555967550)
,p_name=>'New'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(4001102700254175)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4003330527287601)
,p_event_id=>wwv_flow_imp.id(2983337555967550)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4003836412287606)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Populate Catalog and Service'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    select c.id            as catalog_id, ',
'           c.name          as catalog_name, ',
'           s.id            as service_id, ',
'           s.name          as service_name',
'      into :P1928_CATALOG_ID, :P1928_CATALOG_NAME, :P1928_SERVICE_ID, :P1928_SERVICE_NAME',
'      from wwv_flow_web_src_modules     m,',
'           wwv_web_src_catalogs         c,',
'           wwv_web_src_catalog_services s',
'     where c.internal_name     = m.catalog_internal_name ',
'       and s.name              = m.catalog_service_name ',
'       and c.security_group_id = m.security_group_id',
'       and c.id                = s.catalog_id',
'       and s.security_group_id = m.security_group_id',
'       --',
'       and m.id                = :P1928_MODULE_ID',
'       and m.flow_id           = :FB_FLOW_ID',
'       and m.security_group_id = :WORKSPACE_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>4003836412287606
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4002531688254219)
,p_process_sequence=>20
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh Catalog'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_installed_plugins  wwv_flow_t_varchar2;',
'    l_credential_id      number;',
'',
'begin',
'    -- if a module_id is passed in then the procedure will refresh from the',
'    -- the catalog instead of creating a new service. But, we need to ',
'    -- provide the catalog_id and service_id. The module saves the names',
'    -- so run a query to get the ids. ',
'    ',
'     wwv_web_src_catalog.rest_source_from_catalog(',
'        p_catalog_id        => :P1928_CATALOG_ID,',
'        p_service_id        => :P1928_SERVICE_ID,',
'        p_credential_id     => l_credential_id,',
'        --',
'        p_application_id    => :FB_FLOW_ID,',
'        p_module_id         => :P1928_MODULE_ID, ',
'        -- just here because no default in the procedure declaration',
'        p_installed_plugins => l_installed_plugins );',
'end;',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error refreshing REST Data Source.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(4001571807254178)
,p_process_success_message=>'REST Data Source has been refreshed.'
,p_internal_uid=>4002531688254219
);
end;
/
prompt --application/pages/page_01931
begin
wwv_flow_imp_page.create_page(
 p_id=>1931
,p_name=>'Remote Servers'
,p_alias=>'REMOTE-SERVERS'
,p_step_title=>'Remote Servers'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(161024368419385205)
,p_plug_name=>'tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_imp.id(533145899605135270)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(225855266184926518)
,p_plug_name=>'Remote Servers'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>REST Data Source server information is stored as a <strong>Remote Server</strong> object. Remote Servers can be shared among multiple REST Data Sources. Changing Remote Server properties affects all REST Data Sources referencing that object (for e'
||'xample, you can change a Remote Server Object from a testing to a production system).</p>',
'',
'<p>Remote Servers are stored at the workspace level and therefore are visible in all applications. When you export an application, used Remote Servers are added to the export file. When you import the application into another workspace, &PRODUCT_NAME'
||'. checks whether the target workspace already contains Remote Servers with the same <strong>static ID</strong>. If a Remote Server already exists, the application uses it. Otherwise the Remote Servers from the import file are created in the target wo'
||'rkspace.</p>'))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(249349483233883038)
,p_plug_name=>'Remote Servers'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with data as (',
'    select s.id,',
'           s.name,',
'           s.server_type,',
'           s.base_url,',
'           s.static_id,',
'           count(m.id)  module_references,',
'           count(ma.id) auth_references,',
'           count(f.id)  app_references',
'      from wwv_remote_servers s',
'           left outer join wwv_flow_web_src_modules m ',
'                      on (     s.security_group_id = m.security_group_id',
'                           and s.id                = m.remote_server_id )',
'           left outer join wwv_flow_web_src_modules ma ',
'                      on (     s.security_group_id = ma.security_group_id',
'                           and s.id                = ma.auth_remote_server_id )',
'           left outer join wwv_flows f ',
'                      on (     s.security_group_id = f.security_group_id',
'                           and (    s.id = f.print_remote_server_id ',
'                                 or s.id = f.file_remote_server_id ) )',
'        --',
'     where s.server_type       in ( ''WEB_SERVICE'', ''AUTHENTICATION'', ''PRINT_SERVER'', ''CLOUD_OBJECT_STORE'' )',
'       and s.security_group_id  = :FLOW_SECURITY_GROUP_ID',
'       and not exists ( select 1 ',
'                          from wwv_flow_language_map ',
'                         where translation_flow_id in ( m.flow_id, ma.flow_id, f.id ) )',
'     group by s.id, s.name, s.server_type, s.base_url, s.static_id, s.credential_id',
') ',
'select ',
'    id,',
'    name,',
'    server_type,',
'    base_url,',
'    static_id,',
'    module_references + auth_references + app_references as references',
'from data',
''))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(249349528073883039)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'No Remote Servers found in this workspace.'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_rows_per_page=>'N'
,p_show_control_break=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_pivot=>'N'
,p_show_flashback=>'N'
,p_show_download=>'N'
,p_enable_mail_download=>'Y'
,p_owner=>'CARSTEN'
,p_internal_uid=>249349528073883039
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(249349684775883040)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(249349718003883041)
,p_db_column_name=>'NAME'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Name'
,p_column_link=>'f?p=&APP_ID.:1932:&SESSION.::&DEBUG.:RP:P1932_ID,P1932_BACK_TO_PAGE:#ID#,'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(249349834948883042)
,p_db_column_name=>'BASE_URL'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Base URL'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(249350056390883044)
,p_db_column_name=>'REFERENCES'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>'References'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(522796703180429235)
,p_db_column_name=>'SERVER_TYPE'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>'Server Type'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(154020705287547277)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(177068151888885504)
,p_db_column_name=>'STATIC_ID'
,p_display_order=>70
,p_column_identifier=>'G'
,p_column_label=>'Static Identifier'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(309920184639832447)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'3099202'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'NAME:SERVER_TYPE:BASE_URL:REFERENCES:STATIC_ID'
,p_sort_column_1=>'NAME'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'0'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(712704529235086539)
,p_plug_name=>'Learn More'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="padding: 0 12px 12px 12px;"'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'sys.htp.p(''<p><a href="&SYSTEM_HELP_URL." target="_blank">''||wwv_flow_lang.system_message(''LEARN MORE'')||'' ...</a></p>'');'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(225855133192926517)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(249349483233883038)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1932:&SESSION.::&DEBUG.:RP,1932::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(525230224885218512)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete unused remote servers'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for s in (',
'        with data as (',
'            select s.id,',
'                   s.name,',
'                   s.server_type,',
'                   s.base_url,',
'                   case when s.credential_id is not null then ''Y'' else ''N'' end as auth_required,',
'                   count(m.id) module_references,',
'                   count(ma.id) auth_references',
'              from wwv_remote_servers s ',
'                  left outer join wwv_flow_web_src_modules m on ( s.id = m.remote_server_id )',
'                  left outer join wwv_flow_web_src_modules ma on ( s.id = ma.auth_remote_server_id )',
'             where s.server_type in ( ''WEB_SERVICE'', ''AUTHENTICATION'', ''CLOUD_OBJECT_STORE'' )',
'               and s.security_group_id = :FLOW_SECURITY_GROUP_ID',
'             group by s.id, s.name, s.server_type, s.base_url, s.credential_id',
'        ) ',
'        select id',
'          from data',
'        where module_references + auth_references = 0 )',
'   loop',
'       delete wwv_remote_servers ',
'        where id                = s.id',
'          and security_group_id = :FLOW_SECURITY_GROUP_ID;',
'         ',
'   end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Unused remote servers deleted.'
,p_internal_uid=>525230224885218512
);
end;
/
prompt --application/pages/page_01932
begin
wwv_flow_imp_page.create_page(
 p_id=>1932
,p_name=>'Edit Remote Server'
,p_alias=>'EDIT-REMOTE-SERVER'
,p_page_mode=>'MODAL'
,p_step_title=>'Edit Remote Server'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'600'
,p_dialog_width=>'80%'
,p_dialog_max_width=>'1000'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(225855374821926519)
,p_plug_name=>'General'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(225856153590926527)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(225856843527926534)
,p_plug_name=>'Advanced'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(225857020219926536)
,p_plug_name=>'Information'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--simple:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>The server information of a REST Data Source is stored as a <strong>Remote Server</strong> object. Remote Servers can be shared among multiple REST Data Sources. Changing Remote Server properties affects all REST Sources referencing that object. F'
||'or example, by changing a Remote Server''s <strong>Base URL</strong>, all associated REST Sources are moved from a test to a production system.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(225856372419926529)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(225856153590926527)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'CREATE'
,p_button_condition=>'P1932_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(225856224023926528)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(225856153590926527)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
,p_button_condition=>'P1932_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(225856518442926531)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(225856153590926527)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'DELETE'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'', ''DELETE'');'
,p_button_condition=>'P1932_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(225856433876926530)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(225856153590926527)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1931:&SESSION.::&DEBUG.:RP,1932::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(55558467552883026)
,p_branch_action=>'f?p=&APP_ID.:&P1932_BACK_TO_PAGE.:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'ITEM_IS_NOT_NULL'
,p_branch_condition=>'P1932_BACK_TO_PAGE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3403061389415708630)
,p_branch_name=>'Go To Page 1931'
,p_branch_action=>'f?p=&APP_ID.:1931:&SESSION.::&DEBUG.:RP,1932::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4560375580142239)
,p_name=>'P1932_PRINT_SERVER_TYPE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(225855374821926519)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Print Server Type'
,p_source=>'PRINT_SERVER_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PRINT_SERVER_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(6300179213172122)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select the appropriate option:',
'<ul>',
'<li><strong>Oracle Analytics Publisher</strong> - Select this option if you are using a licensed version of Oracle Analytics Publisher. This option enables you to take report query results and convert them from XML to RTF format using Oracle Analytic'
||'s Publisher. Select this option if you want to upload your own customized RTF or XSL-FO templates for printing reports within &PRODUCT_NAME..</li>',
'<li><strong>APEX Office Print</strong> - Select this option if you are using APEX Office Print.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10646317982074436)
,p_name=>'P1932_PRINT_SERVER_TIMEOUT'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(225855374821926519)
,p_use_cache_before_default=>'NO'
,p_item_default=>'300'
,p_prompt=>'Print Timeout'
,p_source=>'SERVER_TIMEOUT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Defines the transfer timeout for communicating with the print server in seconds.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(55558506502883027)
,p_name=>'P1932_BACK_TO_PAGE'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(225855374821926519)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225855459384926520)
,p_name=>'P1932_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(225855374821926519)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225855755385926523)
,p_name=>'P1932_NAME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(225855374821926519)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a name for the remote server object here. Remote Server names must be unique within the workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225855813992926524)
,p_name=>'P1932_BASE_URL'
,p_is_required=>true
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(225855374821926519)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Endpoint URL'
,p_source=>'BASE_URL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>75
,p_cMaxlength=>500
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the Endpoint URL of the remote server. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225855914889926525)
,p_name=>'P1932_CREDENTIAL_ID'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(225855374821926519)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Web Credential'
,p_source=>'CREDENTIAL_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LOV_CREDENTIAL_STORES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_credentials',
' where security_group_id    = :FLOW_SECURITY_GROUP_ID',
'   and authentication_type != ''KEY_PAIR'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'No Credential'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose stored Credentials for Authentication.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225856064530926526)
,p_name=>'P1932_SERVER_COMMENT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(225856843527926534)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comments'
,p_source=>'SERVER_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter any developer comments or notes here. These comments only display within App Builder and never display when running the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225856943196926535)
,p_name=>'P1932_HTTPS_HOST'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(225856843527926534)
,p_use_cache_before_default=>'NO'
,p_prompt=>'HTTPS Host Name'
,p_source=>'HTTPS_HOST'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>500
,p_display_when=>'wwv_flow_utilities.db_version_is_at_least(''12.2'')'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The host name to be matched against the common name (CN) of the remote server''s certificate for an HTTPS request. It can also be a domain name like *.example.com. If NULL, the host name in the given URL will be used.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(522796683482429234)
,p_name=>'P1932_STATIC_ID'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(225856843527926534)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Static Identifier'
,p_source=>'STATIC_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Use the Static ID to reference the Remote Server in API calls.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(522796826390429236)
,p_name=>'P1932_TYPE'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(225855374821926519)
,p_use_cache_before_default=>'NO'
,p_item_default=>'WEB_SERVICE'
,p_prompt=>'Server Type'
,p_source=>'SERVER_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REMOTE_SERVER_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(154020705287547277)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select the appropriate option:',
'<ul>',
'<li><strong>REST Data Source</strong> - Select this option if you are using the server to consume a remote REST API.</li>',
'</ul>',
'<li><strong>Authentication</strong> - Select this option if you are using the remote server for authentication.</li>',
'<li><strong>Print Server</strong> - Select this option if you are using an external print server.</li>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(537043795794394630)
,p_name=>'P1932_PROMPT_ON_INSTALL'
,p_is_required=>true
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(225855374821926519)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Prompt on Install'
,p_source=>'PROMPT_ON_INSTALL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select <strong>On</strong> to have &PRODUCT_NAME. prompt for the Base URL after the application installs into another workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1421872566786014)
,p_computation_sequence=>10
,p_computation_item=>'P1932_PRINT_SERVER_TYPE'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P1932_TYPE'
,p_compute_when_text=>'PRINT_SERVER'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(10646711348074440)
,p_computation_sequence=>20
,p_computation_item=>'P1932_PRINT_SERVER_TIMEOUT'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P1932_TYPE'
,p_compute_when_text=>'PRINT_SERVER'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1421742524786013)
,p_computation_sequence=>10
,p_computation_item=>'P1932_PRINT_SERVER_TYPE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'BIP'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(525232278373218532)
,p_validation_name=>'Name must be unique'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'  from wwv_remote_servers',
' where name = :P1932_NAME',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Remote Server name must be unique'
,p_when_button_pressed=>wwv_flow_imp.id(225856224023926528)
,p_associated_item=>wwv_flow_imp.id(225855755385926523)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(525232470082218534)
,p_validation_name=>'Static ID must be unique'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'  from wwv_remote_servers',
' where static_id = :P1932_STATIC_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Remote Server static ID must be unique'
,p_when_button_pressed=>wwv_flow_imp.id(225856224023926528)
,p_associated_item=>wwv_flow_imp.id(522796683482429234)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(525232563615218535)
,p_validation_name=>'URL must start with http or https'
,p_validation_sequence=>30
,p_validation=>'substr( :P1932_BASE_URL, 1, 8 ) = ''https://'' or substr( :P1932_BASE_URL, 1, 7 ) = ''http://'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Base URL must start with http:// or https://'
,p_validation_condition=>'APPLY_CHANGES:CREATE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(225855813992926524)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(537042329937394616)
,p_validation_name=>'Cannot delete used Remote Server'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select s.id',
'  from wwv_remote_servers s ',
' where exists( select 1 ',
'                 from wwv_flow_web_src_modules m ',
'                where m.security_group_id = s.security_group_id',
'                  and (    m.remote_server_id      = s.id ',
'                        or m.auth_remote_server_id = s.id ) )',
'   and s.server_type       in ( ''WEB_SERVICE'', ''AUTHENTICATION'' )',
'   and s.security_group_id  = :FLOW_SECURITY_GROUP_ID',
'   and s.id                 = :P1932_ID',
'union all',
'select s.id',
'  from wwv_remote_servers s ',
' where s.security_group_id  = :FLOW_SECURITY_GROUP_ID',
'   and s.id                 = :P1932_ID',
'   and (    exists ( select 1',
'                       from wwv_flows f',
'                      where f.file_remote_server_id = s.id',
'                        and f.security_group_id     = s.security_group_id )',
'         or exists ( select 1',
'                       from wwv_flows f',
'                      where f.print_remote_server_id = s.id',
'                        and f.security_group_id      = s.security_group_id ) )'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Remote Server is in use and cannot be deleted.'
,p_when_button_pressed=>wwv_flow_imp.id(225856518442926531)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(249348433251883028)
,p_name=>'Show HTTPS HOST for HTTPS URL'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1932_BASE_URL'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$v("P1932_BASE_URL").startsWith("https://")'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>'wwv_flow_utilities.db_version_is_at_least(''12.2'')'
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(249348581714883029)
,p_event_id=>wwv_flow_imp.id(249348433251883028)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1932_HTTPS_HOST'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(249348633948883030)
,p_event_id=>wwv_flow_imp.id(249348433251883028)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1932_HTTPS_HOST'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(522796914255429237)
,p_name=>'Set Static ID'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1932_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(522797041909429238)
,p_event_id=>wwv_flow_imp.id(522796914255429237)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1932_STATIC_ID'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$v("P1932_NAME").replace(/[^a-zA-Z0-9]+/g, "_")'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(10646473304074437)
,p_name=>'On print server'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1932_TYPE'
,p_condition_element=>'P1932_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'PRINT_SERVER'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(10646576790074438)
,p_event_id=>wwv_flow_imp.id(10646473304074437)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1932_PRINT_SERVER_TIMEOUT,P1932_PRINT_SERVER_TYPE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(10646607485074439)
,p_event_id=>wwv_flow_imp.id(10646473304074437)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1932_PRINT_SERVER_TIMEOUT,P1932_PRINT_SERVER_TYPE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2174822746423029)
,p_name=>'On File Server'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1932_TYPE'
,p_condition_element=>'P1932_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'CLOUD_OBJECT_STORE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2174941004423030)
,p_event_id=>wwv_flow_imp.id(2174822746423029)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1932_CREDENTIAL_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2175022916423031)
,p_event_id=>wwv_flow_imp.id(2174822746423029)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1932_CREDENTIAL_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2175199584423032)
,p_event_id=>wwv_flow_imp.id(2174822746423029)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1932_CREDENTIAL_ID'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(225858251877926548)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_REMOTE_SERVERS'
,p_attribute_02=>'WWV_REMOTE_SERVERS'
,p_attribute_03=>'P1932_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id = :FLOW_SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>225858251877926548
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(225855586024926521)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch row from WWV_REMOTE_SERVERS'
,p_attribute_02=>'WWV_REMOTE_SERVERS'
,p_attribute_03=>'P1932_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id = :FLOW_SECURITY_GROUP_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>225855586024926521
);
end;
/
prompt --application/pages/page_01933
begin
wwv_flow_imp_page.create_page(
 p_id=>1933
,p_name=>'Utilization'
,p_alias=>'UTILIZATION2'
,p_step_title=>'Utilization'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(694160002983515914)
,p_plug_name=>'tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_imp.id(533145899605135270)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(758990900749057227)
,p_plug_name=>'Utilization'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Review where Remote Server objects are being used within this workspace.</p>',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(782485117798013747)
,p_plug_name=>'Remote Server Usage'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select s.id,',
'       s.name,',
'       s.server_type,',
'       s.base_url,',
'       m.flow_id as application_id,',
'       m.name as component_name,',
'       1921 as page_id,',
'       ''P1921_WEB_SRC_MODULE_ID'' as item_name,',
'       m.id as item_value ',
'  from wwv_remote_servers s,',
'       wwv_flow_web_src_modules m',
' where s.id = m.remote_server_id',
'   and s.server_type = ''WEB_SERVICE''',
'   and s.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and not exists (select 1 from wwv_flow_language_map where TRANSLATION_FLOW_ID = m.flow_id)',
'union all',
'select s.id,',
'       s.name,',
'       s.server_type,',
'       s.base_url,',
'       m.flow_id as application_id,',
'       m.name as component_name,',
'       1921 as page_id,',
'       ''P1921_WEB_SRC_MODULE_ID'' as item_name,',
'       m.id as item_value',
'  from wwv_remote_servers s,',
'       wwv_flow_web_src_modules m',
' where s.id = m.auth_remote_server_id',
'   and s.server_type = ''AUTHENTICATION''',
'   and s.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and not exists (select 1 from wwv_flow_language_map where TRANSLATION_FLOW_ID = m.flow_id)',
'union all',
'select s.id,',
'       s.name,',
'       s.server_type,',
'       s.base_url,',
'       f.id as application_id,',
'       wwv_flow_lang.system_message( ''F4000.APP_REMOTE_PRINT_SERVER'', f.id ) component_name,',
'       4001 as page_id,',
'       null item_name,',
'       null item_value',
'  from wwv_remote_servers s,',
'       wwv_flows f',
' where s.id = f.print_remote_server_id',
'   and s.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and not exists (select 1 from wwv_flow_language_map where TRANSLATION_FLOW_ID = f.id)'))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(782485162638013748)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'No used remote servers found in this workspace.'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_rows_per_page=>'N'
,p_show_control_break=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_pivot=>'N'
,p_show_flashback=>'N'
,p_show_download=>'N'
,p_enable_mail_download=>'N'
,p_owner=>'CARSTEN'
,p_internal_uid=>782485162638013748
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(533136960458130732)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(533137382305130737)
,p_db_column_name=>'NAME'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Name'
,p_column_link=>'f?p=&APP_ID.:1932:&SESSION.::&DEBUG.:RP:P1932_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(533137736880130737)
,p_db_column_name=>'BASE_URL'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Base URL'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(533138950303130738)
,p_db_column_name=>'SERVER_TYPE'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>'Server Type'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(154020705287547277)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(529222995957107549)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>70
,p_column_identifier=>'G'
,p_column_label=>'Application ID'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1378288891662029928)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>80
,p_column_identifier=>'J'
,p_column_label=>'Component Name'
,p_column_link=>'f?p=&APP_ID.:#PAGE_ID#:&SESSION.::&DEBUG.:Y,#PAGE_ID#:FB_FLOW_ID,#ITEM_NAME#:#APPLICATION_ID#,#ITEM_VALUE#'
,p_column_linktext=>'#COMPONENT_NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1378288999609029929)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>90
,p_column_identifier=>'K'
,p_column_label=>'Page Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1378289075149029930)
,p_db_column_name=>'ITEM_NAME'
,p_display_order=>100
,p_column_identifier=>'L'
,p_column_label=>'Item Name'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1378289162689029931)
,p_db_column_name=>'ITEM_VALUE'
,p_display_order=>110
,p_column_identifier=>'M'
,p_column_label=>'Item Value'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(843055819203963156)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'5331393'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'NAME:SERVER_TYPE:BASE_URL::APPLICATION_ID:COMPONENT_NAME:PAGE_ID:ITEM_NAME:ITEM_VALUE'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1058364853067349211)
,p_plug_name=>'Unused Remote Servers'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with data as (',
'    select s.id,',
'           s.name,',
'           s.server_type,',
'           s.base_url,',
'           case when s.credential_id is not null then ''Y'' else ''N'' end as auth_required,',
'           count(m.id) module_references,',
'           count(ma.id) auth_references,',
'           count(f.id) print_references',
'      from wwv_remote_servers s ',
'          left outer join wwv_flow_web_src_modules m on ( s.id = m.remote_server_id )',
'          left outer join wwv_flow_web_src_modules ma on ( s.id = ma.auth_remote_server_id )',
'          left outer join wwv_flows f on ( s.id = f.print_remote_server_id )',
'     where s.server_type in ( ''WEB_SERVICE'', ''AUTHENTICATION'', ''PRINT_SERVER'' )',
'       and s.security_group_id = :FLOW_SECURITY_GROUP_ID',
'     group by s.id, s.name, s.server_type, s.base_url, s.credential_id',
') ',
'select ',
'    id,',
'    name,',
'    server_type,',
'    base_url,',
'    auth_required',
'   from data',
'where module_references + auth_references + print_references = 0'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with data as (',
'    select s.id,',
'           s.name,',
'           s.server_type,',
'           s.base_url,',
'           case when s.credential_id is not null then ''Y'' else ''N'' end as auth_required,',
'           count(m.id) module_references,',
'           count(ma.id) auth_references',
'      from wwv_remote_servers s ',
'          left outer join wwv_flow_web_src_modules m on ( s.id = m.remote_server_id )',
'          left outer join wwv_flow_web_src_modules ma on ( s.id = ma.auth_remote_server_id )',
'     where s.server_type in ( ''WEB_SERVICE'', ''AUTHENTICATION'' )',
'       and s.security_group_id = :FLOW_SECURITY_GROUP_ID',
'     group by s.id, s.name, s.server_type, s.base_url, s.credential_id',
') ',
'select ',
'    id,',
'    name,',
'    server_type,',
'    base_url,',
'    auth_required',
'   from data',
'where module_references + auth_references = 0'))
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(1058365111904349213)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'No unused Remote Servers found in this workspace.'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_rows_per_page=>'N'
,p_show_control_break=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_pivot=>'N'
,p_show_flashback=>'N'
,p_show_download=>'N'
,p_enable_mail_download=>'N'
,p_owner=>'CARSTEN'
,p_internal_uid=>1058365111904349213
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(533140427417130741)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(533140833852130742)
,p_db_column_name=>'NAME'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Name'
,p_column_link=>'f?p=&APP_ID.:1932:&SESSION.::&DEBUG.:RP:P1932_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(533141216969130742)
,p_db_column_name=>'BASE_URL'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Base URL'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(533141637921130742)
,p_db_column_name=>'AUTH_REQUIRED'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Authentication'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(84259319526460470)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(533142073386130743)
,p_db_column_name=>'SERVER_TYPE'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>'Server Type'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(154020705287547277)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(1058371995619355972)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'5331424'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'ID:NAME:BASE_URL:AUTH_REQUIRED:REFERENCES:SERVER_TYPE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(533142832128130743)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1058364853067349211)
,p_button_name=>'DELETE_UNUSED'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete Unused'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(533143684796130751)
,p_name=>'Click'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(533142832128130743)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(533144620373130752)
,p_event_id=>wwv_flow_imp.id(533143684796130751)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'Do you really want to delete all unused Remote Server objects in your workspace?'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(533144151502130752)
,p_event_id=>wwv_flow_imp.id(533143684796130751)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'DELETE_UNUSED'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(533143247618130750)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete unused remote servers'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for s in (',
'        with data as (',
'            select s.id,',
'                   s.name,',
'                   s.server_type,',
'                   s.base_url,',
'                   case when s.credential_id is not null then ''Y'' else ''N'' end as auth_required,',
'                   count(m.id) module_references,',
'                   count(ma.id) auth_references',
'              from wwv_remote_servers s ',
'                  left outer join wwv_flow_web_src_modules m on ( s.id = m.remote_server_id )',
'                  left outer join wwv_flow_web_src_modules ma on ( s.id = ma.auth_remote_server_id )',
'             where s.server_type in ( ''WEB_SERVICE'', ''AUTHENTICATION'' )',
'               and s.security_group_id = :FLOW_SECURITY_GROUP_ID',
'             group by s.id, s.name, s.server_type, s.base_url, s.credential_id',
'        ) ',
'        select id',
'          from data',
'        where module_references + auth_references = 0 )',
'   loop',
'       delete wwv_remote_servers ',
'        where id                = s.id',
'          and security_group_id = :FLOW_SECURITY_GROUP_ID;',
'         ',
'   end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(533142832128130743)
,p_process_success_message=>'Unused remote servers deleted.'
,p_internal_uid=>533143247618130750
);
end;
/
prompt --application/pages/page_01934
begin
wwv_flow_imp_page.create_page(
 p_id=>1934
,p_name=>'History'
,p_alias=>'HISTORY1'
,p_step_title=>'History'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(533152446813172812)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_REMOTE_SERVERS'''))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(533152585143172813)
,p_max_row_count=>'1000000'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'CARSTEN'
,p_internal_uid=>533152585143172813
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(533152732484172815)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Audit Date'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(533152819773172816)
,p_db_column_name=>'ACTION'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(533152687001172814)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>40
,p_column_identifier=>'A'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(533152979985172817)
,p_db_column_name=>'SCN'
,p_display_order=>50
,p_column_identifier=>'D'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(533153046209172818)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>60
,p_column_identifier=>'E'
,p_column_label=>'Audit Comment'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(533153165421172819)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>70
,p_column_identifier=>'F'
,p_column_label=>'Component Key'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(533153201870172820)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>80
,p_column_identifier=>'G'
,p_column_label=>'Component Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(533209906239333896)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'5332100'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'AUDIT_DATE:ACTION:DEVELOPER:COMPONENT_NAME:'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1227336961892811571)
,p_plug_name=>'tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_imp.id(533145899605135270)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1292167859658352884)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>'<p>This page displays recent modifications made to Remote Servers in this workspace.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(533185100368295695)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete unused remote servers'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for s in (',
'        with data as (',
'            select s.id,',
'                   s.name,',
'                   s.server_type,',
'                   s.base_url,',
'                   case when s.credential_id is not null then ''Y'' else ''N'' end as auth_required,',
'                   count(m.id) module_references,',
'                   count(ma.id) auth_references',
'              from wwv_remote_servers s ',
'                  left outer join wwv_flow_web_src_modules m on ( s.id = m.remote_server_id )',
'                  left outer join wwv_flow_web_src_modules ma on ( s.id = ma.auth_remote_server_id )',
'             where s.server_type in ( ''WEB_SERVICE'', ''AUTHENTICATION'' )',
'               and s.security_group_id = :FLOW_SECURITY_GROUP_ID',
'             group by s.id, s.name, s.server_type, s.base_url, s.credential_id',
'        ) ',
'        select id',
'          from data',
'        where module_references + auth_references = 0 )',
'   loop',
'       delete wwv_remote_servers ',
'        where id                = s.id',
'          and security_group_id = :FLOW_SECURITY_GROUP_ID;',
'         ',
'   end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Unused remote servers deleted.'
,p_internal_uid=>533185100368295695
);
end;
/
prompt --application/pages/page_01935
begin
wwv_flow_imp_page.create_page(
 p_id=>1935
,p_name=>'Add Remote Print Server'
,p_alias=>'ADD-REMOTE-PRINT-SERVER'
,p_page_mode=>'MODAL'
,p_step_title=>'Add Remote Print Server'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'450'
,p_dialog_attributes=>'resizable:true'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(608889265570440907)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_list_id=>wwv_flow_imp.id(608916658335678510)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(608889575089440910)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(608908559474641574)
,p_plug_name=>'Add Remote Print Server'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(609371704658163107)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(608889575089440910)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(608909627053641576)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(608889575089440910)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(608911252260641587)
,p_branch_name=>'Go To Page 1936'
,p_branch_action=>'f?p=&APP_ID.:1936:&SESSION.::&DEBUG.:CR,1936::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(608909627053641576)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(608889634955440911)
,p_name=>'P1935_BASE_URL'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(608908559474641574)
,p_prompt=>'Endpoint URL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>75
,p_cMaxlength=>500
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the Endpoint URL of the external print server. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(608889961436440914)
,p_name=>'P1935_HTTPS_HOST'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(608908559474641574)
,p_prompt=>'HTTPS Host Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>500
,p_display_when=>'wwv_flow_utilities.db_version_is_at_least(''12.2'')'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The host name to be matched against the common name (CN) of the remote server''s certificate for an HTTPS request. It can also be a domain name like *.example.com. If NULL, the host name in the given URL will be used.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(608891630760440931)
,p_name=>'P1935_NAME'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(608908559474641574)
,p_item_default=>'wwv_flow_lang.system_message( ''F4000.P1935.NAME'', :FB_FLOW_ID )'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Name'
,p_placeholder=>'255'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a name for the remote server object here. Remote Server names must be unique within the workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(608891758307440932)
,p_name=>'P1935_STATIC_ID'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(608908559474641574)
,p_prompt=>'Static Identifier'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Use the Static ID to reference the Remote Server in API calls.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(608909068580641575)
,p_name=>'P1935_PRINT_SERVER_TYPE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(608908559474641574)
,p_prompt=>'Print Server Type'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PRINT_SERVER_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(6300179213172122)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Select the Print Server type:',
'</p>',
'<ul>',
'<li><strong>Oracle Analytics Publisher</strong> - Select this option if you are using a licensed version of Oracle Analytics Publisher. This option enables you to take report query results and convert them from XML to RTF format using Oracle Analytic'
||'s Publisher. Select this option if you want to upload your own customized RTF or XSL-FO templates for printing reports within &PRODUCT_NAME..</li>',
'<li><strong>APEX Office Print</strong> - Select this option if you are using APEX Office Print.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(608892999424440944)
,p_validation_name=>'Name must be unique'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'  from wwv_remote_servers',
' where name = :P1935_NAME',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Remote Server name must be unique'
,p_associated_item=>wwv_flow_imp.id(608891630760440931)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(608893029688440945)
,p_validation_name=>'Static ID must be unique'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'  from wwv_remote_servers',
' where static_id = :P1935_STATIC_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Remote Server static ID must be unique'
,p_associated_item=>wwv_flow_imp.id(608891758307440932)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(608893108529440946)
,p_validation_name=>'URL must start with http or https'
,p_validation_sequence=>30
,p_validation=>'substr( :P1935_BASE_URL, 1, 8 ) = ''https://'' or substr( :P1935_BASE_URL, 1, 7 ) = ''http://'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Base URL must start with http:// or https://'
,p_associated_item=>wwv_flow_imp.id(608889634955440911)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(608891832708440933)
,p_name=>'Set Static ID'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1935_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(608891945092440934)
,p_event_id=>wwv_flow_imp.id(608891832708440933)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1935_STATIC_ID'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$v("P1935_NAME").replace(/[^a-zA-Z0-9]/g, "_")'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(608892295227440937)
,p_name=>'Set Base URL'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1935_PRINT_SERVER_TYPE'
,p_condition_element=>'P1935_PRINT_SERVER_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'AOP'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'ITEM_IS_NULL'
,p_display_when_cond=>'P1935_BASE_URL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(608892305809440938)
,p_event_id=>wwv_flow_imp.id(608892295227440937)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1935_BASE_URL'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'https://api.apexofficeprint.com/'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(608892405214440939)
,p_event_id=>wwv_flow_imp.id(608892295227440937)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1935_BASE_URL'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(608892555767440940)
,p_name=>'Show HTTPS HOST for HTTPS URL'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1935_BASE_URL'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$v("P1935_BASE_URL").startsWith("https://")'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(608892669125440941)
,p_event_id=>wwv_flow_imp.id(608892555767440940)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1935_HTTPS_HOST'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(608892725584440942)
,p_event_id=>wwv_flow_imp.id(608892555767440940)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1935_HTTPS_HOST'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(609371879846163108)
,p_name=>'Cancel Dialog'
,p_event_sequence=>60
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(609371704658163107)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(609371955935163109)
,p_event_id=>wwv_flow_imp.id(609371879846163108)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_01936
begin
wwv_flow_imp_page.create_page(
 p_id=>1936
,p_name=>'Add Remote Print Server Credentials'
,p_alias=>'ADD-REMOTE-PRINT-SERVER-CREDENTIALS'
,p_page_mode=>'MODAL'
,p_step_title=>'Add Remote Print Server Credentials'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(608890114414440916)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(608891030316440925)
,p_plug_name=>'Authentication Required'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(608892801836440943)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_imp.id(608916658335678510)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(608912244464641588)
,p_plug_name=>'Add Remote Print Server Credentials'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>30
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(609371248759163102)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(608890114414440916)
,p_button_name=>'APPLY'
,p_button_static_id=>'CREATE_AND_APPLY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(608913298839641588)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(608890114414440916)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1935:&SESSION.::&DEBUG.:1936::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(609371577554163105)
,p_branch_name=>'Branch To 4001'
,p_branch_action=>'f?p=&APP_ID.:4001:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(608890203624440917)
,p_name=>'P1936_CREDENTIALS_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(608912244464641588)
,p_item_default=>'P1935_NAME'
,p_item_default_type=>'ITEM'
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a descriptive name for the Web Credential. This name must be unique within the workspace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(608890321882440918)
,p_name=>'P1936_CREDENTIALS_STATIC_ID'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(608912244464641588)
,p_prompt=>'Static Identifier'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Use the Static ID to reference the Web Credential in API calls.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(608890495966440919)
,p_name=>'P1936_API_KEY'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(608912244464641588)
,p_prompt=>'API Key'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>70
,p_cMaxlength=>4000
,p_display_when=>'P1935_PRINT_SERVER_TYPE'
,p_display_when2=>'AOP'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the API key for Authentication. &PRODUCT_NAME. stores this information encrypted, so it cannot be retrieved back in clear text.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(608890680443440921)
,p_name=>'P1936_PASSWORD'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(608912244464641588)
,p_prompt=>'Password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>70
,p_cMaxlength=>4000
,p_tag_attributes=>'autocomplete="new-password"'
,p_display_when=>'P1935_PRINT_SERVER_TYPE'
,p_display_when2=>'BIP'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the Password for Basic Authentication. &PRODUCT_NAME. stores this information encrypted, so it cannot be retrieved back in clear text.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(608890733858440922)
,p_name=>'P1936_USERNAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(608912244464641588)
,p_prompt=>'Username'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>70
,p_cMaxlength=>4000
,p_display_when=>'P1935_PRINT_SERVER_TYPE'
,p_display_when2=>'BIP'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the Username for Basic Authentication. &PRODUCT_NAME. does not store this information encrypted.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(608912731401641588)
,p_name=>'P1936_AUTH_REQUIRED'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(608891030316440925)
,p_item_default=>'Y'
,p_prompt=>'Authentication Required'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Determines whether to use authentication for the remote print server. Available options include:</p>',
'<ul>',
'<li><strong>On</strong> - Authenticate the print server requests using a credential.</li>',
'<li><strong>Off</strong> - The print server requires no authentication.</li>',
'</ul>',
'<br/>',
'<p>Steps to re-use existing credentials for the remote print server:</p>',
'<ul>',
'<li>Disable <strong>Authentication Required</strong> and finish this wizard.</li>',
'<li>In Application Attributes, Report Printing enable <strong>Authentication Required</strong>.</li>',
'<li>Choose the existing Web Credential, and save.</li>',
'</ul>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(608893399112440948)
,p_validation_name=>'API not null for AOP'
,p_validation_sequence=>20
,p_validation=>'P1936_API_KEY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>':P1935_PRINT_SERVER_TYPE = ''AOP'' and :P1936_AUTH_REQUIRED = ''Y'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(608890495966440919)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(608893447684440949)
,p_validation_name=>'Username not null for BIP'
,p_validation_sequence=>30
,p_validation=>'P1936_USERNAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>':P1935_PRINT_SERVER_TYPE = ''BIP'' and :P1936_AUTH_REQUIRED = ''Y'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(608890733858440922)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(608893536877440950)
,p_validation_name=>'Password not null for BIP'
,p_validation_sequence=>40
,p_validation=>'P1936_PASSWORD'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>':P1935_PRINT_SERVER_TYPE = ''BIP'' and :P1936_AUTH_REQUIRED = ''Y'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(608890680443440921)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(608891183350440926)
,p_name=>'On Auth Required'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1936_AUTH_REQUIRED'
,p_condition_element=>'P1936_AUTH_REQUIRED'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(608891227806440927)
,p_event_id=>wwv_flow_imp.id(608891183350440926)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(608912244464641588)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(608891318934440928)
,p_event_id=>wwv_flow_imp.id(608891183350440926)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(608912244464641588)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(608891401725440929)
,p_name=>'Set Static ID'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1936_CREDENTIALS_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(608891575601440930)
,p_event_id=>wwv_flow_imp.id(608891401725440929)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1936_CREDENTIALS_STATIC_ID'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$v("P1936_CREDENTIALS_NAME").replace(/[^a-zA-Z0-9]/g, "_")'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(609371122508163101)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Save Remote Print Server'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_server_id         number;',
'    l_credential_id     number;',
'    l_client_secret     wwv_credentials_dev.client_secret%type;',
'begin',
'',
'    insert into wwv_remote_servers (',
'        name,',
'        static_id,',
'        base_url,',
'        server_type,',
'        https_host,',
'        prompt_on_install,',
'        print_server_type,',
'        server_timeout',
'    ) values (',
'        :P1935_NAME,',
'        :P1935_STATIC_ID,',
'        :P1935_BASE_URL,',
'        ''PRINT_SERVER'',',
'        :P1935_HTTPS_HOST,',
'        ''Y'',',
'        :P1935_PRINT_SERVER_TYPE,',
'        :P1935_SERVER_TIMEOUT )',
'    returning id into l_server_id;',
'',
'    if :P1936_AUTH_REQUIRED = ''Y'' then',
'    ',
'        insert into wwv_credentials (',
'            name,',
'            static_id,',
'            authentication_type,',
'            client_id,',
'            valid_for_urls,',
'            prompt_on_install',
'        ) values (',
'            :P1936_CREDENTIALS_NAME,',
'            :P1936_CREDENTIALS_STATIC_ID,',
'            case :P1935_PRINT_SERVER_TYPE ',
'                when ''BIP'' then ''BASIC''',
'                when ''AOP'' then ''HTTP_QUERY_STRING''',
'            end,',
'            case :P1935_PRINT_SERVER_TYPE ',
'                when ''BIP'' then :P1936_USERNAME ',
'                when ''AOP'' then ''api_key''',
'            end,',
'            :P1935_BASE_URL,',
'            ''Y'' )',
'        returning id into l_credential_id;',
'',
'        l_client_secret := ',
'            case :P1935_PRINT_SERVER_TYPE ',
'                when ''BIP'' then :P1936_PASSWORD',
'                when ''AOP'' then :P1936_API_KEY',
'            end;',
'',
'        update wwv_credentials_dev ',
'           set client_secret        = l_client_secret,',
'               client_secret_verify = l_client_secret',
'         where id = l_credential_id;',
'',
'    end if;',
'',
'    update wwv_flows',
'       set print_server_type      = ''REMOTE'',',
'           print_remote_server_id = l_server_id,',
'           print_credential_id    = l_credential_id',
'     where id                = :FB_FLOW_ID',
'       and security_group_id = wwv_flow_security.g_security_group_id;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(609371248759163102)
,p_process_success_message=>'Remote Print Server created and enabled.'
,p_internal_uid=>609371122508163101
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(609371672045163106)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'Clear Session State'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'1935,1936'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>609371672045163106
);
end;
/
prompt --application/pages/page_01941
begin
wwv_flow_imp_page.create_page(
 p_id=>1941
,p_name=>'Create REST Data Source'
,p_alias=>'CREATE-REST-DATA-SOURCE'
,p_page_mode=>'MODAL'
,p_step_title=>'Create REST Data Source'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function hideUrlParameters() {',
'    apex.jQuery( "#url_parameters" ).hide();',
'    apex.item( "P" + $v("pFlowStepId") + "_URL_PARAM1_NAME").hide();',
'    apex.item( "P" + $v("pFlowStepId") + "_URL_PARAM1_VALUE").hide();',
'    apex.item( "P" + $v("pFlowStepId") + "_URL_PARAM2_NAME").hide();',
'    apex.item( "P" + $v("pFlowStepId") + "_URL_PARAM2_VALUE").hide();',
'    $s("P" + $v("pFlowStepId") + "_URL_PARAM1_NAME", "");',
'    $s("P" + $v("pFlowStepId") + "_URL_PARAM1_VALUE", "");',
'    $s("P" + $v("pFlowStepId") + "_URL_PARAM2_NAME", "");',
'    $s("P" + $v("pFlowStepId") + "_URL_PARAM2_VALUE", "");',
'}',
'',
'function checkUrlParameters( pUrlItem ) {',
'    var lUrl        = apex.item( pUrlItem ).getValue(),',
'        lPathPos    = 0,',
'        lParameters, lParameterItem, i;',
'',
'    hideUrlParameters(); ',
'',
'    lPathPos = lUrl.indexOf( "/", 0 ); i = 1;',
'    while ( lPathPos != -1 && i < 3 ) {',
'        lPathPos = lUrl.indexOf( "/", lPathPos + 1 ); i++;',
'    }',
'',
'    if ( lPathPos === -1 ) {',
'        return;',
'    }',
'',
'    lUrl = lUrl.substr( lPathPos );',
'    lParameters = lUrl.match( /:[0-9A-Za-z_-]+/ig );',
'',
'    if ( lParameters && lParameters.length > 0 ) {',
'        apex.jQuery( "#url_parameters" ).show();',
'        for ( i = 0; i < lParameters.length; i++ ) {',
'            if ( i === 2 ) {',
'                break;',
'            }',
'            lParameterItem = "P" + $v("pFlowStepId") + "_URL_PARAM" + ( i + 1 ) + "_";',
'            apex.item( lParameterItem + "NAME" ).setValue( lParameters[ i ].substring( 1 ) );',
'            apex.item( lParameterItem + "NAME" ).show();',
'            apex.item( lParameterItem + "VALUE" ).show();',
'        }',
'    }',
'}',
''))
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(245515811416559833)
,p_plug_name=>'URL Parameters'
,p_region_name=>'url_parameters'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--accessibleHeader:a-Form--autoWidthLabels'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3850682090247121721)
,p_plug_name=>'Create REST Data Source - Step 1'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3850682582142121726)
,p_plug_name=>'Create REST Data Source'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_imp.id(226545212901831813)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3850682600570121727)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3850682751787121728)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(3850682600570121727)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(247657191615093709)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(3850682600570121727)
,p_button_name=>'BACK'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Back'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1905:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2105854872647602)
,p_branch_name=>'Go To Page 1945'
,p_branch_action=>'f?p=&APP_ID.:1945:&SESSION.::&DEBUG.::P1945_WEB_SOURCE_TYPE,P1942_REMOTE_SERVER_ID:&P1941_WEB_SRC_TYPE.,&P1941_REST_SQL_SERVER.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(3850682751787121728)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1941_WEB_SRC_TYPE'
,p_branch_condition_text=>'NATIVE_REST_ENABLED_SQL_QUERY'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3850683593072121736)
,p_branch_name=>'Go To Page 1942'
,p_branch_action=>'f?p=&APP_ID.:1942:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P1941_SUCCESS'
,p_branch_condition_text=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(226684939516475211)
,p_branch_name=>'Go To Page 1947'
,p_branch_action=>'f?p=&APP_ID.:1947:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_branch_condition=>'P1941_SUCCESS'
,p_branch_condition_text=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1506193446184449)
,p_name=>'P1941_REST_SQL_SERVER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(3850682090247121721)
,p_prompt=>'REST Enabled SQL Reference'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REMOTE_SQL_SERVERS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_remote_servers',
' where server_type = ''REMOTE_SQL''',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose the REST Enabled SQL Reference to execute a SQL Query on.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2503805051903935)
,p_name=>'P1941_OPENAPI_URL'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(3850682090247121721)
,p_prompt=>'OpenAPI URL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>75
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the URL where the OpenAPI information is available.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'URL'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(161024795460385209)
,p_name=>'P1941_STATIC_ID'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(3850682090247121721)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(226684053025475202)
,p_name=>'P1941_SUCCESS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3850682090247121721)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(226684215687475204)
,p_name=>'P1941_MUST_AUTHENTICATE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3850682090247121721)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(226684463973475206)
,p_name=>'P1941_MESSAGE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3850682090247121721)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(242268950336871838)
,p_name=>'P1941_HTTPS_HOST'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(3850682090247121721)
,p_prompt=>'HTTPS Host Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>75
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The host name to be matched against the common name (CN) of the remote server''s certificate for an HTTPS request. It can also be a domain name like *.example.com. If NULL, the host name in the given URL will be used.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(245515982963559834)
,p_name=>'P1941_URL_PARAM1_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(245515811416559833)
,p_prompt=>'URL&nbsp;Parameter&nbsp;1'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_grid_column=>3
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(245516009215559835)
,p_name=>'P1941_URL_PARAM1_VALUE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(245515811416559833)
,p_prompt=>'Value'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(245516162788559836)
,p_name=>'P1941_URL_PARAM2_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(245515811416559833)
,p_prompt=>'URL&nbsp;Parameter&nbsp;2'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_grid_column=>3
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(245516247192559837)
,p_name=>'P1941_URL_PARAM2_VALUE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(245515811416559833)
,p_prompt=>'Value'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3850682166297121722)
,p_name=>'P1941_NAME'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(3850682090247121721)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a name for the new REST Data Source.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3850682229713121723)
,p_name=>'P1941_ENDPOINT_URL'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(3850682090247121721)
,p_prompt=>'URL Endpoint'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>75
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the Endpoint URL (starting with http:// or https://) for this REST Data Source. Do <em>not</em> add query string parameters by appending <strong>?name1=value&amp;name2=value</strong> here; these are configured on the <strong>Advanced</strong> w'
||'izard page after Authentication details.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3850682801212121729)
,p_name=>'P1941_WEB_SRC_TYPE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(3850682090247121721)
,p_item_default=>'NATIVE_HTTP'
,p_prompt=>'REST Data Source Type'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEB_SOURCE_MODULE_TYPES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,',
'       r',
'  from (',
'         select wwv_flow_lang.system_message(''WEB_SOURCE.''|| name_with_prefix) as d,',
'               name_with_prefix as r',
'          from wwv_flow_native_plugins',
'         where plugin_type = ''WEB SOURCE TYPE''',
'         union all',
'        select display_name || wwv_flow_lang.system_message(''PLUGIN.DISPLAY_NAME_POSTFIX'') as d,',
'               ''PLUGIN_'' || name     as r',
'          from wwv_flow_plugins',
'         where flow_id           = to_number(:FB_FLOW_ID)',
'           and security_group_id = to_number(:WORKSPACE_ID)',
'           and plugin_type       = ''WEB SOURCE TYPE''',
'       )',
' order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Determines the REST Data Source type.',
'<ul>',
'<li><strong>Simple HTTP</strong> denotes a simple HTTP data feed. &PRODUCT_NAME. assumes that all data is returned with the first request and that the server does not support server-side filtering, ordering or other advanced REST service feature. All'
||' invocation details and parameters must be configured manually.</li>',
'<li><strong>Oracle REST Data Services</strong> (ORDS) denotes RESTful Services provided by ORDS. These REST services follow the <em>Oracle REST standard</em>, which means that GET, POST, PUT or DELETE operations are standardized. Server-side filterin'
||'g and ordering are supported. &PRODUCT_NAME. can leverage these features by delegating report order-bys and filters to the REST service.</li>',
'<li><strong>REST Enabled SQL Query</strong> denotes a REST Source on top of a SQL Query executed on a REST Enabled SQL Reference. &PRODUCT_NAME. supports filtering and pagination, but no DML on these endpoints.</li>',
'<li><strong>Oracle Cloud Applications (SaaS) REST Service</strong> denotes RESTful web services provided by Oracle Cloud SaaS Applications. Use this web service type to integrate Oracle SaaS REST Services into your &PRODUCT_NAME. application. &PRODUC'
||'T_NAME. supports pagination for these Services.</li>',
'<li><strong>Oracle Cloud Infrastructure (OCI) REST Service</strong> denotes RESTful web services provided by Oracle Cloud Infrastructure. Use this web service type to integrate OCI REST Services (for example, accessing the Object Store) into your &PR'
||'ODUCT_NAME. application. &PRODUCT_NAME. supports pagination for these Services.</li>',
'<li><strong>OData REST Service</strong> denotes a REST service which implements the Open Data (OData) protocol, which is an ISO/IEC approved, OASIS standard that defines a set of best practices for building and consuming RESTful APIs. <em>&PRODUCT_NA'
||'ME. currently only supports the <em>Fetch</em> APIs (read data); DML operations for OData are not yet supported.</em></li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(161024878391385210)
,p_computation_sequence=>10
,p_computation_item=>'P1941_STATIC_ID'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'regexp_replace( lower( :P1941_NAME ), ''[^abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890]+'', ''_'' )'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2106507173647609)
,p_validation_name=>'Endpoint URL is not null'
,p_validation_sequence=>10
,p_validation=>'P1941_ENDPOINT_URL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>'P1941_WEB_SRC_TYPE'
,p_validation_condition2=>'NATIVE_REST_ENABLED_SQL_QUERY'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(3850682751787121728)
,p_associated_item=>wwv_flow_imp.id(3850682229713121723)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(110963104512654303)
,p_validation_name=>'REST Enabled SQL reference is not null'
,p_validation_sequence=>20
,p_validation=>'P1941_REST_SQL_SERVER'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>'P1941_WEB_SRC_TYPE'
,p_validation_condition2=>'NATIVE_REST_ENABLED_SQL_QUERY'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(3850682751787121728)
,p_associated_item=>wwv_flow_imp.id(1506193446184449)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(226586723006031727)
,p_validation_name=>'Must start with http or https'
,p_validation_sequence=>30
,p_validation=>'substr(:P1941_ENDPOINT_URL, 1, 7) = ''http://'' or substr(:P1941_ENDPOINT_URL, 1, 8) = ''https://'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Endpoint URL must start with http:// or https://'
,p_validation_condition=>'P1941_WEB_SRC_TYPE'
,p_validation_condition2=>'NATIVE_REST_ENABLED_SQL_QUERY'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(3850682751787121728)
,p_associated_item=>wwv_flow_imp.id(3850682229713121723)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3403062224078708639)
,p_validation_name=>'Name must be unique'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_web_src_modules',
' where flow_id           = :FB_FLOW_ID',
'   and name              = :P1941_NAME',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'This name is already used by another REST Data Source.'
,p_when_button_pressed=>wwv_flow_imp.id(3850682751787121728)
,p_associated_item=>wwv_flow_imp.id(3850682166297121722)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(161024669452385208)
,p_validation_name=>'Static ID must be unique'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_web_src_modules',
' where flow_id           = :FB_FLOW_ID',
'   and static_id         = :P1941_STATIC_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'"&P1941_NAME!HTML." leads to a Static ID ("&P1941_STATIC_ID!HTML.") which is already used by another REST Data Source. Choose a different name.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_web_src_modules',
' where flow_id           = :FB_FLOW_ID',
'   and name              = :P1941_NAME',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_validation_condition_type=>'NOT_EXISTS'
,p_when_button_pressed=>wwv_flow_imp.id(3850682751787121728)
,p_associated_item=>wwv_flow_imp.id(3850682166297121722)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(546918881978857741)
,p_validation_name=>'URL Parameter 1 should have a value'
,p_validation_sequence=>60
,p_validation=>'P1941_URL_PARAM1_VALUE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Parameter &P1941_URL_PARAM1_NAME!HTML. should have a value.'
,p_validation_condition=>'P1941_URL_PARAM1_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(3850682751787121728)
,p_associated_item=>wwv_flow_imp.id(245516009215559835)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(546918940485857742)
,p_validation_name=>'URL Parameter 2 should have a value'
,p_validation_sequence=>70
,p_validation=>'P1941_URL_PARAM2_VALUE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Parameter &P1942_URL_PARAM2_NAME!HTML. should have a value.'
,p_validation_condition=>'P1941_URL_PARAM2_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(3850682751787121728)
,p_associated_item=>wwv_flow_imp.id(245516247192559837)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(245516314359559838)
,p_name=>'Check for URL parameters'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1941_ENDPOINT_URL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(245516440353559839)
,p_event_id=>wwv_flow_imp.id(245516314359559838)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'checkUrlParameters( "P1941_ENDPOINT_URL")'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1417260770635703)
,p_name=>'Load URL Hint'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1941_WEB_SRC_TYPE'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$v("P1941_ENDPOINT_URL") === "" && $v("P1941_WEB_SRC_TYPE").substr( 0, 7 ) === ''PLUGIN_'''
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1417340722635704)
,p_event_id=>wwv_flow_imp.id(1417260770635703)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1941_ENDPOINT_URL'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.default_value',
'  from wwv_flow_plugin_std_attributes a, wwv_flow_plugins p',
' where a.plugin_id         = p.id',
'   and p.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and p.flow_id           = :FB_FLOW_ID',
'   and p.name              = substr( :P1941_WEB_SRC_TYPE, 8 )',
'   and a.name              = ''ENDPOINT_HINT'''))
,p_attribute_07=>'P1941_WEB_SRC_TYPE'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1505676293184444)
,p_name=>'REST Enabled SQL Type'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1941_WEB_SRC_TYPE'
,p_condition_element=>'P1941_WEB_SRC_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NATIVE_REST_ENABLED_SQL_QUERY'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1505736591184445)
,p_event_id=>wwv_flow_imp.id(1505676293184444)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1941_ENDPOINT_URL,P1941_HTTPS_HOST,P1941_OPENAPI_URL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2106014194647604)
,p_event_id=>wwv_flow_imp.id(1505676293184444)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1941_ENDPOINT_URL,P1941_OPENAPI_URL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1506265314184450)
,p_event_id=>wwv_flow_imp.id(1505676293184444)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1941_REST_SQL_SERVER'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2105739466647601)
,p_event_id=>wwv_flow_imp.id(1505676293184444)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1941_REST_SQL_SERVER'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2900740300383305)
,p_event_id=>wwv_flow_imp.id(1505676293184444)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1941_HTTPS_HOST'
,p_client_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_client_condition_expression=>'apex.item( "P1941_ENDPOINT_URL" ).getValue().substr( 0, 8 ) === "https://"'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(242269027885871839)
,p_name=>'Show / Hide HTTPS Host'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1941_ENDPOINT_URL'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'apex.item( "P1941_ENDPOINT_URL" ).getValue().substr( 0, 8 ) === "https://"'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(242269150083871840)
,p_event_id=>wwv_flow_imp.id(242269027885871839)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1941_HTTPS_HOST'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(242269260299871841)
,p_event_id=>wwv_flow_imp.id(242269027885871839)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1941_HTTPS_HOST'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(242269367776871842)
,p_event_id=>wwv_flow_imp.id(242269027885871839)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1941_HTTPS_HOST'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(99962909023536501)
,p_name=>'Simple HTTP Type'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1941_WEB_SRC_TYPE'
,p_condition_element=>'P1941_WEB_SRC_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NATIVE_HTTP'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(99963072190536502)
,p_event_id=>wwv_flow_imp.id(99962909023536501)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show OpenAPI Url'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1941_OPENAPI_URL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(99963151028536503)
,p_event_id=>wwv_flow_imp.id(99962909023536501)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Hide OpenAPI Url'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1941_OPENAPI_URL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(99963200567536504)
,p_event_id=>wwv_flow_imp.id(99962909023536501)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Clear OpenAPI Url'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1941_OPENAPI_URL'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2106434000647608)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load REST Enabled SQL Endpoint'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select base_url, ',
'       ''/_/sql'' ',
'  into :P1942_SERVER_URL,',
'       :P1942_WEB_SOURCE_PATH',
'  from wwv_remote_servers',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and id                = :P1941_REST_SQL_SERVER;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3850682751787121728)
,p_process_when=>'P1941_WEB_SRC_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'NATIVE_REST_ENABLED_SQL_QUERY'
,p_internal_uid=>2106434000647608
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(226684303829475205)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Invoke URL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_plugin_dev.has_standard_attribute(',
'       p_application_id => :FB_FLOW_ID,',
'       p_plugin_type    => wwv_flow_plugin.c_plugin_type_web_source,',
'       p_plugin_name    => :P1941_WEB_SRC_TYPE,',
'       p_feature        => ''NO_TEST_ENDPOINT'' )',
'then',
'    :P1941_SUCCESS           := ''Y'';',
'    :P1941_MUST_AUTHENTICATE := ''N'';',
'else',
'    wwv_flow_web_src_dev.f4000_test_endpoint_url(',
'        p_application_id   => :FB_FLOW_ID,',
'        p_endpoint_url     => :P1941_ENDPOINT_URL,',
'        p_https_host       => :P1941_HTTPS_HOST,',
'        p_web_source_type  => :P1941_WEB_SRC_TYPE,',
'        p_url_param1_name  => :P1941_URL_PARAM1_NAME,',
'        p_url_param1_value => :P1941_URL_PARAM1_VALUE,',
'        p_url_param2_name  => :P1941_URL_PARAM2_NAME,',
'        p_url_param2_value => :P1941_URL_PARAM2_VALUE,',
'        --',
'        p_param1_name      => :P1944_PARAM_NAME_1,',
'        p_param1_type      => :P1944_PARAM_TYPE_1,',
'        p_param1_value     => :P1944_PARAM_VALUE_1,',
'        p_param2_name      => :P1944_PARAM_NAME_2,',
'        p_param2_type      => :P1944_PARAM_TYPE_2,',
'        p_param2_value     => :P1944_PARAM_VALUE_2,',
'        --',
'        p_auth_required    => :P1941_MUST_AUTHENTICATE,',
'        p_success          => :P1941_SUCCESS,',
'        p_message          => :P1941_MESSAGE );',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3850682751787121728)
,p_internal_uid=>226684303829475205
);
end;
/
prompt --application/pages/page_01942
begin
wwv_flow_imp_page.create_page(
 p_id=>1942
,p_name=>'Create REST Data Source - Remote Server'
,p_alias=>'CREATE-REST-DATA-SOURCE-REMOTE-SERVER'
,p_page_mode=>'MODAL'
,p_step_title=>'Create REST Data Source - Remote Server'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4077235555727990976)
,p_plug_name=>'Create REST Data Source - Step 1'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4077236047622990981)
,p_plug_name=>'Create REST Data Source'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_imp.id(226545212901831813)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4077236066050990982)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(226556088489869279)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(4077236066050990982)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3850683633351121737)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(4077236066050990982)
,p_button_name=>'BACK'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Back'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1941:&SESSION.::&DEBUG.:RP,1942::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3850684475700121745)
,p_branch_name=>'Go To Page 1945'
,p_branch_action=>'f?p=&APP_ID.:1945:&SESSION.::&DEBUG.:RP,:P1945_WEB_SOURCE_TYPE:&P1941_WEB_SRC_TYPE.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(226554539349869273)
,p_name=>'P1942_WEB_SOURCE_PATH'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(4077235555727990976)
,p_prompt=>'Service URL Path'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>65
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Enter the service-specific URL Path for this REST Data Source. The HTTP Endpoint URL is built by appending this to the Base URL specified in the Remote Server object.',
'</p>',
'<p>',
'    Examples',
'</p>',
'<ul>',
'    <li>/services/customers/</li>',
'    <li>/products/4711/details</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3850683159515121732)
,p_name=>'P1942_REMOTE_SERVER_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(4077235555727990976)
,p_prompt=>'Remote Server'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEB_SOURCE_REMOTE_SERVERS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_remote_servers',
' where server_type = ''WEB_SERVICE''',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Create New -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Choose an existing <strong>Remote Server</strong> object. The HTTP Endpoint URL of a REST Data Source consists of the remote server (<strong>Base URL</strong>) and the service specific part. Remote Servers are stored as separate Entities. When multip'
||'le REST Data Sources share the same remote server, they can easily be redirected to another physical location (for example, from test to production) by just changing the base URL within the Remote Server definition.',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3850683338280121734)
,p_name=>'P1942_REMOTE_SERVER_URL'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(4077235555727990976)
,p_prompt=>'Base URL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    This is the Base URL of the chosen Remote Server object. The HTTP Endpoint URL of this REST Data Source is made up from the Base URL and the service-specific path suffix below.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3850683495071121735)
,p_name=>'P1942_SERVER_URL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(4077235555727990976)
,p_prompt=>'Base URL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>65
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The URL endpoint of the REST Data Source will consist of the Base URL (starting with http:// or https://) and the service path suffix being appended to that. The Base URL is being stored as a Remote Server object and can be shared between multiple'
||' REST Data Sources. Note that the Base URL can (and frequently should) be more than just the server name and the port. Most often the first parts of the URL path (for example, the context root) are also server-specific.</p>',
'<p>Examples:</p>',
'<ul>',
'    <li>http://api.example.com:8080/myservices/test/</li>',
'    <li>https://api.example.com/ords/scott/</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(226585781101031717)
,p_computation_sequence=>10
,p_computation_item=>'P1942_SERVER_URL'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select base_url ',
'from wwv_remote_servers',
'where id = :P1942_REMOTE_SERVER_ID',
'  and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_compute_when=>'P1942_REMOTE_SERVER_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(226586818431031728)
,p_validation_name=>'Endpoint URL starts with http(s)://'
,p_validation_sequence=>10
,p_validation=>'substr(:P1942_SERVER_URL, 1, 7) = ''http://'' or substr(:P1942_SERVER_URL, 1, 8) = ''https://'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Base URL must start with http:// or https://'
,p_validation_condition=>'P1942_REMOTE_SERVER_ID'
,p_validation_condition_type=>'ITEM_IS_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(226556088489869279)
,p_associated_item=>wwv_flow_imp.id(3850683495071121735)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3850683769458121738)
,p_name=>'Remote Server ID chosen'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1942_REMOTE_SERVER_ID'
,p_condition_element=>'P1942_REMOTE_SERVER_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3850683840149121739)
,p_event_id=>wwv_flow_imp.id(3850683769458121738)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1942_REMOTE_SERVER_URL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3850684240200121743)
,p_event_id=>wwv_flow_imp.id(3850683769458121738)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1942_SERVER_URL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3850683927437121740)
,p_event_id=>wwv_flow_imp.id(3850683769458121738)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1942_REMOTE_SERVER_URL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3850684054124121741)
,p_event_id=>wwv_flow_imp.id(3850683769458121738)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1942_SERVER_URL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3850684320424121744)
,p_event_id=>wwv_flow_imp.id(3850683769458121738)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1942_REMOTE_SERVER_URL'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select base_url',
'  from wwv_remote_servers',
' where id     = :P1942_REMOTE_SERVER_ID',
'  and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_attribute_07=>'P1942_REMOTE_SERVER_ID'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3850683297983121733)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Find Remote Server ID'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_service_path varchar2(32767);',
'    l_server_url   varchar2(32767);',
'begin',
'    wwv_flow_web_src_dev.f4000_find_remote_server(',
'        p_application_id    => :FB_FLOW_ID,',
'        p_endpoint_url      => :P1941_ENDPOINT_URL,',
'        p_remote_server_id  => :P1942_REMOTE_SERVER_ID,',
'        p_remote_server_url => :P1942_REMOTE_SERVER_URL,',
'        p_server_url        => l_server_url,',
'        p_service_path      => l_service_path );',
'        ',
'    :P1942_WEB_SOURCE_PATH := coalesce( :P1942_WEB_SOURCE_PATH, l_service_path );',
'    :P1942_SERVER_URL      := coalesce( :P1942_SERVER_URL, l_server_url );',
'end;',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>3850683297983121733
);
end;
/
prompt --application/pages/page_01943
begin
wwv_flow_imp_page.create_page(
 p_id=>1943
,p_name=>'Authentication'
,p_alias=>'AUTHENTICATION'
,p_page_mode=>'MODAL'
,p_step_title=>'Authentication'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(229756918559737172)
,p_plug_name=>'Authentication'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4303801606432999814)
,p_plug_name=>'Create REST Data Source'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_imp.id(226545212901831813)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4303801624860999815)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(249280433251575818)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(4303801624860999815)
,p_button_name=>'STORE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Create REST Source Manually'
,p_button_position=>'NEXT'
,p_button_condition=>'P1941_WEB_SRC_TYPE'
,p_button_condition2=>'NATIVE_REST_ENABLED_SQL_QUERY'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(226568123068008840)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(4303801624860999815)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'Advanced'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_button_condition=>'P1941_WEB_SRC_TYPE'
,p_button_condition2=>'NATIVE_REST_ENABLED_SQL_QUERY'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(226585407168031714)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(4303801624860999815)
,p_button_name=>'DISCOVER'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Discover'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(226568544889008841)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(4303801624860999815)
,p_button_name=>'BACK_TO_1945'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Back To 1945'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1945:&SESSION.::&DEBUG.:RP,::'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugins p,',
'       wwv_flow_plugin_attributes a',
' where p.flow_id           = case',
'                               when substr(:P1941_WEB_SRC_TYPE, 1, 7) = ''NATIVE_'' then 4411',
'                               else to_number(:FB_FLOW_ID)',
'                             end',
'   and p.plugin_type       = ''WEB SOURCE TYPE''',
'   and p.name              = substr(:P1941_WEB_SRC_TYPE, 8) /* remove NATIVE_ */',
'   and a.plugin_id         = p.id',
'   and a.attribute_scope   = ''COMPONENT''',
'   and a.show_in_wizard    = ''Y''',
'   and p.security_group_id in ( :FLOW_SECURITY_GROUP_ID, 10 )'))
,p_button_condition_type=>'EXISTS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1703512687971334)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(4303801624860999815)
,p_button_name=>'BACK_TO_1942'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Back'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1942:&SESSION.::&DEBUG.:RP,::'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugins p,',
'       wwv_flow_plugin_attributes a',
' where p.flow_id           = case',
'                               when substr(:P1941_WEB_SRC_TYPE, 1, 7) = ''NATIVE_'' then 4411',
'                               else to_number(:FB_FLOW_ID)',
'                             end',
'   and p.plugin_type       = ''WEB SOURCE TYPE''',
'   and p.name              = substr(:P1941_WEB_SRC_TYPE, 8) /* remove NATIVE_ */',
'   and a.plugin_id         = p.id',
'   and a.attribute_scope   = ''COMPONENT''',
'   and a.show_in_wizard    = ''Y''',
'   and p.security_group_id in ( :FLOW_SECURITY_GROUP_ID, 10 )'))
,p_button_condition_type=>'NOT_EXISTS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(249280698399575820)
,p_branch_action=>'f?p=&APP_ID.:1901:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(249280433251575818)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(226585607385031716)
,p_branch_name=>'Go To Page 1946'
,p_branch_action=>'f?p=&APP_ID.:1946:&SESSION.::&DEBUG.:RP:P1946_PREVIOUS_PAGE,P1946_SHOW_ALL:&APP_PAGE_ID.,N&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(226585407168031714)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(226586946017031729)
,p_branch_name=>'Go To Page 1944'
,p_branch_action=>'f?p=&APP_ID.:1944:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(226568123068008840)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1341723934822902)
,p_name=>'P1943_OCI_NAMESPACE'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(229756918559737172)
,p_prompt=>'OCI Tenancy ID'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the Oracle Cloud Infrastructure <em>Tenancy''s OCID</em>.</p>',
'<p><a rel="noopener noreferrer" target="_blank" href="https://docs.cloud.oracle.com/iaas/Content/API/Concepts/apisigningkey.htm">Oracle Cloud Infrastructure Documentation</a></p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1341831635822903)
,p_name=>'P1943_OCI_FINGERPRINT'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(229756918559737172)
,p_prompt=>'OCI Public Key Fingerprint'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Enter the <em>public RSA key fingerprint</em> for OCI authentication. </p><p><a rel="noopener noreferrer" target="_blank" href="https://docs.cloud.oracle.com/iaas/Content/API/Concepts/apisigningkey.htm">Oracle Cloud Infrastructure Documentation</a'
||'></p>'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1342216553822907)
,p_name=>'P1943_OCI_PRIVATE_KEY'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(229756918559737172)
,p_prompt=>'OCI Private Key'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>75
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Enter the <em>private RSA key in PEM format</em> for OCI authentication. Oracle APEX stores this information encrypted and secure, so it cannot be retrieved back in clear text.</p><p><a rel="noopener noreferrer" target="_blank" href="https://docs.'
||'cloud.oracle.com/iaas/Content/API/Concepts/apisigningkey.htm">Oracle Cloud Infrastructure Documentation</a></p>'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1342351857822908)
,p_name=>'P1943_OCI_USER_ID'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(229756918559737172)
,p_prompt=>'OCI User ID'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Enter the Oracle Cloud Infrastructure <em>User OCID</em>. Oracle APEX does not store this information encrypted.</p> <p><a rel="noopener noreferrer" target="_blank" href="https://docs.cloud.oracle.com/iaas/Content/API/Concepts/apisigningkey.htm">O'
||'racle Cloud Infrastructure Documentation</a></p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1342738876822912)
,p_name=>'P1943_DEFAULT_AUTH_TYPE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(229756918559737172)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3367618171004649)
,p_name=>'P1943_GENERIC_NAME'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(229756918559737172)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the Name of the HTTP Header or Query String parameter.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3367703087004650)
,p_name=>'P1943_GENERIC_VALUE'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(229756918559737172)
,p_prompt=>'Value'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the (secret) value for the HTTP Header or URL Query String parameter.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(226573004468012957)
,p_name=>'P1943_AUTH_REQUIRED'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(229756918559737172)
,p_item_default=>'N'
,p_prompt=>'Authentication Required'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Choose whether the new REST Data Source requires Authentication.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(226573966511012963)
,p_name=>'P1943_CREDENTIAL_STORE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(229756918559737172)
,p_prompt=>'Credentials'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_credentials',
' where security_group_id = :flow_security_group_id',
'   and ( authentication_type = ''OCI'' or :P1941_WEB_SRC_TYPE != ''OCI'' )',
' order by name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Enter new credentials -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose existing Credentials to be used for authentication.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(226574766423012964)
,p_name=>'P1943_AUTH_TYPE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(229756918559737172)
,p_prompt=>'Authentication Type'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CREDENTIALS_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(154078822199034715)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Specify the Authentication type here. Currently, Oracle APEX supports the following authentication types:',
'</p>',
'<ul>',
'    <li><strong>Basic Authentication</strong> - Sends username and password in Base64-encoded form as the <strong>Authorization</strong> request header.',
'    </li>',
'    <li><strong>OAuth2 Client Credentials</strong> - Oracle APEX exchanges the client ID and client secret for an <strong>Access Token</strong> using a token server URL. The access token is then used to perform the actual request. If the access token'
||' is expired, APEX will transparently request a new one.</li>',
'    <li><strong>OCI Native Authentication</strong> - Oracle APEX signs requests to the <em>Oracle Cloud Infrastructure (OCI)</em> REST API, as described in the <a rel="noopener noreferrer" href="https://docs.cloud.oracle.com/en-us/iaas/Content/API/Co'
||'ncepts/signingrequests.htm">OCI Documentation</a>. This type is only available in Oracle Database 18c and higher.</li>',
'    <li><strong>HTTP Header</strong> - The credential is added to the REST Request as a HTTP Header. The name of the credential is the HTTP Header name, the Secret of the credential is the HTTP Header value. Oracle APEX does not add these secrets to '
||'the Debug log or any other logs.</li>',
'    <li><strong>URL Query String</strong> -  The credential is added to the URL of the REST Request as a <em>Query String</em> Parameter (for example: <strong>?name=value</strong>). This option can be useful with API keys. Oracle APEX does not add th'
||'ese secrets to the Debug log or any other logs. However,proxy or other intermediate servers will log these credentials in their log files.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(226575673475012965)
,p_name=>'P1943_CLIENT_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(229756918559737172)
,p_prompt=>'Client ID'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the "Client ID" value to be used for the OAuth2 Client Credentials flow. '
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(226576582937012965)
,p_name=>'P1943_CLIENT_SECRET'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(229756918559737172)
,p_prompt=>'Client Secret'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>80
,p_tag_attributes=>'autocomplete="new-password"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the "Client Secret" value to be used for the OAuth2 Client Credentials flow. This value will be stored encrypted.'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(226577406815012966)
,p_name=>'P1943_USERNAME'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(229756918559737172)
,p_prompt=>'Username'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the Username to be used for Basic Authentication.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(226578326052012966)
,p_name=>'P1943_PASSWORD'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(229756918559737172)
,p_prompt=>'Password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_tag_attributes=>'autocomplete="new-password"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the Password to be used for Basic Authentication. This value will be stored encrypted.'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(226686098649475222)
,p_name=>'P1943_TOKEN_URL'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(229756918559737172)
,p_item_default=>'case when :P1941_WEB_SRC_TYPE = wwv_flow_exec_web_src.c_native_web_src_ords then :P1942_SERVER_URL || ''oauth/token'' else :P1942_SERVER_URL end'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'OAuth Token URL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the URL endpoint to request the OAuth Access Token from. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(226685177759475213)
,p_computation_sequence=>10
,p_computation_item=>'P1943_AUTH_REQUIRED'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'Y'
,p_compute_when=>'P1941_MUST_AUTHENTICATE'
,p_compute_when_text=>'Y'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1341641505822901)
,p_computation_sequence=>20
,p_computation_item=>'P1943_DEFAULT_AUTH_TYPE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'OCI'
,p_compute_when=>'P1941_WEB_SRC_TYPE'
,p_compute_when_text=>'OCI'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(226588517742031745)
,p_validation_name=>'Client ID required'
,p_validation_sequence=>10
,p_validation=>'P1943_CLIENT_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Client ID must have a value'
,p_validation_condition=>':P1943_AUTH_TYPE = ''OAUTH2_CLIENT_CREDENTIALS'' and :P1943_CREDENTIAL_STORE is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(226575673475012965)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(397074021607399216)
,p_validation_name=>'Token URL required'
,p_validation_sequence=>20
,p_validation=>'P1943_TOKEN_URL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Token URL must have a value'
,p_validation_condition=>':P1943_AUTH_TYPE = ''OAUTH2_CLIENT_CREDENTIALS'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(226686098649475222)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(226588826445031748)
,p_validation_name=>'Username required'
,p_validation_sequence=>30
,p_validation=>'P1943_USERNAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Username must have a value'
,p_validation_condition=>':P1943_AUTH_TYPE = ''BASIC'' and :P1943_CREDENTIAL_STORE is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(226577406815012966)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(226588968531031749)
,p_validation_name=>'Password required'
,p_validation_sequence=>40
,p_validation=>'P1943_PASSWORD'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Password must have a value'
,p_validation_condition=>':P1943_AUTH_TYPE = ''BASIC'' and :P1943_CREDENTIAL_STORE is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(226578326052012966)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(226588652149031746)
,p_validation_name=>'Client Secret required'
,p_validation_sequence=>50
,p_validation=>'P1943_CLIENT_SECRET'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Client Secret must have a value'
,p_validation_condition=>':P1943_AUTH_TYPE = ''OAUTH2_CLIENT_CREDENTIALS'' and :P1943_CREDENTIAL_STORE is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(226576582937012965)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(226589005405031750)
,p_validation_name=>'Authentication Type required'
,p_validation_sequence=>60
,p_validation=>'P1943_AUTH_TYPE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Authentication Type must have a value'
,p_validation_condition=>':P1943_AUTH_REQUIRED = ''Y'' and :P1943_CREDENTIAL_STORE is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(226574766423012964)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1342840577822913)
,p_validation_name=>'OCI REST Source needs OCI Auth'
,p_validation_sequence=>70
,p_validation=>'P1943_AUTH_TYPE'
,p_validation2=>'OCI'
,p_validation_type=>'ITEM_IN_VALIDATION_EQ_STRING2'
,p_error_message=>'Oracle Cloud Infrastructure (OCI) Authentication required for OCI REST Data Source.'
,p_validation_condition=>'P1941_WEB_SRC_TYPE'
,p_validation_condition2=>'OCI'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(226574766423012964)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3200864665268106)
,p_validation_name=>'Generic Name required'
,p_validation_sequence=>100
,p_validation=>'P1943_GENERIC_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value'
,p_validation_condition=>':P1943_AUTH_TYPE in( ''HTTP_HEADER'', ''HTTP_QUERY_STRING'' ) and :P1943_CREDENTIAL_STORE is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(3367618171004649)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3200952206268107)
,p_validation_name=>'Generic Value required'
,p_validation_sequence=>110
,p_validation=>'P1943_GENERIC_VALUE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value'
,p_validation_condition=>':P1943_AUTH_TYPE in( ''HTTP_HEADER'', ''HTTP_QUERY_STRING'' ) and :P1943_CREDENTIAL_STORE is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(3367703087004650)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3850684515431121746)
,p_name=>'Authentication required'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1943_AUTH_REQUIRED'
,p_condition_element=>'P1943_AUTH_REQUIRED'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3850684660113121747)
,p_event_id=>wwv_flow_imp.id(3850684515431121746)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1943_CREDENTIAL_STORE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3850684732845121748)
,p_event_id=>wwv_flow_imp.id(3850684515431121746)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1943_CREDENTIAL_STORE,P1943_AUTH_TYPE,P1943_CLIENT_ID,P1943_CLIENT_SECRET,P1943_USERNAME,P1943_PASSWORD'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(226584992787031709)
,p_event_id=>wwv_flow_imp.id(3850684515431121746)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1943_CREDENTIAL_STORE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(226585072219031710)
,p_event_id=>wwv_flow_imp.id(3850684515431121746)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1943_CREDENTIAL_STORE,P1943_AUTH_TYPE,P1943_CLIENT_ID,P1943_CLIENT_SECRET,P1943_USERNAME,P1943_PASSWORD'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3850684835538121749)
,p_name=>'Credentials chosen'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1943_CREDENTIAL_STORE'
,p_condition_element=>'P1943_CREDENTIAL_STORE'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3850684937973121750)
,p_event_id=>wwv_flow_imp.id(3850684835538121749)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1943_AUTH_TYPE,P1943_CLIENT_ID,P1943_CLIENT_SECRET,P1943_USERNAME,P1943_PASSWORD'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(397072920246399205)
,p_event_id=>wwv_flow_imp.id(3850684835538121749)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1943_AUTH_TYPE'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select authentication_type',
'  from wwv_credentials',
' where id = :P1943_CREDENTIAL_STORE',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_attribute_07=>'P1943_CREDENTIAL_STORE'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(226585147074031711)
,p_name=>'No Credentials chosen'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1943_CREDENTIAL_STORE'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$v("P1943_AUTH_REQUIRED") === ''Y'' && $v("P1943_CREDENTIAL_STORE") === '''''
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(226585258222031712)
,p_event_id=>wwv_flow_imp.id(226585147074031711)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1943_AUTH_TYPE,P1943_CLIENT_ID,P1943_CLIENT_SECRET,P1943_USERNAME,P1943_PASSWORD'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(226585338588031713)
,p_event_id=>wwv_flow_imp.id(226585147074031711)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1943_AUTH_TYPE'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$v("P1943_DEFAULT_AUTH_TYPE")'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(226584256831031702)
,p_name=>'BASIC Auth for new Credentials'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1943_AUTH_TYPE'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'($v("P1943_AUTH_TYPE") === "BASIC" && $v("P1943_CREDENTIAL_STORE") === "") '
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(226584319480031703)
,p_event_id=>wwv_flow_imp.id(226584256831031702)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1943_USERNAME,P1943_PASSWORD'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(226584482287031704)
,p_event_id=>wwv_flow_imp.id(226584256831031702)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1943_USERNAME,P1943_PASSWORD'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(226584572970031705)
,p_name=>'OAuth Auth for new Credentials'
,p_event_sequence=>45
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1943_AUTH_TYPE'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'($v("P1943_AUTH_TYPE") === "OAUTH2_CLIENT_CREDENTIALS" && $v("P1943_CREDENTIAL_STORE") === "") ',
''))
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(226584617925031706)
,p_event_id=>wwv_flow_imp.id(226584572970031705)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1943_CLIENT_ID,P1943_CLIENT_SECRET,P1943_TOKEN_URL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(226584809742031708)
,p_event_id=>wwv_flow_imp.id(226584572970031705)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1943_CLIENT_ID,P1943_CLIENT_SECRET,P1943_TOKEN_URL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(397073250799399208)
,p_name=>'BASIC Auth for existing Credentials'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1943_AUTH_TYPE'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'($v("P1943_AUTH_TYPE") === "BASIC" && $v("P1943_CREDENTIAL_STORE") !== "") '
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(397073380731399209)
,p_event_id=>wwv_flow_imp.id(397073250799399208)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1943_USERNAME,P1943_PASSWORD,P1943_TOKEN_URL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(397073791635399213)
,p_name=>'OAUTH Auth for existing Credentials'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1943_AUTH_TYPE'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'($v("P1943_AUTH_TYPE") === "OAUTH2_CLIENT_CREDENTIALS" && $v("P1943_CREDENTIAL_STORE") !== "") '
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(397073872674399214)
,p_event_id=>wwv_flow_imp.id(397073791635399213)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1943_USERNAME,P1943_PASSWORD'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(397073958207399215)
,p_event_id=>wwv_flow_imp.id(397073791635399213)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1943_TOKEN_URL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1341945702822904)
,p_name=>'OCI Auth'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1943_AUTH_TYPE'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'($v("P1943_AUTH_TYPE") === "OCI" && $v("P1943_CREDENTIAL_STORE") === "") '
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1342017433822905)
,p_event_id=>wwv_flow_imp.id(1341945702822904)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1943_USERNAME,P1943_PASSWORD,P1943_TOKEN_URL,P1943_CLIENT_ID,P1943_CLIENT_SECRET'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1342563646822910)
,p_event_id=>wwv_flow_imp.id(1341945702822904)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1943_OCI_NAMESPACE,P1943_OCI_FINGERPRINT,P1943_OCI_PRIVATE_KEY,P1943_OCI_USER_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1342116326822906)
,p_event_id=>wwv_flow_imp.id(1341945702822904)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1943_OCI_NAMESPACE,P1943_OCI_FINGERPRINT,P1943_OCI_PRIVATE_KEY,P1943_OCI_USER_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3200515860268103)
,p_name=>'Generic HTTP for new Credentials'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1943_AUTH_TYPE'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'(($v("P1943_AUTH_TYPE") === "HTTP_HEADER" || $v("P1943_AUTH_TYPE") === "HTTP_QUERY_STRING" ) && $v("P1943_CREDENTIAL_STORE") === "") '
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3200620012268104)
,p_event_id=>wwv_flow_imp.id(3200515860268103)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1943_GENERIC_NAME,P1943_GENERIC_VALUE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3200792284268105)
,p_event_id=>wwv_flow_imp.id(3200515860268103)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1943_GENERIC_NAME,P1943_GENERIC_VALUE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(226585513501031715)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Store or Discover REST Source'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'',
'wwv_flow_web_src_dev.f4000_store_or_discover(',
'    p_application_id   => :FB_FLOW_ID,',
'    --',
'    p_action           => :REQUEST,   -- "DISCOVER" or "STORE"',
'    --',
'    p_web_src_type     => :P1941_WEB_SRC_TYPE,',
'    --',
'    p_server_id        => :P1942_REMOTE_SERVER_ID,',
'    p_server_url       => :P1942_SERVER_URL,',
'    p_service_path     => :P1942_WEB_SOURCE_PATH,',
'    --',
'    p_https_host       => :P1941_HTTPS_HOST,',
'    --',
'    p_auth_required    => ( :P1943_AUTH_REQUIRED = ''Y'' ),',
'    p_cred_store       => :P1943_CREDENTIAL_STORE,',
'    p_token_url        => :P1943_TOKEN_URL,',
'    p_openapi_url      => :P1941_OPENAPI_URL,',
'    --',
'    p_auth_type        => :P1943_AUTH_TYPE,',
'    p_client_id        => case when :P1943_AUTH_TYPE = ''OCI''                                 then :P1943_OCI_USER_ID',
'                               when :P1943_AUTH_TYPE in (''HTTP_HEADER'', ''HTTP_QUERY_STRING'') then :P1943_GENERIC_NAME',
'                               else :P1943_CLIENT_ID end,',
'    p_client_secret    => case when :P1943_AUTH_TYPE = ''OCI'' then :P1943_OCI_PRIVATE_KEY',
'                               when :P1943_AUTH_TYPE in (''HTTP_HEADER'', ''HTTP_QUERY_STRING'') then :P1943_GENERIC_VALUE',
'                               else :P1943_CLIENT_SECRET end,',
'    p_username         => :P1943_USERNAME,',
'    p_password         => :P1943_PASSWORD,',
'    p_namespace        => :P1943_OCI_NAMESPACE,',
'    p_fingerprint      => :P1943_OCI_FINGERPRINT,',
'    --',
'    p_url_param_name1  => :P1941_URL_PARAM1_NAME,',
'    p_url_param_type1  => ''URL_PATTERN'',',
'    p_url_param_value1 => :P1941_URL_PARAM1_VALUE,',
'    --',
'    p_url_param_name2  => :P1941_URL_PARAM2_NAME,',
'    p_url_param_type2  => ''URL_PATTERN'',',
'    p_url_param_value2 => :P1941_URL_PARAM2_VALUE,',
'    --',
'    p_module_name      => :P1941_NAME,',
'    --',
'    p_attribute_01     => :P1945_ATTRIBUTE_01,',
'    p_attribute_02     => :P1945_ATTRIBUTE_02,',
'    p_attribute_03     => :P1945_ATTRIBUTE_03,',
'    p_attribute_04     => :P1945_ATTRIBUTE_04,',
'    p_attribute_05     => :P1945_ATTRIBUTE_05,',
'    p_attribute_06     => :P1945_ATTRIBUTE_06,',
'    p_attribute_07     => :P1945_ATTRIBUTE_07,',
'    p_attribute_08     => :P1945_ATTRIBUTE_08,',
'    p_attribute_09     => :P1945_ATTRIBUTE_09,',
'    p_attribute_10     => :P1945_ATTRIBUTE_10,',
'    p_attribute_11     => :P1945_ATTRIBUTE_11,',
'    p_attribute_12     => :P1945_ATTRIBUTE_12,',
'    p_attribute_13     => :P1945_ATTRIBUTE_13,',
'    p_attribute_14     => :P1945_ATTRIBUTE_14,',
'    p_attribute_15     => :P1945_ATTRIBUTE_15 );',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':STORE:DISCOVER:'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_internal_uid=>226585513501031715
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2106262272647606)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load Cedential'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    :P1943_AUTH_REQUIRED := ''Y'';',
'    for i in (',
'        select credential_id',
'          from wwv_remote_servers',
'         where security_group_id = :FLOW_SECURITY_GROUP_ID',
'           and id                = :P1941_REST_SQL_SERVER )',
'    loop',
'        :P1943_CREDENTIAL_STORE := i.credential_id;',
'    end loop;',
'end;',
'      '))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P1941_WEB_SRC_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'NATIVE_REST_ENABLED_SQL_QUERY'
,p_internal_uid=>2106262272647606
);
end;
/
prompt --application/pages/page_01944
begin
wwv_flow_imp_page.create_page(
 p_id=>1944
,p_name=>'Parameters'
,p_alias=>'PARAMETERS'
,p_page_mode=>'MODAL'
,p_step_title=>'Parameters'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function showNextParameter( pElement, pShow ) {',
'    var lIdx = parseInt( apex.jQuery( pElement ).attr( "id" ).match( /\d*$/ ) ) + 1;',
'    ',
'    if ( lIdx <= 10 ) {',
'        if ( pShow ) {',
'            apex.item( "P" + $v( "pFlowStepId" ) + "_PARAM_TYPE_"  + lIdx ).show();',
'            apex.item( "P" + $v( "pFlowStepId" ) + "_PARAM_NAME_"  + lIdx ).show();',
'            apex.item( "P" + $v( "pFlowStepId" ) + "_PARAM_VALUE_" + lIdx ).show();',
'            apex.item( "P" + $v( "pFlowStepId" ) + "_PARAM_STATIC_" + lIdx ).show();',
'        } else {',
'            apex.item( "P" + $v( "pFlowStepId" ) + "_PARAM_TYPE_"  + lIdx ).setValue( null );',
'            apex.item( "P" + $v( "pFlowStepId" ) + "_PARAM_TYPE_"  + lIdx ).hide();',
'            apex.item( "P" + $v( "pFlowStepId" ) + "_PARAM_NAME_"  + lIdx ).hide();',
'            apex.item( "P" + $v( "pFlowStepId" ) + "_PARAM_VALUE_" + lIdx ).hide();            ',
'            apex.item( "P" + $v( "pFlowStepId" ) + "_PARAM_STATIC_" + lIdx ).hide();            ',
'        }',
'    }   ',
'}'))
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(229808739519718827)
,p_plug_name=>'Parameters'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<span id="LABEL_ROW_2" class="u-VisuallyHidden">&APP_TEXT$ITEM_ROW_2.</span>',
'<span id="LABEL_ROW_3" class="u-VisuallyHidden">&APP_TEXT$ITEM_ROW_3.</span>',
'<span id="LABEL_ROW_4" class="u-VisuallyHidden">&APP_TEXT$ITEM_ROW_4.</span>',
'<span id="LABEL_ROW_5" class="u-VisuallyHidden">&APP_TEXT$ITEM_ROW_5.</span>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'Span tags in region are used to label the different item types in the region, that don''t have a visible label.'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(236247361887284208)
,p_plug_name=>'Parsing'
,p_region_template_options=>'#DEFAULT#:a-Form--autoWidthLabels'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(772844574702815533)
,p_plug_name=>'HTTP Method'
,p_region_template_options=>'#DEFAULT#:a-Form--autoWidthLabels'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4530442089424377798)
,p_plug_name=>'Create REST Data Source'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_imp.id(226545212901831813)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4530442107852377799)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(249280830061575822)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(4530442107852377799)
,p_button_name=>'STORE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Create REST Source Manually'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(226641944692378031)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(4530442107852377799)
,p_button_name=>'DISCOVER'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Discover'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(226641566399378030)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(4530442107852377799)
,p_button_name=>'BACK'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Back'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1943:&SESSION.::&DEBUG.:RP,1944::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(249280975339575823)
,p_branch_action=>'f?p=&APP_ID.:1901:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(249280830061575822)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(226660173722378094)
,p_branch_name=>'Go To Page 1946'
,p_branch_action=>'f?p=&APP_ID.:1946:&SESSION.::&DEBUG.:RP:P1946_PREVIOUS_PAGE,P1946_SHOW_ALL:&APP_PAGE_ID.,N&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(226641944692378031)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1642979377019601)
,p_name=>'P1944_SAMPLE_RESPONSE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(236247361887284208)
,p_prompt=>'Discovery Sample'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Upload a sample of the REST Service here. This can be either a sample response of the REST service or a OpenAPI JSON document describing the REST service. &PRODUCT_NAME. will parse this response instead of reaching out to the REST Service. This can b'
||'e used if the REST service cannot be reached or if required authentication is not available during design time.'
,p_inline_help_text=>'Sample response or OpenAPI document'
,p_attribute_01=>'APEX_APPLICATION_TEMP_FILES'
,p_attribute_09=>'REQUEST'
,p_attribute_10=>'N'
,p_attribute_12=>'INLINE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(226664383251383485)
,p_name=>'P1944_PARAM_TYPE_1'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(229808739519718827)
,p_prompt=>'Parameter Type'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEB_SOURCE_PARAM_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(226045111811519566)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(226664774190383486)
,p_name=>'P1944_PARAM_NAME_1'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(229808739519718827)
,p_prompt=>'Parameter Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(226665129383383486)
,p_name=>'P1944_PARAM_VALUE_1'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(229808739519718827)
,p_prompt=>'Value'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(226665501361383486)
,p_name=>'P1944_PARAM_TYPE_2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(229808739519718827)
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEB_SOURCE_PARAM_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(226045111811519566)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_tag_attributes=>'aria-labelledby="LABEL_ROW_2 P1944_PARAM_TYPE_1_LABEL"'
,p_colspan=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(226665984566383486)
,p_name=>'P1944_PARAM_NAME_2'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(229808739519718827)
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'aria-labelledby="LABEL_ROW_2 P1944_PARAM_NAME_1_LABEL"'
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(226666398510383487)
,p_name=>'P1944_PARAM_VALUE_2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(229808739519718827)
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'aria-labelledby="LABEL_ROW_2 P1944_PARAM_VALUE_1_LABEL"'
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(226666733001383487)
,p_name=>'P1944_PARAM_TYPE_3'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(229808739519718827)
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEB_SOURCE_PARAM_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(226045111811519566)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_tag_attributes=>'aria-labelledby="LABEL_ROW_3 P1944_PARAM_TYPE_1_LABEL"'
,p_colspan=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(226667164825383487)
,p_name=>'P1944_PARAM_NAME_3'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(229808739519718827)
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'aria-labelledby="LABEL_ROW_3 P1944_PARAM_NAME_1_LABEL"'
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(226667581668383488)
,p_name=>'P1944_PARAM_VALUE_3'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(229808739519718827)
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'aria-labelledby="LABEL_ROW_3 P1944_PARAM_VALUE_1_LABEL"'
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(226667915467383488)
,p_name=>'P1944_PARAM_TYPE_4'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(229808739519718827)
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEB_SOURCE_PARAM_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(226045111811519566)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_tag_attributes=>'aria-labelledby="LABEL_ROW_4 P1944_PARAM_TYPE_1_LABEL"'
,p_colspan=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(226668342295383488)
,p_name=>'P1944_PARAM_NAME_4'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(229808739519718827)
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'aria-labelledby="LABEL_ROW_4 P1944_PARAM_NAME_1_LABEL"'
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(226668757471383488)
,p_name=>'P1944_PARAM_VALUE_4'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(229808739519718827)
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'aria-labelledby="LABEL_ROW_4 P1944_PARAM_VALUE_1_LABEL"'
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(226669163228383489)
,p_name=>'P1944_PARAM_TYPE_5'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_imp.id(229808739519718827)
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEB_SOURCE_PARAM_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(226045111811519566)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_tag_attributes=>'aria-labelledby="LABEL_ROW_5 P1944_PARAM_TYPE_1_LABEL"'
,p_colspan=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(226669573164383489)
,p_name=>'P1944_PARAM_NAME_5'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_imp.id(229808739519718827)
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'aria-labelledby="LABEL_ROW_5 P1944_PARAM_NAME_1_LABEL"'
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(226669939412383489)
,p_name=>'P1944_PARAM_VALUE_5'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_imp.id(229808739519718827)
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_tag_attributes=>'aria-labelledby="LABEL_ROW_5 P1944_PARAM_VALUE_1_LABEL"'
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(236247462853284209)
,p_name=>'P1944_ROW_SELECTOR'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(236247361887284208)
,p_prompt=>'Row Selector (leave empty for auto-detection)'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>75
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The <strong>Row Selector</strong> denotes the JSON or XML path expression which navigates to the JSON attribute or XML tag containing the array of rows. When no value is provided, &PRODUCT_NAME. will try to automatically detect the row selector. ',
'</p>',
'<p>XML Examples:</p>',
'<ul>',
'<li>/rss/channel/item</li>',
'<li>/root/tag/array</li>',
'</ul>',
'<p>',
'    ',
'</p>',
'<p>JSON Examples:</p>',
'<ul>',
'<li>.</li>',
'<li>items</li>',
'<li>result.items</li>',
'<li>items[0].results</li>',
'</ul>',
'<p>',
'    ',
'</p><p>',
'    You cannot use the "[*]" expression within a JSON row selector. For instance, <span style="text-decoration: line-through";>items[*].employees</span> is forbidden.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(525230382938218513)
,p_name=>'P1944_SINGLE_ROW'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(236247361887284208)
,p_item_default=>'N'
,p_prompt=>'Returns'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC:Single Row;Y,Table;N'
,p_tag_css_classes=>'apex-button-group'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(529222451190107544)
,p_name=>'P1944_PARAM_STATIC_1'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(229808739519718827)
,p_item_default=>'N'
,p_prompt=>'Is Static'
,p_display_as=>'NATIVE_YES_NO'
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(529222567267107545)
,p_name=>'P1944_PARAM_STATIC_2'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(229808739519718827)
,p_item_default=>'N'
,p_display_as=>'NATIVE_YES_NO'
,p_tag_attributes=>'aria-labelledby="LABEL_ROW_2 P1944_PARAM_STATIC_1_LABEL"'
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(529222686536107546)
,p_name=>'P1944_PARAM_STATIC_3'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(229808739519718827)
,p_item_default=>'N'
,p_display_as=>'NATIVE_YES_NO'
,p_tag_attributes=>'aria-labelledby="LABEL_ROW_3 P1944_PARAM_STATIC_1_LABEL"'
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(529222726383107547)
,p_name=>'P1944_PARAM_STATIC_4'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(229808739519718827)
,p_item_default=>'N'
,p_display_as=>'NATIVE_YES_NO'
,p_tag_attributes=>'aria-labelledby="LABEL_ROW_4 P1944_PARAM_STATIC_1_LABEL"'
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(529222893827107548)
,p_name=>'P1944_PARAM_STATIC_5'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_imp.id(229808739519718827)
,p_item_default=>'N'
,p_display_as=>'NATIVE_YES_NO'
,p_tag_attributes=>'aria-labelledby="LABEL_ROW_5 P1944_PARAM_STATIC_1_LABEL"'
,p_begin_on_new_line=>'N'
,p_colspan=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(772844618826815534)
,p_name=>'P1944_HTTP_METHOD'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(772844574702815533)
,p_item_default=>'GET'
,p_prompt=>'HTTP Method'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC:GET;GET,POST;POST'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Pick the HTTP Method to use for discovery.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(772844783985815535)
,p_name=>'P1944_REQUEST_BODY'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(772844574702815533)
,p_prompt=>'Request Body'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Provide a Request Body template for the POST request. When using #PLACEHOLDER# syntax, make sure to declare Parameters of the <strong>Request / Response Body</strong> type above.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(226587069087031730)
,p_name=>'Show Parameter 2'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1944_PARAM_TYPE_1'
,p_condition_element=>'P1944_PARAM_TYPE_1'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(226587113227031731)
,p_event_id=>wwv_flow_imp.id(226587069087031730)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'showNextParameter( this.triggeringElement, true );'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(226587231623031732)
,p_event_id=>wwv_flow_imp.id(226587069087031730)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'showNextParameter( this.triggeringElement, false );'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(226587559358031735)
,p_name=>'Show Parameter 3'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1944_PARAM_TYPE_2'
,p_condition_element=>'P1944_PARAM_TYPE_2'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(226587690838031736)
,p_event_id=>wwv_flow_imp.id(226587559358031735)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'showNextParameter( this.triggeringElement, true );'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(226587770327031737)
,p_event_id=>wwv_flow_imp.id(226587559358031735)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'showNextParameter( this.triggeringElement, false );'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(226587874394031738)
,p_name=>'Show Parameter 4'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1944_PARAM_TYPE_3'
,p_condition_element=>'P1944_PARAM_TYPE_3'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(226587929099031739)
,p_event_id=>wwv_flow_imp.id(226587874394031738)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'showNextParameter( this.triggeringElement, true );'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(226588034035031740)
,p_event_id=>wwv_flow_imp.id(226587874394031738)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'showNextParameter( this.triggeringElement, false );'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(226588232333031742)
,p_name=>'Show Parameter 5'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1944_PARAM_TYPE_4'
,p_condition_element=>'P1944_PARAM_TYPE_4'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(226588355941031743)
,p_event_id=>wwv_flow_imp.id(226588232333031742)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'showNextParameter( this.triggeringElement, true );'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(226588477419031744)
,p_event_id=>wwv_flow_imp.id(226588232333031742)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'showNextParameter( this.triggeringElement, false );'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(525230408212218514)
,p_name=>'Change Row Selector'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1944_ROW_SELECTOR'
,p_condition_element=>'P1944_ROW_SELECTOR'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(525230584838218515)
,p_event_id=>wwv_flow_imp.id(525230408212218514)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1944_SINGLE_ROW'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(525230626357218516)
,p_event_id=>wwv_flow_imp.id(525230408212218514)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1944_SINGLE_ROW'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(772844865122815536)
,p_name=>'Show Request Body'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1944_HTTP_METHOD'
,p_condition_element=>'P1944_HTTP_METHOD'
,p_triggering_condition_type=>'NOT_EQUALS'
,p_triggering_expression=>'GET'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(772844936572815537)
,p_event_id=>wwv_flow_imp.id(772844865122815536)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1944_REQUEST_BODY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(772845004362815538)
,p_event_id=>wwv_flow_imp.id(772844865122815536)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1944_REQUEST_BODY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(772845198924815539)
,p_event_id=>wwv_flow_imp.id(772844865122815536)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1944_REQUEST_BODY'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(226649231601378080)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Store or Discover REST Data Source'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_sample_response blob;',
'    l_sample_is_swagger varchar2(255);',
'begin',
'    if :P1944_SAMPLE_RESPONSE is not null then',
'        select blob_content ',
'          into l_sample_response',
'          from wwv_flow_temp_files',
'         where name = :P1944_SAMPLE_RESPONSE;',
'',
'    select max( nvl( swagger, openapi ) ) as is_openapi_or_swagger',
'        into l_sample_is_swagger',
'    from json_table(',
'             l_sample_response,',
'             ''$'' ',
'             columns(',
'                 openapi varchar2(255) path ''$.openapi'',',
'                 swagger varchar2(255) path ''$.swagger'' ) );',
'',
'    end if;',
'                       ',
'    wwv_flow_web_src_dev.f4000_store_or_discover(',
'        p_application_id   => :FB_FLOW_ID,',
'        --',
'        p_action           => :REQUEST,   -- "DISCOVER" or "STORE"',
'        --',
'        p_web_src_type     => :P1941_WEB_SRC_TYPE,',
'        p_http_method      => :P1944_HTTP_METHOD,',
'        p_request_body     => :P1944_REQUEST_BODY,',
'        --',
'        p_server_id        => :P1942_REMOTE_SERVER_ID,',
'        p_server_url       => :P1942_SERVER_URL,',
'        p_service_path     => :P1942_WEB_SOURCE_PATH,',
'        --',
'        p_https_host       => :P1941_HTTPS_HOST,',
'        --',
'        p_auth_required    => ( :P1943_AUTH_REQUIRED = ''Y'' ),',
'        p_cred_store       => :P1943_CREDENTIAL_STORE,',
'        p_token_url        => :P1943_TOKEN_URL,',
'        p_openapi_url      => :P1941_OPENAPI_URL,',
'        p_openapi_document => case when l_sample_is_swagger is not null then l_sample_response end,',
'        --',
'        p_auth_type        => :P1943_AUTH_TYPE,',
'        p_client_id        => case when :P1943_AUTH_TYPE = ''OCI''                                 then :P1943_OCI_USER_ID ',
'                                   when :P1943_AUTH_TYPE in (''HTTP_HEADER'', ''HTTP_QUERY_STRING'') then :P1943_GENERIC_NAME',
'                                   else :P1943_CLIENT_ID end,',
'        p_client_secret    => case when :P1943_AUTH_TYPE = ''OCI'' then :P1943_OCI_PRIVATE_KEY ',
'                                   when :P1943_AUTH_TYPE in (''HTTP_HEADER'', ''HTTP_QUERY_STRING'') then :P1943_GENERIC_VALUE',
'                                   else :P1943_CLIENT_SECRET end,',
'        p_username         => :P1943_USERNAME,',
'        p_password         => :P1943_PASSWORD,',
'        p_namespace        => :P1943_OCI_NAMESPACE,',
'        p_fingerprint      => :P1943_OCI_FINGERPRINT,',
'        --',
'        p_url_param_name1  => :P1944_PARAM_NAME_1,',
'        p_url_param_type1  => :P1944_PARAM_TYPE_1,',
'        p_url_param_value1 => :P1944_PARAM_VALUE_1,',
'        p_url_param_stat1  => :P1944_PARAM_STATIC_1,',
'        --',
'        p_url_param_name2  => :P1944_PARAM_NAME_2,',
'        p_url_param_type2  => :P1944_PARAM_TYPE_2,',
'        p_url_param_value2 => :P1944_PARAM_VALUE_2,',
'        p_url_param_stat2  => :P1944_PARAM_STATIC_2,',
'        --',
'        p_url_param_name3  => :P1944_PARAM_NAME_3,',
'        p_url_param_type3  => :P1944_PARAM_TYPE_3,',
'        p_url_param_value3 => :P1944_PARAM_VALUE_3,',
'        p_url_param_stat3  => :P1944_PARAM_STATIC_3,',
'        --',
'        p_url_param_name4  => :P1944_PARAM_NAME_4,',
'        p_url_param_type4  => :P1944_PARAM_TYPE_4,',
'        p_url_param_value4 => :P1944_PARAM_VALUE_4,',
'        p_url_param_stat4  => :P1944_PARAM_STATIC_4,',
'        --',
'        p_url_param_name5  => :P1944_PARAM_NAME_5,',
'        p_url_param_type5  => :P1944_PARAM_TYPE_5,',
'        p_url_param_value5 => :P1944_PARAM_VALUE_5,',
'        p_url_param_stat5  => :P1944_PARAM_STATIC_5,',
'        --',
'        p_row_selector     => :P1944_ROW_SELECTOR,',
'        p_is_single_row    => case :P1944_SINGLE_ROW when ''Y'' then true when ''N'' then false end,',
'        --',
'        p_module_name      => :P1941_NAME,',
'        --',
'        p_sample_response  => case when l_sample_is_swagger is null then l_sample_response end,',
'        --',
'        p_attribute_01     => :P1945_ATTRIBUTE_01,',
'        p_attribute_02     => :P1945_ATTRIBUTE_02,',
'        p_attribute_03     => :P1945_ATTRIBUTE_03,',
'        p_attribute_04     => :P1945_ATTRIBUTE_04,',
'        p_attribute_05     => :P1945_ATTRIBUTE_05,',
'        p_attribute_06     => :P1945_ATTRIBUTE_06,',
'        p_attribute_07     => :P1945_ATTRIBUTE_07,',
'        p_attribute_08     => :P1945_ATTRIBUTE_08,',
'        p_attribute_09     => :P1945_ATTRIBUTE_09,',
'        p_attribute_10     => :P1945_ATTRIBUTE_10,',
'        p_attribute_11     => :P1945_ATTRIBUTE_11,',
'        p_attribute_12     => :P1945_ATTRIBUTE_12,',
'        p_attribute_13     => :P1945_ATTRIBUTE_13,',
'        p_attribute_14     => :P1945_ATTRIBUTE_14,',
'        p_attribute_15     => :P1945_ATTRIBUTE_15 );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error during REST Data Source storage or discovery: #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':STORE:DISCOVER:'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_internal_uid=>226649231601378080
);
end;
/
prompt --application/pages/page_01945
begin
wwv_flow_imp_page.create_page(
 p_id=>1945
,p_name=>'Create REST Data Source - Settings'
,p_alias=>'CREATE-WEB-SOURCE-SETTINGS'
,p_page_mode=>'MODAL'
,p_step_title=>'Create REST Data Source - Settings'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2108275387647626)
,p_plug_name=>'REST Enabled SQL Query'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P1945_WEB_SOURCE_TYPE'
,p_plug_display_when_cond2=>'NATIVE_REST_ENABLED_SQL_QUERY'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(348249463253283503)
,p_plug_name=>'Settings'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>40
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P1945_WEB_SOURCE_TYPE'
,p_plug_display_when_cond2=>'NATIVE_REST_ENABLED_SQL_QUERY'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(348267434074286188)
,p_plug_name=>'Add Javascript code for Plugins'
,p_region_name=>'PLUGIN'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    -- create the onChange event for the P1945_SCHEME_TYPE and',
'    -- also the initialization code for the dynamic attributes',
'    wwv_flow_plugin_dev.add_onload_code (',
'        p_plugin_type         => wwv_flow_plugin.c_plugin_type_web_source,',
'        p_type_page_item_name => ''P1945_WEB_SOURCE_TYPE'',',
'        p_page_item_prefix    => ''P1945_'',',
'        p_is_wizard           => true',
'    );',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P1945_WEB_SOURCE_TYPE'
,p_plug_display_when_cond2=>'NATIVE_REST_ENABLED_SQL_QUERY'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4078475012151886933)
,p_plug_name=>'Create REST Data Source'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_imp.id(226545212901831813)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4078475030579886934)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1243693922896095)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(4078475030579886934)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1244095110896102)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(4078475030579886934)
,p_button_name=>'BACK'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Back'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1942:&SESSION.::&DEBUG.:RP,1942::'
,p_button_condition=>'P1945_WEB_SOURCE_TYPE'
,p_button_condition2=>'NATIVE_REST_ENABLED_SQL_QUERY'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2106126111647605)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(4078475030579886934)
,p_button_name=>'BACK_TO_FIRST'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Back'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1941:&SESSION.::&DEBUG.:RP,1942::'
,p_button_condition=>'P1945_WEB_SOURCE_TYPE'
,p_button_condition2=>'NATIVE_REST_ENABLED_SQL_QUERY'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1248589907896187)
,p_branch_name=>'Go To Page 1943'
,p_branch_action=>'f?p=&APP_ID.:1943:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1703473777971333)
,p_branch_name=>'Go To Page 1943'
,p_branch_action=>'f?p=&APP_ID.:1943:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_HEADER'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'NOT_EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugins p,',
'       wwv_flow_plugin_attributes a',
' where p.flow_id           =  case',
'                                when substr(:P1941_WEB_SRC_TYPE, 1, 7) = ''NATIVE_'' then 4411',
'                                else to_number(:FB_FLOW_ID)',
'                              end',
'   and p.plugin_type       =  ''WEB SOURCE TYPE''',
'   and p.name              =  substr(:P1941_WEB_SRC_TYPE, 8) /* remove NATIVE_ */',
'   and a.plugin_id         =  p.id',
'   and a.attribute_scope   =  ''COMPONENT''',
'   and a.show_in_wizard    =  ''Y''',
'   and p.security_group_id in ( :FLOW_SECURITY_GROUP_ID, 10 )'))
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1249113815899063)
,p_name=>'P1945_ATTRIBUTE_01'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(348249463253283503)
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 1, :P1945_ATTRIBUTE_01 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1249514406899065)
,p_name=>'P1945_ATTRIBUTE_02'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(348249463253283503)
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 2, :P1945_ATTRIBUTE_02 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1249973619899065)
,p_name=>'P1945_ATTRIBUTE_03'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(348249463253283503)
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 3, :P1945_ATTRIBUTE_03 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1250311713899066)
,p_name=>'P1945_ATTRIBUTE_04'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(348249463253283503)
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 4, :P1945_ATTRIBUTE_04 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1250788015899066)
,p_name=>'P1945_ATTRIBUTE_05'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(348249463253283503)
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 5, :P1945_ATTRIBUTE_05 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1251104920899066)
,p_name=>'P1945_ATTRIBUTE_06'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(348249463253283503)
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 6, :P1945_ATTRIBUTE_06 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1251522703899066)
,p_name=>'P1945_ATTRIBUTE_07'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(348249463253283503)
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 7, :P1945_ATTRIBUTE_07 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1251963150899066)
,p_name=>'P1945_ATTRIBUTE_08'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(348249463253283503)
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 8, :P1945_ATTRIBUTE_08 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1252318155899066)
,p_name=>'P1945_ATTRIBUTE_09'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(348249463253283503)
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 9, :P1945_ATTRIBUTE_09 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1252775040899067)
,p_name=>'P1945_ATTRIBUTE_10'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(348249463253283503)
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 10, :P1945_ATTRIBUTE_10 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1253100067899067)
,p_name=>'P1945_ATTRIBUTE_11'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(348249463253283503)
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 11, :P1945_ATTRIBUTE_11 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1253505694899067)
,p_name=>'P1945_ATTRIBUTE_12'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(348249463253283503)
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 12, :P1945_ATTRIBUTE_12 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1253916604899067)
,p_name=>'P1945_ATTRIBUTE_13'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(348249463253283503)
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 13, :P1945_ATTRIBUTE_13 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1254346886899067)
,p_name=>'P1945_ATTRIBUTE_14'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(348249463253283503)
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 14, :P1945_ATTRIBUTE_14 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1254744691899068)
,p_name=>'P1945_ATTRIBUTE_15'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_imp.id(348249463253283503)
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 15, :P1945_ATTRIBUTE_15 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2108356345647627)
,p_name=>'P1945_SQL_QUERY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2108275387647626)
,p_prompt=>'SQL Query'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cHeight=>10
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Provide the Query to execute on the REST Enabled SQL Service for this REST Data Source. ',
'    Result discovery and data type detection will be done based on the results of this query.',
'</p',
'<p> ',
'    On MySQL databases, the query will be executed within the <em>default database</em>, which is ',
'    configured within the REST Enabled SQL reference. Tables in other databases can be referenced',
'    by simply prefixing them.',
'</p>'))
,p_attribute_01=>'SQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'P1945_REST_SQL_SERVER_ID'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2108594057647629)
,p_name=>'P1945_REST_SQL_SERVER_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(4078475012151886933)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2211638547848934)
,p_name=>'P1945_WEB_SOURCE_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(4078475012151886933)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2108480616647628)
,p_computation_sequence=>10
,p_computation_item=>'P1945_ATTRIBUTE_01'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P1945_SQL_QUERY'
,p_compute_when=>'P1945_WEB_SOURCE_TYPE'
,p_compute_when_text=>'NATIVE_REST_ENABLED_SQL_QUERY'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2108642005647630)
,p_computation_sequence=>10
,p_computation_item=>'P1945_REST_SQL_SERVER_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P1941_REST_SQL_SERVER'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(6182672934565129)
,p_validation_name=>'Validate Plugin Attributes'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.validate_attribute_items (',
'        p_application_id    => :FB_FLOW_ID,',
'        p_plugin_type       => wwv_flow_plugin.c_plugin_type_web_source,',
'        p_plugin_name       => :P1945_WEB_SOURCE_TYPE,',
'        p_attribute_scope   => wwv_flow_plugin.c_attribute_scope_component,',
'        p_page_item_prefix  => ''P1945_'' );',
'end;'))
,p_validation_type=>'PLSQL_ERROR'
,p_error_message=>'Error'
,p_validation_condition=>'P1945_WEB_SOURCE_TYPE'
,p_validation_condition2=>'NATIVE_REST_ENABLED_SQL_QUERY'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2108760251647631)
,p_validation_name=>'SQL Query is not NULL'
,p_validation_sequence=>20
,p_validation=>'P1945_SQL_QUERY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>'P1945_WEB_SOURCE_TYPE'
,p_validation_condition2=>'NATIVE_REST_ENABLED_SQL_QUERY'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(1243693922896095)
,p_associated_item=>wwv_flow_imp.id(2108356345647627)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1245517386896178)
,p_name=>'Remote Server ID chosen'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1945_REMOTE_SERVER_ID'
,p_condition_element=>'P1945_REMOTE_SERVER_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1246062003896180)
,p_event_id=>wwv_flow_imp.id(1245517386896178)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1945_REMOTE_SERVER_URL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1246545066896182)
,p_event_id=>wwv_flow_imp.id(1245517386896178)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1945_SERVER_URL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1247017135896182)
,p_event_id=>wwv_flow_imp.id(1245517386896178)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1945_REMOTE_SERVER_URL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1247572671896184)
,p_event_id=>wwv_flow_imp.id(1245517386896178)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1945_SERVER_URL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1248075722896184)
,p_event_id=>wwv_flow_imp.id(1245517386896178)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1945_REMOTE_SERVER_URL'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select base_url',
'  from wwv_remote_servers',
' where id     = :P1945_REMOTE_SERVER_ID',
'  and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_attribute_07=>'P1945_REMOTE_SERVER_ID'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
end;
/
prompt --application/pages/page_01946
begin
wwv_flow_imp_page.create_page(
 p_id=>1946
,p_name=>'REST Data Source Discovery'
,p_alias=>'REST-DATA-SOURCE-DISCOVERY'
,p_page_mode=>'MODAL'
,p_step_title=>'REST Data Source Discovery'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(226586120007031721)
,p_plug_name=>'Wizard Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_list_id=>wwv_flow_imp.id(226545212901831813)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(226685270873475214)
,p_plug_name=>'Success'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_condition_type=>'ITEM_IS_NULL'
,p_plug_display_when_condition=>'P1946_STATUS_CODE'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2403493023176708)
,p_plug_name=>'Response Body'
,p_parent_plug_id=>wwv_flow_imp.id(226685270873475214)
,p_region_template_options=>'#DEFAULT#:a-Alert--info:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'to_number( :P1946_RESPONSE_LENGTH default 1000 on conversion error ) >= to_number( :F4000_MAX_RESPONSE_SIZE_KB default 500 on conversion error )'
,p_plug_display_when_cond2=>'PLSQL'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The response body of &P1946_RESPONSE_LENGTH.KB is too large to display. The maximum allowed size is &F4000_MAX_RESPONSE_SIZE_KB.KB.',
'<br> <br>',
'&P1946_BODY_PART.'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(48101656388492239)
,p_plug_name=>'Data Profile'
,p_parent_plug_id=>wwv_flow_imp.id(226685270873475214)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(48101703770492240)
,p_name=>'Data Profile'
,p_parent_plug_id=>wwv_flow_imp.id(48101656388492239)
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_region_attributes=>'style="margin-bottom: 10px"'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select coalesce( c002, ''.'' ) as row_selector,',
'       case when c003 = ''Y'' then wwv_flow_lang.system_message(''APEX.WEBSRC.DATAPROFILE.ONE'') else wwv_flow_lang.system_message(''APEX.WEBSRC.DATAPROFILE.MANY'') end as single_row,',
'       c004 as response_type',
'  from wwv_flow_collections ',
' where collection_name = ''WEB_SOURCE_INFO''',
'   and c001            = ''DATA_PROFILE''',
'   and rownum = 1',
''))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48101890060492241)
,p_query_column_id=>1
,p_column_alias=>'ROW_SELECTOR'
,p_column_display_sequence=>2
,p_column_heading=>'Row Selector'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48101945831492242)
,p_query_column_id=>2
,p_column_alias=>'SINGLE_ROW'
,p_column_display_sequence=>3
,p_column_heading=>'Returns'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(84259319526460470)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48102011041492243)
,p_query_column_id=>3
,p_column_alias=>'RESPONSE_TYPE'
,p_column_display_sequence=>1
,p_column_heading=>'Response Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(229850152662472437)
,p_name=>'Data Profile Columns'
,p_parent_plug_id=>wwv_flow_imp.id(48101656388492239)
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch:a-Report--rowHighlight'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select rownum as sequence,',
'       c002 as column_name,',
'       c003 as is_primary_key,',
'       c004 as data_type,',
'       c005 as max_length,',
'       c006 as format_mask,',
'       c007 as has_time_zone,',
'       c008 as selector,',
'       null as remove_row',
'  from wwv_flow_collections ',
' where collection_name = ''WEB_SOURCE_INFO''',
'   and c001            = ''DATA_PROFILE_COLUMNS''',
' order by seq_id asc',
''))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>150
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>'No Data Found'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(226606368877196931)
,p_query_column_id=>1
,p_column_alias=>'SEQUENCE'
,p_column_display_sequence=>1
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(226606797600196935)
,p_query_column_id=>2
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(226607069519196935)
,p_query_column_id=>3
,p_column_alias=>'IS_PRIMARY_KEY'
,p_column_display_sequence=>3
,p_column_heading=>'Primary Key'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(84259319526460470)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(226607415624196937)
,p_query_column_id=>4
,p_column_alias=>'DATA_TYPE'
,p_column_display_sequence=>4
,p_column_heading=>'Data type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(226607845047196937)
,p_query_column_id=>5
,p_column_alias=>'MAX_LENGTH'
,p_column_display_sequence=>5
,p_column_heading=>'Max Length'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(226608298659196938)
,p_query_column_id=>6
,p_column_alias=>'FORMAT_MASK'
,p_column_display_sequence=>6
,p_column_heading=>'Format Mask'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(226608666487196938)
,p_query_column_id=>7
,p_column_alias=>'HAS_TIME_ZONE'
,p_column_display_sequence=>7
,p_column_heading=>'Has Time Zone'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(84259319526460470)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(226609001538196938)
,p_query_column_id=>8
,p_column_alias=>'SELECTOR'
,p_column_display_sequence=>8
,p_column_heading=>'Selector'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2402710187176701)
,p_query_column_id=>9
,p_column_alias=>'REMOVE_ROW'
,p_column_display_sequence=>18
,p_column_heading=>'Remove '
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<button class="a-Button a-Button--noLabel a-Button--withIcon a-Button--noUI remove-row" data-id ="#COLUMN_NAME#" value="Remove #COLUMN_NAME#" type="button" title="Remove #COLUMN_NAME#"><span class="a-Icon icon-remove" role="img" aria-label="Remove #C'
||'OLUMN_NAME#"></span></button>'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(229792181060921168)
,p_plug_name=>'Response Body'
,p_parent_plug_id=>wwv_flow_imp.id(226685270873475214)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'select wwv_flow_web_src_dev.get_formatted_response( p_response_type => :P1946_RESPONSE_TYPE ) from sys.dual'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.CLOB_CODE_EDITOR'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'to_number(:P1946_RESPONSE_LENGTH default 1000 on conversion error ) < to_number( :F4000_MAX_RESPONSE_SIZE_KB default 500 on conversion error )'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'PAGE_ITEM',
  'attribute_02', 'AUTO',
  'attribute_03', 'Y',
  'attribute_06', 'P1946_RESPONSE_TYPE')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(229851843366472454)
,p_plug_name=>'RDS'
,p_parent_plug_id=>wwv_flow_imp.id(226685270873475214)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'N',
  'rds_mode', 'STANDARD',
  'remember_selection', 'NO')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(229851931201472455)
,p_name=>'Data'
,p_parent_plug_id=>wwv_flow_imp.id(226685270873475214)
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch:a-Report--rowHighlight'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001,',
'       c002,',
'       c003,',
'       c004,',
'       c005,',
'       c006,',
'       c007,',
'       c008,',
'       c009,',
'       c010,',
'       c011,',
'       c012,',
'       c013,',
'       c014,',
'       c015',
'  from wwv_flow_collections',
' where collection_name = ''WEB_SOURCE_DATA'''))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_headings=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_headings varchar2(32767);',
'begin',
'    for c in ( select * from (',
'                   select c002 ',
'                     from wwv_flow_collections',
'                    where collection_name = ''WEB_SOURCE_INFO''',
'                      and c001            = ''DATA_PROFILE_COLUMNS''',
'                      and c015            is null',
'                      and c004            != ''ARRAY''',
'                    order by seq_id asc ) ',
'               where rownum <= 15 ) loop',
'       l_headings := l_headings || initcap(c.c002) || '':'';',
'    end loop;',
'    return substr( l_headings, 1, length( l_headings ) - 1 );',
'end;'))
,p_query_headings_type=>'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST'
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'Found no data while parsing the service response.'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(226610005093196945)
,p_query_column_id=>1
,p_column_alias=>'C001'
,p_column_display_sequence=>1
,p_column_heading=>'C001'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(226610429777196945)
,p_query_column_id=>2
,p_column_alias=>'C002'
,p_column_display_sequence=>2
,p_column_heading=>'C002'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(226610842779196946)
,p_query_column_id=>3
,p_column_alias=>'C003'
,p_column_display_sequence=>3
,p_column_heading=>'C003'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(226611254239196946)
,p_query_column_id=>4
,p_column_alias=>'C004'
,p_column_display_sequence=>4
,p_column_heading=>'C004'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(226611670304196946)
,p_query_column_id=>5
,p_column_alias=>'C005'
,p_column_display_sequence=>5
,p_column_heading=>'C005'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(226612048551196947)
,p_query_column_id=>6
,p_column_alias=>'C006'
,p_column_display_sequence=>6
,p_column_heading=>'C006'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(226612495123196947)
,p_query_column_id=>7
,p_column_alias=>'C007'
,p_column_display_sequence=>7
,p_column_heading=>'C007'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(226612867754196947)
,p_query_column_id=>8
,p_column_alias=>'C008'
,p_column_display_sequence=>8
,p_column_heading=>'C008'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(226613233610196948)
,p_query_column_id=>9
,p_column_alias=>'C009'
,p_column_display_sequence=>9
,p_column_heading=>'C009'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(226613651422196948)
,p_query_column_id=>10
,p_column_alias=>'C010'
,p_column_display_sequence=>10
,p_column_heading=>'C010'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(226614004025196948)
,p_query_column_id=>11
,p_column_alias=>'C011'
,p_column_display_sequence=>11
,p_column_heading=>'C011'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(226614464010196949)
,p_query_column_id=>12
,p_column_alias=>'C012'
,p_column_display_sequence=>12
,p_column_heading=>'C012'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(226614855773196949)
,p_query_column_id=>13
,p_column_alias=>'C013'
,p_column_display_sequence=>13
,p_column_heading=>'C013'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(226615240311196949)
,p_query_column_id=>14
,p_column_alias=>'C014'
,p_column_display_sequence=>14
,p_column_heading=>'C014'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(226615666820196950)
,p_query_column_id=>15
,p_column_alias=>'C015'
,p_column_display_sequence=>15
,p_column_heading=>'C015'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(229894216737686340)
,p_name=>'Operations'
,p_parent_plug_id=>wwv_flow_imp.id(226685270873475214)
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch:a-Report--rowHighlight'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c002 as method,',
'       c003 as url_endpoint,',
'       c004 as database_operation',
'  from wwv_flow_collections',
' where collection_name = ''WEB_SOURCE_INFO''',
'   and c001            = ''METHODS''',
' order by c002 asc'))
,p_display_when_condition=>'P1946_SHOW_ALL'
,p_display_when_cond2=>'Y'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(226617007286196953)
,p_query_column_id=>1
,p_column_alias=>'METHOD'
,p_column_display_sequence=>1
,p_column_heading=>'HTTP Method'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(226617451096196954)
,p_query_column_id=>2
,p_column_alias=>'URL_ENDPOINT'
,p_column_display_sequence=>2
,p_column_heading=>'Endpoint URL'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(226617847373196955)
,p_query_column_id=>3
,p_column_alias=>'DATABASE_OPERATION'
,p_column_display_sequence=>3
,p_column_heading=>'Database Action'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(225834585600778166)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(452559754639812674)
,p_name=>'Response Headers'
,p_parent_plug_id=>wwv_flow_imp.id(226685270873475214)
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch:a-Report--rowHighlight'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c002 as header_name,',
'       c003 as header_value',
'  from wwv_flow_collections',
' where collection_name = ''WEB_SOURCE_INFO''',
'   and c001            = ''RESPONSE_HEADERS''',
' order by seq_id asc',
''))
,p_display_when_condition=>'P1946_SHOW_ALL'
,p_display_when_cond2=>'Y'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(226618521824196956)
,p_query_column_id=>1
,p_column_alias=>'HEADER_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Header name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(226618941809196956)
,p_query_column_id=>2
,p_column_alias=>'HEADER_VALUE'
,p_column_display_sequence=>2
,p_column_heading=>'Header value'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(226685367362475215)
,p_plug_name=>'Failure'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P1946_STATUS_CODE'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3055706140758106)
,p_plug_name=>'HTTP Status'
,p_parent_plug_id=>wwv_flow_imp.id(226685367362475215)
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_header=>'Discovery error: &P1946_STATUS_CODE.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(226685443264475216)
,p_name=>'Server Response'
,p_parent_plug_id=>wwv_flow_imp.id(226685367362475215)
,p_template=>wwv_flow_imp.id(689970285456172024)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sys.dbms_lob.substr( clob001, 4000, 1 ) as response',
'  from wwv_flow_collections ',
' where collection_name = ''WEB_SOURCE_INFO''',
'   and c001            = ''ERROR''',
''))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(226685602377475218)
,p_query_column_id=>1
,p_column_alias=>'RESPONSE'
,p_column_display_sequence=>1
,p_column_heading=>'Response'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(229893262666686330)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(226586249349031722)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(229893262666686330)
,p_button_name=>'SHOW_MORE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'More Detail'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1946:&SESSION.::&DEBUG.:RP:P1946_SHOW_ALL:Y'
,p_button_condition=>':P1946_SHOW_ALL = ''N'' and :P1946_STATUS_CODE is null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(226683938048475201)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(229893262666686330)
,p_button_name=>'SHOW_LESS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Less Detail'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1946:&SESSION.::&DEBUG.:RP:P1946_SHOW_ALL:N'
,p_button_condition=>':P1946_SHOW_ALL = ''Y'' and :P1946_STATUS_CODE is null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(226616313480196951)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(229893262666686330)
,p_button_name=>'CREATE_MODULE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create REST Data Source'
,p_button_position=>'NEXT'
,p_button_condition=>'P1946_STATUS_CODE'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(226585834019031718)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(229893262666686330)
,p_button_name=>'BACK'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Back'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&P1946_PREVIOUS_PAGE.:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(226619854736196958)
,p_branch_name=>'Go To Page 1901'
,p_branch_action=>'f?p=&APP_ID.:1901:&SESSION.::&DEBUG.:RP,1941,1942,1943,1944,1945,1946::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2402855134176702)
,p_name=>'P1946_COLUMN_DATA'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(48101656388492239)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2402937950176703)
,p_name=>'P1946_RESPONSE_LENGTH'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(48101656388492239)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2403083326176704)
,p_name=>'P1946_RESPONSE_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(48101656388492239)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2403508030176709)
,p_name=>'P1946_BODY_PART'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(48101656388492239)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(226585921645031719)
,p_name=>'P1946_PREVIOUS_PAGE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(229893262666686330)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(226586031765031720)
,p_name=>'P1946_SHOW_ALL'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(229893262666686330)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(226685714561475219)
,p_name=>'P1946_STATUS_CODE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(226685443264475216)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3055622531758105)
,p_computation_sequence=>10
,p_computation_item=>'P1946_RESPONSE_TYPE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
' select c004',
'   from wwv_flow_collections ',
'  where collection_name = ''WEB_SOURCE_INFO''',
'    and c001            = ''DATA_PROFILE'';'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(226685885175475220)
,p_computation_sequence=>10
,p_computation_item=>'P1946_STATUS_CODE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c002',
'  from wwv_flow_collections ',
' where collection_name = ''WEB_SOURCE_INFO''',
'   and c001            = ''ERROR''',
'   and rownum          = 1',
''))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2403641493176710)
,p_name=>'Set Value  P1946_COLUMN_DATA on click event'
,p_event_sequence=>10
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'.remove-row'
,p_bind_type=>'live'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2403829819176712)
,p_event_id=>wwv_flow_imp.id(2403641493176710)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1946_COLUMN_DATA'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'this.triggeringElement.dataset.id'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2404414248176718)
,p_name=>'Set Value P1946_COLUMN_DATA on Enter key pressed'
,p_event_sequence=>20
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'.remove-row'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$( this.browserEvent.target ).hasClass( "remove-row") || ( this.browserEvent.type === ''keypress'' && this.browserEvent.key === ''Enter'' )'
,p_bind_type=>'live'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'keypress'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2404546069176719)
,p_event_id=>wwv_flow_imp.id(2404414248176718)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1946_COLUMN_DATA'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'this.triggeringElement.dataset.id'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(7816757144644301)
,p_name=>'Remove row from collection'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1946_COLUMN_DATA'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2403973395176713)
,p_event_id=>wwv_flow_imp.id(7816757144644301)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_seq_id number;',
'begin',
'    select seq_id',
'      into l_seq_id',
'      from wwv_flow_collections ',
'     where collection_name = ''WEB_SOURCE_INFO''',
'       and c001            = ''DATA_PROFILE_COLUMNS''',
'       and lower(c002)     = lower(:P1946_COLUMN_DATA);',
'',
'  wwv_flow_collection.delete_member (',
'    p_collection_name => ''WEB_SOURCE_INFO'',',
'    p_seq             => l_seq_id) ;',
' --   ',
' exception',
'    when no_data_found then',
'        null;',
'',
'end;'))
,p_attribute_02=>'P1946_COLUMN_DATA'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2404315698176717)
,p_event_id=>wwv_flow_imp.id(7816757144644301)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.message.showPageSuccess( ''Row has been deleted.'' )'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2404030007176714)
,p_event_id=>wwv_flow_imp.id(7816757144644301)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(229850152662472437)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(226619385683196957)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Store REST Data Source'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_web_src_dev.store_web_src_module(',
'    p_application_id      => :FB_FLOW_ID,',
'    p_module_name         => :P1941_NAME,',
'    p_web_source_type     => :P1941_WEB_SRC_TYPE,',
'    p_remote_server_id    => :P1942_REMOTE_SERVER_ID,',
'    p_server_base_url     => :P1942_SERVER_URL,',
'    p_url_pattern         => :P1942_WEB_SOURCE_PATH,',
'    p_https_host          => :P1941_HTTPS_HOST,',
'    p_credential_store_id => ( case when :P1943_AUTH_REQUIRED = ''Y'' then :P1943_CREDENTIAL_STORE end ),',
'    p_auth_scheme         => ( case when :P1943_AUTH_REQUIRED = ''Y'' then :P1943_AUTH_TYPE        end ),',
'    p_oauth_token_url     => ( case when :P1943_AUTH_REQUIRED = ''Y'' and :P1943_AUTH_TYPE = wwv_flow_credential_api.c_type_oauth_client_cred ',
'                                    then :P1943_TOKEN_URL end ),',
'    p_client_id           => case when :P1943_AUTH_TYPE = ''OCI''                                 then :P1943_OCI_USER_ID ',
'                                  when :P1943_AUTH_TYPE in (''HTTP_HEADER'', ''HTTP_QUERY_STRING'') then :P1943_GENERIC_NAME',
'                                  else :P1943_CLIENT_ID end,',
'    p_client_secret       => case when :P1943_AUTH_TYPE = ''OCI'' then :P1943_OCI_PRIVATE_KEY ',
'                                 when :P1943_AUTH_TYPE in (''HTTP_HEADER'', ''HTTP_QUERY_STRING'') then :P1943_GENERIC_VALUE',
'                                 else :P1943_CLIENT_SECRET end,',
'    p_username            => :P1943_USERNAME,',
'    p_password            => :P1943_PASSWORD,',
'    p_namespace           => :P1943_OCI_NAMESPACE,',
'    p_fingerprint         => :P1943_OCI_FINGERPRINT,',
'    --',
'    p_attribute_01        => :P1945_ATTRIBUTE_01,',
'    p_attribute_02        => :P1945_ATTRIBUTE_02,',
'    p_attribute_03        => :P1945_ATTRIBUTE_03,',
'    p_attribute_04        => :P1945_ATTRIBUTE_04,',
'    p_attribute_05        => :P1945_ATTRIBUTE_05,',
'    p_attribute_06        => :P1945_ATTRIBUTE_06,',
'    p_attribute_07        => :P1945_ATTRIBUTE_07,',
'    p_attribute_08        => :P1945_ATTRIBUTE_08,',
'    p_attribute_09        => :P1945_ATTRIBUTE_09,',
'    p_attribute_10        => :P1945_ATTRIBUTE_10,',
'    p_attribute_11        => :P1945_ATTRIBUTE_11,',
'    p_attribute_12        => :P1945_ATTRIBUTE_12,',
'    p_attribute_13        => :P1945_ATTRIBUTE_13,',
'    p_attribute_14        => :P1945_ATTRIBUTE_14,',
'    p_attribute_15        => :P1945_ATTRIBUTE_15 );',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(226616313480196951)
,p_process_success_message=>'REST Data Source created.'
,p_internal_uid=>226619385683196957
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2403194101176705)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Init Values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    select round(sys.dbms_lob.getlength(clob001) / 1000), -- transform to kilobytes',
'           substr(clob001, 1, 500)',
'      into :P1946_RESPONSE_LENGTH,',
'           :P1946_BODY_PART',
'      from wwv_flow_collections ',
'     where collection_name = ''WEB_SOURCE_INFO'' ',
'       and c001=''DATA'' ',
'       and rownum = 1;',
'exception',
'    when no_data_found then',
'        null;',
'end;',
'',
'',
'',
'',
'   '))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>2403194101176705
);
end;
/
prompt --application/pages/page_01947
begin
wwv_flow_imp_page.create_page(
 p_id=>1947
,p_name=>'HTTP Failure'
,p_alias=>'HTTP-FAILURE'
,p_page_mode=>'MODAL'
,p_step_title=>'HTTP Failure'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'11'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3056098891758109)
,p_plug_name=>'The endpoint URL could not be invoked.'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
''))
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P1941_SUCCESS'
,p_plug_display_when_cond2=>'N_H'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The remote server responded with ',
'<pre>&P1941_MESSAGE.</pre>',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3056197124758110)
,p_plug_name=>'The endpoint URL could not be invoked.'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'',
''))
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P1941_SUCCESS'
,p_plug_display_when_cond2=>'N_D'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'An error occurred during URL invocation.',
'<pre>&P1941_MESSAGE.</pre>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4079543730140707029)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(236247548469284210)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(4079543730140707029)
,p_button_name=>'CONTINUE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Continue'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(226684519446475207)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(4079543730140707029)
,p_button_name=>'BACK'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Back'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1941:&SESSION.::&DEBUG.:RP:P1941_MUST_AUTHENTICATE,P1941_SUCCESS,P1941_MESSAGE:,,'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(236247659346284211)
,p_branch_action=>'f?p=&APP_ID.:1942:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(236247548469284210)
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_01948
begin
wwv_flow_imp_page.create_page(
 p_id=>1948
,p_name=>'REST Data Source Rediscovery'
,p_alias=>'REST-DATA-SOURCE-REDISCOVERY'
,p_page_mode=>'MODAL'
,p_step_title=>'REST Data Source Rediscovery'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(755919982109834575)
,p_plug_name=>'Success'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_condition_type=>'ITEM_IS_NULL'
,p_plug_display_when_condition=>'P1948_STATUS_CODE'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2406052660176734)
,p_plug_name=>'Response Body'
,p_parent_plug_id=>wwv_flow_imp.id(755919982109834575)
,p_region_template_options=>'#DEFAULT#:a-Alert--info:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'to_number(:P1948_RESPONSE_LENGTH default 1000 on conversion error ) >= to_number( :F4000_MAX_RESPONSE_SIZE_KB default 500 on conversion error )'
,p_plug_display_when_cond2=>'PLSQL'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The response body of &P1948_RESPONSE_LENGTH.KB is too large to display. The maximum allowed size is &F4000_MAX_RESPONSE_SIZE_KB.KB.',
'<br> <br>',
'&P1948_BODY_PART.',
'',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(759026892297280529)
,p_plug_name=>'Response Body'
,p_parent_plug_id=>wwv_flow_imp.id(755919982109834575)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'select wwv_flow_web_src_dev.get_formatted_response( p_response_type => :P1948_RESPONSE_TYPE ) from sys.dual'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.CLOB_CODE_EDITOR'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'to_number(:P1948_RESPONSE_LENGTH default 1000 on conversion error ) < to_number( :F4000_MAX_RESPONSE_SIZE_KB default 500 on conversion error )'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'PAGE_ITEM',
  'attribute_02', 'AUTO',
  'attribute_03', 'Y',
  'attribute_06', 'P1948_RESPONSE_TYPE')).to_clob
,p_plug_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'',
'/* select case when sys.dbms_lob.getlength(clob001) > 524288 then ',
'        to_clob( wwv_flow_lang.system_message(''apex.websrc.response_body_too_large'')) else clob001 ',
'        end clob001 ',
'  from wwv_flow_collections ',
' where collection_name = ''WEB_SOURCE_INFO'' ',
'   and c001=''DATA'' ',
'   and rownum = 1*/'))
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(759084863898831798)
,p_name=>'Columns'
,p_parent_plug_id=>wwv_flow_imp.id(755919982109834575)
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch:a-Report--rowHighlight'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with new_columns as (',
'    select seq_id,',
'           c002 as name,',
'           c003 as is_primary_key,',
'           c004 as data_type,',
'           c005 as max_length,',
'           c006 as format_mask,',
'           c007 as has_time_zone,',
'           c008 as selector',
'      from wwv_flow_collections ',
'     where collection_name = ''WEB_SOURCE_INFO''',
'       and c001            = ''DATA_PROFILE_COLUMNS''',
'), old_columns as (',
'    select dpc.name,',
'           dpc.data_type',
'      from wwv_flow_data_profile_cols dpc,',
'           wwv_flow_web_src_modules wm',
'     where wm.data_profile_id      = dpc.data_profile_id',
'       and wm.id                   = :P1948_WEB_SRC_MODULE_ID',
'       and wm.security_group_id    = :FLOW_SECURITY_GROUP_ID',
'       and wm.flow_id              = :FB_FLOW_ID',
')',
'select case when o.name is null then 1 else 2 end as orderby,',
'       case when o.name is null then ''font-weight: bold;''',
'            when o.name = n.name then ''color: gray;'' end as new_style,',
'       case when o.name = n.name then ''color: gray;'' end as existing_style,',
'       o.name as existing_column_name,',
'       n.name as new_column_name,',
'       n.data_type,',
'       n.format_mask,',
'       n.selector,',
'       null as remove_row',
'  from new_columns n, old_columns o',
' where o.name      ( + ) = n.name',
'   and o.data_type ( + ) = n.data_type',
'  order by orderby, n.seq_id asc nulls first'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(529219275489107512)
,p_query_column_id=>1
,p_column_alias=>'ORDERBY'
,p_column_display_sequence=>6
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(529219372849107513)
,p_query_column_id=>2
,p_column_alias=>'NEW_STYLE'
,p_column_display_sequence=>7
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(529219464209107514)
,p_query_column_id=>3
,p_column_alias=>'EXISTING_STYLE'
,p_column_display_sequence=>8
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(529218944608107509)
,p_query_column_id=>4
,p_column_alias=>'EXISTING_COLUMN_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Existing Column'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<span style="#EXISTING_STYLE#">#EXISTING_COLUMN_NAME#</span>'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(529219039537107510)
,p_query_column_id=>5
,p_column_alias=>'NEW_COLUMN_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'New Column'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<span style="#NEW_STYLE#">#NEW_COLUMN_NAME#</span>'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(529237118965359406)
,p_query_column_id=>6
,p_column_alias=>'DATA_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Data type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(529237918661359406)
,p_query_column_id=>7
,p_column_alias=>'FORMAT_MASK'
,p_column_display_sequence=>4
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(529238766397359407)
,p_query_column_id=>8
,p_column_alias=>'SELECTOR'
,p_column_display_sequence=>5
,p_column_heading=>'Selector'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(759086554602831815)
,p_plug_name=>'RDS'
,p_parent_plug_id=>wwv_flow_imp.id(755919982109834575)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'N',
  'rds_mode', 'STANDARD',
  'remember_selection', 'NO')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(759086642437831816)
,p_name=>'Data'
,p_parent_plug_id=>wwv_flow_imp.id(755919982109834575)
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch:a-Report--rowHighlight'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001,',
'       c002,',
'       c003,',
'       c004,',
'       c005,',
'       c006,',
'       c007,',
'       c008,',
'       c009,',
'       c010,',
'       c011,',
'       c012,',
'       c013,',
'       c014,',
'       c015',
'  from wwv_flow_collections',
' where collection_name = ''WEB_SOURCE_DATA'''))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_headings=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_headings varchar2(32767);',
'begin',
'    for c in ( select * from (',
'                   select c002 ',
'                     from wwv_flow_collections',
'                    where collection_name = ''WEB_SOURCE_INFO''',
'                      and c001            = ''DATA_PROFILE_COLUMNS''',
'                    order by seq_id asc ) ',
'               where rownum <= 15 ) loop',
'       l_headings := l_headings || initcap(c.c002) || '':'';',
'    end loop;',
'    return substr( l_headings, 1, length( l_headings ) - 1 );',
'end;'))
,p_query_headings_type=>'FUNCTION_BODY_RETURNING_COLON_DELIMITED_LIST'
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'Found no data while parsing the service response.'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(529239764726359409)
,p_query_column_id=>1
,p_column_alias=>'C001'
,p_column_display_sequence=>1
,p_column_heading=>'C001'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(529240158672359410)
,p_query_column_id=>2
,p_column_alias=>'C002'
,p_column_display_sequence=>2
,p_column_heading=>'C002'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(529240576953359410)
,p_query_column_id=>3
,p_column_alias=>'C003'
,p_column_display_sequence=>3
,p_column_heading=>'C003'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(529240994309359410)
,p_query_column_id=>4
,p_column_alias=>'C004'
,p_column_display_sequence=>4
,p_column_heading=>'C004'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(529241336682359410)
,p_query_column_id=>5
,p_column_alias=>'C005'
,p_column_display_sequence=>5
,p_column_heading=>'C005'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(529241711855359411)
,p_query_column_id=>6
,p_column_alias=>'C006'
,p_column_display_sequence=>6
,p_column_heading=>'C006'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(529242102972359411)
,p_query_column_id=>7
,p_column_alias=>'C007'
,p_column_display_sequence=>7
,p_column_heading=>'C007'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(529242537732359411)
,p_query_column_id=>8
,p_column_alias=>'C008'
,p_column_display_sequence=>8
,p_column_heading=>'C008'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(529242996605359411)
,p_query_column_id=>9
,p_column_alias=>'C009'
,p_column_display_sequence=>9
,p_column_heading=>'C009'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(529243316621359412)
,p_query_column_id=>10
,p_column_alias=>'C010'
,p_column_display_sequence=>10
,p_column_heading=>'C010'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(529243723016359412)
,p_query_column_id=>11
,p_column_alias=>'C011'
,p_column_display_sequence=>11
,p_column_heading=>'C011'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(529244102290359412)
,p_query_column_id=>12
,p_column_alias=>'C012'
,p_column_display_sequence=>12
,p_column_heading=>'C012'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(529244588361359412)
,p_query_column_id=>13
,p_column_alias=>'C013'
,p_column_display_sequence=>13
,p_column_heading=>'C013'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(529244985549359413)
,p_query_column_id=>14
,p_column_alias=>'C014'
,p_column_display_sequence=>14
,p_column_heading=>'C014'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(529245312343359413)
,p_query_column_id=>15
,p_column_alias=>'C015'
,p_column_display_sequence=>15
,p_column_heading=>'C015'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(755920078598834576)
,p_plug_name=>'Failure'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P1948_STATUS_CODE'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3055833528758107)
,p_plug_name=>'HTTP Status'
,p_parent_plug_id=>wwv_flow_imp.id(755920078598834576)
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_header=>'Discovery error: &P1948_STATUS_CODE.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(755920154500834577)
,p_name=>'Server Response'
,p_parent_plug_id=>wwv_flow_imp.id(755920078598834576)
,p_template=>wwv_flow_imp.id(689970285456172024)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sys.dbms_lob.substr( clob001, 4000, 1 ) as response',
'  from wwv_flow_collections ',
' where collection_name = ''WEB_SOURCE_INFO''',
'   and c001            = ''ERROR''',
''))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(529248953139359419)
,p_query_column_id=>1
,p_column_alias=>'RESPONSE'
,p_column_display_sequence=>1
,p_column_heading=>'Response'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(759127973903045691)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(529250397334359435)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(759127973903045691)
,p_button_name=>'REPLACE_PROFILE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Replace Data Profile'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_page_plugs',
' where web_src_module_id = :P1948_WEB_SRC_MODULE_ID',
'   and flow_id = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
'union all (',
'select 1 ',
'  from wwv_flow_step_processing',
' where web_src_module_id = :P1948_WEB_SRC_MODULE_ID',
'   and flow_id = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
') union all (',
'select 1 from sys.dual where :P1948_STATUS_CODE is not null ',
')'))
,p_button_condition_type=>'NOT_EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(529219709093107517)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(759127973903045691)
,p_button_name=>'EXTEND_PROFILE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Extend Data Profile'
,p_button_position=>'NEXT'
,p_button_condition=>'P1948_STATUS_CODE'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(529250799067359438)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(759127973903045691)
,p_button_name=>'CLOSE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Close'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(529253998227359454)
,p_branch_name=>'Go To Page 1921'
,p_branch_action=>'f?p=&APP_ID.:1925:&SESSION.::&DEBUG.:RP,1948::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2405353940176727)
,p_name=>'P1948_RESPONSE_LENGTH'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(755919982109834575)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2405469477176728)
,p_name=>'P1948_RESPONSE_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(755919982109834575)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2405515716176729)
,p_name=>'P1948_BODY_PART'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(755919982109834575)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(529218844894107508)
,p_name=>'P1948_WEB_SRC_MODULE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(759127973903045691)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(529249329332359421)
,p_name=>'P1948_STATUS_CODE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(755920154500834577)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(529252317749359441)
,p_name=>'P1948_PREVIOUS_PAGE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(759127973903045691)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2405764198176731)
,p_computation_sequence=>10
,p_computation_item=>'P1948_RESPONSE_TYPE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
' select c004',
'   from wwv_flow_collections ',
'  where collection_name = ''WEB_SOURCE_INFO''',
'    and c001            = ''DATA_PROFILE'';'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(529253173284359452)
,p_computation_sequence=>10
,p_computation_item=>'P1948_STATUS_CODE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c002',
'  from wwv_flow_collections ',
' where collection_name = ''WEB_SOURCE_INFO''',
'   and c001            = ''ERROR''',
'   and rownum          = 1',
''))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(529218622052107506)
,p_name=>'Click'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(529250799067359438)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(529218746566107507)
,p_event_id=>wwv_flow_imp.id(529218622052107506)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(529219638360107516)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Replace Data Profile Columns'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_data_profile_id number;',
'begin',
'    select data_profile_id ',
'      into l_data_profile_id',
'      from wwv_flow_web_src_modules',
'     where security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and flow_id           = :FB_FLOW_ID',
'       and id                = :P1948_WEB_SRC_MODULE_ID;',
'',
'    wwv_flow_web_src_dev.store_data_profile_columns(',
'        p_application_id => :FB_FLOW_ID,',
'        p_data_profile_id => l_data_profile_id,',
'        p_replace         => true );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(529250397334359435)
,p_process_success_message=>'Data Profile columns replaced.'
,p_internal_uid=>529219638360107516
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(529219906382107519)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Extend Data Profile Columns'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_data_profile_id number;',
'begin',
'    select data_profile_id ',
'      into l_data_profile_id',
'      from wwv_flow_web_src_modules',
'     where security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and flow_id           = :FB_FLOW_ID',
'       and id                = :P1948_WEB_SRC_MODULE_ID;',
'',
'    wwv_flow_web_src_dev.store_data_profile_columns(',
'        p_application_id => :FB_FLOW_ID,',
'        p_data_profile_id => l_data_profile_id,',
'        p_replace         => false );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(529219709093107517)
,p_process_success_message=>'New Columns have been merged into the Data Profile.'
,p_internal_uid=>529219906382107519
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2405834507176732)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Init Values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    select round(sys.dbms_lob.getlength(clob001) / 1000), -- transform to kilobytes',
'           substr(clob001, 1, 500) ',
'      into :P1948_RESPONSE_LENGTH,',
'           :P1948_BODY_PART ',
'      from wwv_flow_collections ',
'     where collection_name = ''WEB_SOURCE_INFO'' ',
'       and c001=''DATA'' ',
'       and rownum = 1;',
'exception',
'    when no_data_found then',
'        null;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>2405834507176732
);
end;
/
prompt --application/pages/page_01951
begin
wwv_flow_imp_page.create_page(
 p_id=>1951
,p_name=>'REST Synchronization'
,p_alias=>'REST-DATA-SOURCE-SYNCHRONIZATION'
,p_step_title=>'REST Synchronization'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var gCheckJobInterval = 0;',
'',
'function buildInterval() {',
'    var lIntervalString = ''FREQ='' + $v("P1951_INT_FREQUENCY") +',
'                          '';INTERVAL='' + $v("P1951_INT_INTERVAL");',
'    ',
'    if ( $v("P1951_BYDAY") !== "" && $v("P1951_INT_FREQUENCY") !== "DAILY" && $v("P1951_BYDAY") !== "MON:TUE:WED:THU:FRI:SAT:SUN" ) {',
'       lIntervalString =  lIntervalString + ";BYDAY=" + $v("P1951_BYDAY").replace(/:/g,",");',
'    }',
'    if ( $v("P1951_BYHOUR") !== "" && $v("P1951_INT_FREQUENCY") !== "HOURLY") {',
'       lIntervalString =  lIntervalString + ";BYHOUR=" + $v("P1951_BYHOUR");',
'    }',
'    if ( $v("P1951_BYMINUTE") !== "" && $v("P1951_INT_FREQUENCY") !== "MINUTELY" ) {',
'       lIntervalString =  lIntervalString + ";BYMINUTE=" + $v("P1951_BYMINUTE");',
'    }',
'    ',
'    lIntervalString =  lIntervalString + ";BYSECOND=0";',
'    ',
'    return lIntervalString;',
'}',
'',
'function setCheckJobTimeout() {',
'    //',
'    // the interval starts with 2 seconds, and is then increased by 2 seconds',
'    // for each iteration. However, the maximum interval is 10 seconds.',
'    //',
'    if ( gCheckJobInterval < 10000 ) {',
'        gCheckJobInterval = gCheckJobInterval + 2000;        ',
'    } else {',
'        gCheckJobInterval = 10000;',
'    }',
'    window.setTimeout( ',
'        function() {apex.event.trigger( $("#P1951_JOB_STATE"), "checkJobState" );},',
'        gCheckJobInterval );',
'}'))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#sync-steps {min-height: 100px;}',
'',
'tr#MESSAGES {width: 200px;}',
'td[headers=MESSAGES] {width: 200px;}',
'',
'.log-messages {',
'    margin: 0px;',
'    max-width: 400px;}',
'       '))
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1664665857963730)
,p_plug_name=>'"Merge" Synchronization Type requires a Primary Key'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>70
,p_plug_source=>'This synchronization uses the "Merge" synchronization type, but the Data Profile does not have a Primary Key column defined. Synchronization jobs will run into errors.'
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if nvl( :P1951_SYNC_TYPE, ''APPEND'' ) != ''MERGE'' or :P1951_OLD_SYNC_TABLE_NAME is null then',
'        return false;',
'    else',
'        return not wwv_flow_web_src_sync_dev.data_profile_has_primary_key(',
'                       p_web_source_module_id => :P1951_WEB_SRC_MODULE_ID );',
'    end if;',
'end;'))
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3404639650376625)
,p_plug_name=>'Interval Builder'
,p_region_name=>'interval-builder'
,p_region_template_options=>'#DEFAULT#:js-dialog-size600x400'
,p_plug_template=>wwv_flow_imp.id(557449278618308550)
,p_plug_display_sequence=>40
,p_plug_header=>'<p>This dialog assists in building a simple <em>Scheduler Calendaring Expression</em> to specify how often the synchronization job executes.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3405610816376635)
,p_plug_name=>'Details'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_header=>'<a name="sync-details"></a>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3407119919376650)
,p_plug_name=>'Advanced Settings'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1951_SYNC_TABLE_NAME is not null and ',
':P1951_SYNC_STATUS != wwv_flow_web_src_sync.c_table_does_not_exist'))
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3802161062901510)
,p_plug_name=>'REST Synchronization'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'<strong>REST Synchronization</strong> enables you to keep the contents of a local table automatically in sync with the data from a REST service. Synchronization can be triggered manually or on a regular schedule, using a scheduler job.',
'</p>',
'<p>',
'APEX can create the local table based on the visible columns in the <strong>Data Profile</strong> of the REST Data Source. Since the table is a <em>visible object</em> in the database schema, developers <em>can</em> add indexes, change physical prope'
||'rties, or even add more columns to the table. ',
'</p>',
'<p>',
'If the table is <em>not</em> in sync with the Data Profile, REST synchronization will continue to work for columns being present in <em>both</em> the table and the Data Profile (other columns will be ignored). However, APEX generates SQL DDL statemen'
||'ts to sync table columns back to the Data Profile which can be added to the application as supporting objects.',
'</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3802859702901517)
,p_plug_name=>'Synchronization not configured'
,p_region_template_options=>'#DEFAULT#:a-Alert--info:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>10
,p_plug_source=>'REST synchronization is not configured yet. Provide the name of a new or existing table to begin.'
,p_plug_display_condition_type=>'ITEM_IS_NULL'
,p_plug_display_when_condition=>'P1951_OLD_SYNC_TABLE_NAME'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3803587485901524)
,p_plug_name=>'Save as Script (Supporting Objects)'
,p_region_name=>'save-script'
,p_region_template_options=>'#DEFAULT#:js-dialog-size480x320'
,p_plug_template=>wwv_flow_imp.id(557449278618308550)
,p_plug_display_sequence=>50
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4302146574059808)
,p_plug_name=>'Table Status'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P1951_SYNC_TABLE_NAME'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1663866411963722)
,p_plug_name=>'Table is used by another REST Synchronization'
,p_parent_plug_id=>wwv_flow_imp.id(4302146574059808)
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>5
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'This can lead to synchronization conflicts. Check the following REST Data Sources:<br>',
'<strong>&P1951_OTHER_SYNC_INFO!HTML.</strong>'))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P1951_SYNC_STATUS != wwv_flow_web_src_sync.c_table_does_not_exist and :P1951_OTHER_SYNC_INFO is not null'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3703185813255331)
,p_plug_name=>'Synchronization Table does not exist'
,p_parent_plug_id=>wwv_flow_imp.id(4302146574059808)
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>25
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'The synchronization table does not yet exist.'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P1951_SYNC_STATUS = wwv_flow_web_src_sync.c_table_does_not_exist'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3704694634255346)
,p_plug_name=>'Table Sync SQL'
,p_parent_plug_id=>wwv_flow_imp.id(4302146574059808)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>65
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1951_SYNC_STATUS in ( wwv_flow_web_src_sync.c_table_does_not_exist,',
'                        wwv_flow_web_src_sync.c_columns_can_be_synced,',
'                        wwv_flow_web_src_sync.c_columns_cannot_be_synced)'))
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3705021633255350)
,p_plug_name=>'Table "&P1951_SYNC_TABLE_NAME!HTML." is ready for synchronization'
,p_parent_plug_id=>wwv_flow_imp.id(4302146574059808)
,p_region_template_options=>'#DEFAULT#:a-Alert--info:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>35
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'The synchronization table exists and matches the Data Profile.'
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if :P1951_SYNC_STATUS != wwv_flow_web_src_sync.c_table_is_up_to_date then',
'        return false;',
'    end if;',
'',
'    if nvl( :P1951_SYNC_TYPE, ''APPEND'' ) != ''MERGE''  then',
'        return true;',
'    else',
'        return wwv_flow_web_src_sync_dev.data_profile_has_primary_key(',
'                   p_web_source_module_id => :P1951_WEB_SRC_MODULE_ID );',
'    end if;',
'end;'))
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4301625144059803)
,p_plug_name=>'Table "&P1951_SYNC_TABLE_NAME!HTML." is different from Data Profile'
,p_parent_plug_id=>wwv_flow_imp.id(4302146574059808)
,p_icon_css_classes=>'icon-warning'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>55
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'The table columns are different to the data profile, but APEX will continue to synchronize columns being present in <em>both</em> the table and the data profile. Click <strong>Show SQL</strong>  to see the ALTER TABLE statements to adjust table colum'
||'ns to the data profile.'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P1951_SYNC_STATUS = wwv_flow_web_src_sync.c_columns_can_be_synced'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4302455398059811)
,p_plug_name=>'Table needs manual column changes'
,p_parent_plug_id=>wwv_flow_imp.id(4302146574059808)
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>45
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<p>The synchronization table exists, but its columns do not match the Data Profile. Column changes (e.g. data type change from VARCHAR2 to NUMBER) require manual intervention, and possibly data movement. However, APEX will continue to synchronize col'
||'umns being present in <em>both</em> the table and the data profile.</p>'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P1951_SYNC_STATUS = wwv_flow_web_src_sync.c_columns_cannot_be_synced'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1855034208767335709)
,p_plug_name=>'Fetch Rows operation does not exist'
,p_parent_plug_id=>wwv_flow_imp.id(4302146574059808)
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>15
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'Synchronization for this REST Data Source is active, but there is no operation mapped to the <strong>Fetch Rows</strong> database operation. Thus synchronization will not work.'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P1951_SYNC_STATUS = wwv_flow_web_src_sync.c_no_fetch_rows_operation'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4302248671059809)
,p_plug_name=>'RDS'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P1951_OLD_SYNC_TABLE_NAME'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(4302959812059816)
,p_name=>'Steps'
,p_region_name=>'sync-steps'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select pa.id, ',
'       pa.static_id, ',
'       pa.execution_sequence, ',
'       pa.is_active',
'  from wwv_flow_web_src_sync_steps pa, wwv_flow_web_src_comp_params cp',
' where pa.id                = cp.module_sync_step_id (+)',
'   and pa.web_src_module_id = :P1951_WEB_SRC_MODULE_ID',
'   and pa.security_group_id = :FLOW_SECURITY_GROUP_ID',
' group by pa.id, pa.static_id, pa.execution_sequence, pa.is_active'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1951_SYNC_TABLE_NAME is not null and ',
':P1951_SYNC_STATUS != wwv_flow_web_src_sync.c_table_does_not_exist'))
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No steps defined. Synchronization will use REST Source Parameter defaults.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4303016090059817)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Edit'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:1952:&SESSION.::&DEBUG.::P1952_SYNC_STEP_ID:#ID#'
,p_column_linktext=>'<span class="a-Icon icon-edit"></span>'
,p_column_link_attr=>'title="Edit Synchronization Step"'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4303197430059818)
,p_query_column_id=>2
,p_column_alias=>'STATIC_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Static ID'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4303255193059819)
,p_query_column_id=>3
,p_column_alias=>'EXECUTION_SEQUENCE'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4304329085059830)
,p_query_column_id=>4
,p_column_alias=>'IS_ACTIVE'
,p_column_display_sequence=>4
,p_column_heading=>'Active'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(84259319526460470)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(5517859571157119)
,p_name=>'Log'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select l.synchronization_id,',
'       l.web_src_sync_static_id,',
'       l.is_job,',
'       wwv_flow_lang.system_message( ''APEX.WEBSRC.SYNC.STATUS_'' || l.status ) as status,',
'       l.sync_to_table_owner ||',
'           case when l.sync_to_table_owner is not null then ''.'' end ||',
'           l.sync_to_table_name as sync_to_table,',
'       l.start_timestamp,',
'       l.end_timestamp,',
'       ( select count(*) ',
'           from wwv_flow_webservice_log w ',
'          where w.security_group_id = l.security_group_id ',
'            and w.web_src_module_id = l.web_src_module_id',
'            and w.web_src_sync_id   = l.synchronization_id ) http_requests,',
'       ( select sum(w.resp_content_length) ',
'           from wwv_flow_webservice_log w ',
'          where w.security_group_id = l.security_group_id ',
'            and w.web_src_module_id = l.web_src_module_id',
'            and w.web_src_sync_id = l.synchronization_id ) sum_bytes_received,',
'       to_char( extract (HOUR   from l.end_timestamp - l.start_timestamp) * 60 +',
'                extract (MINUTE from l.end_timestamp - l.start_timestamp) ) || '''''''' ||',
'       to_char( extract( second from l.end_timestamp - l.start_timestamp),''FM00'' ) || ''"'' as dur,',
'       l.processed_row_count,',
'       l.messages',
'  from wwv_flow_websource_sync_log l',
' where l.web_src_module_id = :P1951_WEB_SRC_MODULE_ID',
'   and l.flow_id           = :FB_FLOW_ID',
'   and l.security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_optimizer_hint=>'APEX$USE_ROWNUM_PAGINATION'
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1951_SYNC_TABLE_NAME is not null and ',
':P1951_SYNC_STATUS != wwv_flow_web_src_sync.c_table_does_not_exist'))
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>true
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>5
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>'Synchronization log for this REST Data Source is empty.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'Y'
,p_csv_output_link_text=>'Download Log'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5518390346157124)
,p_query_column_id=>1
,p_column_alias=>'SYNCHRONIZATION_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Details'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:1953:&SESSION.::&DEBUG.:RP,:P1953_WSM_SYNC_ID:#SYNCHRONIZATION_ID#'
,p_column_linktext=>'<span class="a-Icon icon-search"></span>'
,p_column_link_attr=>'title="View HTTP Request Log"'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5518408227157125)
,p_query_column_id=>2
,p_column_alias=>'WEB_SRC_SYNC_STATIC_ID'
,p_column_display_sequence=>2
,p_column_heading=>'Step&nbsp;ID'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5518566292157126)
,p_query_column_id=>3
,p_column_alias=>'IS_JOB'
,p_column_display_sequence=>4
,p_column_heading=>'Job'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(84259319526460470)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5518681569157127)
,p_query_column_id=>4
,p_column_alias=>'STATUS'
,p_column_display_sequence=>5
,p_column_heading=>'Status'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3404521938376624)
,p_query_column_id=>5
,p_column_alias=>'SYNC_TO_TABLE'
,p_column_display_sequence=>3
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5518781761157128)
,p_query_column_id=>6
,p_column_alias=>'START_TIMESTAMP'
,p_column_display_sequence=>6
,p_column_heading=>'Started '
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5518831286157129)
,p_query_column_id=>7
,p_column_alias=>'END_TIMESTAMP'
,p_column_display_sequence=>7
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2905946004179142)
,p_query_column_id=>8
,p_column_alias=>'HTTP_REQUESTS'
,p_column_display_sequence=>10
,p_column_heading=>'Requests'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2906054964179143)
,p_query_column_id=>9
,p_column_alias=>'SUM_BYTES_RECEIVED'
,p_column_display_sequence=>11
,p_column_heading=>'Size'
,p_use_as_row_header=>'N'
,p_column_format=>'FILESIZE'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5519275936157133)
,p_query_column_id=>10
,p_column_alias=>'DUR'
,p_column_display_sequence=>8
,p_column_heading=>'Duration'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5519038476157131)
,p_query_column_id=>11
,p_column_alias=>'PROCESSED_ROW_COUNT'
,p_column_display_sequence=>9
,p_column_heading=>'Rows'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5519193450157132)
,p_query_column_id=>12
,p_column_alias=>'MESSAGES'
,p_column_display_sequence=>12
,p_column_heading=>'Messages'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<div class="log-messages">#MESSAGES#</div>'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6292213365932471)
,p_plug_name=>'REST Data Source'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P1951_OLD_SYNC_TABLE_NAME'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6669574068375171)
,p_plug_name=>'REST Synchronization'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_04'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1912360610983083464)
,p_plug_name=>'Learn More'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="padding: 0 12px 12px 12px;"'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p(''<p><a href="&SYSTEM_HELP_URL." target="_blank">''||wwv_flow_lang.system_message(''LEARN MORE'')||'' ...</a></p>'');',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4303314867059820)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(4302959812059816)
,p_button_name=>'ADD_SYNC_STEP'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Add Step'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1373830947674228)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(5517859571157119)
,p_button_name=>'PURGE_LOG'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Purge Log'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2905399506179136)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(4302146574059808)
,p_button_name=>'VIEW_SYNC_TABLE'
,p_button_action=>'REDIRECT_APP'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'View in SQL Workshop'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=4500:2000:&SESSION.::&DEBUG.:RP,2000:P2000_OB_INIT_SCHEMA,P2000_OB_INIT_ID:&P1951_SYNC_SCHEMA_NAME.,&P1951_SYNC_TABLE_OBJECT_ID.'
,p_button_condition=>':P1951_SYNC_STATUS != wwv_flow_web_src_sync.c_table_does_not_exist and :P1951_OLD_SYNC_TABLE_NAME is not null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3200568818532836)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(6669574068375171)
,p_button_name=>'CLEAR_SYNC'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Clear Settings'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if :P1951_OLD_SYNC_TABLE_NAME is null then',
'        return false;',
'    end if;',
'',
'    for c in (',
'        select 1',
'          from wwv_flow_web_src_module_usage',
'         where web_src_module_id    = :P1951_WEB_SRC_MODULE_ID',
'           and security_group_id    = :FLOW_SECURITY_GROUP_ID',
'           and use_local_sync_table = ''Y''',
'           and rownum = 1 )',
'    loop',
'        return false;',
'    end loop;',
'    ',
'    return true;',
'end;'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'FUNCTION_BODY'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3402234723376601)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(3703185813255331)
,p_button_name=>'SHOW_CREATE_TABLE_SQL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Show SQL'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3406775981376646)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(3404639650376625)
,p_button_name=>'BUILD_INTERVAL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Set Execution Interval'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3803834939901527)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(3803587485901524)
,p_button_name=>'SAVE_SCRIPT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Script'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3402593703376604)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(3703185813255331)
,p_button_name=>'HIDE_CREATE_TABLE_SQL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Hide SQL'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3403550413376614)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(4301625144059803)
,p_button_name=>'SHOW_ALTER_TABLE_SQL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Show SQL'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5903029649682530)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(6669574068375171)
,p_button_name=>'REDIRECT_TO_CLEAR_SYNC'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Clear Settings'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1954:&SESSION.::&DEBUG.::P1954_DIALOG_TYPE:CLEAR_SYNC'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if :P1951_SYNC_TABLE_NAME is null then',
'        return false;',
'    end if;',
'',
'    for i in ( ',
'        select 1 ',
'          from wwv_flow_web_src_module_usage',
'         where web_src_module_id    = :P1951_WEB_SRC_MODULE_ID',
'           and security_group_id    = :FLOW_SECURITY_GROUP_ID',
'           and use_local_sync_table = ''Y''',
'           and rownum               = 1 )',
'    loop',
'        return true;',
'    end loop;',
'    ',
'    return false;',
'end;'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'FUNCTION_BODY'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2906244256179145)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(4302455398059811)
,p_button_name=>'SHOW_ALTER_TABLE_SQL2'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Show SQL'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3803085160901519)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(3703185813255331)
,p_button_name=>'ADD_CREATE_SUPP_OBJECTS'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Save as Supporting Object'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5903977576682539)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(3405610816376635)
,p_button_name=>'SHOW_USAGE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Synchronization Usage'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1954:&SESSION.::&DEBUG.::P1954_DIALOG_TYPE:SHOW_USAGE'
,p_button_condition=>'P1951_SYNC_TABLE_NAME'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3200969683532841)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(6669574068375171)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3403686885376615)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(4301625144059803)
,p_button_name=>'HIDE_ALTER_TABLE_SQL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Hide SQL'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3704375012255343)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(3703185813255331)
,p_button_name=>'CREATE_TABLE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Create Table'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4302666690059813)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(6669574068375171)
,p_button_name=>'MANUAL_DATA_SYNC'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Save and Run'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1951_SYNC_TABLE_NAME is not null and ',
':P1951_SYNC_STATUS not in ( wwv_flow_web_src_sync.c_table_does_not_exist, wwv_flow_web_src_sync.c_no_fetch_rows_operation ) and',
':P1951_JOB_STATE is null'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5900100267682501)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(4302455398059811)
,p_button_name=>'HIDE_ALTER_TABLE_SQL2'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Hide SQL'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1375364889674243)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(6669574068375171)
,p_button_name=>'TERMINATE_JOB'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary:a-Button--gapLeft'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Terminate Synchronization'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1951_SYNC_TABLE_NAME is not null and ',
':P1951_JOB_STATE is not null'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3804144280901530)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(4301625144059803)
,p_button_name=>'ADD_ALTER_SUPP_OBJECTS'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Save as Supporting Object'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4301904995059806)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(4301625144059803)
,p_button_name=>'ALTER_TABLE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Alter Table'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4303529234059822)
,p_branch_name=>'Go To Page 1952'
,p_branch_action=>'f?p=&APP_ID.:1952:&SESSION.::&DEBUG.::P1952_SYNC_STEP_ID:&P1951_NEW_SYNC_STEP_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(4303314867059820)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3804243639901531)
,p_branch_name=>'Go To Page 865'
,p_branch_action=>'f?p=&APP_ID.:865:&SESSION.::&DEBUG.:RP,865:P865_SCRIPT_ID,P865_MODE,F4000_LAST_VIEW:&P1951_SCRIPT_ID.,EDIT,1951&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(3803834939901527)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1664257292963726)
,p_branch_action=>'f?p=&APP_ID.:1951:&SESSION.::&DEBUG.:RP,1951:P1951_WEB_SRC_MODULE_ID:&P1951_WEB_SRC_MODULE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(3200568818532836)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1375189579674241)
,p_name=>'P1951_JOB_STATE'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(6292213365932471)
,p_display_as=>'NATIVE_HIDDEN'
,p_display_when=>'P1951_JOB_STATE'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1375534285674245)
,p_name=>'P1951_JOB_SHOW_STATE'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(6292213365932471)
,p_prompt=>'Job Status'
,p_pre_element_text=>'<span class="a-Icon icon-redo u-Animate-spin" style="vertical-align: middle;margin-right: 3px;"></span>'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'P1951_JOB_STATE'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Status of the synchronization job, if active:</p>',
'<ul>',
'    <li><strong>Scheduled</strong> The job is in the queue of the database scheduler, but execution did not start yet.</li>',
'    <li><strong>Running</strong> The job is currently executing.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1400708118398906)
,p_name=>'P1951_USE_RATE_LIMITING'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(3407119919376650)
,p_prompt=>'Enable Simple Rate Limiting'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    When <strong>Simple Rate Limiting</strong> is enabled, APEX ensures that only a limited amount of HTTP requests is executed within the given time frame. This rate limiting is purely based on the number of HTTP requests being executed within a tim'
||'e frame - it does <em>not</em> look into HTTP response headers returned by the REST service.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1401581750400511)
,p_name=>'P1951_MAX_REQUESTS_TIMEFRAME'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(3407119919376650)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Rate Limit Timeframe (in seconds)'
,p_source=>'MAX_REQUESTS_TIMEFRAME_SEC'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Simple Rate Limiting: Provide the time frame, for which to count HTTP requests, in seconds. APEX allows to specify a time frame between 5 and 300 seconds (5 minutes).'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'5'
,p_attribute_02=>'300'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1402379984403051)
,p_name=>'P1951_MAX_REQUESTS'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(3407119919376650)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Rate Limit HTTP Requests'
,p_source=>'MAX_REQUESTS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Simple Rate Limiting. Provide the HTTP request limit for this synchronization within the specified time frame.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1403198659405104)
,p_name=>'P1951_MAX_REQUESTS_EXC_ACTION'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(3407119919376650)
,p_use_cache_before_default=>'NO'
,p_item_default=>'ERROR'
,p_prompt=>'When Rate Limit exceeded'
,p_source=>'MAX_REQUESTS_EXCEED_ACTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P1951_MAX_REQUESTS_EXC_ACTION'
,p_lov=>'.'||wwv_flow_imp.id(601125790424873502)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div>',
'    Simple Rate Limiting: Specify what APEX should do if the specified maximum of HTTP requests within the time frame is reached.',
'</div>',
'<ul>',
'    <li><strong>Wait</strong>: APEX will <em>wait</em> with the next request until the request fits into the limit again. Note that the waiting time is limited to the <strong>HTTP Transfer Timeout</strong> time, or to <strong>180 seconds</strong>, if'
||' no timeout has been configured.</li>',
'    <li><strong>Raise Error</strong>: APEX will <em>terminate</em> the operation and raise an error message</li>',
'</ul>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1662827990963712)
,p_name=>'P1951_SYNC_MAX_HTTP_REQUESTS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3407119919376650)
,p_use_cache_before_default=>'NO'
,p_item_default=>'1000'
,p_prompt=>'HTTP Request Limit'
,p_source=>'SYNC_MAX_HTTP_REQUESTS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>10
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    If required, provide a maximum number of HTTP requests to make for each synchronization step. If this limit is exceeded, synchronization will stop and logged as <strong>Incomplete</strong>.',
'</p>',
'<p>',
'    <em>Note that due to the actual execution method, synchronization will exceed this limit by one request. So if you provide a limit of <strong>10</strong>, synchronization will stop after the 11th request has been made.</em>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1663994792963723)
,p_name=>'P1951_OTHER_SYNC_INFO'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1663866411963722)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1720459414469937)
,p_name=>'P1951_NEW_SYNC_ARRAY_COL_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(3405610816376635)
,p_prompt=>'Array Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select dpc.display_name,',
'       dpc.id',
'  from wwv_flow_web_src_arr_cols_dev dpc',
' where dpc.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and dpc.flow_id           = :FB_FLOW_ID',
'   and dpc.web_src_module_id = :P1951_WEB_SRC_MODULE_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'None'
,p_cHeight=>1
,p_display_when=>'P1951_OLD_SYNC_TABLE_NAME'
,p_display_when_type=>'ITEM_IS_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select an <em>Array Column</em>, from the data profile, to use for synchronizing data to the local table.'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1720693159469939)
,p_name=>'P1951_SYNC_ARRAY_COL_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(3405610816376635)
,p_use_cache_before_default=>'NO'
,p_source=>'SYNC_ARRAY_COL_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1720808115469941)
,p_name=>'P1951_SHOW_SYNC_ARRAY_COL_ID'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(3405610816376635)
,p_prompt=>'Array Column'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select dpc.array_column_path,',
'       dpc.id',
'  from wwv_flow_web_src_arr_cols_dev dpc',
' where dpc.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and dpc.flow_id           = :FB_FLOW_ID',
'   and dpc.web_src_module_id = :P1951_WEB_SRC_MODULE_ID'))
,p_display_when=>'P1951_SHOW_SYNC_ARRAY_COL_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Synchronization is done for this <em>Array Column</em>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1935777712374328)
,p_name=>'P1951_MIN_CADENCE'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(3405610816376635)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2901912843179102)
,p_name=>'P1951_OLD_SYNC_INTERVAL'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(3405610816376635)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2903192530179114)
,p_name=>'P1951_REPLACE_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3407119919376650)
,p_item_default=>'DELETE'
,p_prompt=>'Replace Type'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P1951_REPLACE_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(601128335146874196)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    A <strong>Replace</strong> synchronization type will empty the table before loading new data. </p>',
'<p>',
'    This can either be done using a (transactional) SQL DELETE statement, which will make sure that nothing is lost if an error happens during synchronization.</p>',
'<p>',
'    The alternative is to use the SQL <em>TRUNCATE</em> statement, which leads to more efficient storage usage. However, TRUNCATE is non-transactional - so if an error happens during synchronization, the table will remain empty.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2903749054179120)
,p_name=>'P1951_TABLE_SYNC_TYPE'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(3405610816376635)
,p_use_cache_before_default=>'NO'
,p_source=>'SYNC_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2905462365179137)
,p_name=>'P1951_SYNC_SCHEMA_NAME'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(3405610816376635)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2905660441179139)
,p_name=>'P1951_SYNC_TABLE_OBJECT_ID'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(3405610816376635)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3000455156443099)
,p_name=>'P1951_BREADCRUMB_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(6292213365932471)
,p_source=>'P1951_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3000786442443105)
,p_name=>'P1951_WEB_SRC_MODULE_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(6292213365932471)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3001187163443106)
,p_name=>'P1951_FLOW_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(6292213365932471)
,p_use_cache_before_default=>'NO'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3001980570443106)
,p_name=>'P1951_NAME'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(6292213365932471)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a name of the REST Data Source.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3003754936443112)
,p_name=>'P1951_REMOTE_SERVER_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(6292213365932471)
,p_use_cache_before_default=>'NO'
,p_source=>'REMOTE_SERVER_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3005003532443114)
,p_name=>'P1951_URL_PATH_PREFIX'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(6292213365932471)
,p_use_cache_before_default=>'NO'
,p_source=>'URL_PATH_PREFIX'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3404764744376626)
,p_name=>'P1951_INT_FREQUENCY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3404639650376625)
,p_item_default=>'DAILY'
,p_prompt=>'Frequency'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'SCHEDULE_BUILDER_FREQUENCY'
,p_lov=>'.'||wwv_flow_imp.id(601098854036755106)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the type of recurrence. The possible predefined frequency values are <strong>Weekly</strong>, <strong>Daily</strong>, <strong>Hourly</strong> and <strong>Minutely</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3405282562376631)
,p_name=>'P1951_INT_INTERVAL'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3404639650376625)
,p_item_default=>'1'
,p_prompt=>'Interval'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>4
,p_cMaxlength=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a positive integer representing how often the recurrence repeats. The default is 1, which means every minute for minutely, every day for daily, and so on. The maximum value is 999.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3405326581376632)
,p_name=>'P1951_BYDAY'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3404639650376625)
,p_item_default=>'MON:TUE:WED:THU:FRI:SAT:SUN'
,p_prompt=>'Execution Day'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'SCHEDULE_BUILDER_BYDAY'
,p_lov=>'.'||wwv_flow_imp.id(601095219556747684)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the day of the week, from Monday to Sunday, in the form MON, TUE, and so on.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'5'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3405456270376633)
,p_name=>'P1951_BYHOUR'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(3404639650376625)
,p_item_default=>'0'
,p_prompt=>'Execution Hour'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the hour on which the job is to run. Valid values are 0 to 23. As an example, 10 means 10 a.m.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3405583578376634)
,p_name=>'P1951_BYMINUTE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(3404639650376625)
,p_item_default=>'0'
,p_prompt=>'Execution Minute'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the minute on which the job is to run. Valid values are 0 to 59. As an example, 45 means 45 minutes past the chosen hour.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3702757410255327)
,p_name=>'P1951_SYNC_TABLE_NAME'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(3405610816376635)
,p_use_cache_before_default=>'NO'
,p_source=>'SYNC_TABLE_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3703270495255332)
,p_name=>'P1951_SYNC_STATUS'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(3405610816376635)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3703404227255334)
,p_name=>'P1951_SYNC_TABLE_OWNER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3405610816376635)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Local Table Owner'
,p_source=>'SYNC_TABLE_OWNER'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_AVAILABLE_SCHEMAS2'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(c.schema) d, c.schema r',
'',
'from   wwv_flow_company_schemas c,',
'',
'       wwv_flow_fnd_user u',
'',
'where  c.security_group_id = :flow_security_group_id and',
'',
'       u.security_group_id = :flow_security_group_id and',
'',
'       u.user_name = :flow_user and',
'',
'       (u.ALLOW_ACCESS_TO_SCHEMAS is null or    instr('':''||u.ALLOW_ACCESS_TO_SCHEMAS||'':'','':''||c.schema||'':'')>0)',
'',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Parsing Schema -'
,p_cHeight=>1
,p_display_when=>':P1951_OLD_SYNC_TABLE_NAME is null or :P1951_SYNC_TABLE_OWNER is not null '
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_read_only_when=>'P1951_OLD_SYNC_TABLE_NAME'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Pick the schema of the local table to synchronize data to. By default, the application <em>Parsing Schema</em> is used.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3704822824255348)
,p_name=>'P1951_SQL'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3704694634255346)
,p_prompt=>'Create / Change Table SQL'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>120
,p_cHeight=>10
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'This is the SQL to create the local table or to make the local table consistent with the Data Profile.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3801266410901501)
,p_name=>'P1951_SYNC_COMMIT_INTERVAL'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3407119919376650)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Commit Interval'
,p_source=>'SYNC_COMMIT_INTERVAL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>10
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify the commit interval to use during REST synchronization. If no commit interval is specified, the whole synchronization will be one transaction, with a commit after the last row. If an interval is specified, APEX will commit each time after the'
||' specified amount of rows have been processed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'100'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3802528713901514)
,p_name=>'P1951_OLD_SYNC_TABLE_NAME'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(3405610816376635)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3803619759901525)
,p_name=>'P1951_SCRIPT_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3803587485901524)
,p_prompt=>'Script Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Provide a name for SQL script to save.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3803777441901526)
,p_name=>'P1951_SCRIPT_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3803587485901524)
,p_item_default=>'1'
,p_prompt=>'Script Type'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P1951_SCRIPT_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(601129636599874441)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify whether to store the SQL statements as Install or Upgrade script.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
,p_item_comment=>'Static LOV return values must match t_supp_script constants in wwv_flow_web_src_sync_dev package spec.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3804315936901532)
,p_name=>'P1951_SCRIPT_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3803587485901524)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3804896981901537)
,p_name=>'P1951_JOB_IS_ACTIVE'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(3407119919376650)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Job is Active'
,p_source=>'SYNC_IS_ACTIVE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_web_src_modules thiswm, wwv_flow_web_src_modules masterwm',
' where thiswm.id                = :P1951_WEB_SRC_MODULE_ID',
'   and masterwm.id              = thiswm.reference_id',
'   and masterwm.sync_is_active  = ''Y''',
'   and thiswm.sync_is_active    = ''N''',
'   and thiswm.security_group_id = :FLOW_SECURITY_GROUP_ID',
' '))
,p_read_only_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    An inactive Synchronization can only be manually executed. ',
'</p>',
'<p>',
'    Note that the synchronization job cannot be enabled for subscribed REST Data Sources, when the job is already active for the master REST Data Source. If the synchronization job is being enabled for a master REST Data source, it will be <em>disabl'
||'ed</em> for all subscribed REST Data Sources.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4302356408059810)
,p_name=>'P1951_INCLUDE_DROP_COLUMNS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3704694634255346)
,p_item_default=>'N'
,p_prompt=>'Include Drop Columns'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>':P1951_SYNC_STATUS = wwv_flow_web_src_sync.c_columns_can_be_synced'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify whether to include <strong>DROP COLUMN</strong> statements to the ALTER TABLE SQL. Even though a column has been removed from the data profile, it might be advisable to keep the column in the local table. In this case, turn the switch to <str'
||'ong>Off</strong>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4302707508059814)
,p_name=>'P1951_SYNC_TYPE'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(3405610816376635)
,p_item_default=>'APPEND'
,p_prompt=>'Synchronization Type'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P1951_SYNC_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(601130955295874684)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1951_SYNC_TABLE_NAME is not null and ',
':P1951_SYNC_STATUS != wwv_flow_web_src_sync.c_table_does_not_exist'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Pick the synchronization type to use. Possible values are:',
'</p>',
'<ul>',
'    <li><strong>Append</strong>: Append rows to the local table. This is typically used when no primary key has been defined in the data profile.</li>',
'    <li><strong>Merge</strong>: Merge rows into the local table. The data profile must have a <em>Primary Key</em>em> defined to use this option. If a row for the given primary key value exists, the row will be updated, otherwise the row will be crea'
||'ted.</li>',
'    <li><strong>Replace</strong>: Empty the local table before loading new data.</li>',
'',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4302840882059815)
,p_name=>'P1951_SYNC_INTERVAL'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(3405610816376635)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Synchronization Schedule'
,p_post_element_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#sync-details" id="P1951_EDIT_SYNC_INTERVAL" class="a-Button a-Button--noLabel a-Button--small a-Button--withIcon" title="Schedule Builder" tabindex="0"><span class="a-Icon icon-utilities-build-interval"></span><span class="u-VisuallyHidden"'
||'>Schedule Builder</span></a><a href="#sync-details" id="P1951_CLEAR_SYNC_INTERVAL" class="a-Button a-Button--noLabel a-Button--small a-Button--withIcon" title="Clear Schedule" tabindex="0"><span class="a-Icon icon-remove"></span><span class="u-Visual'
||'lyHidden">Clear Schedule</span></a>',
''))
,p_source=>'SYNC_INTERVAL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>255
,p_cHeight=>3
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1951_SYNC_TABLE_NAME is not null and ',
':P1951_SYNC_STATUS != wwv_flow_web_src_sync.c_table_does_not_exist'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Use the <em>Database Scheduler calendaring syntax</em> to define repeating synchronization schedules, such as "every Tuesday and Friday at 4:00 p.m." or "the second Wednesday of every month". ',
'</p>',
'<p>',
'    The calendaring syntax can either be entered manually, or declaratively by using the <strong>Interval Builder</strong>, to build simple expressions. Click the <em>wrench icon</em> below the Schedule Expression text area, to open the Interval Buil'
||'der.',
'</p>',
'<p>',
'    To have more complex execution schedules, review details about the <strong>Scheduler Calendaring Syntax</strong> in the documentation of the <strong>DBMS_SCHEDULER</strong> PL/SQL package, and provide your expression manually.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4303678738059823)
,p_name=>'P1951_NEW_SYNC_STEP_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(4302959812059816)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5520240846157143)
,p_name=>'P1951_LAST_SYNC_TIMESTAMP'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(6292213365932471)
,p_prompt=>'Last Synchronization'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'P1951_LAST_SYNC_TIMESTAMP'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Indicates when the last synchronization to the local table happened.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5520359347157144)
,p_name=>'P1951_NEXT_SYNC_TIMESTAMP'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(6292213365932471)
,p_prompt=>'Next Synchronization'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_begin_on_new_line=>'N'
,p_display_when=>'P1951_NEXT_SYNC_TIMESTAMP'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Indicates when the next scheduled synchronization is due. Note that synchronizations are kicked off every 10 minutes, starting at the top of the hour. So a synchronization can start at minute 0, 10, 20, 30, 40 or 50, but not in between.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5900754686682507)
,p_name=>'P1951_NEW_OR_EXISTING_TABLE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3405610816376635)
,p_item_default=>'NEW'
,p_prompt=>'Synchronize to'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P1951_NEW_OR_EXISTING_TABLE'
,p_lov=>'.'||wwv_flow_imp.id(601127065669873845)||'.'
,p_display_when=>'P1951_OLD_SYNC_TABLE_NAME'
,p_display_when_type=>'ITEM_IS_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose whether to synchronize to a new or existing table.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5900899407682508)
,p_name=>'P1951_NEW_TABLE_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(3405610816376635)
,p_prompt=>'Table Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>128
,p_tag_attributes=>'style="text-transform: uppercase;"'
,p_display_when=>'P1951_OLD_SYNC_TABLE_NAME'
,p_display_when_type=>'ITEM_IS_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Provide the name of a new table to synchronize data to.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5900966161682509)
,p_name=>'P1951_EXISTING_TABLE_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(3405610816376635)
,p_prompt=>'Table Name'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select table_name a, table_name b',
'  from sys.dba_tables',
' where owner = coalesce( :P1951_SYNC_TABLE_OWNER, upper(wwv_flow_wizard_api.get_flow_owner(:FB_FLOW_ID)))',
'   and table_name not like ''BIN$%''',
' order by table_name'))
,p_lov_display_null=>'YES'
,p_lov_cascade_parent_items=>'P1951_SYNC_TABLE_OWNER'
,p_ajax_optimize_refresh=>'N'
,p_cSize=>60
,p_cMaxlength=>128
,p_display_when=>'P1951_OLD_SYNC_TABLE_NAME'
,p_display_when_type=>'ITEM_IS_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Pick an existing table to synchronize data to.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5901776603682517)
,p_name=>'P1951_SHOW_SYNC_TABLE_NAME'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(3405610816376635)
,p_prompt=>'Synchronizing to'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'P1951_SHOW_SYNC_TABLE_NAME'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Data is currently synchronized to this table.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(319959071716296916)
,p_name=>'P1951_OLD_JOB_IS_ACTIVE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(3407119919376650)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3703358673255333)
,p_computation_sequence=>10
,p_computation_item=>'P1951_SYNC_STATUS'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_web_src_sync.get_table_ddl_sync_status(:P1951_WEB_SRC_MODULE_ID)'
,p_compute_when=>'P1951_SYNC_TABLE_NAME'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3704724987255347)
,p_computation_sequence=>20
,p_computation_item=>'P1951_SQL'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'nvl( wwv_flow_web_src_sync.get_sync_table_column_sql(:P1951_WEB_SRC_MODULE_ID, :P1951_INCLUDE_DROP_COLUMNS = ''Y''), ''-- no SQL statements'')'
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1951_SYNC_STATUS in ( wwv_flow_web_src_sync.c_table_does_not_exist, ',
'                        wwv_flow_web_src_sync.c_columns_can_be_synced, ',
'                        wwv_flow_web_src_sync.c_columns_cannot_be_synced )'))
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3802607184901515)
,p_computation_sequence=>30
,p_computation_item=>'P1951_OLD_SYNC_TABLE_NAME'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P1951_SYNC_TABLE_NAME'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1405671983412668)
,p_computation_sequence=>40
,p_computation_item=>'P1951_USE_RATE_LIMITING'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'case when :P1951_MAX_REQUESTS is not null then ''Y'' else ''N'' end'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(5901822600682518)
,p_computation_sequence=>40
,p_computation_item=>'P1951_SHOW_SYNC_TABLE_NAME'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P1951_SYNC_TABLE_NAME'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2902045826179103)
,p_computation_sequence=>50
,p_computation_item=>'P1951_OLD_SYNC_INTERVAL'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P1951_SYNC_INTERVAL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2905710845179140)
,p_computation_sequence=>60
,p_computation_item=>'P1951_SYNC_SCHEMA_NAME'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'coalesce( :P1951_SYNC_TABLE_OWNER, wwv_flow_wizard_api.get_flow_owner(:FB_FLOW_ID))'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2905871925179141)
,p_computation_sequence=>70
,p_computation_item=>'P1951_SYNC_TABLE_OBJECT_ID'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_id',
'  from sys.dba_objects',
' where owner = :P1951_SYNC_SCHEMA_NAME',
'   and object_name = :P1951_SYNC_TABLE_NAME',
'   and object_type = ''TABLE'''))
,p_compute_when=>'P1951_SYNC_TABLE_NAME'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1375291244674242)
,p_computation_sequence=>80
,p_computation_item=>'P1951_JOB_STATE'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_web_src_sync_dev.get_job_status( :P1951_WEB_SRC_MODULE_ID )'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1375672022674246)
,p_computation_sequence=>90
,p_computation_item=>'P1951_JOB_SHOW_STATE'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_lang.system_message( ''APEX.WEBSRC.SYNC.STATUS_'' || :P1951_JOB_STATE )'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(319959181737296917)
,p_computation_sequence=>100
,p_computation_item=>'P1951_OLD_JOB_IS_ACTIVE'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P1951_JOB_IS_ACTIVE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1935829912374329)
,p_computation_sequence=>110
,p_computation_item=>'P1951_MIN_CADENCE'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'nvl( wwv_flow_platform.get_preference(''BACKGROUND_MIN_EXECUTION_CADENCE''), 0 )'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(90119091852448639)
,p_computation_sequence=>120
,p_computation_item=>'P1921_BREADCRUMB_NAME'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name',
'  from wwv_flow_web_src_modules ',
' where id                = :P1951_WEB_SRC_MODULE_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(580502062081193402)
,p_computation_sequence=>130
,p_computation_item=>'P1921_WEB_SRC_MODULE_ID'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P1951_WEB_SRC_MODULE_ID'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1720709181469940)
,p_computation_sequence=>10
,p_computation_item=>'P1951_SYNC_ARRAY_COL_ID'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P1951_NEW_SYNC_ARRAY_COL_ID'
,p_compute_when=>'P1951_NEW_OR_EXISTING_TABLE'
,p_compute_when_text=>'NEW:EXISTING'
,p_compute_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(721524888650207320)
,p_computation_sequence=>10
,p_computation_item=>'P1951_NEW_TABLE_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper( :P1951_NEW_TABLE_NAME )'
,p_compute_when=>':REQUEST in ( ''SAVE'', ''MANUAL_DATA_SYNC'' )'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3804748324901536)
,p_computation_sequence=>20
,p_computation_item=>'P1951_JOB_IS_ACTIVE'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'Y'
,p_compute_when=>'P1951_OLD_SYNC_TABLE_NAME'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2903524746179118)
,p_computation_sequence=>30
,p_computation_item=>'P1951_TABLE_SYNC_TYPE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case when :P1951_REPLACE_TYPE = ''TRUNCATE'' and :P1951_SYNC_TYPE = ''REPLACE'' ',
'    then ''TRUNCATE''',
'    else :P1951_SYNC_TYPE',
'end',
'      '))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(5901550579682515)
,p_computation_sequence=>40
,p_computation_item=>'P1951_SYNC_TABLE_NAME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P1951_NEW_TABLE_NAME'
,p_compute_when=>'P1951_NEW_OR_EXISTING_TABLE'
,p_compute_when_text=>'NEW'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(5901699317682516)
,p_computation_sequence=>50
,p_computation_item=>'P1951_SYNC_TABLE_NAME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P1951_EXISTING_TABLE_NAME'
,p_compute_when=>'P1951_NEW_OR_EXISTING_TABLE'
,p_compute_when_text=>'EXISTING'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1720927504469942)
,p_computation_sequence=>10
,p_computation_item=>'P1951_SHOW_SYNC_ARRAY_COL_ID'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P1951_SYNC_ARRAY_COL_ID'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3801543478901504)
,p_validation_name=>'Local Table NOT NULL'
,p_validation_sequence=>10
,p_validation=>'P1951_SYNC_TABLE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>'SAVE,MANUAL_DATA_SYNC'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(3702757410255327)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1662745779963711)
,p_validation_name=>'Commit Interval is multiple of 100'
,p_validation_sequence=>20
,p_validation=>'mod( :P1951_SYNC_COMMIT_INTERVAL, 100 ) = 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'#LABEL# must be a multiple of 100.'
,p_validation_condition=>':REQUEST in ( ''SAVE'', ''MANUAL_DATA_SYNC'' ) and :P1951_SYNC_COMMIT_INTERVAL is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(3801266410901501)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3801601054901505)
,p_validation_name=>'Sync Type NOT NULL'
,p_validation_sequence=>30
,p_validation=>'P1951_SYNC_TYPE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>':P1951_OLD_SYNC_TABLE_NAME is not null and :REQUEST in (''SAVE'',''MANUAL_DATA_SYNC'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(4302707508059814)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3801970880901508)
,p_validation_name=>'Sync Type "MERGE" only for Primary Key'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_web_src_sync_dev.data_profile_has_primary_key( ',
'    p_web_source_module_id => :P1951_WEB_SRC_MODULE_ID )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'"Merge" type requires a primary key column defined in the data profile.'
,p_validation_condition=>':REQUEST in ( ''SAVE'', ''MANUAL_DATA_SYNC'' ) and :P1951_SYNC_TYPE = ''MERGE'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(4302707508059814)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(38546807309928201)
,p_validation_name=>'Sync interval is valid'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_cadence number;',
'begin',
'    l_cadence := wwv_flow_web_src_sync_dev.get_execution_cadence_minutes( ',
'                     p_calendaring_expression => :P1951_SYNC_INTERVAL );',
'    return true;',
'exception',
'    when others then',
'        return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Invalid Calendaring Expression.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST in ( ''SAVE'', ''MANUAL_DATA_SYNC'' ) and',
':P1951_SYNC_TABLE_NAME is not null and ',
':P1951_SYNC_INTERVAL is not null and ',
':P1951_OLD_SYNC_TABLE_NAME is not null and',
'nvl(:P1951_SYNC_INTERVAL, chr(1)) != nvl(:P1951_OLD_SYNC_INTERVAL, chr(1))'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(4302840882059815)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3804993186901538)
,p_validation_name=>'Minimum Execution Cadence met'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    return wwv_flow_web_src_sync_dev.get_execution_cadence_minutes( ',
'               p_calendaring_expression => :P1951_SYNC_INTERVAL ) >= to_number(:P1951_MIN_CADENCE);',
'exception',
'    when others then ',
'        -- syntax errors in the calendaring expression are catched in the',
'        -- "Sync Interval is valid" validation',
'        return true;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Synchronizations cannot be executed more frequently than every &P1951_MIN_CADENCE!HTML. minutes.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST in ( ''SAVE'', ''MANUAL_DATA_SYNC'' ) and',
':P1951_SYNC_TABLE_NAME is not null and ',
':P1951_SYNC_INTERVAL is not null and ',
':P1951_OLD_SYNC_TABLE_NAME is not null and',
'nvl(:P1951_SYNC_INTERVAL, chr(1)) != nvl(:P1951_OLD_SYNC_INTERVAL, chr(1))'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(4302840882059815)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1662904757963713)
,p_validation_name=>'Installation Script name must not exist'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_install_scripts',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and name              = :P1951_SCRIPT_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Supporting Objects script with this name already exists.'
,p_when_button_pressed=>wwv_flow_imp.id(3803834939901527)
,p_associated_item=>wwv_flow_imp.id(3803619759901525)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5904226730682542)
,p_validation_name=>'New Table does not exist'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select table_name a, table_name b',
'  from sys.dba_tables',
' where owner = nvl( :P1951_SYNC_TABLE_OWNER, wwv_flow_wizard_api.get_flow_owner(:FB_FLOW_ID))',
'   and table_name = :P1951_NEW_TABLE_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Table &P1951_SYNC_TABLE_NAME!HTML. already exists.'
,p_validation_condition=>':REQUEST in ( ''SAVE'', ''MANUAL_DATA_SYNC'' )  and :P1951_NEW_OR_EXISTING_TABLE = ''NEW'' and :P1951_OLD_SYNC_TABLE_NAME is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(5900899407682508)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3805025722901539)
,p_name=>'Hide all'
,p_event_sequence=>5
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1951_INT_FREQUENCY'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3805136729901540)
,p_event_id=>wwv_flow_imp.id(3805025722901539)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_BYDAY,P1951_BYHOUR,P1951_BYMINUTE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3805259386901541)
,p_name=>'Weekly Frequency chosen'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1951_INT_FREQUENCY'
,p_condition_element=>'P1951_INT_FREQUENCY'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'WEEKLY'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3805374112901542)
,p_event_id=>wwv_flow_imp.id(3805259386901541)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_BYDAY,P1951_BYHOUR,P1951_BYMINUTE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5516815331157109)
,p_name=>'Close New Sync Step DIalog'
,p_event_sequence=>20
,p_triggering_element_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_element=>'window'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5516958219157110)
,p_event_id=>wwv_flow_imp.id(5516815331157109)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(4302959812059816)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5517065783157111)
,p_name=>'Close Edit Sync Step DIalog'
,p_event_sequence=>30
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(4302959812059816)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5517184250157112)
,p_event_id=>wwv_flow_imp.id(5517065783157111)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(4302959812059816)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5520890652157149)
,p_name=>'Hide SQL'
,p_event_sequence=>40
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5520930493157150)
,p_event_id=>wwv_flow_imp.id(5520890652157149)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3704694634255346)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3402804208376607)
,p_event_id=>wwv_flow_imp.id(5520890652157149)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(3402593703376604)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3402335945376602)
,p_name=>'Show Create Table SQL'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3402234723376601)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3402458260376603)
,p_event_id=>wwv_flow_imp.id(3402335945376602)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3704694634255346)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3402986281376608)
,p_event_id=>wwv_flow_imp.id(3402335945376602)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(3402593703376604)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3803379941901522)
,p_event_id=>wwv_flow_imp.id(3402335945376602)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(3803085160901519)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3403068884376609)
,p_event_id=>wwv_flow_imp.id(3402335945376602)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(3402234723376601)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3402687592376605)
,p_name=>'Hide Create Table SQL'
,p_event_sequence=>60
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3402593703376604)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3402786069376606)
,p_event_id=>wwv_flow_imp.id(3402687592376605)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3704694634255346)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3403381330376612)
,p_event_id=>wwv_flow_imp.id(3402687592376605)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(3402234723376601)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3403401991376613)
,p_event_id=>wwv_flow_imp.id(3402687592376605)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(3402593703376604)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3803439117901523)
,p_event_id=>wwv_flow_imp.id(3402687592376605)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(3803085160901519)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3403782744376616)
,p_name=>'Show Alter Table SQL'
,p_event_sequence=>70
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3403550413376614)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3403877295376617)
,p_event_id=>wwv_flow_imp.id(3403782744376616)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3704694634255346)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3803252217901521)
,p_event_id=>wwv_flow_imp.id(3403782744376616)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(3804144280901530)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3403951827376618)
,p_event_id=>wwv_flow_imp.id(3403782744376616)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(3403686885376615)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3404031784376619)
,p_event_id=>wwv_flow_imp.id(3403782744376616)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(3403550413376614)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2906320597179146)
,p_name=>'Show Alter Table SQL2'
,p_event_sequence=>80
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2906244256179145)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2906425015179147)
,p_event_id=>wwv_flow_imp.id(2906320597179146)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3704694634255346)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2906672692179149)
,p_event_id=>wwv_flow_imp.id(2906320597179146)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(5900100267682501)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2906749293179150)
,p_event_id=>wwv_flow_imp.id(2906320597179146)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(2906244256179145)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3404179351376620)
,p_name=>'Hide Alter Table SQL'
,p_event_sequence=>90
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3403686885376615)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3404277765376621)
,p_event_id=>wwv_flow_imp.id(3404179351376620)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3704694634255346)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3404325376376622)
,p_event_id=>wwv_flow_imp.id(3404179351376620)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(3403686885376615)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3803189957901520)
,p_event_id=>wwv_flow_imp.id(3404179351376620)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(3804144280901530)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3404405616376623)
,p_event_id=>wwv_flow_imp.id(3404179351376620)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(3403550413376614)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5900263319682502)
,p_name=>'Hide Alter Table SQL2'
,p_event_sequence=>100
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(5900100267682501)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5900340590682503)
,p_event_id=>wwv_flow_imp.id(5900263319682502)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3704694634255346)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5900472157682504)
,p_event_id=>wwv_flow_imp.id(5900263319682502)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(5900100267682501)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5900621593682506)
,p_event_id=>wwv_flow_imp.id(5900263319682502)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(2906244256179145)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3404836611376627)
,p_name=>'Show Interval Builder'
,p_event_sequence=>110
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'#P1951_EDIT_SYNC_INTERVAL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3404933336376628)
,p_event_id=>wwv_flow_imp.id(3404836611376627)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3404639650376625)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3405053842376629)
,p_name=>'Hide Interval Builder'
,p_event_sequence=>120
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3405170593376630)
,p_event_id=>wwv_flow_imp.id(3405053842376629)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3404639650376625)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3405892116376637)
,p_name=>'Daily Frequency chosen'
,p_event_sequence=>130
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1951_INT_FREQUENCY'
,p_condition_element=>'P1951_INT_FREQUENCY'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'DAILY'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3405966480376638)
,p_event_id=>wwv_flow_imp.id(3405892116376637)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_BYHOUR,P1951_BYMINUTE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3805480788901543)
,p_event_id=>wwv_flow_imp.id(3405892116376637)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_BYDAY'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'MON:TUE:WED:THU:FRI:SAT:SUN'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3406192278376640)
,p_name=>'Hourly Frequency chosen'
,p_event_sequence=>140
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1951_INT_FREQUENCY'
,p_condition_element=>'P1951_INT_FREQUENCY'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'HOURLY'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3406277129376641)
,p_event_id=>wwv_flow_imp.id(3406192278376640)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_BYMINUTE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3805595994901544)
,p_event_id=>wwv_flow_imp.id(3406192278376640)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_BYDAY'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'MON:TUE:WED:THU:FRI:SAT:SUN'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3805616249901545)
,p_event_id=>wwv_flow_imp.id(3406192278376640)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_BYHOUR'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3805902128901548)
,p_name=>'Minutely Frequency chosen'
,p_event_sequence=>150
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1951_INT_FREQUENCY'
,p_condition_element=>'P1951_INT_FREQUENCY'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'MINUTELY'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3806144633901550)
,p_event_id=>wwv_flow_imp.id(3805902128901548)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_BYDAY'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'MON:TUE:WED:THU:FRI:SAT:SUN'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2901870089179101)
,p_event_id=>wwv_flow_imp.id(3805902128901548)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_BYHOUR,P1951_BYMINUTE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3406881060376647)
,p_name=>'Build the interval'
,p_event_sequence=>160
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3406775981376646)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3406913402376648)
,p_event_id=>wwv_flow_imp.id(3406881060376647)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_SYNC_INTERVAL'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'buildInterval()'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3407083032376649)
,p_event_id=>wwv_flow_imp.id(3406881060376647)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLOSE_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3404639650376625)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3801770413901506)
,p_name=>'Reload SQL'
,p_event_sequence=>170
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1951_INCLUDE_DROP_COLUMNS'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3801857978901507)
,p_event_id=>wwv_flow_imp.id(3801770413901506)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_SQL'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>'nvl( wwv_flow_web_src_sync.get_sync_table_column_sql(:P1951_WEB_SRC_MODULE_ID, :P1951_INCLUDE_DROP_COLUMNS = ''Y''), ''-- no SQL statements'')'
,p_attribute_07=>'P1951_INCLUDE_DROP_COLUMNS,P1951_WEB_SRC_MODULE_ID'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3803952592901528)
,p_name=>'Open Save Script Dialog'
,p_event_sequence=>180
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3803085160901519)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3804078606901529)
,p_event_id=>wwv_flow_imp.id(3803952592901528)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3803587485901524)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3804418057901533)
,p_name=>'Save as Script'
,p_event_sequence=>190
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3804144280901530)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3804613762901535)
,p_event_id=>wwv_flow_imp.id(3804418057901533)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_SCRIPT_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'2'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3804504129901534)
,p_event_id=>wwv_flow_imp.id(3804418057901533)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3803587485901524)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2902201004179105)
,p_name=>'Clear Sync Interval'
,p_event_sequence=>200
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'#P1951_CLEAR_SYNC_INTERVAL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2902318682179106)
,p_event_id=>wwv_flow_imp.id(2902201004179105)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_SYNC_INTERVAL'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2903281473179115)
,p_name=>'Replace Type chosen'
,p_event_sequence=>210
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1951_SYNC_TYPE'
,p_condition_element=>'P1951_SYNC_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REPLACE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2903363466179116)
,p_event_id=>wwv_flow_imp.id(2903281473179115)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_REPLACE_TYPE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2903417011179117)
,p_event_id=>wwv_flow_imp.id(2903281473179115)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_REPLACE_TYPE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2903817930179121)
,p_name=>'Interval set'
,p_event_sequence=>220
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1951_SYNC_INTERVAL'
,p_condition_element=>'P1951_SYNC_INTERVAL'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2903904922179122)
,p_event_id=>wwv_flow_imp.id(2903817930179121)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_JOB_IS_ACTIVE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2904085462179123)
,p_event_id=>wwv_flow_imp.id(2903817930179121)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_JOB_IS_ACTIVE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2904718604179130)
,p_event_id=>wwv_flow_imp.id(2903817930179121)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_JOB_IS_ACTIVE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2904838489179131)
,p_event_id=>wwv_flow_imp.id(2903817930179121)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_JOB_IS_ACTIVE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2904963468179132)
,p_name=>'Confirm'
,p_event_sequence=>230
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3200568818532836)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2905056432179133)
,p_event_id=>wwv_flow_imp.id(2904963468179132)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'This will clear all synchronization settings. The local table will NOT be dropped. Do you want to continue?'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2905163797179134)
,p_event_id=>wwv_flow_imp.id(2904963468179132)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'CLEAR_SYNC'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5901034004682510)
,p_name=>'New Table chosen'
,p_event_sequence=>240
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1951_NEW_OR_EXISTING_TABLE'
,p_condition_element=>'P1951_NEW_OR_EXISTING_TABLE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5901179260682511)
,p_event_id=>wwv_flow_imp.id(5901034004682510)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_NEW_TABLE_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5901440820682514)
,p_event_id=>wwv_flow_imp.id(5901034004682510)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_EXISTING_TABLE_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5901236963682512)
,p_event_id=>wwv_flow_imp.id(5901034004682510)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_NEW_TABLE_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5901336470682513)
,p_event_id=>wwv_flow_imp.id(5901034004682510)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_EXISTING_TABLE_NAME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1404085451407882)
,p_name=>'Max Requests Per MIn changed'
,p_event_sequence=>250
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1951_USE_RATE_LIMITING'
,p_condition_element=>'P1951_USE_RATE_LIMITING'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1404413427407894)
,p_event_id=>wwv_flow_imp.id(1404085451407882)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_MAX_REQUESTS_TIMEFRAME,P1951_MAX_REQUESTS,P1951_MAX_REQUESTS_EXC_ACTION'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1404980068407894)
,p_event_id=>wwv_flow_imp.id(1404085451407882)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_MAX_REQUESTS_TIMEFRAME,P1951_MAX_REQUESTS,P1951_MAX_REQUESTS_EXC_ACTION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1241618411106502716)
,p_name=>'Set up interval to check job state'
,p_event_sequence=>260
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_display_when_cond=>'P1951_JOB_STATE'
,p_display_when_cond2=>'RUNNING:SCHEDULED'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1241618521870502717)
,p_event_id=>wwv_flow_imp.id(1241618411106502716)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'setCheckJobTimeout();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1241618649470502718)
,p_name=>'Check Job State'
,p_event_sequence=>270
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1951_JOB_STATE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'custom'
,p_bind_event_type_custom=>'checkJobState'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1241618759245502719)
,p_event_id=>wwv_flow_imp.id(1241618649470502718)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1951_JOB_STATE,P1951_JOB_SHOW_STATE'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with job_state as (',
'    select coalesce( wwv_flow_web_src_sync_dev.get_job_status( :P1951_WEB_SRC_MODULE_ID ), ''SUCCESS'' ) as job_state',
'      from sys.dual )',
'select job_state,',
'       wwv_flow_lang.system_message( ''APEX.WEBSRC.SYNC.STATUS_'' || job_state ) as job_show_state',
'  from job_state',
''))
,p_attribute_07=>'P1951_WEB_SRC_MODULE_ID'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1241618856701502720)
,p_event_id=>wwv_flow_imp.id(1241618649470502718)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'document.location.reload();'
,p_client_condition_type=>'NOT_IN_LIST'
,p_client_condition_element=>'P1951_JOB_STATE'
,p_client_condition_expression=>'RUNNING,SCHEDULED'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1241619083527502722)
,p_event_id=>wwv_flow_imp.id(1241618649470502718)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'setCheckJobTimeout();'
,p_client_condition_type=>'IN_LIST'
,p_client_condition_element=>'P1951_JOB_STATE'
,p_client_condition_expression=>'RUNNING,SCHEDULED'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1664160786963725)
,p_process_sequence=>40
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Get Other Syncs for Table'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_sync_usages varchar2(32767);',
'begin',
'    for s in (',
'        select flow_id,',
'               name',
'          from wwv_flow_web_src_modules',
'         where security_group_id = :FLOW_SECURITY_GROUP_ID',
'           and ( sync_table_owner  = nvl( :P1951_SYNC_TABLE_OWNER, wwv_flow_wizard_api.get_flow_owner(:FB_FLOW_ID) ) or ',
'                        ( sync_table_owner is null and :P1951_SYNC_TABLE_OWNER is null ) )',
'           and sync_table_name   = :P1951_OLD_SYNC_TABLE_NAME',
'           and id != :P1951_WEB_SRC_MODULE_ID',
'    ) loop',
'         l_sync_usages := l_sync_usages || case when l_sync_usages is not null then '', '' end',
'                                        || s.name || '' ('' || wwv_flow_lang.system_message( ''APPLICATION'') || '' '' || s.flow_id || '')'';',
'    end loop;',
'    ',
'    :P1951_OTHER_SYNC_INFO := l_sync_usages;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':P1951_SYNC_STATUS != wwv_flow_web_src_sync.c_table_does_not_exist and :P1951_OLD_SYNC_TABLE_NAME is not null'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>1664160786963725
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1406047373417134)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'Clear Rate Limiting Items'
,p_attribute_01=>'CLEAR_CACHE_FOR_ITEMS'
,p_attribute_03=>'P1951_MAX_REQUESTS_TIMEFRAME,P1951_MAX_REQUESTS,P1951_MAX_REQUESTS_EXC_ACTION'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST in ( ''SAVE'', ''MANUAL_DATA_SYNC'' ) and :P1951_USE_RATE_LIMITING = ''N''',
''))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>1406047373417134
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3704142050255341)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Apply Changes'
,p_attribute_02=>'WWV_FLOW_WEB_SRC_MODULES'
,p_attribute_03=>'P1951_WEB_SRC_MODULE_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id = :FLOW_SECURITY_GROUP_ID'
,p_attribute_11=>'U'
,p_attribute_12=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':REQUEST in ( ''SAVE'', ''MANUAL_DATA_SYNC'' ) '
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Changes applied.'
,p_internal_uid=>3704142050255341
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1664485903963728)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Disable Sync job on subscribed REST Sources'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_web_src_sync_dev.handle_sync_job_subscribed_wsm(',
'        p_master_wsm_job_status   => :P1951_JOB_IS_ACTIVE = ''Y'',',
'        p_web_source_module_id    => :P1951_WEB_SRC_MODULE_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':REQUEST in ( ''SAVE'', ''MANUAL_DATA_SYNC'' ) and :P1951_JOB_IS_ACTIVE = ''Y'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>1664485903963728
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1663791597963721)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Enable Local Table'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_web_src_sync_dev.set_use_local_sync_table(',
'        p_application_id       => :FB_FLOW_ID,',
'        p_web_source_module_id => :P1951_WEB_SRC_MODULE_ID,',
'        p_use_local_sync_table => false);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':REQUEST in ( ''SAVE'', ''MANUAL_DATA_SYNC'' ) and :P1951_SYNC_TABLE_NAME is not null and :P1951_OLD_SYNC_TABLE_NAME is null'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>1663791597963721
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5520707176157148)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Next Run Timestamp'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_web_src_sync.set_web_src_sync_timestamps(',
'        p_web_source_module_id    => :P1951_WEB_SRC_MODULE_ID,',
'        p_calendaring_expression  => case when :P1951_JOB_IS_ACTIVE = ''Y'' then :P1951_SYNC_INTERVAL end,',
'        p_set_last_run_timestamp  => false,',
'        p_clear_when_null         => true );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST in ( ''SAVE'', ''MANUAL_DATA_SYNC'' ) and',
':P1951_SYNC_TABLE_NAME is not null and ',
':P1951_OLD_SYNC_TABLE_NAME is not null and',
'( nvl(:P1951_SYNC_INTERVAL, chr(1)) != nvl(:P1951_OLD_SYNC_INTERVAL, chr(1)) or ',
'  nvl(:P1951_JOB_IS_ACTIVE, chr(1)) != nvl(:P1951_OLD_JOB_IS_ACTIVE, chr(1)) ) '))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>5520707176157148
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3704916247255349)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Sync Table'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_web_src_sync.execute_sync_table( :P1951_WEB_SRC_MODULE_ID, :P1951_INCLUDE_DROP_COLUMNS = ''Y'' );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE_TABLE,ALTER_TABLE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'Table created or changed.'
,p_internal_uid=>3704916247255349
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4302596829059812)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Clear Sync'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_web_src_sync_dev.clear_web_source_sync(',
'        p_application_id       => :FB_FLOW_ID,',
'        p_web_source_module_id => :P1951_WEB_SRC_MODULE_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3200568818532836)
,p_process_success_message=>'REST synchronization settings cleared.'
,p_internal_uid=>4302596829059812
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4303451519059821)
,p_process_sequence=>80
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Sync Step'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    :P1951_NEW_SYNC_STEP_ID := wwv_flow_web_src_sync_dev.create_new_sync_step(',
'                                   p_application_id       => :FB_FLOW_ID,',
'                                   p_web_source_module_id => :P1951_WEB_SRC_MODULE_ID );',
'end;',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(4303314867059820)
,p_internal_uid=>4303451519059821
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5517716244157118)
,p_process_sequence=>90
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Sync Data Manually'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_web_src_sync.execute_due_wsm_data_syncs(',
'        p_web_src_module_id     => :P1951_WEB_SRC_MODULE_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(4302666690059813)
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P1951_SYNC_TABLE_NAME is not null and ',
':P1951_SYNC_STATUS != wwv_flow_web_src_sync.c_table_does_not_exist'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'REST synchronization triggered.'
,p_internal_uid=>5517716244157118
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3802948853901518)
,p_process_sequence=>100
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Supporting Object script'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    :P1951_SCRIPT_ID := wwv_flow_web_src_sync_dev.create_supp_objects_script(',
'                            p_application_id         => :FB_FLOW_ID,',
'                            --',
'                            p_web_source_module_id   => :P1951_WEB_SRC_MODULE_ID,',
'                            p_include_drop_columns   => :P1951_INCLUDE_DROP_COLUMNS = ''Y'',',
'                            p_script_type            => :P1951_SCRIPT_TYPE,',
'                            p_script_name            => :P1951_SCRIPT_NAME );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3803834939901527)
,p_process_success_message=>'Supporting objects script "&P1951_SCRIPT_NAME!HTML." created.'
,p_internal_uid=>3802948853901518
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1373990319674229)
,p_process_sequence=>110
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Purge Log'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    delete wwv_flow_websource_sync_log1$ ',
'     where web_src_module_id = :P1951_WEB_SRC_MODULE_ID ',
'       and security_group_id = :FLOW_SECURITY_GROUP_ID;',
'       ',
'    delete wwv_flow_websource_sync_log2$ ',
'     where web_src_module_id = :P1951_WEB_SRC_MODULE_ID',
'       and security_group_id = :FLOW_SECURITY_GROUP_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1373830947674228)
,p_process_success_message=>'Synchronization Log purged.'
,p_internal_uid=>1373990319674229
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1375474215674244)
,p_process_sequence=>120
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Terminate running sync job'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_web_src_sync_dev.abort_sync_job( ',
'        p_application_id       => :FB_FLOW_ID,',
'        p_web_source_module_id => :P1951_WEB_SRC_MODULE_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1375364889674243)
,p_process_success_message=>'Synchronization terminated.'
,p_internal_uid=>1375474215674244
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3702673013255326)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch WSM Details'
,p_attribute_02=>'WWV_FLOW_WEB_SRC_MODULES'
,p_attribute_03=>'P1951_WEB_SRC_MODULE_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id = :FLOW_SECURITY_GROUP_ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>3702673013255326
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2902132912179104)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch last and next sync timestamp'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with sync_timestamps as (',
'    select sync_last_run_timestamp,',
'           case when sync_next_run_timestamp is not null then',
'               wwv_flow_web_src_sync_dev.get_actual_execution_timestamp( sync_next_run_timestamp ) at time zone ''00:00''',
'           end as sync_next_run_timestamp',
'      from wwv_flow_web_src_modules',
'     where id                = :P1951_WEB_SRC_MODULE_ID',
'       and security_group_id = :FLOW_SECURITY_GROUP_ID )',
'select case ',
'           when sync_next_run_timestamp is not null then',
'               to_char(sync_next_run_timestamp, ''Mon fmdd, '' ) ||',
'               to_char(sync_next_run_timestamp, ''HH24:MI '' ) ||',
'               decode(to_char(sync_next_run_timestamp, ''TZR'' ), ''+00:00'', ''UTC'', to_char(sync_next_run_timestamp, ''TZR'' ) ) ||',
'               '' ('' || htmldb_util.get_since( sync_next_run_timestamp ) || '')''',
'       end,',
'       case',
'           when sync_last_run_timestamp is not null then',
'                      htmldb_util.get_since( sync_last_run_timestamp )',
'       end',
'  into :P1951_NEXT_SYNC_TIMESTAMP,',
'       :P1951_LAST_SYNC_TIMESTAMP',
'  from sync_timestamps;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2902132912179104
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2903646243179119)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Truncate items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case ',
'    when :P1951_TABLE_SYNC_TYPE = ''TRUNCATE'' then',
'        :P1951_SYNC_TYPE := ''REPLACE'';',
'        :P1951_REPLACE_TYPE := ''TRUNCATE'';',
'    when :P1951_TABLE_SYNC_TYPE = ''REPLACE'' then',
'        :P1951_SYNC_TYPE := ''REPLACE'';',
'        :P1951_REPLACE_TYPE := ''DELETE'';',
'    else',
'        :P1951_SYNC_TYPE := :P1951_TABLE_SYNC_TYPE;',
'        :P1951_REPLACE_TYPE := null;',
'end case;',
'       ',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2903646243179119
);
end;
/
prompt --application/pages/page_01952
begin
wwv_flow_imp_page.create_page(
 p_id=>1952
,p_name=>'Edit Synchronization Step'
,p_alias=>'EDIT-SYNC-STEP'
,p_page_mode=>'MODAL'
,p_step_title=>'Edit Synchronization Step'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_width=>'80%'
,p_dialog_attributes=>'resizable:true'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4303740949059824)
,p_plug_name=>'Parameters'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select cp.id, ',
'       pa.name,',
'       pa.data_type,',
'       cp.value_type,',
'       cp.value_language,',
'       cp.value,',
'       cp.format_mask',
'  from wwv_flow_web_src_comp_params cp, wwv_flow_web_src_params pa, wwv_flow_web_src_sync_steps sp',
' where pa.id                = cp.web_src_param_id',
'   and sp.id                = cp.module_sync_step_id',
'   and sp.id                = :P1952_SYNC_STEP_ID',
'    --',
'   and cp.flow_id           = :FB_FLOW_ID',
'   and pa.flow_id           = cp.flow_id',
'   and sp.flow_id           = cp.flow_id',
'    --',
'   and cp.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and pa.security_group_id = cp.security_group_id',
'   and sp.security_group_id = cp.security_group_id',
'    '))
,p_plug_source_type=>'NATIVE_IG'
,p_ajax_items_to_submit=>'P1952_SYNC_STEP_ID'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_web_src_comp_params cp, wwv_flow_web_src_sync_steps sp',
' where sp.id = cp.module_sync_step_id',
'   and sp.id = :P1952_SYNC_STEP_ID',
'    --',
'   and cp.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and sp.security_group_id = cp.security_group_id',
'    --',
'   and cp.flow_id           = :FB_FLOW_ID',
'   and sp.flow_id           = cp.flow_id'))
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Parameters'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1683482483640301)
,p_name=>'FORMAT_MASK'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FORMAT_MASK'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_POPUP_LOV'
,p_heading=>'Format Mask'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>100
,p_value_alignment=>'LEFT'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
,p_is_required=>false
,p_max_length=>255
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(32743907454195192)
,p_lov_display_extra=>true
,p_lov_display_null=>true
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>'Format mask to convert the <strong>Static</strong> value to the data type of the REST Source Parameter.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2233371688790550)
,p_name=>'DATA_TYPE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DATA_TYPE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Parameter Data Type'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>50
,p_value_alignment=>'LEFT'
,p_is_required=>false
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(2225637019805602)
,p_lov_display_extra=>true
,p_lov_display_null=>true
,p_enable_filter=>false
,p_filter_is_required=>false
,p_static_id=>'COLUMN_ITEM_FOR_DATA_TYPE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_include_in_export=>true
,p_readonly_condition_type=>'ALWAYS'
,p_readonly_for_each_row=>false
,p_help_text=>'Data Type of the REST Source Parameter.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2319784476209543)
,p_name=>'VALUE_LANGUAGE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'VALUE_LANGUAGE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>70
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(4304683024059833)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>30
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(4304740260059834)
,p_name=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Parameter Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>40
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_include_in_export=>true
,p_help_text=>'Identifies the <em>Name</em> of the REST Data Source Parameter.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(4304829191059835)
,p_name=>'VALUE_TYPE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'VALUE_TYPE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Value Type'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>60
,p_value_alignment=>'LEFT'
,p_is_required=>true
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(358243382603181986)
,p_lov_display_extra=>false
,p_lov_display_null=>false
,p_enable_filter=>false
,p_filter_is_required=>false
,p_static_id=>'COLUMN_ITEM_FOR_VALUE_TYPE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select how this parameter is populated.</p><p>Available options include:</p>',
'<ul>',
'    <li><strong>Static Value</strong>: Set to the text entered into <em>Static Value</em>.</li>',
'    <li><strong>Item</strong>: Set to the value held in session state for the <em>Item</em> specified.</li>',
'    <li><strong>SQL Query (return single value)</strong>: Set to the first value returned from the <em>SQL Query</em> entered.</li>',
'    <li><strong>PL/SQL Expression</strong>: Set to the value that results from executing the <em>PL/SQL Expression</em> entered.</li>',
'    <li><strong>PL/SQL Function Body</strong>: Set to the value returned from the <em>PL/SQL Function Body</em> entered.</li>',
'    <li><strong>Collection (CLOB)</strong>: Set to the CLOB column value of the first row from the <em>Collection</em> entered.</li>',
'    <li><strong>Preference</strong>: Set to the value of the <em>Preference</em> entered.</li>',
'    <li><strong>Null</strong>: Set to null as no value specified.</li>',
'</ul>',
''))
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(4304949748059836)
,p_name=>'VALUE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'VALUE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Expression'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>80
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
,p_help_text=>'Provide the expression here, based on the <strong>Value Type </strong> column.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(4305021843059837)
,p_name=>'APEX$ROW_ACTION'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>20
,p_use_as_row_header=>false
,p_display_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(4305152515059838)
,p_name=>'APEX$ROW_SELECTOR'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_use_as_row_header=>false
,p_display_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(4304597288059832)
,p_internal_uid=>4304597288059832
,p_is_editable=>true
,p_edit_operations=>'u'
,p_lost_update_check_type=>'VALUES'
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>false
,p_no_data_found_message=>'No Parameters defined.'
,p_show_toolbar=>false
,p_toolbar_buttons=>null
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>false
,p_define_chart_view=>false
,p_enable_download=>false
,p_download_formats=>null
,p_enable_mail_download=>true
,p_fixed_header=>'NONE'
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(5504614616108133)
,p_interactive_grid_id=>wwv_flow_imp.id(4304597288059832)
,p_static_id=>'14132'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(5504795121108135)
,p_report_id=>wwv_flow_imp.id(5504614616108133)
,p_view_type=>'GRID'
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1689447752637942)
,p_view_id=>wwv_flow_imp.id(5504795121108135)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(2233371688790550)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1690296901637938)
,p_view_id=>wwv_flow_imp.id(5504795121108135)
,p_display_seq=>7
,p_column_id=>wwv_flow_imp.id(1683482483640301)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2503012544896420)
,p_view_id=>wwv_flow_imp.id(5504795121108135)
,p_display_seq=>6
,p_column_id=>wwv_flow_imp.id(2319784476209543)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5505295661108157)
,p_view_id=>wwv_flow_imp.id(5504795121108135)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(4304683024059833)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5505708648108175)
,p_view_id=>wwv_flow_imp.id(5504795121108135)
,p_display_seq=>2
,p_column_id=>wwv_flow_imp.id(4304740260059834)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5506214647108179)
,p_view_id=>wwv_flow_imp.id(5504795121108135)
,p_display_seq=>4
,p_column_id=>wwv_flow_imp.id(4304829191059835)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5506714859108181)
,p_view_id=>wwv_flow_imp.id(5504795121108135)
,p_display_seq=>5
,p_column_id=>wwv_flow_imp.id(4304949748059836)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5508110585115355)
,p_view_id=>wwv_flow_imp.id(5504795121108135)
,p_display_seq=>0
,p_column_id=>wwv_flow_imp.id(4305021843059837)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4304145200059828)
,p_plug_name=>'Edit Synchronization Step'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_WEB_SRC_SYNC_STEPS'
,p_query_where=>'security_group_id = :FLOW_SECURITY_GROUP_ID'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'u:d'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4305399667059840)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5516600080157107)
,p_plug_name=>'Advanced'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4305533231059842)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(4305399667059840)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5517419820157115)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(4305399667059840)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4305456974059841)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(4305399667059840)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2905270958179135)
,p_name=>'P1952_EXTERNAL_FILTER_EXPR'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(4304145200059828)
,p_item_source_plug_id=>wwv_flow_imp.id(4304145200059828)
,p_prompt=>'External Filter'
,p_source=>'EXTERNAL_FILTER_EXPR'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_tag_attributes=>'style="width: 100%"'
,p_colspan=>8
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Provide a filter expression to be passed to the external REST service. The expression will be passed to the remote server as-is. The syntax depends on the type of the REST Data Source.</p>',
'<p>',
'    For instance, Oracle REST Data Services (ORDS) expects JSON syntax and an ORDS REST Service would thus accept the following filter to return only records with the "sal" attribute less than 3000.',
'</p>',
'<pre>',
'{"sal": {"$lt": 3000}}',
'</pre>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4304273111059829)
,p_name=>'P1952_SYNC_STEP_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(4304145200059828)
,p_item_source_plug_id=>wwv_flow_imp.id(4304145200059828)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4306115270059848)
,p_name=>'P1952_STATIC_ID'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(4304145200059828)
,p_item_source_plug_id=>wwv_flow_imp.id(4304145200059828)
,p_prompt=>'Static ID'
,p_source=>'STATIC_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_tag_attributes=>'style="width: 100%"'
,p_colspan=>8
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter a static ID to uniquely identify a synchronization step.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4306210534059849)
,p_name=>'P1952_EXECUTION_SEQUENCE'
,p_source_data_type=>'NUMBER'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(4304145200059828)
,p_item_source_plug_id=>wwv_flow_imp.id(4304145200059828)
,p_prompt=>'Sequence'
,p_source=>'EXECUTION_SEQUENCE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>10
,p_begin_on_new_line=>'N'
,p_colspan=>1
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Sequence number to determine the execution order of the synchronization steps.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4306389774059850)
,p_name=>'P1952_IS_ACTIVE'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(4304145200059828)
,p_item_source_plug_id=>wwv_flow_imp.id(4304145200059828)
,p_prompt=>'Active'
,p_source=>'IS_ACTIVE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_begin_on_new_line=>'N'
,p_colspan=>1
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Whether this step will be executed or not.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5516045199157101)
,p_name=>'P1952_SYNC_STEP_COMMENT'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(5516600080157107)
,p_item_source_plug_id=>wwv_flow_imp.id(4304145200059828)
,p_prompt=>'Comments'
,p_source=>'SYNC_STEP_COMMENT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>75
,p_cMaxlength=>4000
,p_cHeight=>3
,p_tag_attributes=>'style="width: 100%"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_item_comment=>'Enter any developer comments or notes here. These comments only display within App Builder and never display when running the application.'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1684338334640310)
,p_tabular_form_region_id=>wwv_flow_imp.id(4303740949059824)
,p_validation_name=>'Validate NON-NULL'
,p_validation_sequence=>10
,p_validation=>'VALUE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#COLUMN_HEADER# must have a value.'
,p_validation_condition=>'VALUE_TYPE'
,p_validation_condition2=>'NULL'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(4305456974059841)
,p_exec_cond_for_each_row=>'Y'
,p_associated_column=>'VALUE'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2903014218179113)
,p_tabular_form_region_id=>wwv_flow_imp.id(4303740949059824)
,p_validation_name=>'Validate NULL'
,p_validation_sequence=>20
,p_validation=>':VALUE is NULL'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'The NULL value type cannot have a value.'
,p_validation_condition=>'VALUE_TYPE'
,p_validation_condition2=>'NULL'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(4305456974059841)
,p_exec_cond_for_each_row=>'Y'
,p_associated_column=>'VALUE'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2902402034179107)
,p_tabular_form_region_id=>wwv_flow_imp.id(4303740949059824)
,p_validation_name=>'Validate Code and SQL'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_web_src_dev.validate_web_src_param_value(',
'           p_application_id => :FB_FLOW_ID,',
'           p_data_type      => :DATA_TYPE,',
'           p_value_type     => :VALUE_TYPE,',
'           p_value_lang     => :VALUE_LANGUAGE,',
'           p_expression     => :VALUE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_when_button_pressed=>wwv_flow_imp.id(4305456974059841)
,p_associated_column=>'VALUE'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2902546536179108)
,p_name=>'Enable / Disable Format Mask'
,p_event_sequence=>10
,p_triggering_element_type=>'COLUMN'
,p_triggering_region_id=>wwv_flow_imp.id(4303740949059824)
,p_triggering_element=>'VALUE_TYPE'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'   [ "STATIC", "ITEM" ].includes( $v( "COLUMN_ITEM_FOR_VALUE_TYPE" ) )',
'&& [ "BOOLEAN", "DATE", "NUMBER", "TIMESTAMP", "TIMESTAMP WITH TIME ZONE" ].includes( $v( "COLUMN_ITEM_FOR_DATA_TYPE" ) )'))
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1683540081640302)
,p_event_id=>wwv_flow_imp.id(2902546536179108)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'FORMAT_MASK'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1683632073640303)
,p_event_id=>wwv_flow_imp.id(2902546536179108)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'FORMAT_MASK'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1683768257640304)
,p_event_id=>wwv_flow_imp.id(2902546536179108)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'FORMAT_MASK'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1683845918640305)
,p_name=>'Enable / Disable Expression'
,p_event_sequence=>20
,p_triggering_element_type=>'COLUMN'
,p_triggering_region_id=>wwv_flow_imp.id(4303740949059824)
,p_triggering_element=>'VALUE_TYPE'
,p_condition_element_type=>'COLUMN'
,p_condition_element=>'VALUE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1683994968640306)
,p_event_id=>wwv_flow_imp.id(1683845918640305)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'VALUE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1684104783640308)
,p_event_id=>wwv_flow_imp.id(1683845918640305)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'VALUE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1684004639640307)
,p_event_id=>wwv_flow_imp.id(1683845918640305)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'VALUE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2319829401209544)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(4303740949059824)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Parameters - Set VALUE_LANGUAGE'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    -- Web Source Parameters should always be handled as PL/SQL,',
'    -- in an IG it''s to complicated having a dynamic languages column',
'    if :VALUE_TYPE in ( ''FUNCTION_BODY'', ''EXPRESSION'' ) then',
'        :VALUE_LANGUAGE := ''PLSQL'';',
'    else',
'        :VALUE_LANGUAGE := null;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2319829401209544
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4305232788059839)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(4303740949059824)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Parameters - Save Interactive Grid Data'
,p_attribute_01=>'TABLE'
,p_attribute_03=>'WWV_FLOW_WEB_SRC_COMP_PARAMS'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>4305232788059839
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5516579260157106)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(4304145200059828)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process form Synchronization Step'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>5516579260157106
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5516738383157108)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>5516738383157108
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4305674944059843)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(4304145200059828)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Edit Sync Step'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>4305674944059843
);
end;
/
prompt --application/pages/page_01953
begin
wwv_flow_imp_page.create_page(
 p_id=>1953
,p_name=>'HTTP Request Log'
,p_alias=>'HTTP-REQUESTS'
,p_page_mode=>'MODAL'
,p_step_title=>'HTTP Request Log'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_width=>'80%'
,p_dialog_attributes=>'resizable:true'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2904138288179124)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(5519335336157134)
,p_name=>'HTTP Request Log'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select http_method,',
'       url,',
'       resp_content_length,',
'       status_code,',
'       request_date,',
'       elapsed_sec',
'  from wwv_flow_webservice_log',
' where web_src_sync_id   = :P1953_WSM_SYNC_ID',
'   and web_src_module_id = :P1951_WEB_SRC_MODULE_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
'       '))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No HTTP requests have been logged for this synchronization.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5519421732157135)
,p_query_column_id=>1
,p_column_alias=>'HTTP_METHOD'
,p_column_display_sequence=>1
,p_column_heading=>'HTTP Method'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5519534970157136)
,p_query_column_id=>2
,p_column_alias=>'URL'
,p_column_display_sequence=>2
,p_column_heading=>'URL'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5519624559157137)
,p_query_column_id=>3
,p_column_alias=>'RESP_CONTENT_LENGTH'
,p_column_display_sequence=>3
,p_column_heading=>'Content Length'
,p_use_as_row_header=>'N'
,p_column_format=>'FILESIZE'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5519714612157138)
,p_query_column_id=>4
,p_column_alias=>'STATUS_CODE'
,p_column_display_sequence=>4
,p_column_heading=>'Status Code'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5520125865157142)
,p_query_column_id=>5
,p_column_alias=>'REQUEST_DATE'
,p_column_display_sequence=>6
,p_column_heading=>'Request As Of'
,p_use_as_row_header=>'N'
,p_column_format=>'YYYY/MM/DD HH24:MI:SS'
,p_column_alignment=>'CENTER'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5519864543157139)
,p_query_column_id=>6
,p_column_alias=>'ELAPSED_SEC'
,p_column_display_sequence=>5
,p_column_heading=>'Elapsed'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2904249830179125)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2904138288179124)
,p_button_name=>'Close'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Close'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5520029440157141)
,p_name=>'P1953_WSM_SYNC_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(5519335336157134)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1375773160674247)
,p_computation_sequence=>10
,p_computation_item=>'P1953_WSM_SYNC_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P1953_WSM_SYNC_ID'
,p_compute_when_text=>'-'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2904374683179126)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2904249830179125)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2904446690179127)
,p_event_id=>wwv_flow_imp.id(2904374683179126)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_01954
begin
wwv_flow_imp_page.create_page(
 p_id=>1954
,p_name=>'Synchronization Usage'
,p_alias=>'CLEAR-SYNCHRONIZATION-SETTINGS'
,p_page_mode=>'MODAL'
,p_step_title=>'Synchronization Usage'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_width=>'80%'
,p_dialog_attributes=>'resizable:true'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5704471149300022)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5903108996682531)
,p_plug_name=>'Clear Sync Information'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'This report shows application components which use the local synchronization table as their data source.'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P1954_DIALOG_TYPE'
,p_plug_display_when_cond2=>'SHOW_USAGE'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5904047098682540)
,p_plug_name=>'Usage Information'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'The following application components are using this REST Data Source, with the <strong>Use Synchronization Table</strong> attribute enabled. If synchronization is cleared, <strong>Use Synchronization Table</strong> will be disabled and the components'
||' will invoke the REST service directly.'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P1954_DIALOG_TYPE'
,p_plug_display_when_cond2=>'CLEAR_SYNC'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(8319668197278032)
,p_name=>'Components '
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang_dev.builder_message( component_type_msg ) as component_type,',
'       component_id,',
'       page_id,',
'       region_name,',
'       series_name,',
'       shared_component_name',
'  from wwv_flow_web_src_module_usage',
' where security_group_id    = :FLOW_SECURITY_GROUP_ID',
'   and web_src_module_id    = :P1951_WEB_SRC_MODULE_ID',
'   and use_local_sync_table = ''Y''',
''))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>'The synchronization table is not used by any application component.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5902430957682524)
,p_query_column_id=>1
,p_column_alias=>'COMPONENT_TYPE'
,p_column_display_sequence=>4
,p_column_heading=>'Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5902530718682525)
,p_query_column_id=>2
,p_column_alias=>'COMPONENT_ID'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5902691473682526)
,p_query_column_id=>3
,p_column_alias=>'PAGE_ID'
,p_column_display_sequence=>2
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_PAGE_ID:#PAGE_ID#'
,p_column_linktext=>'#PAGE_ID#'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5903253422682532)
,p_query_column_id=>4
,p_column_alias=>'REGION_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Region Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5903357610682533)
,p_query_column_id=>5
,p_column_alias=>'SERIES_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'Series Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5903427079682534)
,p_query_column_id=>6
,p_column_alias=>'SHARED_COMPONENT_NAME'
,p_column_display_sequence=>6
,p_column_heading=>'Shared Component Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2800991143120933)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(5704471149300022)
,p_button_name=>'Close'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Close'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5903605869682536)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(5704471149300022)
,p_button_name=>'CLEAR_SYNC'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Clear Synchronization'
,p_button_position=>'NEXT'
,p_button_condition=>'P1954_DIALOG_TYPE'
,p_button_condition2=>'CLEAR_SYNC'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(5903730084682537)
,p_branch_name=>'Go To Page 1951'
,p_branch_action=>'f?p=&APP_ID.:1951:&SESSION.::&DEBUG.:1951:P1951_WEB_SRC_MODULE_ID:&P1951_WEB_SRC_MODULE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5903837157682538)
,p_name=>'P1954_DIALOG_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(5903108996682531)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2804421557120958)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2800991143120933)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2804937711120960)
,p_event_id=>wwv_flow_imp.id(2804421557120958)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5903533804682535)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Clear Sync'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_web_src_sync_dev.clear_web_source_sync(',
'        p_application_id       => :FB_FLOW_ID,',
'        p_web_source_module_id => :P1951_WEB_SRC_MODULE_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(5903605869682536)
,p_process_success_message=>'Synchronization cleared. All components will use the REST source directly.'
,p_internal_uid=>5903533804682535
);
end;
/
prompt --application/pages/page_01955
begin
wwv_flow_imp_page.create_page(
 p_id=>1955
,p_name=>'REST Synchronizations'
,p_alias=>'REST-SYNCHRONIZATIONS'
,p_step_title=>'REST Synchronizations'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(809376180227725873)
,p_plug_name=>'REST Synchronizations'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select m.id,',
'       m.name                                                                    module_name,',
'       nvl( m.sync_table_owner, wwv_flow_lang.system_message(''PARSING_SCHEMA''))  table_owner,',
'       m.sync_table_name                                                         table_name,',
'       m.sync_type,',
'       m.sync_is_active                                                          is_active,',
'       m.sync_interval,',
'       m.sync_last_run_timestamp,',
'       case when m.sync_next_run_timestamp is not null then',
'           wwv_flow_web_src_sync_dev.get_actual_execution_timestamp( m.sync_next_run_timestamp ) at time zone ''00:00'' ',
'       end as sync_next_run_timestamp',
'from wwv_flow_web_src_modules m',
'where m.security_group_id = :flow_security_group_id',
'  and m.flow_id           = :fb_flow_id',
'  and m.sync_table_name   is not null',
''))
,p_optimizer_hint=>'APEX$USE_ROWNUM_PAGINATION'
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(809376252104725874)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'No REST Synchronizations found.'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_control_break=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_pivot=>'N'
,p_show_notify=>'Y'
,p_show_flashback=>'N'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'ADMIN'
,p_internal_uid=>809376252104725874
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(564732923534362597)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(546916858863857721)
,p_db_column_name=>'IS_ACTIVE'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Active'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(84259319526460470)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(564732174506362594)
,p_db_column_name=>'MODULE_NAME'
,p_display_order=>30
,p_column_identifier=>'N'
,p_column_label=>'REST Synchronization'
,p_column_link=>'f?p=&APP_ID.:1951:&SESSION.::&DEBUG.:RP,:P1951_WEB_SRC_MODULE_ID:#ID#'
,p_column_linktext=>'#MODULE_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(546916523539857718)
,p_db_column_name=>'TABLE_OWNER'
,p_display_order=>40
,p_column_identifier=>'Q'
,p_column_label=>'Table Owner'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(546916673844857719)
,p_db_column_name=>'TABLE_NAME'
,p_display_order=>50
,p_column_identifier=>'R'
,p_column_label=>'Table Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(546916771735857720)
,p_db_column_name=>'SYNC_TYPE'
,p_display_order=>60
,p_column_identifier=>'S'
,p_column_label=>'Type'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(601130955295874684)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(546916966797857722)
,p_db_column_name=>'SYNC_INTERVAL'
,p_display_order=>70
,p_column_identifier=>'U'
,p_column_label=>'Interval'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(546917094466857723)
,p_db_column_name=>'SYNC_LAST_RUN_TIMESTAMP'
,p_display_order=>80
,p_column_identifier=>'V'
,p_column_label=>'Last Run'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(546917177804857724)
,p_db_column_name=>'SYNC_NEXT_RUN_TIMESTAMP'
,p_display_order=>90
,p_column_identifier=>'W'
,p_column_label=>'Next Run'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(809537310000856847)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'5647333'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'MODULE_NAME:IS_ACTIVE:TABLE_OWNER:TABLE_NAME:SYNC_TYPE:SYNC_LAST_RUN_TIMESTAMP:SYNC_NEXT_RUN_TIMESTAMP:'
,p_sort_column_1=>'SYNC_LAST_RUN_TIMESTAMP'
,p_sort_direction_1=>'DESC NULLS LAST'
,p_sort_column_2=>'0'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1047425145047544749)
,p_plug_name=>'About'
,p_region_name=>'Synchronizations'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page displays <strong>REST Synchronizations</strong> defined in this application.</p>',
'<p>To create a new REST Synchronization, first create a new <strong>REST Data Source</strong>, then navigate to the <strong>Manage Synchronization</strong> task, in order to configure details like the target table, the synchronization method and addi'
||'tional details.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1047425344240544750)
,p_plug_name=>'tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_imp.id(241353531173849237)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'REST Data Sources'
);
end;
/
prompt --application/pages/page_01960
begin
wwv_flow_imp_page.create_page(
 p_id=>1960
,p_name=>'REST Source Catalogs'
,p_alias=>'REST-SOURCE-CATALOGS'
,p_step_title=>'REST Source Catalogs'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_appgroup.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1466873346002238)
,p_plug_name=>'Create Catalog Group first'
,p_region_template_options=>'#DEFAULT#:a-Alert--info:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'REST Source Catalogs are organized by <em>Groups</em>. Create a catalog group in order to manage REST Source Catalogs.'
,p_plug_display_condition_type=>'NOT_EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_web_src_catalog_groups ',
' where security_group_id = :WORKSPACE_ID'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(93647485831975487)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(2036513182725270)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(97563383977456410)
,p_plug_name=>'About'
,p_region_css_classes=>'a-Region--stacked a-Region--padded a-Region--flush a-Region--sideRegion'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>REST Source Catalogs allow developers to create REST Data Sources using predefined services.</p>',
'<p>Create your own catalog or import an existing catalog.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(447638473297252882)
,p_plug_name=>'REST Source Catalogs'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    g.name as group_name, ',
'    g.id as group_id, ',
'    c.name as catalog_name, ',
'    c.id as catalog_id, ',
'    c.description, ',
'    (select count(*) from wwv_web_src_catalog_services s where s.catalog_id = c.id and s.security_group_id = c.security_group_id) as service_count,',
'    c.last_imported_at imported,',
'    nvl(c.last_updated_on,c.created_on) last_modified',
'from wwv_web_src_catalog_groups g ',
'join wwv_web_src_catalogs c on (c.catalog_group_id = g.id and c.security_group_id = g.security_group_id)',
'where g.security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(447638575838252882)
,p_name=>'Application Groups'
,p_no_data_found_message=>'This workspace contains no REST Source Catalogs.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'SBKENNED'
,p_internal_uid=>447638575838252882
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2029553017651239)
,p_db_column_name=>'GROUP_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Group'
,p_column_link=>'f?p=&APP_ID.:1961:&SESSION.::&DEBUG.:RP,1961:P1961_ID:#GROUP_ID##ID#,&FB_FLOW_ID.'
,p_column_linktext=>'#GROUP_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2030789434651242)
,p_db_column_name=>'LAST_MODIFIED'
,p_display_order=>4
,p_column_identifier=>'E'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(6177033125901821)
,p_db_column_name=>'GROUP_ID'
,p_display_order=>14
,p_column_identifier=>'M'
,p_column_label=>'Group Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(6177174656901822)
,p_db_column_name=>'CATALOG_NAME'
,p_display_order=>24
,p_column_identifier=>'N'
,p_column_label=>'Catalog'
,p_column_link=>'f?p=&APP_ID.:1962:&SESSION.::&DEBUG.:1963:P1962_ID:#CATALOG_ID#'
,p_column_linktext=>'#CATALOG_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(6177290014901823)
,p_db_column_name=>'CATALOG_ID'
,p_display_order=>34
,p_column_identifier=>'O'
,p_column_label=>'Catalog Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(6177490665901825)
,p_db_column_name=>'DESCRIPTION'
,p_display_order=>54
,p_column_identifier=>'Q'
,p_column_label=>'Description'
,p_allow_sorting=>'N'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(6177519312901826)
,p_db_column_name=>'SERVICE_COUNT'
,p_display_order=>64
,p_column_identifier=>'R'
,p_column_label=>'Contents'
,p_column_link=>'f?p=&APP_ID.:1963:&SESSION.::&DEBUG.::P1963_CATALOG_ID:#CATALOG_ID#'
,p_column_linktext=>'#SERVICE_COUNT# Services'
,p_column_link_attr=>'class="a-Button"'
,p_column_type=>'NUMBER'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1464820423002218)
,p_db_column_name=>'IMPORTED'
,p_display_order=>74
,p_column_identifier=>'T'
,p_column_label=>'Imported'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(447640370436260264)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_type=>'REPORT'
,p_report_alias=>'1290823179536644'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'CATALOG_NAME:DESCRIPTION:SERVICE_COUNT:LAST_MODIFIED:GROUP_NAME:'
,p_sort_column_1=>'CATALOG_NAME'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'0'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1466911191002239)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1466873346002238)
,p_button_name=>'CREATE_GROUP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Group'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:1961:&SESSION.::&DEBUG.:1961::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2504582976903942)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(447638473297252882)
,p_button_name=>'OPENAPI'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Create from OpenAPI'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1970:&SESSION.::&DEBUG.:1970::'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_web_src_catalog_groups ',
' where security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2033441015651258)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(447638473297252882)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Catalog'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1962:&SESSION.::&DEBUG.:1962::'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_web_src_catalog_groups ',
' where security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1464958518002219)
,p_name=>'Edit Catalog Dialog closed'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(447638473297252882)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1465084671002220)
,p_event_id=>wwv_flow_imp.id(1464958518002219)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(447638473297252882)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1467272603002242)
,p_name=>'Edit Group Dialog closed'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1466911191002239)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1467394734002243)
,p_event_id=>wwv_flow_imp.id(1467272603002242)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'document.location.reload();'
);
end;
/
prompt --application/pages/page_01961
begin
wwv_flow_imp_page.create_page(
 p_id=>1961
,p_name=>'Catalog Group Details'
,p_alias=>'CATALOG-GROUP-DETAILS'
,p_page_mode=>'MODAL'
,p_step_title=>'Catalog Group Details'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2054133058988356)
,p_plug_name=>'Catalog Group Details'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_query_type=>'TABLE'
,p_query_table=>'WWV_WEB_SRC_CATALOG_GROUPS'
,p_query_where=>'security_group_id = :WORKSPACE_ID'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Groups are used for organizing catalogs so developers can more easily find services from which to create REST Data Sources.',
'</p>'))
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2059941738988482)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2062342717988507)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(2059941738988482)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P1961_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2062745375988508)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(2059941738988482)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>'P1961_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2060360203988483)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2059941738988482)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2061953528988505)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(2059941738988482)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_confirm_message=>'Delete this catalog group?'
,p_confirm_style=>'danger'
,p_button_condition=>'P1961_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2054424688988359)
,p_name=>'P1961_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2054133058988356)
,p_item_source_plug_id=>wwv_flow_imp.id(2054133058988356)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_protection_level=>'S'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2054842949988412)
,p_name=>'P1961_NAME'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2054133058988356)
,p_item_source_plug_id=>wwv_flow_imp.id(2054133058988356)
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Specify the name of the catalog group.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2055143545988441)
,p_name=>'P1961_ICON'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2054133058988356)
,p_item_source_plug_id=>wwv_flow_imp.id(2054133058988356)
,p_prompt=>'Icon'
,p_post_element_text=>'<a class="a-Button a-Button--popupLOV" href="javascript:popupURL(''f?p=4000:1967:&SESSION.::&DEBUG.::P1967_RETURN_ITEM:P1961_ICON'');"><span class="a-Icon icon-popup-lov"></span><span class="u-VisuallyHidden">"LIST_IMAGE_LOV_TITLE"</span></a>'
,p_source=>'ICON'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_item_comment=>'Set condition to NEVER for now. We will address icons in a later release. DBB'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2055555089988442)
,p_name=>'P1961_DESCRIPTION'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(2054133058988356)
,p_item_source_plug_id=>wwv_flow_imp.id(2054133058988356)
,p_prompt=>'Description'
,p_source=>'DESCRIPTION'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Describe the purpose of the group.'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(6814291803316802)
,p_validation_name=>'Name is unique'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_web_src_catalog_groups cg',
' where cg.security_group_id = :WORKSPACE_ID',
'   and cg.id   != :P1961_ID',
'   and cg.name  = :P1961_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#LABEL# must be unique in the workspace.'
,p_validation_condition=>'SAVE,CREATE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(2054842949988412)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(6814384500316803)
,p_validation_name=>'Group must be empty to delete'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null ',
'  from wwv_web_src_catalogs ',
' where security_group_id = :WORKSPACE_ID',
'   and catalog_group_id  = :P1961_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'You cannot delete a group that contains catalogs.'
,p_when_button_pressed=>wwv_flow_imp.id(2061953528988505)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2060435743988483)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2060360203988483)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2061278071988498)
,p_event_id=>wwv_flow_imp.id(2060435743988483)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2063506466988521)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(2054133058988356)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process form Catalog Group Details'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2063506466988521
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2063944806988523)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2063944806988523
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2063146660988520)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(2054133058988356)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Catalog Group Details'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2063146660988520
);
end;
/
prompt --application/pages/page_01962
begin
wwv_flow_imp_page.create_page(
 p_id=>1962
,p_name=>'REST Source Catalog Details'
,p_alias=>'REST-SOURCE-CATALOG-DETAILS'
,p_page_mode=>'MODAL'
,p_step_title=>'REST Source Catalog Details'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2072305345128155)
,p_plug_name=>'REST Source Catalog Details'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_query_type=>'TABLE'
,p_query_table=>'WWV_WEB_SRC_CATALOGS'
,p_query_where=>'security_group_id = :WORKSPACE_ID'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2076109690128210)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2078591107128229)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(2076109690128210)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P1962_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2078902067128229)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(2076109690128210)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>'P1962_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2076549350128212)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2076109690128210)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2078172547128227)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(2076109690128210)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_confirm_message=>'Delete this catalog?'
,p_confirm_style=>'danger'
,p_button_condition=>'P1962_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1502435283184412)
,p_name=>'P1962_CREDENTIAL_TYPE'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(2072305345128155)
,p_prompt=>'Authentication Type'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CREDENTIALS_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(154078822199034715)||'.'
,p_cHeight=>1
,p_tag_attributes=>'disabled'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_credentials',
' where security_group_id = :WORKSPACE_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Type of the Web Credential to use for authentication.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2072650229128156)
,p_name=>'P1962_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2072305345128155)
,p_item_source_plug_id=>wwv_flow_imp.id(2072305345128155)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_protection_level=>'S'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2073019332128175)
,p_name=>'P1962_CATALOG_GROUP_ID'
,p_source_data_type=>'NUMBER'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2072305345128155)
,p_item_source_plug_id=>wwv_flow_imp.id(2072305345128155)
,p_prompt=>'Group'
,p_source=>'CATALOG_GROUP_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name as dv, id as rv ',
'from wwv_web_src_catalog_groups ',
'where security_group_id = :WORKSPACE_ID;'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a group to organize the catalog and assist developers when creating services.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2073475059128195)
,p_name=>'P1962_NAME'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2072305345128155)
,p_item_source_plug_id=>wwv_flow_imp.id(2072305345128155)
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Catalog names must be unique to a workspace.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2073823429128196)
,p_name=>'P1962_ICON'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(2072305345128155)
,p_item_source_plug_id=>wwv_flow_imp.id(2072305345128155)
,p_prompt=>'Icon'
,p_post_element_text=>'<a class="a-Button a-Button--popupLOV" href="javascript:popupURL(''f?p=4000:1967:&SESSION.::&DEBUG.::P1967_RETURN_ITEM:P1962_ICON'');"><span class="a-Icon icon-popup-lov"></span><span class="u-VisuallyHidden">"LIST_IMAGE_LOV_TITLE"</span></a>'
,p_source=>'ICON'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_item_comment=>'Set condition to NEVER for now. We will address icons in a later release. DBB'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2074239369128197)
,p_name=>'P1962_DESCRIPTION'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(2072305345128155)
,p_item_source_plug_id=>wwv_flow_imp.id(2072305345128155)
,p_prompt=>'Description'
,p_source=>'DESCRIPTION'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Describe the REST Source Catalog'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6177863288901829)
,p_name=>'P1962_INTERNAL_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(2072305345128155)
,p_item_source_plug_id=>wwv_flow_imp.id(2072305345128155)
,p_prompt=>'Internal Name'
,p_source=>'INTERNAL_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'The Internal Name is used to identify a catalog across multiple APEX instances. If a catalog is imported, and a catalog with the same internal name already exists, then the existing catalog will be overwritten.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6178096685901831)
,p_name=>'P1962_FORMAT'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(2072305345128155)
,p_item_source_plug_id=>wwv_flow_imp.id(2072305345128155)
,p_item_default=>'APEX'
,p_source=>'FORMAT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_help_text=>'Catalog names must be unique to a workspace.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6817437956316834)
,p_name=>'P1962_ENDPOINT_URL'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(2072305345128155)
,p_item_source_plug_id=>wwv_flow_imp.id(2072305345128155)
,p_prompt=>'Refresh Endpoint URL'
,p_source=>'ENDPOINT_URL'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Provide a URL where the catalog export file can be downloaded from, in order to refresh the REST Source Catalog.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6817503729316835)
,p_name=>'P1962_TOKEN_SERVER_URL'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(2072305345128155)
,p_item_source_plug_id=>wwv_flow_imp.id(2072305345128155)
,p_prompt=>'Token Server URL'
,p_source=>'TOKEN_SERVER_URL'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_credentials',
' where security_group_id = :WORKSPACE_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Provide the URL of a token server, if the <strong>OAuth2 Client Credentials</strong> flow is used to authenticate for the refresh endpoint URL.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6817623133316836)
,p_name=>'P1962_PROXY_SERVER'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(2072305345128155)
,p_item_source_plug_id=>wwv_flow_imp.id(2072305345128155)
,p_prompt=>'Proxy Server'
,p_placeholder=>'- Use default Instance Proxy -'
,p_source=>'PROXY_SERVER'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Proxy server to use when refreshing the REST Source Catalog. If not set, the &PRODUCT_NAME. instance proxy will be used, when defined.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6817733213316837)
,p_name=>'P1962_CREDENTIAL_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(2072305345128155)
,p_item_source_plug_id=>wwv_flow_imp.id(2072305345128155)
,p_prompt=>'Web Credential'
,p_source=>'CREDENTIAL_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LOV_CREDENTIAL_STORES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_credentials',
' where security_group_id    = :FLOW_SECURITY_GROUP_ID',
'   and authentication_type != ''KEY_PAIR'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_credentials',
' where security_group_id = :WORKSPACE_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the Web Credentials to use, when refreshing a catalog. Use this if the refresh endpoint URL requires authentication.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1467864783002248)
,p_computation_sequence=>10
,p_computation_item=>'P1962_INTERNAL_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(:P1962_INTERNAL_NAME) '
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(6814486012316804)
,p_validation_name=>'Name must be unique'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null ',
'  from wwv_web_src_catalogs c',
' where security_group_id = :WORKSPACE_ID',
'   and id   != :P1962_ID',
'   and name  = :P1962_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#LABEL# must be unique in the workspace.'
,p_validation_condition=>'SAVE,CREATE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(2073475059128195)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1467781037002247)
,p_validation_name=>'Internal Name must be unique'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null ',
'  from wwv_web_src_catalogs c',
' where security_group_id = :WORKSPACE_ID',
'   and id            != :P1962_ID',
'   and internal_name  = :P1962_INTERNAL_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#LABEL# must be unique in the workspace.'
,p_validation_condition=>'SAVE,CREATE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(6177863288901829)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1503228722184420)
,p_validation_name=>'URL must start with HTTP or HTTPS'
,p_validation_sequence=>30
,p_validation=>':P1962_ENDPOINT_URL like ''http://%'' or :P1962_ENDPOINT_URL like ''https://%'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'#LABEL# must start with http:// or https://'
,p_validation_condition=>'P1962_ENDPOINT_URL'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(2078591107128229)
,p_associated_item=>wwv_flow_imp.id(6817437956316834)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2076687109128212)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2076549350128212)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2077411694128219)
,p_event_id=>wwv_flow_imp.id(2076687109128212)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1501864116184406)
,p_name=>'Refresh URL entered'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1962_ENDPOINT_URL'
,p_condition_element=>'P1962_ENDPOINT_URL'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1501946740184407)
,p_event_id=>wwv_flow_imp.id(1501864116184406)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1962_CREDENTIAL_ID,P1962_PROXY_SERVER'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1502013735184408)
,p_event_id=>wwv_flow_imp.id(1501864116184406)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1962_CREDENTIAL_ID,P1962_PROXY_SERVER'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1503096295184418)
,p_event_id=>wwv_flow_imp.id(1501864116184406)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1962_CREDENTIAL_ID,P1962_PROXY_SERVER,P1962_CREDENTIAL_TYPE,P1962_TOKEN_SERVER_URL'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1502130587184409)
,p_name=>'Credential chosen'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1962_CREDENTIAL_ID'
,p_condition_element=>'P1962_CREDENTIAL_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1502286633184410)
,p_event_id=>wwv_flow_imp.id(1502130587184409)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1962_CREDENTIAL_TYPE'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select authentication_type',
'  from wwv_credentials',
' where id                = :P1962_CREDENTIAL_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_attribute_07=>'P1962_CREDENTIAL_ID'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1502371589184411)
,p_event_id=>wwv_flow_imp.id(1502130587184409)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1962_TOKEN_SERVER_URL'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1502810012184416)
,p_event_id=>wwv_flow_imp.id(1502130587184409)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1962_CREDENTIAL_TYPE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1502935295184417)
,p_event_id=>wwv_flow_imp.id(1502130587184409)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1962_CREDENTIAL_TYPE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1502523911184413)
,p_name=>'OAuth Creds'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1962_CREDENTIAL_TYPE'
,p_condition_element=>'P1962_CREDENTIAL_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'OAUTH2_CLIENT_CREDENTIALS'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1502678639184414)
,p_event_id=>wwv_flow_imp.id(1502523911184413)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1962_TOKEN_SERVER_URL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1502798789184415)
,p_event_id=>wwv_flow_imp.id(1502523911184413)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1962_TOKEN_SERVER_URL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2601039387934110)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Clear References when deleting catalog'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_web_src_catalog.clear_catalog_references(',
'        p_catalog_id => :P1962_ID',
'    );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2078172547128227)
,p_internal_uid=>2601039387934110
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2079612534128235)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(2072305345128155)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process form REST Source Catalog Details'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Changes applied.'
,p_internal_uid=>2079612534128235
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2080097315128237)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'SAVE,CREATE,DELETE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_internal_uid=>2080097315128237
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2079253647128233)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(2072305345128155)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form REST Source Catalog Details'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2079253647128233
);
end;
/
prompt --application/pages/page_01963
begin
wwv_flow_imp_page.create_page(
 p_id=>1963
,p_name=>'REST Catalog Services'
,p_alias=>'REST-CATALOG-SERVICES'
,p_step_title=>'REST Catalog Services'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_css_file_urls=>'#FONT_APEX_LATEST_DIRECTORY#css/font-apex#MIN#.css'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.xa-CardView-icon.fa, .a-CardView-icon.fa.fa-lg, .a-CardView-icon.a-Icon {font-size: 32px}',
'.xa-CardView-icon {padding:0}',
'.xa-CardView-body {padding-top:0}'))
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'21'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2717167025216206)
,p_plug_name=>'Catalog Services'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6178169545901832)
,p_plug_name=>'Catalog Services IG'
,p_region_name=>'issues'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with service_operations as (',
'    select /*+ RESULT_CACHE */ cs.id, ',
'           listagg (op.operation, '','' ) within group ( order by op.operation ) as operations',
'      from wwv_web_src_catalog_services cs, ',
'           json_table( ',
'                      cs.details_json,',
'                      ''$.operations[*]''',
'                      columns ( operation varchar2(255) path ''$.operation'' ) ) op',
'     where cs.catalog_id        = :P1963_CATALOG_ID',
'       and cs.security_group_id = :FLOW_SECURITY_GROUP_ID',
'     group by cs.id ',
')',
'select cs.id, ',
'       wwv_flow_page_api.get_url(p_page=>1964, p_items=>''P1964_ID'', p_values=>cs.id) as service_link, ',
'       cs.name, ',
'       cs.description,',
'       decode(instr(so.operations, ''GET''),    0, '''', ''<span class="a-IssueLabel label-color-13">GET</span>'')    ||',
'       decode(instr(so.operations, ''POST''),   0, '''', ''<span class="a-IssueLabel label-color-14">POST</span>'')    || ',
'       decode(instr(so.operations, ''PUT''),    0, '''', ''<span class="a-IssueLabel label-color-15">PUT</span>'')   || ',
'       decode(instr(so.operations, ''PATCH''),  0, '''', ''<span class="a-IssueLabel label-color-15">PATCH</span>'')   || ',
'       decode(instr(so.operations, ''DELETE''), 0, '''', ''<span class="a-IssueLabel label-color-16">DELETE</span>'') as labels_html',
'  from wwv_web_src_catalog_services cs,',
'       service_operations           so',
' where so.id                = cs.id',
'   and cs.catalog_id        = :P1963_CATALOG_ID',
'   and cs.security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_plug_source_type=>'NATIVE_IG'
,p_translate_title=>'N'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Services IG'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6178303295901834)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>'Id'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>10
,p_value_alignment=>'RIGHT'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
,p_is_required=>true
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6178465520901835)
,p_name=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_LINK'
,p_heading=>'Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>20
,p_value_alignment=>'LEFT'
,p_link_target=>'f?p=&APP_ID.:1964:&SESSION.::&DEBUG.:1964:P1964_ID:&ID.'
,p_link_text=>'&NAME.'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_escape_on_http_output=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6178668784901837)
,p_name=>'DESCRIPTION'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DESCRIPTION'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Description'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>40
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6179085334901841)
,p_name=>'LABELS_HTML'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LABELS_HTML'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HTML_EXPRESSION'
,p_heading=>'Operations'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>70
,p_value_alignment=>'LEFT'
,p_attribute_01=>'&LABELS_HTML.'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6179428958901845)
,p_name=>'SERVICE_LINK'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'SERVICE_LINK'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Service Link'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>80
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(6178257653901833)
,p_internal_uid=>6178257653901833
,p_is_editable=>false
,p_lazy_loading=>true
,p_requires_filter=>false
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>false
,p_no_data_found_message=>'There are no Services defined for this catalog.'
,p_show_toolbar=>true
,p_toolbar_buttons=>'SEARCH_FIELD:RESET'
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>false
,p_define_chart_view=>false
,p_enable_download=>false
,p_download_formats=>null
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>true
,p_icon_view_use_custom=>true
,p_icon_view_custom=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<li class="a-ContentRowReport-item" data-id="&APEX$ROW_ID.">',
'  <div class="a-ContentRowReport-itemWrap">',
'    <div class="a-ContentRowReport-itemSelection"><span class="u-selector"></span></div>',
'    <!-- div class="a-ContentRowReport-itemIconWrap"><span class="a-CardView-icon u-color &ICON. fa fa-lg fa-apex" aria-hidden="true" title=""></span></div -->',
'    <div class="a-ContentRowReport-itemBody">',
'      <div class="a-ContentRowReport-itemContent">',
'        <h3 class="a-ContentRowReport-itemTitle" id="label_&ID."><a href="&SERVICE_LINK.">&NAME.</a></h3>',
'        <div class="a-ContentRowReport-itemDescription">&DESCRIPTION.</div><div class="a-ContentRowReport-itemDescription">&LABELS_HTML.</div>',
'      </div>',
'      <div class="a-ContentRowReport-itemMisc"><span class="a-User a-User--more" title="&MORE_ASSIGNEES. other assignees"><span class="a-User-initials" role="presentation">&MORE_ASSIGNEES.</span></span></div>',
'      <div class="a-ContentRowReport-itemActions"></div>',
'    </div>',
'  </div>',
'</li>',
''))
,p_show_detail_view=>false
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'//',
'// this code was borrowed from Team Development Page 1',
'// ',
'function (options) {',
'/*',
'    // the following code adds an "update" menu after the "actions" menu of the IG toolbar',
'    var $ = apex.jQuery,',
'        toolbarData = $.apex.interactiveGrid.copyDefaultToolbar();',
'',
'    toolbarData.toolbarInsertAfter( "actions_button", {',
'       type: "MENU",',
'       labelKey: "APEX.ISSUES.UPDATE_MENU",',
'       id: "multi_edit_issues",',
'       menu: {',
'           items: [',
'               {',
'                   type:     "action",',
'                   labelKey: "APEX.ISSUES.MENU.STATUS",',
'                   action:   "open-status-dialog"',
'               },',
'               {',
'                   type:     "action",',
'                   labelKey: "APEX.ISSUES.MENU.ASSIGNEES",',
'                   action:   "open-assignees-dialog"',
'               },',
'               {',
'                   type:     "action",',
'                   labelKey: "APEX.ISSUES.MENU.LABELS",',
'                   action:   "open-labels-dialog"',
'               },',
'               {',
'                   type:     "action",',
'                   labelKey: "APEX.ISSUES.MENU.MILESTONES",',
'                   action:   "open-milestones-dialog"',
'               }',
'           ]',
'       }',
'    });',
'    ',
'    options.toolbarData = toolbarData;',
'*/',
'',
'    // don''t want single row view',
'    apex.util.getNestedObject(options, "views.grid.features").singleRowView = false;',
'',
'    options.defaultIconViewOptions = {',
'        collectionClasses: "a-ContentRowReport a-IssueList",',
'        iconListOptions: {',
'            navigation: false,',
'            tabbableContent: "a"',
'            // comes from row selector when navigation is false',
'            // multiple: true ',
'            // itemSelector: true',
'        }',
'    };',
'',
'    function checkOpen(dialogId) {',
'        if (getSelectedIds()) {',
'            apex.theme.openRegion(dialogId);',
'        } else {',
'            apex.theme.openRegion("noSelectionDialog");',
'        }',
'        return true; // setting focus',
'    }',
'',
'    //',
'    // Actions ',
'    //',
'    options.initActions = function(actions) {',
'',
'        // this changes the iconView button into a details view button. ',
'        // there is a details view option. Not sure why this was necessary. ',
'        // perhaps the feature didn''t exist at the time.',
'        var ig$ = $(actions.context),',
'            iconView = ig$.interactiveGrid("getViews").icon;',
'',
'        iconView.title = apex.lang.getMessage( "APEX.ISSUES.CARDS"); ',
'        iconView.icon = "icon-ig-details";',
'',
'        // this adds keyboard actions to open various dialogs that are not necessary for catalogs.',
'        /* ',
'        actions.add([',
'            {name: "open-status-dialog",',
'            shortcut: "Ctrl+/,S",',
'            action: function (event, elm) {',
'                return checkOpen("statusDialog");',
'            }},',
'            {name: "open-assignees-dialog",',
'            shortcut: "Ctrl+/,A",',
'            action: function (event, elm) {',
'                return checkOpen("assignDialog");',
'            }},',
'            {name: "open-labels-dialog",',
'            shortcut: "Ctrl+/,L",',
'            action: function (event, elm) {',
'                return checkOpen("labelDialog");',
'            }},',
'            {name: "open-milestones-dialog",',
'            shortcut: "Ctrl+/,M",',
'            action: function (event, elm) {',
'                return checkOpen("milestoneDialog");',
'            }}',
'        ]);',
'        */',
'    };',
'',
'    return options;',
'}'))
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(2126796545215111)
,p_interactive_grid_id=>wwv_flow_imp.id(6178257653901833)
,p_static_id=>'21268'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(3246915000009)
,p_report_id=>wwv_flow_imp.id(2126796545215111)
,p_view_type=>'ICON'
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(2126980410215112)
,p_report_id=>wwv_flow_imp.id(2126796545215111)
,p_view_type=>'GRID'
,p_stretch_columns=>true
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2127387904215133)
,p_view_id=>wwv_flow_imp.id(2126980410215112)
,p_display_seq=>0
,p_column_id=>wwv_flow_imp.id(6178303295901834)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2128298950215146)
,p_view_id=>wwv_flow_imp.id(2126980410215112)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(6178465520901835)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2130063647215160)
,p_view_id=>wwv_flow_imp.id(2126980410215112)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(6178668784901837)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2140941216409672)
,p_view_id=>wwv_flow_imp.id(2126980410215112)
,p_display_seq=>4
,p_column_id=>wwv_flow_imp.id(6179085334901841)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2214223318945796)
,p_view_id=>wwv_flow_imp.id(2126980410215112)
,p_display_seq=>5
,p_column_id=>wwv_flow_imp.id(6179428958901845)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(97466518640657800)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(3816997850663267)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(101294189288865252)
,p_plug_name=>'About'
,p_region_css_classes=>'a-Region--stacked a-Region--padded a-Region--flush a-Region--sideRegion'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Review the services provided by the catalog.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2717586700216210)
,p_name=>'P1963_CATALOG_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2717167025216206)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6178999113901840)
,p_name=>'P1963_CATALOG_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(6178169545901832)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4003903902287607)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Populate Catalog Name'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name ',
'into :P1963_CATALOG_NAME',
'from wwv_web_src_catalogs ',
'where id = :P1963_CATALOG_ID',
'and security_group_id = :WORKSPACE_ID;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>4003903902287607
);
end;
/
prompt --application/pages/page_01964
begin
wwv_flow_imp_page.create_page(
 p_id=>1964
,p_name=>'REST Source Catalog Service'
,p_alias=>'REST-SOURCE-CATALOG-SERVICE'
,p_step_title=>'REST Source Catalog Service'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'function callItempopUp(s1,s2) {',
'     var items = document.getElementById(s1).value.replace(/\,/g,''~'');',
'     var values = document.getElementById(s2).value.replace(/\,/g,''~'');',
'     var url = ''f?p=4000:404:&SESSION.:::404:P404_RETURN1,P404_RETURN2,P404_ITEMS,P404_VALUES:'' + s1 + '','' + s2 + '','' + escape(items) + '','' + escape(values);',
'     popUp (url);',
'}',
'</script>',
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(1504384803184431)
,p_name=>'REST Sources based on this Service'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--horizontalBorders:a-Report--stretch'
,p_region_attributes=>'style="margin-top: 20px;"'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select m.flow_id                       as rest_app_id,',
'       m.id                            as rest_source_id,',
'       f.name                          as application_name,',
'       m.name, ',
'       r.base_url || m.url_path_prefix as url,',
'       m.last_refreshed',
'  from wwv_flow_web_src_modules m,',
'       wwv_web_src_catalogs     c,',
'       wwv_remote_servers       r,',
'       wwv_flows                f',
' where c.internal_name        = m.catalog_internal_name',
'   and c.security_group_id    = :WORKSPACE_ID',
'   and r.id                   = m.remote_server_id',
'   and r.security_group_id    = :WORKSPACE_ID',
'   and m.security_group_id    = :WORKSPACE_ID',
'   and m.catalog_service_name = :P1964_NAME',
'   and f.id                   = m.flow_id',
'   and f.security_group_id    = :WORKSPACE_ID',
'   and c.id                   = :P1964_CATALOG_ID',
''))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P1964_NAME,P1964_CATALOG_ID'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>10
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No REST Sources have been created based on this Catalog Service.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1505336684184441)
,p_query_column_id=>1
,p_column_alias=>'REST_APP_ID'
,p_column_display_sequence=>20
,p_column_heading=>'App ID'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_default_sort_column_sequence=>1
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1505240243184440)
,p_query_column_id=>2
,p_column_alias=>'REST_SOURCE_ID'
,p_column_display_sequence=>10
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1504942142184437)
,p_query_column_id=>3
,p_column_alias=>'APPLICATION_NAME'
,p_column_display_sequence=>30
,p_column_heading=>'App Name'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1504478137184432)
,p_query_column_id=>4
,p_column_alias=>'NAME'
,p_column_display_sequence=>40
,p_column_heading=>'REST Source Name'
,p_use_as_row_header=>'Y'
,p_column_link=>'f?p=&APP_ID.:1921:&SESSION.::&DEBUG.:RR,1921:P1921_FLOW_ID,P1921_WEB_SRC_MODULE_ID,FB_FLOW_ID:#REST_APP_ID#,#REST_SOURCE_ID#,#REST_APP_ID#'
,p_column_linktext=>'#NAME#'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1504867076184436)
,p_query_column_id=>5
,p_column_alias=>'URL'
,p_column_display_sequence=>50
,p_column_heading=>'Endpoint URL'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1504690393184434)
,p_query_column_id=>6
,p_column_alias=>'LAST_REFRESHED'
,p_column_display_sequence=>60
,p_column_heading=>'Last Refreshed'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1505148644184439)
,p_plug_name=>'RDS'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2093075006067377)
,p_plug_name=>'Service Details'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_WEB_SRC_CATALOG_SERVICES'
,p_query_where=>'security_group_id = :WORKSPACE_ID'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2982252962967539)
,p_plug_name=>'Operations and Data Profile'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(2981074726967527)
,p_name=>'Data Profile'
,p_parent_plug_id=>wwv_flow_imp.id(2982252962967539)
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--horizontalBorders:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select col.name,',
'       col.data_type || case when col.data_type = ''VARCHAR2'' then '' ('' || nvl(col.max_length, 4000) || '')'' end as data_type,',
'       col.is_primary_key,',
'       col.parent_name,',
'       col.sequence',
'  from wwv_web_src_catalog_services cs, ',
'       json_table( cs.details_json,',
'                   ''$.data_profile.columns[*]''',
'                   columns (',
'                             name           varchar2(255) path ''$.name'',',
'                             data_type      varchar2(255) path ''$.data_type'',',
'                             max_length     number        path ''$.max_length'',',
'                             is_primary_key varchar2(255) path ''$.is_primary_key'',',
'                             parent_name    varchar2(255) path ''$.parent_name'',',
'                             sequence       number        path ''$.sequence'' ) ) col',
' where cs.security_group_id = :WORKSPACE_ID',
'   and cs.id                = :P1964_ID ',
'   and cs.catalog_id        = :P1964_CATALOG_ID',
''))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P1964_ID,P1964_CATALOG_ID'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>10
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2981133291967528)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>20
,p_column_heading=>'Data Profile Column Name'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2981256393967529)
,p_query_column_id=>2
,p_column_alias=>'DATA_TYPE'
,p_column_display_sequence=>30
,p_column_heading=>'Data Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2981413795967531)
,p_query_column_id=>3
,p_column_alias=>'IS_PRIMARY_KEY'
,p_column_display_sequence=>50
,p_column_heading=>'Primary Key'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(84259319526460470)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3263067290306321)
,p_query_column_id=>4
,p_column_alias=>'PARENT_NAME'
,p_column_display_sequence=>60
,p_column_heading=>'Parent Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2981513074967532)
,p_query_column_id=>5
,p_column_alias=>'SEQUENCE'
,p_column_display_sequence=>10
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(2981695214967533)
,p_name=>'Operations'
,p_parent_plug_id=>wwv_flow_imp.id(2982252962967539)
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select op.operation,',
'       op.database_operation,',
'       op.url_pattern',
'  from wwv_web_src_catalog_services cs, ',
'       json_table( cs.details_json,',
'                   ''$.operations[*]''',
'                   columns (',
'                             operation               varchar2(255) path ''$.operation'',',
'                             database_operation      varchar2(255) path ''$.database_operation'',',
'                             url_pattern             varchar2(255) path ''$.url_pattern'' ) ) op',
' where cs.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and cs.id                = :P1964_ID ',
'   and cs.catalog_id        = :P1964_CATALOG_ID',
'',
''))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P1964_ID,P1964_CATALOG_ID'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>10
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2981784082967534)
,p_query_column_id=>1
,p_column_alias=>'OPERATION'
,p_column_display_sequence=>20
,p_column_heading=>'HTTP Method'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2981848108967535)
,p_query_column_id=>2
,p_column_alias=>'DATABASE_OPERATION'
,p_column_display_sequence=>10
,p_column_heading=>'Database Action'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(225834585600778166)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2981912112967536)
,p_query_column_id=>3
,p_column_alias=>'URL_PATTERN'
,p_column_display_sequence=>30
,p_column_heading=>'URL Pattern'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(103936501160649209)
,p_plug_name=>'About'
,p_region_css_classes=>'a-Region--stacked a-Region--padded a-Region--flush a-Region--sideRegion'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The descriptive data of a catalog service may be edited. Enter a title and description to help developers determine the purpose of the service.</p>',
'<p>Other  details such as data profiles, operations, parameters, etc. are edited through the original REST Data Source definition.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2107055731067452)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2093075006067377)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1963:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2107898099067458)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(2093075006067377)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_confirm_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Delete this service?',
''))
,p_confirm_style=>'danger'
,p_button_condition=>'P1964_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2108235893067460)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(2093075006067377)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P1964_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2108652966067462)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(2093075006067377)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>'P1964_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2717833693216213)
,p_branch_name=>'Go to Page 1960'
,p_branch_action=>'f?p=&APP_ID.:1960:&SESSION.::&DEBUG.:1960::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2107898099067458)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2108905584067462)
,p_branch_name=>'Go To Page 1963'
,p_branch_action=>'f?p=&APP_ID.:1963:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'REQUEST_IN_CONDITION'
,p_branch_condition=>'SAVE,CREATE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1505437700184442)
,p_name=>'P1964_SOURCE_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(2093075006067377)
,p_item_source_plug_id=>wwv_flow_imp.id(2093075006067377)
,p_prompt=>'REST Source Type'
,p_source=>'PLUGIN_INTERNAL_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'WEB_SOURCE_MODULE_TYPES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,',
'       r',
'  from (',
'         select wwv_flow_lang.system_message(''WEB_SOURCE.''|| name_with_prefix) as d,',
'               name_with_prefix as r',
'          from wwv_flow_native_plugins',
'         where plugin_type = ''WEB SOURCE TYPE''',
'         union all',
'        select display_name || wwv_flow_lang.system_message(''PLUGIN.DISPLAY_NAME_POSTFIX'') as d,',
'               ''PLUGIN_'' || name     as r',
'          from wwv_flow_plugins',
'         where flow_id           = to_number(:FB_FLOW_ID)',
'           and security_group_id = to_number(:WORKSPACE_ID)',
'           and plugin_type       = ''WEB SOURCE TYPE''',
'       )',
' order by 1'))
,p_display_when=>':P1964_SOURCE_TYPE like ''NATIVE%'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'The type of the REST Data Source.'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1946929175091106)
,p_name=>'P1964_SOURCE_TYPE_PLUGIN'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(2093075006067377)
,p_prompt=>'REST Source Type'
,p_source=>'Plug-In'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>':P1964_SOURCE_TYPE not like ''NATIVE%'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The type of the REST Data Source.'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2093442129067380)
,p_name=>'P1964_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2093075006067377)
,p_item_source_plug_id=>wwv_flow_imp.id(2093075006067377)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_protection_level=>'S'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2093888462067393)
,p_name=>'P1964_SECURITY_GROUP_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2093075006067377)
,p_item_source_plug_id=>wwv_flow_imp.id(2093075006067377)
,p_source=>'SECURITY_GROUP_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2094238447067400)
,p_name=>'P1964_CATALOG_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2093075006067377)
,p_item_source_plug_id=>wwv_flow_imp.id(2093075006067377)
,p_source=>'CATALOG_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2094668440067401)
,p_name=>'P1964_NAME'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(2093075006067377)
,p_item_source_plug_id=>wwv_flow_imp.id(2093075006067377)
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Service names must be unique to each REST Source Catalog.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2095067774067403)
,p_name=>'P1964_ICON'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(2093075006067377)
,p_item_source_plug_id=>wwv_flow_imp.id(2093075006067377)
,p_prompt=>'Icon'
,p_post_element_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a class="a-Button a-Button--popupLOV" href="javascript:popupURL(''f?p=4000:1967:&SESSION.::&DEBUG.::P1967_RETURN_ITEM:P1964_ICON'');"><span class="a-Icon icon-popup-lov"></span><span class="u-VisuallyHidden">"LIST_IMAGE_LOV_TITLE"</span></a>',
''))
,p_source=>'ICON'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>255
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2095462978067404)
,p_name=>'P1964_DESCRIPTION'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(2093075006067377)
,p_item_source_plug_id=>wwv_flow_imp.id(2093075006067377)
,p_prompt=>'Description'
,p_source=>'DESCRIPTION'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>50
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Provide a description for this service.'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2095892244067405)
,p_name=>'P1964_BASE_URL'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(2093075006067377)
,p_item_source_plug_id=>wwv_flow_imp.id(2093075006067377)
,p_prompt=>'Base URL'
,p_source=>'BASE_URL'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'The <em>Remote Server</em> object will be determined based on this attribute when new REST Data Sources are created from the catalog.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2096291242067405)
,p_name=>'P1964_SERVICE_PATH'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(2093075006067377)
,p_item_source_plug_id=>wwv_flow_imp.id(2093075006067377)
,p_prompt=>'Service Path'
,p_source=>'SERVICE_PATH'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'The <em>service-specific</em> part of the REST Source URL.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2096606413067407)
,p_name=>'P1964_AUTH_SERVER_BASE_URL'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(2093075006067377)
,p_item_source_plug_id=>wwv_flow_imp.id(2093075006067377)
,p_prompt=>'Authentication Server Base URL'
,p_source=>'AUTH_SERVER_BASE_URL'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_display_when=>'P1964_AUTHENTICATION_TYPE'
,p_display_when2=>'OAUTH2_CLIENT_CREDENTIALS'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'The <strong>Base URL</strong> of the Authentication Server (<em>Token Server</em>) for the REST Data Source.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2097052022067407)
,p_name=>'P1964_AUTH_SERVER_URL_PATH'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(2093075006067377)
,p_item_source_plug_id=>wwv_flow_imp.id(2093075006067377)
,p_prompt=>'Authentication Server URL Path'
,p_source=>'AUTH_SERVER_URL_PATH'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_display_when=>'P1964_AUTHENTICATION_TYPE'
,p_display_when2=>'OAUTH2_CLIENT_CREDENTIALS'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'The <strong>URL Path</strong> of the Authentication Server (<em>Token Server</em>) for the REST Data Source.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2097407377067409)
,p_name=>'P1964_PLUGIN_INTERNAL_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(2093075006067377)
,p_item_source_plug_id=>wwv_flow_imp.id(2093075006067377)
,p_source=>'PLUGIN_INTERNAL_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2097840692067411)
,p_name=>'P1964_AUTHENTICATION_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(2093075006067377)
,p_item_source_plug_id=>wwv_flow_imp.id(2093075006067377)
,p_prompt=>'Authentication Type'
,p_source=>'AUTHENTICATION_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'CREDENTIALS_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(154078822199034715)||'.'
,p_display_when=>'P1964_AUTHENTICATION_TYPE'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'An empty credential of this type will be created when a REST Data Source is created from the catalog. The credential name and secret  will need to be provided.'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2099008057067416)
,p_name=>'P1964_LAST_IMPORTED_AT'
,p_source_data_type=>'TIMESTAMP_TZ'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(2093075006067377)
,p_item_source_plug_id=>wwv_flow_imp.id(2093075006067377)
,p_prompt=>'Last Imported Date'
,p_format_mask=>'SINCE'
,p_source=>'LAST_IMPORTED_AT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(6814116013316801)
,p_validation_name=>'Name must be unique'
,p_validation_sequence=>150
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from wwv_web_src_catalog_services cs',
'where cs.security_group_id = :WORKSPACE_ID',
'and cs.catalog_id = :P1964_CATALOG_ID',
'and cs.id != nvl(:P1964_ID, 0)',
'and cs.name = :P1964_NAME;'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Name must be unique to a catalog'
,p_validation_condition=>'CREATE,SAVE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(2094668440067401)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1503996366184427)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Clear References before Delete'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_web_src_catalog.clear_catalog_references(',
'        p_catalog_id => :P1964_CATALOG_ID,',
'        p_service_id => :P1964_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2107898099067458)
,p_internal_uid=>1503996366184427
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2109810599067472)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(2093075006067377)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process form REST Catalog Service Details'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2109810599067472
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2109438564067470)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(2093075006067377)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form REST Catalog Service Details'
,p_internal_uid=>2109438564067470
);
end;
/
prompt --application/pages/page_01965
begin
wwv_flow_imp_page.create_page(
 p_id=>1965
,p_name=>'Export REST Source Catalog'
,p_alias=>'EXPORT-REST-SOURCE-CATALOG'
,p_step_title=>'Export REST Source Catalog'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_exprt_plugins.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(34199576705245056)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(12802829107)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(34199976499245057)
,p_plug_name=>'Export Settings'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_grid_column_span=>8
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(34200362051245057)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Use this page to export a REST Source Catalog. Once exported a catalog can be imported into any workspace.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(172597665096943717)
,p_plug_name=>'Export REST Source Catalog'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3738807529982498)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(172597665096943717)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:1965:&SESSION.::&DEBUG.:1965::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3738482091982497)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(172597665096943717)
,p_button_name=>'EXPORT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Export'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1804612139120717)
,p_name=>'P1965_AUDIT_INFO'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(34199976499245057)
,p_item_default=>'NONE'
,p_prompt=>'Audit Information'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'AUDIT INFO DETAIL'
,p_lov=>'.'||wwv_flow_imp.id(1726678227351632)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'None'
,p_lov_null_value=>'NONE'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the Audit Information to include in the export file. ',
'Audit information includes the Created By User, Created On Date, Changed By User and Changed On Date.<ul> ',
'<li>By default, no audit information is included.</li>',
'<li>Choose Names and Dates to include all audit information.</li>',
'<li>Choose Dates Only to include date information and exclude user details.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3735124868982490)
,p_name=>'P1965_CATALOG_ID'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(34199976499245057)
,p_prompt=>'REST Source Catalog'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name as d,',
'       id   as r',
'  from wwv_web_src_catalogs',
' where security_group_id = :WORKSPACE_ID',
' order by name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select a Catalog -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the catalog to export.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3736903539982493)
,p_name=>'P1965_FILE_CHAR_SET'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(34199976499245057)
,p_use_cache_before_default=>'NO'
,p_prompt=>'File Character Set'
,p_source=>'return lower(trim(sys.owa_util.get_cgi_env(''REQUEST_IANA_CHARSET'')));'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'I18N_IANA_CHARSET'
,p_lov=>'.'||wwv_flow_imp.id(144796827445692396)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'The export file will be encoded in the specified character set.'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3742187237982539)
,p_name=>'Submit'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3738482091982497)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3742608656982539)
,p_event_id=>wwv_flow_imp.id(3742187237982539)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'EXPORT'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3740492580982531)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'export catalog'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_web_src_catalog.export_catalog(',
'    p_catalog_id      => :P1965_CATALOG_ID, ',
'    p_with_audit_info => :P1965_AUDIT_INFO );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Catalog export failed!'
,p_process_when_button_id=>wwv_flow_imp.id(3738482091982497)
,p_process_success_message=>'Catalog exported'
,p_internal_uid=>3740492580982531
);
end;
/
prompt --application/pages/page_01966
begin
wwv_flow_imp_page.create_page(
 p_id=>1966
,p_name=>'Import REST Catalog'
,p_alias=>'IMPORT-REST-CATALOG'
,p_step_title=>'Import REST Catalog'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_install.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1465142751002221)
,p_plug_name=>'Catalog already exists'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>10
,p_plug_source=>'<p>The import file contains a catalog named <strong>&P1966_EXISTING_CATALOG_NAME!HTML.</strong> which already exists in your workspace. If you proceed with the import, the existing REST Source Catalog will be replaced.</p>'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_web_src_catalog.catalog_exists( :P1966_FILE_ID )'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(212171192300966644)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(476721091701007198)
,p_plug_name=>'Invalid File'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--danger:a-Alert--horizontal'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>30
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_imp_parser.get_rest_catalog_name(:P1966_FILE_ID) is null'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'Imported file is not a valid &PRODUCT_NAME. REST Source Catalog.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(476721281951007200)
,p_plug_name=>'import progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(37899301707472090)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(476721496008007201)
,p_plug_name=>'Import REST Catalog'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_imp_parser.get_rest_catalog_name(:P1966_FILE_ID) is not null'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(751168206714473129)
,p_plug_name=>'Import REST Catalog'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4021888407334980)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(212171192300966644)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4022297156334981)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(212171192300966644)
,p_button_name=>'IMPORT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Import REST Catalog'
,p_button_position=>'CREATE'
,p_button_condition=>'wwv_flow_imp_parser.get_rest_catalog_name(:P1966_FILE_ID) is not null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2228391266440784)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(212171192300966644)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:163:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4027937002335026)
,p_branch_name=>'Go To Page 1960'
,p_branch_action=>'f?p=&APP_ID.:1960:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(4022297156334981)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1465303439002223)
,p_name=>'P1966_EXISTING_CATALOG_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(476721496008007201)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2717702711216212)
,p_name=>'P1966_GROUP_NAME'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(476721496008007201)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * from (',
'              select name as dv, ',
'                     name as rv',
'                from wwv_web_src_catalog_groups',
'               where security_group_id = :WORKSPACE_ID',
'               order by name )',
' where rownum = 1'))
,p_item_default_type=>'SQL_QUERY'
,p_prompt=>'Catalog Group'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name as dv, ',
'       name as rv',
'  from wwv_web_src_catalog_groups',
' where security_group_id = :WORKSPACE_ID',
' order by name'))
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_web_src_catalog_groups',
' where security_group_id = :WORKSPACE_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose a Catalog Group used for organizing catalogs.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2858280615881131)
,p_name=>'P1966_NEW_GROUP_NAME'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(476721496008007201)
,p_prompt=>'Catalog Group'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'from wwv_web_src_catalog_groups',
'where security_group_id = :WORKSPACE_ID'))
,p_display_when_type=>'NOT_EXISTS'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Catalogs are organized in <em>Groups</em>. As your workspace does not contain Catalog Groups yet, please provide a name for the new group to create.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4023938922334993)
,p_name=>'P1966_FILE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(476721496008007201)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4024333787334996)
,p_name=>'P1966_FEEDBACK_ORIGIN'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(476721496008007201)
,p_use_cache_before_default=>'NO'
,p_prompt=>'REST Catalog Internal Name'
,p_source=>'wwv_flow_imp_parser.get_rest_catalog_name(:p1966_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the internal name of the imported REST Catalog. If a catalog with the same internal name already exists, it will be overwritten.'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4025106188335006)
,p_name=>'P1966_VERSION'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(476721496008007201)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Imported Version'
,p_source=>'wwv_flow_imp_parser.get_version(:p1966_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the imported file version.'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1465292170002222)
,p_computation_sequence=>10
,p_computation_item=>'P1966_EXISTING_CATALOG_NAME'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_imp_parser.get_rest_catalog_name( :P1966_FILE_ID )'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4026728745335019)
,p_validation_name=>'check import file version'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_runtime_version varchar2(200); -- the date of the current runtime flows',
'  l_calling_version varchar2(200);',
'begin',
'    l_calling_version := replace(replace(replace(wwv_flow_imp_parser.get_version (p_file_id => :p1966_file_id),''.'',null),''_'',null),''/'',null);',
'    l_runtime_version := replace(replace(replace(wwv_flows_version,''.'',null),''_'',null),''/'',null);',
'',
'    if l_calling_version > l_runtime_version then',
'        --',
'        -- version incompatability        ',
'        --',
'        ',
'        return false;',
'    else',
'        return true;',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'NOT COMPATIBLE (Your import may contain calls not supported by your &PRODUCT_NAME. version.)'
,p_associated_item=>wwv_flow_imp.id(4025106188335006)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4027100520335020)
,p_validation_name=>'not valid import file'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_imp_parser.get_rest_catalog_name(:P1966_FILE_ID) is null then',
'   return false;',
'else',
'   return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Imported file is not a valid &PRODUCT_NAME. REST Source Catalog.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4027476159335021)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'import catalog'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_web_src_catalog.import_catalog (',
'        p_group_name     => nvl(:P1966_NEW_GROUP_NAME, :P1966_GROUP_NAME),     ',
'        p_export_file_id => :P1966_FILE_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error importing REST Source Catalog.'
,p_process_when_button_id=>wwv_flow_imp.id(4022297156334981)
,p_process_success_message=>'REST Source Catalog imported.'
,p_internal_uid=>4027476159335021
);
end;
/
prompt --application/pages/page_01967
begin
wwv_flow_imp_page.create_page(
 p_id=>1967
,p_name=>'Refresh REST Source Catalog'
,p_alias=>'REFRESH-REST-SOURCE-CATALOG'
,p_page_mode=>'MODAL'
,p_step_title=>'Refresh REST Source Catalog'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3965103871098186)
,p_plug_name=>'Catalog Details'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_query_type=>'TABLE'
,p_query_table=>'WWV_WEB_SRC_CATALOGS'
,p_query_where=>'security_group_id = :WORKSPACE_ID'
,p_include_rowid_column=>false
,p_is_editable=>false
,p_plug_source_type=>'NATIVE_FORM'
,p_plug_header=>'Any local changes will be lost. Please confirm you want to refresh the REST Source Catalog. '
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3970912551098312)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1919245276109873)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(3970912551098312)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1920033366109876)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(3970912551098312)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Refresh Catalog'
,p_button_position=>'NEXT'
,p_button_condition=>'P1967_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1926773452132408)
,p_branch_name=>'Goto 1963'
,p_branch_action=>'f?p=&APP_ID.:1963:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1503148428184419)
,p_name=>'P1967_ENDPOINT_URL'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3965103871098186)
,p_item_source_plug_id=>wwv_flow_imp.id(3965103871098186)
,p_prompt=>'Refresh from URL'
,p_source=>'ENDPOINT_URL'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1911593255109861)
,p_name=>'P1967_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3965103871098186)
,p_item_source_plug_id=>wwv_flow_imp.id(3965103871098186)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_protection_level=>'S'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1911942607109863)
,p_name=>'P1967_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3965103871098186)
,p_item_source_plug_id=>wwv_flow_imp.id(3965103871098186)
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1926069115132401)
,p_name=>'P1967_LAST_IMPORTED_AT'
,p_source_data_type=>'TIMESTAMP_TZ'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(3965103871098186)
,p_item_source_plug_id=>wwv_flow_imp.id(3965103871098186)
,p_prompt=>'Last Import as of'
,p_format_mask=>'SINCE'
,p_source=>'LAST_IMPORTED_AT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6819031627316850)
,p_name=>'P1967_VERSION'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(3965103871098186)
,p_item_source_plug_id=>wwv_flow_imp.id(3965103871098186)
,p_prompt=>'Version'
,p_source=>'VERSION'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'P1967_VERSION'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1922060149109900)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1919245276109873)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1922562852109903)
,p_event_id=>wwv_flow_imp.id(1922060149109900)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1926613749132407)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh Catalog'
,p_process_sql_clob=>'wwv_web_src_catalog.refresh_catalog(:P1967_ID);'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1920033366109876)
,p_process_success_message=>'REST Source Catalog has been refreshed.'
,p_internal_uid=>1926613749132407
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1918106204109871)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(3965103871098186)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Catalog Group Details'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>1918106204109871
);
end;
/
prompt --application/pages/page_01968
begin
wwv_flow_imp_page.create_page(
 p_id=>1968
,p_name=>'REST Source Catalog Groups'
,p_alias=>'REST-SOURCE-CATALOG-GROUPS'
,p_step_title=>'REST Source Catalog Groups'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3811862513186082)
,p_plug_name=>'REST Source Catalog Groups'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select g.id, ',
'       g.name, ',
'       g.description, count(c.id) as catalog_count',
'  from wwv_web_src_catalog_groups g,',
'       wwv_web_src_catalogs       c',
' where g.id                = c.catalog_group_id (+)',
'   and g.security_group_id = :WORKSPACE_ID',
' group by g.id, g.name, g.description'))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'REST Source Catalog Groups'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(3812278197186083)
,p_name=>'Report 1'
,p_max_row_count_message=>'The maximum row count for this report is #MAX_ROW_COUNT# rows.  Please apply a filter to reduce the number of records in your query.'
,p_no_data_found_message=>'No data found.'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'DBLISS'
,p_internal_uid=>3812278197186083
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3812332130186088)
,p_db_column_name=>'ID'
,p_display_order=>0
,p_column_identifier=>'A'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3813105390186102)
,p_db_column_name=>'NAME'
,p_display_order=>10
,p_column_identifier=>'C'
,p_column_label=>'Group Name'
,p_column_link=>'f?p=&APP_ID.:1961:&SESSION.::&DEBUG.:1961:P1961_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3813569911186103)
,p_db_column_name=>'DESCRIPTION'
,p_display_order=>30
,p_column_identifier=>'D'
,p_column_label=>'Description'
,p_allow_sorting=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2983039164967547)
,p_db_column_name=>'CATALOG_COUNT'
,p_display_order=>40
,p_column_identifier=>'E'
,p_column_label=>'Catalogs Count'
,p_column_type=>'NUMBER'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(3818440699240452)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'38185'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'NAME:DESCRIPTION::CATALOG_COUNT'
,p_sort_column_1=>'NAME'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(101383551120726227)
,p_plug_name=>'About'
,p_region_css_classes=>'a-Region--stacked a-Region--padded a-Region--flush a-Region--sideRegion'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Use Catalog Groups to organize catalogs into categories.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3814992301186107)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(3811862513186082)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Group'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:1961:&SESSION.::&DEBUG.:1961::'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3813973549186104)
,p_name=>'Edit Report - Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(3811862513186082)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3814424992186106)
,p_event_id=>wwv_flow_imp.id(3813973549186104)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3811862513186082)
);
end;
/
prompt --application/pages/page_01970
begin
wwv_flow_imp_page.create_page(
 p_id=>1970
,p_name=>'Upload OpenAPI'
,p_alias=>'UPLOAD-OPENAPI'
,p_page_mode=>'MODAL'
,p_step_title=>'Upload OpenAPI'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true'
,p_protection_level=>'C'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2504611503903943)
,p_plug_name=>'Upload File'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2504950017903946)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1614284960343705)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2504950017903946)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2505045770903947)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2504950017903946)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1960:&SESSION.::&DEBUG.:RP,1960::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1614391868343706)
,p_branch_name=>'Next'
,p_branch_action=>'f?p=&APP_ID.:1971:&SESSION.::&DEBUG.:1971:P1971_COLLECTION_NAME,P1971_ENDPOINT_URL,P1971_CREDENTIAL_ID,P1971_CREDENTIAL_TYPE,P1971_TOKEN_SERVER_URL:&P1970_COLLECTION_NAME.,&P1970_TOKEN_SERVER_URL.,&P1970_CREDENTIAL_ID.,&P1970_CREDENTIAL_TYPE.,&P1970_TOKEN_SERVER_URL.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(1614284960343705)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1613816324343701)
,p_name=>'P1970_ENDPOINT_URL'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2504611503903943)
,p_prompt=>'OpenAPI Endpoint URL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the URL where the OpenAPI information is available.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'URL'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1613935439343702)
,p_name=>'P1970_PROXY_SERVER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2504611503903943)
,p_prompt=>'Proxy Server'
,p_placeholder=>'- Use default Instance Proxy -'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Proxy server to use when downloading the OpenAPI document. If not set, the &PRODUCT_NAME. instance proxy will be used, when defined.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2504729718903944)
,p_name=>'P1970_UPLOAD'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2504611503903943)
,p_prompt=>'Upload File'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Upload a OpenAPI JSON document describing the REST service. &PRODUCT_NAME. will parse this response instead of reaching out to the REST Service.'
,p_attribute_01=>'APEX_APPLICATION_TEMP_FILES'
,p_attribute_09=>'REQUEST'
,p_attribute_10=>'N'
,p_attribute_12=>'DROPZONE_BLOCK'
,p_attribute_13=>'Upload File'
,p_attribute_14=>'Select an OpenAPI document in JSON format or drop one here.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2835869312630523)
,p_name=>'P1970_COLLECTION_NAME'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(2504611503903943)
,p_item_default=>'TEMPORARY_OPENAPI_INFO'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2836107963630526)
,p_name=>'P1970_CREDENTIAL_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(2504611503903943)
,p_prompt=>'Web Credential'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LOV_CREDENTIAL_STORES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_credentials',
' where security_group_id    = :FLOW_SECURITY_GROUP_ID',
'   and authentication_type != ''KEY_PAIR'''))
,p_lov_display_null=>'YES'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_credentials',
' where security_group_id = :WORKSPACE_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the Web Credentials to use, when refreshing a catalog. Use this if the refresh endpoint URL requires authentication.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2836249178630527)
,p_name=>'P1970_CREDENTIAL_TYPE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(2504611503903943)
,p_prompt=>'Authentication Type'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CREDENTIALS_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(154078822199034715)||'.'
,p_cHeight=>1
,p_tag_attributes=>'disabled'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_credentials',
' where security_group_id = :WORKSPACE_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Type of the Web Credential to use for authentication.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2836342226630528)
,p_name=>'P1970_TOKEN_SERVER_URL'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(2504611503903943)
,p_prompt=>'Token Server URL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_credentials',
' where security_group_id = :WORKSPACE_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Provide the URL of a token server, if the <strong>OAuth2 Client Credentials</strong> flow is used to authenticate for the refresh endpoint URL.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'URL'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1614099698343703)
,p_validation_name=>'URL must start with HTTP or HTTPS'
,p_validation_sequence=>10
,p_validation=>':P1970_ENDPOINT_URL like ''http://%'' or :P1970_ENDPOINT_URL like ''https://%'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'#LABEL# must start with http:// or https://'
,p_validation_condition=>'P1970_ENDPOINT_URL'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(1614284960343705)
,p_associated_item=>wwv_flow_imp.id(1613816324343701)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1614447227343707)
,p_validation_name=>'Upload or Download used'
,p_validation_sequence=>20
,p_validation=>':P1970_UPLOAD is not null'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'#LABEL# or OpenAPI Endpoint URL must be used.'
,p_validation_condition=>'P1970_ENDPOINT_URL'
,p_validation_condition_type=>'ITEM_IS_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(1614284960343705)
,p_associated_item=>wwv_flow_imp.id(2504729718903944)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3261840713306309)
,p_validation_name=>'Upload or Download Used'
,p_validation_sequence=>30
,p_validation=>':P1970_ENDPOINT_URL is not null'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Upload File or #LABEL# must be used.'
,p_validation_condition=>'P1970_UPLOAD'
,p_validation_condition_type=>'ITEM_IS_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(1614284960343705)
,p_associated_item=>wwv_flow_imp.id(1613816324343701)
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2835244284630517)
,p_name=>'Endpoint URL entered'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1970_ENDPOINT_URL'
,p_condition_element=>'P1970_ENDPOINT_URL'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2835365290630518)
,p_event_id=>wwv_flow_imp.id(2835244284630517)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1970_PROXY_SERVER,P1970_CREDENTIAL_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2835417458630519)
,p_event_id=>wwv_flow_imp.id(2835244284630517)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1970_PROXY_SERVER,P1970_CREDENTIAL_ID,P1970_CREDENTIAL_TYPE,P1970_TOKEN_SERVER_URL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2835518510630520)
,p_event_id=>wwv_flow_imp.id(2835244284630517)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Clear Value'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1970_PROXY_SERVER,P1970_CREDENTIAL_ID,P1970_CREDENTIAL_TYPE,P1970_TOKEN_SERVER_URL'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2836437515630529)
,p_name=>'Credential chosen'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1970_CREDENTIAL_ID'
,p_condition_element=>'P1970_CREDENTIAL_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2836511146630530)
,p_event_id=>wwv_flow_imp.id(2836437515630529)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1970_CREDENTIAL_TYPE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2836696873630531)
,p_event_id=>wwv_flow_imp.id(2836437515630529)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1970_CREDENTIAL_TYPE,P1970_TOKEN_SERVER_URL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2836776343630532)
,p_event_id=>wwv_flow_imp.id(2836437515630529)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Clear Value'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1970_CREDENTIAL_TYPE,P1970_TOKEN_SERVER_URL'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2836843578630533)
,p_event_id=>wwv_flow_imp.id(2836437515630529)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1970_CREDENTIAL_TYPE'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select authentication_type',
'  from wwv_credentials',
' where id                = :P1970_CREDENTIAL_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_attribute_07=>'P1970_CREDENTIAL_ID'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2836904084630534)
,p_name=>'OAuth Creds'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1970_CREDENTIAL_TYPE'
,p_condition_element=>'P1970_CREDENTIAL_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'OAUTH2_CLIENT_CREDENTIALS'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2837070992630535)
,p_event_id=>wwv_flow_imp.id(2836904084630534)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1970_TOKEN_SERVER_URL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2837145781630536)
,p_event_id=>wwv_flow_imp.id(2836904084630534)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1970_TOKEN_SERVER_URL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2837279467630537)
,p_event_id=>wwv_flow_imp.id(2836904084630534)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Clear Value'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1970_TOKEN_SERVER_URL'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1614530959343708)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'get, validate and store document'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_document   blob;',
'begin',
'    if :P1970_UPLOAD is not null then',
'        select blob_content ',
'          into l_document',
'          from wwv_flow_temp_files',
'         where name = :P1970_UPLOAD;',
'',
'    elsif :P1970_ENDPOINT_URL is not null then',
'',
'        l_document := wwv_flow_webservices_api.make_rest_request_b(',
'                          p_url                  => :P1970_ENDPOINT_URL,',
'                          p_http_method          => ''GET'',',
'                          p_proxy_override       => :P1970_PROXY_SERVER,',
'                          p_credential_static_id => :P1970_CREDENTIAL_ID,',
'                          p_token_url            => :P1970_TOKEN_SERVER_URL );',
'',
'    end if;',
'',
'    wwv_flow_web_src_openapi.store_and_validate_openapi( l_document, :P1970_COLLECTION_NAME );',
'',
'end;',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>1614530959343708
);
end;
/
prompt --application/pages/page_01971
begin
wwv_flow_imp_page.create_page(
 p_id=>1971
,p_name=>'Catalog from OpenAPI'
,p_alias=>'CATALOG-FROM-OPENAPI'
,p_page_mode=>'MODAL'
,p_step_title=>'Catalog from OpenAPI'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1615588803343718)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1616786405343730)
,p_plug_name=>'Catalog Details'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>110
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3261920486306310)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1615588803343718)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1615613061343719)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1615588803343718)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1615416778343717)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1615588803343718)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1970:&SESSION.::&DEBUG.:1970::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2835641657630521)
,p_branch_name=>'Next'
,p_branch_action=>'f?p=&APP_ID.:1972:&SESSION.::&DEBUG.:1972:P1972_WEB_SOURCE_TYPE:&P1971_DEFAULT_TYPE.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(1615613061343719)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1614649934343709)
,p_name=>'P1971_CATALOG_GROUP_ID'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1616786405343730)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'from (select id',
'        from wwv_web_src_catalog_groups ',
'       where security_group_id = :WORKSPACE_ID)',
'order by 1'))
,p_item_default_type=>'SQL_QUERY'
,p_prompt=>'Group'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name as dv, id as rv ',
'from wwv_web_src_catalog_groups ',
'where security_group_id = :WORKSPACE_ID',
'order by name'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a group to organize the catalog and assist developers when creating services.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1614718704343710)
,p_name=>'P1971_NAME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(1616786405343730)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Catalog names must be unique to a workspace.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1614844453343711)
,p_name=>'P1971_INTERNAL_NAME'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(1616786405343730)
,p_prompt=>'Internal Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The Internal Name is used to identify a catalog across multiple APEX instances. If a catalog is imported, and a catalog with the same internal name already exists, then the existing catalog will be overwritten.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_attribute_06=>'UPPER'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1614944714343712)
,p_name=>'P1971_DESCRIPTION'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(1616786405343730)
,p_prompt=>'Description'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Describe the REST Source Catalog'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1615007886343713)
,p_name=>'P1971_CATALOG_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1616786405343730)
,p_prompt=>'Catalog'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name as dv, id as rv',
'  from wwv_web_src_catalogs c',
' where security_group_id = :WORKSPACE_ID',
'   and catalog_group_id  = :P1971_CATALOG_GROUP_ID',
'order by name',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Create New Catalog'
,p_lov_cascade_parent_items=>'P1971_CATALOG_GROUP_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select an existing catalog to update all services within that catalog or select "Create New Catalog".'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1615126629343714)
,p_name=>'P1971_DEFAULT_TYPE'
,p_is_required=>true
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(1616786405343730)
,p_item_default=>'NATIVE_HTTP'
,p_prompt=>'Default REST Source Type'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,',
'       r',
'  from (',
'         select wwv_flow_lang.system_message(''WEB_SOURCE.''|| name_with_prefix) as d,',
'               name_with_prefix as r',
'          from wwv_flow_native_plugins',
'         where plugin_type = ''WEB SOURCE TYPE''',
'           and name_with_prefix != ''NATIVE_REST_ENABLED_SQL_QUERY''',
'         union all',
'        select display_name || wwv_flow_lang.system_message(''PLUGIN.DISPLAY_NAME_POSTFIX'') as d,',
'               ''PLUGIN_'' || name     as r',
'          from wwv_flow_plugins',
'         where flow_id           = to_number(:FB_FLOW_ID)',
'           and security_group_id = to_number(:WORKSPACE_ID)',
'           and plugin_type       = ''WEB SOURCE TYPE''',
'       )',
' order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'A REST Data Source is created from the catalog of this type.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1615269650343715)
,p_name=>'P1971_DEFAULT_AUTHENTICATION'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(1616786405343730)
,p_prompt=>'Default Authentication'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CREDENTIALS_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(154078822199034715)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'No Authentication'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'An empty credential of this type will be created when a REST Data Source is created from the catalog. The credential name and secret  will need to be provided at that time.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1615305470343716)
,p_name=>'P1971_ENDPOINT_URL'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(1616786405343730)
,p_prompt=>'Catalog Refresh URL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Provide a URL where the catalog export file can be downloaded from, in order to refresh the REST Source Catalog.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'URL'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1616087496343723)
,p_name=>'P1971_PROXY_SERVER'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(1616786405343730)
,p_prompt=>'Proxy Server'
,p_placeholder=>'- Use default Instance Proxy -'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Proxy server to use when refreshing the REST Source Catalog. If not set, the &PRODUCT_NAME. instance proxy will be used, when defined.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1616656431343729)
,p_name=>'P1971_CREDENTIAL_ID'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(1616786405343730)
,p_prompt=>'Web Credential'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LOV_CREDENTIAL_STORES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_credentials',
' where security_group_id    = :FLOW_SECURITY_GROUP_ID',
'   and authentication_type != ''KEY_PAIR'''))
,p_lov_display_null=>'YES'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_credentials',
' where security_group_id = :WORKSPACE_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the Web Credentials to use, when refreshing a catalog. Use this if the refresh endpoint URL requires authentication.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1616829608343731)
,p_name=>'P1971_CREDENTIAL_TYPE'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(1616786405343730)
,p_prompt=>'Authentication Type'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CREDENTIALS_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(154078822199034715)||'.'
,p_cHeight=>1
,p_tag_attributes=>'disabled'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_credentials',
' where security_group_id = :WORKSPACE_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Type of the Web Credential to use, when refreshing the catalog.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1617253335343735)
,p_name=>'P1971_TOKEN_SERVER_URL'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(1616786405343730)
,p_prompt=>'Token Server URL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_credentials',
' where security_group_id = :WORKSPACE_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Provide the URL of a token server, if the <strong>OAuth2 Client Credentials</strong> flow is used when the catalog is refreshed.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'URL'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2835762977630522)
,p_name=>'P1971_COLLECTION_NAME'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(1616786405343730)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2837354057630538)
,p_name=>'P1971_APPLICATION_ID'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(1616786405343730)
,p_prompt=>'Application'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'        select a.name as d,',
'               a.id   as r',
'          from wwv_flow_plugins p,',
'               wwv_flows        a',
'         where p.security_group_id = to_number(:WORKSPACE_ID)',
'           and p.plugin_type       = ''WEB SOURCE TYPE''',
'           and p.name              = substr( :P1971_DEFAULT_TYPE, 8 )',
'           --',
'           and a.security_group_id = to_number(:WORKSPACE_ID)',
'           and a.id                = p.flow_id',
''))
,p_lov_cascade_parent_items=>'P1971_DEFAULT_TYPE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Provide the <strong>Application</strong> which contains <strong>Default Type</strong>'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2838044324630545)
,p_name=>'P1971_BASE_URL'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(1616786405343730)
,p_prompt=>'Base URL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_display_when=>'P1971_NEED_REMOTE_SERVER'
,p_display_when2=>'Y'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The URL endpoint of the REST Data Source will consist of the Base URL (starting with http:// or https://) and the service path suffix being appended to that. The Base URL is being stored as a Remote Server object and can be shared between multiple'
||' REST Data Sources. Note that the Base URL can (and frequently should) be more than just the server name and the port. Most often the first parts of the URL path (for example, the context root) are also server-specific.</p>',
'<p>Examples:</p>',
'<ul>',
'    <li>http://api.example.com:8080/myservices/test/</li>',
'    <li>https://api.example.com/ords/scott/</li>',
'</ul>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'URL'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2838172379630546)
,p_name=>'P1971_REMOTE_SERVER_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(1616786405343730)
,p_prompt=>'Remote Server'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEB_SOURCE_REMOTE_SERVERS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_remote_servers',
' where server_type = ''WEB_SERVICE''',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Create New Remote Server'
,p_cHeight=>1
,p_display_when=>'P1971_NEED_REMOTE_SERVER'
,p_display_when2=>'Y'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Choose an existing <strong>Remote Server</strong> object. The HTTP Endpoint URL of a REST Data Source consists of the remote server (<strong>Base URL</strong>) and the service specific part. Remote Servers are stored as separate Entities. When multip'
||'le REST Data Sources share the same remote server, they can easily be redirected to another physical location (for example, from test to production) by just changing the base URL within the Remote Server definition.',
''))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2838213062630547)
,p_name=>'P1971_REMOTE_SERVER_URL'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(1616786405343730)
,p_prompt=>'Base URL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'P1971_NEED_REMOTE_SERVER'
,p_display_when2=>'Y'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The URL endpoint of the REST Data Source will consist of the Base URL (starting with http:// or https://) and the service path suffix being appended to that. The Base URL is being stored as a Remote Server object and can be shared between multiple'
||' REST Data Sources. Note that the Base URL can (and frequently should) be more than just the server name and the port. Most often the first parts of the URL path (for example, the context root) are also server-specific.</p>',
'<p>Examples:</p>',
'<ul>',
'    <li>http://api.example.com:8080/myservices/test/</li>',
'    <li>https://api.example.com/ords/scott/</li>',
'</ul>'))
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3261481985306305)
,p_name=>'P1971_NEED_REMOTE_SERVER'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(1616786405343730)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(122067968900718222)
,p_name=>'P1971_DEFAULT_TOKEN_SERVER_URL'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(1616786405343730)
,p_prompt=>'Default Token Server URL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Provide the URL of a token server. This token server is to be used for REST APIs within the OpenAPI file, which are protected by an <strong>OAuth2 Client Credentials</strong> authentication flow.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1616159074343724)
,p_validation_name=>'Catalog Refresh URL must start with http(s)://'
,p_validation_sequence=>10
,p_validation=>':P1971_ENDPOINT_URL like ''http://%'' or :P1971_ENDPOINT_URL like ''https://%'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'#LABEL# must start with http:// or https://'
,p_validation_condition=>'P1971_ENDPOINT_URL'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(1615613061343719)
,p_associated_item=>wwv_flow_imp.id(1615305470343716)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2834963578630514)
,p_validation_name=>'Name must be unique'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null ',
'  from wwv_web_src_catalogs c',
' where security_group_id = :WORKSPACE_ID',
'   and id   != nvl(:P1971_CATALOG_ID,-id)',
'   and name  = :P1971_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#LABEL# must be unique in the workspace.'
,p_validation_condition=>'P1971_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(1615613061343719)
,p_associated_item=>wwv_flow_imp.id(1614718704343710)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2835065121630515)
,p_validation_name=>'Internal Name must be unique'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null ',
'  from wwv_web_src_catalogs c',
' where security_group_id = :WORKSPACE_ID',
'   and id   != nvl(:P1971_CATALOG_ID,-id)',
'   and internal_name  = :P1971_INTERNAL_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#LABEL# must be unique in the workspace.'
,p_validation_condition=>'P1971_INTERNAL_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(1615613061343719)
,p_associated_item=>wwv_flow_imp.id(1614844453343711)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3261380867306304)
,p_validation_name=>'Base URL starts with http(s)://'
,p_validation_sequence=>40
,p_validation=>':P1971_BASE_URL like ''http://%'' or :P1971_BASE_URL like ''https://%'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'#LABEL# must start with http:// or https://'
,p_validation_condition=>'P1971_BASE_URL'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_imp.id(2838044324630545)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3261719395306308)
,p_validation_name=>'Base URL required'
,p_validation_sequence=>60
,p_validation=>'P1971_BASE_URL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>':P1971_NEED_REMOTE_SERVER = ''Y'' and :P1971_REMOTE_SERVER_ID is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(2838044324630545)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1801041618011701)
,p_validation_name=>'Default Token Server  URL required'
,p_validation_sequence=>70
,p_validation=>'P1971_DEFAULT_TOKEN_SERVER_URL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>':P1971_DEFAULT_AUTHENTICATION = wwv_flow_credential_api.c_type_oauth_client_cred'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(122067968900718222)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1801103925011702)
,p_validation_name=>'Default Token Server URL starts with http(s)://'
,p_validation_sequence=>80
,p_validation=>':P1971_DEFAULT_TOKEN_SERVER_URL like ''http://%'' or :P1971_DEFAULT_TOKEN_SERVER_URL like ''https://%'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'#LABEL# must start with http:// or https://'
,p_validation_condition=>'P1971_DEFAULT_TOKEN_SERVER_URL'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_imp.id(122067968900718222)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1616236013343725)
,p_name=>'Refresh URL entered'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1971_ENDPOINT_URL'
,p_condition_element=>'P1971_ENDPOINT_URL'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1616331772343726)
,p_event_id=>wwv_flow_imp.id(1616236013343725)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1971_PROXY_SERVER,P1971_CREDENTIAL_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1616453040343727)
,p_event_id=>wwv_flow_imp.id(1616236013343725)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1971_PROXY_SERVER,P1971_CREDENTIAL_ID,P1971_CREDENTIAL_TYPE,P1971_TOKEN_SERVER_URL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1616571230343728)
,p_event_id=>wwv_flow_imp.id(1616236013343725)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Clear Value'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1971_PROXY_SERVER,P1971_CREDENTIAL_ID,P1971_CREDENTIAL_TYPE,P1971_TOKEN_SERVER_URL'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1616967007343732)
,p_name=>'Credential chosen'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1971_CREDENTIAL_ID'
,p_condition_element=>'P1971_CREDENTIAL_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1617076633343733)
,p_event_id=>wwv_flow_imp.id(1616967007343732)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1971_CREDENTIAL_TYPE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1617108265343734)
,p_event_id=>wwv_flow_imp.id(1616967007343732)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1971_CREDENTIAL_TYPE,P1971_TOKEN_SERVER_URL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1617339261343736)
,p_event_id=>wwv_flow_imp.id(1616967007343732)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Set Value'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1971_CREDENTIAL_TYPE'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select authentication_type',
'  from wwv_credentials',
' where id                = :P1971_CREDENTIAL_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_attribute_07=>'P1971_CREDENTIAL_ID'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1617413722343737)
,p_event_id=>wwv_flow_imp.id(1616967007343732)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Clear Value'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1971_CREDENTIAL_TYPE,P1971_TOKEN_SERVER_URL'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1617513081343738)
,p_name=>'OAuth Creds'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1971_CREDENTIAL_TYPE'
,p_condition_element=>'P1971_CREDENTIAL_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'OAUTH2_CLIENT_CREDENTIALS'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1617667459343739)
,p_event_id=>wwv_flow_imp.id(1617513081343738)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1971_TOKEN_SERVER_URL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1617716563343740)
,p_event_id=>wwv_flow_imp.id(1617513081343738)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Hide'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1971_TOKEN_SERVER_URL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1617835119343741)
,p_event_id=>wwv_flow_imp.id(1617513081343738)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Clear Value'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1971_TOKEN_SERVER_URL'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2837442910630539)
,p_name=>'Refresh Default Type entered'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1971_DEFAULT_TYPE'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>' apex.item( "P1971_DEFAULT_TYPE" ).getValue().substring( 0, 7 ) === "PLUGIN_"'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2837508315630540)
,p_event_id=>wwv_flow_imp.id(2837442910630539)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1971_APPLICATION_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2837888787630543)
,p_event_id=>wwv_flow_imp.id(2837442910630539)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1971_APPLICATION_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2837910499630544)
,p_event_id=>wwv_flow_imp.id(2837442910630539)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Clear Value'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1971_APPLICATION_ID'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2838396873630548)
,p_name=>'Remote Server ID chosen'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1971_REMOTE_SERVER_ID'
,p_condition_element=>'P1971_REMOTE_SERVER_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2838479003630549)
,p_event_id=>wwv_flow_imp.id(2838396873630548)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1971_REMOTE_SERVER_URL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3261226062306303)
,p_event_id=>wwv_flow_imp.id(2838396873630548)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1971_REMOTE_SERVER_URL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2838513343630550)
,p_event_id=>wwv_flow_imp.id(2838396873630548)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1971_BASE_URL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3261112957306302)
,p_event_id=>wwv_flow_imp.id(2838396873630548)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1971_BASE_URL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3261039670306301)
,p_event_id=>wwv_flow_imp.id(2838396873630548)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1971_REMOTE_SERVER_URL,P1971_BASE_URL'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select base_url',
'  from wwv_remote_servers',
' where id     = :P1971_REMOTE_SERVER_ID',
'  and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_attribute_07=>'P1971_REMOTE_SERVER_ID'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3262042084306311)
,p_name=>'Cancel Dialog'
,p_event_sequence=>60
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3261920486306310)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3262176918306312)
,p_event_id=>wwv_flow_imp.id(3262042084306311)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3262231216306313)
,p_name=>'Catalog ID chosen'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1971_CATALOG_ID'
,p_condition_element=>'P1971_CATALOG_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3262379932306314)
,p_event_id=>wwv_flow_imp.id(3262231216306313)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1971_NAME,P1971_INTERNAL_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3262481502306315)
,p_event_id=>wwv_flow_imp.id(3262231216306313)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1971_NAME,P1971_INTERNAL_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3262577642306316)
,p_event_id=>wwv_flow_imp.id(3262231216306313)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Set  Name'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1971_NAME'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name',
'  from wwv_web_src_catalogs c',
' where security_group_id = :WORKSPACE_ID',
'   and id  = :P1971_CATALOG_ID',
'',
''))
,p_attribute_07=>'P1971_CATALOG_ID'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3262638290306317)
,p_event_id=>wwv_flow_imp.id(3262231216306313)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Set Internal Name'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1971_INTERNAL_NAME'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select internal_name',
'  from wwv_web_src_catalogs c',
' where security_group_id = :WORKSPACE_ID',
'   and id  = :P1971_CATALOG_ID'))
,p_attribute_07=>'P1971_CATALOG_ID'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(122068018250718223)
,p_name=>'Default Authentication is OAuth'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P1971_DEFAULT_AUTHENTICATION'
,p_condition_element=>'P1971_DEFAULT_AUTHENTICATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'OAUTH2_CLIENT_CREDENTIALS'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(122068110246718224)
,p_event_id=>wwv_flow_imp.id(122068018250718223)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1971_DEFAULT_TOKEN_SERVER_URL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(122068234713718225)
,p_event_id=>wwv_flow_imp.id(122068018250718223)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1971_DEFAULT_TOKEN_SERVER_URL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(122068318916718226)
,p_event_id=>wwv_flow_imp.id(122068018250718223)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P1971_DEFAULT_TOKEN_SERVER_URL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1615976049343722)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load data from APEX Collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select substr( c.c001, 1, 255 ),',
'       replace( substr( c.c001, 1, 255 ), '' '', ''_'' ),',
'       c.c002,',
'       c.c003',
'  into :P1971_NAME,',
'       :P1971_INTERNAL_NAME,',
'       :P1971_DESCRIPTION,',
'       :P1971_NEED_REMOTE_SERVER',
'from wwv_flow_collections c',
'where c.collection_name = :P1971_COLLECTION_NAME'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>1615976049343722
);
end;
/
prompt --application/pages/page_01972
begin
wwv_flow_imp_page.create_page(
 p_id=>1972
,p_name=>'REST Source Type Default Parameters'
,p_alias=>'REST-SOURCE-TYPE-DEFAULT-PARAMETERS'
,p_page_mode=>'MODAL'
,p_step_title=>'REST Source Type Default Parameters'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2834411303630509)
,p_plug_name=>'Add Javascript code for Plugins'
,p_region_name=>'PLUGIN'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    -- create the onChange event for the P1972_WEB_SOURCE_TYPE and',
'    -- also the initialization code for the dynamic attributes',
'    wwv_flow_plugin_dev.add_onload_code (',
'        p_plugin_type         => wwv_flow_plugin.c_plugin_type_web_source,',
'        p_type_page_item_name => ''P1972_WEB_SOURCE_TYPE'',',
'        p_page_item_prefix    => ''P1972_'',',
'        p_is_wizard           => false',
'    );',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2834698388630511)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(351102163048342320)
,p_plug_name=>'Default Parameters'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>40
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P1972_WEB_SOURCE_TYPE'
,p_plug_display_when_cond2=>'NATIVE_REST_ENABLED_SQL_QUERY'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3262740591306318)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2834698388630511)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2834873132630513)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2834698388630511)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2834784921630512)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2834698388630511)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:1971:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1618007517343743)
,p_name=>'P1972_WEB_SOURCE_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(351102163048342320)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4102023694957888)
,p_name=>'P1972_ATTRIBUTE_01'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(351102163048342320)
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 1, :P1972_ATTRIBUTE_01 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4102424285957890)
,p_name=>'P1972_ATTRIBUTE_02'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(351102163048342320)
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 2, :P1972_ATTRIBUTE_02 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4102883498957890)
,p_name=>'P1972_ATTRIBUTE_03'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(351102163048342320)
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 3, :P1972_ATTRIBUTE_03 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4103221592957891)
,p_name=>'P1972_ATTRIBUTE_04'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(351102163048342320)
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 4, :P1972_ATTRIBUTE_04 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4103697894957891)
,p_name=>'P1972_ATTRIBUTE_05'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(351102163048342320)
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 5, :P1972_ATTRIBUTE_05 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4104014799957891)
,p_name=>'P1972_ATTRIBUTE_06'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(351102163048342320)
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 6, :P1972_ATTRIBUTE_06 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4104432582957891)
,p_name=>'P1972_ATTRIBUTE_07'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(351102163048342320)
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 7, :P1972_ATTRIBUTE_07 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4104873029957891)
,p_name=>'P1972_ATTRIBUTE_08'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(351102163048342320)
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 8, :P1972_ATTRIBUTE_08 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4105228034957891)
,p_name=>'P1972_ATTRIBUTE_09'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(351102163048342320)
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 9, :P1972_ATTRIBUTE_09 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4105684919957892)
,p_name=>'P1972_ATTRIBUTE_10'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(351102163048342320)
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 10, :P1972_ATTRIBUTE_10 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4106009946957892)
,p_name=>'P1972_ATTRIBUTE_11'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(351102163048342320)
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 11, :P1972_ATTRIBUTE_11 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4106415573957892)
,p_name=>'P1972_ATTRIBUTE_12'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(351102163048342320)
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 12, :P1972_ATTRIBUTE_12 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4106826483957892)
,p_name=>'P1972_ATTRIBUTE_13'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(351102163048342320)
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 13, :P1972_ATTRIBUTE_13 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4107256765957892)
,p_name=>'P1972_ATTRIBUTE_14'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(351102163048342320)
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 14, :P1972_ATTRIBUTE_14 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4107654570957893)
,p_name=>'P1972_ATTRIBUTE_15'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(351102163048342320)
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 15, :P1972_ATTRIBUTE_15 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3262831998306319)
,p_name=>'Cancel  Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3262740591306318)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3262916169306320)
,p_event_id=>wwv_flow_imp.id(3262831998306319)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2835910730630524)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Catalog from OpenAPI'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_openapi clob;',
'begin',
'    select c.clob001',
'      into l_openapi',
'      from wwv_flow_collections c',
'     where c.collection_name = :P1971_COLLECTION_NAME;',
'',
'    wwv_web_src_catalog.catalog_from_openapi (',
'        p_openapi                         => l_openapi,',
'        p_id                              => :P1971_CATALOG_ID,',
'        p_group_id                        => :P1971_CATALOG_GROUP_ID,',
'        p_internal_name                   => :P1971_INTERNAL_NAME,',
'        p_name                            => :P1971_NAME,',
'        p_description                     => :P1971_DESCRIPTION,',
'        p_base_url                        => :P1971_BASE_URL,',
'        --',
'        p_endpoint_url                    => :P1971_ENDPOINT_URL,',
'        p_proxy_server                    => :P1971_PROXY_SERVER,',
'        p_token_server_url                => :P1971_TOKEN_SERVER_URL,',
'        p_credential_id                   => :P1971_CREDENTIAL_ID,',
'        --',
'        p_default_plugin_internal_name    => :P1971_DEFAULT_TYPE,',
'        p_application_id                  => :P1971_APPLICATION_ID,',
'        p_default_authentication_type     => :P1971_DEFAULT_AUTHENTICATION,',
'        p_default_token_server_url        => :P1971_DEFAULT_TOKEN_SERVER_URL,',
'        --',
'        p_attribute_01                    => :P1972_ATTRIBUTE_01,',
'        p_attribute_02                    => :P1972_ATTRIBUTE_02,',
'        p_attribute_03                    => :P1972_ATTRIBUTE_03,',
'        p_attribute_04                    => :P1972_ATTRIBUTE_04,',
'        p_attribute_05                    => :P1972_ATTRIBUTE_05,',
'        p_attribute_06                    => :P1972_ATTRIBUTE_06,',
'        p_attribute_07                    => :P1972_ATTRIBUTE_07,',
'        p_attribute_08                    => :P1972_ATTRIBUTE_08,',
'        p_attribute_09                    => :P1972_ATTRIBUTE_09,',
'        p_attribute_10                    => :P1972_ATTRIBUTE_10,',
'        p_attribute_11                    => :P1972_ATTRIBUTE_11,',
'        p_attribute_12                    => :P1972_ATTRIBUTE_12,',
'        p_attribute_13                    => :P1972_ATTRIBUTE_13,',
'        p_attribute_14                    => :P1972_ATTRIBUTE_14,',
'        p_attribute_15                    => :P1972_ATTRIBUTE_15 );',
'end;',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2834873132630513)
,p_internal_uid=>2835910730630524
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2836095819630525)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2836095819630525
);
end;
/
prompt --application/pages/page_02100
begin
wwv_flow_imp_page.create_page(
 p_id=>2100
,p_name=>'Install Application - Supporting Objects'
,p_alias=>'INSTALL-APPLICATION-SUPPORTING-OBJECTS'
,p_step_title=>'Install Application - Supporting Objects'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(24907316279669450)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_pa_install_obj.htm'
,p_page_component_map=>'25'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2106775361185424)
,p_plug_name=>'Application Installed'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>40
,p_plug_item_display_point=>'BELOW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17569803193429308)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(37438506954816730)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P2100_MULTISTEP_YN'
,p_plug_display_when_cond2=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17569985543429309)
,p_plug_name=>'&P2100_PAGE_NAME.'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17570062257429310)
,p_plug_name=>'Instructions'
,p_region_css_classes=>'a-Wizard-region--simple'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>30
,p_plug_item_display_point=>'BELOW'
,p_function_body_language=>'PLSQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_lang.message( ''INSTALLER.APP_HAS_SUPPORTING_OBJECTS'' ) || '' '' ||',
'    case :P2100_MULTISTEP_YN',
'      when ''Y'' then',
'        wwv_flow_lang.message( ''INSTALLER.NEXT_SUPPORTING_OBJECTS'', ',
'                                wwv_flow_utilities.prepare_url( ''f?p='' || :APP_ID || '':2109:'' || :APP_SESSION || ''::::P2109_MODE:INSTALL'' ) )',
'      else',
'        wwv_flow_lang.message( ''INSTALLER.INSTALL_SUPPORTING_OBJECTS'', ',
'                                wwv_flow_utilities.prepare_url( ''f?p='' || :APP_ID || '':2109:'' || :APP_SESSION || ''::::P2109_MODE:INSTALL'' ) )',
'    end;'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(186903532355527837)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2107444086185431)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(186903532355527837)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_execute_validations=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2107160401185428)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(186903532355527837)
,p_button_name=>'EDIT_APP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Edit Application'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::'
,p_button_condition=>'P49_BUILD_STATUS'
,p_button_condition2=>'RUN_AND_BUILD'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(37336001160486106)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(186903532355527837)
,p_button_name=>'INSTALL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Install Supporting Objects'
,p_button_position=>'NEXT'
,p_button_condition=>'P2100_MULTISTEP_YN'
,p_button_condition2=>'N'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(17570370505429313)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(186903532355527837)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_button_condition=>'P2100_MULTISTEP_YN'
,p_button_condition2=>'Y'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(11348931511909152)
,p_branch_name=>'Go To Page 2115 - error'
,p_branch_action=>'f?p=&APP_ID.:2115:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':P2100_AVAILABLE_SPACE||:P2100_PRIV_ERROR||:P2100_ERROR is not null'
,p_branch_condition_text=>'SQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(37336307162486109)
,p_branch_name=>'Go To Page 2101 - license'
,p_branch_action=>'f?p=&APP_ID.:2101:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(17570370505429313)
,p_branch_sequence=>40
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install ',
'where license_message is not null',
'  and flow_id = :FB_FLOW_ID',
'  and security_group_id = :flow_security_group_id'))
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3256723713962127)
,p_branch_name=>'Go To Page 2103 - sub strings'
,p_branch_action=>'f?p=&APP_ID.:2103:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(17570370505429313)
,p_branch_sequence=>50
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where replace(prompt_substitution_01_yn||',
'                 prompt_substitution_02_yn||',
'                 prompt_substitution_03_yn||',
'                 prompt_substitution_04_yn||',
'                 prompt_substitution_05_yn||',
'                 prompt_substitution_06_yn||',
'                 prompt_substitution_07_yn||',
'                 prompt_substitution_08_yn||',
'                 prompt_substitution_09_yn||',
'                 prompt_substitution_10_yn||',
'                 prompt_substitution_11_yn||',
'                 prompt_substitution_12_yn||',
'                 prompt_substitution_13_yn||',
'                 prompt_substitution_14_yn||',
'                 prompt_substitution_15_yn||',
'                 prompt_substitution_16_yn||',
'                 prompt_substitution_17_yn||',
'                 prompt_substitution_18_yn||',
'                 prompt_substitution_19_yn||',
'                 prompt_substitution_20_yn,''N'','''') is not null',
'   and flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(13610511055251610)
,p_branch_name=>'Go To Page 2107 - build options'
,p_branch_action=>'f?p=&APP_ID.:2107:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(17570370505429313)
,p_branch_sequence=>60
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install_build_opt',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(13612312571261528)
,p_branch_name=>'Go To Page 2102 - validations'
,p_branch_action=>'f?p=&APP_ID.:2102:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(17570370505429313)
,p_branch_sequence=>70
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install_checks',
' where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(13575105664060846)
,p_branch_name=>'Go To Page 2116 - installing'
,p_branch_action=>'f?p=&APP_ID.:2116:&SESSION.::&DEBUG.:2116::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(37336001160486106)
,p_branch_sequence=>80
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(17569356459429303)
,p_branch_name=>'Cancel'
,p_branch_action=>'f?p=&APP_ID.:&P2100_CANCEL_PAGE.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2107444086185431)
,p_branch_sequence=>90
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2106861533185425)
,p_name=>'P2100_APP_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2106775361185424)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FLOW_ID.'
,p_prompt=>'Application'
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2107548121185432)
,p_name=>'P2100_CANCEL_PAGE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(2106775361185424)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if :P49_BUILD_STATUS = ''RUN_ONLY'' then',
'        return 1500;',
'    else',
'        return 1;',
'    end if;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17570138414429311)
,p_name=>'P2100_PAGE_NAME'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(2106775361185424)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17570284658429312)
,p_name=>'P2100_MULTISTEP_YN'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(2106775361185424)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(38881611317544045)
,p_name=>'P2100_PARSING_SCHEMA'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2106775361185424)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Parsing Schema'
,p_source=>'select owner from wwv_flows where id = :fb_flow_id and security_group_id = :flow_security_group_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Identifies the schema that will be used to parse and execute all SQL within this application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(38993601601790274)
,p_name=>'P2100_ERROR'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(2106775361185424)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(39398131871551592)
,p_name=>'P2100_AVAILABLE_SPACE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(2106775361185424)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(39510309884283270)
,p_name=>'P2100_FREE_SPACE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2106775361185424)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Free Space Required in KB'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select to_char(nvl(REQUIRED_FREE_KB,0),''999G999G999G999G999G990'') free_kb from wwv_flow_install ',
' where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The following freespace must be available in the parsing schema''s default tablespace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(39517702125545937)
,p_name=>'P2100_PRIV_ERROR'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(2106775361185424)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(39014925514948540)
,p_validation_name=>'application exists'
,p_validation_sequence=>10
,p_validation=>'select 1 from wwv_flows where id = :fb_flow_id and security_group_id = :flow_security_group_id'
,p_validation_type=>'EXISTS'
,p_error_message=>'Application must be installed.'
,p_when_button_pressed=>wwv_flow_imp.id(37336001160486106)
,p_associated_item=>wwv_flow_imp.id(2106861533185425)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(38889903062645790)
,p_validation_name=>'validate schema'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  r boolean := false;',
'begin',
'  for c1 in (select owner from wwv_flows where id = :fb_flow_id and security_group_id = :flow_security_group_id) ',
'  loop',
'    r := wwv_flow_security.current_company_can_build(p_in_schema=>c1.owner);',
'  end loop;',
'  return r;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'You do not have privileges to parse as the identified schema.'
,p_when_button_pressed=>wwv_flow_imp.id(37336001160486106)
,p_associated_item=>wwv_flow_imp.id(38881611317544045)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(211565610847095075)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'check objects'
,p_process_sql_clob=>':P2100_ERROR := wwv_flow_install_wizard.get_existing_objects(:FB_FLOW_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(37336001160486106)
,p_internal_uid=>211565610847095075
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(211573414535162346)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'system privs'
,p_process_sql_clob=>':P2100_PRIV_ERROR := wwv_flow_install_wizard.get_missing_privs(:FB_FLOW_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(37336001160486106)
,p_internal_uid=>211573414535162346
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(211578026918184866)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'free space'
,p_process_sql_clob=>':P2100_AVAILABLE_SPACE := wwv_flow_install_wizard.get_free_space(:FB_FLOW_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(37336001160486106)
,p_internal_uid=>211578026918184866
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(17800102602504423)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Unset flow IDs'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':FB_FLOW_ID := null;',
':FB_FLOW_PAGE_ID := null;',
':F4000_P1_FLOW := null;',
':F4000_P1_PAGE := null;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2107444086185431)
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id from wwv_flows ',
' where id = :FB_FLOW_ID ',
'   and build_status = ''RUN_ONLY''',
'   and security_group_id = :flow_security_group_id'))
,p_process_when_type=>'EXISTS'
,p_internal_uid=>17800102602504423
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(17570430382429314)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Initialize page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_is_multistep_yn      number;',
'begin',
'    select count(*) into l_is_multistep_yn',
'      from (',
'          select 1 from wwv_flow_install_checks    where security_group_id = :flow_security_group_id and flow_id = :fb_flow_id union all',
'          select 1 from wwv_flow_install_build_opt where security_group_id = :flow_security_group_id and flow_id = :fb_flow_id union all',
'          select 1 from wwv_flow_install           ',
'           where ( replace(prompt_substitution_01_yn||',
'                         prompt_substitution_02_yn||',
'                         prompt_substitution_03_yn||',
'                         prompt_substitution_04_yn||',
'                         prompt_substitution_05_yn||',
'                         prompt_substitution_06_yn||',
'                         prompt_substitution_07_yn||',
'                         prompt_substitution_08_yn||',
'                         prompt_substitution_09_yn||',
'                         prompt_substitution_10_yn||',
'                         prompt_substitution_11_yn||',
'                         prompt_substitution_12_yn||',
'                         prompt_substitution_13_yn||',
'                         prompt_substitution_14_yn||',
'                         prompt_substitution_15_yn||',
'                         prompt_substitution_16_yn||',
'                         prompt_substitution_17_yn||',
'                         prompt_substitution_18_yn||',
'                         prompt_substitution_19_yn||',
'                         prompt_substitution_20_yn,''N'','''') is not null',
'                      or license_message is not null )',
'                     and flow_id = :fb_flow_id',
'                     and security_group_id = :flow_security_group_id',
'      );',
'',
'    if l_is_multistep_yn > 0 then',
'        :P2100_MULTISTEP_YN := ''Y'';',
'    else ',
'        :P2100_MULTISTEP_YN := ''N'';',
'    end if;',
'',
'    if :REQUEST = ''APP_INSTALLED'' and :P2100_MULTISTEP_YN = ''N'' then',
'       :P2100_PAGE_NAME := wwv_flow_lang.message( ''INSTALLER.TITLE.APP_INSTALLED'' );',
'    else',
'       :P2100_PAGE_NAME := wwv_flow_lang.message( ''INSTALLER.TITLE.INSTALL_SUPP_OBJ'' );',
'    end if;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>17570430382429314
);
end;
/
prompt --application/pages/page_02101
begin
wwv_flow_imp_page.create_page(
 p_id=>2101
,p_name=>'Install Application - License Acceptance'
,p_alias=>'INSTALL-APPLICATION-LICENSE-ACCEPTANCE'
,p_step_title=>'Install Application - License Acceptance'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(24907316279669450)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_pa_install_obj.htm'
,p_page_component_map=>'25'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(37336800919486110)
,p_plug_name=>'License Acceptance'
,p_region_css_classes=>'a-Wizard-region--simple'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>30
,p_plug_item_display_point=>'BELOW'
,p_function_body_language=>'PLSQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    message clob;',
'begin',
'    select wwv_flow_utilities.esc_non_basic_tags(LICENSE_MESSAGE) ',
'      into message',
'      from WWV_FLOW_INSTALL ',
'     where flow_id = :fb_flow_id',
'       and security_group_id = :WORKSPACE_ID;',
'    ',
'    return message;',
'end;'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(37442730288832905)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(37438506954816730)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(186905023266544144)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747147700038138176)
,p_plug_name=>'Install Application'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(37337207622486111)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(186905023266544144)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&P2100_CANCEL_PAGE.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(37337529228486111)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(186905023266544144)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install_checks    where security_group_id = :WORKSPACE_ID and flow_id = :fb_flow_id union all',
'select 1 from wwv_flow_install_build_opt where security_group_id = :WORKSPACE_ID and flow_id = :fb_flow_id union all',
'select 1 from wwv_flow_install           ',
' where replace(prompt_substitution_01_yn||',
'               prompt_substitution_02_yn||',
'               prompt_substitution_03_yn||',
'               prompt_substitution_04_yn||',
'               prompt_substitution_05_yn||',
'               prompt_substitution_06_yn||',
'               prompt_substitution_07_yn||',
'               prompt_substitution_08_yn||',
'               prompt_substitution_09_yn||',
'               prompt_substitution_10_yn||',
'               prompt_substitution_11_yn||',
'               prompt_substitution_12_yn||',
'               prompt_substitution_13_yn||',
'               prompt_substitution_14_yn||',
'               prompt_substitution_15_yn||',
'               prompt_substitution_16_yn||',
'               prompt_substitution_17_yn||',
'               prompt_substitution_18_yn||',
'               prompt_substitution_19_yn||',
'               prompt_substitution_20_yn,''N'','''') is not null',
'   and flow_id = :fb_flow_id',
'   and security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(17571150326429321)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(186905023266544144)
,p_button_name=>'INSTALL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Install Supporting Objects'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install_checks    where security_group_id = :WORKSPACE_ID and flow_id = :fb_flow_id union all',
'select 1 from wwv_flow_install_build_opt where security_group_id = :WORKSPACE_ID and flow_id = :fb_flow_id union all',
'select 1 from wwv_flow_install           ',
' where replace(prompt_substitution_01_yn||',
'               prompt_substitution_02_yn||',
'               prompt_substitution_03_yn||',
'               prompt_substitution_04_yn||',
'               prompt_substitution_05_yn||',
'               prompt_substitution_06_yn||',
'               prompt_substitution_07_yn||',
'               prompt_substitution_08_yn||',
'               prompt_substitution_09_yn||',
'               prompt_substitution_10_yn||',
'               prompt_substitution_11_yn||',
'               prompt_substitution_12_yn||',
'               prompt_substitution_13_yn||',
'               prompt_substitution_14_yn||',
'               prompt_substitution_15_yn||',
'               prompt_substitution_16_yn||',
'               prompt_substitution_17_yn||',
'               prompt_substitution_18_yn||',
'               prompt_substitution_19_yn||',
'               prompt_substitution_20_yn,''N'','''') is not null',
'   and flow_id = :fb_flow_id',
'   and security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'NOT_EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(37337415093486111)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(186905023266544144)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:2100:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(37338113556486113)
,p_branch_action=>'f?p=&APP_ID.:2103:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(37337529228486111)
,p_branch_sequence=>10
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where replace(prompt_substitution_01_yn||',
'                 prompt_substitution_02_yn||',
'                 prompt_substitution_03_yn||',
'                 prompt_substitution_04_yn||',
'                 prompt_substitution_05_yn||',
'                 prompt_substitution_06_yn||',
'                 prompt_substitution_07_yn||',
'                 prompt_substitution_08_yn||',
'                 prompt_substitution_09_yn||',
'                 prompt_substitution_10_yn||',
'                 prompt_substitution_11_yn||',
'                 prompt_substitution_12_yn||',
'                 prompt_substitution_13_yn||',
'                 prompt_substitution_14_yn||',
'                 prompt_substitution_15_yn||',
'                 prompt_substitution_16_yn||',
'                 prompt_substitution_17_yn||',
'                 prompt_substitution_18_yn||',
'                 prompt_substitution_19_yn||',
'                 prompt_substitution_20_yn,''N'','''') is not null',
'   and flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(13651814892479845)
,p_branch_action=>'f?p=&APP_ID.:2107:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(37337529228486111)
,p_branch_sequence=>20
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install_build_opt',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(13653026666483211)
,p_branch_action=>'f?p=&APP_ID.:2102:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(37337529228486111)
,p_branch_sequence=>30
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * from wwv_flow_install_checks',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(13653630822484402)
,p_branch_name=>'Go To Page 2116'
,p_branch_action=>'f?p=&APP_ID.:2116:&SESSION.::&DEBUG.:2116::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(17571150326429321)
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(37358004418607878)
,p_name=>'P2101_ACCEPT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(37336800919486110)
,p_item_default=>'N'
,p_prompt=>'I Accept'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(37400015472734017)
,p_validation_name=>'P2101_ACCEPT'
,p_validation_sequence=>10
,p_validation=>'P2101_ACCEPT'
,p_validation2=>'Y'
,p_validation_type=>'ITEM_IN_VALIDATION_EQ_STRING2'
,p_error_message=>'You must accept the license terms to continue.  Otherwise, click Cancel.'
,p_associated_item=>wwv_flow_imp.id(37358004418607878)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_02102
begin
wwv_flow_imp_page.create_page(
 p_id=>2102
,p_name=>'Install Application - Pre-Install Validations'
,p_alias=>'INSTALL-APPLICATION-PRE-INSTALL-VALIDATIONS'
,p_step_title=>'Install Application - Pre-Install Validations'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(24907316279669450)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_pa_install_obj.htm'
,p_page_component_map=>'25'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17570950840429319)
,p_plug_name=>'Information'
,p_region_css_classes=>'a-Wizard-region--simple'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>30
,p_plug_item_display_point=>'BELOW'
,p_function_body_language=>'PLSQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    message clob;',
'begin',
'    select decode(VALIDATION_MESSAGE,',
'                  null, wwv_flow_lang.system_message(''INSTALLER.VALIDATION_MESSAGE''),',
'                  wwv_flow_utilities.esc_non_basic_tags(VALIDATION_MESSAGE)) as validation_message',
'      into message',
'      from wwv_flow_install ',
'     where flow_id = :fb_flow_id',
'       and security_group_id = :flow_security_group_id;',
'     ',
'    return message;',
'end;'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(37338604142486113)
,p_name=>'Pre-Install Validations'
,p_parent_plug_id=>wwv_flow_imp.id(17570950840429319)
,p_template=>wwv_flow_imp.id(42025417508627628)
,p_display_sequence=>40
,p_region_css_classes=>'margin-top-md'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name ',
'  from wwv_flow_install_checks ',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by sequence'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(17571077324429320)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>10
,p_column_heading=>'Validation'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(37445929380842126)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(37438506954816730)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(186906420412562271)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747147890157138176)
,p_plug_name=>'Install Application'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(37339004379486114)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(186906420412562271)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&P2100_CANCEL_PAGE.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(37339319482486114)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(186906420412562271)
,p_button_name=>'INSTALL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Install'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(37339225015486114)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(186906420412562271)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(13758211568614355)
,p_branch_action=>'f?p=&APP_ID.:2108:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(37339319482486114)
,p_branch_sequence=>21
,p_branch_condition_type=>'ITEM_IS_NOT_NULL'
,p_branch_condition=>'P2102_ERRORS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(37339906531486116)
,p_branch_name=>'Go To Page 2116'
,p_branch_action=>'f?p=&APP_ID.:2116:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(37339319482486114)
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(37339631448486115)
,p_branch_action=>'f?p=&APP_ID.:2107:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(37339225015486114)
,p_branch_sequence=>10
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install_build_opt',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(13644722333444125)
,p_branch_action=>'f?p=&APP_ID.:2103:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(37339225015486114)
,p_branch_sequence=>20
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where replace(prompt_substitution_01_yn||',
'                 prompt_substitution_02_yn||',
'                 prompt_substitution_03_yn||',
'                 prompt_substitution_04_yn||',
'                 prompt_substitution_05_yn||',
'                 prompt_substitution_06_yn||',
'                 prompt_substitution_07_yn||',
'                 prompt_substitution_08_yn||',
'                 prompt_substitution_09_yn||',
'                 prompt_substitution_10_yn||',
'                 prompt_substitution_11_yn||',
'                 prompt_substitution_12_yn||',
'                 prompt_substitution_13_yn||',
'                 prompt_substitution_14_yn||',
'                 prompt_substitution_15_yn||',
'                 prompt_substitution_16_yn||',
'                 prompt_substitution_17_yn||',
'                 prompt_substitution_18_yn||',
'                 prompt_substitution_19_yn||',
'                 prompt_substitution_20_yn,''N'','''') is not null',
'   and flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(13645514845451434)
,p_branch_action=>'f?p=&APP_ID.:2101:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(37339225015486114)
,p_branch_sequence=>30
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where license_message is not null',
'   and flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(13646119347452754)
,p_branch_action=>'f?p=&APP_ID.:2100:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(37339225015486114)
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(13756207281603606)
,p_name=>'P2102_ERRORS'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(37338604142486113)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(13757116632606356)
,p_computation_sequence=>10
,p_computation_item=>'P2102_ERRORS'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(13754928275600277)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Check Validations'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P2102_ERRORS := wwv_flow_install_wizard.run_install_checks (',
'                     p_flow_id => :FB_FLOW_ID );'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(37339319482486114)
,p_internal_uid=>13754928275600277
);
end;
/
prompt --application/pages/page_02103
begin
wwv_flow_imp_page.create_page(
 p_id=>2103
,p_name=>'Install Application - Application Substitution Strings'
,p_alias=>'INSTALL-APPLICATION-APPLICATION-SUBSTITUTION-STRINGS'
,p_step_title=>'Install Application - Application Substitution Strings'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(24907316279669450)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_pa_install_obj.htm'
,p_page_component_map=>'25'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17570662591429316)
,p_plug_name=>'Configuration Message'
,p_region_css_classes=>'a-Wizard-region--simple'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>30
,p_function_body_language=>'PLSQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    message clob;',
'begin',
'    select decode(CONFIGURATION_MESSAGE,',
'              null,',
'              wwv_flow_lang.system_message(''INSTALLER.CONFIGURATION_MESSAGE''),',
'              wwv_flow_utilities.esc_non_basic_tags(CONFIGURATION_MESSAGE))',
'      into message',
'      from wwv_flow_install ',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :flow_security_group_id;',
'',
'    return message;',
'end;'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(37340424997486117)
,p_plug_name=>'Application Substitution Strings'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>40
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'wwv_flow_install_wizard.configuration_options ( p_flow_id => :FB_FLOW_ID );'
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(37446331804842815)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(37438506954816730)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(206276406164792061)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747147948343138176)
,p_plug_name=>'Install Application'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(37340814925486118)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(206276406164792061)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&P2100_CANCEL_PAGE.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(37341119094486118)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(206276406164792061)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install_checks    where security_group_id = :WORKSPACE_ID and flow_id = :fb_flow_id union all',
'select 1 from wwv_flow_install_build_opt where security_group_id = :WORKSPACE_ID and flow_id = :fb_flow_id'))
,p_button_condition_type=>'EXISTS'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1526502552644705)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(206276406164792061)
,p_button_name=>'INSTALL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Install Supporting Objects'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install_checks    where security_group_id = :WORKSPACE_ID and flow_id = :fb_flow_id union all',
'select 1 from wwv_flow_install_build_opt where security_group_id = :WORKSPACE_ID and flow_id = :fb_flow_id'))
,p_button_condition_type=>'NOT_EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(37341002826486118)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(206276406164792061)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(37341719241486119)
,p_branch_action=>'f?p=&APP_ID.:2107:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(37341119094486118)
,p_branch_sequence=>40
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install_build_opt',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(13636318000405090)
,p_branch_action=>'f?p=&APP_ID.:2102:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(37341119094486118)
,p_branch_sequence=>50
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * from wwv_flow_install_checks',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(13637223540406621)
,p_branch_name=>'Go To Page 2116'
,p_branch_action=>'f?p=&APP_ID.:2116:&SESSION.::&DEBUG.:2116::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(1526502552644705)
,p_branch_sequence=>60
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(37341429307486119)
,p_branch_action=>'f?p=&APP_ID.:2101:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(37341002826486118)
,p_branch_sequence=>8
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where license_message is not null',
'   and flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(8538614107560872)
,p_branch_action=>'f?p=&APP_ID.:2100:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(37341002826486118)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8061331659257144)
,p_name=>'P2103_SS_PROMPTS'
,p_item_sequence=>215
,p_item_plug_id=>wwv_flow_imp.id(37340424997486117)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'  l_ss_prompts wwv_flow_global.vc_arr2;',
'begin',
'  for c1 in (select prompt_substitution_01_yn p01,',
'                    prompt_substitution_02_yn p02,',
'                    prompt_substitution_03_yn p03,',
'                    prompt_substitution_04_yn p04,',
'                    prompt_substitution_05_yn p05,',
'                    prompt_substitution_06_yn p06,',
'                    prompt_substitution_07_yn p07,',
'                    prompt_substitution_08_yn p08,',
'                    prompt_substitution_09_yn p09,',
'                    prompt_substitution_10_yn p10,',
'                    prompt_substitution_11_yn p11,',
'                    prompt_substitution_12_yn p12,',
'                    prompt_substitution_13_yn p13,',
'                    prompt_substitution_14_yn p14,',
'                    prompt_substitution_15_yn p15,',
'                    prompt_substitution_16_yn p16,',
'                    prompt_substitution_17_yn p17,',
'                    prompt_substitution_18_yn p18,',
'                    prompt_substitution_19_yn p19,',
'                    prompt_substitution_20_yn p20',
'               from wwv_flow_install',
'              where flow_id = :FB_FLOW_ID',
'                and security_group_id = :flow_security_group_id)',
'  loop',
'    if c1.p01 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''01''; end if;',
'    if c1.p02 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''02''; end if;',
'    if c1.p03 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''03''; end if;',
'    if c1.p04 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''04''; end if;',
'    if c1.p05 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''05''; end if;',
'    if c1.p06 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''06''; end if;',
'    if c1.p07 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''07''; end if;',
'    if c1.p08 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''08''; end if;',
'    if c1.p09 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''09''; end if;',
'    if c1.p10 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''10''; end if;',
'    if c1.p11 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''11''; end if;',
'    if c1.p12 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''12''; end if;',
'    if c1.p13 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''13''; end if;',
'    if c1.p14 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''14''; end if;',
'    if c1.p15 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''15''; end if;',
'    if c1.p16 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''16''; end if;',
'    if c1.p17 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''17''; end if;',
'    if c1.p18 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''18''; end if;',
'    if c1.p19 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''19''; end if;',
'    if c1.p20 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''20''; end if;',
'  end loop;',
'  return wwv_flow_utilities.table_to_string(l_ss_prompts);',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(8066121410339320)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process Substitution Strings'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select id ',
'             from wwv_flow_install ',
'            where flow_id = :FB_FLOW_ID',
'              and security_group_id = :flow_security_group_id)',
'loop',
'  wwv_flow_install_wizard.set_sub_strings (',
'      p_ss_prompts  => wwv_flow_utilities.string_to_table2(:P2103_SS_PROMPTS),',
'      p_ss_values   => htmldb_application.g_f01,',
'      p_install_id  => c1.id',
'      );',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(37341119094486118)
,p_internal_uid=>8066121410339320
);
end;
/
prompt --application/pages/page_02105
begin
wwv_flow_imp_page.create_page(
 p_id=>2105
,p_name=>'Install Application - Install Status'
,p_alias=>'INSTALL-APPLICATION-INSTALL-STATUS'
,p_step_title=>'Install Application - Install Status'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(24907316279669450)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_pa_install_obj.htm'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(377954002618182699)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(377954831015190921)
,p_plug_name=>'Supporting Objects Installed'
,p_region_template_options=>'#DEFAULT#:a-Alert--success:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in ( select install_success_message',
'              from wwv_flow_install',
'             where flow_id = :FB_FLOW_ID',
'               and security_group_id = :flow_security_group_id )',
'loop',
'    sys.htp.p( coalesce ( wwv_flow_escape.html( c1.install_success_message ),',
'                          wwv_flow_lang.system_message( ''INSTALLER.SUCCESS_MESSAGE'' ) ) );',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NOT_EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''APEX_DEPLOYMENT_LOG_'' || :FB_FLOW_ID',
'   and c002 = ''FAIL'''))
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(388072293039289606)
,p_plug_name=>'Supporting Objects Install Error'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>11
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in ( select install_failure_message',
'              from wwv_flow_install',
'             where flow_id = :FB_FLOW_ID',
'               and security_group_id = :WORKSPACE_ID )',
'loop',
'    sys.htp.p( coalesce( wwv_flow_escape.html( c1.install_failure_message ),',
'                         wwv_flow_lang.system_message( ''INSTALLER.FAILURE_MESSAGE'' ) ) );',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''APEX_DEPLOYMENT_LOG_'' || :FB_FLOW_ID',
'   and c002 = ''FAIL'''))
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(377973404458261750)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(377954002618182699)
,p_button_name=>'INSTALL_SUMMARY'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Install Summary'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:2106:&SESSION.::&DEBUG.::P2106_DEPLOYMENT_FLOW_ID:&FB_FLOW_ID.'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(377973106090259463)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(377954002618182699)
,p_button_name=>'EDIT_APPLICATION'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Edit Application'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::'
,p_button_condition=>'P49_BUILD_STATUS'
,p_button_condition2=>'RUN_AND_BUILD'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(377972214270252338)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(377954002618182699)
,p_button_name=>'RUN_APPLICATION'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Run Application'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(38100423673639275)
,p_name=>'P2105_HOME_LINK'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(377954002618182699)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(379059830271863924)
,p_computation_sequence=>10
,p_computation_item=>'P2105_HOME_LINK'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_dev.get_run_url (',
'    p_application_id => :FB_FLOW_ID )'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2108802062185445)
,p_name=>'Run app in new tab'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(377972214270252338)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2108974233185446)
,p_event_id=>wwv_flow_imp.id(2108802062185445)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.builder.launchAppOrPage( $v( "P2105_HOME_LINK" ) );'
);
end;
/
prompt --application/pages/page_02106
begin
wwv_flow_imp_page.create_page(
 p_id=>2106
,p_name=>'Install Summary'
,p_alias=>'INSTALL-SUMMARY'
,p_step_title=>'Install Summary'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(24907316279669450)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_pa_log.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(13830232636866482)
,p_plug_name=>'Errors'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>140
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'for c1 in (select c001 script_name, clob001 errors from htmldb_collections ',
'           where collection_name = ''APEX_DEPLOYMENT_LOG_''||:P2106_DEPLOYMENT_FLOW_ID',
'           and length(clob001) > 0)',
'loop',
'  sys.htp.p(''<strong>''||wwv_flow_escape.html(c1.script_name)||''</strong>'');',
'  sys.htp.p(''<pre>'');',
'  wwv_flow_sw_script.escape_sc_clob(c1.errors);',
'  sys.htp.p(''</pre>'');',
'end loop;',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from htmldb_collections ',
' where collection_name = ''APEX_DEPLOYMENT_LOG_''||:P2106_DEPLOYMENT_FLOW_ID',
'   and length(clob001) > 0'))
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(13832512597889094)
,p_name=>'Install Summary'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>130
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 script_name, ',
'       decode(c002, ''SUCCESS'', ',
'                    wwv_flow_lang.system_message(''INSTALLER.SCRIPT.SUCCESS''),',
'                    ''FAIL'',',
'                    wwv_flow_lang.system_message(''INSTALLER.SCRIPT.FAIL'')) status,        ',
'       to_number(nvl(c003,0)) fail_count,',
'       to_number(nvl(c004,0)) success_count,',
'       c003 + c004 total_count',
'  from htmldb_collections',
' where collection_name = ''APEX_DEPLOYMENT_LOG_''||:P2106_DEPLOYMENT_FLOW_ID',
' order by seq_id'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>50
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No script results found'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(13832811661889098)
,p_query_column_id=>1
,p_column_alias=>'SCRIPT_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Script Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(13832905646889098)
,p_query_column_id=>2
,p_column_alias=>'STATUS'
,p_column_display_sequence=>2
,p_column_heading=>'Status'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(13833029422889098)
,p_query_column_id=>3
,p_column_alias=>'FAIL_COUNT'
,p_column_display_sequence=>4
,p_column_heading=>'Statements with Errors'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_sum_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18924823251673657)
,p_query_column_id=>4
,p_column_alias=>'SUCCESS_COUNT'
,p_column_display_sequence=>3
,p_column_heading=>'Statements Successful'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_sum_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(18924922101673658)
,p_query_column_id=>5
,p_column_alias=>'TOTAL_COUNT'
,p_column_display_sequence=>5
,p_column_heading=>'Total Statements'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_sum_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(13839317146918771)
,p_plug_name=>'Install Summary'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'This page displays information about the Installation and Deinstallation script results for the current application.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(24174032175852704)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(24172418538839346)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id ',
'  from wwv_flows ',
' where id = :P2106_DEPLOYMENT_FLOW_ID ',
'   and build_status = ''RUN_AND_BUILD''',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(226817912026257376)
,p_plug_name=>'Application'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>91
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(97017221654212316)
,p_name=>'P2106_HOME_LINK'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(13839317146918771)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_dev.get_run_url (',
'    p_application_id => :FB_FLOW_ID )'))
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(138112204575881331)
,p_name=>'P2106_DEPLOYMENT_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(13839317146918771)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(226819701076263618)
,p_name=>'P2106_APP'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(226817912026257376)
,p_prompt=>'Application:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case when :FB_FLOW_ID = :P2106_DEPLOYMENT_FLOW_ID ',
'then wwv_flow_builder.get_current_flow_id_and_name',
'else :P2106_DEPLOYMENT_FLOW_NAME',
'end'))
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_help_text=>'This attribute identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(227659704556466343)
,p_name=>'P2106_DEPLOYMENT_FLOW_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(13839317146918771)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(17574123318431013)
,p_process_sequence=>10
,p_process_point=>'BEFORE_FOOTER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Unset flow IDs'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':FB_FLOW_ID := null;',
':FB_FLOW_PAGE_ID := null;',
':F4000_P1_FLOW := null;',
':F4000_P1_PAGE := null;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id from wwv_flows ',
' where id = :P2106_DEPLOYMENT_FLOW_ID ',
'   and build_status = ''RUN_ONLY'' ',
'   and security_group_id = :flow_security_group_id'))
,p_process_when_type=>'EXISTS'
,p_internal_uid=>17574123318431013
);
end;
/
prompt --application/pages/page_02107
begin
wwv_flow_imp_page.create_page(
 p_id=>2107
,p_name=>'Install Application - Build Options'
,p_alias=>'INSTALL-APPLICATION-BUILD-OPTIONS'
,p_step_title=>'Install Application - Build Options'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(24907316279669450)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_pa_install_obj.htm'
,p_page_component_map=>'25'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(13553928773010793)
,p_plug_name=>'Build Options'
,p_region_css_classes=>'a-Wizard-region--simple'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>40
,p_plug_item_display_point=>'BELOW'
,p_function_body_language=>'PLSQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    message clob;',
'begin',
'    select decode(BUILD_OPTIONS_MESSAGE,',
'                  null,',
'                  wwv_flow_lang.system_message(''INSTALLER.BUILD_OPTIONS_MESSAGE''),',
'                  wwv_flow_utilities.esc_non_basic_tags(build_options_message))',
'      into message',
'      from wwv_flow_install',
'     where flow_id = :fb_flow_id',
'       and security_group_id = :flow_security_group_id;',
'',
'    return message;',
'end;'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(13554812974015615)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(37438506954816730)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(206279716038832790)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747148289883138177)
,p_plug_name=>'Install Application'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(13558728342029561)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(206279716038832790)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&P2100_CANCEL_PAGE.:&SESSION.::&DEBUG.:RP::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(13558924167029562)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(206279716038832790)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_button_condition=>'select 1 from wwv_flow_install_checks where security_group_id = :WORKSPACE_ID and flow_id = :fb_flow_id'
,p_button_condition_type=>'EXISTS'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1526855411646179)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(206279716038832790)
,p_button_name=>'INSTALL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Install Supporting Objects'
,p_button_position=>'NEXT'
,p_button_condition=>'select 1 from wwv_flow_install_checks where security_group_id = :WORKSPACE_ID and flow_id = :fb_flow_id'
,p_button_condition_type=>'NOT_EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(13559100407029562)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(206279716038832790)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(13563020162036687)
,p_branch_action=>'f?p=&APP_ID.:2102:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(13558924167029562)
,p_branch_sequence=>30
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * from wwv_flow_install_checks',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(13642028089436385)
,p_branch_name=>'Go To Page 2116'
,p_branch_action=>'f?p=&APP_ID.:2116:&SESSION.::&DEBUG.:2116::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(1526855411646179)
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(13560910812033924)
,p_branch_action=>'f?p=&APP_ID.:2103:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(13559100407029562)
,p_branch_sequence=>10
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where replace(prompt_substitution_01_yn||',
'                 prompt_substitution_02_yn||',
'                 prompt_substitution_03_yn||',
'                 prompt_substitution_04_yn||',
'                 prompt_substitution_05_yn||',
'                 prompt_substitution_06_yn||',
'                 prompt_substitution_07_yn||',
'                 prompt_substitution_08_yn||',
'                 prompt_substitution_09_yn||',
'                 prompt_substitution_10_yn||',
'                 prompt_substitution_11_yn||',
'                 prompt_substitution_12_yn||',
'                 prompt_substitution_13_yn||',
'                 prompt_substitution_14_yn||',
'                 prompt_substitution_15_yn||',
'                 prompt_substitution_16_yn||',
'                 prompt_substitution_17_yn||',
'                 prompt_substitution_18_yn||',
'                 prompt_substitution_19_yn||',
'                 prompt_substitution_20_yn,''N'','''') is not null',
'   and flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(13640008350430642)
,p_branch_action=>'f?p=&APP_ID.:2101:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(13559100407029562)
,p_branch_sequence=>20
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where license_message is not null',
'   and flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(13640613544432113)
,p_branch_action=>'f?p=&APP_ID.:2100:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(13559100407029562)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(13571505402041833)
,p_name=>'P2107_BUILD_OPTIONS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(13553928773010793)
,p_prompt=>'Available Build Options:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'   l_value wwv_flow_global.vc_arr2;',
' begin ',
'   select id ',
'   bulk collect into l_value',
'   from wwv_flow_patches ',
'   where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
'   and patch_status = ''INCLUDE'';',
'    ',
'   return wwv_flow_utilities.table_to_string2(l_value,'':''); ',
' end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'INSTALLER BUILD OPTIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select patch_name, id from wwv_flow_patches ',
'where id in (select build_opt_id from wwv_flow_install_build_opt',
'              where flow_id = :fb_flow_id',
'                and security_group_id = :flow_security_group_id)'))
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'The distributor of this application has exposed these build options for you to include or exclude in your application.  These settings can be modified later by editing the application''s build options directly.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
end;
/
prompt --application/pages/page_02108
begin
wwv_flow_imp_page.create_page(
 p_id=>2108
,p_name=>'Error'
,p_alias=>'ERROR'
,p_step_title=>'Error'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(24907316279669450)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_pa_install_obj.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(206278808288821043)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747148399828138177)
,p_plug_name=>'Validations Failed'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'The pre-installation validations have failed. Please ensure your system is compatible with this application by reviewing the error messages in the following report.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(13764102611640168)
,p_name=>'Error Messages'
,p_parent_plug_id=>wwv_flow_imp.id(747148399828138177)
,p_template=>wwv_flow_imp.id(208928010704475743)
,p_display_sequence=>40
,p_region_css_classes=>'margin-top-md'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select failure_message from wwv_flow_install_checks',
'where instr('':''||:P2102_ERRORS||'':'','':''||id||'':'') > 0',
'  and flow_id = :FB_FLOW_ID',
'  and security_group_id = :flow_security_group_id'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No Errors found.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(13764424151640172)
,p_query_column_id=>1
,p_column_alias=>'FAILURE_MESSAGE'
,p_column_display_sequence=>1
,p_column_heading=>'Error Messages'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(13766513131652604)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(206278808288821043)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&P2100_CANCEL_PAGE.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(13767421442655065)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(206278808288821043)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:2102:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
end;
/
prompt --application/pages/page_02109
begin
wwv_flow_imp_page.create_page(
 p_id=>2109
,p_name=>'Preview Script'
,p_alias=>'PREVIEW-SCRIPT'
,p_page_mode=>'NON_MODAL'
,p_step_title=>'Preview Script'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deployment.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(57814432655083261)
,p_plug_name=>'Upgrade Scripts'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>140
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
' sys.htp.p(''<table>'');',
' for c1 in (select rownum rn, s.* from ',
'             (select * from wwv_flow_install_scripts',
'               where flow_id = :FB_FLOW_ID',
'                 and security_group_id = :flow_security_group_id',
'                 and nvl(script_type, ''INSTALL'') = ''UPGRADE''',
'               order by sequence, name) s)',
' loop',
'  sys.htp.p(''<tr><td valign="top"><a name="''||c1.rn||''"></a><span class="fielddatabold">''||c1.name||''</span></td></tr><tr><td><pre>'');',
'  wwv_flow_sw_script.escape_sc_clob(c1.script);',
'  sys.htp.p(''</pre></td></tr>'');',
' end loop;',
' sys.htp.p(''</table>'');',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(:P2109_MODE,''INSTALL'') = ''UPGRADE'''
,p_plug_display_when_cond2=>'SQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(210405822258670878)
,p_plug_name=>'Installation Scripts'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>100
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
' sys.htp.p(''<table>'');',
' for c1 in (select rownum rn, s.* from ',
'             (select * from wwv_flow_install_scripts',
'               where flow_id = :FB_FLOW_ID',
'                 and security_group_id = :flow_security_group_id',
'                 and nvl(script_type, ''INSTALL'') = ''INSTALL''',
'               order by sequence, name) s)',
' loop',
'  sys.htp.p(''<tr><td valign="top"><a name="''||c1.rn||''"></a><span class="fielddatabold">''||c1.name||''</span></td></tr><tr><td><pre>'');',
'  wwv_flow_sw_script.escape_sc_clob(c1.script);',
'  sys.htp.p(''</pre></td></tr>'');',
' end loop;',
' sys.htp.p(''</table>'');',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(:P2109_MODE,''INSTALL'') = ''INSTALL'''
,p_plug_display_when_cond2=>'SQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(211272319310208044)
,p_plug_name=>'Summary'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>1
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(211369921752360175)
,p_plug_name=>'Prerequisites'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>21
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(:P2109_MODE,''INSTALL'') = ''INSTALL'''
,p_plug_display_when_cond2=>'SQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(211824324061321054)
,p_name=>'Scripts'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>31
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select rownum rn, s.* from (',
'    select name, ',
'           sys.dbms_lob.getlength(script) len, ',
'           (sys.dbms_lob.getlength(script) - sys.dbms_lob.getlength(replace(script,unistr(''\000a''),'''')) + 1) lines',
'      from wwv_flow_install_scripts',
'     where flow_id = :FB_FLOW_ID',
'       and nvl(:P2109_MODE,''INSTALL'') = nvl(script_type,''INSTALL'')',
'       and security_group_id = :flow_security_group_id',
'     order by sequence, name',
') s'))
,p_display_when_condition=>'P2109_MODE'
,p_display_when_cond2=>'DEINSTALL'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(249244707741859303)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No Scripts found.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(211824324061321054)
,p_plug_column_width=>'align="right"'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(211842529911370009)
,p_query_column_id=>1
,p_column_alias=>'RN'
,p_column_display_sequence=>1
,p_column_heading=>'Rn'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(211824612462321059)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_column_link=>'##RN#'
,p_column_linktext=>'#NAME#'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(211824720672321059)
,p_query_column_id=>3
,p_column_alias=>'LEN'
,p_column_display_sequence=>3
,p_column_heading=>'Length (Bytes)'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(211824831759321059)
,p_query_column_id=>4
,p_column_alias=>'LINES'
,p_column_display_sequence=>4
,p_column_heading=>'Lines'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(219171320267554742)
,p_plug_name=>'button'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>11
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(227747509610732775)
,p_plug_name=>'Deinstallation Script'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>150
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
' sys.htp.p(''<table>'');',
' for c1 in (select deinstall_script from wwv_flow_install',
'             where flow_id = :FB_FLOW_ID',
'               and security_group_id = :flow_security_group_id)',
' loop',
'  sys.htp.p(''<tr><td><pre>'');',
'  wwv_flow_sw_script.escape_sc_clob(c1.deinstall_script);',
'  sys.htp.p(''</pre></td></tr>'');',
' end loop;',
' sys.htp.p(''</table>'');',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(:P2109_MODE,''INSTALL'') = ''DEINSTALL'''
,p_plug_display_when_cond2=>'SQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(219169723599546223)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(211272319310208044)
,p_button_name=>'CLOSE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Close'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'javascript:window.close();'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(210993907246608422)
,p_name=>'P2109_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(211272319310208044)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application:'
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(211002719292706529)
,p_name=>'P2109_PARSING_SCHEMA'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(211272319310208044)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Parsing Schema:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select owner ',
'  from wwv_flows ',
' where id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Identifies the schema that will be used to parse and execute all SQL within this application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(211005800161719948)
,p_name=>'P2109_FREE_SPACE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(211369921752360175)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Free Space Required in KB:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select to_char(nvl(REQUIRED_FREE_KB,0),''999G999G999G999G999G990'') free_kb ',
'  from wwv_flow_install ',
' where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The following freespace must be available in the parsing schema''s default tablespace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(211021728305784821)
,p_name=>'P2109_REQ_SYS_PRIVS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(211369921752360175)
,p_prompt=>'Required System Privileges:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select replace( wwv_flow_escape.html(nvl(required_sys_privs,wwv_flow_lang.system_message(''AUTH.NONE''))),'':'', ''<br />'')',
'  from wwv_flow_install',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_help_text=>'Identifies the system privileges required to run this application''s installation scripts.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(211231405973816221)
,p_name=>'P2109_DB_OBJECT_NAMES'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(211369921752360175)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Database Object Names:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select replace(wwv_flow_escape.html(nvl(required_names_available,wwv_flow_lang.system_message(''AUTH.NONE''))), '':'', ''<br />'')',
'  from wwv_flow_install',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_help_text=>'Identifies database objects that are installed by this application''s installation scripts.  Installation of supporting objects is prevented if these objects exist in the parsing schema.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(211240221603849124)
,p_name=>'P2109_PAGES'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(211272319310208044)
,p_prompt=>'Pages:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*) ',
'  from wwv_flow_steps ',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The number of pages in this application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(211386106908384266)
,p_name=>'P2109_SCRIPT_COUNT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(211272319310208044)
,p_prompt=>'Installation Scripts:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*) from wwv_flow_install_scripts ',
' where flow_id = :FB_FLOW_ID',
'   and nvl(:P2109_MODE,''INSTALL'') = nvl(script_type,''INSTALL'')',
'   and security_group_id = :flow_security_group_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The number of installation scripts associated with this application.  These installation scripts create the supporting objects used by this application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(227745200128720584)
,p_name=>'P2109_MODE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(211272319310208044)
,p_item_default=>'INSTALL'
,p_source=>'INSTALL'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_02110
begin
wwv_flow_imp_page.create_page(
 p_id=>2110
,p_name=>'Deinstall'
,p_alias=>'DEINSTALL'
,p_step_title=>'Deinstall'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(24907316279669450)
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'/* Add more spacing for checkboxes */',
'.apex-item-option {margin-bottom: 8px;margin-top: 4px;}',
'/* Floating radio group left so help icons shows correctly */',
'.apex-item-group {float: left;}'))
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_del.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(37419320197747676)
,p_plug_name=>'Deinstall'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>30
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(37693129196139328)
,p_plug_name=>'Deinstallation Message'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
'where flow_id = :FB_FLOW_ID and deinstall_message is not null'))
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(227756316845782132)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(399849897040726767)
,p_plug_display_sequence=>50
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(227753031474767408)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(923577366660744019)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(923577424457744020)
,p_plug_name=>'Deinstall Application'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(37419900654747681)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(923577366660744019)
,p_button_name=>'DEINSTALL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Deinstall'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(37419514959747679)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(923577366660744019)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&P2110_CANCEL_PAGE.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(37420926958747692)
,p_branch_name=>'Go To Page 2111'
,p_branch_action=>'f?p=&APP_ID.:2111:&SESSION.::&DEBUG.::::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(37419900654747681)
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(37669115541974537)
,p_branch_name=>'Go To Page 20'
,p_branch_action=>'f?p=&APP_ID.:20:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_HEADER'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'NOT_EXISTS'
,p_branch_condition=>'select 1 from WWV_FLOW_INSTALL where FLOW_ID = :fb_flow_id and sys.dbms_lob.getlength(DEINSTALL_SCRIPT) > 2'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(37678007061009999)
,p_branch_action=>'f?p=&APP_ID.:20:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(37419900654747681)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P2110_DEINSTALLATION_OPTIONS'
,p_branch_condition_text=>'APPLICATION'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(36638523808198046)
,p_name=>'P2110_DEINSTALL_APPLICATION'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(37419320197747676)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application'
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'This identifies the number and name of the application you are deinstalling.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(36642706408211917)
,p_name=>'P2110_PARSING_SCHEMA'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_imp.id(37419320197747676)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Parsing Schema'
,p_source=>'select owner from wwv_flows where id = :fb_flow_id and :fb_flow_id is not null'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'This identifies the default schema for you application.  The deinstallation script will also parse as this schema.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(37420315505747685)
,p_name=>'P2110_DEINSTALL_MESSAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(37693129196139328)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_utilities.esc_non_basic_tags(deinstall_message) from wwv_flow_install',
' where flow_id = :FB_FLOW_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(69493630613480452)
,p_name=>'P2110_DEINSTALLATION_OPTIONS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(37419320197747676)
,p_prompt=>'Deinstallation Options'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'REMOVE APPLICATION OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(69499523734506806)||'.'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p><strong>Remove Application Definition</strong> will remove application &FB_FLOW_ID. but leave all the supporting objects that were created.</p>',
'<p><strong>Drop Database Objects</strong> will run the deinstallation script defined in the supporting object definitions of application &FB_FLOW_ID..</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(168169921686849894)
,p_name=>'P2110_DELETE_FEEDBACK'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(37419320197747676)
,p_prompt=>'Delete Feedback'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_feedback',
' where application_id = :FB_FLOW_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'If you are planning to recreate this application using the same ID, you may want to keep your feedback.  If not, you should delete it so that it does not become associated with another application using this application number in the future.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(224488820267485765)
,p_name=>'P2110_CANCEL_PAGE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(37419320197747676)
,p_item_default=>'1'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(123838628142313448)
,p_computation_sequence=>10
,p_computation_item=>'P2111_DEINSTALL_SUCCESS_MESSAGE'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(deinstall_success_message,',
'         null, ',
'         wwv_flow_lang.system_message(''INSTALLER.DEINSTALL_SUCCESS_MESSAGE''),',
'         wwv_flow_utilities.esc_non_basic_tags(deinstall_success_message))',
'  from wwv_flow_install',
' where flow_id = :FB_FLOW_ID'))
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(138134332682993581)
,p_computation_sequence=>20
,p_computation_item=>'P2106_DEPLOYMENT_FLOW_ID'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'FB_FLOW_ID'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(227686726766501167)
,p_computation_sequence=>30
,p_computation_item=>'P2106_DEPLOYMENT_FLOW_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(224761712992884009)
,p_computation_sequence=>30
,p_computation_item=>'P2110_CANCEL_PAGE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'nvl(:P2110_CANCEL_PAGE,1)'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(69501405857511144)
,p_validation_name=>'P2110_DEINSTALLATION_OPTIONS'
,p_validation_sequence=>10
,p_validation=>'P2110_DEINSTALLATION_OPTIONS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'You must check at least one option.'
,p_associated_item=>wwv_flow_imp.id(69493630613480452)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(929198698348394250)
,p_name=>'Deinstall'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(37419900654747681)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1157684060391338201)
,p_event_id=>wwv_flow_imp.id(929198698348394250)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'DEINSTALL'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(9801909508671111)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Deinstall Database Objects'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select id, owner from ',
'              (select id from wwv_flow_install where flow_id = :FB_FLOW_ID), ',
'              (select owner from wwv_flows where id = :FB_FLOW_ID))',
'loop',
'  wwv_flow_install_wizard.deinstall (',
'      p_install_id  => c1.id,',
'      p_flow_id     => :FB_FLOW_ID,',
'      p_schema      => c1.owner',
'      );',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to deinstall application.'
,p_process_when_button_id=>wwv_flow_imp.id(37419900654747681)
,p_process_when=>'DBOBJECTS'
,p_process_when_type=>'CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2'
,p_process_when2=>'P2110_DEINSTALLATION_OPTIONS'
,p_process_success_message=>'Deinstall successful. '
,p_internal_uid=>9801909508671111
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(17816722738661007)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Application'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P2110_DELETE_FEEDBACK = ''Y'' then',
'    wwv_flow_imp.remove_application (',
'    p_application_id  => :FB_FLOW_ID,',
'    p_delete_feedback => true);',
'else',
'    wwv_flow_imp.remove_application (',
'    p_application_id  => :FB_FLOW_ID);',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to delete application definition.'
,p_process_when_button_id=>wwv_flow_imp.id(37419900654747681)
,p_process_when=>'APPLICATION'
,p_process_when_type=>'CONDITION1_IN_VALUE_OF_ITEM_IN_CONDITION2'
,p_process_when2=>'P2110_DEINSTALLATION_OPTIONS'
,p_process_success_message=>'Application definition deleted.'
,p_internal_uid=>17816722738661007
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(19186203979302100)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Clean up on Delete'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow.update_cache_with_write (''FB_FLOW_ID'',null);',
'wwv_flow.update_cache_with_write (''FB_FLOW_NAME'',null);',
'wwv_flow.update_cache_with_write (''FB_FLOW_PAGE_ID'',''1'');',
'wwv_flow.update_cache_with_write (''F4000_P1_PAGE'',''1'');',
'wwv_flow.update_cache_with_write (''F4000_P1_FLOW'',null);',
'',
'for c1 in (select min(id) min_id ',
'             from wwv_flows ',
'            where security_group_id = :flow_security_group_id',
'              and build_status = ''RUN_AND_BUILD'') loop',
'   wwv_flow.update_cache_with_write (''FB_FLOW_ID'',c1.min_id);',
'   wwv_flow.update_cache_with_write (''F4000_P1_FLOW'',c1.min_id);',
'   for c2 in (select min(id) p from wwv_flow_steps where flow_id = nv(''FB_FLOW_ID'')) loop',
'      wwv_flow.update_cache_with_write (''FB_FLOW_PAGE_ID'',c2.p);',
'      wwv_flow.update_cache_with_write (''F4000_P1_PAGE'',c2.p);',
'   end loop;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to refresh session state.'
,p_process_when_button_id=>wwv_flow_imp.id(37419900654747681)
,p_process_when=>'P2110_DEINSTALLATION_OPTIONS'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'APPLICATION:DBOBJECTS'
,p_internal_uid=>19186203979302100
);
end;
/
prompt --application/pages/page_02111
begin
wwv_flow_imp_page.create_page(
 p_id=>2111
,p_name=>'Deinstall'
,p_alias=>'DEINSTALL1'
,p_step_title=>'Deinstall'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(24907316279669450)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_del.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(18149230028164603)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(923577532211744021)
,p_plug_name=>'Deinstall Application'
,p_region_template_options=>'#DEFAULT#:a-Alert--success:a-Alert--wizard'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(923578011411744026)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(18149230028164603)
,p_button_name=>'Deinstall_Summary'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Deinstall Summary'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:2106:&SESSION.::&DEBUG.:RP:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(923577965972744025)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(18149230028164603)
,p_button_name=>'Application_Builder'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'App Builder'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1500:&SESSION.::&DEBUG.:RP:::'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18152503971176089)
,p_name=>'P2111_DEINSTALL_SUCCESS_MESSAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(923577532211744021)
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
end;
/
prompt --application/pages/page_02115
begin
wwv_flow_imp_page.create_page(
 p_id=>2115
,p_name=>'Error Installing Supporting Objects'
,p_alias=>'ERROR-INSTALLING-SUPPORTING-OBJECTS'
,p_step_title=>'Error Installing Supporting Objects'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(24907316279669450)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_pa_install_obj.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11342631633842985)
,p_plug_name=>'Error Installing Supporting Objects'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The installation of this application''s supporting objects cannot continue until these issues are resolved.</p>  ',
'<p>To continue installation after addressing the errors, navigate to the Supporting Objects of this application and select Install Supporting Objects from the Tasks list.</p>',
'<p>Alternatively, you can deinstall the application definition and reinstall after resolving these issues.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(205202428675612736)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(11344616096866801)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(205202428675612736)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(11345709301874379)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(205202428675612736)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:2100:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(17569709686429307)
,p_branch_name=>'Redirect on CANCEL'
,p_branch_action=>'f?p=&APP_ID.:&P2100_CANCEL_PAGE.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(11344616096866801)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(211606205353471924)
,p_name=>'P2115_SPACE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(11342631633842985)
,p_prompt=>'Available Space in KB:'
,p_source=>'P2100_AVAILABLE_SPACE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'P2100_AVAILABLE_SPACE'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The available space in your parsing schema''s default tablespace is less than the amount required to install this application''s supporting objects.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(211610506485529012)
,p_name=>'P2115_REQUIRED_PRIVS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(11342631633842985)
,p_prompt=>'Required Privileges:'
,p_source=>'P2100_PRIV_ERROR'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'P2100_PRIV_ERROR'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'To install this application''s supporting objects requires that the following system privileges be granted to the application''s parsing schema.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(211611313758531197)
,p_name=>'P2115_OBJECT_NAMES'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(11342631633842985)
,p_prompt=>'Object Names:'
,p_source=>'P2100_ERROR'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'P2100_ERROR'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Installation of supporting objects cannot proceed while database objects with these names exist in this application''s parsing schema.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(18461415943022992)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Unset flow IDs'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':FB_FLOW_ID := null;',
':FB_FLOW_PAGE_ID := null;',
':F4000_P1_FLOW := null;',
':F4000_P1_PAGE := null;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(11344616096866801)
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id from wwv_flows ',
' where id = :FB_FLOW_ID ',
'   and build_status = ''RUN_ONLY''',
'   and security_group_id = :flow_security_group_id'))
,p_process_when_type=>'EXISTS'
,p_internal_uid=>18461415943022992
);
end;
/
prompt --application/pages/page_02116
begin
wwv_flow_imp_page.create_page(
 p_id=>2116
,p_name=>'Install Application'
,p_alias=>'INSTALL-APPLICATION2'
,p_step_title=>'Install Application'
,p_allow_duplicate_submissions=>'N'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (!$v("P2116_HALT_Y")) {',
'  window.setTimeout(function() { apex.submit("INSTALL"); }, 100);',
'}'))
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_pa_install_obj.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(212286806351687982)
,p_plug_name=>'Installing Supporting Objects...'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(1147295105621079968)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(212281521804682913)
,p_branch_action=>'f?p=&APP_ID.:2105:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(77661604407399602)
,p_branch_name=>'after error: return to install supporting objects'
,p_branch_action=>'f?p=&APP_ID.:2100:&SESSION.::&DEBUG.:2116::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_HEADER'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'ITEM_IS_NOT_NULL'
,p_branch_condition=>'P2116_HALT_Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(77661585350399601)
,p_name=>'P2116_HALT_Y'
,p_item_sequence=>110
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
,p_item_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'If Y, don''t retry installing the supporting objects.',
'added for',
'Bug 20137505 - IMPORTING APPLICATION WITH INVALID SUPPORT OBJECT CONDITION RESULTS IN LOOP'))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(212278801026676927)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Install'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in ( select id, owner from ',
'                    ( select id ',
'                        from wwv_flow_install ',
'                       where flow_id           = :FB_FLOW_ID',
'                         and security_group_id = :WORKSPACE_ID ), ',
'                    ( select owner ',
'                        from wwv_flows',
'                       where id                = :FB_FLOW_ID',
'                         and security_group_id = :WORKSPACE_ID ) )',
'    loop',
'      wwv_flow_install_wizard.install (',
'          p_flow_id     => :FB_FLOW_ID,',
'          p_install_id  => c1.id,',
'          p_schema      => c1.owner',
'       );',
'    end loop;',
'',
'exception',
'    when others then',
'        rollback;',
'        -- flag 2116 to not retry installation of supporting objects',
'        htmldb_util.set_session_state(''P2116_HALT_Y'',''Y'');',
'        raise;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to install application.'
,p_internal_uid=>212278801026676927
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(212279305527678271)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process Build Options'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'update wwv_flow_patches ',
'   set patch_status = ''EXCLUDE'' ',
' where id in (select build_opt_id ',
'                from wwv_flow_install_build_opt ',
'               where flow_id = :FB_FLOW_ID ',
'                 and security_group_id = :flow_security_group_id) ',
'   and instr('':''||:P2107_BUILD_OPTIONS||'':'', '':''||ID||'':'') = 0',
'   and security_group_id = :flow_security_group_id;',
'',
'update wwv_flow_patches ',
'   set patch_status = ''INCLUDE'' ',
' where instr('':''||:P2107_BUILD_OPTIONS||'':'', '':''||ID||'':'') > 0',
'   and flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>212279305527678271
);
end;
/
prompt --application/pages/page_02117
begin
wwv_flow_imp_page.create_page(
 p_id=>2117
,p_name=>'Install Application'
,p_alias=>'INSTALL-APPLICATION3'
,p_step_title=>'Install Application'
,p_allow_duplicate_submissions=>'N'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code_onload=>'window.setTimeout(function() { apex.submit("INSTALL"); }, 100);'
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(219158001286417970)
,p_plug_name=>'Installing Application...'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(1147295105621079968)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(241341826355308329)
,p_branch_name=>'Go To Page 2160'
,p_branch_action=>'f?p=&APP_ID.:2160:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_collections',
' where collection_name in ( ''WWV_FLOW_IMPORT_CREDENTIALS'', ''WWV_FLOW_IMPORT_REMOTE_SERVERS'' )',
'   and c003 = ''Y'''))
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(80658205422600378)
,p_branch_name=>'Go To Page 2150'
,p_branch_action=>'f?p=&APP_ID.:2150:&SESSION.::&DEBUG.:2150,2151,2152:P2150_CANCEL_PAGE:1&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_install_wizard.needs_upgrade (',
'    p_flow_id => :FB_FLOW_ID )'))
,p_branch_condition_text=>'PLSQL'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(224538621342138907)
,p_branch_name=>'Go To Page 2100'
,p_branch_action=>'f?p=&APP_ID.:2100:&SESSION.:APP_INSTALLED:&DEBUG.:2100,2101,2102,2103,2105::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install_scripts   where security_group_id = :flow_security_group_id and flow_id = :fb_flow_id union all',
'select 1 from wwv_flow_install_objects   where security_group_id = :flow_security_group_id and flow_id = :fb_flow_id union all',
'select 1 from wwv_flow_install_checks    where security_group_id = :flow_security_group_id and flow_id = :fb_flow_id union all',
'select 1 from wwv_flow_install_build_opt where security_group_id = :flow_security_group_id and flow_id = :fb_flow_id'))
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(491304721302717878)
,p_branch_name=>'Go To Page 733'
,p_branch_action=>'f?p=&APP_ID.:733:&SESSION.::&DEBUG.:2100,2101,2102,2103,2105::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flows',
' where id = :FB_FLOW_ID ',
'   and build_status = ''RUN_ONLY''',
'   and security_group_id = :WORKSPACE_ID'))
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(224539224805139928)
,p_branch_name=>'Go To Page 57'
,p_branch_action=>'f?p=&APP_ID.:57:&SESSION.:FLOW:&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(225087719721396975)
,p_branch_action=>'f?p=&APP_ID.:49:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_HEADER'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P2117_SUBMITTED'
,p_branch_condition_text=>'YES'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225086004699383188)
,p_name=>'P2117_SUBMITTED'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(219158001286417970)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(225087023053388432)
,p_computation_sequence=>10
,p_computation_item=>'P2117_SUBMITTED'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'YES'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(224537317056128290)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'import flow'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select 1 from   wwv_flow_company_schemas',
'           where upper(schema) = upper(:P49_PARSE_AS) ',
'           and security_group_id = :flow_security_group_id) loop',
'    wwv_flow_imp_parser.parse (',
'        p_file_id            => :P49_FILE_ID,',
'        p_parse_as_schema    => :P49_PARSE_AS,',
'        p_install_as_flow    => :P49_NEW_FLOW_ID,',
'        p_original_flow_id   => wwv_flow_imp_parser.get_flow_id(:P49_FILE_ID),',
'        p_adjust_offset      => :P49_IMP_FLOW_ID != :P49_NEW_FLOW_ID,',
'        p_new_build_status   => :P49_BUILD_STATUS );',
'end loop;',
'wwv_flow_data_upload.fix_pre42(p_flow_id  => :P49_NEW_FLOW_ID );  ',
'',
':FB_FLOW_ID      := :P49_NEW_FLOW_ID;',
':FB_FLOW_PAGE_ID := ''1'';',
':F4000_P1_FLOW   := :P49_NEW_FLOW_ID;',
':F4000_P1_PAGE   := ''1'';'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error installing application.'
,p_internal_uid=>224537317056128290
);
end;
/
prompt --application/pages/page_02120
begin
wwv_flow_imp_page.create_page(
 p_id=>2120
,p_name=>'Preview File'
,p_alias=>'PREVIEW-FILE'
,p_step_title=>'Preview File'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(19943204431962826)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(227269707121202197)
,p_plug_name=>'Preview File'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'l_charset varchar2(100);',
'begin',
'sys.htp.p(''<pre>'');',
'for c1 in (select blob_content, file_charset',
'             from wwv_flow_file_objects$',
'            where id = :P2120_FILE_ID) loop',
'  if c1.file_charset is null then',
'    l_charset := nvl(sys.owa_util.get_cgi_env(''REQUEST_IANA_CHARSET''),',
'                   ''utf-8'');',
'else',
'   l_charset := c1.file_charset;',
'end if;',
'wwv_flow_sw_script.escape_sc_clob(',
'    wwv_flow_utilities.blob_to_clob(p_blob    => c1.blob_content,',
'                                    p_charset => l_charset));',
'',
'end loop;',
'sys.htp.p(''</pre>'');',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(227298928563331326)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(227269707121202197)
,p_button_name=>'CLOSE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Close'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'javascript:window.close();'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(227295021722310480)
,p_name=>'P2120_FILE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(227269707121202197)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_02140
begin
wwv_flow_imp_page.create_page(
 p_id=>2140
,p_name=>'Application Installed'
,p_alias=>'APPLICATION-INSTALLED'
,p_step_title=>'Application Installed'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_install.htm'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(379113808205930390)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>141
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(379115403619948031)
,p_plug_name=>'Application Installed'
,p_region_template_options=>'#DEFAULT#:a-Alert--success:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p( wwv_flow_lang.system_message( ''IMPORT_APP_SUCCESS_MSG'',',
'                                         wwv_flow_utilities.prepare_url( ''f?p='' || :APP_ID || '':73:'' || :APP_SESSION ) ) );'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(379115706521958355)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(379113808205930390)
,p_button_name=>'RUN_APP'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Run Application'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(379115924528963503)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(379113808205930390)
,p_button_name=>'EDIT_APP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Edit Application'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::'
,p_button_condition=>'P49_BUILD_STATUS'
,p_button_condition2=>'RUN_AND_BUILD'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(107287598700340909)
,p_name=>'P2140_RUN_APP_URL'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(379115403619948031)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(160882555878697845)
,p_computation_sequence=>30
,p_computation_item=>'P2140_RUN_APP_URL'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_dev.get_run_url (p_application_id => :FB_FLOW_ID )'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2108248594185439)
,p_name=>'Run app in new tab'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(379115706521958355)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2108390203185440)
,p_event_id=>wwv_flow_imp.id(2108248594185439)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.builder.launchAppOrPage( $v("P2140_RUN_APP_URL") );'
);
end;
/
prompt --application/pages/page_02150
begin
wwv_flow_imp_page.create_page(
 p_id=>2150
,p_name=>'Install Application - Supporting Objects'
,p_alias=>'INSTALL-APPLICATION-SUPPORTING-OBJECTS1'
,p_step_title=>'Install Application - Supporting Objects'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(24907316279669450)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_pa_install_obj.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(48641830756424111)
,p_plug_name=>'Supporting Objects'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(48642431472424112)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(399849897040726767)
,p_plug_display_sequence=>200
,p_list_id=>wwv_flow_imp.id(57809829707044603)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(48680428299599768)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(48681713885605105)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(208172022706810323)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747148631352138178)
,p_plug_name=>'Install Application'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(48643130915424118)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(208172022706810323)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&P2150_CANCEL_PAGE.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(48643307915424120)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(208172022706810323)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(48649222438424132)
,p_branch_action=>'f?p=&APP_ID.:2151:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(48643307915424120)
,p_branch_sequence=>20
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install ',
'where license_message is not null',
'  and flow_id = :FB_FLOW_ID',
'  and security_group_id = :flow_security_group_id'))
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(48648017064424131)
,p_branch_action=>'f?p=&APP_ID.:2153:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(48643307915424120)
,p_branch_sequence=>30
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where replace(prompt_substitution_01_yn||',
'                 prompt_substitution_02_yn||',
'                 prompt_substitution_03_yn||',
'                 prompt_substitution_04_yn||',
'                 prompt_substitution_05_yn||',
'                 prompt_substitution_06_yn||',
'                 prompt_substitution_07_yn||',
'                 prompt_substitution_08_yn||',
'                 prompt_substitution_09_yn||',
'                 prompt_substitution_10_yn||',
'                 prompt_substitution_11_yn||',
'                 prompt_substitution_12_yn||',
'                 prompt_substitution_13_yn||',
'                 prompt_substitution_14_yn||',
'                 prompt_substitution_15_yn||',
'                 prompt_substitution_16_yn||',
'                 prompt_substitution_17_yn||',
'                 prompt_substitution_18_yn||',
'                 prompt_substitution_19_yn||',
'                 prompt_substitution_20_yn,''N'','''') is not null',
'   and flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(48648612885424132)
,p_branch_action=>'f?p=&APP_ID.:2157:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(48643307915424120)
,p_branch_sequence=>40
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install_build_opt',
' where flow_id = :FB_FLOW_ID'))
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(48648804255424132)
,p_branch_action=>'f?p=&APP_ID.:2152:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(48643307915424120)
,p_branch_sequence=>50
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install_checks',
' where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(48648403379424131)
,p_branch_action=>'f?p=&APP_ID.:2154:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(48649005347424132)
,p_branch_action=>'f?p=&APP_ID.:2140:&SESSION.::&DEBUG.:RP::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>70
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P2150_ACTION'
,p_branch_condition_text=>'N'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48643530611424120)
,p_name=>'P2150_WELCOME_MESSAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(48641830756424111)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(UPGRADE_MESSAGE,',
'              null, wwv_flow_lang.system_message(''INSTALLER.UPGRADE_MESSAGE''),',
'              wwv_flow_utilities.esc_non_basic_tags(UPGRADE_MESSAGE))',
'  from wwv_flow_install ',
' where flow_id = :fb_flow_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48643705376424121)
,p_name=>'P2150_ACTION'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(48641830756424111)
,p_item_default=>'Y'
,p_prompt=>'Upgrade Supporting Objects:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(84259319526460470)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'This application definition has been installed, however, the database objects, images, and seed data need to be upgraded.  Choose <strong>Yes</strong> to continue and upgrade these supporting objects.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48644227970424122)
,p_name=>'P2150_APPLICATION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(48641830756424111)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FLOW_ID.'
,p_prompt=>'Application:'
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48644932245424123)
,p_name=>'P2150_PARSING_SCHEMA'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(48641830756424111)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Parsing Schema:'
,p_source=>'select owner from wwv_flows where id = :fb_flow_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Identifies the schema that will be used to parse and execute all SQL within this application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48645401450424123)
,p_name=>'P2150_ERROR'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(48641830756424111)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48645628461424123)
,p_name=>'P2150_AVAILABLE_SPACE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(48641830756424111)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48645803607424123)
,p_name=>'P2150_FREE_SPACE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(48641830756424111)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Free Space Required in KB:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select to_char(nvl(REQUIRED_FREE_KB,0),''999G999G999G999G999G990'') free_kb from wwv_flow_install ',
'where flow_id = :fb_flow_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'The following freespace must be available in the parsing schema''s default tablespace.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48646322222424124)
,p_name=>'P2150_PRIV_ERROR'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(48641830756424111)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48646529119424124)
,p_name=>'P2150_CANCEL_PAGE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(48641830756424111)
,p_item_default=>'1'
,p_source=>'1'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(48646824364424125)
,p_computation_sequence=>10
,p_computation_item=>'P2150_CANCEL_PAGE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'SQL'
,p_computation=>'nvl(:P2150_CANCEL_PAGE,1)'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(48647006850424127)
,p_validation_name=>'application exists'
,p_validation_sequence=>10
,p_validation=>'select 1 from wwv_flows where id = :fb_flow_id'
,p_validation_type=>'EXISTS'
,p_error_message=>'Application must be installed.'
,p_when_button_pressed=>wwv_flow_imp.id(48643307915424120)
,p_associated_item=>wwv_flow_imp.id(48644227970424122)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(48647232376424128)
,p_validation_name=>'validate schema'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  r boolean := false;',
'begin',
'  for c1 in (select owner from wwv_flows where id = :fb_flow_id) loop',
'    r := wwv_flow_security.current_company_can_build(p_in_schema=>c1.owner);',
'  end loop;',
'  return r;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'You do not have privileges to parse as the identified schema.'
,p_when_button_pressed=>wwv_flow_imp.id(48643307915424120)
,p_associated_item=>wwv_flow_imp.id(48644932245424123)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(48647323522424128)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'check objects'
,p_process_sql_clob=>':P2150_ERROR := wwv_flow_install_wizard.get_existing_objects(:FB_FLOW_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(48643307915424120)
,p_process_when_type=>'NEVER'
,p_internal_uid=>48647323522424128
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(48647515263424129)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'system privs'
,p_process_sql_clob=>':P2150_PRIV_ERROR := wwv_flow_install_wizard.get_missing_privs(:FB_FLOW_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(48643307915424120)
,p_process_when_type=>'NEVER'
,p_internal_uid=>48647515263424129
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(48647726958424130)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'free space'
,p_process_sql_clob=>':P2150_AVAILABLE_SPACE := wwv_flow_install_wizard.get_free_space(:FB_FLOW_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(48643307915424120)
,p_process_when_type=>'NEVER'
,p_internal_uid=>48647726958424130
);
end;
/
prompt --application/pages/page_02151
begin
wwv_flow_imp_page.create_page(
 p_id=>2151
,p_name=>'Install Application - License Acceptance'
,p_alias=>'INSTALL-APPLICATION-LICENSE-ACCEPTANCE1'
,p_step_title=>'Install Application - License Acceptance'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(24907316279669450)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_pa_install_obj.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(48655502408443595)
,p_plug_name=>'License Acceptance'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(48655713415443595)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(48681713885605105)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(48656110285443596)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(399849897040726767)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_imp.id(210424614987781460)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(208175920113847459)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747148726610138178)
,p_plug_name=>'Install Application'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(48656819909443596)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(208175920113847459)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&P2100_CANCEL_PAGE.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(48657019541443597)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(208175920113847459)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(48657232350443597)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(208175920113847459)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(48659106578443598)
,p_branch_action=>'f?p=&APP_ID.:2153:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(48657019541443597)
,p_branch_sequence=>10
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where replace(prompt_substitution_01_yn||',
'                 prompt_substitution_02_yn||',
'                 prompt_substitution_03_yn||',
'                 prompt_substitution_04_yn||',
'                 prompt_substitution_05_yn||',
'                 prompt_substitution_06_yn||',
'                 prompt_substitution_07_yn||',
'                 prompt_substitution_08_yn||',
'                 prompt_substitution_09_yn||',
'                 prompt_substitution_10_yn||',
'                 prompt_substitution_11_yn||',
'                 prompt_substitution_12_yn||',
'                 prompt_substitution_13_yn||',
'                 prompt_substitution_14_yn||',
'                 prompt_substitution_15_yn||',
'                 prompt_substitution_16_yn||',
'                 prompt_substitution_17_yn||',
'                 prompt_substitution_18_yn||',
'                 prompt_substitution_19_yn||',
'                 prompt_substitution_20_yn,''N'','''') is not null',
'   and flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(48658301483443598)
,p_branch_action=>'f?p=&APP_ID.:2157:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(48657019541443597)
,p_branch_sequence=>20
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install_build_opt',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(48658525878443598)
,p_branch_action=>'f?p=&APP_ID.:2152:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(48657019541443597)
,p_branch_sequence=>30
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * from wwv_flow_install_checks',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(48658700750443598)
,p_branch_action=>'f?p=&APP_ID.:2154:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(48657019541443597)
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(48658913799443598)
,p_branch_action=>'f?p=&APP_ID.:2150:&SESSION.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(48657232350443597)
,p_branch_sequence=>50
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48657601512443597)
,p_name=>'P2151_LICENSE_TERMS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(48655502408443595)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_utilities.esc_non_basic_tags( LICENSE_MESSAGE ) ',
'  from WWV_FLOW_INSTALL ',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48657824400443597)
,p_name=>'P2151_ACCEPT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(48655502408443595)
,p_item_default=>'N'
,p_prompt=>'I Accept'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(48658118530443598)
,p_validation_name=>'P2151_ACCEPT'
,p_validation_sequence=>10
,p_validation=>'P2151_ACCEPT'
,p_validation2=>'Y'
,p_validation_type=>'ITEM_IN_VALIDATION_EQ_STRING2'
,p_error_message=>'You must accept the license terms to continue.  Otherwise, click Cancel.'
,p_associated_item=>wwv_flow_imp.id(48657824400443597)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
end;
/
prompt --application/pages/page_02152
begin
wwv_flow_imp_page.create_page(
 p_id=>2152
,p_name=>'Install Application - Pre-Install Validations'
,p_alias=>'INSTALL-APPLICATION-PRE-INSTALL-VALIDATIONS1'
,p_step_title=>'Install Application - Pre-Install Validations'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(24907316279669450)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_pa_install_obj.htm'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(48661831519454947)
,p_plug_name=>'Pre-Install Validations'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'sys.htp.p(''<ul>'');',
'for c1 in (select name ',
'             from wwv_flow_install_checks ',
'            where flow_id = :FB_FLOW_ID ',
'            order by sequence)',
'loop',
'  sys.htp.p(''<li>''||wwv_flow_escape.html(c1.name)||''</li>'');',
'end loop;',
'sys.htp.p(''</ul>'');',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(48662027703454947)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(48681713885605105)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(48662414644454948)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(399849897040726767)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_imp.id(210424614987781460)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(208182509949910780)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747148835944138178)
,p_plug_name=>'Install Application'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(48663126470454948)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(208182509949910780)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&P2100_CANCEL_PAGE.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(48663310147454949)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(208182509949910780)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(48663504623454949)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(208182509949910780)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(48665411373454951)
,p_branch_action=>'f?p=&APP_ID.:2158:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(48663310147454949)
,p_branch_sequence=>10
,p_branch_condition_type=>'ITEM_IS_NOT_NULL'
,p_branch_condition=>'P2152_ERRORS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(48665819125454952)
,p_branch_action=>'f?p=&APP_ID.:2154:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(48663310147454949)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(48665624160454951)
,p_branch_action=>'f?p=&APP_ID.:2157:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(48663504623454949)
,p_branch_sequence=>30
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install_build_opt',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(48664808914454951)
,p_branch_action=>'f?p=&APP_ID.:2153:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(48663504623454949)
,p_branch_sequence=>40
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where replace(prompt_substitution_01_yn||',
'                 prompt_substitution_02_yn||',
'                 prompt_substitution_03_yn||',
'                 prompt_substitution_04_yn||',
'                 prompt_substitution_05_yn||',
'                 prompt_substitution_06_yn||',
'                 prompt_substitution_07_yn||',
'                 prompt_substitution_08_yn||',
'                 prompt_substitution_09_yn||',
'                 prompt_substitution_10_yn||',
'                 prompt_substitution_11_yn||',
'                 prompt_substitution_12_yn||',
'                 prompt_substitution_13_yn||',
'                 prompt_substitution_14_yn||',
'                 prompt_substitution_15_yn||',
'                 prompt_substitution_16_yn||',
'                 prompt_substitution_17_yn||',
'                 prompt_substitution_18_yn||',
'                 prompt_substitution_19_yn||',
'                 prompt_substitution_20_yn,''N'','''') is not null',
'   and flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(48665011129454951)
,p_branch_action=>'f?p=&APP_ID.:2151:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(48663504623454949)
,p_branch_sequence=>50
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where license_message is not null',
'   and flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(48665210872454951)
,p_branch_action=>'f?p=&APP_ID.:2150:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(48663504623454949)
,p_branch_sequence=>60
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48663729123454949)
,p_name=>'P2152_VERIFICATION_MESSAGE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(48661831519454947)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(VALIDATION_MESSAGE,',
'              null, wwv_flow_lang.system_message(''INSTALLER.VALIDATION_MESSAGE''),',
'              wwv_flow_utilities.esc_non_basic_tags(VALIDATION_MESSAGE))',
'  from wwv_flow_install ',
' where flow_id = :fb_flow_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install ',
' where flow_id = :fb_flow_id ',
'   and security_group_id = :flow_security_group_id'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48663920671454950)
,p_name=>'P2152_ERRORS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(48661831519454947)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(48664415975454950)
,p_computation_sequence=>10
,p_computation_item=>'P2152_ERRORS'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(48664500577454950)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Check Validations'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P2152_ERRORS := wwv_flow_install_wizard.run_install_checks (',
'                     p_flow_id => :FB_FLOW_ID );'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(48663310147454949)
,p_internal_uid=>48664500577454950
);
end;
/
prompt --application/pages/page_02153
begin
wwv_flow_imp_page.create_page(
 p_id=>2153
,p_name=>'Install Application - Application Substitution Strings'
,p_alias=>'INSTALL-APPLICATION-APPLICATION-SUBSTITUTION-STRINGS1'
,p_step_title=>'Install Application - Application Substitution Strings'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(24907316279669450)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_pa_install_obj.htm'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(51369702989464992)
,p_plug_name=>'Application Substitution Strings'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_source=>'wwv_flow_install_wizard.configuration_options ( p_flow_id => :FB_FLOW_ID );'
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(51369932294464993)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(48681713885605105)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(51370328183464993)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(399849897040726767)
,p_plug_display_sequence=>30
,p_list_id=>wwv_flow_imp.id(210424614987781460)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(208183308002919647)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747148944461138179)
,p_plug_name=>'Install Application'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(51371026164464994)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(208183308002919647)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&P2100_CANCEL_PAGE.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(51371210452464994)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(208183308002919647)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(51371400869464994)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(208183308002919647)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(51373702960464997)
,p_branch_action=>'f?p=&APP_ID.:2157:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(51371210452464994)
,p_branch_sequence=>10
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install_build_opt',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(51373109189464997)
,p_branch_action=>'f?p=&APP_ID.:2152:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(51371210452464994)
,p_branch_sequence=>20
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * from wwv_flow_install_checks',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(51373308057464997)
,p_branch_action=>'f?p=&APP_ID.:2154:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(51371210452464994)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(51373525698464997)
,p_branch_action=>'f?p=&APP_ID.:2151:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(51371400869464994)
,p_branch_sequence=>40
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where license_message is not null',
'   and flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(51372916136464996)
,p_branch_action=>'f?p=&APP_ID.:2150:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(51371400869464994)
,p_branch_sequence=>50
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(51371613099464994)
,p_name=>'P2153_SS_PROMPTS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(51369702989464992)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'  l_ss_prompts wwv_flow_global.vc_arr2;',
'begin',
'  for c1 in (select prompt_substitution_01_yn p01,',
'                    prompt_substitution_02_yn p02,',
'                    prompt_substitution_03_yn p03,',
'                    prompt_substitution_04_yn p04,',
'                    prompt_substitution_05_yn p05,',
'                    prompt_substitution_06_yn p06,',
'                    prompt_substitution_07_yn p07,',
'                    prompt_substitution_08_yn p08,',
'                    prompt_substitution_09_yn p09,',
'                    prompt_substitution_10_yn p10,',
'                    prompt_substitution_11_yn p11,',
'                    prompt_substitution_12_yn p12,',
'                    prompt_substitution_13_yn p13,',
'                    prompt_substitution_14_yn p14,',
'                    prompt_substitution_15_yn p15,',
'                    prompt_substitution_16_yn p16,',
'                    prompt_substitution_17_yn p17,',
'                    prompt_substitution_18_yn p18,',
'                    prompt_substitution_19_yn p19,',
'                    prompt_substitution_20_yn p20',
'               from wwv_flow_install',
'              where flow_id = :FB_FLOW_ID',
'                and security_group_id = :flow_security_group_id)',
'  loop',
'    if c1.p01 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''01''; end if;',
'    if c1.p02 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''02''; end if;',
'    if c1.p03 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''03''; end if;',
'    if c1.p04 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''04''; end if;',
'    if c1.p05 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''05''; end if;',
'    if c1.p06 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''06''; end if;',
'    if c1.p07 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''07''; end if;',
'    if c1.p08 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''08''; end if;',
'    if c1.p09 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''09''; end if;',
'    if c1.p10 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''10''; end if;',
'    if c1.p11 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''11''; end if;',
'    if c1.p12 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''12''; end if;',
'    if c1.p13 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''13''; end if;',
'    if c1.p14 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''14''; end if;',
'    if c1.p15 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''15''; end if;',
'    if c1.p16 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''16''; end if;',
'    if c1.p17 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''17''; end if;',
'    if c1.p18 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''18''; end if;',
'    if c1.p19 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''19''; end if;',
'    if c1.p20 = ''Y'' then l_ss_prompts(l_ss_prompts.count + 1) := ''20''; end if;',
'  end loop;',
'  return wwv_flow_utilities.table_to_string(l_ss_prompts);',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(51372026014464995)
,p_name=>'P2153_CONFIG_MESSAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(51369702989464992)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(CONFIGURATION_MESSAGE,',
'              null,',
'              wwv_flow_lang.system_message(''INSTALLER.CONFIGURATION_MESSAGE''),',
'              wwv_flow_utilities.esc_non_basic_tags(CONFIGURATION_MESSAGE))',
'  from wwv_flow_install ',
' where flow_id = :FB_FLOW_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(51372415539464995)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process Substitution Strings'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select id ',
'             from wwv_flow_install ',
'            where flow_id = :FB_FLOW_ID)',
'loop',
'  wwv_flow_install_wizard.set_sub_strings (',
'      p_ss_prompts  => wwv_flow_utilities.string_to_table2(:P2153_SS_PROMPTS),',
'      p_ss_values   => htmldb_application.g_f01,',
'      p_install_id  => c1.id',
'      );',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(51371210452464994)
,p_internal_uid=>51372415539464995
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(51372604019464996)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Populate Sub Strings'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select substitution_value_01 sv01, install_prompt_01 ss01, ',
'                  substitution_value_02 sv02, install_prompt_02 ss02,',
'                  substitution_value_03 sv03, install_prompt_03 ss03,',
'                  substitution_value_04 sv04, install_prompt_04 ss04,',
'                  substitution_value_05 sv05, install_prompt_05 ss05,',
'                  substitution_value_06 sv06, install_prompt_06 ss06,',
'                  substitution_value_07 sv07, install_prompt_07 ss07,',
'                  substitution_value_08 sv08, install_prompt_08 ss08,',
'                  substitution_value_09 sv09, install_prompt_09 ss09,',
'                  substitution_value_10 sv10, install_prompt_10 ss10,',
'                  substitution_value_11 sv11, install_prompt_11 ss11,',
'                  substitution_value_12 sv12, install_prompt_12 ss12,',
'                  substitution_value_13 sv13, install_prompt_13 ss13,',
'                  substitution_value_14 sv14, install_prompt_14 ss14,',
'                  substitution_value_15 sv15, install_prompt_15 ss15,',
'                  substitution_value_16 sv16, install_prompt_16 ss16,',
'                  substitution_value_17 sv17, install_prompt_17 ss17,',
'                  substitution_value_18 sv18, install_prompt_18 ss18,',
'                  substitution_value_19 sv19, install_prompt_19 ss19,',
'                  substitution_value_20 sv20, install_prompt_20 ss20',
'             from wwv_flows, wwv_flow_install',
'            where wwv_flows.id = wwv_flow_install.flow_id',
'              and wwv_flows.id = :FB_FLOW_ID',
'              and wwv_flows.security_group_id = :flow_security_group_id)',
'loop',
'  :P2153_SUB_VALUE_01 := c1.sv01;',
'  :P2153_SUB_VALUE_02 := c1.sv02;  ',
'  :P2153_SUB_VALUE_03 := c1.sv03;',
'  :P2153_SUB_VALUE_04 := c1.sv04;',
'  :P2153_SUB_VALUE_05 := c1.sv05;',
'  :P2153_SUB_VALUE_06 := c1.sv06;',
'  :P2153_SUB_VALUE_07 := c1.sv07;',
'  :P2153_SUB_VALUE_08 := c1.sv08;',
'  :P2153_SUB_VALUE_09 := c1.sv09;',
'  :P2153_SUB_VALUE_10 := c1.sv10;',
'  :P2153_SUB_VALUE_11 := c1.sv11;',
'  :P2153_SUB_VALUE_12 := c1.sv12;',
'  :P2153_SUB_VALUE_13 := c1.sv13;',
'  :P2153_SUB_VALUE_14 := c1.sv14;',
'  :P2153_SUB_VALUE_15 := c1.sv15;',
'  :P2153_SUB_VALUE_16 := c1.sv16;',
'  :P2153_SUB_VALUE_17 := c1.sv17;',
'  :P2153_SUB_VALUE_18 := c1.sv18;',
'  :P2153_SUB_VALUE_19 := c1.sv19;',
'  :P2153_SUB_VALUE_20 := c1.sv20;',
'  :P2153_SUB_STRING_01 := c1.ss01;',
'  :P2153_SUB_STRING_02 := c1.ss02;  ',
'  :P2153_SUB_STRING_03 := c1.ss03;',
'  :P2153_SUB_STRING_04 := c1.ss04;',
'  :P2153_SUB_STRING_05 := c1.ss05;',
'  :P2153_SUB_STRING_06 := c1.ss06;',
'  :P2153_SUB_STRING_07 := c1.ss07;',
'  :P2153_SUB_STRING_08 := c1.ss08;',
'  :P2153_SUB_STRING_09 := c1.ss09;',
'  :P2153_SUB_STRING_10 := c1.ss10;',
'  :P2153_SUB_STRING_11 := c1.ss11;',
'  :P2153_SUB_STRING_12 := c1.ss12;',
'  :P2153_SUB_STRING_13 := c1.ss13;',
'  :P2153_SUB_STRING_14 := c1.ss14;',
'  :P2153_SUB_STRING_15 := c1.ss15;',
'  :P2153_SUB_STRING_16 := c1.ss16;',
'  :P2153_SUB_STRING_17 := c1.ss17;',
'  :P2153_SUB_STRING_18 := c1.ss18;',
'  :P2153_SUB_STRING_19 := c1.ss19;',
'  :P2153_SUB_STRING_20 := c1.ss20;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_type=>'NEVER'
,p_internal_uid=>51372604019464996
);
end;
/
prompt --application/pages/page_02154
begin
wwv_flow_imp_page.create_page(
 p_id=>2154
,p_name=>'Install Application - Upgrade Supporting Objects Confirmation'
,p_alias=>'INSTALL-APPLICATION-UPGRADE-SUPPORTING-OBJECTS-CONFIRMATION'
,p_step_title=>'Install Application - Upgrade Supporting Objects Confirmation'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(24907316279669450)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_pa_install_obj.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(57400804980641675)
,p_plug_name=>'Upgrade Supporting Objects'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_footer=>'<p /><p />'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(57401014190641675)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(48681713885605105)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(57401406093641676)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689970285456172024)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_imp.id(57809829707044603)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(208184702854946537)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747149045171138179)
,p_plug_name=>'Install Application'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(57402119664641680)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(208184702854946537)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&P2150_CANCEL_PAGE.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(57402323526641681)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(208184702854946537)
,p_button_name=>'INSTALL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Install'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(57402515688641681)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(208184702854946537)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(57404405597641687)
,p_branch_action=>'f?p=&APP_ID.:2166:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(57402323526641681)
,p_branch_sequence=>10
,p_branch_comment=>'was 2105'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(57404203347641686)
,p_branch_action=>'f?p=&APP_ID.:2152:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(57402515688641681)
,p_branch_sequence=>20
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * from wwv_flow_install_checks',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(57403418013641686)
,p_branch_action=>'f?p=&APP_ID.:2157:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(57402515688641681)
,p_branch_sequence=>30
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install_build_opt',
' where flow_id = :FB_FLOW_ID'))
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(57403621297641686)
,p_branch_action=>'f?p=&APP_ID.:2153:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(57402515688641681)
,p_branch_sequence=>40
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where replace(prompt_substitution_01_yn||',
'                 prompt_substitution_02_yn||',
'                 prompt_substitution_03_yn||',
'                 prompt_substitution_04_yn||',
'                 prompt_substitution_05_yn||',
'                 prompt_substitution_06_yn||',
'                 prompt_substitution_07_yn||',
'                 prompt_substitution_08_yn||',
'                 prompt_substitution_09_yn||',
'                 prompt_substitution_10_yn||',
'                 prompt_substitution_11_yn||',
'                 prompt_substitution_12_yn||',
'                 prompt_substitution_13_yn||',
'                 prompt_substitution_14_yn||',
'                 prompt_substitution_15_yn||',
'                 prompt_substitution_16_yn||',
'                 prompt_substitution_17_yn||',
'                 prompt_substitution_18_yn||',
'                 prompt_substitution_19_yn||',
'                 prompt_substitution_20_yn,''N'','''') is not null',
'   and flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(57403801856641686)
,p_branch_action=>'f?p=&APP_ID.:2151:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(57402515688641681)
,p_branch_sequence=>50
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where license_message is not null',
'   and flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(57404004136641686)
,p_branch_action=>'f?p=&APP_ID.:2150:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(57402515688641681)
,p_branch_sequence=>60
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57402703920641682)
,p_name=>'P2154_INSTALL_MESSAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(57400804980641675)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(INSTALL_MESSAGE,',
'              null,',
'              wwv_flow_lang.system_message(''INSTALLER.CONFIRMATION_MESSAGE''),',
'              wwv_flow_utilities.esc_non_basic_tags(INSTALL_MESSAGE))',
'  from wwv_flow_install ',
' where flow_id = :fb_flow_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
end;
/
prompt --application/pages/page_02155
begin
wwv_flow_imp_page.create_page(
 p_id=>2155
,p_name=>'Install Application - Install Status'
,p_alias=>'INSTALL-APPLICATION-INSTALL-STATUS1'
,p_step_title=>'Install Application - Install Status'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(24907316279669450)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_pa_install_obj.htm'
,p_page_component_map=>'25'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(57408502346645336)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(399849897040726767)
,p_plug_display_sequence=>140
,p_list_id=>wwv_flow_imp.id(58916220936178306)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
,p_plug_header=>'<p>Your imported file is located in the export repository.  Unless you plan to install again, you should remove it.</p>'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747149191823138179)
,p_plug_name=>'Install Application'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>10
,p_function_body_language=>'PLSQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    message clob;',
'begin',
'    select decode(INSTALL_FAILURE_MESSAGE,',
'                  null,',
'                  wwv_flow_lang.system_message(''INSTALLER.FAILURE_MESSAGE''),',
'                  wwv_flow_utilities.esc_non_basic_tags(INSTALL_FAILURE_MESSAGE))',
'      into message',
'      from wwv_flow_install',
'     where flow_id = :fb_flow_id',
'       and security_group_id = :flow_security_group_id;',
'',
'    return message;',
'end;'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from htmldb_collections',
' where collection_name = ''APEX_DEPLOYMENT_LOG_''||:FB_FLOW_ID',
'   and c002 = ''FAIL'''))
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(923578109427744027)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>150
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(923578501489744031)
,p_plug_name=>'Install Application'
,p_region_template_options=>'#DEFAULT#:a-Alert--success:a-Alert--wizard'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>20
,p_function_body_language=>'PLSQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    message clob;',
'begin',
'    select decode(INSTALL_SUCCESS_MESSAGE,',
'                  null,',
'                  wwv_flow_lang.system_message(''INSTALLER.SUCCESS_MESSAGE''),',
'                  wwv_flow_utilities.esc_non_basic_tags(INSTALL_SUCCESS_MESSAGE))',
'      into message',
'      from wwv_flow_install',
'     where flow_id = :fb_flow_id',
'       and security_group_id = :flow_security_group_id;',
'',
'    return message;',
'end;'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
,p_plug_display_condition_type=>'NOT_EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * from htmldb_collections ',
' where collection_name = ''APEX_DEPLOYMENT_LOG_''||:FB_FLOW_ID',
'   and c002 = ''FAIL'''))
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(923578456112744030)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(923578109427744027)
,p_button_name=>'Install_Summary'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Install Summary'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:2106:&SESSION.::&DEBUG.:RP:P2106_DEPLOYMENT_FLOW_ID:&FB_FLOW_ID.:'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(923578355511744029)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(923578109427744027)
,p_button_name=>'Edit_Application'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Edit Application'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:RP:::'
,p_button_condition=>'P49_BUILD_STATUS'
,p_button_condition2=>'RUN_AND_BUILD'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(923578229345744028)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(923578109427744027)
,p_button_name=>'Run_Application'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Run Application'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57409624220645337)
,p_name=>'P2155_HOME_LINK'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(57408502346645336)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_dev.get_run_url (',
'    p_application_id => :FB_FLOW_ID )'))
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2108471270185441)
,p_name=>'Run app in new tab'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(923578229345744028)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2108533479185442)
,p_event_id=>wwv_flow_imp.id(2108471270185441)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.builder.launchAppOrPage( $v("P2155_HOME_LINK") );'
);
end;
/
prompt --application/pages/page_02157
begin
wwv_flow_imp_page.create_page(
 p_id=>2157
,p_name=>'Install Application - Build Options'
,p_alias=>'INSTALL-APPLICATION-BUILD-OPTIONS1'
,p_step_title=>'Install Application - Build Options'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(24907316279669450)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_pa_install_obj.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(57428714672660618)
,p_plug_name=>'Build Options'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(57428926090660618)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(48681713885605105)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(57429328767660619)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(399849897040726767)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_imp.id(57809829707044603)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(208187828958963593)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747149214001138179)
,p_plug_name=>'Install Application'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(57430200537660620)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(208187828958963593)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&P2100_CANCEL_PAGE.:&SESSION.::&DEBUG.:RP::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(57430414690660620)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(208187828958963593)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(57430622424660620)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(208187828958963593)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(57432020019660621)
,p_branch_action=>'f?p=&APP_ID.:2152:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(57430414690660620)
,p_branch_sequence=>10
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * from wwv_flow_install_checks',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(57432606120660622)
,p_branch_action=>'f?p=&APP_ID.:2154:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(57430414690660620)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(57431804694660621)
,p_branch_action=>'f?p=&APP_ID.:2153:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(57430622424660620)
,p_branch_sequence=>30
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where replace(prompt_substitution_01_yn||',
'                 prompt_substitution_02_yn||',
'                 prompt_substitution_03_yn||',
'                 prompt_substitution_04_yn||',
'                 prompt_substitution_05_yn||',
'                 prompt_substitution_06_yn||',
'                 prompt_substitution_07_yn||',
'                 prompt_substitution_08_yn||',
'                 prompt_substitution_09_yn||',
'                 prompt_substitution_10_yn||',
'                 prompt_substitution_11_yn||',
'                 prompt_substitution_12_yn||',
'                 prompt_substitution_13_yn||',
'                 prompt_substitution_14_yn||',
'                 prompt_substitution_15_yn||',
'                 prompt_substitution_16_yn||',
'                 prompt_substitution_17_yn||',
'                 prompt_substitution_18_yn||',
'                 prompt_substitution_19_yn||',
'                 prompt_substitution_20_yn,''N'','''') is not null',
'   and flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(57432402776660622)
,p_branch_action=>'f?p=&APP_ID.:2150:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(57430622424660620)
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(57432214340660622)
,p_branch_action=>'f?p=&APP_ID.:2151:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(57430622424660620)
,p_branch_sequence=>50
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install',
' where license_message is not null',
'   and flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57430813463660620)
,p_name=>'P2157_BUILD_OPTIONS_MESSAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(57428714672660618)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(BUILD_OPTIONS_MESSAGE,',
'              null,',
'              wwv_flow_lang.system_message(''INSTALLER.BUILD_OPTIONS_MESSAGE''),',
'              wwv_flow_utilities.esc_non_basic_tags(build_options_message))',
'  from wwv_flow_install',
' where flow_id = :fb_flow_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57431203450660621)
,p_name=>'P2157_BUILD_OPTIONS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(57428714672660618)
,p_prompt=>'Available Build Options:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'   l_value wwv_flow_global.vc_arr2;',
' begin ',
'   select id ',
'   bulk collect into l_value',
'   from wwv_flow_patches ',
'   where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
'   and patch_status = ''INCLUDE'';',
'    ',
'   return wwv_flow_utilities.table_to_string2(l_value,'':''); ',
' end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'INSTALLER BUILD OPTIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select patch_name, id from wwv_flow_patches ',
'where id in (select build_opt_id from wwv_flow_install_build_opt',
'              where flow_id = :fb_flow_id',
'                and security_group_id = :flow_security_group_id)'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'The distributor of this application has exposed these build options for you to include or exclude in your application.  These settings can be modified later by editing the application''s build options directly.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
end;
/
prompt --application/pages/page_02158
begin
wwv_flow_imp_page.create_page(
 p_id=>2158
,p_name=>'Error'
,p_alias=>'ERROR1'
,p_step_title=>'Error'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(24907316279669450)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_pa_install_obj.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(57439125119676748)
,p_name=>'Error Messages'
,p_template=>wwv_flow_imp.id(42025417508627628)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_report_attributes=>'style="width:100%;"'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select failure_message from wwv_flow_install_checks',
'where instr('':''||:P2152_ERRORS||'':'','':''||id||'':'') > 0',
'  and flow_id = :FB_FLOW_ID',
'  and security_group_id = :flow_security_group_id'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No Errors found.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(57439306381676749)
,p_query_column_id=>1
,p_column_alias=>'FAILURE_MESSAGE'
,p_column_display_sequence=>1
,p_column_heading=>'Error Messages'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(57439618877676749)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(48681713885605105)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(208190412597977730)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747149377303138180)
,p_plug_name=>'Error'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(57440312251676749)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(208190412597977730)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:&P2100_CANCEL_PAGE.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(57440506406676750)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(208190412597977730)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(57440824794676750)
,p_branch_action=>'f?p=&FLOW_ID.:2152:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(57440506406676750)
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_02160
begin
wwv_flow_imp_page.create_page(
 p_id=>2160
,p_name=>'Install Application - Credentials'
,p_alias=>'INSTALL-APPLICATION-CREDENTIALS'
,p_step_title=>'Install Application - Credentials'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(24907316279669450)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_pa_install_obj.htm'
,p_page_component_map=>'21'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1573009001030403)
,p_plug_name=>'Credentials'
,p_region_name=>'ig_credentials'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with imported_credentials as (',
'    select distinct n001 as imported_id,',
'           c002 as is_new,',
'           c003 as prompt_on_install',
'      from wwv_flow_collections',
'     where collection_name = ''WWV_FLOW_IMPORT_CREDENTIALS''',
')',
'select',
'    c.id,',
'    i.is_new,',
'    c.name, ',
'    c.authentication_type,',
'    c.client_id,',
'    c.client_secret,',
'    c.client_secret_verify ',
'from wwv_credentials_dev c, imported_credentials i',
'where c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'  and c.id = i.imported_id',
'  and i.prompt_on_install = ''Y'' ',
'order by name'))
,p_plug_source_type=>'NATIVE_IG'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_collections',
' where collection_name = ''WWV_FLOW_IMPORT_CREDENTIALS''',
'   and c003 = ''Y'''))
,p_plug_footer=>'<p>Credentials that are already in the workspace may be edited from <strong>Workspace Utilities</strong>.</p>'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1573365246030406)
,p_name=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Credential Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>50
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_max_length=>255
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function( options ) {',
'    options.defaultGridColumnOptions = {',
'        noHeaderActivate: true',
'    };',
'    return options;',
'}'))
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_include_in_export=>true
,p_readonly_condition_type=>'ALWAYS'
,p_readonly_for_each_row=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1573409629030407)
,p_name=>'AUTHENTICATION_TYPE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'AUTHENTICATION_TYPE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Authentication Type'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>60
,p_value_alignment=>'LEFT'
,p_is_required=>true
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(154078822199034715)
,p_lov_display_extra=>false
,p_lov_display_null=>false
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function( options ) {',
'    options.defaultGridColumnOptions = {',
'        noHeaderActivate: true',
'    };',
'    return options;',
'}'))
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_include_in_export=>true
,p_readonly_condition_type=>'ALWAYS'
,p_readonly_for_each_row=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1573568220030408)
,p_name=>'CLIENT_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'CLIENT_ID'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Client ID or Username'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>70
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function( options ) {',
'    options.defaultGridColumnOptions = {',
'        noHeaderActivate: true',
'    };',
'    return options;',
'}'))
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1573698106030409)
,p_name=>'CLIENT_SECRET'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'CLIENT_SECRET'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_PASSWORD'
,p_heading=>'Client Secret or Password'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>80
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_is_required=>false
,p_max_length=>255
,p_use_as_row_header=>false
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function( options ) {',
'    options.defaultGridColumnOptions = {',
'        noHeaderActivate: true',
'    };',
'    return options;',
'}'))
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1573782751030410)
,p_name=>'CLIENT_SECRET_VERIFY'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'CLIENT_SECRET_VERIFY'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_PASSWORD'
,p_heading=>'Verify Client Secret / Password'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>90
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_is_required=>false
,p_max_length=>255
,p_use_as_row_header=>false
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function( options ) {',
'    options.defaultGridColumnOptions = {',
'        noHeaderActivate: true',
'    };',
'    return options;',
'}'))
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1573911821030412)
,p_name=>'APEX$ROW_ACTION'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>30
,p_use_as_row_header=>false
,p_enable_hide=>true
,p_display_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1574068402030413)
,p_name=>'APEX$ROW_SELECTOR'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>20
,p_attribute_01=>'N'
,p_attribute_03=>'Y'
,p_use_as_row_header=>false
,p_enable_hide=>true
,p_display_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(537042414723394617)
,p_name=>'IS_NEW'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'IS_NEW'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_YES_NO'
,p_heading=>'Already Existed'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>40
,p_value_alignment=>'LEFT'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'Yes'
,p_attribute_04=>'Y'
,p_attribute_05=>'No'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function( options ) {',
'    options.defaultGridColumnOptions = {',
'        noHeaderActivate: true',
'    };',
'    return options;',
'}'))
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_include_in_export=>true
,p_readonly_condition_type=>'ALWAYS'
,p_readonly_for_each_row=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(537042994888394622)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(1573109468030404)
,p_internal_uid=>1573109468030404
,p_is_editable=>true
,p_edit_operations=>'u'
,p_lost_update_check_type=>'VALUES'
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_show_nulls_as=>'-'
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>true
,p_show_toolbar=>false
,p_toolbar_buttons=>null
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>true
,p_define_chart_view=>true
,p_enable_download=>false
,p_download_formats=>null
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(1748625822176016)
,p_interactive_grid_id=>wwv_flow_imp.id(1573109468030404)
,p_static_id=>'6778'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(1748792135176016)
,p_report_id=>wwv_flow_imp.id(1748625822176016)
,p_view_type=>'GRID'
,p_stretch_columns=>true
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1749717757176022)
,p_view_id=>wwv_flow_imp.id(1748792135176016)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(1573365246030406)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1750262290176024)
,p_view_id=>wwv_flow_imp.id(1748792135176016)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(1573409629030407)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1750726608176026)
,p_view_id=>wwv_flow_imp.id(1748792135176016)
,p_display_seq=>4
,p_column_id=>wwv_flow_imp.id(1573568220030408)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1751279823176027)
,p_view_id=>wwv_flow_imp.id(1748792135176016)
,p_display_seq=>5
,p_column_id=>wwv_flow_imp.id(1573698106030409)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1751760060176029)
,p_view_id=>wwv_flow_imp.id(1748792135176016)
,p_display_seq=>6
,p_column_id=>wwv_flow_imp.id(1573782751030410)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1752762651176032)
,p_view_id=>wwv_flow_imp.id(1748792135176016)
,p_display_seq=>0
,p_column_id=>wwv_flow_imp.id(1573911821030412)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(537071963030781071)
,p_view_id=>wwv_flow_imp.id(1748792135176016)
,p_display_seq=>2
,p_column_id=>wwv_flow_imp.id(537042414723394617)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(537120707412219956)
,p_view_id=>wwv_flow_imp.id(1748792135176016)
,p_display_seq=>7
,p_column_id=>wwv_flow_imp.id(537042994888394622)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(53108643940609615)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(37899301707472090)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(209922019649064269)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(537043026726394623)
,p_plug_name=>'Remote Servers'
,p_region_name=>'ig_remote_servers'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>50
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with imported_credentials as (',
'    select distinct n001 as imported_id,',
'           c002 as is_new,',
'           c005 as is_overwritten,',
'           c003 as prompt_on_install',
'      from wwv_flow_collections',
'     where collection_name = ''WWV_FLOW_IMPORT_REMOTE_SERVERS''',
')',
'select',
'    r.id,',
'    i.is_new,',
'    i.is_overwritten,',
'    r.name, ',
'    r.base_url,',
'    r.https_host',
'from wwv_remote_servers r, imported_credentials i',
'where r.security_group_id = :FLOW_SECURITY_GROUP_ID',
'  and r.id = i.imported_id',
'  and i.prompt_on_install = ''Y'' ',
'order by name'))
,p_plug_source_type=>'NATIVE_IG'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_collections',
' where collection_name = ''WWV_FLOW_IMPORT_REMOTE_SERVERS''',
'and c003 = ''Y'''))
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(537043227518394625)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>30
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_control_break=>false
,p_enable_hide=>true
,p_is_primary_key=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(537043391440394626)
,p_name=>'IS_NEW'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'IS_NEW'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_YES_NO'
,p_heading=>'Already Existed'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>40
,p_value_alignment=>'LEFT'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'Yes'
,p_attribute_04=>'Y'
,p_attribute_05=>'No'
,p_is_required=>false
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function( options ) {',
'    options.defaultGridColumnOptions = {',
'        noHeaderActivate: true',
'    };',
'    return options;',
'}'))
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_include_in_export=>false
,p_readonly_condition_type=>'ALWAYS'
,p_readonly_for_each_row=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(537043485446394627)
,p_name=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Remote Server Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>60
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_max_length=>255
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function( options ) {',
'    options.defaultGridColumnOptions = {',
'        noHeaderActivate: true',
'    };',
'    return options;',
'}'))
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_include_in_export=>false
,p_readonly_condition_type=>'ALWAYS'
,p_readonly_for_each_row=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(537043536566394628)
,p_name=>'BASE_URL'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'BASE_URL'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Base URL'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>70
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_max_length=>500
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function( options ) {',
'    options.defaultGridColumnOptions = {',
'        noHeaderActivate: true',
'    };',
'    return options;',
'}'))
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(537043688159394629)
,p_name=>'HTTPS_HOST'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'HTTPS_HOST'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'HTTPS Host'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>80
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>500
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function( options ) {',
'    options.defaultGridColumnOptions = {',
'        noHeaderActivate: true',
'    };',
'    return options;',
'}'))
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(537043942970394632)
,p_name=>'APEX$ROW_ACTION'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>20
,p_use_as_row_header=>false
,p_enable_hide=>true
,p_display_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(537044092457394633)
,p_name=>'APEX$ROW_SELECTOR'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_use_as_row_header=>false
,p_enable_hide=>true
,p_display_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(537387933896764703)
,p_name=>'IS_OVERWRITTEN'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'IS_OVERWRITTEN'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_YES_NO'
,p_heading=>'Value Changed'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>50
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_is_required=>false
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function( options ) {',
'    options.defaultGridColumnOptions = {',
'        noHeaderActivate: true',
'    };',
'    return options;',
'}'))
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_include_in_export=>false
,p_readonly_condition_type=>'ALWAYS'
,p_readonly_for_each_row=>false
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(537043154086394624)
,p_internal_uid=>537043154086394624
,p_is_editable=>true
,p_edit_operations=>'u'
,p_lost_update_check_type=>'VALUES'
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_show_nulls_as=>'-'
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>true
,p_show_toolbar=>false
,p_toolbar_buttons=>null
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>true
,p_define_chart_view=>true
,p_enable_download=>false
,p_download_formats=>null
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(537166913744389086)
,p_interactive_grid_id=>wwv_flow_imp.id(537043154086394624)
,p_static_id=>'6779'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(537167094662389086)
,p_report_id=>wwv_flow_imp.id(537166913744389086)
,p_view_type=>'GRID'
,p_stretch_columns=>true
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(537167536060389087)
,p_view_id=>wwv_flow_imp.id(537167094662389086)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(537043227518394625)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(537168031504389091)
,p_view_id=>wwv_flow_imp.id(537167094662389086)
,p_display_seq=>2
,p_column_id=>wwv_flow_imp.id(537043391440394626)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(537168515450389093)
,p_view_id=>wwv_flow_imp.id(537167094662389086)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(537043485446394627)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(537169005627389094)
,p_view_id=>wwv_flow_imp.id(537167094662389086)
,p_display_seq=>5
,p_column_id=>wwv_flow_imp.id(537043536566394628)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(537169583441389096)
,p_view_id=>wwv_flow_imp.id(537167094662389086)
,p_display_seq=>6
,p_column_id=>wwv_flow_imp.id(537043688159394629)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(537183942323477977)
,p_view_id=>wwv_flow_imp.id(537167094662389086)
,p_display_seq=>0
,p_column_id=>wwv_flow_imp.id(537043942970394632)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(572839554495223378)
,p_view_id=>wwv_flow_imp.id(537167094662389086)
,p_display_seq=>4
,p_column_id=>wwv_flow_imp.id(537387933896764703)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(537044270096394635)
,p_plug_name=>'Credentials'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_collections',
' where collection_name = ''WWV_FLOW_IMPORT_CREDENTIALS''',
'and c003 =''Y'''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(537044362491394636)
,p_plug_name=>'Remote Servers'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder'
,p_region_attributes=>'style="margin-top: 30px"'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_collections',
' where collection_name = ''WWV_FLOW_IMPORT_REMOTE_SERVERS''',
'and c003 = ''Y'''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(537044413217394637)
,p_plug_name=>'Information'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>The application has been installed. Please take a moment to review and update the following details.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(748887656107282801)
,p_plug_name=>'Install Application'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1741886583144640)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(209922019649064269)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1779243628268721)
,p_branch_name=>'Go To Page 2150'
,p_branch_action=>'f?p=&APP_ID.:2150:&SESSION.::&DEBUG.:2150,2151,2152:P2150_CANCEL_PAGE:1&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_install_wizard.needs_upgrade (',
'    p_flow_id => :FB_FLOW_ID )'))
,p_branch_condition_text=>'PLSQL'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1779582117270051)
,p_branch_name=>'Go To Page 2100'
,p_branch_action=>'f?p=&APP_ID.:2100:&SESSION.:APP_INSTALLED:&DEBUG.:2100,2101,2102,2103,2105::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_install_scripts   where security_group_id = :flow_security_group_id and flow_id = :fb_flow_id union all',
'select 1 from wwv_flow_install_objects   where security_group_id = :flow_security_group_id and flow_id = :fb_flow_id union all',
'select 1 from wwv_flow_install_checks    where security_group_id = :flow_security_group_id and flow_id = :fb_flow_id union all',
'select 1 from wwv_flow_install_build_opt where security_group_id = :flow_security_group_id and flow_id = :fb_flow_id'))
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1779897359271406)
,p_branch_name=>'Go To Page 733'
,p_branch_action=>'f?p=&APP_ID.:733:&SESSION.::&DEBUG.:2100,2101,2102,2103,2105::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flows',
' where id = :FB_FLOW_ID ',
'   and build_status = ''RUN_ONLY''',
'   and security_group_id = :WORKSPACE_ID'))
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1780111302272589)
,p_branch_name=>'Go To Page 57'
,p_branch_action=>'f?p=&APP_ID.:57:&SESSION.:FLOW:&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1574299910030415)
,p_tabular_form_region_id=>wwv_flow_imp.id(1573009001030403)
,p_validation_name=>'Verify Client Secret'
,p_validation_sequence=>10
,p_validation=>':CLIENT_SECRET = :CLIENT_SECRET_VERIFY or (:CLIENT_SECRET is null and :CLIENT_SECRET_VERIFY is null)'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Client Secrets must match.'
,p_associated_column=>'CLIENT_SECRET_VERIFY'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(537042515525394618)
,p_name=>'Is New'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(1573009001030403)
,p_condition_element_type=>'COLUMN'
,p_condition_element=>'IS_NEW'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'N'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'load'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(537042627331394619)
,p_event_id=>wwv_flow_imp.id(537042515525394618)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'CLIENT_ID,CLIENT_SECRET,CLIENT_SECRET_VERIFY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(537042833724394621)
,p_event_id=>wwv_flow_imp.id(537042515525394618)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'CLIENT_ID,CLIENT_SECRET,CLIENT_SECRET_VERIFY'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1574118315030414)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(1573009001030403)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Credentials - Save Interactive Grid Data'
,p_attribute_01=>'TABLE'
,p_attribute_03=>'WWV_CREDENTIALS_DEV'
,p_attribute_05=>'Y'
,p_attribute_06=>'N'
,p_attribute_08=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1741886583144640)
,p_process_success_message=>'Credentials updated.'
,p_internal_uid=>1574118315030414
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(537044128723394634)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(537043026726394623)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Remote Servers - Save Interactive Grid Data'
,p_attribute_01=>'TABLE'
,p_attribute_03=>'WWV_REMOTE_SERVERS'
,p_attribute_05=>'Y'
,p_attribute_06=>'N'
,p_attribute_08=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1741886583144640)
,p_internal_uid=>537044128723394634
);
end;
/
prompt --application/pages/page_02166
begin
wwv_flow_imp_page.create_page(
 p_id=>2166
,p_name=>'Install Application'
,p_alias=>'INSTALL-APPLICATION4'
,p_step_title=>'Install Application'
,p_allow_duplicate_submissions=>'N'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_code_onload=>'window.setTimeout(function() { apex.submit("INSTALL"); }, 100);'
,p_step_template=>wwv_flow_imp.id(698674781428105900)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'11'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(57480004151728405)
,p_plug_name=>'Installing Supporting Objects...'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(1147295105621079968)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(57481723860728407)
,p_branch_action=>'f?p=&APP_ID.:2155:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(57481207581728406)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Install'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select id, owner from ',
'              (select id from wwv_flow_install where flow_id = :FB_FLOW_ID), ',
'              (select owner from wwv_flows where id = :FB_FLOW_ID))',
'loop',
'  wwv_flow_install_wizard.upgrade (',
'      p_flow_id     => :FB_FLOW_ID,',
'      p_install_id  => c1.id,',
'      p_schema      => c1.owner',
'      );',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to install application.'
,p_internal_uid=>57481207581728406
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(57481407136728406)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process Build Options'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'update wwv_flow_patches ',
'   set patch_status = ''EXCLUDE'' ',
' where id in (select build_opt_id ',
'                from wwv_flow_install_build_opt ',
'               where flow_id = :FB_FLOW_ID ',
'                 and security_group_id = :flow_security_group_id) ',
'   and instr('':''||:P2157_BUILD_OPTIONS||'':'', '':''||ID||'':'') = 0',
'   and security_group_id = :flow_security_group_id;',
'',
'update wwv_flow_patches ',
'   set patch_status = ''INCLUDE'' ',
' where instr('':''||:P2157_BUILD_OPTIONS||'':'', '':''||ID||'':'') > 0',
'   and flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>57481407136728406
);
end;
/
prompt --application/pages/page_02222
begin
wwv_flow_imp_page.create_page(
 p_id=>2222
,p_name=>'Reparent List Entries'
,p_alias=>'REPARENT-LIST-ENTRIES'
,p_step_title=>'Reparent List Entries'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_list.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(33590524192567471)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_plug_query_num_rows=>1500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_row_count_max=>5000
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_col_allignments=>'R:R:L:L:L:R'
,p_plug_query_sum_cols=>'NO:NO:NO:NO:NO:YES'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'generated 16-FEB-2000 23:59:43'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(33595925671624596)
,p_name=>'List Entries'
,p_template=>wwv_flow_imp.id(208928010704475743)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with list_items as (',
'  select',
'    list_item_link_text,  ',
'    id, ',
'    list_item_display_sequence, ',
'    list_item_type, ',
'    substr(list_item_link_target,1,50) list_item_link_target, ',
'    parent_list_item_id,',
'    required_patch build_option,',
'    LIST_ITEM_DISP_COND_TYPE,',
'    last_updated_on, LIST_ITEM_ICON',
'  from wwv_flow_list_items',
'  where list_id = replace(:P2222_LIST_ID,''%''||''null%'',null)',
'    and flow_id = :FB_FLOW_ID',
'    and security_group_id = :WORKSPACE_ID',
') select ',
'      ''<input type="checkbox" name="f01" value="''||id||''" title="''||wwv_flow_lang.system_message(''SELECT_ROW_C'', wwv_flow_escape.html(list_item_link_text))||''" />'' cb,',
'      (level-1)*25 indent,',
'      list_item_link_text,',
'      id,',
'      list_item_display_sequence,',
'      list_item_type,    ',
'      list_item_link_target,',
'      parent_list_item_id,',
'      decode(greatest(0,build_option),0,''! '','''')||',
'      (select patch_name from WWV_FLOW_PATCHES where id = abs(build_Option))',
'      build_option,',
'      decode(LIST_ITEM_DISP_COND_TYPE,null,null,''<span class="a-Icon icon-check"></span><span class="u-VisuallyHidden">''||wwv_flow_lang.system_message(''YES'')||''</span>'') conditional,',
'      last_updated_on,',
'      LIST_ITEM_ICON',
'from list_items',
'start with nvl(parent_list_item_id,0) = nvl(:P2222_START_WITH,0)',
'connect by prior id = parent_list_item_id ',
'order siblings by list_item_display_sequence, list_item_link_text'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>10000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1194418302299758812)
,p_query_column_id=>1
,p_column_alias=>'CB'
,p_column_display_sequence=>1
,p_column_heading=>'#CHECK_ALL_CHECKBOX#'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(33596127245624597)
,p_query_column_id=>2
,p_column_alias=>'INDENT'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(33596224658624598)
,p_query_column_id=>3
,p_column_alias=>'LIST_ITEM_LINK_TEXT'
,p_column_display_sequence=>4
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:4052:&SESSION.::&DEBUG.:RP:F4000_P4052_ID:#ID#:'
,p_column_linktext=>'#LIST_ITEM_LINK_TEXT#'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(33596316770624598)
,p_query_column_id=>4
,p_column_alias=>'ID'
,p_column_display_sequence=>5
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(33596427083624598)
,p_query_column_id=>5
,p_column_alias=>'LIST_ITEM_DISPLAY_SEQUENCE'
,p_column_display_sequence=>3
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(33596528396624598)
,p_query_column_id=>6
,p_column_alias=>'LIST_ITEM_TYPE'
,p_column_display_sequence=>6
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(33596613156624598)
,p_query_column_id=>7
,p_column_alias=>'LIST_ITEM_LINK_TARGET'
,p_column_display_sequence=>7
,p_column_heading=>'Target'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(33596724296624598)
,p_query_column_id=>8
,p_column_alias=>'PARENT_LIST_ITEM_ID'
,p_column_display_sequence=>8
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(33596826598624598)
,p_query_column_id=>9
,p_column_alias=>'BUILD_OPTION'
,p_column_display_sequence=>11
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(33596914432624598)
,p_query_column_id=>10
,p_column_alias=>'CONDITIONAL'
,p_column_display_sequence=>10
,p_column_heading=>'Conditional'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(33597030598624598)
,p_query_column_id=>11
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>12
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(33597113464624598)
,p_query_column_id=>12
,p_column_alias=>'LIST_ITEM_ICON'
,p_column_display_sequence=>9
,p_column_heading=>'Image'
,p_use_as_row_header=>'N'
,p_display_when_cond_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_condition=>'P4050_SHOW_IMAGE_NAMES'
,p_display_when_condition2=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(40982312965484269)
,p_plug_name=>'Reparent List Entries'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'This page is used to manage a List Entry hierarchy.  Use the <strong>Start With</strong> select list to restrict your view to a subset of the List Entry hierarchy.',
'<p />',
'To reparent entries, select the new parent, then check the checkboxes corresponding to the list entries you wish move.  Finally, press the <strong>Reparent Checked Entries</strong> button to perform the action.',
''))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(63319801445126819)
,p_plug_name=>'Reparent'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(33591803292567480)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(33590524192567471)
,p_button_name=>'P2222_GO'
,p_button_static_id=>'P2222_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Go'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(63322631574135454)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(63319801445126819)
,p_button_name=>'P2222_REPARENT'
,p_button_static_id=>'P2222_REPARENT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Reparent Checked Entries'
,p_button_position=>'NEXT'
,p_request_source=>'REPARENT'
,p_request_source_type=>'STATIC'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(33594809048619820)
,p_branch_action=>'f?p=&APP_ID.:2222:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33590819531567476)
,p_name=>'P2222_LIST_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(33590524192567471)
,p_item_default=>'0'
,p_prompt=>'List'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name, id',
'  from wwv_flow_lists',
' where flow_id                 = :FB_FLOW_ID',
'   and security_group_id       = :WORKSPACE_ID',
'   and nvl(list_type,''STATIC'') = ''STATIC''',
'   AND reference_id            is null',
' order by upper(name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select List -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the list you would like to edit.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33591305991567480)
,p_name=>'P2222_NEW_PARENT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(63319801445126819)
,p_prompt=>'Reparent To'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select LIST_ITEM_DISPLAY_SEQUENCE||''. ''||wwv_flow_escape.html(list_item_link_text) d,  ',
'       id',
'  from wwv_flow_list_items',
' where list_id = replace(:P2222_LIST_ID,''%''||''null%'',null)',
'   and flow_id = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and sub_list_id is null',
' order by LIST_ITEM_DISPLAY_SEQUENCE, LIST_ITEM_LINK_TEXT'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Parent Entry -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the new parent for checked List Entries.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(63330605910175325)
,p_name=>'P2222_START_WITH'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_imp.id(33590524192567471)
,p_prompt=>'Start With'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P2222 LIST ENTRIES START WITH'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select lpad('' '',4*(level-1),''.'')|| wwv_flow_escape.html(list_item_link_text) list_item_link_text, id',
'from wwv_flow_list_items i',
'where flow_id = :FB_FLOW_ID',
' and security_group_id = :WORKSPACE_ID',
' and list_id = :P2222_LIST_ID',
'start with parent_list_item_id is null       ',
'connect by prior id = parent_list_item_id ',
'        and prior list_id = list_id',
'order siblings by list_item_display_sequence'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- All Entries -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Restrict the view to list entries that are a child of this entry.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(40234627784482846)
,p_validation_name=>'P2222_NEW_PARENT'
,p_validation_sequence=>10
,p_validation=>'P2222_NEW_PARENT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(63322631574135454)
,p_associated_item=>wwv_flow_imp.id(33591305991567480)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1194418100945758810)
,p_name=>'ADD CHECK ALL CHECKBOX'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(33595925671624596)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1194418208384758811)
,p_event_id=>wwv_flow_imp.id(1194418100945758810)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'PLUGIN_COM.ORACLE.APEX.ADD_CHECKALL_CHECKBOX'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(63332016991178559)
,p_process_sequence=>5
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_process_when_button_id=>wwv_flow_imp.id(33591803292567480)
,p_internal_uid=>63332016991178559
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(33727023172435350)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Reparent List Entries'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if  :P2222_NEW_PARENT != 0 then',
'for i in 1..wwv_flow.g_f01.count loop',
'   update wwv_flow_list_items ',
'   set parent_list_item_id = :P2222_NEW_PARENT',
'   where list_id = :P2222_LIST_ID and ',
'         id = to_number(wwv_flow.g_f01(i)) and',
'         security_group_id = :flow_security_group_id and ',
'         flow_id = :fb_flow_id;',
'end loop;',
'else',
'for i in 1..wwv_flow.g_f01.count loop',
'   update wwv_flow_list_items ',
'   set parent_list_item_id = null',
'   where list_id = :P2222_LIST_ID and ',
'         id = to_number(wwv_flow.g_f01(i)) and',
'         security_group_id = :flow_security_group_id and ',
'         flow_id = :fb_flow_id and',
'         :P2222_NEW_PARENT = 0;',
'end loop;',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to reparent List Entries'
,p_process_when_button_id=>wwv_flow_imp.id(63322631574135454)
,p_process_when=>'nvl(wwv_flow.g_f01.count,0) != 0'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'List Entries Re-parented'
,p_internal_uid=>33727023172435350
);
end;
/
prompt --application/pages/page_02300
begin
wwv_flow_imp_page.create_page(
 p_id=>2300
,p_name=>'Application Access Control'
,p_alias=>'APPLICATION-ACCESS-CONTROL'
,p_step_title=>'Application Access Control'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213425326892450628)
,p_inline_css=>'.code-inline {white-space: normal; font-size: 11px; word-break: break-word;}'
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_build_options.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2048320184861301)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_landmark_type=>'region'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2614255303441829)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(4484441724644222)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(79232973737259819)
,p_plug_name=>'Landmark for Displayed Regions '
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>30
,p_landmark_type=>'region'
,p_landmark_label=>'Displayed Regions'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2050757180861325)
,p_plug_name=>'Roles'
,p_parent_plug_id=>wwv_flow_imp.id(79232973737259819)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select r.id,',
'       r.group_name name,',
'       r.static_id,',
'       r.group_desc description,',
'       ( select count(*)',
'           from wwv_flow_acl_group_users u',
'          where u.group_id          = r.id',
'            and u.security_group_id = r.security_group_id ) assigned_user_count,',
'       --',
'       case when r.reference_id is not null then',
'           coalesce ( to_char( master.flow_id ),',
'                       wwv_flow_lang_dev.builder_message( ''SUBSCRIBED_FROM.NONEXISTING_MASTER'' ) )',
'       end as subscribed_from,',
'       ( select case when count(*) > 0 then count(*) end',
'           from wwv_flow_fnd_user_groups sub',
'          where sub.reference_id      = r.id',
'            and sub.security_group_id = :FLOW_SECURITY_GROUP_ID',
'       ) as subscribers,',
'       case when r.reference_id is not null then',
'           case',
'               when master.version_scn = r.version_scn then',
'                   wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_UP_TO_DATE'')',
'               when master.version_scn != r.version_scn then',
'                   wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_NEEDS_REFRESH'')',
'               else',
'                   wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_UNKNOWN'')',
'           end',
'       end subscription_status,',
'       --',
'       null as actions',
'  from wwv_flow_fnd_user_groups r,',
'       wwv_flow_fnd_user_groups master',
' where r.flow_id           = :FB_FLOW_ID',
'   and r.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and r.reference_id      = master.id (+)',
'   and r.security_group_id = master.security_group_id (+)'))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(2050828593861326)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'No Application Roles are defined for this application'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'SHAKEEB'
,p_internal_uid=>2050828593861326
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2050958389861327)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2051018825861328)
,p_db_column_name=>'NAME'
,p_display_order=>30
,p_column_identifier=>'B'
,p_column_label=>'Role'
,p_column_link=>'f?p=&APP_ID.:2320:&SESSION.::&DEBUG.:RP,2320:F4000_P2320_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(84538588770706811)
,p_db_column_name=>'STATIC_ID'
,p_display_order=>40
,p_column_identifier=>'G'
,p_column_label=>'Static Identifier'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2051122296861329)
,p_db_column_name=>'ASSIGNED_USER_COUNT'
,p_display_order=>50
,p_column_identifier=>'C'
,p_column_label=>'Users'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(724232932501924808)
,p_db_column_name=>'DESCRIPTION'
,p_display_order=>60
,p_column_identifier=>'H'
,p_column_label=>'Description'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4795671697120902)
,p_db_column_name=>'SUBSCRIBED_FROM'
,p_display_order=>80
,p_column_identifier=>'J'
,p_column_label=>'Subscribed From'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4795751879120903)
,p_db_column_name=>'SUBSCRIBERS'
,p_display_order=>90
,p_column_identifier=>'K'
,p_column_label=>'Subscribers'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(6611266122558817)
,p_db_column_name=>'SUBSCRIPTION_STATUS'
,p_display_order=>100
,p_column_identifier=>'L'
,p_column_label=>'Subscription Status'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2185182913145941)
,p_db_column_name=>'ACTIONS'
,p_display_order=>110
,p_column_identifier=>'M'
,p_column_label=>'Copy'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'TMPL_THEME_3$ACTIONS'
,p_column_alignment=>'CENTER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'ACTIONS_WRAP', 'N',
  'STYLE', 'b-InlineActions--simple')).to_clob
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(2117833588027975)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'21179'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'NAME:STATIC_ID:ASSIGNED_USER_COUNT:DESCRIPTION:SUBSCRIBED_FROM:SUBSCRIPTION_STATUS:SUBSCRIBERS:ACTIONS'
,p_sort_column_1=>'NAME'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'0'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(342363357189652550)
,p_plug_name=>'User Role Assignments'
,p_parent_plug_id=>wwv_flow_imp.id(79232973737259819)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       user_name,',
'       role_names',
'  from apex_appl_acl_users',
' where application_id = :FB_FLOW_ID',
'   and workspace_id   = :WORKSPACE_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(92468021968325911)
,p_max_row_count=>'1000000'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'CHRISTIAN'
,p_internal_uid=>92468021968325911
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(92468383956325914)
,p_db_column_name=>'USER_NAME'
,p_display_order=>30
,p_column_identifier=>'B'
,p_column_label=>'User Name'
,p_column_link=>'f?p=&APP_ID.:2310:&SESSION.::&DEBUG.:RP,2310:P2310_ID:#ID#'
,p_column_linktext=>'#USER_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(183818757805773715)
,p_db_column_name=>'ROLE_NAMES'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>'Roles'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4348303304260378503)
,p_db_column_name=>'ID'
,p_display_order=>70
,p_column_identifier=>'E'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(95148537308558700)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'951486'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'USER_NAME::ROLE_NAMES'
,p_sort_column_1=>'USER_NAME'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(732476782572293403)
,p_plug_name=>'Application Access Control'
,p_region_template_options=>'a-ButtonRegion--withItems:a-ButtonRegion--wizard:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_landmark_type=>'exclude_landmark'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1375157107785598382)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Access Control requires that developers define application users and roles. Since roles are applied to users, you must create roles before adding users. You can assign users to one or more roles.</p>',
'<p>To control access to application pages and components, you need to create an Authorization Scheme.</p> ',
'<p>Roles and users defined for applications can be reviewed using the following views:<br>',
'<code>APEX_APPL_ACL_USERS<br>',
'APEX_APPL_ACL_USER_ROLES<br>',
'APEX_APPL_ACL_ROLES',
'</code>',
'</p>',
'<p>Use the following API to manage access control settings:<br>',
'<code>APEX_ACL</code>',
'</p>',
'<a href="&SYSTEM_HELP_URL." target="_blank">Learn More ...</a>'))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(95187252405614222)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(342363357189652550)
,p_button_name=>'CREATE_USER_ASSIGNMENT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'Add User Role Assignment'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:2310:&SESSION.::&DEBUG.:2310::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(715710270785990572)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2050757180861325)
,p_button_name=>'CREATE_ROLE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'Add Role'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:2320:&SESSION.::&DEBUG.:2320::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(715712323606990586)
,p_branch_action=>'2310'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1601971360247508)
,p_name=>'P2300_ROLES_COUNT'
,p_item_sequence=>10
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*)',
'  from wwv_flow_fnd_user_groups r',
' where r.flow_id           = :FB_FLOW_ID',
'   and r.security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_item_default_type=>'SQL_QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(715711087584990581)
,p_computation_sequence=>20
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'2300'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(715711324753990582)
,p_name=>'Dialog Close - Role'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(2050757180861325)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2615898471441845)
,p_event_id=>wwv_flow_imp.id(715711324753990582)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2050757180861325)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1402200500748307)
,p_event_id=>wwv_flow_imp.id(715711324753990582)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_name=>'Refresh User Role Assignments'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(342363357189652550)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2615909448441846)
,p_event_id=>wwv_flow_imp.id(715711324753990582)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ( this.data.successMessage ) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1602065141247509)
,p_event_id=>wwv_flow_imp.id(715711324753990582)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_name=>'Set Roles Count'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2300_ROLES_COUNT'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*)',
'  from wwv_flow_fnd_user_groups r',
' where r.flow_id           = :FB_FLOW_ID',
'   and r.security_group_id = :FLOW_SECURITY_GROUP_ID',
''))
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(183819485064773722)
,p_name=>'Dialog Close - Role Assignment'
,p_event_sequence=>30
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(342363357189652550)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(183819570974773723)
,p_event_id=>wwv_flow_imp.id(183819485064773722)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(342363357189652550)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6660748188151758)
,p_name=>'Refresh Subscriptions'
,p_event_sequence=>40
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(2614255303441829)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6661107256151760)
,p_event_id=>wwv_flow_imp.id(6660748188151758)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2050757180861325)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6661690904151761)
,p_event_id=>wwv_flow_imp.id(6660748188151758)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ( this.data.successMessage ) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1602171217247510)
,p_name=>'Value Change - P2300_ROLES_COUNT'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2300_ROLES_COUNT'
,p_condition_element=>'P2300_ROLES_COUNT'
,p_triggering_condition_type=>'GREATER_THAN'
,p_triggering_expression=>'0'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1602261891247511)
,p_event_id=>wwv_flow_imp.id(1602171217247510)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Enable CREATE_USER_ASSIGNMENT Button'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(95187252405614222)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1602305964247512)
,p_event_id=>wwv_flow_imp.id(1602171217247510)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Disable CREATE_USER_ASSIGNMENT Button'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(95187252405614222)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(92467852848325909)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(342363357189652550)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'User Assignments - Save Interactive Grid Data'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>92467852848325909
);
wwv_flow_imp_page.create_component_action(
 p_id=>wwv_flow_imp.id(2185248758145942)
,p_ir_column_id=>wwv_flow_imp.id(2185182913145941)
,p_position_id=>wwv_flow_imp.id(214437533860142316)
,p_display_sequence=>10
,p_template_id=>wwv_flow_imp.id(214438625365151034)
,p_label=>'Copy'
,p_link_target_type=>'REDIRECT_PAGE'
,p_link_target=>'f?p=&APP_ID.:2330:&SESSION.::&DEBUG.:2330:P2330_COPY_SOURCE,P2330_ID,P2330_COPY_FROM_APPLICATION_ID:THIS,#ID#,&FB_FLOW_ID.'
,p_button_display_type=>'ICON'
,p_icon_css_classes=>'icon-copy'
,p_is_hot=>false
,p_show_as_disabled=>false
);
end;
/
prompt --application/pages/page_02310
begin
wwv_flow_imp_page.create_page(
 p_id=>2310
,p_name=>'User Assignment'
,p_alias=>'USER-ASSIGNMENT'
,p_page_mode=>'MODAL'
,p_step_title=>'User Assignment'
,p_reload_on_submit=>'A'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213481614528579568)
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-EditScreen-body {padding-top: 0;}',
'.apex-item-group--rc {margin: 4px 0}'))
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_build_options.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(84538272731706808)
,p_plug_name=>'About Application Users'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--warning:a-Alert--horizontal'
,p_region_attributes=>'style="margin: 12px;"'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>10
,p_plug_source=>'Application users are not exported as part of your application.  When you deploy your application you will need to manually manage your user to role assignments.  Roles are exported as part of an application export and imported with application impor'
||'ts.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2194001926764519201)
,p_plug_name=>'Attributes'
,p_region_template_options=>'#DEFAULT#:a-Form--fixedLabels'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_plug_query_show_nulls_as=>'(null)'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(84538366606706809)
,p_plug_name=>'User Attributes'
,p_parent_plug_id=>wwv_flow_imp.id(2194001926764519201)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2809519452134236128)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noBorder'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(95156035557580475)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(2809519452134236128)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.confirm(''&DELETE_MSG.'', {request:''DELETE''});'
,p_button_execute_validations=>'N'
,p_button_condition=>'P2310_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(95156478329580479)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(2809519452134236128)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save'
,p_button_position=>'NEXT'
,p_button_condition=>'P2310_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(95156801859580479)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(2809519452134236128)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Assignment'
,p_button_position=>'NEXT'
,p_button_condition=>'P2310_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(95157285184580480)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2809519452134236128)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(95154166004580466)
,p_name=>'P2310_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(84538366606706809)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(95154930255580470)
,p_name=>'P2310_USER_NAME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(84538366606706809)
,p_use_cache_before_default=>'NO'
,p_prompt=>'User Name'
,p_source=>'USER_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_tag_css_classes=>'u-textUpper'
,p_read_only_when=>'P2310_ID'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'NO_SPECIAL_CHAR_NL'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(95155394255580471)
,p_name=>'P2310_ROLE_IDS'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(84538366606706809)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application Role'
,p_source=>'ROLE_IDS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'APP_ACL_GROUPS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select group_name d,',
'       id r',
'  from wwv_flow_fnd_user_groups',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID',
' order by 1'))
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(183819223624773720)
,p_name=>'P2310_APPLICATION_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(84538366606706809)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_source=>'APPLICATION_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(222858806571540016)
,p_computation_sequence=>10
,p_computation_item=>'P2310_USER_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(:P2310_USER_NAME)'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(95158188037580491)
,p_validation_name=>'user name exists'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_acl_group_users u,',
'       wwv_flow_fnd_user_groups g',
' where u.security_group_id = :WORKSPACE_ID',
'   and u.user_name         = upper(:P2310_USER_NAME)',
'   and g.id                = u.group_id',
'   and g.flow_id           = :FB_FLOW_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'The user assignment already exists.  '
,p_when_button_pressed=>wwv_flow_imp.id(95156801859580479)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(95159285570580492)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(95157285184580480)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(95159764749580493)
,p_event_id=>wwv_flow_imp.id(95159285570580492)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(95158483332580491)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from APEX_APPL_ACL_USERS'
,p_attribute_02=>'APEX_APPL_ACL_USERS'
,p_attribute_03=>'P2310_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'workspace_id = :WORKSPACE_ID'
,p_process_error_message=>'Error fetching row.'
,p_internal_uid=>95158483332580491
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(183818896809773716)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'DML'
,p_attribute_02=>'APEX_APPL_ACL_USERS'
,p_attribute_03=>'P2310_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'workspace_id = :WORKSPACE_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>183818896809773716
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(183818948108773717)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE,SAVE,DELETE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_internal_uid=>183818948108773717
);
end;
/
prompt --application/pages/page_02320
begin
wwv_flow_imp_page.create_page(
 p_id=>2320
,p_name=>'Role'
,p_alias=>'ROLE'
,p_page_mode=>'MODAL'
,p_step_title=>'Role'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213481614528579568)
,p_inline_css=>'.a-EditScreen-body {padding-top: 0;}'
,p_page_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_read_only_when=>'P2320_REFERENCE_ID'
,p_help_text=>'deploy_build_options.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9191527529579686)
,p_plug_name=>'Subscription'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'F4000_P2320_ID'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'WWV_FLOW_FND_USER_GROUPS',
  'attribute_02', 'GROUP_NAME',
  'attribute_03', 'F4000_P2320_ID',
  'attribute_04', 'P2320_REFERENCE_ID',
  'attribute_05', 'SUBSCRIBE_USER_GROUP',
  'attribute_06', 'VERSION_SCN')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(244599679538454702)
,p_plug_name=>'Associated Authorization Schemes'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_security_schemes',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and ( scheme_type in (''NATIVE_IS_IN_GROUP'', ''NATIVE_IS_NOT_IN_GROUP'') )',
'   and instr(attribute_01, :P2320_GROUP_NAME, 1) > 0'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(212736479171785625)
,p_name=>'Associated Authorization Schemes'
,p_parent_plug_id=>wwv_flow_imp.id(244599679538454702)
,p_template=>wwv_flow_imp.id(208928010704475743)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--noBorders:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       name,',
'       scheme_type',
'  from wwv_flow_security_schemes',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and ( scheme_type in (''NATIVE_IS_IN_GROUP'', ''NATIVE_IS_NOT_IN_GROUP'') )',
'   and instr(attribute_01, :P2320_GROUP_NAME, 1) > 0'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(212736728217785628)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(212736585906785626)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Authorization Scheme'
,p_use_as_row_header=>'Y'
,p_column_link=>'f?p=&APP_ID.:4008:&SESSION.::&DEBUG.:RP,4008:F4000_P4008_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(212736645018785627)
,p_query_column_id=>3
,p_column_alias=>'SCHEME_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'Scheme Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(11239432234132441)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(244599572364454701)
,p_plug_name=>'Notice'
,p_parent_plug_id=>wwv_flow_imp.id(244599679538454702)
,p_region_css_classes=>'a-Alert--noTitle a-Alert--page'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'Changing the Name or Static Identifier of this Role may cause the following associated authorization schemes to fail.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2098848429433938746)
,p_plug_name=>'Attributes'
,p_region_template_options=>'#DEFAULT#:a-Form--fixedLabels'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_FND_USER_GROUPS'
,p_query_where=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    flow_id           = :FB_FLOW_ID',
'and security_group_id = :WORKSPACE_ID'))
,p_include_rowid_column=>false
,p_is_editable=>false
,p_plug_source_type=>'NATIVE_FORM'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2714365954803655673)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noBorder'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4784868847437074)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_imp.id(9191527529579686)
,p_button_name=>'UNSUBSCRIBE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Unsubscribe'
,p_button_position=>'EDIT'
,p_button_condition=>':P2320_REFERENCE_ID is not null and :P2320_SUBSCRIBED_COMP_GRP = ''N'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4785205580437075)
,p_button_sequence=>110
,p_button_plug_id=>wwv_flow_imp.id(9191527529579686)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Refresh Role'
,p_button_position=>'EDIT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P2320_REFERENCE_ID is not null ',
'and ( :P2320_VERSION_SCN != :P2320_MASTER_VERSION_SCN or :P2320_VERSION_SCN is null )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4785643299437075)
,p_button_sequence=>120
,p_button_plug_id=>wwv_flow_imp.id(9191527529579686)
,p_button_name=>'PUBLISH'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Publish'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.:149:F4000_P149_ID,F4000_P149_TEMPLATE_TYPE,F4000_P149_PAGE_ID:&F4000_P2320_ID.,APP_ACL,2320'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * ',
'  from wwv_flow_fnd_user_groups',
' where reference_id      = :F4000_P2320_ID ',
'   and security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(723638267001587820)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(2714365954803655673)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_confirm_message=>'&DELETE_MSG.'
,p_confirm_style=>'danger'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P2320_ID is not null',
'and ( :P2320_REFERENCE_ID is null or :P2320_SUBSCRIBED_COMP_GRP = ''N'' )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(723638614437587821)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(2714365954803655673)
,p_button_name=>'SAVE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>':F4000_P2320_ID is not null and :P2320_REFERENCE_ID is null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(723639016963587821)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(2714365954803655673)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Role'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P2320_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(723637864061587818)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2714365954803655673)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2614087743441827)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(2714365954803655673)
,p_button_name=>'COPY'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Copy from another app'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:2330:&SESSION.::&DEBUG.:2330:P2330_COPY_SOURCE:OTHER'
,p_button_condition=>'F4000_P2320_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_button_css_classes=>'a-Button--noUI'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2358387825667328)
,p_name=>'P2320_SUBSCRIBED_COMP_GRP'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(9191527529579686)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2615295840441839)
,p_name=>'P2320_REFERENCE_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(9191527529579686)
,p_item_source_plug_id=>wwv_flow_imp.id(2098848429433938746)
,p_prompt=>'Subscribe From'
,p_source=>'REFERENCE_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FLOW_SUBSCRIBE_FROM_ROLES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select b.flow_id ||'' ''||f.name||'' - ''|| b.group_name d,',
'       b.id r',
'  from wwv_flow_fnd_user_groups b,',
'       wwv_main_apps_dev f',
' where b.flow_id          != nvl(:FB_FLOW_ID,0)',
'   and b.flow_id           = f.id',
'   and f.build_status      not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'   and b.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and f.security_group_id = :FLOW_SECURITY_GROUP_ID',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Subscription -'
,p_cSize=>50
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a master role to subscribe from. When you select a master role and click on the <strong>Apply Changes</strong> button, the role details will be automatically refreshed from the selected master.<br /><br />If the role is already subscribed, the'
||'n click on the <strong>Refresh Role</strong> button to refresh the role details from the master role.'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2615381719441840)
,p_name=>'P2320_REFERENCE_ID_INIT'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(9191527529579686)
,p_item_default=>'P2320_REFERENCE_ID'
,p_item_default_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4798085119120926)
,p_name=>'P2320_VERSION_SCN'
,p_source_data_type=>'NUMBER'
,p_is_query_only=>true
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(2098848429433938746)
,p_item_source_plug_id=>wwv_flow_imp.id(2098848429433938746)
,p_source=>'VERSION_SCN'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4798134691120927)
,p_name=>'P2320_MASTER_VERSION_SCN'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(9191527529579686)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select version_scn ',
'  from wwv_flow_fnd_user_groups',
' where id                = :P2320_REFERENCE_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(177065667019875217)
,p_name=>'P2320_STATIC_ID'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(2098848429433938746)
,p_item_source_plug_id=>wwv_flow_imp.id(2098848429433938746)
,p_prompt=>'Static Identifier'
,p_source=>'STATIC_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(723633035202587807)
,p_name=>'F4000_P2320_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(2098848429433938746)
,p_item_source_plug_id=>wwv_flow_imp.id(2098848429433938746)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(723633423779587810)
,p_name=>'P2320_FLOW_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(2098848429433938746)
,p_item_source_plug_id=>wwv_flow_imp.id(2098848429433938746)
,p_item_default=>'&FB_FLOW_ID.'
,p_source=>'FLOW_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(723633825844587811)
,p_name=>'P2320_GROUP_NAME'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(2098848429433938746)
,p_item_source_plug_id=>wwv_flow_imp.id(2098848429433938746)
,p_prompt=>'Name'
,p_source=>'GROUP_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(723634785936587812)
,p_name=>'P2320_GROUP_DESC'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(2098848429433938746)
,p_item_source_plug_id=>wwv_flow_imp.id(2098848429433938746)
,p_prompt=>'Description'
,p_source=>'GROUP_DESC'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2358430635667329)
,p_computation_sequence=>10
,p_computation_item=>'P2320_SUBSCRIBED_COMP_GRP'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_component_group_dev.is_part_of_subscribed_comp_grp (',
'    p_component_id   => :F4000_P2320_ID,',
'    p_component_type => wwv_flow_copy_metadata.c_user_group,',
'    p_app_id         => :FB_FLOW_ID )'))
,p_compute_when=>'F4000_P2320_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(723639821255587834)
,p_validation_name=>'Unique Group Name Check'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_fnd_user_groups',
' where security_group_id = :WORKSPACE_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and group_name        = :P2320_GROUP_NAME',
'   and (   :F4000_P2320_ID is null',
'        or id              <> :F4000_P2320_ID )'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#LABEL# is already used by another role.  '
,p_validation_condition=>'Delete'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_associated_item=>wwv_flow_imp.id(723633825844587811)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(177068028295885503)
,p_validation_name=>'Only Valid Characters'
,p_validation_sequence=>40
,p_validation=>'P2320_STATIC_ID'
,p_validation_type=>'ITEM_IS_ALPHANUMERIC'
,p_error_message=>'Identifier may only contain alphanumeric characters and "_".'
,p_associated_item=>wwv_flow_imp.id(177065667019875217)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2615637033441843)
,p_validation_name=>'No duplicate subscription'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_fnd_user_groups',
' where security_group_id = :WORKSPACE_ID ',
'   and flow_id           = :FB_FLOW_ID ',
'   and reference_id      = :P2320_REFERENCE_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'There is another role in this application that is subscribed to the same master. Please select any other master role.'
,p_validation_condition=>':P2320_REFERENCE_ID is not null and :P2320_REFERENCE_ID_INIT is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(723638614437587821)
,p_associated_item=>wwv_flow_imp.id(2615295840441839)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3957240172502137)
,p_validation_name=>'Not part of component groups'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not wwv_flow_component_group_dev.is_part_of_comp_grp (',
'    p_component_id   => :F4000_P2320_ID,',
'    p_component_type => wwv_flow_copy_metadata.c_user_group,',
'    p_app_id         => :FB_FLOW_ID )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Role cannot be deleted because it is part of a component group.'
,p_when_button_pressed=>wwv_flow_imp.id(723638267001587820)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(723641331942587836)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(723637864061587818)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(723641828608587837)
,p_event_id=>wwv_flow_imp.id(723641331942587836)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(177067845109885501)
,p_name=>'Update Static ID'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2320_GROUP_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'keyup'
,p_display_when_type=>'ITEM_IS_NULL'
,p_display_when_cond=>'F4000_P2320_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(177067906911885502)
,p_event_id=>wwv_flow_imp.id(177067845109885501)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'$s(''P2320_STATIC_ID'',$v(''P2320_GROUP_NAME'').replace(/\s+/g, ''_'').toUpperCase());'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6611009648558815)
,p_name=>'Hide P2320_REFERENCE_ID'
,p_event_sequence=>40
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P2320_REFERENCE_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6611146402558816)
,p_event_id=>wwv_flow_imp.id(6611009648558815)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2320_REFERENCE_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2358517450667330)
,p_name=>'Save'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(723638614437587821)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2358668616667331)
,p_event_id=>wwv_flow_imp.id(2358517450667330)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'Are you sure you want to subscribe? This will overwrite the current role data with the selected master role.'
,p_attribute_03=>'warning'
,p_attribute_06=>'Subscribe'
,p_attribute_07=>'Cancel'
,p_client_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_client_condition_expression=>'$v(''P2320_REFERENCE_ID'') !== "" && $v(''P2320_REFERENCE_ID_INIT'') === ""'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2358761725667332)
,p_event_id=>wwv_flow_imp.id(2358517450667330)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'SAVE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(723640598242587835)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(2098848429433938746)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process Row'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE,SAVE,DELETE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'Action Processed'
,p_internal_uid=>723640598242587835
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2615572104441842)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh Role'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.refresh_component (',
'    p_component_type     => wwv_flow_copy_metadata.c_user_group,',
'    p_master_id          => :P2320_REFERENCE_ID,',
'    p_subscribing_id     => :F4000_P2320_ID,',
'    p_subscribing_app_id => :FB_FLOW_ID );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Refresh failed. #SQLERRM_TEXT#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST = ''REFRESH''',
'or ( :REQUEST = ''SAVE'' and :P2320_REFERENCE_ID is not null and :P2320_REFERENCE_ID_INIT is null )'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Role refreshed from the master.'
,p_internal_uid=>2615572104441842
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(6654683705049293)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Unsubscribe'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.unsubscribe_component (',
'    p_component_type  => wwv_flow_copy_metadata.c_user_group,',
'    p_component_id    => :F4000_P2320_ID,',
'    p_app_id          => :FB_FLOW_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(4784868847437074)
,p_process_success_message=>'Role has been unsubscribed.'
,p_internal_uid=>6654683705049293
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4644827546777437)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Clear Subscriptions'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- when deleting the component, clear reference_id data from subscribing apps',
'--',
'wwv_flow_copy_metadata.clear_subscriptions (',
'    p_component_type => wwv_flow_copy_metadata.c_user_group,',
'    p_master_id      => :F4000_P2320_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(723638267001587820)
,p_internal_uid=>4644827546777437
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2615761592441844)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>2615761592441844
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2614391988441830)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(2098848429433938746)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Role'
,p_internal_uid=>2614391988441830
);
end;
/
prompt --application/pages/page_02330
begin
wwv_flow_imp_page.create_page(
 p_id=>2330
,p_name=>'Copy Role'
,p_alias=>'COPY-ROLE'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Role'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'auto'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_protection_level=>'C'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(62001876204697928)
,p_plug_name=>'Wizard Button'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(246742858852840817)
,p_plug_name=>'Copy Role'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3768918102282648)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(62001876204697928)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4411858787904121)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(62001876204697928)
,p_button_name=>'COPY_FROM_ANOTHER'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Copy from another app'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:2330:&SESSION.::&DEBUG.:2330:P2330_COPY_SOURCE:OTHER'
,p_button_condition=>'P2330_COPY_SOURCE'
,p_button_condition2=>'THIS'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_button_css_classes=>'a-Button--noUI'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3769334249282650)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(62001876204697928)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy Role'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3782492544282698)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(3769334249282650)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2613510192441822)
,p_name=>'P2330_STATIC_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(246742858852840817)
,p_prompt=>'Static Identifier'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the static identifier value for the role. Static Identifier must be unique within the application and it may contain only alphanumeric characters and underscores "_".'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_attribute_06=>'UPPER'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(15579117278031728)
,p_name=>'P2330_NEW_USER_GROUP_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(246742858852840817)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30586513978822941)
,p_name=>'P2330_SUBSCRIBE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(246742858852840817)
,p_item_default=>'Y'
,p_prompt=>'Subscribe'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>'P2330_COPY_SOURCE'
,p_display_when2=>'OTHER'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'While copying the role, you can also subscribe to it. Set Subscribe to <strong>On</strong> to subscribe to the role.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30886112781901538)
,p_name=>'P2330_COPY_SOURCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(246742858852840817)
,p_item_default=>'THIS'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(227254270948763324)
,p_name=>'P2330_COPY_FROM_APPLICATION_ID'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(246742858852840817)
,p_prompt=>'Application'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST OTHER FLOWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'  from   wwv_flow_visible_flows f',
' where id != :FB_FLOW_ID',
'   and build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'order by 2'))
,p_lov_cascade_parent_items=>'P2330_COPY_SOURCE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>'P2330_COPY_SOURCE'
,p_display_when2=>'OTHER'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Select the application from which you want to copy a role.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(246764772307880708)
,p_name=>'P2330_GROUP_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(246742858852840817)
,p_prompt=>'New Role Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the role name. Role name must be unique within the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(246768088583885414)
,p_name=>'P2330_ID'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(246742858852840817)
,p_prompt=>'Copy Role'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select group_name d,',
'       id r',
'  from wwv_flow_fnd_user_groups',
' where flow_id           = :P2330_COPY_FROM_APPLICATION_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
' order by upper(group_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Role -'
,p_lov_null_value=>'0'
,p_lov_cascade_parent_items=>'P2330_COPY_FROM_APPLICATION_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_read_only_when=>'P2330_ID'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify a role to copy.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'Y'
,p_attribute_06=>'0'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3774752184282687)
,p_validation_name=>'P2330_GROUP_NAME not null'
,p_validation_sequence=>10
,p_validation=>'P2330_GROUP_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>':P2330_COPY_SOURCE = ''THIS'' or :P2330_SUBSCRIBE = ''N'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(3769334249282650)
,p_associated_item=>wwv_flow_imp.id(246764772307880708)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3775115966282688)
,p_validation_name=>'P2330_GROUP_NAME unique'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_fnd_user_groups',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and group_name        = :P2330_GROUP_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'A role with same name exists in the current application. Please enter a different name.'
,p_validation_condition=>':P2330_COPY_SOURCE = ''THIS'' or :P2330_SUBSCRIBE = ''N'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(3769334249282650)
,p_associated_item=>wwv_flow_imp.id(246764772307880708)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2613908381441826)
,p_validation_name=>'P2330_STATIC_ID not null'
,p_validation_sequence=>30
,p_validation=>'P2330_STATIC_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>':P2330_COPY_SOURCE = ''THIS'' or :P2330_SUBSCRIBE = ''N'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(3769334249282650)
,p_associated_item=>wwv_flow_imp.id(2613510192441822)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2613838735441825)
,p_validation_name=>'P2330_STATIC_ID unique'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_fnd_user_groups',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and static_id         = :P2330_STATIC_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'A role with same static identifier exists in the current application. Please enter a different static identifier.'
,p_validation_condition=>':P2330_COPY_SOURCE = ''THIS'' or :P2330_SUBSCRIBE = ''N'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(3769334249282650)
,p_associated_item=>wwv_flow_imp.id(2613510192441822)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3775937944282689)
,p_validation_name=>'Valid Static ID'
,p_validation_sequence=>50
,p_validation=>'P2330_STATIC_ID'
,p_validation_type=>'ITEM_IS_ALPHANUMERIC'
,p_error_message=>'#LABEL# may contain only alphanumeric characters and underscores "_".'
,p_validation_condition=>':P2330_COPY_SOURCE = ''THIS'' or :P2330_SUBSCRIBE = ''N'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(3769334249282650)
,p_associated_item=>wwv_flow_imp.id(2613510192441822)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3775555816282689)
,p_validation_name=>'No duplicate subscription'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_fnd_user_groups',
' where security_group_id = :FLOW_SECURITY_GROUP_ID ',
'   and flow_id           = :FB_FLOW_ID ',
'   and reference_id      = :P2330_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'There is another role in this application that is subscribed to the same master. Please select another master role.'
,p_validation_condition=>'P2330_SUBSCRIBE'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(3769334249282650)
,p_associated_item=>wwv_flow_imp.id(246768088583885414)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3776607130282691)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3768918102282648)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3777125856282693)
,p_event_id=>wwv_flow_imp.id(3776607130282691)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3780981649282697)
,p_name=>'Toggle Items display'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2330_SUBSCRIBE'
,p_condition_element=>'P2330_SUBSCRIBE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_cond=>'P2330_COPY_SOURCE'
,p_display_when_cond2=>'OTHER'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3781473248282697)
,p_event_id=>wwv_flow_imp.id(3780981649282697)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2330_GROUP_NAME,P2330_STATIC_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3781980062282697)
,p_event_id=>wwv_flow_imp.id(3780981649282697)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2330_GROUP_NAME,P2330_STATIC_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2613659654441823)
,p_name=>'Update Static ID'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2330_GROUP_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2613740862441824)
,p_event_id=>wwv_flow_imp.id(2613659654441823)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2330_STATIC_ID'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$v(''P2330_GROUP_NAME'').replace(/\s+/g, ''_'').toUpperCase()'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4411959406904122)
,p_name=>'Set Group Name and Static ID'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2330_ID'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_cond=>'P2330_COPY_SOURCE'
,p_display_when_cond2=>'OTHER'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4412023847904123)
,p_event_id=>wwv_flow_imp.id(4411959406904122)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2330_GROUP_NAME,P2330_STATIC_ID'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select group_name, static_id',
'  from wwv_flow_fnd_user_groups',
' where flow_id           = :P2330_COPY_FROM_APPLICATION_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and id                = :P2330_ID'))
,p_attribute_07=>'P2330_ID'
,p_attribute_08=>'Y'
,p_attribute_09=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3776208269282689)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Role'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P2330_NEW_USER_GROUP_ID := wwv_flow_copy_metadata.copy_component (',
'    p_component_type       => wwv_flow_copy_metadata.c_user_group,',
'    p_from_id              => :P2330_ID,',
'    p_from_app_id          => :P2330_COPY_FROM_APPLICATION_ID,',
'    p_to_app_id            => :FB_FLOW_ID,',
'    p_new_name             => :P2330_GROUP_NAME,',
'    p_additional_col       => :P2330_STATIC_ID,',
'    p_subscribe            => :P2330_SUBSCRIBE = ''Y'' );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to copy the role.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3769334249282650)
,p_process_success_message=>'Role copied.'
,p_internal_uid=>3776208269282689
);
end;
/
prompt --application/pages/page_02500
begin
wwv_flow_imp_page.create_page(
 p_id=>2500
,p_name=>'Create Page Wizard - Page Type'
,p_alias=>'CREATE-PAGE-PAGE-TYPE'
,p_page_mode=>'MODAL'
,p_step_title=>'Create a Page'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(103848364625132731)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_css_classes=>'a-Dialog--CreatePageDialog'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'600'
,p_dialog_width=>'800'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_protection_level=>'C'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3063471799256535)
,p_plug_name=>'Header'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_01'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(12400918656612904)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(19905182836194941)
,p_plug_name=>'Create Page'
,p_region_css_classes=>'a-Form a-Form--leftLabels a-Form--fixedLabels'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(19905396706194943)
,p_plug_name=>'Choose Page Type'
,p_parent_plug_id=>wwv_flow_imp.id(19905182836194941)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>60
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(21800930057278201)
,p_plug_name=>'Warning - RW'
,p_parent_plug_id=>wwv_flow_imp.id(19905182836194941)
,p_region_css_classes=>'a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--warning:a-Alert--horizontal'
,p_region_attributes=>'style="margin-bottom: 0;display:none"'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<p>Your Redwood Theme application only supports adding the <strong>Login Page</strong> feature and <strong>Push Notifications</strong>.</p>'
,p_translate_title=>'N'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P2500_IS_RW_BASED = ''Y'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(234472564490867204)
,p_plug_name=>'Warning - Not UT or RW'
,p_parent_plug_id=>wwv_flow_imp.id(19905182836194941)
,p_region_css_classes=>'a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--warning:a-Alert--horizontal'
,p_region_attributes=>'style="margin-bottom: 0;display:none"'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<p>This application current theme only supports adding the <strong>Login Page</strong> feature. &PRODUCT_NAME. recommends using the Universal Theme to unlock other features. To learn more, see the <a rel="noopener noreferrer" href="https://apex.oracl'
||'e.com/ut" target="_blank">Universal Theme Reference App</a>.</p>'
,p_translate_title=>'N'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P2500_IS_UT_BASED = ''N'' and :P2500_IS_RW_BASED = ''N'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(12401423903612909)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(12400918656612904)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(12401083507612905)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(12400918656612904)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(12401326825612908)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(12400918656612904)
,p_button_name=>'Help'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Help'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'javascript:apex.navigation.openInNewWindow(''&SYSTEM_HELP_URL.'');'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(70071286762240748)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(12400918656612904)
,p_button_name=>'COPY_PAGE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Create Page as Copy'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:618:&SESSION.::&DEBUG.:618,301,302,305:P618_LAST_VIEW:2500'
,p_button_css_classes=>'a-Button--noUI'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(12203865908853636)
,p_branch_name=>'Page - Wizard Attributes'
,p_branch_action=>'f?p=&APP_ID.:2508:&SESSION.::&DEBUG.:2508,CREATE_WIZARD::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(12401423903612909)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P2500_PAGE_TYPE'
,p_branch_condition_text=>'WIZARD'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(18006478310209946)
,p_branch_name=>'Page - Plug-in Selection'
,p_branch_action=>'f?p=&APP_ID.:2509:&SESSION.::&DEBUG.:2501,2509,2510::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(12401423903612909)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P2500_PAGE_TYPE'
,p_branch_condition_text=>'PLUGIN'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(15901723471127514)
,p_branch_name=>'Page - Dashboard Non-UT'
,p_branch_action=>'f?p=&APP_ID.:2511:&SESSION.::&DEBUG.:2511:P2511_PREV_PAGE:2500&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(12401423903612909)
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':P2500_PAGE_TYPE = ''DASHBOARD'' and :P2500_IS_UT_BASED = ''N'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4405864475104844)
,p_branch_name=>'Page - Master Detail'
,p_branch_action=>'f?p=&APP_ID.:2513:&SESSION.::&DEBUG.:2501,2513,2515,2516,2517,2518::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(12401423903612909)
,p_branch_sequence=>40
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':P2500_PAGE_TYPE = ''MD'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(7722963153899501)
,p_branch_name=>'Page - Chart'
,p_branch_action=>'f?p=&APP_ID.:2514:&SESSION.::&DEBUG.:2501,2514,2505::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(12401423903612909)
,p_branch_sequence=>50
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P2500_PAGE_TYPE'
,p_branch_condition_text=>'CHART'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4611819235691734)
,p_branch_name=>'Page - Global'
,p_branch_action=>'f?p=&APP_ID.:2519:&SESSION.::&DEBUG.:2519::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(12401423903612909)
,p_branch_sequence=>70
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P2500_PAGE_TYPE'
,p_branch_condition_text=>'GLOBAL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4205268231667421)
,p_branch_name=>'Page - No Search Config'
,p_branch_action=>'f?p=&APP_ID.:3117:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(12401423903612909)
,p_branch_sequence=>80
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P2500_PAGE_TYPE'
,p_branch_condition_text=>'NO_SEARCH_CONFIG'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(19905560545194945)
,p_branch_name=>'Feature - Login Page'
,p_branch_action=>'f?p=&APP_ID.:500:&SESSION.::&DEBUG.:500::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>90
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P2500_PAGE_TYPE'
,p_branch_condition_text=>'LOGIN'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2200284624763701)
,p_branch_name=>'Feature Pages'
,p_branch_action=>'declare'||wwv_flow.LF||
'    l_pageno number;'||wwv_flow.LF||
'begin'||wwv_flow.LF||
'    if :P2500_PAGE_TYPE = wwv_flow_app_feature_v3.c_push_notifications then'||wwv_flow.LF||
'        l_pageno := 1318;'||wwv_flow.LF||
'    elsif :P2500_PAGE_TYPE = wwv_flow_app_feature_v3.c_about_page then'||wwv_flow.LF||
'        l_pageno := 1313;'||wwv_flow.LF||
'    elsif :P2500_PAGE_TYPE = wwv_flow_app_feature_v3.c_acl then'||wwv_flow.LF||
'        l_pageno := 572;'||wwv_flow.LF||
'    elsif :P2500_PAGE_TYPE = wwv_flow_app_feature_v3.c_activity_report then'||wwv_flow.LF||
'        l_pageno := 1310;'||wwv_flow.LF||
'    elsif :P2500_PAGE_TYPE = wwv_flow_app_feature_v3.c_configuration then'||wwv_flow.LF||
'        l_pageno := 1311;'||wwv_flow.LF||
'    elsif :P2500_PAGE_TYPE = wwv_flow_app_feature_v3.c_email_report then'||wwv_flow.LF||
'        l_pageno := 1314;'||wwv_flow.LF||
'    elsif :P2500_PAGE_TYPE = wwv_flow_app_feature_v3.c_feedback then'||wwv_flow.LF||
'        l_pageno := 849;'||wwv_flow.LF||
'    elsif :P2500_PAGE_TYPE = wwv_flow_app_feature_v3.c_theme_style then'||wwv_flow.LF||
'        l_pageno := 1312;'||wwv_flow.LF||
'    elsif :P2500_PAGE_TYPE = wwv_flow_app_feature_v3.c_job_report then'||wwv_flow.LF||
'        l_pageno := 1315;'||wwv_flow.LF||
'    end if;'||wwv_flow.LF||
'    return wwv_flow_page_api.get_url ('||wwv_flow.LF||
'           p_page        => l_pageno,'||wwv_flow.LF||
'           p_clear_cache => l_pageno );'||wwv_flow.LF||
'end;'||wwv_flow.LF||
''
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_FUNCTION_RETURNING_URL'
,p_branch_language=>'PLSQL'
,p_branch_sequence=>100
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_app_feature_v3.is_feature (',
'    p_page_type    => :P2500_PAGE_TYPE )',
'and',
'wwv_flow_app_feature_v3.add_feature_page_allowed(',
'    p_app_id       => :FB_FLOW_ID,',
'    p_feature_name => :P2500_PAGE_TYPE )',
'and',
':P2500_IS_UT_BASED = ''Y'''))
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4401856768104804)
,p_branch_name=>'Universal Theme only feature'
,p_branch_action=>'f?p=&APP_ID.:1316:&SESSION.::&DEBUG.:1316::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>110
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P2500_IS_UT_BASED = ''N'' and ',
':P2500_PAGE_TYPE in (',
'  wwv_flow_app_feature_v3.c_acl,',
'  wwv_flow_app_feature_v3.c_feedback,',
'  wwv_flow_app_feature_v3.c_activity_report,',
'  wwv_flow_app_feature_v3.c_email_report,',
'  wwv_flow_app_feature_v3.c_job_report,',
'  wwv_flow_app_feature_v3.c_about_page,',
'  wwv_flow_app_feature_v3.c_configuration,',
'  wwv_flow_app_feature_v3.c_theme_style',
'  )'))
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2622124967896602)
,p_branch_name=>'UT or RW only feature'
,p_branch_action=>'f?p=&APP_ID.:1316:&SESSION.::&DEBUG.:1316::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>120
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P2500_IS_UT_BASED = ''N'' and ',
':P2500_IS_RW_BASED = ''N'' and ',
':P2500_PAGE_TYPE in (',
'   wwv_flow_app_feature_v3.c_push_notifications )'))
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4401970582104805)
,p_branch_name=>'Feature Already Exists'
,p_branch_action=>'f?p=&APP_ID.:1317:&SESSION.::&DEBUG.:1317::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>130
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_app_feature_v3.is_feature (',
'p_page_type => :P2500_PAGE_TYPE )',
'and not',
'wwv_flow_app_feature_v3.add_feature_page_allowed(',
'p_app_id => :FB_FLOW_ID,',
'p_feature_name => :P2500_PAGE_TYPE )'))
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4802612989096922)
,p_branch_name=>'Legacy Page - Summary'
,p_branch_action=>'f?p=&APP_ID.:5100:&SESSION.::&DEBUG.:5100,5105,5110,303,SUMMARY_ITEM::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(12401423903612909)
,p_branch_sequence=>140
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P2500_PAGE_TYPE'
,p_branch_condition_text=>'SUMMARY'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(6972370029210001)
,p_branch_name=>'Legacy Page - Report on WS'
,p_branch_action=>'f?p=&APP_ID.:759:&SESSION.::&DEBUG.:759::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(12401423903612909)
,p_branch_sequence=>150
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P2500_PAGE_TYPE'
,p_branch_condition_text=>'WEBSERVICE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(6972419506210002)
,p_branch_name=>'Legacy Page - Form on WS'
,p_branch_action=>'f?p=&APP_ID.:605:&SESSION.::&DEBUG.:605::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(12401423903612909)
,p_branch_sequence=>160
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P2500_PAGE_TYPE'
,p_branch_condition_text=>'FORMWS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(6972524123210003)
,p_branch_name=>'Legacy Page - Report & Form on WS'
,p_branch_action=>'f?p=&APP_ID.:700:&SESSION.::&DEBUG.:700::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(12401423903612909)
,p_branch_sequence=>170
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P2500_PAGE_TYPE'
,p_branch_condition_text=>'REPORTANDFORMWS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(6972631721210004)
,p_branch_name=>'Legacy Page - Data Loading'
,p_branch_action=>'f?p=&APP_ID.:1700:&SESSION.::&DEBUG.:1700::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(12401423903612909)
,p_branch_sequence=>180
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P2500_PAGE_TYPE'
,p_branch_condition_text=>'LEGACY_DATA_LOAD'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(15900591816127502)
,p_branch_name=>'Page - Page Definition'
,p_branch_action=>'f?p=&APP_ID.:2501:&SESSION.::&DEBUG.:2501,2502,2503,2504,2506,2507,2512:P2501_PREV_PAGE:2500&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(12401423903612909)
,p_branch_sequence=>190
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3700111847679112)
,p_branch_name=>'Invalid UI'
,p_branch_action=>'f?p=&APP_ID.:51:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_HEADER'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>5
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_themes',
' where flow_id             = :FB_FLOW_ID',
'   and security_group_id   = :WORKSPACE_ID',
'   and theme_internal_name = ''JQUERY_MOBILE_SMARTPHONE'''))
,p_branch_comment=>'We should not allow creating new pages if the theme identifier is JQUERY_MOBILE_SMARTPHONE. (feature #3735-cleanup-user-interfaces)'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1806026212350550)
,p_name=>'P2500_IS_RW_BASED'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(19905182836194941)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1906889721054624)
,p_name=>'P2500_IS_NAVLIST_SUBSCRIBED'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(19905182836194941)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3302763492286925)
,p_name=>'P2500_NAVLIST_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(19905182836194941)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4402446933104810)
,p_name=>'P2500_IS_FONT_APEX'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(19905182836194941)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4402664517104812)
,p_name=>'P2500_UT_NAV_ICON'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(19905182836194941)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12400839632612903)
,p_name=>'P2500_PAGE_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(19905396706194943)
,p_item_default=>'BLANK'
,p_prompt=>'Page Type'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'WIZ_PAGE_TYPE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select page_type_display||''| ''||icon disp_val, page_type, display_order',
'  from wwv_flow_page_types_dev',
' where category = :P2500_CATEGORY',
' order by display_order, page_type_display'))
,p_lov_cascade_parent_items=>'P2500_CATEGORY'
,p_ajax_optimize_refresh=>'Y'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-IconList--CreatePageDialog'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_attribute_01=>'M'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12404720001612942)
,p_name=>'P2500_NAVIGATION_TYPE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(19905182836194941)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(19905426743194944)
,p_name=>'P2500_CATEGORY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3063471799256535)
,p_item_default=>'PAGE'
,p_prompt=>'Category'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'PAGE_TYPE_SELECTION'
,p_lov=>'.'||wwv_flow_imp.id(497897080593180120)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_colspan=>10
,p_grid_column=>2
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
,p_item_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select a type of page component to create within your application. <br><br>',
'<ul>',
'<li><strong>Component:</strong> Pages provide page-level functionality and can be added multiple times within a given application. Examples ',
'include reports, forms, plug-ins, charts, calendar and so on. </li>',
'<li><strong>Feature:</strong> Pages provide application-level functionality and are typically added once per application. Examples include About Page, Access Control, Activity Reporting, Feedback, and Login Page.</li>',
'<li><strong>Legacy Pages:</strong> Pages that contain legacy components that are still supported, but are not recommended to use.</li>',
'</ul>'))
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21801247793278204)
,p_name=>'P2500_NAVBAR_ID'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(19905182836194941)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(25208593789438422)
,p_name=>'P2500_IS_UT_BASED'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(19905182836194941)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(39805258686554120)
,p_name=>'P2500_PAGE_TYPE_DISPLAY'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(19905182836194941)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(15900468929127501)
,p_validation_name=>'P2500_PAGE_TYPE not null'
,p_validation_sequence=>10
,p_validation=>'P2500_PAGE_TYPE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Please select a page type'
,p_when_button_pressed=>wwv_flow_imp.id(12401423903612909)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(12401154390612906)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(12401083507612905)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(12401245757612907)
,p_event_id=>wwv_flow_imp.id(12401154390612906)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4402048367104806)
,p_name=>'Show/Hide Non UT Message'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2500_CATEGORY'
,p_condition_element=>'P2500_CATEGORY'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FEATURE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3203168168180723)
,p_event_id=>wwv_flow_imp.id(4402048367104806)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(21800930057278201)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4402180045104807)
,p_event_id=>wwv_flow_imp.id(4402048367104806)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(234472564490867204)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3203071754180722)
,p_event_id=>wwv_flow_imp.id(4402048367104806)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(21800930057278201)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4402246574104808)
,p_event_id=>wwv_flow_imp.id(4402048367104806)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(234472564490867204)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(21801312637278205)
,p_name=>'onChange P2500_CATEGORY = PAGE'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2500_CATEGORY'
,p_condition_element=>'P2500_CATEGORY'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'PAGE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(21801431980278206)
,p_event_id=>wwv_flow_imp.id(21801312637278205)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2500_PAGE_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'BLANK'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(21801579448278207)
,p_name=>'onChange P2500_CATEGORY = FEATURE'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2500_CATEGORY'
,p_condition_element=>'P2500_CATEGORY'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FEATURE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(21801658116278208)
,p_event_id=>wwv_flow_imp.id(21801579448278207)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2500_PAGE_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'FEATURE_PUSH_NOTIFICATIONS'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3202833506180720)
,p_name=>'onChange P2500_CATEGORY = LEGACY_PAGE'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2500_CATEGORY'
,p_condition_element=>'P2500_CATEGORY'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'LEGACY_PAGE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3202952607180721)
,p_event_id=>wwv_flow_imp.id(3202833506180720)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2500_PAGE_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'FORMONPROC'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4613399357691749)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Initialize Create Page Wizard'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.init_create_page_wiz(',
'    p_application_id        => :FB_FLOW_ID,',
'    p_navigation_type       => :P2500_NAVIGATION_TYPE,',
'    p_navlist_id            => :P2500_NAVLIST_ID,',
'    p_is_navlist_subscribed => :P2500_IS_NAVLIST_SUBSCRIBED,',
'    p_navbar_id             => :P2500_NAVBAR_ID,',
'    p_theme_id              => :FB_THEME_ID,',
'    p_is_ut_based           => :P2500_IS_UT_BASED,',
'    p_is_rw_based           => :P2500_IS_RW_BASED,',
'    p_is_font_apex          => :P2500_IS_FONT_APEX );'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>4613399357691749
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4402746227104813)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Derive Page Icon and Page Type'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select page_type_display,',
'       case when :P2500_IS_UT_BASED = ''Y'' and :P2500_IS_FONT_APEX = ''Y'' then ut_nav_icon end',
'  into :P2500_PAGE_TYPE_DISPLAY,',
'       :P2500_UT_NAV_ICON',
'  from wwv_flow_page_types_dev',
' where page_type = :P2500_PAGE_TYPE;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>4402746227104813
);
end;
/
prompt --application/pages/page_02501
begin
wwv_flow_imp_page.create_page(
 p_id=>2501
,p_name=>'Create Page Wizard - Page Definition'
,p_alias=>'CREATE-PAGE-PAGE-DEFINITION'
,p_page_mode=>'MODAL'
,p_step_title=>'Create &P2500_PAGE_TYPE_DISPLAY.'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(103848364625132731)
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function showHideButtons()',
'{',
'    // in some cases, we show both CREATE and NEXT buttons on the client side',
'    // depending on options selected, we want to show either of one button ',
'    var lIncludeForm = apex.item("P2501_INCLUDE_FORM").getValue(),',
'        lEditable = apex.item("P2501_EDITABLE").getValue(),',
'        lPageType = apex.item("P2501_PAGE_TYPE").getValue();',
'    // if page type is INTERACTIVE or CLASSIC, logic is simple',
'    // show NEXT button when lIncludeForm is Y, otherwise show CREATE button',
'    if ( lPageType == ''INTERACTIVE'' || lPageType == ''CLASSIC'' )',
'    {',
'        if ( lIncludeForm == ''Y'' )',
'        {',
'            apex.jQuery("button#CREATE").hide();',
'            apex.jQuery("button#NEXT").show();',
'        }',
'        else',
'        {',
'            apex.jQuery("button#CREATE").show();',
'            apex.jQuery("button#NEXT").hide();',
'        }',
'    }',
'    ',
'    // if page type is GRID, then need to consider both lIncludeForm and lEditable values',
'    if ( lPageType == ''GRID'')',
'    {',
'        if ( lIncludeForm == ''Y'' || lEditable == ''Y'' )',
'        {',
'            apex.jQuery("button#CREATE").hide();',
'            apex.jQuery("button#NEXT").show();            ',
'        }',
'        else',
'        {',
'            apex.jQuery("button#CREATE").show();',
'            apex.jQuery("button#NEXT").hide();            ',
'        }',
'    }    ',
'}'))
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// reposition icon picker',
'apex.jQuery("#P2501_PAGE_ICON").after(apex.jQuery("button#icon_picker"));'))
,p_css_file_urls=>'#FONT_APEX_LATEST_DIRECTORY#css/font-apex#MIN#.css'
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_css_classes=>'a-Dialog--CreatePageDialog'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_protection_level=>'C'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(3400342028977202)
,p_name=>'Search Configurations'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select htmldb_item.checkbox2(',
'              p_idx            => 1,',
'              p_value          => s.id,',
'              p_attributes     => ''class="u-vh apex-ui-selector-input" aria-label="select ''||wwv_flow_escape.html_attribute(s.label)||''"'',',
'              p_checked_values => null,',
'              p_item_id        => ''cb_''||wwv_flow_escape.html_attribute(s.label)) || ''<label class="apex-ui-selector" for="cb_''||wwv_flow_escape.html_attribute(s.label)||''"></label>''',
'       as search_id,',
'       s.label search_label,',
'       s.search_type',
'  from wwv_flow_search_configs s',
' where s.flow_id = :FB_FLOW_ID',
'   and s.security_group_id = :WORKSPACE_ID',
'order by s.label',
' '))
,p_display_when_condition=>'P2500_PAGE_TYPE'
,p_display_when_cond2=>'SEARCH'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>20
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No Search Configurations defined for this application.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3400875913977207)
,p_query_column_id=>1
,p_column_alias=>'SEARCH_ID'
,p_column_display_sequence=>10
,p_column_heading=>'<span class="u-vh">Select Search Configuration</span>'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3400464807977203)
,p_query_column_id=>2
,p_column_alias=>'SEARCH_LABEL'
,p_column_display_sequence=>20
,p_column_heading=>'Label'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3400548577977204)
,p_query_column_id=>3
,p_column_alias=>'SEARCH_TYPE'
,p_column_display_sequence=>30
,p_column_heading=>'Search Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(1813067828014706)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4612441783691740)
,p_plug_name=>'Unified Task List'
,p_region_css_classes=>'a-Alert--inline a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--info:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div>',
'<p>The unified task list shows all initiated user tasks in the workspace.</p>',
'    ',
'<p>To manage your task definitions, navigate to Shared Components, Task Definitions in your application.</p>',
'',
'<p>If your task definitions and unified task list are defined in different applications within your workspace, then ensure you configure session sharing in each application. This will allow the unified task list application to open the task details p'
||'ages in the task definition application. To configure session sharing in each application, navigate to Shared Components, Authentication Schemes, Your Scheme, Session Sharing.</p>',
'</div>'))
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P2500_PAGE_TYPE'
,p_plug_display_when_cond2=>'TASKLIST'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(12401772860612912)
,p_plug_name=>'&P2501_PD_PREFIX. Page Definition'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(12402431675612919)
,p_plug_name=>'Navigation'
,p_region_css_classes=>'margin-top-none margin-bottom-none a-Region--noBottomBorder'
,p_region_template_options=>'#DEFAULT#:is-expanded'
,p_plug_template=>wwv_flow_imp.id(689970285456172024)
,p_plug_display_sequence=>70
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P2500_CATEGORY != ''PATTERN'' or',
'(:P2500_CATEGORY = ''PATTERN'' and nvl(:P2501_PAGE_MODE,''NORMAL'') = ''NORMAL'')'))
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(12404977229612944)
,p_plug_name=>'Navigation List'
,p_parent_plug_id=>wwv_flow_imp.id(12402431675612919)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P2500_NAVIGATION_TYPE'
,p_plug_display_when_cond2=>'L'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(12405028755612945)
,p_plug_name=>'Breadcrumb'
,p_parent_plug_id=>wwv_flow_imp.id(12402431675612919)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID )'))
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(12405128654612946)
,p_plug_name=>'Message for Tabs Navigation'
,p_parent_plug_id=>wwv_flow_imp.id(12402431675612919)
,p_region_css_classes=>'a-Alert--dialog'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>10
,p_plug_source=>'htp.p(wwv_flow_lang_dev.builder_message(''WIZARD.TAB_NAVIGATION_MSG''));'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P2500_NAVIGATION_TYPE'
,p_plug_display_when_cond2=>'T'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(29405697525885104)
,p_plug_name=>'Hidden Items'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'These are the items used in server side processes, for data source section.'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(39038401560015748)
,p_plug_name=>'Dashboard Layout'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P2500_PAGE_TYPE'
,p_plug_display_when_cond2=>'DASHBOARD'
,p_plug_header=>'<p>This wizard creates a first-cut dashboard based on sample data, that you can easily customize using Page Designer. Choose from a number of different chart layouts as the starting point for your page.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(58566768588284414)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(120990806316212000)
,p_plug_name=>'&P2501_SOURCE_REGION_PREFIX. Data Source'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P2501_SHOW_DATA_SOURCE'
,p_plug_display_when_cond2=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(29878231234106626)
,p_plug_name=>'Local data source'
,p_parent_plug_id=>wwv_flow_imp.id(120990806316212000)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(29878316648106627)
,p_plug_name=>'REST Data Source'
,p_parent_plug_id=>wwv_flow_imp.id(120990806316212000)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(31668971078714554)
,p_plug_name=>'Remote SQL'
,p_parent_plug_id=>wwv_flow_imp.id(120990806316212000)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(39807975024554147)
,p_plug_name=>'IG Edit Option'
,p_parent_plug_id=>wwv_flow_imp.id(120990806316212000)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(333042207347446456)
,p_plug_name=>'Data Load Attributes'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P2500_PAGE_TYPE'
,p_plug_display_when_cond2=>'DATALOAD'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(12402842856612923)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_imp.id(12404977229612944)
,p_button_name=>'ICON'
,p_button_static_id=>'icon_picker'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Select Icon'
,p_button_redirect_url=>'f?p=&APP_ID.:181:&SESSION.::&DEBUG.::P181_PASS_BACK_TO_UI,P181_PASS_BACK_TO_SAVE:icon_picker,P2501_PAGE_ICON'
,p_button_css_classes=>'a-Button--colorPicker'
,p_icon_css_classes=>'fa &P2501_PAGE_ICON.'
,p_grid_new_row=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(16101666441318943)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(58566768588284414)
,p_button_name=>'NEXT'
,p_button_static_id=>'NEXT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>':P2500_PAGE_TYPE in (''INTERACTIVE'',''GRID'',''CLASSIC'',''FORM'',''CARD'',''FACETED_SEARCH'',''SMART_FILTERS'',''CHART'',''MAP'',''FORMONPROC'',''TREE'',''CALENDAR'',''MD'',''PLUGIN'')'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(25207746014438414)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(58566768588284414)
,p_button_name=>'CREATE'
,p_button_static_id=>'CREATE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Page'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'   :P2500_PAGE_TYPE in (''BLANK'',''INTERACTIVE'',''GRID'',''CLASSIC'',''DATALOAD'',''DASHBOARD'',''TASKLIST'',''SEARCH'',''WORKFLOWCONSOLE'')',
'or :P2500_PAGE_TYPE like ''TMPL\_%'' escape ''\''',
'or :P2500_PAGE_TYPE like ''PAGEPATTERN%'''))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(16100824943318943)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(58566768588284414)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&P2501_PREV_PAGE.:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(16101259171318943)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(58566768588284414)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(39804355207554111)
,p_branch_name=>'Page 2502 - Form Attributes'
,p_branch_action=>'f?p=&APP_ID.:2502:&SESSION.::&DEBUG.:2502::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(16101666441318943)
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P2500_PAGE_TYPE in (''FORM'',''GRID'',''MD'')',
'or (:P2500_PAGE_TYPE in (''INTERACTIVE'',''GRID'',''CLASSIC'') and :P2501_INCLUDE_FORM = ''Y'')'))
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(39805060906554118)
,p_branch_name=>'Page 2503 - Card Attributes'
,p_branch_action=>'f?p=&APP_ID.:2503:&SESSION.::&DEBUG.::P2503_PREV_PAGE:2501&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(16101666441318943)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P2500_PAGE_TYPE'
,p_branch_condition_text=>'CARD'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(5501314152609213)
,p_branch_name=>'Page 2505 - Chart Attributes'
,p_branch_action=>'f?p=&APP_ID.:2505:&SESSION.::&DEBUG.:2505::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(16101666441318943)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P2500_PAGE_TYPE'
,p_branch_condition_text=>'CHART'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(39805678536554124)
,p_branch_name=>'Page 2504 - FS/SF Attributes'
,p_branch_action=>'f?p=&APP_ID.:2504:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(16101666441318943)
,p_branch_sequence=>40
,p_branch_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_branch_condition=>'P2500_PAGE_TYPE'
,p_branch_condition_text=>'FACETED_SEARCH:SMART_FILTERS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(5503165027609231)
,p_branch_name=>'Page 2506 - Map Attributes'
,p_branch_action=>'f?p=&APP_ID.:2506:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(16101666441318943)
,p_branch_sequence=>50
,p_branch_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_branch_condition=>'P2500_PAGE_TYPE'
,p_branch_condition_text=>'MAP'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(5504785161609247)
,p_branch_name=>'Page 2507 - Form on Proc Attributes'
,p_branch_action=>'f?p=&APP_ID.:2507:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(16101666441318943)
,p_branch_sequence=>60
,p_branch_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_branch_condition=>'P2500_PAGE_TYPE'
,p_branch_condition_text=>'FORMONPROC'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4800509906096901)
,p_branch_name=>'Page 2510 - Calendar Attributes'
,p_branch_action=>'f?p=&APP_ID.:2510:&SESSION.::&DEBUG.::P2510_REGION_TYPE:NATIVE_CSS_CALENDAR&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(16101666441318943)
,p_branch_sequence=>70
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P2500_PAGE_TYPE'
,p_branch_condition_text=>'CALENDAR'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4405422029104840)
,p_branch_name=>'Page 2512 - Tree Attributes'
,p_branch_action=>'f?p=&APP_ID.:2512:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(16101666441318943)
,p_branch_sequence=>80
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P2500_PAGE_TYPE'
,p_branch_condition_text=>'TREE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4611191700691727)
,p_branch_name=>'Page 2510 - Plug-in Attributes'
,p_branch_action=>'f?p=&APP_ID.:2510:&SESSION.::&DEBUG.:2510:P2510_REGION_TYPE:&P2509_REGION_TYPE.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(16101666441318943)
,p_branch_sequence=>90
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P2500_PAGE_TYPE'
,p_branch_condition_text=>'PLUGIN'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4220639116605006)
,p_branch_name=>'Page 4500 - Page Designer'
,p_branch_action=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.:4500:F4000_RUN_EDIT_PAGE,FB_FLOW_PAGE_ID:&P2501_PAGE_ID.,&P2501_PAGE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(25207746014438414)
,p_branch_sequence=>100
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P2501_CLOSE_DIALOG'
,p_branch_condition_text=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1711690627712204)
,p_name=>'P2501_PAGE_PATTERN_PAGE_ID'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(12401772860612912)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
,p_item_comment=>'Using this field in Page JavaScript'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1801461532977012)
,p_name=>'P2501_INCLUDE_DASHBOARD'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(12401772860612912)
,p_item_default=>'N'
,p_prompt=>'Include Dashboard Page'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>'P2500_PAGE_TYPE'
,p_display_when2=>'WORKFLOWCONSOLE'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enable to also create a <em>Dashboard Page</em>, to allow monitoring of running Workflows and to compare cycle time of activities and workflows.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1801578826977013)
,p_name=>'P2501_DASHBOARD_PAGE_ID'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(12401772860612912)
,p_prompt=>'Dashboard Page Number'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>5
,p_display_when=>'P2500_PAGE_TYPE'
,p_display_when2=>'WORKFLOWCONSOLE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Provide a page number for the Dashboard page. The page number is an integer value that identifies a page within an application.'
,p_attribute_03=>'right'
,p_attribute_04=>'decimal'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1801637886977014)
,p_name=>'P2501_DASHBOARD_PAGE_NAME'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(12401772860612912)
,p_prompt=>'Dashboard Page Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_display_when=>'P2500_PAGE_TYPE'
,p_display_when2=>'WORKFLOWCONSOLE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify a name for the Dashboard page. Same text is also used for the dashboard page <em>Title</em>. After page creation, the <em>Title</em> can be modified using Page Designer. '
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2802172467886203)
,p_name=>'P2501_WORKFLOW_CONSOLE_CONTEXT'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(12401772860612912)
,p_prompt=>'Report Context'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WORKFLOW_CONSOLE_REPORT_CONTEXT'
,p_lov=>'.'||wwv_flow_imp.id(3201550597510160)||'.'
,p_cHeight=>1
,p_display_when=>'P2500_PAGE_TYPE'
,p_display_when2=>'WORKFLOWCONSOLE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Defines the report context of the Workflow Console. Available options are:<ul>',
'<li>My Workflows</li>',
'<li>Admin Workflows</li>',
'<li>Initiated by Me</li>',
'</ul></p>'))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3302810263286926)
,p_name=>'P2501_FORM_PAGE_MODE'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(12401772860612912)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_user_interface_dev.drawer_page_template_exists(',
'                     p_application_id => :FB_FLOW_ID ) then ',
'    return ''DRAWER'';',
'elsif wwv_flow_user_interface_dev.dialog_page_template_exists(',
'                     p_application_id => :FB_FLOW_ID ) then ',
'    return ''MODAL'';',
'else',
'    return ''NORMAL'';',
'end if;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Form Page Mode'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DIALOG_PAGE_MODE_CREATE_WIZARD'
,p_lov=>'.'||wwv_flow_imp.id(1497542689968615899)||'.'
,p_display_when=>'P2500_PAGE_TYPE'
,p_display_when2=>'INTERACTIVE:GRID:CLASSIC:WORKFLOWCONSOLE'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_user_interface_dev.dialog_page_template_exists(',
'                     p_application_id     => :FB_FLOW_ID );'))
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Identify the page mode for the form page, based on the following options: <p/>',
'<ul>',
'<li><strong>Normal</strong>: The page is presented as a normal &PRODUCT_NAME. application page.</li>',
'<li><strong>Modal Dialog</strong>: The page is presented as a modal dialog. A modal dialog is an overlay window positioned within the viewport, which remains active and focused until the end user dismisses (closes) it. The underlying page is grayed o'
||'ut and the end user is prevented from interacting with the rest of the page until the dialog is closed.</li>',
'<li><strong>Drawer</strong>: Sets the page mode to <strong>Modal Dialog</strong> and uses <strong>Drawer</strong> template for the page. This option will be available only if the current application theme contains <strong>Drawer</strong> page templat'
||'e.</li>',
'</ul>',
'<br>',
'Note that ',
'<ul>',
'<li>The Modal Dialog option will only be available for selection where the current application theme contains at least one page template of template type <strong>Dialog Page</strong>.</li>',
'<li>The Normal option will only be available for selection, if the report page mode is selected as <strong>Normal</strong>.</li>',
'</ul>'))
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4220531893605005)
,p_name=>'P2501_CLOSE_DIALOG'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_imp.id(12401772860612912)
,p_item_default=>'Y'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
,p_item_comment=>'Data load pages can be created from shared components, besides usual flow starting from Page 4000:1 or from 4000:4500. So, we set this flag as N, when wizard starts from shared components. This way, we skip the "Dialog Close" process and instead we w'
||'ill trigger branch to 4000:4500 to open the new page in page designer.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4609089900691706)
,p_name=>'P2501_ALL_COLUMNS'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(29405697525885104)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
,p_item_comment=>'Contains all columns from the selected table/view as colon seperated list'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4802444337096920)
,p_name=>'P2501_SOURCE_REGION_PREFIX'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(12401772860612912)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4805280387096948)
,p_name=>'P2501_PD_PREFIX'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_imp.id(12401772860612912)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5501687789609216)
,p_name=>'P2501_USE_BREADCRUMB'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(12405028755612945)
,p_item_default=>'Y'
,p_prompt=>'Use Breadcrumb'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Set this flag to <strong>On</strong>, if you want to create a breadcrumb entry for this page. By default, page name will be used as breadcrumb entry name.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5501720699609217)
,p_name=>'P2501_BREADCRUMB_COUNT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(12405028755612945)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*)',
'  from wwv_flow_menus',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5502349303609223)
,p_name=>'P2501_USE_NAVLIST'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(12404977229612944)
,p_item_default=>'case when :P2500_IS_NAVLIST_SUBSCRIBED = ''Y'' then ''N'' else ''Y'' end'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Use Navigation'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Set this flag to <strong>On</strong>, if you want to use navigation for this page.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5504857075609248)
,p_name=>'P2501_INCLUDE_FORM'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(12401772860612912)
,p_item_default=>'N'
,p_prompt=>'Include Form Page'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>'P2500_PAGE_TYPE'
,p_display_when2=>'INTERACTIVE:GRID:CLASSIC'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enable this flag if you want to create form page along with the report page. Form pages are always created as "Modal Dialog" pages.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5505015818609250)
,p_name=>'P2501_FORM_PAGE_ID'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(12401772860612912)
,p_prompt=>'Form Page Number'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>5
,p_display_when=>'P2500_PAGE_TYPE'
,p_display_when2=>'INTERACTIVE:GRID:CLASSIC:WORKFLOWCONSOLE'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The page number is an integer value that identifies a page within an application.'
,p_attribute_03=>'right'
,p_attribute_04=>'decimal'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5601040399117567)
,p_name=>'P2501_DASHBOARD_LAYOUT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(39038401560015748)
,p_item_default=>'PRIMARY_2_SECONDARY'
,p_prompt=>'Dashboard Layout'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'DASHBOARD_LAYOUT'
,p_lov=>'.'||wwv_flow_imp.id(42907758825155833)||'.'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-IconList--CreatePageDialog'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_attribute_01=>'S'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10500762664125992)
,p_name=>'P2501_DATA_LOAD_ID'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(333042207347446456)
,p_prompt=>'Data Load'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id',
'from wwv_flow_load_tables',
'where flow_id = :FB_FLOW_ID',
'and security_group_id = :WORKSPACE_ID',
'and data_profile_id is not null'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the data load definition to use.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10501631972125996)
,p_name=>'P2501_DATA_PROFILE_FORMAT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(333042207347446456)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10502073785125996)
,p_name=>'P2501_DATA_SOURCE_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(333042207347446456)
,p_item_default=>'FILE'
,p_prompt=>'Upload Data From'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DATA.LOAD.DATA_SOURCE_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(2505800285473362)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select if application users will provide data by uploading files or by using copy and paste of delimited text data.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10502961097125998)
,p_name=>'P2501_MAX_FILE_SIZE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(333042207347446456)
,p_item_default=>'5'
,p_prompt=>'Maxmum File Size ( MB )'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the maximum file size (in MB) that should be accepted for the file upload.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12200318392853601)
,p_name=>'P2501_FORM_PAGE_NAME'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(12401772860612912)
,p_prompt=>'Form Page Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_display_when=>'P2500_PAGE_TYPE'
,p_display_when2=>'INTERACTIVE:GRID:CLASSIC:WORKFLOWCONSOLE'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify a text name for the form page. Same text is also used for the form page <em>Title</em>. After page creation, the <em>Title</em> can be modified using Page Designer. '
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12401808562612913)
,p_name=>'P2501_PAGE_ID'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(12401772860612912)
,p_prompt=>'Page Number'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>5
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The page number is an integer value that identifies a page within an application.'
,p_attribute_03=>'right'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12402037652612915)
,p_name=>'P2501_PAGE_NAME'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(12401772860612912)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify a text name for this page. Same text is also used for the page <em>Title</em>. After page creation, the <em>Title</em> can be modified using Page Designer. '
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12402197484612916)
,p_name=>'P2501_PAGE_MODE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(12401772860612912)
,p_item_default=>'NORMAL'
,p_prompt=>'Page Mode'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DIALOG_PAGE_MODE_CREATE_WIZARD'
,p_lov=>'.'||wwv_flow_imp.id(1497542689968615899)||'.'
,p_display_when=>'P2500_CATEGORY'
,p_display_when2=>'PATTERN'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_user_interface_dev.dialog_page_template_exists(',
'                     p_application_id     => :FB_FLOW_ID );'))
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Identify the page mode, based on the following options: <p/>',
'<ul>',
'<li><strong>Normal</strong>: The page is presented as a normal &PRODUCT_NAME. application page.</li>',
'<li><strong>Modal Dialog</strong>: The page is presented as a modal dialog. A modal dialog is an overlay window positioned within the viewport, which remains active and focused until the end user dismisses (closes) it. The underlying page is grayed o'
||'ut and the end user is prevented from interacting with the rest of the page until the dialog is closed.</li>',
'<li><strong>Drawer</strong>: Sets the page mode to <strong>Modal Dialog</strong> and uses <strong>Drawer</strong> template for the page. This option will be available only if the current application theme contains <strong>Drawer</strong> page templat'
||'e.</li>',
'</ul>',
'<br><p>',
'Note that the Modal Dialog option will only be available for selection where the current application theme contains at least one page template of template type <strong>Dialog Page</strong>.</p>'))
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12403138527612926)
,p_name=>'P2501_PAGE_ICON'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(12404977229612944)
,p_item_default=>'P2500_UT_NAV_ICON'
,p_item_default_type=>'ITEM'
,p_prompt=>'Icon'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'apex-item-group--color-picker'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Identify a icon class for the icon associated with this list entry.',
'<br><br>',
'<strong>Using Universal Theme</strong>',
'<br>',
'Most Universal Theme apps use the Font APEX icon library. To pick an icon, use the built-in icon picker and select an icon from the popup window. See examples below:<br><br>',
'<ul>',
'    <li><code>fa-cloud</code> - displays the cloud icon</li>',
'    <li><code>fa-exclamation-circle u-danger-text</code> - displays a red exclamation icon</li>',
'</ul>',
'<br>',
'You can see more examples on the  <a rel="noopener noreferrer" href="https://apex.oracle.com/fontapex" target="_blank">Icons</a> page of the <a rel="noopener noreferrer" href="https://apex.oracle.com/ut" target="_blank">Universal Theme sample app</a>'
||'.'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12403620429612931)
,p_name=>'P2501_BREADCRUMB_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(12405028755612945)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select menu_id',
'  from (',
'select menu_id, count(*) item_count',
'  from wwv_flow_menu_options',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
' group by menu_id',
' order by count(*) desc )',
' where rownum = 1'))
,p_item_default_type=>'SQL_QUERY'
,p_prompt=>'Breadcrumb'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION.MENUS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name,',
'       id',
'  from wwv_flow_menus',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
' order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select which breadcrumb navigation control you want to use.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12403872465612933)
,p_name=>'P2501_BREADCRUMB_PARENT_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(12405028755612945)
,p_prompt=>'Breadcrumb Parent Entry'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov_language=>'PLSQL'
,p_lov=>'return wwv_flow_4000_ui.breadcrumb_parent_lov_sql( p_breadcrumb_item_name => ''P2501_BREADCRUMB_ID'' )'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No parent entry -'
,p_lov_cascade_parent_items=>'P2501_BREADCRUMB_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select parent breadcrumb entry for the current page, select "No Parent Entry" for top level page.'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12405382660612948)
,p_name=>'P2501_NAVLIST_OPTIONS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(12404977229612944)
,p_item_default=>'NEW'
,p_prompt=>'Navigation Preference'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WIZARD.NAVILIST.OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(25100593691198570)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select how you want this page integrated into the Navigation Menu.<p/>',
'<ul>',
'    <li><strong>Create a new entry</strong> - Users will be able to navigate to the new page directly from the Navigation Menu. The new entry can be placed anywhere in the existing hierarchy. By default, page name will be used as list entry name.</li'
||'>',
'    <li><strong>Map to an existing entry</strong> - Use this option when you want the new page to highlight an existing, top level, menu entry. Users will not be able to navigate to the new page directly from the Navigation Menu. Therefore, You will '
||'need to create or define a navigation control on the top level page selected, such as a button, or link in a report, to go to this new page.</li>',
'</ul>'))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18002267253209904)
,p_name=>'P2501_PAGE_TYPE'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(12401772860612912)
,p_use_cache_before_default=>'NO'
,p_source=>'P2500_PAGE_TYPE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
,p_item_comment=>'Using this field in Page JavaScript'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(19901693642194906)
,p_name=>'P2501_PREV_PAGE'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(12401772860612912)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(25206438575438401)
,p_name=>'P2501_PARENT_LIST_ITEM_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(12404977229612944)
,p_prompt=>'Parent Navigation Menu Entry'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'NAVLIST_ENTRIES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case',
'           when (nvl(list_item_link_target,''0'')=''0'' or parent_list_item_id is',
'null) then',
'               lpad('' '',(4*(level-1)),''.'')||list_item_link_text',
'           else',
'               lpad('' '',(4*(level-1)),''.'')||'' (''||list_item_link_text ||'')''',
'       end name,',
'       id',
'  from wwv_flow_list_items',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and sub_list_id is null',
' start with list_id = :P2500_NAVLIST_ID and parent_list_item_id is null',
'connect by prior list_id = list_id and prior id = parent_list_item_id',
' order siblings by list_item_display_sequence'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No parent selected -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the parent for this list entry. '
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(25206592408438402)
,p_name=>'P2501_EXISTING_LIST_ITEM_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(12404977229612944)
,p_prompt=>'Existing Navigation Menu Entry'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'NAVLIST_ENTRIES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case',
'           when (nvl(list_item_link_target,''0'')=''0'' or parent_list_item_id is',
'null) then',
'               lpad('' '',(4*(level-1)),''.'')||list_item_link_text',
'           else',
'               lpad('' '',(4*(level-1)),''.'')||'' (''||list_item_link_text ||'')''',
'       end name,',
'       id',
'  from wwv_flow_list_items',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and sub_list_id is null',
' start with list_id = :P2500_NAVLIST_ID and parent_list_item_id is null',
'connect by prior list_id = list_id and prior id = parent_list_item_id',
' order siblings by list_item_display_sequence'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select an existing menu control to be shown as the active menu control when rendering the new page.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(25207907238438416)
,p_name=>'P2501_NAVLIST_PARENT_ID'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(12404977229612944)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28101105083159043)
,p_name=>'P2501_LOCATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(120990806316212000)
,p_item_default=>'LOCAL'
,p_prompt=>'Data Source'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXEC_LOCATION'
,p_lov=>'.'||wwv_flow_imp.id(3842073961668883)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    This picks the <em>Data Source</em> type for the new APEX component.',
'</p>',
'<ul>',
'    <li><strong>Local Database</strong><br>',
'    Data is sourced from the local database.</li>',
'    <li><strong>REST Enabled SQL Service</strong><br>',
'    Data is sourced from a remote database, where the connection is defined using REST Enabled SQL. To create or maintain REST Enabled SQL references, navigate to Shared Components, REST Enabled SQL.',
'    </li>',
'    <li><strong>REST Data Source</strong><br>',
'    Data is sourced from a RESTful web service defined using REST Data Sources. To create or maintain REST Data Sources, navigate to Shared Components, REST Data Sources.',
'    </li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28102083164159048)
,p_name=>'P2501_EDITABLE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(39807975024554147)
,p_prompt=>'Editing Enabled'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>'P2500_PAGE_TYPE'
,p_display_when2=>'GRID'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select whether to enable editing for this Interactive Grid.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28104436143159052)
,p_name=>'P2501_WEB_SRC_MODULE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(29878316648106627)
,p_prompt=>'REST Data Source'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APP_WEB_SOURCES_FOR_REPORTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_flow_web_src_modules m',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and exists ( select 1 ',
'                  from wwv_flow_web_src_operations',
'                 where web_src_module_id = m.id',
'                   and database_operation = ''FETCH_COLLECTION'' )',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select REST Data Source.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28107250793159055)
,p_name=>'P2501_REMOTE_SERVER_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(31668971078714554)
,p_prompt=>'REST Enabled SQL Service'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REMOTE_SQL_SERVERS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_remote_servers',
' where server_type = ''REMOTE_SQL''',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select REST Enabled SQL Service.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28107680076159055)
,p_name=>'P2501_REMOTE_SOURCE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(31668971078714554)
,p_item_default=>'TABLE'
,p_prompt=>'Source Type'
,p_source=>'WIZARD_SQL_SOURCE_TYPE'
,p_source_type=>'PREFERENCE'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZ_SOURCE_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(37501497605557000)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select how the data is queried.</p>',
'<p>Available options include:</p>',
'<dl><dt>Table / View</dt><dd>The data is retrieved based on a table or view.</dd>',
'<dt>SQL Query</dt><dd>The data is retrieved based on a SQL Query.</dd>',
'</dl>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28108593029159056)
,p_name=>'P2501_REMOTE_SQL'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(31668971078714554)
,p_prompt=>'Enter a SQL SELECT statement'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>8
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the SQL query that will be used as your region source, for example:',
'<pre>',
'select ename,',
'       job,',
'       sal',
'  from emp',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_05=>'P2501_REMOTE_SERVER_ID'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28109408328159056)
,p_name=>'P2501_REMOTE_TABLE_OWNER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(31668971078714554)
,p_prompt=>'Table / View Owner'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value d, column_value r',
'  from table( wwv_flow_remote_server_dev.get_available_objects( :P2501_REMOTE_SERVER_ID, ''SCHEMAS''))',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Current Schema'
,p_lov_cascade_parent_items=>'P2501_REMOTE_SERVER_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the owner of the table.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28110356684159056)
,p_name=>'P2501_REMOTE_TABLE_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(31668971078714554)
,p_prompt=>'Table / View Name'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value d, column_value r',
'  from table( wwv_flow_remote_server_dev.get_available_objects( :P2501_REMOTE_SERVER_ID, ''TABLE'', :P2501_REMOTE_TABLE_OWNER,p_filter=>:p$_search_string ))',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table or View -'
,p_lov_cascade_parent_items=>'P2501_REMOTE_SERVER_ID,P2501_REMOTE_TABLE_OWNER'
,p_ajax_optimize_refresh=>'N'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the owner of the table.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28114578458159061)
,p_name=>'P2501_SOURCE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(29878231234106626)
,p_item_default=>'TABLE'
,p_prompt=>'Source Type'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZ_SOURCE_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(37501497605557000)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select how the data is queried.</p>',
'<p>Available options include:</p>',
'<dl><dt>Table / View</dt><dd>The data is retrieved based on a table or view.</dd>',
'<dt>SQL Query</dt><dd>The data is retrieved based on a SQL Query.</dd>',
'</dl>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28115848614159062)
,p_name=>'P2501_TABLE_OWNER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(29878231234106626)
,p_item_default=>'wwv_flow_security.flow_owner( p_flow_id => :FB_FLOW_ID, p_security_group_id => :WORKSPACE_ID )'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Table / View Owner'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_SCHEMAS_HAVE_PRIVS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(owner) d, owner v',
'  from wwv_flow_object_owners_dev',
'order by d                   '))
,p_lov_cascade_parent_items=>'P2501_SOURCE_TYPE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the owner or schema for the table or view you wish to use.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28116733723159063)
,p_name=>'P2501_TABLE_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(29878231234106626)
,p_prompt=>'Table / View Name'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = :P2501_TABLE_OWNER'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Value -'
,p_lov_cascade_parent_items=>'P2501_TABLE_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select or enter the table or view on which the region will be based. When entering manually, note that the table name is case sensitive.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28118404076159064)
,p_name=>'P2501_SQL'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(29878231234106626)
,p_prompt=>'Enter a SQL SELECT statement'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>8
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_07=>'N'
,p_item_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the SQL query that will be used as your region source, for example:',
'<pre>',
'select ename,',
'       job,',
'       sal',
'  from emp',
'</pre>'))
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(29405765456885105)
,p_name=>'P2501_TAB_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(29405697525885104)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(29405962820885107)
,p_name=>'P2501_TAB_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(29405697525885104)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(29406079618885108)
,p_name=>'P2501_QUERY_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(29405697525885104)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(29406104753885109)
,p_name=>'P2501_SQL_SOURCE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(29405697525885104)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(39804765937554115)
,p_name=>'P2501_SHOW_DATA_SOURCE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(12401772860612912)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(238045641914396402)
,p_name=>'P2501_TASK_LIST_REPORT_CONTEXT'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(12401772860612912)
,p_prompt=>'Report Context'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'UNIFIED_TASK_LIST_REPORT_CONTEXT'
,p_lov=>'.'||wwv_flow_imp.id(264265368241987728)||'.'
,p_cHeight=>1
,p_display_when=>'P2500_PAGE_TYPE'
,p_display_when2=>'TASKLIST'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Defines the report context of the Unified Task List. Available options are:<ul>',
'<li>My Tasks</li>',
'<li>Admin Tasks</li>',
'<li>Initiated by Me</li>',
'</ul></p>'))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(25208067579438417)
,p_computation_sequence=>10
,p_computation_item=>'P2501_NAVLIST_PARENT_ID'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P2501_PARENT_LIST_ITEM_ID'
,p_compute_when=>'P2501_NAVLIST_OPTIONS'
,p_compute_when_text=>'NEW'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(25208188965438418)
,p_computation_sequence=>20
,p_computation_item=>'P2501_NAVLIST_PARENT_ID'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P2501_EXISTING_LIST_ITEM_ID'
,p_compute_when=>'P2501_NAVLIST_OPTIONS'
,p_compute_when_text=>'EXISTING'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(4611902545691735)
,p_computation_sequence=>10
,p_computation_item=>'P2501_PAGE_ID'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_utilities.minimum_free_page(:FB_FLOW_ID,1)'
,p_compute_when=>'P2501_PAGE_ID'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(4612063285691736)
,p_computation_sequence=>30
,p_computation_item=>'P2501_FORM_PAGE_ID'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_utilities.minimum_free_page(:FB_FLOW_ID,1)'
,p_compute_when=>':P2501_FORM_PAGE_ID is null and :P2500_PAGE_TYPE in (''INTERACTIVE'',''GRID'',''CLASSIC'',''WORKFLOWCONSOLE'')'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1802021086977018)
,p_computation_sequence=>40
,p_computation_item=>'P2501_DASHBOARD_PAGE_ID'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_utilities.minimum_free_page(:FB_FLOW_ID,1)'
,p_compute_when=>':P2501_DASHBOARD_PAGE_ID is null and :P2500_PAGE_TYPE = ''WORKFLOWCONSOLE'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(39804839969554116)
,p_computation_sequence=>10
,p_computation_item=>'P2501_SHOW_DATA_SOURCE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_data_source varchar2(1) := ''Y'';',
'    l_standard_attributes wwv_flow_plugins.standard_attributes%type;',
'begin',
'    if   :P2500_PAGE_TYPE in (''BLANK'',''DATALOAD'',''FORMONPROC'',''DASHBOARD'',''TASKLIST'',''SEARCH'',''WORKFLOWCONSOLE'')',
'      or :P2500_PAGE_TYPE like ''TMPL\_%'' escape ''\''',
'      or :P2500_PAGE_TYPE like ''PAGEPATTERN%''',
'    then',
'        l_data_source := ''N'';      ',
'    end if;',
'    ',
'    if :P2500_PAGE_TYPE = ''PLUGIN'' then',
'        l_standard_attributes := wwv_flow_plugin_dev.get_standard_attributes (',
'                                     p_application_id => :FB_FLOW_ID,',
'                                     p_plugin_type    => ''REGION TYPE'',',
'                                     p_plugin_name    => :P2509_REGION_TYPE ); ',
'                                     ',
'        if '':''||l_standard_attributes||'':'' not like ''%:SOURCE_LOCATION:%'' then',
'            l_data_source := ''N'';    ',
'        end if;   ',
'    end if;',
'    return l_data_source;',
'end;'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2801950498886201)
,p_computation_sequence=>30
,p_computation_item=>'P2501_INCLUDE_FORM'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'Y'
,p_compute_when=>'P2500_PAGE_TYPE'
,p_compute_when_text=>'WORKFLOWCONSOLE'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(4802583119096921)
,p_computation_sequence=>40
,p_computation_item=>'P2501_SOURCE_REGION_PREFIX'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'case when :P2500_PAGE_TYPE = ''MD'' then wwv_flow_lang_dev.builder_message(''MASTER'') end'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(4805309132096949)
,p_computation_sequence=>50
,p_computation_item=>'P2501_PD_PREFIX'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case when :P2500_PAGE_TYPE = ''MD'' and :P2513_MD_TYPE = ''MD_TWO_PG'' then',
'    wwv_flow_lang_dev.builder_message(''MASTER'')',
'end'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1711783360712205)
,p_computation_sequence=>60
,p_computation_item=>'P2501_PAGE_PATTERN_PAGE_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'replace(:P2500_PAGE_TYPE, ''PAGEPATTERN_'', '''')'
,p_compute_when=>':P2500_PAGE_TYPE like ''PAGEPATTERN%'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(12403573232612930)
,p_validation_name=>'Page Number does not exists'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_steps',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and id                = :P2501_PAGE_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Page already exists, please enter different page number.'
,p_validation_condition=>'NEXT,CREATE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(12401808562612913)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(12201717912853615)
,p_validation_name=>'P2501_FORM_PAGE_ID Page Number does not exists'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_steps',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and id                = :P2501_FORM_PAGE_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Form Page already exists, please enter different page number.'
,p_validation_condition=>':P2500_PAGE_TYPE in (''INTERACTIVE'',''GRID'',''CLASSIC'') and :P2501_INCLUDE_FORM = ''Y'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(5505015818609250)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(25207835334438415)
,p_validation_name=>'Page Number not decimal or negative'
,p_validation_sequence=>30
,p_validation=>'trunc(abs(:P2501_PAGE_ID)) = :P2501_PAGE_ID'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Page Number must be a positive, whole number.'
,p_validation_condition=>'NEXT,CREATE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(12401808562612913)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(12201850206853616)
,p_validation_name=>'P2501_FORM_PAGE_ID  Page Number not decimal or negative'
,p_validation_sequence=>40
,p_validation=>'trunc(abs(:P2501_FORM_PAGE_ID )) = :P2501_FORM_PAGE_ID'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Form Page Number must be a positive, whole number.'
,p_validation_condition=>':P2500_PAGE_TYPE in (''INTERACTIVE'',''GRID'',''CLASSIC'') and :P2501_INCLUDE_FORM = ''Y'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(5505015818609250)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(12201931004853617)
,p_validation_name=>'P2501_PAGE_ID != P2501_FORM_PAGE_ID'
,p_validation_sequence=>45
,p_validation=>'trunc(:P2501_PAGE_ID) != trunc(:P2501_FORM_PAGE_ID)'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Page number and Form page number should be different'
,p_validation_condition=>':P2500_PAGE_TYPE in (''INTERACTIVE'',''GRID'',''CLASSIC'') and :P2501_INCLUDE_FORM = ''Y'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(29400527859730383)
,p_validation_name=>'Local SQL Not Null'
,p_validation_sequence=>50
,p_validation=>'P2501_SQL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'SQL query must be specified.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P2501_SHOW_DATA_SOURCE = ''Y''',
'and :P2501_SOURCE_TYPE = ''SQL''',
'and :P2501_LOCATION = ''LOCAL'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(28118404076159064)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(25211191639438448)
,p_validation_name=>'Local - Is Valid SQL query'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_describe_result wwv_flow_exec_dev.t_describe_result;',
'begin',
'    if :P2501_LOCATION = wwv_flow_exec_api.c_location_local_db then',
'        l_describe_result := wwv_flow_exec_dev.check_and_describe (',
'                                p_location             => wwv_flow_exec_api.c_location_local_db,',
'                                p_query_type           => wwv_flow_exec_api.c_query_type_sql_query,',
'                                p_sql_query            => :P2501_SQL );',
'    end if;',
'    return l_describe_result.error_message;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P2501_SHOW_DATA_SOURCE = ''Y''',
'and :P2501_SOURCE_TYPE = ''SQL''',
'and :P2501_LOCATION = ''LOCAL''',
'and :P2501_SQL is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(28118404076159064)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(25211388582438450)
,p_validation_name=>'Local - P2501_TABLE_OWNER is not null'
,p_validation_sequence=>70
,p_validation=>'P2501_TABLE_OWNER'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Table owner must be specified.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P2501_SHOW_DATA_SOURCE = ''Y''',
'and :P2501_SOURCE_TYPE = ''TABLE''',
'and :P2501_LOCATION = ''LOCAL'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(28115848614159062)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(12201636452853614)
,p_validation_name=>'Local - P2501_TABLE_NAME is not null'
,p_validation_sequence=>80
,p_validation=>'P2501_TABLE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P2501_SHOW_DATA_SOURCE = ''Y''',
'and :P2501_SOURCE_TYPE = ''TABLE''',
'and :P2501_LOCATION = ''LOCAL'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(28116733723159063)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(29405468492885102)
,p_validation_name=>'Local - Table Exists'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_tables_views_dev',
' where object_name = :P2501_TABLE_NAME',
'   and owner       = :P2501_TABLE_OWNER'))
,p_validation_type=>'EXISTS'
,p_error_message=>'Table &P2501_TABLE_NAME!HTML. does not exist. Note that the table name is case-sensitive.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P2501_SOURCE_TYPE = ''TABLE''',
'and :P2501_LOCATION = ''LOCAL''',
'and :P2501_TABLE_NAME is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(28116733723159063)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(10503939631127733)
,p_validation_name=>'DATALOAD - If format != CSV, paste text not supported'
,p_validation_sequence=>130
,p_validation=>'P2501_DATA_SOURCE_TYPE'
,p_validation2=>'TEXT'
,p_validation_type=>'ITEM_IN_VALIDATION_NOT_EQ_STRING2'
,p_error_message=>'Please select upload data from <strong>File</strong> for &P2501_DATA_PROFILE_FORMAT. data load.  The <strong>Paste Delimited Data</strong> option is supported only for CSV data load.'
,p_validation_condition=>':P2501_DATA_PROFILE_FORMAT != ''CSV'' and :P2500_PAGE_TYPE = ''DATALOAD'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(25207746014438414)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(12200719352853605)
,p_validation_name=>'P2501_FORM_PAGE_ID not null'
,p_validation_sequence=>140
,p_validation=>'P2501_FORM_PAGE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>':P2500_PAGE_TYPE in (''INTERACTIVE'',''GRID'',''CLASSIC'') and :P2501_INCLUDE_FORM = ''Y'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(5505015818609250)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(12200856197853606)
,p_validation_name=>'P2501_FORM_PAGE_NAME not null'
,p_validation_sequence=>150
,p_validation=>'P2501_FORM_PAGE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P2500_PAGE_TYPE in (''INTERACTIVE'',''GRID'',''CLASSIC'') and :P2501_INCLUDE_FORM = ''Y''',
'or',
':P2500_PAGE_TYPE = ''WORKFLOWCONSOLE'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(12200318392853601)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4805413680096950)
,p_validation_name=>'P2501_REMOTE_SERVER_ID not null'
,p_validation_sequence=>200
,p_validation=>'P2501_REMOTE_SERVER_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P2501_SHOW_DATA_SOURCE = ''Y''',
'and :P2501_LOCATION = ''REMOTE'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(28107250793159055)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4608539863691701)
,p_validation_name=>'P2501_REMOTE_TABLE_NAME not null'
,p_validation_sequence=>210
,p_validation=>'P2501_REMOTE_TABLE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P2501_SHOW_DATA_SOURCE = ''Y''',
'and :P2501_REMOTE_SOURCE_TYPE = ''TABLE''',
'and :P2501_LOCATION = ''REMOTE''',
'and :P2501_REMOTE_SERVER_ID is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(28110356684159056)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(25211078088438447)
,p_validation_name=>'Remote SQL Not Null'
,p_validation_sequence=>230
,p_validation=>'P2501_REMOTE_SQL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'SQL query must be specified.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P2501_SHOW_DATA_SOURCE = ''Y''',
'and :P2501_REMOTE_SOURCE_TYPE = ''SQL''',
'and :P2501_LOCATION = ''REMOTE'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(28108593029159056)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(25211297390438449)
,p_validation_name=>'Remote - Is Valid SQL query'
,p_validation_sequence=>240
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_describe_result wwv_flow_exec_dev.t_describe_result;',
'begin',
'    if :P2501_LOCATION =  wwv_flow_exec_api.c_location_remote_db then',
'        l_describe_result := wwv_flow_exec_dev.check_and_describe (',
'                                p_location             => wwv_flow_exec_api.c_location_remote_db,',
'                                p_remote_server_id     => :P2501_REMOTE_SERVER_ID,',
'                                p_query_type           => wwv_flow_exec_api.c_query_type_sql_query,',
'                                p_sql_query            => :P2501_REMOTE_SQL );',
'    end if;',
'    return l_describe_result.error_message;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P2501_SHOW_DATA_SOURCE = ''Y''',
'and :P2501_REMOTE_SOURCE_TYPE = ''SQL''',
'and :P2501_LOCATION = ''REMOTE''',
'and :P2501_REMOTE_SQL is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(28108593029159056)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4608716124691703)
,p_validation_name=>'P2501_WEB_SRC_MODULE_ID not null'
,p_validation_sequence=>250
,p_validation=>'P2501_WEB_SRC_MODULE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P2501_SHOW_DATA_SOURCE = ''Y''',
'and :P2501_LOCATION = ''WEB_SOURCE'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(28104436143159052)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3400658410977205)
,p_validation_name=>'SEARCH - Search Config Not Null'
,p_validation_sequence=>260
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow.g_f01.count = 0 then',
'    return false;',
'else',
'    return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Search Configurations must be selected to create a Search page.'
,p_validation_condition=>'P2500_PAGE_TYPE'
,p_validation_condition2=>'SEARCH'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(25207746014438414)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2803351614288301)
,p_validation_name=>'WORKFLOW - Theme has needed Template Components'
,p_validation_sequence=>270
,p_validation=>'wwv_flow_workflow_dev.has_theme_needed_components(:FB_FLOW_ID)'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Your current theme does not support the creation of Workflow Console. If using Universal Theme, please refresh to the latest version.'
,p_validation_condition=>'P2500_PAGE_TYPE'
,p_validation_condition2=>'WORKFLOWCONSOLE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(25207746014438414)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1906795854054623)
,p_validation_name=>'Navigation Menu not subscribed'
,p_validation_sequence=>280
,p_validation=>'coalesce(:P2500_IS_NAVLIST_SUBSCRIBED,''N'') != ''Y'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'&APP_TEXT$WIZ_NAVIGATION_MENU_SUBSCRIBED!RAW.'
,p_validation_condition=>':P2501_USE_NAVLIST = ''Y'' and :P2500_NAVLIST_ID is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(5502349303609223)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1802179600977019)
,p_validation_name=>'P2501_DASHBOARD_PAGE_ID Page Number Does Not Exist'
,p_validation_sequence=>290
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_steps',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and id                = :P2501_DASHBOARD_PAGE_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Dashboard Page already exists, please enter different page number.'
,p_validation_condition=>':P2500_PAGE_TYPE =''WORKFLOWCONSOLE'' and :P2501_INCLUDE_DASHBOARD = ''Y'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(1801578826977013)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1802227690977020)
,p_validation_name=>'P2501_DASHBOARD_PAGE_ID Page Number Not Decimal Or Negative'
,p_validation_sequence=>300
,p_validation=>'trunc(abs(:P2501_DASHBOARD_PAGE_ID )) = :P2501_DASHBOARD_PAGE_ID'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Dashboard Page Number must be a positive, whole number.'
,p_validation_condition=>':P2500_PAGE_TYPE =''WORKFLOWCONSOLE'' and :P2501_INCLUDE_DASHBOARD = ''Y'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(1801578826977013)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1802300086977021)
,p_validation_name=>'P2501_DASHBOARD_PAGE_ID Page Number Not Null'
,p_validation_sequence=>310
,p_validation=>'P2501_DASHBOARD_PAGE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>':P2500_PAGE_TYPE =''WORKFLOWCONSOLE'' and :P2501_INCLUDE_DASHBOARD = ''Y'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(1801578826977013)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1802482531977022)
,p_validation_name=>'P2501_DASHBOARD_PAGE_NAME not null'
,p_validation_sequence=>320
,p_validation=>'P2501_DASHBOARD_PAGE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>':P2500_PAGE_TYPE =''WORKFLOWCONSOLE'' and :P2501_INCLUDE_DASHBOARD = ''Y'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(1801637886977014)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(12401502644612910)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(16101259171318943)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(12401699301612911)
,p_event_id=>wwv_flow_imp.id(12401502644612910)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(15901120492127508)
,p_name=>'Focus P2501_PAGE_NAME'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(15901263383127509)
,p_event_id=>wwv_flow_imp.id(15901120492127508)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2501_PAGE_NAME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(12403983868612934)
,p_name=>'Show/Hide BC Items'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2501_USE_BREADCRUMB'
,p_condition_element=>'P2501_USE_BREADCRUMB'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(12404019916612935)
,p_event_id=>wwv_flow_imp.id(12403983868612934)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2501_BREADCRUMB_PARENT_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(25207487588438411)
,p_event_id=>wwv_flow_imp.id(12403983868612934)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2501_BREADCRUMB_PARENT_ID,P2501_BREADCRUMB_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5502105371609221)
,p_event_id=>wwv_flow_imp.id(12403983868612934)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2501_BREADCRUMB_ID'
,p_client_condition_type=>'GREATER_THAN'
,p_client_condition_element=>'P2501_BREADCRUMB_COUNT'
,p_client_condition_expression=>'1'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(39808071595554148)
,p_name=>'Hide Page Mode'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P2500_PAGE_TYPE in (''FACETED_SEARCH'',''SMART_FILTERS'',''DASHBOARD'',''TASKLIST'',''WORKFLOWCONSOLE'')',
'or (:P2500_PAGE_TYPE = ''MD'' and :P2513_MD_TYPE in (''MD_TWO_PG'',''MD_EMAIL_STYLE''))'))
,p_display_when_cond2=>'PLSQL'
,p_da_event_comment=>'We can hide P2501_PAGE_MODE directly using server side condition at item level. However, that will impact dynamic actions that depend on this item. So, hiding the item using D.A.'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(39808115657554149)
,p_event_id=>wwv_flow_imp.id(39808071595554148)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2501_PAGE_MODE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4221520771605015)
,p_name=>'Hide P2501_LOCATION'
,p_event_sequence=>30
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_cond=>'P2500_PAGE_TYPE'
,p_display_when_cond2=>'TREE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4221694830605016)
,p_event_id=>wwv_flow_imp.id(4221520771605015)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2501_LOCATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(12404374924612938)
,p_name=>'Handle Page Mode Change'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2501_PAGE_MODE'
,p_condition_element=>'P2501_PAGE_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NORMAL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(12404547277612940)
,p_event_id=>wwv_flow_imp.id(12404374924612938)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2501_USE_BREADCRUMB,P2501_BREADCRUMB_ID,P2501_NAVLIST_OPTIONS,P2501_USE_NAVLIST'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3302998802286927)
,p_event_id=>wwv_flow_imp.id(12404374924612938)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2501_FORM_PAGE_MODE'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'apex.item("P2501_PAGE_MODE").getValue()'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5502010736609220)
,p_event_id=>wwv_flow_imp.id(12404374924612938)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2501_USE_BREADCRUMB'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3303047299286928)
,p_event_id=>wwv_flow_imp.id(12404374924612938)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2501_FORM_PAGE_MODE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(12404435030612939)
,p_event_id=>wwv_flow_imp.id(12404374924612938)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2501_BREADCRUMB_ID'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select menu_id',
'  from (',
'select menu_id, count(*) item_count',
'  from wwv_flow_menu_options',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
' group by menu_id',
' order by count(*) desc )',
' where rownum = 1'))
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_client_condition_type=>'NULL'
,p_client_condition_element=>'P2501_BREADCRUMB_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5502442805609224)
,p_event_id=>wwv_flow_imp.id(12404374924612938)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2501_USE_NAVLIST'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_server_condition_type=>'EXPRESSION'
,p_server_condition_expr1=>'coalesce(:P2500_IS_NAVLIST_SUBSCRIBED,''N'') != ''Y'''
,p_server_condition_expr2=>'PLSQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3303133867286929)
,p_event_id=>wwv_flow_imp.id(12404374924612938)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2501_FORM_PAGE_MODE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4803252319096928)
,p_name=>'Hide SOURCE_TYPE Items'
,p_event_sequence=>40
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>':P2500_PAGE_TYPE in (''MD'',''TREE'')'
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4803381977096929)
,p_event_id=>wwv_flow_imp.id(4803252319096928)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2501_SOURCE_TYPE,P2501_REMOTE_SOURCE_TYPE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(25206644204438403)
,p_name=>'Handle Create New Nav List Case'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2501_NAVLIST_OPTIONS'
,p_condition_element=>'P2501_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(25206773313438404)
,p_event_id=>wwv_flow_imp.id(25206644204438403)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2501_PARENT_LIST_ITEM_ID,P2501_PAGE_ICON'
,p_client_condition_type=>'EQUALS'
,p_client_condition_element=>'P2501_USE_NAVLIST'
,p_client_condition_expression=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(25206812790438405)
,p_event_id=>wwv_flow_imp.id(25206644204438403)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2501_PARENT_LIST_ITEM_ID,P2501_PAGE_ICON'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(25207275928438409)
,p_event_id=>wwv_flow_imp.id(25206644204438403)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(12402842856612923)
,p_client_condition_type=>'EQUALS'
,p_client_condition_element=>'P2501_USE_NAVLIST'
,p_client_condition_expression=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(25207561466438412)
,p_event_id=>wwv_flow_imp.id(25206644204438403)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(12402842856612923)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(25206959915438406)
,p_name=>'Handle Existing Nav List Case'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2501_NAVLIST_OPTIONS'
,p_condition_element=>'P2501_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'EXISTING'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(25207011967438407)
,p_event_id=>wwv_flow_imp.id(25206959915438406)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2501_EXISTING_LIST_ITEM_ID'
,p_client_condition_type=>'EQUALS'
,p_client_condition_element=>'P2501_USE_NAVLIST'
,p_client_condition_expression=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(25207124024438408)
,p_event_id=>wwv_flow_imp.id(25206959915438406)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2501_EXISTING_LIST_ITEM_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(25208724344438424)
,p_name=>'Location "LOCAL"'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2501_LOCATION'
,p_condition_element=>'P2501_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'LOCAL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(25208886980438425)
,p_event_id=>wwv_flow_imp.id(25208724344438424)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(29878231234106626)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(25208978556438426)
,p_event_id=>wwv_flow_imp.id(25208724344438424)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(29878231234106626)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(25209067720438427)
,p_name=>'Location "REMOTE"'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2501_LOCATION'
,p_condition_element=>'P2501_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REMOTE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(25209142724438428)
,p_event_id=>wwv_flow_imp.id(25209067720438427)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(31668971078714554)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(25209214161438429)
,p_event_id=>wwv_flow_imp.id(25209067720438427)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(31668971078714554)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(25209388631438430)
,p_name=>'Location "WEB_SOURCE"'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2501_LOCATION'
,p_condition_element=>'P2501_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'WEB_SOURCE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(25209490250438431)
,p_event_id=>wwv_flow_imp.id(25209388631438430)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(29878316648106627)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(25209553501438432)
,p_event_id=>wwv_flow_imp.id(25209388631438430)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(29878316648106627)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(25209655533438433)
,p_name=>'Show/Hide Table/Query Items - Local'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2501_SOURCE_TYPE'
,p_condition_element=>'P2501_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TABLE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(25209755962438434)
,p_event_id=>wwv_flow_imp.id(25209655533438433)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2501_TABLE_OWNER,P2501_TABLE_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(25210037965438437)
,p_event_id=>wwv_flow_imp.id(25209655533438433)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2501_SQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(25209823653438435)
,p_event_id=>wwv_flow_imp.id(25209655533438433)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2501_TABLE_OWNER,P2501_TABLE_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(25209966772438436)
,p_event_id=>wwv_flow_imp.id(25209655533438433)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2501_SQL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(25210189134438438)
,p_name=>'Show/Hide Data Source Items'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2501_REMOTE_SERVER_ID'
,p_condition_element=>'P2501_REMOTE_SERVER_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(11529156038540906)
,p_event_id=>wwv_flow_imp.id(25210189134438438)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2501_REMOTE_SOURCE_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'TABLE'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_server_condition_type=>'ITEM_IS_NULL'
,p_server_condition_expr1=>'P2501_REMOTE_SOURCE_TYPE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(25210315101438440)
,p_event_id=>wwv_flow_imp.id(25210189134438438)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2501_REMOTE_SOURCE_TYPE,P2501_REMOTE_SQL,P2501_REMOTE_TABLE_OWNER,P2501_REMOTE_TABLE_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(25210240068438439)
,p_event_id=>wwv_flow_imp.id(25210189134438438)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2501_REMOTE_TABLE_OWNER,P2501_REMOTE_TABLE_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4803435564096930)
,p_event_id=>wwv_flow_imp.id(25210189134438438)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2501_REMOTE_SOURCE_TYPE'
,p_server_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_server_condition_expr1=>'P2500_PAGE_TYPE'
,p_server_condition_expr2=>'MD'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(25210485128438441)
,p_name=>'Show/Hide Table/Query Items - Remote'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2501_REMOTE_SOURCE_TYPE'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'apex.item("P2501_REMOTE_SERVER_ID").getValue() !== "" && apex.item("P2501_REMOTE_SOURCE_TYPE").getValue() == "TABLE" '
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(25210506494438442)
,p_event_id=>wwv_flow_imp.id(25210485128438441)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2501_REMOTE_TABLE_OWNER,P2501_REMOTE_TABLE_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(25210884884438445)
,p_event_id=>wwv_flow_imp.id(25210485128438441)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2501_REMOTE_SQL'
,p_client_condition_type=>'NOT_NULL'
,p_client_condition_element=>'P2501_REMOTE_SERVER_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(25210643934438443)
,p_event_id=>wwv_flow_imp.id(25210485128438441)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2501_REMOTE_TABLE_OWNER,P2501_REMOTE_TABLE_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(25210755002438444)
,p_event_id=>wwv_flow_imp.id(25210485128438441)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2501_REMOTE_SQL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(39803866178554106)
,p_name=>'IG - Show/Hide Next/Create Buttons'
,p_event_sequence=>120
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2501_EDITABLE'
,p_condition_element=>'P2501_EDITABLE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_cond=>'P2500_PAGE_TYPE'
,p_display_when_cond2=>'GRID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(39804020086554108)
,p_event_id=>wwv_flow_imp.id(39803866178554106)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'showHideButtons();'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(39804172679554109)
,p_event_id=>wwv_flow_imp.id(39803866178554106)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'showHideButtons();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5502517026609225)
,p_name=>'Show/Hide Nav Items'
,p_event_sequence=>140
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2501_USE_NAVLIST'
,p_condition_element=>'P2501_USE_NAVLIST'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5502686727609226)
,p_event_id=>wwv_flow_imp.id(5502517026609225)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2501_NAVLIST_OPTIONS'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5502843926609228)
,p_event_id=>wwv_flow_imp.id(5502517026609225)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2501_NAVLIST_OPTIONS,P2501_PARENT_LIST_ITEM_ID,P2501_EXISTING_LIST_ITEM_ID,P2501_PAGE_ICON'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5502963141609229)
,p_event_id=>wwv_flow_imp.id(5502517026609225)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2501_NAVLIST_OPTIONS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'NEW'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5503031454609230)
,p_event_id=>wwv_flow_imp.id(5502517026609225)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(12402842856612923)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5503586603609235)
,p_name=>'DATALOAD - Toggle file size'
,p_event_sequence=>150
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2501_DATA_SOURCE_TYPE'
,p_condition_element=>'P2501_DATA_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FILE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_cond=>'P2500_PAGE_TYPE'
,p_display_when_cond2=>'DATALOAD'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5503679604609236)
,p_event_id=>wwv_flow_imp.id(5503586603609235)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2501_MAX_FILE_SIZE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5503771719609237)
,p_event_id=>wwv_flow_imp.id(5503586603609235)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2501_MAX_FILE_SIZE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5503852887609238)
,p_name=>'DATALOAD - Get data format'
,p_event_sequence=>160
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2501_DATA_LOAD_ID'
,p_condition_element=>'P2501_DATA_LOAD_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_cond=>'P2500_PAGE_TYPE'
,p_display_when_cond2=>'DATALOAD'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5503929928609239)
,p_event_id=>wwv_flow_imp.id(5503852887609238)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select format',
'  into :P2501_DATA_PROFILE_FORMAT',
'  from wwv_flow_data_profiles p,',
'       wwv_flow_load_tables d',
' where p.id                = d.data_profile_id',
'   and d.id                = :P2501_DATA_LOAD_ID',
'   and p.flow_id           = :FB_FLOW_ID',
'   and p.security_group_id = :WORKSPACE_ID',
'   and p.flow_id           = d.flow_id',
'   and p.security_group_id = d.security_group_id;'))
,p_attribute_02=>'P2501_DATA_LOAD_ID'
,p_attribute_03=>'P2501_DATA_PROFILE_FORMAT'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5504005545609240)
,p_name=>'Submit CREATE and show progress'
,p_event_sequence=>170
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(25207746014438414)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5504123392609241)
,p_event_id=>wwv_flow_imp.id(5504005545609240)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'CREATE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5504286927609242)
,p_name=>'Submit NEXT and show progress'
,p_event_sequence=>180
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(16101666441318943)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5504351657609243)
,p_event_id=>wwv_flow_imp.id(5504286927609242)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'NEXT'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(12200468897853602)
,p_name=>'Show/Hide Form Items'
,p_event_sequence=>190
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2501_INCLUDE_FORM'
,p_condition_element=>'P2501_INCLUDE_FORM'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_display_when_cond=>'P2500_PAGE_TYPE'
,p_display_when_cond2=>'INTERACTIVE:GRID:CLASSIC:WORKFLOWCONSOLE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(12200536781853603)
,p_event_id=>wwv_flow_imp.id(12200468897853602)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2501_FORM_PAGE_ID,P2501_FORM_PAGE_NAME,P2501_FORM_PAGE_MODE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(12201545359853613)
,p_event_id=>wwv_flow_imp.id(12200468897853602)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2501_EDITABLE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(12200693264853604)
,p_event_id=>wwv_flow_imp.id(12200468897853602)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2501_FORM_PAGE_ID,P2501_FORM_PAGE_NAME,P2501_FORM_PAGE_MODE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(12201327112853611)
,p_event_id=>wwv_flow_imp.id(12200468897853602)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2501_EDITABLE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(12201406705853612)
,p_event_id=>wwv_flow_imp.id(12200468897853602)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2501_EDITABLE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(18002409143209906)
,p_event_id=>wwv_flow_imp.id(12200468897853602)
,p_event_result=>'FALSE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'showHideButtons();'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(18002362600209905)
,p_event_id=>wwv_flow_imp.id(12200468897853602)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'showHideButtons();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(7723920896899611)
,p_name=>'Validation Error - Scroll to Top'
,p_event_sequence=>500
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7724019728899612)
,p_event_id=>wwv_flow_imp.id(7723920896899611)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.message.setThemeHooks( { pageErrorsContainerSelector: ".a-Alert--horizontal" } );'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(636706490383861916)
,p_name=>'Hide P2501_BREADCRUMB_ID'
,p_event_sequence=>510
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_cond=>'P2501_BREADCRUMB_COUNT'
,p_display_when_cond2=>'1'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(636706532522861917)
,p_event_id=>wwv_flow_imp.id(636706490383861916)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2501_BREADCRUMB_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1801794007977015)
,p_name=>'Show/Hide Dashboard Items'
,p_event_sequence=>520
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2501_INCLUDE_DASHBOARD'
,p_condition_element=>'P2501_INCLUDE_DASHBOARD'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1801859981977016)
,p_event_id=>wwv_flow_imp.id(1801794007977015)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2501_DASHBOARD_PAGE_ID,P2501_DASHBOARD_PAGE_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1801977175977017)
,p_event_id=>wwv_flow_imp.id(1801794007977015)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2501_DASHBOARD_PAGE_ID,P2501_DASHBOARD_PAGE_NAME'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1711877889712206)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Page Pattern Conditions'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_has_breadcrumb boolean := false;',
'begin',
'    select page_mode',
'      into :p2501_page_mode',
'      from wwv_flow_steps',
'     where flow_id           = :fb_flow_id',
'       and security_group_id = :workspace_id',
'       and id                = :p2501_page_pattern_page_id;',
'',
'    if :p2501_page_mode in (''MODAL'',''NON_MODAL'') then',
'        :p2501_use_breadcrumb := ''N'';',
'        :p2501_use_navlist    := ''N'';',
'    else',
'        --',
'        -- Check if the pattern has a breadcrumb',
'        --',
'        for c in (',
'            select plug_source_type',
'              from wwv_flow_page_plugs',
'             where flow_id           = :fb_flow_id',
'               and security_group_id = :workspace_id',
'               and page_id           = :p2501_page_pattern_page_id',
'               and plug_source_type = ''NATIVE_BREADCRUMB'' )',
'        loop',
'            l_has_breadcrumb := true;',
'            exit;',
'        end loop;',
'        if not l_has_breadcrumb then',
'            :p2501_use_breadcrumb := ''N'';',
'        end if;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P2500_CATEGORY'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'PATTERN'
,p_internal_uid=>1711877889712206
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4220811154605008)
,p_process_sequence=>5
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update APEX Dictionary Cache'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_object_type wwv_flow_tables_views_dev.object_type%type;',
'begin',
'    select object_type',
'      into l_object_type',
'      from wwv_flow_tables_views_dev',
'     where owner       = :P2501_TABLE_OWNER',
'       and object_name = :P2501_TABLE_NAME;',
'',
'    --- if table, set APEX dictionary cache',
'    if l_object_type = ''TABLE'' then',
'        wwv_dictionary_cache_dev.set_dictionary_table_cache(',
'             p_workspace_name          => htmldb_util.find_workspace( p_security_group_id => :WORKSPACE_ID ),',
'             p_schema                  => :P2501_TABLE_OWNER,',
'             p_table_name              => :P2501_TABLE_NAME,',
'             p_flow_id                 => :FB_FLOW_ID,',
'             p_cache_fk_references     => true );',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':P2501_SHOW_DATA_SOURCE = ''Y'' and :P2501_LOCATION = ''LOCAL'' and :P2501_SOURCE_TYPE = ''TABLE'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>4220811154605008
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5502275477609222)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Breadcrumb & Navigation Items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- if use breadcrumb flag is disabled, then reset breadcrumb item values ',
'if :P2501_USE_BREADCRUMB = ''N'' then',
'    :P2501_BREADCRUMB_ID := null;',
'    :P2501_BREADCRUMB_PARENT_ID := null;',
'end if;',
'',
'-- if use navigation option is disabled, then reset navigation item values ',
'if :P2501_USE_NAVLIST = ''N'' then ',
'    :P2501_NAVLIST_OPTIONS := null;',
'    :P2501_PARENT_LIST_ITEM_ID := null;',
'    :P2501_PAGE_ICON := null;',
'    :P2501_EXISTING_LIST_ITEM_ID := null;',
'    :P2501_NAVLIST_PARENT_ID := null;',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>5502275477609222
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(29406364145885111)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Data Source Items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- reset previous values, if any',
':P2501_TAB_OWNER := null;',
':P2501_TAB_NAME := null;',
':P2501_QUERY_TYPE := null;',
':P2501_SQL_SOURCE := null;',
'',
'if :P2501_LOCATION = wwv_flow_exec_api.c_location_local_db then',
'    :P2501_TAB_OWNER        := :P2501_TABLE_OWNER;',
'    :P2501_TAB_NAME         := :P2501_TABLE_NAME;',
'    :P2501_QUERY_TYPE       := :P2501_SOURCE_TYPE;',
'    :P2501_SQL_SOURCE       := :P2501_SQL;',
'elsif :P2501_LOCATION = wwv_flow_exec_api.c_location_remote_db then',
'    :P2501_TAB_OWNER        := :P2501_REMOTE_TABLE_OWNER;',
'    :P2501_TAB_NAME         := :P2501_REMOTE_TABLE_NAME;',
'    :P2501_QUERY_TYPE       := :P2501_REMOTE_SOURCE_TYPE;',
'    :P2501_SQL_SOURCE       := :P2501_REMOTE_SQL;',
'end if;          '))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P2501_SHOW_DATA_SOURCE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'Y'
,p_internal_uid=>29406364145885111
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4403399320104819)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load Columns to Collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_extended_describe boolean;',
'begin',
'    l_extended_describe := :P2500_PAGE_TYPE in (''FORM'',''MD'') ',
'                           or (:P2500_PAGE_TYPE in (''INTERACTIVE'',''CLASSIC'',''GRID'') and :P2501_INCLUDE_FORM = ''Y'')',
'                           or (:P2500_PAGE_TYPE = ''GRID'' and :P2501_EDITABLE = ''Y'');',
'    -- output',
'    -- c001 => column_name_esc',
'    -- c002 => column_name',
'    -- c003 => data_type',
'    -- c004 => is_primary_key (Y/N) -- Only available when p_extended_describe is TRUE                           ',
'    wwv_flow_wizard_api.create_column_collection (',
'        p_collection_name        => ''WIZ_COLUMNS_LIST'',',
'        p_location               => :P2501_LOCATION,',
'        p_query_type             => :P2501_QUERY_TYPE,',
'        p_owner                  => :P2501_TAB_OWNER,',
'        p_table_name             => :P2501_TAB_NAME,',
'        p_sql_query              => :P2501_SQL_SOURCE,',
'        p_web_src_module_id      => :P2501_WEB_SRC_MODULE_ID,',
'        p_remote_server_id       => :P2501_REMOTE_SERVER_ID,',
'        p_extended_describe      => l_extended_describe );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P2501_SHOW_DATA_SOURCE = ''Y''',
'-- we show data source to calendar, but calendar uses plug-in framework',
'-- so loading columns data into this collection is not required',
' and :P2500_PAGE_TYPE not in (''CALENDAR'')'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>4403399320104819
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4609187585691707)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set P2501_ALL_COLUMNS'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_arr wwv_flow_t_varchar2;',
'begin',
'    select c002',
'      bulk collect into l_arr',
'      from wwv_flow_collections',
'     where collection_name = ''WIZ_COLUMNS_LIST''',
'     order by seq_id;',
'',
'    :P2501_ALL_COLUMNS := wwv_flow_string.join(l_arr,'':'');',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P2501_SHOW_DATA_SOURCE = ''Y''',
'-- we show data source to calendar, but calendar uses plug-in framework',
'-- so loading columns data into this collection is not required',
' and :P2500_PAGE_TYPE not in (''CALENDAR'')'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>4609187585691707
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(25208248136438419)
,p_process_sequence=>100
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Blank Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.create_blank_page (',
'    p_flow_id                  => :FB_FLOW_ID,',
'    p_page_id                  => :P2501_PAGE_ID,',
'    p_name                     => :P2501_PAGE_NAME,',
'    p_page_mode                => :P2501_PAGE_MODE,',
'    p_title                    => :P2501_PAGE_NAME,',
'    --',
'    p_nav_list_id              => :P2500_NAVLIST_ID,',
'    p_nav_list_parent_item_id  => :P2501_NAVLIST_PARENT_ID,',
'    p_nav_list_child_item_name => case when :P2501_NAVLIST_OPTIONS = ''NEW'' then :P2501_PAGE_NAME end,',
'    p_nav_list_item_icon       => :P2501_PAGE_ICON,',
'    --',
'    p_breadcrumb_id            => :P2501_BREADCRUMB_ID,',
'    p_breadcrumb_name          => :P2501_PAGE_NAME,',
'    p_parent_breadcrumb_id     => :P2501_BREADCRUMB_PARENT_ID );',
'',
'wwv_flow.update_cache_with_write(''FB_FLOW_PAGE_ID'',:P2501_PAGE_ID);',
'',
':F4000_RUN_EDIT_PAGE   := :P2501_PAGE_ID;',
':FB_FLOW_PAGE_ID       := :P2501_PAGE_ID;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to create the Blank page. #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(25207746014438414)
,p_process_when=>'P2500_PAGE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'BLANK'
,p_process_success_message=>'&P2500_PAGE_TYPE_DISPLAY. page created.'
,p_internal_uid=>25208248136438419
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1711444168712202)
,p_process_sequence=>110
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Page Pattern'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_page_dev.copy_page_pattern (',
'    p_flow_id_from             => :FB_FLOW_ID,',
'    p_page_id_from             => :P2501_PAGE_PATTERN_PAGE_ID,',
'    p_flow_id_to               => :FB_FLOW_ID,',
'    p_page_id_to               => :P2501_PAGE_ID,',
'    p_page_name_to             => :P2501_PAGE_NAME,',
'    --',
'    p_nav_list_id              => :P2500_NAVLIST_ID,',
'    p_nav_list_parent_item_id  => :P2501_NAVLIST_PARENT_ID,',
'    p_nav_list_child_item_name => case when :P2501_NAVLIST_OPTIONS = ''NEW'' then :P2501_PAGE_NAME end,',
'    p_nav_list_item_icon       => :P2501_PAGE_ICON,',
'    --',
'    p_breadcrumb_id            => :P2501_BREADCRUMB_ID,',
'    p_breadcrumb_name          => :P2501_PAGE_NAME,',
'    p_parent_breadcrumb_id     => :P2501_BREADCRUMB_PARENT_ID );',
'',
'wwv_flow.update_cache_with_write(''FB_FLOW_PAGE_ID'',:P2501_PAGE_ID);',
'',
':F4000_RUN_EDIT_PAGE   := :P2501_PAGE_ID;',
':FB_FLOW_PAGE_ID       := :P2501_PAGE_ID;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to create the Page Pattern. #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(25207746014438414)
,p_process_when=>'P2500_CATEGORY'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'PATTERN'
,p_process_success_message=>'&P2500_PAGE_TYPE_DISPLAY. page created.'
,p_internal_uid=>1711444168712202
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(29405598692885103)
,p_process_sequence=>120
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create IR Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_report_dev.create_ir_page(',
'    p_flow_id                   => :FB_FLOW_ID,',
'    p_page_id                   => :P2501_PAGE_ID,',
'    p_page_name                 => :P2501_PAGE_NAME,',
'    p_page_mode                 => :P2501_PAGE_MODE,',
'    --',
'    p_nav_list_id               => :P2500_NAVLIST_ID,',
'    p_nav_list_parent_item_id   => :P2501_NAVLIST_PARENT_ID,',
'    p_nav_list_child_item_name  => case when :P2501_NAVLIST_OPTIONS = ''NEW'' then :P2501_PAGE_NAME end,',
'    p_nav_list_item_icon        => :P2501_PAGE_ICON,',
'    --',
'    p_breadcrumb_id             => :P2501_BREADCRUMB_ID,',
'    p_breadcrumb_name           => :P2501_PAGE_NAME,',
'    p_parent_bc_id              => :P2501_BREADCRUMB_PARENT_ID,',
'    --',
'    p_query_type                => :P2501_QUERY_TYPE,',
'    p_location                  => :P2501_LOCATION,',
'    p_remote_server_id          => :P2501_REMOTE_SERVER_ID,',
'    p_web_src_module_id         => :P2501_WEB_SRC_MODULE_ID,',
'    p_table_owner               => :P2501_TAB_OWNER,',
'    p_table_name                => :P2501_TAB_NAME,',
'    p_sql_source                => :P2501_SQL_SOURCE,',
'    p_region_name               => :P2501_PAGE_NAME,',
'    p_region_template           => wwv_flow_theme_dev.get_region_template_id (',
'                                                p_application_id => :FB_FLOW_ID,',
'                                                p_theme_id       => :FB_THEME_ID,',
'                                                p_page_type      => ''INTERACTIVE''),',
'    --',
'    p_show_detail_link          => ''N'',',
'    p_use_ui_defaults           => ''Y'' );',
'                                                ',
':F4000_RUN_EDIT_PAGE   := :P2501_PAGE_ID;',
':FB_FLOW_PAGE_ID       := :P2501_PAGE_ID;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to create the Interactive Report page. #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(25207746014438414)
,p_process_when=>':P2500_PAGE_TYPE = ''INTERACTIVE'' and :P2501_INCLUDE_FORM = ''N'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'&P2500_PAGE_TYPE_DISPLAY. page created.'
,p_internal_uid=>29405598692885103
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(39804904041554117)
,p_process_sequence=>130
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create CR Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin      ',
'    wwv_flow_report_dev.create_cr_page(',
'        p_app_id                     => :FB_FLOW_ID,',
'        p_page_id                    => :P2501_PAGE_ID,',
'        p_page_name                  => :P2501_PAGE_NAME,',
'        p_page_mode                  => :P2501_PAGE_MODE,',
'        --',
'        p_nav_list_id                => :P2500_NAVLIST_ID,',
'        p_nav_list_parent_item_id    => :P2501_NAVLIST_PARENT_ID,',
'        p_nav_list_child_item_name   => case when :P2501_NAVLIST_OPTIONS = ''NEW'' then :P2501_PAGE_NAME end,',
'        p_nav_list_item_icon         => :P2501_PAGE_ICON,        ',
'        --',
'        p_breadcrumb_id              => :P2501_BREADCRUMB_ID,',
'        p_breadcrumb_entry_name      => :P2501_PAGE_NAME,',
'        p_parent_breadcrumb_entry_id => :P2501_BREADCRUMB_PARENT_ID,',
'        --',
'        p_region_title               => :P2501_PAGE_NAME,',
'        --',
'        p_location                   => :P2501_LOCATION,',
'        p_query_type                 => :P2501_QUERY_TYPE,',
'        p_table_owner                => :P2501_TAB_OWNER,',
'        p_table_name                 => :P2501_TAB_NAME,',
'        p_sql_plsql_source           => :P2501_SQL_SOURCE,',
'        --',
'        p_remote_server_id           => :P2501_REMOTE_SERVER_ID,',
'        p_web_source_module_id       => :P2501_WEB_SRC_MODULE_ID,',
'        --',
'        p_use_ui_default             => true );',
'',
'    :F4000_RUN_EDIT_PAGE   := :P2501_PAGE_ID;',
'    :FB_FLOW_PAGE_ID       := :P2501_PAGE_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to create the Classic Report page. #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(25207746014438414)
,p_process_when=>':P2500_PAGE_TYPE = ''CLASSIC'' and :P2501_INCLUDE_FORM = ''N'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'&P2500_PAGE_TYPE_DISPLAY. page created.'
,p_internal_uid=>39804904041554117
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(40215172108375357)
,p_process_sequence=>140
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create IG Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_report_dev.create_ig_page (',
'    p_application_id           => :FB_FLOW_ID,',
'    p_page_id                  => :P2501_PAGE_ID,',
'    p_page_name                => :P2501_PAGE_NAME,',
'    p_page_mode                => :P2501_PAGE_MODE,',
'    --',
'    p_nav_list_id              => :P2500_NAVLIST_ID,',
'    p_nav_list_parent_item_id  => :P2501_NAVLIST_PARENT_ID,',
'    p_nav_list_child_item_name => case when :P2501_NAVLIST_OPTIONS = ''NEW'' then :P2501_PAGE_NAME end,',
'    p_nav_list_item_icon       => :P2501_PAGE_ICON,',
'    --',
'    p_breadcrumb_id            => :P2501_BREADCRUMB_ID,',
'    p_breadcrumb_name          => :P2501_PAGE_NAME,',
'    p_parent_bc_id             => :P2501_BREADCRUMB_PARENT_ID,',
'    --',
'    p_location                 => :P2501_LOCATION,',
'    p_query_type               => :P2501_QUERY_TYPE,',
'    p_sql                      => :P2501_SQL_SOURCE,',
'    p_table_owner              => :P2501_TAB_OWNER,',
'    p_table_name               => :P2501_TAB_NAME,',
'    p_web_src_module_id        => :P2501_WEB_SRC_MODULE_ID,',
'    p_remote_server_id         => :P2501_REMOTE_SERVER_ID,',
'    p_automatic_lovs           => true,',
'    --',
'    p_is_editable              => false,',
'    p_pk_column                => null,',
'    p_pk2_column               => null );',
'',
':F4000_RUN_EDIT_PAGE   := :P2501_PAGE_ID;',
':FB_FLOW_PAGE_ID       := :P2501_PAGE_ID;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to create the Interactive Grid page. #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(25207746014438414)
,p_process_when=>':P2500_PAGE_TYPE = ''GRID'' and :P2501_INCLUDE_FORM = ''N'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'&P2500_PAGE_TYPE_DISPLAY. page created.'
,p_internal_uid=>40215172108375357
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4402337073104809)
,p_process_sequence=>150
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Dashboard Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.create_dashboard_page(',
'    p_app_id                    => :FB_FLOW_ID,',
'    p_page_id                   => :P2501_PAGE_ID,',
'    p_page_name                 => :P2501_PAGE_NAME,',
'    p_page_mode                 => wwv_flow_page.c_page_mode_normal,',
'    --',
'    p_dashboard_layout          => :P2501_DASHBOARD_LAYOUT,',
'    --',
'    p_nav_list_id               => :P2500_NAVLIST_ID,',
'    p_nav_list_parent_item_id   => :P2501_NAVLIST_PARENT_ID,',
'    p_nav_list_child_item_name  => case when :P2501_NAVLIST_OPTIONS = ''NEW'' then :P2501_PAGE_NAME end,',
'    p_nav_list_item_icon        => :P2501_PAGE_ICON,',
'    --',
'    p_breadcrumb_id             => :P2501_BREADCRUMB_ID,',
'    p_breadcrumb_name           => :P2501_PAGE_NAME,',
'    p_parent_bc_id              => :P2501_BREADCRUMB_PARENT_ID );',
'',
':FB_FLOW_PAGE_ID       := :P2501_PAGE_ID;',
':F4000_RUN_EDIT_PAGE   := :P2501_PAGE_ID;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to create the Dashboard page. #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(25207746014438414)
,p_process_when=>'P2500_PAGE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'DASHBOARD'
,p_process_success_message=>'&P2500_PAGE_TYPE_DISPLAY. page created.'
,p_internal_uid=>4402337073104809
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(10504110590129100)
,p_process_sequence=>160
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Data Load Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_data_loader_dev.create_data_load_page(',
'    p_application_id             => :FB_FLOW_ID,',
'    p_page_id                    => :P2501_PAGE_ID,',
'    p_page_name                  => :P2501_PAGE_NAME,',
'    p_page_mode                  => :P2501_PAGE_MODE,',
'    --',
'    p_nav_list_id                => :P2500_NAVLIST_ID,',
'    p_nav_list_parent_item_id    => :P2501_NAVLIST_PARENT_ID,',
'    p_nav_list_child_item_name   => case when :P2501_NAVLIST_OPTIONS = ''NEW'' then :P2501_PAGE_NAME end,',
'    p_nav_list_item_icon         => :P2501_PAGE_ICON,    ',
'    --',
'    p_breadcrumb_id              => :P2501_BREADCRUMB_ID,',
'    p_breadcrumb_entry_name      => :P2501_PAGE_NAME,',
'    p_parent_breadcrumb_entry_id => :P2501_BREADCRUMB_PARENT_ID,',
'    --',
'    p_data_load_id               => :P2501_DATA_LOAD_ID,',
'    p_data_source_type           => :P2501_DATA_SOURCE_TYPE,',
'    p_max_file_size              => :P2501_MAX_FILE_SIZE,',
'    p_use_ui_default             => ''Y'' );',
'',
':FB_FLOW_PAGE_ID       := :P2501_PAGE_ID;',
':F4000_RUN_EDIT_PAGE   := :P2501_PAGE_ID;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to create data loading page.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(25207746014438414)
,p_process_when=>'P2500_PAGE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'DATALOAD'
,p_process_success_message=>'&P2500_PAGE_TYPE_DISPLAY. page created.'
,p_internal_uid=>10504110590129100
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4612574925691741)
,p_process_sequence=>170
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Unified Task List Report Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_approval_dev.create_task_list_report (',
'        p_flow_id                    => :FB_FLOW_ID,',
'        p_report_page_id             => :P2501_PAGE_ID,',
'        p_report_page_name           => :P2501_PAGE_NAME,',
'        p_report_context             => :P2501_TASK_LIST_REPORT_CONTEXT,',
'        --',
'        p_breadcrumb_id              => :P2501_BREADCRUMB_ID,',
'        p_breadcrumb_entry_name      => :P2501_PAGE_NAME,',
'        p_parent_breadcrumb_entry_id => :P2501_BREADCRUMB_PARENT_ID,',
'        --',
'        p_nav_list_id                => :P2500_NAVLIST_ID,',
'        p_nav_list_parent_item_id    => :P2501_NAVLIST_PARENT_ID,',
'        p_nav_list_child_item_name   => case when :P2501_NAVLIST_OPTIONS = ''NEW'' then :P2501_PAGE_NAME end,',
'        p_nav_list_item_icon         => :P2501_PAGE_ICON );',
'',
'    :FB_FLOW_PAGE_ID       := :P2501_PAGE_ID;',
'    :F4000_RUN_EDIT_PAGE   := :P2501_PAGE_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error creating Unified Task List page. #SQLERRM_TEXT# '
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(25207746014438414)
,p_process_when=>'P2500_PAGE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'TASKLIST'
,p_process_success_message=>'&P2500_PAGE_TYPE_DISPLAY. page created.'
,p_internal_uid=>4612574925691741
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2802051418886202)
,p_process_sequence=>180
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Workflow Console Pages'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_workflow_dev.create_workflow_console_report (',
'        p_flow_id                    => :FB_FLOW_ID,',
'        p_report_page_id             => :P2501_PAGE_ID,',
'        p_report_page_name           => :P2501_PAGE_NAME,',
'        p_report_context             => :P2501_WORKFLOW_CONSOLE_CONTEXT,',
'        p_details_page_id            => :P2501_FORM_PAGE_ID,',
'            --',
'        p_breadcrumb_id              => :P2501_BREADCRUMB_ID,',
'        p_breadcrumb_entry_name      => :P2501_PAGE_NAME,',
'        p_parent_breadcrumb_entry_id => :P2501_BREADCRUMB_PARENT_ID,',
'        --',
'        p_nav_list_id                => :P2500_NAVLIST_ID,',
'        p_nav_list_parent_item_id    => :P2501_NAVLIST_PARENT_ID,',
'        p_nav_list_child_item_name   => case when :P2501_NAVLIST_OPTIONS = ''NEW'' then :P2501_PAGE_NAME end,',
'        p_nav_list_item_icon         => :P2501_PAGE_ICON );',
'',
'    if :P2501_INCLUDE_FORM = ''Y'' then',
'',
'        wwv_flow_workflow_dev.create_workflow_console_form (',
'            p_flow_id                    => :FB_FLOW_ID,',
'            p_details_page_id            => :P2501_FORM_PAGE_ID,',
'            p_details_page_name          => :P2501_FORM_PAGE_NAME,',
'            p_details_page_mode          => :P2501_FORM_PAGE_MODE );',
'',
'    end if;',
'',
'     if :P2501_INCLUDE_DASHBOARD = ''Y'' then',
'',
'        wwv_flow_workflow_dev.create_workflow_console_charts (',
'            p_flow_id                    => :FB_FLOW_ID,',
'            p_page_id                    => :P2501_DASHBOARD_PAGE_ID,',
'            p_page_name                  => :P2501_DASHBOARD_PAGE_NAME,',
'            p_context                    => :P2501_WORKFLOW_CONSOLE_CONTEXT,',
'            p_page_mode                  => ''NORMAL'',',
'            p_breadcrumb_id              => :P2501_BREADCRUMB_ID,',
'            p_breadcrumb_entry_name      => :P2501_DASHBOARD_PAGE_NAME,',
'            p_parent_breadcrumb_entry_id => :P2501_BREADCRUMB_PARENT_ID,',
'            --',
'            p_nav_list_id                => :P2500_NAVLIST_ID,',
'            p_nav_list_parent_item_id    => :P2501_NAVLIST_PARENT_ID,',
'            p_nav_list_child_item_name   => case when :P2501_NAVLIST_OPTIONS = ''NEW'' then :P2501_DASHBOARD_PAGE_NAME end,',
'            p_nav_list_item_icon         => :P2501_PAGE_ICON ); ',
'',
'    end if;',
'',
'    :FB_FLOW_PAGE_ID       := :P2501_PAGE_ID;',
'    :F4000_RUN_EDIT_PAGE   := :P2501_PAGE_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error creating &P2500_PAGE_TYPE_DISPLAY. page. #SQLERRM_TEXT# '
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(25207746014438414)
,p_process_when=>'P2500_PAGE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'WORKFLOWCONSOLE'
,p_process_success_message=>'&P2500_PAGE_TYPE_DISPLAY. page created.'
,p_internal_uid=>2802051418886202
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3400790964977206)
,p_process_sequence=>190
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Search Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_search_dev.create_search_page(',
'    p_application_id             => :FB_FLOW_ID,',
'    p_page_id                    => :P2501_PAGE_ID,',
'    p_page_name                  => :P2501_PAGE_NAME,',
'    p_page_mode                  => :P2501_PAGE_MODE,',
'    --',
'    p_nav_list_id                => :P2500_NAVLIST_ID,',
'    p_nav_list_parent_item_id    => :P2501_NAVLIST_PARENT_ID,',
'    p_nav_list_child_item_name   => case when :P2501_NAVLIST_OPTIONS = ''NEW'' then :P2501_PAGE_NAME end,',
'    p_nav_list_item_icon         => :P2501_PAGE_ICON,    ',
'    --',
'    p_breadcrumb_id              => :P2501_BREADCRUMB_ID,',
'    p_breadcrumb_entry_name      => :P2501_PAGE_NAME,',
'    p_parent_breadcrumb_entry_id => :P2501_BREADCRUMB_PARENT_ID,',
'    --',
'    p_search_config_ids          => wwv_flow_string.split_numbers( wwv_flow_string.table_to_string( wwv_flow.g_f01, '':'' ), '':'' ) );',
'',
':FB_FLOW_PAGE_ID       := :P2501_PAGE_ID;',
':F4000_RUN_EDIT_PAGE   := :P2501_PAGE_ID;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to create search page.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(25207746014438414)
,p_process_when=>'P2500_PAGE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'SEARCH'
,p_process_success_message=>'&P2500_PAGE_TYPE_DISPLAY. page created.'
,p_internal_uid=>3400790964977206
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3202496414180716)
,p_process_sequence=>200
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Template Report Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_report_dev.create_template_component_page (',
'    p_app_id                     => :FB_FLOW_ID,',
'    p_page_id                    => :P2501_PAGE_ID,',
'    p_page_name                  => :P2501_PAGE_NAME,',
'    p_page_mode                  => :P2501_PAGE_MODE,',
'    --',
'    p_nav_list_id                => :P2500_NAVLIST_ID,',
'    p_nav_list_parent_item_id    => :P2501_NAVLIST_PARENT_ID,',
'    p_nav_list_child_item_name   => case when :P2501_NAVLIST_OPTIONS = ''NEW'' then :P2501_PAGE_NAME end,',
'    p_nav_list_item_icon         => :P2501_PAGE_ICON,',
'    --',
'    p_breadcrumb_id              => :P2501_BREADCRUMB_ID,',
'    p_breadcrumb_entry_name      => :P2501_PAGE_NAME,',
'    p_parent_breadcrumb_entry_id => :P2501_BREADCRUMB_PARENT_ID,',
'    --',
'    p_plugin_name                => substr( :P2500_PAGE_TYPE, 6 ) );',
'    ',
':F4000_RUN_EDIT_PAGE   := :P2501_PAGE_ID;',
':FB_FLOW_PAGE_ID       := :P2501_PAGE_ID;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to create &P2500_PAGE_TYPE_DISPLAY. page.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(25207746014438414)
,p_process_when=>':P2500_PAGE_TYPE like ''TMPL\_%'' escape ''\'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'&P2500_PAGE_TYPE_DISPLAY. page created.'
,p_internal_uid=>3202496414180716
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4612257523691738)
,p_process_sequence=>210
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog - Blank'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,REQUEST'
,p_process_error_message=>'Error creating &P2500_PAGE_TYPE_DISPLAY..'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(25207746014438414)
,p_process_when=>'P2500_PAGE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'BLANK'
,p_process_success_message=>'&P2500_PAGE_TYPE_DISPLAY. created.'
,p_internal_uid=>4612257523691738
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(26900678948069482)
,p_process_sequence=>220
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,REQUEST'
,p_process_error_message=>'Error creating &P2500_PAGE_TYPE_DISPLAY. page.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(25207746014438414)
,p_process_when=>':P2500_PAGE_TYPE != ''BLANK'' and :P2501_CLOSE_DIALOG = ''Y'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'&P2500_PAGE_TYPE_DISPLAY. page created.'
,p_internal_uid=>26900678948069482
);
end;
/
prompt --application/pages/page_02502
begin
wwv_flow_imp_page.create_page(
 p_id=>2502
,p_name=>'Create Page Wizard - Form Attributes'
,p_alias=>'CREATE-PAGE-FORM-ATTRIBUTES'
,p_page_mode=>'MODAL'
,p_step_title=>'Create &P2500_PAGE_TYPE_DISPLAY.'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(103848364625132731)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_css_classes=>'a-Dialog--CreatePageDialog'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_protection_level=>'C'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(39804509364554113)
,p_plug_name=>'Branch Pages'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P2500_PAGE_TYPE = ''FORM'' and :P2501_PAGE_MODE = ''NORMAL'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(69608210379073539)
,p_plug_name=>'Primary Key '
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(98777159611585366)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(40211825181300977)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(98777159611585366)
,p_button_name=>'CREATE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Page'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>':P2500_PAGE_TYPE not in (''MD'')'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7723318792899505)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(98777159611585366)
,p_button_name=>'NEXT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>':P2500_PAGE_TYPE in (''MD'')'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(40210645838300973)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(98777159611585366)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:2501:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(40211001273300976)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(98777159611585366)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(7723645623899508)
,p_branch_name=>'Page 2515 - MD Detail Source'
,p_branch_action=>'f?p=&APP_ID.:2515:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(7723318792899505)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P2500_PAGE_TYPE'
,p_branch_condition_text=>'MD'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4804973654096945)
,p_name=>'P2502_MASTER_NAV_ORDER'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(69608210379073539)
,p_prompt=>'Form Navigation Order'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WIZ_COLUMNS_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 column_name_esc,',
'       c002 column_name',
'  from wwv_flow_collections',
' where collection_name = ''WIZ_COLUMNS_LIST''',
' order by seq_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_display_when=>'P2513_MD_TYPE'
,p_display_when2=>'MD_TWO_PG'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the navigation order column used by the previous and next buttons on the Detail Page, which navigates to a different master record.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4805011825096946)
,p_name=>'P2502_MASTER_DISP_COL1'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(69608210379073539)
,p_prompt=>'Primary Display Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WIZ_COLUMNS_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 column_name_esc,',
'       c002 column_name',
'  from wwv_flow_collections',
' where collection_name = ''WIZ_COLUMNS_LIST''',
' order by seq_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_display_when=>'P2513_MD_TYPE'
,p_display_when2=>'MD_EMAIL_STYLE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the column to display as primary column in the report to navigate to a different master record.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4805193548096947)
,p_name=>'P2502_MASTER_DISP_COL2'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(69608210379073539)
,p_prompt=>'Secondary Display Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WIZ_COLUMNS_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 column_name_esc,',
'       c002 column_name',
'  from wwv_flow_collections',
' where collection_name = ''WIZ_COLUMNS_LIST''',
' order by seq_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_display_when=>'P2513_MD_TYPE'
,p_display_when2=>'MD_EMAIL_STYLE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the column to display as secondary column in the report to navigate to a different master record.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40203031409188445)
,p_name=>'P2502_PK_COLUMN_1'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(69608210379073539)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name ',
'from (',
'select c002 column_name',
'  from wwv_flow_collections ',
' where collection_name = ''WIZ_COLUMNS_LIST''',
'   and c004 = ''Y''',
' order by seq_id )',
' where rownum = 1'))
,p_item_default_type=>'SQL_QUERY'
,p_prompt=>'Primary Key Column 1'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WIZ_COLUMNS_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 column_name_esc,',
'       c002 column_name',
'  from wwv_flow_collections',
' where collection_name = ''WIZ_COLUMNS_LIST''',
' order by seq_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select primary key column.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40203932115188447)
,p_name=>'P2502_PK_COLUMN_2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(69608210379073539)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name ',
'from (',
'select rownum pk_seq, c002 column_name',
'  from wwv_flow_collections ',
' where collection_name = ''WIZ_COLUMNS_LIST''',
'   and c004 = ''Y''',
' order by seq_id )',
' where pk_seq = 2'))
,p_item_default_type=>'SQL_QUERY'
,p_prompt=>'Primary Key Column 2'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 column_name_esc,',
'       c002 column_name',
'  from wwv_flow_collections ',
' where collection_name = ''WIZ_COLUMNS_LIST''',
'   and c002 != :P2502_PK_COLUMN_1',
' order by seq_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_lov_cascade_parent_items=>'P2502_PK_COLUMN_1'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>':P2501_LOCATION in ( wwv_flow_exec_api.c_location_local_db, wwv_flow_exec_api.c_location_remote_db )'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select primary key column.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(41900409890417763)
,p_name=>'P2502_SUBMIT_BRANCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(39804509364554113)
,p_prompt=>'Branch Here on Submit'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d',
'  from wwv_flow_steps',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and is_page_pattern   = ''N''',
'order by 2'))
,p_lov_display_null=>'YES'
,p_cSize=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select a page to branch to after the page processing is complete.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(41901236277419828)
,p_name=>'P2502_CANCEL_BRANCH'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(39804509364554113)
,p_prompt=>'Cancel and Go To Page'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d',
'  from wwv_flow_steps',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and is_page_pattern   = ''N''',
'order by 2'))
,p_lov_display_null=>'YES'
,p_cSize=>5
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select a page to which application shall redirect, when the <em>Cancel</em> button is clicked.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(40200567685180828)
,p_validation_name=>'At least one PK column selected'
,p_validation_sequence=>10
,p_validation=>'P2502_PK_COLUMN_1'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'At least one Primary Key Column must be chosen.'
,p_associated_item=>wwv_flow_imp.id(40203031409188445)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(40212273989303515)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(40211001273300976)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(40212640763303517)
,p_event_id=>wwv_flow_imp.id(40212273989303515)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(7723134148899503)
,p_name=>'Submit CREATE and show progress'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(40211825181300977)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7723262692899504)
,p_event_id=>wwv_flow_imp.id(7723134148899503)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'CREATE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(7723442914899506)
,p_name=>'Submit NEXT and show progress'
,p_event_sequence=>40
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(7723318792899505)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7723554476899507)
,p_event_id=>wwv_flow_imp.id(7723442914899506)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'NEXT'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4228938288855579)
,p_name=>'Validation Error - Scroll to Top'
,p_event_sequence=>50
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4229373127855583)
,p_event_id=>wwv_flow_imp.id(4228938288855579)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.message.setThemeHooks( { pageErrorsContainerSelector: ".a-Alert--horizontal" } );'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(15901685876127513)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Derive Branch Pages'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_branch_page number;',
'    l_url         varchar2(4000);',
'begin',
'    -- try to default the branch pages based on breadcrumb parent, if selected',
'    if :P2501_BREADCRUMB_PARENT_ID is not null then',
'        select link',
'          into l_url',
'          from wwv_flow_menu_options',
'         where id                = :P2501_BREADCRUMB_PARENT_ID',
'           and flow_id           = :FB_FLOW_ID',
'           and security_group_id = :WORKSPACE_ID;',
'',
'        l_branch_page := wwv_flow_page_map.extract_page_id (',
'                             p_url               => l_url,',
'                             p_application_id    => :FB_FLOW_ID );',
'    -- if no breadcrumb parent selected, check if list entry parent is selected',
'    -- try to derive branch page based on parent list entry',
'    elsif :P2501_BREADCRUMB_PARENT_ID is null and :P2501_NAVLIST_PARENT_ID is not null then',
'        select list_item_link_target',
'          into l_url',
'          from wwv_flow_list_items',
'         where id                = :P2501_NAVLIST_PARENT_ID',
'           and flow_id           = :FB_FLOW_ID',
'           and security_group_id = :WORKSPACE_ID;',
'',
'        l_branch_page := wwv_flow_page_map.extract_page_id (',
'                             p_url               => l_url,',
'                             p_application_id    => :FB_FLOW_ID );',
'    end if;',
'',
'    if l_branch_page is null then',
'        l_branch_page := wwv_flow_page_map.get_home_page_id (',
'                             p_application_id    => :FB_FLOW_ID );',
'    end if;',
'    ',
'    :P2502_SUBMIT_BRANCH := l_branch_page;',
'    :P2502_CANCEL_BRANCH := l_branch_page;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>':P2500_PAGE_TYPE = ''FORM'' and :P2501_PAGE_MODE = ''NORMAL'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>15901685876127513
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(40200785745182538)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Editable IG Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_report_dev.create_ig_page (',
'    p_application_id           => :FB_FLOW_ID,',
'    p_page_id                  => :P2501_PAGE_ID,',
'    p_page_name                => :P2501_PAGE_NAME,',
'    p_page_mode                => :P2501_PAGE_MODE,',
'    --',
'    p_nav_list_id              => :P2500_NAVLIST_ID,',
'    p_nav_list_parent_item_id  => :P2501_NAVLIST_PARENT_ID,',
'    p_nav_list_child_item_name => case when :P2501_NAVLIST_OPTIONS = ''NEW'' then :P2501_PAGE_NAME end,',
'    p_nav_list_item_icon       => :P2501_PAGE_ICON,    ',
'    --',
'    p_breadcrumb_id            => :P2501_BREADCRUMB_ID,',
'    p_breadcrumb_name          => :P2501_PAGE_NAME,',
'    p_parent_bc_id             => :P2501_BREADCRUMB_PARENT_ID,',
'    --',
'    p_location                 => :P2501_LOCATION,',
'    p_query_type               => :P2501_QUERY_TYPE,',
'    p_sql                      => :P2501_SQL_SOURCE,',
'    p_table_owner              => :P2501_TAB_OWNER,',
'    p_table_name               => :P2501_TAB_NAME,',
'    p_web_src_module_id        => :P2501_WEB_SRC_MODULE_ID,',
'    p_remote_server_id         => :P2501_REMOTE_SERVER_ID,',
'    p_automatic_lovs           => true,',
'    --',
'    p_is_editable              => case when :P2501_EDITABLE = ''Y'' then true else false end,',
'    p_pk_column                => :P2502_PK_COLUMN_1,',
'    p_pk2_column               => :P2502_PK_COLUMN_2 );',
'',
':F4000_RUN_EDIT_PAGE   := :P2501_PAGE_ID;',
':FB_FLOW_PAGE_ID       := :P2501_PAGE_ID;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to create the Interactive Grid page. #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(40211825181300977)
,p_process_when=>':P2500_PAGE_TYPE = ''GRID'' and :P2501_EDITABLE = ''Y'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>40200785745182538
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(39804636135554114)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Form Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_pk_columns         wwv_flow_t_varchar2;',
'    l_form_columns       wwv_flow_t_varchar2 := wwv_flow_t_varchar2();',
'begin',
'    wwv_flow_string.push( l_pk_columns, :P2502_PK_COLUMN_1 );',
'    if :P2502_PK_COLUMN_2 is not null then',
'        wwv_flow_string.push( l_pk_columns, :P2502_PK_COLUMN_2 );',
'    end if;',
'',
'    wwv_flow_form_region_dev.create_form_page(',
'        p_flow_id                    => :FB_FLOW_ID,',
'        p_page_id                    => :P2501_PAGE_ID,',
'        p_page_name                  => :P2501_PAGE_NAME,',
'        p_page_mode                  => :P2501_PAGE_MODE,',
'        --',
'        p_nav_list_id                => :P2500_NAVLIST_ID,',
'        p_nav_list_parent_item_id    => :P2501_NAVLIST_PARENT_ID,',
'        p_nav_list_child_item_name   => case when :P2501_NAVLIST_OPTIONS = ''NEW'' then :P2501_PAGE_NAME end,',
'        p_nav_list_item_icon         => :P2501_PAGE_ICON,',
'        --',
'        p_breadcrumb_id              => :P2501_BREADCRUMB_ID,',
'        p_breadcrumb_entry_name      => :P2501_PAGE_NAME,',
'        p_parent_breadcrumb_entry_id => :P2501_BREADCRUMB_PARENT_ID,',
'        --',
'        p_region_title               => :P2501_PAGE_NAME,',
'        p_region_template            => wwv_flow_theme_dev.get_region_template_id (',
'                                            p_application_id => :FB_FLOW_ID,',
'                                            p_theme_id       => :FB_THEME_ID,',
'                                            p_page_type      => ''FORM''),',
'        --',
'        p_location                   => :P2501_LOCATION,',
'        p_query_type                 => :P2501_QUERY_TYPE,',
'        p_table_owner                => :P2501_TAB_OWNER,',
'        p_table_name                 => :P2501_TAB_NAME,',
'        p_sql_plsql_source           => :P2501_SQL_SOURCE,',
'        p_remote_server_id           => :P2501_REMOTE_SERVER_ID,',
'        p_web_source_module_id       => :P2501_WEB_SRC_MODULE_ID,',
'        --',
'        p_primary_key_columns        => l_pk_columns,',
'        p_form_columns               => l_form_columns,',
'        --',
'        p_branch                     => case when :P2501_PAGE_MODE = ''NORMAL'' then :P2502_SUBMIT_BRANCH end,',
'        p_cancel_branch              => case when :P2501_PAGE_MODE = ''NORMAL'' then :P2502_CANCEL_BRANCH end,',
'        p_use_ui_default             => ''Y'' );',
'',
'    :FB_FLOW_PAGE_ID       := :P2501_PAGE_ID;',
'    :F4000_RUN_EDIT_PAGE   := :P2501_PAGE_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to create the Form page. #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(40211825181300977)
,p_process_when=>'P2500_PAGE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'FORM'
,p_internal_uid=>39804636135554114
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(12202060586853618)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Report & Form Pages'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_pk_columns          wwv_flow_t_varchar2;',
'    l_all_columns         wwv_flow_t_varchar2;',
'    l_rpt_impl            wwv_flow_form_region_dev.t_report_implementation;',
'    l_rpt_region_template number;',
'begin',
'    wwv_flow_string.push( l_pk_columns, :P2502_PK_COLUMN_1 );',
'    if :P2502_PK_COLUMN_2 is not null then',
'        wwv_flow_string.push( l_pk_columns, :P2502_PK_COLUMN_2 );',
'    end if;',
'',
'    l_all_columns := wwv_flow_string.split( :P2501_ALL_COLUMNS, '':'' );',
'',
'    if :P2500_PAGE_TYPE = ''INTERACTIVE'' then',
'        l_rpt_impl            := wwv_flow_form_region_dev.c_report_impl_interactive;',
'    elsif :P2500_PAGE_TYPE = ''CLASSIC'' then',
'        l_rpt_impl := wwv_flow_form_region_dev.c_report_impl_classic;',
'    elsif :P2500_PAGE_TYPE = ''GRID'' then',
'        l_rpt_impl := wwv_flow_form_region_dev.c_report_impl_ig;',
'    end if;',
'',
'    -- derive region template',
'    if :P2500_PAGE_TYPE = ''INTERACTIVE'' then',
'        l_rpt_region_template := wwv_flow_theme_dev.get_region_template_id (',
'                                     p_application_id => :FB_FLOW_ID,',
'                                     p_theme_id       => :FB_THEME_ID,',
'                                     p_page_type      => ''INTERACTIVE'' );',
'    else',
'        l_rpt_region_template := wwv_flow_theme_dev.get_region_template_id (',
'                                             p_application_id => :FB_FLOW_ID,',
'                                             p_theme_id       => :FB_THEME_ID,',
'                                             p_page_type      => ''REPORT'' );',
'    end if;',
'',
'    wwv_flow_form_region_dev.create_form_and_report_pages(',
'        p_flow_id                    => :FB_FLOW_ID,',
'        p_form_page_id               => :P2501_FORM_PAGE_ID,',
'        p_report_page_id             => :P2501_PAGE_ID,',
'        p_form_page_name             => :P2501_FORM_PAGE_NAME,',
'        p_report_page_name           => :P2501_PAGE_NAME,',
'        --',
'        p_report_implementation      => l_rpt_impl,',
'        -- when report page mode is normal, users can select form page mode',
'        -- when report page mode is not normal, then we use report page mode for form page as-well',
'        p_form_page_mode             => case when :P2501_PAGE_MODE = wwv_flow_page.c_page_mode_normal then',
'                                            :P2501_FORM_PAGE_MODE',
'                                        else',
'                                            :P2501_PAGE_MODE',
'                                        end,',
'        p_report_page_mode           => :P2501_PAGE_MODE,',
'        --',
'        p_nav_list_id                => :P2500_NAVLIST_ID,',
'        p_nav_list_parent_item_id    => :P2501_NAVLIST_PARENT_ID,',
'        p_nav_list_child_item_name   => case when :P2501_NAVLIST_OPTIONS = ''NEW'' then :P2501_PAGE_NAME end,',
'        p_nav_list_item_icon         => :P2501_PAGE_ICON,',
'        --',
'        p_breadcrumb_id              => :P2501_BREADCRUMB_ID,',
'        p_breadcrumb_entry_name      => :P2501_PAGE_NAME,',
'        p_parent_breadcrumb_entry_id => :P2501_BREADCRUMB_PARENT_ID,',
'        --',
'        p_location                   => :P2501_LOCATION,',
'        p_query_type                 => :P2501_QUERY_TYPE,',
'        p_table_owner                => :P2501_TAB_OWNER,',
'        p_table_name                 => :P2501_TAB_NAME,',
'        p_sql_plsql_source           => :P2501_SQL_SOURCE,',
'        p_remote_server_id           => :P2501_REMOTE_SERVER_ID,',
'        p_web_source_module_id       => :P2501_WEB_SRC_MODULE_ID,',
'        --',
'        p_primary_key_columns        => l_pk_columns,',
'        p_form_columns               => l_all_columns,',
'        p_report_columns             => l_all_columns,',
'        --',
'        p_rpt_region_template        => l_rpt_region_template,',
'        p_rpt_template               => case when l_rpt_impl = wwv_flow_form_region_dev.c_report_impl_classic',
'                                             then wwv_flow_theme_dev.get_report_template_id(',
'                                                 p_application_id => :FB_FLOW_ID,',
'                                                 p_theme_id       => :FB_THEME_ID ) end,',
'        p_rpt_region_name            => :P2501_PAGE_NAME,',
'        p_form_region_template       => wwv_flow_theme_dev.get_region_template_id (',
'                                            p_application_id => :FB_FLOW_ID,',
'                                            p_theme_id       => :FB_THEME_ID,',
'                                            p_page_type      => ''FORM''),',
'        p_form_region_name           => :P2501_FORM_PAGE_NAME,',
'        p_use_ui_default             => ''Y'' );',
'',
'    :FB_FLOW_PAGE_ID     := :P2501_PAGE_ID;',
'    :F4000_RUN_EDIT_PAGE := :P2501_PAGE_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to create report and form pages. #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(40211825181300977)
,p_process_when=>':P2500_PAGE_TYPE in (''INTERACTIVE'',''GRID'',''CLASSIC'') and :P2501_INCLUDE_FORM = ''Y'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Report page &P2501_PAGE_ID. and Form page &P2501_FORM_PAGE_ID. are created.'
,p_internal_uid=>12202060586853618
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(40247600601462028)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,REQUEST'
,p_attribute_02=>'N'
,p_process_error_message=>'Error creating &P2500_PAGE_TYPE_DISPLAY. page.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(40211825181300977)
,p_process_when=>':P2500_PAGE_TYPE = ''FORM'' or (:P2500_PAGE_TYPE = ''GRID'' and :P2501_EDITABLE = ''Y'')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'&P2500_PAGE_TYPE_DISPLAY. page created.'
,p_internal_uid=>40247600601462028
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(12202128739853619)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog - Report with Form'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,REQUEST'
,p_attribute_02=>'N'
,p_process_error_message=>'Error creating report and form pages.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(40211825181300977)
,p_process_when=>':P2500_PAGE_TYPE in (''INTERACTIVE'',''GRID'',''CLASSIC'') and :P2501_INCLUDE_FORM = ''Y'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Report and Form pages created.'
,p_internal_uid=>12202128739853619
);
end;
/
prompt --application/pages/page_02503
begin
wwv_flow_imp_page.create_page(
 p_id=>2503
,p_name=>'Create Page Wizard - Card Attributes'
,p_alias=>'CREATE-PAGE-CARD-ATTRIBUTES'
,p_page_mode=>'MODAL'
,p_step_title=>'Create &P2500_PAGE_TYPE_DISPLAY.'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(103848364625132731)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_css_classes=>'a-Dialog--CreatePageDialog'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_protection_level=>'C'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(101523861027884302)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(149991241114176690)
,p_plug_name=>'Cards Attributes'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(237542983073069001)
,p_plug_name=>'Cards Layout'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>5
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(44603538814980434)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(101523861027884302)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(44603910489980436)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(101523861027884302)
,p_button_name=>'CREATE'
,p_button_static_id=>'create_page_button'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Page'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(44604369750980436)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(101523861027884302)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&P2503_PREV_PAGE.:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12202295122853620)
,p_name=>'P2503_PREV_PAGE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(149991241114176690)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(44600844274977049)
,p_name=>'P2503_LAYOUT_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(237542983073069001)
,p_item_default=>'GRID'
,p_prompt=>'Cards Layout'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'CARDS_LAYOUT_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(12784439638072063)||'.'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-IconList--CreatePageDialog'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_attribute_01=>'S'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(44601264932977053)
,p_name=>'P2503_TITLE_COLUMN_NAME'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(149991241114176690)
,p_prompt=>'Title Column'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_col_1 as title',
'      from wwv_dictionary_cache_obj',
'     where object_owner      = :P2501_TAB_OWNER',
'       and object_name       = :P2501_TAB_NAME',
'       and security_group_id = :WORKSPACE_ID',
'       and :P2501_QUERY_TYPE = ''TABLE''',
'       and :P2501_LOCATION   = ''LOCAL'''))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WIZ_COLUMNS_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 column_name_esc,',
'       c002 column_name',
'  from wwv_flow_collections',
' where collection_name = ''WIZ_COLUMNS_LIST''',
' order by seq_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(44601693988977054)
,p_name=>'P2503_BODY_COLUMN_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(149991241114176690)
,p_prompt=>'Body Column'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_col_2 as description',
'  from wwv_dictionary_cache_obj',
' where object_owner      = :P2501_TAB_OWNER',
'   and object_name       = :P2501_TAB_NAME',
'   and security_group_id = :WORKSPACE_ID',
'   and :P2501_QUERY_TYPE = ''TABLE''',
'   and :P2501_LOCATION   = ''LOCAL'''))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WIZ_COLUMNS_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 column_name_esc,',
'       c002 column_name',
'  from wwv_flow_collections',
' where collection_name = ''WIZ_COLUMNS_LIST''',
' order by seq_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(44602001247977055)
,p_name=>'P2503_ICON_COLUMN_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(149991241114176690)
,p_prompt=>'Icon Initials Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WIZ_COLUMNS_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 column_name_esc,',
'       c002 column_name',
'  from wwv_flow_collections',
' where collection_name = ''WIZ_COLUMNS_LIST''',
' order by seq_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(44602430588977056)
,p_name=>'P2503_BADGE_COLUMN_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(149991241114176690)
,p_prompt=>'Badge Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WIZ_COLUMNS_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 column_name_esc,',
'       c002 column_name',
'  from wwv_flow_collections',
' where collection_name = ''WIZ_COLUMNS_LIST''',
' order by seq_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(39806267470554130)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(44603538814980434)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(39806302910554131)
,p_event_id=>wwv_flow_imp.id(39806267470554130)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4229789109858444)
,p_name=>'Validation Error - Scroll to Top'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4230181560858444)
,p_event_id=>wwv_flow_imp.id(4229789109858444)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.message.setThemeHooks( { pageErrorsContainerSelector: ".a-Alert--horizontal" } );'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(44702686413025678)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Cards Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_report_dev.create_card_page(',
'    p_app_id                     => :FB_FLOW_ID,',
'    p_page_id                    => :P2501_PAGE_ID,',
'    p_page_name                  => :P2501_PAGE_NAME,',
'    p_page_mode                  => :P2501_PAGE_MODE,',
'    p_use_ui_default             => true,',
'    --',
'    p_nav_list_id                => :P2500_NAVLIST_ID,',
'    p_nav_list_parent_item_id    => :P2501_NAVLIST_PARENT_ID,',
'    p_nav_list_child_item_name   => case when :P2501_NAVLIST_OPTIONS = ''NEW'' then :P2501_PAGE_NAME end,',
'    p_nav_list_item_icon         => :P2501_PAGE_ICON,    ',
'    --',
'    p_breadcrumb_id              => :P2501_BREADCRUMB_ID,',
'    p_breadcrumb_entry_name      => :P2501_PAGE_NAME,',
'    p_parent_breadcrumb_entry_id => :P2501_BREADCRUMB_PARENT_ID,',
'    --',
'    p_location                   => :P2501_LOCATION,',
'    p_query_type                 => :P2501_QUERY_TYPE,',
'    p_table_owner                => :P2501_TAB_OWNER,',
'    p_table_name                 => :P2501_TAB_NAME,',
'    p_sql_plsql_source           => :P2501_SQL_SOURCE,',
'    --',
'    p_remote_server_id           => :P2501_REMOTE_SERVER_ID,',
'    p_web_source_module_id       => :P2501_WEB_SRC_MODULE_ID,',
'    --',
'    p_layout_type                => :P2503_LAYOUT_TYPE,',
'    p_title_column_name          => :P2503_TITLE_COLUMN_NAME,',
'    p_body_column_name           => :P2503_BODY_COLUMN_NAME,',
'    p_icon_column_name           => :P2503_ICON_COLUMN_NAME,',
'    p_badge_column_name          => :P2503_BADGE_COLUMN_NAME );',
'',
':FB_FLOW_PAGE_ID       := :P2501_PAGE_ID;',
':F4000_RUN_EDIT_PAGE   := :P2501_PAGE_ID;    '))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to create the Cards page. #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(44603910489980436)
,p_process_when=>'P2500_PAGE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'CARD'
,p_internal_uid=>44702686413025678
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(50010427201913598)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create FS/SF Page with Cards'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_faceted_search_dev.create_faceted_search_page(',
'    p_flow_id                    => :FB_FLOW_ID,',
'    p_filter_region_type         => case when :P2500_PAGE_TYPE = ''FACETED_SEARCH'' then',
'                                        wwv_flow_faceted_search_dev.c_filter_region_faceted_search',
'                                    when :P2500_PAGE_TYPE = ''SMART_FILTERS'' then',
'                                        wwv_flow_faceted_search_dev.c_filter_region_smart_filters',
'                                    end,',
'    p_result_region_type         => wwv_flow_faceted_search_dev.c_result_region_card,',
'    p_page_id                    => :P2501_PAGE_ID,',
'    p_page_name                  => :P2501_PAGE_NAME,',
'    p_page_mode                  => wwv_flow_page.c_page_mode_normal,',
'    p_use_ui_default             => true,',
'    --',
'    p_nav_list_id                => :P2500_NAVLIST_ID,',
'    p_nav_list_parent_item_id    => :P2501_NAVLIST_PARENT_ID,',
'    p_nav_list_child_item_name   => case when :P2501_NAVLIST_OPTIONS = ''NEW'' then :P2501_PAGE_NAME end,',
'    p_nav_list_item_icon         => :P2501_PAGE_ICON,',
'    --',
'    p_breadcrumb_id              => :P2501_BREADCRUMB_ID,',
'    p_breadcrumb_entry_name      => :P2501_PAGE_NAME,',
'    p_parent_breadcrumb_entry_id => :P2501_BREADCRUMB_PARENT_ID,',
'    --',
'    p_location                   => :P2501_LOCATION,',
'    p_query_type                 => :P2501_QUERY_TYPE,',
'    p_table_owner                => :P2501_TAB_OWNER,',
'    p_table_name                 => :P2501_TAB_NAME,',
'    p_sql_plsql_source           => :P2501_SQL_SOURCE,',
'    --',
'    p_remote_server_id           => :P2501_REMOTE_SERVER_ID,',
'    p_web_source_module_id       => :P2501_WEB_SRC_MODULE_ID,',
'    --',
'    p_card_layout_type           => :P2503_LAYOUT_TYPE,',
'    p_card_title_column_name     => :P2503_TITLE_COLUMN_NAME,',
'    p_card_body_column_name      => :P2503_BODY_COLUMN_NAME,',
'    p_card_icon_column_name      => :P2503_ICON_COLUMN_NAME,',
'    p_card_badge_column_name     => :P2503_BADGE_COLUMN_NAME,',
'    --',
'    p_facet_columns              => wwv_flow_string.split( :P2504_FACET_COLUMNS, '':'' ),',
'    p_report_columns             => wwv_flow_string.split( :P2501_ALL_COLUMNS, '':'' ) );',
'',
':FB_FLOW_PAGE_ID       := :P2501_PAGE_ID;',
':F4000_RUN_EDIT_PAGE   := :P2501_PAGE_ID;    '))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to create the &P2500_PAGE_TYPE_DISPLAY. page. #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(44603910489980436)
,p_process_when=>':P2500_PAGE_TYPE in (''FACETED_SEARCH'',''SMART_FILTERS'')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>50010427201913598
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(44702320231023034)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,REQUEST'
,p_attribute_02=>'N'
,p_process_error_message=>'Error creating &P2500_PAGE_TYPE_DISPLAY. page.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(44603910489980436)
,p_process_success_message=>'&P2500_PAGE_TYPE_DISPLAY. page created.'
,p_internal_uid=>44702320231023034
);
end;
/
prompt --application/pages/page_02504
begin
wwv_flow_imp_page.create_page(
 p_id=>2504
,p_name=>'Create Page Wizard - Faceted Search'
,p_alias=>'CREATE-PAGE-FS-ATTRIBUTES'
,p_page_mode=>'MODAL'
,p_step_title=>'Create &P2500_PAGE_TYPE_DISPLAY.'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(103848364625132731)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_css_classes=>'a-Dialog--CreatePageDialog'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_protection_level=>'C'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(148624402114887353)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(572537019842755431)
,p_plug_name=>'Facets - Local Table'
,p_region_name=>'fs-table'
,p_region_css_classes=>'margin-top-md'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>30
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from wwv_dictionary_cache_col',
' where table_name        = :P2501_TAB_NAME',
'   and :P2501_LOCATION   = ''LOCAL''',
'   and :P2501_QUERY_TYPE = ''TABLE'''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(566407246488306059)
,p_name=>'Facet Report for Local Table'
,p_region_name=>'table-fsReport'
,p_parent_plug_id=>wwv_flow_imp.id(572537019842755431)
,p_template=>wwv_flow_imp.id(208928010704475743)
,p_display_sequence=>30
,p_region_css_classes=>'margin-sm'
,p_region_sub_css_classes=>'facet-report'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with top5 as (',
'  select column_value column_name',
'  from table( wwv_flow_faceted_search_dev.get_top5_facet_columns(',
'              p_table_owner => :P2501_TAB_OWNER,',
'              p_table_name  => :P2501_TAB_NAME ) ) )',
'select wwv_flow_item.hidden( 1, c.column_name )||',
'       case when c.filterable_score >= 20 and',
'            regexp_replace( c.data_type, ''\(\d+\)'', '''' ) not member of wwv_flow_faceted_search_dev.get_date_col_types and -- 19.2 ignore dates',
'            ( coalesce( c.num_distinct, 0) <= 2000 or c.filter_display_as = ''RANGE'' ) -- if not range, ignore columns with too many distinct values',
'       then',
'          htmldb_item.checkbox2(',
'              p_idx            => 2,',
'              p_value          => c.column_name,',
'              p_attributes     => ''class="u-vh apex-ui-selector-input"'',',
'              p_checked_values => t.column_name,',
'              p_item_id        => ''cb_''||wwv_flow_escape.html_attribute(c.column_name)) || ''<label class="apex-ui-selector" for="cb_''||wwv_flow_escape.html_attribute(c.column_name)||''" aria-labelledby="cb_label_''||wwv_flow_escape.html_attribute(c.col'
||'umn_name)||''"></label>''',
'       end facets,',
'       case when c.filterable_score >= 20 and',
'            c.data_type not member of wwv_flow_faceted_search_dev.get_date_col_types and -- 19.2 ignore dates',
'            ( coalesce( c.num_distinct, 0) <= 2000 or c.filter_display_as = ''RANGE'' ) -- if not range, ignore columns with too many distinct values',
'       then',
'          ''<label for="cb_''||wwv_flow_escape.html_attribute(c.column_name)||''" id="cb_label_''||wwv_flow_escape.html_attribute(c.column_name)||''">''||wwv_flow_escape.html(c.column_name)||'' (''||wwv_flow_escape.html(lower(c.data_type))||'')</label>''',
'       else',
'          wwv_flow_escape.html(c.column_name)||'' (''||wwv_flow_escape.html(lower(c.data_type))||'')''',
'       end column_name,',
'       case when c.filterable_score >= 20 and',
'            regexp_replace( c.data_type, ''\(\d+\)'', '''' ) not member of wwv_flow_faceted_search_dev.get_date_col_types and -- 19.2 ignore dates',
'            ( coalesce( c.num_distinct, 0) <= 2000 or c.filter_display_as = ''RANGE'' ) -- if not range, ignore columns with too many distinct values',
'       then',
'           wwv_flow_item.text_from_lov (',
'               p_value => c.filter_display_as,',
'               p_lov   => ''WIZ_FACET_TYPE'' )',
'       end facet_type,',
'       c.filterable_score  facet_score,',
'       case when c.is_fk_yn = ''Y'' then',
'           ''Y''',
'       else',
'           c.filter_global_searchable_yn',
'       end include_in_search,',
'       c.num_distinct,',
'       c.num_nulls,',
'       c.avg_col_len',
'  from wwv_dictionary_cache_col c,',
'       top5 t',
' where c.column_name       = t.column_name (+)',
'   and c.security_group_id = :WORKSPACE_ID',
'   and c.owner_name        = :P2501_TAB_OWNER',
'   and c.table_name        = :P2501_TAB_NAME',
'   and :P2501_TAB_NAME     is not null',
' order by c.column_id'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P2501_TAB_OWNER,P2501_TAB_NAME'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1024
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'There are no facet recommendations.'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47801683356897678)
,p_query_column_id=>1
,p_column_alias=>'FACETS'
,p_column_display_sequence=>1
,p_column_heading=>'<span class="u-vh">Select Facet</span>'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47802066265897679)
,p_query_column_id=>2
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Column'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47802444888897679)
,p_query_column_id=>3
,p_column_alias=>'FACET_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'&P2504_FACET_TYPE_LABEL!HTML.'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47802700348897680)
,p_query_column_id=>4
,p_column_alias=>'FACET_SCORE'
,p_column_display_sequence=>8
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47803150172897680)
,p_query_column_id=>5
,p_column_alias=>'INCLUDE_IN_SEARCH'
,p_column_display_sequence=>4
,p_column_heading=>'Searchable'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(84259319526460470)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47803535086897680)
,p_query_column_id=>6
,p_column_alias=>'NUM_DISTINCT'
,p_column_display_sequence=>6
,p_column_heading=>'Distinct'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47803926297897681)
,p_query_column_id=>7
,p_column_alias=>'NUM_NULLS'
,p_column_display_sequence=>5
,p_column_heading=>'Nulls'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47804388603897681)
,p_query_column_id=>8
,p_column_alias=>'AVG_COL_LEN'
,p_column_display_sequence=>7
,p_column_heading=>'Average Length'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G999G999G990'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(574672867338399631)
,p_plug_name=>'Facet Information'
,p_parent_plug_id=>wwv_flow_imp.id(572537019842755431)
,p_region_css_classes=>'padding-sm'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noPadding:a-ButtonRegion--noUI:a-ButtonRegion--accessibleTitle'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'Select the &P2504_FACET_TYPE_LABEL!HTML. you want to include in this report.  Note that &P2504_FACET_TYPE_LABEL!HTML. recommendations are based on statistics of data in your table. You can refresh the column statistics to provide better recommendatio'
||'ns.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(699196897409554362)
,p_plug_name=>'Facets - Other'
,p_region_name=>'fs-other'
,p_region_css_classes=>'margin-top-md'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>40
,p_plug_display_condition_type=>'NOT_EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from wwv_dictionary_cache_col',
' where table_name        = :P2501_TAB_NAME',
'   and :P2501_LOCATION   = ''LOCAL''',
'   and :P2501_QUERY_TYPE = ''TABLE'''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(699195543607554348)
,p_name=>'Facets Report'
,p_region_name=>'other-fsReport'
,p_parent_plug_id=>wwv_flow_imp.id(699196897409554362)
,p_template=>wwv_flow_imp.id(208928010704475743)
,p_display_sequence=>30
,p_region_css_classes=>'margin-sm'
,p_region_sub_css_classes=>'facet-report'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with rpt_columns as (',
'    select seq_id column_id,',
'           c002   column_name,',
'           c003   data_type,',
'           n001   data_type_length',
'      from wwv_flow_collections ',
'     where collection_name = ''WIZ_COLUMNS_LIST'' ),',
'top5 as (',
'    select column_name',
'      from rpt_columns',
'     where data_type = ''VARCHAR2''',
'     order by data_type_length asc',
'     fetch first 5 row only )',
'select wwv_flow_item.hidden( 1, c.column_name )||',
'       case when c.data_type = ''VARCHAR2'' then',
'          htmldb_item.checkbox2(',
'              p_idx            => 2,',
'              p_value          => c.column_name,',
'              p_attributes     => ''class="u-vh apex-ui-selector-input"'',',
'              p_checked_values => t.column_name,',
'              p_item_id        => ''cb_''||wwv_flow_escape.html_attribute(c.column_name)) || ''<label class="apex-ui-selector" for="cb_''||wwv_flow_escape.html_attribute(c.column_name)||''" aria-labelledby="cb_label_''||wwv_flow_escape.html_attribute(c.col'
||'umn_name)||''"></label>''',
'       end facets,',
'       case when c.data_type = ''VARCHAR2'' then',
'          ''<label for="cb_''||wwv_flow_escape.html_attribute(c.column_name)||''" id="cb_label_''||wwv_flow_escape.html_attribute(c.column_name)||''">''||wwv_flow_escape.html(c.column_name)||'' (''||wwv_flow_escape.html(lower(c.data_type))||'')</label>''',
'       else',
'          wwv_flow_escape.html(c.column_name)||'' (''||wwv_flow_escape.html(lower(c.data_type))||'')''',
'       end column_name,',
'       case when c.data_type = ''VARCHAR2'' then',
'           wwv_flow_item.text_from_lov (',
'               p_value => ''CHECKBOX'',',
'               p_lov   => ''WIZ_FACET_TYPE'' )',
'       end facet_type,',
'       case when c.data_type = ''VARCHAR2'' then',
'           ''Y''',
'       end include_in_search',
'  from rpt_columns c,',
'       top5 t',
' where c.column_name = t.column_name (+)',
' order by c.column_id'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1024
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'There are no columns to select.'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47805333565900143)
,p_query_column_id=>1
,p_column_alias=>'FACETS'
,p_column_display_sequence=>1
,p_column_heading=>'<span class="u-vh">Select Facet</span>'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47805791986900146)
,p_query_column_id=>2
,p_column_alias=>'COLUMN_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Column'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47806125408900146)
,p_query_column_id=>3
,p_column_alias=>'FACET_TYPE'
,p_column_display_sequence=>3
,p_column_heading=>'&P2504_FACET_TYPE_LABEL!HTML.'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(47806562902900147)
,p_query_column_id=>4
,p_column_alias=>'INCLUDE_IN_SEARCH'
,p_column_display_sequence=>4
,p_column_heading=>'Searchable'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(84259319526460470)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(699197010284554363)
,p_plug_name=>'Facet Information'
,p_parent_plug_id=>wwv_flow_imp.id(699196897409554362)
,p_region_css_classes=>'padding-sm'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noPadding:a-ButtonRegion--noUI:a-ButtonRegion--accessibleTitle'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'Select the &P2504_FACET_TYPE_LABEL!HTML. you want to include in this report.  The generated page may error out if the selected column contains too many distinct values.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(47100886602003097)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(148624402114887353)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(47800945275897670)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(574672867338399631)
,p_button_name=>'RECOMPUTE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Refresh'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'margin-left-md'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(47101259145003100)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(148624402114887353)
,p_button_name=>'CREATE'
,p_button_static_id=>'create_page_button'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Page'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(39806600182554134)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(148624402114887353)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(47101653764003100)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(148624402114887353)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:2501:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(50009527128898824)
,p_branch_name=>'Page 2503 - Card Attributes'
,p_branch_action=>'f?p=&APP_ID.:2503:&SESSION.::&DEBUG.::P2503_PREV_PAGE:2504&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(39806600182554134)
,p_branch_sequence=>40
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P2504_FS_DISPLAY_AS'
,p_branch_condition_text=>'CARD'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(39805710028554125)
,p_name=>'P2504_FACET_TYPE_LABEL'
,p_item_sequence=>20
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(39807439557554142)
,p_name=>'P2504_FACET_COLUMNS'
,p_item_sequence=>50
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(47900412874101054)
,p_name=>'P2504_FS_DISPLAY_AS'
,p_item_sequence=>10
,p_item_default=>'CR'
,p_prompt=>'Display as'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'FS_DISPLAY_AS'
,p_lov=>'.'||wwv_flow_imp.id(592389652645199591)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select how you want to display the filtered region.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(39805808219554126)
,p_computation_sequence=>10
,p_computation_item=>'P2504_FACET_TYPE_LABEL'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P2500_PAGE_TYPE = ''FACETED_SEARCH'' then',
'    return wwv_flow_lang_dev.builder_message( p_name => ''WIZARD.CREATE.PAGE.FS.FACET'' );',
'else',
'    return wwv_flow_lang_dev.builder_message( p_name => ''WIZARD.CREATE.PAGE.SMART_FILTERS.FILTER'' );',
'end if;'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(48000760652342511)
,p_name=>'Reset facet dictionary cache with stats'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(47800945275897670)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(48001145351342532)
,p_event_id=>wwv_flow_imp.id(48000760652342511)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_workspace_name varchar2(255);',
'begin',
'    l_workspace_name := htmldb_util.find_workspace( p_security_group_id => :WORKSPACE_ID );',
'    wwv_dictionary_cache_dev.reset_dictionary_table_cache(',
'        p_workspace_name           => l_workspace_name,',
'        p_schema                   => :P2501_TAB_OWNER,',
'        p_table_name               => :P2501_TAB_NAME,',
'        p_flow_id                  => :FB_FLOW_ID,',
'        p_gather_stats             => true,',
'        p_cache_fk_references      => true);',
'end;'))
,p_attribute_02=>'P2501_TAB_OWNER,P2501_TAB_NAME'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(39806118056554129)
,p_event_id=>wwv_flow_imp.id(48000760652342511)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(566407246488306059)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(39806460850554132)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(47100886602003097)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(39806506253554133)
,p_event_id=>wwv_flow_imp.id(39806460850554132)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(39806797835554135)
,p_name=>'Show/Hide buttons'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2504_FS_DISPLAY_AS'
,p_condition_element=>'P2504_FS_DISPLAY_AS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'CR'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(39806874107554136)
,p_event_id=>wwv_flow_imp.id(39806797835554135)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(47101259145003100)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(39807185791554139)
,p_event_id=>wwv_flow_imp.id(39806797835554135)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(39806600182554134)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(39806998405554137)
,p_event_id=>wwv_flow_imp.id(39806797835554135)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(47101259145003100)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(39807058301554138)
,p_event_id=>wwv_flow_imp.id(39806797835554135)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(39806600182554134)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(49900353550529189)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create FS/SF Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_faceted_search_dev.create_faceted_search_page(',
'    p_flow_id                    => :FB_FLOW_ID,',
'    p_filter_region_type         => case when :P2500_PAGE_TYPE = ''FACETED_SEARCH'' then',
'                                        wwv_flow_faceted_search_dev.c_filter_region_faceted_search',
'                                    when :P2500_PAGE_TYPE = ''SMART_FILTERS'' then',
'                                        wwv_flow_faceted_search_dev.c_filter_region_smart_filters',
'                                    end,',
'    p_result_region_type         => case when :P2504_FS_DISPLAY_AS = ''CR'' then',
'                                        wwv_flow_faceted_search_dev.c_result_region_classic',
'                                    when :P2504_FS_DISPLAY_AS = ''CARD'' then',
'                                        wwv_flow_faceted_search_dev.c_result_region_card',
'                                    end,',
'    p_page_id                    => :P2501_PAGE_ID,',
'    p_page_name                  => :P2501_PAGE_NAME,',
'    p_page_mode                  => wwv_flow_page.c_page_mode_normal,',
'    p_use_ui_default             => true,',
'    --',
'    p_nav_list_id                => :P2500_NAVLIST_ID,',
'    p_nav_list_parent_item_id    => :P2501_NAVLIST_PARENT_ID,',
'    p_nav_list_child_item_name   => case when :P2501_NAVLIST_OPTIONS = ''NEW'' then :P2501_PAGE_NAME end,',
'    p_nav_list_item_icon         => :P2501_PAGE_ICON,',
'    --',
'    p_breadcrumb_id              => :P2501_BREADCRUMB_ID,',
'    p_breadcrumb_entry_name      => :P2501_PAGE_NAME,',
'    p_parent_breadcrumb_entry_id => :P2501_BREADCRUMB_PARENT_ID,',
'    --',
'    p_location                   => :P2501_LOCATION,',
'    p_query_type                 => :P2501_QUERY_TYPE,',
'    p_table_owner                => :P2501_TAB_OWNER,',
'    p_table_name                 => :P2501_TAB_NAME,',
'    p_sql_plsql_source           => :P2501_SQL_SOURCE,',
'    --',
'    p_remote_server_id           => :P2501_REMOTE_SERVER_ID,',
'    p_web_source_module_id       => :P2501_WEB_SRC_MODULE_ID,',
'    --',
'    --p_card_layout_type           => null,',
'    --p_card_title_column_name     => null,',
'    --p_card_body_column_name      => null,',
'    --p_card_icon_column_name      => null,',
'    --p_card_badge_column_name     => null,',
'    --',
'    p_facet_columns              => wwv_flow_string.split( wwv_flow_string.table_to_string( wwv_flow.g_f02, '':'' ), '':'' ),',
'    p_report_columns             => wwv_flow_string.split( :P2501_ALL_COLUMNS, '':'' ) );',
'',
':FB_FLOW_PAGE_ID       := :P2501_PAGE_ID;',
':F4000_RUN_EDIT_PAGE   := :P2501_PAGE_ID;    '))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to create the &P2500_PAGE_TYPE_DISPLAY. page. #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(47101259145003100)
,p_internal_uid=>49900353550529189
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(49900632557530588)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,REQUEST'
,p_attribute_02=>'N'
,p_process_error_message=>'Error creating &P2500_PAGE_TYPE_DISPLAY. page.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(47101259145003100)
,p_process_success_message=>'&P2500_PAGE_TYPE_DISPLAY. page created.'
,p_internal_uid=>49900632557530588
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(39807378515554141)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Store Facet Columns'
,p_process_sql_clob=>':P2504_FACET_COLUMNS := wwv_flow_string.table_to_string( wwv_flow.g_f02, '':'' );'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(39806600182554134)
,p_internal_uid=>39807378515554141
);
end;
/
prompt --application/pages/page_02505
begin
wwv_flow_imp_page.create_page(
 p_id=>2505
,p_name=>'Create Page Wizard - Chart Attributes'
,p_alias=>'CREATE-PAGE-CHART-ATTRIBUTES'
,p_page_mode=>'MODAL'
,p_step_title=>'Create &P2500_PAGE_TYPE_DISPLAY.'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(103848364625132731)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_css_classes=>'a-Dialog--CreatePageDialog'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_protection_level=>'C'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(153424724653337182)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(274365359927234493)
,p_plug_name=>'Create Chart'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>5000
,p_plug_query_num_rows_type=>'0'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'L:C:C:C:C:C'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4800613213449874)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(153424724653337182)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4801074006449876)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(153424724653337182)
,p_button_name=>'CREATE'
,p_button_static_id=>'create_page_button'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Page'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4801861976449877)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(153424724653337182)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:2501:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5000571152617748)
,p_name=>'P2505_CHART_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(274365359927234493)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Chart Type:'
,p_source=>'P2514_JET_CHART_TYPE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'JET_CHART_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(285041260607381464)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'P2514_JET_CHART_TYPE'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'The type of chart to be created.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5003273865617763)
,p_name=>'P2505_ORIENTATION'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(274365359927234493)
,p_item_default=>'vertical'
,p_prompt=>'Orientation'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'JET_CHART_ORIENTATION'
,p_lov=>'.'||wwv_flow_imp.id(272256574572764306)||'.'
,p_cHeight=>1
,p_display_when=>'P2514_JET_CHART_TYPE'
,p_display_when2=>'area:bar:boxPlot:combo:line:funnel:lineWithArea:range'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select the orientation of this chart. Available options include:<p/>',
'<li><strong>Vertical</strong> Displays the data items of the chart vertically. For example, the bars on a Bar chart will display vertically.</li>',
'<li><strong>Horizontal</strong> Displays the data items of the chart horizontally. For example, the bars on a Bar chart will display horizontally.</li>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5004135159617766)
,p_name=>'P2505_GAUGE_ORIENTATION'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(274365359927234493)
,p_item_default=>'circular'
,p_prompt=>'Orientation'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'JET_GAUGE_ORIENTATION'
,p_lov=>'.'||wwv_flow_imp.id(21606267597566254)||'.'
,p_cHeight=>1
,p_display_when=>'P2514_JET_CHART_TYPE'
,p_display_when2=>'dial'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select the orientation of this Status Meter Gauge chart. Available options include:<p/>',
'<li><strong>Circular</strong> Displays the metric value of the chart on a circular axis.</li>',
'<li><strong>Horizontal</strong> Displays the metric value of the chart on a horizontal axis.</li>',
'<li><strong>Vertical</strong> Displays the metric value of the chart on a vertical axis.</li>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5005019595617768)
,p_name=>'P2505_PAGE_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(274365359927234493)
,p_source=>'P2501_PAGE_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Identifies the currently selected page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5005995352617769)
,p_name=>'P2505_OWNER'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(274365359927234493)
,p_source=>'P2501_TAB_OWNER'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Identifies the schema that owns the table.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5006893373617770)
,p_name=>'P2505_TABLE_NAME'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(274365359927234493)
,p_prompt=>'Table / View Name:'
,p_source=>'P2501_TAB_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'P2501_TAB_NAME'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The database object (table or view) on which this chart is based.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5007746666617771)
,p_name=>'P2505_LABEL_COL'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(274365359927234493)
,p_prompt=>'Label Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 d, c002 r',
'  from wwv_flow_collections',
' where collection_name = ''WIZ_COLUMNS_LIST''',
'   and c003 in ( ''VARCHAR2'', ''NUMBER'', ''DATE'', ''TIMESTAMP'', ''TIMESTAMP_TZ'', ''TIMESTAMP_LTZ'' )',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_display_when=>'P2514_JET_CHART_TYPE'
,p_display_when2=>'dial:GANTT'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the column name to be used for defining the label(s) of the x-axis on the chart. For a Stock chart, the column should be of data type Date/Timestamp, to represent the stock information on a time axis.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5008695110617774)
,p_name=>'P2505_AGGREGATE_FUNCTION'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(274365359927234493)
,p_item_default=>'COLVALUE'
,p_prompt=>'Value Aggregation'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'AGGREGATE_FUNCTIONS'
,p_lov=>'.'||wwv_flow_imp.id(101016778607432389)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Aggregation -'
,p_cHeight=>1
,p_display_when=>':P2501_QUERY_TYPE = ''TABLE'' and :P2514_JET_CHART_TYPE not in (''GANTT'',''boxPlot'',''scatter'',''stock'',''range'',''bubble'')'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select how to aggregate the chart Value Column. When <strong>Count</strong> is selected, the aggregation will automatically be based on the Label Column selected. For all other aggregation options, when no Value Column is selected, the aggregation wi'
||'ll be based on the Label column selected. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5009542776617777)
,p_name=>'P2505_VALUE_COL'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(274365359927234493)
,p_prompt=>'Value Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 d, c002 r',
'  from wwv_flow_collections',
' where collection_name = ''WIZ_COLUMNS_LIST''',
'   and c003 = ''NUMBER''',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_display_when=>'P2514_JET_CHART_TYPE'
,p_display_when2=>'area:bar:combo:dial:funnel:line:lineWithArea:pie:donut:radar:polar:pyramid:boxPlot'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the column name to be used for defining the value on this chart.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5010454359617778)
,p_name=>'P2505_TARGET_COL'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(274365359927234493)
,p_prompt=>'Target Value Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 d, c002 r',
'  from wwv_flow_collections',
' where collection_name  = ''WIZ_COLUMNS_LIST''',
'   and c003 = ''NUMBER''',
'   and c002 not in (:P2505_VALUE_COL)',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P2505_VALUE_COL'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>'P2514_JET_CHART_TYPE'
,p_display_when2=>'funnel'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the numeric column to be used for the target value on the chart.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5011322043617778)
,p_name=>'P2505_SERIES_NAME_COL'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(274365359927234493)
,p_display_as=>'NATIVE_HIDDEN'
,p_display_when=>'P2514_JET_CHART_TYPE'
,p_display_when2=>'area:bar:bubble:combo:line:lineWithArea:scatter'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_help_text=>'Specify which column is used as the Series Name value on the chart.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5012232335617779)
,p_name=>'P2505_MAX_VAL_COL'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(274365359927234493)
,p_prompt=>'Maximum Value Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 d, c002 r',
'  from wwv_flow_collections',
' where collection_name  = ''WIZ_COLUMNS_LIST''',
'   and c003 = ''NUMBER''',
'   and c002 not in (:P2505_VALUE_COL)',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P2505_VALUE_COL'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>'P2514_JET_CHART_TYPE'
,p_display_when2=>'dial'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the numeric column to be used for the maximum value on the chart.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5013132667617780)
,p_name=>'P2505_LOW_COL'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(274365359927234493)
,p_prompt=>'Low Value Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 d, c002 r',
'  from wwv_flow_collections',
' where collection_name  = ''WIZ_COLUMNS_LIST''',
' and   c003 = ''NUMBER''',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_display_when=>'P2514_JET_CHART_TYPE'
,p_display_when2=>'range:stock'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the numeric column to be used for the low value on the chart.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5014033870617780)
,p_name=>'P2505_HIGH_COL'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(274365359927234493)
,p_prompt=>'High Value Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 d, c002 r',
'  from wwv_flow_collections',
' where collection_name  = ''WIZ_COLUMNS_LIST''',
'   and c003 = ''NUMBER''',
'   and c002 not in (:P2505_LOW_COL)',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P2505_LOW_COL'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>'P2514_JET_CHART_TYPE'
,p_display_when2=>'range:stock'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the numeric column to be used for the high value on the chart.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5014931642617781)
,p_name=>'P2505_OPEN_COL'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(274365359927234493)
,p_prompt=>'Opening Value Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 d, c002 r',
'  from wwv_flow_collections',
' where collection_name  = ''WIZ_COLUMNS_LIST''',
'   and c003 = ''NUMBER''',
'   and c002 not in (:P2505_LOW_COL,:P2505_HIGH_COL)',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P2505_LOW_COL,P2505_HIGH_COL'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>'P2514_JET_CHART_TYPE'
,p_display_when2=>'stock'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the numeric column to be used for the opening value on the chart.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5015812971617782)
,p_name=>'P2505_CLOSE_COL'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(274365359927234493)
,p_prompt=>'Closing Value Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 d, c002 r',
'  from wwv_flow_collections',
' where collection_name  = ''WIZ_COLUMNS_LIST''',
'   and c003 = ''NUMBER''',
'   and c002 not in (:P2505_LOW_COL,:P2505_HIGH_COL,:P2505_OPEN_COL)',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P2505_LOW_COL,P2505_HIGH_COL,P2505_OPEN_COL'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>'P2514_JET_CHART_TYPE'
,p_display_when2=>'stock'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the numeric column to be used for the closing value on the chart.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5016778969617784)
,p_name=>'P2505_VOLUME_COL'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(274365359927234493)
,p_prompt=>'Volume Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 d, c002 r',
'  from wwv_flow_collections',
' where collection_name = ''WIZ_COLUMNS_LIST''',
'   and c003 = ''NUMBER''',
'   and c002 not in (:P2505_LOW_COL,:P2505_HIGH_COL,:P2505_OPEN_COL)',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P2505_LOW_COL,P2505_HIGH_COL,P2505_OPEN_COL'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>'P2514_JET_CHART_TYPE'
,p_display_when2=>'stock'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the numeric column to be used for the volume value on the chart. When values are provided, the volume is displayed on the y2 axis.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5017654017617785)
,p_name=>'P2505_X_COL'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_imp.id(274365359927234493)
,p_prompt=>'X Value Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 d, c002 r',
'  from wwv_flow_collections',
' where collection_name = ''WIZ_COLUMNS_LIST''',
'   and c003 in (''VARCHAR2'',''NUMBER'',''DATE'',''TIMESTAMP'',''TIMESTAMP_TZ'',''TIMESTAMP_LTZ'')',
' order by 1'))
,p_cHeight=>1
,p_display_when=>'P2514_JET_CHART_TYPE'
,p_display_when2=>'bubble:scatter'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the column to be used for the low value on the chart.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5018567177617785)
,p_name=>'P2505_Y_COL'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_imp.id(274365359927234493)
,p_prompt=>'Y Value Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 d, c002 r',
'  from wwv_flow_collections',
' where collection_name  = ''WIZ_COLUMNS_LIST''',
'   and c003 = ''NUMBER''',
'   and c002 not in (:P2505_X_COL)',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P2505_X_COL'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>'P2514_JET_CHART_TYPE'
,p_display_when2=>'bubble:scatter'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the numeric column to be used for the y value on the chart.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5019454275617786)
,p_name=>'P2505_Z_COL'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_imp.id(274365359927234493)
,p_prompt=>'Z Value Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 d, c002 r',
'  from wwv_flow_collections',
' where collection_name = ''WIZ_COLUMNS_LIST''',
'   and c003 = ''NUMBER''',
'   and c002 not in (:P2505_X_COL,:P2505_Y_COL)',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_lov_cascade_parent_items=>'P2505_X_COL,P2505_Y_COL'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>'P2514_JET_CHART_TYPE'
,p_display_when2=>'bubble:bar:range:polar:boxPlot'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the numeric column to be used for the z value on the chart. The z value defines the bubble radius for a bubble chart, and the bar width for a bar or combination chart, or a box plot item.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5020346087617786)
,p_name=>'P2505_START_DATE_COL'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_imp.id(274365359927234493)
,p_prompt=>'Start Date Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 d, c002 r',
'  from wwv_flow_collections',
' where collection_name = ''WIZ_COLUMNS_LIST''',
'   and c003 in ( ''DATE'', ''TIMESTAMP'', ''TIMESTAMP_TZ'', ''TIMESTAMP_LTZ'' )',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_display_when=>'P2514_JET_CHART_TYPE'
,p_display_when2=>'GANTT'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the column name to be used for defining the start date for the gantt chart. A start date is required in order to render the chart successfully.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5021213543617787)
,p_name=>'P2505_END_DATE_COL'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_imp.id(274365359927234493)
,p_prompt=>'End Date Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 d, c002 r',
'  from wwv_flow_collections',
' where collection_name  = ''WIZ_COLUMNS_LIST''',
'   and c003 in ( ''DATE'', ''TIMESTAMP'', ''TIMESTAMP_TZ'', ''TIMESTAMP_LTZ'' )',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_display_when=>'P2514_JET_CHART_TYPE'
,p_display_when2=>'GANTT'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the column name to be used for defining the end date for the gantt chart. An end date is required in order to render the chart successfully.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5022132672617787)
,p_name=>'P2505_TASK_ID'
,p_item_sequence=>260
,p_item_plug_id=>wwv_flow_imp.id(274365359927234493)
,p_prompt=>'Task ID Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 d, c002 r',
'  from wwv_flow_collections',
' where collection_name  = ''WIZ_COLUMNS_LIST''',
'   and c003 in ( ''VARCHAR2'', ''NUMBER'' )',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_display_when=>'P2514_JET_CHART_TYPE'
,p_display_when2=>'GANTT'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the column name to be used for defining the unique task ID, associated with each task entry that you wish to render on the gantt chart.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5023094275617788)
,p_name=>'P2505_TASK_NAME'
,p_item_sequence=>270
,p_item_plug_id=>wwv_flow_imp.id(274365359927234493)
,p_prompt=>'Task Name Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 d, c002 r',
'  from wwv_flow_collections',
' where collection_name  = ''WIZ_COLUMNS_LIST''',
'   and c003 = ''VARCHAR2''',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_display_when=>'P2514_JET_CHART_TYPE'
,p_display_when2=>'GANTT'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the column name to be used for defining the task name, associated with each task entry that you wish to render on the gantt chart.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5023963380617789)
,p_name=>'P2505_TASK_START_DATE'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_imp.id(274365359927234493)
,p_prompt=>'Task Start Date Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 d, c002 r',
'  from wwv_flow_collections',
' where collection_name  = ''WIZ_COLUMNS_LIST''',
'   and c003 in ( ''DATE'', ''TIMESTAMP'', ''TIMESTAMP_TZ'', ''TIMESTAMP_LTZ'' )',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_display_when=>'P2514_JET_CHART_TYPE'
,p_display_when2=>'GANTT'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the column name to be used for defining the task start date for the gantt chart.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5024824452617789)
,p_name=>'P2505_TASK_END_DATE'
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_imp.id(274365359927234493)
,p_prompt=>'Task End Date Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 d, c002 r',
'  from wwv_flow_collections',
' where collection_name  = ''WIZ_COLUMNS_LIST''',
'   and c003 in (''DATE'', ''TIMESTAMP'', ''TIMESTAMP_TZ'', ''TIMESTAMP_LTZ'')',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_display_when=>'P2514_JET_CHART_TYPE'
,p_display_when2=>'GANTT'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the column name to be used for defining the task end date for the gantt chart.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5501261702609212)
,p_name=>'P2505_MAX_ROWS'
,p_item_sequence=>500
,p_item_plug_id=>wwv_flow_imp.id(274365359927234493)
,p_prompt=>'Maximum Rows'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>4
,p_cMaxlength=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the maximum number of rows you want to use to display the chart.'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5500394716609203)
,p_validation_name=>'P2505_LABEL_COL is not null'
,p_validation_sequence=>10
,p_validation=>'P2505_LABEL_COL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'You must select a Label Column'
,p_validation_condition=>':P2514_JET_CHART_TYPE not in (''dial'',''GANTT'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(4801074006449876)
,p_associated_item=>wwv_flow_imp.id(5007746666617771)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5500473616609204)
,p_validation_name=>'Validate Value'
,p_validation_sequence=>20
,p_validation=>':P2505_VALUE_COL is not null or :P2505_AGGREGATE_FUNCTION is not null'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'You must select a Value Column.'
,p_validation_condition=>':P2514_JET_CHART_TYPE in (''area'',''bar'',''combo'',''dial'',''funnel'',''line'',''lineWithArea'',''pie'',''donut'',''radar'',''polar'',''pyramid'',''boxPlot'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(4801074006449876)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5801940262086775)
,p_validation_name=>'Validate Aggregation'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_data_type wwv_flow_global.t_dbms_id;',
'begin ',
'    for c1 in ( select c003 dataType',
'                  from wwv_flow_collections',
'                 where collection_name  = ''WIZ_COLUMNS_LIST''',
'                   and c003 in  ( ''VARCHAR2'', ''NUMBER'', ''DATE'', ''TIMESTAMP'', ''TIMESTAMP_TZ'', ''TIMESTAMP_LTZ'' )',
'                   and c002 = :P2505_LABEL_COL )',
'    loop',
'        l_data_type := c1.dataType;',
'    end loop;',
'',
'    -- SUM & AVG should only be applied to NUMBER',
'    if :P2505_AGGREGATE_FUNCTION in (''SUM'',''AVG'') then ',
'        return false;',
'    -- MEDIAN should not be applied to VARCHAR2    ',
'    elsif :P2505_AGGREGATE_FUNCTION = ''MEDIAN'' then ',
'        if l_data_type = ''VARCHAR2'' then',
'            return false;',
'        end if;',
'    -- All other aggregates require Value to be selected regardless of Label Datatype    ',
'    elsif :P2505_AGGREGATE_FUNCTION in (''MIN'',''MAX'',''COUNT_DISTINCT'',''APPROX_COUNT_DISTINCT'') then',
'        return false;',
'    elsif :P2505_AGGREGATE_FUNCTION = ''COUNT'' then ',
'        return true;',
'    end if;    ',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'You must select a Value Column for the chosen aggregation'
,p_validation_condition=>':P2505_AGGREGATE_FUNCTION is not null and :P2505_LABEL_COL is not null and :P2505_VALUE_COL is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(4801074006449876)
,p_associated_item=>wwv_flow_imp.id(5009542776617777)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5500529102609205)
,p_name=>'Visibility of Value Column'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2505_AGGREGATE_FUNCTION'
,p_condition_element=>'P2505_AGGREGATE_FUNCTION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'COUNT'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5500644672609206)
,p_event_id=>wwv_flow_imp.id(5500529102609205)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2505_VALUE_COL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5500787431609207)
,p_event_id=>wwv_flow_imp.id(5500529102609205)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2505_VALUE_COL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5501474641609214)
,p_event_id=>wwv_flow_imp.id(5500529102609205)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2505_VALUE_COL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5500986134609209)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(4800613213449874)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5501091620609210)
,p_event_id=>wwv_flow_imp.id(5500986134609209)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4228137894627079)
,p_name=>'Validation Error - Scroll to Top'
,p_event_sequence=>30
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4228516991627079)
,p_event_id=>wwv_flow_imp.id(4228137894627079)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.message.setThemeHooks( { pageErrorsContainerSelector: ".a-Alert--horizontal" } );'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5501131701609211)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Chart'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_series_type  varchar2(10);    ',
'begin',
'      -- Series Type',
'    l_series_type := case :P2514_JET_CHART_TYPE',
'                         when ''range'' then ''barRange''',
'                         when ''stock'' then ''stock''',
'                         when ''combo'' then ''bar''',
'                         when ''polar'' then ''bar''',
'                         when ''radar'' then ''line''',
'                         when ''GANTT'' then ''gantt''',
'                         else :P2514_JET_CHART_TYPE',
'                     end;',
'  ',
'    wwv_flow_wizard_api.create_jet_chart (',
'      p_flow_id                  => :FB_FLOW_ID,',
'      p_page_id                  => :P2501_PAGE_ID,',
'      p_page_name                => :P2501_PAGE_NAME,',
'      p_page_mode                => :P2501_PAGE_MODE,',
'      p_region_template          => wwv_flow_theme_dev.get_region_template_id (',
'                                        p_application_id => :FB_FLOW_ID,',
'                                        p_theme_id       => :FB_THEME_ID,',
'                                        p_page_type      => ''CHART''),',
'      p_region_name              => :P2501_PAGE_NAME,',
'      --',
'      p_nav_list_id              => :P2500_NAVLIST_ID,',
'      p_nav_list_parent_item_id  => :P2501_NAVLIST_PARENT_ID,',
'      p_nav_list_child_item_name => case when :P2501_NAVLIST_OPTIONS = ''NEW'' then :P2501_PAGE_NAME end,',
'      p_nav_list_item_icon       => :P2501_PAGE_ICON,      ',
'      --',
'      p_breadcrumb_id            => :P2501_BREADCRUMB_ID,',
'      p_breadcrumb_name          => :P2501_PAGE_NAME,',
'      p_parent_bc_id             => :P2501_BREADCRUMB_PARENT_ID,',
'      --',
'      p_sql                      => :P2501_SQL_SOURCE,',
'      p_location                 => :P2501_LOCATION,',
'      p_query_type               => :P2501_QUERY_TYPE,',
'      p_remote_server_id         => :P2501_REMOTE_SERVER_ID,',
'      p_web_src_module_id        => :P2501_WEB_SRC_MODULE_ID,',
'      p_table_owner              => :P2501_TAB_OWNER,',
'      p_table_name               => :P2501_TAB_NAME,',
'      p_chart_type               => case :P2514_JET_CHART_TYPE when ''GANTT'' then ''gantt'' else :P2514_JET_CHART_TYPE end,',
'      p_series_type              => l_series_type,',
'      p_max_row_count            => :P2505_MAX_ROWS,  ',
'      --',
'      p_items_value_column_name    => :P2505_VALUE_COL,',
'      p_items_low_column_name      => :P2505_LOW_COL,',
'      p_items_high_column_name     => :P2505_HIGH_COL,',
'      p_items_open_column_name     => :P2505_OPEN_COL,',
'      p_items_close_column_name    => :P2505_CLOSE_COL,   ',
'      p_items_x_column_name        => :P2505_X_COL,',
'      p_items_y_column_name        => :P2505_Y_COL,',
'      p_items_z_column_name        => :P2505_Z_COL,',
'      p_items_target_value         => :P2505_TARGET_COL,',
'      p_items_max_value            => :P2505_MAX_VAL_COL,',
'      p_group_short_desc_column_name     => :P2505_LABEL_COL,',
'      p_items_label_column_name    => :P2505_LABEL_COL,',
'      p_aggregate_function         => :P2505_AGGREGATE_FUNCTION,',
'      -- ',
'      p_orientation                => :P2505_ORIENTATION,',
'      --p_stack                      => (case when :P2505_STACK_CHART = ''Y'' then ''on'' else ''off'' end),',
'      --p_spark_chart                => :P2505_SPARK_CHART,',
'      p_show_tooltip               => ''Y'',',
'      p_show_legend                => case when :P2514_JET_CHART_TYPE in (''pie'',''donut'') then ''auto'' else ''none'' end,  -- Pre 18.2 - 19.1 was remove; for consistency with Create App wiz, display for Pie & Donut',
'      --',
'      p_gantt_start_date_column    => :P2505_START_DATE_COL,',
'      p_gantt_end_date_column      => :P2505_END_DATE_COL,  ',
'      p_gantt_task_id              => :P2505_TASK_ID,  ',
'      p_gantt_task_name            => :P2505_TASK_NAME,',
'      p_gantt_task_start_date      => :P2505_TASK_START_DATE,',
'      p_gantt_task_end_date        => :P2505_TASK_END_DATE,',
'      --',
'      p_gauge_orientation          => :P2505_GAUGE_ORIENTATION );',
'      ',
'    :FB_FLOW_PAGE_ID       := :P2501_PAGE_ID;',
'    :F4000_RUN_EDIT_PAGE   := :P2501_PAGE_ID;    ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to create the &P2500_PAGE_TYPE_DISPLAY. page. #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(4801074006449876)
,p_internal_uid=>5501131701609211
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5900904590408337)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,REQUEST'
,p_attribute_02=>'N'
,p_process_error_message=>'Error creating &P2500_PAGE_TYPE_DISPLAY. page.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(4801074006449876)
,p_process_success_message=>'&P2500_PAGE_TYPE_DISPLAY. page created.'
,p_internal_uid=>5900904590408337
);
end;
/
prompt --application/pages/page_02506
begin
wwv_flow_imp_page.create_page(
 p_id=>2506
,p_name=>'Create Page Wizard - Map Attributes'
,p_alias=>'CREATE-PAGE-MAP-ATTRIBUTES'
,p_page_mode=>'MODAL'
,p_step_title=>'Create &P2500_PAGE_TYPE_DISPLAY.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(103848364625132731)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_css_classes=>'a-Dialog--CreatePageDialog'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_rpt.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3063654112256537)
,p_plug_name=>'Map Style'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3064115804256542)
,p_plug_name=>'Help'
,p_region_template_options=>'#DEFAULT#:js-dialog-size480x320'
,p_plug_template=>wwv_flow_imp.id(557449278618308550)
,p_plug_display_sequence=>30
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Type of the spatial geometry layer to show on the map:',
'</p>',
'<ul>',
'    <li><strong>Points</strong>: Points (e.g. customer or supplier locations) are displayed as markers. The marker shape and color is configurable.</li>',
'    <li><strong>Lines</strong>: Lines represent features like roads or paths. Stroke style and color is configurable.</li>',
'    <li><strong>Polygons</strong>: Polygons represent areas like parcels, states or countries. Style and collor are configurable for stroke and fill.</li>',
'    <li><strong>Heat Map</strong>: Heat Maps are used to visualize the density of point features. The more points are clustered together, the more intense the color gets. Typically used to visualize the spatial distribution of population or incidents'
||'.</li>',
'    <li><strong>Extruded Polygons</strong>: Similar to Polygons, but the polygons are displayed as three-dimensional, "extruded", objects. The height of the 3D object visualizes a column value.</li>',
'</ul>',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(66132867139163128)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(114602869894458979)
,p_plug_name=>'Map Attributes'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7201280972307236)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(66132867139163128)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3064229261256543)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(3063654112256537)
,p_button_name=>'HELP'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Help'
,p_button_position=>'EDIT'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'icon-help'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7201600601307238)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(66132867139163128)
,p_button_name=>'CREATE'
,p_button_static_id=>'create_page_button'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Page'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7202025472307238)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(66132867139163128)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:2501:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7202756662307250)
,p_name=>'P2506_LAYER_TYPE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3063654112256537)
,p_item_default=>'POINT'
,p_prompt=>'Layer Type'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'MAP_REGION_LAYER_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(2204527800561582)||'.'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-IconList--CreatePageDialog margin-bottom-none'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_attribute_01=>'S'
,p_attribute_02=>'N'
,p_item_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Type of the spatial geometry layer to show on the map:',
'</p>',
'<ul>',
'    <li><strong>Points</strong>: Points (e.g. customer or supplier locations) are displayed as markers. The marker shape and color is configurable.</li>',
'    <li><strong>Lines</strong>: Lines represent features like roads or paths. Stroke style and color is configurable.</li>',
'    <li><strong>Polygons</strong>: Polygons represent areas like parcels, states or countries. Style and collor are configurable for stroke and fill.</li>',
'    <li><strong>Heat Map</strong>: Heat Maps are used to visualize the density of point features. The more points are clustered together, the more intense the color gets. Typically used to visualize the spatial distribution of population or incidents'
||'.</li>',
'    <li><strong>Extruded Polygons</strong>: Similar to Polygons, but the polygons are displayed as three-dimensional, "extruded", objects. The height of the 3D object visualizes a column value.</li>',
'</ul>',
''))
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7203604265307256)
,p_name=>'P2506_GEOMETRY_COLUMN_TYPE'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(114602869894458979)
,p_item_default=>'GEOMETRY'
,p_prompt=>'Geometry Column Type'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'MAP_REGION_GEOMETRY_COLUMN_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(2214661182663976)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Spatial objects (geometries) to be displayed on the map can be sourced from a <strong>Geometry</strong> column or from two <strong>NUMBER</strong> columns, containing longitude and latitude values (<strong>Point</strong> and <strong>Heat Map</str'
||'ong> layers only). </p>',
'    <p> Geometry columns can be of the <strong>SDO_GEOMETRY</strong>, <strong>VARCHAR2</strong> or <strong>CLOB</strong> data types. VARCHAR2 and CLOB columns must contain geometry information in GeoJSON format.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7204576930307257)
,p_name=>'P2506_GEOM_COLUMN_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(114602869894458979)
,p_prompt=>'Geometry Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 d, c002 r',
'  from wwv_flow_collections',
' where collection_name = ''WIZ_COLUMNS_LIST''',
'   and c003 in (''CLOB'', ''VARCHAR2'', ''SDO_GEOMETRY'' )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Pick the spatial geometry column. This can either be a column of the Oracle SDO_GEOMETRY type, or a VARCHAR2 or CLOB column, containing GeoJSON data.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7205463613307259)
,p_name=>'P2506_LON_COLUMN_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(114602869894458979)
,p_prompt=>'Longitude Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 d, c002 r',
'  from wwv_flow_collections',
' where collection_name = ''WIZ_COLUMNS_LIST''',
'   and c003 = ''NUMBER'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Pick a numeric column containing longitude values. Column values should be between -180 and 180.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7206305826307259)
,p_name=>'P2506_LAT_COLUMN_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(114602869894458979)
,p_prompt=>'Latitude Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 d, c002 r',
'  from wwv_flow_collections',
' where collection_name = ''WIZ_COLUMNS_LIST''',
'   and c003 = ''NUMBER'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Pick a numeric column containing latitude values. Column values should be between -90 and 90.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7207245364307260)
,p_name=>'P2506_3D_VALUE_COLUMN_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(114602869894458979)
,p_prompt=>'3D Height Value Column'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_col_1 as title',
'  from wwv_dictionary_cache_obj',
' where object_owner      = :P2501_TAB_OWNER',
'   and object_name       = :P2501_TAB_NAME',
'   and security_group_id = :WORKSPACE_ID',
'   and :P2501_LOCATION   = ''LOCAL'''))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 d, c002 r',
'  from wwv_flow_collections',
' where collection_name = ''WIZ_COLUMNS_LIST''',
'   and c003 = ''NUMBER''',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Pick the column containing the value to determine the polygon height. The map will visualize the height in <em>meters</em>; the unit can be changed in Page Designer.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7208169484307261)
,p_name=>'P2506_VALUE_COLUMN_NAME'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(114602869894458979)
,p_prompt=>'Color Value Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 d, c002 r',
'  from wwv_flow_collections',
' where collection_name = ''WIZ_COLUMNS_LIST''',
'   and c003 = ''NUMBER'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'If chosen, then spatial geometries on the map will be colored based on the value of this column.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7209074437307262)
,p_name=>'P2506_HEAT_VALUE_COLUMN_NAME'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(114602869894458979)
,p_prompt=>'Color Value Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 d, c002 r',
'  from wwv_flow_collections',
' where collection_name = ''WIZ_COLUMNS_LIST''',
'   and c003 = ''NUMBER'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'If chosen, then spatial geometries on the map will be colored based on the value of this column.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7209943513307263)
,p_name=>'P2506_TOOLTIP_COLUMN_NAME'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(114602869894458979)
,p_prompt=>'Tooltip Column'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_col_1 as title',
'  from wwv_dictionary_cache_obj',
' where object_owner      = :P2501_TAB_OWNER',
'   and object_name       = :P2501_TAB_NAME',
'   and security_group_id = :WORKSPACE_ID',
'   and :P2501_LOCATION   = ''LOCAL'''))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 d, c002 r',
'  from wwv_flow_collections',
' where collection_name = ''WIZ_COLUMNS_LIST''',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Pick the column containing the <strong>Tooltip</strong> value, to be displayed when hovering over a spatial geometry on the map.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7210865971307264)
,p_name=>'P2506_FACETED_SEARCH'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(114602869894458979)
,p_item_default=>'N'
,p_prompt=>'Create Faceted Search Page'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Whether to create the map page as a Faceted Search page. The <strong>Faceted Search</strong> region will contain only a <strong>Search</strong> facet, other facets can be added in Page Designer.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(6972945265210007)
,p_computation_sequence=>10
,p_computation_item=>'P2506_LAYER_TYPE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case geometry_type',
'           when ''UNKNOWN'' then ''POINT''',
'       else geometry_type end',
'  from wwv_dictionary_cache_obj',
' where object_owner      = :P2501_TAB_OWNER',
'   and object_name       = :P2501_TAB_NAME',
'   and security_group_id = :WORKSPACE_ID',
'   and :P2501_LOCATION   = ''LOCAL'';'))
,p_compute_when=>':P2506_LAYER_TYPE is null and :P2501_LOCATION = ''LOCAL'' and :P2501_QUERY_TYPE = ''TABLE'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(7212160739307290)
,p_validation_name=>'Geometry Column NOT NULL'
,p_validation_sequence=>10
,p_validation=>'P2506_GEOM_COLUMN_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>'P2506_GEOMETRY_COLUMN_TYPE'
,p_validation_condition2=>'GEOMETRY'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(7201600601307238)
,p_associated_item=>wwv_flow_imp.id(7204576930307257)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(7212542303307290)
,p_validation_name=>'Longitude Column NOT NULL'
,p_validation_sequence=>20
,p_validation=>'P2506_LON_COLUMN_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>'P2506_GEOMETRY_COLUMN_TYPE'
,p_validation_condition2=>'NUMBER'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(7201600601307238)
,p_associated_item=>wwv_flow_imp.id(7205463613307259)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(7212963086307291)
,p_validation_name=>'Latitude Column NOT NULL'
,p_validation_sequence=>30
,p_validation=>'P2506_LAT_COLUMN_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>'P2506_GEOMETRY_COLUMN_TYPE'
,p_validation_condition2=>'NUMBER'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(7201600601307238)
,p_associated_item=>wwv_flow_imp.id(7206305826307259)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(7213344742307291)
,p_validation_name=>'3D Value Column NOT NULL'
,p_validation_sequence=>50
,p_validation=>'P2506_3D_VALUE_COLUMN_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>'P2506_LAYER_TYPE'
,p_validation_condition2=>'POLYGON_3D'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(7201600601307238)
,p_associated_item=>wwv_flow_imp.id(7207245364307260)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(7214895120307297)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(7201280972307236)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7215344759307299)
,p_event_id=>wwv_flow_imp.id(7214895120307297)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(7215716293307299)
,p_name=>'Line Layer'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2506_LAYER_TYPE'
,p_condition_element=>'P2506_LAYER_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'LINE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7216243583307300)
,p_event_id=>wwv_flow_imp.id(7215716293307299)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2506_GEOMETRY_COLUMN_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'GEOMETRY'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7216784034307300)
,p_event_id=>wwv_flow_imp.id(7215716293307299)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2506_GEOMETRY_COLUMN_TYPE,P2506_3D_VALUE_COLUMN_NAME,P2506_HEAT_VALUE_COLUMN_NAME,P2506_VALUE_COLUMN_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7217283889307300)
,p_event_id=>wwv_flow_imp.id(7215716293307299)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2506_TOOLTIP_COLUMN_NAME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(7217649378307301)
,p_name=>'Polygon Layer'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2506_LAYER_TYPE'
,p_condition_element=>'P2506_LAYER_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'POLYGON'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7218143736307301)
,p_event_id=>wwv_flow_imp.id(7217649378307301)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2506_GEOMETRY_COLUMN_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'GEOMETRY'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7218663815307302)
,p_event_id=>wwv_flow_imp.id(7217649378307301)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2506_GEOMETRY_COLUMN_TYPE,P2506_3D_VALUE_COLUMN_NAME,P2506_HEAT_VALUE_COLUMN_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7219147683307302)
,p_event_id=>wwv_flow_imp.id(7217649378307301)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2506_VALUE_COLUMN_NAME,P2506_TOOLTIP_COLUMN_NAME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(7219590826307302)
,p_name=>'3D Polygon Layer'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2506_LAYER_TYPE'
,p_condition_element=>'P2506_LAYER_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'POLYGON_3D'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7220055503307302)
,p_event_id=>wwv_flow_imp.id(7219590826307302)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2506_GEOMETRY_COLUMN_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'GEOMETRY'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7220505440307303)
,p_event_id=>wwv_flow_imp.id(7219590826307302)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2506_GEOMETRY_COLUMN_TYPE,P2506_HEAT_VALUE_COLUMN_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7221004456307303)
,p_event_id=>wwv_flow_imp.id(7219590826307302)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2506_3D_VALUE_COLUMN_NAME,P2506_VALUE_COLUMN_NAME,P2506_TOOLTIP_COLUMN_NAME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(7221497389307303)
,p_name=>'Point Layer'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2506_LAYER_TYPE'
,p_condition_element=>'P2506_LAYER_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'POINT'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7221934067307304)
,p_event_id=>wwv_flow_imp.id(7221497389307303)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2506_GEOMETRY_COLUMN_TYPE,P2506_TOOLTIP_COLUMN_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7222476840307306)
,p_event_id=>wwv_flow_imp.id(7221497389307303)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2506_3D_VALUE_COLUMN_NAME,P2506_HEAT_VALUE_COLUMN_NAME,P2506_VALUE_COLUMN_NAME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(7222800769307306)
,p_name=>'Heatmap Layer'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2506_LAYER_TYPE'
,p_condition_element=>'P2506_LAYER_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'HEATMAP'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7223391846307307)
,p_event_id=>wwv_flow_imp.id(7222800769307306)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2506_GEOMETRY_COLUMN_TYPE,P2506_HEAT_VALUE_COLUMN_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7223880577307307)
,p_event_id=>wwv_flow_imp.id(7222800769307306)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2506_3D_VALUE_COLUMN_NAME,P2506_VALUE_COLUMN_NAME,P2506_TOOLTIP_COLUMN_NAME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(7224248332307307)
,p_name=>'Geometry Column Type'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2506_GEOMETRY_COLUMN_TYPE'
,p_condition_element=>'P2506_GEOMETRY_COLUMN_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'GEOMETRY'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7224787173307307)
,p_event_id=>wwv_flow_imp.id(7224248332307307)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2506_GEOM_COLUMN_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7225219287307308)
,p_event_id=>wwv_flow_imp.id(7224248332307307)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2506_LON_COLUMN_NAME,P2506_LAT_COLUMN_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7225783079307309)
,p_event_id=>wwv_flow_imp.id(7224248332307307)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2506_LON_COLUMN_NAME,P2506_LAT_COLUMN_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7226253974307309)
,p_event_id=>wwv_flow_imp.id(7224248332307307)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2506_GEOM_COLUMN_NAME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3064389602256544)
,p_name=>'Show Help Dialog'
,p_event_sequence=>90
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3064229261256543)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3064475797256545)
,p_event_id=>wwv_flow_imp.id(3064389602256544)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3064115804256542)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6973058456210008)
,p_name=>'Validation Error - Scroll to Top'
,p_event_sequence=>100
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6973151203210009)
,p_event_id=>wwv_flow_imp.id(6973058456210008)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.message.setThemeHooks( { pageErrorsContainerSelector: ".a-Alert--horizontal" } );'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(7214494484307295)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Map Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_geom_col_type wwv_flow_map_region.t_feature_data_type;',
'begin',
'    if :P2506_GEOMETRY_COLUMN_TYPE = ''NUMBER'' then',
'        l_geom_col_type := wwv_flow_map_region.c_feature_number_columns;',
'    else',
'        l_geom_col_type := wwv_flow_map_region.c_feature_geojson;',
'',
'        for c in (',
'            select c003 ',
'              from wwv_flow_collections',
'             where collection_name = ''WIZ_COLUMNS_LIST''',
'               and c002            = :P2506_GEOM_COLUMN_NAME',
'               and c003            = ''SDO_GEOMETRY''',
'               and rownum          = 1         ',
'        ) loop',
'            l_geom_col_type := wwv_flow_map_region.c_feature_sdo_geometry;',
'        end loop;',
'    end if;',
'',
'    wwv_flow_map_region_dev.create_map_page(',
'        p_app_id                     => :FB_FLOW_ID,',
'        p_page_id                    => :P2501_PAGE_ID,',
'        p_page_name                  => :P2501_PAGE_NAME,',
'        p_page_mode                  => :P2501_PAGE_MODE,',
'        --',
'        p_nav_list_id                => :P2500_NAVLIST_ID,',
'        p_nav_list_parent_item_id    => :P2501_NAVLIST_PARENT_ID,',
'        p_nav_list_child_item_name   => case when :P2501_NAVLIST_OPTIONS = ''NEW'' then :P2501_PAGE_NAME end,',
'        p_nav_list_item_icon         => :P2501_PAGE_ICON,',
'        --',
'        p_breadcrumb_id              => :P2501_BREADCRUMB_ID,',
'        p_breadcrumb_entry_name      => :P2501_PAGE_NAME,',
'        p_parent_breadcrumb_entry_id => :P2501_BREADCRUMB_PARENT_ID,',
'        --',
'        p_location                   => :P2501_LOCATION,',
'        p_query_type                 => :P2501_QUERY_TYPE,',
'        p_table_owner                => :P2501_TAB_OWNER,',
'        p_table_name                 => :P2501_TAB_NAME,',
'        p_map_source                 => :P2501_SQL_SOURCE,',
'        --',
'        p_remote_server_id           => :P2501_REMOTE_SERVER_ID,',
'        p_web_source_module_id       => :P2501_WEB_SRC_MODULE_ID,',
'        --',
'        p_layer_name                 => :P2501_PAGE_NAME,',
'        p_layer_type                 => case :P2506_LAYER_TYPE',
'                                            when ''POINT''      then wwv_flow_map_region.c_map_layer_points',
'                                            when ''LINE''       then wwv_flow_map_region.c_map_layer_lines',
'                                            when ''POLYGON''    then wwv_flow_map_region.c_map_layer_polygons',
'                                            when ''HEATMAP''    then wwv_flow_map_region.c_map_layer_heat_map',
'                                            when ''POLYGON_3D'' then wwv_flow_map_region.c_map_layer_3d_polygons',
'                                        end,',
'        p_geometry_column_type       => l_geom_col_type,',
'        p_geometry_column            => :P2506_GEOM_COLUMN_NAME,',
'        p_longitude_column           => :P2506_LON_COLUMN_NAME,',
'        p_latitude_column            => :P2506_LAT_COLUMN_NAME,',
'        p_value_column               => case :P2506_LAYER_TYPE',
'                                            when ''HEATMAP'' then :P2506_HEAT_VALUE_COLUMN_NAME',
'                                            else                :P2506_VALUE_COLUMN_NAME',
'                                         end,',
'        p_extrude_value_column       => :P2506_3D_VALUE_COLUMN_NAME,',
'        p_tooltip_column             => :P2506_TOOLTIP_COLUMN_NAME,',
'        --',
'        p_faceted_search_page        => :P2506_FACETED_SEARCH = ''Y'' );',
'                ',
'    :FB_FLOW_PAGE_ID       := :P2501_PAGE_ID;',
'    :F4000_RUN_EDIT_PAGE   := :P2501_PAGE_ID;',
'end;',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to create the Map page. #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(7201600601307238)
,p_internal_uid=>7214494484307295
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(7214042577307295)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,REQUEST'
,p_attribute_02=>'N'
,p_process_error_message=>'Error creating &P2500_PAGE_TYPE_DISPLAY. page.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(7201600601307238)
,p_process_success_message=>'&P2500_PAGE_TYPE_DISPLAY. page created.'
,p_internal_uid=>7214042577307295
);
end;
/
prompt --application/pages/page_02507
begin
wwv_flow_imp_page.create_page(
 p_id=>2507
,p_name=>'Create Page Wizard - Form on Procedure'
,p_alias=>'CREATE-PAGE-FORM-ON-PROC'
,p_page_mode=>'MODAL'
,p_step_title=>'Create &P2500_PAGE_TYPE_DISPLAY.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(103848364625132731)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_css_classes=>'a-Dialog--CreatePageDialog'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_frm.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(10900568987980949)
,p_plug_name=>'Procedure'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_plug_source=>' '
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(50809876650933911)
,p_plug_name=>'Branch Pages'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P2501_PAGE_MODE'
,p_plug_display_when_cond2=>'NORMAL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(213400582154504176)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>102
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(283181239075910775)
,p_name=>'Select procedure arguments to be included in form:'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  q varchar2(32767);',
'begin',
'    q := ''select '';',
'    q :=q||''wwv_flow_item.select_list_from_lov(3,''''YES'''',''''YES_NO_RETURNS_YES_OR_NO'''',null,''''NO'''') include, '';',
'    q :=q||''wwv_flow_escape.html(x.argument_name) || '';',
'    q :=q||''wwv_flow_item.hidden(1,x.argument_name), ''; ',
'    q :=q||''wwv_flow_item.text(2,initcap(replace( ltrim(x.argument_name, ''''P_''''),''''_'''','''' ''''))) prompt, '';',
'    q :=q||''wwv_flow_item.text(4) def, '';',
'    q :=q||''wwv_flow_item.select_list_from_lov(5,''''NATIVE_TEXT_FIELD'''', '';',
'    q :=q||''''''FORM_ON_SP.ITEM_DISPLAY_TYPES'''',null,''''NO'''') typ '';',
'    q :=q||''from ( '';',
'    q :=q||''select '';',
'    q :=q||''argument_name, '';',
'    q :=q||''sequence '';',
'    q :=q||''from sys.dba_arguments '';',
'    q :=q||''where owner = :P2507_OWNER '';',
'    q :=q||''and argument_name is not null '';',
'    if instr(:P2507_PROCEDURE,''.'') > 0 then',
'      q := q||'' and object_name=substr(:P2507_PROCEDURE,instr(:P2507_PROCEDURE,''''.'''')+1)'';',
'      q := q||'' and package_name=substr(:P2507_PROCEDURE,1,instr(:P2507_PROCEDURE,''''.'''')-1)'';      ',
'   else',
'      q := q||'' and object_name = :P2507_PROCEDURE '';     ',
'      q := q||'' and package_name is null '';     ',
'   end if;',
'   q := q||'' order by sequence) x'';',
'  --end if;',
'  return q;',
'end;'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P2507_OWNER,P2507_PROCEDURE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_plug_query_max_columns=>60
,p_query_num_rows=>15
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>'- no procedure selected -'
,p_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10915437123976128)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>1
,p_column_heading=>'Include'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10915881894976129)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>2
,p_column_heading=>'Argument'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10916223056976129)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>3
,p_column_heading=>'Label'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10916688213976130)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>4
,p_column_heading=>'Default'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10917035339976131)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>5
,p_column_heading=>'Display Type'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10917469872976131)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>6
,p_column_heading=>'Display Type'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10917874531976132)
,p_query_column_id=>7
,p_column_alias=>'COL07'
,p_column_display_sequence=>7
,p_column_heading=>'Col07'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10918256594976132)
,p_query_column_id=>8
,p_column_alias=>'COL08'
,p_column_display_sequence=>8
,p_column_heading=>'Col08'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10918654410976133)
,p_query_column_id=>9
,p_column_alias=>'COL09'
,p_column_display_sequence=>9
,p_column_heading=>'Col09'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10919064820976134)
,p_query_column_id=>10
,p_column_alias=>'COL10'
,p_column_display_sequence=>10
,p_column_heading=>'Col10'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10919462160976134)
,p_query_column_id=>11
,p_column_alias=>'COL11'
,p_column_display_sequence=>11
,p_column_heading=>'Col11'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10919832120976135)
,p_query_column_id=>12
,p_column_alias=>'COL12'
,p_column_display_sequence=>12
,p_column_heading=>'Col12'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10920217124976136)
,p_query_column_id=>13
,p_column_alias=>'COL13'
,p_column_display_sequence=>13
,p_column_heading=>'Col13'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10920663365976137)
,p_query_column_id=>14
,p_column_alias=>'COL14'
,p_column_display_sequence=>14
,p_column_heading=>'Col14'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10921094836976137)
,p_query_column_id=>15
,p_column_alias=>'COL15'
,p_column_display_sequence=>15
,p_column_heading=>'Col15'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10921486781976138)
,p_query_column_id=>16
,p_column_alias=>'COL16'
,p_column_display_sequence=>16
,p_column_heading=>'Col16'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10921880592976138)
,p_query_column_id=>17
,p_column_alias=>'COL17'
,p_column_display_sequence=>17
,p_column_heading=>'Col17'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10922205720976139)
,p_query_column_id=>18
,p_column_alias=>'COL18'
,p_column_display_sequence=>18
,p_column_heading=>'Col18'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10922653663976140)
,p_query_column_id=>19
,p_column_alias=>'COL19'
,p_column_display_sequence=>19
,p_column_heading=>'Col19'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10923001637976140)
,p_query_column_id=>20
,p_column_alias=>'COL20'
,p_column_display_sequence=>20
,p_column_heading=>'Col20'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10923495332976141)
,p_query_column_id=>21
,p_column_alias=>'COL21'
,p_column_display_sequence=>21
,p_column_heading=>'Col21'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10923874494976142)
,p_query_column_id=>22
,p_column_alias=>'COL22'
,p_column_display_sequence=>22
,p_column_heading=>'Col22'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10924205331976143)
,p_query_column_id=>23
,p_column_alias=>'COL23'
,p_column_display_sequence=>23
,p_column_heading=>'Col23'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10924659557976143)
,p_query_column_id=>24
,p_column_alias=>'COL24'
,p_column_display_sequence=>24
,p_column_heading=>'Col24'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10925052066976144)
,p_query_column_id=>25
,p_column_alias=>'COL25'
,p_column_display_sequence=>25
,p_column_heading=>'Col25'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10925415368976145)
,p_query_column_id=>26
,p_column_alias=>'COL26'
,p_column_display_sequence=>26
,p_column_heading=>'Col26'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10925881086976146)
,p_query_column_id=>27
,p_column_alias=>'COL27'
,p_column_display_sequence=>27
,p_column_heading=>'Col27'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10926201505976147)
,p_query_column_id=>28
,p_column_alias=>'COL28'
,p_column_display_sequence=>28
,p_column_heading=>'Col28'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10926671358976148)
,p_query_column_id=>29
,p_column_alias=>'COL29'
,p_column_display_sequence=>29
,p_column_heading=>'Col29'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10927027495976150)
,p_query_column_id=>30
,p_column_alias=>'COL30'
,p_column_display_sequence=>30
,p_column_heading=>'Col30'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10927406573976152)
,p_query_column_id=>31
,p_column_alias=>'COL31'
,p_column_display_sequence=>31
,p_column_heading=>'Col31'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10927879885976153)
,p_query_column_id=>32
,p_column_alias=>'COL32'
,p_column_display_sequence=>32
,p_column_heading=>'Col32'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10928277057976155)
,p_query_column_id=>33
,p_column_alias=>'COL33'
,p_column_display_sequence=>33
,p_column_heading=>'Col33'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10928602308976157)
,p_query_column_id=>34
,p_column_alias=>'COL34'
,p_column_display_sequence=>34
,p_column_heading=>'Col34'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10905101623976110)
,p_query_column_id=>35
,p_column_alias=>'COL35'
,p_column_display_sequence=>35
,p_column_heading=>'Col35'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10905508244976113)
,p_query_column_id=>36
,p_column_alias=>'COL36'
,p_column_display_sequence=>36
,p_column_heading=>'Col36'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10905986215976113)
,p_query_column_id=>37
,p_column_alias=>'COL37'
,p_column_display_sequence=>37
,p_column_heading=>'Col37'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10906385952976114)
,p_query_column_id=>38
,p_column_alias=>'COL38'
,p_column_display_sequence=>38
,p_column_heading=>'Col38'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10906615618976115)
,p_query_column_id=>39
,p_column_alias=>'COL39'
,p_column_display_sequence=>39
,p_column_heading=>'Col39'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10907028308976115)
,p_query_column_id=>40
,p_column_alias=>'COL40'
,p_column_display_sequence=>40
,p_column_heading=>'Col40'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10907455700976116)
,p_query_column_id=>41
,p_column_alias=>'COL41'
,p_column_display_sequence=>41
,p_column_heading=>'Col41'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10907813434976116)
,p_query_column_id=>42
,p_column_alias=>'COL42'
,p_column_display_sequence=>42
,p_column_heading=>'Col42'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10908214574976117)
,p_query_column_id=>43
,p_column_alias=>'COL43'
,p_column_display_sequence=>43
,p_column_heading=>'Col43'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10908690688976117)
,p_query_column_id=>44
,p_column_alias=>'COL44'
,p_column_display_sequence=>44
,p_column_heading=>'Col44'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10909026926976118)
,p_query_column_id=>45
,p_column_alias=>'COL45'
,p_column_display_sequence=>45
,p_column_heading=>'Col45'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10909498969976119)
,p_query_column_id=>46
,p_column_alias=>'COL46'
,p_column_display_sequence=>46
,p_column_heading=>'Col46'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10909839520976119)
,p_query_column_id=>47
,p_column_alias=>'COL47'
,p_column_display_sequence=>47
,p_column_heading=>'Col47'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10910285192976120)
,p_query_column_id=>48
,p_column_alias=>'COL48'
,p_column_display_sequence=>48
,p_column_heading=>'Col48'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10910623166976121)
,p_query_column_id=>49
,p_column_alias=>'COL49'
,p_column_display_sequence=>49
,p_column_heading=>'Col49'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10911003304976121)
,p_query_column_id=>50
,p_column_alias=>'COL50'
,p_column_display_sequence=>50
,p_column_heading=>'Col50'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10911429294976122)
,p_query_column_id=>51
,p_column_alias=>'COL51'
,p_column_display_sequence=>51
,p_column_heading=>'Col51'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10911880585976123)
,p_query_column_id=>52
,p_column_alias=>'COL52'
,p_column_display_sequence=>52
,p_column_heading=>'Col52'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10912210217976124)
,p_query_column_id=>53
,p_column_alias=>'COL53'
,p_column_display_sequence=>53
,p_column_heading=>'Col53'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10912607270976124)
,p_query_column_id=>54
,p_column_alias=>'COL54'
,p_column_display_sequence=>54
,p_column_heading=>'Col54'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10913021016976125)
,p_query_column_id=>55
,p_column_alias=>'COL55'
,p_column_display_sequence=>55
,p_column_heading=>'Col55'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10913407095976125)
,p_query_column_id=>56
,p_column_alias=>'COL56'
,p_column_display_sequence=>56
,p_column_heading=>'Col56'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10913898290976126)
,p_query_column_id=>57
,p_column_alias=>'COL57'
,p_column_display_sequence=>57
,p_column_heading=>'Col57'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10914233147976127)
,p_query_column_id=>58
,p_column_alias=>'COL58'
,p_column_display_sequence=>58
,p_column_heading=>'Col58'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10914689985976127)
,p_query_column_id=>59
,p_column_alias=>'COL59'
,p_column_display_sequence=>59
,p_column_heading=>'Col59'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(10915047452976128)
,p_query_column_id=>60
,p_column_alias=>'COL60'
,p_column_display_sequence=>60
,p_column_heading=>'Col60'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(10903683845976101)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(213400582154504176)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(10904021228976104)
,p_button_sequence=>15
,p_button_plug_id=>wwv_flow_imp.id(213400582154504176)
,p_button_name=>'CREATE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Page'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(10904468893976105)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_imp.id(213400582154504176)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:2501:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10901163486976086)
,p_name=>'P2507_OWNER'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(10900568987980949)
,p_item_default=>'wwv_flow_security.flow_owner( p_flow_id => :FB_FLOW_ID, p_security_group_id => :WORKSPACE_ID )'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Procedure Owner'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_SCHEMAS_HAVE_PRIVS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(owner) d, owner v',
'  from wwv_flow_object_owners_dev',
'order by d                   '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Schema -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the owner of procedure you are creating the form on.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10902049747976092)
,p_name=>'P2507_PROCEDURE'
,p_item_sequence=>11
,p_item_plug_id=>wwv_flow_imp.id(10900568987980949)
,p_prompt=>'Stored Procedure Name'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with',
'    l_pkg_functions as (',
'      select a.package_name||''.''||a.object_name object_name',
'        from sys.dba_arguments a',
'       where a.package_name is not null',
'         and a.argument_name is null',
'         and a.owner = :P2507_OWNER ),',
'    l_arguments as (',
'      select distinct',
'             decode(a.package_name, null, null, a.package_name||''.'')||a.object_name object_name',
'        from sys.dba_arguments a,',
'             sys.dba_procedures p',
'      where a.owner = p.owner',
'        and a.object_id = p.object_id',
'        and a.object_name = coalesce( p.procedure_name, p.object_name )',
'        and p.object_type != ''FUNCTION''',
'        and a.owner = :P2507_OWNER',
'        and ( exists (select null',
'                       from sys.dba_tab_privs tp',
'                      where (tp.grantee = (select f.owner',
'                                             from wwv_flows f',
'                                            where f.id = :FB_FLOW_ID',
'                                              and f.security_group_id = :WORKSPACE_ID) or tp.grantee=''PUBLIC'')',
'                        and tp.privilege = ''EXECUTE''',
'                        and (tp.table_name = a.object_name or tp.table_name = a.package_name)',
'                        and tp.owner = a.owner) or',
'              exists (select null',
'                        from wwv_flows f',
'                       where f.owner = :P2507_OWNER',
'                         and f.id = :FB_FLOW_ID',
'                         and f.security_group_id = :WORKSPACE_ID) )  )',
'select ag.object_name d, ag.object_name r',
'  from l_arguments ag',
' where ag.object_name not in (',
'        select pf.object_name',
'        from l_pkg_functions pf )'))
,p_lov_cascade_parent_items=>'P2507_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a procedure or package procedure for the form to use.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11005618394379818)
,p_name=>'P2507_SUBMIT_BRANCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(50809876650933911)
,p_prompt=>'Branch Here on Submit'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d',
'  from wwv_flow_steps',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and is_page_pattern   = ''N''',
'order by 2'))
,p_lov_display_null=>'YES'
,p_cSize=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select a page to branch to after the page processing is complete.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11006413812379823)
,p_name=>'P2507_CANCEL_BRANCH'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(50809876650933911)
,p_prompt=>'Cancel and Go To Page'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d',
'  from wwv_flow_steps',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and is_page_pattern   = ''N''',
'order by 2'))
,p_lov_display_null=>'YES'
,p_cSize=>5
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select a page to which application shall redirect, when the <em>Cancel</em> button is clicked.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(10930633622976177)
,p_validation_name=>'Select Schema Owner'
,p_validation_sequence=>10
,p_validation=>'P2507_OWNER'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Schema owner must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(10904021228976104)
,p_associated_item=>wwv_flow_imp.id(10901163486976086)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(10929837522976177)
,p_validation_name=>'Select Procedure'
,p_validation_sequence=>20
,p_validation=>'P2507_PROCEDURE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Stored procedure must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(10904021228976104)
,p_associated_item=>wwv_flow_imp.id(10902049747976092)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(10930217262976177)
,p_validation_name=>'proc exists'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'  l_point   number;',
'  l_pack    varchar2(2000);',
'  l_obj     varchar2(2000);',
'begin',
'  l_point := instr(:P2507_PROCEDURE,''.'');',
'  if l_point > 0 then',
'    l_pack := substr(:P2507_PROCEDURE,0,l_point-1);',
'	l_obj  := substr(:P2507_PROCEDURE,l_point+1);',
'	for c in ( select 1 from sys.dba_arguments',
'		  	   where owner = :P2507_OWNER',
'			    and object_name = l_obj',
'			    and package_name = l_pack ) loop',
'	  return TRUE;',
'	end loop;',
'  else',
'	for c in ( select * from sys.dba_arguments',
'		  	   where owner = :P2507_OWNER',
'			    and object_name = :P2507_PROCEDURE ) loop',
'	  return TRUE;',
'	end loop;',
'  end if;',
'    return FALSE;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Procedure specified not found, please pick a valid store procedure name.'
,p_when_button_pressed=>wwv_flow_imp.id(10904021228976104)
,p_associated_item=>wwv_flow_imp.id(10902049747976092)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(10932183321976180)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(10903683845976101)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(10932648305976182)
,p_event_id=>wwv_flow_imp.id(10932183321976180)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(10933014622976182)
,p_name=>'Refresh arguments'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2507_PROCEDURE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(10933538424976183)
,p_event_id=>wwv_flow_imp.id(10933014622976182)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(283181239075910775)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5504528983609245)
,p_name=>'Submit CREATE'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(10904021228976104)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5504666087609246)
,p_event_id=>wwv_flow_imp.id(5504528983609245)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'CREATE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(16100960095844934)
,p_process_sequence=>40
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Derive Branch Pages'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_branch_page number;',
'    l_url         varchar2(4000);',
'begin',
'    -- try to default the branch pages based on breadcrumb parent, if selected',
'    if :P2501_BREADCRUMB_PARENT_ID is not null then',
'        select link',
'          into l_url',
'          from wwv_flow_menu_options',
'         where id                = :P2501_BREADCRUMB_PARENT_ID',
'           and flow_id           = :FB_FLOW_ID',
'           and security_group_id = :WORKSPACE_ID;',
'',
'        l_branch_page := wwv_flow_page_map.extract_page_id (',
'                             p_url               => l_url,',
'                             p_application_id    => :FB_FLOW_ID );',
'    -- if no breadcrumb parent selected, check if list entry parent is selected',
'    -- try to derive branch page based on parent list entry',
'    elsif :P2501_BREADCRUMB_PARENT_ID is null and :P2501_NAVLIST_PARENT_ID is not null then',
'        select list_item_link_target',
'          into l_url',
'          from wwv_flow_list_items',
'         where id                = :P2501_NAVLIST_PARENT_ID',
'           and flow_id           = :FB_FLOW_ID',
'           and security_group_id = :WORKSPACE_ID;',
'',
'        l_branch_page := wwv_flow_page_map.extract_page_id (',
'                             p_url               => l_url,',
'                             p_application_id    => :FB_FLOW_ID );',
'    end if;',
'',
'    if l_branch_page is null then',
'        l_branch_page := wwv_flow_page_map.get_home_page_id (',
'                             p_application_id    => :FB_FLOW_ID );',
'    end if;',
'    ',
'    :P2507_SUBMIT_BRANCH := l_branch_page;',
'    :P2507_CANCEL_BRANCH := l_branch_page;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>':P2501_PAGE_MODE = ''NORMAL'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>16100960095844934
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(10930935895976178)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create or truncate the collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.create_or_truncate_collection(''SP_WIZARD'');',
'for i in 1..wwv_flow.g_f01.count loop',
'   wwv_flow_collection.add_member(',
'    p_collection_name => ''SP_WIZARD'',',
'    p_c001            => wwv_flow.g_f01(i),',
'    p_c002            => wwv_flow.g_f02(i),',
'    p_c003            => wwv_flow.g_f03(i),',
'    p_c004            => wwv_flow.g_f04(i),',
'    p_c005            => wwv_flow.g_f05(i));',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(10904021228976104)
,p_internal_uid=>10930935895976178
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(10931358784976178)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create form on procedure'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_wizard_api.create_form_on_sp (',
'       p_flow_id                  => :FB_FLOW_ID,',
'       p_page_id                  => :P2501_PAGE_ID,',
'       p_page_name                => :P2501_PAGE_NAME,',
'       p_page_mode                => :P2501_PAGE_MODE,',
'       --',
'       p_nav_list_id              => :P2500_NAVLIST_ID,',
'       p_nav_list_parent_item_id  => :P2501_NAVLIST_PARENT_ID,',
'       p_nav_list_child_item_name => case when :P2501_NAVLIST_OPTIONS = ''NEW'' then :P2501_PAGE_NAME end,',
'       p_nav_list_item_icon       => :P2501_PAGE_ICON,       ',
'       --',
'       p_region_title             => :P2501_PAGE_NAME,  ',
'       p_region_template          => wwv_flow_theme_dev.get_region_template_id (',
'	  												p_application_id => :FB_FLOW_ID,',
'	  												p_theme_id       => :FB_THEME_ID,',
'	  												p_page_type      => ''FORM'' ),',
'       p_procedure                => :P2507_PROCEDURE, ',
'       p_schema                   => :P2507_OWNER,',
'       p_collection_name          => ''SP_WIZARD'',',
'       p_cancel_branch            => case when :P2501_PAGE_MODE = ''NORMAL'' then :P2507_CANCEL_BRANCH end,',
'       p_submit_branch            => case when :P2501_PAGE_MODE = ''NORMAL'' then :P2507_SUBMIT_BRANCH end,   ',
'       p_cancel_button_name       => wwv_flow_lang_dev.builder_message(''WWV_SPELING.BUTTON_CANCEL''),',
'       p_submit_button_name       => wwv_flow_lang_dev.builder_message(''WWV_SPELING.BUTTON_SUBMIT'') ); ',
'--',
'    wwv_flow_wizard_api.create_breadcrumb_region (',
'        p_application_id             => :FB_FLOW_ID,',
'        p_page_id                    => :P2501_PAGE_ID,',
'        p_seq                        => 10,',
'        p_breadcrumb_id              => :P2501_BREADCRUMB_ID,',
'        p_breadcrumb_entry_name      => :P2501_PAGE_NAME,',
'        p_parent_breadcrumb_entry_id => :P2501_BREADCRUMB_PARENT_ID );',
'        ',
'    :FB_FLOW_PAGE_ID       := :P2501_PAGE_ID;',
'    :F4000_RUN_EDIT_PAGE   := :P2501_PAGE_ID;            ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to create the Form page. #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(10904021228976104)
,p_internal_uid=>10931358784976178
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(10931719773976179)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,REQUEST'
,p_attribute_02=>'N'
,p_process_error_message=>'Error creating form page.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(10904021228976104)
,p_process_success_message=>'Form page created.'
,p_internal_uid=>10931719773976179
);
end;
/
prompt --application/pages/page_02508
begin
wwv_flow_imp_page.create_page(
 p_id=>2508
,p_name=>'Create Page Wizard - Wizard'
,p_alias=>'CREATE-PAGE-WIZARD'
,p_page_mode=>'MODAL'
,p_step_title=>'Create &P2500_PAGE_TYPE_DISPLAY.'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(103848364625132731)
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// reposition icon picker',
'apex.jQuery("#P2508_PAGE_ICON").after(apex.jQuery("button#icon_picker"));'))
,p_css_file_urls=>'#FONT_APEX_LATEST_DIRECTORY#css/font-apex#MIN#.css'
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_css_classes=>'a-Dialog--CreatePageDialog'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_protection_level=>'C'
,p_page_component_map=>'21'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3063558241256536)
,p_plug_name=>'Page Definition'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11529006491540905)
,p_plug_name=>'Branch Pages'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(18005186450209933)
,p_plug_name=>'Wizard Steps'
,p_region_name=>'wiz_steps'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select seq_id id,',
'       c001 step_number,',
'       c002 page_id,',
'       c003 page_name',
'  from wwv_flow_collections',
' where collection_name = ''CREATE_WIZARD'''))
,p_plug_source_type=>'NATIVE_IG'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Wizard Steps'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(18005367000209935)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>30
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(18005413263209936)
,p_name=>'PAGE_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'PAGE_ID'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>'Page Number'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>50
,p_value_alignment=>'RIGHT'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
,p_is_required=>true
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>false
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(18005537016209937)
,p_name=>'PAGE_NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'PAGE_NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>60
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(18005632959209938)
,p_name=>'APEX$ROW_ACTION'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>20
,p_use_as_row_header=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(19904309102194933)
,p_name=>'STEP_NUMBER'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'STEP_NUMBER'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>'Step Number'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>40
,p_value_alignment=>'RIGHT'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
,p_is_required=>true
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>false
,p_include_in_export=>true
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(18005230256209934)
,p_internal_uid=>18005230256209934
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_add_row_if_empty=>false
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>true
,p_show_toolbar=>true
,p_toolbar_buttons=>null
,p_add_button_label=>'Add Wizard Step'
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>false
,p_define_chart_view=>false
,p_enable_download=>false
,p_download_formats=>null
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function(config) {',
'    config.initActions = function( actions ) {',
'        actions.remove("single-row-view");',
'        actions.remove("row-add-row");',
'        actions.remove("row-duplicate");',
'        actions.remove("row-refresh");',
'        actions.remove("row-revert");',
'    };',
'    return config;',
'}'))
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(18414497664150974)
,p_interactive_grid_id=>wwv_flow_imp.id(18005230256209934)
,p_static_id=>'184145'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(18414630301150975)
,p_report_id=>wwv_flow_imp.id(18414497664150974)
,p_view_type=>'GRID'
,p_stretch_columns=>true
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(18415179389150977)
,p_view_id=>wwv_flow_imp.id(18414630301150975)
,p_display_seq=>2
,p_column_id=>wwv_flow_imp.id(18005367000209935)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(18416098145150981)
,p_view_id=>wwv_flow_imp.id(18414630301150975)
,p_display_seq=>4
,p_column_id=>wwv_flow_imp.id(18005413263209936)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>150
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(18416948925150986)
,p_view_id=>wwv_flow_imp.id(18414630301150975)
,p_display_seq=>5
,p_column_id=>wwv_flow_imp.id(18005537016209937)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(18417863397150989)
,p_view_id=>wwv_flow_imp.id(18414630301150975)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(18005632959209938)
,p_is_visible=>true
,p_is_frozen=>true
,p_width=>50
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(22701372632132235)
,p_view_id=>wwv_flow_imp.id(18414630301150975)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(19904309102194933)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>100
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(27505471087052423)
,p_plug_name=>'Navigation'
,p_region_css_classes=>'a-Region--noBottomBorder'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P2500_NAVIGATION_TYPE'
,p_plug_display_when_cond2=>'L'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(27510531301054183)
,p_plug_name=>'Legacy tab based navigation'
,p_region_css_classes=>'a-Alert--dialog'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>50
,p_plug_source=>'htp.p(wwv_flow_lang_dev.builder_message(''WIZARD.TAB_NAVIGATION_MSG''));'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P2500_NAVIGATION_TYPE'
,p_plug_display_when_cond2=>'T'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(75466917512605916)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(15100795123439492)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(27505471087052423)
,p_button_name=>'ICON'
,p_button_static_id=>'icon_picker'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Select Icon'
,p_button_redirect_url=>'f?p=&APP_ID.:181:&SESSION.::&DEBUG.::P181_PASS_BACK_TO_UI,P181_PASS_BACK_TO_SAVE:icon_picker,P2508_PAGE_ICON'
,p_button_css_classes=>'a-Button--colorPicker'
,p_icon_css_classes=>'fa &P2508_PAGE_ICON.'
,p_grid_new_row=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(16900857304321530)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(75466917512605916)
,p_button_name=>'CREATE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Wizard'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(16901288139321530)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(75466917512605916)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:2500:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(16901657574321531)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(75466917512605916)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12204357538853641)
,p_name=>'P2508_WIZARD_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3063558241256536)
,p_prompt=>'Wizard Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter text for Navigation list entry label.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(15101152510439498)
,p_name=>'P2508_USE_NAVLIST'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_imp.id(27505471087052423)
,p_item_default=>'case when :P2500_IS_NAVLIST_SUBSCRIBED = ''Y'' then ''N'' else ''Y'' end'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Use Navigation'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Set this flag to <strong>On</strong>, if you want to link the first page from the wizard to a navigation entry.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(15101909504439502)
,p_name=>'P2508_NAVLIST_OPTIONS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(27505471087052423)
,p_item_default=>'NONE'
,p_prompt=>'Navigation Preference'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WIZARD.NAVILIST.OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(25100593691198570)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select how you want this page integrated into the Navigation Menu.<p/>',
'<ul>',
'    <li><strong>Create a new entry</strong> - Users will be able to navigate to the new page directly from the Navigation Menu. The new entry can be placed anywhere in the existing hierarchy.</li>',
'    <li><strong>Map to an existing entry</strong> - Use this option when you want the new page to highlight an existing, top level, menu entry. Users will not be able to navigate to the new page directly from the Navigation Menu. Therefore, You will '
||'need to create or define a navigation control on the top level page selected, such as a button, or link in a report, to go to this new page.</li>',
'</ul>'))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(15102891612439506)
,p_name=>'P2508_PARENT_LIST_ITEM_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(27505471087052423)
,p_prompt=>'Parent Navigation Menu Entry'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'NAVLIST_ENTRIES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case',
'           when (nvl(list_item_link_target,''0'')=''0'' or parent_list_item_id is',
'null) then',
'               lpad('' '',(4*(level-1)),''.'')||list_item_link_text',
'           else',
'               lpad('' '',(4*(level-1)),''.'')||'' (''||list_item_link_text ||'')''',
'       end name,',
'       id',
'  from wwv_flow_list_items',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and sub_list_id is null',
' start with list_id = :P2500_NAVLIST_ID and parent_list_item_id is null',
'connect by prior list_id = list_id and prior id = parent_list_item_id',
' order siblings by list_item_display_sequence'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No parent selected -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(15103214122439508)
,p_name=>'P2508_PAGE_ICON'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(27505471087052423)
,p_item_default=>'P2500_UT_NAV_ICON'
,p_item_default_type=>'ITEM'
,p_prompt=>'Icon'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'apex-item-group--color-picker'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Identify a icon class for the icon associated with this list entry.',
'<br><br>',
'<strong>Using Universal Theme</strong>',
'<br>',
'Most Universal Theme apps use the Font APEX icon library. To pick an icon, use the built-in icon picker and select an icon from the popup window. See examples below:<br><br>',
'<ul>',
'    <li><code>fa-cloud</code> - displays the cloud icon</li>',
'    <li><code>fa-exclamation-circle u-danger-text</code> - displays a red exclamation icon</li>',
'</ul>',
'<br>',
'You can see more examples on the  <a rel="noopener noreferrer" href="https://apex.oracle.com/fontapex" target="_blank">Icons</a> page of the <a rel="noopener noreferrer" href="https://apex.oracle.com/ut" target="_blank">Universal Theme sample app</a>'
||'.'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(15104121998439509)
,p_name=>'P2508_EXISTING_LIST_ITEM_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(27505471087052423)
,p_prompt=>'Existing Navigation Menu Entry'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'NAVLIST_ENTRIES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case',
'           when (nvl(list_item_link_target,''0'')=''0'' or parent_list_item_id is',
'null) then',
'               lpad('' '',(4*(level-1)),''.'')||list_item_link_text',
'           else',
'               lpad('' '',(4*(level-1)),''.'')||'' (''||list_item_link_text ||'')''',
'       end name,',
'       id',
'  from wwv_flow_list_items',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and sub_list_id is null',
' start with list_id = :P2500_NAVLIST_ID and parent_list_item_id is null',
'connect by prior list_id = list_id and prior id = parent_list_item_id',
' order siblings by list_item_display_sequence'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select an existing menu control to be shown as the active menu control when rendering the new page.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(15105072618439509)
,p_name=>'P2508_NAVLIST_PARENT_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(27505471087052423)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(19901952566194909)
,p_name=>'P2508_PAGE_MODE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3063558241256536)
,p_item_default=>'NORMAL'
,p_prompt=>'Page Mode'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DIALOG_PAGE_MODE_CREATE_WIZARD'
,p_lov=>'.'||wwv_flow_imp.id(1497542689968615899)||'.'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_user_interface_dev.dialog_page_template_exists(',
'                     p_application_id     => :FB_FLOW_ID );'))
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Identify the page mode, based on the following options: <p/>',
'<ul>',
'<li><strong>Normal</strong>: The page is presented as a normal &PRODUCT_NAME. application page.</li>',
'<li><strong>Modal Dialog</strong>: The page is presented as a modal dialog. A modal dialog is an overlay window positioned within the viewport, which remains active and focused until the end user dismisses (closes) it. The underlying page is grayed o'
||'ut and the end user is prevented from interacting with the rest of the page until the dialog is closed.</li>',
'<li><strong>Drawer</strong>: Sets the page mode to <strong>Modal Dialog</strong> and uses <strong>Drawer</strong> template for the page. This option will be available only if the current application theme contains <strong>Drawer</strong> page templat'
||'e.</li>',
'</ul>',
'<br><p>',
'Note that the Modal Dialog option will only be available for selection where the current application theme contains at least one page template of template type <strong>Dialog Page</strong>.</p>'))
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(19902446498194914)
,p_name=>'P2508_FINISH_BRANCH'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(11529006491540905)
,p_item_default=>'P2508_HOME_PAGE'
,p_item_default_type=>'ITEM'
,p_prompt=>'Branch here on Finish'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d',
'  from wwv_flow_steps',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and is_page_pattern   = ''N''',
'order by 2'))
,p_cSize=>10
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a page number to branch to when the user clicks <strong>Finish</strong>.</p>'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(19902681881194916)
,p_name=>'P2508_CANCEL_BRANCH'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(11529006491540905)
,p_item_default=>'P2508_HOME_PAGE'
,p_item_default_type=>'ITEM'
,p_prompt=>'Branch here on Cancel'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d',
'  from wwv_flow_steps',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and is_page_pattern   = ''N''',
'order by 2'))
,p_cSize=>10
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a page number to branch to when the user clicks <strong>Cancel</strong>.</p>'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(19904942570194939)
,p_name=>'P2508_HOME_PAGE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(11529006491540905)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(19904665179194936)
,p_computation_sequence=>10
,p_computation_item=>'P2508_NAVLIST_PARENT_ID'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P2508_PARENT_LIST_ITEM_ID'
,p_compute_when=>'P2508_NAVLIST_OPTIONS'
,p_compute_when_text=>'NEW'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(19904794243194937)
,p_computation_sequence=>20
,p_computation_item=>'P2508_NAVLIST_PARENT_ID'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P2508_EXISTING_LIST_ITEM_ID'
,p_compute_when=>'P2508_NAVLIST_OPTIONS'
,p_compute_when_text=>'EXISTING'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(19905053736194940)
,p_computation_sequence=>20
,p_computation_item=>'P2508_HOME_PAGE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_page_map.get_home_page_id (',
'    p_application_id    => :FB_FLOW_ID )'))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(19903436213194924)
,p_validation_name=>'At least two Wizard Steps'
,p_validation_sequence=>10
,p_validation=>'wwv_flow_collection.collection_member_count( p_collection_name => ''CREATE_WIZARD'') > 1'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Wizard should have at least 2 steps. '
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(12204430619853642)
,p_validation_name=>'P2508_WIZARD_NAME not null'
,p_validation_sequence=>20
,p_validation=>'P2508_WIZARD_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_when_button_pressed=>wwv_flow_imp.id(16900857304321530)
,p_associated_item=>wwv_flow_imp.id(12204357538853641)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(19903024771194920)
,p_validation_name=>'P2508_FINISH_BRANCH is numeric'
,p_validation_sequence=>30
,p_validation=>'P2508_FINISH_BRANCH'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Branch target page number must be numeric.'
,p_associated_item=>wwv_flow_imp.id(19902446498194914)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(19903103165194921)
,p_validation_name=>'P2508_CANCEL_BRANCH is numeric'
,p_validation_sequence=>40
,p_validation=>'P2508_CANCEL_BRANCH'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Branch target page number must be numeric.'
,p_associated_item=>wwv_flow_imp.id(19902681881194916)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4612610078691742)
,p_tabular_form_region_id=>wwv_flow_imp.id(18005186450209933)
,p_validation_name=>'Page Number does not exists'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_steps',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and id                = :PAGE_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Page already exists, please enter different page number.'
,p_when_button_pressed=>wwv_flow_imp.id(16900857304321530)
,p_associated_column=>'PAGE_ID'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4612700680691743)
,p_validation_name=>'STEP_NUMBER must be unique'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001',
'  from wwv_flow_collections',
' where collection_name = ''CREATE_WIZARD''',
' -- c001 is STEP_NUMBER',
' group by c001',
'having count(*) > 1'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Step Number must be unique.'
,p_when_button_pressed=>wwv_flow_imp.id(16900857304321530)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4612882912691744)
,p_validation_name=>'PAGE_ID must be unique'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c002',
'  from wwv_flow_collections',
' where collection_name = ''CREATE_WIZARD''',
' -- c002 is PAGE_ID',
' group by c002',
'having count(*) > 1'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Page Number must be unique.'
,p_when_button_pressed=>wwv_flow_imp.id(16900857304321530)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2829028482620551)
,p_validation_name=>'Navigation Menu not subscribed'
,p_validation_sequence=>80
,p_validation=>'coalesce(:P2500_IS_NAVLIST_SUBSCRIBED,''N'') != ''Y'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'&APP_TEXT$WIZ_NAVIGATION_MENU_SUBSCRIBED!RAW.'
,p_validation_condition=>':P2508_USE_NAVLIST = ''Y'' and :P2500_NAVLIST_ID is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(15101152510439498)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(12202422270853622)
,p_name=>'Show/Hide Nav Items'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2508_USE_NAVLIST'
,p_condition_element=>'P2508_USE_NAVLIST'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(12202518593853623)
,p_event_id=>wwv_flow_imp.id(12202422270853622)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2508_NAVLIST_OPTIONS'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(12202606497853624)
,p_event_id=>wwv_flow_imp.id(12202422270853622)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2508_NAVLIST_OPTIONS,P2508_PARENT_LIST_ITEM_ID,P2508_EXISTING_LIST_ITEM_ID,P2508_PAGE_ICON'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(12202725822853625)
,p_event_id=>wwv_flow_imp.id(12202422270853622)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2508_NAVLIST_OPTIONS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'NEW'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(12202832656853626)
,p_event_id=>wwv_flow_imp.id(12202422270853622)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(15100795123439492)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(12203070756853628)
,p_name=>'Handle Create New Nav List Case'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2508_NAVLIST_OPTIONS'
,p_condition_element=>'P2508_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(12203191678853629)
,p_event_id=>wwv_flow_imp.id(12203070756853628)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2508_PARENT_LIST_ITEM_ID,P2508_PAGE_ICON'
,p_client_condition_type=>'EQUALS'
,p_client_condition_element=>'P2508_USE_NAVLIST'
,p_client_condition_expression=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(12203444840853632)
,p_event_id=>wwv_flow_imp.id(12203070756853628)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(15100795123439492)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(12203289882853630)
,p_event_id=>wwv_flow_imp.id(12203070756853628)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(15100795123439492)
,p_client_condition_type=>'EQUALS'
,p_client_condition_element=>'P2508_USE_NAVLIST'
,p_client_condition_expression=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(12203375571853631)
,p_event_id=>wwv_flow_imp.id(12203070756853628)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2508_PARENT_LIST_ITEM_ID,P2508_PAGE_ICON'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(12203517556853633)
,p_name=>'Handle Existing Nav List Case'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2508_NAVLIST_OPTIONS'
,p_condition_element=>'P2508_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'EXISTING'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(12203600959853634)
,p_event_id=>wwv_flow_imp.id(12203517556853633)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2508_EXISTING_LIST_ITEM_ID'
,p_client_condition_type=>'EQUALS'
,p_client_condition_element=>'P2508_USE_NAVLIST'
,p_client_condition_expression=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(12203740836853635)
,p_event_id=>wwv_flow_imp.id(12203517556853633)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2508_EXISTING_LIST_ITEM_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(12203995598853637)
,p_name=>'Cancel Dialog'
,p_event_sequence=>40
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(16901657574321531)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(12204095641853638)
,p_event_id=>wwv_flow_imp.id(12203995598853637)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(12204118490853639)
,p_name=>'Submit CREATE and show progress'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(16900857304321530)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(12204291981853640)
,p_event_id=>wwv_flow_imp.id(12204118490853639)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'CREATE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(18005926903209941)
,p_name=>'Set PAGE_ID'
,p_event_sequence=>60
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(18005186450209933)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'NATIVE_IG|REGION TYPE|apexbeginrecordedit'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(18006028734209942)
,p_event_id=>wwv_flow_imp.id(18005926903209941)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'PAGE_ID'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>'wwv_flow_utilities.minimum_free_page(:FB_FLOW_ID,1)'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_client_condition_type=>'NULL'
,p_client_condition_elem_type=>'COLUMN'
,p_client_condition_element=>'PAGE_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(19902096992194910)
,p_name=>'Handle Page Mode Change'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2508_PAGE_MODE'
,p_condition_element=>'P2508_PAGE_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NORMAL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(19902171993194911)
,p_event_id=>wwv_flow_imp.id(19902096992194910)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2508_USE_NAVLIST'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_server_condition_type=>'EXPRESSION'
,p_server_condition_expr1=>'coalesce(:P2500_IS_NAVLIST_SUBSCRIBED,''N'') != ''Y'''
,p_server_condition_expr2=>'PLSQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(19902805896194918)
,p_event_id=>wwv_flow_imp.id(19902096992194910)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(11529006491540905)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(19902265875194912)
,p_event_id=>wwv_flow_imp.id(19902096992194910)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2508_USE_NAVLIST'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(19902754435194917)
,p_event_id=>wwv_flow_imp.id(19902096992194910)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(11529006491540905)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4613198852691747)
,p_name=>'Validation Error - Scroll to Top'
,p_event_sequence=>80
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4613294534691748)
,p_event_id=>wwv_flow_imp.id(4613198852691747)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.message.setThemeHooks( { pageErrorsContainerSelector: ".a-Alert--horizontal" } );'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(19904590727194935)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Wizard Pages'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_first_page_id number := null;',
'begin  ',
'    for c1 in ( select c002 page_id',
'                  from wwv_flow_collections',
'                 where collection_name = ''CREATE_WIZARD''',
'                 order by c001 ) loop',
'        l_first_page_id := c1.page_id;',
'        exit;',
'    end loop;',
'    ',
'    wwv_flow_wizard_api.create_wizard (',
'        p_flow_id                  => :FB_FLOW_ID,   ',
'        p_steps                    => wwv_flow_collection.collection_member_count( p_collection_name => ''CREATE_WIZARD''),',
'        p_page_mode                => :P2508_PAGE_MODE,',
'        p_wizard_name              => :P2508_WIZARD_NAME,',
'        --',
'        p_nav_list_id              => :P2500_NAVLIST_ID,',
'        p_nav_list_parent_item_id  => :P2508_NAVLIST_PARENT_ID,',
'        p_nav_list_child_item_name => case when :P2508_NAVLIST_OPTIONS = ''NEW'' then :P2508_WIZARD_NAME end,',
'        p_nav_list_item_icon       => :P2508_PAGE_ICON,        ',
'        --',
'        p_cancel_branch            => case when :P2508_PAGE_MODE = ''NORMAL'' then :P2508_CANCEL_BRANCH end,',
'        p_finish_branch            => case when :P2508_PAGE_MODE = ''NORMAL'' then :P2508_FINISH_BRANCH end,  ',
'        p_cancel_button_name       => wwv_flow_lang_dev.builder_message(''CANCEL''),',
'        p_finish_button_name       => wwv_flow_lang_dev.builder_message(''FINISH''),',
'        p_previous_button_name     => wwv_flow_lang_dev.builder_message(''PREVIOUS''),',
'        p_next_button_name         => wwv_flow_lang_dev.builder_message(''NEXT'') );   ',
'     ',
'    :FB_FLOW_PAGE_ID := l_first_page_id;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error creating wizard. #SQLERRM_TEXT#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(16900857304321530)
,p_internal_uid=>19904590727194935
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(22900517250380766)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,REQUEST'
,p_attribute_02=>'N'
,p_process_error_message=>'Error creating wizard page.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(16900857304321530)
,p_process_success_message=>'Wizard page created.'
,p_internal_uid=>22900517250380766
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(19904252956194932)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Initialize Collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_page_number number;',
'    l_collection_name varchar2(20) := ''CREATE_WIZARD'';',
'begin',
'    -- this collection is cleared during the brnach process to this page',
'    -- wwv_flow_collection.create_or_truncate_collection( l_collection_name );',
'    -- by default add 3 wizard steps',
'    if wwv_flow_collection.collection_member_count( p_collection_name => ''CREATE_WIZARD'') = 0 then',
'        for i in 1..3',
'        loop',
'            l_page_number := wwv_flow_utilities.minimum_free_page(:FB_FLOW_ID,1);',
'            wwv_flow_collection.add_member(',
'                p_collection_name => l_collection_name,',
'                p_c001            => i,',
'                p_c002            => l_page_number,',
'                p_c003            => wwv_flow_lang_dev.builder_message(''WIZARD.DEFAULT_PAGE_NAME'',i),',
'                p_c004            => 0 );',
'        end loop;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>19904252956194932
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(19904408518194934)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_region_id=>wwv_flow_imp.id(18005186450209933)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Update Collection'
,p_attribute_01=>'PLSQL_CODE'
,p_attribute_04=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_collection_name varchar2(20) := ''CREATE_WIZARD'';',
'begin',
'    case :APEX$ROW_STATUS',
'    when ''C'' then',
'        wwv_flow_collection.add_member(',
'            p_collection_name => l_collection_name,',
'            p_c001            => :STEP_NUMBER,',
'            p_c002            => :PAGE_ID,',
'            p_c003            => :PAGE_NAME,',
'            p_c004            => 0 );',
'    when ''U'' then',
'        wwv_flow_collection.update_member(',
'            p_collection_name => l_collection_name,',
'            p_seq             => :ID,',
'            p_c001            => :STEP_NUMBER,',
'            p_c002            => :PAGE_ID,',
'            p_c003            => :PAGE_NAME,',
'            p_c004            => 0 );',
'    when ''D'' then',
'        wwv_flow_collection.delete_member(',
'            p_collection_name => l_collection_name,',
'            p_seq => :ID );',
'    end case;',
'end;'))
,p_attribute_05=>'N'
,p_attribute_06=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>19904408518194934
);
end;
/
prompt --application/pages/page_02509
begin
wwv_flow_imp_page.create_page(
 p_id=>2509
,p_name=>'Create Page Wizard - Plug-in Selection'
,p_alias=>'CREATE-PAGE-PLUG-IN'
,p_page_mode=>'MODAL'
,p_step_title=>'Create &P2500_PAGE_TYPE_DISPLAY.'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(103848364625132731)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_css_classes=>'a-Dialog--CreatePageDialog'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_protection_level=>'C'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(77080106841788111)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(821572402863310331)
,p_plug_name=>'Plug-in Selection'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P2509_PLUGINS_COUNT > 0'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4610617803691722)
,p_plug_name=>'Plug-Ins with Deprecated Source'
,p_parent_plug_id=>wwv_flow_imp.id(821572402863310331)
,p_region_css_classes=>'a-Alert--dialog'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'Note: Your application contains plug-ins with deprecated source types. These plug-ins are not listed here. If you want to use those plug-ins, please create a blank page and add those plug-ins to the page using page designer.'
,p_plug_display_condition_type=>'ITEM_IS_NOT_ZERO'
,p_plug_display_when_condition=>'P2509_DEPRECATED_SOURCE'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(909841732914329098)
,p_plug_name=>'No Plug-In Installed'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P2509_PLUGINS_COUNT = 0'
,p_plug_display_when_cond2=>'PLSQL'
,p_plug_header=>'"NO_PLUGINS_INSTALLED"'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'Y',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(18513609075503705)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(77080106841788111)
,p_button_name=>'NEXT'
,p_button_static_id=>'NEXT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'to_number(:P2509_PLUGINS_COUNT) - to_number(:P2509_DEPRECATED_SOURCE) > 0'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(18514495984503706)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(77080106841788111)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:2500:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(18514811204503707)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(77080106841788111)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(19901590641194905)
,p_branch_name=>'Go to Page 2501 - Page Definition'
,p_branch_action=>'f?p=&APP_ID.:2501:&SESSION.::&DEBUG.::P2501_PREV_PAGE:2509&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(18513609075503705)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4610711437691723)
,p_name=>'P2509_DEPRECATED_SOURCE'
,p_item_sequence=>31
,p_item_plug_id=>wwv_flow_imp.id(821572402863310331)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18516585676512120)
,p_name=>'P2509_PLUGINS_COUNT'
,p_item_sequence=>11
,p_item_plug_id=>wwv_flow_imp.id(821572402863310331)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18516908932512123)
,p_name=>'P2509_REGION_TYPE'
,p_is_required=>true
,p_item_sequence=>21
,p_item_plug_id=>wwv_flow_imp.id(821572402863310331)
,p_prompt=>'Plug-in'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name      as d,',
'       ''PLUGIN_'' || name as r',
'  from wwv_flow_plugins',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and plugin_type       = ''REGION TYPE''',
'   -- display plug-ins with valid source types',
'   and ( -- plug-in does not have source, then show the plug-in',
'        '':''||standard_attributes||'':'' not like ''%:SOURCE%:''',
'        -- or show the plug-ins with valid source types',
'        or '':''||standard_attributes||'':'' like ''%:SOURCE_LOCATION:%''',
'        or '':''||standard_attributes||'':'' like ''%:SOURCE_PLAIN:%'' )',
' order by 1'))
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
,p_attribute_04=>'VERTICAL'
,p_item_comment=>'Identify the region plug-in.'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(18006314638209945)
,p_computation_sequence=>10
,p_computation_item=>'P2509_PLUGINS_COUNT'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*)',
'  from wwv_flow_plugins',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and plugin_type       = ''REGION TYPE'''))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(4611068284691726)
,p_computation_sequence=>20
,p_computation_item=>'P2509_DEPRECATED_SOURCE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*)',
'  from wwv_flow_plugins',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and plugin_type       = ''REGION TYPE''',
'    -- has some plug-ins with SOURCE attributes',
'   and '':''||standard_attributes||'':'' like ''%:SOURCE%:''',
'    -- but not the supported ones',
'   and '':''||standard_attributes||'':'' not like ''%:SOURCE_LOCATION:%''',
'   and '':''||standard_attributes||'':'' not like ''%:SOURCE_PLAIN:%'''))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4612139584691737)
,p_validation_name=>'P2509_REGION_TYPE not null'
,p_validation_sequence=>10
,p_validation=>'P2509_REGION_TYPE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Please select a plug-in.'
,p_when_button_pressed=>wwv_flow_imp.id(18513609075503705)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(18006160468209943)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(18514811204503707)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(18006216852209944)
,p_event_id=>wwv_flow_imp.id(18006160468209943)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(18006601581209948)
,p_name=>'Submit NEXT and show progress'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(18513609075503705)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(18006732704209949)
,p_event_id=>wwv_flow_imp.id(18006601581209948)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'NEXT'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4231468829904658)
,p_name=>'Validation Error - Scroll to Top'
,p_event_sequence=>30
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4231864755904658)
,p_event_id=>wwv_flow_imp.id(4231468829904658)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.message.setThemeHooks( { pageErrorsContainerSelector: ".a-Alert--horizontal" } );'
);
end;
/
prompt --application/pages/page_02510
begin
wwv_flow_imp_page.create_page(
 p_id=>2510
,p_name=>'Create Page Wizard - Plug-in Attributes'
,p_alias=>'CREATE-PAGE-PLUG-IN-ATTRIBUTES'
,p_page_mode=>'MODAL'
,p_step_title=>'Create &P2500_PAGE_TYPE_DISPLAY.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(103848364625132731)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_css_classes=>'a-Dialog--CreatePageDialog'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(224048804000688910)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>140
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(844059701738206115)
,p_plug_name=>'Create Page'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>91
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(844065126809206131)
,p_plug_name=>'Add Javascript code for Plugins'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>130
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    -- create the initialization code for the dynamic attributes',
'    wwv_flow_plugin_dev.add_onload_code (',
'        p_plugin_type              => wwv_flow_plugin.c_plugin_type_region_type,',
'        p_type_value               => :P2510_REGION_TYPE,',
'        p_page_item_prefix         => ''P2510_'',',
'        p_source_type              => :P2501_QUERY_TYPE,',
'        p_location                 => :P2501_LOCATION,',
'        p_remote_server_id         => :P2501_REMOTE_SERVER_ID,',
'        p_table_owner              => :P2501_TAB_OWNER,',
'        p_table_name               => :P2501_TAB_NAME,',
'        p_region_source            => :P2501_SQL_SOURCE,',
'        p_column_names             => NULL,',
'        p_web_src_module_id        => :P2501_WEB_SRC_MODULE_ID,',
'        p_is_wizard                => true );',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(18490358218468415)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(224048804000688910)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(18490710555468416)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(224048804000688910)
,p_button_name=>'CREATE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Page'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(18491183643468416)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(224048804000688910)
,p_button_name=>'Previous'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:2501:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4800651775096902)
,p_name=>'P2510_REGION_TYPE'
,p_item_sequence=>10
,p_prompt=>'Plug-in'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name      as d,',
'       ''PLUGIN_'' || name as r',
'  from wwv_flow_plugins',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and plugin_type       = ''REGION TYPE'''))
,p_grid_column=>1
,p_display_when=>'P2500_PAGE_TYPE'
,p_display_when2=>'PLUGIN'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18491880061468424)
,p_name=>'P2510_ATTRIBUTE_01'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(844059701738206115)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18492271082468427)
,p_name=>'P2510_ATTRIBUTE_02'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(844059701738206115)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18492688628468427)
,p_name=>'P2510_ATTRIBUTE_03'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(844059701738206115)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18493045882468428)
,p_name=>'P2510_ATTRIBUTE_04'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(844059701738206115)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18493484837468428)
,p_name=>'P2510_ATTRIBUTE_05'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(844059701738206115)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18493891081468428)
,p_name=>'P2510_ATTRIBUTE_06'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(844059701738206115)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18494210719468428)
,p_name=>'P2510_ATTRIBUTE_07'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(844059701738206115)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18494621970468429)
,p_name=>'P2510_ATTRIBUTE_08'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(844059701738206115)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18495027656468429)
,p_name=>'P2510_ATTRIBUTE_09'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(844059701738206115)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18495457701468429)
,p_name=>'P2510_ATTRIBUTE_10'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(844059701738206115)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18495803915468429)
,p_name=>'P2510_ATTRIBUTE_11'
,p_item_sequence=>211
,p_item_plug_id=>wwv_flow_imp.id(844059701738206115)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18496261593468430)
,p_name=>'P2510_ATTRIBUTE_12'
,p_item_sequence=>212
,p_item_plug_id=>wwv_flow_imp.id(844059701738206115)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18496678288468430)
,p_name=>'P2510_ATTRIBUTE_13'
,p_item_sequence=>213
,p_item_plug_id=>wwv_flow_imp.id(844059701738206115)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18497037378468430)
,p_name=>'P2510_ATTRIBUTE_14'
,p_item_sequence=>214
,p_item_plug_id=>wwv_flow_imp.id(844059701738206115)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18497422179468430)
,p_name=>'P2510_ATTRIBUTE_15'
,p_item_sequence=>215
,p_item_plug_id=>wwv_flow_imp.id(844059701738206115)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18497861213468431)
,p_name=>'P2510_ATTRIBUTE_16'
,p_item_sequence=>221
,p_item_plug_id=>wwv_flow_imp.id(844059701738206115)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18498299459468431)
,p_name=>'P2510_ATTRIBUTE_17'
,p_item_sequence=>222
,p_item_plug_id=>wwv_flow_imp.id(844059701738206115)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18498615311468431)
,p_name=>'P2510_ATTRIBUTE_18'
,p_item_sequence=>223
,p_item_plug_id=>wwv_flow_imp.id(844059701738206115)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18499070944468432)
,p_name=>'P2510_ATTRIBUTE_19'
,p_item_sequence=>224
,p_item_plug_id=>wwv_flow_imp.id(844059701738206115)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18499418279468432)
,p_name=>'P2510_ATTRIBUTE_20'
,p_item_sequence=>225
,p_item_plug_id=>wwv_flow_imp.id(844059701738206115)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18499898684468432)
,p_name=>'P2510_ATTRIBUTE_21'
,p_item_sequence=>226
,p_item_plug_id=>wwv_flow_imp.id(844059701738206115)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18500272478468433)
,p_name=>'P2510_ATTRIBUTE_22'
,p_item_sequence=>227
,p_item_plug_id=>wwv_flow_imp.id(844059701738206115)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18500619388468433)
,p_name=>'P2510_ATTRIBUTE_23'
,p_item_sequence=>228
,p_item_plug_id=>wwv_flow_imp.id(844059701738206115)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18501007075468433)
,p_name=>'P2510_ATTRIBUTE_24'
,p_item_sequence=>229
,p_item_plug_id=>wwv_flow_imp.id(844059701738206115)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18501491277468434)
,p_name=>'P2510_ATTRIBUTE_25'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_imp.id(844059701738206115)
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(18506503551468447)
,p_validation_name=>'Validate Plugin Attributes (classic, local DB)'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.validate_attribute_items (',
'        p_application_id    => :FB_FLOW_ID,',
'        p_plugin_type       => wwv_flow_plugin.c_plugin_type_region_type,',
'        p_plugin_name       => :P2510_REGION_TYPE,',
'        p_attribute_scope   => wwv_flow_plugin.c_attribute_scope_component,',
'        p_page_item_prefix  => ''P2510_'' );',
'end;'))
,p_validation_type=>'PLSQL_ERROR'
,p_error_message=>'Error'
,p_validation_condition=>'P2501_SHOW_DATA_SOURCE'
,p_validation_condition2=>'N'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(18490710555468416)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(18506176769468447)
,p_validation_name=>'Validate Plugin Attributes (multiple sources)'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.validate_attribute_items (',
'        p_application_id    => :FB_FLOW_ID,',
'        p_plugin_type       => wwv_flow_plugin.c_plugin_type_region_type,',
'        p_plugin_name       => :P2510_REGION_TYPE,',
'        p_attribute_scope   => wwv_flow_plugin.c_attribute_scope_component,',
'        p_page_item_prefix  => ''P2510_'',',
'        --',
'        p_source_type       => :P2501_QUERY_TYPE,',
'        p_location          => :P2501_LOCATION,',
'        p_remote_server_id  => :P2501_REMOTE_SERVER_ID,',
'        p_table_owner       => :P2501_TAB_OWNER,',
'        p_table_name        => :P2501_TAB_NAME,',
'        p_region_source     => :P2501_SQL_SOURCE,',
'        p_web_src_module_id => :P2501_WEB_SRC_MODULE_ID );',
'end;'))
,p_validation_type=>'PLSQL_ERROR'
,p_error_message=>'Error'
,p_validation_condition=>'P2501_SHOW_DATA_SOURCE'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(18490710555468416)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(18508882585468452)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(18490358218468415)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(18509305076468454)
,p_event_id=>wwv_flow_imp.id(18508882585468452)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(15901831207127515)
,p_name=>'Submit CREATE and show progress'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(18490710555468416)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(15901948655127516)
,p_event_id=>wwv_flow_imp.id(15901831207127515)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'CREATE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4220101979605001)
,p_name=>'Validation Error - Scroll to Top'
,p_event_sequence=>30
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4220254668605002)
,p_event_id=>wwv_flow_imp.id(4220101979605001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.message.setThemeHooks( { pageErrorsContainerSelector: ".a-Alert--horizontal" } );'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(18508040812468451)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Convert Plugin Number Attributes for Storage'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.conv_number_fields_for_storage (',
'        p_application_id    => :FB_FLOW_ID,',
'        p_plugin_type       => wwv_flow_plugin.c_plugin_type_region_type,',
'        p_plugin_name       => :P2510_REGION_TYPE,',
'        p_attribute_scope   => wwv_flow_plugin.c_attribute_scope_component,',
'        p_page_item_prefix  => ''P2510_'' );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>18508040812468451
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(18506839442468448)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Plug-in Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_attributes_clob clob;',
'    l_plugin_app_id   number := wwv_flow_plugin_dev.get_plugin_application_id( :P2510_REGION_TYPE, :FB_FLOW_ID );',
'    l_sgid            number := wwv_flow_plugin_dev.get_plugin_sgid( :WORKSPACE_ID, l_plugin_app_id );                                       ',
'begin',
'    l_attributes_clob := wwv_flow_plugin_dev.get_json_attributes_from_items(',
'                             p_application_id    => l_plugin_app_id,',
'                             p_plugin_name       => substr(:P2510_REGION_TYPE, 8),',
'                             p_plugin_type       => wwv_flow_plugin.c_plugin_type_region_type,',
'                             p_attribute_scope   => wwv_flow_plugin.c_attribute_scope_component,',
'                             p_security_group_id => l_sgid,',
'                             p_page_item_prefix  => ''P2510_'' );',
'            ',
'    wwv_flow_wizard_api.create_region_plugin_page (',
'        p_flow_id                  => :FB_FLOW_ID,',
'        --',
'        p_page_id                  => :P2501_PAGE_ID,',
'        p_page_name                => :P2501_PAGE_NAME,',
'        p_page_mode                => :P2501_PAGE_MODE,',
'        --',
'        p_nav_list_id              => :P2500_NAVLIST_ID,',
'        p_nav_list_parent_item_id  => :P2501_NAVLIST_PARENT_ID,',
'        p_nav_list_child_item_name => case when :P2501_NAVLIST_OPTIONS = ''NEW'' then :P2501_PAGE_NAME end,',
'        p_nav_list_item_icon       => :P2501_PAGE_ICON,',
'        --',
'        p_breadcrumb_id            => :P2501_BREADCRUMB_ID,',
'        p_breadcrumb_name          => :P2501_PAGE_NAME,',
'        p_parent_breadcrumb_id     => :P2501_BREADCRUMB_PARENT_ID,',
'        --',
'        p_region_name              => :P2501_PAGE_NAME,',
'        p_region_type              => :P2510_REGION_TYPE,',
'        --',
'        p_source_type              => case when :P2501_SHOW_DATA_SOURCE = ''Y'' then :P2501_QUERY_TYPE end,',
'        p_location                 => case when :P2501_SHOW_DATA_SOURCE = ''Y'' then :P2501_LOCATION end,',
'        p_remote_server_id         => case when :P2501_SHOW_DATA_SOURCE = ''Y'' then :P2501_REMOTE_SERVER_ID end,',
'        p_table_owner              => case when :P2501_SHOW_DATA_SOURCE = ''Y'' then :P2501_TAB_OWNER end,',
'        p_table_name               => case when :P2501_SHOW_DATA_SOURCE = ''Y'' then :P2501_TAB_NAME end,',
'        p_region_source            => case when :P2501_SHOW_DATA_SOURCE = ''Y'' then :P2501_SQL_SOURCE end,',
'        p_column_names             => null,',
'        p_web_src_module_id        => case when :P2501_SHOW_DATA_SOURCE = ''Y'' then :P2501_WEB_SRC_MODULE_ID end,',
'        --',
'        p_attributes               => l_attributes_clob );',
'',
'  :FB_FLOW_PAGE_ID       := :P2501_PAGE_ID;',
'  :F4000_RUN_EDIT_PAGE   := :P2501_PAGE_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(18490710555468416)
,p_internal_uid=>18506839442468448
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(18507219090468450)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close of Dialog - Calendar'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,REQUEST'
,p_attribute_02=>'N'
,p_process_error_message=>'Error creating &P2500_PAGE_TYPE_DISPLAY. page.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(18490710555468416)
,p_process_when=>'P2500_PAGE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'CALENDAR'
,p_process_success_message=>'&P2500_PAGE_TYPE_DISPLAY. page created.'
,p_internal_uid=>18507219090468450
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4612326373691739)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close of Dialog - Plug-in'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,REQUEST'
,p_attribute_02=>'N'
,p_process_error_message=>'Error creating &P2500_PAGE_TYPE_DISPLAY..'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(18490710555468416)
,p_process_when=>'P2500_PAGE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'PLUGIN'
,p_process_success_message=>'&P2500_PAGE_TYPE_DISPLAY. created.'
,p_internal_uid=>4612326373691739
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(18508475119468451)
,p_process_sequence=>20
,p_process_point=>'BEFORE_BOX_BODY'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Convert Plugin Number Attributes for Display'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.conv_number_fields_for_display (',
'        p_application_id    => :FB_FLOW_ID,',
'        p_plugin_type       => wwv_flow_plugin.c_plugin_type_region_type,',
'        p_plugin_name       => :P2510_REGION_TYPE,',
'        p_attribute_scope   => wwv_flow_plugin.c_attribute_scope_component,',
'        p_page_item_prefix  => ''P2510_'' );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>18508475119468451
);
end;
/
prompt --application/pages/page_02511
begin
wwv_flow_imp_page.create_page(
 p_id=>2511
,p_name=>'Create Page Wizard - Theme Check'
,p_alias=>'CREATE-PAGE-THEME-CHECK'
,p_page_mode=>'MODAL'
,p_step_title=>'Create &P2500_PAGE_TYPE_DISPLAY.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(103848364625132731)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_css_classes=>'a-Dialog--CreatePageDialog'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_frm.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(224238048728248726)
,p_plug_name=>'Required Template Missing'
,p_region_css_classes=>'a-Alert--inlineDialog a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'The application does not have the required "Media List" report template for the Side by Side master detail page.  Please refresh your Universal Theme to the latest to add this template.'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P2513_MEDIA_LIST_EXISTS = ''N'' and :P2500_IS_UT_BASED = ''Y'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(886689993030557699)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>170
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1132902467876936976)
,p_plug_name=>'MD Side by Side - Theme Compatibility'
,p_region_css_classes=>'a-Alert--inlineDialog a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Side by Side master detail requires an Universal Theme based application. ',
'Oracle recommends updating to the Univeral Theme. To learn more, see the <a rel="noopener noreferrer" href="https://apex.oracle.com/ut" target="_blank">Universal Theme App</a>.</p>'))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P2500_PAGE_TYPE = ''MD'' and :P2500_IS_UT_BASED = ''N'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1191371276039919446)
,p_plug_name=>'Dashboard - Theme Compatibility'
,p_region_css_classes=>'a-Alert--inlineDialog a-Alert--noTitle'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>180
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Dashboard requires an Universal Theme based application. ',
'Oracle recommends updating to the Univeral Theme. To learn more, see the <a rel="noopener noreferrer" href="https://apex.oracle.com/ut" target="_blank">Universal Theme App</a>.</p>'))
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P2500_PAGE_TYPE'
,p_plug_display_when_cond2=>'DASHBOARD'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5405914951021936)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(886689993030557699)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5406763264021938)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_imp.id(886689993030557699)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&P2511_PREV_PAGE.:&SESSION.::&DEBUG.:RP,::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4406258937104848)
,p_name=>'P2511_PREV_PAGE'
,p_item_sequence=>10
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5411234940021961)
,p_name=>'Cancel Dialog'
,p_event_sequence=>40
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(5405914951021936)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5411727838021961)
,p_event_id=>wwv_flow_imp.id(5411234940021961)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_02512
begin
wwv_flow_imp_page.create_page(
 p_id=>2512
,p_name=>'Create Page Wizard - Tree Attributes'
,p_alias=>'CREATE-PAGE-TREE'
,p_page_mode=>'MODAL'
,p_step_title=>'Create &P2500_PAGE_TYPE_DISPLAY.'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(103848364625132731)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_css_classes=>'a-Dialog--CreatePageDialog'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_protection_level=>'C'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4403242194104818)
,p_plug_name=>'Tree Attributes'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(232549313952953045)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(563603411759389322)
,p_plug_name=>'Help'
,p_region_css_classes=>'help-region'
,p_region_template_options=>'#DEFAULT#:is-expanded:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(689970285456172024)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<p>A tree is based on a query and returns data that can be represented in a hierarchy. A <strong>start with .. connect by</strong> clause will be used to generate the hierarchical query for your tree. Use this page to identify the column you want to '
||'use as the ID, the Parent ID, and text that should appear on the nodes. The Start With column will be used to specify the root of the hierarchical query, and its value can be based on an existing item, static value or SQL query returning a single val'
||'ue.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8500881330264167)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(232549313952953045)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8501210649264168)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(232549313952953045)
,p_button_name=>'CREATE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Page'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8501657900264169)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(232549313952953045)
,p_button_name=>'Previous'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:2501:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4403405034104820)
,p_name=>'P2512_ID'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(4403242194104818)
,p_prompt=>'ID'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WIZ_COLUMNS_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 column_name_esc,',
'       c002 column_name',
'  from wwv_flow_collections',
' where collection_name = ''WIZ_COLUMNS_LIST''',
' order by seq_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the column you want to use as ID. For example, select <code>EMPNO</code> column for <code>EMP</code> table.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4403625874104822)
,p_name=>'P2512_PID'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(4403242194104818)
,p_prompt=>'Parent ID'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WIZ_COLUMNS_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 column_name_esc,',
'       c002 column_name',
'  from wwv_flow_collections',
' where collection_name = ''WIZ_COLUMNS_LIST''',
' order by seq_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the column you want to use as Parent ID. For example, select <code>MGR</code> column for <code>EMP</code> table.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4403798001104823)
,p_name=>'P2512_NAME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(4403242194104818)
,p_prompt=>'Node Text'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WIZ_COLUMNS_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 column_name_esc,',
'       c002 column_name',
'  from wwv_flow_collections',
' where collection_name = ''WIZ_COLUMNS_LIST''',
' order by seq_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the text to appear on the nodes. For example, select <code>ENAME</code> column for <code>EMP</code> table.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4403853579104824)
,p_name=>'P2512_START_NODE'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(4403242194104818)
,p_prompt=>'Start With'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WIZ_COLUMNS_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 column_name_esc,',
'       c002 column_name',
'  from wwv_flow_collections',
' where collection_name = ''WIZ_COLUMNS_LIST''',
' order by seq_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the column to be used to specify the root of the hierarchical tree query. For example, select <code>MGR</code> column for <code>EMP</code> table.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4403937180104825)
,p_name=>'P2512_START_TREE'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(4403242194104818)
,p_item_default=>'NULL'
,p_prompt=>'Start Tree'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'START_TREE'
,p_lov=>'.'||wwv_flow_imp.id(84323624609603883)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose how you wish to start your query.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4404087569104826)
,p_name=>'P2512_START_STATIC_VALUE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(4403242194104818)
,p_prompt=>'Start Value'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a static value, to be used as the root value for the Start With column selected.  To set the Start Value to null, leave the text item empty.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4404104624104827)
,p_name=>'P2512_START_ITEM'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(4403242194104818)
,p_prompt=>'Start Item'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'ALL ITEMS (PAGE AND APPLICATION)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, name r',
'from wwv_flow_items',
'where security_group_id = :flow_security_group_id and',
'         flow_id = :fb_flow_id',
'union all',
'select name d, name r',
'from wwv_flow_step_items',
'where security_group_id = :flow_security_group_id and',
'         flow_id = :fb_flow_id'))
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Select an existing application or page item, holding the value to be used as the root value for the Start With column selected.</p>'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4404227084104828)
,p_name=>'P2512_SQL'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(4403242194104818)
,p_prompt=>'SQL'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Enter a SQL query that returns a single row and a single column.  The return value will be used as the root value for the Start With column selected.</p>'
,p_attribute_01=>'SQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4405551955104841)
,p_name=>'P2512_TREE_BUTTON_OPTIONS'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(4403242194104818)
,p_item_default=>'CONTRACT_ALL:EXPAND_ALL'
,p_prompt=>'Include Buttons'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'TREE_BUTTON_OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(84309708763580409)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select what buttons to include.'
,p_attribute_01=>'2'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4405236257104838)
,p_validation_name=>'P2512_SQL is not null'
,p_validation_sequence=>10
,p_validation=>'P2512_SQL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'SQL Query must be specified for the value of the start node.'
,p_validation_condition=>'P2512_START_TREE'
,p_validation_condition2=>'SQL'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(8501210649264168)
,p_associated_item=>wwv_flow_imp.id(4404227084104828)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4405345251104839)
,p_validation_name=>'Invalid SQL statement'
,p_validation_sequence=>20
,p_validation=>'return wwv_flow_f4000_util.is_valid_start_query(:P2512_SQL);'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'The Start Tree SQL Query is invalid.  The query must return a single value.'
,p_validation_condition=>':P2512_SQL is not null and :P2512_START_TREE = ''SQL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(8501210649264168)
,p_associated_item=>wwv_flow_imp.id(4404227084104828)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4402898127104814)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(8500881330264167)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4402975573104815)
,p_event_id=>wwv_flow_imp.id(4402898127104814)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4403032388104816)
,p_name=>'Submit CREATE and show progress'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(8501210649264168)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4403118634104817)
,p_event_id=>wwv_flow_imp.id(4403032388104816)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'CREATE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4404329353104829)
,p_name=>'Static Start Value'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2512_START_TREE'
,p_condition_element=>'P2512_START_TREE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'STATIC'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4404442689104830)
,p_event_id=>wwv_flow_imp.id(4404329353104829)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2512_START_STATIC_VALUE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4404594523104831)
,p_event_id=>wwv_flow_imp.id(4404329353104829)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2512_START_STATIC_VALUE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4404623343104832)
,p_name=>'Item Start Value'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2512_START_TREE'
,p_condition_element=>'P2512_START_TREE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'ITEM'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4404743946104833)
,p_event_id=>wwv_flow_imp.id(4404623343104832)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2512_START_ITEM'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4404898612104834)
,p_event_id=>wwv_flow_imp.id(4404623343104832)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2512_START_ITEM'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4404963294104835)
,p_name=>'SQL Start Value'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2512_START_TREE'
,p_condition_element=>'P2512_START_TREE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SQL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4405088684104836)
,p_event_id=>wwv_flow_imp.id(4404963294104835)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2512_SQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4405180103104837)
,p_event_id=>wwv_flow_imp.id(4404963294104835)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2512_SQL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4232264770943165)
,p_name=>'Validation Error - Scroll to Top'
,p_event_sequence=>60
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4232624256943165)
,p_event_id=>wwv_flow_imp.id(4232264770943165)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.message.setThemeHooks( { pageErrorsContainerSelector: ".a-Alert--horizontal" } );'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4405671361104842)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Tree Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_start_value              varchar2(4000) := null;',
'  l_start_sql                varchar2(4000) := null;',
'  l_default_region_template  wwv_flow_themes.default_region_template%type;',
'begin',
'  -- Start With Column Value',
'  if :P2512_START_TREE = ''ITEM'' then',
'      l_start_value := '':''||:P2512_START_ITEM;',
'  elsif :P2512_START_TREE = ''STATIC'' then',
'      l_start_value := :P2512_START_STATIC_VALUE;',
'  elsif :P2512_START_TREE = ''SQL'' then',
'      l_start_sql   := trim(trailing '';'' from :P2512_SQL);',
'      l_start_value := ''(''||l_start_sql||'')'';',
'  end if;',
'  ',
'  select default_region_template',
'    into l_default_region_template',
'    from wwv_flow_themes',
'   where flow_id           = :FB_FLOW_ID',
'     and security_group_id = :WORKSPACE_ID',
'     and theme_id          = :FB_THEME_ID;',
'',
'  wwv_flow_wizard_api.create_jstree (',
'     p_flow_id                  => :FB_FLOW_ID,',
'     p_page_id                  => :P2501_PAGE_ID,',
'     p_page_name                => :P2501_PAGE_NAME,',
'     p_page_mode                => :P2501_PAGE_MODE,',
'     --',
'     p_nav_list_id              => :P2500_NAVLIST_ID,',
'     p_nav_list_parent_item_id  => :P2501_NAVLIST_PARENT_ID,',
'     p_nav_list_child_item_name => case when :P2501_NAVLIST_OPTIONS = ''NEW'' then :P2501_PAGE_NAME end,',
'     p_nav_list_item_icon       => :P2501_PAGE_ICON,',
'     --',
'     p_breadcrumb_id            => :P2501_BREADCRUMB_ID,',
'     p_breadcrumb_name          => :P2501_PAGE_NAME,',
'     p_parent_bc_id             => :P2501_BREADCRUMB_PARENT_ID,',
'     --',
'     p_region_template          => l_default_region_template,',
'     p_region_name              => :P2501_PAGE_NAME, ',
'     --',
'     p_tree_query               => wwv_flow_wizard_api.generate_tree_region_query (',
'                                       p_flow_id      => :FB_FLOW_ID,',
'                                       p_owner        => wwv_flow_wizard_api.get_owner(',
'                                                            :FB_FLOW_ID,',
'                                                            :P2501_TAB_OWNER ),',
'                                       p_table_name   => :P2501_TAB_NAME,',
'                                       p_id           => :P2512_ID,',
'                                       p_pid          => :P2512_PID,',
'                                       p_name         => :P2512_NAME,',
'                                       p_start_item   => :P2512_START_NODE,',
'                                       p_start_value  => l_start_value,',
'                                       p_link_option  => null,',
'                                       p_link_page_id => null,',
'                                       p_link_item    => null,',
'                                       p_where        => null,',
'                                       p_order_by     => :P2512_NAME,',
'                                       p_tooltip      => null,',
'                                       p_icon         => null),',
'     p_tree_button_option       => :P2512_TREE_BUTTON_OPTIONS,',
'     p_show_hints               => null,',
'     p_tree_hint_text           => null,',
'     p_tree_click_action        => ''S'',',
'     p_selected_node            => null );',
'       ',
'  :F4000_RUN_EDIT_PAGE   := :P2501_PAGE_ID;',
'  :FB_FLOW_PAGE_ID       := :P2501_PAGE_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to create tree page.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(8501210649264168)
,p_internal_uid=>4405671361104842
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4405732925104843)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,REQUEST'
,p_attribute_02=>'N'
,p_process_error_message=>'Error creating Tree page.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(8501210649264168)
,p_process_success_message=>'Tree page created.'
,p_internal_uid=>4405732925104843
);
end;
/
prompt --application/pages/page_02513
begin
wwv_flow_imp_page.create_page(
 p_id=>2513
,p_name=>'Create Page Wizard - MD - Layout'
,p_alias=>'CREATE-PAGE-MD-LAYOUT'
,p_page_mode=>'MODAL'
,p_step_title=>'Create &P2500_PAGE_TYPE_DISPLAY.'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(103848364625132731)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_css_classes=>'a-Dialog--CreatePageDialog'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_protection_level=>'C'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(43668086241042907)
,p_plug_name=>'Master Detail Style'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(69767572080141161)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(286850267204373059)
,p_plug_name=>'Help'
,p_region_css_classes=>'help-region'
,p_region_template_options=>'#DEFAULT#:is-expanded:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(689970285456172024)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'<li>Stacked - A single page master-detail utilizing editable Interactive Grids.</li>',
'<li>Side by Side - A single page master-detail utilizing side by side layout and report regions with modal edit windows.</li>',
'<li>Drill Down - Consists of a report page that drills down to a page where the selected master is standard form items, and the detail tables use editable Interactive Grids.</li>',
'</ul>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(11201168598856784)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(69767572080141161)
,p_button_name=>'NEXT'
,p_button_static_id=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(11201972256856786)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(69767572080141161)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:2500:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(11202361361856786)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(69767572080141161)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4406066211104846)
,p_branch_name=>'Side by Side - Non UT'
,p_branch_action=>'f?p=&APP_ID.:2511:&SESSION.::&DEBUG.:2511:P2511_PREV_PAGE:2513&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(11201168598856784)
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P2513_MD_TYPE = ''MD_EMAIL_STYLE''',
'and (:P2500_IS_UT_BASED = ''N''',
'    or (:P2513_MEDIA_LIST_EXISTS = ''N'' and :P2500_IS_UT_BASED = ''Y''))'))
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4405944864104845)
,p_branch_name=>'Page 2517 - Side by Side'
,p_branch_action=>'f?p=&APP_ID.:2517:&SESSION.::&DEBUG.:2517::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(11201168598856784)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P2513_MD_TYPE'
,p_branch_condition_text=>'MD_EMAIL_STYLE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(7723854012899610)
,p_branch_name=>'Page 2501 - Page Definition '
,p_branch_action=>'f?p=&APP_ID.:2501:&SESSION.::&DEBUG.::P2501_PREV_PAGE:2513&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(11201168598856784)
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4406434883104850)
,p_name=>'P2513_MEDIA_LIST_EXISTS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(43668086241042907)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11205187240861892)
,p_name=>'P2513_MD_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(43668086241042907)
,p_item_default=>'MD_SINGLE_PG'
,p_prompt=>'Select Master Detail Style'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'WIZ_MD_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(27314867128775183)||'.'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-IconList--CreatePageDialog'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'YES'
,p_attribute_01=>'M'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(11528602845540901)
,p_computation_sequence=>10
,p_computation_item=>'P2513_MEDIA_LIST_EXISTS'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for l_media_list in (',
'        select r.id',
'          from wwv_flow_row_templates r,',
'               wwv_flow_themes t,',
'               wwv_flows f',
'         where r.theme_id = t.theme_id',
'           and r.flow_id = t.flow_id',
'           and r.security_group_id = t.security_group_id',
'           and t.theme_id = f.theme_id',
'           and t.flow_id = f.id',
'           and t.security_group_id = f.security_group_id',
'           and r.security_group_id = :WORKSPACE_ID',
'           and r.flow_id = :FB_FLOW_ID',
'           and t.theme_internal_name = ''UNIVERSAL_THEME''',
'           and r.internal_name = ''MEDIA_LIST'' )',
'    loop',
'        return ''Y'';',
'    end loop;',
'    return ''N'';',
'end;'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4221144739605011)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(11202361361856786)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4221281804605012)
,p_event_id=>wwv_flow_imp.id(4221144739605011)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_02514
begin
wwv_flow_imp_page.create_page(
 p_id=>2514
,p_name=>'Create Page Wizard - Chart Type'
,p_alias=>'CREATE-PAGE-CHART'
,p_page_mode=>'MODAL'
,p_step_title=>'Create &P2500_PAGE_TYPE_DISPLAY.'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(103848364625132731)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_css_classes=>'a-Dialog--CreatePageDialog'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_protection_level=>'C'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(51387106306935249)
,p_plug_name=>'Chart Type'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(77487777719035342)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7720518838894197)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(77487777719035342)
,p_button_name=>'NEXT'
,p_button_static_id=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7720991159894198)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(77487777719035342)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:2500:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7721379020894198)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(77487777719035342)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4801846278096914)
,p_branch_name=>'Page Definition'
,p_branch_action=>'f?p=&APP_ID.:2501:&SESSION.::&DEBUG.::P2501_PREV_PAGE:2514&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(7720518838894197)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7719311586892369)
,p_name=>'P2514_JET_CHART_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(51387106306935249)
,p_item_default=>'bar'
,p_prompt=>'Select Chart Type'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.WIZARD_SELECTION'
,p_named_lov=>'JET_CHART_GALLERY'
,p_lov=>'.'||wwv_flow_imp.id(246508417548358609)||'.'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-IconList--CreatePageDialog'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_attribute_01=>'M'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4801925692096915)
,p_validation_name=>'P2514_JET_CHART_TYPE not null'
,p_validation_sequence=>10
,p_validation=>'P2514_JET_CHART_TYPE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Please select a chart type.'
,p_when_button_pressed=>wwv_flow_imp.id(7720518838894197)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4221374974605013)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(7721379020894198)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4221424468605014)
,p_event_id=>wwv_flow_imp.id(4221374974605013)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_02515
begin
wwv_flow_imp_page.create_page(
 p_id=>2515
,p_name=>'Create Page Wizard - MD - Detail Source'
,p_alias=>'CREATE-PAGE-MD-DETAIL-SOURCE'
,p_page_mode=>'MODAL'
,p_step_title=>'Create &P2500_PAGE_TYPE_DISPLAY.'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(103848364625132731)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_css_classes=>'a-Dialog--CreatePageDialog'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_protection_level=>'C'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(20614237866862192)
,p_plug_name=>'Detail Page Definition'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_plug_display_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_plug_display_when_condition=>'P2513_MD_TYPE'
,p_plug_display_when_cond2=>'MD_TWO_PG:MD_EMAIL_STYLE:'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(37618162532134384)
,p_plug_name=>'Hidden Items'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>200
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'These are the items used in server side processes, for data source section.'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(66779233594533694)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(129203271322461280)
,p_plug_name=>'Detail Data Source'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(38090696240355906)
,p_plug_name=>'Local data source'
,p_parent_plug_id=>wwv_flow_imp.id(129203271322461280)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(38090781654355907)
,p_plug_name=>'REST Data Source'
,p_parent_plug_id=>wwv_flow_imp.id(129203271322461280)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(39881436084963834)
,p_plug_name=>'Remote SQL'
,p_parent_plug_id=>wwv_flow_imp.id(129203271322461280)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8231412845249320)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(66779233594533694)
,p_button_name=>'NEXT'
,p_button_static_id=>'NEXT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8232114405249320)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(66779233594533694)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:2502:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8232545416249321)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(66779233594533694)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(8295094562249363)
,p_branch_name=>'Page 2516 - Detail PK Selection'
,p_branch_action=>'f?p=&APP_ID.:2516:&SESSION.::&DEBUG.:2516::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(8231412845249320)
,p_branch_sequence=>80
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4802940468096925)
,p_name=>'P2515_REGION_TITLE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(129203271322461280)
,p_prompt=>'Detail Region Title'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_display_when=>'P2513_MD_TYPE'
,p_display_when2=>'MD_SINGLE_PG'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4803144837096927)
,p_name=>'P2515_SHOW_RELATED_TABLES'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(38090696240355906)
,p_item_default=>'Y'
,p_prompt=>'Show Only Related Tables'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify whether to restrict the list of detail tables to only those tables related to the master table.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8213085548249299)
,p_name=>'P2515_PAGE_ID'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(20614237866862192)
,p_prompt=>'Page Number'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>5
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The page number is an integer value that identifies a page within an application.'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8213950264249301)
,p_name=>'P2515_PAGE_NAME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(20614237866862192)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify a text name for this page. Same text is also used for the page <em>Title</em>. After page creation, the <em>Title</em> can be modified using Page Designer. '
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8228408828249317)
,p_name=>'P2515_TAB_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(37618162532134384)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8228842160249317)
,p_name=>'P2515_TAB_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(37618162532134384)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8229273459249317)
,p_name=>'P2515_QUERY_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(37618162532134384)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8229605301249318)
,p_name=>'P2515_SQL_SOURCE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(37618162532134384)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8230090501249318)
,p_name=>'P2515_ALL_COLUMNS'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(37618162532134384)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8233235730249321)
,p_name=>'P2515_LOCATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(129203271322461280)
,p_item_default=>'LOCAL'
,p_prompt=>'Data Source'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXEC_LOCATION'
,p_lov=>'.'||wwv_flow_imp.id(3842073961668883)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    This picks the <em>Data Source</em> type for the new APEX component.',
'</p>',
'<ul>',
'    <li><strong>Local Database</strong><br>',
'    Data is sourced from the local database.</li>',
'    <li><strong>REST Enabled SQL Service</strong><br>',
'    Data is sourced from a remote database, where the connection is defined using REST Enabled SQL. To create or maintain REST Enabled SQL references, navigate to Shared Components, REST Enabled SQL.',
'    </li>',
'    <li><strong>REST Data Source</strong><br>',
'    Data is sourced from a RESTful web service defined using REST Data Sources. To create or maintain REST Data Sources, navigate to Shared Components, REST Data Sources.',
'    </li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8234427708249322)
,p_name=>'P2515_SOURCE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(38090696240355906)
,p_item_default=>'P2501_SOURCE_TYPE'
,p_item_default_type=>'ITEM'
,p_prompt=>'Source Type'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZ_SOURCE_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(37501497605557000)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the source of the new page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8235301279249323)
,p_name=>'P2515_TABLE_OWNER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(38090696240355906)
,p_item_default=>'wwv_flow_security.flow_owner( p_flow_id => :FB_FLOW_ID, p_security_group_id => :WORKSPACE_ID )'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Table / View Owner'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_SCHEMAS_HAVE_PRIVS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(owner) d, owner v',
'  from wwv_flow_object_owners_dev',
'order by d                   '))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the owner of the table.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8236243390249324)
,p_name=>'P2515_TABLE_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(38090696240355906)
,p_prompt=>'Table / View Name'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'P2515_TABLE_NAME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if nvl(:P2515_SHOW_RELATED_TABLES,''N'') = ''N'' then',
'    return q''[select object_name_esc d,',
'           object_name r',
'      from wwv_flow_tables_views_dev',
'     where owner                               = :P2515_TABLE_OWNER',
'     order by 1]'';',
'else',
'    return q''[select detail_table_name d,',
'           detail_table_name r',
'      from wwv_flow_detail_tables_dev',
'     where master_owner               = :P2501_TABLE_OWNER',
'       and detail_owner               = :P2515_TABLE_OWNER',
'       and master_table_name          = :P2501_TABLE_NAME',
'       and :P2515_SHOW_RELATED_TABLES = ''Y''',
'    order by 1]''; ',
'end if;'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Value -'
,p_lov_cascade_parent_items=>'P2515_TABLE_OWNER,P2515_SHOW_RELATED_TABLES'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select or enter the table or view on which the region will be based. When entering manually, note that the table name is case sensitive.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8237985112249326)
,p_name=>'P2515_SQL'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(38090696240355906)
,p_prompt=>'Enter a SQL SELECT statement'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>8
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the SQL query that will be used as your region source, for example:',
'<pre>',
'select ename,',
'       job,',
'       sal',
'  from emp',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8239191738249326)
,p_name=>'P2515_WEB_SRC_MODULE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(38090781654355907)
,p_prompt=>'REST Data Source'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APP_WEB_SOURCES_FOR_REPORTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_flow_web_src_modules m',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and exists ( select 1 ',
'                  from wwv_flow_web_src_operations',
'                 where web_src_module_id = m.id',
'                   and database_operation = ''FETCH_COLLECTION'' )',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select REST Data Source.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8240364003249327)
,p_name=>'P2515_REMOTE_SERVER_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(39881436084963834)
,p_prompt=>'REST Enabled SQL Service'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REMOTE_SQL_SERVERS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_remote_servers',
' where server_type = ''REMOTE_SQL''',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select REST Enabled SQL Service.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8241246873249328)
,p_name=>'P2515_REMOTE_SOURCE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(39881436084963834)
,p_item_default=>'TABLE'
,p_prompt=>'Source Type'
,p_source=>'WIZARD_SQL_SOURCE_TYPE'
,p_source_type=>'PREFERENCE'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZ_SOURCE_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(37501497605557000)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the source of the new page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8242165675249328)
,p_name=>'P2515_REMOTE_TABLE_OWNER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(39881436084963834)
,p_prompt=>'Table / View Owner'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value d, column_value r',
'  from table( wwv_flow_remote_server_dev.get_available_objects( :P2515_REMOTE_SERVER_ID, ''SCHEMAS''))',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Current Schema'
,p_lov_cascade_parent_items=>'P2515_REMOTE_SERVER_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the owner of the table.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8243078919249329)
,p_name=>'P2515_REMOTE_TABLE_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(39881436084963834)
,p_prompt=>'Table / View Name'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value d, column_value r',
'  from table( wwv_flow_remote_server_dev.get_available_objects( :P2515_REMOTE_SERVER_ID, ''TABLE'', :P2515_REMOTE_TABLE_OWNER,p_filter=>:p$_search_string ))',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table or View -'
,p_lov_cascade_parent_items=>'P2515_REMOTE_TABLE_OWNER'
,p_ajax_items_to_submit=>'P2515_REMOTE_SERVER_ID'
,p_ajax_optimize_refresh=>'N'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the owner of the table.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8243986263249329)
,p_name=>'P2515_REMOTE_SQL'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(39881436084963834)
,p_prompt=>'Enter a SQL SELECT statement'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>8
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the SQL query that will be used as your region source, for example:',
'<pre>',
'select ename,',
'       job,',
'       sal',
'  from emp',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_05=>'P2515_REMOTE_SERVER_ID'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(4703043792957426)
,p_computation_sequence=>10
,p_computation_item=>'P2515_PAGE_ID'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_utilities.minimum_free_page(:FB_FLOW_ID,1)'
,p_compute_when=>'P2515_PAGE_ID'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(8253906407249339)
,p_validation_name=>'Page Number does not exists'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_steps',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and id                = :P2515_PAGE_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Page already exists, please enter different page number.'
,p_validation_condition=>'P2513_MD_TYPE'
,p_validation_condition2=>'MD_TWO_PG:MD_EMAIL_STYLE:'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_when_button_pressed=>wwv_flow_imp.id(8231412845249320)
,p_associated_item=>wwv_flow_imp.id(8213085548249299)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(8254346437249340)
,p_validation_name=>'Page Number not decimal or negative'
,p_validation_sequence=>30
,p_validation=>'trunc(abs(:P2515_PAGE_ID)) = :P2515_PAGE_ID'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Page Number must be a positive, whole number.'
,p_validation_condition=>'P2513_MD_TYPE'
,p_validation_condition2=>'MD_TWO_PG:MD_EMAIL_STYLE:'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_when_button_pressed=>wwv_flow_imp.id(8231412845249320)
,p_associated_item=>wwv_flow_imp.id(8213085548249299)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(8256361507249341)
,p_validation_name=>'Local SQL Not Null'
,p_validation_sequence=>50
,p_validation=>'P2515_SQL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'SQL query must be specified.'
,p_validation_condition=>':P2515_SOURCE_TYPE = ''SQL'' and :P2515_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(8237985112249326)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(8255190871249340)
,p_validation_name=>'Local - Is Valid SQL query'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_describe_result wwv_flow_exec_dev.t_describe_result;',
'begin',
'    if :P2515_LOCATION = wwv_flow_exec_api.c_location_local_db then',
'        l_describe_result := wwv_flow_exec_dev.check_and_describe (',
'                                p_location             => wwv_flow_exec_api.c_location_local_db,',
'                                p_query_type           => wwv_flow_exec_api.c_query_type_sql_query,',
'                                p_sql_query            => :P2515_SQL );',
'    end if;',
'    return l_describe_result.error_message;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P2515_SOURCE_TYPE = ''SQL''',
'and :P2515_LOCATION = ''LOCAL''',
'and :P2515_SQL is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(8237985112249326)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(8255955307249341)
,p_validation_name=>'Local - P2515_TABLE_OWNER is not null'
,p_validation_sequence=>70
,p_validation=>'P2515_TABLE_OWNER'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Table owner must be specified.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P2515_SOURCE_TYPE = ''TABLE''',
'and :P2515_LOCATION = ''LOCAL'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(8235301279249323)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(8252327915249338)
,p_validation_name=>'Local - P2515_TABLE_NAME is not null'
,p_validation_sequence=>80
,p_validation=>'P2515_TABLE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P2515_SOURCE_TYPE = ''TABLE''',
'and :P2515_LOCATION = ''LOCAL'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(8236243390249324)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(8257112573249342)
,p_validation_name=>'Local - Table Exists'
,p_validation_sequence=>120
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_tables_views_dev',
' where object_name = :P2515_TABLE_NAME',
'   and owner       = :P2515_TABLE_OWNER'))
,p_validation_type=>'EXISTS'
,p_error_message=>'Table &P2515_TABLE_NAME!HTML. does not exist. Note that the table name is case-sensitive.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P2515_SOURCE_TYPE = ''TABLE''',
'and :P2515_LOCATION = ''LOCAL''',
'and :P2515_TABLE_NAME is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(8236243390249324)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4618585298884798)
,p_validation_name=>'P2515_REMOTE_SERVER_ID not null'
,p_validation_sequence=>200
,p_validation=>'P2515_REMOTE_SERVER_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>':P2515_LOCATION = ''REMOTE'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(8240364003249327)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4618869694886842)
,p_validation_name=>'P2515_REMOTE_TABLE_NAME not null'
,p_validation_sequence=>210
,p_validation=>'P2515_REMOTE_TABLE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P2515_REMOTE_SOURCE_TYPE = ''TABLE''',
'and :P2515_LOCATION = ''REMOTE''',
'and :P2515_REMOTE_SERVER_ID is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(8243078919249329)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(8254775530249340)
,p_validation_name=>'Remote SQL Not Null'
,p_validation_sequence=>230
,p_validation=>'P2515_REMOTE_SQL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'SQL query must be specified.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P2515_REMOTE_SOURCE_TYPE = ''SQL''',
'and :P2515_LOCATION = ''REMOTE'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(8243986263249329)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(8255574173249340)
,p_validation_name=>'Remote - Is Valid SQL query'
,p_validation_sequence=>240
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_describe_result wwv_flow_exec_dev.t_describe_result;',
'begin',
'    if :P2515_LOCATION =  wwv_flow_exec_api.c_location_remote_db then',
'        l_describe_result := wwv_flow_exec_dev.check_and_describe (',
'                                p_location             => wwv_flow_exec_api.c_location_remote_db,',
'                                p_remote_server_id     => :P2515_REMOTE_SERVER_ID,',
'                                p_query_type           => wwv_flow_exec_api.c_query_type_sql_query,',
'                                p_sql_query            => :P2515_REMOTE_SQL );',
'    end if;',
'    return l_describe_result.error_message;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P2515_REMOTE_SOURCE_TYPE = ''SQL''',
'and :P2515_LOCATION = ''REMOTE''',
'and :P2515_REMOTE_SQL is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(8243986263249329)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4619131767888883)
,p_validation_name=>'P2515_WEB_SRC_MODULE_ID not null'
,p_validation_sequence=>250
,p_validation=>'P2515_WEB_SRC_MODULE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>':P2515_LOCATION = ''WEB_SOURCE'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(8239191738249326)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(8284522939249358)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(8232545416249321)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8285056080249358)
,p_event_id=>wwv_flow_imp.id(8284522939249358)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(8293550090249362)
,p_name=>'Location "LOCAL"'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2515_LOCATION'
,p_condition_element=>'P2515_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'LOCAL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8294063137249362)
,p_event_id=>wwv_flow_imp.id(8293550090249362)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(38090696240355906)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8294569030249362)
,p_event_id=>wwv_flow_imp.id(8293550090249362)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(38090696240355906)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(8261428468249346)
,p_name=>'Location "REMOTE"'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2515_LOCATION'
,p_condition_element=>'P2515_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REMOTE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8261969177249347)
,p_event_id=>wwv_flow_imp.id(8261428468249346)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(39881436084963834)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8262477118249347)
,p_event_id=>wwv_flow_imp.id(8261428468249346)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(39881436084963834)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(8262859701249347)
,p_name=>'Location "WEB_SOURCE"'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2515_LOCATION'
,p_condition_element=>'P2515_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'WEB_SOURCE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8263328941249348)
,p_event_id=>wwv_flow_imp.id(8262859701249347)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(38090781654355907)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8263847698249348)
,p_event_id=>wwv_flow_imp.id(8262859701249347)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(38090781654355907)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(8264276888249348)
,p_name=>'Show/Hide Table/Query Items - Local'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2515_SOURCE_TYPE'
,p_condition_element=>'P2515_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TABLE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8264702836249349)
,p_event_id=>wwv_flow_imp.id(8264276888249348)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2515_TABLE_OWNER,P2515_TABLE_NAME,P2515_SHOW_RELATED_TABLES'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8265222580249349)
,p_event_id=>wwv_flow_imp.id(8264276888249348)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2515_SQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8265725584249349)
,p_event_id=>wwv_flow_imp.id(8264276888249348)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2515_TABLE_OWNER,P2515_TABLE_NAME,P2515_SHOW_RELATED_TABLES'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8266228499249349)
,p_event_id=>wwv_flow_imp.id(8264276888249348)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2515_SQL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(8266600331249350)
,p_name=>'Show/Hide Data Source Items'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2515_REMOTE_SERVER_ID'
,p_condition_element=>'P2515_REMOTE_SERVER_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8267152529249350)
,p_event_id=>wwv_flow_imp.id(8266600331249350)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2515_REMOTE_SOURCE_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'TABLE'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8267671643249350)
,p_event_id=>wwv_flow_imp.id(8266600331249350)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2515_REMOTE_SOURCE_TYPE,P2515_REMOTE_SQL,P2515_REMOTE_TABLE_OWNER,P2515_REMOTE_TABLE_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8268146617249350)
,p_event_id=>wwv_flow_imp.id(8266600331249350)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2515_REMOTE_TABLE_OWNER,P2515_REMOTE_TABLE_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4804087378096936)
,p_event_id=>wwv_flow_imp.id(8266600331249350)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2515_REMOTE_SOURCE_TYPE'
,p_server_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_server_condition_expr1=>'P2500_PAGE_TYPE'
,p_server_condition_expr2=>'MD'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(8268557825249350)
,p_name=>'Show/Hide Table/Query Items - Remote'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2515_REMOTE_SOURCE_TYPE'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'apex.item("P2515_REMOTE_SERVER_ID").getValue() !== "" && apex.item("P2515_REMOTE_SOURCE_TYPE").getValue() == "TABLE" '
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8269039953249351)
,p_event_id=>wwv_flow_imp.id(8268557825249350)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2515_REMOTE_TABLE_OWNER,P2515_REMOTE_TABLE_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8269571137249351)
,p_event_id=>wwv_flow_imp.id(8268557825249350)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2515_REMOTE_SQL'
,p_client_condition_type=>'NOT_NULL'
,p_client_condition_element=>'P2515_REMOTE_SERVER_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8270059402249351)
,p_event_id=>wwv_flow_imp.id(8268557825249350)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2515_REMOTE_TABLE_OWNER,P2515_REMOTE_TABLE_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8270570814249351)
,p_event_id=>wwv_flow_imp.id(8268557825249350)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2515_REMOTE_SQL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(8278859791249355)
,p_name=>'Submit NEXT and show progress'
,p_event_sequence=>180
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(8231412845249320)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8279366728249356)
,p_event_id=>wwv_flow_imp.id(8278859791249355)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'NEXT'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(8283677350249357)
,p_name=>'Focus P2515_PAGE_NAME'
,p_event_sequence=>200
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_display_when_cond=>'P2513_MD_TYPE'
,p_display_when_cond2=>'MD_TWO_PG:MD_EMAIL_STYLE:'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8284106872249357)
,p_event_id=>wwv_flow_imp.id(8283677350249357)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2515_PAGE_NAME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4803527769096931)
,p_name=>'Hide Show Related Tables'
,p_event_sequence=>210
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_display_when_cond=>'P2501_LOCATION'
,p_display_when_cond2=>'LOCAL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4803644257096932)
,p_event_id=>wwv_flow_imp.id(4803527769096931)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2515_SHOW_RELATED_TABLES'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4803762849096933)
,p_event_id=>wwv_flow_imp.id(4803527769096931)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2515_SHOW_RELATED_TABLES'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4803825041096934)
,p_name=>'Hide P2515_SOURCE_TYPE for MD'
,p_event_sequence=>220
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_cond=>'P2500_PAGE_TYPE'
,p_display_when_cond2=>'MD'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4803941684096935)
,p_event_id=>wwv_flow_imp.id(4803825041096934)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2515_SOURCE_TYPE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4220362780605003)
,p_name=>'Validation Error - Scroll to Top'
,p_event_sequence=>230
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4220430313605004)
,p_event_id=>wwv_flow_imp.id(4220362780605003)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.message.setThemeHooks( { pageErrorsContainerSelector: ".a-Alert--horizontal" } );'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4663588459677276)
,p_process_sequence=>5
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update APEX Dictionary Cache'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_object_type wwv_flow_tables_views_dev.object_type%type;',
'begin',
'    select object_type',
'      into l_object_type',
'      from wwv_flow_tables_views_dev',
'     where owner       = :P2515_TABLE_OWNER',
'       and object_name = :P2515_TABLE_NAME;',
'',
'    --- if table, set APEX dictionary cache',
'    if l_object_type = ''TABLE'' then',
'        wwv_dictionary_cache_dev.set_dictionary_table_cache(',
'             p_workspace_name          => htmldb_util.find_workspace( p_security_group_id => :WORKSPACE_ID ),',
'             p_schema                  => :P2515_TABLE_OWNER,',
'             p_table_name              => :P2515_TABLE_NAME,',
'             p_flow_id                 => :FB_FLOW_ID,',
'             p_cache_fk_references     => true );',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(8231412845249320)
,p_process_when=>':P2515_LOCATION = ''LOCAL'' and :P2515_SOURCE_TYPE = ''TABLE'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>4663588459677276
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(8260290820249344)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Data Source Items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- reset previous values, if any',
':P2515_TAB_OWNER := null;',
':P2515_TAB_NAME := null;',
':P2515_QUERY_TYPE := null;',
':P2515_SQL_SOURCE := null;',
'',
'if :P2515_LOCATION = wwv_flow_exec_api.c_location_local_db then',
'    :P2515_TAB_OWNER        := :P2515_TABLE_OWNER;',
'    :P2515_TAB_NAME         := :P2515_TABLE_NAME;',
'    :P2515_QUERY_TYPE       := :P2515_SOURCE_TYPE;',
'    :P2515_SQL_SOURCE       := :P2515_SQL;',
'elsif :P2515_LOCATION = wwv_flow_exec_api.c_location_remote_db then',
'    :P2515_TAB_OWNER        := :P2515_REMOTE_TABLE_OWNER;',
'    :P2515_TAB_NAME         := :P2515_REMOTE_TABLE_NAME;',
'    :P2515_QUERY_TYPE       := :P2515_REMOTE_SOURCE_TYPE;',
'    :P2515_SQL_SOURCE       := :P2515_REMOTE_SQL;',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(8231412845249320)
,p_internal_uid=>8260290820249344
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(8257839734249342)
,p_process_sequence=>100
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load Columns to Collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.create_column_collection (',
'    p_collection_name        => ''WIZ_COLUMNS_LIST_MD'',',
'    p_location               => :P2515_LOCATION,',
'    p_query_type             => :P2515_QUERY_TYPE,',
'    p_owner                  => :P2515_TAB_OWNER,',
'    p_table_name             => :P2515_TAB_NAME,',
'    p_sql_query              => :P2515_SQL_SOURCE,',
'    p_web_src_module_id      => :P2515_WEB_SRC_MODULE_ID,',
'    p_remote_server_id       => :P2515_REMOTE_SERVER_ID,',
'    p_extended_describe      => true );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(8231412845249320)
,p_internal_uid=>8257839734249342
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(7801477639516785)
,p_process_sequence=>110
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set P2515_ALL_COLUMNS'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_arr wwv_flow_t_varchar2;',
'begin',
'    select c002',
'      bulk collect into l_arr',
'      from wwv_flow_collections',
'     where collection_name = ''WIZ_COLUMNS_LIST_MD''',
'     order by seq_id;',
'',
'    :P2515_ALL_COLUMNS := wwv_flow_string.join(l_arr,'':'');',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(8231412845249320)
,p_internal_uid=>7801477639516785
);
end;
/
prompt --application/pages/page_02516
begin
wwv_flow_imp_page.create_page(
 p_id=>2516
,p_name=>'Create Page Wizard - MD - Primary Key'
,p_alias=>'CREATE-PAGE-MD-PRIMARY-KEY'
,p_page_mode=>'MODAL'
,p_step_title=>'Create &P2500_PAGE_TYPE_DISPLAY.'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(103848364625132731)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_css_classes=>'a-Dialog--CreatePageDialog'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_protection_level=>'C'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4804179944096937)
,p_plug_name=>'Master - Detail Relationship'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(77694982224200830)
,p_plug_name=>'Detail  Primary Key '
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(106863931456712657)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8092801685127316)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(106863931456712657)
,p_button_name=>'CREATE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Page'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8093254086127316)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(106863931456712657)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:2515:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8093680506127317)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(106863931456712657)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4804252666096938)
,p_name=>'P2516_DETAIL_FK_CONS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(4804179944096937)
,p_prompt=>'Master Detail Foreign Key'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with cc as (',
'    select /*+materialize*/',
'           cc.owner,',
'           cc.constraint_name,',
'           cc.table_name,',
'           cc.column_name,',
'           cc.position',
'      from sys.dba_cons_columns cc',
'     where cc.owner      = :P2501_TAB_OWNER',
'     -- 2501 is master items',
'     -- 2521 is detail items',
'       and cc.table_name in ( :P2501_TAB_NAME, :P2515_TAB_NAME ) ),',
'cons_cols as (',
'    select cc.owner,',
'           cc.constraint_name,',
'           cc.table_name,',
'           cc.column_name,',
'           cc.position,',
'           c.constraint_type,',
'           c.r_owner,',
'           c.r_constraint_name',
'      from cc,',
'           sys.dba_constraints  c',
'     where cc.owner           =  c.owner',
'       and cc.constraint_name =  c.constraint_name',
'       and c.constraint_type  in (''R'', ''P'', ''U'') )',
'select LISTAGG(parent.column_name, '', '') WITHIN GROUP (ORDER BY parent.position)||',
'       '' -> ''||',
'       LISTAGG(child.column_name, '', '')  WITHIN GROUP (ORDER BY child.position)  d,',
'       child.constraint_name r',
'    from cons_cols child,cons_cols parent',
'    where child.constraint_type  =  ''R''',
'    and parent.constraint_type  in (''P'',''U'')',
'    and child.r_constraint_name =  parent.constraint_name',
'    and child.r_owner           =  parent.owner',
'    and child.position          =  parent.position',
'    and parent.table_name       =  :P2501_TAB_NAME',
'group by child.constraint_name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Master Detail Relationship -'
,p_cHeight=>1
,p_display_when=>':P2515_SHOW_RELATED_TABLES = ''Y'' and :P2515_LOCATION = ''LOCAL'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the foreign key that relates between the master and detail tables.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4804339191096939)
,p_name=>'P2516_MASTER_COL'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(4804179944096937)
,p_item_default=>'P2502_PK_COLUMN_1'
,p_item_default_type=>'ITEM'
,p_prompt=>'Master Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WIZ_COLUMNS_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 column_name_esc,',
'       c002 column_name',
'  from wwv_flow_collections',
' where collection_name = ''WIZ_COLUMNS_LIST''',
' order by seq_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_display_when=>'not (:P2515_SHOW_RELATED_TABLES = ''Y'' and :P2515_LOCATION = ''LOCAL'')'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_read_only_when=>'P2513_MD_TYPE'
,p_read_only_when2=>'MD_EMAIL_STYLE'
,p_read_only_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the primary key column from the master table or view that corresponds with the detail column.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4804489319096940)
,p_name=>'P2516_DETAIL_COL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(4804179944096937)
,p_item_default=>'P2502_PK_COLUMN_1'
,p_item_default_type=>'ITEM'
,p_prompt=>'Detail Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 column_name_esc,',
'       c002 column_name',
'  from wwv_flow_collections',
' where collection_name = ''WIZ_COLUMNS_LIST_MD''',
' order by seq_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_display_when=>'not (:P2515_SHOW_RELATED_TABLES = ''Y'' and :P2515_LOCATION = ''LOCAL'')'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the column from the detail table, view or REST Data Source that corresponds with the master column.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8090726276127315)
,p_name=>'P2516_PK_COLUMN_1'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(77694982224200830)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name ',
'from (',
'select c002 column_name',
'  from wwv_flow_collections ',
' where collection_name = ''WIZ_COLUMNS_LIST_MD''',
'   and c004 = ''Y''',
' order by seq_id )',
' where rownum = 1'))
,p_item_default_type=>'SQL_QUERY'
,p_prompt=>'Primary Key Column 1'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 column_name_esc,',
'       c002 column_name',
'  from wwv_flow_collections ',
' where collection_name = ''WIZ_COLUMNS_LIST_MD''',
' order by seq_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select primary key column.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8091678607127315)
,p_name=>'P2516_PK_COLUMN_2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(77694982224200830)
,p_prompt=>'Primary Key Column 2'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 column_name_esc,',
'       c002 column_name',
'  from wwv_flow_collections ',
' where collection_name = ''WIZ_COLUMNS_LIST_MD''',
'   and c002 != :P2516_PK_COLUMN_1',
' order by seq_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_lov_cascade_parent_items=>'P2516_PK_COLUMN_1'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>':P2515_LOCATION in ( wwv_flow_exec_api.c_location_local_db, wwv_flow_exec_api.c_location_remote_db )'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select primary key column.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(8094496878127321)
,p_validation_name=>'At least one PK column selected'
,p_validation_sequence=>10
,p_validation=>'P2516_PK_COLUMN_1'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'At least one Primary Key Column must be chosen.'
,p_when_button_pressed=>wwv_flow_imp.id(8092801685127316)
,p_associated_item=>wwv_flow_imp.id(8090726276127315)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4804643629096942)
,p_validation_name=>'P2516_DETAIL_FK_CONS not null'
,p_validation_sequence=>20
,p_validation=>'P2516_DETAIL_FK_CONS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>':P2515_SHOW_RELATED_TABLES = ''Y'' and :P2515_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(8092801685127316)
,p_associated_item=>wwv_flow_imp.id(4804252666096938)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4804704393096943)
,p_validation_name=>'P2516_MASTER_COL not null'
,p_validation_sequence=>30
,p_validation=>'P2516_MASTER_COL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'not (:P2515_SHOW_RELATED_TABLES = ''Y'' and :P2515_LOCATION = ''LOCAL'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(8092801685127316)
,p_associated_item=>wwv_flow_imp.id(4804339191096939)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4804808253096944)
,p_validation_name=>'P2516_DETAIL_COL not null'
,p_validation_sequence=>40
,p_validation=>'P2516_DETAIL_COL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'not (:P2515_SHOW_RELATED_TABLES = ''Y'' and :P2515_LOCATION = ''LOCAL'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(8092801685127316)
,p_associated_item=>wwv_flow_imp.id(4804489319096940)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(8098913092127328)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(8093680506127317)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8099443565127328)
,p_event_id=>wwv_flow_imp.id(8098913092127328)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4802781368096923)
,p_name=>'Submit CREATE and show progress'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(8092801685127316)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4802875901096924)
,p_event_id=>wwv_flow_imp.id(4802781368096923)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'CREATE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4233097338947745)
,p_name=>'Validation Error - Scroll to Top'
,p_event_sequence=>40
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4233478371947745)
,p_event_id=>wwv_flow_imp.id(4233097338947745)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.message.setThemeHooks( { pageErrorsContainerSelector: ".a-Alert--horizontal" } );'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4804520289096941)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create MD Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_master  wwv_flow_wizard_api.t_md;',
'    l_detail  wwv_flow_wizard_api.t_md;',
'    l_details wwv_flow_wizard_api.t_mds;',
'begin',
'    l_master.location             := :P2501_LOCATION;',
'    l_master.owner                := :P2501_TAB_OWNER;',
'    l_master.table_name           := :P2501_TAB_NAME;',
'    l_master.cols                 := :P2501_ALL_COLUMNS;',
'    l_master.pk_col               := :P2502_PK_COLUMN_1;',
'    l_master.pk_col2              := :P2502_PK_COLUMN_2;',
'    l_master.navigation_order_col := :P2502_MASTER_NAV_ORDER;',
'    l_master.primary_label_col    := :P2502_MASTER_DISP_COL1;',
'    l_master.secondary_label_col  := :P2502_MASTER_DISP_COL2;',
'    l_master.remote_server_id     := :P2501_REMOTE_SERVER_ID;',
'    l_master.web_src_module_id    := :P2501_WEB_SRC_MODULE_ID;',
'',
'',
'    l_detail.location             := :P2515_LOCATION;',
'    l_detail.owner                := :P2515_TAB_OWNER;',
'    l_detail.table_name           := :P2515_TAB_NAME;',
'    l_detail.cols                 := :P2515_ALL_COLUMNS;',
'    l_detail.pk_col               := :P2516_PK_COLUMN_1;',
'    l_detail.pk_col2              := :P2516_PK_COLUMN_2;',
'    l_detail.fk_con               := :P2516_DETAIL_FK_CONS;',
'    l_detail.master_col           := :P2516_MASTER_COL;',
'    l_detail.detail_col           := :P2516_DETAIL_COL;',
'    l_detail.remote_server_id     := :P2515_REMOTE_SERVER_ID;',
'    l_detail.web_src_module_id    := :P2515_WEB_SRC_MODULE_ID;',
'',
'',
'    if :P2513_MD_TYPE = ''MD_SINGLE_PG'' then',
'    -- Stacked',
'        l_master.region_title := :P2501_PAGE_NAME;',
'        l_detail.region_title := :P2515_REGION_TITLE;',
'        wwv_flow_wizard_api.create_md_single_page (',
'            p_application_id           => :FB_FLOW_ID,',
'            p_page_id                  => :P2501_PAGE_ID,',
'            p_page_name                => :P2501_PAGE_NAME,',
'            p_page_mode                => :P2501_PAGE_MODE,',
'            --',
'            p_nav_list_id              => :P2500_NAVLIST_ID,',
'            p_nav_list_parent_item_id  => :P2501_NAVLIST_PARENT_ID,',
'            p_nav_list_child_item_name => case when :P2501_NAVLIST_OPTIONS = ''NEW'' then :P2501_PAGE_NAME end,',
'            p_nav_list_item_icon        => :P2501_PAGE_ICON,',
'            --',
'            p_breadcrumb_id            => :P2501_BREADCRUMB_ID,',
'            p_breadcrumb_name          => :P2501_PAGE_NAME,',
'            p_parent_bc_id             => :P2501_BREADCRUMB_PARENT_ID,',
'            --',
'            p_master_region            => l_master,',
'            p_detail_region            => l_detail  );',
'',
'        :FB_FLOW_PAGE_ID       := :P2501_PAGE_ID;',
'        :F4000_RUN_EDIT_PAGE   := :P2501_PAGE_ID;',
'    elsif :P2513_MD_TYPE = ''MD_EMAIL_STYLE'' then',
'    -- Side by Side',
'        l_master.page_id := wwv_flow_utilities.minimum_free_page( p_flow_id => :FB_FLOW_ID, p_start_page => :P2501_PAGE_ID );',
'        l_detail.page_id := wwv_flow_utilities.minimum_free_page( p_flow_id => :FB_FLOW_ID, p_start_page => :P2515_PAGE_ID );',
'',
'        l_master.singular_name := :P2501_PAGE_NAME;',
'        l_master.plural_name   := :P2501_PAGE_NAME;',
'        l_detail.singular_name := :P2515_PAGE_NAME;',
'        l_detail.plural_name   := :P2515_PAGE_NAME;',
'',
'        l_details( 1 ) := l_detail;',
'',
'        wwv_flow_wizard_api.create_md_side_by_side (',
'            p_app_id                   => :FB_FLOW_ID,',
'            --',
'            p_md_page_id               => :P2501_PAGE_ID,',
'            p_md_page_name             => :P2501_PAGE_NAME,',
'            p_md_page_mode             => wwv_flow_page.c_page_mode_normal,',
'            --',
'            p_table_owner              => l_master.owner,',
'            p_master                   => l_master,',
'            p_details                  => l_details,',
'            --',
'            p_nav_list_id              => :P2500_NAVLIST_ID,',
'            p_nav_list_parent_item_id  => :P2501_NAVLIST_PARENT_ID,',
'            p_nav_list_child_item_name => case when :P2501_NAVLIST_OPTIONS = ''NEW'' then :P2501_PAGE_NAME end,',
'            p_nav_list_item_icon       => :P2501_PAGE_ICON,',
'            --',
'            p_breadcrumb_id            => :P2501_BREADCRUMB_ID,',
'            p_breadcrumb_name          => :P2501_PAGE_NAME,',
'            p_parent_bc_id             => :P2501_BREADCRUMB_PARENT_ID );',
'',
'        :FB_FLOW_PAGE_ID       := :P2501_PAGE_ID;',
'        :F4000_RUN_EDIT_PAGE   := :P2501_PAGE_ID;',
'    elsif :P2513_MD_TYPE = ''MD_TWO_PG'' then',
'    -- Drill Down',
'        l_master.page_id              := :P2501_PAGE_ID;',
'        l_master.page_name            := :P2501_PAGE_NAME;',
'        l_master.breadcrumb_name      := :P2501_PAGE_NAME;',
'        l_master.region_title         := :P2501_PAGE_NAME;',
'        l_master.navigation_order_col := :P2502_MASTER_NAV_ORDER;',
'',
'        l_detail.page_id              := :P2515_PAGE_ID;',
'        l_detail.page_name            := :P2515_PAGE_NAME;',
'        l_detail.page_mode            := wwv_flow_page.c_page_mode_normal;',
'        l_detail.breadcrumb_name      := :P2515_PAGE_NAME;',
'        l_detail.region_title         := :P2515_PAGE_NAME;',
'',
'        wwv_flow_wizard_api.create_md_two_page (',
'            p_application_id            => :FB_FLOW_ID,',
'            --',
'            p_nav_list_id               => :P2500_NAVLIST_ID,',
'            p_nav_list_parent_item_id   => :P2501_NAVLIST_PARENT_ID,',
'            p_nav_list_child_item_name  => case when :P2501_NAVLIST_OPTIONS = ''NEW'' then :P2501_PAGE_NAME end,',
'            p_nav_list_item_icon        => :P2501_PAGE_ICON,',
'            --',
'            p_breadcrumb_id             => :P2501_BREADCRUMB_ID,',
'            p_parent_bc_id              => :P2501_BREADCRUMB_PARENT_ID,',
'            --',
'            p_master                    => l_master,',
'            p_detail                    => l_detail );',
'',
'        :FB_FLOW_PAGE_ID       := :P2501_PAGE_ID;',
'        :F4000_RUN_EDIT_PAGE   := :P2501_PAGE_ID;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to create the Master Detail page. #SQLERRM#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(8092801685127316)
,p_internal_uid=>4804520289096941
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4608860712691704)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog - MD Drill Down'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,REQUEST'
,p_attribute_02=>'N'
,p_process_error_message=>'Error creating &P2500_PAGE_TYPE_DISPLAY. page.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(8092801685127316)
,p_process_when=>'P2513_MD_TYPE'
,p_process_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_process_when2=>'MD_TWO_PG:MD_EMAIL_STYLE:'
,p_process_success_message=>'&P2500_PAGE_TYPE_DISPLAY. page created.'
,p_internal_uid=>4608860712691704
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(8096771477127325)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,REQUEST'
,p_attribute_02=>'N'
,p_process_error_message=>'Error creating &P2500_PAGE_TYPE_DISPLAY. page.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(8092801685127316)
,p_process_success_message=>'&P2500_PAGE_TYPE_DISPLAY. page created.'
,p_internal_uid=>8096771477127325
);
end;
/
prompt --application/pages/page_02517
begin
wwv_flow_imp_page.create_page(
 p_id=>2517
,p_name=>'Create Page Wizard - MD - Side by Side'
,p_alias=>'CREATE-PAGE-MD-SIDE'
,p_page_mode=>'MODAL'
,p_step_title=>'Create &P2500_PAGE_TYPE_DISPLAY.'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(103848364625132731)
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// reposition icon picker',
'apex.jQuery("#P2517_PAGE_ICON").after(apex.jQuery("button#icon_picker"));'))
,p_css_file_urls=>'#FONT_APEX_LATEST_DIRECTORY#css/font-apex#MIN#.css'
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_css_classes=>'a-Dialog--CreatePageDialog'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_protection_level=>'C'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17859219483967012)
,p_plug_name=>'Page Definition'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17859878298967019)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#:is-expanded'
,p_plug_template=>wwv_flow_imp.id(689970285456172024)
,p_plug_display_sequence=>100
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17862423852967044)
,p_plug_name=>'Navigation List'
,p_parent_plug_id=>wwv_flow_imp.id(17859878298967019)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P2500_NAVIGATION_TYPE'
,p_plug_display_when_cond2=>'L'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17862475378967045)
,p_plug_name=>'Breadcrumb'
,p_parent_plug_id=>wwv_flow_imp.id(17859878298967019)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID )'))
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17862575277967046)
,p_plug_name=>'Message for Tabs Navigation'
,p_parent_plug_id=>wwv_flow_imp.id(17859878298967019)
,p_region_css_classes=>'a-Alert--dialog'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>10
,p_plug_source=>'htp.p(wwv_flow_lang_dev.builder_message(''WIZARD.TAB_NAVIGATION_MSG''));'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P2500_NAVIGATION_TYPE'
,p_plug_display_when_cond2=>'T'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(64024215211638514)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5469724960354164)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(17862423852967044)
,p_button_name=>'ICON'
,p_button_static_id=>'icon_picker'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Select Icon'
,p_button_redirect_url=>'f?p=&APP_ID.:181:&SESSION.::&DEBUG.::P181_PASS_BACK_TO_UI,P181_PASS_BACK_TO_SAVE:icon_picker,P2517_PAGE_ICON'
,p_button_css_classes=>'a-Button--colorPicker'
,p_icon_css_classes=>'fa &P2517_PAGE_ICON.'
,p_grid_new_row=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5481363941354193)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(64024215211638514)
,p_button_name=>'NEXT'
,p_button_static_id=>'NEXT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>':P2500_PAGE_TYPE in (''INTERACTIVE'',''GRID'',''CLASSIC'',''FORM'',''CARD'',''FACETED_SEARCH'',''SMART_FILTERS'',''CHART'',''MAP'',''FORMONPROC'',''TREE'',''CALENDAR'',''MD'')'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5482182839354194)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(64024215211638514)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:2513:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5482530137354195)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(64024215211638514)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(5544218956354273)
,p_branch_name=>'Page 2518 - MD Stacked Data Source'
,p_branch_action=>'f?p=&APP_ID.:2518:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(5481363941354193)
,p_branch_sequence=>80
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5461358939354130)
,p_name=>'P2517_PAGE_ID'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(17859219483967012)
,p_prompt=>'Starting Page Number'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>5
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter an unused starting page number.  This wizard will create multiple pages starting with the number specified.</p>',
'<p>The default is the first available page number within this application.</p>'))
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5462224156354132)
,p_name=>'P2517_PAGE_NAME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(17859219483967012)
,p_prompt=>'Master Detail Page Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the name of the master detail page which contains side by side master detail regions.  The left side contains master list to navigate to different master record.  The right side contains selected master record and associated detail report.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5470102303354165)
,p_name=>'P2517_USE_NAVLIST'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(17862423852967044)
,p_item_default=>'case when :P2500_IS_NAVLIST_SUBSCRIBED = ''Y'' then ''N'' else ''Y'' end'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Use Navigation'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Set this flag to <strong>On</strong>, if you want to use navigation for this page.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5470900629354167)
,p_name=>'P2517_NAVLIST_OPTIONS'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(17862423852967044)
,p_item_default=>'NEW'
,p_prompt=>'Navigation Preference'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WIZARD.NAVILIST.OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(25100593691198570)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select how you want this page integrated into the Navigation Menu.<p/>',
'<ul>',
'    <li><strong>Create a new entry</strong> - Users will be able to navigate to the new page directly from the Navigation Menu. The new entry can be placed anywhere in the existing hierarchy. By default, page name will be used as list entry name.</li'
||'>',
'    <li><strong>Map to an existing entry</strong> - Use this option when you want the new page to highlight an existing, top level, menu entry. Users will not be able to navigate to the new page directly from the Navigation Menu. Therefore, You will '
||'need to create or define a navigation control on the top level page selected, such as a button, or link in a report, to go to this new page.</li>',
'</ul>'))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5471814688354168)
,p_name=>'P2517_PARENT_LIST_ITEM_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(17862423852967044)
,p_prompt=>'Parent Navigation Menu Entry'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'NAVLIST_ENTRIES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case',
'           when (nvl(list_item_link_target,''0'')=''0'' or parent_list_item_id is',
'null) then',
'               lpad('' '',(4*(level-1)),''.'')||list_item_link_text',
'           else',
'               lpad('' '',(4*(level-1)),''.'')||'' (''||list_item_link_text ||'')''',
'       end name,',
'       id',
'  from wwv_flow_list_items',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and sub_list_id is null',
' start with list_id = :P2500_NAVLIST_ID and parent_list_item_id is null',
'connect by prior list_id = list_id and prior id = parent_list_item_id',
' order siblings by list_item_display_sequence'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No parent selected -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the parent for this list entry. '
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5472264364354169)
,p_name=>'P2517_PAGE_ICON'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(17862423852967044)
,p_item_default=>'P2500_UT_NAV_ICON'
,p_item_default_type=>'ITEM'
,p_prompt=>'Icon'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'a-Property-fieldContainer--colorPicker'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Identify a icon class for the icon associated with this list entry.',
'<br><br>',
'<strong>Using Universal Theme</strong>',
'<br>',
'Most Universal Theme apps use the Font APEX icon library. To pick an icon, use the built-in icon picker and select an icon from the popup window. See examples below:<br><br>',
'<ul>',
'    <li><code>fa-cloud</code> - displays the cloud icon</li>',
'    <li><code>fa-exclamation-circle u-danger-text</code> - displays a red exclamation icon</li>',
'</ul>',
'<br>',
'You can see more examples on the  <a rel="noopener noreferrer" href="https://apex.oracle.com/fontapex" target="_blank">Icons</a> page of the <a rel="noopener noreferrer" href="https://apex.oracle.com/ut" target="_blank">Universal Theme sample app</a>'
||'.'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5473180900354170)
,p_name=>'P2517_EXISTING_LIST_ITEM_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(17862423852967044)
,p_prompt=>'Existing Navigation Menu Entry'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'NAVLIST_ENTRIES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case',
'           when (nvl(list_item_link_target,''0'')=''0'' or parent_list_item_id is',
'null) then',
'               lpad('' '',(4*(level-1)),''.'')||list_item_link_text',
'           else',
'               lpad('' '',(4*(level-1)),''.'')||'' (''||list_item_link_text ||'')''',
'       end name,',
'       id',
'  from wwv_flow_list_items',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and sub_list_id is null',
' start with list_id = :P2500_NAVLIST_ID and parent_list_item_id is null',
'connect by prior list_id = list_id and prior id = parent_list_item_id',
' order siblings by list_item_display_sequence'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select an existing menu control to be shown as the active menu control when rendering the new page.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5474075272354172)
,p_name=>'P2517_NAVLIST_PARENT_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(17862423852967044)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5474786527354174)
,p_name=>'P2517_USE_BREADCRUMB'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(17862475378967045)
,p_item_default=>'Y'
,p_prompt=>'Use Breadcrumb'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Set this flag to <strong>On</strong>, if you want to create a breadcrumb entry for this page. By default, page name will be used as breadcrumb entry name.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5475161135354175)
,p_name=>'P2517_BREADCRUMB_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(17862475378967045)
,p_prompt=>'Breadcrumb'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION.MENUS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name,',
'       id',
'  from wwv_flow_menus',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
' order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select which breadcrumb navigation control you want to use.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5476003001354177)
,p_name=>'P2517_BREADCRUMB_PARENT_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(17862475378967045)
,p_prompt=>'Breadcrumb Parent Entry'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov_language=>'PLSQL'
,p_lov=>'return wwv_flow_4000_ui.breadcrumb_parent_lov_sql( p_breadcrumb_item_name => ''P2517_BREADCRUMB_ID'' )'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No parent entry -'
,p_lov_cascade_parent_items=>'P2517_BREADCRUMB_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select parent breadcrumb entry for the current page, select "No Parent Entry" for top level page.'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5476917988354179)
,p_name=>'P2517_BREADCRUMB_COUNT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(17862475378967045)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*)',
'  from wwv_flow_menus',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(5496567352354227)
,p_computation_sequence=>10
,p_computation_item=>'P2517_NAVLIST_PARENT_ID'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P2517_PARENT_LIST_ITEM_ID'
,p_compute_when=>'P2517_NAVLIST_OPTIONS'
,p_compute_when_text=>'NEW'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(5496998914354228)
,p_computation_sequence=>20
,p_computation_item=>'P2517_NAVLIST_PARENT_ID'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P2517_EXISTING_LIST_ITEM_ID'
,p_compute_when=>'P2517_NAVLIST_OPTIONS'
,p_compute_when_text=>'EXISTING'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(4702995046957425)
,p_computation_sequence=>10
,p_computation_item=>'P2517_PAGE_ID'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_utilities.minimum_free_page(:FB_FLOW_ID,1)'
,p_compute_when=>'P2517_PAGE_ID'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5501702078354232)
,p_validation_name=>'Page Number does not exists'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_steps',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and id                = :P2517_PAGE_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Page already exists, please enter different page number.'
,p_when_button_pressed=>wwv_flow_imp.id(5481363941354193)
,p_associated_item=>wwv_flow_imp.id(5461358939354130)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5502191480354232)
,p_validation_name=>'Page Number not decimal or negative'
,p_validation_sequence=>30
,p_validation=>'trunc(abs(:P2517_PAGE_ID)) = :P2517_PAGE_ID'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Page Number must be a positive, whole number.'
,p_when_button_pressed=>wwv_flow_imp.id(5481363941354193)
,p_associated_item=>wwv_flow_imp.id(5461358939354130)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2852774398885056)
,p_validation_name=>'Navigation Menu not subscribed'
,p_validation_sequence=>40
,p_validation=>'coalesce(:P2500_IS_NAVLIST_SUBSCRIBED,''N'') != ''Y'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'&APP_TEXT$WIZ_NAVIGATION_MENU_SUBSCRIBED!RAW.'
,p_validation_condition=>':P2517_USE_NAVLIST = ''Y'' and :P2500_NAVLIST_ID is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(5470102303354165)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5510152412354251)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(5482530137354195)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5510604351354251)
,p_event_id=>wwv_flow_imp.id(5510152412354251)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5511041844354251)
,p_name=>'Show/Hide BC Items'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2517_USE_BREADCRUMB'
,p_condition_element=>'P2517_USE_BREADCRUMB'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5511570912354252)
,p_event_id=>wwv_flow_imp.id(5511041844354251)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2517_BREADCRUMB_PARENT_ID,P2517_BREADCRUMB_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5512517877354252)
,p_event_id=>wwv_flow_imp.id(5511041844354251)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2517_BREADCRUMB_PARENT_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5512079962354252)
,p_event_id=>wwv_flow_imp.id(5511041844354251)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2517_BREADCRUMB_ID'
,p_client_condition_type=>'GREATER_THAN'
,p_client_condition_element=>'P2517_BREADCRUMB_COUNT'
,p_client_condition_expression=>'1'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5515304304354254)
,p_name=>'Handle Create New Nav List Case'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2517_NAVLIST_OPTIONS'
,p_condition_element=>'P2517_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5515883537354254)
,p_event_id=>wwv_flow_imp.id(5515304304354254)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2517_PARENT_LIST_ITEM_ID,P2517_PAGE_ICON'
,p_client_condition_type=>'EQUALS'
,p_client_condition_element=>'P2517_USE_NAVLIST'
,p_client_condition_expression=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5516386438354254)
,p_event_id=>wwv_flow_imp.id(5515304304354254)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2517_PARENT_LIST_ITEM_ID,P2517_PAGE_ICON'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5516880174354255)
,p_event_id=>wwv_flow_imp.id(5515304304354254)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(5469724960354164)
,p_client_condition_type=>'EQUALS'
,p_client_condition_element=>'P2517_USE_NAVLIST'
,p_client_condition_expression=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5517303926354255)
,p_event_id=>wwv_flow_imp.id(5515304304354254)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(5469724960354164)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5517779943354256)
,p_name=>'Handle Existing Nav List Case'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2517_NAVLIST_OPTIONS'
,p_condition_element=>'P2517_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'EXISTING'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5518225493354256)
,p_event_id=>wwv_flow_imp.id(5517779943354256)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2517_EXISTING_LIST_ITEM_ID'
,p_client_condition_type=>'EQUALS'
,p_client_condition_element=>'P2517_USE_NAVLIST'
,p_client_condition_expression=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5518789364354256)
,p_event_id=>wwv_flow_imp.id(5517779943354256)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2517_EXISTING_LIST_ITEM_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5532805665354265)
,p_name=>'Show/Hide Nav Items'
,p_event_sequence=>140
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2517_USE_NAVLIST'
,p_condition_element=>'P2517_USE_NAVLIST'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5533369893354265)
,p_event_id=>wwv_flow_imp.id(5532805665354265)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2517_NAVLIST_OPTIONS'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5533892621354265)
,p_event_id=>wwv_flow_imp.id(5532805665354265)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2517_NAVLIST_OPTIONS,P2517_PARENT_LIST_ITEM_ID,P2517_EXISTING_LIST_ITEM_ID,P2517_PAGE_ICON'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5534393098354266)
,p_event_id=>wwv_flow_imp.id(5532805665354265)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2517_NAVLIST_OPTIONS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'NEW'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5534831103354266)
,p_event_id=>wwv_flow_imp.id(5532805665354265)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(5469724960354164)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5538494904354268)
,p_name=>'Submit NEXT and show progress'
,p_event_sequence=>180
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(5481363941354193)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5538939055354268)
,p_event_id=>wwv_flow_imp.id(5538494904354268)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'NEXT'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5543229832354271)
,p_name=>'Focus P2517_PAGE_NAME'
,p_event_sequence=>200
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5543738050354271)
,p_event_id=>wwv_flow_imp.id(5543229832354271)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2517_PAGE_NAME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4609466340691710)
,p_name=>'Hide P2517_BREADCRUMB_ID'
,p_event_sequence=>210
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_cond=>'P2517_BREADCRUMB_COUNT'
,p_display_when_cond2=>'1'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4609555045691711)
,p_event_id=>wwv_flow_imp.id(4609466340691710)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2517_BREADCRUMB_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4226549886618170)
,p_name=>'Validation Error - Scroll to Top'
,p_event_sequence=>220
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4226902227618178)
,p_event_id=>wwv_flow_imp.id(4226549886618170)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.message.setThemeHooks( { pageErrorsContainerSelector: ".a-Alert--horizontal" } );'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5506042991354236)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Breadcrumb & Navigation Items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- if use breadcrumb flag is disabled, then reset breadcrumb item values ',
'if :P2517_USE_BREADCRUMB = ''N'' then',
'    :P2517_BREADCRUMB_ID := null;',
'    :P2517_BREADCRUMB_PARENT_ID := null;',
'end if;',
'',
'-- if use navigation option is disabled, then reset navigation item values ',
'if :P2517_USE_NAVLIST = ''N'' then ',
'    :P2517_NAVLIST_OPTIONS := null;',
'    :P2517_PARENT_LIST_ITEM_ID := null;',
'    :P2517_PAGE_ICON := null;',
'    :P2517_EXISTING_LIST_ITEM_ID := null;',
'    :P2517_NAVLIST_PARENT_ID := null;',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>5506042991354236
);
end;
/
prompt --application/pages/page_02518
begin
wwv_flow_imp_page.create_page(
 p_id=>2518
,p_name=>'Create Page Wizard - MD - SS Source'
,p_alias=>'CREATE-PAGE-MD-SS-SOURCE'
,p_page_mode=>'MODAL'
,p_step_title=>'Create &P2500_PAGE_TYPE_DISPLAY.'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(103848364625132731)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_css_classes=>'a-Dialog--CreatePageDialog'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(561686796329168425)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(561688947580168449)
,p_plug_name=>'Master Region'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5582765779470636)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(561686796329168425)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5583163472470637)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(561686796329168425)
,p_button_name=>'ADVANCED'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Advanced'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:2501:&SESSION.::&DEBUG.:RP,2501,2502,2515,2516:P2501_PAGE_ID,P2501_PAGE_NAME,P2501_USE_BREADCRUMB,P2501_BREADCRUMB_ID,P2501_BREADCRUMB_PARENT_ID,P2501_USE_NAVLIST,P2501_NAVLIST_OPTIONS,P2501_PARENT_LIST_ITEM_ID,P2501_PAGE_ICON,P2501_EXISTING_LIST_ITEM_ID,P2501_NAVLIST_PARENT_ID,P2501_LOCATION,P2501_TABLE_OWNER,P2501_TABLE_NAME,P2501_PREV_PAGE:&P2517_PAGE_ID.,&P2517_PAGE_NAME.,&P2517_USE_BREADCRUMB.,&P2517_BREADCRUMB_ID.,&P2517_BREADCRUMB_PARENT_ID.,&P2517_USE_NAVLIST.,&P2517_NAVLIST_OPTIONS.,&P2517_PARENT_LIST_ITEM_ID.,&P2517_PAGE_ICON.,&P2517_EXISTING_LIST_ITEM_ID.,&P2517_NAVLIST_PARENT_ID.,LOCAL,&P2518_TABLE_OWNER.,&P2518_MASTER_TABLE.,2518'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5583592757470638)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(561686796329168425)
,p_button_name=>'CREATE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Page'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5583999820470638)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(561686796329168425)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:2517:&SESSION.::&DEBUG.:RP,::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5584652589470648)
,p_name=>'P2518_TABLE_OWNER'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(561688947580168449)
,p_item_default=>'wwv_flow_security.flow_owner( p_flow_id => :FB_FLOW_ID, p_security_group_id => :WORKSPACE_ID )'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Table / View Owner'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_SCHEMAS_HAVE_PRIVS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(owner) d, owner v',
'  from wwv_flow_object_owners_dev',
'order by d                   '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Schema -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the owner of the table on which you are building master detail page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5585595933470654)
,p_name=>'P2518_MASTER_TABLE'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(561688947580168449)
,p_prompt=>'Master Table'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = :P2518_TABLE_OWNER'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Value -'
,p_lov_cascade_parent_items=>'P2518_TABLE_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the master table or view. When entering manually, note that the table name is case sensitive.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5586483856470655)
,p_name=>'P2518_PRIMARY_LABEL'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(561688947580168449)
,p_prompt=>'Primary Display Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P2518_TABLE_OWNER',
'   and table_name = :P2518_MASTER_TABLE',
'   and :P2518_MASTER_TABLE is not null',
'   and (data_type in (''VARCHAR2'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Label Column -'
,p_lov_cascade_parent_items=>'P2518_TABLE_OWNER,P2518_MASTER_TABLE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the column to display as primary column in the report to navigate to a different master record.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5587369207470657)
,p_name=>'P2518_SECONDARY_LABEL'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(561688947580168449)
,p_prompt=>'Secondary Display Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from wwv_flow_table_columns_dev',
' where owner      = :P2518_TABLE_OWNER',
'   and table_name = :P2518_MASTER_TABLE',
'   and :P2518_MASTER_TABLE is not null',
'   and (data_type in (''VARCHAR2'',''DATE'') or data_type like (''TIMESTAMP%''))',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Label Column -'
,p_lov_cascade_parent_items=>'P2518_TABLE_OWNER,P2518_MASTER_TABLE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the column to display as secondary column in the report to navigate to a different master record.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5588223350470658)
,p_name=>'P2518_DETAIL_TABLE1'
,p_is_required=>true
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(561688947580168449)
,p_prompt=>'Detail Table'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P2518_DETAIL_TABLES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select child_table',
'  from wwv_dictionary_cache_fkcon c',
' where c.parent_table      = :P2518_MASTER_TABLE',
'   and c.parent_owner      = :P2518_TABLE_OWNER',
'   and c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and c.child_owner       in ( select schema from wwv_flow_company_schemas where security_group_id = :FLOW_SECURITY_GROUP_ID )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Value -'
,p_lov_cascade_parent_items=>'P2518_TABLE_OWNER,P2518_MASTER_TABLE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the detail table or view.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5589121928470659)
,p_name=>'P2518_DETAIL_TABLE2'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(561688947580168449)
,p_prompt=>'Detail Table 2'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P2518_DETAIL_TABLES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select child_table',
'  from wwv_dictionary_cache_fkcon c',
' where c.parent_table      = :P2518_MASTER_TABLE',
'   and c.parent_owner      = :P2518_TABLE_OWNER',
'   and c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and c.child_owner       in ( select schema from wwv_flow_company_schemas where security_group_id = :FLOW_SECURITY_GROUP_ID )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Value -'
,p_lov_cascade_parent_items=>'P2518_TABLE_OWNER,P2518_MASTER_TABLE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the detail table or view.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5590002111470660)
,p_name=>'P2518_DETAIL_TABLE3'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(561688947580168449)
,p_prompt=>'Detail Table 3'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P2518_DETAIL_TABLES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select child_table',
'  from wwv_dictionary_cache_fkcon c',
' where c.parent_table      = :P2518_MASTER_TABLE',
'   and c.parent_owner      = :P2518_TABLE_OWNER',
'   and c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and c.child_owner       in ( select schema from wwv_flow_company_schemas where security_group_id = :FLOW_SECURITY_GROUP_ID )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Value -'
,p_lov_cascade_parent_items=>'P2518_TABLE_OWNER,P2518_MASTER_TABLE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the detail table or view.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5590927793470661)
,p_name=>'P2518_DETAIL_TABLE4'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(561688947580168449)
,p_prompt=>'Detail Table 4'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P2518_DETAIL_TABLES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select child_table',
'  from wwv_dictionary_cache_fkcon c',
' where c.parent_table      = :P2518_MASTER_TABLE',
'   and c.parent_owner      = :P2518_TABLE_OWNER',
'   and c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and c.child_owner       in ( select schema from wwv_flow_company_schemas where security_group_id = :FLOW_SECURITY_GROUP_ID )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Value -'
,p_lov_cascade_parent_items=>'P2518_TABLE_OWNER,P2518_MASTER_TABLE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the detail table or view.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(5592218159470667)
,p_computation_sequence=>50
,p_computation_item=>'UI_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P2518_TABLE_OWNER'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5592613004470668)
,p_validation_name=>'Chosen Table exists'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_tables_views_dev',
' where owner       = :P2518_TABLE_OWNER',
'   and object_name = :P2518_MASTER_TABLE'))
,p_validation_type=>'EXISTS'
,p_error_message=>'Table &P2518_MASTER_TABLE!HTML. does not exist. Note that the table name is case-sensitive.'
,p_when_button_pressed=>wwv_flow_imp.id(5583592757470638)
,p_associated_item=>wwv_flow_imp.id(5585595933470654)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5593778529470673)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(5582765779470636)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5594285650470679)
,p_event_id=>wwv_flow_imp.id(5593778529470673)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5594691520470680)
,p_name=>'Toggle Detail 2'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2518_DETAIL_TABLE1'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$v(''P2518_DETAIL_TABLE1'') !== '''''
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5595111520470681)
,p_event_id=>wwv_flow_imp.id(5594691520470680)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2518_DETAIL_TABLE2'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5595685143470682)
,p_event_id=>wwv_flow_imp.id(5594691520470680)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2518_DETAIL_TABLE2'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5596040642470683)
,p_name=>'Toggle Detail 3'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2518_DETAIL_TABLE2'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$v(''P2518_DETAIL_TABLE2'') !== '''''
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5596595212470684)
,p_event_id=>wwv_flow_imp.id(5596040642470683)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2518_DETAIL_TABLE3'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5597075151470685)
,p_event_id=>wwv_flow_imp.id(5596040642470683)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2518_DETAIL_TABLE3'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5597482492470686)
,p_name=>'Toggle Detail 4'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2518_DETAIL_TABLE3'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$v(''P2518_DETAIL_TABLE3'') !== '''''
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5597963715470687)
,p_event_id=>wwv_flow_imp.id(5597482492470686)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2518_DETAIL_TABLE4'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5598410862470688)
,p_event_id=>wwv_flow_imp.id(5597482492470686)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2518_DETAIL_TABLE4'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5598878600470688)
,p_name=>'Set data dictionary cache'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P2518_MASTER_TABLE'
,p_condition_element=>'P2518_MASTER_TABLE'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5599301527470690)
,p_event_id=>wwv_flow_imp.id(5598878600470688)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_object_type wwv_flow_tables_views_dev.object_type%type;',
'begin',
'    select object_type',
'      into l_object_type',
'      from wwv_flow_tables_views_dev',
'     where owner       = :P2518_TABLE_OWNER',
'       and object_name = :P2518_MASTER_TABLE;',
'',
'    --- if table, set APEX dictionary cache',
'    if l_object_type = ''TABLE'' then',
'        wwv_dictionary_cache_dev.set_dictionary_table_cache(',
'             p_workspace_name          => htmldb_util.find_workspace( p_security_group_id => :WORKSPACE_ID ),',
'             p_schema                  => :P2518_TABLE_OWNER,',
'             p_table_name              => :P2518_MASTER_TABLE,',
'             p_flow_id                 => :FB_FLOW_ID,',
'             p_cache_fk_references     => true,',
'             p_cache_child_tables      => true );',
'    end if;',
'end;'))
,p_attribute_02=>'P2518_TABLE_OWNER,P2518_MASTER_TABLE'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5599899613470691)
,p_event_id=>wwv_flow_imp.id(5598878600470688)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P2518_DETAIL_TABLE1,P2518_DETAIL_TABLE2,P2518_DETAIL_TABLE3,P2518_DETAIL_TABLE4'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4609204688691708)
,p_name=>'Submit CREATE and show progress'
,p_event_sequence=>90
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(5583592757470638)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4609395712691709)
,p_event_id=>wwv_flow_imp.id(4609204688691708)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'CREATE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4227397969622631)
,p_name=>'Validation Error - Scroll to Top'
,p_event_sequence=>100
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4227731077622631)
,p_event_id=>wwv_flow_imp.id(4227397969622631)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.message.setThemeHooks( { pageErrorsContainerSelector: ".a-Alert--horizontal" } );'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5593364992470670)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Side by Side MD'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.create_md_side_by_side(',
'    p_app_id                    => :FB_FLOW_ID,',
'    p_starting_page_id          => :P2517_PAGE_ID,',
'    p_md_page_name              => :P2517_PAGE_NAME,',
'    --',
'    p_table_owner               => :P2518_TABLE_OWNER,',
'    p_master_table              => :P2518_MASTER_TABLE,',
'    p_primary_label_col         => :P2518_PRIMARY_LABEL,',
'    p_secondary_label_col       => :P2518_SECONDARY_LABEL,',
'    p_detail_table_1            => :P2518_DETAIL_TABLE1,',
'    p_detail_table_2            => :P2518_DETAIL_TABLE2,',
'    p_detail_table_3            => :P2518_DETAIL_TABLE3,',
'    p_detail_table_4            => :P2518_DETAIL_TABLE4,',
'    --',
'    p_nav_list_id               => :P2500_NAVLIST_ID,',
'    p_nav_list_parent_item_id   => :P2517_NAVLIST_PARENT_ID,',
'    p_nav_list_child_item_name  => case when :P2517_NAVLIST_OPTIONS = ''NEW'' then :P2517_PAGE_NAME end,',
'    p_nav_list_item_icon        => :P2517_PAGE_ICON,    ',
'    --',
'    p_breadcrumb_id             => :P2517_BREADCRUMB_ID,',
'    p_breadcrumb_name           => :P2517_PAGE_NAME,',
'    p_parent_bc_id              => :P2517_BREADCRUMB_PARENT_ID );',
'',
':FB_FLOW_PAGE_ID       := :P2517_PAGE_ID;',
':F4000_RUN_EDIT_PAGE   := :P2517_PAGE_ID;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(5583592757470638)
,p_internal_uid=>5593364992470670
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5592987500470668)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_attribute_02=>'N'
,p_process_error_message=>'Error creating &P2500_PAGE_TYPE_DISPLAY. page.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(5583592757470638)
,p_process_success_message=>'&P2500_PAGE_TYPE_DISPLAY. page created.'
,p_internal_uid=>5592987500470668
);
end;
/
prompt --application/pages/page_02519
begin
wwv_flow_imp_page.create_page(
 p_id=>2519
,p_name=>'Create Page Wizard - Global Page'
,p_alias=>'CREATE-PAGE-GLOBAL-PAGE'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Global Page'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(103848364625132731)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_css_classes=>'a-Dialog--CreatePageDialog'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_pg.htm'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17138371467045371)
,p_plug_name=>'Page Definition'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wiz_confirm.create_global_page (',
'    p_flow_id => :FB_FLOW_ID);',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(277454951210205408)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(13903222922750748)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(277454951210205408)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(13903601282750748)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(277454951210205408)
,p_button_name=>'CREATE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Page'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
,p_button_cattributes=>'tabindex="1"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(13904013960750749)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(277454951210205408)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:2500:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(13902065855750740)
,p_name=>'P2519_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(17138371467045371)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Page Number'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_page_zero_exists number;',
'begin',
'    -- optimization to default with page 0 if it''s not used yet',
'    select count(*)',
'      into l_page_zero_exists',
'      from wwv_flow_steps',
'     where flow_id = :FB_FLOW_ID',
'       and id      = 0',
'       and security_group_id = :WORKSPACE_ID;',
'',
'    if l_page_zero_exists = 1 then',
'        return wwv_flow_utilities.minimum_free_page(:FB_FLOW_ID,1);',
'    else',
'        return 0;',
'    end if;',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>10
,p_cMaxlength=>10
,p_tag_attributes=>'tabindex="1"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The page number is an integer value that identifies a page within an application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(13904515468750752)
,p_validation_name=>'P2519_PAGE_ID not decimal or negative'
,p_validation_sequence=>10
,p_validation=>'trunc(abs(:P2519_PAGE_ID)) = :P2519_PAGE_ID'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Page Number must be a positive, whole number.'
,p_validation_condition=>'P2519_PAGE_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(13903601282750748)
,p_associated_item=>wwv_flow_imp.id(13902065855750740)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(13904907878750753)
,p_validation_name=>'Page id is still available'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_steps',
' where flow_id           = :FB_FLOW_ID',
'   and id                = :P2519_PAGE_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Page number is already in use.'
,p_validation_condition=>'P2519_PAGE_ID'
,p_validation_condition_type=>'ITEM_IS_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(13903601282750748)
,p_associated_item=>wwv_flow_imp.id(13902065855750740)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(13905367752750753)
,p_validation_name=>'Page ID is not null'
,p_validation_sequence=>30
,p_validation=>'P2519_PAGE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_when_button_pressed=>wwv_flow_imp.id(13903601282750748)
,p_associated_item=>wwv_flow_imp.id(13902065855750740)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(13906477235750757)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(13903222922750748)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(13906957378750758)
,p_event_id=>wwv_flow_imp.id(13906477235750757)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4611687806691732)
,p_name=>'Submit CREATE and show progress'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(13903601282750748)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4611755881691733)
,p_event_id=>wwv_flow_imp.id(4611687806691732)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'CREATE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(13905664223750753)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_wizard_api.create_global_page (',
'        p_application_id    => :FB_FLOW_ID,',
'        p_page_id           => :P2519_PAGE_ID );',
'',
'    :FB_FLOW_PAGE_ID     := :P2519_PAGE_ID;',
'    :F4000_RUN_EDIT_PAGE := :P2519_PAGE_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error creating global page. #SQLERRM_TEXT#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(13903601282750748)
,p_process_success_message=>'Global Page Created'
,p_internal_uid=>13905664223750753
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(13906064320750755)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_attribute_02=>'N'
,p_process_error_message=>'Error creating Global page.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(13903601282750748)
,p_process_success_message=>'Global page created.'
,p_internal_uid=>13906064320750755
);
end;
/
prompt --application/pages/page_02520
begin
wwv_flow_imp_page.create_page(
 p_id=>2520
,p_name=>'Reserved for APEX-4844'
,p_alias=>'RESERVED-FOR-APEX-4844'
,p_page_mode=>'MODAL'
,p_step_title=>'Reserved for APEX-4844'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'11'
);
end;
/
prompt --application/pages/page_03009
begin
wwv_flow_imp_page.create_page(
 p_id=>3009
,p_name=>'Create Application - Identify Copy Target'
,p_alias=>'CREATE-APPLICATION-IDENTIFY-COPY-TARGET'
,p_step_title=>'Create Application'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(20647615170785101)
,p_plug_name=>'Create Application'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_query_row_template=>wwv_flow_imp.id(79387910442923002)
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_row_count_max=>5000
,p_plug_query_show_nulls_as=>' - '
,p_plug_query_break_cols=>'0'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(20648424521787810)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(139866417493663090)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(41970322993525165)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747149607092138180)
,p_plug_name=>'Create Application'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(20647831777785102)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(41970322993525165)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:1500:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(20648216317785103)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(41970322993525165)
,p_button_name=>'FINISH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(20648006978785103)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(41970322993525165)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:56:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(23759618480442454)
,p_branch_action=>'f?p=&APP_ID.:84:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(20648216317785103)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20648917164804639)
,p_name=>'P3009_COPY_FROM'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(20647615170785101)
,p_item_default=>'0'
,p_prompt=>'Copy From'
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||name d, id r',
'  from wwv_flow_visible_flows f',
' where f.build_status != ''RUN_AND_HIDDEN''',
' order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Choose Application -'
,p_lov_null_value=>'0'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select the name of the application you wish to copy.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20649132055808948)
,p_name=>'P3009_COPY_TO'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(20647615170785101)
,p_prompt=>'Copy To'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Enter a short descriptive name for the application to distinguish the new application in select lists and reports.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20652902282876073)
,p_name=>'P3009_NEW_APP_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(20647615170785101)
,p_prompt=>'New Application ID'
,p_source=>'wwv_flow_utilities.minimum_free_flow'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify an integer value that identifies the application.  The application ID must be unique within your &PRODUCT_NAME. instance.<br /><br />',
'Application IDs in the range of 3000 to 9000 are reserved for internal use by &PRODUCT_NAME.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20653413017879159)
,p_name=>'P3009_COPY_DEPLOYMENT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(20647615170785101)
,p_item_default=>'N'
,p_prompt=>'Copy Supporting Object Definitions'
,p_source=>'select include_in_export_yn from wwv_flow_install where flow_id = :fb_flow_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'You can copy supporting object definitions, configuration options, and scripts with your application. ',
'<p />',
'Select <strong>On</strong> to include database object definitions, image definitions, and seed data SQL statements encapsulated in a single file.',
'Select <strong>Off</strong> to not include supporting object definitions.',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(23778031696550324)
,p_computation_sequence=>10
,p_computation_item=>'P84_COPY_FROM_NAME'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name',
'from wwv_flows f',
'where security_group_id = :flow_security_group_id',
'and id = :P3009_COPY_FROM'))
,p_compute_when=>'P3009_COPY_FROM'
,p_compute_when_type=>'ITEM_NOT_NULL_OR_ZERO'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(23859315401744351)
,p_validation_name=>'P3009_COPY_FROM'
,p_validation_sequence=>10
,p_validation=>'P3009_COPY_FROM'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'Identify the application to copy.'
,p_when_button_pressed=>wwv_flow_imp.id(20648216317785103)
,p_associated_item=>wwv_flow_imp.id(20648917164804639)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(23882630947796115)
,p_validation_name=>'P3009_NEW_APP_ID'
,p_validation_sequence=>20
,p_validation=>'P3009_NEW_APP_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_when_button_pressed=>wwv_flow_imp.id(20648216317785103)
,p_associated_item=>wwv_flow_imp.id(20652902282876073)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(23882115925782344)
,p_validation_name=>'P3009_NEW_APP_ID positive, whole number'
,p_validation_sequence=>30
,p_validation=>'P3009_NEW_APP_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>'Application Number must be a positive, whole number.'
,p_validation_condition=>'P3009_NEW_APP_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(20648216317785103)
,p_associated_item=>wwv_flow_imp.id(20652902282876073)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(23751328645379097)
,p_validation_name=>'new ID not same as old ID'
,p_validation_sequence=>40
,p_validation=>'ltrim(:P3009_NEW_APP_ID,''0'') != nvl(:P3009_COPY_FROM,-1)'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Specified new application ID must be different from the current Application ID.'
,p_validation_condition=>'P3009_NEW_APP_ID'
,p_validation_condition_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_when_button_pressed=>wwv_flow_imp.id(20648216317785103)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(23751500379380452)
,p_validation_name=>'reserved app id check'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_utilities.is_available_application_id(',
'    p_security_group_id => :flow_security_group_id,',
'    p_application_id    => :P3009_NEW_APP_ID,',
'    p_check_reserved    => FALSE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Application ID reserved.'
,p_validation_condition=>':flow_security_group_id != 10 and wwv_flow_utilities.is_numeric(:P3009_NEW_APP_ID)'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(20648216317785103)
,p_associated_item=>wwv_flow_imp.id(20652902282876073)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(23751706266382146)
,p_validation_name=>'cannot copy invalid range flow'
,p_validation_sequence=>60
,p_validation=>':P3009_NEW_APP_ID not between 4000 and 4999'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'The application you are trying to copy is reserved.'
,p_validation_condition=>'(:flow_security_group_id != 10) and (:P3009_NEW_APP_ID is not null) and (wwv_flow_utilities.is_numeric(:P3009_NEW_APP_ID))'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(20648216317785103)
,p_associated_item=>wwv_flow_imp.id(20652902282876073)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(23751911807383695)
,p_validation_name=>'no deployment exists'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'from wwv_flow_install_scripts ',
'where flow_id = :P3009_COPY_FROM',
'and security_group_id = :flow_security_group_id'))
,p_validation_type=>'EXISTS'
,p_error_message=>'You must define at least one installation script to copy supporting object definitions.'
,p_validation_condition=>'P3009_COPY_DEPLOYMENT'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(20648216317785103)
,p_associated_item=>wwv_flow_imp.id(20653413017879159)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(23752116309385057)
,p_validation_name=>'application ID exists'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flows',
'where id = :P3009_NEW_APP_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Specified new application ID exists already.'
,p_validation_condition=>'wwv_flow_utilities.is_numeric(:P3009_NEW_APP_ID) and ltrim(:P3009_NEW_APP_ID,''0'') != nvl(:P3009_COPY_FROM,-1)'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(20648216317785103)
,p_associated_item=>wwv_flow_imp.id(20652902282876073)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(23882322504784255)
,p_validation_name=>'Restricted users may not create applications'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_provisioning.restricted_schema(',
'   p_schema => wwv_flow_user_api.get_default_schema, ',
'   p_security_group_id => wwv_flow_security.g_security_group_id) then',
'   return false;',
'else',
'   return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Restricted schema, may not create application.'
,p_validation_condition=>'wwv_flow_security.g_security_group_id <> 10'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(20648216317785103)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(153868110618185944)
,p_name=>'Set Copy To Default Value'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3009_COPY_FROM'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(153868416857185945)
,p_event_id=>wwv_flow_imp.id(153868110618185944)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3009_COPY_TO'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name from wwv_flows',
'where id = :P3009_COPY_FROM',
'and security_group_id = :flow_security_group_id'))
,p_attribute_07=>'P3009_COPY_FROM'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
end;
/
prompt --application/pages/page_03100
begin
wwv_flow_imp_page.create_page(
 p_id=>3100
,p_name=>'Search Configuration'
,p_alias=>'SEARCH-CONFIGURATION'
,p_step_title=>'Search Configurations'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1694437147185465)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(1693027045185449)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Search Configurations'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1694858811190201)
,p_plug_name=>'Search Configurations'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with messages as (',
'    select ( select wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_UP_TO_DATE'') from sys.dual ) up_to_date,',
'           ( select wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_NEEDS_REFRESH'') from sys.dual ) needs_refresh,',
'           ( select wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_UNKNOWN'') from sys.dual ) unknown_status,',
'           ( select wwv_flow_lang_dev.builder_message(''SUBSCRIBED_FROM.NONEXISTING_MASTER'') from sys.dual ) no_master',
'      from sys.dual )',
'select s.id,',
'       s.label,',
'       s.static_id,',
'       s.search_type,',
'       ''icon-sc-app-search'' icon_class,',
'       wwv_flow_page_api.get_url(',
'           p_application => :APP_ID,',
'           p_page        => 3120,',
'           p_clear_cache => 3120,',
'           p_items       => ''P3120_ID'',',
'           p_values      => s.id ) edit_link,',
'       coalesce( s.last_updated_on, s.created_on ) last_updated,',
'       coalesce( s.last_updated_by, s.created_by ) last_updated_by,',
'       --',
'       ( select patch_name',
'           from wwv_flow_patches p',
'          where security_group_id = :WORKSPACE_ID',
'            and flow_id           = :FB_FLOW_ID',
'            and p.id              = s.build_option_id ) build_option,',
'       --',
'       case when s.reference_id is not null then',
'           coalesce ( to_char( master.flow_id ),',
'                       messages.no_master )',
'       end as subscribed_from,',
'       ( select case when count(*) > 0 then count(*) end',
'           from wwv_flow_search_configs sub',
'          where sub.reference_id      = s.id',
'            and sub.security_group_id = :WORKSPACE_ID ) as subscribers,',
'       case when s.reference_id is not null then',
'           case',
'               when master.version_scn = s.version_scn then',
'                   messages.up_to_date',
'               when master.version_scn != s.version_scn then',
'                   messages.needs_refresh',
'               else',
'                   messages.unknown_status',
'           end',
'       end subscription_status,',
'       --',
'       --',
'       null as action',
' from wwv_flow_search_configs s,',
'      wwv_flow_search_configs master,',
'      messages',
'where s.flow_id                = :FB_FLOW_ID',
'  and s.security_group_id      = :WORKSPACE_ID',
'  and s.reference_id           = master.id (+)',
'  and s.security_group_id      = master.security_group_id (+)'))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Search Configurations'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(1694946815190202)
,p_no_data_found_message=>'No Search Configurations are defined for this application.'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_download_formats=>'CSV:HTML'
,p_enable_mail_download=>'Y'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#EDIT_LINK#" class="a-IRR-icon"><span class="a-Icon icon-search"></span><span class="a-IRR-iconName">#LABEL#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'CBCHO'
,p_internal_uid=>1694946815190202
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1695051618190203)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1695341072190206)
,p_db_column_name=>'LABEL'
,p_display_order=>40
,p_column_identifier=>'B'
,p_column_label=>'Label'
,p_column_link=>'f?p=&APP_ID.:3120:&SESSION.::&DEBUG.:3120:P3120_ID:#ID#'
,p_column_linktext=>'#LABEL#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1695454128190207)
,p_db_column_name=>'STATIC_ID'
,p_display_order=>50
,p_column_identifier=>'C'
,p_column_label=>'Static ID'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1695694162190209)
,p_db_column_name=>'SEARCH_TYPE'
,p_display_order=>70
,p_column_identifier=>'D'
,p_column_label=>'Type'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(1813067828014706)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2702309059067621)
,p_db_column_name=>'LAST_UPDATED'
,p_display_order=>80
,p_column_identifier=>'K'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1699948614193602)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>90
,p_column_identifier=>'G'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2702486186067622)
,p_db_column_name=>'BUILD_OPTION'
,p_display_order=>100
,p_column_identifier=>'L'
,p_column_label=>'Build Option'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2702583831067623)
,p_db_column_name=>'SUBSCRIBED_FROM'
,p_display_order=>110
,p_column_identifier=>'M'
,p_column_label=>'Subscribed From'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2702621543067624)
,p_db_column_name=>'SUBSCRIBERS'
,p_display_order=>120
,p_column_identifier=>'N'
,p_column_label=>'Subscribers'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1700113848193604)
,p_db_column_name=>'ICON_CLASS'
,p_display_order=>130
,p_column_identifier=>'I'
,p_column_label=>'Icon Class'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1700235929193605)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>140
,p_column_identifier=>'J'
,p_column_label=>'Edit Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1498162183970628)
,p_db_column_name=>'ACTION'
,p_display_order=>150
,p_column_identifier=>'O'
,p_column_label=>'Copy'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'TMPL_THEME_3$ACTIONS'
,p_column_alignment=>'CENTER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'ACTIONS_WRAP', 'N',
  'STYLE', 'b-InlineActions--simple')).to_clob
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(11092031006588009)
,p_db_column_name=>'SUBSCRIPTION_STATUS'
,p_display_order=>160
,p_column_identifier=>'P'
,p_column_label=>'Subscription Status'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(1708263345239112)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_type=>'REPORT'
,p_report_alias=>'17083'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_view_mode=>'REPORT'
,p_report_columns=>'LABEL:SEARCH_TYPE:SUBSCRIBED_FROM:SUBSCRIPTION_STATUS:SUBSCRIBERS:LAST_UPDATED:LAST_UPDATED_BY:ACTION:'
,p_sort_column_1=>'LABEL'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7808180110107400)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'<strong>Search Configuration</strong> contains information about a searchable data source. They can be referenced from <em>Search</em> regions to add declarative searches in your application. Searches can be based on Local data source, REST Enabled S'
||'QL Service, REST Data Source, pre-defined Oracle Text, pre-defined Oracle Ubiquitous Search or &PRODUCT_NAME. List.',
'',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(19380603746626103)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(12263103496827474)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1700421710193607)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1694858811190201)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:&APP_PAGE_ID.:&SESSION.::&DEBUG.:RR,::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1700570860193608)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1694858811190201)
,p_button_name=>'COPY'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Copy'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:3116:&SESSION.::&DEBUG.:3116::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1700331783193606)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(1694858811190201)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:3111:&SESSION.::&DEBUG.:3111,3112,3113,3114::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(4204217023667411)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'3100'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(12264483002821320)
,p_name=>'Refresh Subscriptions'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(19380603746626103)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(12264838698821319)
,p_event_id=>wwv_flow_imp.id(12264483002821320)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1694858811190201)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(12265327946821318)
,p_event_id=>wwv_flow_imp.id(12264483002821320)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ( this.data.successMessage ) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
);
wwv_flow_imp_page.create_component_action(
 p_id=>wwv_flow_imp.id(1498226153970629)
,p_ir_column_id=>wwv_flow_imp.id(1498162183970628)
,p_position_id=>wwv_flow_imp.id(214437533860142316)
,p_display_sequence=>10
,p_template_id=>wwv_flow_imp.id(214438625365151034)
,p_label=>'Copy'
,p_link_target_type=>'REDIRECT_PAGE'
,p_link_target=>'f?p=&APP_ID.:3116:&SESSION.::&DEBUG.:3116:P3116_COPY_SOURCE,P3116_COPY_FROM_ID,P3116_COPY_FROM_APP_ID:THIS,#ID#,&FB_FLOW_ID.'
,p_button_display_type=>'ICON'
,p_icon_css_classes=>'icon-copy'
,p_is_hot=>false
,p_show_as_disabled=>false
);
end;
/
prompt --application/pages/page_03111
begin
wwv_flow_imp_page.create_page(
 p_id=>3111
,p_name=>'Create Search Configuration'
,p_alias=>'CREATE-SEARCH-CONFIG1'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Search Configuration'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213210808239773454)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'500'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'nav_list.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46362578259095351)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(170957572710252371)
,p_plug_name=>'Create Search Configuration'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>A <strong>Search Configuration</strong> contains information about the searchable <em>Data Source</em>, the functionality used',
'for search, as well as display properties.</p>',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'generated 16-FEB-2000 23:59:43'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(170990100557543325)
,p_plug_name=>'wizard progress'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(1957878877823352)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1803393842941397)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46362578259095351)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1803716290941398)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(46362578259095351)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1809328539941445)
,p_branch_name=>'Simple Config Data Source'
,p_branch_action=>'f?p=&APP_ID.:3112:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(1803716290941398)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P3111_SEARCH_TYPE'
,p_branch_condition_text=>'SIMPLE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2701064040067608)
,p_branch_name=>'Oracle Text Data Source'
,p_branch_action=>'f?p=&APP_ID.:3113:&SESSION.::&DEBUG.:WIZ_COLUMNS_LIST::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(1803716290941398)
,p_branch_sequence=>40
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P3111_SEARCH_TYPE'
,p_branch_condition_text=>'TEXT_MANUAL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(5677395576853606)
,p_branch_name=>'Ubiquitous Search Data Source'
,p_branch_action=>'f?p=&APP_ID.:3118:&SESSION.::&DEBUG.:CR,WIZ_COLUMNS_LIST,3118::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(1803716290941398)
,p_branch_sequence=>50
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P3111_SEARCH_TYPE'
,p_branch_condition_text=>'TEXT_DBMS_SEARCH'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2700912104067607)
,p_branch_name=>'Column Mapping if List'
,p_branch_action=>'f?p=&APP_ID.:3114:&SESSION.::&DEBUG.:WIZ_COLUMNS_LIST:P3114_PREV_PAGE:&APP_PAGE_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(1803716290941398)
,p_branch_sequence=>60
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P3111_SEARCH_TYPE'
,p_branch_condition_text=>'APEX_LIST'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1700612978193609)
,p_name=>'P3111_LIST_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(170957572710252371)
,p_prompt=>'List'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'SEARCH_CONFIG.LISTS'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select List -'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1804475838941405)
,p_name=>'P3111_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(170957572710252371)
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1805382790941412)
,p_name=>'P3111_LABEL'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(170957572710252371)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'Enter a name for this Search Configuration.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1806235713941412)
,p_name=>'P3111_SEARCH_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(170957572710252371)
,p_prompt=>'Search Type'
,p_source=>'SIMPLE'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'SEARCH_CONFIG.TYPE'
,p_lov=>'.'||wwv_flow_imp.id(1813067828014706)||'.'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select a type of search.<p />',
'<ul>',
'  <li>',
'    <strong>Standard:</strong>',
'    Define a searchable data source, which can be a table, SQL Query, or REST Data Source. ',
'    Search is executed by a SQL Query using LIKE expressions. ',
'  </li>',
'  <li>',
'    <strong>Oracle Text:</strong>',
'    Define a searchable table or SQL Query, which already has an Oracle Text index created. Search',
'    is executed by using Oracle Text functionality, which provides linguistic and fuzzy search',
'    capabilities.',
'  </li>',
'  <li>',
'    <strong>Oracle Ubiquitous Search:</strong>',
'    Search using an Oracle Ubiquitous Search index (requires Oracle Database 23ai or later).<br/>',
'    <em>The index must be located in the parsing schema of the application.</em>',
'  </li>',
'  <li>',
'    <strong>List:</strong>',
'    Search within a selected <em>List</em> from Shared Components.',
'  </li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2832110201926541)
,p_validation_name=>'P3111_LIST_ID not null'
,p_validation_sequence=>10
,p_validation=>'P3111_LIST_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'P3111_SEARCH_TYPE'
,p_validation_condition2=>'APEX_LIST'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(1700612978193609)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1823523424134544)
,p_validation_name=>'Name must be unique within the application'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_search_configs',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and label             = :P3111_LABEL'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#LABEL# is already taken in this application.'
,p_when_button_pressed=>wwv_flow_imp.id(1803716290941398)
,p_associated_item=>wwv_flow_imp.id(1805382790941412)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(9470746774569848)
,p_validation_name=>'Static ID must be unique within the application'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_search_configs',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and static_id         = regexp_replace( lower( :P3111_LABEL ), ''[^abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890]+'', ''_'' )'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'"&P3111_LABEL!HTML." leads to a static ID which is already taken. Choose a different name.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_search_configs',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and label             = :P3111_LABEL'))
,p_validation_condition_type=>'NOT_EXISTS'
,p_when_button_pressed=>wwv_flow_imp.id(1803716290941398)
,p_associated_item=>wwv_flow_imp.id(1805382790941412)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1808342272941441)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1803393842941397)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1808838265941443)
,p_event_id=>wwv_flow_imp.id(1808342272941441)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1700769638193610)
,p_name=>'toggle list item'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3111_SEARCH_TYPE'
,p_condition_element=>'P3111_SEARCH_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'APEX_LIST'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1700834772193611)
,p_event_id=>wwv_flow_imp.id(1700769638193610)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3111_LIST_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1700910778193612)
,p_event_id=>wwv_flow_imp.id(1700769638193610)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3111_LIST_ID'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2996202699029478)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load Search Cofig Columns Collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_search_dev.init_column_collection (',
'    p_column_collection      => ''APEX$SEARCH_CONFIG_COLUMNS'',',
'    --',
'    p_application_id         => :FB_FLOW_ID,',
'    p_search_type            => wwv_flow_search.c_search_type_list,',
'    --',
'    p_list_id                => :P3111_LIST_ID,',
'    --',
'    p_extended_describe      => true );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P3111_SEARCH_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'APEX_LIST'
,p_internal_uid=>2996202699029478
);
end;
/
prompt --application/pages/page_03112
begin
wwv_flow_imp_page.create_page(
 p_id=>3112
,p_name=>'Create Search Configuration'
,p_alias=>'CREATE-SEARCH-CONFIG2'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Search Configuration'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213211113434774960)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_rpt.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(109114484265480752)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(157584487020776603)
,p_plug_name=>'Create &P3111_LABEL.'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(66471911938671229)
,p_plug_name=>'Create for local data source'
,p_parent_plug_id=>wwv_flow_imp.id(157584487020776603)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(66471997352671230)
,p_plug_name=>'Create for REST Data Source'
,p_parent_plug_id=>wwv_flow_imp.id(157584487020776603)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(68262651783279157)
,p_plug_name=>'Create for Remote SQL'
,p_parent_plug_id=>wwv_flow_imp.id(157584487020776603)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(157590898902781620)
,p_plug_name=>'wizard progress'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(1957878877823352)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2001170206553804)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(109114484265480752)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2001554881553805)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(109114484265480752)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2001960665553805)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(109114484265480752)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:3111:&SESSION.::&DEBUG.:RP,::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2036818627553878)
,p_branch_name=>'Go To Column Mapping'
,p_branch_action=>'f?p=&APP_ID.:3114:&SESSION.::&DEBUG.:RP,:P3114_PREV_PAGE:&APP_PAGE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2001554881553805)
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1532736277420604)
,p_name=>'P3112_WEB_SRC_ARRAY_COL_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(66471997352671230)
,p_prompt=>'Array Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select dpc.display_name,',
'       dpc.id',
'  from wwv_flow_web_src_arr_cols_dev dpc',
' where dpc.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and dpc.flow_id           = :FB_FLOW_ID',
'   and dpc.web_src_module_id = :P3112_WEB_SRC_MODULE_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'None'
,p_lov_cascade_parent_items=>'P3112_WEB_SRC_MODULE_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Denotes the Array Column, from the <em>Data Profile</em> of the REST Data Source, to be used for this Search Configuration.'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1636433641313202)
,p_name=>'P3112_PQL_MATCH_CLAUSE'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(66471911938671229)
,p_prompt=>'Match Clause'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cHeight=>2
,p_display_when=>'sys.dbms_db_version.version >= 23'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a path pattern to find on the property graph. In order to find all edges in your graph, use the following: <strong>(a) - [e] -> (b)</strong>. In addition to this, use <em>label constraints</em> to restrict the types of vertices or edges of i'
||'nterest.</p>',
'<p><strong>Examples</strong></p>',
'<dl>',
'<dt>Find all persons who bought cars.</dt><dd><pre>(p is person) - [t is buys] -> (c is car)</pre></dd>',
'<dt>Find all employees working in departments.</dt><dd><pre>(e is employees) - [is works_at] -> (d is departments)</pre></dd>',
'<dt>Find all employees working in departments who bought cars.</dt><dd><pre>(e is employees) - [is works_at] -> (d is departments), (e is employees) - [t is buys] -> (c is car)</pre></dd>',
'</dl>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1636514143313203)
,p_name=>'P3112_GRAPH_NAME'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(66471911938671229)
,p_prompt=>'Graph Name'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select g.graph_name d, ',
'       g.graph_name r',
'  from sys.dba_property_graphs        g,',
'       wwv_flow_object_owners_dev o',
' where o.owner = g.owner',
'   and g.owner = :P3112_TABLE_OWNER'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Value -'
,p_lov_cascade_parent_items=>'P3112_TABLE_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_display_when=>'sys.dbms_db_version.version >= 23'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Enter the case-sensitive Property Graph name. You can type in the name or pick from the list.'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1636759823313205)
,p_name=>'P3112_PQL_COLUMNS_CLAUSE'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(66471911938671229)
,p_prompt=>'Columns Clause'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cHeight=>2
,p_display_when=>'sys.dbms_db_version.version >= 23'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Define the query return columns. Those are properties of vertices or edges or expressions using them.</p>',
'<p><strong>Example</strong></p>',
'<dl>',
'<dt>Return <strong>NAME</strong>, <strong>BRAND</strong> and <strong>TOTAL_COST</strong> columns, the latter is the <strong>COST</strong> column, multiplied by 100.</dt>',
'<dd><pre>p.name, c.brand, t.cost * 100 as total_cost</pre></dd>',
'</dl>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2002601841553815)
,p_name=>'P3112_LOCATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(157584487020776603)
,p_item_default=>'LOCAL'
,p_prompt=>'Data Source'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXEC_LOCATION'
,p_lov=>'.'||wwv_flow_imp.id(3842073961668883)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Select the <em>Data Source</em> type for the new Search Configuration.',
'</p>',
'<ul>',
'    <li><strong>Local Database</strong><br>',
'    Data is sourced from the local database.</li>',
'    <li><strong>REST Enabled SQL Service</strong><br>',
'    Data is sourced from a remote database, where the connection is defined using REST Enabled SQL. To create or maintain REST Enabled SQL references, navigate to Shared Components, REST Enabled SQL.',
'    </li>',
'    <li><strong>REST Data Source</strong><br>',
'    Data is sourced from a RESTful web service defined using REST Data Sources. REST Data Sources are created or maintained in Shared Components.',
'    </li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2003897416553821)
,p_name=>'P3112_SOURCE_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(66471911938671229)
,p_item_default=>'TABLE'
,p_prompt=>'Source Type'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXEC_SQL_DATA_SOURCE_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(601107956819795211)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the source type of the new Search Configuration. When using the Local Database, ',
'the Search Configuration can be based on a Table, SQL Query, or (on Oracle Database 23ai and later) on a Property Graph.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2004726726553822)
,p_name=>'P3112_TABLE_OWNER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(66471911938671229)
,p_prompt=>'Owner'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_SCHEMAS_HAVE_PRIVS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(owner) d, owner v',
'  from wwv_flow_object_owners_dev',
'order by d                   '))
,p_lov_cascade_parent_items=>'P3112_SOURCE_TYPE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the owner of the object on which you are building a Search Configuration.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2005698411553823)
,p_name=>'P3112_TABLE_NAME'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(66471911938671229)
,p_prompt=>'Table / View Name'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = :P3112_TABLE_OWNER',
'   and :P3112_SOURCE_TYPE = ''TABLE'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Value -'
,p_lov_cascade_parent_items=>'P3112_TABLE_OWNER,P3112_SOURCE_TYPE'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the table or view on which the Search Configuration will be based.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2006543810553824)
,p_name=>'P3112_SQL'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(66471911938671229)
,p_prompt=>'Enter a SQL SELECT statement'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>6
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the SQL query that will produce the results for your Search Configuration, for example:',
'<pre>',
'select empno, ename, job, sal, deptno',
'  from emp',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2009531084553826)
,p_name=>'P3112_WEB_SRC_MODULE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(66471997352671230)
,p_prompt=>'REST Data Source'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APP_WEB_SOURCES_FOR_REPORTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_flow_web_src_modules m',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and exists ( select 1 ',
'                  from wwv_flow_web_src_operations',
'                 where web_src_module_id = m.id',
'                   and database_operation = ''FETCH_COLLECTION'' )',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the REST Data Source.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2010703043553827)
,p_name=>'P3112_REMOTE_SERVER_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(68262651783279157)
,p_prompt=>'REST Enabled SQL Service'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REMOTE_SQL_SERVERS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_remote_servers',
' where server_type = ''REMOTE_SQL''',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the remote database server.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2011608473553828)
,p_name=>'P3112_REMOTE_SOURCE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(68262651783279157)
,p_item_default=>'TABLE'
,p_prompt=>'Source Type'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXEC_REMOTE_SQL_DATA_SOURCE_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(1766286067212864)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Search Configuration using a Data Source of REST Enabled SQL Service can be based on a Table or SQL Query.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2012568661553828)
,p_name=>'P3112_REMOTE_SQL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(68262651783279157)
,p_prompt=>'Enter a SQL SELECT statement'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>6
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the SQL query that will produce the results for your Search Configuration, for example:',
'<pre>',
'select ename,',
'       job,',
'       sal',
'  from emp',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_05=>'P3112_REMOTE_SERVER_ID'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2013408052553829)
,p_name=>'P3112_REMOTE_TABLE_OWNER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(68262651783279157)
,p_prompt=>'Table / View Owner'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value d, column_value r',
'  from table( wwv_flow_remote_server_dev.get_available_objects( :P3112_REMOTE_SERVER_ID, ''SCHEMAS''))',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Current Schema'
,p_lov_cascade_parent_items=>'P3112_REMOTE_SERVER_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the owner of the table on which you are building a Search Configuration.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2014387897553829)
,p_name=>'P3112_REMOTE_TABLE_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(68262651783279157)
,p_prompt=>'Table / View Name'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value d, column_value r',
'  from table( wwv_flow_remote_server_dev.get_available_objects( :P3112_REMOTE_SERVER_ID, ''TABLE'', :P3112_REMOTE_TABLE_OWNER ))',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table or View -'
,p_lov_cascade_parent_items=>'P3112_REMOTE_TABLE_OWNER'
,p_ajax_items_to_submit=>'P3112_REMOTE_SERVER_ID'
,p_ajax_optimize_refresh=>'N'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the table or view on which the Search Configuration will be based.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2015941892553855)
,p_computation_sequence=>50
,p_computation_item=>'P3112_TABLE_OWNER'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_security.flow_owner(',
'           p_flow_id           => :FB_FLOW_ID,',
'           p_security_group_id => :WORKSPACE_ID );'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2016373604553856)
,p_computation_sequence=>50
,p_computation_item=>'UI_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P3112_TABLE_OWNER'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2019919265553858)
,p_validation_name=>'Local - SQL Not Null'
,p_validation_sequence=>10
,p_validation=>'P3112_SQL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'SQL must be specified.'
,p_validation_condition=>':P3112_SOURCE_TYPE = ''SQL'' and :P3112_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(2001554881553805)
,p_associated_item=>wwv_flow_imp.id(2006543810553824)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2020367413553858)
,p_validation_name=>'Local - is valid query'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_describe_result wwv_flow_exec_dev.t_describe_result;',
'begin',
'    l_describe_result := wwv_flow_exec_dev.check_and_describe (',
'                            p_location             => wwv_flow_exec_api.c_location_local_db,',
'                            p_query_type           => wwv_flow_exec_api.c_query_type_sql_query,',
'                            p_sql_query            => :P3112_SQL );',
'                            ',
'    return l_describe_result.error_message;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':P3112_SOURCE_TYPE = ''SQL'' and :P3112_LOCATION = ''LOCAL'' and :P3112_SQL is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(2001554881553805)
,p_associated_item=>wwv_flow_imp.id(2006543810553824)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2020789752553859)
,p_validation_name=>'P3112_TABLE_OWNER is not null'
,p_validation_sequence=>50
,p_validation=>'P3112_TABLE_OWNER'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>':P3112_SOURCE_TYPE = ''TABLE'' and :P3112_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(2001554881553805)
,p_associated_item=>wwv_flow_imp.id(2004726726553822)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1638166443313219)
,p_validation_name=>'P3112_GRAPH_NAME is not null'
,p_validation_sequence=>60
,p_validation=>'P3112_GRAPH_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>':P3112_SOURCE_TYPE = ''GRAPH'' and :P3112_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(2001554881553805)
,p_associated_item=>wwv_flow_imp.id(1636514143313203)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1640503819313243)
,p_validation_name=>'P3112_GRAPH_NAME exists'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from sys.dba_property_graphs',
' where owner      = :P3112_TABLE_OWNER',
'   and graph_name = :P3112_GRAPH_NAME'))
,p_validation_type=>'EXISTS'
,p_error_message=>'Graph &P3112_GRAPH_NAME!HTML. does not exist. Note that this name is case-sensitive.'
,p_validation_condition=>'sys.dbms_db_version.version >= 23 and :P3112_SOURCE_TYPE = ''GRAPH'' and :P3112_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(2001554881553805)
,p_associated_item=>wwv_flow_imp.id(1636514143313203)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1638210091313220)
,p_validation_name=>'P3112_PQL_MATCH_CLAUSE is not null'
,p_validation_sequence=>80
,p_validation=>'P3112_PQL_MATCH_CLAUSE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>':P3112_SOURCE_TYPE = ''GRAPH'' and :P3112_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(2001554881553805)
,p_associated_item=>wwv_flow_imp.id(1636433641313202)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1638301972313221)
,p_validation_name=>'P3112_PQL_COLUMNS_CLAUSE is not null'
,p_validation_sequence=>90
,p_validation=>'P3112_PQL_COLUMNS_CLAUSE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>':P3112_SOURCE_TYPE = ''GRAPH'' and :P3112_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(2001554881553805)
,p_associated_item=>wwv_flow_imp.id(1636759823313205)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2021191197553859)
,p_validation_name=>'Local - P3112_TABLE_NAME is not null'
,p_validation_sequence=>100
,p_validation=>'P3112_TABLE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Table name must be specified.'
,p_validation_condition=>':P3112_SOURCE_TYPE = ''TABLE'' and :P3112_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(2001554881553805)
,p_associated_item=>wwv_flow_imp.id(2005698411553823)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2019175516553858)
,p_validation_name=>'P3112_REMOTE_TABLE_NAME is not null'
,p_validation_sequence=>110
,p_validation=>'P3112_REMOTE_TABLE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Table name must be specified.'
,p_validation_condition=>':P3112_REMOTE_SOURCE_TYPE = ''TABLE'' and :P3112_LOCATION = ''REMOTE'' and :P3112_REMOTE_SERVER_ID is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(2001554881553805)
,p_associated_item=>wwv_flow_imp.id(2014387897553829)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2017573961553857)
,p_validation_name=>'P3112_REMOTE_SQL is not null'
,p_validation_sequence=>120
,p_validation=>'P3112_REMOTE_SQL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'SQL name must be specified.'
,p_validation_condition=>':P3112_REMOTE_SOURCE_TYPE = ''SQL'' and :P3112_LOCATION = ''REMOTE'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(2001554881553805)
,p_associated_item=>wwv_flow_imp.id(2012568661553828)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2017177911553856)
,p_validation_name=>'P3112_WEB_SRC_MODULE_ID is not null'
,p_validation_sequence=>130
,p_validation=>'P3112_WEB_SRC_MODULE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P3112_LOCATION'
,p_validation_condition2=>'WEB_SOURCE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(2001554881553805)
,p_associated_item=>wwv_flow_imp.id(2009531084553826)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2021526967553859)
,p_validation_name=>'P3112_COLUMNS is not null'
,p_validation_sequence=>140
,p_validation=>'P3112_COLUMNS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'A least one column must be selected.'
,p_validation_condition=>':P3112_SOURCE_TYPE = ''TABLE'' and :P3112_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(2001554881553805)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_required_patch=>wwv_flow_imp.id(170786031904296885)
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2019566296553858)
,p_validation_name=>'P3112_REMOTE_COLUMNS is not null'
,p_validation_sequence=>150
,p_validation=>'P3112_REMOTE_COLUMNS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'A least one column must be selected.'
,p_validation_condition=>':P3112_REMOTE_SOURCE_TYPE = ''TABLE'' and :P3112_LOCATION = ''REMOTE'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(2001554881553805)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_required_patch=>wwv_flow_imp.id(170786031904296885)
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2018763794553858)
,p_validation_name=>'P3112_WEB_SRC_COLUMNS is not null'
,p_validation_sequence=>160
,p_validation=>'P3112_WEB_SRC_COLUMNS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'A least one column must be selected.'
,p_validation_condition=>'P3112_LOCATION'
,p_validation_condition2=>'WEB_SOURCE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(2001554881553805)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_required_patch=>wwv_flow_imp.id(170786031904296885)
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2016724858553856)
,p_validation_name=>'P3112_REMOTE_SERVER_ID is not null'
,p_validation_sequence=>170
,p_validation=>'P3112_REMOTE_SERVER_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P3112_LOCATION'
,p_validation_condition2=>'REMOTE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(2001554881553805)
,p_associated_item=>wwv_flow_imp.id(2010703043553827)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2702192988067619)
,p_validation_name=>'Local - Table Exists'
,p_validation_sequence=>180
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_f4000_util.does_table_view_exist (',
'          p_owner       => :P3112_TABLE_OWNER,',
'          p_object_name => :P3112_TABLE_NAME );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Table &P3112_TABLE_NAME!HTML. does not exist. Note that the table name is case-sensitive.'
,p_validation_condition=>':P3112_SOURCE_TYPE = ''TABLE'' and :P3112_LOCATION = ''LOCAL'' and :P3112_TABLE_NAME is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(2005698411553823)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2022206488553861)
,p_name=>'SOURCE TYPE CHANGE HIDE ALL'
,p_event_sequence=>11
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3112_SOURCE_TYPE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2022796835553863)
,p_event_id=>wwv_flow_imp.id(2022206488553861)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3112_SQL,P3112_SQL,P3112_TABLE_OWNER,P3112_TABLE_NAME,P3112_GRAPH_NAME,P3112_PQL_MATCH_CLAUSE,P3112_PQL_COLUMNS_CLAUSE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2023663164553865)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2001170206553804)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2024102079553865)
,p_event_id=>wwv_flow_imp.id(2023663164553865)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2024573422553865)
,p_name=>'SOURCE TYPE = SQL'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3112_SOURCE_TYPE'
,p_condition_element=>'P3112_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SQL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2025087963553865)
,p_event_id=>wwv_flow_imp.id(2024573422553865)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3112_SQL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2025944869553866)
,p_name=>'SOURCE TYPE = TABLE'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3112_SOURCE_TYPE'
,p_condition_element=>'P3112_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TABLE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2026490112553866)
,p_event_id=>wwv_flow_imp.id(2025944869553866)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3112_TABLE_OWNER,P3112_TABLE_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1636880720313206)
,p_name=>'SOURCE TYPE = GRAPH'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3112_SOURCE_TYPE'
,p_condition_element=>'P3112_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'GRAPH'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1636930053313207)
,p_event_id=>wwv_flow_imp.id(1636880720313206)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3112_GRAPH_NAME,P3112_PQL_MATCH_CLAUSE,P3112_PQL_COLUMNS_CLAUSE,P3112_TABLE_OWNER'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2026860328553867)
,p_name=>'SOURCE TYPE = FUNC_BODY'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3112_SOURCE_TYPE'
,p_condition_element=>'P3112_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FUNC_BODY_RETURNING_SQL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2027301702553867)
,p_event_id=>wwv_flow_imp.id(2026860328553867)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3112_FUNC_BODY_LANG,P3112_FUNC_BODY'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2027753444553867)
,p_name=>'Location "LOCAL"'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3112_LOCATION'
,p_condition_element=>'P3112_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'LOCAL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2028229057553868)
,p_event_id=>wwv_flow_imp.id(2027753444553867)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(66471911938671229)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2028799826553868)
,p_event_id=>wwv_flow_imp.id(2027753444553867)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(66471911938671229)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2029139058553868)
,p_name=>'Location "REMOTE"'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3112_LOCATION'
,p_condition_element=>'P3112_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REMOTE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2029682733553869)
,p_event_id=>wwv_flow_imp.id(2029139058553868)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(68262651783279157)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2030119173553870)
,p_event_id=>wwv_flow_imp.id(2029139058553868)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(68262651783279157)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2030516731553870)
,p_name=>'Location "WEB_SRC"'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3112_LOCATION'
,p_condition_element=>'P3112_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'WEB_SOURCE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2031011244553871)
,p_event_id=>wwv_flow_imp.id(2030516731553870)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(66471997352671230)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2031517193553872)
,p_event_id=>wwv_flow_imp.id(2030516731553870)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(66471997352671230)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2031921213553872)
,p_name=>'REMOTE SOURCE TYPE = SQL'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3112_REMOTE_SOURCE_TYPE,P3112_REMOTE_SERVER_ID'
,p_condition_element=>'P3112_REMOTE_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SQL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2032492847553873)
,p_event_id=>wwv_flow_imp.id(2031921213553872)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3112_REMOTE_SQL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2033485157553874)
,p_event_id=>wwv_flow_imp.id(2031921213553872)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3112_REMOTE_TABLE_OWNER,P3112_REMOTE_TABLE_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2033933912553874)
,p_event_id=>wwv_flow_imp.id(2031921213553872)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3112_REMOTE_TABLE_OWNER,P3112_REMOTE_TABLE_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2034955752553875)
,p_event_id=>wwv_flow_imp.id(2031921213553872)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3112_REMOTE_SQL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2035373936553875)
,p_name=>'Remote Server chosen'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3112_REMOTE_SERVER_ID'
,p_condition_element=>'P3112_REMOTE_SERVER_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2035847160553876)
,p_event_id=>wwv_flow_imp.id(2035373936553875)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3112_REMOTE_SOURCE_TYPE,P3112_REMOTE_SQL,P3112_REMOTE_TABLE_OWNER,P3112_REMOTE_TABLE_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2036362837553876)
,p_event_id=>wwv_flow_imp.id(2035373936553875)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3112_REMOTE_SOURCE_TYPE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1532865435420605)
,p_name=>'Web Source Module is not null'
,p_event_sequence=>120
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3112_WEB_SRC_MODULE_ID'
,p_condition_element=>'P3112_WEB_SRC_MODULE_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1532980161420606)
,p_event_id=>wwv_flow_imp.id(1532865435420605)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3112_WEB_SRC_ARRAY_COL_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1533030438420607)
,p_event_id=>wwv_flow_imp.id(1532865435420605)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3112_WEB_SRC_ARRAY_COL_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1533125807420608)
,p_event_id=>wwv_flow_imp.id(1532865435420605)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3112_WEB_SRC_ARRAY_COL_ID'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2702037554067618)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load Search Cofig Columns Collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_search_dev.init_column_collection (',
'    p_column_collection      => ''APEX$SEARCH_CONFIG_COLUMNS'',',
'    --',
'    p_application_id         => :FB_FLOW_ID,',
'    p_search_type            => wwv_flow_search.c_search_type_simple,',
'    --',
'    p_location               => :P3112_LOCATION,',
'    p_query_type             => case :P3112_LOCATION',
'                                    when wwv_flow_exec_api.c_location_local_db then :P3112_SOURCE_TYPE',
'                                    when wwv_flow_exec_api.c_location_remote_db then :P3112_REMOTE_SOURCE_TYPE',
'                                end,',
'    p_owner                  => case',
'                                   when :P3112_LOCATION = wwv_flow_exec_api.c_location_local_db and :P3112_SOURCE_TYPE in ( wwv_flow_exec_api.c_query_type_table, ',
'                                                                                                                            wwv_flow_exec_api.c_query_type_graph ) then',
'                                       :P3112_TABLE_OWNER',
'                                   when :P3112_LOCATION = wwv_flow_exec_api.c_location_remote_db and :P3112_REMOTE_SOURCE_TYPE = wwv_flow_exec_api.c_query_type_table then',
'                                       :P3112_REMOTE_TABLE_OWNER',
'                                end,',
'    p_table_name             => case',
'                                   when :P3112_LOCATION = wwv_flow_exec_api.c_location_local_db and :P3112_SOURCE_TYPE =  wwv_flow_exec_api.c_query_type_table then',
'                                       :P3112_TABLE_NAME',
'                                   when :P3112_LOCATION = wwv_flow_exec_api.c_location_local_db and :P3112_SOURCE_TYPE =  wwv_flow_exec_api.c_query_type_graph then',
'                                       :P3112_GRAPH_NAME',
'                                   when :P3112_LOCATION = wwv_flow_exec_api.c_location_remote_db and :P3112_REMOTE_SOURCE_TYPE = wwv_flow_exec_api.c_query_type_table then',
'                                       :P3112_REMOTE_TABLE_NAME',
'                                end,',
'    p_sql_query              => case',
'                                    when :P3112_LOCATION = wwv_flow_exec_api.c_location_local_db and :P3112_SOURCE_TYPE = wwv_flow_exec_api.c_query_type_sql_query then',
'                                        :P3112_SQL',
'                                    when :P3112_LOCATION = wwv_flow_exec_api.c_location_remote_db and :P3112_REMOTE_SOURCE_TYPE = wwv_flow_exec_api.c_query_type_sql_query then',
'                                        :P3112_REMOTE_SQL',
'                                end,',
'    p_match_clause           => case ',
'                                    when :P3112_LOCATION = wwv_flow_exec_api.c_location_local_db and :P3112_SOURCE_TYPE = wwv_flow_exec_api.c_query_type_graph then',
'                                        :P3112_PQL_MATCH_CLAUSE',
'                                end,                                ',
'    p_columns_clause         => case ',
'                                    when :P3112_LOCATION = wwv_flow_exec_api.c_location_local_db and :P3112_SOURCE_TYPE = wwv_flow_exec_api.c_query_type_graph then',
'                                        :P3112_PQL_COLUMNS_CLAUSE',
'                                end,',
'    --',
'    p_remote_server_id       => case when :P3112_LOCATION = wwv_flow_exec_api.c_location_remote_db then',
'                                    :P3112_REMOTE_SERVER_ID',
'                                end,',
'    p_web_src_module_id      => case when :P3112_LOCATION = wwv_flow_exec_api.c_location_rest_source then',
'                                    :P3112_WEB_SRC_MODULE_ID',
'                                end,',
'    p_web_src_array_col_id   => case when :P3112_LOCATION = wwv_flow_exec_api.c_location_rest_source then',
'                                    :P3112_WEB_SRC_ARRAY_COL_ID',
'                                end,                                ',
'    --',
'    p_extended_describe      => true );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2702037554067618
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2832020264926540)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update APEX Dictionary Cache'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_object_type wwv_flow_tables_views_dev.object_type%type;',
'begin',
'    select object_type',
'      into l_object_type',
'      from wwv_flow_tables_views_dev',
'     where owner       = :P3112_TABLE_OWNER',
'       and object_name = :P3112_TABLE_NAME;',
'',
'    --- if table, set APEX dictionary cache',
'    if l_object_type = ''TABLE'' then',
'        wwv_dictionary_cache_dev.set_dictionary_table_cache(',
'             p_workspace_name          => htmldb_util.find_workspace( p_security_group_id => :WORKSPACE_ID ),',
'             p_schema                  => :P3112_TABLE_OWNER,',
'             p_table_name              => :P3112_TABLE_NAME,',
'             p_flow_id                 => :FB_FLOW_ID,',
'             p_cache_fk_references     => true );',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':P3112_LOCATION = ''LOCAL'' and :P3112_SOURCE_TYPE = ''TABLE'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>2832020264926540
);
end;
/
prompt --application/pages/page_03113
begin
wwv_flow_imp_page.create_page(
 p_id=>3113
,p_name=>'Create Search Configuration'
,p_alias=>'CREATE-SEARCH-CONFIG-COL-MAP'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Search Configuration'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(1449603451873552)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'600'
,p_dialog_width=>'80%'
,p_dialog_max_width=>'1000'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2700492092067602)
,p_plug_name=>'Oracle Text Index Source'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3857819080271388133)
,p_plug_name=>'wizard progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_list_id=>wwv_flow_imp.id(1957878877823352)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3857819098699388134)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2013451442947116)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(3857819098699388134)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2013736791948222)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(3857819098699388134)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1924276190739810)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(3857819098699388134)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:3111:&SESSION.::&DEBUG.:RP,::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1935744793739839)
,p_branch_name=>'Go To Column Mapping'
,p_branch_action=>'f?p=&APP_ID.:3114:&SESSION.::&DEBUG.::P3114_PREV_PAGE:&APP_PAGE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2028539416077540)
,p_name=>'P3113_ORATEXT_TABLE_OWNER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2700492092067602)
,p_prompt=>'Table / View Owner'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_SCHEMAS_HAVE_PRIVS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(owner) d, owner v',
'  from wwv_flow_object_owners_dev',
'order by d                   '))
,p_lov_cascade_parent_items=>'P3112_SOURCE_TYPE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the owner of the table on which you are building a Search Configuration.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2029386667079399)
,p_name=>'P3113_ORATEXT_TABLE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2700492092067602)
,p_prompt=>'Table / View Name'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = :P3113_ORATEXT_TABLE_OWNER',
'   and :P3113_ORATEXT_SOURCE_TYPE = ''TABLE'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Value -'
,p_lov_cascade_parent_items=>'P3113_ORATEXT_TABLE_OWNER'
,p_ajax_items_to_submit=>'P3113_ORATEXT_SOURCE_TYPE'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the table or view which contains column(s) with Oracle Text index.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7133869467811503)
,p_name=>'P3113_ORATEXT_SOURCE_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2700492092067602)
,p_item_default=>'TABLE'
,p_prompt=>'Source Type'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXEC_QUERY_TYPES.TABLE_OR_SQL'
,p_lov=>'.'||wwv_flow_imp.id(6900320112159786)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the source of the search configuration. Oracle Text search data source can be based on a Table or SQL Query. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7134420192811509)
,p_name=>'P3113_ORATEXT_SQL'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(2700492092067602)
,p_prompt=>'Enter a SQL SELECT statement'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>6
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the SQL query that will produce the results for your search configuration, for example:',
'<pre>',
'select empno, ename, job, sal, deptno',
'  from emp',
'</pre>'))
,p_attribute_01=>'SQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2303997397420893)
,p_validation_name=>'Table Exists'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_f4000_util.does_table_view_exist (',
'          p_owner       => :P3113_ORATEXT_TABLE_OWNER,',
'          p_object_name => :P3113_ORATEXT_TABLE_NAME );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Table &P3113_ORATEXT_TABLE_NAME!HTML. does not exist. Note that the table name is case-sensitive.'
,p_validation_condition=>'P3113_ORATEXT_TABLE_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(2013736791948222)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(7135259974811517)
,p_validation_name=>'tabel owner not null'
,p_validation_sequence=>20
,p_validation=>'P3113_ORATEXT_TABLE_OWNER'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'P3113_ORATEXT_SOURCE_TYPE'
,p_validation_condition2=>'TABLE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(2013736791948222)
,p_associated_item=>wwv_flow_imp.id(2028539416077540)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(7135360182811518)
,p_validation_name=>'table name not null'
,p_validation_sequence=>30
,p_validation=>'P3113_ORATEXT_TABLE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'P3113_ORATEXT_SOURCE_TYPE'
,p_validation_condition2=>'TABLE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(2013736791948222)
,p_associated_item=>wwv_flow_imp.id(2029386667079399)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(7135490565811519)
,p_validation_name=>'SQL not null'
,p_validation_sequence=>40
,p_validation=>'P3113_ORATEXT_SQL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'P3113_ORATEXT_SOURCE_TYPE'
,p_validation_condition2=>'SQL'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(2013736791948222)
,p_associated_item=>wwv_flow_imp.id(7134420192811509)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1928981190739833)
,p_name=>'Refresh on First Line Headers Change'
,p_event_sequence=>75
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3113_FIRST_LINE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1929438787739833)
,p_event_id=>wwv_flow_imp.id(1928981190739833)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1929855445739834)
,p_name=>'Refresh XLSX sheet change'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3113_XLSX_SHEET'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1930360795739834)
,p_event_id=>wwv_flow_imp.id(1929855445739834)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1930729445739834)
,p_name=>'Refresh Enclosed By Change'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3113_CSV_ENCLOSED'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1931249829739834)
,p_event_id=>wwv_flow_imp.id(1930729445739834)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1931624079739835)
,p_name=>'Refresh File Charset Change'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3113_FILE_CHARSET'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1932189391739835)
,p_event_id=>wwv_flow_imp.id(1931624079739835)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1933480484739836)
,p_name=>'Refresh column delimiter change'
,p_event_sequence=>130
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3113_CSV_COL_DELIMITER'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1933985263739836)
,p_event_id=>wwv_flow_imp.id(1933480484739836)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1934399983739836)
,p_name=>'Refresh Skip Rows Change'
,p_event_sequence=>140
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3113_SKIP_ROWS'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1934843863739836)
,p_event_id=>wwv_flow_imp.id(1934399983739836)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2701502343067613)
,p_name=>'Cancel Dialog'
,p_event_sequence=>150
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2013451442947116)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2701604291067614)
,p_event_id=>wwv_flow_imp.id(2701502343067613)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(7133930083811504)
,p_name=>'SOURCE_TYPE = TABLE'
,p_event_sequence=>160
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3113_ORATEXT_SOURCE_TYPE'
,p_condition_element=>'P3113_ORATEXT_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TABLE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7134014228811505)
,p_event_id=>wwv_flow_imp.id(7133930083811504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3113_ORATEXT_TABLE_OWNER,P3113_ORATEXT_TABLE_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7134113488811506)
,p_event_id=>wwv_flow_imp.id(7133930083811504)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3113_ORATEXT_TABLE_OWNER,P3113_ORATEXT_TABLE_NAME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(7134261361811507)
,p_name=>'SOURCE_TYPE = SQL'
,p_event_sequence=>170
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3113_ORATEXT_SOURCE_TYPE'
,p_condition_element=>'P3113_ORATEXT_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SQL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7134359083811508)
,p_event_id=>wwv_flow_imp.id(7134261361811507)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3113_ORATEXT_SQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7134510703811510)
,p_event_id=>wwv_flow_imp.id(7134261361811507)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3113_ORATEXT_SQL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3002362454634000)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load Search Cofig Columns Collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_search_dev.init_column_collection (',
'    p_column_collection      => ''APEX$SEARCH_CONFIG_COLUMNS'',',
'    --',
'    p_application_id         => :FB_FLOW_ID,',
'    p_search_type            => wwv_flow_search.c_search_type_text_manual,',
'    --',
'    p_location               => wwv_flow_exec_api.c_location_local_db,',
'    p_query_type             => :P3113_ORATEXT_SOURCE_TYPE,',
'    p_owner                  => :P3113_ORATEXT_TABLE_OWNER,',
'    p_table_name             => :P3113_ORATEXT_TABLE_NAME,',
'    p_sql_query              => :P3113_ORATEXT_SQL,',
'    --',
'    p_extended_describe      => true );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>3002362454634000
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2941633980918838)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update APEX Dictionary Cache'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_object_type wwv_flow_tables_views_dev.object_type%type;',
'begin',
'    select object_type',
'      into l_object_type',
'      from wwv_flow_tables_views_dev',
'     where owner       = :P3113_ORATEXT_TABLE_OWNER',
'       and object_name = :P3113_ORATEXT_TABLE_NAME;',
'',
'    --- if table, set APEX dictionary cache',
'    if l_object_type = ''TABLE'' then',
'        wwv_dictionary_cache_dev.set_dictionary_table_cache(',
'             p_workspace_name          => htmldb_util.find_workspace( p_security_group_id => :WORKSPACE_ID ),',
'             p_schema                  => :P3113_ORATEXT_TABLE_OWNER,',
'             p_table_name              => :P3113_ORATEXT_TABLE_NAME,',
'             p_flow_id                 => :FB_FLOW_ID,',
'             p_cache_fk_references     => true );',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P3113_ORATEXT_SOURCE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'TABLE'
,p_internal_uid=>2941633980918838
);
end;
/
prompt --application/pages/page_03114
begin
wwv_flow_imp_page.create_page(
 p_id=>3114
,p_name=>'Create Search Configuration'
,p_alias=>'CREATE-SEARCH-CONFIGURATION'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Search Configuration'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(1449603451873552)
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// reposition icon picker',
'apex.jQuery("#P3114_ICON_CSS_CLASSES").after(apex.jQuery("button#icon_picker"));'))
,p_css_file_urls=>'#FONT_APEX_LATEST_DIRECTORY#css/font-apex#MIN#.css'
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'600'
,p_dialog_width=>'80%'
,p_dialog_max_width=>'1000'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4701751925001058)
,p_plug_name=>'Column Mapping'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3859820340104321589)
,p_plug_name=>'wizard progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_list_id=>wwv_flow_imp.id(1957878877823352)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3859820358532321590)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8433562623230347)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_imp.id(4701751925001058)
,p_button_name=>'ICON'
,p_button_static_id=>'icon_picker'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Select Icon'
,p_button_redirect_url=>'f?p=&APP_ID.:181:&SESSION.::&DEBUG.::P181_PASS_BACK_TO_UI,P181_PASS_BACK_TO_SAVE:icon_picker,P3114_ICON_CSS_CLASSES'
,p_button_css_classes=>'a-Button--colorPicker'
,p_icon_css_classes=>'fa &P3114_ICON_CSS_CLASSES.'
,p_grid_new_row=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2016120148976171)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(3859820358532321590)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2004081070933485)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(3859820358532321590)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Search Configuration'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2004423860933486)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(3859820358532321590)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:&P3114_PREV_PAGE.:&SESSION.::&DEBUG.:RP,::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2010763281933508)
,p_branch_name=>'Go To Page3100'
,p_branch_action=>'f?p=&APP_ID.:3120:&SESSION.::&DEBUG.:3120:P3120_ID:&P3114_NEW_SEARCH_CONFIG_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2004081070933485)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2001826903933477)
,p_name=>'P3114_PK_COL'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(4701751925001058)
,p_prompt=>'Primary Key Column'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_search_dev.get_pk_column_name(',
'    p_application_id        => :FB_FLOW_ID,',
'    p_search_type           => :P3111_SEARCH_TYPE,',
'    --',
'    p_list_id               => :P3111_LIST_ID );'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P3114.SEARCH_CONFIG.COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 column_display,',
'       case when :P3111_SEARCH_TYPE = ''APEX_LIST'' then',
'           to_char( seq_id ) ',
'       else',
'           c002',
'       end column_return,',
'      seq_id column_id',
' from wwv_flow_collections',
'where collection_name = ''APEX$SEARCH_CONFIG_COLUMNS'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the primary key column for the Search Configuration Data Source.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2002256248933480)
,p_name=>'P3114_TITLE_COL'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(4701751925001058)
,p_prompt=>'Title Column'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_search_dev.get_title_column_name(',
'    p_application_id         => :FB_FLOW_ID,',
'    p_search_type            => :P3111_SEARCH_TYPE,',
'    --',
'    p_list_id                => :P3111_LIST_ID,',
'    --',
'    p_location               => :P3112_LOCATION,',
'    p_query_type             => :P3112_SOURCE_TYPE,',
'    p_owner                  => :P3112_TABLE_OWNER,',
'    p_table_name             => :P3112_TABLE_NAME );'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P3114.SEARCH_CONFIG.COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 column_display,',
'       case when :P3111_SEARCH_TYPE = ''APEX_LIST'' then',
'           to_char( seq_id ) ',
'       else',
'           c002',
'       end column_return,',
'      seq_id column_id',
' from wwv_flow_collections',
'where collection_name = ''APEX$SEARCH_CONFIG_COLUMNS'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the column to be used as title.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2003004427933481)
,p_name=>'P3114_DESCRIPTION_COL'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(4701751925001058)
,p_prompt=>'Description Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P3114.SEARCH_CONFIG.COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 column_display,',
'       case when :P3111_SEARCH_TYPE = ''APEX_LIST'' then',
'           to_char( seq_id ) ',
'       else',
'           c002',
'       end column_return,',
'      seq_id column_id',
' from wwv_flow_collections',
'where collection_name = ''APEX$SEARCH_CONFIG_COLUMNS'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the column to be used as description.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2605585682143305)
,p_name=>'P3114_NEW_SEARCH_CONFIG_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(4701751925001058)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2701219139067610)
,p_name=>'P3114_PREV_PAGE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(4701751925001058)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2703795710286201)
,p_name=>'P3114_ICON_TYPE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(4701751925001058)
,p_item_default=>'INITIALS'
,p_prompt=>'Icon Source'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'SEARCH_CONFIG.ICON_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(2302791576703581)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select the type for the icon that is displayed in the header of the search result.<p />',
'<ul>',
'  <li>',
'    <strong>Initials:</strong>',
'    The <em>Title</em> column will be used to display the icon as initials. ',
'  </li>',
'  <li>',
'    <strong>CSS Classes:</strong>',
'    The entered CSS classes will be used to display the icon.',
'  </li>',
'   <li>',
'    <strong>Class Column:</strong>',
'    The selected column containing the icon CSS class will be used to display the icon.',
'  </li>',
'</ul>'))
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
,p_attribute_04=>'VERTICAL'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2703848466286202)
,p_name=>'P3114_ICON_CLASS_COL'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(4701751925001058)
,p_prompt=>'Icon Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P3114.SEARCH_CONFIG.COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 column_display,',
'       case when :P3111_SEARCH_TYPE = ''APEX_LIST'' then',
'           to_char( seq_id ) ',
'       else',
'           c002',
'       end column_return,',
'      seq_id column_id',
' from wwv_flow_collections',
'where collection_name = ''APEX$SEARCH_CONFIG_COLUMNS'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the column to be used as icon image source.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2711596032330939)
,p_name=>'P3114_ICON_CSS_CLASSES'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(4701751925001058)
,p_prompt=>'Icon CSS Classes'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_css_classes=>'apex-item-group--color-picker'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the classes for the icon you want to display in the search result.',
'<br><br>',
'<strong>Using Universal Theme</strong>',
'<br>',
'Most Universal Theme apps use the Font APEX icon library. To pick an icon, use the built-in icon picker and select an icon from the popup window. See examples below:<br><br>',
'<ul>',
'    <li><code>fa-cloud</code> - displays the cloud icon</li>',
'    <li><code>fa-exclamation-circle u-danger-text</code> - displays a red exclamation icon</li>',
'</ul>',
'<br>',
'You can see more examples on the  <a rel="noopener noreferrer" href="https://apex.oracle.com/fontapex" target="_blank">Icons</a> page of the <a rel="noopener noreferrer" href="https://apex.oracle.com/ut" target="_blank">Universal Theme sample app</a>'
||'.'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7214264245537802)
,p_name=>'P3114_ORATEXT_INDEX_COLUMN'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(4701751925001058)
,p_prompt=>'Oracle Text Index Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001   column_display,',
'       c002   column_return',
' from wwv_flow_collections',
'where collection_name = ''APEX$SEARCH_CONFIG_COLUMNS''',
'  and c003 in ( ''VARCHAR2'', ''CLOB'', ''BLOB'' )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_display_when=>'P3111_SEARCH_TYPE'
,p_display_when2=>'TEXT_MANUAL'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the Oracle Index enabled column.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(7135105595811516)
,p_validation_name=>'Oracle Text Index Column Not Null'
,p_validation_sequence=>10
,p_validation=>'P3114_ORATEXT_INDEX_COLUMN'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'P3111_SEARCH_TYPE'
,p_validation_condition2=>'TEXT_MANUAL'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(2004081070933485)
,p_associated_item=>wwv_flow_imp.id(7214264245537802)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2605365529143303)
,p_validation_name=>'Icon Class Column Required'
,p_validation_sequence=>20
,p_validation=>'P3114_ICON_CLASS_COL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'P3114_ICON_TYPE'
,p_validation_condition2=>'DYNAMIC_CLASS'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(2004081070933485)
,p_associated_item=>wwv_flow_imp.id(2703848466286202)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2605447726143304)
,p_validation_name=>'Icon CSS required'
,p_validation_sequence=>30
,p_validation=>'P3114_ICON_CSS_CLASSES'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'P3114_ICON_TYPE'
,p_validation_condition2=>'STATIC_CLASS'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(2004081070933485)
,p_associated_item=>wwv_flow_imp.id(2711596032330939)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2005241383933501)
,p_name=>'Refresh on First Line Headers Change'
,p_event_sequence=>75
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3114_FIRST_LINE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2005787583933504)
,p_event_id=>wwv_flow_imp.id(2005241383933501)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2006125894933504)
,p_name=>'Refresh XLSX sheet change'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3114_XLSX_SHEET'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2006605500933505)
,p_event_id=>wwv_flow_imp.id(2006125894933504)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2007027179933505)
,p_name=>'Refresh Enclosed By Change'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3114_CSV_ENCLOSED'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2007541978933505)
,p_event_id=>wwv_flow_imp.id(2007027179933505)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2007973811933505)
,p_name=>'Refresh File Charset Change'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3114_FILE_CHARSET'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2008488077933506)
,p_event_id=>wwv_flow_imp.id(2007973811933505)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2008872562933506)
,p_name=>'Refresh column delimiter change'
,p_event_sequence=>130
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3114_CSV_COL_DELIMITER'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2009389174933506)
,p_event_id=>wwv_flow_imp.id(2008872562933506)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2009762262933507)
,p_name=>'Refresh Skip Rows Change'
,p_event_sequence=>140
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3114_SKIP_ROWS'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2010220537933507)
,p_event_id=>wwv_flow_imp.id(2009762262933507)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2701333069067611)
,p_name=>'Cancel Dialog'
,p_event_sequence=>150
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2016120148976171)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2701444756067612)
,p_event_id=>wwv_flow_imp.id(2701333069067611)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2703960655286203)
,p_name=>'ICON_TYPE = DYNAMIC'
,p_event_sequence=>160
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3114_ICON_TYPE'
,p_condition_element=>'P3114_ICON_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'DYNAMIC_CLASS'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2704032594286204)
,p_event_id=>wwv_flow_imp.id(2703960655286203)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3114_ICON_CLASS_COL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2704191697286205)
,p_event_id=>wwv_flow_imp.id(2703960655286203)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3114_ICON_CLASS_COL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2704637859286210)
,p_name=>'ICON_TYPE = STATIC'
,p_event_sequence=>170
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3114_ICON_TYPE'
,p_condition_element=>'P3114_ICON_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'STATIC_CLASS'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2605105779143301)
,p_event_id=>wwv_flow_imp.id(2704637859286210)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3114_ICON_CSS_CLASSES'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2605215071143302)
,p_event_id=>wwv_flow_imp.id(2704637859286210)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3114_ICON_CSS_CLASSES'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(8433743307230349)
,p_name=>'Set default Icon if Icon Class is null'
,p_event_sequence=>180
,p_condition_element=>'P3114_ICON_CSS_CLASSES'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8433845023230350)
,p_event_id=>wwv_flow_imp.id(8433743307230349)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'$(''#icon_picker'').find(''span'').removeClass(''a-Icon fa '').addClass(''a-Icon icon-open-in-dialog'');'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2004803505933499)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create search configuration'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P3114_NEW_SEARCH_CONFIG_ID := wwv_flow_search_dev.create_search_config (',
'                                   p_application_id             => :FB_FLOW_ID,',
'                                   --',
'                                   p_label                      => initcap( :P3111_LABEL ),',
'                                   p_search_type                => :P3111_SEARCH_TYPE,',
'                                   --',
'                                   p_list_id                    => :P3111_LIST_ID,',
'                                   --',
'                                   p_location                   => :P3112_LOCATION,',
'                                   --',
'                                   p_local_query_type           => :P3112_SOURCE_TYPE,',
'                                   p_local_table_owner          => :P3112_TABLE_OWNER,',
'                                   p_local_table_name           => :P3112_TABLE_NAME,',
'                                   p_local_query_source         => :P3112_SQL,',
'                                   --',
'                                   p_local_graph_name           => :P3112_GRAPH_NAME,',
'                                   p_local_pql_match_clause     => :P3112_PQL_MATCH_CLAUSE,',
'                                   p_local_pql_columns_clause   => :P3112_PQL_COLUMNS_CLAUSE,',
'                                   --',
'                                   p_remote_server_id           => :P3112_REMOTE_SERVER_ID,',
'                                   p_remote_query_type          => :P3112_REMOTE_SOURCE_TYPE,',
'                                   p_remote_table_owner         => :P3112_REMOTE_TABLE_OWNER,',
'                                   p_remote_table_name          => :P3112_REMOTE_TABLE_NAME,',
'                                   p_remote_query_source        => :P3112_REMOTE_SQL,',
'                                   --',
'                                   p_oratext_query_type         => :P3113_ORATEXT_SOURCE_TYPE,',
'                                   p_oratext_table_owner        => :P3113_ORATEXT_TABLE_OWNER,',
'                                   p_oratext_table_name         => :P3113_ORATEXT_TABLE_NAME,',
'                                   p_oratext_query_source       => :P3113_ORATEXT_SQL,',
'                                   p_oratext_index_column_name  => :P3114_ORATEXT_INDEX_COLUMN,',
'                                   --',
'                                   p_dbms_search_index_owner    => :P3118_SEARCH_INDEX_OWNER,',
'                                   p_dbms_search_index_name     => :P3118_SEARCH_INDEX_NAME,',
'                                   p_dbms_search_source_owner   => :P3118_SEARCH_SOURCE_OWNER,',
'                                   p_dbms_search_source_name    => :P3118_SEARCH_SOURCE_NAME,',
'                                   --',
'                                   p_web_source_module_id       => :P3112_WEB_SRC_MODULE_ID,  ',
'                                   p_web_source_array_column_id => :P3112_WEB_SRC_ARRAY_COL_ID,                         ',
'                                   --',
'                                   p_pk_column_name             => :P3114_PK_COL,',
'                                   p_title_column_name          => :P3114_TITLE_COL,',
'                                   p_description_column_name    => :P3114_DESCRIPTION_COL,',
'                                   p_icon_source_type           => :P3114_ICON_TYPE,',
'                                   p_icon_class_column_name     => :P3114_ICON_CLASS_COL,',
'                                   p_icon_css_classes           => :P3114_ICON_CSS_CLASSES );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2004081070933485)
,p_process_success_message=>'Search configuration created.'
,p_internal_uid=>2004803505933499
);
end;
/
prompt --application/pages/page_03115
begin
wwv_flow_imp_page.create_page(
 p_id=>3115
,p_name=>'Search Configuration'
,p_alias=>'SEARCH-CONFIGURATION5'
,p_step_title=>'Search Configuration'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'11'
);
end;
/
prompt --application/pages/page_03116
begin
wwv_flow_imp_page.create_page(
 p_id=>3116
,p_name=>'Copy Search Configuration'
,p_alias=>'COPY-SEARCH-CONFIGURATION'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Search Configuration'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(51018875326898953)
,p_plug_name=>'Wizard Button'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(235764393399043642)
,p_plug_name=>'Copy Search Configuration'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4603276813271773)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(51018875326898953)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4603602494271774)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(51018875326898953)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4615820466271826)
,p_branch_name=>'Go to Edit Search Config after Copy'
,p_branch_action=>'f?p=&APP_ID.:3120:&SESSION.::&DEBUG.:3120:P3120_ID:&P3116_COPY_NEW_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(4603602494271774)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1962111819817302)
,p_name=>'P3116_COPY_NEW_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(235764393399043642)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4604326718271786)
,p_name=>'P3116_COPY_SOURCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(235764393399043642)
,p_item_default=>'THIS'
,p_prompt=>'Copy From'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'COPY_SOURCE'
,p_lov=>'.'||wwv_flow_imp.id(9000141896148406)||'.'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose whether to copy the search configuration from this application or from another application.'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4605207475271792)
,p_name=>'P3116_COPY_FROM_APP_ID'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(235764393399043642)
,p_prompt=>'Application'
,p_source=>'&FB_FLOW_ID.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d,',
'       f.id r',
'  from wwv_flow_visible_flows f',
' where (:P3116_COPY_SOURCE = ''THIS''  and f.id = :FB_FLOW_ID)',
'    or (:P3116_COPY_SOURCE = ''OTHER'' and f.id != :FB_FLOW_ID)',
' order by 2'))
,p_lov_cascade_parent_items=>'P3116_COPY_SOURCE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Select the application from which you want to copy search configuration.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4606159534271793)
,p_name=>'P3116_COPY_FROM_ID'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(235764393399043642)
,p_prompt=>'Copy Search Configuration'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(label) search_label, id',
'  from wwv_flow_search_configs',
' where flow_id           = :P3116_COPY_FROM_APP_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
' order by label'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Search Configuration -'
,p_lov_cascade_parent_items=>'P3116_COPY_FROM_APP_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the search configuration to copy.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4607048281271794)
,p_name=>'P3116_SUBSCRIBE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(235764393399043642)
,p_item_default=>'Y'
,p_prompt=>'Subscribe'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'While copying the search configuration, you can also subscribe to it. Set Subscribe to <strong>On</strong> to subscribe to the search configuration.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4607965730271794)
,p_name=>'P3116_NEW_LABEL'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(235764393399043642)
,p_prompt=>'New Search Configuration Label'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identify the label of the search configuration you would like to create.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4609322338271814)
,p_validation_name=>'P3116_NEW_LABEL Not Null'
,p_validation_sequence=>30
,p_validation=>'P3116_NEW_LABEL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'P3116_SUBSCRIBE'
,p_validation_condition2=>'N'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(4603602494271774)
,p_associated_item=>wwv_flow_imp.id(4607965730271794)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(9470401036569845)
,p_validation_name=>'Search Config Name is unique'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_search_configs',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and label             = :P3116_NEW_LABEL'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'The Label "&P3116_NEW_LABEL!HTML." is already taken by another Search Configuration.'
,p_when_button_pressed=>wwv_flow_imp.id(4603602494271774)
,p_associated_item=>wwv_flow_imp.id(4607965730271794)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(9470553306569846)
,p_validation_name=>'Search Config Static ID is unique'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_search_configs',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and static_id         = regexp_replace( lower( :P3116_NEW_LABEL ), ''[^abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890]+'', ''_'' )'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'The REST Source name "&P3116_NEW_LABEL!HTML." will lead to a Static ID which is already taken by another Search Configuration.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_search_configs',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and label             = :P3116_NEW_LABEL'))
,p_validation_condition_type=>'NOT_EXISTS'
,p_when_button_pressed=>wwv_flow_imp.id(4603602494271774)
,p_associated_item=>wwv_flow_imp.id(4607965730271794)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4610053873271816)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(4603276813271773)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4610556386271821)
,p_event_id=>wwv_flow_imp.id(4610053873271816)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4610904530271821)
,p_name=>'On Change of P3116_COPY_SOURCE'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3116_COPY_SOURCE'
,p_condition_element=>'P3116_COPY_SOURCE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'THIS'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4611425614271822)
,p_event_id=>wwv_flow_imp.id(4610904530271821)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3116_COPY_FROM_APP_ID,P3116_SUBSCRIBE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4611968496271822)
,p_event_id=>wwv_flow_imp.id(4610904530271821)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3116_COPY_FROM_APP_ID,P3116_SUBSCRIBE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4612476508271822)
,p_event_id=>wwv_flow_imp.id(4610904530271821)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3116_COPY_FROM_APP_ID'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'&FB_FLOW_ID.'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4612901366271823)
,p_event_id=>wwv_flow_imp.id(4610904530271821)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3116_SUBSCRIBE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4613425522271823)
,p_event_id=>wwv_flow_imp.id(4610904530271821)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3116_COPY_FROM_APP_ID'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4613904647271824)
,p_event_id=>wwv_flow_imp.id(4610904530271821)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3116_SUBSCRIBE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4614392291271824)
,p_name=>'Toggle P3116_LABEL display'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3116_SUBSCRIBE'
,p_condition_element=>'P3116_SUBSCRIBE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4614834298271825)
,p_event_id=>wwv_flow_imp.id(4614392291271824)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3116_NEW_LABEL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4615395291271825)
,p_event_id=>wwv_flow_imp.id(4614392291271824)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3116_NEW_LABEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4609625801271814)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'copy search configuration'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P3116_COPY_NEW_ID := wwv_flow_search_dev.copy_search_config (',
'                          p_from_application_id   => :P3116_COPY_FROM_APP_ID,',
'                          p_from_search_config_id => :P3116_COPY_FROM_ID,',
'                          p_to_application_id     => :FB_FLOW_ID,',
'                          p_to_name               => :P3116_NEW_LABEL,',
'                          p_subscribe             => :P3116_SUBSCRIBE = ''Y'' );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to copy Search Configuration'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(4603602494271774)
,p_process_success_message=>'Search Configuration Copied'
,p_internal_uid=>4609625801271814
);
end;
/
prompt --application/pages/page_03117
begin
wwv_flow_imp_page.create_page(
 p_id=>3117
,p_name=>'Create Search Page'
,p_alias=>'CREATE-SEARCH-PAGE'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Search Page'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(103848364625132731)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_css_classes=>'a-Dialog--CreatePageDialog'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_protection_level=>'C'
,p_page_component_map=>'11'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(80280621823637562)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(913042247896178549)
,p_plug_name=>'No Search Configuration Defined'
,p_region_template_options=>'#DEFAULT#:a-Alert--info:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>There are no Search Configurations defined for this application.</p>',
'',
'<p> A <strong>Search Configuration</strong> is a shared collection of searchable data, ',
'which contains information about the <em>Data Source</em> and the functionality used',
'for search as well as display properties.</p>',
'',
'<p>Search Configurations can be created in <strong>Shared Components</strong> and then can be used in your application.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'Y',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3201533971849480)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(80280621823637562)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:2500:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3201912786849481)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(80280621823637562)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3208376413849515)
,p_branch_name=>'Go to Page 2501 - Page Definition'
,p_branch_action=>'f?p=&APP_ID.:2501:&SESSION.::&DEBUG.::P2501_PREV_PAGE:2509&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3205218682849508)
,p_validation_name=>'P3117_REGION_TYPE not null'
,p_validation_sequence=>10
,p_validation=>'P3117_REGION_TYPE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Please select a plug-in.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3205533416849509)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3201912786849481)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3206066799849511)
,p_event_id=>wwv_flow_imp.id(3205533416849509)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3207369413849512)
,p_name=>'Validation Error - Scroll to Top'
,p_event_sequence=>30
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3207810646849513)
,p_event_id=>wwv_flow_imp.id(3207369413849512)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.message.setThemeHooks( { pageErrorsContainerSelector: ".a-Alert--horizontal" } );'
);
end;
/
prompt --application/pages/page_03118
begin
wwv_flow_imp_page.create_page(
 p_id=>3118
,p_name=>'Create Search Configuration'
,p_alias=>'CREATE-SEARCH-CONFIG-DBMS-SEARCH'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Search Configuration'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213211113434774960)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'600'
,p_dialog_width=>'80%'
,p_dialog_max_width=>'1000'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1881374922911009)
,p_plug_name=>'Oracle Ubiquitous Search Index'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P3118_HAS_DBMS_SEARCH_INDEXES'
,p_plug_display_when_cond2=>'1'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5677006355853603)
,p_plug_name=>'Search Index'
,p_parent_plug_id=>wwv_flow_imp.id(1881374922911009)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9177858892791449)
,p_plug_name=>'Search Index Source'
,p_parent_plug_id=>wwv_flow_imp.id(1881374922911009)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1881475909911010)
,p_plug_name=>'Oracle Ubiquitous Search index does not exist'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>30
,p_plug_source=>'There is <strong>no Ubiquitous Search index</strong> in the current parsing schema.<br/><br/>The Application Developer''s Guide provides information on how to use Ubiquitous Database Search and the DBMS_SEARCH package.'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P3118_HAS_DBMS_SEARCH_INDEXES'
,p_plug_display_when_cond2=>'0'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3864296447072111980)
,p_plug_name=>'wizard progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_list_id=>wwv_flow_imp.id(1957878877823352)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3864296465500111981)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(6481959235723870)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(3864296465500111981)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(6482391118723870)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(3864296465500111981)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_button_condition=>'P3118_HAS_DBMS_SEARCH_INDEXES'
,p_button_condition2=>'1'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(6482742404723870)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(3864296465500111981)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:3111:&SESSION.::&DEBUG.:RP,::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(6494909595723880)
,p_branch_name=>'Go To Column Mapping'
,p_branch_action=>'f?p=&APP_ID.:3114:&SESSION.::&DEBUG.::P3114_PREV_PAGE:&APP_PAGE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1882639711911022)
,p_name=>'P3118_HAS_DBMS_SEARCH_INDEXES'
,p_item_sequence=>10
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5677243893853605)
,p_name=>'P3118_SEARCH_INDEX_OWNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(5677006355853603)
,p_item_default=>'wwv_flow_security.flow_owner( p_flow_id => :FB_FLOW_ID, p_security_group_id => wwv_flow_security.g_security_group_id )'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Choose an owner that has an Oracle Ubiquitous Search index. Only schemas are listed for which you also have object privileges.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_item_comment=>'The search index and source have to be in the parsing schema. This might change in a later release. At this moment we do not have a ALL_... dictionary view.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5677474684853607)
,p_name=>'P3118_SEARCH_INDEX_NAME'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(5677006355853603)
,p_prompt=>'Search Index Name'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value as d, column_value as r',
'  from table (wwv_flow_search_dev.get_dbms_search_indexes( p_application_id => :FB_FLOW_ID) );'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Value -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Choose an Oracle Ubiquitous Search index, this index must already exist in your parsing schema.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8506440742801399)
,p_name=>'P3118_SEARCH_SOURCE_OWNER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(9177858892791449)
,p_item_default=>'wwv_flow_security.flow_owner( p_flow_id => :FB_FLOW_ID, p_security_group_id => wwv_flow_security.g_security_group_id )'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Choose an owner. Only schemas are listed for which a data source exists for the selected Oracle Ubiquitous Search index.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_item_comment=>'The search index and source have to be in the parsing schema. This might change in a later release. At this moment we do not have a ALL_... dictionary view.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8507287993803258)
,p_name=>'P3118_SEARCH_SOURCE_NAME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(9177858892791449)
,p_prompt=>'Search Source Name'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value as d, column_value as r',
'  from table (wwv_flow_search_dev.get_dbms_search_sources( p_application_id => :FB_FLOW_ID,',
'                                                           p_index_name     => :P3118_SEARCH_INDEX_NAME) );'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Value -'
,p_lov_cascade_parent_items=>'P3118_SEARCH_INDEX_NAME'
,p_ajax_items_to_submit=>'P3118_SEARCH_INDEX_NAME'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Choose an Oracle Ubiquitous Search index source from your parsing schema which is part of your selected Oracle Ubiquitous Search index.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1882939721911025)
,p_computation_sequence=>10
,p_computation_item=>'P3118_HAS_DBMS_SEARCH_INDEXES'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*)',
'  from (select 1',
'          from table (wwv_flow_search_dev.get_dbms_search_indexes( p_application_id => :FB_FLOW_ID) )',
'         where rownum <= 1 );'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6491176719723878)
,p_name=>'Cancel Dialog'
,p_event_sequence=>150
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(6481959235723870)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6491620227723879)
,p_event_id=>wwv_flow_imp.id(6491176719723878)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(6485363230723875)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load Search Config Columns Collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_search_dev.init_column_collection (',
'    p_column_collection      => ''APEX$SEARCH_CONFIG_COLUMNS'',',
'    --',
'    p_application_id         => :FB_FLOW_ID,',
'    p_search_type            => wwv_flow_search.c_search_type_text_dbms_search,',
'    --',
'    p_location               => wwv_flow_exec_api.c_location_local_db,',
'    p_query_type             => wwv_flow_exec_api.c_query_type_table,',
'    p_owner                  => :P3118_SEARCH_INDEX_OWNER,',
'    p_table_name             => :P3118_SEARCH_SOURCE_NAME,',
'    --',
'    p_extended_describe      => true );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>6485363230723875
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4024854419649701)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update APEX Dictionary Cache'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_object_type wwv_flow_tables_views_dev.object_type%type;',
'begin',
'    select object_type',
'      into l_object_type',
'      from wwv_flow_tables_views_dev',
'     where owner       = :P3118_SEARCH_SOURCE_OWNER',
'       and object_name = :P3118_SEARCH_SOURCE_NAME;',
'',
'    --- if table, set APEX dictionary cache',
'    if l_object_type = ''TABLE'' then',
'        wwv_dictionary_cache_dev.set_dictionary_table_cache(',
'             p_workspace_name          => htmldb_util.find_workspace( p_security_group_id => :WORKSPACE_ID ),',
'             p_schema                  => :P3118_SEARCH_SOURCE_OWNER,',
'             p_table_name              => :P3118_SEARCH_SOURCE_NAME,',
'             p_flow_id                 => :FB_FLOW_ID,',
'             p_cache_fk_references     => true );',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>4024854419649701
);
end;
/
prompt --application/pages/page_03120
begin
wwv_flow_imp_page.create_page(
 p_id=>3120
,p_name=>'Edit Search Configuration'
,p_alias=>'EDIT-EARCH-CONFIGURATION'
,p_step_title=>'Edit Search Configuration'
,p_autocomplete_on_off=>'OFF'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function callItempopUp(s1,s2) {',
'     var items = document.getElementById(s1).value.replace(/\,/g,''~'');',
'     var values = document.getElementById(s2).value.replace(/\,/g,''~'');',
'     var url = ''f?p=&APP_ID.:404:&SESSION.:::404:P404_RETURN1,P404_RETURN2,P404_ITEMS,P404_VALUES:'' + s1 + '','' + s2 + '','' + escape(items) + '','' + escape(values);',
'     popUp (url);',
'}',
'',
'function refreshColumns() {',
'    apex.server.process( ',
'        "getColumnInfo",',
'        { ',
'            pageItems: "#P3120_SEARCH_TYPE,#P3120_LIST_ID,#P3120_LOCATION,#P3120_QUERY_TYPE,#P3120_REMOTE_SOURCE_TYPE,#P3120_ORATEXT_SOURCE_TYPE,#P3120_QUERY_OWNER,#P3120_REMOTE_TABLE_OWNER,#P3120_ORATEXT_OWNER,#P3120_QUERY_TABLE,#P3120_REMOTE_TABLE_'
||'NAME,#P3120_ORATEXT_TABLE,#P3120_QUERY_SQL,#P3120_REMOTE_SQL,#P3120_POST_PROC_TYPE,#P3120_POST_PROC_SQL,#P3120_ORATEXT_SQL,#P3120_QUERY_FUNC_BODY,#P3120_REMOTE_FUNC_BODY,#P3120_POST_PROC_FUNC_BODY,#P3120_QUERY_FUNC_LANG,#P3120_REMOTE_FUNC_BODY_LANG,#'
||'P3120_POST_PROC_FUNC_LANG,#P3120_QUERY_WHERE,#P3120_REMOTE_WHERE,#P3120_POST_PROC_WHERE,#P3120_ORATEXT_WHERE,#P3120_QUERY_ORDER_BY,#P3120_REMOTE_ORDER_BY,#P3120_POST_PROC_ORDER_BY,#P3120_ORATEXT_ORDER_BY,#P3120_OPTIMIZER_HINT,#P3120_REMOTE_SERVER_ID,'
||'#P3120_WEB_SRC_MODULE_ID,#P3120_GRAPH_NAME,#P3120_PQL_MATCH_CLAUSE,#P3120_PQL_COLUMNS_CLAUSE,#P3120_PQL_WHERE_CLAUSE,#P3120_SEARCH_INDEX_NAME,#P3120_SEARCH_SOURCE_NAME,#P3120_SEARCH_ORDER_BY"        },',
'        {',
'            success: function( pData ) {',
'                var lItems = apex.jQuery( ".is-column");',
'',
'                apex.debug.info( "received column info", pData );',
'',
'                //-----------------------------------------------------------------------------------------',
'                function refreshShuttle( pItemName ) {',
'                    var lItemColumns = apex.item( pItemName ).getValue(),',
'                        lNewColumns  = [];',
'',
'                    if ( lItemColumns && lItemColumns.length > 0 ) {',
'                        for ( let o = 0; o < pData.length; o++ ) {',
'                            if ( pData[ o ].t === "VARCHAR2" || pData[ o ].t === "CLOB" ) {',
'                                lNewColumns.push( pData[ o ].r );',
'                            }',
'                        }',
'                        lItemColumns.filter( function( e ) { return lNewColumns.indexOf( e ) > -1; });',
'                    } else {',
'                        lItemColumns.length = [];',
'                    }',
'        ',
'                    apex.item( pItemName ).setValue( "", undefined, true );',
'                    refreshItem( $( "#" + pItemName + "_LEFT" ), false );',
'                    apex.item( pItemName ).setValue( lItemColumns );',
'                }',
'',
'                //-----------------------------------------------------------------------------------------',
'                function refreshItem( pItem$, pSetValue ) {',
'                    var lValue           = apex.item( pItem$.attr( "name" ) ).getValue(),',
'                        lValueStillValid = false,',
'                        lNullOption$     = pItem$.find( ''option[value=""]''),',
'                        lOption$;',
'',
'                    pItem$.empty();',
'                    if ( lNullOption$.length > 0 ) {',
'                        pItem$.append( lNullOption$ );',
'                    }',
'                    ',
'                    for ( let o = 0; o < pData.length; o++ ) {',
'                        if ( ',
'                            ( pData[ o ].t !== "BLOB" && !pItem$.hasClass("is-blob") && !pItem$.hasClass("is-text") ) ||',
'                            ( pData[ o ].t === "BLOB" &&  pItem$.hasClass("is-blob") && !pItem$.hasClass("is-text") ) || ',
'                            ( ( pData[ o ].t === "BLOB" || pData[ o ].t === "CLOB" || pData[ o ].t === "VARCHAR2" ) && pItem$.hasClass("is-text") ) ',
'                        )',
'                        {',
'                            lOption$ = apex.jQuery("<option></option>").attr("value", pData[ o ].r ).text( pData[ o ].d );',
'                            if ( pData[ o ].r === lValue ) {',
'                                lValueStillValid = true;',
'                            }',
'                            pItem$.append( lOption$ );',
'                        }',
'                    }',
'',
'                    if ( pSetValue ) {',
'                        if ( lValueStillValid ) {',
'                            apex.item( pItem$.attr( "name" ) ).setValue( lValue );',
'                        } else {',
'                            apex.item( pItem$.attr( "name" ) ).setValue( "" );',
'                        }',
'                    }',
'                }',
'',
'                if ( pData.length > 0 ) {',
'',
'                    for (let i=0; i<lItems.length;i++) {',
'                        refreshItem( apex.jQuery (lItems[ i ] ), true );',
'                    }',
'                    if ( apex.jQuery( "#P3120_SEARCHABLE_COLUMNS").length > 0 ) {',
'                        refreshShuttle( "P3120_SEARCHABLE_COLUMNS" );',
'                    }',
'                }',
'            }',
'        }',
'    );',
'}'))
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// reposition icon picker',
'apex.jQuery("#P3120_ICON_CSS_CLASSES").after(apex.jQuery("button#icon_picker"));'))
,p_css_file_urls=>'#FONT_APEX_LATEST_DIRECTORY#css/font-apex#MIN#.css'
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_result number;',
'begin',
'    if :P3120_QUERY_TYPE = ''GRAPH'' and sys.dbms_db_version.version < 23 then',
'        return true;',
'    elsif :P3120_SEARCH_TYPE = ''TEXT_DBMS_SEARCH'' and not wwv_flow_db_version.c_has_dbms_search then',
'        return true;    ',
'    else',
'        return :P3120_REFERENCE_ID is not null;',
'    end if;',
'   ',
'    return false;',
'end;'))
,p_read_only_when2=>'PLSQL'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1710663147072502)
,p_plug_name=>'Search Configuration: &P3120_LABEL.'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_04'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1710799122072503)
,p_plug_name=>'Source'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>45
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1712389499072519)
,p_plug_name=>'APEX List Search Source'
,p_parent_plug_id=>wwv_flow_imp.id(1710799122072503)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P3120_SEARCH_TYPE'
,p_plug_display_when_cond2=>'APEX_LIST'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1712406847072520)
,p_plug_name=>'Oracle Text Search Source'
,p_parent_plug_id=>wwv_flow_imp.id(1710799122072503)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P3120_SEARCH_TYPE'
,p_plug_display_when_cond2=>'TEXT_MANUAL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1880676739911002)
,p_plug_name=>'DBMS Search Source'
,p_parent_plug_id=>wwv_flow_imp.id(1710799122072503)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P3120_SEARCH_TYPE'
,p_plug_display_when_cond2=>'TEXT_DBMS_SEARCH'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1881230294911008)
,p_plug_name=>'Oracle TEXT Function'
,p_parent_plug_id=>wwv_flow_imp.id(1710799122072503)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>60
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_display_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_plug_display_when_condition=>'P3120_SEARCH_TYPE'
,p_plug_display_when_cond2=>'TEXT_MANUAL:TEXT_DBMS_SEARCH'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4301512749800702)
,p_plug_name=>'Simple Search Source'
,p_parent_plug_id=>wwv_flow_imp.id(1710799122072503)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>15
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P3120_SEARCH_TYPE'
,p_plug_display_when_cond2=>'SIMPLE'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1711957073072515)
,p_plug_name=>'Local Data Source'
,p_parent_plug_id=>wwv_flow_imp.id(4301512749800702)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1712144200072517)
,p_plug_name=>'REST Data Source'
,p_parent_plug_id=>wwv_flow_imp.id(4301512749800702)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2602236053033212)
,p_plug_name=>'REST Source Details'
,p_parent_plug_id=>wwv_flow_imp.id(1712144200072517)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2420091833518828)
,p_plug_name=>'REST Source Parameters'
,p_parent_plug_id=>wwv_flow_imp.id(2602236053033212)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select cp.id, ',
'       pa.name,',
'       pa.data_type,',
'       cp.value_type,',
'       cp.value_language,',
'       cp.value,',
'       cp.format_mask',
'  from wwv_flow_web_src_comp_params cp, wwv_flow_web_src_params pa',
' where pa.id                = cp.web_src_param_id',
'   and pa.flow_id           = cp.flow_id',
'   and pa.security_group_id = cp.security_group_id ',
'    -- ',
'   and cp.search_config_id  = :P3120_ID',
'   and cp.security_group_id = :WORKSPACE_ID',
'   and cp.flow_id           = :FB_FLOW_ID',
'   and pa.is_query_param    = ''N'''))
,p_plug_source_type=>'NATIVE_IG'
,p_ajax_items_to_submit=>'P3120_ID'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_web_src_comp_params cp, ',
'       wwv_flow_web_src_params pa',
' where pa.id                = cp.web_src_param_id',
'   and pa.flow_id           = cp.flow_id',
'   and pa.security_group_id = cp.security_group_id',
'    -- ',
'   and cp.security_group_id = :WORKSPACE_ID',
'   and cp.flow_id           = :FB_FLOW_ID',
'   and cp.search_config_id  = :P3120_ID',
'   and pa.is_query_param    = ''N'''))
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'REST Source Parameters'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2420209938518830)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>30
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2420322282518831)
,p_name=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'REST Source Parameter Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>40
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_include_in_export=>true
,p_help_text=>'Identifies the <em>Name</em> of the REST Data Source Parameter.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2420443324518832)
,p_name=>'VALUE_TYPE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'VALUE_TYPE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Value Type'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>60
,p_value_alignment=>'LEFT'
,p_is_required=>true
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(358243382603181986)
,p_lov_display_extra=>false
,p_lov_display_null=>false
,p_enable_filter=>false
,p_filter_is_required=>false
,p_static_id=>'COLUMN_ITEM_FOR_VALUE_TYPE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select how this parameter is populated.</p><p>Available options include:</p>',
'<ul>',
'    <li><strong>Static Value</strong>: Set to the text entered into <em>Static Value</em>.</li>',
'    <li><strong>Item</strong>: Set to the value held in session state for the <em>Item</em> specified.</li>',
'    <li><strong>SQL Query (return single value)</strong>: Set to the first value returned from the <em>SQL Query</em> entered.</li>',
'    <li><strong>PL/SQL Expression</strong>: Set to the value that results from executing the <em>PL/SQL Expression</em> entered.</li>',
'    <li><strong>PL/SQL Function Body</strong>: Set to the value returned from the <em>PL/SQL Function Body</em> entered.</li>',
'    <li><strong>Collection (CLOB)</strong>: Set to the CLOB column value of the first row from the <em>Collection</em> entered.</li>',
'    <li><strong>Preference</strong>: Set to the value of the <em>Preference</em> entered.</li>',
'    <li><strong>Null</strong>: Set to null as no value specified.</li>',
'</ul>',
''))
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2420545289518833)
,p_name=>'VALUE_LANGUAGE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'VALUE_LANGUAGE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>80
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2420637902518834)
,p_name=>'VALUE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'VALUE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Expression'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>90
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
,p_help_text=>'Provide the expression here, based on the <strong>Value Type </strong> column.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2420791562518835)
,p_name=>'APEX$ROW_ACTION'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>20
,p_use_as_row_header=>false
,p_display_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2420869467518836)
,p_name=>'APEX$ROW_SELECTOR'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_use_as_row_header=>false
,p_display_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2686292255958035)
,p_name=>'DATA_TYPE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DATA_TYPE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Parameter Data Type'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>50
,p_value_alignment=>'LEFT'
,p_is_required=>false
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(2225637019805602)
,p_lov_display_extra=>true
,p_lov_display_null=>true
,p_enable_filter=>false
,p_filter_is_required=>false
,p_static_id=>'COLUMN_ITEM_FOR_DATA_TYPE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_include_in_export=>true
,p_readonly_condition_type=>'ALWAYS'
,p_readonly_for_each_row=>false
,p_help_text=>'Data Type of the REST Source Parameter.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2686344729958036)
,p_name=>'FORMAT_MASK'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FORMAT_MASK'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_POPUP_LOV'
,p_heading=>'Format Mask'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>70
,p_value_alignment=>'LEFT'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
,p_is_required=>false
,p_max_length=>255
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(32743907454195192)
,p_lov_display_extra=>true
,p_lov_display_null=>true
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>'Format mask to convert the <strong>Static</strong> or <strong>Item</strong> value to the data type of the REST Source Parameter.'
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(2420107198518829)
,p_internal_uid=>2420107198518829
,p_is_editable=>true
,p_edit_operations=>'u'
,p_lost_update_check_type=>'VALUES'
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>false
,p_no_data_found_message=>'No Parameters defined.'
,p_show_toolbar=>false
,p_toolbar_buttons=>null
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>false
,p_define_chart_view=>false
,p_enable_download=>false
,p_download_formats=>null
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(2524109168303354)
,p_interactive_grid_id=>wwv_flow_imp.id(2420107198518829)
,p_static_id=>'25242'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(2524365646303356)
,p_report_id=>wwv_flow_imp.id(2524109168303354)
,p_view_type=>'GRID'
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1623692080650948)
,p_view_id=>wwv_flow_imp.id(2524365646303356)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(2686292255958035)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1624553023650941)
,p_view_id=>wwv_flow_imp.id(2524365646303356)
,p_display_seq=>7
,p_column_id=>wwv_flow_imp.id(2686344729958036)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2524813576303369)
,p_view_id=>wwv_flow_imp.id(2524365646303356)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(2420209938518830)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2525695099303396)
,p_view_id=>wwv_flow_imp.id(2524365646303356)
,p_display_seq=>2
,p_column_id=>wwv_flow_imp.id(2420322282518831)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2526529164303401)
,p_view_id=>wwv_flow_imp.id(2524365646303356)
,p_display_seq=>4
,p_column_id=>wwv_flow_imp.id(2420443324518832)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2527437297303406)
,p_view_id=>wwv_flow_imp.id(2524365646303356)
,p_display_seq=>5
,p_column_id=>wwv_flow_imp.id(2420545289518833)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2528365098303411)
,p_view_id=>wwv_flow_imp.id(2524365646303356)
,p_display_seq=>6
,p_column_id=>wwv_flow_imp.id(2420637902518834)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2529257802303416)
,p_view_id=>wwv_flow_imp.id(2524365646303356)
,p_display_seq=>0
,p_column_id=>wwv_flow_imp.id(2420791562518835)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1712239748072518)
,p_plug_name=>'Remote Data Source'
,p_parent_plug_id=>wwv_flow_imp.id(4301512749800702)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2008960404717920)
,p_plug_name=>'Remote Data Source Detail'
,p_parent_plug_id=>wwv_flow_imp.id(1712239748072518)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4301496539800701)
,p_plug_name=>'Location'
,p_parent_plug_id=>wwv_flow_imp.id(4301512749800702)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>15
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6700537919775301)
,p_plug_name=>'Searchable Columns'
,p_parent_plug_id=>wwv_flow_imp.id(4301512749800702)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1710885494072504)
,p_plug_name=>'Column Mapping'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>65
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1711155463072507)
,p_plug_name=>'Server-Side Condition'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>95
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1711251784072508)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1711851376072514)
,p_plug_name=>'Subscription'
,p_region_name=>'SUBSCRIPTION'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>35
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'WWV_FLOW_SEARCH_CONFIGS',
  'attribute_02', 'LABEL',
  'attribute_03', 'P3120_ID',
  'attribute_04', 'P3120_REFERENCE_ID',
  'attribute_05', 'SUBSCRIBE_SEARCH_CONFIG',
  'attribute_06', 'VERSION_SCN')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1757925019180889)
,p_plug_name=>'Settings'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>25
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_SEARCH_CONFIGS'
,p_query_where=>'security_group_id = :WORKSPACE_ID and flow_id = :FB_FLOW_ID'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'u:d'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2010830403717939)
,p_plug_name=>'Link'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>85
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2417497793518802)
,p_plug_name=>'Target App or Page'
,p_parent_plug_id=>wwv_flow_imp.id(2010830403717939)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2417553805518803)
,p_plug_name=>'Target URL'
,p_parent_plug_id=>wwv_flow_imp.id(2010830403717939)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2418843606518816)
,p_plug_name=>'Advanced'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>105
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1711015049072506)
,p_plug_name=>'History'
,p_parent_plug_id=>wwv_flow_imp.id(2418843606518816)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(29434107863295859)
,p_plug_display_sequence=>110
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'    select last_updated_by, last_updated_on, created_by, created_on ',
'      from wwv_flow_search_configs',
'     where id = :P3120_ID',
'       and flow_id = :FB_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID )',
'loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id              => :P3120_ID,',
'      p_component_type  => ''Search Configuration'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by      => c1.created_by,',
'      p_created_on      => c1.created_on );',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2704165692067639)
,p_plug_name=>'Please Save your Changes'
,p_region_template_options=>'#DEFAULT#:a-Alert--info:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>55
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>You need to save the changes and reload the page, before you can define the Column Mappings.</p>',
'    '))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2705158547067649)
,p_plug_name=>'Search Configuration'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>150
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'<strong>Search Configuration</strong> contains information about a searchable data source. They can be referenced from <em>Search</em> regions to add declarative searches in your application. Searches can be based on Local data source, REST Enabled S'
||'QL Service, REST Data Source, pre-defined Oracle Text, pre-defined Oracle Ubiquitous Search or &PRODUCT_NAME. List.',
'',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4047128031984702)
,p_plug_name=>'Ubiquitous Search is not supported'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>15
,p_location=>null
,p_plug_source=>'This Search Configuration is based on an Oracle Ubiquitous Search index, which requires Oracle Database 23ai or later. Thus, this page is read only.'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl( :P3120_SEARCH_TYPE, ''X'' ) = ''TEXT_DBMS_SEARCH'' and not wwv_flow_db_version.c_has_dbms_search'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6700676601775302)
,p_plug_name=>'Icon and Display'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>75
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(110966724585654339)
,p_plug_name=>'Property Graph is not supported'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>5
,p_location=>null
,p_plug_source=>'This Search Configuration is based on a Property Graph, which requires Oracle Database 23ai or later. Thus, this page is read only.'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl( :P3120_QUERY_TYPE, ''X'' ) = ''GRAPH'' and sys.dbms_db_version.version < 23'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8433429421230346)
,p_button_sequence=>160
,p_button_plug_id=>wwv_flow_imp.id(6700676601775302)
,p_button_name=>'ICON'
,p_button_static_id=>'icon_picker'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Select Icon'
,p_button_redirect_url=>'f?p=&APP_ID.:181:&SESSION.::&DEBUG.::P181_PASS_BACK_TO_UI,P181_PASS_BACK_TO_SAVE:icon_picker,P3120_ICON_CSS_CLASSES'
,p_button_css_classes=>'a-Button--colorPicker'
,p_icon_css_classes=>'fa &P3120_ICON_CSS_CLASSES.'
,p_grid_new_row=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1798775846181247)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1710663147072502)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:3100:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1799303955181255)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(1710663147072502)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_confirm_message=>'&APP_TEXT$DELETE_MSG!RAW.'
,p_confirm_style=>'danger'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P3120_ID is not null',
'and ( :P3120_REFERENCE_ID is null or :P3120_SUBSCRIBED_COMP_GRP = ''N'' )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1799745296181261)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(1710663147072502)
,p_button_name=>'SAVE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    :P3120_ID is not null ',
'and not wwv_flow_page.is_read_only',
'and ( nvl( :P3120_QUERY_TYPE, ''X'' ) != ''GRAPH'' or sys.dbms_db_version.version >= 23 )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2418772269518815)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_imp.id(1711851376072514)
,p_button_name=>'PUBLISH'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Publish'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.::F4000_P149_ID,F4000_P149_PAGE_ID,F4000_P149_TEMPLATE_TYPE:&P3120_ID.,&APP_PAGE_ID.,SEARCH_CONFIG'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_search_configs',
' where reference_id      = :P3120_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4204124168667410)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_imp.id(1711851376072514)
,p_button_name=>'UNSUBSCRIBE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Unsubscribe'
,p_button_position=>'NEXT'
,p_button_condition=>':P3120_REFERENCE_ID is not null and :P3120_SUBSCRIBED_COMP_GRP = ''N'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4204065935667409)
,p_button_sequence=>110
,p_button_plug_id=>wwv_flow_imp.id(1711851376072514)
,p_button_name=>'REFRESH_SUB'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Refresh'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P3120_REFERENCE_ID is not null ',
'and ( :P3120_VERSION_SCN != :P3120_MASTER_VERSION_SCN or :P3120_VERSION_SCN is null )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4203257065667401)
,p_branch_name=>'Comeback to Edit Page'
,p_branch_action=>'f?p=&APP_ID.:3120:&SESSION.::&DEBUG.:3120:P3120_ID,P3120_RETURN_TO_PAGE:&P3120_ID.,&P3120_RETURN_TO_PAGE.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'( :REQUEST = ''SAVE'' and :P3120_RETURN_TO_PAGE = ''Y'' ) or',
'( :REQUEST = ''SAVE'' and :P3120_REFERENCE_ID is not null ) or',
'( :REQUEST in ( ''REFRESH_SUB'', ''UNSUBSCRIBE'' ) )'))
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1800477580181264)
,p_branch_name=>'Go to Search Configs Page'
,p_branch_action=>'f?p=&APP_ID.:3100:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1416823480012506)
,p_name=>'P3120_SUBSCRIBED_COMP_GRP'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(1711851376072514)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1532553228420602)
,p_name=>'P3120_WEB_SRC_ARRAY_COL_ID'
,p_source_data_type=>'NUMBER'
,p_is_query_only=>true
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(1712144200072517)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Array Column'
,p_source=>'WEB_SRC_ARRAY_COL_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select dpc.array_column_path,',
'       dpc.id',
'  from wwv_flow_web_src_arr_cols_dev dpc',
' where dpc.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and dpc.flow_id           = :FB_FLOW_ID',
'   and dpc.web_src_module_id = :P3112_WEB_SRC_MODULE_ID   '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'None'
,p_cHeight=>1
,p_display_when=>'P3120_WEB_SRC_ARRAY_COL_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Denotes the Array Column, within the <em>Data Profile</em> of the REST Data Source, to be used for this Search Configuration.'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1637015721313208)
,p_name=>'P3120_GRAPH_NAME'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_imp.id(1711957073072515)
,p_prompt=>'Graph Name'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select g.graph_name d, ',
'       g.graph_name r',
'  from sys.dba_property_graphs    g,',
'       wwv_flow_object_owners_dev o',
' where o.owner = g.owner',
'   and g.owner = (select coalesce( :P3120_QUERY_OWNER, upper(wwv_flow_wizard_api.get_flow_owner(:FB_FLOW_ID)) )',
'                    from sys.dual )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Value -'
,p_lov_cascade_parent_items=>'P3120_QUERY_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_tag_css_classes=>'is-query'
,p_display_when=>'sys.dbms_db_version.version >= 23'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Pick the Property Graph from the list.'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1637185764313209)
,p_name=>'P3120_PQL_MATCH_CLAUSE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_imp.id(1711957073072515)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Match Clause'
,p_source=>'QUERY_MATCH'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>3
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a path pattern to find on the property graph. In order to find all edges in your graph, use the following: <strong>(a) - [e] -> (b)</strong>. In addition to this, use <em>label constraints</em> to restrict the types of vertices or edges of i'
||'nterest.</p>',
'<p><strong>Examples</strong></p>',
'<dl>',
'<dt>Find all persons who bought cars.</dt><dd><pre>(p is person) - [t is buys] -> (c is car)</pre></dd>',
'<dt>Find all employees working in departments.</dt><dd><pre>(e is employees) - [is works_at] -> (d is departments)</pre></dd>',
'<dt>Find all employees working in departments who bought cars.</dt><dd><pre>(e is employees) - [is works_at] -> (d is departments), (e is employees) - [t is buys] -> (c is car)</pre></dd>',
'</dl>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1637294480313210)
,p_name=>'P3120_PQL_COLUMNS_CLAUSE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_imp.id(1711957073072515)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Columns Clause'
,p_source=>'QUERY_COLUMNS'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>3
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Define the query return columns. Those are properties of vertices or edges or expressions using them.</p>',
'<p><strong>Example</strong></p>',
'<dl>',
'<dt>Return <strong>NAME</strong>, <strong>BRAND</strong> and <strong>TOTAL_COST</strong> columns, the latter is the <strong>COST</strong> column, multiplied by 100.</dt>',
'<dd><pre>p.name, c.brand, t.cost * 100 as total_cost</pre></dd>',
'</dl>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1637347425313211)
,p_name=>'P3120_PQL_WHERE_CLAUSE'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_imp.id(1711957073072515)
,p_prompt=>'Where Clause'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cHeight=>3
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter an optional WHERE clause to restrict the returned rows. Columns must use a vertex or edge alias.</p>',
'<p><strong>Example</strong></p>',
'<dl>',
'<dt>Only include those employees which have a manager or have a job of salesman.</dt>',
'<dd><pre>( e.mgr is not null or e.job = ''SALESMAN'' )</pre></dd>',
'</dl>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1711553408072511)
,p_name=>'P3120_FLOW_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_source=>'FLOW_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1712547016072521)
,p_name=>'P3120_CONDITION_LANG'
,p_item_sequence=>470
,p_item_plug_id=>wwv_flow_imp.id(1711155463072507)
,p_prompt=>'Language'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select a language that is used to evaluate the entered programming code.'
,p_attribute_03=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1712697338072522)
,p_name=>'P3120_CONDITION_CHECK'
,p_item_sequence=>490
,p_item_plug_id=>wwv_flow_imp.id(1711155463072507)
,p_prompt=>'Do not validate code (parse code at runtime only).'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1758373900180902)
,p_name=>'P3120_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1760046620180985)
,p_name=>'P3120_LABEL'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Label'
,p_source=>'LABEL'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>1000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter the label to be displayed in Search results. When using the Search Configuration within a search region, the label can be overridden.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1760443232180987)
,p_name=>'P3120_STATIC_ID'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Static ID'
,p_source=>'STATIC_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Use the Static ID to reference the Search Configuration definition in API Calls, particularly when using the <strong>APEX_SEARCH.SEARCH</strong> function.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1760805302180991)
,p_name=>'P3120_SEARCH_PREFIX'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Search Query Prefix'
,p_source=>'SEARCH_PREFIX'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Enter a prefix to be used by end users in search queries. A search term which is prefixed will only be used for ',
'    Search Configurations with the same prefix. If a prefix is used in a search query, but not defined in ',
'    <em>any</em> Search Configuration, the prefix will be ignored and the whole term will be used for searching.',
'</p>',
'<p>Examples:</p>',
'<p> Two Search Configurations exist: <strong>Employees</strong> with the <strong>emp</strong>, ',
'    and <strong>Jobs</strong> with the <strong>job</strong> prefix.',
'</p>',
'<dl>',
'    <dt>emp:king president</dt>',
'    <dd>The <strong>king</strong> keyword will only be searched in the <strong>Employees</strong> ',
'        Search Configuration, <strong>president</strong> will be searched in both.</dd>',
'    <dt>emp:king job:president</dt>',
'    <dd>The <strong>king</strong> keyword will only be searched in the <strong>Employees</strong> ',
'        Search Configuration, <strong>president</strong> will only be searched in <strong>Jobs</strong>.</dd>',
'    <dt>emp:king depts:"new york"</dt>',
'    <dd>The <strong>king</strong> keyword will only be searched in the <strong>Employees</strong> ',
'        Search Configuration. <strong>depts:"new york"</strong> will be searched in both configurations,',
'        as the <strong>depts</strong> prefix is nowhere defined.</dd>',
'</dl>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1761210114180993)
,p_name=>'P3120_SEARCH_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Search Type'
,p_source=>'SEARCH_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'SEARCH_CONFIG.TYPE'
,p_lov=>'.'||wwv_flow_imp.id(1813067828014706)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'  <li>',
'    <strong>Standard:</strong>',
'    Define a searchable data source, which can be a table, SQL Query, or REST Data Source. ',
'    Search is executed by a SQL Query using LIKE expressions. ',
'  </li>',
'  <li>',
'    <strong>Oracle Text:</strong>',
'    Define a searchable table or SQL Query, which already has an Oracle Text index created. Search',
'    is executed by using Oracle Text functionality, which provides linguistic and fuzzy search',
'    capabilities.',
'  </li>',
'  <li>',
'    <strong>Oracle Ubiquitous Search:</strong>',
'    Search using an Oracle Ubiquitous Search index (requires Oracle Database 23ai or later).<br/>',
'    <em>The index must be located in the parsing schema of the application.</em>',
'  </li>',
'  <li>',
'    <strong>List:</strong>',
'    Search within a selected <em>List</em> from Shared Components.',
'  </li>',
'</ul>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1761628776180994)
,p_name=>'P3120_LIST_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(1712389499072519)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'List'
,p_source=>'LIST_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'SEARCH_CONFIG.LISTS'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select List -'
,p_cHeight=>1
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select the list (from Shared Components) to search within.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1762395149180996)
,p_name=>'P3120_LOCATION'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(4301496539800701)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Data Source'
,p_source=>'LOCATION'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXEC_LOCATION'
,p_lov=>'.'||wwv_flow_imp.id(3842073961668883)||'.'
,p_display_when=>'P3120_SEARCH_TYPE'
,p_display_when2=>'APEX_LIST'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'apex-button-group is-query'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    The <em>Data Source</em> type selected when this Search Configuration was created.',
'</p>',
'<ul>',
'    <li><strong>Local Database</strong><br>',
'    Data is sourced from the local database.</li>',
'    <li><strong>REST Enabled SQL Service</strong><br>',
'    Data is sourced from a remote database, where the connection is defined using REST Enabled SQL. To create or maintain REST Enabled SQL references, navigate to Shared Components, REST Enabled SQL.',
'    </li>',
'    <li><strong>REST Data Source</strong><br>',
'    Data is sourced from a RESTful web service defined using REST Data Sources. To create or maintain REST Data Sources, navigate to Shared Components, REST Data Sources.',
'    </li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1762710024180997)
,p_name=>'P3120_REMOTE_SERVER_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(1712239748072518)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'REST Enabled SQL Service'
,p_source=>'REMOTE_SERVER_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REMOTE_SQL_SERVERS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_remote_servers',
' where server_type = ''REMOTE_SQL''',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a REST Enabled SQL service that will be used as source of the search configuration.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1763430863180997)
,p_name=>'P3120_WEB_SRC_MODULE_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(1712144200072517)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'REST Data Source'
,p_source=>'WEB_SRC_MODULE_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APP_WEB_SOURCES_FOR_REPORTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_flow_web_src_modules m',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and exists ( select 1 ',
'                  from wwv_flow_web_src_operations',
'                 where web_src_module_id = m.id',
'                   and database_operation = ''FETCH_COLLECTION'' )',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_tag_css_classes=>'is-query'
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a REST Data Source that will be used as source of the search configuration.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1764120685181000)
,p_name=>'P3120_QUERY_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(1711957073072515)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_item_default=>'TABLE'
,p_prompt=>'Source Type'
,p_source=>'QUERY_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXEC_SQL_DATA_SOURCE_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(601107956819795211)||'.'
,p_tag_css_classes=>'apex-button-group is-query'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Specify the source type of the search configuration. A search configuration can be based on a Table, SQL Query, Function Body returning SQL Query, or (on Oracle Database 23ai and later) on a Property Graph.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1764539087181000)
,p_name=>'P3120_QUERY_SQL'
,p_source_data_type=>'CLOB'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(1711957073072515)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Enter a SQL SELECT statement'
,p_source=>'QUERY_SOURCE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>60
,p_cMaxlength=>32767
,p_cHeight=>8
,p_tag_css_classes=>'a-Form-textarea--code is-query'
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the SQL Query that will be used as source of the search configuration:',
'<pre>',
'select [col1], [col2], [col3], ...',
'  from ...',
' where ...',
' order by ...',
'</pre>',
'',
'For example:',
'<pre>',
'select empno, ename, job, hiredate, sal',
'  from emp ',
' where deptno = :my_item ',
' order by 1',
'</pre>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1765318190181002)
,p_name=>'P3120_QUERY_OWNER'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(1711957073072515)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Table / View Owner'
,p_source=>'QUERY_OWNER'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_SCHEMAS_HAVE_PRIVS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(owner) d, owner v',
'  from wwv_flow_object_owners_dev',
'order by d                   '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Parsing Schema -'
,p_cHeight=>1
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select the owner of the table on which you are basing this search configuration.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1765746832181003)
,p_name=>'P3120_QUERY_TABLE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(1711957073072515)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Table / View Name'
,p_source=>'QUERY_TABLE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = coalesce( :P3120_QUERY_OWNER, upper(wwv_flow_wizard_api.get_flow_owner(:FB_FLOW_ID)))'))
,p_lov_cascade_parent_items=>'P3120_QUERY_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>60
,p_cMaxlength=>128
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the table or view that will be used as source of the search configuration.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1766177895181005)
,p_name=>'P3120_QUERY_WHERE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(1711957073072515)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Where Clause'
,p_source=>'QUERY_WHERE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>2
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter a valid SQL where condition, used to limit the records retrieved.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1766536891181006)
,p_name=>'P3120_POST_PROC_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(2602236053033212)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_item_default=>'NONE'
,p_prompt=>'Post Processing Type'
,p_source=>'SOURCE_POST_PROCESSING'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXEC_WEB_SOURCE_POST_PROCESSING'
,p_lov=>'.'||wwv_flow_imp.id(601113045750817318)||'.'
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select how to post process the retrieved REST source data in the local database.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1766979725181009)
,p_name=>'P3120_OPTIMIZER_HINT'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>270
,p_item_plug_id=>wwv_flow_imp.id(1711957073072515)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Optimizer Hint'
,p_source=>'OPTIMIZER_HINT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the Oracle Optimizer hint which is added to the top-level statement when executing the SQL query. A hint is an instruction to the Optimizer. When writing SQL, you may know information about the data unknown to the Optimizer. Hints enable you'
||' to make decisions normally made by the Optimizer, sometimes causing the Optimizer to select a plan that it sees as higher cost.</p>',
'',
'<p>For example, you might know that a certain index is more selective for certain queries. Based on this information, you might be able to choose a more efficient execution plan than the Optimizer. In such a case, use hints to force the Optimizer to '
||'use the optimal execution plan.</p>',
'',
'<p>Example:</p>',
'<p>When accessing the table <code>employees</code>, try to use the index <code>emp_department_ix</code>:</p>',
'<pre>INDEX (employees emp_department_ix)</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1767354232181011)
,p_name=>'P3120_EXTERNAL_FILTER_EXPR'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(2602236053033212)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'External Filter'
,p_source=>'EXTERNAL_FILTER_EXPR'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Provide a filter expression to be passed to the external REST service. The expression will be passed to the remote server as-is. The syntax depends on the type of the REST Data Source. For instance, Oracle REST Data Services (ORDS) expects JSON sy'
||'ntax.</p>',
'<dl><dt>Example: For an ORDS REST Service, filter out all records with the "sal" attribute less than 3000.</dt>',
'<dd><pre>',
'{"sal": {"$lt": 3000}}',
'</pre></dd>',
'</dl>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1767736148181012)
,p_name=>'P3120_WEB_SRC_FUNCTION'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>125
,p_item_plug_id=>wwv_flow_imp.id(2602236053033212)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'REST Data Source Function'
,p_source=>'WEB_SRC_FUNCTION'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter the name of a PL/SQL function to convert the end user query to filter syntax specific to the REST Source. This is required when the REST Source expects a specific query parameter and a specific query syntax.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1768170127181014)
,p_name=>'P3120_SEARCHABLE_COLUMNS'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(6700537919775301)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Searchable Column(s)'
,p_source=>'SEARCHABLE_COLUMNS'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SHUTTLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001   column_display,',
'       c002   column_return',
'  from wwv_flow_collections',
' where collection_name  = ''APEX$SEARCH_CONFIG_COLUMNS''',
'   and c003            != ''BLOB'''))
,p_cHeight=>5
,p_display_when=>'P3120_SEARCHABLE_COLS_REQUIRED'
,p_display_when2=>'Y'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select the column(s) to search within this list of columns.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ALL'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1768510517181016)
,p_name=>'P3120_ORATEXT_INDEX_COLUMN'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(1712406847072520)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Index Column Name'
,p_source=>'ORATEXT_INDEX_COLUMN_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001   column_display,',
'       c002   column_return',
'  from wwv_flow_collections',
' where collection_name = ''APEX$SEARCH_CONFIG_COLUMNS''',
'   and c003 in ( ''VARCHAR2'', ''BLOB'', ''CLOB'' )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_tag_css_classes=>'is-column is-text'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select the column which is indexed with an Oracle Text index. Note that an ',
'Oracle Text index is always created in one specific column, but can actually index',
'multiple columns or even multiple tables. See "Multicolumn Datastore" or "User Datastore" ',
'within the Oracle Text documentation for more details.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1768935765181019)
,p_name=>'P3120_ORATEXT_INDEX_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(1712406847072520)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Index Name'
,p_source=>'ORATEXT_INDEX_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>128
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter the name of the Oracle Text index for this Oracle Text search.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1769392176181022)
,p_name=>'P3120_ORATEXT_FUNCTION'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1881230294911008)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Custom Function Name'
,p_source=>'ORATEXT_FUNCTION'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Specify the name of a custom PL/SQL function which converts end user input to an Oracle Text query. ',
'    The function takes the end user input as VARCHAR2 and returns the Oracle Text query as a result.</p>',
'<p>',
'    This example makes use of <em>Oracle Text Query Relaxation</em>: It first executes the exact query,',
'    then it performs increasing levels of <em>fuzzy search</em>, until the requested amount of rows',
'    is returned. This is all transparent to the end user.',
'</p>',
'<pre>',
'create or replace function convert_end_user_search (',
'    p_search in varchar2 )',
'    return varchar2 ',
'is',
'    c_xml constant varchar2(32767) := ',
'        ''&lt;query&gt;&lt;textquery>&lt;progression&gt;''          ||',
'          ''&lt;seq&gt;       #SEARCH#            &lt;/seq&gt;'' ||',
'          ''&lt;seq&gt; FUZZY(#SEARCH#,80, 100,W) &lt;/seq&gt;'' ||',
'          ''&lt;seq&gt; FUZZY(#SEARCH#,50,1000,W) &lt;/seq&gt;'' ||',
'          ''&lt;seq&gt; FUZZY(#SEARCH#,20,3000,W) &lt;/seq&gt;'' ||',
'        ''&lt;/progression>&lt;/textquery>&lt;/query&gt;'';',
'',
'    l_search varchar2(32767) := p_search;',
'begin',
'    --',
'    -- remove special characters; ',
'    -- these are irrelevant for full text search',
'    --',
'    l_search := regexp_replace(',
'        srcstr  => l_search, ',
'        pattern => ''[&lt;&gt;{}/()*%&!$?.:,;\+#]'' );',
'',
'    return replace( ',
'        srcstr  => c_xml, ',
'        oldsub  => ''#SEARCH#'', ',
'        newsub  => ''{'' || l_search || ''}'' );',
'end;',
'</pre>',
'<p>',
'    For more information about Oracle Text query syntax and the query relaxation',
'    feature see the <a rel="noopener noreferrer" target="_blank" href="https://docs.oracle.com/en/database/oracle/oracle-database/23/ccapp/index.html">Oracle Text Application Developers Guide</a>.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1769625963181022)
,p_name=>'P3120_RETURN_MAX_RESULTS'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(6700676601775302)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Maximum Rows to Return'
,p_source=>'RETURN_MAX_RESULTS'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter the maximum number of rows to be returned by this search configuration.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1770080464181026)
,p_name=>'P3120_QUERY_ORDER_BY'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>260
,p_item_plug_id=>wwv_flow_imp.id(1711957073072515)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Order By Clause'
,p_source=>'QUERY_ORDER_BY'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>2
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter a valid SQL ORDER BY expression, used to sort the records retrieved.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1770418249181028)
,p_name=>'P3120_PK1_COLUMN'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1710885494072504)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Primary Key Column'
,p_source=>'PK_COLUMN_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P3120.SEARCH_CONFIG.COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 column_display,',
'       case when :P3120_SEARCH_TYPE = ''APEX_LIST'' then',
'           to_char( seq_id ) ',
'       else',
'           c002',
'       end column_return,',
'      seq_id column_id',
' from wwv_flow_collections',
'where collection_name = ''APEX$SEARCH_CONFIG_COLUMNS''',
'  and c003           != ''BLOB'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_tag_css_classes=>'is-column'
,p_grid_column=>2
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select the primary key column.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1770806341181029)
,p_name=>'P3120_TITLE_COLUMN_NAME'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(1710885494072504)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Title Column'
,p_source=>'TITLE_COLUMN_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P3120.SEARCH_CONFIG.COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 column_display,',
'       case when :P3120_SEARCH_TYPE = ''APEX_LIST'' then',
'           to_char( seq_id ) ',
'       else',
'           c002',
'       end column_return,',
'      seq_id column_id',
' from wwv_flow_collections',
'where collection_name = ''APEX$SEARCH_CONFIG_COLUMNS''',
'  and c003           != ''BLOB'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_tag_css_classes=>'is-column'
,p_grid_column=>2
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select the column to be used as title.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1771220601181029)
,p_name=>'P3120_SUBTITLE_COLUMN_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(1710885494072504)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Subtitle Column'
,p_source=>'SUBTITLE_COLUMN_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P3120.SEARCH_CONFIG.COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 column_display,',
'       case when :P3120_SEARCH_TYPE = ''APEX_LIST'' then',
'           to_char( seq_id ) ',
'       else',
'           c002',
'       end column_return,',
'      seq_id column_id',
' from wwv_flow_collections',
'where collection_name = ''APEX$SEARCH_CONFIG_COLUMNS''',
'  and c003           != ''BLOB'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_tag_css_classes=>'is-column'
,p_begin_on_new_line=>'N'
,p_grid_column=>5
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select the column to be used as subtitle.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1771671080181030)
,p_name=>'P3120_DESCRIPTION_COLUMN_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(1710885494072504)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Description Column'
,p_source=>'DESCRIPTION_COLUMN_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P3120.SEARCH_CONFIG.COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 column_display,',
'       case when :P3120_SEARCH_TYPE = ''APEX_LIST'' then',
'           to_char( seq_id ) ',
'       else',
'           c002',
'       end column_return,',
'      seq_id column_id',
' from wwv_flow_collections',
'where collection_name = ''APEX$SEARCH_CONFIG_COLUMNS''',
'  and c003           != ''BLOB'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_tag_css_classes=>'is-column'
,p_begin_on_new_line=>'N'
,p_grid_column=>8
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select the column to be used as description.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1772030432181032)
,p_name=>'P3120_BADGE_COLUMN_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(1710885494072504)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Badge Column'
,p_source=>'BADGE_COLUMN_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P3120.SEARCH_CONFIG.COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 column_display,',
'       case when :P3120_SEARCH_TYPE = ''APEX_LIST'' then',
'           to_char( seq_id ) ',
'       else',
'           c002',
'       end column_return,',
'      seq_id column_id',
' from wwv_flow_collections',
'where collection_name = ''APEX$SEARCH_CONFIG_COLUMNS''',
'  and c003           != ''BLOB'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_tag_css_classes=>'is-column'
,p_grid_column=>2
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select the column to be used as badge.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1772492935181035)
,p_name=>'P3120_LAST_MOD_COLUMN_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(1710885494072504)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Last Modified Column'
,p_source=>'LAST_MODIFIED_COLUMN_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P3120.SEARCH_CONFIG.COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 column_display,',
'       case when :P3120_SEARCH_TYPE = ''APEX_LIST'' then',
'           to_char( seq_id ) ',
'       else',
'           c002',
'       end column_return,',
'      seq_id column_id',
' from wwv_flow_collections',
'where collection_name = ''APEX$SEARCH_CONFIG_COLUMNS''',
'  and c003           != ''BLOB'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_tag_css_classes=>'is-column'
,p_begin_on_new_line=>'N'
,p_grid_column=>8
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select a column containing a last modified or last updated date.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1772885242181036)
,p_name=>'P3120_CUSTOM_01_COLUMN_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(1710885494072504)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Custom Column 1'
,p_source=>'CUSTOM_01_COLUMN_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P3120.SEARCH_CONFIG.COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 column_display,',
'       case when :P3120_SEARCH_TYPE = ''APEX_LIST'' then',
'           to_char( seq_id ) ',
'       else',
'           c002',
'       end column_return,',
'      seq_id column_id',
' from wwv_flow_collections',
'where collection_name = ''APEX$SEARCH_CONFIG_COLUMNS''',
'  and c003           != ''BLOB'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_tag_css_classes=>'is-column'
,p_grid_column=>2
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select the column to be used as "custom attribute 1".'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1773230511181038)
,p_name=>'P3120_CUSTOM_02_COLUMN_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(1710885494072504)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Custom Column 2'
,p_source=>'CUSTOM_02_COLUMN_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P3120.SEARCH_CONFIG.COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 column_display,',
'       case when :P3120_SEARCH_TYPE = ''APEX_LIST'' then',
'           to_char( seq_id ) ',
'       else',
'           c002',
'       end column_return,',
'      seq_id column_id',
' from wwv_flow_collections',
'where collection_name = ''APEX$SEARCH_CONFIG_COLUMNS''',
'  and c003           != ''BLOB'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_tag_css_classes=>'is-column'
,p_begin_on_new_line=>'N'
,p_grid_column=>5
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select the column to be used as "custom attribute 2".'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1773671439181041)
,p_name=>'P3120_CUSTOM_03_COLUMN_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(1710885494072504)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Custom Column 3'
,p_source=>'CUSTOM_03_COLUMN_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P3120.SEARCH_CONFIG.COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 column_display,',
'       case when :P3120_SEARCH_TYPE = ''APEX_LIST'' then',
'           to_char( seq_id ) ',
'       else',
'           c002',
'       end column_return,',
'      seq_id column_id',
' from wwv_flow_collections',
'where collection_name = ''APEX$SEARCH_CONFIG_COLUMNS''',
'  and c003           != ''BLOB'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_tag_css_classes=>'is-column'
,p_begin_on_new_line=>'N'
,p_grid_column=>8
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select the column to be used as "custom attribute 3".'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1774089561181042)
,p_name=>'P3120_LINK_TARGET_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2010830403717939)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Link Type'
,p_source=>'LINK_TARGET_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'SEARCH_CONFIG.LINK_TARGET_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(2381418198192059)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Target -'
,p_cHeight=>1
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the type of link for this action to be used.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1774446600181044)
,p_name=>'P3120_LINK_TARGET'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2010830403717939)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_source=>'LINK_TARGET'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1774851736181046)
,p_name=>'P3120_ICON_SOURCE_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(6700676601775302)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Icon Source'
,p_source=>'ICON_SOURCE_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'SEARCH_CONFIG.ICON_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(2302791576703581)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Icon -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select the type for the icon that is displayed for each result of this search configuration.',
'<dl>',
'    <dt>Initials</dt>',
'    <dd>The initials of the <strong>Title</strong> column will be displayed as icon.',
'    <dt>Icon Class</dt>',
'    <dd>Pick (static) Icon CSS Classes.</dd>',
'    <dt>Icon Class Column</dt>',
'    <dd>Choose a column which will provide the (individual) Icon CSS Classes for each result.</dd>',
'    <dt>Image URL</dt>',
'    <dd>Provide the URL which points to an image to be displayed as icon. Supports substitutions.</dd>',
'    <dt>Image BLOB column</dt>',
'    <dd>Pick a column containing a BLOB to be displayed as icon.</dd>',
'</dl>',
'        '))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1775270344181048)
,p_name=>'P3120_ICON_CLASS_COLUMN_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(6700676601775302)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Icon Class Column Name'
,p_source=>'ICON_CLASS_COLUMN_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P3120.SEARCH_CONFIG.COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 column_display,',
'       case when :P3120_SEARCH_TYPE = ''APEX_LIST'' then',
'           to_char( seq_id ) ',
'       else',
'           c002',
'       end column_return,',
'      seq_id column_id',
' from wwv_flow_collections',
'where collection_name = ''APEX$SEARCH_CONFIG_COLUMNS''',
'  and c003           != ''BLOB'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_tag_css_classes=>'is-column'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select the column containing Icon CSS Classes for displaying an individual icon for each result.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1775616738181051)
,p_name=>'P3120_ICON_BLOB_COLUMN_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(6700676601775302)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Icon BLOB Column Name'
,p_source=>'ICON_BLOB_COLUMN_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P3120.SEARCH_CONFIG.BLOB_COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 column_display,',
'       case when :P3120_SEARCH_TYPE = ''APEX_LIST'' then',
'           to_char( seq_id ) ',
'       else',
'           c002',
'       end column_return,',
'      seq_id column_id',
' from wwv_flow_collections',
'where collection_name = ''APEX$SEARCH_CONFIG_COLUMNS''',
'  and c003            = ''BLOB'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_tag_css_classes=>'is-column is-blob'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select the BLOB column to be used as icon.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1776041620181053)
,p_name=>'P3120_ICON_IMAGE_URL'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(6700676601775302)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Icon Image URL'
,p_source=>'ICON_IMAGE_URL'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter the URL for the icon image source.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1776433881181056)
,p_name=>'P3120_ICON_CSS_CLASSES'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(6700676601775302)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Icon CSS Classes'
,p_source=>'ICON_CSS_CLASSES'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_css_classes=>'apex-item-group--color-picker'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Choose an icon or enter the Icon CSS Classes to be used for displaying the icon.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1776874750181057)
,p_name=>'P3120_DEFAULT_ROW_HTML_EXPR'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(6700676601775302)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Default Result Row Template'
,p_source=>'DEFAULT_ROW_HTML_EXPR'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Enter HTML Expression to display a search result row. Use <code>&COLUMN.</code> syntax to show column values in HTML. Supports template directives. In addition, the following substitutions are available:',
'</p>',
'<dl>',
'<dt>ICON_TYPE</dt>',
'<dd>Represents the icon type: Can be <strong>CLASS</strong>, <strong>URL</strong> or <strong>INITIALS</strong>.</dd>',
'<dt>ICON_VALUE</dt>',
'<dd>The actual icon value, depending on the value of <strong>ICON_TYPE</strong></dd>',
'<dt>RESULT_CSS_CLASSES</dt>',
'<dd>The CSS classes applied to each result, based on the <strong>Result CSS Classes</strong> attribute.</dd>',
'<dt>APEX$ORATEXT_SCORE</dt>',
'<dd>Column representing the Oracle Text Score for Oracle Text search types.</dd>',
'</dl>',
'<p>Example:</p>',
'<pre>',
'&lt;div class="a-ResultsItem &amp;RESULT_CSS_CLASSES!ATTR."&gt;',
'  {if ?ICON_VALUE/}',
'    {case ICON_TYPE/}',
'      {when INITIALS/}',
'        &lt;div class="a-ResultItem-initials u-color-var"&gt;&amp;ICON_VALUE.&lt;/div&gt;',
'      {when URL/}',
'        &lt;div class="a-ResultItem-image"&gt;&lt;img src="&amp;ICON_VALUE!ATTR." alt="&amp;ENAME!ATTR." role="presentation" /&gt;&lt;/div&gt;',
'      {when CLASS/}',
'        &lt;div class="a-ResultItem-icon u-color-var"&gt;&lt;span class="fa &amp;ICON_VALUE!ATTR." aria-hidden="true"&gt;&lt;/span&gt;&lt;/div&gt;',
'    {endcase/}',
'  {endif/}',
'  &lt;div class="a-ResultsItem-content"&gt;',
'    &lt;div class="a-ResultsItem-header"&gt;',
'      &lt;span class="a-ResultsItem-title"&gt;&lt;a href="f?p=&amp;APP_ID.:&amp;20:&amp;SESSION.::::P20_EMPNO:&amp;EMPNO."&gt;&amp;ENAME.&lt;/a&gt;&lt;/span&gt;',
'      &lt;span class="a-ResultsItem-badge"&gt;&amp;SAL.&lt;/span&gt;',
'    &lt;/div&gt;',
'    &lt;div class="a-ResultsItem-description"&gt;&amp;RESUMEE.&lt;/div&gt;',
'    &lt;div class="a-ResultsItem-attributes"&gt;',
'      {if ?COMM/}&lt;span class="a-ResultsItem-attribute"&gt;&amp;COMM.&lt;/span&gt;{endif/}',
'      {if ?JOB/}&lt;span class="a-ResultsItem-attribute"&gt;&amp;JOB.&lt;/span&gt;{endif/}',
'    &lt;/div&gt;',
'    &lt;div class="a-ResultsItem-misc"&gt;&amp;HIREDATE.&lt;/div&gt;',
'  &lt;/div&gt;',
'&lt;/div&gt;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1777668406181070)
,p_name=>'P3120_CONDITION_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>460
,p_item_plug_id=>wwv_flow_imp.id(1711155463072507)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Condition Type'
,p_source=>'CONDITION_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CONDITION_LIST'
,p_named_lov=>'STANDARD_CONDITION_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(13602414170805697)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Condition Specified -'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select a condition type from the list that must be met in order for this component to be rendered processed.'
,p_attribute_01=>'P3120_CONDITION_EXPR1'
,p_attribute_02=>'P3120_CONDITION_EXPR2'
,p_attribute_04=>'P3120_CONDITION_CHECK'
,p_attribute_06=>'AUTOM'
,p_attribute_07=>'P3120_CONDITION_LANG'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1778051334181074)
,p_name=>'P3120_CONDITION_EXPR1'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>480
,p_item_plug_id=>wwv_flow_imp.id(1711155463072507)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Expression 1'
,p_source=>'CONDITION_EXPR1'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>6
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'This attribute allows you to conditionally control whether or not a  component is rendered or processed. Enter values in this attribute based on the specific condition type selected. The component will be rendered or processed if the specified condit'
||'ion is met.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1778443251181078)
,p_name=>'P3120_CONDITION_EXPR2'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>500
,p_item_plug_id=>wwv_flow_imp.id(1711155463072507)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Expression 2'
,p_source=>'CONDITION_EXPR2'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>6
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Some condition types require two expressions for comparison. Enter the second expression or item here.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1778822470181079)
,p_name=>'P3120_AUTHORIZATION_SCHEME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2418843606518816)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Authorization Scheme'
,p_source=>'AUTHORIZATION_SCHEME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REQUIRED_ROLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.d, a.r from (',
'    select wwv_flow_lang.system_message(''MUST_NOT_BE_PUBLIC_USER'') d,''MUST_NOT_BE_PUBLIC_USER'' r, 1',
'      from sys.dual',
'    union all',
'    select wwv_flow_escape.html(substr(name,1,50)),to_char(id), 1',
'      from wwv_flow_security_schemes',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID',
'    union all',
'    select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'',wwv_flow_escape.html(substr(name,1,50)))||''}'' d, ''!''||to_char(id) r, 2',
'      from wwv_flow_security_schemes',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID',
'    order by 3,1) a'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Authorization Required -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Optionally select an authorization scheme which must evaluate to TRUE in order for this component to be rendered or otherwise processed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1779206637181081)
,p_name=>'P3120_BUILD_OPTION_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2418843606518816)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Build Option'
,p_source=>'BUILD_OPTION_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PATCHES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(patch_name) pn, id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'', wwv_flow_escape.html(patch_name))||',
'''} '' pn,0-id id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by pn'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Build Option -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a build option for this component. Build options are predefined settings that determine whether or not components within an application are enabled.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1779625414181083)
,p_name=>'P3120_SEARCH_COMMENT'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2418843606518816)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Comments'
,p_source=>'SEARCH_COMMENT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter any developer comments or notes here. These comments only display within App Builder and never display when running the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1780008606181084)
,p_name=>'P3120_REFERENCE_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(1711851376072514)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Subscribe From'
,p_source=>'REFERENCE_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FLOW_SUBSCRIBE_FROM_SEARCH_CONFIGS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select s.flow_id ||'' : ''|| s.label d,',
'       s.id r',
'  from wwv_flow_search_configs s',
' where s.flow_id != nvl(:FB_FLOW_ID,0)',
'   and s.security_group_id = :WORKSPACE_ID',
'   and exists (',
'        select *',
'          from wwv_main_apps_dev f',
'         where f.security_group_id = :WORKSPACE_ID',
'           and f.build_status      not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'           and s.flow_id           = f.id )',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Subscription -'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a master search configuration to subscribe from. When you select a master search configuration and click <strong>Apply Changes</strong>, this search configuration will be automatically refreshed from the master. <br /><br />If the search confi'
||'guration is already subscribed, click <strong>Refresh</strong> to refresh the search configuration details from the master.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'Y'
,p_attribute_06=>'0'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1820481369134513)
,p_name=>'P3120_MIMETYPE_COLUMN_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(6700676601775302)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Icon Mime Type Column Name'
,p_source=>'ICON_MIMETYPE_COLUMN_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P3114.SEARCH_CONFIG.COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 column_display,',
'       case when :P3111_SEARCH_TYPE = ''APEX_LIST'' then',
'           to_char( seq_id ) ',
'       else',
'           c002',
'       end column_return,',
'      seq_id column_id',
' from wwv_flow_collections',
'where collection_name = ''APEX$SEARCH_CONFIG_COLUMNS'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_tag_css_classes=>'is-column'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select the column containing the mime type, which describes the contents of the BLOB column.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1823444462134543)
,p_name=>'P3120_RESULT_CSS_CLASSES'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(6700676601775302)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Result CSS Classes'
,p_source=>'RESULT_CSS_CLASSES'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter the CSS Classes to be applied to each result. In row templates, this value will be available as the <strong>RESULT_CSS_CLASSES</strong> substitution.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1880759589911003)
,p_name=>'P3120_SEARCH_INDEX_OWNER'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1880676739911002)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_source=>'ORATEXT_INDEX_OWNER'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_help_text=>'Choose an owner that has an Oracle Ubiquitous Search index. Only schemas are listed for which you also have object privileges.'
,p_attribute_01=>'Y'
,p_item_comment=>'The search index and source have to be in the parsing schema. This might change in a later release. At this moment we do not have a ALL_... dictionary view.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1880873709911004)
,p_name=>'P3120_SEARCH_INDEX_NAME'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1880676739911002)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Search Index Name'
,p_source=>'ORATEXT_INDEX_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value as d, column_value as r',
'  from table (wwv_flow_search_dev.get_dbms_search_indexes( p_application_id => :FB_FLOW_ID) );'))
,p_cHeight=>1
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Choose an Oracle Ubiquitous Search index, this index must already exist in your parsing schema.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1880971048911005)
,p_name=>'P3120_SEARCH_SOURCE_OWNER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1880676739911002)
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Choose an owner. Only schemas are listed for which a data source exists for the selected Oracle Ubiquitous Search index.'
,p_attribute_01=>'Y'
,p_item_comment=>'The search index and source have to be in the parsing schema. This might change in a later release. At this moment we do not have a ALL_... dictionary view.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1881027793911006)
,p_name=>'P3120_SEARCH_SOURCE_NAME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(1880676739911002)
,p_prompt=>'Search Source Name'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value as d, column_value as r',
'  from table (wwv_flow_search_dev.get_dbms_search_sources( p_application_id => :FB_FLOW_ID,',
'                                                           p_index_name     => :P3120_SEARCH_INDEX_NAME) );'))
,p_lov_cascade_parent_items=>'P3120_SEARCH_INDEX_NAME'
,p_ajax_items_to_submit=>'P3120_SEARCH_INDEX_NAME'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Choose an Oracle Ubiquitous Search Index source from your parsing schema which is part of your selected Oracle Ubiquitous Search Index.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1881125665911007)
,p_name=>'P3120_SEARCH_ORDER_BY'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(1880676739911002)
,p_prompt=>'Order By Clause'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>2
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a valid SQL ORDER BY expression, used to sort the records retrieved.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1931514332915006)
,p_name=>'P3120_ORATEXT_FUNCTION_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1881230294911008)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Text Query Function'
,p_source=>'ORATEXT_FUNCTION_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TEXT_QUERY_FUNCTION_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(1936977999928971)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'None'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The Oracle Text query syntax is very complex and powerful and provides a rich set of query operators to deal with wildcards, stemming, fuzzy searches and so forth. For end users, this syntax is often hard to understand. To simplify the search proc'
||'ess for users, you can select a function that automatically converts simple end user input into an Oracle Text query, with the advanced search features applied automatically. Options include:</p>',
'<ul>',
'    <li><strong>None</strong> - &PRODUCT_NAME. encloses each query term with "{" and "}", except the keywords <strong>and</strong> and <strong>or</strong>.</li>',
'    <li><strong>Search Engine</strong> - This function performs a query relaxation search to retrieve relevant results beyond just exact matches. The goal is to get as many related results as possible, allowing users to easily find related informatio'
||'n without needing to input precise queries. The search process begins with an exact match search and then progressively relaxes the query using techniques like stemming and fuzzy matching. While maximizing the number of results, the search engine fun'
||'ction ensures that the most exact and relevant matches are always ranked at the top of the search results.</li>',
'    <li><strong>Expert Search</strong> - This function supports more advanced search operators for precise queries. It allows exact matching, Boolean operators (AND, OR, NOT), precedence with parentheses and proximity search. Additional parameters al'
||'low customizing search behavior. This is best when requiring highly accurate results from very specific queries. Also see the <code>QUERY_EXPERT_SEARCH</code> function within the <code>APEX_SEARCH</code> package.</li>',
'    <li><strong>Custom</strong> - Provide a custom function.</li>',
'</ul>'))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2007083626717901)
,p_name=>'P3120_OLD_LOCATION'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(4301496539800701)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2009720994717928)
,p_name=>'P3120_REMOTE_FUNC_BODY_LANG'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_imp.id(2008960404717920)
,p_prompt=>'Language'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2009809247717929)
,p_name=>'P3120_REMOTE_FUNC_BODY'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_imp.id(2008960404717920)
,p_prompt=>'Enter a Function Body returning a SQL Query'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>60
,p_cMaxlength=>32767
,p_cHeight=>8
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify a function body returning a SQL Query that will be used as source of the search configuration, for example:',
'<pre>',
'return q''~',
'select ename, empno',
'  from emp',
'~'';',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PAGE_ITEM'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_05=>'P3120_REMOTE_SERVER_ID'
,p_attribute_06=>'P3120_REMOTE_FUNC_BODY_LANG'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2010117213717932)
,p_name=>'P3120_OLD_WEB_SRC_MODULE_ID'
,p_item_sequence=>105
,p_item_plug_id=>wwv_flow_imp.id(1712144200072517)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2010569705717936)
,p_name=>'P3120_POST_PROC_FUNC_BODY'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(2602236053033212)
,p_prompt=>'Function Body returning SQL Query'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>60
,p_cMaxlength=>32767
,p_cHeight=>6
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a Function Body, where the SQL query returned transforms the data retrieved from the REST Source. The SQL query returned by the Function Body must select from the #APEX$SOURCE_DATA# pseudo-table and read columns available in the data profile. S'
||'ubquery factoring using the SQL WITH clause is not supported here.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PAGE_ITEM'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_06=>'P3120_POST_PROC_FUNC_LANG'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2010691451717937)
,p_name=>'P3120_PK2_COLUMN'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(1710885494072504)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Primary Key Column 2'
,p_source=>'PK2_COLUMN_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P3120.SEARCH_CONFIG.COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 column_display,',
'       case when :P3120_SEARCH_TYPE = ''APEX_LIST'' then',
'           to_char( seq_id ) ',
'       else',
'           c002',
'       end column_return,',
'      seq_id column_id',
' from wwv_flow_collections',
'where collection_name = ''APEX$SEARCH_CONFIG_COLUMNS''',
'  and c003           != ''BLOB'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_tag_css_classes=>'is-column'
,p_begin_on_new_line=>'N'
,p_grid_column=>5
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select the second primary key column, if exists.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2010743732717938)
,p_name=>'P3120_SCORE_COLUMN_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(1710885494072504)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Score Column'
,p_source=>'SCORE_COLUMN_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'P3120.SEARCH_CONFIG.COLUMNS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c001 column_display,',
'       case when :P3120_SEARCH_TYPE = ''APEX_LIST'' then',
'           to_char( seq_id ) ',
'       else',
'           c002',
'       end column_return,',
'      seq_id column_id',
' from wwv_flow_collections',
'where collection_name = ''APEX$SEARCH_CONFIG_COLUMNS''',
'  and c003           != ''BLOB'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Column -'
,p_cHeight=>1
,p_tag_css_classes=>'is-column'
,p_begin_on_new_line=>'N'
,p_grid_column=>5
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select the column to be used as search score.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2010901174717940)
,p_name=>'P3120_TARGET_APP_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2417497793518802)
,p_prompt=>'Application'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST FLOWS_NO_ESCAPE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||f.name d, f.id r',
'from   wwv_flow_visible_flows f',
'where  build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'order by 2'))
,p_cSize=>8
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter the application ID.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2011041292717941)
,p_name=>'P3120_TARGET_PAGE_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(2417497793518802)
,p_prompt=>'Page'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d',
'  from wwv_flow_steps',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and is_page_pattern   = ''N''',
'order by 2'))
,p_cSize=>8
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter the page number.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2011152638717942)
,p_name=>'P3120_TARGET_CLEAR_PAGE'
,p_item_sequence=>45
,p_item_plug_id=>wwv_flow_imp.id(2417497793518802)
,p_prompt=>'Reset pagination for this page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select this checkbox to reset the pagination that is linked to.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'YES'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2011220729717943)
,p_name=>'P3120_TARGET_CLEAR_CACHE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(2417497793518802)
,p_prompt=>'Clear Cache'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the page numbers, separated by commas, for which you would like the user''s session state to be cleared.  For example:',
'<p />',
'10,11,12',
'<p />',
'You can also reset a collection by passing including a collection name.  ',
'<p />'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2011303630717944)
,p_name=>'P3120_ARG_NAMES'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(2417497793518802)
,p_prompt=>'Set these items'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>60
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the list of application item names, separated by a comma, for which you would like to set the session state.'
,p_attribute_01=>'callItempopUp'
,p_attribute_03=>'Find Item'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2011480924717945)
,p_name=>'P3120_ARG_VALUES'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(2417497793518802)
,p_prompt=>'With these values'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>60
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter a comma delimited list of values for the items specified in <strong>Set these items</strong>. You can specify static values or substitution syntax (for example, &amp;APP_ITEM_NAME.). ',
'<pre>&amp;APP_ITEM_NAME.</pre>',
'<div class="htmldbInfoBodyP">Item values passed to <strong>f?p=</strong> in the URL may never contain a colon (:). Item values may also not contain commas unless you enclose the entire value in backslash characters. For example:</div>',
'<pre>\1234,56\</pre>',
'<div class="htmldbInfoBodyP">This is useful when decimal values must be passed where the NLS decimal separator character is a comma.</div>'))
,p_attribute_01=>'callItempopUp'
,p_attribute_03=>'Find Item'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2011512590717946)
,p_name=>'P3120_TARGET_URL'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(2417553805518803)
,p_prompt=>'URL Target'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the target URL to open when the link is clicked.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2011605530717947)
,p_name=>'P3120_TARGET_REQUEST'
,p_item_sequence=>45
,p_item_plug_id=>wwv_flow_imp.id(2417497793518802)
,p_prompt=>'Request'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter text that you would like to set the built-in application item REQUEST.  This is also the item that is set with the name of a button that was clicked.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2602718528033217)
,p_name=>'P3120_POST_PROC_WHERE'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(2602236053033212)
,p_prompt=>'Where Clause'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a valid SQL Where condition, used to limit the records retrieved.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2603777959033227)
,p_name=>'P3120_QUERY_FUNC_LANG'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(1711957073072515)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'Language'
,p_source=>'FUNCTION_BODY_LANGUAGE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Select a language that is used to evaluate the entered programming code.'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2603868632033228)
,p_name=>'P3120_QUERY_FUNC_BODY'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(1711957073072515)
,p_prompt=>'Enter a Function Body returning a SQL Query'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>60
,p_cMaxlength=>8000
,p_cHeight=>8
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify a function body returning a SQL Query that will be used as source of the search configuration, for example:',
'<pre>',
'return q''~',
'select ename, empno',
'  from emp',
'~'';',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PAGE_ITEM'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_06=>'P3120_QUERY_FUNC_LANG'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2604660834033236)
,p_name=>'P3120_POST_PROC_ORDER_BY'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(2602236053033212)
,p_prompt=>'Order By Clause'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>2
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a valid SQL Order By clause, used to sort the records retrieved.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2604710695033237)
,p_name=>'P3120_POST_PROC_SQL'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(2602236053033212)
,p_prompt=>'SQL Query'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>6
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a SQL Query to transform the data retrieved from the REST Data Source. Select from the pseudo-table #APEX$SOURCE_DATA# and specify columns available in the data profile. Subquery factoring using the SQL WITH clause is not supported here.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2604808968033238)
,p_name=>'P3120_POST_PROC_FUNC_LANG'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(2602236053033212)
,p_prompt=>'Language'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2605157716033241)
,p_name=>'P3120_REMOTE_SOURCE_TYPE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(2008960404717920)
,p_item_default=>'TABLE'
,p_prompt=>'Source Type'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXEC_REMOTE_SQL_DATA_SOURCE_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(1766286067212864)||'.'
,p_tag_css_classes=>'apex-button-group is-query'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the source of the REST Enabled SQL Service. REST Enabled SQL Service can be based on tables, SQL queries or PL/SQL functions returning a SQL query. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2605276764033242)
,p_name=>'P3120_REMOTE_SQL'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(2008960404717920)
,p_prompt=>'Enter a SQL SELECT statement'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>60
,p_cMaxlength=>32767
,p_cHeight=>8
,p_tag_css_classes=>'a-Form-textarea--code is-query'
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the SQL Query that will be used as source of the search configuration:',
'<pre>',
'select [col1], [col2], [col3], ...',
'  from ...',
' where ...',
' order by ...',
'</pre>',
'',
'For example:',
'<pre>',
'select empno, ename, job, hiredate, sal',
'  from emp ',
' where deptno = :my_item ',
' order by 1',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_05=>'P3120_REMOTE_SERVER_ID'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2605367121033243)
,p_name=>'P3120_REMOTE_TABLE_OWNER'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(2008960404717920)
,p_prompt=>'Table / View Owner'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value d, column_value r',
'  from table( wwv_flow_remote_server_dev.get_available_objects( :P3120_REMOTE_SERVER_ID, ''SCHEMAS''))',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Current Schema'
,p_lov_cascade_parent_items=>'P3120_REMOTE_SERVER_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the owner of the table on which you are basing this search configuration.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2605420235033244)
,p_name=>'P3120_REMOTE_TABLE_NAME'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(2008960404717920)
,p_prompt=>'Table / View Name'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value d, column_value r',
'  from table( wwv_flow_remote_server_dev.get_available_objects( :P3120_REMOTE_SERVER_ID, ''TABLE'', :P3120_REMOTE_TABLE_OWNER ))',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table or View -'
,p_lov_cascade_parent_items=>'P3120_REMOTE_TABLE_OWNER'
,p_ajax_items_to_submit=>'P3120_REMOTE_SERVER_ID'
,p_ajax_optimize_refresh=>'N'
,p_cSize=>30
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the table or view on which the search configuration will be based.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2605583485033245)
,p_name=>'P3120_REMOTE_WHERE'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(2008960404717920)
,p_prompt=>'Where Clause'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>2
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a valid SQL where condition, used to limit the records retrieved.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2605615242033246)
,p_name=>'P3120_REMOTE_ORDER_BY'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_imp.id(2008960404717920)
,p_prompt=>'Order By Clause'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>255
,p_cHeight=>2
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Provide an order by expression to be passed to the REST Enabled SQL Service.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2605789614033247)
,p_name=>'P3120_ORATEXT_OWNER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1712406847072520)
,p_prompt=>'Table / View Owner'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_SCHEMAS_HAVE_PRIVS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(owner) d, owner v',
'  from wwv_flow_object_owners_dev',
'order by d                   '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Parsing Schema -'
,p_cHeight=>1
,p_tag_css_classes=>'is-query'
,p_display_when=>'P3120_QUERY_TYPE'
,p_display_when2=>'TABLE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select the owner of the table containing Oracle Text index column.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2605846430033248)
,p_name=>'P3120_ORATEXT_TABLE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1712406847072520)
,p_prompt=>'Table / View Name'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = coalesce( :P3120_ORATEXT_OWNER, upper(wwv_flow_wizard_api.get_flow_owner(:FB_FLOW_ID)))'))
,p_lov_cascade_parent_items=>'P3120_ORATEXT_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>60
,p_cMaxlength=>128
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select name of the table containing Oracle Text index column.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2704952219067647)
,p_name=>'P3120_OLD_PK1_COLUMN'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1710885494072504)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2705224625067650)
,p_name=>'P3120_RETURN_TO_PAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2705158547067649)
,p_prompt=>'Return To Page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3206423171836705)
,p_name=>'P3120_SEARCHABLE_COLS_REQUIRED'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(6700537919775301)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4203396511667402)
,p_name=>'P3120_OLD_TITLE_COLUMN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1710885494072504)
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Select the column to be used as title.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4424892791889303)
,p_name=>'P3120_SOURCE_CHANGED'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1710799122072503)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6700713295775303)
,p_name=>'P3120_NO_RESULTS_FOUND_MESSAGE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(6700676601775302)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_prompt=>'No Results Found Message'
,p_source=>'NO_RESULTS_FOUND_MESSAGE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter a text message to display if the data source does not return any search results.'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6700822487775304)
,p_name=>'P3120_ORATEXT_WHERE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(1712406847072520)
,p_prompt=>'Where Clause'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>2
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a valid SQL where condition, used to limit the records retrieved.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6700934801775305)
,p_name=>'P3120_ORATEXT_ORDER_BY'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(1712406847072520)
,p_prompt=>'Order By Clause'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>255
,p_cHeight=>2
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a valid SQL ORDER BY expression, used to sort the records retrieved.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6701005759775306)
,p_name=>'P3120_ORATEXT_SQL'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(1712406847072520)
,p_prompt=>'Enter a SQL SELECT statement'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>60
,p_cMaxlength=>32767
,p_cHeight=>8
,p_tag_css_classes=>'a-Form-textarea--code is-query'
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the SQL Query that will be used as source of the search configuration:',
'<pre>',
'select [col1], [col2], [col3], ...',
'  from ...',
' where ...',
' order by ...',
'</pre>',
'',
'For example:',
'<pre>',
'select empno, ename, job, hiredate, sal',
'  from emp ',
' where deptno = :my_item ',
' order by 1',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_05=>'P3120_REMOTE_SERVER_ID'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6701146962775307)
,p_name=>'P3120_ORATEXT_SOURCE_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1712406847072520)
,p_prompt=>'Source Type'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXEC_QUERY_TYPES.TABLE_OR_SQL'
,p_lov=>'.'||wwv_flow_imp.id(6900320112159786)||'.'
,p_tag_css_classes=>'apex-button-group is-query'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the source of the search configuration. Oracle Text search configuration can be based on a Table or SQL Query.'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11092108248588010)
,p_name=>'P3120_VERSION_SCN'
,p_source_data_type=>'NUMBER'
,p_is_query_only=>true
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(1711851376072514)
,p_item_source_plug_id=>wwv_flow_imp.id(1757925019180889)
,p_source=>'VERSION_SCN'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11092217819588011)
,p_name=>'P3120_MASTER_VERSION_SCN'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(1711851376072514)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select version_scn ',
'  from wwv_flow_search_configs',
' where id                = :P3120_REFERENCE_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11092312143588012)
,p_name=>'P3120_REFERENCE_ID_INIT'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(1711851376072514)
,p_item_default=>'P3120_REFERENCE_ID'
,p_item_default_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1416902180012507)
,p_computation_sequence=>60
,p_computation_item=>'P3120_SUBSCRIBED_COMP_GRP'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_component_group_dev.is_part_of_subscribed_comp_grp (',
'    p_component_id   => :P3120_ID,',
'    p_component_type => wwv_flow_copy_metadata.c_search_config,',
'    p_app_id         => :FB_FLOW_ID )'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2418626056518814)
,p_computation_sequence=>30
,p_computation_item=>'P3120_LINK_TARGET'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_link        varchar2(4000);',
'begin',
'    if :P3120_LINK_TARGET_TYPE in ( ''REDIRECT_APP'', ''REDIRECT_PAGE'' ) then',
'        l_link := ''f?p='' ||',
'                  case when :P3120_LINK_TARGET_TYPE = ''REDIRECT_APP'' then',
'                      :P3120_TARGET_APP_ID',
'                  when :P3120_LINK_TARGET_TYPE = ''REDIRECT_PAGE'' then',
'                      ''&'' || ''APP_ID.''',
'                  end || '':'' ||',
'                  :P3120_TARGET_PAGE_ID || '':&'' || ''APP_SESSION.:'' ||',
'                  :P3120_TARGET_REQUEST || '':&'' || ''DEBUG.:'' ||',
'                  case when :P3120_TARGET_CLEAR_PAGE = ''YES'' then',
'                      ''RP,'' || :P3120_TARGET_CLEAR_CACHE',
'                  else',
'                      :P3120_TARGET_CLEAR_CACHE',
'                  end || '':'' ||',
'                  :P3120_ARG_NAMES || '':'' || :P3120_ARG_VALUES;',
'    elsif :P3120_LINK_TARGET_TYPE is null then',
'        l_link := null;',
'    else',
'        l_link := :P3120_TARGET_URL;',
'    end if;',
'    ',
'    return l_link;',
'end;',
''))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(4203671089667405)
,p_computation_sequence=>40
,p_computation_item=>'P3120_PK1_COLUMN'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P3120_OLD_PK1_COLUMN'
,p_compute_when=>':P3120_SOURCE_CHANGED = ''Y'' and :P3120_PK1_COLUMN is null'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(4203737588667406)
,p_computation_sequence=>50
,p_computation_item=>'P3120_TITLE_COLUMN_NAME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P3120_OLD_TITLE_COLUMN'
,p_compute_when=>':P3120_SOURCE_CHANGED = ''Y'' and :P3120_TITLE_COLUMN_NAME is null'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(4204767310667416)
,p_computation_sequence=>10
,p_computation_item=>'P3120_SOURCE_CHANGED'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2007143666717902)
,p_computation_sequence=>20
,p_computation_item=>'P3120_OLD_LOCATION'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P3120_LOCATION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2010279813717933)
,p_computation_sequence=>30
,p_computation_item=>'P3120_OLD_WEB_SRC_MODULE_ID'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P3120_WEB_SRC_MODULE_ID'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2705059889067648)
,p_computation_sequence=>40
,p_computation_item=>'P3120_OLD_PK1_COLUMN'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P3120_PK1_COLUMN'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(4203461389667403)
,p_computation_sequence=>50
,p_computation_item=>'P3120_OLD_TITLE_COLUMN'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P3120_TITLE_COLUMN_NAME'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1684438605640311)
,p_tabular_form_region_id=>wwv_flow_imp.id(2420091833518828)
,p_validation_name=>'Web Source Parameters: Validate NON-NULL'
,p_validation_sequence=>20
,p_validation=>'VALUE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#COLUMN_HEADER# must have a value.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST         = ''SAVE'' and ',
':VALUE_TYPE     != ''NULL'' and',
':P3120_LOCATION  = ''WEB_SOURCE'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_exec_cond_for_each_row=>'Y'
,p_associated_column=>'VALUE'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1711730591072513)
,p_validation_name=>'static ID exists'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /*+ NO_INDEX( wwv_flow_search_configs wwv_searchcfg_staticid_un2 ) */ 1',
'from wwv_flow_search_configs',
'where static_id = :P3120_STATIC_ID',
'and flow_id = :FB_FLOW_ID',
'and security_group_id = :WORKSPACE_ID',
'and id != :P3120_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'The Static ID is already used by another search configuration.'
,p_when_button_pressed=>wwv_flow_imp.id(1799745296181261)
,p_associated_item=>wwv_flow_imp.id(1760443232180987)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2605088937033240)
,p_validation_name=>'P3120_LIST_ID'
,p_validation_sequence=>50
,p_validation=>'P3120_LIST_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>'P3120_SEARCH_TYPE'
,p_validation_condition2=>'APEX_LIST'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(1799745296181261)
,p_associated_item=>wwv_flow_imp.id(1761628776180994)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2418355849518811)
,p_validation_name=>'Target APP_ID not null if redirect APP'
,p_validation_sequence=>60
,p_validation=>'P3120_TARGET_APP_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'P3120_LINK_TARGET_TYPE'
,p_validation_condition2=>'REDIRECT_APP'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(1799745296181261)
,p_associated_item=>wwv_flow_imp.id(2010901174717940)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2418431115518812)
,p_validation_name=>'Target PAGE_ID not null if redirect APP or Page'
,p_validation_sequence=>70
,p_validation=>'P3120_TARGET_PAGE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'P3120_LINK_TARGET_TYPE'
,p_validation_condition2=>'REDIRECT_APP:REDIRECT_PAGE'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_when_button_pressed=>wwv_flow_imp.id(1799745296181261)
,p_associated_item=>wwv_flow_imp.id(2011041292717941)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2418578702518813)
,p_validation_name=>'Target URL not null if redirect URL'
,p_validation_sequence=>80
,p_validation=>'P3120_TARGET_URL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'P3120_LINK_TARGET_TYPE'
,p_validation_condition2=>'REDIRECT_URL'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(1799745296181261)
,p_associated_item=>wwv_flow_imp.id(2011512590717946)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2421131651518839)
,p_tabular_form_region_id=>wwv_flow_imp.id(2420091833518828)
,p_validation_name=>'Web Source Parameters: Validate Code'
,p_validation_sequence=>100
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_web_src_dev.validate_web_src_param_value(',
'           p_application_id => :FB_FLOW_ID,',
'           p_data_type      => :DATA_TYPE,',
'           p_value_type     => :VALUE_TYPE,',
'           p_value_lang     => :VALUE_LANGUAGE,',
'           p_expression     => :VALUE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST        = ''SAVE'' and',
':P3120_LOCATION =  ''WEB_SOURCE'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_exec_cond_for_each_row=>'Y'
,p_associated_column=>'VALUE'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2421082066518838)
,p_tabular_form_region_id=>wwv_flow_imp.id(2420091833518828)
,p_validation_name=>'Web Source Parameters: Validate NULL'
,p_validation_sequence=>110
,p_validation=>':VALUE is NULL'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'The NULL value type cannot have a value.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST        = ''SAVE'' and ',
':VALUE_TYPE     = ''NULL'' and',
':P3120_LOCATION = ''WEB_SOURCE'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_exec_cond_for_each_row=>'Y'
,p_associated_column=>'VALUE'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4425062484889305)
,p_validation_name=>'Icon CSS required'
,p_validation_sequence=>120
,p_validation=>'P3120_ICON_CSS_CLASSES'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'P3120_ICON_SOURCE_TYPE'
,p_validation_condition2=>'STATIC_CLASS'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(1799745296181261)
,p_associated_item=>wwv_flow_imp.id(1776433881181056)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4425156749889306)
,p_validation_name=>'Icon Class Column Required'
,p_validation_sequence=>130
,p_validation=>'P3120_ICON_CLASS_COLUMN_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'P3120_ICON_SOURCE_TYPE'
,p_validation_condition2=>'DYNAMIC_CLASS'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(1799745296181261)
,p_associated_item=>wwv_flow_imp.id(1775270344181048)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4425278322889307)
,p_validation_name=>'Icon URL Required'
,p_validation_sequence=>140
,p_validation=>'P3120_ICON_IMAGE_URL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'P3120_ICON_SOURCE_TYPE'
,p_validation_condition2=>'URL'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(1799745296181261)
,p_associated_item=>wwv_flow_imp.id(1776041620181053)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4425308773889308)
,p_validation_name=>'Icon BLOB Column Required'
,p_validation_sequence=>150
,p_validation=>'P3120_ICON_BLOB_COLUMN_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'P3120_ICON_SOURCE_TYPE'
,p_validation_condition2=>'BLOB'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(1799745296181261)
,p_associated_item=>wwv_flow_imp.id(1775616738181051)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4301874120800705)
,p_validation_name=>'Selected Local Table Exists'
,p_validation_sequence=>160
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_f4000_util.does_table_view_exist (',
'          p_owner       => :P3120_QUERY_OWNER,',
'          p_object_name => :P3120_QUERY_TABLE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Table &P3120_QUERY_TABLE!HTML. does not exist. Note that the table name is case-sensitive.'
,p_validation_condition=>':P3120_SEARCH_TYPE = ''SIMPLE'' and :P3120_LOCATION = ''LOCAL'' and :P3120_QUERY_TYPE = ''TABLE'' and :P3120_QUERY_TABLE is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(1799745296181261)
,p_associated_item=>wwv_flow_imp.id(1765746832181003)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4301982923800706)
,p_validation_name=>'Selected Text Table Exists'
,p_validation_sequence=>170
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_f4000_util.does_table_view_exist (',
'          p_owner       => :P3120_ORATEXT_OWNER,',
'          p_object_name => :P3120_ORATEXT_TABLE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Table &P3120_ORATEXT_TABLE!HTML. does not exist. Note that the table name is case-sensitive.'
,p_validation_condition=>':P3120_SEARCH_TYPE = ''TEXT_MANUAL'' and :P3120_ORATEXT_TABLE is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(1799745296181261)
,p_associated_item=>wwv_flow_imp.id(2605846430033248)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2419953336518827)
,p_validation_name=>'Valid Simple Search Config Query'
,p_validation_sequence=>180
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- validate_query also validates that required items actually contain',
'-- a value (e.g. Table Name for Query Type = TABLE)',
'return wwv_flow_exec_dev.validate_query (',
'           p_application_id         => :FB_FLOW_ID,',
'           p_location               => :P3120_LOCATION,',
'           p_remote_server_id       => :P3120_REMOTE_SERVER_ID,',
'           p_web_src_module_id      => :P3120_WEB_SRC_MODULE_ID,',
'           --  ',
'           p_query_type             => :P3120_QUERY_TYPE,',
'           p_table_owner            => :P3120_QUERY_OWNER,',
'           p_table_name             => :P3120_QUERY_TABLE,',
'           p_where_clause           => case when :P3120_QUERY_TYPE = ''GRAPH'' then :P3120_PQL_WHERE_CLAUSE else :P3120_QUERY_WHERE end,',
'           p_match_clause           => :P3120_PQL_MATCH_CLAUSE,',
'           p_columns_clause         => :P3120_PQL_COLUMNS_CLAUSE,',
'           p_order_by_clause        => :P3120_QUERY_ORDER_BY,',
'           p_sql_query              => :P3120_QUERY_SQL,',
'           p_function_body          => :P3120_QUERY_SQL,',
'           p_function_body_language => :P3120_QUERY_FUNC_LANG,',
'           p_optimizer_hint         => :P3120_OPTIMIZER_HINT,',
'           --  ',
'           p_post_processing_type   => :P3120_POST_PROC_TYPE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':P3120_SEARCH_TYPE = ''SIMPLE'' and :P3120_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(1799745296181261)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4203820270667407)
,p_validation_name=>'Valid Oracle Text Search Config Query'
,p_validation_sequence=>190
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- validate_query also validates that required items actually contain',
'-- a value (e.g. Table Name for Query Type = TABLE)',
'return wwv_flow_exec_dev.validate_query (',
'           p_application_id       => :FB_FLOW_ID,',
'           p_location             => wwv_flow_exec_api.c_location_local_db,',
'           --',
'           p_query_type           => :P3120_ORATEXT_SOURCE_TYPE,',
'           p_table_owner          => :P3120_ORATEXT_OWNER,',
'           p_table_name           => :P3120_ORATEXT_TABLE,',
'           p_where_clause         => :P3120_ORATEXT_WHERE,',
'           p_order_by_clause      => :P3120_ORATEXT_ORDER_BY,',
'           p_sql_query            => :P3120_ORATEXT_SQL );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P3120_SEARCH_TYPE = ''TEXT_MANUAL'' and',
'   :P3120_ORATEXT_TABLE is not null and',
'   wwv_flow_f4000_util.does_table_view_exist (',
'            p_owner       => :P3120_ORATEXT_OWNER,',
'            p_object_name => :P3120_ORATEXT_TABLE ) then',
'    -- if Text Search, text table not null',
'    -- and correct P3120_ORATEXT_TABLE entered',
'    -- validate',
'    return true;',
'else',
'    -- if NOT Text Search, do NOT validate',
'    return false;',
'end if;'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'FUNCTION_BODY'
,p_when_button_pressed=>wwv_flow_imp.id(1799745296181261)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4203942726667408)
,p_validation_name=>'Search Config still referenced'
,p_validation_sequence=>200
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not wwv_flow_search_dev.is_search_config_used(',
'    p_application_id   => :FB_FLOW_ID,',
'    p_search_config_id => :P3120_ID )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'This Search Configuration is being referenced by application components, so you cannot delete it.'
,p_when_button_pressed=>wwv_flow_imp.id(1799303955181255)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3206305371836704)
,p_validation_name=>'Searchable Columns required'
,p_validation_sequence=>210
,p_validation=>'P3120_SEARCHABLE_COLUMNS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# are required.'
,p_validation_condition=>'P3120_SEARCHABLE_COLS_REQUIRED'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(1799745296181261)
,p_associated_item=>wwv_flow_imp.id(1768170127181014)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1821543858134524)
,p_validation_name=>'COLUMN_NAME_PK1 is valid'
,p_validation_sequence=>220
,p_validation=>'wwv_flow_search_dev.column_exists_in_collection( p_column_name => :P3120_PK1_COLUMN )'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'#LABEL# does not exist in data source.'
,p_validation_condition=>':P3120_PK1_COLUMN is not null and :P3120_SEARCH_TYPE in ( ''SIMPLE'', ''TEXT_MANUAL'' )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(1799745296181261)
,p_associated_item=>wwv_flow_imp.id(1770418249181028)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1821626615134525)
,p_validation_name=>'COLUMN_NAME_PK2 is valid'
,p_validation_sequence=>230
,p_validation=>'wwv_flow_search_dev.column_exists_in_collection( p_column_name => :P3120_PK2_COLUMN )'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'#LABEL# does not exist in data source.'
,p_validation_condition=>':P3120_PK2_COLUMN is not null and :P3120_SEARCH_TYPE in ( ''SIMPLE'', ''TEXT_MANUAL'' )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(1799745296181261)
,p_associated_item=>wwv_flow_imp.id(2010691451717937)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1821739708134526)
,p_validation_name=>'TITLE_COLUMN_NAME is valid'
,p_validation_sequence=>240
,p_validation=>'wwv_flow_search_dev.column_exists_in_collection( p_column_name => :P3120_TITLE_COLUMN_NAME )'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'#LABEL# does not exist in data source.'
,p_validation_condition=>':P3120_TITLE_COLUMN_NAME is not null and :P3120_SEARCH_TYPE in ( ''SIMPLE'', ''TEXT_MANUAL'' )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(1799745296181261)
,p_associated_item=>wwv_flow_imp.id(1770806341181029)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1821882170134527)
,p_validation_name=>'SUBTITLE_COLUMN_NAME is valid'
,p_validation_sequence=>250
,p_validation=>'wwv_flow_search_dev.column_exists_in_collection( p_column_name => :P3120_SUBTITLE_COLUMN_NAME )'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'#LABEL# does not exist in data source.'
,p_validation_condition=>':P3120_SUBTITLE_COLUMN_NAME is not null and :P3120_SEARCH_TYPE in ( ''SIMPLE'', ''TEXT_MANUAL'' )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(1799745296181261)
,p_associated_item=>wwv_flow_imp.id(1771220601181029)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1821933247134528)
,p_validation_name=>'DESCRIPTION_COLUMN_NAME is valid'
,p_validation_sequence=>260
,p_validation=>'wwv_flow_search_dev.column_exists_in_collection( p_column_name => :P3120_DESCRIPTION_COLUMN_NAME )'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'#LABEL# does not exist in data source.'
,p_validation_condition=>':P3120_DESCRIPTION_COLUMN_NAME is not null and :P3120_SEARCH_TYPE in ( ''SIMPLE'', ''TEXT_MANUAL'' )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(1799745296181261)
,p_associated_item=>wwv_flow_imp.id(1771671080181030)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1822051814134529)
,p_validation_name=>'CUSTOM_01_COLUMN_NAME is valid'
,p_validation_sequence=>270
,p_validation=>'wwv_flow_search_dev.column_exists_in_collection( p_column_name => :P3120_CUSTOM_01_COLUMN_NAME )'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'#LABEL# does not exist in data source.'
,p_validation_condition=>':P3120_CUSTOM_01_COLUMN_NAME is not null and :P3120_SEARCH_TYPE in ( ''SIMPLE'', ''TEXT_MANUAL'' )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(1799745296181261)
,p_associated_item=>wwv_flow_imp.id(1772885242181036)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1822119624134530)
,p_validation_name=>'CUSTOM_02_COLUMN_NAME is valid'
,p_validation_sequence=>280
,p_validation=>'wwv_flow_search_dev.column_exists_in_collection( p_column_name => :P3120_CUSTOM_02_COLUMN_NAME )'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'#LABEL# does not exist in data source.'
,p_validation_condition=>':P3120_CUSTOM_02_COLUMN_NAME is not null and :P3120_SEARCH_TYPE in ( ''SIMPLE'', ''TEXT_MANUAL'' )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(1799745296181261)
,p_associated_item=>wwv_flow_imp.id(1773230511181038)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1822202273134531)
,p_validation_name=>'CUSTOM_03_COLUMN_NAME is valid'
,p_validation_sequence=>290
,p_validation=>'wwv_flow_search_dev.column_exists_in_collection( p_column_name => :P3120_CUSTOM_03_COLUMN_NAME )'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'#LABEL# does not exist in data source.'
,p_validation_condition=>':P3120_CUSTOM_03_COLUMN_NAME is not null and :P3120_SEARCH_TYPE in ( ''SIMPLE'', ''TEXT_MANUAL'' )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(1799745296181261)
,p_associated_item=>wwv_flow_imp.id(1773671439181041)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1822397641134532)
,p_validation_name=>'BADGE_COLUMN_NAME is valid'
,p_validation_sequence=>300
,p_validation=>'wwv_flow_search_dev.column_exists_in_collection( p_column_name => :P3120_BADGE_COLUMN_NAME )'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'#LABEL# does not exist in data source.'
,p_validation_condition=>':P3120_BADGE_COLUMN_NAME is not null and :P3120_SEARCH_TYPE in ( ''SIMPLE'', ''TEXT_MANUAL'' )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(1799745296181261)
,p_associated_item=>wwv_flow_imp.id(1772030432181032)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1822425510134533)
,p_validation_name=>'ICON_MIMETYPE_COLUMN_NAME is valid'
,p_validation_sequence=>310
,p_validation=>'wwv_flow_search_dev.column_exists_in_collection( p_column_name => :P3120_MIMETYPE_COLUMN_NAME )'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'#LABEL# does not exist in data source.'
,p_validation_condition=>':P3120_MIMETYPE_COLUMN_NAME is not null and :P3120_SEARCH_TYPE in ( ''SIMPLE'', ''TEXT_MANUAL'' )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(1799745296181261)
,p_associated_item=>wwv_flow_imp.id(1820481369134513)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1822506728134534)
,p_validation_name=>'LAST_MOD_COLUMN_NAME is valid'
,p_validation_sequence=>320
,p_validation=>'wwv_flow_search_dev.column_exists_in_collection( p_column_name => :P3120_LAST_MOD_COLUMN_NAME )'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'#LABEL# does not exist in data source.'
,p_validation_condition=>':P3120_LAST_MOD_COLUMN_NAME is not null and :P3120_SEARCH_TYPE in ( ''SIMPLE'', ''TEXT_MANUAL'' )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(1799745296181261)
,p_associated_item=>wwv_flow_imp.id(1772492935181035)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1822768998134536)
,p_validation_name=>'ICON_CLASS_COLUMN_NAME is valid'
,p_validation_sequence=>330
,p_validation=>'wwv_flow_search_dev.column_exists_in_collection( p_column_name => :P3120_ICON_CLASS_COLUMN_NAME )'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'#LABEL# does not exist in data source.'
,p_validation_condition=>':P3120_ICON_CLASS_COLUMN_NAME is not null and :P3120_SEARCH_TYPE in ( ''SIMPLE'', ''TEXT_MANUAL'' )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(1799745296181261)
,p_associated_item=>wwv_flow_imp.id(1775270344181048)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1822836483134537)
,p_validation_name=>'ICON_BLOB_COLUMN_NAME is valid'
,p_validation_sequence=>340
,p_validation=>'wwv_flow_search_dev.column_exists_in_collection( p_column_name => :P3120_ICON_BLOB_COLUMN_NAME )'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'#LABEL# does not exist in data source.'
,p_validation_condition=>':P3120_ICON_BLOB_COLUMN_NAME is not null and :P3120_SEARCH_TYPE in ( ''SIMPLE'', ''TEXT_MANUAL'' )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(1799745296181261)
,p_associated_item=>wwv_flow_imp.id(1775616738181051)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1822935974134538)
,p_validation_name=>'ORATEXT_INDEX_COLUMN is valid'
,p_validation_sequence=>350
,p_validation=>'wwv_flow_search_dev.column_exists_in_collection( p_column_name => :P3120_ORATEXT_INDEX_COLUMN )'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'#LABEL# does not exist in data source.'
,p_validation_condition=>':P3120_ORATEXT_INDEX_COLUMN is not null and :P3120_SEARCH_TYPE in ( ''SIMPLE'', ''TEXT_MANUAL'' )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(1799745296181261)
,p_associated_item=>wwv_flow_imp.id(1768510517181016)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1637808146313216)
,p_validation_name=>'PQL Graph is required'
,p_validation_sequence=>360
,p_validation=>'P3120_GRAPH_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>'P3120_QUERY_TYPE'
,p_validation_condition2=>'GRAPH'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(1799745296181261)
,p_associated_item=>wwv_flow_imp.id(1637015721313208)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1637955254313217)
,p_validation_name=>'PQL Graph Match Clause required'
,p_validation_sequence=>370
,p_validation=>'P3120_PQL_MATCH_CLAUSE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>'P3120_QUERY_TYPE'
,p_validation_condition2=>'GRAPH'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(1799745296181261)
,p_associated_item=>wwv_flow_imp.id(1637185764313209)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1638035248313218)
,p_validation_name=>'PQL Graph Columns Clause required'
,p_validation_sequence=>380
,p_validation=>'P3120_PQL_COLUMNS_CLAUSE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>'P3120_QUERY_TYPE'
,p_validation_condition2=>'GRAPH'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(1799745296181261)
,p_associated_item=>wwv_flow_imp.id(1637294480313210)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1931614813915007)
,p_validation_name=>'Text Query Function is NOT NULL'
,p_validation_sequence=>390
,p_validation=>'P3120_ORATEXT_FUNCTION'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# is required.'
,p_validation_condition=>'P3120_ORATEXT_FUNCTION_TYPE'
,p_validation_condition2=>'CUSTOM'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(1799745296181261)
,p_associated_item=>wwv_flow_imp.id(1769392176181022)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1492163853323201)
,p_validation_name=>'BLOB restriction Ubiquitous'
,p_validation_sequence=>400
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not ( :P3120_SEARCH_TYPE                  = ''TEXT_DBMS_SEARCH''',
'  and NVL( :P3120_ICON_SOURCE_TYPE, ''X'' ) = ''BLOB'' )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'BLOB column as icon source is not supported for the search type Oracle Ubiquitous Search.'
,p_always_execute=>'Y'
,p_when_button_pressed=>wwv_flow_imp.id(1799745296181261)
,p_associated_item=>wwv_flow_imp.id(1774851736181046)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3917108814255121)
,p_validation_name=>'Not part of component groups'
,p_validation_sequence=>400
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not wwv_flow_component_group_dev.is_part_of_comp_grp (',
'    p_component_id   => :P3120_ID,',
'    p_component_type => wwv_flow_copy_metadata.c_search_config,',
'    p_app_id         => :FB_FLOW_ID )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Search Configuration cannot be deleted because it is part of a component group.'
,p_when_button_pressed=>wwv_flow_imp.id(1799303955181255)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2007226089717903)
,p_name=>'Location Local'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3120_LOCATION'
,p_condition_element=>'P3120_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'LOCAL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2007314214717904)
,p_event_id=>wwv_flow_imp.id(2007226089717903)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1711957073072515)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2007403466717905)
,p_event_id=>wwv_flow_imp.id(2007226089717903)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1711957073072515)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2007522738717906)
,p_event_id=>wwv_flow_imp.id(2007226089717903)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_REMOTE_SERVER_ID'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2007643728717907)
,p_name=>'Location Remote'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3120_LOCATION'
,p_condition_element=>'P3120_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REMOTE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2007756178717908)
,p_event_id=>wwv_flow_imp.id(2007643728717907)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1712239748072518)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2007877045717909)
,p_event_id=>wwv_flow_imp.id(2007643728717907)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1712239748072518)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2007915114717910)
,p_name=>'Location REST Data Source'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3120_LOCATION'
,p_condition_element=>'P3120_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'WEB_SOURCE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2008044464717911)
,p_event_id=>wwv_flow_imp.id(2007915114717910)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1712144200072517)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2008128959717912)
,p_event_id=>wwv_flow_imp.id(2007915114717910)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1712144200072517)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2008279276717913)
,p_event_id=>wwv_flow_imp.id(2007915114717910)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_POST_PROC_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'NONE'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_server_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2008339789717914)
,p_event_id=>wwv_flow_imp.id(2007915114717910)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_WEB_SRC_MODULE_ID'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2601811228033208)
,p_name=>'QUERY TYPE = TABLE'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3120_QUERY_TYPE'
,p_condition_element=>'P3120_QUERY_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TABLE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1638686899313224)
,p_event_id=>wwv_flow_imp.id(2601811228033208)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_QUERY_OWNER,P3120_QUERY_TABLE,P3120_QUERY_WHERE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2422270364518850)
,p_event_id=>wwv_flow_imp.id(2601811228033208)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_QUERY_SQL,P3120_OPTIMIZER_HINT,P3120_QUERY_FUNC_LANG,P3120_QUERY_FUNC_BODY,P3120_GRAPH_NAME,P3120_PQL_MATCH_CLAUSE,P3120_PQL_COLUMNS_CLAUSE,P3120_PQL_WHERE_CLAUSE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2601930779033209)
,p_event_id=>wwv_flow_imp.id(2601811228033208)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_QUERY_OWNER,P3120_QUERY_TABLE,P3120_QUERY_WHERE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2601181186033201)
,p_name=>'QUERY TYPE = SQL'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3120_QUERY_TYPE'
,p_condition_element=>'P3120_QUERY_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SQL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2601211296033202)
,p_event_id=>wwv_flow_imp.id(2601181186033201)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_QUERY_SQL,P3120_OPTIMIZER_HINT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2422002833518848)
,p_event_id=>wwv_flow_imp.id(2601181186033201)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_QUERY_OWNER,P3120_QUERY_TABLE,P3120_QUERY_WHERE,P3120_QUERY_FUNC_LANG,P3120_QUERY_FUNC_BODY,P3120_GRAPH_NAME,P3120_PQL_MATCH_CLAUSE,P3120_PQL_COLUMNS_CLAUSE,P3120_PQL_WHERE_CLAUSE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4204638559667415)
,p_event_id=>wwv_flow_imp.id(2601181186033201)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_QUERY_SQL'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.item("P3120_QUERY_TABLE").getValue() !== "" ',
'?',
'apex.builder.sql.buildSelectStmt( "P3120_QUERY_OWNER", "P3120_QUERY_TABLE", "P3120_QUERY_WHERE" )',
':',
'""'))
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2601650736033206)
,p_name=>'QUERY TYPE = FUNC_BODY_RETURNING_SQL'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3120_QUERY_TYPE'
,p_condition_element=>'P3120_QUERY_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FUNC_BODY_RETURNING_SQL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2601750322033207)
,p_event_id=>wwv_flow_imp.id(2601650736033206)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_QUERY_FUNC_LANG,P3120_QUERY_FUNC_BODY,P3120_OPTIMIZER_HINT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2422101923518849)
,p_event_id=>wwv_flow_imp.id(2601650736033206)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_QUERY_OWNER,P3120_QUERY_TABLE,P3120_QUERY_WHERE,P3120_QUERY_SQL,P3120_GRAPH_NAME,P3120_PQL_MATCH_CLAUSE,P3120_PQL_COLUMNS_CLAUSE,P3120_PQL_WHERE_CLAUSE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1823361468134542)
,p_event_id=>wwv_flow_imp.id(2601650736033206)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_QUERY_FUNC_BODY'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.item("P3120_QUERY_TABLE").getValue() !== "" ',
'?',
'apex.builder.sql.buildSelectStmt( "P3120_QUERY_OWNER", "P3120_QUERY_TABLE", "P3120_QUERY_WHERE" )',
':',
'""'))
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1637474114313212)
,p_name=>'QUERY TYPE = GRAPH'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3120_QUERY_TYPE'
,p_condition_element=>'P3120_QUERY_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'GRAPH'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1637567982313213)
,p_event_id=>wwv_flow_imp.id(1637474114313212)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_GRAPH_NAME,P3120_PQL_MATCH_CLAUSE,P3120_PQL_COLUMNS_CLAUSE,P3120_PQL_WHERE_CLAUSE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1638520419313223)
,p_event_id=>wwv_flow_imp.id(1637474114313212)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_PQL_MATCH_CLAUSE,P3120_PQL_COLUMNS_CLAUSE,P3120_PQL_WHERE_CLAUSE,P3120_GRAPH_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1637606368313214)
,p_event_id=>wwv_flow_imp.id(1637474114313212)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_QUERY_OWNER,P3120_QUERY_TABLE,P3120_QUERY_WHERE,P3120_QUERY_SQL,P3120_QUERY_FUNC_LANG,P3120_QUERY_FUNC_BODY,P3120_OPTIMIZER_HINT'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2829472450926514)
,p_name=>'REMOTE SERVER CHANGES'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3120_REMOTE_SERVER_ID'
,p_condition_element=>'P3120_REMOTE_SERVER_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2829573461926515)
,p_event_id=>wwv_flow_imp.id(2829472450926514)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2008960404717920)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2829819475926518)
,p_event_id=>wwv_flow_imp.id(2829472450926514)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_REMOTE_SOURCE_TYPE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2829747189926517)
,p_event_id=>wwv_flow_imp.id(2829472450926514)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_REMOTE_SOURCE_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'TABLE'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2829933294926519)
,p_event_id=>wwv_flow_imp.id(2829472450926514)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2008960404717920)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2009248515717923)
,p_name=>'REMOTE SOURCE TYPE = TABLE'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3120_REMOTE_SOURCE_TYPE'
,p_condition_element=>'P3120_REMOTE_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TABLE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2009398338717924)
,p_event_id=>wwv_flow_imp.id(2009248515717923)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_REMOTE_TABLE_OWNER,P3120_REMOTE_TABLE_NAME,P3120_REMOTE_WHERE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2704912327390501)
,p_event_id=>wwv_flow_imp.id(2009248515717923)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_REMOTE_TABLE_OWNER,P3120_REMOTE_TABLE_NAME,P3120_REMOTE_WHERE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2830019285926520)
,p_name=>'REMOTE SOURCE TYPE = SQL'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3120_REMOTE_SOURCE_TYPE'
,p_condition_element=>'P3120_REMOTE_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SQL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2705091127390502)
,p_event_id=>wwv_flow_imp.id(2830019285926520)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_REMOTE_SQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2830191871926521)
,p_event_id=>wwv_flow_imp.id(2830019285926520)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_REMOTE_SQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2830512963926525)
,p_event_id=>wwv_flow_imp.id(2830019285926520)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_REMOTE_SQL'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.item( "P3120_REMOTE_TABLE_NAME").getValue() !== "" ',
'?',
'apex.builder.sql.buildSelectStmt( "P3120_REMOTE_TABLE_OWNER", "P3120_REMOTE_TABLE_NAME", "P3120_REMOTE_WHERE" )',
':',
'""'))
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_client_condition_type=>'NOT_NULL'
,p_client_condition_element=>'P3120_REMOTE_TABLE_NAME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2009944184717930)
,p_name=>'REMOTE SOURCE TYPE = FUNC_BODY_RETURNING_SQL'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3120_REMOTE_SOURCE_TYPE'
,p_condition_element=>'P3120_REMOTE_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FUNC_BODY_RETURNING_SQL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2010041099717931)
,p_event_id=>wwv_flow_imp.id(2009944184717930)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_REMOTE_FUNC_BODY_LANG,P3120_REMOTE_FUNC_BODY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2705115555390503)
,p_event_id=>wwv_flow_imp.id(2009944184717930)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_REMOTE_FUNC_BODY_LANG,P3120_REMOTE_FUNC_BODY'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2831652754926536)
,p_name=>'POST PROC TYPE = WHERE'
,p_event_sequence=>120
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3120_POST_PROC_TYPE'
,p_condition_element=>'P3120_POST_PROC_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'WHERE_ORDER_BY_CLAUSE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2705244843390504)
,p_event_id=>wwv_flow_imp.id(2831652754926536)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_POST_PROC_WHERE,P3120_POST_PROC_ORDER_BY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2831779422926537)
,p_event_id=>wwv_flow_imp.id(2831652754926536)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_POST_PROC_WHERE,P3120_POST_PROC_ORDER_BY'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2831883210926538)
,p_name=>'POST PROC TYPE = SQL'
,p_event_sequence=>130
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3120_POST_PROC_TYPE'
,p_condition_element=>'P3120_POST_PROC_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SQL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2705330854390505)
,p_event_id=>wwv_flow_imp.id(2831883210926538)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_POST_PROC_SQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2831927772926539)
,p_event_id=>wwv_flow_imp.id(2831883210926538)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_POST_PROC_SQL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2010375776717934)
,p_name=>'POST PROC TYPE = FUNC_BODY_RETURNING_SQL'
,p_event_sequence=>140
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3120_POST_PROC_TYPE'
,p_condition_element=>'P3120_POST_PROC_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FUNC_BODY_RETURNING_SQL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2010474459717935)
,p_event_id=>wwv_flow_imp.id(2010375776717934)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_POST_PROC_FUNC_LANG,P3120_POST_PROC_FUNC_BODY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2705468902390506)
,p_event_id=>wwv_flow_imp.id(2010375776717934)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_POST_PROC_FUNC_LANG,P3120_POST_PROC_FUNC_BODY'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2602428970033214)
,p_name=>'REST Data Source Selected'
,p_event_sequence=>150
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3120_WEB_SRC_MODULE_ID'
,p_condition_element=>'P3120_WEB_SRC_MODULE_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2602540290033215)
,p_event_id=>wwv_flow_imp.id(2602428970033214)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2602236053033212)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2602692867033216)
,p_event_id=>wwv_flow_imp.id(2602428970033214)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2602236053033212)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2704574296067643)
,p_event_id=>wwv_flow_imp.id(2602428970033214)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2420091833518828)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2704607836067644)
,p_event_id=>wwv_flow_imp.id(2602428970033214)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_EXTERNAL_FILTER_EXPR,P3120_POST_PROC_TYPE,P3120_POST_PROC_WHERE,P3120_POST_PROC_ORDER_BY,P3120_POST_PROC_SQL,P3120_POST_PROC_FUNC_LANG,P3120_POST_PROC_FUNC_BODY,P3120_WEB_SRC_FUNCTION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2702933107067627)
,p_name=>'ICON_SOURCE_TYPE = DYNAMIC'
,p_event_sequence=>160
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3120_ICON_SOURCE_TYPE'
,p_condition_element=>'P3120_ICON_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'DYNAMIC_CLASS'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2703005249067628)
,p_event_id=>wwv_flow_imp.id(2702933107067627)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_ICON_CLASS_COLUMN_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2705558265390507)
,p_event_id=>wwv_flow_imp.id(2702933107067627)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_ICON_CLASS_COLUMN_NAME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2703194452067629)
,p_name=>'ICON_SOURCE_TYPE = STATIC'
,p_event_sequence=>170
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3120_ICON_SOURCE_TYPE'
,p_condition_element=>'P3120_ICON_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'STATIC_CLASS'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2703202962067630)
,p_event_id=>wwv_flow_imp.id(2703194452067629)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_ICON_CSS_CLASSES'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2705665277390508)
,p_event_id=>wwv_flow_imp.id(2703194452067629)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_ICON_CSS_CLASSES'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2703325445067631)
,p_name=>'ICON_SOURCE_TYPE = URL'
,p_event_sequence=>180
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3120_ICON_SOURCE_TYPE'
,p_condition_element=>'P3120_ICON_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'URL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2703457377067632)
,p_event_id=>wwv_flow_imp.id(2703325445067631)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_ICON_IMAGE_URL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2705780849390509)
,p_event_id=>wwv_flow_imp.id(2703325445067631)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_ICON_IMAGE_URL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2703505319067633)
,p_name=>'ICON_SOURCE_TYPE = BLOB'
,p_event_sequence=>190
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3120_ICON_SOURCE_TYPE'
,p_condition_element=>'P3120_ICON_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'BLOB'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2703611840067634)
,p_event_id=>wwv_flow_imp.id(2703505319067633)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_ICON_BLOB_COLUMN_NAME,P3120_MIMETYPE_COLUMN_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2705898697390510)
,p_event_id=>wwv_flow_imp.id(2703505319067633)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_ICON_BLOB_COLUMN_NAME,P3120_MIMETYPE_COLUMN_NAME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2011944169717950)
,p_name=>'LINK_TARGET_TYPE in  ( REDIRECT_APP, REDIRECT_PAGE )'
,p_event_sequence=>200
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3120_LINK_TARGET_TYPE'
,p_condition_element=>'P3120_LINK_TARGET_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'REDIRECT_APP, REDIRECT_PAGE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2417333434518801)
,p_event_id=>wwv_flow_imp.id(2011944169717950)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2417497793518802)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2418954230518817)
,p_event_id=>wwv_flow_imp.id(2011944169717950)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2417497793518802)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2419158267518819)
,p_name=>'LINK_TARGET_TYPE = REDIRECT_APP'
,p_event_sequence=>210
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3120_LINK_TARGET_TYPE'
,p_condition_element=>'P3120_LINK_TARGET_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'REDIRECT_APP'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2419499155518822)
,p_event_id=>wwv_flow_imp.id(2419158267518819)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_TARGET_APP_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2419584986518823)
,p_event_id=>wwv_flow_imp.id(2419158267518819)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_TARGET_APP_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4424780116889302)
,p_event_id=>wwv_flow_imp.id(2419158267518819)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_TARGET_APP_ID'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_stop_execution_on_error=>'N'
,p_wait_for_result=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2418187240518809)
,p_name=>'LINK_TARGET_TYPE = REDIRECT_URL'
,p_event_sequence=>220
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3120_LINK_TARGET_TYPE'
,p_condition_element=>'P3120_LINK_TARGET_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REDIRECT_URL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2418229828518810)
,p_event_id=>wwv_flow_imp.id(2418187240518809)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2417553805518803)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2419000751518818)
,p_event_id=>wwv_flow_imp.id(2418187240518809)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2417553805518803)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2605981374033249)
,p_name=>'QUERY ITEMS CHANGE'
,p_event_sequence=>230
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'.is-query'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1821218063134521)
,p_event_id=>wwv_flow_imp.id(2605981374033249)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_name=>'RefreshColumns'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'refreshColumns();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2704274773067640)
,p_name=>'Hide Components on load'
,p_event_sequence=>240
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2704394480067641)
,p_event_id=>wwv_flow_imp.id(2704274773067640)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2704165692067639)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8433684724230348)
,p_event_id=>wwv_flow_imp.id(2704274773067640)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_name=>'Set default icon if Icon Class is null'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'$(''#icon_picker'').find(''span'').removeClass(''a-Icon fa '').addClass(''a-Icon icon-open-in-dialog'');'
,p_client_condition_type=>'NULL'
,p_client_condition_element=>'P3120_ICON_CSS_CLASSES'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6701212027775308)
,p_name=>'ORATEXT SOURCE TYPE = TABLE'
,p_event_sequence=>250
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3120_ORATEXT_SOURCE_TYPE'
,p_condition_element=>'P3120_ORATEXT_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TABLE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6701348099775309)
,p_event_id=>wwv_flow_imp.id(6701212027775308)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_ORATEXT_OWNER,P3120_ORATEXT_TABLE,P3120_ORATEXT_WHERE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6701407002775310)
,p_event_id=>wwv_flow_imp.id(6701212027775308)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_ORATEXT_OWNER,P3120_ORATEXT_TABLE,P3120_ORATEXT_WHERE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6701597419775311)
,p_name=>'ORATEXT SOURCE TYPE = SQL'
,p_event_sequence=>260
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3120_ORATEXT_SOURCE_TYPE'
,p_condition_element=>'P3120_ORATEXT_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SQL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6701674976775312)
,p_event_id=>wwv_flow_imp.id(6701597419775311)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_ORATEXT_SQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6701720254775313)
,p_event_id=>wwv_flow_imp.id(6701597419775311)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_ORATEXT_SQL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1820000208134509)
,p_name=>'Show / Hide PK2'
,p_event_sequence=>270
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3120_PK1_COLUMN'
,p_condition_element=>'P3120_PK1_COLUMN'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1820133077134510)
,p_event_id=>wwv_flow_imp.id(1820000208134509)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_PK2_COLUMN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1820276415134511)
,p_event_id=>wwv_flow_imp.id(1820000208134509)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_PK2_COLUMN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1820361053134512)
,p_event_id=>wwv_flow_imp.id(1820000208134509)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_PK2_COLUMN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2686420996958037)
,p_name=>'Enable / Disable Format Mask'
,p_event_sequence=>280
,p_triggering_element_type=>'COLUMN'
,p_triggering_region_id=>wwv_flow_imp.id(2420091833518828)
,p_triggering_element=>'VALUE_TYPE'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'   [ "STATIC", "ITEM" ].includes( $v( "COLUMN_ITEM_FOR_VALUE_TYPE" ) )',
'&& [ "BOOLEAN", "DATE", "NUMBER", "TIMESTAMP", "TIMESTAMP WITH TIME ZONE" ].includes( $v( "COLUMN_ITEM_FOR_DATA_TYPE" ) )'))
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2686523798958038)
,p_event_id=>wwv_flow_imp.id(2686420996958037)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'FORMAT_MASK'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2686643157958039)
,p_event_id=>wwv_flow_imp.id(2686420996958037)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'FORMAT_MASK'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2686774043958040)
,p_event_id=>wwv_flow_imp.id(2686420996958037)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'FORMAT_MASK'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2686891319958041)
,p_name=>'Enable / Disable Expression'
,p_event_sequence=>290
,p_triggering_element_type=>'COLUMN'
,p_triggering_region_id=>wwv_flow_imp.id(2420091833518828)
,p_triggering_element=>'VALUE_TYPE'
,p_condition_element_type=>'COLUMN'
,p_condition_element=>'VALUE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2686913742958042)
,p_event_id=>wwv_flow_imp.id(2686891319958041)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'VALUE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2687060080958043)
,p_event_id=>wwv_flow_imp.id(2686891319958041)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'VALUE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2687113816958044)
,p_event_id=>wwv_flow_imp.id(2686891319958041)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'VALUE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1931793131915008)
,p_name=>'Text Query Function Type = CUSTOM'
,p_event_sequence=>300
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3120_ORATEXT_FUNCTION_TYPE'
,p_condition_element=>'P3120_ORATEXT_FUNCTION_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'CUSTOM'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1931880128915009)
,p_event_id=>wwv_flow_imp.id(1931793131915008)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_ORATEXT_FUNCTION'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1931931068915010)
,p_event_id=>wwv_flow_imp.id(1931793131915008)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_ORATEXT_FUNCTION'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1932136556915012)
,p_event_id=>wwv_flow_imp.id(1931793131915008)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_ORATEXT_FUNCTION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(12270170713687385)
,p_name=>'Hide P3120_REFERENCE_ID'
,p_event_sequence=>300
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P3120_REFERENCE_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(12270599010687384)
,p_event_id=>wwv_flow_imp.id(12270170713687385)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3120_REFERENCE_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(16494471208178005)
,p_name=>'Apply changes'
,p_event_sequence=>310
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1799745296181261)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(16494527658178006)
,p_event_id=>wwv_flow_imp.id(16494471208178005)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'Are you sure you want to subscribe to the selected master search configuration? This will overwrite current search configuration data with selected master search configuration.'
,p_attribute_03=>'warning'
,p_attribute_06=>'Subscribe'
,p_attribute_07=>'Cancel'
,p_client_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_client_condition_expression=>'$v(''P3120_REFERENCE_ID'') !== "" && $v(''P3120_REFERENCE_ID_INIT'') === ""'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(16494617115178007)
,p_event_id=>wwv_flow_imp.id(16494471208178005)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'SAVE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1801305870181274)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(1757925019180889)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Lost Update Detection Only'
,p_attribute_01=>'PLSQL_CODE'
,p_attribute_04=>'null;'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'SAVE, DELETE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>' '
,p_internal_uid=>1801305870181274
,p_process_comment=>'The automatic Form DML process will only perform lost update detection. The reason is that because of the page complexity, important page items are not always submitted. As the form region ignores "non-submitted" page items in generated DML, changes '
||'would not be saved. Thus we use this process only for lost-update detection, and we have specific PL/SQL processes to do the actual DML.'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1823194226134540)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Save Search Configuration Changes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'update wwv_flow_search_configs',
'   set label                     = :P3120_LABEL,',
'       search_prefix             = :P3120_SEARCH_PREFIX,',
'       static_id                 = :P3120_STATIC_ID,',
'       search_type               = :P3120_SEARCH_TYPE,',
'       list_id                   = :P3120_LIST_ID,',
'       location                  = :P3120_LOCATION,',
'       remote_server_id          = :P3120_REMOTE_SERVER_ID,',
'       web_src_module_id         = :P3120_WEB_SRC_MODULE_ID,',
'       external_filter_expr      = :P3120_EXTERNAL_FILTER_EXPR,',
'       web_src_function          = :P3120_WEB_SRC_FUNCTION,',
'       source_post_processing    = :P3120_POST_PROC_TYPE,',
'       query_type                = :P3120_QUERY_TYPE,',
'       query_owner               = :P3120_QUERY_OWNER,',
'       query_table               = :P3120_QUERY_TABLE,',
'       query_where               = :P3120_QUERY_WHERE,',
'       query_columns             = :P3120_PQL_COLUMNS_CLAUSE,',
'       query_match               = :P3120_PQL_MATCH_CLAUSE,',
'       query_source              = :P3120_QUERY_SQL,',
'       function_body_language    = :P3120_QUERY_FUNC_LANG,',
'       optimizer_hint            = :P3120_OPTIMIZER_HINT,',
'       query_order_by            = :P3120_QUERY_ORDER_BY,',
'       oratext_function_type     = :P3120_ORATEXT_FUNCTION_TYPE,',
'       oratext_function          = :P3120_ORATEXT_FUNCTION,',
'       --',
'       searchable_columns        = :P3120_SEARCHABLE_COLUMNS,',
'       --',
'       pk_column_name            = :P3120_PK1_COLUMN,',
'       pk2_column_name           = :P3120_PK2_COLUMN,',
'       title_column_name         = :P3120_TITLE_COLUMN_NAME,',
'       subtitle_column_name      = :P3120_SUBTITLE_COLUMN_NAME,',
'       badge_column_name         = :P3120_BADGE_COLUMN_NAME,',
'       description_column_name   = :P3120_DESCRIPTION_COLUMN_NAME,',
'       oratext_index_column_name = :P3120_ORATEXT_INDEX_COLUMN,',
'       oratext_index_owner       = :P3120_SEARCH_INDEX_OWNER,',
'       oratext_index_name        = coalesce(:P3120_ORATEXT_INDEX_NAME, :P3120_SEARCH_INDEX_NAME),',
'       custom_01_column_name     = :P3120_CUSTOM_01_COLUMN_NAME,',
'       custom_02_column_name     = :P3120_CUSTOM_02_COLUMN_NAME,',
'       custom_03_column_name     = :P3120_CUSTOM_03_COLUMN_NAME,',
'       icon_class_column_name    = :P3120_ICON_CLASS_COLUMN_NAME,',
'       icon_blob_column_name     = :P3120_ICON_BLOB_COLUMN_NAME,',
'       icon_mimetype_column_name = :P3120_MIMETYPE_COLUMN_NAME,',
'       score_column_name         = :P3120_SCORE_COLUMN_NAME,',
'       last_modified_column_name = :P3120_LAST_MOD_COLUMN_NAME,',
'       --',
'       default_row_html_expr     = :P3120_DEFAULT_ROW_HTML_EXPR,',
'       no_results_found_message  = :P3120_NO_RESULTS_FOUND_MESSAGE,',
'       result_css_classes        = :P3120_RESULT_CSS_CLASSES,',
'       return_max_results        = :P3120_RETURN_MAX_RESULTS,',
'       icon_source_type          = :P3120_ICON_SOURCE_TYPE,',
'       icon_image_url            = :P3120_ICON_IMAGE_URL,',
'       icon_css_classes          = :P3120_ICON_CSS_CLASSES,',
'       link_target_type          = :P3120_LINK_TARGET_TYPE,',
'       link_target               = :P3120_LINK_TARGET,',
'       condition_type            = :P3120_CONDITION_TYPE,',
'       condition_expr1           = :P3120_CONDITION_EXPR1,',
'       condition_expr2           = :P3120_CONDITION_EXPR2,',
'       authorization_scheme      = :P3120_AUTHORIZATION_SCHEME,',
'       build_option_id           = :P3120_BUILD_OPTION_ID,',
'       search_comment            = :P3120_SEARCH_COMMENT,',
'       reference_id              = :P3120_REFERENCE_ID',
' where id                = :P3120_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1799745296181261)
,p_process_success_message=>'Search Configuration updated.'
,p_internal_uid=>1823194226134540
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1823261808134541)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Search Configuration'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_search_dev.delete_search_configuration(',
'    p_search_config_id   => :P3120_ID,',
'    p_application_id     => :FB_FLOW_ID);',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1799303955181255)
,p_process_success_message=>'Search Configuration deleted.'
,p_internal_uid=>1823261808134541
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2421229791518840)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(2420091833518828)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set REST Source Parameters - VALUE_LANGUAGE'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    -- Web Source Parameters should always be handled as PL/SQL,',
'    -- in an IG it''s to complicated having a dynamic languages column',
'    if :VALUE_TYPE in ( ''FUNCTION_BODY'', ''EXPRESSION'' ) then',
'        :VALUE_LANGUAGE := ''PLSQL'';',
'    else',
'        :VALUE_LANGUAGE := null;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1799745296181261)
,p_internal_uid=>2421229791518840
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2420979676518837)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(2420091833518828)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'REST Source Parameters - Save Interactive Grid Data'
,p_attribute_01=>'TABLE'
,p_attribute_03=>'WWV_FLOW_WEB_SRC_COMP_PARAMS'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1799745296181261)
,p_internal_uid=>2420979676518837
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4204353432667412)
,p_process_sequence=>90
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Unsubscribe Search Config'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.unsubscribe_component (',
'    p_component_type  => wwv_flow_copy_metadata.c_search_config,',
'    p_component_id    => :P3120_ID,',
'    p_app_id          => :FB_FLOW_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(4204124168667410)
,p_process_when=>'P3120_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_process_success_message=>'Search Configuration unsubscribed.'
,p_internal_uid=>4204353432667412
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(98114843610433336)
,p_process_sequence=>100
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh Search Config'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_search_dev.refresh_search_config (',
'    p_search_config_id => :P3120_ID,',
'    p_initial_refresh  => :P3120_REFERENCE_ID is not null and :P3120_REFERENCE_ID_INIT is null );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST = ''REFRESH_SUB''',
'or (:REQUEST = ''SAVE'' and :P3120_REFERENCE_ID is not null and :P3120_REFERENCE_ID_INIT is null)'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Search Configuration refreshed.'
,p_internal_uid=>98114843610433336
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2419634810518824)
,p_process_sequence=>10
,p_process_point=>'BEFORE_BOX_BODY'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Distribute Item Values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    procedure clear_local_source is',
'    begin',
'        :P3120_QUERY_TYPE            := null;',
'        :P3120_QUERY_OWNER           := null;',
'        :P3120_QUERY_TABLE           := null;',
'        :P3120_QUERY_SQL             := null;',
'        :P3120_QUERY_FUNC_LANG       := null;',
'        :P3120_QUERY_FUNC_BODY       := null;',
'        :P3120_QUERY_WHERE           := null;',
'        :P3120_QUERY_ORDER_BY        := null;',
'        :P3120_OPTIMIZER_HINT        := null;',
'    end clear_local_source;',
'begin',
'    if :P3120_SEARCH_TYPE in ( ''SIMPLE'', ''TEXT_MANUAL'', ''TEXT_DBMS_SEARCH'' ) then',
'    ',
'        if :P3120_SEARCH_TYPE = ''TEXT_MANUAL'' then',
'            :P3120_ORATEXT_SOURCE_TYPE := :P3120_QUERY_TYPE;',
'            :P3120_ORATEXT_OWNER       := :P3120_QUERY_OWNER;',
'            :P3120_ORATEXT_TABLE       := :P3120_QUERY_TABLE;',
'            :P3120_ORATEXT_WHERE       := :P3120_QUERY_WHERE;',
'            :P3120_ORATEXT_ORDER_BY    := :P3120_QUERY_ORDER_BY;',
'            case :P3120_ORATEXT_SOURCE_TYPE',
'                when ''SQL'' then :P3120_ORATEXT_SQL := :P3120_QUERY_SQL;',
'                else null;',
'            end case;',
'',
'            clear_local_source;',
'        elsif :P3120_SEARCH_TYPE = ''TEXT_DBMS_SEARCH'' then',
'            :P3120_SEARCH_SOURCE_OWNER := :P3120_QUERY_OWNER;',
'            :P3120_SEARCH_SOURCE_NAME  := :P3120_QUERY_TABLE;',
'            :P3120_SEARCH_ORDER_BY     := :P3120_QUERY_ORDER_BY;',
'',
'            clear_local_source;      ',
'        else',
'            if :P3120_LOCATION = ''LOCAL'' then',
'                case :P3120_QUERY_TYPE',
'                    when ''FUNC_BODY_RETURNING_SQL'' then :P3120_QUERY_FUNC_BODY  := :P3120_QUERY_SQL;',
'                    when ''GRAPH''                   then :P3120_GRAPH_NAME       := :P3120_QUERY_TABLE;',
'                                                        :P3120_PQL_WHERE_CLAUSE := :P3120_QUERY_WHERE;',
'                                                        :P3120_QUERY_TABLE      := null;',
'                                                        :P3120_QUERY_WHERE      := null;',
'                    else null;',
'                end case;',
'            elsif :P3120_LOCATION = ''REMOTE'' then',
'                :P3120_REMOTE_SOURCE_TYPE      := :P3120_QUERY_TYPE;',
'                :P3120_REMOTE_TABLE_OWNER      := :P3120_QUERY_OWNER;',
'                :P3120_REMOTE_TABLE_NAME       := :P3120_QUERY_TABLE;',
'                :P3120_REMOTE_WHERE            := :P3120_QUERY_WHERE;',
'                :P3120_REMOTE_ORDER_BY         := :P3120_QUERY_ORDER_BY;',
'    ',
'                case :P3120_REMOTE_SOURCE_TYPE',
'                    when ''SQL''                     then :P3120_REMOTE_SQL := :P3120_QUERY_SQL;',
'                    when ''FUNC_BODY_RETURNING_SQL'' then',
'                        :P3120_REMOTE_FUNC_BODY_LANG := :P3120_QUERY_FUNC_LANG;',
'                        :P3120_REMOTE_FUNC_BODY      := :P3120_QUERY_SQL;',
'                    else null;',
'                end case;',
'    ',
'                clear_local_source;',
'                ',
'            elsif :P3120_LOCATION = ''WEB_SOURCE'' then',
'                if :P3120_POST_PROC_TYPE = ''WHERE_ORDER_BY_CLAUSE'' then',
'                    :P3120_POST_PROC_WHERE          := :P3120_QUERY_WHERE;',
'                    :P3120_POST_PROC_ORDER_BY       := :P3120_QUERY_ORDER_BY;',
'                elsif :P3120_POST_PROC_TYPE = ''SQL'' then',
'                    :P3120_POST_PROC_SQL            := :P3120_QUERY_SQL;',
'                elsif :P3120_POST_PROC_TYPE = ''FUNC_BODY_RETURNING_SQL'' then',
'                    :P3120_POST_PROC_FUNC_LANG      := :P3120_QUERY_FUNC_LANG;',
'                    :P3120_POST_PROC_FUNC_BODY      := :P3120_QUERY_SQL;',
'                end if;',
'    ',
'                :P3120_POST_PROC_TYPE := coalesce( :P3120_POST_PROC_TYPE, ''NONE'' );',
'    ',
'                clear_local_source;',
'            end if;',
'        end if;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>2419634810518824
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2704878030067646)
,p_process_sequence=>20
,p_process_point=>'BEFORE_BOX_BODY'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Initialize Search Config Column Collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_search_dev.p3120_get_columns( p_emit_json => false );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>2704878030067646
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2419769433518825)
,p_process_sequence=>30
,p_process_point=>'BEFORE_BOX_BODY'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Split Target URL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_search_dev.split_target_url (',
'    p_target_type      => :P3120_LINK_TARGET_TYPE,',
'    p_target_url       => :P3120_LINK_TARGET,',
'    --',
'    p_app_id           => :P3120_TARGET_APP_ID,',
'    p_page_id          => :P3120_TARGET_PAGE_ID,',
'    p_request          => :P3120_TARGET_REQUEST,',
'    p_clear_cache      => :P3120_TARGET_CLEAR_CACHE,',
'    p_reset_pagination => :P3120_TARGET_CLEAR_PAGE,',
'    p_arg_names        => :P3120_ARG_NAMES,',
'    p_arg_values       => :P3120_ARG_VALUES );',
'',
'if :P3120_LINK_TARGET_TYPE = ''REDIRECT_URL'' then',
'    :P3120_TARGET_URL := :P3120_LINK_TARGET;',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P3120_LINK_TARGET_TYPE'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>2419769433518825
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3206598595836706)
,p_process_sequence=>40
,p_process_point=>'BEFORE_BOX_BODY'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Determine Searchable Columns Required'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if :P3120_SEARCH_TYPE in ( ''APEX_LIST'', ''TEXT_MANUAL'', ''TEXT_DBMS_SEARCH'' ) then',
'        :P3120_SEARCHABLE_COLS_REQUIRED := ''N'';',
'',
'    elsif :P3120_LOCATION in ( wwv_flow_exec_api.c_location_local_db, ',
'                               wwv_flow_exec_api.c_location_remote_db )',
'    then',
'        -- for local and remote SQL, we always display "searchable columns"',
'        :P3120_SEARCHABLE_COLS_REQUIRED := ''Y'';',
'    else',
'        declare',
'            l_is_query_param number := 0;',
'        begin',
'            -- if the REST Source has a parameter "Use For Row Search" defined, then',
'            -- searchable columns are completely determined by the REST API; no need',
'            -- to display the list here.',
'            select 1 ',
'              into l_is_query_param',
'              from wwv_flow_web_src_params',
'             where security_group_id = :FLOW_SECURITY_GROUP_ID',
'               and flow_id           = :FB_FLOW_ID',
'               and web_src_module_id = :P3120_WEB_SRC_MODULE_ID',
'               and is_query_param    = ''Y''',
'               and rownum            = 1;',
'            ',
'            :P3120_SEARCHABLE_COLS_REQUIRED := ''N'';',
'        exception',
'            when no_data_found then',
'                :P3120_SEARCHABLE_COLS_REQUIRED := ''Y'';',
'        end;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>3206598595836706
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1800904222181272)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(1757925019180889)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Search Configuration Details'
,p_internal_uid=>1800904222181272
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1821114161134520)
,p_process_sequence=>10
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'getColumnInfo'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_search_dev.p3120_get_columns( p_emit_json => true );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>1821114161134520
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1821495666134523)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Re-Fetch columns into collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_search_dev.p3120_get_columns( p_emit_json => false );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1799745296181261)
,p_internal_uid=>1821495666134523
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2419821387518826)
,p_process_sequence=>20
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Consolidate Item Values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    procedure clear_web_source is',
'    begin',
'        :P3120_EXTERNAL_FILTER_EXPR := null;',
'        :P3120_WEB_SRC_FUNCTION     := null;',
'        :P3120_POST_PROC_TYPE       := null;',
'        :P3120_WEB_SRC_MODULE_ID    := null;',
'    end clear_web_source;',
'',
'    procedure clear_unused_query_params is',
'    begin',
'        if     :P3120_QUERY_TYPE  = ''TABLE''',
'            or :P3120_SEARCH_TYPE = ''TEXT_DBMS_SEARCH''',
'        then',
'            :P3120_QUERY_SQL          := null;',
'            :P3120_QUERY_FUNC_LANG    := null;',
'            :P3120_OPTIMIZER_HINT     := null;',
'            :P3120_PQL_COLUMNS_CLAUSE := null;',
'            :P3120_PQL_MATCH_CLAUSE   := null;',
'',
'        elsif :P3120_QUERY_TYPE = ''GRAPH'' then',
'            :P3120_QUERY_SQL          := null;',
'            :P3120_QUERY_FUNC_LANG    := null;',
'            :P3120_OPTIMIZER_HINT     := null;',
'        else',
'            :P3120_QUERY_TABLE        := null;',
'            :P3120_QUERY_OWNER        := null;',
'            :P3120_QUERY_WHERE        := null;',
'            :P3120_PQL_COLUMNS_CLAUSE := null;',
'            :P3120_PQL_MATCH_CLAUSE   := null;',
'',
'            if :P3120_QUERY_TYPE = ''SQL'' then :P3120_QUERY_FUNC_LANG := null; end if;',
'        end if;',
'',
'    end clear_unused_query_params;',
'',
'    procedure clear_remote_source is',
'    begin',
'        :P3120_REMOTE_SERVER_ID    := null;',
'    end clear_remote_source;',
'begin',
'    if :P3120_SEARCH_TYPE in ( ''SIMPLE'', ''TEXT_MANUAL'', ''TEXT_DBMS_SEARCH'' ) then',
'',
'        if :P3120_SEARCH_TYPE = ''TEXT_MANUAL'' then',
'             :P3120_LOCATION            := ''LOCAL'';',
'             :P3120_ORATEXT_SOURCE_TYPE := coalesce( :P3120_ORATEXT_SOURCE_TYPE, ''TABLE'' );',
'             :P3120_QUERY_TYPE          := :P3120_ORATEXT_SOURCE_TYPE;',
'             :P3120_QUERY_ORDER_BY      := :P3120_ORATEXT_ORDER_BY;',
'',
'             if :P3120_ORATEXT_SOURCE_TYPE = ''TABLE'' then',
'                 :P3120_QUERY_OWNER    := :P3120_ORATEXT_OWNER;',
'                 :P3120_QUERY_TABLE    := :P3120_ORATEXT_TABLE;',
'                 :P3120_QUERY_WHERE    := :P3120_ORATEXT_WHERE;',
'             elsif :P3120_ORATEXT_SOURCE_TYPE = ''SQL'' then',
'                  :P3120_QUERY_SQL     := :P3120_ORATEXT_SQL;',
'             end if;',
'',
'             clear_unused_query_params;',
'             clear_remote_source;',
'             clear_web_source;',
'        elsif :P3120_SEARCH_TYPE = ''TEXT_DBMS_SEARCH'' then',
'             :P3120_LOCATION            := ''LOCAL'';',
'             :P3120_QUERY_TYPE          := null;',
'             :P3120_QUERY_OWNER         := :P3120_SEARCH_SOURCE_OWNER;',
'             :P3120_QUERY_TABLE         := :P3120_SEARCH_SOURCE_NAME;',
'             :P3120_QUERY_ORDER_BY      := :P3120_SEARCH_ORDER_BY;',
'',
'             clear_unused_query_params;',
'             clear_remote_source;',
'             clear_web_source;    ',
'        else',
'            if :P3120_LOCATION = ''LOCAL'' then',
'    ',
'                :P3120_QUERY_TYPE      := coalesce( :P3120_QUERY_TYPE, ''TABLE'' );',
'                :P3120_QUERY_SQL       := case :P3120_QUERY_TYPE',
'                                              when ''SQL''                     then :P3120_QUERY_SQL',
'                                              when ''FUNC_BODY_RETURNING_SQL'' then :P3120_QUERY_FUNC_BODY end;',
'                :P3120_QUERY_FUNC_LANG := case when :P3120_QUERY_TYPE = ''FUNC_BODY_RETURNING_SQL'' then :P3120_QUERY_FUNC_LANG end;',
'',
'                if :P3120_QUERY_TYPE = ''GRAPH'' then',
'                    :P3120_QUERY_TABLE     := :P3120_GRAPH_NAME;',
'                    :P3120_QUERY_WHERE     := :P3120_PQL_WHERE_CLAUSE;',
'                end if;',
'',
'                clear_unused_query_params;',
'                clear_remote_source;',
'                clear_web_source;',
'',
'            elsif :P3120_LOCATION = ''REMOTE'' then',
'    ',
'                :P3120_REMOTE_SOURCE_TYPE := coalesce( :P3120_REMOTE_SOURCE_TYPE, ''TABLE'' );',
'                --',
'                :P3120_QUERY_TYPE          := :P3120_REMOTE_SOURCE_TYPE;',
'                :P3120_QUERY_ORDER_BY      := :P3120_REMOTE_ORDER_BY;',
'                ',
'                if :P3120_REMOTE_SOURCE_TYPE = ''TABLE'' then',
'                    :P3120_QUERY_OWNER     := :P3120_REMOTE_TABLE_OWNER;',
'                    :P3120_QUERY_TABLE     := :P3120_REMOTE_TABLE_NAME;',
'                    :P3120_QUERY_WHERE     := :P3120_REMOTE_WHERE;',
'                else',
'                    :P3120_QUERY_SQL       := case :P3120_REMOTE_SOURCE_TYPE',
'                                                  when ''SQL''                     then :P3120_REMOTE_SQL',
'                                                  when ''FUNC_BODY_RETURNING_SQL'' then :P3120_REMOTE_FUNC_BODY end;',
'                    :P3120_QUERY_FUNC_LANG := case when :P3120_REMOTE_SOURCE_TYPE = ''FUNC_BODY_RETURNING_SQL'' then :P3120_REMOTE_FUNC_BODY_LANG end;',
'                end if;',
'',
'                clear_unused_query_params;',
'                clear_web_source;',
'            elsif :P3120_LOCATION = ''WEB_SOURCE'' then',
'    ',
'                if :P3120_OLD_WEB_SRC_MODULE_ID = :P3120_WEB_SRC_MODULE_ID then',
'                    if :P3120_POST_PROC_TYPE = ''WHERE_ORDER_BY_CLAUSE'' then',
'                        :P3120_QUERY_WHERE     := :P3120_POST_PROC_WHERE;',
'                        :P3120_QUERY_ORDER_BY  := :P3120_POST_PROC_ORDER_BY;',
'                        :P3120_QUERY_FUNC_LANG := null;',
'                    elsif :P3120_POST_PROC_TYPE = ''SQL'' then',
'                        :P3120_QUERY_SQL       := :P3120_POST_PROC_SQL;',
'                        :P3120_QUERY_FUNC_LANG := null;',
'                    elsif :P3120_POST_PROC_TYPE = ''FUNC_BODY_RETURNING_SQL'' then',
'                        :P3120_QUERY_SQL       := :P3120_POST_PROC_FUNC_BODY;',
'                        :P3120_QUERY_FUNC_LANG := :P3120_POST_PROC_FUNC_LANG;',
'                    end if;',
'                else',
'                     :P3120_POST_PROC_TYPE  := null;',
'                     :P3120_QUERY_FUNC_LANG := null;',
'                end if;',
'                ',
'                :P3120_POST_PROC_TYPE := nullif ( :P3120_POST_PROC_TYPE, ''NONE'' );',
'                clear_remote_source;',
'               ',
'            end if;',
'        end if;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1799745296181261)
,p_internal_uid=>2419821387518826
);
end;
/
prompt --application/pages/page_03121
begin
wwv_flow_imp_page.create_page(
 p_id=>3121
,p_name=>'Search Configuration Utilization'
,p_alias=>'SEARCH-CONFIGURATION-UTILIZATION'
,p_step_title=>'Search Configuration Utilization'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(1449603451873552)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9404401788349602)
,p_plug_name=>'Search Configuration Utilization'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select s.id,',
'       s.label search_config_label,',
'       r.plug_name,',
'       wwv_flow_utilities.prepare_url(''f?p=4000:4500:''||:flow_session||''::::FB_FLOW_PAGE_ID:''||p.id) page_target,',
'       p.id page_id,',
'       p.name page_name',
'  from wwv_flow_steps p,',
'       wwv_flow_page_plugs r,',
'       wwv_flow_search_region_sources sr,',
'       wwv_flow_search_configs s',
' where p.flow_id           = r.flow_id',
'   and r.flow_id           = sr.flow_id',
'   and sr.flow_id          = s.flow_id',
'   and p.id                = r.page_id',
'   and p.id                = sr.page_id',
'   and r.id                = sr.search_region_id',
'   and sr.search_config_id = s.id',
'   and p.flow_id           = :fb_flow_id',
'   and p.security_group_id = :flow_security_group_id',
'   and r.plug_source_type  = ''NATIVE_SEARCH_REGION'''))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Search Configuration Utilization'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(9404505455349603)
,p_no_data_found_message=>'No Search Configurations are used within this application.'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'CBCHO'
,p_internal_uid=>9404505455349603
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(7303855084002716)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(7305028789002720)
,p_db_column_name=>'PAGE_TARGET'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>'Page Target'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(7305487238002720)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(7305879523002721)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>70
,p_column_identifier=>'G'
,p_column_label=>'Page Name'
,p_column_link=>'#PAGE_TARGET#'
,p_column_linktext=>'#PAGE_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(7135570875811520)
,p_db_column_name=>'SEARCH_CONFIG_LABEL'
,p_display_order=>80
,p_column_identifier=>'H'
,p_column_label=>'Label'
,p_column_link=>'f?p=&APP_ID.:3120:&SESSION.::&DEBUG.:3120:P3120_ID:#ID#'
,p_column_linktext=>'#SEARCH_CONFIG_LABEL#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(7135636633811521)
,p_db_column_name=>'PLUG_NAME'
,p_display_order=>90
,p_column_identifier=>'I'
,p_column_label=>'Region'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(10208692394027142)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'29055'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'SEARCH_CONFIG_LABEL:PAGE_ID:PAGE_NAME:PLUG_NAME:'
,p_sort_column_1=>'SEARCH_CONFIG_LABEL'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9405276717349611)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>'<p>This page displays where <strong>Search Configurations</strong> are being used within the application.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(25342110236193760)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(1693027045185449)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Search Configurations'
);
end;
/
prompt --application/pages/page_03122
begin
wwv_flow_imp_page.create_page(
 p_id=>3122
,p_name=>'Search Configuration History'
,p_alias=>'SEARCH-CONFIGURATION-HISTORY'
,p_step_title=>'Search Configuration History'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22486710371682516)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(1693027045185449)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Search Configurations'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(445286922095412168)
,p_plug_name=>'Search Configuration History'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  l.a object_type,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u,',
'  (select wwv_flow_lang.system_message(''DATA.LOAD.DEFINITION'') a from dual) l',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_SEARCH_CONFIGS'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(445287113820412175)
,p_name=>'History'
,p_no_data_found_message=>'No Search Configuration change history available.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>445287113820412175
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(7331395701221752)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(7331782292221752)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Audit Comment'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(7332165042221752)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Component Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(7332562170221753)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(7332936951221753)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Component Key'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'LEFT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(7333390538221754)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Audit Date'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(7333789685221755)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(7334101299221755)
,p_db_column_name=>'OBJECT_TYPE'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Object Type'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(445288024480412181)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1294307143536645'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'AUDIT_DATE:ACTION:DEVELOPER:OBJECT_TYPE:COMPONENT_NAME'
,p_sort_column_1=>'AUDIT_DATE'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(445505613746457043)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>This page displays recent modifications made to Search Configurations in this application.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
end;
/
prompt --application/pages/page_03890
begin
wwv_flow_imp_page.create_page(
 p_id=>3890
,p_name=>'LDAP Test'
,p_alias=>'LDAP-TEST'
,p_page_mode=>'MODAL'
,p_step_title=>'LDAP Test'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213425326892450628)
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(function() {',
'    if ($v("P3890_FIRST_VIEW") === "YES") {',
'        var l_values = parent.LDAPTestGetValues();',
'        $s("P3890_LDAP_HOST"        , l_values.host);',
'        $s("P3890_PORT"             , l_values.port);',
'        $s("P3890_USE_SSL"          , l_values.use_ssl);',
'        $s("P3890_DN"               , l_values.dn_string);',
'        $s("P3890_USE_EXACT_DN"     , l_values.use_dn);',
'        $s("P3890_SEARCH_FILTER"    , l_values.search_filter);',
'        $s("P3890_USERNAME_EDIT"    , l_values.edit_function);',
'        $s("P3890_USERNAME_ESCAPING", l_values.username_escaping);',
'        $s("P3890_FIRST_VIEW"       , "NO");',
'    }',
'})();',
''))
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'700'
,p_dialog_width=>'800'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_auth_preconfig.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(49595132114659790)
,p_plug_name=>'Parameters'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--simple'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(49600904419727514)
,p_plug_name=>'Credentials for Test Login'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--simple'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(716353189532823638)
,p_plug_name=>'Wizard Button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(49753202827162326)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(716353189532823638)
,p_button_name=>'FINISH'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(29441316397731287)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(716353189532823638)
,p_button_name=>'TEST_LOGIN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Test Login'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(29418308402099980)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(716353189532823638)
,p_button_name=>'CLOSE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Close'
,p_button_position=>'PREVIOUS'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(49605110137767049)
,p_branch_action=>'f?p=&APP_ID.:3890:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(29410110851944068)
,p_name=>'P3890_USERNAME_ESCAPING'
,p_is_required=>true
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(49595132114659790)
,p_prompt=>'Username Escaping'
,p_source=>'STD'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LDAP_USERNAME_ESCAPING'
,p_lov=>'.'||wwv_flow_imp.id(39475531325852002)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(49596318739665432)
,p_name=>'P3890_LDAP_HOST'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(49595132114659790)
,p_prompt=>'LDAP Host'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter your LDAP server name here.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(49597025665667372)
,p_name=>'P3890_PORT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(49595132114659790)
,p_item_default=>'389'
,p_prompt=>'Port'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>5
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the port number for your LDAP server.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(49599919525722432)
,p_name=>'P3890_DN'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(49595132114659790)
,p_item_default=>'cn=%LDAP_USER%,dc=oracle,dc=com'
,p_prompt=>'Distinguished Name (DN) String'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the DN String for your LDAP server.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(49600529914725426)
,p_name=>'P3890_USERNAME_EDIT'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(49595132114659790)
,p_prompt=>'LDAP Username Edit Function'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the username edit function for your LDAP server, if needed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PLSQL_FUNCTION_BODY'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(49601509613729053)
,p_name=>'P3890_USERNAME'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(49600904419727514)
,p_prompt=>'Username'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the username for your LDAP server, if needed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(49602321041732311)
,p_name=>'P3890_PASSWORD'
,p_is_required=>true
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(49600904419727514)
,p_prompt=>'Password'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter the password for your LDAP server, if needed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(240743322394973385)
,p_name=>'P3890_FIRST_VIEW'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(49595132114659790)
,p_item_default=>'YES'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(487363722302444828)
,p_name=>'P3890_USE_SSL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(49595132114659790)
,p_prompt=>'Use SSL:'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LDAP_SSL_PLUGIN_LOV'
,p_lov=>'.'||wwv_flow_imp.id(29453800248365382)||'.'
,p_cSize=>64
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose whether to use SSL to bind to the LDAP directory. If SSL with Authentication is chosen, a wallet must be configured for the &PRODUCT_NAME. instance.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(493020915082662128)
,p_name=>'P3890_USE_EXACT_DN'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(49595132114659790)
,p_item_default=>'Y'
,p_prompt=>'Use Exact Distinguished Name (DN)'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Choose whether the LDAP Distinguished Name (DN) String is exact or non-exact. If non-exact, LDAP Distinguished Name (DN) is the search base and you must supply a Search Filter.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(493021432398667143)
,p_name=>'P3890_SEARCH_FILTER'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(49595132114659790)
,p_prompt=>'Search Filter'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST.LDAP.SEARCH_FILTER'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct',
'       attribute_06 d,',
'       attribute_06 r',
'  from wwv_flow_authentications',
' where scheme_type  = ''NATIVE_LDAP''',
'   and attribute_06 is not null',
'   and security_group_id = :WORKSPACE_ID',
' order by 1'))
,p_cSize=>80
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the search filter when not using an exact distinguished name (DN). Use <strong>%LDAP_USER%</strong> as a place-holder for the username. For example:',
'<br /><br />cn=%LDAP_USER%'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(240737320878963405)
,p_validation_name=>'DN must have LDAP_USER'
,p_validation_sequence=>10
,p_validation=>'instr(:P3890_DN,''%LDAP_USER%'') > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'DN string must contain %LDAP_USER%'
,p_validation_condition=>'P3890_USE_EXACT_DN'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(29441316397731287)
,p_associated_item=>wwv_flow_imp.id(49599919525722432)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(493114508342473898)
,p_validation_name=>'DN must have LDAP_USER'
,p_validation_sequence=>30
,p_validation=>'instr(:P3890_SEARCH_FILTER,''%LDAP_USER%'') > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Search Filter must contain %LDAP_USER%'
,p_validation_condition=>'P3890_USE_EXACT_DN'
,p_validation_condition2=>'N'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(49599919525722432)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(493030726828788558)
,p_name=>'Show/hide Search Filter'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P3890_USE_EXACT_DN'
,p_condition_element=>'P3890_USE_EXACT_DN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'N'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(493031021135788560)
,p_event_id=>wwv_flow_imp.id(493030726828788558)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3890_SEARCH_FILTER'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(493031219124788560)
,p_event_id=>wwv_flow_imp.id(493030726828788558)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P3890_SEARCH_FILTER'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(485481857460873367)
,p_name=>'Pass back'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(49753202827162326)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(485482191743873367)
,p_event_id=>wwv_flow_imp.id(485481857460873367)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    parent.LDAPTestSetValues ({',
'        host:              $v("P3890_LDAP_HOST"),',
'        port:              $v("P3890_PORT"),',
'        use_ssl:           $v("P3890_USE_SSL"),',
'        dn_string:         $v("P3890_DN"),',
'        use_dn:            $v("P3890_USE_EXACT_DN"),',
'        search_filter:     $v("P3890_SEARCH_FILTER"),',
'        edit_function:     $v("P3890_USERNAME_EDIT"),',
'        username_escaping: $v("P3890_USERNAME_ESCAPING") });'))
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(485482397239876351)
,p_event_id=>wwv_flow_imp.id(485481857460873367)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(485482792483898255)
,p_name=>'close dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(29418308402099980)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(485483028069898255)
,p_event_id=>wwv_flow_imp.id(485482792483898255)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(49609818112844982)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Test Login'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_authentication_dev.test_ldap_authentication(    ',
'    p_username            => :P3890_USERNAME,',
'    p_password            => :P3890_PASSWORD,',
'    p_ldap_host           => :P3890_LDAP_HOST,',
'    p_ldap_port           => :P3890_PORT,',
'    p_use_ssl             => :P3890_USE_SSL,',
'    p_use_exact_dn        => :P3890_USE_EXACT_DN,',
'    p_ldap_string         => :P3890_DN,',
'    p_search_filter       => :P3890_SEARCH_FILTER,',
'    p_ldap_edit_function  => :P3890_USERNAME_EDIT,',
'    p_username_escaping   => :P3890_USERNAME_ESCAPING,',
'    p_application_id      => nv(''FB_FLOW_ID'') );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Authentication failed',
'<p>',
'#SQLERRM_TEXT#',
'</p>'))
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(29441316397731287)
,p_process_success_message=>'Authenticated'
,p_internal_uid=>49609818112844982
);
end;
/
prompt --application/pages/page_04001
begin
wwv_flow_imp_page.create_page(
 p_id=>4001
,p_name=>'Edit Application Definition'
,p_alias=>'EDIT-APPLICATION-DEFINITION'
,p_step_title=>'Edit Application Definition'
,p_allow_duplicate_submissions=>'N'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213220627333807318)
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(74845831538733642)
,p_help_text=>'bldr_attr_standard.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(283953577)
,p_plug_name=>'Application &FB_FLOW_ID.'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>140
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_landmark_label=>'Application Attribute Actions '
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46250108023678996)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>145
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(79233015681259820)
,p_plug_name=>'Landmark for Displayed Regions '
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_landmark_type=>'region'
,p_landmark_label=>'Displayed Regions'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(284956612)
,p_plug_name=>'Name'
,p_parent_plug_id=>wwv_flow_imp.id(79233015681259820)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(407106391)
,p_name=>'Build Options'
,p_parent_plug_id=>wwv_flow_imp.id(79233015681259820)
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select patch_name,',
'       patch_status,',
'       decode(patch_status,',
'           ''INCLUDE'',''green'',',
'           ''red'') patch_status_color,',
'       patch_comment',
'from #OWNER#.wwv_flow_patches ',
'where flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'order by 2, 1'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>150
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No build options defined.'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48903831646773009)
,p_query_column_id=>1
,p_column_alias=>'PATCH_NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Build Option'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48903906487773009)
,p_query_column_id=>2
,p_column_alias=>'PATCH_STATUS'
,p_column_display_sequence=>2
,p_column_heading=>'Status'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<b style="color:#PATCH_STATUS_COLOR#">#PATCH_STATUS#</b>'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1215661819905752193)
,p_query_column_id=>3
,p_column_alias=>'PATCH_STATUS_COLOR'
,p_column_display_sequence=>3
,p_column_heading=>'Patch Status Color'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48904009439773009)
,p_query_column_id=>4
,p_column_alias=>'PATCH_COMMENT'
,p_column_display_sequence=>4
,p_column_heading=>'Comment'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(85248570290)
,p_plug_name=>'Substitutions'
,p_parent_plug_id=>wwv_flow_imp.id(79233015681259820)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Form--leftLabels:a-Form--autoWidthLabels'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'Use static substitution strings for phrases or labels that occur in many places within an application. To create a substitution string, enter the string name in the Substitution String column and the string value in the Substitution Value column.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1421934290786015)
,p_plug_name=>'Report Printing'
,p_parent_plug_id=>wwv_flow_imp.id(79233015681259820)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2200978967294804)
,p_plug_name=>'Workflow Settings'
,p_parent_plug_id=>wwv_flow_imp.id(79233015681259820)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2430011519300734)
,p_plug_name=>'Copyright Banner'
,p_parent_plug_id=>wwv_flow_imp.id(79233015681259820)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>130
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6257403627000045)
,p_plug_name=>'Error Handling'
,p_parent_plug_id=>wwv_flow_imp.id(79233015681259820)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8401814586370317)
,p_plug_name=>'Application File Storage'
,p_parent_plug_id=>wwv_flow_imp.id(79233015681259820)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>120
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(74090417789091344)
,p_plug_name=>' Availability'
,p_parent_plug_id=>wwv_flow_imp.id(79233015681259820)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(84785704645417330)
,p_plug_name=>'Global Notification'
,p_parent_plug_id=>wwv_flow_imp.id(79233015681259820)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(198116031744061165)
,p_plug_name=>'Properties'
,p_parent_plug_id=>wwv_flow_imp.id(79233015681259820)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(92874711660553332)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>150
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(92837202675352059)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(274899318766622408)
,p_plug_name=>'Application Attributes'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>130
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(274897624522614662)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_landmark_type=>'navigation'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(615321908441503858)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_imp.id(29434107863295859)
,p_plug_display_sequence=>140
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from  WWV_FLOWS',
'where id = :FB_FLOW_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :FB_FLOW_ID,',
'      p_component_type => ''List Entry'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(631549507496287263)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Edit the general application definition.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1378289375072029933)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1421934290786015)
,p_button_name=>'ADD_REMOTE_PRINT_SERVER'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Add Remote Print Server'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:1935:&SESSION.::&DEBUG.:CR,1935::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8401956728370318)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(8401814586370317)
,p_button_name=>'ADD_REMOTE_FILE_STORAGE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Add Object Storage'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:1850:&SESSION.::&DEBUG.:CR,1850::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(40006876470919)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(283953577)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:RP,1::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(40006877470919)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(283953577)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:2110:&SESSION.::&DEBUG.:2110::'
,p_button_condition=>'FB_FLOW_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(40006878470920)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(283953577)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'FB_FLOW_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(107950530564729123)
,p_branch_action=>'f?p=&APP_ID.:1500:&SESSION.::&DEBUG.::FB_FLOW_ID:&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(40006878470920)
,p_branch_sequence=>10
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>'select 1 from wwv_flows where security_group_id = :flow_security_group_id and id = :fb_flow_id and build_status = ''RUN_ONLY'''
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(40006881470920)
,p_branch_action=>'1'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow.g_request in (''Create'',''Delete'')'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(17572204941560191)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(40006878470920)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(480962819964282124)
,p_branch_action=>'f?p=&APP_ID.:509:&SESSION.::&DEBUG.:509:FB_FLOW_ID,509_FB_UPD_ID:&FB_FLOW_ID.,&FB_FLOW_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_SEC'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(480963812953299018)
,p_branch_action=>'f?p=&APP_ID.:506:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_GLOBAL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(42449828569597528)
,p_branch_action=>'f?p=&APP_ID.:197:&SESSION.::&DEBUG.:197:FB_FLOW_ID:&FB_FLOW_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_USERINTERFACE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(6207913897993243)
,p_branch_name=>'Go To Page 507'
,p_branch_action=>'f?p=&APP_ID.:507:&SESSION.::&DEBUG.:507:FB_FLOW_ID:&FB_FLOW_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>70
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_PWA'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1616009621727101)
,p_branch_name=>'Go To Page 523'
,p_branch_action=>'f?p=&APP_ID.:523:&SESSION.::&DEBUG.:523:FB_FLOW_ID:&FB_FLOW_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>80
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_AI'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(40006882470921)
,p_branch_name=>'Go To Page 9'
,p_branch_action=>'9'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>90
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(480965127460350446)
,p_branch_action=>'f?p=&APP_ID.:4001:&SESSION.::&DEBUG.:4001:FB_FLOW_ID:&FB_FLOW_ID.'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>80
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_DEFN'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(388967724)
,p_name=>'F4000_P4001_FLOW_VERSION'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(284956612)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Version'
,p_source=>'FLOW_VERSION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_working_copy_dev.is_working_copy (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_security_group_id => :WORKSPACE_ID )'))
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Includes the application''s version number on a page. You can also automatically tie the version to the date of last modification using the following format masks:<p>',
'<ul>',
'<li>YYYY.MM.DD</li>',
'<li>MM.DD.YYYY</li>',
'<li>DD.MM.YYYY</li>  ',
'</ul>',
'<p>If your application version uses the format "YYYY.MM.DD", then &PRODUCT_NAME. replaces this format mask with the date of last modification of any application attribute.'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3893122313)
,p_name=>'F4000_P4001_BUILD_STATUS'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(74090417789091344)
,p_use_cache_before_default=>'NO'
,p_item_default=>'RUN_AND_BUILD'
,p_prompt=>'Build&nbsp;Status'
,p_source=>'BUILD_STATUS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'BUILD_STATUS'
,p_lov=>'.'||wwv_flow_imp.id(84305510710571518)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Identifies the build status of the current application. Options include:<br>',
'<ul><li><strong>Run Application Only</strong> - Users can only run the application. This option is intended for applications in a production instance.</li>',
'<li><strong>Run and Build Application</strong> - Developers and users can both run and develop the application.</li>',
'</ul>'))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(53943804854)
,p_name=>'F4000_P4001_PROXY_SERVER'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(198116031744061165)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Proxy Server'
,p_source=>'PROXY_SERVER'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use this field to specify a proxy server to be used by the application.</p>',
'<p>Using a proxy server may be required for REST requests done by the application, for instance when REST Data Sources or the <code>APEX_WEB_SERVICE</code> ',
'package is used.</p>',
'<p>You can reference values entered into this field from PL/SQL using the PL/SQL package variable <code>APEX_APPLICATION.G_PROXY_SERVER</code>. ',
'If no port is specified, &PRODUCT_NAME. assumes port <strong>80</strong>.</p>',
'<p>The <em>Instance Proxy</em>, which is configured in Instance Administration, always takes precedence over an application proxy server. ',
'Thus this attribute has no effect if an instance proxy is configured.</p>',
'<p>For example:</p>',
'<ul>',
'    <li><code>http://www-proxy.example.com</code></li>',
'    <li><code>http://www-proxy.example.com:8080</code></li>',
'</ul>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(85250579435)
,p_name=>'SUBSTITUTION_STRING_01'
,p_item_sequence=>310
,p_item_plug_id=>wwv_flow_imp.id(85248570290)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Substitution String 1'
,p_source=>'SUBSTITUTION_STRING_01'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(85252581887)
,p_name=>'SUBSTITUTION_VALUE_01'
,p_item_sequence=>320
,p_item_plug_id=>wwv_flow_imp.id(85248570290)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Substitution Value 1'
,p_source=>'SUBSTITUTION_VALUE_01'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(85255597012)
,p_name=>'F4000_P4001_STRING_TITLE'
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_imp.id(85248570290)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Substitution String'
,p_source=>'''<span class="instructiontext">''||wwv_flow_lang.system_message(''F4000.P4001.SUBSTITUTION_STR'')||''</span>'''
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_help_text=>'Identify substitution string name.'
,p_attribute_01=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(85257601365)
,p_name=>'F4000_P4001_VALUE_TITLE'
,p_item_sequence=>300
,p_item_plug_id=>wwv_flow_imp.id(85248570290)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Substitution Value'
,p_source=>'''<span class="instructiontext">''||wwv_flow_lang.system_message(''F4000.P4001.SUBSTITUTION_VALUE'')||''</span>'''
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#'
,p_protection_level=>'I'
,p_help_text=>'Identify substitution value.'
,p_attribute_01=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(85264616083)
,p_name=>'SUBSTITUTION_STRING_02'
,p_item_sequence=>330
,p_item_plug_id=>wwv_flow_imp.id(85248570290)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Substitution String 2'
,p_source=>'SUBSTITUTION_STRING_02'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(85266616894)
,p_name=>'SUBSTITUTION_STRING_03'
,p_item_sequence=>350
,p_item_plug_id=>wwv_flow_imp.id(85248570290)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Substitution String 3'
,p_source=>'SUBSTITUTION_STRING_03'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(85268617706)
,p_name=>'SUBSTITUTION_STRING_04'
,p_item_sequence=>370
,p_item_plug_id=>wwv_flow_imp.id(85248570290)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Substitution String 4'
,p_source=>'SUBSTITUTION_STRING_04'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(85270618600)
,p_name=>'SUBSTITUTION_STRING_05'
,p_item_sequence=>390
,p_item_plug_id=>wwv_flow_imp.id(85248570290)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Substitution String 5'
,p_source=>'SUBSTITUTION_STRING_05'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(85272619586)
,p_name=>'SUBSTITUTION_STRING_06'
,p_item_sequence=>410
,p_item_plug_id=>wwv_flow_imp.id(85248570290)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Substitution String 6'
,p_source=>'SUBSTITUTION_STRING_06'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(85274620362)
,p_name=>'SUBSTITUTION_STRING_07'
,p_item_sequence=>430
,p_item_plug_id=>wwv_flow_imp.id(85248570290)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Substitution String 7'
,p_source=>'SUBSTITUTION_STRING_07'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(85276621095)
,p_name=>'SUBSTITUTION_STRING_08'
,p_item_sequence=>450
,p_item_plug_id=>wwv_flow_imp.id(85248570290)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Substitution String 8'
,p_source=>'SUBSTITUTION_STRING_08'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(85278624279)
,p_name=>'SUBSTITUTION_VALUE_02'
,p_item_sequence=>340
,p_item_plug_id=>wwv_flow_imp.id(85248570290)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Substitution Value 2'
,p_source=>'SUBSTITUTION_VALUE_02'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(85282625282)
,p_name=>'SUBSTITUTION_VALUE_03'
,p_item_sequence=>360
,p_item_plug_id=>wwv_flow_imp.id(85248570290)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Substitution Value 3'
,p_source=>'SUBSTITUTION_VALUE_03'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(85284626749)
,p_name=>'SUBSTITUTION_VALUE_04'
,p_item_sequence=>380
,p_item_plug_id=>wwv_flow_imp.id(85248570290)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Substitution Value 4'
,p_source=>'SUBSTITUTION_VALUE_04'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(85289634304)
,p_name=>'SUBSTITUTION_VALUE_05'
,p_item_sequence=>400
,p_item_plug_id=>wwv_flow_imp.id(85248570290)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Substitution Value 5'
,p_source=>'SUBSTITUTION_VALUE_05'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(85291636066)
,p_name=>'SUBSTITUTION_VALUE_06'
,p_item_sequence=>420
,p_item_plug_id=>wwv_flow_imp.id(85248570290)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Substitution Value 6'
,p_source=>'SUBSTITUTION_VALUE_06'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(85293636755)
,p_name=>'SUBSTITUTION_VALUE_07'
,p_item_sequence=>440
,p_item_plug_id=>wwv_flow_imp.id(85248570290)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Substitution Value 7'
,p_source=>'SUBSTITUTION_VALUE_07'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(85295637498)
,p_name=>'SUBSTITUTION_VALUE_08'
,p_item_sequence=>460
,p_item_plug_id=>wwv_flow_imp.id(85248570290)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Substitution Value 8'
,p_source=>'SUBSTITUTION_VALUE_08'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(146826158978)
,p_name=>'F4000_P4001_FLOW_STATUS'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(74090417789091344)
,p_use_cache_before_default=>'NO'
,p_item_default=>'AVAILABLE'
,p_prompt=>'Status'
,p_source=>'FLOW_STATUS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_FLOW_STATUS'
,p_lov=>'.'||wwv_flow_imp.id(634347472712995)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specifies whether or not the application is available or unavailable for use. <p>',
'Options include:<br>',
'<ul>',
'<li><strong>Available</strong> - Application is available with no restrictions.</li>',
'<li><strong>Available with Developer Toolbar</strong> - Application is available for use. For developers, the Developer Toolbar is included on each page. Requires the developer to be logged in to the App Builder in the same browser session.</li>',
'<li><strong>Available to Developers Only</strong> - Application is available to users having developer privileges.</li>',
'<li><strong>Restricted Access</strong> - Application is available to developers named in Restrict to comma separated user list.</li>',
'<li><strong>Unavailable</strong> - Application cannot be run or edited. The message in Message for unavailable application displays when users attempt to access the application.</li>',
'<li><strong>Unavailable (Status Shown with PL/SQL)</strong> - Application cannot be run or edited.</li>',
'<li><strong>Unavailable (Redirect to URL)</strong> - Application cannot be run. The user is linked to the URL entered in Message for unavailable application.</li>',
'</ul>'))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(146840201714)
,p_name=>'F4000_P4001_FLOW_UNAVAILABLE_TEXT'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(74090417789091344)
,p_use_cache_before_default=>'NO'
,p_item_default=>'return wwv_flow_lang.system_message(''F4000_P4001_UNAVAIL'');'
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Message for unavailable application'
,p_source=>'FLOW_UNAVAILABLE_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Use this attribute in conjunction with Status.<p/>',
'If you set Status to <strong>Unavailable</strong>, <strong>Unavailable (Status Shown with PL/SQL)</strong>, or <strong>Unavailable (Redirect to URL)</strong>, the text you enter in this attribute displays.<p/>',
'If you set Status to <strong>Available</strong>, the text you enter in this attribute does not display. '))
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(147579121481)
,p_name=>'F4000_P4001_RESTRICT_TO_USER_LIST'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_imp.id(74090417789091344)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Restrict to comma separated user list (status must equal Restricted Access)'
,p_source=>'RESTRICT_TO_USER_LIST'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>2
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Use this attribute in conjunction with the Status <strong>Restricted Access</strong>. If you set Status to <strong>Restricted Access</strong>, only the users listed in this attribute can run the application.<p/> To use this attribute:',
'<ol>',
'<li>From the Status list, select <strong>Restricted Access</strong>.</li>',
'<li>Enter a comma-delimited list of users who can run the application in the field provided.</li>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40006870470918)
,p_name=>'FB_UPD_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(284956612)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Numeric identification number (ID) which identifies the application. Each application is uniquely identified by an ID.'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40006871470918)
,p_name=>'FB_UPD_NAME'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(284956612)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_working_copy_dev.is_working_copy (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_security_group_id => :WORKSPACE_ID )'))
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Provides a short descriptive name for the application to distinguish it from other applications in your development environment.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40006873470919)
,p_name=>'FB_UPD_LOGGING'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(198116031744061165)
,p_use_cache_before_default=>'NO'
,p_item_default=>'YES'
,p_prompt=>'Logging'
,p_source=>'WEBDB_LOGGING'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_read_only_when=>'nvl(wwv_flow_platform.get_preference(''APPLICATION_ACTIVITY_LOGGING''), ''U'') in (''A'' /* Always */, ''N'' /* Never */)'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Determines whether or not user activity is recorded in the activity log. When set to',
'<strong>On</strong>, every page view is logged, enabling an administrator to monitor user',
'activity for each application.<p/>',
'<p>Disabling logging may be advisable for high volume applications.</p>',
'<p>This attribute can only be modified if the feature configuration "Application Activity Logging"',
'is set to "Use Application Settings" in &PRODUCT_NAME. Administration Services.</p>'))
,p_attribute_01=>'N'
,p_attribute_02=>'YES'
,p_attribute_04=>'NO'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1378952136513217)
,p_name=>'P4001_ORACLE_TEXT_FUNCTION'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(198116031744061165)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Custom Function Name'
,p_source=>'ORACLE_TEXT_FUNCTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>500
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Specify the name of a custom PL/SQL function which converts end user input to an Oracle Text query. ',
'    The function takes the end user input as VARCHAR2 and returns the Oracle Text query as a result.</p>',
'<p>',
'    This example makes use of <em>Oracle Text Query Relaxation</em>: It first executes the exact query,',
'    then it performs increasing levels of <em>fuzzy search</em>, until the requested amount of rows',
'    is returned. This is all transparent to the end user.',
'</p>',
'<pre>',
'create or replace function convert_end_user_search (',
'    p_search in varchar2 )',
'    return varchar2 ',
'is',
'    c_xml constant varchar2(32767) := ',
'        ''&lt;query&gt;&lt;textquery>&lt;progression&gt;''          ||',
'          ''&lt;seq&gt;       #SEARCH#            &lt;/seq&gt;'' ||',
'          ''&lt;seq&gt; FUZZY(#SEARCH#,80, 100,W) &lt;/seq&gt;'' ||',
'          ''&lt;seq&gt; FUZZY(#SEARCH#,50,1000,W) &lt;/seq&gt;'' ||',
'          ''&lt;seq&gt; FUZZY(#SEARCH#,20,3000,W) &lt;/seq&gt;'' ||',
'        ''&lt;/progression>&lt;/textquery>&lt;/query&gt;'';',
'',
'    l_search varchar2(32767) := p_search;',
'begin',
'    --',
'    -- remove special characters; ',
'    -- these are irrelevant for full text search',
'    --',
'    l_search := regexp_replace(',
'        srcstr  => l_search, ',
'        pattern => ''[&lt;&gt;{}/()*%&!$?.:,;\+#]'' );',
'',
'    return replace( ',
'        srcstr  => c_xml, ',
'        oldsub  => ''#SEARCH#'', ',
'        newsub  => ''{'' || l_search || ''}'' );',
'end;',
'</pre>',
'<p>',
'    For more information about Oracle Text query syntax and the query relaxation',
'    feature see the <a rel="noopener noreferrer" target="_blank" href="https://docs.oracle.com/en/database/oracle/oracle-database/23/ccapp/index.html">Oracle Text Application Developers Guide</a>.</p>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1422060242786016)
,p_name=>'P4001_PRINT_SERVER_TYPE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1421934290786015)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Print Server Type'
,p_source=>'PRINT_SERVER_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APP PRINT SERVER TYPE'
,p_lov=>'.'||wwv_flow_imp.id(6801471089410875)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Controls the print server of the application. These settings override the settings from Administration Services. Available options include:</p>',
'<ul>',
'<li><strong>Native Printing</strong> - Use native printing. No external print server required. Custom report layouts are not supported.</li>',
'<li><strong>Remote Print Server</strong> - Choose a remote server of the type "Print Server" that is configured in the Workspace Utilities.</li>',
'<li><strong>Use Instance Settings</strong> - Use the Report Printing settings defined in Administration Services.</li>',
'</ul>'))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1422184336786017)
,p_name=>'P4001_PRINT_REMOTE_SERVER_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1421934290786015)
,p_use_cache_before_default=>'NO'
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.id',
'  from (select id ',
'          from wwv_remote_servers',
'         where server_type = ''PRINT_SERVER''',
'           and security_group_id = :FLOW_SECURITY_GROUP_ID) a',
' where rownum = 1'))
,p_item_default_type=>'SQL_QUERY'
,p_prompt=>'Remote Print Server'
,p_source=>'PRINT_REMOTE_SERVER_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REMOTE_PRINT_SERVER'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_remote_servers',
' where server_type = ''PRINT_SERVER''',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Select a remote server defined in Workspace Utilities of the type "Print Server".</p>'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1422648082786022)
,p_name=>'P4001_PRINT_AUTH_REQUIRED'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1421934290786015)
,p_item_default=>'Y'
,p_prompt=>'Authentication Required'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Determines whether to use authentication for the remote print server. Available options include:</p>',
'<ol>',
'<li><strong>On</strong> - Authenticate the print server requests using a credential.</li>',
'<li><strong>Off</strong> - The print server requires no authentication.</li>',
'</ol> '))
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1422786998786023)
,p_name=>'P4001_PRINT_CREDENTIAL_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(1421934290786015)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Credentials'
,p_source=>'PRINT_CREDENTIAL_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LOV_CREDENTIAL_STORES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_credentials',
' where security_group_id    = :FLOW_SECURITY_GROUP_ID',
'   and authentication_type != ''KEY_PAIR'''))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Select a credential defined in Workspace Utilities.</p>'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1801073607927401)
,p_name=>'P4001_ACCESSIBLE_READ_ONLY'
,p_is_required=>true
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(198116031744061165)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Accessible Read-Only Items'
,p_source=>'ACCESSIBLE_READ_ONLY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Determines whether &PRODUCT_NAME renders the legacy SPAN-based elements for an item''s read-only mode, or the more accessible readonly input or textarea elements. The more accessible input and textarea elements will be focusable with the keyboard, and'
||' easier to perceive for screen reader users.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1931095356915001)
,p_name=>'P4001_ORACLE_TEXT_FUNCTION_TYPE'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(198116031744061165)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Text Query Function'
,p_source=>'ORACLE_TEXT_FUNCTION_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TEXT_QUERY_FUNCTION_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(1936977999928971)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'None'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The Oracle Text query syntax is very complex and powerful and provides a rich set of query operators to deal with wildcards, stemming, fuzzy searches and so forth. For end users, this syntax is often hard to understand. To simplify the search proc'
||'ess for users, you can select a function that automatically converts simple end user input into an Oracle Text query, with the advanced search features applied automatically. Options include:</p>',
'<ul>',
'    <li><strong>None</strong> - &PRODUCT_NAME. encloses each query term with "{" and "}", except the keywords <strong>and</strong> and <strong>or</strong>.</li>',
'    <li><strong>Search Engine</strong> - This function performs a query relaxation search to retrieve relevant results beyond just exact matches. The goal is to get as many related results as possible, allowing users to easily find related informatio'
||'n without needing to input precise queries. The search process begins with an exact match search and then progressively relaxes the query using techniques like stemming and fuzzy matching. While maximizing the number of results, the search engine fun'
||'ction ensures that the most exact and relevant matches are always ranked at the top of the search results.</li>',
'    <li><strong>Expert Search</strong> - This function supports more advanced search operators for precise queries. It allows exact matching, Boolean operators (AND, OR, NOT), precedence with parentheses and proximity search. Additional parameters al'
||'low customizing search behavior. This is best when requiring highly accurate results from very specific queries. Also see the <code>QUERY_EXPERT_SEARCH</code> function within the <code>APEX_SEARCH</code> package.</li>',
'    <li><strong>Custom</strong> - Provide a custom function.</li>',
'</ul>'))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1950100044091138)
,p_name=>'P4001_TOKENIZE_ROW_SEARCH'
,p_is_required=>true
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(198116031744061165)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tokenize Row Search'
,p_source=>'TOKENIZE_ROW_SEARCH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify how the search terms are applied when a <em>row search</em> is performed within a component.</p>',
'<p>Selecting <strong>On</strong> will treat each word of a search term separately, to match a record where the words are contained in any of the columns, together or independently. To search for an exact phrase, use double quotes (") around the searc'
||'h terms. For example, "ui developer". To escape a double quote in a search term, use a double quote ("").',
'</p> ',
'<h4>Examples</h4>',
'<dl>',
'<dt>1- Any record including the words "red" and "shoes"<dt><dd>search term: red shoes</dd>',
'<dt>2- Any record including the word "developer" and the exact expression "ui designer"</dt><dd>search term: developer "ui designer"</dd>',
'<dt>3- Any record including the word "author" and the exact expression "the sky is "blue" and nice"</dt><dd>search term: author "the sky is ""blue"" and nice"</dd>',
'</dl>',
'<p>Selecting <strong>Off</strong> will treat the whole search term as an exact match.</p>'))
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2001338047304309)
,p_name=>'P4001_TASK_VACATION_RULE_PROC'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2200978967294804)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Task Vacation Rule Procedure'
,p_source=>'TASK_VACATION_RULE_PROCEDURE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>100
,p_cMaxlength=>500
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify the name of a PL/SQL procedure in the format <strong>[schemaName.[packageName.]]procedureName</strong>. ',
'The procedure is expected to return additional alternate participants for task definitions in this application.',
'The vacation rule procedure should implement the following interface.</p>',
'<pre>',
'    procedure my_vacation_rule (',
'        p_param   in apex_approval.t_vacation_rule_input,',
'        p_result  out apex_approval.t_vacation_rule_output );',
'</pre>',
'<p>The procedure input is of type <strong>apex_approval.t_vacation_rule_input</strong> and the result output is of type <strong>apex_approval.t_vacation_rule_output</strong> </p>',
'<p>',
'This example shows a vacation rule procedure implementation where SCOTT is added as an alternate participant as JANE ',
'would be on maternity leave.</p>',
'<pre>',
'',
'    procedure alternate_job_approvers(',
'                p_param    in apex_approval.t_vacation_rule_input,',
'                p_result  out apex_approval.t_vacation_rule_result)',
'    is ',
'        l_result            apex_approval.t_vacation_rule_result;',
'        l_changes           apex_approval.t_task_participant_changes;',
'        l_participants      apex_approval.t_task_participants;',
'        l_new_participant   apex_approval.t_task_participant;',
'        l_old_participant   apex_approval.t_task_participant;',
'        l_has_changed       boolean                             := false;',
'        l_index             pls_integer                         := 1;',
'    begin',
'        l_participants := p_param.original_participants;',
'        for i in 1..l_participants.count loop',
'            if l_participants(i).value = ''JANE'' then',
'                l_old_participant               :=  l_participants(i);',
'                l_new_participant.value         := ''SCOTT'';',
'                l_new_participant.type          := ''POTENTIAL_OWNER'';',
'                l_new_participant.identity      := ''USER'';',
'                l_has_changed                   := true;',
'            end if;',
'        end loop;',
'        if l_has_changed then',
'            l_participants(l_participants.count + 1) := l_new_participant;',
'        ',
'            l_changes(l_index).old_participant   := l_old_participant;',
'            l_changes(l_index).new_participant   := l_new_participant;',
'            l_changes(l_index).change_reason     := ''Jane is out on maternity leave'';',
'        end if;',
'        l_result.participant_changes            := l_changes;',
'        l_result.has_participant_changes        := l_has_changed;',
'        p_result                                := l_result;',
'    end;',
'</pre>',
''))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2317886157424403)
,p_name=>'P4001_MAX_SCHEDULER_JOBS'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(198116031744061165)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Maximum Background Page Process Jobs'
,p_source=>'MAX_SCHEDULER_JOBS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Provide the maximum number of scheduler jobs being available ',
'    for <em>background execution</em> of page processes for this application. Only',
'    the configured number of jobs will run at the same time, to execute page',
'    processes for this application in the background. If the configured maximum amount',
'    of scheduler jobs is active, new submitted executions will wait until a job',
'    becomes available.',
'</p>',
'<p>',
'    Setting the attribute to zero disables background executions; new submitted executions',
'    will stay in <em>enqueued</em> state.',
'</p>'))
,p_attribute_01=>'0'
,p_attribute_03=>'left'
,p_attribute_04=>'numeric'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2430140266300735)
,p_name=>'P4001_COPYRIGHT_BANNER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2430011519300734)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Copyright Banner'
,p_source=>'COPYRIGHT_BANNER'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter copyright banner text here. This will be included in the APEX application export file. You can use <code>#APP_NAME#</code> substitution string to refer to current application name and <code>#YEAR#</code> to refer to the current year. <br/><br/>'
||'e.g.',
'<pre>',
'Name: #APP_NAME#',
'Copyright (c) 1999, #YEAR#, Company Name.',
'</pre>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6255524120055403)
,p_name=>'SVAL_09'
,p_item_sequence=>480
,p_item_plug_id=>wwv_flow_imp.id(85248570290)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Substitution Value 9'
,p_source=>'SUBSTITUTION_VALUE_09'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6256026890056232)
,p_name=>'SVAL_10'
,p_item_sequence=>500
,p_item_plug_id=>wwv_flow_imp.id(85248570290)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Substitution Value 10'
,p_source=>'SUBSTITUTION_VALUE_10'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6256428622056745)
,p_name=>'SVAL_11'
,p_item_sequence=>520
,p_item_plug_id=>wwv_flow_imp.id(85248570290)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Substitution Value 11'
,p_source=>'SUBSTITUTION_VALUE_11'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6256831738057618)
,p_name=>'SVAL_12'
,p_item_sequence=>540
,p_item_plug_id=>wwv_flow_imp.id(85248570290)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Substitution Value 12'
,p_source=>'SUBSTITUTION_VALUE_12'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6257101394058272)
,p_name=>'SVAL_13'
,p_item_sequence=>560
,p_item_plug_id=>wwv_flow_imp.id(85248570290)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Substitution Value 13'
,p_source=>'SUBSTITUTION_VALUE_13'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6257117909985232)
,p_name=>'P4001_ERROR_HANDLING_FUNCTION'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_imp.id(6257403627000045)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Error Handling Function'
,p_source=>'ERROR_HANDLING_FUNCTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the name of the PL/SQL function to be called to modify the error message and display location or to log the error if one occurs. It can reference a package function or stand alone function in the database. For example:',
'<pre>',
'log_apex_error',
'</pre>',
'</p>',
'',
'<p>',
'Note: Error handling specified at the page-level overwrites any error handling function specified here.',
'</p>',
'',
'<p>Error Handling Functions must implement the following interface:',
'',
'<pre>',
'function &lt;name of function> (',
'    p_error in apex_error.t_error )',
'    return apex_error.t_error_result',
'</pre>',
'</p>',
'',
'<p>',
'See Also: "apex_error" in &PRODUCT_NAME. API Reference',
'</p>',
''))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6259711915070790)
,p_name=>'SVAL_14'
,p_item_sequence=>580
,p_item_plug_id=>wwv_flow_imp.id(85248570290)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Substitution Value 14'
,p_source=>'SUBSTITUTION_VALUE_14'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6260013300071257)
,p_name=>'SVAL_15'
,p_item_sequence=>600
,p_item_plug_id=>wwv_flow_imp.id(85248570290)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Substitution Value 15'
,p_source=>'SUBSTITUTION_VALUE_15'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6260515031071740)
,p_name=>'SVAL_16'
,p_item_sequence=>620
,p_item_plug_id=>wwv_flow_imp.id(85248570290)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Substitution Value 16'
,p_source=>'SUBSTITUTION_VALUE_16'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6260916763072263)
,p_name=>'SVAL_17'
,p_item_sequence=>640
,p_item_plug_id=>wwv_flow_imp.id(85248570290)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Substitution Value 17'
,p_source=>'SUBSTITUTION_VALUE_17'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6261418841072838)
,p_name=>'SVAL_18'
,p_item_sequence=>660
,p_item_plug_id=>wwv_flow_imp.id(85248570290)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Substitution Value 18'
,p_source=>'SUBSTITUTION_VALUE_18'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6261921958073689)
,p_name=>'SVAL_19'
,p_item_sequence=>680
,p_item_plug_id=>wwv_flow_imp.id(85248570290)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Substitution Value 19'
,p_source=>'SUBSTITUTION_VALUE_19'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6262424382074460)
,p_name=>'SVAL_20'
,p_item_sequence=>700
,p_item_plug_id=>wwv_flow_imp.id(85248570290)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Substitution Value 20'
,p_source=>'SUBSTITUTION_VALUE_20'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6263301657077352)
,p_name=>'SSTRING_09'
,p_item_sequence=>470
,p_item_plug_id=>wwv_flow_imp.id(85248570290)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Substitution String 9'
,p_source=>'SUBSTITUTION_STRING_09'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6263804427078118)
,p_name=>'SSTRING_10'
,p_item_sequence=>490
,p_item_plug_id=>wwv_flow_imp.id(85248570290)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Substitution String 10'
,p_source=>'SUBSTITUTION_STRING_10'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6264106851078773)
,p_name=>'SSTRING_11'
,p_item_sequence=>510
,p_item_plug_id=>wwv_flow_imp.id(85248570290)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Substitution String 11'
,p_source=>'SUBSTITUTION_STRING_11'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6264408929079441)
,p_name=>'SSTRING_12'
,p_item_sequence=>530
,p_item_plug_id=>wwv_flow_imp.id(85248570290)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Substitution String 12'
,p_source=>'SUBSTITUTION_STRING_12'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6264710660079940)
,p_name=>'SSTRING_13'
,p_item_sequence=>550
,p_item_plug_id=>wwv_flow_imp.id(85248570290)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Substitution String 13'
,p_source=>'SUBSTITUTION_STRING_13'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6265012392080423)
,p_name=>'SSTRING_14'
,p_item_sequence=>570
,p_item_plug_id=>wwv_flow_imp.id(85248570290)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Substitution String 14'
,p_source=>'SUBSTITUTION_STRING_14'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6265314470081051)
,p_name=>'SSTRING_15'
,p_item_sequence=>590
,p_item_plug_id=>wwv_flow_imp.id(85248570290)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Substitution String 15'
,p_source=>'SUBSTITUTION_STRING_15'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6265616201081557)
,p_name=>'SSTRING_16'
,p_item_sequence=>610
,p_item_plug_id=>wwv_flow_imp.id(85248570290)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Substitution String 16'
,p_source=>'SUBSTITUTION_STRING_16'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6265917933081999)
,p_name=>'SSTRING_17'
,p_item_sequence=>630
,p_item_plug_id=>wwv_flow_imp.id(85248570290)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Substitution String 17'
,p_source=>'SUBSTITUTION_STRING_17'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6266220357082710)
,p_name=>'SSTRING_18'
,p_item_sequence=>650
,p_item_plug_id=>wwv_flow_imp.id(85248570290)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Substitution String 18'
,p_source=>'SUBSTITUTION_STRING_18'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6266722089083197)
,p_name=>'SSTRING_19'
,p_item_sequence=>670
,p_item_plug_id=>wwv_flow_imp.id(85248570290)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Substitution String 19'
,p_source=>'SUBSTITUTION_STRING_19'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6267424513083951)
,p_name=>'SSTRING_20'
,p_item_sequence=>690
,p_item_plug_id=>wwv_flow_imp.id(85248570290)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Substitution String 20'
,p_source=>'SUBSTITUTION_STRING_20'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--stretch'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8402031162370319)
,p_name=>'P4001_FILE_STORAGE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(8401814586370317)
,p_use_cache_before_default=>'NO'
,p_prompt=>'File Storage Type'
,p_source=>'FILE_STORAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'FILE_STORAGE'
,p_lov=>'.'||wwv_flow_imp.id(1602419714639818)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Controls the file storage of the application. Available options include:</p>',
'<ul>',
'<li><strong>Database</strong> - Use the database to store Static Application Files.</li>',
'<li><strong>Object Storage</strong> - Use specified server to store files in Object Storage.</li>',
'</ul>'))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8402154453370320)
,p_name=>'P4001_FILE_REMOTE_SERVER_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(8401814586370317)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Remote File Server'
,p_source=>'FILE_REMOTE_SERVER_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REMOTE_FILE_SERVER'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_remote_servers',
' where server_type = ''CLOUD_OBJECT_STORE''',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Select a remote server defined in Workspace Utilities of the type "File Server".</p>'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11227626235013287)
,p_name=>'P4001_PUBLISH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(198116031744061165)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_source=>'PUBLISH_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Published applications display on the Applications page, available for the &PRODUCT_NAME. home page.  Non published applications do not display on the  Applications page.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(84788616925426806)
,p_name=>'F4000_P4001_GLOBAL_NOTIFICATION'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_imp.id(84785704645417330)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Message to be displayed in page #GLOBAL_NOTIFICATION# substitution string'
,p_source=>'GLOBAL_NOTIFICATION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'You can use a global notification to communicate system status. If your page template contains a <code>#GLOBAL_NOTIFICATION#</code> substitution string then the text entered here displays on each page.<p>',
'<p>For example, suppose you entered the message "Team picnic this Friday" in this attribute. Assuming your page templates support the global notification substitution string then this message would display on each page.<p>',
'To create a global notification:',
'<ol>',
'<li>Include the <code>#GLOBAL_NOTIFICATION#</code> substitution string in your page template.</li>',
'<li>Navigate to the Edit Application page and enter a message in the Global Notifications attribute.</li>',
'<li>Click <strong>Apply Changes</strong>.</li>',
'</ol>',
''))
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(91061117381015202)
,p_name=>'P4001_GROUP_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(284956612)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application Group'
,p_source=>'GROUP_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select group_name, id',
'from wwv_flow_application_groups',
'where security_group_id = :flow_security_group_id',
'order by upper(group_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Unassigned -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_working_copy_dev.is_working_copy (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_security_group_id => :WORKSPACE_ID )'))
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Displays the application group currently associated with this application.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(98291001902600275)
,p_name=>'F4000_P4001_EXACT_SUBSTITUTIONS_ONLY'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(198116031744061165)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Exact Substitutions'
,p_source=>'EXACT_SUBSTITUTIONS_ONLY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'EXACT_SUBS_Y_N'
,p_lov=>'.'||wwv_flow_imp.id(84908521896674445)||'.'
,p_cHeight=>1
,p_display_when=>'F4000_P4001_EXACT_SUBSTITUTIONS_ONLY'
,p_display_when2=>'N'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Determines support for exact substitutions. Use exact substitutions.<p/> ',
'Note that non exact substitutions is a deprecated feature.<p/> ',
'Exact substitutions use the following syntax:',
'<pre>&amp;ITEM.</pre> ',
'Non-exact substitutions use the syntax:',
'<pre>&amp;ITEM</pre>'))
,p_attribute_01=>'NONE'
,p_item_comment=>'pawolf/05-apr-2012: Page item will only be visible if the application uses Non Exact Substitutions so that they can change it to yes, but we don''t support that new applications will use No.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(105521529152379239)
,p_name=>'F4000_P4001_ALIAS'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(284956612)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application Alias'
,p_source=>'ALIAS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_working_copy_dev.is_working_copy (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_security_group_id => :WORKSPACE_ID )'))
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Assigns an alternate alphanumeric application identifier. You can use this identifier in place of the application ID.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(173032421936291163)
,p_name=>'P4001_ALLOW_FEEDBACK_YN'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(198116031744061165)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Allow Feedback'
,p_source=>'ALLOW_FEEDBACK_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Enables support for end user feedback for this application. Select <strong>Yes</strong> or <strong>No</strong>.',
'<p/>',
'You must create feedback feature page to use this attribute.  If you enable this option, feedback icon displays, so users can click to leave feedback. You can disable this option to hide the feedback icon. This enables you to turn on feedback for tes'
||'ting and turn it off for production.'))
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(185078809102590512)
,p_name=>'P4001_FRIENDLY_URL'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(198116031744061165)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Friendly URLs'
,p_source=>'FRIENDLY_URL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Determines whether URLs generated to navigate to other pages in the application should be easier to read. If set to <strong>On</strong>, a directory structure based on the application, page alias and standard web parameter syntax will be used. If '
||'set to <strong>Off</strong>, the legacy <code>f?p=</code> syntax will be used.</p>',
'<p>Note: The friendly URL will include the workspace <em>Path Prefix</em> in the URL. To modify the Path Prefix go to Workspace Administration > Manage Service > Set Workspace Preferences.</p>',
'<p>If Friendly URLs is set to <strong>On</strong>, you will have access to <strong>Progressive Web App</strong> options.</p>'))
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(191198909190237603)
,p_name=>'P4001_DEFAULT_ERROR_DISPLAY_LOCATION'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_imp.id(6257403627000045)
,p_use_cache_before_default=>'NO'
,p_item_default=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_prompt=>'Default Error Display Location'
,p_source=>'DEFAULT_ERROR_DISPLAY_LOCATION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'DEFAULT_ERROR_DISPLAY_LOCATION'
,p_lov=>'.'||wwv_flow_imp.id(191207805708435328)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies where the validation error messages display for basic validations performed by &PRODUCT_NAME. or by plug-ins. Validation error messages can display in a "notification" area (defined as part of the page template), or within the field label.'
||'</p>'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(198568215654454253)
,p_name=>'P4001_DEBUGGING'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(198116031744061165)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Debugging'
,p_source=>'APPLICATION_TAB_SET'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Determines whether debug mode can be enabled from a browser. Available options include:<p>',
'<ul>',
'<li><strong>On</strong>. Enables the application to run in a debug mode from a browser at runtime.</li>',
'<li><strong>Off</strong>. Disables the application from enabling in debug from a browser.</li>',
'</ul>',
'<p>Running an application in debug mode is useful when an application is under development. For production applications, Oracle recommends disabling debugging and thus preventing users from viewing application logic.</p>',
'<p>Debug can be enabled programmatically regardless of this debug setting.</p>',
'<p>If the application is run from the &PRODUCT_NAME. development environment, debugging can always be enabled.</p>'))
,p_attribute_01=>'N'
,p_attribute_02=>'1'
,p_attribute_04=>'0'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(207464222755454577)
,p_name=>'P4001_COMPATIBILITY_MODE'
,p_is_required=>true
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(198116031744061165)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Compatibility Mode'
,p_source=>'COMPATIBILITY_MODE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION.COMPATIBILITY_MODE'
,p_lov=>'.'||wwv_flow_imp.id(207464823363457503)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Controls the compatibility mode of the &PRODUCT_NAME. runtime engine. Certain runtime behaviors are changed from release to release. Use this attribute to obtain specific application behavior. To realize new behavior in an application, set the compat'
||'ibility mode of the application to the current version.',
'</p>',
'<p>',
'For details see chapter "Changed Behavior - Compatibility Mode" in the Release Notes.',
'</p>'))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(235689124480474701)
,p_name=>'P4001_EMAIL_FROM'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(198116031744061165)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application Email From Address'
,p_source=>'EMAIL_FROM'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Determines the email address to use as the "From" address in the application.</p>',
'<p>This email address is used when sending email from interactive report email download and subscription in the application. This value can be a literal string containing a valid email or a static substitution reference defined in the application usi'
||'ng substitution syntax. Oracle does not recommend using an item substitution at the application or page level since it only works for email downloads, but not in a subscriptions.</p>',
'Examples:',
'<ul>',
'<li><code>john.doe@example.com</code></li>',
'<li><code>&amp;MY_APP_EMAIL_FROM.</code></li>',
'</ul>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'EMAIL'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(538532984883939915)
,p_name=>'P4001_NO_PROXY_DOMAINS'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(198116031744061165)
,p_use_cache_before_default=>'NO'
,p_prompt=>'No Proxy Domains'
,p_source=>'NO_PROXY_DOMAINS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>500
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use this field to specify a list of hosts and domains for which no proxy should be used. <p/>',
'<p>You can reference values entered into this field from PL/SQL using the PL/SQL package variable <code>APEX_APPLICATION.G_NO_PROXY_DOMAINS</code>.</p><p>For example:</p>',
'<pre>internal.example.com,local.example.com</pre>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(95706604629366729)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P4001_ALIAS'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>':FB_UPD_ID'
,p_computation_error_message=>'Unable to compute item value.'
,p_compute_when=>'F4000_P4001_ALIAS'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(486801121465649401)
,p_computation_sequence=>30
,p_computation_item=>'FB_UPD_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'SQL'
,p_computation=>'ltrim(rtrim(:FB_UPD_NAME))'
,p_compute_when=>'ApplyChanges'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1423608357786032)
,p_computation_sequence=>40
,p_computation_item=>'P4001_PRINT_REMOTE_SERVER_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P4001_PRINT_SERVER_TYPE'
,p_compute_when_text=>'REMOTE'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3750691709188804)
,p_computation_sequence=>50
,p_computation_item=>'P4001_FILE_REMOTE_SERVER_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P4001_FILE_STORAGE'
,p_compute_when_text=>'OBJECT_STORE'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1423729749786033)
,p_computation_sequence=>60
,p_computation_item=>'P4001_PRINT_CREDENTIAL_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>':P4001_PRINT_AUTH_REQUIRED != ''Y'' or :P4001_PRINT_SERVER_TYPE != ''REMOTE'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(6951849466786644)
,p_computation_sequence=>10
,p_computation_item=>'P4001_PRINT_AUTH_REQUIRED'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case ',
'  when :P4001_PRINT_REMOTE_SERVER_ID is not null and :P4001_PRINT_CREDENTIAL_ID is null then ''N''',
'  else ''Y''',
'end'))
,p_compute_when=>'P4001_PRINT_SERVER_TYPE'
,p_compute_when_text=>'REMOTE'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(73224212233840493)
,p_validation_name=>'flow alias valid'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not htmldb_util.has_restricted_chars (',
'    p_value => :F4000_P4001_ALIAS,',
'    p_check => ''SAFE_COMPONENT_NAME_NO_NUMBER'' )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#LABEL# contains invalid characters or is numeric! The following characters: :&,.''+?"^, spaces, new line characters and a numeric value can NOT be saved.',
'                                                   '))
,p_validation_condition=>':F4000_P4001_ALIAS is not null and :REQUEST not in (''Cancel'',''Delete'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(105521529152379239)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3303775343286935)
,p_validation_name=>'Alias is not a reserved word'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not wwv_flow_page_dev.is_alias_reserved_word (',
'    p_alias => :F4000_P4001_ALIAS )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Invalid #LABEL#. Entered #LABEL# is a reserved word.'
,p_validation_condition=>':F4000_P4001_ALIAS is not null and :REQUEST not in (''Cancel'',''Delete'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(105521529152379239)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(235689710893481005)
,p_validation_name=>'P4001_EMAIL_FROM is valid'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_amp  number;',
'  l_at   number;',
'  l_dot  number;',
'begin',
'  l_amp := instr(:P4001_EMAIL_FROM,''&'');',
'  l_dot := instr(:P4001_EMAIL_FROM,''.'',l_amp);',
'  if l_amp > 0 and l_dot > 0 then',
'    return true;',
'  else',
'    l_at := instr(:P4001_EMAIL_FROM,''@'');',
'    l_dot := instr(:P4001_EMAIL_FROM,''.'',l_at);',
'    if l_at > 1 and l_dot > 1 and (l_dot - l_at) > 1 then',
'        return true;',
'    end if;',
'  end if;',
'  return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Invalid email address'
,p_validation_condition=>'P4001_EMAIL_FROM'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_imp.id(235689124480474701)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1423860740786034)
,p_validation_name=>'Remote Print Server not null'
,p_validation_sequence=>50
,p_validation=>'P4001_PRINT_REMOTE_SERVER_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# is required.'
,p_validation_condition=>'P4001_PRINT_SERVER_TYPE'
,p_validation_condition2=>'REMOTE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(1422184336786017)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1423942806786035)
,p_validation_name=>'Print Credentials not null'
,p_validation_sequence=>60
,p_validation=>'P4001_PRINT_CREDENTIAL_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# is required.'
,p_validation_condition=>':P4001_PRINT_SERVER_TYPE = ''REMOTE'' and :P4001_PRINT_AUTH_REQUIRED = ''Y'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(1422786998786023)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(8402200537370321)
,p_validation_name=>'Remote File Server not null'
,p_validation_sequence=>65
,p_validation=>'P4001_FILE_REMOTE_SERVER_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# is required.'
,p_validation_condition=>'P4001_FILE_STORAGE'
,p_validation_condition2=>'OBJECT_STORE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(40006878470920)
,p_associated_item=>wwv_flow_imp.id(8402154453370320)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(7424725389419401)
,p_validation_name=>'P4001_ERROR_HANDLING_FUNCTION is valid'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_f4000_util.check_plsql(',
'    p_sql                 => q''[declare l_result wwv_flow_error_api.t_error_result; l_err wwv_flow_error_api.t_error; begin l_result := ]'' ||',
'    :P4001_ERROR_HANDLING_FUNCTION || q''[(l_err); end;]'',',
'    p_flow_id             => :FB_FLOW_ID,',
'    p_security_group_id   => :WORKSPACE_ID',
');'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P4001_ERROR_HANDLING_FUNCTION'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_imp.id(6257117909985232)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1931127249915002)
,p_validation_name=>'Text Query Function Type = CUSTOM'
,p_validation_sequence=>80
,p_validation=>'P4001_ORACLE_TEXT_FUNCTION'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# is required.'
,p_validation_condition=>'P4001_ORACLE_TEXT_FUNCTION_TYPE'
,p_validation_condition2=>'CUSTOM'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(40006878470920)
,p_associated_item=>wwv_flow_imp.id(1378952136513217)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2200753330294802)
,p_validation_name=>'Vacation Rule Procedure name is valid'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    return wwv_flow_approval_dev.validate_vacation_rule_proc(p_proc_name => :P4001_TASK_VACATION_RULE_PROC);',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Please provide a valid name for the Task Vacation Rule Procedure.'
,p_validation_condition=>'P4001_TASK_VACATION_RULE_PROC'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_imp.id(2001338047304309)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(538533015324939916)
,p_name=>'Proxy Server'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P4001_PROXY_SERVER'
,p_condition_element=>'F4000_P4001_PROXY_SERVER'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(538533198743939917)
,p_event_id=>wwv_flow_imp.id(538533015324939916)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4001_NO_PROXY_DOMAINS'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(538533256100939918)
,p_event_id=>wwv_flow_imp.id(538533015324939916)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4001_NO_PROXY_DOMAINS'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(538533354137939919)
,p_event_id=>wwv_flow_imp.id(538533015324939916)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4001_NO_PROXY_DOMAINS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1422256128786018)
,p_name=>'On remote server'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4001_PRINT_SERVER_TYPE'
,p_condition_element=>'P4001_PRINT_SERVER_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REMOTE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1422331611786019)
,p_event_id=>wwv_flow_imp.id(1422256128786018)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4001_PRINT_REMOTE_SERVER_ID,P4001_PRINT_AUTH_REQUIRED'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1422451855786020)
,p_event_id=>wwv_flow_imp.id(1422256128786018)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4001_PRINT_REMOTE_SERVER_ID,P4001_PRINT_AUTH_REQUIRED'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1423437570786030)
,p_event_id=>wwv_flow_imp.id(1422256128786018)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.event.trigger( $("#P4001_PRINT_AUTH_REQUIRED"), "credentialchange" );'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1423595884786031)
,p_event_id=>wwv_flow_imp.id(1422256128786018)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.event.trigger( $("#P4001_PRINT_AUTH_REQUIRED"), "credentialchange" );'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1422832521786024)
,p_name=>'Change Print Authentication'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4001_PRINT_AUTH_REQUIRED'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1422987265786025)
,p_event_id=>wwv_flow_imp.id(1422832521786024)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.event.trigger( $("#P4001_PRINT_AUTH_REQUIRED"), "credentialchange" );'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1423004640786026)
,p_name=>'credentialchange'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4001_PRINT_AUTH_REQUIRED'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.item("P4001_PRINT_AUTH_REQUIRED").getValue() === "Y" &&',
'apex.item("P4001_PRINT_SERVER_TYPE").getValue() === "REMOTE"'))
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'custom'
,p_bind_event_type_custom=>'credentialchange'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1423137728786027)
,p_event_id=>wwv_flow_imp.id(1423004640786026)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4001_PRINT_CREDENTIAL_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1423240441786028)
,p_event_id=>wwv_flow_imp.id(1423004640786026)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4001_PRINT_CREDENTIAL_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(8402371936370322)
,p_name=>'On object storage'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4001_FILE_STORAGE'
,p_condition_element=>'P4001_FILE_STORAGE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'OBJECT_STORE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8402449167370323)
,p_event_id=>wwv_flow_imp.id(8402371936370322)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4001_FILE_REMOTE_SERVER_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8402516451370324)
,p_event_id=>wwv_flow_imp.id(8402371936370322)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4001_FILE_REMOTE_SERVER_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1931286524915003)
,p_name=>'Text Query Function Type = CUSTOM'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4001_ORACLE_TEXT_FUNCTION_TYPE'
,p_condition_element=>'P4001_ORACLE_TEXT_FUNCTION_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'CUSTOM'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1931364597915004)
,p_event_id=>wwv_flow_imp.id(1931286524915003)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4001_ORACLE_TEXT_FUNCTION'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1931489228915005)
,p_event_id=>wwv_flow_imp.id(1931286524915003)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4001_ORACLE_TEXT_FUNCTION'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1932226961915013)
,p_event_id=>wwv_flow_imp.id(1931286524915003)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4001_ORACLE_TEXT_FUNCTION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(40006868470917)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOWS'
,p_attribute_03=>'FB_FLOW_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Error fetching  row.'
,p_internal_uid=>40006868470917
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(72721927488098078)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'security'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.init;',
'sys.owa_util.redirect_url(v(''LOGOUT_URL''));'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'    from   wwv_flow_developers',
'    where  userid = :FLOW_USER ',
'       and',
'       security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and',
'       security_group_id = ',
'         (select security_group_id from wwv_flows where id=:FB_FLOW_ID)',
'       and',
'       instr(developer_role,''EDIT'') > 0 ',
'       and',
'       (flow_id = :FB_FLOW_ID or flow_id is null)  '))
,p_process_when_type=>'NOT_EXISTS'
,p_internal_uid=>72721927488098078
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(40006869470918)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOWS'
,p_attribute_03=>'FB_FLOW_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'U'
,p_attribute_12=>'Y'
,p_process_error_message=>'Error processing  row.'
,p_process_success_message=>'Application &FB_UPD_ID. processed.'
,p_internal_uid=>40006869470918
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(72719524240087695)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'security'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.init;',
'sys.owa_util.redirect_url(v(''LOGOUT_URL''));',
'wwv_flow.g_unrecoverable_error := true;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'    from   wwv_flow_developers',
'    where  userid = :FLOW_USER ',
'       and',
'       security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and',
'       security_group_id = ',
'         (select security_group_id from wwv_flows where id=:FB_FLOW_ID)',
'       and',
'       instr(developer_role,''EDIT'') > 0 ',
'       and',
'       (flow_id = :FB_FLOW_ID or flow_id is null)  '))
,p_process_when_type=>'NOT_EXISTS'
,p_internal_uid=>72719524240087695
);
end;
/
prompt --application/pages/page_04003
begin
wwv_flow_imp_page.create_page(
 p_id=>4003
,p_name=>'Templates'
,p_alias=>'TEMPLATES'
,p_step_title=>'Templates'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(54196929426)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(12437772301)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Templates'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9763401034980576)
,p_plug_name=>'About'
,p_region_css_classes=>'a-Region--sideRegion a-Region--stacked a-Region--flush a-Region--padded'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The &PRODUCT_NAME. engine constructs the appearance of each page in a application using Templates. Templates define how pages, page controls, and page components display.</p>',
'<p>To edit template attributes, select the template name.  To preview a template, click the Run icon.</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(92875519972555730)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'a-LinksList--showArrow'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(92837202675352059)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(632908701274265897)
,p_plug_name=>'Templates'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders:a-IRR-region--responsiveIconView'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>80
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(template_type,',
'           ''PAGE'',wwv_flow_lang.system_message_lit(''F4000.PAGE''),',
'           ''REGION'',wwv_flow_lang.system_message_lit(''F4000.REGION''),',
'           ''LABEL'',wwv_flow_lang.system_message_lit(''F4000.ITEM''),',
'           ''LIST'',wwv_flow_lang.system_message_lit(''F4000.LIST_INITCAP''),',
'           ''POPUP_LOV'',wwv_flow_lang.system_message_lit(''F4000.P371.POPUP_LOV''),',
'           ''CALENDAR'',wwv_flow_lang.system_message_lit(''LEGACY_CALENDAR''),',
'           ''MENU'',wwv_flow_lang.system_message_lit(''BREADCRUMB''),',
'           ''BUTTON'',wwv_flow_lang.system_message_lit(''F4000.BUTTON''),',
'           ''REPORT'',wwv_flow_lang.system_message_lit(''REPORT''),',
'           ''TEMPLATE_COMPONENT'',wwv_flow_lang.system_message_lit(''F4000.TEMPLATE_COMPONENT''),',
'           template_type) t,',
'       upper_name,',
'       template_name n,',
'       internal_name,',
'       edit_page,',
'       reference_count c,',
'       last_updated_on,',
'       lower(last_updated_by) last_updated_by,',
'       ( select case',
'                  when x.reference_id is not null then wwv_flow_lang.system_message( ''SUBSCRIBED_FROM.THEME'' )',
'                  else x.subscribed_from',
'                end',
'           from wwv_flow_themes',
'          where flow_id  = :FB_FLOW_ID',
'            and theme_id = x.theme_id',
'       ) as subscribed_from,',
'       subscribers,',
'       decode(is_default,',
'              0, ''N'',',
'              ''Y'' ) as is_default,',
'       decode(is_default,',
'              0,'''',',
'              ''icon-check'' ) as default_css,',
'       theme_id theme,',
'       case template_type',
'           when ''REGION''             then ''538''',
'           when ''PAGE''               then ''568''',
'           when ''REPORT''             then ''569''',
'           when ''BUTTON''             then ''571''',
'           when ''CALENDAR''           then ''564''',
'           when ''LIST''               then ''573''',
'           when ''LABEL''              then ''574''',
'           when ''MENU''               then ''636''',
'           when ''TEMPLATE_COMPONENT'' then ''4406''',
'           else null',
'       end as copy_template_page,',
'       decode(template_type,',
'           ''REGION'',',
'            wwv_flow_utilities.prepare_url(''f?p=4000:538:''||:app_session||'':::538:P538_FROM_TEMPLATE_ID:''||tid),',
'           ''PAGE'',',
'            wwv_flow_utilities.prepare_url(''f?p=4000:568:''||:app_session||'':::568:P568_FROM_TEMPLATE_ID:''||tid),',
'           ''REPORT'',',
'            wwv_flow_utilities.prepare_url(''f?p=4000:569:''||:app_session||'':::569:P569_FROM_TEMPLATE_ID:''||tid),',
'           ''BUTTON'',',
'            wwv_flow_utilities.prepare_url(''f?p=4000:571:''||:app_session||'':::571:P571_FROM_TEMPLATE_ID:''||tid),',
'           ''CALENDAR'',',
'            wwv_flow_utilities.prepare_url(''f?p=4000:564:''||:app_session||'':::564:P564_FROM_TEMPLATE_ID:''||tid),',
'           ''LIST'',',
'            wwv_flow_utilities.prepare_url(''f?p=4000:573:''||:app_session||'':::573:P573_FROM_TEMPLATE_ID:''||tid),',
'           ''LABEL'',',
'            wwv_flow_utilities.prepare_url(''f?p=4000:574:''||:app_session||'':::574:P574_FROM_TEMPLATE_ID:''||tid),',
'           ''MENU'',',
'            wwv_flow_utilities.prepare_url(''f?p=4000:636:''||:app_session||'':::636:P636_FROM_TEMPLATE_ID:''||tid),',
'           ''TEMPLATE_COMPONENT'',',
'            wwv_flow_utilities.prepare_url(''f?p=4000:4406:''||:app_session',
'                    || '':::4406:P4406_COPY_FROM_THEME_ID,P4406_COPY_TO_THEME_ID,P4406_PLUGIN_TYPE,P4404_COPY_FROM:'' ',
'                    || x.theme_id || '','' || x.theme_id || '',TEMPLATE COMPONENT,'' || :FB_FLOW_ID ),',
'           null',
'        ) as action_link,',
'       tid,',
'       template_type,',
'       case when template_type = ''TEMPLATE_COMPONENT''',
'            then ''P''',
'            else ''F4000_P'' ',
'       end || edit_page || ''_ID'' as edit_item,',
'       --',
'       null action',
'from (  select ''POPUP_LOV'' template_type,',
'            upper(''Popup LOV'') upper_name,',
'            ''251'' edit_page,',
'            ''Popup LOV'' template_name,',
'            ''POPUP_LOV'' internal_name,',
'            case',
'                when plt.theme_id in (  select theme_id',
'                                        from wwv_flows',
'                                        where id = :fb_flow_id',
'                                          and security_group_id = :flow_security_group_id ) then 1',
'                else 0',
'            end reference_count,',
'            last_updated_on,',
'            last_updated_by,',
'            reference_id,',
'            case when reference_id is not null then',
'                coalesce ( ( select to_char( flow_id )',
'                               from wwv_flow_popup_lov_template',
'                              where id                = plt.reference_id',
'                                and security_group_id = :WORKSPACE_ID',
'                            ),',
'                            wwv_flow_lang.system_message( ''SUBSCRIBED_FROM.NONEXISTING_MASTER'' )',
'                         )',
'            end as subscribed_from,',
'            ( select case when count(*) > 0 then count(*) end',
'                from wwv_flow_popup_lov_template',
'               where reference_id      = plt.id',
'                 and security_group_id = :WORKSPACE_ID',
'            ) as subscribers,',
'            case',
'                when plt.theme_id in (  select theme_id',
'                                        from wwv_flows',
'                                        where id = :fb_flow_id',
'                                          and security_group_id = :flow_security_group_id ) then 1',
'                else 0',
'            end is_default,',
'            0 preview,',
'            theme_id,',
'            id tid',
'        from wwv_flow_popup_lov_template plt',
'        where plt.flow_id = :fb_flow_id',
'          and plt.security_group_id = :flow_security_group_id',
'        union all',
'        select ''CALENDAR'' template_type,',
'            upper(name) upper_name,',
'            ''697'' edit_page,',
'            name template_name,',
'            internal_name,',
'            (   select count(*)',
'                from wwv_flow_cals',
'                where template_id = c.id',
'                    and flow_id = :fb_flow_id',
'                    and security_group_id = :flow_security_group_id )',
'                + ( select count(*)',
'                    from wwv_flow_themes',
'                    where flow_id = :fb_flow_id',
'                        and security_group_id = :flow_security_group_id',
'                        and theme_id = c.theme_id',
'                        and default_calendar_template = c.id ) reference_count,',
'            last_updated_on,',
'            last_updated_by,',
'            reference_id,',
'            case when reference_id is not null then',
'                coalesce ( ( select to_char( flow_id )',
'                               from wwv_flow_cal_templates',
'                              where id                = c.reference_id',
'                                and security_group_id = :WORKSPACE_ID',
'                            ),',
'                            wwv_flow_lang.system_message( ''SUBSCRIBED_FROM.NONEXISTING_MASTER'' )',
'                         )',
'            end as subscribed_from,',
'            ( select case when count(*) > 0 then count(*) end',
'                from wwv_flow_cal_templates',
'               where reference_id      = c.id',
'                 and security_group_id = :WORKSPACE_ID',
'            ) as subscribers,',
'            (   select count(*)',
'                from wwv_flow_themes',
'                where flow_id = :fb_flow_id',
'                    and security_group_id = :flow_security_group_id',
'                    and theme_id = c.theme_id',
'                    and default_calendar_template = c.id ) is_default,',
'            0 preview,',
'            theme_id,',
'            id tid',
'        from wwv_flow_cal_templates c',
'        where c.flow_id = :fb_flow_id ',
'          and c.security_group_id = :flow_security_group_id',
'        union all',
'        select ''MENU'' template_type,',
'            upper(name) upper_name,',
'            ''289'' edit_page,',
'            name template_name,',
'            internal_name,',
'            (   select count(*)',
'                from wwv_flow_page_plugs r',
'                where r.flow_id = :fb_flow_id',
'                    and r.security_group_id = :flow_security_group_id',
'                    and r.menu_template_id = m.id )',
'                + ( select count(*)',
'                    from wwv_flow_themes',
'                    where flow_id = :fb_flow_id',
'                        and security_group_id = :flow_security_group_id',
'                        and theme_id = m.theme_id',
'                        and default_menu_template = m.id ) reference_count,',
'            last_updated_on,',
'            last_updated_by,',
'            reference_id,',
'            case when reference_id is not null then',
'                coalesce ( ( select to_char( flow_id )',
'                               from wwv_flow_menu_templates',
'                              where id                = m.reference_id',
'                                and security_group_id = :WORKSPACE_ID',
'                            ),',
'                            wwv_flow_lang.system_message( ''SUBSCRIBED_FROM.NONEXISTING_MASTER'' )',
'                         )',
'            end as subscribed_from,',
'            ( select case when count(*) > 0 then count(*) end',
'                from wwv_flow_menu_templates',
'               where reference_id      = m.id',
'                 and security_group_id = :WORKSPACE_ID',
'            ) as subscribers,',
'            (   select count(*)',
'                from wwv_flow_themes',
'                where flow_id = :fb_flow_id',
'                    and security_group_id = :flow_security_group_id',
'                    and theme_id = m.theme_id',
'                    and default_menu_template = m.id ) is_default,',
'            0 preview,',
'            theme_id,',
'            id tid',
'        from wwv_flow_menu_templates m',
'        where m.flow_id = :fb_flow_id   ',
'          and m.security_group_id = :flow_security_group_id',
'        union all',
'        select ''BUTTON'' template_type,',
'            upper(template_name) upper_name,',
'            ''204'' edit_page,',
'            template_name,',
'            internal_name,',
'            (   select count(*)',
'                from wwv_flow_step_buttons sb',
'                where sb.flow_id = :fb_flow_id',
'                    and sb.security_group_id = :flow_security_group_id',
'                    and sb.button_template_id = b.id )',
'                + ( select count(*)',
'                    from wwv_flow_step_items si',
'                    where flow_id = :fb_flow_id',
'                        and si.security_group_id = :flow_security_group_id',
'                        and si.TAG_ATTRIBUTES = ''template:''||to_char(b.id) )',
'                + ( select count(*)',
'                    from wwv_flow_themes',
'                    where flow_id = :fb_flow_id',
'                        and security_group_id = :flow_security_group_id',
'                        and theme_id = b.theme_id',
'                        and default_button_template = b.id ) reference_count,',
'            last_updated_on,',
'            last_updated_by,',
'            reference_id,',
'            case when reference_id is not null then',
'                coalesce ( ( select to_char( flow_id )',
'                               from wwv_flow_button_templates',
'                              where id                = b.reference_id',
'                                and security_group_id = :WORKSPACE_ID',
'                            ),',
'                            wwv_flow_lang.system_message( ''SUBSCRIBED_FROM.NONEXISTING_MASTER'' )',
'                         )',
'            end as subscribed_from,',
'            ( select case when count(*) > 0 then count(*) end',
'                from wwv_flow_button_templates',
'               where reference_id      = b.id',
'                 and security_group_id = :WORKSPACE_ID',
'            ) as subscribers,',
'            (   select count(*)',
'                from wwv_flow_themes',
'                where flow_id = :fb_flow_id',
'                    and security_group_id = :flow_security_group_id',
'                    and theme_id = b.theme_id',
'                    and default_button_template = b.id ) is_default,',
'            0 preview,',
'            theme_id,',
'            id tid',
'        from wwv_flow_button_templates b',
'        where b.flow_id = :fb_flow_id',
'          and b.security_group_id = :flow_security_group_id',
'        union all',
'        select ''LABEL'' template_type,',
'            upper(template_name) upper_name,',
'            ''85'' edit_page,',
'            template_name,',
'            internal_name,',
'            (   select count(*)',
'                from wwv_flow_step_items i',
'                where i.flow_id = :fb_flow_id',
'                    and i.security_group_id = :flow_security_group_id',
'                    and i.ITEM_FIELD_TEMPLATE = f.id )',
'                + ( select count(*)',
'                    from wwv_flow_themes',
'                    where flow_id = :fb_flow_id',
'                        and security_group_id = :flow_security_group_id',
'                        and theme_id = f.theme_id',
'                        and default_label_template = f.id ) reference_count,',
'            last_updated_on,',
'            last_updated_by,',
'            reference_id,',
'            case when reference_id is not null then',
'                coalesce ( ( select to_char( flow_id )',
'                               from wwv_flow_field_templates',
'                              where id                = f.reference_id',
'                                and security_group_id = :WORKSPACE_ID',
'                            ),',
'                            wwv_flow_lang.system_message( ''SUBSCRIBED_FROM.NONEXISTING_MASTER'' )',
'                         )',
'            end as subscribed_from,',
'            ( select case when count(*) > 0 then count(*) end',
'                from wwv_flow_field_templates',
'               where reference_id      = f.id',
'                 and security_group_id = :WORKSPACE_ID',
'            ) as subscribers,',
'            (   select count(*)',
'                from wwv_flow_themes',
'                where flow_id = :fb_flow_id',
'                    and security_group_id = :flow_security_group_id',
'                    and theme_id = f.theme_id',
'                    and default_label_template = f.id ) is_default,',
'            0 preview,',
'            theme_id,',
'            id tid',
'        from wwv_flow_field_templates f',
'        where f.flow_id = :fb_flow_id',
'          and f.security_group_id = :flow_security_group_id',
'        union all',
'        select ''LIST'' template_type,',
'            upper(list_template_name) upper_name,',
'            ''4655'' edit_page,',
'            l.list_template_name template_name,',
'            internal_name,',
'            (   select count(*)',
'                from wwv_flow_page_plugs p',
'                where p.flow_id = :fb_flow_id',
'                    and p.security_group_id = :flow_security_group_id',
'                    and p.list_template_id = l.id)',
'                + ( select count(*)',
'                    from wwv_flow_themes',
'                    where flow_id = :fb_flow_id',
'                        and security_group_id = :flow_security_group_id',
'                        and theme_id = l.theme_id',
'                        and default_list_template = l.id ) reference_count,',
'            last_updated_on,',
'            last_updated_by,',
'            reference_id,',
'            case when reference_id is not null then',
'                coalesce ( ( select to_char( flow_id )',
'                               from wwv_flow_list_templates',
'                              where id                = l.reference_id',
'                                and security_group_id = :WORKSPACE_ID',
'                            ),',
'                            wwv_flow_lang.system_message( ''SUBSCRIBED_FROM.NONEXISTING_MASTER'' )',
'                         )',
'            end as subscribed_from,',
'            ( select case when count(*) > 0 then count(*) end',
'                from wwv_flow_list_templates',
'               where reference_id      = l.id',
'                 and security_group_id = :WORKSPACE_ID',
'            ) as subscribers,',
'            (   select count(*)',
'                from wwv_flow_themes',
'                where flow_id = :fb_flow_id',
'                    and security_group_id = :flow_security_group_id',
'                    and theme_id = l.theme_id',
'                    and default_list_template = l.id ) is_default,',
'            0 preview,',
'            theme_id,',
'            id tid',
'        from wwv_flow_list_templates l',
'        where l.flow_id = :fb_flow_id',
'          and l.security_group_id = :flow_security_group_id',
'        union all',
'        select ''REPORT'' template_type,',
'            upper(row_template_name) upper_name,',
'            case when row_template_type = ''GENERIC_COLUMNS'' then ''258''',
'                else ''4654''',
'            end as edit_page,',
'            row_template_name template_name,',
'            internal_name,',
'            (   select count(*)',
'                from wwv_flow_page_plugs p',
'                where flow_id = :fb_flow_id',
'                    and p.security_group_id = :flow_security_group_id',
'                    and p.PLUG_QUERY_ROW_TEMPLATE = ro.id',
'                    and plug_source_type in (''NATIVE_SQL_REPORT'', ''NATIVE_TABFORM'') )',
'                + ( select count(*)',
'                    from wwv_flow_themes',
'                    where flow_id = :fb_flow_id',
'                        and security_group_id = :flow_security_group_id',
'                        and theme_id = ro.theme_id',
'                        and default_report_template = ro.id ) reference_count,',
'            last_updated_on,',
'            last_updated_by,',
'            reference_id,',
'            case when reference_id is not null then',
'                coalesce ( ( select to_char( flow_id )',
'                               from wwv_flow_row_templates',
'                              where id                = ro.reference_id',
'                                and security_group_id = :WORKSPACE_ID',
'                            ),',
'                            wwv_flow_lang.system_message( ''SUBSCRIBED_FROM.NONEXISTING_MASTER'' )',
'                         )',
'            end as subscribed_from,',
'            ( select case when count(*) > 0 then count(*) end',
'                from wwv_flow_row_templates',
'               where reference_id      = ro.id',
'                 and security_group_id = :WORKSPACE_ID',
'            ) as subscribers,',
'            (   select count(*)',
'                from wwv_flow_themes',
'                where flow_id = :fb_flow_id',
'                    and security_group_id = :flow_security_group_id',
'                    and theme_id = ro.theme_id',
'                    and default_report_template = ro.id ) is_default,',
'            ro.id preview,',
'            theme_id,',
'            id tid',
'        from wwv_flow_row_templates ro',
'        where ro.flow_id = :fb_flow_id',
'          and ro.security_group_id = :flow_security_group_id',
'        union all',
'        select ''PAGE'' template_type,',
'            upper(name) upper_name,',
'            ''4307'' edit_page,',
'            name template_name,',
'            internal_name,',
'            (   select count(*)',
'                from wwv_flow_steps s',
'                where flow_id = :fb_flow_id',
'                    and s.security_group_id = :flow_security_group_id',
'                    and s.step_template = p.id and s.id > 0 )',
'                + ( select count(*)',
'                    from wwv_flow_themes',
'                    where flow_id = :fb_flow_id',
'                        and security_group_id = :flow_security_group_id',
'                        and DEFAULT_PAGE_TEMPLATE = p.id )',
'                + ( select count(*)',
'                    from wwv_flow_themes',
'                    where flow_id = :fb_flow_id',
'                        and security_group_id = :flow_security_group_id',
'                        and error_template=p.id )',
'                + ( select count(*)',
'                    from wwv_flow_themes',
'                    where flow_id = :fb_flow_id',
'                        and security_group_id = :flow_security_group_id',
'                        and printer_friendly_template=p.id ) reference_count,',
'            last_updated_on,',
'            last_updated_by,',
'            reference_id,',
'            case when reference_id is not null then',
'                coalesce ( ( select to_char( flow_id )',
'                               from wwv_flow_templates',
'                              where id                = p.reference_id',
'                                and security_group_id = :WORKSPACE_ID',
'                            ),',
'                            wwv_flow_lang.system_message( ''SUBSCRIBED_FROM.NONEXISTING_MASTER'' )',
'                         )',
'            end as subscribed_from,',
'            ( select case when count(*) > 0 then count(*) end',
'                from wwv_flow_templates',
'               where reference_id      = p.id',
'                 and security_group_id = :WORKSPACE_ID',
'            ) as subscribers,',
'            (   select count(*)',
'                from wwv_flow_themes',
'                where flow_id = :fb_flow_id',
'                    and security_group_id = :flow_security_group_id',
'                    and DEFAULT_PAGE_TEMPLATE=p.id ) is_default,',
'            p.id preview,',
'            theme_id,',
'            id tid',
'        from wwv_flow_templates p',
'        where p.flow_id = :fb_flow_id',
'          and p.security_group_id = :flow_security_group_id',
'        union all',
'        select ''REGION'' template_type,',
'            upper(page_plug_template_name) upper_name,',
'            ''4653'' edit_page,',
'            page_plug_template_name template_name,',
'            internal_name,',
'            (   select count(*)',
'                from wwv_flow_page_plugs p',
'                where p.flow_id = :fb_flow_id',
'                    and p.security_group_id = :flow_security_group_id',
'                    and p.PLUG_TEMPLATE = r.id )',
'                + ( select count(*)',
'                    from wwv_flow_themes',
'                    where flow_id = :fb_flow_id',
'                        and security_group_id = :flow_security_group_id',
'                        and default_region_template = r.id ) reference_count,',
'            last_updated_on,',
'            last_updated_by,',
'            reference_id,',
'            case when reference_id is not null then',
'                coalesce ( ( select to_char( flow_id )',
'                               from wwv_flow_page_plug_templates',
'                              where id                = r.reference_id',
'                                and security_group_id = :WORKSPACE_ID',
'                            ),',
'                            wwv_flow_lang.system_message( ''SUBSCRIBED_FROM.NONEXISTING_MASTER'' )',
'                         )',
'            end as subscribed_from,',
'            ( select case when count(*) > 0 then count(*) end',
'                from wwv_flow_page_plug_templates',
'               where reference_id      = r.id',
'                 and security_group_id = :WORKSPACE_ID',
'            ) as subscribers,',
'            (   select count(*)',
'                from wwv_flow_themes',
'                where flow_id = :fb_flow_id',
'                    and security_group_id = :flow_security_group_id',
'                    and default_region_template = r.id ) is_default,',
'            r.id preview,',
'            theme_id,',
'            id tid',
'        from wwv_flow_page_plug_templates r',
'        where r.flow_id = :fb_flow_id',
'          and r.security_group_id = :flow_security_group_id',
'        union all',
'        select ''TEMPLATE_COMPONENT'' template_type,',
'            upper(name) upper_name,',
'            ''4410'' edit_page,',
'            builder_name template_name,',
'            name internal_name,',
'            ( select count(*)',
'                from wwv_flow_page_plugs r',
'               where r.flow_id           = :FB_FLOW_ID',
'                 and r.security_group_id = :WORKSPACE_ID',
'                 and r.plug_source_type  = p.used_name ) +',
'            ( select count(*)',
'                from wwv_flow_worksheet_columns c',
'               where c.flow_id           = :FB_FLOW_ID',
'                 and c.security_group_id = :WORKSPACE_ID',
'                 and c.display_text_as   = p.used_name ) as reference_count,',
'            last_updated_on,',
'            last_updated_by,',
'            reference_id,',
'            case when reference_id is not null then',
'                coalesce ( ( select to_char( flow_id )',
'                               from wwv_flow_template_components',
'                              where id                = p.reference_id',
'                                and security_group_id = :WORKSPACE_ID',
'                            ),',
'                            wwv_flow_lang.system_message( ''SUBSCRIBED_FROM.NONEXISTING_MASTER'' )',
'                         )',
'            end as subscribed_from,',
'            ( select case when count(*) > 0 then count(*) end',
'                from wwv_flow_template_components',
'               where reference_id      = p.id',
'                 and security_group_id = :WORKSPACE_ID',
'            ) as subscribers,',
'            0 is_default,',
'            p.id preview,',
'            theme_id,',
'            id tid',
'        from wwv_flow_template_components p',
'        where p.flow_id             = :FB_FLOW_ID',
'          and p.security_group_id   = :WORKSPACE_ID',
'          and p.theme_id            is not null',
'        ) x'))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(632908938554265910)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'Report returned no rows.'
,p_allow_report_categories=>'N'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'DAVID.GALE'
,p_internal_uid=>632908938554265910
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(632909046901265914)
,p_db_column_name=>'T'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Type'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(632909188428265916)
,p_db_column_name=>'UPPER_NAME'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'UPPER_NAME'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(632909261009265917)
,p_db_column_name=>'N'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Name'
,p_column_link=>'f?p=&APP_ID.:#EDIT_PAGE#:&SESSION.::&DEBUG.::#EDIT_ITEM#:#TID#'
,p_column_linktext=>'#N#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1004723783414877701)
,p_db_column_name=>'INTERNAL_NAME'
,p_display_order=>40
,p_column_identifier=>'T'
,p_column_label=>'Identifier'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(632909344233265917)
,p_db_column_name=>'C'
,p_display_order=>50
,p_column_identifier=>'D'
,p_column_label=>'References'
,p_column_link=>'f?p=&APP_ID.:707:&SESSION.::&DEBUG.:RP,707:P707_TEMPLATE_TYPE,P707_TEMPLATE,FB_FLOW_ID:#TEMPLATE_TYPE#,#TID#,&FB_FLOW_ID.:'
,p_column_linktext=>'#C#'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(632909463353265917)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>60
,p_column_identifier=>'E'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'Since'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(632909516469265917)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>70
,p_column_identifier=>'F'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1439515255838192553)
,p_db_column_name=>'SUBSCRIBED_FROM'
,p_display_order=>80
,p_column_identifier=>'R'
,p_column_label=>'Subscribed From'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1439515393018192553)
,p_db_column_name=>'SUBSCRIBERS'
,p_display_order=>90
,p_column_identifier=>'S'
,p_column_label=>'Subscribers'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(632909793905265917)
,p_db_column_name=>'IS_DEFAULT'
,p_display_order=>100
,p_column_identifier=>'H'
,p_column_label=>'Default'
,p_column_html_expression=>'<span class="a-Icon #DEFAULT_CSS#"><span class="u-VisuallyHidden">#IS_DEFAULT#</span></span>'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_column_alignment=>'CENTER'
,p_rpt_named_lov=>wwv_flow_imp.id(84259319526460470)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(632909905288265917)
,p_db_column_name=>'THEME'
,p_display_order=>120
,p_column_identifier=>'J'
,p_column_label=>'Theme'
,p_column_type=>'NUMBER'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1496798667970614)
,p_db_column_name=>'ACTION'
,p_display_order=>130
,p_column_identifier=>'V'
,p_column_label=>'Copy'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'TMPL_THEME_3$ACTIONS'
,p_column_alignment=>'CENTER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'ACTIONS_WRAP', 'N',
  'STYLE', 'b-InlineActions--simple')).to_clob
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(632910133471265917)
,p_db_column_name=>'TID'
,p_display_order=>140
,p_column_identifier=>'L'
,p_column_label=>'TID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(632910251959265917)
,p_db_column_name=>'TEMPLATE_TYPE'
,p_display_order=>150
,p_column_identifier=>'M'
,p_column_label=>'TEMPLATE_TYPE'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(632931763595526755)
,p_db_column_name=>'EDIT_PAGE'
,p_display_order=>160
,p_column_identifier=>'N'
,p_column_label=>'Edit Page'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(632931996059526757)
,p_db_column_name=>'DEFAULT_CSS'
,p_display_order=>170
,p_column_identifier=>'P'
,p_column_label=>'DEFAULT_CSS'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(632932033670526757)
,p_db_column_name=>'COPY_TEMPLATE_PAGE'
,p_display_order=>180
,p_column_identifier=>'Q'
,p_column_label=>'COPY_TEMPLATE_PAGE'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5401711291007017)
,p_db_column_name=>'EDIT_ITEM'
,p_display_order=>190
,p_column_identifier=>'U'
,p_column_label=>'Edit Item'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1497054378970617)
,p_db_column_name=>'ACTION_LINK'
,p_display_order=>210
,p_column_identifier=>'W'
,p_column_label=>'Action Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(632910390117265918)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'6329104'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_display_rows=>100
,p_report_columns=>'T:N:C:LAST_UPDATED_ON:LAST_UPDATED_BY:IS_DEFAULT:THEME:EDIT_ITEM:ACTION:ACTION_LINK'
,p_sort_column_1=>'T'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'N'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
,p_break_on=>'0:0:0:0:0'
,p_break_enabled_on=>'0:0:0:0:0'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(632918839326319900)
,p_plug_name=>'Hidden Items'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>5
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(632910504098265927)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(632908701274265897)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.:RP,RIR::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(632910717765265927)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(632908701274265897)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:162:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(202012917814047095)
,p_branch_action=>'f?p=&FLOW_ID.:4003:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(43234825947728509)
,p_name=>'P4003_THEME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(632918839326319900)
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Select a theme and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(138315008861842757)
,p_name=>'P4003_THEME_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(632918839326319900)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'  from wwv_flow_themes',
' where theme_id = :P4003_THEME',
'   and flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1723456652)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'4003'
,p_computation_error_message=>'Unable to compute item value.'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(21863143902)
,p_computation_sequence=>20
,p_computation_item=>'F4000_P4307_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'Unable to compute item value.'
,p_compute_when=>'wwv_flow.g_request = ''CREATE_TEMPLATE'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(561231806055585456)
,p_computation_sequence=>30
,p_computation_item=>'P4003_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>'select id from wwv_flow_themes where theme_id = :P4003_THEME and flow_id = :fb_flow_id'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(633078464849272660)
,p_name=>'Copy Template - Dialog Closed'
,p_event_sequence=>30
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(632908701274265897)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(633078744690272671)
,p_event_id=>wwv_flow_imp.id(633078464849272660)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(632908701274265897)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(285696016137584400)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create popup lov template if needed'
,p_process_sql_clob=>'insert into wwv_flow_popup_lov_template (id, flow_id) values (wwv_flow_id.next_val, :fb_flow_id);'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'select 1 from wwv_flow_popup_lov_template where flow_id=:fb_flow_id'
,p_process_when_type=>'NOT_EXISTS'
,p_process_success_message=>'Unable to create popup list of values template.'
,p_internal_uid=>285696016137584400
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(19424430567592003)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'rp'
,p_attribute_01=>'THIS_PAGE'
,p_process_when=>'GO'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>19424430567592003
);
wwv_flow_imp_page.create_component_action(
 p_id=>wwv_flow_imp.id(1496897325970615)
,p_ir_column_id=>wwv_flow_imp.id(1496798667970614)
,p_position_id=>wwv_flow_imp.id(214437533860142316)
,p_display_sequence=>10
,p_template_id=>wwv_flow_imp.id(214438625365151034)
,p_label=>'Copy'
,p_link_target_type=>'REDIRECT_URL'
,p_link_target=>'#ACTION_LINK#'
,p_button_display_type=>'ICON'
,p_icon_css_classes=>'icon-copy'
,p_is_hot=>false
,p_show_as_disabled=>false
);
end;
/
prompt --application/pages/page_04004
begin
wwv_flow_imp_page.create_page(
 p_id=>4004
,p_name=>'Create List of Values - Name and Type'
,p_alias=>'CREATE-LIST-OF-VALUES-NAME-AND-TYPE'
,p_page_mode=>'MODAL'
,p_step_title=>'Create List of Values'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213211113434774960)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_lov.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(687482810)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(161740513874429436)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(130739713201)
,p_plug_name=>'Create List of Values'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_header=>'<p>Static lists are based on predefined pairs of display and return values. Dynamic lists are based on a dynamic data source of either Local Database, REST Enabled SQL, or REST Data Source.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44764721724095169)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(130743766434)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(44764721724095169)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(130749204700)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(44764721724095169)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(202915620672933903)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(44764721724095169)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(130750206521)
,p_branch_action=>'4080'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(130749204700)
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':F4000_P4004_TYPE = ''DYNAMIC'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(130753229524)
,p_branch_action=>'4014'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(130749204700)
,p_branch_sequence=>20
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':F4000_P4004_TYPE = ''STATIC'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(102180411308120840)
,p_branch_action=>'f?p=&FLOW_ID.:4004:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(202916028815933908)
,p_branch_action=>'137'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(202915620672933903)
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(130741728686)
,p_name=>'F4000_P4004_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(130739713201)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Name the list of values.  This name will be used when you wish to reference this shared list of values.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(130742754228)
,p_name=>'F4000_P4004_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(130739713201)
,p_prompt=>'Type:'
,p_source=>'DYNAMIC'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Dynamic;DYNAMIC,Static;STATIC'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select a type of list of values.</p>',
'<ul>',
'    <li>A <strong>Dynamic</strong> list of values defines a Data Source of either Local Database, REST Enabled SQL, or REST Data Source.</li>',
'    <li>A <strong>Static</strong> list of values is based on predefined display and return values.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(130802786435)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P4004_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(:F4000_P4004_NAME)'
,p_computation_error_message=>'Unable to compute item value.'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(130754234970)
,p_validation_name=>'name required'
,p_validation_sequence=>10
,p_validation=>'F4000_P4004_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'List of values name must be specified.'
,p_associated_item=>wwv_flow_imp.id(130741728686)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'fires every time'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(78599008311958813)
,p_validation_name=>'NameNotExists'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''x''',
'  from WWV_FLOW_LISTS_OF_VALUES$',
' where flow_id = :FB_FLOW_ID ',
'   and upper(lov_name) = upper(:F4000_P4004_NAME)'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'This name is already used. Enter another name.'
,p_validation_condition=>'F4000_P4004_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(130749204700)
,p_associated_item=>wwv_flow_imp.id(130741728686)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(574039095424616921)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(130743766434)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(574039138350616922)
,p_event_id=>wwv_flow_imp.id(574039095424616921)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_04005
begin
wwv_flow_imp_page.create_page(
 p_id=>4005
,p_name=>'Classic Navigation Bar Entries'
,p_alias=>'CLASSIC-NAVIGATION-BAR-ENTRIES'
,p_step_title=>'Classic Navigation Bar Entries'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213263531591941060)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'nav_navbar.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(340509358)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--sideRegion:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Navigation Bar Entries provide hypertext link based navigation.  Placement is determined by page templates.</p>'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(48422127180609962)
,p_plug_name=>'Classic Navigation Bar Entries'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       icon_sequence,',
'       icon_image,',
'       substr(icon_target,1,20) icon_target,',
'       ICON_SUBTEXT,',
'       substr(ICON_IMAGE_ALT,1,20) iia,',
'       nvl(begins_on_new_line,''NO'') begins_on_new_line, ',
'       cell_colspan,',
'       (select p.patch_name',
'          from wwv_flow_patches p',
'         where p.id = ib.required_patch',
'           and p.security_group_id = ib.security_group_id',
'         union all',
'        select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'',patch_name)|| ''} '' ',
'        patch_name ',
'          from wwv_flow_patches p',
'         where 0-p.id = ib.required_patch',
'           and p.security_group_id = ib.security_group_id ) required_patch,',
'       icon_bar_disp_cond_type,',
'       ''icon-sc-nav-bar'' as icon_class,',
'       substr(ICON_IMAGE_ALT,1,20) img_alt,',
'       wwv_flow_utilities.prepare_url(',
'           p_url => ''f?p=4000:4308:''||:app_session||''::::F4000_P4308_ID:''||id',
'       ) as icon_link,',
'       sys.htf.escape_sc(substr(nvl(ICON_IMAGE_ALT,icon_subtext),1,20)) icon_title,',
'--',
'       ICON_BAR_DISP_COND_TYPE display_condition,',
'       ICON_BAR_DISP_COND display_expression1,',
'       ICON_BAR_FLOW_COND_INSTR display_expression2,',
'       case when ib.reference_id is not null then',
'           coalesce ( ( select to_char( flow_id )',
'                          from wwv_flow_icon_bar',
'                         where id                = ib.reference_id',
'                           and security_group_id = :WORKSPACE_ID',
'                       ),',
'                       wwv_flow_lang.system_message( ''SUBSCRIBED_FROM.NONEXISTING_MASTER'' )',
'                    )',
'       end as subscribed_from,',
'       ( select case when count(*) > 0 then count(*) end',
'           from wwv_flow_icon_bar',
'          where reference_id      = ib.id',
'            and security_group_id = :WORKSPACE_ID',
'       ) as subscribers,',
'       --',
'       null as action',
'  from wwv_flow_icon_bar ib',
' where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(48422219241609962)
,p_name=>'Navigation Bar Entries'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#ICON_LINK#" class="a-IRR-icon"><span class="a-Icon #ICON_CLASS#"></span><span class="a-IRR-iconName">#ICON_TITLE#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(48422515012609987)
,p_db_column_name=>'ICON_SEQUENCE'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>'Sequence'
,p_column_link=>'f?p=&APP_ID.:4308:&SESSION.::&DEBUG.::F4000_P4308_ID:#ID#'
,p_column_linktext=>'#ICON_SEQUENCE#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(48422624388609987)
,p_db_column_name=>'ICON_IMAGE'
,p_display_order=>2
,p_column_identifier=>'C'
,p_column_label=>'Image'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(48422731746609988)
,p_db_column_name=>'ICON_TARGET'
,p_display_order=>3
,p_column_identifier=>'D'
,p_column_label=>'Target'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(48422800668609988)
,p_db_column_name=>'ICON_SUBTEXT'
,p_display_order=>4
,p_column_identifier=>'E'
,p_column_label=>'Text'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(48422905137609989)
,p_db_column_name=>'IIA'
,p_display_order=>5
,p_column_identifier=>'F'
,p_column_label=>'ALT Tag'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(48423025368609989)
,p_db_column_name=>'BEGINS_ON_NEW_LINE'
,p_display_order=>6
,p_column_identifier=>'G'
,p_column_label=>'New Line'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(48423128036609990)
,p_db_column_name=>'CELL_COLSPAN'
,p_display_order=>7
,p_column_identifier=>'H'
,p_column_label=>'Column Span'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(48422416666609982)
,p_db_column_name=>'ID'
,p_display_order=>8
,p_column_identifier=>'A'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(48423307220609990)
,p_db_column_name=>'ICON_BAR_DISP_COND_TYPE'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Display When'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(13602414170805697)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(48423707986618818)
,p_db_column_name=>'IMG_ALT'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Img Alt'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(48482610105271026)
,p_db_column_name=>'REQUIRED_PATCH'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'Build Option'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(188126009288942306)
,p_db_column_name=>'DISPLAY_CONDITION'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Display Condition'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(188126127927942308)
,p_db_column_name=>'DISPLAY_EXPRESSION1'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Display Expression1'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(188126221924942309)
,p_db_column_name=>'DISPLAY_EXPRESSION2'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Display Expression2'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(655681192100026496)
,p_db_column_name=>'ICON_CLASS'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Icon Class'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(655681225030026496)
,p_db_column_name=>'ICON_LINK'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>'Icon Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(655681392222026496)
,p_db_column_name=>'ICON_TITLE'
,p_display_order=>22
,p_column_identifier=>'V'
,p_column_label=>'Icon Title'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1340562500119198335)
,p_db_column_name=>'SUBSCRIBED_FROM'
,p_display_order=>32
,p_column_identifier=>'W'
,p_column_label=>'Subscribed From'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1340562676523198336)
,p_db_column_name=>'SUBSCRIBERS'
,p_display_order=>42
,p_column_identifier=>'X'
,p_column_label=>'Subscribers'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1498557284970632)
,p_db_column_name=>'ACTION'
,p_display_order=>52
,p_column_identifier=>'Y'
,p_column_label=>'Copy'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'TMPL_THEME_3$ACTIONS'
,p_column_alignment=>'CENTER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'ACTIONS_WRAP', 'N',
  'STYLE', 'b-InlineActions--simple')).to_clob
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(48424005315623443)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_type=>'REPORT'
,p_report_alias=>'1294422797536645'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_view_mode=>'ICON'
,p_report_columns=>'ICON_SEQUENCE:ICON_IMAGE:ICON_TARGET:ICON_SUBTEXT:ICON_CLASS:ICON_LINK:ICON_TITLE:SUBSCRIBED_FROM:SUBSCRIBERS:ACTION'
,p_sort_column_1=>'ICON_SEQUENCE'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(166777223986878260)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(166766500720858594)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Classic Navigation Bar'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(188984527877899901)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(48422127180609962)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4005:&SESSION.::&DEBUG.:4005,RIR::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2181157969145901)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(48422127180609962)
,p_button_name=>'COPY'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Copy'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:485:&SESSION.::&DEBUG.:485::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(90844120863363156)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(48422127180609962)
,p_button_name=>'create'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:22:&SESSION.::&DEBUG.:22,4023,4024,4025,134,135::'
,p_icon_css_classes=>'icon-right-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1724511323)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_FOOTER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'4005'
,p_computation_error_message=>'Unable to compute item value.'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(21866143906)
,p_computation_sequence=>20
,p_computation_item=>'F4000_P4308_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'Unable to compute item value.'
,p_compute_when=>'wwv_flow.g_request = ''CREATE_ICON'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(590028931373069351)
,p_name=>'Create Button - Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(90844120863363156)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(590029226438069352)
,p_event_id=>wwv_flow_imp.id(590028931373069351)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_component_action(
 p_id=>wwv_flow_imp.id(1498626283970633)
,p_ir_column_id=>wwv_flow_imp.id(1498557284970632)
,p_position_id=>wwv_flow_imp.id(214437533860142316)
,p_display_sequence=>10
,p_template_id=>wwv_flow_imp.id(214438625365151034)
,p_label=>'Copy'
,p_link_target_type=>'REDIRECT_PAGE'
,p_link_target=>'f?p=&APP_ID.:485:&SESSION.::&DEBUG.:485:P485_ID:#ID#'
,p_button_display_type=>'ICON'
,p_icon_css_classes=>'icon-copy'
,p_is_hot=>false
,p_show_as_disabled=>false
);
end;
/
prompt --application/pages/page_04006
begin
wwv_flow_imp_page.create_page(
 p_id=>4006
,p_name=>'Text Messages'
,p_alias=>'TEXT-MESSAGES'
,p_step_title=>'Text Messages'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213331522315193801)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'global_messages.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9403198943966172)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(4604973800825488)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(34137624724696512)
,p_plug_name=>'Text Messages'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select m.id,',
'       m.name,',
'       m.message_language,',
'       substr(m.message_text,1,1000) message_text,',
'       length(m.message_text) message_length,',
'       m.is_js_message,',
'       nvl(nvl(m.last_updated_on,j.min_date),m.created_on) last_updated_on,       ',
'       m.last_updated_by,',
'       --',
'       case when m.reference_id is not null then',
'           coalesce ( to_char( master.flow_id ),',
'                       wwv_flow_lang_dev.builder_message( ''SUBSCRIBED_FROM.NONEXISTING_MASTER'' ) )',
'       end as subscribed_from,',
'       ( select case when count(*) > 0 then count(*) end',
'           from wwv_flow_messages$ sub',
'          where sub.reference_id      = m.id',
'            and sub.security_group_id = :FLOW_SECURITY_GROUP_ID',
'       ) as subscribers,',
'       case when m.reference_id is not null then',
'           case',
'               when master.version_scn = m.version_scn then',
'                   wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_UP_TO_DATE'')',
'               when master.version_scn != m.version_scn then',
'                   wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_NEEDS_REFRESH'')',
'               else',
'                   wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_UNKNOWN'')',
'           end',
'       end subscription_status,     ',
'       --',
'       null as actions',
'  from wwv_flow_messages$ m,',
'      ( select min(min_date) min_date from (',
'            select min(last_updated_on) min_date from wwv_flow_steps where flow_id = :FB_FLOW_ID and security_group_id = :FLOW_SECURITY_GROUP_ID and last_updated_on is not null',
'            union all',
'            select min(last_updated_on) min_date from wwv_flow_templates where flow_id = :FB_FLOW_ID and security_group_id = :FLOW_SECURITY_GROUP_ID and last_updated_on is not null',
'            union all',
'            select min(last_updated_on) min_date from wwv_flow_tabs where flow_id = :FB_FLOW_ID and security_group_id = :FLOW_SECURITY_GROUP_ID and last_updated_on is not null',
'            union all',
'            select min(last_updated_on) min_date from wwv_flow_step_items where flow_id = :FB_FLOW_ID and security_group_id = :FLOW_SECURITY_GROUP_ID and last_updated_on is not null ) ) j,',
'       wwv_flow_messages$ master',
' where m.flow_id           = :FB_FLOW_ID',
'   and m.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and m.reference_id      = master.id (+)',
'   and m.security_group_id = master.security_group_id (+)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(34137717780696512)
,p_name=>'Text Messages'
,p_max_row_count=>'100000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No text messages found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(34138005352696522)
,p_db_column_name=>'NAME'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>'Name'
,p_column_link=>'f?p=&APP_ID.:4009:&SESSION.::&DEBUG.::F4000_P4009_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(34138122795696522)
,p_db_column_name=>'MESSAGE_LANGUAGE'
,p_display_order=>2
,p_column_identifier=>'C'
,p_column_label=>'Language'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(34138212632696522)
,p_db_column_name=>'MESSAGE_TEXT'
,p_display_order=>3
,p_column_identifier=>'D'
,p_column_label=>'Text'
,p_column_html_expression=>'<span lang="#MESSAGE_LANGUAGE!ATTR#">#MESSAGE_TEXT#</span>'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1119156409779390627)
,p_db_column_name=>'IS_JS_MESSAGE'
,p_display_order=>13
,p_column_identifier=>'G'
,p_column_label=>'Used in JavaScript'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_column_alignment=>'CENTER'
,p_rpt_named_lov=>wwv_flow_imp.id(84259319526460470)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(34137908525696519)
,p_db_column_name=>'ID'
,p_display_order=>23
,p_column_identifier=>'A'
,p_column_label=>'&nbsp;'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(34138419478696523)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>33
,p_column_identifier=>'F'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(34138318878696523)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>43
,p_column_identifier=>'E'
,p_column_label=>'Date'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(100574748500284405)
,p_db_column_name=>'MESSAGE_LENGTH'
,p_display_order=>53
,p_column_identifier=>'H'
,p_column_label=>'Text Length'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4487911983954433)
,p_db_column_name=>'SUBSCRIBED_FROM'
,p_display_order=>63
,p_column_identifier=>'I'
,p_column_label=>'Subscribed From'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4488003322954434)
,p_db_column_name=>'SUBSCRIBERS'
,p_display_order=>73
,p_column_identifier=>'J'
,p_column_label=>'Subscribers'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(6610967221558814)
,p_db_column_name=>'SUBSCRIPTION_STATUS'
,p_display_order=>93
,p_column_identifier=>'L'
,p_column_label=>'Subscription Status'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2181450298145904)
,p_db_column_name=>'ACTIONS'
,p_display_order=>103
,p_column_identifier=>'M'
,p_column_label=>'Copy'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'TMPL_THEME_3$ACTIONS'
,p_column_alignment=>'CENTER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'ACTIONS_WRAP', 'N',
  'STYLE', 'b-InlineActions--simple')).to_clob
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(34138618393696778)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1294505505536645'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'NAME:MESSAGE_LANGUAGE:MESSAGE_TEXT:MESSAGE_LENGTH:IS_JS_MESSAGE:SUBSCRIBED_FROM:SUBSCRIPTION_STATUS:SUBSCRIBERS:LAST_UPDATED_BY:LAST_UPDATED_ON::ACTIONS'
,p_sort_column_1=>'NAME'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'MESSAGE_LANGUAGE'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'LAST_UPDATED_ON'
,p_sort_direction_3=>'DESC'
,p_sort_column_4=>'LAST_UPDATED_BY'
,p_sort_direction_4=>'DESC NULLS LAST'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(80185705259241013)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Text Messages can be used to build translatable text strings with substitution variables that can be called from PL/SQL packages, procedures, and functions.</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(188997218470143208)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(34137624724696512)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4006:&SESSION.::&DEBUG.:4006,RIR::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(10062428169696797)
,p_button_sequence=>35
,p_button_plug_id=>wwv_flow_imp.id(34137624724696512)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Text Message'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4009:&SESSION.::&DEBUG.:4009:P4009_MESSAGE_LANGUAGE:&P4009_MESSAGE_LANGUAGE.'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(540750630)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'4006'
,p_computation_error_message=>'Unable to compute item value.'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(495331285)
,p_computation_sequence=>20
,p_computation_item=>'F4000_P4009_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'Unable to compute item value.'
,p_compute_when=>'CREATE_ROW'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(590088996202411698)
,p_name=>'Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(34137624724696512)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(982214740538928401)
,p_event_id=>wwv_flow_imp.id(590088996202411698)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(34137624724696512)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6650208898990003)
,p_name=>'Refresh Subscriptions'
,p_event_sequence=>20
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(9403198943966172)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6650687537990005)
,p_event_id=>wwv_flow_imp.id(6650208898990003)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(34137624724696512)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6651173314990005)
,p_event_id=>wwv_flow_imp.id(6650208898990003)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ( this.data.successMessage ) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
);
wwv_flow_imp_page.create_component_action(
 p_id=>wwv_flow_imp.id(2181595724145905)
,p_ir_column_id=>wwv_flow_imp.id(2181450298145904)
,p_position_id=>wwv_flow_imp.id(214437533860142316)
,p_display_sequence=>10
,p_template_id=>wwv_flow_imp.id(214438625365151034)
,p_label=>'Copy'
,p_link_target_type=>'REDIRECT_PAGE'
,p_link_target=>'f?p=&APP_ID.:4007:&SESSION.::&DEBUG.:4007:P4007_COPY_SOURCE,P4007_ID,P4007_COPY_FROM_APPLICATION_ID:THIS,#ID#,&FB_FLOW_ID.'
,p_button_display_type=>'ICON'
,p_icon_css_classes=>'icon-copy'
,p_is_hot=>false
,p_show_as_disabled=>false
);
end;
/
prompt --application/pages/page_04007
begin
wwv_flow_imp_page.create_page(
 p_id=>4007
,p_name=>'Copy Text Message'
,p_alias=>'COPY-TEXT-MESSAGE'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Text Message'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'auto'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_protection_level=>'C'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(65360676714501009)
,p_plug_name=>'Wizard Button'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(250101659362643898)
,p_plug_name=>'Copy Text Message'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7127874484085751)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(65360676714501009)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4411568177904118)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(65360676714501009)
,p_button_name=>'COPY_FROM_ANOTHER'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Copy from another app'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:4007:&SESSION.::&DEBUG.:4007:P4007_COPY_SOURCE:OTHER'
,p_button_condition=>'P4007_COPY_SOURCE'
,p_button_condition2=>'THIS'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_button_css_classes=>'a-Button--noUI'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7128209556085754)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(65360676714501009)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy Text Message'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(7141237971085813)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(7128209556085754)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4487834446954432)
,p_name=>'P4007_MESSAGE_LANGUAGE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(250101659362643898)
,p_item_default=>'&BROWSER_LANGUAGE.'
,p_prompt=>'Language'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_LANGUAGES_LOCALES'
,p_lov=>'.'||wwv_flow_imp.id(107899321117195063)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a language for which this message will be used.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18938024591834837)
,p_name=>'P4007_NEW_MESSAGE_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(250101659362643898)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33945421292626050)
,p_name=>'P4007_SUBSCRIBE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(250101659362643898)
,p_item_default=>'Y'
,p_prompt=>'Subscribe'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>'P4007_COPY_SOURCE'
,p_display_when2=>'OTHER'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'While copying the text message, you can also subscribe to it. Set Subscribe to <strong>On</strong> to subscribe to the text message.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(34245020095704647)
,p_name=>'P4007_COPY_SOURCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(250101659362643898)
,p_item_default=>'THIS'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(230613178262566433)
,p_name=>'P4007_COPY_FROM_APPLICATION_ID'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(250101659362643898)
,p_prompt=>'Application'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST OTHER FLOWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'  from   wwv_flow_visible_flows f',
' where id != :FB_FLOW_ID',
'   and build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'order by 2'))
,p_lov_cascade_parent_items=>'P4007_COPY_SOURCE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>'P4007_COPY_SOURCE'
,p_display_when2=>'OTHER'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Select the application from which you want to copy a text message.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(250123679621683817)
,p_name=>'P4007_NAME'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(250101659362643898)
,p_prompt=>'New Text Message Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the name of the text message. For a selected language, the text message name must be unique within the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_attribute_06=>'UPPER'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(250126995897688523)
,p_name=>'P4007_ID'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(250101659362643898)
,p_prompt=>'Copy Text Message'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name || '' ( '' || message_language || '' )'' d, id r',
'  from wwv_flow_messages$',
' where flow_id           = :P4007_COPY_FROM_APPLICATION_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
' order by upper( name )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Text Message -'
,p_lov_cascade_parent_items=>'P4007_COPY_FROM_APPLICATION_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_read_only_when=>'P4007_ID'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify a text message to copy.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'Y'
,p_attribute_06=>'0'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(7133519427085803)
,p_validation_name=>'P4007_NAME not null'
,p_validation_sequence=>10
,p_validation=>'P4007_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>':P4007_COPY_SOURCE = ''THIS'' or :P4007_SUBSCRIBE = ''N'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(7128209556085754)
,p_associated_item=>wwv_flow_imp.id(250123679621683817)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(7133921310085804)
,p_validation_name=>'P4007_NAME unique'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_messages$',
' where name              = :P4007_NAME',
'   and message_language  = :P4007_MESSAGE_LANGUAGE',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'For the selected language, a text message with the same name already exists. Please enter a different name.'
,p_validation_condition=>':P4007_COPY_SOURCE = ''THIS'' or :P4007_SUBSCRIBE = ''N'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(7128209556085754)
,p_associated_item=>wwv_flow_imp.id(250123679621683817)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(7134320422085804)
,p_validation_name=>'No duplicate subscription'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_messages$',
' where security_group_id = :FLOW_SECURITY_GROUP_ID ',
'   and flow_id           = :FB_FLOW_ID ',
'   and reference_id      = :P4007_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'There is another text message in this application that is subscribed to the same master. Please select another master text message.'
,p_validation_condition=>'P4007_SUBSCRIBE'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(7128209556085754)
,p_associated_item=>wwv_flow_imp.id(250126995897688523)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(7135495738085806)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(7127874484085751)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7135954559085808)
,p_event_id=>wwv_flow_imp.id(7135495738085806)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(7139799674085811)
,p_name=>'On Change of P4007_SUBSCRIBE'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4007_SUBSCRIBE'
,p_condition_element=>'P4007_SUBSCRIBE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_cond=>'P4007_COPY_SOURCE'
,p_display_when_cond2=>'OTHER'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7140211915085812)
,p_event_id=>wwv_flow_imp.id(7139799674085811)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4007_NAME,P4007_MESSAGE_LANGUAGE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7140761889085812)
,p_event_id=>wwv_flow_imp.id(7139799674085811)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4007_NAME,P4007_MESSAGE_LANGUAGE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4411682197904119)
,p_name=>'Copy Name and Language'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4007_ID'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_cond=>'P4007_COPY_SOURCE'
,p_display_when_cond2=>'OTHER'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4411712553904120)
,p_event_id=>wwv_flow_imp.id(4411682197904119)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4007_MESSAGE_LANGUAGE,P4007_NAME'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select message_language, name',
'  from wwv_flow_messages$',
' where flow_id           = :P4007_COPY_FROM_APPLICATION_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and id                = :P4007_ID'))
,p_attribute_07=>'P4007_ID'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(7135089756085805)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Text Message'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P4007_NEW_MESSAGE_ID := wwv_flow_copy_metadata.copy_component (',
'    p_component_type       => wwv_flow_copy_metadata.c_message,',
'    p_from_id              => :P4007_ID,',
'    p_from_app_id          => :P4007_COPY_FROM_APPLICATION_ID,',
'    p_to_app_id            => :FB_FLOW_ID,',
'    p_new_name             => :P4007_NAME,',
'    p_additional_col       => :P4007_MESSAGE_LANGUAGE,',
'    p_subscribe            => :P4007_SUBSCRIBE = ''Y'' );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to copy the text message.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(7128209556085754)
,p_process_success_message=>'Text Message copied.'
,p_internal_uid=>7135089756085805
);
end;
/
prompt --application/pages/page_04008
begin
wwv_flow_imp_page.create_page(
 p_id=>4008
,p_name=>'Edit Authorization Scheme'
,p_alias=>'EDIT-AUTHORIZATION-SCHEME'
,p_step_title=>'Edit Authorization Scheme'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213425326892450628)
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_read_only_when=>'F4000_P4008_REFERENCE_ID'
,p_help_text=>'sec_authorization.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4584513380)
,p_plug_name=>'Name'
,p_region_name=>'NAME'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'generated 09-DEC-2000 21:06:40'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4632583063)
,p_plug_name=>'Authorization Schemes'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Authorization schemes enable you to protect applications, pages, and application components and extend the security provided by your application authentication scheme. You can use authorization schemes to identify additional security beyond simple'
||' user authentication. For example, a user with administration rights may need access to more navigation bar icons, pages, and tabs than other users.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(294253922620)
,p_plug_name=>'Comments'
,p_region_name=>'COMMENTS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1905880147054614)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(2513428566412576)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(10863417384563609)
,p_plug_name=>'Add Javascript code for Plugins'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>70
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    -- create the onChange event for the F4000_P4008_SCHEME_TYPE and',
'    -- also the initialization code for the dynamic attributes',
'    wwv_flow_plugin_dev.add_onload_code (',
'        p_plugin_type         => wwv_flow_plugin.c_plugin_type_authorization,',
'        p_type_page_item_name => ''F4000_P4008_SCHEME_TYPE'',',
'        p_page_item_prefix    => ''P4008_'' );',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11219919761952850)
,p_plug_name=>'Anchors'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>90
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(33435410681829163)
,p_plug_name=>'Subscription'
,p_region_name=>'SUBSCRIPTION'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'F4000_P4008_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'WWV_FLOW_SECURITY_SCHEMES',
  'attribute_02', 'NAME',
  'attribute_03', 'F4000_P4008_ID',
  'attribute_04', 'F4000_P4008_REFERENCE_ID',
  'attribute_05', 'SUBSCRIBE_AUTHORIZATION',
  'attribute_06', 'VERSION_SCN')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(72150497869212519)
,p_plug_name=>'Evaluation Point'
,p_region_name=>'EVALUATION_POINT'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(91255107460444101)
,p_plug_name=>'Authorization Scheme'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(178678919656730458)
,p_plug_name=>'Authorization Scheme'
,p_region_name=>'AUTHORIZATION_SCHEME'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(620052903566430673)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(29434107863295859)
,p_plug_display_sequence=>60
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from WWV_FLOW_SECURITY_SCHEMES',
'where id = :F4000_P4008_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :F4000_P4008_ID,',
'      p_component_type => ''Application Item'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'F4000_P4008_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(178753331280914744)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(33435410681829163)
,p_button_name=>'PUBLISH_SECURITY'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Publish Scheme'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.:149:F4000_P149_ID,F4000_P149_PAGE_ID,F4000_P149_TEMPLATE_TYPE:&F4000_P4008_ID.,&FLOW_PAGE_ID.,AUTHORIZATION'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
' from wwv_flow_security_schemes',
'where reference_id      = :F4000_P4008_ID',
'  and security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5729293382070707)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(33435410681829163)
,p_button_name=>'UNSUBSCRIBE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Unsubscribe'
,p_button_position=>'CLOSE'
,p_button_condition=>':F4000_P4008_REFERENCE_ID is not null and :P4008_SUBSCRIBED_COMP_GRP = ''N'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(178748029417904765)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(33435410681829163)
,p_button_name=>'REFRESH_SCHEME'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Refresh Scheme'
,p_button_position=>'CLOSE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P4008_REFERENCE_ID is not null ',
'and ( :F4000_P4008_VERSION_SCN != :F4000_P4008_MASTER_VERSION_SCN or :F4000_P4008_VERSION_SCN is null )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4587513390)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(91255107460444101)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4589513394)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(91255107460444101)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
,p_button_execute_validations=>'N'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P4008_ID is not null ',
'and ( :F4000_P4008_REFERENCE_ID is null or :P4008_SUBSCRIBED_COMP_GRP = ''N'' )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4591513394)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(91255107460444101)
,p_button_name=>'ApplyChanges'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    :F4000_P4008_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4593513395)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(91255107460444101)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P4008_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(178780115996990463)
,p_branch_name=>'Go To Page 4008'
,p_branch_action=>'f?p=&APP_ID.:4008:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(178748029417904765)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4581513379)
,p_branch_name=>'Go To Page 4070'
,p_branch_action=>'f?p=&APP_ID.:4070:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4595513396)
,p_name=>'F4000_P4008_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(4584513380)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4599513401)
,p_name=>'F4000_P4008_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(4584513380)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Application:'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LIST FLOWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'where  build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'order by 2'))
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'This attribute identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4601513402)
,p_name=>'F4000_P4008_NAME'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(4584513380)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter an unique name that identifies this authorization scheme.</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4603513404)
,p_name=>'F4000_P4008_SCHEME_TYPE'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(178678919656730458)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Scheme Type'
,p_source=>'SCHEME_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'AUTHORIZATION TYPE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,',
'       r',
'  from (',
'        select wwv_flow_lang.system_message(''AUTHORIZATION_NAME.''|| name_with_prefix) as d,',
'               name_with_prefix      as r',
'          from wwv_flow_native_plugins',
'         where plugin_type = ''AUTHORIZATION TYPE''',
'         union all',
'        select display_name || wwv_flow_lang.system_message(''PLUGIN.DISPLAY_NAME_POSTFIX'') as d,',
'               ''PLUGIN_'' || name     as r',
'          from wwv_flow_plugins',
'         where flow_id           = to_number(:FB_FLOW_ID)',
'           and security_group_id = to_number(:WORKSPACE_ID)',
'           and plugin_type       = ''AUTHORIZATION TYPE''',
'       )',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select a Scheme Type -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select how this authorization scheme will be applied. The following built-in types are supported:</p>',
'<ul>',
'<li><strong>Exists SQL Query:</strong> A query that causes the authorization scheme to pass if it returns at least one row and causes the scheme to fail if it returns no rows</li>',
'<li><strong>NOT Exists SQL Query:</strong> A query that causes the authorization scheme to pass if it returns no rows and causes the scheme to fail if it returns one or more rows</li>',
'<li><strong>PL/SQL Function Returning Boolean:</strong> A PL/SQL function body that returns true or false. A false value causes the authorization scheme to fail. A true value causes it to pass.</li>',
'<li><strong>Item in Expression 1 is null:</strong> Value of item named in expression 1 is null.</li>',
'<li><strong>Item in Expression 1 is not null:</strong> Value of item named in expression 1 is not null.</li>',
'<li><strong>Value of Preference in Expression 1 Equals Expression 2:</strong> Value of preference named in expression 1 equals expression 2.</li>',
'<li><strong>Value of Preference in Expression 1 Does Not Equal Expression 2:</strong> Value of preference named in expression 1 does not equal expression 2.</li>',
'<li><strong>Value of Item in Expression 1 Equals Expression 2:</strong> Value of item named in expression 1 equals expression 2.</li>',
'<li><strong>Value of Item in Expression 1 Does NOT Equal Expression 2:</strong> Value of item named in expression 1 does not equal expression 2.</li>',
'<li><strong>Is In Role or Group:</strong> Checks the provided comma-separated roles/groups names against the user''s roles/groups for which the source is configured with the application security attribute <strong>Source for Role or Group Schemes</stro'
||'ng>.',
'<p>If the source is set to <em>Access Control User Role Assignments</em>, the authorization process will only consider the user''s granted ACL roles.</p>',
'<p>Otherwise, it will check if the groups are enabled as dynamic groups for the session (see APEX_AUTHORIZATION.ENABLE_DYNAMIC_GROUPS). If the application uses an Authentication scheme configured with Real Security Application (RAS) this check will i'
||'nclude RAS session roles. if Oracle APEX Accounts Authentication is used, this check also includes workspace groups that are granted to the user. If Database Authentication is used, this check also includes database roles that are granted to the user'
||'.</p>',
'<p>The authorization scheme succeed, If the user is granted any of the designated roles/groups.</p>',
'</li>',
'<li><strong>Is Not In Group:</strong> Group is not enabled or granted to the user. See <strong>Is In Group</strong> for details.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4665718741)
,p_name=>'F4000_P4008_ERROR_MESSAGE'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_imp.id(178678919656730458)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Identify error message displayed when scheme violated'
,p_source=>'ERROR_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This is the error text that displays when this authorization scheme is applied to a application or page.</p>',
'<p>If the authorization scheme fails (that is, the current user fails the security check) then this text displays.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(294258930514)
,p_name=>'F4000_P4008_COMMENTS'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_imp.id(294253922620)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comments'
,p_source=>'COMMENTS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Enter any comments or notes here.  These comments will never be displayed when running the application</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_reference_id=>186974523106820907
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1417695675012514)
,p_name=>'P4008_SUBSCRIBED_COMP_GRP'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(33435410681829163)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5729013497070705)
,p_name=>'F4000_P4008_VERSION_SCN'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(33435410681829163)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select version_scn ',
'  from wwv_flow_security_schemes',
' where id                = :F4000_P4008_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5729161210070706)
,p_name=>'F4000_P4008_MASTER_VERSION_SCN'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(33435410681829163)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select version_scn ',
'  from wwv_flow_security_schemes',
' where id                = :F4000_P4008_REFERENCE_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10860428467560854)
,p_name=>'P4008_ATTRIBUTE_01'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(178678919656730458)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_01'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 1, :P4008_ATTRIBUTE_01 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10860606899560854)
,p_name=>'P4008_ATTRIBUTE_02'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(178678919656730458)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_02'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 2, :P4008_ATTRIBUTE_02 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10860821632560855)
,p_name=>'P4008_ATTRIBUTE_03'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(178678919656730458)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_03'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 3, :P4008_ATTRIBUTE_03 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10861029786560855)
,p_name=>'P4008_ATTRIBUTE_04'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(178678919656730458)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_04'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 4, :P4008_ATTRIBUTE_04 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10861216067560855)
,p_name=>'P4008_ATTRIBUTE_05'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(178678919656730458)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_05'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 5, :P4008_ATTRIBUTE_05 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10861424586560855)
,p_name=>'P4008_ATTRIBUTE_06'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(178678919656730458)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_06'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 6, :P4008_ATTRIBUTE_06 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10861609092560856)
,p_name=>'P4008_ATTRIBUTE_07'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(178678919656730458)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_07'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 7, :P4008_ATTRIBUTE_07 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10861822266560856)
,p_name=>'P4008_ATTRIBUTE_08'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(178678919656730458)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_08'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 8, :P4008_ATTRIBUTE_08 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10862031392560856)
,p_name=>'P4008_ATTRIBUTE_09'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(178678919656730458)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_09'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 9, :P4008_ATTRIBUTE_09 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10862206377560856)
,p_name=>'P4008_ATTRIBUTE_10'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(178678919656730458)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_10'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 10, :P4008_ATTRIBUTE_10 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10862409371560857)
,p_name=>'P4008_ATTRIBUTE_11'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(178678919656730458)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_11'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 11, :P4008_ATTRIBUTE_11 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10862611681560857)
,p_name=>'P4008_ATTRIBUTE_12'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(178678919656730458)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_12'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 12, :P4008_ATTRIBUTE_12 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10862827170560857)
,p_name=>'P4008_ATTRIBUTE_13'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(178678919656730458)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_13'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 13, :P4008_ATTRIBUTE_13 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10863017460560857)
,p_name=>'P4008_ATTRIBUTE_14'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(178678919656730458)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_14'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 14, :P4008_ATTRIBUTE_14 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10863219990560857)
,p_name=>'P4008_ATTRIBUTE_15'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_imp.id(178678919656730458)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_15'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 15, :P4008_ATTRIBUTE_15 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11094400289588033)
,p_name=>'P4000_P4008_REFERENCE_ID_INIT'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(33435410681829163)
,p_item_default=>'F4000_P4008_REFERENCE_ID'
,p_item_default_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(72151521185216365)
,p_name=>'F4000_P4008_CACHING'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_imp.id(72150497869212519)
,p_use_cache_before_default=>'NO'
,p_item_default=>'BY_USER_BY_PAGE_VIEW'
,p_prompt=>'Validate authorization scheme:'
,p_source=>'CACHING'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'AUTH_SCHEME_CACHING'
,p_lov=>'.'||wwv_flow_imp.id(84860700520374929)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Authorization schemes are evaluated on first use in a session.',
'The <em>Validate authorization scheme</em> attribute controls if future uses cause re-evaluations and when a memorized result can be taken instead.',
'The list below describes the available options:',
'</p>',
'<ul>',
'<li><strong>Once per session:</strong> Evaluate only once and always use the memorized result afterwards.</li>',
'<li><strong>Once per page view:</strong> Evaluate once for each request that is processed. Use the memorized result if the authorization scheme is referenced in more than one component on the page.</li>',
'<li><strong>Once per component:</strong> Evaluate once for each component that references the authorization scheme, but save the result in the session. Further requests to render or process the scheme use the memorized result.</li>',
'<li><strong>Always (No Caching):</strong> The authorization scheme will always be evaluated.</li>',
'</ul>',
'<p>',
'The default value <em>Once per session</em> is the most efficient.',
'You should choose another value if the authorization check depends on changing session state or other factors that are not consistent over an entire session.',
'The options <em>Once per component</em> and <em>Always (No Caching)</em> provide additional information about the component that is secured by the authorization scheme.',
'In authorization plugins, you can use the <em>component.type</em>, <em>component.id</em> and <em>component.name</em> attributes of the <em>t_authorization</em> parameter.',
'For the built-in <em>Exists SQL Query</em> and <em>PL/SQL Function</em> scheme types, equivalent bind variables <em>:APP_COMPONENT_TYPE</em>, <em>:APP_COMPONENT_ID</em> and <em>:APP_COMPONENT_NAME</em> are available.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(178743827500893941)
,p_name=>'F4000_P4008_REFERENCE_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(33435410681829163)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Subscibed from'
,p_source=>'REFERENCE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FLOW_SUBSCRIBE_FROM_SECURITY_SCHEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||',
'wwv_flow_lang.system_message(''NO_AUTHORIZATION_SCHEME'')||',
''' -'' d, 0 r from sys.dual union all',
'select flow_id||'' : ''||name d, id r',
'from   wwv_flow_security_schemes',
'where  flow_id != nvl(:fb_flow_id,0) and flow_id in (',
'select f.id',
'from   wwv_main_apps_dev f',
'where  security_group_id = :flow_security_group_id and',
'       build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') and',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id is null and security_group_id = :flow_security_group_id)',
'       or',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id = f.id and security_group_id = :flow_security_group_id )',
')',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_colspan=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Use this field to base this authorization scheme on an existing authorization scheme in this application or another application in your workspace.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1417708440012515)
,p_computation_sequence=>10
,p_computation_item=>'P4008_SUBSCRIBED_COMP_GRP'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_component_group_dev.is_part_of_subscribed_comp_grp (',
'    p_component_id   => :F4000_P4008_ID,',
'    p_component_type => wwv_flow_copy_metadata.c_authorization,',
'    p_app_id         => :FB_FLOW_ID )'))
,p_compute_when=>'F4000_P4008_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4646630029)
,p_validation_name=>'naming convention on name'
,p_validation_sequence=>10
,p_validation=>'substr(:F4000_P4008_NAME,1,1) not in (''!'',''0'',''1'',''2'',''3'',''4'',''5'',''6'',''7'',''8'',''9'','' '')'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Authorization scheme name must not begin with numeral, ''!'', or whitespace'
,p_associated_item=>wwv_flow_imp.id(4601513402)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(178760112798946315)
,p_validation_name=>'reference id not null'
,p_validation_sequence=>20
,p_validation=>'F4000_P4008_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Reference ID must be specified to refresh the authorization scheme.'
,p_when_button_pressed=>wwv_flow_imp.id(178748029417904765)
,p_associated_item=>wwv_flow_imp.id(178743827500893941)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(178764630685953193)
,p_validation_name=>'reference id not zero'
,p_validation_sequence=>30
,p_validation=>'F4000_P4008_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_ZERO'
,p_error_message=>'Authorization scheme must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(178748029417904765)
,p_associated_item=>wwv_flow_imp.id(178743827500893941)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(10882903317568994)
,p_validation_name=>'Validate Plugin Attributes'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.validate_attribute_items (',
'        p_application_id    => :FB_FLOW_ID,',
'        p_plugin_type       => wwv_flow_plugin.c_plugin_type_authorization,',
'        p_plugin_name       => :F4000_P4008_SCHEME_TYPE,',
'        p_attribute_scope   => wwv_flow_plugin.c_attribute_scope_component,',
'        p_page_item_prefix  => ''P4008_'' );',
'end;'))
,p_validation_type=>'PLSQL_ERROR'
,p_error_message=>'Error'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(270498903813546672)
,p_validation_name=>'Name Unique'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from WWV_FLOW_SECURITY_SCHEMES',
'where security_group_id = :flow_security_group_id ',
'and   flow_id = :FB_FLOW_ID ',
'and   id != nvl(:F4000_P4008_ID, -1)',
'and   name = :F4000_P4008_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#LABEL# must be unique.'
,p_associated_item=>wwv_flow_imp.id(4601513402)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1905781109054613)
,p_validation_name=>'Prevent used Auth Schemes deletion'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from wwv_flow_auth_scheme_usage_dev',
' where flow_id = :FB_FLOW_ID',
'   and (authorization_scheme = to_char( :F4000_P4008_ID )',
'    or authorization_scheme = ''!''||to_char( :F4000_P4008_ID ))'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'This Authorization Scheme is still in use and can not be deleted. Please click <strong>Utilization</strong> link under <strong>Tasks</strong> to view the usage details.'
,p_when_button_pressed=>wwv_flow_imp.id(4589513394)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1420448800484271)
,p_validation_name=>'No duplicate subscription'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_security_schemes',
' where security_group_id = :WORKSPACE_ID ',
'   and flow_id           = :FB_FLOW_ID ',
'   and reference_id      = :F4000_P4008_REFERENCE_ID',
'   and id               != :F4000_P4008_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Another authorization scheme in this application is subscribed to the same master. Please select another authorization scheme.'
,p_validation_condition=>'nvl(:F4000_P4008_REFERENCE_ID, 0) != 0'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(4591513394)
,p_associated_item=>wwv_flow_imp.id(178743827500893941)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2609599799088427)
,p_validation_name=>'Not part of component groups'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not wwv_flow_component_group_dev.is_part_of_comp_grp (',
'    p_component_id   => :F4000_P4008_ID,',
'    p_component_type => wwv_flow_copy_metadata.c_authorization,',
'    p_app_id         => :FB_FLOW_ID )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Authorization Scheme cannot be deleted because it is part of a component group.'
,p_when_button_pressed=>wwv_flow_imp.id(4589513394)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(7576506808755882)
,p_name=>'Hide F4000_P4008_REFERENCE_ID'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'F4000_P4008_REFERENCE_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7576947152755881)
,p_event_id=>wwv_flow_imp.id(7576506808755882)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4008_REFERENCE_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(11095745621588046)
,p_name=>'Apply changes'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(4591513394)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(11095889520588047)
,p_event_id=>wwv_flow_imp.id(11095745621588046)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'Are you sure you want to subscribe to the selected master authorization scheme? This will overwrite current authorization scheme data with selected master authorization scheme.'
,p_attribute_03=>'warning'
,p_attribute_06=>'Subscribe'
,p_attribute_07=>'Cancel'
,p_client_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_client_condition_expression=>'$v(''F4000_P4008_REFERENCE_ID'') !== "" && $v(''P4000_P4008_REFERENCE_ID_INIT'') === ""'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(11095920615588048)
,p_event_id=>wwv_flow_imp.id(11095745621588046)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'ApplyChanges'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4607513409)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_SECURITY_SCHEMES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_SECURITY_SCHEMES'
,p_attribute_03=>'F4000_P4008_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_process_error_message=>'Error fetching  row.'
,p_internal_uid=>4607513409
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2203928541810288817)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Init Plugin Number Attributes for Display'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.init_number_fields_for_display (',
'        p_application_id    => :FB_FLOW_ID,',
'        p_plugin_type       => wwv_flow_plugin.c_plugin_type_authorization,',
'        p_plugin_name       => :F4000_P4008_SCHEME_TYPE,',
'        p_attribute_scope   => wwv_flow_plugin.c_attribute_scope_component );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2203928541810288817
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2203928411578288816)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Convert Plugin Number Attributes for Storage'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.conv_number_fields_for_storage (',
'        p_application_id    => :FB_FLOW_ID,',
'        p_plugin_type       => wwv_flow_plugin.c_plugin_type_authorization,',
'        p_plugin_name       => :F4000_P4008_SCHEME_TYPE,',
'        p_attribute_scope   => wwv_flow_plugin.c_attribute_scope_component,',
'        p_page_item_prefix  => ''P4008_'' );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2203928411578288816
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4609513412)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_SECURITY_SCHEMES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_SECURITY_SCHEMES'
,p_attribute_03=>'F4000_P4008_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U'
,p_attribute_12=>'Y'
,p_process_error_message=>'Error processing  row.'
,p_process_when=>'COPY_TEMPLATE,Delete'
,p_process_when_type=>'REQUEST_NOT_IN_CONDITION'
,p_process_success_message=>'Action processed.'
,p_internal_uid=>4609513412
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4994516461587607)
,p_process_sequence=>55
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete authorization scheme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_authorization_dev.delete_authorization(',
'    p_authorization_id => :F4000_P4008_ID,',
'    p_app_id           => :FB_FLOW_ID);'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'Delete'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>'Authorization Scheme deleted.'
,p_internal_uid=>4994516461587607
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(35584005305003996)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh authorization scheme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_authorization_dev.subscribe_security_scheme (',
'    p_master_scheme_id         => :F4000_P4008_REFERENCE_ID,',
'    p_subscribing_scheme_id    => :F4000_P4008_ID,',
'    p_subscribing_app_id       => :fb_flow_id',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error refreshing authorization scheme.'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST = ''REFRESH_SCHEME''',
'or ( :REQUEST = ''ApplyChanges'' and :F4000_P4008_REFERENCE_ID is not null and :P4000_P4008_REFERENCE_ID_INIT is null )'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Authorization Scheme refreshed.'
,p_internal_uid=>35584005305003996
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(178776823544986968)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove reference id'
,p_process_sql_clob=>'wwv_flow_copy_metadata.remove_scheme_reference_id (:F4000_P4008_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error setting reference id to null.'
,p_process_when_button_id=>wwv_flow_imp.id(4591513394)
,p_process_when=>'F4000_P4008_REFERENCE_ID'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'0'
,p_internal_uid=>178776823544986968
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(12850122373753013)
,p_process_sequence=>80
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'reset app authorization cache'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_authorization.reset_cache (',
'    p_save_state => true );'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>12850122373753013
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(7965069212212537)
,p_process_sequence=>90
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Unsubscribe'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.unsubscribe_component (',
'    p_component_type  => wwv_flow_copy_metadata.c_authorization,',
'    p_component_id    => :F4000_P4008_ID,',
'    p_app_id          => :FB_FLOW_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(5729293382070707)
,p_process_success_message=>'Authorization Scheme is no longer subscribed to its master authorization scheme.'
,p_internal_uid=>7965069212212537
);
end;
/
prompt --application/pages/page_04009
begin
wwv_flow_imp_page.create_page(
 p_id=>4009
,p_name=>'Text Messages'
,p_alias=>'TEXT-MESSAGES1'
,p_page_mode=>'MODAL'
,p_step_title=>'Create/Edit Text Message'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213331522315193801)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_dialog_chained=>'N'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_read_only_when=>'P4009_REFERENCE_ID'
,p_help_text=>'global_messages.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(478331273)
,p_plug_name=>'Message'
,p_region_css_classes=>'resizable: true'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_MESSAGES$'
,p_query_where=>'security_group_id = :WORKSPACE_ID'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
,p_plug_header=>'<p>Messages are designed to provide translation services for use in PL/SQL.</p>'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(14795893128799609)
,p_plug_name=>'Subscription'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'F4000_P4009_ID'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'WWV_FLOW_MESSAGES$',
  'attribute_02', 'NAME',
  'attribute_03', 'F4000_P4009_ID',
  'attribute_04', 'P4009_REFERENCE_ID',
  'attribute_05', 'SUBSCRIBE_MESSAGE',
  'attribute_06', 'VERSION_SCN')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(206273416506766642)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(479331275)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(206273416506766642)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4411497717904117)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(206273416506766642)
,p_button_name=>'COPY_FROM_ANOTHER'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Copy from another app'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:4007:&SESSION.::&DEBUG.:4007:P4007_COPY_SOURCE:OTHER'
,p_button_condition=>'F4000_P4009_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_button_css_classes=>'a-Button--noUI'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(480331276)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(206273416506766642)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'EDIT'
,p_confirm_message=>'&DELETE_MSG.'
,p_confirm_style=>'danger'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P4009_ID is not null',
'and ( :P4009_REFERENCE_ID is null or :P4009_SUBSCRIBED_COMP_GRP = ''N'' )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2236348923306066)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_imp.id(14795893128799609)
,p_button_name=>'UNSUBSCRIBE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Unsubscribe'
,p_button_position=>'EDIT'
,p_button_condition=>':P4009_REFERENCE_ID is not null and :P4009_SUBSCRIBED_COMP_GRP = ''N'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2236727271306068)
,p_button_sequence=>110
,p_button_plug_id=>wwv_flow_imp.id(14795893128799609)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Refresh Text Message'
,p_button_position=>'EDIT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P4009_REFERENCE_ID is not null ',
'and ( :P4009_VERSION_SCN != :P4009_MASTER_VERSION_SCN or :P4009_VERSION_SCN is null )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2237138217306069)
,p_button_sequence=>120
,p_button_plug_id=>wwv_flow_imp.id(14795893128799609)
,p_button_name=>'PUBLISH'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Publish'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.:149:F4000_P149_ID,F4000_P149_TEMPLATE_TYPE,F4000_P149_PAGE_ID:&F4000_P4009_ID.,MESSAGE,4009'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * ',
'  from wwv_flow_messages$',
' where reference_id      = :F4000_P4009_ID ',
'   and security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(171883101276015336)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(206273416506766642)
,p_button_name=>'CREATEAGAIN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Create And Create Another'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P4009_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(482331277)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(206273416506766642)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Text Message'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P4009_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(481331277)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(206273416506766642)
,p_button_name=>'SAVE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>':F4000_P4009_ID is not null and :P4009_REFERENCE_ID is null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(483331280)
,p_name=>'F4000_P4009_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(478331273)
,p_item_source_plug_id=>wwv_flow_imp.id(478331273)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(484331280)
,p_name=>'P4009_FLOW_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(478331273)
,p_item_source_plug_id=>wwv_flow_imp.id(478331273)
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Application'
,p_source=>'FLOW_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'This attribute identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(485331281)
,p_name=>'P4009_NAME'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(478331273)
,p_item_source_plug_id=>wwv_flow_imp.id(478331273)
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter a unique name for the message you are creating.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(486331281)
,p_name=>'P4009_MESSAGE_LANGUAGE'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(478331273)
,p_item_source_plug_id=>wwv_flow_imp.id(478331273)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select coalesce( flow_language, ''en'' )',
'  from wwv_flows',
' where id                = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_item_default_type=>'SQL_QUERY'
,p_prompt=>'Language'
,p_source=>'MESSAGE_LANGUAGE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_LANGUAGES_LOCALES'
,p_lov=>'.'||wwv_flow_imp.id(107899321117195063)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'Select a language for which this message will be used.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(487331281)
,p_name=>'P4009_MESSAGE_TEXT'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(478331273)
,p_item_source_plug_id=>wwv_flow_imp.id(478331273)
,p_prompt=>'Text'
,p_source=>'MESSAGE_TEXT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>70
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'lang="&P4009_MESSAGE_LANGUAGE!ATTR."'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the text to be returned when this text message is called.</p>',
'<p>Example: Tax: %0 Total amount %1',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2360376628667348)
,p_name=>'P4009_SUBSCRIBED_COMP_GRP'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_imp.id(14795893128799609)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2611526488441802)
,p_name=>'P4009_REFERENCE_ID_INIT'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(14795893128799609)
,p_use_cache_before_default=>'NO'
,p_item_default=>'P4009_REFERENCE_ID'
,p_item_default_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4488842978954442)
,p_name=>'P4009_REFERENCE_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(14795893128799609)
,p_item_source_plug_id=>wwv_flow_imp.id(478331273)
,p_prompt=>'Subscribe From'
,p_source=>'REFERENCE_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FLOW_SUBSCRIBE_FROM_TEXT_MESSAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select b.flow_id ||'' ''||f.name||'' - ''||b.name||'' ( ''|| b.message_language ||'' )'' d,',
'       b.id r',
'  from wwv_flow_messages$ b,',
'       wwv_main_apps_dev f',
' where b.flow_id          != nvl(:FB_FLOW_ID,0)',
'   and b.flow_id           = f.id',
'   and f.build_status      not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'   and b.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and f.security_group_id = :FLOW_SECURITY_GROUP_ID',
'order by 1'))
,p_lov_display_null=>'YES'
,p_cSize=>50
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select a master text message to subscribe from. When you select a master text message and click on the <strong>Apply Changes</strong> button, the text message details will be automatically refreshed from the selected master.<br /><br />If the text me'
||'ssage is already subscribed, then click on the <strong>Refresh Text Message</strong> button to refresh the text message details from the master text message.'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'Y'
,p_attribute_06=>'0'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4797881456120924)
,p_name=>'P4009_VERSION_SCN'
,p_source_data_type=>'NUMBER'
,p_is_query_only=>true
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_imp.id(478331273)
,p_item_source_plug_id=>wwv_flow_imp.id(478331273)
,p_source=>'VERSION_SCN'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4797900980120925)
,p_name=>'P4009_MASTER_VERSION_SCN'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(14795893128799609)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select version_scn ',
'  from wwv_flow_messages$',
' where id                = :P4009_REFERENCE_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6610831190558813)
,p_name=>'P4009_IS_JS_MESSAGE_1'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(478331273)
,p_item_source_plug_id=>wwv_flow_imp.id(478331273)
,p_item_default=>'N'
,p_prompt=>'Used in JavaScript'
,p_source=>'IS_JS_MESSAGE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Select <strong>On</strong> if the message is used in <code>apex.lang.*</code> API calls in JavaScript code.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2719084897351596)
,p_computation_sequence=>20
,p_computation_item=>'P4009_SUBSCRIBED_COMP_GRP'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_component_group_dev.is_part_of_subscribed_comp_grp (',
'    p_component_id   => :F4000_P4009_ID,',
'    p_component_type => wwv_flow_copy_metadata.c_message,',
'    p_app_id         => :FB_FLOW_ID )'))
,p_compute_when=>'F4000_P4009_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(181025111997044440)
,p_computation_sequence=>10
,p_computation_item=>'P4009_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'trim(:P4009_NAME)'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(38027668285101533)
,p_computation_sequence=>20
,p_computation_item=>'P4009_IS_JS_MESSAGE_1'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_is_js_message wwv_flow_messages$.is_js_message%type;',
'begin',
'    begin',
'        -- check if the name matches with one of the APEX system messages,',
'        -- in that case we use the same is_js_message setting because the',
'        -- developer just wants provide a different text message in their app.',
'        select is_js_message',
'          into l_is_js_message',
'          from wwv_flow_messages$',
'         where flow_id           = 4411',
'           and security_group_id = 10',
'           and name              = :P4009_NAME;',
'',
'        return l_is_js_message;',
'    exception when no_data_found then ',
'        return :P4009_IS_JS_MESSAGE_1;',
'    end;',
'end;'))
,p_compute_when=>'FB_FLOW_ID'
,p_compute_when_text=>'4411'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(599335264)
,p_validation_name=>'Name must be supplied'
,p_validation_sequence=>10
,p_validation=>'P4009_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Message Name must be specified.'
,p_associated_item=>wwv_flow_imp.id(485331281)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(601352090)
,p_validation_name=>'Message Text Required'
,p_validation_sequence=>20
,p_validation=>'P4009_MESSAGE_TEXT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Message text must be specified.'
,p_associated_item=>wwv_flow_imp.id(487331281)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(114586604868671476)
,p_validation_name=>'name must be unique within application - create'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_messages$',
' where upper( name )     = upper( :P4009_NAME )',
'   and message_language  = :P4009_MESSAGE_LANGUAGE',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Message name must be unique'
,p_validation_condition=>'CREATE,CREATEAGAIN'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(485331281)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(114727927266487237)
,p_validation_name=>'name must be unique within application - update'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_messages$',
' where upper( name )     = upper( :P4009_NAME )',
'   and message_language  = :P4009_MESSAGE_LANGUAGE',
'   and id                <> :F4000_P4009_ID',
'   and FLOW_ID           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Message name must be unique'
,p_when_button_pressed=>wwv_flow_imp.id(481331277)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2617981319506616)
,p_validation_name=>'No duplicate subscription'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_messages$',
' where security_group_id = :WORKSPACE_ID ',
'   and flow_id           = :FB_FLOW_ID ',
'   and reference_id      = :P4009_REFERENCE_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'An existing text message in this application is subscribed to the same master. Please select another master text message.'
,p_validation_condition=>':P4009_REFERENCE_ID is not null and :P4009_REFERENCE_ID_INIT is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(481331277)
,p_associated_item=>wwv_flow_imp.id(4488842978954442)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3400264721600329)
,p_validation_name=>'Not part of component groups'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not wwv_flow_component_group_dev.is_part_of_comp_grp (',
'    p_component_id   => :F4000_P4009_ID,',
'    p_component_type => wwv_flow_copy_metadata.c_message,',
'    p_app_id         => :FB_FLOW_ID )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Text Message cannot be deleted because it is part of a component group.'
,p_when_button_pressed=>wwv_flow_imp.id(480331276)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(590015417007897547)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(479331275)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(590015547784897548)
,p_event_id=>wwv_flow_imp.id(590015417007897547)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6610697881558811)
,p_name=>'Hide P4009_REFERENCE_ID'
,p_event_sequence=>30
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P4009_REFERENCE_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6610798098558812)
,p_event_id=>wwv_flow_imp.id(6610697881558811)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4009_REFERENCE_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1401594714151301)
,p_name=>'update language'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4009_MESSAGE_LANGUAGE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1401688130151302)
,p_event_id=>wwv_flow_imp.id(1401594714151301)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'$("#P4009_MESSAGE_TEXT").attr("lang",$v("P4009_MESSAGE_LANGUAGE"));'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2720308007367642)
,p_name=>'Save'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(481331277)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2720782506367643)
,p_event_id=>wwv_flow_imp.id(2720308007367642)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'Are you sure you want to subscribe? This will overwrite the current text message data with the selected master text message.'
,p_attribute_03=>'warning'
,p_attribute_06=>'Subscribe'
,p_attribute_07=>'Cancel'
,p_client_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_client_condition_expression=>'$v(''P4009_REFERENCE_ID'') !== "" && $v(''P4009_REFERENCE_ID_INIT'') === ""'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2721278574367644)
,p_event_id=>wwv_flow_imp.id(2720308007367642)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'SAVE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4489546745954449)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(478331273)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process form Message'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE,CREATEAGAIN,SAVE,DELETE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'Action processed.'
,p_internal_uid=>4489546745954449
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2611603562441803)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh Message'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.refresh_component (',
'    p_component_type     => wwv_flow_copy_metadata.c_message,',
'    p_master_id          => :P4009_REFERENCE_ID,',
'    p_subscribing_id     => :F4000_P4009_ID,',
'    p_subscribing_app_id => :FB_FLOW_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST = ''REFRESH''',
'or ( :REQUEST = ''SAVE'' and :P4009_REFERENCE_ID is not null and :P4009_REFERENCE_ID_INIT is null )'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Text message refreshed from the master.'
,p_internal_uid=>2611603562441803
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(6638567232779105)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Unsubscribe'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.unsubscribe_component (',
'    p_component_type  => wwv_flow_copy_metadata.c_message,',
'    p_component_id    => :F4000_P4009_ID,',
'    p_app_id          => :FB_FLOW_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2236348923306066)
,p_process_success_message=>'Text Message has been unsubscribed.'
,p_internal_uid=>6638567232779105
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4642678795740825)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Clear Subscriptions'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- when deleting the component, clear reference_id data from subscribing apps',
'--',
'wwv_flow_copy_metadata.clear_subscriptions (',
'    p_component_type => wwv_flow_copy_metadata.c_message,',
'    p_master_id      => :F4000_P4009_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(480331276)
,p_internal_uid=>4642678795740825
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2613038732441817)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'Clear Session State'
,p_attribute_01=>'CLEAR_CACHE_CURRENT_PAGE'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(171883101276015336)
,p_internal_uid=>2613038732441817
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(590015679101897549)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE,DELETE,SAVE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>590015679101897549
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4488129644954435)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(478331273)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Text Messages'
,p_internal_uid=>4488129644954435
);
end;
/
prompt --application/pages/page_04014
begin
wwv_flow_imp_page.create_page(
 p_id=>4014
,p_name=>'Create List of Values - Query or Static Values'
,p_alias=>'CREATE-LIST-OF-VALUES-QUERY-OR-STATIC-VALUES'
,p_page_mode=>'MODAL'
,p_step_title=>'Create List of Values'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213211113434774960)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_lov.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(689510170)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(161740513874429436)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_plug_query_headings=>'Sequence:Display Value:Return Value'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'RLL'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(130764307507)
,p_name=>'Create Static List of Values'
,p_template=>wwv_flow_imp.id(42025417508627628)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select i,',
'       ''<input type="text" size="32" maxlength="255" value="" name="f01" title="''||wwv_flow_lang.system_message(''DISPLAY_VALUE.N'',i)||''">'' g01,',
'       ''<input type="text" size="32" maxlength="255" value="" name="f02" title="''||wwv_flow_lang.system_message(''RETURN_VALUE.N'',i)||''">'' g02',
'from   wwv_flow_dual100',
'where  i < 16',
'order  by i'))
,p_header=>'<p>Enter static display and return values. Values will display in the order entered. <strong>Return Value</strong> does not display, but is the value that is returned to the &PRODUCT_NAME. engine.  If you do not specify a <strong>Return Value</strong'
||'>  then it is equal to the <strong>Display Value</strong>.  You can display additional attributes including build option controls and item level conditional display by editing the List of Values.</p>'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48477814920770274)
,p_query_column_id=>1
,p_column_alias=>'I'
,p_column_display_sequence=>1
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48477906451770274)
,p_query_column_id=>2
,p_column_alias=>'G01'
,p_column_display_sequence=>2
,p_column_heading=>'Display Value'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48478030779770274)
,p_query_column_id=>3
,p_column_alias=>'G02'
,p_column_display_sequence=>3
,p_column_heading=>'Return Value'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44768629474106856)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(130795542638)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(44768629474106856)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(130794537566)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(44768629474106856)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create List of Values'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(130797612760)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(44768629474106856)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(130796609694)
,p_branch_name=>'Go To Page 4110'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.::::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(130794537566)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(130798614150)
,p_branch_action=>'4004'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(130797612760)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(130800656059)
,p_name=>'F4000_P4014_N'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(130764307507)
,p_use_cache_before_default=>'NO'
,p_prompt=>'List of Values Name:'
,p_source=>'F4000_P4004_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_escape_on_http_input=>'Y'
,p_help_text=>'This will be the name of the shared list of values.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(159409002328124590)
,p_validation_name=>'must enter at least one value'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  c number;',
'  x number := 0;',
'begin',
'  c := wwv_flow.g_f01.count;',
'  if c > 0 then ',
'     for i in 1..c loop',
'        if wwv_flow.g_f01(i) is not null then',
'          x := x + 1;',
'        end if;',
'     end loop;',
'     if x > 0 then ',
'         return true;',
'     else',
'         return false;',
'     end if;',
'  else ',
'     return false;',
'  end if;',
'exception',
'  when others then c := 0;',
'  return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'At least on entry must be entered.'
,p_when_button_pressed=>wwv_flow_imp.id(130794537566)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(574038708765616918)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(130795542638)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(574038830634616919)
,p_event_id=>wwv_flow_imp.id(574038708765616918)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(130799617858)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create List of Values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  s int;',
'  r varchar2(4000);',
'begin',
'  select wwv_flow_id.next_val into s from dual;',
'  ',
'  wwv_flow_imp_shared.create_list_of_values (',
'      p_id        => s,',
'      p_flow_id   => nv(''FB_FLOW_ID''),',
'      p_lov_name  => upper(v(''F4000_P4004_NAME'')),',
'      p_lov_query => null,',
'      p_location  => ''STATIC'');',
'    ',
'  for i in 1..wwv_flow.g_f01.count loop',
'      begin ',
'          r := nvl(wwv_flow.g_f02(i),wwv_flow.g_f01(i)); ',
'      exception when others then ',
'          r := wwv_flow.g_f01(i);',
'      end;',
'      if wwv_flow.g_f01(i) is not null then',
'          wwv_flow_imp_shared.create_static_lov_data (',
'              p_lov_id            => s,',
'              p_lov_disp_sequence => i,',
'              p_lov_disp_value    => wwv_flow.g_f01(i),',
'              p_lov_return_value  => r);',
'      end if;',
'  end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error creating static List of Values.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(130794537566)
,p_process_success_message=>'Static List of Values created.'
,p_internal_uid=>130799617858
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(574038930528616920)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_type=>'NEVER'
,p_process_success_message=>'Static List of Values created.'
,p_internal_uid=>574038930528616920
);
end;
/
prompt --application/pages/page_04023
begin
wwv_flow_imp_page.create_page(
 p_id=>4023
,p_name=>'Create Navigation Bar Entry - Attributes'
,p_alias=>'CREATE-NAVIGATION-BAR-ENTRY-ATTRIBUTES'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Navigation Bar Entry'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213263531591941060)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_navbar.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(690542997)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(103870209211856610)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_plug_query_headings=>'Seq:Icon:Alt:Conditional'
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'-'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(937050648)
,p_name=>'Existing Navigation Bar Entries'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ICON_SEQUENCE, ',
'       decode(icon_image,null,null,sys.htf.img(''&IMAGE_PREFIX.''||ICON_IMAGE)) img, ',
'       substr(ICON_IMAGE_ALT,1,20) a,',
'       decode(ICON_BAR_DISP_COND,',
'          null,wwv_flow_lang.system_message(''F4000.NO''),',
'          wwv_flow_lang.system_message(''F4000.YES'')) is_cond',
'from   wwv_flow_icon_bar',
'where  flow_id = :FB_FLOW_ID',
'order  by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>150
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48936711202773185)
,p_query_column_id=>1
,p_column_alias=>'ICON_SEQUENCE'
,p_column_display_sequence=>1
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48936821834773186)
,p_query_column_id=>2
,p_column_alias=>'IMG'
,p_column_display_sequence=>2
,p_column_heading=>'Icon'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48936918682773186)
,p_query_column_id=>3
,p_column_alias=>'A'
,p_column_display_sequence=>3
,p_column_heading=>'ALT Text'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48937025056773186)
,p_query_column_id=>4
,p_column_alias=>'IS_COND'
,p_column_display_sequence=>4
,p_column_heading=>'Conditional'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(131995828236)
,p_plug_name=>'Create Navigation Bar Entry'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46437828557135499)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(197011332657417640)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(399849897040726767)
,p_plug_display_sequence=>40
,p_plug_source=>'<p>Navigation Bar Entries offer an easy way for users to move between pages in an application. The location of a navigation Bar depends upon the associated page template. A Navigation Bar Entry can be an image, an image with text beneath it, or text.'
||'</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(506536418928562515)
,p_plug_name=>'Optional Icon'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(131997838777)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(46437828557135499)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(691552414)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46437828557135499)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(193677631147123583)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(46437828557135499)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(692552421)
,p_branch_action=>'4024'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(691552414)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(27844700456921702)
,p_branch_name=>'Go To Page 22'
,p_branch_action=>'f?p=&APP_ID.:22:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(193677631147123583)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(722661038)
,p_name=>'F4000_P4023_SEQUENCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(131995828236)
,p_item_default=>'10'
,p_prompt=>'Sequence'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>8
,p_cMaxlength=>38
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the sequence for this component. The sequence determines the order of evaluation.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(921834124)
,p_name=>'F4000_P4023_IMG1'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(506536418928562515)
,p_prompt=>'Icon Image Name'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'PICK_IMAGE_NAME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select file_name || '' ('' || wwv_flow_lang.system_message(scope) || '')'' as d,',
'       r',
'  from ( select file_name,',
'                ''#'' || ''APP_FILES#'' || file_name as r,',
'                ''APPLICATION'' as scope',
'           from wwv_flow_static_files',
'          where flow_id           = :FB_FLOW_ID',
'            and security_group_id = :WORKSPACE_ID',
'            and upper(mime_type)  like ''IMAGE/%''',
'          union all',
'         select file_name,',
'                ''#'' || ''WORKSPACE_FILES#'' || file_name as r,',
'                ''WORKSPACE'' as scope',
'           from wwv_flow_company_static_files',
'          where security_group_id = :WORKSPACE_ID',
'            and upper(mime_type)  like ''IMAGE/%''',
'          order by scope, file_name',
'       )',
''))
,p_cSize=>50
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The image is the name of image.&nbsp; For example: wwv_find.gif.&nbsp; The image prefix can be one of the following:',
'',
'<ol>',
'',
'<li>&#35;WORKSPACE_FILES&#35;</li>',
'',
'<li>&#35;APP_FILES&#35;</li>',
'',
'<li>null (from the directory specified by the application image attribute)</li>',
'',
'</ol>',
'',
'Example of image names:',
'',
'<pre>',
'',
'&#35;WORKSPACE_FILES&#35;my_image.jpg',
'',
'&#35;APP_FILES&#35;another_image.gif',
'',
'html_db_white.gif',
'',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(922839912)
,p_name=>'F4000_P4023_TEXT1'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(131995828236)
,p_prompt=>'Entry Label'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter additional text to display with the image. You can include text or use icons with no text. This attribute is optional and can be translated.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(923854364)
,p_name=>'F4000_P4023_ALT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(506536418928562515)
,p_prompt=>'Image ALT'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter ALT text for navigation icons that are images. If you do not specify an image name, then this text displays.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(930896906)
,p_name=>'F4000_P4023_H1'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(506536418928562515)
,p_prompt=>'Image Height'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Defines the height of the image.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(931900081)
,p_name=>'F4000_P4023_W1'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(506536418928562515)
,p_prompt=>'Width'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Defines the width of the image.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(72114714144530024)
,p_validation_name=>'HeightNumeric'
,p_validation_sequence=>10
,p_validation=>'F4000_P4023_H1'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Height must be numeric.'
,p_when_button_pressed=>wwv_flow_imp.id(691552414)
,p_associated_item=>wwv_flow_imp.id(930896906)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(72116325918533419)
,p_validation_name=>'WidthNumeric'
,p_validation_sequence=>20
,p_validation=>'F4000_P4023_W1'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Width must be numeric.'
,p_when_button_pressed=>wwv_flow_imp.id(691552414)
,p_associated_item=>wwv_flow_imp.id(931900081)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(185464304552464966)
,p_validation_name=>'sequence not null'
,p_validation_sequence=>30
,p_validation=>'F4000_P4023_SEQUENCE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Sequence must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(691552414)
,p_associated_item=>wwv_flow_imp.id(722661038)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(185465322906470190)
,p_validation_name=>'sequence is numberic'
,p_validation_sequence=>40
,p_validation=>'F4000_P4023_SEQUENCE'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Sequence must be a number.'
,p_when_button_pressed=>wwv_flow_imp.id(691552414)
,p_associated_item=>wwv_flow_imp.id(722661038)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(185467513126486307)
,p_validation_name=>'must have image or text'
,p_validation_sequence=>50
,p_validation=>':F4000_P4023_IMG1 is not null or :F4000_P4023_TEXT1 is not null'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'You must supply either an image, text or both.'
,p_when_button_pressed=>wwv_flow_imp.id(691552414)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(573753685869229717)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(131997838777)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(573753714566229718)
,p_event_id=>wwv_flow_imp.id(573753685869229717)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_04024
begin
wwv_flow_imp_page.create_page(
 p_id=>4024
,p_name=>'Create Navigation Bar Entry - Target'
,p_alias=>'CREATE-NAVIGATION-BAR-ENTRY-TARGET'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Navigation Bar Entry'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213263531591941060)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'function callItempopUp(s1,s2) {',
'     var items = document.getElementById(s1).value.replace(/\,/g,''~'');',
'     var values = document.getElementById(s2).value.replace(/\,/g,''~'');',
'     var url = ''f?p=4000:404:&SESSION.:::404:P404_RETURN1,P404_RETURN2,P404_ITEMS,P404_VALUES:'' + s1 + '','' + s2 + '','' + escape(items) + '','' + escape(values);',
'     popUp (url);',
'}',
'</script>'))
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_navbar.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(693567012)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(103870209211856610)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_plug_query_headings=>'Seq:Icon:Alt:Conditional'
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'-'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(695584447)
,p_plug_name=>'Create Navigation Bar Entry'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(137389740604)
,p_name=>'Existing Navigation Bar Entry Targets'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select icon_sequence, ',
'       substr(icon_target,1,60) icon_target',
'from   wwv_flow_icon_bar',
'where  flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'order  by 1'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>150
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48761121492772061)
,p_query_column_id=>1
,p_column_alias=>'ICON_SEQUENCE'
,p_column_display_sequence=>1
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48761213870772061)
,p_query_column_id=>2
,p_column_alias=>'ICON_TARGET'
,p_column_display_sequence=>2
,p_column_heading=>'Target'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46442727696173137)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(956248135)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(46442727696173137)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(697594360)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(46442727696173137)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(939083560)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46442727696173137)
,p_button_name=>'Back'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(698594362)
,p_branch_action=>'4025'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(697594360)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(940083562)
,p_branch_action=>'4023'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(939083560)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(938077978)
,p_name=>'F4000_P4023_TARGET'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(695584447)
,p_prompt=>'Target: (syntax f?p=application:page:session:request:debug:clearCache:itemNames:itemValues)'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>65
,p_cMaxlength=>2000
,p_cHeight=>3
,p_cAttributes=>'nowrap="nowrap"'
,p_colspan=>3
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(941090545)
,p_name=>'F4000_P4024_P'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(695584447)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application:'
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(943110344)
,p_name=>'F4000_P4024_ALT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(695584447)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Alt Tag'
,p_source=>'F4000_P4023_ALT'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'F4000_P4023_ALT'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the ALT text for the image.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22228804443016517)
,p_name=>'P4024_URL_OR_FLOW'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(695584447)
,p_item_default=>'FLOW'
,p_prompt=>'Target is a'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'URL_OR_PAGE'
,p_lov=>'.'||wwv_flow_imp.id(84796030957080920)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the target for this navigation entry.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22229420374021153)
,p_name=>'P4024_PAGE_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(695584447)
,p_prompt=>'Page'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d',
'  from wwv_flow_steps',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and is_page_pattern   = ''N''',
'order by 2'))
,p_cSize=>8
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter the page number. To reset pagination, select <span class="fielddatabold">reset pagination for this page</span>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22230301804025267)
,p_name=>'P4024_CLEAR_PAGE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(695584447)
,p_prompt=>'Reset pagination for this page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Select this checkbox to reset the pagination of the page that you are linking to.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'YES'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22231209685046384)
,p_name=>'P4024_REQUEST'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(695584447)
,p_prompt=>'Request'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter text that defines the built-in application item called REQUEST. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22232120074049444)
,p_name=>'P4024_CLEAR_CACHE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(695584447)
,p_prompt=>'Clear Cache'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the page numbers where you would like to clear the user''s session state. Separate multiple entries with commas.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22233028732051929)
,p_name=>'P4024_ARG_NAMES'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(695584447)
,p_prompt=>'Set these items'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the list of application item names for which you would like to set session state. Separate multiple items with commas. Setting the session state gives the listed item a value. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'callItempopUp'
,p_attribute_03=>'Find Item'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22234007392055225)
,p_name=>'P4024_ARG_VALUES'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(695584447)
,p_prompt=>'With these values'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter a comma delimited list of values for the items specified in <span class="fielddatabold">Set these items</span>. You can specify static values or substitution syntax (for example, &amp;APP_ITEM_NAME.). ',
'<pre>&amp;APP_ITEM_NAME.</pre>',
'<div class="htmldbInfoBodyP">Item values passed to <span class="fielddatabold">f?p=</span> in the URL may never contain a colon (:). Item values may also not contain commas unless you enclose the entire value in backslash characters. For example:</di'
||'v>',
'<pre>\1234,56\</pre>',
'<div class="htmldbInfoBodyP">This is useful when decimal values must be passed where the NLS decimal separator character is a comma.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'callItempopUp'
,p_attribute_03=>'Find Item'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22235619475106034)
,p_name=>'P4024_URL_TARGET'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(695584447)
,p_prompt=>'URL Target'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Enter an URL for this navigation bar entry.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(135042203997757993)
,p_name=>'P4024_PINTER_FRIENDLY'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(695584447)
,p_prompt=>'Printer friendly'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select this checkbox to set the printer friendly.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'YES'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(940659298610194134)
,p_name=>'P4024_COMMA_SEP1'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(695584447)
,p_prompt=>'Comma sep1'
,p_source=>'''(''||wwv_flow_lang.system_message(''WS_COMMA_SEP_LIST'')||'')'''
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(940659388647194135)
,p_name=>'P4024_COMMA_SEP2'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(695584447)
,p_prompt=>'Comma sep1'
,p_source=>'''(''||wwv_flow_lang.system_message(''WS_COMMA_SEP_LIST'')||'')'''
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(940659435853194136)
,p_name=>'P4024_COMMA_SEP3'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(695584447)
,p_prompt=>'Comma sep1'
,p_source=>'''(''||wwv_flow_lang.system_message(''WS_COMMA_SEP_LIST'')||'')'''
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(22238723855173575)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P4023_TARGET'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_clear_cache varchar2(4000);',
'  l_pf          varchar2(30) := null;',
'begin',
'if nvl(:P4024_PINTER_FRIENDLY,''N'') = ''YES'' then',
'   l_pf := '':YES'';',
'end if;',
'if :P4024_URL_OR_FLOW = ''FLOW'' then',
'  if :P4024_CLEAR_PAGE = ''YES'' then',
'    l_clear_cache := ''RP,''||:P4024_CLEAR_CACHE;',
'  else',
'    l_clear_cache := :P4024_CLEAR_CACHE;',
'  end if;',
'  return ''f?p=&''||''APP_ID.:''',
'         ||:P4024_PAGE_ID||',
'         '':&''||''SESSION.:''||:P4024_REQUEST||',
'         '':&''||''DEBUG.:''||rtrim(l_clear_cache,'','')||',
'         '':''||:P4024_ARG_NAMES||',
'         '':''||:P4024_ARG_VALUES||',
'         l_pf;',
'else',
'  return :P4024_URL_TARGET;',
'end if;',
'end;'))
,p_computation_error_message=>'Unable to compute item value.'
,p_compute_when=>'Next'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(957259216)
,p_validation_name=>'Target Required'
,p_validation_sequence=>10
,p_validation=>'(:P4024_URL_OR_FLOW = ''URL'' and :P4024_URL_TARGET is not null) or (:P4024_URL_OR_FLOW = ''FLOW'' and :P4024_PAGE_ID is not null)'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'URL or page must be specified as target.'
,p_when_button_pressed=>wwv_flow_imp.id(697594360)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(573753415200229715)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(956248135)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(573753520719229716)
,p_event_id=>wwv_flow_imp.id(573753415200229715)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(385810889376243633)
,p_name=>'URL or Flow Change'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4024_URL_OR_FLOW'
,p_condition_element=>'P4024_URL_OR_FLOW'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FLOW'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(385810992597243634)
,p_event_id=>wwv_flow_imp.id(385810889376243633)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4024_PAGE_ID,P4024_REQUEST,P4024_CLEAR_CACHE,P4024_ARG_NAMES,P4024_ARG_VALUES,P4024_COMMA_SEP1,P4024_COMMA_SEP2,P4024_COMMA_SEP3,P4024_CLEAR_PAGE,P4024_PINTER_FRIENDLY'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(385811094569243635)
,p_event_id=>wwv_flow_imp.id(385810889376243633)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4024_PAGE_ID,P4024_REQUEST,P4024_CLEAR_CACHE,P4024_ARG_NAMES,P4024_ARG_VALUES,P4024_COMMA_SEP1,P4024_COMMA_SEP2,P4024_COMMA_SEP3,P4024_CLEAR_PAGE,P4024_PINTER_FRIENDLY'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(385811158041243636)
,p_event_id=>wwv_flow_imp.id(385810889376243633)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4024_URL_TARGET'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(385811202327243637)
,p_event_id=>wwv_flow_imp.id(385810889376243633)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4024_URL_TARGET'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_04025
begin
wwv_flow_imp_page.create_page(
 p_id=>4025
,p_name=>'Create Navigation Bar Entry - Display Condition'
,p_alias=>'CREATE-NAVIGATION-BAR-ENTRY-DISPLAY-CONDITION'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Navigation Bar Entry'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213263531591941060)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_navbar.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(694570598)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(103870209211856610)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_plug_query_headings=>'Seq:Icon:Alt:Conditional'
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'-'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(699599737)
,p_plug_name=>'Create Navigation Bar Entry'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_header=>'<p>Identify a display condition for this Navigation Bar Entry and then click <strong>Create</strong></p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46443208781177145)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(193548722227751980)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(46443208781177145)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(948258037)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46443208781177145)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(953148861)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(46443208781177145)
,p_button_name=>'Back'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(949258039)
,p_branch_action=>'&F4000_LAST_VIEW.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(948258037)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(954148863)
,p_branch_action=>'4024'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(953148861)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(944209567)
,p_name=>'F4000_P4023_CONDITION_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(699599737)
,p_item_default=>'0'
,p_prompt=>'Condition Type'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CONDITION_LIST'
,p_named_lov=>'STANDARD_CONDITION_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(13602414170805697)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Condition -'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a condition type from the list. This condition  must be met in order for this component to be rendered or processed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'F4000_P4023_CONDITION'
,p_attribute_02=>'F4000_P4023_CONDITION_INSTR'
,p_attribute_04=>'F4000_P4023_CONDITION_CHECK'
,p_attribute_06=>'CONDITION'
,p_attribute_07=>'F4000_P4023_CONDITION_LANG'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(945212993)
,p_name=>'F4000_P4023_CONDITION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(699599737)
,p_prompt=>'Expression 1'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'This attribute enables you to conditionally control whether a component is rendered or processed. Enter values in this attribute based on the specific condition type you select. The component will be rendered or processed if the specified condition i'
||'s met.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(946217758)
,p_name=>'F4000_P4023_CONDITION_INSTR'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(699599737)
,p_prompt=>'Expression 2'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Some condition types require two expressions for comparison. Enter the second expression or item here.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1678821880973449)
,p_name=>'F4000_P4023_CONDITION_LANG'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(699599737)
,p_prompt=>'Language'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select a language that is used to evaluate the entered programming code.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(435039717599654780)
,p_name=>'F4000_P4023_CONDITION_CHECK'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(699599737)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Do not validate code (parse code at runtime only).'
,p_source=>'NULL'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(573753213413229713)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(193548722227751980)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(573753313020229714)
,p_event_id=>wwv_flow_imp.id(573753213413229713)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(950258662)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create nav bar'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_imp_shared.create_icon_bar_item (',
'p_flow_id                  => nv(''FB_FLOW_ID''),',
'p_icon_sequence            => nv(''F4000_P4023_SEQUENCE''),',
'p_icon_image               => v(''F4000_P4023_IMG1''),',
'p_icon_image2              => v(''F4000_P4023_IMG2''),',
'p_icon_image3              => v(''F4000_P4023_IMG3''),',
'p_icon_subtext             => v(''F4000_P4023_TEXT1''),',
'p_icon_subtext2            => v(''F4000_P4023_TEXT2''),',
'p_icon_subtext3            => v(''F4000_P4023_TEXT3''),',
'p_icon_target              => v(''F4000_P4023_TARGET''),',
'p_icon_image_alt           => v(''F4000_P4023_ALT''),',
'p_icon_height              => v(''F4000_P4023_H1''),',
'p_icon_width               => v(''F4000_P4023_W1''),',
'p_icon_height2             => v(''F4000_P4023_H2''),',
'p_icon_width2              => v(''F4000_P4023_W2''),',
'p_icon_height3             => v(''F4000_P4023_H3''),',
'p_icon_width3              => v(''F4000_P4023_W3''),',
'p_icon_bar_disp_cond       => v(''F4000_P4023_CONDITION''),',
'p_icon_bar_disp_cond_type  => replace(v(''F4000_P4023_CONDITION_TYPE''),''0'',null),',
'p_icon_bar_flow_cond_instr => v(''F4000_P4023_CONDITION_INSTR''),',
'p_begins_on_new_line       => ''NO'',',
'p_cell_colspan             => ''1'',',
'p_onclick                  => null,',
'p_required_patch           => null,',
'p_icon_bar_comment         => null);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error creating navigation bar entry.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(948258037)
,p_process_success_message=>'Navigation bar created.'
,p_internal_uid=>950258662
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(573755158311229732)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Navigation bar created.'
,p_internal_uid=>573755158311229732
);
end;
/
prompt --application/pages/page_04046
begin
wwv_flow_imp_page.create_page(
 p_id=>4046
,p_name=>'Authorization Schemes by Page'
,p_alias=>'AUTHORIZATION-SCHEMES-BY-PAGE'
,p_page_mode=>'NON_MODAL'
,p_step_title=>'Authorization Schemes by Page'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213425326892450628)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'sec_authorization.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(62159807886965497)
,p_name=>'Pages With Authorization Schemes'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>100
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.id,',
'       a.name,',
'       decode(instr(required_role,''!''),',
'                1,''{NOT}'',',
'                null)||',
'         sec.name r',
'  from wwv_flow_steps a, ',
'       wwv_flow_security_schemes sec',
' where replace(required_role,''!'',null) = to_char(sec.id)',
'   and a.flow_id                       = :FB_FLOW_ID',
'   and a.security_group_id             = :FLOW_SECURITY_GROUP_ID',
'   and sec.flow_id                     = :FB_FLOW_ID',
'   and sec.security_group_id           = :FLOW_SECURITY_GROUP_ID'))
,p_display_when_condition=>'P4046_OPT'
,p_display_when_cond2=>'1'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>50
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No pages found with authorization schemes.'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'Y'
,p_csv_output_link_text=>'Download'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(62160303032965524)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Page'
,p_use_as_row_header=>'Y'
,p_column_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(62160525519965525)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(62185907867164222)
,p_query_column_id=>3
,p_column_alias=>'R'
,p_column_display_sequence=>3
,p_column_heading=>'Authorization Scheme'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>3
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(62163422000988557)
,p_name=>'Pages Without Authorization Schemes'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>130
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select s.id,',
'       s.name',
'  from wwv_flow_steps s',
' where s.flow_id           = :FB_FLOW_ID',
'   and s.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and ( s.required_role is null',
'    or not exists (',
'        select 1',
'          from wwv_flow_security_schemes sec',
'         where sec.flow_id            = :FB_FLOW_ID',
'           and sec.security_group_id  = :FLOW_SECURITY_GROUP_ID',
'           and to_char(sec.id)        = replace(s.required_role,''!'',null) ) )'))
,p_display_when_condition=>'P4046_OPT'
,p_display_when_cond2=>'2'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>50
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No pages found that do not have authorization schemes.'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'Y'
,p_csv_output_link_text=>'Download'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_query_asc_image_attr=>' width="13" height="12" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(62163621613988561)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Page'
,p_use_as_row_header=>'Y'
,p_column_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(62163706422988561)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(62166416590996453)
,p_name=>'P4046_OPT'
,p_item_sequence=>10
,p_item_default=>'1'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
end;
/
prompt --application/pages/page_04047
begin
wwv_flow_imp_page.create_page(
 p_id=>4047
,p_name=>'Shortcuts'
,p_alias=>'SHORTCUTS'
,p_step_title=>'Shortcuts'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213468022923563047)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_cut.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(471994393)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--sideRegion:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use Shortcuts to write frequently used code once and then reference it in many places within your application.  Shortcuts also allow for dynamic generation of code in places that typically only support static text.</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11699437408353367)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(4583987353560664)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(184800416391237029)
,p_plug_name=>'Shortcuts'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with messages as (',
'    select ( select wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_UP_TO_DATE'') from sys.dual ) up_to_date,',
'           ( select wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_NEEDS_REFRESH'') from sys.dual ) needs_refresh,',
'           ( select wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_UNKNOWN'') from sys.dual ) unknown_status,',
'           ( select wwv_flow_lang_dev.builder_message(''SUBSCRIBED_FROM.NONEXISTING_MASTER'') from sys.dual ) no_master',
'      from sys.dual )',
'select s.shortcut_name, ',
'       s.shortcut_type, ',
'       sys.dbms_lob.substr(s.SHORTCUT,512,1) shortcut_text,',
'       s.id,',
'       ''icon-sc-shortcut'' icon_class,',
'       replace(s.shortcut_name,''_'','' '') alt,',
'       wwv_flow_utilities.prepare_url( ',
'           p_url => ''f?p=4000:4048:''||:app_session||''::NO::F4000_P4048_ID:''||s.ID ',
'       ) as link,',
'       replace(s.shortcut_name,''_'','' '') icon_title,',
'       --',
'       case when s.reference_id is not null then',
'           coalesce ( to_char( master.flow_id ),',
'                       messages.no_master )',
'       end as subscribed_from,',
'       ( select case when count(*) > 0 then count(*) end',
'           from wwv_flow_shortcuts sub',
'          where sub.reference_id      = s.id',
'            and sub.security_group_id = :WORKSPACE_ID ) as subscribers,',
'       case when s.reference_id is not null then',
'           case',
'               when master.version_scn = s.version_scn then',
'                   messages.up_to_date',
'               when master.version_scn != s.version_scn then',
'                   messages.needs_refresh',
'               else',
'                   messages.unknown_status',
'           end',
'       end subscription_status,',
'       --',
'       null actions',
' from WWV_FLOW_SHORTCUTS s,',
'      wwv_flow_shortcuts master,',
'      messages',
'where s.flow_id                = :FB_FLOW_ID',
'  and s.security_group_id      = :WORKSPACE_ID',
'  and s.reference_id           = master.id (+)',
'  and s.security_group_id      = master.security_group_id (+)',
''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(184800502564237029)
,p_name=>'Shortcuts'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#LINK#" class="a-IRR-icon"><span class="a-Icon #ICON_CLASS#"></span><span class="a-IRR-iconName">#ICON_TITLE#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(184800717912237035)
,p_db_column_name=>'SHORTCUT_NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Name'
,p_column_link=>'f?p=&APP_ID.:4048:&SESSION.::&DEBUG.::F4000_P4048_ID:#ID#'
,p_column_linktext=>'#SHORTCUT_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(184800831230237036)
,p_db_column_name=>'SHORTCUT_TYPE'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Type'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(184800916994237037)
,p_db_column_name=>'SHORTCUT_TEXT'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Shortcut Text'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(184801029924237037)
,p_db_column_name=>'ID'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(184804332325260074)
,p_db_column_name=>'ALT'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Alt'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(184804408127260075)
,p_db_column_name=>'LINK'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1340561932096198329)
,p_db_column_name=>'SUBSCRIBED_FROM'
,p_display_order=>17
,p_column_identifier=>'K'
,p_column_label=>'Subscribed From'
,p_column_type=>'STRING'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1340562015585198330)
,p_db_column_name=>'SUBSCRIBERS'
,p_display_order=>27
,p_column_identifier=>'L'
,p_column_label=>'Subscribers'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(656717225906281249)
,p_db_column_name=>'ICON_CLASS'
,p_display_order=>37
,p_column_identifier=>'I'
,p_column_label=>'ICON_CLASS'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(656717581534286878)
,p_db_column_name=>'ICON_TITLE'
,p_display_order=>47
,p_column_identifier=>'J'
,p_column_label=>'ICON_TITLE'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1600874504586808)
,p_db_column_name=>'ACTIONS'
,p_display_order=>57
,p_column_identifier=>'M'
,p_column_label=>'Copy'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'TMPL_THEME_3$ACTIONS'
,p_column_alignment=>'CENTER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'ACTIONS_WRAP', 'N',
  'STYLE', 'b-InlineActions--simple')).to_clob
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4568377706763509)
,p_db_column_name=>'SUBSCRIPTION_STATUS'
,p_display_order=>67
,p_column_identifier=>'N'
,p_column_label=>'Subscription Status'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(184804717913266027)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1294709288536645'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_view_mode=>'REPORT'
,p_report_columns=>'SHORTCUT_NAME:SHORTCUT_TYPE:SUBSCRIBED_FROM:SUBSCRIPTION_STATUS:SUBSCRIBERS:ACTIONS:'
,p_sort_column_1=>'SHORTCUT_NAME'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(186549210348731768)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(186543329326722942)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Shortcuts'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(188991005685016539)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(184800416391237029)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4047:&SESSION.::&DEBUG.:4047,RIR::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(115662705243734978)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(184800416391237029)
,p_button_name=>'COPY'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Copy'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:617:&SESSION.::&DEBUG.:617::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(90872727490393442)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(184800416391237029)
,p_button_name=>'create'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:131:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-right-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(463978632)
,p_branch_action=>'4048'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'CREATE_ROW'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(465978634)
,p_branch_action=>'4047'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(467978638)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P4048_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'Unable to compute item value.'
,p_compute_when=>'CREATE_ROW'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(557923157)
,p_computation_sequence=>20
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'4047'
,p_computation_error_message=>'Unable to compute item value.'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(590011398952897506)
,p_name=>'Create Button - Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(90872727490393442)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(590011452554897507)
,p_event_id=>wwv_flow_imp.id(590011398952897506)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(590019836054960386)
,p_name=>'Copy Button - Dialog Closed'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(115662705243734978)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(590020181496960410)
,p_event_id=>wwv_flow_imp.id(590019836054960386)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1601063463586810)
,p_name=>'Copy Column - Dialog Closed'
,p_event_sequence=>30
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(184800416391237029)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1601144103586811)
,p_event_id=>wwv_flow_imp.id(1601063463586810)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4586096540602035)
,p_name=>'Refresh Subscriptions'
,p_event_sequence=>40
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(11699437408353367)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4586486271602035)
,p_event_id=>wwv_flow_imp.id(4586096540602035)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(184800416391237029)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4586995483602036)
,p_event_id=>wwv_flow_imp.id(4586096540602035)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ( this.data.successMessage ) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(179421209808554499)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_RESET_PAGINATION'
,p_process_name=>'Reset Pagination'
,p_attribute_01=>'THIS_PAGE'
,p_internal_uid=>179421209808554499
);
wwv_flow_imp_page.create_component_action(
 p_id=>wwv_flow_imp.id(1600946240586809)
,p_ir_column_id=>wwv_flow_imp.id(1600874504586808)
,p_position_id=>wwv_flow_imp.id(214437533860142316)
,p_display_sequence=>10
,p_template_id=>wwv_flow_imp.id(214438625365151034)
,p_label=>'Copy'
,p_link_target_type=>'REDIRECT_PAGE'
,p_link_target=>'f?p=&APP_ID.:617:&SESSION.::&DEBUG.:617:P617_ID:#ID#'
,p_button_display_type=>'ICON'
,p_icon_css_classes=>'icon-copy'
,p_is_hot=>false
,p_show_as_disabled=>false
);
end;
/
prompt --application/pages/page_04048
begin
wwv_flow_imp_page.create_page(
 p_id=>4048
,p_name=>'Shortcuts'
,p_alias=>'SHORTCUTS1'
,p_step_title=>'Edit Shortcut'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213468022923563047)
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_read_only_when=>'F4000_P4048_REFERENCE_ID'
,p_help_text=>'bldapp_cut.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(418978588)
,p_plug_name=>'Name'
,p_region_name=>'N'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'generated 04-SEP-2000 16:36:50'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(525681934)
,p_plug_name=>'Source'
,p_region_name=>'SRC'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(530699890)
,p_plug_name=>'Shortcuts'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>90
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Shortcuts are a repository of shared static or dynamic HTML.  Shortcuts are substitution strings that are expanded using the syntax: "SHORTCUT_NAME".  Shortcuts are used in the following locations:',
'<ul>',
'<li>Region Source for regions of type HTML_WITH_SHORTCUTS</li>',
'<li>Region Templates, Region Headers &amp; Footers</li>',
'<li>Item Labels</li>',
'<li>Item Default Value</li>',
'<li>Item Post Element Text</li>',
'<li>Item Help Text</li>',
'<li>HTML Header of a page</li>',
'</ul>'))
,p_plug_query_num_rows=>10
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'L:L:L:R'
,p_plug_query_number_formats=>':::999,999,990'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(544791081)
,p_plug_name=>'Comments'
,p_region_name=>'C'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(33428223869359883)
,p_plug_name=>'Subscription'
,p_region_name=>'SUBSCRIPTION'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'WWV_FLOW_SHORTCUTS',
  'attribute_02', 'SHORTCUT_NAME',
  'attribute_03', 'F4000_P4048_ID',
  'attribute_04', 'F4000_P4048_REFERENCE_ID',
  'attribute_05', 'SUBSCRIBE_SHORTCUT',
  'attribute_06', 'VERSION_SCN')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46252909255679001)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(93334400585521646)
,p_plug_name=>'Shortcut'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(167217503879480109)
,p_plug_name=>'Configuration'
,p_region_name=>'CONF'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(183169630693815096)
,p_plug_name=>'Item Substitutions'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Creating shortcuts on page item labels and page item post element text attributes can include the following substitution strings:',
'<span class="tiny">',
'<br />#CURRENT_FORM_ELEMENT#',
'<br />#CURRENT_ITEM_ID#',
'<br />#CURRENT_ITEM_NAME#',
'<br />#CURRENT_ITEM_HELP_TEXT#',
'</span>',
''))
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(615485504460192258)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(29434107863295859)
,p_plug_display_sequence=>60
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from WWV_FLOW_SHORTCUTS ',
'where id = :F4000_P4048_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id=> :F4000_P4048_ID,',
'      p_component_type=> ''Shortcuts'',',
'      p_last_updated_by=> c1.last_updated_by,',
'      p_last_updated_on=> c1.last_updated_on,',
'      p_created_by=> c1.created_by,',
'      p_created_on=> c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(185095622707075273)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(33428223869359883)
,p_button_name=>'PUBLISH_SHORTCUT'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Publish Shortcut'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.::F4000_P149_ID,F4000_P149_PAGE_ID,F4000_P149_TEMPLATE_TYPE:&F4000_P4048_ID.,&FLOW_PAGE_ID.,SHORTCUT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_shortcuts',
' where reference_id      = :F4000_P4048_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(421978593)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(93334400585521646)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4578923812880944)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(33428223869359883)
,p_button_name=>'UNSUBSCRIBE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Unsubscribe'
,p_button_position=>'NEXT'
,p_button_condition=>':F4000_P4048_REFERENCE_ID is not null and :P4048_SUBSCRIBED_COMP_GRP = ''N'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(423978594)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(93334400585521646)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P4048_ID is not null ',
'and ( :F4000_P4048_REFERENCE_ID is null or :P4048_SUBSCRIBED_COMP_GRP = ''N'' )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(185103611672100533)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(33428223869359883)
,p_button_name=>'REFRESH_SHORTCUT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Refresh Shortcut'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P4048_REFERENCE_ID is not null ',
'and ( :F000_P4048_VERSION_SCN != :F4000_P4048_MASTER_VERSION_SCN or :F000_P4048_VERSION_SCN is null )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(425978595)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(93334400585521646)
,p_button_name=>'SAVE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    :F4000_P4048_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(427978595)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(93334400585521646)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P4048_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(185107516612104106)
,p_branch_name=>'Go To Page 4048'
,p_branch_action=>'f?p=&APP_ID.:4048:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(185103611672100533)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(411978585)
,p_branch_name=>'Go To Page 4047'
,p_branch_action=>'f?p=&APP_ID.:4047:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'Create'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(413978587)
,p_branch_name=>'Go To Page 4047'
,p_branch_action=>'f?p=&APP_ID.:4047:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'Delete'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(415978587)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(429978599)
,p_name=>'F4000_P4048_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(418978588)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(435978610)
,p_name=>'F4000_P4048_SHORTCUT_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(418978588)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>'SHORTCUT_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The shortcut name identifies the shortcut and is the name that the shortcut is referenced using.  To reference a shortcut use the "SHORTCUT_NAME" syntax wherever a shortcut is permitted  The name will automatically be converted into all uppercase.  A'
||'ll references to shortcuts must be in upper case.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(439978615)
,p_name=>'F4000_P4048_SHORTCUT_TYPE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(525681934)
,p_use_cache_before_default=>'NO'
,p_item_default=>'HTML_TEXT'
,p_prompt=>'Type'
,p_source=>'SHORTCUT_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'SHORTCUT_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(84752421139794200)||'.'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'The shortcut type identifies what is in the shortcut text.  This field is required.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(449978619)
,p_name=>'F4000_P4048_BUILD_OPTION'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(167217503879480109)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Build Option'
,p_source=>'BUILD_OPTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PATCHES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(patch_name) pn, id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'', wwv_flow_escape.html(patch_name))||',
'''} '' pn,0-id id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by pn'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Build Option -'
,p_lov_null_value=>'%null%'
,p_cSize=>64
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select a build option for this component.</p>',
'<p>Build options are predefined settings that determine whether or not  components within an application are enabled.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(451978620)
,p_name=>'F4000_P4048_ERROR_TEXT'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(525681934)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Error Text'
,p_source=>'ERROR_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'If an error should occur during the processing of a shortcut then the following text is displayed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(453978622)
,p_name=>'F4000_P4048_SHORTCUT'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(525681934)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Shortcut'
,p_source=>'SHORTCUT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>10
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Text of the shortcut.  The shortcut must be less then 4000 characters in length.  The text is processed based on the shortcut type.',
'',
'Support substitution strings include #PAGE_TITLE# (the title of the current page), #CURRENT_FORM_ELEMENT# (the number of the current HTML form element), #CURRENT_ITEM_ID# (the generated ID of the current item), #CURRENT_ITEM_NAME#, and #CURRENT_ITEM_'
||'HELP_TEXT#.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(542789374)
,p_name=>'F4000_P4048_COMMENTS'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(544791081)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comments'
,p_source=>'COMMENTS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Enter any comments or notes here.  These comments will never be displayed when running the application</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1418268925012520)
,p_name=>'P4048_SUBSCRIBED_COMP_GRP'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(33428223869359883)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2406579956684625)
,p_name=>'F4000_P4048_SHORTCUT_LANG'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(525681934)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Language'
,p_source=>'SHORTCUT_LANGUAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select a language that is used to evaluate the entered programming code.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_02=>'F4000_P4048_SHORTCUT_TYPE'
,p_attribute_03=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4567618229763502)
,p_name=>'F000_P4048_VERSION_SCN'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(33428223869359883)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select version_scn ',
'  from wwv_flow_shortcuts',
' where id                = :F4000_P4048_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4567857413763504)
,p_name=>'F4000_P4048_MASTER_VERSION_SCN'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(33428223869359883)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select version_scn ',
'  from wwv_flow_shortcuts',
' where id                = :F4000_P4048_REFERENCE_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4568494327763510)
,p_name=>'F4000_P4048_REFERENCE_ID_INIT'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(33428223869359883)
,p_use_cache_before_default=>'NO'
,p_item_default=>'F4000_P4048_REFERENCE_ID'
,p_item_default_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(185065508719001406)
,p_name=>'F4000_P4048_REFERENCE_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(33428223869359883)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Subscribe From'
,p_source=>'REFERENCE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FLOW_SUBSCRIBE_FROM_SHORTCUTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||',
'wwv_flow_lang.system_message(''NO_SHORTCUT'')||',
''' -'' d, 0 r from sys.dual union all',
'select flow_id||'' : ''||shortcut_name d, id r',
'from   wwv_flow_shortcuts',
'where  flow_id != nvl(:fb_flow_id,0) and flow_id in (',
'select f.id',
'from   wwv_main_apps_dev f',
'where  security_group_id = :flow_security_group_id and',
'       build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') and',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id is null and security_group_id = :flow_security_group_id)',
'       or',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id = f.id and security_group_id = :flow_security_group_id )',
')',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'You may base the shortcut definition on an existing shortcut in this application or another in your workspaces schema.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1418315501012521)
,p_computation_sequence=>10
,p_computation_item=>'P4048_SUBSCRIBED_COMP_GRP'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_component_group_dev.is_part_of_subscribed_comp_grp (',
'    p_component_id   => :F4000_P4048_ID,',
'    p_component_type => wwv_flow_copy_metadata.c_shortcut,',
'    p_app_id         => :FB_FLOW_ID )'))
,p_compute_when=>'F4000_P4048_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(185112530833112696)
,p_validation_name=>'F4000_P4048_SHORTCUT_NAME Not Null'
,p_validation_sequence=>10
,p_validation=>'F4000_P4048_SHORTCUT_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Name must be specified.'
,p_associated_item=>wwv_flow_imp.id(435978610)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 01-MAR-2002 14:24'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(185122511208121784)
,p_validation_name=>'reference id not null'
,p_validation_sequence=>20
,p_validation=>'F4000_P4048_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Reference ID must be specified to refresh the shortcut.'
,p_when_button_pressed=>wwv_flow_imp.id(185103611672100533)
,p_associated_item=>wwv_flow_imp.id(185065508719001406)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(185130927586129409)
,p_validation_name=>'reference id not zero'
,p_validation_sequence=>30
,p_validation=>'F4000_P4048_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_ZERO'
,p_error_message=>'Shortcut to refresh must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(185103611672100533)
,p_associated_item=>wwv_flow_imp.id(185065508719001406)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(373231310358857202)
,p_validation_name=>'check pl/sql'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_f4000_util.check_plsql(',
'    :F4000_P4048_SHORTCUT,',
'    :FB_FLOW_ID,',
'    :FLOW_SECURITY_GROUP_ID',
');'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':F4000_P4048_SHORTCUT_TYPE = ''FUNCTION_BODY'' and :F4000_P4048_SHORTCUT_LANG = ''PLSQL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(425978595)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3956355232478234)
,p_validation_name=>'Not part of component groups'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not wwv_flow_component_group_dev.is_part_of_comp_grp (',
'    p_component_id   => :F4000_P4048_ID,',
'    p_component_type => wwv_flow_copy_metadata.c_shortcut,',
'    p_app_id         => :FB_FLOW_ID )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Shortcut cannot be deleted because it is part of a component group.'
,p_when_button_pressed=>wwv_flow_imp.id(423978594)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4576519501848006)
,p_name=>'Hide F4000_P4048_REFERENCE_ID'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'F4000_P4048_REFERENCE_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4576938160848007)
,p_event_id=>wwv_flow_imp.id(4576519501848006)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4048_REFERENCE_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(16494163668178002)
,p_name=>'Apply changes'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(425978595)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(16494203238178003)
,p_event_id=>wwv_flow_imp.id(16494163668178002)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'Are you sure you want to subscribe to the selected master shortcut? This will overwrite current shortcut data with selected master shortcut.'
,p_attribute_03=>'warning'
,p_attribute_06=>'Subscribe'
,p_attribute_07=>'Cancel'
,p_client_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_client_condition_expression=>'$v(''F4000_P4048_REFERENCE_ID'') !== "" && $v(''F4000_P4048_REFERENCE_ID_INIT'') === ""'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(16494378588178004)
,p_event_id=>wwv_flow_imp.id(16494163668178002)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'SAVE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(455978628)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_SHORTCUTS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_SHORTCUTS'
,p_attribute_03=>'F4000_P4048_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_process_error_message=>'Error fetching row.'
,p_internal_uid=>455978628
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(457978630)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_SHORTCUTS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_SHORTCUTS'
,p_attribute_03=>'F4000_P4048_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_process_error_message=>'Error processing row.'
,p_process_success_message=>'Action processed.'
,p_internal_uid=>457978630
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(185137100185157284)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh shortcut'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.refresh_component (',
'    p_component_type     => wwv_flow_copy_metadata.c_shortcut,',
'    p_master_id          => :F4000_P4048_REFERENCE_ID,',
'    p_subscribing_id     => :F4000_P4048_ID,',
'    p_subscribing_app_id => :FB_FLOW_ID );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying shortcut.'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST = ''REFRESH_SHORTCUT''',
'or ( :REQUEST = ''SAVE'' and :F4000_P4048_REFERENCE_ID is not null and :F4000_P4048_REFERENCE_ID_INIT is null )'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Shortcut refreshed.'
,p_internal_uid=>185137100185157284
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(185140903623170925)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove reference id'
,p_process_sql_clob=>'wwv_flow_copy_metadata.remove_shortcut_reference_id (:F4000_P4048_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error setting reference id to null.'
,p_process_when_button_id=>wwv_flow_imp.id(425978595)
,p_process_when=>'F4000_P4048_REFERENCE_ID'
,p_process_when_type=>'VALUE_OF_ITEM_IN_COND_1_EQ_COND_2'
,p_process_when2=>'0'
,p_internal_uid=>185140903623170925
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4578554021873961)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Unsubscribe'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.unsubscribe_component (',
'    p_component_type  => wwv_flow_copy_metadata.c_shortcut,',
'    p_component_id    => :F4000_P4048_ID,',
'    p_app_id          => :FB_FLOW_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(4578923812880944)
,p_process_success_message=>'Shortcut is no longer subscribed to its master shortcut.'
,p_internal_uid=>4578554021873961
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4906180056904076)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Clear Subscriptions'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- when deleting the component, clear reference_id data from subscribing apps',
'--',
'wwv_flow_copy_metadata.clear_subscriptions (',
'    p_component_type => wwv_flow_copy_metadata.c_shortcut,',
'    p_master_id      => :F4000_P4048_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(423978594)
,p_internal_uid=>4906180056904076
);
end;
/
prompt --application/pages/page_04050
begin
wwv_flow_imp_page.create_page(
 p_id=>4050
,p_name=>'List Details'
,p_alias=>'LIST-DETAILS'
,p_step_title=>'List Details'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213210808239773454)
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_read_only_when=>'P4050_REFERENCE_ID'
,p_help_text=>'nav_list.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1496810553895860)
,p_plug_name=>'List Query'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P4050_LIST_TYPE'
,p_plug_display_when_cond2=>'STATIC'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4904664492688543)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4904760105688544)
,p_plug_name=>'Name'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_LISTS'
,p_query_where=>'security_group_id = :WORKSPACE_ID'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4904802874688545)
,p_plug_name=>'Subscription'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'WWV_FLOW_LISTS',
  'attribute_02', 'NAME',
  'attribute_03', 'F4000_P4050_LIST_ID',
  'attribute_04', 'P4050_REFERENCE_ID',
  'attribute_05', 'SUBSCRIBE_LIST',
  'attribute_06', 'VERSION_SCN')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4904954406688546)
,p_plug_name=>'Configuration'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6301625345031116)
,p_plug_name=>'Comments'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(33434828256111704)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(33430506092105266)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
,p_plug_display_condition_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_plug_display_when_condition=>'F4000_P4050_LIST_ID'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(188598218337740337)
,p_plug_name=>'List: &P4050_NAME.'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_04'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(466869405573124318)
,p_plug_name=>'List Details'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>List can be static or dynamic. When the list is static, the list may contain any number of list entries. For dynamic lists, the number of list entries depends on the list query output. When you delete a list, then corresponding list regions are de'
||'leted as well.</p><p>When list is subscribed, then it is not possible to change any data that is copied from the master list.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(622178476623944606)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_imp.id(29434107863295859)
,p_plug_display_sequence=>80
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'    select last_updated_by,',
'           last_updated_on,',
'           created_by,',
'           created_on ',
'      from wwv_flow_lists',
'     where id                = :F4000_P4050_LIST_ID',
'       and security_group_id = :FLOW_SECURITY_GROUP_ID )',
'loop',
'    wwv_flow_4000_ui.show_history (',
'       p_id              => :F4000_P4050_LIST_ID,',
'       p_component_type  => ''List'',',
'       p_last_updated_by => c1.last_updated_by,',
'       p_last_updated_on => c1.last_updated_on,',
'       p_created_by      => c1.created_by,',
'       p_created_on      => c1.created_on );',
'    exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(665073618803777080)
,p_plug_name=>'List Entries'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       list_id,',
'       flow_id,',
'       list_item_display_sequence,',
'       list_item_link_text,',
'       list_item_link_target,',
'       list_item_current_type,',
'       list_item_current_for_pages,',
'       list_item_icon,',
'       list_text_01,',
'       list_text_02,',
'       list_text_03,',
'       list_text_04,',
'       list_text_05,',
'       list_text_06,',
'       list_text_07,',
'       list_text_08,',
'       list_text_09,',
'       list_text_10,',
'       list_text_11,',
'       list_text_12,',
'       parent_list_item_id,',
'       list_item_icon_attributes,',
'       list_item_icon_alt_attribute,',
'       list_item_status,',
'       item_displayed,',
'       list_item_type,',
'       list_item_current_language,',
'       list_item_disp_cond_type,',
'       list_item_disp_condition,',
'       list_item_disp_condition2,',
'       security_scheme,',
'       required_patch,',
'       list_countclicks_y_n,',
'       list_countclicks_cat,',
'       translate_list_text_y_n,',
'       ( select nullif( count( c.id ), 0 )',
'           from wwv_flow_list_items c',
'          where list_id           = :F4000_P4050_LIST_ID',
'            and flow_id           = :FB_FLOW_ID',
'            and security_group_id = :WORKSPACE_ID',
'          start with c.parent_list_item_id = p.id',
'        connect by c.parent_list_item_id = prior c.id ) as child_item_count,',
'        --',
'       ( select case when count( c.id ) > 0 then ''U'' else ''UD'' end',
'           from wwv_flow_list_items c',
'          where list_id           = :F4000_P4050_LIST_ID',
'            and flow_id           = :FB_FLOW_ID',
'            and security_group_id = :WORKSPACE_ID',
'          start with c.parent_list_item_id = p.id',
'        connect by c.parent_list_item_id = prior c.id  ) as allowed_operations,',
'        --',
'       ( select hierarchy_level from (',
'             select id, level as hierarchy_level',
'               from (',
'                      select *',
'                        from wwv_flow_list_items',
'                       where list_id           = :F4000_P4050_LIST_ID',
'                         and flow_id           = :FB_FLOW_ID',
'                         and security_group_id = :WORKSPACE_ID',
'                    ) c',
'              start with c.parent_list_item_id is null',
'            connect by c.parent_list_item_id = prior c.id  ) where id = p.id ) as this_level,',
'       decode(list_item_disp_cond_type,null,null,''Y'') conditional,',
'       last_updated_on',
'  from wwv_flow_list_items p',
' where list_id           = :F4000_P4050_LIST_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_plug_source_type=>'NATIVE_IG'
,p_ajax_items_to_submit=>'F4000_P4050_LIST_ID'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P4050_LIST_TYPE'
,p_plug_display_when_cond2=>'STATIC'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'List Entries'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3900995930269003)
,p_name=>'CONDITIONAL'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'CONDITIONAL'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Conditional'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>430
,p_value_alignment=>'LEFT'
,p_attribute_02=>'LOV'
,p_attribute_05=>'PLAIN'
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(84887415298521126)
,p_lov_display_extra=>true
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3901059803269004)
,p_name=>'LAST_UPDATED_ON'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LAST_UPDATED_ON'
,p_data_type=>'DATE'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Updated On'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>440
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_format_mask=>'SINCE'
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_date_ranges=>'ALL'
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6301743750031117)
,p_name=>'PARENT_LIST_ITEM_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'PARENT_LIST_ITEM_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Parent Entry'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>280
,p_value_alignment=>'LEFT'
,p_attribute_02=>'LOV'
,p_attribute_05=>'PLAIN'
,p_lov_type=>'SQL_QUERY'
,p_lov_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select list_item_link_text d, id r',
'  from wwv_flow_list_items',
' where list_id           = :F4000_P4050_LIST_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_lov_display_extra=>true
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6301816106031118)
,p_name=>'LIST_ITEM_ICON_ATTRIBUTES'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_ITEM_ICON_ATTRIBUTES'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>290
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6301970499031119)
,p_name=>'LIST_ITEM_ICON_ALT_ATTRIBUTE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_ITEM_ICON_ALT_ATTRIBUTE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>300
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6302055261031120)
,p_name=>'LIST_ITEM_STATUS'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_ITEM_STATUS'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>310
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6302130147031121)
,p_name=>'ITEM_DISPLAYED'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ITEM_DISPLAYED'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>320
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6302213295031122)
,p_name=>'LIST_ITEM_TYPE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_ITEM_TYPE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>330
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6302301652031123)
,p_name=>'LIST_ITEM_CURRENT_LANGUAGE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_ITEM_CURRENT_LANGUAGE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>340
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6302473786031124)
,p_name=>'LIST_ITEM_DISP_COND_TYPE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_ITEM_DISP_COND_TYPE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>350
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6302535393031125)
,p_name=>'LIST_ITEM_DISP_CONDITION'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_ITEM_DISP_CONDITION'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>360
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6302664382031126)
,p_name=>'LIST_ITEM_DISP_CONDITION2'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_ITEM_DISP_CONDITION2'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>370
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6302732314031127)
,p_name=>'SECURITY_SCHEME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'SECURITY_SCHEME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Authorization Scheme'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>380
,p_value_alignment=>'LEFT'
,p_is_required=>false
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(283664112341)
,p_lov_display_extra=>false
,p_lov_display_null=>true
,p_lov_null_text=>'- No Authorization Required -'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
,p_help_text=>'Optionally select an authorization scheme which must evaluate to TRUE in order for this component to be rendered or otherwise processed.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6302867032031128)
,p_name=>'REQUIRED_PATCH'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'REQUIRED_PATCH'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Build Option'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>390
,p_value_alignment=>'LEFT'
,p_is_required=>false
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(198057397)
,p_lov_display_extra=>false
,p_lov_display_null=>true
,p_lov_null_text=>'- No Build Option -'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
,p_help_text=>'Select a build option for this component. Build options are predefined settings that determine whether or not components within an application are enabled.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6302968131031129)
,p_name=>'LIST_COUNTCLICKS_Y_N'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_COUNTCLICKS_Y_N'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>400
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6303054088031130)
,p_name=>'LIST_COUNTCLICKS_CAT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_COUNTCLICKS_CAT'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>410
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6303119304031131)
,p_name=>'TRANSLATE_LIST_TEXT_Y_N'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'TRANSLATE_LIST_TEXT_Y_N'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>420
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(101782253139691407)
,p_name=>'CHILD_ITEM_COUNT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'CHILD_ITEM_COUNT'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Children'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>250
,p_value_alignment=>'RIGHT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>true
,p_help_text=>'If the list item acts as a <em>parent</em> item, the total number of children is reported here. Items with existing child items cannot be deleted.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(101782313142691408)
,p_name=>'ALLOWED_OPERATIONS'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ALLOWED_OPERATIONS'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>260
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_is_primary_key=>false
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(101782419966691409)
,p_name=>'THIS_LEVEL'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'THIS_LEVEL'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Level'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>270
,p_value_alignment=>'RIGHT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>true
,p_help_text=>'This represents the hierarchy level of the list item.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(114877574336332692)
,p_name=>'LIST_ITEM_ICON'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_ITEM_ICON'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Icon'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>120
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Identify an image file name or the icon class for the icon associated with this list entry.',
'<br><br>',
'<strong>Using Universal Theme</strong>',
'<br>',
'Most Universal Theme apps use the Font APEX icon library. To pick an icon, use the built-in icon picker and select an icon from the popup window. See examples below:<br><br>',
'<ul>',
'    <li><code>fa-cloud</code> - displays the cloud icon</li>',
'    <li><code>fa-exclamation-circle u-danger-text</code> - displays a red exclamation icon</li>',
'</ul>',
'<br>',
'You can see more examples on the  <a rel="noopener noreferrer" href="https://apex.oracle.com/fontapex" target="_blank">Icons</a> page of the <a rel="noopener noreferrer" href="https://apex.oracle.com/ut" target="_blank">Universal Theme sample app</a>'
||'.',
'',
'<br><br>',
'<strong>Using a Custom or Legacy Theme</strong>',
'<br>',
'You can also enter the full image path if your application theme does not use an icon library.'))
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(572417459796084893)
,p_name=>'LIST_ITEM_LINK_TARGET'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_ITEM_LINK_TARGET'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Target'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>90
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(572417559995084894)
,p_name=>'LIST_ITEM_CURRENT_FOR_PAGES'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_ITEM_CURRENT_FOR_PAGES'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>110
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(572417586492084895)
,p_name=>'LIST_TEXT_01'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_TEXT_01'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Attribute 1'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>130
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>'Extra attributes that can be accessed via the list template.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(572417691703084896)
,p_name=>'LIST_TEXT_02'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_TEXT_02'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Attribute 2'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>140
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>'Extra attributes that can be accessed via the list template.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(572417861526084897)
,p_name=>'LIST_TEXT_03'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_TEXT_03'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Attribute 3'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>150
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>'Extra attributes that can be accessed via the list template.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(572418286012084902)
,p_name=>'LIST_ITEM_CURRENT_TYPE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_ITEM_CURRENT_TYPE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>100
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'TARGET_PAGE'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(665073769201777082)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_LINK'
,p_heading=>'Edit'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>40
,p_value_alignment=>'LEFT'
,p_link_target=>'f?p=&APP_ID.:4052:&SESSION.::&DEBUG.:4052:F4000_P4052_ID,FB_FLOW_ID:&ID.,&FB_FLOW_ID.'
,p_link_text=>'<span role="img" class="a-Icon icon-edit" title="&EDIT." aria-label="&EDIT."></span>'
,p_link_attributes=>'class="a-Button a-Button--noUI"'
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function( options ) {',
'    options.defaultGridColumnOptions = {',
'        noHeaderActivate: true',
'    };',
'    return options;',
'}   '))
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_enable_pivot=>false
,p_is_primary_key=>true
,p_duplicate_value=>false
,p_include_in_export=>false
,p_escape_on_http_output=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(665073888091777083)
,p_name=>'LIST_ITEM_DISPLAY_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_ITEM_DISPLAY_SEQUENCE'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>'Sequence'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>70
,p_value_alignment=>'RIGHT'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_enable_pivot=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>'Specify the sequence for this component. The sequence determines the order of evaluation.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(665074002372777084)
,p_name=>'LIST_ITEM_LINK_TEXT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_ITEM_LINK_TEXT'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>80
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>true
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_enable_pivot=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>'Identify the text of the link.  The display of this link text is controlled by list templates.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(665074625200777090)
,p_name=>'LIST_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>50
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_enable_pivot=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'F4000_P4050_LIST_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(665074797530777092)
,p_name=>'APEX$ROW_ACTION'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_label=>'Actions'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>20
,p_value_alignment=>'CENTER'
,p_use_as_row_header=>false
,p_enable_hide=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(665074952311777093)
,p_name=>'APEX$ROW_SELECTOR'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_use_as_row_header=>false
,p_enable_hide=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(719513912489900324)
,p_name=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FLOW_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>60
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'FB_FLOW_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(719514453403900329)
,p_name=>'LIST_TEXT_04'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_TEXT_04'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Attribute 4'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>160
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>'Extra attributes that can be accessed via the list template.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(722650155724446780)
,p_name=>'LIST_TEXT_05'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_TEXT_05'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Attribute 5'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>170
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>'Extra attributes that can be accessed via the list template.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(722650188032446781)
,p_name=>'LIST_TEXT_06'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_TEXT_06'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Attribute 6'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>180
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>'Extra attributes that can be accessed via the list template.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(722650269125446782)
,p_name=>'LIST_TEXT_07'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_TEXT_07'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Attribute 7'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>190
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>'Extra attributes that can be accessed via the list template.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(722650423698446783)
,p_name=>'LIST_TEXT_08'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_TEXT_08'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Attribute 8'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>200
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>'Extra attributes that can be accessed via the list template.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(722650534438446784)
,p_name=>'LIST_TEXT_09'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_TEXT_09'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Attribute 9'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>210
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>'Extra attributes that can be accessed via the list template.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(722650634486446785)
,p_name=>'LIST_TEXT_10'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_TEXT_10'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Attribute 10'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>220
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>'Extra attributes that can be accessed via the list template.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(722650707392446786)
,p_name=>'LIST_TEXT_11'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_TEXT_11'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>230
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(722650817079446787)
,p_name=>'LIST_TEXT_12'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_TEXT_12'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>240
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(665073716046777081)
,p_internal_uid=>665073716046777081
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_edit_row_operations_column=>'ALLOWED_OPERATIONS'
,p_lost_update_check_type=>'VALUES'
,p_add_row_if_empty=>false
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_show_nulls_as=>'-'
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>true
,p_no_data_found_message=>'No entries defined.'
,p_show_toolbar=>true
,p_toolbar_buttons=>'SEARCH_FIELD:ACTIONS_MENU:RESET'
,p_add_button_label=>'Add Entry'
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>false
,p_define_chart_view=>false
,p_enable_download=>false
,p_download_formats=>null
,p_enable_mail_download=>true
,p_fixed_header=>'NONE'
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(665079563548779201)
,p_interactive_grid_id=>wwv_flow_imp.id(665073716046777081)
,p_static_id=>'2923'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(665079635247779201)
,p_report_id=>wwv_flow_imp.id(665079563548779201)
,p_view_type=>'GRID'
,p_stretch_columns=>true
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5000235838090180)
,p_view_id=>wwv_flow_imp.id(665079635247779201)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(665074797530777092)
,p_is_visible=>true
,p_is_frozen=>true
,p_width=>40
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5000246889090179)
,p_view_id=>wwv_flow_imp.id(665079635247779201)
,p_display_seq=>19
,p_column_id=>wwv_flow_imp.id(719514453403900329)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5000366546090179)
,p_view_id=>wwv_flow_imp.id(665079635247779201)
,p_display_seq=>20
,p_column_id=>wwv_flow_imp.id(722650155724446780)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5000393049090180)
,p_view_id=>wwv_flow_imp.id(665079635247779201)
,p_display_seq=>2
,p_column_id=>wwv_flow_imp.id(665073769201777082)
,p_is_visible=>true
,p_is_frozen=>true
,p_width=>60
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5000475030090179)
,p_view_id=>wwv_flow_imp.id(665079635247779201)
,p_display_seq=>21
,p_column_id=>wwv_flow_imp.id(722650188032446781)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5000509096090180)
,p_view_id=>wwv_flow_imp.id(665079635247779201)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(665074625200777090)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5000552780090179)
,p_view_id=>wwv_flow_imp.id(665079635247779201)
,p_display_seq=>22
,p_column_id=>wwv_flow_imp.id(722650269125446782)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5000600743090180)
,p_view_id=>wwv_flow_imp.id(665079635247779201)
,p_display_seq=>4
,p_column_id=>wwv_flow_imp.id(719513912489900324)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5000715157090179)
,p_view_id=>wwv_flow_imp.id(665079635247779201)
,p_display_seq=>23
,p_column_id=>wwv_flow_imp.id(722650423698446783)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5000721499090180)
,p_view_id=>wwv_flow_imp.id(665079635247779201)
,p_display_seq=>5
,p_column_id=>wwv_flow_imp.id(665073888091777083)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>100
,p_sort_order=>2
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5000747040090180)
,p_view_id=>wwv_flow_imp.id(665079635247779201)
,p_display_seq=>6
,p_column_id=>wwv_flow_imp.id(665074002372777084)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>150
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5000750525090180)
,p_view_id=>wwv_flow_imp.id(665079635247779201)
,p_display_seq=>25
,p_column_id=>wwv_flow_imp.id(722650534438446784)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5000839595090180)
,p_view_id=>wwv_flow_imp.id(665079635247779201)
,p_display_seq=>37
,p_column_id=>wwv_flow_imp.id(722650634486446785)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5000897249090180)
,p_view_id=>wwv_flow_imp.id(665079635247779201)
,p_display_seq=>7
,p_column_id=>wwv_flow_imp.id(572417459796084893)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>250
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5000979692090180)
,p_view_id=>wwv_flow_imp.id(665079635247779201)
,p_display_seq=>8
,p_column_id=>wwv_flow_imp.id(572418286012084902)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>182
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5001060118090180)
,p_view_id=>wwv_flow_imp.id(665079635247779201)
,p_display_seq=>9
,p_column_id=>wwv_flow_imp.id(572417559995084894)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>100
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5001195247090181)
,p_view_id=>wwv_flow_imp.id(665079635247779201)
,p_display_seq=>11
,p_column_id=>wwv_flow_imp.id(572417586492084895)
,p_is_visible=>false
,p_is_frozen=>false
,p_width=>100
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5001318716090181)
,p_view_id=>wwv_flow_imp.id(665079635247779201)
,p_display_seq=>12
,p_column_id=>wwv_flow_imp.id(572417691703084896)
,p_is_visible=>false
,p_is_frozen=>false
,p_width=>100
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5001355303090181)
,p_view_id=>wwv_flow_imp.id(665079635247779201)
,p_display_seq=>13
,p_column_id=>wwv_flow_imp.id(572417861526084897)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(7601155077927402)
,p_view_id=>wwv_flow_imp.id(665079635247779201)
,p_display_seq=>17
,p_column_id=>wwv_flow_imp.id(6301743750031117)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>80
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(7602006040927408)
,p_view_id=>wwv_flow_imp.id(665079635247779201)
,p_display_seq=>27
,p_column_id=>wwv_flow_imp.id(6301816106031118)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(7602960566927411)
,p_view_id=>wwv_flow_imp.id(665079635247779201)
,p_display_seq=>28
,p_column_id=>wwv_flow_imp.id(6301970499031119)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(7603803335927414)
,p_view_id=>wwv_flow_imp.id(665079635247779201)
,p_display_seq=>29
,p_column_id=>wwv_flow_imp.id(6302055261031120)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(7604768203927416)
,p_view_id=>wwv_flow_imp.id(665079635247779201)
,p_display_seq=>30
,p_column_id=>wwv_flow_imp.id(6302130147031121)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(7605620637927419)
,p_view_id=>wwv_flow_imp.id(665079635247779201)
,p_display_seq=>31
,p_column_id=>wwv_flow_imp.id(6302213295031122)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(7606568190927422)
,p_view_id=>wwv_flow_imp.id(665079635247779201)
,p_display_seq=>32
,p_column_id=>wwv_flow_imp.id(6302301652031123)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(7607436313927425)
,p_view_id=>wwv_flow_imp.id(665079635247779201)
,p_display_seq=>33
,p_column_id=>wwv_flow_imp.id(6302473786031124)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(7608306404927427)
,p_view_id=>wwv_flow_imp.id(665079635247779201)
,p_display_seq=>34
,p_column_id=>wwv_flow_imp.id(6302535393031125)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(7609252663927430)
,p_view_id=>wwv_flow_imp.id(665079635247779201)
,p_display_seq=>35
,p_column_id=>wwv_flow_imp.id(6302664382031126)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(7610160819927433)
,p_view_id=>wwv_flow_imp.id(665079635247779201)
,p_display_seq=>14
,p_column_id=>wwv_flow_imp.id(6302732314031127)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>150
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(7611083560927435)
,p_view_id=>wwv_flow_imp.id(665079635247779201)
,p_display_seq=>15
,p_column_id=>wwv_flow_imp.id(6302867032031128)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>150
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(7611999002927438)
,p_view_id=>wwv_flow_imp.id(665079635247779201)
,p_display_seq=>38
,p_column_id=>wwv_flow_imp.id(6302968131031129)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(7612823850927442)
,p_view_id=>wwv_flow_imp.id(665079635247779201)
,p_display_seq=>39
,p_column_id=>wwv_flow_imp.id(6303054088031130)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(7613724763927444)
,p_view_id=>wwv_flow_imp.id(665079635247779201)
,p_display_seq=>40
,p_column_id=>wwv_flow_imp.id(6303119304031131)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(7701193744559119)
,p_view_id=>wwv_flow_imp.id(665079635247779201)
,p_display_seq=>41
,p_column_id=>wwv_flow_imp.id(3900995930269003)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>80
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(8204680403840447)
,p_view_id=>wwv_flow_imp.id(665079635247779201)
,p_display_seq=>42
,p_column_id=>wwv_flow_imp.id(3901059803269004)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>80
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(105955857368477313)
,p_view_id=>wwv_flow_imp.id(665079635247779201)
,p_display_seq=>18
,p_column_id=>wwv_flow_imp.id(101782253139691407)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>80
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(105956279100477308)
,p_view_id=>wwv_flow_imp.id(665079635247779201)
,p_display_seq=>24
,p_column_id=>wwv_flow_imp.id(101782313142691408)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(105956832729477306)
,p_view_id=>wwv_flow_imp.id(665079635247779201)
,p_display_seq=>16
,p_column_id=>wwv_flow_imp.id(101782419966691409)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>80
,p_sort_order=>1
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(155154472633830748)
,p_view_id=>wwv_flow_imp.id(665079635247779201)
,p_display_seq=>10
,p_column_id=>wwv_flow_imp.id(114877574336332692)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>100
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1366429426254103066)
,p_view_id=>wwv_flow_imp.id(665079635247779201)
,p_display_seq=>26
,p_column_id=>wwv_flow_imp.id(722650707392446786)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1366429519437103067)
,p_view_id=>wwv_flow_imp.id(665079635247779201)
,p_display_seq=>36
,p_column_id=>wwv_flow_imp.id(722650817079446787)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(10001417059466535)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(665073618803777080)
,p_button_name=>'CREATE_LIST_ITEM'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'Create Entry'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:4052:&SESSION.::&DEBUG.:4052::'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_lists',
' where id = :F4000_P4050_LIST_ID',
'   and nvl(list_type,''STATIC'') = ''STATIC''',
'   and flow_id = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and :P4050_REFERENCE_ID is null'))
,p_button_condition_type=>'EXISTS'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1499003515035673)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(188598218337740337)
,p_button_name=>'SAVE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    :F4000_P4050_LIST_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(11400373113450689)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(188598218337740337)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(6303208968031132)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(188598218337740337)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'EDIT'
,p_confirm_message=>'&DELETE_MSG.'
,p_button_condition=>':P4050_REFERENCE_ID is null or :P4050_SUBSCRIBED_COMP_GRP = ''N'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3305127825465849)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(4904802874688545)
,p_button_name=>'PUBLISH'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Publish'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.:149:F4000_P149_ID,F4000_P149_TEMPLATE_TYPE,F4000_P149_PAGE_ID:&F4000_P4050_LIST_ID.,LIST,4050'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * ',
'  from wwv_flow_lists',
' where reference_id = :F4000_P4050_LIST_ID   ',
'   and security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(28401102894554702)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(4904802874688545)
,p_button_name=>'UNSUBSCRIBE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Unsubscribe'
,p_button_position=>'EDIT'
,p_button_condition=>':P4050_REFERENCE_ID is not null and :P4050_SUBSCRIBED_COMP_GRP = ''N'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3304741421465845)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(4904802874688545)
,p_button_name=>'REFRESH_LIST'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Refresh List'
,p_button_position=>'EDIT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P4050_REFERENCE_ID is not null ',
'and ( :P4050_VERSION_SCN != :P4050_MASTER_VERSION_SCN or :P4050_VERSION_SCN is null )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(448041105)
,p_branch_action=>'4052'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'CREATE_ROW'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(6303357886031133)
,p_branch_name=>'Delete List - Go To Page 405'
,p_branch_action=>'f?p=&APP_ID.:405:&SESSION.::&DEBUG.:4050::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(6303208968031132)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(423984514)
,p_name=>'F4000_P4050_LIST_ID'
,p_data_type=>'NUMBER'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(4904760105688544)
,p_item_source_plug_id=>wwv_flow_imp.id(4904760105688544)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1416659319012504)
,p_name=>'P4050_SUBSCRIBED_COMP_GRP'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(4904802874688545)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1497810694980982)
,p_name=>'P4050_LIST_QUERY'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(1496810553895860)
,p_item_source_plug_id=>wwv_flow_imp.id(4904760105688544)
,p_prompt=>'Query'
,p_source=>'LIST_QUERY'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cMaxlength=>4000
,p_cHeight=>14
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a list SQL Query or Function returning a SQL Query  to generate a dynamic list.</p>',
'<strong>SQL Query Syntax:</strong>',
'<pre>',
'select level, labelValue label, ',
'       [targetValue]            target, ',
'       [is_current]             is_current_list_entry,',
'       [imageValue]             image, ',
'       [imageAttributeValue]    image_attribute,',
'       [imageAltValue]          image_alt_attribute,',
'       [attribute1]             attribute1,',
'       [attribute2]             attribute2,',
'       [attribute3]             attribute3,',
'       [attribute4]             attribute4,',
'       [attribute5]             attribute5,',
'       [attribute6]             attribute6,',
'       [attribute7]             attribute7,',
'       [attribute8]             attribute8,',
'       [attribute9]             attribute9,',
'       [attribute10]            attribute10',
'from ...',
'where ...',
'order by ...',
'</pre>',
'',
'<strong>Function Returning SQL Query Syntax:</strong>',
'<pre>',
'RETURN',
'''select level, labelValue label,''||',
'''       [targetValue]         target,''|| ',
'''       [is_current]          is_current_list_entry,''||',
'''       [imageValue]          image,''||',
'''       [imageAttributeValue] image_attribute, ''||',
'''       [imageAltValue]       image_alt_attribute,''||',
'''       [attribute1]          attribute1,''||',
'''       [attribute2]          attribute2,''||',
'''       [attribute3]          attribute3,''||',
'''       [attribute4]          attribute4,''||',
'''       [attribute5]          attribute5,''||',
'''       [attribute6]          attribute6,''||',
'''       [attribute7]          attribute7,''||',
'''       [attribute8]          attribute8,''||',
'''       [attribute9]          attribute9,''||',
'''       [attribute10]         attribute10''||',
'''from ...''||',
'''where ...''||',
'''order by ...'';',
'</pre>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PAGE_ITEM'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_06=>'P4050_EDITOR_MODE'
,p_attribute_07=>'N'
,p_item_comment=>'nvl(v(''P464_QUERY''),''x'') != ''.'''
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2525718390409144)
,p_name=>'P4050_VERSION_SCN'
,p_source_data_type=>'NUMBER'
,p_is_query_only=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(4904802874688545)
,p_item_source_plug_id=>wwv_flow_imp.id(4904760105688544)
,p_source=>'VERSION_SCN'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2525867735409145)
,p_name=>'P4050_MASTER_VERSION_SCN'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(4904802874688545)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select version_scn ',
'  from wwv_flow_lists',
' where id                = :P4050_REFERENCE_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4905298062688549)
,p_name=>'P4050_FLOW_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(4904760105688544)
,p_item_source_plug_id=>wwv_flow_imp.id(4904760105688544)
,p_source=>'FLOW_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4905390226688550)
,p_name=>'P4050_NAME'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(4904760105688544)
,p_item_source_plug_id=>wwv_flow_imp.id(4904760105688544)
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter a name for the list you are creating.  Numeric or alphanumeric list names are permitted.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6300260114031102)
,p_name=>'P4050_LIST_LANGUAGE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(1496810553895860)
,p_item_source_plug_id=>wwv_flow_imp.id(4904760105688544)
,p_source=>'LIST_LANGUAGE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6300739943031107)
,p_name=>'P4050_REQUIRED_PATCH'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(4904954406688546)
,p_item_source_plug_id=>wwv_flow_imp.id(4904760105688544)
,p_prompt=>'Build Option'
,p_source=>'REQUIRED_PATCH'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PATCHES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(patch_name) pn, id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'', wwv_flow_escape.html(patch_name))||',
'''} '' pn,0-id id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by pn'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Build Option -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a build option for this component. Build options are predefined settings that determine whether or not components within an application are enabled.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6301379495031113)
,p_name=>'P4050_LIST_COMMENT'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(6301625345031116)
,p_item_source_plug_id=>wwv_flow_imp.id(4904760105688544)
,p_prompt=>'Comments'
,p_source=>'LIST_COMMENT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter any comments or notes for developers. These comments will never be displayed when running the application.'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6301418852031114)
,p_name=>'P4050_REFERENCE_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(4904802874688545)
,p_item_source_plug_id=>wwv_flow_imp.id(4904760105688544)
,p_prompt=>'Subscribe From'
,p_source=>'REFERENCE_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FLOW_SUBSCRIBE_FROM_LISTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select flow_id||'' : ''||name d,',
'       id r',
'  from wwv_flow_lists l',
' where flow_id != nvl(:FB_FLOW_ID,0)',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and exists (',
'        select *',
'          from wwv_main_apps_dev f',
'         where f.security_group_id = :FLOW_SECURITY_GROUP_ID',
'           and f.build_status      not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'           and l.flow_id           = f.id )',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Subscription -'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a master list to subscribe from. When you select a master list and click on "Apply Changes" button, then list details will be automatically refreshed from the master list.<br /><br />If the list is already subscribed, then use "Refresh List" b'
||'utton to refresh list details from the master list.'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'Y'
,p_attribute_06=>'0'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(10697604668749425)
,p_name=>'P4050_LIST_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1496810553895860)
,p_item_source_plug_id=>wwv_flow_imp.id(4904760105688544)
,p_item_default=>'SQL_QUERY'
,p_prompt=>'Query Source Type'
,p_source=>'LIST_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'FLASH_CHART_QUERY_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(6026412205740110)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select the query source type.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28401048161554701)
,p_name=>'P4050_REFERENCE_ID_INIT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(4904802874688545)
,p_use_cache_before_default=>'NO'
,p_item_default=>'P4050_REFERENCE_ID'
,p_item_default_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(78408500074861201)
,p_name=>'P4050_EDITOR_MODE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1496810553895860)
,p_use_cache_before_default=>'NO'
,p_source=>'case when :P4050_LIST_TYPE = ''SQL_QUERY'' then ''SQL'' else ''PLSQL_FUNCTION_BODY'' end'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1416739747012505)
,p_computation_sequence=>10
,p_computation_item=>'P4050_SUBSCRIBED_COMP_GRP'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_component_group_dev.is_part_of_subscribed_comp_grp (',
'    p_component_id   => :F4000_P4050_LIST_ID,',
'    p_component_type => wwv_flow_copy_metadata.c_list,',
'    p_app_id         => :FB_FLOW_ID )'))
,p_compute_when=>'F4000_P4050_LIST_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(450041106)
,p_computation_sequence=>30
,p_computation_item=>'F4000_P4052_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'Unable to compute item value.'
,p_compute_when=>'wwv_flow.g_request = ''CREATE_ROW'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(6303425549031134)
,p_computation_sequence=>40
,p_computation_item=>'P4050_LIST_LANGUAGE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'case when :P4050_LIST_TYPE = ''FUNCTION_RETURNING_SQL_QUERY'' then ''PLSQL'' else null end'
,p_compute_when=>'SAVE'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(28401287693554703)
,p_computation_sequence=>50
,p_computation_item=>'P4050_REFERENCE_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'UNSUBSCRIBE'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1499725725070526)
,p_validation_name=>'is_valid_list_query'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_f4000_util.is_valid_list_query(',
'    p_query      => :P4050_LIST_QUERY,',
'    p_query_type => :P4050_LIST_TYPE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':P4050_LIST_TYPE in (''SQL_QUERY'',''FUNCTION_RETURNING_SQL_QUERY'') and :F4000_P4050_LIST_ID is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(1499003515035673)
,p_associated_item=>wwv_flow_imp.id(1497810694980982)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(8900749934113988)
,p_validation_name=>'Current Navigation Menu List'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flows',
' where navigation_list_id = :f4000_p4050_list_id',
'   and id                 = :fb_flow_id',
'   and security_group_id  = :flow_security_group_id'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Navigation menu lists cannot be deleted while they are referenced in the user interface attributes.'
,p_when_button_pressed=>wwv_flow_imp.id(6303208968031132)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(9000218093118725)
,p_validation_name=>'Used Navigation Menu List'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_steps s',
' where s.navigation_list_id = :F4000_P4050_LIST_ID',
'   and s.flow_id            = :FB_FLOW_ID',
'   and s.security_group_id  = :FLOW_SECURITY_GROUP_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Navigation menu lists cannot be deleted while they are referenced in application pages.'
,p_when_button_pressed=>wwv_flow_imp.id(6303208968031132)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(9000582339120113)
,p_validation_name=>'Current Navigation Bar List'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flows',
' where nav_bar_list_id   = :f4000_p4050_list_id',
'   and id                = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Navigation bar lists cannot be deleted while they are referenced in the user interface attributes.'
,p_when_button_pressed=>wwv_flow_imp.id(6303208968031132)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(57890133195881037)
,p_validation_name=>'List used in Pages'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_page_plugs',
' where list_id            = :F4000_P4050_LIST_ID ',
'   and flow_id            = :FB_FLOW_ID',
'   and security_group_id  = :FLOW_SECURITY_GROUP_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Lists cannot be deleted while they are referenced in the application pages.'
,p_when_button_pressed=>wwv_flow_imp.id(6303208968031132)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3001478507102309)
,p_validation_name=>'List used as Sub-List'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_list_items',
' where sub_list_id       = :f4000_p4050_list_id',
'   and flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Lists cannot be deleted while they are referenced as sub-lists by other lists.'
,p_when_button_pressed=>wwv_flow_imp.id(6303208968031132)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4171773901198015)
,p_validation_name=>'List name unique'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_lists',
' where security_group_id = :WORKSPACE_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and name              = :P4050_NAME',
'   and id               != nvl(:F4000_P4050_LIST_ID, -1)'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#LABEL# must be unique.'
,p_when_button_pressed=>wwv_flow_imp.id(1499003515035673)
,p_associated_item=>wwv_flow_imp.id(4905390226688550)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1410578109707784)
,p_validation_name=>'No duplicate subscription'
,p_validation_sequence=>100
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_lists',
' where security_group_id = :WORKSPACE_ID ',
'   and flow_id           = :FB_FLOW_ID ',
'   and reference_id      = :P4050_REFERENCE_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'An existing list in this application is subscribed to the same master. Please select another master list.'
,p_validation_condition=>':P4050_REFERENCE_ID is not null and :P4050_REFERENCE_ID_INIT is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(1499003515035673)
,p_associated_item=>wwv_flow_imp.id(6301418852031114)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3000322072504372)
,p_validation_name=>'Not part of component groups'
,p_validation_sequence=>110
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not wwv_flow_component_group_dev.is_part_of_comp_grp (',
'    p_component_id   => :F4000_P4050_LIST_ID,',
'    p_component_type => wwv_flow_copy_metadata.c_list,',
'    p_app_id         => :FB_FLOW_ID )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'List cannot be deleted because it is part of a component group.'
,p_when_button_pressed=>wwv_flow_imp.id(6303208968031132)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(78408616580861202)
,p_name=>'On P4050_LIST_TYPE Change'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4050_LIST_TYPE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(78408738623861203)
,p_event_id=>wwv_flow_imp.id(78408616580861202)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4050_EDITOR_MODE'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'apex.item(''P4050_LIST_TYPE'').getValue() === ''SQL_QUERY'' ? ''SQL'' : ''PLSQL_FUNCTION_BODY'''
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3900730517269001)
,p_name=>'Disable Refresh Button'
,p_event_sequence=>30
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'NOT_EXISTS'
,p_display_when_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from wwv_flow_lists l',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and id                = :P4050_REFERENCE_ID',
''))
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3900892809269002)
,p_event_id=>wwv_flow_imp.id(3900730517269001)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(3304741421465845)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2212367112520658)
,p_name=>'Hide P4050_REFERENCE_ID'
,p_event_sequence=>50
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P4050_REFERENCE_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2212779094520659)
,p_event_id=>wwv_flow_imp.id(2212367112520658)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4050_REFERENCE_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(11095435399588043)
,p_name=>'Apply changes'
,p_event_sequence=>60
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1499003515035673)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(11095557556588044)
,p_event_id=>wwv_flow_imp.id(11095435399588043)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'Are you sure you want to subscribe to the selected master list? This will overwrite current list data with selected master list.'
,p_attribute_03=>'warning'
,p_attribute_06=>'Subscribe'
,p_attribute_07=>'Cancel'
,p_client_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_client_condition_expression=>'$v(''P4050_REFERENCE_ID'') !== "" && $v(''P4050_REFERENCE_ID_INIT'') === ""'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(11095636697588045)
,p_event_id=>wwv_flow_imp.id(11095435399588043)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'SAVE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(6301574243031115)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(4904760105688544)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process List Data'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'SAVE,UNSUBSCRIBE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>' List changes saved.'
,p_internal_uid=>6301574243031115
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5011539167092641)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(665073618803777080)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Edit List Entries - Save Interactive Grid Data'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1499003515035673)
,p_process_success_message=>'List Entries saved.'
,p_internal_uid=>5011539167092641
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3304469812465842)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh List'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_list (',
'    p_master_list_id      => :P4050_REFERENCE_ID,',
'    p_subscribing_list_id => :F4000_P4050_LIST_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST = ''REFRESH_LIST''',
'or (:REQUEST = ''SAVE'' and :P4050_REFERENCE_ID is not null and :P4050_REFERENCE_ID_INIT is null)'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>' List details refreshed from the master list.'
,p_internal_uid=>3304469812465842
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4994259149587604)
,p_process_sequence=>80
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete list'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_f4000_util.delete_list(',
'    p_list_id         => :F4000_P4050_LIST_ID,',
'    p_application_id  => :P4050_FLOW_ID);'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(6303208968031132)
,p_process_success_message=>'List deleted.'
,p_internal_uid=>4994259149587604
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(149048410519026991)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'CheckIfChangedFlow'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P4050_FLOW_ID is not null',
'   then :F4000_P4050_LIST_ID := ''0'';',
'end if;',
':P4050_FLOW_ID := :FB_FLOW_ID;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'nvl(:P4050_FLOW_ID,''-1'') != nvl(:FB_FLOW_ID,''-1'')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_required_patch=>wwv_flow_imp.id(170786031904296885)
,p_internal_uid=>149048410519026991
,p_process_comment=>'Need to test this case after completing all these changes'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4905021750688547)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(4904760105688544)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form List Details'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>4905021750688547
);
end;
/
prompt --application/pages/page_04052
begin
wwv_flow_imp_page.create_page(
 p_id=>4052
,p_name=>'Create / Edit List Entry'
,p_alias=>'CREATE-EDIT-LIST-ENTRY'
,p_step_title=>'Create / Edit List Entry'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213210808239773454)
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function callItempopUp(s1,s2) {',
'     var items = document.getElementById(s1).value.replace(/\,/g,''~'');',
'     var values = document.getElementById(s2).value.replace(/\,/g,''~'');',
'     var url = ''f?p=4000:404:&SESSION.:::404:P404_RETURN1,P404_RETURN2,P404_ITEMS,P404_VALUES:'' + s1 + '','' + s2 + '','' + escape(items) + '','' + escape(values);',
'     popUp (url);',
'}',
'',
'htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';',
''))
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'nav_list.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(430041099)
,p_plug_name=>'Entry'
,p_region_name=>'E'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'generated 17-FEB-2000 00:12:44'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(53980942183)
,p_plug_name=>'User Defined Attributes'
,p_region_name=>'ATT'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_plug_header=>'Substitution strings #A01# - #A10# are optional attributes within a list template, which can be used to reference list entry user defined attributes 1 - 10, respectively. Click <strong>List Template Attributes</strong> to view a more meaningful descr'
||'iption of the substitution strings in use in the list templates available in the current application.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(62089494403)
,p_plug_name=>'Conditions'
,p_region_name=>'CON'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_plug_query_show_nulls_as=>'(null)'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(117870675835)
,p_plug_name=>'Current List Entry'
,p_region_name=>'CUR'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3702017403663645)
,p_plug_name=>'Subentries'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3927618305147337)
,p_plug_name=>'Configuration'
,p_region_name=>'C'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6318908261115812)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>130
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(6276618987043262)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':F4000_P4052_ID is not null and :P4052_REFERENCE_ID is null'
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11914530632270079)
,p_plug_name=>'Target'
,p_region_name=>'TEX'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46254030791679003)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(91214122594391523)
,p_plug_name=>'List Entry'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(121190512604224652)
,p_plug_name=>'Click Counting'
,p_region_name=>'CLI'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(145764027504126720)
,p_plug_name=>'Authorization'
,p_region_name=>'AUT'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(149873601043426764)
,p_name=>'List Entries'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>140
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'REGION_POSITION_03'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with list_items as (',
'  select ',
'    list_item_link_text,  ',
'    id, ',
'    list_item_display_sequence, ',
'    list_item_type, ',
'    parent_list_item_id',
'   from wwv_flow_list_items',
'  where list_id = replace(:F4000_P4050_LIST_ID,''%''||''null%'',null)',
'    and security_group_id = :WORKSPACE_ID ) ',
'  select',
'    substr(''......................................'',0,(level-1)*3) indent,',
'    list_item_link_text,  ',
'    id, ',
'    list_item_display_sequence, ',
'    list_item_type, ',
'    parent_list_item_id',
'from list_items',
'start with parent_list_item_id is null',
'connect by prior id = parent_list_item_id ',
'order siblings by list_item_display_sequence, list_item_link_text'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(11667910335347890)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No list entries defined'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(149873900034426778)
,p_query_column_id=>1
,p_column_alias=>'INDENT'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(149874016710426779)
,p_query_column_id=>2
,p_column_alias=>'LIST_ITEM_LINK_TEXT'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_column_html_expression=>'#LIST_ITEM_DISPLAY_SEQUENCE##INDENT##LIST_ITEM_LINK_TEXT#'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(149874130758426779)
,p_query_column_id=>3
,p_column_alias=>'ID'
,p_column_display_sequence=>3
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(149874214013426779)
,p_query_column_id=>4
,p_column_alias=>'LIST_ITEM_DISPLAY_SEQUENCE'
,p_column_display_sequence=>4
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(149874321856426780)
,p_query_column_id=>5
,p_column_alias=>'LIST_ITEM_TYPE'
,p_column_display_sequence=>5
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(149874424822426780)
,p_query_column_id=>6
,p_column_alias=>'PARENT_LIST_ITEM_ID'
,p_column_display_sequence=>6
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(173343408947359829)
,p_name=>'Page Items'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>150
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'REGION_POSITION_03'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select i.name item_name',
'from wwv_flow_step_items i,',
'     wwv_flow_page_plugs r',
'where i.flow_id = :fb_flow_id and',
'      i.flow_step_id = :fb_flow_page_id and',
'      i.security_group_id = :flow_security_group_id and',
'      i.item_plug_id(+) = r.id',
'order by r.plug_name, i.ITEM_SEQUENCE, i.name'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(11667910335347890)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No Page Items found.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(173343611809359833)
,p_query_column_id=>1
,p_column_alias=>'ITEM_NAME'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(466869601203132495)
,p_plug_name=>'List Entry'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Define the list entry.  Each entry is typically a link to page in this application or a URL.</p><p>When list is subscribed, then it is not possible to change any data that is copied from the master list.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(615280628695471882)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_imp.id(29434107863295859)
,p_plug_display_sequence=>100
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from  WWV_FLOW_LIST_ITEMS',
'where id = :F4000_P4052_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :F4000_P4052_ID,',
'      p_component_type => ''List Entry'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(925159348439646118)
,p_plug_name=>'Developer Resources'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>132
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(26512283167477231)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(212143516770567204)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(53980942183)
,p_button_name=>'VIEW_UTILIZATION'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'View List Utilization'
,p_button_redirect_url=>'f?p=&APP_ID.:417:&SESSION.::&DEBUG.:RP,RIR:IR_LIST_ID,F4000_LAST_VIEW:&F4000_P4052_LIST_ID.,4052'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1500322967122760213)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(53980942183)
,p_button_name=>'LIST_TEMP_ATTRIBUTES'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'List Template Attributes'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:50:&SESSION.::&DEBUG.:RP:P50_LIST_ID,P50_LIST_TEMPLATE_ID:&F4000_P4052_LIST_ID.,'
,p_icon_css_classes=>'i icon-right-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(75363617837907452)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(91214122594391523)
,p_button_name=>'APPLY_CHANGES_GET_PREVIOUS_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'disabled=""'
,p_button_comment=>'javascript:htmldb_goSubmit(''GET_PREVIOUS_ID'')'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(75363526977907452)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(91214122594391523)
,p_button_name=>'APPLY_CHANGES_GET_NEXT_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Next'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'disabled=""'
,p_button_comment=>'javascript:htmldb_goSubmit(''GET_NEXT_ID'')'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(431041099)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(91214122594391523)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:4050:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(432041100)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(91214122594391523)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
,p_button_condition=>':F4000_P4052_ID is not null and :P4052_REFERENCE_ID is null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(433041100)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(91214122594391523)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>':F4000_P4052_ID is not null and :P4052_REFERENCE_ID is null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(464203883)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(91214122594391523)
,p_button_name=>'CreateAgain'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Create and Create Another'
,p_button_position=>'NEXT'
,p_button_condition=>':F4000_P4052_ID is null and :P4052_REFERENCE_ID is null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30361126085886687)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(91214122594391523)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create List Entry'
,p_button_position=>'NEXT'
,p_button_condition=>':F4000_P4052_ID is null and :P4052_REFERENCE_ID is null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(75373303591907501)
,p_branch_action=>'f?p=&APP_ID.:4052:&SESSION.::&DEBUG.::F4000_P4052_ID:&P4052_ID_NEXT.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(75363526977907452)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(75373611266907503)
,p_branch_action=>'f?p=&APP_ID.:4052:&SESSION.::&DEBUG.::F4000_P4052_ID:&P4052_ID_PREV.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(75363617837907452)
,p_branch_sequence=>20
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(75382726163973412)
,p_branch_action=>'f?p=&APP_ID.:4052:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':P4052_RETURN_TO_PAGE = ''1'' and upper(:REQUEST) != ''DELETE'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(54187577144)
,p_branch_action=>'4052'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>40
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'CreateAgain'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(50153016595557639)
,p_branch_action=>'f?p=&FLOW_ID.:4050:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(435041100)
,p_name=>'F4000_P4052_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(430041099)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(436041100)
,p_name=>'F4000_P4052_LIST_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(430041099)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&F4000_P4050_LIST_ID.'
,p_prompt=>'List:'
,p_source=>'LIST_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'LISTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) d, id ',
'  from wwv_flow_lists',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
' order by upper(name)'))
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(437041101)
,p_name=>'F4000_P4052_LIST_ITEM_TYPE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(430041099)
,p_use_cache_before_default=>'NO'
,p_item_default=>'LINK'
,p_prompt=>'Entry Type'
,p_source=>'LIST_ITEM_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(440041101)
,p_name=>'F4000_P4052_LIST_ITEM_LINK_TEXT'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(430041099)
,p_use_cache_before_default=>'NO'
,p_prompt=>'List Entry Label'
,p_source=>'LIST_ITEM_LINK_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>2
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identify the text of the link.  The display of this link text is controlled by list templates.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(441041102)
,p_name=>'F4000_P4052_LIST_ITEM_LINK_TARGET'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(11914530632270079)
,p_use_cache_before_default=>'NO'
,p_prompt=>'URL Target ( <a class="itemlink" href="javascript:setValue(''F4000_P4052_LIST_ITEM_LINK_TARGET'',''f?p=&FB_FLOW_ID.:&FB_FLOW_PAGE_ID.:&amp;SESSION.'');">f?p=&FB_FLOW_ID.:&FB_FLOW_PAGE_ID.:&amp;SESSION.</a> )'
,p_source=>'LIST_ITEM_LINK_TARGET'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>80
,p_cMaxlength=>255
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(442041104)
,p_name=>'F4000_P4052_LIST_ITEM_ICON'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(430041099)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Image/Class'
,p_post_element_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a class="a-Button a-Button--popupLOV" href="javascript:popupURL(''f?p=4000:654:&SESSION.::::P654_RETURN_ITEM:F4000_P4052_LIST_ITEM_ICON'');"><span class="a-Icon icon-popup-lov"></span><span class="u-VisuallyHidden">"LIST_IMAGE_LOV_TITLE"</span></a>',
''))
,p_source=>'LIST_ITEM_ICON'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Identify an image file name or the icon class for the icon associated with this list entry.',
'<br><br>',
'<strong>Using Universal Theme</strong>',
'<br>',
'Most Universal Theme apps use the Font APEX icon library. To pick an icon, use the built-in icon picker and select an icon from the popup window. See examples below:<br><br>',
'<ul>',
'    <li><code>fa-cloud</code> - displays the cloud icon</li>',
'    <li><code>fa-exclamation-circle u-danger-text</code> - displays a red exclamation icon</li>',
'</ul>',
'<br>',
'You can see more examples on the  <a rel="noopener noreferrer" href="https://apex.oracle.com/fontapex" target="_blank">Icons</a> page of the <a rel="noopener noreferrer" href="https://apex.oracle.com/ut" target="_blank">Universal Theme sample app</a>'
||'.',
'',
'<br><br>',
'<strong>Using a Custom or Legacy Theme</strong>',
'<br>',
'You can also enter the full image path if your application theme does not use an icon library.',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(463184292)
,p_name=>'P4052_LIST_ITEM_DISPLAY_SEQ'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(430041099)
,p_use_cache_before_default=>'NO'
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  s number;',
'begin',
'  select max(LIST_ITEM_DISPLAY_SEQUENCE)',
'    into s',
'    from WWV_FLOW_LIST_ITEMS ',
'   where LIST_ID = :F4000_P4052_LIST_ID',
'     and security_group_id = :WORKSPACE_ID;',
'  s := nvl(s,0);',
'  s := trunc(s) + 10;',
'  return s;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Sequence'
,p_source=>'LIST_ITEM_DISPLAY_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>8
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Specify the sequence for this component. The sequence determines the order of evaluation.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(32343314046)
,p_name=>'F4000_P4052_REQUIRED_PATCH'
,p_item_sequence=>320
,p_item_plug_id=>wwv_flow_imp.id(3927618305147337)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Build Option'
,p_source=>'REQUIRED_PATCH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PATCHES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(patch_name) pn, id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'', wwv_flow_escape.html(patch_name))||',
'''} '' pn,0-id id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by pn'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Build Option -'
,p_lov_null_value=>'%null%'
,p_cSize=>64
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Select a build option for this component.</div>',
'<div class="htmldbInfoBodyP">Build options are predefined settings that determine whether or not  components within an application are enabled.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(32370803678)
,p_name=>'P4052_LIST_ITEM_ICON_ATTR'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(430041099)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Attributes'
,p_source=>'LIST_ITEM_ICON_ATTRIBUTES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct LIST_ITEM_ICON_ATTRIBUTES d, LIST_ITEM_ICON_ATTRIBUTES r',
'  from wwv_flow_list_items',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_cSize=>60
,p_cMaxlength=>2000
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Identify the image attributes (such as width="12" height="12") for the list element image.',
'<p />',
'Use the #LIST_LABEL# substitution string to reference the list label text.  This substitution string allows for the title image attribute to be automatically set based on the value of the list label text.  For example: ',
'<pre>...title="#LIST_LABEL#"...</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(46356878453)
,p_name=>'F4000_P4052_LIST_ITEM_CURRENT_FOR_PAGES'
,p_item_sequence=>270
,p_item_plug_id=>wwv_flow_imp.id(117870675835)
,p_use_cache_before_default=>'NO'
,p_prompt=>'List Entry Current for Condition'
,p_source=>'LIST_ITEM_CURRENT_FOR_PAGES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Based on the selection above, define a condition to evaluate.  When this condition is true then the list item becomes current.',
'</div>',
'<div class="htmldbInfoBodyP">Current items use the current template. Non current items use the non current template. If the condition identified here is true then the item is current. You can cause a list item to use the current template which will g'
||'ive users a visual indication that the current list item is "selected" or somehow "current".</div>',
'<div class="htmldbInfoBodyP">Use commas to separate multiple pages, if many pages are current for this list item.  For example:</div>',
'<pre>',
'5,6,12,15',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(53981946409)
,p_name=>'F4000_P4052_LIST_TEXT_01'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(53980942183)
,p_use_cache_before_default=>'NO'
,p_prompt=>'1.'
,p_source=>'LIST_TEXT_01'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>2
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Extra attributes that can be accessed via the list template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(53982987938)
,p_name=>'F4000_P4052_LIST_TEXT_02'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(53980942183)
,p_use_cache_before_default=>'NO'
,p_prompt=>'2.'
,p_source=>'LIST_TEXT_02'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>2
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Extra attributes that can be accessed via the list template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(53983988598)
,p_name=>'F4000_P4052_LIST_TEXT_03'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(53980942183)
,p_use_cache_before_default=>'NO'
,p_prompt=>'3.'
,p_source=>'LIST_TEXT_03'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>2
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Extra attributes that can be accessed via the list template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(53984989492)
,p_name=>'F4000_P4052_LIST_TEXT_04'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(53980942183)
,p_use_cache_before_default=>'NO'
,p_prompt=>'4.'
,p_source=>'LIST_TEXT_04'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>2
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Extra attributes that can be accessed via the list template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(53985990198)
,p_name=>'F4000_P4052_LIST_TEXT_05'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(53980942183)
,p_use_cache_before_default=>'NO'
,p_prompt=>'5.'
,p_source=>'LIST_TEXT_05'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>2
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Extra attributes that can be accessed via the list template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(53986990876)
,p_name=>'F4000_P4052_LIST_TEXT_06'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(53980942183)
,p_use_cache_before_default=>'NO'
,p_prompt=>'6.'
,p_source=>'LIST_TEXT_06'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>2
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Extra attributes that can be accessed via the list template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(53987991555)
,p_name=>'F4000_P4052_LIST_TEXT_07'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(53980942183)
,p_use_cache_before_default=>'NO'
,p_prompt=>'7.'
,p_source=>'LIST_TEXT_07'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>2
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Extra attributes that can be accessed via the list template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(53988992499)
,p_name=>'F4000_P4052_LIST_TEXT_08'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(53980942183)
,p_use_cache_before_default=>'NO'
,p_prompt=>'8.'
,p_source=>'LIST_TEXT_08'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>2
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Extra attributes that can be accessed via the list template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(53989994310)
,p_name=>'F4000_P4052_LIST_TEXT_09'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(53980942183)
,p_use_cache_before_default=>'NO'
,p_prompt=>'9.'
,p_source=>'LIST_TEXT_09'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>2
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Extra attributes that can be accessed via the list template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(53990995131)
,p_name=>'F4000_P4052_LIST_TEXT_10'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(53980942183)
,p_use_cache_before_default=>'NO'
,p_prompt=>'10.'
,p_source=>'LIST_TEXT_10'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>2
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Extra attributes that can be accessed via the list template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(62087474089)
,p_name=>'F4000_P4052_LIST_ITEM_DISP_COND_TYPE'
,p_item_sequence=>270
,p_item_plug_id=>wwv_flow_imp.id(62089494403)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Condition Type'
,p_source=>'LIST_ITEM_DISP_COND_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CONDITION_LIST'
,p_named_lov=>'STANDARD_CONDITION_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(13602414170805697)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Condition Specified -'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'Y'
,p_help_text=>'<div class="htmldbInfoBodyP">Select a condition type from the list that must be met in order for this component to be rendered processed.</div>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'F4000_P4052_LIST_ITEM_DISP_CONDITION'
,p_attribute_02=>'F4000_P4052_LIST_ITEM_DISP_CONDITION2'
,p_attribute_04=>'F4000_P4052_LIST_ITEM_DISP_CONDITION_CHECK'
,p_attribute_06=>'CONDITION'
,p_attribute_07=>'F4000_P4052_LIST_ITEM_DISP_COND_LANG'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(62088475548)
,p_name=>'F4000_P4052_LIST_ITEM_DISP_CONDITION'
,p_item_sequence=>300
,p_item_plug_id=>wwv_flow_imp.id(62089494403)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Expression 1'
,p_source=>'LIST_ITEM_DISP_CONDITION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>6
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'<div class="htmldbInfoBodyP">This attribute allows you to conditionally control whether or not a  component is rendered or processed. Enter values in this attribute based on the specific condition type selected. The component will be rendered or proc'
||'essed if the specified condition is met.</div>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(85177002763)
,p_name=>'F4000_P4052_LIST_ITEM_DISP_CONDITION2'
,p_item_sequence=>320
,p_item_plug_id=>wwv_flow_imp.id(62089494403)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Expression 2'
,p_source=>'LIST_ITEM_DISP_CONDITION2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>6
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'<div class="htmldbInfoBodyP">Some condition types require two expressions for comparison. Enter the second expression or item here.</div>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(117862616204)
,p_name=>'F4000_P4052_LIST_ITEM_CURRENT_TYPE'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_imp.id(117870675835)
,p_use_cache_before_default=>'NO'
,p_item_default=>'TARGET_PAGE'
,p_prompt=>'List Entry Current for Pages Type'
,p_source=>'LIST_ITEM_CURRENT_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ITEM_CURRENT_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(84729824360877320)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Specify when this list entry should be current based on the page type.</div>',
'<div class="htmldbInfoBodyP">List items can be current or non-current.  Current list items use the current template, non current list items use the non current list item template.  The actual condition and templates are defined in subsequent attribut'
||'es.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(293178618453)
,p_name=>'F4000_P4052_SECURITY_SCHEME'
,p_item_sequence=>310
,p_item_plug_id=>wwv_flow_imp.id(145764027504126720)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Authorization Scheme'
,p_source=>'SECURITY_SCHEME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REQUIRED_ROLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.d, a.r from (',
'    select wwv_flow_lang.system_message(''MUST_NOT_BE_PUBLIC_USER'') d,''MUST_NOT_BE_PUBLIC_USER'' r, 1',
'      from sys.dual',
'    union all',
'    select wwv_flow_escape.html(substr(name,1,50)),to_char(id), 1',
'      from wwv_flow_security_schemes',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID',
'    union all',
'    select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'',wwv_flow_escape.html(substr(name,1,50)))||''}'' d, ''!''||to_char(id) r, 2',
'      from wwv_flow_security_schemes',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID',
'    order by 3,1) a'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Authorization Required -'
,p_lov_null_value=>'%null%'
,p_cSize=>64
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'Y'
,p_help_text=>'<div class="htmldbInfoBodyP">Optionally select an authorization scheme which must evaluate to TRUE in order for this component to be rendered or otherwise processed.</div>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(919320760230919)
,p_name=>'P4052_PARENT_LIST_ITEM_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(430041099)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Parent List Entry'
,p_source=>'PARENT_LIST_ITEM_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST ITEMS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(list_item_link_text) d, id',
'  from (',
'           select lpad('' '', 4 * (level - 1), ''.'') || list_item_link_text list_item_link_text, id',
'             from (',
'                      select id, parent_list_item_id, list_item_display_sequence, list_item_link_text',
'                        from wwv_flow_list_items i',
'                       where flow_id = :fb_flow_id',
'                         and security_group_id = :WORKSPACE_ID',
'                         and list_id = :f4000_p4052_list_id',
'                         and id not in (',
'                                 select id',
'                                   from wwv_flow_list_items',
'                                  where flow_id           = :fb_flow_id',
'                                    and security_group_id = :workspace_id',
'                                    and list_id           = :f4000_p4052_list_id',
'                                  start with id = :f4000_p4052_id',
'                                connect by prior id = parent_list_item_id',
'                             )',
'                         and sub_list_id is null',
'                  )',
'            start with parent_list_item_id is null',
'          connect by prior id = parent_list_item_id',
'            order siblings by list_item_display_sequence',
'       );'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Parent List Item -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id ',
'  from wwv_flow_list_items ',
' where flow_id = :FB_FLOW_ID',
'   and list_id = :F4000_P4052_LIST_ID',
'   and security_group_id = :WORKSPACE_ID   '))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Identify the parent for this list entry. Use this attribute if you are creating a hierarchical list.',
'<p>To create a hierarchical list, you must select a list template that supports hierarchical lists. To determine which list templates support hierarchical lists, look for templates having the naming convention "with Sublist." For more information on '
||'hierarchical list item display, see list template item help.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2318341207209529)
,p_name=>'F4000_P4052_LIST_ITEM_DISP_COND_LANG'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_imp.id(62089494403)
,p_prompt=>'Language'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select a language that is used to evaluate the entered programming code.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2319038303209536)
,p_name=>'F4000_P4052_LIST_ITEM_CURRENT_LANG'
,p_item_sequence=>260
,p_item_plug_id=>wwv_flow_imp.id(117870675835)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Language'
,p_source=>'LIST_ITEM_CURRENT_LANGUAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select a language that is used to evaluate the entered programming code.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_02=>'F4000_P4052_LIST_ITEM_CURRENT_TYPE'
,p_attribute_03=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3002196881102316)
,p_name=>'P4052_SUB_LIST_DISABLED_MSG'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3702017403663645)
,p_prompt=>'List'
,p_source=>'This list item is already referenced as a parent by other items in this List. Remove or reparent child entries to enable property for this list item.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3702138926663646)
,p_name=>'F4000_P4052_SUB_LIST_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3702017403663645)
,p_use_cache_before_default=>'NO'
,p_prompt=>'List'
,p_source=>'SUB_LIST_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name as d,',
'       id   as r',
'  from wwv_flow_lists',
' where flow_id            = :fb_flow_id',
'   and security_group_id  = :workspace_id',
'   and id                != :F4000_P4052_LIST_ID',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Sub List -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Identify the list populating subentries for this list entry. Use this attribute if you are creating a hierarchical list.',
'<p>To create a hierarchical list, you must select a list template that supports hierarchical lists. To determine which list templates support hierarchical lists, look for templates having the naming convention "with Sublist." For more information on '
||'hierarchical list item display, see list template item help.'))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14498429652085716)
,p_name=>'P4052_LIST_ITEM_ICON_ALT'
,p_item_sequence=>75
,p_item_plug_id=>wwv_flow_imp.id(430041099)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Alt Attribute'
,p_source=>'LIST_ITEM_ICON_ALT_ATTRIBUTE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Identify the image alt attribute for the list element image.',
'<p />',
'Use the #LIST_LABEL# substitution string to reference the list label text.  This substitution string allows for the image alt attribute to be automatically set based on the value of the list label text.  For example: ',
'<pre>...alt="#LIST_LABEL#"...</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(15002489638753515)
,p_name=>'P4052_REFERENCE_ID'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(430041099)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17439931431603834)
,p_name=>'P4052_URL_TARGET'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_imp.id(11914530632270079)
,p_prompt=>'URL Target'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a URL target for this list entry.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17445520536714188)
,p_name=>'P4052_PAGE_ID'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(11914530632270079)
,p_prompt=>'Page'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d',
'  from wwv_flow_steps',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and is_page_pattern   = ''N''',
'order by 2'))
,p_cSize=>8
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter the page number.  Check the box next to the page number if you would like to reset pagination for that page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17446401751727725)
,p_name=>'P4052_REQUEST'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(11914530632270079)
,p_prompt=>'Request'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter text that you would like to set the built-in application item REQUEST.  This is also the item that is set with the name of a button that was clicked.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17448018636751567)
,p_name=>'P4052_CLEAR_CACHE'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(11914530632270079)
,p_prompt=>'Clear Cache'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the page numbers, separated by commas, for which you would like the user''s session state to be cleared.  For example:',
'<p />',
'10,11,12',
'<p />',
'You can also reset a collection by passing including a collection name.  ',
'<p />',
'To reset pagination of all reports on a the destination page you can enter the letters "RP".'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17448608032757919)
,p_name=>'P4052_ARG_NAMES'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(11914530632270079)
,p_prompt=>'Set these items'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the list of application item names, separated by a comma, for which you would like to set the session state.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'callItempopUp'
,p_attribute_03=>'Find Item'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17449222576762100)
,p_name=>'P4052_ARG_VALUES'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_imp.id(11914530632270079)
,p_prompt=>'With these values'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter a comma delimited list of values for the items specified in <span class="fielddatabold">Set these items</span>. You can specify static values or substitution syntax (for example, &amp;APP_ITEM_NAME.). ',
'<pre>&amp;APP_ITEM_NAME.</pre>',
'<div class="htmldbInfoBodyP">Item values passed to <span class="fielddatabold">f?p=</span> in the URL may never contain a colon (:). Item values may also not contain commas unless you enclose the entire value in backslash characters. For example:</di'
||'v>',
'<pre>\1234,56\</pre>',
'<div class="htmldbInfoBodyP">This is useful when decimal values must be passed where the NLS decimal separator character is a comma.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'callItempopUp'
,p_attribute_03=>'Find Item'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17851616965567403)
,p_name=>'P4052_URL_OR_FLOW'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(11914530632270079)
,p_item_default=>'FLOW'
,p_prompt=>'Target type'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'URL_OR_PAGE'
,p_lov=>'.'||wwv_flow_imp.id(84796030957080920)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Target -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a target type.  The target is either a page in the current application, or any valid URL. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17891605592018345)
,p_name=>'P4052_CLEAR_PAGE'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(11914530632270079)
,p_prompt=>'Reset pagination for this page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select this checkbox to reset the pagination that is linked to.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'YES'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(36306628512525530)
,p_name=>'P4052_LIST_ITEM_STATUS'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(430041099)
,p_use_cache_before_default=>'NO'
,p_item_default=>'PUBLIC'
,p_prompt=>'Sequence'
,p_source=>'LIST_ITEM_STATUS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>8
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(36308222410533252)
,p_name=>'P4052_ITEM_DISPLAYED'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(430041099)
,p_use_cache_before_default=>'NO'
,p_item_default=>'BY_DEFAULT'
,p_prompt=>'ITEM_DISPLAYED'
,p_source=>'ITEM_DISPLAYED'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>8
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40799027386265055)
,p_name=>'P4052_N'
,p_item_sequence=>480
,p_item_plug_id=>wwv_flow_imp.id(91214122594391523)
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select substr(LIST_ITEM_LINK_TEXT,1,50) n',
'  from WWV_FLOW_LIST_ITEMS',
' where id = :F4000_P4052_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Identifies list entry name'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(75371127504907483)
,p_name=>'P4052_ID_NEXT'
,p_item_sequence=>450
,p_item_plug_id=>wwv_flow_imp.id(91214122594391523)
,p_prompt=>'P4052_ID_NEXT'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(75371520005907484)
,p_name=>'P4052_ID_PREV'
,p_item_sequence=>460
,p_item_plug_id=>wwv_flow_imp.id(91214122594391523)
,p_prompt=>'P4052_ID_PREV'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(75371929675907487)
,p_name=>'P4052_ID_COUNT'
,p_item_sequence=>470
,p_item_plug_id=>wwv_flow_imp.id(91214122594391523)
,p_prompt=>'List Entry: '
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(57731626458856526)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Edit list entry.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(75382021184962574)
,p_name=>'P4052_RETURN_TO_PAGE'
,p_item_sequence=>490
,p_item_plug_id=>wwv_flow_imp.id(91214122594391523)
,p_prompt=>'Return To Page'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when=>'F4000_P4052_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(121186724909203707)
,p_name=>'F4000_P4052_LIST_COUNTCLICKS_Y_N'
,p_item_sequence=>330
,p_item_plug_id=>wwv_flow_imp.id(121190512604224652)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Count Clicks'
,p_source=>'LIST_COUNTCLICKS_Y_N'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES.RETURNS.Y'
,p_lov=>'.'||wwv_flow_imp.id(84886607679518894)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'No - Do not count clicks'
,p_lov_null_value=>'N'
,p_cSize=>96
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'If this is a link to an external page (for example www.google.com) you can count clicks.  Reference API documentation for the "Z" procedure.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(121187420596205732)
,p_name=>'F4000_P4052_LIST_COUNTCLICKS_CAT'
,p_item_sequence=>340
,p_item_plug_id=>wwv_flow_imp.id(121190512604224652)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Click Count Category'
,p_source=>'LIST_COUNTCLICKS_CAT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>255
,p_cHeight=>2
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Reference API documentation for the "Z" procedure.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(206894593488094516)
,p_name=>'P4052_THEME_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(53980942183)
,p_prompt=>'Theme'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(theme_name)||'' - ''||theme_id theme_name, theme_id',
'  from wwv_flow_themes',
'where flow_id = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'order by upper(theme_name)'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select a theme associated with this application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(206915873780097187)
,p_name=>'P4052_LIST_TEMPLATE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(53980942183)
,p_prompt=>'List Template'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(list_template_name) ',
'       || decode( ref_count,',
'                  null,',
'                  '''',',
'                  '' ('' || wwv_flow_lang.message( ''APEX.SC.REFERENCES'', ref_count ) || '')''',
'          ) as list_template_name,',
'       id',
'  from wwv_flow_list_templates l, ',
'         ( select count(*) ref_count, list_template_id',
'             from (',
'                    -- Lists in regions',
'                    select list_template_id as list_template_id',
'                      from wwv_flow_page_plugs p',
'                     where p.flow_id = :fb_flow_id',
'                       and p.page_id != 0',
'                       and p.security_group_id = :flow_security_group_id',
'                       and p.list_id           = :F4000_P4052_LIST_ID',
'',
'                    union all',
'                    -- Application Navigation List',
'                    select navigation_list_template_id as list_template_id',
'                      from wwv_flows f',
'                     where f.id = :fb_flow_id',
'                       and f.security_group_id  = :flow_security_group_id',
'                       and f.navigation_list_id = :F4000_P4052_LIST_ID',
'                    ',
'                    union all',
'                    -- Page may have customized navigation list',
'                    select navigation_list_template_id as list_template_id',
'                      from wwv_flow_steps s',
'                     where s.flow_id = :fb_flow_id',
'                       and s.security_group_id  = :flow_security_group_id',
'                       and s.navigation_list_id = :F4000_P4052_LIST_ID',
'',
'                    union all',
'                    -- Navigation Bar List',
'                    select nav_bar_list_template_id as list_template_id',
'                      from wwv_flows f',
'                     where f.id = :fb_flow_id',
'                       and f.security_group_id = :flow_security_group_id',
'                       and f.nav_bar_list_id   = :F4000_P4052_LIST_ID',
'                )',
'            group by list_template_id',
'          ) ref',
'',
' where l.flow_id = :fb_flow_id',
'   and l.id = ref.list_template_id (+)',
'   and l.security_group_id = :flow_security_group_id',
'   and l.theme_id = :P4052_THEME_ID',
'',
'order by ref.ref_count desc nulls last, list_template_name asc;'))
,p_lov_cascade_parent_items=>'P4052_THEME_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the list template you would like to view. The substitution string attributes will automatically display for the selected list template.  The attribute descriptions aid developers in understanding the use of the optional substitution strings #A'
||'01# - #A10# within a list template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(237447905222885171)
,p_name=>'P4052_PRINTER_FRIENDLY'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(11914530632270079)
,p_prompt=>'Printer friendly'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select this checkbox to set the printer friendly.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'YES'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(435040000513654781)
,p_name=>'F4000_P4052_LIST_ITEM_DISP_CONDITION_CHECK'
,p_item_sequence=>310
,p_item_plug_id=>wwv_flow_imp.id(62089494403)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Do not validate code (parse code at runtime only).'
,p_source=>'NULL'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1062699820597914280)
,p_name=>'P4052_TRANSLATE_LIST_TEXT_Y_N'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(53980942183)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Translatable'
,p_source=>'TRANSLATE_LIST_TEXT_Y_N'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(17513103500929880)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P4052_LIST_ITEM_LINK_TARGET'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_clear_cache varchar2(4000);',
'begin',
'',
'if :P4052_URL_OR_FLOW = ''FLOW'' then',
'  if :P4052_CLEAR_PAGE = ''YES'' then',
'    l_clear_cache := ''RP,''||:P4052_CLEAR_CACHE;',
'  else',
'    l_clear_cache := :P4052_CLEAR_CACHE;',
'  end if;',
'  return ''f?p=&''||''APP_ID.:''||:P4052_PAGE_ID||'':&''||''SESSION.:''||:P4052_REQUEST||'':&''||''DEBUG.:''||rtrim(l_clear_cache,'','')||'':''||:P4052_ARG_NAMES||'':''||:P4052_ARG_VALUES||'':''||:P4052_PRINTER_FRIENDLY;',
'elsif :P4052_URL_OR_FLOW = ''0'' then',
'  return null; ',
'else',
'  return :P4052_URL_TARGET;',
'end if;',
'end;'))
,p_computation_error_message=>'Unable to compute item value.'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2140868191029758142)
,p_computation_sequence=>20
,p_computation_item=>'F4000_P4052_LIST_ITEM_CURRENT_FOR_PAGES'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'F4000_P4052_LIST_ITEM_CURRENT_TYPE'
,p_compute_when_text=>'TARGET_PAGE:NEVER:ALWAYS'
,p_compute_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3001287345102307)
,p_computation_sequence=>30
,p_computation_item=>'F4000_P4052_SUB_LIST_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_comment=>'User should not be able to create the situation where the current item is referenced as parent-item and has a value for sub-list, but to prevent this, we clear the sub-list reference if the item is a parent.'
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_list_items',
' where flow_id             = :fb_flow_id',
'   and security_group_id   = :workspace_id',
'   and parent_list_item_id = :f4000_p4052_id',
'   and :F4000_P4052_SUB_LIST_ID is not null'))
,p_compute_when_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(212143214231567201)
,p_computation_sequence=>10
,p_computation_item=>'P4052_THEME_ID'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select (select max(theme_id) as current_theme_id ',
'            from wwv_flows ',
'           where id = :fb_flow_id)',
'  from wwv_flow_themes t',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(15002562622753516)
,p_computation_sequence=>10
,p_computation_item=>'P4052_REFERENCE_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select reference_id',
'  from wwv_flow_lists',
' where id = :F4000_P4050_LIST_ID',
'   and security_group_id = :WORKSPACE_ID'))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(20973901829489688)
,p_validation_name=>'Must have page if FLOW target'
,p_validation_sequence=>10
,p_validation=>'P4052_PAGE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Page must be specified.'
,p_validation_condition=>':REQUEST not in (''Cancel'',''Delete'') and :P4052_URL_OR_FLOW = ''FLOW'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(17445520536714188)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(159757522215341520)
,p_validation_name=>'is_numeric_sequence'
,p_validation_sequence=>20
,p_validation=>'P4052_LIST_ITEM_DISPLAY_SEQ'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'sequence value must be numeric'
,p_validation_condition=>':REQUEST not in (''Cancel'',''Delete'') and :P4052_URL_OR_FLOW = ''FLOW'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(463184292)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(8127115046963671)
,p_validation_name=>'parent id != id'
,p_validation_sequence=>30
,p_validation=>':P4052_PARENT_LIST_ITEM_ID <> :F4000_P4052_ID'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Parent item must be different from current item.'
,p_when_button_pressed=>wwv_flow_imp.id(433041100)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(178794902235835620)
,p_validation_name=>'F4000_P4052_LIST_ITEM_LINK_TEXT'
,p_validation_sequence=>40
,p_validation=>'F4000_P4052_LIST_ITEM_LINK_TEXT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'List entry label must be specified.'
,p_validation_condition=>':REQUEST not in (''Cancel'',''Delete'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(440041101)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(15002623375753517)
,p_validation_name=>'Prevent modifications if List is subscribed'
,p_validation_sequence=>50
,p_validation=>':P4052_REFERENCE_ID is null'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'It is not possible to modify the list entry, as the list is subscribed from other list.'
,p_validation_condition=>'upper(:REQUEST) in (''DELETE'', ''APPLYCHANGES'', ''CREATEAGAIN'', ''CREATE'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(14604001900749488)
,p_name=>'Item Current Type Setting'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P4052_LIST_ITEM_CURRENT_TYPE'
,p_condition_element=>'F4000_P4052_LIST_ITEM_CURRENT_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'TARGET_PAGE,NEVER,ALWAYS'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(14604317235749499)
,p_event_id=>wwv_flow_imp.id(14604001900749488)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4052_LIST_ITEM_CURRENT_FOR_PAGES'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(14604505742749500)
,p_event_id=>wwv_flow_imp.id(14604001900749488)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4052_LIST_ITEM_CURRENT_FOR_PAGES'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(397298120318466523)
,p_name=>'ENABLE PREVIOUS'
,p_event_sequence=>30
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P4052_ID_PREV'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(397298405505466524)
,p_event_id=>wwv_flow_imp.id(397298120318466523)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(75363617837907452)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(397298526898468334)
,p_name=>'ENABLE NEXT'
,p_event_sequence=>40
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P4052_ID_NEXT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(397298814170468334)
,p_event_id=>wwv_flow_imp.id(397298526898468334)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(75363526977907452)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(385812165106243646)
,p_name=>'URL or Flow Change flow'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4052_URL_OR_FLOW'
,p_condition_element=>'P4052_URL_OR_FLOW'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'FLOW,0'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(385812252882243647)
,p_event_id=>wwv_flow_imp.id(385812165106243646)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4052_URL_TARGET'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(846498626474131701)
,p_event_id=>wwv_flow_imp.id(385812165106243646)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4052_URL_TARGET'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(385812394304243648)
,p_name=>'URL or Flow Change url'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4052_URL_OR_FLOW'
,p_condition_element=>'P4052_URL_OR_FLOW'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'URL,0'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(385812472153243649)
,p_event_id=>wwv_flow_imp.id(385812394304243648)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4052_PAGE_ID,P4052_REQUEST,P4052_CLEAR_CACHE,P4052_ARG_NAMES,P4052_ARG_VALUES'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(385812575761243650)
,p_event_id=>wwv_flow_imp.id(385812394304243648)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4052_PAGE_ID,P4052_REQUEST,P4052_CLEAR_CACHE,P4052_ARG_NAMES,P4052_ARG_VALUES'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(62894500692211647)
,p_name=>'Get Template Attributes Descriptions'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4052_LIST_TEMPLATE_ID'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(62894664611211648)
,p_event_id=>wwv_flow_imp.id(62894500692211647)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var updateLabel = function ( pData ) {',
'    var key,',
'        SEP = ''. '';',
'',
'    var updateLabelText = function ( num, content ) {',
'        var PREFIX  = ''#F4000_P4052_LIST_TEXT_0'',',
'            POSTFIX = ''_LABEL'';',
'        $( PREFIX + num + POSTFIX ).text( content );',
'    }',
'',
'    var resetAllLabels = function(){',
'        var i = 0;',
'        for ( i = 0; i < 10; i++ ) {',
'            updateLabelText( i, i + SEP );',
'        }',
'    };',
'',
'    resetAllLabels();',
'',
'    for ( key in pData ) {',
'        if ( pData.hasOwnProperty( key ) ) {',
'            updateLabelText( key, key + SEP + pData[ key ] );',
'        }',
'    }',
'};',
'',
'apex.server.process (''getAttrDesc'', {',
'    pageItems: "#P4052_LIST_TEMPLATE_ID"',
'    }, {',
'    success: function( pData ) {',
'        updateLabel( pData );',
'    }',
'});'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(212143328323567202)
,p_name=>'Set Default List Template ID'
,p_event_sequence=>80
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'NEVER'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(212143401763567203)
,p_event_id=>wwv_flow_imp.id(212143328323567202)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$( ''#P4052_LIST_TEMPLATE_ID'' ).find( ''option'' ).each(function(){',
'    var option$ = $( this );',
'',
'    if ( option$.text().indexOf( ''*)'' ) > -1 ) {',
'        apex.item( ''P4052_LIST_TEMPLATE_ID'' ).setValue( option$.val() )',
'    }',
'})'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3702478269663649)
,p_name=>'hide SubList'
,p_event_sequence=>90
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXISTS'
,p_display_when_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_list_items',
' where flow_id             = :fb_flow_id',
'   and security_group_id   = :workspace_id',
'   and parent_list_item_id = :f4000_p4052_id'))
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3702549026663650)
,p_event_id=>wwv_flow_imp.id(3702478269663649)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4052_SUB_LIST_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3001032097102305)
,p_event_id=>wwv_flow_imp.id(3702478269663649)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4052_SUB_LIST_DISABLED_MSG'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3002421424102319)
,p_name=>'show SubList'
,p_event_sequence=>100
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'NOT_EXISTS'
,p_display_when_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_list_items',
' where flow_id             = :fb_flow_id',
'   and security_group_id   = :workspace_id',
'   and parent_list_item_id = :f4000_p4052_id'))
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3002579883102320)
,p_event_id=>wwv_flow_imp.id(3002421424102319)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4052_SUB_LIST_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3002664971102321)
,p_event_id=>wwv_flow_imp.id(3002421424102319)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4052_SUB_LIST_DISABLED_MSG'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(184075320258520274)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_LIST_ITEMS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_LIST_ITEMS'
,p_attribute_03=>'F4000_P4052_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_internal_uid=>184075320258520274
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(444041105)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Split URL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'declare',
'  l_dummy varchar2(255);',
'  l_url_parts wwv_flow_global.vc_arr2;',
'begin',
'',
'for c1 in (select list_item_link_target',
'             from wwv_flow_list_items',
'            where id = :F4000_P4052_ID',
'            and security_group_id = wwv_flow_security.g_security_group_id) loop',
'',
'wwv_flow_builder.split_url(',
'  p_url         => c1.list_item_link_target,',
'  p_flow        => l_dummy,',
'  p_page        => :P4052_PAGE_ID,',
'  p_session     => l_dummy,',
'  p_request     => :P4052_REQUEST,',
'  p_debug       => l_dummy,',
'  p_clear_cache => :P4052_CLEAR_CACHE,',
'  p_arg_names   => :P4052_ARG_NAMES,',
'  p_arg_values  => :P4052_ARG_VALUES,',
'  p_success_msg => l_dummy );',
'',
'  if :P4052_PAGE_ID is null then',
'    if c1.list_item_link_target is not null then',
'      :P4052_URL_TARGET := c1.list_item_link_target;',
'      :P4052_URL_OR_FLOW := ''URL'';',
'    else',
'      :P4052_URL_OR_FLOW := ''0'';',
'      :P4052_URL_TARGET := null;',
'    end if;',
'  else',
'    :P4052_URL_TARGET := null;',
'    :P4052_URL_OR_FLOW := ''FLOW'';',
'    if instr(:P4052_CLEAR_CACHE,''RP'') = 1 then',
'      :P4052_CLEAR_PAGE := ''YES'';',
'      :P4052_CLEAR_CACHE := ltrim(replace(:P4052_CLEAR_CACHE,''RP'',null),'','');',
'    else',
'      :P4052_CLEAR_PAGE := null;',
'    end if;',
'    -- Printer Friendly Check',
'    l_url_parts := wwv_flow_utilities.string_to_table(c1.list_item_link_target);',
'',
'    if l_url_parts.exists(9) then',
'      :P4052_PRINTER_FRIENDLY := l_url_parts(9);',
'    else',
'      :P4052_PRINTER_FRIENDLY := null;',
'    end if;',
'',
'  end if;',
'end loop;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error fetching row.'
,p_internal_uid=>444041105
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(75372911895907497)
,p_process_sequence=>30
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_PAGINATION'
,p_process_name=>'Get Next or Previous Primary Key Value'
,p_attribute_02=>'WWV_FLOW_LIST_ITEMS'
,p_attribute_03=>'F4000_P4052_ID'
,p_attribute_04=>'ID'
,p_attribute_07=>'LIST_ITEM_DISPLAY_SEQUENCE'
,p_attribute_08=>'LIST_ITEM_LINK_TEXT'
,p_attribute_09=>'P4052_ID_NEXT'
,p_attribute_10=>'P4052_ID_PREV'
,p_attribute_13=>'P4052_ID_COUNT'
,p_attribute_14=>wwv_flow_string.join(wwv_flow_t_varchar2(
'flow_id = :fb_flow_id',
'and security_group_id = :WORKSPACE_ID',
'and list_id = :F4000_P4050_LIST_ID'))
,p_process_error_message=>'Unable to run Get Next or Previous Primary Key Value process.'
,p_internal_uid=>75372911895907497
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(445041105)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process Row of WWV_FLOW_LIST_ITEMS'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'for c1 in (',
'select 1 from dual',
'where :F4000_P4052_ID is null',
'or exists (select 1 from wwv_flow_list_items',
'                   where security_group_id = :flow_security_group_id and',
'      flow_id = :FB_FLOW_ID and',
'      id = :F4000_P4052_ID)) loop',
'wwv_flow_dml.process(',
'p_action => wwv_flow.g_request,',
'p_table_owner => ''#OWNER#'',',
'p_table_name  => ''WWV_FLOW_LIST_ITEMS'',',
'p_rowid       => v(''F4000_P4052_ID''),',
'p_alt_rowid   => ''ID'');',
'exit;',
'end loop;',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error processing row.'
,p_process_when=>'P4052_REFERENCE_ID'
,p_process_when_type=>'ITEM_IS_NULL'
,p_process_success_message=>'Action processed.'
,p_internal_uid=>445041105
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(466209724)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Clear Cache if Create Again'
,p_process_sql_clob=>'wwv_flow.null_step_cache(4052);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error clearing page cache.'
,p_process_when=>'CreateAgain'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>466209724
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(62894711438211649)
,p_process_sequence=>10
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'getAttrDesc'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'',
'  wwv_flow_json.open_object;',
'',
'  for c1 in (',
'    select A01_LABEL,',
'       A02_LABEL,',
'       A03_LABEL,',
'       A04_LABEL,',
'       A05_LABEL,',
'       A06_LABEL,',
'       A07_LABEL,',
'       A08_LABEL,',
'       A09_LABEL,',
'       A10_LABEL',
'  from WWV_FLOW_LIST_TEMPLATES',
' where id = :P4052_LIST_TEMPLATE_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id = :FB_FLOW_ID )',
'',
'  loop',
'    wwv_flow_json.write( ''1'', c1.A01_LABEL );',
'    wwv_flow_json.write( ''2'', c1.A02_LABEL );',
'    wwv_flow_json.write( ''3'', c1.A03_LABEL );',
'    wwv_flow_json.write( ''4'', c1.A04_LABEL );',
'    wwv_flow_json.write( ''5'', c1.A05_LABEL );',
'    wwv_flow_json.write( ''6'', c1.A06_LABEL );',
'    wwv_flow_json.write( ''7'', c1.A07_LABEL );',
'    wwv_flow_json.write( ''8'', c1.A08_LABEL );',
'    wwv_flow_json.write( ''9'', c1.A09_LABEL );',
'    wwv_flow_json.write( ''10'',c1.A10_LABEL );',
'  end loop;',
'  ',
'  wwv_flow_json.close_object;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>62894711438211649
);
end;
/
prompt --application/pages/page_04053
begin
wwv_flow_imp_page.create_page(
 p_id=>4053
,p_name=>'Change List'
,p_alias=>'CHANGE-LIST'
,p_step_title=>'Change List'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213210808239773454)
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_list.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6431204217672901)
,p_plug_name=>'List Item: &P4053_LIST_ITEM_LINK_TEXT.'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(6488926081057707)
,p_name=>'Parent List'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>160
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select lpad('' '',24*(level-1),''&nbsp;'') || list_item_link_text list_item_link_text',
'from wwv_flow_list_items',
'where flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'start with id = :P4053_ID',
'connect by prior id = parent_list_item_id ',
'order siblings by list_item_display_sequence'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(1041645860037406591)
,p_query_headings_type=>'NO_HEADINGS'
,p_query_num_rows=>10000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'Report returned no rows.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(6497208812081188)
,p_query_column_id=>1
,p_column_alias=>'LIST_ITEM_LINK_TEXT'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(15002794992753518)
,p_plug_name=>'Change Parent List'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>170
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>'This page is used to move selected list entry from one list to another list.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8401214118571915)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(6431204217672901)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:4052:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8435422523631181)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(6431204217672901)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(8216221523533289)
,p_branch_action=>'f?p=&APP_ID.:4053:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'P4053_LIST_ID'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(8435600488631185)
,p_branch_action=>'f?p=&FLOW_ID.:4050:&SESSION.::&DEBUG.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(8435422523631181)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6448009206759577)
,p_name=>'P4053_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(6488926081057707)
,p_prompt=>'ID'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6452205658777400)
,p_name=>'P4053_LIST_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(6488926081057707)
,p_prompt=>'List'
,p_source=>'select list_id from wwv_flow_list_items where id = :P4053_ID'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'EDITABLE_STATIC_LISTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_flow_lists',
' where list_type    = ''STATIC''',
'   and reference_id is null',
'   and flow_id      = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
' order by 1'))
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a list. Dynamic Lists and lists that are subscribed to other lists are not offered here for selection.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6464113895874499)
,p_name=>'P4053_PARENT_LIST_ITEM_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(6488926081057707)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Parent List Item'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select parent_list_item_id',
'  from wwv_flow_list_items',
' where id                = :P4053_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PARENT_LIST.LIST_ITEMS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select lpad('' '',4*(level-1),''.'')|| wwv_flow_escape.html(list_item_link_text) list_item_link_text, id',
'from wwv_flow_list_items i',
'where id not in (',
'    select id from wwv_flow_list_items ',
'    where flow_id = :FB_FLOW_ID',
'    and list_id = :P4053_LIST_ID',
'    and security_group_id = :WORKSPACE_ID',
'    start with id = :P4053_ID ',
'    connect by prior id = parent_list_item_id )',
'and security_group_id = :WORKSPACE_ID',
'start with parent_list_item_id is null',
'       and flow_id = :FB_FLOW_ID',
'       and list_id = :P4053_LIST_ID',
'connect by prior id = parent_list_item_id ',
'        and prior list_id = list_id',
'order siblings by list_item_display_sequence'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Parent List Item -'
,p_lov_null_value=>'0'
,p_lov_cascade_parent_items=>'P4053_LIST_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'If you have a hierarchical list; use this attribute to identify a list items parent.  Displaying a hierarchical list requires a list template which accommodates the display of hierarchical lists.  Reference list template help text for more informatio'
||'n on hierarchical list item display.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8338513482325738)
,p_name=>'P4053_OLD_LIST_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(6488926081057707)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select list_id',
'  from wwv_flow_list_items',
' where id = :P4053_ID',
'   and flow_id = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8430619836611491)
,p_name=>'P4053_LIST_ITEM_LINK_TEXT'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(6431204217672901)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select list_item_link_text',
'  from wwv_flow_list_items',
' where id = :P4053_ID',
'   and flow_id = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'I'
,p_help_text=>'Identify your list item link text.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(8389505844522205)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'update parent list'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'update wwv_flow_list_items',
'set list_id = :P4053_LIST_ID',
'where list_id = :P4053_OLD_LIST_ID',
'and flow_id = :FB_FLOW_ID',
'and security_group_id = :WORKSPACE_ID',
'and id in (',
'    select id',
'    from wwv_flow_list_items',
'    where flow_id = :FB_FLOW_ID',
'      and security_group_id = :WORKSPACE_ID',
'    start with id = :P4053_ID',
'    connect by prior id = parent_list_item_id ',
');',
'',
'if :P4053_PARENT_LIST_ITEM_ID=0 then',
'    update wwv_flow_list_items',
'       set parent_list_item_id = NULL',
'     where id = :P4053_ID',
'       and flow_id = :FB_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID;',
'else',
'    update wwv_flow_list_items',
'       set parent_list_item_id = :P4053_PARENT_LIST_ITEM_ID',
'     where id = :P4053_ID',
'       and flow_id = :FB_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID;',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Update of parent list for current list items and associated sublist items failed.',
'',
''))
,p_process_when_button_id=>wwv_flow_imp.id(8435422523631181)
,p_process_success_message=>'Update of parent list for current list items and associated sublist items was successful.'
,p_internal_uid=>8389505844522205
);
end;
/
prompt --application/pages/page_04069
begin
wwv_flow_imp_page.create_page(
 p_id=>4069
,p_name=>'Create List Template - Copy From'
,p_alias=>'CREATE-LIST-TEMPLATE-COPY-FROM'
,p_page_mode=>'MODAL'
,p_step_title=>'Create List Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(12244490384)
,p_plug_name=>'Create List Template'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_header=>'<p>Select the application that contains the templates you wish to copy.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(177345505779114236)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(320074633987)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(186372503218123509)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(12264554878)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(186372503218123509)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(178299516222547816)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(186372503218123509)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(177347717095117687)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(186372503218123509)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(154528428531099650)
,p_branch_action=>'f?p=&FLOW_ID.:412:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(585124829857099811)
,p_branch_action=>'f?p=&APP_ID.:931:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(177347717095117687)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12255533342)
,p_name=>'F4000_P4069_COPY_FROM_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(12244490384)
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Copy From Application'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select an Application -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the application from which you wish to copy templates.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(178316719733575591)
,p_validation_name=>'F4000_P4069_COPY_FROM_FLOW_ID Not Null'
,p_validation_sequence=>1
,p_validation=>'F4000_P4069_COPY_FROM_FLOW_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Copy From Application must be specified.'
,p_associated_item=>wwv_flow_imp.id(12255533342)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 19-FEB-2002 11:14'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(585124605775099809)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(12264554878)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(585124771388099810)
,p_event_id=>wwv_flow_imp.id(585124605775099809)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_04070
begin
wwv_flow_imp_page.create_page(
 p_id=>4070
,p_name=>'Authorization Schemes'
,p_alias=>'AUTHORIZATION-SCHEMES'
,p_step_title=>'Authorization Schemes'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213425326892450628)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_authorization.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4627541309)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--sideRegion:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>You manage authorization for applications, pages, and most other components using Authorization Schemes.</p>',
'<p>You associate an Authorization Scheme with an application, page, or other component on the component''s attributes page.</p>',
'<p>Authorization Schemes are pass/fail checks.  Common Authorization Scheme types include Exists, Not Exists SQL Queries, and PL/SQL Function Returning Boolean.</p>',
'<p>To enhance performance, the success or failure of an Authorization Scheme is cached on a per session or per page view basis.</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(14681952541787325)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(7570344622934033)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47949307778486335)
,p_plug_name=>'Authorization Schemes'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with messages as (',
'    select ( select wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_UP_TO_DATE'') from sys.dual ) up_to_date,',
'           ( select wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_NEEDS_REFRESH'') from sys.dual ) needs_refresh,',
'           ( select wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_UNKNOWN'') from sys.dual ) unknown_status,',
'           ( select wwv_flow_lang_dev.builder_message(''SUBSCRIBED_FROM.NONEXISTING_MASTER'') from sys.dual ) no_master',
'      from sys.dual )',
'select s.NAME,',
'       s.scheme_type st,',
'       s.caching,',
'       s.id,',
'       s.ERROR_MESSAGE,',
'       --',
'       case when s.reference_id is not null then',
'           coalesce ( to_char( master.flow_id ),',
'                       messages.no_master )',
'       end as subscribed_from,',
'       ( select case when count(*) > 0 then count(*) end',
'           from wwv_flow_security_schemes sub',
'          where sub.reference_id      = s.id',
'            and sub.security_group_id = :WORKSPACE_ID ) as subscribers,',
'       case when s.reference_id is not null then',
'           case',
'               when master.version_scn = s.version_scn then',
'                   messages.up_to_date',
'               when master.version_scn != s.version_scn then',
'                   messages.needs_refresh',
'               else',
'                   messages.unknown_status',
'           end',
'       end subscription_status,',
'       --',
'       ''icon-sc-authorization-scheme'' icon_class,',
'       replace(s.name,''_'','' '') icon_title,',
'       wwv_flow_utilities.prepare_url(',
'           p_url => ''f?p=4000:4008:''||:flow_SESSION||''::NO::F4000_P4008_ID:''||s.ID',
'       ) as edit_link,',
'       replace(s.name,''_'','' '') img_name,',
'       s.last_updated_by,',
'       s.last_updated_on,',
'       s.created_by,',
'       s.created_on,',
'       --',
'       null as actions',
'  from WWV_FLOW_SECURITY_SCHEMES s,',
'       wwv_flow_security_schemes master,',
'       messages',
' where s.flow_id                = :FB_FLOW_ID',
'   and s.security_group_id      = :WORKSPACE_ID',
'   and s.reference_id           = master.id (+)',
'   and s.security_group_id      = master.security_group_id (+)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(47949429235486335)
,p_name=>'Authorization Schemes'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#EDIT_LINK#" class="a-IRR-icon"><span class="a-Icon #ICON_CLASS#"></span><span class="a-IRR-iconName">#ICON_TITLE#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47949605902486429)
,p_db_column_name=>'NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Name'
,p_column_link=>'f?p=&APP_ID.:4008:&SESSION.::&DEBUG.:4008:F4000_P4008_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47949715644486435)
,p_db_column_name=>'ST'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Type'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(11239432234132441)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47949916504486436)
,p_db_column_name=>'CACHING'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Caching'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(84860700520374929)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1340562394549198333)
,p_db_column_name=>'SUBSCRIBED_FROM'
,p_display_order=>14
,p_column_identifier=>'S'
,p_column_label=>'Subscribed From'
,p_column_type=>'STRING'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1340562407259198334)
,p_db_column_name=>'SUBSCRIBERS'
,p_display_order=>24
,p_column_identifier=>'T'
,p_column_label=>'Subscribers'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47950030313486437)
,p_db_column_name=>'ID'
,p_display_order=>34
,p_column_identifier=>'E'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47952131945502695)
,p_db_column_name=>'IMG_NAME'
,p_display_order=>44
,p_column_identifier=>'I'
,p_column_label=>'Img Name'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47954105495544256)
,p_db_column_name=>'ERROR_MESSAGE'
,p_display_order=>54
,p_column_identifier=>'J'
,p_column_label=>'Error Message'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47954321014544281)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>64
,p_column_identifier=>'L'
,p_column_label=>'Created By'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47954412974544282)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>74
,p_column_identifier=>'M'
,p_column_label=>'Created'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47954610343545682)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>84
,p_column_identifier=>'N'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47954710964545682)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>94
,p_column_identifier=>'O'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(656867620569786669)
,p_db_column_name=>'ICON_CLASS'
,p_display_order=>104
,p_column_identifier=>'P'
,p_column_label=>'Icon Class'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(656867711958786669)
,p_db_column_name=>'ICON_TITLE'
,p_display_order=>114
,p_column_identifier=>'Q'
,p_column_label=>'Icon Title'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(656867883500786669)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>124
,p_column_identifier=>'R'
,p_column_label=>'Edit Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1600638724586806)
,p_db_column_name=>'ACTIONS'
,p_display_order=>134
,p_column_identifier=>'U'
,p_column_label=>'Copy'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'TMPL_THEME_3$ACTIONS'
,p_column_alignment=>'CENTER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'ACTIONS_WRAP', 'N',
  'STYLE', 'b-InlineActions--simple')).to_clob
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5728970028070704)
,p_db_column_name=>'SUBSCRIPTION_STATUS'
,p_display_order=>144
,p_column_identifier=>'V'
,p_column_label=>'Subscription Status'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(47951124794493113)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1306012333536647'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_view_mode=>'REPORT'
,p_report_columns=>'NAME:ST:CACHING:SUBSCRIBED_FROM:SUBSCRIPTION_STATUS:SUBSCRIBERS:LAST_UPDATED_ON:ACTIONS:'
,p_sort_column_1=>'NAME'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'LAST_UPDATED_ON'
,p_sort_direction_2=>'DESC NULLS LAST'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(180461031739299652)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(180462022520306486)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Authorization Schemes'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(115177118264903056)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(47949307778486335)
,p_button_name=>'COPY'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Copy'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:493:&SESSION.::&DEBUG.:::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(188928919776662007)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(47949307778486335)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4070:&SESSION.::&DEBUG.:4070,RIR::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(90884429006403343)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_imp.id(47949307778486335)
,p_button_name=>'create'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:184:&SESSION.::&DEBUG.:184,185,186,188::'
,p_icon_css_classes=>'icon-right-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4613513414)
,p_branch_action=>'4008'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'CREATE_ROW'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(4617513415)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P4008_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_comment=>'Set the value of the item conainting the primary key to null when asked to create a new row.'
,p_computation_error_message=>'Unable to compute item value.'
,p_compute_when=>'CREATE_ROW'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(199670330190175566)
,p_computation_sequence=>20
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'4070'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(590130201968619590)
,p_name=>'Create Button - Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(90884429006403343)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(590130582152619590)
,p_event_id=>wwv_flow_imp.id(590130201968619590)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(7565871997982339)
,p_name=>'Refresh Subscriptions'
,p_event_sequence=>20
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(14681952541787325)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7566281847982337)
,p_event_id=>wwv_flow_imp.id(7565871997982339)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(47949307778486335)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7566706130982336)
,p_event_id=>wwv_flow_imp.id(7565871997982339)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ( this.data.successMessage ) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
);
wwv_flow_imp_page.create_component_action(
 p_id=>wwv_flow_imp.id(1600758112586807)
,p_ir_column_id=>wwv_flow_imp.id(1600638724586806)
,p_position_id=>wwv_flow_imp.id(214437533860142316)
,p_display_sequence=>10
,p_template_id=>wwv_flow_imp.id(214438625365151034)
,p_label=>'Copy'
,p_link_target_type=>'REDIRECT_PAGE'
,p_link_target=>'f?p=&APP_ID.:493:&SESSION.::&DEBUG.:493:P493_ID:#ID#'
,p_button_display_type=>'ICON'
,p_icon_css_classes=>'icon-copy'
,p_is_hot=>false
,p_show_as_disabled=>false
);
end;
/
prompt --application/pages/page_04080
begin
wwv_flow_imp_page.create_page(
 p_id=>4080
,p_name=>'Create List of Values - Data Source'
,p_alias=>'CREATE-LIST-OF-VALUES-DATA-SOURCE'
,p_page_mode=>'MODAL'
,p_step_title=>'Create List of Values'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213211113434774960)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_help_text=>'bldapp_rpt.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(107113896747926973)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(155583899503222824)
,p_plug_name=>'Create &F4000_P4004_NAME.'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(64471324421117450)
,p_plug_name=>'Create for local data source'
,p_parent_plug_id=>wwv_flow_imp.id(155583899503222824)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(64471409835117451)
,p_plug_name=>'Create List of Values on REST Data Source'
,p_parent_plug_id=>wwv_flow_imp.id(155583899503222824)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(66262064265725378)
,p_plug_name=>'Create List of Values on Remote SQL'
,p_parent_plug_id=>wwv_flow_imp.id(155583899503222824)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(155584115286222824)
,p_plug_name=>'SQL Query Example'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(399849897040726767)
,p_plug_display_sequence=>40
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'SELECT ename d, ',
'       empno r',
'  FROM emp ',
' ORDER BY 1',
'</pre>'))
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the SQL query definition to populate this list of values. Generally list of value queries are of the form:</p>',
'<pre>',
'select [displayValue],',
'       [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
'<p>Each column selected must have a unique name or alias. Oracle recommends using an alias on any column that includes an SQL expression.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(155590311385227841)
,p_plug_name=>'navigation'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(161740513874429436)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(62694601289169857)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(107113896747926973)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(62695038308169864)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(107113896747926973)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(62695406624169864)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(107113896747926973)
,p_button_name=>'Previous'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:4004:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(8966161347715512)
,p_branch_name=>'Go To Page 4081'
,p_branch_action=>'f?p=&APP_ID.:4081:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(62695038308169864)
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1533236788420609)
,p_name=>'P4080_WEB_SRC_ARRAY_COL_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(64471409835117451)
,p_prompt=>'Array Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select dpc.display_name,',
'       dpc.id',
'  from wwv_flow_web_src_arr_cols_dev dpc',
' where dpc.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and dpc.flow_id           = :FB_FLOW_ID',
'   and dpc.web_src_module_id = :P4080_WEB_SRC_MODULE_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'None'
,p_lov_cascade_parent_items=>'P4080_WEB_SRC_MODULE_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Denotes the Array Column, within the <em>Data Profile</em> of the REST Data Source, to be used for this List of Values.'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1663415361059313)
,p_name=>'P4080_GRAPH_NAME'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(64471324421117450)
,p_prompt=>'Graph Name'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select g.graph_name d, ',
'       g.graph_name r',
'  from sys.dba_property_graphs        g,',
'       wwv_flow_object_owners_dev o',
' where o.owner = g.owner',
'   and g.owner = :P4080_TABLE_OWNER'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_lov_cascade_parent_items=>'P4080_TABLE_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_display_when=>'sys.dbms_db_version.version >= 23'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the Property Graph on which the List of Values will be based.'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1663517519059314)
,p_name=>'P4080_PQL_MATCH_CLAUSE'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(64471324421117450)
,p_prompt=>'Match Clause'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cHeight=>2
,p_display_when=>'sys.dbms_db_version.version >= 23'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a path pattern to find on the property graph. In order to find all edges in your graph, use the following: <strong>(a) - [e] -> (b)</strong>. In addition to this, use <em>label constraints</em> to restrict the types of vertices or edges of i'
||'nterest.</p>',
'<p><strong>Examples</strong></p>',
'<dl>',
'<dt>Find all persons who bought cars.</dt><dd><pre>(p is person) - [t is buys] -> (c is car)</pre></dd>',
'<dt>Find all employees working in departments.</dt><dd><pre>(e is employees) - [is works_at] -> (d is departments)</pre></dd>',
'<dt>Find all employees working in departments who bought cars.</dt><dd><pre>(e is employees) - [is works_at] -> (d is departments), (e is employees) - [t is buys] -> (c is car)</pre></dd>',
'</dl>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1663610369059315)
,p_name=>'P4080_PQL_COLUMNS_CLAUSE'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(64471324421117450)
,p_prompt=>'Columns Clause'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cHeight=>2
,p_display_when=>'sys.dbms_db_version.version >= 23'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Define the query return columns. Those are properties of vertices or edges or expressions using them.</p>',
'<p><strong>Example</strong></p>',
'<dl>',
'<dt>Return <strong>NAME</strong>, <strong>BRAND</strong> and <strong>TOTAL_COST</strong> columns, the latter is the <strong>COST</strong> column, multiplied by 100.</dt>',
'<dd><pre>p.name, c.brand, t.cost * 100 as total_cost</pre></dd>',
'</dl>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1691437837640582)
,p_name=>'P4080_FUNC_BODY_LANG'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(64471324421117450)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Language'
,p_source=>'SHORTCUT_LANGUAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select a language that is used to evaluate the entered programming code.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(23200271467325527)
,p_name=>'P4080_FUNC_BODY'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(64471324421117450)
,p_prompt=>'Enter a Function Body returning a SQL query'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>6
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the SQL query that will produce the results for your List of Values, for example:',
'<pre>',
'return q''~',
'select ename, empno',
'  from emp',
'~'';',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PAGE_ITEM'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_06=>'P4080_FUNC_BODY_LANG'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(62696138761169874)
,p_name=>'P4080_LOCATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(155583899503222824)
,p_item_default=>'LOCAL'
,p_prompt=>'Data Source'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXEC_LOCATION'
,p_lov=>'.'||wwv_flow_imp.id(3842073961668883)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    This picks the <em>Data Source</em> type for the new APEX List of Values.',
'</p>',
'<ul>',
'    <li><strong>Local Database</strong><br>',
'    Data is sourced from the local database.</li>',
'    <li><strong>REST Enabled SQL Service</strong><br>',
'    Data is sourced from a remote database, where the connection is defined using REST Enabled SQL. To create or maintain REST Enabled SQL references, navigate to Shared Components, REST Enabled SQL.',
'    </li>',
'    <li><strong>REST Data Source</strong><br>',
'    Data is sourced from a RESTful web service defined using REST Data Sources. REST Data Sources are created or maintained in Shared Components.',
'    </li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(62697783862169888)
,p_name=>'P4080_SOURCE_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(64471324421117450)
,p_item_default=>'TABLE'
,p_prompt=>'Source Type'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXEC_SQL_DATA_SOURCE_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(601107956819795211)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'List of Values using a Data Source of Local Database ',
'can be based on a Table, SQL Query, PL/SQL Function Returning SQL, or (on Oracle Database 23ai and later) on a Property Graph.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(62699004973169889)
,p_name=>'P4080_TABLE_OWNER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(64471324421117450)
,p_prompt=>'Table / View Owner'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_SCHEMAS_HAVE_PRIVS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(owner) d, owner v',
'  from wwv_flow_object_owners_dev',
'order by d                   '))
,p_lov_cascade_parent_items=>'P4080_SOURCE_TYPE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the owner of the table on which you are building a List of Values.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(62699936633169891)
,p_name=>'P4080_TABLE_NAME'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(64471324421117450)
,p_prompt=>'Table / View Name'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = :P4080_TABLE_OWNER',
'   and :P4080_SOURCE_TYPE = ''TABLE'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Value -'
,p_lov_cascade_parent_items=>'P4080_TABLE_OWNER,P4080_SOURCE_TYPE'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the table or view on which the List of Values will be based.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(62703092726169894)
,p_name=>'P4080_SQL'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(64471324421117450)
,p_prompt=>'Enter a SQL SELECT statement'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>6
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the SQL query that will produce the results for your List of Values, for example:',
'<pre>',
'select ename, empno',
'  from emp',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(62710063600169925)
,p_name=>'P4080_WEB_SRC_MODULE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(64471409835117451)
,p_prompt=>'REST Data Source'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APP_WEB_SOURCES_FOR_REPORTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_flow_web_src_modules m',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and exists ( select 1 ',
'                  from wwv_flow_web_src_operations',
'                 where web_src_module_id = m.id',
'                   and database_operation = ''FETCH_COLLECTION'' )',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the REST Data Source which supports fetching a collection.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(62711699254169926)
,p_name=>'P4080_REMOTE_SERVER_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(66262064265725378)
,p_prompt=>'REST Enabled SQL Service'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REMOTE_SQL_SERVERS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_remote_servers',
' where server_type = ''REMOTE_SQL''',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the remote database server.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(62712070268169926)
,p_name=>'P4080_REMOTE_SOURCE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(66262064265725378)
,p_item_default=>'TABLE'
,p_prompt=>'Source Type'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_lov=>'STATIC2:Table;TABLE,SQL Query;SQL'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Specify the source of the new page. List of Values using a Data Source of REST Enabled SQL Service can be based on a Table or SQL Query.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(62712957037169927)
,p_name=>'P4080_REMOTE_SQL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(66262064265725378)
,p_prompt=>'Enter a SQL SELECT statement'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>6
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the SQL query that will produce the results for your List of Values, for example:',
'<pre>',
'select ename, empno',
'  from emp',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_05=>'P4080_REMOTE_SERVER_ID'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(62713888294169928)
,p_name=>'P4080_REMOTE_TABLE_OWNER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(66262064265725378)
,p_prompt=>'Table / View Owner'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value d, column_value r',
'  from table( wwv_flow_remote_server_dev.get_available_objects( :P4080_REMOTE_SERVER_ID, ''SCHEMAS''))',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Current Schema'
,p_lov_cascade_parent_items=>'P4080_REMOTE_SERVER_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the owner of the table on which you are building a List of Values.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(62714764004169928)
,p_name=>'P4080_REMOTE_TABLE_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(66262064265725378)
,p_prompt=>'Table / View Name'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value d, column_value r',
'  from table( wwv_flow_remote_server_dev.get_available_objects( :P4080_REMOTE_SERVER_ID, ''TABLE'', :P4080_REMOTE_TABLE_OWNER ))',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table or View -'
,p_lov_cascade_parent_items=>'P4080_REMOTE_TABLE_OWNER'
,p_ajax_items_to_submit=>'P4080_REMOTE_SERVER_ID'
,p_ajax_optimize_refresh=>'N'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the table or view on which the List of Values will be based.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(62717698513169951)
,p_computation_sequence=>50
,p_computation_item=>'P4080_TABLE_OWNER'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select owner',
'  from wwv_flows',
' where id = :FB_FLOW_ID',
'    and security_group_id = :FLOW_SECURITY_GROUP_ID'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(62718010802169951)
,p_computation_sequence=>50
,p_computation_item=>'UI_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P4080_TABLE_OWNER'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(62719607435169960)
,p_validation_name=>'SQL Not Null'
,p_validation_sequence=>10
,p_validation=>'P4080_SQL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'SQL must be specified.'
,p_validation_condition=>':P4080_SOURCE_TYPE = ''SQL'' and :P4080_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(62695038308169864)
,p_associated_item=>wwv_flow_imp.id(62703092726169894)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(23200409731325529)
,p_validation_name=>'Function Body Not Null'
,p_validation_sequence=>20
,p_validation=>'P4080_FUNC_BODY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Function Body must be specified.'
,p_validation_condition=>':P4080_SOURCE_TYPE = ''FUNC_BODY_RETURNING_SQL'' and :P4080_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(62695038308169864)
,p_associated_item=>wwv_flow_imp.id(23200271467325527)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(62720075044169961)
,p_validation_name=>'is valid query'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_describe_result wwv_flow_exec_dev.t_describe_result;',
'begin',
'    l_describe_result := wwv_flow_exec_dev.check_and_describe (',
'                            p_location             => wwv_flow_exec_api.c_location_local_db,',
'                            p_query_type           => wwv_flow_exec_api.c_query_type_sql_query,',
'                            p_sql_query            => :P4080_SQL );',
'                            ',
'    return l_describe_result.error_message;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':P4080_SOURCE_TYPE = ''SQL'' and :P4080_LOCATION = ''LOCAL'' and :P4080_SQL is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(62695038308169864)
,p_associated_item=>wwv_flow_imp.id(62703092726169894)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(23200571197325530)
,p_validation_name=>'is valid code'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_describe_result wwv_flow_exec_dev.t_describe_result;',
'begin',
'    l_describe_result := wwv_flow_exec_dev.check_and_describe (',
'                            p_location               => wwv_flow_exec_api.c_location_local_db,',
'                            p_query_type             => wwv_flow_exec_api.c_query_type_func_return_sql,',
'                            p_function_body          => :P4080_FUNC_BODY,',
'                            p_function_body_language => :P4080_FUNC_BODY_LANG );',
'                            ',
'    return l_describe_result.error_message;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P4080_SOURCE_TYPE = ''FUNC_BODY_RETURNING_SQL'' and',
':P4080_LOCATION = ''LOCAL'' and ',
':P4080_FUNC_BODY is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(62695038308169864)
,p_associated_item=>wwv_flow_imp.id(23200271467325527)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1641139377313249)
,p_validation_name=>'is valid Graph Query'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_describe_result wwv_flow_exec_dev.t_describe_result;',
'begin',
'    l_describe_result := wwv_flow_exec_dev.check_and_describe (',
'                            p_location               => wwv_flow_exec_api.c_location_local_db,',
'                            p_query_type             => wwv_flow_exec_api.c_query_type_graph,',
'                            p_owner                  => :P4080_TABLE_OWNER,',
'                            p_table_name             => :P4080_GRAPH_NAME,',
'                            p_columns_clause         => :P4080_PQL_COLUMNS_CLAUSE,',
'                            p_match_clause           => :P4080_PQL_MATCH_CLAUSE );',
'                            ',
'    return l_describe_result.error_message;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    :P4080_SOURCE_TYPE         = ''GRAPH''',
'and :P4080_LOCATION            = ''LOCAL''',
'and :P4080_GRAPH_NAME         is not null',
'and :P4080_PQL_COLUMNS_CLAUSE is not null',
'and :P4080_PQL_MATCH_CLAUSE   is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(62695038308169864)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(62720891942169961)
,p_validation_name=>'P4080_TABLE_OWNER is not null'
,p_validation_sequence=>60
,p_validation=>'P4080_TABLE_OWNER'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Table owner must be specified.'
,p_validation_condition=>':P4080_SOURCE_TYPE = ''TABLE'' and :P4080_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(62695038308169864)
,p_associated_item=>wwv_flow_imp.id(62699004973169889)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(62721225061169962)
,p_validation_name=>'P4080_TABLE_NAME is not null'
,p_validation_sequence=>70
,p_validation=>'P4080_TABLE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Table name must be specified.'
,p_validation_condition=>':P4080_SOURCE_TYPE = ''TABLE'' and :P4080_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(62695038308169864)
,p_associated_item=>wwv_flow_imp.id(62699936633169891)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(62718882922169960)
,p_validation_name=>'P4080_REMOTE_TABLE_NAME is not null'
,p_validation_sequence=>80
,p_validation=>'P4080_REMOTE_TABLE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Table name must be specified.'
,p_validation_condition=>':P4080_REMOTE_SOURCE_TYPE = ''TABLE'' and :P4080_LOCATION = ''REMOTE'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(62695038308169864)
,p_associated_item=>wwv_flow_imp.id(62714764004169928)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(21193465435792704)
,p_validation_name=>'P4080_REMOTE_SQL is not null'
,p_validation_sequence=>90
,p_validation=>'P4080_REMOTE_SQL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'SQL name must be specified.'
,p_validation_condition=>':P4080_REMOTE_SOURCE_TYPE = ''SQL'' and :P4080_LOCATION = ''REMOTE'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(62695038308169864)
,p_associated_item=>wwv_flow_imp.id(62712957037169927)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(21193398293792703)
,p_validation_name=>'P4080_WEB_SRC_MODULE_ID is not null'
,p_validation_sequence=>100
,p_validation=>'P4080_WEB_SRC_MODULE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P4080_LOCATION'
,p_validation_condition2=>'WEB_SOURCE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(62695038308169864)
,p_associated_item=>wwv_flow_imp.id(62710063600169925)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(62721623073169962)
,p_validation_name=>'P4080_COLUMNS is not null'
,p_validation_sequence=>110
,p_validation=>'P4080_COLUMNS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'A least one column must be selected.'
,p_validation_condition=>':P4080_SOURCE_TYPE = ''TABLE'' and :P4080_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(62695038308169864)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_required_patch=>wwv_flow_imp.id(170786031904296885)
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(62719266551169960)
,p_validation_name=>'P4080_REMOTE_COLUMNS is not null'
,p_validation_sequence=>120
,p_validation=>'P4080_REMOTE_COLUMNS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'A least one column must be selected.'
,p_validation_condition=>':P4080_REMOTE_SOURCE_TYPE = ''TABLE'' and :P4080_LOCATION = ''REMOTE'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(62695038308169864)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_required_patch=>wwv_flow_imp.id(170786031904296885)
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(62718448247169952)
,p_validation_name=>'P4080_WEB_SRC_COLUMNS is not null'
,p_validation_sequence=>130
,p_validation=>'P4080_WEB_SRC_COLUMNS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'A least one column must be selected.'
,p_validation_condition=>'P4080_LOCATION'
,p_validation_condition2=>'WEB_SOURCE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(62695038308169864)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_required_patch=>wwv_flow_imp.id(170786031904296885)
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1485482335307043)
,p_validation_name=>'P4080_REMOTE_SERVER_ID is not null'
,p_validation_sequence=>140
,p_validation=>'P4080_REMOTE_SERVER_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P4080_LOCATION'
,p_validation_condition2=>'REMOTE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(62695038308169864)
,p_associated_item=>wwv_flow_imp.id(62711699254169926)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1663907334059318)
,p_validation_name=>'P4080_GRAPH_NAME is not null'
,p_validation_sequence=>150
,p_validation=>'P4080_GRAPH_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P4080_SOURCE_TYPE'
,p_validation_condition2=>'GRAPH'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(62695038308169864)
,p_associated_item=>wwv_flow_imp.id(1663415361059313)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1664010040059319)
,p_validation_name=>'P4080_PQL_MATCH_CLAUSE is not null'
,p_validation_sequence=>160
,p_validation=>'P4080_PQL_MATCH_CLAUSE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P4080_SOURCE_TYPE'
,p_validation_condition2=>'GRAPH'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(62695038308169864)
,p_associated_item=>wwv_flow_imp.id(1663517519059314)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1664139468059320)
,p_validation_name=>'P4080_PQL_COLUMNS_CLAUSE is not null'
,p_validation_sequence=>170
,p_validation=>'P4080_PQL_COLUMNS_CLAUSE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P4080_SOURCE_TYPE'
,p_validation_condition2=>'GRAPH'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(62695038308169864)
,p_associated_item=>wwv_flow_imp.id(1663610369059315)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(23199395266325518)
,p_name=>'SOURCE TYPE CHANGE HIDE ALL'
,p_event_sequence=>11
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4080_SOURCE_TYPE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(23200372430325528)
,p_event_id=>wwv_flow_imp.id(23199395266325518)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4080_SQL,P4080_FUNC_BODY_LANG,P4080_FUNC_BODY,P4080_SQL,P4080_TABLE_OWNER,P4080_TABLE_NAME,P4080_GRAPH_NAME,P4080_PQL_MATCH_CLAUSE,P4080_PQL_COLUMNS_CLAUSE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(23199658881325521)
,p_event_id=>wwv_flow_imp.id(23199395266325518)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(155584115286222824)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(62724368003169967)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(62694601289169857)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(62724840160169979)
,p_event_id=>wwv_flow_imp.id(62724368003169967)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(62725255941169982)
,p_name=>'SOURCE TYPE = SQL'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4080_SOURCE_TYPE'
,p_condition_element=>'P4080_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SQL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(62725789398169983)
,p_event_id=>wwv_flow_imp.id(62725255941169982)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4080_SQL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(62729252547169989)
,p_event_id=>wwv_flow_imp.id(62725255941169982)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(155584115286222824)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(23199798892325522)
,p_name=>'SOURCE TYPE = TABLE'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4080_SOURCE_TYPE'
,p_condition_element=>'P4080_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TABLE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(23199988055325524)
,p_event_id=>wwv_flow_imp.id(23199798892325522)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4080_TABLE_OWNER,P4080_TABLE_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(23198490781325509)
,p_name=>'SOURCE TYPE = FUNC_BODY'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4080_SOURCE_TYPE'
,p_condition_element=>'P4080_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FUNC_BODY_RETURNING_SQL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(23198510758325510)
,p_event_id=>wwv_flow_imp.id(23198490781325509)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4080_FUNC_BODY_LANG,P4080_FUNC_BODY'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1663704275059316)
,p_name=>'SOURCE TYPE = GRAPH'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4080_SOURCE_TYPE'
,p_condition_element=>'P4080_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'GRAPH'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1663857655059317)
,p_event_id=>wwv_flow_imp.id(1663704275059316)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4080_GRAPH_NAME,P4080_PQL_MATCH_CLAUSE,P4080_PQL_COLUMNS_CLAUSE,P4080_TABLE_OWNER'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(62738845679169997)
,p_name=>'Location "LOCAL"'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4080_LOCATION'
,p_condition_element=>'P4080_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'LOCAL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(62739338668169997)
,p_event_id=>wwv_flow_imp.id(62738845679169997)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(64471324421117450)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(62739890783169998)
,p_event_id=>wwv_flow_imp.id(62738845679169997)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(64471324421117450)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(62740736327169999)
,p_name=>'Location "REMOTE"'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4080_LOCATION'
,p_condition_element=>'P4080_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REMOTE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(62741212427169999)
,p_event_id=>wwv_flow_imp.id(62740736327169999)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(66262064265725378)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(62741797280169999)
,p_event_id=>wwv_flow_imp.id(62740736327169999)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(66262064265725378)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(62742172505170000)
,p_name=>'Location "WEB_SRC"'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4080_LOCATION'
,p_condition_element=>'P4080_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'WEB_SOURCE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(62742642829170000)
,p_event_id=>wwv_flow_imp.id(62742172505170000)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(64471409835117451)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(62743140616170000)
,p_event_id=>wwv_flow_imp.id(62742172505170000)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(64471409835117451)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(62732690000169992)
,p_name=>'REMOTE SOURCE TYPE = SQL'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4080_REMOTE_SOURCE_TYPE,P4080_REMOTE_SERVER_ID'
,p_condition_element=>'P4080_REMOTE_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SQL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(62733177106169993)
,p_event_id=>wwv_flow_imp.id(62732690000169992)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4080_REMOTE_SQL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(62733624986169993)
,p_event_id=>wwv_flow_imp.id(62732690000169992)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(155584115286222824)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(62734105204169993)
,p_event_id=>wwv_flow_imp.id(62732690000169992)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4080_REMOTE_TABLE_OWNER,P4080_REMOTE_TABLE_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(62734654502169993)
,p_event_id=>wwv_flow_imp.id(62732690000169992)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4080_REMOTE_TABLE_OWNER,P4080_REMOTE_TABLE_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(62735158648169994)
,p_event_id=>wwv_flow_imp.id(62732690000169992)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(155584115286222824)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(62735619121169994)
,p_event_id=>wwv_flow_imp.id(62732690000169992)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4080_REMOTE_SQL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(21193579919792705)
,p_name=>'Remote Server chosen'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4080_REMOTE_SERVER_ID'
,p_condition_element=>'P4080_REMOTE_SERVER_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(21193707120792707)
,p_event_id=>wwv_flow_imp.id(21193579919792705)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4080_REMOTE_SOURCE_TYPE,P4080_REMOTE_SQL,P4080_REMOTE_TABLE_OWNER,P4080_REMOTE_TABLE_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(21193939564792709)
,p_event_id=>wwv_flow_imp.id(21193579919792705)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4080_REMOTE_SOURCE_TYPE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1533363581420610)
,p_name=>'Web Source Module is not null'
,p_event_sequence=>120
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4080_WEB_SRC_MODULE_ID'
,p_condition_element=>'P4080_WEB_SRC_MODULE_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1533426609420611)
,p_event_id=>wwv_flow_imp.id(1533363581420610)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4080_WEB_SRC_ARRAY_COL_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1533581700420612)
,p_event_id=>wwv_flow_imp.id(1533363581420610)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4080_WEB_SRC_ARRAY_COL_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1533652081420613)
,p_event_id=>wwv_flow_imp.id(1533363581420610)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4080_WEB_SRC_ARRAY_COL_ID'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(62723989987169966)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_USER_PREFERENCES'
,p_process_name=>'Save Source Type Preference'
,p_attribute_01=>'SET_PREFERENCE_TO_ITEM_VALUE_IF_ITEM_NOT_NULL'
,p_attribute_02=>'WIZARD_SQL_SOURCE_TYPE'
,p_attribute_03=>'P4080_SOURCE_TYPE'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(62695038308169864)
,p_required_patch=>wwv_flow_imp.id(170786031904296885)
,p_internal_uid=>62723989987169966
,p_process_comment=>'commented out as source type changed to be ''SQL'' not ''QUERY'''
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1664269622059321)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'Clear Graph items'
,p_attribute_01=>'CLEAR_CACHE_FOR_ITEMS'
,p_attribute_03=>'P4080_GRAPH_NAME,P4080_PQL_MATCH_CLAUSE,P4080_PQL_COLUMNS_CLAUSE'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(62695038308169864)
,p_process_when=>'P4080_SOURCE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_process_when2=>'GRAPH'
,p_internal_uid=>1664269622059321
);
end;
/
prompt --application/pages/page_04081
begin
wwv_flow_imp_page.create_page(
 p_id=>4081
,p_name=>'Create List of Values - Column Mappings'
,p_alias=>'CREATE-LIST-OF-VALUES-COLUMN-MAPPINGS'
,p_page_mode=>'MODAL'
,p_step_title=>'Create List of Values'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213211113434774960)
,p_javascript_code_onload=>'//apex.region("column_info").call("getActions").set("edit", true);'
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8966275624715513)
,p_plug_name=>'navigation'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(161740513874429436)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8966394636715514)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(104836580260625037)
,p_plug_name=>'Column Mapping'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(663117390211931018)
,p_plug_name=>'Queries Defined with Multiple Columns'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'When creating List of Values based on a SQL Query with more than 2 columns, if you wish to display these additional columns in an item that supports it (for example the Popup LOV), you will need to explicitly add them after creating the LOV. To do so'
||', go to the edit page, and then in ''Additional Display Columns'', select ''Select Columns'' where you can select additional columns to display.'
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_describe_result wwv_flow_exec_dev.t_describe_result;',
'begin',
'    if ( :P4080_LOCATION = ''LOCAL'' and :P4080_SOURCE_TYPE in ( ''SQL'', ''FUNC_BODY_RETURNING_SQL'' )',
'         or ',
'         :P4080_LOCATION = ''REMOTE'' and :P4080_REMOTE_SOURCE_TYPE = ''SQL'' ) ',
'    then ',
'        l_describe_result := wwv_flow_exec_dev.check_and_describe (',
'                                 p_location               => :P4080_LOCATION,',
'                                 p_remote_server_id       => case when :P4080_LOCATION = ''REMOTE'' then :P4080_REMOTE_SERVER_ID end,',
'                                 p_query_type             => :P4080_SOURCE_TYPE,',
'                                 p_sql_query              => case ',
'                                                                 when :P4080_LOCATION = ''LOCAL'' and :P4080_SOURCE_TYPE = ''SQL'' then :P4080_SQL',
'                                                                 when :P4080_LOCATION = ''REMOTE'' and :P4080_REMOTE_SOURCE_TYPE = ''SQL'' then :P4080_REMOTE_SQL',
'                                                             end,',
'                                 p_function_body          => case ',
'                                                                 when :P4080_LOCATION = ''LOCAL'' and :P4080_SOURCE_TYPE = ''FUNC_BODY_RETURNING_SQL'' then :P4080_FUNC_BODY',
'                                                             end,',
'                                 p_function_body_language => case ',
'                                                                 when :P4080_LOCATION = ''LOCAL'' and :P4080_SOURCE_TYPE = ''FUNC_BODY_RETURNING_SQL'' then :P4080_FUNC_BODY_LANG',
'                                                             end );',
'                                ',
'        return case when l_describe_result.query_columns.count > 2 then true else false end;',
'',
'    end if;',
'end;'))
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8966487532715515)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(8966394636715514)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8966537405715516)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(8966394636715514)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8966611408715517)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(8966394636715514)
,p_button_name=>'Previous'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:4080:&SESSION.::&DEBUG.:RP::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21185764186624645)
,p_name=>'P4081_RETURN_COLUMN'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(104836580260625037)
,p_prompt=>'Return Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name d, ',
'       column_name r',
'  from table( wwv_flow_exec_dev.get_query_columns(',
'                  p_location                => :P4080_LOCATION,',
'                  p_query_type              => case :P4080_LOCATION ',
'                                                   when ''LOCAL'' then :P4080_SOURCE_TYPE',
'                                                   when ''REMOTE'' then :P4080_REMOTE_SOURCE_TYPE',
'                                               end,',
'                  p_owner                   => case :P4080_LOCATION ',
'                                                   when ''LOCAL'' then :P4080_TABLE_OWNER',
'                                                   when ''REMOTE'' then :P4080_REMOTE_TABLE_OWNER',
'                                               end,       ',
'                  p_table_name              => case :P4080_LOCATION ',
'                                                   when ''LOCAL''  then case :P4080_SOURCE_TYPE',
'                                                                          when ''TABLE'' then :P4080_TABLE_NAME',
'                                                                          when ''GRAPH'' then :P4080_GRAPH_NAME',
'                                                                      end',
'                                                   when ''REMOTE'' then :P4080_REMOTE_TABLE_NAME',
'                                               end,',
'                  p_sql_query               => case :P4080_LOCATION ',
'                                                   when ''LOCAL'' then :P4080_SQL',
'                                                   when ''REMOTE'' then :P4080_REMOTE_SQL',
'                                               end,',
'                  p_match_clause            => :P4080_PQL_MATCH_CLAUSE,',
'                  p_columns_clause          => :P4080_PQL_COLUMNS_CLAUSE,',
'                  p_function_body           => :P4080_FUNC_BODY,',
'                  p_function_body_language  => :P4080_FUNC_BODY_LANG,',
'                  p_remote_server_id        => to_number(:P4080_REMOTE_SERVER_ID),',
'                  p_web_src_module_id       => to_number(:P4080_WEB_SRC_MODULE_ID),',
'                  p_web_src_array_column_id => to_number( :P4080_WEB_SRC_ARRAY_COL_ID )',
'        ) )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Define the column that will be used as the return value for your List of Values.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21186197082624653)
,p_name=>'P4081_DISPLAY_COLUMN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(104836580260625037)
,p_prompt=>'Display Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name d, ',
'       column_name r',
'  from table( wwv_flow_exec_dev.get_query_columns(',
'                  p_location                => :P4080_LOCATION,',
'                  p_query_type              => case :P4080_LOCATION ',
'                                                   when ''LOCAL'' then :P4080_SOURCE_TYPE',
'                                                   when ''REMOTE'' then :P4080_REMOTE_SOURCE_TYPE',
'                                               end,',
'                  p_owner                   => case :P4080_LOCATION ',
'                                                   when ''LOCAL'' then :P4080_TABLE_OWNER',
'                                                   when ''REMOTE'' then :P4080_REMOTE_TABLE_OWNER',
'                                               end,       ',
'                  p_table_name              => case :P4080_LOCATION ',
'                                                   when ''LOCAL''  then case :P4080_SOURCE_TYPE',
'                                                                          when ''TABLE'' then :P4080_TABLE_NAME',
'                                                                          when ''GRAPH'' then :P4080_GRAPH_NAME',
'                                                                      end',
'                                                   when ''REMOTE'' then :P4080_REMOTE_TABLE_NAME',
'                                               end,',
'                  p_sql_query               => case :P4080_LOCATION ',
'                                                   when ''LOCAL'' then :P4080_SQL',
'                                                   when ''REMOTE'' then :P4080_REMOTE_SQL',
'                                               end,',
'                  p_match_clause            => :P4080_PQL_MATCH_CLAUSE,',
'                  p_columns_clause          => :P4080_PQL_COLUMNS_CLAUSE,',
'                  p_function_body           => :P4080_FUNC_BODY,',
'                  p_function_body_language  => :P4080_FUNC_BODY_LANG,',
'                  p_remote_server_id        => to_number(:P4080_REMOTE_SERVER_ID),',
'                  p_web_src_module_id       => to_number(:P4080_WEB_SRC_MODULE_ID),',
'                  p_web_src_array_column_id => to_number( :P4080_WEB_SRC_ARRAY_COL_ID )                  ',
'        ) )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Define the column that will be used as the display value for your List of Values. Note: Additional display columns can be defined after creating the List of Values for item types that support displaying multiple columns (such as the Popup LOV).'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(8966754951715518)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(8966487532715515)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8966866217715519)
,p_event_id=>wwv_flow_imp.id(8966754951715518)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(21193104939792701)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Default Return and Display Values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_data_type             wwv_flow_exec_api.t_data_type;',
'    l_return_value_found    boolean := false;',
'    l_display_value_found   boolean := false;',
'    l_table_name            varchar2(128);',
'    l_table_owner           varchar2(128);',
'    l_source_type           wwv_flow_lists_of_values$.source_type%type;',
'    l_sql                   varchar2(32767);',
'    l_describe_result       wwv_flow_exec_dev.t_describe_result;',
'    l_column                wwv_flow_exec_api.t_column;',
'begin',
'',
'    if :P4080_LOCATION = wwv_flow_exec_api.c_location_local_db then',
'        l_table_owner   := :P4080_TABLE_OWNER;',
'        l_table_name    := case :P4080_SOURCE_TYPE ',
'                                when ''TABLE'' then :P4080_TABLE_NAME',
'                                when ''GRAPH'' then :P4080_GRAPH_NAME',
'                           end;',
'        l_source_type   := :P4080_SOURCE_TYPE;',
'        l_sql           := :P4080_SQL;',
'    elsif :P4080_LOCATION = wwv_flow_exec_api.c_location_remote_db then',
'        l_table_owner   := :P4080_REMOTE_TABLE_OWNER;',
'        l_table_name    := :P4080_REMOTE_TABLE_NAME;',
'        l_source_type   := :P4080_REMOTE_SOURCE_TYPE;',
'        l_sql           := :P4080_REMOTE_SQL;',
'    end if;',
'',
'    -- parse and describe query',
'    l_describe_result := wwv_flow_exec_dev.check_and_describe (',
'                              p_location                => :P4080_LOCATION,',
'                              p_query_type              => l_source_type,',
'                              p_owner                   => l_table_owner,           ',
'                              p_table_name              => l_table_name, ',
'                              p_match_clause            => :P4080_PQL_MATCH_CLAUSE,',
'                              p_columns_clause          => :P4080_PQL_COLUMNS_CLAUSE,           ',
'                              p_sql_query               => l_sql,              ',
'                              p_function_body           => :P4080_FUNC_BODY,',
'                              p_function_body_language  => :P4080_FUNC_BODY_LANG,',
'                              p_remote_server_id        => :P4080_REMOTE_SERVER_ID,',
'                              p_web_src_module_id       => :P4080_WEB_SRC_MODULE_ID,',
'                              p_web_src_array_column_id => :P4080_WEB_SRC_ARRAY_COL_ID );',
'    ',
'    for i in 1 .. l_describe_result.query_columns.count loop',
'',
'        l_column := l_describe_result.query_columns( i );',
'',
'        -- We only support the following data types for LOVs',
'        if l_column.data_type in ( ',
'                wwv_flow_exec_api.c_data_type_varchar2, ',
'                wwv_flow_exec_api.c_data_type_number,',
'                wwv_flow_exec_api.c_data_type_date,',
'                wwv_flow_exec_api.c_data_type_timestamp,',
'                wwv_flow_exec_api.c_data_type_timestamp_tz,',
'                wwv_flow_exec_api.c_data_type_timestamp_ltz,',
'                wwv_flow_exec_api.c_data_type_interval_y2m,',
'                wwv_flow_exec_api.c_data_type_interval_d2s,',
'                wwv_flow_exec_api.c_data_type_clob,',
'                wwv_flow_exec_api.c_data_type_rowid ) ',
'        then',
'            -- If this is the first number column, assume it''s the return value',
'            if l_column.data_type = wwv_flow_exec_api.c_data_type_number and not l_return_value_found then',
'                :P4081_RETURN_COLUMN := l_column.name;',
'                l_return_value_found := true;',
'            end if;',
'',
'            -- If this is the first text column, assume it''s the primary display value',
'            if l_column.data_type = wwv_flow_exec_api.c_data_type_varchar2 and not l_display_value_found then',
'                :P4081_DISPLAY_COLUMN := l_column.name;',
'                l_display_value_found := true;',
'            end if;',
'',
'            -- stop looking when we''ve got both display and return',
'            if l_return_value_found and l_display_value_found then ',
'                exit;',
'            end if;',
'        end if;',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>21193104939792701
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(21190462109691831)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create LOV'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_lov_dev.create_dynamic_lov(',
'    p_lov_name               => :F4000_P4004_NAME,',
'    p_location               => :P4080_LOCATION,',
'    p_source_type            => case :P4080_LOCATION ',
'                                    when wwv_flow_exec_api.c_location_local_db then :P4080_SOURCE_TYPE',
'                                    when wwv_flow_exec_api.c_location_remote_db then :P4080_REMOTE_SOURCE_TYPE',
'                                end,',
'    p_owner                  => case :P4080_LOCATION ',
'                                    when wwv_flow_exec_api.c_location_local_db then :P4080_TABLE_OWNER',
'                                    when wwv_flow_exec_api.c_location_remote_db then :P4080_REMOTE_TABLE_OWNER',
'                                end,',
'    p_table_name             => case :P4080_LOCATION ',
'                                    when ''LOCAL''  then case :P4080_SOURCE_TYPE',
'                                                           when ''TABLE'' then :P4080_TABLE_NAME',
'                                                           when ''GRAPH'' then :P4080_GRAPH_NAME',
'                                                       end',
'                                    when ''REMOTE'' then :P4080_REMOTE_TABLE_NAME',
'                                end,',
'    p_sql_query              => case :P4080_LOCATION ',
'                                    when wwv_flow_exec_api.c_location_local_db then',
'                                        case :P4080_SOURCE_TYPE',
'                                            when wwv_flow_exec_api.c_query_type_sql_query then :P4080_SQL',
'                                            when wwv_flow_exec_api.c_query_type_func_return_sql then :P4080_FUNC_BODY',
'                                        end',
'                                    when wwv_flow_exec_api.c_location_remote_db then :P4080_REMOTE_SQL',
'                                end,',
'    p_function_body_language => case',
'                                  when :P4080_LOCATION = wwv_flow_exec_api.c_location_local_db',
'                                   and :P4080_SOURCE_TYPE = wwv_flow_exec_api.c_query_type_func_return_sql',
'                                  then :P4080_FUNC_BODY_LANG',
'                                end,',
'    p_web_src_module_id      => to_number(:P4080_WEB_SRC_MODULE_ID),',
'    p_web_src_array_col_id   => to_number(:P4080_WEB_SRC_ARRAY_COL_ID),',
'    p_remote_server_id       => to_number(:P4080_REMOTE_SERVER_ID),',
'    p_match_clause           => :P4080_PQL_MATCH_CLAUSE,',
'    p_columns_clause         => :P4080_PQL_COLUMNS_CLAUSE,    ',
'    p_return_column          => :P4081_RETURN_COLUMN,',
'    p_display_column         => :P4081_DISPLAY_COLUMN',
');'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(8966537405715516)
,p_internal_uid=>21190462109691831
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4368263449268577)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,REQUEST'
,p_attribute_02=>'N'
,p_process_error_message=>'Error creating List of Values'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(8966537405715516)
,p_process_success_message=>'List of Values created successfully'
,p_internal_uid=>4368263449268577
);
end;
/
prompt --application/pages/page_04082
begin
wwv_flow_imp_page.create_page(
 p_id=>4082
,p_name=>'Select Additional Display Columns'
,p_alias=>'SELECT-ADDITIONAL-DISPLAY-COLUMNS'
,p_page_mode=>'MODAL'
,p_step_title=>'Select Additional Display Columns'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213211113434774960)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(20214923591919128)
,p_plug_name=>'Select Columns'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(421568269617510633)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(73082888039504666)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(421568269617510633)
,p_button_name=>'UPDATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Update'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(73083254460504669)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(421568269617510633)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20997955128632618)
,p_name=>'P4082_SELECT_COLUMNS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(20214923591919128)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_return varchar2(32767);',
'    ',
'    procedure add_value (',
'        p_value     in     varchar2,',
'        p_return    in out varchar2 )',
'    is',
'        l_return_array  wwv_flow_t_varchar2 := wwv_flow_string.split(p_return,'':'');',
'    begin',
'        if p_value is not null then',
'            -- Check if column has already been added',
'            for i in 1..l_return_array.count loop',
'                if l_return_array(i) = p_value then ',
'                    return;',
'                end if;',
'            end loop;',
'            ',
'            if p_return is not null then',
'                p_return := p_return||'':'';',
'            end if;',
'       ',
'            p_return := p_return || p_value;  ',
'        end if;',
'    end add_value;',
'begin',
'    -- if collection already exists (because additional columns are already defined),',
'    -- pre-fill these values',
'    for c1 in (select c001 column_name ',
'                 from wwv_flow_collections ',
'                where collection_name = ''LOV_COL_INFO'') ',
'    loop',
'        add_value( c1.column_name, l_return );',
'    end loop;',
'  ',
'    -- if collection doesn''t exist, pre-fill with any columns defined in column mapping',
'    if l_return is null then',
'        add_value( :P4111_RETURN_COLUMN, l_return );',
'        add_value( :P4111_DISPLAY_COLUMN, l_return );',
'        add_value( :P4111_DEFAULT_SORT_COLUMN, l_return );',
'        add_value( :P4111_GROUP_COLUMN, l_return );',
'        add_value( :P4111_ICON_COLUMN, l_return );',
'        add_value( :P4111_ORACLE_TEXT_COLUMN, l_return );',
'    end if;',
'    ',
'    return l_return;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Select Columns'
,p_display_as=>'NATIVE_SHUTTLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc d, ',
'       column_name r',
'  from table( wwv_flow_exec_dev.get_query_columns(',
'                  p_location                 => :P4111_LOCATION,',
'                  p_query_type               => case :P4111_LOCATION ',
'                                                    when ''LOCAL'' then :P4111_SOURCE_TYPE',
'                                                    when ''REMOTE'' then :P4111_REMOTE_SOURCE_TYPE',
'                                                end,',
'                  p_owner                    => case :P4111_LOCATION ',
'                                                    when ''LOCAL'' then :P4111_QUERY_OWNER',
'                                                    when ''REMOTE'' then :P4111_REMOTE_TABLE_OWNER',
'                                                end,       ',
'                  p_table_name               => case :P4111_LOCATION ',
'                                                    when ''LOCAL'' then ',
'                                                                 case :P4111_SOURCE_TYPE',
'                                                                     when ''GRAPH'' then :P4111_GRAPH_NAME',
'                                                                     else              :P4111_QUERY_TABLE',
'                                                                 end',
'                                                    when ''REMOTE'' then :P4111_REMOTE_TABLE_NAME',
'                                                end,',
'                  p_match_clause             => :P4111_PQL_MATCH_CLAUSE,',
'                  p_columns_clause           => :P4111_PQL_COLUMNS_CLAUSE,',
'                  p_sql_query                => case :P4111_LOCATION ',
'                                                    when ''LOCAL'' then :P4111_LOV_QUERY_SQL',
'                                                    when ''REMOTE'' then :P4111_REMOTE_SQL',
'                                                    when ''WEB_SOURCE'' then :P4111_SOURCE_POST_PROC_SQL',
'                                                end,             ',
'                  p_function_body            => case :P4111_LOCATION',
'                                                     when ''LOCAL'' then :P4111_LOV_QUERY_FUNC_BODY',
'                                                     when ''REMOTE'' then :P4111_SRC_POST_PROC_FUNC_BODY',
'                                                 end,',
'                  p_function_body_language   => case :P4111_LOCATION',
'                                                   when ''LOCAL''  then :P4111_LOV_QUERY_FUNC_LANG',
'                                                   when ''REMOTE'' then :P4111_SRC_POST_PROC_FUNC_LANG',
'                                                end,',
'                  p_remote_server_id         => to_number(:P4111_REMOTE_SERVER_ID),',
'                  p_web_src_module_id        => to_number(:P4111_WEB_SRC_MODULE_ID),',
'                  p_web_src_array_column_id  => to_number(:P4111_WEB_SRC_ARRAY_COL_ID),',
'                  p_where_clause             => case :P4111_LOCATION ',
'                                                    when ''LOCAL'' then :P4111_LOCAL_WHERE ',
'                                                    when ''REMOTE'' then :P4111_REMOTE_WHERE',
'                                                    when ''WEB_SOURCE'' then :P4111_SOURCE_POST_PROC_WHERE',
'                                                end,',
'                  p_post_processing_type     => :P4111_SOURCE_POST_PROC_TYPE',
'        ) )'))
,p_lov_cascade_parent_items=>'P1_DUMMY'
,p_ajax_items_to_submit=>'P4111_LOCATION, P4111_QUERY_TABLE, P4111_REMOTE_TABLE_NAME, P4111_SOURCE_TYPE, P4111_REMOTE_SOURCE_TYPE, P4111_QUERY_OWNER, P4111_REMOTE_TABLE_OWNER, P4111_LOV_QUERY_SQL, P4111_REMOTE_SQL, P4111_LOV_QUERY_FUNC_LANG, P4111_LOV_QUERY_FUNC_BODY, P4111_R'
||'EMOTE_SERVER_ID, P4111_WEB_SRC_MODULE_ID, P4111_SOURCE_POST_PROC_SQL, P4111_SRC_POST_PROC_FUNC_LANG, P4111_SRC_POST_PROC_FUNC_BODY, P4111_LOCAL_WHERE, P4111_REMOTE_WHERE, P4111_SOURCE_POST_PROC_WHERE, P4111_SOURCE_POST_PROC_TYPE,P4111_GRAPH_NAME,P411'
||'1_PQL_MATCH_CLAUSE,P4111_PQL_COLUMNS_CLAUSE,P4111_WEB_SRC_ARRAY_COL_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>18
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ALL'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4469240629653229)
,p_validation_name=>'DISALLOW REMOVE FOR COLUMNS USED IN MAPPINGS'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_shuttle_columns           wwv_flow_t_varchar2;',
'    l_check_return              boolean := :P4111_RETURN_COLUMN is not null;',
'    l_check_display             boolean := :P4111_DISPLAY_COLUMN is not null;',
'    l_check_default_sort        boolean := :P4111_DEFAULT_SORT_COLUMN is not null;',
'    l_check_group               boolean := :P4111_GROUP_COLUMN is not null;',
'    l_check_icon                boolean := :P4111_ICON_COLUMN is not null;',
'    l_return_ok                 boolean := not l_check_return;',
'    l_display_ok                boolean := not l_check_display;',
'    l_default_sort_ok           boolean := not l_check_default_sort;',
'    l_group_ok                  boolean := not l_check_group;',
'    l_icon_ok                   boolean := not l_check_icon;',
'    i                           int;',
'    l_error                     varchar2(4000);',
'begin ',
'    l_shuttle_columns := wwv_flow_string.split(:P4082_SELECT_COLUMNS,'':'');',
'    ',
'    if l_shuttle_columns.count > 0 then ',
'        i := l_shuttle_columns.first;',
'        loop',
'            -- return column',
'            if l_check_return and not l_return_ok then ',
'                if l_shuttle_columns( i ) = :P4111_RETURN_COLUMN then ',
'                    l_return_ok := true;',
'                end if;',
'            end if;',
'            ',
'            -- display column',
'            if l_check_display and not l_display_ok then ',
'                if l_shuttle_columns( i ) = :P4111_DISPLAY_COLUMN then ',
'                    l_display_ok := true;',
'                end if;',
'            end if;',
'',
'            -- default sort',
'            if l_check_default_sort and not l_default_sort_ok then ',
'                if l_shuttle_columns( i ) = :P4111_DEFAULT_SORT_COLUMN then ',
'                    l_default_sort_ok := true;',
'                end if;',
'            end if;',
'',
'            -- group',
'            if l_check_group and not l_group_ok then ',
'                if l_shuttle_columns( i ) = :P4111_GROUP_COLUMN then ',
'                    l_group_ok := true;',
'                end if;',
'            end if;',
' ',
'            -- icon',
'            if l_check_icon and not l_icon_ok then ',
'                if l_shuttle_columns( i ) = :P4111_ICON_COLUMN then ',
'                    l_icon_ok := true;',
'                end if;',
'            end if;',
'            ',
'            exit when i = l_shuttle_columns.last;',
'            i := l_shuttle_columns.next(i);',
'        end loop;',
'    end if;',
'    ',
'    if not l_return_ok or ',
'       not l_display_ok or ',
'       not l_default_sort_ok or',
'       not l_group_ok or',
'       not l_icon_ok       ',
'    then ',
'        l_error := ''You cannot remove the following columns, as they are defined in the ''''Column Mappings'''' for this List of Values: '';',
'        l_error := l_error || case when not l_return_ok       then :P4111_RETURN_COLUMN || '', '' end ||',
'                              case when not l_display_ok      then :P4111_DISPLAY_COLUMN || '', '' end ||',
'                              case when not l_default_sort_ok then :P4111_DEFAULT_SORT_COLUMN || '', '' end ||',
'                              case when not l_group_ok        then :P4111_GROUP_COLUMN || '', '' end ||',
'                              case when not l_icon_ok         then :P4111_ICON_COLUMN end;',
'        return l_error;',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_when_button_pressed=>wwv_flow_imp.id(73082888039504666)
,p_associated_item=>wwv_flow_imp.id(20997955128632618)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_required_patch=>wwv_flow_imp.id(170786031904296885)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(20999217583632631)
,p_name=>'CANCEL BUTTON CLICKED'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(73083254460504669)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(20999375822632632)
,p_event_id=>wwv_flow_imp.id(20999217583632631)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(20999687257632635)
,p_process_sequence=>1
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update LOV Column Collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_lov_dev.update_column_collection(',
'    p_collection_name        => ''LOV_COL_INFO'',',
'    p_new_columns            => :P4082_SELECT_COLUMNS,',
'    p_location               => :P4111_LOCATION,',
'    p_source_type            => case :P4111_LOCATION',
'                                    when wwv_flow_exec_api.c_location_local_db then :P4111_SOURCE_TYPE',
'                                    when wwv_flow_exec_api.c_location_remote_db then :P4111_REMOTE_SOURCE_TYPE',
'                                end,',
'    p_owner                  => case :P4111_LOCATION',
'                                    when wwv_flow_exec_api.c_location_local_db then :P4111_QUERY_OWNER',
'                                    when wwv_flow_exec_api.c_location_remote_db then :P4111_REMOTE_TABLE_OWNER',
'                                end,',
'    p_table_name             => case :P4111_LOCATION ',
'                                    when ''LOCAL'' then ',
'                                                 case :P4111_SOURCE_TYPE',
'                                                     when ''GRAPH'' then :P4111_GRAPH_NAME',
'                                                     else              :P4111_QUERY_TABLE',
'                                                 end',
'                                    when ''REMOTE'' then :P4111_REMOTE_TABLE_NAME',
'                                end,',
'    p_match_clause           => :P4111_PQL_MATCH_CLAUSE,',
'    p_columns_clause         => :P4111_PQL_COLUMNS_CLAUSE,',
'    p_sql_query              => case :P4111_LOCATION',
'                                    when wwv_flow_exec_api.c_location_local_db then :P4111_LOV_QUERY_SQL',
'                                    when wwv_flow_exec_api.c_location_remote_db then :P4111_REMOTE_SQL',
'                                    when wwv_flow_exec_api.c_location_web_source then :P4111_SOURCE_POST_PROC_SQL',
'                                end,',
'    p_function_body          => case :P4111_LOCATION',
'                                    when wwv_flow_exec_api.c_location_local_db then :P4111_LOV_QUERY_FUNC_BODY',
'                                    when wwv_flow_exec_api.c_location_web_source then :P4111_SRC_POST_PROC_FUNC_BODY',
'                                end,',
'    p_function_body_language => case :P4111_LOCATION',
'                                   when ''LOCAL''  then :P4111_LOV_QUERY_FUNC_LANG',
'                                   when ''REMOTE'' then :P4111_SRC_POST_PROC_FUNC_LANG',
'                                end,    ',
'    p_remote_server_id       => to_number(:P4111_REMOTE_SERVER_ID),',
'    p_web_src_module_id      => to_number(:P4111_WEB_SRC_MODULE_ID),',
'    p_web_src_array_col_id   => to_number(:P4111_WEB_SRC_ARRAY_COL_ID),',
'    p_where_clause           => case :P4111_LOCATION ',
'                                    when wwv_flow_exec_api.c_location_local_db then :P4111_LOCAL_WHERE ',
'                                    when wwv_flow_exec_api.c_location_remote_db then :P4111_REMOTE_WHERE',
'                                    when wwv_flow_exec_api.c_location_web_source then :P4111_SOURCE_POST_PROC_WHERE',
'                                end,',
'    p_post_processing_type   => :P4111_SOURCE_POST_PROC_TYPE,',
'    p_return_column          => :P4111_RETURN_COLUMN );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>20999687257632635
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(73084821026504677)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID,REQUEST'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Column information successfully updated.'
,p_internal_uid=>73084821026504677
);
end;
/
prompt --application/pages/page_04083
begin
wwv_flow_imp_page.create_page(
 p_id=>4083
,p_name=>'Edit REST Data Source Parameter Values'
,p_alias=>'EDIT-REST-DATA-SOURCE-PARAMETER-VALUES'
,p_page_mode=>'MODAL'
,p_step_title=>'Edit REST Data Source Parameter Values'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213211113434774960)
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4437481313497226)
,p_plug_name=>'Edit REST Data Source Parameter Values'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_WEB_SRC_COMP_PARAMS'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4444768135497245)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4445185941497245)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(4444768135497245)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4447119598497250)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(4444768135497245)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P4083_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1465248613917843)
,p_name=>'P4083_VALUE_STATIC'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(4437481313497226)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Static Value'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P4083_VALUE_TYPE = ''STATIC'' then',
'    return :P4083_VALUE;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the static value used as the source for this parameter value.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1465382459917844)
,p_name=>'P4083_VALUE_ITEM'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(4437481313497226)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Item'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P4083_VALUE_TYPE = ''ITEM'' then',
'    return :P4083_VALUE;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the page or application item used as the source for this parameter value.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1465412992917845)
,p_name=>'P4083_VALUE_SQL'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(4437481313497226)
,p_use_cache_before_default=>'NO'
,p_prompt=>'SQL Query'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P4083_VALUE_TYPE = ''SQL_QUERY'' then',
'    return :P4083_VALUE;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the SQL Query used as the source for this parameter value. If more than one row is returned then the value of the first row is used.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1465580604917846)
,p_name=>'P4083_VALUE_PLSQL_EXPRESSION'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(4437481313497226)
,p_use_cache_before_default=>'NO'
,p_prompt=>'PL/SQL Expression'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P4083_VALUE_TYPE = ''EXPRESSION'' then',
'    return :P4083_VALUE;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a PL/SQL expression that produces a value used as the source for this parameter value.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1465652780917847)
,p_name=>'P4083_VALUE_PLSQL_FUNC_BODY'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(4437481313497226)
,p_use_cache_before_default=>'NO'
,p_prompt=>'PL/SQL Function Body'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P4083_VALUE_TYPE = ''FUNCTION_BODY'' then',
'    return :P4083_VALUE;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a PL/SQL function body that returns a value used as the source for this parameter value.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PLSQL_FUNCTION_BODY'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1465784271917848)
,p_name=>'P4083_VALUE_COLLECTION'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(4437481313497226)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Collection'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P4083_VALUE_TYPE = ''COLLECTION'' then',
'    return :P4083_VALUE;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the Collection name. The source for this parameter value will be based on the value of the CLOB column from the collection''s first row.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1465830105917849)
,p_name=>'P4083_VALUE_PREFERENCE'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(4437481313497226)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Preference'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P4083_VALUE_TYPE = ''PREFERENCE'' then',
'    return :P4083_VALUE;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the User Preference to be used as the source for this parameter value.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2319907728209545)
,p_name=>'P4083_VALUE_LANGUAGE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(4437481313497226)
,p_item_source_plug_id=>wwv_flow_imp.id(4437481313497226)
,p_source=>'VALUE_LANGUAGE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2687292105958045)
,p_name=>'P4083_DATA_TYPE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(4437481313497226)
,p_prompt=>'Parameter Data Type'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select data_type',
'  from wwv_flow_web_src_params',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and id                = :P4083_WEB_SRC_PARAM_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'WEB_SOURCE_PARAM_DATA_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(2225637019805602)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2687348474958046)
,p_name=>'P4083_FORMAT_MASK'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(4437481313497226)
,p_item_source_plug_id=>wwv_flow_imp.id(4437481313497226)
,p_prompt=>'Format Mask'
,p_source=>'FORMAT_MASK'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FORMAT MASK'
,p_lov=>'.'||wwv_flow_imp.id(32743907454195192)||'.'
,p_lov_display_null=>'YES'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Format mask to convert the <strong>Static</strong> or <strong>Item</strong> value to the data type of the REST Source Parameter.'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4437746057497227)
,p_name=>'P4083_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(4437481313497226)
,p_item_source_plug_id=>wwv_flow_imp.id(4437481313497226)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4438165902497232)
,p_name=>'P4083_FLOW_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(4437481313497226)
,p_item_source_plug_id=>wwv_flow_imp.id(4437481313497226)
,p_source=>'FLOW_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4438505627497237)
,p_name=>'P4083_WEB_SRC_PARAM_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(4437481313497226)
,p_item_source_plug_id=>wwv_flow_imp.id(4437481313497226)
,p_prompt=>'Name'
,p_source=>'WEB_SRC_PARAM_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id',
'  from wwv_flow_web_src_params'))
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4438988247497237)
,p_name=>'P4083_SHARED_LOV_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(4437481313497226)
,p_item_source_plug_id=>wwv_flow_imp.id(4437481313497226)
,p_source=>'SHARED_LOV_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4439301963497237)
,p_name=>'P4083_VALUE_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(4437481313497226)
,p_item_source_plug_id=>wwv_flow_imp.id(4437481313497226)
,p_prompt=>'Value Type'
,p_source=>'VALUE_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'WEB_SOURCE_COMP_PARAM_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(358243382603181986)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the type how this parameter is populated.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4439708773497237)
,p_name=>'P4083_VALUE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(4437481313497226)
,p_item_source_plug_id=>wwv_flow_imp.id(4437481313497226)
,p_source=>'VALUE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4440133478497238)
,p_name=>'P4083_LAST_UPDATED_BY'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(4437481313497226)
,p_item_source_plug_id=>wwv_flow_imp.id(4437481313497226)
,p_source=>'LAST_UPDATED_BY'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4440546118497238)
,p_name=>'P4083_LAST_UPDATED_ON'
,p_source_data_type=>'DATE'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(4437481313497226)
,p_item_source_plug_id=>wwv_flow_imp.id(4437481313497226)
,p_source=>'LAST_UPDATED_ON'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4440982335497238)
,p_name=>'P4083_CREATED_BY'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(4437481313497226)
,p_item_source_plug_id=>wwv_flow_imp.id(4437481313497226)
,p_source=>'CREATED_BY'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4441323230497239)
,p_name=>'P4083_CREATED_ON'
,p_source_data_type=>'DATE'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(4437481313497226)
,p_item_source_plug_id=>wwv_flow_imp.id(4437481313497226)
,p_source=>'CREATED_ON'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2320083998209546)
,p_computation_sequence=>10
,p_computation_item=>'P4083_VALUE_LANGUAGE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'case when :P4083_VALUE_TYPE in ( ''EXPRESSION'', ''FUNCTION_BODY'' ) then wwv_flow_code_exec.c_plsql end'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(4467972988653216)
,p_computation_sequence=>10
,p_computation_item=>'P4083_VALUE'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return case :P4083_VALUE_TYPE ',
'           when ''STATIC'' then        :P4083_VALUE_STATIC',
'           when ''ITEM'' then          :P4083_VALUE_ITEM',
'           when ''SQL_QUERY'' then     :P4083_VALUE_SQL',
'           when ''EXPRESSION'' then    :P4083_VALUE_PLSQL_EXPRESSION',
'           when ''FUNCTION_BODY'' then :P4083_VALUE_PLSQL_FUNC_BODY',
'           when ''COLLECTION'' then    :P4083_VALUE_COLLECTION',
'           when ''PREFERENCE'' then    :P4083_VALUE_PREFERENCE',
'       end;'))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4468007595653217)
,p_validation_name=>'P4083_VALUE_STATIC not null'
,p_validation_sequence=>10
,p_validation=>'P4083_VALUE_STATIC'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P4083_VALUE_TYPE'
,p_validation_condition2=>'STATIC'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(4447119598497250)
,p_associated_item=>wwv_flow_imp.id(1465248613917843)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4468195404653218)
,p_validation_name=>'P4083_VALUE_ITEM not null'
,p_validation_sequence=>20
,p_validation=>'P4083_VALUE_ITEM'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P4083_VALUE_TYPE'
,p_validation_condition2=>'ITEM'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(4447119598497250)
,p_associated_item=>wwv_flow_imp.id(1465382459917844)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4468258796653219)
,p_validation_name=>'P4083_VALUE_SQL not null'
,p_validation_sequence=>30
,p_validation=>'P4083_VALUE_SQL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P4083_VALUE_TYPE'
,p_validation_condition2=>'SQL_QUERY'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(4447119598497250)
,p_associated_item=>wwv_flow_imp.id(1465412992917845)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4468349540653220)
,p_validation_name=>'P4083_VALUE_PLSQL_EXPRESSION not null'
,p_validation_sequence=>40
,p_validation=>'P4083_VALUE_PLSQL_EXPRESSION'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P4083_VALUE_TYPE'
,p_validation_condition2=>'PLSQL_EXPRESSION'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(4447119598497250)
,p_associated_item=>wwv_flow_imp.id(1465580604917846)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4468439281653221)
,p_validation_name=>'P4083_VALUE_PLSQL_FUNC_BODY not null'
,p_validation_sequence=>50
,p_validation=>'P4083_VALUE_PLSQL_FUNC_BODY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P4083_VALUE_TYPE'
,p_validation_condition2=>'PLSQL_FUNCTION_BODY'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(4447119598497250)
,p_associated_item=>wwv_flow_imp.id(1465652780917847)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4468559596653222)
,p_validation_name=>'P4083_VALUE_COLLECTION not null'
,p_validation_sequence=>60
,p_validation=>'P4083_VALUE_COLLECTION'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P4083_VALUE_TYPE'
,p_validation_condition2=>'COLLECTION'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(4447119598497250)
,p_associated_item=>wwv_flow_imp.id(1465784271917848)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4468609984653223)
,p_validation_name=>'P4083_VALUE_PREFERENCE not null'
,p_validation_sequence=>70
,p_validation=>'P4083_VALUE_PREFERENCE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P4083_VALUE_TYPE'
,p_validation_condition2=>'PREFERENCE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(4447119598497250)
,p_associated_item=>wwv_flow_imp.id(1465830105917849)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4445239075497245)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(4445185941497245)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4446021760497248)
,p_event_id=>wwv_flow_imp.id(4445239075497245)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1465953680917850)
,p_name=>'VALUE TYPE CHANGE - HIDE ALL'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4083_VALUE_TYPE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4466478432653201)
,p_event_id=>wwv_flow_imp.id(1465953680917850)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4083_VALUE_STATIC,P4083_VALUE_ITEM,P4083_VALUE_SQL,P4083_VALUE_PLSQL_EXPRESSION,P4083_VALUE_PLSQL_FUNC_BODY,P4083_VALUE_COLLECTION,P4083_VALUE_PREFERENCE,P4083_FORMAT_MASK'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4466547127653202)
,p_name=>'VALUE TYPE CHANGE = STATIC'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4083_VALUE_TYPE'
,p_condition_element=>'P4083_VALUE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'STATIC'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4466640786653203)
,p_event_id=>wwv_flow_imp.id(4466547127653202)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4083_VALUE_STATIC'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2687464924958047)
,p_event_id=>wwv_flow_imp.id(4466547127653202)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4083_FORMAT_MASK'
,p_client_condition_type=>'NOT_IN_LIST'
,p_client_condition_element=>'P4083_DATA_TYPE'
,p_client_condition_expression=>'VARCHAR2,BLOB'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4466755893653204)
,p_name=>'VALUE TYPE CHANGE = ITEM'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4083_VALUE_TYPE'
,p_condition_element=>'P4083_VALUE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'ITEM'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4466897578653205)
,p_event_id=>wwv_flow_imp.id(4466755893653204)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4083_VALUE_ITEM'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2687583600958048)
,p_event_id=>wwv_flow_imp.id(4466755893653204)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4083_FORMAT_MASK'
,p_client_condition_type=>'NOT_IN_LIST'
,p_client_condition_element=>'P4083_DATA_TYPE'
,p_client_condition_expression=>'VARCHAR2,BLOB'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4466912660653206)
,p_name=>'VALUE TYPE CHANGE = SQL'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4083_VALUE_TYPE'
,p_condition_element=>'P4083_VALUE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SQL_QUERY'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4467022298653207)
,p_event_id=>wwv_flow_imp.id(4466912660653206)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4083_VALUE_SQL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4467147319653208)
,p_name=>'VALUE TYPE CHANGE = EXPRESSION'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4083_VALUE_TYPE'
,p_condition_element=>'P4083_VALUE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'EXPRESSION'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4467239361653209)
,p_event_id=>wwv_flow_imp.id(4467147319653208)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4083_VALUE_PLSQL_EXPRESSION'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4467335536653210)
,p_name=>'VALUE TYPE CHANGE = FUNCTION BODY'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4083_VALUE_TYPE'
,p_condition_element=>'P4083_VALUE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FUNCTION_BODY'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4467484037653211)
,p_event_id=>wwv_flow_imp.id(4467335536653210)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4083_VALUE_PLSQL_FUNC_BODY'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4467511307653212)
,p_name=>'VALUE TYPE CHANGE = COLLECTION'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4083_VALUE_TYPE'
,p_condition_element=>'P4083_VALUE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'COLLECTION'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4467647234653213)
,p_event_id=>wwv_flow_imp.id(4467511307653212)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4083_VALUE_COLLECTION'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4467789725653214)
,p_name=>'VALUE TYPE CHANGE = PREFERENCE'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4083_VALUE_TYPE'
,p_condition_element=>'P4083_VALUE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'PREFERENCE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4467858881653215)
,p_event_id=>wwv_flow_imp.id(4467789725653214)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4083_VALUE_PREFERENCE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1684987268640316)
,p_event_id=>wwv_flow_imp.id(4467789725653214)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4083_FORMAT_MASK'
,p_client_condition_type=>'NOT_IN_LIST'
,p_client_condition_element=>'P4083_DATA_TYPE'
,p_client_condition_expression=>'VARCHAR2,BLOB'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4448385987497251)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(4437481313497226)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process form Edit REST Source Parameter Values'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>4448385987497251
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4448720632497251)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE,SAVE,DELETE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_internal_uid=>4448720632497251
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4447940845497251)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(4437481313497226)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Edit REST Source Parameter Values'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>4447940845497251
);
end;
/
prompt --application/pages/page_04100
begin
wwv_flow_imp_page.create_page(
 p_id=>4100
,p_name=>'Application Items'
,p_alias=>'APPLICATION-ITEMS'
,p_step_title=>'Application Items'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(91429205691059841)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_item_app.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(337416713)
,p_plug_name=>'About'
,p_region_css_classes=>'a-Region--flush a-Region--stacked a-Region--sideRegion a-Region--padded'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use Application Items to maintain session state. Application Items can be set using computations, processes, or by passing values on a URL. Use "On New Instance" computations to set the value of items once for a session. Use Application Items to m'
||'aintain session state that is not displayed and is not specific to any one page.</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_plug_column_width=>' '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3727517093871356)
,p_plug_name=>'Application Items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select i.id,',
'       i.name,',
'       i.scope,',
'       ''icon-sc-app-item'' icon,',
'       replace(i.name,''_'','' '') alt,',
'       wwv_flow_page_api.get_url(',
'           p_page        => 4303,',
'           p_clear_cache => 4303,',
'           p_items       => ''F4000_P4303_ID'',',
'           p_values      => i.id ) link,',
'       wwv_flow_computation.get_computation_points( :FB_FLOW_ID, i.name ) as comps,',
'       ( select count(*)',
'           from wwv_flow_computations',
'          where security_group_id = :FLOW_SECURITY_GROUP_ID',
'            and flow_id           = :FB_FLOW_ID',
'            and i.name            = computation_item ) application_computations,',
'       ( select count(*)',
'           from wwv_flow_step_computations',
'          where security_group_id = :FLOW_SECURITY_GROUP_ID',
'            and flow_id           = :FB_FLOW_ID',
'            and i.name            = computation_item ) page_computations,',
'       ( select count(*)',
'           from wwv_flow_processing',
'          where security_group_id = :FLOW_SECURITY_GROUP_ID',
'            and flow_id           = :FB_FLOW_ID',
'            and instr( upper( sys.dbms_lob.substr(',
'                    process_sql_clob, 4000, 1 ) ), '':'' || upper( i.name ) ) > 0 ) application_processes,',
'       ( select count(*)',
'           from wwv_flow_step_processing',
'          where security_group_id = :FLOW_SECURITY_GROUP_ID',
'            and flow_id           = :FB_FLOW_ID',
'            and instr( upper( sys.dbms_lob.substr(',
'                    process_sql_clob, 4000, 1 ) ), '':'' || upper( i.name ) ) > 0 ) page_processes,',
'       nvl( i.last_updated_by, i.created_by ) last_updated_by,',
'       nvl( i.last_updated_on, i.created_on ) last_updated,',
'       i.protection_level,',
'       i.escape_on_http_output,',
'       --',
'       case when i.reference_id is not null then',
'           coalesce ( to_char( master.flow_id ),',
'                       wwv_flow_lang_dev.builder_message( ''SUBSCRIBED_FROM.NONEXISTING_MASTER'' ) )',
'       end as subscribed_from,',
'       ( select case when count(*) > 0 then count(*) end',
'           from wwv_flow_items sub',
'          where sub.reference_id      = i.id',
'            and sub.security_group_id = :FLOW_SECURITY_GROUP_ID',
'       ) as subscribers,',
'       case when i.reference_id is not null then',
'           case',
'               when master.version_scn = i.version_scn then',
'                   wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_UP_TO_DATE'')',
'               when master.version_scn != i.version_scn then',
'                   wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_NEEDS_REFRESH'')',
'               else',
'                   wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_UNKNOWN'')',
'           end',
'       end subscription_status,',
'       --',
'       null as actions',
'  from wwv_flow_items i,',
'       wwv_flow_items master',
' where i.flow_id           = :FB_FLOW_ID',
'   and i.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and i.reference_id      = master.id (+)',
'   and i.security_group_id = master.security_group_id (+)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(3727618522871356)
,p_name=>'Application Items'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No application level items exist in this application.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#LINK#" class="a-IRR-icon"><span class="a-Icon #ICON#"></span><span class="a-IRR-iconName">#NAME#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3727827243871363)
,p_db_column_name=>'NAME'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Name'
,p_column_link=>'f?p=&APP_ID.:4303:&SESSION.::&DEBUG.::F4000_P4303_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3728228054871365)
,p_db_column_name=>'COMPS'
,p_display_order=>2
,p_column_identifier=>'E'
,p_column_label=>'Computed On'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3728324116871365)
,p_db_column_name=>'ID'
,p_display_order=>3
,p_column_identifier=>'F'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3731417624925492)
,p_db_column_name=>'APPLICATION_COMPUTATIONS'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Application Computations'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3731813946933809)
,p_db_column_name=>'PAGE_COMPUTATIONS'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Page Computations'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3732521611964395)
,p_db_column_name=>'APPLICATION_PROCESSES'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Application Processes'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3733114816971915)
,p_db_column_name=>'PAGE_PROCESSES'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Page Processes'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3735108283998409)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3735205133998410)
,p_db_column_name=>'LAST_UPDATED'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(25715705946585298)
,p_db_column_name=>'PROTECTION_LEVEL'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Protection Level'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_tz_dependent=>'N'
,p_rpt_named_lov=>wwv_flow_imp.id(109261519627066371)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2373191992105007)
,p_db_column_name=>'ESCAPE_ON_HTTP_OUTPUT'
,p_display_order=>23
,p_column_identifier=>'P'
,p_column_label=>'Escape Special Characters'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(84259319526460470)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(211620524264413267)
,p_db_column_name=>'SCOPE'
,p_display_order=>33
,p_column_identifier=>'N'
,p_column_label=>'Scope'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(211617631947367477)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5205225140040740)
,p_db_column_name=>'SUBSCRIBED_FROM'
,p_display_order=>43
,p_column_identifier=>'Q'
,p_column_label=>'Subscribed From'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5205308317040741)
,p_db_column_name=>'SUBSCRIBERS'
,p_display_order=>53
,p_column_identifier=>'R'
,p_column_label=>'Subscribers'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(8161764126443226)
,p_db_column_name=>'ICON'
,p_display_order=>63
,p_column_identifier=>'S'
,p_column_label=>'Icon'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(8161857230443227)
,p_db_column_name=>'ALT'
,p_display_order=>73
,p_column_identifier=>'T'
,p_column_label=>'Alt'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(8161966783443228)
,p_db_column_name=>'LINK'
,p_display_order=>83
,p_column_identifier=>'U'
,p_column_label=>'Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4414618338904149)
,p_db_column_name=>'SUBSCRIPTION_STATUS'
,p_display_order=>103
,p_column_identifier=>'W'
,p_column_label=>'Subscription Status'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2181627563145906)
,p_db_column_name=>'ACTIONS'
,p_display_order=>113
,p_column_identifier=>'X'
,p_column_label=>'Copy'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'TMPL_THEME_3$ACTIONS'
,p_column_alignment=>'CENTER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'ACTIONS_WRAP', 'N',
  'STYLE', 'b-InlineActions--simple')).to_clob
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(3728530690872449)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_type=>'REPORT'
,p_report_alias=>'1306127644536647'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_view_mode=>'REPORT'
,p_report_columns=>'NAME:COMPS:PROTECTION_LEVEL:SCOPE:SUBSCRIBED_FROM:SUBSCRIPTION_STATUS:SUBSCRIBERS:LAST_UPDATED:LAST_UPDATED_BY::ACTIONS'
,p_sort_column_1=>'NAME'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4410322431904106)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(4419912902081041)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(22760811789529877)
,p_name=>'Recent'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>60
,p_region_css_classes=>'a-Region--flush a-Region--stacked a-Region--sideRegion'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'REGION_POSITION_03'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name p, id',
'from WWV_FLOW_ITEMS',
'where security_group_id = :flow_security_group_id and',
'     flow_id = :fb_flow_id',
'order by last_updated_on desc'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(11667910335347890)
,p_query_num_rows=>10
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No Items found.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.set_region_column_width(
 p_id=>wwv_flow_imp.id(22760811789529877)
,p_plug_column_width=>' '
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22761020113529878)
,p_query_column_id=>1
,p_column_alias=>'P'
,p_column_display_sequence=>1
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=4000:4303:&SESSION.::&DEBUG.::FB_FLOW_ID,F4000_P4303_ID:&FB_FLOW_ID.,#ID#'
,p_column_linktext=>'#P#'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(22761126515529878)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47809708314106355)
,p_plug_name=>'navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(47807005066095922)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Application Items'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(188872800198792603)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(3727517093871356)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4100:&SESSION.::&DEBUG.:4100,RIR::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3730112944886257)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(3727517093871356)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4303:&SESSION.::&DEBUG.:4303::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(522454896)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_BOX_BODY'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'4100'
,p_computation_error_message=>'Unable to compute item value.'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6616219962581737)
,p_name=>'Refresh Subscriptions'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(4410322431904106)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6616694578581743)
,p_event_id=>wwv_flow_imp.id(6616219962581737)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3727517093871356)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6617126743581743)
,p_event_id=>wwv_flow_imp.id(6616219962581737)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ( this.data.successMessage ) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
);
wwv_flow_imp_page.create_component_action(
 p_id=>wwv_flow_imp.id(2181708277145907)
,p_ir_column_id=>wwv_flow_imp.id(2181627563145906)
,p_position_id=>wwv_flow_imp.id(214437533860142316)
,p_display_sequence=>10
,p_template_id=>wwv_flow_imp.id(214438625365151034)
,p_label=>'Copy'
,p_link_target_type=>'REDIRECT_PAGE'
,p_link_target=>'f?p=&APP_ID.:4120:&SESSION.::&DEBUG.:4120:P4120_COPY_SOURCE,P4120_ID,P4120_COPY_FROM_APPLICATION_ID:THIS,#ID#,&FB_FLOW_ID.'
,p_button_display_type=>'ICON'
,p_icon_css_classes=>'icon-copy'
,p_is_hot=>false
,p_show_as_disabled=>false
);
end;
/
prompt --application/pages/page_04101
begin
wwv_flow_imp_page.create_page(
 p_id=>4101
,p_name=>'Application Computations'
,p_alias=>'APPLICATION-COMPUTATIONS'
,p_step_title=>'Application Computations'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(91429205691059841)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_comp.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(344696366)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--sideRegion:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Use Application Computations to assign values to application and page items.<p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9235913606664419)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(4439523336547769)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47828322653545689)
,p_plug_name=>'navigation'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(47827519966525945)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Application Computations'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47836101365827708)
,p_plug_name=>'Application Computations'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c.computation_sequence,',
'       c.computation_point a,',
'       c.computation_item,',
'       c.computation_type b,',
'       ( select p.patch_name',
'           from wwv_flow_patches p',
'          where p.id = c.required_patch',
'            and p.security_group_id = c.security_group_id',
'         union all',
'         select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'',patch_name)|| ''} ''',
'                patch_name',
'           from wwv_flow_patches p',
'          where 0-p.id = c.required_patch',
'            and p.security_group_id = c.security_group_id ) as required_patch,',
'       c.compute_when,',
'       substr( c.computation, 1, 100 ) computation,',
'       c.id,',
'       ''icon-sc-app-computation'' icon,',
'       wwv_flow_page_api.get_url(',
'           p_page        => 4304,',
'           p_clear_cache => 4304,',
'           p_items       => ''F4000_P4304_ID'',',
'           p_values      => c.id ) link,',
'       nvl( c.last_updated_by, c.created_by ) last_updated_by,',
'       nvl( c.last_updated_on, c.created_on ) last_updated_on,',
'       --',
'       case when c.reference_id is not null then',
'           coalesce ( to_char( master.flow_id ),',
'                       wwv_flow_lang_dev.builder_message( ''SUBSCRIBED_FROM.NONEXISTING_MASTER'' ) )',
'       end as subscribed_from,',
'       ( select case when count(*) > 0 then count(*) end',
'           from wwv_flow_computations sub',
'          where sub.reference_id      = c.id',
'            and sub.security_group_id = :FLOW_SECURITY_GROUP_ID',
'       ) as subscribers,',
'       case when c.reference_id is not null then',
'           case',
'               when master.version_scn = c.version_scn then',
'                   wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_UP_TO_DATE'')',
'               when master.version_scn != c.version_scn then',
'                   wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_NEEDS_REFRESH'')',
'               else',
'                   wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_UNKNOWN'')',
'           end',
'       end subscription_status,',
'       --',
'       null as actions',
'  from wwv_flow_computations c,',
'       wwv_flow_computations master',
' where c.flow_id           = :FB_FLOW_ID',
'   and c.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and c.reference_id      = master.id (+)',
'   and c.security_group_id = master.security_group_id (+)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(47836204953827708)
,p_name=>'Application Computations'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#LINK#" class="a-IRR-icon"><span class="a-Icon #ICON#"></span><span class="a-IRR-iconName">#COMPUTATION_ITEM#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47836615965827723)
,p_db_column_name=>'COMPUTATION_ITEM'
,p_display_order=>1
,p_column_identifier=>'C'
,p_column_label=>'Name'
,p_column_link=>'f?p=&APP_ID.:4304:&SESSION.::&DEBUG.:4304:F4000_P4304_ID:#ID#'
,p_column_linktext=>'#COMPUTATION_ITEM#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47836404739827721)
,p_db_column_name=>'COMPUTATION_SEQUENCE'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>'Sequence'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47836528038827722)
,p_db_column_name=>'A'
,p_display_order=>4
,p_column_identifier=>'B'
,p_column_label=>'Point'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(48425308522403722)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47836730424827724)
,p_db_column_name=>'B'
,p_display_order=>5
,p_column_identifier=>'D'
,p_column_label=>'Type'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(84926512995804334)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47837214412827726)
,p_db_column_name=>'ID'
,p_display_order=>7
,p_column_identifier=>'I'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47837031613827725)
,p_db_column_name=>'COMPUTE_WHEN'
,p_display_order=>9
,p_column_identifier=>'G'
,p_column_label=>'Compute When'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47837109389827726)
,p_db_column_name=>'COMPUTATION'
,p_display_order=>10
,p_column_identifier=>'H'
,p_column_label=>'Computation'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47837311524827727)
,p_db_column_name=>'ICON'
,p_display_order=>11
,p_column_identifier=>'J'
,p_column_label=>'Icon'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47837421584827728)
,p_db_column_name=>'LINK'
,p_display_order=>12
,p_column_identifier=>'K'
,p_column_label=>'Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47839810485863843)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>13
,p_column_identifier=>'L'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47839921815863845)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>14
,p_column_identifier=>'M'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47999803968158806)
,p_db_column_name=>'REQUIRED_PATCH'
,p_display_order=>15
,p_column_identifier=>'N'
,p_column_label=>'Build Option'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3347301714623739)
,p_db_column_name=>'SUBSCRIBED_FROM'
,p_display_order=>25
,p_column_identifier=>'O'
,p_column_label=>'Subscribed From'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3347401634623740)
,p_db_column_name=>'SUBSCRIBERS'
,p_display_order=>35
,p_column_identifier=>'P'
,p_column_label=>'Subscribers'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(6610360662558808)
,p_db_column_name=>'SUBSCRIPTION_STATUS'
,p_display_order=>55
,p_column_identifier=>'R'
,p_column_label=>'Subscription Status'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2181868780145908)
,p_db_column_name=>'ACTIONS'
,p_display_order=>65
,p_column_identifier=>'S'
,p_column_label=>'Copy'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'TMPL_THEME_3$ACTIONS'
,p_column_alignment=>'CENTER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'ACTIONS_WRAP', 'N',
  'STYLE', 'b-InlineActions--simple')).to_clob
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(47837809399835130)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_type=>'REPORT'
,p_report_alias=>'1306232580536647'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_view_mode=>'REPORT'
,p_report_columns=>'COMPUTATION_SEQUENCE:COMPUTATION_ITEM:A:B:REQUIRED_PATCH:SUBSCRIBED_FROM:SUBSCRIPTION_STATUS:SUBSCRIBERS::ACTIONS'
,p_sort_column_1=>'COMPUTATION_ITEM'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(188878423026922160)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(47836101365827708)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4101:&SESSION.::&DEBUG.:4101,RIR::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(90835422810354181)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(47836101365827708)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4304:&SESSION.::&DEBUG.:4304::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(4797179695)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'4101'
,p_computation_error_message=>'Unable to compute item value.'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6629872311634116)
,p_name=>'Refresh Subscriptions'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(9235913606664419)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6630224764634118)
,p_event_id=>wwv_flow_imp.id(6629872311634116)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(47836101365827708)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6630776176634119)
,p_event_id=>wwv_flow_imp.id(6629872311634116)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ( this.data.successMessage ) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
);
wwv_flow_imp_page.create_component_action(
 p_id=>wwv_flow_imp.id(2181910426145909)
,p_ir_column_id=>wwv_flow_imp.id(2181868780145908)
,p_position_id=>wwv_flow_imp.id(214437533860142316)
,p_display_sequence=>10
,p_template_id=>wwv_flow_imp.id(214438625365151034)
,p_label=>'Copy'
,p_link_target_type=>'REDIRECT_PAGE'
,p_link_target=>'f?p=&APP_ID.:4102:&SESSION.::&DEBUG.:4102:P4102_COPY_SOURCE,P4102_ID,P4102_COPY_FROM_APPLICATION_ID:THIS,#ID#,&FB_FLOW_ID.'
,p_button_display_type=>'ICON'
,p_icon_css_classes=>'icon-copy'
,p_is_hot=>false
,p_show_as_disabled=>false
);
end;
/
prompt --application/pages/page_04102
begin
wwv_flow_imp_page.create_page(
 p_id=>4102
,p_name=>'Copy Application Computation'
,p_alias=>'COPY-APPLICATION-COMPUTATION'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Application Computation'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'auto'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_protection_level=>'C'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(65158995101194481)
,p_plug_name=>'Wizard Button'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(249899977749337370)
,p_plug_name=>'Copy Application Computation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4421191908862964)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(65158995101194481)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4411217688904115)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(65158995101194481)
,p_button_name=>'COPY_FROM_ANOTHER'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Copy from another app'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:4102:&SESSION.::&DEBUG.:4102:P4102_COPY_SOURCE:OTHER'
,p_button_condition=>'P4102_COPY_SOURCE'
,p_button_condition2=>'THIS'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_button_css_classes=>'a-Button--noUI'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4421549034862966)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(65158995101194481)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy Application Computation'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4433395106863011)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(4421549034862966)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18738019909528472)
,p_name=>'P4102_NEW_COMPUTATION_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(249899977749337370)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33745416610319685)
,p_name=>'P4102_SUBSCRIBE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(249899977749337370)
,p_item_default=>'Y'
,p_prompt=>'Subscribe'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>'P4102_COPY_SOURCE'
,p_display_when2=>'OTHER'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'While copying the application computation, you can also subscribe to it. Set Subscribe to <strong>On</strong> to subscribe to the application computation.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(34045015413398282)
,p_name=>'P4102_COPY_SOURCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(249899977749337370)
,p_item_default=>'THIS'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(230413173580260068)
,p_name=>'P4102_COPY_FROM_APPLICATION_ID'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(249899977749337370)
,p_prompt=>'Application'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST OTHER FLOWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'  from   wwv_flow_visible_flows f',
' where id != :FB_FLOW_ID',
'   and build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'order by 2'))
,p_lov_cascade_parent_items=>'P4102_COPY_SOURCE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>'P4102_COPY_SOURCE'
,p_display_when2=>'OTHER'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Select the application from which you want to copy an application computation.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(249923674939377452)
,p_name=>'P4102_COMPUTATION_ITEM'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(249899977749337370)
,p_prompt=>'New Computation Item'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'COMPUTATION_ITEM'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''APPLICATION'')||'': ''||name d, name v',
'  from wwv_flow_items',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' union all',
'select wwv_flow_lang.system_message(''PAGE'')||'': ''||flow_step_id||'' ''||name d, name v',
'  from wwv_flow_step_items',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by 1'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select an application level or a page level item.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(249926991215382158)
,p_name=>'P4102_ID'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(249899977749337370)
,p_prompt=>'Copy Application Computation'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select computation_item d,',
'       id r',
'  from wwv_flow_computations',
' where flow_id           = :P4102_COPY_FROM_APPLICATION_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
' order by computation_item'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Application Computation -'
,p_lov_null_value=>'0'
,p_lov_cascade_parent_items=>'P4102_COPY_FROM_APPLICATION_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_read_only_when=>'P4102_ID'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify an application computation to copy.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'Y'
,p_attribute_06=>'0'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(4484767773954401)
,p_computation_sequence=>10
,p_computation_item=>'P4102_COMPUTATION_ITEM'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(:P4102_COMPUTATION_ITEM)'
,p_compute_when=>'P4102_COMPUTATION_ITEM'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4426869931863003)
,p_validation_name=>'P4102_COMPUTATION_ITEM not null'
,p_validation_sequence=>10
,p_validation=>'P4102_COMPUTATION_ITEM'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>':P4102_COPY_SOURCE = ''THIS'' or :P4102_SUBSCRIBE = ''N'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(4421549034862966)
,p_associated_item=>wwv_flow_imp.id(249923674939377452)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4484827122954402)
,p_validation_name=>'P4102_COMPUTATION_ITEM item exists'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_f4000_util.get_page_item_id(',
'                     p_item_name       => :P4102_COMPUTATION_ITEM ,',
'                     p_application_id  => :FB_FLOW_ID ) is not null',
'or wwv_flow_f4000_util.get_application_item_id(',
'                     p_item_name       => :P4102_COMPUTATION_ITEM ,',
'                     p_application_id  => :FB_FLOW_ID ) is  not null'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Item does not exist.'
,p_validation_condition=>':P4102_COMPUTATION_ITEM is not null and ( :P4102_COPY_SOURCE = ''THIS'' or :P4102_SUBSCRIBE = ''N'' )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(4421549034862966)
,p_associated_item=>wwv_flow_imp.id(249923674939377452)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4427585661863005)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(4421191908862964)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4428066761863007)
,p_event_id=>wwv_flow_imp.id(4427585661863005)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4428471752863007)
,p_name=>'On Change of P4102_COPY_SOURCE'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4102_COPY_SOURCE'
,p_condition_element=>'P4102_COPY_SOURCE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'THIS'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4428953092863008)
,p_event_id=>wwv_flow_imp.id(4428471752863007)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4102_COPY_FROM_APPLICATION_ID,P4102_SUBSCRIBE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4429413591863008)
,p_event_id=>wwv_flow_imp.id(4428471752863007)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4102_COPY_FROM_APPLICATION_ID,P4102_SUBSCRIBE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4429914227863008)
,p_event_id=>wwv_flow_imp.id(4428471752863007)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4102_COPY_FROM_APPLICATION_ID'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'&FB_FLOW_ID.'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4430456763863008)
,p_event_id=>wwv_flow_imp.id(4428471752863007)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4102_COPY_FROM_APPLICATION_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4430912034863009)
,p_event_id=>wwv_flow_imp.id(4428471752863007)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4102_SUBSCRIBE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4431431106863009)
,p_event_id=>wwv_flow_imp.id(4428471752863007)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4102_SUBSCRIBE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4431896767863009)
,p_name=>'Toggle P4102_COMPUTATION_ITEM display'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4102_SUBSCRIBE'
,p_condition_element=>'P4102_SUBSCRIBE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4432391664863009)
,p_event_id=>wwv_flow_imp.id(4431896767863009)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4102_COMPUTATION_ITEM'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4432870153863010)
,p_event_id=>wwv_flow_imp.id(4431896767863009)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4102_COMPUTATION_ITEM'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4427179414863003)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Application Computation'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P4102_NEW_COMPUTATION_ID := wwv_flow_copy_metadata.copy_app_computation (',
'    p_copy_from_computation_id  => :P4102_ID,',
'    p_copy_from_app_id          => :P4102_COPY_FROM_APPLICATION_ID,',
'    p_new_computation_item      => :P4102_COMPUTATION_ITEM,',
'    p_copy_to_app_id            => :FB_FLOW_ID,',
'    p_include_subscription      => :P4102_SUBSCRIBE = ''Y'' );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to copy the application computation.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(4421549034862966)
,p_process_success_message=>'Application computation copied.'
,p_internal_uid=>4427179414863003
);
end;
/
prompt --application/pages/page_04110
begin
wwv_flow_imp_page.create_page(
 p_id=>4110
,p_name=>'Lists of Values'
,p_alias=>'LISTS-OF-VALUES'
,p_step_title=>'Lists of Values'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213211113434774960)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_lov.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(394086908)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--sideRegion:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>A List of Values can be referenced by page items as well as report fields.  It controls the values displayed and limits the user''s selection. Lists of Values can be static (based on values you enter), or dynamic (based on different data sources of'
||' either Local Database, REST Enabled SQL or REST Data Source).</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1548308438182178)
,p_plug_name=>'Lists of Values'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with messages as (',
'    select ( select wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_UP_TO_DATE'') from sys.dual ) up_to_date,',
'           ( select wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_NEEDS_REFRESH'') from sys.dual ) needs_refresh,',
'           ( select wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_UNKNOWN'') from sys.dual ) unknown_status,',
'           ( select wwv_flow_lang_dev.builder_message(''SUBSCRIBED_FROM.NONEXISTING_MASTER'') from sys.dual ) no_master',
'      from sys.dual )',
'select ''icon-sc-lov'' icon_class,',
'       wwv_flow_utilities.prepare_url(',
'           p_url => ''f?p=4000:4111:''||:app_session||''::NO:4111:F4000_P4111_ID:''||l.ID',
'       ) as edit_link,',
'       replace(replace(l.lov_name,''_'','' ''),''.'','' '') icon_title,',
'       l.ID,',
'       l.flow_id, ',
'       l.lov_name,',
'       case l.location',
'           when ''LOCAL'' then ',
'               case when l.source_type <> ''LEGACY_SQL'' then ',
'                   system_message."LOCAL" ',
'               else ',
'                   system_message."LEGACY_SQL" ',
'               end',
'           when ''REMOTE''     then system_message."REST_ENABLED_SQL"',
'           when ''WEB_SOURCE'' then system_message."WEB_SOURCE"',
'           when ''STATIC''     then system_message."STATIC"',
'       end lov_type,',
'       nvl(l.last_updated_on,l.created_on) LAST_UPDATED_ON,',
'       l.last_updated_by,',
'       decode(substr(l.lov_query,1,1),''.'','''',',
'         decode(substr(upper(l.lov_query),1,6),''STATIC'','''',substr(l.lov_query,1,3500)))',
'       LOV_QUERY,',
'       case when substr(l.lov_query,1,1) = ''.'' then',
'           (select count(*)',
'              from   wwv_flow_list_of_values_data',
'             where  lov_id = l.id and security_group_id = :flow_security_group_id)',
'       end entry_count,',
'       --',
'       case when l.reference_id is not null then',
'           coalesce ( to_char( master.flow_id ),',
'                       messages.no_master )',
'       end as subscribed_from,',
'       ( select case when count(*) > 0 then count(*) end',
'           from wwv_flow_lists_of_values$ sub',
'          where sub.reference_id      = l.id',
'            and sub.security_group_id = :WORKSPACE_ID ) as subscribers,',
'       case when l.reference_id is not null then',
'           case',
'               when master.version_scn = l.version_scn then',
'                   messages.up_to_date',
'               when master.version_scn != l.version_scn then',
'                   messages.needs_refresh',
'               else',
'                   messages.unknown_status',
'           end',
'       end subscription_status,',
'       --',
'       null as actions',
'from   WWV_FLOW_LISTS_OF_VALUES$ l,',
'       WWV_FLOW_LISTS_OF_VALUES$ master,',
'       messages,',
'(select ',
'wwv_flow_lang.system_message(''F4000.STATIC'')           "STATIC",',
'wwv_flow_lang.system_message(''F4000.LOCAL'')            "LOCAL",',
'wwv_flow_lang.system_message(''F4000.LEGACY_SQL'')       "LEGACY_SQL",',
'wwv_flow_lang.system_message(''F4000.REST_ENABLED_SQL'') "REST_ENABLED_SQL",',
'wwv_flow_lang.system_message(''F4000.WEB_SOURCE'')       "WEB_SOURCE"',
'from dual) system_message',
'where l.flow_id                = :FB_FLOW_ID',
'  and l.security_group_id      = :WORKSPACE_ID',
'  and l.reference_id           = master.id (+)',
'  and l.security_group_id      = master.security_group_id (+)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(1548412223182178)
,p_name=>'Lists of Values'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No List of Values found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#EDIT_LINK#" class="a-IRR-icon"><span class="a-Icon #ICON_CLASS#"></span><span class="a-IRR-iconName">#ICON_TITLE#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1548702627182185)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Edit Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1548905125182185)
,p_db_column_name=>'ID'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1549021708182185)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1549113598182186)
,p_db_column_name=>'LOV_NAME'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Name'
,p_column_link=>'#EDIT_LINK#'
,p_column_linktext=>'#LOV_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1549225783182186)
,p_db_column_name=>'LOV_TYPE'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Type'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1549419300182186)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1549500296182186)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1551205210206584)
,p_db_column_name=>'LOV_QUERY'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Query'
,p_allow_sorting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_column_type=>'STRING'
,p_rpt_show_filter_lov=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1556001972271876)
,p_db_column_name=>'ENTRY_COUNT'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Entry Count'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1340561708125198327)
,p_db_column_name=>'SUBSCRIBED_FROM'
,p_display_order=>22
,p_column_identifier=>'S'
,p_column_label=>'Subscribed From'
,p_column_type=>'STRING'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1340561864259198328)
,p_db_column_name=>'SUBSCRIBERS'
,p_display_order=>32
,p_column_identifier=>'T'
,p_column_label=>'Subscribers'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(656703198583098697)
,p_db_column_name=>'ICON_CLASS'
,p_display_order=>42
,p_column_identifier=>'P'
,p_column_label=>'ICON_CLASS'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(656707978041167011)
,p_db_column_name=>'ICON_TITLE'
,p_display_order=>52
,p_column_identifier=>'Q'
,p_column_label=>'ICON_TITLE'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1600483487586804)
,p_db_column_name=>'ACTIONS'
,p_display_order=>62
,p_column_identifier=>'U'
,p_column_label=>'Copy'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'TMPL_THEME_3$ACTIONS'
,p_column_alignment=>'CENTER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'ACTIONS_WRAP', 'N',
  'STYLE', 'b-InlineActions--simple')).to_clob
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5729400025070709)
,p_db_column_name=>'SUBSCRIPTION_STATUS'
,p_display_order=>72
,p_column_identifier=>'V'
,p_column_label=>'Subscription Status'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(1550029190194632)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_type=>'REPORT'
,p_report_alias=>'1306332520536647'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_view_mode=>'REPORT'
,p_report_columns=>'LOV_NAME:LOV_TYPE:ENTRY_COUNT:SUBSCRIBED_FROM:SUBSCRIPTION_STATUS:SUBSCRIBERS:LAST_UPDATED_ON:ACTIONS:'
,p_sort_column_1=>'LOV_NAME'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'REFERENCES'
,p_sort_direction_2=>'DESC'
,p_sort_column_3=>'ENTRY_COUNT'
,p_sort_direction_3=>'DESC'
,p_sort_column_4=>'LAST_UPDATED_ON'
,p_sort_direction_4=>'DESC'
,p_sort_column_5=>'LAST_UPDATED_BY'
,p_sort_direction_5=>'DESC NULLS LAST'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17776266807125065)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(10662051819310192)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(115612724617589113)
,p_name=>'Recently Edited'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>60
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_display_column=>1
,p_display_point=>'REGION_POSITION_03'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select initcap(replace(replace(LOV_NAME,''_'','' ''),''.'','' '')) n, id',
'from WWV_FLOW_LISTS_OF_VALUES$',
'where last_updated_on is not null ',
'and flow_id = :fb_flow_id',
'and security_group_id = :flow_security_group_id',
'order by LAST_UPDATED_ON DESC'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(11667910335347890)
,p_query_num_rows=>10
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No recently edited List of Values found.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>10
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(115616313667595495)
,p_query_column_id=>1
,p_column_alias=>'N'
,p_column_display_sequence=>1
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=4000:4111:&SESSION.::&DEBUG.:4111:F4000_P4111_ID:#ID#'
,p_column_linktext=>'#N#'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(115620702370601654)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_column_heading=>'ID'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(203038606023376563)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(203029530177365353)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Lists of Values'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(188987204899959490)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1548308438182178)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4110:&SESSION.::&DEBUG.:4110,RIR::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30370320039998454)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1548308438182178)
,p_button_name=>'COPY'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Copy'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:603:&SESSION.::&DEBUG.:603:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30370505625003721)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(1548308438182178)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:137:&SESSION.::&DEBUG.:4004,4007,4014,137,138,139,4080,4081,4082::'
,p_icon_css_classes=>'icon-right-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(308985838)
,p_branch_action=>'4110'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(130828990069)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'4110'
,p_computation_error_message=>'Unable to compute item value.'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(309985839)
,p_computation_sequence=>20
,p_computation_item=>'F4000_P4111_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'Unable to compute item value.'
,p_compute_when=>'wwv_flow.g_request = ''CREATE_ROW'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(9261215880081440)
,p_name=>'Dialog Closed'
,p_event_sequence=>30
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(1548308438182178)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(9261328238081441)
,p_event_id=>wwv_flow_imp.id(9261215880081440)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'TRIGGERING_ELEMENT'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(10660150763319175)
,p_name=>'Refresh Subscriptions'
,p_event_sequence=>40
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(17776266807125065)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(10660523950319173)
,p_event_id=>wwv_flow_imp.id(10660150763319175)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1548308438182178)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(10661015822319172)
,p_event_id=>wwv_flow_imp.id(10660150763319175)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ( this.data.successMessage ) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
);
wwv_flow_imp_page.create_component_action(
 p_id=>wwv_flow_imp.id(1600593404586805)
,p_ir_column_id=>wwv_flow_imp.id(1600483487586804)
,p_position_id=>wwv_flow_imp.id(214437533860142316)
,p_display_sequence=>10
,p_template_id=>wwv_flow_imp.id(214438625365151034)
,p_label=>'Copy'
,p_link_target_type=>'REDIRECT_PAGE'
,p_link_target=>'f?p=&APP_ID.:603:&SESSION.::&DEBUG.:603:P603_ID:#ID#'
,p_button_display_type=>'ICON'
,p_icon_css_classes=>'icon-copy'
,p_is_hot=>false
,p_show_as_disabled=>false
);
end;
/
prompt --application/pages/page_04111
begin
wwv_flow_imp_page.create_page(
 p_id=>4111
,p_name=>'Named Lists of Values'
,p_alias=>'NAMED-LISTS-OF-VALUES'
,p_step_title=>'Edit List of Values'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213211113434774960)
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// Used to hold variable values for page Dynamic Actions',
'var p4111 = {};',
'',
'// Store column mapping values, so we can try to set them back again following a refresh',
'function storeColumnMappings(){',
'    p4111.columnMappingValues = {',
'        ''P4111_RETURN_COLUMN'':       apex.item( ''P4111_RETURN_COLUMN'' ).getValue(),',
'        ''P4111_DISPLAY_COLUMN'':      apex.item( ''P4111_DISPLAY_COLUMN'' ).getValue(),',
'        ''P4111_GROUP_COLUMN'':        apex.item( ''P4111_GROUP_COLUMN'' ).getValue(),',
'        ''P4111_ICON_COLUMN'':         apex.item( ''P4111_ICON_COLUMN'' ).getValue(),',
'        ''P4111_DEFAULT_SORT_COLUMN'': apex.item( ''P4111_DEFAULT_SORT_COLUMN'' ).getValue(),',
'        ''P4111_ORACLE_TEXT_COLUMN'':  apex.item( ''P4111_ORACLE_TEXT_COLUMN'' ).getValue(),        ',
'    };',
'}',
'',
'// Set column mapping value',
'function setColumnMappings( pItemName ){',
'    var lValue = p4111.columnMappingValues[ pItemName ];',
'    if ( lValue ) {',
'        apex.item( pItemName ).setValue( lValue );',
'    }',
'}',
'',
'// Checks if the current source definition is a valid one (has everything defined that needs to be, to get column information).',
'function isValidSourceDefinition(){ ',
'    var lLocation           = apex.item( ''P4111_LOCATION'' ),',
'        lSourceType         = apex.item( ''P4111_SOURCE_TYPE'' ),',
'        lLovQuerySQL        = apex.item( ''P4111_LOV_QUERY_SQL'' ),',
'        lLovQueryFunc       = apex.item( ''P4111_LOV_QUERY_FUNC_BODY'' ),',
'        lQueryTable         = apex.item( ''P4111_QUERY_TABLE'' ),',
'        lRemoteSourceType   = apex.item( ''P4111_REMOTE_SOURCE_TYPE'' ),',
'        lRemoteSQL          = apex.item( ''P4111_REMOTE_SQL'' ),',
'        lRemoteTableName    = apex.item( ''P4111_REMOTE_TABLE_NAME'' ),',
'        lWebSrcModule       = apex.item( ''P4111_WEB_SRC_MODULE_ID'' ),',
'        lWebSrcArrayColId   = apex.item( ''P4111_WEB_SRC_ARRAY_COL_ID'' ),',
'        lGraphName          = apex.item( ''P4111_GRAPH_NAME'' ),',
'        lMatchClause        = apex.item( ''P4111_PQL_MATCH_CLAUSE'' ),',
'        lColumnsClause      = apex.item( ''P4111_PQL_COLUMNS_CLAUSE'' );',
'    ',
'    switch ( lLocation.getValue() ) {',
'        case ''LOCAL'':      ',
'            switch ( lSourceType.getValue() ) {',
'                case ''SQL'':',
'                    return !lLovQuerySQL.isEmpty();',
'                    break;',
'                case ''FUNC_BODY_RETURNING_SQL'':',
'                    return !lLovQueryFunc.isEmpty();',
'                    break;',
'                case ''TABLE'':',
'                    return !lQueryTable.isEmpty();',
'                case ''GRAPH'':',
'                    return !lGraphName.isEmpty() && !lMatchClause.isEmpty() && !lColumnsClause.isEmpty();',
'            };',
'            break;',
'        case ''REMOTE'':',
'            switch ( lRemoteSourceType.getValue() ) {',
'                case ''SQL'':',
'                    return !lRemoteSQL.isEmpty();',
'                    break;',
'                case ''TABLE'':',
'                    return !lRemoteTableName.isEmpty();',
'            };',
'            break;',
'        case ''WEB_SOURCE'':',
'                return !lWebSrcModule.isEmpty();',
'            break;',
'    }',
'    ',
'    return false;',
'}',
''))
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'EXPRESSION'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'( :F4000_P4111_ID is not null  ',
'  and wwv_flow_lov_dev.is_based_on_graph( :F4000_P4111_ID ) ',
'  and sys.dbms_db_version.version < 23 ) ',
'or :F4000_P4111_REFERENCE_ID is not null'))
,p_read_only_when2=>'PLSQL'
,p_help_text=>'bldapp_lov.htm'
,p_page_component_map=>'21'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(395110922)
,p_plug_name=>'List of Values'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>130
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'Lists of Values can be static, hard coded display values and return values, or dynamic, based on different data sources. Data sources of either Local Database, REST Enabled SQL or REST Data Source are supported.'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(396113952)
,p_plug_name=>'Name'
,p_region_name=>'N'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>' '
,p_plug_query_row_template=>wwv_flow_imp.id(79387910442923002)
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROW_RANGES_IN_SELECT_LIST'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'L:L:L:L:L:L'
,p_plug_query_sum_cols=>'NO:NO:NO:NO:NO:NO'
,p_plug_query_number_formats=>':::::'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(397115560)
,p_plug_name=>'List of Values: &P4111_N.'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_header=>'<h1>'
,p_plug_footer=>'</h1>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(63176833274)
,p_name=>'Source: Static Values'
,p_region_name=>'SRC'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       lov_disp_sequence, ',
'       substr(lov_disp_value,1,100) lov_disp_value, ',
'       lov_return_value, ',
'       decode(lov_disp_cond_type,null,null,''<span class="a-Icon icon-check"></span>'') lov_disp_cond_type,',
'       last_updated_on',
'from   wwv_flow_list_of_values_data',
'where  lov_id = :F4000_P4111_ID',
'  and  flow_id = :FB_FLOW_ID',
'  and  security_group_id = :flow_security_group_id'))
,p_display_condition_type=>'NEVER'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'&nbsp;'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(932666891452561018)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48658118900771489)
,p_query_column_id=>2
,p_column_alias=>'LOV_DISP_SEQUENCE'
,p_column_display_sequence=>2
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48658227777771489)
,p_query_column_id=>3
,p_column_alias=>'LOV_DISP_VALUE'
,p_column_display_sequence=>3
,p_column_heading=>'Display'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:4113:&SESSION.::&DEBUG.:RP:F4000_P4113_ID:#ID#:'
,p_column_linktext=>'#LOV_DISP_VALUE#'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48658309251771489)
,p_query_column_id=>4
,p_column_alias=>'LOV_RETURN_VALUE'
,p_column_display_sequence=>4
,p_column_heading=>'Return'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48658432295771489)
,p_query_column_id=>5
,p_column_alias=>'LOV_DISP_COND_TYPE'
,p_column_display_sequence=>5
,p_column_heading=>'Conditional'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_report_column_width=>40
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(113978927691693005)
,p_query_column_id=>6
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>6
,p_column_heading=>'Updated'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1483115269307020)
,p_plug_name=>'Additional Display Columns'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P4111_LOCATION in (''LOCAL'',''REMOTE'',''WEB_SOURCE'')'
,p_plug_display_when_cond2=>'PLSQL'
,p_plug_header=>'Additional display columns can be defined for item types that support multiple display columns, for example the Popup LOV. For item types that do not support multiple columns, these will be ignored. If adding additional display columns ensure that th'
||'e return column is included in the column list. The return column can be set to Visible No and Searchable No if you do not want it displayed to users.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9499495849275742)
,p_plug_name=>'Additional Display Columns IG'
,p_region_name=>'COL_IG'
,p_parent_plug_id=>wwv_flow_imp.id(1483115269307020)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>90
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select n001 id,',
'       n002 display_sequence,',
'       c001 column_name, ',
'       c002 heading,',
'       c003 format_mask,',
'       c004 data_type,',
'       c005 is_visible,',
'       c006 is_searchable,',
'       c007 column_comment,',
'       seq_id',
'  from wwv_flow_collections',
' where collection_name = ''LOV_COL_INFO'''))
,p_plug_source_type=>'NATIVE_IG'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P4111_LOCATION in (''LOCAL'',''REMOTE'',''WEB_SOURCE'')'
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(9499648783275744)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>40
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(9499785522275745)
,p_name=>'COLUMN_NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'COLUMN_NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Column Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>20
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(9499841474275746)
,p_name=>'HEADING'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'HEADING'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Heading'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>30
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_item_width=>60
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(9499995556275747)
,p_name=>'DISPLAY_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DISPLAY_SEQUENCE'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Sequence'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>10
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_item_width=>10
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(9500146418275749)
,p_name=>'FORMAT_MASK'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FORMAT_MASK'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Format Mask'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>110
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_item_width=>60
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(9500255407275750)
,p_name=>'DATA_TYPE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DATA_TYPE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Data Type'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>50
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(20213169868919110)
,p_name=>'ROW_ACTIONS'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>1
,p_use_as_row_header=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(20996402546632603)
,p_name=>'IS_VISIBLE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'IS_VISIBLE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_YES_NO'
,p_heading=>'Visible'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>130
,p_value_alignment=>'LEFT'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
,p_attribute_03=>'Yes'
,p_attribute_04=>'N'
,p_attribute_05=>'No'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(21123426452823701)
,p_name=>'SEQ_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'SEQ_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>140
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(23197628206325501)
,p_name=>'IS_SEARCHABLE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'IS_SEARCHABLE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_YES_NO'
,p_heading=>'Searchable'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>80
,p_value_alignment=>'LEFT'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
,p_attribute_03=>'Yes'
,p_attribute_04=>'N'
,p_attribute_05=>'No'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(23197949678325504)
,p_name=>'COLUMN_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'COLUMN_COMMENT'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Column Comment'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>120
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_item_width=>60
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(9499596054275743)
,p_internal_uid=>9499596054275743
,p_is_editable=>true
,p_edit_operations=>'u:d'
,p_lost_update_check_type=>'VALUES'
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_show_nulls_as=>'-'
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>true
,p_no_data_found_message=>'No additional display columns defined'
,p_show_toolbar=>true
,p_toolbar_buttons=>'RESET'
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>true
,p_define_chart_view=>true
,p_enable_download=>true
,p_download_formats=>'HTML'
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(23204494782337413)
,p_interactive_grid_id=>wwv_flow_imp.id(9499596054275743)
,p_static_id=>'14221'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(23204590036337413)
,p_report_id=>wwv_flow_imp.id(23204494782337413)
,p_view_type=>'GRID'
,p_stretch_columns=>true
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(20895892182270194)
,p_view_id=>wwv_flow_imp.id(23204590036337413)
,p_display_seq=>0
,p_column_id=>wwv_flow_imp.id(20213169868919110)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(21007420305862821)
,p_view_id=>wwv_flow_imp.id(23204590036337413)
,p_display_seq=>7
,p_column_id=>wwv_flow_imp.id(20996402546632603)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>130
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(21129537434825011)
,p_view_id=>wwv_flow_imp.id(23204590036337413)
,p_display_seq=>13
,p_column_id=>wwv_flow_imp.id(21123426452823701)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(23205053306337416)
,p_view_id=>wwv_flow_imp.id(23204590036337413)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(9499648783275744)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(23205593766337422)
,p_view_id=>wwv_flow_imp.id(23204590036337413)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(9499785522275745)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>183
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(23206046599337424)
,p_view_id=>wwv_flow_imp.id(23204590036337413)
,p_display_seq=>4
,p_column_id=>wwv_flow_imp.id(9499841474275746)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>155
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(23206493363337426)
,p_view_id=>wwv_flow_imp.id(23204590036337413)
,p_display_seq=>2
,p_column_id=>wwv_flow_imp.id(9499995556275747)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>97
,p_sort_order=>1
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(23207453038337429)
,p_view_id=>wwv_flow_imp.id(23204590036337413)
,p_display_seq=>9
,p_column_id=>wwv_flow_imp.id(9500146418275749)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>148
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(23207903459337431)
,p_view_id=>wwv_flow_imp.id(23204590036337413)
,p_display_seq=>6
,p_column_id=>wwv_flow_imp.id(9500255407275750)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>134
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(23208402823337432)
,p_view_id=>wwv_flow_imp.id(23204590036337413)
,p_display_seq=>8
,p_column_id=>wwv_flow_imp.id(23197628206325501)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>84
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(23209921453337438)
,p_view_id=>wwv_flow_imp.id(23204590036337413)
,p_display_seq=>10
,p_column_id=>wwv_flow_imp.id(23197949678325504)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(20215412492919133)
,p_plug_name=>'Column Mapping'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P4111_LOCATION in (''LOCAL'',''REMOTE'',''WEB_SOURCE'')'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(33426411524290175)
,p_plug_name=>'Subscription'
,p_region_name=>'SUBSCRIPTION'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>300
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'WWV_FLOW_LISTS_OF_VALUES$',
  'attribute_02', 'LOV_NAME',
  'attribute_03', 'F4000_P4111_ID',
  'attribute_04', 'F4000_P4111_REFERENCE_ID',
  'attribute_05', 'SUBSCRIBE_LOV',
  'attribute_06', 'VERSION_SCN')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46251304866678998)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(110966926074654341)
,p_plug_name=>'Property Graph is not supported'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>5
,p_location=>null
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'This List of Values is based on a Property Graph, which requires Oracle Database 23ai or later. Thus, this page is read only.',
''))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_lov_dev.is_based_on_graph( :F4000_P4111_ID ) and sys.dbms_db_version.version < 23'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(202306103707329518)
,p_plug_name=>'Source'
,p_region_name=>'SRC'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_lists_of_values$',
' where id                 = :F4000_P4111_ID ',
'   and location          <> ''STATIC''',
'   and security_group_id  = :FLOW_SECURITY_GROUP_ID',
'union',
'select 1 ',
'  from sys.dual ',
' where :F4000_P4111_ID is null'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(399144664)
,p_plug_name=>'Example: Dynamic Lists of Values on Function Returning SQL'
,p_parent_plug_id=>wwv_flow_imp.id(202306103707329518)
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689970285456172024)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'A function that returns a SQL query with two columns:',
'<pre>',
'if :MY_ITEM=''10'' then',
'    return ''SELECT ename, empno FROM emp WHERE deptno = 10 ORDER BY 1'';',
'else',
'    return ''SELECT ename, empno FROM emp WHERE deptno = :MY_ITEM ORDER BY 1'';',
'end if;',
'</pre>'))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(73945327537305242)
,p_plug_name=>'Local Data Source'
,p_parent_plug_id=>wwv_flow_imp.id(202306103707329518)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>1
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(73951063066307275)
,p_plug_name=>'REST Data Source'
,p_parent_plug_id=>wwv_flow_imp.id(202306103707329518)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>160
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P4111_SOURCE_TYPE_HIDDEN'
,p_plug_display_when_cond2=>'LEGACY_SQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(1461332165917804)
,p_name=>'REST Source Parameters'
,p_parent_plug_id=>wwv_flow_imp.id(73951063066307275)
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>60
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--horizontalBorders:a-Report--stretch:a-Report--rowHighlight'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select cp.id,',
'       p.name,',
'       p.is_query_param,',
'       cp.value_type,',
'       cp.value,',
'       p.data_type,',
'       cp.format_mask',
'  from wwv_flow_web_src_comp_params cp,',
'       wwv_flow_web_src_params p',
' where p.id = cp.web_src_param_id',
'   and cp.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and cp.flow_id = nv(''FB_FLOW_ID'')',
'   and cp.shared_lov_id = :F4000_P4111_ID',
' order by p.name'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_web_src_comp_params',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and shared_lov_id     = :F4000_P4111_ID'))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>'No parameters defined for the selected REST Data Source.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1461400182917805)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:4083:&SESSION.::&DEBUG.:RP,4083:P4083_ID:#ID#'
,p_column_linktext=>'<img src="#IMAGE_PREFIX#app_ui/img/icons/apex-edit-pencil.png" class="apex-edit-pencil" alt="Edit #NAME#">'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1463021423917821)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(510295765939814531)
,p_query_column_id=>3
,p_column_alias=>'IS_QUERY_PARAM'
,p_column_display_sequence=>32
,p_column_heading=>'Use for Search'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(84259319526460470)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1462438593917815)
,p_query_column_id=>4
,p_column_alias=>'VALUE_TYPE'
,p_column_display_sequence=>22
,p_column_heading=>'Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV'
,p_named_lov=>wwv_flow_imp.id(358243382603181986)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1462508157917816)
,p_query_column_id=>5
,p_column_alias=>'VALUE'
,p_column_display_sequence=>42
,p_column_heading=>'Value'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2233106535790548)
,p_query_column_id=>6
,p_column_alias=>'DATA_TYPE'
,p_column_display_sequence=>12
,p_column_heading=>'Parameter Data Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(2225637019805602)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2233258733790549)
,p_query_column_id=>7
,p_column_alias=>'FORMAT_MASK'
,p_column_display_sequence=>62
,p_column_heading=>'Format Mask'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(20215619883919135)
,p_plug_name=>'Advanced REST Data Source Attributes'
,p_parent_plug_id=>wwv_flow_imp.id(73951063066307275)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P4111_LOCATION in (''LOCAL'',''REMOTE'',''WEB_SOURCE'')'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(75743329779916863)
,p_plug_name=>'Remote SQL'
,p_parent_plug_id=>wwv_flow_imp.id(202306103707329518)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>170
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P4111_SOURCE_TYPE_HIDDEN'
,p_plug_display_when_cond2=>'LEGACY_SQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(20212831971919107)
,p_plug_name=>'Remote Caching'
,p_parent_plug_id=>wwv_flow_imp.id(75743329779916863)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>110
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P4111_LOCATION in (''LOCAL'',''REMOTE'',''WEB_SOURCE'')'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(125268524262083710)
,p_plug_name=>'Example: Dynamic Lists of Values on SQL Queries'
,p_parent_plug_id=>wwv_flow_imp.id(202306103707329518)
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689970285456172024)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Example 1 (using bind variable): ',
'<pre>',
'SELECT ename d, empno r',
'FROM  emp ',
'WHERE deptno = :my_item ',
'ORDER BY 1',
'</pre>',
'Example 2 (query contains in-line query, must ensure first FROM clause in the SQL statement is not part of the in-line query):',
'<pre>',
'SELECT c1, c2 ',
'  FROM ',
'(SELECT decode(',
'         (SELECT count(*) ',
'            FROM emp2 b ',
'           WHERE a.ename = b.ename), ',
'          1, ''+'' || ename, ename) c1, ',
'         ename c2 ',
'   FROM emp a)</pre>'))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(233330927108902814)
,p_name=>'Usage'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>140
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_new_grid_row=>false
,p_display_column=>1
,p_display_point=>'REGION_POSITION_03'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select i.flow_step_id as page_id,',
'       to_char(i.flow_step_id)||''. ''||substr(i.name,1,15) as page',
'  from wwv_flow_step_items i',
' where i.flow_id           = :FB_FLOW_ID',
'   and i.security_group_id = :WORKSPACE_ID',
'   and exists ( select 1 ',
'                  from wwv_flow_lists_of_values$ l',
'                 where l.security_group_id = :WORKSPACE_ID',
'                   and l.id                = :F4000_P4111_ID',
'                   and l.lov_name          = i.named_lov )',
'    --',
' union',
'select r.page_id,',
'       to_char(r.page_id)||''. ''||substr(r.plug_name,1,15) as page',
'  from wwv_flow_page_plugs           r,',
'       wwv_flow_region_report_column c,',
'       wwv_flow_lists_of_values$     l',
' where r.security_group_id  = c.security_group_id',
'   and c.security_group_id  = l.security_group_id',
'   and l.security_group_id  = :WORKSPACE_ID',
'    -- ',
'   and r.id                 = c.region_id',
'   and l.id                 = c.named_lov',
'    --',
'   and r.flow_id            = to_number( :FB_FLOW_ID )',
'   and l.id                 = to_number( :F4000_P4111_ID )',
'    --',
' union',
'select r.page_id,',
'       to_char(r.page_id)||''. ''||substr(r.plug_name,1,15) as page',
'  from wwv_flow_worksheet_columns c,',
'       wwv_flow_worksheets        w,',
'       wwv_flow_page_plugs        r',
' where r.security_group_id  = c.security_group_id',
'   and c.security_group_id  = w.security_group_id',
'   and w.security_group_id  = :WORKSPACE_ID',
'    --',
'   and w.id                = c.worksheet_id',
'   and r.id                = w.region_id',
'    --',
'   and c.flow_id           = to_number(:FB_FLOW_ID)',
'   and c.rpt_named_lov     = to_number(:F4000_P4111_ID)',
'    --',
' union',
'select r.page_id,',
'       to_char(r.page_id)||''. ''||substr(r.plug_name,1,15) as page',
'  from wwv_flow_page_plugs        r,',
'       wwv_flow_region_columns    c,',
'       wwv_flow_lists_of_values$  l',
' where r.security_group_id  = c.security_group_id',
'   and c.security_group_id  = l.security_group_id',
'   and l.security_group_id  = :WORKSPACE_ID',
'    --',
'   and r.id                 = c.region_id',
'   and (    c.lov_id        = l.id ',
'         or c.filter_lov_id = l.id )',
'    --',
'   and r.flow_id            = to_number( :FB_FLOW_ID )',
'   and r.security_group_id  = to_number( :WORKSPACE_ID )',
'   and l.id                 = to_number( :F4000_P4111_ID )',
' order by page_id, page',
''))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(11667910335347890)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'This List of Values is not used.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(932666743622561017)
,p_query_column_id=>1
,p_column_alias=>'PAGE_ID'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(233331531178902828)
,p_query_column_id=>2
,p_column_alias=>'PAGE'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.:RP,:FB_FLOW_PAGE_ID:#PAGE_ID#'
,p_column_linktext=>'#PAGE#'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(350215855993563251)
,p_plug_name=>'Comments'
,p_region_name=>'COMMENTS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>400
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(615278327394452603)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_imp.id(29434107863295859)
,p_plug_display_sequence=>410
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from  WWV_FLOW_LISTS_OF_VALUES$',
'where id = :F4000_P4111_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :F4000_P4111_ID,',
'      p_component_type => ''List of Values'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(712080000591813402)
,p_plug_name=>'Source: Static Values'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       flow_id,',
'       lov_id,',
'       lov_disp_sequence, ',
'       lov_disp_value, ',
'       lov_template,',
'       lov_return_value, ',
'       decode(lov_disp_cond_type,null,null,''<span class="a-Icon icon-check"></span>'') lov_disp_cond_type,',
'       last_updated_on',
'from   wwv_flow_list_of_values_data',
'where  lov_id = :F4000_P4111_ID',
'  and  flow_id = :FB_FLOW_ID',
'  and  security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IG'
,p_ajax_items_to_submit=>'F4000_P4111_ID'
,p_plug_display_condition_type=>'NOT_EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_lists_of_values$',
' where id                 = to_number(:F4000_P4111_ID)',
'   and location          <> ''STATIC''',
'   and security_group_id  = :flow_security_group_id',
' union',
'select null',
'  from sys.dual',
' where :F4000_P4111_ID is null'))
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(109877556624242514)
,p_name=>'LOV_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LOV_TEMPLATE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Globalization Template'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>130
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_item_height=>6
,p_is_required=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(567418956578994731)
,p_name=>'APEX$ROW_ACTION'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>20
,p_use_as_row_header=>false
,p_display_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(567419076212994732)
,p_name=>'APEX$ROW_SELECTOR'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_use_as_row_header=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(567419448188994736)
,p_name=>'LOV_DISP_COND_TYPE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LOV_DISP_COND_TYPE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Conditional'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>110
,p_value_alignment=>'CENTER'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'HTML'
,p_enable_filter=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_is_primary_key=>false
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(567419657230994738)
,p_name=>'LAST_UPDATED_ON'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LAST_UPDATED_ON'
,p_data_type=>'DATE'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Updated'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>120
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_format_mask=>'SINCE'
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_date_ranges=>'ALL'
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(712080217605813404)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_LINK'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>50
,p_value_alignment=>'LEFT'
,p_link_target=>'f?p=&APP_ID.:4113:&SESSION.::&DEBUG.:RP,:F4000_P4113_ID,P4113_REFERENCE_ID:&ID.,&F4000_P4111_REFERENCE_ID.'
,p_link_text=>'<span class="a-Icon icon-edit" title="&EDIT."></span>'
,p_link_attributes=>'class="a-Button a-Button--noUI"'
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
,p_escape_on_http_output=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(712080320008813405)
,p_name=>'LOV_DISP_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LOV_DISP_SEQUENCE'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>'Sequence'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>80
,p_value_alignment=>'RIGHT'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
,p_is_required=>true
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(712080489276813406)
,p_name=>'LOV_DISP_VALUE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LOV_DISP_VALUE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Display'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>90
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(712080547723813407)
,p_name=>'LOV_RETURN_VALUE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LOV_RETURN_VALUE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Return'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>100
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(714513527369810143)
,p_name=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FLOW_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>60
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'FB_FLOW_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(714513644443810144)
,p_name=>'LOV_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LOV_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>70
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'F4000_P4111_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(712080143327813403)
,p_internal_uid=>712080143327813403
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_add_row_if_empty=>true
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_show_nulls_as=>'-'
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>true
,p_show_toolbar=>true
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>true
,p_define_chart_view=>true
,p_enable_download=>true
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(712386498335634625)
,p_interactive_grid_id=>wwv_flow_imp.id(712080143327813403)
,p_static_id=>'14222'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(712386562133634625)
,p_report_id=>wwv_flow_imp.id(712386498335634625)
,p_view_type=>'GRID'
,p_stretch_columns=>true
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(29482000001)
,p_view_id=>wwv_flow_imp.id(712386562133634625)
,p_display_seq=>0
,p_column_id=>wwv_flow_imp.id(567418956578994731)
,p_is_visible=>true
,p_is_frozen=>true
,p_width=>40
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(97236000001)
,p_view_id=>wwv_flow_imp.id(712386562133634625)
,p_display_seq=>8
,p_column_id=>wwv_flow_imp.id(714513527369810143)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(157385000001)
,p_view_id=>wwv_flow_imp.id(712386562133634625)
,p_display_seq=>9
,p_column_id=>wwv_flow_imp.id(714513644443810144)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(204657000002)
,p_view_id=>wwv_flow_imp.id(712386562133634625)
,p_display_seq=>5
,p_column_id=>wwv_flow_imp.id(567419448188994736)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>93
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(245321000002)
,p_view_id=>wwv_flow_imp.id(712386562133634625)
,p_display_seq=>9
,p_column_id=>wwv_flow_imp.id(567419657230994738)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>123
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(278085000001)
,p_view_id=>wwv_flow_imp.id(712386562133634625)
,p_display_seq=>2
,p_column_id=>wwv_flow_imp.id(712080217605813404)
,p_is_visible=>true
,p_is_frozen=>true
,p_width=>48
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(497241000001)
,p_view_id=>wwv_flow_imp.id(712386562133634625)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(712080320008813405)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>55
,p_sort_order=>1
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(591092000001)
,p_view_id=>wwv_flow_imp.id(712386562133634625)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(712080489276813406)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>311
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(679027000001)
,p_view_id=>wwv_flow_imp.id(712386562133634625)
,p_display_seq=>4
,p_column_id=>wwv_flow_imp.id(712080547723813407)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>181
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(150162090920755449)
,p_view_id=>wwv_flow_imp.id(712386562133634625)
,p_display_seq=>8
,p_column_id=>wwv_flow_imp.id(109877556624242514)
,p_is_visible=>false
,p_is_frozen=>false
,p_width=>400
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(202117306273446159)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(33426411524290175)
,p_button_name=>'PUBLISH_LOV'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Publish LOV'
,p_button_position=>'COPY'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.::F4000_P149_ID,F4000_P149_PAGE_ID,F4000_P149_TEMPLATE_TYPE:&F4000_P4111_ID.,&APP_PAGE_ID.,LOV:'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
' from wwv_flow_lists_of_values$',
'where reference_id      = :F4000_P4111_ID',
'  and security_group_id = :flow_security_group_id'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5730127734070716)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(33426411524290175)
,p_button_name=>'UNSUBSCRIBE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Unsubscribe'
,p_button_position=>'COPY'
,p_button_condition=>':F4000_P4111_REFERENCE_ID is not null and :P4111_SUBSCRIBED_COMP_GRP = ''N'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(202120612291457307)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(33426411524290175)
,p_button_name=>'REFRESH_LOV'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Refresh LOV'
,p_button_position=>'COPY'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P4111_REFERENCE_ID is not null ',
'and ( :F4000_P4111_VERSION_SCN != :F4000_P4111_MASTER_VERSION_SCN or :F4000_P4111_VERSION_SCN is null )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(10345212253298998)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(712080000591813402)
,p_button_name=>'CREATE_STATIC_VALUE'
,p_button_static_id=>'CREATE_STATIC_VALUE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'Create Entry'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:4113:&SESSION.::&DEBUG.:4113::'
,p_button_condition=>'not wwv_flow_page.is_read_only'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(20999087932632629)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1483115269307020)
,p_button_name=>'SELECT_ADDITIONAL_COLUMNS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'Select Columns'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:4082:&SESSION.::&DEBUG.:RP,4082::'
,p_button_condition=>'not wwv_flow_page.is_read_only'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(9496177960275709)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(202306103707329518)
,p_button_name=>'CONVERT_LEGACY_SQL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Convert Legacy SQL'
,p_button_position=>'HELP'
,p_button_condition=>'P4111_SOURCE_TYPE_HIDDEN'
,p_button_condition2=>'LEGACY_SQL'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(290985826)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(397115560)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(63589945603)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_imp.id(397115560)
,p_button_name=>'CREATE_STATIC'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Create Static LOV'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P4111_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(87511229484617914)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_imp.id(397115560)
,p_button_name=>'CONVERT_STATIC'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Convert To Static'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_lists_of_values$ ',
' where id                                  = :F4000_P4111_ID ',
'   and security_group_id                   = :flow_security_group_id',
'   and substr(upper(ltrim(lov_query)),1,6) = ''STATIC'''))
,p_button_condition_type=>'EXISTS'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(398127928)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_imp.id(397115560)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Create LOV from Query'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P4111_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(291985826)
,p_button_sequence=>110
,p_button_plug_id=>wwv_flow_imp.id(397115560)
,p_button_name=>'Delete'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P4111_ID is not null',
'and ( :F4000_P4111_REFERENCE_ID is null or :P4111_SUBSCRIBED_COMP_GRP = ''N'' )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(292985826)
,p_button_sequence=>130
,p_button_plug_id=>wwv_flow_imp.id(397115560)
,p_button_name=>'ApplyChanges'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
' :F4000_P4111_ID is not null ',
' and ( not wwv_flow_lov_dev.is_based_on_graph( :F4000_P4111_ID ) or sys.dbms_db_version.version >= 23 )',
' and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(202121001451457313)
,p_branch_name=>'Go To Page 4111'
,p_branch_action=>'f?p=&APP_ID.:4111:&SESSION.::&DEBUG.:RP,4111:F4000_P4111_ID:&F4000_P4111_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST in (''CONVERT_LEGACY_SQL'',''REFRESH_COLUMN_INFO'',''REFRESH_LOV'')',
'or (:REQUEST = ''ApplyChanges'' and :P4111_RETURN_TO_PAGE = ''YES'')'))
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(294985827)
,p_branch_name=>'Go To Page 4110'
,p_branch_action=>'f?p=&APP_ID.:4110:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow.g_request in (''Create'',''Delete'')'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(295985827)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(296985827)
,p_branch_action=>'4110'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>40
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow.g_request in (''Cancel'')'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(297985833)
,p_name=>'F4000_P4111_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(396113952)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_warn_on_unsaved_changes=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(299985834)
,p_name=>'F4000_P4111_LOV_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(396113952)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>'LOV_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(300985834)
,p_name=>'P4111_LOV_QUERY_HIDDEN'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(202306103707329518)
,p_use_cache_before_default=>'NO'
,p_source=>'LOV_QUERY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_warn_on_unsaved_changes=>'I'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1417897061012516)
,p_name=>'P4111_SUBSCRIBED_COMP_GRP'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(33426411524290175)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1481401320307003)
,p_name=>'P4111_SOURCE_POST_PROC_TYPE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(20215619883919135)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Post Processing Type'
,p_source=>'SOURCE_POST_PROCESSING'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'EXEC_WEB_SOURCE_POST_PROCESSING'
,p_lov=>'.'||wwv_flow_imp.id(601113045750817318)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select how to post process the retrieved REST source data in the local database.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1481681766307005)
,p_name=>'P4111_SOURCE_POST_PROC_WHERE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(20215619883919135)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Post Processing Where Clause'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (coalesce(:P4111_LOCATION,''LOCAL'') = ''WEB_SOURCE'' and',
'    :P4111_SOURCE_POST_PROC_TYPE = ''WHERE_ORDER_BY_CLAUSE'' ) ',
'then ',
'    return :P4111_WHERE_CLAUSE_HIDDEN;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a valid SQL where condition, used to limit the records retrieved.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1481905921307008)
,p_name=>'P4111_SOURCE_POST_PROC_SQL'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(20215619883919135)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Post Processing SQL Query'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (coalesce(:P4111_LOCATION,''LOCAL'') = ''WEB_SOURCE'' and',
'    :P4111_SOURCE_POST_PROC_TYPE = ''SQL'' ) ',
'then ',
'    return :P4111_LOV_QUERY_HIDDEN;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>6
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a SQL Query to transform the data retrieved from the REST Data Source. Select from the pseudo-table #APEX$SOURCE_DATA# and specify columns available in the data profile. Subquery factoring using the SQL WITH clause is not supported here.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1482059431307009)
,p_name=>'P4111_SRC_POST_PROC_FUNC_BODY'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(20215619883919135)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Post Processing Function Body returning SQL Query'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (coalesce(:P4111_LOCATION,''LOCAL'') = ''WEB_SOURCE'' and',
'    :P4111_SOURCE_POST_PROC_TYPE = ''FUNC_BODY_RETURNING_SQL'' ) ',
'then ',
'    return :P4111_LOV_QUERY_HIDDEN;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>6
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a Function Body, where the SQL query returned transforms the data retrieved from the REST Source. The SQL query returned by the Function Body must select from the #APEX$SOURCE_DATA# pseudo-table and read columns available in the data profile. S'
||'ubquery factoring using the SQL WITH clause is not supported here.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PAGE_ITEM'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_06=>'P4111_SRC_POST_PROC_FUNC_LANG'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1483438977307023)
,p_name=>'P4111_ADDITIONAL_COL_COUNT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1483115269307020)
,p_display_as=>'NATIVE_HIDDEN'
,p_warn_on_unsaved_changes=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1484196749307030)
,p_name=>'P4111_LOCAL_WHERE'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(73945327537305242)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Where Clause'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if coalesce(:P4111_LOCATION,''LOCAL'') = ''LOCAL'' and :P4111_SOURCE_TYPE_HIDDEN = ''TABLE'' then ',
'    return :P4111_WHERE_CLAUSE_HIDDEN;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>4
,p_display_when=>'P4111_SOURCE_TYPE_HIDDEN'
,p_display_when2=>'LEGACY_SQL'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a valid SQL where condition, used to limit the records retrieved.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1484201460307031)
,p_name=>'P4111_WHERE_CLAUSE_HIDDEN'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(202306103707329518)
,p_use_cache_before_default=>'NO'
,p_source=>'QUERY_WHERE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_warn_on_unsaved_changes=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1484388646307032)
,p_name=>'P4111_REMOTE_WHERE'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(75743329779916863)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Where Clause'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if coalesce(:P4111_LOCATION,''LOCAL'') = ''REMOTE'' and :P4111_SOURCE_TYPE_HIDDEN = ''TABLE'' then ',
'    return :P4111_WHERE_CLAUSE_HIDDEN;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>4
,p_display_when=>'P4111_SOURCE_TYPE_HIDDEN'
,p_display_when2=>'LEGACY_SQL'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a valid SQL where condition, used to limit the records retrieved.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1484575580307034)
,p_name=>'P4111_GROUP_SORT_DIRECTION'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(20215412492919133)
,p_use_cache_before_default=>'NO'
,p_item_default=>'ASC'
,p_prompt=>'Group Sort Direction'
,p_source=>'GROUP_SORT_DIRECTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'SORT_DIRECTIONS'
,p_lov=>'.'||wwv_flow_imp.id(601135878417900624)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Define the sort direction for the group column.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1502673776993117)
,p_name=>'P4111_PARSING_SCHEMA'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(202306103707329518)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select owner',
'  from wwv_flows',
' where id                = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1503825536956068)
,p_name=>'P4111_RETURN_TO_PAGE'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(395110922)
,p_prompt=>'Stay on page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select this checkbox to stay on this page after applying changes.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'YES'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1511439672159230)
,p_name=>'P4111_COMMENTS'
,p_item_sequence=>340
,p_item_plug_id=>wwv_flow_imp.id(350215855993563251)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comments'
,p_source=>'LOV_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'<p>Enter any comments or notes here.  These comments will never be displayed when running the application.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1533704350420614)
,p_name=>'P4111_WEB_SRC_ARRAY_COL_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(73951063066307275)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Array Column'
,p_source=>'WEB_SRC_ARRAY_COL_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select dpc.array_column_path,',
'       dpc.id',
'  from wwv_flow_web_src_arr_cols_dev dpc',
' where dpc.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and dpc.flow_id           = :FB_FLOW_ID',
'   and dpc.web_src_module_id = :P4111_WEB_SRC_MODULE_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'None'
,p_cHeight=>1
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Denotes the Array Column, within the <em>Data Profile</em> of the REST Data Source, to be used for this List of Values.',
''))
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1534285942420619)
,p_name=>'P4111_OLD_USE_LOCAL_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(20215619883919135)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1568830406713219)
,p_name=>'P4111_LOV_QUERY_FUNC_LANG'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(73945327537305242)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Language'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if coalesce(:P4111_LOCATION,''LOCAL'') = ''LOCAL'' and :P4111_SOURCE_TYPE_HIDDEN = ''FUNC_BODY_RETURNING_SQL'' then ',
'   return :P4111_FUNC_BODY_LANG_HIDDEN;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_display_when=>'P4111_SOURCE_TYPE_HIDDEN'
,p_display_when2=>'LEGACY_SQL'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1663011480963714)
,p_name=>'P4111_USE_LOCAL_TABLE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(20215619883919135)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Use Synchronization Table'
,p_source=>'USE_LOCAL_SYNC_TABLE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_web_src_sync.sync_exists_for_array_column(',
'    p_web_source_module_id  => :P4111_WEB_SRC_MODULE_ID,',
'    p_array_column_id       => :P4111_WEB_SRC_ARRAY_COL_ID ) = ''Y'''))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enable this to use the local table, which is configured within the <strong>REST Synchronization</strong> section of the REST Data Source, instead of reaching out to the external REST service.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1664599372059324)
,p_name=>'P4111_PQL_MATCH_CLAUSE'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(73945327537305242)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Match Clause'
,p_source=>'QUERY_MATCH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cHeight=>3
,p_display_when=>'P4111_SOURCE_TYPE_HIDDEN'
,p_display_when2=>'LEGACY_SQL'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a path pattern to find on the property graph. In order to find all edges in your graph, use the following: <strong>(a) - [e] -> (b)</strong>. In addition to this, use <em>label constraints</em> to restrict the types of vertices or edges of i'
||'nterest.</p>',
'<p><strong>Examples</strong></p>',
'<dl>',
'<dt>Find all persons who bought cars.</dt><dd><pre>(p is person) - [t is buys] -> (c is car)</pre></dd>',
'<dt>Find all employees working in departments.</dt><dd><pre>(e is employees) - [is works_at] -> (d is departments)</pre></dd>',
'<dt>Find all employees working in departments who bought cars.</dt><dd><pre>(e is employees) - [is works_at] -> (d is departments), (e is employees) - [t is buys] -> (c is car)</pre></dd>',
'</dl>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1664649423059325)
,p_name=>'P4111_PQL_COLUMNS_CLAUSE'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(73945327537305242)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Columns Clause'
,p_source=>'QUERY_COLUMNS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cHeight=>3
,p_display_when=>'P4111_SOURCE_TYPE_HIDDEN'
,p_display_when2=>'LEGACY_SQL'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Define the query return columns. Those are properties of vertices or edges or expressions using them.</p>',
'<p><strong>Example</strong></p>',
'<dl>',
'<dt>Return <strong>NAME</strong>, <strong>BRAND</strong> and <strong>TOTAL_COST</strong> columns, the latter is the <strong>COST</strong> column, multiplied by 100.</dt>',
'<dd><pre>p.name, c.brand, t.cost * 100 as total_cost</pre></dd>',
'</dl>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1664785927059326)
,p_name=>'P4111_PQL_WHERE_CLAUSE'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(73945327537305242)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if coalesce(:P4111_LOCATION,''LOCAL'') = ''LOCAL'' and :P4111_SOURCE_TYPE_HIDDEN = ''GRAPH'' then ',
'    return :P4111_WHERE_CLAUSE_HIDDEN;',
'end if;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Where Clause'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cHeight=>3
,p_display_when=>'P4111_SOURCE_TYPE_HIDDEN'
,p_display_when2=>'LEGACY_SQL'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter an optional WHERE clause to restrict the returned rows. Columns must use a vertex or edge alias.</p>',
'<p><strong>Example</strong></p>',
'<dl>',
'<dt>Only include those employees which have a manager or have a job of salesman.</dt>',
'<dd><pre>( e.mgr is not null or e.job = ''SALESMAN'' )</pre></dd>',
'</dl>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1664819367059327)
,p_name=>'P4111_GRAPH_NAME'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(73945327537305242)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Graph Name'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if coalesce(:P4111_LOCATION,''LOCAL'') = ''LOCAL'' and :P4111_SOURCE_TYPE = ''GRAPH'' then ',
'    return :P4111_QUERY_TABLE_HIDDEN;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select g.graph_name d, ',
'       g.graph_name r',
'  from sys.dba_property_graphs        g,',
'       wwv_flow_object_owners_dev o',
' where o.owner = g.owner',
'   and g.owner = :P4111_QUERY_OWNER'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_lov_cascade_parent_items=>'P4111_QUERY_OWNER'
,p_ajax_items_to_submit=>'P4111_SOURCE_TYPE'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_display_when=>'sys.dbms_db_version.version >= 23 and :P4111_SOURCE_TYPE_HIDDEN != ''LEGACY_SQL'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Pick the Property Graph name from the list.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'Y'
,p_attribute_06=>'0'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1672964397329624)
,p_name=>'P4111_SRC_POST_PROC_FUNC_LANG'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(20215619883919135)
,p_prompt=>'Language'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (coalesce(:P4111_LOCATION,''LOCAL'') = ''WEB_SOURCE'' and',
'    :P4111_SOURCE_POST_PROC_TYPE = ''FUNC_BODY_RETURNING_SQL'' ) ',
'then ',
'    return :P4111_FUNC_BODY_LANG_HIDDEN;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2320180550209547)
,p_name=>'P4111_FUNC_BODY_LANG_HIDDEN'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(202306103707329518)
,p_use_cache_before_default=>'NO'
,p_source=>'FUNCTION_BODY_LANGUAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_warn_on_unsaved_changes=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4439479327967228)
,p_name=>'P4111_LOV_QUERY_FUNC_BODY'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(73945327537305242)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Function Body Returning SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if coalesce(:P4111_LOCATION,''LOCAL'') = ''LOCAL'' and :P4111_SOURCE_TYPE_HIDDEN = ''FUNC_BODY_RETURNING_SQL'' then ',
'   return :P4111_LOV_QUERY_HIDDEN;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>8000
,p_cHeight=>15
,p_display_when=>'P4111_SOURCE_TYPE_HIDDEN'
,p_display_when2=>'LEGACY_SQL'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'A list of values SQL Query in the format:',
'<pre>',
'select [displayValue], [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
'',
'For example:',
'<pre>',
'select ename, empno ',
'  from emp ',
' where deptno = :my_item ',
' order by 1',
'</pre>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PAGE_ITEM'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_06=>'P4111_LOV_QUERY_FUNC_LANG'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5729502643070710)
,p_name=>'F4000_P4111_VERSION_SCN'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(33426411524290175)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select version_scn ',
'  from wwv_flow_lists_of_values$',
' where id                = :F4000_P4111_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5729637743070711)
,p_name=>'F4000_P4111_MASTER_VERSION_SCN'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(33426411524290175)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select version_scn ',
'  from wwv_flow_lists_of_values$',
' where id                = :F4000_P4111_REFERENCE_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6001230377547808)
,p_name=>'P4111_DEL_COL_COUNT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1483115269307020)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9446885770950044)
,p_name=>'P4111_LOCATION'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(202306103707329518)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Data Source'
,p_source=>'LOCATION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'EXEC_LOCATION'
,p_lov=>'.'||wwv_flow_imp.id(3842073961668883)||'.'
,p_display_when=>'P4111_SOURCE_TYPE_HIDDEN'
,p_display_when2=>'LEGACY_SQL'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9474354598187800)
,p_name=>'P4111_SOURCE_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(73945327537305242)
,p_use_cache_before_default=>'NO'
,p_item_default=>'TABLE'
,p_prompt=>'Source Type'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if coalesce(:P4111_LOCATION,''LOCAL'') = ''LOCAL'' then ',
'    return :P4111_SOURCE_TYPE_HIDDEN;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXEC_SQL_DATA_SOURCE_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(601107956819795211)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_display_when=>'P4111_SOURCE_TYPE_HIDDEN'
,p_display_when2=>'LEGACY_SQL'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'List of Values using a Data Source of Local Database ',
'can be based on a Table, SQL Query, PL/SQL Function Returning SQL, or (on Oracle Database 23ai and later) on a Property Graph.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9475606571187803)
,p_name=>'P4111_QUERY_OWNER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(73945327537305242)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Table / View Owner'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if coalesce(:P4111_LOCATION,''LOCAL'') = ''LOCAL'' then',
'    return coalesce(:P4111_QUERY_OWNER_HIDDEN, wwv_flow_security.flow_owner(',
'        p_flow_id           => :FB_FLOW_ID,',
'        p_security_group_id => wwv_flow_security.g_security_group_id ));',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_SCHEMAS_HAVE_PRIVS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(owner) d, owner v',
'  from wwv_flow_object_owners_dev',
'order by d                   '))
,p_cHeight=>1
,p_display_when=>'P4111_SOURCE_TYPE_HIDDEN'
,p_display_when2=>'LEGACY_SQL'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the owner of the table on which you are building a report.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9476514751187804)
,p_name=>'P4111_QUERY_TABLE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(73945327537305242)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Table / View Name'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if coalesce(:P4111_LOCATION,''LOCAL'') = ''LOCAL'' and :P4111_SOURCE_TYPE = ''TABLE'' then ',
'    return :P4111_QUERY_TABLE_HIDDEN;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = :P4111_QUERY_OWNER',
'   and :P4111_SOURCE_TYPE = ''TABLE'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Value -'
,p_lov_cascade_parent_items=>'P4111_QUERY_OWNER'
,p_ajax_items_to_submit=>'P4111_SOURCE_TYPE'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_display_when=>'P4111_SOURCE_TYPE_HIDDEN'
,p_display_when2=>'LEGACY_SQL'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select the table or view on which the form will be based.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'Y'
,p_attribute_06=>'0'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9479941132189824)
,p_name=>'P4111_WEB_SRC_MODULE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(73951063066307275)
,p_use_cache_before_default=>'NO'
,p_prompt=>'REST Data Source'
,p_source=>'WEB_SRC_MODULE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APP_WEB_SOURCES_FOR_REPORTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_flow_web_src_modules m',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and exists ( select 1 ',
'                  from wwv_flow_web_src_operations',
'                 where web_src_module_id = m.id',
'                   and database_operation = ''FETCH_COLLECTION'' )',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9481590790191485)
,p_name=>'P4111_REMOTE_SERVER_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(75743329779916863)
,p_use_cache_before_default=>'NO'
,p_prompt=>'REST Enabled SQL Service'
,p_source=>'REMOTE_SERVER_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REMOTE_SQL_SERVERS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_remote_servers',
' where server_type = ''REMOTE_SQL''',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9481940949191488)
,p_name=>'P4111_REMOTE_SOURCE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(75743329779916863)
,p_use_cache_before_default=>'NO'
,p_item_default=>'TABLE'
,p_prompt=>'Source Type'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P4111_LOCATION = ''REMOTE'' then ',
'    return :P4111_SOURCE_TYPE_HIDDEN;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXEC_REMOTE_SQL_DATA_SOURCE_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(1766286067212864)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Specify the source of the new page. List of Values can be based on tables or SQL queries. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9482874028191489)
,p_name=>'P4111_REMOTE_SQL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(75743329779916863)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Enter a SQL SELECT statement'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P4111_LOCATION = ''REMOTE'' then ',
'    return :P4111_LOV_QUERY_HIDDEN;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>8
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the SQL query that will produce the results for your List of Values, for example:',
'<pre>',
'select ename, job, sal',
'from  emp',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_05=>'P4111_REMOTE_SERVER_ID'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9483702025191489)
,p_name=>'P4111_REMOTE_TABLE_OWNER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(75743329779916863)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Table / View Owner'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P4111_LOCATION = ''REMOTE'' then ',
'    return :P4111_QUERY_OWNER_HIDDEN;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value d, column_value r',
'  from table( wwv_flow_remote_server_dev.get_available_objects( :P4111_REMOTE_SERVER_ID, ''SCHEMAS''))',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Current Schema'
,p_lov_cascade_parent_items=>'P4111_REMOTE_SERVER_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select the owner of the table on which you are building the List of Values.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9484614427191490)
,p_name=>'P4111_REMOTE_TABLE_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(75743329779916863)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Table / View Name'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P4111_LOCATION = ''REMOTE'' then ',
'    return :P4111_QUERY_TABLE_HIDDEN;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value d, column_value r',
'  from table( wwv_flow_remote_server_dev.get_available_objects( :P4111_REMOTE_SERVER_ID, ''TABLE'', :P4111_REMOTE_TABLE_OWNER ))',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table or View -'
,p_lov_cascade_parent_items=>'P4111_REMOTE_TABLE_OWNER'
,p_ajax_items_to_submit=>'P4111_REMOTE_SERVER_ID'
,p_ajax_optimize_refresh=>'N'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select the owner of the table on which you are building a List of Values.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9496533107275713)
,p_name=>'P4111_LOV_QUERY_SQL'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(73945327537305242)
,p_use_cache_before_default=>'NO'
,p_prompt=>'SQL Query'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if coalesce(:P4111_LOCATION,''LOCAL'') = ''LOCAL'' and :P4111_SOURCE_TYPE_HIDDEN in (''SQL'',''LEGACY_SQL'') then ',
'    return :P4111_LOV_QUERY_HIDDEN;',
'end if;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>8000
,p_cHeight=>15
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'A list of values SQL Query in the format:',
'<pre>',
'select [displayValue], [returnValue]',
'  from ...',
' where ...',
' order by ...',
'</pre>',
'',
'For example:',
'<pre>',
'select ename, empno ',
'  from emp ',
' where deptno = :my_item ',
' order by 1',
'</pre>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11091909535588008)
,p_name=>'F4000_P4111_REFERENCE_ID_INIT'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(33426411524290175)
,p_item_default=>'F4000_P4111_REFERENCE_ID'
,p_item_default_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11466741156432841)
,p_name=>'P4111_EXTERNAL_FILTER_EXPR'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(20215619883919135)
,p_use_cache_before_default=>'NO'
,p_prompt=>'External Filter'
,p_source=>'EXTERNAL_FILTER_EXPR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Provide a filter expression to be passed to the external REST service. The expression will be passed to the remote server as-is. The syntax depends on the type of the REST Data Source. For instance, Oracle REST Data Services (ORDS) expects JSON synta'
||'x.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11466887559432842)
,p_name=>'P4111_EXTERNAL_ORDER_BY_EXPR'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(20215619883919135)
,p_use_cache_before_default=>'NO'
,p_prompt=>'External Order By'
,p_source=>'EXTERNAL_ORDER_BY_EXPR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Provide an order by expression to be passed to the external REST service. The expression will be passed to the remote server as-is. The syntax depends on the type of the REST Data Source. For instance, Oracle REST Data Services (ORDS) expects JSON sy'
||'ntax.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11466961272432843)
,p_name=>'P4111_REMOTE_SQL_CACHING'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(20212831971919107)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Caching'
,p_source=>'REMOTE_SQL_CACHING'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CACHING_MODE'
,p_lov=>'.'||wwv_flow_imp.id(225840272947805161)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Disabled'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select how the &PRODUCT_NAME. engine can cache data in the local database. If caching can be used, the List of Values will be rendered based on cached results, instead of fetching from the remote database. Cached results will greatly improve performa'
||'nce, especially if there is latency between the local and remote database.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11467018910432844)
,p_name=>'P4111_REMOTE_SQL_INVALIDATE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(20212831971919107)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Cache Timeout'
,p_source=>'REMOTE_SQL_INVALIDATE_WHEN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>255
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter when cached data is to be invalidated. Provide either the amount of minutes or a DBMS_SCHEDULER Calendar String.',
'For DBMS_SCHEDULER Calendar String, you can define that cached data is invalidated at the top of the hour, at midnight, or another specific recurring point in time. See the documentation on DBMS_SCHEDULER.EVALUATE_CALENDAR_STRING for more details.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11467490901432848)
,p_name=>'P4111_OPTIMIZER_HINT'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(73945327537305242)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Optimizer Hint'
,p_source=>'OPTIMIZER_HINT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>255
,p_display_when=>'P4111_SOURCE_TYPE_HIDDEN'
,p_display_when2=>'LEGACY_SQL'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the Oracle Optimizer hint which is added to the top-level statement when executing the SQL query. A hint is an instruction to the Optimizer. When writing SQL, you may know information about the data unknown to the Optimizer. Hints enable you'
||' to make decisions normally made by the Optimizer, sometimes causing the Optimizer to select a plan that it sees as higher cost.</p>',
'',
'<p>For example, you might know that a certain index is more selective for certain queries. Based on this information, you might be able to choose a more efficient execution plan than the Optimizer. In such a case, use hints to force the Optimizer to '
||'use the optimal execution plan.</p>',
'',
'<p>Example:</p>',
'<p>When accessing the table <code>employees</code>, try to use the index <code>emp_department_ix</code>:</p>',
'<pre>INDEX (employees emp_department_ix)</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(19531770866272706)
,p_name=>'P4111_AUTH_TEST'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(75743329779916863)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return case ',
'    when wwv_flow_exec_remote.test_authentication( :P4111_REMOTE_SERVER_ID ) is null then ',
'        ''COMM_FAILURE''',
'    when not wwv_flow_exec_remote.test_authentication( :P4111_REMOTE_SERVER_ID ) then',
'        ''AUTH_FAILURE''',
'    when wwv_flow_exec_remote.test_authentication( :P4111_REMOTE_SERVER_ID ) then',
'        ''AUTH_PASSED''',
'    end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_display_when=>'P4111_LOCATION'
,p_display_when2=>'REMOTE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20214151972919120)
,p_name=>'P4111_RETURN_COLUMN'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(20215412492919133)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Return'
,p_source=>'RETURN_COLUMN_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name d, ',
'       column_name r',
'  from table( wwv_flow_exec_dev.get_query_columns(',
'                  p_location                 => :P4111_LOCATION,',
'                  p_query_type               => case :P4111_LOCATION ',
'                                                    when ''LOCAL''  then :P4111_SOURCE_TYPE',
'                                                    when ''REMOTE'' then :P4111_REMOTE_SOURCE_TYPE',
'                                                end,',
'                  p_owner                    => case :P4111_LOCATION ',
'                                                    when ''LOCAL''  then :P4111_QUERY_OWNER',
'                                                    when ''REMOTE'' then :P4111_REMOTE_TABLE_OWNER',
'                                                end,       ',
'                  p_table_name               => case :P4111_LOCATION ',
'                                                    when ''LOCAL''  then case :P4111_SOURCE_TYPE ',
'                                                                           when ''TABLE'' then :P4111_QUERY_TABLE',
'                                                                           when ''GRAPH'' then :P4111_GRAPH_NAME',
'                                                                       end',
'                                                    when ''REMOTE'' then :P4111_REMOTE_TABLE_NAME',
'                                                end,',
'                  p_sql_query                => case :P4111_LOCATION ',
'                                                    when ''LOCAL''      then :P4111_LOV_QUERY_SQL',
'                                                    when ''REMOTE''     then :P4111_REMOTE_SQL',
'                                                    when ''WEB_SOURCE'' then :P4111_SOURCE_POST_PROC_SQL',
'                                                end,             ',
'                  p_function_body            => case :P4111_LOCATION',
'                                                    when ''LOCAL''      then :P4111_LOV_QUERY_FUNC_BODY',
'                                                    when ''WEB_SOURCE'' then :P4111_SRC_POST_PROC_FUNC_BODY',
'                                                end,',
'                  p_function_body_language   => case :P4111_LOCATION',
'                                                    when ''LOCAL''      then :P4111_LOV_QUERY_FUNC_LANG',
'                                                    when ''WEB_SOURCE'' then :P4111_SRC_POST_PROC_FUNC_LANG',
'                                                end,',
'                  p_match_clause             => :P4111_PQL_MATCH_CLAUSE,',
'                  p_columns_clause           => :P4111_PQL_COLUMNS_CLAUSE,',
'                  p_remote_server_id         => to_number(:P4111_REMOTE_SERVER_ID),',
'                  p_web_src_module_id        => to_number(:P4111_WEB_SRC_MODULE_ID),',
'                  p_web_src_array_column_id  => to_number(:P4111_WEB_SRC_ARRAY_COL_ID),',
'                  p_where_clause             => case :P4111_LOCATION ',
'                                                    when ''LOCAL'' then :P4111_LOCAL_WHERE ',
'                                                    when ''REMOTE'' then :P4111_REMOTE_WHERE',
'                                                    when ''WEB_SOURCE'' then :P4111_SOURCE_POST_PROC_WHERE',
'                                                end,',
'                  p_post_processing_type     => :P4111_SOURCE_POST_PROC_TYPE',
'        ) )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_lov_cascade_parent_items=>'P1_DUMMY'
,p_ajax_items_to_submit=>'P4111_LOCATION, P4111_QUERY_TABLE, P4111_REMOTE_TABLE_NAME, P4111_SOURCE_TYPE, P4111_REMOTE_SOURCE_TYPE, P4111_QUERY_OWNER, P4111_REMOTE_TABLE_OWNER, P4111_LOV_QUERY_SQL, P4111_REMOTE_SQL, P4111_LOV_QUERY_FUNC_LANG, P4111_LOV_QUERY_FUNC_BODY, P4111_R'
||'EMOTE_SERVER_ID, P4111_WEB_SRC_MODULE_ID, P4111_SOURCE_POST_PROC_SQL, P4111_SRC_POST_PROC_FUNC_LANG, P4111_SRC_POST_PROC_FUNC_BODY, P4111_LOCAL_WHERE, P4111_REMOTE_WHERE, P4111_SOURCE_POST_PROC_WHERE, P4111_SOURCE_POST_PROC_TYPE,P4111_GRAPH_NAME,P411'
||'1_PQL_MATCH_CLAUSE,P4111_PQL_COLUMNS_CLAUSE,P4111_WEB_SRC_ARRAY_COL_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Define the column that will be used as the return value for your List of Values.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20216380459919142)
,p_name=>'P4111_DISPLAY_COLUMN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(20215412492919133)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Display'
,p_source=>'DISPLAY_COLUMN_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name d, ',
'       column_name r',
'  from table( wwv_flow_exec_dev.get_query_columns(',
'                  p_location                 => :P4111_LOCATION,',
'                  p_query_type               => case :P4111_LOCATION ',
'                                                    when ''LOCAL''  then :P4111_SOURCE_TYPE',
'                                                    when ''REMOTE'' then :P4111_REMOTE_SOURCE_TYPE',
'                                                end,',
'                  p_owner                    => case :P4111_LOCATION ',
'                                                    when ''LOCAL''  then :P4111_QUERY_OWNER',
'                                                    when ''REMOTE'' then :P4111_REMOTE_TABLE_OWNER',
'                                                end,       ',
'                  p_table_name               => case :P4111_LOCATION ',
'                                                    when ''LOCAL''  then case :P4111_SOURCE_TYPE ',
'                                                                           when ''TABLE'' then :P4111_QUERY_TABLE',
'                                                                           when ''GRAPH'' then :P4111_GRAPH_NAME',
'                                                                       end',
'                                                    when ''REMOTE'' then :P4111_REMOTE_TABLE_NAME',
'                                                end,',
'                  p_sql_query                => case :P4111_LOCATION ',
'                                                    when ''LOCAL''      then :P4111_LOV_QUERY_SQL',
'                                                    when ''REMOTE''     then :P4111_REMOTE_SQL',
'                                                    when ''WEB_SOURCE'' then :P4111_SOURCE_POST_PROC_SQL',
'                                                end,             ',
'                  p_function_body            => case :P4111_LOCATION',
'                                                    when ''LOCAL''      then :P4111_LOV_QUERY_FUNC_BODY',
'                                                    when ''WEB_SOURCE'' then :P4111_SRC_POST_PROC_FUNC_BODY',
'                                                end,',
'                  p_function_body_language   => case :P4111_LOCATION',
'                                                    when ''LOCAL''      then :P4111_LOV_QUERY_FUNC_LANG',
'                                                    when ''WEB_SOURCE'' then :P4111_SRC_POST_PROC_FUNC_LANG',
'                                                end,',
'                  p_match_clause             => :P4111_PQL_MATCH_CLAUSE,',
'                  p_columns_clause           => :P4111_PQL_COLUMNS_CLAUSE,',
'                  p_remote_server_id         => to_number(:P4111_REMOTE_SERVER_ID),',
'                  p_web_src_module_id        => to_number(:P4111_WEB_SRC_MODULE_ID),',
'                  p_web_src_array_column_id  => to_number(:P4111_WEB_SRC_ARRAY_COL_ID),',
'                  p_where_clause             => case :P4111_LOCATION ',
'                                                    when ''LOCAL'' then :P4111_LOCAL_WHERE ',
'                                                    when ''REMOTE'' then :P4111_REMOTE_WHERE',
'                                                    when ''WEB_SOURCE'' then :P4111_SOURCE_POST_PROC_WHERE',
'                                                end,',
'                  p_post_processing_type     => :P4111_SOURCE_POST_PROC_TYPE',
'        ) )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_lov_cascade_parent_items=>'P1_DUMMY'
,p_ajax_items_to_submit=>'P4111_LOCATION, P4111_QUERY_TABLE, P4111_REMOTE_TABLE_NAME, P4111_SOURCE_TYPE, P4111_REMOTE_SOURCE_TYPE, P4111_QUERY_OWNER, P4111_REMOTE_TABLE_OWNER, P4111_LOV_QUERY_SQL, P4111_REMOTE_SQL, P4111_LOV_QUERY_FUNC_LANG, P4111_LOV_QUERY_FUNC_BODY, P4111_R'
||'EMOTE_SERVER_ID, P4111_WEB_SRC_MODULE_ID, P4111_SOURCE_POST_PROC_SQL, P4111_SRC_POST_PROC_FUNC_LANG, P4111_SRC_POST_PROC_FUNC_BODY, P4111_LOCAL_WHERE, P4111_REMOTE_WHERE, P4111_SOURCE_POST_PROC_WHERE, P4111_SOURCE_POST_PROC_TYPE,P4111_GRAPH_NAME,P411'
||'1_PQL_MATCH_CLAUSE,P4111_PQL_COLUMNS_CLAUSE,P4111_WEB_SRC_ARRAY_COL_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Define the column that will be used as the display value for your List of Values.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20216431316919143)
,p_name=>'P4111_GROUP_COLUMN'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(20215412492919133)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Group'
,p_source=>'GROUP_COLUMN_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name d, ',
'       column_name r',
'  from table( wwv_flow_exec_dev.get_query_columns(',
'                  p_location                 => :P4111_LOCATION,',
'                  p_query_type               => case :P4111_LOCATION ',
'                                                    when ''LOCAL''  then :P4111_SOURCE_TYPE',
'                                                    when ''REMOTE'' then :P4111_REMOTE_SOURCE_TYPE',
'                                                end,',
'                  p_owner                    => case :P4111_LOCATION ',
'                                                    when ''LOCAL''  then :P4111_QUERY_OWNER',
'                                                    when ''REMOTE'' then :P4111_REMOTE_TABLE_OWNER',
'                                                end,       ',
'                  p_table_name               => case :P4111_LOCATION ',
'                                                    when ''LOCAL''  then case :P4111_SOURCE_TYPE ',
'                                                                           when ''TABLE'' then :P4111_QUERY_TABLE',
'                                                                           when ''GRAPH'' then :P4111_GRAPH_NAME',
'                                                                       end',
'                                                    when ''REMOTE'' then :P4111_REMOTE_TABLE_NAME',
'                                                end,',
'                  p_sql_query                => case :P4111_LOCATION ',
'                                                    when ''LOCAL''      then :P4111_LOV_QUERY_SQL',
'                                                    when ''REMOTE''     then :P4111_REMOTE_SQL',
'                                                    when ''WEB_SOURCE'' then :P4111_SOURCE_POST_PROC_SQL',
'                                                end,             ',
'                  p_function_body            => case :P4111_LOCATION',
'                                                    when ''LOCAL''      then :P4111_LOV_QUERY_FUNC_BODY',
'                                                    when ''WEB_SOURCE'' then :P4111_SRC_POST_PROC_FUNC_BODY',
'                                                end,',
'                  p_function_body_language   => case :P4111_LOCATION',
'                                                    when ''LOCAL''      then :P4111_LOV_QUERY_FUNC_LANG',
'                                                    when ''WEB_SOURCE'' then :P4111_SRC_POST_PROC_FUNC_LANG',
'                                                end,',
'                  p_match_clause             => :P4111_PQL_MATCH_CLAUSE,',
'                  p_columns_clause           => :P4111_PQL_COLUMNS_CLAUSE,',
'                  p_remote_server_id         => to_number(:P4111_REMOTE_SERVER_ID),',
'                  p_web_src_module_id        => to_number(:P4111_WEB_SRC_MODULE_ID),',
'                  p_web_src_array_column_id  => to_number(:P4111_WEB_SRC_ARRAY_COL_ID),',
'                  p_where_clause             => case :P4111_LOCATION ',
'                                                    when ''LOCAL'' then :P4111_LOCAL_WHERE ',
'                                                    when ''REMOTE'' then :P4111_REMOTE_WHERE',
'                                                    when ''WEB_SOURCE'' then :P4111_SOURCE_POST_PROC_WHERE',
'                                                end,',
'                  p_post_processing_type     => :P4111_SOURCE_POST_PROC_TYPE',
'        ) )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Not Defined -'
,p_lov_cascade_parent_items=>'P1_DUMMY'
,p_ajax_items_to_submit=>'P4111_LOCATION, P4111_QUERY_TABLE, P4111_REMOTE_TABLE_NAME, P4111_SOURCE_TYPE, P4111_REMOTE_SOURCE_TYPE, P4111_QUERY_OWNER, P4111_REMOTE_TABLE_OWNER, P4111_LOV_QUERY_SQL, P4111_REMOTE_SQL, P4111_LOV_QUERY_FUNC_LANG, P4111_LOV_QUERY_FUNC_BODY, P4111_R'
||'EMOTE_SERVER_ID, P4111_WEB_SRC_MODULE_ID, P4111_SOURCE_POST_PROC_SQL, P4111_SRC_POST_PROC_FUNC_LANG, P4111_SRC_POST_PROC_FUNC_BODY, P4111_LOCAL_WHERE, P4111_REMOTE_WHERE, P4111_SOURCE_POST_PROC_WHERE, P4111_SOURCE_POST_PROC_TYPE,P4111_GRAPH_NAME,P411'
||'1_PQL_MATCH_CLAUSE,P4111_PQL_COLUMNS_CLAUSE,P4111_WEB_SRC_ARRAY_COL_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Define the column that will be used as the group value for your List of Values. If the item type supports it, information will be grouped by this value.</p>',
'<p>Note: Currently in APEX the supported native item types are Popup LOV with multiple columns displayed, and Select List.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20216595069919144)
,p_name=>'P4111_ICON_COLUMN'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(20215412492919133)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Icon'
,p_source=>'ICON_COLUMN_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name d, ',
'       column_name r',
'  from table( wwv_flow_exec_dev.get_query_columns(',
'                  p_location                 => :P4111_LOCATION,',
'                  p_query_type               => case :P4111_LOCATION ',
'                                                    when ''LOCAL''  then :P4111_SOURCE_TYPE',
'                                                    when ''REMOTE'' then :P4111_REMOTE_SOURCE_TYPE',
'                                                end,',
'                  p_owner                    => case :P4111_LOCATION ',
'                                                    when ''LOCAL''  then :P4111_QUERY_OWNER',
'                                                    when ''REMOTE'' then :P4111_REMOTE_TABLE_OWNER',
'                                                end,       ',
'                  p_table_name               => case :P4111_LOCATION ',
'                                                    when ''LOCAL''  then case :P4111_SOURCE_TYPE ',
'                                                                           when ''TABLE'' then :P4111_QUERY_TABLE',
'                                                                           when ''GRAPH'' then :P4111_GRAPH_NAME',
'                                                                       end',
'                                                    when ''REMOTE'' then :P4111_REMOTE_TABLE_NAME',
'                                                end,',
'                  p_sql_query                => case :P4111_LOCATION ',
'                                                    when ''LOCAL''      then :P4111_LOV_QUERY_SQL',
'                                                    when ''REMOTE''     then :P4111_REMOTE_SQL',
'                                                    when ''WEB_SOURCE'' then :P4111_SOURCE_POST_PROC_SQL',
'                                                end,             ',
'                  p_function_body            => case :P4111_LOCATION',
'                                                    when ''LOCAL''      then :P4111_LOV_QUERY_FUNC_BODY',
'                                                    when ''WEB_SOURCE'' then :P4111_SRC_POST_PROC_FUNC_BODY',
'                                                end,',
'                  p_function_body_language   => case :P4111_LOCATION',
'                                                    when ''LOCAL''      then :P4111_LOV_QUERY_FUNC_LANG',
'                                                    when ''WEB_SOURCE'' then :P4111_SRC_POST_PROC_FUNC_LANG',
'                                                end,',
'                  p_match_clause             => :P4111_PQL_MATCH_CLAUSE,',
'                  p_columns_clause           => :P4111_PQL_COLUMNS_CLAUSE,',
'                  p_remote_server_id         => to_number(:P4111_REMOTE_SERVER_ID),',
'                  p_web_src_module_id        => to_number(:P4111_WEB_SRC_MODULE_ID),',
'                  p_web_src_array_column_id  => to_number(:P4111_WEB_SRC_ARRAY_COL_ID),',
'                  p_where_clause             => case :P4111_LOCATION ',
'                                                    when ''LOCAL'' then :P4111_LOCAL_WHERE ',
'                                                    when ''REMOTE'' then :P4111_REMOTE_WHERE',
'                                                    when ''WEB_SOURCE'' then :P4111_SOURCE_POST_PROC_WHERE',
'                                                end,',
'                  p_post_processing_type     => :P4111_SOURCE_POST_PROC_TYPE',
'        ) )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Not Defined -'
,p_lov_cascade_parent_items=>'P1_DUMMY'
,p_ajax_items_to_submit=>'P4111_LOCATION, P4111_QUERY_TABLE, P4111_REMOTE_TABLE_NAME, P4111_SOURCE_TYPE, P4111_REMOTE_SOURCE_TYPE, P4111_QUERY_OWNER, P4111_REMOTE_TABLE_OWNER, P4111_LOV_QUERY_SQL, P4111_REMOTE_SQL, P4111_LOV_QUERY_FUNC_LANG, P4111_LOV_QUERY_FUNC_BODY, P4111_R'
||'EMOTE_SERVER_ID, P4111_WEB_SRC_MODULE_ID, P4111_SOURCE_POST_PROC_SQL, P4111_SRC_POST_PROC_FUNC_LANG, P4111_SRC_POST_PROC_FUNC_BODY, P4111_LOCAL_WHERE, P4111_REMOTE_WHERE, P4111_SOURCE_POST_PROC_WHERE, P4111_SOURCE_POST_PROC_TYPE,P4111_GRAPH_NAME,P411'
||'1_PQL_MATCH_CLAUSE,P4111_PQL_COLUMNS_CLAUSE,P4111_WEB_SRC_ARRAY_COL_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Define the column that will be used as the icon column for your List of Values. The column needs to provide a value that corresponds to a CSS Class name for the icon. If the item type supports it, an icon will be displayed with your List of Values'
||'.</p>',
'<p>Note: Currently in APEX the only supported native item type is Popup LOV.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20217141923919150)
,p_name=>'P4111_DEFAULT_SORT_COLUMN'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(20215412492919133)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Default Sort'
,p_source=>'DEFAULT_SORT_COLUMN_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name d, ',
'       column_name r',
'  from table( wwv_flow_exec_dev.get_query_columns(',
'                  p_location                 => :P4111_LOCATION,',
'                  p_query_type               => case :P4111_LOCATION ',
'                                                    when ''LOCAL''  then :P4111_SOURCE_TYPE',
'                                                    when ''REMOTE'' then :P4111_REMOTE_SOURCE_TYPE',
'                                                end,',
'                  p_owner                    => case :P4111_LOCATION ',
'                                                    when ''LOCAL''  then :P4111_QUERY_OWNER',
'                                                    when ''REMOTE'' then :P4111_REMOTE_TABLE_OWNER',
'                                                end,       ',
'                  p_table_name               => case :P4111_LOCATION ',
'                                                    when ''LOCAL''  then case :P4111_SOURCE_TYPE ',
'                                                                           when ''TABLE'' then :P4111_QUERY_TABLE',
'                                                                           when ''GRAPH'' then :P4111_GRAPH_NAME',
'                                                                       end',
'                                                    when ''REMOTE'' then :P4111_REMOTE_TABLE_NAME',
'                                                end,',
'                  p_sql_query                => case :P4111_LOCATION ',
'                                                    when ''LOCAL''      then :P4111_LOV_QUERY_SQL',
'                                                    when ''REMOTE''     then :P4111_REMOTE_SQL',
'                                                    when ''WEB_SOURCE'' then :P4111_SOURCE_POST_PROC_SQL',
'                                                end,             ',
'                  p_function_body            => case :P4111_LOCATION',
'                                                    when ''LOCAL''      then :P4111_LOV_QUERY_FUNC_BODY',
'                                                    when ''WEB_SOURCE'' then :P4111_SRC_POST_PROC_FUNC_BODY',
'                                                end,',
'                  p_function_body_language   => case :P4111_LOCATION',
'                                                    when ''LOCAL''      then :P4111_LOV_QUERY_FUNC_LANG',
'                                                    when ''WEB_SOURCE'' then :P4111_SRC_POST_PROC_FUNC_LANG',
'                                                end,',
'                  p_match_clause             => :P4111_PQL_MATCH_CLAUSE,',
'                  p_columns_clause           => :P4111_PQL_COLUMNS_CLAUSE,',
'                  p_remote_server_id         => to_number(:P4111_REMOTE_SERVER_ID),',
'                  p_web_src_module_id        => to_number(:P4111_WEB_SRC_MODULE_ID),',
'                  p_web_src_array_column_id  => to_number(:P4111_WEB_SRC_ARRAY_COL_ID),',
'                  p_where_clause             => case :P4111_LOCATION ',
'                                                    when ''LOCAL'' then :P4111_LOCAL_WHERE ',
'                                                    when ''REMOTE'' then :P4111_REMOTE_WHERE',
'                                                    when ''WEB_SOURCE'' then :P4111_SOURCE_POST_PROC_WHERE',
'                                                end,',
'                  p_post_processing_type     => :P4111_SOURCE_POST_PROC_TYPE',
'        ) )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Use Order By from Query'
,p_lov_cascade_parent_items=>'P1_DUMMY'
,p_ajax_items_to_submit=>'P4111_LOCATION, P4111_QUERY_TABLE, P4111_REMOTE_TABLE_NAME, P4111_SOURCE_TYPE, P4111_REMOTE_SOURCE_TYPE, P4111_QUERY_OWNER, P4111_REMOTE_TABLE_OWNER, P4111_LOV_QUERY_SQL, P4111_REMOTE_SQL, P4111_LOV_QUERY_FUNC_LANG, P4111_LOV_QUERY_FUNC_BODY, P4111_R'
||'EMOTE_SERVER_ID, P4111_WEB_SRC_MODULE_ID, P4111_SOURCE_POST_PROC_SQL, P4111_SRC_POST_PROC_FUNC_LANG, P4111_SRC_POST_PROC_FUNC_BODY, P4111_LOCAL_WHERE, P4111_REMOTE_WHERE, P4111_SOURCE_POST_PROC_WHERE, P4111_SOURCE_POST_PROC_TYPE,P4111_GRAPH_NAME,P411'
||'1_PQL_MATCH_CLAUSE,P4111_PQL_COLUMNS_CLAUSE,P4111_WEB_SRC_ARRAY_COL_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Define the column that will be used as the default sort column for your List of Values.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20996296341632601)
,p_name=>'P4111_DEFAULT_SORT_DIRECTION'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(20215412492919133)
,p_use_cache_before_default=>'NO'
,p_item_default=>'ASC'
,p_prompt=>'Sort Direction'
,p_source=>'DEFAULT_SORT_DIRECTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'SORT_DIRECTIONS'
,p_lov=>'.'||wwv_flow_imp.id(601135878417900624)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Define the sort direction for the default sort.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(23201457449325539)
,p_name=>'P4111_SOURCE_TYPE_HIDDEN'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(202306103707329518)
,p_use_cache_before_default=>'NO'
,p_source=>'SOURCE_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_warn_on_unsaved_changes=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(23201573811325540)
,p_name=>'P4111_QUERY_OWNER_HIDDEN'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(202306103707329518)
,p_use_cache_before_default=>'NO'
,p_source=>'QUERY_OWNER'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_warn_on_unsaved_changes=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(23201601896325541)
,p_name=>'P4111_QUERY_TABLE_HIDDEN'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(202306103707329518)
,p_use_cache_before_default=>'NO'
,p_source=>'QUERY_TABLE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_warn_on_unsaved_changes=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40783720601998105)
,p_name=>'P4111_N'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(397115560)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select LOV_NAME ',
'  from WWV_FLOW_LISTS_OF_VALUES$ ',
' where id                = :F4000_P4111_ID',
'   and security_group_id = :flow_security_group_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Identifies the list of values name'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(104438100298823819)
,p_name=>'P4111_ORIG_LOV_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(396113952)
,p_display_as=>'NATIVE_HIDDEN'
,p_warn_on_unsaved_changes=>'I'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(202159909119506526)
,p_name=>'F4000_P4111_REFERENCE_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(33426411524290175)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Subscribed From'
,p_source=>'REFERENCE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FLOW_SUBSCRIBE_FROM_LOVS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||',
'wwv_flow_lang.system_message(''NO_LOV'')||',
''' -'' d, 0 r from sys.dual ',
'union all',
'select flow_id||'' : ''||LOV_NAME d, id r',
'from   wwv_flow_lists_of_values$',
'where  flow_id != nvl(:fb_flow_id,0) and flow_id in (',
'select f.id',
'from   wwv_main_apps_dev f',
'where  security_group_id = :flow_security_group_id and',
'       build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') and',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id is null and security_group_id = :flow_security_group_id)',
'       or',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id = f.id and security_group_id = :flow_security_group_id )',
')',
'order by 1'))
,p_cSize=>60
,p_cMaxlength=>2000
,p_colspan=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Identify a subscription to another List of Values. To automatically load a new copy of the selected master List of Values,',
'click <strong>Refresh</strong>.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(510295804664814532)
,p_name=>'P4111_ORACLE_TEXT_COLUMN'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(20215412492919133)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Oracle Text Column'
,p_source=>'ORACLE_TEXT_COLUMN_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name d, ',
'       column_name r',
'  from table( wwv_flow_exec_dev.get_query_columns(',
'                  p_location                 => :P4111_LOCATION,',
'                  p_query_type               => case :P4111_LOCATION ',
'                                                    when ''LOCAL''  then :P4111_SOURCE_TYPE',
'                                                    when ''REMOTE'' then :P4111_REMOTE_SOURCE_TYPE',
'                                                end,',
'                  p_owner                    => case :P4111_LOCATION ',
'                                                    when ''LOCAL''  then :P4111_QUERY_OWNER',
'                                                    when ''REMOTE'' then :P4111_REMOTE_TABLE_OWNER',
'                                                end,       ',
'                  p_table_name               => case :P4111_LOCATION ',
'                                                    when ''LOCAL''  then case :P4111_SOURCE_TYPE ',
'                                                                           when ''TABLE'' then :P4111_QUERY_TABLE',
'                                                                           when ''GRAPH'' then :P4111_GRAPH_NAME',
'                                                                       end',
'                                                    when ''REMOTE'' then :P4111_REMOTE_TABLE_NAME',
'                                                end,',
'                  p_sql_query                => case :P4111_LOCATION ',
'                                                    when ''LOCAL''      then :P4111_LOV_QUERY_SQL',
'                                                    when ''REMOTE''     then :P4111_REMOTE_SQL',
'                                                    when ''WEB_SOURCE'' then :P4111_SOURCE_POST_PROC_SQL',
'                                                end,             ',
'                  p_function_body            => case :P4111_LOCATION',
'                                                    when ''LOCAL''      then :P4111_LOV_QUERY_FUNC_BODY',
'                                                    when ''WEB_SOURCE'' then :P4111_SRC_POST_PROC_FUNC_BODY',
'                                                end,',
'                  p_function_body_language   => case :P4111_LOCATION',
'                                                    when ''LOCAL''      then :P4111_LOV_QUERY_FUNC_LANG',
'                                                    when ''WEB_SOURCE'' then :P4111_SRC_POST_PROC_FUNC_LANG',
'                                                end,',
'                  p_match_clause             => :P4111_PQL_MATCH_CLAUSE,',
'                  p_columns_clause           => :P4111_PQL_COLUMNS_CLAUSE,',
'                  p_remote_server_id         => to_number(:P4111_REMOTE_SERVER_ID),',
'                  p_web_src_module_id        => to_number(:P4111_WEB_SRC_MODULE_ID),',
'                  p_web_src_array_column_id  => to_number(:P4111_WEB_SRC_ARRAY_COL_ID),',
'                  p_where_clause             => case :P4111_LOCATION ',
'                                                    when ''LOCAL'' then :P4111_LOCAL_WHERE ',
'                                                    when ''REMOTE'' then :P4111_REMOTE_WHERE',
'                                                    when ''WEB_SOURCE'' then :P4111_SOURCE_POST_PROC_WHERE',
'                                                end,',
'                  p_post_processing_type     => :P4111_SOURCE_POST_PROC_TYPE',
'        ) )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Not Defined -'
,p_lov_cascade_parent_items=>'P1_DUMMY'
,p_ajax_items_to_submit=>'P4111_LOCATION, P4111_QUERY_TABLE, P4111_REMOTE_TABLE_NAME, P4111_SOURCE_TYPE, P4111_REMOTE_SOURCE_TYPE, P4111_QUERY_OWNER, P4111_REMOTE_TABLE_OWNER, P4111_LOV_QUERY_SQL, P4111_REMOTE_SQL, P4111_LOV_QUERY_FUNC_LANG, P4111_LOV_QUERY_FUNC_BODY, P4111_R'
||'EMOTE_SERVER_ID, P4111_WEB_SRC_MODULE_ID, P4111_SOURCE_POST_PROC_SQL, P4111_SRC_POST_PROC_FUNC_LANG, P4111_SRC_POST_PROC_FUNC_BODY, P4111_LOCAL_WHERE, P4111_REMOTE_WHERE, P4111_SOURCE_POST_PROC_WHERE, P4111_SOURCE_POST_PROC_TYPE,P4111_GRAPH_NAME,P411'
||'1_PQL_MATCH_CLAUSE,P4111_PQL_COLUMNS_CLAUSE,P4111_WEB_SRC_ARRAY_COL_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>'P4111_LOCATION'
,p_display_when2=>'LOCAL:REMOTE'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Select a column where the column is indexed by an Oracle Text index.',
'</p>',
'<p>',
'    Row Search returns results based on the Oracle Text operator entered, providing the corresponding Oracle Text index has been created for the column. This option should only be enabled if the necessary index exist, and the end users have been trai'
||'ned in how to utilize the Oracle Text search operators. To simplify Oracle Text syntax for end users, you can specify a function for the Oracle Text PL/SQL Function Name Component Setting in Shared Components, Application Attributes.',
'</p>',
'<p>Note: Currently in APEX the only supported native item type is Popup LOV.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1417954660012517)
,p_computation_sequence=>10
,p_computation_item=>'P4111_SUBSCRIBED_COMP_GRP'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_component_group_dev.is_part_of_subscribed_comp_grp (',
'    p_component_id   => :F4000_P4111_ID,',
'    p_component_type => wwv_flow_copy_metadata.c_lov,',
'    p_app_id         => :FB_FLOW_ID )'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(104450218961876535)
,p_computation_sequence=>20
,p_computation_item=>'P4111_ORIG_LOV_NAME'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>'select lov_name from wwv_flow_lists_of_values$ where security_group_id = :FLOW_SECURITY_GROUP_ID and id=:F4000_P4111_ID'
,p_compute_when=>'F4000_P4111_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1534508609420622)
,p_computation_sequence=>30
,p_computation_item=>'P4111_OLD_USE_LOCAL_TABLE'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>'select use_local_sync_table from wwv_flow_lists_of_values$ where security_group_id = :FLOW_SECURITY_GROUP_ID and id=:F4000_P4111_ID'
,p_compute_when=>'F4000_P4111_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(23201774898325542)
,p_computation_sequence=>5
,p_computation_item=>'P4111_SOURCE_TYPE_HIDDEN'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if coalesce(:P4111_LOCATION,''LOCAL'') = ''LOCAL'' then',
'    if (:P4111_SOURCE_TYPE_HIDDEN in (''TABLE'',''SQL'',''FUNC_BODY_RETURNING_SQL'', ''GRAPH'')) then',
'        return :P4111_SOURCE_TYPE;',
'    else',
'        return :P4111_SOURCE_TYPE_HIDDEN;     -- for legacy P4111_SOURCE_TYPE is not displayed, ',
'                                              -- so just set back to itself.    ',
'    end if;',
'elsif :P4111_LOCATION = ''REMOTE'' then',
'    return :P4111_REMOTE_SOURCE_TYPE;',
'end if;'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2320291263209548)
,p_computation_sequence=>15
,p_computation_item=>'P4111_FUNC_BODY_LANG_HIDDEN'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if coalesce(:P4111_LOCATION,''LOCAL'') = ''LOCAL'' then',
'        return case when :P4111_SOURCE_TYPE = ''FUNC_BODY_RETURNING_SQL'' then :P4111_LOV_QUERY_FUNC_LANG end;',
'    elsif :P4111_LOCATION = ''WEB_SOURCE'' then',
'        return case when :P4111_SOURCE_POST_PROC_TYPE = ''FUNC_BODY_RETURNING_SQL'' then :P4111_SRC_POST_PROC_FUNC_LANG end;',
'    end if;',
'',
'    return null;',
'end;'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(9496916949275717)
,p_computation_sequence=>25
,p_computation_item=>'P4111_LOV_QUERY_HIDDEN'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if coalesce(:P4111_LOCATION,''LOCAL'') = ''LOCAL'' then',
'    if :P4111_SOURCE_TYPE_HIDDEN in (''SQL'',''LEGACY_SQL'') then',
'        return :P4111_LOV_QUERY_SQL;',
'    elsif :P4111_SOURCE_TYPE_HIDDEN = ''FUNC_BODY_RETURNING_SQL'' then',
'        return :P4111_LOV_QUERY_FUNC_BODY;',
'    end if;',
'elsif :P4111_LOCATION = ''REMOTE'' then',
'    return :P4111_REMOTE_SQL;',
'elsif :P4111_LOCATION = ''WEB_SOURCE'' then',
'    if :P4111_SOURCE_POST_PROC_TYPE = ''SQL'' then',
'        return :P4111_SOURCE_POST_PROC_SQL;',
'    elsif :P4111_SOURCE_POST_PROC_TYPE = ''FUNC_BODY_RETURNING_SQL'' then',
'        return :P4111_SRC_POST_PROC_FUNC_BODY;',
'    end if;',
'end if;',
'',
''))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(663117061643931015)
,p_computation_sequence=>35
,p_computation_item=>'P4111_GROUP_COLUMN'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_comment=>'Clear group column when default sort is null (order in query)'
,p_computation_error_message=>'Default sort column is null, but unable to clear group column'
,p_compute_when=>'P4111_DEFAULT_SORT_COLUMN'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1484488258307033)
,p_computation_sequence=>45
,p_computation_item=>'P4111_WHERE_CLAUSE_HIDDEN'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if coalesce(:P4111_LOCATION,''LOCAL'') = ''LOCAL'' then',
'    return case :P4111_SOURCE_TYPE',
'               when ''GRAPH'' then :P4111_PQL_WHERE_CLAUSE',
'               else              :P4111_LOCAL_WHERE',
'           end;',
'elsif :P4111_LOCATION = ''REMOTE'' then',
'    return :P4111_REMOTE_WHERE;',
'elsif :P4111_LOCATION = ''WEB_SOURCE'' then',
'    return :P4111_SOURCE_POST_PROC_WHERE;',
'end if;',
'',
''))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(23201877744325543)
,p_computation_sequence=>55
,p_computation_item=>'P4111_QUERY_OWNER_HIDDEN'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if coalesce(:P4111_LOCATION,''LOCAL'') = ''LOCAL'' then',
'    return wwv_flow_lov_dev.get_table_owner(:P4111_QUERY_OWNER);',
'elsif :P4111_LOCATION = ''REMOTE'' then',
'    return :P4111_REMOTE_TABLE_OWNER;',
'end if;'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(23201933601325544)
,p_computation_sequence=>65
,p_computation_item=>'P4111_QUERY_TABLE_HIDDEN'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if coalesce(:P4111_LOCATION,''LOCAL'') = ''LOCAL'' then',
'    return case :P4111_SOURCE_TYPE ',
'               when ''GRAPH'' then :P4111_GRAPH_NAME',
'                            else :P4111_QUERY_TABLE',
'           end;',
'elsif :P4111_LOCATION = ''REMOTE'' then',
'    return :P4111_REMOTE_TABLE_NAME;',
'end if;'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(58679708573256876)
,p_computation_sequence=>75
,p_computation_item=>'F4000_P4111_LOV_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(:F4000_P4111_LOV_NAME)'
,p_computation_error_message=>'Unable to compute item value.'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1665514385059334)
,p_computation_sequence=>85
,p_computation_item=>'P4111_PQL_MATCH_CLAUSE'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P4111_SOURCE_TYPE'
,p_compute_when_text=>'GRAPH'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1665651040059335)
,p_computation_sequence=>95
,p_computation_item=>'P4111_PQL_COLUMNS_CLAUSE'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P4111_SOURCE_TYPE'
,p_compute_when_text=>'GRAPH'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(202262221502184510)
,p_validation_name=>'reference id not null'
,p_validation_sequence=>10
,p_validation=>'F4000_P4111_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Reference ID must be specified to refresh the LOV.'
,p_when_button_pressed=>wwv_flow_imp.id(202120612291457307)
,p_associated_item=>wwv_flow_imp.id(202159909119506526)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(202271106609206645)
,p_validation_name=>'reference id not zero'
,p_validation_sequence=>20
,p_validation=>'F4000_P4111_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_ZERO'
,p_error_message=>'LOV to refresh must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(202120612291457307)
,p_associated_item=>wwv_flow_imp.id(202159909119506526)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(78604504333995558)
,p_validation_name=>'LovNameMand'
,p_validation_sequence=>30
,p_validation=>'F4000_P4111_LOV_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'LOV Name must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(292985826)
,p_associated_item=>wwv_flow_imp.id(299985834)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(78602631083984314)
,p_validation_name=>'LOVnameUnique'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''x''',
'  from WWV_FLOW_LISTS_OF_VALUES$',
' where flow_id            = to_number(:FB_FLOW_ID) ',
'   and upper(lov_name)    = upper(:F4000_P4111_LOV_NAME)',
'   and id                != to_number(:F4000_P4111_ID)',
'   and security_group_id  = :FLOW_SECURITY_GROUP_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Name already exists.  Enter another name.'
,p_validation_condition=>'F4000_P4111_LOV_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(292985826)
,p_associated_item=>wwv_flow_imp.id(299985834)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1261521852603722)
,p_validation_name=>'P4111_LOV_QUERY_SQL Not Null'
,p_validation_sequence=>50
,p_validation=>'P4111_LOV_QUERY_SQL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P4111_SOURCE_TYPE_HIDDEN = ''LEGACY_SQL'' or ',
':P4111_SOURCE_TYPE = ''SQL'' and :P4111_LOCATION = ''LOCAL'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(292985826)
,p_associated_item=>wwv_flow_imp.id(9496533107275713)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1485773525307046)
,p_validation_name=>'P4111_LOV_QUERY_FUNC_BODY Not Null'
,p_validation_sequence=>60
,p_validation=>'P4111_LOV_QUERY_FUNC_BODY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>':P4111_SOURCE_TYPE = ''FUNC_BODY_RETURNING_SQL'' and :P4111_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(292985826)
,p_associated_item=>wwv_flow_imp.id(4439479327967228)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2824717245544456)
,p_validation_name=>'valid LOV query'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if upper(substr(trim(:P4111_LOV_QUERY_SQL),1,6)) = ''SELECT'' then',
'        return wwv_flow_f4000_util.is_valid_lov_query(:P4111_LOV_QUERY_SQL);',
'    else',
'        return null;',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':P4111_SOURCE_TYPE_HIDDEN = ''LEGACY_SQL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(292985826)
,p_associated_item=>wwv_flow_imp.id(9496533107275713)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1260667749598995)
,p_validation_name=>'P4111_QUERY_TABLE is not null'
,p_validation_sequence=>80
,p_validation=>'P4111_QUERY_TABLE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>':P4111_SOURCE_TYPE = ''TABLE'' and :P4111_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(292985826)
,p_associated_item=>wwv_flow_imp.id(9476514751187804)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1485687373307045)
,p_validation_name=>'P4111_REMOTE_SERVER_ID is not null'
,p_validation_sequence=>90
,p_validation=>'P4111_REMOTE_SERVER_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P4111_LOCATION'
,p_validation_condition2=>'REMOTE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(292985826)
,p_associated_item=>wwv_flow_imp.id(9481590790191485)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1260925876600182)
,p_validation_name=>'P4111_REMOTE_TABLE_NAME is not null'
,p_validation_sequence=>100
,p_validation=>'P4111_REMOTE_TABLE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>':P4111_REMOTE_SOURCE_TYPE = ''TABLE'' and :P4111_LOCATION = ''REMOTE'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(292985826)
,p_associated_item=>wwv_flow_imp.id(9484614427191490)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1261214981601363)
,p_validation_name=>'P4111_REMOTE_SQL is not null'
,p_validation_sequence=>110
,p_validation=>'P4111_REMOTE_SQL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>':P4111_REMOTE_SOURCE_TYPE = ''SQL'' and :P4111_LOCATION = ''REMOTE'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(292985826)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1485574003307044)
,p_validation_name=>'P4111_WEB_SRC_MODULE_ID is not null'
,p_validation_sequence=>120
,p_validation=>'P4111_WEB_SRC_MODULE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P4111_LOCATION'
,p_validation_condition2=>'WEB_SOURCE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(292985826)
,p_associated_item=>wwv_flow_imp.id(9479941132189824)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1485294120307041)
,p_validation_name=>'P4111_RETURN_COLUMN not null'
,p_validation_sequence=>130
,p_validation=>'P4111_RETURN_COLUMN'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>':P4111_LOCATION in (''LOCAL'',''REMOTE'',''WEB_SOURCE'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(292985826)
,p_associated_item=>wwv_flow_imp.id(20214151972919120)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1485387244307042)
,p_validation_name=>'P4111_DISPLAY_COLUMN not null'
,p_validation_sequence=>140
,p_validation=>'P4111_DISPLAY_COLUMN'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>':P4111_LOCATION in (''LOCAL'',''REMOTE'',''WEB_SOURCE'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(292985826)
,p_associated_item=>wwv_flow_imp.id(20216380459919142)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_required_patch=>wwv_flow_imp.id(170786031904296885)
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1485815796307047)
,p_validation_name=>'P4111_SOURCE_POST_PROC_WHERE not null'
,p_validation_sequence=>160
,p_validation=>'P4111_SOURCE_POST_PROC_WHERE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P4111_LOCATION = ''WEB_SOURCE'' and',
':P4111_SOURCE_POST_PROC_TYPE = ''WHERE_ORDER_BY_CLAUSE'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(292985826)
,p_associated_item=>wwv_flow_imp.id(1481681766307005)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1485923103307048)
,p_validation_name=>'P4111_SOURCE_POST_PROC_SQL not null'
,p_validation_sequence=>170
,p_validation=>'P4111_SOURCE_POST_PROC_SQL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P4111_LOCATION = ''WEB_SOURCE'' and',
':P4111_SOURCE_POST_PROC_TYPE = ''SQL'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(292985826)
,p_associated_item=>wwv_flow_imp.id(1481905921307008)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1486070129307049)
,p_validation_name=>'P4111_SRC_POST_PROC_FUNC_BODY not null'
,p_validation_sequence=>180
,p_validation=>'P4111_SRC_POST_PROC_FUNC_BODY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P4111_LOCATION = ''WEB_SOURCE'' and',
':P4111_SOURCE_POST_PROC_TYPE = ''FUNC_BODY_RETURNING_SQL'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(292985826)
,p_associated_item=>wwv_flow_imp.id(1482059431307009)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2701380099095211)
,p_validation_name=>'Prevent used LOV deletion'
,p_validation_sequence=>190
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_used_on_pages     varchar2(4000);',
'    l_used_on_pages_msg varchar2(4000);',
'begin    ',
'    l_used_on_pages := wwv_flow_lov_dev.lov_used_on_pages( :F4000_P4111_ID );',
'    if l_used_on_pages is not null then',
'        l_used_on_pages_msg := wwv_flow_lang.system_message(''P4111_USED_ON_PAGES'',l_used_on_pages);',
'    end if;',
'    return l_used_on_pages_msg;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_when_button_pressed=>wwv_flow_imp.id(291985826)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3304782279286945)
,p_validation_name=>'P4111_RETURN_COLUMN Addl Column Check'
,p_validation_sequence=>200
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from wwv_flow_collections',
' where collection_name = ''LOV_COL_INFO''',
'   and            c001 = :P4111_RETURN_COLUMN'))
,p_validation_type=>'EXISTS'
,p_error_message=>'Return column ''&P4111_RETURN_COLUMN!HTML.'' must be also added to Additional Display Columns.'
,p_validation_condition=>':P4111_ADDITIONAL_COL_COUNT > 0 and :P4111_RETURN_COLUMN is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(292985826)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3304858882286946)
,p_validation_name=>'P4111_DISPLAY_COLUMN Addl Column Check'
,p_validation_sequence=>210
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from wwv_flow_collections',
' where collection_name = ''LOV_COL_INFO''',
'   and            c001 = :P4111_DISPLAY_COLUMN'))
,p_validation_type=>'EXISTS'
,p_error_message=>'Display column ''&P4111_DISPLAY_COLUMN!HTML.'' must be also added to Additional Display Columns.'
,p_validation_condition=>':P4111_ADDITIONAL_COL_COUNT > 0 and :P4111_DISPLAY_COLUMN is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(292985826)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3304950206286947)
,p_validation_name=>'P4111_DEFAULT_SORT_COLUMN Addl Column Check'
,p_validation_sequence=>220
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from wwv_flow_collections',
' where collection_name = ''LOV_COL_INFO''',
'   and            c001 = :P4111_DEFAULT_SORT_COLUMN'))
,p_validation_type=>'EXISTS'
,p_error_message=>'Default Sort column ''&P4111_DEFAULT_SORT_COLUMN!HTML.'' must be also added to Additional Display Columns.'
,p_validation_condition=>':P4111_ADDITIONAL_COL_COUNT > 0 and :P4111_DEFAULT_SORT_COLUMN is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(292985826)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3305088133286948)
,p_validation_name=>'P4111_GROUP_COLUMN Addl Column Check'
,p_validation_sequence=>230
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from wwv_flow_collections',
' where collection_name = ''LOV_COL_INFO''',
'   and            c001 = :P4111_GROUP_COLUMN'))
,p_validation_type=>'EXISTS'
,p_error_message=>'Group column ''&P4111_GROUP_COLUMN!HTML.'' must be also added to Additional Display Columns.'
,p_validation_condition=>':P4111_ADDITIONAL_COL_COUNT > 0 and :P4111_GROUP_COLUMN is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(292985826)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3305107979286949)
,p_validation_name=>'P4111_ICON_COLUMN Addl Column Check'
,p_validation_sequence=>240
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from wwv_flow_collections',
' where collection_name = ''LOV_COL_INFO''',
'   and            c001 = :P4111_ICON_COLUMN'))
,p_validation_type=>'EXISTS'
,p_error_message=>'Icon column ''&P4111_ICON_COLUMN!HTML.'' must be also added to Additional Display Columns.'
,p_validation_condition=>':P4111_ADDITIONAL_COL_COUNT > 0 and :P4111_ICON_COLUMN is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(292985826)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3305228852286950)
,p_validation_name=>'P4111_ORACLE_TEXT_COLUMN Addl Column Check'
,p_validation_sequence=>250
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from wwv_flow_collections',
' where collection_name = ''LOV_COL_INFO''',
'   and            c001 = :P4111_ORACLE_TEXT_COLUMN'))
,p_validation_type=>'EXISTS'
,p_error_message=>'Oracle Text column ''&P4111_ORACLE_TEXT_COLUMN!HTML.'' must be also added to Additional Display Columns.'
,p_validation_condition=>':P4111_ADDITIONAL_COL_COUNT > 0 and :P4111_ORACLE_TEXT_COLUMN is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(292985826)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1664932861059328)
,p_validation_name=>'P4111_GRAPH_NAME not null'
,p_validation_sequence=>260
,p_validation=>'P4111_GRAPH_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>'P4111_SOURCE_TYPE'
,p_validation_condition2=>'GRAPH'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(292985826)
,p_associated_item=>wwv_flow_imp.id(1664819367059327)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1665020850059329)
,p_validation_name=>'P4111_PQL_MATCH_CLAUSE not null'
,p_validation_sequence=>270
,p_validation=>'P4111_PQL_MATCH_CLAUSE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>'P4111_SOURCE_TYPE'
,p_validation_condition2=>'GRAPH'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(292985826)
,p_associated_item=>wwv_flow_imp.id(1664599372059324)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1665150925059330)
,p_validation_name=>'P4111_PQL_COLUMNS_CLAUSE not null'
,p_validation_sequence=>280
,p_validation=>'P4111_PQL_COLUMNS_CLAUSE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>'P4111_SOURCE_TYPE'
,p_validation_condition2=>'GRAPH'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(292985826)
,p_associated_item=>wwv_flow_imp.id(1664649423059325)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3200469391588007)
,p_validation_name=>'Not part of component groups'
,p_validation_sequence=>290
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not wwv_flow_component_group_dev.is_part_of_comp_grp (',
'    p_component_id   => :F4000_P4111_ID,',
'    p_component_type => wwv_flow_copy_metadata.c_lov,',
'    p_app_id         => :FB_FLOW_ID )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'List of values cannot be deleted because it is part of a component group.'
,p_when_button_pressed=>wwv_flow_imp.id(291985826)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1479591516915265404)
,p_name=>'Refresh Grid'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(712080000591813402)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1479591668347265405)
,p_event_id=>wwv_flow_imp.id(1479591516915265404)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(712080000591813402)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(9446966051950045)
,p_name=>'ON LOCATION CHANGE HIDE ALL'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_LOCATION'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_display_when_cond=>'P4111_LOCATION'
,p_display_when_cond2=>'STATIC'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(9447016627950046)
,p_event_id=>wwv_flow_imp.id(9446966051950045)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(73945327537305242)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(9447100599950047)
,p_event_id=>wwv_flow_imp.id(9446966051950045)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(73951063066307275)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(9447226373950048)
,p_event_id=>wwv_flow_imp.id(9446966051950045)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(75743329779916863)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4437849918967212)
,p_event_id=>wwv_flow_imp.id(9446966051950045)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(399144664)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4437968298967213)
,p_event_id=>wwv_flow_imp.id(9446966051950045)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(125268524262083710)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(20215928130919138)
,p_event_id=>wwv_flow_imp.id(9446966051950045)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(20212831971919107)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(9447399675950049)
,p_name=>'LOCATION = LOCAL'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_LOCATION'
,p_condition_element=>'P4111_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'LOCAL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_display_when_cond=>'P4111_LOCATION'
,p_display_when_cond2=>'STATIC'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(9447400847950050)
,p_event_id=>wwv_flow_imp.id(9447399675950049)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(73945327537305242)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(9495322763275701)
,p_name=>'LOCATION = REMOTE'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_LOCATION'
,p_condition_element=>'P4111_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REMOTE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_display_when_cond=>'P4111_LOCATION'
,p_display_when_cond2=>'STATIC'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(23202036615325545)
,p_event_id=>wwv_flow_imp.id(9495322763275701)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_REMOTE_SERVER_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(9495483697275702)
,p_event_id=>wwv_flow_imp.id(9495322763275701)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(75743329779916863)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(20216169683919140)
,p_event_id=>wwv_flow_imp.id(9495322763275701)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(20212831971919107)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(9495541356275703)
,p_name=>'LOCATION = WEB_SOURCE'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_LOCATION'
,p_condition_element=>'P4111_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'WEB_SOURCE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_display_when_cond=>'P4111_LOCATION'
,p_display_when_cond2=>'STATIC'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(23202194381325546)
,p_event_id=>wwv_flow_imp.id(9495541356275703)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_WEB_SRC_MODULE_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(9495678016275704)
,p_event_id=>wwv_flow_imp.id(9495541356275703)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(73951063066307275)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4436855444967202)
,p_name=>'SOURCE TYPE CHANGE HIDE ALL'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_SOURCE_TYPE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_display_when_cond=>'P4111_LOCATION'
,p_display_when_cond2=>'STATIC'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4436999952967203)
,p_event_id=>wwv_flow_imp.id(4436855444967202)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_QUERY_OWNER,P4111_QUERY_TABLE,P4111_LOV_QUERY_SQL,P4111_LOV_QUERY_FUNC_LANG,P4111_LOV_QUERY_FUNC_BODY,P4111_OPTIMIZER_HINT,P4111_LOCAL_WHERE,P4111_GRAPH_NAME,P4111_PQL_MATCH_CLAUSE,P4111_PQL_COLUMNS_CLAUSE,P4111_PQL_WHERE_CLAUSE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4437461818967208)
,p_event_id=>wwv_flow_imp.id(4436855444967202)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(399144664)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4437528211967209)
,p_event_id=>wwv_flow_imp.id(4436855444967202)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(125268524262083710)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4437074517967204)
,p_name=>'SOURCE TYPE = SQL'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_SOURCE_TYPE'
,p_condition_element=>'P4111_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SQL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_display_when_cond=>'P4111_LOCATION'
,p_display_when_cond2=>'STATIC'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4437114804967205)
,p_event_id=>wwv_flow_imp.id(4437074517967204)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_LOV_QUERY_SQL,P4111_OPTIMIZER_HINT'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4437675016967210)
,p_event_id=>wwv_flow_imp.id(4437074517967204)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(125268524262083710)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1502742019993118)
,p_event_id=>wwv_flow_imp.id(4437074517967204)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_LOV_QUERY_SQL'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>wwv_flow_string.join(wwv_flow_t_varchar2(
'''select * from''',
'+ ( ( apex.item("P4111_PARSING_SCHEMA").getValue() === apex.item("P4111_QUERY_OWNER").getValue() ) ? '' '' : '' '' + apex.item("P4111_QUERY_OWNER").getValue() + ''.'' )',
'+ apex.item("P4111_QUERY_TABLE").getValue()',
'+ ( ( apex.item("P4111_LOCAL_WHERE").getValue() !== '''' ) ? '' where '' + apex.item("P4111_LOCAL_WHERE").getValue() : '''' )'))
,p_attribute_09=>'Y'
,p_wait_for_result=>'Y'
,p_client_condition_type=>'NOT_NULL'
,p_client_condition_element=>'P4111_QUERY_TABLE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4439512303967229)
,p_name=>'SOURCE TYPE = PLSQL'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_SOURCE_TYPE'
,p_condition_element=>'P4111_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FUNC_BODY_RETURNING_SQL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_display_when_cond=>'P4111_LOCATION'
,p_display_when_cond2=>'STATIC'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4439635810967230)
,p_event_id=>wwv_flow_imp.id(4439512303967229)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_LOV_QUERY_FUNC_LANG,P4111_LOV_QUERY_FUNC_BODY,P4111_OPTIMIZER_HINT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4437777413967211)
,p_event_id=>wwv_flow_imp.id(4439512303967229)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(399144664)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4437201738967206)
,p_name=>'SOURCE TYPE = TABLE'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_SOURCE_TYPE'
,p_condition_element=>'P4111_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TABLE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_display_when_cond=>'P4111_LOCATION'
,p_display_when_cond2=>'STATIC'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4437392903967207)
,p_event_id=>wwv_flow_imp.id(4437201738967206)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_QUERY_OWNER,P4111_QUERY_TABLE,P4111_LOCAL_WHERE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1664310842059322)
,p_name=>'SOURCE TYPE = GRAPH'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_SOURCE_TYPE'
,p_condition_element=>'P4111_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'GRAPH'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_display_when_cond=>'P4111_LOCATION'
,p_display_when_cond2=>'STATIC'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1664462008059323)
,p_event_id=>wwv_flow_imp.id(1664310842059322)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_QUERY_OWNER,P4111_GRAPH_NAME,P4111_PQL_MATCH_CLAUSE,P4111_PQL_COLUMNS_CLAUSE,P4111_PQL_WHERE_CLAUSE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4439973878967233)
,p_name=>'SOURCE TYPE = LEGACY_SQL'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_SOURCE_TYPE'
,p_condition_element=>'P4111_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'LEGACY_SQL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_display_when_cond=>'P4111_LOCATION'
,p_display_when_cond2=>'STATIC'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4440041070967234)
,p_event_id=>wwv_flow_imp.id(4439973878967233)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_LOV_QUERY_SQL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4440169513967235)
,p_event_id=>wwv_flow_imp.id(4439973878967233)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(399144664)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4440210903967236)
,p_event_id=>wwv_flow_imp.id(4439973878967233)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(125268524262083710)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4438269217967216)
,p_name=>'REMOTE SERVER CHANGES'
,p_event_sequence=>120
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_REMOTE_SERVER_ID'
,p_condition_element=>'P4111_REMOTE_SERVER_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_display_when_cond=>'P4111_LOCATION'
,p_display_when_cond2=>'STATIC'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4438389418967217)
,p_event_id=>wwv_flow_imp.id(4438269217967216)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_REMOTE_SOURCE_TYPE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4438501274967219)
,p_event_id=>wwv_flow_imp.id(4438269217967216)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_REMOTE_SOURCE_TYPE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4438629320967220)
,p_event_id=>wwv_flow_imp.id(4438269217967216)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_REMOTE_SOURCE_TYPE,P4111_REMOTE_TABLE_OWNER,P4111_REMOTE_TABLE_NAME,P4111_REMOTE_WHERE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(20212940887919108)
,p_event_id=>wwv_flow_imp.id(4438269217967216)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(20212831971919107)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4438484798967218)
,p_event_id=>wwv_flow_imp.id(4438269217967216)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_REMOTE_SOURCE_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'TABLE'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(20213046613919109)
,p_event_id=>wwv_flow_imp.id(4438269217967216)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(20212831971919107)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4438769047967221)
,p_name=>'REMOTE SOURCE TYPE CHANGE'
,p_event_sequence=>130
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_REMOTE_SOURCE_TYPE'
,p_condition_element=>'P4111_REMOTE_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SQL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_display_when_cond=>'P4111_LOCATION'
,p_display_when_cond2=>'STATIC'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4438834555967222)
,p_event_id=>wwv_flow_imp.id(4438769047967221)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_REMOTE_SQL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4438908807967223)
,p_event_id=>wwv_flow_imp.id(4438769047967221)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_REMOTE_SQL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4439042872967224)
,p_event_id=>wwv_flow_imp.id(4438769047967221)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_REMOTE_TABLE_OWNER,P4111_REMOTE_TABLE_NAME,P4111_REMOTE_WHERE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4439269347967226)
,p_event_id=>wwv_flow_imp.id(4438769047967221)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_REMOTE_TABLE_OWNER,P4111_REMOTE_TABLE_NAME,P4111_REMOTE_WHERE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1502941062993120)
,p_event_id=>wwv_flow_imp.id(4438769047967221)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_REMOTE_SQL'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>wwv_flow_string.join(wwv_flow_t_varchar2(
'''select * from ''',
'+ ( ( apex.item("P4111_REMOTE_TABLE_OWNER").getValue() !== '''' ) ? apex.item("P4111_REMOTE_TABLE_OWNER").getValue() + ''.'' : '''' )',
'+ apex.item("P4111_REMOTE_TABLE_NAME").getValue()',
'+ ( ( apex.item("P4111_REMOTE_WHERE").getValue() !== '''' ) ? '' where '' + apex.item("P4111_REMOTE_WHERE").getValue() : '''' )'))
,p_attribute_09=>'Y'
,p_wait_for_result=>'Y'
,p_client_condition_type=>'NOT_NULL'
,p_client_condition_element=>'P4111_REMOTE_TABLE_NAME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(11467118814432845)
,p_name=>'REMOTE CACHING CHANGES'
,p_event_sequence=>140
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_REMOTE_SQL_CACHING'
,p_condition_element=>'P4111_REMOTE_SQL_CACHING'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(11467281034432846)
,p_event_id=>wwv_flow_imp.id(11467118814432845)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_REMOTE_SQL_INVALIDATE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(11467338718432847)
,p_event_id=>wwv_flow_imp.id(11467118814432845)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_REMOTE_SQL_INVALIDATE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(11467518747432849)
,p_name=>'WEB SRC MODULE CHANGES'
,p_event_sequence=>150
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_WEB_SRC_MODULE_ID'
,p_condition_element=>'P4111_WEB_SRC_MODULE_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(11467676239432850)
,p_event_id=>wwv_flow_imp.id(11467518747432849)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(20215619883919135)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(20212276678919101)
,p_event_id=>wwv_flow_imp.id(11467518747432849)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(20215619883919135)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1533868086420615)
,p_event_id=>wwv_flow_imp.id(11467518747432849)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_WEB_SRC_ARRAY_COL_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(21000182695632640)
,p_name=>'SOURCE ITEMS CHANGE'
,p_event_sequence=>160
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_SOURCE_TYPE, P4111_QUERY_OWNER, P4111_QUERY_TABLE, P4111_WEB_SRC_MODULE_ID, P4111_REMOTE_SERVER_ID, P4111_REMOTE_SOURCE_TYPE, P4111_REMOTE_TABLE_OWNER, P4111_REMOTE_TABLE_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_da_event_comment=>'Disable and clear column related controls when any source item is changed.'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4470218907653239)
,p_event_id=>wwv_flow_imp.id(21000182695632640)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'//has to be done before clear',
'storeColumnMappings();'))
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(21000373569632642)
,p_event_id=>wwv_flow_imp.id(21000182695632640)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>'wwv_flow_collection.truncate_collection( ''LOV_COL_INFO'' );'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(21000417639632643)
,p_event_id=>wwv_flow_imp.id(21000182695632640)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(9499495849275742)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(21000533436632644)
,p_event_id=>wwv_flow_imp.id(21000182695632640)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_RETURN_COLUMN,P4111_DISPLAY_COLUMN,P4111_DEFAULT_SORT_COLUMN,P4111_GROUP_COLUMN,P4111_ICON_COLUMN,P4111_ORACLE_TEXT_COLUMN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(21000986508632648)
,p_event_id=>wwv_flow_imp.id(21000182695632640)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_RETURN_COLUMN,P4111_DISPLAY_COLUMN,P4111_DEFAULT_SORT_COLUMN,P4111_DEFAULT_SORT_DIRECTION,P4111_GROUP_COLUMN,P4111_ICON_COLUMN,P4111_ORACLE_TEXT_COLUMN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(21001064272632649)
,p_event_id=>wwv_flow_imp.id(21000182695632640)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(20999087932632629)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(688654437560399026)
,p_name=>'SOURCE COLUMN CHANGE'
,p_event_sequence=>170
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_LOV_QUERY_SQL,P4111_LOV_QUERY_FUNC_LANG,P4111_LOV_QUERY_FUNC_BODY,P4111_REMOTE_SQL, P4111_SOURCE_POST_PROC_SQL,P4111_SRC_POST_PROC_FUNC_LANG, P4111_SRC_POST_PROC_FUNC_BODY,P4111_SOURCE_POST_PROC_TYPE,P4111_PQL_MATCH_CLAUSE,P4111_GRAPH_NAME,P411'
||'1_PQL_COLUMNS_CLAUSE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_da_event_comment=>'Disable and clear column related controls when any source item is changed.'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(688654565543399027)
,p_event_id=>wwv_flow_imp.id(688654437560399026)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'//has to be done before clear',
'storeColumnMappings();'))
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1389541671697745)
,p_event_id=>wwv_flow_imp.id(688654437560399026)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_table_name            varchar2(128);',
'    l_table_owner           varchar2(128);',
'    l_source_type           wwv_flow_lists_of_values$.source_type%type;',
'    l_sql                   varchar2(32767);',
'    l_func_body             varchar2(32767);',
'    l_func_body_language    wwv_flow_code_exec.t_language;',
'    l_describe_result       wwv_flow_exec_dev.t_describe_result;',
'    l_column                wwv_flow_exec_api.t_column;',
'    l_column_matched        boolean;',
'    --',
'    c_collection_name       varchar2(12) := ''LOV_COL_INFO'';',
'begin',
'    if :P4111_LOCATION = wwv_flow_exec_api.c_location_local_db then',
'        l_table_owner        := :P4111_QUERY_OWNER;',
'        l_source_type        := :P4111_SOURCE_TYPE;',
'        l_table_name         := case l_source_type',
'                                    when ''TABLE'' then :P4111_QUERY_TABLE',
'                                    when ''GRAPH'' then :P4111_GRAPH_NAME',
'                                 end;',
'        l_sql                := :P4111_LOV_QUERY_SQL;',
'        l_func_body          := :P4111_LOV_QUERY_FUNC_BODY;',
'        l_func_body_language := :P4111_LOV_QUERY_FUNC_LANG;',
'    elsif :P4111_LOCATION = wwv_flow_exec_api.c_location_remote_db then',
'        l_table_owner   := :P4111_REMOTE_TABLE_OWNER;',
'        l_table_name    := :P4111_REMOTE_TABLE_NAME;',
'        l_source_type   := :P4111_REMOTE_SOURCE_TYPE;',
'        l_sql           := :P4111_REMOTE_SQL;',
'    elsif :P4111_LOCATION = wwv_flow_exec_api.c_location_web_source then',
'        l_sql                := :P4111_SOURCE_POST_PROC_SQL;',
'        l_func_body          := :P4111_SRC_POST_PROC_FUNC_BODY;',
'        l_func_body_language := :P4111_SRC_POST_PROC_FUNC_LANG;',
'    end if;',
'',
'    -- parse and describe query',
'    l_describe_result := wwv_flow_exec_dev.check_and_describe (',
'                              p_location                => :P4111_LOCATION,',
'                              p_query_type              => l_source_type,',
'                              p_owner                   => l_table_owner,           ',
'                              p_table_name              => l_table_name,  ',
'                              p_match_clause            => :P4111_PQL_MATCH_CLAUSE,',
'                              p_columns_clause          => :P4111_PQL_COLUMNS_CLAUSE,          ',
'                              p_sql_query               => l_sql,              ',
'                              p_function_body           => l_func_body,     ',
'                              p_function_body_language  => l_func_body_language,',
'                              p_remote_server_id        => :P4111_REMOTE_SERVER_ID,',
'                              p_web_src_module_id       => :P4111_WEB_SRC_MODULE_ID,',
'                              p_web_src_array_column_id => :P4111_WEB_SRC_ARRAY_COL_ID,',
'                              p_post_processing_type    => :P4111_SOURCE_POST_PROC_TYPE );',
'    ',
'    -- loop over columns in collection',
'    for l_column_collection in ( select seq_id,',
'                                        c001 column_name ',
'                                   from wwv_flow_collections',
'                                  where collection_name = c_collection_name )',
'    loop ',
'        l_column_matched := false;',
'        -- loop over page columns',
'        for i in 1 .. l_describe_result.query_columns.count loop',
'            l_column := l_describe_result.query_columns( i );',
'            if l_column.name = l_column_collection.column_name then ',
'                l_column_matched := true;',
'                exit;',
'            end if;',
'        end loop;        ',
'        ',
'        -- column not in shuttle columns, delete it from the collection',
'        if not l_column_matched then',
'            wwv_flow_collection.delete_member(',
'                p_collection_name => c_collection_name,',
'                p_seq             => l_column_collection.seq_id );',
'        end if;',
'    end loop;',
'end;'))
,p_attribute_02=>'P4111_LOCATION,P4111_QUERY_OWNER,P4111_QUERY_TABLE,P4111_SOURCE_TYPE,P4111_LOV_QUERY_SQL,P4111_LOV_QUERY_FUNC_LANG,P4111_LOV_QUERY_FUNC_BODY,P4111_REMOTE_TABLE_OWNER,P4111_REMOTE_TABLE_NAME,P4111_REMOTE_SOURCE_TYPE,P4111_REMOTE_SQL,P4111_SOURCE_POST_'
||'PROC_SQL,P4111_SRC_POST_PROC_FUNC_BODY,P4111_REMOTE_SERVER_ID,P4111_WEB_SRC_MODULE_ID,P4111_SOURCE_POST_PROC_TYPE,P4111_GRAPH_NAME,P4111_PQL_MATCH_CLAUSE,P4111_PQL_COLUMNS_CLAUSE,P4111_WEB_SRC_ARRAY_COL_ID'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1389623643697746)
,p_event_id=>wwv_flow_imp.id(688654437560399026)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(9499495849275742)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(688654846070399030)
,p_event_id=>wwv_flow_imp.id(688654437560399026)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_RETURN_COLUMN,P4111_DISPLAY_COLUMN,P4111_DEFAULT_SORT_COLUMN,P4111_GROUP_COLUMN,P4111_ICON_COLUMN,P4111_ORACLE_TEXT_COLUMN'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'Y'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(688654993453399031)
,p_event_id=>wwv_flow_imp.id(688654437560399026)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_RETURN_COLUMN,P4111_DISPLAY_COLUMN,P4111_DEFAULT_SORT_COLUMN,P4111_DEFAULT_SORT_DIRECTION,P4111_GROUP_COLUMN,P4111_ICON_COLUMN,P4111_ORACLE_TEXT_COLUMN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(688655033867399032)
,p_event_id=>wwv_flow_imp.id(688654437560399026)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(20999087932632629)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(20996501334632604)
,p_name=>'SOURCE ITEMS CHANGE - GET NEW COLUMN INFO'
,p_event_sequence=>180
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_SOURCE_TYPE, P4111_QUERY_OWNER, P4111_QUERY_TABLE, P4111_LOV_QUERY_SQL, P4111_LOV_QUERY_FUNC_LANG, P4111_LOV_QUERY_FUNC_BODY, P4111_WEB_SRC_MODULE_ID, P4111_REMOTE_SERVER_ID, P4111_REMOTE_SOURCE_TYPE, P4111_REMOTE_SQL, P4111_REMOTE_TABLE_OWNER,'
||' P4111_REMOTE_TABLE_NAME, P4111_SOURCE_POST_PROC_WHERE, P4111_SOURCE_POST_PROC_SQL, P4111_SRC_POST_PROC_FUNC_LANG, P4111_SRC_POST_PROC_FUNC_BODY,P4111_SOURCE_POST_PROC_TYPE,P4111_GRAPH_NAME,P4111_PQL_MATCH_CLAUSE,P4111_PQL_COLUMNS_CLAUSE,P4111_WEB_SR'
||'C_ARRAY_COL_ID'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'isValidSourceDefinition()'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_da_event_comment=>'Enabled and refresh column related controls when any source items are changed, and the current source definition is a valid one (has everything defined that needs to be to get column information).'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(20996611252632605)
,p_event_id=>wwv_flow_imp.id(20996501334632604)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_RETURN_COLUMN,P4111_DISPLAY_COLUMN,P4111_GROUP_COLUMN,P4111_ICON_COLUMN,P4111_DEFAULT_SORT_COLUMN,P4111_ORACLE_TEXT_COLUMN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(21000784603632646)
,p_event_id=>wwv_flow_imp.id(20996501334632604)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_RETURN_COLUMN,P4111_DISPLAY_COLUMN,P4111_DEFAULT_SORT_COLUMN,P4111_DEFAULT_SORT_DIRECTION,P4111_GROUP_COLUMN,P4111_ICON_COLUMN,P4111_ORACLE_TEXT_COLUMN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(21001164155632650)
,p_event_id=>wwv_flow_imp.id(20996501334632604)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(20999087932632629)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(20999466262632633)
,p_name=>'CLOSE DIALOG'
,p_event_sequence=>190
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(1483115269307020)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1484049193307029)
,p_event_id=>wwv_flow_imp.id(20999466262632633)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_ADDITIONAL_COL_COUNT'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(1)',
'  from wwv_flow_collections',
' where collection_name = ''LOV_COL_INFO'''))
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(20999596825632634)
,p_event_id=>wwv_flow_imp.id(20999466262632633)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(9499495849275742)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1482140275307010)
,p_name=>'SOURCE POST PROCESSING TYPE CHANGE HIDE ALL'
,p_event_sequence=>200
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_SOURCE_POST_PROC_TYPE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1482250856307011)
,p_event_id=>wwv_flow_imp.id(1482140275307010)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_SOURCE_POST_PROC_WHERE,P4111_SOURCE_POST_PROC_SQL,P4111_SRC_POST_PROC_FUNC_LANG,P4111_SRC_POST_PROC_FUNC_BODY'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1482395108307012)
,p_name=>'SOURCE POST PROCESSING TYPE = WHERE'
,p_event_sequence=>210
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_SOURCE_POST_PROC_TYPE'
,p_condition_element=>'P4111_SOURCE_POST_PROC_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'WHERE_ORDER_BY_CLAUSE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1482477242307013)
,p_event_id=>wwv_flow_imp.id(1482395108307012)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_SOURCE_POST_PROC_WHERE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1482544110307014)
,p_name=>'SOURCE POST PROCESSING TYPE = SQL'
,p_event_sequence=>220
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_SOURCE_POST_PROC_TYPE'
,p_condition_element=>'P4111_SOURCE_POST_PROC_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SQL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1482671291307015)
,p_event_id=>wwv_flow_imp.id(1482544110307014)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_SOURCE_POST_PROC_SQL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1461053545917801)
,p_event_id=>wwv_flow_imp.id(1482544110307014)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_SOURCE_POST_PROC_SQL'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_lov_dev.get_post_processing_sql_query(',
'    p_location               => :P4111_LOCATION,',
'    p_query_type             => case :P4111_LOCATION',
'                                    when wwv_flow_exec_api.c_location_local_db then :P4111_SOURCE_TYPE',
'                                    when wwv_flow_exec_api.c_location_remote_db then :P4111_REMOTE_SOURCE_TYPE',
'                                end,',
'    p_owner                  => case :P4111_LOCATION',
'                                  when wwv_flow_exec_api.c_location_local_db then :P4111_QUERY_OWNER',
'                                  when wwv_flow_exec_api.c_location_remote_db then :P4111_REMOTE_TABLE_OWNER',
'                                end,         ',
'    p_table_name             => case :P4111_LOCATION',
'                                  when wwv_flow_exec_api.c_location_local_db then :P4111_QUERY_TABLE',
'                                  when wwv_flow_exec_api.c_location_remote_db then :P4111_REMOTE_TABLE_NAME',
'                                end,            ',
'    p_sql_query              => case :P4111_LOCATION',
'                                  when wwv_flow_exec_api.c_location_local_db then :P4111_LOV_QUERY_SQL',
'                                  when wwv_flow_exec_api.c_location_remote_db then :P4111_REMOTE_SQL',
'                                end,',
'    p_function_body          => :P4111_LOV_QUERY_FUNC_BODY,',
'    p_function_body_language => :P4111_LOV_QUERY_FUNC_LANG,',
'    p_remote_server_id       => to_number(:P4111_REMOTE_SERVER_ID),',
'    p_web_src_module_id      => to_number(:P4111_WEB_SRC_MODULE_ID),',
'    p_web_src_array_col_id   => to_number(:P4111_WEB_SRC_ARRAY_COL_ID) );'))
,p_attribute_07=>'P4111_LOCATION,P4111_SOURCE_TYPE,P4111_REMOTE_SOURCE_TYPE,P4111_QUERY_OWNER,P4111_REMOTE_TABLE_OWNER,P4111_QUERY_TABLE,P4111_REMOTE_TABLE_NAME,P4111_LOV_QUERY_SQL,P4111_REMOTE_SQL,P4111_LOV_QUERY_FUNC_LANG,P4111_LOV_QUERY_FUNC_BODY,P4111_REMOTE_SERVE'
||'R_ID,P4111_WEB_SRC_MODULE_ID,P4111_WEB_SRC_ARRAY_COL_ID'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1482712875307016)
,p_name=>'SOURCE POST PROCESSING TYPE = PLSQL'
,p_event_sequence=>230
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_SOURCE_POST_PROC_TYPE'
,p_condition_element=>'P4111_SOURCE_POST_PROC_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FUNC_BODY_RETURNING_SQL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1482844235307017)
,p_event_id=>wwv_flow_imp.id(1482712875307016)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_SRC_POST_PROC_FUNC_LANG,P4111_SRC_POST_PROC_FUNC_BODY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1461111669917802)
,p_event_id=>wwv_flow_imp.id(1482712875307016)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_SRC_POST_PROC_FUNC_BODY'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return ''return q''''~''||chr(13)||',
'        wwv_flow_lov_dev.get_post_processing_sql_query(',
'            p_location               => :P4111_LOCATION,',
'            p_query_type             => case :P4111_LOCATION',
'                                            when wwv_flow_exec_api.c_location_local_db then :P4111_SOURCE_TYPE',
'                                            when wwv_flow_exec_api.c_location_remote_db then :P4111_REMOTE_SOURCE_TYPE',
'                                        end,',
'            p_owner                  => case :P4111_LOCATION',
'                                          when wwv_flow_exec_api.c_location_local_db then :P4111_QUERY_OWNER',
'                                          when wwv_flow_exec_api.c_location_remote_db then :P4111_REMOTE_TABLE_OWNER',
'                                        end,         ',
'            p_table_name             => case :P4111_LOCATION',
'                                          when wwv_flow_exec_api.c_location_local_db then :P4111_QUERY_TABLE',
'                                          when wwv_flow_exec_api.c_location_remote_db then :P4111_REMOTE_TABLE_NAME',
'                                        end,            ',
'            p_sql_query              => case :P4111_LOCATION',
'                                          when wwv_flow_exec_api.c_location_local_db then :P4111_LOV_QUERY_SQL',
'                                          when wwv_flow_exec_api.c_location_remote_db then :P4111_REMOTE_SQL',
'                                        end,',
'            p_function_body          => :P4111_LOV_QUERY_FUNC_BODY,',
'            p_function_body_language => :P4111_LOV_QUERY_FUNC_LANG,',
'            p_remote_server_id       => to_number(:P4111_REMOTE_SERVER_ID),',
'            p_web_src_module_id      => to_number(:P4111_WEB_SRC_MODULE_ID),',
'            p_web_src_array_col_id   => to_number(:P4111_WEB_SRC_ARRAY_COL_ID ) ) || chr(13)||''~'''';'';',
''))
,p_attribute_07=>'P4111_LOCATION,P4111_SOURCE_TYPE,P4111_REMOTE_SOURCE_TYPE,P4111_QUERY_OWNER,P4111_REMOTE_TABLE_OWNER,P4111_QUERY_TABLE,P4111_REMOTE_TABLE_NAME,P4111_LOV_QUERY_SQL,P4111_REMOTE_SQL,P4111_LOV_QUERY_FUNC_LANG,P4111_LOV_QUERY_FUNC_BODY,P4111_REMOTE_SERVE'
||'R_ID,P4111_WEB_SRC_MODULE_ID,P4111_SRC_POST_PROC_FUNC_LANG,P4111_WEB_SRC_ARRAY_COL_ID'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1483589861307024)
,p_name=>'SHOW / HIDE COLUMN IG'
,p_event_sequence=>240
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_ADDITIONAL_COL_COUNT'
,p_condition_element=>'P4111_ADDITIONAL_COL_COUNT'
,p_triggering_condition_type=>'GREATER_THAN'
,p_triggering_expression=>'0'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1483669713307025)
,p_event_id=>wwv_flow_imp.id(1483589861307024)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(9499495849275742)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1483734117307026)
,p_event_id=>wwv_flow_imp.id(1483589861307024)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(9499495849275742)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1484826845307037)
,p_name=>'GROUP COLUMN CHANGES'
,p_event_sequence=>250
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_GROUP_COLUMN'
,p_condition_element=>'P4111_GROUP_COLUMN'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1484943637307038)
,p_event_id=>wwv_flow_imp.id(1484826845307037)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_GROUP_SORT_DIRECTION'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1485069072307039)
,p_event_id=>wwv_flow_imp.id(1484826845307037)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_GROUP_SORT_DIRECTION'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1465060645917841)
,p_name=>'WEB SOURCE PARAM DIALOG CLOSSE'
,p_event_sequence=>260
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(1461332165917804)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1465182744917842)
,p_event_id=>wwv_flow_imp.id(1465060645917841)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1461332165917804)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4470082448653237)
,p_name=>'SET SOURCE ITEMS AFTER REFRESH'
,p_event_sequence=>270
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_RETURN_COLUMN,P4111_DISPLAY_COLUMN,P4111_GROUP_COLUMN,P4111_ICON_COLUMN,P4111_DEFAULT_SORT_COLUMN,P4111_ORACLE_TEXT_COLUMN'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4469757345653234)
,p_event_id=>wwv_flow_imp.id(4470082448653237)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'setColumnMappings( this.triggeringElement.id );'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(19531886461272707)
,p_name=>'REMOTE SQL AUTH CHECK'
,p_event_sequence=>280
,p_condition_element=>'P4111_AUTH_TEST'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'AUTH_FAILURE,COMM_FAILURE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_cond=>'P4111_LOCATION'
,p_display_when_cond2=>'REMOTE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(19531961987272708)
,p_event_id=>wwv_flow_imp.id(19531886461272707)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var lAuthTest = apex.item( ''P4111_AUTH_TEST'' ).getValue();',
'',
'if ( lAuthTest === ''AUTH_FAILURE'' ) {',
'    apex.message.showErrors({',
'            type:       ''error'',',
'            location:   ''page'',',
'            message:    ''&"APP_TEXT$APEX.REMOTESQL.AUTHENTICATION_FAILED_FOR_LOV".'',',
'            unsafe:     false',
'    });',
'} else if ( lAuthTest === ''COMM_FAILURE'' ) {',
'    apex.message.showErrors({',
'            type:       ''error'',',
'            location:   ''page'',',
'            message:    ''&"APP_TEXT$APEX.REMOTESQL.COMMUNICATION_FAILURE".'',',
'            unsafe:     false',
'    });    ',
'}'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(663116787013931012)
,p_name=>'DEFAULT SORT DEFINED'
,p_event_sequence=>290
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_DEFAULT_SORT_COLUMN'
,p_condition_element=>'P4111_DEFAULT_SORT_COLUMN'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(663116816588931013)
,p_event_id=>wwv_flow_imp.id(663116787013931012)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_DEFAULT_SORT_DIRECTION,P4111_GROUP_COLUMN,P4111_GROUP_SORT_DIRECTION'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(663116980068931014)
,p_event_id=>wwv_flow_imp.id(663116787013931012)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_DEFAULT_SORT_DIRECTION,P4111_GROUP_COLUMN,P4111_GROUP_SORT_DIRECTION'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(255005309062399740)
,p_name=>'DISABLE SAVE BUTTON ON QUERY KEY PRESS'
,p_event_sequence=>300
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_LOV_QUERY_SQL,P4111_LOV_QUERY_FUNC_LANG,P4111_LOV_QUERY_FUNC_BODY,P4111_REMOTE_SQL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'keypress'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P4111_LOCATION <> ''STATIC'' and',
':P4111_SOURCE_TYPE <> ''LEGACY_SQL'''))
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(255005444121399741)
,p_event_id=>wwv_flow_imp.id(255005309062399740)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(292985826)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(255005506628399742)
,p_name=>'ENABLE SAVE BUTTON ON LEAVE QUERY ITEM'
,p_event_sequence=>310
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_LOV_QUERY_SQL,P4111_LOV_QUERY_FUNC_LANG,P4111_LOV_QUERY_FUNC_BODY,P4111_REMOTE_SQL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'custom'
,p_bind_event_type_custom=>'blur'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P4111_LOCATION <> ''STATIC'' and',
':P4111_SOURCE_TYPE <> ''LEGACY_SQL'''))
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(255005687009399743)
,p_event_id=>wwv_flow_imp.id(255005506628399742)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(292985826)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1663199442963715)
,p_name=>'Use Local Table Enabled'
,p_event_sequence=>320
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4111_USE_LOCAL_TABLE'
,p_condition_element=>'P4111_USE_LOCAL_TABLE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1663281334963716)
,p_event_id=>wwv_flow_imp.id(1663199442963715)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_EXTERNAL_FILTER_EXPR,P4111_EXTERNAL_ORDER_BY_EXPR'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1663547549963719)
,p_event_id=>wwv_flow_imp.id(1663199442963715)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1461332165917804)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1663331417963717)
,p_event_id=>wwv_flow_imp.id(1663199442963715)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1461332165917804)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1663497778963718)
,p_event_id=>wwv_flow_imp.id(1663199442963715)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_EXTERNAL_FILTER_EXPR,P4111_EXTERNAL_ORDER_BY_EXPR'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2701444639095212)
,p_name=>'Delete LOV'
,p_event_sequence=>330
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(291985826)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2701598298095213)
,p_event_id=>wwv_flow_imp.id(2701444639095212)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'&DELETE_MSG.'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2701720452095215)
,p_event_id=>wwv_flow_imp.id(2701444639095212)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'Delete'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6001428992547810)
,p_name=>'Apply Changes'
,p_event_sequence=>340
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(292985826)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6001537670547811)
,p_event_id=>wwv_flow_imp.id(6001428992547810)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'let lDelCount = 0,',
'    lAllCount = 0;',
'    ',
'const model = apex.region("COL_IG").widget().interactiveGrid("getCurrentView").model;',
'',
'model.forEach( function( record, index, id ) {',
'    lAllCount = lAllCount + 1;',
'    let meta = model.getRecordMetadata(id);',
'    if ( meta.deleted ){',
'      lDelCount = lDelCount + 1;',
'    }',
'});',
'',
'// set IG row count and deleted rows count to hidden items',
'// we need them for validations',
'apex.item("P4111_ADDITIONAL_COL_COUNT").setValue(lAllCount);',
'apex.item("P4111_DEL_COL_COUNT").setValue(lDelCount);'))
,p_client_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_client_condition_expression=>'apex.region("COL_IG") !== null'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(11094755239588036)
,p_event_id=>wwv_flow_imp.id(6001428992547810)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'Are you sure you want to subscribe to the selected master list of values? This will overwrite current list of values data with selected master list of values.'
,p_attribute_03=>'warning'
,p_attribute_06=>'Subscribe'
,p_attribute_07=>'Cancel'
,p_client_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_client_condition_expression=>'$v(''F4000_P4111_REFERENCE_ID'') !== "" && $v(''F4000_P4111_REFERENCE_ID_INIT'') === ""'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6001668494547812)
,p_event_id=>wwv_flow_imp.id(6001428992547810)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'ApplyChanges'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1666106721059340)
,p_name=>'Get Property Graph Items into Session State'
,p_event_sequence=>350
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_cond=>'P4111_SOURCE_TYPE'
,p_display_when_cond2=>'GRAPH'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1666267444059341)
,p_event_id=>wwv_flow_imp.id(1666106721059340)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>'null;'
,p_attribute_02=>'P4111_GRAPH_NAME,P4111_PQL_MATCH_CLAUSE,P4111_PQL_COLUMNS_CLAUSE'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1533947048420616)
,p_name=>'Hide Array Col when NULL'
,p_event_sequence=>370
,p_condition_element=>'P4111_WEB_SRC_ARRAY_COL_ID'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1534034549420617)
,p_event_id=>wwv_flow_imp.id(1533947048420616)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_WEB_SRC_ARRAY_COL_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(10675860191291947)
,p_name=>'Hide F4000_P4111_REFERENCE_ID'
,p_event_sequence=>370
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'F4000_P4111_REFERENCE_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(10676210434291946)
,p_event_id=>wwv_flow_imp.id(10675860191291947)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4111_REFERENCE_ID'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(20999152427632630)
,p_process_sequence=>10
,p_process_point=>'AFTER_BOX_BODY'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'SET STATE OF ITEMS USED IN COLUMN DIALOG'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    -- Referenced in LOV on modal page item P4082_SELECT_COLUMNS, so must be set in ',
'    -- session state on load in case the dialog is opened immediately',
'    htmldb_util.set_session_state(''P4111_LOCATION'',                :P4111_LOCATION,                false );',
'    htmldb_util.set_session_state(''P4111_SOURCE_TYPE'',             :P4111_SOURCE_TYPE,             false );',
'    htmldb_util.set_session_state(''P4111_REMOTE_SOURCE_TYPE'',      :P4111_REMOTE_SOURCE_TYPE,      false );',
'    htmldb_util.set_session_state(''P4111_QUERY_OWNER'',             :P4111_QUERY_OWNER,             false );',
'    htmldb_util.set_session_state(''P4111_REMOTE_TABLE_OWNER'',      :P4111_REMOTE_TABLE_OWNER,      false );',
'    htmldb_util.set_session_state(''P4111_QUERY_TABLE'',             :P4111_QUERY_TABLE,             false );',
'    htmldb_util.set_session_state(''P4111_REMOTE_TABLE_NAME'',       :P4111_REMOTE_TABLE_NAME,       false );',
'    htmldb_util.set_session_state(''P4111_GRAPH_NAME'',              :P4111_GRAPH_NAME,              false );',
'    htmldb_util.set_session_state(''P4111_PQL_MATCH_CLAUSE'',        :P4111_PQL_MATCH_CLAUSE,        false );',
'    htmldb_util.set_session_state(''P4111_PQL_COLUMNS_CLAUSE'',      :P4111_PQL_COLUMNS_CLAUSE,      false );',
'    htmldb_util.set_session_state(''P4111_LOV_QUERY_SQL'',           :P4111_LOV_QUERY_SQL,           false );',
'    htmldb_util.set_session_state(''P4111_REMOTE_SQL'',              :P4111_REMOTE_SQL,              false );',
'    htmldb_util.set_session_state(''P4111_LOV_QUERY_FUNC_LANG'',     :P4111_LOV_QUERY_FUNC_LANG,     false );',
'    htmldb_util.set_session_state(''P4111_LOV_QUERY_FUNC_BODY'',     :P4111_LOV_QUERY_FUNC_BODY,     false );',
'    htmldb_util.set_session_state(''P4111_REMOTE_SERVER_ID'',        :P4111_REMOTE_SERVER_ID,        false );',
'    htmldb_util.set_session_state(''P4111_WEB_SRC_MODULE_ID'',       :P4111_WEB_SRC_MODULE_ID,       false );',
'    htmldb_util.set_session_state(''P4111_WEB_SRC_ARRAY_COL_ID'',    :P4111_WEB_SRC_ARRAY_COL_ID,    false );',
'    htmldb_util.set_session_state(''P4111_SOURCE_POST_PROC_SQL'',    :P4111_SOURCE_POST_PROC_SQL,    false );',
'    htmldb_util.set_session_state(''P4111_SRC_POST_PROC_FUNC_LANG'', :P4111_SRC_POST_PROC_FUNC_LANG, false );',
'    htmldb_util.set_session_state(''P4111_SRC_POST_PROC_FUNC_BODY'', :P4111_SRC_POST_PROC_FUNC_BODY, false );',
'    htmldb_util.set_session_state(''P4111_LOCAL_WHERE'',             :P4111_LOCAL_WHERE,             false );',
'    htmldb_util.set_session_state(''P4111_REMOTE_WHERE'',            :P4111_REMOTE_WHERE,            false );',
'    htmldb_util.set_session_state(''P4111_SOURCE_POST_PROC_WHERE'',  :P4111_SOURCE_POST_PROC_WHERE,  false );',
'    htmldb_util.set_session_state(''P4111_SOURCE_POST_PROC_TYPE'',   :P4111_SOURCE_POST_PROC_TYPE,   false );',
'',
'    -- Referenced in default value on modal page item P4082_SELECT_COLUMNS, so',
'    -- also must be set',
'    htmldb_util.set_session_state(''P4111_RETURN_COLUMN'',           :P4111_RETURN_COLUMN,           false );',
'    htmldb_util.set_session_state(''P4111_DISPLAY_COLUMN'',          :P4111_DISPLAY_COLUMN,          false );',
'    htmldb_util.set_session_state(''P4111_GROUP_COLUMN'',            :P4111_GROUP_COLUMN,            false );',
'    htmldb_util.set_session_state(''P4111_ICON_COLUMN'',             :P4111_ICON_COLUMN,             false );',
'    htmldb_util.set_session_state(''P4111_DEFAULT_SORT_COLUMN'',     :P4111_DEFAULT_SORT_COLUMN,     false );',
'    htmldb_util.set_session_state(''P4111_ORACLE_TEXT_COLUMN'',      :P4111_ORACLE_TEXT_COLUMN,      false );',
'',
'    commit;',
'end;',
''))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>20999152427632630
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(301985835)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch Row from WWV_FLOW_LISTS_OF_VALUES$'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select 1 from wwv_flow_lists_of_values$',
'where security_group_id = :flow_security_group_id and',
'      flow_id = :FB_FLOW_ID and',
'      id = :F4000_P4111_ID) loop',
'wwv_flow_dml.fetch_row(',
'  p_table_owner => ''#OWNER#'',',
'  p_table_name  => ''WWV_FLOW_LISTS_OF_VALUES$'',',
'  p_rowid       => v(''F4000_P4111_ID''),',
'  p_alt_rowid   => ''ID'',',
'  p_dml_fetch_mode => ''F'');',
'exit;',
'end loop;',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error fetching row.'
,p_internal_uid=>301985835
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(9498262582275730)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'CREATE LOV COL INFO COLLECTION'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_lov_dev.create_coll_from_lov_columns(',
'    p_collection_name       => ''LOV_COL_INFO'',',
'    p_lov_id                => to_number(:F4000_P4111_ID) );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>9498262582275730
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(9496222651275710)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Convert Legacy SQL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_lov_dev.convert_legacy_lov(',
'    p_lov_id => to_number(:F4000_P4111_ID));'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error converting Legacy SQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(9496177960275709)
,p_process_success_message=>'Legacy SQL List of Values converted to SQL.'
,p_internal_uid=>9496222651275710
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(302985836)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process Row of WWV_FLOW_LISTS_OF_VALUES$'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select 1 from sys.dual',
'where :F4000_P4111_ID is null',
'or exists (select 1 from wwv_flow_lists_of_values$',
'                   where security_group_id = :flow_security_group_id and',
'      flow_id = :FB_FLOW_ID and',
'      id = :F4000_P4111_ID)) loop',
'wwv_flow_dml.process(',
'p_action => replace(replace(wwv_flow.g_request,',
'                            ''CREATE_STATIC'',''CREATE''),',
'                            ''REFRESH_COLUMN_INFO'',''UPDATE''),',
'p_table_owner => ''#OWNER#'',',
'p_table_name  => ''WWV_FLOW_LISTS_OF_VALUES$'',',
'p_rowid       => v(''F4000_P4111_ID''),',
'p_alt_rowid   => ''ID'');',
'exit;',
'end loop;',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error processing row.'
,p_process_when=>':REQUEST IN (''Create'',''ApplyChanges'',''REFRESH_COLUMN_INFO'',''CREATE_STATIC'')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Action processed.'
,p_internal_uid=>302985836
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4994633067587608)
,p_process_sequence=>45
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete List of Values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_lov_dev.delete_lov(',
'    p_lov_id         => :F4000_P4111_ID,',
'    p_application_id => :FB_FLOW_ID);'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'Delete'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>'List of values deleted.'
,p_internal_uid=>4994633067587608
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(87513231047656264)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Convert to Static LOV'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if substr(upper(ltrim(:P4111_LOV_QUERY_HIDDEN)), 1, 6) = ''STATIC'' then',
'        wwv_flow_lov_dev.create_named_lov (',
'            p_id      => :F4000_P4111_ID,',
'            p_flow_id => :FB_FLOW_ID,',
'            p_name    => :F4000_P4111_LOV_NAME,',
'            p_query   => :P4111_LOV_QUERY_HIDDEN );',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to convert LOV to static LOV.'
,p_process_when_button_id=>wwv_flow_imp.id(87511229484617914)
,p_process_success_message=>'LOV converted to static LOV.'
,p_internal_uid=>87513231047656264
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(410891997)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'cascade update to wwv_flow_step_items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'update wwv_flow_step_items ',
'  set named_lov = upper(:F4000_P4111_LOV_NAME)',
'  where ',
'   (upper(named_lov) = upper(:P4111_ORIG_LOV_NAME)',
'    or lov = ''.''||:F4000_P4111_ID||''.'')',
'  and flow_id = :FB_FLOW_ID',
'  and security_group_id = :flow_security_group_id;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(292985826)
,p_process_when=>'UPPER(:F4000_P4111_LOV_NAME) != UPPER(:P4111_ORIG_LOV_NAME)'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>410891997
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(202284215642232821)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh LOV'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_lov_dev.subscribe_lov (',
'    p_master_lov_id         => :F4000_P4111_REFERENCE_ID,',
'    p_subscribing_lov_id    => :F4000_P4111_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error refreshing List of Values.'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST = ''REFRESH_LOV''',
'or ( :REQUEST = ''ApplyChanges'' and :F4000_P4111_REFERENCE_ID is not null and :F4000_P4111_REFERENCE_ID_INIT is null )'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'List of Values refreshed. '
,p_internal_uid=>202284215642232821
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(202293227491242525)
,p_process_sequence=>90
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove reference id'
,p_process_sql_clob=>'wwv_flow_lov_dev.remove_lov_reference_id (:F4000_P4111_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error setting reference id to null.'
,p_process_when_button_id=>wwv_flow_imp.id(292985826)
,p_process_when=>'F4000_P4111_REFERENCE_ID'
,p_process_when_type=>'VALUE_OF_ITEM_IN_COND_1_EQ_COND_2'
,p_process_when2=>'0'
,p_internal_uid=>202293227491242525
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(567419190309994733)
,p_process_sequence=>100
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(712080000591813402)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Source: Static Values - Save Interactive Grid Data'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>567419190309994733
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(23198298652325507)
,p_process_sequence=>110
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(9499495849275742)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'UPDATE ADDITIONAL COLUMN INFO COLLECTION'
,p_attribute_01=>'PLSQL_CODE'
,p_attribute_04=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    c_lov_collection varchar2(12) := ''LOV_COL_INFO'';',
'begin',
'    case :APEX$ROW_STATUS',
'    when ''U'' then',
'        /* can''t use update_member as we have to pass all member attributes to avoid values being lost,',
'           however values for non-editable columns (column_name and data_type) are null',
'        wwv_flow_collection.update_member (',
'            p_collection_name   => c_lov_col_name,',
'            p_seq               => l_seq_id,',
'            p_c001              => :COLUMN_NAME,',
'            p_c002              => :DATA_TYPE,',
'            p_c003              => :LABEL,',
'            p_c004              => :COLUMN_ROLE,',
'            p_c005              => :DEFAULT_SORT );',
'        */',
'  ',
'        wwv_flow_collection.update_member_attribute (',
'            p_collection_name   => c_lov_collection,',
'            p_seq               => :SEQ_ID,',
'            p_attr_number       => 1,',
'            p_number_value       => :ID );',
'        wwv_flow_collection.update_member_attribute (',
'            p_collection_name   => c_lov_collection,',
'            p_seq               => :SEQ_ID,',
'            p_attr_number       => 2,',
'            p_number_value       => :DISPLAY_SEQUENCE );',
'        -- skip query_column_name: read only',
'        wwv_flow_collection.update_member_attribute (',
'            p_collection_name   => c_lov_collection,',
'            p_seq               => :SEQ_ID,',
'            p_attr_number       => 2,',
'            p_attr_value        => :HEADING );      ',
'        wwv_flow_collection.update_member_attribute (',
'            p_collection_name   => c_lov_collection,',
'            p_seq               => :SEQ_ID,',
'            p_attr_number       => 3,',
'            p_attr_value        => :FORMAT_MASK );',
'        -- skip data_type: read only  ',
'        wwv_flow_collection.update_member_attribute (',
'            p_collection_name   => c_lov_collection,',
'            p_seq               => :SEQ_ID,',
'            p_attr_number       => 5,',
'            p_attr_value        => :IS_VISIBLE );',
'        wwv_flow_collection.update_member_attribute (',
'            p_collection_name   => c_lov_collection,',
'            p_seq               => :SEQ_ID,',
'            p_attr_number       => 6,',
'            p_attr_value        => :IS_SEARCHABLE );',
'        wwv_flow_collection.update_member_attribute (',
'            p_collection_name   => c_lov_collection,',
'            p_seq               => :SEQ_ID,',
'            p_attr_number       => 7,',
'            p_attr_value        => :COLUMN_COMMENT );',
'    when ''D'' then  ',
'        wwv_flow_collection.delete_member (',
'            p_collection_name   => c_lov_collection,',
'            p_seq               => :SEQ_ID );',
'',
'    end case;',
'end;'))
,p_attribute_05=>'N'
,p_attribute_06=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P4111_SOURCE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_process_when2=>'STATIC'
,p_internal_uid=>23198298652325507
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(23201242310325537)
,p_process_sequence=>120
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'UPDATE LOV COLUMN INFO'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_lov_dev.save_column_info_from_coll(',
'    p_collection_name       => ''LOV_COL_INFO'',',
'    p_lov_id                => nv(''F4000_P4111_ID'') );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(292985826)
,p_process_when=>'P4111_SOURCE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_process_when2=>'STATIC'
,p_internal_uid=>23201242310325537
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1663630736963720)
,p_process_sequence=>130
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Sync REST Data Source Parameters'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if :P4111_USE_LOCAL_TABLE = ''Y'' and coalesce( :P4111_OLD_USE_LOCAL_TABLE, ''N'' ) = ''N'' then',
'        --',
'        -- use local sync table was enabled and it was disabled before. So we have to delete all ',
'        -- component parameters; as data comes directly from the sync table.',
'        --',
'        delete wwv_flow_web_src_comp_params',
'         where security_group_id = :FLOW_SECURITY_GROUP_ID',
'           and flow_id           = :FB_FLOW_ID',
'           and shared_lov_id     = :F4000_P4111_ID;',
'',
'    elsif coalesce( :P4111_USE_LOCAL_TABLE, ''N'' ) = ''N'' and :P4111_OLD_USE_LOCAL_TABLE = ''Y'' then',
'        --',
'        -- use local sync table was disabled and it was enabled before. An LOV invocation',
'        -- must perform a REST call, so we need to initialize REST source component parameters.',
'        --',
'        wwv_flow_web_src_dev.add_web_source_params(',
'            p_flow_id              => :FB_FLOW_ID,',
'            p_web_source_module_id => :P4111_WEB_SRC_MODULE_ID,',
'            p_array_column_id      => :P4111_WEB_SRC_ARRAY_COL_ID,',
'            p_database_operation   => wwv_flow_plugin_api.c_db_operation_fetch_rows,',
'            p_shared_lov_id        => :F4000_P4111_ID );',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(292985826)
,p_process_when=>'P4111_WEB_SRC_MODULE_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>1663630736963720
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(10677207222253995)
,p_process_sequence=>140
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Unsubscribe'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.unsubscribe_component (',
'    p_component_type  => wwv_flow_copy_metadata.c_lov,',
'    p_component_id    => :F4000_P4111_ID,',
'    p_app_id          => :FB_FLOW_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(5730127734070716)
,p_process_success_message=>'List of values is no longer subscribed to its master list of values.'
,p_internal_uid=>10677207222253995
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(6000764141547803)
,p_process_sequence=>20
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_region_id=>wwv_flow_imp.id(9499495849275742)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Deleted columns in Column Mapping'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- if any row is deleted from additional display columns IG, ensure the column is not referred in column mapping',
'if :APEX$ROW_STATUS = ''D'' and :COLUMN_NAME in ( :P4111_RETURN_COLUMN,',
'                      :P4111_DISPLAY_COLUMN,',
'                      :P4111_DEFAULT_SORT_COLUMN,',
'                      :P4111_GROUP_COLUMN,',
'                      :P4111_ICON_COLUMN,',
'                      :P4111_ORACLE_TEXT_COLUMN ) then',
'    wwv_flow_error.add_error(',
'        p_message          => wwv_flow_lang.message( ''LOV.CANT_DELETE_ADDL_COLUMN'', :COLUMN_NAME ),',
'        p_display_location => wwv_flow_error_api.c_inline_in_notification );',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(292985826)
,p_process_when=>':P4111_DEL_COL_COUNT < :P4111_ADDITIONAL_COL_COUNT'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>6000764141547803
,p_process_comment=>'Ideally this should be a validation. But we can''t execute validations for IG deleted rows, ref Bug 28257516. This process should be executed only when some of the rows are getting deleted. When all rows are being deleted, then we should not run this '
||'check.'
);
end;
/
prompt --application/pages/page_04113
begin
wwv_flow_imp_page.create_page(
 p_id=>4113
,p_name=>'Static Lists of Values'
,p_alias=>'STATIC-LISTS-OF-VALUES'
,p_page_mode=>'MODAL'
,p_step_title=>'Create/Edit Static List of Values Entry'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213211113434774960)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';',
'',
'//-->',
'</script>'))
,p_page_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_read_only_when=>'P4113_REFERENCE_ID'
,p_help_text=>'bldapp_lov.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(63182855698)
,p_plug_name=>'Entry'
,p_region_name=>'E'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_plug_query_show_nulls_as=>'(null)'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'generated 13-JUN-2000 11:36:34'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(63205897861)
,p_plug_name=>'Conditions'
,p_region_name=>'C'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>130
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_plug_query_show_nulls_as=>'(null)'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(63243999508)
,p_name=>'Existing List of Values Entries'
,p_template=>wwv_flow_imp.id(689970285456172024)
,p_display_sequence=>160
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select lov_disp_sequence,lov_disp_value,lov_return_value',
'from wwv_flow_list_of_values_data',
'where lov_id = :F4000_P4113_LOV_ID',
'order by lov_disp_sequence'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>150
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48848907653772539)
,p_query_column_id=>1
,p_column_alias=>'LOV_DISP_SEQUENCE'
,p_column_display_sequence=>1
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48849027974772540)
,p_query_column_id=>2
,p_column_alias=>'LOV_DISP_VALUE'
,p_column_display_sequence=>2
,p_column_heading=>'Display'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48849113018772540)
,p_query_column_id=>3
,p_column_alias=>'LOV_RETURN_VALUE'
,p_column_display_sequence=>3
,p_column_heading=>'Return'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5358920086062640)
,p_plug_name=>'button bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(16848629696670874)
,p_plug_name=>'Globalization'
,p_region_name=>'G'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>150
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46259112084679012)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(145747221614947109)
,p_plug_name=>'Static Lists of Values'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Edit display and return values for a List of Values entry.</p>'
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'R:L:L'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(167154021724274310)
,p_plug_name=>'Configuration'
,p_region_name=>'CONFIG'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>140
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(620050103042392721)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(29434107863295859)
,p_plug_display_sequence=>170
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from  WWV_FLOW_LIST_OF_VALUES_DATA',
'where id = :F4000_P4113_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :F4000_P4113_ID,',
'      p_component_type => ''List of Values'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'F4000_P4113_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(63183855701)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(5358920086062640)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(63184855701)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(5358920086062640)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'',''DELETE'');'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P4113_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(63185855701)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(5358920086062640)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P4113_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(63249147840)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(5358920086062640)
,p_button_name=>'CREATE_AGAIN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Create and Create Another'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P4113_ID is null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(63186855702)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(5358920086062640)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P4113_ID is null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(63250160883)
,p_branch_action=>'4113'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>60
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'CREATE_AGAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(63187855704)
,p_name=>'F4000_P4113_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(63182855698)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(63188855706)
,p_name=>'F4000_P4113_LOV_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(63182855698)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&F4000_P4111_ID.'
,p_prompt=>'Lov Id'
,p_source=>'LOV_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(63189855707)
,p_name=>'F4000_P4113_LOV_DISP_SEQUENCE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(63182855698)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&F4000_P4113_LOV_DISP_SEQUENCE.'
,p_prompt=>'Sequence'
,p_source=>'LOV_DISP_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Specify the sequence for this component.  The sequence determines the order of evaluation.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(63190855707)
,p_name=>'F4000_P4113_LOV_DISP_VALUE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(63182855698)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Display Value'
,p_source=>'LOV_DISP_VALUE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'This text is displayed to the user.  The return value is returned.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(63191855708)
,p_name=>'F4000_P4113_LOV_RETURN_VALUE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(63182855698)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Return Value'
,p_source=>'LOV_RETURN_VALUE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify the return value for this LOV entry.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(63192855709)
,p_name=>'F4000_P4113_LOV_DISP_COND_TYPE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(63205897861)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Condition Type'
,p_source=>'LOV_DISP_COND_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CONDITION_LIST'
,p_named_lov=>'STANDARD_CONDITION_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(13602414170805697)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Condition -'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'<p>Select a condition type from the list that must be met in order for this component to be rendered processed.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'F4000_P4113_LOV_DISP_COND'
,p_attribute_02=>'F4000_P4113_LOV_DISP_COND2'
,p_attribute_04=>'F4000_P4113_LOV_DISP_COND_CHECK'
,p_attribute_06=>'CONDITION'
,p_attribute_07=>'F4000_P4113_LOV_DISP_COND_LANG'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(63193855709)
,p_name=>'F4000_P4113_LOV_DISP_COND'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(63205897861)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Expression 1'
,p_source=>'LOV_DISP_COND'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>This attribute allows you to conditionally control whether or not a  component is rendered or processed.  Enter values in this attribute based on the specific condition type selected.  The component will be rendered or processed if the specified c'
||'ondition is met.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(63194855710)
,p_name=>'F4000_P4113_REQUIRED_PATCH'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(167154021724274310)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Build Option'
,p_source=>'REQUIRED_PATCH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PATCHES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(patch_name) pn, id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'', wwv_flow_escape.html(patch_name))||',
'''} '' pn,0-id id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by pn'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Build Option -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select a build option for this component.</p>',
'<p>Build options are predefined settings that determine whether or not  components within an application are enabled.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(116264468029)
,p_name=>'F4000_P4113_TEMP_SEQ'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(63182855698)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2006656883568365)
,p_name=>'F4000_P4113_LOV_DISP_COND_LANG'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(63205897861)
,p_prompt=>'Language'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select a language that is used to evaluate the entered programming code.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(16495033644178011)
,p_name=>'P4113_REFERENCE_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(63182855698)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(16664818316645684)
,p_name=>'P4113_LOV_TEMPLATE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(16848629696670874)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Template'
,p_source=>'LOV_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>8
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Use this optional template when developing list of values entries that need to be translated, and you wish to simplify the translation text.  Use the #DISPLAY_VALUE# substitution string.  The display value will be this attribute with the display valu'
||'e substituted for all occurrences of the substitution string #DISPLAY_VALUE#.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18143617754868675)
,p_name=>'F4000_P4113_LOV_DISP_COND2'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(63205897861)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Expression 2'
,p_source=>'LOV_DISP_COND2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Some condition types require two expressions for comparison.  Enter the second expression or item here.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(75394607108090542)
,p_name=>'P4113_ID_NEXT'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(5358920086062640)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(75395028902090543)
,p_name=>'P4113_ID_PREV'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(5358920086062640)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(75395409777090546)
,p_name=>'P4113_ID_COUNT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(63182855698)
,p_prompt=>'Static List of Values Entry: '
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_display_when=>'F4000_P4113_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies the shared LOV.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(75401929560144771)
,p_name=>'P4113_RETURN_TO_PAGE'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(145747221614947109)
,p_prompt=>'Stay on page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select this checkbox to stay on this page after applying changes.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'YES'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(435040326620654782)
,p_name=>'F4000_P4113_LOV_DISP_COND_CHECK'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(63205897861)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Do not validate code (parse code at runtime only).'
,p_source=>'NULL'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(116281665962)
,p_computation_sequence=>20
,p_computation_item=>'F4000_P4113_LOV_DISP_SEQUENCE'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl( max( lov_disp_sequence ), 0 ) + 10 as seq',
'  from wwv_flow_list_of_values_data',
' where lov_id = :F4000_P4111_ID'))
,p_computation_error_message=>'Unable to compute item value.'
,p_compute_when=>'F4000_P4113_ID'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(185781508782421843)
,p_validation_name=>'sequence not null'
,p_validation_sequence=>10
,p_validation=>'F4000_P4113_LOV_DISP_SEQUENCE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Sequence must be specified.'
,p_validation_condition=>'Create, Apply Changes, CREATE_AGAIN'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(63189855707)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(185782107527430954)
,p_validation_name=>'sequence is numeric'
,p_validation_sequence=>20
,p_validation=>'F4000_P4113_LOV_DISP_SEQUENCE'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Sequence must be numeric.'
,p_validation_condition=>'Create, Apply Changes, CREATE_AGAIN'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(63189855707)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(185782702810438973)
,p_validation_name=>'display value required'
,p_validation_sequence=>30
,p_validation=>'F4000_P4113_LOV_DISP_VALUE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Display value must be specified.'
,p_validation_condition=>'Create, Apply Changes, CREATE_AGAIN'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(63190855707)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(397299812269483058)
,p_name=>'ENABLE PREVIOUS'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P4113_ID_PREV'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(397300218156484728)
,p_name=>'ENABLE NEXT'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P4113_ID_NEXT'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1479591354673265402)
,p_name=>'Close Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(63183855701)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1479591414906265403)
,p_event_id=>wwv_flow_imp.id(1479591354673265402)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(63195855710)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_LIST_OF_VALUES_DATA'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_LIST_OF_VALUES_DATA'
,p_attribute_03=>'F4000_P4113_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error fetching row.'
,p_internal_uid=>63195855710
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(75396423970090553)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_PAGINATION'
,p_process_name=>'Get Next or Previous Primary Key Value'
,p_attribute_02=>'WWV_FLOW_LIST_OF_VALUES_DATA'
,p_attribute_03=>'F4000_P4113_ID'
,p_attribute_04=>'ID'
,p_attribute_07=>'LOV_DISP_SEQUENCE'
,p_attribute_08=>'LOV_DISP_VALUE'
,p_attribute_09=>'P4113_ID_NEXT'
,p_attribute_10=>'P4113_ID_PREV'
,p_attribute_13=>'P4113_ID_COUNT'
,p_attribute_14=>'flow_id = :fb_flow_id and lov_id = :F4000_P4111_ID'
,p_process_error_message=>'Unable to run Get Next or Previous Primary Key Value process.'
,p_internal_uid=>75396423970090553
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(63196855712)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_LIST_OF_VALUES_DATA'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_LIST_OF_VALUES_DATA'
,p_attribute_03=>'F4000_P4113_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error processing row.'
,p_process_success_message=>'Action processed.'
,p_internal_uid=>63196855712
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1479591228851265401)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE_AGAIN'
,p_process_when_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_internal_uid=>1479591228851265401
);
end;
/
prompt --application/pages/page_04120
begin
wwv_flow_imp_page.create_page(
 p_id=>4120
,p_name=>'Copy Application Item'
,p_alias=>'COPY-APPLICATION-ITEM'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Application Item'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'auto'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_protection_level=>'C'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(58233456551415310)
,p_plug_name=>'Wizard Button'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(242974439199558199)
,p_plug_name=>'Copy Application Item'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7401122016606440)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(58233456551415310)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4410191549904104)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(58233456551415310)
,p_button_name=>'COPY_FROM_ANOTHER'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Copy from another app'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:4120:&SESSION.::&DEBUG.:4120:P4120_COPY_SOURCE:OTHER'
,p_button_condition=>'P4120_COPY_SOURCE'
,p_button_condition2=>'THIS'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_button_css_classes=>'a-Button--noUI'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7401550251606441)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(58233456551415310)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy Application Item'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(7414282308606496)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(7401550251606441)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11809004608749071)
,p_name=>'P4120_NEW_ITEM_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(242974439199558199)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(26816401309540284)
,p_name=>'P4120_SUBSCRIBE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(242974439199558199)
,p_item_default=>'Y'
,p_prompt=>'Subscribe'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>'P4120_COPY_SOURCE'
,p_display_when2=>'OTHER'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'While copying the application item, you can also subscribe to it. Set Subscribe to <strong>On</strong> to subscribe to the application item.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(27116000112618881)
,p_name=>'P4120_COPY_SOURCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(242974439199558199)
,p_item_default=>'THIS'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(223484158279480667)
,p_name=>'P4120_COPY_FROM_APPLICATION_ID'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(242974439199558199)
,p_prompt=>'Application'
,p_source=>'&FB_FLOW_ID.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST OTHER FLOWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'  from   wwv_flow_visible_flows f',
' where id != :FB_FLOW_ID',
'   and build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'order by 2'))
,p_lov_cascade_parent_items=>'P4120_COPY_SOURCE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>'P4120_COPY_SOURCE'
,p_display_when2=>'OTHER'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Select the application from which you want to copy an application item.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(242994659638598051)
,p_name=>'P4120_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(242974439199558199)
,p_prompt=>'New Application Item Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the name of the application item. Application item name must be unique within the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_attribute_06=>'UPPER'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(242997975914602757)
,p_name=>'P4120_ID'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(242974439199558199)
,p_prompt=>'Copy Application Item'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d,',
'       id r',
'  from wwv_flow_items',
' where flow_id           = :P4120_COPY_FROM_APPLICATION_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
' order by upper(name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Application Item -'
,p_lov_cascade_parent_items=>'P4120_COPY_FROM_APPLICATION_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_read_only_when=>'P4120_ID'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify an application item to copy.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'Y'
,p_attribute_06=>'0'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(7406951605606484)
,p_validation_name=>'P4120_NAME not null'
,p_validation_sequence=>10
,p_validation=>'P4120_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>':P4120_COPY_SOURCE = ''THIS'' or :P4120_SUBSCRIBE = ''N'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(7401550251606441)
,p_associated_item=>wwv_flow_imp.id(242994659638598051)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(7407357700606485)
,p_validation_name=>'P4120_NAME unique'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not wwv_flow_builder.is_item_name_used(',
'        p_flow => :FB_FLOW_ID,',
'        p_name => :P4120_NAME )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Item name is already used by another application or page item. Please enter a different name.'
,p_validation_condition=>':P4120_COPY_SOURCE = ''THIS'' or :P4120_SUBSCRIBE = ''N'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(7401550251606441)
,p_associated_item=>wwv_flow_imp.id(242994659638598051)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(8160333172443212)
,p_validation_name=>'Valid Item Name'
,p_validation_sequence=>30
,p_validation=>'P4120_NAME'
,p_validation_type=>'ITEM_IS_ALPHANUMERIC'
,p_error_message=>'Name "&P4120_NAME." may contain only alphanumeric characters and underscores "_".'
,p_validation_condition=>':P4120_COPY_SOURCE = ''THIS'' or :P4120_SUBSCRIBE = ''N'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(7401550251606441)
,p_associated_item=>wwv_flow_imp.id(242994659638598051)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(7407775460606485)
,p_validation_name=>'No duplicate subscription'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_items',
' where security_group_id = :FLOW_SECURITY_GROUP_ID ',
'   and flow_id           = :FB_FLOW_ID ',
'   and reference_id      = :P4120_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'There is another application item in this application that is subscribed to the same master. Please select another master application item.'
,p_validation_condition=>'P4120_SUBSCRIBE'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(7401550251606441)
,p_associated_item=>wwv_flow_imp.id(242997975914602757)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(7413218860606494)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(7401122016606440)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7413720510606495)
,p_event_id=>wwv_flow_imp.id(7413218860606494)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(7408462354606488)
,p_name=>'Toggle P4120_NAME display'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4120_SUBSCRIBE'
,p_condition_element=>'P4120_SUBSCRIBE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_cond=>'P4120_COPY_SOURCE'
,p_display_when_cond2=>'OTHER'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7408940904606491)
,p_event_id=>wwv_flow_imp.id(7408462354606488)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4120_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(7409474754606492)
,p_event_id=>wwv_flow_imp.id(7408462354606488)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4120_NAME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4409881306904101)
,p_name=>'Set New Name'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4120_ID'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_cond=>'P4120_COPY_SOURCE'
,p_display_when_cond2=>'OTHER'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4409903659904102)
,p_event_id=>wwv_flow_imp.id(4409881306904101)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4120_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'apex.item("P4120_ID").displayValueFor($v("P4120_ID"))'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(7408004397606485)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Application Item'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P4120_NEW_ITEM_ID := wwv_flow_copy_metadata.copy_component (',
'    p_component_type       => wwv_flow_copy_metadata.c_app_item,',
'    p_from_id              => :P4120_ID,',
'    p_from_app_id          => :P4120_COPY_FROM_APPLICATION_ID,',
'    p_to_app_id            => :FB_FLOW_ID,',
'    p_new_name             => :P4120_NAME,',
'    p_subscribe            => :P4120_SUBSCRIBE = ''Y'' );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to copy the application item.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(7401550251606441)
,p_process_success_message=>'Application item copied.'
,p_internal_uid=>7408004397606485
);
end;
/
prompt --application/pages/page_04207
begin
wwv_flow_imp_page.create_page(
 p_id=>4207
,p_name=>'Application Processes'
,p_alias=>'APPLICATION-PROCESSES'
,p_step_title=>'Application Processes'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(91429205691059841)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_proc.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(342616740)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--sideRegion:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Application Processes run PL/SQL logic at specific points for each page in an application or as defined by the conditions under which they are set to fire.  Note that "Ajax Callback" processes fire only when called from Ajax or by "Run Ajax Callba'
||'ck" processes defined for pages.</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4034623932624575)
,p_plug_name=>'Navigate'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(4020210037479119)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Application Processes'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9231155424553929)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(4433238684424109)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47814230554191364)
,p_plug_name=>'Application Processes'
,p_region_template_options=>'a-IRR-region--responsiveIconView'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select p.process_sequence,',
'       p.process_point,',
'       p.process_name,',
'       decode( greatest(sys.dbms_lob.getlength(p.process_sql_clob),200),',
'          150,sys.dbms_lob.substr(p.process_sql_clob,2000,1),',
'          sys.dbms_lob.substr(p.process_sql_clob,200,1)||'' ...'' )',
'          process_sql_clob,',
'       p.id,',
'       ''icon-sc-app-process'' icon,',
'       wwv_flow_page_api.get_url(',
'           p_page        => 4309,',
'           p_clear_cache => 4309,',
'           p_items       => ''F4000_P4309_ID'',',
'           p_values      => p.id ) edit_link,',
'       replace(p.process_name,''_'','' '') icon_image_alt_text,',
'       p.security_scheme,',
'       nvl(p.last_updated_by,p.created_by) last_updated_by,',
'       nvl(p.last_updated_on,p.created_on) last_updated_on,',
'       --',
'       case when p.reference_id is not null then',
'           coalesce ( to_char( master.flow_id ),',
'                       wwv_flow_lang_dev.builder_message( ''SUBSCRIBED_FROM.NONEXISTING_MASTER'' ) )',
'       end as subscribed_from,',
'       ( select case when count(*) > 0 then count(*) end',
'           from wwv_flow_processing sub',
'          where sub.reference_id      = p.id',
'            and sub.security_group_id = :FLOW_SECURITY_GROUP_ID',
'       ) as subscribers,',
'       case when p.reference_id is not null then',
'           case',
'               when master.version_scn = p.version_scn then',
'                   wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_UP_TO_DATE'')',
'               when master.version_scn != p.version_scn then',
'                   wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_NEEDS_REFRESH'')',
'               else',
'                   wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_UNKNOWN'')',
'           end',
'       end subscription_status,',
'       --',
'       null as actions',
' from wwv_flow_processing p,',
'      wwv_flow_processing master',
' where p.flow_id           = :FB_FLOW_ID',
'   and p.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and p.reference_id      = master.id (+)',
'   and p.security_group_id = master.security_group_id (+)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(47814307723191364)
,p_name=>'Application Processes'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#EDIT_LINK#" class="a-IRR-icon"><span class="a-Icon #ICON#"></span><span class="a-IRR-iconName">#ICON_IMAGE_ALT_TEXT#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'SBKENNED'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47814518445191373)
,p_db_column_name=>'PROCESS_SEQUENCE'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Sequence'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47814616624191379)
,p_db_column_name=>'PROCESS_POINT'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Point'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(179311318624565491)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47814705631191381)
,p_db_column_name=>'PROCESS_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Name'
,p_column_link=>'f?p=&APP_ID.:4309:&SESSION.::&DEBUG.::F4000_P4309_ID:#ID#'
,p_column_linktext=>'#PROCESS_NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47814821233191381)
,p_db_column_name=>'PROCESS_SQL_CLOB'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Text'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47814932002191382)
,p_db_column_name=>'ID'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47819912573240062)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Edit Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47820023832240063)
,p_db_column_name=>'ICON_IMAGE_ALT_TEXT'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Icon Image Alt Text'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47820317595240064)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47820423338240067)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(646445089785466043)
,p_db_column_name=>'ICON'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'ICON'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(620834540482373108)
,p_db_column_name=>'SECURITY_SCHEME'
,p_display_order=>23
,p_column_identifier=>'N'
,p_column_label=>'Authorization Scheme'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(283664112341)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(8161529074443224)
,p_db_column_name=>'SUBSCRIBED_FROM'
,p_display_order=>33
,p_column_identifier=>'O'
,p_column_label=>'Subscribed From'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(8161669775443225)
,p_db_column_name=>'SUBSCRIBERS'
,p_display_order=>43
,p_column_identifier=>'P'
,p_column_label=>'Subscribers'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(6610047703558805)
,p_db_column_name=>'SUBSCRIPTION_STATUS'
,p_display_order=>63
,p_column_identifier=>'R'
,p_column_label=>'Subscription Status'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2182050988145910)
,p_db_column_name=>'ACTIONS'
,p_display_order=>73
,p_column_identifier=>'S'
,p_column_label=>'Copy'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'TMPL_THEME_3$ACTIONS'
,p_column_alignment=>'CENTER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'ACTIONS_WRAP', 'N',
  'STYLE', 'b-InlineActions--simple')).to_clob
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(47815210532192150)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_type=>'REPORT'
,p_report_alias=>'1306419666536647'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_view_mode=>'REPORT'
,p_report_columns=>'PROCESS_SEQUENCE:PROCESS_NAME:PROCESS_POINT:PROCESS_SQL_CLOB:SECURITY_SCHEME:SUBSCRIBED_FROM:SUBSCRIPTION_STATUS:SUBSCRIBERS::ACTIONS'
,p_sort_column_1=>'PROCESS_NAME'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(188876303146831279)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(47814230554191364)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4207:&SESSION.::&DEBUG.:4207,RIR::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(90816218739334112)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(47814230554191364)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:147:&SESSION.::&DEBUG.:147,148,150::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(591284026)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'4207'
,p_computation_error_message=>'Unable to compute item value.'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(590026245805029674)
,p_name=>'Create Button - Dialog Closed'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(90816218739334112)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(590026508359029674)
,p_event_id=>wwv_flow_imp.id(590026245805029674)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6623852024951168)
,p_name=>'Refresh Subscriptions'
,p_event_sequence=>20
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(9231155424553929)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6624299901951170)
,p_event_id=>wwv_flow_imp.id(6623852024951168)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(47814230554191364)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6624786602951171)
,p_event_id=>wwv_flow_imp.id(6623852024951168)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ( this.data.successMessage ) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
);
wwv_flow_imp_page.create_component_action(
 p_id=>wwv_flow_imp.id(2182139323145911)
,p_ir_column_id=>wwv_flow_imp.id(2182050988145910)
,p_position_id=>wwv_flow_imp.id(214437533860142316)
,p_display_sequence=>10
,p_template_id=>wwv_flow_imp.id(214438625365151034)
,p_label=>'Copy'
,p_link_target_type=>'REDIRECT_PAGE'
,p_link_target=>'f?p=&APP_ID.:4209:&SESSION.::&DEBUG.:4209:P4209_COPY_SOURCE,P4209_ID,P4209_COPY_FROM_APPLICATION_ID:THIS,#ID#,&FB_FLOW_ID.'
,p_button_display_type=>'ICON'
,p_icon_css_classes=>'icon-copy'
,p_is_hot=>false
,p_show_as_disabled=>false
);
end;
/
prompt --application/pages/page_04209
begin
wwv_flow_imp_page.create_page(
 p_id=>4209
,p_name=>'Copy Application Process'
,p_alias=>'COPY-APPLICATION-PROCESS'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Application Process'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'auto'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_protection_level=>'C'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(60738446295331681)
,p_plug_name=>'Wizard Button'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(245479428943474570)
,p_plug_name=>'Copy Application Process'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2505591505916418)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(60738446295331681)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4410638478904109)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(60738446295331681)
,p_button_name=>'COPY_FROM_ANOTHER'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Copy from another app'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:4209:&SESSION.::&DEBUG.:4209:P4209_COPY_SOURCE:OTHER'
,p_button_condition=>'P4209_COPY_SOURCE'
,p_button_condition2=>'THIS'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_button_css_classes=>'a-Button--noUI'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2505958191916420)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(60738446295331681)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy Application Process'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2519042663916467)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2505958191916420)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14315713782665499)
,p_name=>'P4209_NEW_PROCESS_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(245479428943474570)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(29323110483456712)
,p_name=>'P4209_SUBSCRIBE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(245479428943474570)
,p_item_default=>'Y'
,p_prompt=>'Subscribe'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>'P4209_COPY_SOURCE'
,p_display_when2=>'OTHER'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'While copying the application process, you can also subscribe to it. Set Subscribe to <strong>On</strong> to subscribe to the application process.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(29622709286535309)
,p_name=>'P4209_COPY_SOURCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(245479428943474570)
,p_item_default=>'THIS'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(225990867453397095)
,p_name=>'P4209_COPY_FROM_APPLICATION_ID'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(245479428943474570)
,p_prompt=>'Application'
,p_source=>'&FB_FLOW_ID.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST OTHER FLOWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'  from   wwv_flow_visible_flows f',
' where id != :FB_FLOW_ID',
'   and build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'order by 2'))
,p_lov_cascade_parent_items=>'P4209_COPY_SOURCE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>'P4209_COPY_SOURCE'
,p_display_when2=>'OTHER'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Select the application from which you want to copy an application process.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(245501368812514479)
,p_name=>'P4209_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(245479428943474570)
,p_prompt=>'New Application Process Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the name of the application process.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_attribute_06=>'UPPER'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(245504685088519185)
,p_name=>'P4209_ID'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(245479428943474570)
,p_prompt=>'Copy Application Process'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select process_name d,',
'       id r',
'  from wwv_flow_processing',
' where flow_id           = :P4209_COPY_FROM_APPLICATION_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
' order by upper(process_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Application Process -'
,p_lov_null_value=>'0'
,p_lov_cascade_parent_items=>'P4209_COPY_FROM_APPLICATION_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_read_only_when=>'P4209_ID'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify an application process to copy.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'Y'
,p_attribute_06=>'0'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2511309337916455)
,p_validation_name=>'P4209_NAME not null'
,p_validation_sequence=>10
,p_validation=>'P4209_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>':P4209_COPY_SOURCE = ''THIS'' or :P4209_SUBSCRIBE = ''N'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(2505958191916420)
,p_associated_item=>wwv_flow_imp.id(245501368812514479)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4023047869933466)
,p_validation_name=>'Process name unique'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_processing',
' where security_group_id = :WORKSPACE_ID ',
'   and flow_id           = :FB_FLOW_ID ',
'   and process_name      = :P4209_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#LABEL# must be unique'
,p_validation_condition=>'P4209_SUBSCRIBE'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(2505958191916420)
,p_associated_item=>wwv_flow_imp.id(245501368812514479)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4024135128952275)
,p_validation_name=>'Subscribed process name unique'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_processing',
' where security_group_id = :WORKSPACE_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and process_name      = (',
'       select process_name ',
'         from wwv_flow_processing',
'        where security_group_id = :WORKSPACE_ID',
'          and flow_id           = :P4209_COPY_FROM_APPLICATION_ID',
'          and id                = :P4209_ID )'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Unable to subscribe, the application process already exists.'
,p_validation_condition=>'P4209_SUBSCRIBE'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(2505958191916420)
,p_associated_item=>wwv_flow_imp.id(29622709286535309)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1409412984537196)
,p_validation_name=>'No duplicate subscription'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_processing',
' where security_group_id = :WORKSPACE_ID ',
'   and flow_id           = :FB_FLOW_ID ',
'   and reference_id      = :P4209_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'There is another application process in this application that is subscribed to the same master. Please select another master application process.'
,p_validation_condition=>'P4209_SUBSCRIBE'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(2505958191916420)
,p_associated_item=>wwv_flow_imp.id(245504685088519185)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2513251398916459)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2505591505916418)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2513739677916462)
,p_event_id=>wwv_flow_imp.id(2513251398916459)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2517551780916465)
,p_name=>'Toggle P4209_NAME display'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4209_SUBSCRIBE'
,p_condition_element=>'P4209_SUBSCRIBE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_cond=>'P4209_COPY_SOURCE'
,p_display_when_cond2=>'OTHER'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2518055504916466)
,p_event_id=>wwv_flow_imp.id(2517551780916465)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4209_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2518512820916466)
,p_event_id=>wwv_flow_imp.id(2517551780916465)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4209_NAME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4410443449904107)
,p_name=>'Set New Name'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4209_ID'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_cond=>'P4209_COPY_SOURCE'
,p_display_when_cond2=>'OTHER'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4410508040904108)
,p_event_id=>wwv_flow_imp.id(4410443449904107)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4209_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'apex.item("P4209_ID").displayValueFor($v("P4209_ID"))'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2512858607916457)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Application Process'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P4209_NEW_PROCESS_ID := wwv_flow_copy_metadata.copy_component (',
'    p_component_type       => wwv_flow_copy_metadata.c_app_process,',
'    p_from_id              => :P4209_ID,',
'    p_from_app_id          => :P4209_COPY_FROM_APPLICATION_ID,',
'    p_to_app_id            => :FB_FLOW_ID,',
'    p_new_name             => :P4209_NAME,',
'    p_subscribe            => :P4209_SUBSCRIBE = ''Y'' );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to copy the application process.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2505958191916420)
,p_process_success_message=>'Application process copied.'
,p_internal_uid=>2512858607916457
);
end;
/
prompt --application/pages/page_04303
begin
wwv_flow_imp_page.create_page(
 p_id=>4303
,p_name=>'Create / Edit Application Item'
,p_alias=>'CREATE-EDIT-APPLICATION-ITEM'
,p_step_title=>'Create / Edit Application Item'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(91429205691059841)
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_read_only_when=>'P4303_REFERENCE_ID'
,p_help_text=>'bldapp_item_app.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(454431825)
,p_plug_name=>'Application Item'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_04'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_ITEMS'
,p_query_where=>'security_group_id = :WORKSPACE_ID'
,p_include_rowid_column=>false
,p_is_editable=>false
,p_plug_source_type=>'NATIVE_FORM'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(455433462)
,p_plug_name=>'Name'
,p_region_name=>'N'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>' '
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(456444407)
,p_plug_name=>'Application Items'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Application level items are used to maintain session state. Application items can be set using computations, processes, or by passing values on a URL.</p><p>Use "On New Instance" computations to set the value of items once for a session. Use appli'
||'cation items to maintain session state that is not displayed and is not specific to any one page.</p><p>When Application Item is subscribed, then it is not possible to change any data.</p>',
'<p>Deletion of the <strong>master</strong> application item automatically clears all application item references from subscribing application items.</p>'))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8831810191006473)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(4419912902081041)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
,p_plug_display_condition_type=>'ITEM_IS_NULL'
,p_plug_display_when_condition=>'F4000_P4303_ID'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(12559831346493637)
,p_plug_name=>'Subscription'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>35
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'F4000_P4303_ID'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'WWV_FLOW_ITEMS',
  'attribute_02', 'NAME',
  'attribute_03', 'F4000_P4303_ID',
  'attribute_04', 'P4303_REFERENCE_ID',
  'attribute_05', 'SUBSCRIBE_APP_ITEM',
  'attribute_06', 'VERSION_SCN')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(17312310527965891)
,p_plug_name=>'Security'
,p_region_name=>'S'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46261714381679017)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>22
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(62049781536334954)
,p_plug_name=>'Configuration'
,p_region_name=>'C'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>5000
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_row_count_max=>5000
,p_plug_query_show_nulls_as=>'(null)'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(62050080142337727)
,p_plug_name=>'Comments'
,p_region_name=>'CO'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(615490023292207195)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_imp.id(29434107863295859)
,p_plug_display_sequence=>100
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from WWV_FLOW_ITEMS',
'where id = :F4000_P4303_ID and security_group_id = :WORKSPACE_ID) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :F4000_P4303_ID,',
'      p_component_type => ''Application Item'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'F4000_P4303_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8153916784351034)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_imp.id(12559831346493637)
,p_button_name=>'UNSUBSCRIBE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Unsubscribe'
,p_button_position=>'EDIT'
,p_button_condition=>':P4303_REFERENCE_ID is not null and :P4303_SUBSCRIBED_COMP_GRP = ''N'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8153105995351031)
,p_button_sequence=>110
,p_button_plug_id=>wwv_flow_imp.id(12559831346493637)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Refresh Application Item'
,p_button_position=>'EDIT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P4303_REFERENCE_ID is not null ',
'and ( :P4303_VERSION_SCN != :P4303_MASTER_VERSION_SCN or :P4303_VERSION_SCN is null )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8153584135351033)
,p_button_sequence=>120
,p_button_plug_id=>wwv_flow_imp.id(12559831346493637)
,p_button_name=>'PUBLISH'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Publish'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.:149:F4000_P149_ID,F4000_P149_TEMPLATE_TYPE,F4000_P149_PAGE_ID:&F4000_P4303_ID.,APP_ITEM,4303'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * ',
'  from wwv_flow_items',
' where reference_id      = :F4000_P4303_ID ',
'   and security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(21934143985)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(454431825)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(21935143985)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(454431825)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_confirm_message=>'&DELETE_MSG.'
,p_confirm_style=>'danger'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P4303_ID is not null ',
'and ( :P4303_REFERENCE_ID is null or :P4303_SUBSCRIBED_COMP_GRP = ''N'' )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(21936143985)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(454431825)
,p_button_name=>'SAVE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>':F4000_P4303_ID is not null and :P4303_REFERENCE_ID is null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(21937143985)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(454431825)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Application Item'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P4303_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(21939143985)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':REQUEST in (''CREATE'',''SAVE'',''DELETE'')'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(808206684)
,p_name=>'P4303_ITEM_COMMENT'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(62050080142337727)
,p_item_source_plug_id=>wwv_flow_imp.id(454431825)
,p_prompt=>'Comments'
,p_source=>'ITEM_COMMENT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'<p>Enter any comments or notes here.  These comments will never be displayed when running the application</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9174630521)
,p_name=>'P4303_REQUIRED_PATCH'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(62049781536334954)
,p_item_source_plug_id=>wwv_flow_imp.id(454431825)
,p_prompt=>'Build Option'
,p_source=>'REQUIRED_PATCH'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PATCHES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(patch_name) pn, id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'', wwv_flow_escape.html(patch_name))||',
'''} '' pn,0-id id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by pn'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Build Option -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select a build option for this component.</p>',
'<p>Build options are predefined settings that determine whether or not  components within an application are enabled.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21941143986)
,p_name=>'F4000_P4303_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(455433462)
,p_item_source_plug_id=>wwv_flow_imp.id(454431825)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21942143986)
,p_name=>'P4303_FLOW_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(455433462)
,p_item_source_plug_id=>wwv_flow_imp.id(454431825)
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Application'
,p_source=>'FLOW_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21943143987)
,p_name=>'P4303_NAME'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(455433462)
,p_item_source_plug_id=>wwv_flow_imp.id(454431825)
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter a name when creating a new item or change the name of an existing item.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_attribute_06=>'UPPER'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2355631919667301)
,p_name=>'P4303_SUBSCRIBED_COMP_GRP'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(12559831346493637)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2373270202105008)
,p_name=>'P4303_ESCAPE_ON_HTTP_OUTPUT'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(17312310527965891)
,p_item_source_plug_id=>wwv_flow_imp.id(454431825)
,p_item_default=>'Y'
,p_prompt=>'Escape Special Characters'
,p_source=>'ESCAPE_ON_HTTP_OUTPUT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'This item controls whether the application item''s value will be automatically escaped in substitutions, e.g. when referencing the item via <code>&amp;G_ITEM.</code>.',
'To prevent Cross-Site Scripting (XSS) attacks, set it to <em>On</em>.',
'If you need to render HTML tags stored in the application item,',
'you can set this flag to <em>Off</em>.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4796957323120915)
,p_name=>'P4303_VERSION_SCN'
,p_source_data_type=>'NUMBER'
,p_is_query_only=>true
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(455433462)
,p_item_source_plug_id=>wwv_flow_imp.id(454431825)
,p_source=>'VERSION_SCN'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4797041976120916)
,p_name=>'P4303_MASTER_VERSION_SCN'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(12559831346493637)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select version_scn ',
'  from wwv_flow_items',
' where id                = :P4303_REFERENCE_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6611621582558821)
,p_name=>'P4303_NAME_INIT'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(455433462)
,p_source=>'P4303_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12561383739493658)
,p_name=>'P4303_REFERENCE_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(12559831346493637)
,p_item_source_plug_id=>wwv_flow_imp.id(454431825)
,p_prompt=>'Subscribe From'
,p_source=>'REFERENCE_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FLOW_SUBSCRIBE_FROM_APP_ITEMS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select b.flow_id ||'' ''||f.name||'' - ''|| b.name d,',
'       b.id r',
'  from wwv_flow_items b,',
'       wwv_main_apps_dev f',
' where b.flow_id          != nvl(:FB_FLOW_ID,0)',
'   and b.flow_id           = f.id',
'   and f.build_status      not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'   and b.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and f.security_group_id = :FLOW_SECURITY_GROUP_ID',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Subscription -'
,p_cSize=>50
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a master application item to subscribe from. When you select a master application item and click on "Apply Changes" button, then application item details will be automatically refreshed from the selected master.<br /><br />If the application i'
||'tem is already subscribed, then use "Refresh Application Item" button to refresh application item details from the master application item.'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'Y'
,p_attribute_06=>'0'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12561470217493659)
,p_name=>'P4303_REFERENCE_ID_INIT'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(12559831346493637)
,p_use_cache_before_default=>'NO'
,p_item_default=>'P4303_REFERENCE_ID'
,p_item_default_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17314311266994460)
,p_name=>'P4303_PROTECTION_LEVEL'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(17312310527965891)
,p_item_source_plug_id=>wwv_flow_imp.id(454431825)
,p_item_default=>'I'
,p_prompt=>'Session State Protection'
,p_source=>'PROTECTION_LEVEL'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ITEM PROTECTION LEVEL D'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select nvl(PAGE_PROTECTION_ENABLED_Y_N,''N'') p from wwv_flows where id = :FB_FLOW_ID) loop',
'    if c1.p = ''Y'' then',
'       return  ''select wwv_flow_lang.system_message(''''UNRESTRICTED'''') d, ''''N'''' r',
'                  from sys.dual union all',
'                select wwv_flow_lang.system_message(''''CHECKSUM_REQUIRED_APPLICATION'''') d, ''''B'''' r',
'                  from sys.dual union all',
'                select wwv_flow_lang.system_message(''''CHECKSUM_REQUIRED_USER'''') d, ''''P'''' r',
'                  from sys.dual union all               ',
'                select wwv_flow_lang.system_message(''''CHECKSUM_REQUIRED_SESSION'''') d, ''''S'''' r',
'                  from sys.dual union all               ',
'                select wwv_flow_lang.system_message(''''RESTRICTED_NO_SET_FROM_BROWSER'''') d, ''''I'''' r',
'                  from sys.dual'';',
'    else',
'       return  ''select wwv_flow_lang.system_message(''''UNRESTRICTED'''') d, ''''N'''' r',
'                  from sys.dual union all ',
'                select wwv_flow_lang.system_message(''''RESTRICTED_NO_SET_FROM_BROWSER'''') d, ''''I'''' r',
'                  from sys.dual'';',
'    end if;',
'end loop;'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select Session State Protection for this item:',
'<ul>',
'<li><strong>Unrestricted</strong> - The item may be set by passing the item name/value in a URL or in a form. No checksum is required in the URL.</li><br />       ',
'<li><strong>Restricted - May not be set from browser</strong> - The item may not be altered using the URL or POSTDATA. Use this option when you want to restrict the way that the item value can be set to internal processes, computations, and so on. Th'
||'is attribute is only applicable only to items that cannot be used as data entry items and is always observed even if Session State Protection is disabled. This attribute may be used for application items or for page items with any of these "Display A'
||'s" types:',
'<br />',
'<ul>',
'<li>Display Only (Save State=No)</li>',
'<li>Text Field (Disabled, does not save state)</li>                          ',
'<li>Stop and Start Grid Layout (Displays label only)</li>',
'</li></ul>',
'<li><strong>Checksum Required: Application Level</strong> - The item may be set by passing the item name/value in a URL if a checksum is also provided that is specific to the workspace and application. Use this option when you want to allow the item '
||'to be set only by URLs having checksums that were generated by any user running the same application in the current workspace but in a different session.</li>',
'<li><strong>Checksum Required: User Level</strong> - The item may be set by passing the item name/value in a URL if a checksum is also provided that is specific to the workspace, application, and user. Use this option when you want to allow the item '
||'to be set only by URLs having checksums that were generated by the same named user, running the same application in the current workspace but in a different session.</li>      ',
'<li><strong>Checksum Required: Session Level</strong> - The item may be set by passing the item name/value in a URL if a checksum is also provided that is specific to the current session. Use this option when you want to allow this item to be set onl'
||'y by URLs having checksums that were generated in the current session.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(211618610714373977)
,p_name=>'P4303_SCOPE'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(455433462)
,p_item_source_plug_id=>wwv_flow_imp.id(454431825)
,p_prompt=>'Scope'
,p_source=>'SCOPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APP_ITEM_SCOPE'
,p_lov=>'.'||wwv_flow_imp.id(211617631947367477)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Specify <em>Global</em> if the &PRODUCT_NAME. session is shared by more than one application and the item''s value should be the same for all applications.',
'<br/>',
'Specify <em>Application</em> otherwise (this is the default).',
'</p>',
'<p>',
'Applications can share the same session if their authentications have the same <em>Session Cookie Attributes</em>.',
'The <em>Scope</em> attribute of application items has to be the same across these applications.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(361951120886513562)
,p_name=>'P4303_DATA_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(17312310527965891)
,p_item_source_plug_id=>wwv_flow_imp.id(454431825)
,p_item_default=>'VARCHAR'
,p_prompt=>'Data Type'
,p_source=>'DATA_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC2:NUMBER;NUMBER,VARCHAR;VARCHAR'
,p_cHeight=>1
,p_display_when=>':fb_flow_id between 4000 and 4999'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Defining a value as numeric will ensure that any time this session state is set, that it is numeric.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2355881435667303)
,p_computation_sequence=>10
,p_computation_item=>'P4303_SUBSCRIBED_COMP_GRP'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_component_group_dev.is_part_of_subscribed_comp_grp (',
'    p_component_id   => :F4000_P4303_ID,',
'    p_component_type => wwv_flow_copy_metadata.c_app_item,',
'    p_app_id         => :FB_FLOW_ID )'))
,p_compute_when=>'F4000_P4303_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(69315223364661257)
,p_validation_name=>'Item not exists'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not wwv_flow_builder.is_item_name_used(',
'        p_flow => :FB_FLOW_ID,',
'        p_name => :P4303_NAME )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Item name is already used by existing application item or page item.'
,p_when_button_pressed=>wwv_flow_imp.id(21937143985)
,p_associated_item=>wwv_flow_imp.id(21943143987)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(70258610007099366)
,p_validation_name=>'Item name not dup on edit'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not wwv_flow_builder.is_item_name_duplicate(',
'          p_flow => :FB_FLOW_ID,',
'          p_id   => :F4000_P4303_ID,',
'          p_name => :P4303_NAME )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Item name is already used by another application or page item.  '
,p_when_button_pressed=>wwv_flow_imp.id(21936143985)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(107687001406716203)
,p_validation_name=>'Valid item name'
,p_validation_sequence=>50
,p_validation=>'P4303_NAME'
,p_validation_type=>'ITEM_IS_ALPHANUMERIC'
,p_error_message=>'Name "&P4303_NAME." may contain only alphanumeric characters and underscores "_".'
,p_validation_condition=>'DELETE'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_associated_item=>wwv_flow_imp.id(21943143987)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(8215705366264609)
,p_validation_name=>'No duplicate subscription'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_items',
' where security_group_id = :WORKSPACE_ID ',
'   and flow_id           = :FB_FLOW_ID ',
'   and reference_id      = :P4303_REFERENCE_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'An existing application item in this application is subscribed to the same master. Please select another master application item.'
,p_validation_condition=>':P4303_REFERENCE_ID is not null and :P4303_REFERENCE_ID_INIT is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(21936143985)
,p_associated_item=>wwv_flow_imp.id(12561383739493658)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(6611549814558820)
,p_validation_name=>'Prevent Item Rename'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from wwv_flow_computations',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and computation_item  = :P4303_NAME_INIT',
'   -- computation subscribed from other app ',
'   -- renaming item will also modify computation, but it should not be possible',
'   -- because computation is subscribed   ',
'   and reference_id      is not null'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'It is not possible to rename this item because it is associated with an application computation that is subscribed from another application.'
,p_validation_condition=>':P4303_NAME != :P4303_NAME_INIT'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(21936143985)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2600359371971201)
,p_validation_name=>'Not part of component groups'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not wwv_flow_component_group_dev.is_part_of_comp_grp (',
'    p_component_id   => :F4000_P4303_ID,',
'    p_component_type => wwv_flow_copy_metadata.c_app_item,',
'    p_app_id         => :FB_FLOW_ID )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Application Item cannot be deleted because it is part of a component group.'
,p_when_button_pressed=>wwv_flow_imp.id(21935143985)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4414422849904147)
,p_name=>'Hide P4303_REFERENCE_ID'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P4303_REFERENCE_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4414543903904148)
,p_event_id=>wwv_flow_imp.id(4414422849904147)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4303_REFERENCE_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2356061480667305)
,p_name=>'Save'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(21936143985)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2356150134667306)
,p_event_id=>wwv_flow_imp.id(2356061480667305)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'Are you sure you want to subscribe? This will overwrite the current application item data with the selected master application item.'
,p_attribute_03=>'warning'
,p_attribute_06=>'Subscribe'
,p_attribute_07=>'Cancel'
,p_client_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_client_condition_expression=>'$v(''P4303_REFERENCE_ID'') !== "" && $v(''P4303_REFERENCE_ID_INIT'') === ""'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2356214467667307)
,p_event_id=>wwv_flow_imp.id(2356061480667305)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'SAVE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(8160134140443210)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(454431825)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process form Application Item'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE,SAVE,DELETE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'Application Item saved.'
,p_internal_uid=>8160134140443210
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(62220711958189689)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'warn on long name'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if length(:P4303_NAME) > 30 then',
'   wwv_flow.g_notification := ''Warning... flow items with names longer then 30 bytes can not be used as bind variables.'';',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'CREATE,SAVE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_internal_uid=>62220711958189689
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(8160213026443211)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh App Item'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.refresh_component (',
'    p_component_type     => wwv_flow_copy_metadata.c_app_item,',
'    p_master_id          => :P4303_REFERENCE_ID,',
'    p_subscribing_id     => :F4000_P4303_ID,',
'    p_subscribing_app_id => :FB_FLOW_ID );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Refresh failed. #SQLERRM_TEXT#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST = ''REFRESH''',
'or ( :REQUEST = ''SAVE'' and :P4303_REFERENCE_ID is not null and :P4303_REFERENCE_ID_INIT is null )'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Application item refreshed from the master.'
,p_internal_uid=>8160213026443211
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(6606059762410495)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Unsubscribe'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.unsubscribe_component (',
'    p_component_type  => wwv_flow_copy_metadata.c_app_item,',
'    p_component_id    => :F4000_P4303_ID,',
'    p_app_id          => :FB_FLOW_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(8153916784351034)
,p_process_success_message=>'Application Item has been unsubscribed.'
,p_internal_uid=>6606059762410495
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4640658120708216)
,p_process_sequence=>80
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Clear Subscriptions'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- when deleting the component, clear reference_id data from subscribing apps',
'--',
'wwv_flow_copy_metadata.clear_subscriptions (',
'    p_component_type => wwv_flow_copy_metadata.c_app_item,',
'    p_master_id      => :F4000_P4303_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(21935143985)
,p_internal_uid=>4640658120708216
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5205433768040742)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(454431825)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Create / Edit Application Item'
,p_internal_uid=>5205433768040742
);
end;
/
prompt --application/pages/page_04304
begin
wwv_flow_imp_page.create_page(
 p_id=>4304
,p_name=>'Create/Edit Computations'
,p_alias=>'CREATE-EDIT-COMPUTATIONS'
,p_step_title=>'Create / Edit Application Computation'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(91429205691059841)
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_read_only_when=>'P4304_REFERENCE_ID'
,p_help_text=>'bldr_app_comp.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(474996958)
,p_plug_name=>'Application Computation'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>90
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_COMPUTATIONS'
,p_query_where=>'security_group_id = :WORKSPACE_ID'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(475005575)
,p_plug_name=>'Item'
,p_region_name=>'I'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(476008649)
,p_plug_name=>'Conditions'
,p_region_name=>'CON'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_row_template=>wwv_flow_imp.id(81008210556197147)
,p_plug_query_num_rows=>50
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_row_count_max=>5000
,p_plug_query_show_nulls_as=>'(null)'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(477016621)
,p_plug_name=>'Application Computations'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Application Computations are computed for every page at the computation point, except On New Instance computations which are executed when a new logical session is created.</p>  <p>If you wish to set an item equal to the value of another item, use'
||' the syntax &amp;ITEM_NAME. in the computation field with a computation type of "Static Assignment."</p> <p>When Application Computation is subscribed, then it is not possible to change any data. </p>',
'<p>Deletion of the <strong>master</strong> application computation automatically clears the application computation references from subscribing application computations.</p>',
''))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(13676604798224434)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(4439523336547769)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
,p_plug_display_condition_type=>'ITEM_IS_NULL'
,p_plug_display_when_condition=>'F4000_P4304_ID'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(20572814637059788)
,p_plug_name=>'Subscription'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>15
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'F4000_P4304_ID'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'WWV_FLOW_COMPUTATIONS',
  'attribute_02', 'COMPUTATION_ITEM',
  'attribute_03', 'F4000_P4304_ID',
  'attribute_04', 'P4304_REFERENCE_ID',
  'attribute_05', 'SUBSCRIBE_APP_COMPUTATION',
  'attribute_06', 'VERSION_SCN')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46262726407679018)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(145703210893876094)
,p_plug_name=>'Comments'
,p_region_name=>'C'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(145705302698879924)
,p_plug_name=>'Authorization'
,p_region_name=>'AUT'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_row_template=>wwv_flow_imp.id(81008210556197147)
,p_plug_query_num_rows=>50
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_row_count_max=>5000
,p_plug_query_show_nulls_as=>'(null)'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(167082316394200777)
,p_plug_name=>'Configuration'
,p_region_name=>'BUILD'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(185533214224429562)
,p_plug_name=>'Computation'
,p_region_name=>'COM'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(203952522346859792)
,p_plug_name=>'Frequency'
,p_region_name=>'FRE'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(615500923207226126)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_imp.id(29434107863295859)
,p_plug_display_sequence=>80
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from WWV_FLOW_COMPUTATIONS',
'where id = :F4000_P4304_ID and security_group_id = :WORKSPACE_ID) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :F4000_P4304_ID,',
'      p_component_type => ''Application Computations'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4449030710400391)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_imp.id(20572814637059788)
,p_button_name=>'UNSUBSCRIBE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Unsubscribe'
,p_button_position=>'EDIT'
,p_button_condition=>':P4304_REFERENCE_ID is not null and :P4304_SUBSCRIBED_COMP_GRP = ''N'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4449467337400392)
,p_button_sequence=>110
,p_button_plug_id=>wwv_flow_imp.id(20572814637059788)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Refresh Application Computation'
,p_button_position=>'EDIT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P4304_REFERENCE_ID is not null ',
'and ( :P4304_VERSION_SCN != :P4304_MASTER_VERSION_SCN or :P4304_VERSION_SCN is null )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4449837764400392)
,p_button_sequence=>120
,p_button_plug_id=>wwv_flow_imp.id(20572814637059788)
,p_button_name=>'PUBLISH'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Publish'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.:149:F4000_P149_ID,F4000_P149_TEMPLATE_TYPE,F4000_P149_PAGE_ID:&F4000_P4304_ID.,APP_COMPUTATION,4304'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * ',
'  from wwv_flow_computations',
' where reference_id      = :F4000_P4304_ID ',
'   and security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(21949143988)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(474996958)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(21950143988)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(474996958)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_confirm_message=>'&DELETE_MSG.'
,p_confirm_style=>'danger'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P4304_ID is not null',
'and ( :P4304_REFERENCE_ID is null or :P4304_SUBSCRIBED_COMP_GRP = ''N'' )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(21951143988)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(474996958)
,p_button_name=>'SAVE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>':F4000_P4304_ID is not null and :P4304_REFERENCE_ID is null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(21952143988)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(474996958)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Computation'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P4304_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(36784333218)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':REQUEST IN (''CREATE'',''DELETE'') or :FB_FLOW_PAGE_ID is not null'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(21954143989)
,p_branch_name=>'Go To Page 4101'
,p_branch_action=>'f?p=&APP_ID.:4101:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9175636984)
,p_name=>'P4304_REQUIRED_PATCH'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(167082316394200777)
,p_item_source_plug_id=>wwv_flow_imp.id(474996958)
,p_prompt=>'Build Option'
,p_source=>'REQUIRED_PATCH'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PATCHES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(patch_name) pn, id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'', wwv_flow_escape.html(patch_name))||',
'''} '' pn,0-id id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by pn'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Build Option -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select a build option for this component.<p/>',
'Build options are predefined settings that determine whether or not components within an application are enabled.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21956143990)
,p_name=>'F4000_P4304_ID'
,p_data_type=>'NUMBER'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(475005575)
,p_item_source_plug_id=>wwv_flow_imp.id(474996958)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21957143990)
,p_name=>'P4304_FLOW_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(475005575)
,p_item_source_plug_id=>wwv_flow_imp.id(474996958)
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Application:'
,p_source=>'FLOW_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_tag_attributes=>'class="fieldtitlebold"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21958143990)
,p_name=>'P4304_COMPUTATION_SEQUENCE'
,p_source_data_type=>'NUMBER'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(475005575)
,p_item_source_plug_id=>wwv_flow_imp.id(474996958)
,p_item_default=>'10'
,p_prompt=>'Sequence'
,p_source=>'COMPUTATION_SEQUENCE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>8
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Specify the sequence for this component. The sequence determines the order of evaluation.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21959143990)
,p_name=>'P4304_COMPUTATION_ITEM'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(475005575)
,p_item_source_plug_id=>wwv_flow_imp.id(474996958)
,p_prompt=>'Computation Item'
,p_source=>'COMPUTATION_ITEM'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'COMPUTATION_ITEM'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang.system_message(''APPLICATION'')||'': ''||name d, name v',
'  from wwv_flow_items',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' union all',
'select wwv_flow_lang.system_message(''PAGE'')||'': ''||flow_step_id||'' ''||name d, name v',
'  from wwv_flow_step_items',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by 1'))
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select an application-level or page-level item that this computation affects.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21960143991)
,p_name=>'P4304_COMPUTATION_POINT'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(203952522346859792)
,p_item_source_plug_id=>wwv_flow_imp.id(474996958)
,p_item_default=>'ON_NEW_INSTANCE'
,p_prompt=>'Computation Point'
,p_source=>'COMPUTATION_POINT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APP_COMPUTATION_POINTS'
,p_lov=>'.'||wwv_flow_imp.id(48425308522403722)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select one of the pre-defined process points at which this computation should be performed. Selecting <strong>After Submit</strong> causes the computation to be performed only after the page is displayed and then submitted. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21962143992)
,p_name=>'P4304_COMPUTATION_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(185533214224429562)
,p_item_source_plug_id=>wwv_flow_imp.id(474996958)
,p_item_default=>'STATIC_ASSIGNMENT'
,p_prompt=>'Computation Type'
,p_source=>'COMPUTATION_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APP COMPUTATION TYPES'
,p_lov=>'.'||wwv_flow_imp.id(84926512995804334)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select the manner in which this computation will be performed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21964143992)
,p_name=>'P4304_COMPUTATION'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(185533214224429562)
,p_item_source_plug_id=>wwv_flow_imp.id(474996958)
,p_prompt=>'Computation'
,p_source=>'COMPUTATION'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the computation logic that corresponds to the computation type, &nbsp;for example:',
'<UL>',
'<LI>QUERY computation:',
'<pre>select to_char(sysdate,''YYYYMMDD'') from dual</pre></LI>',
'<LI>SQL_EXPRESION: ',
'<pre>to_char(sysdate,''YYYYMMDD'')</pre></LI>',
'<LI>STATIC_ASSIGNMENT: ',
'<pre>HELLO</pre></LI>',
'<LI>PLSQL_EXPRESSION: ',
'<pre>365 &gt; v(''DAYS_ELAPSED'')</pre></LI>',
'</UL>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21965143993)
,p_name=>'P4304_COMPUTATION_COMMENT'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(145703210893876094)
,p_item_source_plug_id=>wwv_flow_imp.id(474996958)
,p_prompt=>'Comments'
,p_source=>'COMPUTATION_COMMENT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter any comments or notes here. These comments will never be displayed when running the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21966143993)
,p_name=>'P4304_COMPUTE_WHEN'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(476008649)
,p_item_source_plug_id=>wwv_flow_imp.id(474996958)
,p_prompt=>'Expression 1'
,p_source=>'COMPUTE_WHEN'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Use this attribute to conditionally control whether or not a component is rendered or processed. Enter values in this attribute based on the selected condition type. The component will be rendered or processed if the specified condition is met.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21967143993)
,p_name=>'P4304_COMPUTE_WHEN_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(476008649)
,p_item_source_plug_id=>wwv_flow_imp.id(474996958)
,p_prompt=>'Condition Type'
,p_source=>'COMPUTE_WHEN_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CONDITION_LIST'
,p_named_lov=>'STANDARD_CONDITION_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(13602414170805697)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Condition -'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Select a condition type from the list that must be met in order for this component to be rendered or processed.'
,p_attribute_01=>'P4304_COMPUTE_WHEN'
,p_attribute_02=>'P4304_COMPUTE_WHEN_TEXT'
,p_attribute_04=>'P4304_COMPUTE_WHEN_CHECK'
,p_attribute_06=>'CONDITION'
,p_attribute_07=>'P4304_COMPUTE_WHEN_LANG'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(130028238902)
,p_name=>'P4304_COMPUTATION_ERROR_MSG'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(185533214224429562)
,p_item_source_plug_id=>wwv_flow_imp.id(474996958)
,p_prompt=>'Computation Error Message'
,p_source=>'COMPUTATION_ERROR_MESSAGE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter the text for an error message to be displayed if the computation fails.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(275598274926)
,p_name=>'P4304_COMPUTE_WHEN_TEXT'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(476008649)
,p_item_source_plug_id=>wwv_flow_imp.id(474996958)
,p_prompt=>'Expression 2'
,p_source=>'COMPUTE_WHEN_TEXT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Some condition types require two expressions for comparison. Enter the second expression or item here.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2100734087586209)
,p_name=>'P4304_COMPUTE_WHEN_LANG'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(476008649)
,p_prompt=>'Language'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select a language that is used to evaluate the entered programming code.'
,p_attribute_03=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2103320729627592)
,p_name=>'P4304_COMPUTATION_LANG'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(185533214224429562)
,p_item_source_plug_id=>wwv_flow_imp.id(474996958)
,p_prompt=>'Language'
,p_source=>'COMPUTATION_LANGUAGE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Select a language that is used to evaluate the entered programming code.'
,p_attribute_02=>'P4304_COMPUTATION_TYPE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2356895555667313)
,p_name=>'P4304_SUBSCRIBED_COMP_GRP'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(20572814637059788)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4797400607120920)
,p_name=>'P4304_VERSION_SCN'
,p_source_data_type=>'NUMBER'
,p_is_query_only=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(475005575)
,p_item_source_plug_id=>wwv_flow_imp.id(474996958)
,p_source=>'VERSION_SCN'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4797552567120921)
,p_name=>'P4304_MASTER_VERSION_SCN'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(20572814637059788)
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select version_scn ',
'  from wwv_flow_computations',
' where id                = :P4304_REFERENCE_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20577347873059845)
,p_name=>'P4304_REFERENCE_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(20572814637059788)
,p_item_source_plug_id=>wwv_flow_imp.id(474996958)
,p_prompt=>'Subscribe From'
,p_source=>'REFERENCE_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FLOW_SUBSCRIBE_FROM_APP_COMPUTATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select b.flow_id ||'' ''||f.name||'' - ''|| b.computation_item d,',
'       b.id r',
'  from wwv_flow_computations b,',
'       wwv_main_apps_dev f',
' where b.flow_id          != nvl(:FB_FLOW_ID,0)',
'   and b.flow_id           = f.id',
'   and f.build_status      not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'   and b.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and f.security_group_id = :FLOW_SECURITY_GROUP_ID',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Subscription -'
,p_cSize=>50
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a master application computation to subscribe from. When you select a master application computation and click on the <strong>Apply Changes</strong> button, the application computation details will be automatically refreshed from the selected '
||'master.<br /><br />If the application computation is already subscribed, then click on the <strong>Refresh Application Computation</strong> button to refresh the application computation details from the master application computation.'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'Y'
,p_attribute_06=>'0'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20577434351059846)
,p_name=>'P4304_REFERENCE_ID_INIT'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(20572814637059788)
,p_use_cache_before_default=>'NO'
,p_item_default=>'P4304_REFERENCE_ID'
,p_item_default_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(147184318455081486)
,p_name=>'P4304_SECURITY_SCHEME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(145705302698879924)
,p_item_source_plug_id=>wwv_flow_imp.id(474996958)
,p_prompt=>'Authorization Scheme'
,p_source=>'SECURITY_SCHEME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REQUIRED_ROLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.d, a.r from (',
'    select wwv_flow_lang.system_message(''MUST_NOT_BE_PUBLIC_USER'') d,''MUST_NOT_BE_PUBLIC_USER'' r, 1',
'      from sys.dual',
'    union all',
'    select wwv_flow_escape.html(substr(name,1,50)),to_char(id), 1',
'      from wwv_flow_security_schemes',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID',
'    union all',
'    select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'',wwv_flow_escape.html(substr(name,1,50)))||''}'' d, ''!''||to_char(id) r, 2',
'      from wwv_flow_security_schemes',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID',
'    order by 3,1) a'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Authorization Required -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Optionally select an authorization scheme which must evaluate to TRUE in order for this component to be rendered or otherwise processed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(435040930119654784)
,p_name=>'P4304_COMPUTE_WHEN_CHECK'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(476008649)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Do not validate code (parse code at runtime only).'
,p_source=>'NULL'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2356977202667314)
,p_computation_sequence=>10
,p_computation_item=>'P4304_SUBSCRIBED_COMP_GRP'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_component_group_dev.is_part_of_subscribed_comp_grp (',
'    p_component_id   => :F4000_P4304_ID,',
'    p_component_type => wwv_flow_copy_metadata.c_app_computation,',
'    p_app_id         => :FB_FLOW_ID )'))
,p_compute_when=>'F4000_P4304_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(8210588274260002)
,p_computation_sequence=>20
,p_computation_item=>'P4304_COMPUTATION_ITEM'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(:P4304_COMPUTATION_ITEM)'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(36678931215035872)
,p_validation_name=>'Item must exist'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_f4000_util.get_page_item_id(',
'                     p_item_name       => :P4304_COMPUTATION_ITEM,',
'                     p_application_id  => :FB_FLOW_ID ) is not null',
'or wwv_flow_f4000_util.get_application_item_id(',
'                     p_item_name       => :P4304_COMPUTATION_ITEM,',
'                     p_application_id  => :FB_FLOW_ID ) is  not null'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Item does not exist.'
,p_validation_condition=>'CREATE,SAVE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(21959143990)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(36680815762040916)
,p_validation_name=>'must supply computation'
,p_validation_sequence=>20
,p_validation=>'P4304_COMPUTATION'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Computation must be specified.'
,p_validation_condition=>'CREATE,SAVE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(21964143992)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2607114572046513)
,p_validation_name=>'Not part of component groups'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not wwv_flow_component_group_dev.is_part_of_comp_grp (',
'    p_component_id   => :F4000_P4304_ID,',
'    p_component_type => wwv_flow_copy_metadata.c_app_computation,',
'    p_app_id         => :FB_FLOW_ID )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Application Computation cannot be deleted because it is part of a component group.'
,p_when_button_pressed=>wwv_flow_imp.id(21950143988)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6610183651558806)
,p_name=>'Hide P4304_REFERENCE_ID'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P4304_REFERENCE_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6610265273558807)
,p_event_id=>wwv_flow_imp.id(6610183651558806)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4304_REFERENCE_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2357004054667315)
,p_name=>'Save'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(21951143988)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2357182464667316)
,p_event_id=>wwv_flow_imp.id(2357004054667315)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'Are you sure you want to subscribe? This will overwrite the current application computation data with the selected master application computation.'
,p_attribute_03=>'warning'
,p_client_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_client_condition_expression=>'$v(''P4304_REFERENCE_ID'') !== "" && $v(''P4304_REFERENCE_ID_INIT'') === ""'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2357279514667317)
,p_event_id=>wwv_flow_imp.id(2357004054667315)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'SAVE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4487376097954427)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(474996958)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process form Application Computation'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_process_error_message=>'#SQLERRM_TEXT#'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE,SAVE,DELETE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'Action processed.'
,p_internal_uid=>4487376097954427
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4454884428670827)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh App Computation'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.refresh_app_computation (',
'    p_master_computation_id      => :P4304_REFERENCE_ID,',
'    p_subscribing_computation_id => :F4000_P4304_ID,',
'    p_subscribing_app_id         => :FB_FLOW_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST = ''REFRESH''',
'or ( :REQUEST = ''SAVE'' and :P4304_REFERENCE_ID is not null and :P4304_REFERENCE_ID_INIT is null )'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Application computation refreshed from the master.'
,p_internal_uid=>4454884428670827
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(6627435755507346)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Unsubscribe'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.unsubscribe_component (',
'    p_component_type  => wwv_flow_copy_metadata.c_app_computation,',
'    p_component_id    => :F4000_P4304_ID,',
'    p_app_id          => :FB_FLOW_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(4449030710400391)
,p_process_success_message=>'Application Computation has been unsubscribed.'
,p_internal_uid=>6627435755507346
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4641966435729587)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Clear Subscriptions'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- when deleting the component, clear reference_id data from subscribing apps',
'--',
'wwv_flow_copy_metadata.clear_subscriptions (',
'    p_component_type => wwv_flow_copy_metadata.c_app_computation,',
'    p_master_id      => :F4000_P4304_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(21950143988)
,p_internal_uid=>4641966435729587
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4484989670954403)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(474996958)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Create/Edit Computations'
,p_internal_uid=>4484989670954403
);
end;
/
prompt --application/pages/page_04305
begin
wwv_flow_imp_page.create_page(
 p_id=>4305
,p_name=>'Edit Standard Tab'
,p_alias=>'EDIT-STANDARD-TAB'
,p_step_title=>'Edit Standard Tab'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213240607818867991)
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(462588551)
,p_plug_name=>'Standard Tab'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(463590414)
,p_plug_name=>'Name'
,p_region_name=>'N'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(464604042)
,p_plug_name=>'Tabs'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>90
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'When you use standard tabs, you associate a page with a tab set (or a collection of related tabs). Each tab within a tab set identifies a page that is designated as current (or selected). You can specify other pages to be current for a tab using the '
||'Tab Also Current for Pages attribute.  If you wish to use two levels of tabs, you must specify a parent tab set in the Parent Tab Set attribute.'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(33940909982)
,p_plug_name=>'Conditions'
,p_region_name=>'CONDITIONS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(303236693948)
,p_plug_name=>'Comments'
,p_region_name=>'C'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46263816985679020)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46720126060136757)
,p_plug_name=>'Images'
,p_region_name=>'IMG'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46766726670181982)
,p_plug_name=>'Parent Tab Set'
,p_region_name=>'P'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(145717022514901086)
,p_plug_name=>'Authorization'
,p_region_name=>'AUTH'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(167043408008174269)
,p_plug_name=>'Configuration'
,p_region_name=>'BUILD'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(180275209988934962)
,p_plug_name=>'Current For Pages'
,p_region_name=>'CURR'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(615476809776127566)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(29434107863295859)
,p_plug_display_sequence=>130
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from WWV_FLOW_TABS ',
'where id = :F4000_P4305_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :F4000_P4305_ID,',
'      p_component_type => ''Tab'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(21971143994)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(462588551)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(21972143994)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(462588551)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
,p_button_condition=>'F4000_P4305_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(21973143994)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(462588551)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P4305_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(21974143994)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(462588551)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P4305_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(21976143995)
,p_branch_action=>'&F4000_LAST_VIEW.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(241522187)
,p_name=>'TAB_ALSO_CURRENT_FOR_PAGES'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(180275209988934962)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tab Also Current for Pages'
,p_source=>'TAB_ALSO_CURRENT_FOR_PAGES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">In the event that one tab corresponds to more than one page, list all pages that are "current" delimited by a comma. For example:</div>',
'<pre>12,13,33</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4508871236)
,p_name=>'F4000_P4305_TAB_DISP_COND_TEXT'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(33940909982)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Expression 2'
,p_source=>'TAB_DISP_COND_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Some condition types require two expressions for comparison.  Enter the second expression or item here.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9176653287)
,p_name=>'F4000_P4305_REQUIRED_PATCH'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(167043408008174269)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Build Option'
,p_source=>'REQUIRED_PATCH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PATCHES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(patch_name) pn, id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'', wwv_flow_escape.html(patch_name))||',
'''} '' pn,0-id id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by pn'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Build Option -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<div class="htmldbInfoBodyP">Select a build option for this component. Build options are predefined settings that determine whether or not components within an application are enabled.</div>'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11123716925)
,p_name=>'F4000_P4305_TAB_PARENT_TABSET'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(46766726670181982)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Parent&nbsp;Tab Set'
,p_source=>'TAB_PARENT_TABSET'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PARENT_TABSETS'
,p_lov=>'select distinct wwv_flow_escape.html(tab_set) d, tab_set r from wwv_flow_toplevel_tabs where flow_id = :fb_flow_id order by 1'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Parent Tab Set -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'A parent tab set functions as a container to hold a group of standard tabs. If your application uses two levels of tabs, you must choose a parent tab set.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21978143995)
,p_name=>'F4000_P4305_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(463590414)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21979143996)
,p_name=>'F4000_P4305_FLOW_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(463590414)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Application:'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_attributes=>'class="fieldtitlebold"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the application associated with this tab.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21980143996)
,p_name=>'F4000_P4305_TAB_SET'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(463590414)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Standard Tab Set'
,p_source=>'TAB_SET'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TABSETS WITH EMPTY SETS UNIONED'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(d) d, r',
'  from wwv_flow_tabset_view2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Standard Tab Set -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the standard tab sets to which this tab entry will be attached.'
,p_encrypt_session_state_yn=>'N'
,p_item_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Fixed spelling of label 01.22.02 -- Scott S.',
'',
'',
'',
'',
'',
'',
'',
'sleuniss: previous query',
'',
'',
'',
'select distinct tab_set from wwv_flow_tabs where flow_id = &FB_FLOW_ID order by 1'))
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21981143996)
,p_name=>'F4000_P4305_TAB_SEQUENCE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(463590414)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Sequence'
,p_source=>'TAB_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'TAB_SEQUENCE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct tab_sequence a, tab_sequence b',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID',
'order  by 1'))
,p_cSize=>8
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the sequence for this component. The sequence determines the order of evaluation.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21982143997)
,p_name=>'F4000_P4305_TAB_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(463590414)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tab Name'
,p_source=>'TAB_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter a unique name for this tab.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21983143997)
,p_name=>'F4000_P4305_TAB_IMAGE'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(46720126060136757)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Current Tab Image'
,p_source=>'TAB_IMAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'PICK_IMAGE_NAME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select file_name || '' ('' || wwv_flow_lang.system_message(scope) || '')'' as d,',
'       r',
'  from ( select file_name,',
'                ''#'' || ''APP_FILES#'' || file_name as r,',
'                ''APPLICATION'' as scope',
'           from wwv_flow_static_files',
'          where flow_id           = :FB_FLOW_ID',
'            and security_group_id = :WORKSPACE_ID',
'            and upper(mime_type)  like ''IMAGE/%''',
'          union all',
'         select file_name,',
'                ''#'' || ''WORKSPACE_FILES#'' || file_name as r,',
'                ''WORKSPACE'' as scope',
'           from wwv_flow_company_static_files',
'          where security_group_id = :WORKSPACE_ID',
'            and upper(mime_type)  like ''IMAGE/%''',
'          order by scope, file_name',
'       )',
''))
,p_cSize=>60
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Specify the image to display when the tab is current. For example:</div>',
'<pre>',
'   tab1.gif',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21984143997)
,p_name=>'F4000_P4305_TAB_TEXT'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(463590414)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tab Label'
,p_source=>'TAB_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter the text that displays as a tab (assuming tab images are not used). If you are using tab images, this name becomes the ALT text.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21985143998)
,p_name=>'F4000_P4305_TAB_STEP'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(180275209988934962)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tab Page'
,p_source=>'TAB_STEP'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d',
'  from wwv_flow_steps',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and is_page_pattern   = ''N''',
'order by 2'))
,p_cSize=>4
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter the ID of the page to which the user navigates to when selecting this tab.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33939893897)
,p_name=>'F4000_P4305_TAB_PLSQL_CONDITION'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(33940909982)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Expression 1'
,p_source=>'TAB_PLSQL_CONDITION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'This attribute allows you to conditionally control whether or not a  component is rendered or processed. Enter values in this attribute based on the specific condition type selected. The component will be rendered or processed if the specified condit'
||'ion is met.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(64067896247)
,p_name=>'F4000_P4305_DISPLAY_CONDITION_TYPE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(33940909982)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Condition Type'
,p_source=>'DISPLAY_CONDITION_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CONDITION_LIST'
,p_named_lov=>'STANDARD_CONDITION_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(13602414170805697)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Display Condition -'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select a condition type from the list. This condition type must be met in order for this component to be rendered processed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'F4000_P4305_TAB_PLSQL_CONDITION'
,p_attribute_02=>'F4000_P4305_TAB_DISP_COND_TEXT'
,p_attribute_04=>'F4000_P4305_TAB_PLSQL_CONDITION_CHECK'
,p_attribute_06=>'CONDITION'
,p_attribute_07=>'F4000_P4305_DISPLAY_CONDITION_LANG'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(219831439971)
,p_name=>'F4000_P4305_TAB_NON_CURRENT_IMAGE'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(46720126060136757)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Non Current Tab&nbsp;Image'
,p_source=>'TAB_NON_CURRENT_IMAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'PICK_IMAGE_NAME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select file_name || '' ('' || wwv_flow_lang.system_message(scope) || '')'' as d,',
'       r',
'  from ( select file_name,',
'                ''#'' || ''APP_FILES#'' || file_name as r,',
'                ''APPLICATION'' as scope',
'           from wwv_flow_static_files',
'          where flow_id           = :FB_FLOW_ID',
'            and security_group_id = :WORKSPACE_ID',
'            and upper(mime_type)  like ''IMAGE/%''',
'          union all',
'         select file_name,',
'                ''#'' || ''WORKSPACE_FILES#'' || file_name as r,',
'                ''WORKSPACE'' as scope',
'           from wwv_flow_company_static_files',
'          where security_group_id = :WORKSPACE_ID',
'            and upper(mime_type)  like ''IMAGE/%''',
'          order by scope, file_name',
'       )',
''))
,p_cSize=>60
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Specify the image to display when the tab is not current. For example:</div>',
'<pre>',
'   tab_inactive.gif',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(219831439972)
,p_name=>'F4000_P4305_TAB_IMAGE_ATTRIBUTES'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(46720126060136757)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Image&nbsp;Attributes'
,p_source=>'TAB_IMAGE_ATTRIBUTES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Include image attributes. For example:',
'<pre>border="0" width="34" height="22"</pre>',
'<div class="htmldbInfoBodyP">The image attributes are included in the HTML &lt;img&gt; tag.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(293048221908)
,p_name=>'F4000_P4305_SECURITY_SCHEME'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(145717022514901086)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Authorization Scheme'
,p_source=>'SECURITY_SCHEME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REQUIRED_ROLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.d, a.r from (',
'    select wwv_flow_lang.system_message(''MUST_NOT_BE_PUBLIC_USER'') d,''MUST_NOT_BE_PUBLIC_USER'' r, 1',
'      from sys.dual',
'    union all',
'    select wwv_flow_escape.html(substr(name,1,50)),to_char(id), 1',
'      from wwv_flow_security_schemes',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID',
'    union all',
'    select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'',wwv_flow_escape.html(substr(name,1,50)))||''}'' d, ''!''||to_char(id) r, 2',
'      from wwv_flow_security_schemes',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID',
'    order by 3,1) a'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Authorization Required -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'<p>Optionally select an authorization scheme which must evaluate to TRUE in order for this component to be rendered or otherwise processed.</p>'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(303238700264)
,p_name=>'F4000_P4305_TAB_COMMENT'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(303236693948)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comments'
,p_source=>'TAB_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter any comments or notes here. These comments never display when an application is running.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
,p_item_comment=>'mike added 01.08.01'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2202391078381358)
,p_name=>'F4000_P4305_DISPLAY_CONDITION_LANG'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(33940909982)
,p_prompt=>'Language'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select a language that is used to evaluate the entered programming code.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(23659613323072909)
,p_name=>'P4305_OLD_TABSET'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(463590414)
,p_prompt=>'Old Tabset'
,p_source=>'F4000_P4305_TAB_SET'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(435041226594654785)
,p_name=>'F4000_P4305_TAB_PLSQL_CONDITION_CHECK'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(33940909982)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Do not validate code (parse code at runtime only).'
,p_source=>'NULL'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(49389322403096293)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P4305_TAB_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'replace(:F4000_P4305_TAB_NAME,'''''''','''')'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(25924427102259776)
,p_validation_name=>'tab name not null'
,p_validation_sequence=>10
,p_validation=>'F4000_P4305_TAB_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Name must be specified.'
,p_validation_condition=>'ApplyChanges, Create'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(21982143997)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(25925228964269781)
,p_validation_name=>'sequence not null'
,p_validation_sequence=>20
,p_validation=>'F4000_P4305_TAB_SEQUENCE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Sequence must be specified.'
,p_validation_condition=>'ApplyChanges, Create'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(21981143996)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(25925821476277086)
,p_validation_name=>'sequence is numeric'
,p_validation_sequence=>30
,p_validation=>'F4000_P4305_TAB_SEQUENCE'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Sequence must be numeric.'
,p_validation_condition=>'ApplyChanges, Create'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(21981143996)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(25926414681284558)
,p_validation_name=>'tab label not null'
,p_validation_sequence=>40
,p_validation=>'F4000_P4305_TAB_TEXT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Label must be specified.'
,p_validation_condition=>'ApplyChanges, Create'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(21984143997)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(25927028449307478)
,p_validation_name=>'page exists'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_steps',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id = :FB_FLOW_ID',
'   and id = :F4000_P4305_TAB_STEP'))
,p_validation_type=>'EXISTS'
,p_error_message=>'Must specify an existing page.'
,p_validation_condition=>'ApplyChanges, Create'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(21985143998)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(8009122126989976)
,p_validation_name=>'tab also current for pages'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :TAB_ALSO_CURRENT_FOR_PAGES is null then',
'return true;',
'elsif rtrim(translate(:TAB_ALSO_CURRENT_FOR_PAGES,''0123456789, '',''00000000000''),''0'') is not null then',
'return false;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Use page numbers and commas.  For example: 1,2,3'
,p_associated_item=>wwv_flow_imp.id(241522187)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(21986143998)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch Row from WWV_FLOW_TABS'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'for c1 in (',
'select 1 from wwv_flow_tabs',
'where security_group_id = :flow_security_group_id and',
'      flow_id = :FB_FLOW_ID and',
'      id = :F4000_P4305_ID) loop',
'wwv_flow_dml.fetch_row(',
'  p_table_owner => ''#OWNER#'',',
'  p_table_name  => ''WWV_FLOW_TABS'',',
'  p_rowid       => v(''F4000_P4305_ID''),',
'  p_alt_rowid   => ''ID'');',
'exit;',
'end loop;',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error fetching row.'
,p_internal_uid=>21986143998
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(21987143998)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process Row of WWV_FLOW_TABS'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'for c1 in (',
'select 1 from dual',
'where :F4000_P4305_ID is null',
'or exists (select 1 from wwv_flow_tabs',
'                   where security_group_id = :flow_security_group_id and',
'      flow_id = :FB_FLOW_ID and',
'      id = :F4000_P4305_ID)) loop',
'wwv_flow_dml.process(',
'p_action => wwv_flow.g_request,',
'p_table_owner => ''#OWNER#'',',
'p_table_name  => ''WWV_FLOW_TABS'',',
'p_rowid       => v(''F4000_P4305_ID''),',
'p_alt_rowid   => ''ID'');',
'exit;',
'end loop;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error processing row.'
,p_process_success_message=>'Tab item "&F4000_P4305_TAB_NAME." processed.'
,p_internal_uid=>21987143998
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(23666808353137702)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Move assoc pages to new tabset'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_tab_page      varchar2(30);',
'    l_also_cur_for  varchar2(4000);',
'begin',
'    for c1 in (select TAB_STEP,TAB_ALSO_CURRENT_FOR_PAGES',
'                 from wwv_flow_tabs',
'                where id = :F4000_P4305_ID)',
'    loop',
'        l_tab_page      :=  c1.TAB_STEP;',
'        l_also_cur_for  :=  c1.TAB_ALSO_CURRENT_FOR_PAGES;',
'        exit;',
'    end loop;',
'                   ',
'    wwv_flow_tab_mgr.update_tab_pages(',
'            p_tab_id        => :F4000_P4305_ID,',
'            p_tab_set       => :F4000_P4305_TAB_SET,',
'            p_flow          => :F4000_P4305_FLOW_ID,',
'            p_tab_page      => l_tab_page,',
'            p_also_cur_for  => l_also_cur_for);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>':REQUEST = ''ApplyChanges'' AND :F4000_P4305_TAB_SET != :P4305_OLD_TABSET'
,p_internal_uid=>23666808353137702
);
end;
/
prompt --application/pages/page_04307
begin
wwv_flow_imp_page.create_page(
 p_id=>4307
,p_name=>'Template'
,p_alias=>'TEMPLATE'
,p_step_title=>'Edit Page Template'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'<!--',
'  htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';',
'//-->',
'</script>',
'',
''))
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_read_only_when_type=>'EXISTS'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_templates t, ',
'       wwv_flow_themes th',
' where t.id                 = :F4000_P4307_ID',
'   and t.flow_id            = th.flow_id',
'   and t.theme_id           = th.theme_id',
'   and t.security_group_id  = :WORKSPACE_ID',
'   and th.security_group_id = t.security_group_id',
'   and t.reference_id      is not null',
'   and th.reference_id     is not null'))
,p_help_text=>'ui_templt_page.htm'
,p_page_component_map=>'21'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(541989765)
,p_plug_name=>'Edit Page Template'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--accessibleTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>170
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_landmark_label=>'Page Template Actions'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(547026858)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>140
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Templates define the appearance of a page. Each template consists of a header template, a body template, and a footer template as well as a number of subtemplate definitions.</p>',
''))
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3431364703804901)
,p_plug_name=>'Landmark for Displayed Regions'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_landmark_type=>'region'
,p_landmark_label=>'Displayed Regions'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(542993683)
,p_plug_name=>'Definition'
,p_region_name=>'TEMP'
,p_parent_plug_id=>wwv_flow_imp.id(3431364703804901)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>250
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'-'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(543003816)
,p_plug_name=>'Subtemplate'
,p_region_name=>'SUBTEMP'
,p_parent_plug_id=>wwv_flow_imp.id(3431364703804901)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>250
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'-'
,p_plug_header=>'Enter the HTML for subtemplates below.  Subtemplates will be placed inside the body of the page template using substitution strings.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(544005752)
,p_plug_name=>'Standard Tab Attributes'
,p_region_name=>'STDTAB'
,p_parent_plug_id=>wwv_flow_imp.id(3431364703804901)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>' '
,p_plug_query_num_rows=>250
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'-'
,p_plug_display_condition_type=>'NOT_EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_themes',
' where flow_id                      = :fb_flow_id',
'   and nvl ( navigation_type, ''T'' ) = ''L''',
'   and security_group_id            = :WORKSPACE_ID'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(545007733)
,p_plug_name=>'Parent Tab Attributes'
,p_region_name=>'PARTAB'
,p_parent_plug_id=>wwv_flow_imp.id(3431364703804901)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>250
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'-'
,p_plug_display_condition_type=>'NOT_EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from   wwv_flow_themes',
'where  flow_id = :fb_flow_id',
'and    nvl(navigation_type,''T'') = ''L'''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(548047061)
,p_plug_name=>'Name'
,p_region_name=>'N'
,p_parent_plug_id=>wwv_flow_imp.id(3431364703804901)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1257318030)
,p_plug_name=>'Image Based Tab Attributes'
,p_region_name=>'IMGTAB'
,p_parent_plug_id=>wwv_flow_imp.id(3431364703804901)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>250
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'-'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(131914703603)
,p_plug_name=>'Layout'
,p_region_name=>'GRID'
,p_parent_plug_id=>wwv_flow_imp.id(3431364703804901)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>120
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(26094145448822952)
,p_plug_name=>'Template Options'
,p_parent_plug_id=>wwv_flow_imp.id(3431364703804901)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(21515661633785596)
,p_plug_name=>'Template Options'
,p_parent_plug_id=>wwv_flow_imp.id(26094145448822952)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.template_types,',
'       o.id,',
'       o.display_name,',
'       o.name,',
'       o.display_sequence,',
'       o.css_classes,',
'       o.flow_id,',
'       o.theme_id,',
'       o.help_text,',
'       o.group_id,',
'       o.page_template_id,',
'       ( select g.display_sequence from wwv_flow_template_opt_groups g where g.id = o.group_id ) group_display_sequence,',
'       ( select g.display_name     from wwv_flow_template_opt_groups g where g.id = o.group_id ) group_display_name',
'  from wwv_flow_template_options o',
' where o.flow_id           = :FB_FLOW_ID',
'   and o.theme_id          = :P4307_THEME',
'   and o.template_types    = ''PAGE''',
'   and o.page_template_id  = :F4000_P4307_ID',
'   and o.security_group_id = :WORKSPACE_ID'))
,p_plug_source_type=>'NATIVE_IG'
,p_ajax_items_to_submit=>'P4307_DEFAULT_TEMPLATE_OPTIONS,P4307_THEME'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Template Options'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(9690272634802635)
,p_name=>'PAGE_TEMPLATE_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'PAGE_TEMPLATE_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>70
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'F4000_P4307_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(13087527981499032)
,p_name=>'GROUP_DISPLAY_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'GROUP_DISPLAY_SEQUENCE'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Group Sequence'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>80
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(13087621620499033)
,p_name=>'GROUP_DISPLAY_NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'GROUP_DISPLAY_NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Group Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>90
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(21516440167785604)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>30
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(21516526316785605)
,p_name=>'DISPLAY_NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DISPLAY_NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>100
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_item_width=>30
,p_is_required=>true
,p_max_length=>30
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_static_id=>'COLUMN_DISPLAY_NAME'
,p_use_as_row_header=>true
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(21516575601785606)
,p_name=>'DISPLAY_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DISPLAY_SEQUENCE'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>'Sequence'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>120
,p_value_alignment=>'RIGHT'
,p_attribute_03=>'left'
,p_attribute_04=>'decimal'
,p_item_width=>5
,p_is_required=>true
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'1'
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(21516690988785607)
,p_name=>'CSS_CLASSES'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'CSS_CLASSES'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Classes'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>130
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_max_length=>255
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(21517042624785610)
,p_name=>'APEX$ROW_ACTION'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>20
,p_use_as_row_header=>false
,p_display_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(21517092101785611)
,p_name=>'APEX$ROW_SELECTOR'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_use_as_row_header=>false
,p_display_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(21518126610785621)
,p_name=>'TEMPLATE_TYPES'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'TEMPLATE_TYPES'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>60
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'PAGE'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(21518188126785622)
,p_name=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Identifier'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>110
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_attribute_06=>'UPPER'
,p_item_width=>30
,p_is_required=>true
,p_max_length=>30
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(22158879215941076)
,p_name=>'HELP_TEXT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'HELP_TEXT'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Help Text'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>150
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(22158981018941077)
,p_name=>'GROUP_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'GROUP_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Group'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>140
,p_value_alignment=>'LEFT'
,p_is_required=>false
,p_lov_type=>'SQL_QUERY'
,p_lov_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name,',
'       id',
'  from wwv_flow_template_opt_groups',
' where template_types = :TEMPLATE_TYPES',
'   and flow_id        = :FB_FLOW_ID',
'   and theme_id       = :P4307_THEME'))
,p_lov_display_extra=>true
,p_lov_display_null=>true
,p_lov_cascade_parent_items=>'TEMPLATE_TYPES'
,p_ajax_items_to_submit=>'P4307_THEME'
,p_ajax_optimize_refresh=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(22159076646941078)
,p_name=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FLOW_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>40
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'FB_FLOW_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(22159195810941079)
,p_name=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'THEME_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>50
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'P4307_THEME'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(21516332370785603)
,p_internal_uid=>21516332370785603
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_add_row_if_empty=>false
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>true
,p_no_data_found_message=>'No template options.'
,p_show_toolbar=>true
,p_toolbar_buttons=>'SEARCH_FIELD:SAVE'
,p_add_button_label=>'Add Template Option'
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>false
,p_define_chart_view=>false
,p_enable_download=>false
,p_download_formats=>null
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function(config) {',
'    config.defaultGridViewOptions = {',
'        reorderColumns: false',
'    }',
'    return config;',
'}'))
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(21952299068924429)
,p_interactive_grid_id=>wwv_flow_imp.id(21516332370785603)
,p_static_id=>'94803'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(21952485086924430)
,p_report_id=>wwv_flow_imp.id(21952299068924429)
,p_view_type=>'GRID'
,p_stretch_columns=>true
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(12475362294158743)
,p_view_id=>wwv_flow_imp.id(21952485086924430)
,p_display_seq=>11
,p_column_id=>wwv_flow_imp.id(22159076646941078)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(12476402101158749)
,p_view_id=>wwv_flow_imp.id(21952485086924430)
,p_display_seq=>12
,p_column_id=>wwv_flow_imp.id(22159195810941079)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(12488214309175382)
,p_view_id=>wwv_flow_imp.id(21952485086924430)
,p_display_seq=>13
,p_column_id=>wwv_flow_imp.id(9690272634802635)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(21953036308924436)
,p_view_id=>wwv_flow_imp.id(21952485086924430)
,p_display_seq=>2
,p_column_id=>wwv_flow_imp.id(21516440167785604)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(21953941268924443)
,p_view_id=>wwv_flow_imp.id(21952485086924430)
,p_display_seq=>4
,p_column_id=>wwv_flow_imp.id(21516526316785605)
,p_is_visible=>true
,p_is_frozen=>false
,p_sort_order=>4
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(21954823805924447)
,p_view_id=>wwv_flow_imp.id(21952485086924430)
,p_display_seq=>6
,p_column_id=>wwv_flow_imp.id(21516575601785606)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>105
,p_sort_order=>3
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(21955669378924452)
,p_view_id=>wwv_flow_imp.id(21952485086924430)
,p_display_seq=>7
,p_column_id=>wwv_flow_imp.id(21516690988785607)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(21958392989924461)
,p_view_id=>wwv_flow_imp.id(21952485086924430)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(21517042624785610)
,p_is_visible=>true
,p_is_frozen=>true
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(22164904459943461)
,p_view_id=>wwv_flow_imp.id(21952485086924430)
,p_display_seq=>10
,p_column_id=>wwv_flow_imp.id(21518126610785621)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(22165813170943467)
,p_view_id=>wwv_flow_imp.id(21952485086924430)
,p_display_seq=>5
,p_column_id=>wwv_flow_imp.id(21518188126785622)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(22169452674943479)
,p_view_id=>wwv_flow_imp.id(21952485086924430)
,p_display_seq=>8
,p_column_id=>wwv_flow_imp.id(22158879215941076)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(22170349443943482)
,p_view_id=>wwv_flow_imp.id(21952485086924430)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(22158981018941077)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(23826057138954788)
,p_view_id=>wwv_flow_imp.id(21952485086924430)
,p_display_seq=>14
,p_column_id=>wwv_flow_imp.id(13087527981499032)
,p_is_visible=>false
,p_is_frozen=>false
,p_sort_order=>1
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(23826938256954791)
,p_view_id=>wwv_flow_imp.id(21952485086924430)
,p_display_seq=>15
,p_column_id=>wwv_flow_imp.id(13087621620499033)
,p_is_visible=>false
,p_is_frozen=>false
,p_sort_order=>2
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(709028592980629349)
,p_name=>'Global Template Options'
,p_parent_plug_id=>wwv_flow_imp.id(26094145448822952)
,p_template=>wwv_flow_imp.id(689970285456172024)
,p_display_sequence=>230
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.id,',
'       o.display_name,',
'       o.display_sequence,',
'       o.css_classes,',
'       g.display_name group_name',
'  from wwv_flow_template_options o,',
'       wwv_flow_template_opt_groups g',
' where o.flow_id              = :FB_FLOW_ID',
'   and o.virtual_template_id    is null',
'   and o.template_types          = ''PAGE''',
'   and o.PAGE_TEMPLATE_ID       is null',
'   and o.security_group_id       = :WORKSPACE_ID',
'   and g.security_group_id   (+) = o.security_group_id',
'   and o.theme_id                = :P4307_THEME',
'   and g.id                  (+) = o.group_id',
' order by',
'       g.display_sequence,',
'       g.display_name,',
'       o.display_sequence,',
'       o.display_name'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P4307_DEFAULT_TEMPLATE_OPTIONS,P4307_THEME'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>200
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No template options defined.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(12481919781138522)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(12482340783138522)
,p_query_column_id=>2
,p_column_alias=>'DISPLAY_NAME'
,p_column_display_sequence=>21
,p_column_heading=>'Name'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(12482708921138523)
,p_query_column_id=>3
,p_column_alias=>'DISPLAY_SEQUENCE'
,p_column_display_sequence=>31
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(12483122544138523)
,p_query_column_id=>4
,p_column_alias=>'CSS_CLASSES'
,p_column_display_sequence=>41
,p_column_heading=>'Classes'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(12483582170138523)
,p_query_column_id=>5
,p_column_alias=>'GROUP_NAME'
,p_column_display_sequence=>11
,p_column_heading=>'Group'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(33421119555122202)
,p_plug_name=>'Subscription'
,p_region_name=>'SUBSCRIPTION'
,p_parent_plug_id=>wwv_flow_imp.id(3431364703804901)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P4307_THEME_IS_SUBSCRIBED'
,p_plug_display_when_cond2=>'NONE'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'WWV_FLOW_TEMPLATES',
  'attribute_02', 'NAME',
  'attribute_03', 'F4000_P4307_ID',
  'attribute_04', 'F4000_P4307_REFERENCE_ID',
  'attribute_05', 'SUBSCRIBE_TEMPLATE')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(34390928027007081)
,p_plug_name=>'Cascading Style Sheet'
,p_region_name=>'CSS'
,p_parent_plug_id=>wwv_flow_imp.id(3431364703804901)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(34407606078341355)
,p_plug_name=>'JavaScript'
,p_region_name=>'JAVASCRIPT'
,p_parent_plug_id=>wwv_flow_imp.id(3431364703804901)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(53603513531407414)
,p_plug_name=>'Dialog'
,p_region_name=>'DIALOG'
,p_parent_plug_id=>wwv_flow_imp.id(3431364703804901)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>140
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(117385421687588488)
,p_plug_name=>'Error Page Template Control'
,p_region_name=>'ERROR'
,p_parent_plug_id=>wwv_flow_imp.id(3431364703804901)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>150
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>250
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'-'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(117398103762627232)
,p_plug_name=>'Comments'
,p_region_name=>'C'
,p_parent_plug_id=>wwv_flow_imp.id(3431364703804901)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>160
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(161865231402504850)
,p_plug_name=>'Substitution Strings'
,p_region_name=>'T'
,p_parent_plug_id=>wwv_flow_imp.id(3431364703804901)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>170
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_region_layout.page_template_substitution(',
'   p_flow=>:FB_FLOW_ID,   ',
'   p_template_id=>:F4000_P4307_ID );',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings=>'Flow:Region:Page'
,p_plug_query_num_rows=>1500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_no_data_found=>'<font class="fielddata">No Utilization Found.</font>'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_break_cols=>'1'
,p_plug_header=>'Substitution strings are used within templates to reference component values.  This report details substitution string usage for this template.'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(262121216799808381)
,p_plug_name=>'Positions'
,p_region_name=>'DISPLAY_POINT'
,p_parent_plug_id=>wwv_flow_imp.id(3431364703804901)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>130
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select "ROWID",',
'       "ID",',
'       "FLOW_ID",',
'       "PAGE_TEMPLATE_ID",',
'       "NAME",',
'       "PLACEHOLDER",',
'       "HAS_GRID_SUPPORT",',
'       "HAS_REGION_SUPPORT",',
'       "HAS_ITEM_SUPPORT",',
'       "HAS_BUTTON_SUPPORT",',
'       "GLV_NEW_ROW",',
'       "MAX_FIXED_GRID_COLUMNS"',
'  from wwv_flow_page_tmpl_disp_points',
' where flow_id           = :FB_FLOW_ID',
'   and page_template_id  = :F4000_P4307_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_plug_source_type=>'NATIVE_IG'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'F4000_P4307_ID'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Positions'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Create positions for this page template. Positions allow to identify where components (regions, items, buttons) will be displayed on this page template.',
'<br />',
'Positions can be used to restrict the placement of regions, items and buttons on this page template by configuring which component type is supported in a position.',
'<br />',
'The <strong>Template Substitution</strong> of a position cannot be one of the reserved page substitution strings, eg. NOTIFICATION_MESSAGE. See section <strong>Substitution Strings</strong> below for a complete list.'))
);
wwv_flow_imp_page.create_region_column_group(
 p_id=>wwv_flow_imp.id(2103274483292119)
,p_heading=>'Grid Layout Rendering'
);
wwv_flow_imp_page.create_region_column_group(
 p_id=>wwv_flow_imp.id(4311638742030101)
,p_heading=>'Component Type Support'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2101874581292105)
,p_name=>'ROWID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ROWID'
,p_data_type=>'ROWID'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>30
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_is_primary_key=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2101910896292106)
,p_name=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FLOW_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>50
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'FB_FLOW_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2102087818292107)
,p_name=>'PAGE_TEMPLATE_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'PAGE_TEMPLATE_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>60
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'F4000_P4307_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2102178764292108)
,p_name=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Position Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>70
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_max_length=>30
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>true
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2102230538292109)
,p_name=>'PLACEHOLDER'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'PLACEHOLDER'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Template Substitution'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>80
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_attribute_06=>'UPPER'
,p_is_required=>true
,p_max_length=>30
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2102308595292110)
,p_name=>'HAS_GRID_SUPPORT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'HAS_GRID_SUPPORT'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SINGLE_CHECKBOX'
,p_heading=>'Grid Support'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>120
,p_value_alignment=>'CENTER'
,p_group_id=>wwv_flow_imp.id(2103274483292119)
,p_use_group_for=>'BOTH'
,p_attribute_01=>'Y'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'Y'
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2102446912292111)
,p_name=>'HAS_REGION_SUPPORT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'HAS_REGION_SUPPORT'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SINGLE_CHECKBOX'
,p_heading=>'Regions'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>90
,p_value_alignment=>'CENTER'
,p_group_id=>wwv_flow_imp.id(4311638742030101)
,p_use_group_for=>'BOTH'
,p_attribute_01=>'Y'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'Y'
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2102504905292112)
,p_name=>'HAS_ITEM_SUPPORT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'HAS_ITEM_SUPPORT'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SINGLE_CHECKBOX'
,p_heading=>'Items'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>100
,p_value_alignment=>'CENTER'
,p_group_id=>wwv_flow_imp.id(4311638742030101)
,p_use_group_for=>'BOTH'
,p_attribute_01=>'Y'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'N'
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2102641659292113)
,p_name=>'HAS_BUTTON_SUPPORT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'HAS_BUTTON_SUPPORT'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SINGLE_CHECKBOX'
,p_heading=>'Buttons'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>110
,p_value_alignment=>'CENTER'
,p_group_id=>wwv_flow_imp.id(4311638742030101)
,p_use_group_for=>'BOTH'
,p_attribute_01=>'Y'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'N'
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2102706624292114)
,p_name=>'GLV_NEW_ROW'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'GLV_NEW_ROW'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SINGLE_CHECKBOX'
,p_heading=>'New Row'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>140
,p_value_alignment=>'CENTER'
,p_group_id=>wwv_flow_imp.id(2103274483292119)
,p_use_group_for=>'BOTH'
,p_attribute_01=>'Y'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'Y'
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2102860268292115)
,p_name=>'MAX_FIXED_GRID_COLUMNS'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'MAX_FIXED_GRID_COLUMNS'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>'Maximum Fixed Grid Columns	'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>130
,p_value_alignment=>'RIGHT'
,p_group_id=>wwv_flow_imp.id(2103274483292119)
,p_use_group_for=>'BOTH'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'P4307_GRID_MAX_COLUMNS'
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2102964446292116)
,p_name=>'APEX$ROW_ACTION'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>20
,p_use_as_row_header=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2103031133292117)
,p_name=>'APEX$ROW_SELECTOR'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_use_as_row_header=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(11786210086314003)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>40
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>false
,p_include_in_export=>false
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(2101731088292104)
,p_internal_uid=>2101731088292104
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_add_row_if_empty=>true
,p_submit_checked_rows=>false
,p_lazy_loading=>true
,p_requires_filter=>false
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>true
,p_show_toolbar=>true
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>true
,p_define_chart_view=>true
,p_enable_download=>true
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(2113442552309866)
,p_interactive_grid_id=>wwv_flow_imp.id(2101731088292104)
,p_static_id=>'21135'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(2113627634309869)
,p_report_id=>wwv_flow_imp.id(2113442552309866)
,p_view_type=>'GRID'
,p_stretch_columns=>true
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2114107496309877)
,p_view_id=>wwv_flow_imp.id(2113627634309869)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(2101874581292105)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2115045805309883)
,p_view_id=>wwv_flow_imp.id(2113627634309869)
,p_display_seq=>2
,p_column_id=>wwv_flow_imp.id(2101910896292106)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2115960837309886)
,p_view_id=>wwv_flow_imp.id(2113627634309869)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(2102087818292107)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2116826732309889)
,p_view_id=>wwv_flow_imp.id(2113627634309869)
,p_display_seq=>4
,p_column_id=>wwv_flow_imp.id(2102178764292108)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>350
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2117754971309891)
,p_view_id=>wwv_flow_imp.id(2113627634309869)
,p_display_seq=>5
,p_column_id=>wwv_flow_imp.id(2102230538292109)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>350
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2118609246309894)
,p_view_id=>wwv_flow_imp.id(2113627634309869)
,p_display_seq=>9
,p_column_id=>wwv_flow_imp.id(2102308595292110)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>100
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2119547934309896)
,p_view_id=>wwv_flow_imp.id(2113627634309869)
,p_display_seq=>6
,p_column_id=>wwv_flow_imp.id(2102446912292111)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>100
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2120429176309899)
,p_view_id=>wwv_flow_imp.id(2113627634309869)
,p_display_seq=>7
,p_column_id=>wwv_flow_imp.id(2102504905292112)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>100
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2121385021309901)
,p_view_id=>wwv_flow_imp.id(2113627634309869)
,p_display_seq=>8
,p_column_id=>wwv_flow_imp.id(2102641659292113)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>100
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2122224638309904)
,p_view_id=>wwv_flow_imp.id(2113627634309869)
,p_display_seq=>12
,p_column_id=>wwv_flow_imp.id(2102706624292114)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>130
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2123166069309907)
,p_view_id=>wwv_flow_imp.id(2113627634309869)
,p_display_seq=>10
,p_column_id=>wwv_flow_imp.id(2102860268292115)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>215
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2203926486396400)
,p_view_id=>wwv_flow_imp.id(2113627634309869)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(2102964446292116)
,p_is_visible=>true
,p_is_frozen=>true
,p_width=>65
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(11798536784339251)
,p_view_id=>wwv_flow_imp.id(2113627634309869)
,p_display_seq=>13
,p_column_id=>wwv_flow_imp.id(11786210086314003)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(262126230150844591)
,p_column_sequence=>1
,p_query_column_name=>'ROWID'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(262126327298844591)
,p_column_sequence=>2
,p_query_column_name=>'FLOW_ID'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(262127203592874554)
,p_column_sequence=>3
,p_query_column_name=>'PAGE_TEMPLATE_ID'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(262126508492844591)
,p_column_sequence=>4
,p_query_column_name=>'NAME'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(262126622408844591)
,p_column_sequence=>5
,p_query_column_name=>'PLACEHOLDER'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(262126717364844591)
,p_column_sequence=>6
,p_query_column_name=>'HAS_GRID_SUPPORT'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(262126802547844591)
,p_column_sequence=>7
,p_query_column_name=>'MAX_FIXED_GRID_COLUMNS'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2104757477592773343)
,p_plug_name=>'Subscription'
,p_parent_plug_id=>wwv_flow_imp.id(3431364703804901)
,p_region_template_options=>'a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>15
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P4307_THEME_IS_SUBSCRIBED = ''BOTH'' then',
'     sys.htp.p(wwv_flow_lang.system_message(''TEMPLATE_SUBSCRIPTION.THEME_AND_TEMPLATE_SUBSCRIBED''));',
'else',
'     sys.htp.p(wwv_flow_lang.system_message(''TEMPLATE_SUBSCRIPTION.THEME_SUBSCRIBED''));',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P4307_THEME_IS_SUBSCRIBED'
,p_plug_display_when_cond2=>'NONE'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46265504325679023)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>180
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(117321519519339260)
,p_plug_name=>'Hidden'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>160
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(615297506447484334)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_imp.id(29434107863295859)
,p_plug_display_sequence=>180
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from  WWV_FLOW_TEMPLATES',
'where id = :F4000_P4307_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :F4000_P4307_ID,',
'      p_component_type => ''List Entry'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(75342716186817071)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(541989765)
,p_button_name=>'APPLY_CHANGES_GET_PREVIOUS_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'disabled=""'
,p_button_comment=>'javascript:htmldb_goSubmit(''GET_PREVIOUS_ID'')'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(75342608829817071)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_imp.id(541989765)
,p_button_name=>'APPLY_CHANGES_GET_NEXT_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Next'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'disabled=""'
,p_button_comment=>'javascript:htmldb_goSubmit(''GET_NEXT_ID'')'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(165188919623029588)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(33421119555122202)
,p_button_name=>'PUBLISH_TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Publish Template'
,p_button_position=>'COPY'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.::F4000_P149_ID,F4000_P149_PAGE_ID,F4000_P149_TEMPLATE_TYPE:&F4000_P4307_ID.,&FLOW_PAGE_ID.,PAGE_TEMPLATE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_templates',
' where reference_id      = :F4000_P4307_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(163582115209140770)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(33421119555122202)
,p_button_name=>'COPY_TEMPLATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Refresh'
,p_button_position=>'COPY'
,p_button_execute_validations=>'N'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_templates',
' where id                = :F4000_P4307_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and reference_id     is not null'))
,p_button_condition_type=>'EXISTS'
,p_button_comment=>'class="fielddatasmall"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(22002144001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(541989765)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(22003144001)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(541989765)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:298:&SESSION.::&DEBUG.::P298_ID:&F4000_P4307_ID.'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P4307_ID is not null',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_comment=>'javascript:confirmDelete(''&DELETE_MSG.'');'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(22004144002)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(541989765)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P4307_ID is not null',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(22005144002)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(541989765)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P4307_ID is null',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(12472305540138494)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_imp.id(26094145448822952)
,p_button_name=>'OPTION_GROUPS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Template Option Groups'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:81:&SESSION.::&DEBUG.:CR,81:P81_THEME_ID,P81_TEMPLATE_TYPE:&P4307_THEME.,PAGE'
,p_button_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(30628311052631110)
,p_branch_name=>'Go To Page 149'
,p_branch_action=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.::F4000_P149_ID,F4000_P149_TEMPLATE_TYPE,F4000_P149_PAGE_ID:&F4000_P4307_ID.,PAGE_TEMPLATE,4307&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P4307_PUBLISH'
,p_branch_condition_text=>'PUBLISH'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(75354001488817237)
,p_branch_action=>'f?p=&APP_ID.:4307:&SESSION.::&DEBUG.::F4000_P4307_ID:&P4307_ID_NEXT.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(75342608829817071)
,p_branch_sequence=>20
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(75354425649817240)
,p_branch_action=>'f?p=&APP_ID.:4307:&SESSION.::&DEBUG.::F4000_P4307_ID:&P4307_ID_PREV.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(75342716186817071)
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(112551849596702847)
,p_branch_action=>'f?p=&APP_ID.:4307:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'F4000_P4307_RETURN_TO_PAGE'
,p_branch_condition_text=>'YES'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(22007144002)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(610545004)
,p_branch_name=>'Go To Page 920'
,p_branch_action=>'f?p=&APP_ID.:920:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>70
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'Copy'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(22008144002)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>80
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'Cancel'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(513170525)
,p_name=>'F4000_P4307_MESSAGE'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(543003816)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Notification'
,p_source=>'MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>32767
,p_cHeight=>15
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Enter HTML or text that will be substituted when the string #NOTIFICATION_MESSAGE# is referenced in the template header, body or footer.</div>',
'<p>',
'<div class="htmldbInfoBodyP">The following substitutions strings are supported in the Notification Subtemplate:',
'<ul>',
'  <li>#MESSAGE#</li>',
'  <li>#NOTIFICATION_MESSAGE_HEADER#</li>',
'</ul>',
'</p>',
'<p>',
'<div class="htmldbInfoBodyP">Use the substitution string #MESSAGE# to indicate where in the Notification Message the body of the message will appear.</div>',
'<div class="htmldbInfoBodyP">For example:</div>',
'<pre>',
'&lt;table&gt;&lt;tr&gt;&lt;td&gt;#MESSAGE#&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;',
'</pre>',
'</p>'))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(802929285)
,p_name=>'F4000_P4307_TEMPLATE_COMMENT'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_imp.id(117398103762627232)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comments'
,p_source=>'TEMPLATE_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'<div class="htmldbInfoBodyP">Developer comments or notes. These comments never display when the application is running.</div>'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1493920202)
,p_name=>'F4000_P4307_SUCCESS_MESSAGE'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(543003816)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Success Message'
,p_source=>'SUCCESS_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>15
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter HTML that will substitute the string #SUCCESS_MESSAGE# in the template body, header or footer.  <br /><br />',
'For example:',
'<pre>',
'&lt;b&gt;#SUCCESS_MESSAGE#&lt;/b&gt;',
'</pre>',
''))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1494929072)
,p_name=>'F4000_P4307_CURRENT_TAB'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(544005752)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Current Tab'
,p_source=>'CURRENT_TAB'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>15
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter HTML or text that will be substituted for the currently selected standard tab.',
'<br /><br />',
'For example:',
'<br /><pre>',
'&lt;td&gt;#TAB_LABEL#&lt;/td&gt;',
'</pre>',
'The following substitution strings are available:',
'<br />',
'<ul>',
'<li>#TAB_LABEL# - required, this displays the tab display text</li>',
'<li>#TAB_IMAGE# - image file name</li>',
'<li>#TAB_INLINE_EDIT# - Allows tab to be edited by application developers</li>',
'<li>#TAB_LINK# - Clicking on this tab goes to this link</li>',
'<li>#TAB_NAME# - Name of the tab, not the display text</li>',
'<li>#TAB_NAME_ENCODED# - Name of the tab encoded</li>',
'<li>#TAB_FONT_ATTRIBUTES# - Embeds text specified in template attribute</li>'))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1495931144)
,p_name=>'F4000_P4307_NON_CURRENT_TAB'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(544005752)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Non Current Standard Tab'
,p_source=>'NON_CURRENT_TAB'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>15
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter HTML or text that will be substituted for the unselected standard tabs.',
'<br /><br />',
'For example:',
'<br /><pre>',
'&lt;td&gt;&lt;a href="#TAB_LINK#"&gt;#TAB_LABEL#&lt;/a&gt;&lt;/td&gt;',
'</pre>',
'The following substitution strings are available:',
'<br />',
'<ul>',
'<li>#TAB_LABEL# - required, this displays the tab display text</li>',
'<li>#TAB_IMAGE# - image file name</li>',
'<li>#TAB_INLINE_EDIT# - Allows tab to be edited by application developers</li>',
'<li>#TAB_LINK# - Clicking on this tab goes to this link</li>',
'<li>#TAB_NAME# - Name of the tab, not the display text</li>',
'<li>#TAB_NAME_ENCODED# - Name of the tab encoded</li>',
'<li>#TAB_FONT_ATTRIBUTES# - Embeds text specified in template attribute</li>'))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2148881144)
,p_name=>'F4000_P4307_NON_CURRENT_IMAGE_TAB'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_imp.id(1257318030)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Non Current Image Tab'
,p_source=>'NON_CURRENT_IMAGE_TAB'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>4000
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the html to be used to indicate that an image tab is not currently selected. Include the #TAB_TEXT# substitution string to show the displayed name of the tab.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8029292853)
,p_name=>'F4000_P4307_BOX'
,p_is_required=>true
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(542993683)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Body'
,p_source=>'BOX'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>15
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the HTML that makes up the BODY of the HTML document.  Include substitution strings to define where the body content is placed and to define additional positions for regions.</p>',
'',
'For example: <br />',
'',
'<pre>',
'   &lt;body #ONLOAD#&gt;',
'      #FORM_OPEN#',
'      #BOX_BODY#',
'      #FORM_CLOSE#',
'      #GENERATED_CSS#',
'      #APEX_JAVASCRIPT#',
'      #THEME_JAVASCRIPT#',
'      #TEMPLATE_JAVASCRIPT#',
'      #APPLICATION_JAVASCRIPT#',
'      #PAGE_JAVASCRIPT#',
'      #GENERATED_JAVASCRIPT#',
'   &lt;/body&gt;',
'</pre>',
'<p>You must include at least #BOX_BODY#, #FORM_OPEN# and #FORM_CLOSE# in this section of the template. The following substitution strings are allowed in the template body:',
'<ul>',
'<li>#BOX_BODY#</li>',
'<li>#GENERATED_CSS#</li>',
'<li>#GENERATED_JAVASCRIPT#</li>',
'<li>#ONLOAD#</li>',
'<li>#TITLE# </li>',
'<li>#PAGE_STATIC_ID#</li>',
'<li>#TOP_GLOBAL_NAVIGATION_LIST#</li>',
'<li>#SIDE_GLOBAL_NAVIGATION_LIST#</li>',
'<li>#NAVIGATION_BAR#</li> ',
'<li>#NOTIFICATION_MESSAGE#</li>',
'<li>#SUCCESS_MESSAGE#</li>',
'<li>#GLOBAL_NOTIFICATION#</li>',
'<li>#APEX_CSS#</li>',
'<li>#THEME_CSS#</li>',
'<li>#TEMPLATE_CSS#</li>',
'<li>#THEME_STYLE_CSS#</li>',
'<li>#APPLICATION_CSS#</li>',
'<li>#PAGE_CSS#</li>',
'<li>#PAGE_CSS_CLASSES#</li>',
'<li>#APEX_JAVASCRIPT#</li>',
'<li>#THEME_JAVASCRIPT#</li>',
'<li>#TEMPLATE_JAVASCRIPT#</li>',
'<li>#APPLICATION_JAVASCRIPT#</li>',
'<li>#PAGE_JAVASCRIPT#</li>',
'<li>#DEVELOPER_TOOLBAR#</li>',
'<li>#SCREEN_READER_TOGGLE#</li>',
'<li>#HIGH_CONTRAST_TOGGLE#</li>',
'<li>#LANGUAGE_SELECTOR#</li>',
'<li>#WELCOME_USER#</li>',
'<li>#HOME_LINK#</li>',
'<li>#LOGOUT_URL#</li>',
'<li>#LOGIN_URL#</li>',
'<li>#REQUESTED_URL#</li>',
'<li>#PAGE_TRANSITION#</li>',
'<li>#POPUP_TRANSITION#</li>',
'<li>#EXPAND_COLLAPSE_NAV_LABEL#</li>',
'<li>#EXPAND_COLLAPSE_SIDE_COL_LABEL#</li>',
'<li>#OUTDATED_BROWSER#</li>',
'<li>#APP_VERSION#</li>',
'<li>#LOGO#</li>',
'<li>#PARENT_TAB_CELLS#</li>',
'<li>#TAB_CELLS#</li>',
'<li>#FORM_OPEN#</li>',
'<li>#FORM_CLOSE#</li>',
'</ul>',
'</p>'))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8029292854)
,p_name=>'F4000_P4307_NAVIGATION_BAR'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(543003816)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Navigation Bar'
,p_source=>'NAVIGATION_BAR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>15
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Enter HTML or text that will be substituted when the string #NAVIGATION_BAR# is referenced in the template header, body or footer.</div>',
'<div class="htmldbInfoBodyP">Use the substitution string #BAR_BODY# to indicate where in the Navigation Bar the entries will appear.</div>',
'<div class="htmldbInfoBodyP">For example:</div>',
'<pre>',
'&lt;table class="navBar"&gt;&lt;tr&gt;#BAR_BODY#&lt;/tr&gt;&lt;/table&gt;',
'</pre>',
'<div class="htmldbInfoBodyP">The #BAR_BODY# substitution string will generate the appropriate HTML table cells.</div>'))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11495931144)
,p_name=>'F4000_P4307_CURRENT_IMAGE_TAB'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_imp.id(1257318030)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Current Image Tab'
,p_source=>'CURRENT_IMAGE_TAB'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>4000
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter HTML to be used to indicate that an image-based tab is currently selected.  Include the #TAB_TEXT# substitution string to show the displayed name of the tab.',
'<br /><br />',
'For example:',
'<pre>',
'&lt;td&gt;#TAB_TEXT#&lt;/td&gt;',
'</pre>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14949290722)
,p_name=>'F4000_P4307_CURRENT_TAB_FONT_ATTR'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(544005752)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Current Tab Font Attributes'
,p_source=>'CURRENT_TAB_FONT_ATTR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>255
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_templates ',
' where CURRENT_TAB_FONT_ATTR is not null ',
'   and id                     = :F4000_P4307_ID',
'   and security_group_id      = :WORKSPACE_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'This attribute is part of the Standard Tab subtemplate.  This value replaces the #TAB_FONT_ATTRIBUTES# substitution string.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'example: face=arial size=-1 color=white'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14959311442)
,p_name=>'F4000_P4307_NON_CURRENT_TAB_FONT_ATTR'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(544005752)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Non Current Tab Font Attributes'
,p_source=>'NON_CURRENT_TAB_FONT_ATTR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>255
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_templates ',
' where NON_CURRENT_TAB_FONT_ATTR is not null ',
'   and id                         = :F4000_P4307_ID',
'   and security_group_id          = :WORKSPACE_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'This attribute is part of the Standard Tab subtemplate.  This value replaces the #TAB_FONT_ATTRIBUTES# substitution string.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21494929072)
,p_name=>'F4000_P4307_TOP_CURRENT_TAB'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(545007733)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Current Parent Tab'
,p_source=>'TOP_CURRENT_TAB'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>15
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter HTML or text that will be substituted for the selected parent tabs.',
'<br /><br />',
'For example:',
'<br /><pre>',
'&lt;td&gt;&lt;a href="#TAB_LINK#"&gt;#TAB_LABEL#&lt;/a&gt;&lt;/td&gt;',
'</pre>',
'This attribute is part of the Parent Tab subtemplate and expands the #PARENT_TAB_CELLS# substitution string. ',
'<br /><br />',
'The following substitution strings are available: ',
'<ul>',
'<li>#TAB_LABEL# - required, represents the label of a tab</li>',
'<li>#TAB_IMAGE# - image file name</li>',
'<li>#TAB_INLINE_EDIT# - places the link that enables developers to perform edits inline</li>',
'<li>#TAB_LINK# - the link used for a tab</li>',
'<li>#TAB_NAME# - the unique name of a tab</li>',
'<li>#TAB_NAME_ENCODED# - the encoded name of a tab</li>',
'<li>#TAB_FONT_ATTRIBUTES# - additional font attributes defined for a tab</li>',
'</ul>'))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21495931144)
,p_name=>'F4000_P4307_TOP_NON_CURRENT_TAB'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_imp.id(545007733)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Non Current Parent Tab'
,p_source=>'TOP_NON_CURRENT_TAB'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>15
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter HTML or text that will be substituted for the unselected parent tabs.',
'<br /><br />',
'For example:',
'<br /><pre>',
'&lt;td&gt;&lt;a href="#TAB_LINK#"&gt;#TAB_LABEL#&lt;/a&gt;&lt;/td&gt;',
'</pre>',
'This attribute is part of the Parent Tab subtemplate and expands the #PARENT_TAB_CELLS# substitution string. ',
'<br /><br />',
'The following substitution strings are available: ',
'<ul>',
'<li>#TAB_LABEL# - required, represents the label of a tab</li>',
'<li>#TAB_IMAGE# - image file name</li>',
'<li>#TAB_INLINE_EDIT# - places the link that enables developers to perform edits inline</li>',
'<li>#TAB_LINK# - the link used for a tab</li>',
'<li>#TAB_NAME# - the unique name of a tab</li>',
'<li>#TAB_NAME_ENCODED# - the encoded name of a tab</li>',
'<li>#TAB_FONT_ATTRIBUTES# - additional font attributes defined for a tab</li>',
'</ul>'))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22009144002)
,p_name=>'F4000_P4307_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>310
,p_item_plug_id=>wwv_flow_imp.id(117321519519339260)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22011144003)
,p_name=>'F4000_P4307_NAME'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(548047061)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies a name for this template.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22012144003)
,p_name=>'F4000_P4307_HEADER_TEMPLATE'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(542993683)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Header'
,p_source=>'HEADER_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>15
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'In the header section of the template, enter the HTML that makes up the <code>&lt;HEAD&gt;</code> section of the HTML document.  That is, all the required HTML tags before the BODY of the HTML document.  Include substitution strings to include dynami'
||'c content. For example: <br />',
'<pre>',
'&lt;html&gt;',
' &lt;head&gt;',
'   &lt;title&gt;#TITLE#&lt;/title&gt;',
'   #APEX_CSS#',
'   #THEME_CSS#',
'   #TEMPLATE_CSS#',
'   #THEME_STYLE_CSS#',
'   #APPLICATION_CSS#',
'   #PAGE_CSS#',
'   #HEAD#',
' &lt;/head&gt;',
'</pre>',
'It is recommended that you include at least #TITLE# and #HEAD# in this template section.  The following substitution strings are supported in the template header:',
'',
'<ul>',
'<li>#TITLE# </li>',
'<li>#HEAD#</li>',
'<li>#ONLOAD#</li>',
'<li>#PAGE_STATIC_ID#</li>',
'<li>#TOP_GLOBAL_NAVIGATION_LIST#</li>',
'<li>#SIDE_GLOBAL_NAVIGATION_LIST#</li>',
'<li>#NAVIGATION_BAR#</li> ',
'<li>#NOTIFICATION_MESSAGE#</li>',
'<li>#SUCCESS_MESSAGE#</li>',
'<li>#GLOBAL_NOTIFICATION#</li>',
'<li>#APEX_CSS#</li>',
'<li>#THEME_CSS#</li>',
'<li>#TEMPLATE_CSS#</li>',
'<li>#THEME_STYLE_CSS#</li>',
'<li>#APPLICATION_CSS#</li>',
'<li>#PAGE_CSS#</li>',
'<li>#PAGE_CSS_CLASSES#</li>',
'<li>#APEX_JAVASCRIPT#</li>',
'<li>#THEME_JAVASCRIPT#</li>',
'<li>#TEMPLATE_JAVASCRIPT#</li>',
'<li>#APPLICATION_JAVASCRIPT#</li>',
'<li>#PAGE_JAVASCRIPT#</li>',
'<li>#DEVELOPER_TOOLBAR#</li>',
'<li>#SCREEN_READER_TOGGLE#</li>',
'<li>#HIGH_CONTRAST_TOGGLE#</li>',
'<li>#LANGUAGE_SELECTOR#</li>',
'<li>#WELCOME_USER#</li>',
'<li>#HOME_LINK#</li>',
'<li>#LOGOUT_URL#</li>',
'<li>#LOGIN_URL#</li>',
'<li>#REQUESTED_URL#</li>',
'<li>#PAGE_TRANSITION#</li>',
'<li>#POPUP_TRANSITION#</li>',
'<li>#EXPAND_COLLAPSE_NAV_LABEL#</li>',
'<li>#EXPAND_COLLAPSE_SIDE_COL_LABEL#</li>',
'<li>#OUTDATED_BROWSER#</li>',
'<li>#APP_VERSION#</li>',
'<li>#LOGO#</li>',
'<li>#PARENT_TAB_CELLS#</li>',
'<li>#TAB_CELLS#</li>',
'<li>#CUSTOMIZE#</li>',
'<li>#FORM_OPEN#</li>',
'<li>#FORM_CLOSE#</li>',
'</ul>'))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22013144004)
,p_name=>'F4000_P4307_FOOTER_TEMPLATE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(542993683)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Footer'
,p_source=>'FOOTER_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>15
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Footer is the third section in the page template that displays after the Body.</p>',
'',
'<p>The following substitution strings are supported in the template footer:',
'',
'<ul>',
'<li>#GENERATED_CSS#</li>',
'<li>#GENERATED_JAVASCRIPT#</li>',
'<li>#PAGE_STATIC_ID#</li>',
'<li>#TOP_GLOBAL_NAVIGATION_LIST#</li>',
'<li>#SIDE_GLOBAL_NAVIGATION_LIST#</li>',
'<li>#NAVIGATION_BAR#</li> ',
'<li>#NOTIFICATION_MESSAGE#</li>',
'<li>#SUCCESS_MESSAGE#</li>',
'<li>#GLOBAL_NOTIFICATION#</li>',
'<li>#APEX_CSS#</li>',
'<li>#THEME_CSS#</li>',
'<li>#TEMPLATE_CSS#</li>',
'<li>#THEME_STYLE_CSS#</li>',
'<li>#APPLICATION_CSS#</li>',
'<li>#PAGE_CSS#</li>',
'<li>#PAGE_CSS_CLASSES#</li>',
'<li>#APEX_JAVASCRIPT#</li>',
'<li>#THEME_JAVASCRIPT#</li>',
'<li>#TEMPLATE_JAVASCRIPT#</li>',
'<li>#APPLICATION_JAVASCRIPT#</li>',
'<li>#PAGE_JAVASCRIPT#</li>',
'<li>#DEVELOPER_TOOLBAR#</li>',
'<li>#SCREEN_READER_TOGGLE#</li>',
'<li>#HIGH_CONTRAST_TOGGLE#</li>',
'<li>#LANGUAGE_SELECTOR#</li>',
'<li>#WELCOME_USER#</li>',
'<li>#HOME_LINK#</li>',
'<li>#LOGOUT_URL#</li>',
'<li>#LOGIN_URL#</li>',
'<li>#REQUESTED_URL#</li>',
'<li>#PAGE_TRANSITION#</li>',
'<li>#POPUP_TRANSITION#</li>',
'<li>#EXPAND_COLLAPSE_NAV_LABEL#</li>',
'<li>#EXPAND_COLLAPSE_SIDE_COL_LABEL#</li>',
'<li>#OUTDATED_BROWSER#</li>',
'<li>#APP_VERSION#</li>',
'<li>#LOGO#</li>',
'<li>#PARENT_TAB_CELLS#</li>',
'<li>#TAB_CELLS#</li>',
'<li>#CUSTOMIZE#</li>',
'<li>#FORM_OPEN#</li>',
'<li>#FORM_CLOSE#</li>',
'</ul>'))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(50737423740)
,p_name=>'F4000_P4307_RETURN_TO_PAGE'
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_imp.id(547026858)
,p_prompt=>'Stay on page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select this checkbox to stay on this page after applying changes.'
,p_attribute_01=>'N'
,p_attribute_02=>'YES'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(131640028108)
,p_name=>'F4000_P4307_REG_TAB_CATTR'
,p_item_sequence=>390
,p_item_plug_id=>wwv_flow_imp.id(131914703603)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Region Table Attributes'
,p_source=>'REGION_TABLE_CATTRIBUTES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>255
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'<p>If the &PRODUCT_NAME. engine displays regions in multiple columns in the same region position then &PRODUCT_NAME. will render an HTML table.  This attribute enables you to control the attributes of the &lt;table&gt; tag.</p>'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(214949290722)
,p_name=>'F4000_P4307_TOP_CURRENT_TAB_FONT_ATTR'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_imp.id(545007733)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Parent Current Tab Font Attributes'
,p_source=>'TOP_CURRENT_TAB_FONT_ATTR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>255
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_templates ',
' where TOP_CURRENT_TAB_FONT_ATTR is not null ',
'   and id                         = :F4000_P4307_ID',
'   and security_group_id          = :WORKSPACE_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>This attribute is part of the Parent Tab subtemplate and expands the #PARENT_TAB_CELLS# substitution string. A "current tab" is a tab that is current for the current page. This attribute controls the font used to display the parent tab text.</p>'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
,p_item_comment=>'example: face=arial size=-1 color=white'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(214959311442)
,p_name=>'F4000_P4307_TOP_NON_CURRENT_TAB_FONT_ATTR'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_imp.id(545007733)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Parent Non Current Tab Font Attributes'
,p_source=>'TOP_NON_CURRENT_TAB_FONT_ATTR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>255
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_templates ',
' where TOP_NON_CURRENT_TAB_FONT_ATTR is not null ',
'   and id                             = :F4000_P4307_ID',
'   and security_group_id              = :WORKSPACE_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>This attribute is part of the Parent Tab subtemplate and expands the #PARENT_TAB_CELLS# substitution string. A "non current tab" is a tab that is NOT current for the current page. This attribute controls the font used to display the parent tab tex'
||'t. </p>'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3691714003171)
,p_name=>'P4307_DIALOG_CANCEL_CODE'
,p_item_sequence=>1340
,p_item_plug_id=>wwv_flow_imp.id(34407606078341355)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Dialog Cancel Code'
,p_source=>'DIALOG_JS_CANCEL_CODE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter JavaScript code to cancel the dialog page. The substitution string will be replaced with its respective value at rendering time. .<p/>',
'The default JavaScript call to cancel a dialog is:<p/><strong>',
'apex.navigation.dialog.cancel(#IS_MODAL#);</strong>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4312042879030105)
,p_name=>'P4307_BREADCRUMB_DP_TEMP'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(262121216799808381)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4312119707030106)
,p_name=>'P4307_SIDEBAR_DP_TEMP'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(262121216799808381)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12472748969138498)
,p_name=>'P4307_PRESET_TEMPLATE_OPTIONS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(26094145448822952)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Preset Template Options:'
,p_source=>'PRESET_TEMPLATE_OPTIONS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.TEMPALTE_OPT_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.display_name as d,',
'       o.css_classes as r,',
'       null default_template_options,',
'       null,',
'       o.help_text,',
'       g.display_name group_name,',
'       g.is_advanced advanced_group,',
'       g.null_text',
'  from wwv_flow_template_options o,',
'       wwv_flow_template_opt_groups g,',
'       wwv_flow_templates t',
' where o.flow_id               = :fb_flow_id',
'   and o.template_types        = ''PAGE''',
'   and (page_template_id       = :f4000_p4307_id or page_template_id is null)',
'   and o.theme_id              = t.theme_id',
'   and t.id                    = :f4000_p4307_id',
'   and g.id                (+) = o.group_id',
'   and o.security_group_id     = :WORKSPACE_ID',
'   and g.security_group_id (+) = o.security_group_id',
'   and t.security_group_id     = o.security_group_id',
' order by ',
'       g.is_advanced nulls first,',
'       g.display_sequence nulls first,',
'       g.display_name nulls first,',
'       o.display_sequence,',
'       o.display_name'))
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_attribute_02=>'N'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12473064237138500)
,p_name=>'P4307_DEFAULT_TEMPLATE_OPTIONS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(26094145448822952)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Default Template Options:'
,p_source=>'DEFAULT_TEMPLATE_OPTIONS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.TEMPALTE_OPT_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.display_name as d,',
'       o.css_classes as r,',
'       t.default_template_options,',
'       null,',
'       o.help_text,',
'       g.display_name group_name',
'  from wwv_flow_template_options o,',
'       wwv_flow_template_opt_groups g,',
'       wwv_flow_templates t',
' where o.flow_id               = :fb_flow_id',
'   and t.id                    = o.page_template_id',
'   and o.page_template_id      = :f4000_p4307_id',
'   and g.id                (+) = o.group_id',
'   and o.security_group_id     = :workspace_id',
'   and g.security_group_id (+) = o.security_group_id',
'   and t.security_group_id     = o.security_group_id',
' order by',
'       g.display_sequence nulls first,',
'       g.display_name nulls first,',
'       o.display_sequence,',
'       o.display_name'))
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12473430018138500)
,p_name=>'P4307_PRESET_TMPLOPT_CHECK'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(26094145448822952)
,p_use_cache_before_default=>'NO'
,p_source=>'P4307_PRESET_TEMPLATE_OPTIONS'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(24140521005219980)
,p_name=>'P4307_TRANSLATABLE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(548047061)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Translatable'
,p_source=>'TRANSLATE_THIS_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30626103986543906)
,p_name=>'P4307_PUBLISH'
,p_item_sequence=>300
,p_item_plug_id=>wwv_flow_imp.id(547026858)
,p_prompt=>'Publish on Save'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select this checkbox to publish this template after applying changes.'
,p_attribute_01=>'N'
,p_attribute_02=>'PUBLISH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(31558329325911721)
,p_name=>'P4307_BREADCRUMB_DISPLAY_POINT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(262121216799808381)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Breadcrumb Position'
,p_source=>'BREADCRUMB_DEF_REG_POS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r',
'from (',
'    select lov_disp_value d,',
'           lov_return_value r,',
'           1 seq1,',
'           lov_disp_sequence seq2',
'      from wwv_flow_lists_of_values$ lov',
'      join wwv_flow_list_of_values_data lovd on lovd.lov_id = lov.id',
'     where lov.lov_name = ''REGION_DISPLAY_POINT''',
'       and lov.flow_id = :FB_FLOW_ID',
'       and lov.security_group_id = :flow_security_group_id',
'    ',
'    union all',
'    ',
'    select name d,',
'           placeholder r,',
'           2 seq1,',
'           id seq2',
'      from wwv_flow_page_tmpl_disp_points',
'     where flow_id           = :FB_FLOW_ID',
'       and page_template_id  = :F4000_P4307_ID',
'       and security_group_id = :WORKSPACE_ID',
')',
'',
'order by seq1, seq2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Not Identified -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Applies to generated components that use Breadcrumbs. Defines where Breadcrumbs are placed on the page.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(31567909286934250)
,p_name=>'P4307_SIDEBAR_DISPLAY_POINT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(262121216799808381)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Sidebar Position'
,p_source=>'SIDEBAR_DEF_REG_POS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r',
'from (',
'    select lov_disp_value d,',
'           lov_return_value r,',
'           1 seq1,',
'           lov_disp_sequence seq2',
'      from wwv_flow_lists_of_values$ lov',
'      join wwv_flow_list_of_values_data lovd on lovd.lov_id = lov.id',
'     where lov.lov_name = ''REGION_DISPLAY_POINT''',
'       and lov.flow_id = :FB_FLOW_ID',
'       and lov.security_group_id = :flow_security_group_id',
'    ',
'    union all',
'    ',
'    select name d,',
'           placeholder r,',
'           2 seq1,',
'           id seq2',
'      from wwv_flow_page_tmpl_disp_points',
'     where flow_id           = :FB_FLOW_ID',
'       and page_template_id  = :F4000_P4307_ID',
'       and security_group_id = :WORKSPACE_ID',
')',
'',
'order by seq1, seq2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Not Identified -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Applies to generated components that use Sidebars. Defines where Sidebars are placed on the page.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33911014789412987)
,p_name=>'F4000_P4307_REFRESH'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(33421119555122202)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Refresh'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_templates',
' where reference_id     is null',
'   and id                = :F4000_P4307_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(34391125123007081)
,p_name=>'P4307_CSS_FILE_URLS'
,p_item_sequence=>930
,p_item_plug_id=>wwv_flow_imp.id(34390928027007081)
,p_use_cache_before_default=>'NO'
,p_prompt=>'File URLs'
,p_source=>'CSS_FILE_URLS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>3
,p_tag_css_classes=>'a-Form-textarea--code'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter Cascading Style Sheet file URLs to be loaded for this page template. Each URL has to be written into a new line. If you provide a minified version of your file you can use the substitution string <code>#MIN#</code> to include <code>.min</cod'
||'e> or <code>#MIN_DIRECTORY#</code> to include <code>minified/</code> in your file URL for a regular page view and an empty string if the page is viewed in debug mode. You also have access to the substitution string <code>#APP_VERSION#</code> if you w'
||'ant to include the application''s version in the file URL.</p>',
'',
'<p>File URLs you enter here will replace the <code>#TEMPLATE_CSS#</code> substitution string in the template.</p>',
'',
'<p>Note: You do not need to include opening or closing <code>link</code> tags. Just include the file URL.</p>',
'',
'<p>',
'Examples:',
'<ul>',
'  <li>Standard file reference',
'      <pre>/mycss/main.css</pre>',
'  </li>',
'  <li>Standard file reference which loads the minified file main.min.css from /mycss/minified/ for regular page views and main.css from /mycss/ in debug mode.',
'      <pre>/mycss/#MIN_DIRECTORY#main#MIN#.css</pre>',
'  </li>',
'  <li>Conditional media query',
'      <pre>[media="only screen and (max-device-width: 480px)"]/mycss/smartphone.css</pre>',
'  </li>',
'  <li>File reference using a query string in the URL referencing the application version, such that when the application is upgraded (and the version is incremented), the browser will be instructed to always load the new file and ignore any previousl'
||'y cached files.',
'      <pre>/mycss/main.css?version=#APP_VERSION#</pre>',
'  </li>',
'</ul>',
'</p>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(34391627520007082)
,p_name=>'P4307_INLINE_CSS'
,p_item_sequence=>940
,p_item_plug_id=>wwv_flow_imp.id(34390928027007081)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Inline'
,p_source=>'INLINE_CSS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>15
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter Cascading Style Sheet code to be used for this page template. Consider putting it into an external file to avoid duplication and to leverage browser caching of static files.</p>',
'',
'<p>Code you enter here replaces the <code>#TEMPLATE_CSS#</code> substitution string in the template.</p>',
'',
'<p>Note: You do not need to include opening or closing <code>style</code> tags. Just include the cascading style sheet code.</p>',
'',
'<p>',
'Example to set the CSS class <code>display_only</code> to bold',
'<pre>',
'.display_only {',
'  font-weight:bold;',
'}',
'</pre>',
'</p>'))
,p_attribute_01=>'CSS'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(34407825067341355)
,p_name=>'P4307_JAVASCRIPT_FILE_URLS'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(34407606078341355)
,p_use_cache_before_default=>'NO'
,p_prompt=>'File URLs'
,p_source=>'JAVASCRIPT_FILE_URLS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>3
,p_tag_css_classes=>'a-Form-textarea--code'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter JavaScript file URLs for code to be loaded on this page. Each URL has to be written into a new line. If you provide a minified version of your file you can use the substitution string <code>#MIN#</code> to include <code>.min</code> or <code>'
||'#MIN_DIRECTORY#</code> to include <code>minified/</code> in your file URL for a regular page view and an empty string if the page is viewed in debug mode. You also have access to the substitution string <code>#APP_VERSION#</code> if you want to inclu'
||'de the application''s version in the file URL.</p>',
'',
'<p>JavaScript file URLs you enter here replaces the <code>#TEMPLATE_JAVASCRIPT#</code> substitution string in the page template.</p>',
'',
'<p>Note: You do not need to include opening or closing <code>script</code> tags. Just write the URL.',
'',
'<p>',
'Examples:',
'<ul>',
'  <li>Standard file reference',
'      <pre>/myjs/main.js</pre>',
'  </li>',
'  <li>Standard file reference which loads the minified file main.min.js from /myjs/minified/ for regular page views and main.js from /myjs/ in debug mode.',
'      <pre>/myjs/#MIN_DIRECTORY#main#MIN#.js</pre>',
'  </li>',
'  <li>Use this syntax if the library is also used from a RequireJS require call. The define name must match what is used in the requirejs.config paths and the value must be the global symbol exposed by the library. Only applies when using RequireJS. '
||'This avoids RequireJS  loading that library a second time.',
'      <pre>[define hammerjs=Hammer]/myjs/hammer.js</pre>',
'  </li>',
'  <li>Use this syntax if the file has a dependency on RequireJS. This will automatically load RequireJS before this file.',
'      <pre>[require requirejs]/myjs/main.js</pre>',
'  </li>',
'  <li>Use this syntax if the file has a dependency on Oracle JET. This will automatically load RequireJS and the Oracle JET RequireJS configuration before this file.',
'      <pre>[require jet]/myjs/main.js</pre>',
'  </li>',
'  <li>File reference using a query string in the URL referencing the application version, such that when the application is upgraded (and the version is incremented), the browser will be instructed to always load the new file and ignore any previousl'
||'y cached files.',
'      <pre>/myjs/main.js?version=#APP_VERSION#</pre>',
'  </li>',
'</ul>',
'</p>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(38294618517561859)
,p_name=>'P4307_JAVASCRIPT_CODE'
,p_item_sequence=>960
,p_item_plug_id=>wwv_flow_imp.id(34407606078341355)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Function and Global Variable Declaration'
,p_source=>'JAVASCRIPT_CODE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>15
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter JavaScript code (for example, functions or global variable declarations) for code to be used in this page template. Consider putting it into an external file to avoid duplication and to leverage browser caching of static files.</p>',
'',
'<p>Code you enter here replaces the <code>#TEMPLATE_JAVASCRIPT#</code> substitution string in the page template.</p>',
'',
'<p>Note: You do not need to include opening or closing <code>script</code> tags. Just include the JavaScript code.</p>',
'',
'<p>To reference a shortcut, use &quot;SHORTCUTNAME&quot;.</p>'))
,p_attribute_01=>'JAVASCRIPT'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(38295131330565573)
,p_name=>'P4307_JAVASCRIPT_CODE_ONLOAD'
,p_item_sequence=>970
,p_item_plug_id=>wwv_flow_imp.id(34407606078341355)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Execute when Page Loads'
,p_source=>'JAVASCRIPT_CODE_ONLOAD'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>15
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter JavaScript code to execute when the page loads. The code is executed after the JavaScript code generated by &PRODUCT_NAME..</p>',
'',
'<p>Code you enter here replaces the <code>#GENERATED_JAVASCRIPT#</code> substitution string in the page template.</p>',
'',
'<p>Note: You do not need to add any opening or closing <code>script</code> tags, just the JavaScript code.</p>',
''))
,p_attribute_01=>'JAVASCRIPT'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(38986814262975620)
,p_name=>'P4307_NAVBAR_ENTRY'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(543003816)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Navigation Bar Entry'
,p_source=>'NAVBAR_ENTRY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>32767
,p_cHeight=>15
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The following will be substituted into the navigation bar #BAR_BODY# for each navigation bar entry.  Use the following substitution strings to compose the navigation bar entry sub template.',
'<ul class="noIndent">',
'<li>#LINK# - entry link</li>',
'<li>#TEXT# - entry sub text</li>',
'<li>#IMAGE# - entry image (HTML image ALT, HEIGHT, and WIDTH arguments will be included with the HTML IMG tag when supplied with the navigation bar entry)',
'<li>#WIDTH# - Image width</li>',
'<li>#HEIGHT# - Image height</li>',
'<li>#COLSPAN# - HTML COLSPAN value</li>',
'<li>#ALT# - Image alternative text</li>',
'</ul>'))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(39616011051963782)
,p_name=>'P4307_IS_POPUP'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(548047061)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Template Type'
,p_source=>'IS_POPUP'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE_TEMPLATE_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(361310216348385184)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identifies the page template type. When set to <strong>Dialog Page</strong>, the template will only be available for selection by a page with a page mode of Modal Dialog or Non-Modal Dialog.  When set to <strong>Normal Page</strong>, the template wil'
||'l only be available for selection by a page with a page mode of Normal.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40806100730333001)
,p_name=>'P4307_N'
,p_item_sequence=>360
,p_item_plug_id=>wwv_flow_imp.id(541989765)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select substr ( name, 1, 80 ) ',
'  from WWV_FLOW_TEMPLATES ',
' where id                = :F4000_P4307_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies template name'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(41971024675100523)
,p_name=>'P4307_THEME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(548047061)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Theme:'
,p_source=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_tag_css_classes=>'fielddatabold'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the theme to which this template is associated. A theme is a grouping of templates which together provide layout and style for an application.'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(41975001866122334)
,p_name=>'P4307_THEME_CLASS_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(548047061)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Template Class'
,p_source=>'THEME_CLASS_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE THEME CLASS ID'
,p_lov=>'.'||wwv_flow_imp.id(41972431732112027)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Not Identified -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Identifies a specific usage for this template.</div>',
'<div class="htmldbInfoBodyP">When you switch to a new theme, all templates in one theme are assigned to corresponding templates in another theme. App Builder accomplishes this template mapping through the assignment of template class identifiers.<p /'
||'>',
'Use the <strong>Translatable</strong> check box to indicate if this template contains text strings that require translation. ',
'</div>'))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(44400104182090696)
,p_name=>'P4307_DIALOG_JS_INIT_CODE'
,p_item_sequence=>1300
,p_item_plug_id=>wwv_flow_imp.id(34407606078341355)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Dialog Initialization Code'
,p_source=>'DIALOG_JS_INIT_CODE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter JavaScript code to initialize the page as a dialog. The substitution strings will be replaced with their respective values at rendering time.  For example, #DIALOG_ATTRIBUTES# will be replaced by custom attributes defined in the ''Dialog Attribu'
||'tes'' item on the Edit Page.<p/>',
'The default JavaScript call for initializing a dialog is:<p/><strong>',
'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);</strong>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(53603824389412903)
,p_name=>'P4307_DIALOG_WIDTH'
,p_item_sequence=>1305
,p_item_plug_id=>wwv_flow_imp.id(53603513531407414)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Width'
,p_source=>'DIALOG_WIDTH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the default width of a dialog, in pixels or percent. This setting will be overwritten by a dialog width specified at page level.<p/>',
'For a page using a Desktop user interface, the value should be set in pixels, for example, 500. For a page using the jQuery Mobile Smartphone user interface, the value should be set in percent, for example, 80%.<p/>',
'',
'The substitution string #DIALOG_WIDTH# in the dialog initialization code will be replaced with the dialog width specified.'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(53604016194416715)
,p_name=>'P4307_DIALOG_MAX_WIDTH'
,p_item_sequence=>1320
,p_item_plug_id=>wwv_flow_imp.id(53603513531407414)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Maximum Width'
,p_source=>'DIALOG_MAX_WIDTH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the default maximum width of a dialog, in pixels. This setting will be overwritten by a dialog maximum width specified at page level.<p/>',
'',
'For a page using the jQuery Mobile Smartphone user interface, the maximum width is 500.<p/>',
'',
'The substitution string #DIALOG_MAX_WIDTH# in the dialog initialization code will be replaced with the dialog maximum width specified. '))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(75351815043817215)
,p_name=>'P4307_ID_NEXT'
,p_item_sequence=>330
,p_item_plug_id=>wwv_flow_imp.id(117321519519339260)
,p_prompt=>'P4307_ID_NEXT'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(75352216490817217)
,p_name=>'P4307_ID_PREV'
,p_item_sequence=>340
,p_item_plug_id=>wwv_flow_imp.id(117321519519339260)
,p_prompt=>'P4307_ID_PREV'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(75352613675817220)
,p_name=>'P4307_ID_COUNT'
,p_item_sequence=>350
,p_item_plug_id=>wwv_flow_imp.id(541989765)
,p_prompt=>'Page Template'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Edit page template.'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(89504404889471393)
,p_name=>'P4307_DIALOG_HEIGHT'
,p_item_sequence=>1310
,p_item_plug_id=>wwv_flow_imp.id(53603513531407414)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Height'
,p_source=>'DIALOG_HEIGHT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the height of the dialog, in pixels, for example, <strong><i>500</i></strong>. This setting will be overwritten by a dialog height specified at page level.<p/> The substitution string #DIALOG_HEIGHT# in the dialog initialization code of the pag'
||'e template will be replaced with the dialog height specified.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(117381119974574119)
,p_name=>'F4000_P4307_ERROR_PAGE_TEMPLATE'
,p_item_sequence=>270
,p_item_plug_id=>wwv_flow_imp.id(117385421687588488)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Error Page Template'
,p_source=>'ERROR_PAGE_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>32767
,p_cHeight=>15
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use this attribute when a page template is designated as an error template. Supported substitution strings include:</p>',
'<ul>',
'<li>#MESSAGE# and #ADDITIONAL_INFO# - Places the error message. </li>',
'<li>#TECHNICAL_INFO# - Displays detailed internal error information which will just be visible for developers.</li>',
'<li>#BACK_LINK# - Displays a link back to the previous page. </li>',
'<li>#OK# and #RETURN_TO_APPLICATION# - Returns translated text strings. </li>',
'</ul>',
''))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(162671431587462663)
,p_name=>'F4000_P4307_REFERENCE_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(33421119555122202)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Reference Master Template From'
,p_source=>'REFERENCE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FLOW_SUBSCRIBE_FROM_PAGE_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''|| lower(wwv_flow_lang.system_message(''NO_TEMPLATE'')) || '' -'' d, 0 r ',
'  from sys.dual union all',
'select d, r ',
'  from ( select flow_id || '' : '' || name || decode ( theme_id, null, '''', '' (''||theme_id||'')'') d, id r',
'           from wwv_flow_templates',
'          where  flow_id != nvl(:fb_flow_id,0)',
'            and flow_id in ( select f.id',
'                               from   wwv_main_apps_dev f',
'                              where  security_group_id = :flow_security_group_id ',
'                                and  build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') ',
'                                and exists ( select 1 from wwv_flow_developers',
'                                              where userid = :flow_user ',
'                                                and ( flow_id is null or flow_id = f.id) ',
'                                                and security_group_id = :flow_security_group_id',
'                                            )',
'                            )',
'          order by 1',
'        )'))
,p_cSize=>60
,p_cMaxlength=>2000
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">You may select an existing template in this workspace or another template in your workspace''s schema. By selecting an existing template, you become a subscriber to that template.</div>',
'<div class="htmldbInfoBodyP">To load a new copy of any master template, click <span class="fielddatabold">Refresh</span>.</div>',
''))
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(203351726181564628)
,p_name=>'P4307_GRID_TEMPLATE'
,p_item_sequence=>400
,p_item_plug_id=>wwv_flow_imp.id(131914703603)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Container Template'
,p_source=>'GRID_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>15
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specifies the markup to start a new layout. You must include at least #ROWS# in this template. The following substitution strings are allowed in the container template:</p>',
'<ul>',
'<li><strong>#USED_COLUMNS_NUMBER#</strong> - Number of used columns. For example: 1, 2, 3, ...</li>',
'<li><strong>#USED_COLUMNS_ALPHA#</strong> - Alphabet character representing the number of used columns. For example: a, b, c, ...</li>',
'<li><strong>#USED_COLUMNS_ALPHA_MINUS#</strong> - Alphabet character representing the number of used columns which are reduced by one column. For example: Two columns will return "a".</li>',
'<li><strong>#USED_COLUMNS_WORD#</strong> - Word representing the number of used columns. For example: one, two, three, ...</li>',
'<li><strong>#USED_COLUMNS_PLURAL#</strong> - Gets substituted by "s" if the number of columns is bigger than one. Use it if the layout requires a class name "column" for a single column and "columns" if multiple columns are specified. For example: cl'
||'ass="#USED_COLUMNS_WORD# column#USED_COLUMNS_PLURAL#"</li>',
'<li><strong>#ROWS#</strong> - Substituted by the "Row Template".</li>',
'</ul>',
'<p>',
'Example:',
'<pre>',
'&lt;div class="ui-grid-#USED_COLUMNS_ALPHA_MINUS#"&gt;#ROWS#&lt;/div&gt;',
'</pre>',
'</p>'))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(203352930914577600)
,p_name=>'P4307_GRID_ROW_TEMPLATE'
,p_item_sequence=>410
,p_item_plug_id=>wwv_flow_imp.id(131914703603)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Row Template'
,p_source=>'GRID_ROW_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>15
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specifies the markup to start a new layout row. You must include at least #COLUMNS# in this template. The following substitution string is allowed in the row template:</p>',
'<ul>',
'<li><strong>#COLUMNS#</strong> - Substituted by the "Column Template".</li>',
'<li><strong>#CSS_CLASSES#</strong> - Substituted by the value specified as "Row CSS Classes". This allows to further customize a layout row with CSS classes.</li>',
'</ul>',
'<p>',
'Example:',
'<pre>',
'&lt;div class="row"&gt;#COLUMNS#&lt;/div&gt;',
'</pre>',
'</p>'))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(203353124660580498)
,p_name=>'P4307_GRID_COLUMN_TEMPLATE'
,p_item_sequence=>420
,p_item_plug_id=>wwv_flow_imp.id(131914703603)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Column Template'
,p_source=>'GRID_COLUMN_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>15
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specifies the markup to start a new layout column. You must include at least #CONTENT# in this template. The following substitution strings are allowed in the column template:</p>',
'<ul>',
'<li><strong>#COLUMN_NUMBER#</strong> - Number of the column. For example: 1, 2, 3, ...</li>',
'<li><strong>#COLUMN_ALPHA#</strong> - Alphabet character representing the column. For example: a, b, c, ...</li>',
'<li><strong>#COLUMN_WORD#</strong> - Word representing the column. For example: one, two, three, ...</li>',
'<li><strong>#COLUMN_PLURAL#</strong> - Gets substituted by "s" if the column is bigger than one. Use it if the layout requires a class name "column" for the first column and "columns" for the following columns. For example: class="#COLUMN_WORD# colum'
||'n#COLUMN_PLURAL#"</li>',
'<li><strong>#COLUMN_SPAN_NUMBER#</strong> - Number of the column span. For example: 1, 2, 3, ...</li>',
'<li><strong>#COLUMN_SPAN_ALPHA#</strong> - Alphabet character representing the column span. For example: a, b, c, ...</li>',
'<li><strong>#COLUMN_SPAN_WORD#</strong> - Word representing the column span. For example: one, two, three, ...</li>',
'<li><strong>#COLUMN_SPAN_PLURAL#</strong> - Gets substituted by "s" if the column span is bigger than one. Use it if the layout requires a class name "column" for a single column span and "columns" if multiple columns are specified. For example: clas'
||'s="#COLUMN_SPAN_WORD# column#COLUMN_SPAN_PLURAL#"</li>',
'<li><strong>#CSS_CLASSES#</strong> - Substituted by the value specified as "Column CSS Classes". This allows to further customize a column with CSS classes.</li>',
'<li><strong>#ATTRIBUTES#</strong> - Substituted by the value specified as "Column Attributes". This allows to further customize a column.</li>',
'<li><strong>#FIRST_LAST_COLUMN_ATTRIBUTES#</strong> - Substituted by the value specified in "First Column Attributes" and "Last Column Attributes" depending if it''s the first or last column.</li>',
'<li><strong>#CONTENT#</strong> - Substituted by the regions, page items or buttons displayed in the column.</li>',
'</ul>',
'<p>',
'Example:',
'<pre>',
'&lt;div class="#COLUMN_SPAN_WORD# column#COLUMN_SPAN_PLURAL# #CSS_CLASSES#"&gt;#CONTENT#&lt;/div&gt;',
'</pre>',
'</p>'))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(203354207813618760)
,p_name=>'P4307_GRID_FIRST_COLUMN_ATTRIBUTES'
,p_item_sequence=>370
,p_item_plug_id=>wwv_flow_imp.id(131914703603)
,p_use_cache_before_default=>'NO'
,p_prompt=>'First Column Attributes'
,p_source=>'GRID_FIRST_COLUMN_ATTRIBUTES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>255
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Specify the value which should substitute #FIRST_LAST_COLUMN_ATTRIBUTES# in the Column Template if it''s the first layout column.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(203354927210624892)
,p_name=>'P4307_GRID_LAST_COLUMN_ATTRIBUTES'
,p_item_sequence=>380
,p_item_plug_id=>wwv_flow_imp.id(131914703603)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Last Column Attributes'
,p_source=>'GRID_LAST_COLUMN_ATTRIBUTES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>255
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Specify the value which should substitute #FIRST_LAST_COLUMN_ATTRIBUTES# in the Column Template if it''s the last layout column.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(203355117074629639)
,p_name=>'P4307_GRID_JAVASCRIPT_DEBUG_CODE'
,p_item_sequence=>430
,p_item_plug_id=>wwv_flow_imp.id(131914703603)
,p_use_cache_before_default=>'NO'
,p_prompt=>'JavaScript Debug Code'
,p_source=>'GRID_JAVASCRIPT_DEBUG_CODE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>90
,p_cMaxlength=>4000
,p_cHeight=>15
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>JavaScript code which gets executed to provide additional layout help when the "Show Layout Columns" and "Hide Layout Columns" buttons in the developer toolbar are clicked. The JavaScript code has to register to the JavaScript events "apex-devbar-'
||'grid-debug-on" and "apex-devbar-grid-debug-off".',
'</p>',
'<p>',
'The following example registers the JavaScript functions showLayoutColumns and hideLayoutColumns for the above events.',
'<pre>',
'apex.jQuery(document)',
'    .on("apex-devbar-grid-debug-on", showLayoutColumns)',
'    .on("apex-devbar-grid-debug-off", hideLayoutColumns);',
'</pre>',
'</p>',
''))
,p_attribute_01=>'JAVASCRIPT'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(203355426982640216)
,p_name=>'P4307_GRID_TYPE'
,p_item_sequence=>270
,p_item_plug_id=>wwv_flow_imp.id(131914703603)
,p_use_cache_before_default=>'NO'
,p_item_default=>'TABLE'
,p_prompt=>'Type'
,p_source=>'GRID_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'GRID_LAYOUT.TYPE'
,p_lov=>'.'||wwv_flow_imp.id(203356809012666718)||'.'
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Specifies the type of the layout.',
'</p>',
'<ul>',
'<li><strong>HTML Table</strong> - Uses HTML Tables to position regions, page items and buttons.</li>',
'<li><strong>Fixed Number of Columns</strong> - Used for layouts which divide the screen into a fixed number of layout columns.</li>',
'<li><strong>Variable Number of Columns</strong> - Used for layouts which can display up to "n" number of layout columns depending on how the regions, page items and buttons are positioned.</li>',
'</ul>'))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(203358119194674228)
,p_name=>'P4307_GRID_ALWAYS_USE_MAX_COLUMNS'
,p_item_sequence=>310
,p_item_plug_id=>wwv_flow_imp.id(131914703603)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Always use Max Columns'
,p_source=>'GRID_ALWAYS_USE_MAX_COLUMNS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify <strong>On</strong> if the layout can always use the maximum number of columns for a slot. Specify <strong>Off</strong> if the maximum number of columns is for the full screen and each position reduces the available columns.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(203359230180684370)
,p_name=>'P4307_GRID_HAS_COLUMN_SPAN'
,p_item_sequence=>320
,p_item_plug_id=>wwv_flow_imp.id(131914703603)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Has Column Span'
,p_source=>'GRID_HAS_COLUMN_SPAN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify <strong>On</strong> if the layout supports a span over multiple layout columns. Most "Fixed Number of Columns" layouts do support that.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(203360312496692505)
,p_name=>'P4307_GRID_EMIT_EMPTY_LEADING_COLS'
,p_item_sequence=>340
,p_item_plug_id=>wwv_flow_imp.id(131914703603)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Emit Empty Leading Columns'
,p_source=>'GRID_EMIT_EMPTY_LEADING_COLS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify <strong>On</strong> to fill up unused leading layout columns with an empty layout column. Most of the time this has to be set to <strong>On</strong> for "Fixed Number of Columns" layouts.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(203361328874700145)
,p_name=>'P4307_GRID_EMIT_EMPTY_TRAILING_COLS'
,p_item_sequence=>350
,p_item_plug_id=>wwv_flow_imp.id(131914703603)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Emit Empty Trailing Columns'
,p_source=>'GRID_EMIT_EMPTY_TRAILING_COLS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify <strong>On</strong> to fill up unused trailing layout columns with an empty layout column to always include the maximum number of layout columns.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(203362430143729887)
,p_name=>'P4307_GRID_MAX_COLUMNS'
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_imp.id(131914703603)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Maximum Columns'
,p_format_mask=>'90'
,p_source=>'GRID_MAX_COLUMNS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>2
,p_cMaxlength=>2
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_restricted_characters=>'US_ONLY'
,p_help_text=>'Specifies the maximum number of columns which are supported by the layout.'
,p_attribute_01=>'1'
,p_attribute_02=>'99'
,p_attribute_03=>'right'
,p_attribute_04=>'numeric'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(359736513076708169)
,p_name=>'P4307_DIALOG_CLOSE_CODE'
,p_item_sequence=>1330
,p_item_plug_id=>wwv_flow_imp.id(34407606078341355)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Dialog Closure Code'
,p_source=>'DIALOG_JS_CLOSE_CODE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter JavaScript code to close the dialog page. The substitution strings will be replaced with their respective values at rendering time.<p/>',
'The default JavaScript call for closing a dialog is:<p/><strong>',
'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);</strong>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(360927825279161478)
,p_name=>'P4307_DIALOG_CSS_CLASSES'
,p_item_sequence=>1340
,p_item_plug_id=>wwv_flow_imp.id(53603513531407414)
,p_use_cache_before_default=>'NO'
,p_prompt=>'CSS Classes'
,p_source=>'DIALOG_CSS_CLASSES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter additional CSS classes you wish to be applied to the dialog, as a space delimited list.For example: <p/>',
'',
'<strong>ui-dialog--wizard</strong><p/><p/>',
'',
'Any occurrence of the substitution string #DIALOG_CSS_CLASSES# in the page template will be replaced with the value(s) specified in this field. This value can be overwritten at page level.  '))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(741443279094225827)
,p_name=>'P4307_GRID_ALWAYS_EMIT'
,p_item_sequence=>330
,p_item_plug_id=>wwv_flow_imp.id(131914703603)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Always Render Layout'
,p_source=>'GRID_ALWAYS_EMIT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify <strong>On</strong> to always render the layout, even if only the first column of the layout is used. Specify <strong>Off</strong> to only render the layout when more than one column is used.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(864568260573731002)
,p_name=>'P4307_DIALOG_BROWSER_FRAME'
,p_item_sequence=>1350
,p_item_plug_id=>wwv_flow_imp.id(53603513531407414)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Allow Embed In Frame'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'   l_value wwv_flow_global.vc_arr2;',
'begin ',
'   select dialog_browser_frame ',
'   bulk collect into l_value ',
'   from wwv_flow_templates ',
'   where id = :F4000_P4307_ID',
'   and flow_id = :FB_FLOW_ID ',
'   and security_group_id = :flow_security_group_id;',
'',
'   return wwv_flow_utilities.table_to_string2(l_value,'':''); ',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'DIALOG_PAGE_MODE_OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(887851591470130537)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Your page template level browser frame options are listed below, along with the current setting for each.',
'Check the box next to a page mode to use this attribute to control if the browser is allowed to display your application''s pages within a frame.',
'The current setting will be the default for each modal and non-modal dialog using this page template.',
'<p/>',
'<p>',
'Displaying pages within frames can be misused with "clickjacking" attacks.',
'In a clickjacking attack the attacker uses multiple layers to trick a user into clicking a button or link on another page when they were intending to click on the top level page.',
'Thus, the attacker is hijacking clicks (or keystrokes) meant for their page and routing them to another page.',
'<p/>',
'<p>',
'&PRODUCT_NAME. embeds modal dialogs in iframes.',
'If you set the application security attribute <em>Browser Frame</em> to "Deny",',
'checking <em>Allow Embed In Frame</em> for "Modal Dialog" will instead use "Allow from same origin" for dialog pages that use this template. ',
'</p>'))
,p_attribute_01=>'1'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1004724448190877708)
,p_name=>'P4307_INTERNAL_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(548047061)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Identifier'
,p_source=>'INTERNAL_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Template identifier, this is used when switching and upgrading themes and cannot be modified.'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1564192840347583631)
,p_name=>'P4307_GRID_DEFAULT_LABEL_COL_SPAN'
,p_item_sequence=>360
,p_item_plug_id=>wwv_flow_imp.id(131914703603)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Default Label Column Span'
,p_format_mask=>'90'
,p_source=>'GRID_DEFAULT_LABEL_COL_SPAN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>2
,p_cMaxlength=>2
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'US_ONLY'
,p_help_text=>'Specifies the default number of layout columns an item label occupies if not specified on item level. Your label template must include the <code>#LABEL_COLUMN_SPAN_[NUMBER|ALPHA|WORD|PLURAL]#</code> and <code>#ITEM_COLUMN_SPAN_[NUMBER|ALPHA|WORD|PLUR'
||'AL]#</code> substitution strings.'
,p_attribute_01=>'1'
,p_attribute_02=>'99'
,p_attribute_03=>'right'
,p_attribute_04=>'numeric'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2104756311530753955)
,p_name=>'P4307_THEME_IS_SUBSCRIBED'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(548047061)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2104756918394760735)
,p_computation_sequence=>10
,p_computation_item=>'P4307_THEME_IS_SUBSCRIBED'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'    l_is_subscribed varchar2(16) := ''NONE'';',
'begin',
'  ',
'    for c1 in (',
'        select t.reference_id template_ref_id, ',
'               th.reference_id theme_ref_id',
'          from wwv_flow_templates t, ',
'               wwv_flow_themes th',
'         where t.id                 = :F4000_P4307_ID',
'           and t.flow_id            = th.flow_id',
'           and t.theme_id           = th.theme_id',
'           and t.security_group_id  = :WORKSPACE_ID',
'           and th.security_group_id = t.security_group_id',
'    ) loop',
'        if c1. theme_ref_id is not null then',
'            if c1.template_ref_id is not null then',
'                l_is_subscribed := ''BOTH'';',
'            else ',
'                l_is_subscribed := ''THEME'';',
'            end if;',
'        end if;    ',
'    end loop;',
'',
'    return l_is_subscribed;',
'',
'end;',
''))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(34382100375905921)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P4307_REFRESH'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'Unable to compute item value.'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(30630018119718339)
,p_computation_sequence=>20
,p_computation_item=>'P4307_PUBLISH'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(116593057307910565)
,p_validation_name=>'unique template name'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_templates ',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :workspace_id',
'   and theme_id          = :P4307_THEME',
'   and name              = :F4000_P4307_NAME',
'   and id               != :F4000_P4307_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Template name must be unique'
,p_associated_item=>wwv_flow_imp.id(22011144003)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5389218572782507)
,p_validation_name=>'#HEAD# included'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_start number;',
'    l_end   number;',
'    l_head  varchar2(32767);',
'    l_error varchar2(255);',
'begin',
'    l_start := instr(upper(:F4000_P4307_HEADER_TEMPLATE),''<HEAD'');',
'    l_end   := instr(upper(:F4000_P4307_HEADER_TEMPLATE),''</HEAD>'');',
'    l_head  := substr(:F4000_P4307_HEADER_TEMPLATE,l_start,l_end);',
'',
'    if l_start = 0 or l_end = 0 then',
'        return wwv_flow_lang.system_message(''F4000.HEADER_VALIDATION1'');',
'    elsIf instr(l_head,''#HEAD#'') = 0 then',
'        return wwv_flow_lang.system_message(''F4000.HEADER_VALIDATION2'');',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_message=>'Error.'
,p_associated_item=>wwv_flow_imp.id(22012144003)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(132386007512842231)
,p_validation_name=>'#BOX_BODY# included'
,p_validation_sequence=>30
,p_validation=>'nvl(instr(:F4000_P4307_BOX,''#BODY#''), 0) > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Template must supply BODY substitution.'
,p_associated_item=>wwv_flow_imp.id(8029292853)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(163591311590173316)
,p_validation_name=>'reference is not null'
,p_validation_sequence=>40
,p_validation=>'F4000_P4307_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Reference ID must be specified to refresh the template.'
,p_when_button_pressed=>wwv_flow_imp.id(163582115209140770)
,p_associated_item=>wwv_flow_imp.id(162671431587462663)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(163709929625529582)
,p_validation_name=>'reference id not zero'
,p_validation_sequence=>50
,p_validation=>'F4000_P4307_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_ZERO'
,p_error_message=>'Template to refresh must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(163582115209140770)
,p_associated_item=>wwv_flow_imp.id(162671431587462663)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(203382712859041824)
,p_validation_name=>'P4307_GRID_MAX_COLUMNS is not null'
,p_validation_sequence=>60
,p_validation=>'P4307_GRID_MAX_COLUMNS'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P4307_GRID_TYPE'
,p_validation_condition2=>'FIXED:VARIABLE'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(203378009291921898)
,p_validation_name=>'P4307_GRID_TEMPLATE contains #ROWS#'
,p_validation_sequence=>80
,p_validation=>'nvl(instr(:P4307_GRID_TEMPLATE, ''#ROWS#''), 0) > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'#LABEL# must contain #ROWS# substitution.'
,p_validation_condition=>'P4307_GRID_TYPE'
,p_validation_condition2=>'FIXED:VARIABLE'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_associated_item=>wwv_flow_imp.id(203351726181564628)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(203378303684924520)
,p_validation_name=>'P4307_GRID_ROW_TEMPLATE contains #COLUMNS#'
,p_validation_sequence=>90
,p_validation=>'nvl(instr(:P4307_GRID_ROW_TEMPLATE, ''#COLUMNS#''), 0) > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'#LABEL# must contain #COLUMNS# substitution.'
,p_validation_condition=>'P4307_GRID_TYPE'
,p_validation_condition2=>'FIXED:VARIABLE'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_associated_item=>wwv_flow_imp.id(203352930914577600)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(203379202988985610)
,p_validation_name=>'P4307_GRID_COLUMN_TEMPLATE contains #CONTENT#'
,p_validation_sequence=>100
,p_validation=>'nvl(instr(:P4307_GRID_COLUMN_TEMPLATE, ''#CONTENT#''), 0) > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'#LABEL# must contain #CONTENT# substitution.'
,p_validation_condition=>'P4307_GRID_TYPE'
,p_validation_condition2=>'FIXED:VARIABLE'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_associated_item=>wwv_flow_imp.id(203353124660580498)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(135893110531224286)
,p_validation_name=>'Dialog Init Code NOT NULL'
,p_validation_sequence=>140
,p_validation=>'P4307_DIALOG_JS_INIT_CODE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#LABEL# must have some value when Template Type is Dialog Page.  The default value is:<p/><p/>',
'apex.navigation.dialog(#PAGE_URL#,{title:#TITLE#,height:#DIALOG_HEIGHT#,width:#DIALOG_WIDTH#,maxWidth:#DIALOG_MAX_WIDTH#,modal:#IS_MODAL#,dialog:#DIALOG#,#DIALOG_ATTRIBUTES#},#DIALOG_CSS_CLASSES#,#TRIGGERING_ELEMENT#);'))
,p_validation_condition=>'P4307_IS_POPUP'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(44400104182090696)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3782840599861)
,p_validation_name=>'Dialog Closure Code NOT NULL'
,p_validation_sequence=>150
,p_validation=>'P4307_DIALOG_CLOSE_CODE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#LABEL# must have some value when Template Type is Dialog Page.  The default value is:<p/><p/>',
'apex.navigation.dialog.close(#IS_MODAL#,#TARGET#);'))
,p_validation_condition=>'P4307_IS_POPUP'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3782844604517)
,p_validation_name=>'Dialog Cancel Code NOT NULL'
,p_validation_sequence=>160
,p_validation=>'P4307_DIALOG_CANCEL_CODE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#LABEL# must have some value when Template Type is Dialog Page.  The default value is:<p/><p/>',
'apex.navigation.dialog.cancel(#IS_MODAL#);'))
,p_validation_condition=>'P4307_IS_POPUP'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(177290396349915730)
,p_tabular_form_region_id=>wwv_flow_imp.id(262121216799808381)
,p_validation_name=>'Positions - Reserved template substitutions'
,p_validation_sequence=>170
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
':placeholder not in (',
'    ''AFTER_HEADER'', ',
'    ''BEFORE_FOOTER'',',
'    ''BODY_1'',',
'    ''BODY_2'',',
'    ''BODY_3'',',
'    ''LEGACY_ORPHAN_COMPONENTS'',',
'    ''APEX_CSS'',',
'    ''APEX_JAVASCRIPT'',',
'    ''APP_VERSION'',',
'    ''APPLICATION_CSS'',',
'    ''APPLICATION_JAVASCRIPT'',',
'    ''APPLICATION_TABS'',',
'    ''BODY_TITLE'',',
'    ''BUILT_WITH_LOVE_USING_APEX'',',
'    ''CLOSE_NOTIFICATION'',',
'    ''CUSTOMIZE'',',
'    ''DEVELOPER_TOOLBAR'',',
'    ''DIALOG_CSS_CLASSES'',',
'    ''ENVIRONMENT_BANNER'',',
'    ''ERROR_MESSAGE_HEADING'',',
'    ''EXPAND_COLLAPSE_NAV_LABEL'',',
'    ''EXPAND_COLLAPSE_SIDE_COL_LABEL'',',
'    ''FAVICONS'',',
'    ''FLOW_NAME'',',
'    ''FLOW_VERSION'',',
'    ''FORM_CLOSE'',',
'    ''FORM_OPEN'',',
'    ''GENERATED_CSS'',',
'    ''GENERATED_JAVASCRIPT'',',
'    ''GLOBAL_NOTIFICATION'',',
'    ''HIGH_CONTRAST_TOGGLE'',',
'    ''HOME_LINK'',',
'    ''LANGUAGE_SELECTOR'',',
'    ''LOGIN_URL'',',
'    ''LOGO'',',
'    ''LOGOUT_URL'',',
'    ''MESSAGE'',',
'    ''NAVIGATION_BAR'',',
'    ''NOTIFICATION_MESSAGE'',',
'    ''ONLOAD'',',
'    ''OUTDATED_BROWSER'',',
'    ''PAGE_CSS'',',
'    ''PAGE_CSS_CLASSES'',',
'    ''PAGE_JAVASCRIPT'',',
'    ''PAGE_STATIC_ID'',',
'    ''PAGE_TRANSITION'',',
'    ''PARENT_TAB_CELLS'',',
'    ''POPUP_TRANSITION'',',
'    ''REQUESTED_URL'',',
'    ''RTL_CLASS'',',
'    ''SCREEN_READER_TOGGLE'',',
'    ''SIDE_GLOBAL_NAVIGATION_LIST'',',
'    ''SUCCESS_MESSAGE'',',
'    ''SUCCESS_MESSAGE_HEADING'',',
'    ''TAB_CELLS'',',
'    ''TEMPLATE_CSS'',',
'    ''TEMPLATE_JAVASCRIPT'',',
'    ''TEXT_DIRECTION'',',
'    ''THEME_CSS'',',
'    ''THEME_JAVASCRIPT'',',
'    ''THEME_STYLE_CSS'',',
'    ''TITLE'',',
'    ''TOP_GLOBAL_NAVIGATION_LIST'',',
'    ''WELCOME_USER'' )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'This is a reserved template substitution.'
,p_validation_condition=>'F4000_P4307_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_exec_cond_for_each_row=>'Y'
,p_associated_column=>'PLACEHOLDER'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(11786378753314004)
,p_tabular_form_region_id=>wwv_flow_imp.id(262121216799808381)
,p_validation_name=>'Positions - No duplicate placeholders'
,p_validation_sequence=>180
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_page_tmpl_disp_points',
' where flow_id           = :FB_FLOW_ID',
'   and page_template_id  = :F4000_P4307_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and placeholder       = :placeholder',
'   and id               != nvl(:id, 0)'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#COLUMN_HEADER# must be unique.'
,p_validation_condition=>'F4000_P4307_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_column=>'PLACEHOLDER'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(11786753098314008)
,p_tabular_form_region_id=>wwv_flow_imp.id(262121216799808381)
,p_validation_name=>'Positions - No duplicate names'
,p_validation_sequence=>190
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_page_tmpl_disp_points',
' where flow_id           = :FB_FLOW_ID',
'   and page_template_id  = :F4000_P4307_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and name              = :name',
'   and id               != nvl(:id, 0)'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#COLUMN_HEADER# must be unique.'
,p_validation_condition=>'F4000_P4307_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_column=>'NAME'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(231753188711461229)
,p_tabular_form_region_id=>wwv_flow_imp.id(262121216799808381)
,p_validation_name=>'Positions - At least one component type'
,p_validation_sequence=>200
,p_validation=>':has_region_support = ''Y'' or :has_item_support = ''Y'' or :has_button_support = ''Y'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Position must support at least one component type (region, item or button).'
,p_validation_condition=>'F4000_P4307_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_column=>'PLACEHOLDER'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(24048270426574809)
,p_tabular_form_region_id=>wwv_flow_imp.id(21515661633785596)
,p_validation_name=>'Template Options - No duplicates name'
,p_validation_sequence=>210
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_template_options',
' where flow_id              = :FB_FLOW_ID',
'   and theme_id             = :P4307_THEME',
'   and page_template_id     = :F4000_P4307_ID',
'   and security_group_id    = :WORKSPACE_ID',
'   and name                 = :NAME',
'   and template_types       = :TEMPLATE_TYPES',
'   and (:ID is null or id != :ID)'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#COLUMN_HEADER# must be unique.'
,p_validation_condition=>'F4000_P4307_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_exec_cond_for_each_row=>'Y'
,p_associated_column=>'NAME'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(24048317155574810)
,p_tabular_form_region_id=>wwv_flow_imp.id(21515661633785596)
,p_validation_name=>'Template Options - No duplicates classes'
,p_validation_sequence=>220
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_template_options',
' where flow_id              = :FB_FLOW_ID',
'   and theme_id             = :P4307_THEME',
'   and page_template_id     = :F4000_P4307_ID',
'   and security_group_id    = :WORKSPACE_ID',
'   and css_classes          = :CSS_CLASSES',
'   and template_types       = :TEMPLATE_TYPES',
'   and (:ID is null or id != :ID)'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#COLUMN_HEADER# must be unique.'
,p_validation_condition=>'F4000_P4307_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_exec_cond_for_each_row=>'Y'
,p_associated_column=>'CSS_CLASSES'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(203371716603791882)
,p_name=>'Hide All'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4307_GRID_TYPE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(203372001728791883)
,p_event_id=>wwv_flow_imp.id(203371716603791882)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4307_GRID_ALWAYS_USE_MAX_COLUMNS,P4307_GRID_HAS_COLUMN_SPAN,P4307_GRID_ALWAYS_EMIT,P4307_GRID_EMIT_EMPTY_LEADING_COLS,P4307_GRID_EMIT_EMPTY_TRAILING_COLS,P4307_GRID_DEFAULT_LABEL_COL_SPAN,P4307_GRID_FIRST_COLUMN_ATTRIBUTES,P4307_GRID_LAST_COLUMN_ATT'
||'RIBUTES,F4000_P4307_REG_TAB_CATTR,P4307_GRID_TEMPLATE,P4307_GRID_ROW_TEMPLATE,P4307_GRID_COLUMN_TEMPLATE,P4307_GRID_JAVASCRIPT_DEBUG_CODE,P4307_GRID_MAX_COLUMNS'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(203372103920797720)
,p_name=>'HTML Table Grid'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4307_GRID_TYPE'
,p_condition_element=>'P4307_GRID_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TABLE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(203372417830797720)
,p_event_id=>wwv_flow_imp.id(203372103920797720)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4307_REG_TAB_CATTR'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(203372512709809707)
,p_name=>'Fixed and Variable Column Grid'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4307_GRID_TYPE'
,p_condition_element=>'P4307_GRID_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'FIXED,VARIABLE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(203372810467809707)
,p_event_id=>wwv_flow_imp.id(203372512709809707)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4307_GRID_MAX_COLUMNS,P4307_GRID_HAS_COLUMN_SPAN,P4307_GRID_ALWAYS_EMIT,P4307_GRID_EMIT_EMPTY_LEADING_COLS,P4307_GRID_EMIT_EMPTY_TRAILING_COLS,P4307_GRID_DEFAULT_LABEL_COL_SPAN,P4307_GRID_FIRST_COLUMN_ATTRIBUTES,P4307_GRID_LAST_COLUMN_ATTRIBUTES,P43'
||'07_GRID_TEMPLATE,P4307_GRID_ROW_TEMPLATE,P4307_GRID_COLUMN_TEMPLATE,P4307_GRID_JAVASCRIPT_DEBUG_CODE'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(203373005914817236)
,p_name=>'Fixed Column Grid'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4307_GRID_TYPE'
,p_condition_element=>'P4307_GRID_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FIXED'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(203373322249817236)
,p_event_id=>wwv_flow_imp.id(203373005914817236)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4307_GRID_ALWAYS_USE_MAX_COLUMNS'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(397301320019494740)
,p_name=>'ENABLE PREVIOUS'
,p_event_sequence=>50
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P4307_ID_PREV'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(397301624186494740)
,p_event_id=>wwv_flow_imp.id(397301320019494740)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(75342716186817071)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(397301725560496413)
,p_name=>'ENABLE NEXT'
,p_event_sequence=>60
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P4307_ID_NEXT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(397302029758496413)
,p_event_id=>wwv_flow_imp.id(397301725560496413)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(75342608829817071)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(129634725104310153)
,p_name=>'Visibility of Modal/Non-Modal Option'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4307_IS_POPUP'
,p_condition_element=>'P4307_IS_POPUP'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(129635004062310163)
,p_event_id=>wwv_flow_imp.id(129634725104310153)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4307_DIALOG_JS_INIT_CODE,P4307_DIALOG_CLOSE_CODE,P4307_DIALOG_CANCEL_CODE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(129635207478310166)
,p_event_id=>wwv_flow_imp.id(129634725104310153)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4307_DIALOG_JS_INIT_CODE,P4307_DIALOG_CLOSE_CODE,P4307_DIALOG_CANCEL_CODE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(129635403809312255)
,p_event_id=>wwv_flow_imp.id(129634725104310153)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(53603513531407414)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2103325728292120)
,p_name=>'onSave Positions'
,p_event_sequence=>100
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(262121216799808381)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'NATIVE_IG|REGION TYPE|interactivegridsave'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4312280572030107)
,p_event_id=>wwv_flow_imp.id(2103325728292120)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4307_BREADCRUMB_DP_TEMP'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'apex.item("P4307_BREADCRUMB_DISPLAY_POINT").getValue()'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4312376050030108)
,p_event_id=>wwv_flow_imp.id(2103325728292120)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4307_SIDEBAR_DP_TEMP'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'apex.item("P4307_SIDEBAR_DISPLAY_POINT").getValue()'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2103469641292121)
,p_event_id=>wwv_flow_imp.id(2103325728292120)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4307_BREADCRUMB_DISPLAY_POINT'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4312486868030109)
,p_name=>'afterRefresh P4307_BREADCRUMB_DISPLAY_POINT'
,p_event_sequence=>120
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4307_BREADCRUMB_DISPLAY_POINT'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4312505270030110)
,p_event_id=>wwv_flow_imp.id(4312486868030109)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4307_BREADCRUMB_DISPLAY_POINT'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'apex.item("P4307_BREADCRUMB_DP_TEMP").getValue()'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4312637583030111)
,p_name=>'afterRefresh P4307_SIDEBAR_DISPLAY_POINT'
,p_event_sequence=>130
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4307_SIDEBAR_DISPLAY_POINT'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4312749277030112)
,p_event_id=>wwv_flow_imp.id(4312637583030111)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4307_SIDEBAR_DISPLAY_POINT'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'apex.item("P4307_SIDEBAR_DP_TEMP").getValue()'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(9690373335802636)
,p_name=>'upper case identifier'
,p_event_sequence=>140
,p_triggering_element_type=>'COLUMN'
,p_triggering_region_id=>wwv_flow_imp.id(21515661633785596)
,p_triggering_element=>'DISPLAY_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(9690594865802638)
,p_event_id=>wwv_flow_imp.id(9690373335802636)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
':NAME := regexp_replace(',
'      srcstr     => :DISPLAY_NAME,',
'      pattern    => ''[^'' || wwv_flow_utilities.c_alnum || '']+'',',
'      replacestr => ''_'' );'))
,p_attribute_02=>'DISPLAY_NAME'
,p_attribute_03=>'NAME'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(9690603129802639)
,p_name=>'refresh template options on cancel'
,p_event_sequence=>150
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'body'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosecanceldialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(9690708041802640)
,p_event_id=>wwv_flow_imp.id(9690603129802639)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(21515661633785596)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(9690803633802641)
,p_event_id=>wwv_flow_imp.id(9690603129802639)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(709028592980629349)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3004064703333538)
,p_name=>'Show Publish Success Msg'
,p_event_sequence=>160
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(165188919623029588)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3004190030333539)
,p_event_id=>wwv_flow_imp.id(3004064703333538)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ( this.data.successMessage ) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(22014144004)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch Row from WWV_FLOW_TEMPLATES'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'for c1 in (',
'select 1 from wwv_flow_templates',
'where security_group_id = :flow_security_group_id and',
'      flow_id = :FB_FLOW_ID and',
'      id = :F4000_P4307_ID) loop',
'wwv_flow_dml.fetch_row(',
'  p_table_owner => ''#OWNER#'',',
'  p_table_name  => ''WWV_FLOW_TEMPLATES'',',
'  p_rowid       => v(''F4000_P4307_ID''),',
'  p_alt_rowid   => ''ID'');',
'exit;',
'end loop;',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error fetching row.'
,p_internal_uid=>22014144004
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(75353619195817232)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_PAGINATION'
,p_process_name=>'Get Next or Previous Primary Key Value'
,p_attribute_02=>'WWV_FLOW_TEMPLATES'
,p_attribute_03=>'F4000_P4307_ID'
,p_attribute_04=>'ID'
,p_attribute_07=>'NAME'
,p_attribute_09=>'P4307_ID_NEXT'
,p_attribute_10=>'P4307_ID_PREV'
,p_attribute_13=>'P4307_ID_COUNT'
,p_attribute_14=>'flow_id = :fb_flow_id'
,p_process_error_message=>'Unable to run Get Next or Previous Primary Key Value process.'
,p_internal_uid=>75353619195817232
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(162744514301306294)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh Template 1'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_page_template (',
'    p_master_template_id         => :F4000_P4307_REFERENCE_ID,',
'    p_subscribing_template_id    => :F4000_P4307_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying template.'
,p_process_when_button_id=>wwv_flow_imp.id(163582115209140770)
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'nvl(:F4000_P4307_REFERENCE_ID,0)<>0 ',
'and not wwv_flow_page.is_read_only'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Template copied'
,p_internal_uid=>162744514301306294
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(22015144004)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process Row of WWV_FLOW_TEMPLATES'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'    select 1 from sys.dual',
'     where :F4000_P4307_ID is null or exists ( select 1 ',
'                                                 from wwv_flow_templates',
'                                                where security_group_id = :flow_security_group_id ',
'                                                  and flow_id           = :FB_FLOW_ID ',
'                                                  and id                = :F4000_P4307_ID',
'                                             )',
'          ) loop',
'wwv_flow_dml.process(',
'    p_action      => wwv_flow.g_request,',
'    p_table_owner => ''#OWNER#'',',
'    p_table_name  => ''WWV_FLOW_TEMPLATES'',',
'    p_rowid       => v(''F4000_P4307_ID''),',
'    p_alt_rowid   => ''ID'');',
'exit;',
'end loop;',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error processing row.'
,p_process_when=>'COPY_TEMPLATE'
,p_process_when_type=>'REQUEST_NOT_IN_CONDITION'
,p_process_success_message=>'Page template processed.'
,p_internal_uid=>22015144004
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(886492862328981504)
,p_process_sequence=>55
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process Dialog Browser Frame Setting'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'begin',
'  update wwv_flow_templates',
'     set dialog_browser_frame = :P4307_DIALOG_BROWSER_FRAME',
'   where id = :F4000_P4307_ID',
'     and flow_id = :FB_FLOW_ID',
'     and security_group_id = :flow_security_group_id;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error updating dialog browser frame setting.'
,p_process_when=>'COPY_TEMPLATE'
,p_process_when_type=>'REQUEST_NOT_IN_CONDITION'
,p_internal_uid=>886492862328981504
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(34063422379622171)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh template 2'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_page_template (',
'    p_master_template_id         => :F4000_P4307_REFERENCE_ID,',
'    p_subscribing_template_id    => :F4000_P4307_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying the template.'
,p_process_when=>':F4000_P4307_REFERENCE_ID is not null and :F4000_P4307_REFRESH = ''Y'' and upper(:request) like ''APPLY%'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Template copied.'
,p_internal_uid=>34063422379622171
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2179039248041757453)
,p_process_sequence=>65
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sync template option presets'
,p_process_sql_clob=>'wwv_flow_templates_util.sync_page_tmplopt_presets(:F4000_P4307_ID);'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'nvl(:P4307_PRESET_TEMPLATE_OPTIONS,''NOPRESETS'') <> nvl(:P4307_PRESET_TMPLOPT_CHECK,''NOPRESETS'') '
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>2179039248041757453
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(163701720388488269)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove reference id as needed'
,p_process_sql_clob=>'wwv_flow_copy_metadata.remove_page_reference_id (:F4000_P4307_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error setting template id to null.'
,p_process_when=>':F4000_P4307_REFERENCE_ID = ''0'' and upper(:request) like ''APPLY%'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>163701720388488269
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2103150213292118)
,p_process_sequence=>80
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(262121216799808381)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Positions - Save Interactive Grid Data'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2103150213292118
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(12481242918138519)
,p_process_sequence=>80
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(21515661633785596)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Template Options - Save Interactive Grid Data'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>12481242918138519
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2103672480292123)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_region_id=>wwv_flow_imp.id(262121216799808381)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'upper :placeholder'
,p_process_sql_clob=>':placeholder := upper(:placeholder);'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'F4000_P4307_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_exec_cond_for_each_row=>'Y'
,p_internal_uid=>2103672480292123
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(177290406014915731)
,p_process_sequence=>20
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_region_id=>wwv_flow_imp.id(262121216799808381)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'trim pound'
,p_process_sql_clob=>':placeholder := trim( both ''#'' from :placeholder );'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'F4000_P4307_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_exec_cond_for_each_row=>'Y'
,p_internal_uid=>177290406014915731
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(24048159279574808)
,p_process_sequence=>30
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_region_id=>wwv_flow_imp.id(21515661633785596)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'upper :name'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':NAME := REGEXP_REPLACE(',
'      srcstr     => :NAME,',
'      pattern    => ''[^'' || wwv_flow_utilities.c_alnum || '']+'',',
'      replacestr => ''_'' );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'F4000_P4307_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_exec_cond_for_each_row=>'Y'
,p_internal_uid=>24048159279574808
);
end;
/
prompt --application/pages/page_04308
begin
wwv_flow_imp_page.create_page(
 p_id=>4308
,p_name=>'Edit Navigation Bar Entry'
,p_alias=>'EDIT-NAVIGATION-BAR-ENTRY'
,p_step_title=>'Edit Navigation Bar Entry'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213263531591941060)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript" language="JavaScript">',
'function callItempopUp(s1,s2) {',
'     var items = document.getElementById(s1).value.replace(/\,/g,''~'');',
'     var values = document.getElementById(s2).value.replace(/\,/g,''~'');',
'     var url = ''f?p=4000:404:&SESSION.:::404:P404_RETURN1,P404_RETURN2,P404_ITEMS,P404_VALUES:'' + s1 + '','' + s2 + '','' + escape(items) + '','' + escape(values);',
'     popUp (url);',
'}',
'</script>',
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_navbar.htm'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(457499110)
,p_plug_name=>'button box'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(458502857)
,p_plug_name=>'Entry Display'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(459517222)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>130
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Navigation Bar Entries, typically graphic icons are used to provide application level navigation.  Navigation Bar Entries are displayed on every page, however a Navigation Bar Entry can be conditionally displayed.</p>',
'',
'<p>The placement of the Navigation Bar is identified in a page level template and the (#NAVIGATION_BAR#) substitution string.</p>'))
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(460530239)
,p_plug_name=>'Conditions'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_row_template=>wwv_flow_imp.id(81008210556197147)
,p_plug_query_num_rows=>50
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_row_count_max=>5000
,p_plug_query_show_nulls_as=>'(null)'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(461549004)
,p_plug_name=>'Target'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(33343906966817956)
,p_plug_name=>'Subscription'
,p_region_name=>'SUB'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'WWV_FLOW_ICON_BAR',
  'attribute_02', 'ICON_IMAGE_ALT',
  'attribute_03', 'F4000_P4308_ID',
  'attribute_04', 'F4000_P4308_REFERENCE_ID',
  'attribute_05', 'SUBSCRIBE_NAVBAR')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46257412080679009)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>10
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(112450309806494185)
,p_plug_name=>'Comments'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(145711905273893908)
,p_plug_name=>'Authorization'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(167051831503178663)
,p_plug_name=>'Configuration'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(195827117454955907)
,p_plug_name=>'Entry Image'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(197051508527618833)
,p_plug_name=>'Feedback Entry'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Navigation bar entries can be identified as being a feedback entry.  Feedback is enabled or disabled at the application level so that feedback can be turned on for testing and turned off for production.  If the application level attribute is disab'
||'led then the feedback navigation bar entry will not be displayed.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(615341607888588885)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(29434107863295859)
,p_plug_display_sequence=>110
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from  WWV_FLOW_ICON_BAR',
'where id = :F4000_P4308_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :F4000_P4308_ID,',
'      p_component_type => ''Navigation Bar'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(925158746310624162)
,p_plug_name=>'Developer Resources'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>140
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_05'
,p_list_id=>wwv_flow_imp.id(26512283167477231)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(200951627971903655)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(33343906966817956)
,p_button_name=>'COPY_NAVBAR'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Refresh NavBar'
,p_button_position=>'BOTTOM'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_icon_bar',
' where id = :F4000_P4308_ID',
'   and reference_id is not null',
'   and security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(200947320221891904)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(33343906966817956)
,p_button_name=>'PUSH_NAVBAR'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Publish NavBar'
,p_button_position=>'BOTTOM'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.::F4000_P149_ID,F4000_P149_PAGE_ID,F4000_P149_TEMPLATE_TYPE:&F4000_P4308_ID.,&FLOW_PAGE_ID.,NAVBAR'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_icon_bar',
' where reference_id      = :F4000_P4308_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(148586029317925560)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(457499110)
,p_button_name=>'APPLY_CHANGES_GET_PREVIOUS_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'disabled=""'
,p_button_comment=>'javascript:htmldb_goSubmit(''GET_PREVIOUS_ID'')'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(148585905863925560)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_imp.id(457499110)
,p_button_name=>'APPLY_CHANGES_GET_NEXT_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Next'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'disabled=""'
,p_button_comment=>'javascript:htmldb_goSubmit(''GET_NEXT_ID'')'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(22017144004)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(457499110)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(22018144005)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(457499110)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
,p_button_condition=>'F4000_P4308_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(22019144005)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(457499110)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P4308_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(22020144005)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(457499110)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P4308_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(148593512524925649)
,p_branch_action=>'f?p=&APP_ID.:4308:&SESSION.::&DEBUG.::F4000_P4308_ID:&P4308_ID_NEXT.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(148585905863925560)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(148593919899925652)
,p_branch_action=>'f?p=&APP_ID.:4308:&SESSION.::&DEBUG.::F4000_P4308_ID:&P4308_ID_PREV.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(148586029317925560)
,p_branch_sequence=>20
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(200952015038903658)
,p_branch_action=>'4308'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(200951627971903655)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(119001127005800137)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(819585597)
,p_name=>'F4000_P4308_ICON_BAR_COMMENT'
,p_item_sequence=>340
,p_item_plug_id=>wwv_flow_imp.id(112450309806494185)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comments'
,p_source=>'ICON_BAR_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Enter any comments or notes here.  These comments will never be displayed when running the application</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9169568864)
,p_name=>'F4000_P4308_REQUIRED_PATCH'
,p_item_sequence=>300
,p_item_plug_id=>wwv_flow_imp.id(167051831503178663)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Build Option'
,p_source=>'REQUIRED_PATCH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PATCHES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(patch_name) pn, id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'', wwv_flow_escape.html(patch_name))||',
'''} '' pn,0-id id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by pn'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Build Option -'
,p_lov_null_value=>'%null%'
,p_cSize=>64
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select a build option for this component.</p>',
'<p>Build options are predefined settings that determine whether or not  components within an application are enabled.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22024144006)
,p_name=>'F4000_P4308_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>310
,p_item_plug_id=>wwv_flow_imp.id(33343906966817956)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22026144007)
,p_name=>'F4000_P4308_ICON_SEQUENCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(458502857)
,p_use_cache_before_default=>'NO'
,p_item_default=>'10'
,p_prompt=>'Sequence'
,p_source=>'ICON_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>8
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Specify the sequence for this component.  The sequence determines the order of evaluation.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22027144007)
,p_name=>'F4000_P4308_ICON_IMAGE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(195827117454955907)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Image'
,p_source=>'ICON_IMAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'PICK_IMAGE_NAME'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select file_name || '' ('' || wwv_flow_lang.system_message(scope) || '')'' as d,',
'       r',
'  from ( select file_name,',
'                ''#'' || ''APP_FILES#'' || file_name as r,',
'                ''APPLICATION'' as scope',
'           from wwv_flow_static_files',
'          where flow_id           = :FB_FLOW_ID',
'            and security_group_id = :WORKSPACE_ID',
'            and upper(mime_type)  like ''IMAGE/%''',
'          union all',
'         select file_name,',
'                ''#'' || ''WORKSPACE_FILES#'' || file_name as r,',
'                ''WORKSPACE'' as scope',
'           from wwv_flow_company_static_files',
'          where security_group_id = :WORKSPACE_ID',
'            and upper(mime_type)  like ''IMAGE/%''',
'          order by scope, file_name',
'       )',
''))
,p_cSize=>60
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The image is the name of image.&nbsp; For example: wwv_find.gif.&nbsp; The image prefix can be one of the following:',
'',
'<ol>',
'',
'<li>&#35;WORKSPACE_IMAGES&#35;</li>',
'',
'<li>&#35;APP_IMAGES&#35;</li>',
'',
'<li>null (from the directory specified by the application image attribute)</li>',
'',
'</ol>',
'',
'Example of image names:',
'',
'<pre>',
'',
'&#35;WORKSPACE_IMAGES&#35;my_image.jpg',
'',
'&#35;APP_IMAGES&#35;another_image.gif',
'',
'html_db_white.gif',
'',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22028144007)
,p_name=>'F4000_P4308_ICON_TARGET'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(461549004)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Icon Target'
,p_source=>'ICON_TARGET'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22029144008)
,p_name=>'F4000_P4308_ICON_IMAGE_ALT'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(195827117454955907)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Icon Image Alt'
,p_source=>'ICON_IMAGE_ALT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'This text is added to the ALT tag of the image.&nbsp; When the cursor hovers over the image the alternate text is displayed. If this Icon Bar item has no image, just text, this is where you specify that text.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22030144008)
,p_name=>'F4000_P4308_ICON_HEIGHT'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(195827117454955907)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Image Height'
,p_source=>'ICON_HEIGHT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>8
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'You can set height and width attributes of the image.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22031144008)
,p_name=>'F4000_P4308_ICON_WIDTH'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(195827117454955907)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Width'
,p_source=>'ICON_WIDTH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>8
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'You can set height and width attributes of the image.&nbsp; '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22035144009)
,p_name=>'F4000_P4308_ICON_BAR_DISP_COND'
,p_item_sequence=>270
,p_item_plug_id=>wwv_flow_imp.id(460530239)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Expression 1'
,p_source=>'ICON_BAR_DISP_COND'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>This attribute allows you to conditionally control whether or not a  component is rendered or processed.  Enter values in this attribute based on the specific condition type selected.  The component will be rendered or processed if the specified c'
||'ondition is met.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22036144010)
,p_name=>'F4000_P4308_ICON_BAR_DISP_COND_TYPE'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_imp.id(460530239)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Condition Type'
,p_source=>'ICON_BAR_DISP_COND_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CONDITION_LIST'
,p_named_lov=>'STANDARD_CONDITION_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(13602414170805697)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Condition Specified -'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'<p>Select a condition type from the list that must be met in order for this component to be rendered processed.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'F4000_P4308_ICON_BAR_DISP_COND'
,p_attribute_02=>'F4000_P4308_ICON_BAR_FLOW_COND_INSTR'
,p_attribute_04=>'F4000_P4308_ICON_BAR_DISP_COND_CHECK'
,p_attribute_06=>'CONDITION'
,p_attribute_07=>'F4000_P4308_ICON_BAR_DISP_COND_LANG'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22037144010)
,p_name=>'F4000_P4308_ICON_BAR_FLOW_COND_INSTR'
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_imp.id(460530239)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Expression 2'
,p_source=>'ICON_BAR_FLOW_COND_INSTR'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Some condition types require two expressions for comparison.  Enter the second expression or item here.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22038144010)
,p_name=>'F4000_P4308_BEGINS_ON_NEW_LINE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(458502857)
,p_use_cache_before_default=>'NO'
,p_item_default=>'NO'
,p_prompt=>'Begins On New Line'
,p_source=>'BEGINS_ON_NEW_LINE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'YES_NO_RETURNS_YES_OR_NO'
,p_lov=>'.'||wwv_flow_imp.id(84270019143507704)||'.'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Navigation icons are displayed in table cells, if you set begins-on-new-line to YES then a new table row will be created.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22039144010)
,p_name=>'F4000_P4308_CELL_COLSPAN'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(458502857)
,p_use_cache_before_default=>'NO'
,p_item_default=>'1'
,p_prompt=>'Cell Column Span'
,p_source=>'CELL_COLSPAN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>8
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'By default each navigation bar entry spans one cell (that is the HTML table data colspan=1).&nbsp; If your HTML requires a different COLSPAN you can set it using this control.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(293034139962)
,p_name=>'F4000_P4308_SECURITY_SCHEME'
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_imp.id(145711905273893908)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Authorization Scheme'
,p_source=>'SECURITY_SCHEME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REQUIRED_ROLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.d, a.r from (',
'    select wwv_flow_lang.system_message(''MUST_NOT_BE_PUBLIC_USER'') d,''MUST_NOT_BE_PUBLIC_USER'' r, 1',
'      from sys.dual',
'    union all',
'    select wwv_flow_escape.html(substr(name,1,50)),to_char(id), 1',
'      from wwv_flow_security_schemes',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID',
'    union all',
'    select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'',wwv_flow_escape.html(substr(name,1,50)))||''}'' d, ''!''||to_char(id) r, 2',
'      from wwv_flow_security_schemes',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID',
'    order by 3,1) a'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Authorization Required -'
,p_lov_null_value=>'%null%'
,p_cSize=>64
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'<p>Optionally select an authorization scheme which must evaluate to TRUE in order for this component to be rendered or otherwise processed.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8220271440001)
,p_name=>'F4000_P4308_ICON_SUBTEXT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(458502857)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Entry Label'
,p_source=>'ICON_SUBTEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'For each navigation bar icon you can define an optional sub-text to be displayed below the icon.&nbsp; For example a help icon can display the text "help" below the icon.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2206168622404716)
,p_name=>'F4000_P4308_ICON_BAR_DISP_COND_LANG'
,p_item_sequence=>260
,p_item_plug_id=>wwv_flow_imp.id(460530239)
,p_prompt=>'Language'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select a language that is used to evaluate the entered programming code.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22257618866437042)
,p_name=>'P4308_URL_OR_FLOW'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(461549004)
,p_item_default=>'FLOW'
,p_prompt=>'Target type'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'URL_OR_PAGE'
,p_lov=>'.'||wwv_flow_imp.id(84796030957080920)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a target for this navigation bar entry.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22258504799442417)
,p_name=>'P4308_PAGE_ID'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(461549004)
,p_prompt=>'Page'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d',
'  from wwv_flow_steps',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and is_page_pattern   = ''N''',
'order by 2'))
,p_cSize=>8
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter the page number.  Check the box next to the page number if you would like to reset pagination for that page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22259803675460991)
,p_name=>'P4308_CLEAR_PAGE'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(461549004)
,p_prompt=>'Reset pagination for this page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select this checkbox to reset the pagination that is linked to.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'YES'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22260829995468664)
,p_name=>'P4308_REQUEST'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(461549004)
,p_prompt=>'Request'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter text that you would like to set the built-in application item called REQUEST.  This is also the item that is set with the name of a button that was clicked.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22261712118472912)
,p_name=>'P4308_CLEAR_CACHE'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(461549004)
,p_prompt=>'Clear Cache'
,p_post_element_text=>'<span class="instructionText">(comma separated page numbers)</span>'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter the page numbers, separated by commas, for which you would like the user''s session state to be cleared.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22262727009477231)
,p_name=>'P4308_ARG_NAMES'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(461549004)
,p_prompt=>'Set these items'
,p_post_element_text=>'<span class="instructionText">(comma separated name list)</span>'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the list of application item names separated by a comma, for which you would like to set the session state (give the listed item a value).'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'callItempopUp'
,p_attribute_03=>'Find Item'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22263604976480339)
,p_name=>'P4308_ARG_VALUES'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(461549004)
,p_prompt=>'With these values'
,p_post_element_text=>'<span class="instructionText">(comma separated value list)</span>'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter a comma delimited list of values for the items specified in <span class="fielddatabold">Set these items</span>. You can specify static values or substitution syntax (for example, &amp;APP_ITEM_NAME.). ',
'<pre>&amp;APP_ITEM_NAME.</pre>',
'<div class="htmldbInfoBodyP">Item values passed to <span class="fielddatabold">f?p=</span> in the URL may never contain a colon (:). Item values may also not contain commas unless you enclose the entire value in backslash characters. For example:</di'
||'v>',
'<pre>\1234,56\</pre>',
'<div class="htmldbInfoBodyP">This is useful when decimal values must be passed where the NLS decimal separator character is a comma.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'callItempopUp'
,p_attribute_03=>'Find Item'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22269307925519078)
,p_name=>'P4308_URL_TARGET'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_imp.id(461549004)
,p_prompt=>'URL Target'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identify URL.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(35744908558245590)
,p_name=>'F4000_P4308_REFRESH'
,p_item_sequence=>330
,p_item_plug_id=>wwv_flow_imp.id(33343906966817956)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Refresh'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_icon_bar',
' where reference_id      is null',
'   and id                = :F4000_P4308_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(106505115489517485)
,p_name=>'P4308_PRINTER_FRIENDLY'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(461549004)
,p_prompt=>'Printer friendly'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select this checkbox to set the printer friendly.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'YES'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(148591414867925615)
,p_name=>'P4308_ID_NEXT'
,p_item_sequence=>350
,p_item_plug_id=>wwv_flow_imp.id(457499110)
,p_prompt=>'P4308_ID_NEXT'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(148591712078925620)
,p_name=>'P4308_ID_PREV'
,p_item_sequence=>360
,p_item_plug_id=>wwv_flow_imp.id(457499110)
,p_prompt=>'P4308_ID_PREV'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(148592132491925621)
,p_name=>'P4308_ID_COUNT'
,p_item_sequence=>370
,p_item_plug_id=>wwv_flow_imp.id(457499110)
,p_prompt=>'Navigation Bar Entry: '
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies the navigation bar icon.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(173928305516662714)
,p_name=>'P4308_NAV_ENTRY_IS_FEEDBACK_YN'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(197051508527618833)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Is this a Feedback Entry'
,p_source=>'NAV_ENTRY_IS_FEEDBACK_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Indicates that this navigation bar entry is a link to a page that gathers feedback accessible within Team Development.  Feedback is enabled or disabled at the application level so that feedback can be turned on for testing and turned off for producti'
||'on.  If the application level attribute is disabled then the feedback navigation bar entry will not be displayed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(197056626676709192)
,p_name=>'P4308_FEEDBACK_ENABLED'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(197051508527618833)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Feedback Enabled By Application:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select decode(',
'   nvl(allow_feedback_yn,''N''),',
'   ''N'',wwv_flow_lang.system_message(''NO''),',
'   ''Y'',wwv_flow_lang.system_message(''YES'')) allow_feedback',
'from wwv_flows',
'where security_group_id = :flow_security_group_id and',
'          id = :fb_flow_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies whether Feedback is enabled within the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(200963313439917546)
,p_name=>'F4000_P4308_REFERENCE_ID'
,p_item_sequence=>320
,p_item_plug_id=>wwv_flow_imp.id(33343906966817956)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Reference Master Navigation Bar From'
,p_source=>'REFERENCE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FLOW_SUBSCRIBE_FROM_NAVBARS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- ''||',
'lower(wwv_flow_lang.system_message(''LAYOUT.T_NO''))||'' '' ||wwv_flow_lang.system_message(''NAVBAR'')||',
'''  -'' d, 0 r from sys.dual union all',
'select flow_id||'' : ''||',
'icon_image_alt d,',
'id r',
'from   wwv_flow_icon_bar',
'where  flow_id != nvl(:fb_flow_id,0) and flow_id in (',
'select f.id',
'from   wwv_main_apps_dev f',
'where  security_group_id = :flow_security_group_id and',
'       build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') and',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id is null and security_group_id = :flow_security_group_id)',
'       or',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id = f.id and security_group_id = :flow_security_group_id )',
')',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify a navigation bar entry to subscribe to.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(435041518929654786)
,p_name=>'F4000_P4308_ICON_BAR_DISP_COND_CHECK'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_imp.id(460530239)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Do not validate code (parse code at runtime only).'
,p_source=>'NULL'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(22308631230658229)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P4308_ICON_TARGET'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_clear_cache varchar2(4000);',
'begin',
'',
'if :P4308_URL_OR_FLOW = ''FLOW'' then',
'  if :P4308_CLEAR_PAGE = ''YES'' then',
'    l_clear_cache := ''RP,''||:P4308_CLEAR_CACHE;',
'  else',
'    l_clear_cache := :P4308_CLEAR_CACHE;',
'  end if;',
'  return ''f?p=&''||''APP_ID.:''||:P4308_PAGE_ID||'':&''||''SESSION.:''||:P4308_REQUEST||'':&''||''DEBUG.:''||rtrim(l_clear_cache,'','')||'':''||:P4308_ARG_NAMES||'':''||:P4308_ARG_VALUES||'':''||:P4308_PRINTER_FRIENDLY;',
'else',
'  return :P4308_URL_TARGET;',
'end if;',
'end;'))
,p_computation_error_message=>'Unable to compute item value.'
,p_compute_when=>'Create,ApplyChanges,APPLY_CHANGES_GET_PREVIOUS_ID,APPLY_CHANGES_GET_NEXT_ID'
,p_compute_when_type=>'REQUEST_IN_CONDITION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(35755306389261804)
,p_computation_sequence=>20
,p_computation_item=>'F4000_P4308_REFRESH'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'Unable to compute item value.'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(22318216563720245)
,p_validation_name=>'Target Required'
,p_validation_sequence=>10
,p_validation=>'(:P4308_URL_OR_FLOW = ''URL'' and :P4308_URL_TARGET is not null) or (:P4308_URL_OR_FLOW = ''FLOW'' and :P4308_PAGE_ID is not null)'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'URL or page as target must be specified.'
,p_validation_condition=>'Create,ApplyChanges,APPLY_CHANGES_GET_PREVIOUS_ID,APPLY_CHANGES_GET_NEXT_ID'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(201030209496995288)
,p_validation_name=>'sequence not null'
,p_validation_sequence=>20
,p_validation=>'F4000_P4308_ICON_SEQUENCE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Sequence must be specified.'
,p_associated_item=>wwv_flow_imp.id(22026144007)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(201034923717003950)
,p_validation_name=>'reference id not null'
,p_validation_sequence=>30
,p_validation=>'F4000_P4308_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Reference ID must be specified to refresh the navigation bar.'
,p_when_button_pressed=>wwv_flow_imp.id(200951627971903655)
,p_associated_item=>wwv_flow_imp.id(200963313439917546)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(201039407542011420)
,p_validation_name=>'reference id not zero'
,p_validation_sequence=>40
,p_validation=>'F4000_P4308_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_ZERO'
,p_error_message=>'Navigation Bar must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(200951627971903655)
,p_associated_item=>wwv_flow_imp.id(200963313439917546)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(29795621712493576)
,p_validation_name=>'sequence must be numeric'
,p_validation_sequence=>50
,p_validation=>'F4000_P4308_ICON_SEQUENCE'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Sequence must be a number.'
,p_validation_condition=>'ApplyChanges,APPLY_CHANGES_GET_PREVIOUS_ID,APPLY_CHANGES_GET_NEXT_ID'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(22026144007)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(79925008243460498)
,p_validation_name=>'HeightNumeric'
,p_validation_sequence=>60
,p_validation=>'F4000_P4308_ICON_HEIGHT'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Height must be numeric.'
,p_validation_condition=>'ApplyChanges,APPLY_CHANGES_GET_PREVIOUS_ID,APPLY_CHANGES_GET_NEXT_ID'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(22030144008)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(79926119325463712)
,p_validation_name=>'WidthNumeric'
,p_validation_sequence=>70
,p_validation=>'F4000_P4308_ICON_WIDTH'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Width must be numeric'
,p_validation_condition=>'ApplyChanges,APPLY_CHANGES_GET_PREVIOUS_ID,APPLY_CHANGES_GET_NEXT_ID'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(22031144008)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(114970116502901828)
,p_validation_name=>'either image or subtext'
,p_validation_sequence=>80
,p_validation=>'return :F4000_P4308_ICON_IMAGE is not null or :F4000_P4308_ICON_SUBTEXT is not null'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'You must supply either an image or subtext.'
,p_validation_condition=>'Create,ApplyChanges,APPLY_CHANGES_GET_PREVIOUS_ID,APPLY_CHANGES_GET_NEXT_ID'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(8220271440001)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(397302832270507728)
,p_name=>'ENABLE PREVIOUS'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P4308_ID_PREV'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(397303116209507728)
,p_event_id=>wwv_flow_imp.id(397302832270507728)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(148586029317925560)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(397303205390509427)
,p_name=>'ENABLE NEXT'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P4308_ID_NEXT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(397303511890509429)
,p_event_id=>wwv_flow_imp.id(397303205390509427)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(148585905863925560)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(385811634721243641)
,p_name=>'URL or Flow Change'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4308_URL_OR_FLOW'
,p_condition_element=>'P4308_URL_OR_FLOW'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FLOW'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(385811702814243642)
,p_event_id=>wwv_flow_imp.id(385811634721243641)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4308_URL_TARGET'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(385811877002243643)
,p_event_id=>wwv_flow_imp.id(385811634721243641)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4308_URL_TARGET'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(385811935593243644)
,p_event_id=>wwv_flow_imp.id(385811634721243641)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4308_PAGE_ID,P4308_REQUEST,P4308_CLEAR_CACHE,P4308_ARG_NAMES,P4308_ARG_VALUES,P4308_CLEAR_PAGE,P4308_PRINTER_FRIENDLY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(385812010092243645)
,p_event_id=>wwv_flow_imp.id(385811634721243641)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4308_PAGE_ID,P4308_REQUEST,P4308_CLEAR_CACHE,P4308_ARG_NAMES,P4308_ARG_VALUES,P4308_CLEAR_PAGE,P4308_PRINTER_FRIENDLY'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3004344924333541)
,p_name=>'Show Publish Success Msg'
,p_event_sequence=>40
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(200947320221891904)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3004452875333542)
,p_event_id=>wwv_flow_imp.id(3004344924333541)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ( this.data.successMessage ) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(184076129018005316)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_ICON_BAR'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_ICON_BAR'
,p_attribute_03=>'F4000_P4308_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_internal_uid=>184076129018005316
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(22040144011)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Split URL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'declare',
'  l_dummy varchar2(255);',
'  l_url_parts wwv_flow_global.vc_arr2;',
'begin',
'',
'for c1 in (select icon_target',
'             from wwv_flow_icon_bar',
'            where id = :F4000_P4308_ID',
'              and security_group_id = wwv_flow_security.g_security_group_id) loop',
'',
'wwv_flow_builder.split_url(',
'  p_url         => c1.icon_target,',
'  p_flow        => l_dummy,',
'  p_page        => :P4308_PAGE_ID,',
'  p_session     => l_dummy,',
'  p_request     => :P4308_REQUEST,',
'  p_debug       => l_dummy,',
'  p_clear_cache => :P4308_CLEAR_CACHE,',
'  p_arg_names   => :P4308_ARG_NAMES,',
'  p_arg_values  => :P4308_ARG_VALUES,',
'  p_success_msg => l_dummy );',
'',
'  -- Printer Friendly Check',
'  l_url_parts := wwv_flow_utilities.string_to_table(c1.icon_target);',
'  if l_url_parts.exists(9) then',
'    :P4308_PRINTER_FRIENDLY := l_url_parts(9);',
'  else',
'    :P4308_PRINTER_FRIENDLY := null;',
'  end if;',
'',
'  if :P4308_PAGE_ID is null then',
'    :P4308_URL_TARGET := c1.icon_target;',
'    :P4308_URL_OR_FLOW := ''URL'';',
'  else',
'    :P4308_URL_TARGET := null;',
'    :P4308_URL_OR_FLOW := ''FLOW'';',
'    if instr(:P4308_CLEAR_CACHE,''RP'') = 1 then',
'      :P4308_CLEAR_PAGE := ''YES'';',
'      :P4308_CLEAR_CACHE := ltrim(replace(:P4308_CLEAR_CACHE,''RP'',null),'','');',
'    else',
'      :P4308_CLEAR_PAGE := null;',
'    end if;',
'  end if;',
'end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error fetching row.'
,p_internal_uid=>22040144011
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(148593117500925633)
,p_process_sequence=>30
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_PAGINATION'
,p_process_name=>'Get Next or Previous Primary Key Value'
,p_attribute_02=>'WWV_FLOW_ICON_BAR'
,p_attribute_03=>'F4000_P4308_ID'
,p_attribute_04=>'ID'
,p_attribute_07=>'ICON_SEQUENCE'
,p_attribute_09=>'P4308_ID_NEXT'
,p_attribute_10=>'P4308_ID_PREV'
,p_attribute_13=>'P4308_ID_COUNT'
,p_attribute_14=>'flow_id = :fb_flow_id'
,p_process_error_message=>'Unable to run Get Next or Previous Primary Key Value process.'
,p_internal_uid=>148593117500925633
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(201053200844029745)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'referesh navbar 1'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_navbar (',
'    p_master_navbar_id         => :F4000_P4308_REFERENCE_ID,',
'    p_subscribing_navbar_id    => :F4000_P4308_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying navigation bar.'
,p_process_when_button_id=>wwv_flow_imp.id(200951627971903655)
,p_process_when=>'F4000_P4308_REFERENCE_ID'
,p_process_when_type=>'VALUE_OF_ITEM_IN_COND_1_NOT_EQ_COND_2'
,p_process_when2=>'0'
,p_process_success_message=>'Navigation bar copied.'
,p_internal_uid=>201053200844029745
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(22041144011)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process Row of WWV_FLOW_ICON_BAR'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'    select 1',
'      from sys.dual',
'     where :F4000_P4308_ID is null',
'        or exists ( select 1',
'                      from wwv_flow_icon_bar',
'                     where security_group_id = :FLOW_SECURITY_GROUP_ID',
'                       and flow_id           = :FB_FLOW_ID',
'                       and id                = :F4000_P4308_ID ) )',
'loop',
'    wwv_flow_dml.process(',
'    p_action      => wwv_flow.g_request,',
'    p_table_owner => ''#OWNER#'',',
'    p_table_name  => ''WWV_FLOW_ICON_BAR'',',
'    p_rowid       => v(''F4000_P4308_ID''),',
'    p_alt_rowid   => ''ID'');',
'    exit;',
'end loop;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error processing row.'
,p_process_success_message=>'Action processed.'
,p_internal_uid=>22041144011
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(35764514128288584)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh navbar 2'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_navbar (',
'    p_master_navbar_id         => :F4000_P4308_REFERENCE_ID,',
'    p_subscribing_navbar_id    => :F4000_P4308_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying navigation bar.'
,p_process_when=>':F4000_P4308_REFERENCE_ID is not null and :F4000_P4308_REFRESH = ''Y'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Navigation bar copied.'
,p_internal_uid=>35764514128288584
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(201063006008042542)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove reference id'
,p_process_sql_clob=>'wwv_flow_copy_metadata.remove_navbar_reference_id (:F4000_P4308_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error setting reference id to null.'
,p_process_when=>'F4000_P4308_REFERENCE_ID'
,p_process_when_type=>'VALUE_OF_ITEM_IN_COND_1_EQ_COND_2'
,p_process_when2=>'0'
,p_internal_uid=>201063006008042542
);
end;
/
prompt --application/pages/page_04309
begin
wwv_flow_imp_page.create_page(
 p_id=>4309
,p_name=>'Edit Application Process'
,p_alias=>'EDIT-APPLICATION-PROCESS'
,p_step_title=>'Edit Application Process'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(91429205691059841)
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_read_only_when=>'P4309_REFERENCE_ID'
,p_help_text=>'bldr_app_proc.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(470940026)
,p_plug_name=>'Application Process'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>90
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_PROCESSING'
,p_query_where=>'security_group_id = :WORKSPACE_ID'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(471942214)
,p_plug_name=>'Source'
,p_region_name=>'PROC'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_menu_template_id=>wwv_flow_imp.id(10071028536455972)
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_no_data_found=>'No menu options exist for this menu.'
,p_plug_query_show_nulls_as=>'(null)'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(472946689)
,p_plug_name=>'Conditions'
,p_region_name=>'COND'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_row_template=>wwv_flow_imp.id(60628322026519501)
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(473950010)
,p_plug_name=>'Application Processes'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>110
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Application Processes can be used to perform actions required for every page.  Application and page items can be referenced using :ITEM_NAME (bind variable) syntax.<br /><br />The Process Code is treated as a PL/SQL anonymous block.  &PRODUCT_NAME. w'
||'ill wrap a "begin" and "end;" around this code.  If you need to declare local variables you will need to do so using a "declare", "begin" and "end" block.<br /><br />',
'<p>When Application Process is subscribed, then it is not possible to change any data.</p>',
'<p>Deletion of the <strong>master</strong> application process automatically clears the application process references from subscribing application processes.</p>'))
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(16124035673659412)
,p_plug_name=>'Subscription'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>15
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'F4000_P4309_ID'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'WWV_FLOW_PROCESSING',
  'attribute_02', 'PROCESS_NAME',
  'attribute_03', 'F4000_P4309_ID',
  'attribute_04', 'P4309_REFERENCE_ID',
  'attribute_05', 'SUBSCRIBE_APP_PROCESS',
  'attribute_06', 'VERSION_SCN')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46258417365679010)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(146358621670654951)
,p_plug_name=>'Comments'
,p_region_name=>'C'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(146360716710657189)
,p_plug_name=>'Authorization'
,p_region_name=>'AUTH'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_row_template=>wwv_flow_imp.id(60628322026519501)
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(179022502185802099)
,p_plug_name=>'Configuration'
,p_region_name=>'CONFIG'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(179321217295576377)
,p_plug_name=>'Name'
,p_region_name=>'N'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(615490518574215323)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_imp.id(29434107863295859)
,p_plug_display_sequence=>80
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from WWV_FLOW_PROCESSING',
'where id = :F4000_P4309_ID and security_group_id = :WORKSPACE_ID) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :F4000_P4309_ID,',
'      p_component_type => ''Application Process'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3564573479165792)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_imp.id(16124035673659412)
,p_button_name=>'UNSUBSCRIBE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Unsubscribe'
,p_button_position=>'EDIT'
,p_button_condition=>':P4309_REFERENCE_ID is not null and :P4309_SUBSCRIBED_COMP_GRP = ''N'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3564977118165794)
,p_button_sequence=>110
,p_button_plug_id=>wwv_flow_imp.id(16124035673659412)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Refresh Application Process'
,p_button_position=>'EDIT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P4309_REFERENCE_ID is not null ',
'and ( :P4309_VERSION_SCN != :P4309_MASTER_VERSION_SCN or :P4309_VERSION_SCN is null )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3565373393165794)
,p_button_sequence=>120
,p_button_plug_id=>wwv_flow_imp.id(16124035673659412)
,p_button_name=>'PUBLISH'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Publish'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.:149:F4000_P149_ID,F4000_P149_TEMPLATE_TYPE,F4000_P149_PAGE_ID:&F4000_P4309_ID.,APP_PROCESS,4309'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * ',
'  from wwv_flow_processing',
' where reference_id      = :F4000_P4309_ID ',
'   and security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(22043144011)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(470940026)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(22044144011)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(470940026)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_confirm_message=>'&DELETE_MSG.'
,p_confirm_style=>'danger'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P4309_ID is not null',
'and ( :P4309_REFERENCE_ID is null or :P4309_SUBSCRIBED_COMP_GRP = ''N'' )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(22045144012)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(470940026)
,p_button_name=>'SAVE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>':F4000_P4309_ID is not null and :P4309_REFERENCE_ID is null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(22046144012)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(470940026)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P4309_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(91800322412064357)
,p_branch_name=>'Go To Page 4309'
,p_branch_action=>'f?p=&APP_ID.:4309:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':F4000_P4309_STAY = ''YES'' and :REQUEST != ''DELETE'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(22048144012)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(803951768)
,p_name=>'P4309_PROCESS_COMMENT'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(146358621670654951)
,p_item_source_plug_id=>wwv_flow_imp.id(470940026)
,p_prompt=>'Comments'
,p_source=>'PROCESS_COMMENT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'<p>Enter any comments or notes here.  These comments will never be displayed when running the application, but are for use by application developers instead.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9170594471)
,p_name=>'P4309_REQUIRED_PATCH'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(179022502185802099)
,p_item_source_plug_id=>wwv_flow_imp.id(470940026)
,p_prompt=>'Build Option'
,p_source=>'REQUIRED_PATCH'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PATCHES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(patch_name) pn, id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'', wwv_flow_escape.html(patch_name))||',
'''} '' pn,0-id id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by pn'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Build Option -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select a build option for this component.</p>',
'<p>Build options are predefined settings that determine whether or not  components within an application are enabled.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22050144013)
,p_name=>'F4000_P4309_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(179321217295576377)
,p_item_source_plug_id=>wwv_flow_imp.id(470940026)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22051144013)
,p_name=>'P4309_FLOW_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(179321217295576377)
,p_item_source_plug_id=>wwv_flow_imp.id(470940026)
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Application'
,p_source=>'FLOW_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies the application ID and name that owns the process.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22052144013)
,p_name=>'P4309_PROCESS_SEQUENCE'
,p_source_data_type=>'NUMBER'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(179321217295576377)
,p_item_source_plug_id=>wwv_flow_imp.id(470940026)
,p_item_default=>'10'
,p_prompt=>'Sequence'
,p_source=>'PROCESS_SEQUENCE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'<p>Specify the sequence for this component.  The sequence determines the order of evaluation.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22053144014)
,p_name=>'P4309_PROCESS_POINT'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(179321217295576377)
,p_item_source_plug_id=>wwv_flow_imp.id(470940026)
,p_item_default=>'BEFORE_HEADER'
,p_prompt=>'Process Point'
,p_source=>'PROCESS_POINT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'FLOW.PROCESS.TYPE'
,p_lov=>'.'||wwv_flow_imp.id(179311318624565491)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'<p>For an application-level process, this identifies the point during the processing of each page in the application that this process runs. Note the option, Ajax Callback, only runs when requested by a page process.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22054144014)
,p_name=>'P4309_PROCESS_NAME'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(179321217295576377)
,p_item_source_plug_id=>wwv_flow_imp.id(470940026)
,p_prompt=>'Name'
,p_source=>'PROCESS_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'<p>Identifies the name of the process for reference by application developers.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22055144014)
,p_name=>'P4309_PROCESS_SQL'
,p_source_data_type=>'CLOB'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(471942214)
,p_item_source_plug_id=>wwv_flow_imp.id(470940026)
,p_prompt=>'Code'
,p_source=>'PROCESS_SQL_CLOB'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>16
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter the PL/SQL code of your application process. The code will automatically be wrapped with a "<code>Begin</code>" and "<code>End;</code>".'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PAGE_ITEM'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_06=>'P4309_PROCESS_CLOB_LANGUAGE'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22056144014)
,p_name=>'P4309_PROCESS_ERROR_MESSAGE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(471942214)
,p_item_source_plug_id=>wwv_flow_imp.id(470940026)
,p_prompt=>'Process Error Message'
,p_source=>'PROCESS_ERROR_MESSAGE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter the text for an error message that can be displayed if the process fails.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22057144015)
,p_name=>'P4309_PROCESS_WHEN'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(472946689)
,p_item_source_plug_id=>wwv_flow_imp.id(470940026)
,p_prompt=>'Expression 1'
,p_source=>'PROCESS_WHEN'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'<p>This attribute allows you to conditionally control the circumstances under which this process should fire.  Enter values in this attribute based on the specific condition type selected.  The process will fire only if the specified condition is met'
||'.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22058144015)
,p_name=>'P4309_PROCESS_WHEN_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(472946689)
,p_item_source_plug_id=>wwv_flow_imp.id(470940026)
,p_prompt=>'Condition Type'
,p_source=>'PROCESS_WHEN_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CONDITION_LIST'
,p_named_lov=>'STANDARD_CONDITION_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(13602414170805697)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Condition Type -'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'<p>Select a condition type from the list that must be met in order for this component to be processed.</p>'
,p_attribute_01=>'P4309_PROCESS_WHEN'
,p_attribute_02=>'P4309_PROCESS_WHEN2'
,p_attribute_04=>'P4309_PROCESS_WHEN_CHECK'
,p_attribute_06=>'CONDITION'
,p_attribute_07=>'P4309_PROCESS_WHEN_LANG'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1567784322713208)
,p_name=>'P4309_PROCESS_CLOB_LANGUAGE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(471942214)
,p_item_source_plug_id=>wwv_flow_imp.id(470940026)
,p_prompt=>'Language'
,p_source=>'PROCESS_CLOB_LANGUAGE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2300219343421105)
,p_name=>'P4309_PROCESS_WHEN_LANG'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(472946689)
,p_prompt=>'Language'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select a language that is used to evaluate the entered programming code.'
,p_attribute_03=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2356382669667308)
,p_name=>'P4309_SUBSCRIBED_COMP_GRP'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(16124035673659412)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4295631883163712)
,p_name=>'P4309_ERROR_DISPLAY_LOCATION'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(471942214)
,p_item_source_plug_id=>wwv_flow_imp.id(470940026)
,p_item_default=>'INLINE_IN_NOTIFICATION'
,p_prompt=>'Error message display location'
,p_source=>'ERROR_DISPLAY_LOCATION'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PROCESS_ERROR_DISPLAY_LOCATION'
,p_lov=>'.'||wwv_flow_imp.id(4297030283172730)||'.'
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_display_when=>'P4309_PROCESS_POINT'
,p_display_when2=>'ON_SUBMIT_BEFORE_COMPUTATION:AFTER_SUBMIT'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>The <strong>Error display location</strong> identifies where the process error message will display.  Process error messages can be displayed on an error page, or inline with the existing page in the "notification" area (defined as part of the pag'
||'e template).</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4797207856120918)
,p_name=>'P4309_VERSION_SCN'
,p_source_data_type=>'NUMBER'
,p_is_query_only=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(16124035673659412)
,p_item_source_plug_id=>wwv_flow_imp.id(470940026)
,p_source=>'VERSION_SCN'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4797326524120919)
,p_name=>'P4309_MASTER_VERSION_SCN'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(16124035673659412)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select version_scn ',
'  from wwv_flow_processing',
' where id                = :P4309_REFERENCE_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4836709962963406)
,p_name=>'P4309_CHECK_SYNTAX'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(471942214)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Do not validate code (parse code at runtime only).'
,p_source=>'NULL'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_restricted_characters=>'WEB_SAFE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'NO'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(16127131905659452)
,p_name=>'P4309_REFERENCE_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(16124035673659412)
,p_item_source_plug_id=>wwv_flow_imp.id(470940026)
,p_prompt=>'Subscribe From'
,p_source=>'REFERENCE_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FLOW_SUBSCRIBE_FROM_APP_PROCESSES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select b.flow_id ||'' ''||f.name||'' - ''|| b.process_name d,',
'       b.id r',
'  from wwv_flow_processing b,',
'       wwv_main_apps_dev f',
' where b.flow_id          != nvl(:FB_FLOW_ID,0)',
'   and b.flow_id           = f.id',
'   and f.build_status      not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'   and b.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and f.security_group_id = :FLOW_SECURITY_GROUP_ID',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Subscription -'
,p_cSize=>50
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a master application process to subscribe from. When you select a master application process and click on the <strong>Apply Changes</strong> button, the application process details will be automatically refreshed from the selected master.<br /'
||'><br />If the application process is already subscribed, then click on the <strong>Refresh Application Process</strong> button to refresh the application process details from the master application process.'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'Y'
,p_attribute_06=>'0'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(16127218383659453)
,p_name=>'P4309_REFERENCE_ID_INIT'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(16124035673659412)
,p_use_cache_before_default=>'NO'
,p_item_default=>'P4309_REFERENCE_ID'
,p_item_default_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17787105784947386)
,p_name=>'P4309_PROCESS_WHEN2'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(472946689)
,p_item_source_plug_id=>wwv_flow_imp.id(470940026)
,p_prompt=>'Expression 2'
,p_source=>'PROCESS_WHEN2'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'<p>Some condition types require two expressions for comparison.  Enter the second expression or item here.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(91797521458045167)
,p_name=>'F4000_P4309_STAY'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(473950010)
,p_prompt=>'Stay on page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_read_only_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select this checkbox to stay on this page after applying changes.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'YES'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(146368811522674873)
,p_name=>'P4309_SECURITY_SCHEME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(146360716710657189)
,p_item_source_plug_id=>wwv_flow_imp.id(470940026)
,p_prompt=>'Authorization Scheme'
,p_source=>'SECURITY_SCHEME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REQUIRED_ROLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.d, a.r from (',
'    select wwv_flow_lang.system_message(''MUST_NOT_BE_PUBLIC_USER'') d,''MUST_NOT_BE_PUBLIC_USER'' r, 1',
'      from sys.dual',
'    union all',
'    select wwv_flow_escape.html(substr(name,1,50)),to_char(id), 1',
'      from wwv_flow_security_schemes',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID',
'    union all',
'    select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'',wwv_flow_escape.html(substr(name,1,50)))||''}'' d, ''!''||to_char(id) r, 2',
'      from wwv_flow_security_schemes',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID',
'    order by 3,1) a'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Authorization Required -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'<p>Optionally select an authorization scheme which must evaluate to TRUE in order for this process to run.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(195096709473544728)
,p_name=>'P4309_PROCESS_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(179321217295576377)
,p_item_source_plug_id=>wwv_flow_imp.id(470940026)
,p_item_default=>'PLSQL'
,p_prompt=>'Type'
,p_source=>'PROCESS_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PLSQL_ANONYMOUS_BLOCK'
,p_lov=>'.'||wwv_flow_imp.id(84783318827001758)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Identifies the type of process. <strong>PL/SQL anonymous block</strong>:</p><BLOCKQUOTE>Runs a PL/SQL process. </BLOCKQUOTE>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(435041823893654787)
,p_name=>'P4309_PROCESS_WHEN_CHECK'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(472946689)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Do not validate code (parse code at runtime only).'
,p_source=>'NULL'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2356456270667309)
,p_computation_sequence=>10
,p_computation_item=>'P4309_SUBSCRIBED_COMP_GRP'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_component_group_dev.is_part_of_subscribed_comp_grp (',
'    p_component_id   => :F4000_P4309_ID,',
'    p_component_type => wwv_flow_copy_metadata.c_app_computation,',
'    p_app_id         => :FB_FLOW_ID )'))
,p_compute_when=>'F4000_P4309_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(171393802931702648)
,p_computation_sequence=>20
,p_computation_item=>'P4309_PROCESS_SQL'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_utilities.remove_trailing_whitespace(:P4309_PROCESS_SQL)'
,p_computation_error_message=>'Unable to compute item value.'
,p_compute_when=>'P4309_PROCESS_SQL'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(171398124916707597)
,p_validation_name=>'P4309_PROCESS_SQL must be less than 30,000'
,p_validation_sequence=>30
,p_validation=>'length(:P4309_PROCESS_SQL) <= 30000'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Application process cannot exceed 30,000 bytes.'
,p_validation_condition=>'CREATE,SAVE,DELETE,UNSUBSCRIBE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4835631325938298)
,p_validation_name=>'Syntax Check'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_code_exec_dev.check_code (',
'           p_type     => wwv_flow_code_exec_dev.c_check_block,',
'           p_code     => :P4309_PROCESS_SQL,',
'           p_language => :P4309_PROCESS_CLOB_LANGUAGE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'nvl(:P4309_CHECK_SYNTAX, ''YES'') = ''YES'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(22045144012)
,p_associated_item=>wwv_flow_imp.id(22055144014)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4025380984992037)
,p_validation_name=>'Process name unique'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_processing',
' where security_group_id = :WORKSPACE_ID ',
'   and flow_id           = :FB_FLOW_ID ',
'   and process_name      = :P4309_PROCESS_NAME',
'   and id               != nvl(:F4000_P4309_ID, -1)'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#LABEL# must be unique'
,p_when_button_pressed=>wwv_flow_imp.id(22045144012)
,p_associated_item=>wwv_flow_imp.id(22054144014)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1411259994779894)
,p_validation_name=>'No duplicate subscription'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_processing',
' where security_group_id = :WORKSPACE_ID ',
'   and flow_id           = :FB_FLOW_ID ',
'   and reference_id      = :P4309_REFERENCE_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'An existing application process in this application is subscribed to the same master. Please select another master application process.'
,p_validation_condition=>':P4309_REFERENCE_ID is not null and :P4309_REFERENCE_ID_INIT is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(22045144012)
,p_associated_item=>wwv_flow_imp.id(16127131905659452)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2606405138037352)
,p_validation_name=>'Not part of component groups'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not wwv_flow_component_group_dev.is_part_of_comp_grp (',
'    p_component_id   => :F4000_P4309_ID ,',
'    p_component_type => wwv_flow_copy_metadata.c_app_process,',
'    p_app_id         => :FB_FLOW_ID )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Application Process cannot be deleted because it is part of a component group.'
,p_when_button_pressed=>wwv_flow_imp.id(22044144011)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6609803755558803)
,p_name=>'Hide P4309_REFERENCE_ID'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P4309_REFERENCE_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6609938081558804)
,p_event_id=>wwv_flow_imp.id(6609803755558803)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4309_REFERENCE_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2356548188667310)
,p_name=>'Save'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(22045144012)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2356610715667311)
,p_event_id=>wwv_flow_imp.id(2356548188667310)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'Are you sure you want to subscribe? This will overwrite the current application process data with the selected master application process.'
,p_attribute_03=>'warning'
,p_attribute_06=>'Subscribe'
,p_attribute_07=>'Cancel'
,p_client_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_client_condition_expression=>'$v(''P4309_REFERENCE_ID'') !== "" && $v(''P4309_REFERENCE_ID_INIT'') === ""'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2356762853667312)
,p_event_id=>wwv_flow_imp.id(2356548188667310)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'SAVE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3345938028623725)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(470940026)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process form Application Process'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE,SAVE,DELETE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'Application Process saved.'
,p_internal_uid=>3345938028623725
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3346146196623727)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh App Process'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.refresh_component (',
'    p_component_type     => wwv_flow_copy_metadata.c_app_process,',
'    p_master_id          => :P4309_REFERENCE_ID,',
'    p_subscribing_id     => :F4000_P4309_ID,',
'    p_subscribing_app_id => :FB_FLOW_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST = ''REFRESH''',
'or ( :REQUEST = ''SAVE'' and :P4309_REFERENCE_ID is not null and :P4309_REFERENCE_ID_INIT is null )'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Application process refreshed from the master.'
,p_internal_uid=>3346146196623727
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(6620302365882052)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Unsubscribe'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.unsubscribe_component (',
'    p_component_type  => wwv_flow_copy_metadata.c_app_process,',
'    p_component_id    => :F4000_P4309_ID,',
'    p_app_id          => :FB_FLOW_ID );    '))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3564573479165792)
,p_process_success_message=>'Application Process has been unsubscribed.'
,p_internal_uid=>6620302365882052
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4641245795721108)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Clear Subscriptions'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- when deleting the component, clear reference_id data from subscribing apps',
'--',
'wwv_flow_copy_metadata.clear_subscriptions (',
'    p_component_type => wwv_flow_copy_metadata.c_app_process,',
'    p_master_id      => :F4000_P4309_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(22044144011)
,p_internal_uid=>4641245795721108
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(8162019968443229)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(470940026)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Edit Application Process'
,p_internal_uid=>8162019968443229
);
end;
/
prompt --application/pages/page_04310
begin
wwv_flow_imp_page.create_page(
 p_id=>4310
,p_name=>'Application Comments'
,p_alias=>'APPLICATION-COMMENTS'
,p_page_mode=>'MODAL'
,p_step_title=>'Application Comments'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213220627333807318)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_app_com.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(62329311242879281)
,p_plug_name=>'Comments'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>130
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(590132738684647897)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>140
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(22062144016)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_imp.id(590132738684647897)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(22064144016)
,p_button_sequence=>3
,p_button_plug_id=>wwv_flow_imp.id(590132738684647897)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'CREATE'
,p_button_condition=>'F4000_P4310_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(22065144016)
,p_button_sequence=>4
,p_button_plug_id=>wwv_flow_imp.id(590132738684647897)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
,p_button_condition=>'F4000_P4310_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(22067144017)
,p_branch_action=>'9'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>119
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22069144017)
,p_name=>'F4000_P4310_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(62329311242879281)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'This attribute identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(22070144017)
,p_name=>'F4000_P4310_BANNER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(62329311242879281)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comments'
,p_source=>'BANNER'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cMaxlength=>32767
,p_cHeight=>12
,p_tag_attributes=>'style="width:465px;"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'<p>Enter any comments or notes here.  These comments will never be displayed when running the application.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(590116752384572003)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(22062144016)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(590116858254572004)
,p_event_id=>wwv_flow_imp.id(590116752384572003)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(22071144018)
,p_process_sequence=>1
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch Row from WWV_FLOW_BANNER'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'for c1 in (',
'select 1 from wwv_flow_banner',
'where security_group_id = :flow_security_group_id and',
'      id = :F4000_P4310_ID) loop',
'wwv_flow_dml.fetch_row(',
'  p_table_owner => ''#OWNER#'',',
'  p_table_name  => ''WWV_FLOW_BANNER'',',
'  p_rowid       => v(''F4000_P4310_ID''),',
'  p_alt_rowid   => ''ID'');',
'exit;',
'end loop;',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error fetching row.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>22071144018
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(22072144018)
,p_process_sequence=>1
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process Row of WWV_FLOW_BANNER'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'for c1 in (',
'select 1 from dual',
'where :F4000_P4310_ID is null',
'or exists (select 1 from wwv_flow_banner',
'                   where security_group_id = :flow_security_group_id and',
'      id = :F4000_P4310_ID)) loop',
'wwv_flow_dml.process(',
'p_action => wwv_flow.g_request,',
'p_table_owner => ''#OWNER#'',',
'p_table_name  => ''WWV_FLOW_BANNER'',',
'p_rowid       => v(''F4000_P4310_ID''),',
'p_alt_rowid   => ''ID'');',
'exit;',
'end loop;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error processing row.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Action processed.'
,p_internal_uid=>22072144018
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(590116923491572005)
,p_process_sequence=>11
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'Create,ApplyChanges'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'Action processed.'
,p_internal_uid=>590116923491572005
);
end;
/
prompt --application/pages/page_04318
begin
wwv_flow_imp_page.create_page(
 p_id=>4318
,p_name=>'Edit Parent Tabs'
,p_alias=>'EDIT-PARENT-TABS'
,p_step_title=>'Edit Parent Tab'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213240607818867991)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'function callItempopUp(s1,s2) {',
'     var items = document.getElementById(s1).value.replace(/\,/g,''~'');',
'     var values = document.getElementById(s2).value.replace(/\,/g,''~'');',
'     var url = ''f?p=4000:404:&SESSION.:::404:P404_RETURN1,P404_RETURN2,P404_ITEMS,P404_VALUES:'' + s1 + '','' + s2 + '','' + escape(items) + '','' + escape(values);',
'     popUp (url);',
'}',
'</script>'))
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(466864847)
,p_plug_name=>'Attributes'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>3
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_row_count_max=>5000
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'L:L:R'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(467876613)
,p_plug_name=>'Parent Tabs'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>21
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Parent tabs are parents of standard tabs and require the existence of a standard level tab to be displayed.  Each non-current parent level tab is displayed as a link.  ',
'<p>',
'A parent level tab is current if the current page belongs to a tab-set whose parent is the parent level tab.  The current tab set is defined by the "Current on Standard TabSet" field.'))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(468886629)
,p_plug_name=>'Tab Target'
,p_region_name=>'TAR'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>94
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(469888520)
,p_plug_name=>'Conditional Tab Display'
,p_region_name=>'CON'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>96
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>' '
,p_plug_query_row_template=>wwv_flow_imp.id(118965217531999309)
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46261023725679016)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>2
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(91892922055192842)
,p_plug_name=>'Parent Tab'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(119249815723896591)
,p_plug_name=>'Comments'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(145723531128912349)
,p_plug_name=>'Authorization'
,p_region_name=>'AUT'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>97
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(167029827418165358)
,p_plug_name=>'Configuration'
,p_region_name=>'BUILD'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>98
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(185569318248518897)
,p_plug_name=>'Image Attributes'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>95
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(11089289914)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_imp.id(91892922055192842)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(11090289914)
,p_button_sequence=>2
,p_button_plug_id=>wwv_flow_imp.id(91892922055192842)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
,p_button_condition=>'F4000_P4318_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(11091289914)
,p_button_sequence=>3
,p_button_plug_id=>wwv_flow_imp.id(91892922055192842)
,p_button_name=>'Apply_Changes'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P4318_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(11092289914)
,p_button_sequence=>4
,p_button_plug_id=>wwv_flow_imp.id(91892922055192842)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P4318_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(11094289915)
,p_branch_action=>'&F4000_LAST_VIEW.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>119
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(576386928)
,p_name=>'F4000_P4318_DISPLAY_CONDITION'
,p_item_sequence=>36
,p_item_plug_id=>wwv_flow_imp.id(469888520)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Expression 1'
,p_source=>'DISPLAY_CONDITION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>This attribute allows you to conditionally control whether or not a  component is rendered or processed.  Enter values in this attribute based on the specific condition type selected.  The component will be rendered or processed if the specified c'
||'ondition is met.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11096289920)
,p_name=>'F4000_P4318_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(466864847)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11097289920)
,p_name=>'F4000_P4318_FLOW_ID'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_imp.id(466864847)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Application:'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'This attribute identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11098289921)
,p_name=>'F4000_P4318_TAB_SET'
,p_item_sequence=>3
,p_item_plug_id=>wwv_flow_imp.id(466864847)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Parent Tab Set:'
,p_source=>'TAB_SET'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Allows tabs to be grouped into a single tabset. All tabs of a tabset are displayed assuming the tab passes the display condition. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11099289921)
,p_name=>'F4000_P4318_TAB_SEQUENCE'
,p_item_sequence=>4
,p_item_plug_id=>wwv_flow_imp.id(466864847)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Sequence'
,p_source=>'TAB_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>8
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Specify the sequence for this component.  The sequence determines the order of evaluation.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11100289921)
,p_name=>'F4000_P4318_TAB_NAME'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_imp.id(466864847)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>'TAB_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the individual tab entry. This is for referencing the tab internally. This is not the displayed text, or label for the tab.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11101289922)
,p_name=>'F4000_P4318_TAB_IMAGE'
,p_item_sequence=>6
,p_item_plug_id=>wwv_flow_imp.id(185569318248518897)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Image'
,p_source=>'TAB_IMAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'If the tab is an image and not text tab then enter a file name (without a prefix) in this field. For example mytab.gif. This is the image for the current tab.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11102289922)
,p_name=>'F4000_P4318_TAB_NON_CURRENT_IMAGE'
,p_item_sequence=>7
,p_item_plug_id=>wwv_flow_imp.id(185569318248518897)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Non Current Image'
,p_source=>'TAB_NON_CURRENT_IMAGE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Optional image used for non current tab. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11103289922)
,p_name=>'F4000_P4318_TAB_IMAGE_ATTRIBUTES'
,p_item_sequence=>8
,p_item_plug_id=>wwv_flow_imp.id(185569318248518897)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Image Attributes'
,p_source=>'TAB_IMAGE_ATTRIBUTES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Additional HTML attributes for the image, if used, for example, width="14" height="18".'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11104289923)
,p_name=>'F4000_P4318_TAB_TEXT'
,p_item_sequence=>11
,p_item_plug_id=>wwv_flow_imp.id(466864847)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Label'
,p_source=>'TAB_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'This is the displayed name for the tab if an image is not used. It is used as the ALT image tag if an image is used.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11105289923)
,p_name=>'F4000_P4318_TAB_TARGET'
,p_item_sequence=>12
,p_item_plug_id=>wwv_flow_imp.id(468886629)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Target<br> (Syntax: f?p=application:page:session:request:debug:clearCache:itemNames:itemValues:printerFriendly)(Example f?p=3000:3001:&amp;SESSION.)'
,p_source=>'TAB_TARGET'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>80
,p_cMaxlength=>255
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11106289924)
,p_name=>'F4000_P4318_REQUIRED_PATCH'
,p_item_sequence=>13
,p_item_plug_id=>wwv_flow_imp.id(167029827418165358)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Build Option'
,p_source=>'REQUIRED_PATCH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PATCHES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(patch_name) pn, id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'', wwv_flow_escape.html(patch_name))||',
'''} '' pn,0-id id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by pn'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Build Option -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select a build option for this component.</p>',
'<p>Build options are predefined settings that determine whether or not  components within an application are enabled.</p>'))
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11107289924)
,p_name=>'F4000_P4318_TAB_COMMENT'
,p_item_sequence=>18
,p_item_plug_id=>wwv_flow_imp.id(119249815723896591)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comments'
,p_source=>'TAB_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Enter any comments or notes here.  These comments will never be displayed when running the application</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11132399142)
,p_name=>'F4000_P4318_CURRENT_ON_TABSET'
,p_item_sequence=>9
,p_item_plug_id=>wwv_flow_imp.id(466864847)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Current on Standard TabSet'
,p_source=>'CURRENT_ON_TABSET'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_TABSETS'
,p_lov=>'select wwv_flow_escape.html(d) d, r from wwv_flow_tabset_view'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Standard Tab Set -'
,p_lov_null_value=>'%null%'
,p_cSize=>64
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identifies the child (corresponding standard tab) of this parent tab.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(64149671474)
,p_name=>'F4000_P4318_DISPLAY_CONDITION_TYPE'
,p_item_sequence=>16
,p_item_plug_id=>wwv_flow_imp.id(469888520)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tab Display Condition'
,p_source=>'DISPLAY_CONDITION_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CONDITION_LIST'
,p_named_lov=>'STANDARD_CONDITION_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(13602414170805697)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Tab Not Conditional -'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<P>Select one of the predefined conditions if you want this tab displayed only in certain situations:</P>',
'',
'<UL>',
'',
'<LI>CURRENT_PAGE_NOT_EQUALS_CONDITION: tab will be displayed only if the current page is not the page specified in the Display Condition field.</LI>',
'',
'<LI>CURRENT_PAGE_EQUALS_CONDITION: tab will be displayed only if the current page is the page specified in the Display Condition field.</LI>',
'',
'<LI>CURRENT_PAGE_NOT_IN_CONDITION: tab will be displayed only if the current page is not in the list of pages specified in the Display Condition field (comma-separated list of pages).</LI>',
'',
'<LI>CURRENT_PAGE_IN_CONDITION: tab will be displayed only if the current page is in the list of pages specified in the Display Condition field (comma-separated list of pages).</LI>',
'',
'<LI>USER_IS_NOT_PUBLIC_USER: tab will be displayed only&nbsp;if the current user is not the public user. No entry required in the Display Condition field.</LI>',
'',
'<LI>USER_IS_PUBLIC_USER: tab will be displayed only&nbsp;if the current user is the public user. No entry required in the Display Condition field.</LI>',
'',
'<LI>EXISTS: tab will be displayed only if the query in the Display Condition field returns at least one row.</LI>',
'',
'<LI>ITEM_IS_NOT_NULL: tab will be displayed only if item identified in the Display Condition field is not null.</LI>',
'',
'<LI>ITEM_IS_NULL:&nbsp; tab will be displayed only if item identified in the Display Condition field is null.</LI>',
'',
'<LI>NOT_EXISTS: tab will be displayed only if the query in the Display Condition field returns no rows.</LI>',
'',
'<LI>PLSQL_EXPRESSION: tab will be displayed only if the PL/SQL expression in the Display Condition field evaluates to true.</LI>',
'',
'<LI>SQL_EXPRESSION: tab will be displayed only if the SQL expression in the Display Condition field evaluates to true.</LI></UL>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'F4000_P4318_DISPLAY_CONDITION'
,p_attribute_02=>'F4000_P4318_DISPLAY_CONDITION2'
,p_attribute_04=>'F4000_P4318_DISPLAY_CONDITION_CHECK'
,p_attribute_06=>'CONDITION'
,p_attribute_07=>'F4000_P4318_DISPLAY_CONDITION_LANG'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(293052246378)
,p_name=>'F4000_P4318_SECURITY_SCHEME'
,p_item_sequence=>14
,p_item_plug_id=>wwv_flow_imp.id(145723531128912349)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Authorization Scheme'
,p_source=>'SECURITY_SCHEME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REQUIRED_ROLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.d, a.r from (',
'    select wwv_flow_lang.system_message(''MUST_NOT_BE_PUBLIC_USER'') d,''MUST_NOT_BE_PUBLIC_USER'' r, 1',
'      from sys.dual',
'    union all',
'    select wwv_flow_escape.html(substr(name,1,50)),to_char(id), 1',
'      from wwv_flow_security_schemes',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID',
'    union all',
'    select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'',wwv_flow_escape.html(substr(name,1,50)))||''}'' d, ''!''||to_char(id) r, 2',
'      from wwv_flow_security_schemes',
'     where flow_id = :FB_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID',
'    order by 3,1) a'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Authorization Required -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'<p>Optionally select an authorization scheme which must evaluate to TRUE in order for this component to be rendered or otherwise processed.</p>'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2302783387436909)
,p_name=>'F4000_P4318_DISPLAY_CONDITION_LANG'
,p_item_sequence=>26
,p_item_plug_id=>wwv_flow_imp.id(469888520)
,p_prompt=>'Language'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select a language that is used to evaluate the entered programming code.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17468309780745161)
,p_name=>'F4000_P4318_DISPLAY_CONDITION2'
,p_item_sequence=>56
,p_item_plug_id=>wwv_flow_imp.id(469888520)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Expression 2'
,p_source=>'DISPLAY_CONDITION2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Some condition types require two expressions for comparison.  Enter the second expression or item here.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21535509380480556)
,p_name=>'P4318_PAGE_ID'
,p_item_sequence=>38
,p_item_plug_id=>wwv_flow_imp.id(468886629)
,p_prompt=>'Page'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d',
'  from wwv_flow_steps',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and is_page_pattern   = ''N''',
'order by 2'))
,p_cSize=>14
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter the page number.  Check the box next to the page number if you would like to reset pagination for that page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21536421631493496)
,p_name=>'P4318_CLEAR_PAGE'
,p_item_sequence=>48
,p_item_plug_id=>wwv_flow_imp.id(468886629)
,p_prompt=>'Reset pagination for this page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Check this box to reset the pagination that is linked to.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'YES'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21537300984497027)
,p_name=>'P4318_REQUEST'
,p_item_sequence=>58
,p_item_plug_id=>wwv_flow_imp.id(468886629)
,p_prompt=>'Request'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter text that you would like to set the built-in application item called REQUEST.  This is also the item that is set with the name of a button that was clicked.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21538213451500649)
,p_name=>'P4318_CLEAR_CACHE'
,p_item_sequence=>68
,p_item_plug_id=>wwv_flow_imp.id(468886629)
,p_prompt=>'Clear Cache'
,p_post_element_text=>'<span class="instructionText">(comma separated page numbers)</span>'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter the page numbers, separated by commas, for which you would like the user''s session state to be cleared.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21539125918504264)
,p_name=>'P4318_ARG_NAMES'
,p_item_sequence=>78
,p_item_plug_id=>wwv_flow_imp.id(468886629)
,p_prompt=>'Set these items'
,p_post_element_text=>'<span class="instructionText">(comma separated name list)</span>'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the list of application item names separated by a comma, for which you would like to set the session state (give the listed item a value).'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'callItempopUp'
,p_attribute_03=>'Find Item'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21540024317513227)
,p_name=>'P4318_ARG_VALUES'
,p_item_sequence=>88
,p_item_plug_id=>wwv_flow_imp.id(468886629)
,p_prompt=>'With these values'
,p_post_element_text=>'<span class="instructionText">(comma separated value list)</span>'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter a comma delimited list of values for the items specified in <span class="fielddatabold">Set these items</span>. You can specify static values or substitution syntax (for example, &amp;APP_ITEM_NAME.). ',
'<pre>&amp;APP_ITEM_NAME.</pre>',
'<div class="htmldbInfoBodyP">Item values passed to <span class="fielddatabold">f?p=</span> in the URL may never contain a colon (:). Item values may also not contain commas unless you enclose the entire value in backslash characters. For example:</di'
||'v>',
'<pre>\1234,56\</pre>',
'<div class="htmldbInfoBodyP">This is useful when decimal values must be passed where the NLS decimal separator character is a comma.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'callItempopUp'
,p_attribute_03=>'Find Item'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(77640609408595060)
,p_name=>'P4318_URL_OR_FLOW'
,p_item_sequence=>11.5
,p_item_plug_id=>wwv_flow_imp.id(468886629)
,p_item_default=>'FLOW'
,p_prompt=>'Target type'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'URL_OR_PAGE'
,p_lov=>'.'||wwv_flow_imp.id(84796030957080920)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a target type for this parent tab.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(77648318674616570)
,p_name=>'P4318_URL_TARGET'
,p_item_sequence=>108
,p_item_plug_id=>wwv_flow_imp.id(468886629)
,p_prompt=>'URL Target'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>3
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify URL.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(435043900011654795)
,p_name=>'F4000_P4318_DISPLAY_CONDITION_CHECK'
,p_item_sequence=>46
,p_item_plug_id=>wwv_flow_imp.id(469888520)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Do not validate code (parse code at runtime only).'
,p_source=>'NULL'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(21546424111598369)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P4318_TAB_TARGET'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_clear_cache varchar2(4000);',
'begin',
'',
'if :P4318_URL_OR_FLOW = ''FLOW'' then',
'  if :P4318_CLEAR_PAGE = ''YES'' then',
'    l_clear_cache := ''RP,''||:P4318_CLEAR_CACHE;',
'  else',
'    l_clear_cache := :P4318_CLEAR_CACHE;',
'  end if;',
'  return ''f?p=&''||''APP_ID.:''||:P4318_PAGE_ID||'':&''||''SESSION.:''||:P4318_REQUEST||'':&''||''DEBUG.:''||rtrim(l_clear_cache,'','')||'':''||:P4318_ARG_NAMES||'':''||:P4318_ARG_VALUES;',
'else',
'  return :P4318_URL_TARGET;',
'end if;',
'end;'))
,p_computation_error_message=>'Unable to compute item value.'
,p_compute_when=>'Create,Apply_Changes'
,p_compute_when_type=>'REQUEST_IN_CONDITION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(240569720533263131)
,p_validation_name=>'F4000_P4318_TAB_SEQUENCE not null'
,p_validation_sequence=>5
,p_validation=>'F4000_P4318_TAB_SEQUENCE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Sequence number must be specified.'
,p_validation_condition=>'Apply_Changes, Create'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(11099289921)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(240568002394248467)
,p_validation_name=>'F4000_P4318_TAB_SEQUENCE is numeric'
,p_validation_sequence=>10
,p_validation=>'F4000_P4318_TAB_SEQUENCE'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Sequence must be a number.'
,p_validation_condition=>'Apply_Changes, Create'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(11099289921)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(240571806381287495)
,p_validation_name=>'F4000_P4318_TAB_NAME not null'
,p_validation_sequence=>20
,p_validation=>'F4000_P4318_TAB_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Tab name must be specified.'
,p_validation_condition=>'Apply_Changes, Create'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(11100289921)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(240575519204366837)
,p_validation_name=>'F4000_P4318_TAB_TEXT not null'
,p_validation_sequence=>30
,p_validation=>'F4000_P4318_TAB_TEXT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Tab label must be specified.'
,p_validation_condition=>'Apply_Changes, Create'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(11104289923)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(846498751146131702)
,p_name=>'URL or Flow Change'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4318_URL_OR_FLOW'
,p_condition_element=>'P4318_URL_OR_FLOW'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FLOW'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(846498865378131703)
,p_event_id=>wwv_flow_imp.id(846498751146131702)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4318_URL_TARGET'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(846498978490131704)
,p_event_id=>wwv_flow_imp.id(846498751146131702)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4318_URL_TARGET'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(846499014488131705)
,p_event_id=>wwv_flow_imp.id(846498751146131702)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4318_PAGE_ID,P4318_REQUEST,P4318_CLEAR_CACHE,P4318_ARG_NAMES,P4318_ARG_VALUES.P4318_CLEAR_PAGE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(846499156151131706)
,p_event_id=>wwv_flow_imp.id(846498751146131702)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4318_PAGE_ID,P4318_REQUEST,P4318_CLEAR_CACHE,P4318_ARG_NAMES,P4318_ARG_VALUES,P4318_CLEAR_PAGE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(184082828343506519)
,p_process_sequence=>1
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch row from WWV_FLOW_TOPLEVEL_TABS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_TOPLEVEL_TABS'
,p_attribute_03=>'F4000_P4318_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_internal_uid=>184082828343506519
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(11108289924)
,p_process_sequence=>11
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Split URL'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'declare',
'  l_dummy varchar2(255);',
'begin',
'',
'for c1 in (select tab_target',
'             from wwv_flow_toplevel_tabs',
'            where id = :F4000_P4318_ID',
'            and security_group_id = wwv_flow_security.g_security_group_id) loop',
'',
'wwv_flow_builder.split_url(',
'  p_url         => c1.tab_target,',
'  p_flow        => l_dummy,',
'  p_page        => :P4318_PAGE_ID,',
'  p_session     => l_dummy,',
'  p_request     => :P4318_REQUEST,',
'  p_debug       => l_dummy,',
'  p_clear_cache => :P4318_CLEAR_CACHE,',
'  p_arg_names   => :P4318_ARG_NAMES,',
'  p_arg_values  => :P4318_ARG_VALUES,',
'  p_success_msg => l_dummy );',
'',
'  if :P4318_PAGE_ID is null then',
'    if c1.tab_target is not null then',
'      :P4318_URL_TARGET := c1.tab_target;',
'      :P4318_URL_OR_FLOW := ''URL'';',
'    else',
'      :P4318_URL_OR_FLOW := ''0'';',
'      :P4318_URL_TARGET := null;',
'    end if;',
'  else',
'    :P4318_URL_TARGET := null;',
'    :P4318_URL_OR_FLOW := ''FLOW'';',
'    if instr(:P4318_CLEAR_CACHE,''RP'') = 1 then',
'      :P4318_CLEAR_PAGE := ''YES'';',
'      :P4318_CLEAR_CACHE := ltrim(replace(:P4318_CLEAR_CACHE,''RP'',null),'','');',
'    else',
'      :P4318_CLEAR_PAGE := null;',
'    end if;',
'  end if;',
'end loop;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error fetching row.'
,p_internal_uid=>11108289924
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(11109289924)
,p_process_sequence=>1
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process Row of WWV_FLOW_TOPLEVEL_TABS'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'for c1 in (',
'select 1 from dual',
'where :F4000_P4318_ID is null',
'or exists (select 1 from wwv_flow_toplevel_tabs',
'                   where security_group_id = :flow_security_group_id and',
'      flow_id = :FB_FLOW_ID and',
'      id = :F4000_P4318_ID)) loop',
'wwv_flow_dml.process(',
'p_action => wwv_flow.g_request,',
'p_table_owner => ''#OWNER#'',',
'p_table_name  => ''WWV_FLOW_TOPLEVEL_TABS'',',
'p_rowid       => v(''F4000_P4318_ID''),',
'p_alt_rowid   => ''ID'');',
'exit;',
'end loop;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error processing row.'
,p_process_success_message=>'Parent tab &F4000_P4318_TAB_NAME. action processed.'
,p_internal_uid=>11109289924
);
end;
/
prompt --application/pages/page_04320
begin
wwv_flow_imp_page.create_page(
 p_id=>4320
,p_name=>'Create Region Template - Copy From'
,p_alias=>'CREATE-REGION-TEMPLATE-COPY-FROM'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Region Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(267682922)
,p_plug_name=>'Create Region Template'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>150
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_source=>' '
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_no_data_found=>'No Page Template Found.'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_header=>'<p>Select the application that contains the templates you wish to copy.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47959921151873200)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>160
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(177290315823957583)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>60
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(320074633987)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(274749605)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_imp.id(47959921151873200)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(177879730880992221)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(47959921151873200)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(177245107894925820)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47959921151873200)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(151482332258001583)
,p_branch_action=>'f?p=&FLOW_ID.:498:&SESSION.::&DEBUG.:498::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(177879730880992221)
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(177245501542925829)
,p_branch_action=>'901'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(177245107894925820)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(270704481)
,p_name=>'F4000_P4320_COPY_FROM_FLOW_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(267682922)
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Copy From Application'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select an Application -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the application you want to copy region templates from.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(177909802031012438)
,p_validation_name=>'F4000_P4320_COPY_FROM_FLOW_ID Not Null'
,p_validation_sequence=>1
,p_validation=>'F4000_P4320_COPY_FROM_FLOW_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Copy From Application must be specified.'
,p_validation_comment=>'generated 18-FEB-2002 17:00'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(589947406131621419)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(274749605)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(589947581029621420)
,p_event_id=>wwv_flow_imp.id(589947406131621419)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_04321
begin
wwv_flow_imp_page.create_page(
 p_id=>4321
,p_name=>'Create Report Template - Copy From'
,p_alias=>'CREATE-REPORT-TEMPLATE-COPY-FROM'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Report Template'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(381176857)
,p_plug_name=>'Create Report Template'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>92
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_header=>'<p>Select the application that contains the templates you wish to copy.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47965624839940518)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>102
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(178585413354262292)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>12
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(320074633987)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(394437439)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_imp.id(47965624839940518)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(178567722323240273)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47965624839940518)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(178565114358237978)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47965624839940518)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(178568125379240276)
,p_branch_action=>'343'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(178567722323240273)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(589890586342923050)
,p_branch_action=>'f?p=&APP_ID.:951:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(178565114358237978)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(384253953)
,p_name=>'F4000_P4321_COPY_FROM_FLOW_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(381176857)
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Copy From Application'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select an Application -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the application from which the new report will be copied.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(178573604093251417)
,p_validation_name=>'F4000_P4321_COPY_FROM_FLOW_ID Not Null'
,p_validation_sequence=>1
,p_validation=>'F4000_P4321_COPY_FROM_FLOW_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Copy From Application must be specified.'
,p_associated_item=>wwv_flow_imp.id(384253953)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 19-FEB-2002 13:06'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(589890306211923048)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(394437439)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(589890435109923049)
,p_event_id=>wwv_flow_imp.id(589890306211923048)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_04400
begin
wwv_flow_imp_page.create_page(
 p_id=>4400
,p_name=>'Plug-ins'
,p_alias=>'PLUG-INS'
,p_step_title=>'Plug-ins'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(27816729931938405)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_plugins.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(27795916812844315)
,p_name=>'Recently Edited'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>60
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_new_grid_row=>false
,p_display_column=>1
,p_display_point=>'REGION_POSITION_03'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name name,',
'       id',
'  from wwv_flow_plugins',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and last_updated_on   is not null',
'   and theme_id          is null',
' order by last_updated_on desc',
''))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(11667910335347890)
,p_query_num_rows=>10
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No plug-ins found'
,p_query_row_count_max=>10
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_prn_format=>'PDF'
,p_prn_output_show_link=>'Y'
,p_prn_output_link_text=>'Print'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Application &FB_FLOW_ID.: &FB_FLOW_NAME.'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#ffffff'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(27796127997844319)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_use_as_row_header=>'Y'
,p_column_link=>'f?p=&APP_ID.:4410:&SESSION.::&DEBUG.:RP,4410:P4410_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(27796228142844319)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_column_heading=>'&nbsp;'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_print_col_width=>'50'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(27796304762844319)
,p_plug_name=>'Plug-ins'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders:a-IRR-region--responsiveIconView'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with messages as (',
'    select ( select wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_UP_TO_DATE'') from sys.dual ) up_to_date,',
'           ( select wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_NEEDS_REFRESH'') from sys.dual ) needs_refresh,',
'           ( select wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_UNKNOWN'') from sys.dual ) unknown_status,',
'           ( select wwv_flow_lang_dev.builder_message(''SUBSCRIBED_FROM.NONEXISTING_MASTER'') from sys.dual ) no_master',
'      from sys.dual )',
'select p.id, ',
'       p.name,',
'       p.display_name,',
'       p.plugin_type,',
'       ( select count(*)',
'           from wwv_flow_step_items',
'          where flow_id       = p.flow_id',
'            and display_as    = ''PLUGIN_''||p.name',
'            and p.plugin_type = ''ITEM TYPE''',
'       ) +',
'       ( select count(*)',
'           from wwv_flow_region_columns',
'          where flow_id       = p.flow_id',
'            and item_type     = ''PLUGIN_''||p.name',
'            and p.plugin_type = ''ITEM TYPE''',
'       ) +',
'       ( select count(*)',
'           from wwv_flow_page_plugs',
'          where flow_id          = p.flow_id',
'            and plug_source_type = ''PLUGIN_''||p.name',
'            and p.plugin_type    = ''REGION TYPE''',
'       ) +',
'       ( select count(*)',
'           from wwv_flow_page_plugs',
'          where flow_id          = p.flow_id',
'            and plug_source_type = ''TMPL_''||p.name',
'            and p.plugin_type    = ''TEMPLATE COMPONENT''',
'       ) +',
'       ( select count(*)',
'           from wwv_flow_region_report_column',
'          where flow_id       = p.flow_id',
'            and display_as    = ''PLUGIN_''||p.name',
'            and p.plugin_type = ''REPORT COLUMN TYPE''',
'       ) +',
'       ( select count(*)',
'           from wwv_flow_processing',
'          where flow_id       = p.flow_id',
'            and process_type  = ''PLUGIN_''||p.name',
'            and p.plugin_type = ''PROCESS TYPE''',
'       ) +',
'       ( select count(*)',
'           from wwv_flow_step_processing',
'          where flow_id       = p.flow_id',
'            and process_type  = ''PLUGIN_''||p.name',
'            and p.plugin_type = ''PROCESS TYPE''',
'       ) +',
'       ( select count(*)',
'           from wwv_flow_page_da_events  e,',
'                wwv_flow_page_da_actions a',
'          where e.flow_id     = p.flow_id',
'            and a.event_id    = e.id',
'            and a.action      = ''PLUGIN_''||p.name',
'            and p.plugin_type = ''DYNAMIC ACTION''',
'       ) +',
'       ( select count(*)',
'           from wwv_flow_security_schemes',
'          where flow_id       = p.flow_id',
'            and scheme_type   = ''PLUGIN_''||p.name',
'            and p.plugin_type = ''AUTHORIZATION TYPE''',
'       ) +',
'       ( select count(*)',
'           from wwv_flow_web_src_modules',
'          where flow_id         = p.flow_id',
'            and web_source_type = ''PLUGIN_''||p.name',
'            and p.plugin_type   = ''WEB SOURCE TYPE''',
'       ) +       ',
'       ( select count(*)',
'           from wwv_flow_authentications',
'          where flow_id       = p.flow_id',
'            and scheme_type   = ''PLUGIN_''||p.name',
'            and p.plugin_type = ''AUTHENTICATION TYPE''',
'       ) +',
'       ( select count(*)',
'           from wwv_flow_worksheet_columns',
'          where flow_id         = p.flow_id',
'            and display_text_as = ''TMPL_''||p.name',
'            and p.plugin_type   = ''TEMPLATE COMPONENT''',
'       ) as ref,',
'       --',
'       case when p.reference_id is not null then',
'           coalesce ( to_char( master.flow_id ),',
'                       messages.no_master )',
'       end as subscribed_from,',
'       ( select case when count(*) > 0 then count(*) end',
'           from wwv_flow_plugins sub',
'          where sub.reference_id      = p.id',
'            and sub.security_group_id = :WORKSPACE_ID ) as subscribers,',
'       case when p.reference_id is not null then',
'           case',
'               when master.version_scn = p.version_scn then',
'                   messages.up_to_date',
'               when master.version_scn != p.version_scn then',
'                   messages.needs_refresh',
'               else',
'                   messages.unknown_status',
'           end',
'       end subscription_status,',
'       --',
'       p.version_identifier,',
'       p.about_url,',
'       p.plugin_comment,',
'       p.help_text,',
'       --',
'       coalesce( p.last_updated_on, p.created_on ) last_updated,',
'       coalesce( p.last_updated_by, p.created_by ) last_updated_by,',
'       --',
'       ''icon-sc-plugin'' as icon_class,',
'       p.display_name                             as icon_title,',
'       ''f?p=4000:4410:''||:app_session||''::NO:4410:P4410_ID:''||p.id as edit_link',
'  from wwv_flow_plugins p,',
'       wwv_flow_plugins master,',
'       messages',
' where p.flow_id           = :FB_FLOW_ID',
'   and p.security_group_id = :WORKSPACE_ID',
'   and p.reference_id           = master.id (+)',
'   and p.security_group_id      = master.security_group_id (+)',
'   and p.theme_id is null'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_prn_output_show_link=>'Y'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#ffffff'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'LEFT'
,p_prn_page_footer_alignment=>'LEFT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(27796519609844319)
,p_name=>'Lists'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No plug-ins found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#EDIT_LINK#" class="a-IRR-icon"><span class="a-Icon #ICON_CLASS#"></span><span class="a-IRR-iconName">#ICON_TITLE#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(27796610594844321)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(27816028761928582)
,p_db_column_name=>'DISPLAY_NAME'
,p_display_order=>2
,p_column_identifier=>'J'
,p_column_label=>'Name'
,p_column_link=>'f?p=&APP_ID.:4410:&SESSION.::&DEBUG.:RP,4410:P4410_ID:#ID#'
,p_column_linktext=>'#DISPLAY_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(27796726333844322)
,p_db_column_name=>'NAME'
,p_display_order=>3
,p_column_identifier=>'B'
,p_column_label=>'Internal Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(32848825202511722)
,p_db_column_name=>'PLUGIN_TYPE'
,p_display_order=>4
,p_column_identifier=>'N'
,p_column_label=>'Type'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(32850007287563326)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(27816115563928583)
,p_db_column_name=>'VERSION_IDENTIFIER'
,p_display_order=>5
,p_column_identifier=>'K'
,p_column_label=>'Version'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(27816222669928583)
,p_db_column_name=>'ABOUT_URL'
,p_display_order=>6
,p_column_identifier=>'L'
,p_column_label=>'About URL'
,p_column_link=>'#ABOUT_URL#'
,p_column_linktext=>'#ABOUT_URL#'
,p_column_link_attr=>'target="_blank"'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1340561585027198325)
,p_db_column_name=>'SUBSCRIBED_FROM'
,p_display_order=>16
,p_column_identifier=>'R'
,p_column_label=>'Subscribed From'
,p_column_type=>'STRING'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1340561688389198326)
,p_db_column_name=>'SUBSCRIBERS'
,p_display_order=>26
,p_column_identifier=>'S'
,p_column_label=>'Subscribers'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(27796928916844322)
,p_db_column_name=>'REF'
,p_display_order=>36
,p_column_identifier=>'D'
,p_column_label=>'References'
,p_column_link=>'f?p=&APP_ID.:4420:&SESSION.::&DEBUG.:RP,4420,CIR:IR_DISPLAY_NAME:#DISPLAY_NAME#'
,p_column_linktext=>'#REF#'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(27797023408844322)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>56
,p_column_identifier=>'E'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(28181600244446878)
,p_db_column_name=>'PLUGIN_COMMENT'
,p_display_order=>66
,p_column_identifier=>'M'
,p_column_label=>'Comment'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(27797412280844323)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>76
,p_column_identifier=>'I'
,p_column_label=>'Edit Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(135880018019765024)
,p_db_column_name=>'HELP_TEXT'
,p_display_order=>86
,p_column_identifier=>'O'
,p_column_label=>'Help Text'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(656759561042314130)
,p_db_column_name=>'ICON_CLASS'
,p_display_order=>96
,p_column_identifier=>'P'
,p_column_label=>'ICON_CLASS'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(656759603814314130)
,p_db_column_name=>'ICON_TITLE'
,p_display_order=>106
,p_column_identifier=>'Q'
,p_column_label=>'ICON_TITLE'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(11093430061588023)
,p_db_column_name=>'SUBSCRIPTION_STATUS'
,p_display_order=>116
,p_column_identifier=>'T'
,p_column_label=>'Subscription Status'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(11093522680588024)
,p_db_column_name=>'LAST_UPDATED'
,p_display_order=>126
,p_column_identifier=>'U'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(27798220762844327)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_type=>'REPORT'
,p_report_alias=>'1306521486536647'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_view_mode=>'REPORT'
,p_report_columns=>'DISPLAY_NAME:PLUGIN_TYPE:VERSION_IDENTIFIER:ABOUT_URL:SUBSCRIBED_FROM:REF:SUBSCRIPTION_STATUS:SUBSCRIBERS:LAST_UPDATED:LAST_UPDATED_BY:'
,p_sort_column_1=>'DISPLAY_NAME'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'0'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(27798318837844327)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--sideRegion:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>A plug-in is an extension to the built-in types of &PRODUCT_NAME.. Use plug-ins for declarative use of new item, region, dynamic action process, authentication scheme and authorization scheme types in your application.</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(27883916853665983)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(27943608569240649)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(188995524741097691)
,p_plug_name=>'navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(188993730020080349)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Plug-ins'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(188992318414039122)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(27796304762844319)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4400:&SESSION.::&DEBUG.:4400,RIR::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(429270928966650613)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(27796304762844319)
,p_button_name=>'VIEW_REPOSITORY'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'View Plug-in Repository'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'javascript:window.open(''http://apex.oracle.com/plugins211'', ''_blank'');void(0);'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(27885315646703424)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(27796304762844319)
,p_button_name=>'INSTALL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'Import'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:460:&SESSION.::&DEBUG.:RP,460:P460_FILE_TYPE,P460_CANCEL_TARGET:PLUGIN,4400'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(28078910841897614)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(27796304762844319)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4402:&SESSION.::&DEBUG.:RP,4402,4404,4406,4410::'
,p_icon_css_classes=>'icon-right-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(13863958383489100)
,p_name=>'Refresh Subscriptions'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(27883916853665983)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(13864384782489097)
,p_event_id=>wwv_flow_imp.id(13863958383489100)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(27796304762844319)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(13864898289489096)
,p_event_id=>wwv_flow_imp.id(13863958383489100)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ( this.data.successMessage ) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
);
end;
/
prompt --application/pages/page_04402
begin
wwv_flow_imp_page.create_page(
 p_id=>4402
,p_name=>'Create Plug-in - Method'
,p_alias=>'CREATE-PLUG-IN-METHOD'
,p_step_title=>'Create Plug-in - Method'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213425326892450628)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'sec_authentication.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1434103354337321418)
,p_plug_name=>'Create Plug-in'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_header=>'<p>When you create a new plug-in, you have two options. You can create a new plug-in from scratch or you reuse implementations that already exist in your application or in other applications within your workspace.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1434104034376321434)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(1434105688733324411)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1434104283162321434)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1434104895732321440)
,p_plug_name=>'Create Plug-in'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1434104409431321435)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1434104283162321434)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:4400:&SESSION.::&DEBUG.:::'
,p_button_condition=>'P4402_FOR_THEME'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3403794516955629)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1434104283162321434)
,p_button_name=>'CANCEL_THEME'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.:::'
,p_button_condition=>'P4402_FOR_THEME'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1434104635838321439)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1434104283162321434)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1434105352327321468)
,p_branch_name=>'Go To Page 4404'
,p_branch_action=>'f?p=&APP_ID.:4404:&SESSION.::&DEBUG.::P4404_FOR_THEME:&P4402_FOR_THEME.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(1434104635838321439)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P4402_ACTION'
,p_branch_condition_text=>'COPY'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3404982878955641)
,p_branch_name=>'Go To Page 4403'
,p_branch_action=>'f?p=&APP_ID.:4403:&SESSION.::&DEBUG.:4403:P4403_FOR_THEME:&P4402_FOR_THEME.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'ITEM_IS_NOT_NULL'
,p_branch_condition=>'P4402_FOR_THEME'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1434105524301321474)
,p_branch_name=>'Go To Page 4410'
,p_branch_action=>'f?p=&APP_ID.:4410:&SESSION.::&DEBUG.:RP,4410::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(1434104635838321439)
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P4402_ACTION'
,p_branch_condition_text=>'CREATE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3403458100955626)
,p_name=>'P4402_FOR_THEME'
,p_item_sequence=>20
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1434103585895321420)
,p_name=>'P4402_ACTION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1434103354337321418)
,p_item_default=>'CREATE'
,p_prompt=>'Create Plug-in:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P4402.ACTION'
,p_lov=>'.'||wwv_flow_imp.id(1434173283114513679)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_escape_on_http_output=>'N'
,p_help_text=>'Select the method by which you would like to create a plug-in.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
end;
/
prompt --application/pages/page_04403
begin
wwv_flow_imp_page.create_page(
 p_id=>4403
,p_name=>'Create Plug-in - Name'
,p_alias=>'CREATE-PLUG-IN-NAME'
,p_step_title=>'Create Plug-in - Name'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213425326892450628)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'sec_authentication.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(50444698491679431)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(125073289619079006)
,p_plug_name=>'Create Template Component'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<p>Identify the name for your Plug-in.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1436579857627962954)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(1434105688733324411)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1436580718983962960)
,p_plug_name=>'Create Plug-in'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2489553022835689)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(50444698491679431)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2489979732835691)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(50444698491679431)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2490300402835692)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(50444698491679431)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2480317564641540)
,p_branch_name=>'Go To Page 4410'
,p_branch_action=>'f?p=&APP_ID.:4410:&SESSION.::&DEBUG.:RP,:P4410_ID:&P4403_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3405093424955642)
,p_branch_name=>'Go To Page 4402'
,p_branch_action=>'f?p=&APP_ID.:4402:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2490300402835692)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2479487101641538)
,p_name=>'P4403_FOR_THEME'
,p_item_sequence=>20
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2481084927651107)
,p_name=>'P4403_DISPLAY_NAME'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(125073289619079006)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>64
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The name of your plug-in.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2481936452651109)
,p_name=>'P4403_THEME'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(125073289619079006)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Theme'
,p_source=>'wwv_flow_user_interface_dev.get_current_theme_id(:FB_FLOW_ID);'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cHeight=>1
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the current theme of the application. The plug-in will be created as part of this theme.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4823651480098945)
,p_name=>'P4403_PLUGIN_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(125073289619079006)
,p_item_default=>'TEMPLATE COMPONENT'
,p_prompt=>'Plug-in Type'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PLUGIN.TYPE'
,p_lov=>'.'||wwv_flow_imp.id(32850007287563326)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Defines the type of component that can use this plug-in.'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4823968495098948)
,p_name=>'P4403_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(125073289619079006)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7473457966849716)
,p_name=>'P4403_NAME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(125073289619079006)
,p_prompt=>'Internal Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>40
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter an internal name for the plug-in. The internal name is used internally by &PRODUCT_NAME. for identifying the plug-in, and is not displayed. The internal name must be unique to your current application.</p>',
'',
'<p>It is recommended that your organization domain name be used as a prefix to plug-in names, to create a globally unique name. For example: a domain name of "mycompany.com" prefixed to an Item Type plug-in named ''Slider'', would result in an internal'
||' name like the following: <code>COM.MYCOMPANY.SLIDER</code></p>',
'',
'<p>The internal name of a Template Component type plug-in as part of a theme is automatically prefixed with "THEME$": <code>THEME$COM.MYCOMPANY.BADGE</code>.',
'Use this internal name to apply a Template Component from the current theme manually in &PRODUCT_NAME. in a component where server-side template directives are supported:',
'</p>',
'<pre><code>',
'{with/}',
'MY_ARGUMENT:=foo',
'{apply THEME$COM.MYCOMPANY.BADGE/}    ',
'</code></pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(4823807854098947)
,p_computation_sequence=>10
,p_computation_item=>'P4403_ID'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_id.next_val'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5830766728948627)
,p_validation_name=>'Name is unique'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugins',
' where flow_id              = :FB_FLOW_ID',
'   and security_group_id    = :FLOW_SECURITY_GROUP_ID',
'   and name                 = ''THEME_'' || :P4403_THEME || ''$'' || upper( :P4403_NAME )',
'   and rownum               = 1'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#LABEL# must be unique.'
,p_when_button_pressed=>wwv_flow_imp.id(2489979732835691)
,p_associated_item=>wwv_flow_imp.id(7473457966849716)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(108301977537800414)
,p_name=>'On change Display Name'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4403_DISPLAY_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_cond=>'P4403_PLUGIN_TYPE'
,p_display_when_cond2=>'TEMPLATE COMPONENT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(108302042635800415)
,p_event_id=>wwv_flow_imp.id(108301977537800414)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_name=>'Set Internal Name'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4403_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>wwv_flow_string.join(wwv_flow_t_varchar2(
'this.triggeringElement.value',
'    .toUpperCase()',
'    .replace( /\W/g, "_" )',
'    .replace( /^\_*/, "" )',
'    .replace( /\_*$/, "" );'))
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3404823385955640)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Template Component'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_imp_shared.create_plugin(',
'    p_id                        => :P4403_ID,',
'    p_flow_id                   => :FB_FLOW_ID,',
'    p_theme_id                  => :P4403_THEME,',
'    p_plugin_type               => wwv_flow_plugin.c_plugin_type_tmpl_component,',
'    p_name                      => upper( :P4403_NAME ),',
'    p_display_name              => :P4403_DISPLAY_NAME );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2489979732835691)
,p_process_success_message=>'Plug-in created.'
,p_internal_uid=>3404823385955640
);
end;
/
prompt --application/pages/page_04404
begin
wwv_flow_imp_page.create_page(
 p_id=>4404
,p_name=>'Create Plug-in - Application'
,p_alias=>'CREATE-PLUG-IN-APPLICATION'
,p_step_title=>'Create Plug-in - Application'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213425326892450628)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_authentication.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1434158319547350901)
,p_plug_name=>'Create Plug-in'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_header=>'<p>Use this page to copy a plug-in from another application.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1434159038252350902)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(1434105688733324411)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1434159247913350902)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1434160020964350904)
,p_plug_name=>'Create Plug-in'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1434159464309350902)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1434159247913350902)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:4400:&SESSION.::&DEBUG.:::'
,p_button_condition=>'P4404_FOR_THEME'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3403691000955628)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1434159247913350902)
,p_button_name=>'CANCEL_THEME'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.:::'
,p_button_condition=>'P4404_FOR_THEME'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1434159608808350902)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(1434159247913350902)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1434159851620350902)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1434159247913350902)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1434160521315350908)
,p_branch_name=>'Go To Page 4405'
,p_branch_action=>'f?p=&APP_ID.:4405:&SESSION.::&DEBUG.:RP,::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(1434159608808350902)
,p_branch_sequence=>10
,p_branch_condition_type=>'ITEM_IS_NOT_NULL'
,p_branch_condition=>'P4404_FOR_THEME'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3404665207955638)
,p_branch_name=>'Go To Page 4406'
,p_branch_action=>'f?p=&APP_ID.:4406:&SESSION.::&DEBUG.:RP,:P4406_COPY_FROM_THEME_ID:&P4404_COPY_FROM_THEME_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(1434159608808350902)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1434160701938350908)
,p_branch_name=>'Go To Page 4402'
,p_branch_action=>'f?p=&APP_ID.:4402:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(1434159851620350902)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3403504169955627)
,p_name=>'P4404_FOR_THEME'
,p_item_sequence=>20
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(84086971137907508)
,p_name=>'P4404_COPY_FROM_THEME_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1434158319547350901)
,p_prompt=>'Theme'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(theme_name) d, theme_id',
'from   wwv_flow_themes',
'where  flow_id = :P4404_COPY_FROM',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Theme -'
,p_lov_cascade_parent_items=>'P4404_COPY_FROM'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Identify the theme from which you wish to copy Template Component type plug-ins. Selecting a theme will only list those Template Components.',
'Leave the theme empty if you wish to copy plug-ins which are not part of a theme.'))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1434158563533350901)
,p_name=>'P4404_COPY_FROM'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1434158319547350901)
,p_prompt=>'Copy From Application'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||f.name as d,',
'       f.id as rr',
'  from wwv_flows f',
' where f.security_group_id = :WORKSPACE_ID',
'   and exists ( select 1',
'                  from wwv_flow_plugins a',
'                 where a.flow_id           = f.id',
'                   and a.security_group_id = :WORKSPACE_ID )',
'   and not exists ( select 1',
'                      from wwv_flow_language_map t',
'                     where t.translation_flow_id = f.id ',
'                       and t.security_group_id = :WORKSPACE_ID )',
' order by f.id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select an Application -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Select an application to copy the plug-ins from.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
end;
/
prompt --application/pages/page_04405
begin
wwv_flow_imp_page.create_page(
 p_id=>4405
,p_name=>'Create Plug-in - Identify Theme'
,p_alias=>'CREATE-PLUG-IN-IDENTIFY-THEME'
,p_step_title=>'Create Plug-in - Identify Theme'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213425326892450628)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_authentication.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(153939139817963391)
,p_plug_name=>'Create Template Component'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<p>A Theme is a named collection of Templates.  An Application can have one or more Themes.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1436389374099777713)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(1434105688733324411)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1436389583760777713)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1436390356811777715)
,p_plug_name=>'Create Plug-in'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2233612272426866)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1436389583760777713)
,p_button_name=>'CANCEL_THEME'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2232838388426864)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(1436389583760777713)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2233258738426865)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1436389583760777713)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2234886695426887)
,p_branch_name=>'Go To Page 4406'
,p_branch_action=>'f?p=&APP_ID.:4406:&SESSION.::&DEBUG.:RP,:P4406_COPY_FROM_THEME_ID,P4406_COPY_TO_THEME_ID,P4406_PLUGIN_TYPE:&P4405_COPY_FROM_THEME.,&P4405_COPY_TO_THEME.,TEMPLATE COMPONENT&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2232838388426864)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2235200721426888)
,p_branch_name=>'Go To Page 4402'
,p_branch_action=>'f?p=&APP_ID.:4402:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2233258738426865)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2237178239467587)
,p_name=>'P4405_F'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(153939139817963391)
,p_prompt=>'Copy From:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2237528462467587)
,p_name=>'P4405_FROM_APP'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_imp.id(153939139817963391)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application:'
,p_source=>'P4404_COPY_FROM'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identifies the application from which the theme will be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2238411286467588)
,p_name=>'P4405_COPY_FROM_THEME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(153939139817963391)
,p_prompt=>'Theme'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. ''||wwv_flow_escape.html(theme_name) d, theme_id',
'from   wwv_flow_themes',
'where  flow_id = :P4404_COPY_FROM',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Theme -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the theme from which you wish to copy templates.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2239395349467589)
,p_name=>'P4405_X'
,p_item_sequence=>11
,p_item_plug_id=>wwv_flow_imp.id(153939139817963391)
,p_post_element_text=>'<br />'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2239760744467589)
,p_name=>'P4405_TO'
,p_item_sequence=>12
,p_item_plug_id=>wwv_flow_imp.id(153939139817963391)
,p_prompt=>'Copy To:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2240157751467589)
,p_name=>'P4405_COPY_TO'
,p_item_sequence=>15
,p_item_plug_id=>wwv_flow_imp.id(153939139817963391)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application:'
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identifies the application to which the template will be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2241041238467590)
,p_name=>'P4405_COPY_TO_THEME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(153939139817963391)
,p_prompt=>'Theme'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Theme -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the theme to which the template will be copied.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
end;
/
prompt --application/pages/page_04406
begin
wwv_flow_imp_page.create_page(
 p_id=>4406
,p_name=>'Create Plug-in - Copy'
,p_alias=>'CREATE-PLUG-IN-COPY'
,p_step_title=>'Create Plug-in - Copy'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213425326892450628)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'sec_authentication.htm'
,p_page_component_map=>'01'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(1340559765582198307)
,p_name=>'Create Plug-in'
,p_template=>wwv_flow_imp.id(42025417508627628)
,p_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       plugin_type,',
'       display_name,',
'       case when reference_id is not null then ''Y'' end as is_subscribed,',
'       case',
'         when reference_id is null and :P4404_COPY_FROM = :FB_FLOW_ID then wwv_flow_lang.system_message( ''F4000.P158.COPY_OF'', display_name )',
'         else display_name',
'       end as to_display_name,',
'       case',
'         when :P4404_COPY_FROM = :FB_FLOW_ID then ''N''',
'         when reference_id is not null       then ''Y''',
'         else ''SUBSCRIBE''',
'       end as action',
'  from wwv_flow_plugins a',
' where flow_id           = :P4404_COPY_FROM',
'   and security_group_id = :WORKSPACE_ID',
'   and (',
'       -- Don''t show subscribed plug-ins, because they can''t be copied',
'          (   :P4404_COPY_FROM = :FB_FLOW_ID',
'          and (    reference_id is null',
'                or theme_id is not null )',
'          )',
'       -- Don''t show plug-ins which have already been copied from another application',
'       or (   :P4404_COPY_FROM <> :FB_FLOW_ID',
'              -- Same internal name',
'              and not exists ( select 1',
'                                 from wwv_flow_plugins b',
'                                where b.flow_id           = :FB_FLOW_ID',
'                                  and b.security_group_id = :WORKSPACE_ID',
'                                  and b.plugin_type       = a.plugin_type',
'                                  and b.name              = a.name',
'                                  and b.theme_id          is null',
'                             )',
'              -- Same internal name when removing the theme prefix',
'              and not exists ( select 1',
'                                 from wwv_flow_plugins b',
'                                where b.flow_id                 = :FB_FLOW_ID',
'                                  and b.security_group_id       = :WORKSPACE_ID',
'                                  and b.name                    = regexp_replace( a.name, ''^THEME_[[:digit:]]+\$'' )',
'                                  and a.theme_id                is not null',
'                                  and :P4406_COPY_TO_THEME_ID   is null',
'                             )',
'              -- Same internal name and theme',
'              and not exists ( select 1',
'                                 from wwv_flow_plugins b',
'                                where b.flow_id                 = :FB_FLOW_ID',
'                                  and b.security_group_id       = :WORKSPACE_ID',
'                                  and b.name                    = a.name',
'                                  and a.theme_id                = :P4406_COPY_TO_THEME_ID',
'                             )',
'          )',
'       )',
'   and ( ',
'        -- Only theme related plug-ins',
'            (      :P4406_COPY_FROM_THEME_ID is not null ',
'               and theme_id = :P4406_COPY_FROM_THEME_ID )',
'          or (     :P4406_COPY_FROM_THEME_ID is null ',
'               and theme_id is null )',
'        )',
'   and ( plugin_type = nvl( :P4406_PLUGIN_TYPE, plugin_type ) )',
' order by plugin_type, display_name',
''))
,p_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Identify the Plug-in to be copied and select the copy option. Copy options include:</p>',
'<ul>',
'    <li><strong>Yes.</strong> Copy the Plug-in.</li>',
'    <li><strong>No.</strong> Do not copy this Plug-in.</li>',
'    <li><strong>Copy and Subscribe.</Strong> Subscribing to a Plug-in puts a copy of it in your application and sets the plugin master reference.</li>',
'</ul>',
''))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>999
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_no_data_found=>'No Plug-in available or all are already copied.'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1340559827601198308)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1340559918145198309)
,p_query_column_id=>2
,p_column_alias=>'PLUGIN_TYPE'
,p_column_display_sequence=>2
,p_column_heading=>'Type'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(32850007287563326)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1340560021525198310)
,p_query_column_id=>3
,p_column_alias=>'DISPLAY_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Name'
,p_use_as_row_header=>'Y'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1340560722930198317)
,p_query_column_id=>4
,p_column_alias=>'IS_SUBSCRIBED'
,p_column_display_sequence=>4
,p_column_heading=>'Subscribed'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(84259319526460470)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1340560194906198311)
,p_query_column_id=>5
,p_column_alias=>'TO_DISPLAY_NAME'
,p_column_display_sequence=>5
,p_column_heading=>'To Name'
,p_use_as_row_header=>'N'
,p_display_as=>'TEXT'
,p_column_width=>40
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1340560284075198312)
,p_query_column_id=>6
,p_column_alias=>'ACTION'
,p_column_display_sequence=>6
,p_column_heading=>'Copy?'
,p_use_as_row_header=>'N'
,p_display_as=>'SELECT_LIST_FROM_LOV'
,p_named_lov=>wwv_flow_imp.id(1434176433131599379)
,p_lov_show_nulls=>'NO'
,p_derived_column=>'N'
,p_lov_display_extra=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1340561447354198324)
,p_plug_name=>'Buttons'
,p_parent_plug_id=>wwv_flow_imp.id(1340559765582198307)
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1434163698916375404)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(1434105688733324411)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1434163882193375405)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1434164663980375407)
,p_plug_name=>'Create Plug-in'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1340561087128198320)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1340561447354198324)
,p_button_name=>'DESELECT_ALL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--padLeft'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Deselect All'
,p_grid_new_row=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1434164055823375405)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(1434163882193375405)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:4400:&SESSION.::&DEBUG.:::'
,p_button_condition=>'P4406_COPY_TO_THEME_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3403934307955631)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(1434163882193375405)
,p_button_name=>'CANCEL_THEME'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.:::'
,p_button_condition=>'P4406_COPY_TO_THEME_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1434164291946375406)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1434163882193375405)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy Plug-ins'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1434164460554375406)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(1434163882193375405)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3404065018955632)
,p_branch_name=>'Go To Page 4003'
,p_branch_action=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'ITEM_IS_NOT_NULL'
,p_branch_condition=>'P4406_COPY_TO_THEME_ID'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1434165712968375419)
,p_branch_name=>'Go To Page 4400'
,p_branch_action=>'f?p=&APP_ID.:4400:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1434166193582375420)
,p_branch_name=>'Go To Page 4404'
,p_branch_action=>'f?p=&APP_ID.:4404:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(1434164460554375406)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3403829169955630)
,p_name=>'P4406_COPY_TO_THEME_ID'
,p_item_sequence=>30
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3405164508955643)
,p_name=>'P4406_COPY_FROM_THEME_ID'
,p_item_sequence=>40
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7473915618849721)
,p_name=>'P4406_PLUGIN_TYPE'
,p_item_sequence=>50
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1340561103171198321)
,p_name=>'New'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1340561087128198320)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1340561200400198322)
,p_event_id=>wwv_flow_imp.id(1340561103171198321)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'td[headers=ACTION] select'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1340560585862198315)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(1340559765582198307)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy plug-ins'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if :ACTION in (''Y'', ''SUBSCRIBE'') then',
'        wwv_flow_copy_util.copy_plugin (',
'            p_from_application_id => :P4404_COPY_FROM,',
'            p_from_plugin_id      => :ID,',
'            p_to_application_id   => :FB_FLOW_ID,',
'            p_to_display_name     => :TO_DISPLAY_NAME,',
'            p_subscribe           => ( :ACTION = ''SUBSCRIBE'' ),',
'            p_to_theme_id         => :P4406_COPY_TO_THEME_ID );',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1434164291946375406)
,p_only_for_changed_rows=>'N'
,p_process_success_message=>'Plug-ins copied.'
,p_internal_uid=>1340560585862198315
);
end;
/
prompt --application/pages/page_04410
begin
wwv_flow_imp_page.create_page(
 p_id=>4410
,p_name=>'Create / Edit Plug-in'
,p_alias=>'PLUGIN'
,p_step_title=>'Create / Edit Plug-in'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(27816729931938405)
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_read_only_when=>'P4410_REFERENCE_ID'
,p_help_text=>'advnc_plugins.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(1622849868577319)
,p_name=>'Action Templates'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>130
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_PLUGIN_ACT_TEMPLATES'
,p_query_where=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    plugin_id         = :P4410_ID',
'and security_group_id = :WORKSPACE_ID'))
,p_include_rowid_column=>false
,p_display_when_condition=>'P4410_ID'
,p_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No Action Templates defined.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1622960020577320)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>10
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1623164696577322)
,p_query_column_id=>5
,p_column_alias=>'NAME'
,p_column_display_sequence=>30
,p_column_heading=>'Name'
,p_use_as_row_header=>'Y'
,p_column_link=>'javascript:apex.submit({request:''APPLY_CHANGES_EDIT_4418'',set:{''P4410_ACTION_TEMPLATE_ID'':''#ID#''}});'
,p_column_linktext=>'#NAME#'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1623520482577326)
,p_query_column_id=>6
,p_column_alias=>'TYPE'
,p_column_display_sequence=>70
,p_column_heading=>'Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(2610859887449164)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1651611827240822)
,p_plug_name=>'Events'
,p_region_name=>'EVENTS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>150
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       plugin_id,',
'       display_name,',
'       name,',
'       flow_id',
'  from wwv_flow_plugin_events',
' where plugin_id = to_number(:P4410_ID)',
'   and security_group_id = to_number(:workspace_id)'))
,p_plug_source_type=>'NATIVE_IG'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P4410_ID'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Events'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1651836719240824)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>30
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1651965630240825)
,p_name=>'PLUGIN_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'PLUGIN_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>50
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'P4410_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1652070286240826)
,p_name=>'DISPLAY_NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DISPLAY_NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>60
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_max_length=>100
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>true
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1652124009240827)
,p_name=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Internal Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>70
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_max_length=>45
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1652228695240828)
,p_name=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FLOW_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>40
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'FB_FLOW_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1652604931240832)
,p_name=>'APEX$ROW_ACTION'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>20
,p_use_as_row_header=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1652747883240833)
,p_name=>'APEX$ROW_SELECTOR'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_use_as_row_header=>false
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(1651765060240823)
,p_internal_uid=>1651765060240823
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_add_row_if_empty=>false
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>true
,p_no_data_found_message=>'No Events defined.'
,p_show_toolbar=>false
,p_toolbar_buttons=>null
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>true
,p_define_chart_view=>true
,p_enable_download=>true
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(1665669478337827)
,p_interactive_grid_id=>wwv_flow_imp.id(1651765060240823)
,p_static_id=>'16657'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(1665839317337827)
,p_report_id=>wwv_flow_imp.id(1665669478337827)
,p_view_type=>'GRID'
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1666390546337829)
,p_view_id=>wwv_flow_imp.id(1665839317337827)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(1651836719240824)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1667206967337833)
,p_view_id=>wwv_flow_imp.id(1665839317337827)
,p_display_seq=>2
,p_column_id=>wwv_flow_imp.id(1651965630240825)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1668183631337836)
,p_view_id=>wwv_flow_imp.id(1665839317337827)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(1652070286240826)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1669053713337839)
,p_view_id=>wwv_flow_imp.id(1665839317337827)
,p_display_seq=>4
,p_column_id=>wwv_flow_imp.id(1652124009240827)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1669947131337843)
,p_view_id=>wwv_flow_imp.id(1665839317337827)
,p_display_seq=>5
,p_column_id=>wwv_flow_imp.id(1652228695240828)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1676200306363652)
,p_view_id=>wwv_flow_imp.id(1665839317337827)
,p_display_seq=>0
,p_column_id=>wwv_flow_imp.id(1652604931240832)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2675372452330944)
,p_plug_name=>'Attribute Groups'
,p_region_name=>'CUST_ATTR_GROUPS'
,p_region_css_classes=>'a-Region--noReportBorder'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       flow_id,',
'       plugin_id,',
'       title,',
'       display_sequence,',
'       (select count(*)',
'          from wwv_flow_plugin_attributes a',
'         where a.plugin_id          = ag.plugin_id',
'           and a.security_group_id  = ag.security_group_id',
'           and a.attribute_group_id = ag.id',
'       ) as references',
'  from wwv_flow_plugin_attr_groups ag',
' where ag.plugin_id         = :P4410_ID',
'   and ag.security_group_id = :WORKSPACE_ID'))
,p_plug_source_type=>'NATIVE_IG'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P4410_ID'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Attribute Groups'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1653234416240838)
,p_name=>'APEX$ROW_ACTION'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>20
,p_use_as_row_header=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1653326350240839)
,p_name=>'APEX$ROW_SELECTOR'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_use_as_row_header=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1654228486240848)
,p_name=>'REFERENCES'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'REFERENCES'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'References'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>80
,p_value_alignment=>'RIGHT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1663607101153110)
,p_name=>'DISPLAY_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DISPLAY_SEQUENCE'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>'Sequence'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>70
,p_value_alignment=>'RIGHT'
,p_attribute_03=>'left'
,p_attribute_04=>'decimal'
,p_is_required=>true
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>false
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2675511192330946)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>30
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>true
,p_duplicate_value=>false
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2675603765330947)
,p_name=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FLOW_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>40
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'FB_FLOW_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2675772249330948)
,p_name=>'PLUGIN_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'PLUGIN_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>50
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'P4410_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2675814383330949)
,p_name=>'TITLE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'TITLE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Title'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>60
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_max_length=>255
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>true
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>'Name of an attribute group'
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(2675470760330945)
,p_internal_uid=>2675470760330945
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_add_row_if_empty=>false
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>true
,p_no_data_found_message=>'No Attribute Groups defined.'
,p_show_toolbar=>false
,p_toolbar_buttons=>null
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>false
,p_define_chart_view=>false
,p_enable_download=>false
,p_download_formats=>null
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(1642513948221388)
,p_interactive_grid_id=>wwv_flow_imp.id(2675470760330945)
,p_static_id=>'16426'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(1642753125221388)
,p_report_id=>wwv_flow_imp.id(1642513948221388)
,p_view_type=>'GRID'
,p_stretch_columns=>true
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1643211218221393)
,p_view_id=>wwv_flow_imp.id(1642753125221388)
,p_display_seq=>2
,p_column_id=>wwv_flow_imp.id(2675511192330946)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1644106368221399)
,p_view_id=>wwv_flow_imp.id(1642753125221388)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(2675603765330947)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1645051250221403)
,p_view_id=>wwv_flow_imp.id(1642753125221388)
,p_display_seq=>4
,p_column_id=>wwv_flow_imp.id(2675772249330948)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1645941461221406)
,p_view_id=>wwv_flow_imp.id(1642753125221388)
,p_display_seq=>5
,p_column_id=>wwv_flow_imp.id(2675814383330949)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1653835585036881)
,p_view_id=>wwv_flow_imp.id(1642753125221388)
,p_display_seq=>7
,p_column_id=>wwv_flow_imp.id(1654228486240848)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1684432747410664)
,p_view_id=>wwv_flow_imp.id(1642753125221388)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(1653234416240838)
,p_is_visible=>true
,p_is_frozen=>true
,p_width=>41
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1695671057054471)
,p_view_id=>wwv_flow_imp.id(1642753125221388)
,p_display_seq=>6
,p_column_id=>wwv_flow_imp.id(1663607101153110)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>228.5
,p_sort_order=>1
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3053446993523770)
,p_plug_name=>'Help - Slots'
,p_region_template_options=>'#DEFAULT#:js-dialog-size720x480'
,p_plug_template=>wwv_flow_imp.id(557449278618308550)
,p_plug_display_sequence=>220
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li>If the template component is used in a region, displayed as a partial, then &PRODUCT_NAME. will only render slots inside the partial template. Side effects are that it cannot be refreshed dynamically and cannot be lazy loaded.</li>',
'    <li>If the template component is used in a region, displayed as a report, then &PRODUCT_NAME. will only render slots inside the report container template. The report container template is surrounding the report body template.</li>',
'    <li>It is not possible to render slots in the report rows or interactive report columns, as slot content is not designed to be repeatable on page rendering.</li>',
'    <li>It''s possible to check for the existence of slot content, such that we can render additional markup only if the slot is used. Example:',
'        <pre><code>',
'            &lt;div class="outer-div"&gt;',
'            {if SLOT_A/}',
'            &lt;div class="inner-div"&gt;#SLOT_A#&lt;/div&gt;',
'            {endif/}',
'            &lt;/div&gt;',
'        </code></pre>',
'    </li>',
'</ul>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4004640729629327)
,p_plug_name=>'Templates'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(4004965443629330)
,p_name=>'Action Positions'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>120
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select p.id,',
'       p.name,',
'       p.static_id,',
'       p.display_sequence,',
'       p.is_quick_pick,',
'       p.type,',
'       t.name as template_name',
'  from wwv_flow_plugin_act_positions p,',
'       wwv_flow_plugin_act_templates t',
' where p.plugin_id             = :P4410_ID',
'   and p.security_group_id     = :WORKSPACE_ID',
'   and t.id                (+) = p.template_id',
'   and t.security_group_id (+) = p.security_group_id'))
,p_display_when_condition=>'P4410_ID'
,p_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No Action Positions defined.'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1621134040577302)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>10
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1621562735577306)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>50
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_column_link=>'javascript:apex.submit({request:''APPLY_CHANGES_EDIT_4417'',set:{''P4410_ACTION_POSITION_ID'':''#ID#''}});'
,p_column_linktext=>'#NAME#'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1621638592577307)
,p_query_column_id=>3
,p_column_alias=>'STATIC_ID'
,p_column_display_sequence=>60
,p_column_heading=>'Static ID'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1621759041577308)
,p_query_column_id=>4
,p_column_alias=>'DISPLAY_SEQUENCE'
,p_column_display_sequence=>70
,p_column_heading=>'Display Sequence'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1621827448577309)
,p_query_column_id=>5
,p_column_alias=>'IS_QUICK_PICK'
,p_column_display_sequence=>80
,p_column_heading=>'Quick Pick'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(84259319526460470)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1621947884577310)
,p_query_column_id=>6
,p_column_alias=>'TYPE'
,p_column_display_sequence=>90
,p_column_heading=>'Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(2609610747438738)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2619568415490913)
,p_query_column_id=>7
,p_column_alias=>'TEMPLATE_NAME'
,p_column_display_sequence=>100
,p_column_heading=>'Predefined Template'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5261005290655272)
,p_plug_name=>'Supported for'
,p_region_name=>'WORKS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(27899611028734555)
,p_plug_name=>'Name'
,p_region_name=>'PLUGIN_NAME'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'generated 04-SEP-2000 16:36:50'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(27899831305734555)
,p_plug_name=>'Source'
,p_region_name=>'SOURCE'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(27900213448734557)
,p_plug_name=>'Comments'
,p_region_name=>'COMMENTS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>210
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(27900816654734558)
,p_plug_name=>'Plug-in: &P4410_PLUGIN_DISPLAY_NAME.'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>160
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(27901032534734559)
,p_plug_name=>'Information'
,p_region_name=>'INFORMATION'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>190
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(27935931959010930)
,p_plug_name=>'Callbacks'
,p_region_name=>'CALLBACKS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(27941016095186035)
,p_plug_name=>'Plug-ins'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>140
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>A plug-in is an extension to the built-in types of &PRODUCT_NAME.. Use plug-ins for declarative use of new item, region, process and dynamic action types in your application.</p> ',
''))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(27942831164228303)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>150
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(27884204995681439)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P4410_ID is not null and :P4410_THEME_ID is null'
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(29873113508481210)
,p_name=>'Files'
,p_region_name=>'FILES'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>160
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       security_group_id,',
'       file_name,',
'       mime_type,',
'       htmldb_util.filesize_mask(sys.dbms_lob.getLength(file_content)) as file_size,',
'       sys.dbms_lob.getLength(file_content) as file_content,',
'       wwv_flow_file_editor_dev.get_file_reference (',
'           p_scope      => ''PLUGIN'',',
'           p_app_id     => :fb_flow_id,',
'           p_plugin_id  => :P4410_ID,',
'           p_file_name  => file_name ) as reference,',
'       wwv_flow_page_api.get_url(',
'           p_page        => 118,',
'           p_clear_cache => 118,',
'           p_items       => ''P118_SCOPE,P118_APP_ID,P118_PLUGIN_ID,P118_ID'',',
'           p_values      => ''PLUGIN,'' || flow_id || '','' || plugin_id || '','' || id',
'       ) as edit_link,',
'       nvl(last_updated_on, created_on)                 as updated,',
'       nvl(lower(last_updated_by), lower(created_by))   as updated_by',
'  from ( select f.*, wwv_flow_string_util.get_file_extension(f.file_name) as file_ext from wwv_flow_plugin_files f)',
' where flow_id           = :fb_flow_id',
'   and plugin_id         = :P4410_ID',
'   and security_group_id = :workspace_id'))
,p_display_when_condition=>'P4410_ID'
,p_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No Files found.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>9999
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(29877510794584509)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3567173693979613)
,p_query_column_id=>2
,p_column_alias=>'SECURITY_GROUP_ID'
,p_column_display_sequence=>11
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(29873408985481212)
,p_query_column_id=>3
,p_column_alias=>'FILE_NAME'
,p_column_display_sequence=>21
,p_column_heading=>'Name'
,p_use_as_row_header=>'Y'
,p_column_link=>'#EDIT_LINK#'
,p_column_linktext=>'#FILE_NAME#'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(29873530227481212)
,p_query_column_id=>4
,p_column_alias=>'MIME_TYPE'
,p_column_display_sequence=>31
,p_column_heading=>'Mime Type'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(29895523719796329)
,p_query_column_id=>5
,p_column_alias=>'FILE_SIZE'
,p_column_display_sequence=>51
,p_column_heading=>'File Size'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(29873603248481212)
,p_query_column_id=>6
,p_column_alias=>'FILE_CONTENT'
,p_column_display_sequence=>81
,p_column_heading=>'File'
,p_use_as_row_header=>'N'
,p_column_format=>'DOWNLOAD:WWV_FLOW_PLUGIN_FILES:FILE_CONTENT:ID:SECURITY_GROUP_ID:MIME_TYPE:FILE_NAME:LAST_UPDATED_ON:FILE_CHARSET:attachment:&APP_TEXT$DOWNLOAD.:'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(21699665166753948)
,p_query_column_id=>7
,p_column_alias=>'REFERENCE'
,p_column_display_sequence=>71
,p_column_heading=>'Reference'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(21699727731753949)
,p_query_column_id=>8
,p_column_alias=>'EDIT_LINK'
,p_column_display_sequence=>91
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(21699861698753950)
,p_query_column_id=>9
,p_column_alias=>'UPDATED'
,p_column_display_sequence=>101
,p_column_heading=>'Updated'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3565962651979601)
,p_query_column_id=>10
,p_column_alias=>'UPDATED_BY'
,p_column_display_sequence=>111
,p_column_heading=>'Updated By'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(33327228999114743)
,p_plug_name=>'Anchors'
,p_region_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>170
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_translate_title=>'N'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(33340707031647637)
,p_plug_name=>'Subscription'
,p_region_name=>'SUBSCRIPTION'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P4410_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'WWV_FLOW_PLUGINS',
  'attribute_02', 'DISPLAY_NAME',
  'attribute_03', 'P4410_ID',
  'attribute_04', 'P4410_REFERENCE_ID',
  'attribute_05', 'SUBSCRIBE_PLUGIN',
  'attribute_06', 'VERSION_SCN')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46888818357161021)
,p_plug_name=>'Help Text'
,p_region_name=>'HELP_TEXT'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>200
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(48467930491898431)
,p_name=>'Custom Attributes'
,p_region_name=>'CUST_ATTRIBUTES'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.id,',
'       a.attribute_scope,',
'       a.attribute_sequence,',
'       a.display_sequence,',
'       a.static_id,',
'       a.prompt,',
'       a.is_required,',
'       a.default_value,',
'       a.attribute_type,',
'       case when dg.title is not null then dg.title || '' - '' end ||',
'       d.prompt as depending_on_prompt,',
'       ag.title as attribute_group_title',
'  from wwv_flow_plugin_attributes  a,',
'       wwv_flow_plugin_attributes  d,',
'       wwv_flow_plugin_attr_groups ag,',
'       wwv_flow_plugin_attr_groups dg',
' where a.plugin_id              = :P4410_ID',
'   and a.security_group_id      = :WORKSPACE_ID',
'   and d.id (+)                 = a.depending_on_attribute_id',
'   and ag.plugin_id         (+) = :P4410_ID',
'   and ag.security_group_id (+) = :WORKSPACE_ID',
'   and ag.id                (+) = a.attribute_group_id',
'   and dg.id                (+) = d.attribute_group_id',
'   and dg.security_group_id (+) = d.security_group_id',
' order by a.attribute_scope,',
'          ag.display_sequence asc nulls first,',
'          ag.id,',
'          a.display_sequence  asc,',
'          a.id'))
,p_display_when_condition=>'P4410_ID'
,p_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>999
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No attributes defined.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48468100478898440)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48468705126910020)
,p_query_column_id=>2
,p_column_alias=>'ATTRIBUTE_SCOPE'
,p_column_display_sequence=>41
,p_column_heading=>'Scope'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(32688601172502165)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48468808229910037)
,p_query_column_id=>3
,p_column_alias=>'ATTRIBUTE_SEQUENCE'
,p_column_display_sequence=>71
,p_column_heading=>'Attribute'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(451251025866010763)
,p_query_column_id=>4
,p_column_alias=>'DISPLAY_SEQUENCE'
,p_column_display_sequence=>61
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2832491655618426)
,p_query_column_id=>5
,p_column_alias=>'STATIC_ID'
,p_column_display_sequence=>31
,p_column_heading=>'Static ID'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P4410_PLUGIN_TYPE in ( ''TEMPLATE COMPONENT'', ''REGION TYPE'' )'
,p_display_when_condition2=>'PLSQL'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48468927141910037)
,p_query_column_id=>6
,p_column_alias=>'PROMPT'
,p_column_display_sequence=>21
,p_column_heading=>'Label'
,p_use_as_row_header=>'Y'
,p_column_link=>'javascript:apex.submit({request:''APPLY_CHANGES_EDIT_4415'',set:{''P4410_ATTRIBUTE_ID'':''#ID#''}});'
,p_column_linktext=>'#PROMPT#'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48469008549910037)
,p_query_column_id=>7
,p_column_alias=>'IS_REQUIRED'
,p_column_display_sequence=>101
,p_column_heading=>'Required'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(84259319526460470)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(161084231163549216)
,p_query_column_id=>8
,p_column_alias=>'DEFAULT_VALUE'
,p_column_display_sequence=>111
,p_column_heading=>'Default Value'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(262037604939319214)
,p_query_column_id=>9
,p_column_alias=>'ATTRIBUTE_TYPE'
,p_column_display_sequence=>91
,p_column_heading=>'Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(28057124498012298)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(262037930350336033)
,p_query_column_id=>10
,p_column_alias=>'DEPENDING_ON_PROMPT'
,p_column_display_sequence=>121
,p_column_heading=>'Depending on'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1654129691240847)
,p_query_column_id=>11
,p_column_alias=>'ATTRIBUTE_GROUP_TITLE'
,p_column_display_sequence=>51
,p_column_heading=>'Attribute Group'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_when_cond_type=>'EXPRESSION'
,p_display_when_condition=>':P4410_PLUGIN_TYPE in ( ''REGION TYPE'', ''ITEM TYPE'', ''PROCESS TYPE'', ''DYNAMIC ACTION'', ''TEMPLATE COMPONENT'' )'
,p_display_when_condition2=>'PLSQL'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(263527442738503017)
,p_plug_name=>'Slots'
,p_region_name=>'SlotsDataEntry'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>140
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_PLUGIN_SLOTS'
,p_query_where=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    flow_id           = :FB_FLOW_ID',
'and plugin_id         = :P4410_ID',
'and security_group_id = :WORKSPACE_ID'))
,p_include_rowid_column=>false
,p_plug_source_type=>'NATIVE_IG'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P4410_ID'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Slots'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Slots are placeholders in your template component markup where you can place page components, such as regions, items and buttons.</p>',
'<p>Slots can be used to restrict the placement of regions, items and buttons on this template component by configuring which component type is supported in a slot.</p>'))
);
wwv_flow_imp_page.create_region_column_group(
 p_id=>wwv_flow_imp.id(3509500421986755)
,p_heading=>'Grid Layout Rendering'
);
wwv_flow_imp_page.create_region_column_group(
 p_id=>wwv_flow_imp.id(5717864680724737)
,p_heading=>'Component Type Support'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1413069572026112)
,p_name=>'SUPPORTED_REGION_TYPES'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'SUPPORTED_REGION_TYPES'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_CHECKBOX'
,p_heading=>'Supported Regions'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>160
,p_value_alignment=>'LEFT'
,p_group_id=>wwv_flow_imp.id(5717864680724737)
,p_use_group_for=>'BOTH'
,p_attribute_01=>'1'
,p_is_required=>false
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(1447420798857654)
,p_lov_display_extra=>false
,p_multi_value_type=>'JSON_ARRAY'
,p_enable_filter=>false
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_escape_on_http_output=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1413118794026113)
,p_name=>'SUPPORTED_ITEM_TYPES'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'SUPPORTED_ITEM_TYPES'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_CHECKBOX'
,p_heading=>'Supported Items'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>170
,p_value_alignment=>'LEFT'
,p_group_id=>wwv_flow_imp.id(5717864680724737)
,p_use_group_for=>'BOTH'
,p_attribute_01=>'1'
,p_is_required=>false
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(1415923876037819)
,p_lov_display_extra=>false
,p_multi_value_type=>'JSON_ARRAY'
,p_enable_filter=>false
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_escape_on_http_output=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1423274254828824)
,p_name=>'PLUGIN_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'PLUGIN_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>60
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'P4410_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1423449589828826)
,p_name=>'APEX$ROW_ACTION'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>20
,p_use_as_row_header=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1423566851828827)
,p_name=>'APEX$ROW_SELECTOR'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_use_as_row_header=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3508136834986742)
,p_name=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FLOW_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>50
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'FB_FLOW_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3508404702986744)
,p_name=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>70
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_max_length=>30
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>true
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3508456476986745)
,p_name=>'PLACEHOLDER'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'PLACEHOLDER'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Static Identifier'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>80
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_attribute_06=>'UPPER'
,p_is_required=>true
,p_max_length=>30
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3508534533986746)
,p_name=>'HAS_GRID_SUPPORT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'HAS_GRID_SUPPORT'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SINGLE_CHECKBOX'
,p_heading=>'Grid Support'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>130
,p_value_alignment=>'CENTER'
,p_group_id=>wwv_flow_imp.id(3509500421986755)
,p_use_group_for=>'BOTH'
,p_attribute_01=>'Y'
,p_is_required=>false
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'N'
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3508672850986747)
,p_name=>'HAS_REGION_SUPPORT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'HAS_REGION_SUPPORT'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SINGLE_CHECKBOX'
,p_heading=>'Regions'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>100
,p_value_alignment=>'CENTER'
,p_group_id=>wwv_flow_imp.id(5717864680724737)
,p_use_group_for=>'BOTH'
,p_attribute_01=>'Y'
,p_is_required=>false
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'Y'
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3508730843986748)
,p_name=>'HAS_ITEM_SUPPORT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'HAS_ITEM_SUPPORT'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SINGLE_CHECKBOX'
,p_heading=>'Items'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>110
,p_value_alignment=>'CENTER'
,p_group_id=>wwv_flow_imp.id(5717864680724737)
,p_use_group_for=>'BOTH'
,p_attribute_01=>'Y'
,p_is_required=>false
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'N'
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3508867597986749)
,p_name=>'HAS_BUTTON_SUPPORT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'HAS_BUTTON_SUPPORT'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SINGLE_CHECKBOX'
,p_heading=>'Buttons'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>120
,p_value_alignment=>'CENTER'
,p_group_id=>wwv_flow_imp.id(5717864680724737)
,p_use_group_for=>'BOTH'
,p_attribute_01=>'Y'
,p_is_required=>false
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'N'
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3508932562986750)
,p_name=>'GLV_NEW_ROW'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'GLV_NEW_ROW'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SINGLE_CHECKBOX'
,p_heading=>'New Row'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>150
,p_value_alignment=>'CENTER'
,p_group_id=>wwv_flow_imp.id(3509500421986755)
,p_use_group_for=>'BOTH'
,p_attribute_01=>'Y'
,p_is_required=>false
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'Y'
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3509086206986751)
,p_name=>'MAX_FIXED_GRID_COLUMNS'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'MAX_FIXED_GRID_COLUMNS'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>'Maximum Grid Columns'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>140
,p_value_alignment=>'RIGHT'
,p_group_id=>wwv_flow_imp.id(3509500421986755)
,p_use_group_for=>'BOTH'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
,p_is_required=>false
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'P4410_GRID_MAX_COLUMNS'
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(13192436025008639)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>40
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>true
,p_duplicate_value=>false
,p_include_in_export=>false
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(3507957026986740)
,p_internal_uid=>3507957026986740
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_add_row_if_empty=>false
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>true
,p_no_data_found_message=>'No slots defined.'
,p_show_toolbar=>false
,p_toolbar_buttons=>null
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>false
,p_define_chart_view=>false
,p_enable_download=>false
,p_download_formats=>null
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(3519668491004502)
,p_interactive_grid_id=>wwv_flow_imp.id(3507957026986740)
,p_static_id=>'21135'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(3519853573004505)
,p_report_id=>wwv_flow_imp.id(3519668491004502)
,p_view_type=>'GRID'
,p_stretch_columns=>true
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1604856711433189)
,p_view_id=>wwv_flow_imp.id(3519853573004505)
,p_display_seq=>7
,p_column_id=>wwv_flow_imp.id(1413069572026112)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>125
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1605779337433194)
,p_view_id=>wwv_flow_imp.id(3519853573004505)
,p_display_seq=>9
,p_column_id=>wwv_flow_imp.id(1413118794026113)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>132
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2028781676029004)
,p_view_id=>wwv_flow_imp.id(3519853573004505)
,p_display_seq=>14
,p_column_id=>wwv_flow_imp.id(1423274254828824)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2032759264069662)
,p_view_id=>wwv_flow_imp.id(3519853573004505)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(1423449589828826)
,p_is_visible=>true
,p_is_frozen=>true
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3521271744004519)
,p_view_id=>wwv_flow_imp.id(3519853573004505)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(3508136834986742)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3523052671004525)
,p_view_id=>wwv_flow_imp.id(3519853573004505)
,p_display_seq=>4
,p_column_id=>wwv_flow_imp.id(3508404702986744)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>180
,p_sort_order=>1
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3523980910004527)
,p_view_id=>wwv_flow_imp.id(3519853573004505)
,p_display_seq=>5
,p_column_id=>wwv_flow_imp.id(3508456476986745)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>216
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3524835185004530)
,p_view_id=>wwv_flow_imp.id(3519853573004505)
,p_display_seq=>11
,p_column_id=>wwv_flow_imp.id(3508534533986746)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>178
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3525773873004532)
,p_view_id=>wwv_flow_imp.id(3519853573004505)
,p_display_seq=>6
,p_column_id=>wwv_flow_imp.id(3508672850986747)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>76
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3526655115004535)
,p_view_id=>wwv_flow_imp.id(3519853573004505)
,p_display_seq=>8
,p_column_id=>wwv_flow_imp.id(3508730843986748)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>83
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3527610960004537)
,p_view_id=>wwv_flow_imp.id(3519853573004505)
,p_display_seq=>10
,p_column_id=>wwv_flow_imp.id(3508867597986749)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>93
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3528450577004540)
,p_view_id=>wwv_flow_imp.id(3519853573004505)
,p_display_seq=>15
,p_column_id=>wwv_flow_imp.id(3508932562986750)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>108
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3529392008004543)
,p_view_id=>wwv_flow_imp.id(3519853573004505)
,p_display_seq=>12
,p_column_id=>wwv_flow_imp.id(3509086206986751)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>136
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(13204762723033887)
,p_view_id=>wwv_flow_imp.id(3519853573004505)
,p_display_seq=>13
,p_column_id=>wwv_flow_imp.id(13192436025008639)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1606343904945704)
,p_plug_name=>'Default Slots'
,p_parent_plug_id=>wwv_flow_imp.id(263527442738503017)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_header=>'<p>Default slots are used in Page Designer for creating components inside a template component, or moving components across different containers.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(439386704233826730)
,p_plug_name=>'Standard Attributes'
,p_region_name=>'STD_ATTRIBUTES'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(538625467201238345)
,p_plug_name=>'File URLs to Load'
,p_region_name=>'FILE_URLS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>170
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P4410_ID'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(620042529567315148)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(29434107863295859)
,p_plug_display_sequence=>220
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from WWV_FLOW_PLUGINS',
'where id = :P4410_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :P4410_ID,',
'      p_component_type => ''Application Item'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P4410_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(791007298727651108)
,p_name=>'Standard Attribute additional Meta Data'
,p_region_name=>'STD_ATTRIBUTE_DETAILS'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select   a.id,',
'       lvd.lov_disp_value   as display_name,',
'         a.name             as internal_name,',
'         a.is_required,',
'         a.default_value,',
'         d.prompt           as depending_on_attribute',
'  from',
'       wwv_flow_plugins               p,',
'       wwv_flow_plugin_attributes     d,',
'       wwv_flow_plugin_std_attributes a,',
'       wwv_flow_list_of_values_data   lvd, ',
'       WWV_FLOW_LISTS_OF_VALUES$      lv',
' where a.plugin_id         = :P4410_ID',
'   and p.id                = a.plugin_id',
'   and a.security_group_id = :WORKSPACE_ID',
'   and d.id (+)            = a.depending_on_attribute_id',
'   and a.name              = lvd.lov_return_value',
'   and lvd.lov_id          = lv.id ',
'   and lvd.flow_id         = 4000',
'   and lv.lov_name         = case when p.plugin_type = ''ITEM TYPE'' then ''PLUGIN.ITEM_ATTRIBUTES''',
'                                  when p.plugin_type = ''REGION TYPE'' then ''PLUGIN.REGION_ATTRIBUTES''',
'                                  when p.plugin_type = ''WEB SOURCE TYPE'' then ''PLUGIN.WEB_SOURCE_ATTRIBUTES''',
'                                  when p.plugin_type = ''DYNAMIC ACTION'' then ''PLUGIN.DYNAMIC_ACTION_ATTRIBUTES'' end',
''))
,p_display_when_condition=>'P4410_ID'
,p_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>999
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No standard attributes with additional details selected.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(791007519136651111)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(791008596495651121)
,p_query_column_id=>2
,p_column_alias=>'DISPLAY_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Standard Attribute'
,p_use_as_row_header=>'Y'
,p_column_link=>'f?p=&APP_ID.:4411:&SESSION.::&DEBUG.:RP,4411:P4411_PLUGIN_ID,P4411_NAME,P4411_ID,P4411_PLUGIN_TYPE:&P4410_ID.,#INTERNAL_NAME#,#ID#,&P4410_PLUGIN_TYPE.'
,p_column_linktext=>'#DISPLAY_NAME#'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(791008614330651122)
,p_query_column_id=>3
,p_column_alias=>'INTERNAL_NAME'
,p_column_display_sequence=>5
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(791008031523651116)
,p_query_column_id=>4
,p_column_alias=>'IS_REQUIRED'
,p_column_display_sequence=>3
,p_column_heading=>'Required'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(84259319526460470)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(791008111392651117)
,p_query_column_id=>5
,p_column_alias=>'DEFAULT_VALUE'
,p_column_display_sequence=>4
,p_column_heading=>'Default Value'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(791008769882651123)
,p_query_column_id=>6
,p_column_alias=>'DEPENDING_ON_ATTRIBUTE'
,p_column_display_sequence=>6
,p_column_heading=>'Depending on Custom Attribute'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1649549844240801)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2675372452330944)
,p_button_name=>'ADD_ATTRIBUTE_GROUP'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Add Group'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
,p_button_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(9812207339144407)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(48467930491898431)
,p_button_name=>'SYNCHRONIZE_ATTRIBUTES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Synchronize from Templates'
,p_button_position=>'CREATE'
,p_button_condition=>'not wwv_flow_page.is_read_only and :P4410_ID is not null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(48656805235692689)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1651611827240822)
,p_button_name=>'ADD_EVENT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Add Event'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
,p_button_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2800145762549801)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(263527442738503017)
,p_button_name=>'ADD_SLOT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Add Slot'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
,p_button_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(48437800027915146)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(48467930491898431)
,p_button_name=>'ADD_ATTRIBUTE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Add Attribute'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'javascript:apex.submit({request:''APPLY_CHANGES_CREATE_4415''});'
,p_button_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2620492499490922)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(4004965443629330)
,p_button_name=>'ADD_ACTION_POSITION'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Add Action Position'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'javascript:apex.submit({request:''APPLY_CHANGES_CREATE_4417''});'
,p_button_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2622950955490947)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(1622849868577319)
,p_button_name=>'ADD_ACTION_TEMPLATE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Add Action Template'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'javascript:apex.submit({request:''APPLY_CHANGES_CREATE_4418''});'
,p_button_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1606036653945701)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(263527442738503017)
,p_button_name=>'HELP_SLOTS'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--regionHeader:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Help'
,p_button_position=>'EDIT'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'icon-help'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30855910247544017)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(29873113508481210)
,p_button_name=>'FILES_DELETE_ALL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete All Files'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugin_files',
' where flow_id             = :P4410_FLOW_ID',
'   and plugin_id           = :P4410_ID',
'   and security_group_id   = :WORKSPACE_ID',
'   and :P4410_REFERENCE_ID is not null'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(32723802886376952)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(33340707031647637)
,p_button_name=>'PUBLISH_PLUGIN'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Publish Plug-in'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.:RP,149:F4000_P149_ID,F4000_P149_PAGE_ID,F4000_P149_TEMPLATE_TYPE:&P4410_ID.,&APP_PAGE_ID.,PLUGIN'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugins',
' where reference_id      = :P4410_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(11094566030588034)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(33340707031647637)
,p_button_name=>'UNSUBSCRIBE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Unsubscribe'
,p_button_position=>'NEXT'
,p_button_condition=>':P4410_REFERENCE_ID is not null and :P4410_SUBSCRIBED_COMP_GRP = ''N'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30855713266542663)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(29873113508481210)
,p_button_name=>'FILES_DOWNLOAD_ZIP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Download as Zip'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:4410:&SESSION.:FILES_DOWNLOAD_ZIP:&DEBUG.::P4410_ID,P4410_FLOW_ID:&P4410_ID.,&P4410_FLOW_ID.'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugin_files',
' where flow_id           = :P4410_FLOW_ID',
'   and plugin_id         = :P4410_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(29870024711418146)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(29873113508481210)
,p_button_name=>'CREATE_FILE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Create File'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:118:&SESSION.::&DEBUG.:RP,118:P118_SCOPE,P118_APP_ID,P118_PLUGIN_ID:PLUGIN,&P4410_FLOW_ID.,&P4410_ID.'
,p_button_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(32723606028376952)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(33340707031647637)
,p_button_name=>'REFRESH_PLUGIN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Refresh Plug-in'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P4410_REFERENCE_ID is not null ',
'and ( :P4410_VERSION_SCN != :P4410_MASTER_VERSION_SCN or :P4410_VERSION_SCN is null )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(27902718197734562)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(27900816654734558)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:4400:&SESSION.::&DEBUG.:::'
,p_button_condition=>'P4410_THEME_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3404234342955634)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_imp.id(27900816654734558)
,p_button_name=>'Cancel_Theme'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.:::'
,p_button_condition=>'P4410_THEME_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(27903106352734562)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_imp.id(27900816654734558)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
,p_button_execute_validations=>'N'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P4410_ID is not null and NVL(:P4410_IS_IN_USE, ''N'') = ''N''',
'and ( :P4410_REFERENCE_ID is null or :P4410_SUBSCRIBED_COMP_GRP = ''N'' )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(27902501930734562)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_imp.id(27900816654734558)
,p_button_name=>'apply_changes'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P4410_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(28077802830866929)
,p_button_sequence=>110
,p_button_plug_id=>wwv_flow_imp.id(27900816654734558)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Plug-in'
,p_button_position=>'NEXT'
,p_button_condition=>'P4410_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(30858131573592203)
,p_branch_name=>'Reset Pagination after delete all files'
,p_branch_action=>'f?p=&APP_ID.:4410:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(30855910247544017)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(437419308521420527)
,p_branch_name=>'Go To Page 4415 - Edit'
,p_branch_action=>'f?p=&APP_ID.:4415:&SESSION.::&DEBUG.:RP,4415:P4415_ID:&P4410_ATTRIBUTE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_EDIT_4415'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(437422211207440225)
,p_branch_name=>'Go To Page 4415 - Create'
,p_branch_action=>'f?p=&APP_ID.:4415:&SESSION.::&DEBUG.:RP,4415:P4415_PLUGIN_ID:&P4410_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_CREATE_4415'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2619769118490915)
,p_branch_name=>'Go To Page 4417 - Edit'
,p_branch_action=>'f?p=&APP_ID.:4417:&SESSION.::&DEBUG.:RP,4417:P4417_ID,P4417_PLUGIN_ID:&P4410_ACTION_POSITION_ID.,&P4410_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_EDIT_4417'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2620564599490923)
,p_branch_name=>'Go To Page 4417 - Create'
,p_branch_action=>'f?p=&APP_ID.:4417:&SESSION.::&DEBUG.:RP,4417:P4417_PLUGIN_ID:&P4410_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>80
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_CREATE_4417'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2622792345490945)
,p_branch_name=>'Go To Page 4418 - Edit'
,p_branch_action=>'f?p=&APP_ID.:4418:&SESSION.::&DEBUG.:RP,4418:P4418_ID,P4418_PLUGIN_ID:&P4410_ACTION_TEMPLATE_ID.,&P4410_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>90
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_EDIT_4418'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2622801004490946)
,p_branch_name=>'Go To Page 4418 - Create'
,p_branch_action=>'f?p=&APP_ID.:4418:&SESSION.::&DEBUG.:RP,4418:P4418_PLUGIN_ID:&P4410_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>100
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_CREATE_4418'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(437441811656922826)
,p_branch_name=>'Go To Page 4440'
,p_branch_action=>'f?p=&APP_ID.:4440:&SESSION.::&DEBUG.:RP,4440:P4440_ID:&P4410_FILE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>110
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_EDIT_4440'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(32732406702828279)
,p_branch_name=>'Go To Page 4410'
,p_branch_action=>'f?p=&APP_ID.:4410:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(32723606028376952)
,p_branch_sequence=>120
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(28054007984885220)
,p_branch_name=>'Go To Page 4410'
,p_branch_action=>'f?p=&APP_ID.:4410:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>130
,p_branch_condition_type=>'REQUEST_IN_CONDITION'
,p_branch_condition=>'DELETE_EVENT,ADD_EVENT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(27942313933204406)
,p_branch_name=>'Go To Page 4410'
,p_branch_action=>'f?p=&APP_ID.:4410:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(27902501930734562)
,p_branch_sequence=>140
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P4410_RETURN_TO_PAGE'
,p_branch_condition_text=>'YES'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(28078125776866929)
,p_branch_name=>'Go To Page 4410'
,p_branch_action=>'f?p=&APP_ID.:4410:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(28077802830866929)
,p_branch_sequence=>150
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(9812840446144413)
,p_branch_name=>'Go To Page 4410'
,p_branch_action=>'f?p=&APP_ID.:4410:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(9812207339144407)
,p_branch_sequence=>160
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3404411690955636)
,p_branch_name=>'Go To Page 4003'
,p_branch_action=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>170
,p_branch_condition_type=>'ITEM_IS_NOT_NULL'
,p_branch_condition=>'P4410_THEME_ID'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(48839616468976683)
,p_branch_name=>'Go To Page 4400'
,p_branch_action=>'f?p=&APP_ID.:4400:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>180
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1401713408619804)
,p_name=>'P4410_PROCESS_COMPONENT_TYPES'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(5261005290655272)
,p_item_default=>'APEX_APPLICATION_PAGE_PROC:APEX_APPL_AUTOMATION_ACTIONS:APEX_APPL_TASKDEF_ACTIONS:APEX_APPL_WORKFLOW_ACTIVITIES'
,p_prompt=>'Component Type'
,p_source=>'P4410_SUPPORTED_COMP_TYPES'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PLUGIN_PROCESS_TYPE_COMPONENT_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(1800185422847060)||'.'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specifies if the plug-in is displayed in the Builder as a supported component for Page Processes, Automation Actions, and Task Definition Actions.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1417035605635701)
,p_name=>'P4410_WEB_SOURCE_ATTRIBUTES'
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_imp.id(439386704233826730)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Attributes:'
,p_source=>'P4410_STANDARD_ATTRIBUTES'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PLUGIN.WEB_SOURCE_ATTRIBUTES'
,p_lov=>'.'||wwv_flow_imp.id(1416444037632936)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'For REST Data Source plug-ins, identify the attributes that apply to this plug-in:',
'</p>',
'<p>',
'<ul>',
'    <li>Default Endpoint - The URL endpoint or URL prefix to propose for new REST Data Source.</li>',
'    <li>Do Not Test Endpoint - Whether to test the provided URL endpoint when a new REST Data Source is created.</li>',
'</ul>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1418070052012518)
,p_name=>'P4410_SUBSCRIBED_COMP_GRP'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(33340707031647637)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1420968226828801)
,p_name=>'P4410_DEFAULT_SLOT_REGION'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(1606343904945704)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Regions'
,p_source=>'DEFAULT_SLOT_REGION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name,',
'       placeholder r',
'  from wwv_flow_plugin_slots',
' where flow_id            = :FB_FLOW_ID',
'   and plugin_id          = :P4410_ID',
'   and security_group_id  = :WORKSPACE_ID',
'   and has_region_support = ''Y'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Not Identified -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>You can optionally choose a default slot for a region for the current template component. ',
'    If no default slot is selected for a region, ',
'    then the first available slot (that supports regions) will be picked, alphabetically.</p>'))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1421093172828802)
,p_name=>'P4410_DEFAULT_SLOT_REGION_TEMP'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1606343904945704)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1421310174828805)
,p_name=>'P4410_DEFAULT_SLOT_ITEM_TEMP'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1606343904945704)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1421406657828806)
,p_name=>'P4410_DEFAULT_SLOT_ITEM'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(1606343904945704)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Items'
,p_source=>'DEFAULT_SLOT_ITEM'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name,',
'       placeholder r',
'  from wwv_flow_plugin_slots',
' where flow_id           = :FB_FLOW_ID',
'   and plugin_id         = :P4410_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and has_item_support  = ''Y'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Not Identified -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>You can optionally choose a default slot for an item for the current template component. ',
'    If no default slot is selected for an item, ',
'    then the first available slot (that supports items) will be picked, alphabetically.</p>'))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1421916795828811)
,p_name=>'P4410_DEFAULT_SLOT_BUTTON_TEMP'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1606343904945704)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1422007088828812)
,p_name=>'P4410_DEFAULT_SLOT_BUTTON'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(1606343904945704)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Buttons'
,p_source=>'DEFAULT_SLOT_BUTTON'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name,',
'       placeholder r',
'  from wwv_flow_plugin_slots',
' where flow_id            = :FB_FLOW_ID',
'   and plugin_id          = :P4410_ID',
'   and security_group_id  = :WORKSPACE_ID',
'   and has_button_support = ''Y'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Not Identified -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>You can optionally choose a default slot for a button for the current template component. ',
'    If no default slot is selected for a button, ',
'    then the first available slot (that supports buttons) will be picked, alphabetically.</p>'))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1601166824579201)
,p_name=>'P4410_TERMINATION_FUNCTION'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(27935931959010930)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Termination Function Name'
,p_source=>'TERMINATION_FUNCTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the name of the PL/SQL function to be called to release locked resources or cancel associated rows within a workflow context, especially when a plug-in implements a wait state. ',
'By invoking the terminate function, the plugin can effectively free up resources if the associated workflow instance gets terminated.',
'It can reference a function of the anonymous PL/SQL code block, a package function or stand alone function in the database. For example:',
'<pre>',
'terminate_proc',
'</pre></p>',
'',
'<p>When referencing a database PL/SQL package or stand alone function, you can use the <code>#OWNER#</code> substitution string to reference the parsing schema of the current application. For example:',
'<pre>',
'#OWNER#.terminate_proc',
'</pre></p>',
'',
'<p>Process Type Plug-in Termination Functions must implement the following interface:',
'',
'<pre>',
'function name_of_function (',
'    p_process in apex_plugin.t_process,',
'    p_plugin  in apex_plugin.t_plugin )',
'    return apex_plugin.t_process_terminate_result',
'',
'</pre>',
'</p>',
''))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1606759360479201)
,p_name=>'P4410_REPORT_CONT_TEMPLATE'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(4004640729629327)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Report Container'
,p_source=>'REPORT_CONTAINER_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the markup for the report container template. The Static IDs of the Custom Attributes of scope "Report" can be referenced with <code>#STATIC_ID#</code> syntax.',
'You can quickly synchronize all placeholders as Custom Attributes using the <strong>Synchronize Attributes</strong> button.',
'</p>',
'<p>',
'The following predefined template placeholders are supported:',
'<dl>',
'<dt>APEX$DOM_ID</dt>',
'<dd>Unique DOM ID generated when the template is invoked, useful for referencing other DOM elements in the provided HTML markup.</dd>',
'<dt>APEX$COMPONENT_CSS_CLASSES</dt>',
'<dd>CSS classes specified for the region.</dd>',
'<dt>APEX$REPORT_BODY</dt>',
'<dd>Output of the Report Body template.</dd>',
'</dl>',
'</p>',
'',
'<p>You can also use slot placeholders to allow this report container to render page components (regions, items, buttons). Slots can be referenced with <code>#SLOT_STATIC_ID#</code> syntax. To render a slot conditionally use the <code>{if SLOT_STATIC_'
||'ID/}&lt;div class="inner-div"&gt;#SLOT_STATIC_ID#&lt;/div&gt;{endif/}</code> syntax to render additional markup only if the slot is being used. Slots in the report container template will only render if the associated region uses <strong>Display: Mul'
||'tiple (Report)</strong></p>',
'',
'<p>Supports Template Directives.</p>'))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1807041210773813)
,p_name=>'P4410_COMPLETION_FUNCTION'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(27935931959010930)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Completion Function Name'
,p_source=>'COMPLETION_FUNCTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the name of the PL/SQL function to be called to complete the plug-in. It can reference a function of the anonymous PL/SQL code block, a package function or stand alone function in the database. For example:',
'<pre>',
'complete_proc',
'</pre></p>',
'',
'<p>When referencing a database PL/SQL package or stand alone function, you can use the <code>#OWNER#</code> substitution string to reference the parsing schema of the current application. For example:',
'<pre>',
'#OWNER#.complete_proc',
'</pre></p>',
'',
'<p>Process Type Plug-in Completion Functions must implement the following interface:',
'',
'<pre>',
'function &lt;name of function&gt; (',
'    p_process in apex_plugin.t_process,',
'    p_plugin  in apex_plugin.t_plugin,',
'    p_param   in apex_plugin.t_process_complete_param )',
'    return apex_plugin.t_process_complete_result',
'</pre>',
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2003612747458832)
,p_name=>'P4410_REPORT_BODY_TEMPLATE'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(4004640729629327)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Report Body'
,p_source=>'REPORT_BODY_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>10
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the markup for the report body template. The Static IDs of the Custom Attributes of scope "Report" can be referenced with <code>#STATIC_ID#</code> syntax.',
'You can quickly synchronize all placeholders as Custom Attributes using the <strong>Synchronize Attributes</strong> button.',
'</p>',
'<p>',
'The following predefined template placeholders are supported:',
'<dl>',
'<dt>APEX$DOM_ID</dt>',
'<dd>Unique DOM ID generated when the template is invoked, useful for referencing other DOM elements in the provided HTML markup.</dd>',
'<dt>APEX$IS_LAZY_LOADING</dt>',
'<dd>Set to <code>T</code> if the region uses lazy loading to load its data and skeleton markup should be rendered instead.</dd>',
'<dt>APEX$HAS_MESSAGE</dt>',
'<dd>Set to <code>T</code> if the region''s data source does not return any data.</dd>',
'<dt>APEX$MESSAGE</dt>',
'<dd>Text of the No Data Found Message.</dd>',
'<dt>APEX$MESSAGE_ICON</dt>',
'<dd>Icon class of the No Data Found Icon.</dd>',
'<dt>APEX$COMPONENT_CSS_CLASSES</dt>',
'<dd>CSS classes specified for the region.</dd>',
'<dt>APEX$ROWS</dt>',
'<dd>For each row queried, output of the Row template.</dd>',
'<dt>APEX$TITLE</dt>',
'<dd>Title of the region.</dd>',
'</dl>',
'</p>',
'<p>Supports Template Directives.</p>'))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2003700350458833)
,p_name=>'P4410_REPORT_ROW_TEMPLATE'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(4004640729629327)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Report Row'
,p_source=>'REPORT_ROW_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the markup for the report row template. The Static IDs of the Custom Attributes of scope "Report" can be referenced with <code>#STATIC_ID#</code> syntax.',
'You can quickly synchronize all placeholders as Custom Attributes using the <strong>Synchronize Attributes</strong> button.',
'</p>',
'<p>',
'The following predefined template placeholders are supported:',
'<dl>',
'<dt>APEX$DOM_ID</dt>',
'<dd>Unique DOM ID generated when the template is invoked, useful for referencing other DOM elements in the provided HTML markup.</dd>',
'<dt>APEX$IS_LAZY_LOADING</dt>',
'<dd>Set to <code>T</code> if the region uses lazy loading to load its data and skeleton markup should be rendered instead.</dd>',
'<dt>APEX$ROW_IDENTIFICATION</dt>',
'<dd>Contains data-id and data-rownum attributes to identify a row.</dd>',
'<dt>APEX$ROW_ID</dt>',
'<dd>Primary key value of the current row.</dd>',
'<dt>APEX$SELECTOR</dt>',
'<dd>For row selection support. Renders as a radio or checkbox control depending on single or multiple selection. This placeholder will only be populated in the context of a template component report.</dd>',
'<dt>APEX$VALUE_IDENTIFIES_ROW</dt>',
'<dd>Contains row values of report columns which enabled the accessibilty related column setting "Value Identifies Row". Enabling this setting on multiple report columns outputs the values separated by a blank. This placeholder will only be populated '
||'in the context of a template component report.</dd>',
'<dt>APEX$PARTIAL</dt>',
'<dd>Output of the Partial template.</dd>',
'</dl>',
'</p>',
'<p>Supports Template Directives.</p>'))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2004276549458838)
,p_name=>'P4410_REPORT_PLACEHOLDER_COUNT'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_imp.id(4004640729629327)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Number of Lazy Loading Skeletons'
,p_format_mask=>'990'
,p_source=>'REPORT_PLACEHOLDER_COUNT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify how often the partial template is rendered as a skeleton if the region''s display attribute is set to <strong>Multiple (Report)</strong> and lazy loading is turned on.'
,p_attribute_01=>'0'
,p_attribute_02=>'100'
,p_attribute_03=>'left'
,p_attribute_04=>'numeric'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2006666175278109)
,p_name=>'P4410_TEMPLATE_COMP_ATTRIBUTES'
,p_item_sequence=>310
,p_item_plug_id=>wwv_flow_imp.id(439386704233826730)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Attributes:'
,p_source=>'P4410_STANDARD_ATTRIBUTES'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PLUGIN.TEMPLATE_COMPONENT_ATTRIBUTES'
,p_lov=>'.'||wwv_flow_imp.id(1800908936730547)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'For Template Component type plug-ins, check the following to enable options as described here:',
'</p>',
'<p>',
'<ul>',
'    <li>Has Row Selection Support - If checked allows row based selection support for template component reports.</li>',
'    <li>Has Region Template Attribute - If checked, a Region Template can be selected to define the appearance and layout of the region. Note: this option is disabled for Region Only template component types.</li>',
'</ul>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2210655951848924)
,p_name=>'P4410_WSM_CAPABILITIES'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(27935931959010930)
,p_use_cache_before_default=>'NO'
,p_prompt=>'REST Source Capabilities Procedure'
,p_source=>'WSM_CAPABILITIES_FUNCTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the name of the PL/SQL procedure to get the REST Data Source <em>Capabilities</em>. It can reference a procedure of the anonymous PL/SQL code block, a package procedure or stand alone procedure in the database. For example:',
'<pre>',
'capabilities_web_source',
'</pre>',
'</p>',
'',
'<p>When referencing a database PL/SQL package or stand alone procedure, you can use the <code>#OWNER#</code> substitution string to reference the parsing schema of the current application. For example:',
'<pre>',
'#OWNER#.capabilities_web_source',
'</pre></p>',
'',
'<p>REST Data Source Type Plug-in Capabilities Procedures must implement the following interface:',
'',
'<pre>',
'procedure capabilities_web_source (',
'    p_plugin in            apex_plugin.t_plugin,',
'    p_result in out nocopy apex_plugin.t_web_source_capabilities );',
'</pre>',
'</p>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2211252101848930)
,p_name=>'P4410_WSM_FETCH'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(27935931959010930)
,p_use_cache_before_default=>'NO'
,p_prompt=>'REST Source Fetch Procedure'
,p_source=>'WSM_FETCH_FUNCTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the name of the PL/SQL procedure which implements the <em>Fetch Rows</em> operation. It can reference a procedure of the anonymous PL/SQL code block, a package procedure or stand alone procedure in the database. For example:',
'<pre>',
'fetch_web_source',
'</pre>',
'</p>',
'',
'<p>When referencing a database PL/SQL package or stand alone procedure, you can use the <code>#OWNER#</code> substitution string to reference the parsing schema of the current application. For example:',
'<pre>',
'#OWNER#.fetch_web_source',
'</pre></p>',
'',
'<p>REST Data Source Type Plug-in Fetch Procedures must implement the following interface:',
'',
'<pre>',
'procedure fetch_web_source(',
'    p_plugin     in            apex_plugin.t_plugin,',
'    p_web_source in            apex_plugin.t_web_source,',
'    p_params     in            apex_plugin.t_web_source_fetch_params,',
'    p_result     in out nocopy apex_plugin.t_web_source_fetch_result );',
'</pre>',
'</p>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2211342826848931)
,p_name=>'P4410_WSM_DML'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(27935931959010930)
,p_use_cache_before_default=>'NO'
,p_prompt=>'REST Source DML Procedure'
,p_source=>'WSM_DML_FUNCTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the name of the PL/SQL procedure which implements the <em>DML</em> operations (insert, update or delete rows). It can reference a procedure of the anonymous PL/SQL code block, a package procedure or stand alone procedure in the database. For'
||' example:',
'<pre>',
'dml_web_source',
'</pre>',
'</p>',
'',
'<p>When referencing a database PL/SQL package or stand alone procedure, you can use the <code>#OWNER#</code> substitution string to reference the parsing schema of the current application. For example:',
'<pre>',
'#OWNER#.dml_web_source',
'</pre></p>',
'',
'<p>REST Data Source Type Plug-in DML Procedures must implement the following interface:',
'',
'<pre>',
'procedure dml_web_source (',
'    p_plugin     in            apex_plugin.t_plugin,',
'    p_web_source in            apex_plugin.t_web_source,',
'    p_params     in            apex_plugin.t_web_source_dml_params,',
'    p_result     in out nocopy apex_plugin.t_web_source_dml_result );',
'</pre>',
'</p>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2211440908848932)
,p_name=>'P4410_WSM_EXECUTE'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(27935931959010930)
,p_use_cache_before_default=>'NO'
,p_prompt=>'REST Source Execute Procedure'
,p_source=>'WSM_EXECUTE_FUNCTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the name of the PL/SQL procedure which implements the <em>Execute</em> operation, which is invoked when <strong>APEX_EXEC.EXECUTE_WEB_SOURCE</strong> is used. It can reference a procedure of the anonymous PL/SQL code block, a package procedu'
||'re or stand alone procedure in the database. For example:',
'<pre>',
'execute_web_source',
'</pre>',
'</p>',
'',
'<p>When referencing a database PL/SQL package or stand alone procedure, you can use the <code>#OWNER#</code> substitution string to reference the parsing schema of the current application. For example:',
'<pre>',
'#OWNER#.execute_web_source',
'</pre></p>',
'',
'<p>REST Data Source Type Plug-in Execute Procedures must implement the following interface:',
'',
'<pre>',
'procedure execute_web_source(',
'    p_plugin     in            apex_plugin.t_plugin,',
'    p_web_source in            apex_plugin.t_web_source,',
'    p_result     in out nocopy apex_plugin.t_web_source_execute_result );',
'</pre>',
'</p>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2211502762848933)
,p_name=>'P4410_WSM_DISCOVER'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(27935931959010930)
,p_use_cache_before_default=>'NO'
,p_prompt=>'REST Source Discover Procedure'
,p_source=>'WSM_DISCOVER_FUNCTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the name of the PL/SQL procedure which implements the <em>Discovery</em> operation, which is invoked when a new REST Data Source is created, in order to determine operations, columns and data types. It can reference a procedure of the anonym'
||'ous PL/SQL code block, a package procedure or stand alone procedure in the database. For example:',
'<pre>',
'discover_web_source',
'</pre>',
'</p>',
'',
'<p>When referencing a database PL/SQL package or stand alone procedure, you can use the <code>#OWNER#</code> substitution string to reference the parsing schema of the current application. For example:',
'<pre>',
'#OWNER#.discover_web_source',
'</pre></p>',
'',
'<p>REST Data Source Type Plug-in Discovery Procedures must implement the following interface:',
'',
'<pre>',
'procedure discover_web_source (',
'    p_plugin         in            apex_plugin.t_plugin,',
'    p_web_source     in            apex_plugin.t_web_source,',
'    p_params         in            apex_plugin.t_web_source_discover_params,',
'    p_result         in out nocopy apex_plugin.t_web_source_discover_result );',
'</pre>',
'</p>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2522853640409115)
,p_name=>'P4410_PLUGIN_SETTINGS_INIT'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(33340707031647637)
,p_source=>'P4410_SUBSCRIBE_PLGIN_SETTINGS'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2523143991409118)
,p_name=>'P4410_REFERENCE_ID_INIT'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(33340707031647637)
,p_item_default=>'P4410_REFERENCE_ID'
,p_item_default_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2619823001490916)
,p_name=>'P4410_ACTION_POSITION_ID'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(27899611028734555)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2622631554490944)
,p_name=>'P4410_ACTION_TEMPLATE_ID'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(27899611028734555)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2831326039618415)
,p_name=>'P4410_TRANSLATE_THIS_TEMPLATE'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_imp.id(4004640729629327)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Translate Templates'
,p_source=>'TRANSLATE_THIS_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify whether the templates are included in the XLIFF translation file.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2832908358618431)
,p_name=>'P4410_TMPL_COMPONENT_TYPES'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(4004640729629327)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Available as'
,p_source=>'P4410_SUPPORTED_COMP_TYPES'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PLUGIN_TEMPLATE_COMPONENT_COMPONENT_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(8409910097232187)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specifies how the plug-in can be displayed and where it can be used.</p>',
'<p>',
'<dl>',
'<dt>Single (Partial)</dt>',
'<dd>When checked, the Template Component can be used for an Interactive Report Column or for a region to show a single row.</dd>',
'<dt>Multiple (Report)</dt>',
'<dd>When checked, the Template Component can be used for a region to show multiple rows with pagination options.</dd>',
'<dt>Region Only</dt>',
'<dd>When checked, the Template Component can be used as a region showing static values. The provided HTML template is displayed without any wrapping HTML elements around it. The region has a limited number of attributes in Page Designer (excludes Reg'
||'ion Template, Header text, Footer text). It is recommended to include the <code>APEX$DOM_ID</code> substitution as an ID attribute of an element in within the template, to ensure that existing APEX functionality works with this component.</dd>',
'</dl>',
'<p>Template Components can always be used in server-side Template Directives using <code>{with/}</code> and <code>{apply/}</code> syntax without checking any of the checkboxes.<p>',
'<p>Example:',
'<pre>',
'{with/}',
'PLACEHOLDER1:=Some value',
'PLACEHOLDER2:=Some value',
'{apply INTERNAL_NAME/}',
'</pre>',
'</p>'))
,p_attribute_01=>'1'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2845829404306501)
,p_name=>'P4410_API_VERSION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(27935931959010930)
,p_use_cache_before_default=>'NO'
,p_source=>'API_VERSION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2846116433306504)
,p_name=>'P4410_API_VERSION_REGION'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(27935931959010930)
,p_use_cache_before_default=>'NO'
,p_item_default=>'3'
,p_prompt=>'API Interface'
,p_source=>'P4410_API_VERSION'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'PLUGIN_API_VERSION_REGION'
,p_lov=>'.'||wwv_flow_imp.id(2201166487924678)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify if the region type plug-in uses the deprecated FUNCTION based APIs to call the plug-in callbacks or if it uses the new PROCEDURE based APIs. Note: In order for a region type plug-in to support unlimited attributes, it must implement the PROCE'
||'DURE based APIs.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3401250921955604)
,p_name=>'P4410_DEFAULT_ESCAPE_MODE'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_imp.id(4004640729629327)
,p_use_cache_before_default=>'NO'
,p_item_default=>'HTML'
,p_prompt=>'Default Escape Mode'
,p_source=>'DEFAULT_ESCAPE_MODE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PLUGIN.ESCAPE_MODE'
,p_lov=>'.'||wwv_flow_imp.id(2201509320945428)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'The default escape mode for substitutions of the templates.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3404163157955633)
,p_name=>'P4410_THEME_ID'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(27899611028734555)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Theme'
,p_source=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_display_when=>'P4410_THEME_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identifies the theme to which this Template Component is associated. A theme is a grouping of templates which together provide layout and style for an application.'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9811750713144402)
,p_name=>'P4410_PARTIAL_TEMPLATE'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(4004640729629327)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Partial'
,p_source=>'PARTIAL_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>25
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the markup for the template. The Static IDs of the Custom Attributes of scope "Component" can be referenced with <code>#STATIC_ID#</code> syntax.',
'You can quickly synchronize all placeholders as Custom Attributes using the <strong>Synchronize from Templates</strong> button from the Custom Attributes region.',
'</p>',
'<p>',
'The following predefined template placeholders are supported:',
'<dl>',
'<dt>APEX$DOM_ID</dt>',
'<dd>Unique DOM ID generated when the template is invoked, useful for referencing other DOM elements in the provided HTML markup.</dd>',
'<dt>APEX$IS_LAZY_LOADING</dt>',
'<dd>Set to <code>T</code> if the region uses lazy loading to load its data and skeleton markup should be rendered instead.</dd>',
'<dt>APEX$HAS_ACTION_BUTTONS</dt>',
'<dd>Set to <code>T</code> if at least one button or button menu action gets rendered.</dd>',
'<dt>APEX$TITLE</dt>',
'<dd>Title of the region.</dd>',
'<dt>APEX$COMPONENT_CSS_CLASSES</dt>',
'<dd>CSS classes specified for the region.</dd>',
'<dt>APEX$SELECTOR</dt>',
'<dd>For row selection support. Renders as a radio or checkbox control depending on single or multiple selection. This placeholder will only be populated in the context of a template component report.</dd>',
'<dt>APEX$VALUE_IDENTIFIES_ROW</dt>',
'<dd>Contains row values of report columns which enabled the accessibilty related column setting "Value Identifies Row". Enabling this setting on multiple report columns outputs the values separated by a blank. This placeholder will only be populated '
||'in the context of a template component report.</dd>',
'</dl>',
'</p>',
'<p>The Static IDs of Action Positions can be referenced with <code>#STATIC_ID#</code> syntax.',
'If the Action Position is of type Link, <code>#STATIC_ID_ATTR#</code> can be used to reference the value of the Link Attribute.</p>',
'<p>You can also use slot placeholders to allow this partial to render page components (regions, items, buttons). Slots can be referenced with <code>#SLOT_STATIC_ID#</code> syntax. To render a slot conditionally to its usage use the <code>{if SLOT_STA'
||'TIC_ID/}&lt;div class="inner-div"&gt;#SLOT_STATIC_ID#&lt;/div&gt;{endif/}</code> syntax to render additional markup only if the slot is being used. Slots in the partial template will only render if the associated region uses <strong>Display As: Singl'
||'e (Partial)</strong></p>',
'',
'<p>Supports Template Directives.</p>'))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11093637292588025)
,p_name=>'P4410_VERSION_SCN'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(33340707031647637)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select version_scn ',
'  from wwv_flow_plugins',
' where id                = :P4410_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11093761581588026)
,p_name=>'P4410_MASTER_VERSION_SCN'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(33340707031647637)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select version_scn ',
'  from wwv_flow_plugins',
' where id                = :P4410_REFERENCE_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14861902600280221)
,p_name=>'P4410_SUBSCRIBE_PLGIN_SETTINGS'
,p_is_required=>true
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(33340707031647637)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Subscribe Component Settings'
,p_source=>'SUBSCRIBE_PLUGIN_SETTINGS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_read_only_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specifies if the component settings of the plug-in should be refreshed with the component settings of the subscribed plug-in in the master application if the plug-in is getting refreshed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20527901230873212)
,p_name=>'P4410_SUBSTITUTE_ATTRIBUTES'
,p_item_sequence=>340
,p_item_plug_id=>wwv_flow_imp.id(48467930491898431)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Substitute Attribute Values'
,p_source=>'SUBSTITUTE_ATTRIBUTES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Custom Attribute Values specified by the developer might contain items referenced with substitution syntax, for example <code>&amp;P1_DNAME.</code>',
'</p>',
'<p>If Substitute Attribute Values is set to <strong>On</strong> &PRODUCT_NAME. will automatically replace those references with their actual value before calling the plug-in.',
'</p>',
'<p>If Substitute Attribute Values is set to <strong>Off</strong> the values are written unchanged into the <code>attribute_01 - attribute_25</code> record type attributes of <code>p_plugin, p_item, p_region, ...</code> and the plug-in developer is re'
||'sponsible to replace those substitution syntax references with a call to <code>apex_plugin_util.replace_substitutions</code> or do similar replacements.',
'</p>',
'<p>A use case for <strong>Off</strong> would be if the custom plug-in attribute is used as a template and the substitution syntax is used to reference page items and columns of the SQL statement executed by the plug-in. Because the column values of t'
||'he SQL statement are not available at the time when the plug-in is called, the replacement has to be done by the plug-in itself.',
'</p>',
'<p>Example to manually substitute column values for each row:</p>',
'<pre>',
'/* Read data */',
'l_column_value_list := apex_plugin_util.get_data2 (',
'                           p_sql_statement => p_region.source,',
'                           p_region        => p_region );',
'/* Emit rows */',
'for l_row_num in 1 .. l_column_value_list( 1 ).value_list.count loop',
'    begin',
'        -- Assign the column values of the current row',
'        -- into session state',
'        apex_plugin_util.set_component_values (',
'            p_column_value_list => l_column_value_list,',
'            p_row_num           => l_row_num );',
'',
'        ...',
'',
'        -- Link Attribute: Replace substitution variables',
'        -- (including column values of the current row)',
'        l_link := apex_plugin_util.replace_substitutions(',
'                      p_value => p_region.attribute_01 );',
'        ...',
'',
'        apex_plugin_util.clear_component_values;',
'    exception when others then',
'        apex_plugin_util.clear_component_values;',
'        raise;',
'    end;',
'end loop;',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(27903303099734563)
,p_name=>'P4410_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(27899611028734555)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(27903506683734563)
,p_name=>'P4410_DISPLAY_NAME'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(27899611028734555)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>'DISPLAY_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The name of your plug-in.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(27905505067734569)
,p_name=>'P4410_PLSQL_CODE'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(27899831305734555)
,p_use_cache_before_default=>'NO'
,p_prompt=>'PL/SQL Code'
,p_source=>'PLSQL_CODE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>25
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a PL/SQL anonymous block of code that contains function for rendering, validating, execution and Ajax callbacks for the plug-in.</p>',
'',
'<p>For performance reasons you can also store this code in a PL/SQL package in the database.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PLSQL_FUNCTIONS'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(27906008506734569)
,p_name=>'P4410_PLUGIN_COMMENT'
,p_item_sequence=>390
,p_item_plug_id=>wwv_flow_imp.id(27900213448734557)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comments'
,p_source=>'PLUGIN_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'<p>Enter any comments or notes here.  These comments will never be displayed when running the application.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(27912623836772078)
,p_name=>'P4410_NAME'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(27899611028734555)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Internal Name'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>40
,p_read_only_when=>'P4410_IS_IN_USE'
,p_read_only_when2=>'Y'
,p_read_only_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter an internal name for the plug-in. The internal name is used internally by &PRODUCT_NAME. for identifying the plug-in, and is not displayed. The internal name must be unique to your current application.</p>',
'',
'<p>It is recommended that your organization domain name be used as a prefix to plug-in names, to create a globally unique name. For example: a domain name of "mycompany.com" prefixed to an Item Type plug-in named ''Slider'', would result in an internal'
||' name like the following: <code>COM.MYCOMPANY.SLIDER</code></p>',
'',
'<p>The internal name of a Template Component type plug-in as part of a theme will always be prefixed with "THEME$": <code>THEME$COM.MYCOMPANY.BADGE</code>.',
'Use this internal name to apply a Template Component manually where server-side template directives are supported.',
'<pre><code>',
'{with/}',
'MY_ARGUMENT:=foo',
'{apply THEME$COM.MYCOMPANY.BADGE/}    ',
'</code></pre>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(27932030733896986)
,p_name=>'P4410_VERSION_IDENTIFIER'
,p_item_sequence=>360
,p_item_plug_id=>wwv_flow_imp.id(27901032534734559)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Version'
,p_source=>'VERSION_IDENTIFIER'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>30
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'String to identify the version of the plug-in.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(27932216666902439)
,p_name=>'P4410_ABOUT_URL'
,p_item_sequence=>370
,p_item_plug_id=>wwv_flow_imp.id(27901032534734559)
,p_use_cache_before_default=>'NO'
,p_prompt=>'About URL'
,p_source=>'ABOUT_URL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'URL to the plug-in author''s homepage or to additional documentation about the plug-in.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(27936619062026066)
,p_name=>'P4410_IMAGE_PREFIX'
,p_item_sequence=>350
,p_item_plug_id=>wwv_flow_imp.id(29873113508481210)
,p_use_cache_before_default=>'NO'
,p_prompt=>'File Prefix'
,p_source=>'IMAGE_PREFIX'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Determines the virtual path the Web server uses to point to the files of the plug-in.</p>',
'',
'<p>Do not specify anything to reference files which are stored with your plug-in definition in the database.</p>',
'',
'<p>For performance reasons you can also store your plug-in files on your Web Server. Use <code>&#35;APEX_FILES&#35;</code> or any valid URL to reference them.</p>',
'',
'<p>Examples:',
'<ul>',
'  <li>/myFiles/</li>',
'  <li>http://example.com/myFiles/</li>',
'  <li>&#35;APEX_FILES&#35;myFiles/</li>',
'</li>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(27936921271036180)
,p_name=>'P4410_RENDER_FUNCTION'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(27935931959010930)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Render Procedure/Function Name'
,p_source=>'RENDER_FUNCTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the name of the PL/SQL procedure/function to be called to render the plug-in. It can reference a procedure or function of the anonymous PL/SQL code block, a package procedure or function, or stand alone procedure or function in the database.'
||' For example:',
'<pre>',
'render_slider',
'</pre></p>',
'',
'<p>When referencing a database PL/SQL package or stand alone procedure/function, you can use the <code>#OWNER#</code> substitution string to reference the parsing schema of the current application. For example:',
'<pre>',
'#OWNER#.render_slider',
'</pre></p>',
'',
'<p>Item Type Plug-in Render Procedures must implement the following interface:',
'',
'<pre>',
'procedure &lt;name of procedure&gt; (',
'    p_item   in            apex_plugin.t_item,',
'    p_plugin in            apex_plugin.t_plugin,',
'    p_param  in            apex_plugin.t_item_render_param,',
'    p_result in out nocopy apex_plugin.t_item_render_result )',
'</pre>',
'</p>',
'',
'<p>Region Type Plug-in Render Procedures must implement the following interface:',
'',
'<pre>',
'procedure &lt;name of procedure&gt; (',
'    p_plugin in            apex_plugin.t_plugin,',
'    p_region in            apex_plugin.t_region,',
'    p_param  in            apex_plugin.t_region_render_param,',
'    p_result in out nocopy apex_plugin.t_region_render_result )',
'</pre>',
'</p>',
'',
'<p>Dynamic Action Plug-in Render Functions must implement the following interface:',
'',
'<pre>',
'function &lt;name of function&gt; (',
'    p_dynamic_action in apex_plugin.t_dynamic_action,',
'    p_plugin         in apex_plugin.t_plugin )',
'    return apex_plugin.t_dynamic_action_render_result',
'</pre>',
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(27937216900044386)
,p_name=>'P4410_AJAX_FUNCTION'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(27935931959010930)
,p_use_cache_before_default=>'NO'
,p_prompt=>'AJAX Procedure/Function Name'
,p_source=>'AJAX_FUNCTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the name of the PL/SQL procedure/function used by the plug-in to load additional data with an Ajax call. It can reference a procedure or function of the anonymous PL/SQL code block, a package procedure or function, or stand alone procedure o'
||'r function in the database. For example:',
'<pre>',
'ajax_slider',
'</pre></p>',
'',
'<p>When referencing a database PL/SQL package or stand alone procedure or function, you can use the <code>#OWNER#</code> substitution string to reference the parsing schema of the current application. For example:',
'<pre>',
'#OWNER#.ajax_slider',
'</pre></p>',
'',
'<p>The Ajax Procedure callback behaves the same way as an Ajax callback process and can access the generic <code>apex_application.g_x01 - g_x10</code> global variables to transfer data from the browser to the back end. It can also read and set sessio'
||'n state as an Ajax callback process does.</p>',
'',
'<p>To call the Ajax callback function from Javascript, use the same technique as used for Ajax callback processes. Instead of <code>APPLICATION_PROCESS=[process name]</code> use <code>PLUGIN=[p_ajax_identifier]</code>, where p_ajax_identifier is the '
||'value generated with the apex_plugin.get_ajax_identifier function in the render function.</p>',
'',
'<p>Item Type Plug-in Ajax Procedures must implement the following interface:',
'',
'<pre>',
'procedure &lt;name of procedure&gt; (',
'    p_item   in            apex_plugin.t_item,',
'    p_plugin in            apex_plugin.t_plugin,',
'    p_param  in            apex_plugin.t_item_ajax_param,',
'    p_result in out nocopy apex_plugin.t_item_ajax_result )',
'</pre>',
'</p>',
'',
'<p>Region Type Plug-in Ajax Procedures must implement the following interface:',
'',
'<pre>',
'procedure &lt;name of procedure&gt; (',
'    p_plugin in            apex_plugin.t_plugin,',
'    p_region in            apex_plugin.t_region,',
'    p_param  in            apex_plugin.t_region_ajax_param,',
'    p_result in out nocopy apex_plugin.t_region_ajax_result )',
'</pre>',
'</p>',
'',
'<p>Dynamic Action Plug-in Ajax Functions must implement the following interface:',
'',
'<pre>',
'function &lt;name of function&gt; (',
'    p_dynamic_action in apex_plugin.t_dynamic_action,',
'    p_plugin         in apex_plugin.t_plugin )',
'    return apex_plugin.t_dynamic_action_ajax_result',
'</pre>',
'</p>',
'',
'',
'<p>Authentication Scheme Plug-in Ajax Functions must implement the following interface:',
'',
'<pre>',
'function &lt;name of function&gt; (',
'    p_authentication in apex_plugin.t_authentication,',
'    p_plugin         in apex_plugin.t_plugin )',
'    return apex_plugin.t_authentication_ajax_result',
'</pre>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(27937500062049023)
,p_name=>'P4410_VALIDATION_FUNCTION'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(27935931959010930)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Validation Procedure Name'
,p_source=>'VALIDATION_FUNCTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the name of the PL/SQL procedure the plug-in can use to perform basic validations on the submitted data. It can reference a procedure of the anonymous PL/SQL code block, a package procedure or a stand alone procedure in the database. For exa'
||'mple:',
'<pre>',
'validate_slider',
'</pre></p>',
'',
'<p>When referencing a database PL/SQL package or stand alone procedure, you can use the <code>#OWNER#</code> substitution string to reference the parsing schema of the current application. For example:',
'<pre>',
'#OWNER#.validate_slider',
'</pre></p>',
'',
'<p>The Validation Procedure callback is called after the basic checks performed by &PRODUCT_NAME. and before the user defined validations are processed. Use the <em>#LABEL#</em> placeholder in your error message if you want to get the current label o'
||'f the page item. If <code>message</code> contains a value after the call, the message will be displayed in the <em>Default Error Display Location</em> defined on application level. To overwrite the default location, <code>display_location</code> can '
||'contain one of the constant values defined in <code>apex_plugin</code>. If you want to show the error at a page item that is different than the current processed one, set <code>page_item_name</code> to the name of that page item.</p> ',
'',
'<p>Item Type Plug-in Validation Procedure must implement the following interface:',
'',
'<pre>',
'procedure &lt;name of procedure&gt; (',
'    p_item   in            apex_plugin.t_item,',
'    p_plugin in            apex_plugin.t_plugin,',
'    p_param  in            apex_plugin.t_item_validation_param,',
'    p_result in out nocopy apex_plugin.t_item_validation_result )',
'</pre>',
'</p>',
'',
'<p>Region Type Plug-ins do not support validation functions.</p>',
'',
'<p>Dynamic Action Plug-ins do not support validation functions.</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(27941328817186038)
,p_name=>'P4410_RETURN_TO_PAGE'
,p_item_sequence=>400
,p_item_plug_id=>wwv_flow_imp.id(27941016095186035)
,p_prompt=>'Stay on page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_display_when=>'P4410_ID'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_read_only_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_help_text=>'Select this checkbox to stay on this page after applying changes.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'YES'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28059502690081686)
,p_name=>'P4410_IS_IN_USE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(27899611028734555)
,p_prompt=>'Is In Use'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>1
,p_cMaxlength=>1
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28080920238928776)
,p_name=>'P4410_FLOW_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(27899611028734555)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Flow Id'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28102822026383415)
,p_name=>'P4410_CHECK_PLSQL_CODE'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(27899831305734555)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Do not validate code (parse code at runtime only).'
,p_source=>'NULL'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'NO'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28184221546490809)
,p_name=>'P4410_PLUGIN_TYPE'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(27899611028734555)
,p_use_cache_before_default=>'NO'
,p_item_default=>'TEMPLATE COMPONENT'
,p_prompt=>'Type'
,p_source=>'PLUGIN_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PLUGIN.TYPE'
,p_lov=>'.'||wwv_flow_imp.id(32850007287563326)||'.'
,p_cHeight=>1
,p_read_only_when=>':P4410_IS_IN_USE = ''Y'' or :P4410_THEME_ID is not null'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Defines the type of component that can use this plug-in.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(32723128238376948)
,p_name=>'P4410_REFERENCE_ID'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(33340707031647637)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Subscribe From'
,p_source=>'REFERENCE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FLOW_SUBSCRIBE_FROM_PLUGINS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case when p.security_group_id in ( 11, 12 ) ',
'       then wwv_flow_lang.system_message( ''SUBSCRIBED_FROM.THEME_REPOSITORY'' )',
'       else to_char( p.flow_id )',
'       end ||'' : ''||p.display_name || ',
'       case when p.theme_id is not null',
'       then '' '' || wwv_flow_lang.system_message( ''THEME.THEME_ID_POSTFIX'', p0 => p.theme_id )',
'       end as d,',
'       p.id as r',
'  from wwv_flow_plugins p,',
'       wwv_main_apps_dev f',
' where ( (    p.flow_id != to_number(:FB_FLOW_ID)',
'          and p.theme_id is null',
'          and :P4410_THEME_ID is null )',
'        or ( p.theme_id is not null',
'          and :P4410_THEME_ID is not null',
'          and p.id != :P4410_ID ) )',
'   and p.security_group_id in ( to_number(:WORKSPACE_ID), 11, 12 )',
'   and f.id                = p.flow_id',
'   and f.build_status     not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- no plug-in -'
,p_lov_cascade_parent_items=>'P4410_THEME_ID'
,p_ajax_optimize_refresh=>'N'
,p_cSize=>50
,p_cMaxlength=>2000
,p_read_only_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'<p>Use this field to base this plug-in on an existing plug-in in this application or another application in your workspace.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(46889517103170172)
,p_name=>'P4410_HELP_TEXT'
,p_item_sequence=>380
,p_item_plug_id=>wwv_flow_imp.id(46888818357161021)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Help Text'
,p_source=>'HELP_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>8
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'<p>Specify help text for this plug-in. The help text is used by the users of the plug-in to understand how it works.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(331874103528635393)
,p_name=>'P4410_SESSION_SENTRY_FUNCTION'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(27935931959010930)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Session Sentry Function Name'
,p_source=>'SESSION_SENTRY_FUNCTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the name of the PL/SQL function the plug-in can use to perform the session sentry verification. It can reference a function of the anonymous PL/SQL code block, a package function or a stand alone function in the database. For example:',
'<pre>',
'check_ldap_session_sentry',
'</pre></p>',
'',
'<p>When referencing a database PL/SQL package or stand alone function, you can use the <code>#OWNER#</code> substitution string to reference the parsing schema of the current application. For example:',
'<pre>',
'#OWNER#.check_ldap_session_sentry',
'</pre></p>',
'',
'<p>Session Sentry Functions must implement the following interface:',
'',
'<pre>',
'function &lt;name of function&gt; (',
'    p_authentication in apex_plugin.t_authentication,',
'    p_plugin         in apex_plugin.t_plugin,',
'    p_is_public_page in boolean )',
'    return apex_plugin.t_authentication_sentry_result',
'</pre>',
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(331889920151640177)
,p_name=>'P4410_AUTHENTICATION_FUNCTION'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(27935931959010930)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Authentication Function Name'
,p_source=>'AUTHENTICATION_FUNCTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the name of the PL/SQL function the plug-in can use to perform the verification of the entered user credentials. It can reference a function of the anonymous PL/SQL code block, a package function or a stand alone function in the database. Fo'
||'r example:',
'<pre>',
'authenticate_ldap',
'</pre></p>',
'',
'<p>When referencing a database PL/SQL package or stand alone function, you can use the <code>#OWNER#</code> substitution string to reference the parsing schema of the current application. For example:',
'<pre>',
'#OWNER#.authenticate_ldap',
'</pre></p>',
'',
'<p>Authentication Functions must implement the following interface:',
'',
'<pre>',
'function &lt;name of function&gt; (',
'    p_authentication in apex_plugin.t_authentication,',
'    p_plugin         in apex_plugin.t_plugin,',
'    p_password       in varchar2 )',
'    return apex_plugin.t_authentication_auth_result',
'</pre>',
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(331906101235644222)
,p_name=>'P4410_POST_LOGOUT_FUNCTION'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(27935931959010930)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Post Logout Function Name'
,p_source=>'POST_LOGOUT_FUNCTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the name of the PL/SQL function the plug-in calls after &PRODUCT_NAME. has terminated the current session. Use this function to logout from other systems like a Single Sign-On sever.</p>',
'<p>It can reference a function of the anonymous PL/SQL code block, a package function or a stand alone function in the database. For example:',
'<pre>',
'logout_sso',
'</pre></p>',
'',
'<p>When referencing a database PL/SQL package or stand alone function, you can use the <code>#OWNER#</code> substitution string to reference the parsing schema of the current application. For example:',
'<pre>',
'#OWNER#.logout_sso',
'</pre></p>',
'',
'<p>Post Logout Functions must implement the following interface:',
'',
'<pre>',
'function &lt;name of function&gt; (',
'    p_authentication in apex_plugin.t_authentication,',
'    p_plugin         in apex_plugin.t_plugin )',
'    return apex_plugin.t_authentication_logout_result',
'</pre>',
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(332034113880685678)
,p_name=>'P4410_AUTHENTCATION_ATTRIBUTES'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_imp.id(439386704233826730)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Attributes:'
,p_source=>'P4410_STANDARD_ATTRIBUTES'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PLUGIN.AUTHENTICATION_ATTRIBUTES'
,p_lov=>'.'||wwv_flow_imp.id(332110302021701175)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'For Authentication Scheme type plug-ins, identify the attributes that apply to this plug-in:',
'</p>',
'<p>',
'<ul>',
'    <li>Has Session not Valid Attribute - The Stop Execution on Error field is available for the action.</li>',
'    <li>Has Login Page In Application - Users logs in via a page of this application.</li>',
'</ul>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(366692012369682701)
,p_name=>'P4410_PROCESS_ATTRIBUTES'
,p_item_sequence=>300
,p_item_plug_id=>wwv_flow_imp.id(439386704233826730)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Attributes:'
,p_source=>'P4410_STANDARD_ATTRIBUTES'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PLUGIN.PROCESS_ATTRIBUTES'
,p_lov=>'.'||wwv_flow_imp.id(366693502933776161)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    <p>',
'For Process type plug-ins, check the following to enable options as described here:',
'</p>',
'<p>',
'<ul>',
'    <li>Region - If checked allows to run a process for each row of a tabular form.</li>',
'    <li>Region Required - This attribute makes the region a required value.</li>',
'    <li>Wait For Completion - This attribute indicates that the process is being used as a Workflow Activity and the Workflow will wait for the completion of the process.</li>',
'</ul>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(366988906394505193)
,p_name=>'P4410_IS_DEPRECATED'
,p_is_required=>true
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(27899611028734555)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Deprecated'
,p_source=>'IS_DEPRECATED'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>'FB_FLOW_ID'
,p_display_when2=>'4411'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(392528513648169636)
,p_name=>'P4410_INVALID_SESSION_FUNCTION'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(27935931959010930)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Invalid Session Function Name'
,p_source=>'INVALID_SESSION_FUNCTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the name of the PL/SQL function the plug-in calls if an invalid session has been detected. Use this function to call for example a Single Sign-On sever.</p>',
'<p>It can reference a function of the anonymous PL/SQL code block, a package function or a stand alone function in the database. For example:',
'<pre>',
'invalid_sso_session',
'</pre></p>',
'',
'<p>When referencing a database PL/SQL package or stand alone function, you can use the <code>#OWNER#</code> substitution string to reference the parsing schema of the current application. For example:',
'<pre>',
'#OWNER#.invalid_sso_session',
'</pre></p>',
'',
'<p>Invalid Session Functions must implement the following interface:',
'',
'<pre>',
'function &lt;name of function&gt; (',
'    p_authentication in apex_plugin.t_authentication,',
'    p_plugin         in apex_plugin.t_plugin )',
'    return apex_plugin.t_authentication_inval_result',
'</pre>',
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(437419030769408004)
,p_name=>'P4410_ATTRIBUTE_ID'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(27899611028734555)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(437441631957919189)
,p_name=>'P4410_FILE_ID'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(27899611028734555)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(437472122129256922)
,p_name=>'P4410_PLUGIN_DISPLAY_NAME'
,p_item_sequence=>410
,p_item_plug_id=>wwv_flow_imp.id(27900816654734558)
,p_use_cache_before_default=>'NO'
,p_source=>'P4410_DISPLAY_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Current plug-in.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(439387710252837916)
,p_name=>'P4410_PAGE_ITEM_ATTRIBUTES'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_imp.id(439386704233826730)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Attributes:'
,p_source=>'P4410_STANDARD_ATTRIBUTES'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PLUGIN.ITEM_ATTRIBUTES'
,p_lov=>'.'||wwv_flow_imp.id(439387913761867364)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'For Item type plug-ins, identify the attributes that apply to this plug-in.',
'</p>',
'<p>',
'To learn about the attributes that apply to Item type plug-ins, read the documentation in Section <strong>Standard Attributes for Item Type Plug-ins</strong> under the topic <strong>Creating Plug-ins</strong> in the App Builder User''s Guide.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(439396713209952288)
,p_name=>'P4410_REGION_ATTRIBUTES'
,p_item_sequence=>260
,p_item_plug_id=>wwv_flow_imp.id(439386704233826730)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Attributes:'
,p_source=>'P4410_STANDARD_ATTRIBUTES'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PLUGIN.REGION_ATTRIBUTES'
,p_lov=>'.'||wwv_flow_imp.id(439394121736945367)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'For Region type plug-ins, check the following to enable options as described here:',
'</p>',
'<p>',
'<ul>',
'<li>Region Source is SQL Statement - The region source is a SQL Statement. When checked, a minimum and a maximum number of columns the query can return can be specified and SQL Examples display to help the user.</li>',
'<li>Region Source is Plain Text - The region source is plain text.</li>',
'<li>Region Source Required - If region source is a SQL Statement, this attribute makes this a required value.</li>',
'<li>Has "Page Items to Submit" Attribute - If region source is a SQL Statement, this attribute allows to specify those page items which should be set in session state when executing an Ajax call for that region.</li>',
'<li>Has "Number of Fetched Rows" Attribute - The region has the Number of Fetched Rows fields in the Advanced section when the region is edited.</li>',
'<li>Has "No Data Found Message" Attribute - The region has the No Data Found Message field in the Advanced section when the region is edited.</li>',
'<li>Has "Escape Special Characters" Attribute -  The region has the Escape Special Characters field in the Security section when the region is edited.</li>',
'<li>Has "Region Columns" - The region allows to specify additional custom attributes for each column of the region source SQL statement.</li>',
'<li>Has "Heading" Column Attribute - Region columns have the Heading field in the Heading section when the column is edited.</li>',
'<li>Has "Heading Alignment" Column Attribute - Region columns have the Alignment field in the Heading section when the column is edited.</li>',
'<li>Has "Alignment" Column Attribute - Region columns have the Column Alignment field in the Layout section when the column is edited.</li>',
'<li>Has "CSS Classes" Column Attribute - Region columns have the CSS Classes field in the Appearance section when the column is edited.</li>',
'<li>Has "Custom Attributes" Column Attribute - Region columns have the Custom Attributes field in the Advanced section when the column is edited.</li>',
'<li>Has "Escape Special Characters" Column Attribute - Region columns have the Escape Special Characters field in the Security section when the column is edited.</li>',
'<li>Has "Initialization JavaScript Code" Attribute - The Initialization JavaScript Code field is available for the action.</li>',
'<li>Supports Faceted Search / Smart Filters - The region can be connected to a Faceted Search or Smart Filters region. "Region Source is SQL Statement" is required.</li>',
'</ul>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(439400226200993952)
,p_name=>'P4410_DYNAMIC_ACTIN_ATTRIBUTES'
,p_item_sequence=>270
,p_item_plug_id=>wwv_flow_imp.id(439386704233826730)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Attributes:'
,p_source=>'P4410_STANDARD_ATTRIBUTES'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PLUGIN.DYNAMIC_ACTION_ATTRIBUTES'
,p_lov=>'.'||wwv_flow_imp.id(439399613733990280)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'For Dynamic Action type plug-ins, identify the attributes that apply to this plug-in:',
'</p>',
'<p>',
'<ul>',
'<li>For Item(s) - The dynamic action supports selection of items as the affected elements.</li>',
'<li>For Button - The dynamic action supports selection of a button as the affected element.</li>',
'<li>For Region - The dynamic action supports selection of a region as the affected element.</li>',
'<li>For jQuery Selector - The dynamic action supports specifying a jQuery selector as the affected elements.</li>',
'<li>For JavaScript Expression - The dynamic action supports specifying a JavaScript Expression as the affected elements.</li>',
'<li>For Triggering Element - The dynamic action supports selection of the triggering element as the affected element.</li>',
'<li>For Event Source - The dynamic action supports selection of your event source as the affected elements.</li>',
'<li>Affected Element Required - The dynamic action requires an affected element to be specified.</li>',
'<li>Check "Fire on Initialization" - Defines the default value for the action''s Fire on Initialization field.</li>',
'<li>Has "Stop Execution on Error" Attribute - The Stop Execution on Error field is available for the action.</li>',
'<li>Has "Wait For Result" Attribute - The Wait For Result field is available for the action.</li>',
'<li>Has "Initialization JavaScript Code" Attribute - The Initialization JavaScript Code field is available for the action.</li>    ',
'</ul>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(439423826798637462)
,p_name=>'P4410_STANDARD_ATTRIBUTES'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_imp.id(439386704233826730)
,p_use_cache_before_default=>'NO'
,p_source=>'STANDARD_ATTRIBUTES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(471055523670047848)
,p_name=>'P4410_EXECUTION_FUNCTION'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(27935931959010930)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Execution Function Name'
,p_source=>'EXECUTION_FUNCTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the name of the PL/SQL function to be called to execute the plug-in. It can reference a function of the anonymous PL/SQL code block, a package function or stand alone function in the database. For example:',
'<pre>',
'execute_email',
'</pre></p>',
'',
'<p>When referencing a database PL/SQL package or stand alone function, you can use the <code>#OWNER#</code> substitution string to reference the parsing schema of the current application. For example:',
'<pre>',
'#OWNER#.execute_email',
'</pre></p>',
'',
'<p>Process Type Plug-in Execution Functions must implement the following interface:',
'',
'<pre>',
'function &lt;name of function&gt; (',
'    p_process in apex_plugin.t_process,',
'    p_plugin  in apex_plugin.t_plugin )',
'    return apex_plugin.t_process_exec_result',
'</pre>',
'</p>',
'',
'<p>Authorization Type Plug-in Execution Functions must implement the following interface:',
'',
'<pre>',
'function &lt;name of function&gt; (',
'    p_authorization in apex_plugin.t_authorization,',
'    p_plugin        in apex_plugin.t_plugin )',
'    return apex_plugin.t_authorization_exec_result',
'</pre>',
'</p>',
'',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(492593534398392048)
,p_name=>'P4410_IS_QUICK_PICK'
,p_is_required=>true
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(27899611028734555)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Quick Pick'
,p_source=>'IS_QUICK_PICK'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specifies if this plug-in is listed in the Quick Pick Select List.</p>',
'<p>To display the Template Component plug-in in the Create Page wizard, quick pick has to be <strong>On</strong> and Custom Attributes have to have demo values set.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(502499335047935711)
,p_name=>'P4410_ITEM_COMPONENT_TYPES'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(5261005290655272)
,p_item_default=>'APEX_APPLICATION_PAGE_ITEMS:APEX_APPL_PAGE_IG_COLUMNS'
,p_prompt=>'Component Type'
,p_source=>'P4410_SUPPORTED_COMP_TYPES'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PLUGIN_ITEM_TYPE_COMPONENT_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(513667640463524657)||'.'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specifies if the plug-in is displayed in the Builder as a supported component for Page Items, Interactive Grid Columns and Facets.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(502499417457935712)
,p_name=>'P4410_SUPPORTED_COMP_TYPES'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(5261005290655272)
,p_use_cache_before_default=>'NO'
,p_source=>'SUPPORTED_COMPONENT_TYPES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(573060960895794186)
,p_name=>'P4410_JAVASCRIPT_FILE_URLS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(538625467201238345)
,p_use_cache_before_default=>'NO'
,p_prompt=>'JavaScript'
,p_source=>'JAVASCRIPT_FILE_URLS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>3
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter JavaScript file URLs for code to be loaded with this plug-in. Each URL has to be written on a new line. If you provide a minified version of your file you can use the substitution string <code>#MIN#</code> to include <code>.min</code>, or <c'
||'ode>#MIN_DIRECTORY#</code> to include <code>minified/</code> in your file URL for a regular page view, and an empty string if the page is viewed in debug mode. You also have access to the substitution string <code>#PLUGIN_FILES#</code> to substitute '
||'the value of the plug-in''s file prefix.</p>',
'',
'<p>JavaScript file URLs you enter here will be emitted within the <code>#GENERATED_JAVASCRIPT#</code> substitution string in the page template.</p>',
'',
'<p>Note: You do not need to include opening or closing <code>script</code> tags, just the file URL.',
'',
'<p>',
'Examples:',
'<ul>',
'  <li>Standard file reference',
'      <pre>#PLUGIN_FILES#main.js</pre>',
'  </li>',
'  <li>Standard file reference which loads the minified file main.min.js from #PLUGIN_FILES#minified/ for regular page views and main.js from #PLUGIN_FILES# in debug mode.',
'      <pre>#PLUGIN_FILES##MIN_DIRECTORY#main#MIN#.js</pre>',
'  </li>',
'  <li>Use this syntax if the library is also used from a RequireJS require call. The define name must match what is used in the requirejs.config paths and the value must be the global symbol exposed by the library. Only applies when using RequireJS. '
||'This avoids RequireJS  loading that library a second time.',
'      <pre>[define hammerjs=Hammer]/myjs/hammer.js</pre>',
'  </li>',
'  <li>Use this syntax if the file has a dependency on Oracle JET. This will automatically load RequireJS, the Oracle JET RequireJS configuration and the JET common module bundle before this file.',
'      <pre>[require jet]/myjs/main.js</pre>',
'  </li>',
'  <li>Use this syntax if the file has a dependency on RequireJS. This will automatically load RequireJS before this file.',
'      <pre>[require requirejs]/myjs/main.js</pre>',
'  </li>',
'</ul>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(573061496548800093)
,p_name=>'P4410_CSS_FILE_URLS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(538625467201238345)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Cascading Style Sheet'
,p_source=>'CSS_FILE_URLS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>3
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter Cascading Style Sheet file URLs to be loaded with this plug-in. Each URL has to be written on a new line. If you provide a minified version of your file you can use the substitution string <code>#MIN#</code> to include <code>.min</code>, or '
||'<code>#MIN_DIRECTORY#</code> to include <code>minified/</code> in your file URL for a regular page view, and an empty string if the page is viewed in debug mode. You also have access to the substitution string <code>#PLUGIN_FILES#</code> to substitut'
||'e with the value of the plug-in''s file prefix.</p>',
'',
'<p>File URLs you enter here will be emitted within the <code>#APEX_CSS#</code> substitution string in the page template.</p>',
'',
'<p>Note: You do not need to include opening or closing <code>link</code> tags, just the file URL.</p>',
'',
'<p>',
'Examples:',
'<ul>',
'  <li>Standard file reference',
'      <pre>#PLUGIN_FILES#main.css</pre>',
'  </li>',
'  <li>Standard file reference which loads the minified file main.min.css from #PLUGIN_FILES#minified/ for regular page views and main.css from #PLUGIN_FILES# in debug mode.',
'      <pre>#PLUGIN_FILES##MIN_DIRECTORY#main#MIN#.css</pre>',
'  </li>',
'  <li>Conditional media query',
'      <pre>[media="only screen and (max-device-width: 480px)"]#PLUGIN_FILES#smartphone.css</pre>',
'  </li>',
'</ul>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(579718874159783420)
,p_name=>'P4410_IS_LEGACY'
,p_is_required=>true
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(27899611028734555)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Legacy'
,p_source=>'IS_LEGACY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>'FB_FLOW_ID'
,p_display_when2=>'4411'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(626801217275300456)
,p_name=>'P4410_CATEGORY'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(27899611028734555)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Category'
,p_source=>'CATEGORY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PLUGIN.CATEGORY'
,p_lov=>'.'||wwv_flow_imp.id(626799404677287430)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Category -'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Specifies under which category the plug-in will be displayed in the UI.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1587735358919175023)
,p_name=>'P4410_META_DATA_FUNCTION'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(27935931959010930)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Meta Data Procedure Name'
,p_source=>'META_DATA_FUNCTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the name of the PL/SQL procedure to be called to get dynamic meta data about the plug-in. It can reference a procedure of the anonymous PL/SQL code block, a package procedure or stand alone procedure in the database. For example:',
'<pre>',
'meta_data_slider',
'</pre></p>',
'',
'<p>When referencing a database PL/SQL package or stand alone procedure, you can use the <code>#OWNER#</code> substitution string to reference the parsing schema of the current application. For example:',
'<pre>',
'#OWNER#.meta_data_slider',
'</pre></p>',
'',
'<p>Item Type Plug-in Meta Data Procedures must implement the following interface:',
'',
'<pre>',
'procedure &lt;name of procedure&gt; (',
'    p_item   in            apex_plugin.t_item,',
'    p_plugin in            apex_plugin.t_plugin,',
'    p_param  in            apex_plugin.t_item_meta_data_param,',
'    p_result in out nocopy apex_plugin.t_item_meta_data_result )',
'</pre>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1587735477451175024)
,p_name=>'P4410_API_VERSION_ITEM'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(27935931959010930)
,p_use_cache_before_default=>'NO'
,p_item_default=>'2'
,p_prompt=>'API Interface'
,p_source=>'P4410_API_VERSION'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'PLUGIN_API_VERSION_ITEM'
,p_lov=>'.'||wwv_flow_imp.id(2202155239931633)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify if the item type plug-in uses the deprecated FUNCTION based APIs to call the plug-in callbacks or if it uses the new PROCEDURE based APIs. Note: In order for an item type plug-in to support Interactive Grid Columns, it must implement the PROC'
||'EDURE based APIs.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1418103627012519)
,p_computation_sequence=>10
,p_computation_item=>'P4410_SUBSCRIBED_COMP_GRP'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_component_group_dev.is_part_of_subscribed_comp_grp (',
'    p_component_id   => :P4410_ID,',
'    p_component_type => wwv_flow_copy_metadata.c_plugin,',
'    p_app_id         => :FB_FLOW_ID )'))
,p_compute_when=>'P4410_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(28060022823115846)
,p_computation_sequence=>10
,p_computation_item=>'P4410_IS_IN_USE'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'case when wwv_flow_plugin_dev.is_in_use(:P4410_ID) then ''Y'' end'
,p_compute_when=>'P4410_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(7473577005849717)
,p_computation_sequence=>10
,p_computation_item=>'P4410_ID'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_id.next_val'
,p_computation_comment=>'We are using DML on a view with instead of trigger, and the RETURNING clause does not work any more.'
,p_compute_when=>'P4410_ID'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1580179561039736504)
,p_computation_sequence=>20
,p_computation_item=>'P4410_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper( :P4410_NAME )'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(48633209198507489)
,p_computation_sequence=>30
,p_computation_item=>'P4410_REFERENCE_ID'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'null'
,p_compute_when=>'P4410_REFERENCE_ID'
,p_compute_when_text=>'undefined'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(491906922347677938)
,p_computation_sequence=>40
,p_computation_item=>'P4410_VERSION_IDENTIFIER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'1.0'
,p_compute_when=>':REQUEST = ''CREATE'' and :P4410_VERSION_IDENTIFIER is null'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(492593632308392049)
,p_computation_sequence=>50
,p_computation_item=>'P4410_IS_QUICK_PICK'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'N'
,p_compute_when=>'P4410_IS_QUICK_PICK'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(366989218243514982)
,p_computation_sequence=>60
,p_computation_item=>'P4410_IS_DEPRECATED'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'N'
,p_compute_when=>'P4410_IS_DEPRECATED'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(579718925674783421)
,p_computation_sequence=>70
,p_computation_item=>'P4410_IS_LEGACY'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'N'
,p_compute_when=>'P4410_IS_LEGACY'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2831469514618416)
,p_computation_sequence=>80
,p_computation_item=>'P4410_TRANSLATE_THIS_TEMPLATE'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'N'
,p_compute_when=>'P4410_TRANSLATE_THIS_TEMPLATE'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(4008645717534236)
,p_computation_sequence=>90
,p_computation_item=>'P4410_TEMPLATE_COMP_ATTRIBUTES'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P4410_TEMPLATE_COMP_ATTRIBUTES || ',
'case',
'  when  instr( :P4410_PARTIAL_TEMPLATE || :P4410_REPORT_ROW_TEMPLATE, ''#APEX$SELECTOR#'' ) > 0',
'    and instr( nvl( :P4410_TEMPLATE_COMP_ATTRIBUTES, ''x'' ), ''ROW_SELECTION'' ) = 0',
'  then',
'    case when :P4410_TEMPLATE_COMP_ATTRIBUTES is not null then '':'' end || ''ROW_SELECTION''',
'end'))
,p_compute_when=>'P4410_PLUGIN_TYPE'
,p_compute_when_text=>'TEMPLATE COMPONENT'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(28102505057378500)
,p_validation_name=>'check PL/SQL syntax'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_f4000_util.check_plsql (',
'           p_sql               => ''declare''||chr(10)||:P4410_PLSQL_CODE||chr(10)||''begin null; end;'',',
'           p_flow_id           => :P4410_FLOW_ID,',
'           p_security_group_id => :WORKSPACE_ID );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'nvl(:P4410_CHECK_PLSQL_CODE, ''YES'') = ''YES'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(27905505067734569)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(27946303815296046)
,p_validation_name=>'Still in use?'
,p_validation_sequence=>20
,p_validation=>'wwv_flow_plugin_dev.is_in_use(:P4410_ID) = false'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Plug-in is still in use! Use the Utilization link in Tasks to edit this occurrences before you delete the plug-in.'
,p_when_button_pressed=>wwv_flow_imp.id(27903106352734562)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(626801810480307940)
,p_validation_name=>'P4410_CATEGORY is not null if Dynamic Action'
,p_validation_sequence=>30
,p_validation=>'P4410_CATEGORY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P4410_PLUGIN_TYPE'
,p_validation_condition2=>'DYNAMIC ACTION'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(626801217275300456)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(20207954971136502)
,p_validation_name=>'P4410_PARTIAL_TEMPLATE is not null'
,p_validation_sequence=>70
,p_validation=>'P4410_PARTIAL_TEMPLATE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>'P4410_PLUGIN_TYPE'
,p_validation_condition2=>'TEMPLATE COMPONENT'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(9813514314144420)
,p_validation_name=>'Valid Partial Template'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_template_directive.validate_template(',
'    p_template          => :P4410_PARTIAL_TEMPLATE,',
'    p_application_id    => :FB_FLOW_ID );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P4410_PLUGIN_TYPE'
,p_validation_condition2=>'TEMPLATE COMPONENT'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(9811750713144402)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1921206400465818)
,p_validation_name=>'Report Body Template is not null'
,p_validation_sequence=>90
,p_validation=>'P4410_REPORT_BODY_TEMPLATE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>':P4410_PLUGIN_TYPE = ''TEMPLATE COMPONENT'' and :P4410_TMPL_COMPONENT_TYPES like ''%REPORT%'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(2003612747458832)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1921480877465820)
,p_validation_name=>'Report Body Template - required placeholders'
,p_validation_sequence=>100
,p_validation=>'instr( :P4410_REPORT_BODY_TEMPLATE, ''#APEX$ROWS#'' ) > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'#LABEL# must contain <strong>APEX$ROWS</strong> placeholder.'
,p_validation_condition=>'P4410_REPORT_BODY_TEMPLATE'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_imp.id(2003612747458832)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2003821586458834)
,p_validation_name=>'Valid Report Body Template'
,p_validation_sequence=>120
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_template_directive.validate_template(',
'    p_template          => :P4410_REPORT_BODY_TEMPLATE,',
'    p_application_id    => :FB_FLOW_ID );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P4410_PLUGIN_TYPE'
,p_validation_condition2=>'TEMPLATE COMPONENT'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(2003612747458832)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1921399049465819)
,p_validation_name=>'Report Row Template is not null'
,p_validation_sequence=>130
,p_validation=>'P4410_REPORT_BODY_TEMPLATE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>':P4410_PLUGIN_TYPE = ''TEMPLATE COMPONENT'' and :P4410_TMPL_COMPONENT_TYPES like ''%REPORT%'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(2003700350458833)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1921501916465821)
,p_validation_name=>'Report Row Template - required placeholders'
,p_validation_sequence=>140
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    instr( :P4410_REPORT_ROW_TEMPLATE, ''APEX$ROW_IDENTIFICATION'' ) > 0',
'and instr( :P4410_REPORT_ROW_TEMPLATE, ''#APEX$PARTIAL#'' ) > 0'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'#LABEL# must contain <strong>APEX$ROW_IDENTIFICATION</strong> and <strong>APEX$PARTIAL</strong> placeholder.'
,p_validation_condition=>'P4410_REPORT_ROW_TEMPLATE'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_imp.id(2003700350458833)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1606817095479202)
,p_validation_name=>'Report Container Template - required placeholders'
,p_validation_sequence=>150
,p_validation=>'instr( :P4410_REPORT_CONT_TEMPLATE, ''#APEX$REPORT_BODY#'' ) > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'#LABEL# must contain <strong>APEX$REPORT_BODY</strong> placeholder.'
,p_validation_condition=>'P4410_REPORT_CONT_TEMPLATE'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_imp.id(1606759360479201)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2003990481458835)
,p_validation_name=>'Valid Report Row Template'
,p_validation_sequence=>160
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_template_directive.validate_template(',
'    p_template          => :P4410_REPORT_ROW_TEMPLATE,',
'    p_application_id    => :FB_FLOW_ID );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P4410_PLUGIN_TYPE'
,p_validation_condition2=>'TEMPLATE COMPONENT'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(2003700350458833)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1606957018479203)
,p_validation_name=>'Valid Report Container Template'
,p_validation_sequence=>170
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_template_directive.validate_template(',
'    p_template          => :P4410_REPORT_CONT_TEMPLATE,',
'    p_application_id    => :FB_FLOW_ID );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P4410_PLUGIN_TYPE'
,p_validation_condition2=>'TEMPLATE COMPONENT'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(1606759360479201)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1653179685240837)
,p_tabular_form_region_id=>wwv_flow_imp.id(1651611827240822)
,p_validation_name=>'NAME cannot contain dots'
,p_validation_sequence=>180
,p_validation=>'NAME'
,p_validation2=>'.'
,p_validation_type=>'ITEM_IN_VALIDATION_CONTAINS_NO_CHAR_IN_STRING2'
,p_error_message=>'#COLUMN_HEADER# cannot contain a dot.'
,p_associated_column=>'NAME'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2389256688778004)
,p_validation_name=>'P4410_NAME is unique'
,p_validation_sequence=>190
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugins',
' where flow_id     = :FB_FLOW_ID',
'   and name        = :P4410_NAME',
'   and plugin_type = :P4410_PLUGIN_TYPE',
'   and id         != :P4410_ID',
'   and rownum      = 1'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#LABEL# must be unique within this application and plug-in type.'
,p_associated_item=>wwv_flow_imp.id(27912623836772078)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2401961718101807)
,p_tabular_form_region_id=>wwv_flow_imp.id(2675372452330944)
,p_validation_name=>'Validate Duplicate Attribute Group Titles'
,p_validation_sequence=>200
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''y''',
'  from wwv_flow_plugin_attr_groups',
' where plugin_id         = :P4410_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and title             = :TITLE',
'   and id               != coalesce(to_number(:ID),-1);'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Attribute Group Title already exists!'
,p_associated_column=>'TITLE'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1423786650828829)
,p_tabular_form_region_id=>wwv_flow_imp.id(263527442738503017)
,p_validation_name=>'Slots - No duplicate names'
,p_validation_sequence=>210
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugin_slots',
' where flow_id           = :FB_FLOW_ID',
'   and plugin_id         = :P4410_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and name              = :name',
'   and id               != nvl(:id, 0)'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#COLUMN_HEADER# must be unique.'
,p_validation_condition=>'P4410_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_column=>'NAME'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1423869091828830)
,p_tabular_form_region_id=>wwv_flow_imp.id(263527442738503017)
,p_validation_name=>'Slots - No duplicate placeholders'
,p_validation_sequence=>220
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugin_slots',
' where flow_id           = :FB_FLOW_ID',
'   and plugin_id         = :P4410_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and placeholder       = :placeholder',
'   and id               != nvl(:id, 0)',
'',
'union all',
'',
'select 1',
'  from wwv_flow_plugin_attributes',
' where flow_id           = :FB_FLOW_ID',
'   and plugin_id         = :P4410_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and static_id         = :placeholder',
'',
'union all',
'',
'select 1',
'  from wwv_flow_plugin_act_positions',
' where flow_id           = :FB_FLOW_ID',
'   and plugin_id         = :P4410_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and static_id         = :placeholder'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#COLUMN_HEADER# already in use as another region plugin slot, action position or custom attribute.'
,p_validation_condition=>'P4410_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_column=>'PLACEHOLDER'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1423993395828831)
,p_tabular_form_region_id=>wwv_flow_imp.id(263527442738503017)
,p_validation_name=>'Slots - At least one component type'
,p_validation_sequence=>230
,p_validation=>':has_region_support = ''Y'' or :has_item_support = ''Y'' or :has_button_support = ''Y'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Slot must support at least one component type (region, item or button).'
,p_validation_condition=>'P4410_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_column=>'PLACEHOLDER'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3201544967297801)
,p_tabular_form_region_id=>wwv_flow_imp.id(263527442738503017)
,p_validation_name=>'Slots - Placeholder restricted characters'
,p_validation_sequence=>250
,p_validation=>'PLACEHOLDER'
,p_validation2=>'^[[:alnum:]_]+$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>'#COLUMN_HEADER# contains invalid characters. Only letters, numbers and underscores are supported.'
,p_associated_column=>'PLACEHOLDER'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1604144463863113)
,p_tabular_form_region_id=>wwv_flow_imp.id(263527442738503017)
,p_validation_name=>'Slot Deletion - Not in use'
,p_validation_sequence=>260
,p_validation=>'not wwv_flow_plugin_dev.is_slot_in_use ( p_id => :ID )'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Slot cannot be deleted because it is used by page components (regions, items, buttons) or by the plugin default slots.'
,p_always_execute=>'Y'
,p_validation_condition=>':APEX$ROW_STATUS = ''D'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_exec_cond_for_each_row=>'Y'
,p_only_for_changed_rows=>'N'
,p_associated_column=>'PLACEHOLDER'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1800535575929407)
,p_validation_name=>'Not part of component groups'
,p_validation_sequence=>270
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not wwv_flow_component_group_dev.is_part_of_comp_grp (',
'    p_component_id   => :P4410_ID,',
'    p_component_type => wwv_flow_copy_metadata.c_plugin,',
'    p_app_id         => :FB_FLOW_ID )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Plug-in cannot be deleted because it is part of a component group.'
,p_when_button_pressed=>wwv_flow_imp.id(27903106352734562)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(439411826209419649)
,p_name=>'Hide all except of SQL Attributes'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_PLUGIN_TYPE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(439412121211419652)
,p_event_id=>wwv_flow_imp.id(439411826209419649)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Items'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_CATEGORY,P4410_API_VERSION_ITEM,P4410_API_VERSION_REGION,P4410_RENDER_FUNCTION,P4410_META_DATA_FUNCTION,P4410_SESSION_SENTRY_FUNCTION,P4410_INVALID_SESSION_FUNCTION,P4410_AUTHENTICATION_FUNCTION,P4410_AJAX_FUNCTION,P4410_POST_LOGOUT_FUNCTION,P4'
||'410_VALIDATION_FUNCTION,P4410_EXECUTION_FUNCTION,P4410_RENDER_FUNCTION,P4410_ITEM_COMPONENT_TYPES,P4410_PROCESS_COMPONENT_TYPES,P4410_PAGE_ITEM_ATTRIBUTES,P4410_REGION_ATTRIBUTES,P4410_DYNAMIC_ACTIN_ATTRIBUTES,P4410_AUTHENTCATION_ATTRIBUTES,P4410_PRO'
||'CESS_ATTRIBUTES,P4410_WEB_SOURCE_ATTRIBUTES,P4410_WSM_CAPABILITIES,P4410_WSM_FETCH,P4410_WSM_DML,P4410_WSM_EXECUTE,P4410_WSM_DISCOVER,P4410_PLSQL_CODE,P4410_CHECK_PLSQL_CODE,P4410_IS_QUICK_PICK,P4410_COMPLETION_FUNCTION,P4410_TERMINATION_FUNCTION,P44'
||'10_TEMPLATE_COMP_ATTRIBUTES'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(471131805144530744)
,p_event_id=>wwv_flow_imp.id(439411826209419649)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Standard Attributes'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(439386704233826730)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1654466563240850)
,p_event_id=>wwv_flow_imp.id(439411826209419649)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Attribute Groups'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2675372452330944)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2622522614490943)
,p_event_id=>wwv_flow_imp.id(439411826209419649)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Templates'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(4004640729629327)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1644700850999001)
,p_event_id=>wwv_flow_imp.id(439411826209419649)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Sync from Template'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(9812207339144407)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1622708442577318)
,p_event_id=>wwv_flow_imp.id(439411826209419649)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Action Position'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(4004965443629330)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2622454411490942)
,p_event_id=>wwv_flow_imp.id(439411826209419649)
,p_event_result=>'TRUE'
,p_action_sequence=>70
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Action Templates'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1622849868577319)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1654332594240849)
,p_event_id=>wwv_flow_imp.id(439411826209419649)
,p_event_result=>'TRUE'
,p_action_sequence=>80
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Events'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1651611827240822)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(483229918595060541)
,p_event_id=>wwv_flow_imp.id(439411826209419649)
,p_event_result=>'TRUE'
,p_action_sequence=>90
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Files'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(29873113508481210)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(538625595312238346)
,p_event_id=>wwv_flow_imp.id(439411826209419649)
,p_event_result=>'TRUE'
,p_action_sequence=>100
,p_execute_on_page_init=>'Y'
,p_name=>'Hide File URLs to Load'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(538625467201238345)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2001747127420702)
,p_event_id=>wwv_flow_imp.id(439411826209419649)
,p_event_result=>'TRUE'
,p_action_sequence=>110
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Slots'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(263527442738503017)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(47348904121291950)
,p_name=>'Item Type'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_PLUGIN_TYPE'
,p_condition_element=>'P4410_PLUGIN_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'ITEM TYPE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(47349412564303889)
,p_event_id=>wwv_flow_imp.id(47348904121291950)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show Items'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_RENDER_FUNCTION,P4410_META_DATA_FUNCTION,P4410_AJAX_FUNCTION,P4410_VALIDATION_FUNCTION,P4410_ITEM_COMPONENT_TYPES,P4410_PAGE_ITEM_ATTRIBUTES,P4410_PLSQL_CODE,P4410_CHECK_PLSQL_CODE'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(439450931515329471)
,p_event_id=>wwv_flow_imp.id(47348904121291950)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.jQuery(''#P4410_PAGE_ITEM_ATTRIBUTES_01'').trigger(''change'');'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(471130828777518584)
,p_event_id=>wwv_flow_imp.id(47348904121291950)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Show  Standard Attributes'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(439386704233826730)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1663325519153107)
,p_event_id=>wwv_flow_imp.id(47348904121291950)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_name=>'Show Attribute Groups'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2675372452330944)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1663298653153106)
,p_event_id=>wwv_flow_imp.id(47348904121291950)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_name=>'Show Events'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1651611827240822)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(483230301411065030)
,p_event_id=>wwv_flow_imp.id(47348904121291950)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'Y'
,p_name=>'Show Files'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(29873113508481210)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(538625603789238347)
,p_event_id=>wwv_flow_imp.id(47348904121291950)
,p_event_result=>'TRUE'
,p_action_sequence=>70
,p_execute_on_page_init=>'Y'
,p_name=>'Show File URLs to Load'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(538625467201238345)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2016487212356722)
,p_event_id=>wwv_flow_imp.id(47348904121291950)
,p_event_result=>'TRUE'
,p_action_sequence=>80
,p_execute_on_page_init=>'N'
,p_name=>'Set Item API Version'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_API_VERSION_ITEM'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'2'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1587735535586175025)
,p_name=>'Item Type - API Version'
,p_event_sequence=>30
,p_condition_element=>'P4410_PLUGIN_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'ITEM TYPE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>':P4410_ID is not null and :P4410_API_VERSION = 1'
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1587735680553175026)
,p_event_id=>wwv_flow_imp.id(1587735535586175025)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show API Version Item'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_API_VERSION_ITEM'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(439412221492427734)
,p_name=>'Region Type'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_PLUGIN_TYPE'
,p_condition_element=>'P4410_PLUGIN_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REGION TYPE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(439412503742427736)
,p_event_id=>wwv_flow_imp.id(439412221492427734)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show Items'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_RENDER_FUNCTION,P4410_AJAX_FUNCTION,P4410_REGION_ATTRIBUTES,P4410_PLSQL_CODE,P4410_CHECK_PLSQL_CODE'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(439451111906333254)
,p_event_id=>wwv_flow_imp.id(439412221492427734)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.jQuery(''#P4410_REGION_ATTRIBUTES'').trigger(''change'');'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(471131419212525328)
,p_event_id=>wwv_flow_imp.id(439412221492427734)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Show Standard Attributes'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(439386704233826730)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1662879382153102)
,p_event_id=>wwv_flow_imp.id(439412221492427734)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_name=>'Show Attribute Groups'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2675372452330944)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1662765109153101)
,p_event_id=>wwv_flow_imp.id(439412221492427734)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_name=>'Shoe Events'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1651611827240822)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(483230715610069113)
,p_event_id=>wwv_flow_imp.id(439412221492427734)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'Y'
,p_name=>'Show Files'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(29873113508481210)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(573414526671205502)
,p_event_id=>wwv_flow_imp.id(439412221492427734)
,p_event_result=>'TRUE'
,p_action_sequence=>70
,p_execute_on_page_init=>'Y'
,p_name=>'Show File URLs to Load'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(538625467201238345)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2846439155306507)
,p_event_id=>wwv_flow_imp.id(439412221492427734)
,p_event_result=>'TRUE'
,p_action_sequence=>80
,p_execute_on_page_init=>'N'
,p_name=>'Set Region API Version'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_API_VERSION_REGION'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'3'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2845960033306502)
,p_name=>'Region Type - API Version'
,p_event_sequence=>50
,p_condition_element=>'P4410_PLUGIN_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REGION TYPE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>':P4410_ID is not null and :P4410_API_VERSION = 1'
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2846078436306503)
,p_event_id=>wwv_flow_imp.id(2845960033306502)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show Region API Version Item'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_API_VERSION_REGION'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(439412610195433998)
,p_name=>'Dynamic Actions'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_PLUGIN_TYPE'
,p_condition_element=>'P4410_PLUGIN_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'DYNAMIC ACTION'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(439412923139433998)
,p_event_id=>wwv_flow_imp.id(439412610195433998)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show Items'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_CATEGORY,P4410_RENDER_FUNCTION,P4410_AJAX_FUNCTION,P4410_DYNAMIC_ACTIN_ATTRIBUTES,P4410_PLSQL_CODE,P4410_CHECK_PLSQL_CODE'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(439451326797337521)
,p_event_id=>wwv_flow_imp.id(439412610195433998)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.jQuery(''#P4410_DYNAMIC_ACTIN_ATTRIBUTES'').trigger(''change'');'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(618931207756408201)
,p_event_id=>wwv_flow_imp.id(439412610195433998)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Show Standard Attributes'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(439386704233826730)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1663086575153104)
,p_event_id=>wwv_flow_imp.id(439412610195433998)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_name=>'Show Attribute Groups'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2675372452330944)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1662940118153103)
,p_event_id=>wwv_flow_imp.id(439412610195433998)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_name=>'Show Events'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1651611827240822)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(483231128769072944)
,p_event_id=>wwv_flow_imp.id(439412610195433998)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'Y'
,p_name=>'Show Files'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(29873113508481210)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(573414662208205503)
,p_event_id=>wwv_flow_imp.id(439412610195433998)
,p_event_result=>'TRUE'
,p_action_sequence=>70
,p_execute_on_page_init=>'Y'
,p_name=>'Show File URLs to Load'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(538625467201238345)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(471055129080040003)
,p_name=>'Process Type'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_PLUGIN_TYPE'
,p_condition_element=>'P4410_PLUGIN_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'PROCESS TYPE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(471055408404040010)
,p_event_id=>wwv_flow_imp.id(471055129080040003)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show Items'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_EXECUTION_FUNCTION,P4410_PROCESS_ATTRIBUTES,P4410_PROCESS_COMPONENT_TYPES,P4410_PLSQL_CODE,P4410_CHECK_PLSQL_CODE'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(375221322912099826)
,p_event_id=>wwv_flow_imp.id(471055129080040003)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Show Files'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(29873113508481210)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(366691611531652666)
,p_event_id=>wwv_flow_imp.id(471055129080040003)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Show Standard Attributes'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(439386704233826730)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1663155479153105)
,p_event_id=>wwv_flow_imp.id(471055129080040003)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_name=>'Show Attribute Groups'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2675372452330944)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(10801908044286535)
,p_name=>'Authorization Type'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_PLUGIN_TYPE'
,p_condition_element=>'P4410_PLUGIN_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'AUTHORIZATION TYPE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(10802230415286539)
,p_event_id=>wwv_flow_imp.id(10801908044286535)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show Items'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_EXECUTION_FUNCTION,P4410_PLSQL_CODE,P4410_CHECK_PLSQL_CODE'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(331962206691664754)
,p_name=>'Authentication Type'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_PLUGIN_TYPE'
,p_condition_element=>'P4410_PLUGIN_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'AUTHENTICATION TYPE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(331962506669664758)
,p_event_id=>wwv_flow_imp.id(331962206691664754)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show Items'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_SESSION_SENTRY_FUNCTION,P4410_INVALID_SESSION_FUNCTION,P4410_AUTHENTICATION_FUNCTION,P4410_AJAX_FUNCTION,P4410_POST_LOGOUT_FUNCTION,P4410_AUTHENTCATION_ATTRIBUTES,P4410_PLSQL_CODE,P4410_CHECK_PLSQL_CODE'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(331994601282672606)
,p_event_id=>wwv_flow_imp.id(331962206691664754)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Show Standard Attributes'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(439386704233826730)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(445176402174363503)
,p_name=>'Enable/Disable Page Item Is Visible Checkboxes'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_PAGE_ITEM_ATTRIBUTES'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'/:VISIBLE:/.test('':''+$v(this.triggeringElement)+'':'')'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(445176724561363507)
,p_event_id=>wwv_flow_imp.id(445176402174363503)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_PAGE_ITEM_ATTRIBUTES'
,p_attribute_01=>'apex.jQuery(''input[value=FORM_ELEMENT],input[value=SESSION_STATE],input[value=QUICKPICK],input[value=ESCAPE_OUTPUT],input[value=READONLY],input[value=LOV]'', ''#P4410_PAGE_ITEM_ATTRIBUTES'').prop("disabled",false);'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(445176907219363511)
,p_event_id=>wwv_flow_imp.id(445176402174363503)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_PAGE_ITEM_ATTRIBUTES'
,p_attribute_01=>'apex.jQuery(''input[value=FORM_ELEMENT],input[value=SESSION_STATE],input[value=QUICKPICK],input[value=ESCAPE_OUTPUT],input[value=READONLY],input[value=LOV]'', ''#P4410_PAGE_ITEM_ATTRIBUTES'').prop({"disabled":true, "checked":false});'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2849565016306538)
,p_name=>'Enable/Disable Page Item AI Checkboxes'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_PAGE_ITEM_ATTRIBUTES'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2849665811306539)
,p_event_id=>wwv_flow_imp.id(2849565016306538)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_PAGE_ITEM_ATTRIBUTES'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'const attributes = apex.items.P4410_PAGE_ITEM_ATTRIBUTES.value;',
'const dependentAiCheckboxes$ = apex.jQuery( "input[value=AI_SYSTEM_PROMPT],input[value=AI_WELCOME_MESSAGE]", "#P4410_PAGE_ITEM_ATTRIBUTES" );',
'',
'if( attributes.includes( "AI_ENABLED_ALWAYS" ) || attributes.includes( "AI_ENABLED")  ) {',
'    dependentAiCheckboxes$.prop( "disabled", false );',
'} else {',
'    dependentAiCheckboxes$.prop( { "checked": false, "disabled": true } );',
'}'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(445183512058479868)
,p_name=>'Enable/Disable Page Item Source Checkboxes'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_PAGE_ITEM_ATTRIBUTES'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'/:SOURCE:/.test('':''+$v(this.triggeringElement)+'':'')'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(445183802908479868)
,p_event_id=>wwv_flow_imp.id(445183512058479868)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_PAGE_ITEM_ATTRIBUTES'
,p_attribute_01=>'apex.jQuery(''input[value=FORMAT_MASK_DATE],input[value=FORMAT_MASK_NUMBER],input[value=FILTER]'', ''#P4410_PAGE_ITEM_ATTRIBUTES'').prop("disabled",false);'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(445184023120479875)
,p_event_id=>wwv_flow_imp.id(445183512058479868)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_PAGE_ITEM_ATTRIBUTES'
,p_attribute_01=>'apex.jQuery(''input[value=FORMAT_MASK_DATE],input[value=FORMAT_MASK_NUMBER],input[value=FILTER]'', ''#P4410_PAGE_ITEM_ATTRIBUTES'').prop({"disabled":true, "checked":false});'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(439437108210840247)
,p_name=>'On Region Attributes Change'
,p_event_sequence=>120
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_REGION_ATTRIBUTES'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(439437431648840248)
,p_event_id=>wwv_flow_imp.id(439437108210840247)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'let',
'    selectedItems = apex.item( "P4410_REGION_ATTRIBUTES" ).getValue(),',
'    items$ = $( "#P4410_REGION_ATTRIBUTES" ),',
'    checkboxAjaxItems$ = items$.find( "input[value=AJAX_ITEMS_TO_SUBMIT]" ),',
'    checkboxOrberBy$ = items$.find( "input[value=ORDER_BY]" ),',
'    checkboxSupportsFiltering$ = items$.find( "input[value=SUPPORTS_EXTERNAL_FILTERING]" ),',
'    checkboxHasColumns$ = items$.find( "input[value=COLUMNS]" ),',
'    checkboxesOfColumns$ = items$.find( "input[value=COLUMN_HEADING],input[value=HEADING_ALIGNMENT],input[value^=VALUE_]" ),',
'    checkboxesOfAi$ = items$.find( "input[value=AI_SYSTEM_PROMPT],input[value=AI_WELCOME_MESSAGE]" );',
'',
'// RULE 1: Enable/Disable Region Source Type Checkboxes',
'const SOURCE_TYPES = ["SOURCE_LOCATION", "SOURCE_PLAIN", "SOURCE_HTML", "SOURCE_SQL", "SOURCE_PLSQL", "SOURCE_PLSQL_FUNCTION"];',
'',
'const sourceTypeIdx = (function () {',
'    //',
'    // return the index position of the selected source type',
'    //',
'    for (var i = 0; i < selectedItems.length; i++) {',
'        var lIdx = SOURCE_TYPES.indexOf(selectedItems[i]);',
'        if (lIdx >= 0) {',
'            return lIdx;',
'        }',
'    }',
'    return -1;',
'})();',
'',
'if (sourceTypeIdx >= 0) {',
'    //',
'    // disable every type but the selected source type',
'    // ',
'    for (var lIdx = 0; lIdx < SOURCE_TYPES.length; lIdx++) {',
'        if (lIdx !== sourceTypeIdx) {',
'            $("#P4410_REGION_ATTRIBUTES input[value=" + SOURCE_TYPES[lIdx] + "]").prop({ "disabled": true, "checked": false });',
'        }',
'    }',
'} else {',
'    //',
'    // no type selected -> enable all types',
'    //',
'    for (var lIdx = 0; lIdx < SOURCE_TYPES.length; lIdx++) {',
'        $("#P4410_REGION_ATTRIBUTES input[value=" + SOURCE_TYPES[lIdx] + "]").prop({ "disabled": false, "checked": false });',
'    }',
'}',
'',
'// RULE 2: Enable/Disable "Has Region Columns" and "Supports Faceted Search"',
'checkboxOrberBy$.add( checkboxSupportsFiltering$ ).prop( selectedItems.includes( "SOURCE_LOCATION" )',
'    ? { "disabled": false }',
'    : { "disabled": true, "checked": false }',
');',
'',
'// RULE 3: Enable/Disable "Has Region Columns"',
'checkboxHasColumns$ .prop( selectedItems.includes( "SOURCE_LOCATION" ) || selectedItems.includes( "SOURCE_SQL" )',
'    ? { "disabled": false }',
'    : { "disabled": true, "checked": false }',
');',
'',
'// RULE 4: Enable/Disable Column Attributes',
'selectedItems = apex.item( "P4410_REGION_ATTRIBUTES" ).getValue(); // refresh items',
'',
'checkboxesOfColumns$.prop( selectedItems.includes( "COLUMNS" )',
'    ? { "disabled": false }',
'    : { "disabled": true, "checked": false }',
');',
'',
'// RULE 5: Enable/Disable AI related Attributes',
'checkboxesOfAi$.prop( ( selectedItems.includes( "AI_ENABLED_ALWAYS" ) || selectedItems.includes( "AI_ENABLED" ) )',
'    ? { "disabled": false }',
'    : { "disabled": true, "checked": false }',
');'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(366787330074911526)
,p_name=>'Enable/Disable Process Type Checkboxes'
,p_event_sequence=>130
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_PROCESS_ATTRIBUTES'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(366787620564911791)
,p_event_id=>wwv_flow_imp.id(366787330074911526)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var lList = $v( "P4410_PROCESS_ATTRIBUTES" ).split( ":" ),',
'    lRegionRequired$ = $( "#P4410_PROCESS_ATTRIBUTES input[value=REGION_REQUIRED]" );',
'',
'if ( $.inArray( "REGION", lList ) >= 0 ) {',
'    lRegionRequired$.prop( "disabled", false );',
'} else {',
'    lRegionRequired$.prop({ "disabled": true, "checked": false });',
'}'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3401283764811712)
,p_name=>'Enable/Disable Always Multiple Values'
,p_event_sequence=>140
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_PAGE_ITEM_ATTRIBUTES'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'/:MULTI_VALUE_OPTIONAL:/.test('':''+$v(this.triggeringElement)+'':'')'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3401396981811713)
,p_event_id=>wwv_flow_imp.id(3401283764811712)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.jQuery( "#P4410_PAGE_ITEM_ATTRIBUTES input[value=MULTI_VALUE_ALWAYS]" ).prop( "disabled", false );'
,p_client_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_client_condition_expression=>'apex.jQuery( "#P4410_PAGE_ITEM_ATTRIBUTES input[value=LOV]" ).prop( "checked" )'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3401445173811714)
,p_event_id=>wwv_flow_imp.id(3401283764811712)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.jQuery( "#P4410_PAGE_ITEM_ATTRIBUTES input[value=MULTI_VALUE_ALWAYS]" ).attr( { "disabled": true, "checked": false } );'
,p_client_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_client_condition_expression=>'apex.jQuery( "#P4410_PAGE_ITEM_ATTRIBUTES input[value=LOV]" ).prop( "checked" )'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(439413623579504041)
,p_name=>'Show LOV Attributes'
,p_event_sequence=>140
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_PAGE_ITEM_ATTRIBUTES'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'/:LOV:/.test('':''+$v(this.triggeringElement)+'':'')'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(439417003849573994)
,p_event_id=>wwv_flow_imp.id(439413623579504041)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.jQuery( "#P4410_PAGE_ITEM_ATTRIBUTES input[value=LOV_REQUIRED],#P4410_PAGE_ITEM_ATTRIBUTES input[value=LOV_DISPLAY_NULL],#P4410_PAGE_ITEM_ATTRIBUTES input[value=CASCADING_LOV],#P4410_PAGE_ITEM_ATTRIBUTES input[value=JOIN_LOV],#P4410_PAGE_ITEM_AT'
||'TRIBUTES input[value=MULTI_VALUE_OPTIONAL],#P4410_PAGE_ITEM_ATTRIBUTES input[value=MULTI_VALUE_ALWAYS]" ).prop( { "disabled": true, "checked": false } );'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(439415101032544808)
,p_event_id=>wwv_flow_imp.id(439413623579504041)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.jQuery( "#P4410_PAGE_ITEM_ATTRIBUTES input[value=LOV_REQUIRED],#P4410_PAGE_ITEM_ATTRIBUTES input[value=LOV_DISPLAY_NULL],#P4410_PAGE_ITEM_ATTRIBUTES input[value=CASCADING_LOV],#P4410_PAGE_ITEM_ATTRIBUTES input[value=JOIN_LOV],#P4410_PAGE_ITEM_AT'
||'TRIBUTES input[value=MULTI_VALUE_OPTIONAL],#P4410_PAGE_ITEM_ATTRIBUTES input[value=MULTI_VALUE_ALWAYS]" ).prop( "disabled", false );'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3401554122811715)
,p_name=>'Enable/Disable Optional Multiple Values'
,p_event_sequence=>150
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_PAGE_ITEM_ATTRIBUTES'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'/:MULTI_VALUE_ALWAYS:/.test('':''+$v(this.triggeringElement)+'':'')'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3401620649811716)
,p_event_id=>wwv_flow_imp.id(3401554122811715)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.jQuery( "#P4410_PAGE_ITEM_ATTRIBUTES input[value=MULTI_VALUE_OPTIONAL]" ).prop( "disabled", false );'
,p_client_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_client_condition_expression=>'apex.jQuery( "#P4410_PAGE_ITEM_ATTRIBUTES input[value=LOV]" ).prop( "checked" )'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3401771522811717)
,p_event_id=>wwv_flow_imp.id(3401554122811715)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.jQuery( "#P4410_PAGE_ITEM_ATTRIBUTES input[value=MULTI_VALUE_OPTIONAL]" ).attr( { "disabled": true, "checked": false } );'
,p_client_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_client_condition_expression=>'apex.jQuery( "#P4410_PAGE_ITEM_ATTRIBUTES input[value=LOV]" ).prop( "checked" )'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(17942703399432375)
,p_name=>'Show/Hide Subscribe Component Settings'
,p_event_sequence=>160
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_REFERENCE_ID'
,p_condition_element=>'P4410_REFERENCE_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(17943012786432380)
,p_event_id=>wwv_flow_imp.id(17942703399432375)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show Subscribe Plugin Settings'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_SUBSCRIBE_PLGIN_SETTINGS'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(17943213430432381)
,p_event_id=>wwv_flow_imp.id(17942703399432375)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Subscribe Plugin Settings'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_SUBSCRIBE_PLGIN_SETTINGS'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(30856001959545797)
,p_name=>'Delete all Files'
,p_event_sequence=>170
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(30855910247544017)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(30856509493545801)
,p_event_id=>wwv_flow_imp.id(30856001959545797)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'Do you really want to delete all files?'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(30856304040545798)
,p_event_id=>wwv_flow_imp.id(30856001959545797)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'FILES_DELETE_ALL'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2210794207848925)
,p_name=>'REST Data Source Type'
,p_event_sequence=>180
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_PLUGIN_TYPE'
,p_condition_element=>'P4410_PLUGIN_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'WEB SOURCE TYPE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2211195111848929)
,p_event_id=>wwv_flow_imp.id(2210794207848925)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show Items'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_WSM_CAPABILITIES,P4410_WSM_FETCH,P4410_WSM_DML,P4410_WSM_EXECUTE,P4410_WSM_DISCOVER,P4410_WEB_SOURCE_ATTRIBUTES,P4410_PLSQL_CODE,P4410_CHECK_PLSQL_CODE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1417160362635702)
,p_event_id=>wwv_flow_imp.id(2210794207848925)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Show Standard Attributes'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(439386704233826730)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(9811908110144404)
,p_name=>'Template Component Type'
,p_event_sequence=>190
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_PLUGIN_TYPE'
,p_condition_element=>'P4410_PLUGIN_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TEMPLATE COMPONENT'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1624887248577339)
,p_event_id=>wwv_flow_imp.id(9811908110144404)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Show Source'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(27899831305734555)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4004763464629328)
,p_event_id=>wwv_flow_imp.id(9811908110144404)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Show Templates'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(4004640729629327)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2832269839618424)
,p_event_id=>wwv_flow_imp.id(9811908110144404)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Show Callbacks'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(27935931959010930)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(9812016835144405)
,p_event_id=>wwv_flow_imp.id(9811908110144404)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Show Quickpick'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_IS_QUICK_PICK'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2015952481356717)
,p_event_id=>wwv_flow_imp.id(9811908110144404)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_name=>'Show Standard Attributes'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(439386704233826730)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3402247015955614)
,p_event_id=>wwv_flow_imp.id(9811908110144404)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_name=>'Show Standard Attributes Meta Data'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(791007298727651108)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(9812141333144406)
,p_event_id=>wwv_flow_imp.id(9811908110144404)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_name=>'Show Custom Attributes'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(48467930491898431)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1644870050999002)
,p_event_id=>wwv_flow_imp.id(9811908110144404)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'Y'
,p_name=>'Show Sync from Template'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(9812207339144407)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3001322595489203)
,p_event_id=>wwv_flow_imp.id(9811908110144404)
,p_event_result=>'FALSE'
,p_action_sequence=>60
,p_execute_on_page_init=>'Y'
,p_name=>'Show Supported For'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(5261005290655272)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2832082981618422)
,p_event_id=>wwv_flow_imp.id(9811908110144404)
,p_event_result=>'TRUE'
,p_action_sequence=>70
,p_execute_on_page_init=>'Y'
,p_name=>'Show Files'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(29873113508481210)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3402013477955612)
,p_event_id=>wwv_flow_imp.id(9811908110144404)
,p_event_result=>'FALSE'
,p_action_sequence=>70
,p_execute_on_page_init=>'Y'
,p_name=>'Show Substitute Attributes'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_SUBSTITUTE_ATTRIBUTES'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2832174507618423)
,p_event_id=>wwv_flow_imp.id(9811908110144404)
,p_event_result=>'TRUE'
,p_action_sequence=>80
,p_execute_on_page_init=>'Y'
,p_name=>'Show File URLs to Load'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(538625467201238345)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2001674181420701)
,p_event_id=>wwv_flow_imp.id(9811908110144404)
,p_event_result=>'TRUE'
,p_action_sequence=>90
,p_execute_on_page_init=>'Y'
,p_name=>'Show Attribute Groups'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2675372452330944)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1624998486577340)
,p_event_id=>wwv_flow_imp.id(9811908110144404)
,p_event_result=>'TRUE'
,p_action_sequence=>100
,p_execute_on_page_init=>'Y'
,p_name=>'Show Action Positions'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(4004965443629330)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1625002863577341)
,p_event_id=>wwv_flow_imp.id(9811908110144404)
,p_event_result=>'TRUE'
,p_action_sequence=>110
,p_execute_on_page_init=>'Y'
,p_name=>'Show Action Templates'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1622849868577319)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2006845297278111)
,p_event_id=>wwv_flow_imp.id(9811908110144404)
,p_event_result=>'TRUE'
,p_action_sequence=>120
,p_execute_on_page_init=>'Y'
,p_name=>'Show Standard Attributes Item'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_TEMPLATE_COMP_ATTRIBUTES'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4004813320629329)
,p_event_id=>wwv_flow_imp.id(9811908110144404)
,p_event_result=>'TRUE'
,p_action_sequence=>130
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Source'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(27899831305734555)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1422326524828815)
,p_event_id=>wwv_flow_imp.id(9811908110144404)
,p_event_result=>'TRUE'
,p_action_sequence=>140
,p_execute_on_page_init=>'Y'
,p_name=>'Show Slots'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(263527442738503017)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2831999725618421)
,p_event_id=>wwv_flow_imp.id(9811908110144404)
,p_event_result=>'TRUE'
,p_action_sequence=>150
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Callbacks'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(27935931959010930)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3402148298955613)
,p_event_id=>wwv_flow_imp.id(9811908110144404)
,p_event_result=>'TRUE'
,p_action_sequence=>160
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Standard Attributes Meta Data'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(791007298727651108)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3401985076955611)
,p_event_id=>wwv_flow_imp.id(9811908110144404)
,p_event_result=>'TRUE'
,p_action_sequence=>170
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Substitute Attributes'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_SUBSTITUTE_ATTRIBUTES'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1625457423577345)
,p_event_id=>wwv_flow_imp.id(9811908110144404)
,p_event_result=>'TRUE'
,p_action_sequence=>180
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Supported For'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(5261005290655272)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3404387530955635)
,p_event_id=>wwv_flow_imp.id(9811908110144404)
,p_event_result=>'TRUE'
,p_action_sequence=>190
,p_execute_on_page_init=>'N'
,p_name=>'Clear PL/SQL Code'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_PLSQL_CODE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1897156944601401)
,p_name=>'Native plugin'
,p_event_sequence=>200
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_PLUGIN_TYPE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1897279929601402)
,p_event_id=>wwv_flow_imp.id(1897156944601401)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show Quick Pick'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_IS_QUICK_PICK'
,p_server_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_server_condition_expr1=>'FB_FLOW_ID'
,p_server_condition_expr2=>'4411'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1649615766240802)
,p_name=>'On Add Attribute Group Button Click'
,p_event_sequence=>210
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1649549844240801)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1649796500240803)
,p_event_id=>wwv_flow_imp.id(1649615766240802)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.region( "CUST_ATTR_GROUPS" ).widget().interactiveGrid( "getActions" ).invoke( "selection-add-row" );'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2800250778549802)
,p_name=>'onClick ADD_SLOT'
,p_event_sequence=>220
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2800145762549801)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2800354946549803)
,p_event_id=>wwv_flow_imp.id(2800250778549802)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.regions.SlotsDataEntry.widget().interactiveGrid( "getActions" ).invoke( "selection-add-row" );'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1652375646240829)
,p_name=>'On Add Event Button Click'
,p_event_sequence=>230
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(48656805235692689)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1652594765240831)
,p_event_id=>wwv_flow_imp.id(1652375646240829)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.region( "EVENTS" ).widget().interactiveGrid( "getActions" ).invoke( "selection-add-row" );'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1920270152465808)
,p_name=>'Is Partial or Template Report'
,p_event_sequence=>240
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_TMPL_COMPONENT_TYPES'
,p_condition_element=>'P4410_PARTIAL_TEMPLATE'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4004483828629325)
,p_event_id=>wwv_flow_imp.id(1920270152465808)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_name=>'Default Partial'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_PARTIAL_TEMPLATE'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>wwv_flow_string.join(wwv_flow_t_varchar2(
'`{if APEX$IS_LAZY_LOADING/}',
'  <div></div>',
'  {if MY_SECOND_PLACEHOLDER%assigned/}<div></div>{endif/}',
'{else/}',
'  <div>#MY_FIRST_PLACEHOLDER#</div>',
'  {if MY_SECOND_PLACEHOLDER/}<div>#MY_SECOND_PLACEHOLDER#</div>{endif/}',
'{endif/}`'))
,p_attribute_09=>'N'
,p_stop_execution_on_error=>'N'
,p_wait_for_result=>'N'
,p_client_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_client_condition_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(() => {',
'    let value = apex.items.P4410_TMPL_COMPONENT_TYPES.value;',
'    return ( !!value.length && !value.includes( "REGION_ONLY" ) );',
'})()'))
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2583461375625702)
,p_event_id=>wwv_flow_imp.id(1920270152465808)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_name=>'Default Static'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_PARTIAL_TEMPLATE'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>wwv_flow_string.join(wwv_flow_t_varchar2(
'`<div id="#APEX$DOM_ID#">#MY_FIRST_PLACEHOLDER#</div>',
'{if MY_SECOND_PLACEHOLDER/}<div>#MY_SECOND_PLACEHOLDER#</div>{endif/}',
'`'))
,p_attribute_09=>'N'
,p_stop_execution_on_error=>'N'
,p_wait_for_result=>'N'
,p_client_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_client_condition_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(() => {',
'    let value = apex.items.P4410_TMPL_COMPONENT_TYPES.value;',
'    return ( value.length === 1 && value[ 0 ] === "REGION_ONLY" );',
'})()'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4003885835629319)
,p_name=>'Is Template Report'
,p_event_sequence=>250
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_TMPL_COMPONENT_TYPES'
,p_condition_element=>'P4410_TMPL_COMPONENT_TYPES'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REPORT'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4003907811629320)
,p_event_id=>wwv_flow_imp.id(4003885835629319)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show Items'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_REPORT_BODY_TEMPLATE,P4410_REPORT_ROW_TEMPLATE,P4410_REPORT_PLACEHOLDER_COUNT,P4410_REPORT_CONT_TEMPLATE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4004053784629321)
,p_event_id=>wwv_flow_imp.id(4003885835629319)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Items'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_REPORT_BODY_TEMPLATE,P4410_REPORT_ROW_TEMPLATE,P4410_REPORT_PLACEHOLDER_COUNT,P4410_REPORT_CONT_TEMPLATE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4004566547629326)
,p_event_id=>wwv_flow_imp.id(4003885835629319)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_name=>'Clear Items'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_REPORT_BODY_TEMPLATE,P4410_REPORT_ROW_TEMPLATE,P4410_REPORT_PLACEHOLDER_COUNT,P4410_REPORT_CONT_TEMPLATE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4004180933629322)
,p_event_id=>wwv_flow_imp.id(4003885835629319)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_name=>'Default Body Template'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_REPORT_BODY_TEMPLATE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'<ul>#APEX$ROWS#</ul>'
,p_attribute_09=>'N'
,p_stop_execution_on_error=>'N'
,p_wait_for_result=>'N'
,p_client_condition_type=>'NULL'
,p_client_condition_element=>'P4410_REPORT_BODY_TEMPLATE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4004269157629323)
,p_event_id=>wwv_flow_imp.id(4003885835629319)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_name=>'Default Row Template'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_REPORT_ROW_TEMPLATE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'<li #APEX$ROW_IDENTIFICATION#>#APEX$PARTIAL#</li>'
,p_attribute_09=>'N'
,p_stop_execution_on_error=>'N'
,p_wait_for_result=>'N'
,p_client_condition_type=>'NULL'
,p_client_condition_element=>'P4410_REPORT_ROW_TEMPLATE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4004311980629324)
,p_event_id=>wwv_flow_imp.id(4003885835629319)
,p_event_result=>'TRUE'
,p_action_sequence=>70
,p_execute_on_page_init=>'N'
,p_name=>'Default Placeholder Count'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_REPORT_PLACEHOLDER_COUNT'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'3'
,p_attribute_09=>'N'
,p_stop_execution_on_error=>'N'
,p_wait_for_result=>'N'
,p_client_condition_type=>'NULL'
,p_client_condition_element=>'P4410_REPORT_PLACEHOLDER_COUNT'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1818580040635007)
,p_name=>'On change Display Name'
,p_event_sequence=>260
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_DISPLAY_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1818678054635008)
,p_event_id=>wwv_flow_imp.id(1818580040635007)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_name=>'Set Internal Name'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>wwv_flow_string.join(wwv_flow_t_varchar2(
'this.triggeringElement.value',
'    .toUpperCase()',
'    .replace( /\W/g, "_" )',
'    .replace( /\_*$/g, "" );'))
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_client_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_client_condition_expression=>'apex.items.P4410_NAME.isEmpty() && apex.items.P4410_PLUGIN_TYPE.value === "TEMPLATE COMPONENT"'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1601251976579202)
,p_name=>'Show Termination and Completion Functions'
,p_event_sequence=>270
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_PROCESS_ATTRIBUTES'
,p_condition_element=>'P4410_PROCESS_ATTRIBUTES'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'WAIT_FOR_COMPLETION'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1601396260579203)
,p_event_id=>wwv_flow_imp.id(1601251976579202)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show Completion/Termination Function'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_COMPLETION_FUNCTION,P4410_TERMINATION_FUNCTION'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1601427014579204)
,p_event_id=>wwv_flow_imp.id(1601251976579202)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Completion/Termination Function'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_COMPLETION_FUNCTION,P4410_TERMINATION_FUNCTION'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1601572231579205)
,p_event_id=>wwv_flow_imp.id(1601251976579202)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_name=>'Clear Completion/Termination Function'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_COMPLETION_FUNCTION,P4410_TERMINATION_FUNCTION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2846265048306505)
,p_name=>'Substitute Attribute Values Logic'
,p_event_sequence=>280
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_PLUGIN_TYPE,P4410_API_VERSION_ITEM,P4410_API_VERSION_REGION'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2846353670306506)
,p_event_id=>wwv_flow_imp.id(2846265048306505)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// in a few specific cases, "Substitute Attribute Values" should be hidden',
'if( apex.items.P4410_PLUGIN_TYPE.value === "TEMPLATE COMPONENT" ||',
'    ( apex.items.P4410_PLUGIN_TYPE.value === "REGION TYPE" &&',
'      apex.items.P4410_API_VERSION_REGION.value === "3" )',
') {',
'    apex.item("P4410_SUBSTITUTE_ATTRIBUTES").hide();',
'} else {',
'    apex.item("P4410_SUBSTITUTE_ATTRIBUTES").show();',
'}'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1910627027989901)
,p_name=>'Toggle Template Options'
,p_event_sequence=>290
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_TMPL_COMPONENT_TYPES'
,p_condition_element=>'P4410_REFERENCE_ID'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1910723550989902)
,p_event_id=>wwv_flow_imp.id(1910627027989901)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'let item = apex.item( "P4410_TMPL_COMPONENT_TYPES" );',
'let value = item.getValue();',
'if ( value.includes( "REGION_ONLY") ) {',
'    $( "input[value=PARTIAL],input[value=REPORT]", item.element ).prop( {',
'        "disabled": true,',
'        "checked": false',
'    } );',
'} else if ( value.includes( "REPORT" ) || value.includes( "PARTIAL" ) ) {',
'    $( "input[value=REGION_ONLY]", item.element ).prop( {',
'        "disabled": true,',
'        "checked": false',
'    } );',
'} else {',
'    $( "input[value=REGION_ONLY],input[value=REPORT],input[value=PARTIAL]", item.element ).prop( {',
'        "disabled": false',
'    } );',
'}'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(11093836624588027)
,p_name=>'Hide P4410_REFERENCE_ID'
,p_event_sequence=>290
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P4410_REFERENCE_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(11093971471588028)
,p_event_id=>wwv_flow_imp.id(11093836624588027)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_REFERENCE_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1421175358828803)
,p_name=>'afterRefrsh P4410_DEFAULT_SLOT_REGION'
,p_event_sequence=>300
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_DEFAULT_SLOT_REGION'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1421252352828804)
,p_event_id=>wwv_flow_imp.id(1421175358828803)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_name=>'Set Default Slots Region Value'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_DEFAULT_SLOT_REGION'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'apex.items.P4410_DEFAULT_SLOT_REGION_TEMP.value'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4000407010879403)
,p_name=>'Toggle Template Component Standard Attributes'
,p_event_sequence=>300
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_TMPL_COMPONENT_TYPES'
,p_condition_element=>'P4410_REFERENCE_ID'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4000563451879404)
,p_event_id=>wwv_flow_imp.id(4000407010879403)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'let item = apex.item( "P4410_TMPL_COMPONENT_TYPES" );',
'let value = item.getValue();',
'let targetItem = apex.item( "P4410_TEMPLATE_COMP_ATTRIBUTES" );',
'let targetOption = targetItem.element.find( "input[value=REGION_TEMPLATE]" );',
'if ( value.includes( "REGION_ONLY") ) {',
'    targetOption.prop( {',
'        "disabled": true,',
'        "checked": false',
'    } );',
'} else {',
'    targetOption.prop( {',
'        "disabled": false',
'    } );',
'}'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6200212588918102)
,p_name=>'Enable Has Region Template attribute by default'
,p_event_sequence=>310
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_TMPL_COMPONENT_TYPES'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(() => {',
'    let tempTypes = apex.item( "P4410_TMPL_COMPONENT_TYPES" ).getValue();',
'    return apex.item( "P4410_ID" ).getValue() === "" && tempTypes.length && tempTypes[ 0 ] !== "REGION_ONLY"',
'})() '))
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6200313425918103)
,p_event_id=>wwv_flow_imp.id(6200212588918102)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'let targetItem = apex.item( "P4410_TEMPLATE_COMP_ATTRIBUTES" );',
'targetItem.element.find( "input[value=REGION_TEMPLATE]" ).prop( { checked: true } );',
''))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(11096069664588049)
,p_name=>'Apply changes'
,p_event_sequence=>310
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(27902501930734562)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(11096168298588050)
,p_event_id=>wwv_flow_imp.id(11096069664588049)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'Are you sure you want to subscribe to the selected master plug-in? This will overwrite current plug-in data with selected master plug-in.'
,p_attribute_03=>'warning'
,p_attribute_06=>'Subscribe'
,p_attribute_07=>'Cancel'
,p_client_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_client_condition_expression=>'$v(''P4410_REFERENCE_ID'') !== "" && $v(''P4410_REFERENCE_ID_INIT'') === ""'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(16494015550178001)
,p_event_id=>wwv_flow_imp.id(11096069664588049)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'apply_changes'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1421774976828809)
,p_name=>'afterRefrsh P4410_DEFAULT_SLOT_ITEM'
,p_event_sequence=>320
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_DEFAULT_SLOT_ITEM'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1421811766828810)
,p_event_id=>wwv_flow_imp.id(1421774976828809)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_name=>'Set Default Slot Item Value'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_DEFAULT_SLOT_ITEM'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'apex.items.P4410_DEFAULT_SLOT_ITEM_TEMP.value'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1414489064026126)
,p_name=>'Enable / disable  / clear region types'
,p_event_sequence=>330
,p_triggering_element_type=>'COLUMN'
,p_triggering_region_id=>wwv_flow_imp.id(263527442738503017)
,p_triggering_element=>'HAS_REGION_SUPPORT'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1414568885026127)
,p_event_id=>wwv_flow_imp.id(1414489064026126)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Enable Supported Region Types'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'SUPPORTED_REGION_TYPES'
,p_client_condition_type=>'EQUALS'
,p_client_condition_elem_type=>'COLUMN'
,p_client_condition_element=>'HAS_REGION_SUPPORT'
,p_client_condition_expression=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1415167118026133)
,p_event_id=>wwv_flow_imp.id(1414489064026126)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_name=>'Clear Supported Region Types'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'SUPPORTED_REGION_TYPES'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_client_condition_type=>'EQUALS'
,p_client_condition_elem_type=>'COLUMN'
,p_client_condition_element=>'HAS_REGION_SUPPORT'
,p_client_condition_expression=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1415014262026132)
,p_event_id=>wwv_flow_imp.id(1414489064026126)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Disable Supported Region Types'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'SUPPORTED_REGION_TYPES'
,p_client_condition_type=>'EQUALS'
,p_client_condition_elem_type=>'COLUMN'
,p_client_condition_element=>'HAS_REGION_SUPPORT'
,p_client_condition_expression=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1422123137828813)
,p_name=>'afterRefrsh P4410_DEFAULT_SLOT_BUTTON'
,p_event_sequence=>330
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_DEFAULT_SLOT_BUTTON'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1422210511828814)
,p_event_id=>wwv_flow_imp.id(1422123137828813)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_name=>'Set Default Slot  Button Value'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_DEFAULT_SLOT_BUTTON'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'apex.items.P4410_DEFAULT_SLOT_BUTTON_TEMP.value'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1415260617026134)
,p_name=>'Enable / disable  / clear item types'
,p_event_sequence=>340
,p_triggering_element_type=>'COLUMN'
,p_triggering_region_id=>wwv_flow_imp.id(263527442738503017)
,p_triggering_element=>'HAS_ITEM_SUPPORT'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1415399562026135)
,p_event_id=>wwv_flow_imp.id(1415260617026134)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Enable Supported Item Types'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'SUPPORTED_ITEM_TYPES'
,p_client_condition_type=>'EQUALS'
,p_client_condition_elem_type=>'COLUMN'
,p_client_condition_element=>'HAS_ITEM_SUPPORT'
,p_client_condition_expression=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1415443905026136)
,p_event_id=>wwv_flow_imp.id(1415260617026134)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_name=>'Clear Supported Item Types'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'SUPPORTED_ITEM_TYPES'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_client_condition_type=>'EQUALS'
,p_client_condition_elem_type=>'COLUMN'
,p_client_condition_element=>'HAS_ITEM_SUPPORT'
,p_client_condition_expression=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1415505545026137)
,p_event_id=>wwv_flow_imp.id(1415260617026134)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Disable Supported Item Types'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'SUPPORTED_ITEM_TYPES'
,p_client_condition_type=>'EQUALS'
,p_client_condition_elem_type=>'COLUMN'
,p_client_condition_element=>'HAS_ITEM_SUPPORT'
,p_client_condition_expression=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1422555212828817)
,p_name=>'onSave Slots'
,p_event_sequence=>340
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(263527442738503017)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'NATIVE_IG|REGION TYPE|interactivegridsave'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1422653000828818)
,p_event_id=>wwv_flow_imp.id(1422555212828817)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_name=>'Set Default Slot Region'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_DEFAULT_SLOT_REGION_TEMP'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'apex.item("P4410_DEFAULT_SLOT_REGION").getValue()'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1422748608828819)
,p_event_id=>wwv_flow_imp.id(1422555212828817)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_name=>'Set Default Slot Item'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_DEFAULT_SLOT_ITEM_TEMP'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'apex.item("P4410_DEFAULT_SLOT_ITEM").getValue()'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1422885272828820)
,p_event_id=>wwv_flow_imp.id(1422555212828817)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_name=>'Set Default Slot Button'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_DEFAULT_SLOT_BUTTON_TEMP'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'apex.item("P4410_DEFAULT_SLOT_BUTTON").getValue()'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1422945965828821)
,p_event_id=>wwv_flow_imp.id(1422555212828817)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_DEFAULT_SLOT_REGION,P4410_DEFAULT_SLOT_ITEM,P4410_DEFAULT_SLOT_BUTTON'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1606183331945702)
,p_name=>'onClick HELP_SLOTS'
,p_event_sequence=>350
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1606036653945701)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1606299675945703)
,p_event_id=>wwv_flow_imp.id(1606183331945702)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_name=>'Open Region - Help Slots'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3053446993523770)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1506332479023803)
,p_name=>'Enable/Disable DA AI Checkboxes'
,p_event_sequence=>360
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4410_DYNAMIC_ACTIN_ATTRIBUTES'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1506461300023804)
,p_event_id=>wwv_flow_imp.id(1506332479023803)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4410_DYNAMIC_ACTIN_ATTRIBUTES'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'const attributes = apex.items.P4410_DYNAMIC_ACTIN_ATTRIBUTES.value;',
'const dependentAiCheckboxes$ = apex.jQuery( "input[value=AI_SYSTEM_PROMPT],input[value=AI_WELCOME_MESSAGE]", "#P4410_DYNAMIC_ACTIN_ATTRIBUTES" );',
'',
'if( attributes.includes( "AI_ENABLED_ALWAYS" ) || attributes.includes( "AI_ENABLED")  ) {',
'    dependentAiCheckboxes$.prop( "disabled", false );',
'} else {',
'    dependentAiCheckboxes$.prop( { "checked": false, "disabled": true } );',
'}'))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(439466610220411226)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Standard Attributes / Comp Types / API Version '
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P4410_STANDARD_ATTRIBUTES :=',
'    case :P4410_PLUGIN_TYPE',
'        when ''ITEM TYPE''           then :P4410_PAGE_ITEM_ATTRIBUTES',
'        when ''REPORT COLUMN TYPE''  then :P4410_PAGE_ITEM_ATTRIBUTES',
'        when ''REGION TYPE''         then :P4410_REGION_ATTRIBUTES',
'        when ''WEB SOURCE TYPE''     then :P4410_WEB_SOURCE_ATTRIBUTES',
'        when ''PROCESS TYPE''        then :P4410_PROCESS_ATTRIBUTES',
'        when ''DYNAMIC ACTION''      then :P4410_DYNAMIC_ACTIN_ATTRIBUTES',
'        when ''AUTHENTICATION TYPE'' then :P4410_AUTHENTCATION_ATTRIBUTES',
'        when ''TEMPLATE COMPONENT''  then :P4410_TEMPLATE_COMP_ATTRIBUTES',
'    end;',
'',
':P4410_DEFAULT_ESCAPE_MODE :=',
'    case :P4410_PLUGIN_TYPE',
'        when ''TEMPLATE COMPONENT''  then :P4410_DEFAULT_ESCAPE_MODE',
'    end;',
'',
':P4410_SUPPORTED_COMP_TYPES :=',
'    case :P4410_PLUGIN_TYPE',
'        when ''ITEM TYPE''           then :P4410_ITEM_COMPONENT_TYPES',
'        when ''PROCESS TYPE''        then :P4410_PROCESS_COMPONENT_TYPES',
'        when ''TEMPLATE COMPONENT''  then :P4410_TMPL_COMPONENT_TYPES',
'    end;',
'',
':P4410_API_VERSION :=',
'    case :P4410_PLUGIN_TYPE',
'        when ''ITEM TYPE''           then :P4410_API_VERSION_ITEM',
'        when ''REGION TYPE''         then :P4410_API_VERSION_REGION',
'        else ''1''',
'    end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>439466610220411226
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2402564151101813)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(2675372452330944)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Attribute Groups - Save Interactive Grid Data (PL/SQL)'
,p_attribute_01=>'PLSQL_CODE'
,p_attribute_04=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.store_attribute_group (',
'        p_id               => :ID,',
'        p_application_id   => :FB_FLOW_ID,',
'        p_action           => :APEX$ROW_STATUS,',
'        p_plugin_id        => :P4410_ID,',
'        p_title            => :TITLE,',
'        p_display_sequence => :DISPLAY_SEQUENCE );',
'end;'))
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'Delete'
,p_process_when_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_internal_uid=>2402564151101813
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(27908610123734606)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_PLUGINS_DEV'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_PLUGINS_DEV'
,p_attribute_03=>'P4410_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_process_error_message=>'Error processing row.'
,p_process_success_message=>'Action processed.'
,p_internal_uid=>27908610123734606
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1652888803240834)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(1651611827240822)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Events - Save Interactive Grid Data'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'Delete'
,p_process_when_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_internal_uid=>1652888803240834
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(30289491586650247)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Report scope custom attributes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    -- delete all "Report" attributes if the template component does not',
'    -- support "Multiple (Report)"',
'    if   :P4410_TMPL_COMPONENT_TYPES not like ''%REPORT%''',
'      or :P4410_TMPL_COMPONENT_TYPES is null',
'    then',
'        delete wwv_flow_plugin_attributes',
'         where plugin_id         = :P4410_ID',
'           and security_group_id = :WORKSPACE_ID',
'           and attribute_scope   = ''REPORT'';',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P4410_PLUGIN_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'TEMPLATE COMPONENT'
,p_internal_uid=>30289491586650247
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(791008837851651124)
,p_process_sequence=>80
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Synchronize additional standard attribute meta data'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.synchronize_std_attributes (',
'        p_application_id => to_number(:FB_FLOW_ID),',
'        p_plugin_type    => :P4410_PLUGIN_TYPE,',
'        p_plugin_name    => :P4410_NAME);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'apply_changes:CREATE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_internal_uid=>791008837851651124
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(24025130578997830)
,p_process_sequence=>90
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Synchronize standard attribute values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.synchronize_attribute_columns (',
'        p_application_id => to_number(:FB_FLOW_ID),',
'        p_plugin_type    => :P4410_PLUGIN_TYPE,',
'        p_plugin_name    => :P4410_NAME,',
'        p_action         => ''PLUGIN'' );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'Delete'
,p_process_when_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_internal_uid=>24025130578997830
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(15066327223640442)
,p_process_sequence=>100
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Plug-in Settings'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.delete_plugin_settings (',
'        p_application_id => :P4410_FLOW_ID,',
'        p_plugin_type    => :P4410_PLUGIN_TYPE,',
'        p_plugin         => ''PLUGIN_'' || :P4410_NAME );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(27903106352734562)
,p_internal_uid=>15066327223640442
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(32730610240734651)
,p_process_sequence=>110
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh plugin'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_plugin_dev.subscribe_plugin (',
'    p_master_plugin_id      => :P4410_REFERENCE_ID,',
'    p_subscribing_plugin_id => :P4410_ID );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error refreshing plug-in.'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST = ''REFRESH_PLUGIN''',
'or ( :REQUEST = ''apply_changes'' and :P4410_REFERENCE_ID is not null and :P4410_REFERENCE_ID_INIT is null )'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Plug-in refreshed.'
,p_internal_uid=>32730610240734651
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(30856727586553252)
,p_process_sequence=>130
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete all files'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    delete wwv_flow_plugin_files',
'     where flow_id           = :P4410_FLOW_ID',
'       and plugin_id         = :P4410_ID',
'       and security_group_id = :WORKSPACE_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(30855910247544017)
,p_process_success_message=>'Files deleted'
,p_internal_uid=>30856727586553252
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(9812720571144412)
,p_process_sequence=>140
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Synchronize custom attributes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.synchronize_cust_attributes (',
'        p_application_id => to_number(:FB_FLOW_ID),',
'        p_plugin_name    => wwv_flow_template_directive.get_name (',
'                                p_name                => :P4410_NAME,',
'                                p_theme_id            => :P4410_THEME_ID,',
'                                p_for_using_component => false )',
'        );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':REQUEST in ( ''SYNCHRONIZE_ATTRIBUTES'', ''CREATE'' ) and :P4410_PLUGIN_TYPE = ''TEMPLATE COMPONENT'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Attributes synchronized'
,p_internal_uid=>9812720571144412
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2522999333409116)
,p_process_sequence=>150
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Unsubscribe Plug-in Settings'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_plugin_dev.unsubscribe_plugin_settings (',
'    p_plugin_id => :P4410_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(27902501930734562)
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P4410_SUBSCRIBE_PLGIN_SETTINGS = ''N'' and :P4410_PLUGIN_SETTINGS_INIT = ''Y''',
'-- clear reference_id from wwv_flow_plugin_settings table when plug-in is unsubscribed',
'or ( :P4410_REFERENCE_ID is null and :P4410_REFERENCE_ID_INIT is not null )'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>2522999333409116
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2523048224409117)
,p_process_sequence=>160
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Subscribe Plug-in Settings'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_plugin_dev.subscribe_plugin_settings (',
'    p_plugin_id        => :P4410_ID,',
'    p_master_plugin_id => :P4410_REFERENCE_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(27902501930734562)
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P4410_REFERENCE_ID is not null',
' and :P4410_SUBSCRIBE_PLGIN_SETTINGS = ''Y''',
' and ( nvl(:P4410_PLUGIN_SETTINGS_INIT,''N'') = ''N'' ',
'       -- master plug-in changed, then we need to change derive reference_id again ',
'       -- for wwv_flow_plugin_settings table',
'       or  :P4410_REFERENCE_ID != :P4410_REFERENCE_ID_INIT )'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>2523048224409117
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(11094602392588035)
,p_process_sequence=>160
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Unsubscribe plugin'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.unsubscribe_component (',
'    p_component_type  => wwv_flow_copy_metadata.c_plugin,',
'    p_component_id    => :P4410_ID,',
'    p_app_id          => :FB_FLOW_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(11094566030588034)
,p_process_success_message=>'Plug-in is no longer subscribed to its master plug-in.'
,p_internal_uid=>11094602392588035
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1423686827828828)
,p_process_sequence=>170
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(263527442738503017)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Slots - Save Interactive Grid Data'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>1423686827828828
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(30856901744555241)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_DOWNLOAD'
,p_process_name=>'Download Files as Zip'
,p_attribute_01=>'Y'
,p_attribute_02=>'plugin_files.zip'
,p_attribute_04=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select file_content,',
'       file_name',
'  from wwv_flow_plugin_files',
' where flow_id           = :P4410_FLOW_ID',
'   and plugin_id         = :P4410_ID',
'   and security_group_id = :WORKSPACE_ID',
' order by file_name'))
,p_process_when=>'FILES_DOWNLOAD_ZIP'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_internal_uid=>30856901744555241
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(27908232345734599)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_PLUGINS_DEV'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_PLUGINS_DEV'
,p_attribute_03=>'P4410_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_process_error_message=>'Error fetching row.'
,p_internal_uid=>27908232345734599
);
end;
/
prompt --application/pages/page_04411
begin
wwv_flow_imp_page.create_page(
 p_id=>4411
,p_name=>'Edit Meta Data Plug-in Standard  Attribute'
,p_alias=>'EDIT-META-DATA-PLUG-IN-STANDARD-ATTRIBUTE'
,p_step_title=>'Edit Meta Data Plug-in Standard  Attribute'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(27816729931938405)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
' htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';',
'',
'</script>'))
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'EXISTS'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugins',
' where id                = :P4411_PLUGIN_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and reference_id      is not null'))
,p_help_text=>'advnc_plugins.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(885670354491824879)
,p_plug_name=>'Name'
,p_region_name=>'NAME'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(885689667799324159)
,p_plug_name=>'Attributes'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Edit additional meta data for plug-in standard attributes. Based on this data, Page Designer will validate attribute values and display help texts or examples.</p>'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(885690376111326555)
,p_plug_name=>'Help Text and Examples'
,p_region_name=>'HELP_TEXT'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>200
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(885693371964401096)
,p_plug_name=>'Plug-in: &P4411_PLUGIN_DISPLAY_NAME.'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>5
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(885699281370507840)
,p_plug_name=>'Settings'
,p_region_name=>'SETTINGS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>130
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(885709874827158803)
,p_plug_name=>'Default Value'
,p_region_name=>'DEFAULT'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>157
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(885751479252954694)
,p_plug_name=>'Comments'
,p_region_name=>'COMMENTS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>220
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1008572563940076363)
,p_plug_name=>'Anchors'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1026674371687481642)
,p_plug_name=>'Condition'
,p_region_name=>'TRIGGERING_EVENT_CONDITION'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>179
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1098958249230563891)
,p_plug_name=>'Supported for'
,p_region_name=>'UI'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>189
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(837273289146611816)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(885693371964401096)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:4410:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(837274072985611818)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(885693371964401096)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>':P4411_ID is not null and not wwv_flow_region.is_read_only'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(837343803566611952)
,p_branch_action=>'f?p=&APP_ID.:4410:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>149
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(791008994665651125)
,p_name=>'P4411_DISPLAY_NAME_ITEM'
,p_item_sequence=>55
,p_item_plug_id=>wwv_flow_imp.id(885670354491824879)
,p_prompt=>'Standard Attribute'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PLUGIN.ITEM_ATTRIBUTES'
,p_lov=>'.'||wwv_flow_imp.id(439387913761867364)||'.'
,p_cHeight=>1
,p_display_when=>'P4411_PLUGIN_TYPE'
,p_display_when2=>'ITEM TYPE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the label which is displayed for that attribute in the &PRODUCT_NAME. Builder.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(791009042670651126)
,p_name=>'P4411_PLUGIN_TYPE'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_imp.id(885670354491824879)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(791009195646651127)
,p_name=>'P4411_DISPLAY_NAME_REGION'
,p_item_sequence=>65
,p_item_plug_id=>wwv_flow_imp.id(885670354491824879)
,p_prompt=>'Standard Attribute'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PLUGIN.REGION_ATTRIBUTES'
,p_lov=>'.'||wwv_flow_imp.id(439394121736945367)||'.'
,p_cHeight=>1
,p_display_when=>'P4411_PLUGIN_TYPE'
,p_display_when2=>'REGION TYPE'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the label which is displayed for that attribute in the &PRODUCT_NAME. Builder.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(791009234426651128)
,p_name=>'P4411_DISPLAY_NAME_DYNACT'
,p_item_sequence=>75
,p_item_plug_id=>wwv_flow_imp.id(885670354491824879)
,p_prompt=>'Standard Attribute'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PLUGIN.DYNAMIC_ACTION_ATTRIBUTES'
,p_lov=>'.'||wwv_flow_imp.id(439399613733990280)||'.'
,p_cHeight=>1
,p_display_when=>'P4411_PLUGIN_TYPE'
,p_display_when2=>'DYNAMIC ACTION'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the label which is displayed for that attribute in the &PRODUCT_NAME. Builder.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(791009891502651134)
,p_name=>'P4411_DEPENDING_ON_HAS_TO_EXIST'
,p_item_sequence=>45
,p_item_plug_id=>wwv_flow_imp.id(1026674371687481642)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Always Evaluate'
,p_source=>'DEPENDING_ON_HAS_TO_EXIST'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>If set to <strong>On</strong>, the condition will always be evaluated and as a pre-requirement the depending on attribute has to be rendered. If set to <strong>Off</strong>, the condition will still be evaluated when the depending on attribute has'
||' been rendered, however if the depending on attribute has not NOT been rendered, the condition will not be evaluated.</p>',
'',
'<p>This may be useful, for example if the depending on attribute itself has a condition (for example it only supports certain component types), and where you still want the current attribute to be rendered in the case where the depending on attribute'
||'''s condition fails.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(837264113304611792)
,p_name=>'P4411_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(885670354491824879)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(837264402593611800)
,p_name=>'P4411_IS_IN_USE'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(885670354491824879)
,p_prompt=>'Is In Use'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>1
,p_cMaxlength=>1
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(837265250046611801)
,p_name=>'P4411_PLUGIN_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(885670354491824879)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Plugin Id'
,p_source=>'PLUGIN_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(837265664654611801)
,p_name=>'P4411_FLOW_ID'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_imp.id(885670354491824879)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Flow Id'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(837268702458611807)
,p_name=>'P4411_NAME'
,p_item_sequence=>45
,p_item_plug_id=>wwv_flow_imp.id(885670354491824879)
,p_use_cache_before_default=>'NO'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Specify the label which is displayed for that attribute in the &PRODUCT_NAME. Builder.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(837271178916611814)
,p_name=>'P4411_HELP_TEXT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(885690376111326555)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Help Text'
,p_source=>'HELP_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>8
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'<p>Specify help text for this plug-in attribute. The help text is displayed as context sensitive help for the attribute in the Builder.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(837272079297611815)
,p_name=>'P4411_EXAMPLES'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(885690376111326555)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Examples'
,p_source=>'EXAMPLES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>8
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Specify examples for this plug-in attribute. The examples are displayed as part of the context sensitive help for the attribute in the Builder.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(837276019325611820)
,p_name=>'P4411_PLUGIN_DISPLAY_NAME'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_imp.id(885693371964401096)
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name',
'  from wwv_flow_plugins',
' where id = :P4411_PLUGIN_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Selected plug-in.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(837281586765611836)
,p_name=>'P4411_IS_REQUIRED'
,p_is_required=>true
,p_item_sequence=>95
,p_item_plug_id=>wwv_flow_imp.id(885699281370507840)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Required'
,p_source=>'IS_REQUIRED'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify if this attribute must contain a value.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(837285105475611841)
,p_name=>'P4411_SQL_MIN_COLUMN_COUNT'
,p_item_sequence=>135
,p_item_plug_id=>wwv_flow_imp.id(885699281370507840)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Minimum Columns'
,p_source=>'SQL_MIN_COLUMN_COUNT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>3
,p_cMaxlength=>3
,p_display_when=>'P4411_NAME'
,p_display_when2=>'SOURCE_PLSQL_FUNCTION:SOURCE_SQL:LOV:SOURCE_PLSQL'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Minimum number of columns that the SQL query has to select.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'999'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(837286061813611842)
,p_name=>'P4411_SQL_MAX_COLUMN_COUNT'
,p_item_sequence=>145
,p_item_plug_id=>wwv_flow_imp.id(885699281370507840)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Maximum Columns'
,p_source=>'SQL_MAX_COLUMN_COUNT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>3
,p_cMaxlength=>3
,p_display_when=>'P4411_NAME'
,p_display_when2=>'SOURCE_PLSQL_FUNCTION:SOURCE_SQL:LOV:SOURCE_PLSQL'
,p_display_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Maximum number of columns that the SQL query can select.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'999'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(837292118883611851)
,p_name=>'P4411_DEFAULT_VALUE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(885709874827158803)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Default Value'
,p_source=>'DEFAULT_VALUE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify a default value for this plug-in attribute. The default value is used when a new component is created that uses this plug-in.</p>',
'<p>',
'Use Y and N for attributes of type "Yes/No".',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(837293390646611852)
,p_name=>'P4411_ATTRIBUTE_COMMENT'
,p_item_sequence=>131
,p_item_plug_id=>wwv_flow_imp.id(885751479252954694)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comments'
,p_source=>'ATTRIBUTE_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'<p>Enter any comments or notes here.  These comments will never be displayed when running the application.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(837297569655611861)
,p_name=>'P4411_DEPENDING_ON_ATTRIBUTE_ID'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_imp.id(1026674371687481642)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Depending on'
,p_source=>'DEPENDING_ON_ATTRIBUTE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select prompt,',
'       id',
'  from wwv_flow_plugin_attributes ca',
' where plugin_id       = to_number(:P4411_PLUGIN_ID)',
'   and attribute_scope = ''COMPONENT'' ',
' order by attribute_sequence'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Not Dependent -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select the attribute the current attribute depends on. For example, only show the current attribute if "Orientation" is equal to "VERTICAL".'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(837298436974611865)
,p_name=>'P4411_DEPENDING_ON_CONDITION_TYPE'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_imp.id(1026674371687481642)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Condition Type'
,p_source=>'DEPENDING_ON_CONDITION_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PLUGIN.ATTRIBUTE.CONDITION_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(189411726584965751)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Condition Type -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select a condition type that must be met in order for this attribute to render.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(837299328301611869)
,p_name=>'P4411_DEPENDING_ON_EXPRESSION'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_imp.id(1026674371687481642)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Expression'
,p_source=>'DEPENDING_ON_EXPRESSION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter values in this attribute based on the specific condition type selected. If you have selected "in list" or "not in list", enter values separated by a comma. Don''t add a blank before or after the comma if that isn''t included in the value which yo'
||'u want to compare.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(837301894706611872)
,p_name=>'P4411_SUPPORTED_COMP_TYPES'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1098958249230563891)
,p_use_cache_before_default=>'NO'
,p_source=>'SUPPORTED_COMPONENT_TYPES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(837306319081611902)
,p_computation_sequence=>70
,p_computation_item=>'P4411_DEPENDING_ON_CONDITION_TYPE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'NULL'
,p_compute_when=>'P4411_DEPENDING_ON_ATTRIBUTE_ID'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(837306770271611902)
,p_computation_sequence=>80
,p_computation_item=>'P4411_DEPENDING_ON_EXPRESSION'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'NULL'
,p_compute_when=>'P4411_DEPENDING_ON_CONDITION_TYPE'
,p_compute_when_text=>'EQUALS:NOT_EQUALS:IN_LIST:NOT_IN_LIST'
,p_compute_when_type=>'VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(791009349206651129)
,p_computation_sequence=>10
,p_computation_item=>'P4411_DISPLAY_NAME_ITEM'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P4411_NAME'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(791009453432651130)
,p_computation_sequence=>20
,p_computation_item=>'P4411_DISPLAY_NAME_REGION'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P4411_NAME'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(791009555092651131)
,p_computation_sequence=>30
,p_computation_item=>'P4411_DISPLAY_NAME_DYNACT'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P4411_NAME'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(837312359249611911)
,p_validation_name=>'P4411_DEPENDING_ON_CONDITION_TYPE not null'
,p_validation_sequence=>240
,p_validation=>'P4411_DEPENDING_ON_CONDITION_TYPE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_validation_condition=>'P4411_DEPENDING_ON_ATTRIBUTE_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_imp.id(837298436974611865)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(837312796893611912)
,p_validation_name=>'P4411_DEPENDING_ON_EXPRESSION not null'
,p_validation_sequence=>250
,p_validation=>'P4411_DEPENDING_ON_EXPRESSION'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_validation_condition=>'P4411_DEPENDING_ON_CONDITION_TYPE'
,p_validation_condition2=>'EQUALS:NOT_EQUALS:IN_LIST:NOT_IN_LIST'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_associated_item=>wwv_flow_imp.id(837299328301611869)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(837334909933611940)
,p_name=>'Condition'
,p_event_sequence=>175
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4411_DEPENDING_ON_ATTRIBUTE_ID'
,p_condition_element=>'P4411_DEPENDING_ON_ATTRIBUTE_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(837336922911611941)
,p_event_id=>wwv_flow_imp.id(837334909933611940)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4411_DEPEND_ON_HAS_TO_EXIST'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(845305462628934503)
,p_event_id=>wwv_flow_imp.id(837334909933611940)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4411_DEPENDING_ON_HAS_TO_EXIST'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(837335498081611941)
,p_event_id=>wwv_flow_imp.id(837334909933611940)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4411_DEPENDING_ON_CONDITION_TYPE'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(837336415830611941)
,p_event_id=>wwv_flow_imp.id(837334909933611940)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4411_DEPEND_ON_HAS_TO_EXIST'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(837335904226611941)
,p_event_id=>wwv_flow_imp.id(837334909933611940)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4411_DEPENDING_ON_CONDITION_TYPE,P4411_DEPENDING_ON_EXPRESSION'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(845305310758934502)
,p_event_id=>wwv_flow_imp.id(837334909933611940)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4411_DEPENDING_ON_HAS_TO_EXIST'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(837337399890611942)
,p_name=>'Condition Type'
,p_event_sequence=>185
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4411_DEPENDING_ON_CONDITION_TYPE'
,p_condition_element=>'P4411_DEPENDING_ON_CONDITION_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'EQUALS,NOT_EQUALS,IN_LIST,NOT_IN_LIST'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(837337858168611942)
,p_event_id=>wwv_flow_imp.id(837337399890611942)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4411_DEPENDING_ON_EXPRESSION'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(837338340207611942)
,p_event_id=>wwv_flow_imp.id(837337399890611942)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4411_DEPENDING_ON_EXPRESSION'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(837314230198611913)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_PLUGIN_ATTRIBUTES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_PLUGIN_STD_ATTRIBUTES'
,p_attribute_03=>'P4411_ID'
,p_attribute_04=>'ID'
,p_process_error_message=>'Unable to fetch row.'
,p_internal_uid=>837314230198611913
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(837313833612611913)
,p_process_sequence=>50
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set P4411_IS_IN_USE'
,p_process_sql_clob=>':P4411_IS_IN_USE := case when wwv_flow_plugin_dev.is_in_use(:P4411_PLUGIN_ID) then ''Y'' end;'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P4411_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>837313833612611913
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(837314609240611914)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_PLUGIN_ATTRIBUTES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_PLUGIN_STD_ATTRIBUTES'
,p_attribute_03=>'P4411_ID'
,p_attribute_04=>'ID'
,p_attribute_09=>'P4411_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_process_error_message=>'Unable to process row of table WWV_FLOW_PLUGIN_ATTRIBUTES.'
,p_process_when=>'not wwv_flow_page.is_read_only'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>837314609240611914
);
end;
/
prompt --application/pages/page_04415
begin
wwv_flow_imp_page.create_page(
 p_id=>4415
,p_name=>'Edit Plug-in Attribute'
,p_alias=>'EDIT-PLUG-IN-ATTRIBUTE'
,p_step_title=>'Edit Plug-in Attribute'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(27816729931938405)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
' htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';',
'',
'</script>'))
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'EXISTS'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugins',
' where id                = :P4415_PLUGIN_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and reference_id      is not null'))
,p_help_text=>'advnc_plugins.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1482891480055201)
,p_plug_name=>'Accessibility'
,p_region_name=>'ACCESSIBILITY_HELP_TEXT'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>207
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1920770738465813)
,p_plug_name=>'Demo Value'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>217
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P4415_PLUGIN_TYPE'
,p_plug_display_when_cond2=>'TEMPLATE COMPONENT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(48406905308213111)
,p_plug_name=>'Name'
,p_region_name=>'NAME'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(48426218615712391)
,p_plug_name=>'Attributes'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>A plug-in attribute is used to prompt the developer for additional data in the Builder when the plug-in is used.</p>'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(48426926927714787)
,p_plug_name=>'Help Text and Examples'
,p_region_name=>'HELP_TEXT'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>197
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(48429922780789328)
,p_plug_name=>'Plug-in: &P4415_PLUGIN_DISPLAY_NAME.'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>5
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(48435832186896072)
,p_plug_name=>'Settings'
,p_region_name=>'SETTINGS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>130
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(48446425643547035)
,p_plug_name=>'Default Value'
,p_region_name=>'DEFAULT'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>157
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(48488030069342926)
,p_plug_name=>'Comments'
,p_region_name=>'COMMENTS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>227
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(171309114756464595)
,p_plug_name=>'Anchors'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(184705009472204046)
,p_name=>'Static List of Values'
,p_region_name=>'STATIC_LOV'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>155
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_sequence,',
'       display_value,',
'       return_value,',
'       id',
'  from wwv_flow_plugin_attr_values',
' where plugin_attribute_id = to_number(:P4415_ID)',
'   and security_group_id   = to_number(:WORKSPACE_ID)',
' order by display_sequence, display_value'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>999
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No values defined.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(184705316368204050)
,p_query_column_id=>1
,p_column_alias=>'DISPLAY_SEQUENCE'
,p_column_display_sequence=>1
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(184705413106204050)
,p_query_column_id=>2
,p_column_alias=>'DISPLAY_VALUE'
,p_column_display_sequence=>2
,p_column_heading=>'Display'
,p_use_as_row_header=>'Y'
,p_column_link=>'javascript:apex.submit({request:''APPLY_CHANGES_EDIT_4416'',set:{''P4415_ATTRIBUTE_VALUE_ID'':''#ID#''}});'
,p_column_linktext=>'#DISPLAY_VALUE#'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(184705516154204051)
,p_query_column_id=>3
,p_column_alias=>'RETURN_VALUE'
,p_column_display_sequence=>3
,p_column_heading=>'Return'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(184706703632230704)
,p_query_column_id=>4
,p_column_alias=>'ID'
,p_column_display_sequence=>4
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(189410922503869874)
,p_plug_name=>'Condition'
,p_region_name=>'TRIGGERING_EVENT_CONDITION'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>177
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(261694800046952123)
,p_plug_name=>'Supported for'
,p_region_name=>'UI'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>187
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P4415_PLUGIN_TYPE'
,p_plug_display_when_cond2=>'TEMPLATE COMPONENT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(361914528060159138)
,p_plug_name=>'Component List of Values'
,p_region_name=>'COMPONENT_LOV'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>140
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'WORKSPACE_ID'
,p_plug_display_when_cond2=>'10'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(184715709275364731)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(184705009472204046)
,p_button_name=>'ADD_VALUE_CREATE_MODE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Add Value'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'javascript:apex.submit({request:''INSERT''});'
,p_button_condition=>':P4415_ID is null and not wwv_flow_region.is_read_only'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(186269904054873930)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_imp.id(184705009472204046)
,p_button_name=>'ADD_VALUE_UPDATE_MODE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Add Value'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'javascript:apex.submit({request:''APPLY_CHANGES_CREATE_4416''});'
,p_button_condition=>':P4415_ID is not null and not wwv_flow_region.is_read_only'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(48407527404213125)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(48429922780789328)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:4410:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(48407317470213118)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(48429922780789328)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(htmldb_delete_message,''DELETE'');'
,p_button_execute_validations=>'N'
,p_button_condition=>':P4415_ID is not null and not wwv_flow_region.is_read_only'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(48407222371213118)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(48429922780789328)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>':P4415_ID is not null and not wwv_flow_region.is_read_only'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(48407120986213118)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(48429922780789328)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>':P4415_ID is null and not wwv_flow_region.is_read_only'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(48415410595256026)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(48429922780789328)
,p_button_name=>'CREATE_AGAIN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Create and Create Another'
,p_button_position=>'NEXT'
,p_button_condition=>':P4415_ID is null and not wwv_flow_region.is_read_only'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(48451130677610984)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(48429922780789328)
,p_button_name=>'APPLY_CHANGES_GET_PREVIOUS_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'disabled=""'
,p_button_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(48451017903610984)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(48429922780789328)
,p_button_name=>'APPLY_CHANGES_GET_NEXT_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Next'
,p_button_position=>'PREVIOUS'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'disabled=""'
,p_button_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(184834804613527132)
,p_branch_action=>'f?p=&APP_ID.:4416:&SESSION.::&DEBUG.:4416:P4416_ID:&P4415_ATTRIBUTE_VALUE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>21
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_EDIT_4416'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(184835319850531488)
,p_branch_action=>'f?p=&APP_ID.:4416:&SESSION.::&DEBUG.:4416:P4416_PLUGIN_ATTRIBUTE_ID:&P4415_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>31
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':REQUEST in (''INSERT'', ''APPLY_CHANGES_CREATE_4416'')'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(48415825963269832)
,p_branch_name=>'Go To Page 4415'
,p_branch_action=>'f?p=&APP_ID.:4415:&SESSION.::&DEBUG.:4415:P4415_PLUGIN_ID,P4415_PLUGIN_TYPE:&P4415_PLUGIN_ID.,&P4415_PLUGIN_TYPE.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(48415410595256026)
,p_branch_sequence=>51
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(48453932471611004)
,p_branch_name=>'Go To Page 4415'
,p_branch_action=>'f?p=&APP_ID.:4415:&SESSION.::&DEBUG.::P4415_ID:&P4415_ID_PREV.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(48451130677610984)
,p_branch_sequence=>54
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(48453713720611003)
,p_branch_name=>'Go To Page 4415'
,p_branch_action=>'f?p=&APP_ID.:4415:&SESSION.::&DEBUG.::P4415_ID:&P4415_ID_NEXT.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(48451017903610984)
,p_branch_sequence=>55
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(48427804332727252)
,p_branch_action=>'f?p=&APP_ID.:4415:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>61
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P4415_RETURN_TO_PAGE'
,p_branch_condition_text=>'YES'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(48408107125213133)
,p_branch_action=>'f?p=&APP_ID.:4410:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>149
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1482925959055202)
,p_name=>'P4415_ACCESSIBILITY_HELP_TEXT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1482891480055201)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Accessibility Help Text'
,p_source=>'ACCESSIBILITY_HELP_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>8
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'<p>Specify accessibility help text for this plug-in attribute. If defined, the accessibility help text is displayed after the standard help text for the attribute.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1653549584240841)
,p_name=>'P4415_ATTRIBUTE_GROUP_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(48406905308213111)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Attribute Group'
,p_source=>'ATTRIBUTE_GROUP_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select title as d,',
'       id as r',
'  from wwv_flow_plugin_attr_groups',
' where plugin_id = to_number(:P4415_PLUGIN_ID)',
'   and security_group_id = :WORKSPACE_ID',
' order by 1 asc'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Settings'
,p_cHeight=>1
,p_display_when=>':P4415_PLUGIN_TYPE in ( ''REGION TYPE'', ''ITEM TYPE'', ''PROCESS TYPE'', ''DYNAMIC ACTION'', ''TEMPLATE COMPONENT'' )'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'<p>Specify the group in Page Designer where this attribute will be displayed.</p>'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1920838396465814)
,p_name=>'P4415_DEMO_VALUE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1920770738465813)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Demo Value'
,p_source=>'DEMO_VALUE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify a demo value for this plug-in attribute. The demo value is used when a new page is created that uses this plug-in.</p>',
'<p>The demo value might differ from the default value to create a working example that demonstrates the features of the plug-in.',
'All required attributes have to have a demo or default value. The demo value of depending attributes has to match the demo value of the depending attribute.</p>',
'<p>Use <code>Y</code> and <code>N</code> for attributes of type "Yes/No". Use a random value like <code>Lorem Ipsum</code> for attributes of type "Session State Value".</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2000343320799901)
,p_name=>'P4415_IMPORTANT_FOR_ACCESSIBILITY'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1482891480055201)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Important For Accessibility'
,p_source=>'IMPORTANT_FOR_ACCESSIBILITY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify if this custom plugin attribute is important for Accessibility.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2029958216167737)
,p_name=>'P4415_PROCESS_COMPONENT_TYPES'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(261694800046952123)
,p_prompt=>'Component Type'
,p_source=>'P4415_SUPPORTED_COMP_TYPES'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PLUGIN_PROCESS_TYPE_COMPONENT_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(1800185422847060)||'.'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugins',
' where id                = :P4415_PLUGIN_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and plugin_type       = ''PROCESS TYPE'''))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Specifies if the plug-in attribute is displayed in the Builder for Page Items and Interactive Grid Columns. If no supported type is set then it will always be displayed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2831529779618417)
,p_name=>'P4415_ESCAPE_MODE'
,p_item_sequence=>225
,p_item_plug_id=>wwv_flow_imp.id(48435832186896072)
,p_use_cache_before_default=>'NO'
,p_item_default=>'HTML'
,p_prompt=>'Escape Mode'
,p_source=>'ESCAPE_MODE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PLUGIN.ESCAPE_MODE'
,p_lov=>'.'||wwv_flow_imp.id(2201509320945428)||'.'
,p_cHeight=>1
,p_display_when=>'P4415_PLUGIN_TYPE'
,p_display_when2=>'TEMPLATE COMPONENT'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'The Escape Mode is used when the placeholder for this attribute is substituted in the template.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9813270736144417)
,p_name=>'P4415_PLUGIN_TYPE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(48406905308213111)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9813324748144418)
,p_name=>'P4415_STATIC_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(48406905308213111)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Static ID'
,p_source=>'STATIC_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_display_when=>':P4415_PLUGIN_TYPE in (''TEMPLATE COMPONENT'', ''REGION TYPE'')'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_read_only_when=>'P4415_IS_IN_USE'
,p_read_only_when2=>'Y'
,p_read_only_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify the Static ID for this attribute.</p>',
'<p>Template component plug-ins should use uppercase IDs such as <code>MY_PLACEHOLDER</code>. The attribute value can then be referenced in the template by using the substitution syntax <code>#MY_PLACEHOLDER#</code>.</p>',
'<p>Region plug-ins should use lowercase IDs such as <code>my_static_id</code>. The attribute value can then be referenced in the code via <code>p_region.attributes.get_varchar2(''my_static_id'')</code>.</p>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(24177601344122901)
,p_name=>'P4415_COLUMN_DATA_TYPES'
,p_item_sequence=>175
,p_item_plug_id=>wwv_flow_imp.id(48435832186896072)
,p_use_cache_before_default=>'NO'
,p_item_default=>'VARCHAR2'
,p_prompt=>'Data Types'
,p_source=>'COLUMN_DATA_TYPES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PLUGIN.ATTRIBUTE.COLUMN_DATA_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(24174232595113027)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specifies the data types of which the selected column has to be. If the data type "Varchar2" has been checked then the column can be of any data type except "Blob" and "Bfile", because all of these data types can be converted to a "Varchar2". If no d'
||'ata type is checked, the selected column can be of any data type.',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48408318304213142)
,p_name=>'P4415_ID'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(48406905308213111)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48408508921213164)
,p_name=>'P4415_PLUGIN_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(48406905308213111)
,p_use_cache_before_default=>'NO'
,p_source=>'PLUGIN_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48408925689213174)
,p_name=>'P4415_ATTRIBUTE_SEQUENCE'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(48406905308213111)
,p_use_cache_before_default=>'NO'
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_next_sequence number;',
'begin',
'    select coalesce(max(attribute_sequence), 0)+1',
'      into l_next_sequence',
'      from wwv_flow_plugin_attributes',
'     where plugin_id             = to_number(:P4415_PLUGIN_ID)',
'       and security_group_id     = :WORKSPACE_ID',
'       and (  attribute_scope    = :P4415_ATTRIBUTE_SCOPE',
'           or :P4415_PLUGIN_TYPE = ''TEMPLATE COMPONENT''',
'           );',
'',
'    return l_next_sequence;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Attribute'
,p_source=>'ATTRIBUTE_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>4
,p_cMaxlength=>3
,p_read_only_when=>'P4415_IS_IN_USE'
,p_read_only_when2=>'Y'
,p_read_only_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Sequence which correlates with the <code>ATTRIBUTE_XX</code> columns (for example in <code>APEX_APPLICATION_PAGE_ITEMS</code>) and to the PL/SQL types defined in the package <code>apex_plugin</code></p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'decimal'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48409303076213175)
,p_name=>'P4415_PROMPT'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(48406905308213111)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Label'
,p_source=>'PROMPT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify the label which is displayed for that attribute in the &PRODUCT_NAME. Builder.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48409725092213176)
,p_name=>'P4415_HELP_TEXT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(48426926927714787)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Help Text'
,p_source=>'HELP_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>8
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'<p>Specify help text for this plug-in attribute. The help text is displayed as context sensitive help for the attribute in the Builder.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48409929706213176)
,p_name=>'P4415_ATTRIBUTE_TYPE'
,p_is_required=>true
,p_item_sequence=>45
,p_item_plug_id=>wwv_flow_imp.id(48435832186896072)
,p_use_cache_before_default=>'NO'
,p_item_default=>'TEXT'
,p_prompt=>'Type'
,p_source=>'ATTRIBUTE_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PLUGIN.ATTRIBUTE.TYPE'
,p_lov=>'.'||wwv_flow_imp.id(28057124498012298)||'.'
,p_cHeight=>1
,p_read_only_when=>'P4415_IS_IN_USE'
,p_read_only_when2=>'Y'
,p_read_only_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify the type the attribute should have when it is displayed in the &PRODUCT_NAME. Builder. The type is also used to verify the entered data when the developer sets or modifies them and is used by the Advisor as well when checking the applicati'
||'on.</p>',
'<p>To learn about the different types of attributes, check the documentation in the <strong>Adding Custom Attributes to a Plug-in</strong> section under <strong>Implementing Plug-ins</strong> in the App Builder User''s Guide.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48410328970213177)
,p_name=>'P4415_IS_REQUIRED'
,p_is_required=>true
,p_item_sequence=>105
,p_item_plug_id=>wwv_flow_imp.id(48435832186896072)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Required'
,p_source=>'IS_REQUIRED'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify if this attribute must contain a value.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48410920133213178)
,p_name=>'P4415_DEFAULT_VALUE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(48446425643547035)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Default Value'
,p_source=>'DEFAULT_VALUE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify a default value for this plug-in attribute. The default value is used when a new component is created that uses this plug-in.</p>',
'<p>',
'Use Y and N for attributes of type "Yes/No".',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48411131268213180)
,p_name=>'P4415_DISPLAY_LENGTH'
,p_item_sequence=>125
,p_item_plug_id=>wwv_flow_imp.id(48435832186896072)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Display Width'
,p_source=>'DISPLAY_LENGTH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>4
,p_cMaxlength=>4
,p_display_when=>'P4415_PLUGIN_TYPE'
,p_display_when2=>'TEMPLATE COMPONENT'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify the length (in characters) that is displayed for this attribute in the &PRODUCT_NAME. Builder.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'9999'
,p_attribute_03=>'right'
,p_attribute_04=>'decimal'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48411323772213180)
,p_name=>'P4415_MAX_LENGTH'
,p_item_sequence=>135
,p_item_plug_id=>wwv_flow_imp.id(48435832186896072)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Maximum Length'
,p_source=>'MAX_LENGTH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>5
,p_cMaxlength=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify the maximum number of character users are allowed to type into this attribute.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'99999'
,p_attribute_03=>'right'
,p_attribute_04=>'decimal'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48411901310213183)
,p_name=>'P4415_ATTRIBUTE_SCOPE'
,p_is_required=>true
,p_item_sequence=>28
,p_item_plug_id=>wwv_flow_imp.id(48406905308213111)
,p_use_cache_before_default=>'NO'
,p_item_default=>'COMPONENT'
,p_prompt=>'Scope'
,p_source=>'ATTRIBUTE_SCOPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PLUGIN.ATTRIBUTE.SCOPE'
,p_lov=>'.'||wwv_flow_imp.id(32688601172502165)||'.'
,p_cHeight=>1
,p_read_only_when=>'P4415_IS_IN_USE'
,p_read_only_when2=>'Y'
,p_read_only_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The attribute scope can be Application, Component, or Report.',
'<dl>',
'<dt>Application</dt>',
'<dd>The attribute can only be defined once for the application.</dd>',
'<dt>Component</dt>',
'<dd>The attribute can be defined each time the plug-in is referenced in a component.</dd>',
'<dt>Report</dt>',
'<dd>The attribute can only be defined if the region''s display attribute is set to Multiple (Report).</dd>',
'</dl>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48412325717213184)
,p_name=>'P4415_SQL_MIN_COLUMN_COUNT'
,p_item_sequence=>145
,p_item_plug_id=>wwv_flow_imp.id(48435832186896072)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Minimum Columns'
,p_source=>'SQL_MIN_COLUMN_COUNT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>3
,p_cMaxlength=>3
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Minimum number of columns that the SQL query has to select.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'999'
,p_attribute_03=>'right'
,p_attribute_04=>'decimal'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48412508641213185)
,p_name=>'P4415_SQL_MAX_COLUMN_COUNT'
,p_item_sequence=>155
,p_item_plug_id=>wwv_flow_imp.id(48435832186896072)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Maximum Columns'
,p_source=>'SQL_MAX_COLUMN_COUNT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>3
,p_cMaxlength=>3
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Maximum number of columns that the SQL query can select.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'999'
,p_attribute_03=>'right'
,p_attribute_04=>'decimal'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48412708248213186)
,p_name=>'P4415_IS_TRANSLATABLE'
,p_item_sequence=>115
,p_item_plug_id=>wwv_flow_imp.id(48435832186896072)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Translatable'
,p_source=>'IS_TRANSLATABLE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify whether or not this attribute is included in the XLIFF translation file.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48426502736712403)
,p_name=>'P4415_RETURN_TO_PAGE'
,p_item_sequence=>910
,p_item_plug_id=>wwv_flow_imp.id(48426218615712391)
,p_prompt=>'Stay on page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_help_text=>'Select this checkbox to stay on this page after applying changes.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'YES'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48433504997850407)
,p_name=>'P4415_PLUGIN_DISPLAY_NAME'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_imp.id(48429922780789328)
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name',
'  from wwv_flow_plugins',
' where id                = :P4415_PLUGIN_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Selected plug-in.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48452709508610987)
,p_name=>'P4415_ID_NEXT'
,p_item_sequence=>920
,p_item_plug_id=>wwv_flow_imp.id(48429922780789328)
,p_prompt=>'P4415_ID_NEXT'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48452905290610993)
,p_name=>'P4415_ID_PREV'
,p_item_sequence=>930
,p_item_plug_id=>wwv_flow_imp.id(48429922780789328)
,p_prompt=>'P4415_ID_PREV'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48453124751610999)
,p_name=>'P4415_ID_COUNT'
,p_item_sequence=>940
,p_item_plug_id=>wwv_flow_imp.id(48429922780789328)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48488324692343018)
,p_name=>'P4415_ATTRIBUTE_COMMENT'
,p_item_sequence=>131
,p_item_plug_id=>wwv_flow_imp.id(48488030069342926)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comments'
,p_source=>'ATTRIBUTE_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'<p>Enter any comments or notes here.  These comments will never be displayed when running the application.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48608823932224997)
,p_name=>'P4415_IS_IN_USE'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(48406905308213111)
,p_prompt=>'Is In Use'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>1
,p_cMaxlength=>1
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(179294009802986782)
,p_name=>'P4415_FLOW_ID'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_imp.id(48406905308213111)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Flow Id'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(184840503059564465)
,p_name=>'P4415_ATTRIBUTE_VALUE_ID'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_imp.id(48406905308213111)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Attribute Value Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(189411104013869899)
,p_name=>'P4415_DEPENDING_ON_CONDITION_TYPE'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_imp.id(189410922503869874)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Condition Type'
,p_source=>'DEPENDING_ON_CONDITION_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PLUGIN.ATTRIBUTE.CONDITION_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(189411726584965751)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Condition Type -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select a condition type that must be met in order for this attribute to render.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(189411326157869917)
,p_name=>'P4415_DEPENDING_ON_EXPRESSION'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_imp.id(189410922503869874)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Expression'
,p_source=>'DEPENDING_ON_EXPRESSION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter values in this attribute based on the specific condition type selected. If you have selected "in list" or "not in list", enter values separated by a comma. Don''t add a blank before or after the comma if that isn''t included in the value which yo'
||'u want to compare.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(189417128063022926)
,p_name=>'P4415_DEPENDING_ON_ATTRIBUTE_ID'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_imp.id(189410922503869874)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Depending on'
,p_source=>'DEPENDING_ON_ATTRIBUTE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case when g.title is not null then g.title || '' - '' end ||',
'       a.prompt as prompt,',
'       a.id',
'  from wwv_flow_plugin_attributes a,',
'       wwv_flow_plugin_attr_groups g',
' where a.plugin_id             = to_number(:P4415_PLUGIN_ID)',
'   and a.security_group_id     = :WORKSPACE_ID',
'   and a.attribute_scope       = :P4415_ATTRIBUTE_SCOPE',
'   and a.id                   <> nvl(to_number(:P4415_ID), -1)',
'   and g.id (+)                = a.attribute_group_id',
'   and g.security_group_id (+) = a.security_group_id',
' order by a.attribute_sequence'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Not Dependent -'
,p_lov_cascade_parent_items=>'P4415_ATTRIBUTE_SCOPE'
,p_ajax_items_to_submit=>'P4415_PLUGIN_ID,P4415_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select the attribute the current attribute depends on. For example, only show the current attribute if "Orientation" is equal to "VERTICAL".'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(261696518877976860)
,p_name=>'P4415_IS_COMMON'
,p_is_required=>true
,p_item_sequence=>75
,p_item_plug_id=>wwv_flow_imp.id(48435832186896072)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Common'
,p_source=>'IS_COMMON'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify if this attribute should always be displayed in the Property Editor of Page Designer or only if advanced attributes are displayed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(361901122073943577)
,p_name=>'P4415_TEXT_CASE'
,p_item_sequence=>185
,p_item_plug_id=>wwv_flow_imp.id(48435832186896072)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Set Text Case'
,p_source=>'TEXT_CASE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PLUGIN_ATTRIBUTE_SET_TEXT_CASE'
,p_lov=>'.'||wwv_flow_imp.id(361901313057946615)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Unchanged'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_restricted_characters=>'US_ONLY'
,p_help_text=>'Specify if the entered plug-in attribute value should always be stored in upper or lowercase.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(361902914728962164)
,p_name=>'P4415_NULL_TEXT'
,p_item_sequence=>205
,p_item_plug_id=>wwv_flow_imp.id(48435832186896072)
,p_use_cache_before_default=>'NO'
,p_prompt=>'LOV Null Text'
,p_source=>'NULL_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the text to be displayed at the top of the list. This value also displays when the attribute value is null. If you do not enter any text, it is displayed as ''- Select -''.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(361905701764998545)
,p_name=>'P4415_LOV_TYPE'
,p_item_sequence=>55
,p_item_plug_id=>wwv_flow_imp.id(48435832186896072)
,p_use_cache_before_default=>'NO'
,p_item_default=>'STATIC'
,p_prompt=>'Lov Type'
,p_source=>'LOV_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PLUGIN_ATTRIBUTE_LOV_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(361905807263001770)||'.'
,p_cHeight=>1
,p_read_only_when=>'WORKSPACE_ID'
,p_read_only_when2=>'10'
,p_read_only_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(361907202171028717)
,p_name=>'P4415_LOV_COMPONENT_TYPE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(361914528060159138)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Component Type'
,p_source=>'LOV_COMPONENT_TYPE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select replace( lpad( '' '', ( level - 1 ) * 2 ), '' '', ''&nbsp;'' ) || wwv_flow_escape.html( wwv_flow_lang.system_message( singular_title )) as d,',
'       id',
'  from wwv_pe_component_types',
' start with parent_component_type_id is null',
'connect by prior id = parent_component_type_id',
'  order siblings by display_sequence'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- select -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(361907421987049969)
,p_name=>'P4415_LOV_COMPONENT_TYPE_SCOPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(361914528060159138)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Scope'
,p_source=>'LOV_COMPONENT_TYPE_SCOPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PLUGIN_ATTRIBUTE_LOV_SCOPE'
,p_lov=>'.'||wwv_flow_imp.id(361909922032072224)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Application'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(361908431895060539)
,p_name=>'P4415_LOV_COMP_TYPE_ON_DELETE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(361914528060159138)
,p_use_cache_before_default=>'NO'
,p_prompt=>'On Delete Behavior'
,p_source=>'LOV_COMPONENT_TYPE_ON_DELETE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PLUGIN_ATTRIBUTE_LOV_ON_DELETE'
,p_lov=>'.'||wwv_flow_imp.id(361908530213065178)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Raise Error'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(361911515708083243)
,p_name=>'P4415_DEPRECATED_VALUES'
,p_item_sequence=>55
,p_item_plug_id=>wwv_flow_imp.id(189410922503869874)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Show Deprecated Attribute for Values'
,p_source=>'DEPRECATED_VALUES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>30
,p_display_when=>'WORKSPACE_ID'
,p_display_when2=>'10'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(362600600277420823)
,p_name=>'P4415_PARENT_ATTRIBUTE_ID'
,p_item_sequence=>165
,p_item_plug_id=>wwv_flow_imp.id(48435832186896072)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Parent Attribute'
,p_source=>'PARENT_ATTRIBUTE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select prompt,',
'       id',
'  from wwv_flow_plugin_attributes',
' where plugin_id         = to_number(:P4415_PLUGIN_ID)',
'   and security_group_id = :WORKSPACE_ID',
'   and id               <> nvl(to_number(:P4415_ID), -1)',
'   and (   attribute_type = case :P4415_ATTRIBUTE_TYPE',
'                              when ''TABLE''         then ''OWNER''',
'                              when ''COLUMN''        then ''TABLE''',
'                              when ''PLSQL PACKAGE'' then ''OWNER''',
'                            end',
'       or (   :P4415_ATTRIBUTE_TYPE = ''PLSQL METHOD''',
'          and attribute_type        in ( ''OWNER'', ''PLSQL PACKAGE'' )',
'          )',
'       )',
' order by attribute_sequence'))
,p_lov_cascade_parent_items=>'P4415_ATTRIBUTE_TYPE'
,p_ajax_items_to_submit=>'P4415_ID,P4415_PLUGIN_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(451251527298039490)
,p_name=>'P4415_DISPLAY_SEQUENCE'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(48406905308213111)
,p_use_cache_before_default=>'NO'
,p_item_default=>':P4415_ATTRIBUTE_SEQUENCE*10'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Display Sequence'
,p_source=>'DISPLAY_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>4
,p_cMaxlength=>4
,p_cHeight=>1
,p_read_only_disp_attr=>'class="fielddatabold"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the display sequence for this plug-in attribute in the &PRODUCT_NAME. Builder.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(492593772231392050)
,p_name=>'P4415_EXAMPLES'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(48426926927714787)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Examples'
,p_source=>'EXAMPLES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>8
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Specify examples for this plug-in attribute. The examples are displayed as part of the context sensitive help for the attribute in the Builder.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(502499517782935713)
,p_name=>'P4415_ITEM_COMPONENT_TYPES'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(261694800046952123)
,p_prompt=>'Component Type'
,p_source=>'P4415_SUPPORTED_COMP_TYPES'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'PLUGIN_ITEM_TYPE_COMPONENT_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(513667640463524657)||'.'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugins',
' where id                = :P4415_PLUGIN_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and plugin_type       = ''ITEM TYPE'''))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Specifies if the plug-in attribute is displayed in the Builder for Page Items and Interactive Grid Columns. If no supported type is set then it will always be displayed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(502499655346935714)
,p_name=>'P4415_SUPPORTED_COMP_TYPES'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(261694800046952123)
,p_use_cache_before_default=>'NO'
,p_source=>'SUPPORTED_COMPONENT_TYPES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(502499874499935716)
,p_name=>'P4415_DEPEND_ON_HAS_TO_EXIST'
,p_item_sequence=>45
,p_item_plug_id=>wwv_flow_imp.id(189410922503869874)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Always Evaluate'
,p_source=>'DEPENDING_ON_HAS_TO_EXIST'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>If set to <strong>On</strong>, the condition will always be evaluated and as a pre-requirement the depending on attribute has to be rendered. If set to <strong>Off</strong>, the condition will still be evaluated when the depending on attribute has'
||' been rendered, however if the depending on attribute has not NOT been rendered, the condition will not be evaluated.</p>',
'',
'<p>This may be useful, for example if the depending on attribute itself has a condition (for example it only supports certain component types), and where you still want the current attribute to be rendered in the case where the depending on attribute'
||'''s condition fails.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(907492157679523347)
,p_name=>'P4415_SHOW_IN_WIZARD'
,p_is_required=>true
,p_item_sequence=>95
,p_item_plug_id=>wwv_flow_imp.id(48435832186896072)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Show in Wizard'
,p_source=>'SHOW_IN_WIZARD'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>'P4415_PLUGIN_TYPE'
,p_display_when2=>'TEMPLATE COMPONENT'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify if this attribute should be displayed in the Create Wizard if a new component is created based on the current plug-in.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1474235115866765843)
,p_name=>'P4415_UNIT'
,p_item_sequence=>195
,p_item_plug_id=>wwv_flow_imp.id(48435832186896072)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Unit'
,p_source=>'UNIT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>30
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the text to be displayed as the unit (i.e. pixels) for the attribute''s value in Page Designer.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1499432283349055529)
,p_name=>'P4415_REFERENCE_SCOPE'
,p_is_required=>true
,p_item_sequence=>215
,p_item_plug_id=>wwv_flow_imp.id(48435832186896072)
,p_use_cache_before_default=>'NO'
,p_item_default=>'COMPONENT'
,p_prompt=>'Include Columns in Items Picker'
,p_source=>'REFERENCE_SCOPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugins',
' where id                = :P4415_PLUGIN_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and plugin_type      in ( ''REGION TYPE'', ''PROCESS TYPE'' )',
'   and instr (',
'           '':'' || standard_attributes || '':'',',
'           '':'' || case when plugin_type = ''REGION TYPE'' then ''SOURCE_SQL'' else ''REGION_REQUIRED'' end || '':''',
'       ) > 0'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'US_ONLY'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify <strong>On</strong> if the Items Picker in Page Designer should also include columns of the current region.</p>',
'',
'<p>Note: In order for this to work, you must perform manual substitutions in your plug-in code and you must also set the plug-in level <em>Substitute Attribute Values</em> flag to <strong>Off</strong>. Please see help for that attribute for further d'
||'etails on how to perform manual substitutions.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'ROW'
,p_attribute_03=>'Yes'
,p_attribute_04=>'COMPONENT'
,p_attribute_05=>'No'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2613546572213902)
,p_computation_sequence=>10
,p_computation_item=>'P4415_STATIC_ID'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case :P4415_PLUGIN_TYPE',
'    when ''TEMPLATE COMPONENT'' then upper( :P4415_STATIC_ID )',
'    when ''REGION TYPE''        then lower( :P4415_STATIC_ID )',
'else null end'))
,p_compute_when=>':P4415_PLUGIN_TYPE in (''TEMPLATE COMPONENT'', ''REGION TYPE'')'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(48618425494963471)
,p_computation_sequence=>50
,p_computation_item=>'P4415_DEFAULT_VALUE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'NVL(:P4415_DEFAULT_VALUE, ''N'')'
,p_compute_when=>'P4415_ATTRIBUTE_TYPE'
,p_compute_when_text=>'CHECKBOX'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(189424813386359234)
,p_computation_sequence=>70
,p_computation_item=>'P4415_DEPENDING_ON_CONDITION_TYPE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'NULL'
,p_compute_when=>'P4415_DEPENDING_ON_ATTRIBUTE_ID'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(189425130486373640)
,p_computation_sequence=>80
,p_computation_item=>'P4415_DEPENDING_ON_EXPRESSION'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'NULL'
,p_compute_when=>'P4415_DEPENDING_ON_CONDITION_TYPE'
,p_compute_when_text=>'EQUALS:NOT_EQUALS:IN_LIST:NOT_IN_LIST'
,p_compute_when_type=>'VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(24183904264284602)
,p_computation_sequence=>90
,p_computation_item=>'P4415_COLUMN_DATA_TYPES'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'null'
,p_compute_when=>'P4415_ATTRIBUTE_TYPE'
,p_compute_when_text=>'REGION SOURCE COLUMN:COLUMN:SESSION STATE VALUE'
,p_compute_when_type=>'VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(361913323866125091)
,p_computation_sequence=>100
,p_computation_item=>'P4415_LOV_TYPE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'null'
,p_compute_when=>':P4415_ATTRIBUTE_TYPE not in ( ''SELECT LIST'', ''CHECKBOXES'' )'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(362034932398032753)
,p_computation_sequence=>110
,p_computation_item=>'P4415_TEXT_CASE'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'null'
,p_compute_when=>':P4415_ATTRIBUTE_TYPE not in ( ''TEXT'', ''TEXTAREA'' )'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1499432325867055530)
,p_computation_sequence=>120
,p_computation_item=>'P4415_REFERENCE_SCOPE'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'COMPONENT'
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    :P4415_ATTRIBUTE_TYPE not in ( ''LINK'', ''TEXT'', ''TEXTAREA'', ''PAGE ITEM'', ''PAGE ITEMS'', ''SQL'', ''HTML'', ''JAVASCRIPT'', ''XML'' )',
'and :P4415_ATTRIBUTE_TYPE not like ''PLSQL%'''))
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1474235438551765846)
,p_computation_sequence=>130
,p_computation_item=>'P4415_UNIT'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'null'
,p_compute_when=>':P4415_ATTRIBUTE_TYPE not in ( ''TEXT'', ''NUMBER'', ''INTEGER'' )'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1474234888784765840)
,p_computation_sequence=>140
,p_computation_item=>'P4415_IS_TRANSLATABLE'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'N'
,p_compute_when=>':P4415_ATTRIBUTE_TYPE not in ( ''TEXT'', ''TEXTAREA'', ''HTML'', ''XML'' )'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1474234991152765841)
,p_computation_sequence=>150
,p_computation_item=>'P4415_DISPLAY_LENGTH'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'null'
,p_compute_when=>':P4415_ATTRIBUTE_TYPE not in ( ''TEXT'', ''TEXTAREA'', ''NUMBER'', ''INTEGER'' )'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1474235093312765842)
,p_computation_sequence=>160
,p_computation_item=>'P4415_MAX_LENGTH'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'null'
,p_compute_when=>':P4415_ATTRIBUTE_TYPE not in ( ''TEXT'', ''TEXTAREA'', ''NUMBER'', ''INTEGER'' )'
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(362608418115488549)
,p_computation_sequence=>170
,p_computation_item=>'P4415_PARENT_ATTRIBUTE_ID'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'null'
,p_compute_when=>'P4415_ATTRIBUTE_TYPE'
,p_compute_when_text=>'TABLE:COLUMN:PLSQL PACKAGE:PLSQL METHOD'
,p_compute_when_type=>'VALUE_OF_ITEM_IN_CONDITION_NOT_IN_COLON_DELIMITED_LIST'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(502499771942935715)
,p_computation_sequence=>180
,p_computation_item=>'P4415_SUPPORTED_COMP_TYPES'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P4415_ITEM_COMPONENT_TYPES'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2029883003167736)
,p_computation_sequence=>190
,p_computation_item=>'P4415_SUPPORTED_COMP_TYPES'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P4415_PROCESS_COMPONENT_TYPES'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3402366629955615)
,p_computation_sequence=>200
,p_computation_item=>'P4415_PLUGIN_TYPE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select p.plugin_type',
'  from wwv_flow_plugins p',
' where p.security_group_id = :WORKSPACE_ID',
'   and ( (      :P4415_PLUGIN_ID is not null ',
'            and p.id = :P4415_PLUGIN_ID )',
'        or (    :P4415_ID is not null ',
'            and exists ( select 1',
'                       from wwv_flow_plugin_attributes a',
'                      where a.security_group_id = p.security_group_id',
'                        and a.plugin_id         = p.id',
'                        and a.id                = :P4415_ID ) ) )'))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(13739400846552942)
,p_validation_name=>'P4415_ATTRIBUTE_SEQUENCE max attribute check'
,p_validation_sequence=>210
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_plugin_type       wwv_flow_plugins.plugin_type%type;',
'    l_max_attribute_seq number;',
'begin',
'    select plugin_type',
'      into l_plugin_type',
'      from wwv_flow_plugins',
'     where id                = :P4415_PLUGIN_ID',
'       and flow_id           = :P4415_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID;',
'',
'    l_max_attribute_seq := wwv_flow_plugin_dev.get_max_custom_attributes (',
'                               p_plugin_type     => l_plugin_type,',
'                               p_attribute_scope => :P4415_ATTRIBUTE_SCOPE );',
'',
'    if to_number(:P4415_ATTRIBUTE_SEQUENCE) not between 1 and l_max_attribute_seq then',
'        return wwv_flow_lang.system_message(''APEX.NUMBER_FIELD.VALUE_NOT_BETWEEN_MIN_MAX'', 1, l_max_attribute_seq);',
'    end if;',
'',
'    return null;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_associated_item=>wwv_flow_imp.id(48408925689213174)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(48466230220803781)
,p_validation_name=>'P4415_DEFAULT_VALUE is not null when IS_REQUIRED'
,p_validation_sequence=>220
,p_validation=>'P4415_DEFAULT_VALUE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified if attribute is required and type is "Select List" or "Checkboxes".'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    :P4415_ATTRIBUTE_TYPE in (''SELECT LIST'', ''CHECKBOXES'')',
'and :P4415_IS_REQUIRED = ''Y''',
'and :P4415_LOV_TYPE    = ''STATIC'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(48410920133213178)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(48618605670976611)
,p_validation_name=>'P4415_DEFAULT_VALUE for Checkbox'
,p_validation_sequence=>230
,p_validation=>':P4415_DEFAULT_VALUE IN (''Y'', ''N'')'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Value has to be Y or N for a Checkbox.'
,p_validation_condition=>'P4415_ATTRIBUTE_TYPE'
,p_validation_condition2=>'CHECKBOX'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(48410920133213178)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(189424216456331790)
,p_validation_name=>'P4415_DEPENDING_ON_CONDITION_TYPE not null'
,p_validation_sequence=>240
,p_validation=>'P4415_DEPENDING_ON_CONDITION_TYPE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_validation_condition=>'P4415_DEPENDING_ON_ATTRIBUTE_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_imp.id(189411104013869899)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(189424525245343796)
,p_validation_name=>'P4415_DEPENDING_ON_EXPRESSION not null'
,p_validation_sequence=>250
,p_validation=>'P4415_DEPENDING_ON_EXPRESSION'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_validation_condition=>'P4415_DEPENDING_ON_CONDITION_TYPE'
,p_validation_condition2=>'EQUALS:NOT_EQUALS:IN_LIST:NOT_IN_LIST'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_associated_item=>wwv_flow_imp.id(189411326157869917)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(362608628023499110)
,p_validation_name=>'P4415_PARENT_ATTRIBUTE_ID not null'
,p_validation_sequence=>260
,p_validation=>'P4415_PARENT_ATTRIBUTE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P4415_ATTRIBUTE_TYPE'
,p_validation_condition2=>'TABLE:COLUMN:PLSQL PACKAGE:PLSQL METHOD'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_associated_item=>wwv_flow_imp.id(362600600277420823)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(362036302421046663)
,p_validation_name=>'P4415_DEPENDING_ON_CONDITION_TYPE is not null'
,p_validation_sequence=>280
,p_validation=>'P4415_LOV_COMPONENT_TYPE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Value must be specified.'
,p_validation_condition=>'P4415_LOV_TYPE'
,p_validation_condition2=>'COMPONENT'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(361907202171028717)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(48621123827142757)
,p_validation_name=>'P4415_ATTRIBUTE_SEQUENCE unique for all other plug-in types'
,p_validation_sequence=>290
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugin_attributes',
' where plugin_id          = :P4415_PLUGIN_ID',
'   and security_group_id  = :WORKSPACE_ID',
'   and attribute_scope    = :P4415_ATTRIBUTE_SCOPE',
'   and attribute_sequence = :P4415_ATTRIBUTE_SEQUENCE',
'   and (  :P4415_ID is null',
'       or id <> :P4415_ID',
'       )'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Attribute already in use for this scope.'
,p_validation_condition=>'P4415_PLUGIN_TYPE'
,p_validation_condition2=>'TEMPLATE COMPONENT'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(48408925689213174)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(30289367485650246)
,p_validation_name=>'P4415_ATTRIBUTE_SEQUENCE unique for Template Component'
,p_validation_sequence=>300
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugin_attributes',
' where plugin_id          = :P4415_PLUGIN_ID',
'   and security_group_id  = :WORKSPACE_ID',
'   and attribute_sequence = :P4415_ATTRIBUTE_SEQUENCE',
'   and (  :P4415_ID is null',
'       or id <> :P4415_ID',
'       )'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Attribute already in use.'
,p_validation_condition=>'P4415_PLUGIN_TYPE'
,p_validation_condition2=>'TEMPLATE COMPONENT'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(48408925689213174)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1921133180465817)
,p_validation_name=>'P4415_STATIC_ID not null'
,p_validation_sequence=>310
,p_validation=>'P4415_STATIC_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>':P4415_PLUGIN_TYPE in (''TEMPLATE COMPONENT'', ''REGION TYPE'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(9813324748144418)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2833781253618439)
,p_validation_name=>'P4415_STATIC_ID unique for Template Components'
,p_validation_sequence=>320
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugin_attributes',
' where plugin_id          = :P4415_PLUGIN_ID',
'   and security_group_id  = :WORKSPACE_ID',
'   and static_id          = :P4415_STATIC_ID',
'   and (  :P4415_ID is null',
'       or id <> :P4415_ID',
'       )',
'union all',
'select 1',
'  from wwv_flow_plugin_act_positions',
' where plugin_id          = :P4415_PLUGIN_ID',
'   and security_group_id  = :WORKSPACE_ID',
'   and static_id          = :P4415_STATIC_ID',
'union all',
'select 1',
'  from wwv_flow_plugin_slots',
' where flow_id           = :FB_FLOW_ID',
'   and plugin_id         = :P4415_PLUGIN_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and placeholder       = :P4415_STATIC_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Static Identifier already in use as a custom attribute, action position, or template component slot.'
,p_validation_condition=>'P4415_PLUGIN_TYPE'
,p_validation_condition2=>'TEMPLATE COMPONENT'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(9813324748144418)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2804735544667419)
,p_validation_name=>'P4415_STATIC_ID unique for plugins with multiple scopes'
,p_validation_sequence=>330
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugin_attributes',
' where plugin_id          = :P4415_PLUGIN_ID',
'   and security_group_id  = :WORKSPACE_ID',
'   and static_id          = :P4415_STATIC_ID',
'   and attribute_scope    = :P4415_ATTRIBUTE_SCOPE',
'   and (  :P4415_ID is null',
'       or id <> :P4415_ID',
'       )',
'union all',
'select 1',
'  from wwv_flow_plugin_slots',
' where flow_id           = :FB_FLOW_ID',
'   and plugin_id         = :P4415_PLUGIN_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and placeholder       = :P4415_STATIC_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Static Identifier already in use as a custom attribute, or region plugin slot.'
,p_validation_condition=>'P4415_PLUGIN_TYPE'
,p_validation_condition2=>'REGION TYPE'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(9813324748144418)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4805862038190601)
,p_validation_name=>'Restrict Characters'
,p_validation_sequence=>340
,p_validation=>'regexp_like (:P4415_STATIC_ID, ''^[[:alnum:]_]+$'' )'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Invalid characters detected. Please use only letters, numbers, and underscores (_).'
,p_validation_condition=>':P4415_PLUGIN_TYPE in (''TEMPLATE COMPONENT'', ''REGION TYPE'')'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(9813324748144418)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(48471419334989784)
,p_name=>'Hide all'
,p_event_sequence=>0
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_ATTRIBUTE_TYPE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_da_event_comment=>'This action will also hide the P4415_MAX_LENGTH and P4415_SQL_MAX_COLUMN_COUNT because they are in the same table row'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(48471832279003073)
,p_event_id=>wwv_flow_imp.id(48471419334989784)
,p_event_result=>'TRUE'
,p_action_sequence=>1
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_LOV_TYPE,P4415_IS_TRANSLATABLE,P4415_DISPLAY_LENGTH,P4415_MAX_LENGTH,P4415_SQL_MIN_COLUMN_COUNT,P4415_SQL_MAX_COLUMN_COUNT,P4415_PARENT_ATTRIBUTE_ID,P4415_COLUMN_DATA_TYPES,P4415_TEXT_CASE,P4415_UNIT,P4415_NULL_TEXT,P4415_REFERENCE_SCOPE'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(48473017781027212)
,p_name=>'Type is Select List,Checkboxes'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_ATTRIBUTE_TYPE'
,p_condition_element=>'P4415_ATTRIBUTE_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'SELECT LIST,CHECKBOXES'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(48473430248030853)
,p_event_id=>wwv_flow_imp.id(48473017781027212)
,p_event_result=>'TRUE'
,p_action_sequence=>1
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_LOV_TYPE'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(362050805940081043)
,p_event_id=>wwv_flow_imp.id(48473017781027212)
,p_event_result=>'TRUE'
,p_action_sequence=>11
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_LOV_TYPE'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$v( "P4415_LOV_TYPE" )'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_da_action_comment=>'Needed to trigger the dynamic action on LOV TYPE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1480724267628735033)
,p_name=>'Type is Select List'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_ATTRIBUTE_TYPE'
,p_condition_element=>'P4415_ATTRIBUTE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SELECT LIST'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1480724104603735032)
,p_event_id=>wwv_flow_imp.id(1480724267628735033)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_IS_REQUIRED'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$v( "P4415_IS_REQUIRED" )'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_da_action_comment=>'Needed to trigger the dynamic action on IS_REQUIRED'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(48473601074041340)
,p_name=>'Type is SQL'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_ATTRIBUTE_TYPE'
,p_condition_element=>'P4415_ATTRIBUTE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SQL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_da_event_comment=>'Will also show P4415_SQL_MAX_COLUMN_COUNT because they are in the same table row'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(48474026700048672)
,p_event_id=>wwv_flow_imp.id(48473601074041340)
,p_event_result=>'TRUE'
,p_action_sequence=>1
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_SQL_MIN_COLUMN_COUNT,P4415_SQL_MAX_COLUMN_COUNT'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(48480115375177875)
,p_name=>'Type is Text,Textarea,HTML,XML - Translatable'
,p_event_sequence=>45
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_ATTRIBUTE_TYPE'
,p_condition_element=>'P4415_ATTRIBUTE_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'TEXT,TEXTAREA,HTML,XML'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(48480526457181134)
,p_event_id=>wwv_flow_imp.id(48480115375177875)
,p_event_result=>'TRUE'
,p_action_sequence=>1
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_IS_TRANSLATABLE,P4415_REFERENCE_SCOPE'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1474234694573765838)
,p_name=>'Type is Text,Textarea - Text Case'
,p_event_sequence=>55
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_ATTRIBUTE_TYPE'
,p_condition_element=>'P4415_ATTRIBUTE_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'TEXT,TEXTAREA'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1474234773227765839)
,p_event_id=>wwv_flow_imp.id(1474234694573765838)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_TEXT_CASE'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(48474217612065002)
,p_name=>'Type is Text,Textarea,Number,Integer'
,p_event_sequence=>65
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_ATTRIBUTE_TYPE'
,p_condition_element=>'P4415_ATTRIBUTE_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'TEXT,TEXTAREA,NUMBER,INTEGER'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_da_event_comment=>'Will also show P4415_MAX_LENGTH, because they are in the same table row.'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(48474600774069632)
,p_event_id=>wwv_flow_imp.id(48474217612065002)
,p_event_result=>'TRUE'
,p_action_sequence=>1
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_DISPLAY_LENGTH,P4415_MAX_LENGTH'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1474235247602765844)
,p_name=>'Type is Text,Number,Integer - Unit'
,p_event_sequence=>75
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_ATTRIBUTE_TYPE'
,p_condition_element=>'P4415_ATTRIBUTE_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'TEXT,NUMBER,INTEGER'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_da_event_comment=>'Will also show P4415_MAX_LENGTH, because they are in the same table row.'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1474235352771765845)
,p_event_id=>wwv_flow_imp.id(1474235247602765844)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_UNIT'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(48479325717152479)
,p_name=>'Type is SQL,PLSQL,PLSQL Expression*,PLSQL Function Body*,JavaScript'
,p_event_sequence=>85
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_ATTRIBUTE_TYPE'
,p_condition_element=>'P4415_ATTRIBUTE_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'SQL,PLSQL,PLSQL EXPRESSION,PLSQL EXPRESSION BOOLEAN,PLSQL FUNCTION BODY,PLSQL FUNCTION BODY BOOLEAN,JAVASCRIPT'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(48479702992155394)
,p_event_id=>wwv_flow_imp.id(48479325717152479)
,p_event_result=>'TRUE'
,p_action_sequence=>1
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_IS_TRANSLATABLE'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(837441566044841426)
,p_event_id=>wwv_flow_imp.id(48479325717152479)
,p_event_result=>'TRUE'
,p_action_sequence=>11
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_REFERENCE_SCOPE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(48617531119946167)
,p_name=>'Type is Yes/No'
,p_event_sequence=>95
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_ATTRIBUTE_TYPE'
,p_condition_element=>'P4415_ATTRIBUTE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'CHECKBOX'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(48617914973950978)
,p_event_id=>wwv_flow_imp.id(48617531119946167)
,p_event_result=>'TRUE'
,p_action_sequence=>1
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_IS_REQUIRED'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(48618221207952775)
,p_event_id=>wwv_flow_imp.id(48617531119946167)
,p_event_result=>'FALSE'
,p_action_sequence=>1
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_IS_REQUIRED'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(24178727363158746)
,p_name=>'Type is Region Source Column'
,p_event_sequence=>105
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_ATTRIBUTE_TYPE'
,p_condition_element=>'P4415_ATTRIBUTE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REGION SOURCE COLUMN'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(24179001137158750)
,p_event_id=>wwv_flow_imp.id(24178727363158746)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_COLUMN_DATA_TYPES'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(362604428648452136)
,p_name=>'Type is Table, PL/SQL Package or PL/SQL Method'
,p_event_sequence=>125
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_ATTRIBUTE_TYPE'
,p_condition_element=>'P4415_ATTRIBUTE_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'TABLE,PLSQL PACKAGE,PLSQL METHOD'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(362604701612452136)
,p_event_id=>wwv_flow_imp.id(362604428648452136)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_PARENT_ATTRIBUTE_ID'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(362602816873448719)
,p_name=>'Type is Column'
,p_event_sequence=>135
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_ATTRIBUTE_TYPE'
,p_condition_element=>'P4415_ATTRIBUTE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'COLUMN'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(362603110252448742)
,p_event_id=>wwv_flow_imp.id(362602816873448719)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_PARENT_ATTRIBUTE_ID,P4415_COLUMN_DATA_TYPES'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1499432466760055531)
,p_name=>'Type is Page Item(s),Link'
,p_event_sequence=>145
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_ATTRIBUTE_TYPE'
,p_condition_element=>'P4415_ATTRIBUTE_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'PAGE ITEM,PAGE ITEMS,LINK'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1499432571726055532)
,p_event_id=>wwv_flow_imp.id(1499432466760055531)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_REFERENCE_SCOPE'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(361916804904180878)
,p_name=>'Lov Type - Hide Regions'
,p_event_sequence=>155
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_LOV_TYPE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(361917101944180879)
,p_event_id=>wwv_flow_imp.id(361916804904180878)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(361914528060159138)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(361981505496711010)
,p_event_id=>wwv_flow_imp.id(361916804904180878)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(184705009472204046)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(362000330652822309)
,p_name=>'Lov Type = STATIC'
,p_event_sequence=>165
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_LOV_TYPE'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(   $.inArray( $v( "P4415_ATTRIBUTE_TYPE" ), [ "SELECT LIST", "CHECKBOXES" ]) >= 0',
'&& $v( "P4415_LOV_TYPE" ) === "STATIC" )'))
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(361981309162709233)
,p_event_id=>wwv_flow_imp.id(362000330652822309)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(184705009472204046)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(361998325326811272)
,p_name=>'Lov Type = COMPONENT'
,p_event_sequence=>175
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_LOV_TYPE'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(   $v( "P4415_ATTRIBUTE_TYPE" ) === "SELECT LIST"',
' && $v( "P4415_LOV_TYPE" ) === "COMPONENT"',
')'))
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(361917318523180879)
,p_event_id=>wwv_flow_imp.id(361998325326811272)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(361914528060159138)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(189417804261072808)
,p_name=>'Condition'
,p_event_sequence=>185
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_DEPENDING_ON_ATTRIBUTE_ID'
,p_condition_element=>'P4415_DEPENDING_ON_ATTRIBUTE_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(502499922503935717)
,p_event_id=>wwv_flow_imp.id(189417804261072808)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_DEPEND_ON_HAS_TO_EXIST'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(502500073031935718)
,p_event_id=>wwv_flow_imp.id(189417804261072808)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_DEPEND_ON_HAS_TO_EXIST'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(189418125190072818)
,p_event_id=>wwv_flow_imp.id(189417804261072808)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_DEPENDING_ON_CONDITION_TYPE'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(189418324512072821)
,p_event_id=>wwv_flow_imp.id(189417804261072808)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_DEPENDING_ON_CONDITION_TYPE,P4415_DEPENDING_ON_EXPRESSION'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(189418608894083622)
,p_name=>'Condition Type'
,p_event_sequence=>195
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_DEPENDING_ON_CONDITION_TYPE'
,p_condition_element=>'P4415_DEPENDING_ON_CONDITION_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'EQUALS,NOT_EQUALS,IN_LIST,NOT_IN_LIST'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(189418901899083624)
,p_event_id=>wwv_flow_imp.id(189418608894083622)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_DEPENDING_ON_EXPRESSION'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(189419116866083625)
,p_event_id=>wwv_flow_imp.id(189418608894083622)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_DEPENDING_ON_EXPRESSION'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(48635511669536590)
,p_name=>'Default ATTRIBUTE_SCOPE'
,p_event_sequence=>205
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_ATTRIBUTE_SCOPE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(48635911453545942)
,p_event_id=>wwv_flow_imp.id(48635511669536590)
,p_event_result=>'TRUE'
,p_action_sequence=>1
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_ATTRIBUTE_SEQUENCE'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select coalesce(max(attribute_sequence), 0)+1 as next_attribute_sequence',
'  from wwv_flow_plugin_attributes',
' where plugin_id         = to_number(:P4415_PLUGIN_ID)',
'   and security_group_id = :WORKSPACE_ID',
'   and (  attribute_scope    = :P4415_ATTRIBUTE_SCOPE',
'       or :P4415_PLUGIN_TYPE = ''TEMPLATE COMPONENT''',
'       )'))
,p_attribute_07=>'P4415_PLUGIN_ID,P4415_PLUGIN_TYPE,P4415_ATTRIBUTE_SCOPE'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(451258919080093934)
,p_name=>'Default Display Sequence'
,p_event_sequence=>215
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_ATTRIBUTE_SEQUENCE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(451259208102093936)
,p_event_id=>wwv_flow_imp.id(451258919080093934)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_DISPLAY_SEQUENCE'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'$v(''P4415_ATTRIBUTE_SEQUENCE'')*10'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(397304208637519828)
,p_name=>'ENABLE PREVIOUS'
,p_event_sequence=>225
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P4415_ID_PREV'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(397304531723519830)
,p_event_id=>wwv_flow_imp.id(397304208637519828)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(48451130677610984)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(397304614178521429)
,p_name=>'ENABLE NEXT'
,p_event_sequence=>235
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P4415_ID_NEXT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(397304904527521430)
,p_event_id=>wwv_flow_imp.id(397304614178521429)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(48451017903610984)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(361980408863692925)
,p_name=>'Null Text'
,p_event_sequence=>245
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_IS_REQUIRED'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$v( "P4415_IS_REQUIRED" ) === "N" && $v( "P4415_ATTRIBUTE_TYPE" ) === "SELECT LIST"'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(361980705585692926)
,p_event_id=>wwv_flow_imp.id(361980408863692925)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_NULL_TEXT'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(361980906569692926)
,p_event_id=>wwv_flow_imp.id(361980408863692925)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_NULL_TEXT'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2831691639618418)
,p_name=>'Type is Link, Media, Icon, Color, HTML'
,p_event_sequence=>255
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_ATTRIBUTE_TYPE'
,p_condition_element=>'P4415_ATTRIBUTE_TYPE'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'MEDIA,LINK,ICON,COLOR,HTML'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_cond=>'P4415_PLUGIN_TYPE'
,p_display_when_cond2=>'TEMPLATE COMPONENT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2831790268618419)
,p_event_id=>wwv_flow_imp.id(2831691639618418)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_ESCAPE_MODE'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'( apex.items.P4415_ATTRIBUTE_TYPE === "HTML" ) ? "RAW" : "ATTR";'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4820505291098914)
,p_event_id=>wwv_flow_imp.id(2831691639618418)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_ESCAPE_MODE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'HTML'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2832513615618427)
,p_name=>'Type is Session State Value'
,p_event_sequence=>275
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_ATTRIBUTE_TYPE'
,p_condition_element=>'P4415_ATTRIBUTE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SESSION STATE VALUE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2832629658618428)
,p_event_id=>wwv_flow_imp.id(2832513615618427)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_COLUMN_DATA_TYPES'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3402408825955616)
,p_name=>'Set Prompt'
,p_event_sequence=>285
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_STATIC_ID'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3402513879955617)
,p_event_id=>wwv_flow_imp.id(3402408825955616)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_PROMPT'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.items.P4415_STATIC_ID.value',
'    .replace( /_+/g, "_" ).replace( /^_+/, "" ).replace( /_+$/, "" ).replace( /_/g, " " )',
'    .toLowerCase()',
'    .split( " " )',
'    .map( function( word ) {',
'            var firstWord = word[ 0 ] || "";',
'            return word.replace( firstWord, firstWord.toUpperCase() );',
'    } )',
'    .join( " " );'))
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_client_condition_type=>'NULL'
,p_client_condition_element=>'P4415_PROMPT'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3402626078955618)
,p_name=>'Type is Media'
,p_event_sequence=>295
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_ATTRIBUTE_TYPE'
,p_condition_element=>'P4415_ATTRIBUTE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'MEDIA'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3402709500955619)
,p_event_id=>wwv_flow_imp.id(3402626078955618)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(48446425643547035)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3402889500955620)
,p_event_id=>wwv_flow_imp.id(3402626078955618)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(48446425643547035)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4820147867098910)
,p_event_id=>wwv_flow_imp.id(3402626078955618)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_DEFAULT_VALUE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2965133642895404)
,p_name=>'Toggle lower/upper text case for P4415_STATIC_ID'
,p_event_sequence=>305
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>':P4415_PLUGIN_TYPE in (''TEMPLATE COMPONENT'', ''REGION TYPE'')'
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2965205837895405)
,p_event_id=>wwv_flow_imp.id(2965133642895404)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'const staticIdtextCase = apex.items.P4415_PLUGIN_TYPE.value === "TEMPLATE COMPONENT" ? "UPPER" : "LOWER";',
'apex.items.P4415_STATIC_ID.element.attr( "data-text-case", staticIdtextCase );'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2001024246799908)
,p_name=>'show/hide accessibility help text'
,p_event_sequence=>315
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4415_important_for_accessibility'
,p_condition_element=>'P4415_important_for_accessibility'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2001125591799909)
,p_event_id=>wwv_flow_imp.id(2001024246799908)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_ACCESSIBILITY_HELP_TEXT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2001359062799911)
,p_event_id=>wwv_flow_imp.id(2001024246799908)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_ACCESSIBILITY_HELP_TEXT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2600858494435201)
,p_event_id=>wwv_flow_imp.id(2001024246799908)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_name=>'Clear'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4415_ACCESSIBILITY_HELP_TEXT'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(48413203431213188)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_PLUGIN_ATTRIBUTES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_PLUGIN_ATTRIBUTES'
,p_attribute_03=>'P4415_ID'
,p_attribute_04=>'ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Unable to fetch row.'
,p_internal_uid=>48413203431213188
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(48453528653611000)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_PAGINATION'
,p_process_name=>'Get Next or Previous Primary Key Value'
,p_attribute_02=>'WWV_FLOW_PLUGIN_ATTRIBUTES'
,p_attribute_03=>'P4415_ID'
,p_attribute_04=>'ID'
,p_attribute_07=>'ATTRIBUTE_SCOPE'
,p_attribute_08=>'ATTRIBUTE_SEQUENCE'
,p_attribute_09=>'P4415_ID_NEXT'
,p_attribute_10=>'P4415_ID_PREV'
,p_attribute_13=>'P4415_ID_COUNT'
,p_attribute_14=>'plugin_id = :P4415_PLUGIN_ID'
,p_process_error_message=>'Unable to run Get Next or Previous Primary Key Value process.'
,p_internal_uid=>48453528653611000
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(17172608303187792)
,p_process_sequence=>50
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set P4415_IS_IN_USE'
,p_process_sql_clob=>':P4415_IS_IN_USE := case when wwv_flow_plugin_dev.is_in_use(:P4415_PLUGIN_ID) then ''Y'' end;'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P4415_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>17172608303187792
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(361912018962099809)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Reset Values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if :P4415_LOV_TYPE = ''STATIC'' or :P4415_LOV_TYPE is null then',
'        :P4415_LOV_COMPONENT_TYPE_ID    := null;',
'        :P4415_LOV_COMPONENT_TYPE_SCOPE := null;',
'        :P4415_LOV_COMP_TYPE_ON_DELETE  := null;',
'    end if;',
'',
'    if :P4415_LOV_TYPE = ''COMPONENT'' or :P4415_LOV_TYPE is null then',
'        delete from wwv_flow_plugin_attr_values',
'         where plugin_attribute_id = :P4415_ID',
'           and security_group_id   = :WORKSPACE_ID;',
'    end if;',
'',
'    if :P4415_LOV_TYPE is null then',
'        :P4415_NULL_TEXT := null;',
'    end if;',
'',
'    if v( ''P4415_DEPENDING_ON_ATTRIBUTE_ID'' ) is null then',
'        :P4415_DEPEND_ON_HAS_TO_EXIST := null;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>361912018962099809
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(48413404729213191)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_PLUGIN_ATTRIBUTES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_PLUGIN_ATTRIBUTES'
,p_attribute_03=>'P4415_ID'
,p_attribute_04=>'ID'
,p_attribute_09=>'P4415_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_process_error_message=>'Unable to process row of table WWV_FLOW_PLUGIN_ATTRIBUTES.'
,p_process_when=>'not wwv_flow_page.is_read_only'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Action Processed.'
,p_internal_uid=>48413404729213191
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(48608501983209265)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Synchronize attribute values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for l_plugin in',
'      ( select flow_id,',
'               plugin_type,',
'               name',
'          from wwv_flow_plugins',
'         where id                = to_number(:P4415_PLUGIN_ID)',
'           and security_group_id = :WORKSPACE_ID )',
'    loop',
'        wwv_flow_plugin_dev.synchronize_attribute_columns (',
'            p_application_id => l_plugin.flow_id,',
'            p_plugin_type    => l_plugin.plugin_type,',
'            p_plugin_name    => l_plugin.name,',
'            p_action         => ''ATTRIBUTES'' );',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'not wwv_flow_page.is_read_only'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>48608501983209265
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(48413623569213191)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'4415'
,p_process_when_button_id=>wwv_flow_imp.id(48407317470213118)
,p_internal_uid=>48413623569213191
);
end;
/
prompt --application/pages/page_04416
begin
wwv_flow_imp_page.create_page(
 p_id=>4416
,p_name=>'Edit Plug-in Attribute Value'
,p_alias=>'EDIT-PLUG-IN-ATTRIBUTE-VALUE'
,p_step_title=>'Edit Plug-in Attribute Value'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(27816729931938405)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script type="text/javascript">',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
' htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';',
'',
'</script>'))
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'EXISTS'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugin_attributes a,',
'       wwv_flow_plugins p',
' where a.id                = :P4416_PLUGIN_ATTRIBUTE_ID',
'   and a.security_group_id = :WORKSPACE_ID',
'   and p.id                = a.plugin_id',
'   and reference_id        is not null'))
,p_help_text=>'advnc_plugins.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(184653017765027772)
,p_plug_name=>'Entry'
,p_region_name=>'ENTRY'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_plug_query_show_nulls_as=>'(null)'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'generated 13-JUN-2000 11:36:34'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(184658130596027795)
,p_plug_name=>'Attribute: &P4416_PLUGIN_ATTRIBUTE_NAME.'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(184661911544027806)
,p_plug_name=>'Attribute Value'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>80
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Edit display and return values for an Attribute Value entry.</p>'
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'R:L:L'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(690213795029382242)
,p_plug_name=>'Anchor'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(184658518831027797)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(184658130596027795)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:4415:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(184659114740027798)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(184658130596027795)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(htmldb_delete_message,''DELETE'');'
,p_button_execute_validations=>'N'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    :P4416_ID                  is not null',
'and nvl(:P4416_IS_IN_USE, ''N'') = ''N''',
'and not wwv_flow_region.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(184658327013027796)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(184658130596027795)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>':P4416_ID is not null and not wwv_flow_region.is_read_only'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(184658723225027797)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(184658130596027795)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>':P4416_ID is null and not wwv_flow_region.is_read_only'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(184658927484027797)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(184658130596027795)
,p_button_name=>'CREATE_AGAIN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Create and Create Another'
,p_button_position=>'NEXT'
,p_button_condition=>':P4416_ID is null and not wwv_flow_region.is_read_only'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(184659512726027798)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(184658130596027795)
,p_button_name=>'APPLY_CHANGES_GET_PREVIOUS_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'disabled=""'
,p_button_comment=>'javascript:htmldb_goSubmit(''GET_PREVIOUS_ID'')'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(184659331693027798)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(184658130596027795)
,p_button_name=>'APPLY_CHANGES_GET_NEXT_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Next'
,p_button_position=>'PREVIOUS'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'disabled=""'
,p_button_comment=>'javascript:htmldb_goSubmit(''GET_NEXT_ID'')'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(184665626629027936)
,p_branch_action=>'f?p=&APP_ID.:4416:&SESSION.::&DEBUG.::P4416_ID:&P4416_ID_NEXT.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(184659331693027798)
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(184665802053027938)
,p_branch_action=>'f?p=&APP_ID.:4416:&SESSION.::&DEBUG.::P4416_ID:&P4416_ID_PREV.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(184659512726027798)
,p_branch_sequence=>40
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(184666028053027938)
,p_branch_name=>'Go To Page 4416'
,p_branch_action=>'f?p=&APP_ID.:4416:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':P4416_RETURN_TO_PAGE = ''YES'' and upper(:request) != ''DELETE'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(184722216772433152)
,p_branch_action=>'f?p=&APP_ID.:4416:&SESSION.::&DEBUG.:4416:P4416_PLUGIN_ATTRIBUTE_ID:&P4416_PLUGIN_ATTRIBUTE_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(184658927484027797)
,p_branch_sequence=>60
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(184666430682027939)
,p_branch_action=>'f?p=&APP_ID.:4415:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>70
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(184653222746027780)
,p_name=>'P4416_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(184653017765027772)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(184653630382027783)
,p_name=>'P4416_DISPLAY_SEQUENCE'
,p_is_required=>true
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(184653017765027772)
,p_use_cache_before_default=>'NO'
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_next_sequence number;',
'begin',
'    select coalesce(max(display_sequence), 0)+10',
'      into l_next_sequence',
'      from wwv_flow_plugin_attr_values',
'     where plugin_attribute_id = to_number(:P4416_PLUGIN_ATTRIBUTE_ID);',
'',
'    return l_next_sequence;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Sequence'
,p_source=>'DISPLAY_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>3
,p_cMaxlength=>3
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Specify the sequence for this value. The sequence determines the order in which the values are displayed.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(184654218916027785)
,p_name=>'P4416_DISPLAY_VALUE'
,p_is_required=>true
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(184653017765027772)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Display Value'
,p_source=>'DISPLAY_VALUE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'This text is displayed to the user. The return value is returned.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(184654800785027786)
,p_name=>'P4416_RETURN_VALUE'
,p_is_required=>true
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(184653017765027772)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Return Value'
,p_source=>'RETURN_VALUE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_cHeight=>1
,p_read_only_when=>'P4416_IS_IN_USE'
,p_read_only_when2=>'Y'
,p_read_only_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_read_only_disp_attr=>'class="fielddatabold"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the return value for this select list entry. The return value is stored in the attribute_xx column.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(184659715969027799)
,p_name=>'P4416_ID_NEXT'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(184658130596027795)
,p_prompt=>'P4416_ID_NEXT'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(184659919751027800)
,p_name=>'P4416_ID_PREV'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(184658130596027795)
,p_prompt=>'P4416_ID_PREV'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(184660128721027800)
,p_name=>'P4416_ID_COUNT'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(184658130596027795)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(57731626458856526)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies the plug-in attribute value.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(184662127656027898)
,p_name=>'P4416_RETURN_TO_PAGE'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(184661911544027806)
,p_prompt=>'Stay on page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_help_text=>'Select this checkbox to stay on this page after applying changes.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'YES'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(184721501058419139)
,p_name=>'P4416_FLOW_ID'
,p_item_sequence=>85
,p_item_plug_id=>wwv_flow_imp.id(184653017765027772)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Flow Id'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(184727714357508187)
,p_name=>'P4416_PLUGIN_ATTRIBUTE_NAME'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(184658130596027795)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select prompt',
'  from wwv_flow_plugin_attributes',
' where id = to_number(:P4416_PLUGIN_ATTRIBUTE_ID)'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Current attribute.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(184801318559237892)
,p_name=>'P4416_PLUGIN_ATTRIBUTE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(184653017765027772)
,p_use_cache_before_default=>'NO'
,p_source=>'PLUGIN_ATTRIBUTE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>5
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(366993328761570859)
,p_name=>'P4416_IS_DEPRECATED'
,p_is_required=>true
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(184653017765027772)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Deprecated'
,p_source=>'IS_DEPRECATED'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>'FB_FLOW_ID'
,p_display_when2=>'4411'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(517780551564724701)
,p_name=>'P4416_IS_QUICK_PICK'
,p_is_required=>true
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(184653017765027772)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Quick Pick'
,p_source=>'IS_QUICK_PICK'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify if the value should be displayed as a quick pick option in Page Designer.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(517780621466724702)
,p_name=>'P4416_HELP_TEXT'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(184653017765027772)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Help Text'
,p_source=>'HELP_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify help text for this value. The value help text is displayed as part of the context sensitive help for the attribute in the Builder.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'Y'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(782866828622960460)
,p_name=>'P4416_IS_IN_USE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(184653017765027772)
,p_prompt=>'Is In Use'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>1
,p_cMaxlength=>1
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_display_when_type=>'NEVER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(366993521213574351)
,p_computation_sequence=>10
,p_computation_item=>'P4416_IS_DEPRECATED'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'N'
,p_compute_when=>'P4416_IS_DEPRECATED'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(397306015479540740)
,p_name=>'ENABLE PREVIOUS'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P4416_ID_PREV'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(397306328730540740)
,p_event_id=>wwv_flow_imp.id(397306015479540740)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(184659512726027798)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(397306421020542400)
,p_name=>'ENABLE NEXT'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P4416_ID_NEXT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(397306701534542401)
,p_event_id=>wwv_flow_imp.id(397306421020542400)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(184659331693027798)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(184665024225027932)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_PLUGIN_ATTR_VALUES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_PLUGIN_ATTR_VALUES'
,p_attribute_03=>'P4416_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Error fetching row.'
,p_internal_uid=>184665024225027932
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(184665223103027934)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_PAGINATION'
,p_process_name=>'Get Next or Previous Primary Key Value'
,p_attribute_02=>'WWV_FLOW_PLUGIN_ATTR_VALUES'
,p_attribute_03=>'P4416_ID'
,p_attribute_04=>'ID'
,p_attribute_07=>'DISPLAY_SEQUENCE'
,p_attribute_08=>'DISPLAY_VALUE'
,p_attribute_09=>'P4416_ID_NEXT'
,p_attribute_10=>'P4416_ID_PREV'
,p_attribute_13=>'P4416_ID_COUNT'
,p_attribute_14=>'flow_id = :fb_flow_id and plugin_attribute_id = :P4416_PLUGIN_ATTRIBUTE_ID'
,p_process_error_message=>'Unable to run Get Next or Previous Primary Key Value process.'
,p_internal_uid=>184665223103027934
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(783000913880116947)
,p_process_sequence=>40
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set is-in-use'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_plugin_id number;',
'begin',
'    if :P4416_ID is null then',
'        :P4416_IS_IN_USE := ''N'';',
'    else',
'        select plugin_id',
'          into l_plugin_id',
'          from wwv_flow_plugin_attributes',
'         where id = :P4416_PLUGIN_ATTRIBUTE_ID;',
'',
'        :P4416_IS_IN_USE := case when wwv_flow_plugin_dev.is_in_use(l_plugin_id) then ''Y'' end;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>783000913880116947
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(184665418260027934)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_PLUGIN_ATTR_VALUES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_PLUGIN_ATTR_VALUES'
,p_attribute_03=>'P4416_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error processing row.'
,p_process_when=>'not wwv_flow_page.is_read_only'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Action processed.'
,p_internal_uid=>184665418260027934
);
end;
/
prompt --application/pages/page_04417
begin
wwv_flow_imp_page.create_page(
 p_id=>4417
,p_name=>'Edit Plug-in Action Position'
,p_alias=>'PLUG-IN-ACTION-POSITION'
,p_step_title=>'Edit Plug-in Action Position'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(27816729931938405)
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'EXISTS'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugins',
' where id                = :P4417_PLUGIN_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and reference_id      is not null'))
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(49889031712753845)
,p_plug_name=>'Identification'
,p_region_name=>'NAME'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_PLUGIN_ACT_POSITIONS'
,p_query_where=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    plugin_id         = :P4417_PLUGIN_ID',
'and security_group_id = :WORKSPACE_ID'))
,p_query_order_by=>'display_sequence'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(49908345020253125)
,p_plug_name=>'Action Positions'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>A plug-in action position is used to allow developers to specify additional interactions when the plug-in is used.</p>'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(49909053332255521)
,p_plug_name=>'Help Text'
,p_region_name=>'HELP_TEXT'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>197
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(49912049185330062)
,p_plug_name=>'Plug-in: &P4417_PLUGIN_DISPLAY_NAME.'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>5
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(49917958591436806)
,p_plug_name=>'Settings'
,p_region_name=>'SETTINGS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>130
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(49970156473883660)
,p_plug_name=>'Comments'
,p_region_name=>'COMMENTS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>207
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(172791241161005329)
,p_plug_name=>'Anchors'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1492927222540770)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(49912049185330062)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:4410:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1493313462540771)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(49912049185330062)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_confirm_message=>'&APP_TEXT$DELETE_MSG!RAW.'
,p_confirm_style=>'danger'
,p_button_condition=>':P4417_ID is not null and not wwv_flow_region.is_read_only and :P4417_IS_IN_USE = ''N'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1493768910540772)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(49912049185330062)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>':P4417_ID is not null and not wwv_flow_region.is_read_only'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1494133060540772)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(49912049185330062)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>':P4417_ID is null and not wwv_flow_region.is_read_only'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1494551028540772)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(49912049185330062)
,p_button_name=>'CREATE_AGAIN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Create and Create Another'
,p_button_position=>'NEXT'
,p_button_condition=>':P4417_ID is null and not wwv_flow_region.is_read_only'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1494991562540772)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(49912049185330062)
,p_button_name=>'APPLY_CHANGES_GET_PREVIOUS_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'disabled'
,p_button_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1495362188540773)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(49912049185330062)
,p_button_name=>'APPLY_CHANGES_GET_NEXT_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Next'
,p_button_position=>'PREVIOUS'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'disabled'
,p_button_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1566807323540829)
,p_branch_name=>'Go To Page 4417'
,p_branch_action=>'f?p=&APP_ID.:4417:&SESSION.::&DEBUG.:4417:P4417_PLUGIN_ID:&P4417_PLUGIN_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(1494551028540772)
,p_branch_sequence=>51
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1568057384540830)
,p_branch_name=>'Go To Page 4417'
,p_branch_action=>'f?p=&APP_ID.:4417:&SESSION.::&DEBUG.::P4417_ID,P4417_PLUGIN_ID:&P4417_ID_PREV.,&P4417_PLUGIN_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(1494991562540772)
,p_branch_sequence=>54
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1567672418540830)
,p_branch_name=>'Go To Page 4417'
,p_branch_action=>'f?p=&APP_ID.:4417:&SESSION.::&DEBUG.::P4417_ID,P4417_PLUGIN_ID:&P4417_ID_NEXT.,&P4417_PLUGIN_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(1495362188540773)
,p_branch_sequence=>55
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1567226583540830)
,p_branch_name=>'Go To Page 4417'
,p_branch_action=>'f?p=&APP_ID.:4417:&SESSION.::&DEBUG.::P4417_PLUGIN_ID,P4417_ID:&P4417_PLUGIN_ID.,&P4417_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>61
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P4417_RETURN_TO_PAGE'
,p_branch_condition_text=>'YES'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1566474146540829)
,p_branch_name=>'Go To Page 4410'
,p_branch_action=>'f?p=&APP_ID.:4410:&SESSION.::&DEBUG.::P4410_ID:&P4417_PLUGIN_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>149
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2619670763490914)
,p_name=>'P4417_TEMPLATE_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(49917958591436806)
,p_item_source_plug_id=>wwv_flow_imp.id(49889031712753845)
,p_prompt=>'Predefined Template'
,p_source=>'TEMPLATE_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name,',
'       id',
'  from wwv_flow_plugin_act_templates',
' where plugin_id         = :P4417_PLUGIN_ID',
'   and security_group_id = :WORKSPACE_ID',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'None'
,p_cHeight=>1
,p_read_only_when=>'P4417_IS_IN_USE'
,p_read_only_when2=>'Y'
,p_read_only_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select an action template that is used automatically if a developer creates an action for this position. If no template is selected, developers are free to pick an available action template themselves.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11296038478685172)
,p_name=>'P4417_STATIC_ID'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_imp.id(49889031712753845)
,p_item_source_plug_id=>wwv_flow_imp.id(49889031712753845)
,p_prompt=>'Static ID'
,p_source=>'STATIC_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the Static ID for this action position. This ID can be referenced in the partial template using the #STATIC_ID# syntax.',
'If the position is of type link, #STATIC_ID_ATTR# can be used to reference the link attributes entered by the developer.'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_attribute_06=>'UPPER'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(49891032034753896)
,p_name=>'P4417_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(49889031712753845)
,p_item_source_plug_id=>wwv_flow_imp.id(49889031712753845)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(49891222651753918)
,p_name=>'P4417_PLUGIN_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(49889031712753845)
,p_item_source_plug_id=>wwv_flow_imp.id(49889031712753845)
,p_source=>'PLUGIN_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(49892016806753929)
,p_name=>'P4417_NAME'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_imp.id(49889031712753845)
,p_item_source_plug_id=>wwv_flow_imp.id(49889031712753845)
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Specify the name displayed for this action position in the Builder.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(49900637130753945)
,p_name=>'P4417_HELP_TEXT'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(49909053332255521)
,p_item_source_plug_id=>wwv_flow_imp.id(49889031712753845)
,p_prompt=>'Help Text'
,p_source=>'HELP_TEXT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>8
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_is_persistent=>'N'
,p_help_text=>'<p>Specify help text for this plug-in action position. The help text is displayed as context sensitive help for the action position in the Builder.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(49910600422753961)
,p_name=>'P4417_IS_QUICK_PICK'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(49917958591436806)
,p_item_source_plug_id=>wwv_flow_imp.id(49889031712753845)
,p_item_default=>'N'
,p_prompt=>'Quick Pick'
,p_source=>'IS_QUICK_PICK'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Specifies if this action position is listed in the Quick Pick select list.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(49916246351253171)
,p_name=>'P4417_RETURN_TO_PAGE'
,p_item_sequence=>910
,p_item_plug_id=>wwv_flow_imp.id(49908345020253125)
,p_prompt=>'Stay on page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_help_text=>'Select this checkbox to stay on this page after applying changes.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'YES'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(49929281367391180)
,p_name=>'P4417_PLUGIN_DISPLAY_NAME'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_imp.id(49912049185330062)
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name',
'  from wwv_flow_plugins',
' where id                = :P4417_PLUGIN_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Selected plug-in.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(49948485878151760)
,p_name=>'P4417_ID_NEXT'
,p_item_sequence=>920
,p_item_plug_id=>wwv_flow_imp.id(49912049185330062)
,p_prompt=>'P4417_ID_NEXT'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(49948681660151766)
,p_name=>'P4417_ID_PREV'
,p_item_sequence=>930
,p_item_plug_id=>wwv_flow_imp.id(49912049185330062)
,p_prompt=>'P4417_ID_PREV'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(49948901121151772)
,p_name=>'P4417_ID_COUNT'
,p_item_sequence=>940
,p_item_plug_id=>wwv_flow_imp.id(49912049185330062)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(50000359082883803)
,p_name=>'P4417_ACTION_POSITION_COMMENTS'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>131
,p_item_plug_id=>wwv_flow_imp.id(49970156473883660)
,p_item_source_plug_id=>wwv_flow_imp.id(49889031712753845)
,p_prompt=>'Comments'
,p_source=>'ACTION_POSITION_COMMENTS'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_is_persistent=>'N'
,p_help_text=>'<p>Enter any comments or notes here.  These comments will never be displayed when running the application.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(50091537662765751)
,p_name=>'P4417_IS_IN_USE'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(49889031712753845)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(180776723533527536)
,p_name=>'P4417_FLOW_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(49889031712753845)
,p_item_source_plug_id=>wwv_flow_imp.id(49889031712753845)
,p_item_default=>'&FB_FLOW_ID.'
,p_source=>'FLOW_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(363403593939539320)
,p_name=>'P4417_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(49917958591436806)
,p_item_source_plug_id=>wwv_flow_imp.id(49889031712753845)
,p_item_default=>'LINK'
,p_prompt=>'Type'
,p_source=>'TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PLUGIN.ACTION_POSITION.TYPE'
,p_lov=>'.'||wwv_flow_imp.id(2609610747438738)||'.'
,p_cHeight=>1
,p_read_only_when=>'P4417_IS_IN_USE'
,p_read_only_when2=>'Y'
,p_read_only_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select if the action position renders as a <strong>link</strong> or is based on a button <strong>template</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(452734241028580244)
,p_name=>'P4417_DISPLAY_SEQUENCE'
,p_source_data_type=>'NUMBER'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(49917958591436806)
,p_item_source_plug_id=>wwv_flow_imp.id(49889031712753845)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select coalesce( max( display_sequence ), 0 ) + 10',
'  from wwv_flow_plugin_act_positions',
' where plugin_id         = :P4417_PLUGIN_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_item_default_type=>'SQL_QUERY'
,p_prompt=>'Display Sequence'
,p_source=>'DISPLAY_SEQUENCE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>4
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Specify the display sequence for this plug-in action position in the &PRODUCT_NAME. Builder.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
,p_attribute_04=>'numeric'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1528878432540805)
,p_validation_name=>'P4417_STATIC_ID unique'
,p_validation_sequence=>580
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugin_act_positions',
' where plugin_id          = :P4417_PLUGIN_ID',
'   and security_group_id  = :WORKSPACE_ID',
'   and static_id          = :P4417_STATIC_ID',
'   and (  :P4417_ID is null',
'       or id <> :P4417_ID',
'       )',
'union all',
'select 1',
'  from wwv_flow_plugin_attributes',
' where plugin_id          = :P4417_PLUGIN_ID',
'   and security_group_id  = :WORKSPACE_ID',
'   and static_id          = :P4417_STATIC_ID',
'union all',
'select 1',
'  from wwv_flow_plugin_slots',
' where flow_id           = :FB_FLOW_ID',
'   and plugin_id         = :P4417_PLUGIN_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and placeholder       = :P4417_STATIC_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Static Identifier already in use as an action position, custom attribute or region plugin slot.'
,p_validation_condition=>'P4417_STATIC_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_imp.id(11296038478685172)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1558051561540823)
,p_name=>'ENABLE PREVIOUS'
,p_event_sequence=>225
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P4417_ID_PREV'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1558512202540824)
,p_event_id=>wwv_flow_imp.id(1558051561540823)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(1494991562540772)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1558992065540824)
,p_name=>'ENABLE NEXT'
,p_event_sequence=>235
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P4417_ID_NEXT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1559490255540825)
,p_event_id=>wwv_flow_imp.id(1558992065540824)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(1495362188540773)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1563511071540826)
,p_name=>'Set Static ID'
,p_event_sequence=>285
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4417_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1564051842540827)
,p_event_id=>wwv_flow_imp.id(1563511071540826)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4417_STATIC_ID'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.items.P4417_NAME.value',
'    .replace( /\s|-/g, "_" )',
'    .toUpperCase();'))
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_client_condition_type=>'NULL'
,p_client_condition_element=>'P4417_STATIC_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2619992140490917)
,p_name=>'Type = Template'
,p_event_sequence=>305
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4417_TYPE'
,p_condition_element=>'P4417_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TEMPLATE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2620036698490918)
,p_event_id=>wwv_flow_imp.id(2619992140490917)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4417_TEMPLATE_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2620264715490920)
,p_event_id=>wwv_flow_imp.id(2619992140490917)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4417_TEMPLATE_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2620320820490921)
,p_event_id=>wwv_flow_imp.id(2619992140490917)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4417_TEMPLATE_ID'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1532373098540807)
,p_process_sequence=>50
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set P4417_IS_IN_USE'
,p_process_sql_clob=>':P4417_IS_IN_USE := case when wwv_flow_plugin_dev.is_action_position_in_use(:P4417_ID) then ''Y'' else ''N'' end;'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P4417_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>1532373098540807
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2622334764490941)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(49889031712753845)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process form Identification'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2622334764490941
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1533586088540808)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'4415'
,p_process_when_button_id=>wwv_flow_imp.id(1493313462540771)
,p_internal_uid=>1533586088540808
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2620623711490924)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(49889031712753845)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Edit Plug-in Action Position'
,p_attribute_01=>'P4417_ID_NEXT'
,p_attribute_02=>'P4417_ID_PREV'
,p_attribute_03=>'P4417_ID_COUNT'
,p_internal_uid=>2620623711490924
);
end;
/
prompt --application/pages/page_04418
begin
wwv_flow_imp_page.create_page(
 p_id=>4418
,p_name=>'Edit Plug-in Action Template'
,p_alias=>'PLUGIN-ACTION-TEMPLATE'
,p_step_title=>'Edit Plug-in Action Template'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(27816729931938405)
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'EXISTS'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugins',
' where id                = :P4418_PLUGIN_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and reference_id      is not null'))
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(51780708985211848)
,p_plug_name=>'Identification'
,p_region_name=>'NAME'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_PLUGIN_ACT_TEMPLATES'
,p_query_where=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    plugin_id         = :P4418_PLUGIN_ID',
'and security_group_id = :WORKSPACE_ID'))
,p_query_order_by=>'name'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(51800022292711128)
,p_plug_name=>'Action Templates'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>A plug-in action template is used to allow developers to specify what kind of interaction gets displayed when the plug-in action positions are used.</p>'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(51800730604713524)
,p_plug_name=>'Help Text'
,p_region_name=>'HELP_TEXT'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>197
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(51803726457788065)
,p_plug_name=>'Plug-in: &P4418_PLUGIN_DISPLAY_NAME.'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>5
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(51809635863894809)
,p_plug_name=>'Settings'
,p_region_name=>'SETTINGS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>130
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(51861833746341663)
,p_plug_name=>'Comments'
,p_region_name=>'COMMENTS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>207
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(174682918433463332)
,p_plug_name=>'Anchors'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1902962389458123)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(51803726457788065)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:4410:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1903311670458123)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(51803726457788065)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_confirm_message=>'&APP_TEXT$DELETE_MSG!RAW.'
,p_confirm_style=>'danger'
,p_button_condition=>':P4418_ID is not null and not wwv_flow_region.is_read_only and :P4418_IS_IN_USE = ''N'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1903721830458124)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(51803726457788065)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>':P4418_ID is not null and not wwv_flow_region.is_read_only'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1904138866458124)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(51803726457788065)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>':P4418_ID is null and not wwv_flow_region.is_read_only'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1904515357458124)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(51803726457788065)
,p_button_name=>'CREATE_AGAIN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Create and Create Another'
,p_button_position=>'NEXT'
,p_button_condition=>':P4418_ID is null and not wwv_flow_region.is_read_only'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1904926317458124)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(51803726457788065)
,p_button_name=>'APPLY_CHANGES_GET_PREVIOUS_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'disabled'
,p_button_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1905304138458125)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(51803726457788065)
,p_button_name=>'APPLY_CHANGES_GET_NEXT_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Next'
,p_button_position=>'PREVIOUS'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'disabled'
,p_button_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1918069880458142)
,p_branch_name=>'Go To Page 4417'
,p_branch_action=>'f?p=&APP_ID.:4418:&SESSION.::&DEBUG.:4418:P4418_PLUGIN_ID:&P4418_PLUGIN_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(1904515357458124)
,p_branch_sequence=>51
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1919212640458142)
,p_branch_name=>'Go To Page 4417'
,p_branch_action=>'f?p=&APP_ID.:4418:&SESSION.::&DEBUG.::P4418_ID,P4418_PLUGIN_ID:&P4418_ID_PREV.,&P4418_PLUGIN_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(1904926317458124)
,p_branch_sequence=>54
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1918856166458142)
,p_branch_name=>'Go To Page 4417'
,p_branch_action=>'f?p=&APP_ID.:4418:&SESSION.::&DEBUG.::P4418_ID,P4418_PLUGIN_ID:&P4418_ID_NEXT.,&P4418_PLUGIN_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(1905304138458125)
,p_branch_sequence=>55
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1918405094458142)
,p_branch_name=>'Go To Page 4417'
,p_branch_action=>'f?p=&APP_ID.:4418:&SESSION.::&DEBUG.::P4418_PLUGIN_ID,P4418_ID:&P4418_PLUGIN_ID.,&P4418_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>61
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P4418_RETURN_TO_PAGE'
,p_branch_condition_text=>'YES'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1917696980458141)
,p_branch_name=>'Go To Page 4410'
,p_branch_action=>'f?p=&APP_ID.:4410:&SESSION.::&DEBUG.::P4410_ID:&P4418_PLUGIN_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>149
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1919579107465801)
,p_name=>'P4418_ACTION_TEMPLATE_COMMENTS'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(51861833746341663)
,p_item_source_plug_id=>wwv_flow_imp.id(51780708985211848)
,p_prompt=>'Comments'
,p_source=>'ACTION_TEMPLATE_COMMENTS'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_is_persistent=>'N'
,p_help_text=>'<p>Enter any comments or notes here.  These comments will never be displayed when running the application.</p>'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2623132198490949)
,p_name=>'P4418_TEMPLATE'
,p_source_data_type=>'CLOB'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(51809635863894809)
,p_item_source_plug_id=>wwv_flow_imp.id(51780708985211848)
,p_prompt=>'Action Template'
,p_source=>'TEMPLATE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>30000
,p_cHeight=>10
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the HTML markup for the template.</p>',
'<p>',
'The following predefined template placeholders are supported:',
'<ul>',
'<li>LABEL</li>',
'<li>ICON_CLASSES</li>',
'<li>CSS_CLASSES</li>',
'<li>IS_HOT</li>',
'<li>IS_ICON_ONLY</li>',
'<li>IS_DISABLED</li>',
'<li>LINK_URL</li>',
'<li>LINK_ATTR</li>',
'<li>APEX$DOM_ID - Unique DOM ID generated when the template is invoked, useful for referencing other DOM elements in the provided HTML markup.</li>',
'</ul>',
'</p>',
'<p>',
'For templates of type <strong>Menu</strong> the following additional placeholders have to be used:',
'<ul>',
'<li>MENU_ID</li>',
'<li>MENU</li>',
'</ul>',
'</p>',
'',
'<p>Supports Template Directives.</p>'))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2623241234490950)
,p_name=>'P4418_TRANSLATE_THIS_TEMPLATE'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(51809635863894809)
,p_item_source_plug_id=>wwv_flow_imp.id(51780708985211848)
,p_item_default=>'N'
,p_prompt=>'Translate Action Template'
,p_source=>'TRANSLATE_THIS_TEMPLATE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Specify whether or not this template is included in the XLIFF translation file.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(51785497869212012)
,p_name=>'P4418_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(51780708985211848)
,p_item_source_plug_id=>wwv_flow_imp.id(51780708985211848)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(51785688486212034)
,p_name=>'P4418_PLUGIN_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(51780708985211848)
,p_item_source_plug_id=>wwv_flow_imp.id(51780708985211848)
,p_source=>'PLUGIN_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(51786482641212045)
,p_name=>'P4418_NAME'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_imp.id(51780708985211848)
,p_item_source_plug_id=>wwv_flow_imp.id(51780708985211848)
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Specify the name displayed for this action template in the Builder.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(51802083135212067)
,p_name=>'P4418_HELP_TEXT'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(51800730604713524)
,p_item_source_plug_id=>wwv_flow_imp.id(51780708985211848)
,p_prompt=>'Help Text'
,p_source=>'HELP_TEXT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>8
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_is_persistent=>'N'
,p_help_text=>'<p>Specify help text for this plug-in action template. The help text is displayed as context sensitive help for the action template in the Builder.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(51816482356711292)
,p_name=>'P4418_RETURN_TO_PAGE'
,p_item_sequence=>910
,p_item_plug_id=>wwv_flow_imp.id(51800022292711128)
,p_prompt=>'Stay on page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_help_text=>'Select this checkbox to stay on this page after applying changes.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'YES'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(51835078173849305)
,p_name=>'P4418_PLUGIN_DISPLAY_NAME'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_imp.id(51803726457788065)
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name',
'  from wwv_flow_plugins',
' where id                = :P4418_PLUGIN_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Selected plug-in.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(51854282684609885)
,p_name=>'P4418_ID_NEXT'
,p_item_sequence=>920
,p_item_plug_id=>wwv_flow_imp.id(51803726457788065)
,p_prompt=>'P4418_ID_NEXT'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(51854478466609891)
,p_name=>'P4418_ID_PREV'
,p_item_sequence=>930
,p_item_plug_id=>wwv_flow_imp.id(51803726457788065)
,p_prompt=>'P4418_ID_PREV'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(51854697927609897)
,p_name=>'P4418_ID_COUNT'
,p_item_sequence=>940
,p_item_plug_id=>wwv_flow_imp.id(51803726457788065)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(51986003497223867)
,p_name=>'P4418_IS_IN_USE'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(51780708985211848)
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(182671189367985652)
,p_name=>'P4418_FLOW_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(51780708985211848)
,p_item_source_plug_id=>wwv_flow_imp.id(51780708985211848)
,p_item_default=>'&FB_FLOW_ID.'
,p_source=>'FLOW_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(365311401109997448)
,p_name=>'P4418_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(51809635863894809)
,p_item_source_plug_id=>wwv_flow_imp.id(51780708985211848)
,p_prompt=>'Type'
,p_source=>'TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PLUGIN.ACTION_TEMPLATE.TYPE'
,p_lov=>'.'||wwv_flow_imp.id(2610859887449164)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_read_only_when=>'P4418_IS_IN_USE'
,p_read_only_when2=>'Y'
,p_read_only_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select if the template is just a simple <strong>Button</strong> or displays a <strong>Menu</strong> button.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1912906083458137)
,p_name=>'ENABLE PREVIOUS'
,p_event_sequence=>225
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P4418_ID_PREV'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1913427011458139)
,p_event_id=>wwv_flow_imp.id(1912906083458137)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(1904926317458124)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1913861322458139)
,p_name=>'ENABLE NEXT'
,p_event_sequence=>235
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P4418_ID_NEXT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1914321211458139)
,p_event_id=>wwv_flow_imp.id(1913861322458139)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(1905304138458125)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1914710034458139)
,p_name=>'Set Static ID'
,p_event_sequence=>285
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4418_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1915286742458140)
,p_event_id=>wwv_flow_imp.id(1914710034458139)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4418_STATIC_ID'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.items.P4418_NAME.value',
'    .replace( /\s|-/g, "_" )',
'    .toUpperCase();'))
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_client_condition_type=>'NULL'
,p_client_condition_element=>'P4418_STATIC_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1920496870465810)
,p_name=>'Set Default Template'
,p_event_sequence=>295
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4418_TYPE'
,p_condition_element=>'P4418_TEMPLATE'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1920562451465811)
,p_event_id=>wwv_flow_imp.id(1920496870465810)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'For Button'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4418_TEMPLATE'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>wwv_flow_string.join(wwv_flow_t_varchar2(
'`<a class="rw-Button{if IS_HOT/} is-hot{endif/} {if ICON_CLASSES/}rw-Button--iconText{else/}rw-Button--text{endif/} #CSS_CLASSES#" href="#LINK_URL#" title="#LABEL!ATTR#" #LINK_ATTR# {if IS_DISABLED/}disabled{endif/}>',
'  <span class="rw-Button-label">',
'    <span class="rw-Button-icon #ICON_CLASSES#" aria-hidden="true"></span>',
'    <span class="rw-Button-text">#LABEL#</span>',
'  </span>',
'</a>`'))
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_client_condition_type=>'EQUALS'
,p_client_condition_element=>'P4418_TYPE'
,p_client_condition_expression=>'BUTTON'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1920615488465812)
,p_event_id=>wwv_flow_imp.id(1920496870465810)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'For Menu'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4418_TEMPLATE'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>wwv_flow_string.join(wwv_flow_t_varchar2(
'`<button class="rw-Button rw-Button--borderless rw-Button--icon" {if IS_DISABLED/}disabled{endif/} type="button" data-menu="#MENU_ID#">',
'  <span class="rw-Button-label">',
'    <span class="rw-Button-icon oj-ux-ico-overflow-h" aria-hidden="true"></span>',
'    <span class="rw-Button-text">#LABEL#</span>',
'  </span>',
'</button> #MENU#`'))
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_client_condition_type=>'EQUALS'
,p_client_condition_element=>'P4418_TYPE'
,p_client_condition_expression=>'MENU'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1912104758458136)
,p_process_sequence=>50
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set P4418_IS_IN_USE'
,p_process_sql_clob=>':P4418_IS_IN_USE := case when wwv_flow_plugin_dev.is_action_template_in_use(:P4418_ID) then ''Y'' else ''N'' end;'
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P4418_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>1912104758458136
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1899593199458120)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(51780708985211848)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process form Identification'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>1899593199458120
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1912531806458136)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'4415'
,p_process_when_button_id=>wwv_flow_imp.id(1903311670458123)
,p_internal_uid=>1912531806458136
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1899192854458119)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(51780708985211848)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Edit Plug-in Action Template'
,p_attribute_01=>'P4418_ID_NEXT'
,p_attribute_02=>'P4418_ID_PREV'
,p_attribute_03=>'P4418_ID_COUNT'
,p_internal_uid=>1899192854458119
);
end;
/
prompt --application/pages/page_04420
begin
wwv_flow_imp_page.create_page(
 p_id=>4420
,p_name=>'Plug-in Utilization'
,p_alias=>'PLUG-IN-UTILIZATION'
,p_step_title=>'Plug-in Utilization'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(27816729931938405)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_plugins.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(27854530209326914)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page displays the page items and regions that will be rendered using the selected Plug-in in the current application.</p>',
'',
'<p>To edit page items or region, select the item name or region.</p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(27858112567431339)
,p_plug_name=>'Plug-in Utilization'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name,',
'       object_type,',
'       coalesce (',
'           object_url,',
'           ''f?p=4000:4500:''||:APP_SESSION||''::NO:1:FB_FLOW_ID,FB_FLOW_PAGE_ID,F4000_P1_FLOW,F4000_P1_PAGE:''||app_id||'',''||page_id||'',''||app_id||'',''||page_id||''#''||component_type||'':''||component_id',
'           ) as object_url,',
'       object_name,',
'       page_id,',
'       page_name,',
'       region_title',
'  from (',
'        select /* APEX 4000P4420a */ p.display_name            as display_name,',
'               wwv_flow_lang.system_message(''F4000.PAGE_ITEM'') as object_type,',
'               to_char(null)                                   as object_url,',
'               i.name                                          as object_name,',
'               5120                                            as component_type,',
'               i.id                                            as component_id,',
'               i.flow_id                                       as app_id,',
'               i.flow_step_id                                  as page_id,',
'               pg.name                                         as page_name,',
'               r.plug_name                                     as region_title',
'          from wwv_flow_plugins    p,',
'               wwv_flow_step_items i,',
'               wwv_flow_steps      pg,',
'               wwv_flow_page_plugs r',
'         where p.flow_id           = to_number(:FB_FLOW_ID)',
'           and p.security_group_id = to_number(:WORKSPACE_ID)',
'           and p.plugin_type       = ''ITEM TYPE''',
'           and i.flow_id           = p.flow_id',
'           and i.display_as        = ''PLUGIN_''||p.name',
'           and pg.flow_id          = i.flow_id',
'           and pg.id               = i.flow_step_id',
'           and r.id (+)            = i.item_plug_id',
'        union all',
'        select p.display_name                                      as display_name,',
'               wwv_flow_lang.system_message(''F4000.REPORT_COLUMN'') as object_type,',
'               to_char(null)                                       as object_url,',
'               c.name                                              as object_name,',
'               7940                                                as component_type,',
'               c.id                                                as component_id,',
'               c.flow_id                                           as app_id,',
'               pg.id                                               as page_id,',
'               pg.name                                             as page_name,',
'               r.plug_name                                         as region_title',
'          from wwv_flow_plugins    p,',
'               wwv_flow_region_columns c,',
'               wwv_flow_page_plugs r,',
'               wwv_flow_steps      pg',
'         where p.flow_id           = to_number(:FB_FLOW_ID)',
'           and p.security_group_id = to_number(:WORKSPACE_ID)',
'           and p.plugin_type       = ''ITEM TYPE''',
'           and c.flow_id           = p.flow_id',
'           and c.item_type         = ''PLUGIN_''||p.name',
'           and r.id                = c.region_id',
'           and pg.flow_id          = r.flow_id',
'           and pg.id               = r.page_id',
'        union all',
'        select p.display_name                               as display_name,',
'               wwv_flow_lang.system_message(''F4000.REGION'') as object_type,',
'               to_char(null)                                as object_url,',
'               r.plug_name                                  as object_name,',
'               5110                                         as component_type,',
'               r.id                                         as component_id,',
'               r.flow_id                                    as app_id,',
'               r.page_id                                    as page_id,',
'               pg.name                                      as page_name,',
'               null                                         as region_title',
'          from wwv_flow_plugins    p,',
'               wwv_flow_page_plugs r,',
'               wwv_flow_steps      pg',
'         where p.flow_id           = to_number(:FB_FLOW_ID)',
'           and p.security_group_id = to_number(:WORKSPACE_ID)',
'           and p.plugin_type       = ''REGION TYPE''',
'           and r.flow_id           = p.flow_id',
'           and r.plug_source_type  = ''PLUGIN_''||p.name',
'           and pg.flow_id          = r.flow_id',
'           and pg.id               = r.page_id',
'        union all',
'        select p.display_name                               as display_name,',
'               wwv_flow_lang.system_message(''F4000.REGION'') as object_type,',
'               to_char(null)                                as object_url,',
'               r.plug_name                                  as object_name,',
'               5110                                         as component_type,',
'               r.id                                         as component_id,',
'               r.flow_id                                    as app_id,',
'               r.page_id                                    as page_id,',
'               pg.name                                      as page_name,',
'               null                                         as region_title',
'          from wwv_flow_template_components p,',
'               wwv_flow_page_plugs r,',
'               wwv_flow_steps pg',
'         where p.flow_id            = to_number(:FB_FLOW_ID)',
'           and p.security_group_id  = to_number(:WORKSPACE_ID)',
'           and p.theme_id           is null',
'           and r.flow_id            = p.flow_id',
'           and r.security_group_id  = p.security_group_id',
'           and r.plug_source_type   = p.used_name',
'           and pg.flow_id           = r.flow_id',
'           and pg.id                = r.page_id',
'           and pg.security_group_id = r.security_group_id',
'        union all',
'        select p.display_name                                       as display_name,',
'               wwv_flow_lang.system_message(''F4000.DYNAMIC ACTION'') as object_type,',
'               to_char(null)                                        as object_url,',
'               e.name                                               as object_name,',
'               5150                                                 as component_type,',
'               a.id                                                 as component_id,',
'               a.flow_id                                            as app_id,',
'               e.page_id                                            as page_id,',
'               pg.name                                              as page_name,',
'               null                                                 as region_title',
'          from wwv_flow_plugins         p,',
'               wwv_flow_page_da_events  e,',
'               wwv_flow_page_da_actions a,',
'               wwv_flow_steps           pg',
'         where p.flow_id           = to_number(:FB_FLOW_ID)',
'           and p.security_group_id = to_number(:WORKSPACE_ID)',
'           and p.plugin_type       = ''DYNAMIC ACTION''',
'           and e.flow_id           = p.flow_id',
'           and a.event_id          = e.id',
'           and a.action            = ''PLUGIN_''||p.name',
'           and pg.flow_id          = e.flow_id',
'           and pg.id               = e.page_id',
'        union all',
'        select p.display_name                                as display_name,',
'               wwv_flow_lang.system_message(''PAGE PROCESS'')  as object_type,',
'               to_char(null)                                 as object_url,',
'               pr.process_name                               as object_name,',
'               5530                                          as component_type,',
'               pr.id                                         as component_id,',
'               pr.flow_id                                    as app_id,',
'               pr.flow_step_id                               as page_id,',
'               pg.name                                       as page_name,',
'               null                                          as region_title',
'          from wwv_flow_plugins    p,',
'               wwv_flow_step_processing pr,',
'               wwv_flow_steps      pg',
'         where p.flow_id           = to_number(:FB_FLOW_ID)',
'           and p.security_group_id = to_number(:WORKSPACE_ID)',
'           and p.plugin_type       = ''PROCESS TYPE''',
'           and pr.flow_id          = p.flow_id',
'           and pr.process_type     = ''PLUGIN_''||p.name',
'           and pg.flow_id          = pr.flow_id',
'           and pg.id               = pr.flow_step_id',
'        union all',
'        select p.display_name                                as display_name,',
'               wwv_flow_lang.system_message(''APPLICACTION_PROCESS'') as object_type,',
'               ''f?p=4000:4309:''||:APP_SESSION||''::NO:RP,4309:''||''F4000_P4309_ID,FB_FLOW_ID:''||pr.id||'',''||pr.flow_id as object_url,',
'               pr.process_name                               as object_name,',
'               null                                          as component_type,',
'               null                                          as component_id,',
'               pr.flow_id                                    as app_id,',
'               null                                          as page_id,',
'               null                                          as page_name,',
'               null                                          as region_title',
'          from wwv_flow_plugins    p,',
'               wwv_flow_processing pr',
'         where p.flow_id           = to_number(:FB_FLOW_ID)',
'           and p.security_group_id = to_number(:WORKSPACE_ID)',
'           and p.plugin_type       = ''PROCESS TYPE''',
'           and pr.flow_id          = p.flow_id',
'           and pr.process_type     = ''PLUGIN_''||p.name',
'        union all',
'        select p.display_name                                    as display_name,',
'               wwv_flow_lang.system_message(''DICTIONARY_VIEW.APEX_APPL_AUTOMATION_ACTIONS'') as object_type,',
'               ''f?p=4000:7022:''||:APP_SESSION||''::NO:RP,7022:''||''P7022_ID,FB_FLOW_ID:''||a.id||'',''||a.flow_id as object_url,',
'               a.name                                            as object_name,',
'               null                                              as component_type,',
'               null                                              as component_id,',
'               a.flow_id                                         as app_id,',
'               null                                              as page_id,',
'               null                                              as page_name,',
'               null                                              as region_title',
'          from wwv_flow_plugins            p,',
'               wwv_flow_automation_actions a',
'         where p.flow_id           = to_number(:FB_FLOW_ID)',
'           and p.security_group_id = to_number(:WORKSPACE_ID)',
'           and p.plugin_type       = ''PROCESS TYPE''',
'           and a.flow_id           = p.flow_id',
'           and a.action_type       = ''PLUGIN_''||p.name',
'        union all',
'        select p.display_name                                as display_name,',
'               wwv_flow_lang.system_message(''DICTIONARY_VIEW.APEX_APPL_TASKDEF_ACTIONS'') as object_type,',
'               ''f?p=4000:9506:''||:APP_SESSION||''::NO:RP,9506:''||''P9506_ID,FB_FLOW_ID:''||a.id||'',''||a.flow_id as object_url,',
'               a.name                                        as object_name,',
'               null                                          as component_type,',
'               null                                          as component_id,',
'               a.flow_id                                     as app_id,',
'               null                                          as page_id,',
'               null                                          as page_name,',
'               null                                          as region_title',
'          from wwv_flow_plugins          p,',
'               wwv_flow_task_def_actions a',
'         where p.flow_id           = to_number(:FB_FLOW_ID)',
'           and p.security_group_id = to_number(:WORKSPACE_ID)',
'           and p.plugin_type       = ''PROCESS TYPE''',
'           and a.flow_id           = p.flow_id',
'           and a.action_type       = ''PLUGIN_''||p.name',
'        union all',
'        select p.display_name                                as display_name,',
'               wwv_flow_lang.system_message(''DICTIONARY_VIEW.APEX_APPL_WORKFLOW_ACTIVITIES'') as object_type,',
'               to_char(null)                                 as object_url,',
'               a.name                                        as object_name,',
'               8630                                          as component_type,',
'               a.id                                          as component_id,',
'               a.flow_id                                     as app_id,',
'               null                                          as page_id,',
'               null                                          as page_name,',
'               null                                          as region_title',
'          from wwv_flow_plugins          p,',
'               wwv_flow_workflow_activities a',
'         where p.flow_id           = to_number(:FB_FLOW_ID)',
'           and p.security_group_id = to_number(:WORKSPACE_ID)',
'           and p.plugin_type       = ''PROCESS TYPE''',
'           and a.flow_id           = p.flow_id',
'           and a.activity_type     = ''PLUGIN_''||p.name           ',
'        union all',
'        select p.display_name                                as display_name,',
'               wwv_flow_lang.system_message(''SECURITY_SCHEME'') as object_type,',
'               ''f?p=4000:4008:''||:APP_SESSION||''::NO:RP,4008:''||''F4000_P4008_ID,FB_FLOW_ID:''||s.id||'',''||s.flow_id as object_url,',
'               s.name                                        as object_name,',
'               null                                          as component_type,',
'               null                                          as component_id,',
'               s.flow_id                                     as app_id,',
'               null                                          as page_id,',
'               null                                          as page_name,',
'               null                                          as region_title',
'          from wwv_flow_plugins    p,',
'               wwv_flow_security_schemes s',
'         where p.flow_id           = to_number(:FB_FLOW_ID)',
'           and p.security_group_id = to_number(:WORKSPACE_ID)',
'           and p.plugin_type       = ''AUTHORIZATION TYPE''',
'           and s.flow_id           = p.flow_id',
'           and s.scheme_type       = ''PLUGIN_''||p.name',
'        union all',
'        select p.display_name                                as display_name,',
'               wwv_flow_lang.system_message(''AUTHENTICATION SCHEME'') as object_type,',
'               ''f?p=4000:4495:''||:APP_SESSION||''::NO:RP,4495:''||''P4495_ID,FB_FLOW_ID:''||a.id||'',''||a.flow_id as object_url,',
'               a.name                                        as object_name,',
'               null                                          as component_type,',
'               null                                          as component_id,',
'               a.flow_id                                     as app_id,',
'               null                                          as page_id,',
'               null                                          as page_name,',
'               null                                          as region_title',
'          from wwv_flow_plugins    p,',
'               wwv_flow_authentications a',
'         where p.flow_id           = to_number(:FB_FLOW_ID)',
'           and p.security_group_id = to_number(:WORKSPACE_ID)',
'           and p.plugin_type       = ''AUTHENTICATION TYPE''',
'           and a.flow_id           = p.flow_id',
'           and a.scheme_type       = ''PLUGIN_''||p.name',
'        union all',
'        select p.display_name                                as display_name,',
'               wwv_flow_lang.system_message(''F4000.WEB_SOURCE'') as object_type,',
'               ''f?p=4000:1921:''||:APP_SESSION||''::NO:RP,1921:''||''P1921_WEB_SRC_MODULE_ID,FB_FLOW_ID:''||a.id||'',''||a.flow_id as object_url,',
'               a.name                                        as object_name,',
'               null                                          as component_type,',
'               null                                          as component_id,',
'               a.flow_id                                     as app_id,',
'               null                                          as page_id,',
'               null                                          as page_name,',
'               null                                          as region_title',
'          from wwv_flow_plugins         p,',
'               wwv_flow_web_src_modules a',
'         where p.flow_id           = to_number(:FB_FLOW_ID)',
'           and p.security_group_id = to_number(:WORKSPACE_ID)',
'           and p.plugin_type       = ''WEB SOURCE TYPE''',
'           and a.flow_id           = p.flow_id',
'           and a.web_source_type   = ''PLUGIN_''||p.name',
'        union all',
'        select p.display_name                                         as display_name,',
'               wwv_flow_lang.system_message(''F4000.REPORT_COLUMN'')    as object_type,',
'               to_char(null)                                          as object_url,',
'               c.db_column_name                                       as object_name,',
'               7040                                                   as component_type,',
'               c.id                                                   as component_id,',
'               c.flow_id                                              as app_id,',
'               c.page_id                                              as page_id,',
'               pg.name                                                as page_name,',
'               r.plug_name                                            as region_title',
'          from wwv_flow_template_components    p,',
'               wwv_flow_worksheet_columns    c,',
'               wwv_flow_worksheets           w,',
'               wwv_flow_page_plugs           r,',
'               wwv_flow_steps                pg',
'         where p.flow_id           = to_number(:FB_FLOW_ID)',
'           and p.security_group_id = to_number(:WORKSPACE_ID)',
'           and p.theme_id          is null',
'           and c.flow_id           = p.flow_id',
'           and c.display_text_as   = p.used_name',
'           and w.id                = c.worksheet_id',
'           and r.id                = w.region_id',
'           and pg.flow_id          = r.flow_id',
'           and pg.id               = r.page_id',
'    )'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_prn_output_show_link=>'Y'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#ffffff'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'LEFT'
,p_prn_page_footer_alignment=>'LEFT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(27858227168431340)
,p_name=>'xxx'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'PATRICK'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(27863717183464545)
,p_db_column_name=>'DISPLAY_NAME'
,p_display_order=>1
,p_column_identifier=>'G'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(33458616286623587)
,p_db_column_name=>'OBJECT_NAME'
,p_display_order=>2
,p_column_identifier=>'J'
,p_column_label=>'Component Name'
,p_column_link=>'#OBJECT_URL#'
,p_column_linktext=>'#OBJECT_NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(33458409566623582)
,p_db_column_name=>'OBJECT_TYPE'
,p_display_order=>3
,p_column_identifier=>'H'
,p_column_label=>'Component Type'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(27858730043431347)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(27858805774431347)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Page Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(27858902448431347)
,p_db_column_name=>'REGION_TITLE'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Region'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(33460724289665621)
,p_db_column_name=>'OBJECT_URL'
,p_display_order=>7
,p_column_identifier=>'K'
,p_column_label=>'Component Url'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(27878126485138981)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1306600121536647'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'DISPLAY_NAME:OBJECT_NAME:OBJECT_TYPE:PAGE_ID:PAGE_NAME:REGION_TITLE'
,p_sort_column_1=>'DISPLAY_NAME'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'PAGE_ID'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'OBJECT_NAME'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(188994928073089183)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(188993730020080349)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Plug-ins'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(188995107426092721)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(27858112567431339)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4420:&SESSION.::&DEBUG.:4420,RIR::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(27855510704326916)
,p_branch_action=>'f?p=&FLOW_ID.:4420:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
end;
/
prompt --application/pages/page_04445
begin
wwv_flow_imp_page.create_page(
 p_id=>4445
,p_name=>'Component Settings'
,p_alias=>'COMPONENT-SETTINGS'
,p_step_title=>'Component Defaults'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(27816729931938405)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_plugins.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4374731231850323)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(2565914177260747)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select *',
'  from wwv_flow_plugin_settings',
' where reference_id      is not null',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and plugin            like ''NATIVE\_%'' escape ''\'''))
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(14886004355621915)
,p_plug_name=>'Component Settings'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select s.id,',
'       s.display_name,',
'       s.plugin_type,',
'       s.last_updated_on,',
'       s.last_updated_by,',
'       --',
'       ''icon-sc-component-settings''                as icon_class,',
'       s.display_name                              as icon_title,',
'       wwv_flow_page_api.get_url(',
'           p_page        => 4446,',
'           p_clear_cache => 4446,',
'           p_items       => ''P4446_ID'',',
'           p_values      => s.id ) edit_link,       ',
'       --',
'       case when s.reference_id is not null then',
'           coalesce ( to_char( master.flow_id ),',
'                       wwv_flow_lang_dev.builder_message( ''SUBSCRIBED_FROM.NONEXISTING_MASTER'' ) )',
'       end as subscribed_from,',
'       ( select case when count(*) > 0 then count(*) end',
'           from wwv_flow_plugin_settings sub',
'          where sub.reference_id      = s.id',
'            and sub.security_group_id = :WORKSPACE_ID ) as subscribers,',
'       case when s.reference_id is not null then',
'           case',
'               when master.version_scn = s.version_scn then',
'                   wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_UP_TO_DATE'')',
'               when master.version_scn != s.version_scn then',
'                   wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_NEEDS_REFRESH'')',
'               else',
'                   wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_UNKNOWN'')',
'           end',
'       end subscription_status',
'       --',
'  from wwv_flow_plugin_settings_dev s,',
'       wwv_flow_plugin_settings master',
' where s.flow_id           = :FB_FLOW_ID',
'   and s.security_group_id = :WORKSPACE_ID',
'   and s.reference_id      = master.id (+)',
'   and s.security_group_id = master.security_group_id (+)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_prn_output_show_link=>'Y'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#ffffff'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'LEFT'
,p_prn_page_footer_alignment=>'LEFT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(14886206368621919)
,p_name=>'Lists'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No plug-ins found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#EDIT_LINK#" class="a-IRR-icon"><span class="a-Icon #ICON_CLASS#"></span><span class="a-IRR-iconName">#ICON_TITLE#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(14886330425621923)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(14892402487772202)
,p_db_column_name=>'DISPLAY_NAME'
,p_display_order=>2
,p_column_identifier=>'M'
,p_column_label=>'Name'
,p_column_link=>'f?p=&APP_ID.:4446:&SESSION.::&DEBUG.:4446:P4446_ID:#ID#'
,p_column_linktext=>'#DISPLAY_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(14891621215654597)
,p_db_column_name=>'PLUGIN_TYPE'
,p_display_order=>4
,p_column_identifier=>'K'
,p_column_label=>'Type'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(32850007287563326)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(14891727994654598)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>5
,p_column_identifier=>'L'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(14886604074621927)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>13
,p_column_identifier=>'E'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(14887014071621927)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>18
,p_column_identifier=>'I'
,p_column_label=>'Edit Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(656766879368365174)
,p_db_column_name=>'ICON_CLASS'
,p_display_order=>19
,p_column_identifier=>'N'
,p_column_label=>'ICON_CLASS'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(656766960710365174)
,p_db_column_name=>'ICON_TITLE'
,p_display_order=>20
,p_column_identifier=>'O'
,p_column_label=>'ICON_TITLE'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2522043290409107)
,p_db_column_name=>'SUBSCRIBED_FROM'
,p_display_order=>30
,p_column_identifier=>'P'
,p_column_label=>'Subscribed From'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2522120616409108)
,p_db_column_name=>'SUBSCRIBERS'
,p_display_order=>40
,p_column_identifier=>'Q'
,p_column_label=>'Subscribers'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2522287117409109)
,p_db_column_name=>'SUBSCRIPTION_STATUS'
,p_display_order=>50
,p_column_identifier=>'R'
,p_column_label=>'Subscription Status'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(14887631485621929)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_type=>'REPORT'
,p_report_alias=>'148877'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_view_mode=>'REPORT'
,p_report_columns=>'DISPLAY_NAME:PLUGIN_TYPE:SUBSCRIBED_FROM:SUBSCRIPTION_STATUS:SUBSCRIBERS:LAST_UPDATED_ON:'
,p_sort_column_1=>'DISPLAY_NAME'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'0'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(14887816467621931)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--sideRegion:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use Component Settings to set application level values for built-in &PRODUCT_NAME. components and installed plug-ins.</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''), ''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(14889427929621935)
,p_plug_name=>'navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(14972101971160040)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Component Settings'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(14888615562621933)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(14886004355621915)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4445:&SESSION.::&DEBUG.:4445,RIR::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2568672111347957)
,p_name=>'Refresh Subscriptions'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(4374731231850323)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2569047870347960)
,p_event_id=>wwv_flow_imp.id(2568672111347957)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(14886004355621915)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2569596948347961)
,p_event_id=>wwv_flow_imp.id(2568672111347957)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ( this.data.successMessage ) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
);
end;
/
prompt --application/pages/page_04446
begin
wwv_flow_imp_page.create_page(
 p_id=>4446
,p_name=>'Component Settings'
,p_alias=>'COMPONENT-SETTINGS1'
,p_step_title=>'Component Defaults'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(27816729931938405)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_read_only_when=>'P4446_REFERENCE_ID'
,p_help_text=>'advnc_plugins.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2522464438409111)
,p_plug_name=>'Tabs'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'USER')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2522546219409112)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>1009
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use Component Settings to set application level values for built-in &PRODUCT_NAME. components and installed plug-ins.</p>',
'<p>When component settings are subscribed, then it is not possible to change any data.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7667617628187971)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>1019
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(2565914177260747)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P4446_IS_NATIVE_PLUGIN'
,p_plug_display_when_cond2=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(14905826791797203)
,p_plug_name=>'Settings'
,p_region_name=>'SETTINGS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_PLUGIN_SETTINGS'
,p_query_where=>'security_group_id = :WORKSPACE_ID'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'u'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
,p_plug_comment=>'generated 04-SEP-2000 16:36:50'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(14913024434797214)
,p_plug_name=>'Add Javascript code for Plugins'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>30
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    -- create the initialization code for the dynamic attributes',
'    wwv_flow_plugin_dev.add_onload_code (',
'        p_plugin_type       => :P4446_PLUGIN_TYPE,',
'        p_type_value        => :P4446_PLUGIN,',
'        p_page_item_prefix  => ''P4446_'',',
'        p_attribute_scope   => wwv_flow_plugin.c_attribute_scope_application );',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(14922127573797230)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(29434107863295859)
,p_plug_display_sequence=>999
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'    select last_updated_by,',
'           last_updated_on,',
'           created_by,',
'           created_on ',
'      from wwv_flow_plugin_settings',
'     where id                = :P4446_ID',
'       and security_group_id = :WORKSPACE_ID )',
'loop',
'    wwv_flow_4000_ui.show_history (',
'        p_id              => :P4446_ID,',
'        p_component_type  => ''Plugin Settings'',',
'        p_last_updated_by => c1.last_updated_by,',
'        p_last_updated_on => c1.last_updated_on,',
'        p_created_by      => c1.created_by,',
'        p_created_on      => c1.created_on );',
'    exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_required_patch=>wwv_flow_imp.id(170786031904296885)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(20555148356507447)
,p_plug_name=>'Subscription'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'WWV_FLOW_PLUGIN_SETTINGS_DEV',
  'attribute_02', 'DISPLAY_NAME',
  'attribute_03', 'P4446_ID',
  'attribute_04', 'P4446_REFERENCE_ID',
  'attribute_05', 'SUBSCRIBE_COMPONENT_SETTING',
  'attribute_06', 'VERSION_SCN')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(43411751201937301)
,p_plug_name=>'<!-- Subscription Info Text -->'
,p_region_template_options=>'#DEFAULT#:a-Alert--noIcon:a-Alert--info:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>10
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This plug-in settings are subscribed from <a href="&P4446_MASTER_APP_EDIT_LINK.">&P4446_MASTER_APP.</a> application. These settings can be changed in the master application.</p>',
'<p>If the settings are not up to date with the master, refresh the plug-in from <strong>Edit Plug-in</strong> page. Click on <strong>Edit Plug-in</strong> link under <strong>Tasks</strong> to navigate to <strong>Edit Plug-in</strong> page.</p>'))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P4446_IS_NATIVE_PLUGIN = ''N'' and :P4446_REFERENCE_ID is not null'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1059809137210457628)
,p_plug_name=>'Component Settings'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1801796802767824)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_imp.id(20555148356507447)
,p_button_name=>'UNSUBSCRIBE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Unsubscribe'
,p_button_position=>'EDIT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P4446_IS_NATIVE_PLUGIN = ''Y'' ',
'and :P4446_REFERENCE_ID is not null',
'and wwv_flow_component_group_dev.is_part_of_subscribed_comp_grp (',
'    p_component_id   => :P4446_ID,',
'    p_component_type => wwv_flow_copy_metadata.c_component_setting,',
'    p_app_id         => :FB_FLOW_ID ) = ''N'''))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1802131689767826)
,p_button_sequence=>110
,p_button_plug_id=>wwv_flow_imp.id(20555148356507447)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Refresh Component Settings'
,p_button_position=>'EDIT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P4446_IS_NATIVE_PLUGIN = ''Y'' and :P4446_REFERENCE_ID is not null',
'and ( :P4446_VERSION_SCN != :P4446_MASTER_VERSION_SCN or :P4446_VERSION_SCN is null )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1802531234767827)
,p_button_sequence=>120
,p_button_plug_id=>wwv_flow_imp.id(20555148356507447)
,p_button_name=>'PUBLISH'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Publish'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.:149:F4000_P149_ID,F4000_P149_TEMPLATE_TYPE,F4000_P149_PAGE_ID:&P4446_ID.,PLUGIN_SETTINGS,4446'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * ',
'  from wwv_flow_plugin_settings',
' where reference_id      = :P4446_ID ',
'   and security_group_id = :WORKSPACE_ID',
'   and :P4446_IS_NATIVE_PLUGIN = ''Y'''))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(14899112152797192)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1059809137210457628)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:4445:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(14898924648797192)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1059809137210457628)
,p_button_name=>'SAVE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition_type=>'IS_NOT_READ_ONLY'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(14952320934834332)
,p_branch_name=>'Go To Page 4445'
,p_branch_action=>'f?p=&APP_ID.:4445:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2522621710409113)
,p_name=>'P4446_PLUGIN_ID'
,p_item_sequence=>450
,p_item_plug_id=>wwv_flow_imp.id(14905826791797203)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2965391726895406)
,p_name=>'P4446_PLUGIN_NAME'
,p_item_sequence=>460
,p_item_plug_id=>wwv_flow_imp.id(14905826791797203)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3629511288310641)
,p_name=>'P4446_IS_NATIVE_PLUGIN'
,p_item_sequence=>440
,p_item_plug_id=>wwv_flow_imp.id(14905826791797203)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4438304265901941)
,p_name=>'P4446_VERSION_SCN'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(20555148356507447)
,p_item_source_plug_id=>wwv_flow_imp.id(14905826791797203)
,p_source=>'VERSION_SCN'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(9231436852968996)
,p_name=>'P4446_MASTER_VERSION_SCN'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(20555148356507447)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select version_scn ',
'  from wwv_flow_plugin_settings',
' where id                = :P4446_REFERENCE_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14894129215797177)
,p_name=>'P4446_ID'
,p_data_type=>'NUMBER'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_imp.id(14905826791797203)
,p_item_source_plug_id=>wwv_flow_imp.id(14905826791797203)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14894329466797178)
,p_name=>'P4446_PLUGIN'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>270
,p_item_plug_id=>wwv_flow_imp.id(14905826791797203)
,p_item_source_plug_id=>wwv_flow_imp.id(14905826791797203)
,p_prompt=>'Name:'
,p_source=>'PLUGIN'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name d, plugin r',
'  from wwv_flow_plugin_settings_dev',
' where id                = :P4446_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'The name of your plug-in.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14895526113797182)
,p_name=>'P4446_FLOW_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>260
,p_item_plug_id=>wwv_flow_imp.id(14905826791797203)
,p_item_source_plug_id=>wwv_flow_imp.id(14905826791797203)
,p_item_default=>'&FB_FLOW_ID.'
,p_source=>'FLOW_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14895711239797182)
,p_name=>'P4446_PLUGIN_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_imp.id(14905826791797203)
,p_item_source_plug_id=>wwv_flow_imp.id(14905826791797203)
,p_source=>'PLUGIN_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_help_text=>'Defines the type of component that can use this plug-in.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14906019221797206)
,p_name=>'P4446_ATTRIBUTE_11'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>390
,p_item_plug_id=>wwv_flow_imp.id(14905826791797203)
,p_item_source_plug_id=>wwv_flow_imp.id(14905826791797203)
,p_source=>'ATTRIBUTE_11'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14906216730797207)
,p_name=>'P4446_ATTRIBUTE_12'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>400
,p_item_plug_id=>wwv_flow_imp.id(14905826791797203)
,p_item_source_plug_id=>wwv_flow_imp.id(14905826791797203)
,p_source=>'ATTRIBUTE_12'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14906411672797207)
,p_name=>'P4446_ATTRIBUTE_13'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>410
,p_item_plug_id=>wwv_flow_imp.id(14905826791797203)
,p_item_source_plug_id=>wwv_flow_imp.id(14905826791797203)
,p_source=>'ATTRIBUTE_13'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14906622795797207)
,p_name=>'P4446_ATTRIBUTE_14'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>420
,p_item_plug_id=>wwv_flow_imp.id(14905826791797203)
,p_item_source_plug_id=>wwv_flow_imp.id(14905826791797203)
,p_source=>'ATTRIBUTE_14'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14906806961797207)
,p_name=>'P4446_ATTRIBUTE_15'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>430
,p_item_plug_id=>wwv_flow_imp.id(14905826791797203)
,p_item_source_plug_id=>wwv_flow_imp.id(14905826791797203)
,p_source=>'ATTRIBUTE_15'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14907511436797208)
,p_name=>'P4446_ATTRIBUTE_01'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_imp.id(14905826791797203)
,p_item_source_plug_id=>wwv_flow_imp.id(14905826791797203)
,p_source=>'ATTRIBUTE_01'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14907706020797208)
,p_name=>'P4446_ATTRIBUTE_02'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>300
,p_item_plug_id=>wwv_flow_imp.id(14905826791797203)
,p_item_source_plug_id=>wwv_flow_imp.id(14905826791797203)
,p_source=>'ATTRIBUTE_02'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14907919092797208)
,p_name=>'P4446_ATTRIBUTE_03'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>310
,p_item_plug_id=>wwv_flow_imp.id(14905826791797203)
,p_item_source_plug_id=>wwv_flow_imp.id(14905826791797203)
,p_source=>'ATTRIBUTE_03'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14908104024797208)
,p_name=>'P4446_ATTRIBUTE_04'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>320
,p_item_plug_id=>wwv_flow_imp.id(14905826791797203)
,p_item_source_plug_id=>wwv_flow_imp.id(14905826791797203)
,p_source=>'ATTRIBUTE_04'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14908314605797209)
,p_name=>'P4446_ATTRIBUTE_05'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>330
,p_item_plug_id=>wwv_flow_imp.id(14905826791797203)
,p_item_source_plug_id=>wwv_flow_imp.id(14905826791797203)
,p_source=>'ATTRIBUTE_05'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14908503879797209)
,p_name=>'P4446_ATTRIBUTE_06'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>340
,p_item_plug_id=>wwv_flow_imp.id(14905826791797203)
,p_item_source_plug_id=>wwv_flow_imp.id(14905826791797203)
,p_source=>'ATTRIBUTE_06'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14908704195797209)
,p_name=>'P4446_ATTRIBUTE_07'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>350
,p_item_plug_id=>wwv_flow_imp.id(14905826791797203)
,p_item_source_plug_id=>wwv_flow_imp.id(14905826791797203)
,p_source=>'ATTRIBUTE_07'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14908918167797209)
,p_name=>'P4446_ATTRIBUTE_08'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>360
,p_item_plug_id=>wwv_flow_imp.id(14905826791797203)
,p_item_source_plug_id=>wwv_flow_imp.id(14905826791797203)
,p_source=>'ATTRIBUTE_08'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14909118039797209)
,p_name=>'P4446_ATTRIBUTE_09'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>370
,p_item_plug_id=>wwv_flow_imp.id(14905826791797203)
,p_item_source_plug_id=>wwv_flow_imp.id(14905826791797203)
,p_source=>'ATTRIBUTE_09'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14909317130797209)
,p_name=>'P4446_ATTRIBUTE_10'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>380
,p_item_plug_id=>wwv_flow_imp.id(14905826791797203)
,p_item_source_plug_id=>wwv_flow_imp.id(14905826791797203)
,p_source=>'ATTRIBUTE_10'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20561242234507529)
,p_name=>'P4446_REFERENCE_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(20555148356507447)
,p_item_source_plug_id=>wwv_flow_imp.id(14905826791797203)
,p_prompt=>'Subscribe From'
,p_source=>'REFERENCE_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select b.flow_id ||'' ''||f.name||'' - ''|| b.display_name d,',
'       b.id r',
'  from wwv_flow_plugin_settings_dev b,',
'       wwv_flows f',
' where b.flow_id          != nvl(:FB_FLOW_ID,0)',
'   and b.flow_id           = f.id',
'   and f.build_status      not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'   and b.security_group_id = :WORKSPACE_ID',
'   and f.security_group_id = :WORKSPACE_ID',
'   -- limit to current plugin and plugin type',
'   and ((    b.plugin      = :P4446_PLUGIN',
'         and b.plugin_type = :P4446_PLUGIN_TYPE )',
'         -- always show selected master record',
'          or b.id = :P4446_REFERENCE_ID_INIT )',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Subscription -'
,p_lov_cascade_parent_items=>'P4446_PLUGIN,P4446_PLUGIN_TYPE,P4446_REFERENCE_ID_INIT'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>50
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a master component to subscribe from. When you select a master component and click on the <strong>Apply Changes</strong> button, the component settings will be automatically refreshed from the selected master.<br /><br />If the component setti'
||'ngs are already subscribed, then click on the <strong>Refresh Component Settings</strong> button to refresh the component settings from the master component.'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'Y'
,p_attribute_06=>'0'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(20561328712507530)
,p_name=>'P4446_REFERENCE_ID_INIT'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(20555148356507447)
,p_use_cache_before_default=>'NO'
,p_item_default=>'P4446_REFERENCE_ID'
,p_item_default_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(43411889019937302)
,p_name=>'P4446_MASTER_APP'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(43411751201937301)
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(43411952470937303)
,p_name=>'P4446_MASTER_APP_EDIT_LINK'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(43411751201937301)
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2965544433895408)
,p_computation_sequence=>10
,p_computation_item=>'P4446_PLUGIN_NAME'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select plugin ',
'  from wwv_flow_plugin_settings_dev',
' where id                = :P4446_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID'))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(14924401663797237)
,p_validation_name=>'Validate Plugin Attributes'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.validate_attribute_items (',
'        p_application_id    => :P4446_FLOW_ID,',
'        p_page_id           => null,',
'        p_plugin_type       => :P4446_PLUGIN_TYPE,',
'        p_plugin_name       => :P4446_PLUGIN,',
'        p_attribute_scope   => wwv_flow_plugin.c_attribute_scope_application,',
'        p_page_item_prefix  => ''P4446_'' );',
'end;'))
,p_validation_type=>'PLSQL_ERROR'
,p_error_message=>'Error'
,p_when_button_pressed=>wwv_flow_imp.id(14898924648797192)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2521575285409102)
,p_name=>'Hide P4446_REFERENCE_ID'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>':P4446_REFERENCE_ID is not null or :P4446_IS_NATIVE_PLUGIN = ''N'''
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2521608929409103)
,p_event_id=>wwv_flow_imp.id(2521575285409102)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4446_REFERENCE_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1416304139012501)
,p_name=>'Save'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(14898924648797192)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1416442467012502)
,p_event_id=>wwv_flow_imp.id(1416304139012501)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'Are you sure you want to subscribe? This will overwrite the current component settings data with the selected master component settings.'
,p_attribute_03=>'warning'
,p_attribute_06=>'Subscribe'
,p_attribute_07=>'Cancel'
,p_client_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_client_condition_expression=>'$v(''P4446_REFERENCE_ID'') !== "" && $v(''P4446_REFERENCE_ID_INIT'') === ""'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1416542595012503)
,p_event_id=>wwv_flow_imp.id(1416304139012501)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'SAVE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2203928983585288821)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Convert Plugin Number Attributes for Storage'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.conv_number_fields_for_storage (',
'        p_application_id    => :P4446_FLOW_ID,',
'        p_page_id           => null,',
'        p_plugin_type       => :P4446_PLUGIN_TYPE,',
'        p_plugin_name       => :P4446_PLUGIN,',
'        p_attribute_scope   => wwv_flow_plugin.c_attribute_scope_application,',
'        p_page_item_prefix  => ''P4446_'' );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(14898924648797192)
,p_internal_uid=>2203928983585288821
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(361064779276469332)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(14905826791797203)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process form Settings'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(14898924648797192)
,p_process_when=>'P4446_PLUGIN_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_process_when2=>'REGION TYPE'
,p_process_success_message=>'Component Settings changed.'
,p_internal_uid=>361064779276469332
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2965443610895407)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process from  JSON Settings'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_plugin_dev.set_json_component_settings (',
'    p_application_id    => :P4446_FLOW_ID,',
'    p_plugin_name       => :P4446_PLUGIN_NAME,',
'    p_security_group_id => :WORKSPACE_ID );',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(14898924648797192)
,p_process_when=>'P4446_PLUGIN_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'REGION TYPE'
,p_process_success_message=>'Component Settings changed.'
,p_internal_uid=>2965443610895407
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2555635929460749)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh Component Settings'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.refresh_component (',
'    p_component_type     => wwv_flow_copy_metadata.c_component_setting,',
'    p_master_id          => :P4446_REFERENCE_ID,',
'    p_subscribing_id     => :P4446_ID,',
'    p_subscribing_app_id => :FB_FLOW_ID );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error during component settings refresh.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P4446_IS_NATIVE_PLUGIN = ''Y''',
'and (     :REQUEST = ''REFRESH''',
'     or (    :REQUEST = ''SAVE''',
'         and :P4446_REFERENCE_ID is not null',
'         and :P4446_REFERENCE_ID_INIT is null ) )'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Component settings are refreshed from the master.'
,p_internal_uid=>2555635929460749
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2556822688512277)
,p_process_sequence=>80
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Unsubscribe'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.unsubscribe_component (',
'    p_component_type  => wwv_flow_copy_metadata.c_component_setting,',
'    p_component_id    => :P4446_ID,',
'    p_app_id          => :FB_FLOW_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1801796802767824)
,p_process_success_message=>'Unsubscribed successfully.'
,p_internal_uid=>2556822688512277
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2965697009895409)
,p_process_sequence=>40
,p_process_point=>'BEFORE_BOX_BODY'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Init Component Settings JSON Values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_plugin_dev.init_json_component_settings (',
'    p_application_id    => :P4446_FLOW_ID,',
'    p_plugin_name       => :P4446_PLUGIN_NAME,',
'    p_page_item_prefix  => ''P4446_'',',
'    p_security_group_id => :WORKSPACE_ID );'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P4446_PLUGIN_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'REGION TYPE'
,p_internal_uid=>2965697009895409
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(361062219812469307)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(14905826791797203)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Component Settings'
,p_process_when=>'P4446_PLUGIN_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_process_when2=>'REGION TYPE'
,p_internal_uid=>361062219812469307
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2203929078611288822)
,p_process_sequence=>50
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Init Plugin Number Attributes for Display'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.init_number_fields_for_display (',
'        p_application_id    => :P4446_FLOW_ID,',
'        p_page_id           => null,',
'        p_plugin_type       => :P4446_PLUGIN_TYPE,',
'        p_plugin_name       => :P4446_PLUGIN,',
'        p_attribute_scope   => wwv_flow_plugin.c_attribute_scope_application );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>2203929078611288822
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3629771551310643)
,p_process_sequence=>60
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Derive P4446_IS_NATIVE_PLUGIN'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    select ''Y'' is_native_plugin',
'      into :P4446_IS_NATIVE_PLUGIN',
'      from wwv_flow_plugin_settings s,',
'           wwv_flow_native_plugins p',
'     where s.flow_id           = :FB_FLOW_ID',
'       and s.security_group_id = :WORKSPACE_ID',
'       and p.plugin_type       = s.plugin_type',
'       and p.name_with_prefix  = s.plugin',
'       and s.id                = :P4446_ID;',
'exception',
'    when no_data_found then',
'        :P4446_IS_NATIVE_PLUGIN := ''N'';',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>3629771551310643
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2522748213409114)
,p_process_sequence=>70
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Derive P4446_PLUGIN_ID'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- no need to handle no_data_found exception',
'-- row should exist for Plug-in Components and',
'-- same server side condition used for this process',
'--',
'select id',
'  into :P4446_PLUGIN_ID',
'  from wwv_flow_plugins',
' where plugin_type       = :P4446_PLUGIN_TYPE',
'   and ''PLUGIN_'' || name = :P4446_PLUGIN',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P4446_IS_NATIVE_PLUGIN'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'N'
,p_internal_uid=>2522748213409114
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(43412037816937304)
,p_process_sequence=>80
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Init Subscription Info Text'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    select f.id||'' - ''||f.name,',
'           wwv_flow_page_api.get_url(',
'                p_application => 4000,',
'                p_page        => 4446,',
'                p_clear_cache => ''4446'',',
'                p_items       => ''FB_FLOW_ID,P4446_ID'',',
'                p_values      => ps.flow_id||'',''||ps.id)',
'      into :P4446_MASTER_APP,',
'           :P4446_MASTER_APP_EDIT_LINK',
'      from wwv_flow_plugin_settings ps,',
'           wwv_flows f      ',
'     where f.id                  = ps.flow_id',
'       and f.security_group_id   = ps.security_group_id',
'       and ps.security_group_id  = :WORKSPACE_ID',
'       and ps.id                 = :P4446_REFERENCE_ID;',
'exception',
'    when no_data_found then',
'        :P4446_MASTER_APP           := null;',
'        :P4446_MASTER_APP_EDIT_LINK := null;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>':P4446_IS_NATIVE_PLUGIN = ''N'' and :P4446_REFERENCE_ID is not null'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>43412037816937304
);
end;
/
prompt --application/pages/page_04447
begin
wwv_flow_imp_page.create_page(
 p_id=>4447
,p_name=>'Component Settings History'
,p_alias=>'COMPONENT-SETTINGS-HISTORY'
,p_step_title=>'Component Defaults History'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(91429205691059841)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_plugins.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(14969311395141286)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(14972101971160040)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Component Settings'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(14969527739141287)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>This page displays recent modifications made to Component Settings in this application.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''), ''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(14970101127141289)
,p_plug_name=>'Component Settings History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select flow_user as developer, ',
'       audit_date,',
'       audit_action as action,',
'       scn,',
'       audit_comment,',
'       flow_table_pk as component_key,',
'       object_name   as component_name',
'  from wwv_flow_builder_audit_trail',
' where flow_ID           = :FB_FLOW_ID',
'   and flow_table        = ''WWV_FLOW_PLUGIN_SETTINGS''',
'   and security_group_id = :flow_security_group_id'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(14970325211141289)
,p_name=>'History'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(14970926660141290)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>9
,p_column_identifier=>'R'
,p_column_label=>'Audit Date'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(14971032570141290)
,p_db_column_name=>'ACTION'
,p_display_order=>10
,p_column_identifier=>'S'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(192763415498955359)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(14970723623141289)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>11
,p_column_identifier=>'N'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(14970620866141289)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>12
,p_column_identifier=>'M'
,p_column_label=>'Component Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(14970814404141290)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>13
,p_column_identifier=>'Q'
,p_column_label=>'Component Key'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(14970411115141289)
,p_db_column_name=>'SCN'
,p_display_order=>14
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(14970525590141289)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>15
,p_column_identifier=>'J'
,p_column_label=>'Audit Comment'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(14971132696141290)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'149712'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'AUDIT_DATE:ACTION:DEVELOPER:COMPONENT_NAME'
,p_sort_column_1=>'AUDIT_DATE'
,p_sort_direction_1=>'DESC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(14969921499141287)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(14970101127141289)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4447:&SESSION.::&DEBUG.:4447,RIR::'
);
end;
/
prompt --application/pages/page_04450
begin
wwv_flow_imp_page.create_page(
 p_id=>4450
,p_name=>'Install Plug-in'
,p_alias=>'INSTALL-PLUG-IN'
,p_step_title=>'Install Plug-in'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(27816729931938405)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'advnc_plugins.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30496813883469143)
,p_plug_name=>'import progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(37899301707472090)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30497027132469156)
,p_plug_name=>'Install Plug-in'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_imp_parser.get_plugin_name(:P4450_FILE_ID) is not null'
,p_plug_display_when_cond2=>'PLSQL'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>When you install a plug-in into the current application, the new plug-in will overwrite an existing plug-in having the same plug-in name. If the installation succeeds, the installation of the plug-in becomes permanent. If any errors are encountere'
||'d, the actions are rolled back, resulting in no permanent changes.</p>',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30497613484469157)
,p_plug_name=>'Invalid Plug-in File'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--danger:a-Alert--horizontal'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>30
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'File is not a valid &PRODUCT_NAME. plug-in import.'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'wwv_flow_imp_parser.get_plugin_name(:P4450_FILE_ID) is null'
,p_plug_display_when_cond2=>'PLSQL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(198921711591824186)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747149800997138181)
,p_plug_name=>'Install Plug-in'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30498322998469231)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(198921711591824186)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30498724327469233)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(198921711591824186)
,p_button_name=>'INSTALL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Install Plug-in'
,p_button_position=>'CREATE'
,p_button_condition=>'wwv_flow_imp_parser.get_plugin_name(:P4450_FILE_ID) is not null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2228621545445656)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(198921711591824186)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:163:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(30503532021469247)
,p_branch_action=>'f?p=&APP_ID.:4446:&SESSION.::&DEBUG.:RP,4446:P4446_ID:&P4450_PLUGIN_SETTINGS_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':REQUEST in (''INSTALL'', ''REPLACE'') and :P4450_PLUGIN_SETTINGS_ID is not null'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(7474141795849723)
,p_branch_name=>'Go To Page 4003'
,p_branch_action=>'f?p=&APP_ID.:4003:&SESSION.::&DEBUG.:RP,::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':REQUEST in (''INSTALL'', ''REPLACE'') and :P4450_NEW_THEME_ID is not null'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(15061504573548776)
,p_branch_name=>'Go To Page 4400'
,p_branch_action=>'f?p=&APP_ID.:4400:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'REQUEST_IN_CONDITION'
,p_branch_condition=>'INSTALL:REPLACE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(30503923791469248)
,p_branch_action=>'f?p=&APP_ID.:73:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(30498322998469231)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(30504110237469248)
,p_branch_name=>'Go To Page 48'
,p_branch_action=>'f?p=&APP_ID.:48:&SESSION.:PLUGIN:&DEBUG.:::'
,p_branch_point=>'BEFORE_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(30498724327469233)
,p_branch_sequence=>20
,p_branch_condition_type=>'EXISTS'
,p_branch_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plugins',
' where flow_id           = to_number(:P4450_NEW_FLOW_ID)',
'   and security_group_id = to_number(:WORKSPACE_ID)',
'   and plugin_type       = :P4450_PLUGIN_TYPE',
'   and name              = :P4450_NAME',
'   and theme_id          = :P4450_NEW_THEME_ID'))
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7474096590849722)
,p_name=>'P4450_NEW_THEME_ID'
,p_item_sequence=>125
,p_item_plug_id=>wwv_flow_imp.id(30497027132469156)
,p_prompt=>'Install Into Theme'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'INSTALL_PLUGIN_THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P4450_NEW_FLOW_ID, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Theme -'
,p_lov_cascade_parent_items=>'P4450_NEW_FLOW_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>'wwv_flow_imp_parser.get_plugin_type(:p4450_file_id) = ''TEMPLATE COMPONENT'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'You can install the plug-in into a theme of the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(15034323919525891)
,p_name=>'P4450_PLUGIN_SETTINGS_ID'
,p_item_sequence=>145
,p_item_plug_id=>wwv_flow_imp.id(30497027132469156)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30498920995469234)
,p_name=>'P4450_ACTION'
,p_item_sequence=>135
,p_item_plug_id=>wwv_flow_imp.id(30497027132469156)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Action'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_name varchar2( 32767 ) := :P4450_NAME;',
'begin',
'',
'    if :P4450_NEW_THEME_ID is not null then',
'        l_name := wwv_flow_template_directive.get_name (',
'                     p_name                 => l_name,',
'                     p_theme_id             => :P4450_NEW_THEME_ID,',
'                     p_for_using_component  => false );',
'    end if;',
'',
'    -- does the plugin already exist?',
'    for c1 in (',
'        select 1 dummy',
'          from wwv_flow_plugins',
'         where flow_id           = to_number(:P4450_NEW_FLOW_ID)',
'           and security_group_id = to_number(:WORKSPACE_ID)',
'           and plugin_type       = :P4450_PLUGIN_TYPE',
'           and name              = l_name',
'           and (   :P4450_NEW_THEME_ID is null',
'                or theme_id = to_number(:P4450_NEW_THEME_ID) ) )',
'    loop',
'        return wwv_flow_lang.system_message(''F4000.P4450.ACTION_REPLACE'', :P4450_NEW_FLOW_ID);',
'    end loop;',
'',
'    -- doesn''t exist yet',
'    return wwv_flow_lang.system_message(''F4000.P4450.ACTION_CREATE'', :P4450_NEW_FLOW_ID);',
'exception',
'    when others then',
'        raise_application_error(-20001, :P4450_NEW_THEME_ID );',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Action which is performed when you press the "Install Plug-in" button.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30499429719469237)
,p_name=>'P4450_NAME'
,p_item_sequence=>112
,p_item_plug_id=>wwv_flow_imp.id(30497027132469156)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Imported Plug-in Internal Name'
,p_source=>'wwv_flow_imp_parser.get_plugin_name(:p4450_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Internal name to reference the plug-in.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30499925768469238)
,p_name=>'P4450_FILE_ID'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_imp.id(30497027132469156)
,p_prompt=>'File Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30500113807469238)
,p_name=>'P4450_IMP_VERSION'
,p_item_sequence=>55
,p_item_plug_id=>wwv_flow_imp.id(30497027132469156)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Imported Plug-in Version'
,p_source=>'wwv_flow_imp_parser.get_version(:p4450_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies file version.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30500623799469239)
,p_name=>'P4450_NEW_FLOW_ID'
,p_item_sequence=>115
,p_item_plug_id=>wwv_flow_imp.id(30497027132469156)
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Install Into Application'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST FLOWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'where  build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'You can install the plug-in into the same application it came from or into a different application in the workspace. Leave the Application ID as is or select another.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30520028289737590)
,p_name=>'P4450_DISPLAY_NAME'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(30497027132469156)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Imported Plug-in Name'
,p_source=>'wwv_flow_imp_parser.get_plugin_display_name(:p4450_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Name of the plug-in.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30559014501263350)
,p_name=>'P4450_PLUGIN_TYPE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(30497027132469156)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name:'
,p_source=>'wwv_flow_imp_parser.get_plugin_type(:p4450_file_id)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Name of the plug-in.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(30502907671469245)
,p_validation_name=>'not valid export file'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if wwv_flow_imp_parser.get_plugin_name(:P4450_FILE_ID) is null then',
'   return false;',
'else',
'   return true;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'File is not a valid &PRODUCT_NAME. theme import.'
,p_when_button_pressed=>wwv_flow_imp.id(30498724327469233)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(30503130205469245)
,p_validation_name=>'version must be compatible'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  l_runtime_version varchar2(200); -- the date of the current runtime flows',
'  l_calling_version varchar2(200);',
'begin',
'    l_calling_version := replace(replace(replace(wwv_flow_imp_parser.get_version (p_file_id => :p4450_file_id),''.'',null),''_'',null),''/'',null);',
'    l_runtime_version := replace(replace(replace(wwv_flows_version,''.'',null),''_'',null),''/'',null);',
'',
'    if l_calling_version > l_runtime_version then',
'        --',
'        -- version incompatability        ',
'        --',
'        ',
'        return false;',
'    else',
'        return true;',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'NOT COMPATIBLE (Your import may contain calls not supported by your application version.)'
,p_when_button_pressed=>wwv_flow_imp.id(30498724327469233)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(30503204642469245)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'install plugin'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_owner          wwv_flows.owner%type;',
'begin',
'    select owner',
'      into l_owner',
'      from wwv_flows',
'     where id                = to_number(:P4450_NEW_FLOW_ID)',
'       and security_group_id = to_number(:WORKSPACE_ID);',
'',
'    wwv_flow_imp_parser.parse (',
'        p_file_id           => :P4450_FILE_ID,',
'        p_parse_as_schema   => l_owner,',
'        p_install_as_flow   => :P4450_NEW_FLOW_ID,',
'        p_original_flow_id  => null,',
'        p_adjust_offset     => true,',
'        p_install_in_theme  => :P4450_NEW_THEME_ID );',
'',
'    -- after import we have to synchronize existing references of this plugin',
'    wwv_flow_plugin_dev.synchronize_attribute_columns (',
'        p_application_id => :FB_FLOW_ID,',
'        p_plugin_type    => :P4450_PLUGIN_TYPE,',
'        p_plugin_name    => :P4450_NAME );',
'',
'    -- get imported plugin id to redirect to the new plugin',
'    :FB_FLOW_ID := :P4450_NEW_FLOW_ID;',
'',
'    -- try to get the plug-in setting ID if the plug-in contains custom attributes of scope "Application"',
'    select min(id)',
'      into :P4450_PLUGIN_SETTINGS_ID',
'      from wwv_flow_plugin_settings',
'     where flow_id           = to_number(:FB_FLOW_ID)',
'       and plugin_type       = :P4450_PLUGIN_TYPE',
'       and plugin            = ''PLUGIN_'' || :P4450_NAME',
'       and security_group_id = to_number(:WORKSPACE_ID);',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error installing plug-in.'
,p_process_when=>'INSTALL:REPLACE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'Plug-in installed.'
,p_internal_uid=>30503204642469245
);
end;
/
prompt --application/pages/page_04460
begin
wwv_flow_imp_page.create_page(
 p_id=>4460
,p_name=>'Export Plug-in'
,p_alias=>'EXPORT-PLUG-IN'
,p_step_title=>'Export Plug-in'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(27816729931938405)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_exprt_plugins.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30467118077262612)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(12802829107)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30467517871262613)
,p_plug_name=>'Export Settings'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_plug_grid_column_span=>8
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NUMERIC'
,p_plug_display_when_condition=>'P4460_A'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30467903423262613)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Use this page to export a plug-in definition to a file.  Once exported a plug-in can be imported into any application.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(168865206468961273)
,p_plug_name=>'Export Plug-in'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(486290602680795598)
,p_plug_name=>'Choose Application'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_grid_column_span=>8
,p_plug_item_display_point=>'BELOW'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_plug_read_only_when=>'FB_FLOW_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(486290330815784758)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(168865206468961273)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:4460:&SESSION.::&DEBUG.:4460::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(30468611840262614)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(168865206468961273)
,p_button_name=>'EXPORT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Export'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1801876338093042)
,p_name=>'P4460_AUDIT_INFO'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(30467517871262613)
,p_item_default=>'NONE'
,p_prompt=>'Audit Information'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'AUDIT INFO DETAIL'
,p_lov=>'.'||wwv_flow_imp.id(1726678227351632)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'None'
,p_lov_null_value=>'NONE'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the Audit Information to include in the export file. ',
'Audit information includes the Created By User, Created On Date, Changed By User and Changed On Date.<ul> ',
'<li>By default, no audit information is included.</li>',
'<li>Choose Names and Dates to include all audit information.</li>',
'<li>Choose Dates Only to include date information and exclude user details.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30468809262262615)
,p_name=>'P4460_A'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(486290602680795598)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Application'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PICK_EXPORT_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flows f',
'where  ',
'       security_group_id = :flow_security_group_id and',
'       f.build_status != ''RUN_AND_HIDDEN'' and',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id is null and security_group_id = :flow_security_group_id )',
'       or',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id = f.id and security_group_id = :flow_security_group_id) ',
'order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Application -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'This attribute identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30469301789262618)
,p_name=>'P4460_PLUGIN_ID'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(30467517871262613)
,p_prompt=>'Plug-in'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name as d,',
'       id           as r',
'  from wwv_flow_plugins',
' where flow_id           = nvl(:P4460_A,0) ',
'   and security_group_id = :flow_security_group_id',
'   and theme_id is null',
' order by display_name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select a Plug-in -'
,p_lov_null_value=>'0'
,p_lov_cascade_parent_items=>'P4460_A'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies a plug-in of the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30469812914262619)
,p_name=>'P4460_FILE_CHAR_SET'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(30467517871262613)
,p_use_cache_before_default=>'NO'
,p_prompt=>'File Character Set'
,p_source=>'return lower(trim(sys.owa_util.get_cgi_env(''REQUEST_IANA_CHARSET'')));'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'I18N_IANA_CHARSET'
,p_lov=>'.'||wwv_flow_imp.id(144796827445692396)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_protection_level=>'I'
,p_help_text=>'The export file will be encoded in the specified character set.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(486403214123824439)
,p_name=>'P4460_PLUGIN_COUNT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(30467517871262613)
,p_prompt=>'Plug-ins available for export'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the number of Plug-ins that are defined in the selected application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(937791513581878640)
,p_name=>'Set Values'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4460_A'
,p_condition_element=>'P4460_A'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5629572535882805)
,p_event_id=>wwv_flow_imp.id(937791513581878640)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Plug-ins'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(30467517871262613)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(937791693547878641)
,p_event_id=>wwv_flow_imp.id(937791513581878640)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4460_PLUGIN_COUNT'
,p_attribute_01=>'SQL_STATEMENT'
,p_attribute_03=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select count(*)',
'  from wwv_flow_plugins',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :P4460_A',
'   and theme_id is null'))
,p_attribute_07=>'P4460_A'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5629491626882804)
,p_event_id=>wwv_flow_imp.id(937791513581878640)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Show Plug-ins'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(30467517871262613)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(651511805049755611)
,p_name=>'Submit'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(30468611840262614)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(651511932562755612)
,p_event_id=>wwv_flow_imp.id(651511805049755611)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'EXPORT'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(30471029145262622)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'export plugin'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_export_dev.export_plugin (',
'    p_application_id  => :P4460_A,',
'    p_plugin_id       => :P4460_PLUGIN_ID,',
'    p_format          => ''UNIX'', ',
'    p_with_audit_info => :P4460_AUDIT_INFO );',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Plug-in Export failed!'
,p_process_when_button_id=>wwv_flow_imp.id(30468611840262614)
,p_process_success_message=>'Plug-in exported'
,p_internal_uid=>30471029145262622
);
end;
/
prompt --application/pages/page_04495
begin
wwv_flow_imp_page.create_page(
 p_id=>4495
,p_name=>'Edit Authentication Scheme'
,p_alias=>'EDIT-AUTHENTICATION-SCHEME'
,p_step_title=>'Edit Authentication Scheme'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(27816729931938405)
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function LDAPTestGetValues() {',
'    return {',
'        host: $v("P4495_ATTRIBUTE_01"),',
'        port: $v("P4495_ATTRIBUTE_02"),',
'        use_ssl: $v("P4495_ATTRIBUTE_03"),',
'        dn_string: $v("P4495_ATTRIBUTE_04"),',
'        use_dn: $v("P4495_ATTRIBUTE_05"),',
'        search_filter: $v("P4495_ATTRIBUTE_06"),',
'        edit_function: $v("P4495_ATTRIBUTE_07"),',
'        username_escaping: $v("P4495_ATTRIBUTE_08")',
'    };',
'}',
'function LDAPTestSetValues(pLDAPValues) {',
'    $s("P4495_ATTRIBUTE_01", pLDAPValues.host);',
'    $s("P4495_ATTRIBUTE_02", pLDAPValues.port);',
'    $s("P4495_ATTRIBUTE_03", pLDAPValues.use_ssl);',
'    $s("P4495_ATTRIBUTE_04", pLDAPValues.dn_string);',
'    $s("P4495_ATTRIBUTE_05", pLDAPValues.use_dn);',
'    $s("P4495_ATTRIBUTE_06", pLDAPValues.search_filter);',
'    $s("P4495_ATTRIBUTE_07", pLDAPValues.edit_function);',
'    $s("P4495_ATTRIBUTE_08", pLDAPValues.username_escaping);',
'}'))
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_read_only_when=>'P4495_REFERENCE_ID'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(125788308327200146)
,p_plug_name=>'Real Application Security'
,p_region_name=>'RAS'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>' '
,p_plug_required_role=>wwv_flow_imp.id(125788121598195155)
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P4495_ID'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(315239623539491637)
,p_plug_name=>'Hidden Items'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>180
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(345781625941052324)
,p_plug_name=>'Settings'
,p_region_name=>'PLUGIN'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="color:#FFFFFF;display:none;"'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(345785730519052338)
,p_plug_name=>'Authentication Scheme'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(345787019175052342)
,p_plug_name=>'Add Javascript code for Plugins'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>40
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    -- create the onChange event for the P4495_SCHEME_TYPE and',
'    -- also the initialization code for the dynamic attributes',
'    wwv_flow_plugin_dev.add_onload_code (',
'        p_plugin_type         => wwv_flow_plugin.c_plugin_type_authentication,',
'        p_type_page_item_name => ''P4495_SCHEME_TYPE'',',
'        p_page_item_prefix    => ''P4495_'',',
'        p_is_wizard           => ( :P4495_ID is null )',
'    );',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(345787207892052343)
,p_plug_name=>'Anchors'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>130
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P4495_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(345873610535069243)
,p_plug_name=>'Subscription'
,p_region_name=>'SUBSCRIPTION'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P4495_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'WWV_FLOW_AUTHENTICATIONS',
  'attribute_02', 'NAME',
  'attribute_03', 'P4495_ID',
  'attribute_04', 'P4495_REFERENCE_ID',
  'attribute_05', 'F4000_P4495',
  'attribute_06', 'VERSION_SCN')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(345889721617072434)
,p_plug_name=>'Name'
,p_region_name=>'NAME'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(345906632699075659)
,p_plug_name=>'Session Not Valid'
,p_region_name=>'INVALID_SESSION'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>' '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P4495_ID'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(462984315510460759)
,p_plug_name=>'Region to make it easier show/hide from apex_builder.js'
,p_region_name=>'INVALID_SESSION_ATTRIBUTES'
,p_parent_plug_id=>wwv_flow_imp.id(345906632699075659)
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>130
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(345924009281078364)
,p_plug_name=>'Login Processing'
,p_region_name=>'LOGIN_PROCESSING'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>' '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P4495_ID'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(345944618631081002)
,p_plug_name=>'Session Sharing'
,p_region_name=>'SESSION_COOKIE_ATTRIBUTES'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>' '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P4495_ID'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(345961628328083848)
,p_plug_name=>'Post-Logout URL'
,p_region_name=>'POST_LOGOUT_URL'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>' '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P4495_ID'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(348704723086404030)
,p_plug_name=>'Comments'
,p_region_name=>'COMMENTS'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>120
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P4495_ID'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(350195718995582647)
,p_plug_name=>'Authentication Scheme'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>140
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_05'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Authentication is the process of establishing each user''s identity before they can access your application. It may require a user to enter a user name and password or could involve the use of digital certificates or a secure key.</p>',
'',
'<p>Use this page to create or edit Authentication Schemes and set the one which your application is using. The current Authentication Scheme determines how your application identifies and verifies the end user. Depending on the selected Authenticatio'
||'n Scheme Type, you can use various settings and program hooks to fine-tune your application''s authentication.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(530943617040934909)
,p_plug_name=>'Source'
,p_region_name=>'SOURCE'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(345873831230069245)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(345873610535069243)
,p_button_name=>'PUBLISH_SCHEME'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Publish Scheme'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.:149:F4000_P149_ID,F4000_P149_PAGE_ID,F4000_P149_TEMPLATE_TYPE:&P4495_ID.,4495,AUTHENTICATION'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /*+ result_cache */',
'       1',
'  from wwv_flow_authentications',
' where reference_id      = :P4495_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
,p_security_scheme=>wwv_flow_imp.id(317822338466)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(345874024900069245)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(345873610535069243)
,p_button_name=>'REFRESH_SCHEME'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Refresh Scheme'
,p_button_position=>'CLOSE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P4495_REFERENCE_ID is not null ',
'and ( :P4495_VERSION_SCN != :P4495_MASTER_VERSION_SCN or :P4495_VERSION_SCN is null )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_security_scheme=>wwv_flow_imp.id(34674432490821717)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(345786103000052340)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(345785730519052338)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:801:&SESSION.::&DEBUG.:::'
,p_button_condition=>'P4495_PAGE_MODE'
,p_button_condition2=>'NORMAL'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(349533325173480285)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_imp.id(345785730519052338)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#:a-Button--gapRight'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
,p_button_execute_validations=>'N'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flows',
' where id                 = :FB_FLOW_ID',
'   and security_group_id  = :WORKSPACE_ID',
'   and authentication_id <> :P4495_ID',
'   and ( :P4495_REFERENCE_ID is null or :P4495_SUBSCRIBED_COMP_GRP = ''N'' )'))
,p_button_condition_type=>'EXISTS'
,p_security_scheme=>wwv_flow_imp.id(317822338466)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(29414822038032931)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_imp.id(345785730519052338)
,p_button_name=>'LDAP_Test'
,p_button_static_id=>'ldap_test_button'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Test LDAP Login'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:3890:&SESSION.::&DEBUG.:3890:P3890_FIRST_VIEW:YES'
,p_security_scheme=>wwv_flow_imp.id(317822338466)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(367654722935524231)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_imp.id(345785730519052338)
,p_button_name=>'MAKE_CURRENT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Make Current Scheme'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flows',
' where :P4495_ID          is not null',
'   and id                 = :FB_FLOW_ID',
'   and security_group_id  = :WORKSPACE_ID',
'   and (   authentication_id is null',
'        or authentication_id <> :P4495_ID)'))
,p_button_condition_type=>'EXISTS'
,p_security_scheme=>wwv_flow_imp.id(317822338466)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(345785910825052339)
,p_button_sequence=>110
,p_button_plug_id=>wwv_flow_imp.id(345785730519052338)
,p_button_name=>'ApplyChanges'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    :P4495_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_security_scheme=>wwv_flow_imp.id(317822338466)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(366683525818383144)
,p_button_sequence=>120
,p_button_plug_id=>wwv_flow_imp.id(345785730519052338)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Authentication Scheme'
,p_button_position=>'NEXT'
,p_button_condition=>'P4495_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5742526352944729)
,p_button_sequence=>130
,p_button_plug_id=>wwv_flow_imp.id(345873610535069243)
,p_button_name=>'UNSUBSCRIBE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Unsubscribe'
,p_button_position=>'NEXT'
,p_button_condition=>':P4495_REFERENCE_ID is not null and :P4495_SUBSCRIBED_COMP_GRP = ''N'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1145873507341466275)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(345785730519052338)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_button_condition=>'P4495_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(372433627502055491)
,p_branch_action=>'f?p=&APP_ID.:4495:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(345874024900069245)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(372546725902064436)
,p_branch_action=>'f?p=&APP_ID.:4495:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P4495_RETURN_TO_PAGE'
,p_branch_condition_text=>'YES'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(372226129795046638)
,p_branch_action=>'f?p=&APP_ID.:801:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P4495_PAGE_MODE'
,p_branch_condition_text=>'NORMAL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1146014811066486259)
,p_branch_action=>'f?p=&APP_ID.:815:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(1145873507341466275)
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1417419023012512)
,p_name=>'P4495_SUBSCRIBED_COMP_GRP'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(345873610535069243)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5728735390070702)
,p_name=>'P4495_VERSION_SCN'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(345873610535069243)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select version_scn ',
'  from wwv_flow_authentications',
' where id                = :P4495_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5728899964070703)
,p_name=>'P4495_MASTER_VERSION_SCN'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(345873610535069243)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select version_scn ',
'  from wwv_flow_authentications',
' where id                = :P4495_REFERENCE_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11095340587588042)
,p_name=>'P4495_REFERENCE_ID_INIT'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(345873610535069243)
,p_item_default=>'P4495_REFERENCE_ID'
,p_item_default_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(125790700667219995)
,p_name=>'P4495_RAS_MODE'
,p_is_required=>true
,p_item_sequence=>390
,p_item_plug_id=>wwv_flow_imp.id(125788308327200146)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'RAS Mode'
,p_source=>'RAS_MODE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REAL APPLICATION SECURITY MODE'
,p_lov=>'.'||wwv_flow_imp.id(125789401878207743)||'.'
,p_cSize=>32
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Define how Real Application Security should be used in this application.',
'<p/>',
'If <em>RAS Mode</em> is set to <em>Disabled</em>, Real Application Security does not get used in the application.',
'When this is set to <em>Internal Users</em>, &PRODUCT_NAME. assumes that all users are internal and passes <em>false</em> via the <em>is_external</em> parameter to <em>dbms_xs_sessions.assign_user</em>.',
'Light weight external users can be configured by setting the attribute to <em>External</em>. In that case, <em>true</em> gets passed via <em>is_external</em>.',
'<p/>',
'If you enable <em>RAS Mode</em>,',
'make sure that the users get privileges to access the application''s schema objects.',
'For <em>External Users</em>, you can for example grant database privileges to a <em>RAS Dynamic Application Role</em> and configure it in this authentication scheme as a <em>Dynamic Role</em>.',
'You can also enable roles via a call to <em>apex_authorization.enable_dynamic_groups</em>, e.g. in a Post-Authentication procedure.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(125790910144230797)
,p_name=>'P4495_RAS_DYNAMIC_ROLES'
,p_item_sequence=>400
,p_item_plug_id=>wwv_flow_imp.id(125788308327200146)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Dynamic Roles'
,p_source=>'RAS_DYNAMIC_ROLES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SHUTTLE'
,p_named_lov=>'RAS_DYNAMIC_ROLES'
,p_lov=>'select name n,name v from sys.dba_xs_dynamic_roles where system_defined=''NO'' order by 1'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>10
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Configure the Real Application Security Dynamic Roles for authenticated users.',
'&PRODUCT_NAME. enables these roles on login,',
'by passing them via the <em>enable_dynamic_roles</em> parameter of <em>sys.dbms_xs_sessions.assign_user</em>.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'MOVE'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(125791103890233778)
,p_name=>'P4495_RAS_NAMESPACES'
,p_item_sequence=>410
,p_item_plug_id=>wwv_flow_imp.id(125788308327200146)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Namespaces'
,p_source=>'RAS_NAMESPACES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SHUTTLE'
,p_named_lov=>'RAS_NAMESPACE_TEMPLATES'
,p_lov=>'select name n,name v from sys.dba_xs_ns_templates where name not like ''XS$%'' order by 1'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>10
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Configure the Real Application Security Namespace Templates for authenticated users.',
'&PRODUCT_NAME. enables these namespaces on login,',
'by passing them via the <em>namespaces</em> parameter of <em>sys.dbms_xs_sessions.assign_user</em>.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'MOVE'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(315240024514495330)
,p_name=>'P4495_PAGE_MODE'
,p_item_sequence=>380
,p_item_plug_id=>wwv_flow_imp.id(315239623539491637)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(342360883478652525)
,p_name=>'P4495_COOKIE_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(345944618631081002)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Type'
,p_source=>'COOKIE_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'SESSION COOKIE SHARING'
,p_lov=>'.'||wwv_flow_imp.id(46630896750249951)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Define which type of session cookie should be used by this application.',
'You can use this attribute to share the same &PRODUCT_NAME. session between multiple applications in a workspace.',
'With session sharing, users can seamlessly navigate between applications without logging in multiple times.',
'</p><p>',
'<ul>',
'    <li><em>Application (No Sharing)</em>: The session cookie is specific to this application.',
'        Sessions are not shared with other applications.</li>',
'    <li><em>Workspace Sharing</em>: The session is shared with other applications of this workspace,',
'        if these also set <em>Cookie Type</em> to <em>Workspace Sharing</em>.</li>',
'    <li><em>Custom</em>: Define custom session cookie attributes.</li>',
'</ul>    ',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(345781809729052326)
,p_name=>'P4495_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(345889721617072434)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(345782504523052330)
,p_name=>'P4495_ATTRIBUTE_11'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(345781625941052324)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_11'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 11, :P4495_ATTRIBUTE_11 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(345782711740052331)
,p_name=>'P4495_ATTRIBUTE_12'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(345781625941052324)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_12'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 12, :P4495_ATTRIBUTE_12 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(345782916842052331)
,p_name=>'P4495_ATTRIBUTE_13'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(345781625941052324)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_13'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 13, :P4495_ATTRIBUTE_13 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(345783102579052332)
,p_name=>'P4495_ATTRIBUTE_14'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(345781625941052324)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_14'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 14, :P4495_ATTRIBUTE_14 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(345783305255052332)
,p_name=>'P4495_ATTRIBUTE_15'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_imp.id(345781625941052324)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_15'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 15, :P4495_ATTRIBUTE_15 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(345783521998052332)
,p_name=>'P4495_ATTRIBUTE_01'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(345781625941052324)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_01'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 1, :P4495_ATTRIBUTE_01 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(345783708314052332)
,p_name=>'P4495_ATTRIBUTE_02'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(345781625941052324)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_02'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 2, :P4495_ATTRIBUTE_02 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(345783932506052332)
,p_name=>'P4495_ATTRIBUTE_03'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(345781625941052324)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_03'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 3, :P4495_ATTRIBUTE_03 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(345784119391052334)
,p_name=>'P4495_ATTRIBUTE_04'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(345781625941052324)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_04'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 4, :P4495_ATTRIBUTE_04 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(345784303772052334)
,p_name=>'P4495_ATTRIBUTE_05'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(345781625941052324)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_05'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 5, :P4495_ATTRIBUTE_05 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(345784506476052334)
,p_name=>'P4495_ATTRIBUTE_06'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(345781625941052324)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_06'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 6, :P4495_ATTRIBUTE_06 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(345784718827052334)
,p_name=>'P4495_ATTRIBUTE_07'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(345781625941052324)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_07'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 7, :P4495_ATTRIBUTE_07 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(345784925535052334)
,p_name=>'P4495_ATTRIBUTE_08'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(345781625941052324)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_08'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 8, :P4495_ATTRIBUTE_08 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(345785121864052335)
,p_name=>'P4495_ATTRIBUTE_09'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(345781625941052324)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_09'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 9, :P4495_ATTRIBUTE_09 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(345785314557052335)
,p_name=>'P4495_ATTRIBUTE_10'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(345781625941052324)
,p_use_cache_before_default=>'NO'
,p_source=>'ATTRIBUTE_10'
,p_source_type=>'DB_COLUMN'
,p_source_post_computation=>'wwv_flow_plugin_dev.get_number_field_for_display( 10, :P4495_ATTRIBUTE_10 )'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_cSize=>1
,p_cMaxlength=>4000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(345874209190069246)
,p_name=>'P4495_REFERENCE_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(345873610535069243)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Subscribed from'
,p_source=>'REFERENCE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.flow_id||'': ''||a.name as d,',
'       a.id as r',
'  from wwv_flow_authentications a,',
'       wwv_flows f',
' where a.id                <> to_number(:P4495_ID)',
'   and a.security_group_id = to_number(:WORKSPACE_ID)',
'   and f.id                = a.flow_id',
'   and f.build_status     not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- no authentication scheme -'
,p_cSize=>32
,p_cMaxlength=>255
,p_colspan=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch:a-Form-fieldContainer--autoLabelWidth'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select an application whose authentication scheme you want this scheme to subscribe to.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(345890420333072437)
,p_name=>'P4495_FLOW_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(345889721617072434)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'ABOVE'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(345891325506072438)
,p_name=>'P4495_NAME'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(345889721617072434)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'This name is used to reference the authentication scheme by application developers.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(345908228187075663)
,p_name=>'P4495_INVALID_SESSION_URL'
,p_item_sequence=>360
,p_item_plug_id=>wwv_flow_imp.id(462984315510460759)
,p_use_cache_before_default=>'NO'
,p_prompt=>'URL'
,p_source=>'INVALID_SESSION_URL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify a URL &PRODUCT_NAME. should redirect to if the session sentry function returns false. This would normally be a URL to a login page or single sign-on portal.',
'<p/>',
'Example: f?p=&amp;APP_ID.:101:&amp;SESSION'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(345924211605078366)
,p_name=>'P4495_HELP_TEXT'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_imp.id(345924009281078364)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Help Text'
,p_source=>'HELP_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>61
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Text displayed in a help popup window, available on the login page. This should offer guidance and links to resources to assist users of the &PRODUCT_NAME. built-in login page, specific to the type of authentication your application is using (Open Do'
||'or, &PRODUCT_NAME. account, or LDAP).'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(345927811351078376)
,p_name=>'P4495_PRE_AUTH_PROCESS'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_imp.id(345924009281078364)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Pre-Authentication Procedure Name'
,p_source=>'PRE_AUTH_PROCESS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify the name of a procedure to be executed after the login page is submitted and just before credentials',
'verification is performed. The procedure can be defined in the PL/SQL Code attribute or within the',
'database.</p>',
'',
'<p>Authentication schemes where user credentials checking is done outside of &PRODUCT_NAME. typically do',
'not execute the Pre-Authentication procedure. Examples are HTTP Header Variable,',
'Social Sign-In, and custom authentication schemes that use',
'<code>apex_authentication.post_login</code> instead of <code>apex_authentication.login</code>.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(345944805782081003)
,p_name=>'P4495_USE_SECURE_COOKIE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(345944618631081002)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Secure'
,p_source=>'USE_SECURE_COOKIE_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Select <strong>On</strong> to allow the session management cookie to be sent from the browser only when the protocol is HTTPS. ',
'Select <strong>Off</strong> to allow the session management cookie to be sent from the browser when the protocol is HTTP or HTTPS.',
'</p>',
'<p>',
'If SSL is configured on your web server,',
'you should select <strong>On</strong> to strengthen your application''s security by preventing unencrypted HTTP traffic.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(345945321610081005)
,p_name=>'P4495_COOKIE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(345944618631081002)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Cookie Name'
,p_source=>'COOKIE_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Name for the session cookie, which is required to identify an &PRODUCT_NAME. session, together with the session id in the URL. If no value for the session cookie name is specified, &PRODUCT_NAME. picks a default value.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(345945819177081005)
,p_name=>'P4495_COOKIE_PATH'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(345944618631081002)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Cookie Path'
,p_source=>'COOKIE_PATH'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Path attribute for the session cookie.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(345946314278081007)
,p_name=>'P4495_COOKIE_DOMAIN'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(345944618631081002)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Cookie Domain'
,p_source=>'COOKIE_DOMAIN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Domain attribute for the session cookie.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(345961832512083848)
,p_name=>'P4495_LOGOUT_URL'
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_imp.id(345961628328083848)
,p_use_cache_before_default=>'NO'
,p_prompt=>'URL'
,p_source=>'LOGOUT_URL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the URL where your application should redirect to after &PRODUCT_NAME. cleaned up the session.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(346057922272119929)
,p_name=>'P4495_POST_AUTH_PROCESS'
,p_item_sequence=>260
,p_item_plug_id=>wwv_flow_imp.id(345924009281078364)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Post-Authentication Procedure Name'
,p_source=>'POST_AUTH_PROCESS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify the name of a procedure to be executed by the &PRODUCT_NAME. login procedure (login API) after',
'the authentication step (login credentials verification). The login procedure will execute this code after',
'it verified the user''s credentials, but before registering the user in the session and redirecting to the',
'desired application page. The procedure can be defined in the PL/SQL Code attribute or',
'within the database.</p>',
'',
'<p>For example, to transform the <code>JOHNDOE@EXAMPLE.COM</code> authenticated username to',
'<code>JOHNDOE</code>, define <code>my_post_auth</code> procedure in the PL/SQL Code attribute:</p>',
'<pre>',
'procedure my_post_auth',
'is',
'begin',
'  apex_custom_auth.set_user (',
'    p_user => regexp_replace(:APP_USER, ''@.*'', null) );',
'end my_post_auth;',
'</pre>',
'',
'<p>Then, reference this procedure in the Post-Authentication Procedure Name attribute:</p>',
'<pre>',
'my_post_auth',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(346898909384210784)
,p_name=>'P4495_SCHEME_TYPE'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(345889721617072434)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Scheme Type'
,p_source=>'SCHEME_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'AUTHENTICATION_SCHEME_TYPE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,',
'       r',
'  from (',
'        select wwv_flow_lang.system_message(''AUTHENTICATION_NAME.''|| name_with_prefix) as d,',
'               name_with_prefix      as r',
'          from wwv_flow_native_plugins',
'         where plugin_type = ''AUTHENTICATION TYPE''',
'         union all',
'        select display_name || wwv_flow_lang.system_message(''PLUGIN.DISPLAY_NAME_POSTFIX'') as d,',
'               ''PLUGIN_'' || name     as r',
'          from wwv_flow_plugins',
'         where flow_id           = to_number(:FB_FLOW_ID)',
'           and security_group_id = to_number(:WORKSPACE_ID)',
'           and plugin_type       = ''AUTHENTICATION TYPE''',
'       )',
' order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select how this authentication scheme will be applied.  The following built-in types are supported (they can be extended using plug-ins):</p>',
'<ul>',
'    <li><strong>Builder Extension Sign-In</strong> - Enables you to integrate this application with the APEX development environment.</li>',
'    <li><strong>Custom</strong> - Enables you to create a custom authentication scheme from scratch, giving you complete control over your authentication interface.</li>',
'    <li><strong>Database Accounts</strong> - This authentication scheme requires that a database user (schema) exists in the local database. When using this method, the user name and password of the database account is used to authenticate the user.<'
||'/li>',
'    <li><strong>HTTP Header Variable</strong> - Authenticate externally, where the username is stored in an HTTP header variable set by the web server.</li>',
'    <li><strong>Internal Application Extension</strong> - Use this scheme for extensions to internal applications.</li>',
'    <li><strong>LDAP Directory</strong> - Authentication of user/password with an authentication request to an LDAP server.</li>',
'    <li><strong>No Authentication</strong> - Adopts the current database user.</li>',
'    <li><strong>Open Door Credentials</strong> - Enables anyone to access your application using a login page that captures a user name.</li>',
'    <li><strong>Oracle APEX Accounts</strong> - &PRODUCT_NAME. Account Credentials are internal user accounts that are created within and managed in the &PRODUCT_NAME. user repository. When you use this method, your application is authenticated again'
||'st these accounts.</li>',
'    <li><strong>SAML Sign-In</strong> - Supports authentication with SAML2 identity providers.</li>',
'    <li><strong>Social Sign-In</strong> - Supports authentication with Google, Facebook, generic OpenID Connect, and generic OAuth2 identity providers.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(348704930096404032)
,p_name=>'P4495_COMMENTS'
,p_item_sequence=>340
,p_item_plug_id=>wwv_flow_imp.id(348704723086404030)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comments'
,p_source=>'COMMENTS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Enter any comments or notes here.  These comments will never be displayed when running the application.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(364146420886050573)
,p_name=>'P4495_INVALID_SESSION_TYPE'
,p_item_sequence=>350
,p_item_plug_id=>wwv_flow_imp.id(462984315510460759)
,p_use_cache_before_default=>'NO'
,p_item_default=>'LOGIN'
,p_prompt=>'Go To:'
,p_source=>'INVALID_SESSION_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P4495_INVALID_SESSION_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(364180307858056288)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify where &PRODUCT_NAME. redirects to if the session is not valid. This happens if the Sentry Function or the Verify Function return false, on normal page requests (not on AJAX requests).</p>',
'',
'<p>Note: If using the "Custom" Authentication Scheme Type, the Sentry Function is a property available in the Authentication Scheme. For plug-in Authentication Scheme Types this is defined by the plug-in developer in the Session Sentry Function Name '
||'callback.</p>',
'',
'<ul>',
'<li><strong>Login Page</strong> - The Login URL defined in the application properties.</li>',
'<li><strong>Built-In Login Page</strong> - The &PRODUCT_NAME.-provided <code>wwv_flow_custom_auth_std.login_page</code>.</li>',
'<li><strong>URL</strong> - Specify a custom URL, for example <code>/login.html</code> or <code>f?p=&amp;APP_ID.:101:&amp;APP_SESSION.</code></li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(369399109064719016)
,p_name=>'P4495_LOGOUT_TYPE'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_imp.id(345961628328083848)
,p_item_default=>'HOME'
,p_prompt=>'Go To:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P4495_LOGOUT_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(369466420839722403)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify where &PRODUCT_NAME. should redirect to after logout.',
'<ul>',
'<li>Home Page. The Home Link value in the application properties.</li>',
'<li>URL. An additional item is displayed where you can enter any URL, for example f?p=&amp;APP_ID.:1</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
,p_attribute_04=>'VERTICAL'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(372342614689051784)
,p_name=>'P4495_RETURN_TO_PAGE'
,p_item_sequence=>370
,p_item_plug_id=>wwv_flow_imp.id(350195718995582647)
,p_prompt=>'Stay on page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select this checkbox to stay on this page after applying changes.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'YES'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(378152604158663779)
,p_name=>'P4495_VERIFICATION_FUNCTION'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_imp.id(345906632699075659)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Verify Function Name'
,p_source=>'VERIFICATION_FUNCTION'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the name of a function that is called after the session sentry returned successfully. The',
'function can either be defined in the PL/SQL Code attribute or directly in the database. The boolean',
'return value of this function determines whether or not the session is still valid.</p>',
'',
'<p>For example, to restrict the use of your application to specific business hours, define',
'<code>check_business_hours</code> function in the PL/SQL Code attribute:</p>',
'<pre>',
'function check_business_hours return boolean',
'is',
'begin',
'  return to_number(to_char(sysdate, ''hh24'')) between 8 and 17;',
'end check_business_hours;',
'</pre>',
'<p>Then, reference this function in the Verify Function Name attribute:</p>',
'<pre>',
'check_business_hours',
'</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(414185518003152116)
,p_name=>'P4495_SWITCH_IN_SESSION_YN'
,p_is_required=>true
,p_item_sequence=>270
,p_item_plug_id=>wwv_flow_imp.id(345924009281078364)
,p_use_cache_before_default=>'NO'
,p_item_default=>'N'
,p_prompt=>'Switch in Session'
,p_source=>'SWITCH_IN_SESSION_YN'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ENABLED_DISABLED_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(91439803955181562)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Select <strong>Enabled</strong> to enable switching from the default authentication scheme to this scheme in the current &PRODUCT_NAME. session. Select <strong>Disabled</strong> if the authentication scheme should not be enabled at runtime.',
'</p><p>',
'If enabled, the current session''s authentication scheme can be changed by passing <strong>APEX_AUTHENTICATION=scheme name</strong> in a URL''s request parameter.',
'</p>',
'<h3>Example</h3>',
'<p>',
'The developer adds a button labelled "Sign In with OAuth2" to the application''s login page, which redirects to',
'<pre>',
'f?p=&amp;APP_ID.:1:&amp;APP_SESSION.:APEX_AUTHENTICATION=OAuth2-Scheme',
'</pre>',
'where "OAuth2-Scheme" is the authentication scheme name. When processing the request (and assuming "Switch in Session" is enabled), &PRODUCT_NAME. registers the scheme in the session and will use it for all future requests.',
'</p>',
'<p>',
'<strong>NOTE:</strong>',
'If the application has an <em>Authentication Configuration Procedure</em>,',
'changing the authentication via the URL is not supported.',
'However, this attribute still has to be set.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(530943827162934913)
,p_name=>'P4495_CHECK_PLSQL_CODE'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_imp.id(530943617040934909)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Do not validate code (parse code at runtime only).'
,p_source=>'NULL'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'NO'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(530944009026934914)
,p_name=>'P4495_PLSQL_CODE'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_imp.id(530943617040934909)
,p_use_cache_before_default=>'NO'
,p_prompt=>'PL/SQL Code'
,p_source=>'PLSQL_CODE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>10
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a PL/SQL anonymous block of code that contains the definition of functions and procedures',
'for verifying if the session is valid, pre- and post-authentication and (optionally) other authentication',
'entry points.</p>',
'',
'<p>For performance reasons you can store this code in a PL/SQL package in the database rather',
'than storing it in this attribute.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PLSQL_FUNCTIONS'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1417508548012513)
,p_computation_sequence=>10
,p_computation_item=>'P4495_SUBSCRIBED_COMP_GRP'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_component_group_dev.is_part_of_subscribed_comp_grp (',
'    p_component_id   => :P4495_ID,',
'    p_component_type => wwv_flow_copy_metadata.c_authentication,',
'    p_app_id         => :FB_FLOW_ID )'))
,p_compute_when=>'P4495_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(377859318657639619)
,p_computation_sequence=>10
,p_computation_item=>'P4495_LOGOUT_TYPE'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'case when :P4495_LOGOUT_URL is null then ''HOME'' else ''URL'' end'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(345977422225091560)
,p_computation_sequence=>20
,p_computation_item=>'P4495_COOKIE_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'upper(replace(:P4495_COOKIE_NAME,'' '',''_''))'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1147516411224072964)
,p_computation_sequence=>30
,p_computation_item=>'P4495_USE_SECURE_COOKIE'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'N'
,p_compute_when=>'P4495_ID'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(315550412221501053)
,p_computation_sequence=>40
,p_computation_item=>'P4495_PAGE_MODE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'NORMAL'
,p_compute_when=>'P4495_PAGE_MODE'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(374153603803237837)
,p_validation_name=>'Is current scheme'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flows',
' where id                = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and authentication_id = :P4495_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Selected authentication scheme is current authentication scheme of the application.'
,p_when_button_pressed=>wwv_flow_imp.id(349533325173480285)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(345788224582052346)
,p_validation_name=>'Validate Plugin Attributes'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.validate_attribute_items (',
'        p_application_id    => :FB_FLOW_ID,',
'        p_plugin_type       => wwv_flow_plugin.c_plugin_type_authentication,',
'        p_plugin_name       => :P4495_SCHEME_TYPE,',
'        p_attribute_scope   => wwv_flow_plugin.c_attribute_scope_component,',
'        p_page_item_prefix  => ''P4495_'' );',
'end;'))
,p_validation_type=>'PLSQL_ERROR'
,p_error_message=>'Error'
,p_validation_condition=>'coalesce(:REQUEST,''X'') != ''UNSUBSCRIBE'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(462266921407188030)
,p_validation_name=>'Invalid Session URL is not null'
,p_validation_sequence=>30
,p_validation=>'P4495_INVALID_SESSION_URL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P4495_INVALID_SESSION_TYPE'
,p_validation_condition2=>'URL'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(345908228187075663)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(531003323966936870)
,p_validation_name=>'check PL/SQL syntax'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_f4000_util.check_plsql (',
'           p_sql               => ''declare''||chr(10)||:P4495_PLSQL_CODE||chr(10)||''begin null; end;'',',
'           p_flow_id           => :P4495_FLOW_ID,',
'           p_security_group_id => :WORKSPACE_ID );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'nvl(:P4495_CHECK_PLSQL_CODE, ''YES'') = ''YES'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(530944009026934914)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2608837316075875)
,p_validation_name=>'Not part of component groups'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not wwv_flow_component_group_dev.is_part_of_comp_grp (',
'    p_component_id   => :P4495_ID,',
'    p_component_type => wwv_flow_copy_metadata.c_authentication,',
'    p_app_id         => :FB_FLOW_ID )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Authentication Scheme cannot be deleted because it is part of a component group.'
,p_validation_condition=>'Delete'
,p_validation_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1145735812704429996)
,p_name=>'Show/Hide Source'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4495_SCHEME_TYPE'
,p_condition_element=>'P4495_SCHEME_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NATIVE_CUSTOM'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'ITEM_IS_NULL'
,p_display_when_cond=>'P4495_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1145736113257429997)
,p_event_id=>wwv_flow_imp.id(1145735812704429996)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(530943617040934909)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1145736316248429998)
,p_event_id=>wwv_flow_imp.id(1145735812704429996)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(530943617040934909)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(364705910637132731)
,p_name=>'Invalid Session Type = URL'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4495_INVALID_SESSION_TYPE'
,p_condition_element=>'P4495_INVALID_SESSION_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'URL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(364371805632082974)
,p_event_id=>wwv_flow_imp.id(364705910637132731)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4495_INVALID_SESSION_URL'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(364706229305132731)
,p_event_id=>wwv_flow_imp.id(364705910637132731)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4495_INVALID_SESSION_URL'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(368053200388565038)
,p_name=>'Confirm Make Current'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(367654722935524231)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(368053514510565040)
,p_event_id=>wwv_flow_imp.id(368053200388565038)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'Would you like to make &#x27;&P4495_NAME.&#x27; the current authentication scheme of the application?'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(368146920474570916)
,p_event_id=>wwv_flow_imp.id(368053200388565038)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'MAKE_CURRENT'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(369613519238731420)
,p_name=>'Logout Type = URL'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4495_LOGOUT_TYPE'
,p_condition_element=>'P4495_LOGOUT_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'URL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(369613816315731421)
,p_event_id=>wwv_flow_imp.id(369613519238731420)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4495_LOGOUT_URL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(369614017428731421)
,p_event_id=>wwv_flow_imp.id(369613519238731420)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4495_LOGOUT_URL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(29416016725040869)
,p_name=>'Show/hide LDAP Test'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4495_SCHEME_TYPE'
,p_condition_element=>'P4495_SCHEME_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NATIVE_LDAP'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(29416302656040878)
,p_event_id=>wwv_flow_imp.id(29416016725040869)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(29414822038032931)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(29416722241048043)
,p_event_id=>wwv_flow_imp.id(29416016725040869)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(29414822038032931)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(125819924873349888)
,p_name=>'Enable/Disable RAS attributes'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4495_RAS_MODE'
,p_condition_element=>'P4495_RAS_MODE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'0'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(125820217815349896)
,p_event_id=>wwv_flow_imp.id(125819924873349888)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4495_RAS_DYNAMIC_ROLES,P4495_RAS_NAMESPACES'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(125820425507349898)
,p_event_id=>wwv_flow_imp.id(125819924873349888)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4495_RAS_DYNAMIC_ROLES,P4495_RAS_NAMESPACES'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(342360905305652526)
,p_name=>'When C'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4495_COOKIE_TYPE'
,p_condition_element=>'P4495_COOKIE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'C'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(342361013070652527)
,p_event_id=>wwv_flow_imp.id(342360905305652526)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4495_COOKIE_NAME,P4495_COOKIE_PATH,P4495_COOKIE_DOMAIN,P4495_USE_SECURE_COOKIE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(342361203414652529)
,p_event_id=>wwv_flow_imp.id(342360905305652526)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4495_COOKIE_NAME,P4495_COOKIE_PATH,P4495_COOKIE_DOMAIN,P4495_USE_SECURE_COOKIE'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5741066788964415)
,p_name=>'Hide P4495_REFERENCE_ID'
,p_event_sequence=>80
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'F4000_P4495_REFERENCE_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5741477242964415)
,p_event_id=>wwv_flow_imp.id(5741066788964415)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4495_REFERENCE_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(11095086246588039)
,p_name=>'Apply changes'
,p_event_sequence=>100
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(345785910825052339)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(11095120980588040)
,p_event_id=>wwv_flow_imp.id(11095086246588039)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'Are you sure you want to subscribe to the selected master authentication scheme? This will overwrite current authentication scheme data with selected master authentication scheme.'
,p_attribute_03=>'warning'
,p_attribute_06=>'Subscribe'
,p_attribute_07=>'Cancel'
,p_client_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_client_condition_expression=>'$v(''P4495_REFERENCE_ID'') !== "" && $v(''P4495_REFERENCE_ID_INIT'') === ""'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(11095218664588041)
,p_event_id=>wwv_flow_imp.id(11095086246588039)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'ApplyChanges'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(462442818646262938)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Cleanup'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if wwv_flow_plugin_dev.has_standard_attribute (',
'           p_application_id => :FB_FLOW_ID,',
'           p_plugin_type    => wwv_flow_plugin.c_plugin_type_authentication,',
'           p_plugin_name    => :P4495_SCHEME_TYPE,',
'           p_feature        => ''INVALID_SESSION'' )',
'    then',
'        :P4495_INVALID_SESSION_TYPE := nvl(:P4495_INVALID_SESSION_TYPE, ''LOGIN'');',
'    else',
'        :P4495_INVALID_SESSION_TYPE := null;',
'    end if;',
'',
'    -- if it''s not a URL type, clear the page item',
'    if nvl(:P4495_INVALID_SESSION_TYPE, ''PAGE'') <> ''URL'' then',
'        :P4495_INVALID_SESSION_URL := null;',
'    end if;',
'',
'    -- if it''s not a URL type, clear the page item',
'    if nvl(:P4495_LOGOUT_TYPE, ''PAGE'') <> ''URL'' then',
'        :P4495_LOGOUT_URL := null;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'coalesce(:REQUEST,''X'') != ''UNSUBSCRIBE'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>462442818646262938
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(342361487079652531)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Cookie Attributes Based On Type'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P4495_COOKIE_NAME       := case :P4495_COOKIE_TYPE',
'                            when ''W'' then ''&''||''WORKSPACE_COOKIE.''',
'                            end;',
':P4495_COOKIE_PATH       := null;',
':P4495_COOKIE_DOMAIN     := null;',
':P4495_USE_SECURE_COOKIE := ''N'';'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P4495_COOKIE_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_process_when2=>'C'
,p_internal_uid=>342361487079652531
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2203930117076288833)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Convert Plugin Number Attributes for Storage'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.conv_number_fields_for_storage (',
'        p_application_id    => :FB_FLOW_ID,',
'        p_plugin_type       => wwv_flow_plugin.c_plugin_type_authentication,',
'        p_plugin_name       => :P4495_SCHEME_TYPE,',
'        p_attribute_scope   => wwv_flow_plugin.c_attribute_scope_component,',
'        p_page_item_prefix  => ''P4495_'' );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'coalesce(:REQUEST,''X'') != ''UNSUBSCRIBE'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>2203930117076288833
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(345788508103052347)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_AUTHENTICATIONS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_AUTHENTICATIONS'
,p_attribute_03=>'P4495_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_09=>'P4495_ID'
,p_attribute_11=>'I:U'
,p_attribute_12=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'Delete'
,p_process_when_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_process_success_message=>'Action processed.'
,p_security_scheme=>wwv_flow_imp.id(317822338466)
,p_internal_uid=>345788508103052347
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4994423073587606)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete authentication'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_authentication_dev.delete_authentication(',
'    p_authentication_id    => :P4495_ID,',
'    p_application_id       => :FB_FLOW_ID);',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'Delete'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>'Authentication scheme deleted.'
,p_internal_uid=>4994423073587606
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(401476602790283024)
,p_process_sequence=>80
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Login Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for l_ui in ( select id',
'                    from wwv_flows f',
'                   where f.id                = :FB_FLOW_ID',
'                     and f.security_group_id = :WORKSPACE_ID',
'                     and not exists (',
'                         select 1',
'                           from wwv_flow_steps p',
'                          where flow_id           = :FB_FLOW_ID',
'                            and security_group_id = :WORKSPACE_ID',
'                            and upper(alias)      like ''LOGIN%'' )',
'                )',
'    loop',
'        wwv_flow_wizard_api.create_login_page2 (',
'            p_fb_flow_id        => :FB_FLOW_ID );',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from dual',
' where :P4495_INVALID_SESSION_TYPE = ''LOGIN''',
'   and not exists ( select 1',
'                      from wwv_flow_steps',
'                     where flow_id           = :FB_FLOW_ID',
'                       and security_group_id = :WORKSPACE_ID',
'                       and upper(alias)      like ''LOGIN%''',
'                  )'))
,p_process_when_type=>'EXISTS'
,p_process_success_message=>'Login Page created.'
,p_internal_uid=>401476602790283024
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(346412714831155629)
,p_process_sequence=>90
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh plugin'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_authentication (',
'    p_master_auth_id         => :P4495_REFERENCE_ID,',
'    p_subscribing_auth_id    => :P4495_ID,',
'    p_subscribing_app_id     => :fb_flow_id );'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST = ''REFRESH_SCHEME''',
'or ( :REQUEST = ''ApplyChanges'' and :P4495_REFERENCE_ID is not null and :P4495_REFERENCE_ID_INIT is null )'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Authentication Scheme refreshed.'
,p_security_scheme=>wwv_flow_imp.id(34674432490821717)
,p_internal_uid=>346412714831155629
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(368499211432615551)
,p_process_sequence=>100
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Make Current Scheme'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    update wwv_flows',
'       set authentication_id = :P4495_ID,',
'           authentication    = ''PLUGIN''',
'     where id                = :FB_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(367654722935524231)
,p_process_success_message=>'Authentication scheme activated as current authentication scheme.'
,p_security_scheme=>wwv_flow_imp.id(317822338466)
,p_internal_uid=>368499211432615551
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5743350071932385)
,p_process_sequence=>110
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Unsubscribe'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.unsubscribe_component (',
'    p_component_type  => wwv_flow_copy_metadata.c_authentication,',
'    p_component_id    => :P4495_ID,',
'    p_app_id          => :FB_FLOW_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(5742526352944729)
,p_process_success_message=>'Authentication Scheme is no longer subscribed to its master authentication scheme.'
,p_internal_uid=>5743350071932385
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(345788330523052347)
,p_process_sequence=>70
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_AUTHENTICATIONS'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_AUTHENTICATIONS'
,p_attribute_03=>'P4495_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_internal_uid=>345788330523052347
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2203930263809288834)
,p_process_sequence=>80
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Init Plugin Number Attributes for Display'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_plugin_dev.init_number_fields_for_display (',
'        p_application_id    => :FB_FLOW_ID,',
'        p_plugin_type       => wwv_flow_plugin.c_plugin_type_authentication,',
'        p_plugin_name       => :P4495_SCHEME_TYPE,',
'        p_attribute_scope   => wwv_flow_plugin.c_attribute_scope_component );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2203930263809288834
);
end;
/
prompt --application/pages/page_04500
begin
wwv_flow_imp_page.create_page(
 p_id=>4500
,p_name=>'Page Designer'
,p_alias=>'PAGE-DESIGNER'
,p_step_title=>'Page Designer'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- keep in sync with app 4000 combined files (under shared components - user interfaces - combined files)',
'#APEX_FILES#libraries/apex/#MIN_DIRECTORY#widget.treeView#MIN#.js',
'#APEX_FILES#libraries/apex/#MIN_DIRECTORY#widget.iconList#MIN#.js',
'#APEX_FILES#libraries/apex/#MIN_DIRECTORY#commandHistory#MIN#.js',
'#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#templateOptionsHelper#MIN#.js',
'#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#pe.model#MIN#.js',
'#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#f4000_p4500#MIN#.js',
'#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#pe.callbacks#MIN#.js',
'#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#widget.peMessagesView#MIN#.js',
'#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#widget.peSearch#MIN#.js',
'#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#gridlayout#MIN#.js',
'#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#f4000_p4500.gallery#MIN#.js',
'#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#f4000_p4500.tree#MIN#.js',
'#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#widget.propertyEditor#MIN#.js',
'#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#widget.lovDialog#MIN#.js',
'#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#widget.pdPropertyEditor#MIN#.js',
'#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#f4000_p4500.glv#MIN#.js',
'-- end',
'#APEX_FILES#libraries/apex/#MIN_DIRECTORY#item.Colorpicker#MIN#.js',
'[require requirejs]#APEX_FILES#libraries/apex/#MIN_DIRECTORY#widget.toolbar#MIN#.js',
'[require requirejs]#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#widget.codeEditor#MIN#.js'))
,p_step_template=>wwv_flow_imp.id(384711093594980574)
,p_page_css_classes=>'apex-page-designer'
,p_required_role=>wwv_flow_imp.id(74845831538733642)
,p_help_text=>'bldr_pg_def_about.htm'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3705300509478)
,p_plug_name=>'APEX 5 Main Control Bar'
,p_region_css_classes=>'a-ControlBar apex-app-builder a-Toolbar--simple'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3700518577643)
,p_plug_name=>'Control Bar - Page Select Region'
,p_parent_plug_id=>wwv_flow_imp.id(3705300509478)
,p_region_css_classes=>'a-ControlBar-col'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_landmark_type=>'region'
,p_landmark_label=>'Page Actions'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3700537613973)
,p_plug_name=>'Page Select Form'
,p_parent_plug_id=>wwv_flow_imp.id(3700518577643)
,p_region_css_classes=>'a-PageSelect'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.prn(',
'    ''<button id="go_to_page_lov" class="a-Button a-Button--noUI a-Button--noLabel a-PageSelect-menuButton" type="button" aria-haspopup="dialog"'' ||',
'    wwv_flow_plugin_util.get_html_attr(',
'        p_name  => ''aria-label'',',
'        p_value => wwv_flow_lang.system_message( ''PAGE_FINDER'' ) ) ||',
'    wwv_flow_plugin_util.get_html_attr(',
'        p_name  => ''title'',',
'        p_value => wwv_flow_lang.system_message(',
'                       ''APEX.POPUP_LOV.ICON_TEXT'',',
'                       wwv_flow_lang.system_message( ''PAGE_FINDER'' ) ) ) ||',
'    ''>'');',
'sys.htp.prn(''<span class="a-Icon icon-page" aria-hidden="true"></span>'');',
'sys.htp.prn(',
'    ''<span class="a-Icon icon-menu-drop-down" aria-hidden="true"></span>'' );',
'sys.htp.prn( ''</button>'' );',
'sys.htp.prn(',
'    ''<input type="text" id="go_to_page" class="a-PageSelect-input" value="'' ||',
'    :FB_FLOW_PAGE_ID || ''" aria-labelledby="go_to_page_lov" />'' );',
'sys.htp.p(',
'    ''<div class="a-PageSelect-buttons">'' );',
'sys.htp.p(',
'    ''<button type="button" class="a-Button a-Button--pageNav a-Button--icon a-Button--noLabel" data-action="pd-goto-next-page" id="pd_next_page"'' ||',
'    wwv_flow_plugin_util.get_html_attr(',
'        p_name  => ''aria-label'',',
'    p_value => wwv_flow_lang.message( ''PD.NEXT_PAGE'' ) ) ||',
'    wwv_flow_plugin_util.get_html_attr(',
'        p_name  => ''aria-keyshortcuts'', ',
'        p_value => ''Alt+Shift+PageDown'' ) ||',
'    wwv_flow_plugin_util.get_html_attr(',
'        p_name  => ''title'',',
'        p_value => wwv_flow_lang.message( ''PD.NAV_NEXT_PAGE'' ) ) ||',
'    ''"><span class="a-Icon icon-up-chevron" aria-hidden="true"></span></button>'' );',
'sys.htp.p(',
'    ''<button type="button" class="a-Button a-Button--pageNav a-Button--icon a-Button--noLabel" data-action="pd-goto-prev-page" id="pd_prev_page"'' ||',
'    wwv_flow_plugin_util.get_html_attr(',
'        p_name  => ''aria-label'',',
'        p_value => wwv_flow_lang.message( ''PD.PREV_PAGE'' ) ) ||',
'    wwv_flow_plugin_util.get_html_attr(',
'        p_name  => ''aria-keyshortcuts'', ',
'        p_value => ''Alt+Shift+PageUp'' ) ||',
'    wwv_flow_plugin_util.get_html_attr(',
'        p_name  => ''title'',',
'        p_value => wwv_flow_lang.message( ''PD.NAV_PREV_PAGE'' ) ) ||',
'    ''><span class="a-Icon icon-down-chevron" aria-hidden="true"></span></button>'' );',
'sys.htp.p( ''</div>'' );'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3734482699681)
,p_plug_name=>'Create Menu'
,p_region_name=>'createMenu'
,p_parent_plug_id=>wwv_flow_imp.id(3700518577643)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:js-addActions'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_imp.id(3734458575652)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(3712705120335)
,p_translate_title=>'N'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3767961827915)
,p_plug_name=>'Utilitiies Menu'
,p_region_name=>'utilitiesMenu'
,p_parent_plug_id=>wwv_flow_imp.id(3700518577643)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:js-addActions'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_imp.id(3741507057557)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(3712705120335)
,p_translate_title=>'N'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4897845794505267)
,p_plug_name=>'Working Copy Menu'
,p_region_name=>'workingCopyMenu'
,p_parent_plug_id=>wwv_flow_imp.id(3700518577643)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_imp.id(3056785755622754)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(3712705120335)
,p_translate_title=>'N'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_working_copy_dev.is_working_copy( ',
'    p_application_id    => :FB_FLOW_ID,',
'    p_security_group_id => :WORKSPACE_ID )'))
,p_plug_display_when_cond2=>'PLSQL'
,p_landmark_type=>'exclude_landmark'
,p_plug_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'1500,460,514,516,527,273,2100,2101,2102,2103,2105,2106,2107,2108,2109,2111,2115,1556,1555,163,1550,56,320,176,189,351,433,437,447,448,451,454,458,494,495,496,3001,3002,3003,3004,3005,3006,3014,3015,3020,49,57,3000,2116,598,2117,73',
'',
'-- condition: current page is not in expression 1 (as of 01/06/2014)',
'4500,1500,460,514,516,527,273,2100,2101,2102,2103,2105,2106,2107,2108,2109,2111,2115,163,56,320,176,189,351,433,437,447,448,451,454,458,494,495,496,3001,3002,3003,3004,3005,3006,3014,3015,3020,49,57,3000,2116,598,2117,73,227,262,20,800,662,544,2150,2'
||'151,2152,2153,2154,2155,2156,2157,733,870,871,872,873,874,550,555,560,580,585,588,589,599,226,595,875,876,700,705,710,715,720,725,730,735,750,880,882,600,605,610,615,620,625,630,635,640,884,886,196,722,523,689,4460,479,224,4900,76,489,488,487,441,110'
||'05,933,559,934,679,11002,11003,11004,78,279,50,83,209,81,650,680',
''))
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(224570715692726883)
,p_plug_name=>'Working Copy Main App Menu'
,p_region_name=>'mainAppMenu'
,p_parent_plug_id=>wwv_flow_imp.id(3700518577643)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_imp.id(1415423878169192)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(3712705120335)
,p_translate_title=>'N'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_working_copy_dev.is_main_app (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_security_group_id => :WORKSPACE_ID )'))
,p_plug_display_when_cond2=>'PLSQL'
,p_landmark_type=>'exclude_landmark'
,p_plug_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'1500,460,514,516,527,273,2100,2101,2102,2103,2105,2106,2107,2108,2109,2111,2115,1556,1555,163,1550,56,320,176,189,351,433,437,447,448,451,454,458,494,495,496,3001,3002,3003,3004,3005,3006,3014,3015,3020,49,57,3000,2116,598,2117,73',
'',
'-- condition: current page is not in expression 1 (as of 01/06/2014)',
'4500,1500,460,514,516,527,273,2100,2101,2102,2103,2105,2106,2107,2108,2109,2111,2115,163,56,320,176,189,351,433,437,447,448,451,454,458,494,495,496,3001,3002,3003,3004,3005,3006,3014,3015,3020,49,57,3000,2116,598,2117,73,227,262,20,800,662,544,2150,2'
||'151,2152,2153,2154,2155,2156,2157,733,870,871,872,873,874,550,555,560,580,585,588,589,599,226,595,875,876,700,705,710,715,720,725,730,735,750,880,882,600,605,610,615,620,625,630,635,640,884,886,196,722,523,689,4460,479,224,4900,76,489,488,487,441,110'
||'05,933,559,934,679,11002,11003,11004,78,279,50,83,209,81,650,680',
''))
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(48577912101738240)
,p_plug_name=>'Breadcrumb'
,p_parent_plug_id=>wwv_flow_imp.id(3705300509478)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_menu_id=>wwv_flow_imp.id(6341600034528019)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_imp.id(3705314539083)
,p_landmark_type=>'navigation'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3707738215039)
,p_plug_name=>'Global JavaScript variables'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>30
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_allow_team_dev varchar2( 1 );',
'begin',
'    sys.htp.p(''<script type="text/javascript">'');',
'',
'    select nvl( allow_team_development_yn, ''Y'' )',
'      into l_allow_team_dev',
'      from wwv_flow_companies',
'     where provisioning_company_id = :WORKSPACE_ID;',
'     ',
'    sys.htp.p(',
'        ''var gTeamDevEnabled = '' || wwv_flow_javascript.add_value( l_allow_team_dev = ''Y'', false ) ||',
'        '', gBuilderLang = '' || wwv_flow_escape.js_literal( wwv_flow.g_flow_language ) ||',
'        '', gIsInternal  = '' || wwv_flow_javascript.add_value( :WORKSPACE_ID = 10, false ) ||',
'        '', gIsReadOnly  = '' || wwv_flow_javascript.add_value( false, false ) ||',
'        '', gLanguage    = '' || wwv_flow_javascript.add_value( wwv_flow.g_flow_language, false ) ||',
'        '', gApexVersion = '' || wwv_flow_javascript.add_value( wwv_flows_release, false ) ||',
'        '';'' );',
'',
'    wwv_flow_json.initialize_clob_output;',
'    wwv_flow_json.open_object;',
'    for l_preferences in ( select preference_name,',
'                                  attribute_value',
'                             from wwv_flow_preferences$',
'                            where user_id = wwv_flow.g_user',
'                              and security_group_id = :WORKSPACE_ID',
'                              and preference_name in ( ''PD_PE_KEEP_LABELS_ABOVE'',',
'                                                       ''PD_PE_SHOW_ALL'',',
'                                                       ''PD_GAL_SHOW_UNSUP'',',
'                                                       ''PD_GAL_CUR_TAB'',',
'                                                       ''PD_GLV_HIDE_LEGACY'',',
'                                                       ''PD_GLV_HIDE_GLOBAL'',',
'                                                       ''PD_GLV_HIDE_BTNS'',',
'                                                       ''PD_GLV_HIDE_ITEMS'',',
'                                                       ''PD_GLV_HIDE_EMPTY'',',
'                                                       ''PD_TAB_LAYOUT_2'',',
'                                                       ''PD_TAB_LAYOUT_3'',',
'                                                       ''PD_TWO_COLUMN_MODE'',',
'                                                       ''CODE_EDITOR_SETTINGS'',',
'                                                       ''CODE_LANGUAGE'',',
'                                                       ''PD_PE_CODE_EDITOR_DLG_W'',',
'                                                       ''PD_PE_CODE_EDITOR_DLG_H'',',
'                                                       ''PD_GROUP_BY_COMPONENT_TYPE'',',
'                                                       ''PD_ENABLE_TOOLTIPS'',',
'                                                       ''PD_ENABLE_LAYOUT_VIEW'') )',
'    loop',
'        wwv_flow_json.write(l_preferences.preference_name, l_preferences.attribute_value);',
'    end loop;',
'    wwv_flow_json.close_object;',
'    ',
'    sys.htp.prn(''var gPreferences = '' || wwv_flow_json.get_clob_output(p_free => true) || '';'');',
'    sys.htp.p(''</script>'');',
'',
'end;',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3710342843565)
,p_plug_name=>'Lock Dialog'
,p_region_name=>'lockDialog'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="display:none;"'
,p_plug_template=>wwv_flow_imp.id(461857790551605627)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_06'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p id="lockDialogIntroUnlocked">Locking a page gives you exclusive access to make modifications to the page and its components. Other developers cannot change the page until you unlock it. You can enter a comment to let other developers know why you '
||'have the page locked.</p>',
'<p id="lockDialogIntroOwned">You have this page locked. You can unlock the page to allow other developers to make changes to it or you can update the lock comment.</p>',
'<p id="lockDialogIntroLocked">Another developer currently has this page locked. You will not be able to edit this page until they unlock it.</p>',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1426591753658002)
,p_plug_name=>'AI Hook'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_06'
,p_location=>null
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.AI_HOOK'
,p_ai_enabled=>false
,p_ai_system_prompt=>'APEX$CODE_EDITOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'ai_key', 'codeEditor')).to_clob
,p_plug_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'*** Do not remove *** ',
'This region is necessary for the AI Chat feature in the code editors.',
''))
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2449077891076402)
,p_plug_name=>'Page Pattern Unsubscribe Dialog'
,p_region_name=>'pdUnsubscribeDialog'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="display:none;"'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_06'
,p_plug_source=>'<p>You are choosing to unsubscribe this page pattern from the master application. If your page is still part of a subscribed component group you will receive an error message. In this situation you will need to delete the component group first before'
||' unsubscribing the page.</p>'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(48564602512738202)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(150655275868720205)
,p_plug_name=>'Message Dialog'
,p_region_name=>'pdMessagesDialog'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="display:none;"'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_06'
,p_plug_source=>'<div id="pdMessages" class="padding-md"></div>'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(203904827661009901)
,p_plug_name=>'[Splitter] Main'
,p_region_name=>'sp_main'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="display:none"'
,p_plug_template=>wwv_flow_imp.id(177373906751600776)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SPLITTER'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', '#sp_main_content',
  'attribute_02', 'horizontal',
  'attribute_03', 'begin',
  'attribute_04', '290',
  'attribute_05', 'N',
  'attribute_08', '280',
  'attribute_09', 'N',
  'attribute_12', 'Left Splitter',
  'attribute_13', 'Y',
  'attribute_14', 'Y',
  'attribute_15', 'N',
  'attribute_16', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(203905025078009915)
,p_plug_name=>'Page Elements'
,p_region_name=>'left_col'
,p_parent_plug_id=>wwv_flow_imp.id(203904827661009901)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(226071526010722245)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(203905223102009916)
,p_plug_name=>'Page Elements - Container'
,p_parent_plug_id=>wwv_flow_imp.id(203905025078009915)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1340563172981198341)
,p_plug_name=>'Left Column Tree'
,p_region_name=>'trees'
,p_parent_plug_id=>wwv_flow_imp.id(203905223102009916)
,p_region_css_classes=>'resize ui-tabs--simpleInset a-Tabs--pageDesignerTabs'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(1094670710611261973)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_landmark_label=>'Page Elements Tabs'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1340563217684198342)
,p_plug_name=>'Rendering'
,p_region_name=>'renderTree_container'
,p_parent_plug_id=>wwv_flow_imp.id(1340563172981198341)
,p_region_css_classes=>'resize'
,p_icon_css_classes=>'icon-pd-rendering'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(280299836211526841)
,p_plug_name=>'Rendering'
,p_parent_plug_id=>wwv_flow_imp.id(1340563217684198342)
,p_region_css_classes=>'a-Toolbar-pageColumn a-Toolbar--floating'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174795802901076650)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The title is not visible but accessible to screen readers as the label of the accessible toolbar, which is  provided by the template "APEX 5.0 - Toolbar".',
'Do not use the word "Toolbar" as part of the title, this will produce doubled output of this word.'))
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1494054703785077894)
,p_plug_name=>'Rendering'
,p_region_name=>'r_rendering_tree'
,p_parent_plug_id=>wwv_flow_imp.id(1340563217684198342)
,p_region_css_classes=>'u-ScrollingViewport resize a-PageDesigner-treeWrap'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div aria-label=''&"APP_TEXT$PD.TREE.NAME_RENDERING".'' id="PDrenderingTree"></div>',
'',
''))
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1340563351308198343)
,p_plug_name=>'Dynamic Actions'
,p_region_name=>'dynActTree_container'
,p_parent_plug_id=>wwv_flow_imp.id(1340563172981198341)
,p_region_css_classes=>'resize'
,p_icon_css_classes=>'icon-pd-dynact'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(280299977196526842)
,p_plug_name=>'Dynamic Actions'
,p_parent_plug_id=>wwv_flow_imp.id(1340563351308198343)
,p_region_css_classes=>'a-Toolbar-pageColumn a-Toolbar--floating'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174795802901076650)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The title is not visible but accessible to screen readers as the label of the accessible toolbar, which is  provided by the template "APEX 5.0 - Toolbar".',
'Do not use the word "Toolbar" as part of the title, this will produce doubled output of this word.'))
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1494055203061088419)
,p_plug_name=>'Dynamic Actions'
,p_region_name=>'r_da_tree'
,p_parent_plug_id=>wwv_flow_imp.id(1340563351308198343)
,p_region_css_classes=>'u-ScrollingViewport resize a-PageDesigner-treeWrap'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div aria-label=''&"APP_TEXT$PD.TREE.NAME_DYNAMIC_ACTIONS".'' id="PDdynamicActionTree"></div>',
'',
'',
''))
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1340563430729198344)
,p_plug_name=>'Processing'
,p_region_name=>'procTree_container'
,p_parent_plug_id=>wwv_flow_imp.id(1340563172981198341)
,p_region_css_classes=>'resize'
,p_icon_css_classes=>'icon-pd-processing'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>60
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(280300071991526843)
,p_plug_name=>'Processing'
,p_parent_plug_id=>wwv_flow_imp.id(1340563430729198344)
,p_region_css_classes=>'a-Toolbar-pageColumn a-Toolbar--floating'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174795802901076650)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The title is not visible but accessible to screen readers as the label of the accessible toolbar, which is  provided by the template "APEX 5.0 - Toolbar".',
'Do not use the word "Toolbar" as part of the title, this will produce doubled output of this word.'))
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1494055572937094000)
,p_plug_name=>'Processing'
,p_region_name=>'r_processing_tree'
,p_parent_plug_id=>wwv_flow_imp.id(1340563430729198344)
,p_region_css_classes=>'u-ScrollingViewport resize a-PageDesigner-treeWrap'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div aria-label=''&"APP_TEXT$PD.TREE.NAME_PROCESSING".'' id="PDprocessingTree"></div>',
'',
''))
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1340563522501198345)
,p_plug_name=>'Page Shared Components'
,p_region_name=>'sharedComp_container'
,p_parent_plug_id=>wwv_flow_imp.id(1340563172981198341)
,p_region_css_classes=>'resize'
,p_icon_css_classes=>'icon-pd-shared-components'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>80
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(280300175072526844)
,p_plug_name=>'Page Shared Components'
,p_parent_plug_id=>wwv_flow_imp.id(1340563522501198345)
,p_region_css_classes=>'a-Toolbar-pageColumn a-Toolbar--floating'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174795802901076650)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The title is not visible but accessible to screen readers as the label of the accessible toolbar, which is  provided by the template "APEX 5.0 - Toolbar".',
'Do not use the word "Toolbar" as part of the title, this will produce doubled output of this word.'))
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1493954211520964691)
,p_plug_name=>'Page Shared Components'
,p_region_name=>'r_shared_comp_tree'
,p_parent_plug_id=>wwv_flow_imp.id(1340563522501198345)
,p_region_css_classes=>'u-ScrollingViewport resize a-PageDesigner-treeWrap'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div aria-label=''&"APP_TEXT$PD.TREE.NAME_SHARED_COMPONENTS".'' id="PDsharedCompTree"></div>',
'',
'',
'',
''))
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(203906404237009921)
,p_plug_name=>'[Splitter] Right'
,p_region_name=>'sp_right'
,p_parent_plug_id=>wwv_flow_imp.id(203904827661009901)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(177373906751600776)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SPLITTER'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', '#sp_right_content',
  'attribute_02', 'horizontal',
  'attribute_03', 'end',
  'attribute_04', '290',
  'attribute_05', 'N',
  'attribute_08', '200',
  'attribute_09', 'N',
  'attribute_12', 'Right Splitter',
  'attribute_13', 'Y',
  'attribute_14', 'Y',
  'attribute_15', 'N',
  'attribute_16', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(203907003331009924)
,p_plug_name=>'Primary Editor'
,p_region_name=>'top_col'
,p_parent_plug_id=>wwv_flow_imp.id(203906404237009921)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(226071526010722245)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(203907206229009924)
,p_plug_name=>'Editor Tabs'
,p_region_name=>'editor_tabs'
,p_parent_plug_id=>wwv_flow_imp.id(203907003331009924)
,p_region_css_classes=>'resize ui-tabs--simpleInset a-Tabs--pageDesignerTabs a-Tabs--pageDesignerPrimaryTabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(1094670710611261973)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_landmark_label=>'Primary Editor Tabs'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(113729401479047174)
,p_plug_name=>'Dump'
,p_region_name=>'dump'
,p_parent_plug_id=>wwv_flow_imp.id(203907206229009924)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>60
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<div id="dumpContent" style="height: 100%; overflow: auto;"></div>'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NEVER'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(142989453942607541)
,p_plug_name=>'Messages'
,p_region_name=>'messages'
,p_parent_plug_id=>wwv_flow_imp.id(203907206229009924)
,p_region_css_classes=>'resize'
,p_icon_css_classes=>'icon-pd-messages'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<div id="messages-container" class="resize u-ScrollingViewport"></div>'
,p_plug_display_condition_type=>'NEVER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'Set to Condition NEVER by Shakeeb on 12-4-2019. We moved Messages into an inline dialog for 20.1. Will delete this region once I demo to team.'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(203907414821009925)
,p_plug_name=>'Layout'
,p_region_name=>'grid_layout'
,p_parent_plug_id=>wwv_flow_imp.id(203907206229009924)
,p_region_css_classes=>'resize'
,p_icon_css_classes=>'icon-pd-layout'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(203907623449009926)
,p_plug_name=>'Layout'
,p_parent_plug_id=>wwv_flow_imp.id(203907414821009925)
,p_region_css_classes=>'a-Toolbar-pageColumn a-Toolbar-pageColumn--gridLayout a-Toolbar--simple'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174795802901076650)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The title is not visible but accessible to screen readers as the label of the accessible toolbar, which is  provided by the template "APEX 5.0 - Toolbar".',
'Do not use the word "Toolbar" as part of the title, this will produce doubled output of this word.'))
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1157687726908338238)
,p_plug_name=>'[Splitter] GLV'
,p_region_name=>'sp_glv'
,p_parent_plug_id=>wwv_flow_imp.id(203907414821009925)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(177373906751600776)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SPLITTER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', '#sp_glv_content',
  'attribute_02', 'vertical',
  'attribute_03', 'end',
  'attribute_04', '200',
  'attribute_05', 'N',
  'attribute_08', '140',
  'attribute_09', 'N',
  'attribute_12', 'Gallery Splitter',
  'attribute_13', 'Y',
  'attribute_14', 'Y',
  'attribute_15', 'N',
  'attribute_16', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(203921031629597761)
,p_plug_name=>'Drag and Drop Editor'
,p_region_name=>'glv-viewport-container'
,p_parent_plug_id=>wwv_flow_imp.id(1157687726908338238)
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="glv-viewport" class="dark-scroll resize u-ScrollingViewport a-GridLayout-wrapper">',
'  <div id="glv"></div>',
'</div>',
'<div id="glvMenu"></div>'))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_landmark_type=>'region'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1157688004078338241)
,p_plug_name=>'TabHolder'
,p_parent_plug_id=>wwv_flow_imp.id(1157687726908338238)
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'For proper sizing tabs must be in a container div that is sized.'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(203912509681231815)
,p_plug_name=>'Gallery'
,p_region_name=>'gallery-tabs'
,p_parent_plug_id=>wwv_flow_imp.id(1157688004078338241)
,p_region_css_classes=>'resize ui-tabs--subTabButtons a-Toolbar--simple'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(183219627032331552)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3694511958291)
,p_plug_name=>'Regions'
,p_region_name=>'cg-regions'
,p_parent_plug_id=>wwv_flow_imp.id(203912509681231815)
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class=''resize u-ScrollingViewport''>',
'  <ul></ul>',
'</div>',
''))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3694514965509)
,p_plug_name=>'Items'
,p_region_name=>'cg-items'
,p_parent_plug_id=>wwv_flow_imp.id(203912509681231815)
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class=''resize u-ScrollingViewport''>',
'  <ul></ul>',
'</div>',
''))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3694524975718)
,p_plug_name=>'Buttons'
,p_region_name=>'cg-buttons'
,p_parent_plug_id=>wwv_flow_imp.id(203912509681231815)
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class=''resize u-ScrollingViewport''>',
'  <ul></ul>',
'</div>',
''))
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(226343526195304018)
,p_plug_name=>'Help'
,p_region_name=>'help'
,p_parent_plug_id=>wwv_flow_imp.id(203907206229009924)
,p_icon_css_classes=>'icon-help'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<div id="help-container" class="a-HelpRegion resize u-ScrollingViewport"></div>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(361877912555473789)
,p_plug_name=>'Page Search'
,p_region_name=>'search'
,p_parent_plug_id=>wwv_flow_imp.id(203907206229009924)
,p_region_css_classes=>'resize'
,p_icon_css_classes=>'icon-search'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3344151064196342)
,p_plug_name=>'Search Toolbar'
,p_parent_plug_id=>wwv_flow_imp.id(361877912555473789)
,p_region_css_classes=>'a-Toolbar-pageColumn a-Toolbar-pageColumn--search'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3344283174196343)
,p_plug_name=>'Search Bar'
,p_parent_plug_id=>wwv_flow_imp.id(3344151064196342)
,p_region_css_classes=>'a-Toolbar-pageColumn--searchBar'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3344377146196344)
,p_plug_name=>'Search Options'
,p_parent_plug_id=>wwv_flow_imp.id(3344151064196342)
,p_region_css_classes=>'a-Toolbar-pageColumn--searchOptions'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3344471875196345)
,p_plug_name=>'Search Results'
,p_region_name=>'search-container'
,p_parent_plug_id=>wwv_flow_imp.id(361877912555473789)
,p_region_css_classes=>'resize u-ScrollingViewport'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'aria-live="polite"'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1341168555477845045)
,p_plug_name=>'Right Column Pane'
,p_region_name=>'right_col'
,p_parent_plug_id=>wwv_flow_imp.id(203906404237009921)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(226071526010722245)
,p_plug_display_sequence=>40
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1524154516324670408)
,p_plug_name=>'Property Editor Tabs'
,p_region_name=>'peTabs'
,p_parent_plug_id=>wwv_flow_imp.id(1341168555477845045)
,p_region_css_classes=>'resize ui-tabs--simpleInset a-Tabs--pageDesignerTabs'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(183219627032331552)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7800382557215003)
,p_plug_name=>'Attributes'
,p_region_name=>'peAttributesTabPanel'
,p_parent_plug_id=>wwv_flow_imp.id(1524154516324670408)
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7800501277215005)
,p_plug_name=>'Property Editor - Attributes'
,p_parent_plug_id=>wwv_flow_imp.id(7800382557215003)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="peAttributes" class="resize"></div>',
'<div id="pe_attributes_goto_group_menu"></div>'))
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7800658140215006)
,p_plug_name=>'Property Editor'
,p_region_name=>'peAttributesToolbar'
,p_parent_plug_id=>wwv_flow_imp.id(7800382557215003)
,p_region_css_classes=>'a-Toolbar-pageColumn a-Toolbar--simple a-Toolbar--propertyEditor'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174795802901076650)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The title is not visible but accessible to screen readers as the label of the accessible toolbar, which is  provided by the template "APEX 5.0 - Toolbar".',
'Do not use the word "Toolbar" as part of the title, this will produce doubled output of this word.'))
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7800873921215008)
,p_plug_name=>'Printing'
,p_region_name=>'pePrintingTabPanel'
,p_parent_plug_id=>wwv_flow_imp.id(1524154516324670408)
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7800994639215009)
,p_plug_name=>'Property Editor'
,p_region_name=>'pePrintingToolbar'
,p_parent_plug_id=>wwv_flow_imp.id(7800873921215008)
,p_region_css_classes=>'a-Toolbar-pageColumn a-Toolbar--simple a-Toolbar--propertyEditor'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174795802901076650)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The title is not visible but accessible to screen readers as the label of the accessible toolbar, which is  provided by the template "APEX 5.0 - Toolbar".',
'Do not use the word "Toolbar" as part of the title, this will produce doubled output of this word.'))
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7801104432215011)
,p_plug_name=>'Property Editor - Printing'
,p_parent_plug_id=>wwv_flow_imp.id(7800873921215008)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="pePrinting" class="resize"></div>',
'<div id="pe_printing_goto_group_menu"></div>'))
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1524154122429670404)
,p_plug_name=>'Component Properties'
,p_region_name=>'peComponentProperties'
,p_parent_plug_id=>wwv_flow_imp.id(1524154516324670408)
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1341168630800845046)
,p_plug_name=>'Property Editor'
,p_region_name=>'peMainToolbar'
,p_parent_plug_id=>wwv_flow_imp.id(1524154122429670404)
,p_region_css_classes=>'a-Toolbar-pageColumn a-Toolbar--simple a-Toolbar--propertyEditor'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174795802901076650)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The title is not visible but accessible to screen readers as the label of the accessible toolbar, which is  provided by the template "APEX 5.0 - Toolbar".',
'Do not use the word "Toolbar" as part of the title, this will produce doubled output of this word.'))
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1524154068172670403)
,p_plug_name=>'Property Editor'
,p_parent_plug_id=>wwv_flow_imp.id(1524154122429670404)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="peMain" class="resize"></div>',
'<div id="pe_goto_group_menu"></div>'))
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(385808069211243605)
,p_plug_name=>'Run Page'
,p_region_name=>'runDialogOpenMsg'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="display:none;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_06'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Changes have been saved.</p>',
'<p>Failed to open a window to run the page.</p>',
'<p>If you get a pop-up blocked message from the browser you may choose',
'to allow or deny pop-ups, or simply ignore the message. ',
'This dialog will always give you a second chance to run the page.',
'If you allow pop-ups you will not get this message again.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(385808170912243606)
,p_plug_name=>'Focus Page'
,p_region_name=>'runDialogFocusMsg'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="display:none;"'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_06'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Changes have been saved and the page has run.</p>',
'<p>Failed to focus application window for the page.</p>',
'<p>Note: Some browsers will not allow a tab in another window to be focused',
'if it is not the active tab. If this is the case you will have to manually',
'switch to the application tab or window.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(651997817665245731)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(3344283174196343)
,p_button_name=>'CLEAR_PAGE_SEARCH'
,p_button_static_id=>'CLEAR_PAGE_SEARCH'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Clear'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'icon-remove'
,p_button_cattributes=>'aria-controls="search-container"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7800771314215007)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(7800658140215006)
,p_button_name=>'GOTO_GROUP_ATTR'
,p_button_static_id=>'peAttributesGoToGroupBtn'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(3705362896815)
,p_button_image_alt=>'Go to Group'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--simple'
,p_icon_css_classes=>'icon-goto-group'
,p_button_cattributes=>'data-menu="pe_attributes_goto_group_menu"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7801034657215010)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(7800994639215009)
,p_button_name=>'GOTO_GROUP_PRINT'
,p_button_static_id=>'pePrintingGoToGroupBtn'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(3705362896815)
,p_button_image_alt=>'Go to Group'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--simple'
,p_icon_css_classes=>'icon-goto-group'
,p_button_cattributes=>'data-menu="pe_printing_goto_group_menu"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1157688133261338242)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(280299836211526841)
,p_button_name=>'RENDERING_MENU'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(3705362896815)
,p_button_image_alt=>'Rendering'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'icon-menu'
,p_button_cattributes=>'data-menu="PDrenderingTreeMenu"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1157688259884338243)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(280299977196526842)
,p_button_name=>'DA_MENU'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(3705362896815)
,p_button_image_alt=>'Dynamic Actions'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'icon-menu'
,p_button_cattributes=>'data-menu="PDdynamicActionTreeMenu"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1157688362643338244)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(280300071991526843)
,p_button_name=>'PROCESSING_MENU'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(3705362896815)
,p_button_image_alt=>'Processing'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'icon-menu'
,p_button_cattributes=>'data-menu="PDprocessingTreeMenu"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1157688604793338247)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(280300175072526844)
,p_button_name=>'SHARED_COMPONENTS_MENU'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(3705362896815)
,p_button_image_alt=>'Page Shared Components'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'icon-menu'
,p_button_cattributes=>'data-menu="PDsharedCompTreeMenu"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1341168930067845049)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(1341168630800845046)
,p_button_name=>'GOTO_GROUP_MAIN'
,p_button_static_id=>'peGoToGroupBtn'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(3705362896815)
,p_button_image_alt=>'Go to Group'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--simple'
,p_icon_css_classes=>'icon-goto-group'
,p_button_cattributes=>'data-menu="pe_goto_group_menu"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3694510953653)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(203912509681231815)
,p_button_name=>'GALLERY_MENU'
,p_button_static_id=>'galleryMenuBtn'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(3705362896815)
,p_button_image_alt=>'Gallery'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--simple '
,p_icon_css_classes=>'icon-menu'
,p_button_cattributes=>'data-menu="galleryMenu"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(204039413666958409)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(203907623449009926)
,p_button_name=>'GLV_MENU'
,p_button_static_id=>'glvMenuBtn'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(3705362896815)
,p_button_image_alt=>'Layout'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--simple '
,p_icon_css_classes=>'icon-menu'
,p_button_cattributes=>'data-menu="glvMenu"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(48563428122738189)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_imp.id(3700518577643)
,p_button_name=>'GO'
,p_button_static_id=>'go_to_page_button'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Go'
,p_button_position=>'NEXT'
,p_button_css_classes=>' a-Button--goToPageButton a-Button--pillEnd'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(150654840937720201)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_imp.id(3700518577643)
,p_button_name=>'SHOW_MESSAGES'
,p_button_static_id=>'pdShowMessagesBtn'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(3781715377307)
,p_button_image_alt=>'Show Messages'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--simple'
,p_icon_css_classes=>'icon-pd-messages'
,p_button_cattributes=>'style="display:none"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3705913948159)
,p_button_sequence=>120
,p_button_plug_id=>wwv_flow_imp.id(3700518577643)
,p_button_name=>'LOCK'
,p_button_static_id=>'button-lock'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Lock'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--gapLeft a-Button--simple'
,p_icon_css_classes=>'icon-unlock'
,p_button_cattributes=>'aria-haspopup="dialog"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(136021117712580811)
,p_button_sequence=>130
,p_button_plug_id=>wwv_flow_imp.id(3700518577643)
,p_button_name=>'UNDO'
,p_button_static_id=>'button-undo'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Undo'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--pillStart a-Button--gapLeft a-Button--padLeft a-Button--simple'
,p_icon_css_classes=>'icon-undo'
,p_button_cattributes=>'data-action="pd-undo"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(136021815073589540)
,p_button_sequence=>140
,p_button_plug_id=>wwv_flow_imp.id(3700518577643)
,p_button_name=>'REDO'
,p_button_static_id=>'button-redo'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Redo'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--pillEnd a-Button--simple'
,p_icon_css_classes=>'icon-redo'
,p_button_cattributes=>'data-action="pd-redo"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3705393924440)
,p_button_sequence=>150
,p_button_plug_id=>wwv_flow_imp.id(3700518577643)
,p_button_name=>'CREATE_MENU'
,p_button_static_id=>'menu-create'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(3705362896815)
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--gapLeft a-Button--simple'
,p_icon_css_classes=>'icon-plus'
,p_button_cattributes=>'data-menu="createMenu_menu"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3705373911136)
,p_button_sequence=>160
,p_button_plug_id=>wwv_flow_imp.id(3700518577643)
,p_button_name=>'UTILITIES_MENU'
,p_button_static_id=>'menu-utilities'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(3705362896815)
,p_button_image_alt=>'Utilities'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--gapRight a-Button--simple'
,p_icon_css_classes=>'icon-tools'
,p_button_cattributes=>'data-menu="utilitiesMenu_menu"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3705398937273)
,p_button_sequence=>170
,p_button_plug_id=>wwv_flow_imp.id(3700518577643)
,p_button_name=>'TEAM_DEV_MENU'
,p_button_static_id=>'menu-team-dev'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(3770144455858)
,p_button_image_alt=>'Team Development'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'select 1 from wwv_flow_companies where nvl(ALLOW_TEAM_DEVELOPMENT_YN, ''Y'') = ''Y'' and provisioning_company_id = :FLOW_SECURITY_GROUP_ID'
,p_button_condition_type=>'EXISTS'
,p_button_css_classes=>'a-Button--simple'
,p_icon_css_classes=>'icon-users'
,p_button_cattributes=>'data-menu="teamDevMenu" disabled style="display: none"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3705396934374)
,p_button_sequence=>200
,p_button_plug_id=>wwv_flow_imp.id(3700518577643)
,p_button_name=>'SHARED_COMP'
,p_button_static_id=>'menu-shared-components'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Shared Components'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.:RP::'
,p_button_css_classes=>'a-Button--gapRight a-Button--simple'
,p_icon_css_classes=>'icon-shared-components'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3226742114984201)
,p_button_sequence=>210
,p_button_plug_id=>wwv_flow_imp.id(3700518577643)
,p_button_name=>'PAGE_DIFFS'
,p_button_static_id=>'page-diffs-button'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'View changes in other copies'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:5330:&SESSION.::&DEBUG.:::'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_working_copy_dev.is_working_copy(',
'    p_application_id => :FB_FLOW_ID )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_css_classes=>'a-Button--simple'
,p_icon_css_classes=>'icon-warning is-working-copy'
,p_button_cattributes=>'style="display:none" aria-haspopup="dialog"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(220483976268998704)
,p_button_sequence=>220
,p_button_plug_id=>wwv_flow_imp.id(3700518577643)
,p_button_name=>'MAIN_APP_MENU'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(267402330762941782)
,p_button_image_alt=>'Main'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_working_copy_dev.app_has_working_copy (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_security_group_id => :WORKSPACE_ID )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_css_classes=>'a-Button a-Button--padLeft a-Button--gapRight'
,p_icon_css_classes=>'icon-working-copy-main'
,p_button_cattributes=>'data-menu="mainAppMenu_menu" aria-label="Working Copy: Main" title="Working Copy: Main"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1713232055363869)
,p_button_sequence=>230
,p_button_plug_id=>wwv_flow_imp.id(3700518577643)
,p_button_name=>'WORKING_COPY_MENU'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(267402330762941782)
,p_button_image_alt=>'&WORKING_COPY_NAME.'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_working_copy_dev.is_working_copy( ',
'    p_application_id    => :FB_FLOW_ID,',
'    p_security_group_id => :WORKSPACE_ID )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_css_classes=>'a-Button a-Button--padLeft a-Button--gapRight is-working-copy'
,p_icon_css_classes=>'icon-working-copy'
,p_button_cattributes=>'data-menu="workingCopyMenu_menu" aria-label="Working Copy: &WORKING_COPY_NAME." title="Working Copy: &WORKING_COPY_NAME."'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3705918956180)
,p_button_sequence=>240
,p_button_plug_id=>wwv_flow_imp.id(3700518577643)
,p_button_name=>'SAVE_PAGE'
,p_button_static_id=>'button-save-page'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Save'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--iconTopAction a-Button--savePage'
,p_button_cattributes=>'data-action="pd-save-page" disabled'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3705920960782)
,p_button_sequence=>250
,p_button_plug_id=>wwv_flow_imp.id(3700518577643)
,p_button_name=>'RUN_PAGE'
,p_button_static_id=>'button-save-run-page'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save and Run Page'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--iconTopAction a-Button--runPage'
,p_icon_css_classes=>'icon-run-page'
,p_button_cattributes=>'data-action="pd-save-run-page" disabled'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(385901226436802236)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(203907623449009926)
,p_button_name=>'GLV_DISPLAY_FROM_PAGE'
,p_button_static_id=>'glvDispFromPageBtn'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Display From Page'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--simple a-Button--pillStart'
,p_icon_css_classes=>'icon-zoom-page'
,p_button_cattributes=>'data-action="glv-disp-from-page" disabled'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(385901489451807019)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(203907623449009926)
,p_button_name=>'GLV_DISPLAY_FROM_HERE'
,p_button_static_id=>'glvDispFromHereBtn'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Display From Here'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--simple a-Button--pillEnd'
,p_icon_css_classes=>'icon-zoom-region'
,p_button_cattributes=>'data-action="glv-disp-from-region" disabled'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(394428806332743893)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(203907623449009926)
,p_button_name=>'GLV_EXPAND_RESTORE'
,p_button_static_id=>'glvExpandRestoreBtn'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Expand'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--simple a-Button--gapLeft'
,p_icon_css_classes=>'icon-maximize'
,p_button_cattributes=>'data-action="pd-expand-restore"'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3708102043021)
,p_name=>'P4500_CURRENT_APP'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(48564602512738202)
,p_use_cache_before_default=>'NO'
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>'Identifies the page number. To view another page, select or enter a new page number and click <strong>Go</strong>.'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3710346923664)
,p_name=>'P4500_DLG_LOCK_COMMENT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(3710342843565)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comment'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3711685408090)
,p_name=>'P4500_DLG_LOCK_OWNER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(3710342843565)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Lock Owned By'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(361878703986669565)
,p_name=>'P4500_LOCAL_SEARCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3344283174196343)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Search'
,p_placeholder=>'Search page...'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>40
,p_cMaxlength=>255
,p_tag_attributes=>'aria-controls="search-container"'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--search'
,p_item_icon_css_classes=>'a-Icon icon-search'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(361879015280831539)
,p_name=>'P4500_MATCH_CASE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3344377146196344)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Match Case'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_tag_attributes=>'aria-controls="search-container"'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--inline'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(361879604663897172)
,p_name=>'P4500_IS_REGEXP'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3344377146196344)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Regular Expression'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_tag_attributes=>'aria-controls="search-container"'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--inline'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(48579902612738246)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'4500'
,p_computation_error_message=>'Unable to compute item value.'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(48582011193738251)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'security'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_error.raise_internal_error(',
'    p_error_message => wwv_flow_lang.system_message( p_name => ''F4000.P1.APP_DOES_NOT_EXIST'',',
'                                                     p0     => wwv_flow_escape.html( nvl( :FB_FLOW_ID, ''NULL'' ) ) ) );'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from sys.dual',
' where :FB_FLOW_ID is null',
'union all',
'select 1',
'    from   wwv_flow_developers',
'    where  userid = :FLOW_USER ',
'       and',
'       security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and',
'       security_group_id = ',
'         (select security_group_id from wwv_flows where id=:FB_FLOW_ID)',
'       and',
'       instr(developer_role,''EDIT'') > 0 ',
'       and',
'       (flow_id = :FB_FLOW_ID or flow_id is null)  ',
'intersect',
'select 1',
'  from wwv_flows',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and id = :FB_FLOW_ID',
'   and build_status = ''RUN_AND_BUILD'''))
,p_process_when_type=>'NOT_EXISTS'
,p_internal_uid=>48582011193738251
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3785910874387)
,p_process_sequence=>10
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'getDistinctValues'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_property_dev.emit_distinct_values (',
'        p_application_id    => :FB_FLOW_ID,',
'        p_component_type_id => wwv_flow.g_x01,',
'        p_property_id       => wwv_flow.g_x02 );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>3785910874387
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3786198819950)
,p_process_sequence=>10
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'getPageItems'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_property_dev.emit_page_items (',
'        p_application_id => :FB_FLOW_ID,',
'        p_page_id        => wwv_flow.g_x01 );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>3786198819950
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3786207134291)
,p_process_sequence=>10
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'getPages'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_property_dev.emit_pages (',
'        p_application_id   => :FB_FLOW_ID,',
'        p_include_global   => wwv_flow.g_x01 = ''Y'',',
'        p_filter_type      => wwv_flow.g_x02,',
'        p_filter_id        => wwv_flow.g_x03,',
'        p_include_patterns => wwv_flow.g_x04 = ''Y'' );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>3786207134291
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3787259718152)
,p_process_sequence=>10
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'getDbObjects'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_property_dev.emit_db_objects (',
'        p_application_id   => :FB_FLOW_ID,',
'        p_type             => wwv_flow.g_x01,',
'        p_owner            => wwv_flow.g_x02,',
'        p_parent           => wwv_flow.g_x03,',
'        p_remote_server_id => wwv_flow.g_x04 );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>3787259718152
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(379983509886592218)
,p_process_sequence=>10
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'getNewComponentId'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_property_dev.emit_new_component_id (',
'        p_count => wwv_flow.g_x01 );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>379983509886592218
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3710681876314)
,p_process_sequence=>40
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'getCodeCompleteList'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_f4000_plugins.emit_code_complete_list (',
'        p_application_id => :FB_FLOW_ID,',
'        p_type           => wwv_flow.g_widget_name,',
'        p_search_prefix  => wwv_flow.g_x01,',
'        p_parent         => wwv_flow.g_x02,',
'        p_grand_parent   => wwv_flow.g_x03 );',
'exception',
'    when others then',
'        wwv_flow_debug.log_exception;',
'        wwv_flow_error.handle_ajax_error (',
'            p_rollback => false );        ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>3710681876314
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(58466930233192809)
,p_process_sequence=>50
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'getPageData'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_property_dev.emit_page_data (',
'        p_application_id => :FB_FLOW_ID,',
'        p_page           => wwv_flow.g_x01 );',
'    :FB_FLOW_PAGE_ID := wwv_flow.g_x01;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>58466930233192809
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(48624806507914277)
,p_process_sequence=>60
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'getSharedData'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_property_dev.emit_shared_data (',
'        p_application_id => :FB_FLOW_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>48624806507914277
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(391308403502598043)
,p_process_sequence=>70
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'getWorkspaceData'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_property_dev.emit_workspace_data;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>391308403502598043
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(48608915034907292)
,p_process_sequence=>80
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'getStaticData'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_property_dev.emit_static_data;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>48608915034907292
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(402665328061568915)
,p_process_sequence=>90
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'getAdditionalData'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    c_page_id constant number := to_number( wwv_flow.g_x01 );',
'',
'    l_count   pls_integer;',
'    l_page_id number;',
'begin',
'    ',
'    wwv_flow_json.open_object;',
'',
'    -- Get previous page id',
'    begin',
'        select id',
'          into l_page_id',
'          from ( select id',
'                   from wwv_flow_steps',
'                  where flow_id = :FB_FLOW_ID',
'                    and security_group_id = :WORKSPACE_ID',
'                    and id                < c_page_id',
'                  order by id desc',
'               )',
'         where rownum <= 1;',
'        wwv_flow_json.  write( ''prevPageId'', to_char( l_page_id ));',
'    exception when no_data_found then null;',
'    end;',
'',
'    -- Get next page id',
'    begin',
'        select id',
'          into l_page_id',
'          from ( select id',
'                   from wwv_flow_steps',
'                  where flow_id = :FB_FLOW_ID',
'                    and security_group_id = :WORKSPACE_ID',
'                    and id                > c_page_id',
'                  order by id',
'               )',
'         where rownum <= 1;',
'        wwv_flow_json.  write( ''nextPageId'', to_char( l_page_id ));',
'    exception when no_data_found then null;',
'    end;',
'    ',
'    select count(*)',
'      into l_count',
'      from wwv_flow_app_comments',
'     where flow_id            = :FB_FLOW_ID',
'       and security_group_id  = :WORKSPACE_ID',
'       and instr( '','' || replace( replace( pages, '' '', null ), '':'', '','' ) || '','' , '','' || c_page_id || '','' ) > 0;',
'',
'    wwv_flow_json.  write( ''comments'', l_count );',
'',
'    wwv_flow_json.  open_object( ''teamDev'' );',
'    ',
'    ',
'    select count(*)',
'      into l_count',
'      from wwv_flow_feedback',
'     where application_id            = :FB_FLOW_ID',
'       and page_id                   = c_page_id',
'       and security_group_id         = :WORKSPACE_ID',
'       and nvl( feedback_status, 0 ) < 3;',
'',
'    wwv_flow_json.    write( ''feedback'', l_count );',
'    ',
'    --',
'    ',
'     select count(*)',
'      into l_count',
'      from wwv_flow_issues',
'     where application_id            = :FB_FLOW_ID',
'       and page_id                   = c_page_id',
'       and security_group_id         = :WORKSPACE_ID',
'       and status = ''OPEN'';',
'',
'    wwv_flow_json.    write( ''issues'', l_count );',
'    ',
'    wwv_flow_json.write( ''todos'', 0 );',
'    wwv_flow_json.write( ''features'', 0 );',
'    wwv_flow_json.write( ''bugs'', 0 );',
'    ',
'    wwv_flow_json.close_all;',
'    ',
'exception',
'    when others then',
'        wwv_flow_debug.log_exception;',
'        wwv_flow_error.handle_ajax_error (',
'            p_rollback => false );',
'end;',
''))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>402665328061568915
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(703162813604905314)
,p_process_sequence=>120
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'setPreference'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_property_dev.set_preference (',
'        p_preference_name   => wwv_flow.g_x01,',
'        p_preference_value  => wwv_flow.g_x02 );',
'end;        '))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>703162813604905314
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(139325814856024145)
,p_process_sequence=>130
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validateProperty'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_property_dev.validate_browser_property (',
'        p_application_id         => :FB_FLOW_ID, ',
'        p_page_id                => wwv_flow.g_x19,',
'        p_property_id            => wwv_flow.g_x01,',
'        p_property_type          => wwv_flow.g_x02,',
'        p_sql_min_column_count   => wwv_flow.g_x03,',
'        p_sql_max_column_count   => wwv_flow.g_x04,',
'        p_value                  => wwv_flow.g_x05,',
'        p_location               => wwv_flow.g_x06,',
'        p_query_type             => wwv_flow.g_x07,',
'        p_owner                  => wwv_flow.g_x08,',
'        p_object_name            => wwv_flow.g_x09,',
'        p_sql_query              => wwv_flow.g_x09,',
'        p_function_body          => wwv_flow.g_x09,',
'        p_web_source_query_id    => wwv_flow.g_x18,',
'        p_web_source_array_id  => wwv_flow.g_x10,',
'        p_include_rowid_column   => ( wwv_flow.g_x10 = ''Y'' ),',
'        p_optimizer_hint         => wwv_flow.g_x11,',
'        p_remote_database_id     => wwv_flow.g_x12,',
'        p_package_name           => wwv_flow.g_x13,',
'        p_custom_data_type       => wwv_flow.g_x14,',
'        p_match_clause           => wwv_flow.g_x15,',
'        p_columns_clause         => wwv_flow.g_x16,',
'        p_function_body_language => wwv_flow.g_x17 );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>139325814856024145
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(381488768716741713)
,p_process_sequence=>140
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'lockPage'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_property_dev.lock_page (',
'        p_application_id => :FB_FLOW_ID,',
'        p_page_id        => wwv_flow.g_x02,',
'        p_comment        => wwv_flow.g_x03 );',
'    commit;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>381488768716741713
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(381489365105890681)
,p_process_sequence=>150
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'unlockPage'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_property_dev.unlock_page (',
'        p_application_id => :FB_FLOW_ID,',
'        p_page_id        => wwv_flow.g_x02 );',
'    commit;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>381489365105890681
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2448918007076401)
,p_process_sequence=>160
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'unsubscribePage'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_property_dev.unsubscribe_page (',
'        p_application_id => :FB_FLOW_ID,',
'        p_page_id        => wwv_flow.g_x02 );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>2448918007076401
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3791708414403)
,p_process_sequence=>170
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'writePageData'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_property_dev.write_data (',
'        p_application_id => wwv_flow.g_x01,',
'        p_page_id        => wwv_flow.g_x02,',
'        p_designer_type  => ''PAGE'',',
'        p_data           => wwv_flow.g_f01 );',
'    commit;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>3791708414403
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(21976368989958503)
,p_process_sequence=>180
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'getEmailPlaceholders'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_json.open_object;',
'    wwv_flow_json.write( ',
'        p_name          => ''placeholders'',',
'        p_values        =>  wwv_flow_template_dev.email_template_placeholders(',
'                                p_application_id    => :FB_FLOW_ID,',
'                                p_email_template_id => wwv_flow.g_x01 ),',
'        p_write_null    => true );',
'    wwv_flow_json.close_object;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>21976368989958503
);
end;
/
prompt --application/pages/page_04653
begin
wwv_flow_imp_page.create_page(
 p_id=>4653
,p_name=>'Region Templates'
,p_alias=>'REGION-TEMPLATES'
,p_step_title=>'Edit Region Template'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';',
'',
'//-->',
'</script>'))
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'EXISTS'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_page_plug_templates t, wwv_flow_themes th',
'where t.id = :F4000_P4653_ID',
'and t.flow_id = th.flow_id',
'and t.theme_id = th.theme_id',
'and t.reference_id is not null',
'and th.reference_id is not null',
'and t.security_group_id = th.security_group_id',
'and t.security_group_id = :WORKSPACE_ID'))
,p_help_text=>'ui_templt_reg.htm'
,p_page_component_map=>'21'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(686703536)
,p_plug_name=>'Edit Region Template'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--accessibleTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_landmark_label=>'Region Template Actions'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(688720308)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>90
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Regions templates control the appearance and placement of region attributes.  ',
'You place region attributes using substitution strings such as <strong>#BODY#</strong> and <strong>#EDIT#</strong>. Template substitution strings must be in upper case and begin and end with a pound sign (#).'))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4546372471032502)
,p_plug_name=>'Landmark for Displayed Regions'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_landmark_type=>'region'
,p_landmark_label=>'Displayed Regions'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(687705197)
,p_plug_name=>'Name'
,p_region_name=>'NAME'
,p_parent_plug_id=>wwv_flow_imp.id(4546372471032502)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>250
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'-'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(689725477)
,p_plug_name=>'Comments'
,p_region_name=>'COMMENTS'
,p_parent_plug_id=>wwv_flow_imp.id(4546372471032502)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>140
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>' '
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6902767343389925)
,p_plug_name=>'Accessibility'
,p_parent_plug_id=>wwv_flow_imp.id(4546372471032502)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(25015589019379144)
,p_plug_name=>'Image'
,p_parent_plug_id=>wwv_flow_imp.id(4546372471032502)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(25494159951442861)
,p_plug_name=>'Template Options'
,p_parent_plug_id=>wwv_flow_imp.id(4546372471032502)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(20915676136405505)
,p_plug_name=>'Template Options'
,p_parent_plug_id=>wwv_flow_imp.id(25494159951442861)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.template_types,',
'       o.id,',
'       o.display_name,',
'       o.name,',
'       o.display_sequence,',
'       o.css_classes,',
'       o.flow_id,',
'       o.theme_id,',
'       o.help_text,',
'       o.group_id,',
'       o.region_template_id,',
'       ( select g.display_sequence from wwv_flow_template_opt_groups g where g.id = o.group_id ) group_display_sequence,',
'       ( select g.display_name     from wwv_flow_template_opt_groups g where g.id = o.group_id ) group_display_name',
'  from wwv_flow_template_options o',
' where o.flow_id            = :FB_FLOW_ID',
'   and o.theme_id           = :P4653_THEME',
'   and o.template_types     = ''REGION''',
'   and o.region_template_id = :F4000_P4653_ID',
'   and o.security_group_id  = :WORKSPACE_ID'))
,p_plug_source_type=>'NATIVE_IG'
,p_ajax_items_to_submit=>'P4653_DEFAULT_TEMPLATE_OPTIONS,P4653_THEME'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Template Options'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(9689552861802628)
,p_name=>'REGION_TEMPLATE_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'REGION_TEMPLATE_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>70
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'F4000_P4653_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(13087328298499030)
,p_name=>'GROUP_DISPLAY_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'GROUP_DISPLAY_SEQUENCE'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Group Sequence'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>80
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(13087466549499031)
,p_name=>'GROUP_DISPLAY_NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'GROUP_DISPLAY_NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Group Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>90
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(20916454670405513)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>30
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(20916540819405514)
,p_name=>'DISPLAY_NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DISPLAY_NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>100
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_item_width=>30
,p_is_required=>true
,p_max_length=>30
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_static_id=>'COLUMN_DISPLAY_NAME'
,p_use_as_row_header=>true
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(20916590104405515)
,p_name=>'DISPLAY_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DISPLAY_SEQUENCE'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>'Sequence'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>120
,p_value_alignment=>'RIGHT'
,p_attribute_03=>'left'
,p_attribute_04=>'decimal'
,p_item_width=>5
,p_is_required=>true
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'1'
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(20916705491405516)
,p_name=>'CSS_CLASSES'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'CSS_CLASSES'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Classes'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>130
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_max_length=>255
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(20917057127405519)
,p_name=>'APEX$ROW_ACTION'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>20
,p_use_as_row_header=>false
,p_display_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(20917106604405520)
,p_name=>'APEX$ROW_SELECTOR'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_use_as_row_header=>false
,p_display_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(20918141113405530)
,p_name=>'TEMPLATE_TYPES'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'TEMPLATE_TYPES'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>60
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'REGION'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(20918202629405531)
,p_name=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Identifier'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>110
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_attribute_06=>'UPPER'
,p_item_width=>30
,p_is_required=>true
,p_max_length=>30
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(21558893718560985)
,p_name=>'HELP_TEXT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'HELP_TEXT'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Help Text'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>150
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(21558995521560986)
,p_name=>'GROUP_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'GROUP_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Group'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>140
,p_value_alignment=>'LEFT'
,p_is_required=>false
,p_lov_type=>'SQL_QUERY'
,p_lov_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name,',
'       id',
'  from wwv_flow_template_opt_groups',
' where template_types    = :TEMPLATE_TYPES',
'   and flow_id           = :FB_FLOW_ID',
'   and theme_id          = :P4653_THEME',
'   and security_group_id = :WORKSPACE_ID'))
,p_lov_display_extra=>true
,p_lov_display_null=>true
,p_lov_cascade_parent_items=>'TEMPLATE_TYPES'
,p_ajax_items_to_submit=>'P4653_THEME'
,p_ajax_optimize_refresh=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(21559091149560987)
,p_name=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FLOW_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>40
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'FB_FLOW_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(21559210313560988)
,p_name=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'THEME_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>50
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'P4653_THEME'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(20916346873405512)
,p_internal_uid=>20916346873405512
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_add_row_if_empty=>false
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>true
,p_no_data_found_message=>'No template options.'
,p_show_toolbar=>true
,p_toolbar_buttons=>'SEARCH_FIELD:SAVE'
,p_add_button_label=>'Add Template Option'
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>false
,p_define_chart_view=>false
,p_enable_download=>false
,p_download_formats=>null
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function(config) {',
'    config.defaultGridViewOptions = {',
'        reorderColumns: false',
'    }',
'    return config;',
'}'))
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(21352313571544338)
,p_interactive_grid_id=>wwv_flow_imp.id(20916346873405512)
,p_static_id=>'94803'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(21352499589544339)
,p_report_id=>wwv_flow_imp.id(21352313571544338)
,p_view_type=>'GRID'
,p_stretch_columns=>true
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(11875376796778652)
,p_view_id=>wwv_flow_imp.id(21352499589544339)
,p_display_seq=>11
,p_column_id=>wwv_flow_imp.id(21559091149560987)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(11876416603778658)
,p_view_id=>wwv_flow_imp.id(21352499589544339)
,p_display_seq=>12
,p_column_id=>wwv_flow_imp.id(21559210313560988)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(11887395139794952)
,p_view_id=>wwv_flow_imp.id(21352499589544339)
,p_display_seq=>13
,p_column_id=>wwv_flow_imp.id(9689552861802628)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(21353050811544345)
,p_view_id=>wwv_flow_imp.id(21352499589544339)
,p_display_seq=>2
,p_column_id=>wwv_flow_imp.id(20916454670405513)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(21353955771544352)
,p_view_id=>wwv_flow_imp.id(21352499589544339)
,p_display_seq=>4
,p_column_id=>wwv_flow_imp.id(20916540819405514)
,p_is_visible=>true
,p_is_frozen=>false
,p_sort_order=>4
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(21354838308544356)
,p_view_id=>wwv_flow_imp.id(21352499589544339)
,p_display_seq=>6
,p_column_id=>wwv_flow_imp.id(20916590104405515)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>104
,p_sort_order=>3
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(21355683881544361)
,p_view_id=>wwv_flow_imp.id(21352499589544339)
,p_display_seq=>7
,p_column_id=>wwv_flow_imp.id(20916705491405516)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(21358407492544370)
,p_view_id=>wwv_flow_imp.id(21352499589544339)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(20917057127405519)
,p_is_visible=>true
,p_is_frozen=>true
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(21564918962563370)
,p_view_id=>wwv_flow_imp.id(21352499589544339)
,p_display_seq=>10
,p_column_id=>wwv_flow_imp.id(20918141113405530)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(21565827673563376)
,p_view_id=>wwv_flow_imp.id(21352499589544339)
,p_display_seq=>5
,p_column_id=>wwv_flow_imp.id(20918202629405531)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(21569467177563388)
,p_view_id=>wwv_flow_imp.id(21352499589544339)
,p_display_seq=>8
,p_column_id=>wwv_flow_imp.id(21558893718560985)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(21570363946563391)
,p_view_id=>wwv_flow_imp.id(21352499589544339)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(21558995521560986)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(23823650655936025)
,p_view_id=>wwv_flow_imp.id(21352499589544339)
,p_display_seq=>14
,p_column_id=>wwv_flow_imp.id(13087328298499030)
,p_is_visible=>false
,p_is_frozen=>false
,p_sort_order=>1
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(23824554668936028)
,p_view_id=>wwv_flow_imp.id(21352499589544339)
,p_display_seq=>15
,p_column_id=>wwv_flow_imp.id(13087466549499031)
,p_is_visible=>false
,p_is_frozen=>false
,p_sort_order=>2
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(708428607483249258)
,p_name=>'Global Template Options'
,p_parent_plug_id=>wwv_flow_imp.id(25494159951442861)
,p_template=>wwv_flow_imp.id(689970285456172024)
,p_display_sequence=>230
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.id,',
'       o.display_name,',
'       o.display_sequence,',
'       o.css_classes,',
'       g.display_name group_name',
'  from wwv_flow_template_options o,',
'       wwv_flow_template_opt_groups g',
' where o.flow_id              = :FB_FLOW_ID',
'   and o.virtual_template_id is null',
'   and o.template_types       = ''REGION''',
'   and o.REGION_TEMPLATE_ID  is null',
'   and o.security_group_id    = :WORKSPACE_ID',
'   and o.theme_id             = :P4653_THEME',
'   and g.id (+)               = o.group_id',
' order by',
'       g.display_sequence,',
'       g.display_name,',
'       o.display_sequence,',
'       o.display_name'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P4653_DEFAULT_TEMPLATE_OPTIONS,P4653_THEME'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>200
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No template options defined.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(11882034546758425)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(11882489760758425)
,p_query_column_id=>2
,p_column_alias=>'DISPLAY_NAME'
,p_column_display_sequence=>21
,p_column_heading=>'Name'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(11882840958758425)
,p_query_column_id=>3
,p_column_alias=>'DISPLAY_SEQUENCE'
,p_column_display_sequence=>31
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(11883299502758426)
,p_query_column_id=>4
,p_column_alias=>'CSS_CLASSES'
,p_column_display_sequence=>41
,p_column_heading=>'Classes'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(11883645940758426)
,p_query_column_id=>5
,p_column_alias=>'GROUP_NAME'
,p_column_display_sequence=>11
,p_column_heading=>'Group'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(33424815586234511)
,p_plug_name=>'Subscription'
,p_region_name=>'SUBSCRIPTION'
,p_parent_plug_id=>wwv_flow_imp.id(4546372471032502)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P4653_THEME_IS_SUBSCRIBED'
,p_plug_display_when_cond2=>'NONE'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'WWV_FLOW_PAGE_PLUG_TEMPLATES',
  'attribute_02', 'PAGE_PLUG_TEMPLATE_NAME',
  'attribute_03', 'F4000_P4653_ID',
  'attribute_04', 'F4000_P4653_REFERENCE_ID',
  'attribute_05', 'SUBSCRIBE_TEMPLATE')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(69539118475360417)
,p_plug_name=>'Layout'
,p_region_name=>'FORM_TABLE_ATTRIBUTES'
,p_parent_plug_id=>wwv_flow_imp.id(4546372471032502)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(164213211890458701)
,p_plug_name=>'Definition'
,p_region_name=>'DEFINITION'
,p_parent_plug_id=>wwv_flow_imp.id(4546372471032502)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(166001904678450845)
,p_plug_name=>'Substitution Strings'
,p_region_name=>'SUBSTITUTION_STRINGS'
,p_parent_plug_id=>wwv_flow_imp.id(4546372471032502)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>150
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_region_layout.region_template_substitution(',
'   p_flow=>:FB_FLOW_ID,',
'   p_template_id=>:F4000_P4653_ID );'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_header=>'Substitution strings are used within templates to reference component values.  This report details substitution string usage for this template.'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(170537816680150865)
,p_plug_name=>'Sub Regions'
,p_region_name=>'SUB_REGIONS'
,p_parent_plug_id=>wwv_flow_imp.id(4546372471032502)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(266470409881026219)
,p_plug_name=>'Slots'
,p_region_name=>'DISPLAY_POINT'
,p_parent_plug_id=>wwv_flow_imp.id(4546372471032502)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>130
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select "ROWID",',
'       "ID",',
'       "FLOW_ID",',
'       "PLUG_TEMPLATE_ID",',
'       "NAME",',
'       "PLACEHOLDER",',
'       "HAS_GRID_SUPPORT",',
'       "HAS_REGION_SUPPORT",',
'       "HAS_ITEM_SUPPORT",',
'       "HAS_BUTTON_SUPPORT",',
'       "GLV_NEW_ROW",',
'       "MAX_FIXED_GRID_COLUMNS"',
'  from wwv_flow_plug_tmpl_disp_points',
' where flow_id           = :FB_FLOW_ID',
'   and plug_template_id  = :F4000_P4653_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_plug_source_type=>'NATIVE_IG'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'F4000_P4653_ID'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Slots'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Create slots for this region template. Slots allow to identify where components (regions, items, buttons) will be displayed on this region template.',
'<br />',
'Slots can be used to restrict the placement of regions, items and buttons on this region template by configuring which component type is supported in a slot.',
'<br />',
'The <strong>Template Substitution</strong> of a slot cannot be one of the reserved page substitution strings, eg. REGION_STATIC_ID. See section <strong>Substitution Strings</strong> below for a complete list.'))
);
wwv_flow_imp_page.create_region_column_group(
 p_id=>wwv_flow_imp.id(6452467564509957)
,p_heading=>'Grid Layout Rendering'
);
wwv_flow_imp_page.create_region_column_group(
 p_id=>wwv_flow_imp.id(8660831823247939)
,p_heading=>'Component Type Support'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(4312819678030113)
,p_name=>'PLUG_TEMPLATE_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'PLUG_TEMPLATE_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>60
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'F4000_P4653_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(4312983675030114)
,p_name=>'APEX$ROW_ACTION'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>20
,p_use_as_row_header=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(4313073125030115)
,p_name=>'APEX$ROW_SELECTOR'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_use_as_row_header=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6451067662509943)
,p_name=>'ROWID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ROWID'
,p_data_type=>'ROWID'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>30
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_is_primary_key=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6451103977509944)
,p_name=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FLOW_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>50
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'FB_FLOW_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6451371845509946)
,p_name=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Slot Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>70
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_max_length=>30
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6451423619509947)
,p_name=>'PLACEHOLDER'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'PLACEHOLDER'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Template Substitution'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>80
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_attribute_06=>'UPPER'
,p_is_required=>true
,p_max_length=>30
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6451501676509948)
,p_name=>'HAS_GRID_SUPPORT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'HAS_GRID_SUPPORT'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SINGLE_CHECKBOX'
,p_heading=>'Grid Support'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>120
,p_value_alignment=>'CENTER'
,p_group_id=>wwv_flow_imp.id(6452467564509957)
,p_use_group_for=>'BOTH'
,p_attribute_01=>'Y'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'Y'
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6451639993509949)
,p_name=>'HAS_REGION_SUPPORT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'HAS_REGION_SUPPORT'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SINGLE_CHECKBOX'
,p_heading=>'Regions'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>90
,p_value_alignment=>'CENTER'
,p_group_id=>wwv_flow_imp.id(8660831823247939)
,p_use_group_for=>'BOTH'
,p_attribute_01=>'Y'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'Y'
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6451697986509950)
,p_name=>'HAS_ITEM_SUPPORT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'HAS_ITEM_SUPPORT'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SINGLE_CHECKBOX'
,p_heading=>'Items'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>100
,p_value_alignment=>'CENTER'
,p_group_id=>wwv_flow_imp.id(8660831823247939)
,p_use_group_for=>'BOTH'
,p_attribute_01=>'Y'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'N'
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6451834740509951)
,p_name=>'HAS_BUTTON_SUPPORT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'HAS_BUTTON_SUPPORT'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SINGLE_CHECKBOX'
,p_heading=>'Buttons'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>110
,p_value_alignment=>'CENTER'
,p_group_id=>wwv_flow_imp.id(8660831823247939)
,p_use_group_for=>'BOTH'
,p_attribute_01=>'Y'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'N'
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6451899705509952)
,p_name=>'GLV_NEW_ROW'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'GLV_NEW_ROW'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SINGLE_CHECKBOX'
,p_heading=>'New Row'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>140
,p_value_alignment=>'CENTER'
,p_group_id=>wwv_flow_imp.id(6452467564509957)
,p_use_group_for=>'BOTH'
,p_attribute_01=>'Y'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'Y'
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6452053349509953)
,p_name=>'MAX_FIXED_GRID_COLUMNS'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'MAX_FIXED_GRID_COLUMNS'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>'Maximum Fixed Grid Columns	'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>130
,p_value_alignment=>'RIGHT'
,p_group_id=>wwv_flow_imp.id(6452467564509957)
,p_use_group_for=>'BOTH'
,p_attribute_03=>'right'
,p_attribute_04=>'decimal'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(11786183328314002)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>40
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>false
,p_include_in_export=>false
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(6450924169509942)
,p_internal_uid=>6450924169509942
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_add_row_if_empty=>true
,p_submit_checked_rows=>false
,p_lazy_loading=>true
,p_requires_filter=>false
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>true
,p_show_toolbar=>true
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>true
,p_define_chart_view=>true
,p_enable_download=>true
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(6462635633527704)
,p_interactive_grid_id=>wwv_flow_imp.id(6450924169509942)
,p_static_id=>'21135'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(6462820715527707)
,p_report_id=>wwv_flow_imp.id(6462635633527704)
,p_view_type=>'GRID'
,p_stretch_columns=>true
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(4358302348234287)
,p_view_id=>wwv_flow_imp.id(6462820715527707)
,p_display_seq=>13
,p_column_id=>wwv_flow_imp.id(4312819678030113)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(4370293982323741)
,p_view_id=>wwv_flow_imp.id(6462820715527707)
,p_display_seq=>0
,p_column_id=>wwv_flow_imp.id(4312983675030114)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(6463300577527715)
,p_view_id=>wwv_flow_imp.id(6462820715527707)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(6451067662509943)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(6464238886527721)
,p_view_id=>wwv_flow_imp.id(6462820715527707)
,p_display_seq=>2
,p_column_id=>wwv_flow_imp.id(6451103977509944)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(6466019813527727)
,p_view_id=>wwv_flow_imp.id(6462820715527707)
,p_display_seq=>4
,p_column_id=>wwv_flow_imp.id(6451371845509946)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>350
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(6466948052527729)
,p_view_id=>wwv_flow_imp.id(6462820715527707)
,p_display_seq=>5
,p_column_id=>wwv_flow_imp.id(6451423619509947)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>350
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(6467802327527732)
,p_view_id=>wwv_flow_imp.id(6462820715527707)
,p_display_seq=>9
,p_column_id=>wwv_flow_imp.id(6451501676509948)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>100
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(6468741015527734)
,p_view_id=>wwv_flow_imp.id(6462820715527707)
,p_display_seq=>6
,p_column_id=>wwv_flow_imp.id(6451639993509949)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>100
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(6469622257527737)
,p_view_id=>wwv_flow_imp.id(6462820715527707)
,p_display_seq=>7
,p_column_id=>wwv_flow_imp.id(6451697986509950)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>100
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(6470578102527739)
,p_view_id=>wwv_flow_imp.id(6462820715527707)
,p_display_seq=>8
,p_column_id=>wwv_flow_imp.id(6451834740509951)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>100
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(6471417719527742)
,p_view_id=>wwv_flow_imp.id(6462820715527707)
,p_display_seq=>12
,p_column_id=>wwv_flow_imp.id(6451899705509952)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>130
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(6472359150527745)
,p_view_id=>wwv_flow_imp.id(6462820715527707)
,p_display_seq=>10
,p_column_id=>wwv_flow_imp.id(6452053349509953)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>215
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(11792218441318935)
,p_view_id=>wwv_flow_imp.id(6462820715527707)
,p_display_seq=>14
,p_column_id=>wwv_flow_imp.id(11786183328314002)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(932807207016193716)
,p_plug_name=>'Subscription'
,p_parent_plug_id=>wwv_flow_imp.id(4546372471032502)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P4653_THEME_IS_SUBSCRIBED = ''BOTH'' then',
'     sys.htp.p(wwv_flow_lang.system_message(''TEMPLATE_SUBSCRIPTION.THEME_AND_TEMPLATE_SUBSCRIBED''));',
'else',
'     sys.htp.p(wwv_flow_lang.system_message(''TEMPLATE_SUBSCRIPTION.THEME_SUBSCRIBED''));',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P4653_THEME_IS_SUBSCRIBED'
,p_plug_display_when_cond2=>'NONE'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'N',
  'attribute_02', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1094586036782933029)
,p_plug_name=>'JavaScript'
,p_parent_plug_id=>wwv_flow_imp.id(4546372471032502)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1094586347046933032)
,p_plug_name=>'Cascading Style Sheet'
,p_parent_plug_id=>wwv_flow_imp.id(4546372471032502)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>120
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(92906206971788557)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>100
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(153210815104527139)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(117326511432403116)
,p_plug_name=>'Hidden'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(170543402060241250)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>130
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(615306603461492922)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_imp.id(29434107863295859)
,p_plug_display_sequence=>160
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from  WWV_FLOW_PAGE_PLUG_TEMPLATES',
'where id = :F4000_P4653_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :F4000_P4653_ID,',
'      p_component_type => ''List Entry'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(57515028086887716)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(686703536)
,p_button_name=>'APPLY_CHANGES_GET_PREVIOUS_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'disabled=""'
,p_button_comment=>'javascript:htmldb_goSubmit(''GET_PREVIOUS_ID'')'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(57514913787887716)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_imp.id(686703536)
,p_button_name=>'APPLY_CHANGES_GET_NEXT_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Next'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'disabled=""'
,p_button_comment=>'javascript:htmldb_goSubmit(''GET_NEXT_ID'')'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(166448303431073862)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(33424815586234511)
,p_button_name=>'PUBLISH_TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Publish Template'
,p_button_position=>'COPY'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.::F4000_P149_ID,F4000_P149_PAGE_ID,F4000_P149_TEMPLATE_TYPE:&F4000_P4653_ID.,&FLOW_PAGE_ID.,REGION_TEMPLATE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_page_plug_templates',
'where reference_id = :F4000_P4653_ID',
'and security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(164060102283696912)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(33424815586234511)
,p_button_name=>'COPY_TEMPLATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Refresh'
,p_button_position=>'COPY'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_page_plug_templates',
'where id = :F4000_P4653_ID',
'and reference_id is not null',
'and security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3610655866)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(686703536)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3611655866)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(686703536)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:307:&SESSION.::&DEBUG.::P307_ID:&F4000_P4653_ID.'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P4653_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_comment=>'javascript:confirmDelete(''&DELETE_MSG.'');'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3612655867)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(686703536)
,p_button_name=>'Apply_Changes'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P4653_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3613655867)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(686703536)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P4653_ID is null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(11872344369758401)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_imp.id(25494159951442861)
,p_button_name=>'OPTION_GROUPS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Template Option Groups'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:81:&SESSION.::&DEBUG.:CR,81:P81_THEME_ID,P81_TEMPLATE_TYPE:&P4653_THEME.,REGION'
,p_button_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(30855228922454855)
,p_branch_name=>'Go To Page 149'
,p_branch_action=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.::F4000_P149_ID,F4000_P149_TEMPLATE_TYPE,F4000_P149_PAGE_ID:&F4000_P4653_ID.,REGION_TEMPLATE,4653'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P4653_PUBLISH'
,p_branch_condition_text=>'Y'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(57520814607887767)
,p_branch_action=>'f?p=&APP_ID.:4653:&SESSION.::&DEBUG.::F4000_P4653_ID:&P4653_ID_NEXT.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(57514913787887716)
,p_branch_sequence=>20
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(57521200495887768)
,p_branch_action=>'f?p=&APP_ID.:4653:&SESSION.::&DEBUG.::F4000_P4653_ID:&P4653_ID_PREV.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(57515028086887716)
,p_branch_sequence=>30
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(57647007515633459)
,p_branch_action=>'f?p=&FLOW_ID.:4653:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'F4000_P4653_RETURN_TO_PAGE'
,p_branch_condition_text=>'YES'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(164060500846696916)
,p_branch_name=>'Go To Page 4653'
,p_branch_action=>'f?p=&APP_ID.:4653:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(164060102283696912)
,p_branch_sequence=>50
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(352622128785729197)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>60
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3617655868)
,p_name=>'F4000_P4653_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(117326511432403116)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3619655869)
,p_name=>'F4000_P4653_REGION_TEMPL_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(687705197)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>'PAGE_PLUG_TEMPLATE_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'Identifies a name for this template.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3620655869)
,p_name=>'F4000_P4653_TEMPLATE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(164213211890458701)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Template'
,p_source=>'TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>16
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Region templates provide the appearance for a portion of a page called a region. Use substitution strings to indicate the existence and placement of a component within the region.</div>',
'<div class="htmldbInfoBodyP">#BODY# is the only required substitution string. It identifies where the source of the region should be placed. All other substitution strings are optional.</div>',
'<div class="htmldbInfoBodyP">The following are valid substitution strings:',
'<ul class="noIndent">',
'<li>#TITLE#</li>',
'<li>#PAGE_TITLE#</li>',
'<li>#EXPAND#</li>',
'<li>#CHANGE#</li>',
'<li>#BODY#</li>',
'<li>#SUB_REGION_HEADERS#</li>',
'<li>#SUB_REGIONS#</li>',
'<li>#FORM_OPEN#</li> ',
'<li>#FORM_CLOSE#</li>',
'<li>#REGION_ID#</li>',
'<li>#REGION_STATIC_ID#</li>',
'<li>#REGION_CSS_CLASSES#</li>',
'<li>#REGION_ATTRIBUTES#</li>',
'<li>#REGION_HEADER#</li>',
'<li>#REGION_FOOTER#</li>',
'<li>#REGION_IMAGE#</li>',
'<li>#REGION_IMAGE_URL#</li>',
'<li>#REGION_IMAGE_ALT_TEXT#</li>',
'<li>#REGION_IMAGE_ATTRIBUTES#</li>',
'<li>#REGION_LANDMARK_ATTRIBUTES#</li>',
'</ul>',
'</div>',
'<div class="htmldbInfoBodyP">You can also use the following substitution strings to specify slots of buttons within this region:</div>',
'<ul class="noIndent">',
'<li>#EDIT#</li>',
'<li>#CLOSE#</li>',
'<li>#CREATE#</li>',
'<li>#CREATE2#</li>',
'<li>#EXPAND#</li>',
'<li>#HELP#</li>',
'<li>#DELETE#</li>',
'<li>#COPY#</li>',
'<li>#NEXT#</li>',
'<li>#PREVIOUS#</li>',
'</ul>'))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3621655869)
,p_name=>'F4000_P4653_TEMPLATE_COMMENT'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(689725477)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comments'
,p_source=>'TEMPLATE_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'<div class="htmldbInfoBodyP">Developer comments or notes. These comments never display when the application is running.</div>'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6902842551389926)
,p_name=>'P4653_DEFAULT_LANDMARK_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(6902767343389925)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Default Landmark Type'
,p_source=>'DEFAULT_LANDMARK_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC:Banner;banner,Complementary;complementary,Content Info;contentinfo,Form;form,Main;main,Navigation;navigation,Region;region,Search;search'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Default Landmark -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Define the default landmark type to be used for this region template. When this region template is used by a region, this will be the landmark type exposed to screen reader users, unless this has been overridden at region level.</p>',
'<p>Note: In order for this functionality to work, the Template attribute must include the <code>#REGION_LANDMARK_ATTRIBUTES#</code> substitution string. This should be defined on the main container element of the template.</p>',
'<p>Landmarks provide a powerful way to identify the organization and structure of a web page. The structural information conveyed visually to users should be represented programmatically in the markup using landmark roles. The use of landmarks roles '
||'support keyboard navigation to the structure of a web page for screen reader users, and can be used as targets for browser extensions for enhanced keyboard navigation.</p>',
'<p>The <a rel="noopener noreferrer" target="_blank" href="https://www.w3.org/WAI/ARIA/apg/example-index/landmarks/index.html">W3C ARIA Landmarks site</a> provides useful information, including a good reference implementation (click on the ''Show Landm'
||'arks'' button to visualize well defined landmarks).</p>'))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6902964986389927)
,p_name=>'P4653_REGION_TITLE_DOM_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(6902767343389925)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Region Title HTML ID'
,p_source=>'REGION_TITLE_DOM_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The ID of the element that contains the region title (for example, the #TITLE# substitution string).</p>',
'<p>This is used by the region landmark support, to determine if <code>aria-labelledby</code> or <code>aria-label</code> is used to label the landmark.</p>',
'<p>If the landmark is labelled using the region title and this attribute is defined, the landmark can be labelled by <code>aria-labelledby</code>. If this is not defined, or the region overrides with a custom landmark label, then <code>aria-label</co'
||'de> will be used.</p>',
'<p>Note: You can use the <code>#REGION_STATIC_ID#</code> substitution string to refer to the region''s static ID.</p>',
'<p>Note: In order for this functionality to work, the Template attribute must include the <code>#REGION_LANDMARK_ATTRIBUTES#</code> substitution string. This should be defined on the main container element of the template.</p>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11872727394758405)
,p_name=>'P4653_PRESET_TEMPLATE_OPTIONS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(25494159951442861)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Preset Template Options:'
,p_source=>'PRESET_TEMPLATE_OPTIONS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.TEMPALTE_OPT_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.display_name as d,',
'       o.css_classes as r,',
'       null default_template_options,',
'       null,',
'       o.help_text,',
'       g.display_name group_name,',
'       g.is_advanced advanced_group,',
'       g.null_text null_text ',
'  from wwv_flow_template_options o,',
'       wwv_flow_template_opt_groups g,',
'       wwv_flow_page_plug_templates t',
' where o.flow_id             = :fb_flow_id',
'   and o.template_types      = ''REGION''',
'   and t.security_group_id   = o.security_group_id',
'   and t.security_group_id   = :workspace_id',
'   and (o.region_template_id = :f4000_p4653_id or o.region_template_id is null)',
'   and t.theme_id            = o.theme_id',
'   and t.id                  = :f4000_p4653_id',
'   and g.id             (+)  = o.group_id',
' order by ',
'       g.is_advanced nulls first,',
'       g.display_sequence nulls first,',
'       g.display_name nulls first,',
'       o.display_sequence,',
'       o.display_name'))
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_attribute_02=>'N'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11873185303758407)
,p_name=>'P4653_DEFAULT_TEMPLATE_OPTIONS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(25494159951442861)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Default Template Options:'
,p_source=>'DEFAULT_TEMPLATE_OPTIONS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.TEMPALTE_OPT_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.display_name as d,',
'       o.css_classes as r,',
'       t.default_template_options,',
'       null,',
'       o.help_text,',
'       g.display_name group_name',
'  from wwv_flow_template_options o,',
'       wwv_flow_template_opt_groups g,',
'       wwv_flow_page_plug_templates t',
' where o.flow_id               = :fb_flow_id',
'   and o.security_group_id     = :flow_security_group_id',
'   and t.security_group_id     = :flow_security_group_id',
'   and t.id                    = o.region_template_id',
'   and o.region_template_id    = :f4000_p4653_id',
'   and g.id                (+) = o.group_id',
'   and g.security_group_id (+) = :flow_security_group_id',
' order by',
'       g.display_sequence nulls first,',
'       g.display_name nulls first,',
'       o.display_sequence,',
'       o.display_name'))
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11873503265758407)
,p_name=>'P4653_PRESET_TMPLOPT_CHECK'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(25494159951442861)
,p_use_cache_before_default=>'NO'
,p_source=>'P4653_PRESET_TEMPLATE_OPTIONS'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12774423472920724)
,p_name=>'F4000_P4653_RETURN_TO_PAGE'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(688720308)
,p_prompt=>'Stay on Page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select this checkbox to stay on this page after applying changes.'
,p_attribute_01=>'N'
,p_attribute_02=>'YES'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(24146906189471199)
,p_name=>'P4653_TRANSLATABLE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(687705197)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Translatable'
,p_source=>'TRANSLATE_THIS_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(25015876110379147)
,p_name=>'P4653_IMAGE_TEMPLATE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(25015589019379144)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Template'
,p_source=>'IMAGE_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>10
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">The Image template provides the possibility of defining a region image with additional HTML code.</div>',
'<div class="htmldbInfoBodyP">#REGION_IMAGE_URL# is the only required substitution string and should be used within an img HTML tag. It specifies the img src attribute. All other substitution strings are optional.</div>',
'<div class="htmldbInfoBodyP">The following are valid substitution strings:',
'<ul class="noIndent">',
'<li>#REGION_IMAGE_URL#</li>',
'<li>#REGION_IMAGE_ALT_TEXT#</li>',
'<li>#REGION_IMAGE_ATTRIBUTES#</li>',
'<li>#REGION_ID#</li>',
'<li>#REGION_STATIC_ID#</li>',
'</ul>',
'</div>',
'<div class="htmldbInfoBodyP">Use #REGION_IMAGE# in the region template to place the output of this template.</div>',
''))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30854803942419329)
,p_name=>'P4653_PUBLISH'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(688720308)
,p_prompt=>'Publish on Save'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select this checkbox to publish the template when you apply your changes.'
,p_attribute_01=>'N'
,p_attribute_02=>'PUBLISH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(34404508114932740)
,p_name=>'F4000_P4653_REFRESH'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(33424815586234511)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Refresh'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_page_plug_templates',
'where reference_id is null',
'and id = :F4000_P4653_ID',
'and security_group_id = :WORKSPACE_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40811004586362518)
,p_name=>'P4653_N'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(686703536)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select PAGE_PLUG_TEMPLATE_NAME from WWV_FLOW_PAGE_PLUG_TEMPLATES',
' where id = :F4000_P4653_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies template name'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(41994108838502830)
,p_name=>'P4653_THEME'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_imp.id(687705197)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Theme:'
,p_source=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the theme to which this template is associated. A theme is a grouping of templates which together provide layout and style for an application.'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(42008624431583032)
,p_name=>'P4653_THEME_CLASS'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(687705197)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Template Class'
,p_source=>'THEME_CLASS_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REGION THEME CLASS ID'
,p_lov=>'.'||wwv_flow_imp.id(42003622222572861)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Not Identified -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Identifies a specific usage for this template.</div>',
'<div class="htmldbInfoBodyP">When you switch to a new theme, all templates in one theme are assigned to corresponding templates in another theme. App Builder accomplishes this template mapping through the assignment of template class identifiers.<p /'
||'>',
'Use the <strong>Translatable</strong> check box to indicate that the template contains text strings that require translation. ',
'</div>'))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57518300201887745)
,p_name=>'P4653_ID_NEXT'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(689725477)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57518731059887749)
,p_name=>'P4653_ID_PREV'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(689725477)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57519105074887750)
,p_name=>'P4653_ID_COUNT'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(686703536)
,p_prompt=>'Region Template'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Click next and previous buttons to navigate between templates.'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(69546102516367776)
,p_name=>'F4000_P4653_TEMPLATE2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(69539118475360417)
,p_use_cache_before_default=>'NO'
,p_prompt=>'HTML Table Attributes:  Used when rendering items within regions to control formatting.'
,p_source=>'TEMPLATE2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>96
,p_cMaxlength=>255
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Page items display within regions. Each item is part of an HTML table if the layout type in the page template is set to "Table". You can set the attributes of this table using this attribute.</div>',
'<div class="htmldbInfoBodyP">For example:</div>',
'<pre>class="instructiontext"</pre>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(164022700752309091)
,p_name=>'F4000_P4653_REFERENCE_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(33424815586234511)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Reference Master Template From'
,p_source=>'REFERENCE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FLOW_SUBSCRIBE_FROM_REGION_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select flow_id||'' : ''||page_plug_template_name||decode(theme_id,null,'''','' (''||theme_id||'')'') d, id r',
'from   wwv_flow_page_plug_templates',
'where  flow_id != nvl(:fb_flow_id,0) and flow_id in (',
'select f.id',
'from   wwv_main_apps_dev f',
'where  security_group_id = :flow_security_group_id and',
'       build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') and',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and ( flow_id is null or flow_id = f.id ) and security_group_id = :flow_security_group_id)',
')',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Template -'
,p_cSize=>50
,p_cMaxlength=>2000
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">You may select an existing template in this application or another template in your workspace schema. By selecting an existing template, you become a subscriber to that template.</div>',
'<div class="htmldbInfoBodyP">To load a new copy of any master template, click <span class="fielddatabold">Refresh</span>.</div>',
''))
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(170538701358165364)
,p_name=>'P4653_SUB_PLUG_HEADER_TEMPLATE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(170537816680150865)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Header Template'
,p_source=>'SUB_PLUG_HEADER_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Sub region header templates together with sub region header entry templates provide the possibility to generate a list of region titles of all the sub regions of the current region.</div>',
'<div class="htmldbInfoBodyP">#ENTRIES# is the only required substitution string. It identifies where the sub region header entries should be placed. All other substitution strings are optional.</div>',
'<div class="htmldbInfoBodyP">The following are valid substitution strings:',
'<ul class="noIndent">',
'<li>#ENTRIES#</li>',
'<li>#REGION_ID#</li>',
'<li>#REGION_STATIC_ID#</li>',
'</ul>',
'</div>',
'<div class="htmldbInfoBodyP">Use #SUB_REGION_HEADERS# in the region template to place the output of this template.</div>',
''))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(170539214995178768)
,p_name=>'P4653_HEADER_ENTRY_TEMPLATE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(170537816680150865)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Header Entry Template'
,p_source=>'SUB_PLUG_HEADER_ENTRY_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>3
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Sub region header entry templates together with the sub region header templates provide the possibility to generate a list of region titles of all the sub regions of the current region.</div>',
'<div class="htmldbInfoBodyP">The following are valid substitution strings:',
'<ul class="noIndent">',
'<li>#SUB_REGION_ID#</li>',
'<li>#SUB_REGION_TITLE#</li>',
'<li>#REGION_ID#</li>',
'<li>#REGION_STATIC_ID#</li>',
'</ul>',
'</div>',
'<div class="htmldbInfoBodyP">Use #ENTRIES# in the sub region header template to place the output of this template.</div>',
''))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(170539727462182389)
,p_name=>'P4653_SUB_PLUG_TEMPLATE'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(170537816680150865)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Template'
,p_source=>'SUB_PLUG_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>10
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Sub Region templates provide the possibility to wrap the sub regions with additional HTML code.</div>',
'<div class="htmldbInfoBodyP">#SUB_REGION# is the only required substitution string. It identifies where the source of the sub region should be placed. All other substitution strings are optional.</div>',
'<div class="htmldbInfoBodyP">The following are valid substitution strings:',
'<ul class="noIndent">',
'<li>#SUB_REGION#</li>',
'<li>#SUB_REGION_ID#</li>',
'<li>#SUB_REGION_TITLE#</li>',
'<li>#REGION_ID#</li>',
'<li>#REGION_STATIC_ID#</li>',
'</ul>',
'</div>',
'<div class="htmldbInfoBodyP">Use #SUB_REGIONS# in the region template to place the output of this template.</div>',
''))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1094586109106933030)
,p_name=>'P4653_JAVASCRIPT_FILE_URLS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1094586036782933029)
,p_use_cache_before_default=>'NO'
,p_prompt=>'File URLs'
,p_source=>'JAVASCRIPT_FILE_URLS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter JavaScript file URLs for code to be loaded on this page. Each URL has to be written into a new line. If you provide a minified version of your file you can use the substitution string <code>#MIN#</code> to include <code>.min</code> or <code>'
||'#MIN_DIRECTORY#</code> to include <code>minified/</code> in your file URL for a regular page view and an empty string if the page is viewed in debug mode. You also have access to the substitution string <code>#APP_VERSION#</code> if you want to inclu'
||'de the application''s version in the file URL.</p>',
'',
'<p>Note: You do not need to include opening or closing <code>script</code> tags. Just write the URL.',
'',
'<p>',
'Examples:',
'<ul>',
'  <li>Standard file reference',
'      <pre>/myjs/main.js</pre>',
'  </li>',
'  <li>Standard file reference which loads the minified file main.min.js from /myjs/minified/ for regular page views and main.js from /myjs/ in debug mode.',
'      <pre>/myjs/#MIN_DIRECTORY#main#MIN#.js</pre>',
'  </li>',
'  <li>Use this syntax if the library is also used from a RequireJS require call. The define name must match what is used in the requirejs.config paths and the value must be the global symbol exposed by the library. Only applies when using RequireJS. '
||'This avoids RequireJS  loading that library a second time.',
'      <pre>[define hammerjs=Hammer]/myjs/hammer.js</pre>',
'  </li>',
'  <li>Use this syntax if the file has a dependency on RequireJS. This will automatically load RequireJS before this file.',
'      <pre>[require requirejs]/myjs/main.js</pre>',
'  </li>',
'  <li>Use this syntax if the file has a dependency on Oracle JET. This will automatically load RequireJS and the Oracle JET RequireJS configuration before this file.',
'      <pre>[require jet]/myjs/main.js</pre>',
'  </li>',
'  <li>File reference using a query string in the URL referencing the application version, such that when the application is upgraded (and the version is incremented), the browser will be instructed to always load the new file and ignore any previousl'
||'y cached files.',
'      <pre>/myjs/main.js?version=#APP_VERSION#</pre>',
'  </li>',
'</ul>',
'</p>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1094586251166933031)
,p_name=>'P4653_JAVASCRIPT_CODE_ONLOAD'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1094586036782933029)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Execute when Page Loads'
,p_source=>'JAVASCRIPT_CODE_ONLOAD'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cHeight=>15
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter JavaScript code to execute when the page loads. The code is executed after the JavaScript code generated by &PRODUCT_NAME..</p>',
'',
'<p>Note: You do not need to add any opening or closing <code>script</code> tags, just the JavaScript code.</p>',
''))
,p_attribute_01=>'JAVASCRIPT'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1094586405660933033)
,p_name=>'P4653_CSS_FILE_URLS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1094586347046933032)
,p_use_cache_before_default=>'NO'
,p_prompt=>'File URLs'
,p_source=>'CSS_FILE_URLS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter Cascading Style Sheet file URLs to be loaded for this page template. Each URL has to be written into a new line. If you provide a minified version of your file you can use the substitution string <code>#MIN#</code> to include <code>.min</cod'
||'e> or <code>#MIN_DIRECTORY#</code> to include <code>minified/</code> in your file URL for a regular page view and an empty string if the page is viewed in debug mode. You also have access to the substitution string <code>#APP_VERSION#</code> if you w'
||'ant to include the application''s version in the file URL.</p>',
'',
'<p>Note: You do not need to include opening or closing <code>link</code> tags. Just include the file URL.</p>',
'',
'<p>',
'Examples:',
'<ul>',
'  <li>Standard file reference',
'      <pre>/mycss/main.css</pre>',
'  </li>',
'  <li>Standard file reference which loads the minified file main.min.css from /mycss/minified/ for regular page views and main.css from /mycss/ in debug mode.',
'      <pre>/mycss/#MIN_DIRECTORY#main#MIN#.css</pre>',
'  </li>',
'  <li>Conditional media query',
'      <pre>[media="only screen and (max-device-width: 480px)"]/mycss/smartphone.css</pre>',
'  </li>',
'  <li>File reference using a query string in the URL referencing the application version, such that when the application is upgraded (and the version is incremented), the browser will be instructed to always load the new file and ignore any previousl'
||'y cached files.',
'      <pre>/mycss/main.css?version=#APP_VERSION#</pre>',
'  </li>',
'</ul>',
'</p>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1331350003570223302)
,p_name=>'P4653_INTERNAL_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(687705197)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Identifier'
,p_source=>'INTERNAL_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Template identifier, this is used when switching and upgrading themes and cannot be modified.'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2104768030368830011)
,p_name=>'P4653_THEME_IS_SUBSCRIBED'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(687705197)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2104768571245833700)
,p_computation_sequence=>10
,p_computation_item=>'P4653_THEME_IS_SUBSCRIBED'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'    l_is_subscribed varchar2(16) := ''NONE'';',
'begin',
'  ',
'    for c1 in (',
'        select t.reference_id template_ref_id, th.reference_id theme_ref_id',
'        from wwv_flow_page_plug_templates t, wwv_flow_themes th',
'        where t.id = :F4000_P4653_ID',
'        and t.security_group_id = th.security_group_id',
'        and t.security_group_id = :WORKSPACE_ID',
'        and t.flow_id = th.flow_id',
'        and t.theme_id = th.theme_id',
'    ) loop',
'        if c1. theme_ref_id is not null then',
'            if c1.template_ref_id is not null then',
'                l_is_subscribed := ''BOTH'';',
'            else ',
'                l_is_subscribed := ''THEME'';',
'            end if;',
'        end if;    ',
'    end loop;',
'',
'    return l_is_subscribed;',
'',
'end;'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(34460128768983948)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P4653_REFRESH'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'Unable to compute item value.'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(164067032755719714)
,p_validation_name=>'reference id not null'
,p_validation_sequence=>10
,p_validation=>'F4000_P4653_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Reference ID must be specified to refresh the template.'
,p_when_button_pressed=>wwv_flow_imp.id(164060102283696912)
,p_associated_item=>wwv_flow_imp.id(164022700752309091)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(150712331006210623)
,p_validation_name=>'TemplateNameMand'
,p_validation_sequence=>30
,p_validation=>'F4000_P4653_REGION_TEMPL_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Template Name must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(3612655867)
,p_associated_item=>wwv_flow_imp.id(3619655869)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(73941510767235924)
,p_validation_name=>'unique template name'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_page_plug_templates',
' where flow_id                 = :fb_flow_id',
'   and security_group_id       = :workspace_id',
'   and theme_id                = :P4653_THEME',
'   and page_plug_template_name = :F4000_P4653_REGION_TEMPL_NAME',
'   and id                     != :F4000_P4653_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#LABEL# must be unique.'
,p_when_button_pressed=>wwv_flow_imp.id(3612655867)
,p_associated_item=>wwv_flow_imp.id(3619655869)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(177290555869915732)
,p_tabular_form_region_id=>wwv_flow_imp.id(266470409881026219)
,p_validation_name=>'Slots - Reserved template substitutions'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
':placeholder not in (',
'    ''TOP'',',
'    ''TOP_AND_BOTTOM'',',
'    ''ABOVE_BOX'',',
'    ''TEMPLATE_DEFAULT'',',
'    ''BELOW_BOX'',',
'    ''BOTTOM'',',
'    ''RIGHT_OF_IR_SEARCH_BAR'',',
'    ''LEFT_OF_TITLE'',',
'    ''RIGHT_OF_TITLE'',',
'    ''ENTRIES'',',
'    ''FIRST_ROW_FETCHED'',',
'    ''FORM_CLOSE'',',
'    ''FORM_OPEN'',',
'    ''ICON_CSS_CLASSES'',',
'    ''INTERNET_PAGINATION'',',
'    ''LAST_ROW_FETCHED'',',
'    ''PAGE_TITLE'',',
'    ''REGION_ATTRIBUTES'',',
'    ''REGION_CSS_CLASSES'',',
'    ''REGION_FOOTER'',',
'    ''REGION_HEADER'',',
'    ''REGION_ID'',',
'    ''REGION_SEQUENCE_ID'',',
'    ''REGION_STATIC_ID'',',
'    ''REGION_LANDMARK_ATTRIBUTES'',',
'    ''ROW_RANGES'',',
'    ''ROW_RANGES_IN_SELECT_LIST'',',
'    ''ROWS_FETCHED'',',
'    ''SUB_REGION_HEADERS'',',
'    ''SUB_REGION_ICON_CSS_CLASSES'',',
'    ''SUB_REGION_ID'',',
'    ''SUB_REGION_TITLE'',',
'    ''TIMING'',',
'    ''TITLE'',',
'    ''TOTAL_ROWS'' )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'This is a reserved template substitution.'
,p_validation_condition=>'F4000_P4653_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_exec_cond_for_each_row=>'Y'
,p_associated_column=>'PLACEHOLDER'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(11786006001314001)
,p_tabular_form_region_id=>wwv_flow_imp.id(266470409881026219)
,p_validation_name=>'Slots - No duplicates placeholders'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plug_tmpl_disp_points',
' where flow_id           = :FB_FLOW_ID',
'   and plug_template_id  = :F4000_P4653_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and placeholder       = :placeholder',
'   and id               != nvl(:id, 0)'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#COLUMN_HEADER# must be unique.'
,p_validation_condition=>'F4000_P4653_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_column=>'PLACEHOLDER'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(13086311382499020)
,p_tabular_form_region_id=>wwv_flow_imp.id(20915676136405505)
,p_validation_name=>'Template Options - No duplicates name'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_template_options',
' where flow_id              = :FB_FLOW_ID',
'   and theme_id             = :P4653_THEME',
'   and region_template_id   = :F4000_P4653_ID',
'   and security_group_id    = :WORKSPACE_ID',
'   and name                 = :NAME',
'   and template_types       = :TEMPLATE_TYPES',
'   and (:ID is null or id != :ID)'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#COLUMN_HEADER# must be unique.'
,p_validation_condition=>'F4000_P4653_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_exec_cond_for_each_row=>'Y'
,p_associated_column=>'NAME'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(11881043929758422)
,p_tabular_form_region_id=>wwv_flow_imp.id(20915676136405505)
,p_validation_name=>'Template Options - No duplicates classes'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_template_options',
' where flow_id              = :FB_FLOW_ID',
'   and theme_id             = :P4653_THEME',
'   and region_template_id   = :F4000_P4653_ID',
'   and security_group_id    = :WORKSPACE_ID',
'   and css_classes          = :CSS_CLASSES',
'   and template_types       = :TEMPLATE_TYPES',
'   and (:ID is null or id != :ID)'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#COLUMN_HEADER# must be unique.'
,p_validation_condition=>'F4000_P4653_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_exec_cond_for_each_row=>'Y'
,p_associated_column=>'CSS_CLASSES'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(11786689935314007)
,p_tabular_form_region_id=>wwv_flow_imp.id(266470409881026219)
,p_validation_name=>'Slots - No duplicates names'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_plug_tmpl_disp_points',
' where flow_id           = :FB_FLOW_ID',
'   and plug_template_id  = :F4000_P4653_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and name              = :name',
'   and id               != nvl(:id, 0)'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#COLUMN_HEADER# must be unique.'
,p_validation_condition=>'F4000_P4653_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_column=>'NAME'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(231753253789461230)
,p_tabular_form_region_id=>wwv_flow_imp.id(266470409881026219)
,p_validation_name=>'Slots - At least one component type'
,p_validation_sequence=>110
,p_validation=>':has_region_support = ''Y'' or :has_item_support = ''Y'' or :has_button_support = ''Y'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Slot must support at least one component type (region, item or button).'
,p_validation_condition=>'F4000_P4653_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_column=>'PLACEHOLDER'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(11407974809212316)
,p_validation_name=>'Image template not null'
,p_validation_sequence=>120
,p_validation=>':P4653_IMAGE_TEMPLATE is not null'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Image template is required with use of #REGION_IMAGE# substitution string.'
,p_validation_condition=>'instr(:F4000_P4653_TEMPLATE, ''#REGION_IMAGE#'') > 0'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(3612655867)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(11408079737212317)
,p_validation_name=>'REGION_IMAGE_URL in image template'
,p_validation_sequence=>130
,p_validation=>'instr(:P4653_IMAGE_TEMPLATE, ''#REGION_IMAGE_URL#'') > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'The #REGION_IMAGE_URL# substitution string is required in Image template.'
,p_validation_condition=>':P4653_IMAGE_TEMPLATE is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(3612655867)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(397307220112551594)
,p_name=>'ENABLE PREVIOUS'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P4653_ID_PREV'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(397307508996551594)
,p_event_id=>wwv_flow_imp.id(397307220112551594)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(57515028086887716)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(397307627731553768)
,p_name=>'ENABLE NEXT'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P4653_ID_NEXT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(397307920753553768)
,p_event_id=>wwv_flow_imp.id(397307627731553768)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(57514913787887716)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(9689693371802629)
,p_name=>'refresh template options on cancel'
,p_event_sequence=>30
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'body'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosecanceldialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(9689757736802630)
,p_event_id=>wwv_flow_imp.id(9689693371802629)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(20915676136405505)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(9689829238802631)
,p_event_id=>wwv_flow_imp.id(9689693371802629)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(708428607483249258)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(9689911692802632)
,p_name=>'upper case identifier'
,p_event_sequence=>40
,p_triggering_element_type=>'COLUMN'
,p_triggering_region_id=>wwv_flow_imp.id(20915676136405505)
,p_triggering_element=>'DISPLAY_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(9690178479802634)
,p_event_id=>wwv_flow_imp.id(9689911692802632)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
':NAME := regexp_replace(',
'      srcstr     => :DISPLAY_NAME,',
'      pattern    => ''[^'' || wwv_flow_utilities.c_alnum || '']+'',',
'      replacestr => ''_'' );'))
,p_attribute_02=>'DISPLAY_NAME'
,p_attribute_03=>'NAME'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3004581206333543)
,p_name=>'Show Publish Success Msg'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(166448303431073862)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3004630591333544)
,p_event_id=>wwv_flow_imp.id(3004581206333543)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ( this.data.successMessage ) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3622655870)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch Row from WWV_FLOW_PAGE_PLUG_TEMPLATES'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'for c1 in (',
'select 1 from wwv_flow_page_plug_templates',
'where security_group_id = :flow_security_group_id and',
'      flow_id = :FB_FLOW_ID and',
'      id = :F4000_P4653_ID) loop',
'wwv_flow_dml.fetch_row(',
'  p_table_owner => ''#OWNER#'',',
'  p_table_name  => ''WWV_FLOW_PAGE_PLUG_TEMPLATES'',',
'  p_rowid       => v(''F4000_P4653_ID''),',
'  p_alt_rowid   => ''ID'');',
'exit;',
'end loop;',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error fetching row.'
,p_internal_uid=>3622655870
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(57520116652887760)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_PAGINATION'
,p_process_name=>'Get Next or Previous Primary Key Value'
,p_attribute_02=>'WWV_FLOW_PAGE_PLUG_TEMPLATES'
,p_attribute_03=>'F4000_P4653_ID'
,p_attribute_04=>'ID'
,p_attribute_07=>'PAGE_PLUG_TEMPLATE_NAME'
,p_attribute_09=>'P4653_ID_NEXT'
,p_attribute_10=>'P4653_ID_PREV'
,p_attribute_13=>'P4653_ID_COUNT'
,p_attribute_14=>'flow_id = :fb_flow_id'
,p_process_error_message=>'Unable to run Get Next or Previous Primary Key Value process.'
,p_internal_uid=>57520116652887760
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(164085714109849931)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh template 1'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_region_template (',
'    p_master_template_id         => :F4000_P4653_REFERENCE_ID,',
'    p_subscribing_template_id    => :F4000_P4653_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying template.'
,p_process_when_button_id=>wwv_flow_imp.id(164060102283696912)
,p_process_when=>'F4000_P4653_REFERENCE_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_process_success_message=>'Template copied.'
,p_internal_uid=>164085714109849931
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3623655870)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process Row of WWV_FLOW_PAGE_PLUG_TEMPLATES'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select 1 from SYS.dual',
'where :F4000_P4653_ID is null',
'or exists (select 1 from wwv_flow_page_plug_templates',
'                   where security_group_id = :flow_security_group_id and',
'      flow_id = :FB_FLOW_ID and',
'      id = :F4000_P4653_ID)) loop',
'wwv_flow_dml.process(',
'p_action => wwv_flow.g_request,',
'p_table_owner => ''#OWNER#'',',
'p_table_name  => ''WWV_FLOW_PAGE_PLUG_TEMPLATES'',',
'p_rowid       => v(''F4000_P4653_ID''),',
'p_alt_rowid   => ''ID'');',
'exit;',
'end loop;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error processing row.'
,p_process_when=>'COPY_TEMPLATE'
,p_process_when_type=>'REQUEST_NOT_IN_CONDITION'
,p_process_success_message=>'Region template processed.'
,p_internal_uid=>3623655870
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(34415815650944401)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh template 2'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_region_template (',
'    p_master_template_id         => :F4000_P4653_REFERENCE_ID,',
'    p_subscribing_template_id    => :F4000_P4653_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying template.'
,p_process_when=>':F4000_P4653_REFERENCE_ID is not null and :F4000_P4653_REFRESH = ''Y'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Template copied.'
,p_internal_uid=>34415815650944401
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2046920780635584503)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sync template option presets'
,p_process_sql_clob=>'wwv_flow_templates_util.sync_region_tmplopt_presets(:F4000_P4653_ID);'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'nvl(:P4653_PRESET_TEMPLATE_OPTIONS,''NOPRESETS'') <> nvl(:P4653_PRESET_TMPLOPT_CHECK,''NOPRESETS'') '
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>2046920780635584503
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(11881326291758422)
,p_process_sequence=>80
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(20915676136405505)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Template Options - Save Interactive Grid Data'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>11881326291758422
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(164079525613753399)
,p_process_sequence=>80
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove reference id as needed'
,p_process_sql_clob=>'wwv_flow_copy_metadata.remove_region_reference_id (:F4000_P4653_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error setting template id to null.'
,p_process_when=>'F4000_P4653_REFERENCE_ID'
,p_process_when_type=>'ITEM_IS_NULL'
,p_process_success_message=>'Reference id removed.'
,p_internal_uid=>164079525613753399
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4313197422030116)
,p_process_sequence=>90
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(266470409881026219)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Slots - Save Interactive Grid Data'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>4313197422030116
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(177290695973915733)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_region_id=>wwv_flow_imp.id(266470409881026219)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'upper :placeholder'
,p_process_sql_clob=>':placeholder := upper(:placeholder);'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'F4000_P4653_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_exec_cond_for_each_row=>'Y'
,p_internal_uid=>177290695973915733
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(177290796098915734)
,p_process_sequence=>20
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_region_id=>wwv_flow_imp.id(266470409881026219)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'trim pound'
,p_process_sql_clob=>':placeholder := trim( both ''#'' from :placeholder );'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'F4000_P4653_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_exec_cond_for_each_row=>'Y'
,p_internal_uid=>177290796098915734
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(13086400032499021)
,p_process_sequence=>30
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_region_id=>wwv_flow_imp.id(20915676136405505)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'upper :name'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':NAME := REGEXP_REPLACE(',
'      srcstr     => :NAME,',
'      pattern    => ''[^'' || wwv_flow_utilities.c_alnum || '']+'',',
'      replacestr => ''_'' );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'F4000_P4653_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_exec_cond_for_each_row=>'Y'
,p_internal_uid=>13086400032499021
);
end;
/
prompt --application/pages/page_04654
begin
wwv_flow_imp_page.create_page(
 p_id=>4654
,p_name=>'Edit Report Template'
,p_alias=>'EDIT-REPORT-TEMPLATE1'
,p_step_title=>'Edit Report Template'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'EXISTS'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_row_templates t, ',
'       wwv_flow_themes th',
' where t.id                 = :F4000_P4654_ID',
'   and t.flow_id            = th.flow_id',
'   and t.theme_id           = th.theme_id',
'   and t.security_group_id  = :workspace_id',
'   and th.security_group_id = t.security_group_id',
'   and t.reference_id      is not null',
'   and th.reference_id     is not null',
''))
,p_help_text=>'ui_templt.htm'
,p_page_component_map=>'21'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(333463912)
,p_plug_name=>'Edit Report Template'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(334466077)
,p_plug_name=>'Name'
,p_region_name=>'N'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(335468967)
,p_plug_name=>'Row Templates'
,p_region_name=>'ROW'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>150
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(336494473)
,p_plug_name=>'Comments'
,p_region_name=>'C'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>210
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(337523805)
,p_plug_name=>'Report Templates'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>12
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Report templates provide template control over the results of a row from a SQL query.  Report templates be defined to format an entire row or specify a specific column.  Report templates that define a cell are smaller because they need only define ea'
||'ch cell, however all cells are the same.  Use column name substitutions for example #ENAME# #JOB# or row position substitutions #1# #2# to substitute column values.  Report template conditions allow you to use a specific row template based on row col'
||'umn values or session state.   For example "#SAL# > 1000" or "''#ENAME#'' = ''SMITH''" (Note the use of quotes for text strings). Reference rownum using #ROWNUM#.',
'',
''))
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46650415178)
,p_plug_name=>'Before first and after last row text'
,p_region_name=>'BA'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>170
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4323409658151759)
,p_plug_name=>'Pagination'
,p_region_name=>'PG'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>180
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(14467922958338901)
,p_plug_name=>'Column Headings'
,p_region_name=>'COL'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>160
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(14532616069639696)
,p_plug_name=>'Obsolete Attributes'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>220
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'FUNCTION_BODY'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  r boolean := false;',
'begin',
'  for c1 in ( select ROW_TEMPLATE_TABLE_ATTRIBUTES ',
'                from WWV_FLOW_ROW_TEMPLATES ',
'               where id                = :F4000_P4654_ID',
'                 and security_group_id = :workspace_id ',
'            ) loop',
'     if c1.ROW_TEMPLATE_TABLE_ATTRIBUTES = ''OMIT'' or c1.ROW_TEMPLATE_TABLE_ATTRIBUTES is null then',
'        r := false;',
'     else',
'        r := true;',
'     end if;',
'  end loop;',
'  return r;',
'end;'))
,p_plug_display_when_cond2=>'PLSQL'
,p_plug_header=>'<span class="instructiontext">This attribute is obsolete, please integrate this into your template above.</span>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(25099151573363002)
,p_plug_name=>'Template Options'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>130
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(20520667758325646)
,p_plug_name=>'Template Options'
,p_parent_plug_id=>wwv_flow_imp.id(25099151573363002)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.template_types,',
'       o.id,',
'       o.display_name,',
'       o.name,',
'       o.display_sequence,',
'       o.css_classes,',
'       o.flow_id,',
'       o.theme_id,',
'       o.help_text,',
'       o.group_id,',
'       o.report_template_id,',
'       ( select g.display_sequence from wwv_flow_template_opt_groups g where g.id = o.group_id ) group_display_sequence,',
'       ( select g.display_name     from wwv_flow_template_opt_groups g where g.id = o.group_id ) group_display_name',
'  from wwv_flow_template_options o',
' where o.flow_id            = :FB_FLOW_ID',
'   and o.theme_id           = :P4654_THEME_ID',
'   and o.template_types     = ''REPORT''',
'   and o.report_template_id = :F4000_P4654_ID',
'   and o.security_group_id  = :WORKSPACE_ID'))
,p_plug_source_type=>'NATIVE_IG'
,p_ajax_items_to_submit=>'P4654_DEFAULT_TEMPLATE_OPTIONS,P4654_THEME_ID'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Template Options'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(13087191868499028)
,p_name=>'GROUP_DISPLAY_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'GROUP_DISPLAY_SEQUENCE'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Group Sequence'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>80
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(13087226384499029)
,p_name=>'GROUP_DISPLAY_NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'GROUP_DISPLAY_NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Group Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>90
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(20521446292325654)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>30
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(20521532441325655)
,p_name=>'DISPLAY_NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DISPLAY_NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>100
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_item_width=>30
,p_is_required=>true
,p_max_length=>30
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_static_id=>'COLUMN_DISPLAY_NAME'
,p_use_as_row_header=>true
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(20521581726325656)
,p_name=>'DISPLAY_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DISPLAY_SEQUENCE'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>'Sequence'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>120
,p_value_alignment=>'RIGHT'
,p_attribute_03=>'left'
,p_attribute_04=>'decimal'
,p_item_width=>5
,p_is_required=>true
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'1'
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(20521697113325657)
,p_name=>'CSS_CLASSES'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'CSS_CLASSES'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Classes'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>130
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_max_length=>255
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(20522048749325660)
,p_name=>'APEX$ROW_ACTION'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>20
,p_use_as_row_header=>false
,p_display_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(20522098226325661)
,p_name=>'APEX$ROW_SELECTOR'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_use_as_row_header=>false
,p_display_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(20523132735325671)
,p_name=>'TEMPLATE_TYPES'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'TEMPLATE_TYPES'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>60
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'REPORT'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(20523194251325672)
,p_name=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Identifier'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>110
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_attribute_06=>'UPPER'
,p_item_width=>30
,p_is_required=>true
,p_max_length=>30
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(21163885340481126)
,p_name=>'HELP_TEXT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'HELP_TEXT'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Help Text'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>150
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(21163987143481127)
,p_name=>'GROUP_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'GROUP_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Group'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>140
,p_value_alignment=>'LEFT'
,p_is_required=>false
,p_lov_type=>'SQL_QUERY'
,p_lov_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name,',
'       id',
'  from wwv_flow_template_opt_groups',
' where template_types     = :TEMPLATE_TYPES',
'   and flow_id            = :FB_FLOW_ID',
'   and theme_id           = :P4654_THEME_ID',
'   and security_group_id  = :WORKSPACE_ID'))
,p_lov_display_extra=>true
,p_lov_display_null=>true
,p_lov_cascade_parent_items=>'TEMPLATE_TYPES'
,p_ajax_items_to_submit=>'P4654_THEME_ID'
,p_ajax_optimize_refresh=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(21164082771481128)
,p_name=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FLOW_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>40
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'FB_FLOW_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(21164201935481129)
,p_name=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'THEME_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>50
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'P4654_THEME_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(21164429369481131)
,p_name=>'REPORT_TEMPLATE_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'REPORT_TEMPLATE_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>70
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'F4000_P4654_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(20521338495325653)
,p_internal_uid=>20521338495325653
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_add_row_if_empty=>false
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>true
,p_no_data_found_message=>'No template options.'
,p_show_toolbar=>true
,p_toolbar_buttons=>'SEARCH_FIELD:SAVE'
,p_add_button_label=>'Add Template Option'
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>false
,p_define_chart_view=>false
,p_enable_download=>false
,p_download_formats=>null
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function(config) {',
'    config.defaultGridViewOptions = {',
'        reorderColumns: false',
'    }',
'    return config;',
'}'))
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(20957305193464479)
,p_interactive_grid_id=>wwv_flow_imp.id(20521338495325653)
,p_static_id=>'94803'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(20957491211464480)
,p_report_id=>wwv_flow_imp.id(20957305193464479)
,p_view_type=>'GRID'
,p_stretch_columns=>true
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(11480368418698793)
,p_view_id=>wwv_flow_imp.id(20957491211464480)
,p_display_seq=>11
,p_column_id=>wwv_flow_imp.id(21164082771481128)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(11481408225698799)
,p_view_id=>wwv_flow_imp.id(20957491211464480)
,p_display_seq=>12
,p_column_id=>wwv_flow_imp.id(21164201935481129)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(20958042433464486)
,p_view_id=>wwv_flow_imp.id(20957491211464480)
,p_display_seq=>2
,p_column_id=>wwv_flow_imp.id(20521446292325654)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(20958947393464493)
,p_view_id=>wwv_flow_imp.id(20957491211464480)
,p_display_seq=>4
,p_column_id=>wwv_flow_imp.id(20521532441325655)
,p_is_visible=>true
,p_is_frozen=>false
,p_sort_order=>4
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(20959829930464497)
,p_view_id=>wwv_flow_imp.id(20957491211464480)
,p_display_seq=>6
,p_column_id=>wwv_flow_imp.id(20521581726325656)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>112
,p_sort_order=>3
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(20960675503464502)
,p_view_id=>wwv_flow_imp.id(20957491211464480)
,p_display_seq=>7
,p_column_id=>wwv_flow_imp.id(20521697113325657)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(20963399114464511)
,p_view_id=>wwv_flow_imp.id(20957491211464480)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(20522048749325660)
,p_is_visible=>true
,p_is_frozen=>true
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(21169910584483511)
,p_view_id=>wwv_flow_imp.id(20957491211464480)
,p_display_seq=>10
,p_column_id=>wwv_flow_imp.id(20523132735325671)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(21170819295483517)
,p_view_id=>wwv_flow_imp.id(20957491211464480)
,p_display_seq=>5
,p_column_id=>wwv_flow_imp.id(20523194251325672)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(21174458799483529)
,p_view_id=>wwv_flow_imp.id(20957491211464480)
,p_display_seq=>8
,p_column_id=>wwv_flow_imp.id(21163885340481126)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(21175355568483532)
,p_view_id=>wwv_flow_imp.id(20957491211464480)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(21163987143481127)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(21752051651873813)
,p_view_id=>wwv_flow_imp.id(20957491211464480)
,p_display_seq=>13
,p_column_id=>wwv_flow_imp.id(21164429369481131)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(23818494793921866)
,p_view_id=>wwv_flow_imp.id(20957491211464480)
,p_display_seq=>14
,p_column_id=>wwv_flow_imp.id(13087191868499028)
,p_is_visible=>false
,p_is_frozen=>false
,p_sort_order=>1
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(23819392089921869)
,p_view_id=>wwv_flow_imp.id(20957491211464480)
,p_display_seq=>15
,p_column_id=>wwv_flow_imp.id(13087226384499029)
,p_is_visible=>false
,p_is_frozen=>false
,p_sort_order=>2
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(708033599105169399)
,p_name=>'Global Template Options'
,p_parent_plug_id=>wwv_flow_imp.id(25099151573363002)
,p_template=>wwv_flow_imp.id(689970285456172024)
,p_display_sequence=>230
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.id,',
'       o.display_name,',
'       o.display_sequence,',
'       o.css_classes,',
'       g.display_name group_name',
'  from wwv_flow_template_options o,',
'       wwv_flow_template_opt_groups g',
' where o.flow_id              = :FB_FLOW_ID',
'   and o.virtual_template_id is null',
'   and o.template_types       = ''REPORT''',
'   and o.report_template_id  is null',
'   and o.security_group_id    = :WORKSPACE_ID',
'   and g.id (+)               = o.group_id',
'   and o.theme_id             = :P4654_THEME_ID',
' order by',
'       g.display_sequence,',
'       g.display_name,',
'       o.display_sequence,',
'       o.display_name'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P4654_DEFAULT_TEMPLATE_OPTIONS,P4654_THEME_ID'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>200
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No template options defined.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(11487041697678557)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(11487491798678557)
,p_query_column_id=>2
,p_column_alias=>'DISPLAY_NAME'
,p_column_display_sequence=>21
,p_column_heading=>'Name'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(11487893456678558)
,p_query_column_id=>3
,p_column_alias=>'DISPLAY_SEQUENCE'
,p_column_display_sequence=>31
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(11488297437678558)
,p_query_column_id=>4
,p_column_alias=>'CSS_CLASSES'
,p_column_display_sequence=>41
,p_column_heading=>'Classes'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(11488619905678558)
,p_query_column_id=>5
,p_column_alias=>'GROUP_NAME'
,p_column_display_sequence=>11
,p_column_heading=>'Group'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46255923216679006)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>2
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(92905500045786517)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(92837202675352059)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(932807384840193717)
,p_plug_name=>'Subscription'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P4654_THEME_IS_SUBSCRIBED = ''BOTH'' then',
'     sys.htp.p(wwv_flow_lang.system_message(''TEMPLATE_SUBSCRIPTION.THEME_AND_TEMPLATE_SUBSCRIBED''));',
'else',
'     sys.htp.p(wwv_flow_lang.system_message(''TEMPLATE_SUBSCRIPTION.THEME_SUBSCRIBED''));',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P4654_THEME_IS_SUBSCRIBED'
,p_plug_display_when_cond2=>'NONE'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'N',
  'attribute_02', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1094587077987933039)
,p_plug_name=>'Javascript'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>190
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1094587181132933040)
,p_plug_name=>'Cascading Style Sheet'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>200
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1517532632413488001)
,p_plug_name=>'Subscription'
,p_region_name=>'SUBSCRIPTION'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>120
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_column=>false
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P4654_THEME_IS_SUBSCRIBED'
,p_plug_display_when_cond2=>'NONE'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'WWV_FLOW_ROW_TEMPLATES',
  'attribute_02', 'ROW_TEMPLATE_NAME',
  'attribute_03', 'F4000_P4654_ID',
  'attribute_04', 'F4000_P4654_REFERENCE_ID',
  'attribute_05', 'SUBSCRIBE_TEMPLATE')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(304434608)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_imp.id(333463912)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(305434612)
,p_button_sequence=>2
,p_button_plug_id=>wwv_flow_imp.id(333463912)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P4654_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(306434612)
,p_button_sequence=>3
,p_button_plug_id=>wwv_flow_imp.id(333463912)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P4654_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(307434612)
,p_button_sequence=>4
,p_button_plug_id=>wwv_flow_imp.id(333463912)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P4654_ID is null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(164357816901006904)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1517532632413488001)
,p_button_name=>'COPY_TEMPLATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Refresh'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_row_templates',
' where id                 = :F4000_P4654_ID',
'   and security_group_id  = :WORKSPACE_ID',
'   and reference_id      is not null'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(166460709234094432)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1517532632413488001)
,p_button_name=>'PUBLISH_TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Publish Template'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.::F4000_P149_ID,F4000_P149_PAGE_ID,F4000_P149_TEMPLATE_TYPE:&F4000_P4654_ID.,&FLOW_PAGE_ID.,REPORT_TEMPLATE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_row_templates',
' where reference_id       = :F4000_P4654_ID',
'   and security_group_id  = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(11477326091678533)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_imp.id(25099151573363002)
,p_button_name=>'OPTION_GROUPS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Template Option Groups'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:81:&SESSION.::&DEBUG.:CR,81:P81_THEME_ID,P81_TEMPLATE_TYPE:&P4654_THEME_ID.,REPORT'
,p_button_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(50733365791)
,p_branch_name=>'Go To Page 4654'
,p_branch_action=>'f?p=&APP_ID.:4654:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>21
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'F4000_P4654_RETUEN_TO_SELF'
,p_branch_condition_text=>'YES'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(164358200863006907)
,p_branch_name=>'Go To Page 4654'
,p_branch_action=>'f?p=&APP_ID.:4654:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(164357816901006904)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(309434620)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>70
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(311434626)
,p_name=>'F4000_P4654_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(334466077)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(313434632)
,p_name=>'F4000_P4654_ROW_TEMPLATE_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(334466077)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Template Name'
,p_source=>'ROW_TEMPLATE_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Enter a name for this row template.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(314434632)
,p_name=>'F4000_P4654_ROW_TEMPLATE1'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(335468967)
,p_use_cache_before_default=>'NO'
,p_item_default=>'<tr><td>#1#</td><td>#2#</td><td>#3#</td><td>#4#</td><td>#5#</td></tr>'
,p_prompt=>'Row Template 1'
,p_source=>'ROW_TEMPLATE1'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>12
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Defines the row template. You can use these substitution strings here:',
'<ul>',
'<li>#COLUMN_VALUE# - Will be replaced with the value of a column</li>',
'<li>#ALIGNMENT# - Specified by the user, determines the alignment of a column</li>',
'<li>#COLNUM# - Current Column Number</li>',
'<li>#COLUMN_HEADER# - Column Header</li>',
'<li>#COLCOUNT# - Number of Columns</li>',
'<li>#ROWNUM# - Current Row Number</li>',
'</ul>',
'<p>You can also use column number syntax to reference columns by select list position in the query, such as #1#, #2#.</p>',
'<p>A typical example would be:</p>',
'<pre>&lt;td #ALIGNMENT#&gt;#COLUMN_VALUE#&lt;/td&gt;</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(315434634)
,p_name=>'F4000_P4654_ROW_TEMPLATE_CONDITION1'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(335468967)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Row Template 1 Expression'
,p_source=>'ROW_TEMPLATE_CONDITION1'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Used only when the row condition is set to Use Based on PL/SQL Expression.   Enables you to format rows based on the data in that row.</p>',
'<p>For example, if you wanted to display a value in bold if the salary was greater than 2000, you could use the following row template condition:</p>',
'<pre>',
'#SAL# &gt; 2000',
'</pre>',
'<p>You can also use the substitution string #ROWNUM# here.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(316434634)
,p_name=>'F4000_P4654_ROW_TEMPLATE2'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(335468967)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Row Template 2'
,p_source=>'ROW_TEMPLATE2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>12
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Defines the row template. You can use these substitution strings here:',
'<ul>',
'<li>#COLUMN_VALUE# - Will be replaced with the value of a column</li>',
'<li>#ALIGNMENT# - Specified by the user, determines the alignment of a column</li>',
'<li>#COLNUM# - Current Column Number</li>',
'<li>#COLUMN_HEADER# - Column Header</li>',
'<li>#COLCOUNT# - Number of Columns</li>',
'<li>#ROWNUM# - Current Row Number</li>',
'</ul>',
'<p>You can also use column number syntax to reference columns by select list position in the query, such as #1#, #2#.</p>',
'<p>A typical example would be:</p>',
'<pre>&lt;td #ALIGNMENT#&gt;#COLUMN_VALUE#&lt;/td&gt;</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(317434634)
,p_name=>'F4000_P4654_ROW_TEMPLATE_CONDITION2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(335468967)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Row Template 2 Expression'
,p_source=>'ROW_TEMPLATE_CONDITION2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Used only when the row condition is set to Use Based on PL/SQL Expression.   Enables you to format rows based on the data in that row.</p>',
'<p>For example, if you wanted to display a value in bold if the salary was greater than 2000, you could use the following row template condition:</p>',
'<pre>',
'#SAL# &gt; 2000',
'</pre>',
'<p>You can also use the substitution string #ROWNUM# here.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(318434635)
,p_name=>'F4000_P4654_ROW_TEMPLATE3'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(335468967)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Row Template 3'
,p_source=>'ROW_TEMPLATE3'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>12
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Defines the row template. You can use these substitution strings here:',
'<ul>',
'<li>#COLUMN_VALUE# - Will be replaced with the value of a column</li>',
'<li>#ALIGNMENT# - Specified by the user, determines the alignment of a column</li>',
'<li>#COLNUM# - Current Column Number</li>',
'<li>#COLUMN_HEADER# - Column Header</li>',
'<li>#COLCOUNT# - Number of Columns</li>',
'<li>#ROWNUM# - Current Row Number</li>',
'</ul>',
'<p>You can also use column number syntax to reference columns by select list position in the query, such as #1#, #2#.</p>',
'<p>A typical example would be:</p>',
'<pre>&lt;td #ALIGNMENT#&gt;#COLUMN_VALUE#&lt;/td&gt;</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(319434635)
,p_name=>'F4000_P4654_ROW_TEMPLATE_CONDITION3'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(335468967)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Row Template 3 Expression'
,p_source=>'ROW_TEMPLATE_CONDITION3'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Used only when the row condition is set to Use Based on PL/SQL Expression.   Enables you to format rows based on the data in that row.</p>',
'<p>For example, if you wanted to display a value in bold if the salary was greater than 2000, you could use the following row template condition:</p>',
'<pre>',
'#SAL# &gt; 2000',
'</pre>',
'<p>You can also use the substitution string #ROWNUM# here.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(320434635)
,p_name=>'F4000_P4654_ROW_TEMPLATE4'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(335468967)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Row Template 4'
,p_source=>'ROW_TEMPLATE4'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>12
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Defines the row template. You can use these substitution strings here:',
'<ul>',
'<li>#COLUMN_VALUE# - Will be replaced with the value of a column</li>',
'<li>#ALIGNMENT# - Specified by the user, determines the alignment of a column</li>',
'<li>#COLNUM# - Current Column Number</li>',
'<li>#COLUMN_HEADER# - Column Header</li>',
'<li>#COLCOUNT# - Number of Columns</li>',
'<li>#ROWNUM# - Current Row Number</li>',
'</ul>',
'<p>You can also use column number syntax to reference columns by select list position in the query, such as #1#, #2#.</p>',
'<p>A typical example would be:</p>',
'<pre>&lt;td #ALIGNMENT#&gt;#COLUMN_VALUE#&lt;/td&gt;</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(321434636)
,p_name=>'F4000_P4654_ROW_TEMPLATE_CONDITION4'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(335468967)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Row Template 4 Expression'
,p_source=>'ROW_TEMPLATE_CONDITION4'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Used only when the row condition is set to Use Based on PL/SQL Expression.   Enables you to format rows based on the data in that row.</p>',
'<p>For example, if you wanted to display a value in bold if the salary was greater than 2000, you could use the following row template condition:</p>',
'<pre>',
'#SAL# &gt; 2000',
'</pre>',
'<p>You can also use the substitution string #ROWNUM# here.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(322434638)
,p_name=>'F4000_P4654_ROW_TEMPLATE_COMMENT'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(336494473)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comments'
,p_source=>'ROW_TEMPLATE_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Enter any comments or notes here.  These comments will never be displayed when running the application</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(46651420058)
,p_name=>'F4000_P4654_ROW_TEMPLATE_BEFORE_ROWS'
,p_item_sequence=>112
,p_item_plug_id=>wwv_flow_imp.id(46650415178)
,p_use_cache_before_default=>'NO'
,p_item_default=>'<table>'
,p_prompt=>'Before Rows'
,p_source=>'ROW_TEMPLATE_BEFORE_ROWS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter HTML which will be displayed one time at the beginning of a report template.</p>',
'<p>The most common use of this attribute is to open an HTML table:</p>',
'<pre>&lt;table&gt;</pre>',
'<p>You can also specify table column headers here:</p>',
'<pre>&lt;th&gt;#1#&lt;/th&gt;&lt;th&gt;#2#&lt;/th&gt;&lt;th&gt;#3#&lt;/th&gt;</pre>',
'<p>If you want to display pagination above the reports, your template needs to specify the following substitution string:</p>',
'<pre>#TOP_PAGINATION#</pre>',
'The #TOP_PAGINATION# substitution string will generate HTML which starts with an opening &lt;tr&gt; tag and ends with a closing &lt;/tr&gt; tag.  Ideally, you would include an open table tag and #TOP_PAGINATION# substitution string like so:</p>',
'<pre>&lt;table&gt;#TOP_PAGINATION#</pre>',
'<p>You can also use the substitution string #CSV_LINK# if you wish to support exporting your report to CSV format for use in spreadsheets.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(46652431799)
,p_name=>'F4000_P4654_ROW_TEMPLATE_AFTER_ROWS'
,p_item_sequence=>114
,p_item_plug_id=>wwv_flow_imp.id(46650415178)
,p_use_cache_before_default=>'NO'
,p_item_default=>'</table>'
,p_prompt=>'After Rows'
,p_source=>'ROW_TEMPLATE_AFTER_ROWS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This text displays after the last row. Typically, you close the HTML table tag here.</p>',
'<p>For example:</p>',
'<pre>&lt;/table&gt;</pre>',
'<p>The following substitution strings are available:</p>',
'<ul>',
'<li>#PAGINATION# - Will be replaced with the pagination attribute</li>',
'<li>#COLCOUNT# - Number of HTML columns to span</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(46653434128)
,p_name=>'F4000_P4654_ROW_TEMPLATE_TABLE_ATTRIBUTES'
,p_item_sequence=>116
,p_item_plug_id=>wwv_flow_imp.id(14532616069639696)
,p_use_cache_before_default=>'NO'
,p_item_default=>'OMIT'
,p_prompt=>'Table Attributes (obsolete use:  to not have Applications open an close a table for you)'
,p_source=>'ROW_TEMPLATE_TABLE_ATTRIBUTES'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>100
,p_cMaxlength=>255
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Obsolete. Use OMIT for a value to turn this feature off.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(50732358732)
,p_name=>'F4000_P4654_RETUEN_TO_SELF'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(337523805)
,p_prompt=>'Stay on page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_help_text=>'Select this checkbox to stay on this page after applying changes.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'YES'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4324032514158298)
,p_name=>'F4000_P4654_PAGINATION_TEMPLATE'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(4323409658151759)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Pagination Template'
,p_source=>'PAGINATION_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This attribute will be applied to the entire pagination subtemplate.  You can further modify each item in the subtemplate below.</p>',
'<p>For example:</p>',
'<pre>&lt;span class="instructiontext"&gt;#TEXT#&lt;/span&gt;</pre>',
'<p>Use the substitution string #TEXT# where you want the pagination subtemplate to display</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4327402217187418)
,p_name=>'F4000_P4654_NEXT_PAGE_TEMPLATE'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(4323409658151759)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Next Page Template'
,p_source=>'NEXT_PAGE_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter HTML that will modify how the "Next Page" portion of the pagination subtemplate will appear.</p>',
'<p>For example:</p>',
'<pre>&lt;a href="#LINK#"&gt;next&lt;/a&gt;</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4328218494192112)
,p_name=>'F4000_P4654_PREV_PAGE_TEMPLATE'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(4323409658151759)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Previous Page Template'
,p_source=>'PREVIOUS_PAGE_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter HTML that will modify how the "Previous Page" portion of the pagination subtemplate will appear.</p>',
'<p>For example:</p>',
'<pre>&lt;a href="#LINK#"&gt;previous&lt;/a&gt;</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4329112737199962)
,p_name=>'F4000_P4654_PREV_SET_TEMPLATE'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(4323409658151759)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Previous Set Template'
,p_source=>'PREVIOUS_SET_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter HTML that will modify how the "Previous Set" portion of the pagination subtemplate will appear.</p>',
'<p>For example:</p>',
'<pre>&lt;a href="#LINK#"&gt;previous set&lt;/a&gt;</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4329821741202564)
,p_name=>'F4000_P4654_NEXT_SET_TEMPLATE'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(4323409658151759)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Next Set Template'
,p_source=>'NEXT_SET_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter HTML that will modify how the "Next Set" portion of the pagination subtemplate will appear.</p>',
'<p>For example:</p>',
'<pre>&lt;a href="#LINK#"&gt;next set&lt;/a&gt;</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11477771108678537)
,p_name=>'P4654_PRESET_TEMPLATE_OPTIONS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(25099151573363002)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Preset Template Options:'
,p_source=>'PRESET_TEMPLATE_OPTIONS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.TEMPALTE_OPT_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.display_name as d,',
'       o.css_classes as r,',
'       null default_template_options,',
'       null,',
'       o.help_text,',
'       g.display_name group_name,',
'       g.is_advanced advanced_group,',
'       g.null_text',
'  from wwv_flow_template_options o,',
'       wwv_flow_template_opt_groups g,',
'       wwv_flow_row_templates t',
' where o.flow_id                = :fb_flow_id',
'   and o.template_types         = ''REPORT''',
'   and (report_template_id      = :f4000_p4654_id or report_template_id is null)',
'   and o.theme_id               = t.theme_id',
'   and t.id                     = :f4000_p4654_id',
'   and g.id                 (+) = o.group_id',
'   and o.security_group_id      = :WORKSPACE_ID',
'   and g.security_group_id  (+) = o.security_group_id',
'   and t.security_group_id      = o.security_group_id',
' order by ',
'       g.is_advanced nulls first,',
'       g.display_sequence nulls first,',
'       g.display_name nulls first,',
'       o.display_sequence,',
'       o.display_name'))
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11478140010678539)
,p_name=>'P4654_DEFAULT_TEMPLATE_OPTIONS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(25099151573363002)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Default Template Options:'
,p_source=>'DEFAULT_TEMPLATE_OPTIONS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.TEMPALTE_OPT_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.display_name as d,',
'       o.css_classes as r,',
'       t.default_template_options,',
'       null,',
'       o.help_text,',
'       g.display_name group_name',
'  from wwv_flow_template_options o,',
'       wwv_flow_template_opt_groups g,',
'       wwv_flow_row_templates t',
' where o.flow_id               = :fb_flow_id',
'   and t.id                    = o.report_template_id',
'   and o.report_template_id    = :f4000_p4654_id',
'   and g.id                (+) = o.group_id',
'   and o.security_group_id     = :WORKSPACE_ID',
'   and g.security_group_id (+) = o.security_group_id',
'   and t.security_group_id     = o.security_group_id',
' order by',
'       g.display_sequence nulls first,',
'       g.display_name nulls first,',
'       o.display_sequence,',
'       o.display_name'))
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(14466107721334507)
,p_name=>'F4000_P4654_COLUMN_HEADING_TEMPLATE'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(14467922958338901)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Column Heading Template'
,p_source=>'COLUMN_HEADING_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>6
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This attribute is for use only with generic column templates. Use this template to colorize each column header cell. The text of this attribute must include Help to indicate where the cell heading text is to be colorized.</p>',
'',
'<p>If you do not enter a column header template, then a default column header template will be applied.  If you do not want any column headings, then enter "OMIT".</p>',
'<p>',
'For example:</p>',
'<pre>',
' &lt;th #ALIGNMENT#&gt;#COLUMN_HEADER#&lt;/th&gt;',
'</pre>',
'<p>Support for column headings with row templates (named column) will be discontinued with the next version. Headings for row templates should be define in "before rows" using column position #1# substitutions.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30680411168394404)
,p_name=>'P4654_TRANSLATABLE'
,p_item_sequence=>32
,p_item_plug_id=>wwv_flow_imp.id(334466077)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Translatable'
,p_source=>'TRANSLATE_THIS_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(34519123555031875)
,p_name=>'F4000_P4654_REFRESH'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(1517532632413488001)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Refresh'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_row_templates',
' where reference_id      is null',
'   and id                 = :F4000_P4654_ID',
'   and security_group_id  = :WORKSPACE_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(79198417617521783)
,p_name=>'F4000_P4654_ROW_TEMPLATE_TYPE'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_imp.id(334466077)
,p_use_cache_before_default=>'NO'
,p_item_default=>'NAMED_COLUMNS'
,p_prompt=>'Template Type'
,p_source=>'ROW_TEMPLATE_TYPE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'ROW_TEMPLATE_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(84775019904954668)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Displays the type of the template - either <strong>Named Columns</strong> or <strong>Generic Columns</strong>.</p>',
'',
'<p>Named Column templates reference column names in the template, whereas Generic Column Templates reference #COLUMN_VALUE# in the template.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(79216121209611292)
,p_name=>'F4000_P4654_ROW_TEMPLATE_COND1'
,p_item_sequence=>45
,p_item_plug_id=>wwv_flow_imp.id(335468967)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Row Template 1 Condition'
,p_source=>'ROW_TEMPLATE_DISPLAY_COND1'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ROW_TEMPLATE_COND2'
,p_lov=>'.'||wwv_flow_imp.id(84871821607428292)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select condition -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Optionally select a condition that must be met in order to apply this row template.  You can select either even or odd row numbers, or supply a PL/SQL expression.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(79221416884628515)
,p_name=>'F4000_P4654_ROW_TEMPLATE_COND2'
,p_item_sequence=>65
,p_item_plug_id=>wwv_flow_imp.id(335468967)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Row Template 2 Condition'
,p_source=>'ROW_TEMPLATE_DISPLAY_COND2'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ROW_TEMPLATE_COND2'
,p_lov=>'.'||wwv_flow_imp.id(84871821607428292)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select condition -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Optionally select a condition that must be met in order to apply this row template.  You can select either even or odd row numbers, or supply a PL/SQL expression.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(79222113433630086)
,p_name=>'F4000_P4654_ROW_TEMPLATE_COND3'
,p_item_sequence=>85
,p_item_plug_id=>wwv_flow_imp.id(335468967)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Row Template 3 Condition'
,p_source=>'ROW_TEMPLATE_DISPLAY_COND3'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ROW_TEMPLATE_COND2'
,p_lov=>'.'||wwv_flow_imp.id(84871821607428292)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select condition -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Optionally select a condition that must be met in order to apply this row template.  You can select either even or odd row numbers, or supply a PL/SQL expression.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(79222810845631287)
,p_name=>'F4000_P4654_ROW_TEMPLATE_COND4'
,p_item_sequence=>105
,p_item_plug_id=>wwv_flow_imp.id(335468967)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Row Template 4 Condition'
,p_source=>'ROW_TEMPLATE_DISPLAY_COND4'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ROW_TEMPLATE_COND2'
,p_lov=>'.'||wwv_flow_imp.id(84871821607428292)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select condition -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Optionally select a condition that must be met in order to apply this row template.  You can select either even or odd row numbers, or supply a PL/SQL expression.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(91279426390006921)
,p_name=>'P4654_THEME_ID'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_imp.id(334466077)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Theme'
,p_source=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies a collection of templates which define the look and feel of the application.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(93879326521016469)
,p_name=>'P4654_THEME_CLASS_ID'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_imp.id(334466077)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Template Class'
,p_source=>'THEME_CLASS_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REPORT THEME CLASS ID'
,p_lov=>'.'||wwv_flow_imp.id(44022800298370465)||'.'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'The template class identifies a specific usage for this template.  The template class is used when switching themes.  When switching themes template classes are matched, thus allowing themes to be switched without manually mapping all templates.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(164372613373020267)
,p_name=>'F4000_P4654_REFERENCE_ID'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(1517532632413488001)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Reference Master Report Template From'
,p_source=>'REFERENCE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FLOW_SUBSCRIBE_FROM_REPORT_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''- '' || lower(wwv_flow_lang.system_message(''NO_TEMPLATE'')) || '' -'' d,',
'       0 r ',
'  from sys.dual ',
' union all',
'select flow_id||'' : ''||row_template_name||decode(theme_id,',
'       null,',
'       '''',',
'       '' (''||theme_id||'')'') d, ',
'       id r',
'  from wwv_flow_row_templates',
' where flow_id != nvl(:fb_flow_id,0) ',
'   and flow_id in ( select f.id',
'                      from wwv_main_apps_dev f',
'                     where security_group_id = :flow_security_group_id ',
'                       and build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'') ',
'                       and exists ( select 1 ',
'                                      from wwv_flow_developers',
'                                     where userid            = :flow_user ',
'                                       and ( flow_id is null or flow_id = f.id ) ',
'                                       and security_group_id = :flow_security_group_id)',
'    )',
'order by 1'))
,p_cSize=>30
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>You may select an existing template in this application or another template in your workspaces schema. By selecting an existing template, you become a subscriber to that template.</p>',
'',
'<p>To load a new copy of any master template, click <strong>Refresh</strong>.</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1094587257527933041)
,p_name=>'P4654_JAVASCRIPT_FILE_URLS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1094587077987933039)
,p_use_cache_before_default=>'NO'
,p_prompt=>'File URLs'
,p_source=>'JAVASCRIPT_FILE_URLS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter JavaScript file URLs for code to be loaded on this page. Each URL has to be written into a new line. If you provide a minified version of your file you can use the substitution string <code>#MIN#</code> to include <code>.min</code> or <code>'
||'#MIN_DIRECTORY#</code> to include <code>minified/</code> in your file URL for a regular page view and an empty string if the page is viewed in debug mode. You also have access to the substitution string <code>#APP_VERSION#</code> if you want to inclu'
||'de the application''s version in the file URL.</p>',
'',
'<p>Note: You do not need to include opening or closing <code>script</code> tags. Just write the URL.',
'',
'<p>',
'Examples:',
'<ul>',
'  <li>Standard file reference',
'      <pre>/myjs/main.js</pre>',
'  </li>',
'  <li>Standard file reference which loads the minified file main.min.js from /myjs/minified/ for regular page views and main.js from /myjs/ in debug mode.',
'      <pre>/myjs/#MIN_DIRECTORY#main#MIN#.js</pre>',
'  </li>',
'  <li>Use this syntax if the library is also used from a RequireJS require call. The define name must match what is used in the requirejs.config paths and the value must be the global symbol exposed by the library. Only applies when using RequireJS. '
||'This avoids RequireJS  loading that library a second time.',
'      <pre>[define hammerjs=Hammer]/myjs/hammer.js</pre>',
'  </li>',
'  <li>Use this syntax if the file has a dependency on RequireJS. This will automatically load RequireJS before this file.',
'      <pre>[require requirejs]/myjs/main.js</pre>',
'  </li>',
'  <li>Use this syntax if the file has a dependency on Oracle JET. This will automatically load RequireJS and the Oracle JET RequireJS configuration before this file.',
'      <pre>[require jet]/myjs/main.js</pre>',
'  </li>',
'  <li>File reference using a query string in the URL referencing the application version, such that when the application is upgraded (and the version is incremented), the browser will be instructed to always load the new file and ignore any previousl'
||'y cached files.',
'      <pre>/myjs/main.js?version=#APP_VERSION#</pre>',
'  </li>',
'</ul>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1094587300769933042)
,p_name=>'P4654_CSS_FILE_URLS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1094587181132933040)
,p_use_cache_before_default=>'NO'
,p_prompt=>'File URLs'
,p_source=>'CSS_FILE_URLS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter Cascading Style Sheet file URLs to be loaded for this page template. Each URL has to be written into a new line. If you provide a minified version of your file you can use the substitution string <code>#MIN#</code> to include <code>.min</cod'
||'e> or <code>#MIN_DIRECTORY#</code> to include <code>minified/</code> in your file URL for a regular page view and an empty string if the page is viewed in debug mode. You also have access to the substitution string <code>#APP_VERSION#</code> if you w'
||'ant to include the application''s version in the file URL.</p>',
'',
'<p>Note: You do not need to include opening or closing <code>link</code> tags. Just include the file URL.</p>',
'',
'<p>',
'Examples:',
'<ul>',
'  <li>Standard file reference',
'      <pre>/mycss/main.css</pre>',
'  </li>',
'  <li>Standard file reference which loads the minified file main.min.css from /mycss/minified/ for regular page views and main.css from /mycss/ in debug mode.',
'      <pre>/mycss/#MIN_DIRECTORY#main#MIN#.css</pre>',
'  </li>',
'  <li>Conditional media query',
'      <pre>[media="only screen and (max-device-width: 480px)"]/mycss/smartphone.css</pre>',
'  </li>',
'  <li>File reference using a query string in the URL referencing the application version, such that when the application is upgraded (and the version is incremented), the browser will be instructed to always load the new file and ignore any previousl'
||'y cached files.',
'      <pre>/mycss/main.css?version=#APP_VERSION#</pre>',
'  </li>',
'</ul>',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1094587408055933043)
,p_name=>'P4654_JAVASCRIPT_CODE_ONLOAD'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1094587077987933039)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Execute when Page Loads'
,p_source=>'JAVASCRIPT_CODE_ONLOAD'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cHeight=>15
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter JavaScript code to execute when the page loads. The code is executed after the JavaScript code generated by &PRODUCT_NAME..</p>',
'',
'<p>Note: You do not need to add any opening or closing <code>script</code> tags, just the JavaScript code.</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'JAVASCRIPT'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2104786427191065739)
,p_name=>'P4654_THEME_IS_SUBSCRIBED'
,p_item_sequence=>225
,p_item_plug_id=>wwv_flow_imp.id(334466077)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_alignment=>'LEFT-CENTER'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2104787120662069906)
,p_computation_sequence=>10
,p_computation_item=>'P4654_THEME_IS_SUBSCRIBED'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'    l_is_subscribed varchar2(16) := ''NONE'';',
'begin',
'',
'    for c1 in (',
'        select t.reference_id template_ref_id, th.reference_id theme_ref_id',
'          from wwv_flow_row_templates t, ',
'               wwv_flow_themes th',
'         where t.id                  = :F4000_P4654_ID',
'           and t.flow_id             = th.flow_id',
'           and t.theme_id            = th.theme_id',
'           and t.security_group_id   = :WORKSPACE_ID',
'           and th.security_group_id  = t.security_group_id',
'    ) loop',
'        if c1. theme_ref_id is not null then',
'            if c1.template_ref_id is not null then',
'                l_is_subscribed := ''BOTH'';',
'            else ',
'                l_is_subscribed := ''THEME'';',
'            end if;',
'        end if;    ',
'    end loop;',
'',
'    return l_is_subscribed;',
'',
'end;'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(34527315145035803)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P4654_REFRESH'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'Unable to compute item value.'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(164421208592067969)
,p_validation_name=>'reference id not null'
,p_validation_sequence=>10
,p_validation=>'F4000_P4654_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Reference ID must be specified to refresh the template.'
,p_when_button_pressed=>wwv_flow_imp.id(164357816901006904)
,p_associated_item=>wwv_flow_imp.id(164372613373020267)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(164431029498073482)
,p_validation_name=>'reference id not zero'
,p_validation_sequence=>10
,p_validation=>'F4000_P4654_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_ZERO'
,p_error_message=>'Template to refresh must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(164357816901006904)
,p_associated_item=>wwv_flow_imp.id(164372613373020267)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(24047982074574806)
,p_tabular_form_region_id=>wwv_flow_imp.id(20520667758325646)
,p_validation_name=>'Template Options - No duplicates name'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_template_options',
' where flow_id              = :FB_FLOW_ID',
'   and theme_id             = :P4654_THEME_ID',
'   and report_template_id   = :F4000_P4654_ID',
'   and security_group_id    = :WORKSPACE_ID',
'   and name                 = :NAME',
'   and template_types       = :TEMPLATE_TYPES',
'   and (:ID is null or id != :ID)'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#COLUMN_HEADER# must be unique.'
,p_validation_condition=>'F4000_P4654_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_exec_cond_for_each_row=>'Y'
,p_associated_column=>'NAME'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(24048042668574807)
,p_tabular_form_region_id=>wwv_flow_imp.id(20520667758325646)
,p_validation_name=>'Template Options - No duplicates classes'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_template_options',
' where flow_id              = :FB_FLOW_ID',
'   and theme_id             = :P4654_THEME_ID',
'   and report_template_id   = :F4000_P4654_ID',
'   and security_group_id    = :WORKSPACE_ID',
'   and css_classes          = :CSS_CLASSES',
'   and template_types       = :TEMPLATE_TYPES',
'   and (:ID is null or id != :ID)'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#COLUMN_HEADER# must be unique.'
,p_validation_condition=>'F4000_P4654_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_exec_cond_for_each_row=>'Y'
,p_associated_column=>'CSS_CLASSES'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(846499535666131710)
,p_name=>'Cond 4 Change'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P4654_ROW_TEMPLATE_COND4'
,p_condition_element=>'F4000_P4654_ROW_TEMPLATE_COND4'
,p_triggering_condition_type=>'NOT_EQUALS'
,p_triggering_expression=>'NOT_CONDITIONAL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(846499615362131711)
,p_event_id=>wwv_flow_imp.id(846499535666131710)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4654_ROW_TEMPLATE_CONDITION4'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(846499761800131712)
,p_event_id=>wwv_flow_imp.id(846499535666131710)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4654_ROW_TEMPLATE_CONDITION4'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(846499837540131713)
,p_name=>'Cond 3 Change'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P4654_ROW_TEMPLATE_COND3'
,p_condition_element=>'F4000_P4654_ROW_TEMPLATE_COND3'
,p_triggering_condition_type=>'NOT_EQUALS'
,p_triggering_expression=>'NOT_CONDITIONAL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(846500045628131715)
,p_event_id=>wwv_flow_imp.id(846499837540131713)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4654_ROW_TEMPLATE_CONDITION3'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(846500177557131716)
,p_event_id=>wwv_flow_imp.id(846499837540131713)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4654_ROW_TEMPLATE_CONDITION3'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(846500211556131717)
,p_name=>'Cond 2 Change'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P4654_ROW_TEMPLATE_COND2'
,p_condition_element=>'F4000_P4654_ROW_TEMPLATE_COND2'
,p_triggering_condition_type=>'NOT_EQUALS'
,p_triggering_expression=>'NOT_CONDITIONAL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(846500645156131721)
,p_event_id=>wwv_flow_imp.id(846500211556131717)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4654_ROW_TEMPLATE_CONDITION2'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(846500949666131724)
,p_event_id=>wwv_flow_imp.id(846500211556131717)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4654_ROW_TEMPLATE_CONDITION2'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(846500475003131719)
,p_name=>'Cond 1 Change'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P4654_ROW_TEMPLATE_COND1'
,p_condition_element=>'F4000_P4654_ROW_TEMPLATE_COND1'
,p_triggering_condition_type=>'NOT_EQUALS'
,p_triggering_expression=>'NOT_CONDITIONAL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(846500782834131722)
,p_event_id=>wwv_flow_imp.id(846500475003131719)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4654_ROW_TEMPLATE_CONDITION1'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(846500829611131723)
,p_event_id=>wwv_flow_imp.id(846500475003131719)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4654_ROW_TEMPLATE_CONDITION1'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(9688914448802622)
,p_name=>'upper case identifier'
,p_event_sequence=>50
,p_triggering_element_type=>'COLUMN'
,p_triggering_region_id=>wwv_flow_imp.id(20520667758325646)
,p_triggering_element=>'DISPLAY_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(9689117420802624)
,p_event_id=>wwv_flow_imp.id(9688914448802622)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
':NAME := regexp_replace(',
'      srcstr     => :DISPLAY_NAME,',
'      pattern    => ''[^'' || wwv_flow_utilities.c_alnum || '']+'',',
'      replacestr => ''_'' );'))
,p_attribute_02=>'DISPLAY_NAME'
,p_attribute_03=>'NAME'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(9689260512802625)
,p_name=>'refresh template options on cancel'
,p_event_sequence=>60
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'body'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosecanceldialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(9689316022802626)
,p_event_id=>wwv_flow_imp.id(9689260512802625)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(20520667758325646)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(9689423419802627)
,p_event_id=>wwv_flow_imp.id(9689260512802625)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(708033599105169399)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3004735855333545)
,p_name=>'Show Publish Success Msg'
,p_event_sequence=>70
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(166460709234094432)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3004863656333546)
,p_event_id=>wwv_flow_imp.id(3004735855333545)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ( this.data.successMessage ) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(323434642)
,p_process_sequence=>1
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch Row from WWV_FLOW_ROW_TEMPLATES'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'for c1 in (',
'select 1 from wwv_flow_row_templates',
'where security_group_id = :flow_security_group_id and',
'      flow_id = :FB_FLOW_ID and',
'      id = :F4000_P4654_ID) loop',
'wwv_flow_dml.fetch_row(',
'  p_table_owner => ''#OWNER#'',',
'  p_table_name  => ''WWV_FLOW_ROW_TEMPLATES'',',
'  p_rowid       => v(''F4000_P4654_ID''),',
'  p_alt_rowid   => ''ID'');',
'exit;',
'end loop;',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error fetching row.'
,p_internal_uid=>323434642
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(164455400600086959)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh template 1'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_report_template (',
'    p_master_template_id         => :F4000_P4654_REFERENCE_ID,',
'    p_subscribing_template_id    => :F4000_P4654_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying template.'
,p_process_when_button_id=>wwv_flow_imp.id(164357816901006904)
,p_process_when=>'F4000_P4654_REFERENCE_ID'
,p_process_when_type=>'VALUE_OF_ITEM_IN_COND_1_NOT_EQ_COND_2'
,p_process_when2=>'0'
,p_process_success_message=>'Template copied.'
,p_internal_uid=>164455400600086959
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(324434648)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process Row of WWV_FLOW_ROW_TEMPLATES'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'    select 1 ',
'      from sys.dual',
'     where :F4000_P4654_ID is null or exists ( select 1 ',
'                                                 from wwv_flow_row_templates',
'                                                where security_group_id = :flow_security_group_id ',
'                                                  and flow_id           = :FB_FLOW_ID ',
'                                                  and id                = :F4000_P4654_ID ',
'                                             )',
') loop',
'',
'    wwv_flow_dml.process(',
'        p_action      => wwv_flow.g_request,',
'        p_table_owner => ''#OWNER#'',',
'        p_table_name  => ''WWV_FLOW_ROW_TEMPLATES'',',
'        p_rowid       => v(''F4000_P4654_ID''),',
'        p_alt_rowid   => ''ID'');',
'',
'    exit;',
'',
'end loop;',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error processing row.'
,p_process_when=>'COPY_TEMPLATE'
,p_process_when_type=>'REQUEST_NOT_IN_CONDITION'
,p_process_success_message=>'Changes to row template &F4000_P4654_ROW_TEMPLATE_NAME. processed.'
,p_internal_uid=>324434648
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(34536928287044948)
,p_process_sequence=>25
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh template 2'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_report_template (',
'    p_master_template_id         => :F4000_P4654_REFERENCE_ID,',
'    p_subscribing_template_id    => :F4000_P4654_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying template.'
,p_process_when_button_id=>wwv_flow_imp.id(306434612)
,p_process_when=>':F4000_P4654_REFERENCE_ID is not null and :F4000_P4654_REFRESH = ''Y'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Template copied.'
,p_internal_uid=>34536928287044948
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(164466811371097141)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove reference id as needed'
,p_process_sql_clob=>'wwv_flow_copy_metadata.remove_report_reference_id (:F4000_P4654_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error setting template id to null.'
,p_process_when_button_id=>wwv_flow_imp.id(306434612)
,p_process_when=>'F4000_P4654_REFERENCE_ID'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'0'
,p_internal_uid=>164466811371097141
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(11486346993678553)
,p_process_sequence=>80
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(20520667758325646)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Template Options - Save Interactive Grid Data'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>11486346993678553
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(24047808412574805)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_region_id=>wwv_flow_imp.id(20520667758325646)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'upper :name'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':NAME := REGEXP_REPLACE(',
'      srcstr     => :NAME,',
'      pattern    => ''[^'' || wwv_flow_utilities.c_alnum || '']+'',',
'      replacestr => ''_'' );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'F4000_P4654_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_exec_cond_for_each_row=>'Y'
,p_internal_uid=>24047808412574805
);
end;
/
prompt --application/pages/page_04655
begin
wwv_flow_imp_page.create_page(
 p_id=>4655
,p_name=>'List Templates'
,p_alias=>'LIST-TEMPLATES'
,p_step_title=>'Edit List Template'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'<!--',
'',
' htmldb_ch_message=''"OK_TO_GET_NEXT_PREV_PK_VALUE"'';',
'',
'//-->',
'</script>'))
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'EXISTS'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_list_templates t, ',
'       wwv_flow_themes th',
' where t.id                  = :F4000_P4655_ID',
'   and t.flow_id             = th.flow_id',
'   and t.theme_id            = th.theme_id',
'   and t.security_group_id   = :WORKSPACE_ID',
'   and th.security_group_id  = t.security_group_id',
'   and t.reference_id       is not null',
'   and th.reference_id      is not null'))
,p_help_text=>'ui_templt_list.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1793917614009201)
,p_plug_name=>'Landmark for Displayed Regions'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_translate_title=>'N'
,p_landmark_label=>'Displayed Regions'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(53950891417)
,p_plug_name=>'Template Definition'
,p_region_name=>'ELE'
,p_parent_plug_id=>wwv_flow_imp.id(1793917614009201)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>65
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'generated 30-MAY-2000 13:41:50'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(863509230394959)
,p_plug_name=>'Sublist Entry'
,p_region_name=>'SLI'
,p_parent_plug_id=>wwv_flow_imp.id(1793917614009201)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>95
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(878916409690360)
,p_plug_name=>'Before Sublist Entry'
,p_region_name=>'BSL'
,p_parent_plug_id=>wwv_flow_imp.id(1793917614009201)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>85
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(881526929702883)
,p_plug_name=>'After Sublist Entry'
,p_region_name=>'ASL'
,p_parent_plug_id=>wwv_flow_imp.id(1793917614009201)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>105
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(26726285071226615)
,p_plug_name=>'Template Options'
,p_parent_plug_id=>wwv_flow_imp.id(1793917614009201)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>35
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(22147801256189259)
,p_plug_name=>'Template Options'
,p_parent_plug_id=>wwv_flow_imp.id(26726285071226615)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.template_types,',
'       o.id,',
'       o.display_name,',
'       o.name,',
'       o.display_sequence,',
'       o.css_classes,',
'       o.flow_id,',
'       o.theme_id,',
'       o.help_text,',
'       o.group_id,',
'       o.list_template_id,',
'       ( select g.display_sequence from wwv_flow_template_opt_groups g where g.id = o.group_id ) group_display_sequence,',
'       ( select g.display_name     from wwv_flow_template_opt_groups g where g.id = o.group_id ) group_display_name',
'  from wwv_flow_template_options o',
' where o.flow_id            = :FB_FLOW_ID',
'   and o.theme_id           = :P4655_THEME_ID',
'   and o.template_types     = ''LIST''',
'   and o.list_template_id   = :F4000_P4655_ID',
'   and o.security_group_id  = :WORKSPACE_ID'))
,p_plug_source_type=>'NATIVE_IG'
,p_ajax_items_to_submit=>'P4655_DEFAULT_TEMPLATE_OPTIONS,P4655_THEME_ID'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Template Options'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(13084913457499006)
,p_name=>'LIST_TEMPLATE_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LIST_TEMPLATE_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>70
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'F4000_P4655_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(13088101836499038)
,p_name=>'GROUP_DISPLAY_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'GROUP_DISPLAY_SEQUENCE'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Group Sequence'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>80
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(13088226131499039)
,p_name=>'GROUP_DISPLAY_NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'GROUP_DISPLAY_NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Group Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>90
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(22148579790189267)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>30
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(22148665939189268)
,p_name=>'DISPLAY_NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DISPLAY_NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>100
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_item_width=>30
,p_is_required=>true
,p_max_length=>30
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_static_id=>'COLUMN_DISPLAY_NAME'
,p_use_as_row_header=>true
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(22148715224189269)
,p_name=>'DISPLAY_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DISPLAY_SEQUENCE'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>'Sequence'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>120
,p_value_alignment=>'RIGHT'
,p_attribute_03=>'left'
,p_attribute_04=>'decimal'
,p_item_width=>5
,p_is_required=>true
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'1'
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(22148830611189270)
,p_name=>'CSS_CLASSES'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'CSS_CLASSES'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Classes'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>130
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_max_length=>255
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(22149182247189273)
,p_name=>'APEX$ROW_ACTION'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>20
,p_use_as_row_header=>false
,p_display_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(22149231724189274)
,p_name=>'APEX$ROW_SELECTOR'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_use_as_row_header=>false
,p_display_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(22150266233189284)
,p_name=>'TEMPLATE_TYPES'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'TEMPLATE_TYPES'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>60
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'LIST'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(22150327749189285)
,p_name=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Identifier'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>110
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_attribute_06=>'UPPER'
,p_item_width=>30
,p_is_required=>true
,p_max_length=>30
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(22791018838344739)
,p_name=>'HELP_TEXT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'HELP_TEXT'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Help Text'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>150
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(22791120641344740)
,p_name=>'GROUP_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'GROUP_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Group'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>140
,p_value_alignment=>'LEFT'
,p_is_required=>false
,p_lov_type=>'SQL_QUERY'
,p_lov_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select display_name,',
'       id',
'  from wwv_flow_template_opt_groups',
' where template_types     = :TEMPLATE_TYPES',
'   and flow_id            = :FB_FLOW_ID',
'   and theme_id           = :P4655_THEME_ID',
'   and security_group_id  = :WORKSPACE_ID'))
,p_lov_display_extra=>true
,p_lov_display_null=>true
,p_lov_cascade_parent_items=>'TEMPLATE_TYPES'
,p_ajax_items_to_submit=>'P4655_THEME_ID'
,p_ajax_optimize_refresh=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(22791216269344741)
,p_name=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FLOW_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>40
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'FB_FLOW_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(22791335433344742)
,p_name=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'THEME_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>50
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'P4655_THEME_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(22148471993189266)
,p_internal_uid=>22148471993189266
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_add_row_if_empty=>false
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>true
,p_no_data_found_message=>'No template options.'
,p_show_toolbar=>true
,p_toolbar_buttons=>'SEARCH_FIELD:SAVE'
,p_add_button_label=>'Add Template Option'
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>false
,p_define_chart_view=>false
,p_enable_download=>false
,p_download_formats=>null
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function(config) {',
'    config.defaultGridViewOptions = {',
'        reorderColumns: false',
'    }',
'    return config;',
'}'))
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(22584438691328092)
,p_interactive_grid_id=>wwv_flow_imp.id(22148471993189266)
,p_static_id=>'94803'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(22584624709328093)
,p_report_id=>wwv_flow_imp.id(22584438691328092)
,p_view_type=>'GRID'
,p_stretch_columns=>true
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(13107501916562406)
,p_view_id=>wwv_flow_imp.id(22584624709328093)
,p_display_seq=>11
,p_column_id=>wwv_flow_imp.id(22791216269344741)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(13108541723562412)
,p_view_id=>wwv_flow_imp.id(22584624709328093)
,p_display_seq=>12
,p_column_id=>wwv_flow_imp.id(22791335433344742)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(13121906665590155)
,p_view_id=>wwv_flow_imp.id(22584624709328093)
,p_display_seq=>13
,p_column_id=>wwv_flow_imp.id(13084913457499006)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(22585175931328099)
,p_view_id=>wwv_flow_imp.id(22584624709328093)
,p_display_seq=>2
,p_column_id=>wwv_flow_imp.id(22148579790189267)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(22586080891328106)
,p_view_id=>wwv_flow_imp.id(22584624709328093)
,p_display_seq=>4
,p_column_id=>wwv_flow_imp.id(22148665939189268)
,p_is_visible=>true
,p_is_frozen=>false
,p_sort_order=>4
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(22586963428328110)
,p_view_id=>wwv_flow_imp.id(22584624709328093)
,p_display_seq=>6
,p_column_id=>wwv_flow_imp.id(22148715224189269)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>103
,p_sort_order=>3
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(22587809001328115)
,p_view_id=>wwv_flow_imp.id(22584624709328093)
,p_display_seq=>7
,p_column_id=>wwv_flow_imp.id(22148830611189270)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(22590532612328124)
,p_view_id=>wwv_flow_imp.id(22584624709328093)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(22149182247189273)
,p_is_visible=>true
,p_is_frozen=>true
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(22797044082347124)
,p_view_id=>wwv_flow_imp.id(22584624709328093)
,p_display_seq=>10
,p_column_id=>wwv_flow_imp.id(22150266233189284)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(22797952793347130)
,p_view_id=>wwv_flow_imp.id(22584624709328093)
,p_display_seq=>5
,p_column_id=>wwv_flow_imp.id(22150327749189285)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(22801592297347142)
,p_view_id=>wwv_flow_imp.id(22584624709328093)
,p_display_seq=>8
,p_column_id=>wwv_flow_imp.id(22791018838344739)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(22802489066347145)
,p_view_id=>wwv_flow_imp.id(22584624709328093)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(22791120641344740)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(23842764285999416)
,p_view_id=>wwv_flow_imp.id(22584624709328093)
,p_display_seq=>14
,p_column_id=>wwv_flow_imp.id(13088101836499038)
,p_is_visible=>false
,p_is_frozen=>false
,p_sort_order=>1
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(23843683985999420)
,p_view_id=>wwv_flow_imp.id(22584624709328093)
,p_display_seq=>15
,p_column_id=>wwv_flow_imp.id(13088226131499039)
,p_is_visible=>false
,p_is_frozen=>false
,p_sort_order=>2
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(709660732603033012)
,p_name=>'Global Template Options'
,p_parent_plug_id=>wwv_flow_imp.id(26726285071226615)
,p_template=>wwv_flow_imp.id(689970285456172024)
,p_display_sequence=>230
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noPadding:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.id,',
'       o.display_name,',
'       o.display_sequence,',
'       o.css_classes,',
'       g.display_name group_name',
'  from wwv_flow_template_options o,',
'       wwv_flow_template_opt_groups g',
' where o.flow_id              = :FB_FLOW_ID',
'   and o.virtual_template_id is null',
'   and o.template_types       = ''LIST''',
'   and o.LIST_TEMPLATE_ID    is null',
'   and o.security_group_id    = :WORKSPACE_ID',
'   and o.theme_id             = :P4655_THEME_ID',
'   and g.id (+)               = o.group_id',
' order by',
'       g.display_sequence,',
'       g.display_name,',
'       o.display_sequence,',
'       o.display_name'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'P4655_DEFAULT_TEMPLATE_OPTIONS,P4655_THEME_ID'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>200
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No template options defined.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(13114210082542159)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'ID'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(13114691999542159)
,p_query_column_id=>2
,p_column_alias=>'DISPLAY_NAME'
,p_column_display_sequence=>21
,p_column_heading=>'Name'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(13115017187542160)
,p_query_column_id=>3
,p_column_alias=>'DISPLAY_SEQUENCE'
,p_column_display_sequence=>31
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'RIGHT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(13115416076542160)
,p_query_column_id=>4
,p_column_alias=>'CSS_CLASSES'
,p_column_display_sequence=>41
,p_column_heading=>'Classes'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(13115860871542160)
,p_query_column_id=>5
,p_column_alias=>'GROUP_NAME'
,p_column_display_sequence=>11
,p_column_heading=>'Group'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(33420204617089509)
,p_plug_name=>'Subscription'
,p_region_name=>'SUBSCRIPTION'
,p_parent_plug_id=>wwv_flow_imp.id(1793917614009201)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P4655_THEME_IS_SUBSCRIBED'
,p_plug_display_when_cond2=>'NONE'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'WWV_FLOW_LIST_TEMPLATES',
  'attribute_02', 'LIST_TEMPLATE_NAME',
  'attribute_03', 'F4000_P4655_ID',
  'attribute_04', 'F4000_P4655_REFERENCE_ID',
  'attribute_05', 'SUBSCRIBE_TEMPLATE')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(116536510836697402)
,p_plug_name=>'Name'
,p_region_name=>'N'
,p_parent_plug_id=>wwv_flow_imp.id(1793917614009201)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(116537606954699246)
,p_plug_name=>'Before List Entry'
,p_region_name=>'BEF'
,p_parent_plug_id=>wwv_flow_imp.id(1793917614009201)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>55
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(116542925057706036)
,p_plug_name=>'After List Entry'
,p_region_name=>'AFT'
,p_parent_plug_id=>wwv_flow_imp.id(1793917614009201)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>115
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(116550701119717119)
,p_plug_name=>'Comments'
,p_region_name=>'COM'
,p_parent_plug_id=>wwv_flow_imp.id(1793917614009201)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>155
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(166159828806299946)
,p_plug_name=>'Substitution Strings'
,p_region_name=>'SS'
,p_parent_plug_id=>wwv_flow_imp.id(1793917614009201)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>165
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_templates_util.list_template_sub_str(',
'    p_list_template_id => :F4000_P4655_ID);'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(198130607764423244)
,p_plug_name=>'Template Definitions for First Entry'
,p_parent_plug_id=>wwv_flow_imp.id(1793917614009201)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>75
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(362350814362123456)
,p_plug_name=>'JavaScript'
,p_parent_plug_id=>wwv_flow_imp.id(1793917614009201)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>125
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(362356910300179127)
,p_plug_name=>'Cascading Style Sheet'
,p_parent_plug_id=>wwv_flow_imp.id(1793917614009201)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>135
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1480974873547287737)
,p_plug_name=>'Attribute Descriptions'
,p_parent_plug_id=>wwv_flow_imp.id(1793917614009201)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>145
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>15
,p_plug_header=>'Substitution strings #A01# - #A20# are optional attributes which can be used within a list template, to reference component values. Use the attributes below to specify a more meaningful description for the substitution strings in use by the current l'
||'ist template.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2104731459324667496)
,p_plug_name=>'Subscription'
,p_parent_plug_id=>wwv_flow_imp.id(1793917614009201)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>25
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P4655_THEME_IS_SUBSCRIBED = ''BOTH'' then',
'     sys.htp.p(wwv_flow_lang.system_message(''TEMPLATE_SUBSCRIPTION.THEME_AND_TEMPLATE_SUBSCRIBED''));',
'else',
'     sys.htp.p(wwv_flow_lang.system_message(''TEMPLATE_SUBSCRIPTION.THEME_SUBSCRIBED''));',
'end if;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_num_rows=>15
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P4655_THEME_IS_SUBSCRIBED'
,p_plug_display_when_cond2=>'NONE'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'N',
  'attribute_02', 'HTML',
  'attribute_03', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46257112265679008)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(61176810813006870)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>A list is a named collection of links. You control the appearance a list through lists templates.</p>',
'<p>Each list element has a display condition which enables you to control when it displays. Using template attributes, you can also define a list element to be either "current" or "non-current" for a specific page.</p>'))
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_item=>'F4000_P4769_ROWS'
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_row_count_max=>5000
,p_plug_query_no_data_found=>'No data found.'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'L:C:C:C:C:C'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(91234309210412885)
,p_plug_name=>'Edit List Template'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--accessibleTitle'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_landmark_label=>'List Template Actions'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(92904708571779507)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(92837202675352059)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(117210727055660187)
,p_plug_name=>'Hidden'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(615449124546848074)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(29434107863295859)
,p_plug_display_sequence=>175
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from  WWV_FLOW_LIST_TEMPLATES',
'where id = :F4000_P4655_ID and security_group_id = :flow_security_group_id) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id => :F4000_P4655_ID,',
'      p_component_type => ''List Entry'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by => c1.created_by,',
'      p_created_on => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(189859532094856279)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(91234309210412885)
,p_button_name=>'APPLY_CHANGES_GET_PREVIOUS_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillStart'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-left-chevron'
,p_button_cattributes=>'disabled=""'
,p_button_comment=>'javascript:htmldb_goSubmit(''GET_PREVIOUS_ID'')'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(189859422332856279)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_imp.id(91234309210412885)
,p_button_name=>'APPLY_CHANGES_GET_NEXT_ID'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Next'
,p_button_position=>'CLOSE'
,p_button_css_classes=>'apex_disabled'
,p_icon_css_classes=>'icon-right-chevron'
,p_button_cattributes=>'disabled=""'
,p_button_comment=>'javascript:htmldb_goSubmit(''GET_NEXT_ID'')'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(166454708756084778)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(33420204617089509)
,p_button_name=>'PUBLISH_TEMPLATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Publish Template'
,p_button_position=>'COPY'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.::F4000_P149_ID,F4000_P149_PAGE_ID,F4000_P149_TEMPLATE_TYPE:&F4000_P4655_ID.,&FLOW_PAGE_ID.,LIST_TEMPLATE'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_list_templates',
' where reference_id      = :F4000_P4655_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(164147432233017788)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(33420204617089509)
,p_button_name=>'COPY_TEMPLATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Refresh'
,p_button_position=>'COPY'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_list_templates',
' where id                 = :F4000_P4655_ID',
'   and security_group_id  = :WORKSPACE_ID',
'   and reference_id      is not null'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(53951891421)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(91234309210412885)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:RP::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(53952891421)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(91234309210412885)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:278:&SESSION.::&DEBUG.::P278_ID:&F4000_P4655_ID.'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P4655_ID is not null',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_comment=>'javascript:confirmDelete(''&DELETE_MSG.'');'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(53953891421)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(91234309210412885)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P4655_ID is not null',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(53954891422)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(91234309210412885)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P4655_ID is null',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(13104556546542144)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_imp.id(26726285071226615)
,p_button_name=>'OPTION_GROUPS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Template Option Groups'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:81:&SESSION.::&DEBUG.:CR,81:P81_THEME_ID,P81_TEMPLATE_TYPE:&P4655_THEME_ID.,LIST'
,p_button_condition_type=>'IS_NOT_READ_ONLY'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(189865230056856313)
,p_branch_action=>'f?p=&APP_ID.:4655:&SESSION.::&DEBUG.::F4000_P4655_ID:&P4655_ID_NEXT.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(189859422332856279)
,p_branch_sequence=>10
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(189865623363856315)
,p_branch_action=>'f?p=&APP_ID.:4655:&SESSION.::&DEBUG.::F4000_P4655_ID:&P4655_ID_PREV.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(189859532094856279)
,p_branch_sequence=>20
,p_save_state_before_branch_yn=>'Y'
,p_branch_comment=>'This button is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(164147824403017790)
,p_branch_name=>'Go To Page 4655'
,p_branch_action=>'f?p=&APP_ID.:4655:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(164147432233017788)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(27882730416277606)
,p_branch_action=>'f?p=&APP_ID.:4655:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'F4000_P4655_RETURN_TO_PAGE'
,p_branch_condition_text=>'YES'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(117338403992438825)
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(53955891424)
,p_name=>'F4000_P4655_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(117210727055660187)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Id'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(53957891426)
,p_name=>'F4000_P4655_LIST_TEMPLATE_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(116536510836697402)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>'LIST_TEMPLATE_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>255
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Defines a name that identifies the template.<p />',
'Use the <strong>Translatable</strong> check box to indicate that the template contains text strings that require translation.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(53958891427)
,p_name=>'F4000_P4655_LIST_TEMPLATE_CURRENT'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(53950891417)
,p_use_cache_before_default=>'NO'
,p_item_default=>'<tr><td><img src=#IMAGE_PREFIX##IMAGE# border=0 #IMAGE_ATTR#></td><td><a href="#LINK#">#TEXT#</a></td></tr>'
,p_prompt=>'List Template Current'
,p_source=>'LIST_TEMPLATE_CURRENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter HTML or text to be substituted for the selected (or current) list template. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(53959891427)
,p_name=>'F4000_P4655_LIST_TEMPLATE_NONCURRENT'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(53950891417)
,p_use_cache_before_default=>'NO'
,p_item_default=>'<tr><td><img src=#IMAGE_PREFIX##IMAGE# border=0 #IMAGE_ATTR#></td><td><a href="#LINK#">#TEXT#</a></td></tr>'
,p_prompt=>'List Template Noncurrent'
,p_source=>'LIST_TEMPLATE_NONCURRENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter HTML or text to be substituted for the unselected (or noncurrent) list template. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(53960891429)
,p_name=>'F4000_P4655_LIST_TEMPLATE_BEFORE_ROWS'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(116537606954699246)
,p_use_cache_before_default=>'NO'
,p_item_default=>'<table>'
,p_prompt=>'List Template Before Rows (for example &lt;table&gt; &lt;tr&gt;)'
,p_source=>'LIST_TEMPLATE_BEFORE_ROWS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter HTML that displays before any list elements. You can use this attribute to open an HTML table or HTML table row.',
'',
'You can use the substitution string #COMPONENT_CSS_CLASSES# to apply a CSS class to your breadcrumb template. The component CSS classes are set on the region edit page.',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(53961891429)
,p_name=>'F4000_P4655_LIST_TEMPLATE_AFTER_ROWS'
,p_item_sequence=>320
,p_item_plug_id=>wwv_flow_imp.id(116542925057706036)
,p_use_cache_before_default=>'NO'
,p_item_default=>'</table>'
,p_prompt=>'List Template After Rows  (for example &lt;/tr&gt; &lt;/table&gt;)'
,p_source=>'LIST_TEMPLATE_AFTER_ROWS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'This is the HTML that displays after displaying all list elements. You can use this attribute to close a HTML table opened in the Before List Elements attribute.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(53962891430)
,p_name=>'F4000_P4655_LIST_TEMPLATE_COMMENT'
,p_item_sequence=>370
,p_item_plug_id=>wwv_flow_imp.id(116550701119717119)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comments'
,p_source=>'LIST_TEMPLATE_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Developer comments or notes. These comments never display when the application is running.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(866504953459981)
,p_name=>'P4655_BETWEEN_ITEMS'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(53950891417)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Between List Elements'
,p_source=>'BETWEEN_ITEMS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'This is the HTML that displays between list elements. This attribute will be ignored if no HTML is specified.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(870702192534844)
,p_name=>'P4655_BEFORE_SUB_LIST'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_imp.id(878916409690360)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Sublist Template Before Rows'
,p_source=>'BEFORE_SUB_LIST'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter HTML that displays before any sublist elements. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(873918084586721)
,p_name=>'P4655_BETWEEN_SUB_LIST_ITEMS'
,p_item_sequence=>300
,p_item_plug_id=>wwv_flow_imp.id(863509230394959)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Between Sublist Items'
,p_source=>'BETWEEN_SUB_LIST_ITEMS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'This is the HTML that displays between sublist elements. This attribute will be ignored if no HTML is specified.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(877229653675208)
,p_name=>'P4655_SUB_LIST_ITEM_NONCURRENT'
,p_item_sequence=>280
,p_item_plug_id=>wwv_flow_imp.id(863509230394959)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Sublist Template Noncurrent'
,p_source=>'SUB_LIST_ITEM_NONCURRENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter HTML or text to be substituted for the unselected (or noncurrent) sublist template. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(882722558711005)
,p_name=>'P4655_SUB_LIST_ITEM_CURRENT'
,p_item_sequence=>260
,p_item_plug_id=>wwv_flow_imp.id(863509230394959)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Sublist Template Current'
,p_source=>'SUB_LIST_ITEM_CURRENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter HTML or text to be substituted for the selected (or current) sublist template. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(891205420743950)
,p_name=>'P4655_AFTER_SUB_LIST'
,p_item_sequence=>310
,p_item_plug_id=>wwv_flow_imp.id(881526929702883)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Sublist Template After Rows'
,p_source=>'AFTER_SUB_LIST'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter HTML that displays after any sublist elements. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1432809553325533)
,p_name=>'P4655_TEMP_CURR_W_CHILD'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(53950891417)
,p_use_cache_before_default=>'NO'
,p_prompt=>'List Template Current with Sublist Items'
,p_source=>'ITEM_TEMPLATE_CURR_W_CHILD'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'HTML or text to be substituted for the selected (or current) list template used when item has sublist items. If not specified, the current list item template will be used. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1494705819579926)
,p_name=>'P4655_ITEM_TEMPLATE_NONCURR_W_CHILD'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(53950891417)
,p_use_cache_before_default=>'NO'
,p_prompt=>'List Template Noncurrent  with Sublist Items'
,p_source=>'ITEM_TEMPLATE_NONCURR_W_CHILD'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'HTML or text to be substituted for the unselected (or noncurrent) list template used when item has sublist items. If not specified, the current list item template will be used. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1501303357626555)
,p_name=>'P4655_SUB_TEMPLATE_CURR_W_CHILD'
,p_item_sequence=>270
,p_item_plug_id=>wwv_flow_imp.id(863509230394959)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Sublist Template Current with Sublist Items'
,p_source=>'SUB_TEMPLATE_CURR_W_CHILD'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'HTML or text to be substituted for the selected (or current) sublist template used when an item has sublist entries. If not specified, the current sublist item template will be used. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1505327729643081)
,p_name=>'P4655_SUB_TEMPLATE_NONCURR_W_CHILD'
,p_item_sequence=>290
,p_item_plug_id=>wwv_flow_imp.id(863509230394959)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Sublist Template Noncurrent with Sublist Items'
,p_source=>'SUB_TEMPLATE_NONCURR_W_CHILD'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'HTML or text to be substituted for the unselected (or noncurrent) list template used when item has sublist items. If not specified, the current list item template will be used. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(13104939387542144)
,p_name=>'P4655_PRESET_TEMPLATE_OPTIONS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(26726285071226615)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Preset Template Options:'
,p_source=>'PRESET_TEMPLATE_OPTIONS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.TEMPALTE_OPT_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.display_name as d,',
'       o.css_classes as r,',
'       null default_template_options,',
'       null,',
'       o.help_text,',
'       g.display_name group_name,',
'       g.is_advanced advanced_group,',
'       g.null_text',
'  from wwv_flow_template_options o,',
'       wwv_flow_template_opt_groups g,',
'       wwv_flow_list_templates t',
' where o.flow_id               = :fb_flow_id',
'   and o.template_types        = ''LIST''',
'   and (list_template_id       = :f4000_p4655_id or list_template_id is null)',
'   and o.theme_id              = t.theme_id',
'   and t.id                    = :f4000_p4655_id',
'   and g.id                (+) = o.group_id',
'   and o.security_group_id     = :WORKSPACE_ID',
'   and g.security_group_id (+) = o.security_group_id',
'   and t.security_group_id     = o.security_group_id',
'',
' order by ',
'       g.is_advanced nulls first,',
'       g.display_sequence nulls first,',
'       g.display_name nulls first,',
'       o.display_sequence,',
'       o.display_name'))
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(13105335981542146)
,p_name=>'P4655_DEFAULT_TEMPLATE_OPTIONS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(26726285071226615)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Default Template Options:'
,p_source=>'DEFAULT_TEMPLATE_OPTIONS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.TEMPALTE_OPT_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select o.display_name as d,',
'       o.css_classes as r,',
'       t.default_template_options,',
'       null,',
'       o.help_text,',
'       g.display_name group_name',
'  from wwv_flow_template_options o,',
'       wwv_flow_template_opt_groups g,',
'       wwv_flow_list_templates t',
' where o.flow_id               = :fb_flow_id',
'   and t.id                    = o.list_template_id',
'   and o.list_template_id      = :f4000_p4655_id',
'   and g.id                (+) = o.group_id',
'   and o.security_group_id     = :WORKSPACE_ID',
'   and g.security_group_id (+) = o.security_group_id',
'   and t.security_group_id     = o.security_group_id',
' order by',
'       g.display_sequence nulls first,',
'       g.display_name nulls first,',
'       o.display_sequence,',
'       o.display_name'))
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(13105751129542146)
,p_name=>'P4655_PRESET_TMPLOPT_CHECK'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(26726285071226615)
,p_source=>'F4000_P4655_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(24152211131529435)
,p_name=>'P4655_TRANSLATABLE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(116536510836697402)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Translatable'
,p_source=>'TRANSLATE_THIS_TEMPLATE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(27877514008263344)
,p_name=>'F4000_P4655_RETURN_TO_PAGE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(61176810813006870)
,p_prompt=>'Stay on page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select this checkbox to stay on this page after applying changes.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'YES'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(35406214013635329)
,p_name=>'F4000_P4655_REFRESH'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(33420204617089509)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Refresh'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_list_templates',
' where reference_id     is null',
'   and id                = :F4000_P4655_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(40824816501451172)
,p_name=>'P4655_N'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(91234309210412885)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Name'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select LIST_TEMPLATE_NAME ',
'  from WWV_FLOW_LIST_TEMPLATES ',
' where id                = :F4000_P4655_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies template name'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(43851908984899903)
,p_name=>'P4655_THEME_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(116536510836697402)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Theme:'
,p_source=>'THEME_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Indicates the theme to which the template is a member.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(43939103789248532)
,p_name=>'P4655_TEMPLATE_CLASS'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(116536510836697402)
,p_use_cache_before_default=>'NO'
,p_item_default=>'0'
,p_prompt=>'Template Class'
,p_source=>'THEME_CLASS_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST THEME CLASS ID'
,p_lov=>'.'||wwv_flow_imp.id(43918610013174571)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Not Identified -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Identifies a specific usage for this template.</div>',
'<div class="htmldbInfoBodyP">When you switch to a new theme, all templates in one theme are assigned to corresponding templates in another theme. App Builder accomplishes this template mapping through the assignment of template class identifiers.</di'
||'v>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(164153822587028317)
,p_name=>'F4000_P4655_REFERENCE_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(33420204617089509)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Reference Master Template From'
,p_source=>'REFERENCE_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FLOW_SUBSCRIBE_FROM_LIST_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,',
'       r ',
' from ( select ''- '' || lower(wwv_flow_lang.system_message(''NO_TEMPLATE'')) || '' -''  d, ',
'                0 r, ',
'                1 ob',
'          from sys.dual ',
'         union all',
'        select flow_id || '' : '' || list_template_name || decode( theme_id, null, '''', '' ('' || theme_id|| '')'' ) d,  ',
'               id r, ',
'               2 ob',
'          from wwv_flow_list_templates',
'         where flow_id != nvl( :fb_flow_id ,0 ) ',
'           and flow_id in ( select f.id',
'                              from wwv_main_apps_dev f',
'                             where security_group_id = :FLOW_SECURITY_GROUP_ID ',
'                               and build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'                               and exists ( select 1 ',
'                                              from wwv_flow_developers',
'                                             where userid = :FLOW_USER ',
'                                               and ( flow_id is null or flow_id = f.id )',
'                                               and security_group_id = :FLOW_SECURITY_GROUP_ID ',
'                                          )',
'',
'                           )',
'     )',
'order by ob,d'))
,p_cSize=>60
,p_cMaxlength=>2000
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">You may select an existing template in this workspace or another template in your workspace''s schema. By selecting an existing template, you become a subscriber to that template.</div>',
'<div class="htmldbInfoBodyP">To load a new copy of any master template, click <span class="fielddatabold">Refresh</span>.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(189863125869856297)
,p_name=>'P4655_ID_NEXT'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(117210727055660187)
,p_prompt=>'P4655_ID_NEXT'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(189863505587856298)
,p_name=>'P4655_ID_PREV'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(117210727055660187)
,p_prompt=>'P4655_ID_PREV'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(189863819454856300)
,p_name=>'P4655_ID_COUNT'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(91234309210412885)
,p_prompt=>'List Template'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Edit a list template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
,p_item_comment=>'This item is needed for Get Next or Previous Primary Key Value process.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(198130823001427613)
,p_name=>'P4655_FIRST_LIST_TEMPLATE_NONCURRENT'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_imp.id(198130607764423244)
,p_use_cache_before_default=>'NO'
,p_prompt=>'List Template Noncurrent (First)'
,p_source=>'FIRST_LIST_TEMPLATE_NONCURRENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'If defined, will be used for the first list item. ',
'<p/>',
'Enter HTML or text to be substituted for the unselected (or noncurrent) list template.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(198131100622430662)
,p_name=>'P4655_FIRST_LIST_TEMPLATE_CURRENT'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_imp.id(198130607764423244)
,p_use_cache_before_default=>'NO'
,p_prompt=>'List Template Current (First)'
,p_source=>'FIRST_LIST_TEMPLATE_CURRENT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'If defined, will be used for the first list item.',
'<p/>',
'Enter HTML or text to be substituted for the selected (or current) list template.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(198131414128434500)
,p_name=>'P4655_F_ITEM_TEMPLATE_CURR_W_CHILD'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_imp.id(198130607764423244)
,p_use_cache_before_default=>'NO'
,p_prompt=>'List Template Current with Sublist Items (First)'
,p_source=>'F_ITEM_TEMPLATE_CURR_W_CHILD'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'If defined, will be used for the first list item.',
'<p/>',
'HTML or text to be substituted for the selected (or current) list template used when item has sublist items.  '))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(198131625210437755)
,p_name=>'P4655_FITEM_TEMPLATE_NONCURR_W_CHILD'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_imp.id(198130607764423244)
,p_use_cache_before_default=>'NO'
,p_prompt=>'List Template Noncurrent with Sublist Items (First)'
,p_source=>'FITEM_TEMPLATE_NONCURR_W_CHILD'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'If defined, will be used for the first list item. ',
'<p/>',
'HTML or text to be substituted for the unselected (or noncurrent) list template used when item has sublist items.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(362351229679132568)
,p_name=>'P4655_JAVASCRIPT_FILE_URLS'
,p_item_sequence=>330
,p_item_plug_id=>wwv_flow_imp.id(362350814362123456)
,p_use_cache_before_default=>'NO'
,p_prompt=>'File URLs'
,p_source=>'JAVASCRIPT_FILE_URLS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(362356523832165685)
,p_name=>'P4655_JAVASCRIPT_CODE_ONLOAD'
,p_item_sequence=>340
,p_item_plug_id=>wwv_flow_imp.id(362350814362123456)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Execute when Page Loads'
,p_source=>'JAVASCRIPT_CODE_ONLOAD'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>15
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'JAVASCRIPT'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(362357400312191793)
,p_name=>'P4655_CSS_FILE_URLS'
,p_item_sequence=>350
,p_item_plug_id=>wwv_flow_imp.id(362356910300179127)
,p_use_cache_before_default=>'NO'
,p_prompt=>'File URLs'
,p_source=>'CSS_FILE_URLS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(362357711730201651)
,p_name=>'P4655_INLINE_CSS'
,p_item_sequence=>360
,p_item_plug_id=>wwv_flow_imp.id(362356910300179127)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Inline'
,p_source=>'INLINE_CSS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>15
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'CSS'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1145991925650648502)
,p_name=>'P4655_INTERNAL_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(116536510836697402)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Identifier'
,p_source=>'INTERNAL_NAME'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Template identifier, this is used when switching and upgrading themes and cannot be modified.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1480976054644303108)
,p_name=>'P4655_A01_LABEL'
,p_item_sequence=>380
,p_item_plug_id=>wwv_flow_imp.id(1480974873547287737)
,p_use_cache_before_default=>'NO'
,p_prompt=>'#A01# Description'
,p_source=>'A01_LABEL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify a brief description for the substitution string #A01#, to assist in understanding its use in the current list template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1480976225407303110)
,p_name=>'P4655_A02_LABEL'
,p_item_sequence=>390
,p_item_plug_id=>wwv_flow_imp.id(1480974873547287737)
,p_use_cache_before_default=>'NO'
,p_prompt=>'#A02# Description'
,p_source=>'A02_LABEL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify a brief description for the substitution string #A02#, to assist in understanding its use in the current list template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1480976490053303110)
,p_name=>'P4655_A03_LABEL'
,p_item_sequence=>400
,p_item_plug_id=>wwv_flow_imp.id(1480974873547287737)
,p_use_cache_before_default=>'NO'
,p_prompt=>'#A03# Description'
,p_source=>'A03_LABEL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify a brief description for the substitution string #A03#, to assist in understanding its use in the current list template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1480976660937303111)
,p_name=>'P4655_A04_LABEL'
,p_item_sequence=>410
,p_item_plug_id=>wwv_flow_imp.id(1480974873547287737)
,p_use_cache_before_default=>'NO'
,p_prompt=>'#A04# Description'
,p_source=>'A04_LABEL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify a brief description for the substitution string #A04#, to assist in understanding its use in the current list template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1480976827847303111)
,p_name=>'P4655_A05_LABEL'
,p_item_sequence=>420
,p_item_plug_id=>wwv_flow_imp.id(1480974873547287737)
,p_use_cache_before_default=>'NO'
,p_prompt=>'#A05# Description'
,p_source=>'A05_LABEL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify a brief description for the substitution string #A05#, to assist in understanding its use in the current list template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1480977012044303111)
,p_name=>'P4655_A06_LABEL'
,p_item_sequence=>430
,p_item_plug_id=>wwv_flow_imp.id(1480974873547287737)
,p_use_cache_before_default=>'NO'
,p_prompt=>'#A06# Description'
,p_source=>'A06_LABEL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify a brief description for the substitution string #A06#, to assist in understanding its use in the current list template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1480977242318303111)
,p_name=>'P4655_A07_LABEL'
,p_item_sequence=>440
,p_item_plug_id=>wwv_flow_imp.id(1480974873547287737)
,p_use_cache_before_default=>'NO'
,p_prompt=>'#A07# Description'
,p_source=>'A07_LABEL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify a brief description for the substitution string #A07#, to assist in understanding its use in the current list template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1480977468973303111)
,p_name=>'P4655_A08_LABEL'
,p_item_sequence=>450
,p_item_plug_id=>wwv_flow_imp.id(1480974873547287737)
,p_use_cache_before_default=>'NO'
,p_prompt=>'#A08# Description'
,p_source=>'A08_LABEL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify a brief description for the substitution string #A08#, to assist in understanding its use in the current list template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1480977697345303111)
,p_name=>'P4655_A09_LABEL'
,p_item_sequence=>460
,p_item_plug_id=>wwv_flow_imp.id(1480974873547287737)
,p_use_cache_before_default=>'NO'
,p_prompt=>'#A09# Description'
,p_source=>'A09_LABEL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify a brief description for the substitution string #A09#, to assist in understanding its use in the current list template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1480977837986303112)
,p_name=>'P4655_A10_LABEL'
,p_item_sequence=>470
,p_item_plug_id=>wwv_flow_imp.id(1480974873547287737)
,p_use_cache_before_default=>'NO'
,p_prompt=>'#A10# Description'
,p_source=>'A10_LABEL'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify a brief description for the substitution string #A10#, to assist in understanding its use in the current list template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2104719075582639696)
,p_name=>'P4655_THEME_IS_SUBSCRIBED'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(116536510836697402)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2104721203868650107)
,p_computation_sequence=>10
,p_computation_item=>'P4655_THEME_IS_SUBSCRIBED'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'    l_is_subscribed varchar2(16) := ''NONE'';',
'begin',
'  ',
'    for c1 in (',
'        select t.reference_id template_ref_id, th.reference_id theme_ref_id',
'          from wwv_flow_list_templates t, ',
'               wwv_flow_themes th',
'         where t.id                 = :F4000_P4655_ID',
'           and t.flow_id            = th.flow_id',
'           and t.theme_id           = th.theme_id',
'           and t.security_group_id  = :WORKSPACE_ID',
'           and th.security_group_id = t.security_group_id',
'    ) loop',
'        if c1. theme_ref_id is not null then',
'            if c1.template_ref_id is not null then',
'                l_is_subscribed := ''BOTH'';',
'            else ',
'                l_is_subscribed := ''THEME'';',
'            end if;',
'        end if;    ',
'    end loop;',
'',
'    return l_is_subscribed;',
'',
'end;',
''))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(35423021764646951)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P4655_REFRESH'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'Unable to compute item value.'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(164167822994058498)
,p_validation_name=>'reference id not null'
,p_validation_sequence=>10
,p_validation=>'F4000_P4655_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Reference ID must be specified to refresh the template.'
,p_when_button_pressed=>wwv_flow_imp.id(164147432233017788)
,p_associated_item=>wwv_flow_imp.id(164153822587028317)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(164172311564063782)
,p_validation_name=>'reference id not zero'
,p_validation_sequence=>20
,p_validation=>'F4000_P4655_REFERENCE_ID'
,p_validation_type=>'ITEM_NOT_ZERO'
,p_error_message=>'Template to refresh must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(164147432233017788)
,p_associated_item=>wwv_flow_imp.id(164153822587028317)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(150708028965162693)
,p_validation_name=>'NameMand'
,p_validation_sequence=>30
,p_validation=>'F4000_P4655_LIST_TEMPLATE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Template Name must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(53953891421)
,p_associated_item=>wwv_flow_imp.id(53957891426)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(116587152007891268)
,p_validation_name=>'unique template name'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_list_templates ',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :workspace_id',
'   and theme_id          = :P4655_THEME_ID',
'   and list_template_name= :F4000_P4655_LIST_TEMPLATE_NAME',
'   and id               != :F4000_P4655_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Template name must be unique'
,p_associated_item=>wwv_flow_imp.id(53957891426)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(24049197307574818)
,p_tabular_form_region_id=>wwv_flow_imp.id(22147801256189259)
,p_validation_name=>'Template Options - No duplicates name'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_template_options',
' where flow_id              = :FB_FLOW_ID',
'   and theme_id             = :P4655_THEME_ID',
'   and list_template_id     = :F4000_P4655_ID',
'   and security_group_id    = :WORKSPACE_ID',
'   and name                 = :NAME',
'   and template_types       = :TEMPLATE_TYPES',
'   and (:ID is null or id != :ID)'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#COLUMN_HEADER# must be unique.'
,p_validation_condition=>'F4000_P4655_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_exec_cond_for_each_row=>'Y'
,p_associated_column=>'NAME'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(24049266534574819)
,p_tabular_form_region_id=>wwv_flow_imp.id(22147801256189259)
,p_validation_name=>'Template Options - No duplicates classes'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_template_options',
' where flow_id              = :FB_FLOW_ID',
'   and theme_id             = :P4655_THEME_ID',
'   and list_template_id     = :F4000_P4655_ID',
'   and security_group_id    = :WORKSPACE_ID',
'   and css_classes          = :CSS_CLASSES',
'   and template_types       = :TEMPLATE_TYPES',
'   and (:ID is null or id != :ID)'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#COLUMN_HEADER# must be unique.'
,p_validation_condition=>'F4000_P4655_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_exec_cond_for_each_row=>'Y'
,p_associated_column=>'CSS_CLASSES'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(397308601327565118)
,p_name=>'ENABLE PREVIOUS'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P4655_ID_PREV'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(397308917097565118)
,p_event_id=>wwv_flow_imp.id(397308601327565118)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(189859532094856279)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(397309007215566768)
,p_name=>'ENABLE NEXT'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P4655_ID_NEXT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(397309312777566769)
,p_event_id=>wwv_flow_imp.id(397309007215566768)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(189859422332856279)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(13085080775499007)
,p_name=>'upper case identifier'
,p_event_sequence=>30
,p_triggering_element_type=>'COLUMN'
,p_triggering_region_id=>wwv_flow_imp.id(22147801256189259)
,p_triggering_element=>'DISPLAY_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(13085255591499009)
,p_event_id=>wwv_flow_imp.id(13085080775499007)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
':NAME := regexp_replace(',
'      srcstr     => :DISPLAY_NAME,',
'      pattern    => ''[^'' || wwv_flow_utilities.c_alnum || '']+'',',
'      replacestr => ''_'' );'))
,p_attribute_02=>'DISPLAY_NAME'
,p_attribute_03=>'NAME'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(13085346297499010)
,p_name=>'refresh template options on cancel'
,p_event_sequence=>40
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'body'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosecanceldialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(13085478204499011)
,p_event_id=>wwv_flow_imp.id(13085346297499010)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(22147801256189259)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(13085514409499012)
,p_event_id=>wwv_flow_imp.id(13085346297499010)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(709660732603033012)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3004957438333547)
,p_name=>'Show Publish Success Msg'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(166454708756084778)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3005014825333548)
,p_event_id=>wwv_flow_imp.id(3004957438333547)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ( this.data.successMessage ) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(53963891433)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_LIST_TEMPLATES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_LIST_TEMPLATES'
,p_attribute_03=>'F4000_P4655_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error fetching row.'
,p_internal_uid=>53963891433
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(189864825006856309)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_PAGINATION'
,p_process_name=>'Get Next or Previous Primary Key Value'
,p_attribute_02=>'WWV_FLOW_LIST_TEMPLATES'
,p_attribute_03=>'F4000_P4655_ID'
,p_attribute_04=>'ID'
,p_attribute_07=>'LIST_TEMPLATE_NAME'
,p_attribute_09=>'P4655_ID_NEXT'
,p_attribute_10=>'P4655_ID_PREV'
,p_attribute_13=>'P4655_ID_COUNT'
,p_attribute_14=>'flow_id = :fb_flow_id'
,p_process_error_message=>'Unable to run Get Next or Previous Primary Key Value process.'
,p_internal_uid=>189864825006856309
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(164182328576086354)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'referesh template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_list_template (',
'    p_master_template_id         => :F4000_P4655_REFERENCE_ID,',
'    p_subscribing_template_id    => :F4000_P4655_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying template.'
,p_process_when_button_id=>wwv_flow_imp.id(164147432233017788)
,p_process_when=>'F4000_P4655_REFERENCE_ID'
,p_process_when_type=>'VALUE_OF_ITEM_IN_COND_1_NOT_EQ_COND_2'
,p_process_when2=>'0'
,p_process_success_message=>'Template copied.'
,p_internal_uid=>164182328576086354
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(53964891433)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_LIST_TEMPLATES'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_LIST_TEMPLATES'
,p_attribute_03=>'F4000_P4655_ID'
,p_attribute_04=>'ID'
,p_attribute_05=>'WORKSPACE_ID'
,p_attribute_06=>'SECURITY_GROUP_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error processing row.'
,p_process_when=>'COPY_TEMPLATE'
,p_process_when_type=>'REQUEST_NOT_IN_CONDITION'
,p_process_success_message=>'Action processed.'
,p_internal_uid=>53964891433
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(35430002355655896)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'refresh template 2'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.subscribe_list_template (',
'    p_master_template_id         => :F4000_P4655_REFERENCE_ID,',
'    p_subscribing_template_id    => :F4000_P4655_ID',
'    );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error copying template.'
,p_process_when_button_id=>wwv_flow_imp.id(53953891421)
,p_process_when=>':F4000_P4655_REFERENCE_ID is not null and :F4000_P4655_REFRESH = ''Y'' and upper(:request) like ''APPLY%'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Template copied.'
,p_internal_uid=>35430002355655896
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1449463095706055533)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'sync template option presets'
,p_process_sql_clob=>'wwv_flow_templates_util.sync_list_tmplopt_presets(:F4000_P4655_ID);'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'nvl(:P4655_PRESET_TEMPLATE_OPTIONS,''NOPRESETS'') <> nvl(:P4655_PRESET_TMPLOPT_CHECK,''NOPRESETS'') '
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>1449463095706055533
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(164178515218077277)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'remove reference id as needed'
,p_process_sql_clob=>'wwv_flow_copy_metadata.remove_list_reference_id (:F4000_P4655_ID);'
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error setting template id to null.'
,p_process_when_type=>'VALUE_OF_ITEM_IN_COND_1_EQ_COND_2'
,p_internal_uid=>164178515218077277
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(13113588443542157)
,p_process_sequence=>80
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(22147801256189259)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Template Options - Save Interactive Grid Data'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>13113588443542157
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(24049033629574817)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_region_id=>wwv_flow_imp.id(22147801256189259)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'upper :name'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':NAME := REGEXP_REPLACE(',
'      srcstr     => :NAME,',
'      pattern    => ''[^'' || wwv_flow_utilities.c_alnum || '']+'',',
'      replacestr => ''_'' );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'F4000_P4655_ID'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_exec_cond_for_each_row=>'Y'
,p_internal_uid=>24049033629574817
);
end;
/
prompt --application/pages/page_04656
begin
wwv_flow_imp_page.create_page(
 p_id=>4656
,p_name=>'Template Utilization'
,p_alias=>'TEMPLATE-UTILIZATION'
,p_step_title=>'Template Utilization'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212879727923324936)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'ui_templt_rpts.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(133434464852)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>1
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(12437772301)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Templates'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(304382492121)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page displays template utilization in the current application for all template types. The number in the References column indicates the total number of pages that use the specific template.</p>',
'<p>To view additional details, click the number. To edit a template, click the template name.</p>',
''))
,p_plug_query_num_rows=>5000
,p_plug_query_num_rows_type=>'0'
,p_plug_query_show_nulls_as=>'-'
,p_plug_query_break_cols=>'1:2'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(5297711133003335)
,p_name=>'Template Utilization'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>5
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    q                    varchar2(32767) := null;',
'    l_page               varchar2(512);',
'    l_pages              varchar2(512);',
'    l_region             varchar2(512);',
'    l_report             varchar2(512);',
'    l_list               varchar2(512);',
'    l_label              varchar2(512);',
'    l_button             varchar2(512);',
'    l_menu               varchar2(512);',
'    l_calendar           varchar2(512);',
'    l_template_component varchar2(512);',
'begin',
'select wwv_flow_lang.system_message_lit(''CONFIRM.PAGES''),',
'       wwv_flow_lang.system_message_lit(''F4000.REGION''),',
'       wwv_flow_lang.system_message_lit(''REPORT''),',
'       wwv_flow_lang.system_message_lit(''F4000.LIST_INITCAP''),',
'       wwv_flow_lang.system_message_lit(''LABEL''),',
'       wwv_flow_lang.system_message_lit(''F4000.BUTTON''),',
'       wwv_flow_lang.system_message_lit(''BREADCRUMB''),',
'       wwv_flow_lang.system_message_lit(''LEGACY_CALENDAR''),',
'       wwv_flow_lang.system_message_lit(''F4000.TEMPLATE_COMPONENT'')',
'  into l_page,',
'       l_region,',
'       l_report,',
'       l_list,',
'       l_label,',
'       l_button,',
'       l_menu,',
'       l_calendar,',
'       l_template_component',
'  from sys.dual;',
'',
'    if (nvl(:F4000_P4656_SHOW,''Page'') = ''Page'') then',
'      q :=q||''select '';      ',
'      q :=q||''flow_id, '';',
'      q :=q||''theme_id, '';',
'      q :=q||''''''''||l_page||'''''' ttype, '';     ',
'      q :=q||'' sys.htf.anchor(''''f?p=4000:4307:''||:FLOW_SESSION||''::NO:4307:F4000_P4307_ID:''''||id, '';',
'      q :=q||'' wwv_flow_escape.html(name)) tname, ''; ',
'      q :=q||'' wwv_flow_theme_manager.get_page_util(:fb_flow_id,p.id)  utilization, ''; ',
'      q :=q||'' wwv_flow_templates_util.page_template_ref_count(:fb_flow_id,p.id) references ''; ',
'      q :=q||''from wwv_flow_templates p '';',
'      q :=q||''where p.flow_id = :fb_flow_id '';',
'      q :=q||''  and p.security_group_id = :flow_security_group_id '';',
'      q :=q||''  and (p.theme_id = :P4656_THEME or :p4656_theme = 0) '';               ',
'    end if;',
'',
'    if (nvl(:F4000_P4656_SHOW,''Region'') = ''Region'') then',
'      q :=q||''union all '';',
'      q :=q||''select '';',
'      q :=q||''flow_id, '';',
'      q :=q||''theme_id, '';',
'      q :=q||''''''''||l_region||'''''' ttype, '';',
'      q :=q||'' sys.htf.anchor(''''f?p=4000:4653:''''||:flow_session||''''::NO:4653:F4000_P4653_ID:''''||id, '';',
'      q :=q||'' wwv_flow_escape.html(PAGE_PLUG_TEMPLATE_NAME)) tname, '';',
'      q :=q||'' wwv_flow_theme_manager.get_region_util(:fb_flow_id,r.id) utilization, ''; ',
'      q :=q||'' wwv_flow_templates_util.region_template_ref_count(:fb_flow_id,r.id) references ''; ',
'      q :=q||''from wwv_flow_page_plug_templates r '';',
'      q :=q||''where r.flow_id = :fb_flow_id '';',
'      q :=q||''  and r.security_group_id = :flow_security_group_id '';',
'      q :=q||''  and (r.theme_id = :P4656_THEME or :p4656_theme = 0) '';               ',
'    end if;',
'    ',
'    if (nvl(:F4000_P4656_SHOW,''Report'') = ''Report'') then',
'      q :=q||''union all '';',
'      q :=q||''select '';',
'      q :=q||''flow_id, '';',
'      q :=q||''theme_id, '';',
'      q :=q||''''''''||l_report||'''''' ttype, '';     ',
'      q :=q||'' sys.htf.anchor(''''f?p=4000:4654:''''||:flow_session||''''::NO:4654:F4000_P4654_ID:''''||id, '';',
'      q :=q||'' wwv_flow_escape.html(ROW_TEMPLATE_NAME)) tname, '';      ',
'      q :=q||'' wwv_flow_theme_manager.get_report_util(:fb_flow_id,ro.id) utilization, ''; ',
'      q :=q||'' wwv_flow_templates_util.report_template_ref_count(:fb_flow_id,ro.id) references ''; ',
'      q :=q||''from wwv_flow_row_templates ro '';',
'      q :=q||''where ro.flow_id = :fb_flow_id '';',
'      q :=q||''  and ro.security_group_id = :flow_security_group_id '';',
'      q :=q||''  and (ro.theme_id = :P4656_THEME or :p4656_theme = 0) '';               ',
'    end if;',
'',
'    if (nvl(:F4000_P4656_SHOW,''List'') = ''List'') then',
'      q :=q||''union all '';',
'      q :=q||''select '';            ',
'      q :=q||''flow_id, '';',
'      q :=q||''theme_id, '';',
'      q :=q||''''''''||l_list||'''''' ttype, '';',
'      q :=q||'' sys.htf.anchor(''''f?p=4000:4655:''||:FLOW_SESSION||''::NO:4655:F4000_P4655_ID:''''||id, '';      ',
'      q :=q||''wwv_flow_escape.html(LIST_TEMPLATE_NAME)) tname, '';      ',
'      q :=q||'' wwv_flow_theme_manager.get_list_util(:fb_flow_id,l.id) utilization, ''; ',
'      q :=q||'' wwv_flow_templates_util.list_template_ref_count(:fb_flow_id,l.id) references ''; ',
'      q :=q||''from wwv_flow_list_templates l '';',
'      q :=q||''where l.flow_id = :fb_flow_id '';',
'      q :=q||''  and l.security_group_id = :flow_security_group_id '';',
'      q :=q||''  and (l.theme_id = :P4656_THEME or :p4656_theme = 0) '';               ',
'    end if;',
'',
'    if (nvl(:F4000_P4656_SHOW,''Field'') = ''Field'') then',
'      q :=q||''union all '';',
'      q :=q||''select '';      ',
'      q :=q||''flow_id, '';',
'      q :=q||''theme_id, '';',
'      q :=q||''''''''||l_label||'''''' ttype, '';',
'      q :=q||'' sys.htf.anchor(''''f?p=4000:85:''''||:flow_session||''''::NO:85:F4000_P85_ID:''''||id, '';',
'      q :=q||''wwv_flow_escape.html(TEMPLATE_NAME)) tname, '';      ',
'      q :=q||'' wwv_flow_theme_manager.get_field_util(:fb_flow_id,f.id) utilization, ''; ',
'      q :=q||'' wwv_flow_templates_util.label_template_ref_count(:fb_flow_id,f.id) references ''; ',
'      q :=q||''from wwv_flow_field_templates f '';',
'      q :=q||''where f.flow_id = :fb_flow_id '';',
'      q :=q||''  and f.security_group_id = :flow_security_group_id '';',
'      q :=q||''  and (f.theme_id = :P4656_THEME or :p4656_theme = 0) '';               ',
'    end if;',
'',
'    if (nvl(:F4000_P4656_SHOW,''Button'') = ''Button'') then',
'      q :=q||''union all '';',
'      q :=q||''select '';      ',
'      q :=q||''flow_id, '';',
'      q :=q||''theme_id, '';',
'      q :=q||''''''''||l_button||'''''' ttype, '';',
'      q :=q||'' sys.htf.anchor(''''f?p=4000:204:''||:FLOW_SESSION||''::NO:204:F4000_P204_ID:''''||id, '';',
'      q :=q||''wwv_flow_escape.html(TEMPLATE_NAME)) tname, '';      ',
'      q :=q||'' wwv_flow_theme_manager.get_button_util(:fb_flow_id,b.id) utilization, ''; ',
'      q :=q||'' wwv_flow_templates_util.button_template_ref_count(:fb_flow_id,b.id) references ''; ',
'      q :=q||''from wwv_flow_button_templates b '';',
'      q :=q||''where b.flow_id = :fb_flow_id '';',
'      q :=q||''  and b.security_group_id = :flow_security_group_id '';',
'      q :=q||''  and (b.theme_id = :P4656_THEME or :p4656_theme = 0) '';               ',
'    end if;',
'',
'    if (nvl(:F4000_P4656_SHOW,''Menu'') = ''Menu'') then',
'      q :=q||''union all '';',
'      q :=q||''select '';      ',
'      q :=q||''flow_id, '';',
'      q :=q||''theme_id, '';',
'      q :=q||''''''''||l_menu||'''''' ttype, '';',
'      q :=q||'' sys.htf.anchor(''''f?p=4000:289:''||:FLOW_SESSION||''::NO:289:F4000_P289_ID:''''||id, '';',
'      q :=q||''wwv_flow_escape.html(NAME)) tname, '';      ',
'      q :=q||'' wwv_flow_theme_manager.get_menu_util(:fb_flow_id,m.id) utilization, ''; ',
'      q :=q||'' wwv_flow_templates_util.breadcrumb_template_ref_count(:fb_flow_id,m.id) references ''; ',
'      q :=q||''from wwv_flow_menu_templates m '';',
'      q :=q||''where m.flow_id = :fb_flow_id '';',
'      q :=q||''  and m.security_group_id = :flow_security_group_id '';',
'      q :=q||''  and (m.theme_id = :P4656_THEME or :p4656_theme = 0) '';               ',
'    end if;',
'',
'    if (nvl(:F4000_P4656_SHOW,''Calendar'') = ''Calendar'') then',
'      q :=q||''union all '';',
'      q :=q||''select '';            ',
'      q :=q||''flow_id, '';',
'      q :=q||''theme_id, '';',
'      q :=q||''''''''||l_calendar||'''''' ttype, '';',
'      q :=q||'' sys.htf.anchor(''''f?p=4000:122:''||:FLOW_SESSION||''::NO:122:P122_ID:''''||id, '';      ',
'      q :=q||''wwv_flow_escape.html(NAME)) tname, '';      ',
'      q :=q||'' wwv_flow_theme_manager.get_cal_util(:fb_flow_id,l.id) utilization, ''; ',
'      q :=q||'' wwv_flow_templates_util.calendar_template_ref_count(:fb_flow_id,l.id) references ''; ',
'      q :=q||''from wwv_flow_cal_templates l '';',
'      q :=q||''where l.flow_id = :fb_flow_id '';',
'      q :=q||''  and l.security_group_id = :flow_security_group_id '';',
'      q :=q||''  and (l.theme_id = :P4656_THEME or :p4656_theme = 0) '';               ',
'    end if;',
'',
'    if (nvl(:F4000_P4656_SHOW,''TemplateComponent'') = ''TemplateComponent'') then',
'      q :=q||''union all '';',
'      q :=q||''select '';            ',
'      q :=q||''flow_id, '';',
'      q :=q||''theme_id, '';',
'      q :=q||''''''''||l_template_component||'''''' ttype, '';',
'      q :=q||'' sys.htf.anchor(''''f?p=4000:4410:''||:FLOW_SESSION||''::NO:4410:P4410_ID:''''||id, '';      ',
'      q :=q||''wwv_flow_escape.html(builder_name)) tname, '';      ',
'      q :=q||'' wwv_flow_theme_manager.get_template_component_util(:fb_flow_id,l.id) utilization, ''; ',
'      q :=q||'' wwv_flow_templates_util.template_component_ref_count(:fb_flow_id,l.id) references ''; ',
'      q :=q||''from wwv_flow_template_components l '';',
'      q :=q||''where l.flow_id = :fb_flow_id '';',
'      q :=q||''  and l.security_group_id = :flow_security_group_id '';',
'      q :=q||''  and l.theme_id is not null '';',
'      q :=q||''  and (l.theme_id = :P4656_THEME or :p4656_theme = 0) '';               ',
'    end if;',
'',
'    q := ltrim(q,''union all '');',
'    wwv_flow.debug(''XXX-''||q);',
'    q := ''select flow_id, theme_id, ttype, tname, utilization, references from (''||q||'') x where (:P4656_FIND is null or instr(upper(tname),upper(:P4656_FIND))>0)'';',
'    return q;',
'end;'))
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_plug_query_max_columns=>6
,p_query_num_rows=>50
,p_query_options=>'GENERIC_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_break_cols=>'1:2'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48825931314772408)
,p_query_column_id=>1
,p_column_alias=>'COL01'
,p_column_display_sequence=>5
,p_column_heading=>'Application'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48826023690772408)
,p_query_column_id=>2
,p_column_alias=>'COL02'
,p_column_display_sequence=>3
,p_column_heading=>'Theme'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48826100249772408)
,p_query_column_id=>3
,p_column_alias=>'COL03'
,p_column_display_sequence=>1
,p_column_heading=>'Type'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48826220199772408)
,p_query_column_id=>4
,p_column_alias=>'COL04'
,p_column_display_sequence=>2
,p_column_heading=>'Name'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48826311255772408)
,p_query_column_id=>5
,p_column_alias=>'COL05'
,p_column_display_sequence=>4
,p_column_heading=>'References'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48826422081772409)
,p_query_column_id=>6
,p_column_alias=>'COL06'
,p_column_display_sequence=>6
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(114597106818824335)
,p_plug_name=>'Template Filters'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>2
,p_plug_item_display_point=>'BELOW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1599000348644951291)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(1598999842830947024)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5308530733024627)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(114597106818824335)
,p_button_name=>'F4000_P4656_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Go'
,p_request_source=>'GO'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(114610217423836695)
,p_branch_name=>'Go To Page 4656'
,p_branch_action=>'f?p=&APP_ID.:4656:&SESSION.::&DEBUG.:RP:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'GO'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(96115914230357187)
,p_branch_action=>'f?p=&APP_ID.:4656:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>119
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5306702494022579)
,p_name=>'F4000_P4656_SHOW'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(114597106818824335)
,p_prompt=>'Show'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TEMPLATE_REPORT_ON'
,p_lov=>'.'||wwv_flow_imp.id(84836411424340211)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- All Templates -'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Select the type of templates to display and click <strong>Go</strong>. Options include: <strong>Templates Referenced</strong>, <strong>Templates Not Referenced</strong>, and <strong>All Templates </strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(62036901141708268)
,p_name=>'P4656_THEME'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_imp.id(114597106818824335)
,p_item_default=>'0'
,p_prompt=>'Theme'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION THEMES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select theme_id||''. '' ||wwv_flow_escape.html(theme_name) d, theme_id',
'  from wwv_flow_themes',
' where flow_id = nvl(:P224_A, :fb_flow_id)',
'   and security_group_id = :flow_security_group_id',
' order by theme_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- All -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a theme and click <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(96064730928917258)
,p_name=>'P4656_FIND'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(114597106818824335)
,p_prompt=>'Template Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter case insensitive query criteria for template name and press <strong>Go</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
end;
/
prompt --application/pages/page_04716
begin
wwv_flow_imp_page.create_page(
 p_id=>4716
,p_name=>'Create Page - Navigation Menu / Tabs'
,p_alias=>'CREATE-PAGE-NAVIGATION-MENU-TABS'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Page'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(11511713242614593)
,p_javascript_code_onload=>'apex.util.getTopApex().jQuery(".ui-dialog--apex .ui-dialog-title").text($v("P4716_PAGE_TITLE"));'
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5439406785188009)
,p_plug_name=>'Create Page'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P2500_NAVIGATION_TYPE'
,p_plug_display_when_cond2=>'L'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(5438818215188007)
,p_name=>'Tabs'
,p_parent_plug_id=>wwv_flow_imp.id(5439406785188009)
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''<a title="click to set tab set" href="javascript:$x_Value(''''P4716_TAB_SET'''',''''''||',
'       wwv_flow_javascript.escape(tab_set)||',
'       '''''');">''||',
'       wwv_flow_escape.html(tab_set)||',
'       ''</a>'' tab_set, ',
'       tab_step, ',
'       substr(tab_text,1,30) tab_text,',
'       replace(TAB_ALSO_CURRENT_FOR_PAGES,'','','', '') tacfp',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID and ',
'       security_group_id = :flow_security_group_id',
'order  by tab_set, TAB_SEQUENCE, tab_step'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>'No tabs or tab sets exist.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5439024987188008)
,p_query_column_id=>1
,p_column_alias=>'TAB_SET'
,p_column_display_sequence=>1
,p_column_heading=>'Tab Set'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5439118949188008)
,p_query_column_id=>2
,p_column_alias=>'TAB_STEP'
,p_column_display_sequence=>2
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5439202581188008)
,p_query_column_id=>3
,p_column_alias=>'TAB_TEXT'
,p_column_display_sequence=>3
,p_column_heading=>'Tab'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5439300381188008)
,p_query_column_id=>4
,p_column_alias=>'TACFP'
,p_column_display_sequence=>4
,p_column_heading=>'Also&nbsp;Current&nbsp;For'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6783914938961087)
,p_plug_name=>'progress'
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    c_app_id  constant number := wwv_flow_security.get_translated_flow_id;',
'    c_page_id constant number := wwv_flow_security.get_translated_id( :P4716_PREV_PAGE_ID );',
'begin',
'    -- Get the progress train from our previous wizard step and render the same progress',
'    -- train on this shared "Navigation Menu" wizard page. This will avoid that we have',
'    -- to have x number of conditional progress train regions on this page.',
'    for l_list in ( select id as region_id,',
'                           list_id,',
'                           list_template_id,',
'                           region_sub_css_classes,',
'                           component_template_options',
'                      from wwv_flow_page_plugs',
'                     where flow_id = c_app_id',
'                       and page_id = c_page_id',
'                       and plug_display_point = ''REGION_POSITION_01'' )',
'    loop',
'        wwv_flow_region_native.render_list (',
'            p_region_id               => l_list.region_id,',
'            p_list_id                 => l_list.list_id,',
'            p_list_template_id        => l_list.list_template_id,',
'            p_region_sub_css_classes  => l_list.region_sub_css_classes,',
'            p_region_template_options => l_list.component_template_options );',
'        exit;',
'    end loop;',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(44009705261558987)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(925258843485540203)
,p_plug_name=>'List Based Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_translate_title=>'N'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P2500_NAVIGATION_TYPE'
,p_plug_display_when_cond2=>'L'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5439602032188009)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(44009705261558987)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5439802675188010)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(44009705261558987)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5440008510188010)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(44009705261558987)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(5446523773188018)
,p_branch_name=>'Go To Next Wizard Page'
,p_branch_action=>'declare'||wwv_flow.LF||
'    l_list_id                    number;'||wwv_flow.LF||
'    l_list_item_display_sequence number;'||wwv_flow.LF||
'begin'||wwv_flow.LF||
'    -- 1) Get the progress train from our previous wizard step'||wwv_flow.LF||
'    -- 2) In that process train, find the list item entry for our current page,'||wwv_flow.LF||
'    --    this query will always find two entries (Navigation Menu, Tabs). We are'||wwv_flow.LF||
'    --    just interested in the last entry.'||wwv_flow.LF||
'    select max( li.list_id ),'||wwv_flow.LF||
'           max( li.list_item_display_sequence )'||wwv_flow.LF||
'      into l_list_id,'||wwv_flow.LF||
'           l_list_item_display_sequence'||wwv_flow.LF||
'      from wwv_flow_page_plugs r,'||wwv_flow.LF||
'           wwv_flow_list_items li'||wwv_flow.LF||
'     where r.security_group_id            = 10'||wwv_flow.LF||
'       and r.flow_id                      = :APP_ID'||wwv_flow.LF||
'       and r.page_id                      = :P4716_PREV_PAGE_ID'||wwv_flow.LF||
'       and r.plug_display_point           = ''REGION_POSITION_01'''||wwv_flow.LF||
'       and li.security_group_id           = 10'||wwv_flow.LF||
'       and li.flow_id                     = :APP_ID'||wwv_flow.LF||
'       and li.list_id                     = r.list_id'||wwv_flow.LF||
'       and li.list_item_current_for_pages = :APP_PAGE_ID;'||wwv_flow.LF||
''||wwv_flow.LF||
'    -- 3) Based on that list item entry, find the target page of the next valid wizard step in the list'||wwv_flow.LF||
'    for l_items in ('||wwv_flow.LF||
'        select list_item_current_for_pages as next_page_id,'||wwv_flow.LF||
'               list_item_disp_cond_type,'||wwv_flow.LF||
'               list_item_disp_condition,'||wwv_flow.LF||
'               list_item_disp_condition2'||wwv_flow.LF||
'          from wwv_flow_list_items'||wwv_flow.LF||
'         where security_group_id          = 10'||wwv_flow.LF||
'           and flow_id                    = :APP_ID'||wwv_flow.LF||
'           and list_id                    = l_list_id'||wwv_flow.LF||
'           and list_item_display_sequence > l_list_item_display_sequence'||wwv_flow.LF||
'         order by list_item_display_sequence )'||wwv_flow.LF||
'    loop'||wwv_flow.LF||
'        if wwv_flow_conditions.standard_condition ('||wwv_flow.LF||
'               p_condition_type => l_items.list_item_disp_cond_type,'||wwv_flow.LF||
'               p_condition      => l_items.list_item_disp_condition,'||wwv_flow.LF||
'               p_condition2     => l_items.list_item_disp_condition2 )'||wwv_flow.LF||
'        then'||wwv_flow.LF||
'            -- For the confirmation page of the master-detail wizard we have to set the previous page'||wwv_flow.LF||
'            --:P35_PREV_PAGE := :APP_PAGE_ID;'||wwv_flow.LF||
'            --'||wwv_flow.LF||
'            return case'||wwv_flow.LF||
'                     -- If the next process step is used by multiple pages, use the first page for navigation'||wwv_flow.LF||
'                     when instr( l_items.next_page_id, '','' ) > 0 then'||wwv_flow.LF||
'                          substr( l_items.next_page_id, 1, instr( l_items.next_page_id, '','' ) - 1 )'||wwv_flow.LF||
'                     when instr( l_items.next_page_id, '':'' ) > 0 then'||wwv_flow.LF||
'                          substr( l_items.next_page_id, 1, instr( l_items.next_page_id, '':'' ) - 1 )'||wwv_flow.LF||
'                     else l_items.next_page_id'||wwv_flow.LF||
'                   end;'||wwv_flow.LF||
'        end if;'||wwv_flow.LF||
'    end loop;'||wwv_flow.LF||
'    return null;'||wwv_flow.LF||
'end;'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_FUNCTION_RETURNING_PAGE'
,p_branch_language=>'PLSQL'
,p_branch_when_button_id=>wwv_flow_imp.id(5439802675188010)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(5446908760188018)
,p_branch_name=>'Go To Previous Wizard Page'
,p_branch_action=>'f?p=&APP_ID.:&P4716_PREV_PAGE_ID.:&SESSION.::&DEBUG.::::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(5440008510188010)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5440211507188010)
,p_name=>'P4716_TAB_SET'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(5439406785188009)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   t varchar2(4000);',
'begin',
'   for c1 in (',
'select tab_set, count(*) c',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID and ',
'       security_group_id = :flow_security_group_id',
'group  by tab_set',
'order by 2 desc) loop',
'return c1.tab_set;',
'exit;',
'end loop;',
'return null;',
'end;',
''))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Tab Set'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_TABSETS'
,p_lov=>'select wwv_flow_escape.html(d) d, r from wwv_flow_tabset_view'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Tab Set -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Select the tab set you wish to use for this page.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5440714773188011)
,p_name=>'P4716_TAB_OPTIONS'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(5439406785188009)
,p_item_default=>'0'
,p_prompt=>'Tab Options:'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.TAB.OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(35310611267199336)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Specify whether this page should have tabs and click <strong>Next</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5441711984188012)
,p_name=>'P4716_TAB_LABEL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(5439406785188009)
,p_prompt=>'New Tab Label'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the label for the tab that will be created. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5442201058188012)
,p_name=>'P4716_TAB_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(5439406785188009)
,p_prompt=>'Use Tab'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(TAB_NAME)||'': label="''||wwv_flow_escape.html(substr(TAB_TEXT,1,40))||''"'' tab_text,tab_name',
'from   wwv_flow_tabs',
'where  flow_id = :fb_flow_id and',
'       security_group_id = :flow_security_group_id and',
'       tab_set = :P4716_TAB_SET'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Tab -'
,p_lov_cascade_parent_items=>'P4716_TAB_SET'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Select the tab to be designated as "current" for this page.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(925258727506540202)
,p_name=>'P4716_NAVLIST_OPTIONS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(925258843485540203)
,p_item_default=>'NONE'
,p_prompt=>'Navigation Preference'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'WIZARD.NAVIGATIONLIST.OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(925221062390507339)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select how you want this page integrated into the Navigation Menu.<p/>',
'<ul>',
'    <li><strong>Do not associate this page with a Navigation Menu entry</strong> - The new page will not be current or highlighted for any menu entry.</li>',
'    <li><strong>Create a new Navigation Menu entry</strong> - Users will be able to navigate to the new page directly from the Navigation Menu. The new entry can be placed anywhere in the existing hierarchy.</li>',
'    <li><strong>Identify an existing Navigation Menu entry which will be current for this page</strong> - Use this option when you want the new page to highlight an existing, top level, menu entry. Users will not be able to navigate to the new page d'
||'irectly from the Navigation Menu. Therefore, You will need to create or define a navigation control on the top level page selected, such as a button, or link in a report, to go to this new page.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(925259067142540205)
,p_name=>'P4716_NAVLIST_PARENT_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(925258843485540203)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cHeight=>7
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select a navigation parent for your new page. When creating a new navigation item, the new item links to',
'the new page. The new item can be added at the top level, by not selecting any parent item, or shown as a child',
'of an existing item. </p>',
'',
'<p>When selecting item without creating a new item, the selected item determines which top level item is shown',
'as the "current" item.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(925259133577540206)
,p_name=>'P4716_NAVLIST_ENTRY_NAME'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_imp.id(925258843485540203)
,p_prompt=>'New Navigation Menu Entry'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Enter a name for the new menu control.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(936748980980404408)
,p_name=>'P4716_NAVLIST_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(925258843485540203)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cHeight=>1
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(969051498795554601)
,p_name=>'P4716_PREV_PAGE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(6783914938961087)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(969051719295554604)
,p_name=>'P4716_PAGE_TITLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(6783914938961087)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1340197749667591930)
,p_name=>'P4716_EXISTING_PARENT_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(925258843485540203)
,p_prompt=>'Existing Navigation Menu Entry'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case',
'           when (nvl(list_item_link_target,''0'')=''0'' or parent_list_item_id is null) then',
'               lpad('' '',(4*(level-1)),''.'')||list_item_link_text',
'           else',
'               lpad('' '',(4*(level-1)),''.'')||'' (''||list_item_link_text ||'')''',
'       end name,',
'       id',
'  from wwv_flow_list_items',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
' start with list_id = :P4716_NAVLIST_ID and parent_list_item_id is null',
'connect by prior list_id = list_id and prior id = parent_list_item_id',
' order siblings by list_item_display_sequence'))
,p_cHeight=>7
,p_tag_css_classes=>'a-Form-select--multi'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Select an existing menu control to be shown as the active menu control when rendering the new page. ',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1340201294813626612)
,p_name=>'P4716_NEW_PARENT_ID'
,p_item_sequence=>35
,p_item_plug_id=>wwv_flow_imp.id(925258843485540203)
,p_prompt=>'Parent Navigation Menu Entry'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case',
'           when (nvl(list_item_link_target,''0'')=''0'' or parent_list_item_id is null) then',
'               lpad('' '',(4*(level-1)),''.'')||list_item_link_text',
'           else',
'               lpad('' '',(4*(level-1)),''.'')||'' (''||list_item_link_text ||'')''',
'       end name,',
'       id',
'  from wwv_flow_list_items',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
' start with list_id = :P4716_NAVLIST_ID and parent_list_item_id is null',
'connect by prior list_id = list_id and prior id = parent_list_item_id',
' order siblings by list_item_display_sequence'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No parent selected - '
,p_cHeight=>7
,p_tag_css_classes=>'a-Form-select--multi'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'a-Form-fieldContainer--boxLabels'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select an existing menu control if you wish to add a menu entry for the new page to this menu control. ',
'When not selecting an existing menu control, a menu control for the new page will be created at the to level.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(5443705390188015)
,p_computation_sequence=>10
,p_computation_item=>'P4716_TAB_SET'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P4716_TAB_OPTIONS'
,p_compute_when_text=>'0'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(5443919237188016)
,p_computation_sequence=>20
,p_computation_item=>'P4716_TAB_NAME'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P4716_TAB_OPTIONS'
,p_compute_when_text=>'1'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(5444100706188016)
,p_computation_sequence=>30
,p_computation_item=>'P4716_TAB_LABEL'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P4716_TAB_OPTIONS'
,p_compute_when_text=>'2'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(940899910291433100)
,p_computation_sequence=>40
,p_computation_item=>'P4716_NAVLIST_ENTRY_NAME'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>'return null;'
,p_compute_when=>'P4716_NAVLIST_OPTIONS'
,p_compute_when_text=>'NEW'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1340221674681794212)
,p_computation_sequence=>50
,p_computation_item=>'P4716_NAVLIST_PARENT_ID'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P4716_NEW_PARENT_ID'
,p_compute_when=>'P4716_NAVLIST_OPTIONS'
,p_compute_when_text=>'NEW'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1340221956836801876)
,p_computation_sequence=>60
,p_computation_item=>'P4716_NAVLIST_PARENT_ID'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P4716_EXISTING_PARENT_ID'
,p_compute_when=>'P4716_NAVLIST_OPTIONS'
,p_compute_when_text=>'EXISTING'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(969051846428554605)
,p_computation_sequence=>10
,p_computation_item=>'P4716_PAGE_TITLE'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_prev_page in (select step_title',
'                    from wwv_flow_steps',
'                    where flow_id = :APP_TRANSLATION_ID',
'                    and id = ( select wwv_flow_security.get_translated_id( :P4716_PREV_PAGE_ID ) from dual ))',
'loop',
'    return wwv_flow_session_state.do_raw_substitutions( p_string => l_prev_page.step_title);',
'end loop;'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(936755246151435875)
,p_computation_sequence=>40
,p_computation_item=>'P4716_NAVLIST_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select navigation_list_id',
'  from wwv_flows',
' where id                = :fb_flow_id',
'   and security_group_id = :workspace_id'))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5444326089188016)
,p_validation_name=>'tab set not null'
,p_validation_sequence=>10
,p_validation=>'P4716_TAB_SET'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'P4716_TAB_OPTIONS'
,p_validation_condition2=>'1:2'
,p_validation_condition_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
,p_when_button_pressed=>wwv_flow_imp.id(5439802675188010)
,p_associated_item=>wwv_flow_imp.id(5440211507188010)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5444515315188016)
,p_validation_name=>'tab label not null'
,p_validation_sequence=>20
,p_validation=>'P4716_TAB_LABEL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'P4716_TAB_OPTIONS'
,p_validation_condition2=>'1'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(5439802675188010)
,p_associated_item=>wwv_flow_imp.id(5441711984188012)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5444716260188016)
,p_validation_name=>'tab name not null'
,p_validation_sequence=>30
,p_validation=>'P4716_TAB_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must be specified.'
,p_validation_condition=>'P4716_TAB_OPTIONS'
,p_validation_condition2=>'2'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(5439802675188010)
,p_associated_item=>wwv_flow_imp.id(5442201058188012)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1104689937872514441)
,p_validation_name=>'New Entry with no List'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ''x''',
'from wwv_flow_list_items',
'where flow_id = :FB_FLOW_ID',
'and list_id = :P4716_NAVLIST_ID',
'and parent_list_item_id is null',
'and rownum = 1'))
,p_validation_type=>'EXISTS'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'You must associate a navigation menu list to use this preference. Go to Shared Components, User Interface Attributes, select the appropriate User Interface, then select a Navigation Menu List.<br>',
'Alternatively, do not associate this page with a navigation menu entry.'))
,p_validation_condition=>':P4716_NAVLIST_OPTIONS = ''NEW'' and :P2500_NAVIGATION_TYPE = ''L'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(925258727506540202)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(937697826722470958)
,p_validation_name=>'P4716_NAVLIST_ENTRY_NAME'
,p_validation_sequence=>50
,p_validation=>'P4716_NAVLIST_ENTRY_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Entry name is required for new navigation items'
,p_validation_condition=>':P2500_NAVIGATION_TYPE=''L'' and :P4716_NAVLIST_OPTIONS=''NEW'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(925259133577540206)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1104689811335514440)
,p_validation_name=>'Existing Entry with no List'
,p_validation_sequence=>60
,p_validation=>'P4716_EXISTING_PARENT_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'You must associate a navigation menu list to use this preference. Go to Shared Components, User Interface Attributes, select the appropriate User Interface, then select a Navigation Menu List.<br>',
'Alternatively, do not associate this page with a navigation menu entry.'))
,p_validation_condition=>'P4716_NAVLIST_OPTIONS'
,p_validation_condition2=>'EXISTING'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(925258727506540202)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2946760607940956)
,p_validation_name=>'Navigation Menu not subscribed'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * ',
'  from wwv_flow_lists',
' where id                = :P4716_NAVLIST_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and reference_id      is not null'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'&APP_TEXT$NAVIGATION_MENU_SUBSCRIBED!RAW.'
,p_validation_condition=>':P4716_NAVLIST_OPTIONS in ( ''NEW'', ''EXISTING'' ) and :P4716_NAVLIST_ID is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(925258727506540202)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5444809065188016)
,p_name=>'Tab Option 0 Settings'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4716_TAB_OPTIONS'
,p_condition_element=>'P4716_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'0'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5445119643188017)
,p_event_id=>wwv_flow_imp.id(5444809065188016)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4716_TAB_SET,P4716_TAB_LABEL,P4716_TAB_NAME'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5445227826188017)
,p_name=>'Tab Option 1 Settings'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4716_TAB_OPTIONS'
,p_condition_element=>'P4716_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'1'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5445530793188017)
,p_event_id=>wwv_flow_imp.id(5445227826188017)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4716_TAB_SET,P4716_TAB_LABEL'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5445712868188017)
,p_event_id=>wwv_flow_imp.id(5445227826188017)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4716_TAB_NAME'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5445816848188017)
,p_name=>'Tab Option 2 Settings'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4716_TAB_OPTIONS'
,p_condition_element=>'P4716_TAB_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'2'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5446102367188018)
,p_event_id=>wwv_flow_imp.id(5445816848188017)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4716_TAB_SET,P4716_TAB_NAME'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5446329768188018)
,p_event_id=>wwv_flow_imp.id(5445816848188017)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4716_TAB_LABEL'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(548119885642282099)
,p_name=>'Cancel Dialog'
,p_event_sequence=>40
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(5439602032188009)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(548120199421282099)
,p_event_id=>wwv_flow_imp.id(548119885642282099)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(936775814888831027)
,p_name=>'P4716_NAVLIST_ENTRY_NAME'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4716_NAVLIST_OPTIONS'
,p_condition_element=>'P4716_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(936776136685831028)
,p_event_id=>wwv_flow_imp.id(936775814888831027)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4716_NAVLIST_ENTRY_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(936776335190831028)
,p_event_id=>wwv_flow_imp.id(936775814888831027)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4716_NAVLIST_ENTRY_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(936776455074838833)
,p_name=>'P4716_NEW_PARENT_ID'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4716_NAVLIST_OPTIONS'
,p_condition_element=>'P4716_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NEW'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(936776715832838833)
,p_event_id=>wwv_flow_imp.id(936776455074838833)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4716_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(936776950625838833)
,p_event_id=>wwv_flow_imp.id(936776455074838833)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4716_NEW_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1340208425559737369)
,p_name=>'P4716_EXISTING_PARENT_ID'
,p_event_sequence=>65
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4716_NAVLIST_OPTIONS'
,p_condition_element=>'P4716_NAVLIST_OPTIONS'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'EXISTING'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1340208725480737371)
,p_event_id=>wwv_flow_imp.id(1340208425559737369)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4716_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1340209077932743788)
,p_event_id=>wwv_flow_imp.id(1340208425559737369)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4716_EXISTING_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1119158641361390649)
,p_name=>'Set Dialog Title'
,p_event_sequence=>90
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1119158745964390650)
,p_event_id=>wwv_flow_imp.id(1119158641361390649)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'window.parent.$( "#apex_dialog_page" ).dialog( "option", "title", "&P4716_PAGE_TITLE!JS." );'
);
end;
/
prompt --application/pages/page_04722
begin
wwv_flow_imp_page.create_page(
 p_id=>4722
,p_name=>'Create Standard Tab - Current Page'
,p_alias=>'CREATE-STANDARD-TAB-CURRENT-PAGE'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Standard Tab'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213240607818867991)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(680079518)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(100922117111440207)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_plug_query_headings=>'Item:Seq:Region'
,p_plug_query_num_rows=>1500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_row_count_max=>5000
,p_plug_query_show_nulls_as=>'-'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(985967059)
,p_plug_name=>'Create Standard Tab'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>91
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_break_cols=>'1'
,p_plug_header=>'<div class="htmldbInfoBodyP">You must define a "current page" for this tab. When the user clicks on the tab, the application will branch to this page.</div>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(137385505969)
,p_name=>'Existing Tab Sets'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>130
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select tab_set, tab_sequence, tab_step, wwv_flow_escape.html(substr(tab_text,1,30)) tab_text, TAB_ALSO_CURRENT_FOR_PAGES',
'from   wwv_flow_tabs',
'where  flow_id = :FB_FLOW_ID and ',
'           security_group_id = :flow_security_group_id',
'order  by 1, 2'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' -'
,p_query_break_cols=>'1'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48629207759771310)
,p_query_column_id=>1
,p_column_alias=>'TAB_SET'
,p_column_display_sequence=>1
,p_column_heading=>'Tab Set'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48629306426771310)
,p_query_column_id=>2
,p_column_alias=>'TAB_SEQUENCE'
,p_column_display_sequence=>2
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48629415625771310)
,p_query_column_id=>3
,p_column_alias=>'TAB_STEP'
,p_column_display_sequence=>3
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48629505756771310)
,p_query_column_id=>4
,p_column_alias=>'TAB_TEXT'
,p_column_display_sequence=>4
,p_column_heading=>'Label'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(199996925491685170)
,p_query_column_id=>5
,p_column_alias=>'TAB_ALSO_CURRENT_FOR_PAGES'
,p_column_display_sequence=>5
,p_column_heading=>'Tab Also Current For Pages'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46534921875718778)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>150
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(199994127784676324)
,p_name=>'Existing Pages'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>140
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id, name ',
'from wwv_flow_steps ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'order by 1'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>5000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(199994703403676341)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>1
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(199994819564676342)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(130416677537)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_imp.id(46534921875718778)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(130411585073)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(46534921875718778)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(101093920424829050)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46534921875718778)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(130418785046)
,p_branch_action=>'4723'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(130411585073)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1829407077332002)
,p_branch_action=>'f?p=&FLOW_ID.:4723:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(101094305835829054)
,p_branch_action=>'96'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(101093920424829050)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(130414639866)
,p_name=>'F4000_P4722_CURRENT_PAGE'
,p_item_sequence=>3
,p_item_plug_id=>wwv_flow_imp.id(985967059)
,p_prompt=>'Tab Current for Page'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d',
'  from wwv_flow_steps',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and is_page_pattern   = ''N''',
'order by 2'))
,p_cSize=>16
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the page that makes this tab current. Required. When the user clicks on this tab, the application will navigate to this page number.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(130435396582)
,p_name=>'F4000_P4722_F'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(985967059)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application:'
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="fieldtitlebold"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(130423109743)
,p_validation_name=>'Tab Current Page must not be null'
,p_validation_sequence=>10
,p_validation=>'F4000_P4722_CURRENT_PAGE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Current page ID must be specified.'
,p_associated_item=>wwv_flow_imp.id(130414639866)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(8021411222024630)
,p_validation_name=>'validate also current for'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :F4000_P4722_CURRENT_PAGE is null then',
'return true;',
'elsif rtrim(translate(:F4000_P4722_CURRENT_PAGE,''0123456789, '',''00000000000''),''0'') is not null then',
'return false;',
'end if;',
'return true;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Specify page number separated by commas, for example: 1,2,3'
,p_associated_item=>wwv_flow_imp.id(130414639866)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(573756645794229747)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(130416677537)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(573756771417229748)
,p_event_id=>wwv_flow_imp.id(573756645794229747)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_04723
begin
wwv_flow_imp_page.create_page(
 p_id=>4723
,p_name=>'Create Standard Tab - Sequence and Images'
,p_alias=>'CREATE-STANDARD-TAB-SEQUENCE-AND-IMAGES'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Standard Tab'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213240607818867991)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(682087822)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(100922117111440207)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_plug_query_headings=>'Item:Seq:Region'
,p_plug_query_num_rows=>1500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_row_count_max=>5000
,p_plug_query_show_nulls_as=>'-'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(130419789518)
,p_plug_name=>'Create Standard Tab'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>91
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_break_cols=>'1'
,p_plug_header=>'<p>Identify the tab sequence and optional image attributes.  If no images are provided the tab will be displayed as text.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(130421823300)
,p_name=>'Tab Set'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>310
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select tab_sequence "Sequence", tab_text "TabName",tab_step "PageName" from wwv_flow_tabs ',
'where flow_id = :FB_FLOW_ID ',
'and tab_set = :f4000_p4722_tabset',
'and security_group_id = :flow_security_group_id',
'order by 1, 2'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>150
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48927608288773128)
,p_query_column_id=>1
,p_column_alias=>'Sequence'
,p_column_display_sequence=>1
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48927717393773128)
,p_query_column_id=>2
,p_column_alias=>'TabName'
,p_column_display_sequence=>2
,p_column_heading=>'Tabname'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48927808793773129)
,p_query_column_id=>3
,p_column_alias=>'PageName'
,p_column_display_sequence=>3
,p_column_heading=>'Pagename'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46535508846724523)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>320
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(130422866033)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_imp.id(46535508846724523)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(130428277483)
,p_button_sequence=>2
,p_button_plug_id=>wwv_flow_imp.id(46535508846724523)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(130427275874)
,p_button_sequence=>3
,p_button_plug_id=>wwv_flow_imp.id(46535508846724523)
,p_button_name=>'Back'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(130429278854)
,p_branch_action=>'4724'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(130428277483)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(130430280034)
,p_branch_action=>'4722'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(130427275874)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(130432369096)
,p_name=>'F4000_P4722_TAB_SEQUENCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(130419789518)
,p_item_default=>'10'
,p_prompt=>'Sequence'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'',
'  s number := 0;',
'',
'begin',
'',
'  for c1 in (select max(tab_sequence) s',
'',
'             from wwv_flow_tabs',
'',
'             where flow_id = :FB_FLOW_ID',
'',
'             and tab_set = :F4000_P4722_TABSET',
'',
'             ) loop',
'',
'          s := c1.s;',
'',
'  end loop;',
'',
'',
'',
'  return trunc(s) + 10;',
'',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>8
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the sequence for this component. The sequence determines the order of evaluation.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(130433377035)
,p_name=>'F4000_P4723_TS'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(130419789518)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tab Set:'
,p_source=>'F4000_P4722_TABSET'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="fieldtitlebold"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the selected tab set.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(130434386486)
,p_name=>'F4000_P4723_TN'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_imp.id(130419789518)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Label:'
,p_source=>'F4000_P4722_NEW_TAB_DISPLAY_TEXT'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="fieldtitlebold"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the tab label.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(130436450411)
,p_name=>'F4000_P4722_CURRENT_IMAGE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(130419789518)
,p_prompt=>'Current Image'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Defines the image that displays when the tab is selected (or "current"). Do not prefix the image. A prefix will be added.',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(130438459104)
,p_name=>'F4000_P4722_NON_CURRENT_IMAGE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(130419789518)
,p_prompt=>'Non Current Image'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Defines the image that displays when the tab is not selected (or "non current"). If you want to use the same image regardless of whether the tab is selected, enter the same image name as entered in Current Image.</div>',
'<div class="htmldbInfoBodyP">Do not prefix the image. A prefix will be added.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(130439464122)
,p_name=>'F4000_P4722_IMAGE_ATTRIBUTES'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(130419789518)
,p_prompt=>'Image Attributes'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Image attributes specify image height and width. For example:</div>',
'<pre>height="20" width="50"</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(185776224880388599)
,p_validation_name=>'Sequence is numeric'
,p_validation_sequence=>10
,p_validation=>'F4000_P4722_TAB_SEQUENCE'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'A numeric sequence must be entered.'
,p_when_button_pressed=>wwv_flow_imp.id(130428277483)
,p_associated_item=>wwv_flow_imp.id(130432369096)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(185777009081393480)
,p_validation_name=>'Sequence Not Null'
,p_validation_sequence=>20
,p_validation=>'F4000_P4722_TAB_SEQUENCE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'A numeric sequence must be entered.'
,p_when_button_pressed=>wwv_flow_imp.id(130428277483)
,p_associated_item=>wwv_flow_imp.id(130432369096)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(573756418841229745)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(130422866033)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(573756569343229746)
,p_event_id=>wwv_flow_imp.id(573756418841229745)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_04724
begin
wwv_flow_imp_page.create_page(
 p_id=>4724
,p_name=>'Create Standard Tab - Display Conditions'
,p_alias=>'CREATE-STANDARD-TAB-DISPLAY-CONDITIONS'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Standard Tab'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213240607818867991)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(683094383)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(100922117111440207)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_plug_query_headings=>'Item:Seq:Region'
,p_plug_query_num_rows=>1500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_row_count_max=>5000
,p_plug_query_show_nulls_as=>'-'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(130441495589)
,p_plug_name=>'Create Standard Tab'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>91
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>1500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_row_count_max=>5000
,p_plug_query_show_nulls_as=>'-'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(283597086572)
,p_name=>'Existing Page Items'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>130
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, item_sequence, (select plug_name from wwv_flow_page_plugs where id = item_plug_id) item_plug_id',
'from   wwv_flow_step_items',
'where  flow_id = :FB_FLOW_ID ',
'and flow_step_id = :FB_FLOW_PAGE_ID',
'and security_group_id = :flow_security_group_id',
'order  by name'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>5000
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48893700809772777)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Item'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48893825234772777)
,p_query_column_id=>2
,p_column_alias=>'ITEM_SEQUENCE'
,p_column_display_sequence=>2
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48893908730772777)
,p_query_column_id=>3
,p_column_alias=>'ITEM_PLUG_ID'
,p_column_display_sequence=>3
,p_column_heading=>'Region'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46536700451741043)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>140
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(130443503109)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_imp.id(46536700451741043)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(101366802088325250)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(46536700451741043)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(130444509860)
,p_button_sequence=>3
,p_button_plug_id=>wwv_flow_imp.id(46536700451741043)
,p_button_name=>'Back'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(101367204560325253)
,p_branch_action=>'92'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(101366802088325250)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(130445511451)
,p_branch_action=>'4723'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(130444509860)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(130448555739)
,p_name=>'F4000_P4722_DISPLAY_CONDITION'
,p_item_sequence=>29
,p_item_plug_id=>wwv_flow_imp.id(130441495589)
,p_prompt=>'Expression 1'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>32767
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Use this attribute to conditionally control whether or not a component is rendered or processed. Enter values in this attribute based on the specific condition type you select. The component will be rendered or processed if the specified condition is'
||' met.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(130449564532)
,p_name=>'F4000_P4722_CONDITION_TYPE'
,p_item_sequence=>9
,p_item_plug_id=>wwv_flow_imp.id(130441495589)
,p_prompt=>'Condition Type'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CONDITION_LIST'
,p_named_lov=>'STANDARD_CONDITION_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(13602414170805697)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Display Condition -'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a condition type from the list. This condition must be met in order for this component to be rendered or processed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'F4000_P4722_DISPLAY_CONDITION'
,p_attribute_02=>'F4000_P4722_DISPLAY_CONDITION_TEXT'
,p_attribute_04=>'F4000_P4722_DISPLAY_CONDITION_CHECK'
,p_attribute_06=>'WIZARD'
,p_attribute_07=>'F4000_P4722_CONDITION_LANG'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(130450570735)
,p_name=>'F4000_P4722_BUILD_OPTION'
,p_item_sequence=>59
,p_item_plug_id=>wwv_flow_imp.id(130441495589)
,p_prompt=>'Build Option'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PATCHES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(patch_name) pn, id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'', wwv_flow_escape.html(patch_name))||',
'''} '' pn,0-id id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by pn'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Build Option -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a build option for this component. Build options are predefined settings that determine whether or not  components within an application are enabled.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(130451602030)
,p_name=>'F4000_P4724_TN'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(130441495589)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tab Name:'
,p_source=>'F4000_P4722_NEW_TAB_DISPLAY_TEXT'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="fieldtitlebold"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the selected tab name.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(130452610308)
,p_name=>'F4000_P4724_TCP'
,p_item_sequence=>3
,p_item_plug_id=>wwv_flow_imp.id(130441495589)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Current for Page:'
,p_source=>'F4000_P4722_CURRENT_PAGE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="fieldtitlebold"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identifies the selected application page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(130453615959)
,p_name=>'F4000_P4724_TS'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_imp.id(130441495589)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tab Set:'
,p_source=>'F4000_P4722_TABSET'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_attributes=>'class="fieldtitlebold"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the selected tab set.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(283591027500)
,p_name=>'F4000_P4722_DISPLAY_CONDITION_TEXT'
,p_item_sequence=>49
,p_item_plug_id=>wwv_flow_imp.id(130441495589)
,p_prompt=>'Expression 2'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>32767
,p_cHeight=>2
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Some condition types require two expressions for comparison. Enter the second expression or item here.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2304966721464434)
,p_name=>'F4000_P4722_CONDITION_LANG'
,p_item_sequence=>19
,p_item_plug_id=>wwv_flow_imp.id(130441495589)
,p_prompt=>'Language'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select a language that is used to evaluate the entered programming code.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(435044829650654798)
,p_name=>'F4000_P4722_DISPLAY_CONDITION_CHECK'
,p_item_sequence=>39
,p_item_plug_id=>wwv_flow_imp.id(130441495589)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Do not validate code (parse code at runtime only).'
,p_source=>'NULL'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(573756235976229743)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(130443503109)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(573756307595229744)
,p_event_id=>wwv_flow_imp.id(573756235976229743)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_04725
begin
wwv_flow_imp_page.create_page(
 p_id=>4725
,p_name=>'Create Parent Tab - Parent Tab'
,p_alias=>'CREATE-PARENT-TAB-PARENT-TAB'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Parent Tab'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213240607818867991)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(684379911)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(100804924518345585)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_plug_query_headings=>'TabSet:Seq:Name:Target'
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_break_cols=>'1'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(130505887827)
,p_plug_name=>'Create Parent Tab '
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>91
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>1500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_row_count_max=>5000
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_break_cols=>'1'
,p_plug_header=>'<p>A Parent Tab functions as a container to hold a group of Standard Tabs. Parent Tabs give users another level of navigation as well as a sense of place within the application. Use Parent Tab Label to specify the tab display text.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(137383461413)
,p_name=>'Existing Parent Tabs'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>200
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select tab_set, tab_sequence, tab_name, tab_text',
'from   wwv_flow_toplevel_tabs',
'where  flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'order  by 1, 2'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>150
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'1'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48628609033771307)
,p_query_column_id=>1
,p_column_alias=>'TAB_SET'
,p_column_display_sequence=>1
,p_column_heading=>'Tab Set'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48628722487771307)
,p_query_column_id=>2
,p_column_alias=>'TAB_SEQUENCE'
,p_column_display_sequence=>2
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48628815663771307)
,p_query_column_id=>3
,p_column_alias=>'TAB_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48628905084771307)
,p_query_column_id=>4
,p_column_alias=>'TAB_TEXT'
,p_column_display_sequence=>4
,p_column_heading=>'Label'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46507423720877216)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>210
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(130510928901)
,p_button_sequence=>2
,p_button_plug_id=>wwv_flow_imp.id(46507423720877216)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(130511932578)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_imp.id(46507423720877216)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(130512938502)
,p_branch_action=>'4726'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(130513963435)
,p_name=>'F4000_P4725_TABSET'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(130505887827)
,p_prompt=>'Parent Tab Set'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PARENT_TABSETS'
,p_lov=>'select distinct wwv_flow_escape.html(tab_set) d, tab_set r from wwv_flow_toplevel_tabs where flow_id = :fb_flow_id order by 1'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Tab Set Selected -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when=>':F4000_LAST_VIEW != ''9000'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the parent level tab set to which the new tab belongs. A tab set identifies a group of tabs that are displayed together.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(130514966502)
,p_name=>'F4000_P4725_NEW_TABSET'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(130505887827)
,p_prompt=>'New Parent Tab Set (if no tab set exits)'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_display_when=>':F4000_LAST_VIEW != 9000'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter a name in this attribute to create a new parent tab set.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(130516975869)
,p_name=>'F4000_P4725_F'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(130505887827)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application:'
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'Identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(130520055184)
,p_name=>'F4000_P4725_DISPLAY_TEXT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(130505887827)
,p_prompt=>'Parent Tab Label'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Defines the text that displays on the tab. If the tab is an image, enter text to describe the tab.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(130562454599)
,p_computation_sequence=>1
,p_computation_item=>'F4000_P4725_TABSET'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'&F4000_P4725_NEW_TABSET.'
,p_computation_error_message=>'Unable to compute item value.'
,p_compute_when=>'F4000_P4725_NEW_TABSET'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(130579542330)
,p_validation_name=>'Display Text Required'
,p_validation_sequence=>10
,p_validation=>'F4000_P4725_DISPLAY_TEXT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Parent tab label must be specified.'
,p_associated_item=>wwv_flow_imp.id(130520055184)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(130580554748)
,p_validation_name=>'Tab set must be supplied'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'replace(v(''F4000_P4725_TABSET''),''%null''||''%'',null) is not null or',
'',
'replace(v(''F4000_P4725_TABSET''),''%null''||''%'',null) is not null'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Tab set or new tab set must be specified.'
,p_associated_item=>wwv_flow_imp.id(130514966502)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(573755732842229738)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(130510928901)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(573755846131229739)
,p_event_id=>wwv_flow_imp.id(573755732842229738)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_04726
begin
wwv_flow_imp_page.create_page(
 p_id=>4726
,p_name=>'Create Parent Tab - Target'
,p_alias=>'CREATE-PARENT-TAB-TARGET'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Parent Tab'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213240607818867991)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<script language="JavaScript" type="text/javascript">',
'function callItempopUp(s1,s2) {',
'     var items = document.getElementById(s1).value.replace(/\,/g,''~'');',
'     var values = document.getElementById(s2).value.replace(/\,/g,''~'');',
'     var url = ''f?p=4000:404:&SESSION.:::404:P404_RETURN1,P404_RETURN2,P404_ITEMS,P404_VALUES:'' + s1 + '','' + s2 + '','' + escape(items) + '','' + escape(values);',
'     popUp (url);',
'}',
'</script>'))
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(685388405)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>0
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(100804924518345585)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_plug_query_headings=>'TabSet:Seq:Name:Target'
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_break_cols=>'1'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(130522096221)
,p_plug_name=>'Create Parent Tab'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>91
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>500
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(130523097735)
,p_plug_name=>'Parent Tab'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(399849897040726767)
,p_plug_display_sequence=>201
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Identify the page to call when a user selects this parent level tab.</p>',
'<center><img src="#IMAGE_PREFIX#wwv_parent_tab_wiz.gif" alt="" /></center>',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(137384486592)
,p_name=>'Existing Tab Targets'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>200
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select tab_set, tab_sequence, tab_name, wwv_flow_escape.html(tab_target) target',
'from   wwv_flow_toplevel_tabs',
'where  flow_id = :FB_FLOW_ID',
'and security_group_id = :flow_security_group_id',
'order  by 1,2'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>150
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_break_cols=>'1'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48717109682771759)
,p_query_column_id=>1
,p_column_alias=>'TAB_SET'
,p_column_display_sequence=>1
,p_column_heading=>'Tab Set'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48717219952771759)
,p_query_column_id=>2
,p_column_alias=>'TAB_SEQUENCE'
,p_column_display_sequence=>2
,p_column_heading=>'Sequence'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48717314629771759)
,p_query_column_id=>3
,p_column_alias=>'TAB_NAME'
,p_column_display_sequence=>3
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48717427595771759)
,p_query_column_id=>4
,p_column_alias=>'TARGET'
,p_column_display_sequence=>4
,p_column_heading=>'Target'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46508826883906543)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(130530157719)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_imp.id(46508826883906543)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(130531162744)
,p_button_sequence=>2
,p_button_plug_id=>wwv_flow_imp.id(46508826883906543)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(130532164072)
,p_button_sequence=>3
,p_button_plug_id=>wwv_flow_imp.id(46508826883906543)
,p_button_name=>'Back'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(130533165918)
,p_branch_action=>'4727'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(130531162744)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(130534167198)
,p_branch_action=>'4725'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(130532164072)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(130524107490)
,p_name=>'F4000_P4725_TARGET_FLOW'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(130522096221)
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>8
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(130525116304)
,p_name=>'F4000_P4725_TARGET_PAGE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(130522096221)
,p_prompt=>'Page'
,p_source=>'FB_FLOW_PAGE_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'LIST PAGES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name n, id, id d',
'  from wwv_flow_steps',
' where flow_id           = :fb_flow_id',
'   and security_group_id = :flow_security_group_id',
'   and is_page_pattern   = ''N''',
'order by 2'))
,p_cSize=>12
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_cattributes_element=>'nowrap="nowrap" style="white-space:nowrap;"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the application page to call when the user selects this tab. A URL will be constructed using f?p syntax. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(130527127174)
,p_name=>'F4000_P4725_TARGET_REQUEST'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(130522096221)
,p_prompt=>'Request'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">When a parent tab is selected, an application page is called using a URL in the <code>f?p</code> syntax format. If you want to include the REQUEST component in this URL, enter it here. For example: </div>',
'<pre> ref: f?p=application:page:session:request:debug:clearCache:itemNames:itemValues:printerFriendly</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(130558328062)
,p_name=>'F4000_P4726_TN'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(130522096221)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tab Label:'
,p_source=>'F4000_P4725_DISPLAY_TEXT'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the tab label.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(130559406469)
,p_name=>'F4000_P4726_TS'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_imp.id(130522096221)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tab Set:'
,p_source=>'F4000_P4725_TABSET'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the selected tab set.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21290121856492063)
,p_name=>'P4726_CLEAR_PAGE'
,p_item_sequence=>25
,p_item_plug_id=>wwv_flow_imp.id(130522096221)
,p_prompt=>'('
,p_post_element_text=>')'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'RESET_PAGINATION_PAREN'
,p_lov=>'.'||wwv_flow_imp.id(84877500529450588)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Check this box to reset the pagination that is linked to.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21292432030504395)
,p_name=>'P4726_ARG_NAMES'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(130522096221)
,p_prompt=>'Set these items'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Set the session state for these application items. Setting the session state gives the listed items a value. Separate multiple item names with a comma.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'callItempopUp'
,p_attribute_03=>'Find Item'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21293511036507851)
,p_name=>'P4726_ARG_VALUES'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(130522096221)
,p_prompt=>'With these values'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.INTERNAL_PAGE_POPUPLOV'
,p_cSize=>64
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter a comma delimited list of values for the items specified in <span class="fielddatabold">Set these items</span>. You can specify static values or substitution syntax (for example, &amp;APP_ITEM_NAME.). ',
'<pre>&amp;APP_ITEM_NAME.</pre>',
'<div class="htmldbInfoBodyP">Item values passed to <span class="fielddatabold">f?p=</span> in the URL may never contain a colon (:). Item values may also not contain commas unless you enclose the entire value in backslash characters. For example:</di'
||'v>',
'<pre>\1234,56\</pre>',
'<div class="htmldbInfoBodyP">This is useful when decimal values must be passed where the NLS decimal separator character is a comma.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'callItempopUp'
,p_attribute_03=>'Find Item'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(21526423691342700)
,p_name=>'P4726_CLEAR_CACHE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(130522096221)
,p_prompt=>'Clear Cache (page, page)'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Clear the cache for these pages. Separate multiple pages with a comma.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(130581583629)
,p_validation_name=>'Flow ID Required'
,p_validation_sequence=>10
,p_validation=>'F4000_P4725_TARGET_FLOW'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Application ID must be specified.'
,p_associated_item=>wwv_flow_imp.id(130524107490)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(130582585040)
,p_validation_name=>'Page ID Required'
,p_validation_sequence=>20
,p_validation=>'F4000_P4725_TARGET_PAGE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Page ID must be specified.'
,p_associated_item=>wwv_flow_imp.id(130525116304)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(573755550406229736)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(130530157719)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(573755623445229737)
,p_event_id=>wwv_flow_imp.id(573755550406229736)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_04727
begin
wwv_flow_imp_page.create_page(
 p_id=>4727
,p_name=>'Create Parent Tab - Sequence and Display'
,p_alias=>'CREATE-PARENT-TAB-SEQUENCE-AND-DISPLAY'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Parent Tab'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213240607818867991)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(686394994)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(100804924518345585)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_plug_query_headings=>'TabSet:Seq:Name:Target'
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_break_cols=>'1'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(130553981766)
,p_plug_name=>'Create Parent Tab'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>91
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_break_cols=>'1'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(130554984359)
,p_plug_name=>'Parent Tab'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(399849897040726767)
,p_plug_display_sequence=>101
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Identify the sequence.  Use the listing of other tabs in this tab set to determine a sequence number.  If the tabs display is conditional then identify a build option and or a condition.</p>',
'<center><img src="#IMAGE_PREFIX#wwv_parent_tab_wiz.gif" /></center>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46511822428933590)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>101
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(130555061264)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_imp.id(46511822428933590)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(130557067755)
,p_button_sequence=>2
,p_button_plug_id=>wwv_flow_imp.id(46511822428933590)
,p_button_name=>'CreateParentTab'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Parent Tab'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(130556065048)
,p_button_sequence=>3
,p_button_plug_id=>wwv_flow_imp.id(46511822428933590)
,p_button_name=>'Back'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(130586692998)
,p_branch_action=>'&F4000_LAST_VIEW.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>119
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(130561436671)
,p_branch_action=>'4726'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(130556065048)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(130519051336)
,p_name=>'F4000_P4725_SEQUENCE'
,p_item_sequence=>1.1
,p_item_plug_id=>wwv_flow_imp.id(130553981766)
,p_prompt=>'Sequence'
,p_source=>'10'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the sequence for this component. The sequence determines the order of evaluation.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(130544254553)
,p_name=>'F4000_P4725_DISPLAY_CONDITION'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(130553981766)
,p_prompt=>'Expression 1'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>32767
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Use this attribute to conditionally control whether or not a component is rendered or processed. Enter values in this attribute based on the specific condition type you select. The component will be rendered or processed if the specified condition is'
||' met.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(130563543200)
,p_name=>'F4000_P4727_TN'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(130553981766)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Tab Name:'
,p_source=>'F4000_P4725_DISPLAY_TEXT'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the selected tab name.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(130583662977)
,p_name=>'F4000_P4725_CONDITION_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(130553981766)
,p_prompt=>'Condition Type'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CONDITION_LIST'
,p_named_lov=>'STANDARD_CONDITION_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(13602414170805697)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Condition -'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a condition type from the list. This condition must be met in order for this component to be rendered or processed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'F4000_P4725_DISPLAY_CONDITION'
,p_attribute_02=>'F4000_P4725_DISPLAY_CONDITION2'
,p_attribute_04=>'F4000_P4725_DISPLAY_CONDITION_CHECK'
,p_attribute_06=>'WIZARD'
,p_attribute_07=>'F4000_P4725_CONDITION_LANG'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(130584673664)
,p_name=>'F4000_P4725_BUILD_OPTION'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(130553981766)
,p_prompt=>'Build Option'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PATCHES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(patch_name) pn, id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'', wwv_flow_escape.html(patch_name))||',
'''} '' pn,0-id id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by pn'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Build Option -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<div class="htmldbInfoBodyP">Select a build option for this component. Build options are predefined settings that determine whether or not  components within an application are enabled.</div>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2307536599478302)
,p_name=>'F4000_P4725_CONDITION_LANG'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(130553981766)
,p_prompt=>'Language'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select a language that is used to evaluate the entered programming code.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17589829151313563)
,p_name=>'F4000_P4725_DISPLAY_CONDITION2'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(130553981766)
,p_prompt=>'Expression 2'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>32767
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Some condition types require two expressions for comparison. Enter the second expression or item here.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(435045129305654799)
,p_name=>'F4000_P4725_DISPLAY_CONDITION_CHECK'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(130553981766)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Do not validate code (parse code at runtime only).'
,p_source=>'NULL'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(130585677858)
,p_validation_name=>'sequence is numeric'
,p_validation_sequence=>10
,p_validation=>'F4000_P4725_SEQUENCE'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Sequence must be numeric.'
,p_associated_item=>wwv_flow_imp.id(130519051336)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(185780111075413036)
,p_validation_name=>'Sequence Not Null'
,p_validation_sequence=>20
,p_validation=>'F4000_P4725_SEQUENCE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'You must specify a numeric sequence.'
,p_validation_condition=>'Back,Cancel'
,p_validation_condition_type=>'REQUEST_NOT_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(130519051336)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(573755230701229733)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(130555061264)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(573755379646229734)
,p_event_id=>wwv_flow_imp.id(573755230701229733)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(130560434983)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create parent tab set'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'  n varchar2(300); ',
'  t varchar2(4000);',
'  l_current_on_tabset varchar2(255);',
'  l_clear_cache varchar2(4000);',
'  c_pt  number;',
'  c_st  number;',
'  ts    varchar2(4000);',
'  l_no_parent_tab boolean := false;',
'  l_parent_tab_tabset varchar2(255);',
'begin',
'n := replace(v(''F4000_P4725_DISPLAY_TEXT''),''?'',null);',
'n := replace(n,'' '',null);',
'n := replace(n,''&'',null);',
'n := replace(n,''='',null);',
'n := replace(n,''%'',null);',
'n := ''T_''||upper(substr(n,1,30));',
'if :P4726_CLEAR_PAGE = ''YES'' then',
'  l_clear_cache := ''RP,''||:P4726_CLEAR_CACHE;',
'else',
'  l_clear_cache := :P4726_CLEAR_CACHE;',
'end if;',
't := ''f?p=&''||''APP_ID.''||'':''||',
'v(''F4000_P4725_TARGET_PAGE'')||'':''||',
'''&''||''SESSION.:''||',
'v(''F4000_P4725_TARGET_REQUEST'')||'':&''||''DEBUG.:''||',
'rtrim(l_clear_cache,'','')||'':''||',
':P4726_ARG_NAMES||'':''||',
':P4726_ARG_VALUES;',
'',
'if replace(vrn(''F4000_P197_STD_TABSET''),''%''||''null%'',null) is null then',
'  select count(*) into c_pt from WWV_FLOW_TOPLEVEL_TABS where FLOW_ID = :fb_flow_id;',
'  select count(distinct TAB_SET), nvl(max(tab_set),''TS1'') ts into c_st, ts from WWV_FLOW_TABS where flow_id = :fb_flow_id;',
'  if c_pt = 0 and c_st = 1 then',
'    -- no parent tabs exist',
'    -- only one stand tab set exists',
'    l_current_on_tabset := ts;',
'    l_no_parent_tab := true;',
'  else',
'    l_current_on_tabset := n;',
'  end if;',
'else',
'  l_current_on_tabset := vrn(''F4000_P197_STD_TABSET'');',
'end if;',
'',
'',
'l_parent_tab_tabset := v(''F4000_P4725_TABSET'');',
'',
'wwv_flow_imp_shared.create_toplevel_tab(',
'  p_flow_id=>nv(''FB_FLOW_ID''),',
'  p_tab_set=> l_parent_tab_tabset,',
'  p_tab_sequence=>nv(''F4000_P4725_SEQUENCE''),',
'  p_tab_name=>n,',
'  p_tab_image=>null,',
'  p_tab_non_current_image=>null,',
'  p_tab_image_attributes=>null,',
'  p_tab_text=>v(''F4000_P4725_DISPLAY_TEXT''),',
'  p_tab_target=>t,',
'  p_current_on_tabset=>l_current_on_tabset,',
'  p_display_condition=>v(''F4000_P4725_DISPLAY_CONDITION''),',
'  p_display_condition2=>v(''F4000_P4725_DISPLAY_CONDITION2''),',
'  p_display_condition_type=>vrn(''F4000_P4725_CONDITION_TYPE''),',
'  p_required_patch=>vrn(''F4000_P4725_BUILD_OPTION''),',
'  p_tab_comment=>null);',
'',
'',
'if l_no_parent_tab then',
'   -- setting current for parent tabset',
'   update wwv_flow_tabs',
'   set    TAB_PARENT_TABSET = l_parent_tab_tabset',
'   where  flow_id = :fb_flow_id and',
'          TAB_SET = ts;',
'end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error creating parent tab &F4000_P4725_DISPLAY_TEXT..'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(130557067755)
,p_process_success_message=>'Parent Tab &F4000_P4725_DISPLAY_TEXT. created.'
,p_internal_uid=>130560434983
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(573755449668229735)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_01=>'FB_FLOW_ID,FB_FLOW_PAGE_ID'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Parent Tab &F4000_P4725_DISPLAY_TEXT. created.'
,p_internal_uid=>573755449668229735
);
end;
/
prompt --application/pages/page_04750
begin
wwv_flow_imp_page.create_page(
 p_id=>4750
,p_name=>'XLIFF Export'
,p_alias=>'XLIFF-EXPORT'
,p_step_title=>'XLIFF Export'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213331522315193801)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'global_process.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6098825384679471)
,p_plug_name=>'XLIFF Export'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>11
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>To export an XLIFF file for a specific application or page, select the application and mapping (and optionally, the page) and click <strong>Export XLIFF File for Application</strong> or <strong>Export XLIFF File for Page</strong>.</p>',
'<p>Prior to exporting the XLIFF translations for an application, you must complete the application translation mapping as well as seeding of all translatable text.</p>'))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6099113886679478)
,p_plug_name=>'Download XLIFF file for complete Application'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>130
,p_plug_source=>' '
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6130403796816817)
,p_plug_name=>'XLIFF Export'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle:a-Form--autoWidthLabels'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>95
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6147923891898273)
,p_plug_name=>'Download XLIFF file for Application Page'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>140
,p_plug_source=>' '
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(6161126755955912)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(6147923891898273)
,p_button_name=>'GENERATEXLIFFFORPAGE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Export XLIFF File for Page'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'javascript:apex.submit(''GENERATEXLIFFFORPAGE'');'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(6132706351826979)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(6130403796816817)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:4761:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(6099321355679479)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(6130403796816817)
,p_button_name=>'GenerateXLIFFTranslation'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Export XLIFF File for Application'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.submit(''GenerateXLIFFTranslation'');'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(6157202597930040)
,p_branch_action=>'4750'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':REQUEST = ''F4000_P4750_XLIFF_FLOW_PAGE'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6099730213679481)
,p_name=>'F4000_P4750_XLIFF_FLOW'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(6099113886679478)
,p_prompt=>'Language'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_LANGUAGES_LOCALES_MAPPED_TO_FB_FLOW_ID'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.text_from_lov(translation_flow_language_code,''I18N_LANGUAGES_LOCALES'') d,',
'       translation_flow_id r',
'from   wwv_flow_language_map',
'where  security_group_id = :flow_security_group_id',
'  and  primary_language_flow_id = :FB_FLOW_ID',
'order  by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_lov_null_value=>'NULL'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose the language to be downloaded in the XLIFF file.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_item_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select primary_language_flow_id||'' &gt;&gt; ''||translation_flow_id||',
'           '' (''||htf.escape_sc(translation_flow_language_code)||'')'' d,',
'       translation_flow_id r',
'from   wwv_flow_language_map',
'where  security_group_id = :flow_security_group_id',
'  and  primary_language_flow_id = :FB_FLOW_ID',
'order  by 2'))
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6149710516903903)
,p_name=>'F4000_P4750_XLIFF_FLOW_PAGE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(6147923891898273)
,p_prompt=>'Language'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_LANGUAGES_LOCALES_MAPPED_TO_FB_FLOW_ID'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_item.text_from_lov(translation_flow_language_code,''I18N_LANGUAGES_LOCALES'') d,',
'       translation_flow_id r',
'from   wwv_flow_language_map',
'where  security_group_id = :flow_security_group_id',
'  and  primary_language_flow_id = :FB_FLOW_ID',
'order  by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_lov_null_value=>'0'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose the language to be downloaded in the XLIFF file.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SUBMIT'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6152111686913714)
,p_name=>'F4000_P4750_XLIFF_PAGE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(6147923891898273)
,p_prompt=>'Page'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select s.id||'' ''||wwv_flow_escape.html(s.name) n, s.id',
'',
'  from wwv_flow_steps s, wwv_flow_language_map m',
'',
' where s.flow_id = m.primary_language_flow_id',
'',
'   and m.translation_flow_id = :F4000_P4750_XLIFF_FLOW_PAGE',
'',
'   and s.security_group_id = :flow_security_group_id',
'',
'   and m.security_group_id = :flow_security_group_id',
'',
'order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_lov_null_value=>'NULL'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Identifies the page.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(13212519502137882)
,p_name=>'F4000_P4750_PRIMARY_FLOW'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(6147923891898273)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(42168716185947321)
,p_name=>'P4750_XLIFF_FLOW_TARGET_INCL'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(6099113886679478)
,p_use_cache_before_default=>'NO'
,p_item_default=>'Y'
,p_prompt=>'Include XLIFF Target Elements'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select this checkbox to include the target elements and corresponding language code in the generated XLIFF file.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(42171314931956385)
,p_name=>'P4750_XLIFF_PAGE_TARGET_INCL'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(6147923891898273)
,p_item_default=>'Y'
,p_prompt=>'Include XLIFF Target Elements'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select this checkbox to include the target elements and corresponding language code in the generated XLIFF file.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(102653403370395954)
,p_name=>'P4750_XLIFF_ELEMENTS_INCLUDE'
,p_item_sequence=>95
,p_item_plug_id=>wwv_flow_imp.id(6099113886679478)
,p_prompt=>'Export:'
,p_source=>'Y'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'XLIFF_ELEMENTS_INCLUDE'
,p_lov=>'.'||wwv_flow_imp.id(102649602892386356)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Choose to export all translatable elements of the application or only those elements which are new or have been updated.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(106850704601454149)
,p_name=>'P4750_XLIFF_PAGE_ELEMENTS_INCL'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(6147923891898273)
,p_prompt=>'Export:'
,p_source=>'Y'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'XLIFF_ELEMENTS_INCLUDE'
,p_lov=>'.'||wwv_flow_imp.id(102649602892386356)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>'Choose to export all translatable elements of the page or only those elements which are new or have been updated.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(6108605041732046)
,p_validation_name=>'Flow not null'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :F4000_P4750_XLIFF_FLOW = ''NULL'' then',
'',
'    return FALSE;',
'',
'else',
'',
'    return TRUE;',
'',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Application must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(6099321355679479)
,p_associated_item=>wwv_flow_imp.id(6099730213679481)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(6164223769964525)
,p_validation_name=>'Flow not null for page export'
,p_validation_sequence=>10
,p_validation=>':F4000_P4750_XLIFF_FLOW_PAGE <> ''0'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Application must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(6161126755955912)
,p_associated_item=>wwv_flow_imp.id(6149710516903903)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(43443229444071712)
,p_validation_name=>'Check that flow language is set'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_lang_set boolean := FALSE;',
'begin',
'    for c1 in (select null',
'                 from wwv_flows',
'                where id = :FB_FLOW_ID',
'                  and upper(nvl(flow_language,''%NULL%'')) <> ''%NULL%'') loop',
'        l_lang_set := TRUE;',
'        exit;',
'    end loop;',
'    --',
'    return l_lang_set;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'XLIFF file cannot be generated if the Application Primary Language is not set.  Edit the attributes of application &FB_FLOW_ID. and set the Application Primary Language.'
,p_validation_condition=>'GENERATEXLIFFFORPAGE:GenerateXLIFFTranslation'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(6166006931969143)
,p_validation_name=>'Page not null'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :F4000_P4750_XLIFF_PAGE = ''NULL'' then',
'',
'    return false;',
'',
'else',
'',
'    return true;',
'',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Page must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(6161126755955912)
,p_associated_item=>wwv_flow_imp.id(6152111686913714)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(13215421842157545)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Translation Flow ID'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select translation_flow_id',
'                 from wwv_flow_language_map',
'                where primary_language_flow_id = :F4000_P4750_PRIMARY_FLOW) loop',
'        :F4000_P4750_XLIFF_FLOW_PAGE := c1.translation_flow_id;',
'        --',
'        exit;',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'F4000_P4750_PRIMARY_FLOW'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>13215421842157545
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(6100628798679496)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Generate XLIFF'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select primary_language_flow_id',
'                 from wwv_flow_language_map',
'                where translation_flow_id = :F4000_P4750_XLIFF_FLOW) loop',
'        --',
'        wwv_flow_xliff.print_translation_document(',
'            p_flow_id             => c1.primary_language_flow_id,',
'            p_translation_flow_id => :F4000_P4750_XLIFF_FLOW,',
'            p_include_target      => nvl(:P4750_XLIFF_FLOW_TARGET_INCL,''N''),',
'            p_include_all         => nvl(:P4750_XLIFF_ELEMENTS_INCLUDE, ''N'' ));',
'',
'        --',
'        exit;',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error generating XLIFF file.'
,p_process_when_button_id=>wwv_flow_imp.id(6099321355679479)
,p_internal_uid=>6100628798679496
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(6180403215024787)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Generate XLIFF for page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    for c1 in (select primary_language_flow_id',
'                 from wwv_flow_language_map',
'                where translation_flow_id = :F4000_P4750_XLIFF_FLOW_PAGE) loop',
'        --',
'        wwv_flow_xliff.print_translation_document(',
'            p_flow_id => c1.primary_language_flow_id,',
'            p_translation_flow_id => :F4000_P4750_XLIFF_FLOW_PAGE,',
'            p_page_id             => :F4000_P4750_XLIFF_PAGE,',
'            p_include_target      => nvl(:P4750_XLIFF_PAGE_TARGET_INCL,''N''),',
'            p_include_all         => nvl(:P4750_XLIFF_PAGE_ELEMENTS_INCL, ''N'' ));',
'        --',
'        exit;',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error generating XLIFF file.'
,p_process_when_button_id=>wwv_flow_imp.id(6161126755955912)
,p_internal_uid=>6180403215024787
);
end;
/
prompt --application/pages/page_04751
begin
wwv_flow_imp_page.create_page(
 p_id=>4751
,p_name=>'Language Mappings'
,p_alias=>'LANGUAGE-MAPPINGS'
,p_step_title=>'Application Language Mappings'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213331522315193801)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'global_process.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(371234255)
,p_plug_name=>'Application Language Mappings'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Translated applications are published as new applications. You must specify a primary language application ID and a translated language application ID for each application and for each language you wish to translate.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30840328417229054)
,p_plug_name=>'Application Language Mappings'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P4751a */',
'       ID,',
'       primary_language_flow_id,',
'       translation_flow_id,',
'       translation_flow_language_code,',
'       translation_image_directory,',
'       translation_comments,',
'       decode((select count(*) c',
'                 from wwv_flows f',
'                where f.id = m.translation_flow_id ),',
'              0, ''No'',',
'              ''Yes'' ) as translated_application_exists,',
'       (select created_on',
'          from wwv_flows f',
'         where f.id = m.translation_flow_id ) as translation_created,',
'       m.created_on as created,',
'       m.created_by as created_by,',
'       m.last_updated_on as updated,',
'       m.last_updated_by as updated_by',
'  from WWV_FLOW_LANGUAGE_MAP m',
' where security_group_id = :flow_security_group_id',
'   and primary_language_flow_id = :FB_FLOW_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(30840414634229054)
,p_name=>'Application Language Mappings'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30840608692229064)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30840729780229065)
,p_db_column_name=>'PRIMARY_LANGUAGE_FLOW_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Primary Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30840823240229065)
,p_db_column_name=>'TRANSLATION_FLOW_ID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Translated Application'
,p_column_link=>'f?p=&APP_ID.:4754:&SESSION.::&DEBUG.::P4754_ID:#ID#:'
,p_column_linktext=>'#TRANSLATION_FLOW_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30840924055229066)
,p_db_column_name=>'TRANSLATION_FLOW_LANGUAGE_CODE'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Language'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_rpt_named_lov=>wwv_flow_imp.id(107899321117195063)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30841026860229066)
,p_db_column_name=>'TRANSLATION_IMAGE_DIRECTORY'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Image Path'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(30841109962229066)
,p_db_column_name=>'TRANSLATION_COMMENTS'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Translation Comment'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162404706149956872)
,p_db_column_name=>'TRANSLATED_APPLICATION_EXISTS'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Application Exists'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162404931776964263)
,p_db_column_name=>'TRANSLATION_CREATED'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Published'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162449716444603203)
,p_db_column_name=>'CREATED'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Created'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162449820975603206)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Created By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162449901795603206)
,p_db_column_name=>'UPDATED'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(162450012311603207)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(30841408940231502)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1306803537536647'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'ID:TRANSLATION_FLOW_ID:TRANSLATION_FLOW_LANGUAGE_CODE:TRANSLATED_APPLICATION_EXISTS:TRANSLATION_CREATED:TRANSLATION_COMMENTS:CREATED:UPDATED:'
,p_sort_column_1=>'TRANSLATION_FLOW_LANGUAGE_CODE'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1030166014964015783)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(30840328417229054)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4761:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8258120720657693)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(30840328417229054)
,p_button_name=>'CREATE_MAP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4754:&SESSION.::&DEBUG.:4754::'
,p_icon_css_classes=>'icon-right-chevron'
);
end;
/
prompt --application/pages/page_04754
begin
wwv_flow_imp_page.create_page(
 p_id=>4754
,p_name=>'Edit Language Mappings'
,p_alias=>'EDIT-LANGUAGE-MAPPINGS'
,p_step_title=>'Create/Edit Application Language Mapping'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213331522315193801)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'global_process.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9918913505546139)
,p_plug_name=>'Wizard buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(61713417943886213)
,p_plug_name=>'Application Language Mapping'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_header=>'<p>To perform a translation, you create a unique application ID for the translated application. Use this page to map an existing application ID to a translation application ID.  Note that when an application mapping is deleted, any corresponding tran'
||'slated applications are also deleted.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(101558816609853494)
,p_name=>'Application Language Mappings'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select primary_language_flow_id,',
'       translation_flow_id,',
'       translation_flow_language_code,',
'       translation_image_directory',
'  from WWV_FLOW_LANGUAGE_MAP',
' where security_group_id = :flow_security_group_id',
'   and primary_language_flow_id = :FB_FLOW_ID',
' order by translation_flow_id'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'1'
,p_query_no_data_found=>'Report returned no rows.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48769922686772122)
,p_query_column_id=>1
,p_column_alias=>'PRIMARY_LANGUAGE_FLOW_ID'
,p_column_display_sequence=>1
,p_column_heading=>'Primary Application'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48770029804772122)
,p_query_column_id=>2
,p_column_alias=>'TRANSLATION_FLOW_ID'
,p_column_display_sequence=>2
,p_column_heading=>'Translated Application'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48770123365772122)
,p_query_column_id=>3
,p_column_alias=>'TRANSLATION_FLOW_LANGUAGE_CODE'
,p_column_display_sequence=>3
,p_column_heading=>'Language'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(107899321117195063)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48770207508772122)
,p_query_column_id=>4
,p_column_alias=>'TRANSLATION_IMAGE_DIRECTORY'
,p_column_display_sequence=>4
,p_column_heading=>'Image Directory'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747149928010138181)
,p_plug_name=>'Create/Edit Application Language Mapping'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2901592737)
,p_button_sequence=>1
,p_button_plug_id=>wwv_flow_imp.id(9918913505546139)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:4751:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2902592737)
,p_button_sequence=>2
,p_button_plug_id=>wwv_flow_imp.id(9918913505546139)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
,p_button_execute_validations=>'N'
,p_button_condition=>'P4754_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2903592737)
,p_button_sequence=>3
,p_button_plug_id=>wwv_flow_imp.id(9918913505546139)
,p_button_name=>'ApplyChanges'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P4754_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2904592738)
,p_button_sequence=>4
,p_button_plug_id=>wwv_flow_imp.id(9918913505546139)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>'P4754_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2905592738)
,p_branch_action=>'4751'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>40
,p_branch_condition_type=>'REQUEST_IN_CONDITION'
,p_branch_condition=>'Create:Delete'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2906592738)
,p_branch_action=>'4751'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>119
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2908592739)
,p_name=>'P4754_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(61713417943886213)
,p_use_cache_before_default=>'NO'
,p_prompt=>'ID'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2909592741)
,p_name=>'P4754_PRIMARY_LANGUAGE_FLOW_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(61713417943886213)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Primary Language Application'
,p_source=>'PRIMARY_LANGUAGE_FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_cSize=>32
,p_cMaxlength=>255
,p_cHeight=>1
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the application to be translated.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2910592741)
,p_name=>'P4754_TRANSLATION_FLOW_ID'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(61713417943886213)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Translation Application'
,p_source=>'TRANSLATION_FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter a unique integer value that identifies an application.  The application ID must be unique on your instance of &PRODUCT_NAME..',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2911592741)
,p_name=>'P4754_TRANS_LANGUAGE_CODE'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(61713417943886213)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Language'
,p_source=>'TRANSLATION_FLOW_LANGUAGE_CODE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_LANGUAGES_LOCALES'
,p_lov=>'.'||wwv_flow_imp.id(107899321117195063)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Value -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Select the language to be translated.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_show_quick_picks=>'Y'
,p_quick_pick_label_01=>'Brazilian Portuguese'
,p_quick_pick_value_01=>'pt-br'
,p_quick_pick_label_02=>'Chinese (China)'
,p_quick_pick_value_02=>'zh-cn'
,p_quick_pick_label_03=>'Chinese (Taiwan)'
,p_quick_pick_value_03=>'zh-tw'
,p_quick_pick_label_04=>'English'
,p_quick_pick_value_04=>'en'
,p_quick_pick_label_05=>'French'
,p_quick_pick_value_05=>'fr'
,p_quick_pick_label_06=>'German'
,p_quick_pick_value_06=>'de'
,p_quick_pick_label_07=>'Italian'
,p_quick_pick_value_07=>'it'
,p_quick_pick_label_08=>'Japanese'
,p_quick_pick_value_08=>'ja'
,p_quick_pick_label_09=>'Korean'
,p_quick_pick_value_09=>'ko'
,p_quick_pick_label_10=>'Spanish'
,p_quick_pick_value_10=>'es'
,p_quick_pick_link_attr=>'class="itemlink"'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2912592741)
,p_name=>'P4754_TRANSLATION_COMMENTS'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(61713417943886213)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Comments'
,p_source=>'TRANSLATION_COMMENTS'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_help_text=>'Enter any comments or notes here. These comments will never display when running the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33941917888)
,p_name=>'P4754_TRANSLATION_IMAGE_DIRECTORY'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(61713417943886213)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Image Directory'
,p_source=>'TRANSLATION_IMAGE_DIRECTORY'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the directory where images will be obtained.  Unless you are using static files from the images directory which are translated, you can leave this field blank.  This is the default and most common option.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(123305263008447102)
,p_name=>'P4754_DIRECTION_RIGHT_TO_LEFT'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(61713417943886213)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Document Direction'
,p_source=>'DIRECTION_RIGHT_TO_LEFT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'RIGHT-TO-LEFT'
,p_lov=>'.'||wwv_flow_imp.id(124580607576171078)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Set document direction left-to-right or right-to-left.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(519713912454234734)
,p_name=>'P4754_ORIG_TRANS_FLOW_ID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(61713417943886213)
,p_use_cache_before_default=>'NO'
,p_source=>'P4754_TRANSLATION_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(519740931155240165)
,p_name=>'P4754_ORIG_TRANS_LANG_CODE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(61713417943886213)
,p_use_cache_before_default=>'NO'
,p_source=>'P4754_TRANS_LANGUAGE_CODE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(16652408402607797)
,p_validation_name=>'primary language not null'
,p_validation_sequence=>10
,p_validation=>'P4754_PRIMARY_LANGUAGE_FLOW_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Must specify a primary language Application ID.'
,p_validation_condition=>'Cancel'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_associated_item=>wwv_flow_imp.id(2909592741)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(20464617086406041)
,p_validation_name=>'trans flow id must not end in zero'
,p_validation_sequence=>25
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_return boolean := TRUE;',
'begin',
'    if mod(v(''P4754_TRANSLATION_FLOW_ID''),10) = 0 then',
'        l_return := FALSE;',
'    end if;',
'    return l_return;',
'exception ',
'    when others then',
'        return l_return;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Translation Application must not end in zero.'
,p_validation_condition=>'Cancel'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_associated_item=>wwv_flow_imp.id(2910592741)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(13159032423681475)
,p_validation_name=>'translation flow must not already exist'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_return boolean := TRUE;',
'begin',
'    for c1 in (select null',
'                 from wwv_flows',
'                where id = :P4754_TRANSLATION_FLOW_ID) loop',
'        l_return := FALSE;',
'        exit;',
'    end loop;',
'    return l_return;',
'exception',
'    when others then',
'        return l_return;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Application with this ID already exists.'
,p_validation_condition=>'Create,ApplyChanges'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(2910592741)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(13237722820735479)
,p_validation_name=>'translation mapping must not already exist'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_return boolean := TRUE;',
'begin',
'    for c1 in (select null',
'                 from wwv_flow_language_map',
'                where translation_flow_id = :P4754_TRANSLATION_FLOW_ID) loop',
'        l_return := FALSE;',
'        exit;',
'    end loop;',
'    return l_return;',
'exception',
'    when others then',
'        return l_return;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Translation Application with this ID already exists.'
,p_when_button_pressed=>wwv_flow_imp.id(2904592738)
,p_associated_item=>wwv_flow_imp.id(2910592741)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(636237718854328099)
,p_validation_name=>'P4754_TRANSLATION_FLOW_ID'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if trunc(:P4754_TRANSLATION_FLOW_ID) = :P4754_TRANSLATION_FLOW_ID then',
'        return TRUE;',
'    else',
'        return FALSE;',
'    end if;',
'exception when others then',
'    return FALSE;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Translation Application must be an integer.'
,p_validation_condition=>'trim(:P4754_TRANSLATION_FLOW_ID) is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(2910592741)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2913592742)
,p_process_sequence=>1
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch Row from WWV_FLOW_LANGUAGE_MAP'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select 1 from wwv_flow_language_map',
'where security_group_id = :flow_security_group_id and',
'      primary_language_flow_id = :FB_FLOW_ID and',
'      id = :P4754_ID) loop',
'wwv_flow_dml.fetch_row(',
'  p_table_owner => ''#OWNER#'',',
'  p_table_name  => ''WWV_FLOW_LANGUAGE_MAP'',',
'  p_rowid       => :P4754_ID,',
'  p_alt_rowid   => ''ID'');',
'exit;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error fetching row.'
,p_process_when_type=>'NEVER'
,p_internal_uid=>2913592742
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(520357119661407165)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_FORM_FETCH'
,p_process_name=>'Fetch Row from WWV_FLOW_LANGUAGE_MAP'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_LANGUAGE_MAP'
,p_attribute_03=>'P4754_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id = :flow_security_group_id and primary_language_flow_id = :FB_FLOW_ID'
,p_attribute_14=>'N'
,p_process_error_message=>'Error fetching row.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>520357119661407165
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(76904415523844751)
,p_process_sequence=>5
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete translated applications when mapping deleted'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- If the mapping is deleted, also delete any translated flows ',
'-- that use this mapping as well as text from the translation repository',
'--',
'wwv_flow.g_import_in_progress := true;',
'',
'for c1 in (select translation_flow_id',
'             from WWV_FLOW_LANGUAGE_MAP ',
'            where security_group_id = :flow_security_group_id ',
'              and primary_language_flow_id =  :P4754_PRIMARY_LANGUAGE_FLOW_ID',
'              and translation_flow_id = :P4754_TRANSLATION_FLOW_ID) loop',
'',
'   delete from wwv_flows ',
'    where id = c1.translation_flow_id ',
'      and security_group_id = :flow_security_group_id;',
'',
'   --',
'   -- Delete any seeded text associated with the mapping being deleted',
'   --',
'   delete from wwv_flow_translatable_text$',
'    where flow_id = :P4754_PRIMARY_LANGUAGE_FLOW_ID',
'      and security_group_id = :flow_security_group_id',
'      and translated_flow_id = c1.translation_flow_id;',
'',
'  delete from wwv_flows_reserved',
'   where id = c1.translation_flow_id;',
'',
'end loop;',
'',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(2902592737)
,p_internal_uid=>76904415523844751
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2914592742)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process Row of WWV_FLOW_LANGUAGE_MAP'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select 1 from dual',
'where :P4754_ID is null',
'or exists (select 1 from wwv_flow_language_map',
'                   where security_group_id = :flow_security_group_id and',
'      primary_language_flow_id = :FB_FLOW_ID and',
'      id = :P4754_ID)) loop',
'wwv_flow_dml.process(',
'p_action => wwv_flow.g_request,',
'p_table_owner => ''#OWNER#'',',
'p_table_name  => ''WWV_FLOW_LANGUAGE_MAP'',',
'p_rowid       => v(''P4754_ID''),',
'p_alt_rowid   => ''ID'');',
'exit;',
'end loop;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error processing row.'
,p_process_when_type=>'NEVER'
,p_process_success_message=>'Action processed.'
,p_internal_uid=>2914592742
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(521237001409534326)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update translatable_text when translation mapping ID or language code changes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    c_nls_num_parm    constant varchar2(100) := ''NLS_NUMERIC_CHARACTERS=''''.,'''''';',
'    c_nls_num_fmt2    constant varchar2(100) := ''999999999999999999999999999999.999999999999999999999999999999'';',
'begin',
'--',
'-- If the mapped application ID changes or the translated language code changes,',
'-- then first delete any associated translated applications and then',
'-- also update the translatable text repository',
'--',
'-- This process must occur before the Automatic DML on WWV_FLOW_LANGUAGE_MAP occurs',
'',
'if ( :P4754_ORIG_TRANS_FLOW_ID <> :P4754_TRANSLATION_FLOW_ID ) or ',
'   ( :P4754_ORIG_TRANS_LANG_CODE <> :P4754_TRANS_LANGUAGE_CODE ) then',
'   ',
'   ',
'	wwv_flow.g_import_in_progress := true;',
'	',
'	for c1 in (select translation_flow_id',
'				 from wwv_flow_language_map',
'				where security_group_id = :flow_security_group_id ',
'				  and primary_language_flow_id =  :P4754_PRIMARY_LANGUAGE_FLOW_ID',
'				  and translation_flow_id = :P4754_ORIG_TRANS_FLOW_ID) loop',
'	',
'	   delete from wwv_flows ',
'		where id = c1.translation_flow_id ',
'		  and security_group_id = :flow_security_group_id;',
'		  ',
'    end loop;',
'    ',
'    --',
'    -- Then, update the existing data in the translatable text repository',
'    --',
'    update wwv_flow_translatable_text$',
'       set translated_flow_id = :P4754_TRANSLATION_FLOW_ID,',
'           translate_to_lang_code = :P4754_TRANS_LANGUAGE_CODE,',
'           translate_to_id = to_number(trunc(translate_to_id) || ''.'' || :P4754_TRANSLATION_FLOW_ID, c_nls_num_fmt2, c_nls_num_parm)',
'     where flow_id = :P4754_PRIMARY_LANGUAGE_FLOW_ID',
'       and translated_flow_id = :P4754_ORIG_TRANS_FLOW_ID',
'       and translate_to_lang_code = :P4754_ORIG_TRANS_LANG_CODE',
'       and security_group_id = :flow_security_group_id;',
'',
'',
'    --',
'    -- Lastly, if the ID changed, then remove the old one from the reserved table and add the new one',
'    --',
'    if ( :P4754_ORIG_TRANS_FLOW_ID <> :P4754_TRANSLATION_FLOW_ID ) then',
'       delete from wwv_flows_reserved',
'         where id = :P4754_ORIG_TRANS_FLOW_ID;',
'       --',
'       insert into wwv_flows_reserved( id, created_on, created_by)',
'       values( :P4754_TRANSLATION_FLOW_ID, sysdate, :APP_USER );',
'    end if;',
'end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2903592737)
,p_internal_uid=>521237001409534326
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(520489126372418593)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_FORM_PROCESS'
,p_process_name=>'Process Row of WWV_FLOW_LANGUAGE_MAP'
,p_attribute_01=>'#OWNER#'
,p_attribute_02=>'WWV_FLOW_LANGUAGE_MAP'
,p_attribute_03=>'P4754_ID'
,p_attribute_04=>'ID'
,p_attribute_08=>'security_group_id = :flow_security_group_id and primary_language_flow_id = :FB_FLOW_ID'
,p_attribute_11=>'I:U:D'
,p_attribute_12=>'Y'
,p_attribute_14=>'N'
,p_attribute_15=>'D'
,p_process_error_message=>'Error processing row.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Action processed.'
,p_internal_uid=>520489126372418593
);
end;
/
prompt --application/pages/page_04756
begin
wwv_flow_imp_page.create_page(
 p_id=>4756
,p_name=>'Dynamic Translations'
,p_alias=>'DYNAMIC-TRANSLATIONS'
,p_step_title=>'Dynamic Translations'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213331522315193801)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'global_process.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(25239076706)
,p_name=>'Dynamic Translations'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--hideHeader'
,p_component_template_options=>'a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'FUNC_BODY_RETURNING_SQL'
,p_function_body_language=>'PLSQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'  q varchar2(32767) := null;',
'begin',
'  q := ''select '''''''' as e,'';',
'  q :=q||'' id,translate_from_text,translate_to_lang_code,translate_to_text',
''';',
'  q :=q||'' from   WWV_FLOW_DYNAMIC_TRANSLATIONS$'';',
'  q :=q||'' where  security_group_id = :flow_security_group_id and flow_id = :FB_FLOW_ID '';',
'  if :F4000_P4756_LANGUAGE != ''NULL'' then',
'      q :=q||'' and translate_to_lang_code = :F4000_P4756_LANGUAGE '';',
'  end if;',
'  if :F4000_P4756_FIND is not null then',
'      q :=q||''   and (instr(upper(translate_from_text),upper(:F4000_P4756_FIND))>0 or instr(upper(translate_to_text),upper(:F4000_P4756_FIND))>0) '';',
'  end if;',
'  q :=q||'' order  by 3'';',
'  return q;',
'end;'))
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'(null)'
,p_query_no_data_found=>'No dynamic translations found.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48539606052770706)
,p_query_column_id=>1
,p_column_alias=>'E'
,p_column_display_sequence=>1
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48539728590770706)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_column_heading=>'ID'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_hidden_column=>'Y'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48539802305770707)
,p_query_column_id=>3
,p_column_alias=>'TRANSLATE_FROM_TEXT'
,p_column_display_sequence=>3
,p_column_heading=>'Translate From'
,p_use_as_row_header=>'Y'
,p_column_link=>'f?p=&APP_ID.:4757:&SESSION.::&DEBUG.::F4000_P4757_ID:#ID#:'
,p_column_linktext=>'#TRANSLATE_FROM_TEXT#'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48539911172770707)
,p_query_column_id=>4
,p_column_alias=>'TRANSLATE_TO_LANG_CODE'
,p_column_display_sequence=>4
,p_column_heading=>'Language'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48540013505770707)
,p_query_column_id=>5
,p_column_alias=>'TRANSLATE_TO_TEXT'
,p_column_display_sequence=>5
,p_column_heading=>'Translate To'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(25240089058)
,p_plug_name=>'Dynamic Translations'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Dynamic translations enable custom PL/SQL code to perform translations using the <code>APEX_LANG.LANG</code> function. This table maps values from the primary language to another national language.</p>'
,p_plug_query_row_template=>wwv_flow_imp.id(79387910442923002)
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'0'
,p_plug_query_no_data_found=>'No data found.'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'L:C:C:C:C:C'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(188061024872596772)
,p_plug_name=>'top bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(465706408)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(188061024872596772)
,p_button_name=>'F4000_P4756_GO'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--small'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Go'
,p_button_alignment=>'LEFT'
,p_request_source=>'Go'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(188999509859169126)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(188061024872596772)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:4756:&SESSION.::&DEBUG.:RP,4756::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8276308778692096)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(188061024872596772)
,p_button_name=>'CREATE_NEW'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:4757:&SESSION.::&DEBUG.:4757::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(25235072502)
,p_branch_action=>'4757'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow.g_request = ''CREATE_ROW'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(25236072502)
,p_branch_action=>'4756'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(463694999)
,p_name=>'F4000_P4756_FIND'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(188061024872596772)
,p_prompt=>'Find'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Enter text to search for in saved dynamic translations. This is entered in the primary language.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(466725053)
,p_name=>'F4000_P4756_LANGUAGE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(188061024872596772)
,p_prompt=>'Language'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_LANGUAGES_LOCALES'
,p_lov=>'.'||wwv_flow_imp.id(107899321117195063)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- All -'
,p_lov_null_value=>'NULL'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the language to be translated to.'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(25237072502)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P4757_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation_error_message=>'Unable to compute item value.'
,p_compute_when=>'wwv_flow.g_request = ''CREATE_ROW'''
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'EXPRESSION'
);
end;
/
prompt --application/pages/page_04757
begin
wwv_flow_imp_page.create_page(
 p_id=>4757
,p_name=>'Create/Edit Dynamic Translation'
,p_alias=>'CREATE-EDIT-DYNAMIC-TRANSLATION'
,p_step_title=>'Create/Edit Dynamic Translation'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213331522315193801)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'global_process.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(25241119284)
,p_plug_name=>'Dynamic Translations'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Dynamic translations are used by lists of values and by code you write in PL/SQL. You can call dynamic',
'   translations using the <code>APEX_LANG</code> package.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(61710711910641976)
,p_plug_name=>'Dynamic Translations'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(886492934541981505)
,p_plug_name=>'Create/Edit Dynamic Translation'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(25218072493)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(61710711910641976)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:4756:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(25219072493)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(61710711910641976)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
,p_button_condition=>'F4000_P4757_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(25221072493)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(61710711910641976)
,p_button_name=>'Create'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P4757_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(25220072493)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(61710711910641976)
,p_button_name=>'Apply_Changes'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P4757_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(25222072493)
,p_branch_action=>'4756'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow.g_request in (''Create'',''Delete'')'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(25223072494)
,p_branch_action=>'4757'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(467932441)
,p_name=>'F4000_P4757_FLOW_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(25241119284)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Application'
,p_source=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_tag_attributes=>'class="fieldtitlebold"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the primary language application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(25225072498)
,p_name=>'F4000_P4757_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(25241119284)
,p_use_cache_before_default=>'NO'
,p_source=>'ID'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(25226072498)
,p_name=>'F4000_P4757_TRANSLATE_FROM_TEXT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(25241119284)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Translate From Text'
,p_source=>'TRANSLATE_FROM_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>32767
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the text in the primary language to be translated.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(25227072499)
,p_name=>'F4000_P4757_TRANSLATE_TO_LANG_CODE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(25241119284)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&F4000_P4756_LANGUAGE.'
,p_prompt=>'Language'
,p_source=>'TRANSLATE_TO_LANG_CODE'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'I18N_LANGUAGES_LOCALES'
,p_lov=>'.'||wwv_flow_imp.id(107899321117195063)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Language -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a language to translate to.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(25228072499)
,p_name=>'F4000_P4757_TRANSLATE_TO_TEXT'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(25241119284)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Translate To Text'
,p_source=>'TRANSLATE_TO_TEXT'
,p_source_type=>'DB_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>32767
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the translated text in the target language.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(88279301555756952)
,p_validation_name=>'LangMand'
,p_validation_sequence=>10
,p_validation=>'F4000_P4757_TRANSLATE_TO_LANG_CODE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Language must be specified.'
,p_validation_condition=>'Create,Apply Changes'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(25227072499)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(25229072500)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch Row from WWV_FLOW_DYNAMIC_TRANSLATIONS$'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'for c1 in (',
'select 1 from wwv_flow_dynamic_translations$',
'where security_group_id = :flow_security_group_id and',
'      flow_id = :FB_FLOW_ID and',
'      id = :F4000_P4757_ID) loop',
'wwv_flow_dml.fetch_row(',
'  p_table_owner => ''#OWNER#'',',
'  p_table_name  => ''WWV_FLOW_DYNAMIC_TRANSLATIONS$'',',
'  p_rowid       => v(''F4000_P4757_ID''),',
'  p_alt_rowid   => ''ID'');',
'exit;',
'end loop;',
''))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error fetching row.'
,p_internal_uid=>25229072500
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(25230072500)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process Row of WWV_FLOW_DYNAMIC_TRANSLATIONS$'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'for c1 in (',
'select 1 from dual',
'where :F4000_P4757_ID is null',
'or exists (select 1 from wwv_flow_dynamic_translations$',
'                   where security_group_id = :flow_security_group_id and',
'      flow_id = :FB_FLOW_ID and',
'      id = :F4000_P4757_ID)) loop',
'wwv_flow_dml.process(',
'p_action => wwv_flow.g_request,',
'p_table_owner => ''#OWNER#'',',
'p_table_name  => ''WWV_FLOW_DYNAMIC_TRANSLATIONS$'',',
'p_rowid       => v(''F4000_P4757_ID''),',
'p_alt_rowid   => ''ID'');',
'exit;',
'end loop;',
'commit;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error processing row.'
,p_process_success_message=>'Action processed.'
,p_internal_uid=>25230072500
);
end;
/
prompt --application/pages/page_04758
begin
wwv_flow_imp_page.create_page(
 p_id=>4758
,p_name=>'XLIFF Translation Files'
,p_alias=>'XLIFF-TRANSLATION-FILES'
,p_step_title=>'XLIFF Translation Files'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213331522315193801)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'global_process.htm'
,p_page_component_map=>'01'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5297413578239257)
,p_plug_name=>'XLIFF Repository'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>To upload one or more translated XLIFF files, click "Upload Files". The files must be encoded in UTF-8.  To delete a file from the repository, select the check box adjacent to the file name and click "Delete Checked".</p>',
'<p>To apply the XLIFF files, check the rows you wish to apply and also choose a translation mapping from the "Apply to Translation" column, then click "Apply Checked".  The XLIFF file will be parsed and the contents will be applied to the translation'
||' repository.  Once this process is complete, you will need to publish the application for each translation.</p>',
''))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5309600462294735)
,p_plug_name=>'Top Bar'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(637355708555846594)
,p_name=>'XLIFF Files'
,p_template=>wwv_flow_imp.id(208928010704475743)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_TABFORM'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'"ID",',
'"FILENAME",',
'"TITLE",',
'"DOC_SIZE",',
'"CREATED_BY",',
'"CREATED_ON",',
'null translation_mapping',
'from wwv_flow_file_objects$',
'where file_type = ''XLIFF''',
'  and security_group_id = :FLOW_SECURITY_GROUP_ID',
'  and flow_id = :FB_FLOW_ID',
'  '))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No XLIFF files found.'
,p_query_num_rows_type=>'0'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'DEFAULT_BREAK_FORMATTING'
,p_csv_output=>'N'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(638083509688903634)
,p_query_column_id=>1
,p_column_alias=>'CHECK$01'
,p_column_display_sequence=>1
,p_column_heading=>'Select Row'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'CHECKBOX'
,p_derived_column=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(637356031628846596)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_column_heading=>'ID'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_hidden_column=>'Y'
,p_display_as=>'HIDDEN'
,p_column_width=>16
,p_pk_col_source_type=>'T'
,p_ref_schema=>'APEX_040200'
,p_ref_table_name=>'WWV_FLOW_FILES'
,p_ref_column_name=>'ID'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(637356414896846598)
,p_query_column_id=>3
,p_column_alias=>'FILENAME'
,p_column_display_sequence=>3
,p_column_heading=>'Filename'
,p_use_as_row_header=>'N'
,p_column_link=>'p?n=#ID#&p_mime_type=text/xml'
,p_column_linktext=>'#FILENAME#'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_column_width=>16
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040200'
,p_ref_table_name=>'WWV_FLOW_FILES'
,p_ref_column_name=>'FILENAME'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(637356524359846598)
,p_query_column_id=>4
,p_column_alias=>'TITLE'
,p_column_display_sequence=>4
,p_column_heading=>'Title'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_column_width=>16
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040200'
,p_ref_table_name=>'WWV_FLOW_FILES'
,p_ref_column_name=>'TITLE'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(637356700090846598)
,p_query_column_id=>5
,p_column_alias=>'DOC_SIZE'
,p_column_display_sequence=>5
,p_column_heading=>'Document Size'
,p_use_as_row_header=>'N'
,p_column_format=>'FILESIZE'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_column_width=>16
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040200'
,p_ref_table_name=>'WWV_FLOW_FILES'
,p_ref_column_name=>'DOC_SIZE'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(637356908879846598)
,p_query_column_id=>6
,p_column_alias=>'CREATED_BY'
,p_column_display_sequence=>7
,p_column_heading=>'Created By'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_column_width=>16
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040200'
,p_ref_table_name=>'WWV_FLOW_FILES'
,p_ref_column_name=>'CREATED_BY'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(637357017623846598)
,p_query_column_id=>7
,p_column_alias=>'CREATED_ON'
,p_column_display_sequence=>6
,p_column_heading=>'Created'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_column_width=>12
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
,p_ref_schema=>'APEX_040200'
,p_ref_table_name=>'WWV_FLOW_FILES'
,p_ref_column_name=>'CREATED_ON'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(638488202536946133)
,p_query_column_id=>8
,p_column_alias=>'TRANSLATION_MAPPING'
,p_column_display_sequence=>8
,p_column_heading=>'Apply to Translation'
,p_use_as_row_header=>'N'
,p_display_as=>'SELECT_LIST_FROM_LOV'
,p_named_lov=>wwv_flow_imp.id(640493208817215668)
,p_lov_show_nulls=>'YES'
,p_lov_null_text=>'- Select -'
,p_lov_display_extra=>'NO'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(637454225871851507)
,p_column_sequence=>1
,p_query_column_name=>'ID'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(637454629852851512)
,p_column_sequence=>2
,p_query_column_name=>'FILENAME'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(637454717319851512)
,p_column_sequence=>3
,p_query_column_name=>'TITLE'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(637454927736851512)
,p_column_sequence=>4
,p_query_column_name=>'DOC_SIZE'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(637455105787851512)
,p_column_sequence=>5
,p_query_column_name=>'CREATED_BY'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(637455216901851512)
,p_column_sequence=>6
,p_query_column_name=>'CREATED_ON'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_region_rpt_cols(
 p_id=>wwv_flow_imp.id(638488107392946132)
,p_column_sequence=>7
,p_query_column_name=>'TRANSLATION_MAPPING'
,p_display_as=>'TEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(166433417238786023)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(5309600462294735)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:4761:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5632329390234879)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(5309600462294735)
,p_button_name=>'Delete'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete Checked'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:confirmDelete(''&DELETE_MSG.'');'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_file_objects$ f',
' where f.security_group_id = :flow_security_group_id',
'       and f.file_type = ''XLIFF''',
'       and f.flow_id = :FB_FLOW_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(639244705897053912)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(5309600462294735)
,p_button_name=>'APPLY_CHECKED'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Apply Checked'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_file_objects$ f',
' where f.security_group_id = :flow_security_group_id',
'       and f.file_type = ''XLIFF''',
'       and f.flow_id = :FB_FLOW_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(750332303862462709)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(5309600462294735)
,p_button_name=>'PUBLISH'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'Publish'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:385:&SESSION.::&DEBUG.::P385_ACTION:PUBLISH:'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5607822876062701)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(5309600462294735)
,p_button_name=>'UPLOADXLIFF'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Upload Files'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:4760:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(5608124177062703)
,p_branch_action=>'4760'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(5607822876062701)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(653980526497953088)
,p_tabular_form_region_id=>wwv_flow_imp.id(637355708555846594)
,p_validation_name=>'Translation Mapping Not Null'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :APEX$ROW_SELECTOR = ''X'' then',
'    if :TRANSLATION_MAPPING is null then',
'        return FALSE;',
'    end if;',
'end if;',
'return TRUE;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Translation Mapping must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(639244705897053912)
,p_exec_cond_for_each_row=>'Y'
,p_associated_column=>'TRANSLATION_MAPPING'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(639350626806069474)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(637355708555846594)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Checked Files'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete from wwv_flow_file_objects$',
' where id = :ID',
' and security_group_id = :FLOW_SECURITY_GROUP_ID;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error deleting file(s).'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(5632329390234879)
,p_process_when=>'APEX$ROW_SELECTOR'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'X'
,p_exec_cond_for_each_row=>'Y'
,p_only_for_changed_rows=>'N'
,p_process_success_message=>'File(s) deleted.'
,p_internal_uid=>639350626806069474
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(640273130587193506)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(637355708555846594)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Apply Checked Files'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :TRANSLATION_MAPPING is not null then',
'wwv_flow_xliff.apply_xliff_file(',
'    p_flow_id => :FB_FLOW_ID,',
'    p_translation_flow_id => :TRANSLATION_MAPPING,',
'    p_file_id             => :ID );',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error applying file(s).'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(639244705897053912)
,p_process_when=>'APEX$ROW_SELECTOR'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'X'
,p_exec_cond_for_each_row=>'Y'
,p_process_success_message=>'File(s) applied.'
,p_internal_uid=>640273130587193506
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(657364723670198316)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(637355708555846594)
,p_process_type=>'NATIVE_TABFORM_UPDATE'
,p_process_name=>'MRU'
,p_attribute_02=>'WWV_FLOW_FILES'
,p_attribute_03=>'ID'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(639244705897053912)
,p_process_when_type=>'NEVER'
,p_internal_uid=>657364723670198316
);
end;
/
prompt --application/pages/page_04760
begin
wwv_flow_imp_page.create_page(
 p_id=>4760
,p_name=>'XLIFF Upload'
,p_alias=>'XLIFF-UPLOAD'
,p_step_title=>'XLIFF Upload'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213331522315193801)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'global_process.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(634586126292406991)
,p_plug_name=>'XLIFF Upload'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>40
,p_plug_item_display_point=>'BELOW'
,p_translate_title=>'N'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Upload up to ten translated XLIFF files into the XLIFF repository. XLIFF files uploaded into the XLIFF file repository should <strong>only</strong> be translated files which were first generated via the XLIFF Export operation.',
'</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(694679936718238907)
,p_plug_name=>'XLIFF Upload'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(694680033925238908)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(635724214190554879)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(694680033925238908)
,p_button_name=>'UPLOAD'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Upload'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5617525918158240)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(694680033925238908)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:4758:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(749387221468363783)
,p_branch_action=>'f?p=&APP_ID.:4758:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>99
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(634756618720433125)
,p_name=>'P4760_FILE1'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(634586126292406991)
,p_prompt=>'1'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>255
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'WWV_FLOW_FILES'
,p_attribute_12=>'INLINE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(634881424392444267)
,p_name=>'P4760_FILE2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(634586126292406991)
,p_prompt=>'2'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>255
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'WWV_FLOW_FILES'
,p_attribute_12=>'INLINE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(634896430626446061)
,p_name=>'P4760_FILE3'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(634586126292406991)
,p_prompt=>'3'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>255
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'WWV_FLOW_FILES'
,p_attribute_12=>'INLINE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(634911413442450549)
,p_name=>'P4760_FILE4'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(634586126292406991)
,p_prompt=>'4'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>255
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'WWV_FLOW_FILES'
,p_attribute_12=>'INLINE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(634975204915457535)
,p_name=>'P4760_FILE5'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(634586126292406991)
,p_prompt=>'5'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>255
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'WWV_FLOW_FILES'
,p_attribute_12=>'INLINE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(650852126863404431)
,p_name=>'P4760_FILE6'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(634586126292406991)
,p_prompt=>'6'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>255
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'WWV_FLOW_FILES'
,p_attribute_12=>'INLINE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(650878531365405696)
,p_name=>'P4760_FILE7'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(634586126292406991)
,p_prompt=>'7'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>255
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'WWV_FLOW_FILES'
,p_attribute_12=>'INLINE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(650932903445407071)
,p_name=>'P4760_FILE8'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(634586126292406991)
,p_prompt=>'8'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>255
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'WWV_FLOW_FILES'
,p_attribute_12=>'INLINE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(650955507254408191)
,p_name=>'P4760_FILE9'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(634586126292406991)
,p_prompt=>'9'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>255
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'WWV_FLOW_FILES'
,p_attribute_12=>'INLINE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(651000612449409728)
,p_name=>'P4760_FILE10'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(634586126292406991)
,p_prompt=>'10'
,p_display_as=>'NATIVE_FILE'
,p_cSize=>255
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'WWV_FLOW_FILES'
,p_attribute_12=>'INLINE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5627501770208037)
,p_validation_name=>'File Not Null'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (',
':P4760_FILE1 is null and  ',
':P4760_FILE2 is null and ',
':P4760_FILE3 is null and ',
':P4760_FILE4 is null and ',
':P4760_FILE5 is null and ',
':P4760_FILE6 is null and ',
':P4760_FILE7 is null and ',
':P4760_FILE8 is null and ',
':P4760_FILE9 is null and ',
':P4760_FILE10 is null) then',
'    return FALSE;',
'else',
'    return TRUE;',
'end if;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'At least one file must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(635724214190554879)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(636002313114601872)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update attributes of files'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P4760_FILE1 is not null then',
'    update wwv_flow_file_objects$',
'       set flow_id = :FB_FLOW_ID,',
'           title = filename,',
'           security_group_id = :APP_SECURITY_GROUP_ID,',
'           file_type = ''XLIFF'',',
'           created_by = :APP_USER',
'     where name = :P4760_FILE1;',
'    commit;',
'end if;',
'',
'if :P4760_FILE2 is not null then',
'    update wwv_flow_file_objects$',
'       set flow_id = :FB_FLOW_ID,',
'           title = filename,',
'           security_group_id = :APP_SECURITY_GROUP_ID,',
'           file_type = ''XLIFF'',',
'           created_by = :APP_USER',
'     where name = :P4760_FILE2;',
'    commit;',
'end if;',
'',
'if :P4760_FILE3 is not null then',
'    update wwv_flow_file_objects$',
'       set flow_id = :FB_FLOW_ID,',
'           title = filename,',
'           security_group_id = :APP_SECURITY_GROUP_ID,',
'           file_type = ''XLIFF'',',
'           created_by = :APP_USER',
'     where name = :P4760_FILE3;',
'    commit;',
'end if;',
'',
'if :P4760_FILE4 is not null then',
'    update wwv_flow_file_objects$',
'       set flow_id = :FB_FLOW_ID,',
'           title = filename,',
'           security_group_id = :APP_SECURITY_GROUP_ID,',
'           file_type = ''XLIFF'',',
'           created_by = :APP_USER',
'     where name = :P4760_FILE4;',
'    commit;',
'end if;',
'',
'if :P4760_FILE5 is not null then',
'    update wwv_flow_file_objects$',
'       set flow_id = :FB_FLOW_ID,',
'           title = filename,',
'           security_group_id = :APP_SECURITY_GROUP_ID,',
'           file_type = ''XLIFF'',',
'           created_by = :APP_USER',
'     where name = :P4760_FILE5;',
'    commit;',
'end if;',
'',
'',
'if :P4760_FILE6 is not null then',
'    update wwv_flow_file_objects$',
'       set flow_id = :FB_FLOW_ID,',
'           title = filename,',
'           security_group_id = :APP_SECURITY_GROUP_ID,',
'           file_type = ''XLIFF'',',
'           created_by = :APP_USER',
'     where name = :P4760_FILE6;',
'    commit;',
'end if;',
'',
'',
'if :P4760_FILE7 is not null then',
'    update wwv_flow_file_objects$',
'       set flow_id = :FB_FLOW_ID,',
'           title = filename,',
'           security_group_id = :APP_SECURITY_GROUP_ID,',
'           file_type = ''XLIFF'',',
'           created_by = :APP_USER',
'     where name = :P4760_FILE7;',
'    commit;',
'end if;',
'',
'',
'if :P4760_FILE8 is not null then',
'    update wwv_flow_file_objects$',
'       set flow_id = :FB_FLOW_ID,',
'           title = filename,',
'           security_group_id = :APP_SECURITY_GROUP_ID,',
'           file_type = ''XLIFF'',',
'           created_by = :APP_USER',
'     where name = :P4760_FILE8;',
'    commit;',
'end if;',
'',
'',
'if :P4760_FILE9 is not null then',
'    update wwv_flow_file_objects$',
'       set flow_id = :FB_FLOW_ID,',
'           title = filename,',
'           security_group_id = :APP_SECURITY_GROUP_ID,',
'           file_type = ''XLIFF'',',
'           created_by = :APP_USER',
'     where name = :P4760_FILE9;',
'    commit;',
'end if;',
'',
'',
'if :P4760_FILE10 is not null then',
'    update wwv_flow_file_objects$',
'       set flow_id = :FB_FLOW_ID,',
'           title = filename,',
'           security_group_id = :APP_SECURITY_GROUP_ID,',
'           file_type = ''XLIFF'',',
'           created_by = :APP_USER',
'     where name = :P4760_FILE10;',
'    commit;',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error uploading file(s).'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(635724214190554879)
,p_process_success_message=>'Successfully uploaded file(s).'
,p_internal_uid=>636002313114601872
);
end;
/
prompt --application/pages/page_04761
begin
wwv_flow_imp_page.create_page(
 p_id=>4761
,p_name=>'Translate Application'
,p_alias=>'TRANSLATE-APPLICATION'
,p_step_title=>'Translate Application'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213331522315193801)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<style>',
'#how-to-translate .rc-content,',
'#translations .rc-content {',
'height: 456px;}',
'#translations .rc-content {',
'padding: 0;',
'}',
'#translations .rc-content table {',
'width: 100%; }',
'</style>'))
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'global_process.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(689897690)
,p_plug_name=>'How to Translate'
,p_region_name=>'how-to-translate'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--shadowScroll:a-Region--noPadding:h540'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_list_id=>wwv_flow_imp.id(165943028704262550)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(693422331030340241)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1591026164633612)
,p_plug_name=>'Application Translation'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Applications can be translated from a primary language into other languages.  Each translation results in the creation of a new translated application.  Each translation requires a mapping which identifies the target language as well as the transl'
||'ated application ID.  Translated applications cannot be edited directly in the App Builder.<p/>',
'',
'<p>Once the translation mappings are established the translatable text within the application is seeded into a translation repository.  This repository can then be exported to an XLIFF for translation.</p>',
'',
'<p>Once the XLIFF file is populated with the translations, one file per language, the XLIFF file is uploaded back into the translation repository.  The final step is to publish each translated application from the translation repository.</p>',
'',
'<p>A translated application will require synchronization when the primary application has been modified since the translated version was last published.  Even modifications to application logic will require synchronization.  To synchronize, seed and '
||'publish the translated application.</p>',
'',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1632930076767224)
,p_plug_name=>'Translation Utilities'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>55
,p_list_id=>wwv_flow_imp.id(165621520543370755)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(693422331030340241)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(694679486622238902)
,p_plug_name=>'Translations'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--shadowScroll:a-Region--noPadding:h540'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>34
,p_plug_new_grid_row=>false
,p_plug_column_width=>'apex-col--leftBorder'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(694679334842238901)
,p_plug_name=>'Translations not Enabled'
,p_parent_plug_id=>wwv_flow_imp.id(694679486622238902)
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--warning:a-Alert--horizontal'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.p( wwv_flow_lang.system_message( ''F4000.P4761.TRANSLATIONS_NOT_USED'',',
'                                         wwv_flow_utilities.prepare_url( ''f?p=&APP_ID.:506:'' || :APP_SESSION || '':::506:FB_FLOW_ID:'' || :fb_flow_id ) ) );'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flows f,',
'       wwv_flow_language_map m',
' where f.id = m.primary_language_flow_id',
'   and f.security_group_id = :flow_security_group_id',
'   and f.id = :fb_flow_id',
'   and nvl( f.flow_language_derived_from, ''0'' ) = ''0'''))
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(746836409020161499)
,p_name=>'Application Languages'
,p_region_name=>'translations'
,p_parent_plug_id=>wwv_flow_imp.id(694679486622238902)
,p_template=>wwv_flow_imp.id(208928010704475743)
,p_display_sequence=>35
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch:a-Report--rowHighlight'
,p_display_point=>'SUB_REGIONS'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select m.translation_flow_language_code,',
'       nvl((select decode(sign(difference),-1,''Y'',''N'')',
'         from ',
'       (select (f2.created_on - f1.last_updated_on) difference, f2.id',
'         from wwv_flows f1, wwv_flows f2, wwv_flow_language_map m',
'        where f1.id = :FB_FLOW_ID',
'          and f1.id = m.primary_language_flow_id',
'          and f2.id = m.translation_flow_id) x',
'        where x.id = m.translation_flow_id),''Y'') requires_synchronization,',
'       (select created_on',
'          from wwv_flows f',
'         where f.id = m.translation_flow_id) translation_created',
'from wwv_flow_language_map m',
'where m.primary_language_flow_id = :fb_flow_id',
'  and m.security_group_id = :flow_security_group_id'))
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'No translations found.'
,p_query_row_count_max=>500
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_query_asc_image=>'apex/builder/dup.gif'
,p_query_asc_image_attr=>'width="16" height="16" alt="" '
,p_query_desc_image=>'apex/builder/ddown.gif'
,p_query_desc_image_attr=>'width="16" height="16" alt="" '
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(746836804088161503)
,p_query_column_id=>1
,p_column_alias=>'TRANSLATION_FLOW_LANGUAGE_CODE'
,p_column_display_sequence=>1
,p_column_heading=>'Language'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(107899321117195063)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(746836910588161504)
,p_query_column_id=>2
,p_column_alias=>'REQUIRES_SYNCHRONIZATION'
,p_column_display_sequence=>2
,p_column_heading=>'Requires Synchronization'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(84259319526460470)
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(746837021017161504)
,p_query_column_id=>3
,p_column_alias=>'TRANSLATION_CREATED'
,p_column_display_sequence=>3
,p_column_heading=>'Published'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3107005878)
,p_branch_action=>'4761'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(9487269104)
,p_branch_action=>'1'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>20
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'Cancel'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3109052268)
,p_computation_sequence=>10
,p_computation_item=>'FB_FLOW_NAME'
,p_computation_type=>'QUERY'
,p_computation=>'select replace(name,'' '',''&nbsp;'') n from wwv_flows where id = :FB_FLOW_ID and security_group_id = :flow_security_group_id'
,p_computation_error_message=>'Unable to compute item value.'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3108044387)
,p_computation_sequence=>20
,p_computation_item=>'FB_FLOW_ID'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'SQL'
,p_computation=>'nvl(:F4000_P4761_FLOW,:FB_FLOW_ID)'
,p_computation_error_message=>'Unable to compute item value.'
);
end;
/
prompt --application/pages/page_04850
begin
wwv_flow_imp_page.create_page(
 p_id=>4850
,p_name=>'Application Settings'
,p_alias=>'APPLICATION-SETTINGS'
,p_step_title=>'Application Settings'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213481614528579568)
,p_inline_css=>'.code-inline {white-space: normal; font-size: 11px; word-break: break-word;}'
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_build_options.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6036620591209186)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(4229347245662858)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(659452654063607863)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--sideRegion:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Application Settings enable developers to define application level configuration options.</p>',
'',
'<p>You can use the following APIs within your application to access your application settings:</p>',
'',
'<p><strong>To set a value for a setting:</strong>',
'<code class="code-inline">apex_app_setting.<br>set_value()</code></p>',
'',
'<p><strong>To get the value of a setting:</strong>',
'<code class="code-inline">apex_app_setting.<br>get_value()</code></p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(663191276316602128)
,p_plug_name=>'Application Settings'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select s.id,',
'       s.name,',
'       s.is_required,',
'       s.valid_values,',
'       s.value,',
'       s.on_upgrade_keep_value,',
'       s.comments,',
'       (select p.patch_name',
'          from wwv_flow_patches p',
'         where p.id                = s.required_patch',
'           and p.security_group_id = s.security_group_id',
'        union all',
'        select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'',patch_name)|| ''} ''',
'               patch_name',
'          from wwv_flow_patches p',
'         where 0-p.id              = s.required_patch',
'           and p.security_group_id = s.security_group_id ) as required_patch,',
'       ''a-Icon icon-util-gear'' img,',
'       wwv_flow_page_api.get_url(',
'           p_page        => 4851,',
'           p_clear_cache => 4851,',
'           p_items       => ''F4000_P4851_ID'',',
'           p_values      => s.id ) link,       ',
'       s.created_on,',
'       s.created_by,',
'       s.last_updated_on,',
'       s.last_updated_by,',
'       --',
'       case when s.reference_id is not null then',
'           coalesce ( to_char( master.flow_id ),',
'                       wwv_flow_lang_dev.builder_message( ''SUBSCRIBED_FROM.NONEXISTING_MASTER'' ) )',
'       end as subscribed_from,',
'       ( select case when count(*) > 0 then count(*) end',
'           from wwv_flow_app_settings sub',
'          where sub.reference_id      = s.id',
'            and sub.security_group_id = :WORKSPACE_ID ) as subscribers,',
'       case when s.reference_id is not null then',
'           case',
'               when master.version_scn = s.version_scn then',
'                   wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_UP_TO_DATE'')',
'               when master.version_scn != s.version_scn then',
'                   wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_NEEDS_REFRESH'')',
'               else',
'                   wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_UNKNOWN'')',
'           end',
'       end subscription_status,',
'       --',
'       null as actions',
'  from wwv_flow_app_settings s,',
'       wwv_flow_app_settings master',
' where s.flow_id           = :FB_FLOW_ID',
'   and s.security_group_id = :WORKSPACE_ID',
'   and s.reference_id      = master.id (+)',
'   and s.security_group_id = master.security_group_id (+)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(663191354226602129)
,p_name=>'Build Options'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No settings are defined for this application'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#LINK#" class="a-IRR-icon"><span class="a-Icon #IMG#"></span><span class="a-IRR-iconName">#NAME#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'MIKE'
,p_internal_uid=>663191354226602129
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(659455242914551039)
,p_db_column_name=>'ID'
,p_display_order=>33
,p_column_identifier=>'E'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(659466226407559701)
,p_db_column_name=>'NAME'
,p_display_order=>193
,p_column_identifier=>'X'
,p_column_label=>'Name'
,p_column_link=>'f?p=&APP_ID.:4851:&SESSION.::&DEBUG.:RP,4851:F4000_P4851_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(659466409712559703)
,p_db_column_name=>'VALUE'
,p_display_order=>203
,p_column_identifier=>'Z'
,p_column_label=>'Value'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524768890490188216)
,p_db_column_name=>'IS_REQUIRED'
,p_display_order=>213
,p_column_identifier=>'AI'
,p_column_label=>'Required'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(84259319526460470)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524768988975188217)
,p_db_column_name=>'VALID_VALUES'
,p_display_order=>223
,p_column_identifier=>'AJ'
,p_column_label=>'Valid Values'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524771791998188245)
,p_db_column_name=>'ON_UPGRADE_KEEP_VALUE'
,p_display_order=>233
,p_column_identifier=>'AM'
,p_column_label=>'On Upgrade Keep Value'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(84259319526460470)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(659466568974559704)
,p_db_column_name=>'COMMENTS'
,p_display_order=>243
,p_column_identifier=>'AA'
,p_column_label=>'Comments'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524771978805188247)
,p_db_column_name=>'REQUIRED_PATCH'
,p_display_order=>253
,p_column_identifier=>'AN'
,p_column_label=>'Build Option'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(659466678035559705)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>263
,p_column_identifier=>'AB'
,p_column_label=>'Created'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(659461245250551053)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>273
,p_column_identifier=>'S'
,p_column_label=>'Created By'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524769098525188218)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>283
,p_column_identifier=>'AK'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(524769101778188219)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>293
,p_column_identifier=>'AL'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(275642861173510006)
,p_db_column_name=>'IMG'
,p_display_order=>303
,p_column_identifier=>'AO'
,p_column_label=>'Img'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(275642992681510007)
,p_db_column_name=>'LINK'
,p_display_order=>313
,p_column_identifier=>'AP'
,p_column_label=>'Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3626358165310609)
,p_db_column_name=>'SUBSCRIBED_FROM'
,p_display_order=>323
,p_column_identifier=>'AQ'
,p_column_label=>'Subscribed From'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3626457534310610)
,p_db_column_name=>'SUBSCRIBERS'
,p_display_order=>333
,p_column_identifier=>'AR'
,p_column_label=>'Subscribers'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3626556408310611)
,p_db_column_name=>'SUBSCRIPTION_STATUS'
,p_display_order=>343
,p_column_identifier=>'AS'
,p_column_label=>'Subscription Status'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2185943426145949)
,p_db_column_name=>'ACTIONS'
,p_display_order=>363
,p_column_identifier=>'AU'
,p_column_label=>'Copy'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'TMPL_THEME_3$ACTIONS'
,p_column_alignment=>'CENTER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'ACTIONS_WRAP', 'N',
  'STYLE', 'b-InlineActions--simple')).to_clob
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(663193778295677089)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_type=>'REPORT'
,p_report_alias=>'6594628'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'NAME:VALUE:IS_REQUIRED:VALID_VALUES:ON_UPGRADE_KEEP_VALUE:REQUIRED_PATCH:SUBSCRIBED_FROM:SUBSCRIPTION_STATUS:SUBSCRIBERS:LAST_UPDATED_ON:LAST_UPDATED_BY::ACTIONS'
,p_sort_column_1=>'NAME'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'0'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(659463232081551063)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(663191276316602128)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4850:&SESSION.::&DEBUG.:4850,RIR::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(659463668767551063)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(663191276316602128)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Setting'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4851:&SESSION.::&DEBUG.:4851::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(659465550091551069)
,p_branch_action=>'4910'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(659465121897551068)
,p_computation_sequence=>20
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'4850'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(659508237433651406)
,p_name=>'Refresh after Close Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(663191276316602128)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(659508377745651407)
,p_event_id=>wwv_flow_imp.id(659508237433651406)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(663191276316602128)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4232038396687553)
,p_event_id=>wwv_flow_imp.id(659508237433651406)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ( this.data.successMessage ) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4231132549687551)
,p_name=>'Refresh Subscriptions'
,p_event_sequence=>20
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(6036620591209186)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4231539630687553)
,p_event_id=>wwv_flow_imp.id(4231132549687551)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(663191276316602128)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3629257510310638)
,p_event_id=>wwv_flow_imp.id(4231132549687551)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ( this.data.successMessage ) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
);
wwv_flow_imp_page.create_component_action(
 p_id=>wwv_flow_imp.id(2186027462145950)
,p_ir_column_id=>wwv_flow_imp.id(2185943426145949)
,p_position_id=>wwv_flow_imp.id(214437533860142316)
,p_display_sequence=>10
,p_template_id=>wwv_flow_imp.id(214438625365151034)
,p_label=>'Copy'
,p_link_target_type=>'REDIRECT_PAGE'
,p_link_target=>'f?p=&APP_ID.:4852:&SESSION.::&DEBUG.:4852:P4852_COPY_SOURCE,P4852_ID,P4852_COPY_FROM_APP_ID:THIS,#ID#,&FB_FLOW_ID.'
,p_button_display_type=>'ICON'
,p_icon_css_classes=>'icon-copy'
,p_is_hot=>false
,p_show_as_disabled=>false
);
end;
/
prompt --application/pages/page_04851
begin
wwv_flow_imp_page.create_page(
 p_id=>4851
,p_name=>'Application Setting Details'
,p_alias=>'APPLICATION-SETTING-DETAILS'
,p_page_mode=>'MODAL'
,p_step_title=>'Application Setting'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213481614528579568)
,p_inline_css=>'.a-EditScreen-body {padding-top: 0;}'
,p_page_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_read_only_when=>'P4851_REFERENCE_ID'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(23358987284081925)
,p_plug_name=>'Subscription'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>25
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'F4000_P4851_ID'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'WWV_FLOW_APP_SETTINGS',
  'attribute_02', 'NAME',
  'attribute_03', 'F4000_P4851_ID',
  'attribute_04', 'P4851_REFERENCE_ID',
  'attribute_05', 'SUBSCRIBE_APP_SETTING',
  'attribute_06', 'VERSION_SCN')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(224900616502191331)
,p_plug_name=>'Configuration'
,p_region_name=>'BUILD'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>' '
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_num_rows=>150
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(659491575818183010)
,p_plug_name=>'Attributes'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_region_attributes=>' '
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_APP_SETTINGS'
,p_query_where=>'security_group_id = :WORKSPACE_ID'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1275009101187899937)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noBorder'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1276927482838254567)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_imp.id(29434107863295859)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'    select last_updated_by,',
'           last_updated_on,',
'           created_by,',
'           created_on',
'      from wwv_flow_app_settings',
'     where id                = :F4000_P4851_ID',
'       and flow_id           = :FB_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID )',
'loop',
'    wwv_flow_4000_ui.show_history (',
'        p_id                 => :F4000_P4851_ID,',
'        p_last_updated_by    => c1.last_updated_by,',
'        p_last_updated_on    => c1.last_updated_on,',
'        p_created_by         => c1.created_by,',
'        p_created_on         => c1.created_on );',
'    exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'F4000_P4851_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4605528640342289)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_imp.id(23358987284081925)
,p_button_name=>'UNSUBSCRIBE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Unsubscribe'
,p_button_position=>'EDIT'
,p_button_condition=>':P4851_REFERENCE_ID is not null and :P4851_SUBSCRIBED_COMP_GRP = ''N'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4605922799342291)
,p_button_sequence=>110
,p_button_plug_id=>wwv_flow_imp.id(23358987284081925)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Refresh Application Setting'
,p_button_position=>'EDIT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P4851_REFERENCE_ID is not null ',
'and ( :P4851_VERSION_SCN != :P4851_MASTER_VERSION_SCN or :P4851_VERSION_SCN is null )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4606361763342291)
,p_button_sequence=>120
,p_button_plug_id=>wwv_flow_imp.id(23358987284081925)
,p_button_name=>'PUBLISH'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Publish'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.:149:F4000_P149_ID,F4000_P149_TEMPLATE_TYPE,F4000_P149_PAGE_ID:&F4000_P4851_ID.,APP_SETTING,4851'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * ',
'  from wwv_flow_app_settings',
' where reference_id      = :F4000_P4851_ID ',
'   and security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(659499040691635276)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1275009101187899937)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_confirm_message=>'&DELETE_MSG.'
,p_confirm_style=>'danger'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P4851_ID is not null',
'and ( :P4851_REFERENCE_ID is null or :P4851_SUBSCRIBED_COMP_GRP = ''N'' )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(659499425611635277)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(1275009101187899937)
,p_button_name=>'SAVE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>':F4000_P4851_ID is not null and :P4851_REFERENCE_ID is null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(659499891212635277)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(1275009101187899937)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Application Setting'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P4851_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(659498663294635274)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1275009101187899937)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2525558306409142)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1275009101187899937)
,p_button_name=>'COPY_FROM_ANOTHER'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Copy from another app'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:4852:&SESSION.::&DEBUG.:4852:P4852_COPY_SOURCE:OTHER'
,p_button_condition=>'F4000_P4851_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_button_css_classes=>'a-Button--noUI'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2357302430667318)
,p_name=>'P4851_SUBSCRIBED_COMP_GRP'
,p_item_sequence=>260
,p_item_plug_id=>wwv_flow_imp.id(23358987284081925)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2525307392409140)
,p_name=>'P4851_SUCCESS_MSG'
,p_item_sequence=>250
,p_item_plug_id=>wwv_flow_imp.id(659491575818183010)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7242108116476406)
,p_name=>'P4851_VERSION_SCN'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(23358987284081925)
,p_item_source_plug_id=>wwv_flow_imp.id(659491575818183010)
,p_source=>'VERSION_SCN'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(12035240703543461)
,p_name=>'P4851_MASTER_VERSION_SCN'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(23358987284081925)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select version_scn ',
'  from wwv_flow_app_settings',
' where id                = :P4851_REFERENCE_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(23365046085081994)
,p_name=>'P4851_REFERENCE_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(23358987284081925)
,p_item_source_plug_id=>wwv_flow_imp.id(659491575818183010)
,p_prompt=>'Subscribe From'
,p_source=>'REFERENCE_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FLOW_SUBSCRIBE_FROM_APP_SETTINGS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select b.flow_id ||'' ''||f.name||'' - ''|| b.name d,',
'       b.id r',
'  from wwv_flow_app_settings b,',
'       wwv_flows f',
' where b.flow_id          != nvl(:FB_FLOW_ID,0)',
'   and b.flow_id           = f.id',
'   and f.build_status      not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'   and b.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and f.security_group_id = :FLOW_SECURITY_GROUP_ID',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Subscription -'
,p_cSize=>50
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a master application setting to subscribe from. When you select a master application setting and click on the <strong>Apply Changes</strong> button, the application setting details will be automatically refreshed from the selected master.<br /'
||'><br />If the application setting is already subscribed, then click on the <strong>Refresh application setting</strong> button to refresh the application setting details from the master application setting.'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'Y'
,p_attribute_06=>'0'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(23365132563081995)
,p_name=>'P4851_REFERENCE_ID_INIT'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(23358987284081925)
,p_use_cache_before_default=>'NO'
,p_item_default=>'P4851_REFERENCE_ID'
,p_item_default_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(57818688735990561)
,p_name=>'P4851_REQUIRED_PATCH'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(224900616502191331)
,p_item_source_plug_id=>wwv_flow_imp.id(659491575818183010)
,p_prompt=>'Build Option'
,p_source=>'REQUIRED_PATCH'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PATCHES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(patch_name) pn, id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'', wwv_flow_escape.html(patch_name))||',
'''} '' pn,0-id id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by pn'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Build Option -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select a build option for this component.<p/>',
'Build options are predefined settings that determine whether or not components within an application are enabled.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(524768673200188214)
,p_name=>'P4851_IS_REQUIRED'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_imp.id(659491575818183010)
,p_item_source_plug_id=>wwv_flow_imp.id(659491575818183010)
,p_prompt=>'Value Required'
,p_source=>'IS_REQUIRED'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(524768706335188215)
,p_name=>'P4851_VALID_VALUES'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_imp.id(659491575818183010)
,p_item_source_plug_id=>wwv_flow_imp.id(659491575818183010)
,p_prompt=>'Valid Values'
,p_source=>'VALID_VALUES'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter comma separated valid values.  If defined, &PRODUCT_NAME. only accepts valid values when the settings change.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(659492293967635269)
,p_name=>'F4000_P4851_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(659491575818183010)
,p_item_source_plug_id=>wwv_flow_imp.id(659491575818183010)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(659507705606651401)
,p_name=>'P4851_NAME'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(659491575818183010)
,p_item_source_plug_id=>wwv_flow_imp.id(659491575818183010)
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter a descriptive name for this application setting. Application Settings enable developers to define application level configuration options.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(659507876349651402)
,p_name=>'P4851_VALUE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(659491575818183010)
,p_item_source_plug_id=>wwv_flow_imp.id(659491575818183010)
,p_prompt=>'Value'
,p_source=>'VALUE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter the default value for this application setting.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(659507965963651403)
,p_name=>'P4851_COMMENTS'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>240
,p_item_plug_id=>wwv_flow_imp.id(659491575818183010)
,p_item_source_plug_id=>wwv_flow_imp.id(659491575818183010)
,p_prompt=>'Comments'
,p_source=>'COMMENTS'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(659508452659651408)
,p_name=>'P4851_FLOW_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(659491575818183010)
,p_item_source_plug_id=>wwv_flow_imp.id(659491575818183010)
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Application:'
,p_source=>'FLOW_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(724232577429924804)
,p_name=>'P4851_ON_UPGRADE_KEEP_VALUE'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_imp.id(659491575818183010)
,p_item_source_plug_id=>wwv_flow_imp.id(659491575818183010)
,p_item_default=>'N'
,p_prompt=>'On Upgrade Keep Value'
,p_source=>'ON_UPGRADE_KEEP_VALUE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Select whether the application setting value in the deployed application should be kept, or overwritten with the specified value when the application is upgraded. Selecting <strong>On</strong> to keep the deployed value is useful if the application s'
||'upports application setting configuration (using the <code>APEX_APP_SETTING.SET_VALUE</code> API) to change the application setting value in the deployed application, and where you want to respect those values upon upgrade.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2357490862667319)
,p_computation_sequence=>10
,p_computation_item=>'P4851_SUBSCRIBED_COMP_GRP'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_component_group_dev.is_part_of_subscribed_comp_grp (',
'    p_component_id   => :F4000_P4851_ID,',
'    p_component_type => wwv_flow_copy_metadata.c_app_setting,',
'    p_app_id         => :FB_FLOW_ID )'))
,p_compute_when=>'F4000_P4851_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(618161397257156838)
,p_validation_name=>'valid name'
,p_validation_sequence=>10
,p_validation=>'P4851_NAME'
,p_validation_type=>'ITEM_IS_ALPHANUMERIC'
,p_error_message=>'#LABEL# may contain only alphanumeric characters and underscores "_".'
,p_validation_condition=>'DELETE'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_associated_item=>wwv_flow_imp.id(659507705606651401)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(618161497447156839)
,p_validation_name=>'name exists'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_app_settings',
' where name              = upper(:P4851_NAME)',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and ( id != :F4000_P4851_ID or :F4000_P4851_ID is null )'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'The name is already used by another application setting.  '
,p_validation_condition=>'DELETE'
,p_validation_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(524769391908188221)
,p_validation_name=>'value required'
,p_validation_sequence=>30
,p_validation=>'P4851_VALUE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Application Setting &P4851_NAME. may not be set to a null value'
,p_validation_condition=>'P4851_IS_REQUIRED'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(524769282896188220)
,p_validation_name=>'is value valid'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for l_valid_value in (',
'    select column_value',
'    from table( wwv_flow_string.split( :P4851_VALID_VALUES, '','' ) ) )',
'loop',
'    if :P4851_VALUE = trim(l_valid_value.column_value) then',
'        return true;',
'    end if;',
'end loop;',
'',
'-- if value not one of the valid value',
'return false;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Application Setting &P4851_NAME. value is invalid'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P4851_VALID_VALUES is not null and',
':P4851_VALUE is not null and',
':REQUEST != ''DELETE'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4629731093516083)
,p_validation_name=>'No duplicate subscription'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_app_settings',
' where security_group_id = :WORKSPACE_ID ',
'   and flow_id           = :FB_FLOW_ID ',
'   and reference_id      = :P4851_REFERENCE_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'An existing application setting in this application is subscribed to the same master. Please select another master application setting.'
,p_validation_condition=>':P4851_REFERENCE_ID is not null and :P4851_REFERENCE_ID_INIT is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(659499425611635277)
,p_associated_item=>wwv_flow_imp.id(23365046085081994)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2608028098062020)
,p_validation_name=>'Not part of component groups'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not wwv_flow_component_group_dev.is_part_of_comp_grp (',
'    p_component_id   => :F4000_P4851_ID,',
'    p_component_type => wwv_flow_copy_metadata.c_app_setting,',
'    p_app_id         => :FB_FLOW_ID )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Application Setting cannot be deleted because it is part of a component group.'
,p_when_button_pressed=>wwv_flow_imp.id(659499040691635276)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(659508860217651412)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(659498663294635274)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(659508916024651413)
,p_event_id=>wwv_flow_imp.id(659508860217651412)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2525178672409138)
,p_name=>'Hide P4851_REFERENCE_ID'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P4851_REFERENCE_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2525232076409139)
,p_event_id=>wwv_flow_imp.id(2525178672409138)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4851_REFERENCE_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2357521642667320)
,p_name=>'Save'
,p_event_sequence=>40
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(659499425611635277)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2357651992667321)
,p_event_id=>wwv_flow_imp.id(2357521642667320)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'Are you sure you want to subscribe? This will overwrite the current application setting data with the selected master application setting.'
,p_attribute_03=>'warning'
,p_attribute_06=>'Subscribe'
,p_attribute_07=>'Cancel'
,p_client_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_client_condition_expression=>'$v(''P4851_REFERENCE_ID'') !== "" && $v(''P4851_REFERENCE_ID_INIT'') === ""'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2357755396667322)
,p_event_id=>wwv_flow_imp.id(2357521642667320)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'SAVE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2525011466409137)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(659491575818183010)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process form Attributes'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE,SAVE,DELETE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'Action processed.'
,p_internal_uid=>2525011466409137
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4630136149524532)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh App Setting'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.refresh_component (',
'    p_component_type     => wwv_flow_copy_metadata.c_app_setting,',
'    p_master_id          => :P4851_REFERENCE_ID,',
'    p_subscribing_id     => :F4000_P4851_ID,',
'    p_subscribing_app_id => :FB_FLOW_ID );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Refresh failed.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST = ''REFRESH''',
'or ( :REQUEST = ''SAVE'' and :P4851_REFERENCE_ID is not null and :P4851_REFERENCE_ID_INIT is null )'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Application setting refreshed from the master.'
,p_internal_uid=>4630136149524532
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4630454954525536)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Unsubscribe'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.unsubscribe_component (',
'    p_component_type  => wwv_flow_copy_metadata.c_app_setting,',
'    p_component_id    => :F4000_P4851_ID,',
'    p_app_id          => :FB_FLOW_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(4605528640342289)
,p_process_success_message=>'Application setting has been unsubscribed.'
,p_internal_uid=>4630454954525536
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4632432296559410)
,p_process_sequence=>80
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Clear Subscriptions'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- when deleting the component, clear reference_id data from subscribing apps',
'--',
'wwv_flow_copy_metadata.clear_subscriptions (',
'    p_component_type => wwv_flow_copy_metadata.c_app_setting,',
'    p_master_id      => :F4000_P4851_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(659499040691635276)
,p_internal_uid=>4632432296559410
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2525464353409141)
,p_process_sequence=>90
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Save Success Message to P4851_SUCCESS_MSG'
,p_process_sql_clob=>':P4851_SUCCESS_MSG := wwv_flow.g_print_success_message;'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2525464353409141
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(659508135714651405)
,p_process_sequence=>100
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'&P4851_SUCCESS_MSG.'
,p_internal_uid=>659508135714651405
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2523361854409120)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(659491575818183010)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Application Setting Details'
,p_internal_uid=>2523361854409120
);
end;
/
prompt --application/pages/page_04852
begin
wwv_flow_imp_page.create_page(
 p_id=>4852
,p_name=>'Copy Application Setting'
,p_alias=>'COPY-APPLICATION-SETTING'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Application Setting'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'auto'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_protection_level=>'C'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(55033826065081455)
,p_plug_name=>'Wizard Button'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(239774808713224344)
,p_plug_name=>'Copy Application Setting'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4201502972272131)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(55033826065081455)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4201948102272133)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(55033826065081455)
,p_button_name=>'COPY_FROM_ANOTHER'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Copy from another app'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:4852:&SESSION.::&DEBUG.:4852:P4852_COPY_SOURCE:OTHER'
,p_button_condition=>'P4852_COPY_SOURCE'
,p_button_condition2=>'THIS'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_button_css_classes=>'a-Button--noUI'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4202343685272133)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(55033826065081455)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy Application Setting'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4212025298272170)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(4202343685272133)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8609828895414759)
,p_name=>'P4852_NEW_APP_SETTING_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(239774808713224344)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(23617225596205972)
,p_name=>'P4852_SUBSCRIBE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(239774808713224344)
,p_item_default=>'Y'
,p_prompt=>'Subscribe'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>'P4852_COPY_SOURCE'
,p_display_when2=>'OTHER'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'While copying the application setting, you can also subscribe to it. Set Subscribe to <strong>On</strong> to subscribe to the application setting.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(23916824399284569)
,p_name=>'P4852_COPY_SOURCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(239774808713224344)
,p_item_default=>'THIS'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(220284982566146355)
,p_name=>'P4852_COPY_FROM_APP_ID'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(239774808713224344)
,p_prompt=>'Application'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST OTHER FLOWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'  from   wwv_flow_visible_flows f',
' where id != :FB_FLOW_ID',
'   and build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'order by 2'))
,p_cHeight=>1
,p_display_when=>'P4852_COPY_SOURCE'
,p_display_when2=>'OTHER'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Select the application from which you want to copy an application setting.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(239795483925263739)
,p_name=>'P4852_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(239774808713224344)
,p_prompt=>'New Application Setting Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the name of the application setting. Application setting name must be unique within the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(239798800201268445)
,p_name=>'P4852_ID'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(239774808713224344)
,p_prompt=>'Copy Application Setting'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_flow_app_settings',
' where flow_id           = :P4852_COPY_FROM_APP_ID',
'   and security_group_id = :WORKSPACE_ID',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Application Setting -'
,p_lov_cascade_parent_items=>'P4852_COPY_FROM_APP_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_read_only_when=>'P4852_ID'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify an application setting to copy.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'Y'
,p_attribute_06=>'0'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4207244448272162)
,p_validation_name=>'P4852_NAME not null'
,p_validation_sequence=>10
,p_validation=>'P4852_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>':P4852_COPY_SOURCE = ''THIS'' or :P4852_SUBSCRIBE = ''N'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(4202343685272133)
,p_associated_item=>wwv_flow_imp.id(239795483925263739)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3629303438310639)
,p_validation_name=>'P4852_NAME is valid'
,p_validation_sequence=>20
,p_validation=>'P4852_NAME'
,p_validation_type=>'ITEM_IS_ALPHANUMERIC'
,p_error_message=>'#LABEL# may contain only alphanumeric characters and underscores "_".'
,p_validation_condition=>':P4852_COPY_SOURCE = ''THIS'' or :P4852_SUBSCRIBE = ''N'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(4202343685272133)
,p_associated_item=>wwv_flow_imp.id(239795483925263739)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4207671074272163)
,p_validation_name=>'NAME unique'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_app_settings',
' where security_group_id = :WORKSPACE_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and name              = :P4852_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'An application setting already exists with the same name. Please enter a different name.'
,p_validation_condition=>':P4852_COPY_SOURCE = ''THIS'' or :P4852_SUBSCRIBE = ''N'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(4202343685272133)
,p_associated_item=>wwv_flow_imp.id(239795483925263739)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4208050894272163)
,p_validation_name=>'No duplicate subscription'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_app_settings',
' where security_group_id = :WORKSPACE_ID ',
'   and flow_id           = :FB_FLOW_ID ',
'   and reference_id      = :P4852_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'There is another application setting in this application that is subscribed to the same master. Please select another master application setting.'
,p_validation_condition=>'P4852_SUBSCRIBE'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(4202343685272133)
,p_associated_item=>wwv_flow_imp.id(239798800201268445)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4208764393272165)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(4201502972272131)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4209268165272167)
,p_event_id=>wwv_flow_imp.id(4208764393272165)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4209648003272168)
,p_name=>'Toggle P4852_NAME display'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4852_SUBSCRIBE'
,p_condition_element=>'P4852_SUBSCRIBE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_cond=>'P4852_COPY_SOURCE'
,p_display_when_cond2=>'OTHER'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4210187418272168)
,p_event_id=>wwv_flow_imp.id(4209648003272168)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4852_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4210640108272168)
,p_event_id=>wwv_flow_imp.id(4209648003272168)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4852_NAME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4211010001272168)
,p_name=>'Set New Name'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4852_ID'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_cond=>'P4852_COPY_SOURCE'
,p_display_when_cond2=>'OTHER'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4211599347272169)
,p_event_id=>wwv_flow_imp.id(4211010001272168)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4852_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'apex.item("P4852_ID").displayValueFor($v("P4852_ID"))'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4208378196272164)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Application Setting'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P4852_NEW_APP_SETTING_ID := wwv_flow_copy_metadata.copy_component (',
'    p_component_type       => wwv_flow_copy_metadata.c_app_setting,',
'    p_from_id              => :P4852_ID,',
'    p_from_app_id          => :P4852_COPY_FROM_APP_ID,',
'    p_to_app_id            => :FB_FLOW_ID,',
'    p_new_name             => :P4852_NAME,',
'    p_subscribe            => :P4852_SUBSCRIBE = ''Y'' );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to copy the application setting.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(4202343685272133)
,p_process_success_message=>'Application setting copied.'
,p_internal_uid=>4208378196272164
);
end;
/
prompt --application/pages/page_04860
begin
wwv_flow_imp_page.create_page(
 p_id=>4860
,p_name=>'Email Templates'
,p_alias=>'EMAIL-TEMPLATES'
,p_step_title=>'Email Templates'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213481614528579568)
,p_inline_css=>'.code-inline {white-space: normal; font-size: 11px; word-break: break-word;}'
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_build_options.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1807825119551129)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(2010986589661811)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(487196643709213274)
,p_plug_name=>'tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_imp.id(2306436841283369)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Email Templates'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1340410279495045514)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--sideRegion:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Your application can send emails using the email templates defined on this screen.</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1344148901748039779)
,p_plug_name=>'Email Templates'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select e.id,',
'       e.name,',
'       e.subject,',
'       e.static_id,',
'       e.comments,',
'       e.created_on,',
'       e.created_by,',
'       e.last_updated_on,',
'       e.last_updated_by,',
'       case when e.version_number > 1 then ''Y'' else ''N'' end supports_template_directives,',
'       --',
'       case when e.reference_id is not null then',
'           coalesce ( to_char( master.flow_id ),',
'                       wwv_flow_lang_dev.builder_message( ''SUBSCRIBED_FROM.NONEXISTING_MASTER'' ) )',
'       end as subscribed_from,',
'       ( select case when count(*) > 0 then count(*) end',
'           from wwv_flow_email_templates sub',
'          where sub.reference_id      = e.id',
'            and sub.security_group_id = :WORKSPACE_ID ) as subscribers,',
'       case when e.reference_id is not null then',
'           case',
'               when master.version_scn = e.version_scn then',
'                   wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_UP_TO_DATE'')',
'               when master.version_scn != e.version_scn then',
'                   wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_NEEDS_REFRESH'')',
'               else',
'                   wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_UNKNOWN'')',
'           end',
'       end subscription_status,',
'       --',
'       null as actions   ',
'  from wwv_flow_email_templates e,',
'       wwv_flow_email_templates master',
' where e.flow_id           = :FB_FLOW_ID',
'   and e.security_group_id = :WORKSPACE_ID',
'   and e.reference_id      = master.id (+)',
'   and e.security_group_id = master.security_group_id (+)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(1344148979658039780)
,p_name=>'Build Options'
,p_no_data_found_message=>'No Email templates are defined for this application'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1344148979658039780
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(680959332520437687)
,p_db_column_name=>'ID'
,p_display_order=>33
,p_column_identifier=>'E'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(680960154480437688)
,p_db_column_name=>'NAME'
,p_display_order=>193
,p_column_identifier=>'X'
,p_column_label=>'Name'
,p_column_link=>'f?p=&APP_ID.:4861:&SESSION.::&DEBUG.:RP,4861:F4000_P4861_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(446736640682201412)
,p_db_column_name=>'SUBJECT'
,p_display_order=>203
,p_column_identifier=>'AL'
,p_column_label=>'Subject'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(680960949155437689)
,p_db_column_name=>'COMMENTS'
,p_display_order=>213
,p_column_identifier=>'AA'
,p_column_label=>'Comments'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(680961326881437690)
,p_db_column_name=>'CREATED_ON'
,p_display_order=>223
,p_column_identifier=>'AB'
,p_column_label=>'Created'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(680959790441437688)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>233
,p_column_identifier=>'S'
,p_column_label=>'Created By'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(620207530378182231)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>243
,p_column_identifier=>'AI'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(620207611569182232)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>253
,p_column_identifier=>'AJ'
,p_column_label=>'Updated by'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(693723440750042145)
,p_db_column_name=>'STATIC_ID'
,p_display_order=>263
,p_column_identifier=>'AK'
,p_column_label=>'Static Identifier'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(259650021343209801)
,p_db_column_name=>'SUPPORTS_TEMPLATE_DIRECTIVES'
,p_display_order=>273
,p_column_identifier=>'AM'
,p_column_label=>'Supports Template Directives'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(84259319526460470)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1807974010551130)
,p_db_column_name=>'SUBSCRIBED_FROM'
,p_display_order=>283
,p_column_identifier=>'AN'
,p_column_label=>'Subscribed From'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1808032030551131)
,p_db_column_name=>'SUBSCRIBERS'
,p_display_order=>293
,p_column_identifier=>'AO'
,p_column_label=>'Subscribers'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1808110874551132)
,p_db_column_name=>'SUBSCRIPTION_STATUS'
,p_display_order=>303
,p_column_identifier=>'AP'
,p_column_label=>'Subscription Status'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2182263625145912)
,p_db_column_name=>'ACTIONS'
,p_display_order=>323
,p_column_identifier=>'AR'
,p_column_label=>'Copy'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'TMPL_THEME_3$ACTIONS'
,p_column_alignment=>'CENTER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'ACTIONS_WRAP', 'N',
  'STYLE', 'b-InlineActions--simple')).to_clob
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(1344151403727114740)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_type=>'REPORT'
,p_report_alias=>'6809617'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'NAME:SUBJECT:SUPPORTS_TEMPLATE_DIRECTIVES:SUBSCRIBED_FROM:SUBSCRIPTION_STATUS:SUBSCRIBERS:LAST_UPDATED_BY:LAST_UPDATED_ON:STATIC_ID::ACTIONS'
,p_sort_column_1=>'PATCH_NAME'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(680962100362437694)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1344148901748039779)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4860:&SESSION.::&DEBUG.:4860,RIR::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(680962541348437694)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(1344148901748039779)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Email Template'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4861:&SESSION.::&DEBUG.:4861::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(680963756327437697)
,p_computation_sequence=>20
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'4910'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2626472108028996)
,p_name=>'Refresh Subscriptions'
,p_event_sequence=>20
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(1807825119551129)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2626823028029001)
,p_event_id=>wwv_flow_imp.id(2626472108028996)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1344148901748039779)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2627328745029001)
,p_event_id=>wwv_flow_imp.id(2626472108028996)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ( this.data.successMessage ) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
);
wwv_flow_imp_page.create_component_action(
 p_id=>wwv_flow_imp.id(2182335543145913)
,p_ir_column_id=>wwv_flow_imp.id(2182263625145912)
,p_position_id=>wwv_flow_imp.id(214437533860142316)
,p_display_sequence=>10
,p_template_id=>wwv_flow_imp.id(214438625365151034)
,p_label=>'Copy'
,p_link_target_type=>'REDIRECT_PAGE'
,p_link_target=>'f?p=&APP_ID.:120:&SESSION.::&DEBUG.:120:P120_COPY_SOURCE,P120_FROM_ID,P120_FROM_APPLICATION_ID:THIS,#ID#,&FB_FLOW_ID.'
,p_button_display_type=>'ICON'
,p_icon_css_classes=>'icon-copy'
,p_is_hot=>false
,p_show_as_disabled=>false
);
end;
/
prompt --application/pages/page_04861
begin
wwv_flow_imp_page.create_page(
 p_id=>4861
,p_name=>'Email Template Details'
,p_alias=>'EMAIL-TEMPLATE-DETAILS'
,p_step_title=>'Email Template Details'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(91429205691059841)
,p_inline_css=>'.sample-btn {width: 100%; display: block; margin-bottom: 8px; margin-left: 0 !important; text-align: left;}'
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_read_only_when=>'P4861_REFERENCE_ID'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3820682042253841)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>90
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(2010986589661811)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
,p_plug_display_condition_type=>'ITEM_IS_NULL'
,p_plug_display_when_condition=>'F4000_P4861_ID'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(18753703737739650)
,p_plug_name=>'Subscription'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>25
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'F4000_P4861_ID'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'WWV_FLOW_EMAIL_TEMPLATES',
  'attribute_02', 'NAME',
  'attribute_03', 'F4000_P4861_ID',
  'attribute_04', 'P4861_REFERENCE_ID',
  'attribute_05', 'SUBSCRIBE_EMAIL_TEMPLATE',
  'attribute_06', 'VERSION_SCN')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(218252253865877505)
,p_plug_name=>'Sample Templates'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Get started by loading a sample email template.</p>'
,p_plug_display_condition_type=>'ITEM_IS_NULL'
,p_plug_display_when_condition=>'P4861_REFERENCE_ID'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(413799296758117483)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Define the HTML format and Plain Text formats for the emails you wish to send.</p>',
'<p>When email template is subscribed, then it is not possible to change any data.</p>',
'<p>Deletion of the <strong>master</strong> email template automatically clears the email template references from subscribing email templates.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(481182180273329903)
,p_plug_name=>'Sample API Usage'
,p_region_template_options=>'#DEFAULT#:a-Region--shadowScroll:a-Region--paddedBody:h480'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'<div id="api"></div>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(556519583874537179)
,p_plug_name=>'Update Email Template Available'
,p_region_css_classes=>'a-Alert--page'
,p_region_template_options=>'#DEFAULT#:a-Alert--info:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'Email templates now support template directives! You can upgrade your email template and use directives to control how substitution strings are processed.'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':F4000_P4861_VERSION_NUMBER = 1 and :P4861_REFERENCE_ID is null'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(620207911554182235)
,p_plug_name=>'Plain Text Format'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(620208118464182237)
,p_plug_name=>'HTML Format'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(40361794223464001)
,p_plug_name=>'Advanced'
,p_parent_plug_id=>wwv_flow_imp.id(620208118464182237)
,p_region_css_classes=>'a-Region--noBottomBorder'
,p_region_template_options=>'#DEFAULT#:is-expanded:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(689970285456172024)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(620208219513182238)
,p_plug_name=>'Comments'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(620208848205182244)
,p_plug_name=>'RDS'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(681116845925664404)
,p_plug_name=>'Identification'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(681117531703664406)
,p_plug_name=>'Template Details'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_04'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_EMAIL_TEMPLATES'
,p_query_where=>'security_group_id = :WORKSPACE_ID'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(40362328235464007)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(40361794223464001)
,p_button_name=>'RESTORE_HTML'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--gapLeft'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Load Default HTML'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'icon-undo'
,p_grid_new_row=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(218252429784877507)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(218252253865877505)
,p_button_name=>'LOAD_ORDER_DETAILS'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'Order Details'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'sample-btn'
,p_icon_css_classes=>'icon-load-sample'
,p_grid_new_row=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(218252503160877508)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(218252253865877505)
,p_button_name=>'LOAD_EVENT_REMINDER'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'Event Reminder'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'sample-btn'
,p_icon_css_classes=>'icon-load-sample'
,p_grid_new_row=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(100576992718284427)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(218252253865877505)
,p_button_name=>'LOAD_SCHEDULED_OUTAGE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'Scheduled Outage'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'sample-btn'
,p_icon_css_classes=>'icon-load-sample'
,p_grid_new_row=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2629927337080247)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_imp.id(18753703737739650)
,p_button_name=>'UNSUBSCRIBE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Unsubscribe'
,p_button_position=>'EDIT'
,p_button_condition=>':P4861_REFERENCE_ID is not null and :P4861_SUBSCRIBED_COMP_GRP = ''N'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2630390028080248)
,p_button_sequence=>110
,p_button_plug_id=>wwv_flow_imp.id(18753703737739650)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Refresh Email Template'
,p_button_position=>'EDIT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P4861_REFERENCE_ID is not null ',
'and ( :P4861_VERSION_SCN != :P4861_MASTER_VERSION_SCN or :P4861_VERSION_SCN is null )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2630721928080249)
,p_button_sequence=>120
,p_button_plug_id=>wwv_flow_imp.id(18753703737739650)
,p_button_name=>'PUBLISH'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Publish'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.:149:F4000_P149_ID,F4000_P149_TEMPLATE_TYPE,F4000_P149_PAGE_ID:&F4000_P4861_ID.,EMAIL_TEMPLATE,4861'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * ',
'  from wwv_flow_email_templates',
' where reference_id      = :F4000_P4861_ID ',
'   and security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2801767283175295)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(556519583874537179)
,p_button_name=>'UPGRADE_TEMPLATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Upgrade Template'
,p_button_position=>'NEXT'
,p_confirm_message=>'Upgrading an email template cannot be undone. Do you really want to continue?'
,p_confirm_style=>'information'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(681117952155664406)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(681117531703664406)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:4860:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(681117422344664406)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(681117531703664406)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_confirm_message=>'Would you like to delete this Email Template?'
,p_confirm_style=>'danger'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P4861_ID is not null',
'and ( :P4861_REFERENCE_ID is null or :P4861_SUBSCRIBED_COMP_GRP = ''N'' )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(681117353209664406)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(681117531703664406)
,p_button_name=>'SAVE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>':F4000_P4861_ID is not null and :P4861_REFERENCE_ID is null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(681117279243664406)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(681117531703664406)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Email Template'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P4861_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(620208962722182245)
,p_branch_name=>'Branch to Templates Page'
,p_branch_action=>'f?p=&APP_ID.:4860:&SESSION.::&DEBUG.:RP::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_branch_condition=>'RESTORE_HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1706356962319011)
,p_name=>'F4000_P4861_VERSION_NUMBER'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(681116845925664404)
,p_item_source_plug_id=>wwv_flow_imp.id(681117531703664406)
,p_item_default=>'wwv_flow_mail.c_template_version'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_source=>'VERSION_NUMBER'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2358869826667333)
,p_name=>'P4861_SUBSCRIBED_COMP_GRP'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(18753703737739650)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2635357446134114)
,p_name=>'P4861_VERSION_SCN'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(18753703737739650)
,p_item_source_plug_id=>wwv_flow_imp.id(681117531703664406)
,p_source=>'VERSION_SCN'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7428490033201169)
,p_name=>'P4861_MASTER_VERSION_SCN'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(18753703737739650)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select version_scn ',
'  from wwv_flow_email_templates',
' where id                = :P4861_REFERENCE_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18758295414739702)
,p_name=>'P4861_REFERENCE_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(18753703737739650)
,p_item_source_plug_id=>wwv_flow_imp.id(681117531703664406)
,p_prompt=>'Subscribe From'
,p_source=>'REFERENCE_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FLOW_SUBSCRIBE_FROM_EMAIL_TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select b.flow_id ||'' ''||f.name||'' - ''|| b.name d,',
'       b.id r',
'  from wwv_flow_email_templates b,',
'       wwv_flows f',
' where b.flow_id          != nvl(:FB_FLOW_ID,0)',
'   and b.flow_id           = f.id',
'   and f.build_status      not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'   and b.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and f.security_group_id = :FLOW_SECURITY_GROUP_ID',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Subscription -'
,p_cSize=>50
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a master email template to subscribe from. When you select a master email template and click on the <strong>Apply Changes</strong> button, the email template details will be automatically refreshed from the selected master.<br /><br />If the e'
||'mail template is already subscribed, then click on the <strong>Refresh Email Template</strong> button to refresh the email template details from the master email template.'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'Y'
,p_attribute_06=>'0'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18758381892739703)
,p_name=>'P4861_REFERENCE_ID_INIT'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(18753703737739650)
,p_use_cache_before_default=>'NO'
,p_item_default=>'P4861_REFERENCE_ID'
,p_item_default_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(259650230882209803)
,p_name=>'P4861_SUPPORTS_TMPT_DIRECTIVES'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(681116845925664404)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Supports Template Directives'
,p_source=>'case when :F4000_P4861_VERSION_NUMBER > 1 then ''Y'' else ''N'' end'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'YES_NO_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(84259319526460470)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'	',
'You can use template directives to control how substitution strings are processed.'))
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(446736559362201411)
,p_name=>'F4000_P4861_SUBJECT'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(681116845925664404)
,p_item_source_plug_id=>wwv_flow_imp.id(681117531703664406)
,p_prompt=>'Email Subject'
,p_source=>'SUBJECT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Substitution strings may be used with the <code>#STRING_NAME#</code> format. You can pass in values for these strings using the <code>APEX_MAIL</code> API.',
'<p></p>',
'<h4>Additional Information</h4>',
'<ul>',
'    <li>Supports Template Directives</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(681120398494664411)
,p_name=>'F4000_P4861_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(681116845925664404)
,p_item_source_plug_id=>wwv_flow_imp.id(681117531703664406)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(681121138469664443)
,p_name=>'F4000_P4861_FLOW_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(681116845925664404)
,p_item_source_plug_id=>wwv_flow_imp.id(681117531703664406)
,p_item_default=>'&FB_FLOW_ID.'
,p_source=>'FLOW_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(681121579555664443)
,p_name=>'F4000_P4861_NAME'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(681116845925664404)
,p_item_source_plug_id=>wwv_flow_imp.id(681117531703664406)
,p_prompt=>'Template Name'
,p_source=>'NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_restricted_characters=>'US_ONLY'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(681121989585664444)
,p_name=>'F4000_P4861_STATIC_ID'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(681116845925664404)
,p_item_source_plug_id=>wwv_flow_imp.id(681117531703664406)
,p_prompt=>'Static Identifier'
,p_source=>'STATIC_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'This identifier is used in the <code>APEX_MAIL</code> API call to reference this template.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(681122356863664444)
,p_name=>'F4000_P4861_COMMENTS'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(620208219513182238)
,p_item_source_plug_id=>wwv_flow_imp.id(681117531703664406)
,p_prompt=>'Comments'
,p_source=>'COMMENTS'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(681122782009664445)
,p_name=>'F4000_P4861_TEXT_TEMPLATE'
,p_source_data_type=>'CLOB'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(620207911554182235)
,p_item_source_plug_id=>wwv_flow_imp.id(681117531703664406)
,p_prompt=>'Content'
,p_source=>'TEXT_TEMPLATE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>60
,p_cMaxlength=>32767
,p_cHeight=>12
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Substitution strings may be used with the <code>#STRING_NAME#</code> format. You can pass in values for these strings using the <code>APEX_MAIL</code> API.',
'<p></p>',
'<h4>Additional Information</h4>',
'<ul>',
'    <li>Supports Template Directives</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(681124744435664446)
,p_name=>'F4000_P4861_HTML_TEMPLATE'
,p_source_data_type=>'CLOB'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(40361794223464001)
,p_item_source_plug_id=>wwv_flow_imp.id(681117531703664406)
,p_prompt=>'HTML Template'
,p_source=>'HTML_TEMPLATE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cMaxlength=>32767
,p_cHeight=>8
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Available substitution strings:</p>',
'',
'<ul>',
'    <li><code>#HEADER#</code></li>',
'    <li><code>#BODY#</code></li>',
'    <li><code>#FOOTER#</code></li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(681125178547664446)
,p_name=>'F4000_P4861_HTML_HEADER'
,p_source_data_type=>'CLOB'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(620208118464182237)
,p_item_source_plug_id=>wwv_flow_imp.id(681117531703664406)
,p_prompt=>'Header'
,p_source=>'HTML_HEADER'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>60
,p_cMaxlength=>32767
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Substitution strings may be used with the <code>#STRING_NAME#</code> format. You can pass in values for these strings using the <code>APEX_MAIL</code> API.',
'<p></p>',
'<h4>Additional Information</h4>',
'<ul>',
'    <li>Supports Template Directives</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(681125548202664447)
,p_name=>'F4000_P4861_HTML_BODY'
,p_source_data_type=>'CLOB'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(620208118464182237)
,p_item_source_plug_id=>wwv_flow_imp.id(681117531703664406)
,p_prompt=>'Body'
,p_source=>'HTML_BODY'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>60
,p_cMaxlength=>32767
,p_cHeight=>8
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>You can use basic markup to format the body of your HTML email.</p>',
'<p>Substitution strings may be used with the <code>#STRING_NAME#</code> format. You can pass in values for these strings using the <code>APEX_MAIL</code> API.</p>',
'<p></p>',
'<h4>Additional Information</h4>',
'<ul>',
'    <li>Supports Template Directives</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(681125979457664447)
,p_name=>'F4000_P4861_HTML_FOOTER'
,p_source_data_type=>'CLOB'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(620208118464182237)
,p_item_source_plug_id=>wwv_flow_imp.id(681117531703664406)
,p_prompt=>'Footer'
,p_source=>'HTML_FOOTER'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>60
,p_cMaxlength=>32767
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Substitution strings may be used with the <code>#STRING_NAME#</code> format. You can pass in values for these strings using the <code>APEX_MAIL</code> API.',
'<p></p>',
'<h4>Additional Information</h4>',
'<ul>',
'    <li>Supports Template Directives</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2358920506667334)
,p_computation_sequence=>10
,p_computation_item=>'P4861_SUBSCRIBED_COMP_GRP'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_component_group_dev.is_part_of_subscribed_comp_grp (',
'    p_component_id   => :F4000_P4861_ID,',
'    p_component_type => wwv_flow_copy_metadata.c_email_template,',
'    p_app_id         => :FB_FLOW_ID )'))
,p_compute_when=>'F4000_P4861_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1706433390319012)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P4861_VERSION_NUMBER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_mail.c_template_version'
,p_compute_when=>'UPGRADE_TEMPLATE'
,p_compute_when_type=>'REQUEST_EQUALS_CONDITION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(620207869381182234)
,p_validation_name=>'Internal Name must be Unique'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_email_templates',
' where static_id         = upper(:F4000_P4861_STATIC_ID)',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and ( id != :F4000_P4861_ID or :F4000_P4861_ID is null )'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'The internal name is already used by another email template.  '
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(693723517414042146)
,p_validation_name=>'Only Valid Characters'
,p_validation_sequence=>20
,p_validation=>'F4000_P4861_STATIC_ID'
,p_validation_type=>'ITEM_IS_ALPHANUMERIC'
,p_error_message=>'Identifier may only contain alphanumeric characters and "_".'
,p_associated_item=>wwv_flow_imp.id(681121989585664444)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3102636038440426)
,p_validation_name=>'Email Template in use'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_step_processing',
' where flow_id           = :FB_FLOW_ID',
'   and attribute_11      = :F4000_P4861_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and process_type      = ''NATIVE_SEND_EMAIL''',
'union all (',
'select 1',
'  from wwv_flow_automation_actions',
' where flow_id           = :FB_FLOW_ID',
'   and attribute_11      = :F4000_P4861_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and action_type       = ''NATIVE_SEND_EMAIL''',
')'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Email Template is in use in a Page Process or Automation Action.'
,p_when_button_pressed=>wwv_flow_imp.id(681117422344664406)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(9473919020883901)
,p_validation_name=>'Valid Subject Template'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_template_directive.validate_template(',
'    p_template          => :F4000_P4861_SUBJECT,',
'    p_application_id    => :FB_FLOW_ID );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':F4000_P4861_VERSION_NUMBER = wwv_flow_mail.c_template_version'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(446736559362201411)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1705591965319003)
,p_validation_name=>'Valid Text Template'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_template_directive.validate_template(',
'    p_template          => :F4000_P4861_TEXT_TEMPLATE,',
'    p_application_id    => :FB_FLOW_ID );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':F4000_P4861_VERSION_NUMBER = wwv_flow_mail.c_template_version'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(681122782009664445)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1705611196319004)
,p_validation_name=>'Valid HTML Header Template'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_template_directive.validate_template(',
'    p_template          => :F4000_P4861_HTML_HEADER,',
'    p_application_id    => :FB_FLOW_ID );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':F4000_P4861_VERSION_NUMBER = wwv_flow_mail.c_template_version'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(681125178547664446)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1705760550319005)
,p_validation_name=>'Valid HTML Body Template'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_template_directive.validate_template(',
'    p_template          => :F4000_P4861_HTML_BODY,',
'    p_application_id    => :FB_FLOW_ID );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':F4000_P4861_VERSION_NUMBER = wwv_flow_mail.c_template_version'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(681125548202664447)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1705801183319006)
,p_validation_name=>'Valid HTML Footer Template'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_template_directive.validate_template(',
'    p_template          => :F4000_P4861_HTML_FOOTER,',
'    p_application_id    => :FB_FLOW_ID );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':F4000_P4861_VERSION_NUMBER = wwv_flow_mail.c_template_version'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(681125979457664447)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2661604344245344)
,p_validation_name=>'No duplicate subscription'
,p_validation_sequence=>100
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_email_templates',
' where security_group_id = :WORKSPACE_ID ',
'   and flow_id           = :FB_FLOW_ID ',
'   and reference_id      = :P4861_REFERENCE_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'An existing email template in this application is subscribed to the same master. Please select another master email template.'
,p_validation_condition=>':P4861_REFERENCE_ID is not null and :P4861_REFERENCE_ID_INIT is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(681117353209664406)
,p_associated_item=>wwv_flow_imp.id(18758295414739702)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2800321733492709)
,p_validation_name=>'Not part of component groups'
,p_validation_sequence=>110
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not wwv_flow_component_group_dev.is_part_of_comp_grp (',
'    p_component_id   => :F4000_P4861_ID,',
'    p_component_type => wwv_flow_copy_metadata.c_email_template,',
'    p_app_id         => :FB_FLOW_ID )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Email Template cannot be deleted because it is part of a component group.'
,p_when_button_pressed=>wwv_flow_imp.id(681117422344664406)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(40361878504464002)
,p_name=>'Update Static ID'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P4861_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'keyup'
,p_display_when_type=>'ITEM_IS_NULL'
,p_display_when_cond=>'F4000_P4861_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(40361971123464003)
,p_event_id=>wwv_flow_imp.id(40361878504464002)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'$s(''F4000_P4861_STATIC_ID'',$v(''F4000_P4861_NAME'').replace(/\s+/g, ''_'').toUpperCase());'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(177068213385885505)
,p_name=>'Set Default HTML Template'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(40362328235464007)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(177068397091885506)
,p_event_id=>wwv_flow_imp.id(177068213385885505)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4861_HTML_TEMPLATE'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>'wwv_flow_mail.get_default_html_template'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(218253182235877514)
,p_name=>'Load Order Details Sample'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(218252429784877507)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(218253215205877515)
,p_event_id=>wwv_flow_imp.id(218253182235877514)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4861_HTML_HEADER'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>'wwv_flow_lang.system_message(''EMAIL.TEMPLATE.HEADER_EXAMPLE'')'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(218253337981877516)
,p_event_id=>wwv_flow_imp.id(218253182235877514)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4861_HTML_BODY'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>'wwv_flow_lang.system_message(''EMAIL.TEMPLATE.HTML_BODY_EXAMPLE.OD'')'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(481181914965329901)
,p_event_id=>wwv_flow_imp.id(218253182235877514)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4861_SUBJECT'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>'wwv_flow_lang.system_message(''EMAIL.TEMPLATE.SUBJECT_EXAMPLE.OD'')'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(218253477851877517)
,p_event_id=>wwv_flow_imp.id(218253182235877514)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4861_HTML_FOOTER'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>'wwv_flow_lang.system_message(''EMAIL.TEMPLATE.FOOTER_EXAMPLE'')'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(218253576691877518)
,p_event_id=>wwv_flow_imp.id(218253182235877514)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4861_TEXT_TEMPLATE'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>'wwv_flow_lang.system_message(''EMAIL.TEMPLATE.TEXT_BODY_EXAMPLE.OD'')'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(218253634134877519)
,p_name=>'Load Event Reminder Sample'
,p_event_sequence=>60
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(218252503160877508)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(218253789725877520)
,p_event_id=>wwv_flow_imp.id(218253634134877519)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4861_HTML_HEADER'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>'wwv_flow_lang.system_message(''EMAIL.TEMPLATE.HEADER_EXAMPLE'')'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(218253805031877521)
,p_event_id=>wwv_flow_imp.id(218253634134877519)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4861_HTML_BODY'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>'wwv_flow_lang.system_message(''EMAIL.TEMPLATE.HTML_BODY_EXAMPLE.EV'')'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(481182048498329902)
,p_event_id=>wwv_flow_imp.id(218253634134877519)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4861_SUBJECT'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>'wwv_flow_lang.system_message(''EMAIL.TEMPLATE.SUBJECT_EXAMPLE.EV'')'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(218253984047877522)
,p_event_id=>wwv_flow_imp.id(218253634134877519)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4861_HTML_FOOTER'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>'wwv_flow_lang.system_message(''EMAIL.TEMPLATE.FOOTER_EXAMPLE'')'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(218254044156877523)
,p_event_id=>wwv_flow_imp.id(218253634134877519)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4861_TEXT_TEMPLATE'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>'wwv_flow_lang.system_message(''EMAIL.TEMPLATE.TEXT_BODY_EXAMPLE.EV'')'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(100577052930284428)
,p_name=>'Load Scheduled Outage Sample'
,p_event_sequence=>70
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(100576992718284427)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(100577143626284429)
,p_event_id=>wwv_flow_imp.id(100577052930284428)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4861_HTML_HEADER'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>'wwv_flow_lang.system_message(''EMAIL.TEMPLATE.HEADER_EXAMPLE'')'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(100577248602284430)
,p_event_id=>wwv_flow_imp.id(100577052930284428)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4861_HTML_BODY'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>'wwv_flow_lang.system_message(''EMAIL.TEMPLATE.HTML_BODY_EXAMPLE.SO'')'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(100577381971284431)
,p_event_id=>wwv_flow_imp.id(100577052930284428)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4861_HTML_FOOTER'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>'wwv_flow_lang.system_message(''EMAIL.TEMPLATE.FOOTER_EXAMPLE'')'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(100577461608284432)
,p_event_id=>wwv_flow_imp.id(100577052930284428)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4861_TEXT_TEMPLATE'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>'wwv_flow_lang.system_message(''EMAIL.TEMPLATE.TEXT_BODY_EXAMPLE.SO'')'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(100577525161284433)
,p_event_id=>wwv_flow_imp.id(100577052930284428)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'F4000_P4861_SUBJECT'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>'wwv_flow_lang.system_message(''EMAIL.TEMPLATE.SUBJECT_EXAMPLE.SO'')'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(483371065390969312)
,p_name=>'API'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P4861_STATIC_ID,F4000_P4861_SUBJECT,F4000_P4861_HTML_HEADER,F4000_P4861_HTML_BODY,F4000_P4861_HTML_FOOTER,F4000_P4861_TEXT_TEMPLATE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(483371122535969313)
,p_event_id=>wwv_flow_imp.id(483371065390969312)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'#api'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_f4000_util.get_sample_email_api_usage(',
'    p_static_id         => :F4000_P4861_STATIC_ID,',
'    p_version_number    => :F4000_P4861_VERSION_NUMBER,',
'    p_subject           => :F4000_P4861_SUBJECT,',
'    p_html_header       => :F4000_P4861_HTML_HEADER,',
'    p_html_body         => :F4000_P4861_HTML_BODY,',
'    p_html_footer       => :F4000_P4861_HTML_FOOTER,',
'    p_text_template     => :F4000_P4861_TEXT_TEMPLATE );'))
,p_attribute_07=>'F4000_P4861_STATIC_ID,F4000_P4861_SUBJECT,F4000_P4861_HTML_HEADER,F4000_P4861_HTML_BODY,F4000_P4861_HTML_FOOTER,F4000_P4861_TEXT_TEMPLATE,F4000_P4861_VERSION_NUMBER'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_stop_execution_on_error=>'N'
,p_wait_for_result=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2634981260134110)
,p_name=>'Hide P4861_REFERENCE_ID'
,p_event_sequence=>90
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P4861_REFERENCE_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2635001877134111)
,p_event_id=>wwv_flow_imp.id(2634981260134110)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4861_REFERENCE_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2359004370667335)
,p_name=>'Save'
,p_event_sequence=>110
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(681117353209664406)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2359128700667336)
,p_event_id=>wwv_flow_imp.id(2359004370667335)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'Are you sure you want to subscribe? This will overwrite the current email template data with the selected master email template.'
,p_attribute_03=>'warning'
,p_attribute_06=>'Subscribe'
,p_attribute_07=>'Cancel'
,p_client_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_client_condition_expression=>'$v(''P4861_REFERENCE_ID'') !== "" && $v(''P4861_REFERENCE_ID_INIT'') === ""'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2359206301667337)
,p_event_id=>wwv_flow_imp.id(2359004370667335)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'SAVE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2634899818134109)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(681117531703664406)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process form Template Details'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE,SAVE,DELETE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'Action processed.'
,p_internal_uid=>2634899818134109
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(259650178473209802)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Upgrade Email Template Success Message'
,p_process_sql_clob=>'null;'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2801767283175295)
,p_process_success_message=>'Successfully upgraded the email template.'
,p_internal_uid=>259650178473209802
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2662104483255465)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh Email Template'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.refresh_component (',
'    p_component_type     => wwv_flow_copy_metadata.c_email_template,',
'    p_master_id          => :P4861_REFERENCE_ID,',
'    p_subscribing_id     => :F4000_P4861_ID,',
'    p_subscribing_app_id => :FB_FLOW_ID,',
'    p_initial_refresh    => :P4861_REFERENCE_ID is not null and :P4861_REFERENCE_ID_INIT is null );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error during email template refresh.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST = ''REFRESH''',
'or ( :REQUEST = ''SAVE'' and :P4861_REFERENCE_ID is not null and :P4861_REFERENCE_ID_INIT is null )'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Email template refreshed from the master.'
,p_internal_uid=>2662104483255465
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2662405920256901)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Unsubscribe'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.unsubscribe_component (',
'    p_component_type  => wwv_flow_copy_metadata.c_email_template,',
'    p_component_id    => :F4000_P4861_ID,',
'    p_app_id          => :FB_FLOW_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2629927337080247)
,p_process_success_message=>'Email template has been unsubscribed.'
,p_internal_uid=>2662405920256901
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2635652681134117)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Clear Subscriptions'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- when deleting the component, clear reference_id data from subscribing apps',
'--',
'wwv_flow_copy_metadata.clear_subscriptions (',
'    p_component_type => wwv_flow_copy_metadata.c_email_template,',
'    p_master_id      => :F4000_P4861_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(681117422344664406)
,p_internal_uid=>2635652681134117
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(681129571001664454)
,p_process_sequence=>80
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'reset page'
,p_attribute_01=>'CLEAR_CACHE_CURRENT_PAGE'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(681117422344664406)
,p_internal_uid=>681129571001664454
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1808353798551134)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(681117531703664406)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Email Template Details'
,p_internal_uid=>1808353798551134
);
end;
/
prompt --application/pages/page_04862
begin
wwv_flow_imp_page.create_page(
 p_id=>4862
,p_name=>'Utilization'
,p_alias=>'UTILIZATION'
,p_step_title=>'Email Template Utilization'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3103040285440430)
,p_plug_name=>'Email Template Utilization'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  ',
'    t.id                    template_id,',
'    wwv_flow_utilities.prepare_url(''f?p=4000:4500:''||:flow_session||''::::FB_FLOW_PAGE_ID:''||p.id) ',
'                            the_url,',
'    p.id                    page_id, ',
'    p.name                  page_name, ',
'    wwv_flow_lang.system_message(''PAGE PROCESS'') ',
'                            process_type,',
'    pr.process_name         process_name,',
'    t.name                  template_name',
'from wwv_flow_steps           p,',
'     wwv_flow_step_processing pr,',
'     wwv_flow_email_templates t',
'where t.id = pr.attribute_11',
'  and pr.process_type     = ''NATIVE_SEND_EMAIL''',
'  and pr.flow_step_id     = p.id',
'  and pr.flow_id          = p.flow_id',
'  and p.flow_id           = t.flow_id',
'  and t.flow_id           = :FB_FLOW_ID',
'  and t.security_group_id = :flow_security_group_id',
'union all (',
'select  ',
'    t.id,',
'    wwv_flow_utilities.prepare_url(''f?p=4000:7022:''||:flow_session||'':::7021,7022:P7021_ID,P7022_AUTOMATION_ID,P7022_ID:''||a.id || '','' || a.id || '','' || am.id) ',
'                               the_url,  ',
'    null                       page_id, ',
'    null                       page_name,  ',
'    wwv_flow_lang.system_message(''AUTOMATION_ACTIONS'') ',
'                               process_type,',
'    a.name || '' - '' || am.name process_name,',
'    t.name                     template_name',
'from wwv_flow_automations        a,',
'     wwv_flow_automation_actions am,',
'     wwv_flow_email_templates    t ',
'where t.id                 = am.attribute_11',
'  and am.action_type       = ''NATIVE_SEND_EMAIL''',
'  and am.automation_id     = a.id',
'  and a.flow_id            = t.flow_id',
'  and t.flow_id           = :FB_FLOW_ID',
'  and a.security_group_id  = :flow_security_group_id',
')'))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Utilization'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(2406388620825309)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'No Email Template utilizations found.'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_pivot=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'ADMIN'
,p_internal_uid=>2406388620825309
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2406435252825310)
,p_db_column_name=>'TEMPLATE_ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Template Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2406596323825311)
,p_db_column_name=>'THE_URL'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'The Url'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2407059330825316)
,p_db_column_name=>'TEMPLATE_NAME'
,p_display_order=>30
,p_column_identifier=>'G'
,p_column_label=>'Template Name'
,p_column_link=>'f?p=&APP_ID.:4861:&SESSION.::&DEBUG.:4861:F4000_P4861_ID:#TEMPLATE_ID#'
,p_column_linktext=>'#TEMPLATE_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2406698500825312)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>40
,p_column_identifier=>'C'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2406758551825313)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>50
,p_column_identifier=>'D'
,p_column_label=>'Page Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2406873085825314)
,p_db_column_name=>'PROCESS_TYPE'
,p_display_order=>60
,p_column_identifier=>'E'
,p_column_label=>'Component Type'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2406968686825315)
,p_db_column_name=>'PROCESS_NAME'
,p_display_order=>70
,p_column_identifier=>'F'
,p_column_label=>'Component Name'
,p_column_link=>'#THE_URL#'
,p_column_linktext=>'#PROCESS_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(3107988200034864)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'33018'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'TEMPLATE_NAME:PROCESS_TYPE:PROCESS_NAME:PAGE_ID:PAGE_NAME:'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(484996226588456413)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page displays where <strong>Email Templates</strong> are being used within the application.',
'</p>',
'<p>',
'Note that template usage within PL/SQL code (Package APEX_MAIL) is not listed on this page.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(484996425781456414)
,p_plug_name=>'tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_imp.id(2306436841283369)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Email Templates'
);
end;
/
prompt --application/pages/page_04863
begin
wwv_flow_imp_page.create_page(
 p_id=>4863
,p_name=>'Email Template History'
,p_alias=>'EMAIL-TEMPLATE-HISTORY'
,p_step_title=>'Email Template History'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213240607818867991)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_lov.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3104865324440448)
,p_plug_name=>'Email Template History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.a object_type,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u,',
'  (select wwv_flow_lang.system_message(''BU.EMAIL_TEMPLATES'') a from dual) t',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_EMAIL_TEMPLATES''',
''))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'New'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(3105027003440450)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'No history found for Email Templates.'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_pivot=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'CCZARSKI'
,p_internal_uid=>3105027003440450
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2405656268825302)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>10
,p_column_identifier=>'B'
,p_column_label=>'Audit Date'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2405766151825303)
,p_db_column_name=>'ACTION'
,p_display_order=>20
,p_column_identifier=>'C'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2405567018825301)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>30
,p_column_identifier=>'A'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2406172324825307)
,p_db_column_name=>'OBJECT_TYPE'
,p_display_order=>40
,p_column_identifier=>'G'
,p_column_label=>'Object Type'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2406200357825308)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>50
,p_column_identifier=>'H'
,p_column_label=>'Component Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2405835522825304)
,p_db_column_name=>'SCN'
,p_display_order=>60
,p_column_identifier=>'D'
,p_column_label=>'Scn'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'LEFT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2405916383825305)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>70
,p_column_identifier=>'E'
,p_column_label=>'Audit Comment'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2406026302825306)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>80
,p_column_identifier=>'F'
,p_column_label=>'Component Key'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'LEFT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(2700668682866662)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'33012'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'AUDIT_DATE:ACTION:DEVELOPER:OBJECT_TYPE:COMPONENT_NAME:'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(195748512769210350)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>90
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(2306436841283369)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Email Templates'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(195748697203210351)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>This page displays recent modifications made to Email Templates in this application.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
end;
/
prompt --application/pages/page_04900
begin
wwv_flow_imp_page.create_page(
 p_id=>4900
,p_name=>'Export Application'
,p_alias=>'EXPORTAPP'
,p_step_title=>'Export Application'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213300727323081712)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_export_app.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(380536008)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Exporting an application exports all application attributes (including templates, pages, regions, items, buttons,',
'and so on) to a single file.</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(39183122032)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(12802829107)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(5630067605882810)
,p_name=>'Application Information'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>60
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding:a-Region--noBorder:a-Region--accessibleHeader:a-Form-fixedLabelsMed'
,p_component_template_options=>'#DEFAULT#:a-Report--staticRowColors:a-Report--horizontalBorders:a-Report--stretch'
,p_grid_column_span=>8
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       name,',
'       last_updated_by,',
'       last_updated_on,',
'       (select count(*)',
'          from wwv_flow_steps',
'         where security_group_id = :FLOW_SECURITY_GROUP_ID',
'           and flow_id           = :FB_FB_EXPORT_FLOW_ID) as page_count,',
'       owner',
'  from wwv_flows ',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and id                = :FB_FB_EXPORT_FLOW_ID',
' order by id'))
,p_ajax_enabled=>'Y'
,p_ajax_items_to_submit=>'FB_FB_EXPORT_FLOW_ID'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>2
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(6303611124459517)
,p_query_column_id=>1
,p_column_alias=>'ID'
,p_column_display_sequence=>10
,p_column_heading=>'Application'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5630119309882811)
,p_query_column_id=>2
,p_column_alias=>'NAME'
,p_column_display_sequence=>20
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5630568803882815)
,p_query_column_id=>3
,p_column_alias=>'LAST_UPDATED_BY'
,p_column_display_sequence=>40
,p_column_heading=>'Updated By'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(6306175582459542)
,p_query_column_id=>4
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>50
,p_column_heading=>'Updated'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5630636523882816)
,p_query_column_id=>5
,p_column_alias=>'PAGE_COUNT'
,p_column_display_sequence=>30
,p_column_heading=>'Pages'
,p_use_as_row_header=>'N'
,p_column_format=>'999G999G999G990'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(5630736774882817)
,p_query_column_id=>6
,p_column_alias=>'OWNER'
,p_column_display_sequence=>60
,p_column_heading=>'Owner'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6605299200036719)
,p_plug_name=>'Choose Application'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_grid_column_span=>8
,p_plug_display_condition_type=>'ITEM_IS_NULL'
,p_plug_display_when_condition=>'FB_FLOW_ID'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(168863605513942093)
,p_plug_name=>'Export Application'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%; float:left;"'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(168869025093061269)
,p_name=>'Recent Exports to Export Repository'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>90
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch'
,p_region_attributes=>'style="width:100%;"'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select title as application,',
'       case',
'           when bytes < 1024 * 1024 then',
'               to_char(bytes / 1024, ''fm999G990'') || ''KB''',
'           else to_char(bytes / 1024 / 1024, ''fm999G999G990'') || ''MB''',
'       end as doc_size,',
'       created_on',
'  from (',
'select title,',
'       created_on,',
'       nvl( doc_size, 0 ) as bytes',
'  from WWV_FLOW_FILE_OBJECTS$ o',
' where flow_id = :FB_FB_EXPORT_FLOW_ID',
'   and file_type = ''FLOW_EXPORT''',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
' order by created_on desc',
'       )',
' where rownum <= 10'))
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>10
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_no_data_found=>'No exports found for this application.'
,p_query_row_count_max=>10
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_prn_format=>'PDF'
,p_prn_output_show_link=>'Y'
,p_prn_output_link_text=>'Print'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'MILLIMETERS'
,p_prn_paper_size=>'A4'
,p_prn_width_units=>'PERCENTAGE'
,p_prn_width=>297
,p_prn_height=>210
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#ffffff'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'LEFT'
,p_prn_page_footer_alignment=>'LEFT'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(168869304377061274)
,p_query_column_id=>1
,p_column_alias=>'APPLICATION'
,p_column_display_sequence=>1
,p_column_heading=>'File Name'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_print_col_width=>'50'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(932668108778561031)
,p_query_column_id=>2
,p_column_alias=>'DOC_SIZE'
,p_column_display_sequence=>2
,p_column_heading=>'File Size'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(168869414702061274)
,p_query_column_id=>3
,p_column_alias=>'CREATED_ON'
,p_column_display_sequence=>3
,p_column_heading=>'Created'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
,p_print_col_width=>'50'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(486282025733641382)
,p_plug_name=>'Export Settings'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>80
,p_plug_grid_column_span=>8
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(47282706020505243)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(168863605513942093)
,p_button_name=>'reset_page'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:4900:&SESSION.::&DEBUG.:RP,4900::'
,p_button_cattributes=>'class="button8_69c" onMouseUp="javascript:this.disabled=false;"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(6923471041)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(168863605513942093)
,p_button_name=>'ExportFlow'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Export'
,p_button_position=>'CREATE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(64241520463572558)
,p_branch_action=>'f?p=&FLOW_ID.:4900:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(6923471041)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(186781008440066252)
,p_branch_name=>'Go To Page 4900'
,p_branch_action=>'f?p=&APP_ID.:4900:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(486379404165452528)
,p_branch_name=>'Go To Page 4900'
,p_branch_action=>'f?p=&APP_ID.:4900:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>1
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'nvl(:FB_FB_EXPORT_FLOW_ID,0) = 0'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(791781102)
,p_name=>'F4000_P4900_OWNER_OVERRIDE'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(486282025733641382)
,p_prompt=>'Owner Override'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'By default, the application is owned by the owner identified in the application attribute owner.  Use this attribute if you wish to import this application as a different schema owner then you are exporting.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ENTERABLE'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1721949240)
,p_name=>'F4000_P4900_FORMAT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(486282025733641382)
,p_source=>'UNIX'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select a file format. Options include:',
'<ul>',
'<li>Select <strong>DOS</strong> to have the lines in the resulting file terminated by carriage returns and line feeds.</li>',
'<li>Select <strong>UNIX</strong> to have the lines in the resulting file contain terminated by line feeds.</li>',
'<li>Select <strong>Database</strong> to have the resulting file saved in the Export Repository instead of downloading it.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_item_comment=>'unix=chr(10),dos=chr(13)||chr(10) after each row'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6926471043)
,p_name=>'FB_FB_EXPORT_FLOW_ID'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(6605299200036719)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Application'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PICK_EXPORT_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flows f',
'where  ',
'       security_group_id = :flow_security_group_id and',
'       f.build_status != ''RUN_AND_HIDDEN'' and',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id is null and security_group_id = :flow_security_group_id )',
'       or',
'       exists (',
'       select 1 from wwv_flow_developers',
'       where userid = :flow_user and flow_id = f.id and security_group_id = :flow_security_group_id) ',
'order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Application -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the application to be exported.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1940780815660829)
,p_name=>'P4900_AUDIT_INFO'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(486282025733641382)
,p_item_default=>'NONE'
,p_prompt=>'Audit Information'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'AUDIT INFO DETAIL'
,p_lov=>'.'||wwv_flow_imp.id(1726678227351632)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'None'
,p_lov_null_value=>'NONE'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the Audit Information to include in the export file. ',
'Audit information includes the Created By User, Created On Date, Changed By User and Changed On Date.<ul> ',
'<li>By default, no audit information is included.</li>',
'<li>Choose Names and Dates to include all audit information.</li>',
'<li>Choose Dates Only to include date information and exclude user details.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2116033645561643)
,p_name=>'P4900_READABLE_FORMAT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(486282025733641382)
,p_item_default=>'N'
,p_prompt=>'Readable Format'
,p_display_as=>'NATIVE_YES_NO'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Choose <strong>On</strong> if the export file should contain a human-readable YAML version of the application meta-data.',
'It can be used to identify and review differences between versions of an application when checked into a Version Control System.</p>',
'<p>',
'Choose <strong>Off</strong> to export in non-readable SQL format.',
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18616933281491919)
,p_name=>'P4900_SPLIT'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(486282025733641382)
,p_item_default=>'N'
,p_prompt=>'Split into Multiple Files'
,p_display_as=>'NATIVE_YES_NO'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Choose <strong>On</strong> to export the application as a ZIP archive containing separate files for each page, shared component, and so forth.</p>',
'',
'<p>',
'Choose <strong>Off</strong> to export as a single SQL file containing the entire application.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(18891404558260052)
,p_name=>'F4000_P4900_SET_RUN_ONLY'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(486282025733641382)
,p_use_cache_before_default=>'NO'
,p_item_default=>'RUN_AND_BUILD'
,p_prompt=>'Build Status Override'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'BUILD_STATUS'
,p_lov=>'.'||wwv_flow_imp.id(84305510710571518)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the build status of the exported application.  Options include:<br>',
'<ul><li><strong>Run Application Only</strong> - Users can only run the application. This option is intended for applications in a production instance.</li>',
'<li><strong>Run and Build Application</strong> - Developers and users can both run and develop the application.</li>',
'</ul></p>',
'<p>Note:  Build Status Override setting can be changed when importing using the Web interface in App Builder but not when using the command line interface.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(19748423599833275)
,p_name=>'P4900_PRIVATE_REPORTS'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(486282025733641382)
,p_item_default=>'N'
,p_prompt=>'Private Reports'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify whether to include Private reports with your application. Available options include:',
'<p />',
'<ul>',
'<li><strong>On</strong> includes Private reports in the application export.</li>',
'<li><strong>Off</strong> does not include Private reports in the application export.</li>',
'</ul>',
'<p />',
'Private reports are the private customized settings saved by users from Interactive Report or Interactive Grid.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(25717725405973450)
,p_name=>'P4900_EXP_DEPLOYMENT_METADATA'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(486282025733641382)
,p_item_default=>'Y'
,p_prompt=>'Supporting Object Definitions'
,p_source=>'select include_in_export_yn from wwv_flow_install where flow_id = :fb_flow_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'EXPORT_SUP_OBJ_OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(388231942990864305)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify whether to export supporting object definitions with your application. Available options include:',
'<p />',
'<ul>',
'<li><strong>Yes</strong> - Includes supporting object definitions in the application export.  Does not automatically load supporting objects when invoked from a command line.',
'</li>',
'<li><strong>No</strong> - Does not include the supporting object definitions in the export.</li>',
'<li><strong>Yes and Install on Import Automatically</strong> - Includes supporting object definitions and a call to install supporting objects in the application export.  This option is valid only for command line installs.  When application imports '
||'from the command line, it automatically installs or upgrades the supporting objects.',
'</ul>',
'<p />',
'Supporting object definitions include all configuration options and scripts and enable an application export to include database object definitions, image definitions, and seed data SQL statements encapsulated in a single file.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(28916903130872699)
,p_name=>'P4900_ORIGINAL_IDS'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(486282025733641382)
,p_item_default=>'N'
,p_prompt=>'Original IDs'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify whether the export file should contain the application component IDs as of now or as of the last import of this application. Available options include:',
'<p />',
'<ul>',
'<li><strong>On</strong> includes the IDs as of the last import.</li>',
'<li><strong>Off</strong> includes the current IDs of the components.</li>',
'</ul>',
'<p />',
'<p />',
'Using Original IDs can be beneficial for various purposes, including:',
'<p />',
'<ul>',
'<li><strong>Readable Format:</strong> Simplify comparisons between different versions of app components and pages. Minimize changes to version controlled export files.</li>',
'<li><strong>Shared Component Subscriptions:</strong> Ensure subscribed components stay linked to a source app when it is replaced with an updated version.</li>',
'</ul>',
'<p />'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(45083820509961243)
,p_name=>'P4900_FLASHBK_FLOW_AS_OF'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(486282025733641382)
,p_prompt=>'As of'
,p_post_element_text=>'<span class="fielddata">minutes ago</span>'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>4
,p_cMaxlength=>2000
,p_display_when=>'F4000_P4900_FORMAT'
,p_display_when2=>'DB'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Specify a time in minutes to go to back to for your export. This option enables you to go back in time in your application, perhaps to get back a deleted object.</div>',
'',
'<div class="htmldbInfoBodyP">This utility uses the <code>dbms_flashback</code> package. The timestamp to SCN (system change number) mapping is refreshed approximately every 5 minutes, so you may have to wait that long to get to the version you are lo'
||'oking for. The time undo information is retained by the startup parameter <code>undo_retention</code> (default 3 hrs), but this only influences the size of the undo tablespace.</div>',
'<div class="htmldbInfoBodyP">While two databases may have the same <code>undo_retention</code> parameter, you can go back much further in time on the database with less transactions since the transactions are not filling the undo tablespace, forcing '
||'older data to be archived.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(48525920521551162)
,p_name=>'P4900_NOTIFICATIONS'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(486282025733641382)
,p_item_default=>'N'
,p_prompt=>'Report Subscriptions'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify whether to include Interactive Report or Interactive Grid subscription settings with your application. Available options include:',
'<p />',
'<ul>',
'<li><strong>On</strong> includes report subscriptions for the reports you are exporting in the application export.</li>',
'<li><strong>Off</strong> does not include report subscriptions for the reports in the application export.</li>',
'</ul>',
'<p />',
'This will be limited to the un-expired subscription settings of all users for all Interactive Reports or Interactive Grids in the application.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(124195606865896920)
,p_name=>'P4900_EXPORT_COMMENTS'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(486282025733641382)
,p_item_default=>'Y'
,p_prompt=>'Developer Comments'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify whether to include Developer Comments in your application export. Available options include:',
'<p />',
'<ul>',
'<li><strong>On</strong> includes Developer Comments in the application export.</li>',
'<li><strong>Off</strong> does not include Developer Comments in the export.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(160646506742945585)
,p_name=>'F4000_P4900_FILE_CHARSET'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_imp.id(486282025733641382)
,p_use_cache_before_default=>'NO'
,p_prompt=>'File Character Set'
,p_source=>'return lower(trim(sys.owa_util.get_cgi_env(''REQUEST_IANA_CHARSET'')));'
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'I18N_IANA_CHARSET'
,p_lov=>'.'||wwv_flow_imp.id(144796827445692396)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'The export file will be encoded in the specified character set.  When importing this file you will need to specify the same character set.   '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(193576832187147918)
,p_name=>'P4900_PUBLIC_REPORTS'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(486282025733641382)
,p_item_default=>'Y'
,p_prompt=>'Public Reports'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify whether to include Public reports with your application.  Available options include:',
'<p />',
'<ul>',
'<li><strong>On</strong> includes Public reports in the application export.</li>',
'<li><strong>Off</strong> does not include Public reports in the application export.</li>',
'</ul>',
'<p />',
'Public reports are the public shared report settings saved by users from Interactive Report or Interactive Grid.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(198614502120573324)
,p_name=>'P4900_DEBUGGING'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(486282025733641382)
,p_use_cache_before_default=>'NO'
,p_item_default=>'1'
,p_prompt=>'Debugging'
,p_source=>'select nvl(APPLICATION_TAB_SET,1) debugging from wwv_flows where id = :fb_flow_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select one of the following:',
'<p />',
'<ul>',
'<li><strong>On</strong> exports the application with debugging enabled.</li> ',
'<li><strong>Off</strong> exports the application with debugging disabled.</li>  ',
'</ul>',
'<p />',
'Enabling debugging is useful for applications under development. As a best practice, Oracle',
'recommends turn off debugging for production applications to prevent users from viewing application logic.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'1'
,p_attribute_04=>'0'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(535545301221838705)
,p_name=>'P4900_EXPORT_TRANSLATIONS'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(486282025733641382)
,p_item_default=>'Y'
,p_prompt=>'Translations'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify whether to include Translations with your application export.  Available options include:',
'<p />',
'<ul>',
'<li><strong>On</strong> includes the translation mappings and all text from the translation repository.</li>',
'<li><strong>Off</strong> does not include translation mappings or the translation repository.</li>',
'</ul>',
'<p />',
'Translation Text Messages and Dynamic Translations will always be included in the application export.',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(168872412851123884)
,p_computation_sequence=>10
,p_computation_item=>'FB_FLOW_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'&FB_FB_EXPORT_FLOW_ID.'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(486379904427471521)
,p_computation_sequence=>20
,p_computation_item=>'FB_FB_EXPORT_FLOW_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'&FB_FLOW_ID.'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(362405205819170865)
,p_validation_name=>'FB_FB_EXPORT_FLOW_ID Must Have Value'
,p_validation_sequence=>5
,p_validation=>'FB_FB_EXPORT_FLOW_ID'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'#LABEL# must have some value.'
,p_when_button_pressed=>wwv_flow_imp.id(6923471041)
,p_associated_item=>wwv_flow_imp.id(6926471043)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(45221530343799739)
,p_validation_name=>'P4900_FLASHBK_FLOW_AS_OF is numeric'
,p_validation_sequence=>10
,p_validation=>'P4900_FLASHBK_FLOW_AS_OF'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'"As Of" must be numeric.'
,p_validation_condition=>':P4900_FLASHBK_FLOW_AS_OF is not null and :REQUEST = ''ExportFlow'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(45083820509961243)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(937789531661878620)
,p_name=>'Set Values'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'FB_FB_EXPORT_FLOW_ID'
,p_condition_element=>'FB_FB_EXPORT_FLOW_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6304494581459525)
,p_event_id=>wwv_flow_imp.id(937789531661878620)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Recent Exports to Export Repository'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(168869025093061269)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4204346429056228)
,p_event_id=>wwv_flow_imp.id(937789531661878620)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Export Settings'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(486282025733641382)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4204020399056225)
,p_event_id=>wwv_flow_imp.id(937789531661878620)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Show Export Settings'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(486282025733641382)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6303857246459519)
,p_event_id=>wwv_flow_imp.id(937789531661878620)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Export Application'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(5630067605882810)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6303708464459518)
,p_event_id=>wwv_flow_imp.id(937789531661878620)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_name=>'Show Export Application'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(5630067605882810)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6304302593459524)
,p_event_id=>wwv_flow_imp.id(937789531661878620)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_name=>'Show Recent Exports to Export Repository'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(168869025093061269)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6304505946459526)
,p_event_id=>wwv_flow_imp.id(937789531661878620)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'N'
,p_name=>'Refresh Recent Exports to Export Repository'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(168869025093061269)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6303144860459512)
,p_event_id=>wwv_flow_imp.id(937789531661878620)
,p_event_result=>'TRUE'
,p_action_sequence=>70
,p_execute_on_page_init=>'N'
,p_name=>'Refresh Application Information'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(5630067605882810)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(651513226431755625)
,p_name=>'Submit'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(6923471041)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(651513321581755626)
,p_event_id=>wwv_flow_imp.id(651513226431755625)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'ExportFlow'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1800365072934701)
,p_name=>'readable = Y'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4900_READABLE_FORMAT'
,p_condition_element=>'P4900_READABLE_FORMAT'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1800442495934702)
,p_event_id=>wwv_flow_imp.id(1800365072934701)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_name=>'set Original IDs = Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4900_ORIGINAL_IDS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(72827100072386496)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'security'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.init;',
'sys.owa_util.redirect_url(v(''LOGOUT_URL''));',
'wwv_flow.g_unrecoverable_error := true;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'    from   wwv_flow_developers',
'    where  userid = :FLOW_USER ',
'       and',
'       security_group_id = :WORKSPACE_ID',
'       and',
'       security_group_id = ',
'         (select security_group_id from wwv_flows where id=:FB_FB_EXPORT_FLOW_ID or :FB_FB_EXPORT_FLOW_ID is null)',
'       and',
'       instr(developer_role,''EDIT'') > 0 ',
'       and',
'       (flow_id = :FB_FB_EXPORT_FLOW_ID or flow_id is null)  ',
'       and not exists (select 1 from wwv_flows',
'                    where id = :FB_FB_EXPORT_FLOW_ID',
'                      and build_status = ''RUN_AND_HIDDEN'')'))
,p_process_when_type=>'NOT_EXISTS'
,p_internal_uid=>72827100072386496
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(6924471042)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Export Flow'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_export_dev.export_application (',
'    p_application_id            => :FB_FB_EXPORT_FLOW_ID,',
'    p_owner_override            => :F4000_P4900_OWNER_OVERRIDE,',
'    p_export_sup_objects        => :P4900_EXP_DEPLOYMENT_METADATA,',
'    p_export_components         => nvl(:P4900_EXPORT_COMMENTS,''N''),',
'    p_export_ir_public_reports  => nvl(:P4900_PUBLIC_REPORTS,''N''),',
'    p_export_ir_private_reports => nvl(:P4900_PRIVATE_REPORTS,''N''),',
'    p_export_ir_notifications   => nvl(:P4900_NOTIFICATIONS,''N''),',
'    p_export_translations       => nvl(:P4900_EXPORT_TRANSLATIONS,''N''),',
'    p_build_status_override     => case',
'                                   when :F4000_P4900_SET_RUN_ONLY = ''RUN_ONLY'' then ''YES''',
'                                   else ''NO''',
'                                   end,',
'    p_debugging_override        => :P4900_DEBUGGING,',
'    p_with_original_ids         => :P4900_ORIGINAL_IDS,',
'    p_split                     => ( nvl( :P4900_SPLIT, ''N'' ) = ''Y'' ),',
'    p_readable_format           => ( nvl( :P4900_READABLE_FORMAT, ''N'' ) = ''Y'' ),',
'    p_flashback_min_ago         => :P4900_FLASHBK_FLOW_AS_OF, ',
'    p_with_audit_info           => :P4900_AUDIT_INFO);'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error exporting flow &FB_FB_EXPORT_FLOW_ID.. #SQLERRM#'
,p_process_when_button_id=>wwv_flow_imp.id(6923471041)
,p_process_when=>'wwv_flow.g_request = ''ExportFlow'' and :F4000_P4900_FORMAT != ''XML'' '
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Application &FB_FB_EXPORT_FLOW_ID. exported.'
,p_internal_uid=>6924471042
);
end;
/
prompt --application/pages/page_04905
begin
wwv_flow_imp_page.create_page(
 p_id=>4905
,p_name=>'Remote Deployment Server'
,p_alias=>'REMOTE-DEPLOYMENT-SERVER'
,p_step_title=>'Remote Deployment Server'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213300727323081712)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_help_text=>'deploy_import.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(45445616494031715)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>150
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(48314023675949547)
,p_plug_name=>'Deployment Server'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>130
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_plug_header=>'<p class="u-tC">Choose an existing REST Enabled SQL service or create a new one.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'Region generated 16-MAY-2003 17:18:02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(750143103004641521)
,p_plug_name=>'Remote Deployment'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_plug_query_options=>'DERIVED_REPORT_COLUMNS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3001471245503399)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(45445616494031715)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:RP,::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3001844622503400)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(45445616494031715)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Help'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'javascript:w=window.open(''&SYSTEM_HELP_URL.'');'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3002260983503401)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(45445616494031715)
,p_button_name=>'NEXT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3002650181503401)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(45445616494031715)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:461:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3012045320503429)
,p_branch_name=>'Go To Page 4906'
,p_branch_action=>'f?p=&APP_ID.:4906:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(3002260983503401)
,p_branch_sequence=>30
,p_branch_comment=>'Generated 16-MAY-2003 17:18:02'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(11007566129042201)
,p_branch_name=>'Create Remote Server'
,p_branch_action=>'f?p=&APP_ID.:1615:&SESSION.::&DEBUG.:RP,1615,1616:P1605_BACK_TO_PAGE:4905&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'CREATE_REMOTE_SERVER'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3012803587503430)
,p_branch_action=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(3001471245503399)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2700336969358302)
,p_name=>'P4905_SERVER_ID'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(48314023675949547)
,p_prompt=>'Deployment Server'
,p_post_element_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<button onclick="apex.submit(''CREATE_REMOTE_SERVER'');" aria-label="&APP_TEXT$P4905_BUTTON_ALT_LABEL." type="button" id="P4905_CREATE_REMOTE_SERVER_BUTTON" title="&APP_TEXT$P4905_BUTTON_ALT_LABEL." class="a-Button a-Button--noLabel a-Button--withIcon '
||'a-Button--small">',
'    <span class="a-Icon icon-plus" aria-hidden="true"></span>',
'</button>'))
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id v',
'  from wwv_remote_servers',
' where server_type = ''REMOTE_SQL''',
'   and security_group_id = :flow_security_group_id'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'-- Select REST Enabled SQL Service --'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select an existing REST Enabled SQL service from the list or click the plus icon to create a new one.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'REDIRECT_SET_VALUE'
,p_item_comment=>'<a id="P4905_CREATE_REMOTE_SERVER_BUTTON" class="a-Button a-Button--noLabel a-Button--small a-Button--withIcon" onClick="apex.page.submit(''CREATE_REMOTE_SERVER'')"><span class="a-Icon icon-plus"></span></a>'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(271597133785112731)
,p_name=>'P4905_CREDENTIAL_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(48314023675949547)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(500668364724419686)
,p_name=>'P4905_CREDENTIAL_TYPE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(48314023675949547)
,p_prompt=>'Authentication Type'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'CREDENTIALS_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(154078822199034715)||'.'
,p_cHeight=>1
,p_display_when=>'P4905_SERVER_ID'
,p_display_when_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Displays the Authentication type.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(500680947492429346)
,p_name=>'P4905_CREDENTIAL_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(48314023675949547)
,p_prompt=>'Credential Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_cMaxlength=>255
,p_display_when=>'P4905_SERVER_ID'
,p_display_when_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Displays a descriptive name for the credentials.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(501154122788434523)
,p_name=>'P4905_EMPTY_CREDENTIAL'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(48314023675949547)
,p_item_default=>'N'
,p_prompt=>'Empty Credential Store'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>'P4905_SERVER_ID'
,p_display_when_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Indicates whether the credential is stored.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(501157752331440928)
,p_name=>'P4905_CLIENT_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(48314023675949547)
,p_prompt=>'Client ID'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_display_when=>'P4905_SERVER_ID'
,p_display_when_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_read_only_when=>'P4905_EMPTY_CREDENTIAL'
,p_read_only_when2=>'N'
,p_read_only_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'For Basic Authentication, enter the database user name. For OAuth2, enter the client ID. This information will not be encrypted. User names for Basic Authentication are converted to upper case. To include a case-sensitive user name, prefix it with th'
||'e exclamation mark (!).'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(501159234880447965)
,p_name=>'P4905_CLIENT_SECRET'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(48314023675949547)
,p_prompt=>'Client Secret'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>30
,p_cMaxlength=>255
,p_tag_attributes=>'autocomplete="new-password"'
,p_display_when=>'nvl(:P4905_SERVER_ID,''0'') <> ''0'' and nvl(:P4905_EMPTY_CREDENTIAL,''N'') = ''Y'''
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter the password or OAuth2 Client Secret. This information is stored encrypted and cannot be retrieved in clear text.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(508759940964208131)
,p_name=>'P4905_ENDPOINT_URL'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(48314023675949547)
,p_prompt=>'Endpoint URL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>75
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_display_when=>'P4905_SERVER_ID'
,p_display_when_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Displays the base URL for this REST Enabled SQL service.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(11601005038734806)
,p_validation_name=>'Validate Remote Server'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if nvl(:P4905_EMPTY_CREDENTIAL,''N'') = ''Y'' then',
'        wwv_flow_credential.set_session_credentials(',
'            p_credential_id => :P4905_CREDENTIAL_ID,',
'            p_client_id     => :P4905_CLIENT_ID,',
'            p_client_secret => :P4905_CLIENT_SECRET );',
'    end if;',
'    return wwv_flow_remote_deploy_dev.validate_deployment_server(p_server_id => :P4905_SERVER_ID);',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_when_button_pressed=>wwv_flow_imp.id(3002260983503401)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3011039171503427)
,p_name=>'Submit page'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3002260983503401)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3011586047503428)
,p_event_id=>wwv_flow_imp.id(3011039171503427)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'NEXT'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(271597099581112730)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'populate items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    select base_url, credential_name, authentication_type, client_id, ',
'           decode(client_id,null,''Y'',''N'') empty_credential, credential_id',
'      into :P4905_ENDPOINT_URL, :P4905_CREDENTIAL_NAME, :P4905_CREDENTIAL_TYPE,',
'           :P4905_CLIENT_ID, :P4905_EMPTY_CREDENTIAL, :P4905_CREDENTIAL_ID',
'      from wwv_remotesql_servers_dev ',
'     where id = :P4905_SERVER_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P4905_SERVER_ID'
,p_process_when_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_internal_uid=>271597099581112730
);
end;
/
prompt --application/pages/page_04906
begin
wwv_flow_imp_page.create_page(
 p_id=>4906
,p_name=>'Remote Deployment Options'
,p_alias=>'REMOTE-DEPLOYMENT-OPTIONS'
,p_step_title=>'Remote Deployment Options'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213300727323081712)
,p_inline_css=>'.a-Region .a-Region-title {font-weight: 600;}'
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_export_app.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2701833594358317)
,p_plug_name=>'Deployment Overrides'
,p_region_css_classes=>'margin-top-md margin-bottom-lg'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder'
,p_region_attributes=>'style="width:100%;"'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3300547964231734)
,p_plug_name=>'Deploy Application'
,p_region_css_classes=>'margin-top-lg'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_source=>' '
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(50246390315203481)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>90
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(197597352626318639)
,p_plug_name=>'Export Preferences'
,p_region_css_classes=>'margin-top-md'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="width:100%;"'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4801045459171794)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(50246390315203481)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:1500:&SESSION.::&DEBUG.:RP:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4801476496171795)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(50246390315203481)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Help'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'javascript:w=window.open(''&SYSTEM_HELP_URL.'');'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4801850489171795)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(50246390315203481)
,p_button_name=>'NEXT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Deploy'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4802242863171795)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(50246390315203481)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:4905:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3328579702728517)
,p_branch_name=>'Go To Page 4906'
,p_branch_action=>'f?p=&APP_ID.:4907:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(4801850489171795)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3328989556728518)
,p_branch_action=>'f?p=&FLOW_ID.:4906:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2702648440358325)
,p_name=>'P4906_WORKSPACE_OVERRIDE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(2701833594358317)
,p_prompt=>'Workspace&nbsp;Override'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select x.column_value d, x.column_value r',
'  from table(wwv_flow_remote_deploy_dev.get_workspaces(p_server_id=>:P4905_SERVER_ID)) x'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the workspace where the application should be deployed from the list. If there are no entries in the list, then the database user associated with the REST Enabled SQL connection is not mapped to any workspaces.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2702738661358326)
,p_name=>'P4906_RESPONSE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(2701833594358317)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2702891819358327)
,p_name=>'P4906_OVERWRITE_APP'
,p_item_sequence=>62
,p_item_plug_id=>wwv_flow_imp.id(2701833594358317)
,p_item_default=>'N'
,p_prompt=>'Overwrite Existing Application'
,p_display_as=>'NATIVE_YES_NO'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify whether to overwrite the application on the target system. Available options include:',
'<p />',
'<ul>',
'<li><strong>On</strong> the application will be deployed with the same application ID as this application and the application will be overwritten on the target system.</li>',
'<li><strong>Off</strong> you must specify the application ID for the target system.</li>',
'</ul>',
'<p />'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2703331270358332)
,p_name=>'P4906_ALIAS_OVERRIDE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(2701833594358317)
,p_item_default=>'select alias from wwv_flows where id = :FB_FLOW_ID'
,p_item_default_type=>'SQL_QUERY'
,p_prompt=>'Application Alias Override'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify a new alternate alphanumeric application identifier. You can use this identifier in place of the application ID. The value is defaulted to the application alias of the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ENTERABLE'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2703481285358333)
,p_name=>'P4906_KEEP_SESSIONS'
,p_item_sequence=>63
,p_item_plug_id=>wwv_flow_imp.id(2701833594358317)
,p_item_default=>'Y'
,p_prompt=>'Keep Sessions'
,p_display_as=>'NATIVE_YES_NO'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify whether sessions will be preserved when overwriting the application on the target system. Available options include:',
'<p />',
'<ul>',
'<li><strong>On</strong> keeps sessions associated with the application being overwritten on the target system.</li>',
'<li><strong>Off</strong> does not keep sessions associated with the application being overwritten on the target system.</li>',
'</ul>',
'<p />',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3301408187728455)
,p_name=>'P4906_SELECTED_APPLICATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3300547964231734)
,p_use_cache_before_default=>'NO'
,p_item_default=>'&FB_FLOW_ID.'
,p_prompt=>'Selected Application:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the currently selected application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3302340904728460)
,p_name=>'P4906_PAGE_COUNT'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3300547964231734)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Page Count:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select to_char(count(*),''999G999G999G990'') c',
'from wwv_flow_steps ',
'where flow_id = nvl(:FB_FB_EXPORT_FLOW_ID,0) and security_group_id = :flow_security_group_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the number of pages in the currently selected application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3303234454728462)
,p_name=>'P4906_APPLICATION_SCHEMA'
,p_item_sequence=>31
,p_item_plug_id=>wwv_flow_imp.id(3300547964231734)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Owner:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select owner ',
'from wwv_flows ',
'where id = nvl(:FB_FB_EXPORT_FLOW_ID,0) and security_group_id = :flow_security_group_id'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WORKSPACE_SCHEMA'
,p_help_text=>'Identifies the database schema owner of the selected application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3304189616728462)
,p_name=>'F4000_P4906_FORMAT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(3300547964231734)
,p_source=>'UNIX'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select a file format. Options include:',
'<ul>',
'<li>Select <strong>DOS</strong> to have the lines in the resulting file terminated by carriage returns and line feeds.</li>',
'<li>Select <strong>UNIX</strong> to have the lines in the resulting file contain terminated by line feeds.</li>',
'<li>Select <strong>Database</strong> to have the resulting file saved in the Export Repository instead of downloading it.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_item_comment=>'unix=chr(10),dos=chr(13)||chr(10) after each row'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3305021371728465)
,p_name=>'F4000_P4906_OWNER_OVERRIDE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(2701833594358317)
,p_prompt=>'Owner&nbsp;Override'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select x.column_value d, x.column_value r',
'  from table (wwv_flow_remote_deploy_dev.get_schemas(p_server_id=>:P4905_SERVER_ID)) x'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Use this attribute to import this application into the available schemas defined by your REST Enabled SQL connection. If there are no entries to select, then this connection is not mapped to any workspaces, and you will not be able to deploy the appl'
||'ication.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3305971648728467)
,p_name=>'P4906_BUILD_STATUS_OVERRIDE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(3300547964231734)
,p_use_cache_before_default=>'NO'
,p_item_default=>'RUN_AND_BUILD'
,p_prompt=>'Build&nbsp;Status&nbsp;Override'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'BUILD_STATUS'
,p_lov=>'.'||wwv_flow_imp.id(84305510710571518)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select the build status of the exported application.  Options include:<br>',
'<ul><li><strong>Run Application Only</strong> - Users can only run the application. This option is intended for applications in a production instance.</li>',
'<li><strong>Run and Build Application</strong> - Developers and users can both run and develop the application.</li>',
'</ul></p>',
'<p>Note:  This setting can be changed when importing via the Web interface of &PRODUCT_NAME. but not via the command line interface.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3307776924728470)
,p_name=>'P4906_FLASHBK_FLOW_AS_OF'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(3300547964231734)
,p_prompt=>'As of'
,p_post_element_text=>'<span class="fielddata">minutes ago (~ 5 min delay)</span>'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>4
,p_cMaxlength=>2000
,p_display_when=>'F4000_P4906_FORMAT'
,p_display_when2=>'DB'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="htmldbInfoBodyP">Specify a time in minutes to go to back to for your export. This option enables you to go back in time in your application, perhaps to get back a deleted object.</div>',
'',
'<div class="htmldbInfoBodyP">This utility uses the <code>dbms_flashback</code> package. The timestamp to SCN (system change number) mapping is refreshed approximately every 5 minutes, so you may have to wait that long to get to the version you are lo'
||'oking for. The time undo information is retained by the startup parameter <code>undo_retention</code> (default 3 hrs), but this only influences the size of the undo tablespace.</div>',
'<div class="htmldbInfoBodyP">While two databases may have the same <code>undo_retention</code> parameter, you can go back much further in time on the database with less transactions since the transactions are not filling the undo tablespace, forcing '
||'older data to be archived.</div>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3313097473728485)
,p_name=>'P4906_EXP_DEPLOYMENT_METADATA'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(197597352626318639)
,p_item_default=>'Y'
,p_prompt=>'Export Supporting Object Definitions'
,p_source=>'select include_in_export_yn from wwv_flow_install where flow_id = :fb_flow_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'EXPORT_SUP_OBJ_OPTIONS'
,p_lov=>'.'||wwv_flow_imp.id(388231942990864305)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify whether to export supporting object definitions with your application. Available options include:',
'<p />',
'<ul>',
'<li><strong>Yes</strong> Includes supporting object definitions in the application export.  Does not automatically load supporting objects when invoked from a command line.',
'</li>',
'<li><strong>No</strong> Does not include the supporting object definitions in the export.</li>',
'<li><strong>Yes and Install on Import Automatically</strong> Includes supporting object definitions and a call to install supporting objects in the application export.  This option is valid only for command line installs.  When application imports fr'
||'om the command line, it automatically installs or upgrades the supporting objects.',
'</ul>',
'<p />',
'Supporting object definitions include all configuration options and scripts and enable an application export to include database object definitions, image definitions, and seed data SQL statements encapsulated in a single file.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3313961472728487)
,p_name=>'P4906_PUBLIC_REPORTS'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(197597352626318639)
,p_item_default=>'Y'
,p_prompt=>'Export Public Reports'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify whether to include Public reports with your application.  Available options include:',
'<p />',
'<ul>',
'<li><strong>On</strong> includes Public reports in the application export.</li>',
'<li><strong>Off</strong> does not include Public reports in the application export.</li>',
'</ul>',
'<p />',
'Public reports are the public shared report settings saved by users from Interactive Report or Interactive Grid.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3314888068728487)
,p_name=>'P4906_PRIVATE_REPORTS'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(197597352626318639)
,p_item_default=>'N'
,p_prompt=>'Export Private Reports'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify whether to include Private reports with your application. Available options include:',
'<p />',
'<ul>',
'<li><strong>On</strong> includes Private reports in the application export.</li>',
'<li><strong>Off</strong> does not include Private reports in the application export.</li>',
'</ul>',
'<p />',
'Private reports are the private customized settings saved by users from Interactive Report or Interactive Grid.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3315740386728488)
,p_name=>'P4906_NOTIFICATIONS'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(197597352626318639)
,p_item_default=>'N'
,p_prompt=>'Export Report Subscriptions'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify whether to include Interactive Report or Interactive Grid subscription settings with your application. Available options include:',
'<p />',
'<ul>',
'<li><strong>On</strong> includes report subscriptions for the reports you are exporting in the application export.</li>',
'<li><strong>Off</strong> does not include report subscriptions for the reports in the application export.</li>',
'</ul>',
'<p />',
'This will be limited to the un-expired subscription settings of all users for all Interactive Reports or Interactive Grids in the application.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3316658864728489)
,p_name=>'P4906_EXPORT_COMMENTS'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(197597352626318639)
,p_item_default=>'Y'
,p_prompt=>'Export Developer Comments'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify whether to include Developer Comments in your application export. Available options include:',
'<p />',
'<ul>',
'<li><strong>On</strong> includes Developer Comments in the application export.</li>',
'<li><strong>Off</strong> does not include Developer Comments in the export.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3317553743728490)
,p_name=>'P4906_EXPORT_TRANSLATIONS'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(197597352626318639)
,p_item_default=>'Y'
,p_prompt=>'Export Translations'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify whether to include Translations with your application export.  Available options include:',
'<p />',
'<ul>',
'<li><strong>On</strong> includes the translation mappings and all text from the translation repository.</li>',
'<li><strong>Off</strong> does not include translation mappings or the translation repository.</li>',
'</ul>',
'<p />',
'Translation Text Messages and Dynamic Translations will always be included in the application export.',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11007638655042202)
,p_name=>'P4906_ID_OVERRIDE'
,p_item_sequence=>65
,p_item_plug_id=>wwv_flow_imp.id(2701833594358317)
,p_prompt=>'Application ID Override'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>8
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify a new application ID for the application on the target system.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ENTERABLE'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3320987612728502)
,p_computation_sequence=>10
,p_computation_item=>'FB_FLOW_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'&FB_FB_EXPORT_FLOW_ID.'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3321307553728502)
,p_computation_sequence=>20
,p_computation_item=>'FB_FB_EXPORT_FLOW_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'&FB_FLOW_ID.'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3321737659728503)
,p_validation_name=>'P4906_FLASHBK_FLOW_AS_OF is numeric'
,p_validation_sequence=>10
,p_validation=>'P4906_FLASHBK_FLOW_AS_OF'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'"As Of" must be numeric.'
,p_validation_condition=>':P4906_FLASHBK_FLOW_AS_OF is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(4801850489171795)
,p_associated_item=>wwv_flow_imp.id(3307776924728470)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2704968014358348)
,p_validation_name=>'ID is numeric'
,p_validation_sequence=>20
,p_validation=>'P4906_ID_OVERRIDE'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Application ID override must numeric.'
,p_validation_condition=>'nvl(:P4906_OVERWRITE_APP,''N'') = ''N'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(4801850489171795)
,p_associated_item=>wwv_flow_imp.id(11007638655042202)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(11600713382734803)
,p_validation_name=>'ID not null'
,p_validation_sequence=>30
,p_validation=>'P4906_ID_OVERRIDE'
,p_validation_type=>'ITEM_NOT_NULL_OR_ZERO'
,p_error_message=>'Application ID override must be specified.'
,p_validation_condition=>'nvl(:P4906_OVERWRITE_APP,''N'') = ''N'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(4801850489171795)
,p_associated_item=>wwv_flow_imp.id(11007638655042202)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(11600850475734804)
,p_validation_name=>'OWNER not null'
,p_validation_sequence=>40
,p_validation=>'F4000_P4906_OWNER_OVERRIDE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Please select an owner for the application.'
,p_associated_item=>wwv_flow_imp.id(3305021371728465)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(11600986283734805)
,p_validation_name=>'Workspace not null'
,p_validation_sequence=>50
,p_validation=>'P4906_WORKSPACE_OVERRIDE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Please select a workspace.'
,p_associated_item=>wwv_flow_imp.id(2702648440358325)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(11600611005734802)
,p_validation_name=>'Validate Alias'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_remote_deploy_dev.is_valid_alias(',
'    p_server_id => :P4905_SERVER_ID,',
'    p_alias     => :P4906_ALIAS_OVERRIDE);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'This alias already exists in the &P4906_WORKSPACE_OVERRIDE. workspace.'
,p_validation_condition=>'nvl(:P4906_OVERWRITE_APP,''N'') = ''N'' and :P4906_ALIAS_OVERRIDE is not null and :F4000_P4906_OWNER_OVERRIDE is not null and :P4906_WORKSPACE_OVERRIDE is not null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(4801850489171795)
,p_associated_item=>wwv_flow_imp.id(2703331270358332)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(11601192824734807)
,p_validation_name=>'Validate app id'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_app_id varchar2(30);',
'begin',
'    if nvl(:P4906_OVERWRITE_APP,''N'') = ''N'' then',
'        l_app_id := :P4906_ID_OVERRIDE;',
'    else',
'        l_app_id := :FB_FLOW_ID;',
'    end if;',
'    ',
'    return wwv_flow_remote_deploy_dev.is_valid_app_id(',
'               p_server_id => :P4905_SERVER_ID,',
'               p_app_id    => l_app_id,',
'               p_workspace => :P4906_WORKSPACE_OVERRIDE);',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_when_button_pressed=>wwv_flow_imp.id(4801850489171795)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3323286651728507)
,p_name=>'Set Values'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'FB_FB_EXPORT_FLOW_ID'
,p_condition_element=>'FB_FB_EXPORT_FLOW_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3323618716728510)
,p_event_id=>wwv_flow_imp.id(3323286651728507)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4906_SELECTED_APPLICATION'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'   l_ret   varchar2(255);',
'begin',
'  select name into l_ret',
'    from wwv_flows ',
'    where id = nvl(:FB_FB_EXPORT_FLOW_ID,0) and security_group_id = :flow_security_group_id;',
'  return l_ret;',
'end;'))
,p_attribute_07=>'FB_FB_EXPORT_FLOW_ID'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3324111688728511)
,p_event_id=>wwv_flow_imp.id(3323286651728507)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3300547964231734)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3324621745728512)
,p_event_id=>wwv_flow_imp.id(3323286651728507)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4906_PAGE_COUNT'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_ret   varchar2(255);',
'begin',
'select to_char(count(*),''999G999G999G990'') c into l_ret',
'from wwv_flow_steps ',
'where flow_id = nvl(:FB_FB_EXPORT_FLOW_ID,0) and security_group_id = :flow_security_group_id;',
'return l_ret;',
'end;'))
,p_attribute_07=>'FB_FB_EXPORT_FLOW_ID'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3325166974728512)
,p_event_id=>wwv_flow_imp.id(3323286651728507)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(197597352626318639)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3325673042728513)
,p_event_id=>wwv_flow_imp.id(3323286651728507)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4906_APPLICATION_SCHEMA'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_ret varchar2(255);',
'begin',
'   select owner into l_ret',
'from wwv_flows ',
'where id = nvl(:FB_FB_EXPORT_FLOW_ID,0) and security_group_id = :flow_security_group_id;',
'return l_ret;',
'end;'))
,p_attribute_07=>'FB_FB_EXPORT_FLOW_ID'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3326142166728513)
,p_event_id=>wwv_flow_imp.id(3323286651728507)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3300547964231734)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3326687319728514)
,p_event_id=>wwv_flow_imp.id(3323286651728507)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(197597352626318639)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3327184141728515)
,p_event_id=>wwv_flow_imp.id(3323286651728507)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    :FB_FLOW_ID := :FB_FB_EXPORT_FLOW_ID;',
'end;'))
,p_attribute_02=>'FB_FB_EXPORT_FLOW_ID'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2704050985358339)
,p_name=>'Submit Page'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(4801850489171795)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2704184957358340)
,p_event_id=>wwv_flow_imp.id(2704050985358339)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'NEXT'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(11008096182042206)
,p_name=>'Toggle Items'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4906_OVERWRITE_APP'
,p_condition_element=>'P4906_OVERWRITE_APP'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(11008150093042207)
,p_event_id=>wwv_flow_imp.id(11008096182042206)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4906_KEEP_SESSIONS'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(11600541271734801)
,p_event_id=>wwv_flow_imp.id(11008096182042206)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4906_ID_OVERRIDE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2705170735358350)
,p_event_id=>wwv_flow_imp.id(11008096182042206)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4906_ID_OVERRIDE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(11008277459042208)
,p_event_id=>wwv_flow_imp.id(11008096182042206)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4906_KEEP_SESSIONS'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3322864568728505)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'security'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'sys.htp.init;',
'sys.owa_util.redirect_url(v(''LOGOUT_URL''));',
'wwv_flow.g_unrecoverable_error := true;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'    from   wwv_flow_developers',
'    where  userid = :FLOW_USER ',
'       and',
'       security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and',
'       security_group_id = ',
'         (select security_group_id from wwv_flows where id=:FB_FB_EXPORT_FLOW_ID or :FB_FB_EXPORT_FLOW_ID is null)',
'       and',
'       instr(developer_role,''EDIT'') > 0 ',
'       and',
'       (flow_id = :FB_FB_EXPORT_FLOW_ID or flow_id is null)  ',
'       and not exists (select 1 from wwv_flows',
'                    where id = :FB_FB_EXPORT_FLOW_ID',
'                      and build_status = ''RUN_AND_HIDDEN'')'))
,p_process_when_type=>'NOT_EXISTS'
,p_internal_uid=>3322864568728505
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3322481540728504)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Deploy App Remotely'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'wwv_flow_remote_deploy_dev.deploy (',
'    p_application_id            => :FB_FB_EXPORT_FLOW_ID,',
'    p_server_id                 => :P4905_SERVER_ID,',
'    p_owner_override            => :F4000_P4906_OWNER_OVERRIDE,',
'    p_workspace_override        => :P4906_WORKSPACE_OVERRIDE,',
'    p_app_id_override           => :P4906_ID_OVERRIDE,',
'    p_alias_override            => :P4906_ALIAS_OVERRIDE,',
'    p_overwrite_app             => :P4906_OVERWRITE_APP,',
'    p_keep_sessions             => nvl(:P4906_KEEP_SESSIONS,''N''),',
'    p_export_sup_objects        => :P4906_EXP_DEPLOYMENT_METADATA,',
'    p_export_comments           => nvl(:P4906_EXPORT_COMMENTS,''N''),',
'    p_export_ir_public_reports  => nvl(:P4906_PUBLIC_REPORTS,''N''),',
'    p_export_ir_private_reports => nvl(:P4906_PRIVATE_REPORTS,''N''),',
'    p_export_ir_notifications   => nvl(:P4906_NOTIFICATIONS,''N''),',
'    p_export_translations       => nvl(:P4906_EXPORT_TRANSLATIONS,''N''),',
'    p_build_status_override     => :P4906_BUILD_STATUS_OVERRIDE,',
'    p_flashback_min_ago         => :P4906_FLASHBK_FLOW_AS_OF );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error remotely deploying application &FB_FB_EXPORT_FLOW_ID.. #SQLERRM#'
,p_process_when_button_id=>wwv_flow_imp.id(4801850489171795)
,p_process_success_message=>'Application &FB_FB_EXPORT_FLOW_ID. remotely deployed.'
,p_internal_uid=>3322481540728504
);
end;
/
prompt --application/pages/page_04907
begin
wwv_flow_imp_page.create_page(
 p_id=>4907
,p_name=>'Remote Deployment Successful'
,p_alias=>'REMOTE-DEPLOYMENT-SUCCESSFUL'
,p_step_title=>'Remote Deployment Successful'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213300727323081712)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_install.htm'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(229957875453617761)
,p_plug_name=>'Application Remotely Deployed'
,p_region_template_options=>'#DEFAULT#:a-Alert--success:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>20
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if nvl(:P4906_OVERWRITE_APP,''N'') = ''Y'' then',
'    sys.htp.p( ''<p>'' || wwv_flow_lang.system_message( ''APEX.REMOTEDEPLOY.SUCCESS'', :FB_FLOW_ID ) || ''</p>'' );',
'else',
'    sys.htp.p( ''<p>'' || wwv_flow_lang.system_message( ''APEX.REMOTEDEPLOY.SUCCESS2'', :FB_FLOW_ID, :P4906_ID_OVERRIDE ) || ''</p>'' );',
'end if;',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(229958372944635937)
,p_plug_name=>'app success buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(10765277646068677)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(229958372944635937)
,p_button_name=>'EDIT_APP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Edit Application'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(10770719760068691)
,p_branch_action=>'f?p=&FB_FLOW_ID.:1:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'RUN'
,p_save_state_before_branch_yn=>'Y'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(10771519710068692)
,p_branch_action=>'f?p=&FLOW_ID.:73:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'VIEW'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(10771123657068691)
,p_branch_action=>'f?p=4000:1:&SESSION.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'EDIT'
,p_save_state_before_branch_yn=>'Y'
);
end;
/
prompt --application/pages/page_04910
begin
wwv_flow_imp_page.create_page(
 p_id=>4910
,p_name=>'Build Options'
,p_alias=>'BUILD-OPTIONS'
,p_step_title=>'Build Options'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213481614528579568)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'deploy_build_options.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(299056867)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--sideRegion:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Build options enable developers to conditionally enable and disable application components and functionality when the application is installed or at runtime using the <code>GET_BUILD_OPTION_STATUS</code> and <code>SET_BUILD_OPTION_STATUS</code> AP'
||'Is.</p>',
'<p>You can apply build options to most components (such as pages, regions, items, validations, and so on) to include or exclude them in the runtime application:</p>',
'<p><strong>Include</strong> - Components are enabled and part of the application.</p>',
'<p><strong>Exclude</strong> - Components are disabled and not part of the application.</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3738622552051132)
,p_plug_name=>'Build Options'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select',
'   b.flow_id,',
'   b.patch_name,',
'   replace(b.patch_name,''_'','' '') build_option_name,',
'   wwv_flow_lang.system_message(b.patch_status) as patch_status,',
'   b.on_upgrade_keep_status,',
'   substr(b.patch_comment,1,500) patch_comment,',
'   b.id,',
'   decode(b.patch_status,',
'          ''EXCLUDE'', ''u-danger-text'',',
'          ''u-success-text'') as patch_class,',
'   decode (b.patch_status,',
'      ''EXCLUDE'',''icon-sc-build-option-off u-danger-text'',',
'      ''icon-sc-build-option-on u-success-text'') img,',
'   replace(b.patch_name,''_'', '' '') alt,',
'   wwv_flow_page_api.get_url(',
'       p_page        => 4911,',
'       p_clear_cache => 4911,',
'       p_items       => ''F4000_P4911_ID'',',
'       p_values      => b.id ) link,',
'   b.last_updated_by updated_by,',
'   b.last_updated_on updated,',
'   b.created_by,',
'   b.created_on created,',
'   (select count(*)',
'       from wwv_flow_steps s',
'       where s.flow_id = :fb_flow_id and',
'             s.security_group_id = :flow_security_group_id and',
'             b.id = s.REQUIRED_PATCH) pages,',
'   (select count(*)',
'       from wwv_flow_step_items s',
'       where s.flow_id = :fb_flow_id and',
'             s.security_group_id = :flow_security_group_id and',
'             b.id = s.REQUIRED_PATCH) page_items,',
'   (select count(*)',
'       from wwv_flow_step_buttons s',
'       where s.flow_id = :fb_flow_id and',
'             s.security_group_id = :flow_security_group_id and',
'             b.id = s.REQUIRED_PATCH) page_buttons,',
'   (select count(*)',
'       from WWV_FLOW_STEP_BRANCHES s',
'       where s.flow_id = :fb_flow_id and',
'             s.security_group_id = :flow_security_group_id and',
'             b.id = s.REQUIRED_PATCH) page_branches,',
'   (select count(*)',
'       from WWV_FLOW_STEP_COMPUTATIONS s',
'       where s.flow_id = :fb_flow_id and',
'             s.security_group_id = :flow_security_group_id and',
'             b.id = s.REQUIRED_PATCH) page_computations,',
'   (select count(*)',
'       from WWV_FLOW_STEP_PROCESSING s',
'       where s.flow_id = :fb_flow_id and',
'             s.security_group_id = :flow_security_group_id and',
'             b.id = s.REQUIRED_PATCH) page_processes,',
'   (select count(*)',
'       from WWV_FLOW_STEP_VALIDATIONS s',
'       where s.flow_id = :fb_flow_id and',
'             s.security_group_id = :flow_security_group_id and',
'             b.id = s.REQUIRED_PATCH) page_validations,',
'   (select count(*)',
'      from wwv_flow_page_da_events s',
'     where s.flow_id = :fb_flow_id and',
'           s.security_group_id = :flow_security_group_id and',
'           b.id = s.REQUIRED_PATCH) page_dynamic_actions,',
'   (select count(*)',
'      from wwv_flow_page_da_actions s',
'     where s.flow_id = :fb_flow_id and',
'           s.security_group_id = :flow_security_group_id and',
'           b.id = s.build_option_id) page_dynamic_action_actions,',
'   (select count(*)',
'       from wwv_flow_card_actions a',
'      where a.flow_id = :fb_flow_id and',
'            a.security_group_id = :flow_security_group_id and',
'            b.id = a.build_option_id) page_card_actions,',
'   (select count(*)',
'       from wwv_flow_pwa_shortcuts a',
'      where a.flow_id = :fb_flow_id and',
'            a.security_group_id = :flow_security_group_id and',
'            b.id = a.build_option_id) pwa_shortcuts,',
'   (select count(*)',
'       from wwv_flow_pwa_screenshots a',
'      where a.flow_id = :fb_flow_id and',
'            a.security_group_id = :flow_security_group_id and',
'            b.id = a.build_option_id) pwa_screenshots,',
'   (select count(*)',
'       from wwv_flow_page_meta_tags a',
'      where a.flow_id = :fb_flow_id and',
'            a.security_group_id = :flow_security_group_id and',
'            b.id = a.build_option_id) page_meta_tags,',
'   (select count(*)',
'       from wwv_flow_component_actions a',
'      where a.flow_id = :fb_flow_id and',
'            a.security_group_id = :flow_security_group_id and',
'            b.id = a.build_option_id) page_component_actions,',
'   (select count(*)',
'       from wwv_flow_comp_menu_entries a',
'      where a.flow_id = :fb_flow_id and',
'            a.security_group_id = :flow_security_group_id and',
'            b.id = a.build_option_id) page_action_menus,',
'   wwv_flow_lang.system_message(nvl(b.default_on_export,b.patch_status)) DEFAULT_ON_EXPORT,',
'   b.FEATURE_IDENTIFIER,',
'   --',
'   case when b.reference_id is not null then',
'       coalesce ( to_char( master.flow_id ),',
'                   wwv_flow_lang_dev.builder_message( ''SUBSCRIBED_FROM.NONEXISTING_MASTER'' ) )',
'   end as subscribed_from,',
'   ( select case when count(*) > 0 then count(*) end',
'       from wwv_flow_patches sub',
'      where sub.reference_id      = b.id',
'        and sub.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   ) as subscribers,',
'   case when b.reference_id is not null then',
'       case',
'           when master.version_scn = b.version_scn then',
'               wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_UP_TO_DATE'')',
'           when master.version_scn != b.version_scn then',
'               wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_NEEDS_REFRESH'')',
'           else',
'               wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_UNKNOWN'')',
'       end',
'   end subscription_status,',
'   --',
'   null as actions',
' from wwv_flow_patches b,',
'      wwv_flow_patches master',
'where b.flow_id                = :FB_FLOW_ID',
'  and b.security_group_id      = :FLOW_SECURITY_GROUP_ID',
'  and b.reference_id           = master.id (+)',
'  and b.security_group_id      = master.security_group_id (+)'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(3738700462051133)
,p_name=>'Build Options'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No build options are defined for this application'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#LINK#" class="a-IRR-icon"><span class="a-Icon #IMG#"></span><span class="a-IRR-iconName">#PATCH_NAME#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3739013673051137)
,p_db_column_name=>'PATCH_NAME'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>'Name'
,p_column_link=>'f?p=&APP_ID.:4911:&SESSION.::&DEBUG.:4911:F4000_P4911_ID:#ID#'
,p_column_linktext=>'#PATCH_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3738902120051137)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>2
,p_column_identifier=>'A'
,p_column_label=>'Application'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3739129869051137)
,p_db_column_name=>'PATCH_STATUS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Status'
,p_column_html_expression=>'<span class="#PATCH_CLASS#">#PATCH_STATUS#</span>'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(337328430321153006)
,p_db_column_name=>'ON_UPGRADE_KEEP_STATUS'
,p_display_order=>13
,p_column_identifier=>'W'
,p_column_label=>'On Upgrade Keep Status'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(84259319526460470)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3739223534051138)
,p_db_column_name=>'PATCH_COMMENT'
,p_display_order=>23
,p_column_identifier=>'D'
,p_column_label=>'Comment'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3739312786051138)
,p_db_column_name=>'ID'
,p_display_order=>33
,p_column_identifier=>'E'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3739430626051138)
,p_db_column_name=>'IMG'
,p_display_order=>43
,p_column_identifier=>'F'
,p_column_label=>'Image'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3739511995051138)
,p_db_column_name=>'ALT'
,p_display_order=>53
,p_column_identifier=>'G'
,p_column_label=>'Alt'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3739626916051139)
,p_db_column_name=>'LINK'
,p_display_order=>63
,p_column_identifier=>'H'
,p_column_label=>'Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3739718316051139)
,p_db_column_name=>'UPDATED_BY'
,p_display_order=>73
,p_column_identifier=>'I'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3739815957051139)
,p_db_column_name=>'UPDATED'
,p_display_order=>83
,p_column_identifier=>'J'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3742107609149600)
,p_db_column_name=>'BUILD_OPTION_NAME'
,p_display_order=>93
,p_column_identifier=>'K'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3742830512184595)
,p_db_column_name=>'PAGES'
,p_display_order=>103
,p_column_identifier=>'L'
,p_column_label=>'Pages'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3742929557184595)
,p_db_column_name=>'PAGE_ITEMS'
,p_display_order=>113
,p_column_identifier=>'M'
,p_column_label=>'Page Items'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3743004257184596)
,p_db_column_name=>'PAGE_BUTTONS'
,p_display_order=>123
,p_column_identifier=>'N'
,p_column_label=>'Page Buttons'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3743901469204578)
,p_db_column_name=>'PAGE_BRANCHES'
,p_display_order=>133
,p_column_identifier=>'O'
,p_column_label=>'Page Branches'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3744019193204578)
,p_db_column_name=>'PAGE_COMPUTATIONS'
,p_display_order=>143
,p_column_identifier=>'P'
,p_column_label=>'Page Computations'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3744111943204578)
,p_db_column_name=>'PAGE_PROCESSES'
,p_display_order=>153
,p_column_identifier=>'Q'
,p_column_label=>'Page Processes'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3744222625204579)
,p_db_column_name=>'PAGE_VALIDATIONS'
,p_display_order=>163
,p_column_identifier=>'R'
,p_column_label=>'Page Validations'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(196342407305337777)
,p_db_column_name=>'PAGE_DYNAMIC_ACTIONS'
,p_display_order=>173
,p_column_identifier=>'U'
,p_column_label=>'Page Dynamic Actions'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1569137845713222)
,p_db_column_name=>'PAGE_DYNAMIC_ACTION_ACTIONS'
,p_display_order=>183
,p_column_identifier=>'AB'
,p_column_label=>'Page Dynamic Action - Actions'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47907532686539828)
,p_db_column_name=>'CREATED_BY'
,p_display_order=>193
,p_column_identifier=>'S'
,p_column_label=>'Created By'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(47907617818539829)
,p_db_column_name=>'CREATED'
,p_display_order=>203
,p_column_identifier=>'T'
,p_column_label=>'Created'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(176251254950916912)
,p_db_column_name=>'DEFAULT_ON_EXPORT'
,p_display_order=>223
,p_column_identifier=>'X'
,p_column_label=>'Default on Export'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(176251348847916913)
,p_db_column_name=>'FEATURE_IDENTIFIER'
,p_display_order=>233
,p_column_identifier=>'Y'
,p_column_label=>'Feature Identifier'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(222860555034540033)
,p_db_column_name=>'PATCH_CLASS'
,p_display_order=>243
,p_column_identifier=>'Z'
,p_column_label=>'Patch CSS'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1512041137491412)
,p_db_column_name=>'PAGE_CARD_ACTIONS'
,p_display_order=>253
,p_column_identifier=>'AA'
,p_column_label=>'Page Card Actions'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3047403295097921)
,p_db_column_name=>'PWA_SHORTCUTS'
,p_display_order=>263
,p_column_identifier=>'AC'
,p_column_label=>'PWA Shortcuts'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3047566614097922)
,p_db_column_name=>'PWA_SCREENSHOTS'
,p_display_order=>273
,p_column_identifier=>'AD'
,p_column_label=>'PWA Screenshots'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3047634400097923)
,p_db_column_name=>'PAGE_META_TAGS'
,p_display_order=>283
,p_column_identifier=>'AE'
,p_column_label=>'Page Meta Tags'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2460576284390837)
,p_db_column_name=>'PAGE_COMPONENT_ACTIONS'
,p_display_order=>293
,p_column_identifier=>'AH'
,p_column_label=>'Page Component Actions'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2460600438390838)
,p_db_column_name=>'PAGE_ACTION_MENUS'
,p_display_order=>303
,p_column_identifier=>'AI'
,p_column_label=>'Page Action Menus'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4406780057142621)
,p_db_column_name=>'SUBSCRIBED_FROM'
,p_display_order=>313
,p_column_identifier=>'AJ'
,p_column_label=>'Subscribed From'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4406859136142622)
,p_db_column_name=>'SUBSCRIBERS'
,p_display_order=>323
,p_column_identifier=>'AK'
,p_column_label=>'Subscribers'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4412217597904125)
,p_db_column_name=>'SUBSCRIPTION_STATUS'
,p_display_order=>343
,p_column_identifier=>'AM'
,p_column_label=>'Subscription Status'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1600244902586802)
,p_db_column_name=>'ACTIONS'
,p_display_order=>353
,p_column_identifier=>'AN'
,p_column_label=>'Copy'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'TMPL_THEME_3$ACTIONS'
,p_column_alignment=>'CENTER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'ACTIONS_WRAP', 'N',
  'STYLE', 'b-InlineActions--simple')).to_clob
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(3741124531126093)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_type=>'REPORT'
,p_report_alias=>'1306905275536647'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'PATCH_NAME:PATCH_STATUS:DEFAULT_ON_EXPORT:ON_UPGRADE_KEEP_STATUS:SUBSCRIBED_FROM:SUBSCRIPTION_STATUS:SUBSCRIBERS:PATCH_COMMENT:UPDATED:UPDATED_BY::ACTIONS'
,p_sort_column_1=>'PATCH_NAME'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4796820911120914)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(4232641859826655)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47910018534564133)
,p_plug_name=>'tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_list_id=>wwv_flow_imp.id(47909111131552473)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Build Options'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(188926110828413443)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(3738622552051132)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4910:&SESSION.::&DEBUG.:4910,RIR::'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(10080222113732957)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(3738622552051132)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:4911:&SESSION.::&DEBUG.:4911::'
,p_icon_css_classes=>'icon-right-chevron'
,p_grid_new_row=>'N'
,p_grid_new_column=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(146376031581502626)
,p_computation_sequence=>20
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'4910'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4414769298904150)
,p_name=>'Refresh Subscriptions'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(4796820911120914)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6609646321558801)
,p_event_id=>wwv_flow_imp.id(4414769298904150)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3738622552051132)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6609761322558802)
,p_event_id=>wwv_flow_imp.id(4414769298904150)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ( this.data.successMessage ) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
);
wwv_flow_imp_page.create_component_action(
 p_id=>wwv_flow_imp.id(1600355854586803)
,p_ir_column_id=>wwv_flow_imp.id(1600244902586802)
,p_position_id=>wwv_flow_imp.id(214437533860142316)
,p_display_sequence=>10
,p_template_id=>wwv_flow_imp.id(214438625365151034)
,p_label=>'Copy'
,p_link_target_type=>'REDIRECT_PAGE'
,p_link_target=>'f?p=&APP_ID.:4912:&SESSION.::&DEBUG.:4912:P4912_COPY_SOURCE,P4912_ID,P4912_COPY_FROM_APPLICATION_ID:THIS,#ID#,&FB_FLOW_ID.'
,p_button_display_type=>'ICON'
,p_icon_css_classes=>'icon-copy'
,p_is_hot=>false
,p_show_as_disabled=>false
);
end;
/
prompt --application/pages/page_04911
begin
wwv_flow_imp_page.create_page(
 p_id=>4911
,p_name=>'Create/Edit Build Options'
,p_alias=>'CREATE-EDIT-BUILD-OPTIONS'
,p_step_title=>'Create/Edit Build Option'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213481614528579568)
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_read_only_when=>'P4911_REFERENCE_ID'
,p_help_text=>'deploy_build_options.htm'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(439547742)
,p_plug_name=>'Attributes'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_region_attributes=>'style="width:100%"'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_PATCHES'
,p_query_where=>'security_group_id = :WORKSPACE_ID'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'i:u'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4406975042142623)
,p_plug_name=>'Subscription'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'F4000_P4911_ID'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'WWV_FLOW_PATCHES',
  'attribute_02', 'PATCH_NAME',
  'attribute_03', 'F4000_P4911_ID',
  'attribute_04', 'P4911_REFERENCE_ID',
  'attribute_05', 'SUBSCRIBE_PATCH',
  'attribute_06', 'VERSION_SCN')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9333382179988514)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(4232641859826655)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
,p_plug_display_condition_type=>'ITEM_IS_NULL'
,p_plug_display_when_condition=>'F4000_P4911_ID'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(52412001060114527)
,p_name=>'Associated Components'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select component, ',
'       component_name, ',
'       build_option,',
'       page_number,',
'       is_subscribed',
'  from wwv_flow_build_opt_usage_dev',
'  -- security_group_id  filter exists in the view',
' where id     = :F4000_P4911_ID',
'  and flow_id = :FB_FLOW_ID'))
,p_display_when_condition=>'F4000_P4911_ID'
,p_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>'-'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(710588709092275240)
,p_query_column_id=>1
,p_column_alias=>'COMPONENT'
,p_column_display_sequence=>1
,p_column_heading=>'Component'
,p_use_as_row_header=>'Y'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(710588829823275241)
,p_query_column_id=>2
,p_column_alias=>'COMPONENT_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Component Name'
,p_use_as_row_header=>'Y'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(710589025159275243)
,p_query_column_id=>3
,p_column_alias=>'BUILD_OPTION'
,p_column_display_sequence=>3
,p_column_heading=>'Build Option'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(710589252544275245)
,p_query_column_id=>4
,p_column_alias=>'PAGE_NUMBER'
,p_column_display_sequence=>4
,p_column_heading=>'Page Number'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(6611364041558818)
,p_query_column_id=>5
,p_column_alias=>'IS_SUBSCRIBED'
,p_column_display_sequence=>14
,p_column_heading=>'Is Subscribed?'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(84259319526460470)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(179892122974870284)
,p_plug_name=>'Build Options'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Use build options to enable or disable functionality within an application.</p><p>When Build Option is subscribed, then it is not possible to change any data.</p>',
'<p>Deletion of the master build option automatically clears the build option references from subscribing build options.</p>'))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(615517525809264669)
,p_plug_name=>'Build Option'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(617435907459619299)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(29434107863295859)
,p_plug_display_sequence=>50
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'select last_updated_by, last_updated_on, created_by, created_on ',
'from WWV_FLOW_PATCHES ',
'where id = :F4000_P4911_ID and security_group_id = :WORKSPACE_ID) loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id                 => :F4000_P4911_ID,',
'      p_component_type     => ''Region'',',
'      p_last_updated_by    => c1.last_updated_by,',
'      p_last_updated_on    => c1.last_updated_on,',
'      p_created_by         => c1.created_by,',
'      p_created_on         => c1.created_on);',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'F4000_P4911_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(690213637713382241)
,p_plug_name=>'Anchor'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>20
,p_plug_new_grid_column=>false
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(54178613300055452)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(52412001060114527)
,p_button_name=>'REMOVE_COMPONENTS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary:a-Button--gapRight:a-Button--gapLeft'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Remove Components'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:232:&SESSION.::&DEBUG.:RP,232:F4000_P232_ID:&F4000_P4911_ID.'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4407288716142626)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_imp.id(4406975042142623)
,p_button_name=>'UNSUBSCRIBE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Unsubscribe'
,p_button_position=>'EDIT'
,p_button_condition=>':P4911_REFERENCE_ID is not null and :P4911_SUBSCRIBED_COMP_GRP = ''N'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4407327928142627)
,p_button_sequence=>110
,p_button_plug_id=>wwv_flow_imp.id(4406975042142623)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Refresh Build Option'
,p_button_position=>'EDIT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P4911_REFERENCE_ID is not null ',
'and ( :P4911_VERSION_SCN != :P4911_MASTER_VERSION_SCN or :P4911_VERSION_SCN is null )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4407438140142628)
,p_button_sequence=>120
,p_button_plug_id=>wwv_flow_imp.id(4406975042142623)
,p_button_name=>'PUBLISH'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Publish'
,p_button_position=>'EDIT'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.:149:F4000_P149_ID,F4000_P149_TEMPLATE_TYPE,F4000_P149_PAGE_ID:&F4000_P4911_ID.,BUILD_OPTION,4911'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * ',
'  from wwv_flow_patches',
' where reference_id      = :F4000_P4911_ID ',
'   and security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7622161824)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(615517525809264669)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:4910:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7623161824)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(615517525809264669)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:235:&SESSION.::&DEBUG.:RP,235:F4000_P235_ID:&F4000_P4911_ID.'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':F4000_P4911_ID is not null ',
'and ( :P4911_REFERENCE_ID is null or :P4911_SUBSCRIBED_COMP_GRP = ''N'' )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7624161824)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(615517525809264669)
,p_button_name=>'SAVE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>':F4000_P4911_ID is not null and :P4911_REFERENCE_ID is null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7625161824)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(615517525809264669)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Build Option'
,p_button_position=>'NEXT'
,p_button_condition=>'F4000_P4911_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(5204878863040736)
,p_branch_name=>'Go to Page 4910'
,p_branch_action=>'f?p=&APP_ID.:4910:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':REQUEST in (''CREATE'',''SAVE'',''DELETE'')'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2357837918667323)
,p_name=>'P4911_SUBSCRIBED_COMP_GRP'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(4406975042142623)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4407058422142624)
,p_name=>'P4911_REFERENCE_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(4406975042142623)
,p_item_source_plug_id=>wwv_flow_imp.id(439547742)
,p_prompt=>'Subscribe From'
,p_source=>'REFERENCE_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FLOW_SUBSCRIBE_FROM_PATCHES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select b.flow_id ||'' ''||f.name||'' - ''|| patch_name d,',
'       b.id r',
'  from wwv_flow_patches b,',
'       wwv_main_apps_dev f',
' where b.flow_id          != nvl(:FB_FLOW_ID,0)',
'   and b.flow_id           = f.id',
'   and f.build_status      not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'   and b.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and f.security_group_id = :FLOW_SECURITY_GROUP_ID',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Subscription -'
,p_cSize=>50
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a master build option to subscribe from. When you select a master build option and click on the <strong>Apply Changes</strong> button, the build option details will be automatically refreshed from the selected master.<br /><br />If the build o'
||'ption is already subscribed, then click on the <strong>Refresh Build Option</strong> button to refresh the build option details from the master build option.'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'Y'
,p_attribute_06=>'0'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4407144900142625)
,p_name=>'P4911_REFERENCE_ID_INIT'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(4406975042142623)
,p_use_cache_before_default=>'NO'
,p_item_default=>'P4911_REFERENCE_ID'
,p_item_default_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4796363868120909)
,p_name=>'P4911_VERSION_SCN'
,p_source_data_type=>'NUMBER'
,p_is_query_only=>true
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(439547742)
,p_item_source_plug_id=>wwv_flow_imp.id(439547742)
,p_source=>'VERSION_SCN'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4796444810120910)
,p_name=>'P4911_MASTER_VERSION_SCN'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(4406975042142623)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select version_scn ',
'  from wwv_flow_patches',
' where id                = :P4911_REFERENCE_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5201597693040703)
,p_name=>'F4000_P4911_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(439547742)
,p_item_source_plug_id=>wwv_flow_imp.id(439547742)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5201619784040704)
,p_name=>'P4911_FLOW_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(439547742)
,p_item_source_plug_id=>wwv_flow_imp.id(439547742)
,p_item_default=>':FB_FLOW_ID'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Application'
,p_source=>'FLOW_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'PICK_FLOWID_USER_HAS_PRIV_ON'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'from   wwv_flow_visible_flows f',
'order by 2'))
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5201767959040705)
,p_name=>'P4911_PATCH_NAME'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(439547742)
,p_item_source_plug_id=>wwv_flow_imp.id(439547742)
,p_prompt=>'Build Option'
,p_source=>'PATCH_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter a descriptive name for this build option. Build options are predefined settings that determine whether or not components within an application are enabled.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5201846087040706)
,p_name=>'P4911_PATCH_STATUS'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(439547742)
,p_item_source_plug_id=>wwv_flow_imp.id(439547742)
,p_prompt=>'Status'
,p_source=>'PATCH_STATUS'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'INCLUDE_EXCLUDE'
,p_lov=>'.'||wwv_flow_imp.id(84357332667662999)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select a status:',
'<ul>',
'<li><strong>Include</strong> - Use this feature.',
'<li><strong>Exclude</strong> - Do not use any attribute flagged with this build option.',
'</ul>'))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5202050109040708)
,p_name=>'P4911_DEFAULT_ON_EXPORT'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(439547742)
,p_item_source_plug_id=>wwv_flow_imp.id(439547742)
,p_prompt=>'Default On Export'
,p_source=>'DEFAULT_ON_EXPORT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'INCLUDE_EXCLUDE'
,p_lov=>'.'||wwv_flow_imp.id(84357332667662999)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Same as Current Status -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'When this application is exported, set the build option to this value.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5202188803040709)
,p_name=>'P4911_ON_UPGRADE_KEEP_STATUS'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(439547742)
,p_item_source_plug_id=>wwv_flow_imp.id(439547742)
,p_item_default=>'N'
,p_prompt=>'On Upgrade Keep Status'
,p_source=>'ON_UPGRADE_KEEP_STATUS'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Select whether the build option status in the deployed application should be kept, or overwritten with the specified status when the application is upgraded. Selecting <strong>On</strong> to keep the deployed status is useful if the application suppo'
||'rts build option configuration (using the <code>APEX_UTIL.SET_BUILD_OPTION_STATUS</code> API) to enable or disable the build option in the deployed application, and where you want to respect those settings upon upgrade.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5203113556040719)
,p_name=>'P4911_PATCH_COMMENT'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(439547742)
,p_item_source_plug_id=>wwv_flow_imp.id(439547742)
,p_prompt=>'Comments'
,p_source=>'PATCH_COMMENT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter any comments or notes. These comments never display when running the application.'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2357974845667324)
,p_computation_sequence=>10
,p_computation_item=>'P4911_SUBSCRIBED_COMP_GRP'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_component_group_dev.is_part_of_subscribed_comp_grp (',
'    p_component_id   => :F4000_P4911_ID,',
'    p_component_type => wwv_flow_copy_metadata.c_build_option,',
'    p_app_id         => :FB_FLOW_ID )'))
,p_compute_when=>'F4000_P4911_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5203430476040722)
,p_validation_name=>'P4911_PATCH_NAME Unique'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_patches',
' where security_group_id = :WORKSPACE_ID ',
'   and flow_id           = :FB_FLOW_ID ',
'   and id               != nvl(:F4000_P4911_ID, -1)',
'   and patch_name        = :P4911_PATCH_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#LABEL# must be unique.'
,p_associated_item=>wwv_flow_imp.id(5201767959040705)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5203523837040723)
,p_validation_name=>'No duplicate subscription'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_patches',
' where security_group_id = :WORKSPACE_ID ',
'   and flow_id           = :FB_FLOW_ID ',
'   and reference_id      = :P4911_REFERENCE_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'An existing build option in this application is subscribed to the same master. Please select another master build option.'
,p_validation_condition=>':P4911_REFERENCE_ID is not null and :P4911_REFERENCE_ID_INIT is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(7624161824)
,p_associated_item=>wwv_flow_imp.id(4407058422142624)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4413952432904142)
,p_name=>'Hide P4911_REFERENCE_ID'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P4911_REFERENCE_ID'
,p_da_event_comment=>'We can hide this item P4911_REFERENCE_ID using server side condition for the item. But, when item is hidden using item''s serverside condition, then "Refresh" process won''t work. Because refresh process is using P4911_REFERENCE_ID item and the item va'
||'lue will not be available during serverside processing when item is hidden from server side during rendering. Point to be noted, this is happening because P4911_REFERENCE_ID item is part of form region.'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4414096802904143)
,p_event_id=>wwv_flow_imp.id(4413952432904142)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4911_REFERENCE_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2358072661667325)
,p_name=>'Save'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(7624161824)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2358176552667326)
,p_event_id=>wwv_flow_imp.id(2358072661667325)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'Are you sure you want to subscribe? This will overwrite the current build option data with the selected master build option.'
,p_attribute_03=>'warning'
,p_attribute_06=>'Subscribe'
,p_attribute_07=>'Cancel'
,p_client_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_client_condition_expression=>'$v(''P4911_REFERENCE_ID'') !== "" && $v(''P4911_REFERENCE_ID_INIT'') === ""'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2358202534667327)
,p_event_id=>wwv_flow_imp.id(2358072661667325)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'SAVE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5203315739040721)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(439547742)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process form Attributes'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE,SAVE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'Build option saved.'
,p_internal_uid=>5203315739040721
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4407669879142630)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh Build Option'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.refresh_component (',
'    p_component_type     => wwv_flow_copy_metadata.c_build_option,',
'    p_master_id          => :P4911_REFERENCE_ID,',
'    p_subscribing_id     => :F4000_P4911_ID,',
'    p_subscribing_app_id => :FB_FLOW_ID );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error during build option refresh.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST = ''REFRESH''',
'or ( :REQUEST = ''SAVE'' and :P4911_REFERENCE_ID is not null and :P4911_REFERENCE_ID_INIT is null )'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Build option refreshed from the master.'
,p_internal_uid=>4407669879142630
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4412150575904124)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Unsubscribe'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.unsubscribe_component (',
'    p_component_type  => wwv_flow_copy_metadata.c_build_option,',
'    p_component_id    => :F4000_P4911_ID,',
'    p_app_id          => :FB_FLOW_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(4407288716142626)
,p_process_success_message=>'Build Option has been unsubscribed.'
,p_internal_uid=>4412150575904124
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5201414713040702)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(439547742)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Create/Edit Build Options'
,p_internal_uid=>5201414713040702
);
end;
/
prompt --application/pages/page_04912
begin
wwv_flow_imp_page.create_page(
 p_id=>4912
,p_name=>'Copy Build Option'
,p_alias=>'COPY-BUILD-OPTION'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Build Option'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'auto'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_protection_level=>'C'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(50832903690809355)
,p_plug_name=>'Wizard Button'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(235573886338952244)
,p_plug_name=>'Copy Build Option'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4416958501182125)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(50832903690809355)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4410025565904103)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(50832903690809355)
,p_button_name=>'COPY_FROM_ANOTHER'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Copy from another app'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:4912:&SESSION.::&DEBUG.:4912:P4912_COPY_SOURCE:OTHER'
,p_button_condition=>'P4912_COPY_SOURCE'
,p_button_condition2=>'THIS'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_button_css_classes=>'a-Button--noUI'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4417333697182126)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(50832903690809355)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy Build Option'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(4406421421142618)
,p_branch_name=>'Go To Page &F4000_LAST_VIEW.'
,p_branch_action=>'f?p=&APP_ID.:&F4000_LAST_VIEW.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(4417333697182126)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4406641244142620)
,p_name=>'P4912_NEW_PATCH_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(235573886338952244)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(19414037944933833)
,p_name=>'P4912_SUBSCRIBE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(235573886338952244)
,p_item_default=>'Y'
,p_prompt=>'Subscribe'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>'P4912_COPY_SOURCE'
,p_display_when2=>'OTHER'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'While copying the build option, you can also subscribe to it. Set Subscribe to <strong>On</strong> to subscribe to the build option.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(19713636748012430)
,p_name=>'P4912_COPY_SOURCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(235573886338952244)
,p_item_default=>'THIS'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(216081794914874216)
,p_name=>'P4912_COPY_FROM_APPLICATION_ID'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(235573886338952244)
,p_prompt=>'Application'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST OTHER FLOWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'  from   wwv_flow_visible_flows f',
' where id != :FB_FLOW_ID',
'   and build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'order by 2'))
,p_lov_cascade_parent_items=>'P4912_COPY_SOURCE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>'P4912_COPY_SOURCE'
,p_display_when2=>'OTHER'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Select the application from which you want to copy a build option.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(235592296273991600)
,p_name=>'P4912_PATCH_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(235573886338952244)
,p_prompt=>'New Build Option Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the name of the build option. Build option name must be unique within the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(235595612549996306)
,p_name=>'P4912_ID'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(235573886338952244)
,p_prompt=>'Copy Build Option'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select patch_name d, id r',
'  from wwv_flow_patches',
' where flow_id           = :P4912_COPY_FROM_APPLICATION_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
' order by upper(patch_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Build Option -'
,p_lov_cascade_parent_items=>'P4912_COPY_FROM_APPLICATION_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_read_only_when=>'P4912_ID'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify a build option to copy.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'Y'
,p_attribute_06=>'0'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4406383886142617)
,p_validation_name=>'P4912_PATCH_NAME not null'
,p_validation_sequence=>10
,p_validation=>'P4912_PATCH_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>':P4912_COPY_SOURCE = ''THIS'' or :P4912_SUBSCRIBE = ''N'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(4417333697182126)
,p_associated_item=>wwv_flow_imp.id(235592296273991600)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5204659440040734)
,p_validation_name=>'PATCH_NAME unique'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_patches',
' where security_group_id = :FLOW_SECURITY_GROUP_ID ',
'   and flow_id           = :FB_FLOW_ID ',
'   and patch_name        = :P4912_PATCH_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'A build option already exists with the same name. Please enter a different name.'
,p_validation_condition=>':P4912_COPY_SOURCE = ''THIS'' or :P4912_SUBSCRIBE = ''N'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(4417333697182126)
,p_associated_item=>wwv_flow_imp.id(235592296273991600)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5204738641040735)
,p_validation_name=>'No duplicate subscription'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_patches',
' where security_group_id = :FLOW_SECURITY_GROUP_ID ',
'   and flow_id           = :FB_FLOW_ID ',
'   and reference_id      = :P4912_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'There is another build option in this application that is subscribed to the same master. Please select another master build option.'
,p_validation_condition=>'P4912_SUBSCRIBE'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(4417333697182126)
,p_associated_item=>wwv_flow_imp.id(235595612549996306)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4405005942142604)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(4416958501182125)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4405132889142605)
,p_event_id=>wwv_flow_imp.id(4405005942142604)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4406036514142614)
,p_name=>'Toggle P4912_PATCH_NAME display'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4912_SUBSCRIBE'
,p_condition_element=>'P4912_SUBSCRIBE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_cond=>'P4912_COPY_SOURCE'
,p_display_when_cond2=>'OTHER'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4406114799142615)
,p_event_id=>wwv_flow_imp.id(4406036514142614)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4912_PATCH_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4406200740142616)
,p_event_id=>wwv_flow_imp.id(4406036514142614)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4912_PATCH_NAME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3005194745333549)
,p_name=>'Set New Name'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P4912_ID'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_cond=>'P4912_COPY_SOURCE'
,p_display_when_cond2=>'OTHER'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3005262218333550)
,p_event_id=>wwv_flow_imp.id(3005194745333549)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P4912_PATCH_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'apex.item("P4912_ID").displayValueFor($v("P4912_ID"))'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4406504608142619)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Build Option'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P4912_NEW_PATCH_ID := wwv_flow_copy_metadata.copy_component (',
'    p_component_type       => wwv_flow_copy_metadata.c_build_option,',
'    p_from_id              => :P4912_ID,',
'    p_from_app_id          => :P4912_COPY_FROM_APPLICATION_ID,',
'    p_to_app_id            => :FB_FLOW_ID,',
'    p_new_name             => :P4912_PATCH_NAME,',
'    p_subscribe            => :P4912_SUBSCRIBE = ''Y'' );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to copy the build option.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(4417333697182126)
,p_process_success_message=>'Build Option copied.'
,p_internal_uid=>4406504608142619
);
end;
/
prompt --application/pages/page_05100
begin
wwv_flow_imp_page.create_page(
 p_id=>5100
,p_name=>'Create Summary Page - Page Attributes'
,p_alias=>'CREATE-SUMMARY-PAGE-PAGE-ATTRIBUTES'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Summary Page'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(214168830839927421)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_pg.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8598000754817441)
,p_plug_name=>'Identify Page Attributes'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>5000
,p_plug_query_num_rows_type=>'0'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'L:C:C:C:C:C'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<p>Use this wizard to create or extend a summary page.  A summary page displays a read only representation of items from other pages.  Summary pages are typically used for confirmation wizards.  The source page is the page that contains the items to '
||'be shown as display-only items on the summary page. If a summary page already exists, enter a page or select from the popup search. To create a new summary page, enter a new page and specify a page name.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8781222616974433)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(8771208191950732)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(204699818789801481)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>160
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8787124180988585)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(204699818789801481)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8791617038995945)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(204699818789801481)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(699461649385656036)
,p_button_sequence=>5
,p_button_plug_id=>wwv_flow_imp.id(204699818789801481)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:2500:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(8792032586995947)
,p_branch_name=>'Skip Navigation Menu / Tabs'
,p_branch_action=>'5105'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(8791617038995945)
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow_wizard_api.page_exists (p_flow_id => :fb_flow_id, p_page_id => :F4000_P5100_PAGE_ID) = true'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(12343123418191418)
,p_branch_name=>'Navigation Menu / Tabs'
,p_branch_action=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.:RP:P4716_PREV_PAGE_ID:&APP_PAGE_ID.:&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(8791617038995945)
,p_branch_sequence=>40
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow_wizard_api.page_exists (p_flow_id => :fb_flow_id, p_page_id => :F4000_P5100_PAGE_ID) = false'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(122275014083513804)
,p_branch_action=>'f?p=&APP_ID.:5100:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>50
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'P5100_BREADCRUMB_ID'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7586415417512335)
,p_name=>'F4000_P5100_PREV_SRC_PAGE_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(8598000754817441)
,p_prompt=>'P5100 Prev Src Page Id'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8614626153866490)
,p_name=>'F4000_P5100_PAGE_ID'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(8598000754817441)
,p_prompt=>'Page Number'
,p_source=>'wwv_flow_utilities.minimum_free_page(v(''FB_FLOW_ID''),1)'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>10
,p_cMaxlength=>2000
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.page_exists (p_flow_id => :FB_FLOW_ID,',
'                                 p_page_id => :F4000_P5100_PAGE_ID)'))
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a new page number.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8744303281892238)
,p_name=>'F4000_P5100_PAGE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(8598000754817441)
,p_prompt=>'Page Name'
,p_source=>'wwv_flow_lang.system_message(p_name=>''F4000_P5100_PAGE_NAME'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a page name for a new summary page, the name for an existing summary page will not change.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8865915363144954)
,p_name=>'F4000_P5100_SRC_PAGE_ID'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_imp.id(8598000754817441)
,p_prompt=>'Source Page'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST PAGES ESCAPED'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id || '' '' || wwv_flow_escape.html( name ) n, id',
'  from wwv_flow_steps',
' where flow_id           = nvl( :FB_FLOW_ID, :P164_APPLICATION )',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and is_page_pattern   = ''N''',
' order by 2'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Page -'
,p_lov_null_value=>'%null%'
,p_cSize=>32
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select page that contains items to be shown on summary page'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(45246131772546431)
,p_name=>'P5100_PAGE_MODE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(8598000754817441)
,p_item_default=>'NORMAL'
,p_prompt=>'Page Mode'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'DIALOG_PAGE_MODE_CREATE_WIZARD'
,p_lov=>'.'||wwv_flow_imp.id(1497542689968615899)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_read_only_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return not wwv_flow_user_interface_dev.dialog_page_template_exists(',
'                     p_application_id     => :FB_FLOW_ID ); '))
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Identify the page mode, based on the following options: <p/>',
'<ul>',
'<li><strong>Normal</strong>: The page is presented as a normal &PRODUCT_NAME. application page.</li>',
'<li><strong>Modal Dialog</strong>: The page is presented as a modal dialog. A modal dialog is an overlay window positioned within the viewport, which remains active and focused until the end user dismisses (closes) it. The underlying page is grayed o'
||'ut and the end user is prevented from interacting with the rest of the page until the dialog is closed.</li></ul>',
'<br><p>',
'Note that the Modal Dialog option will only be available for selection where the current application theme contains at least one page template of template type <strong>Dialog Page</strong>.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
,p_attribute_04=>'VERTICAL'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(122273620878506380)
,p_name=>'P5100_BREADCRUMB_ID'
,p_data_type=>'NUMBER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(8598000754817441)
,p_item_default=>'0'
,p_prompt=>'Breadcrumb'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATION.MENUS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) name,',
'       id',
'  from wwv_flow_menus',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- do not add breadcrumb region to page -'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.page_exists (p_flow_id => :fb_flow_id, p_page_id => :F4000_P5100_PAGE_ID) = false',
'and',
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select whether you want to use a breadcrumb navigation control on your page, and which breadcrumb navigation control you want to use.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(122277027155518222)
,p_name=>'P5100_BREADCRUMB_NAME'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(8598000754817441)
,p_prompt=>'Entry Name'
,p_source=>'F4000_P5100_PAGE_NAME'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>4000
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify the name of the breadcrumb entry.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(381730383902045547)
,p_name=>'P5100_BREADCRUMB_PARENT_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(8598000754817441)
,p_prompt=>'Parent Entry'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov_language=>'PLSQL'
,p_lov=>'return wwv_flow_4000_ui.breadcrumb_parent_lov_sql( p_breadcrumb_item_name => ''P5100_BREADCRUMB_ID'' )'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'No parent entry'
,p_lov_cascade_parent_items=>'P5100_BREADCRUMB_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.supports_breadcrumbs (',
'    p_application_id    => :FB_FLOW_ID )'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(403516230632685401)
,p_name=>'P5100_GROUP_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(8598000754817441)
,p_prompt=>'Page Group'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE GROUP (RETURNS NAME)'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(group_name) d, group_name r ',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id',
'order by upper(group_name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Page Group -'
,p_cHeight=>1
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'from wwv_flow_page_groups ',
'where flow_id = :fb_flow_id ',
'and security_group_id = :flow_security_group_id'))
,p_display_when_type=>'EXISTS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Identify the name of the page group you would like to associate with this page. Page groups help developers manage the pages within an application. To create a page group, enter the name.  To use an existing page group, select the name from the list '
||'of values.',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(10248518797082293)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P5105_SRC_REGION'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'0'
,p_computation_error_message=>'Unable to compute item value.'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1941058841116438792)
,p_computation_sequence=>60
,p_computation_item=>'P4716_NAVLIST_ENTRY_NAME'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'F4000_P5100_PAGE_NAME'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(7631102078170839)
,p_computation_sequence=>10
,p_computation_item=>'F4000_P5100_PREV_SRC_PAGE_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>':F4000_P5100_SRC_PAGE_ID'
,p_computation_error_message=>'Unable to compute item value.'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(9118702944366261)
,p_validation_name=>'SOURCE_PAGE_ID_NOT_NULL'
,p_validation_sequence=>1
,p_validation=>'F4000_P5100_SRC_PAGE_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Source Page must be specified.'
,p_associated_item=>wwv_flow_imp.id(8865915363144954)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(144944129193057216)
,p_validation_name=>'F4000_P5100_PAGE_ID  positive, whole number'
,p_validation_sequence=>1
,p_validation=>'F4000_P5100_PAGE_ID'
,p_validation2=>'^[0-9]*$'
,p_validation_type=>'REGULAR_EXPRESSION'
,p_error_message=>'Page Number must be a positive, whole number.'
,p_when_button_pressed=>wwv_flow_imp.id(8791617038995945)
,p_associated_item=>wwv_flow_imp.id(8614626153866490)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 05-AUG-2003 09:52'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(144944325332057220)
,p_validation_name=>'F4000_P5100_PAGE_NAME Not Null'
,p_validation_sequence=>2
,p_validation=>'F4000_P5100_PAGE_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Summary Page Name must be specified.'
,p_associated_item=>wwv_flow_imp.id(8744303281892238)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
,p_validation_comment=>'generated 05-AUG-2003 09:52'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(45246628321548010)
,p_validation_name=>'P5100_PAGE_MODE Not Null'
,p_validation_sequence=>3
,p_validation=>'P5100_PAGE_MODE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Page Mode must be specified.'
,p_when_button_pressed=>wwv_flow_imp.id(8791617038995945)
,p_associated_item=>wwv_flow_imp.id(45246131772546431)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_validation_comment=>'generated 10-MAR-2001 11:10'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(70475623184954674)
,p_validation_name=>'has_items'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_step_items',
'where flow_step_id = replace(:F4000_P5100_SRC_PAGE_ID,''%''||''null%'',null)',
'and flow_id = :FB_FLOW_ID'))
,p_validation_type=>'EXISTS'
,p_error_message=>'No items found on page selected.'
,p_validation_condition=>'F4000_P5100_SRC_PAGE_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(8791617038995945)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(9121515225375700)
,p_validation_name=>'SOURCE_PAGE_ID_EXISTS'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 from wwv_flow_steps',
'',
'where flow_id = :FB_FLOW_ID',
'',
'and id = :F4000_P5100_SRC_PAGE_ID'))
,p_validation_type=>'EXISTS'
,p_error_message=>'Source Page ID must be a valid page ID.'
,p_validation_condition=>'F4000_P5100_SRC_PAGE_ID'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_imp.id(8865915363144954)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(138696220035702532)
,p_validation_name=>'ok to add breadcrumb'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      select 1',
'      from wwv_flow_page_plugs',
'      where flow_id = :fb_flow_id',
'      and   page_id = :F4000_P5100_PAGE_ID',
'      and   menu_id is not null',
'      and   nvl(:P5100_BREADCRUMB_ID,0)<>0'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'The page specified already has a breadcrumb region.'
,p_when_button_pressed=>wwv_flow_imp.id(8791617038995945)
,p_associated_item=>wwv_flow_imp.id(122273620878506380)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(403516792027687440)
,p_validation_name=>'Validate Group Name'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_utilities.is_valid_page_group_name (',
'  p_name => :P5100_GROUP_NAME);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'P5100_GROUP_NAME'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(8791617038995945)
,p_associated_item=>wwv_flow_imp.id(403516230632685401)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(381731076631052149)
,p_name=>'Breadcrumb options'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P5100_BREADCRUMB_ID'
,p_condition_element=>'P5100_BREADCRUMB_ID'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(381731326560052149)
,p_event_id=>wwv_flow_imp.id(381731076631052149)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P5100_BREADCRUMB_NAME,P5100_BREADCRUMB_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(381731575436052149)
,p_event_id=>wwv_flow_imp.id(381731076631052149)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P5100_BREADCRUMB_NAME,P5100_BREADCRUMB_PARENT_ID'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(549187397672939024)
,p_name=>'Cancel Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(8787124180988585)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(549187606052939024)
,p_event_id=>wwv_flow_imp.id(549187397672939024)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(699437523366200411)
,p_name=>'Page Exists'
,p_event_sequence=>40
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_wizard_api.page_exists (p_flow_id => :FB_FLOW_ID,',
'                                 p_page_id => :F4000_P5100_PAGE_ID)'))
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(699437832070200412)
,p_event_id=>wwv_flow_imp.id(699437523366200411)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P5100_PAGE_MODE,P5100_GROUP_NAME,P5100_BREADCRUMB_ID,P5100_BREADCRUMB_PARENT_ID,P5100_BREADCRUMB_NAME,F4000_P5100_PAGE_NAME'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1941059144529440365)
,p_name=>'set region name'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'F4000_P5100_PAGE_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1941059549021440366)
,p_event_id=>wwv_flow_imp.id(1941059144529440365)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P5100_BREADCRUMB_NAME'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':F4000_P5100_PAGE_NAME'
,p_attribute_07=>'F4000_P5100_PAGE_NAME'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2337319753250933)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'CLEAR_CACHE'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'5105:5110'
,p_internal_uid=>2337319753250933
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(7614715444089544)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'clear collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_collection.create_or_truncate_collection(',
'      p_collection_name => ''SUMMARY_ITEM'');'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>':F4000_P5100_SRC_PAGE_ID != :F4000_P5100_PREV_SRC_PAGE_ID'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>7614715444089544
);
end;
/
prompt --application/pages/page_05105
begin
wwv_flow_imp_page.create_page(
 p_id=>5105
,p_name=>'Create Summary Page - Item Attributes'
,p_alias=>'CREATE-SUMMARY-PAGE-ITEM-ATTRIBUTES'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Summary Page'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(214168830839927421)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8881521352202994)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(8771208191950732)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8887931654258960)
,p_plug_name=>'Identify Item Attributes'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_query_num_rows=>5000
,p_plug_query_num_rows_type=>'0'
,p_plug_query_show_nulls_as=>'(null)'
,p_plug_query_col_allignments=>'L:C:C:C:C:C'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Items can be copied to the summary page as display-only items from all regions of the source page or only the region specified in ''Source Region''.  Items can be copied to a new region on the summary page, or - if an existing page was selected - to'
||' any of the regions defined on that page.  The label and field attribute definitions of the source items can be maintained or overwritten by changing alignment and template usage.</p>',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(204703424938822175)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8995431011984066)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(204703424938822175)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(9132913489414281)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(204703424938822175)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(8998725255991869)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(204703424938822175)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(8981129774715655)
,p_branch_action=>'5105'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'F4000_P5105_SRC_REGION'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(9133306570414283)
,p_branch_action=>'5110'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(9132913489414281)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(8999106624991871)
,p_branch_action=>'5100'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(8998725255991869)
,p_branch_sequence=>40
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow_wizard_api.page_exists (p_flow_id => :fb_flow_id, p_page_id => :F4000_P5100_PAGE_ID) = true'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(272569925883335510)
,p_branch_name=>'Skip Navigation Menu / Tabs'
,p_branch_action=>'5100'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(8998725255991869)
,p_branch_sequence=>15
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow_wizard_api.page_exists (p_flow_id => :fb_flow_id, p_page_id => :F4000_P5100_PAGE_ID) = true'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(12349808322198476)
,p_branch_name=>'Navigation Menu / Tabs'
,p_branch_action=>'f?p=&APP_ID.:4716:&SESSION.::&DEBUG.:RP:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_VALIDATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(8998725255991869)
,p_branch_sequence=>20
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>'wwv_flow_wizard_api.page_exists (p_flow_id => :fb_flow_id, p_page_id => :F4000_P5100_PAGE_ID) = false'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2080410972521915)
,p_name=>'F4000_P5105_FIELD_TEMPLATE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(8887931654258960)
,p_prompt=>'Label Template'
,p_source=>'select DEFAULT_LABEL_TEMPLATE from wwv_flow_themes where flow_id = :fb_flow_id and theme_id = :fb_theme_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'FIELDTEMPLATE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(template_name) d, id',
'from   wwv_flow_field_templates',
'where  flow_id = :fb_flow_id and ',
'       (:fb_theme_id is null or theme_id = :fb_theme_id)',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Same as Source Item'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>A label field template allows you to identify a shared definition of how a field label is to be displayed.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2108924509576442)
,p_name=>'F4000_P5105_LABEL_ALIGNMENT'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(8887931654258960)
,p_prompt=>'Label&nbsp;Align'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LABEL_ALIGNMENT'
,p_lov=>'.'||wwv_flow_imp.id(84757522618851451)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Same as Source Item'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'This attribute controls where the label is displayed.  Labels displayed "ABOVE" are shown in the same HTML table cell as the item.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2123126198621219)
,p_name=>'F4000_P5105_TAG_ATTRIBUTES'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(8887931654258960)
,p_prompt=>'Field Attributes '
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct TAG_ATTRIBUTES d, TAG_ATTRIBUTES v',
'from   wwv_flow_step_items',
'where  flow_id = :fb_flow_id',
'order by 1'))
,p_cSize=>25
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'For each type of tag, add the following text inside the tag generated. This allows for the insertion of JavaScript. Be careful that your code does not conflict with generated JavaScript. This has been implemented for item types of TEXT, TEXTAREA, FIL'
||'E and PASSWORD. Buttons (not displayed as images) also support tab attributes.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2128920362639158)
,p_name=>'F4000_P5105_FIELD_ALIGNMENT'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(8887931654258960)
,p_prompt=>'Field&nbsp;Align'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'FIELD_ALIGNMENT'
,p_lov=>'.'||wwv_flow_imp.id(84354125395660958)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Same as Source Item'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Use this attribute with other display attributes to control how each item is displayed on the page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2272517720099890)
,p_name=>'F4000_P5105_REGION_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(8887931654258960)
,p_item_default=>'replace(wwv_flow_lang.system_message(''F4350_SUMMARY''),'':'',null)'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Region Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify region name for new regions, if existing region is selected, the name will not be changed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2275808446104241)
,p_name=>'F4000_P5105_REGION_TEMPLATE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(8887931654258960)
,p_prompt=>'Region Template'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select default_region_template ',
'  from wwv_flow_themes ',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID ',
'   and theme_id          = :FB_THEME_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REGION.TEMPLATES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.d, ',
'       t.r ',
'  from ( select wwv_flow_escape.html(page_plug_template_name) d, ',
'             id r',
'           from wwv_flow_page_plug_templates',
'          where security_group_id = :FLOW_SECURITY_GROUP_ID',
'            and flow_id           = :FB_FLOW_ID',
'            and (:FB_THEME_ID is null or theme_id = :FB_THEME_ID)',
'          order by upper(page_plug_template_name) ) t'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'No Template'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select region template for summary region.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2319414386223038)
,p_name=>'F4000_P5105_REGION_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(8887931654258960)
,p_prompt=>'Summary Region'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select plug_name || '' ('' || plug_display_sequence || '')'' as d, ',
'       id',
'  from wwv_flow_page_plugs',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and page_id           = :F4000_P5100_PAGE_ID',
' order by plug_display_sequence'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'New Region'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a region for the summary page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8894520643279237)
,p_name=>'F4000_P5105_PAGE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(8887931654258960)
,p_prompt=>'Summary Page:'
,p_source=>':F4000_P5100_PAGE_ID || '' - '' || :F4000_P5100_PAGE_NAME'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'This is the summary page you specified.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8900025363307421)
,p_name=>'F4000_P5105_SRC_PAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(8887931654258960)
,p_prompt=>'Source Page:'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id || '' - '' || name',
'  from wwv_flow_steps',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and id                = :F4000_P5100_SRC_PAGE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'This is the source page you specified.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(8958022300627958)
,p_name=>'F4000_P5105_SRC_REGION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(8887931654258960)
,p_item_default=>'0'
,p_prompt=>'Source Region'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select plug_name || '' ('' || plug_display_sequence || '')'' as d,',
'       id',
'  from wwv_flow_page_plugs',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and page_id           = :F4000_P5100_SRC_PAGE_ID',
' order by plug_display_sequence'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'All Regions'
,p_lov_null_value=>'0'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select region to limit list of items to specific region'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(165232800939462897)
,p_computation_sequence=>10
,p_computation_item=>'FB_THEME_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_user_interface_dev.get_current_theme_id (',
'    p_application_id    => :FB_FLOW_ID )'))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(144955300413096219)
,p_validation_name=>'RegionNameMandWhenNewRegion'
,p_validation_sequence=>20
,p_validation=>'F4000_P5105_REGION_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Region Name must be specified.'
,p_validation_condition=>'F4000_P5105_REGION_ID'
,p_validation_condition_type=>'ITEM_IS_NULL'
,p_when_button_pressed=>wwv_flow_imp.id(9132913489414281)
,p_associated_item=>wwv_flow_imp.id(2272517720099890)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(549187996964946924)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(8995431011984066)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(549188267783946925)
,p_event_id=>wwv_flow_imp.id(549187996964946924)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
end;
/
prompt --application/pages/page_05110
begin
wwv_flow_imp_page.create_page(
 p_id=>5110
,p_name=>'Create Summary Page - Summary Items'
,p_alias=>'CREATE-SUMMARY-PAGE-SUMMARY-ITEMS'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Summary Page'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(214168830839927421)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(2260526790080521)
,p_name=>'Select items to include in summary page'
,p_template=>wwv_flow_imp.id(42025417508627628)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_new_grid_row=>false
,p_display_column=>1
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with collection_values as (',
'    select c005 item_id,',
'           c001 unordered_checked,',
'           c002 item_name,',
'           c003 display_as,',
'           c004 plug_name',
'      from wwv_flow_collections',
'     where collection_name = ''SUMMARY_ITEM'' ),',
'collection_values_checked as (',
'    select item_id,',
'           ( select c2.unordered_checked',
'               from collection_values c2',
'              where c1.item_id = c2.unordered_checked ) item_id_checked,',
'           item_name,',
'           display_as,',
'           plug_name',
'      from collection_values c1 ),',
'item_values as (',
'    select to_char(i.id) item_id,',
'           null          item_id_checked,',
'           i.name        item_name,',
'           i.display_as  display_as,',
'           p.plug_name   plug_name',
'      from wwv_flow_step_items i,',
'           wwv_flow_page_plugs p',
'     where i.item_plug_id      = p.id',
'       and i.flow_step_id      = :F4000_P5100_SRC_PAGE_ID',
'       and i.security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and p.security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and i.flow_id           = :FB_FLOW_ID',
'       and i.display_as not in ( ''NATIVE_HIDDEN'',',
'                                 ''NATIVE_DISPLAY_IMAGE'',',
'                                 ''NATIVE_PASSWORD'',',
'                                 ''NATIVE_STOP_AND_START_HTML_TABLE'' )',
'       and (nvl(:F4000_P5105_SRC_REGION,0) = 0 or i.item_plug_id = :F4000_P5105_SRC_REGION)',
'     order by p.plug_display_sequence, i.item_sequence ),',
'columns as (',
'    select *',
'      from collection_values_checked',
'     union all',
'    select *',
'      from item_values',
'     where not exists ( select null from collection_values_checked ))',
'select wwv_flow_item.checkbox(1,item_id,''title="''||wwv_flow_lang.system_message(''INCLUDE_LABEL'',item_name)||''"'',item_id_checked) c,',
'       wwv_flow_item.display_and_save(2,item_name) n,',
'       wwv_flow_item.hidden(3,display_as)||',
'       wwv_flow_item.text_from_lov (',
'           display_as,',
'           ''ITEM_TYPES (REQUIRES APPLICATION CONTEXT)'' ) dl,',
'       wwv_flow_item.display_and_save(4,plug_name) p,',
'       wwv_flow_item.hidden(5,item_id) id',
'  from columns'))
,p_header=>'<p>Select items to include in summary page. All checked items will be copied to the summary page, the display type will be translated into display-only text, or display-only LOV for all LOV source items.</p>'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>100
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_break_cols=>'0'
,p_query_num_rows_type=>'ROW_RANGES_WITH_LINKS'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_query_asc_image=>'blue_arrow_down.gif'
,p_query_desc_image=>'blue_arrow_up.gif'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48527607412770638)
,p_query_column_id=>1
,p_column_alias=>'C'
,p_column_display_sequence=>1
,p_column_heading=>'&nbsp;'
,p_use_as_row_header=>'N'
,p_column_alignment=>'CENTER'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48527729248770638)
,p_query_column_id=>2
,p_column_alias=>'N'
,p_column_display_sequence=>2
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(274033123105742648)
,p_query_column_id=>3
,p_column_alias=>'DL'
,p_column_display_sequence=>3
,p_column_heading=>'Display'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48527901834770639)
,p_query_column_id=>4
,p_column_alias=>'P'
,p_column_display_sequence=>4
,p_column_heading=>'Region'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(48528015058770639)
,p_query_column_id=>5
,p_column_alias=>'ID'
,p_column_display_sequence=>5
,p_column_heading=>'&nbsp;'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9174523536493468)
,p_plug_name=>'Navigation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(8771208191950732)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(204705432342833768)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(9177207050497577)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(204705432342833768)
,p_button_name=>'Cancel'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(9187008912507569)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(204705432342833768)
,p_button_name=>'Next'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(9247013470612899)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(204705432342833768)
,p_button_name=>'Previous'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(9187401298507571)
,p_branch_action=>'303'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(9187008912507569)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(9182831134502213)
,p_branch_action=>'5105'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(9247013470612899)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2388118408844121)
,p_name=>'F4000_P5110_SRC_PAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2260526790080521)
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id || '' - '' || name',
'  from wwv_flow_steps',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and id                = :F4000_P5100_SRC_PAGE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'This is the summary page you specified.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2393100939852195)
,p_name=>'F4000_P5110_PAGE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2260526790080521)
,p_source=>':F4000_P5100_PAGE_ID || '' - '' || :F4000_P5100_PAGE_NAME'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'This is the source page you specified.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2412912523922790)
,p_validation_name=>'ITEM_SELECTED'
,p_validation_sequence=>10
,p_validation=>'wwv_flow.g_f01.count > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'At least one item needs to be specified for summary.'
,p_validation_condition=>'Next'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(549716605498753327)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(9177207050497577)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(549716703224753328)
,p_event_id=>wwv_flow_imp.id(549716605498753327)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(7577401144252723)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'create collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  function array_element( ',
'      p_vcarr in wwv_flow_global.vc_arr2,',
'      p_index in number )',
'      return varchar2',
'  is',
'      l_return_value varchar2(4000) := NULL;',
'  begin',
'      if p_vcarr is not null then',
'          l_return_value := substr(p_vcarr( p_index ), 1, 4000);',
'      end if;',
'      return l_return_value;  ',
'  exception',
'      when others then',
'          return NULL;',
'  end;',
'begin',
'  wwv_flow_collection.create_or_truncate_collection(',
'      p_collection_name => ''SUMMARY_ITEM'');',
'  ',
'  for i in 1..wwv_flow.g_f05.count',
'  loop    ',
'    wwv_flow_collection.add_member(',
'        p_collection_name => ''SUMMARY_ITEM'',',
'        p_c001            => array_element(wwv_flow.g_f01,i),',
'        p_c002            => wwv_flow.g_f02(i),',
'        p_c003            => wwv_flow.g_f03(i),',
'        p_c004            => wwv_flow.g_f04(i),',
'        p_c005            => wwv_flow.g_f05(i));',
'  end loop; ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error creating summary item collection.'
,p_internal_uid=>7577401144252723
);
end;
/
prompt --application/pages/page_05300
begin
wwv_flow_imp_page.create_page(
 p_id=>5300
,p_name=>'Identify Changes for Merging'
,p_alias=>'IDENTIFY-CHANGES-FOR-MERGING'
,p_step_title=>'Identify Changes for Merging'
,p_autocomplete_on_off=>'OFF'
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.stickyWidget#MIN#.js?v=#APEX_VERSION#',
'#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#f4000_p5300#MIN#.js'))
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(function($) {',
'',
'  $(".a-PageWizard-buttons")',
'    .stickyWidget({',
'      isFooter: true,',
'      toggleWidth: true',
'    });',
'',
'})(apex.jQuery);'))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.pageTitle {',
'  text-align: center;',
'  padding-block: 40px;',
'}',
'',
'.a-CardView-header {',
'  --a-cv-header-border-width: 0px;',
'',
'  justify-items: center;',
'}',
'',
'.a-IRR .b-Badge {',
'  --ab-badge-display: block;',
'  ',
'  text-align: center;',
'}',
'',
'#INFO .u-Processing,',
'#DIFF_OVERVIEW .u-Processing {',
'  display: none;',
'}',
'',
'.a-SystemMessage a {',
'  text-decoration: underline;',
'}',
'',
'.a-Wizard-body {',
'    position: relative;',
'}',
'',
'.a-PageWizard-buttons {',
'    margin: 0;',
'    padding-block: 16px;',
'    transition: .15s ease;',
'}',
'',
'.a-PageWizard-buttons .a-Button {',
'    --a-icon-size: 20px;',
'',
'    display: inline-flex;',
'    align-items: center;',
'}'))
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(74845831538733642)
,p_page_component_map=>'23'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1384130138308002)
,p_plug_name=>'Hidden Items'
,p_plug_display_sequence=>10
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3155083522834735)
,p_plug_name=>'Wizard Buttons'
,p_region_css_classes=>'a-PageWizard-buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>60
,p_translate_title=>'N'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P5300_COMPARE_ONLY'
,p_plug_display_when_cond2=>'Y'
,p_landmark_type=>'exclude_landmark'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(292978814960744902)
,p_plug_name=>'Button Container'
,p_parent_plug_id=>wwv_flow_imp.id(3155083522834735)
,p_region_css_classes=>'a-ButtonRegion--noPadding'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_landmark_type=>'exclude_landmark'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3372976219152815)
,p_plug_name=>'Differences'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_landmark_type=>'region'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1384510544308006)
,p_plug_name=>'Differences Report'
,p_parent_plug_id=>wwv_flow_imp.id(3372976219152815)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>40
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'    case component_status',
'    when ''MISSING'' then null',
'    else',
'        wwv_flow_working_copy_dev.add_encoded_checkbox (',
'            p_component_type           => component_type,',
'            p_component_id             => component_id,',
'            p_component_type_label     => component_type_label,',
'            p_component_display_name   => component_display_name,',
'            p_status                   => component_status,',
'            p_rownum                   => rownum ) ',
'    end as sel,',
'    v.*',
'from ( ',
'    select r.component_id,',
'           l.seq_id  as export_left_id,',
'           r.seq_id  as export_right_id,',
'           r.file_name,',
'           r.component_type,',
'           r.component_type_label,',
'           r.component_display_name,',
'           null as link,',
'           r.component_export_id,',
'           ''CHANGED'' as component_status,',
'           wwv_flow_lang_dev.builder_message( p_name => ''APEXDEV.DIFF.CHANGED'' ) as component_status_display,',
'           l.offset_component_id as left_offset_comp_id,',
'           r.offset_component_id as right_offset_comp_id,',
'           ''info'' as badge_state',
'      from wwv_flow_diff_export_left_dev l,',
'           wwv_flow_diff_export_right_dev r',
'     where l.offset_component_id = r.offset_component_id',
'       and l.component_type      = r.component_type',
'       and l.diff_checksum      != r.diff_checksum',
'    union all',
'    /* new components that exist in the right app but not in the left */',
'    select r.component_id,',
'           null      as export_left_id,',
'           r.seq_id as export_right_id,',
'           r.file_name,',
'           r.component_type,',
'           r.component_type_label,',
'           r.component_display_name,',
'           null as link,',
'           r.component_export_id,',
'           ''ADDED'' as component_status,',
'           wwv_flow_lang_dev.builder_message( p_name => ''APEXDEV.DIFF.ADDED'' ) as component_status_display,',
'           null as left_offset_comp_id,',
'           r.offset_component_id as right_offset_comp_id,',
'           ''success'' as badge_state',
'      from wwv_flow_diff_export_right_dev r,',
'           wwv_flow_diff_export_left_dev l',
'     where l.component_type      (+) = r.component_type',
'       and l.offset_component_id (+) = r.offset_component_id',
'       and l.component_type is null',
'       and l.offset_component_id is null',
'       and not exists (',
'           /* ignore list items when the list is being created/new */',
'           select null',
'             from wwv_flow_list_items',
'            where list_id in (select ir.component_id ',
'                                from wwv_flow_diff_export_right_dev ir',
'                               where ir.component_type = ''LIST''',
'                                and not exists',
'                                       ( select null ',
'                                           from wwv_flow_diff_export_left_dev il',
'                                          where il.component_type      = ir.component_type',
'                                            and il.offset_component_id = ir.offset_component_id',
'                                       )                         ',
'                            )',
'              and id                = r.component_id',
'              and security_group_id = :WORKSPACE_ID',
'       )',
'    union all',
'    /* components that exist in the left app but not in the right (might have been deleted or merged in from another app) */',
'    select l.component_id,',
'           l.seq_id  as export_left_id,',
'           null      as export_right_id,',
'           l.file_name,',
'           l.component_type,',
'           l.component_type_label,',
'           l.component_display_name,',
'           null as link,',
'           l.component_export_id,',
'           ''MISSING'' as component_status,',
'           wwv_flow_lang_dev.builder_message( p_name => ''APEXDEV.DIFF.MISSING'' ) as component_status_display,',
'           l.offset_component_id as left_offset_comp_id,',
'           null as right_offset_comp_id,',
'           ''danger'' as badge_state',
'      from wwv_flow_diff_export_left_dev l,',
'           wwv_flow_diff_export_right_dev r',
'     where l.component_type         = r.component_type (+)',
'       and l.offset_component_id    = r.offset_component_id (+)',
'       and nvl(:P5300_REVERSE, ''N'') = ''N''',
'       and r.component_type is null',
'       and r.offset_component_id is null',
') v',
'order by component_type_label, component_display_name'))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P5300_REVERSE'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Differences'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(1385544900308016)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'There are no differences found!'
,p_show_search_bar=>'N'
,p_report_list_mode=>'TABS'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_enable_mail_download=>'Y'
,p_owner=>'ADMIN'
,p_internal_uid=>1385544900308016
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1385675542308017)
,p_db_column_name=>'SEL'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'<label for="check-all-rows" class="hideMeButHearMe">Check All</label><input type="checkbox" id="check-all-rows" onclick="$f_CheckFirstColumn(this)" />'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'WITHOUT_MODIFICATION'
,p_column_alignment=>'CENTER'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_display_condition=>'P5300_COMPARE_ONLY'
,p_display_condition2=>'Y'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3894297008699002)
,p_db_column_name=>'COMPONENT_STATUS_DISPLAY'
,p_display_order=>15
,p_column_identifier=>'Y'
,p_column_label=>'Status'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'TMPL_THEME_3$BADGE'
,p_column_alignment=>'CENTER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'LABEL_DISPLAY', 'N',
  'STATE', 'BADGE_STATE',
  'VALUE', 'COMPONENT_STATUS_DISPLAY')).to_clob
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1386488474308025)
,p_db_column_name=>'LINK'
,p_display_order=>60
,p_column_identifier=>'I'
,p_column_label=>'Diff'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'TMPL_THEME_3$ACTIONS'
,p_column_alignment=>'CENTER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'ACTIONS_WRAP', 'N',
  'STYLE', 'b-InlineActions--simple')).to_clob
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3372267000152808)
,p_db_column_name=>'FILE_NAME'
,p_display_order=>80
,p_column_identifier=>'P'
,p_column_label=>'File Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3603499866086144)
,p_db_column_name=>'EXPORT_LEFT_ID'
,p_display_order=>90
,p_column_identifier=>'J'
,p_column_label=>'Export Left Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3603582834086145)
,p_db_column_name=>'EXPORT_RIGHT_ID'
,p_display_order=>100
,p_column_identifier=>'K'
,p_column_label=>'Export Right Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2114979826188811)
,p_db_column_name=>'COMPONENT_TYPE_LABEL'
,p_display_order=>110
,p_column_identifier=>'S'
,p_column_label=>'Component Type'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2115086298188812)
,p_db_column_name=>'COMPONENT_DISPLAY_NAME'
,p_display_order=>120
,p_column_identifier=>'T'
,p_column_label=>'Component Name'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3374697952152832)
,p_db_column_name=>'COMPONENT_TYPE'
,p_display_order=>130
,p_column_identifier=>'V'
,p_column_label=>'Type'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3374300352152829)
,p_db_column_name=>'COMPONENT_EXPORT_ID'
,p_display_order=>140
,p_column_identifier=>'Q'
,p_column_label=>'Type / ID'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
,p_column_comment=>'Used for debugging purposes'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2115181929188813)
,p_db_column_name=>'COMPONENT_STATUS'
,p_display_order=>150
,p_column_identifier=>'U'
,p_column_label=>'Status'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4261405922379349)
,p_db_column_name=>'LEFT_OFFSET_COMP_ID'
,p_display_order=>160
,p_column_identifier=>'W'
,p_column_label=>'Left Offset Comp Id'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4261565634379350)
,p_db_column_name=>'RIGHT_OFFSET_COMP_ID'
,p_display_order=>170
,p_column_identifier=>'X'
,p_column_label=>'Right Offset Comp Id'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4086592710729912)
,p_db_column_name=>'BADGE_STATE'
,p_display_order=>190
,p_column_identifier=>'Z'
,p_column_label=>'Badge State'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4088661219729933)
,p_db_column_name=>'COMPONENT_ID'
,p_display_order=>200
,p_column_identifier=>'AA'
,p_column_label=>'Component Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(3586703646772446)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'35868'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_display_rows=>1000
,p_report_columns=>'SEL:COMPONENT_STATUS_DISPLAY:COMPONENT_TYPE_LABEL:COMPONENT_DISPLAY_NAME:COMPONENT_EXPORT_ID:LINK:'
,p_sort_column_1=>'COMPONENT_TYPE_LABEL'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'COMPONENT_DISPLAY_NAME'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3152898246834713)
,p_plug_name=>'Differences Overview'
,p_region_name=>'DIFF_OVERVIEW'
,p_parent_plug_id=>wwv_flow_imp.id(3372976219152815)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang_dev.builder_message(''APEXDEV.DIFF.CHANGED'', count(*)) as status_count,',
'       ''CHANGED'' as status',
'  from wwv_flow_diff_export_left_dev l,',
'       wwv_flow_diff_export_right_dev r',
' where l.offset_component_id = r.offset_component_id',
'   and l.component_type      = r.component_type',
'   and l.diff_checksum      != r.diff_checksum',
'union all',
'select wwv_flow_lang_dev.builder_message(''APEXDEV.DIFF.ADDED'', count(*)) as status_count,',
'       ''ADDED'' as status',
'  from wwv_flow_diff_export_right_dev r,',
'       wwv_flow_diff_export_left_dev l',
' where l.component_type      (+) = r.component_type ',
'   and l.offset_component_id (+) = r.offset_component_id ',
'   and l.component_type is null',
'   and l.offset_component_id is null',
'   and not exists (',
'       /* ignore list items when the list is being created/new */',
'       select null',
'         from wwv_flow_list_items',
'        where list_id in (select ir.component_id ',
'                            from wwv_flow_diff_export_right_dev ir',
'                           where ir.component_type = ''LIST''',
'                            and not exists',
'                                   ( select null ',
'                                       from wwv_flow_diff_export_left_dev il',
'                                      where il.component_type      = ir.component_type',
'                                        and il.offset_component_id = ir.offset_component_id',
'                                   )                         ',
'                        )',
'          and id                = r.component_id',
'          and security_group_id = :WORKSPACE_ID',
'   )',
'union all',
'select wwv_flow_lang_dev.builder_message(''APEXDEV.DIFF.MISSING'', count(*)) as status_count,',
'       ''MISSING'' as status',
'  from wwv_flow_diff_export_left_dev l,',
'       wwv_flow_diff_export_right_dev r ',
' where l.component_type         = r.component_type (+)',
'   and l.offset_component_id    = r.offset_component_id (+)',
'   and nvl(:P5300_REVERSE, ''N'') = ''N''   ',
'   and r.component_type is null',
'   and r.offset_component_id is null',
''))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_CARDS'
,p_ajax_items_to_submit=>'P5300_REVERSE'
,p_plug_query_num_rows_type=>'SCROLL'
,p_show_total_row_count=>false
,p_landmark_type=>'region'
);
wwv_flow_imp_page.create_card(
 p_id=>wwv_flow_imp.id(3154390186834728)
,p_region_id=>wwv_flow_imp.id(3152898246834713)
,p_layout_type=>'GRID'
,p_grid_column_count=>3
,p_title_adv_formatting=>true
,p_title_html_expr=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h3 class="a-CardView-title ">',
'&STATUS_COUNT.',
'</h3>'))
,p_sub_title_adv_formatting=>false
,p_body_adv_formatting=>false
,p_second_body_adv_formatting=>false
,p_media_adv_formatting=>false
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3184481414144504)
,p_plug_name=>'Information'
,p_region_name=>'INFO'
,p_parent_plug_id=>wwv_flow_imp.id(3372976219152815)
,p_region_css_classes=>'a-Alert--noTitle margin-bottom-md'
,p_region_template_options=>'#DEFAULT#:a-Alert--info:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>30
,p_function_body_language=>'PLSQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_working_copy_dev.get_differences_info ( ',
'    p_url => wwv_flow_utilities.prepare_url(''f?p=''||:APP_ID||'':5303:''||:APP_SESSION||'':''||:DEBUG),',
'    p_differences_count => :P5300_DIFF_COUNT );'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
,p_ajax_items_to_submit=>'P5300_DIFF_COUNT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3600557371086115)
,p_plug_name=>'Merge Summary'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_item_display_point=>'BELOW'
,p_function_body_language=>'PLSQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_working_copy_dev.get_page_title (',
'    p_compare         => :P5300_COMPARE_ONLY = ''Y'',',
'    p_reverse         => :P5300_REVERSE = ''Y'',',
'    p_left_app_label  => :P5300_LEFT_APP_LABEL,',
'    p_right_app_label => :P5300_RIGHT_APP_LABEL );'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
,p_landmark_type=>'region'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1388287921308043)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(292978814960744902)
,p_button_name=>'NEXT'
,p_button_static_id=>'NEXT_BTN'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-ButtonRegion--noPadding'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3600352731086113)
,p_branch_name=>'Go To Page 5301'
,p_branch_action=>'f?p=&APP_ID.:5301:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(1388287921308043)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3600469917086114)
,p_branch_name=>'Go To Page 5300'
,p_branch_action=>'f?p=&APP_ID.:5300:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1384259781308003)
,p_name=>'P5300_LEFT_APP_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1384130138308002)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1384306508308004)
,p_name=>'P5300_RIGHT_APP_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1384130138308002)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1384483906308005)
,p_name=>'P5300_REVERSE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(1384130138308002)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1387174606308032)
,p_name=>'P5300_CURRENT_STATUS'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(1384130138308002)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1387218386308033)
,p_name=>'P5300_PCT_COMPLETE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(1384130138308002)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3184545401144505)
,p_name=>'P5300_DIFF_COUNT'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(1384130138308002)
,p_item_default=>'0'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3373958924152825)
,p_name=>'P5300_ACTION'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(1384130138308002)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3374758323152833)
,p_name=>'P5300_COMPARE_ONLY'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(1384130138308002)
,p_item_default=>'N'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3774709521609907)
,p_name=>'P5300_LEFT_APP_LABEL'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1384130138308002)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3774812683609908)
,p_name=>'P5300_RIGHT_APP_LABEL'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(1384130138308002)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4089226397729939)
,p_name=>'P5300_STATUS'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(1384130138308002)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(4089504145729942)
,p_computation_sequence=>10
,p_computation_item=>'DIFF_JOB_STATUS'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'INIT'
,p_compute_when=>'DIFF_JOB_STATUS'
,p_compute_when_text=>'DONE:ERROR'
,p_compute_when_type=>'VALUE_OF_ITEM_IN_CONDITION_IN_COLON_DELIMITED_LIST'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(4089421886729941)
,p_computation_sequence=>20
,p_computation_item=>'P5300_STATUS'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'DIFF_JOB_STATUS'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3775317707609913)
,p_validation_name=>'Components selected for merging'
,p_validation_sequence=>10
,p_validation=>'wwv_flow.g_f01.count > 0'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'You must select as least 1 component to add to your merge!'
,p_when_button_pressed=>wwv_flow_imp.id(1388287921308043)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1386865801308029)
,p_name=>'Do Diff and Report Status until Complete'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'REQUEST_EQUALS_CONDITION'
,p_display_when_cond=>'DIFF'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4088367044729930)
,p_event_id=>wwv_flow_imp.id(1386865801308029)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'workingCopyDiff.init();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1388357234308044)
,p_name=>'On Next click Submit with Wait Indicator'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1388287921308043)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1388511075308046)
,p_event_id=>wwv_flow_imp.id(1388357234308044)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'NEXT'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3600632309086116)
,p_name=>'On Diff Complete Refresh Regions'
,p_event_sequence=>40
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'body'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'custom'
,p_bind_event_type_custom=>'working-copy-diff-completed'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3600738519086117)
,p_event_id=>wwv_flow_imp.id(3600632309086116)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1384510544308006)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3154490202834729)
,p_event_id=>wwv_flow_imp.id(3600632309086116)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3152898246834713)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3184674367144506)
,p_event_id=>wwv_flow_imp.id(3600632309086116)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select sum(status_count)',
'into :P5300_DIFF_COUNT',
'from (',
'    select count(*) as status_count,',
'           ''CHANGED'' as status',
'      from wwv_flow_diff_export_left_dev l,',
'           wwv_flow_diff_export_right_dev r',
'     where l.offset_component_id = r.offset_component_id',
'       and l.component_type = r.component_type',
'       and l.diff_checksum != r.diff_checksum',
'       and r.component_type not in (select column_value from table(wwv_flow_working_copy_dev.get_unsupported_export_types))',
'    union all',
'    select count(*) as status_count,',
'           ''ADDED'' as status',
'      from wwv_flow_diff_export_right_dev r',
'      left join wwv_flow_diff_export_left_dev l on',
'              l.component_type = r.component_type',
'          and l.offset_component_id = r.offset_component_id',
'     where l.component_type is null',
'       and l.offset_component_id is null',
'       and r.component_type not in (select column_value from table(wwv_flow_working_copy_dev.get_unsupported_export_types))',
'       and not exists (',
'           /* ignore list items when the list is being created/new */',
'           select null',
'             from wwv_flow_list_items',
'            where list_id in (select ir.component_id ',
'                                from wwv_flow_diff_export_right_dev ir',
'                               where ir.component_type = ''LIST''',
'                                 and not exists',
'                                       ( select null ',
'                                           from wwv_flow_diff_export_left_dev il',
'                                          where il.component_type = ir.component_type',
'                                            and il.offset_component_id = ir.offset_component_id',
'                                       )                         ',
'                            )',
'              and id = r.component_id',
'              and security_group_id = :WORKSPACE_ID',
'       )',
'    union all',
'    select count(*) as status_count,',
'           ''MISSING'' as status',
'      from wwv_flow_diff_export_left_dev l',
'      left join wwv_flow_diff_export_right_dev r on',
'              l.component_type = r.component_type',
'          and l.offset_component_id = r.offset_component_id',
'     where r.component_type is null',
'       and r.offset_component_id is null',
'       and l.component_type not in (select column_value from table(wwv_flow_working_copy_dev.get_unsupported_export_types))',
'       and nvl(:P5300_REVERSE, ''N'') = ''N''',
');'))
,p_attribute_03=>'P5300_DIFF_COUNT'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3184843073144508)
,p_event_id=>wwv_flow_imp.id(3600632309086116)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3184481414144504)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3605414428131301)
,p_name=>'Select All After Refresh'
,p_event_sequence=>60
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(1384510544308006)
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'!window.checkAllHasRun'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterrefresh'
,p_display_when_type=>'NOT_EXISTS'
,p_display_when_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_diff_comp_export_dev',
'union all',
'select null',
'  from sys.dual',
' where :P5300_COMPARE_ONLY = ''Y'''))
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3605557549131302)
,p_event_id=>wwv_flow_imp.id(3605414428131301)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'window.checkAllHasRun = true;',
'let checkAllRows$ = apex.jQuery(''#check-all-rows'');',
'let table = $x_UpTill(checkAllRows$[0], "TABLE");',
'if (table) {',
'    checkAllRows$.prop(''checked'', true);',
'    $f_CheckFirstColumn(checkAllRows$[0]);',
'}'))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3600040248086110)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Add components to collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_working_copy_dev.add_to_merge_collection (',
'    p_app_id => :P5300_RIGHT_APP_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1388287921308043)
,p_internal_uid=>3600040248086110
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1387372922308034)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'Clear Page Items'
,p_attribute_01=>'CLEAR_CACHE_FOR_ITEMS'
,p_attribute_03=>'P5300_CURRENT_STATUS,P5300_PCT_COMPLETE'
,p_process_when=>'P5300_STATUS'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_process_when2=>'RUNNING'
,p_internal_uid=>1387372922308034
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3600987811086119)
,p_process_sequence=>40
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Session State and Truncate Collections'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_working_copy_dev.diff_merge_init (',
'    p_left_app_id_item       => ''P5300_LEFT_APP_ID'',',
'    p_left_label_item        => ''P5300_LEFT_APP_LABEL'',',
'    p_right_app_id_item      => ''P5300_RIGHT_APP_ID'',',
'    p_right_label_item       => ''P5300_RIGHT_APP_LABEL'',',
'    p_reverse_item           => ''P5300_REVERSE'',',
'    p_init_collections       => :REQUEST = ''DIFF'' AND nvl(:P5300_STATUS,''X'') != ''RUNNING'' );'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>3600987811086119
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3373602523152822)
,p_process_sequence=>20
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'doDiff'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_working_copy_dev.do_diff (',
'    p_left_app_id            => :P5300_LEFT_APP_ID,',
'    p_right_app_id           => :P5300_RIGHT_APP_ID,',
'    p_left_app_label         => :P5300_LEFT_APP_LABEL,',
'    p_right_app_label        => :P5300_RIGHT_APP_LABEL,',
'    p_reverse_merge          => nvl(:P5300_REVERSE, ''N''),',
'    p_status_item            => ''DIFF_JOB_STATUS'',',
'    p_pct_item               => ''P5300_PCT_COMPLETE'',',
'    p_current_status_item    => ''P5300_CURRENT_STATUS'',',
'    p_in_background          => true );',
'',
''))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>3373602523152822
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1387631599308037)
,p_process_sequence=>30
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'getCurrentStatus'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_json.open_object;',
'    wwv_flow_json.open_array(''items'');',
'    wwv_flow_json.open_object;',
'    wwv_flow_json.write(''id'', ''P5300_STATUS'');',
'    wwv_flow_json.write(''value'', wwv_flow_session_state.v(''DIFF_JOB_STATUS''));',
'    wwv_flow_json.close_object;',
'    wwv_flow_json.open_object;',
'    wwv_flow_json.write(''id'', ''P5300_CURRENT_STATUS'');',
'    wwv_flow_json.write(''value'', wwv_flow_session_state.v(''P5300_CURRENT_STATUS''));',
'    wwv_flow_json.close_object;',
'    wwv_flow_json.open_object;',
'    wwv_flow_json.write(''id'', ''P5300_PCT_COMPLETE'');',
'    wwv_flow_json.write(''value'', wwv_flow_session_state.v(''P5300_PCT_COMPLETE''));',
'    wwv_flow_json.close_object;',
'    wwv_flow_json.close_array;',
'    wwv_flow_json.close_object;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>1387631599308037
);
wwv_flow_imp_page.create_component_action(
 p_id=>wwv_flow_imp.id(4088588853729932)
,p_ir_column_id=>wwv_flow_imp.id(1386488474308025)
,p_position_id=>wwv_flow_imp.id(214437533860142316)
,p_display_sequence=>10
,p_template_id=>wwv_flow_imp.id(214438625365151034)
,p_label=>'Compare Changes'
,p_link_target_type=>'REDIRECT_PAGE'
,p_link_target=>'f?p=&APP_ID.:5302:&SESSION.::&DEBUG.::P5302_EXPORT_LEFT_ID,P5302_EXPORT_RIGHT_ID:#EXPORT_LEFT_ID#,#EXPORT_RIGHT_ID#'
,p_button_display_type=>'ICON'
,p_icon_css_classes=>'icon-compare'
,p_is_hot=>false
,p_show_as_disabled=>false
);
end;
/
prompt --application/pages/page_05301
begin
wwv_flow_imp_page.create_page(
 p_id=>5301
,p_name=>'Confirm Action'
,p_alias=>'CONFIRM-ACTION'
,p_step_title=>'Confirm Action'
,p_autocomplete_on_off=>'OFF'
,p_javascript_file_urls=>'#IMAGE_PREFIX#libraries/apex/#MIN_DIRECTORY#widget.stickyWidget#MIN#.js?v=#APEX_VERSION#'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(function($) {',
'',
'  $("#WIZARD_BUTTONS")',
'    .stickyWidget({',
'      isFooter: true,',
'      toggleWidth: true',
'    });',
'',
'})(apex.jQuery);'))
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.pageTitle {',
'  text-align: center;',
'  padding-block: 40px;',
'}',
'',
'.a-CardView-header {',
'  --a-cv-header-border-width: 0px;',
'  justify-items: center;',
'}',
'',
'.a-IRR .b-Badge {',
'  --ab-badge-display: block;',
'  text-align: center;',
'}',
'',
'.a-Wizard-body {',
'  position: relative;',
'}',
'',
'.a-PageWizard-buttons {',
'  margin-top: 0;',
'}',
'',
'.a-PageWizard-buttons.is-stuck {',
'  padding-top: 0;',
'}',
'',
'.merge-container .a-Region-header {',
'  padding-inline: 0;',
'}'))
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(74845831538733642)
,p_protection_level=>'C'
,p_page_component_map=>'23'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3608167383131328)
,p_plug_name=>'Wizard Buttons'
,p_region_name=>'WIZARD_BUTTONS'
,p_region_css_classes=>'a-PageWizard-buttons margin-top-md'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>70
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5023993122753095)
,p_plug_name=>'Merge Actions'
,p_parent_plug_id=>wwv_flow_imp.id(3608167383131328)
,p_region_css_classes=>'a-ButtonRegion--noPadding'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--noUI'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_diff_comp_export_dev'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6784821699277513)
,p_plug_name=>'Selected Components'
,p_region_css_classes=>'merge-container'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_item_display_point=>'BELOW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3188718390144547)
,p_plug_name=>'Components to Merge Report'
,p_parent_plug_id=>wwv_flow_imp.id(6784821699277513)
,p_region_css_classes=>'margin-bottom-md'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select component_type,',
'       component_type_label,',
'       component_display_name,',
'       component_id,',
'       component_export_id, ',
'       component_status,',
'       wwv_flow_lang_dev.builder_message( p_name => ''APEXDEV.DIFF.'' || component_status) as component_status_display,',
'       case component_status',
'           when ''ADDED''   then ''success''',
'           when ''CHANGED'' then ''info''',
'           when ''MISSING'' then ''danger''',
'       end as badge_state',
'  from wwv_flow_diff_comp_export_dev',
''))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Components to Merge Rpt'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(3188881929144548)
,p_max_row_count=>'1000000'
,p_show_search_bar=>'N'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_enable_mail_download=>'Y'
,p_owner=>'MJNOLAN'
,p_internal_uid=>3188881929144548
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4085462832729901)
,p_db_column_name=>'COMPONENT_TYPE'
,p_display_order=>30
,p_column_identifier=>'A'
,p_column_label=>'Component Type'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4085568931729902)
,p_db_column_name=>'COMPONENT_ID'
,p_display_order=>40
,p_column_identifier=>'B'
,p_column_label=>'Component Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4085622397729903)
,p_db_column_name=>'COMPONENT_TYPE_LABEL'
,p_display_order=>50
,p_column_identifier=>'C'
,p_column_label=>'Component Type'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4085790096729904)
,p_db_column_name=>'COMPONENT_DISPLAY_NAME'
,p_display_order=>60
,p_column_identifier=>'D'
,p_column_label=>'Component Name'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4086122452729908)
,p_db_column_name=>'COMPONENT_EXPORT_ID'
,p_display_order=>100
,p_column_identifier=>'E'
,p_column_label=>'Type / ID'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4086379601729910)
,p_db_column_name=>'COMPONENT_STATUS'
,p_display_order=>110
,p_column_identifier=>'F'
,p_column_label=>'Component Status'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4086450399729911)
,p_db_column_name=>'COMPONENT_STATUS_DISPLAY'
,p_display_order=>120
,p_column_identifier=>'G'
,p_column_label=>'Status'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'TMPL_THEME_3$BADGE'
,p_column_alignment=>'CENTER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'LABEL_DISPLAY', 'N',
  'STATE', 'BADGE_STATE',
  'VALUE', 'COMPONENT_STATUS_DISPLAY')).to_clob
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4087089989729917)
,p_db_column_name=>'BADGE_STATE'
,p_display_order=>130
,p_column_identifier=>'H'
,p_column_label=>'Badge State'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(4093080940754962)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'40931'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'COMPONENT_STATUS_DISPLAY:COMPONENT_TYPE_LABEL:COMPONENT_DISPLAY_NAME:COMPONENT_EXPORT_ID:'
,p_sort_column_1=>'COMPONENT_TYPE_LABEL'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'COMPONENT_DISPLAY_NAME'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6784906255277514)
,p_plug_name=>'Components to Merge Overview'
,p_parent_plug_id=>wwv_flow_imp.id(6784821699277513)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_lang_dev.builder_message(''APEXDEV.DIFF.CHANGED'', count(*)) as status_count,',
'       ''CHANGED'' as status',
'  from wwv_flow_diff_comp_export_dev',
' where component_status = ''CHANGED'' ',
'union all',
'select wwv_flow_lang_dev.builder_message(''APEXDEV.DIFF.ADDED'', count(*)) as status_count,',
'       ''ADDED'' as status',
'  from wwv_flow_diff_comp_export_dev',
' where component_status = ''ADDED'' ',
''))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_CARDS'
,p_plug_query_num_rows_type=>'SCROLL'
,p_show_total_row_count=>false
,p_landmark_type=>'region'
);
wwv_flow_imp_page.create_card(
 p_id=>wwv_flow_imp.id(3635102575442789)
,p_region_id=>wwv_flow_imp.id(6784906255277514)
,p_layout_type=>'GRID'
,p_grid_column_count=>2
,p_title_adv_formatting=>true
,p_title_html_expr=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h3 class="a-CardView-title ">',
'&STATUS_COUNT.',
'</h3>'))
,p_sub_title_adv_formatting=>false
,p_body_adv_formatting=>false
,p_second_body_adv_formatting=>false
,p_media_adv_formatting=>false
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(292978732012744901)
,p_plug_name=>'Merge Options'
,p_parent_plug_id=>wwv_flow_imp.id(6784821699277513)
,p_region_css_classes=>'margin-bottom-md'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>30
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_diff_comp_export_dev'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7408912238359283)
,p_plug_name=>'Merge Summary'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>30
,p_function_body_language=>'PLSQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_working_copy_dev.get_page_title (',
'    p_compare         => :P5300_COMPARE_ONLY = ''Y'',',
'    p_reverse         => :P5300_REVERSE = ''Y'',',
'    p_left_app_label  => :P5300_LEFT_APP_LABEL,',
'    p_right_app_label => :P5300_RIGHT_APP_LABEL );'))
,p_lazy_loading=>false
,p_plug_source_type=>'NATIVE_DYNAMIC_CONTENT'
,p_landmark_type=>'region'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3645139399484266)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(5023993122753095)
,p_button_name=>'CONFIRM_MERGE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Confirm Merge'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P5300_ACTION'
,p_button_condition2=>'MERGE_BACK_TO_MAIN'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(119480122979947241)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(5023993122753095)
,p_button_name=>'CONFIRM_REFRESH'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Confirm Refresh'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P5300_ACTION'
,p_button_condition2=>'REFRESH_FROM_MAIN'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3636103523445054)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(5023993122753095)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--large:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:5300:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3601228290086122)
,p_branch_name=>'Branch to Main App'
,p_branch_action=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.::FB_FLOW_ID,F4000_P1_FLOW:&MAIN_APP_ID.,&MAIN_APP_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(3645139399484266)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(119480740134947247)
,p_branch_name=>'Branch to Working Copy App'
,p_branch_action=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(119480122979947241)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2164847487339106)
,p_branch_name=>'Branch to App Builder'
,p_branch_action=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3608470079131331)
,p_branch_name=>'Previous Page'
,p_branch_action=>'f?p=&APP_ID.:5300:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'BEFORE_COMPUTATION'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(3636103523445054)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3605880029131305)
,p_name=>'P5301_DELETE_WORKING_COPY'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(292978732012744901)
,p_item_default=>'N'
,p_prompt=>'Delete Working Copy after merge'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_display_when=>'P5300_ACTION'
,p_display_when2=>'MERGE_BACK_TO_MAIN'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--noPadding margin-bottom-md'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(7238997968531186)
,p_name=>'P5301_BACKUP_BEFORE_MERGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(292978732012744901)
,p_item_default=>'Y'
,p_prompt=>'Backup target app first'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--noPadding margin-bottom-md'
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--autoLabelWidth'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3178310348092438)
,p_validation_name=>'Check for locked pages'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_errors wwv_flow_t_varchar2;',
'begin',
'    l_errors := wwv_flow_working_copy_dev.get_locked_page_errors ( :P5300_LEFT_APP_ID );',
'    return wwv_flow_string.join( p_table => l_errors, p_sep => ''<br />'');',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3605660057131303)
,p_name=>'Confirm Merge'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3645139399484266)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_cond=>'P5300_ACTION'
,p_display_when_cond2=>'MERGE_BACK_TO_MAIN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3605732681131304)
,p_event_id=>wwv_flow_imp.id(3605660057131303)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'Are you sure you want to merge the changes? This operation cannot be undone! This is why we recommend you to "Backup target app before merge".'
,p_attribute_02=>'Confirm Merge'
,p_client_condition_type=>'EQUALS'
,p_client_condition_element=>'P5301_BACKUP_BEFORE_MERGE'
,p_client_condition_expression=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3372872842152814)
,p_event_id=>wwv_flow_imp.id(3605660057131303)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'CONFIRM_MERGE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(119480210977947242)
,p_name=>'Confirm Refresh'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(119480122979947241)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_cond=>'P5300_ACTION'
,p_display_when_cond2=>'REFRESH_FROM_MAIN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(119480390740947243)
,p_event_id=>wwv_flow_imp.id(119480210977947242)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'Are you sure you want to refresh the changes? This operation cannot be undone! This is why we recommend you to "Backup target app before merge".'
,p_attribute_02=>'Confirm Merge'
,p_client_condition_type=>'EQUALS'
,p_client_condition_element=>'P5301_BACKUP_BEFORE_MERGE'
,p_client_condition_expression=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(119480486983947244)
,p_event_id=>wwv_flow_imp.id(119480210977947242)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'CONFIRM_REFRESH'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3637452597447810)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Merge Changes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_working_copy_dev.diff_merge (',
'    p_left_app_id       => :P5300_LEFT_APP_ID,',
'    p_right_app_id      => :P5300_RIGHT_APP_ID,',
'    p_reverse_merge     => :P5300_REVERSE = ''Y'',',
'    p_backup_first      => :P5301_BACKUP_BEFORE_MERGE = ''Y'' );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error merging changes!'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3645139399484266)
,p_process_success_message=>'Your changes have been successfully merged!'
,p_internal_uid=>3637452597447810
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(119480529558947245)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh Changes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_working_copy_dev.diff_merge (',
'    p_left_app_id       => :P5300_LEFT_APP_ID,',
'    p_right_app_id      => :P5300_RIGHT_APP_ID,',
'    p_reverse_merge     => :P5300_REVERSE = ''Y'',',
'    p_backup_first      => :P5301_BACKUP_BEFORE_MERGE = ''Y'' );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error refreshing changes!'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(119480122979947241)
,p_process_success_message=>'Your changes have been successfully refreshed!'
,p_internal_uid=>119480529558947245
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3373860314152824)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Working Copy'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_imp.remove_application (',
'    p_application_id  => :P5300_RIGHT_APP_ID,',
'    p_delete_feedback => true );',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3645139399484266)
,p_process_when=>':P5301_DELETE_WORKING_COPY = ''Y'' and :P5300_ACTION = ''MERGE_BACK_TO_MAIN'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Your working copy has been deleted!'
,p_internal_uid=>3373860314152824
);
end;
/
prompt --application/pages/page_05302
begin
wwv_flow_imp_page.create_page(
 p_id=>5302
,p_name=>'View Differences'
,p_alias=>'VIEW-DIFFERENCES'
,p_page_mode=>'MODAL'
,p_step_title=>'View Differences'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.page-diff {',
'    padding-inline: 12px;',
'    margin-bottom: 12px;',
'}',
'',
'.page-diff--target {',
'    padding-inline-start: 0;',
'}',
'',
'.page-diff--target:before {',
'    content: '''';',
'    display: block;',
'    height: 40px;',
'    width: 2px;',
'    position: absolute;',
'    background: currentColor;',
'    left: -16px;',
'    opacity: .1;',
'}',
'',
'.page-diff-title {',
'    font-size: 16px;',
'    font-weight: bold;',
'    color: var(--a-palette-primary-contrast);',
'}',
'',
'.page-diff-desc {',
'    margin-top: 4px;',
'    color: var(--a-palette-primary-shade);',
'}',
'',
'.a-Icon.icon-arrow-up:before{',
'    content: "\e01a";',
'}',
'.a-Icon.icon-arrow-down:before{',
'    content: "\e026";',
'}'))
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'640'
,p_dialog_width=>'80%'
,p_dialog_attributes=>'resizable:true'
,p_protection_level=>'C'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2164948075339107)
,p_plug_name=>'Diff Viewer'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>30
,p_landmark_type=>'region'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3602767168086137)
,p_plug_name=>'Hidden Item Container'
,p_plug_display_sequence=>40
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3774424634609904)
,p_plug_name=>'Source Applications'
,p_region_name=>'details'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_landmark_type=>'region'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3774521433609905)
,p_plug_name=>'Left App ID'
,p_parent_plug_id=>wwv_flow_imp.id(3774424634609904)
,p_region_css_classes=>'page-diff'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="page-diff-title">&P5300_LEFT_APP_LABEL!HTML.</div>',
'<div class="page-diff-desc">Application &P5300_LEFT_APP_ID!HTML.</div>'))
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3774610336609906)
,p_plug_name=>'Right App ID'
,p_parent_plug_id=>wwv_flow_imp.id(3774424634609904)
,p_region_css_classes=>'page-diff page-diff--target'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="page-diff-title">&P5300_RIGHT_APP_LABEL!HTML.</div>',
'<div class="page-diff-desc">Application &P5300_RIGHT_APP_ID!HTML.</div>'))
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2165086927339108)
,p_name=>'P5302_DIFF_VIEWER'
,p_data_type=>'CLOB'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2164948075339107)
,p_prompt=>'Differences View'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_json sys.json_object_t;',
'    l_left_file  clob;',
'    l_right_file clob;',
'begin',
'    begin',
'        select clob001',
'          into l_left_file ',
'          from wwv_flow_diff_export_left_dev',
'         where seq_id          = :P5302_EXPORT_LEFT_ID;',
'    exception',
'        when no_data_found then',
'            l_left_file := empty_clob();',
'    end;',
'    begin',
'        select clob001',
'          into l_right_file ',
'          from wwv_flow_diff_export_right_dev',
'         where seq_id          = :P5302_EXPORT_RIGHT_ID;',
'    exception',
'        when no_data_found then',
'            l_right_file := empty_clob();',
'    end;',
'',
'    l_json := sys.json_object_t();',
'    l_json.put( ''original'', l_left_file );',
'    l_json.put( ''modified'', l_right_file );',
'',
'    return l_json.to_clob;',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_imp.id(4923925522744860)
,p_item_template_options=>'#DEFAULT#'
,p_plugin_init_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function( options ) {',
'    options.heightFn = () => {',
'        return $( ".a-Dialog-body" ).height() - $( "#details" ).height();',
'    };',
'    return options;',
'}'))
,p_attribute_01=>'yaml'
,p_attribute_04=>'N'
,p_attribute_07=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3602891614086138)
,p_name=>'P5302_EXPORT_LEFT_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3602767168086137)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3602912726086139)
,p_name=>'P5302_EXPORT_RIGHT_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3602767168086137)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3603017031086140)
,p_name=>'P5302_FILE_CONTENTS'
,p_data_type=>'CLOB'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3602767168086137)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
end;
/
prompt --application/pages/page_05303
begin
wwv_flow_imp_page.create_page(
 p_id=>5303
,p_name=>'About Working Copies'
,p_alias=>'ABOUT-WORKING-COPIES'
,p_page_mode=>'MODAL'
,p_step_title=>'About Working Copies'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-Region .a-Region-body {',
'  font-size: 14px;',
'  line-height: 20px;',
'}',
'',
'.a-Region .a-Region-body h3 {',
'    margin-top: 8px;',
'    margin-bottom: 4px;',
'}',
'',
'.a-Region .a-Region-body p,',
'.a-Region .a-Region-body ul {',
'  margin-bottom: 16px;',
'}'))
,p_step_template=>wwv_flow_imp.id(120871216744825711)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'560'
,p_protection_level=>'C'
,p_page_component_map=>'11'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3185079872144510)
,p_plug_name=>'About Working Copies'
,p_region_css_classes=>'padding-left-md padding-right-md'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<h3>Tips</h3>',
'<ul>',
'    <li>Developers can use distinct working copies. To avoid overwrites or errors on merge:',
'        <ul>',
'            <li>Lock a page in your main app before modifying it in a working copy</li>',
'            <li>Reserve page ranges for new pages each developer will create</li>',
'            <li>Agree on shared component names each developer will add</li>',
'        </ul>',
'    </li>',
'    <li>Export a working copy as needed using <em>Original IDs</em> to maintain its link with main</li>',
'    <li><em>Unlink</em> a working copy from main by using the <em>Copy Application</em> task</li>',
'    <li>Delete any working copies <em>before</em> deleting an application</li>',
'</ul>',
'<h3>Unsupported Component Types</h3>',
'<p>These component types are not yet supported for <em>automatic</em> merging:',
'   Translations, Themes, Theme Templates, Supporting Objects, Application Properties, Tabs (Legacy), and',
'   Workspace-level components like App Groups, Credentials, or Remote Servers. You can merge the working copy,',
'   then manually apply the additions or changes to these component types.',
'</p>',
'<h3>Limitations</h3>',
'<p>Working copies have the following limitations:</p>',
'<ul>',
'    <li>You cannot create a working copy of a working copy</li>',
'    <li>Deleted working copy pages or shared components must be <em>manually</em> deleted in main</li>',
'    <li>Components listed as <em>Missing</em> may have been removed in the working copy or may only exist in main</li>',
'</ul>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
end;
/
prompt --application/pages/page_05305
begin
wwv_flow_imp_page.create_page(
 p_id=>5305
,p_name=>'Working Copy Details'
,p_alias=>'WORKING-COPY-DETAILS'
,p_page_mode=>'MODAL'
,p_step_title=>'Working Copy Details'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3263482172009882)
,p_plug_name=>'Working Copy Details'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOWS'
,p_query_where=>'security_group_id = :WORKSPACE_ID'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'u'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3397891856010000)
,p_plug_name=>'Buttons Container'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3400003535010001)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(3397891856010000)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P5305_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1802898609786722)
,p_branch_name=>'Go To Last App Page'
,p_branch_action=>'f?p=&P5305_LAST_APP_ID.:&P5305_LAST_PAGE_ID.:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1802493824786718)
,p_name=>'P5305_LAST_APP_ID'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(3263482172009882)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1802557587786719)
,p_name=>'P5305_LAST_PAGE_ID'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(3263482172009882)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3263758154009883)
,p_name=>'P5305_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3263482172009882)
,p_item_source_plug_id=>wwv_flow_imp.id(3263482172009882)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_protection_level=>'S'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3264507109009885)
,p_name=>'P5305_ALIAS'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(3263482172009882)
,p_item_source_plug_id=>wwv_flow_imp.id(3263482172009882)
,p_prompt=>'Alias'
,p_source=>'ALIAS'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'An alphanumeric application identifier. You can use this identifier in place of the application ID.'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3338790367009970)
,p_name=>'P5305_WORKING_COPY_CREATED_ON'
,p_source_data_type=>'DATE'
,p_is_query_only=>true
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(3263482172009882)
,p_item_source_plug_id=>wwv_flow_imp.id(3263482172009882)
,p_prompt=>'Working Copy Created On'
,p_format_mask=>'SINCE'
,p_source=>'WORKING_COPY_CREATED_ON'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'The date the working copy application was created.'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3339126019009970)
,p_name=>'P5305_WORKING_COPY_DESCRIPTION'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(3263482172009882)
,p_item_source_plug_id=>wwv_flow_imp.id(3263482172009882)
,p_prompt=>'Working Copy Description'
,p_source=>'WORKING_COPY_DESCRIPTION'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter a description of your working copy application and its purpose.'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3340362065009971)
,p_name=>'P5305_WORKING_COPY_NAME'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(3263482172009882)
,p_item_source_plug_id=>wwv_flow_imp.id(3263482172009882)
,p_prompt=>'Working Copy Name'
,p_source=>'WORKING_COPY_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>40
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter a short identifier for the working copy application to distinguish its purpose.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3340761035009971)
,p_name=>'P5305_WORKING_COPY_CREATED_BY'
,p_source_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(3263482172009882)
,p_item_source_plug_id=>wwv_flow_imp.id(3263482172009882)
,p_prompt=>'Working Copy Created By'
,p_source=>'WORKING_COPY_CREATED_BY'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'The developer who created the working copy application.'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3894601385699006)
,p_name=>'P5305_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(3263482172009882)
,p_item_source_plug_id=>wwv_flow_imp.id(3263482172009882)
,p_source=>'NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3894772000699007)
,p_computation_sequence=>10
,p_computation_item=>'P5305_NAME'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_working_copy_dev.get_working_copy_app_name (',
'    p_main_app_name     => :P5305_NAME,',
'    p_working_copy_name => :P5305_WORKING_COPY_NAME )'))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3458343222027708)
,p_validation_name=>'P5305_WORKING_COPY_NAME max length check'
,p_validation_sequence=>20
,p_validation=>'lengthb(:P5305_WORKING_COPY_NAME) <= 40'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Size of #LABEL# must be 40 bytes or less'
,p_when_button_pressed=>wwv_flow_imp.id(3400003535010001)
,p_associated_item=>wwv_flow_imp.id(3340362065009971)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3401282582010002)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(3263482172009882)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process form Working Copy Details'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3400003535010001)
,p_process_success_message=>'Working copy name updated!'
,p_internal_uid=>3401282582010002
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1802692100786720)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update Working Copy Name Application Item'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':WORKING_COPY_NAME := wwv_flow_working_copy_dev.get_working_copy_name( ',
'    p_application_id    => :FB_FLOW_ID,',
'    p_security_group_id => :WORKSPACE_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>1802692100786720
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3400852193010002)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(3263482172009882)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Working Copy Details'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>3400852193010002
);
end;
/
prompt --application/pages/page_05310
begin
wwv_flow_imp_page.create_page(
 p_id=>5310
,p_name=>'Create Working Copy'
,p_alias=>'CREATE-WORKING-COPY'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Working Copy'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213220627333807318)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldapp_copy_app.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47918946221711269)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(116595641669712135)
,p_plug_name=>'Create Working Copy'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>100
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1406771242704143)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47918946221711269)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1407109961704144)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(47918946221711269)
,p_button_name=>'CREATE_WORKING_COPY'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Working Copy'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1418146104704169)
,p_branch_name=>'Go To Page 1'
,p_branch_action=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(1407109961704144)
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3156067752834745)
,p_name=>'P5310_DESCRIPTION'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(116595641669712135)
,p_prompt=>'Working Copy Description'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>'Enter a description for the working copy application to distinguish its purpose.'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5009495488790269)
,p_name=>'P5310_WORKING_COPY_NAME'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(116595641669712135)
,p_prompt=>'Working Copy Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a short identifier for the working copy application to distinguish its purpose.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(116598082625712166)
,p_name=>'P5310_MAIN_APP_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(116595641669712135)
,p_prompt=>'Main Application ID'
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies application ID to copy.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(116618183434757367)
,p_name=>'P5310_MAIN_APP_NAME'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(116595641669712135)
,p_prompt=>'Main Application Name'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name from wwv_flows',
'where id = :FB_FLOW_ID',
'and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies application name to copy.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(116659893664873850)
,p_name=>'P5310_NEW_APP_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(116595641669712135)
,p_source=>'wwv_flow_utilities.minimum_free_flow'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Enter a unique integer value to identify the application. Note that application IDs between 3000 to 9000 are reserved for internal use by &PRODUCT_NAME..'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(116661784099880591)
,p_name=>'P5310_NEW_APP_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(116595641669712135)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name',
'from wwv_flows',
'where id = :FB_FLOW_ID',
'and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Enter a short descriptive name for the application to distinguish the new application in select lists and reports.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3156545769834750)
,p_validation_name=>'Working copy name is valid application name'
,p_validation_sequence=>110
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_utilities.is_valid_application_name (',
'  p_name => :P5310_WORKING_COPY_NAME);'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_when_button_pressed=>wwv_flow_imp.id(1407109961704144)
,p_associated_item=>wwv_flow_imp.id(5009495488790269)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3184121849144501)
,p_validation_name=>'P5310_WORKING_COPY_NAME max length check'
,p_validation_sequence=>130
,p_validation=>'lengthb(:P5310_WORKING_COPY_NAME) <= 255'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Size of #LABEL# must be 255 bytes or less'
,p_when_button_pressed=>wwv_flow_imp.id(1407109961704144)
,p_associated_item=>wwv_flow_imp.id(5009495488790269)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(119477292424947212)
,p_validation_name=>'Working Copy Name is not the reserved word Main'
,p_validation_sequence=>140
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'lower( :P5310_WORKING_COPY_NAME ) != lower( wwv_flow_lang.runtime_message(''APEXDEV.DIFF.MAIN'') ) and ',
'lower( :P5310_WORKING_COPY_NAME ) != ''main'''))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'The working copy name cannot be a reserved word.'
,p_when_button_pressed=>wwv_flow_imp.id(1407109961704144)
,p_associated_item=>wwv_flow_imp.id(5009495488790269)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1417242515704166)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1406771242704143)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1417757903704168)
,p_event_id=>wwv_flow_imp.id(1417242515704166)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3156332114834748)
,p_name=>'Show Processing Indicator and Submit'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1407109961704144)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3156407594834749)
,p_event_id=>wwv_flow_imp.id(3156332114834748)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_name=>'CREATE_WORKING_COPY'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'CREATE_WORKING_COPY'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1418812626715315)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Working Copy'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_working_copy_dev.create_working_copy (',
'    p_old_application_id => :P5310_MAIN_APP_ID,',
'    p_new_application_id => :P5310_NEW_APP_ID,',
'    p_main_app_name      => :P5310_NEW_APP_NAME,',
'    p_working_copy_name  => :P5310_WORKING_COPY_NAME,',
'    p_description        => :P5310_DESCRIPTION,',
'    p_export_sup_objects => ''N'',',
'    p_security_group_id  => :WORKSPACE_ID );',
'',
':FB_FLOW_ID      := :P5310_NEW_APP_ID;',
':FB_FLOW_PAGE_ID := ''1'';',
':F4000_P1_FLOW   := :P5310_NEW_APP_ID;',
':F4000_P1_PAGE   := ''1'';  '))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to copy application &P5310_MAIN_APP_ID..'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1407109961704144)
,p_internal_uid=>1418812626715315
);
end;
/
prompt --application/pages/page_05320
begin
wwv_flow_imp_page.create_page(
 p_id=>5320
,p_name=>'Delete Working Copy'
,p_alias=>'DELETE-WORKING-COPY'
,p_page_mode=>'MODAL'
,p_step_title=>'Delete Working Copy'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213220627333807318)
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.a-Region .a-Region-body {',
'  font-size: 14px;',
'  line-height: 20px;',
'}',
'',
'.a-Region .a-Region-body h3 {',
'    margin-top: 8px;',
'    margin-bottom: 4px;',
'}',
'',
'.a-Region .a-Region-body p,',
'.a-Region .a-Region-body ul {',
'  margin-bottom: 16px;',
'}',
'',
'.a-Alert-header {',
'    display: none;',
'}'))
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1426804476053820)
,p_plug_name=>'Confirm Delete'
,p_region_css_classes=>'a-Alert--inlineDialog margin-none u-tC'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Are you sure you want to delete this working copy of the application?</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47945130734267493)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>1
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1430192132142313)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(47945130734267493)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1430536840142314)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(47945130734267493)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Delete Working Copy'
,p_button_position=>'CREATE'
,p_button_cattributes=>'class="button10"'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1436197808142325)
,p_branch_name=>'Go To Page 1'
,p_branch_action=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:RP,:FB_FLOW_ID,F4000_P1_FLOW:&MAIN_APP_ID.,&MAIN_APP_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(1430536840142314)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(58698150705939241)
,p_name=>'F4000_P5320_FLOW_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1426804476053820)
,p_use_cache_before_default=>'NO'
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(119477517551947215)
,p_name=>'P5320_WORKING_COPY_APP_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1426804476053820)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Working Copy'
,p_source=>'select working_copy_name || '' ('' || id || '')'' from wwv_flows where id = :FB_FLOW_ID'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(195059363643925884)
,p_name=>'P5320_APP_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(1426804476053820)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Main Application'
,p_source=>'select name || '' ('' || id || '')'' from wwv_flows where id = :MAIN_APP_ID'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'Y'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(203314042347062920)
,p_name=>'P5320_APPLICATION_DELETED'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1426804476053820)
,p_source=>'wwv_flow_lang.system_message(''APPLICATION_DELETED'')'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(119477335469947213)
,p_name=>'Close Modal Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1430192132142313)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(119477462936947214)
,p_event_id=>wwv_flow_imp.id(119477335469947213)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1434353694142323)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Flow'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_imp.remove_application (',
'    p_application_id  => :F4000_P5320_FLOW_ID );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error deleting application &F4000_P5320_FLOW_ID..'
,p_process_when_button_id=>wwv_flow_imp.id(1430536840142314)
,p_process_success_message=>'Working Copy: &P5320_WORKING_COPY_APP_NAME!HTML. deleted.'
,p_internal_uid=>1434353694142323
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1433915345142323)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Clean up Cache on Delete'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow.update_cache_with_write (''FB_FLOW_ID'',null);',
'wwv_flow.update_cache_with_write (''FB_FLOW_NAME'',null);',
'wwv_flow.update_cache_with_write (''FB_FLOW_PAGE_ID'',''1'');',
'wwv_flow.update_cache_with_write (''F4000_P1_PAGE'',''1'');',
'wwv_flow.update_cache_with_write (''F4000_P1_FLOW'',null);',
'',
'for c1 in (select min(id) min_id ',
'             from wwv_flows ',
'            where security_group_id = :WORKSPACE_ID',
'              and build_status = ''RUN_AND_BUILD'') loop',
'   wwv_flow.update_cache_with_write (''FB_FLOW_ID'',c1.min_id);',
'   wwv_flow.update_cache_with_write (''F4000_P1_FLOW'',c1.min_id);',
'   for c2 in (select min(id) p from wwv_flow_steps where flow_id = nv(''FB_FLOW_ID'')) loop',
'      wwv_flow.update_cache_with_write (''FB_FLOW_PAGE_ID'',c2.p);',
'      wwv_flow.update_cache_with_write (''F4000_P1_PAGE'',c2.p);',
'   end loop;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error performing process.'
,p_process_when_button_id=>wwv_flow_imp.id(1430536840142314)
,p_internal_uid=>1433915345142323
);
end;
/
prompt --application/pages/page_05330
begin
wwv_flow_imp_page.create_page(
 p_id=>5330
,p_name=>'Page Changes and Locks'
,p_alias=>'PAGE-CHANGES-AND-LOCKS'
,p_page_mode=>'MODAL'
,p_step_title=>'Page Changes and Locks'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1992550426812902)
,p_plug_name=>'Page Changes Exist'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_header=>'Page &FB_FLOW_PAGE_ID. is locked or has been modified in another working copy. Reference the report below to review page changes across working copies.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(1996217584812939)
,p_name=>'Page Changes'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--inline:a-Report--staticRowColors:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select c.application_id,',
'       c.page_id,',
'       decode(',
'           l.locked_by,',
'           null, ''u-hidden'',',
'           ''icon-lock-s'') page_is_locked,',
'       decode(',
'           l.locked_by,',
'           null, '''',',
'           l.lock_comment ) lock_comment,',
'       decode(',
'           l.locked_by,',
'           null, '''',',
'           wwv_flow_lang.system_message( ''BU.LOCKED'' ) ) lock_label,',
'       c.working_copy_name,',
'       c.last_updated_by,',
'       c.last_updated_on,',
'       null as link',
'  from wwv_flow_diff_page_changes c,',
'       wwv_flow_diff_page_locks l',
' where c.application_id = l.application_id (+)',
'   and c.page_id        = l.page_id (+)'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1000000
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1997341185812950)
,p_query_column_id=>1
,p_column_alias=>'APPLICATION_ID'
,p_column_display_sequence=>30
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2020984997029201)
,p_query_column_id=>2
,p_column_alias=>'PAGE_ID'
,p_column_display_sequence=>40
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2021006875029202)
,p_query_column_id=>3
,p_column_alias=>'PAGE_IS_LOCKED'
,p_column_display_sequence=>10
,p_column_heading=>'Lock'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'<span class="a-Icon #PAGE_IS_LOCKED#" role="presentation" title="Page #PAGE_ID# is locked in #WORKING_COPY_NAME!ATTR#"></span><span class="u-vh">#LOCK_LABEL#</span>'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2021137506029203)
,p_query_column_id=>4
,p_column_alias=>'LOCK_COMMENT'
,p_column_display_sequence=>90
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(3272258266959648)
,p_query_column_id=>5
,p_column_alias=>'LOCK_LABEL'
,p_column_display_sequence=>110
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2021251078029204)
,p_query_column_id=>6
,p_column_alias=>'WORKING_COPY_NAME'
,p_column_display_sequence=>20
,p_column_heading=>'Working Copy'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<strong>#WORKING_COPY_NAME# (#APPLICATION_ID#)</strong>',
'<div>#LOCK_COMMENT#</div>'))
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2021321635029205)
,p_query_column_id=>7
,p_column_alias=>'LAST_UPDATED_BY'
,p_column_display_sequence=>70
,p_column_heading=>'Last Updated By'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2021403714029206)
,p_query_column_id=>8
,p_column_alias=>'LAST_UPDATED_ON'
,p_column_display_sequence=>80
,p_column_heading=>'Last Updated On'
,p_use_as_row_header=>'N'
,p_column_format=>'SINCE'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_default_sort_dir=>'desc'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2021501462029207)
,p_query_column_id=>9
,p_column_alias=>'LINK'
,p_column_display_sequence=>100
,p_column_heading=>'Diff'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:5335:&SESSION.::&DEBUG.:5335:P5335_RIGHT_ID,P5335_EXPORT_PAGE_ID:#APPLICATION_ID#,#PAGE_ID#'
,p_column_linktext=>'<span class="a-Icon icon-compare" aria-hidden="true"></span><span class="u-VisuallyHidden">View Diff</span>'
,p_column_link_attr=>'class="a-Button"'
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3268199759959607)
,p_plug_name=>'Hidden item container'
,p_plug_display_sequence=>40
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3267515359959601)
,p_name=>'P5330_CHANGES_COUNT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3268199759959607)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3267602692959602)
,p_name=>'P5330_LOCKS_COUNT'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3268199759959607)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3271766028959643)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Populate page changes and locks'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_changes_count number;',
'    l_locks_count   number;',
'begin',
'    wwv_flow_working_copy_dev.populate_other_page_changes (',
'        p_application_id => :FB_FLOW_ID,',
'        p_page_id        => :FB_FLOW_PAGE_ID,',
'        p_count          => l_changes_count );',
'    wwv_flow_working_copy_dev.populate_other_page_locks (',
'        p_application_id => :FB_FLOW_ID,',
'        p_page_id        => :FB_FLOW_PAGE_ID,',
'        p_count          => l_locks_count );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>3271766028959643
);
end;
/
prompt --application/pages/page_05335
begin
wwv_flow_imp_page.create_page(
 p_id=>5335
,p_name=>'Working Copy Page Diff'
,p_alias=>'PAGE-DIFF'
,p_page_mode=>'MODAL'
,p_step_title=>'Viewing Page Differences'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'.page-diff {',
'    padding-inline: 12px;',
'    margin-bottom: 12px;',
'}',
'.page-diff--target {',
'    padding-inline-start: 0;',
'}',
'.page-diff--target:before {',
'    content: '''';',
'    display: block;',
'    height: 40px;',
'    width: 2px;',
'    position: absolute;',
'    background: currentColor;',
'    left: -16px;',
'    opacity: .1;',
'}',
'',
'.page-diff-title {',
'    font-size: 16px;',
'    font-weight: bold;',
'    color: var(--a-palette-primary-contrast);',
'}',
'',
'.page-diff-desc {',
'    margin-top: 4px;',
'    color: var(--a-palette-primary-shade);',
'}'))
,p_page_css_classes=>'ui-dialog--stretch'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_chained=>'N'
,p_protection_level=>'C'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3268991611959615)
,p_plug_name=>'Hidden items container'
,p_plug_display_sequence=>40
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3608399818663413)
,p_plug_name=>'Page Does Not Exist'
,p_region_css_classes=>'a-Alert--inlineDialog a-Alert--noTitle u-tC'
,p_region_template_options=>'#DEFAULT#:a-Alert--danger:a-Alert--wizard'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>50
,p_plug_source=>'<p>Page &P5335_EXPORT_PAGE_ID. does not exist in the target application.</p>'
,p_plug_display_condition_type=>'NOT_EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_steps ',
' where id                = :P5335_EXPORT_PAGE_ID ',
'   and flow_id           = :P5335_RIGHT_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5783850556898848)
,p_plug_name=>'Diff Viewer'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_steps ',
' where id                = :P5335_EXPORT_PAGE_ID ',
'   and flow_id           = :P5335_RIGHT_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_landmark_type=>'region'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7438595207674113)
,p_plug_name=>'Source Applications'
,p_region_name=>'details'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_steps ',
' where id                = :P5335_EXPORT_PAGE_ID ',
'   and flow_id           = :P5335_RIGHT_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_landmark_type=>'region'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3607823576663408)
,p_plug_name=>'Main'
,p_parent_plug_id=>wwv_flow_imp.id(7438595207674113)
,p_region_css_classes=>'page-diff'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="page-diff-title">&P5335_APP_NAME!HTML. (Main)</div>',
'<div class="page-diff-desc">',
'    Application &P5335_RIGHT_ID!HTML. ',
'    &middot; Page &P5335_EXPORT_PAGE_ID. ',
'    <span class="&P5335_RIGHT_UPDATED_DISP_CLS!ATTR.">',
'        &middot; Last updated &P5335_RIGHT_UPDATED_ON!HTML. by &P5335_RIGHT_UPDATED_BY!HTML.',
'    </span>',
'</div>'))
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P5335_COMPARING_MAIN'
,p_plug_display_when_cond2=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7438692006674114)
,p_plug_name=>'Base'
,p_parent_plug_id=>wwv_flow_imp.id(7438595207674113)
,p_region_css_classes=>'page-diff'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>30
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="page-diff-title">&WORKING_COPY_NAME!HTML. (Current)</div>',
'<div class="page-diff-desc">',
'    Application &FB_FLOW_ID!HTML. ',
'    &middot; Page &P5335_EXPORT_PAGE_ID. ',
'    <span class="&P5335_LEFT_UPDATED_DISP_CLS!ATTR.">&middot; Last updated &P5335_LEFT_UPDATED_ON!HTML. by &P5335_LEFT_UPDATED_BY!HTML.</span>',
'</div>'))
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7438780909674115)
,p_plug_name=>'Changed'
,p_parent_plug_id=>wwv_flow_imp.id(7438595207674113)
,p_region_css_classes=>'page-diff page-diff--target'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class="page-diff-title">&P5335_APP_NAME!HTML.</div>',
'<div class="page-diff-desc">',
'    Application &P5335_RIGHT_ID!HTML. ',
'    &middot; Page &P5335_EXPORT_PAGE_ID. ',
'    <span class="&P5335_RIGHT_UPDATED_DISP_CLS!ATTR.">',
'        &middot; Last updated &P5335_RIGHT_UPDATED_ON!HTML. by &P5335_RIGHT_UPDATED_BY!HTML.',
'    </span>',
'</div>'))
,p_translate_title=>'N'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_plug_display_when_condition=>'P5335_COMPARING_MAIN'
,p_plug_display_when_cond2=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2021831429029210)
,p_name=>'P5335_LEFT_UPDATED_ON'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(3268991611959615)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2021926608029211)
,p_name=>'P5335_LEFT_UPDATED_BY'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(3268991611959615)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2022264389029214)
,p_name=>'P5335_RIGHT_UPDATED_ON'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(3268991611959615)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2022368609029215)
,p_name=>'P5335_RIGHT_UPDATED_BY'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(3268991611959615)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2022420496029216)
,p_name=>'P5335_RIGHT_UPDATED_DISP_CLS'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(3268991611959615)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2022574984029217)
,p_name=>'P5335_LEFT_UPDATED_DISP_CLS'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(3268991611959615)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3269754242959623)
,p_name=>'P5335_EXPORT_PAGE_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3268991611959615)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3270464034959630)
,p_name=>'P5335_DIFF_JSON'
,p_data_type=>'CLOB'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3268991611959615)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3270867225959634)
,p_name=>'P5335_APP_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(3268991611959615)
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(working_copy_name, name)',
'  from wwv_flows',
' where id                = :P5335_RIGHT_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3607920235663409)
,p_name=>'P5335_COMPARING_MAIN'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3268991611959615)
,p_source=>'N'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3613862595925704)
,p_name=>'P5335_RIGHT_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3268991611959615)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5784360738898853)
,p_name=>'P5335_DIFF_VIEWER'
,p_data_type=>'CLOB'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(5783850556898848)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Differences View'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_json sys.json_object_t;',
'begin',
'    l_json := sys.json_object_t();',
'    l_json.put( ''original'', ''''); ',
'    l_json.put( ''modified'', '''');',
'    return l_json.to_clob;',
'end;'))
,p_source_type=>'FUNCTION_BODY'
,p_source_language=>'PLSQL'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_imp.id(4923925522744860)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_plugin_init_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function( options ) {',
'    options.heightFn = () => {',
'        return $( ".a-Dialog-body" ).height() - $( "#details" ).height();',
'    };',
'    return options;',
'}'))
,p_attribute_01=>'yaml'
,p_attribute_04=>'N'
,p_attribute_07=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2021771691029209)
,p_computation_sequence=>10
,p_computation_item=>'P5335_EXPORT_PAGE_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'FB_FLOW_PAGE_ID'
,p_compute_when=>'P5335_EXPORT_PAGE_ID'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3269847882959624)
,p_name=>'Show spinner and get contents'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXISTS'
,p_display_when_cond=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_steps ',
' where id                = :P5335_EXPORT_PAGE_ID ',
'   and flow_id           = :P5335_RIGHT_ID',
'   and security_group_id = :WORKSPACE_ID'))
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3270011296959626)
,p_event_id=>wwv_flow_imp.id(3269847882959624)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_name=>'Show spinner'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'setTimeout(function() {',
'    apex.util.showSpinner();',
'}, 500 );'))
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3269920607959625)
,p_event_id=>wwv_flow_imp.id(3269847882959624)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_name=>'Get diff contents'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    :P5335_DIFF_JSON := wwv_flow_working_copy_dev.diff_pages(',
'                            p_left_app_id    => :FB_FLOW_ID,',
'                            p_right_app_id   => :P5335_RIGHT_ID,',
'                            p_page_id        => :P5335_EXPORT_PAGE_ID,',
'                            p_comparing_main => (:P5335_COMPARING_MAIN = ''Y'') );',
'end;'))
,p_attribute_03=>'P5335_DIFF_JSON'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'N'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3270209897959628)
,p_name=>'Remove spinner and update diff'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P5335_DIFF_JSON'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3270112555959627)
,p_event_id=>wwv_flow_imp.id(3270209897959628)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_name=>'Remove spinner'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'$(".u-Processing").remove();'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3270561977959631)
,p_event_id=>wwv_flow_imp.id(3270209897959628)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.items.P5335_DIFF_VIEWER.setValue(apex.items.P5335_DIFF_JSON.getValue());'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2022120273029213)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Initialize Hidden Items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'',
'    select to_char( last_updated_on, ''YYYY.MM.DD HH24:MI:SS'' ), ',
'           last_updated_by, ',
'           decode( ',
'               last_updated_on, ',
'               null, ''u-hidden'' )',
'      into :P5335_LEFT_UPDATED_ON, ',
'           :P5335_LEFT_UPDATED_BY, ',
'           :P5335_LEFT_UPDATED_DISP_CLS',
'      from wwv_flow_steps',
'     where flow_id            = :FB_FLOW_ID',
'       and id                 = :P5335_EXPORT_PAGE_ID',
'       and security_group_id  = :WORKSPACE_ID;',
'',
'    select to_char( last_updated_on, ''YYYY.MM.DD HH24:MI:SS'' ), ',
'           last_updated_by, ',
'           decode( ',
'               last_updated_on, ',
'               null, ''u-hidden'' )',
'      into :P5335_RIGHT_UPDATED_ON, ',
'           :P5335_RIGHT_UPDATED_BY, ',
'           :P5335_RIGHT_UPDATED_DISP_CLS',
'      from wwv_flow_steps',
'     where flow_id            = :P5335_RIGHT_ID',
'       and id                 = :P5335_EXPORT_PAGE_ID',
'       and security_group_id  = :WORKSPACE_ID;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_steps ',
' where id                = :P5335_EXPORT_PAGE_ID ',
'   and flow_id           = :P5335_RIGHT_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_process_when_type=>'EXISTS'
,p_internal_uid=>2022120273029213
);
end;
/
prompt --application/pages/page_06000
begin
wwv_flow_imp_page.create_page(
 p_id=>6000
,p_name=>'Data Package - Select Tables'
,p_alias=>'DATA-PACKAGE-SELECT-TABLES1'
,p_step_title=>'Data Package - Select Tables'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(117814363885361293)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(3200591188196688)
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6301071404752397)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(4589709522084091)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(264955122693003915)
,p_plug_name=>'Create Script'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(264955200008003916)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(264955787061003922)
,p_plug_name=>'Tables'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(252876725633187309)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(264955200008003916)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:473:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(252877119702187312)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(264955200008003916)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(252877465257187313)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(264955200008003916)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(252881030025187325)
,p_branch_name=>'Go To Page 6001'
,p_branch_action=>'f?p=&APP_ID.:6001:&SESSION.::&DEBUG.:6001:P6001_SCRIPT_NAME,P6001_SCRIPT_SEQUENCE,P6001_OBJECT_OWNER:&P6000_SCRIPT_NAME.,&P6000_SCRIPT_SEQUENCE.,&P6000_OBJECT_OWNER.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(252877119702187312)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(252881410270187325)
,p_branch_name=>'Go To Page 850'
,p_branch_action=>'f?p=&APP_ID.:850:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(252877465257187313)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1706301228626367)
,p_name=>'P6000_SCRIPT_TYPE'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_imp.id(264955787061003922)
,p_item_default=>'INSTALL'
,p_prompt=>'Script Type:'
,p_source=>'P850_MODE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'SUPPORTING OBJECT SCRIPT TYPES'
,p_lov=>'.'||wwv_flow_imp.id(57799129745997268)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the type of supporting object script you are creating.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1707125394629439)
,p_name=>'P6000_SCRIPT_SOURCE_TYPE'
,p_item_sequence=>4
,p_item_plug_id=>wwv_flow_imp.id(264955787061003922)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Script Source Type:'
,p_source=>'P850_SCRIPT_SOURCE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'INSTALL_SCRIPT_SOURCE'
,p_lov=>'.'||wwv_flow_imp.id(4626801323289842)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'This is the method you are using to create an installation script.  All installation scripts except Data Package are editable after they are created.  To change the script source type, go back to the first step of this wizard.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(252878157813187313)
,p_name=>'P6000_SCRIPT_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(264955787061003922)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a name for the script you are creating.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(252878562175187316)
,p_name=>'P6000_SCRIPT_SEQUENCE'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(264955787061003922)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(max(sequence),0) + 10',
'  from wwv_flow_install_scripts ',
' where flow_id = :FB_FLOW_ID;'))
,p_item_default_type=>'SQL_QUERY'
,p_prompt=>'Sequence'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a sequence number for the script you are creating.  The scripts will be run in order according to the sequence numbers.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(252878936309187316)
,p_name=>'P6000_OBJECT_OWNER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(264955787061003922)
,p_item_default=>'wwv_flow_wizard_api.get_flow_owner'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Object Owner'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the database user that owns the object.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(252879725225187317)
,p_name=>'P6000_TABLES'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(264955787061003922)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select listagg(d,'':'') tables from (',
'select object_name d',
'   from wwv_flow_install_objects',
'  where flow_id = :FB_FLOW_ID',
'    and object_type = ''TABLE''',
'    and upper(object_name) like ''%'' || upper(:P6000_FILTER) ||''%''',
'union',
' select table_name d',
'   from apex_application_lovs',
'  where application_id = :FB_FLOW_ID',
'  and upper(table_name) like ''%'' || upper(:P6000_FILTER) ||''%''',
'union',
' select db_table_name d',
'   from apex_application_page_db_items',
'  where application_id = :FB_FLOW_ID',
'  and upper(db_table_name) like ''%'' || upper(:P6000_FILTER) ||''%''',
'union',
' select r.table_name d',
'   from apex_application_page_regions r, sys.dba_tables t',
'  where r.application_id = :FB_FLOW_ID',
'    and r.table_name = t.table_name',
'    and r.table_owner = t.owner',
'    and upper(r.table_name) like ''%'' || upper(:P6000_FILTER) ||''%''',
'union',
' select table_name d',
'   from apex_application_page_chart_s',
'  where application_id = :FB_FLOW_ID',
'  and upper(table_name) like ''%'' || upper(:P6000_FILTER) ||''%''',
'order by d )'))
,p_item_default_type=>'SQL_QUERY_COLON'
,p_prompt=>'Tables'
,p_display_as=>'NATIVE_SHUTTLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name d, object_name r',
'  from sys.dba_objects',
' where owner = :P6000_OBJECT_OWNER',
'   and object_name not like ''SYS\_%'' escape ''\''',
'   and object_name not like ''APEX$%''',
'   and object_type = ''TABLE''',
'   --and object_type in (select * from table(wwv_flow_string.split(:P855_OBJECT_TYPE,'':'')))',
'   --and (instr(object_name,upper(:P858_FILTER)) > 0 or :P858_FILTER is null)',
'   and upper(object_name) like ''%''  || upper(:P6000_FILTER) ||''%''',
'union',
'select object_name d,',
'        object_name r',
'   from wwv_flow_install_objects',
'  where flow_id = :FB_FLOW_ID',
'    and object_type = ''TABLE''',
'    and upper(object_name) like ''%'' || upper(:P6000_FILTER) ||''%''',
'union',
' select table_name d,',
'        table_name r',
'   from apex_application_lovs',
'  where application_id = :FB_FLOW_ID',
'  and upper(table_name) like ''%'' || upper(:P6000_FILTER) ||''%''',
'union',
' select db_table_name d,',
'        db_table_name r',
'   from apex_application_page_db_items',
'  where application_id = :FB_FLOW_ID',
'  and upper(db_table_name) like ''%'' || upper(:P6000_FILTER) ||''%''',
'union',
' select r.table_name d,',
'        r.table_name r',
'   from apex_application_page_regions r, sys.dba_tables t',
'  where r.application_id = :FB_FLOW_ID',
'    and r.table_name = t.table_name',
'    and r.table_owner = t.owner',
'    and upper(r.table_name) like ''%'' || upper(:P6000_FILTER) ||''%''',
'union',
' select table_name d,',
'        table_name r',
'   from apex_application_page_chart_s',
'  where application_id = :FB_FLOW_ID',
'  and upper(table_name) like ''%'' || upper(:P6000_FILTER) ||''%''',
'  order by d'))
,p_lov_cascade_parent_items=>'P6000_FILTER'
,p_ajax_items_to_submit=>'P6000_OBJECT_OWNER'
,p_ajax_optimize_refresh=>'N'
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Note: Table data will be packaged in the order specified. Child tables that rely on foreign key data should appear after the parent tables.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'ALL'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(265280529031302202)
,p_name=>'P6000_FILTER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(264955787061003922)
,p_prompt=>'Filter'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a filter criteria for the object list and press enter.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1712556321736470)
,p_validation_name=>'P6000_SCRIPT_NAME'
,p_validation_sequence=>10
,p_validation=>'P6000_SCRIPT_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Please specify a name for your script.'
,p_when_button_pressed=>wwv_flow_imp.id(252877119702187312)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2218821802597630)
,p_validation_name=>'Must select a table'
,p_validation_sequence=>20
,p_validation=>'P6000_TABLES'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'You must select at least one table.'
,p_associated_item=>wwv_flow_imp.id(252879725225187317)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2218905897597631)
,p_name=>'Set Focus'
,p_event_sequence=>10
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2219099767597632)
,p_event_id=>wwv_flow_imp.id(2218905897597631)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6000_SCRIPT_NAME'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(252880140974187324)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Clean coll'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if wwv_flow_collection.collection_exists(''DATA_MIG_TABLE_COLUMNS'') then ',
'        wwv_flow_collection.delete_collection (',
'            p_collection_name => ''DATA_MIG_TABLE_COLUMNS'');',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(252877119702187312)
,p_internal_uid=>252880140974187324
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(252950369766747003)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'  cursor c_values is ',
'    select t.column_value as table_name',
'      from',
'        table ( wwv_flow_string.split(:P6000_TABLES, '':'') ) t',
'     where t.column_value is not null;',
'',
'begin',
'    wwv_flow_collection.create_or_truncate_collection(''DATA_MIG_TABLES'');',
'    --save table names into new collection',
'    --c001 -> Table Name',
'    --c002 -> Customized Y/N, default N',
'    --c003 -> Where Clause',
'    --c004 -> configure columns flag Y/N, default N',
'    --n001 -> Rownum',
'    ',
'    for c in c_values loop',
'        wwv_flow_collection.add_member(',
'            p_collection_name => ''DATA_MIG_TABLES'',',
'            p_c001            => c.table_name,',
'            p_c002            => ''N'',',
'            p_c003            => null,',
'            p_c004            => ''N'',',
'            p_n001            =>  10000',
'        );',
'    end loop;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>252950369766747003
);
end;
/
prompt --application/pages/page_06001
begin
wwv_flow_imp_page.create_page(
 p_id=>6001
,p_name=>'Data Package - Tables'
,p_alias=>'DATA-PACKAGE-ALL-TABLES'
,p_step_title=>'Data Package - Tables'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(117814363885361293)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(3200591188196688)
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8104450044586612)
,p_plug_name=>'progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(4589709522084091)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(252923282316646394)
,p_plug_name=>'Data Migration - Tables'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>10
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with the_counts as',
'  (select ac.c001 table_name,',
'          (select count(*) ',
'            from wwv_flow_collections ac2',
'            inner join table(wwv_data_pkg_int.supported_data_types) sdt',
'              on ac2.c003 like sdt.column_value',
'          where ac2.collection_name = ''DATA_MIG_TABLE_COLUMNS''',
'            and ac2.c001 = ac.c001',
'            and ac2.c006 = ''Y'') collection_columns,',
'          (select count(*)',
'            from dba_tab_columns dtc',
'            where dtc.owner = :P6001_OBJECT_OWNER',
'              and dtc.table_name = ac.c001) total_columns,',
'          (select count(*)',
'            from sys.dba_tab_columns dtc',
'            inner join table(wwv_data_pkg_int.supported_data_types) sdt',
'              on dtc.data_type like sdt.column_value',
'            where dtc.owner = :P6001_OBJECT_OWNER',
'              and dtc.table_name = ac.c001) supported_columns',
'    from wwv_flow_collections ac',
'    where collection_name = ''DATA_MIG_TABLES'')',
'select seq_id,',
'       c001,',
'       c003,',
'       n001,',
'       case when the_counts.collection_columns = 0 then the_counts.supported_columns',
'         else the_counts.collection_columns',
'         end included_columns,',
'       the_counts.total_columns',
'from wwv_flow_collections ac',
'inner join the_counts on the_counts.table_name = ac.c001',
'where collection_name = ''DATA_MIG_TABLES''',
'order by c001'))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_page_header=>'Data Migration - Tables'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(252923369323646394)
,p_name=>'Data Migration - Tables'
,p_max_row_count=>'1000'
,p_max_row_count_message=>'The maximum row count for this report is #MAX_ROW_COUNT# rows.  Please apply a filter to reduce the number of records in your query.'
,p_no_data_found_message=>'No data found.'
,p_allow_report_saving=>'N'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_select_columns=>'N'
,p_show_filter=>'N'
,p_show_sort=>'N'
,p_show_control_break=>'N'
,p_show_highlight=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_pivot=>'N'
,p_show_flashback=>'N'
,p_show_download=>'N'
,p_enable_mail_download=>'N'
,p_owner=>'EDIAZ@INSUM.CA'
,p_internal_uid=>252923369323646394
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(252924107654646396)
,p_db_column_name=>'SEQ_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Config'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(252924541313646396)
,p_db_column_name=>'C001'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Tables'
,p_column_link=>'f?p=&APP_ID.:6002:&SESSION.::&DEBUG.:6002:P6002_TABLE_SEQ_ID:#SEQ_ID#'
,p_column_linktext=>'#C001#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(252945359624646409)
,p_db_column_name=>'N001'
,p_display_order=>56
,p_column_identifier=>'BC'
,p_column_label=>'Rows'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(252952040432747020)
,p_db_column_name=>'C003'
,p_display_order=>76
,p_column_identifier=>'BF'
,p_column_label=>'Where Clause'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(258271548702096317)
,p_db_column_name=>'INCLUDED_COLUMNS'
,p_display_order=>86
,p_column_identifier=>'BI'
,p_column_label=>'Included Columns'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(271870302483321804)
,p_db_column_name=>'TOTAL_COLUMNS'
,p_display_order=>96
,p_column_identifier=>'BJ'
,p_column_label=>'Columns'
,p_column_html_expression=>'#INCLUDED_COLUMNS# of #TOTAL_COLUMNS#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
,p_help_text=>'# of included columns / # of total columns in table'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(252957906602756693)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'2529580'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'SEQ_ID:C001:N001:C003::INCLUDED_COLUMNS:TOTAL_COLUMNS'
,p_sort_column_1=>'C001'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(252950169471747001)
,p_plug_name=>'Create Script'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(277162631434148119)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1850656139316149662)
,p_plug_name=>'Information'
,p_region_template_options=>'#DEFAULT#:a-Alert--colorBG:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source=>'BLOB data type is currently not supported for export.'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
' select null ',
'   from sys.dba_tab_columns dtc ',
'  where dtc.owner = :P6001_OBJECT_OWNER ',
'    and dtc.table_name in (select c001 from wwv_flow_collections where collection_name = ''DATA_MIG_TABLES'') ',
'    and dtc.data_type = ''BLOB'''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(252956392155753203)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(277162631434148119)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:473:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(252957160251753203)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(277162631434148119)
,p_button_name=>'FINISH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Finish'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(252957567189753204)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(277162631434148119)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:6000:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(253033270703155539)
,p_branch_name=>'Branch to page 473'
,p_branch_action=>'f?p=&APP_ID.:473:&SESSION.::&DEBUG.:473::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(252957160251753203)
,p_branch_sequence=>60
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1801857337826835)
,p_name=>'P6001_SCRIPT_TYPE'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_imp.id(252923282316646394)
,p_item_default=>'INSTALL'
,p_prompt=>'Script Type:'
,p_source=>'P850_MODE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'SUPPORTING OBJECT SCRIPT TYPES'
,p_lov=>'.'||wwv_flow_imp.id(57799129745997268)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identifies the type of supporting object script you are creating.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1802692994831795)
,p_name=>'P6001_SOURCE_SCRIPT_TYPE'
,p_item_sequence=>4
,p_item_plug_id=>wwv_flow_imp.id(252923282316646394)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Script Source Type:'
,p_source=>'P850_SCRIPT_SOURCE'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'INSTALL_SCRIPT_SOURCE'
,p_lov=>'.'||wwv_flow_imp.id(4626801323289842)||'.'
,p_tag_css_classes=>'fielddatabold'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_protection_level=>'I'
,p_help_text=>'This is the method you are using to create an installation script.  All installation scripts except Data Package are editable after they are created.  To change the script source type, go back to the first step of this wizard.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(252950476480747004)
,p_name=>'P6001_SCRIPT_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(252923282316646394)
,p_prompt=>'Name:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the name for the script you are creating.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(252950581573747005)
,p_name=>'P6001_SCRIPT_SEQUENCE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(252923282316646394)
,p_prompt=>'Sequence:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the sequence number for the script you are creating.  The scripts will be run in order according to the sequence numbers.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(252950645802747006)
,p_name=>'P6001_OBJECT_OWNER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(252923282316646394)
,p_prompt=>'Object Owner:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the owner of the database object.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(271870415773321805)
,p_name=>'P6001_REMOVE_AFTER_LOAD'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(252923282316646394)
,p_item_default=>'Y'
,p_prompt=>'Remove After Load'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'When enabled, this switch will create a script that will remove the generated static files upon application install. You can manually update the generated script to change this setting.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2218797231597629)
,p_validation_name=>'At least one column included'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select null',
'  from wwv_flow_collections',
' where collection_name = ''DATA_MIG_TABLE_COLUMNS'' ',
'   and c006 = ''Y''',
' union',
' select count(*)',
'   from sys.dba_tab_columns dtc, wwv_flow_collections ac,',
'        table(wwv_data_pkg_int.supported_data_types) sdt',
'  where dtc.owner = :P6001_OBJECT_OWNER',
'    and dtc.data_type like sdt.column_value',
'    and dtc.table_name = ac.c001',
'    and ac.collection_name = ''DATA_MIG_TABLES''',
' having count(*) > 0'))
,p_validation_type=>'EXISTS'
,p_error_message=>'There are no columns included in this data package.'
,p_when_button_pressed=>wwv_flow_imp.id(252957160251753203)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(48418747398656801)
,p_validation_name=>'Check for duplicate script name '
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name  ',
'  from wwv_flow_install_scripts ',
' where name              = :P6001_SCRIPT_NAME',
'   and security_group_id = :WORKSPACE_ID;'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Script name must be unique.'
,p_when_button_pressed=>wwv_flow_imp.id(252957160251753203)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(252951635156747016)
,p_name=>'OnDialogClosed - Refresh Report'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(252923282316646394)
,p_bind_type=>'live'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(252951749013747017)
,p_event_id=>wwv_flow_imp.id(252951635156747016)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(252923282316646394)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2219125773597633)
,p_name=>'Set Focus'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2219215217597634)
,p_event_id=>wwv_flow_imp.id(2219125773597633)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_FOCUS'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6001_REMOVE_AFTER_LOAD'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(252951385370747013)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Execute Data Package'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'',
'l_table_rec         wwv_data_pkg_int.t_data_migration;',
'l_table_recs        wwv_data_pkg_int.t_data_migration_tab;',
'',
'l_column_rec        wwv_data_pkg_int.t_column_info default null;',
'',
'l_script_id         number;',
'l_script_name       varchar2(4000) := :P6001_SCRIPT_NAME;',
'',
'c_app_id            number := :FB_FLOW_ID;',
'l_sequence          number := :P6001_SCRIPT_SEQUENCE;',
'',
'l_count             number;',
'l_count_1           number;',
'',
'l_count_nw number;',
'',
'cursor c_tables is ',
'    select *',
'      from wwv_flow_collections',
'     where collection_name = ''DATA_MIG_TABLES'';',
'',
'begin',
'    -- DATA_MIG_TABLES --',
'    --c001 -> Table Name',
'    --c002 -> Customized Y/N, default N',
'    --c003 -> Where Clause',
'    --n001 -> Rownum',
'',
'    -- DATA_MIG_TABLE_COLUMNS --',
'    --c001 => table name',
'    --c002 => column name',
'    --c003 => column type ',
'    --c004 => override column value',
'    --c005 => mask value flag Y/N',
'    --c006 => include column',
'    --c020 -> redact expression',
'    --c021 -> REDACT_TYPE',
'    --c022 -> FUNCTION_PARMS',
'    --c023 -> REGEXP_PATTERN',
'    --c024 -> REGEXP_REPLACE_STR',
'    --c025 -> REGEXP_POSITION',
'    --c026 -> REGEXP_OCCURANCE',
'    --c027 -> REGEXP_MATCH_PARM ',
'',
'    l_count_1   := 0;',
'    l_count     := 0;',
'    ',
'    --loop through the selected tables',
'    for c in c_tables loop',
'        l_count := l_count + 1;',
'        l_table_rec.table_owner     := :P6001_OBJECT_OWNER;',
'        l_table_rec.table_name      := trim(c.c001);',
'        l_table_rec.where_clause    := nvl(c.c003, null);',
'        l_table_rec.number_of_rows  := c.n001;',
'        ',
'        --loop through the columns of that table',
'        for col in (select * ',
'                      from wwv_flow_collections ',
'                     where collection_name = ''DATA_MIG_TABLE_COLUMNS'' ',
'                       and c001 = c.c001) loop',
'',
'            -- add  override value',
'            if col.c004 is not null then',
'                l_column_rec.value_override := col.c004;',
'            end if;',
'',
'            -- add data masking',
'            if (col.c006 = ''Y'') then',
'                l_count_1 := l_count_1 + 1;',
'                l_column_rec.column_name    := col.c002;',
'                if col.c005 = ''Y'' then',
'                    l_column_rec.column_mask := true;',
'                    l_column_rec.redact_exp  := col.c020; -- REDACT_EXP',
'                    l_column_rec.redact_type := col.c021; -- REDACT_TYPE',
'                    l_column_rec.func_parms  := col.c022; -- FUNCTION_PARMS',
'                    l_column_rec.regexp_pat  := col.c023; -- REGEXP_PATTERN',
'                    l_column_rec.regexp_rep  := col.c024; -- REGEXP_REPLACE_STR',
'                    l_column_rec.regexp_pos  := col.c025; -- REGEXP_POSITION',
'                    l_column_rec.regexp_occ  := col.c026; -- REGEXP_OCCURANCE',
'                    l_column_rec.regexp_matp := col.c027; -- REGEXP_MATCH_PARM  ',
'                else',
'                    l_column_rec.column_mask := false;',
'                end if;',
'',
'                l_table_rec.column_tab(l_count_1) := l_column_rec;',
'                l_column_rec := null;',
'            end if;',
'        end loop; ',
'',
'        l_table_recs(l_count)       := l_table_rec;',
'        ',
'        l_table_rec := null;',
'        ',
'        l_count_1 := 0;',
'    end loop; ',
'',
'    ',
'    wwv_data_pkg_int.create_data_migration( ',
'        p_target_app_id         =>  c_app_id,',
'        p_tables                =>  l_table_recs,',
'        p_script_name           =>  l_script_name,',
'        p_sequence              =>  l_sequence,',
'        p_remove_after_load     => nvl(:P6001_REMOVE_AFTER_LOAD,''Y'') = ''Y'',',
'        p_script_id             => l_script_id);',
'',
'    commit;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error creating data package.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(252957160251753203)
,p_process_success_message=>'Install data package script created, data package added to Shared Components.'
,p_internal_uid=>252951385370747013
);
end;
/
prompt --application/pages/page_06002
begin
wwv_flow_imp_page.create_page(
 p_id=>6002
,p_name=>'Data Package - Table Configuration'
,p_alias=>'DATA-PKG-TABLE-CONFIGURATION'
,p_page_mode=>'MODAL'
,p_step_title=>'Data - Table Configuration'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(117814363885361293)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(3200591188196688)
,p_dialog_height=>'700'
,p_dialog_width=>'1100'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(252952317441747023)
,p_plug_name=>'Columns'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select dtc.column_name,',
'       dtc.column_id,',
'        dtc.data_type,',
'        case when dtc.data_type in (''CHAR'',''VARCHAR2'',''NUMBER'') then ''(''||dtc.data_length||'')''',
'             else null',
'        end data_length,',
'       nvl( (select ac.c005',
'          from wwv_flow_collections ac',
'         where collection_name = ''DATA_MIG_TABLE_COLUMNS'' ',
'           and ac.c001 = :P6002_TABLE_NAME',
'           and ac.c002 = column_name) ,''N'')as mask_flag,',
'        nvl( (select ac.c006 ',
'          from wwv_flow_collections ac',
'         where collection_name = ''DATA_MIG_TABLE_COLUMNS'' ',
'           and ac.c001 = :P6002_TABLE_NAME',
'           and ac.c002 = column_name ) ,''N'') as included,',
'       ''config'' as config,',
'       nvl2(sdt.column_value,''Y'',''N'') is_supported',
'from sys.dba_tab_cols dtc',
'left outer join table(wwv_data_pkg_int.supported_data_types) sdt',
'  on dtc.data_type like sdt.column_value',
'where dtc.table_name = :P6002_TABLE_NAME',
' and owner = :P6002_OBJECT_OWNER',
' and hidden_column = ''NO''',
'order by dtc.column_name;'))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P6002_TABLE_SEQ_ID,P6002_OBJECT_OWNER,P6002_TABLE_NAME'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Columns'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(252952482704747024)
,p_max_row_count=>'1000000'
,p_allow_report_saving=>'N'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_select_columns=>'N'
,p_show_filter=>'N'
,p_show_sort=>'N'
,p_show_control_break=>'N'
,p_show_highlight=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_pivot=>'N'
,p_show_flashback=>'N'
,p_show_download=>'N'
,p_enable_mail_download=>'N'
,p_owner=>'EDIAZ@INSUM.CA'
,p_internal_uid=>252952482704747024
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(252952869022747028)
,p_db_column_name=>'CONFIG'
,p_display_order=>10
,p_column_identifier=>'D'
,p_column_label=>'Config'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(252952557487747025)
,p_db_column_name=>'COLUMN_NAME'
,p_display_order=>20
,p_column_identifier=>'A'
,p_column_label=>'Column Name'
,p_column_link=>'f?p=&APP_ID.:6003:&SESSION.::&DEBUG.:6003:P6003_COLUMN_NAME,P6003_OBJECT_OWNER,P6003_DATA_TYPE,P6003_OBJECT_NAME,P6003_TABLE_SEQ_ID,P6003_DATA_TYPE_DISPLAY:#COLUMN_NAME#,&P6002_OBJECT_OWNER.,#DATA_TYPE#,&P6002_TABLE_NAME.,&P6002_TABLE_SEQ_ID.,#DATA_T'
||'YPE# #DATA_LENGTH#'
,p_column_linktext=>'#COLUMN_NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(252952693116747026)
,p_db_column_name=>'DATA_TYPE'
,p_display_order=>30
,p_column_identifier=>'B'
,p_column_label=>'Data Type'
,p_column_html_expression=>'#DATA_TYPE# #DATA_LENGTH#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(252952734057747027)
,p_db_column_name=>'MASK_FLAG'
,p_display_order=>50
,p_column_identifier=>'C'
,p_column_label=>'Masked'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_column_alignment=>'CENTER'
,p_rpt_named_lov=>wwv_flow_imp.id(84887415298521126)
,p_rpt_show_filter_lov=>'1'
,p_display_condition_type=>'FUNCTION_BODY'
,p_display_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select 1 ',
'             from sys.dba_tab_privs ',
'            where privilege = ''EXECUTE'' ',
'              and table_name = ''DBMS_REDACT'' ',
'              and grantee = :P6002_OBJECT_OWNER ) loop',
'    return true;',
'end loop;',
'return false;'))
,p_display_condition2=>'PLSQL'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(258270825808096310)
,p_db_column_name=>'INCLUDED'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>'Included'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_column_alignment=>'CENTER'
,p_rpt_named_lov=>wwv_flow_imp.id(84887415298521126)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(265280456140302201)
,p_db_column_name=>'IS_SUPPORTED'
,p_display_order=>70
,p_column_identifier=>'G'
,p_column_label=>'Supported'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_column_alignment=>'CENTER'
,p_rpt_named_lov=>wwv_flow_imp.id(84887415298521126)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
,p_help_text=>'Only supported data types will be included in the data package.'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(265281068918302207)
,p_db_column_name=>'COLUMN_ID'
,p_display_order=>80
,p_column_identifier=>'H'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2218551482597627)
,p_db_column_name=>'DATA_LENGTH'
,p_display_order=>90
,p_column_identifier=>'I'
,p_column_label=>'Data Length'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(253149509657296841)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'2531496'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'CONFIG:COLUMN_ID:COLUMN_NAME:DATA_TYPE:INCLUDED:MASK_FLAG:IS_SUPPORTED::DATA_LENGTH'
,p_sort_column_1=>'COLUMN_ID'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(277097272295955910)
,p_plug_name=>'Data Migration'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(277102291650031131)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(295357732045140549)
,p_plug_name=>'Config'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(252896602500636217)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(277102291650031131)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(252897485899636217)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(277102291650031131)
,p_button_name=>'SAVE_TABLE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Table'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(252898947686636218)
,p_name=>'P6002_OBJECT_OWNER'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(295357732045140549)
,p_item_default=>'wwv_flow_wizard_api.get_flow_owner'
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(252899378364636218)
,p_name=>'P6002_TABLE_NAME'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(295357732045140549)
,p_prompt=>'Table Name:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select table_name as d,',
'    table_name as r',
'from all_tables',
'where table_name like ''%WWV_DG%'';'))
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Identifies the current table being configured.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(252899783923636218)
,p_name=>'P6002_WHERE_C'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(295357732045140549)
,p_prompt=>'Where Clause'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter an optional where clause to filter the number of rows exported.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(252900190195636218)
,p_name=>'P6002_ROWNUM'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(295357732045140549)
,p_prompt=>'Rows'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the maximum number or rows in the table to export.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(252902579612636222)
,p_name=>'P6002_NUM_TABLES_LEFT'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(295357732045140549)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(252902986287636222)
,p_name=>'P6002_TABLES'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(295357732045140549)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(252903362875636222)
,p_name=>'P6002_SCRIPT_NAME'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(295357732045140549)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(252903759375636222)
,p_name=>'P6002_TABLE_SEQUENCE'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(295357732045140549)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(252904163494636222)
,p_name=>'P6002_TABLE_SEQ_ID'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(295357732045140549)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(252904555255636222)
,p_name=>'P6002_OVR_COLUMN_CONCAT'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(295357732045140549)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2218441447597626)
,p_computation_sequence=>10
,p_computation_item=>'P6002_OBJECT_OWNER'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_wizard_api.get_flow_owner'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(252918678795636237)
,p_name=>'Enable Function Parameters'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P6002_REDACT_TYPE'
,p_condition_element=>'P6002_REDACT_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'PARTIAL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(252919105755636238)
,p_event_id=>wwv_flow_imp.id(252918678795636237)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6002_FUNCTION_PARMS'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(252919609095636238)
,p_event_id=>wwv_flow_imp.id(252918678795636237)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6002_FUNCTION_PARMS'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(252920018679636238)
,p_name=>'Enable REGEXP Items'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P6002_REDACT_TYPE'
,p_condition_element=>'P6002_REDACT_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REGEXP'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(252920569771636239)
,p_event_id=>wwv_flow_imp.id(252920018679636238)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6002_REGEXP_PATTERN,P6002_REGEXP_REPLACE_STR,P6002_REGEXP_POSITION,P6002_REGEXP_OCCURANCE,P6002_REGEXP_MATCH_PARM'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(252921043540636239)
,p_event_id=>wwv_flow_imp.id(252920018679636238)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6002_REGEXP_PATTERN,P6002_REGEXP_REPLACE_STR,P6002_REGEXP_POSITION,P6002_REGEXP_OCCURANCE,P6002_REGEXP_MATCH_PARM'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(252951401517747014)
,p_name=>'OnClick - Close Modal'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(252896602500636217)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(252951562240747015)
,p_event_id=>wwv_flow_imp.id(252951401517747014)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(252950755625747007)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch Collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    select c001,',
'           c003,',
'           n001',
'      into :P6002_TABLE_NAME,',
'           :P6002_WHERE_C,',
'           :P6002_ROWNUM',
'      from wwv_flow_collections',
'     where collection_name = ''DATA_MIG_TABLES''',
'       and seq_id = :P6002_TABLE_SEQ_ID;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>252950755625747007
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(258270961966096311)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Add all table columns'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    cursor data_columns is',
'        select dtc.*, sdt.column_value supported_type',
'          from sys.dba_tab_cols dtc',
'          left outer join table(wwv_data_pkg_int.supported_data_types) sdt',
'            on dtc.data_type like sdt.column_value',
'         where table_name = :P6002_TABLE_NAME',
'           and dtc.owner = :P6002_OBJECT_OWNER',
'           and dtc.hidden_column = ''NO''',
'           and not exists (select null ',
'                             from wwv_flow_collections ',
'                            where collection_name = ''DATA_MIG_TABLE_COLUMNS''',
'                              and c001 = :P6002_TABLE_NAME);',
'begin',
'    -- DATA_MIG_TABLES --',
'    --c001 -> Table Name',
'    --c002 -> Customized Y/N, default N',
'    --c003 -> Where Clause',
'    --n001 -> Rownum',
'',
'    -- DATA_MIG_TABLE_COLUMNS --',
'    --c001 => table name',
'    --c002 => column name',
'    --c003 => column type ',
'    --c004 => override column value',
'    --c005 => mask value flag Y/N',
'    --c006 => include column',
'    --c007 => supported column data type',
'    --c020 -> redact expression',
'    --c021 -> REDACT_TYPE',
'    --c022 -> FUNCTION_PARMS',
'    --c023 -> REGEXP_PATTERN',
'    --c024 -> REGEXP_REPLACE_STR',
'    --c025 -> REGEXP_POSITION',
'    --c026 -> REGEXP_OCCURANCE',
'    --c027 -> REGEXP_MATCH_PARM ',
'    --n001 -> data_length',
'',
'',
'    if not wwv_flow_collection.collection_exists(''DATA_MIG_TABLE_COLUMNS'') then ',
'        wwv_flow_collection.create_collection(''DATA_MIG_TABLE_COLUMNS'');',
'    end if;',
'',
'        for i in data_columns loop',
'            wwv_flow_collection.add_member(',
'                p_collection_name => ''DATA_MIG_TABLE_COLUMNS'',',
'                p_c001            => :P6002_TABLE_NAME,',
'                p_c002            => i.column_name,',
'                p_c003            => i.data_type,',
'                p_c004            => null,',
'                p_c005            => ''N'',',
'                p_c006            => case when i.supported_type is not null then ''Y''',
'                                          else ''N''',
'                                          end,',
'                p_c007            => case when i.supported_type is not null then ''Y''',
'                                          else ''N''',
'                                          end,                          ',
'                p_n001            => i.data_length',
'            );',
'        end loop;',
'        ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>258270961966096311
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(252917464030636229)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update Table Collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin ',
'    wwv_flow_collection.update_member_attribute(',
'        p_collection_name => ''DATA_MIG_TABLES'',',
'        p_seq  => :P6002_TABLE_SEQ_ID,',
'        p_attr_number => ''1'',',
'        p_number_value  => :P6002_ROWNUM',
'    );',
'',
'    wwv_flow_collection.update_member_attribute(',
'        p_collection_name => ''DATA_MIG_TABLES'',',
'        p_seq  => :P6002_TABLE_SEQ_ID,',
'        p_attr_number => ''2'',',
'        p_attr_value  => ''Y''',
'    );',
'    wwv_flow_collection.update_member_attribute(',
'        p_collection_name => ''DATA_MIG_TABLES'',',
'        p_seq  => :P6002_TABLE_SEQ_ID,',
'        p_attr_number => ''3'',',
'        p_attr_value  => :P6002_WHERE_C',
'    );',
'    wwv_flow_collection.update_member_attribute(',
'        p_collection_name => ''DATA_MIG_TABLES'',',
'        p_seq  => :P6002_TABLE_SEQ_ID,',
'        p_attr_number => ''4'',',
'        p_attr_value  => ''Y''',
'    );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CANCEL'
,p_process_when_type=>'REQUEST_NOT_EQUAL_CONDITION'
,p_internal_uid=>252917464030636229
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(252951229781747012)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'On Finish - Close Dialog'
,p_attribute_02=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(252897485899636217)
,p_internal_uid=>252951229781747012
);
end;
/
prompt --application/pages/page_06003
begin
wwv_flow_imp_page.create_page(
 p_id=>6003
,p_name=>'Data - Column Configuration'
,p_alias=>'DATA-COLUMN-CONFIGURATION'
,p_page_mode=>'MODAL'
,p_step_title=>'Data - Column Configuration'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(117814363885361293)
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(3200591188196688)
,p_dialog_height=>'700'
,p_dialog_width=>'1100'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(252953643742747036)
,p_plug_name=>'Column Info'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--hideHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(257883755982505706)
,p_plug_name=>'Data Masking Options'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_region_attributes=>'style = "display: none"'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(257885602378505725)
,p_plug_name=>'Data Override'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P6003_SUPPORTED_OVERRIDE'
,p_plug_display_when_cond2=>'1'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(534966138498506506)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(257864105664475376)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(534966138498506506)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:6002:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(257864551491475376)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(534966138498506506)
,p_button_name=>'FINISH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Column'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(258270724558096309)
,p_branch_name=>'Go To Page 6002'
,p_branch_action=>'f?p=&APP_ID.:6002:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2218641625597628)
,p_name=>'P6003_DATA_TYPE_DISPLAY'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(252953643742747036)
,p_prompt=>'Data Type:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the data type of the column.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(252953794637747037)
,p_name=>'P6003_OBJECT_NAME'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(252953643742747036)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(257885716383505726)
,p_name=>'P6003_NEW_COL_VALUE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(257885602378505725)
,p_prompt=>'Column Override Value'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The format of the Override Value must match the underlying database session NLS parameter for that data type.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(257885894549505727)
,p_name=>'P6003_OBJECT_OWNER'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(252953643742747036)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(257885991901505728)
,p_name=>'P6003_DATA_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(252953643742747036)
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Identifies the data type of the column.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(257886156338505730)
,p_name=>'P6003_COLUMN_NAME'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(252953643742747036)
,p_prompt=>'Column Name:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_grid_column=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the name of the column.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(257886327792505732)
,p_name=>'P6003_MASK_COLUMN'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(252953643742747036)
,p_prompt=>'Mask Column'
,p_display_as=>'NATIVE_YES_NO'
,p_begin_on_new_line=>'N'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select 1 ',
'             from sys.dba_tab_privs ',
'            where privilege = ''EXECUTE'' ',
'              and table_name = ''DBMS_REDACT'' ',
'              and grantee = :P6003_OBJECT_OWNER ) loop',
'    return true;',
'end loop;',
'return false;'))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'FUNCTION_BODY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Choose whether you want to configure data masking for this column.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(257890026826534593)
,p_name=>'P6003_REDACT_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(257883755982505706)
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Enter a unique name for the redaction policy.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(257892735663542093)
,p_name=>'P6003_REDACT_TYPE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(257883755982505706)
,p_prompt=>'Function Type'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>'STATIC2:Full;FULL,Partial;PARTIAL,Regular Expression;REGEXP,Random;RANDOM,None;NONE'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'-- Select Redact Type --'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a function that sets the type of redaction.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(257893831907549867)
,p_name=>'P6003_FUNCTION_PARMS'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(257883755982505706)
,p_prompt=>'Function Parameters'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'REDACT_FUNC_PARMS'
,p_lov=>'.'||wwv_flow_imp.id(1633884855696516)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Enter or choose from the pop-up list how the column redaction should appear. See Syntax for Performing Partial Data Redaction in Oracle Database Advanced Security Guide 12c Release 1 (12.1) for more information.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(257894619082551512)
,p_name=>'P6003_REGEXP_PATTERN'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(257883755982505706)
,p_prompt=>'Regular Expression Pattern'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'REDACT_REGEXP_PATTERN'
,p_lov=>'.'||wwv_flow_imp.id(1638174978696518)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Enter or choose from the pop-up list a regular expression to match the data that is to be redacted. If a match is made then it will be redacted using the regular expression specified in the Regular Expression Replace String field.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(257895415360553165)
,p_name=>'P6003_REGEXP_REPLACE_STR'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(257883755982505706)
,p_prompt=>'Regular Expression Replace String'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'REDACT_REGEXP_REPL_STR'
,p_lov=>'.'||wwv_flow_imp.id(1640893349696518)||'.'
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Enter or choose from the pop-up list how you want to replace the data to be redacted. It can be of any of the data types CHAR, VARCHAR2, NCHAR, or NVARCHAR2. The regexp_replace_string can contain up to 500 back references to subexpressions in the for'
||'m \n, where n is a number from 1 to 9. If you want to include a backslash (\) in the regexp_replace_string setting, then you must precede it with the escape character, which is also a backslash. For example, to literally replace the matched pattern w'
||'ith \2 (rather than replace it with the second matched subexpression of the matched pattern) you would enter \\2 in the regexp_replace_string setting. For more information, see Oracle Database SQL Language Reference.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(257896275457554730)
,p_name=>'P6003_REGEXP_POSITION'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(257883755982505706)
,p_item_default=>'1'
,p_prompt=>'Regular Expression Position'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>3
,p_cMaxlength=>10
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the starting position for the string search. This is a positive integer indicating the character of the column_name data where Oracle Database should begin the search. The default is 1 , meaning that Oracle Database begins the search at the fir'
||'st character of the column_name data.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(257897063825556111)
,p_name=>'P6003_REGEXP_OCCURANCE'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(257883755982505706)
,p_item_default=>'0'
,p_prompt=>'Regular Expression Occurance'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>5
,p_cMaxlength=>10
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a non-negative integer to specify the occurrence to perform the search and replace operation. If you enter 0, all occurrences will be replaced.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(257897806647557623)
,p_name=>'P6003_REGEXP_MATCH_PARM'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(257883755982505706)
,p_prompt=>'Regular Expression Match Parameter'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REGEXP_MATCH_PARAM'
,p_lov=>'.'||wwv_flow_imp.id(1644350231696519)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'-- Select Match Parameter --'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the default matching behavior of the function. The behavior of this parameter is the same for this function as for the REGEXP_REPLACE SQL function.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(258269958935096301)
,p_name=>'P6003_INCLUDE_COLUMN'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(252953643742747036)
,p_prompt=>'Include Column'
,p_display_as=>'NATIVE_YES_NO'
,p_begin_on_new_line=>'N'
,p_read_only_when=>'P6003_SUPPORTED_DATA_TYPE'
,p_read_only_when2=>'N'
,p_read_only_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify whether to include this column.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(258270120118096303)
,p_name=>'P6003_TABLE_SEQ_ID'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(252953643742747036)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(258271640625096318)
,p_name=>'P6003_SUPPORTED_OVERRIDE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(257885602378505725)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(282947558378837921)
,p_name=>'P6003_LENGTH'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(252953643742747036)
,p_display_as=>'NATIVE_HIDDEN'
,p_display_when=>':P6003_LENGTH is not null and :P6003_DATA_TYPE in (''VARCHAR2'', ''CHAR'', ''NUMBER'')'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_help_text=>'Identifies the length of the column.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(282947605104837922)
,p_name=>'P6003_FORMAT_MASK'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(257885602378505725)
,p_prompt=>'Format Mask'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_begin_on_new_line=>'N'
,p_begin_on_new_field=>'N'
,p_display_when=>'P6003_FORMAT_MASK'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identifies the format mask applied based on the column data type.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(282947726440837923)
,p_name=>'P6003_SUPPORTED_DATA_TYPE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(252953643742747036)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(258271736663096319)
,p_validation_name=>'Override value matches column data type format mask'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_timestamp         timestamp;',
'    l_timestamp_tz      timestamp with time zone;',
'    l_timestamp_ltz     timestamp with local time zone;',
'    l_date              date;',
'    l_data_length       number;',
'begin',
'    select data_length',
'      into l_data_length',
'      from sys.dba_tab_cols',
'     where table_name = :P6003_OBJECT_NAME',
'       and owner = :P6003_OBJECT_OWNER',
'       and column_name = :P6003_COLUMN_NAME',
'       and hidden_column = ''NO'';',
'    ',
'    if (:P6003_DATA_TYPE in (''VARCHAR2'', ''CHAR'', ''NUMBER'')) then',
'        if length(:P6003_NEW_COL_VALUE) > l_data_length then',
'            return false;',
'        else',
'            return true;',
'        end if;',
'    elsif (:P6003_DATA_TYPE = ''DATE'') then',
'        begin',
'            select to_date(:P6003_NEW_COL_VALUE)',
'              into l_date',
'              from dual;',
'            ',
'            return true;',
'',
'            exception when others then',
'                return false;',
'        end;',
'    elsif (:P6003_DATA_TYPE = ''TIMESTAMP(%)'') then',
'        begin',
'            select to_timestamp(:P6003_NEW_COL_VALUE)',
'              into l_timestamp',
'              from dual;',
'            ',
'            return true;',
'',
'            exception when others then',
'                return false;',
'        end;',
'    elsif (:P6003_DATA_TYPE = ''TIMESTAMP(%) WITH TIME ZONE'') then',
'        begin',
'            select to_timestamp_tz(:P6003_NEW_COL_VALUE)',
'              into l_timestamp_tz',
'              from dual;',
'            ',
'            return true;',
'',
'            exception when others then',
'                return false;',
'        end;',
'    elsif (:P6003_DATA_TYPE = ''TIMESTAMP(%) WITH LOCAL TIME ZONE'') then',
'        begin',
'            select cast(:P6003_NEW_COL_VALUE as timestamp with local time zone) ',
'              into l_timestamp_ltz',
'              from dual;',
'            ',
'            return true;',
'',
'            exception when others then',
'                return false;',
'        end;',
'    end if;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Override Value does not match column data type format mask or maximum length.'
,p_associated_item=>wwv_flow_imp.id(257885716383505726)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(257899337354569846)
,p_name=>'Enable Function Parameters'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P6003_REDACT_TYPE'
,p_condition_element=>'P6003_REDACT_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'PARTIAL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(257899761239569847)
,p_event_id=>wwv_flow_imp.id(257899337354569846)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6003_FUNCTION_PARMS'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(257900206417569847)
,p_event_id=>wwv_flow_imp.id(257899337354569846)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6003_FUNCTION_PARMS'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(257900622085580383)
,p_name=>'Enable REGEXP Items'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P6003_REDACT_TYPE'
,p_condition_element=>'P6003_REDACT_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REGEXP'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(257901050569580384)
,p_event_id=>wwv_flow_imp.id(257900622085580383)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6003_REGEXP_PATTERN,P6003_REGEXP_REPLACE_STR,P6003_REGEXP_POSITION,P6003_REGEXP_OCCURANCE,P6003_REGEXP_MATCH_PARM'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(257901590062580384)
,p_event_id=>wwv_flow_imp.id(257900622085580383)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6003_REGEXP_PATTERN,P6003_REGEXP_REPLACE_STR,P6003_REGEXP_POSITION,P6003_REGEXP_OCCURANCE,P6003_REGEXP_MATCH_PARM'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(258271251396096314)
,p_name=>'OnChange - Toggle Data Redaction Fields'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P6003_MASK_COLUMN'
,p_condition_element=>'P6003_MASK_COLUMN'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(258271394211096315)
,p_event_id=>wwv_flow_imp.id(258271251396096314)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(257883755982505706)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(271870186393321802)
,p_event_id=>wwv_flow_imp.id(258271251396096314)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(257885602378505725)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(258271418169096316)
,p_event_id=>wwv_flow_imp.id(258271251396096314)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(257883755982505706)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(271870017759321801)
,p_event_id=>wwv_flow_imp.id(258271251396096314)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(257885602378505725)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(271870236701321803)
,p_event_id=>wwv_flow_imp.id(258271251396096314)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6003_NEW_COL_VALUE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(258270004138096302)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Save Column in Collection'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_seq_id          number;',
'    l_count     number;',
'    l_redact_action varchar2(128);',
'begin',
'',
'        -- DATA_MIG_TABLES --',
'    --c001 -> Table Name',
'    --c002 -> Customized Y/N, default N',
'    --c003 -> Where Clause',
'    --n001 -> Rownum',
'',
'    -- DATA_MIG_TABLE_COLUMNS --',
'    --c001 => table name',
'    --c002 => column name',
'    --c003 => column type ',
'    --c004 => override column value',
'    --c005 => mask value flag Y/N',
'    --c006 => include column',
'    --c020 -> redact expression',
'    --c021 -> REDACT_TYPE',
'    --c022 -> FUNCTION_PARMS',
'    --c023 -> REGEXP_PATTERN',
'    --c024 -> REGEXP_REPLACE_STR',
'    --c025 -> REGEXP_POSITION',
'    --c026 -> REGEXP_OCCURANCE',
'    --c027 -> REGEXP_MATCH_PARM ',
'    ',
'    if not wwv_flow_collection.collection_exists(''DATA_MIG_TABLE_COLUMNS'') then ',
'        wwv_flow_collection.create_collection(''DATA_MIG_TABLE_COLUMNS'');',
'    end if;',
'',
'    --check if column info already exists in collection',
'    select count(seq_id)',
'      into l_count',
'      from wwv_flow_collections',
'     where collection_name = ''DATA_MIG_TABLE_COLUMNS''',
'       and c001 = :P6003_OBJECT_NAME',
'       and c002 = :P6003_COLUMN_NAME;',
'    ',
'    if l_count = 0 then',
'        --add column info as new collection row ',
'        wwv_flow_collection.add_member(',
'            p_collection_name => ''DATA_MIG_TABLE_COLUMNS'',',
'            p_c001            => :P6003_OBJECT_NAME,',
'            p_c002            => :P6003_COLUMN_NAME,',
'            p_c003            => :P6003_DATA_TYPE,',
'            p_c004            => :P6003_NEW_COL_VALUE,',
'            p_c005            => :P6003_MASK_COLUMN,',
'            p_c006            => :P6003_INCLUDE_COLUMN,',
'            p_c007            => :P6003_SUPPORTED_DATA_TYPE,',
'            p_c020            => ''1=1'',',
'            p_c021            => :P6003_REDACT_TYPE,',
'            p_c022            => :P6003_FUNCTION_PARMS,',
'            p_c023            => :P6003_REGEXP_PATTERN,',
'            p_c024            => :P6003_REGEXP_REPLACE_STR,',
'            p_c025            => :P6003_REGEXP_POSITION,',
'            p_c026            => :P6003_REGEXP_OCCURANCE,',
'            p_c027            => :P6003_REGEXP_MATCH_PARM,',
'            p_n001            => :P6003_LENGTH',
'        );',
'    else',
'        select seq_id',
'          into l_seq_id',
'          from wwv_flow_collections',
'         where collection_name = ''DATA_MIG_TABLE_COLUMNS''',
'           and c001 = :P6003_OBJECT_NAME',
'           and c002 = :P6003_COLUMN_NAME;',
'        ',
'        wwv_flow_collection.update_member (',
'            p_collection_name => ''DATA_MIG_TABLE_COLUMNS'',',
'            p_seq             => l_seq_id,',
'            p_c001            => :P6003_OBJECT_NAME,',
'            p_c002            => :P6003_COLUMN_NAME,',
'            p_c003            => :P6003_DATA_TYPE,',
'            p_c004            => :P6003_NEW_COL_VALUE,',
'            p_c005            => :P6003_MASK_COLUMN,',
'            p_c006            => :P6003_INCLUDE_COLUMN,',
'            p_c007            => :P6003_SUPPORTED_DATA_TYPE,',
'            p_c020            => ''1=1'',',
'            p_c021            => :P6003_REDACT_TYPE,',
'            p_c022            => :P6003_FUNCTION_PARMS,',
'            p_c023            => :P6003_REGEXP_PATTERN,',
'            p_c024            => :P6003_REGEXP_REPLACE_STR,',
'            p_c025            => :P6003_REGEXP_POSITION,',
'            p_c026            => :P6003_REGEXP_OCCURANCE,',
'            p_c027            => :P6003_REGEXP_MATCH_PARM,',
'            p_n001            => :P6003_LENGTH',
'        );',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>258270004138096302
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(257886078225505729)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Populate Redaction Items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    cursor c_column is ',
'    select *',
'      from wwv_flow_collections',
'     where collection_name = ''DATA_MIG_TABLE_COLUMNS''',
'       and c001 = :P6003_OBJECT_NAME',
'       and c002 = :P6003_COLUMN_NAME;',
'begin',
'        -- DATA_MIG_TABLES --',
'    --c001 -> Table Name',
'    --c002 -> Customized Y/N, default N',
'    --c003 -> Where Clause',
'    --n001 -> Rownum',
'',
'    -- DATA_MIG_TABLE_COLUMNS --',
'    --c001 => table name',
'    --c002 => column name',
'    --c003 => column type ',
'    --c004 => override column value',
'    --c005 => mask value flag Y/N',
'    --c006 => include column',
'    --c007 => supported data type Y/N',
'    --c020 -> redact expression',
'    --c021 -> REDACT_TYPE',
'    --c022 -> FUNCTION_PARMS',
'    --c023 -> REGEXP_PATTERN',
'    --c024 -> REGEXP_REPLACE_STR',
'    --c025 -> REGEXP_POSITION',
'    --c026 -> REGEXP_OCCURANCE',
'    --c027 -> REGEXP_MATCH_PARM ',
'    --n001 -> data_length   ',
'',
'    for c in c_column loop',
'        :P6003_NEW_COL_VALUE := c.c004;',
'        :P6003_MASK_COLUMN := c.c005;',
'        :P6003_INCLUDE_COLUMN := c.c006;',
'        :P6003_REDACT_TYPE := c.c021;',
'        :P6003_FUNCTION_PARMS := c.c022;',
'        :P6003_REGEXP_PATTERN := c.c023;',
'        :P6003_REGEXP_REPLACE_STR := c.c024;',
'        :P6003_REGEXP_POSITION := c.c025;',
'        :P6003_REGEXP_OCCURANCE := c.c026;',
'        :P6003_REGEXP_MATCH_PARM := c.c027;',
'        :P6003_LENGTH := c.n001;',
'        :P6003_SUPPORTED_DATA_TYPE := c.c007;',
'',
'        case  ',
'            when c.c003 = ''DATE'' then ',
'                select value ',
'                  into :P6003_FORMAT_MASK',
'                  from nls_session_parameters',
'                  where parameter = ''NLS_DATE_FORMAT'';',
'            when c.c003 like ''TIMESTAMP(%)'' then',
'                select value ',
'                  into :P6003_FORMAT_MASK',
'                  from nls_session_parameters',
'                  where parameter = ''NLS_TIMESTAMP_FORMAT'';',
'            when c.c003 like ''TIMESTAMP(%) WITH TIME ZONE'' then',
'                select value ',
'                  into :P6003_FORMAT_MASK',
'                  from nls_session_parameters',
'                  where parameter = ''NLS_TIMESTAMP_TZ_FORMAT'';      ',
'            when c.c003 like ''TIMESTAMP(%) WITH LOCAL TIME ZONE'' then',
'                select value ',
'                  into :P6003_FORMAT_MASK',
'                  from nls_session_parameters',
'                  where parameter = ''NLS_TIMESTAMP_FORMAT'';        ',
'            else :P6003_FORMAT_MASK := null;',
'        end case;',
'    end loop;',
'',
'    select count(*) ',
'      into :P6003_SUPPORTED_OVERRIDE',
'      from table(wwv_data_pkg_int.supported_override_types)',
'      where :P6003_DATA_TYPE like column_value;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>257886078225505729
);
end;
/
prompt --application/pages/page_06100
begin
wwv_flow_imp_page.create_page(
 p_id=>6100
,p_name=>'Map Backgrounds'
,p_alias=>'MAP-BACKGROUNDS'
,p_step_title=>'Map Backgrounds'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3079055206425104)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(1385199811261560)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Map Backgrounds'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3084457844524926)
,p_plug_name=>'Map Backgrounds'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with messages as (',
'    select ( select wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_UP_TO_DATE'') from sys.dual ) up_to_date,',
'           ( select wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_NEEDS_REFRESH'') from sys.dual ) needs_refresh,',
'           ( select wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_UNKNOWN'') from sys.dual ) unknown_status,',
'           ( select wwv_flow_lang_dev.builder_message(''SUBSCRIBED_FROM.NONEXISTING_MASTER'') from sys.dual ) no_master',
'      from sys.dual )',
'select mbg.id,',
'       mbg.name,',
'       (select wwv_flow_lang.system_message( ''MAP_BACKGROUND.TYPES.'' || mbg.type )',
'          from sys.dual )',
'       as type,',
'       mbg.url,',
'       mbg.api_key,',
'       mbg.attribution,',
'       mbg.map_comment,',
'       ''icon-sc-app-search'' icon_class,',
'       wwv_flow_page_api.get_url(',
'           p_application => :APP_ID,',
'           p_page        => 6120,',
'           p_clear_cache => 6120,',
'           p_items       => ''P6120_ID'',',
'           p_values      => mbg.id ) edit_link,',
'       coalesce( mbg.last_updated_on, mbg.created_on ) last_updated,',
'       coalesce( mbg.last_updated_by, mbg.created_by ) last_updated_by,',
'       --',
'       case when mbg.reference_id is not null then',
'           coalesce ( to_char( master.flow_id ),',
'                       messages.no_master )',
'       end as subscribed_from,',
'       ( select case when count(*) > 0 then count(*) end',
'           from wwv_flow_map_backgrounds sub',
'          where sub.reference_id      = mbg.id',
'            and sub.security_group_id = :WORKSPACE_ID ) as subscribers,',
'       case when mbg.reference_id is not null then',
'           case',
'               when master.version_scn = mbg.version_scn then',
'                   messages.up_to_date',
'               when master.version_scn != mbg.version_scn then',
'                   messages.needs_refresh',
'               else',
'                   messages.unknown_status',
'           end',
'       end subscription_status,',
'       --',
'       null action',
'  from wwv_flow_map_backgrounds mbg,',
'       wwv_flow_map_backgrounds master,',
'       messages',
' where mbg.flow_id                = :FB_FLOW_ID',
'   and mbg.security_group_id      = :WORKSPACE_ID',
'   and mbg.reference_id           = master.id (+)',
'   and mbg.security_group_id      = master.security_group_id (+)'))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Search Configurations'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(3084545848524927)
,p_no_data_found_message=>'No Map Backgrounds are defined for this application.'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_download_formats=>'CSV:HTML'
,p_enable_mail_download=>'Y'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#EDIT_LINK#" class="a-IRR-icon"><span class="a-Icon icon-page-map"></span><span class="a-IRR-iconName">#NAME#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'CBCHO'
,p_internal_uid=>3084545848524927
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3084650651524928)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1775390048700701)
,p_db_column_name=>'NAME'
,p_display_order=>20
,p_column_identifier=>'O'
,p_column_label=>'Name'
,p_column_link=>'f?p=&APP_ID.:6120:&SESSION.::&DEBUG.:6120:P6120_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1775473498700702)
,p_db_column_name=>'TYPE'
,p_display_order=>30
,p_column_identifier=>'P'
,p_column_label=>'Type'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1775513741700703)
,p_db_column_name=>'URL'
,p_display_order=>40
,p_column_identifier=>'Q'
,p_column_label=>'URL'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1775623761700704)
,p_db_column_name=>'ICON_CLASS'
,p_display_order=>50
,p_column_identifier=>'R'
,p_column_label=>'Icon Class'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1775759602700705)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>60
,p_column_identifier=>'S'
,p_column_label=>'Edit Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1859435429065947)
,p_db_column_name=>'API_KEY'
,p_display_order=>70
,p_column_identifier=>'V'
,p_column_label=>'API Key'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1859511957065948)
,p_db_column_name=>'ATTRIBUTION'
,p_display_order=>80
,p_column_identifier=>'W'
,p_column_label=>'Attribution'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1859660877065949)
,p_db_column_name=>'MAP_COMMENT'
,p_display_order=>90
,p_column_identifier=>'X'
,p_column_label=>'Map Comment'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1775814189700706)
,p_db_column_name=>'LAST_UPDATED'
,p_display_order=>100
,p_column_identifier=>'T'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1775996062700707)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>110
,p_column_identifier=>'U'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1943138205646310)
,p_db_column_name=>'SUBSCRIBED_FROM'
,p_display_order=>120
,p_column_identifier=>'Y'
,p_column_label=>'Subscribed From'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1943236528646311)
,p_db_column_name=>'SUBSCRIBERS'
,p_display_order=>130
,p_column_identifier=>'Z'
,p_column_label=>'Subscribers'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(6613782343558842)
,p_db_column_name=>'SUBSCRIPTION_STATUS'
,p_display_order=>140
,p_column_identifier=>'AA'
,p_column_label=>'Subscription Status'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1496524870970612)
,p_db_column_name=>'ACTION'
,p_display_order=>160
,p_column_identifier=>'AC'
,p_column_label=>'Copy'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'TMPL_THEME_3$ACTIONS'
,p_column_alignment=>'CENTER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'ACTIONS_WRAP', 'N',
  'STYLE', 'b-InlineActions--simple')).to_clob
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(3097862378573837)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_type=>'REPORT'
,p_report_alias=>'17083'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'NAME:TYPE:URL:SUBSCRIBED_FROM:SUBSCRIPTION_STATUS:SUBSCRIBERS:LAST_UPDATED:LAST_UPDATED_BY::ACTION'
,p_sort_column_1=>'NAME'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'0'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7116444488802270)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(2317463565649817)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9835426181828718)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'<strong>Map Backgrounds</strong> allow to use different background tile layers for Map Regions, Display Map Items or the Geocoded Address item.',
'</p><p>',
'&PRODUCT_NAME. allows to reference <em>Vector Tile Layers</em>, <em>Raster Tile Layers</em> and map tiles fetched from <em>OGC WMS (Web Map Service)</em> endpoints.',
'</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1393430271334740)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(3084457844524926)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:&APP_PAGE_ID.:&SESSION.::&DEBUG.:RR,::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1394206309334741)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(3084457844524926)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:6110:&SESSION.::&DEBUG.:6110::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2320970264078930)
,p_name=>'Refresh Subscriptions'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(7116444488802270)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2321398054078934)
,p_event_id=>wwv_flow_imp.id(2320970264078930)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3084457844524926)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2321878413078935)
,p_event_id=>wwv_flow_imp.id(2320970264078930)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ( this.data.successMessage ) {',
'    apex.message.showPageSuccess(this.data.successMessage.text);',
'}'))
);
wwv_flow_imp_page.create_component_action(
 p_id=>wwv_flow_imp.id(1496669056970613)
,p_ir_column_id=>wwv_flow_imp.id(1496524870970612)
,p_position_id=>wwv_flow_imp.id(214437533860142316)
,p_display_sequence=>10
,p_template_id=>wwv_flow_imp.id(214438625365151034)
,p_label=>'Copy'
,p_link_target_type=>'REDIRECT_PAGE'
,p_link_target=>'f?p=&APP_ID.:6130:&SESSION.::&DEBUG.:6130:P6130_COPY_SOURCE,P6130_COPY_FROM_ID,P6130_COPY_FROM_APP_ID:THIS,#ID#,&FB_FLOW_ID.'
,p_button_display_type=>'ICON'
,p_icon_css_classes=>'icon-copy'
,p_is_hot=>false
,p_show_as_disabled=>false
);
end;
/
prompt --application/pages/page_06110
begin
wwv_flow_imp_page.create_page(
 p_id=>6110
,p_name=>'Create Map Background'
,p_alias=>'CREATE-MAP-BACKGROUND'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Map Background'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(48253785867089826)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(172750867020091038)
,p_plug_name=>'Create Map Background'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Add a <strong>Map Background</strong> to be used by map components in the application. Raster, Vector, and OGC WMS tiles are supported.</p>',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'generated 16-FEB-2000 23:59:43'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1823157548111507)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(48253785867089826)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(6613923772558844)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(48253785867089826)
,p_button_name=>'COPY_FROM_ANOTHER'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Copy from another app'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:6130:&SESSION.::&DEBUG.:6130:P6130_COPY_SOURCE:OTHER'
,p_button_css_classes=>'a-Button--noUI'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1823420537111508)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(48253785867089826)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create Map Background'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1778898226700736)
,p_branch_name=>'Go to 6120'
,p_branch_action=>'f?p=&APP_ID.:6120:&SESSION.::&DEBUG.:6120:P6120_ID:&P6110_NEW_MAP_BACKGROUND_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(1823420537111508)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1776087800700708)
,p_name=>'P6110_API_KEY'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(172750867020091038)
,p_prompt=>'API Key'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'API Key value that can be set in the URL, if required by the provider.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1776196877700709)
,p_name=>'P6110_XYZ_TILE_SERVER_URL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(172750867020091038)
,p_prompt=>'Raster Tiles (XYZ) URL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'URL used to fetch a raster tile passing x, y, and z values.',
'</p>You can add your API key if provided, and using the placeholder {api-key} to have its value replaced in the URL, e.g.: http://example.com/path/{api-key}.'))
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1776238529700710)
,p_name=>'P6110_WMS_URL'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(172750867020091038)
,p_prompt=>'WMS URL'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'URL used to fetch a map tile layer from the Web Map Service - Open Geospatial Consortium. Pass in the URL with all the required WMS parameters, except the following ones, which are added automatically by the Map Region:',
'<ul>',
'    <li>BBOX</li>',
'    <li>WIDTH</li>',
'    <li>HEIGHT</li>',
'    <li>REQUEST</li>',
'    <li>FORMAT</li>',
'    <li>SRS / CRS</li>',
'</ul>',
'</p><p>',
'Examples:',
'<ul>',
'    <li>https://wms.example.com/wms?service=WMS&version=1.3.0&layers=maplayer&styles=default</li>',
'    <li>https://wms.example.com/wms?service=WMS&version=1.1.1&layers=countries,rivers</li>',
'</ul>',
'</p>You can add your API key if provided, and using the placeholder {api-key} to have its value replaced in the URL, e.g.: http://example.com/path/{api-key}.'))
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1776463400700712)
,p_name=>'P6110_MAP_STYLESHEET'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(172750867020091038)
,p_prompt=>'URL to Map Stylesheet'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'URL used to fetch the style.json file contents describing the map tile layer.',
'</p>You can add your API key if provided, and using the placeholder {api-key} to have its value replaced in the URL, e.g.: http://example.com/path/{api-key}.'))
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1778927660700737)
,p_name=>'P6110_NEW_MAP_BACKGROUND_ID'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(172750867020091038)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3598038547780159)
,p_name=>'P6110_FLOW_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(172750867020091038)
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3598945499780166)
,p_name=>'P6110_NAME'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(172750867020091038)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_escape_on_http_input=>'N'
,p_help_text=>'Enter a name for this Map Background.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3599798422780166)
,p_name=>'P6110_TYPE'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(172750867020091038)
,p_prompt=>'Type'
,p_source=>'VECTOR'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'MAP_BACKGROUND.TYPES'
,p_lov=>'.'||wwv_flow_imp.id(1798811115902278)||'.'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Type of the map tile layer retrieved from a URL.</p>',
'<ul>',
'    <li><strong>Raster XYZ Tile Layer</strong> renders a raster tile that is retrieved from an URL passing x, y, and z values.</li>',
'    <li><strong>Vector Tile Layer</strong> retrieves a map tile layer described in a style.json file from an URL.</li>',
'    <li><strong>OGC WMS</strong> retrieves a layer from the Web Map Service from the Open Geospatial Consortium.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1942621701646305)
,p_validation_name=>'Name is Unique'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_map_backgrounds',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and name              = :P6110_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'The Name "&P6110_NAME!HTML." is already taken by another Map Background.'
,p_always_execute=>'Y'
,p_when_button_pressed=>wwv_flow_imp.id(1823420537111508)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2173859740423019)
,p_validation_name=>'Vector URL NOT NULL'
,p_validation_sequence=>20
,p_validation=>'P6110_MAP_STYLESHEET'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>'P6110_TYPE'
,p_validation_condition2=>'VECTOR'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(1823420537111508)
,p_associated_item=>wwv_flow_imp.id(1776463400700712)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2173930669423020)
,p_validation_name=>'Raster URL NOT NULL'
,p_validation_sequence=>30
,p_validation=>'P6110_XYZ_TILE_SERVER_URL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>'P6110_TYPE'
,p_validation_condition2=>'RASTER'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(1823420537111508)
,p_associated_item=>wwv_flow_imp.id(1776196877700709)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2174000567423021)
,p_validation_name=>'WMS URL NOT NULL'
,p_validation_sequence=>40
,p_validation=>'P6110_WMS_URL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>'P6110_TYPE'
,p_validation_condition2=>'OGCWMS'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(1823420537111508)
,p_associated_item=>wwv_flow_imp.id(1776238529700710)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3278464222031692)
,p_validation_name=>'API Key must have a value'
,p_validation_sequence=>50
,p_validation=>'P6110_API_KEY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value, as the entered URL contains an <strong>api-key</strong> placeholder.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'lower( ',
'    case :P6110_TYPE',
'        when ''VECTOR'' then :P6110_MAP_STYLESHEET',
'        when ''RASTER'' then :P6110_XYZ_TILE_SERVER_URL',
'        when ''OGCWMS'' then :P6110_WMS_URL',
'    end ) like ''%{api-key}%'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(1823420537111508)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1776889179700716)
,p_name=>'Show Hide Raster Field'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P6110_TYPE'
,p_condition_element=>'P6110_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'RASTER'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1776944844700717)
,p_event_id=>wwv_flow_imp.id(1776889179700716)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6110_XYZ_TILE_SERVER_URL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2174157880423022)
,p_event_id=>wwv_flow_imp.id(1776889179700716)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6110_WMS_URL,P6110_MAP_STYLESHEET'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2174210942423023)
,p_event_id=>wwv_flow_imp.id(1776889179700716)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6110_WMS_URL,P6110_MAP_STYLESHEET'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1777146489700719)
,p_name=>'Show Hide OGC WMS URL'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P6110_TYPE'
,p_condition_element=>'P6110_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'OGCWMS'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1777210959700720)
,p_event_id=>wwv_flow_imp.id(1777146489700719)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6110_WMS_URL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2174336389423024)
,p_event_id=>wwv_flow_imp.id(1777146489700719)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6110_MAP_STYLESHEET,P6110_XYZ_TILE_SERVER_URL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2174436724423025)
,p_event_id=>wwv_flow_imp.id(1777146489700719)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6110_MAP_STYLESHEET,P6110_XYZ_TILE_SERVER_URL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1777621363700724)
,p_name=>'Show Hide Vector URL'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P6110_TYPE'
,p_condition_element=>'P6110_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'VECTOR'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1777755745700725)
,p_event_id=>wwv_flow_imp.id(1777621363700724)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6110_MAP_STYLESHEET'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3409865922935604)
,p_event_id=>wwv_flow_imp.id(1777621363700724)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6110_XYZ_TILE_SERVER_URL,P6110_WMS_URL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1778687815700734)
,p_name=>'Close Dialog'
,p_event_sequence=>40
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1823157548111507)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1778717265700735)
,p_event_id=>wwv_flow_imp.id(1778687815700734)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1778500282700733)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Save Map Background'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P6110_NEW_MAP_BACKGROUND_ID := wwv_flow_map_region_dev.create_map_background(   ',
'    p_flow_id      => :P6110_FLOW_ID,',
'    p_name         => :P6110_NAME,',
'    p_type         => :P6110_TYPE,',
'    p_url          => case ',
'                        when :P6110_TYPE = ''RASTER'' then',
'                            :P6110_XYZ_TILE_SERVER_URL',
'                        when :P6110_TYPE = ''OGCWMS'' then',
'                            :P6110_WMS_URL',
'                        when :P6110_TYPE = ''VECTOR'' then',
'                            :P6110_MAP_STYLESHEET',
'                      end,',
'    p_attribution  => null,',
'    p_api_key      => :P6110_API_KEY',
');',
'',
'wwv_flow_debug_api.message(''NEW MAP BACKGROUND ID IS '' || :P6110_NEW_MAP_BACKGROUND_ID);'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1823420537111508)
,p_process_success_message=>'Map Background created.'
,p_internal_uid=>1778500282700733
);
end;
/
prompt --application/pages/page_06120
begin
wwv_flow_imp_page.create_page(
 p_id=>6120
,p_name=>'Edit Map Background'
,p_alias=>'EDIT-MAP-BACKGROUND'
,p_step_title=>'Map Background'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_read_only_when=>'P6120_REFERENCE_ID'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1855427598065907)
,p_plug_name=>'Settings'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_MAP_BACKGROUNDS'
,p_query_where=>'security_group_id = :WORKSPACE_ID and flow_id = :FB_FLOW_ID'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'u:d'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3589710193148165)
,p_plug_name=>'Subscription'
,p_region_name=>'SUBSCRIPTION'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_plug_read_only_when=>'P6120_REFERENCE_ID'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'WWV_FLOW_MAP_BACKGROUNDS',
  'attribute_02', 'NAME',
  'attribute_03', 'P6120_ID',
  'attribute_04', 'P6120_REFERENCE_ID',
  'attribute_05', 'SUBSCRIBE_MAP_BACKGROUND',
  'attribute_06', 'VERSION_SCN')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3600224218217956)
,p_plug_name=>'Map Background: &P6120_NAME.'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>120
,p_plug_display_point=>'REGION_POSITION_04'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3602294767219516)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>130
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'NO')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4554508864010952)
,p_plug_name=>'Advanced'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>150
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3846680306564642)
,p_plug_name=>'History'
,p_parent_plug_id=>wwv_flow_imp.id(4554508864010952)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(29434107863295859)
,p_plug_display_sequence=>40
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'    select last_updated_by, last_updated_on, created_by, created_on ',
'      from wwv_flow_map_backgrounds',
'     where id = :P6120_ID',
'       and flow_id = :FB_FLOW_ID',
'       and security_group_id = :WORKSPACE_ID )',
'loop',
'   wwv_flow_4000_ui.show_history (',
'      p_id              => :P6120_ID,',
'      p_component_type  => ''Map Background'',',
'      p_last_updated_by => c1.last_updated_by,',
'      p_last_updated_on => c1.last_updated_on,',
'      p_created_by      => c1.created_by,',
'      p_created_on      => c1.created_on );',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11863142500567961)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>140
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'<strong>Map Backgrounds</strong> allow to use different background tile layers for Map Regions, Display Map Items or the Geocoded Address item.',
'</p><p>',
'&PRODUCT_NAME. allows to reference <em>Vector Tile Layers</em>, <em>Raster Tile Layers</em> and map tiles fetched from <em>OGC WMS (Web Map Service)</em> endpoints.',
'</p>',
'<p>When map background is subscribed, then it is not possible to change any data.</p>',
'<p>Deletion of the <strong>master</strong> map background automatically clears the map background references from subscribing map backgrounds.</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1878599287075688)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(3589710193148165)
,p_button_name=>'UNSUBSCRIBE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Unsubscribe'
,p_button_position=>'NEXT'
,p_button_condition=>':P6120_REFERENCE_ID is not null and :P6120_SUBSCRIBED_COMP_GRP = ''N'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1889823799145483)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(3600224218217956)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6100:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1878955697075688)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(3589710193148165)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Refresh Map Background'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P6120_REFERENCE_ID is not null ',
'and ( :P6120_VERSION_SCN != :P6120_MASTER_VERSION_SCN or :P6120_VERSION_SCN is null )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1878159768075682)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(3589710193148165)
,p_button_name=>'PUBLISH'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Publish'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.::F4000_P149_ID,F4000_P149_PAGE_ID,F4000_P149_TEMPLATE_TYPE:&P6120_ID.,&APP_PAGE_ID.,MAP_BACKGROUND'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_map_backgrounds',
' where reference_id      = :P6120_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1890298077145483)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(3600224218217956)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_confirm_message=>'Would you like to delete this Map Background?'
,p_confirm_style=>'danger'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P6120_ID is not null ',
'and ( :P6120_REFERENCE_ID is null or :P6120_SUBSCRIBED_COMP_GRP = ''N'' )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1890669015145483)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(3600224218217956)
,p_button_name=>'SAVE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    :P6120_ID is not null ',
'and not wwv_flow_page.is_read_only'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1942345067646302)
,p_branch_action=>'f?p=&APP_ID.:6100:&SESSION.::&DEBUG.:6100::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1399298474080905)
,p_name=>'P6120_ZOOM_MIN'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(4554508864010952)
,p_item_source_plug_id=>wwv_flow_imp.id(1855427598065907)
,p_prompt=>'Minimum Zoom Level'
,p_source=>'ZOOM_MIN'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>15
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the minimal possible zoom level for this map background. ',
'Zoom levels range from <code>0</code> to <code>24</code>, with <code>0</code> being fully zoomed out, and <code>24</code> being zoomed in to the maximum.'))
,p_attribute_01=>'0'
,p_attribute_02=>'24'
,p_attribute_03=>'left'
,p_attribute_04=>'numeric'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1399339052080906)
,p_name=>'P6120_ZOOM_MAX'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(4554508864010952)
,p_item_source_plug_id=>wwv_flow_imp.id(1855427598065907)
,p_prompt=>'Maximum Zoom Level'
,p_source=>'ZOOM_MAX'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>15
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Enter the maximum possible zoom level for this map background. ',
'Zoom levels range from <code>0</code> to <code>24</code>, with <code>0</code> being fully zoomed out, and <code>24</code> being zoomed in to the maximum.'))
,p_attribute_01=>'0'
,p_attribute_02=>'24'
,p_attribute_03=>'left'
,p_attribute_04=>'numeric'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1855699643065909)
,p_name=>'P6120_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1855427598065907)
,p_item_source_plug_id=>wwv_flow_imp.id(1855427598065907)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_protection_level=>'S'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1855779388065910)
,p_name=>'P6120_FLOW_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1855427598065907)
,p_item_source_plug_id=>wwv_flow_imp.id(1855427598065907)
,p_source=>'FLOW_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1855888620065911)
,p_name=>'P6120_SECURITY_GROUP_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1855427598065907)
,p_item_source_plug_id=>wwv_flow_imp.id(1855427598065907)
,p_source=>'SECURITY_GROUP_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1855971241065912)
,p_name=>'P6120_NAME'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(1855427598065907)
,p_item_source_plug_id=>wwv_flow_imp.id(1855427598065907)
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'This is the name of this Map Background.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1856089758065913)
,p_name=>'P6120_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(1855427598065907)
,p_item_source_plug_id=>wwv_flow_imp.id(1855427598065907)
,p_item_default=>'VECTOR'
,p_prompt=>'Type'
,p_source=>'TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'MAP_BACKGROUND.TYPES'
,p_lov=>'.'||wwv_flow_imp.id(1798811115902278)||'.'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Type of the map tile layer retrieved from a URL.</p>',
'<ul>',
'    <li><strong>Raster XYZ Tile Layer</strong> renders a raster tile that is retrieved from an URL passing x, y, and z values.</li>',
'    <li><strong>Vector Tile Layer</strong> retrieves a map tile layer described in a style.json file from an URL.</li>',
'    <li><strong>OGC WMS</strong> retrieves a layer from the Web Map Service from the Open Geospatial Consortium.</li>',
'</ul>'))
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1856119175065914)
,p_name=>'P6120_URL'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(1855427598065907)
,p_item_source_plug_id=>wwv_flow_imp.id(1855427598065907)
,p_source=>'URL'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1856221991065915)
,p_name=>'P6120_ATTRIBUTION'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(1855427598065907)
,p_item_source_plug_id=>wwv_flow_imp.id(1855427598065907)
,p_prompt=>'Attribution'
,p_source=>'ATTRIBUTION'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'<em>Attribution</em> text to display on the lower right corner of the map. This is typically used to show the copyright notice for the map background to users.'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1856373232065916)
,p_name=>'P6120_API_KEY'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(1855427598065907)
,p_item_source_plug_id=>wwv_flow_imp.id(1855427598065907)
,p_prompt=>'API Key'
,p_source=>'API_KEY'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'API Key value to be sent along with the URL, if required by the provider. &PRODUCT_NAME. will replace the <code>{api-key}</code> placeholder in the URL with the value specified here.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1856429275065917)
,p_name=>'P6120_REFERENCE_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3589710193148165)
,p_item_source_plug_id=>wwv_flow_imp.id(1855427598065907)
,p_prompt=>'Subscribe From'
,p_source=>'REFERENCE_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'FLOW_SUBSCRIBE_FROM_MAP_BACKGROUNDS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select mb.flow_id ||'' : ''|| mb.name d,',
'       mb.id r',
'  from wwv_flow_map_backgrounds mb',
' where mb.flow_id != nvl(:FB_FLOW_ID,0)',
'   and mb.security_group_id = :WORKSPACE_ID',
'   and exists (',
'        select *',
'          from wwv_flows f',
'         where f.security_group_id = :WORKSPACE_ID',
'           and f.build_status      not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'           and mb.flow_id           = f.id )',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Subscription -'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select a master map background to subscribe from. When you select a master map background and click <strong>Apply Changes</strong>, this map background will be automatically refreshed from the master. <br /><br />If the map background is already subs'
||'cribed, click <strong>Refresh Map Background</strong> to refresh the map background details from the master.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'Y'
,p_attribute_06=>'0'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1856519109065918)
,p_name=>'P6120_MAP_COMMENT'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(4554508864010952)
,p_item_source_plug_id=>wwv_flow_imp.id(1855427598065907)
,p_prompt=>'Comments'
,p_source=>'MAP_COMMENT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'You can provide a comment for this custom Map Background.',
''))
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1856656032065919)
,p_name=>'P6120_CREATED_BY'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(1855427598065907)
,p_item_source_plug_id=>wwv_flow_imp.id(1855427598065907)
,p_source=>'CREATED_BY'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1856724293065920)
,p_name=>'P6120_CREATED_ON'
,p_source_data_type=>'DATE'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(1855427598065907)
,p_item_source_plug_id=>wwv_flow_imp.id(1855427598065907)
,p_source=>'CREATED_ON'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1856858492065921)
,p_name=>'P6120_LAST_UPDATED_BY'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(1855427598065907)
,p_item_source_plug_id=>wwv_flow_imp.id(1855427598065907)
,p_source=>'LAST_UPDATED_BY'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1856998864065922)
,p_name=>'P6120_LAST_UPDATED_ON'
,p_source_data_type=>'DATE'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(1855427598065907)
,p_item_source_plug_id=>wwv_flow_imp.id(1855427598065907)
,p_source=>'LAST_UPDATED_ON'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1906637356244069)
,p_name=>'P6120_XYZ_TILE_SERVER_URL'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(1855427598065907)
,p_item_source_plug_id=>wwv_flow_imp.id(1855427598065907)
,p_prompt=>'Raster Tiles (XYZ) URL'
,p_source=>'URL'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'URL used to fetch a raster tile passing x, y, and z values.',
'</p>You can add your API key if provided, and using the placeholder {api-key} to have its value replaced in the URL, e.g.: http://example.com/path/{api-key}.'))
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1907425308246307)
,p_name=>'P6120_WMS_URL'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(1855427598065907)
,p_item_source_plug_id=>wwv_flow_imp.id(1855427598065907)
,p_prompt=>'WMS URL'
,p_source=>'URL'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'URL used to fetch a map tile layer from the Web Map Service - Open Geospatial Consortium. Pass in the URL with all the required WMS parameters, except the following ones, which are added automatically by the Map Region:',
'<ul>',
'    <li>BBOX</li>',
'    <li>WIDTH</li>',
'    <li>HEIGHT</li>',
'    <li>REQUEST</li>',
'    <li>FORMAT</li>',
'    <li>SRS / CRS</li>',
'</ul>',
'</p><p>',
'Examples:',
'<ul>',
'    <li>https://wms.example.com/wms?service=WMS&version=1.3.0&layers=maplayer&styles=default</li>',
'    <li>https://wms.example.com/wms?service=WMS&version=1.1.1&layers=countries,rivers</li>',
'</ul>',
'</p>You can add your API key if provided, and using the placeholder {api-key} to have its value replaced in the URL, e.g.: http://example.com/path/{api-key}.'))
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1908292784251682)
,p_name=>'P6120_MAP_STYLESHEET'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(1855427598065907)
,p_item_source_plug_id=>wwv_flow_imp.id(1855427598065907)
,p_prompt=>'URL to Map Stylesheet'
,p_source=>'URL'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'URL used to fetch the style.json file contents describing the map tile layer.',
'</p>You can add your API key if provided, and using the placeholder {api-key} to have its value replaced in the URL, e.g.: http://example.com/path/{api-key}.'))
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2100216874648002)
,p_name=>'P6120_HTTP_HEADERS'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(1855427598065907)
,p_item_source_plug_id=>wwv_flow_imp.id(1855427598065907)
,p_prompt=>'HTTP Headers'
,p_source=>'HTTP_HEADERS'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Add <em>HTTP Request Headers</em>, which are to be sent from the browser to the Map Server. Enter as Key-Value pairs, separated by <code>=</code>, and one per line. Entries in invalid format (for instance, with a missing equals sign) will be ignor'
||'ed.</p>',
'<p>Example:</p>',
'<pre>',
'header-1=value-1',
'header-2=value-2',
'</pre>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2359327064667338)
,p_name=>'P6120_SUBSCRIBED_COMP_GRP'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_imp.id(3589710193148165)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6614010811558845)
,p_name=>'P6120_REFERENCE_ID_INIT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(3589710193148165)
,p_item_default=>'P6120_REFERENCE_ID'
,p_item_default_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6614156554558846)
,p_name=>'P6120_MASTER_VERSION_SCN'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(3589710193148165)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select version_scn ',
'  from wwv_flow_map_backgrounds',
' where id                = :P6120_REFERENCE_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6614246587558847)
,p_name=>'P6120_VERSION_SCN'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(3589710193148165)
,p_item_source_plug_id=>wwv_flow_imp.id(1855427598065907)
,p_source=>'VERSION_SCN'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2359458468667339)
,p_computation_sequence=>10
,p_computation_item=>'P6120_SUBSCRIBED_COMP_GRP'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_component_group_dev.is_part_of_subscribed_comp_grp (',
'    p_component_id   => :P6120_ID,',
'    p_component_type => wwv_flow_copy_metadata.c_custom_map_bkg,',
'    p_app_id         => :FB_FLOW_ID )'))
,p_compute_when=>'P6120_ID'
,p_compute_when_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1858718782065940)
,p_computation_sequence=>10
,p_computation_item=>'P6120_XYZ_TILE_SERVER_URL'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select mbg.url ',
'  from wwv_flow_map_backgrounds mbg ',
' where mbg.id                = :P6120_ID',
'   and mbg.type              = ''RASTER''',
'   and mbg.flow_id           = :FB_FLOW_ID',
'   and mbg.security_group_id = :WORKSPACE_ID;'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1858858117065941)
,p_computation_sequence=>20
,p_computation_item=>'P6120_WMS_URL'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select mbg.url ',
'  from wwv_flow_map_backgrounds mbg ',
' where mbg.id                = :P6120_ID',
'   and mbg.type              = ''OGCWMS''',
'   and mbg.flow_id           = :FB_FLOW_ID',
'   and mbg.security_group_id = :WORKSPACE_ID;'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1858938344065942)
,p_computation_sequence=>30
,p_computation_item=>'P6120_MAP_STYLESHEET'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select mbg.url ',
'  from wwv_flow_map_backgrounds mbg ',
' where mbg.id                = :P6120_ID',
'   and mbg.type              = ''VECTOR''',
'   and mbg.flow_id           = :FB_FLOW_ID',
'   and mbg.security_group_id = :WORKSPACE_ID;'))
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2172603538423007)
,p_validation_name=>'WMS URL NOT NULL'
,p_validation_sequence=>20
,p_validation=>'P6120_WMS_URL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>'P6120_TYPE'
,p_validation_condition2=>'OGCWMS'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(1890669015145483)
,p_associated_item=>wwv_flow_imp.id(1907425308246307)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2172774841423008)
,p_validation_name=>'Raster URL NOT NULL'
,p_validation_sequence=>30
,p_validation=>'P6120_XYZ_TILE_SERVER_URL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>'P6120_TYPE'
,p_validation_condition2=>'RASTER'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(1890669015145483)
,p_associated_item=>wwv_flow_imp.id(1906637356244069)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2172846444423009)
,p_validation_name=>'Vector URL NOT NULL'
,p_validation_sequence=>40
,p_validation=>'P6120_MAP_STYLESHEET'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>'P6120_TYPE'
,p_validation_condition2=>'VECTOR'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(1890669015145483)
,p_associated_item=>wwv_flow_imp.id(1908292784251682)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2172907492423010)
,p_validation_name=>'API Key must have a value'
,p_validation_sequence=>50
,p_validation=>'P6120_API_KEY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value, as the entered URL contains an <strong>api-key</strong> placeholder.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'lower( ',
'    case :P6120_TYPE',
'        when ''VECTOR'' then :P6120_MAP_STYLESHEET',
'        when ''RASTER'' then :P6120_XYZ_TILE_SERVER_URL',
'        when ''OGCWMS'' then :P6120_WMS_URL',
'    end ) like ''%{api-key}%'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(1890669015145483)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2173086481423011)
,p_validation_name=>'Min Zoom Level less than Max Zoom Level'
,p_validation_sequence=>60
,p_validation=>'to_number( nvl( :P6120_ZOOM_MIN, ''0'' ) ) <= to_number( nvl( :P6120_ZOOM_MAX, ''24'' ) )'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Minimum Zoom Level must be less than or equal to the Maximum Zoom Level.'
,p_when_button_pressed=>wwv_flow_imp.id(1890669015145483)
,p_associated_item=>wwv_flow_imp.id(1399298474080905)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2173262953423013)
,p_validation_name=>'Map Background is in use'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_map_backgrounds_usage',
' where id                = :P6120_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'The Map Background is in use and cannot be deleted.'
,p_when_button_pressed=>wwv_flow_imp.id(1890298077145483)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3002185629826949)
,p_validation_name=>'No duplicate subscription'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_map_backgrounds',
' where security_group_id = :WORKSPACE_ID ',
'   and flow_id           = :FB_FLOW_ID ',
'   and reference_id      = :P6120_REFERENCE_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'An existing map background in this application is subscribed to the same master. Please select another master map background.'
,p_validation_condition=>':P6120_REFERENCE_ID is not null and :P6120_REFERENCE_ID_INIT is null'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(1856429275065917)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2611951169453959)
,p_validation_name=>'Not part of component groups'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'not wwv_flow_component_group_dev.is_part_of_comp_grp (',
'    p_component_id   => :P6120_ID,',
'    p_component_type => wwv_flow_copy_metadata.c_custom_map_bkg,',
'    p_app_id         => :FB_FLOW_ID )'))
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Map Background cannot be deleted because it is part of a component group.'
,p_when_button_pressed=>wwv_flow_imp.id(1890298077145483)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1857118075065924)
,p_name=>'Show and Hide Raster URL'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P6120_TYPE'
,p_condition_element=>'P6120_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'RASTER'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1857257413065925)
,p_event_id=>wwv_flow_imp.id(1857118075065924)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6120_XYZ_TILE_SERVER_URL,P6120_ATTRIBUTION'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1857563033065928)
,p_event_id=>wwv_flow_imp.id(1857118075065924)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6120_WMS_URL,P6120_MAP_STYLESHEET'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2174523683423026)
,p_event_id=>wwv_flow_imp.id(1857118075065924)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6120_WMS_URL,P6120_MAP_STYLESHEET'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1857638039065929)
,p_name=>'Show and Hide WMS URL'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P6120_TYPE'
,p_condition_element=>'P6120_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'OGCWMS'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1857719445065930)
,p_event_id=>wwv_flow_imp.id(1857638039065929)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6120_WMS_URL,P6120_ATTRIBUTION'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1857966474065932)
,p_event_id=>wwv_flow_imp.id(1857638039065929)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6120_XYZ_TILE_SERVER_URL,P6120_MAP_STYLESHEET'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2174601712423027)
,p_event_id=>wwv_flow_imp.id(1857638039065929)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6120_XYZ_TILE_SERVER_URL,P6120_MAP_STYLESHEET'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1858038488065933)
,p_name=>'Show and Hide Vector URL'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P6120_TYPE'
,p_condition_element=>'P6120_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'VECTOR'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1858100323065934)
,p_event_id=>wwv_flow_imp.id(1858038488065933)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6120_MAP_STYLESHEET'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1858404033065937)
,p_event_id=>wwv_flow_imp.id(1858038488065933)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6120_ATTRIBUTION,P6120_WMS_URL,P6120_XYZ_TILE_SERVER_URL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2174792313423028)
,p_event_id=>wwv_flow_imp.id(1858038488065933)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6120_ATTRIBUTION,P6120_WMS_URL,P6120_XYZ_TILE_SERVER_URL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3410360792935609)
,p_name=>'Set URL'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P6120_XYZ_TILE_SERVER_URL,P6120_WMS_URL,P6120_MAP_STYLESHEET'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3410485073935610)
,p_event_id=>wwv_flow_imp.id(3410360792935609)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6120_URL'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6614350831558848)
,p_name=>'Hide P6120_REFERENCE_ID'
,p_event_sequence=>60
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_display_when_cond=>'P6120_REFERENCE_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6614445712558849)
,p_event_id=>wwv_flow_imp.id(6614350831558848)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6120_REFERENCE_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2359508226667340)
,p_name=>'Save'
,p_event_sequence=>70
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1890669015145483)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2359600493667341)
,p_event_id=>wwv_flow_imp.id(2359508226667340)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'Are you sure you want to subscribe? This will overwrite the current map background data with the selected master map background.'
,p_attribute_03=>'warning'
,p_attribute_06=>'Subscribe'
,p_attribute_07=>'Cancel'
,p_client_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_client_condition_expression=>'$v(''P6120_REFERENCE_ID'') !== "" && $v(''P6120_REFERENCE_ID_INIT'') === ""'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2359730398667342)
,p_event_id=>wwv_flow_imp.id(2359508226667340)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'SAVE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1859284179065945)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(1855427598065907)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Save Map Background Changes'
,p_attribute_01=>'PLSQL_CODE'
,p_attribute_04=>wwv_flow_string.join(wwv_flow_t_varchar2(
'update wwv_flow_map_backgrounds',
'   set name              = :P6120_NAME,',
'       type              = :P6120_TYPE,',
'       url               = case',
'                             when :P6120_TYPE = ''RASTER'' then',
'                                 :P6120_XYZ_TILE_SERVER_URL',
'                             when :P6120_TYPE = ''OGCWMS'' then',
'                                 :P6120_WMS_URL',
'                             when :P6120_TYPE = ''VECTOR'' then',
'                                 :P6120_MAP_STYLESHEET',
'                             else',
'                                 null',
'                           end,',
'       attribution       = :P6120_ATTRIBUTION,',
'       api_key           = :P6120_API_KEY,',
'       http_headers      = :P6120_HTTP_HEADERS,',
'       map_comment       = :P6120_MAP_COMMENT,',
'       reference_id      = :P6120_REFERENCE_ID,',
'       zoom_min          = :P6120_ZOOM_MIN,',
'       zoom_max          = :P6120_ZOOM_MAX',
' where id                = :P6120_ID',
'   and flow_id           = :P6120_FLOW_ID',
'   and security_group_id = :P6120_SECURITY_GROUP_ID;'))
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1890669015145483)
,p_process_success_message=>'Map Background changes saved.'
,p_internal_uid=>1859284179065945
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1942221335646301)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(1855427598065907)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Delete Map Background'
,p_attribute_01=>'PLSQL_CODE'
,p_attribute_04=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_map_region_dev.delete_map_background (',
'    p_map_background_id => :P6120_ID,',
'    p_flow_id           => :FB_FLOW_ID );'))
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1890298077145483)
,p_process_success_message=>'Map Background deleted successfully.'
,p_internal_uid=>1942221335646301
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1944906120646328)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Unsubscribe'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.unsubscribe_component (',
'    p_component_type  => wwv_flow_copy_metadata.c_custom_map_bkg,',
'    p_component_id    => :P6120_ID,',
'    p_app_id          => :FB_FLOW_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1878599287075688)
,p_process_success_message=>'Map Background is no longer subscribed to its master map background.'
,p_internal_uid=>1944906120646328
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1945092868646329)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh Map Background'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_copy_metadata.refresh_component (',
'    p_component_type     => wwv_flow_copy_metadata.c_custom_map_bkg,',
'    p_master_id          => :P6120_REFERENCE_ID,',
'    p_subscribing_id     => :P6120_ID,',
'    p_subscribing_app_id => :FB_FLOW_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST = ''REFRESH''',
'or ( :REQUEST = ''SAVE'' and :P6120_REFERENCE_ID is not null and :P6120_REFERENCE_ID_INIT is null )'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Map Background attributes refreshed from master.'
,p_internal_uid=>1945092868646329
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1855588999065908)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(1855427598065907)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Map Background'
,p_internal_uid=>1855588999065908
);
end;
/
prompt --application/pages/page_06130
begin
wwv_flow_imp_page.create_page(
 p_id=>6130
,p_name=>'Copy Map Background'
,p_alias=>'COPY-MAP-BACKGROUND'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Map Background'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'auto'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_protection_level=>'C'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(52855835223104057)
,p_plug_name=>'Wizard Button'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(237596687998246998)
,p_plug_name=>'Copy Map Background'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1837271955205121)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(52855835223104057)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(6613162860558836)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(52855835223104057)
,p_button_name=>'COPY_FROM_ANOTHER'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Copy from another app'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:6130:&SESSION.::&DEBUG.:6130:P6130_COPY_SOURCE:OTHER'
,p_button_condition=>'P6130_COPY_SOURCE'
,p_button_condition2=>'THIS'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_button_css_classes=>'a-Button--noUI'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1837606704205121)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(52855835223104057)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy Map Background'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1943554600646314)
,p_branch_name=>'Go to Map Background Detail'
,p_branch_action=>'f?p=&APP_ID.:6120:&SESSION.::&DEBUG.:6120:P6120_ID:&P6130_COPY_NEW_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3794703916020667)
,p_name=>'P6130_COPY_NEW_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(237596687998246998)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6436918814475151)
,p_name=>'P6130_COPY_SOURCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(237596687998246998)
,p_item_default=>'THIS'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6437799571475157)
,p_name=>'P6130_COPY_FROM_APP_ID'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(237596687998246998)
,p_prompt=>'Application'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST OTHER FLOWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'  from   wwv_flow_visible_flows f',
' where id != :FB_FLOW_ID',
'   and build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'order by 2'))
,p_cHeight=>1
,p_display_when=>'P6130_COPY_SOURCE'
,p_display_when2=>'OTHER'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Select the application from which you want to copy the map background.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6438751630475158)
,p_name=>'P6130_COPY_FROM_ID'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(237596687998246998)
,p_prompt=>'Copy Map Background'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(name) search_label, id',
'  from wwv_flow_map_backgrounds',
' where flow_id           = :P6130_COPY_FROM_APP_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
' order by name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Map Background -'
,p_lov_cascade_parent_items=>'P6130_COPY_FROM_APP_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_read_only_when=>'P6130_COPY_FROM_ID'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify the map background to copy.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'Y'
,p_attribute_06=>'0'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6439640377475159)
,p_name=>'P6130_SUBSCRIBE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(237596687998246998)
,p_item_default=>'Y'
,p_prompt=>'Subscribe'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>'P6130_COPY_SOURCE'
,p_display_when2=>'OTHER'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'While copying the map background, you can also subscribe to it. Set Subscribe to <strong>On</strong> to subscribe to the map background.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6440557826475159)
,p_name=>'P6130_NEW_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(237596687998246998)
,p_prompt=>'New Map Background Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Identify the name of the map background you would like to create. Map background name must be unique within the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(6613649867558841)
,p_validation_name=>'P6130_NEW_NAME not null'
,p_validation_sequence=>10
,p_validation=>'P6130_NEW_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>':P6130_COPY_SOURCE = ''THIS'' or :P6130_SUBSCRIBE = ''N'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(1837606704205121)
,p_associated_item=>wwv_flow_imp.id(6440557826475159)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1943002231646309)
,p_validation_name=>'P6130_NEW_NAME must be Unique'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_map_backgrounds',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and name              = :P6130_NEW_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'The Label "&P6130_NEW_NAME!HTML." is already taken by another Map Background.'
,p_validation_condition=>':P6130_COPY_SOURCE = ''THIS'' or :P6130_SUBSCRIBE = ''N'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(1837606704205121)
,p_associated_item=>wwv_flow_imp.id(6440557826475159)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2316345494620137)
,p_validation_name=>'No duplicate subscription'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_map_backgrounds',
' where security_group_id = :FLOW_SECURITY_GROUP_ID ',
'   and flow_id           = :FB_FLOW_ID ',
'   and reference_id      = :P6130_COPY_FROM_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'There is another map background in this application that is subscribed to the same master. Please select another master map background.'
,p_validation_condition=>'P6130_SUBSCRIBE'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_when_button_pressed=>wwv_flow_imp.id(1837606704205121)
,p_associated_item=>wwv_flow_imp.id(6438751630475158)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1779084292700738)
,p_name=>'Close Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1837271955205121)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1779162977700739)
,p_event_id=>wwv_flow_imp.id(1779084292700738)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CLOSE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1944606949646325)
,p_name=>'Hide Show New Name'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P6130_SUBSCRIBE'
,p_condition_element=>'P6130_SUBSCRIBE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_cond=>'P6130_COPY_SOURCE'
,p_display_when_cond2=>'OTHER'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1944763023646326)
,p_event_id=>wwv_flow_imp.id(1944606949646325)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6130_NEW_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1944886892646327)
,p_event_id=>wwv_flow_imp.id(1944606949646325)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6130_NEW_NAME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(6613410846558839)
,p_name=>'Set New Name'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P6130_COPY_FROM_ID'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_cond=>'P6130_COPY_SOURCE'
,p_display_when_cond2=>'OTHER'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(6613534372558840)
,p_event_id=>wwv_flow_imp.id(6613410846558839)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6130_NEW_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'apex.item("P6130_COPY_FROM_ID").displayValueFor($v("P6130_COPY_FROM_ID"))'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1943443110646313)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Map Background'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P6130_COPY_NEW_ID := wwv_flow_map_region_dev.copy_map_background (',
'    p_from_application_id    => :P6130_COPY_FROM_APP_ID,',
'    p_from_map_background_id => :P6130_COPY_FROM_ID,',
'    p_to_application_id      => :FB_FLOW_ID,',
'    p_to_name                => :P6130_NEW_NAME,',
'    p_subscribe              => :P6130_SUBSCRIBE = ''Y'' );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1837606704205121)
,p_process_success_message=>'Map Background successfully copied.'
,p_internal_uid=>1943443110646313
);
end;
/
prompt --application/pages/page_06140
begin
wwv_flow_imp_page.create_page(
 p_id=>6140
,p_name=>'Map Background Utilization'
,p_alias=>'MAP-BACKGROUND-UTILIZATION'
,p_step_title=>'Map Background Utilization'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4466542497710384)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(1385199811261560)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Map Backgrounds'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11229729405518087)
,p_plug_name=>'Map Background Utilization'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       map_background_name,',
'       wwv_flow_lang_dev.builder_message( ''DICTIONARY_VIEW.'' || component_type ) as component_type,',
'       page_id,',
'       page_name,',
'       page_item,',
'       region,',
'       wwv_flow_utilities.prepare_url( ',
'           case when component_type in ( ''APEX_APPLICATION_PAGE_REGIONS'', ''APEX_APPLICATION_PAGE_ITEMS'')',
'               then ''f?p=4000:4500:'' || :APP_SESSION ||''::::FB_FLOW_ID,FB_FLOW_PAGE_ID'' || '':'' || flow_id || '','' || page_id',
'               else ''f?p=4000:4446:'' || :APP_SESSION ||''::::P4446_ID'' || '':'' || plugin_setting_id',
'           end ) as link_target,',
'       plugin_setting_id',
'  from wwv_flow_map_backgrounds_usage',
' where flow_id                      = :fb_flow_id',
'   and security_group_id            = :flow_security_group_id',
'order by id'))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Search Configuration Utilization'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(11229833072518088)
,p_no_data_found_message=>'No Map Backgrounds are used within this application.'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'CBCHO'
,p_internal_uid=>11229833072518088
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9129182701171201)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2101252100648012)
,p_db_column_name=>'MAP_BACKGROUND_NAME'
,p_display_order=>60
,p_column_identifier=>'J'
,p_column_label=>'Map Background Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2173579116423016)
,p_db_column_name=>'COMPONENT_TYPE'
,p_display_order=>70
,p_column_identifier=>'O'
,p_column_label=>'Component Type'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{if PLUGIN_SETTING_ID/}',
'<a href="#LINK_TARGET#">#COMPONENT_TYPE#</a>',
'{else/}',
'#COMPONENT_TYPE#',
'{endif/}'))
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9130814855171205)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>80
,p_column_identifier=>'F'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9131207140171206)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>90
,p_column_identifier=>'G'
,p_column_label=>'Page Name'
,p_column_link=>'#LINK_TARGET#'
,p_column_linktext=>'#PAGE_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2101341500648013)
,p_db_column_name=>'PAGE_ITEM'
,p_display_order=>100
,p_column_identifier=>'K'
,p_column_label=>'Page Item'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2101444816648014)
,p_db_column_name=>'REGION'
,p_display_order=>110
,p_column_identifier=>'L'
,p_column_label=>'Region'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2173691950423017)
,p_db_column_name=>'LINK_TARGET'
,p_display_order=>120
,p_column_identifier=>'P'
,p_column_label=>'Link Target'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2173703423423018)
,p_db_column_name=>'PLUGIN_SETTING_ID'
,p_display_order=>130
,p_column_identifier=>'Q'
,p_column_label=>'Plugin Setting Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(12034020011195627)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'29055'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'MAP_BACKGROUND_NAME:COMPONENT_TYPE:PAGE_ID:PAGE_NAME:REGION:PAGE_ITEM:LINK_TARGET:PLUGIN_SETTING_ID'
,p_sort_column_1=>'SEARCH_CONFIG_LABEL'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(12825901260370546)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>'<p>This page displays where <strong>Map Backgrounds</strong> are being used within the application.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
end;
/
prompt --application/pages/page_06150
begin
wwv_flow_imp_page.create_page(
 p_id=>6150
,p_name=>'Map Background History'
,p_alias=>'MAP-BACKGROUND-HISTORY'
,p_step_title=>'Map Background History'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4466797650711509)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(1385199811261560)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
,p_landmark_type=>'navigation'
,p_landmark_label=>'Map Backgrounds'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(16248415396499656)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>'<p>This page displays recent modifications made to <strong>Custom Map Backgrounds</strong> in this application.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(447115307390599780)
,p_plug_name=>'Map Background History'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  l.a object_type,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from sys.dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from sys.dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from sys.dual) u,',
'  (select wwv_flow_lang.system_message(''COMPONENT_TYPE.MAP_BACKGROUND'') a from sys.dual) l',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_MAP_BACKGROUNDS''',
'order by t.flow_user'))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(447115499115599787)
,p_name=>'History'
,p_no_data_found_message=>'No Map Backgrounds change history available.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>447115499115599787
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9159780996409364)
,p_db_column_name=>'SCN'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9160167587409364)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Audit Comment'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9160550337409364)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Component Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9160947465409365)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9161322246409365)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Component Key'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'LEFT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9161775833409366)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Audit Date'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9162174980409367)
,p_db_column_name=>'ACTION'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(9162486594409367)
,p_db_column_name=>'OBJECT_TYPE'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Object Type'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(447116409775599793)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1294307143536645'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'AUDIT_DATE:ACTION:DEVELOPER:OBJECT_TYPE:COMPONENT_NAME'
,p_sort_column_1=>'AUDIT_DATE'
,p_sort_direction_1=>'DESC'
);
end;
/
prompt --application/pages/page_06200
begin
wwv_flow_imp_page.create_page(
 p_id=>6200
,p_name=>'Component Groups'
,p_alias=>'COMPONENT-GROUPS'
,p_step_title=>'Component Groups'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5074631674291414)
,p_plug_name=>'Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_list_id=>wwv_flow_imp.id(5960568658265871)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8122089112994347)
,p_plug_name=>'Component Groups'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with messages as (',
'    select ( select wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_UP_TO_DATE'') from sys.dual ) up_to_date,',
'           ( select wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_NEEDS_REFRESH'') from sys.dual ) needs_refresh,',
'           ( select wwv_flow_lang_dev.builder_message(''WWV_FLOW_F4000_PLUGINS.SUBSCRIPTION_UNKNOWN'') from sys.dual ) unknown_status,',
'           ( select wwv_flow_lang_dev.builder_message(''SUBSCRIBED_FROM.NONEXISTING_MASTER'') from sys.dual ) no_master',
'      from sys.dual )',
'select cg.id,',
'       cg.name,',
'       cg.group_comment,',
'       wwv_flow_page_api.get_url(',
'           p_application => :APP_ID,',
'           p_page        => 6201,',
'           p_clear_cache => 6201,',
'           p_items       => ''P6201_ID'',',
'           p_values      => cg.id ) edit_link,',
'       coalesce( cg.last_updated_on, cg.created_on ) last_updated,',
'       coalesce( cg.last_updated_by, cg.created_by ) last_updated_by,',
'       --',
'       case when cg.reference_id is not null then',
'           coalesce ( to_char( master.flow_id ),',
'                       messages.no_master )',
'       end as subscribed_from,',
'       ( select case when count(*) > 0 then count(*) end',
'           from wwv_flow_component_groups sub',
'          where sub.reference_id      = cg.id',
'            and sub.security_group_id = :WORKSPACE_ID ) as subscribers,',
'       case when cg.reference_id is not null then',
'           case',
'               when master.version_scn = cg.version_scn then',
'                   messages.up_to_date',
'               when master.version_scn != cg.version_scn then',
'                   messages.needs_refresh',
'               else',
'                   messages.unknown_status',
'           end',
'       end subscription_status,',
'       --',
'       null action',
'  from wwv_flow_component_groups cg,',
'       wwv_flow_component_groups master,',
'       messages',
' where cg.flow_id                = :FB_FLOW_ID',
'   and cg.security_group_id      = :WORKSPACE_ID',
'   and cg.reference_id           = master.id (+)',
'   and cg.security_group_id      = master.security_group_id (+)'))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Search Configurations'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(8122177116994348)
,p_no_data_found_message=>'No component groups found.'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_download_formats=>'CSV:HTML'
,p_enable_mail_download=>'Y'
,p_icon_view_enabled_yn=>'Y'
,p_icon_view_use_custom=>'Y'
,p_icon_view_custom_link=>'<a href="#EDIT_LINK#" class="a-IRR-icon"><span class="a-Icon icon-sc-comp-group"></span><span class="a-IRR-iconName">#NAME#</span></a>'
,p_icon_view_columns_per_row=>5
,p_owner=>'CBCHO'
,p_internal_uid=>8122177116994348
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(8122281919994349)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(6813021317170122)
,p_db_column_name=>'NAME'
,p_display_order=>20
,p_column_identifier=>'O'
,p_column_label=>'Name'
,p_column_link=>'f?p=&APP_ID.:6201:&SESSION.::&DEBUG.:RR,6201:P6201_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(6813390871170126)
,p_db_column_name=>'EDIT_LINK'
,p_display_order=>60
,p_column_identifier=>'S'
,p_column_label=>'Edit Link'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(6813445458170127)
,p_db_column_name=>'LAST_UPDATED'
,p_display_order=>100
,p_column_identifier=>'T'
,p_column_label=>'Updated'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(6813627331170128)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>110
,p_column_identifier=>'U'
,p_column_label=>'Updated By'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(6980769474115731)
,p_db_column_name=>'SUBSCRIBED_FROM'
,p_display_order=>120
,p_column_identifier=>'Y'
,p_column_label=>'Subscribed From'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(6980867797115732)
,p_db_column_name=>'SUBSCRIBERS'
,p_display_order=>130
,p_column_identifier=>'Z'
,p_column_label=>'Subscribers'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(11651413612028263)
,p_db_column_name=>'SUBSCRIPTION_STATUS'
,p_display_order=>140
,p_column_identifier=>'AA'
,p_column_label=>'Subscription Status'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(6534156139440033)
,p_db_column_name=>'ACTION'
,p_display_order=>160
,p_column_identifier=>'AC'
,p_column_label=>'Copy'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'TMPL_THEME_3$ACTIONS'
,p_column_alignment=>'CENTER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'ACTIONS_WRAP', 'N',
  'STYLE', 'b-InlineActions--simple')).to_clob
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5057385918023230)
,p_db_column_name=>'GROUP_COMMENT'
,p_display_order=>170
,p_column_identifier=>'AD'
,p_column_label=>'Group Comment'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(8135493647043258)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_type=>'REPORT'
,p_report_alias=>'17083'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'NAME:GROUP_COMMENT:SUBSCRIBED_FROM:SUBSCRIPTION_STATUS:SUBSCRIBERS:LAST_UPDATED:LAST_UPDATED_BY:ACTION:'
,p_sort_column_1=>'NAME'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'0'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(14879604869299537)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p><strong>Component groups</strong> are collections of shared components that can be easily copied or subscribed to across different applications. They also enable bulk refresh of the shared components.</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL." rel="noopener noreferrer">Learn More ...</a></p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5043359822469439)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(8122089112994347)
,p_button_name=>'RESET'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Reset'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:&APP_PAGE_ID.:&SESSION.::&DEBUG.:RR,::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5043707890469440)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(8122089112994347)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:6201:&SESSION.::&DEBUG.:RR,6201::'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_component_action(
 p_id=>wwv_flow_imp.id(6534300325440034)
,p_ir_column_id=>wwv_flow_imp.id(6534156139440033)
,p_position_id=>wwv_flow_imp.id(214437533860142316)
,p_display_sequence=>10
,p_template_id=>wwv_flow_imp.id(214438625365151034)
,p_label=>'Copy'
,p_link_target_type=>'REDIRECT_PAGE'
,p_link_target=>'f?p=&APP_ID.:6202:&SESSION.::&DEBUG.:6202:P6202_COPY_SOURCE,P6202_ID,P6202_COPY_FROM_APP_ID:THIS,#ID#,&FB_FLOW_ID.'
,p_button_display_type=>'ICON'
,p_icon_css_classes=>'icon-copy'
,p_is_hot=>false
,p_show_as_disabled=>false
);
end;
/
prompt --application/pages/page_06201
begin
wwv_flow_imp_page.create_page(
 p_id=>6201
,p_name=>'Create / Edit Component Group'
,p_alias=>'CREATE-EDIT-COMPONENT-GROUP'
,p_step_title=>'Create / Edit Component Group'
,p_autocomplete_on_off=>'OFF'
,p_javascript_code_onload=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.actions.add({',
'    name: "rem-comp-grp-component",',
'    action: function(event, focusElement, args) {',
'        let result = apex.server.process( "UNASSIGN_COMP_GRP_COMPONENT", {',
'            x01: args.id,',
'            pageItems: "#P6201_ID"',
'        });',
'',
'        result.done( function(){',
'            apex.region( "comp_grp_components" ).refresh();',
'            apex.message.showPageSuccess( apex.lang.getMessage( "COMP_GRP.COMPONENT_UNASSIGNED" ) );',
'        });',
'    }',
'});'))
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_read_only_when=>'P6201_REFERENCE_ID'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5057487145023231)
,p_plug_name=>'Component Group'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5057515063023232)
,p_plug_name=>'Name'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_COMPONENT_GROUPS'
,p_query_where=>'security_group_id = :WORKSPACE_ID and flow_id = :FB_FLOW_ID'
,p_include_rowid_column=>false
,p_is_editable=>false
,p_plug_source_type=>'NATIVE_FORM'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5058831455023245)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'USER')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5074141690291409)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p><strong>Component groups</strong> are collections of shared components that can be easily copied or subscribed to across different applications. They also enable bulk refresh of the shared components.</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL." rel="noopener noreferrer">Learn More ...</a></p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8646717116979459)
,p_plug_name=>'Subscription'
,p_region_name=>'SUBSCRIPTION'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SUBSCRIPTIONS'
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P6201_ID'
,p_plug_read_only_when_type=>'ITEM_IS_NOT_NULL'
,p_plug_read_only_when=>'P6201_REFERENCE_ID'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', 'WWV_FLOW_COMPONENT_GROUPS',
  'attribute_02', 'NAME',
  'attribute_03', 'P6201_ID',
  'attribute_04', 'P6201_REFERENCE_ID',
  'attribute_05', 'SUBSCRIBE_COMPONENT_GROUP',
  'attribute_06', 'VERSION_SCN')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(11582238149703717)
,p_plug_name=>'Components'
,p_region_name=>'comp_grp_components'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select s.id,',
'       s.component_type,',
'       ( select c.name',
'           from wwv_flow_appl_export_comps c',
'          where c.workspace_id   = :WORKSPACE_ID',
'            and c.application_id = :FB_FLOW_ID',
'            and c.type_name      = s.component_type',
'            and c.id             = s.component_id ) component,',
'       null as actions',
'  from wwv_flow_comp_grp_components s',
' where s.component_group_id = :P6201_ID',
'   and s.flow_id            = :FB_FLOW_ID',
'   and s.security_group_id  = :WORKSPACE_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P6201_ID'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P6201_ID is not null and :P6201_REFERENCE_ID is null'
,p_plug_display_when_cond2=>'PLSQL'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Components'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(11582357971703718)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'No components assigned.'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_pivot=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'SRAVVA'
,p_internal_uid=>11582357971703718
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(11582499637703719)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(11582511346703720)
,p_db_column_name=>'COMPONENT_TYPE'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Component Type'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(5087092943835745)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(13515172341184701)
,p_db_column_name=>'ACTIONS'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Actions'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'TMPL_THEME_3$ACTIONS'
,p_column_alignment=>'CENTER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'ACTIONS_WRAP', 'N',
  'STYLE', 'b-InlineActions--simple')).to_clob
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(13518966256184739)
,p_db_column_name=>'COMPONENT'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>'Component'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(12397329792776780)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'123974'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'COMPONENT_TYPE:COMPONENT:ACTIONS:'
,p_sort_column_1=>'COMPONENT_TYPE'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'COMPONENT'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(16938346371934448)
,p_application_user=>'APXWS_ALTERNATIVE'
,p_name=>'By Component Type'
,p_report_seq=>10
,p_report_alias=>'169384'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'COMPONENT_TYPE:COMPONENT:ACTIONS:'
,p_sort_column_1=>'COMPONENT_TYPE'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'COMPONENT'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
,p_break_on=>'COMPONENT_TYPE:0:0:0:0:0'
,p_break_enabled_on=>'COMPONENT_TYPE:0:0:0:0:0'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(13516055683184710)
,p_plug_name=>'Subscribed Components'
,p_region_name=>'comp_grp_components_sub'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select s.id,',
'       s.component_type,',
'       ( select c.name',
'           from wwv_flow_appl_export_comps c',
'          where c.workspace_id   = :WORKSPACE_ID',
'            and c.application_id = :FB_FLOW_ID',
'            and c.type_name      = s.component_type',
'            and c.id             = s.component_id ) component,',
'       ( select sc.subscription_status',
'           from wwv_flow_subscribed_comp_dev sc',
'          where sc.component_type = s.component_type',
'            and sc.component_id   = s.component_id ) subscription_status',
'  from wwv_flow_comp_grp_components s',
' where s.component_group_id = :P6201_ID',
'   and s.flow_id            = :FB_FLOW_ID',
'   and s.security_group_id  = :WORKSPACE_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_ajax_items_to_submit=>'P6201_ID'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P6201_REFERENCE_ID is not null'
,p_plug_display_when_cond2=>'PLSQL'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Subscribed Components'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(13516151079184711)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'No components assigned.'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_pivot=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'SRAVVA'
,p_internal_uid=>13516151079184711
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(13516259742184712)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(13516360650184713)
,p_db_column_name=>'COMPONENT_TYPE'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Component Type'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(5087092943835745)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(13516781610184717)
,p_db_column_name=>'SUBSCRIPTION_STATUS'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Subscription Status'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(13519094656184740)
,p_db_column_name=>'COMPONENT'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>'Component'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(16934492211860309)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'169345'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'COMPONENT_TYPE:COMPONENT:SUBSCRIPTION_STATUS:'
,p_sort_column_1=>'COMPONENT_TYPE'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'COMPONENT'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(16937608493924872)
,p_application_user=>'APXWS_ALTERNATIVE'
,p_name=>'By Component Type'
,p_report_seq=>10
,p_report_alias=>'169377'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'COMPONENT_TYPE:COMPONENT:SUBSCRIPTION_STATUS:'
,p_sort_column_1=>'COMPONENT_TYPE'
,p_sort_direction_1=>'ASC'
,p_sort_column_2=>'COMPONENT'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
,p_break_on=>'COMPONENT_TYPE:0:0:0:0:0'
,p_break_enabled_on=>'COMPONENT_TYPE:0:0:0:0:0'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(622506656805792203)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(29434107863295859)
,p_plug_display_sequence=>60
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (',
'    select last_updated_by,',
'           last_updated_on,',
'           created_by,',
'           created_on ',
'      from wwv_flow_component_groups ',
'     where id                = :P6201_ID',
'       and security_group_id = :WORKSPACE_ID )',
'loop',
'    wwv_flow_4000_ui.show_history (',
'        p_last_updated_by    => c1.last_updated_by,',
'        p_last_updated_on    => c1.last_updated_on,',
'        p_created_by         => c1.created_by,',
'        p_created_on         => c1.created_on );',
'   exit;',
'end loop;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'ITEM_IS_NOT_NULL'
,p_plug_display_when_condition=>'P6201_ID'
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5059060412023247)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(5057487145023231)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6200:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5059186049023248)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(5057487145023231)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_confirm_message=>'Would you like to delete this Component Group?'
,p_confirm_style=>'danger'
,p_button_condition=>'P6201_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5059267905023249)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(5057487145023231)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>':P6201_ID is not null and :P6201_REFERENCE_ID is null'
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5059305633023250)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(5057487145023231)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>'P6201_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5057333871831294)
,p_button_sequence=>90
,p_button_plug_id=>wwv_flow_imp.id(8646717116979459)
,p_button_name=>'PUBLISH'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Publish'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:149:&SESSION.::&DEBUG.:RP,149:F4000_P149_ID,F4000_P149_TEMPLATE_TYPE,F4000_P149_PAGE_ID:&P6201_ID.,COMPONENT_GROUP,6201'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_component_groups',
' where reference_id      = :P6201_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5057733435831295)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_imp.id(8646717116979459)
,p_button_name=>'UNSUBSCRIBE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Unsubscribe'
,p_button_position=>'NEXT'
,p_button_condition=>'P6201_REFERENCE_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5058100460831295)
,p_button_sequence=>110
,p_button_plug_id=>wwv_flow_imp.id(8646717116979459)
,p_button_name=>'REFRESH'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Refresh'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6204:&SESSION.::&DEBUG.:RP,6204:P6204_ID:&P6201_ID.'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P6201_REFERENCE_ID is not null ',
'and ( :P6201_VERSION_SCN != :P6201_MASTER_VERSION_SCN or :P6201_VERSION_SCN is null )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(11582815933703723)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(11582238149703717)
,p_button_name=>'ASSIGN_COMPONENTS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Assign Components'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:6206:&SESSION.::&DEBUG.:6206:P6206_COMPONENT_GROUP_ID:&P6201_ID.'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(5074306177291411)
,p_branch_name=>'Go To Page 6200'
,p_branch_action=>'f?p=&APP_ID.:6200:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':REQUEST in ( ''SAVE'', ''DELETE'' )'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5057719889023234)
,p_name=>'P6201_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(5057515063023232)
,p_item_source_plug_id=>wwv_flow_imp.id(5057515063023232)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_protection_level=>'S'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5057897922023235)
,p_name=>'P6201_FLOW_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(5057515063023232)
,p_item_source_plug_id=>wwv_flow_imp.id(5057515063023232)
,p_item_default=>'FB_FLOW_ID'
,p_item_default_type=>'ITEM'
,p_source=>'FLOW_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5058054352023237)
,p_name=>'P6201_NAME'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(5057515063023232)
,p_item_source_plug_id=>wwv_flow_imp.id(5057515063023232)
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter the name of the component group. The component group name must be unique within the application.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5058178038023238)
,p_name=>'P6201_REFERENCE_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(8646717116979459)
,p_item_source_plug_id=>wwv_flow_imp.id(5057515063023232)
,p_source=>'REFERENCE_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5058209544023239)
,p_name=>'P6201_VERSION_SCN'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(8646717116979459)
,p_item_source_plug_id=>wwv_flow_imp.id(5057515063023232)
,p_source=>'VERSION_SCN'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5058373191023240)
,p_name=>'P6201_GROUP_COMMENT'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(5057515063023232)
,p_item_source_plug_id=>wwv_flow_imp.id(5057515063023232)
,p_prompt=>'Comments'
,p_source=>'GROUP_COMMENT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter a brief description of this component group.'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11672520665390140)
,p_name=>'P6201_REFERENCE_ID_INIT'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(8646717116979459)
,p_item_default=>'P6201_REFERENCE_ID'
,p_item_default_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(11672666408390141)
,p_name=>'P6201_MASTER_VERSION_SCN'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(8646717116979459)
,p_use_cache_before_default=>'NO'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select version_scn ',
'  from wwv_flow_component_groups',
' where id                = :P6201_REFERENCE_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1419647551012534)
,p_validation_name=>'P6201_NAME length check'
,p_validation_sequence=>10
,p_validation=>'lengthb( :P6201_NAME ) <= 255'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Size of #LABEL# must be 255 bytes or less.'
,p_validation_condition=>':REQUEST IN ( ''SAVE'', ''CREATE'' )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(5058054352023237)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1419763413012535)
,p_validation_name=>'P6201_GROUP_COMMENT length check'
,p_validation_sequence=>20
,p_validation=>'lengthb( :P6201_GROUP_COMMENT ) <= 4000'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Size of #LABEL# must be 4000 bytes or less.'
,p_validation_condition=>':REQUEST IN ( ''SAVE'', ''CREATE'' )'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(5058373191023240)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3458923554763601)
,p_name=>'Refresh Components IR'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(11582815933703723)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosecanceldialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3459000765763602)
,p_event_id=>wwv_flow_imp.id(3458923554763601)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(11582238149703717)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5058987905023246)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(5057515063023232)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process Component Group'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':REQUEST IN (''CREATE'',''SAVE'')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Component group changes saved.'
,p_internal_uid=>5058987905023246
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(13515912017184709)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Unsubscribe'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_component_group_dev.unsubscribe (',
'    p_component_group_id        => :P6201_ID,',
'    p_app_id                    => :FB_FLOW_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(5057733435831295)
,p_process_success_message=>'Component group has been unsubscribed.'
,p_internal_uid=>13515912017184709
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5074250246291410)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Delete Component Group'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_component_group_dev.delete_component_group (',
'    p_id      => :P6201_ID,',
'    p_app_id  => :FB_FLOW_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(5059186049023248)
,p_process_success_message=>'Component group deleted.'
,p_internal_uid=>5074250246291410
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5057682546023233)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(5057515063023232)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Component Group'
,p_internal_uid=>5057682546023233
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(13515311694184703)
,p_process_sequence=>10
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'UNASSIGN_COMP_GRP_COMPONENT'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_component_group_dev.unassign_component (',
'        p_id                 => wwv_flow.g_x01,',
'        p_component_group_id => :P6201_ID,',
'        p_app_id             => :FB_FLOW_ID );',
'        ',
'    wwv_flow_json.open_object;',
'    wwv_flow_json.write( p_name => ''success'', p_value => true );',
'    wwv_flow_json.close_object;',
'exception',
'    when others then',
'        wwv_flow_json.open_object;',
'        wwv_flow_json.write( p_name => ''success'', p_value => false );',
'        wwv_flow_json.write( p_name => ''message'', p_value => sqlerrm );',
'        wwv_flow_json.close_object;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_type=>'IS_NOT_READ_ONLY'
,p_internal_uid=>13515311694184703
);
wwv_flow_imp_page.create_component_action(
 p_id=>wwv_flow_imp.id(13515262357184702)
,p_ir_column_id=>wwv_flow_imp.id(13515172341184701)
,p_position_id=>wwv_flow_imp.id(214437533860142316)
,p_display_sequence=>10
,p_template_id=>wwv_flow_imp.id(214438625365151034)
,p_label=>'Unassign from Component Group'
,p_link_target_type=>'REDIRECT_URL'
,p_link_target=>'#action$rem-comp-grp-component?id=#ID#'
,p_button_display_type=>'ICON'
,p_icon_css_classes=>'icon-delete-app'
,p_is_hot=>false
,p_show_as_disabled=>false
);
end;
/
prompt --application/pages/page_06202
begin
wwv_flow_imp_page.create_page(
 p_id=>6202
,p_name=>'Copy Component Group'
,p_alias=>'COPY-COMPONENT-GROUP'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Component Group'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'auto'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_protection_level=>'C'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(63814016562768633)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(248554999210911522)
,p_plug_name=>'Component Group'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5581151089353328)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(63814016562768633)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5581597494353328)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(63814016562768633)
,p_button_name=>'COPY_FROM_ANOTHER'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Copy from another app'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:6202:&SESSION.::&DEBUG.:6202:P6202_COPY_SOURCE:OTHER'
,p_button_condition=>'P6202_COPY_SOURCE'
,p_button_condition2=>'THIS'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_button_css_classes=>'a-Button--noUI'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5581934068353328)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(63814016562768633)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy Component Group'
,p_button_position=>'NEXT'
,p_button_condition=>'P6202_COPY_SOURCE'
,p_button_condition2=>'THIS'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5074503060291413)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(63814016562768633)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_button_condition=>'P6202_COPY_SOURCE'
,p_button_condition2=>'THIS'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_NOT_EQ_COND2'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(5074415970291412)
,p_branch_name=>'Go To Page 6201'
,p_branch_action=>'f?p=&APP_ID.:6201:&SESSION.::&DEBUG.:6201:P6201_ID:&P6202_NEW_COMPONENT_GROUP_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(5581934068353328)
,p_branch_sequence=>20
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(5074720159291415)
,p_branch_name=>'Go To Page 6203'
,p_branch_action=>'f?p=&APP_ID.:6203:&SESSION.::&DEBUG.:RP,6203::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(5074503060291413)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(17391754674102403)
,p_name=>'P6202_NEW_COMPONENT_GROUP_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(248554999210911522)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(32399151374893616)
,p_name=>'P6202_SUBSCRIBE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(248554999210911522)
,p_item_default=>'Y'
,p_prompt=>'Subscribe'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>'P6202_COPY_SOURCE'
,p_display_when2=>'OTHER'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'While copying the component group, you can also subscribe to it. Set Subscribe to <strong>On</strong> to subscribe to the component group.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(32698750177972213)
,p_name=>'P6202_COPY_SOURCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(248554999210911522)
,p_item_default=>'THIS'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(229066908344833999)
,p_name=>'P6202_COPY_FROM_APP_ID'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(248554999210911522)
,p_prompt=>'Application'
,p_source=>'&FB_FLOW_ID.'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST OTHER FLOWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select distinct f.id||'' ''||wwv_flow_escape.html(f.name) d, f.id r',
'  from   wwv_flow_visible_flows f',
' where id != :FB_FLOW_ID',
'   and build_status not in (''RUN_ONLY'',''RUN_AND_HIDDEN'')',
'order by 2'))
,p_lov_cascade_parent_items=>'P6202_COPY_SOURCE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_display_when=>'P6202_COPY_SOURCE'
,p_display_when2=>'OTHER'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'<p>Select the application from which you want to copy a component group.</p>'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(248577409703951383)
,p_name=>'P6202_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(248554999210911522)
,p_prompt=>'New Component Group Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>32
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the name of the component group. The component group name must be unique within the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(248580725979956089)
,p_name=>'P6202_ID'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(248554999210911522)
,p_prompt=>'Component Group'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d,',
'       id r',
'  from wwv_flow_component_groups',
' where flow_id           = :P6202_COPY_FROM_APP_ID',
'   and security_group_id = :WORKSPACE_ID',
' order by upper(name)'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Component Group -'
,p_lov_cascade_parent_items=>'P6202_COPY_FROM_APP_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_read_only_when=>':P6202_COPY_SOURCE = ''THIS'' and :P6202_ID is not null'
,p_read_only_when2=>'PLSQL'
,p_read_only_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify a component group to copy.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'Y'
,p_attribute_06=>'0'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2893033503137316)
,p_validation_name=>'Same theme check'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_component_group_dev.check_app_themes (',
'    p_from_app_id  => :P6202_COPY_FROM_APP_ID,',
'    p_to_app_id    => :FB_FLOW_ID );'))
,p_validation_type=>'PLSQL_ERROR'
,p_error_message=>'Error occurred.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P6202_COPY_SOURCE != ''THIS'' and',
'wwv_flow_component_group_dev.has_page_patterns (',
'    p_component_group_id => :P6202_ID,',
'    p_app_id             => :P6202_COPY_FROM_APP_ID )'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5586876079353344)
,p_validation_name=>'P6202_NAME not null'
,p_validation_sequence=>20
,p_validation=>'P6202_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>':P6202_COPY_SOURCE = ''THIS'' or :P6202_SUBSCRIBE = ''N'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(248577409703951383)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5587203517353344)
,p_validation_name=>'P6202_NAME unique'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_component_groups',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and name              = :P6202_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Component group name must be unique. Please enter a different name.'
,p_validation_condition=>':P6202_COPY_SOURCE = ''THIS'' or :P6202_SUBSCRIBE = ''N'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(248577409703951383)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1419842012012536)
,p_validation_name=>'P6202_NAME  length check'
,p_validation_sequence=>40
,p_validation=>'lengthb( :P6202_NAME ) <= 255'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Size of #LABEL# must be 255 bytes or less.'
,p_validation_condition=>':P6202_COPY_SOURCE = ''THIS'' or :P6202_SUBSCRIBE = ''N'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(248577409703951383)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(11582173145703716)
,p_validation_name=>'Name Unique - Subscribe'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_component_groups t',
' where t.flow_id           = :FB_FLOW_ID',
'   and t.security_group_id = :WORKSPACE_ID',
'   and t.name              = ( ',
'       select name',
'         from wwv_flow_component_groups s',
'        where s.flow_id           = :P6202_COPY_FROM_APP_ID',
'          and s.security_group_id = :WORKSPACE_ID',
'          and s.id                = :P6202_ID )'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Unable to subscribe. Component group with the same name already exists.'
,p_validation_condition=>':P6202_SUBSCRIBE = ''Y'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(248577409703951383)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(5587693421353344)
,p_validation_name=>'No duplicate subscription'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_component_groups',
' where security_group_id = :FLOW_SECURITY_GROUP_ID ',
'   and flow_id           = :FB_FLOW_ID ',
'   and reference_id      = :P6202_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'There is another component group in this application that is subscribed to the same master. Please select another master component group.'
,p_validation_condition=>'P6202_SUBSCRIBE'
,p_validation_condition2=>'Y'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(248580725979956089)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5588754111353345)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(5581151089353328)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5589235278353346)
,p_event_id=>wwv_flow_imp.id(5588754111353345)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5589671801353347)
,p_name=>'Toggle P6202_NAME display'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P6202_SUBSCRIBE'
,p_condition_element=>'P6202_SUBSCRIBE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_cond=>'P6202_COPY_SOURCE'
,p_display_when_cond2=>'OTHER'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5590113429353347)
,p_event_id=>wwv_flow_imp.id(5589671801353347)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6202_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5590621715353347)
,p_event_id=>wwv_flow_imp.id(5589671801353347)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6202_NAME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5591096469353347)
,p_name=>'Set New Name'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P6202_ID'
,p_condition_element=>'P6202_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_display_when_cond=>'P6202_COPY_SOURCE'
,p_display_when_cond2=>'OTHER'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1419379635012531)
,p_event_id=>wwv_flow_imp.id(5591096469353347)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6202_NAME'
,p_da_action_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'',
''))
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5591560676353348)
,p_event_id=>wwv_flow_imp.id(5591096469353347)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P6202_NAME'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'apex.item("P6202_ID").displayValueFor($v("P6202_ID"))'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_da_action_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'',
''))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5588369785353345)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Component Group'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P6202_NEW_COMPONENT_GROUP_ID := wwv_flow_component_group_dev.copy_component_group (',
'                                     p_from_component_group_id  => :P6202_ID,',
'                                     p_from_app_id              => :P6202_COPY_FROM_APP_ID,',
'                                     p_new_name                 => :P6202_NAME,',
'                                     p_to_app_id                => :FB_FLOW_ID,',
'                                     p_subscribe                => :P6202_SUBSCRIBE = ''Y'' );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to copy the component group.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(5581934068353328)
,p_process_success_message=>'Component group copied.'
,p_internal_uid=>5588369785353345
);
end;
/
prompt --application/pages/page_06203
begin
wwv_flow_imp_page.create_page(
 p_id=>6203
,p_name=>'Copy Component Group  - Another App'
,p_alias=>'COPY-COMPONENT-GROUP-1'
,p_page_mode=>'MODAL'
,p_step_title=>'Copy Component Group '
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#comp_grp_components_cr td .b-Badge {',
'    min-inline-size: 100px;',
'    justify-content: center;',
'}'))
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'auto'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_protection_level=>'C'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(5078039502291448)
,p_name=>'Components - Copy & Subscribe'
,p_region_name=>'comp_grp_components_cr'
,p_template=>wwv_flow_imp.id(646287526247383209)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select s.component_type,',
'       ( select name',
'           from wwv_flow_appl_export_comps c',
'          where c.workspace_id   = :WORKSPACE_ID',
'            and c.application_id = :P6202_COPY_FROM_APP_ID',
'            and c.type_name      = s.component_type',
'            and c.id             = s.from_component_id ) component,',
'       s.matching_status,',
'       wwv_flow_lang.message(''COMP_GRP.MATCHING_STATUS.''||s.matching_status) matching_status_display,',
'       case s.matching_status',
'           when ''FOUND'' then ''danger''',
'           when ''NEEDS_REFRESH'' then ''warning''',
'           when ''NOT_FOUND'' then ''success''',
'           when ''UP_TO_DATE'' then ''info''',
'       end badge_state',
'  from wwv_flow_component_group_dev.compare (',
'           p_from_component_group_id => :P6202_ID,',
'           p_from_app_id             => :P6202_COPY_FROM_APP_ID,',
'           p_to_app_id               => :FB_FLOW_ID ) s',
' order by ',
'       case s.matching_status',
'           when ''FOUND'' then 1',
'           when ''NEEDS_REFRESH'' then 2',
'           when ''NOT_FOUND'' then 3',
'           when ''UP_TO_DATE'' then 4',
'       end,',
'       s.component_type'))
,p_display_when_condition=>'P6202_SUBSCRIBE'
,p_display_when_cond2=>'Y'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(11581099628703705)
,p_query_column_id=>1
,p_column_alias=>'COMPONENT_TYPE'
,p_column_display_sequence=>20
,p_column_heading=>'Component Type'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(5087092943835745)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(13518551119184735)
,p_query_column_id=>2
,p_column_alias=>'COMPONENT'
,p_column_display_sequence=>30
,p_column_heading=>'Component'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(11581280776703707)
,p_query_column_id=>3
,p_column_alias=>'MATCHING_STATUS'
,p_column_display_sequence=>40
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(11581397446703708)
,p_query_column_id=>4
,p_column_alias=>'MATCHING_STATUS_DISPLAY'
,p_column_display_sequence=>10
,p_column_heading=>'Action'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{with/}',
'VALUE:=#MATCHING_STATUS_DISPLAY#',
'STATE:=#BADGE_STATE#',
'{apply THEME$BADGE/}'))
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(11581442226703709)
,p_query_column_id=>5
,p_column_alias=>'BADGE_STATE'
,p_column_display_sequence=>50
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5749638398630596)
,p_plug_name=>'Help'
,p_region_template_options=>'#DEFAULT#:js-dialog-size480x320'
,p_plug_template=>wwv_flow_imp.id(557449278618308550)
,p_plug_display_sequence=>40
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>Add</strong>: A new component will be added to the target application.</li>',
'    <li><strong>Refresh</strong>: An existing component will be reused after refresh.</li>',
'    <li><strong>Replace</strong>: An existing component will be replaced with the master component.</li>',
'    <li><strong>Reuse</strong>: An existing component will be reused.</li>',
'</ul>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(11581559252703710)
,p_name=>'Components - Copy'
,p_region_name=>'comp_grp_components_cr'
,p_template=>wwv_flow_imp.id(646287526247383209)
,p_display_sequence=>30
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select s.component_type,',
'       ( select c.name',
'           from wwv_flow_appl_export_comps c',
'          where c.workspace_id   = :WORKSPACE_ID',
'            and c.application_id = :P6202_COPY_FROM_APP_ID',
'            and c.type_name      = s.component_type',
'            and c.id             = s.from_component_id ) component,',
'       s.matching_status,',
'       case when s.matching_status = ''NOT_FOUND'' then',
'           wwv_flow_lang.message(''COMP_GRP.MATCHING_STATUS.NOT_FOUND'')',
'       else',
'           wwv_flow_lang.message(''COMP_GRP.MATCHING_STATUS.UP_TO_DATE'')',
'       end matching_status_display,',
'       case when s.matching_status = ''NOT_FOUND'' then',
'           ''success''',
'       else',
'           ''info''',
'       end badge_state',
'  from wwv_flow_component_group_dev.compare (',
'           p_from_component_group_id => :P6202_ID,',
'           p_from_app_id             => :P6202_COPY_FROM_APP_ID,',
'           p_to_app_id               => :FB_FLOW_ID ) s',
' order by ',
'       case s.matching_status',
'           when ''NOT_FOUND'' then 1',
'           else 2',
'       end,',
'       s.component_type'))
,p_display_when_condition=>'P6202_SUBSCRIBE'
,p_display_when_cond2=>'N'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(11581780510703712)
,p_query_column_id=>1
,p_column_alias=>'COMPONENT_TYPE'
,p_column_display_sequence=>20
,p_column_heading=>'Component Type'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(5087092943835745)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(13518628234184736)
,p_query_column_id=>2
,p_column_alias=>'COMPONENT'
,p_column_display_sequence=>30
,p_column_heading=>'Component'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(11581950219703714)
,p_query_column_id=>3
,p_column_alias=>'MATCHING_STATUS'
,p_column_display_sequence=>40
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(11581644481703711)
,p_query_column_id=>4
,p_column_alias=>'MATCHING_STATUS_DISPLAY'
,p_column_display_sequence=>10
,p_column_heading=>'Action'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{with/}',
'VALUE:=#MATCHING_STATUS_DISPLAY#',
'STATE:=#BADGE_STATE#',
'{apply THEME$BADGE/}'))
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(11582069304703715)
,p_query_column_id=>5
,p_column_alias=>'BADGE_STATE'
,p_column_display_sequence=>50
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(69461867193757484)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5648178531988854)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(69461867193757484)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:6202:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5648599514988855)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(69461867193757484)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(7213308063927225)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(69461867193757484)
,p_button_name=>'HELP'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Help'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'icon-help'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5649336027988856)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(69461867193757484)
,p_button_name=>'COPY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy Component Group'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(5075891040291426)
,p_branch_name=>'Go To Page 6201'
,p_branch_action=>'f?p=&APP_ID.:6201:&SESSION.::&DEBUG.:6201:P6201_ID:&P6203_NEW_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5075731653291425)
,p_name=>'P6203_NEW_ID'
,p_item_sequence=>40
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(5074850695291416)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(5648599514988855)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(5074967832291417)
,p_event_id=>wwv_flow_imp.id(5074850695291416)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3236872039884309)
,p_name=>'Show Help'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(7213308063927225)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3236951889884310)
,p_event_id=>wwv_flow_imp.id(3236872039884309)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(5749638398630596)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(12602108701654589)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Component Group'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P6203_NEW_ID := wwv_flow_component_group_dev.copy_component_group (',
'                     p_from_component_group_id  => :P6202_ID,',
'                     p_from_app_id              => :P6202_COPY_FROM_APP_ID,',
'                     p_new_name                 => :P6202_NAME,',
'                     p_to_app_id                => :FB_FLOW_ID,',
'                     p_subscribe                => :P6202_SUBSCRIBE = ''Y'' );'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Unable to copy the component group.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(5649336027988856)
,p_process_success_message=>'Component group copied.'
,p_internal_uid=>12602108701654589
);
end;
/
prompt --application/pages/page_06204
begin
wwv_flow_imp_page.create_page(
 p_id=>6204
,p_name=>'Refresh Component Group'
,p_alias=>'REFRESH-COMPONENT-GROUP'
,p_page_mode=>'MODAL'
,p_step_title=>'Refresh Component Group'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#comp_grp_components_cr td .b-Badge {',
'    min-inline-size: 100px;',
'    justify-content: center;',
'}'))
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'auto'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_protection_level=>'C'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(13516851699184718)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(20051471503378449)
,p_name=>'Component Changes'
,p_region_name=>'comp_grp_components_cr'
,p_template=>wwv_flow_imp.id(646287526247383209)
,p_display_sequence=>10
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select s.component_type,',
'       ( select c.name',
'           from wwv_flow_appl_export_comps c',
'          where c.workspace_id   = :WORKSPACE_ID',
'            and c.application_id = case when s.from_component_id is not null then',
'                                       s.from_app_id',
'                                   else ',
'                                       s.to_app_id',
'                                   end',
'            and c.type_name      = s.component_type',
'            and c.id             = coalesce( s.from_component_id, s.to_component_id ) ) component,',
'       s.matching_status,',
'       case ',
'           when s.matching_status in ( ''FOUND'', ''NOT_FOUND'', ''UP_TO_DATE'' )',
'             or  ( s.matching_status = ''NEEDS_REFRESH'' and s.row_action is null ) then',
'               wwv_flow_lang.message(''COMP_GRP.MATCHING_STATUS.''||matching_status)',
'           when s.matching_status = ''NEEDS_REFRESH'' and s.row_action = ''ASSIGN'' then',
'               wwv_flow_lang.message(''COMP_GRP.REFRESH_ASSIGN'')',
'           when s.matching_status is null and s.row_action = ''UNASSIGN'' then',
'               wwv_flow_lang.message(''COMP_GRP.ROW_ACTION.UNASSIGN'')',
'       end matching_status_display,',
'       case s.matching_status',
'           when ''FOUND'' then ''danger''',
'           when ''NEEDS_REFRESH'' then ''warning''',
'           when ''NOT_FOUND'' then ''success''',
'           when ''UP_TO_DATE'' then ''info''',
'       end badge_state',
'  from wwv_flow_component_group_dev.compare (',
'           p_from_component_group_id => :P6204_REFERENCE_ID,',
'           p_from_app_id             => :P6204_MASTER_APP_ID,',
'           p_to_app_id               => :FB_FLOW_ID,',
'           p_to_component_group_id   => :P6204_ID,',
'           p_mode                    => ''REFRESH'' ) s',
' order by',
'       case s.matching_status',
'           when ''FOUND'' then 1',
'           when ''NEEDS_REFRESH'' then 2',
'           when ''NOT_FOUND'' then 3',
'           when ''UP_TO_DATE'' then 4',
'           else 5',
'       end,',
'       s.component_type'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_no_data_found=>'There are no component changes in this component group.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(14973729805087005)
,p_query_column_id=>1
,p_column_alias=>'COMPONENT_TYPE'
,p_column_display_sequence=>30
,p_column_heading=>'Component Type'
,p_use_as_row_header=>'Y'
,p_heading_alignment=>'LEFT'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(5087092943835745)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(13518877202184738)
,p_query_column_id=>2
,p_column_alias=>'COMPONENT'
,p_column_display_sequence=>60
,p_column_heading=>'Component'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(14974599063087005)
,p_query_column_id=>3
,p_column_alias=>'MATCHING_STATUS'
,p_column_display_sequence=>40
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(14974986712087006)
,p_query_column_id=>4
,p_column_alias=>'MATCHING_STATUS_DISPLAY'
,p_column_display_sequence=>20
,p_column_heading=>'Action'
,p_use_as_row_header=>'N'
,p_column_html_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{if MATCHING_STATUS_DISPLAY/}',
'{with/}',
'VALUE:=#MATCHING_STATUS_DISPLAY#',
'STATE:=#BADGE_STATE#',
'{apply THEME$BADGE/}',
'{endif/}'))
,p_column_alignment=>'CENTER'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(14975357890087006)
,p_query_column_id=>5
,p_column_alias=>'BADGE_STATE'
,p_column_display_sequence=>50
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(13516916038184719)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(13516851699184718)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1419173096012529)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(13516851699184718)
,p_button_name=>'HELP'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Help'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:6205:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-help'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(13517274778184722)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(13516851699184718)
,p_button_name=>'REFRESH'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Refresh'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(13518114358184731)
,p_branch_action=>'f?p=&APP_ID.:6201:&SESSION.::&DEBUG.:6201:P6201_ID:&P6204_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(13517313211184723)
,p_name=>'P6204_ID'
,p_item_sequence=>20
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(13517414565184724)
,p_name=>'P6204_REFERENCE_ID'
,p_item_sequence=>30
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(13517591108184725)
,p_name=>'P6204_MASTER_APP_ID'
,p_item_sequence=>40
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(13517019028184720)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(13516916038184719)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(13517179078184721)
,p_event_id=>wwv_flow_imp.id(13517019028184720)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(13517766170184727)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Refresh'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_component_group_dev.refresh_component_group (',
'    p_master_id          => :P6204_REFERENCE_ID,',
'    p_master_app_id      => :P6204_MASTER_APP_ID,',
'    p_subscribing_id     => :P6204_ID,',
'    p_subscribing_app_id => :FB_FLOW_ID );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(13517274778184722)
,p_process_success_message=>'Component group refreshed from the master.'
,p_internal_uid=>13517766170184727
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(13517620579184726)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Item Values'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id,',
'       flow_id',
'  into :P6204_REFERENCE_ID,',
'       :P6204_MASTER_APP_ID',
'  from wwv_flow_component_groups m',
' where id = (',
'     select reference_id ',
'       from wwv_flow_component_groups s ',
'      where s.id              = :P6204_ID',
'        and s.flow_id         = :FB_FLOW_ID',
'        and security_group_id = :WORKSPACE_ID )',
'   and security_group_id = :WORKSPACE_ID;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>13517620579184726
);
end;
/
prompt --application/pages/page_06205
begin
wwv_flow_imp_page.create_page(
 p_id=>6205
,p_name=>'Component Group Action Legend'
,p_alias=>'COMPONENT-GROUP-ACTION-LEGEND'
,p_page_mode=>'MODAL'
,p_step_title=>'Help'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'320'
,p_dialog_width=>'480'
,p_dialog_chained=>'N'
,p_protection_level=>'C'
,p_page_component_map=>'11'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1419418494012532)
,p_plug_name=>'Help'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<ul>',
'    <li><strong>Add</strong>: A new component will be added to the target application and it will be assigned to the component group.</li>',
'    <li><strong>Refresh</strong>: An existing component will be refreshed.</li>',
'    <li><strong>Refresh and Assign</strong>: An existing component will be refreshed and it will be assigned to the component group.</li>    ',
'    <li><strong>Replace</strong>: An existing component will be replaced with the master component and it will be assigned to the component group.</li>',
'    <li><strong>Reuse</strong>: An existing component will be assigned to the component group.</li>',
'    <li><strong>Unassign</strong>: This component will be unassigned from the component group.</li>',
'</ul>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
end;
/
prompt --application/pages/page_06206
begin
wwv_flow_imp_page.create_page(
 p_id=>6206
,p_name=>'Component Group - Assign Components'
,p_alias=>'COMPONENT-GROUP-ASSIGN-COMPONENTS'
,p_page_mode=>'MODAL'
,p_step_title=>'Assign Components'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_height=>'auto'
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:400'
,p_protection_level=>'C'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3236181259884302)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(15026306802305542)
,p_plug_name=>'Assign Components'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_display_condition_type=>'IS_NOT_READ_ONLY'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3443885196601823)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(3236181259884302)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3444298185601823)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(3236181259884302)
,p_button_name=>'ASSIGN_STAY'
,p_button_static_id=>'ASSIGN_STAY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Assign and Assign More'
,p_button_position=>'NEXT'
,p_show_processing=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3444631792601823)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(3236181259884302)
,p_button_name=>'ASSIGN'
,p_button_static_id=>'ASSIGN'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Assign'
,p_button_position=>'NEXT'
,p_show_processing=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3236264506884303)
,p_name=>'P6206_COMPONENT_GROUP_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(15026306802305542)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(15028136783305549)
,p_name=>'P6206_COMPONENT_TYPE'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(15026306802305542)
,p_prompt=>'Component Type'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'COMP_GRP_COMPONENT_TYPES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select case when type_name = ''PAGE'' then',
'           wwv_flow_lang_dev.builder_message(''PAGE_PATTERN'')',
'       else',
'           wwv_flow_lang_dev.builder_message(''COMPONENT_TYPE.''||type_name)',
'       end display_val,',
'       type_name return_val',
'  from wwv_flow_appl_component_types app_comp',
' where app_comp.type_name in ( ''APP_ITEM'',',
'                               ''APP_PROCESS'',',
'                               ''APP_COMPUTATION'',',
'                               ''APP_SETTING'',',
'                               ''BUILD_OPTION'',',
'                               ''LIST'',',
'                               ''SEARCH_CONFIG'',',
'                               ''DATA_LOAD'',',
'                               ''WEB_SOURCE'',',
'                               ''AUTHENTICATION'',',
'                               ''AUTHORIZATION'',',
'                               ''APP_ACL'',',
'                               ''EMAIL_TEMPLATE'',',
'                               ''LOV'',',
'                               ''PLUGIN'',',
'                               ''PLUGIN_SETTINGS'',',
'                               ''SHORTCUT'',',
'                               ''MAP_BACKGROUND'',',
'                               ''REPORT_LAYOUT'',',
'                               ''MESSAGE'' )',
'     or ( app_comp.type_name = ''PAGE'' ',
'          and ( select wwv_flow_platform.get_preference(''ENABLE_PAGE_PATTERNS'') ',
'                  from sys.dual ) = ''Y'' )',
'order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select a component type.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(15028297084305550)
,p_name=>'P6206_COMPONENT_IDS'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(15026306802305542)
,p_prompt=>'Components'
,p_display_as=>'NATIVE_SHUTTLE'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ac.name display_val,',
'       ac.id return_val',
'  from wwv_flow_appl_export_comps ac',
' where ac.type_name      = :P6206_COMPONENT_TYPE',
'   and ac.workspace_id   = :WORKSPACE_ID',
'   and ac.application_id = :FB_FLOW_ID',
'   and not exists (',
'       select 1',
'         from wwv_flow_comp_grp_components cc',
'        where cc.component_group_id = :P6206_COMPONENT_GROUP_ID',
'          and cc.component_id       = ac.id',
'          and cc.component_type     = ac.type_name',
'          and cc.flow_id            = :FB_FLOW_ID',
'          and cc.security_group_id  = :WORKSPACE_ID )          ',
'   -- when component type PAGE is selected, only show page patterns',
'   and (   :P6206_COMPONENT_TYPE != ''PAGE''',
'        or exists (',
'            select 1',
'              from wwv_flow_steps pp',
'             where pp.is_page_pattern   = ''Y''',
'               and pp.id                = ac.id',
'               and pp.flow_id           = :FB_FLOW_ID',
'               and pp.security_group_id = :WORKSPACE_ID ) )',
' order by 1'))
,p_lov_cascade_parent_items=>'P6206_COMPONENT_TYPE'
,p_ajax_items_to_submit=>'P6206_COMPONENT_GROUP_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_warn_on_unsaved_changes=>'I'
,p_lov_display_extra=>'NO'
,p_help_text=>'Please select one or more components to assign to the component group. Components that are already assigned to the group will not be available for selection.'
,p_attribute_01=>'ALL'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3236302934884304)
,p_name=>'Cancel Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3443885196601823)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3236426376884305)
,p_event_id=>wwv_flow_imp.id(3236302934884304)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3236566037884306)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Assign Components'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_component_group_dev.assign_components (',
'    p_component_group_id => :P6206_COMPONENT_GROUP_ID,',
'    p_app_id             => :FB_FLOW_ID,',
'    p_component_type     => :P6206_COMPONENT_TYPE,',
'    p_component_ids      => wwv_flow_string.split_numbers (',
'                                p_str   => :P6206_COMPONENT_IDS,',
'                                p_sep   => '':'' ) );'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':REQUEST IN ( ''ASSIGN'', ''ASSIGN_STAY'')'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>'Selected components assigned to the component group.'
,p_internal_uid=>3236566037884306
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3236636262884307)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_CLOSE_WINDOW'
,p_process_name=>'Close Dialog'
,p_attribute_02=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3444631792601823)
,p_internal_uid=>3236636262884307
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3236761423884308)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Assign & Stay'
,p_process_sql_clob=>':P6206_COMPONENT_TYPE := NULL;'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3444298185601823)
,p_internal_uid=>3236761423884308
);
end;
/
prompt --application/pages/page_06210
begin
wwv_flow_imp_page.create_page(
 p_id=>6210
,p_name=>'Page Pattern Utilization'
,p_alias=>'UTILIZATION4'
,p_step_title=>'Page Pattern Utilization'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7216833911514029)
,p_plug_name=>'Utilization'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  ',
'    p.page_pattern_id       as page_pattern_id,',
'    wwv_flow_utilities.prepare_url',
'        (    ''f?p=4000:4500:''',
'          || :flow_session',
'          || ''::::FB_FLOW_PAGE_ID:''',
'          || p.page_pattern_id',
'        )                   as pattern_url,',
'    pattern.name            as pattern_page_name,                        ',
'    p.id                    as page_id, ',
'    wwv_flow_utilities.prepare_url',
'        (    ''f?p=4000:4500:''',
'          || :flow_session',
'          || ''::::FB_FLOW_PAGE_ID:''',
'          || p.id',
'        )                   as page_url,',
'    p.name                  as page_name',
'from wwv_flow_steps           p,',
'     wwv_flow_steps           pattern',
'where p.page_pattern_id         = pattern.id',
'  and pattern.flow_id           = p.flow_id',
'  and pattern.security_group_id = p.security_group_id',
'  and p.security_group_id       = :flow_security_group_id',
'  and p.flow_id                 = :FB_FLOW_ID',
''))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Utilization'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(6520182246898908)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'No Page Patten utilizations found.'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_control_break=>'N'
,p_show_highlight=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_pivot=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'ADMIN'
,p_internal_uid=>6520182246898908
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1414590321465003)
,p_db_column_name=>'PATTERN_PAGE_NAME'
,p_display_order=>10
,p_column_identifier=>'L'
,p_column_label=>'Page Pattern Name'
,p_column_link=>'#PATTERN_URL#'
,p_column_linktext=>'#PATTERN_PAGE_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1414344387465001)
,p_db_column_name=>'PAGE_PATTERN_ID'
,p_display_order=>20
,p_column_identifier=>'J'
,p_column_label=>'Page Pattern'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4115446703073643)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>30
,p_column_identifier=>'D'
,p_column_label=>'Page Name'
,p_column_link=>'#PAGE_URL#'
,p_column_linktext=>'#PAGE_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4115053751073643)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>40
,p_column_identifier=>'C'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1414455877465002)
,p_db_column_name=>'PATTERN_URL'
,p_display_order=>60
,p_column_identifier=>'K'
,p_column_label=>'Pattern Url'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1414662144465004)
,p_db_column_name=>'PAGE_URL'
,p_display_order=>70
,p_column_identifier=>'M'
,p_column_label=>'Page Url'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(7221781826108463)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'33018'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'PAGE_ID:PAGE_NAME::PAGE_PATTERN_ID:PATTERN_URL:PATTERN_PAGE_NAME:PAGE_URL'
,p_break_on=>'PATTERN_PAGE_NAME:PAGE_PATTERN_ID'
,p_break_enabled_on=>'PATTERN_PAGE_NAME:PAGE_PATTERN_ID'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(489110020214530012)
,p_plug_name=>'About'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page displays where <strong>Page Patterns</strong> are being used within the application.',
'</p>',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
end;
/
prompt --application/pages/page_07020
begin
wwv_flow_imp_page.create_page(
 p_id=>7020
,p_name=>'Automations'
,p_alias=>'AUTOMATIONS'
,p_step_title=>'Automations'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function runAutomation( pId ) {',
'    $s("P7020_ID", pId);',
'    apex.submit(''PLAY'');',
'}'))
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1379958984188245)
,p_plug_name=>'Copy Automation'
,p_region_template_options=>'#DEFAULT#:js-dialog-size600x400'
,p_plug_template=>wwv_flow_imp.id(557449278618308550)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2533191240513173)
,p_plug_name=>'Automations Report '
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ID,',
'       FLOW_ID,',
'       SECURITY_GROUP_ID,',
'       NAME,',
'       STATIC_ID,',
'       TRIGGER_TYPE,',
'       POLLING_INTERVAL,',
'       POLLING_LAST_RUN_TIMESTAMP,',
'       POLLING_NEXT_RUN_TIMESTAMP,',
'       POLLING_STATUS,',
'       case polling_status',
'           when ''ACTIVE'' then ''icon-check''',
'           when ''DISABLED'' then ''icon-error''',
'           when ''ERROR''    then ''icon-warning'' end as status_icon,',
'       RESULT_TYPE,',
'       LOCATION,',
'       --',
'       null as actions',
'  from WWV_FLOW_AUTOMATIONS',
' where flow_id = :FB_FLOW_ID and security_group_id = :WORKSPACE_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Automations Report '
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(2533511338513173)
,p_name=>'Report 1'
,p_max_row_count_message=>'The maximum row count for this report is #MAX_ROW_COUNT# rows.  Please apply a filter to reduce the number of records in your query.'
,p_no_data_found_message=>'No automations found.'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'MARC'
,p_internal_uid=>2533511338513173
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2534875345513178)
,p_db_column_name=>'NAME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Name'
,p_column_link=>'f?p=&APP_ID.:7021:&SESSION.::&DEBUG.::P7021_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2535299980513178)
,p_db_column_name=>'STATIC_ID'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Static ID'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2536079157513178)
,p_db_column_name=>'TRIGGER_TYPE'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Type'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(1355426926728029)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2536411083513178)
,p_db_column_name=>'POLLING_INTERVAL'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Schedule Expression'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2536876646513178)
,p_db_column_name=>'POLLING_LAST_RUN_TIMESTAMP'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Last Run'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2537283890513178)
,p_db_column_name=>'POLLING_NEXT_RUN_TIMESTAMP'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Next Run'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2537635665513178)
,p_db_column_name=>'POLLING_STATUS'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Schedule Status'
,p_column_html_expression=>'<span class="a-Icon #STATUS_ICON#"></span>&nbsp;#POLLING_STATUS#'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(1358229692738259)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2538080396513179)
,p_db_column_name=>'RESULT_TYPE'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Execute Actions When'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(1356468048734066)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2538431779513179)
,p_db_column_name=>'LOCATION'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Location'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(3842073961668883)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2533603144513175)
,p_db_column_name=>'ID'
,p_display_order=>23
,p_column_identifier=>'A'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2534096746513177)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>33
,p_column_identifier=>'B'
,p_column_label=>'Flow Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2534417521513178)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>43
,p_column_identifier=>'C'
,p_column_label=>'Security Group Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1379177251188237)
,p_db_column_name=>'STATUS_ICON'
,p_display_order=>63
,p_column_identifier=>'O'
,p_column_label=>'Status Icon'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1497534225970622)
,p_db_column_name=>'ACTIONS'
,p_display_order=>73
,p_column_identifier=>'Q'
,p_column_label=>'Run'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_column_type=>'STRING'
,p_display_text_as=>'TMPL_THEME_3$ACTIONS'
,p_column_alignment=>'CENTER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'ACTIONS_WRAP', 'N',
  'STYLE', 'b-InlineActions--simple')).to_clob
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(2550626531514215)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'25507'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'NAME:TRIGGER_TYPE:RESULT_TYPE:POLLING_STATUS:POLLING_LAST_RUN_TIMESTAMP:POLLING_NEXT_RUN_TIMESTAMP::STATUS_ICON:ACTIONS'
,p_sort_column_1=>'POLLING_NEXT_RUN_TIMESTAMP'
,p_sort_direction_1=>'ASC NULLS LAST'
,p_sort_column_2=>'0'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2900862523394601)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_imp.id(2700189206621868)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2900983179394602)
,p_plug_name=>'Automations'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Automations initiate a sequential set of actions based on a schedule. They are used to monitor data and then perform the appropriate action. Examples are auto-approving specific requests and sending email alerts.',
'</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(2901080518394603)
,p_name=>'Recently Edited'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--sideRegion:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'REGION_POSITION_03'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P7020b */ replace(replace(name,''_'','' ''),''.'','' '') name, id',
'from  wwv_flow_automations',
'where flow_id = :fb_flow_id',
'and last_updated_on is not null',
'and security_group_id = :flow_security_group_id',
'order by last_updated_on desc'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_automations ',
' where flow_id = :fb_flow_id',
'   and last_updated_on is not null',
'   and security_group_id = :flow_security_group_id'))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(11667910335347890)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2901192108394604)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:7021:&SESSION.::&DEBUG.::P7021_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(2901253412394605)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(29895294190987845)
,p_name=>'Last 24 hours'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#:a-BadgeList--stacked:a-BadgeList--large'
,p_display_point=>'REGION_POSITION_03'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'with data as (',
'    select count(id) as executions,',
'           nvl( sum(successful_row_count + error_row_count), 0)  as rows_processed',
'      from wwv_flow_automation_log',
'     where security_group_id = :WORKSPACE_ID',
'       and flow_id           = :FB_FLOW_ID',
'       and start_timestamp   >= systimestamp - interval ''1'' day',
')',
'select executions,',
'       case when rows_processed < 1000                   then to_char(rows_processed)',
'            when rows_processed between 1000 and 1000000 then floor( rows_processed / 100 ) / 10    || ''K''',
'            else                                              floor( rows_processed / 100000 ) / 10 || ''M'' ',
'       end as rows_processed',
'  from data',
'  '))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(1041640454953406573)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(29895383069987846)
,p_query_column_id=>1
,p_column_alias=>'EXECUTIONS'
,p_column_display_sequence=>10
,p_column_heading=>'Executions'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(29895471954987847)
,p_query_column_id=>2
,p_column_alias=>'ROWS_PROCESSED'
,p_column_display_sequence=>20
,p_column_heading=>'Rows Processed'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1934466572374315)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1379958984188245)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1934093123374311)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1379958984188245)
,p_button_name=>'COPY_AUTOMATION'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy Automation'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1933766281374308)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2533191240513173)
,p_button_name=>'COPY'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Copy'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2550221776513183)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(2533191240513173)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:7030:&SESSION.::&DEBUG.:7030,7031'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1935114906374322)
,p_branch_name=>'Go To Page 7021'
,p_branch_action=>'f?p=&APP_ID.:7021:&SESSION.::&DEBUG.:7021,7020:P7021_ID:&P7020_COPY_NEW_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(1934093123374311)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1380091207188246)
,p_name=>'P7020_FROM_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1379958984188245)
,p_prompt=>'Copy Automation'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name,',
'       id',
'  from wwv_flow_automations',
' where security_group_id = :WORKSPACE_ID',
'   and flow_id           = :P7020_APPLICATIONS'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_lov_cascade_parent_items=>'P7020_APPLICATIONS'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose the automation to copy'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1380188239188247)
,p_name=>'P7020_COPY_NEW_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(1379958984188245)
,p_prompt=>'New Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Provide a name for the copied automation.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1380273100188248)
,p_name=>'P7020_COPY_NEW_STATIC_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(1379958984188245)
,p_prompt=>'New Static ID'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>50
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Provide a static ID for the copied automation.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1380348778188249)
,p_name=>'P7020_COPY_SOURCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1379958984188245)
,p_item_default=>'THIS'
,p_prompt=>'Copy From'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P7020_COPY_SOURCE'
,p_lov=>'.'||wwv_flow_imp.id(601116568254832030)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Whether to copy the automation from this or from another application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1380432360188250)
,p_name=>'P7020_APPLICATIONS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1379958984188245)
,p_prompt=>'Applications'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||name d, id r',
'  from wwv_flow_visible_flows f',
' where f.build_status != ''RUN_AND_HIDDEN''',
' order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose the application to copy the automation from.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1926315765406302)
,p_name=>'P7020_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2533191240513173)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1935012768374321)
,p_name=>'P7020_COPY_NEW_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(1379958984188245)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1377761480188223)
,p_validation_name=>'Can execute Automation ID'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_automations',
' where id                = :P7020_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and flow_id           = :FB_FLOW_ID'))
,p_validation_type=>'EXISTS'
,p_error_message=>'Automation does not exist.'
,p_validation_condition=>'PLAY'
,p_validation_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1934171122374312)
,p_validation_name=>'Copy From Automation must be not NULL'
,p_validation_sequence=>20
,p_validation=>'P7020_FROM_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'An automation to copy is required.'
,p_when_button_pressed=>wwv_flow_imp.id(1934093123374311)
,p_associated_item=>wwv_flow_imp.id(1380091207188246)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1934247886374313)
,p_validation_name=>'New Name must be not null'
,p_validation_sequence=>30
,p_validation=>'P7020_COPY_NEW_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_when_button_pressed=>wwv_flow_imp.id(1934093123374311)
,p_associated_item=>wwv_flow_imp.id(1380188239188247)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1934320286374314)
,p_validation_name=>'New Static ID must be not null'
,p_validation_sequence=>40
,p_validation=>'P7020_COPY_NEW_STATIC_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_when_button_pressed=>wwv_flow_imp.id(1934093123374311)
,p_associated_item=>wwv_flow_imp.id(1380273100188248)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1934723236374318)
,p_validation_name=>'New Name must not yet exist'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_automations',
' where security_group_id = :WORKSPACE_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and name              = :P7020_COPY_NEW_NAME;'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'The new automation name is already taken. '
,p_when_button_pressed=>wwv_flow_imp.id(1934093123374311)
,p_associated_item=>wwv_flow_imp.id(1380188239188247)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1934821394374319)
,p_validation_name=>'New Static ID must not yet exist'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_automations',
' where security_group_id = :WORKSPACE_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and static_id         = :P7020_COPY_NEW_STATIC_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'The new automation static ID is already taken. '
,p_when_button_pressed=>wwv_flow_imp.id(1934093123374311)
,p_associated_item=>wwv_flow_imp.id(1380188239188247)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1933013795374301)
,p_name=>'This App'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7020_COPY_SOURCE'
,p_condition_element=>'P7020_COPY_SOURCE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'THIS'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1933135420374302)
,p_event_id=>wwv_flow_imp.id(1933013795374301)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7020_APPLICATIONS'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1933528357374306)
,p_event_id=>wwv_flow_imp.id(1933013795374301)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7020_APPLICATIONS'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1933463560374305)
,p_event_id=>wwv_flow_imp.id(1933013795374301)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7020_APPLICATIONS'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':FB_FLOW_ID'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1933603263374307)
,p_event_id=>wwv_flow_imp.id(1933013795374301)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7020_APPLICATIONS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1933829550374309)
,p_name=>'Copy Automation'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1933766281374308)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1935296164374323)
,p_event_id=>wwv_flow_imp.id(1933829550374309)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7020_APPLICATIONS,P7020_FROM_ID,P7020_COPY_NEW_ID,P7020_COPY_NEW_NAME,P7020_COPY_NEW_STATIC_ID'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1935373169374324)
,p_event_id=>wwv_flow_imp.id(1933829550374309)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7020_COPY_SOURCE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'THIS'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1933915141374310)
,p_event_id=>wwv_flow_imp.id(1933829550374309)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1379958984188245)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1934547498374316)
,p_name=>'Cancel Copy Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1934466572374315)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1934695503374317)
,p_event_id=>wwv_flow_imp.id(1934547498374316)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLOSE_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1379958984188245)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1926284457406301)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Run Automation'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_automation.execute_due_automations( p_automation_id => :P7020_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'PLAY'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>'Automation Execution initiated.'
,p_internal_uid=>1926284457406301
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1934960443374320)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Automation'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    :P7020_COPY_NEW_ID :=wwv_flow_automation_dev.copy(',
'                    p_id           => :P7020_FROM_ID,',
'                    p_to_name      => :P7020_COPY_NEW_NAME,',
'                    p_to_static_id => :P7020_COPY_NEW_STATIC_ID,',
'                    p_to_flow_id   => :FB_FLOW_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1934093123374311)
,p_process_success_message=>'Automation copied.'
,p_internal_uid=>1934960443374320
);
wwv_flow_imp_page.create_component_action(
 p_id=>wwv_flow_imp.id(1497646920970623)
,p_ir_column_id=>wwv_flow_imp.id(1497534225970622)
,p_position_id=>wwv_flow_imp.id(214437533860142316)
,p_display_sequence=>10
,p_template_id=>wwv_flow_imp.id(214438625365151034)
,p_label=>'Run'
,p_link_target_type=>'REDIRECT_URL'
,p_link_target=>'javascript:runAutomation(''#ID#'');'
,p_button_display_type=>'ICON'
,p_icon_css_classes=>'icon-run-script'
,p_is_hot=>false
,p_show_as_disabled=>false
);
end;
/
prompt --application/pages/page_07021
begin
wwv_flow_imp_page.create_page(
 p_id=>7021
,p_name=>'Edit Automation'
,p_alias=>'EDIT-AUTOMATION'
,p_step_title=>'Edit Automation'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';',
'',
'function buildInterval() {',
'    var lIntervalString = ''FREQ='' + $v("P7021_INT_FREQUENCY") +',
'                          '';INTERVAL='' + $v("P7021_INT_INTERVAL");',
'    ',
'    if ( $v("P7021_BYDAY") !== "" && $v("P7021_INT_FREQUENCY") !== "DAILY" && $v("P7021_BYDAY") !== "MON:TUE:WED:THU:FRI:SAT:SUN" ) {',
'       lIntervalString =  lIntervalString + ";BYDAY=" + $v("P7021_BYDAY").replace(/:/g,",");',
'    }',
'    if ( $v("P7021_BYHOUR") !== "" && $v("P7021_INT_FREQUENCY") !== "HOURLY") {',
'       lIntervalString =  lIntervalString + ";BYHOUR=" + $v("P7021_BYHOUR");',
'    }',
'    if ( $v("P7021_BYMINUTE") !== "" && $v("P7021_INT_FREQUENCY") !== "MINUTELY" ) {',
'       lIntervalString =  lIntervalString + ";BYMINUTE=" + $v("P7021_BYMINUTE");',
'    }',
'        ',
'    return lIntervalString;',
'}',
'',
'function refreshPrimaryKeyColumns() { ',
'    apex.server.process( ',
'        "getColumnInfo",',
'        { ',
'            pageItems: "#P7021_LOCATION,#P7021_LOCAL_DATA_SOURCE_TYPE,#P7021_REMOTE_DATA_SOURCE_TYPE,#P7021_TABLE_OWNER,#P7021_REMOTE_TABLE_OWNER,#P7021_TABLE_NAME,#P7021_REMOTE_TABLE_NAME,#P7021_SQL,#P7021_REMOTE_SQL,#P7021_SOURCE_POST_PROCESSING,#P'
||'7021_POST_PROCESS_QUERY,#P7021_FUNCTION_BODY,#P7021_REMOTE_FUNC_BODY,#P7021_POST_PROC_FUNC_BODY,#P7021_FUNCTION_BODY_LANGUAGE,#P7021_REMOTE_FUNC_BODY_LANG,#P7021_POST_PROC_FUNC_BODY_LANG,#P7021_WEB_SRC_MODULE_ID,#P7021_REMOTE_SERVER_ID,#P7021_INCLUDE'
||'_ROWID_COLUMN,#P7021_REMOTE_INCLUDE_ROWID,#P7021_GRAPH_NAME,#P7021_PQL_MATCH_CLAUSE,#P7021_PQL_COLUMNS_CLAUSE,#P7021_PQL_WHERE_CLAUSE"        },',
'        {',
'            success: function( pData ) {',
'                var lItems = apex.jQuery( ".is-column");',
'',
'                //-----------------------------------------------------------------------------------------',
'                function refreshItem( pItem$, pSetValue ) {',
'                    var lValue           = apex.item( pItem$.attr( "name" ) ).getValue(),',
'                        lValueStillValid = false,',
'                        lNullOption$     = pItem$.find( ''option[value=""]''),',
'                        lOption$;',
'',
'                    pItem$.empty();',
'                    if ( lNullOption$.length > 0 ) {',
'                        pItem$.append( lNullOption$ );',
'                    }',
'                    ',
'                    for ( let o = 0; o < pData.length; o++ ) {',
'                        if (    pData[ o ].t === "NUMBER" ',
'                                || pData[ o ].t === "VARCHAR2" ',
'                                || pData[ o ].t === "DATE" ',
'                                || pData[ o ].t === "TIMESTAMP"  )',
'                        {',
'                            lOption$ = apex.jQuery("<option></option>").attr("value", pData[ o ].r ).text( pData[ o ].d );',
'                            if ( pData[ o ].r === lValue ) {',
'                                lValueStillValid = true;',
'                            }',
'                            pItem$.append( lOption$ );',
'                        }',
'                    }',
'',
'                    if ( pSetValue ) {',
'                        if ( lValueStillValid ) {',
'                            apex.item( pItem$.attr( "name" ) ).setValue( lValue );',
'                        } else {',
'                            apex.item( pItem$.attr( "name" ) ).setValue( "" );',
'                        }',
'                    }',
'                }',
'',
'                if ( pData.length > 0 ) {',
'                    for (let i=0; i<lItems.length;i++) {',
'                        refreshItem( apex.jQuery (lItems[ i ] ), true );',
'                    }',
'                }',
'            }',
'        }',
'    );',
'}'))
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_read_only_when_type=>'EXPRESSION'
,p_read_only_when=>':P7021_LOCAL_DATA_SOURCE_TYPE = ''GRAPH'' and sys.dbms_db_version.version < 23'
,p_read_only_when2=>'PLSQL'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1807698834591844)
,p_plug_name=>'Action Execution'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_region_attributes=>'style="padding-top: 10px"'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2513514643671712)
,p_plug_name=>'Query related parameters'
,p_parent_plug_id=>wwv_flow_imp.id(1807698834591844)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2517114410671748)
,p_plug_name=>'Only for Data Found'
,p_parent_plug_id=>wwv_flow_imp.id(2513514643671712)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2513640627671713)
,p_plug_name=>'Common Parameters'
,p_parent_plug_id=>wwv_flow_imp.id(1807698834591844)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2065703853407625)
,p_plug_name=>'Function Body Returning Boolean'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2066950595407637)
,p_plug_name=>'Local'
,p_parent_plug_id=>wwv_flow_imp.id(2065703853407625)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2067168170407639)
,p_plug_name=>'Remote'
,p_parent_plug_id=>wwv_flow_imp.id(2065703853407625)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2500558986513154)
,p_plug_name=>'Settings'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_AUTOMATIONS'
,p_query_where=>'security_group_id = :WORKSPACE_ID'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2901312169394606)
,p_plug_name=>'Automation: &P7021_NAME.'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2901494873394607)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2901534819394608)
,p_plug_name=>'Name'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4800138856119501)
,p_plug_name=>'Advanced'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>110
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4800456594119504)
,p_plug_name=>'Automations'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'<strong>Automations</strong> initiate a sequential set of processes. They are used to monitor data and then perform the appropriate action (examples are auto-approving specific requests and sending email alerts).',
'</p>',
'<p>',
'<strong>Automation Actions</strong> fire once for each row returned by the automation source. An action can reference the values of each column for each row using bind variable syntax.</p>',
'<p>',
'After <em>importing</em> an application, automations will be <em>disabled</em>, to prevent multiple automations running simultaneously. The automation needs to be explicitly enabled, either in this page or using the <strong>APEX_AUTOMATION</strong> p'
||'ackage.</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>',
'',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4803374779119533)
,p_plug_name=>'Additional Code Execution'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>90
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4803890382119538)
,p_plug_name=>'Actions'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_AUTOMATION_ACTIONS'
,p_query_where=>wwv_flow_string.join(wwv_flow_t_varchar2(
'automation_id = :P7021_ID and  ',
'flow_id = :FB_FLOW_ID and  ',
'security_group_id = :flow_security_group_id'))
,p_include_rowid_column=>false
,p_plug_source_type=>'NATIVE_IG'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Actions'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(4804039241119540)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_LINK'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>30
,p_value_alignment=>'LEFT'
,p_link_target=>'javascript:apex.submit({request:''APPLY_CHANGES_EDIT_7021'',set:{''P7021_ACTION_ID'':''&ID.''}});'
,p_link_text=>'<span class="a-Icon icon-edit" title="&EDIT."></span>'
,p_link_attributes=>'class="a-Button a-Button--noUI"'
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
,p_display_condition_type=>'EXPRESSION'
,p_display_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    :P7021_ID is not null',
'and ( nvl( :P7021_LOCAL_DATA_SOURCE_TYPE, ''X'' ) != ''GRAPH'' or sys.dbms_db_version.version >= 23 )'))
,p_display_condition2=>'PLSQL'
,p_escape_on_http_output=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(4804163839119541)
,p_name=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FLOW_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>40
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(4804275890119542)
,p_name=>'SECURITY_GROUP_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'SECURITY_GROUP_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>50
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(4804317400119543)
,p_name=>'AUTOMATION_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'AUTOMATION_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>60
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(4804423459119544)
,p_name=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>70
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_max_length=>255
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>true
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(4804541306119545)
,p_name=>'EXECUTION_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'EXECUTION_SEQUENCE'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>'Execution Sequence'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>80
,p_value_alignment=>'RIGHT'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
,p_is_required=>true
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(4804675812119546)
,p_name=>'ACTION_TYPE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ACTION_TYPE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Action Type'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>90
,p_value_alignment=>'LEFT'
,p_is_required=>false
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(362343527524601835)
,p_lov_display_extra=>false
,p_lov_display_null=>false
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>false
,p_include_in_export=>false
,p_readonly_condition_type=>'ALWAYS'
,p_readonly_for_each_row=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(4804747120119547)
,p_name=>'ACTION_CLOB'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ACTION_CLOB'
,p_data_type=>'CLOB'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Action Clob'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>100
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>32767
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(4804885799119548)
,p_name=>'ATTRIBUTE_01'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ATTRIBUTE_01'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Attribute 01'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>110
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(4804959696119549)
,p_name=>'ATTRIBUTE_02'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ATTRIBUTE_02'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Attribute 02'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>120
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(4805006066119550)
,p_name=>'ATTRIBUTE_03'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ATTRIBUTE_03'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Attribute 03'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>130
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5813956115534501)
,p_name=>'ATTRIBUTE_04'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ATTRIBUTE_04'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Attribute 04'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>140
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5814085723534502)
,p_name=>'ATTRIBUTE_05'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ATTRIBUTE_05'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Attribute 05'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>150
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5814117196534503)
,p_name=>'ATTRIBUTE_06'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ATTRIBUTE_06'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Attribute 06'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>160
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5814269683534504)
,p_name=>'ATTRIBUTE_07'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ATTRIBUTE_07'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Attribute 07'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>170
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5814321181534505)
,p_name=>'ATTRIBUTE_08'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ATTRIBUTE_08'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Attribute 08'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>180
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5814496797534506)
,p_name=>'ATTRIBUTE_09'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ATTRIBUTE_09'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Attribute 09'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>190
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5814536296534507)
,p_name=>'ATTRIBUTE_10'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ATTRIBUTE_10'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Attribute 10'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>200
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5814671610534508)
,p_name=>'ATTRIBUTE_11'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ATTRIBUTE_11'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Attribute 11'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>210
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5814715906534509)
,p_name=>'ATTRIBUTE_12'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ATTRIBUTE_12'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Attribute 12'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>220
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5814822881534510)
,p_name=>'ATTRIBUTE_13'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ATTRIBUTE_13'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Attribute 13'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>230
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5814986034534511)
,p_name=>'ATTRIBUTE_14'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ATTRIBUTE_14'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Attribute 14'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>240
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5815062608534512)
,p_name=>'ATTRIBUTE_15'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ATTRIBUTE_15'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Attribute 15'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>250
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5815166754534513)
,p_name=>'LOCATION'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LOCATION'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Location'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>260
,p_value_alignment=>'LEFT'
,p_is_required=>false
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(3842073961668883)
,p_lov_display_extra=>false
,p_lov_display_null=>false
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
,p_readonly_condition_type=>'ALWAYS'
,p_readonly_for_each_row=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5815218564534514)
,p_name=>'REMOTE_SERVER_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'REMOTE_SERVER_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>'Remote Server Id'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>270
,p_value_alignment=>'RIGHT'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5815373703534515)
,p_name=>'WEB_SRC_MODULE_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'WEB_SRC_MODULE_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>'Web Src Module Id'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>280
,p_value_alignment=>'RIGHT'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5815411031534516)
,p_name=>'WEB_SRC_OPERATION_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'WEB_SRC_OPERATION_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>'Web Src Operation Id'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>290
,p_value_alignment=>'RIGHT'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5815558620534517)
,p_name=>'ERROR_MESSAGE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ERROR_MESSAGE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Error Message'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>300
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5815678589534518)
,p_name=>'STOP_EXECUTION_ON_ERROR'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'STOP_EXECUTION_ON_ERROR'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>310
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5815712882534519)
,p_name=>'CONDITION_TYPE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'CONDITION_TYPE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Condition Type'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>320
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>255
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5815818983534520)
,p_name=>'CONDITION_EXPR1'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'CONDITION_EXPR1'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Condition Expr1'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>330
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5815959127534521)
,p_name=>'CONDITION_EXPR2'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'CONDITION_EXPR2'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Condition Expr2'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>340
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5816055949534522)
,p_name=>'EXEC_COND_FOR_EACH_ROW'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'EXEC_COND_FOR_EACH_ROW'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Exec Cond For Each Row'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>350
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>1
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5816113084534523)
,p_name=>'BUILD_OPTION_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'BUILD_OPTION_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>'Build Option Id'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>360
,p_value_alignment=>'RIGHT'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5816229551534524)
,p_name=>'ACTION_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ACTION_COMMENT'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Action Comment'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>370
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5816379685534525)
,p_name=>'CREATED_BY'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'CREATED_BY'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Created By'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>380
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>255
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5816493910534526)
,p_name=>'CREATED_ON'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'CREATED_ON'
,p_data_type=>'DATE'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_DATE_PICKER_APEX'
,p_heading=>'Created On'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>390
,p_value_alignment=>'CENTER'
,p_attribute_01=>'N'
,p_attribute_02=>'POPUP'
,p_attribute_03=>'NONE'
,p_attribute_06=>'NONE'
,p_attribute_09=>'N'
,p_attribute_11=>'Y'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_date_ranges=>'ALL'
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5816505519534527)
,p_name=>'LAST_UPDATED_BY'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LAST_UPDATED_BY'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Last Updated By'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>400
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>255
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5816685002534528)
,p_name=>'LAST_UPDATED_ON'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LAST_UPDATED_ON'
,p_data_type=>'DATE'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_DATE_PICKER_APEX'
,p_heading=>'Last Updated On'
,p_heading_alignment=>'CENTER'
,p_display_sequence=>410
,p_value_alignment=>'CENTER'
,p_attribute_01=>'N'
,p_attribute_02=>'POPUP'
,p_attribute_03=>'NONE'
,p_attribute_06=>'NONE'
,p_attribute_09=>'N'
,p_attribute_11=>'Y'
,p_is_required=>false
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_date_ranges=>'ALL'
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5816725864534529)
,p_name=>'APEX$ROW_ACTION'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>20
,p_use_as_row_header=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5816809960534530)
,p_name=>'APEX$ROW_SELECTOR'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_use_as_row_header=>false
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(4803910563119539)
,p_internal_uid=>4803910563119539
,p_is_editable=>true
,p_edit_operations=>'u:d'
,p_lost_update_check_type=>'VALUES'
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>true
,p_no_data_found_message=>'Click <strong>Add Action</strong> to create the first Action.'
,p_show_toolbar=>true
,p_toolbar_buttons=>'SEARCH_COLUMN:SEARCH_FIELD:RESET'
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>false
,p_define_chart_view=>false
,p_enable_download=>false
,p_download_formats=>null
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(5820473146534722)
,p_interactive_grid_id=>wwv_flow_imp.id(4803910563119539)
,p_static_id=>'14393'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(5820532485534723)
,p_report_id=>wwv_flow_imp.id(5820473146534722)
,p_view_type=>'GRID'
,p_stretch_columns=>true
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5821007254534729)
,p_view_id=>wwv_flow_imp.id(5820532485534723)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(4804039241119540)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>40
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5821569676534733)
,p_view_id=>wwv_flow_imp.id(5820532485534723)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(4804163839119541)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5822086014534735)
,p_view_id=>wwv_flow_imp.id(5820532485534723)
,p_display_seq=>2
,p_column_id=>wwv_flow_imp.id(4804275890119542)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5822553828534736)
,p_view_id=>wwv_flow_imp.id(5820532485534723)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(4804317400119543)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5823086444534737)
,p_view_id=>wwv_flow_imp.id(5820532485534723)
,p_display_seq=>6
,p_column_id=>wwv_flow_imp.id(4804423459119544)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5823585899534738)
,p_view_id=>wwv_flow_imp.id(5820532485534723)
,p_display_seq=>6
,p_column_id=>wwv_flow_imp.id(4804541306119545)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>168.66699999999997
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5824034802534739)
,p_view_id=>wwv_flow_imp.id(5820532485534723)
,p_display_seq=>7
,p_column_id=>wwv_flow_imp.id(4804675812119546)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5824542343534741)
,p_view_id=>wwv_flow_imp.id(5820532485534723)
,p_display_seq=>8
,p_column_id=>wwv_flow_imp.id(4804747120119547)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5825094650534742)
,p_view_id=>wwv_flow_imp.id(5820532485534723)
,p_display_seq=>9
,p_column_id=>wwv_flow_imp.id(4804885799119548)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5825521168534743)
,p_view_id=>wwv_flow_imp.id(5820532485534723)
,p_display_seq=>10
,p_column_id=>wwv_flow_imp.id(4804959696119549)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5826089507534744)
,p_view_id=>wwv_flow_imp.id(5820532485534723)
,p_display_seq=>11
,p_column_id=>wwv_flow_imp.id(4805006066119550)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5826536715534746)
,p_view_id=>wwv_flow_imp.id(5820532485534723)
,p_display_seq=>12
,p_column_id=>wwv_flow_imp.id(5813956115534501)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5827017853534747)
,p_view_id=>wwv_flow_imp.id(5820532485534723)
,p_display_seq=>13
,p_column_id=>wwv_flow_imp.id(5814085723534502)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5827582043534748)
,p_view_id=>wwv_flow_imp.id(5820532485534723)
,p_display_seq=>14
,p_column_id=>wwv_flow_imp.id(5814117196534503)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5828065522534749)
,p_view_id=>wwv_flow_imp.id(5820532485534723)
,p_display_seq=>15
,p_column_id=>wwv_flow_imp.id(5814269683534504)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5828589724534751)
,p_view_id=>wwv_flow_imp.id(5820532485534723)
,p_display_seq=>16
,p_column_id=>wwv_flow_imp.id(5814321181534505)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5829066277534752)
,p_view_id=>wwv_flow_imp.id(5820532485534723)
,p_display_seq=>17
,p_column_id=>wwv_flow_imp.id(5814496797534506)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5829564358534753)
,p_view_id=>wwv_flow_imp.id(5820532485534723)
,p_display_seq=>18
,p_column_id=>wwv_flow_imp.id(5814536296534507)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5830011666534754)
,p_view_id=>wwv_flow_imp.id(5820532485534723)
,p_display_seq=>19
,p_column_id=>wwv_flow_imp.id(5814671610534508)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5830570416534755)
,p_view_id=>wwv_flow_imp.id(5820532485534723)
,p_display_seq=>20
,p_column_id=>wwv_flow_imp.id(5814715906534509)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5831003167534757)
,p_view_id=>wwv_flow_imp.id(5820532485534723)
,p_display_seq=>21
,p_column_id=>wwv_flow_imp.id(5814822881534510)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5831556729534758)
,p_view_id=>wwv_flow_imp.id(5820532485534723)
,p_display_seq=>22
,p_column_id=>wwv_flow_imp.id(5814986034534511)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5832042717534759)
,p_view_id=>wwv_flow_imp.id(5820532485534723)
,p_display_seq=>23
,p_column_id=>wwv_flow_imp.id(5815062608534512)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5832582133534760)
,p_view_id=>wwv_flow_imp.id(5820532485534723)
,p_display_seq=>24
,p_column_id=>wwv_flow_imp.id(5815166754534513)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5833016220534762)
,p_view_id=>wwv_flow_imp.id(5820532485534723)
,p_display_seq=>25
,p_column_id=>wwv_flow_imp.id(5815218564534514)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5833555438534763)
,p_view_id=>wwv_flow_imp.id(5820532485534723)
,p_display_seq=>26
,p_column_id=>wwv_flow_imp.id(5815373703534515)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5834056565534764)
,p_view_id=>wwv_flow_imp.id(5820532485534723)
,p_display_seq=>27
,p_column_id=>wwv_flow_imp.id(5815411031534516)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5834584687534765)
,p_view_id=>wwv_flow_imp.id(5820532485534723)
,p_display_seq=>28
,p_column_id=>wwv_flow_imp.id(5815558620534517)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5835055262534767)
,p_view_id=>wwv_flow_imp.id(5820532485534723)
,p_display_seq=>28
,p_column_id=>wwv_flow_imp.id(5815678589534518)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5835500083534768)
,p_view_id=>wwv_flow_imp.id(5820532485534723)
,p_display_seq=>30
,p_column_id=>wwv_flow_imp.id(5815712882534519)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5836008821534769)
,p_view_id=>wwv_flow_imp.id(5820532485534723)
,p_display_seq=>31
,p_column_id=>wwv_flow_imp.id(5815818983534520)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5836576990534771)
,p_view_id=>wwv_flow_imp.id(5820532485534723)
,p_display_seq=>32
,p_column_id=>wwv_flow_imp.id(5815959127534521)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5837022622534772)
,p_view_id=>wwv_flow_imp.id(5820532485534723)
,p_display_seq=>33
,p_column_id=>wwv_flow_imp.id(5816055949534522)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5837512107534773)
,p_view_id=>wwv_flow_imp.id(5820532485534723)
,p_display_seq=>34
,p_column_id=>wwv_flow_imp.id(5816113084534523)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5838078914534774)
,p_view_id=>wwv_flow_imp.id(5820532485534723)
,p_display_seq=>35
,p_column_id=>wwv_flow_imp.id(5816229551534524)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5838581982534776)
,p_view_id=>wwv_flow_imp.id(5820532485534723)
,p_display_seq=>36
,p_column_id=>wwv_flow_imp.id(5816379685534525)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5839018672534777)
,p_view_id=>wwv_flow_imp.id(5820532485534723)
,p_display_seq=>37
,p_column_id=>wwv_flow_imp.id(5816493910534526)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5839572534534778)
,p_view_id=>wwv_flow_imp.id(5820532485534723)
,p_display_seq=>38
,p_column_id=>wwv_flow_imp.id(5816505519534527)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5840047425534780)
,p_view_id=>wwv_flow_imp.id(5820532485534723)
,p_display_seq=>39
,p_column_id=>wwv_flow_imp.id(5816685002534528)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5902012058596752)
,p_view_id=>wwv_flow_imp.id(5820532485534723)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(5816725864534529)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>62.667
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5426552263545892)
,p_plug_name=>'Interval Builder'
,p_region_name=>'interval-builder'
,p_region_template_options=>'#DEFAULT#:js-dialog-size600x400'
,p_plug_template=>wwv_flow_imp.id(557449278618308550)
,p_plug_display_sequence=>120
,p_plug_header=>'<p>This dialog assists in building a simple <em>Scheduler Calendaring Expression</em> to specify how often the automation executes.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5702933124970087)
,p_plug_name=>'Server-Side Condition'
,p_region_name=>'COND'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_query_row_template=>wwv_flow_imp.id(60628322026519501)
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_plug_query_show_nulls_as=>'(null)'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(96107915683078518)
,p_plug_name=>'Source'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2903682401394629)
,p_plug_name=>'remote data source'
,p_parent_plug_id=>wwv_flow_imp.id(96107915683078518)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2064319266407611)
,p_plug_name=>'remote data source details'
,p_parent_plug_id=>wwv_flow_imp.id(2903682401394629)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2903704119394630)
,p_plug_name=>'REST data source'
,p_parent_plug_id=>wwv_flow_imp.id(96107915683078518)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2063557467407603)
,p_plug_name=>'REST Source Details'
,p_parent_plug_id=>wwv_flow_imp.id(2903704119394630)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2514185254671718)
,p_plug_name=>'Please save your Changes'
,p_parent_plug_id=>wwv_flow_imp.id(2063557467407603)
,p_region_template_options=>'#DEFAULT#:a-Alert--info:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>120
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'You need to save the changes before you can edit REST Data Source details.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6353168577393099)
,p_plug_name=>'REST Source Parameters'
,p_parent_plug_id=>wwv_flow_imp.id(2063557467407603)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>110
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select cp.id, ',
'       pa.name,',
'       pa.data_type,',
'       cp.value_type,',
'       cp.value_language,',
'       cp.value,',
'       cp.format_mask',
'  from wwv_flow_web_src_comp_params cp, wwv_flow_web_src_params pa',
' where pa.id                = cp.web_src_param_id',
'    -- ',
'   and cp.automation_id     = :P7021_ID',
'   and cp.security_group_id = :WORKSPACE_ID',
'   and cp.flow_id           = :FB_FLOW_ID',
'   and cp.security_group_id = pa.security_group_id'))
,p_plug_source_type=>'NATIVE_IG'
,p_ajax_items_to_submit=>'P7021_ID'
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_web_src_comp_params cp',
' where cp.automation_id = :P7021_ID'))
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Parameters'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1567495226713205)
,p_name=>'VALUE_LANGUAGE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'VALUE_LANGUAGE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>80
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2231769910790534)
,p_name=>'FORMAT_MASK'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FORMAT_MASK'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_POPUP_LOV'
,p_heading=>'Format Mask'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>70
,p_value_alignment=>'LEFT'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
,p_attribute_05=>'N'
,p_is_required=>false
,p_max_length=>255
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(32743907454195192)
,p_lov_display_extra=>true
,p_lov_display_null=>true
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>'Format mask to convert the <strong>Static</strong> or <strong>Item</strong> value to the data type of the REST Source Parameter.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2232792501790544)
,p_name=>'DATA_TYPE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DATA_TYPE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Parameter Data Type'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>50
,p_value_alignment=>'LEFT'
,p_is_required=>false
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(2225637019805602)
,p_lov_display_extra=>true
,p_lov_display_null=>true
,p_enable_filter=>false
,p_static_id=>'COLUMN_ITEM_FOR_DATA_TYPE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_include_in_export=>true
,p_readonly_condition_type=>'ALWAYS'
,p_readonly_for_each_row=>false
,p_help_text=>'Data Type of the REST Source Parameter.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6354110652393108)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>30
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6354167888393109)
,p_name=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'REST Source Parameter Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>40
,p_value_alignment=>'LEFT'
,p_attribute_02=>'VALUE'
,p_attribute_05=>'PLAIN'
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>true
,p_enable_sort_group=>true
,p_enable_control_break=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_include_in_export=>true
,p_help_text=>'Identifies the <em>Name</em> of the REST Data Source Parameter.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6354256819393110)
,p_name=>'VALUE_TYPE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'VALUE_TYPE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Value Type'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>60
,p_value_alignment=>'LEFT'
,p_is_required=>true
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(358243382603181986)
,p_lov_display_extra=>false
,p_lov_display_null=>false
,p_enable_filter=>false
,p_filter_is_required=>false
,p_static_id=>'COLUMN_ITEM_FOR_VALUE_TYPE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select how this parameter is populated.</p><p>Available options include:</p>',
'<ul>',
'    <li><strong>Static Value</strong>: Set to the text entered into <em>Static Value</em>.</li>',
'    <li><strong>Item</strong>: Set to the value held in session state for the <em>Item</em> specified.</li>',
'    <li><strong>SQL Query (return single value)</strong>: Set to the first value returned from the <em>SQL Query</em> entered.</li>',
'    <li><strong>PL/SQL Expression</strong>: Set to the value that results from executing the <em>PL/SQL Expression</em> entered.</li>',
'    <li><strong>PL/SQL Function Body</strong>: Set to the value returned from the <em>PL/SQL Function Body</em> entered.</li>',
'    <li><strong>Collection (CLOB)</strong>: Set to the CLOB column value of the first row from the <em>Collection</em> entered.</li>',
'    <li><strong>Null</strong>: Set to null as no value specified.</li>',
'</ul>',
''))
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6354377376393111)
,p_name=>'VALUE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'VALUE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Expression'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>90
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
,p_help_text=>'Provide the expression here, based on the <strong>Value Type </strong> column.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6354449471393112)
,p_name=>'APEX$ROW_ACTION'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>20
,p_use_as_row_header=>false
,p_display_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(6354580143393113)
,p_name=>'APEX$ROW_SELECTOR'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_use_as_row_header=>false
,p_display_condition_type=>'NEVER'
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(6354024916393107)
,p_internal_uid=>6354024916393107
,p_is_editable=>true
,p_edit_operations=>'u'
,p_lost_update_check_type=>'VALUES'
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>false
,p_no_data_found_message=>'No Parameters defined.'
,p_show_toolbar=>false
,p_toolbar_buttons=>null
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>false
,p_define_chart_view=>false
,p_enable_download=>false
,p_download_formats=>null
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(7554042244441408)
,p_interactive_grid_id=>wwv_flow_imp.id(6354024916393107)
,p_static_id=>'14394'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(7554222749441410)
,p_report_id=>wwv_flow_imp.id(7554042244441408)
,p_view_type=>'GRID'
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1470794287350096)
,p_view_id=>wwv_flow_imp.id(7554222749441410)
,p_display_seq=>7
,p_column_id=>wwv_flow_imp.id(2231769910790534)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1479273823300068)
,p_view_id=>wwv_flow_imp.id(7554222749441410)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(2232792501790544)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1593577388001779)
,p_view_id=>wwv_flow_imp.id(7554222749441410)
,p_display_seq=>6
,p_column_id=>wwv_flow_imp.id(1567495226713205)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(7554723289441432)
,p_view_id=>wwv_flow_imp.id(7554222749441410)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(6354110652393108)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(7555136276441450)
,p_view_id=>wwv_flow_imp.id(7554222749441410)
,p_display_seq=>2
,p_column_id=>wwv_flow_imp.id(6354167888393109)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(7555642275441454)
,p_view_id=>wwv_flow_imp.id(7554222749441410)
,p_display_seq=>4
,p_column_id=>wwv_flow_imp.id(6354256819393110)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(7556142487441456)
,p_view_id=>wwv_flow_imp.id(7554222749441410)
,p_display_seq=>5
,p_column_id=>wwv_flow_imp.id(6354377376393111)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(7557538213448630)
,p_view_id=>wwv_flow_imp.id(7554222749441410)
,p_display_seq=>0
,p_column_id=>wwv_flow_imp.id(6354449471393112)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4995340600973144)
,p_plug_name=>'local data source'
,p_parent_plug_id=>wwv_flow_imp.id(96107915683078518)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(110966821857654340)
,p_plug_name=>'Property Graph is not supported'
,p_region_template_options=>'#DEFAULT#:a-Alert--warning:a-Alert--horizontal'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>10
,p_location=>null
,p_plug_source=>'This Automation is based on a Property Graph, which requires Oracle Database 23ai or later. Thus, this page is read only.'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>':P7021_LOCAL_DATA_SOURCE_TYPE = ''GRAPH'' and sys.dbms_db_version.version <  23'
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(5817521371534537)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(4803890382119538)
,p_button_name=>'ADD_ACTION'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Add Action'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:7022:&SESSION.::&DEBUG.:7022:P7022_AUTOMATION_ID:&P7021_ID.'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    :P7021_ID is not null',
'and ( nvl( :P7021_LOCAL_DATA_SOURCE_TYPE,''X'') != ''GRAPH'' or sys.dbms_db_version.version >= 23 )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2022286112169334)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(5426552263545892)
,p_button_name=>'BUILD_INTERVAL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Set Execution Interval'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2529714709513169)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(2901312169394606)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:7020:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2530582957513170)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(2901312169394606)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.confirm(htmldb_delete_message,''DELETE'');'
,p_button_execute_validations=>'N'
,p_button_condition=>':P7021_ID is not null and :P7021_IS_RUNNING = ''N'''
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2530968069513170)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(2901312169394606)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save Changes'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    :P7021_ID is not null',
'and ( nvl( :P7021_LOCAL_DATA_SOURCE_TYPE, ''X'' ) != ''GRAPH'' or sys.dbms_db_version.version >= 23 )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2531343429513170)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(2901312169394606)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>'P7021_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2064814695407616)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(2901312169394606)
,p_button_name=>'PLAY'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Save and Run'
,p_button_position=>'NEXT'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    :P7021_ID is not null',
'and :P7021_IS_RUNNING = ''N''',
'and ( nvl( :P7021_LOCAL_DATA_SOURCE_TYPE,''X'') != ''GRAPH'' or sys.dbms_db_version.version >= 23 )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3160590621926705)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(2901312169394606)
,p_button_name=>'TERMINATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Terminate Execution'
,p_button_position=>'NEXT'
,p_confirm_message=>'Do you really want to terminate the currently running execution?'
,p_confirm_style=>'danger'
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    :P7021_ID is not null',
'and :P7021_IS_RUNNING = ''Y''',
'and ( nvl( :P7021_LOCAL_DATA_SOURCE_TYPE,''X'') != ''GRAPH'' or sys.dbms_db_version.version >= 23 )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_css_classes=>'a-Button--danger'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(5817141222534533)
,p_branch_name=>'Go to Page 7022'
,p_branch_action=>'f?p=&APP_ID.:7022:&SESSION.::&DEBUG.:7022:P7022_ID:&P7021_ACTION_ID.'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_EDIT_7021'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2065397326407621)
,p_branch_name=>'Go To Page 7021'
,p_branch_action=>'f?p=&APP_ID.:7021:&SESSION.::&DEBUG.::P7021_ID:&P7021_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'REQUEST_IN_CONDITION'
,p_branch_condition=>'PLAY:TERMINATE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1379229546188238)
,p_branch_name=>'Go To Page 7021'
,p_branch_action=>'f?p=&APP_ID.:7021:&SESSION.::&DEBUG.:7021:P7021_ID,P7021_RETURN_TO_PAGE:&P7021_ID.,&P7021_RETURN_TO_PAGE.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':REQUEST in (''CREATE'', ''SAVE'') and :P7021_RETURN_TO_PAGE = ''YES'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2531625419513170)
,p_branch_name=>'Go To Page 7020'
,p_branch_action=>'f?p=&APP_ID.:7020:&SESSION.::&DEBUG.:7021::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1377476877188220)
,p_name=>'P7021_TABLE_USELOCALSYNCTABLE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2063557467407603)
,p_item_source_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_source=>'USE_LOCAL_SYNC_TABLE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1561714301645591)
,p_name=>'P7021_CONDITION_LANG'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(5702933124970087)
,p_prompt=>'Language'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select a language that is used to evaluate the entered programming code.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1562580979647574)
,p_name=>'P7021_CONDITION_CHECK'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(5702933124970087)
,p_prompt=>'Do not validate code (parse code at runtime only).'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1567001921713201)
,p_name=>'P7021_FUNCTION_BODY_LANGUAGE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(4995340600973144)
,p_item_source_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_prompt=>'Language'
,p_source=>'FUNCTION_BODY_LANGUAGE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Select a language that is used to evaluate the entered programming code.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1567123283713202)
,p_name=>'P7021_REMOTE_FUNC_BODY_LANG'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(2064319266407611)
,p_prompt=>'Language'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1567229026713203)
,p_name=>'P7021_POST_PROC_FUNC_BODY_LANG'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(2063557467407603)
,p_prompt=>'Language'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1639624110313234)
,p_name=>'P7021_GRAPH_NAME'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(4995340600973144)
,p_prompt=>'Graph Name'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select g.graph_name d, ',
'       g.graph_name r',
'  from sys.dba_property_graphs        g,',
'       wwv_flow_object_owners_dev o',
' where o.owner = g.owner',
'   and g.owner = ( select coalesce( :P7021_TABLE_OWNER, upper(wwv_flow_wizard_api.get_flow_owner(:FB_FLOW_ID)))',
'                     from sys.dual )'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Value -'
,p_lov_cascade_parent_items=>'P7021_TABLE_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_tag_css_classes=>'is-query'
,p_display_when=>'sys.dbms_db_version.version >= 23'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Pick the Property Graph from the list.'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1639772482313235)
,p_name=>'P7021_PQL_MATCH_CLAUSE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(4995340600973144)
,p_item_source_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_prompt=>'Match Clause'
,p_source=>'QUERY_MATCH'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>3
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a path pattern to find on the property graph. In order to find all edges in your graph, use the following: <strong>(a) - [e] -> (b)</strong>. In addition to this, use <em>label constraints</em> to restrict the types of vertices or edges of i'
||'nterest.</p>',
'<p><strong>Examples</strong></p>',
'<dl>',
'<dt>Find all persons who bought cars.</dt><dd><pre>(p is person) - [t is buys] -> (c is car)</pre></dd>',
'<dt>Find all employees working in departments.</dt><dd><pre>(e is employees) - [is works_at] -> (d is departments)</pre></dd>',
'<dt>Find all employees working in departments who bought cars.</dt><dd><pre>(e is employees) - [is works_at] -> (d is departments), (e is employees) - [t is buys] -> (c is car)</pre></dd>',
'</dl>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1639845399313236)
,p_name=>'P7021_PQL_COLUMNS_CLAUSE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(4995340600973144)
,p_item_source_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_prompt=>'Columns Clause'
,p_source=>'QUERY_COLUMNS'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>3
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Define the query return columns. Those are properties of vertices or edges or expressions using them.</p>',
'<p><strong>Example</strong></p>',
'<dl>',
'<dt>Return <strong>NAME</strong>, <strong>BRAND</strong> and <strong>TOTAL_COST</strong> columns, the latter is the <strong>COST</strong> column, multiplied by 100.</dt>',
'<dd><pre>p.name, c.brand, t.cost * 100 as total_cost</pre></dd>',
'</dl>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1639912132313237)
,p_name=>'P7021_PQL_WHERE_CLAUSE'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(4995340600973144)
,p_prompt=>'Where Clause'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cHeight=>3
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter an optional WHERE clause to restrict the returned rows. Columns must use a vertex or edge alias.</p>',
'<p><strong>Example</strong></p>',
'<dl>',
'<dt>Only include those employees which have a manager or have a job of salesman.</dt>',
'<dd><pre>( e.mgr is not null or e.job = ''SALESMAN'' )</pre></dd>',
'</dl>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1721045657469943)
,p_name=>'P7021_WEB_SRC_ARRAY_COL_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(2903704119394630)
,p_item_source_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_prompt=>'Array Column'
,p_source=>'WEB_SRC_ARRAY_COL_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select dpc.display_name,',
'       dpc.id',
'  from wwv_flow_web_src_arr_cols_dev dpc',
' where dpc.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and dpc.flow_id           = :FB_FLOW_ID',
'   and dpc.web_src_module_id = :P7021_WEB_SRC_MODULE_ID   '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'None'
,p_lov_cascade_parent_items=>'P7021_WEB_SRC_MODULE_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Choose an <em>Array Column</em> from the <em>Data Profile</em> of the REST Data Source.',
'</p>',
''))
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1721650243469949)
,p_name=>'P7021_OLD_WEB_SRC_ARRAY_COL_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2903704119394630)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1805210902591820)
,p_name=>'P7021_REMOTE_INCLUDE_ROWID'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(2064319266407611)
,p_prompt=>'Include ROWID Column'
,p_display_as=>'NATIVE_YES_NO'
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify whether the pseudo column ROWID should be selected.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1805381557591821)
,p_name=>'P7021_POST_PROCESS_ORDERBY'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(2063557467407603)
,p_prompt=>'ORDER BY Clause'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>255
,p_cHeight=>2
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a valid SQL ORDER BY clause, used to sort the records retrieved.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1805468247591822)
,p_name=>'P7021_POST_PROCESS_WHERE'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(2063557467407603)
,p_prompt=>'WHERE Clause'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>2
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a valid SQL where condition, used to limit the records retrieved.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1805546008591823)
,p_name=>'P7021_POST_PROCESS_QUERY'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(2063557467407603)
,p_prompt=>'SQL Query'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>60
,p_cMaxlength=>32767
,p_cHeight=>6
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a SQL Query to transform the data retrieved from the REST Data Source. Select from the pseudo-table #APEX$SOURCE_DATA# and specify columns available in the data profile. Subquery factoring using the SQL WITH clause is not supported here.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1805670814591824)
,p_name=>'P7021_POST_PROC_FUNC_BODY'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(2063557467407603)
,p_prompt=>'Function Body returning SQL Query'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>60
,p_cMaxlength=>32767
,p_cHeight=>6
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a function body, where the SQL query returned transforms the data retrieved from the REST Source. The SQL query returned by the function body must select from the #APEX$SOURCE_DATA# pseudo-table and read columns available in the data profile. S'
||'ubquery factoring using the SQL WITH clause is not supported here.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PAGE_ITEM'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_06=>'P7021_POST_PROC_FUNC_BODY_LANG'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1807990044591847)
,p_name=>'P7021_OLD_LOCATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(96107915683078518)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1920697193175901)
,p_name=>'P7021_RETURN_TO_PAGE'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(4800456594119504)
,p_prompt=>'Stay on page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'a-Form-fieldContainer--autoLabelWidth'
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select this checkbox to stay on this page after applying changes.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'YES'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1935415110374325)
,p_name=>'P7021_MIN_CADENCE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2901534819394608)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2022634549169338)
,p_name=>'P7021_INT_INTERVAL'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(5426552263545892)
,p_item_default=>'1'
,p_prompt=>'Interval'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>4
,p_cMaxlength=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a positive integer representing how often the recurrence repeats. The default is 1, which means every minute for minutely, every day for daily, and so on. The maximum value is 999.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2023526259169347)
,p_name=>'P7021_INT_FREQUENCY'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(5426552263545892)
,p_item_default=>'DAILY'
,p_prompt=>'Frequency'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'SCHEDULE_BUILDER_FREQUENCY'
,p_lov=>'.'||wwv_flow_imp.id(601098854036755106)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the type of recurrence. The possible predefined frequency values are <strong>Weekly</strong>, <strong>Daily</strong>, <strong>Hourly</strong> and <strong>Minutely</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2024443788169347)
,p_name=>'P7021_BYDAY'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(5426552263545892)
,p_item_default=>'MON:TUE:WED:THU:FRI:SAT:SUN'
,p_prompt=>'Execution Day'
,p_display_as=>'NATIVE_CHECKBOX'
,p_named_lov=>'SCHEDULE_BUILDER_BYDAY'
,p_lov=>'.'||wwv_flow_imp.id(601095219556747684)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the day of the week, from Monday to Sunday, in the form MON, TUE, and so on.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'5'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2025340909169348)
,p_name=>'P7021_BYHOUR'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(5426552263545892)
,p_item_default=>'0'
,p_prompt=>'Execution Hour'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the hour on which the job is to run. Valid values are 0 to 23. As an example, 10 means 10 a.m.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2026284504169348)
,p_name=>'P7021_BYMINUTE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(5426552263545892)
,p_item_default=>'0'
,p_prompt=>'Execution Minute'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the minute on which the job is to run. Valid values are 0 to 59. As an example, 45 means 45 minutes past the chosen hour.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2063305422407601)
,p_name=>'P7021_REMOTE_WHERE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(2064319266407611)
,p_item_source_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_prompt=>'Where'
,p_source=>'QUERY_WHERE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>2
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_is_persistent=>'N'
,p_help_text=>'Enter a valid SQL where condition, used to limit the records retrieved.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2063401132407602)
,p_name=>'P7021_REMOTE_ORDER_BY'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(2064319266407611)
,p_item_source_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_prompt=>'Order By'
,p_source=>'QUERY_ORDER_BY'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>255
,p_cHeight=>2
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_is_persistent=>'N'
,p_help_text=>'Enter a valid SQL ORDER BY expression, used to sort the records retrieved.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2064555861407613)
,p_name=>'P7021_OLD_POLLING_STATUS'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2065645269407624)
,p_name=>'P7021_SOURCE_TYPE'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_item_default=>'QUERY'
,p_prompt=>'Actions Initiated On'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P7021_SOURCE_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(601093532765741216)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'apex- apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the data source type for this automation.',
'<ul>',
'    <li><strong>Query</strong>: A SQL Query will be executed. Automation actions can be executed when data is found (for each row), or when no data is found (once).</li>',
'    <li><strong>PL/SQL Returning Boolean</strong>: A PL/SQL function body is executed. If it returns <strong>true</strong>, then the automation actions are executed once.</li>',
'    <li><strong>Always</strong>: Automation actions are always executed. This option is suitable to be used with the <strong>Schedule</strong> type, to execute the actions based on a schedule, regardless of the presence of certain data.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2065864931407626)
,p_name=>'P7021_FUNC_BODY_BOOL_LOCATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2065703853407625)
,p_item_default=>'LOCAL'
,p_prompt=>'Location'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXEC_SQL_LOCATIONS'
,p_lov=>'.'||wwv_flow_imp.id(601110993871808630)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Select where the PL/SQL function returning boolean is to be executed.',
'</p>',
'<ul>',
'    <li><strong>Local Database</strong><br>',
'    Execute the PL/SQL function body in the local database.</li>',
'    <li><strong>REST Enabled SQL Service</strong><br>',
'    Execute the PL/SQL function body in a remote database, where the connection is defined using REST Enabled SQL. To create or maintain REST Enabled SQL references, navigate to Shared Components, REST Enabled SQL.',
'    </li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2065976767407627)
,p_name=>'P7021_LOCAL_FUNC_BODY_BOOLEAN'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2066950595407637)
,p_prompt=>'PL/SQL Function Body returning Boolean'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>60
,p_cHeight=>8
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Provide a PL/SQL Function body returning boolean which executes when the automation runs. If the function body returns <strong>true</strong>, the actions will be executed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PAGE_ITEM'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_06=>'P7021_LOCAL_FUNCBODYBOOL_LANG'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2066030221407628)
,p_name=>'P7021_REMOTE_PLSQL_BOOLEAN'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(2067168170407639)
,p_prompt=>'PL/SQL Function Body returning Boolean'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>60
,p_cHeight=>8
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Provide a PL/SQL Function body returning boolean which executes when the automation runs. If the function body returns <strong>true</strong>, the actions will be executed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PLSQL_FUNCTION_BODY'
,p_attribute_02=>'BOOLEAN'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_05=>'P7021_PLSQL_REMOTE_SERVER_ID'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2066153096407629)
,p_name=>'P7021_PLSQL_REMOTE_SERVER_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2067168170407639)
,p_prompt=>'REST Enabled SQL Service'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REMOTE_SQL_SERVERS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_remote_servers',
' where server_type = ''REMOTE_SQL''',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose a REST Enabled SQL Reference.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2320310780209549)
,p_name=>'P7021_LOCAL_FUNCBODYBOOL_LANG'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2066950595407637)
,p_prompt=>'Language'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select a language that is used to evaluate the entered programming code.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2500964129513156)
,p_name=>'P7021_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2901534819394608)
,p_item_source_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2501319977513158)
,p_name=>'P7021_FLOW_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2901534819394608)
,p_item_source_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_item_default=>'&FB_FLOW_ID.'
,p_source=>'FLOW_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2502179976513160)
,p_name=>'P7021_NAME'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(2901534819394608)
,p_item_source_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Name of this automation.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2502532715513160)
,p_name=>'P7021_STATIC_ID'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(2901534819394608)
,p_item_source_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_prompt=>'Static ID'
,p_source=>'STATIC_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Static ID for this automation. The static ID is used when manually executing the automation with the <strong>APEX_AUTOMATION</strong> package (<strong>APEX_AUTOMATION.EXECUTE</strong>).'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2503305198513160)
,p_name=>'P7021_TRIGGER_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_item_source_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_prompt=>'Type'
,p_source=>'TRIGGER_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'AUTOMATION_TRIGGER_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(1355426926728029)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Automations with a <strong>Schedule</strong> will be executed automatically based on the selected frequency. If <strong>On Demand</strong> is selected, the automation will only be executed when called explicitly using the APEX_AUTOMATION package.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2503723575513160)
,p_name=>'P7021_POLLING_INTERVAL'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_item_source_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_prompt=>'Schedule Expression'
,p_post_element_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<a href="#sync-details" id="P7021_EDIT_POLLING_INTERVAL" class="a-Button a-Button--noLabel a-Button--small a-Button--withIcon" title="Schedule Builder" tabindex="0"><span class="a-Icon icon-utilities-build-interval"></span><span class="u-VisuallyHidd'
||'en">Schedule Builder</span></a><a href="#sync-details" id="P7021_CLEAR_POLLING_INTERVAL" class="a-Button a-Button--noLabel a-Button--small a-Button--withIcon"  tabindex="0" title="Clear Schedule"><span class="a-Icon icon-remove"></span><span class="u'
||'-VisuallyHidden">Clear Schedule</span></a>',
''))
,p_source=>'POLLING_INTERVAL'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Use the <em>Database Scheduler calendaring syntax</em> to define repeating execution schedules, such as "every Tuesday and Friday at 4:00 p.m." or "the second Wednesday of every month". ',
'</p>',
'<p>',
'    The calendaring syntax can either be entered manually, or declaratively by using the <strong>Interval Builder</strong>, to build simple expressions. Click the <em>wrench icon</em> below the Schedule Expression text area, to open the Interval Buil'
||'der.',
'</p>',
'<p>',
'    To have more complex execution schedules, review details about the <strong>Scheduler Calendaring Syntax</strong> in the documentation of the <strong>DBMS_SCHEDULER</strong> PL/SQL package, and provide your expression manually.',
'</p>',
'<p>',
'    This &PRODUCT_NAME. instance is configured to require at least &P7021_MIN_CADENCE. minutes between two automation executions.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2504190914513160)
,p_name=>'P7021_POLL_LAST_RUN_TIMESTAMP'
,p_source_data_type=>'TIMESTAMP_TZ'
,p_is_query_only=>true
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(2901534819394608)
,p_item_source_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_prompt=>'Last Execution'
,p_format_mask=>'SINCE'
,p_source=>'POLLING_LAST_RUN_TIMESTAMP'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'P7021_POLL_LAST_RUN_TIMESTAMP'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Indicates when this automation was last executed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2504959513513161)
,p_name=>'P7021_POLL_NEXT_RUN_TIMESTAMP'
,p_source_data_type=>'TIMESTAMP_TZ'
,p_is_query_only=>true
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(2901534819394608)
,p_item_source_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_prompt=>'Next Execution Due'
,p_format_mask=>'SINCE'
,p_source=>'POLLING_NEXT_RUN_TIMESTAMP'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_display_when=>'P7021_POLL_NEXT_RUN_TIMESTAMP'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Indicates when the next scheduled execution <em>is due</em>. Note that automation executions are kicked off by a coordinator job, which runs in regular intervals. So the automation will actually execute up to a few minutes <em>after</em> the executio'
||'n due time.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2505746718513161)
,p_name=>'P7021_POLLING_STATUS'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_item_source_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_prompt=>'Schedule Status'
,p_source=>'POLLING_STATUS'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'AUTOMATION_POLLING_STATUS'
,p_lov=>'.'||wwv_flow_imp.id(1358229692738259)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Denotes the state of this automation schedule.',
'<ul>',
'    <li><strong>Active</strong>: the schedule is active and the automation will be executed based on the <strong>Schedule Expression</strong>.</li>',
'    <li><strong>Disabled</strong>: the schedule will not be executed. However, the automation can still be executed by calling the <strong>APEX_AUTOMATION</strong> PL/SQL package.</li>',
'    <li><strong>Error</strong>: the schedule is disabled because an error occurred during the last execution. However, the automation can still be executed by calling the <strong>APEX_AUTOMATION</strong> PL/SQL package.</li> ',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2506127162513161)
,p_name=>'P7021_RESULT_TYPE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2513514643671712)
,p_item_default=>'ROWS'
,p_prompt=>'Execute Actions When'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'AUTOMATION_RESULT_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(601105473256773090)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Specify whether the automation actions should be executed when the query <em>returns rows</em> or when the <em>query does not return rows</em>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2510517742513163)
,p_name=>'P7021_SOURCE_POST_PROCESSING'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(2063557467407603)
,p_item_source_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_item_default=>'NONE'
,p_prompt=>'Post Processing Type'
,p_source=>'SOURCE_POST_PROCESSING'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXEC_WEB_SOURCE_POST_PROCESSING'
,p_lov=>'.'||wwv_flow_imp.id(601113045750817318)||'.'
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select how to post process the retrieved REST source data in the local database.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2510932862513163)
,p_name=>'P7021_INCLUDE_ROWID_COLUMN'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(4995340600973144)
,p_item_source_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_prompt=>'Include ROWID Column'
,p_source=>'INCLUDE_ROWID_COLUMN'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Specify whether the pseudo column ROWID should be selected.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2512504424513163)
,p_name=>'P7021_PK_COLUMN_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2517114410671748)
,p_item_source_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_prompt=>'Primary Key Column'
,p_source=>'PK_COLUMN_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from table(wwv_flow_exec_dev.get_query_columns(',
'      p_location               => :P7021_LOCATION,',
'      p_query_type             => case :P7021_LOCATION ',
'                                      when ''LOCAL''  then :P7021_LOCAL_DATA_SOURCE_TYPE',
'                                      when ''REMOTE'' then :P7021_REMOTE_DATA_SOURCE_TYPE end,',
'      p_owner                  => case :P7021_LOCATION ',
'                                      when ''LOCAL''  then :P7021_TABLE_OWNER',
'                                      when ''REMOTE'' then :P7021_REMOTE_TABLE_OWNER end,',
'      p_table_name             => case :P7021_LOCATION ',
'                                      when ''LOCAL''  then :P7021_TABLE_NAME',
'                                      when ''REMOTE'' then :P7021_REMOTE_TABLE_NAME end,',
'      p_match_clause           => :P7021_PQL_MATCH_CLAUSE,',
'      p_columns_clause         => :P7021_PQL_COLUMNS_CLAUSE,',
'      p_sql_query              => case ',
'                                      when :P7021_LOCATION = ''LOCAL''      and :P7021_LOCAL_DATA_SOURCE_TYPE  = ''SQL'' then :P7021_SQL',
'                                      when :P7021_LOCATION = ''REMOTE''     and :P7021_REMOTE_DATA_SOURCE_TYPE = ''SQL'' then :P7021_REMOTE_SQL',
'                                      when :P7021_LOCATION = ''WEB_SOURCE'' and :P7021_SOURCE_POST_PROCESSING  = ''SQL'' then :P7021_POST_PROCESS_QUERY',
'                                  end,      ',
'      p_function_body          => case ',
'                                      when :P7021_LOCATION = ''LOCAL''      and :P7021_LOCAL_DATA_SOURCE_TYPE  = ''FUNC_BODY_RETURNING_SQL'' then :P7021_FUNCTION_BODY',
'                                      when :P7021_LOCATION = ''REMOTE''     and :P7021_REMOTE_DATA_SOURCE_TYPE = ''FUNC_BODY_RETURNING_SQL'' then :P7021_REMOTE_FUNC_BODY',
'                                      when :P7021_LOCATION = ''WEB_SOURCE'' and :P7021_SOURCE_POST_PROCESSING  = ''FUNC_BODY_RETURNING_SQL'' then :P7021_POST_PROC_FUNC_BODY',
'                                  end,      ',
'      p_function_body_language => case ',
'                                    when :P7021_LOCATION = ''LOCAL''      and :P7021_LOCAL_DATA_SOURCE_TYPE  = ''FUNC_BODY_RETURNING_SQL'' then :P7021_FUNCTION_BODY_LANGUAGE',
'                                    when :P7021_LOCATION = ''REMOTE''     and :P7021_REMOTE_DATA_SOURCE_TYPE = ''FUNC_BODY_RETURNING_SQL'' then :P7021_REMOTE_FUNC_BODY_LANG',
'                                    when :P7021_LOCATION = ''WEB_SOURCE'' and :P7021_SOURCE_POST_PROCESSING  = ''FUNC_BODY_RETURNING_SQL'' then :P7021_POST_PROC_FUNC_BODY_LANG',
'                                  end,      ',
'      p_web_src_module_id      => case when :P7021_LOCATION = ''WEB_SOURCE'' then :P7021_WEB_SRC_MODULE_ID end,',
'      p_remote_server_id       => case when :P7021_LOCATION = ''REMOTE''     then :P7021_REMOTE_SERVER_ID end,',
'      p_post_processing_type   => case when :P7021_LOCATION = ''WEB_SOURCE'' then ',
'                                      case when :P7021_SOURCE_POST_PROCESSING != ''NONE'' then :P7021_SOURCE_POST_PROCESSING end ',
'                                  end ))',
'union all',
'select ''ROWID (Varchar2)'' column_name_esc,',
'       ''ROWID''            column_name',
'  from sys.dual',
' where case :P7021_LOCATION',
'           when ''LOCAL''  then :P7021_INCLUDE_ROWID_COLUMN ',
'           when ''REMOTE'' then :P7021_REMOTE_INCLUDE_ROWID end = ''Y'' ',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_tag_css_classes=>'is-column'
,p_display_when=>'P7021_SOURCE_TYPE'
,p_display_when2=>'QUERY'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the <em>primary key</em> column within the query result. The value of this column will be added to the log messages, in order to allow correlating log messages to source rows.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2512935171513163)
,p_name=>'P7021_MAX_ROWS_TO_PROCESS'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(2517114410671748)
,p_item_source_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_prompt=>'Maximum Rows to Process'
,p_source=>'MAX_ROWS_TO_PROCESS'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>18
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'If <strong>Maximum Rows to Process</strong> is specified, automation execution will stop when that maximum is reached and the automation will be logged as <strong>Incomplete</strong>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2513319851513164)
,p_name=>'P7021_COMMIT_EACH_ROW'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(2517114410671748)
,p_item_source_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_item_default=>'N'
,p_prompt=>'Commit'
,p_source=>'COMMIT_EACH_ROW'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P7021_COMMIT_EACH_ROW'
,p_lov=>'.'||wwv_flow_imp.id(601100928341755832)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify whether to commit after the actions for each row have been executed or to commit just once after all rows have been processed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2513364469671710)
,p_name=>'P7021_TABLE_RESULT_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2513514643671712)
,p_item_source_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_source=>'RESULT_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2513732961513164)
,p_name=>'P7021_ERROR_HANDLING_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(2513640627671713)
,p_item_source_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_prompt=>'Action Error Handling'
,p_source=>'ERROR_HANDLING_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P7021_ERROR_HANDLING_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(601102221885756461)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select what should happen when the automation encounters and error:</p>',
'<ul>',
'    <li><strong>Ignore</strong>: Ignore error and continue processing automation</li>',
'    <li><strong>Terminate Automation</strong>: Terminate automation but leave it enabled</li>',
'    <li><strong>Disable Automation</strong>: Terminate automation and Disable it</li>',
'</ul>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2514111507513164)
,p_name=>'P7021_CODE_SNIPPET'
,p_source_data_type=>'CLOB'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(4803374779119533)
,p_item_source_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_prompt=>'Executable PL/SQL Code'
,p_source=>'CODE_SNIPPET'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>60
,p_cHeight=>8
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a PL/SQL anonymous block of code that contains procedures to be called for Initialization or Cleanup of the automation, or before action processing for each row.</p>',
'',
'<p>For performance reasons you can also store this code in a PL/SQL package in the database.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PLSQL_FUNCTIONS'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2514525609513164)
,p_name=>'P7021_INIT_PROC'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(4803374779119533)
,p_item_source_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_prompt=>'Initialization Procedure'
,p_source=>'INIT_PROC_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Provide the name of an <strong>Initialization Procedure</strong>, which is either defined as a PL/SQL object in the database schema, or in the above <strong>Executable Code</strong>. APEX will execute that procedure at the very beginning of an automa'
||'tion execution.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2514913691513164)
,p_name=>'P7021_BEFORE_PROCESSING_PROC'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(4803374779119533)
,p_item_source_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_prompt=>'Before Row Processing Procedure'
,p_source=>'BEFORE_PROCESSING_PROC_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Provide the name of a <strong>Before Row Processing Procedure</strong>, which is either defined as a PL/SQL object in the database schema, or in the above <strong>Executable Code</strong>. APEX will execute that procedure for each row, before it star'
||'ts executing the defined actions.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2515106339671728)
,p_name=>'P7021_OLD_WEB_SRC_MODULE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2903704119394630)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2515319851513164)
,p_name=>'P7021_TEARDOWN_PROC'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(4803374779119533)
,p_item_source_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_prompt=>'Cleanup Procedure'
,p_source=>'TEARDOWN_PROC_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Provide the name of a <strong>Cleanup Procedure</strong>, which is either defined as a PL/SQL object in the database schema, or in the above <strong>Executable Code</strong>. APEX will execute that procedure at the very end of the automation executio'
||'n.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2516992345513165)
,p_name=>'P7021_BUILD_OPTION_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(4800138856119501)
,p_item_source_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_prompt=>'Build Option'
,p_source=>'BUILD_OPTION_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PATCHES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(patch_name) pn, id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'', wwv_flow_escape.html(patch_name))||',
'''} '' pn,0-id id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by pn'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Build Option -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select a build option for this automation.</p>',
'<p>Build options are predefined settings that determine whether or not components within an application are enabled.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2517392135671750)
,p_name=>'P7021_USE_LOCAL_SYNC_TABLE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2063557467407603)
,p_prompt=>'Use Synchronization Table'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_web_src_sync.sync_exists_for_array_column(',
'    p_web_source_module_id => :P7021_WEB_SRC_MODULE_ID,',
'    p_array_column_id      => :P7021_WEB_SRC_ARRAY_COL_ID ) = ''Y''',
''))
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enable this to use the local table, which is configured within the REST Synchronization section of the <strong>REST Data Source</strong>, instead of reaching out to the external REST service.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2903863001394631)
,p_name=>'P7021_REMOTE_DATA_SOURCE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2064319266407611)
,p_item_default=>'TABLE'
,p_prompt=>'Source Type'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXEC_REMOTE_SQL_DATA_SOURCE_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(1766286067212864)||'.'
,p_tag_css_classes=>'apex-button-group is-query'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the source type of the automation. Automations can be based on tables, SQL queries or PL/SQL functions returning a SQL query. '
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2904340376394636)
,p_name=>'P7021_FUNCTION_BODY'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(4995340600973144)
,p_prompt=>'Enter a Function Body returning a SQL Query'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>60
,p_cMaxlength=>32767
,p_cHeight=>8
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify a function body returning a SQL query that will that will be the source of the data evaluated during the execution of the automation, for example:',
'<pre>',
'return q''~',
'select ename, empno',
'  from emp',
'~'';',
'</pre>',
'Column values can be used within automation actions with bind variable syntax (for example, <strong>:EMPNO</strong>). '))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PAGE_ITEM'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_06=>'P7021_FUNCTION_BODY_LANGUAGE'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3160192679926701)
,p_name=>'P7021_IS_RUNNING'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(2901534819394608)
,p_prompt=>'Currently Executing'
,p_display_as=>'NATIVE_YES_NO'
,p_read_only_when_type=>'ALWAYS'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Indicates whether this automation is currently executing.'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
,p_attribute_03=>'Yes'
,p_attribute_04=>'N'
,p_attribute_05=>'No'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3218301351025544)
,p_name=>'P7021_LOCATION'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(96107915683078518)
,p_item_source_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_item_default=>'LOCAL'
,p_prompt=>'Data Source'
,p_source=>'LOCATION'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXEC_LOCATION'
,p_lov=>'.'||wwv_flow_imp.id(3842073961668883)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'apex-button-group is-query'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Select the <em>Data Source</em> for this automation.',
'</p>',
'<ul>',
'    <li><strong>Local Database</strong><br>',
'    Data is sourced from the local database.</li>',
'    <li><strong>REST Enabled SQL Service</strong><br>',
'    Data is sourced from a remote database, where the connection is defined using REST Enabled SQL. To create or maintain REST Enabled SQL references, navigate to Shared Components, REST Enabled SQL.',
'    </li>',
'    <li><strong>REST Data Source</strong><br>',
'    Data is sourced from a RESTful web service defined using REST Data Sources. To create or maintain REST Data Sources, navigate to Shared Components, REST Data Sources.',
'    </li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3221292817025548)
,p_name=>'P7021_LOCAL_DATA_SOURCE_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(4995340600973144)
,p_item_source_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_item_default=>'TABLE'
,p_prompt=>'Source Type'
,p_source=>'QUERY_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXEC_SQL_DATA_SOURCE_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(601107956819795211)||'.'
,p_tag_css_classes=>'apex-button-group is-query'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the source of the data evaluated during the execution of the automation. ',
'Automations can be based on tables, SQL queries, PL/SQL functions returning a SQL query, or (on Oracle Database 23ai and later) Property Graphs.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3222573974025549)
,p_name=>'P7021_TABLE_OWNER'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(4995340600973144)
,p_item_source_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_prompt=>'Owner'
,p_source=>'QUERY_OWNER'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_SCHEMAS_HAVE_PRIVS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(owner) d, owner v',
'  from wwv_flow_object_owners_dev',
'order by d                   '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Parsing Schema'
,p_lov_cascade_parent_items=>'P7021_LOCAL_DATA_SOURCE_TYPE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the owner of the table on which you are basing this automation.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3223498365025549)
,p_name=>'P7021_TABLE_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(4995340600973144)
,p_item_source_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_prompt=>'Table or View Name'
,p_source=>'QUERY_TABLE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'P7021_TABLE_VIEWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = coalesce( :P7021_TABLE_OWNER, wwv_flow_security.flow_owner( p_flow_id => :FB_FLOW_ID, p_security_group_id => :WORKSPACE_ID ) )',
''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Value -'
,p_lov_cascade_parent_items=>'P7021_TABLE_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_cMaxlength=>128
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the table or view on which the automation will be based.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3224760802025550)
,p_name=>'P7021_SQL'
,p_source_data_type=>'CLOB'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(4995340600973144)
,p_item_source_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_prompt=>'Enter a SQL SELECT statement'
,p_source=>'QUERY_SOURCE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>60
,p_cMaxlength=>32767
,p_cHeight=>8
,p_tag_css_classes=>'a-Form-textarea--code is-query'
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the SQL query that will be the source of the data evaluated during the execution of the automation, for example: ',
'<pre>',
'select empno, ename, job, sal',
'from  emp',
'</pre>',
'Column values can be used within automation actions with bind variable syntax (for example, <strong>:EMPNO</strong>). ',
'In addition to data from your query, you can use <strong>APEX_AUTOMATION.GET_LAST_RUN</strong> to reference the timestamp of the previous run of this automation. This is useful to prevent processing data twice.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3240000858025566)
,p_name=>'P7021_WEB_SRC_MODULE_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2903704119394630)
,p_item_source_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_prompt=>'REST Data Source'
,p_source=>'WEB_SRC_MODULE_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APP_WEB_SOURCES_FOR_REPORTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_flow_web_src_modules m',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and exists ( select 1 ',
'                  from wwv_flow_web_src_operations',
'                 where web_src_module_id = m.id',
'                   and database_operation = ''FETCH_COLLECTION'' )',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Choose a REST Data Source. Actions will be executed based on the result of the <em>Fetch Rows</em> Database Action of this REST source.',
'</p>',
''))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3242897007025568)
,p_name=>'P7021_REMOTE_SERVER_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2903682401394629)
,p_item_source_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_prompt=>'REST Enabled SQL Service'
,p_source=>'REMOTE_SERVER_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REMOTE_SQL_SERVERS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_remote_servers',
' where server_type = ''REMOTE_SQL''',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Pick a the REST Enabled SQL service to execute the query on. Automation Actions will be executed based on the results of this query.',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4501791612659931)
,p_name=>'P7021_REMOTE_SQL'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(2064319266407611)
,p_prompt=>'Enter a SQL SELECT statement'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>60
,p_cMaxlength=>32767
,p_cHeight=>8
,p_tag_css_classes=>'a-Form-textarea--code is-query'
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the SQL query that will be the source of the data evaluated during the execution of the automation, for example:',
'<pre>',
'select empno, ename, job, sal',
'from  emp',
'</pre>',
'Column values can be used within automation actions with bind variable syntax (for example, <strong>:EMPNO</strong>).'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'P7021_REMOTE_SERVER_ID'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4502664655659932)
,p_name=>'P7021_REMOTE_TABLE_OWNER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2064319266407611)
,p_prompt=>'Table / View Owner'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value d, column_value r',
'  from table( wwv_flow_remote_server_dev.get_available_objects( :P7021_REMOTE_SERVER_ID, ''SCHEMAS''))',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Current Schema'
,p_lov_cascade_parent_items=>'P7021_REMOTE_SERVER_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the owner of the table on which you are basing this automation.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4503534755659932)
,p_name=>'P7021_REMOTE_TABLE_NAME'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(2064319266407611)
,p_prompt=>'Table / View Name'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value d, column_value r',
'  from table( wwv_flow_remote_server_dev.get_available_objects( :P7021_REMOTE_SERVER_ID, ''TABLE'', :P7021_REMOTE_TABLE_OWNER,p_filter=>:p$_search_string ))',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table or View -'
,p_lov_cascade_parent_items=>'P7021_REMOTE_TABLE_OWNER'
,p_ajax_items_to_submit=>'P7021_REMOTE_SERVER_ID'
,p_ajax_optimize_refresh=>'N'
,p_cSize=>30
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the table or view on which the automation will be based.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4801309424119513)
,p_name=>'P7021_AUTOMATION_COMMENT'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(4800138856119501)
,p_item_source_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_prompt=>'Comments'
,p_source=>'AUTOMATION_COMMENT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>6
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter any developer comments or notes here. These comments only display within App Builder and never display when running the application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4803162714119531)
,p_name=>'P7021_QUERY_WHERE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(4995340600973144)
,p_item_source_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_prompt=>'Where Clause'
,p_source=>'QUERY_WHERE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>2
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_is_persistent=>'N'
,p_help_text=>'Enter a valid SQL where condition, used to limit the records retrieved.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4803209177119532)
,p_name=>'P7021_QUERY_ORDER_BY'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(4995340600973144)
,p_item_source_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_prompt=>'Order By Clause'
,p_source=>'QUERY_ORDER_BY'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>255
,p_cHeight=>2
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_is_persistent=>'N'
,p_help_text=>'Enter a valid SQL ORDER BY expression, used to sort the records retrieved.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4803499169119534)
,p_name=>'P7021_EXTERNAL_FILTER_EXPR'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2063557467407603)
,p_item_source_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_prompt=>'External Filter'
,p_source=>'EXTERNAL_FILTER_EXPR'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Provide an order by expression to be passed to the external REST service. The expression will be passed to the remote server as-is. The syntax depends on the type of the REST Data Source. For instance, Oracle REST Data Services (ORDS) expects JSON'
||' syntax.</p>',
'',
'<strong>Examples</strong><br/>',
'<p>For an ORDS REST Service, order by the "job" attribute ascending, then by "ename", descending.</p>',
'<pre>{"job": "asc", "ename": "desc"}</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4803531735119535)
,p_name=>'P7021_EXTERNAL_ORDER_BY'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(2063557467407603)
,p_item_source_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_prompt=>'External Order By'
,p_source=>'EXTERNAL_ORDER_BY_EXPR'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Provide an order by expression to be passed to the external REST service. The expression will be passed to the remote server as-is. The syntax depends on the type of the REST Data Source. For instance, Oracle REST Data Services (ORDS) expects JSON'
||' syntax.</p>',
'',
'<strong>Examples</strong><br />',
'<p>For an ORDS REST Service, order by the "job" attribute ascending, then by "ename", descending.</p>',
'<pre>{"job": "asc", "ename": "desc"}</pre>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4803650621119536)
,p_name=>'P7021_OPTIMIZER_HINT'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(4995340600973144)
,p_item_source_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_prompt=>'Optimizer Hint'
,p_source=>'OPTIMIZER_HINT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the Oracle Optimizer hint which is added to the top-level statement when executing the SQL query.',
'        A hint is an instruction to the Optimizer. When writing SQL, you may know information about the data unknown to the Optimizer. Hints enable you to make decisions normally made by the Optimizer,',
'        sometimes causing the Optimizer to select a plan that it sees as higher cost.</p>',
'        <p>For example, you might know that a certain index is more selective for certain queries. Based on this information, you might be able to choose a more efficient execution plan than the Optimizer.',
'        In such a case, use hints to force the Optimizer to use the optimal execution plan.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4904612338945005)
,p_name=>'P7021_REMOTE_FUNC_BODY'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(2064319266407611)
,p_prompt=>'Enter a Function Body returning a SQL Query'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>60
,p_cMaxlength=>32767
,p_cHeight=>8
,p_tag_css_classes=>'is-query'
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Specify the function body returning a SQL query that will be source of the data evaluated during the execution of the automation, for example:',
'</p>',
'<pre>',
'return q''~',
'select ename, empno',
'  from emp',
'~'';',
'</pre>',
'<p>',
'Column values can be used within automation actions with bind variable syntax (for example, <strong>:EMPNO</strong>). ',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'PAGE_ITEM'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_05=>'P7021_REMOTE_SERVER_ID'
,p_attribute_06=>'P7021_REMOTE_FUNC_BODY_LANG'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5703206634023402)
,p_name=>'P7021_CONDITION_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(5702933124970087)
,p_item_source_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_prompt=>'Condition Type'
,p_source=>'CONDITION_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CONDITION_LIST'
,p_named_lov=>'STANDARD_CONDITION_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(13602414170805697)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Condition Type -'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'Select a condition type from the list that must be met in order for this automation to be executed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'P7021_CONDITION_EXPR1'
,p_attribute_02=>'P7021_CONDITION_EXPR2'
,p_attribute_04=>'P7021_CONDITION_CHECK'
,p_attribute_06=>'AUTOM'
,p_attribute_07=>'P7021_CONDITION_LANG'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5704110366023405)
,p_name=>'P7021_CONDITION_EXPR1'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(5702933124970087)
,p_item_source_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_prompt=>'Expression 1'
,p_source=>'CONDITION_EXPR1'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'This attribute allows you to conditionally control the circumstances under which this automation will be executed.  Enter values in this attribute based on the specific condition type selected.  The automation will execute only if the specified condi'
||'tion is met.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5705092234023406)
,p_name=>'P7021_CONDITION_EXPR2'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(5702933124970087)
,p_item_source_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_prompt=>'Expression 2'
,p_source=>'CONDITION_EXPR2'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Some condition types require two expressions for comparison.  Enter the second expression or item here.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(5817324123534535)
,p_name=>'P7021_ACTION_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(4803890382119538)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(141809210566435713)
,p_name=>'P7021_OLD_POLLING_INTERVAL'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(2500558986513154)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2065002605407618)
,p_computation_sequence=>10
,p_computation_item=>'P7021_POLLING_STATUS'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'DISABLED'
,p_compute_when=>'P7021_TRIGGER_TYPE'
,p_compute_when_text=>'API'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1808074633591848)
,p_computation_sequence=>10
,p_computation_item=>'P7021_OLD_LOCATION'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P7021_LOCATION'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2064654390407614)
,p_computation_sequence=>30
,p_computation_item=>'P7021_OLD_POLLING_STATUS'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P7021_POLLING_STATUS'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(141809352383435714)
,p_computation_sequence=>40
,p_computation_item=>'P7021_OLD_POLLING_INTERVAL'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P7021_POLLING_INTERVAL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2515207817671729)
,p_computation_sequence=>50
,p_computation_item=>'P7021_OLD_WEB_SRC_MODULE_ID'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P7021_WEB_SRC_MODULE_ID'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2513232130671709)
,p_computation_sequence=>70
,p_computation_item=>'P7021_SOURCE_TYPE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case :P7021_TABLE_RESULT_TYPE',
'    when ''ROWS'' then ''QUERY''',
'    when ''NO_ROWS'' then ''QUERY''',
'    when ''FUNC_BODY_RETURNING_BOOLEAN'' then ''FUNC_BODY_RETURNING_BOOLEAN''',
'    when ''ALWAYS'' then ''ALWAYS'' end'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2513443220671711)
,p_computation_sequence=>80
,p_computation_item=>'P7021_RESULT_TYPE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'case when :P7021_TABLE_RESULT_TYPE in ( ''ROWS'', ''NO_ROWS'' ) then :P7021_TABLE_RESULT_TYPE end'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1377585382188221)
,p_computation_sequence=>90
,p_computation_item=>'P7021_USE_LOCAL_SYNC_TABLE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P7021_TABLE_USELOCALSYNCTABLE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1935527246374326)
,p_computation_sequence=>100
,p_computation_item=>'P7021_MIN_CADENCE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'nvl(wwv_flow_platform.get_preference(''BACKGROUND_MIN_EXECUTION_CADENCE''),0)'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3160230099926702)
,p_computation_sequence=>110
,p_computation_item=>'P7021_IS_RUNNING'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case when wwv_flow_automation_api.is_running(',
'              p_application_id => :FB_FLOW_ID,',
'              p_static_id      => :P7021_STATIC_ID ) then ''Y'' else ''N'' end'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1721708848469950)
,p_computation_sequence=>120
,p_computation_item=>'P7021_OLD_WEB_SRC_ARRAY_COL_ID'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P7021_WEB_SRC_ARRAY_COL_ID'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(987817015076252918)
,p_validation_name=>'Local Automation PL/SQL is not null'
,p_validation_sequence=>20
,p_validation=>'P7021_LOCAL_FUNC_BODY_BOOLEAN'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST           in ( ''SAVE'', ''CREATE'', ''PLAY'' )  and ',
':P7021_LOCATION    =  ''LOCAL''                       and ',
':P7021_SOURCE_TYPE =  ''FUNC_BODY_RETURNING_BOOLEAN'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(2065976767407627)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(987817160796252919)
,p_validation_name=>'Remote Automation PL/SQL is not null'
,p_validation_sequence=>30
,p_validation=>'P7021_REMOTE_PLSQL_BOOLEAN'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST           in ( ''SAVE'', ''CREATE'', ''PLAY'' ) and',
':P7021_LOCATION    =  ''REMOTE''                     and ',
':P7021_SOURCE_TYPE =  ''FUNC_BODY_RETURNING_BOOLEAN'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(2066030221407628)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(987817445072252922)
,p_validation_name=>'Remote Automation PL/SQL Remote Server is not null'
,p_validation_sequence=>40
,p_validation=>'P7021_PLSQL_REMOTE_SERVER_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST            in ( ''SAVE'', ''CREATE'', ''PLAY'' ) and ',
':P7021_LOCATION     =  ''REMOTE''                     and ',
':P7021_SOURCE_TYPE  =  ''FUNC_BODY_RETURNING_BOOLEAN'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(2066153096407629)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(987816905081252917)
,p_validation_name=>'Automation PL/SQL'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_location        wwv_flow_exec_api.t_location;',
'    l_error           varchar2(32767);',
'begin',
'    l_location   := case :P7021_LOCATION',
'                        when ''LOCAL''                   then wwv_flow_exec_api.c_location_local_db',
'                        when ''REMOTE''                  then wwv_flow_exec_api.c_location_remote_db end;',
'',
'    l_error := wwv_flow_exec_dev.check_code (',
'                   p_code                   => :P7021_SQL,',
'                   p_location               => l_location,',
'                   p_language               => wwv_flow_code_exec.c_plsql,',
'                   p_return_data_type       => wwv_flow_code_exec_dev.c_return_data_type_boolean,',
'                   p_type                   => wwv_flow_code_exec_dev.c_check_func_body,',
'                   --',
'                   p_remote_server_id       => case when l_location = wwv_flow_exec_api.c_location_remote_db then :P7021_REMOTE_SERVER_ID end,',
'                   p_application_id         => :FB_FLOW_ID );',
'',
'    return l_error;   ',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST           in ( ''SAVE'', ''CREATE'', ''PLAY'' ) and ',
':P7021_SOURCE_TYPE =  ''FUNC_BODY_RETURNING_BOOLEAN'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1684279945640309)
,p_tabular_form_region_id=>wwv_flow_imp.id(6353168577393099)
,p_validation_name=>'Web Source Parameters: Value NOT NULL'
,p_validation_sequence=>80
,p_validation=>'VALUE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#COLUMN_HEADER# must have a value.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST        in ( ''SAVE'', ''CREATE'', ''PLAY'' ) and ',
':VALUE_TYPE     != ''NULL''                       and',
':P7021_LOCATION = ''WEB_SOURCE'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_exec_cond_for_each_row=>'Y'
,p_associated_column=>'VALUE'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(987816604192252914)
,p_validation_name=>'Automation Query'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- validate_query also validates that required items actually contain',
'-- a value (e.g. Table Name for Query Type = TABLE)',
'return wwv_flow_exec_dev.validate_query(',
'           p_location               => :P7021_LOCATION,',
'           p_remote_server_id       => :P7021_REMOTE_SERVER_ID,',
'           p_web_src_module_id      => :P7021_WEB_SRC_MODULE_ID,',
'           --',
'           p_table_owner            => :P7021_TABLE_OWNER,',
'           p_table_name             => case when :P7021_LOCAL_DATA_SOURCE_TYPE = ''GRAPH'' then :P7021_GRAPH_NAME else :P7021_TABLE_NAME end,',
'           p_where_clause           => :P7021_QUERY_WHERE,',
'           p_match_clause           => :P7021_PQL_MATCH_CLAUSE,',
'           p_columns_clause         => :P7021_PQL_COLUMNS_CLAUSE,',
'           p_order_by_clause        => :P7021_QUERY_ORDER_BY,',
'           p_sql_query              => :P7021_SQL,',
'           p_function_body_language => :P7021_FUNCTION_BODY_LANGUAGE,',
'           p_optimizer_hint         => :P7021_OPTIMIZER_HINT,',
'           --',
'           p_post_processing_type   => :P7021_SOURCE_POST_PROCESSING,',
'',
'           p_query_type             => case when :P7021_LOCATION = ''REMOTE'' then :P7021_REMOTE_DATA_SOURCE_TYPE else :P7021_LOCAL_DATA_SOURCE_TYPE end );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST           in ( ''SAVE'', ''CREATE'', ''PLAY'' ) and ',
':P7021_SOURCE_TYPE =  ''QUERY'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2052770649333327)
,p_tabular_form_region_id=>wwv_flow_imp.id(6353168577393099)
,p_validation_name=>'Web Source Parameters: Validate Code'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_web_src_dev.validate_web_src_param_value(',
'           p_application_id => :FB_FLOW_ID,',
'           p_data_type      => :DATA_TYPE,',
'           p_value_type     => :VALUE_TYPE,',
'           p_value_lang     => :VALUE_LANGUAGE,',
'           p_expression     => :VALUE );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST        in ( ''SAVE'', ''CREATE'', ''PLAY'' ) and',
':P7021_LOCATION =  ''WEB_SOURCE'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_exec_cond_for_each_row=>'Y'
,p_associated_column=>'VALUE'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2053157453333328)
,p_tabular_form_region_id=>wwv_flow_imp.id(6353168577393099)
,p_validation_name=>'Web Source Parameters: Validate NULL'
,p_validation_sequence=>100
,p_validation=>':VALUE is NULL'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'The NULL value type cannot have a value.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST        in ( ''SAVE'', ''CREATE'', ''PLAY'' ) and ',
':VALUE_TYPE     = ''NULL''                        and',
':P7021_LOCATION = ''WEB_SOURCE'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_exec_cond_for_each_row=>'Y'
,p_associated_column=>'VALUE'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1251855757222756050)
,p_validation_name=>'Polling Interval is not null'
,p_validation_sequence=>110
,p_validation=>'P7021_POLLING_INTERVAL'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST in ( ''SAVE'', ''CREATE'', ''PLAY'' ) and',
':P7021_TRIGGER_TYPE   =  ''POLLING'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(2503723575513160)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1251855577096756048)
,p_validation_name=>'Polling Interval is valid'
,p_validation_sequence=>120
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_cadence number;',
'begin',
'    l_cadence := wwv_flow_automation_dev.get_execution_cadence_minutes( ',
'                     p_calendaring_expression => :P7021_POLLING_INTERVAL );',
'    return true;',
'exception',
'    when others then',
'        return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Invalid Calendaring Expression.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST in ( ''SAVE'', ''CREATE'', ''PLAY'' ) and',
':P7021_TRIGGER_TYPE   =  ''POLLING'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(2503723575513160)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1402989705294846)
,p_validation_name=>'Minimum Execution Cadence met'
,p_validation_sequence=>130
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    return wwv_flow_automation_dev.get_execution_cadence_minutes( ',
'               p_calendaring_expression => :P7021_POLLING_INTERVAL ) >= to_number( :P7021_MIN_CADENCE );',
'exception',
'    when others then',
'        -- syntax errors in the calendaring expression are catched in the',
'        -- "Polling Interval is Valid" validation',
'        return true;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Automations cannot be executed more frequently than every &P7021_MIN_CADENCE!HTML. minutes.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST              in ( ''SAVE'', ''CREATE'', ''PLAY'' ) and ',
':P7021_POLLING_STATUS =  ''ACTIVE'' and ',
':P7021_TRIGGER_TYPE   =  ''POLLING'' and ',
'wwv_flow_platform.get_preference(''BACKGROUND_MIN_EXECUTION_CADENCE'') is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(2503723575513160)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4477107233299402)
,p_validation_name=>'Must have Actions to Activate'
,p_validation_sequence=>140
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_automation_actions',
' where security_group_id = :WORKSPACE_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and automation_id     = :P7021_ID'))
,p_validation_type=>'EXISTS'
,p_error_message=>'Automations without Actions cannot be enabled.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P7021_OLD_POLLING_STATUS != :P7021_POLLING_STATUS and ',
':P7021_POLLING_STATUS      = ''ACTIVE''              and ',
':REQUEST                  in (''PLAY'', ''CREATE'', ''SAVE'' )'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(987817511087252923)
,p_validation_name=>'Validate Code Snippets'
,p_validation_sequence=>150
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_code_exec_dev.check_code(',
'    p_type     => wwv_flow_code_exec_dev.c_check_procedures,',
'    p_code     => :P7021_CODE_SNIPPET,',
'    p_language => wwv_flow_code_exec.c_plsql );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST            in ( ''SAVE'', ''CREATE'', ''PLAY'' ) and ',
':P7021_CODE_SNIPPET is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(2514111507513164)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3160356294926703)
,p_validation_name=>'Cannot delete currently running automation'
,p_validation_sequence=>160
,p_validation=>'not wwv_flow_automation.is_automation_running( :P7021_ID )'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'The automation is currently running, so it cannot be deleted.'
,p_when_button_pressed=>wwv_flow_imp.id(2530582957513170)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3160422298926704)
,p_validation_name=>'Automation already running'
,p_validation_sequence=>170
,p_validation=>'not wwv_flow_automation.is_automation_running( :P7021_ID )'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'The automation is already running.'
,p_when_button_pressed=>wwv_flow_imp.id(2064814695407616)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2902582587394618)
,p_name=>'Location Local'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_LOCATION'
,p_condition_element=>'P7021_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'LOCAL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2902610672394619)
,p_event_id=>wwv_flow_imp.id(2902582587394618)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(4995340600973144)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2902895461394621)
,p_event_id=>wwv_flow_imp.id(2902582587394618)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(4995340600973144)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2902722617394620)
,p_event_id=>wwv_flow_imp.id(2902582587394618)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_REMOTE_SERVER_ID'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2902967394394622)
,p_name=>'Location Remote'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_LOCATION'
,p_condition_element=>'P7021_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REMOTE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2903949527394632)
,p_event_id=>wwv_flow_imp.id(2902967394394622)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2903682401394629)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2904039171394633)
,p_event_id=>wwv_flow_imp.id(2902967394394622)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2903682401394629)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2903222006394625)
,p_name=>'Location REST Data Source'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_LOCATION'
,p_condition_element=>'P7021_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'WEB_SOURCE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2904163348394634)
,p_event_id=>wwv_flow_imp.id(2903222006394625)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2903704119394630)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2904274877394635)
,p_event_id=>wwv_flow_imp.id(2903222006394625)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2903704119394630)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1807056316591838)
,p_event_id=>wwv_flow_imp.id(2903222006394625)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_SOURCE_POST_PROCESSING'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'NONE'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2903515460394628)
,p_event_id=>wwv_flow_imp.id(2903222006394625)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_WEB_SRC_MODULE_ID'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2904788266394640)
,p_name=>'show table attributes'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_LOCAL_DATA_SOURCE_TYPE'
,p_condition_element=>'P7021_LOCAL_DATA_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TABLE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2904894944394641)
,p_event_id=>wwv_flow_imp.id(2904788266394640)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_TABLE_OWNER,P7021_TABLE_NAME,P7021_QUERY_ORDER_BY,P7021_QUERY_WHERE,P7021_INCLUDE_ROWID_COLUMN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2904962571394642)
,p_event_id=>wwv_flow_imp.id(2904788266394640)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_SQL,P7021_FUNCTION_BODY_LANGUAGE,P7021_FUNCTION_BODY,P7021_OPTIMIZER_HINT,P7021_GRAPH_NAME,P7021_PQL_MATCH_CLAUSE,P7021_PQL_WHERE_CLAUSE,P7021_PQL_COLUMNS_CLAUSE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2905059188394643)
,p_name=>'show SQL attributes'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_LOCAL_DATA_SOURCE_TYPE'
,p_condition_element=>'P7021_LOCAL_DATA_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SQL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2905181789394644)
,p_event_id=>wwv_flow_imp.id(2905059188394643)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_SQL,P7021_OPTIMIZER_HINT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2065192016407619)
,p_event_id=>wwv_flow_imp.id(2905059188394643)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_TABLE_OWNER,P7021_TABLE_NAME,P7021_QUERY_ORDER_BY,P7021_QUERY_WHERE,P7021_INCLUDE_ROWID_COLUMN,P7021_FUNCTION_BODY_LANGUAGE,P7021_FUNCTION_BODY,P7021_GRAPH_NAME,P7021_PQL_MATCH_CLAUSE,P7021_PQL_WHERE_CLAUSE,P7021_PQL_COLUMNS_CLAUSE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2905356488394646)
,p_name=>'show Function Body attributes'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_LOCAL_DATA_SOURCE_TYPE'
,p_condition_element=>'P7021_LOCAL_DATA_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FUNC_BODY_RETURNING_SQL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2905466413394647)
,p_event_id=>wwv_flow_imp.id(2905356488394646)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_FUNCTION_BODY_LANGUAGE,P7021_FUNCTION_BODY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2065213911407620)
,p_event_id=>wwv_flow_imp.id(2905356488394646)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_TABLE_OWNER,P7021_TABLE_NAME,P7021_QUERY_ORDER_BY,P7021_QUERY_WHERE,P7021_INCLUDE_ROWID_COLUMN,P7021_SQL,P7021_GRAPH_NAME,P7021_PQL_MATCH_CLAUSE,P7021_PQL_WHERE_CLAUSE,P7021_PQL_COLUMNS_CLAUSE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1640089023313238)
,p_name=>'show Graph attributes'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_LOCAL_DATA_SOURCE_TYPE'
,p_condition_element=>'P7021_LOCAL_DATA_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'GRAPH'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1640187487313239)
,p_event_id=>wwv_flow_imp.id(1640089023313238)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_TABLE_OWNER,P7021_OPTIMIZER_HINT,P7021_QUERY_ORDER_BY,P7021_GRAPH_NAME,P7021_PQL_MATCH_CLAUSE,P7021_PQL_WHERE_CLAUSE,P7021_PQL_COLUMNS_CLAUSE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1640223715313240)
,p_event_id=>wwv_flow_imp.id(1640089023313238)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_TABLE_NAME,P7021_QUERY_ORDER_BY,P7021_QUERY_WHERE,P7021_INCLUDE_ROWID_COLUMN,P7021_SQL,P7021_FUNCTION_BODY_LANGUAGE,P7021_FUNCTION_BODY'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2905614283394649)
,p_name=>'show remote data source attributes'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_REMOTE_SERVER_ID'
,p_condition_element=>'P7021_REMOTE_SERVER_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2064415121407612)
,p_event_id=>wwv_flow_imp.id(2905614283394649)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2064319266407611)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2905703213394650)
,p_event_id=>wwv_flow_imp.id(2905614283394649)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2064319266407611)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4904403141945003)
,p_name=>'show remote table attributes'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_REMOTE_DATA_SOURCE_TYPE'
,p_condition_element=>'P7021_REMOTE_DATA_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TABLE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4904570740945004)
,p_event_id=>wwv_flow_imp.id(4904403141945003)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_REMOTE_TABLE_OWNER,P7021_REMOTE_TABLE_NAME,P7021_REMOTE_INCLUDE_ROWID,P7021_REMOTE_WHERE,P7021_REMOTE_ORDER_BY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2064078410407608)
,p_event_id=>wwv_flow_imp.id(4904403141945003)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_REMOTE_SQL,P7021_REMOTE_FUNC_BODY,P7021_REMOTE_FUNC_BODY_LANG'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4904869136945007)
,p_name=>'show remote SQL attributes'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_REMOTE_DATA_SOURCE_TYPE'
,p_condition_element=>'P7021_REMOTE_DATA_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SQL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4904905064945008)
,p_event_id=>wwv_flow_imp.id(4904869136945007)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_REMOTE_SQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2064112903407609)
,p_event_id=>wwv_flow_imp.id(4904869136945007)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_REMOTE_TABLE_OWNER,P7021_REMOTE_TABLE_NAME,P7021_REMOTE_INCLUDE_ROWID,P7021_REMOTE_WHERE,P7021_REMOTE_ORDER_BY,P7021_REMOTE_FUNC_BODY,,P7021_REMOTE_FUNC_BODY_LANG'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4905238548945011)
,p_name=>'show remote PL/SQL attributes'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_REMOTE_DATA_SOURCE_TYPE'
,p_condition_element=>'P7021_REMOTE_DATA_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FUNC_BODY_RETURNING_SQL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4905358190945012)
,p_event_id=>wwv_flow_imp.id(4905238548945011)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_REMOTE_FUNC_BODY,P7021_REMOTE_FUNC_BODY_LANG'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2064202392407610)
,p_event_id=>wwv_flow_imp.id(4905238548945011)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_REMOTE_TABLE_OWNER,P7021_REMOTE_TABLE_NAME,P7021_REMOTE_INCLUDE_ROWID,P7021_REMOTE_WHERE,P7021_REMOTE_ORDER_BY,P7021_REMOTE_SQL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1805867519591826)
,p_name=>'Post Processing NONE'
,p_event_sequence=>120
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_SOURCE_POST_PROCESSING'
,p_condition_element=>'P7021_SOURCE_POST_PROCESSING'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NONE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1805902367591827)
,p_event_id=>wwv_flow_imp.id(1805867519591826)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_POST_PROCESS_ORDERBY,P7021_POST_PROCESS_WHERE,P7021_POST_PROCESS_QUERY,P7021_POST_PROC_FUNC_BODY_LANG,P7021_POST_PROC_FUNC_BODY'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1806035175591828)
,p_name=>'Post Processing WHERE'
,p_event_sequence=>130
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_SOURCE_POST_PROCESSING'
,p_condition_element=>'P7021_SOURCE_POST_PROCESSING'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'WHERE_ORDER_BY_CLAUSE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1806143747591829)
,p_event_id=>wwv_flow_imp.id(1806035175591828)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_POST_PROCESS_ORDERBY,P7021_POST_PROCESS_WHERE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1806327369591831)
,p_event_id=>wwv_flow_imp.id(1806035175591828)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_POST_PROCESS_QUERY,P7021_POST_PROC_FUNC_BODY_LANG,P7021_POST_PROC_FUNC_BODY'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1806422379591832)
,p_name=>'Post Processing SQL'
,p_event_sequence=>140
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_SOURCE_POST_PROCESSING'
,p_condition_element=>'P7021_SOURCE_POST_PROCESSING'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SQL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1806576586591833)
,p_event_id=>wwv_flow_imp.id(1806422379591832)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_POST_PROCESS_QUERY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1806665454591834)
,p_event_id=>wwv_flow_imp.id(1806422379591832)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_POST_PROCESS_ORDERBY,P7021_POST_PROCESS_WHERE,P7021_POST_PROC_FUNC_BODY_LANG,P7021_POST_PROC_FUNC_BODY'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1806714271591835)
,p_name=>'Post Processing PLSQL'
,p_event_sequence=>150
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_SOURCE_POST_PROCESSING'
,p_condition_element=>'P7021_SOURCE_POST_PROCESSING'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FUNC_BODY_RETURNING_SQL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1806856140591836)
,p_event_id=>wwv_flow_imp.id(1806714271591835)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_POST_PROC_FUNC_BODY_LANG,P7021_POST_PROC_FUNC_BODY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1806900970591837)
,p_event_id=>wwv_flow_imp.id(1806714271591835)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_POST_PROCESS_ORDERBY,P7021_POST_PROCESS_WHERE,P7021_POST_PROCESS_QUERY'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2027541351184808)
,p_name=>'Show Interval Builder'
,p_event_sequence=>160
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'#P7021_EDIT_POLLING_INTERVAL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2027943196184811)
,p_event_id=>wwv_flow_imp.id(2027541351184808)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(5426552263545892)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2028336622186323)
,p_name=>'Build the interval'
,p_event_sequence=>170
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2022286112169334)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2028723998186324)
,p_event_id=>wwv_flow_imp.id(2028336622186323)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_POLLING_INTERVAL'
,p_attribute_01=>'JAVASCRIPT_EXPRESSION'
,p_attribute_05=>'buildInterval()'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2029236271186324)
,p_event_id=>wwv_flow_imp.id(2028336622186323)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLOSE_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(5426552263545892)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2029600049187879)
,p_name=>'Hide Components on load'
,p_event_sequence=>180
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2030053948187879)
,p_event_id=>wwv_flow_imp.id(2029600049187879)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(5426552263545892)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2515087259671727)
,p_event_id=>wwv_flow_imp.id(2029600049187879)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2514185254671718)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2030443946192921)
,p_name=>'Clear Sync Interval'
,p_event_sequence=>190
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'#P7021_CLEAR_POLLING_INTERVAL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2030872752192922)
,p_event_id=>wwv_flow_imp.id(2030443946192921)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_POLLING_INTERVAL'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2032854750210526)
,p_name=>'Hide all'
,p_event_sequence=>200
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_INT_FREQUENCY'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2033246075210527)
,p_event_id=>wwv_flow_imp.id(2032854750210526)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_BYDAY,P7021_BYHOUR,P7021_BYMINUTE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2033637835212081)
,p_name=>'Weekly Frequency chosen'
,p_event_sequence=>210
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_INT_FREQUENCY'
,p_condition_element=>'P7021_INT_FREQUENCY'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'WEEKLY'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2034043183212081)
,p_event_id=>wwv_flow_imp.id(2033637835212081)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_BYDAY,P7021_BYHOUR,P7021_BYMINUTE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2034470438213547)
,p_name=>'Daily Frequency chosen'
,p_event_sequence=>220
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_INT_FREQUENCY'
,p_condition_element=>'P7021_INT_FREQUENCY'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'DAILY'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2034838703213547)
,p_event_id=>wwv_flow_imp.id(2034470438213547)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_BYHOUR,P7021_BYMINUTE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2035351162213547)
,p_event_id=>wwv_flow_imp.id(2034470438213547)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_BYDAY'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'MON:TUE:WED:THU:FRI:SAT:SUN'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2035726316214660)
,p_name=>'Hourly Frequency chosen'
,p_event_sequence=>230
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_INT_FREQUENCY'
,p_condition_element=>'P7021_INT_FREQUENCY'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'HOURLY'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2036196639214660)
,p_event_id=>wwv_flow_imp.id(2035726316214660)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_BYMINUTE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2036697823214660)
,p_event_id=>wwv_flow_imp.id(2035726316214660)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_BYDAY'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'MON:TUE:WED:THU:FRI:SAT:SUN'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2037110477214661)
,p_event_id=>wwv_flow_imp.id(2035726316214660)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_BYHOUR'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2037581936216081)
,p_name=>'Minutely Frequency chosen'
,p_event_sequence=>240
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_INT_FREQUENCY'
,p_condition_element=>'P7021_INT_FREQUENCY'
,p_triggering_condition_type=>'IN_LIST'
,p_triggering_expression=>'MINUTELY'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2037958621216081)
,p_event_id=>wwv_flow_imp.id(2037581936216081)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_BYDAY'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'MON:TUE:WED:THU:FRI:SAT:SUN'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2038490775216081)
,p_event_id=>wwv_flow_imp.id(2037581936216081)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_BYHOUR,P7021_BYMINUTE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1807344842591841)
,p_name=>'Show / Hide Polling interval'
,p_event_sequence=>250
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_TRIGGER_TYPE'
,p_condition_element=>'P7021_TRIGGER_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'POLLING'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1807424976591842)
,p_event_id=>wwv_flow_imp.id(1807344842591841)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_POLLING_INTERVAL,P7021_POLLING_STATUS'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1807536655591843)
,p_event_id=>wwv_flow_imp.id(1807344842591841)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_POLLING_INTERVAL,P7021_POLLING_STATUS'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1251855691684756049)
,p_event_id=>wwv_flow_imp.id(1807344842591841)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_POLLING_INTERVAL'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2063670005407604)
,p_name=>'REST Source Changed'
,p_event_sequence=>260
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_WEB_SRC_MODULE_ID'
,p_condition_element=>'P7021_WEB_SRC_MODULE_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1721292738469945)
,p_event_id=>wwv_flow_imp.id(2063670005407604)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_WEB_SRC_ARRAY_COL_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2063741979407605)
,p_event_id=>wwv_flow_imp.id(2063670005407604)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2063557467407603)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2063892277407606)
,p_event_id=>wwv_flow_imp.id(2063670005407604)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2063557467407603)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1721151144469944)
,p_event_id=>wwv_flow_imp.id(2063670005407604)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_WEB_SRC_ARRAY_COL_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2065492605407622)
,p_name=>'Hide "Error"'
,p_event_sequence=>270
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_POLLING_STATUS'
,p_condition_element=>'P7021_POLLING_STATUS'
,p_triggering_condition_type=>'NOT_EQUALS'
,p_triggering_expression=>'ERROR'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2065544206407623)
,p_event_id=>wwv_flow_imp.id(2065492605407622)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'#P7021_POLLING_STATUS_2'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2066254576407630)
,p_name=>'PL/SQL Location LOCAL'
,p_event_sequence=>280
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_FUNC_BODY_BOOL_LOCATION'
,p_condition_element=>'P7021_FUNC_BODY_BOOL_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'LOCAL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2066358010407631)
,p_event_id=>wwv_flow_imp.id(2066254576407630)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2066950595407637)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2067519970407643)
,p_event_id=>wwv_flow_imp.id(2066254576407630)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2067168170407639)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2066632600407634)
,p_event_id=>wwv_flow_imp.id(2066254576407630)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_PLSQL_REMOTE_SERVER_ID'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2067229994407640)
,p_name=>'PL/SQL Location Remote'
,p_event_sequence=>290
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_FUNC_BODY_BOOL_LOCATION'
,p_condition_element=>'P7021_FUNC_BODY_BOOL_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REMOTE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2067390120407641)
,p_event_id=>wwv_flow_imp.id(2067229994407640)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2067168170407639)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2067603953407644)
,p_event_id=>wwv_flow_imp.id(2067229994407640)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2066950595407637)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2067797042407645)
,p_name=>'PL/SQL Remote Server chosen'
,p_event_sequence=>300
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_PLSQL_REMOTE_SERVER_ID'
,p_condition_element=>'P7021_PLSQL_REMOTE_SERVER_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2067893552407646)
,p_event_id=>wwv_flow_imp.id(2067797042407645)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_REMOTE_PLSQL_BOOLEAN'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2067979495407647)
,p_event_id=>wwv_flow_imp.id(2067797042407645)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_REMOTE_PLSQL_BOOLEAN'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2068073728407648)
,p_name=>'Source Type QUERY'
,p_event_sequence=>310
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_SOURCE_TYPE'
,p_condition_element=>'P7021_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'QUERY'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2068118677407649)
,p_event_id=>wwv_flow_imp.id(2068073728407648)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(96107915683078518)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2068279107407650)
,p_event_id=>wwv_flow_imp.id(2068073728407648)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2065703853407625)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2513716108671714)
,p_event_id=>wwv_flow_imp.id(2068073728407648)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2513514643671712)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2514759707671724)
,p_event_id=>wwv_flow_imp.id(2068073728407648)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_LOCATION'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'LOCAL'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2516619889671743)
,p_event_id=>wwv_flow_imp.id(2068073728407648)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_LOCAL_DATA_SOURCE_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'SQL'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2512482455671701)
,p_name=>'Source Type Function Body'
,p_event_sequence=>320
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_SOURCE_TYPE'
,p_condition_element=>'P7021_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2512505861671702)
,p_event_id=>wwv_flow_imp.id(2512482455671701)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(96107915683078518)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2512652892671703)
,p_event_id=>wwv_flow_imp.id(2512482455671701)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2065703853407625)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2513822897671715)
,p_event_id=>wwv_flow_imp.id(2512482455671701)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2513514643671712)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2512989046671706)
,p_name=>'Source Type ALWAYS'
,p_event_sequence=>330
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_SOURCE_TYPE'
,p_condition_element=>'P7021_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'ALWAYS'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2513051284671707)
,p_event_id=>wwv_flow_imp.id(2512989046671706)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(96107915683078518)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2513121537671708)
,p_event_id=>wwv_flow_imp.id(2512989046671706)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2065703853407625)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2513994134671716)
,p_event_id=>wwv_flow_imp.id(2512989046671706)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2513514643671712)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2515831622671735)
,p_name=>'Refresh Column Select Lists'
,p_event_sequence=>340
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'.is-query'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2515987148671736)
,p_event_id=>wwv_flow_imp.id(2515831622671735)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'refreshPrimaryKeyColumns();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2516778140671744)
,p_name=>'ROWS Type'
,p_event_sequence=>350
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_RESULT_TYPE'
,p_condition_element=>'P7021_RESULT_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'ROWS'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2516835601671745)
,p_event_id=>wwv_flow_imp.id(2516778140671744)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2517114410671748)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2516999592671746)
,p_event_id=>wwv_flow_imp.id(2516778140671744)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2517114410671748)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2517002835671747)
,p_event_id=>wwv_flow_imp.id(2516778140671744)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_MAX_ROWS_TO_PROCESS'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1375523210188201)
,p_name=>'Use Local Sync Table'
,p_event_sequence=>360
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_USE_LOCAL_SYNC_TABLE'
,p_condition_element=>'P7021_USE_LOCAL_SYNC_TABLE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'Y'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1375620100188202)
,p_event_id=>wwv_flow_imp.id(1375523210188201)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_EXTERNAL_FILTER_EXPR,P7021_EXTERNAL_ORDER_BY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1376130620188207)
,p_event_id=>wwv_flow_imp.id(1375523210188201)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(6353168577393099)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1375858039188204)
,p_event_id=>wwv_flow_imp.id(1375523210188201)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(6353168577393099)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1375921993188205)
,p_event_id=>wwv_flow_imp.id(1375523210188201)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_EXTERNAL_FILTER_EXPR,P7021_EXTERNAL_ORDER_BY'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(110967014683654342)
,p_name=>'Hide Edit Schedule buttons for "Graph" Automations on non-23ai DB'
,p_event_sequence=>380
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
,p_display_when_type=>'EXPRESSION'
,p_display_when_cond=>':P7021_LOCAL_DATA_SOURCE_TYPE = ''GRAPH'' and sys.dbms_db_version.version < 23'
,p_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(110967189271654343)
,p_event_id=>wwv_flow_imp.id(110967014683654342)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'JQUERY_SELECTOR'
,p_affected_elements=>'#P7021_EDIT_POLLING_INTERVAL,#P7021_CLEAR_POLLING_INTERVAL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2231919766790536)
,p_name=>'Enable / Disable Format Mask'
,p_event_sequence=>390
,p_triggering_element_type=>'COLUMN'
,p_triggering_region_id=>wwv_flow_imp.id(6353168577393099)
,p_triggering_element=>'VALUE_TYPE'
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>wwv_flow_string.join(wwv_flow_t_varchar2(
'   [ "STATIC", "ITEM" ].includes( $v( "COLUMN_ITEM_FOR_VALUE_TYPE" ) )',
'&& [ "BOOLEAN", "DATE", "NUMBER", "TIMESTAMP", "TIMESTAMP WITH TIME ZONE" ].includes( $v( "COLUMN_ITEM_FOR_DATA_TYPE" ) )'))
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2232037225790537)
,p_event_id=>wwv_flow_imp.id(2231919766790536)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'FORMAT_MASK'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2232194055790538)
,p_event_id=>wwv_flow_imp.id(2231919766790536)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'FORMAT_MASK'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2232220532790539)
,p_event_id=>wwv_flow_imp.id(2231919766790536)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'FORMAT_MASK'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2232373860790540)
,p_name=>'Enable / Disable Expression'
,p_event_sequence=>400
,p_triggering_element_type=>'COLUMN'
,p_triggering_region_id=>wwv_flow_imp.id(6353168577393099)
,p_triggering_element=>'VALUE_TYPE'
,p_condition_element_type=>'COLUMN'
,p_condition_element=>'VALUE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2232438736790541)
,p_event_id=>wwv_flow_imp.id(2232373860790540)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'VALUE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2232561325790542)
,p_event_id=>wwv_flow_imp.id(2232373860790540)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'VALUE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2232654232790543)
,p_event_id=>wwv_flow_imp.id(2232373860790540)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'VALUE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1721315941469946)
,p_name=>'REST Source or Array Column Changed'
,p_event_sequence=>410
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7021_WEB_SRC_MODULE_ID,P7021_WEB_SRC_ARRAY_COL_ID'
,p_condition_element=>'P7021_WEB_SRC_MODULE_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2514579304671722)
,p_event_id=>wwv_flow_imp.id(1721315941469946)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(6353168577393099)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1377325561188219)
,p_event_id=>wwv_flow_imp.id(1721315941469946)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7021_USE_LOCAL_SYNC_TABLE,P7021_EXTERNAL_FILTER_EXPR,P7021_EXTERNAL_ORDER_BY,P7021_SOURCE_POST_PROCESSING,P7021_POST_PROCESS_WHERE,P7021_POST_PROCESS_ORDERBY,P7021_POST_PROCESS_QUERY,P7021_POST_PROC_FUNC_BODY_LANG,P7021_POST_PROC_FUNC_BODY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2514835773671725)
,p_event_id=>wwv_flow_imp.id(1721315941469946)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2514185254671718)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2532500787513171)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(2500558986513154)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process form Edit Automation'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Changes applied.'
,p_internal_uid=>2532500787513171
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(5816927654534531)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(4803890382119538)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Actions - Save Interactive Grid Data'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>5816927654534531
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1567328351713204)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(6353168577393099)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Parameters - VALUE_LANGUAGE'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    -- Web Source Parameters should always be handled as PL/SQL,',
'    -- in an IG it''s to complicated having a dynamic languages column',
'    if :VALUE_TYPE in ( ''FUNCTION_BODY'', ''EXPRESSION'' ) then',
'        :VALUE_LANGUAGE := ''PLSQL'';',
'    else',
'        :VALUE_LANGUAGE := null;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>1567328351713204
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2053448886333329)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(6353168577393099)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Parameters - Save Interactive Grid Data'
,p_attribute_01=>'TABLE'
,p_attribute_03=>'WWV_FLOW_WEB_SRC_COMP_PARAMS'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2053448886333329
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1807724155591845)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Clear REST Source Parameters'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'delete wwv_flow_web_src_comp_params',
' where security_group_id = :WORKSPACE_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and automation_id     = :P7021_ID;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    :REQUEST in (''SAVE'', ''PLAY'' )',
'and (    :P7021_LOCATION != ''WEB_SOURCE'' ',
'      or :P7021_TABLE_RESULT_TYPE in (''ALWAYS'', ''FUNC_BODY_RETURNING_BOOLEAN'' ) ',
'      or coalesce( :P7021_OLD_WEB_SRC_MODULE_ID,    ''X'' ) != :P7021_WEB_SRC_MODULE_ID',
'      or coalesce( :P7021_OLD_WEB_SRC_ARRAY_COL_ID, ''X'' ) != coalesce( :P7021_WEB_SRC_ARRAY_COL_ID, ''X'' ) )',
''))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>1807724155591845
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1807875798591846)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Sync REST Source Parameters'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_web_src_dev.add_web_source_params(',
'    p_flow_id                 => :FB_FLOW_ID,',
'    p_web_source_module_id    => :P7021_WEB_SRC_MODULE_ID,',
'    p_array_column_id         => :P7021_WEB_SRC_ARRAY_COL_ID,',
'    p_database_operation      => wwv_flow_plugin_api.c_db_operation_fetch_rows,',
'    p_automation_id           => :P7021_ID );',
'',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'    :P7021_LOCATION                               = ''WEB_SOURCE''',
'and :REQUEST                                     in ( ''CREATE'', ''SAVE'', ''PLAY'')',
'and (    coalesce( :P7021_OLD_LOCATION, ''X'' )             != :P7021_LOCATION',
'      or coalesce( :P7021_OLD_WEB_SRC_MODULE_ID, ''X'' )    != :P7021_WEB_SRC_MODULE_ID',
'      or coalesce( :P7021_OLD_WEB_SRC_ARRAY_COL_ID, ''X'' ) != coalesce( :P7021_WEB_SRC_ARRAY_COL_ID, ''X'' ) )'))
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>1807875798591846
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2064709286407615)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Status and Next Run Date'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- 1. Status changed from Disabled/Error to Active',
'if :P7021_OLD_POLLING_STATUS in (''DISABLED'',''ERROR'') and ',
'   :P7021_POLLING_STATUS = ''ACTIVE'' ',
'then',
'    wwv_flow_automation.set_job_status(',
'        p_automation_id      => :P7021_ID,',
'        p_status             => wwv_flow_automation.c_status_active );',
'--        ',
'-- 2. Execution schedule changed for active automation',
'elsif :P7021_POLLING_STATUS = ''ACTIVE'' and ',
'      :P7021_POLLING_INTERVAL is not null and ',
'      nvl( :P7021_OLD_POLLING_INTERVAL, ''X'' ) != nvl( :P7021_POLLING_INTERVAL, ''X'' ) ',
'then',
'    wwv_flow_automation.set_job_status(',
'        p_automation_id      => :P7021_ID,',
'        p_status             => wwv_flow_automation.c_status_active );',
'--',
'-- 3. Status changed from Active to Disabled / Error or Type changed to API: disable automation',
'elsif :P7021_TRIGGER_TYPE = ''API'' or :P7021_OLD_POLLING_STATUS = ''ACTIVE'' and :P7021_POLLING_STATUS in (''DISABLED'',''ERROR'') then',
'    wwv_flow_automation.set_job_status(',
'        p_automation_id      => :P7021_ID,',
'        p_status             => wwv_flow_automation.c_status_disabled );',
'end if;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'PLAY,SAVE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_internal_uid=>2064709286407615
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2064903543407617)
,p_process_sequence=>80
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Play automation'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_automation.execute_due_automations( p_automation_id => :P7021_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2064814695407616)
,p_process_success_message=>'Automation Execution initiated.'
,p_internal_uid=>2064903543407617
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3160691890926706)
,p_process_sequence=>90
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Terminate automation'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_automation.abort_job( p_id => :P7021_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(3160590621926705)
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_automations',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and id                = :P7021_ID'))
,p_process_when_type=>'EXISTS'
,p_process_success_message=>'Automation Execution terminated.'
,p_internal_uid=>3160691890926706
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2515564925671732)
,p_process_sequence=>10
,p_process_point=>'BEFORE_BOX_BODY'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Distribute items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if :P7021_SOURCE_TYPE = ''QUERY'' then',
'    ',
'        if :P7021_LOCATION = ''REMOTE'' then',
'            :P7021_REMOTE_TABLE_OWNER      := :P7021_TABLE_OWNER;',
'            :P7021_REMOTE_TABLE_NAME       := :P7021_TABLE_NAME;',
'            :P7021_REMOTE_DATA_SOURCE_TYPE := :P7021_LOCAL_DATA_SOURCE_TYPE;',
'            :P7021_REMOTE_WHERE            := :P7021_QUERY_WHERE;',
'            :P7021_REMOTE_ORDER_BY         := :P7021_QUERY_ORDER_BY;',
'',
'            case :P7021_REMOTE_DATA_SOURCE_TYPE',
'                when ''SQL''                     then :P7021_REMOTE_SQL := :P7021_SQL;',
'                when ''FUNC_BODY_RETURNING_SQL'' then',
'                    :P7021_REMOTE_FUNC_BODY      := :P7021_SQL; ',
'                    :P7021_REMOTE_FUNC_BODY_LANG := :P7021_FUNCTION_BODY_LANGUAGE;',
'                else null;',
'            end case;',
'            :P7021_REMOTE_INCLUDE_ROWID   := :P7021_INCLUDE_ROWID_COLUMN;',
'            :P7021_SQL                    := null;',
'            :P7021_TABLE_NAME             := null;',
'            :P7021_TABLE_OWNER            := null;',
'            :P7021_QUERY_WHERE            := null;',
'            :P7021_QUERY_ORDER_BY         := null;',
'            ',
'        elsif :P7021_LOCATION = ''LOCAL'' then',
'            case :P7021_LOCAL_DATA_SOURCE_TYPE',
'                when ''FUNC_BODY_RETURNING_SQL'' then :P7021_FUNCTION_BODY    := :P7021_SQL;',
'                when ''GRAPH''                   then :P7021_GRAPH_NAME       := :P7021_TABLE_NAME;',
'                                                    :P7021_PQL_WHERE_CLAUSE := :P7021_QUERY_WHERE;',
'                else null;',
'            end case;',
'            ',
'        elsif :P7021_LOCATION = ''WEB_SOURCE'' then',
'            if :P7021_SOURCE_POST_PROCESSING = ''WHERE_ORDER_BY_CLAUSE'' then',
'                :P7021_POST_PROCESS_WHERE            := :P7021_QUERY_WHERE;',
'                :P7021_POST_PROCESS_ORDERBY         := :P7021_QUERY_ORDER_BY;',
'            elsif :P7021_SOURCE_POST_PROCESSING = ''SQL'' then',
'                :P7021_POST_PROCESS_QUERY            := :P7021_SQL;',
'            elsif :P7021_SOURCE_POST_PROCESSING = ''FUNC_BODY_RETURNING_SQL'' then',
'                :P7021_POST_PROC_FUNC_BODY_LANG      := :P7021_FUNCTION_BODY_LANGUAGE;',
'                :P7021_POST_PROC_FUNC_BODY           := :P7021_SQL;',
'            end if;',
'',
'            :P7021_SOURCE_POST_PROCESSING := coalesce( :P7021_SOURCE_POST_PROCESSING, ''NONE'' );',
'',
'            :P7021_SQL                    := null;',
'            :P7021_TABLE_NAME             := null;',
'            :P7021_TABLE_OWNER            := null;',
'            :P7021_QUERY_WHERE            := null;',
'            :P7021_QUERY_ORDER_BY         := null;            ',
'        end if;',
'',
'    elsif :P7021_SOURCE_TYPE = ''FUNC_BODY_RETURNING_BOOLEAN'' then',
'        :P7021_FUNC_BODY_BOOL_LOCATION := :P7021_LOCATION;',
'',
'        if :P7021_FUNC_BODY_BOOL_LOCATION = ''LOCAL'' then',
'            :P7021_LOCAL_FUNC_BODY_BOOLEAN      := :P7021_SQL;',
'            :P7021_LOCAL_FUNCBODYBOOL_LANG      := :P7021_FUNCTION_BODY_LANGUAGE;',
'            :P7021_REMOTE_PLSQL_BOOLEAN         := null;',
'            :P7021_PLSQL_REMOTE_SERVER_ID       := null;',
'        else ',
'            :P7021_REMOTE_PLSQL_BOOLEAN         := :P7021_SQL;',
'            :P7021_PLSQL_REMOTE_SERVER_ID       := :P7021_REMOTE_SERVER_ID;',
'            :P7021_LOCAL_FUNC_BODY_BOOLEAN      := null;',
'            :P7021_LOCAL_FUNCBODYBOOL_LANG      := null;',
'        end if;',
'        :P7021_SQL := null;',
'    elsif :P7021_SOURCE_TYPE = ''ALWAYS'' then',
'        :P7021_LOCATION                := null;',
'        :P7021_SQL                     := null;',
'        :P7021_LOCAL_FUNC_BODY_BOOLEAN := null;',
'    end if;',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>2515564925671732
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2532145098513171)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(2500558986513154)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Edit Automation'
,p_internal_uid=>2532145098513171
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(98114159853433329)
,p_process_sequence=>10
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'getColumnInfo'
,p_process_sql_clob=>'wwv_flow_automation_dev.p7021_emit_query_columns;'
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>98114159853433329
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1808270756591850)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Consolidate items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    procedure clear_wsm is',
'    begin',
'        :P7021_SOURCE_POST_PROCESSING := null;',
'        :P7021_WEB_SRC_MODULE_ID      := null;',
'    end clear_wsm;',
'    ',
'    procedure clear_table is',
'    begin',
'        :P7021_TABLE_NAME             := null;',
'        :P7021_TABLE_OWNER            := null;',
'        :P7021_QUERY_WHERE            := null;',
'        :P7021_QUERY_ORDER_BY         := null;',
'        :P7021_PQL_COLUMNS_CLAUSE     := null;',
'        :P7021_PQL_MATCH_CLAUSE       := null;',
'        :P7021_OPTIMIZER_HINT         := null;',
'        :P7021_INCLUDE_ROWID_COLUMN   := ''N'';',
'    end clear_table;',
'',
'begin',
'    if :P7021_SOURCE_TYPE = ''QUERY'' then',
'',
'        :P7021_TABLE_RESULT_TYPE := :P7021_RESULT_TYPE;',
'',
'        if :P7021_LOCATION = ''REMOTE'' then',
'            :P7021_REMOTE_DATA_SOURCE_TYPE := coalesce( :P7021_REMOTE_DATA_SOURCE_TYPE, ''TABLE'' );',
'            --',
'            :P7021_TABLE_OWNER             := :P7021_REMOTE_TABLE_OWNER;',
'            :P7021_TABLE_NAME              := :P7021_REMOTE_TABLE_NAME;',
'            :P7021_LOCAL_DATA_SOURCE_TYPE  := :P7021_REMOTE_DATA_SOURCE_TYPE;',
'            :P7021_SQL                     := case :P7021_REMOTE_DATA_SOURCE_TYPE',
'                                                  when ''SQL''                     then :P7021_REMOTE_SQL',
'                                                  when ''FUNC_BODY_RETURNING_SQL'' then :P7021_REMOTE_FUNC_BODY end;',
'            :P7021_FUNCTION_BODY_LANGUAGE  := case when :P7021_REMOTE_DATA_SOURCE_TYPE = ''FUNC_BODY_RETURNING_SQL'' then :P7021_REMOTE_FUNC_BODY_LANG end;',
'            :P7021_INCLUDE_ROWID_COLUMN    := case when :P7021_REMOTE_DATA_SOURCE_TYPE = ''TABLE'' then :P7021_REMOTE_INCLUDE_ROWID else ''N'' end;',
'            :P7021_QUERY_WHERE             := :P7021_REMOTE_WHERE;',
'            :P7021_QUERY_ORDER_BY          := :P7021_REMOTE_ORDER_BY;',
'            clear_wsm;',
'        elsif :P7021_LOCATION = ''LOCAL'' then',
'            :P7021_REMOTE_SERVER_ID       := null;',
'            :P7021_LOCAL_DATA_SOURCE_TYPE := coalesce( :P7021_LOCAL_DATA_SOURCE_TYPE, ''TABLE'' );',
'            :P7021_SQL                    := case :P7021_LOCAL_DATA_SOURCE_TYPE',
'                                                 when ''SQL''                     then :P7021_SQL',
'                                                 when ''FUNC_BODY_RETURNING_SQL'' then :P7021_FUNCTION_BODY end;',
'            :P7021_FUNCTION_BODY_LANGUAGE := case when :P7021_LOCAL_DATA_SOURCE_TYPE = ''FUNC_BODY_RETURNING_SQL'' then :P7021_FUNCTION_BODY_LANGUAGE end;',
'            :P7021_INCLUDE_ROWID_COLUMN   := case when :P7021_LOCAL_DATA_SOURCE_TYPE = ''TABLE'' then :P7021_INCLUDE_ROWID_COLUMN else ''N'' end;',
'            if :P7021_LOCAL_DATA_SOURCE_TYPE = ''GRAPH'' then ',
'                :P7021_TABLE_NAME := :P7021_GRAPH_NAME;',
'                :P7021_QUERY_WHERE := :P7021_PQL_WHERE_CLAUSE;',
'            end if;',
'            clear_wsm;',
'        elsif :P7021_LOCATION = ''WEB_SOURCE'' then',
'            if     :P7021_OLD_WEB_SRC_MODULE_ID                     = :P7021_WEB_SRC_MODULE_ID ',
'               and coalesce( :P7021_OLD_WEB_SRC_ARRAY_COL_ID, ''X'' ) = coalesce( :P7021_WEB_SRC_ARRAY_COL_ID, ''X'' )',
'            then',
'                if :P7021_SOURCE_POST_PROCESSING = ''WHERE_ORDER_BY_CLAUSE'' then',
'                    :P7021_QUERY_WHERE            := :P7021_POST_PROCESS_WHERE;',
'                    :P7021_QUERY_ORDER_BY         := :P7021_POST_PROCESS_ORDERBY;',
'                    :P7021_FUNCTION_BODY_LANGUAGE := null;',
'                elsif :P7021_SOURCE_POST_PROCESSING = ''SQL'' then',
'                    :P7021_SQL                    := :P7021_POST_PROCESS_QUERY;',
'                    :P7021_FUNCTION_BODY_LANGUAGE := null;',
'                elsif :P7021_SOURCE_POST_PROCESSING = ''FUNC_BODY_RETURNING_SQL'' then',
'                    :P7021_SQL                    := :P7021_POST_PROC_FUNC_BODY;',
'                    :P7021_FUNCTION_BODY_LANGUAGE := :P7021_POST_PROC_FUNC_BODY_LANG;',
'                end if;',
'            else',
'                 :P7021_SOURCE_POST_PROCESSING := null;',
'                 :P7021_FUNCTION_BODY_LANGUAGE := null;',
'            end if;',
'            :P7021_REMOTE_SERVER_ID           := null;',
'            :P7021_INCLUDE_ROWID_COLUMN       := ''N'';',
'            :P7021_SOURCE_POST_PROCESSING     := nullif ( :P7021_SOURCE_POST_PROCESSING, ''NONE'' );',
'            :P7021_TABLE_USELOCALSYNCTABLE    := case ',
'                                                 when wwv_flow_web_src_sync.sync_exists_for_array_column(',
'                                                          p_web_source_module_id => :P7021_WEB_SRC_MODULE_ID,',
'                                                          p_array_column_id      => :P7021_WEB_SRC_ARRAY_COL_ID ) = ''Y'' ',
'                                                 then coalesce(:P7021_USE_LOCAL_SYNC_TABLE,''N'')',
'                                                 end;',
'        end if;',
'',
'    elsif :P7021_SOURCE_TYPE = ''FUNC_BODY_RETURNING_BOOLEAN'' then',
'        :P7021_LOCATION          := :P7021_FUNC_BODY_BOOL_LOCATION;',
'        :P7021_TABLE_RESULT_TYPE := ''FUNC_BODY_RETURNING_BOOLEAN'';',
'',
'        if :P7021_FUNC_BODY_BOOL_LOCATION = ''LOCAL'' then',
'            :P7021_SQL                    := :P7021_LOCAL_FUNC_BODY_BOOLEAN;',
'            :P7021_FUNCTION_BODY_LANGUAGE := :P7021_LOCAL_FUNCBODYBOOL_LANG;',
'            :P7021_REMOTE_SERVER_ID       := null;',
'        else ',
'            :P7021_SQL                    := :P7021_REMOTE_PLSQL_BOOLEAN;',
'            :P7021_FUNCTION_BODY_LANGUAGE := null;',
'            :P7021_REMOTE_SERVER_ID       := :P7021_PLSQL_REMOTE_SERVER_ID;',
'        end if;',
'        ',
'        clear_table;',
'        clear_wsm;',
'',
'    elsif :P7021_SOURCE_TYPE = ''ALWAYS'' then',
'        :P7021_TABLE_RESULT_TYPE      := ''ALWAYS'';',
'        :P7021_SQL                    := null;',
'        :P7021_REMOTE_SERVER_ID       := null;',
'        :P7021_FUNCTION_BODY_LANGUAGE := null;',
'        clear_wsm;',
'        clear_table;',
'    end if;',
'    ',
'    :P7021_POLL_LAST_RUN_TIMESTAMP := null;',
'    :P7021_POLL_NEXT_RUN_TIMESTAMP := null;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>1808270756591850
);
end;
/
prompt --application/pages/page_07022
begin
wwv_flow_imp_page.create_page(
 p_id=>7022
,p_name=>'Edit Automation Action'
,p_alias=>'EDIT-AUTOMATION-ACTION'
,p_step_title=>'Edit Automation Action'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1409136117910718)
,p_plug_name=>'Set Plugin Settings'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>85
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    -- create the onChange event for the P7022_ACTION_TYPE and',
'    -- also the initialization code for the dynamic attributes',
'    wwv_flow_plugin_dev.add_onload_code (',
'        p_plugin_type         => wwv_flow_plugin.c_plugin_type_process_type,',
'        p_type_page_item_name => ''P7022_ACTION_TYPE'',',
'        p_page_item_prefix    => ''P7022_'',',
'        p_is_wizard           => false',
'    );',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1409470037910721)
,p_plug_name=>'Code'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>45
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(29895161562987844)
,p_plug_name=>' Examples'
,p_parent_plug_id=>wwv_flow_imp.id(1409470037910721)
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(689970285456172024)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Example 1: Send en email. This assumes that an email template named <strong>ORDER</strong> exists, with the placeholders used in the ',
'    <strong>p_placeholders</strong> parameter.',
'</p>',
'<pre>',
'begin',
'    apex_mail.send (',
'        p_template_static_id => ''ORDER'',',
'        p_placeholders       => ''{ "ORDER_NUMBER": '' || :ORDER_NUMBER ||',
'                                  ''"ORDER_DATE":"''   || to_char( :ORDER_DATE, ''YYYY-MM-DD'' ) || ''", ''',
'                                  ''"ORDER_TOTAL":''   || :ORDER_TOTAL || ',
'                                ''}'',',
'        p_to                 => ''some_user@somewhere.com'' );',
'end;',
'</pre>',
'<p>',
'    Example 2: Insert a row into another table. If the :SAL value is NULL, write a warning message to the automation log.',
'</p>',
'<pre>',
'begin',
'    insert into other_table( empno, ename, sal )',
'                     values( :EMPNO, :ENAME, :SAL );',
'    if :SAL is null then',
'        apex_automation.log_warn( ''EMPNO '' || :EMPNO ||'' has a NULL Salary'');',
'    end if;',
'end;',
'</pre>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(90115922532448608)
,p_plug_name=>'Local Code'
,p_parent_plug_id=>wwv_flow_imp.id(1409470037910721)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(90116067165448609)
,p_plug_name=>'Remote Code'
,p_parent_plug_id=>wwv_flow_imp.id(1409470037910721)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1410170163910728)
,p_plug_name=>'Action'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>5
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_AUTOMATION_ACTIONS'
,p_query_where=>'security_group_id = :WORKSPACE_ID'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1733465727290719)
,p_plug_name=>'Error Handling'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>55
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1733554992290720)
,p_plug_name=>'Server Side Condition'
,p_region_name=>'CON'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>65
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1733611964290721)
,p_plug_name=>'Advanced'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>75
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1734379323290728)
,p_plug_name=>'Edit Action'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>15
,p_plug_display_point=>'REGION_POSITION_04'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1927189008406310)
,p_plug_name=>'Edit Action'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>35
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>'The Action''s PL/SQL code will be executed once for each row, which the automation query returns. Bind variables can be used to reference column values from the automation query.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1936683460374337)
,p_plug_name=>'Send Email Settings'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>35
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3704459976120823)
,p_plug_name=>'Placeholders Grid'
,p_parent_plug_id=>wwv_flow_imp.id(1936683460374337)
,p_region_template_options=>'#DEFAULT#:js-dialog-size720x480'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(557449278618308550)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select seq_id,',
'       c001 placeholder,',
'       c002 value',
'  from wwv_flow_collections',
' where collection_name = ''P7022_EMAIL_PLACEHOLDER_COLL''',
'   and :P7022_ACTION_TYPE = ''NATIVE_SEND_EMAIL''',
'   and :P7022_EMAIL_TEMPLATE_ID is not null'))
,p_plug_source_type=>'NATIVE_IG'
,p_ajax_items_to_submit=>'P7022_EMAIL_TEMPLATE_ID,P7022_ACTION_TYPE'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Placeholders Grid'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3704944171120828)
,p_name=>'PLACEHOLDER'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'PLACEHOLDER'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Placeholder'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>40
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_max_length=>4000
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3705010549120829)
,p_name=>'VALUE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'VALUE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Column or Value'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>50
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3705148834120830)
,p_name=>'APEX$ROW_ACTION'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>20
,p_use_as_row_header=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3705213310120831)
,p_name=>'APEX$ROW_SELECTOR'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_use_as_row_header=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3705605985120835)
,p_name=>'SEQ_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'SEQ_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>60
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(3704544776120824)
,p_internal_uid=>3704544776120824
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_add_row_if_empty=>false
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>false
,p_no_data_found_message=>'No Placeholders defined.'
,p_show_toolbar=>true
,p_toolbar_buttons=>'SAVE'
,p_add_button_label=>'Add Placeholder'
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>false
,p_define_chart_view=>false
,p_enable_download=>false
,p_download_formats=>null
,p_enable_mail_download=>true
,p_fixed_header=>'REGION'
,p_fixed_header_max_height=>380
,p_show_icon_view=>false
,p_show_detail_view=>false
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function( options ) {',
'    options.initialSelection = false;',
'    return options;',
'}',
''))
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(5105010913042482)
,p_interactive_grid_id=>wwv_flow_imp.id(3704544776120824)
,p_static_id=>'51051'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(5105286097042483)
,p_report_id=>wwv_flow_imp.id(5105010913042482)
,p_view_type=>'GRID'
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5110691637062094)
,p_view_id=>wwv_flow_imp.id(5105286097042483)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(3704944171120828)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5111522471062099)
,p_view_id=>wwv_flow_imp.id(5105286097042483)
,p_display_seq=>4
,p_column_id=>wwv_flow_imp.id(3705010549120829)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5114361703066049)
,p_view_id=>wwv_flow_imp.id(5105286097042483)
,p_display_seq=>0
,p_column_id=>wwv_flow_imp.id(3705148834120830)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(5117889028077502)
,p_view_id=>wwv_flow_imp.id(5105286097042483)
,p_display_seq=>5
,p_column_id=>wwv_flow_imp.id(3705605985120835)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5817463665534536)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>25
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(348707341969499917)
,p_plug_name=>'Action Settings'
,p_region_name=>'PLUGIN'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="color:#FFFFFF;display:none;"'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>25
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3704015479120819)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_imp.id(1936683460374337)
,p_button_name=>'SET_PLACEHOLDERS'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Set Placeholder Values'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_button_cattributes=>'style="margin-top:8px"'
,p_grid_new_row=>'N'
,p_grid_column=>8
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1735507194290740)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1734379323290728)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:7021:&SESSION.::&DEBUG.:7022:P7021_ID:&P7022_AUTOMATION_ID.'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1735615488290741)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1734379323290728)
,p_button_name=>'DELETE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P7022_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1734085091290725)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(1734379323290728)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>'P7022_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1734148271290726)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(1734379323290728)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P7022_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1805022861591818)
,p_branch_name=>'Back to 7021'
,p_branch_action=>'f?p=&APP_ID.:7021:&SESSION.::&DEBUG.:7022:P7021_ID:&P7022_AUTOMATION_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1400711910572550)
,p_name=>'P7022_CONDITION_LANG'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(1733554992290720)
,p_prompt=>'Language'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select a language that is used to evaluate the entered programming code.'
,p_attribute_03=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1403594152592939)
,p_name=>'P7022_CONDITION_CHECK'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(1733554992290720)
,p_prompt=>'Do not validate code (parse at runtime only).'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1409356763910720)
,p_name=>'P7022_ACTION_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(1410170163910728)
,p_item_source_plug_id=>wwv_flow_imp.id(1410170163910728)
,p_item_default=>'NATIVE_PLSQL'
,p_prompt=>'Type'
,p_source=>'ACTION_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,',
'       r',
'  from (',
'         select wwv_flow_lang.system_message(''PROCESS.''|| name_with_prefix) as d,',
'               name_with_prefix as r',
'          from wwv_flow_native_plugins',
'         where plugin_type               = ''PROCESS TYPE''',
'           and supported_component_types like ''%APEX_APPL_AUTOMATION_ACTIONS%''',
'           and ( ( select wwv_flow_f4000_util.is_cloud',
'                     from sys.dual ) = ''Y''',
'                  or name != ''GEOCODING'' )',
'         union all',
'        select display_name || wwv_flow_lang.system_message(''PLUGIN.DISPLAY_NAME_POSTFIX'') as d,',
'               ''PLUGIN_'' || name     as r',
'          from wwv_flow_plugins',
'         where flow_id                   = to_number(:FB_FLOW_ID)',
'           and security_group_id         = to_number(:WORKSPACE_ID)',
'           and plugin_type               = ''PROCESS TYPE''',
'           and supported_component_types like ''%APEX_APPL_AUTOMATION_ACTIONS%''',
'       )',
' order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the type of action.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1409543908910722)
,p_name=>'P7022_REMOTE_PLSQL_CODE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(90116067165448609)
,p_prompt=>'PL/SQL Code (executes at the REST Enabled SQL Service)'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>10
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Provide the PL/SQL code to be executed. Column values from the automation query are available as bind variables, by column name, for example <strong>:EMPNO</strong>, <strong>:ENAME</strong> and so on. Additionally, APEX provides the following, ge'
||'neric bind variables:',
'</p>',
'<ul>',
'    <li><strong>APEX$AUTOMATION_ROW_PK</strong>: If a primary key column has been defined, this bind variable contains the primary key value.</li>',
'    <li><strong>APEX$AUTOMATION_ROW_NUM</strong>: For automations based on a query, this bind variable contains the current row number.</li>',
'    <li><strong>APEX$AUTOMATION_ERROR_ROWS</strong>: For automations based on a query, this bind variable contains the number of rows where the actions raised errors.</li>',
'    <li><strong>APEX$AUTOMATION_LASTRUN_ISO</strong>: Contains the timestamp of the <em>previous</em> automation run, in the <strong>YYYY-MM-DD"T"HH24:MI:SS.FF3TZH:TZM</strong> format.</li>        ',
'</ul>',
'<p style="padding-top: 10px">',
'    Note that the <strong>APEX_AUTOMATION</strong> package might not be available on the REST Enabled SQL service. For adding messages to the execution log (<strong>LOG_WARN</strong>, <strong>LOG_INFO</strong>, <strong>LOG_ERROR</strong>), create <em'
||'>another</em> Action being executed on the <em>Local Database.</em>',
'</p>'))
,p_attribute_01=>'PLSQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_05=>'P7022_REMOTE_SERVER_ID'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1409907400910726)
,p_name=>'P7022_NAME'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(1410170163910728)
,p_item_source_plug_id=>wwv_flow_imp.id(1410170163910728)
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter a name for the automation action.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1410334092910730)
,p_name=>'P7022_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1410170163910728)
,p_item_source_plug_id=>wwv_flow_imp.id(1410170163910728)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1410699192910733)
,p_name=>'P7022_AUTOMATION_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1410170163910728)
,p_item_source_plug_id=>wwv_flow_imp.id(1410170163910728)
,p_source=>'AUTOMATION_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1410817116910735)
,p_name=>'P7022_EXECUTION_SEQUENCE'
,p_source_data_type=>'NUMBER'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(1410170163910728)
,p_item_source_plug_id=>wwv_flow_imp.id(1410170163910728)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ceil( ( max( execution_sequence ) + 1 ) / 10 ) * 10',
'  from wwv_flow_automation_actions',
' where automation_id     = :P7022_AUTOMATION_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_item_default_type=>'SQL_QUERY'
,p_prompt=>'Execution Sequence'
,p_source=>'EXECUTION_SEQUENCE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>5
,p_cMaxlength=>5
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Specify the execution sequence. Higher numbers will be executed after lower numbers.'
,p_attribute_01=>'0'
,p_attribute_03=>'right'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1567511807713206)
,p_name=>'P7022_ACTION_CLOB_LANGUAGE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(90115922532448608)
,p_item_source_plug_id=>wwv_flow_imp.id(1410170163910728)
,p_prompt=>'Language'
,p_source=>'ACTION_CLOB_LANGUAGE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Select a language that is used to evaluate the entered programming code.'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1706926079115518)
,p_name=>'P7022_ATTRIBUTE_01'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(348707341969499917)
,p_item_source_plug_id=>wwv_flow_imp.id(1410170163910728)
,p_source=>'ATTRIBUTE_01'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1707292559115535)
,p_name=>'P7022_ATTRIBUTE_02'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(348707341969499917)
,p_item_source_plug_id=>wwv_flow_imp.id(1410170163910728)
,p_source=>'ATTRIBUTE_02'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1707644450115535)
,p_name=>'P7022_ATTRIBUTE_03'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(348707341969499917)
,p_item_source_plug_id=>wwv_flow_imp.id(1410170163910728)
,p_source=>'ATTRIBUTE_03'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1708053886115535)
,p_name=>'P7022_ATTRIBUTE_04'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(348707341969499917)
,p_item_source_plug_id=>wwv_flow_imp.id(1410170163910728)
,p_source=>'ATTRIBUTE_04'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1708485452115536)
,p_name=>'P7022_ATTRIBUTE_05'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(348707341969499917)
,p_item_source_plug_id=>wwv_flow_imp.id(1410170163910728)
,p_source=>'ATTRIBUTE_05'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1708847040115536)
,p_name=>'P7022_ATTRIBUTE_06'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(348707341969499917)
,p_item_source_plug_id=>wwv_flow_imp.id(1410170163910728)
,p_source=>'ATTRIBUTE_06'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1709227594115536)
,p_name=>'P7022_ATTRIBUTE_07'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(348707341969499917)
,p_item_source_plug_id=>wwv_flow_imp.id(1410170163910728)
,p_source=>'ATTRIBUTE_07'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1709653251115537)
,p_name=>'P7022_ATTRIBUTE_08'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(348707341969499917)
,p_item_source_plug_id=>wwv_flow_imp.id(1410170163910728)
,p_source=>'ATTRIBUTE_08'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1710048534115538)
,p_name=>'P7022_ATTRIBUTE_09'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(348707341969499917)
,p_item_source_plug_id=>wwv_flow_imp.id(1410170163910728)
,p_source=>'ATTRIBUTE_09'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1710435123115538)
,p_name=>'P7022_ATTRIBUTE_10'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(348707341969499917)
,p_item_source_plug_id=>wwv_flow_imp.id(1410170163910728)
,p_source=>'ATTRIBUTE_10'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1710818746115538)
,p_name=>'P7022_ATTRIBUTE_11'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(348707341969499917)
,p_item_source_plug_id=>wwv_flow_imp.id(1410170163910728)
,p_source=>'ATTRIBUTE_11'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1711265457115539)
,p_name=>'P7022_ATTRIBUTE_12'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(348707341969499917)
,p_item_source_plug_id=>wwv_flow_imp.id(1410170163910728)
,p_source=>'ATTRIBUTE_12'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1711699180115540)
,p_name=>'P7022_ATTRIBUTE_13'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(348707341969499917)
,p_item_source_plug_id=>wwv_flow_imp.id(1410170163910728)
,p_source=>'ATTRIBUTE_13'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1712058068115543)
,p_name=>'P7022_ATTRIBUTE_14'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(348707341969499917)
,p_item_source_plug_id=>wwv_flow_imp.id(1410170163910728)
,p_source=>'ATTRIBUTE_14'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1712489517115543)
,p_name=>'P7022_ATTRIBUTE_15'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_imp.id(348707341969499917)
,p_item_source_plug_id=>wwv_flow_imp.id(1410170163910728)
,p_source=>'ATTRIBUTE_15'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1731838233290703)
,p_name=>'P7022_LOCATION'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1409470037910721)
,p_item_source_plug_id=>wwv_flow_imp.id(1410170163910728)
,p_item_default=>'LOCAL'
,p_prompt=>'Location'
,p_source=>'LOCATION'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXEC_SQL_LOCATIONS'
,p_lov=>'.'||wwv_flow_imp.id(601110993871808630)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify whether your PL/SQL code is to be executed in the <em>Local Database</em> or on a <em>REST Enabled SQL Service</em>.'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1731977565290704)
,p_name=>'P7022_REMOTE_SERVER_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(90116067165448609)
,p_item_source_plug_id=>wwv_flow_imp.id(1410170163910728)
,p_prompt=>'REST Enabled SQL Reference'
,p_source=>'REMOTE_SERVER_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REMOTE_SQL_ORACLE_SERVERS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_remote_servers',
' where server_type = ''REMOTE_SQL''',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and remote_sql_database_type = ''ORACLE'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Pick the REST Enabled SQL service to execute the PL/SQL code on.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1732231184290707)
,p_name=>'P7022_ERROR_MESSAGE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(1733465727290719)
,p_item_source_plug_id=>wwv_flow_imp.id(1410170163910728)
,p_prompt=>'Error Message'
,p_source=>'ERROR_MESSAGE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter an error message to be written to the automation log when the processing fails. Use #SQLERRM# as a placeholder for the actual ORA error message.'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1732309344290708)
,p_name=>'P7022_STOP_EXECUTION_ON_ERROR'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(1733465727290719)
,p_item_source_plug_id=>wwv_flow_imp.id(1410170163910728)
,p_item_default=>'Y'
,p_prompt=>'Stop Execution On Error'
,p_source=>'STOP_EXECUTION_ON_ERROR'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enable when processing for the current row should stop on error. Subsequent actions will not be processed in this case.'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1732420639290709)
,p_name=>'P7022_CONDITION_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(1733554992290720)
,p_item_source_plug_id=>wwv_flow_imp.id(1410170163910728)
,p_prompt=>'Condition Type'
,p_source=>'CONDITION_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CONDITION_LIST'
,p_named_lov=>'STANDARD_CONDITION_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(13602414170805697)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Condition Type -'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select a condition type from the list that must be met in order for this action to be executed.',
'',
''))
,p_attribute_01=>'P7022_CONDITION_EXPR1'
,p_attribute_02=>'P7022_CONDITION_EXPR2'
,p_attribute_04=>'P7022_CONDITION_CHECK'
,p_attribute_05=>'P7022_EXEC_COND_FOR_EACH_ROW'
,p_attribute_06=>'ACTION'
,p_attribute_07=>'P7022_CONDITION_LANG'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1732505426290710)
,p_name=>'P7022_CONDITION_EXPR1'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(1733554992290720)
,p_item_source_plug_id=>wwv_flow_imp.id(1410170163910728)
,p_prompt=>'Expression 1'
,p_source=>'CONDITION_EXPR1'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>6
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'This attribute allows you to conditionally control the circumstances under which this action will be executed.  Enter values in this attribute based on the specific condition type selected.  The action will execute only if the specified condition is '
||'met.'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1732633499290711)
,p_name=>'P7022_CONDITION_EXPR2'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(1733554992290720)
,p_item_source_plug_id=>wwv_flow_imp.id(1410170163910728)
,p_prompt=>'Expression 2'
,p_source=>'CONDITION_EXPR2'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>6
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Some condition types require two expressions for comparison.  Enter the second expression or item here.'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1732712865290712)
,p_name=>'P7022_EXEC_COND_FOR_EACH_ROW'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(1733554992290720)
,p_item_source_plug_id=>wwv_flow_imp.id(1410170163910728)
,p_item_default=>'Y'
,p_prompt=>'Execute For Each Row'
,p_source=>'EXEC_COND_FOR_EACH_ROW'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'<p>Specify whether the condition is to be executed for each row or only once.</p>'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1732811511290713)
,p_name=>'P7022_BUILD_OPTION_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(1733611964290721)
,p_item_source_plug_id=>wwv_flow_imp.id(1410170163910728)
,p_prompt=>'Build Option'
,p_source=>'BUILD_OPTION_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PATCHES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(patch_name) pn, id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'', wwv_flow_escape.html(patch_name))||',
'''} '' pn,0-id id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by pn'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Build Option - '
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select a build option for this action.</p>',
'<p>Build options are predefined settings that determine whether or not components within an application are enabled.</p>'))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1732940692290714)
,p_name=>'P7022_ACTION_COMMENT'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(1733611964290721)
,p_item_source_plug_id=>wwv_flow_imp.id(1410170163910728)
,p_prompt=>'Comments'
,p_source=>'ACTION_COMMENT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>6
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter any developer comments or notes here. These comments only display within App Builder and never display when running the application.'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_item_comment=>'Enter any developer comments or notes here. These comments only display within App Builder and never display when running the application.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1736536337290750)
,p_name=>'P7022_LOCAL_CODE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(90115922532448608)
,p_prompt=>'Code'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>10
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Provide the PL/SQL code to be executed. Column values from the automation query are available as bind variables, by column name, for example <strong>:EMPNO</strong>, <strong>:ENAME</strong> and so on. Additionally, &PRODUCT_NAME. provides the fol'
||'lowing generic bind variables:',
'</p>',
'<ul>',
'    <li><strong>APEX$AUTOMATION_ROW_PK</strong>: If a primary key column has been defined, this bind variable contains the primary key value.</li>',
'    <li><strong>APEX$AUTOMATION_ROW_NUM</strong>: For automations based on a query, this bind variable contains the current row number.</li>',
'    <li><strong>APEX$AUTOMATION_ERROR_ROWS</strong>: For automations based on a query, this bind variable contains the number of rows, where at least the one of the actions raised errors.</li>',
'    <li><strong>APEX$AUTOMATION_LASTRUN_ISO</strong>: Contains the timestamp of the <em>previous</em> automation run, in the <strong>YYYY-MM-DD"T"HH24:MI:SS.FF3TZH:TZM</strong> format.</li>        ',
'</ul>',
'<p>',
'    ',
'</p>',
'<p>',
'    To write messages to the execution log, use the <strong>LOG_INFO</strong>, <strong>LOG_WARN</strong>, or <strong>LOG_ERROR</strong> procedures in the <strong>APEX_AUTOMATION</strong> package.',
'</p>'))
,p_attribute_01=>'PLSQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1803598788591803)
,p_name=>'P7022_CODE'
,p_source_data_type=>'CLOB'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1409470037910721)
,p_item_source_plug_id=>wwv_flow_imp.id(1410170163910728)
,p_source=>'ACTION_CLOB'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1804727916591815)
,p_name=>'P7022_FLOW_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1410170163910728)
,p_item_source_plug_id=>wwv_flow_imp.id(1410170163910728)
,p_source=>'FLOW_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1937001282374341)
,p_name=>'P7022_EMAIL_FROM'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1936683460374337)
,p_item_default=>'''&''||''APP_EMAIL.'''
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'From'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>65
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Enter the email address to display as the sender of the email. This email address must be a valid address. Otherwise, the message will not be sent. Use substitution syntax if you want to use a dynamic value.',
'</p>',
'<ul>',
'<li><code>noreply@test.com</code></li>',
'<li><code>Do not reply &lt;noreply@test.com&gt;</code></li>',
'<li><code>&amp;P6_FROM.</code></li>',
'</ul>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1937161460374342)
,p_name=>'P7022_EMAIL_TO'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1936683460374337)
,p_prompt=>'To'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>65
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Enter the email recipients by specifying one or more email addresses. For multiple email addresses, use a comma-separated list. Use substitution syntax if you want to use a dynamic value.</p>',
'<ul>',
'<li><code>john.doe@test.com, jane.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;, Jane Doe &lt;jane.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_TO.</code></li>',
'</ul>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1937213913374343)
,p_name=>'P7022_EMAIL_CC'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1936683460374337)
,p_prompt=>'Cc'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>65
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Enter the carbon copy email recipients by specifying one or more email addresses. For multiple email addresses, use a comma-separated list. Use substitution syntax if you want to use a dynamic value.',
'</p>',
'<ul>',
'<li><code>john.doe@test.com, jane.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;, Jane Doe &lt;jane.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_CC.</code></li>',
'</ul>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1937358335374344)
,p_name=>'P7022_EMAIL_BCC'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(1936683460374337)
,p_prompt=>'Bcc'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>65
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Enter the blind carbon copy email recipients by specifying one or more email addresses. For multiple email addresses, use a comma-separated list. Use substitution syntax if you want to use a dynamic value.',
'</p>',
'<ul>',
'<li><code>john.doe@test.com, jane.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;, Jane Doe &lt;jane.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_BCC.</code></li>',
'</ul>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1937411156374345)
,p_name=>'P7022_EMAIL_REPLYTO'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(1936683460374337)
,p_prompt=>'Reply To'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>65
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Enter the email address replies should be sent to. If not specified the e-mail address entered in <strong>From</strong> will be used. Use substitution syntax if you want to use a dynamic value.</p>',
'<ul>',
'<li><code>john.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_REPLY_TO.</code></li>',
'</ul>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1937527798374346)
,p_name=>'P7022_EMAIL_TEMPLATE_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(1936683460374337)
,p_prompt=>'Email Template'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name,',
'       id',
'  from wwv_flow_email_templates',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID',
' order by name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Template -'
,p_cHeight=>1
,p_colspan=>7
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'YES'
,p_help_text=>'Choose an email template. Use the <strong>Set Placeholder Values</strong> button to assign column or static values to the Email template placeholders. To assign a column value, use substitution syntax, for example <code>&amp;COLUMN_NAME.<code>'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1937602033374347)
,p_name=>'P7022_EMAIL_PLACEHOLDERS'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(1936683460374337)
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Template placeholder names along with the values, to be substituted. Internally stored as a JSON string.'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1937708719374348)
,p_name=>'P7022_EMAIL_LANG_OVERRIDE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(1936683460374337)
,p_prompt=>'Language Override'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>65
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>If a language code is specified, the process will look up the template from an application translation for this language. If no translation exists, the process uses the primary language of the application. Substitution syntax is supported.</p>',
'<p>Language code hierarchy is supported. If a value of "fr-ca" (French - Canada) is specified, but only a translation for "fr" (french) exists, this translation is being used.</p>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1937828893374349)
,p_name=>'P7022_EMAIL_SUBJECT'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(1936683460374337)
,p_prompt=>'Subject'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>120
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the subject of the e-mail. Use substitution syntax, such as <code>&amp;P6_PRODUCT_NAME.</code>, if you want to include a dynamic value.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1937960503374350)
,p_name=>'P7022_EMAIL_BODY_TEXT'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(1936683460374337)
,p_prompt=>'Body Plain Text'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>65
,p_cMaxlength=>4000
,p_cHeight=>8
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the text of the e-mail. The plain text version is used if the recipient&#39;s e-mail client does not support rich text display. Use substitution syntax, such as <code>&amp;P6_PRODUCT_NAME.</code>, if you want to include dynamic content in yo'
||'ur text.</p>',
'<p><em>Note: The SMTP/MIME specification dictates that no single line shall exceed 1000 characters. To comply with this restriction, you must add a carriage return or line feed characters to break your text into chunks of 1000 characters or less. Fai'
||'ling to do so will result in erroneous email messages, including partial messages or messages with extraneous exclamation points.</em></p>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3702247340120801)
,p_name=>'P7022_EMAIL_BODY_HTML'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(1936683460374337)
,p_prompt=>'Body HTML'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>8
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter text that yields a multi-part HTML message, including both plain text and HTML content. The settings and capabilities of the recipient&#39;s email client will determine what displays. Although most modern email clients can read an HTML forma'
||'tted email, remember that some users disable this functionality to address security issues. Use substitution syntax, such as <code>&amp;P6_PRODUCT_NAME.</code>, if you want to include dynamic content in the text.</p>',
'<p>When referencing images using the &lt;img /&gt; tag, remember that the images must be accessible to the recipient&#39;s email client in order for them to see the image. For example, suppose you reference an image on your network called hello.gif a'
||'s follows:</p>',
'<pre>',
'&lt;img src=&quot;http://example.com/hello.gif&quot; alt=&quot;Hello&quot; /&gt;',
'</pre>',
'<p>In this example, the image is not attached to the email, but is referenced by the email. For the recipient to see it, they must be able to access the image using a Web browser. If the image is inside a firewall and the recipient is outside of the '
||'firewall, the image will not display. For this reason, avoid using images. If you must include images, be sure to include the ALT attribute to provide a textual description in the event the image is not accessible.</p>',
'<p><em>Note: The SMTP/MIME specification dictates that no single line shall exceed 1000 characters. To comply with this restriction, you must add a carriage return or line feed characters to break your text into chunks of 1000 characters or less. Fai'
||'ling to do so will result in erroneous email messages, including partial messages or messages with extraneous exclamation points.</em></p>'))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3702317872120802)
,p_name=>'P7022_EMAIL_ATTACH_QUERY'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(1936683460374337)
,p_prompt=>'Attachment SQL'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>65
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a SQL statement which returns one or more BLOBs that are attached as files to the e-mail.</p>',
'<p>If the content_id column contains a null value then the associated files will be regular attachments. Files such as documents or zip archives are generally attached in this way.</p>',
'<p>If the value of the content_id is non-null then the associated file will be marked as being attached inline. The value of the content_id column will be used as the CID (Content ID) of the attachment. This CID value can be used in the HTML code of '
||'the email in order to embed images directly within the email content. Note that some email clients may not automatically display inline attachments. Also note that email standards dictate various requirements for the format of content identifiers. Or'
||'acle &PRODUCT_NAME. does not enforce compliance with these standards.</p>',
'<p></p>',
'<p>The SQL statement must be in the following format:</p>',
'<pre>',
'select blob_column,',
'       file_name,',
'       mime_type,',
'       content_id',
'  from table',
'</pre>',
'<p>The columns mime_type and content_id are optional. If content_id is present then the file will be attached inline and the value of content_id will be used for the attachment''s CID.</p>',
'<p>If the content_id column contains the value ''my_inline_content'' then that image may be embedded within the email using the following HTML:</p>',
'<p>',
'<pre>',
'&lt;div&gt;',
'&nbsp;&nbsp;&lt;h1&gt;Some Embedded Content&lt;/h1&gt;',
'&nbsp;&nbsp;&lt;p&gt;',
'&nbsp;&nbsp;&nbsp;&nbsp;&lt;img src="cid:my_inline_content" alt="Inline Image" &gt;',
'&nbsp;&nbsp;&lt;/p&gt;',
'&lt;/div&gt;',
'</pre>',
'</p>'))
,p_attribute_01=>'SQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(108345209529984210)
,p_computation_sequence=>10
,p_computation_item=>'P7022_REMOTE_SERVER_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P7022_LOCATION'
,p_compute_when_text=>'LOCAL'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1736036609290745)
,p_computation_sequence=>10
,p_computation_item=>'P7022_LOCATION'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'LOCAL'
,p_compute_when=>'P7022_LOCATION'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1804863853591816)
,p_computation_sequence=>20
,p_computation_item=>'P7022_FLOW_ID'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'FB_FLOW_ID'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1501304193184401)
,p_computation_sequence=>30
,p_computation_item=>'P7022_EXEC_COND_FOR_EACH_ROW'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'Y'
,p_compute_when=>'P7022_EXEC_COND_FOR_EACH_ROW'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1736409816290749)
,p_validation_name=>'Validate Remote PL/SQL Code'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    return wwv_flow_exec_dev.check_code (',
'               p_location         => ''REMOTE'',',
'               p_remote_server_id => :P7022_REMOTE_SERVER_ID,',
'               p_code             => :P7022_CODE,',
'               p_language         => wwv_flow_code_exec.c_plsql );',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':REQUEST in (''APPLY_CHANGES'',''CREATE'') and :P7022_ACTION_TYPE = wwv_flow_process_native.c_plsql and :P7022_LOCATION = ''REMOTE'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(1409543908910722)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1804033152591808)
,p_validation_name=>'Validate Local Code'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    return wwv_flow_code_exec_dev.check_code (',
'               p_code     => :P7022_CODE,',
'               p_language => :P7022_ACTION_CLOB_LANGUAGE );',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':REQUEST in (''APPLY_CHANGES'',''CREATE'') and :P7022_ACTION_TYPE = wwv_flow_process_native.c_plsql and :P7022_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(1736536337290750)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1804381817591811)
,p_validation_name=>'Code is required'
,p_validation_sequence=>30
,p_validation=>'P7022_CODE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'PL/SQL Code is required'
,p_validation_condition=>':REQUEST in (''CREATE'', ''APPLY_CHANGES'' ) and :P7022_ACTION_TYPE = wwv_flow_process_native.c_plsql'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3703533064120814)
,p_validation_name=>'Email Subject is required'
,p_validation_sequence=>40
,p_validation=>'P7022_EMAIL_SUBJECT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST              in (''APPLY_CHANGES'',''CREATE'') and ',
':P7022_ACTION_TYPE     = ''NATIVE_SEND_EMAIL''        and',
':P7022_EMAIL_TEMPLATE_ID is null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(1937828893374349)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3706972053120848)
,p_validation_name=>'Email From is required'
,p_validation_sequence=>50
,p_validation=>'P7022_EMAIL_FROM'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST              in (''APPLY_CHANGES'',''CREATE'') and ',
':P7022_ACTION_TYPE     = ''NATIVE_SEND_EMAIL'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(1937001282374341)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3707027010120849)
,p_validation_name=>'Email To is required'
,p_validation_sequence=>60
,p_validation=>'P7022_EMAIL_TO'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST              in (''APPLY_CHANGES'',''CREATE'') and ',
':P7022_ACTION_TYPE     = ''NATIVE_SEND_EMAIL'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(1937161460374342)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3703640637120815)
,p_validation_name=>'Email Body Plain Text is required'
,p_validation_sequence=>70
,p_validation=>'P7022_EMAIL_BODY_TEXT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST              in (''APPLY_CHANGES'',''CREATE'') and ',
':P7022_ACTION_TYPE     = ''NATIVE_SEND_EMAIL''        and',
':P7022_EMAIL_TEMPLATE_ID is null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(1937960503374350)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3703883833120817)
,p_validation_name=>'Email Placeholders are valid JSON'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_values wwv_flow_json.t_values;',
'begin',
'    wwv_flow_json.parse(',
'        p_values => l_values,',
'        p_source => coalesce( :P7022_EMAIL_PLACEHOLDERS, ''{}'' ) );',
'',
'    return true;',
'exception',
'    when others then',
'        return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'#LABEL# is not a valid JSON object.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST              in (''APPLY_CHANGES'',''CREATE'') and ',
':P7022_ACTION_TYPE     = ''NATIVE_SEND_EMAIL''        and',
':P7022_EMAIL_TEMPLATE_ID is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(1937602033374347)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1409669859910723)
,p_name=>'Execute Code'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7022_ACTION_TYPE'
,p_condition_element=>'P7022_ACTION_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NATIVE_PLSQL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1409764006910724)
,p_event_id=>wwv_flow_imp.id(1409669859910723)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1409470037910721)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1735392609290738)
,p_event_id=>wwv_flow_imp.id(1409669859910723)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1409470037910721)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1733756061290722)
,p_name=>'REST Enabled SQL Reference'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7022_LOCATION'
,p_condition_element=>'P7022_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REMOTE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(90116420313448613)
,p_event_id=>wwv_flow_imp.id(1733756061290722)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(90115922532448608)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1733838030290723)
,p_event_id=>wwv_flow_imp.id(1733756061290722)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(90116067165448609)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(90116331048448612)
,p_event_id=>wwv_flow_imp.id(1733756061290722)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(90116067165448609)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1803309431591801)
,p_event_id=>wwv_flow_imp.id(1733756061290722)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(90115922532448608)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1735719758290742)
,p_name=>'Confirm'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1735615488290741)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1735823568290743)
,p_event_id=>wwv_flow_imp.id(1735719758290742)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'Do you really want to delete this action?'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1735943089290744)
,p_event_id=>wwv_flow_imp.id(1735719758290742)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'DELETE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(90116530888448614)
,p_name=>'Remote Server Chosen'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7022_REMOTE_SERVER_ID'
,p_condition_element=>'P7022_REMOTE_SERVER_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(90116629180448615)
,p_event_id=>wwv_flow_imp.id(90116530888448614)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7022_REMOTE_PLSQL_CODE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(90116710734448616)
,p_event_id=>wwv_flow_imp.id(90116530888448614)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7022_REMOTE_PLSQL_CODE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1936307267374334)
,p_name=>'Send Email'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7022_ACTION_TYPE'
,p_condition_element=>'P7022_ACTION_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NATIVE_SEND_EMAIL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1936452688374335)
,p_event_id=>wwv_flow_imp.id(1936307267374334)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(348707341969499917)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1936805327374339)
,p_event_id=>wwv_flow_imp.id(1936307267374334)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1936683460374337)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1936583392374336)
,p_event_id=>wwv_flow_imp.id(1936307267374334)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(348707341969499917)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1936774874374338)
,p_event_id=>wwv_flow_imp.id(1936307267374334)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1936683460374337)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3702516007120804)
,p_name=>'Email Template chosen'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7022_EMAIL_TEMPLATE_ID'
,p_condition_element=>'P7022_EMAIL_TEMPLATE_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3702629436120805)
,p_event_id=>wwv_flow_imp.id(3702516007120804)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7022_EMAIL_PLACEHOLDERS,P7022_EMAIL_LANG_OVERRIDE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3702742207120806)
,p_event_id=>wwv_flow_imp.id(3702516007120804)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7022_EMAIL_PLACEHOLDERS,P7022_EMAIL_LANG_OVERRIDE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3706534848120844)
,p_event_id=>wwv_flow_imp.id(3702516007120804)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(3704015479120819)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3706613462120845)
,p_event_id=>wwv_flow_imp.id(3702516007120804)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(3704015479120819)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3702861461120807)
,p_event_id=>wwv_flow_imp.id(3702516007120804)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7022_EMAIL_SUBJECT,P7022_EMAIL_BODY_TEXT,P7022_EMAIL_BODY_HTML'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3702969573120808)
,p_event_id=>wwv_flow_imp.id(3702516007120804)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7022_EMAIL_SUBJECT,P7022_EMAIL_BODY_TEXT,P7022_EMAIL_BODY_HTML'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3703175773120810)
,p_event_id=>wwv_flow_imp.id(3702516007120804)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7022_EMAIL_PLACEHOLDERS,P7022_EMAIL_LANG_OVERRIDE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3706706670120846)
,p_event_id=>wwv_flow_imp.id(3702516007120804)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$s("P7022_EMAIL_SUBJECT", "");',
'$s("P7022_EMAIL_BODY_TEXT", "");',
'$s("P7022_EMAIL_BODY_HTML","");'))
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3703030757120809)
,p_event_id=>wwv_flow_imp.id(3702516007120804)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7022_EMAIL_PLACEHOLDERS'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_template_dev.add_new_placeholders(',
'           p_application_id    => :FB_FLOW_ID,',
'           p_email_template_id => :P7022_EMAIL_TEMPLATE_ID,',
'           p_placeholder_json  => :P7022_EMAIL_PLACEHOLDERS );'))
,p_attribute_07=>'P7022_EMAIL_TEMPLATE_ID,P7022_EMAIL_PLACEHOLDERS'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3704156927120820)
,p_name=>'Open Placeholders dialog'
,p_event_sequence=>70
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(3704015479120819)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3704380215120822)
,p_event_id=>wwv_flow_imp.id(3704156927120820)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_template_dev.placeholders_to_collection(',
'    p_placeholder_json => :P7022_EMAIL_PLACEHOLDERS,',
'    p_collection_name  => ''P7022_EMAIL_PLACEHOLDER_COLL'' );'))
,p_attribute_02=>'P7022_EMAIL_PLACEHOLDERS,P7022_EMAIL_TEMPLATE_ID'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3704834447120827)
,p_event_id=>wwv_flow_imp.id(3704156927120820)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3704459976120823)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3704206259120821)
,p_event_id=>wwv_flow_imp.id(3704156927120820)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3704459976120823)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3706079552120839)
,p_name=>'Save Placeholders: Copy Placeholders from to Item (JSON)'
,p_event_sequence=>80
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(3704459976120823)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'NATIVE_IG|REGION TYPE|interactivegridsave'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3706133162120840)
,p_event_id=>wwv_flow_imp.id(3706079552120839)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P7022_EMAIL_PLACEHOLDERS := wwv_flow_template_dev.placeholders_from_collection(',
'                                 p_collection_name => ''P7022_EMAIL_PLACEHOLDER_COLL'' );'))
,p_attribute_03=>'P7022_EMAIL_PLACEHOLDERS'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3706280109120841)
,p_event_id=>wwv_flow_imp.id(3706079552120839)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLOSE_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3704459976120823)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1501640651184404)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Adjust Condition for each row'
,p_process_sql_clob=>':P7022_EXEC_COND_FOR_EACH_ROW := case when :P7022_CONDITION_TYPE is null then null else :P7022_EXEC_COND_FOR_EACH_ROW end;'
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'APPLY_CHANGES:CREATE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_internal_uid=>1501640651184404
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1735408536290739)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(1410170163910728)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process form Action'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Action processed.'
,p_internal_uid=>1735408536290739
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1804231622591810)
,p_process_sequence=>10
,p_process_point=>'BEFORE_BOX_BODY'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load "Load and Remote" Code'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P7022_LOCATION = wwv_flow_exec_api.c_location_local_db then',
'    :P7022_LOCAL_CODE := :P7022_CODE;',
'else',
'    :P7022_REMOTE_PLSQL_CODE := :P7022_CODE;',
'end if;',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>1804231622591810
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3703409029120813)
,p_process_sequence=>20
,p_process_point=>'BEFORE_BOX_BODY'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Send Email Attributes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  :P7022_EMAIL_FROM            := :P7022_ATTRIBUTE_01;',
'  :P7022_EMAIL_TO              := :P7022_ATTRIBUTE_02;',
'  :P7022_EMAIL_CC              := :P7022_ATTRIBUTE_03;',
'  :P7022_EMAIL_BCC             := :P7022_ATTRIBUTE_04;',
'  :P7022_EMAIL_REPLYTO         := :P7022_ATTRIBUTE_05;',
'  :P7022_EMAIL_SUBJECT         := :P7022_ATTRIBUTE_06;',
'  :P7022_EMAIL_BODY_TEXT       := :P7022_ATTRIBUTE_07;',
'  :P7022_EMAIL_BODY_HTML       := :P7022_ATTRIBUTE_08;',
'  :P7022_EMAIL_ATTACH_QUERY    := :P7022_ATTRIBUTE_09;',
'  :P7022_EMAIL_TEMPLATE_ID     := :P7022_ATTRIBUTE_11;',
'  :P7022_EMAIL_PLACEHOLDERS    := :P7022_ATTRIBUTE_12;',
'  :P7022_EMAIL_LANG_OVERRIDE   := :P7022_ATTRIBUTE_13;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P7022_ACTION_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'NATIVE_SEND_EMAIL'
,p_internal_uid=>3703409029120813
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1410208284910729)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(1410170163910728)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form WWV_FLOW_AUTOMATION_ACTIONS'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>1410208284910729
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3703228772120811)
,p_process_sequence=>20
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process Send Email Attributes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    :P7022_ATTRIBUTE_01 := :P7022_EMAIL_FROM;',
'    :P7022_ATTRIBUTE_02 := :P7022_EMAIL_TO;',
'    :P7022_ATTRIBUTE_03 := :P7022_EMAIL_CC;',
'    :P7022_ATTRIBUTE_04 := :P7022_EMAIL_BCC;',
'    :P7022_ATTRIBUTE_05 := :P7022_EMAIL_REPLYTO;',
'    :P7022_ATTRIBUTE_06 := :P7022_EMAIL_SUBJECT;',
'    :P7022_ATTRIBUTE_07 := :P7022_EMAIL_BODY_TEXT;',
'    :P7022_ATTRIBUTE_08 := :P7022_EMAIL_BODY_HTML;',
'    :P7022_ATTRIBUTE_09 := :P7022_EMAIL_ATTACH_QUERY;',
'    :P7022_ATTRIBUTE_10 := ''N'';',
'    :P7022_ATTRIBUTE_11 := :P7022_EMAIL_TEMPLATE_ID;',
'    :P7022_ATTRIBUTE_12 := :P7022_EMAIL_PLACEHOLDERS;',
'    :P7022_ATTRIBUTE_13 := :P7022_EMAIL_LANG_OVERRIDE;',
'end;',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':REQUEST in (''APPLY_CHANGES'',''CREATE'') and :P7022_ACTION_TYPE = ''NATIVE_SEND_EMAIL'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>3703228772120811
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1567619929713207)
,p_process_sequence=>30
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Execute Code Items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if :P7022_ACTION_TYPE = wwv_flow_process_native.c_plsql then',
'        if :P7022_LOCATION = wwv_flow_exec_api.c_location_local_db then',
'            :P7022_CODE := :P7022_LOCAL_CODE;',
'        else',
'            :P7022_CODE                 := :P7022_REMOTE_PLSQL_CODE;',
'            :P7022_ACTION_CLOB_LANGUAGE := null;',
'        end if;',
'    else',
'        :P7022_CODE                 := null;',
'        :P7022_ACTION_CLOB_LANGUAGE := null;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>1567619929713207
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3705927437120838)
,p_process_sequence=>40
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_region_id=>wwv_flow_imp.id(3704459976120823)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Copy Placeholders Grid to Collection'
,p_attribute_01=>'PLSQL_CODE'
,p_attribute_04=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    case :APEX$ROW_STATUS',
'    when ''C'' then',
'        :SEQ_ID := wwv_flow_collection.add_member( p_collection_name => ''P7022_EMAIL_PLACEHOLDER_COLL'', p_c001 => :PLACEHOLDER, p_c002 => :VALUE );',
'    when ''U'' then',
'        wwv_flow_collection.update_member( p_collection_name => ''P7022_EMAIL_PLACEHOLDER_COLL'', p_seq => :SEQ_ID, p_c001 => :PLACEHOLDER, p_c002 => :VALUE );',
'    when ''D'' then',
'        wwv_flow_collection.delete_member( p_collection_name => ''P7022_EMAIL_PLACEHOLDER_COLL'', p_seq => :SEQ_ID );',
'    end case;',
'end;'))
,p_attribute_05=>'N'
,p_attribute_06=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':REQUEST is null'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_exec_cond_for_each_row=>'Y'
,p_internal_uid=>3705927437120838
);
end;
/
prompt --application/pages/page_07025
begin
wwv_flow_imp_page.create_page(
 p_id=>7025
,p_name=>'Execution Log'
,p_alias=>'EXECUTION-LOG'
,p_step_title=>'Execution Log'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1926493800406303)
,p_plug_name=>'Clear Automation Log'
,p_region_template_options=>'#DEFAULT#:js-dialog-size480x320'
,p_plug_template=>wwv_flow_imp.id(557449278618308550)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Purge all log entries for the selected automation.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4278350131923238)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_imp.id(2700189206621868)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5817615693534538)
,p_plug_name=>'Execution Log'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select l.id,',
'       a.name automation_name,',
'       l.is_job,',
'       l.status,',
'       l.start_timestamp,',
'       l.end_timestamp,',
'       l.successful_row_count,',
'       l.error_row_count,',
'       l.security_group_id,',
'       (select count(1) from wwv_flow_automation_msg_log where log_id = l.id) msg_count',
'  from wwv_flow_automations a, wwv_flow_automation_log l',
' where a.flow_id = :fb_flow_id',
'   and a.security_group_id = :flow_security_group_id  ',
'   and a.id = l.automation_id',
''))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Execution Log'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(5817715858534539)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'No automation executions logged.'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'ADMIN'
,p_internal_uid=>5817715858534539
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5817884178534540)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3100190697149801)
,p_db_column_name=>'AUTOMATION_NAME'
,p_display_order=>20
,p_column_identifier=>'J'
,p_column_label=>'Automation'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5818073345534542)
,p_db_column_name=>'IS_JOB'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Scheduled'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_column_alignment=>'CENTER'
,p_rpt_named_lov=>wwv_flow_imp.id(84887415298521126)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5818124649534543)
,p_db_column_name=>'STATUS'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Status'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_column_alignment=>'CENTER'
,p_rpt_named_lov=>wwv_flow_imp.id(2000855720872191)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5818268993534544)
,p_db_column_name=>'START_TIMESTAMP'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>'Start Timestamp'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5818394529534545)
,p_db_column_name=>'END_TIMESTAMP'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>'End Timestamp'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5818430301534546)
,p_db_column_name=>'SUCCESSFUL_ROW_COUNT'
,p_display_order=>70
,p_column_identifier=>'G'
,p_column_label=>'Successful Rows'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5818533192534547)
,p_db_column_name=>'ERROR_ROW_COUNT'
,p_display_order=>80
,p_column_identifier=>'H'
,p_column_label=>'Error Rows'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5818887816534550)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>90
,p_column_identifier=>'I'
,p_column_label=>'Security Group Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3100282407149802)
,p_db_column_name=>'MSG_COUNT'
,p_display_order=>100
,p_column_identifier=>'K'
,p_column_label=>'Messages'
,p_column_link=>'f?p=&APP_ID.:7026:&SESSION.::&DEBUG.:7026:P7026_LOG_ID:#ID#'
,p_column_linktext=>'#MSG_COUNT#'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(1376238778510584)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'13763'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'START_TIMESTAMP:AUTOMATION_NAME:STATUS:SUCCESSFUL_ROW_COUNT:ERROR_ROW_COUNT:MSG_COUNT:'
,p_sort_column_1=>'START_TIMESTAMP'
,p_sort_direction_1=>'DESC NULLS LAST'
,p_sort_column_2=>'0'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(29895556730987848)
,p_plug_name=>'Execution Log'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--slimPadding:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Review logged information about previous automation executions. The log contains start and end timestamps as well as details about processed rows (successful and with errors). Drill down into <strong>Messages</strong> to see individual messages fo'
||'r processed rows.</p>',
'<p>&PRODUCT_NAME. purges log information by default every 14 days. Other retention periods can be configured in Administration Services.</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1926957076406308)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1926493800406303)
,p_button_name=>'CLEAR_LOG'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Clear Log'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1926603486406305)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(5817615693534538)
,p_button_name=>'OPEN_CLEAR_LOG'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Purge Log'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1926510639406304)
,p_name=>'P7025_AUTOMATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1926493800406303)
,p_prompt=>'Automation'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id',
'  from wwv_flow_automations',
' where security_group_id = :WORKSPACE_ID',
'   and flow_id           = :FB_FLOW_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1926753216406306)
,p_name=>'Open Clear Log Dialog'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1926603486406305)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1926893253406307)
,p_event_id=>wwv_flow_imp.id(1926753216406306)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1926493800406303)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1927072386406309)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Clear Automation Log'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    delete wwv_flow_automation_msg_log1$',
'     where automation_id     = :P7025_AUTOMATION',
'       and security_group_id = :WORKSPACE_ID;',
'     ',
'    delete wwv_flow_automation_msg_log2$',
'     where automation_id     = :P7025_AUTOMATION',
'       and security_group_id = :WORKSPACE_ID;',
'',
'    delete wwv_flow_automation_log1$ ',
'     where automation_id     = :P7025_AUTOMATION',
'       and security_group_id = :WORKSPACE_ID;',
'       ',
'    delete wwv_flow_automation_log2$ ',
'     where automation_id     = :P7025_AUTOMATION',
'       and security_group_id = :WORKSPACE_ID;',
'     ',
'    :P7025_AUTOMATION := null; ',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CLEAR_LOG'
,p_process_when_type=>'REQUEST_EQUALS_CONDITION'
,p_process_success_message=>'Log for Automation Cleared.'
,p_internal_uid=>1927072386406309
);
end;
/
prompt --application/pages/page_07026
begin
wwv_flow_imp_page.create_page(
 p_id=>7026
,p_name=>'Log Messages'
,p_alias=>'LOG-MESSAGES'
,p_step_title=>'Log Messages'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(1379381290188239)
,p_name=>'Automation Execution'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--accessibleHeader'
,p_component_template_options=>'#DEFAULT#:a-Report--noBorders:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select a.name,',
'       l.start_timestamp,',
'       l.status',
'  from wwv_flow_automations a,',
'       wwv_flow_automation_log l',
' where a.id                = l.automation_id',
'   and a.security_group_id = :flow_security_group_id  ',
'   and l.security_group_id = :flow_security_group_id  ',
'   and l.id                = :P7026_LOG_ID'))
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(82408032331628644)
,p_query_num_rows=>1
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1379451249188240)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>10
,p_column_heading=>'Automation'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1379528031188241)
,p_query_column_id=>2
,p_column_alias=>'START_TIMESTAMP'
,p_column_display_sequence=>20
,p_column_heading=>'Execution Start Timestamp'
,p_use_as_row_header=>'N'
,p_column_format=>'&DATE_TIME_FORMAT.'
,p_heading_alignment=>'LEFT'
,p_disable_sort_column=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1379681945188242)
,p_query_column_id=>3
,p_column_alias=>'STATUS'
,p_column_display_sequence=>30
,p_column_heading=>'Status'
,p_use_as_row_header=>'N'
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(2000855720872191)
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3101396571149813)
,p_plug_name=>'Log Messages'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select log_id,',
'       action_id,',
'       message_type,',
'       message,',
'       pk_value,',
'       message_timestamp,',
'       security_group_id',
'  from wwv_flow_automation_msg_log',
' where security_group_id = :flow_security_group_id  ',
'   and log_id = :P7026_LOG_ID',
'',
'  '))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Log Messages'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(3101586625149815)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'No detail messages available for this execution.'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'ADMIN'
,p_internal_uid=>3101586625149815
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3101671491149816)
,p_db_column_name=>'LOG_ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Log Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3101700606149817)
,p_db_column_name=>'ACTION_ID'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Action Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3101849886149818)
,p_db_column_name=>'MESSAGE_TYPE'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Message Type'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(4601034447346038)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3101992033149819)
,p_db_column_name=>'MESSAGE'
,p_display_order=>40
,p_column_identifier=>'D'
,p_column_label=>'Message'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3102093627149820)
,p_db_column_name=>'PK_VALUE'
,p_display_order=>50
,p_column_identifier=>'E'
,p_column_label=>'Primary Key Value'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3102163225149821)
,p_db_column_name=>'MESSAGE_TIMESTAMP'
,p_display_order=>60
,p_column_identifier=>'F'
,p_column_label=>'Timestamp'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'&DATE_TIME_FORMAT.'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3102280991149822)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>70
,p_column_identifier=>'G'
,p_column_label=>'Security Group Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(3808640475255276)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'38087'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'MESSAGE_TIMESTAMP:MESSAGE:MESSAGE_TYPE:PK_VALUE:'
,p_sort_column_1=>'MESSAGE_TIMESTAMP'
,p_sort_direction_1=>'DESC NULLS LAST'
,p_sort_column_2=>'0'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4477052522299401)
,p_plug_name=>'Log Messages'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Review detail messages generated during automation execution. A message will be ',
'generated for each error which occurs during execution of automation actions. ',
'The <strong>LOG_INFO</strong>, <strong>LOG_WARN</strong>',
'or <strong>LOG_ERROR</strong> procedures within <strong>APEX_AUTOMATION</strong>',
'also generate log messages.',
'</p>',
'<p>',
'A log message contains the message timestamp, message type (Info, Warning, Error),',
'the actual message and (optionally) the primary key value of the row for which ',
'the message was generated.',
'</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7678852160115842)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_imp.id(2700189206621868)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3101474004149814)
,p_name=>'P7026_LOG_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(7678852160115842)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
end;
/
prompt --application/pages/page_07027
begin
wwv_flow_imp_page.create_page(
 p_id=>7027
,p_name=>'History'
,p_alias=>'HISTORY'
,p_step_title=>'History'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3104354856149843)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.a object_type,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u,',
'  (select wwv_flow_lang.system_message(''AUTOMATION'') a from dual) t',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_AUTOMATIONS''',
'union',
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.a object_type,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u,',
'  (select wwv_flow_lang.system_message(''AUTOMATION ACTION'') a from dual) t',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_AUTOMATION_ACTIONS'''))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'History'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(3104443872149844)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'No history information found.'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'ADMIN'
,p_internal_uid=>3104443872149844
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3104544445149845)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3104676270149846)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Audit Date'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3104767829149847)
,p_db_column_name=>'ACTION'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5012446025058001)
,p_db_column_name=>'OBJECT_TYPE'
,p_display_order=>70
,p_column_identifier=>'G'
,p_column_label=>'Object Type'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(1387977807801823)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(5012535112058002)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>80
,p_column_identifier=>'H'
,p_column_label=>'Component Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3104849534149848)
,p_db_column_name=>'SCN'
,p_display_order=>90
,p_column_identifier=>'D'
,p_column_label=>'Scn'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3104972238149849)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>100
,p_column_identifier=>'E'
,p_column_label=>'Audit Comment'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3105052040149850)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>110
,p_column_identifier=>'F'
,p_column_label=>'Component Key'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(5020363749058186)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'50204'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'AUDIT_DATE:ACTION:DEVELOPER:OBJECT_TYPE:COMPONENT_NAME:'
,p_sort_column_1=>'AUDIT_DATE'
,p_sort_direction_1=>'DESC NULLS LAST'
,p_sort_column_2=>'0'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(12679063870106035)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_imp.id(2700189206621868)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(29895658509987849)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>'This page displays recent modifications made to Automations in this application.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
end;
/
prompt --application/pages/page_07030
begin
wwv_flow_imp_page.create_page(
 p_id=>7030
,p_name=>'Create Automation'
,p_alias=>'CREATE-AUTOMATION1'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Automation'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>'div#P7030_POLLING_STARTAT_DAILY_CONTAINER span.apex-quick-picks {display: inline; padding-left: 5px; }'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1482219015184018)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4284423226001546)
,p_plug_name=>'Automation Details'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1480696327184002)
,p_plug_name=>'Polling Details'
,p_parent_plug_id=>wwv_flow_imp.id(4284423226001546)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1407895539910705)
,p_plug_name=>'Custom Interval'
,p_parent_plug_id=>wwv_flow_imp.id(1480696327184002)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1482361436184019)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1482219015184018)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'NEXT'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1377917386188225)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1482219015184018)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1484112867184037)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(1482219015184018)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1482418259184020)
,p_branch_action=>'f?p=&APP_ID.:7031:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(1482361436184019)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1379028918188236)
,p_branch_action=>'f?p=&APP_ID.:7021:&SESSION.::&DEBUG.:7021:P7021_ID:&P7030_NEW_AUTOMATION_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(1377917386188225)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P7030_RESULT_TYPE'
,p_branch_condition_text=>'ALWAYS'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1377873956188224)
,p_name=>'P7030_RESULT_TYPE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(4284423226001546)
,p_item_default=>'QUERY'
,p_prompt=>'Actions initiated on'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P7030_RESULT_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(601121722896835768)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select whether execution of Automation Actions should be initiated based on a <strong>Query</strong> (the rows returned can then be used by the actions) or if the actions should <strong>Always</strong> be executed.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1378610163188232)
,p_name=>'P7030_MIN_CADENCE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(4284423226001546)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1378947340188235)
,p_name=>'P7030_NEW_AUTOMATION_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(4284423226001546)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1407471175910701)
,p_name=>'P7030_POLLING_PREDEFINED'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1480696327184002)
,p_item_default=>'T1H'
,p_prompt=>'Execution Schedule'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P7030_POLLING_PREDEFINED'
,p_lov=>'.'||wwv_flow_imp.id(601117964216834048)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select an execution schedule for the new automation.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'4'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1480507758184001)
,p_name=>'P7030_POLLING_STARTAT_HOURLY'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(1407895539910705)
,p_prompt=>'Execution Minute'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>5
,p_cMaxlength=>2
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify the execution minute, from 0 to 59.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'0'
,p_attribute_02=>'59'
,p_attribute_03=>'left'
,p_attribute_04=>'text'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1482139156184017)
,p_name=>'P7030_POLLING_INTERVAL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1407895539910705)
,p_item_default=>'1'
,p_prompt=>'Interval'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>5
,p_cMaxlength=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify the execution interval. For instance, if <strong>Daily</strong> was chosen as the <strong>Frequency</strong> and <strong>2</strong> is entered here, then the automation will be executed every two days.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4284549488001547)
,p_name=>'P7030_AUTOMATION_NAME'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(4284423226001546)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a name for the new Automation.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4284616068001548)
,p_name=>'P7030_AUTOMATION_TYPE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(4284423226001546)
,p_item_default=>'POLLING'
,p_prompt=>'Type'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'AUTOMATION_TRIGGER_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(1355426926728029)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Automations with a <strong>Schedule</strong> will be executed automatically based on the selected frequency. If <strong>On Demand</strong> is selected, the automation will only be executed when called explicitly using the <strong>APEX_AUTOMATION</str'
||'ong> package.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4284714832001549)
,p_name=>'P7030_POLLING_INTERVAL_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1407895539910705)
,p_item_default=>'HOURLY'
,p_prompt=>'Frequency'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P7030_POLLING_INTERVAL_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(601120036396834677)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify whether the execution schedule should be based on a daily, hourly or minutely basis. More advanced schedules can be defined on the edit pages once the automation has been created.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4284826933001550)
,p_name=>'P7030_POLLING_STARTAT_DAILY'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(1407895539910705)
,p_prompt=>'Execution Time'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>5
,p_cMaxlength=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Specify the execution time in <strong>HH24:MI</strong> format.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_show_quick_picks=>'Y'
,p_quick_pick_label_01=>'Midnight'
,p_quick_pick_value_01=>'00:00'
,p_quick_pick_label_02=>'6:00am'
,p_quick_pick_value_02=>'06:00'
,p_quick_pick_label_03=>'Noon'
,p_quick_pick_value_03=>'12:00'
,p_quick_pick_label_04=>'6:00pm'
,p_quick_pick_value_04=>'18:00'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4477275252299403)
,p_name=>'P7030_SCHEDULER_EXPRESSION'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(1407895539910705)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(4477385851299404)
,p_computation_sequence=>10
,p_computation_item=>'P7030_SCHEDULER_EXPRESSION'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'rtrim( case :P7030_POLLING_PREDEFINED ',
'        when ''15M''      then ''FREQ=MINUTELY;INTERVAL=15''',
'        when ''T1H''      then ''FREQ=HOURLY;INTERVAL=1;BYMINUTE=0''',
'        when ''MIDNIGHT'' then ''FREQ=DAILY;INTERVAL=1;BYHOUR=0;BYMINUTE=0''',
'        when ''CUSTOM''   then ''FREQ='' || :P7030_POLLING_INTERVAL_TYPE || '';'' ||',
'                                        ''INTERVAL=''  || :P7030_POLLING_INTERVAL || '';'' ||',
'                                        case :P7030_POLLING_INTERVAL_TYPE',
'                                            when ''DAILY'' then ',
'                                                ''BYHOUR=''   || to_char( to_date ( :P7030_POLLING_STARTAT_DAILY, ''HH24:MI'' ), ''FMHH24'' ) || ',
'                                                '';'' ||',
'                                                ''BYMINUTE='' || to_char( to_date ( :P7030_POLLING_STARTAT_DAILY, ''HH24:MI'' ), ''FMMI'' )',
'                                            when ''HOURLY'' then',
'                                                ''BYMINUTE='' || :P7030_POLLING_STARTAT_HOURLY',
'                                        end',
'    end, '';'' )'))
,p_compute_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_dummy_date date;',
'begin',
'    l_dummy_date := to_date( :P7030_POLLING_STARTAT_DAILY, ''HH24:MI'' );',
'    return true;',
'exception',
'    when others then',
'        return false;',
'end;'))
,p_compute_when_text=>'PLSQL'
,p_compute_when_type=>'FUNCTION_BODY'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1935605700374327)
,p_computation_sequence=>10
,p_computation_item=>'P7030_MIN_CADENCE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'nvl(wwv_flow_platform.get_preference(''BACKGROUND_MIN_EXECUTION_CADENCE''),0)'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1408083237910707)
,p_validation_name=>'Is valid time'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_dummy_date date;',
'begin',
'    l_dummy_date := to_date( :P7030_POLLING_STARTAT_DAILY, ''HH24:MI'' );',
'    return true;',
'exception',
'    when others then',
'        return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Time must be specified in hh:mm format, e.g. 14:00'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P7030_AUTOMATION_TYPE = ''POLLING'' and :P7030_POLLING_INTERVAL_TYPE = ''DAILY'' and',
':P7030_POLLING_PREDEFINED = ''CUSTOM'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(1482361436184019)
,p_associated_item=>wwv_flow_imp.id(4284826933001550)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1408302835910710)
,p_validation_name=>'Not more frequent than BACKGROUND_MIN_EXECUTION_CADENCE'
,p_validation_sequence=>20
,p_validation=>'to_number( wwv_flow_automation_dev.get_execution_cadence_minutes( :P7030_SCHEDULER_EXPRESSION ) ) >= to_number( :P7030_MIN_CADENCE )'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Automations cannot be executed more frequently than every &P7030_MIN_CADENCE!HTML. minutes.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P7030_POLLING_INTERVAL_TYPE = ''MINUTELY'' and :P7030_AUTOMATION_TYPE = ''POLLING'' and ',
':P7030_POLLING_PREDEFINED = ''CUSTOM'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_when_button_pressed=>wwv_flow_imp.id(1482361436184019)
,p_associated_item=>wwv_flow_imp.id(1482139156184017)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1501795377184405)
,p_validation_name=>'Automation Name is unique'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_automations',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and name              = :P7030_AUTOMATION_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Automation name is already taken'
,p_validation_condition=>'NEXT:CREATE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(4284549488001547)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1480735517184003)
,p_name=>'Automation Type'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7030_AUTOMATION_TYPE'
,p_condition_element=>'P7030_AUTOMATION_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'POLLING'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1480880293184004)
,p_event_id=>wwv_flow_imp.id(1480735517184003)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1480696327184002)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1480973671184005)
,p_event_id=>wwv_flow_imp.id(1480735517184003)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1480696327184002)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1481052251184006)
,p_name=>'Interval "MINUTELY"'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7030_POLLING_INTERVAL_TYPE'
,p_condition_element=>'P7030_POLLING_INTERVAL_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'MINUTELY'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1481670583184012)
,p_event_id=>wwv_flow_imp.id(1481052251184006)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7030_POLLING_STARTAT_HOURLY,P7030_POLLING_STARTAT_DAILY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1484503383184041)
,p_event_id=>wwv_flow_imp.id(1481052251184006)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7030_POLLING_STARTAT_DAILY,P7030_POLLING_STARTAT_HOURLY'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1408861371910715)
,p_event_id=>wwv_flow_imp.id(1481052251184006)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7030_POLLING_INTERVAL'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'15'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1481881118184014)
,p_name=>'Interval "HOURLY"'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7030_POLLING_INTERVAL_TYPE'
,p_condition_element=>'P7030_POLLING_INTERVAL_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'HOURLY'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1481902724184015)
,p_event_id=>wwv_flow_imp.id(1481881118184014)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7030_POLLING_STARTAT_HOURLY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1482054210184016)
,p_event_id=>wwv_flow_imp.id(1481881118184014)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7030_POLLING_STARTAT_DAILY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1484641960184042)
,p_event_id=>wwv_flow_imp.id(1481881118184014)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7030_POLLING_STARTAT_DAILY'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1484859877184044)
,p_event_id=>wwv_flow_imp.id(1481881118184014)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7030_POLLING_STARTAT_HOURLY'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'0'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1408998062910716)
,p_event_id=>wwv_flow_imp.id(1481881118184014)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7030_POLLING_INTERVAL'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'1'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1481364447184009)
,p_name=>'Interval "DAILY"'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7030_POLLING_INTERVAL_TYPE'
,p_condition_element=>'P7030_POLLING_INTERVAL_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'DAILY'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1481483690184010)
,p_event_id=>wwv_flow_imp.id(1481364447184009)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7030_POLLING_STARTAT_DAILY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1407959778910706)
,p_event_id=>wwv_flow_imp.id(1481364447184009)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7030_POLLING_STARTAT_HOURLY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1484456947184040)
,p_event_id=>wwv_flow_imp.id(1481364447184009)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7030_POLLING_STARTAT_DAILY'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'12:00'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1484752306184043)
,p_event_id=>wwv_flow_imp.id(1481364447184009)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7030_POLLING_STARTAT_HOURLY'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1409081251910717)
,p_event_id=>wwv_flow_imp.id(1481364447184009)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7030_POLLING_INTERVAL'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'1'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1484221707184038)
,p_name=>'Cancel'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1484112867184037)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1484305893184039)
,p_event_id=>wwv_flow_imp.id(1484221707184038)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1407562176910702)
,p_name=>'Custom Interval Chosen'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7030_POLLING_PREDEFINED'
,p_condition_element=>'P7030_POLLING_PREDEFINED'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'CUSTOM'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1407685185910703)
,p_event_id=>wwv_flow_imp.id(1407562176910702)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1407895539910705)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1407736354910704)
,p_event_id=>wwv_flow_imp.id(1407562176910702)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1407895539910705)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1378096245188226)
,p_name=>'Result Type'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7030_RESULT_TYPE'
,p_condition_element=>'P7030_RESULT_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'QUERY'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1378123256188227)
,p_event_id=>wwv_flow_imp.id(1378096245188226)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(1482361436184019)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1378411527188230)
,p_event_id=>wwv_flow_imp.id(1378096245188226)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(1377917386188225)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1378263947188228)
,p_event_id=>wwv_flow_imp.id(1378096245188226)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(1377917386188225)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1378368125188229)
,p_event_id=>wwv_flow_imp.id(1378096245188226)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(1482361436184019)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1378717517188233)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Automation'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_automation_id    number;    ',
'begin',
'    :P7030_NEW_AUTOMATION_ID := wwv_flow_automation_dev.create_wizard (',
'                                    p_flow_id           =>    :FB_FLOW_ID,',
'                                    --',
'                                    p_name              =>    :P7030_AUTOMATION_NAME,',
'                                    p_trigger_type      =>    :P7030_AUTOMATION_TYPE,',
'                                    p_polling_interval  =>    :P7030_SCHEDULER_EXPRESSION,',
'                                    --',
'                                    p_result_type       =>    ''ALWAYS'',',
'                                    p_location          =>    null,',
'                                    p_remote_server_id  =>    null,',
'                                    p_web_src_module_id =>    null,',
'                                    p_web_src_array_col_id => null,',
'                                    p_query_match       =>    null,',
'                                    p_query_columns     =>    null,',
'                                    p_query_type        =>    null,',
'                                    p_query_source      =>    null,',
'                                    p_query_owner       =>    null,',
'                                    p_query_table       =>    null,',
'                                    --   ',
'                                    p_pk_column_name    =>    null ); ',
'end;',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1377917386188225)
,p_process_when=>'P7030_RESULT_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'ALWAYS'
,p_process_success_message=>'Automation has been created. Now create <em>Actions</em> to execute when the automation runs.'
,p_internal_uid=>1378717517188233
);
end;
/
prompt --application/pages/page_07031
begin
wwv_flow_imp_page.create_page(
 p_id=>7031
,p_name=>'Create Automation'
,p_alias=>'CREATE-AUTOMATION'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Automation'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(93464502376707648)
,p_step_template=>wwv_flow_imp.id(689065306389965836)
,p_dialog_attributes=>'resizable:true,minWidth:500,minHeight:500'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(45759350624876133)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(94229353380171984)
,p_plug_name=>'Create Automation'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3116778298066610)
,p_plug_name=>'Create for local data source'
,p_parent_plug_id=>wwv_flow_imp.id(94229353380171984)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3116863712066611)
,p_plug_name=>'Create Report on REST Data Source'
,p_parent_plug_id=>wwv_flow_imp.id(94229353380171984)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4907518142674538)
,p_plug_name=>'Create Report on Remote SQL'
,p_parent_plug_id=>wwv_flow_imp.id(94229353380171984)
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(94229569163171984)
,p_plug_name=>'SQL Query Example'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(399849897040726767)
,p_plug_display_sequence=>40
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'SELECT ENAME, JOB, SAL, COMM',
'  FROM EMPLOYEE_CHANGES',
' WHERE UPDATED_ON > APEX_AUTOMATION.GET_LAST_RUN',
'</pre>'))
,p_plug_header=>'<p><strong>APEX_AUTOMATION.GET_LAST_RUN</strong> returns the timestamp  of the previous automation run, so it can be used to process only records not being processed by the previous automations.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1340033910119016)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(45759350624876133)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1340421143119017)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(45759350624876133)
,p_button_name=>'CREATE'
,p_button_static_id=>'create_page_button'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1340891475119017)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(45759350624876133)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:7030:&SESSION.::&DEBUG.:RP,::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1408121517910708)
,p_branch_action=>'f?p=&APP_ID.:7021:&SESSION.::&DEBUG.:7021:P7021_ID:&P7031_NEW_AUTOMATION_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1341581006119025)
,p_name=>'P7031_LOCATION'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(94229353380171984)
,p_item_default=>'LOCAL'
,p_prompt=>'Data Source'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXEC_LOCATION'
,p_lov=>'.'||wwv_flow_imp.id(3842073961668883)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Select the <em>Data Source</em> for the new Automation.',
'</p>',
'<ul>',
'    <li><strong>Local Database</strong><br>',
'    Data is sourced from the local database.</li>',
'    <li><strong>REST Enabled SQL Service</strong><br>',
'    Data is sourced from a remote database, where the connection is defined using REST Enabled SQL. To create or maintain REST Enabled SQL references, navigate to Shared Components, REST Enabled SQL.',
'    </li>',
'    <li><strong>REST Data Source</strong><br>',
'    Data is sourced from a RESTful web service defined using REST Data Sources. To create or maintain REST Data Sources, navigate to Shared Components, REST Data Sources.',
'    </li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1344416432119033)
,p_name=>'P7031_SOURCE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3116778298066610)
,p_item_default=>'TABLE'
,p_prompt=>'Source Type'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'PAGE_SOURCE'
,p_lov=>'.'||wwv_flow_imp.id(141264908196813501)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select the source of the data evaluated during the execution of the automation. ',
'Automations can be based on tables, SQL queries, or (on Oracle Database 23ai and later) on Property Graphs. ',
'More options can be configured on the edit page.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'3'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1345743577119035)
,p_name=>'P7031_TABLE_OWNER'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(3116778298066610)
,p_prompt=>'Owner'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_SCHEMAS_HAVE_PRIVS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(owner) d, owner v',
'  from wwv_flow_object_owners_dev',
'order by d                   '))
,p_lov_cascade_parent_items=>'P7031_SOURCE_TYPE'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the owner of the object on which you are basing this automation.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1346687732119035)
,p_name=>'P7031_TABLE_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(3116778298066610)
,p_prompt=>'Table / View Name'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = :P7031_TABLE_OWNER',
'   and :P7031_SOURCE_TYPE = ''TABLE'''))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Value -'
,p_lov_cascade_parent_items=>'P7031_TABLE_OWNER,P7031_SOURCE_TYPE'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the table or view on which the automation will be based.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1347963424119036)
,p_name=>'P7031_SQL'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(3116778298066610)
,p_prompt=>'Enter a SQL SELECT statement'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>8
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the SQL query that will be the source of the data evaluated during the execution of the automation, for example:',
'<pre>',
'select empno, ename, job, sal',
'from  emp',
'</pre>',
'Column values can be used within automation actions with bind variable syntax (for example, <strong>:EMPNO</strong>). In addition to data from your query, you can use <strong>APEX_AUTOMATION.GET_LAST_RUN</strong> to reference the timestamp of the <em'
||'>previous run</em> of this automation. This is useful to prevent processing data twice.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1363610750119068)
,p_name=>'P7031_WEB_SRC_MODULE_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3116863712066611)
,p_prompt=>'REST Data Source'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APP_WEB_SOURCES_FOR_REPORTS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name d, id r',
'  from wwv_flow_web_src_modules m',
' where flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID',
'   and exists ( select 1 ',
'                  from wwv_flow_web_src_operations',
'                 where web_src_module_id = m.id',
'                   and database_operation = ''FETCH_COLLECTION'' )',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1366462296119070)
,p_name=>'P7031_REMOTE_SERVER_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(4907518142674538)
,p_prompt=>'REST Enabled SQL Service'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REMOTE_SQL_SERVERS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_remote_servers',
' where server_type = ''REMOTE_SQL''',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose a REST Enabled SQL Reference.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1366857840119070)
,p_name=>'P7031_REMOTE_SOURCE_TYPE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(4907518142674538)
,p_item_default=>'TABLE'
,p_prompt=>'Source Type'
,p_source=>'WIZARD_SQL_SOURCE_TYPE'
,p_source_type=>'PREFERENCE'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'PAGE_REMOTE_SOURCE'
,p_lov=>'.'||wwv_flow_imp.id(1770066301256915)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Specify the source of the data evaluated during the execution of the automation. Automations can be based on tables or SQL queries.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1367741822119070)
,p_name=>'P7031_REMOTE_SQL'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(4907518142674538)
,p_prompt=>'Enter a SQL SELECT statement'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>96
,p_cMaxlength=>32767
,p_cHeight=>8
,p_tag_css_classes=>'a-Form-textarea--code'
,p_field_template=>wwv_flow_imp.id(561549716994252345)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the SQL query that will be the source of the data evaluated during the execution of the automation, for example:',
'<pre>',
'select empno, ename, job, sal',
'from  emp',
'</pre>',
'Column values can be used within automation actions with bind variable syntax (for example, <strong>:EMPNO</strong>).'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'SQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_05=>'P7031_REMOTE_SERVER_ID'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1368611592119070)
,p_name=>'P7031_REMOTE_TABLE_OWNER'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(4907518142674538)
,p_prompt=>'Table / View Owner'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value d, column_value r',
'  from table( wwv_flow_remote_server_dev.get_available_objects( :P7031_REMOTE_SERVER_ID, ''SCHEMAS''))',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Current Schema'
,p_lov_cascade_parent_items=>'P7031_REMOTE_SERVER_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the owner of the table on which you are basing this automation.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1369572098119071)
,p_name=>'P7031_REMOTE_TABLE_NAME'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(4907518142674538)
,p_prompt=>'Table / View Name'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_value d, column_value r',
'  from table( wwv_flow_remote_server_dev.get_available_objects( :P7031_REMOTE_SERVER_ID, ''TABLE'', :P7031_REMOTE_TABLE_OWNER,p_filter=>:p$_search_string ))',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Table or View -'
,p_lov_cascade_parent_items=>'P7031_REMOTE_TABLE_OWNER'
,p_ajax_items_to_submit=>'P7031_REMOTE_SERVER_ID'
,p_ajax_optimize_refresh=>'N'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the table or view on which the automation will be based.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1408292598910709)
,p_name=>'P7031_NEW_AUTOMATION_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(94229353380171984)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1408410223910711)
,p_name=>'P7031_WEB_SRC_RESULT_TYPE'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3116863712066611)
,p_item_default=>'ROWS'
,p_prompt=>'Result Type'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'AUTOMATION_RESULT_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(601105473256773090)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify whether the automation actions should be executed when the service <em>returns rows</em> (Data Found) or when the <em>query does not return rows</em> (No Data Found).'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1484930150184045)
,p_name=>'P7031_RESULT_TYPE'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(3116778298066610)
,p_item_default=>'ROWS'
,p_prompt=>'Execute Actions When'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'AUTOMATION_RESULT_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(601105473256773090)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select whether Automation Actions should be executed, when the query <em>returns rows</em>, or when the query <em>does not return rows</em>.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1485324427184049)
,p_name=>'P7031_REMOTE_RESULT_TYPE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(4907518142674538)
,p_item_default=>'ROWS'
,p_prompt=>'Result Type'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'AUTOMATION_RESULT_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(601105473256773090)||'.'
,p_tag_css_classes=>'apex-button-group'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify whether the automation actions should be executed when the data source <em>returns rows</em> (Data Found) or when the <em>query does not return rows</em> (No Data Found).'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1534662729420623)
,p_name=>'P7031_WEB_SRC_ARRAY_COL_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3116863712066611)
,p_prompt=>'Array Column'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select dpc.display_name,',
'       dpc.id',
'  from wwv_flow_web_src_arr_cols_dev dpc',
' where dpc.security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and dpc.flow_id           = :FB_FLOW_ID',
'   and dpc.web_src_module_id = :P7031_WEB_SRC_MODULE_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'None'
,p_lov_cascade_parent_items=>'P7031_WEB_SRC_MODULE_ID'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Denotes the Array Column, from the <em>Data Profile</em> of the REST Data Source, to be used for this Automation.'
,p_attribute_01=>'NONE'
,p_attribute_02=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1638723066313225)
,p_name=>'P7031_GRAPH_NAME'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(3116778298066610)
,p_prompt=>'Graph Name'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select g.graph_name d, ',
'       g.graph_name r',
'  from sys.dba_property_graphs        g,',
'       wwv_flow_object_owners_dev o',
' where o.owner = g.owner',
'   and g.owner = :P7031_TABLE_OWNER'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Value -'
,p_lov_cascade_parent_items=>'P7031_TABLE_OWNER'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>30
,p_display_when=>'sys.dbms_db_version.version >= 23'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>'Pick the Property Graph from the list.'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1638852717313226)
,p_name=>'P7031_PQL_MATCH_CLAUSE'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(3116778298066610)
,p_prompt=>'Match Clause'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cHeight=>2
,p_display_when=>'sys.dbms_db_version.version >= 23'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a path pattern to find on the property graph. In order to find all edges in your graph, use the following: <strong>(a) - [e] -> (b)</strong>. In addition to this, use <em>label constraints</em> to restrict the types of vertices or edges of i'
||'nterest.</p>',
'<p><strong>Examples</strong></p>',
'<dl>',
'<dt>Find all persons who bought cars.</dt><dd><pre>(p is person) - [t is buys] -> (c is car)</pre></dd>',
'<dt>Find all employees working in departments.</dt><dd><pre>(e is employees) - [is works_at] -> (d is departments)</pre></dd>',
'<dt>Find all employees working in departments who bought cars.</dt><dd><pre>(e is employees) - [is works_at] -> (d is departments), (e is employees) - [t is buys] -> (c is car)</pre></dd>',
'</dl>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1638951112313227)
,p_name=>'P7031_PQL_COLUMNS_CLAUSE'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(3116778298066610)
,p_prompt=>'Columns Clause'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cHeight=>2
,p_display_when=>'sys.dbms_db_version.version >= 23'
,p_display_when2=>'PLSQL'
,p_display_when_type=>'EXPRESSION'
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Define the query return columns. Those are properties of vertices or edges or expressions using them.</p>',
'<p><strong>Example</strong></p>',
'<dl>',
'<dt>Return <strong>NAME</strong>, <strong>BRAND</strong> and <strong>TOTAL_COST</strong> columns, the latter is the <strong>COST</strong> column, multiplied by 100.</dt>',
'<dd><pre>p.name, c.brand, t.cost * 100 as total_cost</pre></dd>',
'</dl>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1377410808119092)
,p_computation_sequence=>50
,p_computation_item=>'P7031_TABLE_OWNER'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'QUERY'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select owner',
'  from wwv_flows',
' where id = :FB_FLOW_ID',
'    and security_group_id = :FLOW_SECURITY_GROUP_ID'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1377894340119092)
,p_computation_sequence=>50
,p_computation_item=>'UI_SCHEMA'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'P7031_TABLE_OWNER'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1376619329119090)
,p_computation_sequence=>60
,p_computation_item=>'P7031_REMOTE_SERVER_ID'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1380687782119094)
,p_validation_name=>'Is Valid Automation Query'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'--',
'-- validate_query also validates that required items actually contain',
'-- a value (e.g. Table Name for Query Type = TABLE)',
'return wwv_flow_exec_dev.validate_query(',
'           p_location               => :P7031_LOCATION,',
'           p_remote_server_id       => :P7031_REMOTE_SERVER_ID,',
'           p_web_src_module_id      => :P7031_WEB_SRC_MODULE_ID,',
'           --',
'           p_table_owner            => case :P7031_LOCATION',
'                                           when ''LOCAL''  then :P7031_TABLE_OWNER ',
'                                           when ''REMOTE'' then :P7031_REMOTE_TABLE_OWNER end,',
'           p_table_name             => case :P7031_LOCATION',
'                                           when ''LOCAL''  then case ',
'                                                                  when :P7031_SOURCE_TYPE = ''GRAPH'' ',
'                                                                       then :P7031_GRAPH_NAME ',
'                                                                       else :P7031_TABLE_NAME ',
'                                                              end ',
'                                           when ''REMOTE'' then :P7031_REMOTE_TABLE_NAME end,',
'           p_where_clause           => null,',
'           p_order_by_clause        => null,',
'           p_match_clause           => case when :P7031_SOURCE_TYPE = ''GRAPH'' then :P7031_PQL_MATCH_CLAUSE end,',
'           p_columns_clause         => case when :P7031_SOURCE_TYPE = ''GRAPH'' then :P7031_PQL_COLUMNS_CLAUSE end,',
'           p_sql_query              => case :P7031_LOCATION',
'                                           when ''LOCAL''  then :P7031_SQL ',
'                                           when ''REMOTE'' then :P7031_REMOTE_SQL end,',
'           p_function_body_language => ''PLSQL'',',
'           p_optimizer_hint         => null,',
'           --',
'           p_post_processing_type   => null,',
'           p_query_type             => case :P7031_LOCATION',
'                                           when ''REMOTE'' then ',
'                                               case :P7031_REMOTE_SOURCE_TYPE',
'                                                   when ''QUERY'' then ''SQL''',
'                                                   else :P7031_REMOTE_SOURCE_TYPE end',
'                                           else',
'                                               case :P7031_SOURCE_TYPE',
'                                                   when ''QUERY'' then ''SQL''',
'                                                   else :P7031_SOURCE_TYPE end',
'                                        end );'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_when_button_pressed=>wwv_flow_imp.id(1340421143119017)
,p_associated_item=>wwv_flow_imp.id(1347963424119036)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1384591848119099)
,p_name=>'Cancel Dialog'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1340033910119016)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1385062308119104)
,p_event_id=>wwv_flow_imp.id(1384591848119099)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1385482908119107)
,p_name=>'Show attributes for source "SQL"'
,p_event_sequence=>30
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7031_SOURCE_TYPE'
,p_condition_element=>'P7031_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'QUERY'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1390492324119111)
,p_event_id=>wwv_flow_imp.id(1385482908119107)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(94229569163171984)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1385913558119107)
,p_event_id=>wwv_flow_imp.id(1385482908119107)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7031_SQL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1386957334119108)
,p_event_id=>wwv_flow_imp.id(1385482908119107)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7031_TABLE_OWNER,P7031_TABLE_NAME,P7031_GRAPH_NAME,P7031_PQL_MATCH_CLAUSE,P7031_PQL_COLUMNS_CLAUSE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1485004985184046)
,p_event_id=>wwv_flow_imp.id(1385482908119107)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7031_RESULT_TYPE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1483033194184026)
,p_name=>'Show attributes for source "TABLE"'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7031_SOURCE_TYPE'
,p_condition_element=>'P7031_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TABLE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1483283525184028)
,p_event_id=>wwv_flow_imp.id(1483033194184026)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7031_SQL,P7031_GRAPH_NAME,P7031_PQL_MATCH_CLAUSE,P7031_PQL_COLUMNS_CLAUSE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1483413723184030)
,p_event_id=>wwv_flow_imp.id(1483033194184026)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7031_TABLE_OWNER,P7031_TABLE_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1483532025184031)
,p_event_id=>wwv_flow_imp.id(1483033194184026)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(94229569163171984)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1485143815184047)
,p_event_id=>wwv_flow_imp.id(1483033194184026)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7031_RESULT_TYPE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1639027252313228)
,p_name=>'Show attributes for source "GRAPH"'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7031_SOURCE_TYPE'
,p_condition_element=>'P7031_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'GRAPH'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1639162117313229)
,p_event_id=>wwv_flow_imp.id(1639027252313228)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7031_SQL,P7031_TABLE_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1639264724313230)
,p_event_id=>wwv_flow_imp.id(1639027252313228)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7031_TABLE_OWNER,P7031_GRAPH_NAME,P7031_PQL_MATCH_CLAUSE,P7031_PQL_COLUMNS_CLAUSE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1639376311313231)
,p_event_id=>wwv_flow_imp.id(1639027252313228)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(94229569163171984)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1639471282313232)
,p_event_id=>wwv_flow_imp.id(1639027252313228)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7031_RESULT_TYPE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1395854463119113)
,p_name=>'show remote source attributes'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7031_REMOTE_SOURCE_TYPE'
,p_condition_element=>'P7031_REMOTE_SOURCE_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'QUERY'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1396329813119114)
,p_event_id=>wwv_flow_imp.id(1395854463119113)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7031_REMOTE_SQL'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1396868674119114)
,p_event_id=>wwv_flow_imp.id(1395854463119113)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7031_REMOTE_TABLE_OWNER,P7031_REMOTE_TABLE_NAME'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1397318711119114)
,p_event_id=>wwv_flow_imp.id(1395854463119113)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7031_REMOTE_TABLE_OWNER,P7031_REMOTE_TABLE_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1397841937119114)
,p_event_id=>wwv_flow_imp.id(1395854463119113)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7031_REMOTE_SQL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1398327308119114)
,p_event_id=>wwv_flow_imp.id(1395854463119113)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(94229569163171984)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1398802374119114)
,p_event_id=>wwv_flow_imp.id(1395854463119113)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(94229569163171984)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1403434134119132)
,p_name=>'Location "LOCAL"'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7031_LOCATION'
,p_condition_element=>'P7031_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'LOCAL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1403924801119132)
,p_event_id=>wwv_flow_imp.id(1403434134119132)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3116778298066610)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1404443367119132)
,p_event_id=>wwv_flow_imp.id(1403434134119132)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3116778298066610)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1405417287119133)
,p_event_id=>wwv_flow_imp.id(1403434134119132)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7031_REMOTE_SERVER_ID'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1406887016119133)
,p_name=>'Location "REMOTE"'
,p_event_sequence=>80
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7031_LOCATION'
,p_condition_element=>'P7031_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REMOTE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1407321219119133)
,p_event_id=>wwv_flow_imp.id(1406887016119133)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(4907518142674538)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1407843134119133)
,p_event_id=>wwv_flow_imp.id(1406887016119133)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(4907518142674538)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1408263565119134)
,p_name=>'Location "WEB_SRC"'
,p_event_sequence=>90
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7031_LOCATION'
,p_condition_element=>'P7031_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'WEB_SOURCE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1408794745119134)
,p_event_id=>wwv_flow_imp.id(1408263565119134)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3116863712066611)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1409267912119134)
,p_event_id=>wwv_flow_imp.id(1408263565119134)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3116863712066611)
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1409790381119134)
,p_event_id=>wwv_flow_imp.id(1408263565119134)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7031_WEB_SRC_MODULE_ID'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1410136177119134)
,p_name=>'Remote Server chosen'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7031_REMOTE_SERVER_ID'
,p_condition_element=>'P7031_REMOTE_SERVER_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1410622070119134)
,p_event_id=>wwv_flow_imp.id(1410136177119134)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7031_REMOTE_SOURCE_TYPE,P7031_REMOTE_RESULT_TYPE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1411100138119134)
,p_event_id=>wwv_flow_imp.id(1410136177119134)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7031_REMOTE_SOURCE_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1411656612119134)
,p_event_id=>wwv_flow_imp.id(1410136177119134)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7031_REMOTE_SOURCE_TYPE,P7031_REMOTE_SQL,P7031_REMOTE_TABLE_OWNER,P7031_REMOTE_TABLE_NAME,P7031_REMOTE_RESULT_TYPE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1412126899119135)
,p_event_id=>wwv_flow_imp.id(1410136177119134)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7031_REMOTE_SOURCE_TYPE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'TABLE'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1408590684910712)
,p_name=>'Web Source Module is not null'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P7031_WEB_SRC_MODULE_ID'
,p_condition_element=>'P7031_WEB_SRC_MODULE_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1408632360910713)
,p_event_id=>wwv_flow_imp.id(1408590684910712)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7031_WEB_SRC_RESULT_TYPE,P7031_WEB_SRC_ARRAY_COL_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1408752890910714)
,p_event_id=>wwv_flow_imp.id(1408590684910712)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7031_WEB_SRC_RESULT_TYPE,P7031_WEB_SRC_ARRAY_COL_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1534796386420624)
,p_event_id=>wwv_flow_imp.id(1408590684910712)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P7031_WEB_SRC_ARRAY_COL_ID'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1401497341619801)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Automation'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    c_item_prefix constant varchar2(15) := ''P7031_'' ||',
'                                          case when :P7031_LOCATION = ''REMOTE'' then ''REMOTE_'' end;',
'',
'    l_automation_id number;',
'    l_query_type       wwv_flow_automations.query_type%type;',
'    l_query_owner      wwv_flow_automations.query_owner%type;',
'    l_query_table      wwv_flow_automations.query_table%type;',
'    l_query_source     wwv_flow_automations.query_source%type;',
'    l_result_type      wwv_flow_automations.result_type%type;',
'    l_query_match      wwv_flow_automations.query_match%type;',
'    l_query_columns    wwv_flow_automations.query_match%type;',
'',
'    l_polling_interval varchar2(32767);',
'begin',
'    case :P7030_POLLING_PREDEFINED ',
'        when ''15M''      then l_polling_interval := ''FREQ=MINUTELY;INTERVAL=15'';',
'        when ''T1H''      then l_polling_interval := ''FREQ=HOURLY;INTERVAL=1;BYMINUTE=0'';',
'        when ''MIDNIGHT'' then l_polling_interval := ''FREQ=DAILY;INTERVAL=1;BYHOUR=0;BYMINUTE=0'';',
'        when ''CUSTOM''   then',
'            l_polling_interval := ''FREQ=''      || :P7030_POLLING_INTERVAL_TYPE || '';'' ||',
'                                  ''INTERVAL=''  || :P7030_POLLING_INTERVAL || '';'' ||',
'                                  case :P7030_POLLING_INTERVAL_TYPE',
'                                      when ''DAILY'' then ',
'                                          ''BYHOUR=''   || to_char( to_date ( :P7030_POLLING_STARTAT_DAILY, ''HH24:MI'' ), ''FMHH24'' ) || ',
'                                          '';'' ||',
'                                          ''BYMINUTE='' || to_char( to_date ( :P7030_POLLING_STARTAT_DAILY, ''HH24:MI'' ), ''FMMI'' )',
'                                      when ''HOURLY'' then',
'                                          ''BYMINUTE='' || :P7030_POLLING_STARTAT_HOURLY',
'                                  end;',
'    end case;    ',
'',
'    if :P7031_LOCATION in ( ''LOCAL'', ''REMOTE'' ) then',
'        l_query_type  := v( c_item_prefix || ''SOURCE_TYPE'' );',
'        l_result_type := v( c_item_prefix || ''RESULT_TYPE'' );',
'        ',
'        case l_query_type',
'        when ''TABLE'' then',
'            l_query_owner := v( c_item_prefix || ''TABLE_OWNER'' );',
'            l_query_table := v( c_item_prefix || ''TABLE_NAME'' );',
'        when ''QUERY'' then',
'            l_query_source := v( c_item_prefix || ''SQL'' );',
'            l_query_type   := ''SQL'';',
'        when ''GRAPH'' then',
'            l_query_owner   := v( c_item_prefix || ''TABLE_OWNER'' );',
'            l_query_table   := v( c_item_prefix || ''GRAPH_NAME'' );',
'            l_query_match   := v( c_item_prefix || ''PQL_MATCH_CLAUSE'' );',
'            l_query_columns := v( c_item_prefix || ''PQL_COLUMNS_CLAUSE'' );',
'        end case;',
'    elsif :P7031_LOCATION = ''WEB_SOURCE'' then',
'        l_result_type := v( ''P7031_WEB_SRC_RESULT_TYPE'' );',
'    end if;',
'',
'    :P7031_NEW_AUTOMATION_ID := wwv_flow_automation_dev.create_wizard (',
'                                    p_flow_id              => :FB_FLOW_ID,',
'                                    --   ',
'                                    p_name                 => :P7030_AUTOMATION_NAME,',
'                                    p_trigger_type         => :P7030_AUTOMATION_TYPE,',
'                                    p_polling_interval     => rtrim(l_polling_interval,'';'' ),',
'                                    --   ',
'                                    p_result_type          => l_result_type,',
'                                    p_location             => :P7031_LOCATION,',
'                                    p_remote_server_id     => :P7031_REMOTE_SERVER_ID,',
'                                    p_web_src_module_id    => :P7031_WEB_SRC_MODULE_ID,',
'                                    p_web_src_array_col_id => :P7031_WEB_SRC_ARRAY_COL_ID,',
'                                    p_query_type           => l_query_type,',
'                                    p_query_source         => l_query_source,',
'                                    p_query_owner          => l_query_owner,',
'                                    p_query_match          => l_query_match,',
'                                    p_query_columns        => l_query_columns,',
'                                    p_query_table          => l_query_table,',
'                                    --   ',
'                                    p_pk_column_name       => null ); ',
'end;',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Automation has been created and is in "Disabled" state. Now create <em>Actions</em> to execute when the automation runs.'
,p_internal_uid=>1401497341619801
);
end;
/
prompt --application/pages/page_07777
begin
wwv_flow_imp_page.create_page(
 p_id=>7777
,p_name=>'Password Items'
,p_alias=>'PASSWORD-ITEMS1'
,p_step_title=>'Password Items'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213425326892450628)
,p_inline_css=>' tr[class^=''rule''] a, tr[class*='' rule''] a{ color: #AE562C; }'
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_util_cross_app.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(15991103646058130)
,p_plug_name=>'Password Items'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P7777a */',
'    f.id                            application_id,',
'    f.name                          application_name,',
'    p.id                            page_id,',
'    p.name                          page_name,',
'    --',
'    i.name                          item_name,',
'    (select plug_name',
'     from wwv_flow_page_plugs',
'     where id = i.ITEM_PLUG_ID)     region,',
'    i.PROMPT                        label,',
'    --',
'    i.id                            item_id,',
'    case i.is_persistent when ''N'' then m.m_yes else m.m_no end dnss,',
'    decode(i.encrypt_session_state_yn,''Y'',m.m_yes,m.m_no) encrypt_state,',
'    decode(nvl(p.AUTOCOMPLETE_ON_OFF,''ON''),',
'       ''ON'',m_on,',
'       ''OFF'',m_off,',
'       p.AUTOCOMPLETE_ON_OFF) AUTOCOMPLETE_ON_OFF,',
'    decode(nvl(i.encrypt_session_state_yn,''N''),',
'      ''Y'',m.m_no,',
'      case i.is_persistent when ''N'' then m_no else m_yes end) at_risk,',
'    decode(nvl(i.encrypt_session_state_yn,''N''),',
'      ''Y'',''N'',',
'      case i.is_persistent when ''N'' then ''N'' else ''Y'' end) at_risk_code',
'from wwv_flow_step_items i,',
'     wwv_flow_steps p,',
'     wwv_flows f,',
'(select ',
'       wwv_flow_lang.system_message(''F4000.YES'') m_yes,',
'       wwv_flow_lang.system_message(''F4000.NO'') m_no,',
'       wwv_flow_lang.system_message(''F4000_ON'') m_on,',
'       wwv_flow_lang.system_message(''F4000_OFF'') m_off',
'from dual) m',
'where i.flow_step_id = p.id and',
'      i.flow_id = f.id and',
'      i.flow_id = p.flow_id and',
'      i.display_as = ''NATIVE_PASSWORD'' and',
'      i.security_group_id = :flow_security_group_id and',
'      i.flow_id = f.id and',
'      p.flow_id = i.flow_id and',
'      f.build_status != ''RUN_AND_HIDDEN'''))
,p_plug_source_type=>'NATIVE_IR'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(15991228349058130)
,p_name=>'Password Items'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more than 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15991424526058152)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Application'
,p_column_link=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:RP,1,4015,RP:FB_FLOW_ID,F4000_P1_FLOW:#APPLICATION_ID#,#APPLICATION_ID#'
,p_column_linktext=>'#APPLICATION_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15991511431058152)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Application Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15991619847058152)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Page'
,p_column_link=>'#PAGE_LINK#'
,p_column_linktext=>'#PAGE_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15991725247058153)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Page Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15991831587058153)
,p_db_column_name=>'ITEM_NAME'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Item Name'
,p_column_link=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.:1:FB_FLOW_ID,F4000_P1_FLOW,FB_FLOW_PAGE_ID:#APPLICATION_ID#,#APPLICATION_ID#,#PAGE_ID##5120:#ITEM_ID#'
,p_column_linktext=>'#ITEM_NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15992012541058153)
,p_db_column_name=>'REGION'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Region'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15992108837058153)
,p_db_column_name=>'LABEL'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Label'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15992209394058153)
,p_db_column_name=>'ITEM_ID'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Item ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(435148310342536430)
,p_db_column_name=>'DNSS'
,p_display_order=>10
,p_column_identifier=>'N'
,p_column_label=>'Does not save state'
,p_column_type=>'STRING'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15992315624058153)
,p_db_column_name=>'ENCRYPT_STATE'
,p_display_order=>11
,p_column_identifier=>'J'
,p_column_label=>'Encrypt State'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15992404096058154)
,p_db_column_name=>'AUTOCOMPLETE_ON_OFF'
,p_display_order=>12
,p_column_identifier=>'K'
,p_column_label=>'Autocomplete'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15992521637058154)
,p_db_column_name=>'AT_RISK'
,p_display_order=>13
,p_column_identifier=>'L'
,p_column_label=>'At Risk'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(487114910098693160)
,p_db_column_name=>'AT_RISK_CODE'
,p_display_order=>16
,p_column_identifier=>'O'
,p_column_label=>'At Risk Code'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(15992621887058375)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1307024044536647'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'APPLICATION_ID:APPLICATION_NAME:PAGE_ID:PAGE_NAME:ITEM_NAME:LABEL:DNSS:ENCRYPT_STATE:AUTOCOMPLETE_ON_OFF:AT_RISK'
,p_sort_column_1=>'APPLICATION_ID'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_worksheet_condition(
 p_id=>wwv_flow_imp.id(34299863678816672)
,p_report_id=>wwv_flow_imp.id(15992621887058375)
,p_name=>'&P7777_AT_RISK_LABEL.'
,p_condition_type=>'HIGHLIGHT'
,p_allow_delete=>'Y'
,p_column_name=>'AT_RISK_CODE'
,p_operator=>'='
,p_expr=>'Y'
,p_condition_sql=>' (case when ("AT_RISK_CODE" = #APXWS_EXPR#) then #APXWS_HL_ID# end) '
,p_condition_display=>'#APXWS_COL_NAME# = ''Y''  '
,p_enabled=>'Y'
,p_highlight_sequence=>10
,p_row_bg_color=>'#fdfdd8'
,p_row_font_color=>'#000000'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(222858147672540009)
,p_plug_name=>'Password Items'
,p_region_template_options=>'#DEFAULT#:a-Region--slimPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Oracle recommends that password item values be available in memory only and not save the session state. ',
'To set a password item to not save state, edit the item by clicking on the <strong>Item Name</strong> and ',
'set the <strong>Session State, Storage</strong> attribute to <strong>Per Request (Memory Only)</strong>.</p>',
'',
'<p>When password items require session state to be maintained between page views, ',
'Oracle recommends encrypting the item values. To encrypt item session state, edit ',
'the item and enable the <strong>Security, Store value encrypted in session state</strong> ',
'attribute.</p>',
'',
'<p>Oracle also recommends disabling HTML form auto completion on pages with ',
'passwords. To disable auto completion, edit the page attributes and set the ',
'<strong>Security, Form Auto Complete</strong> value to <strong>Off</strong>.</p>',
'',
'<p>At risk password items, are password items that save state and are not ',
'encrypted.</p>'))
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(702955313727525460)
,p_plug_name=>'Cross Application Reports'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(702923103587108064)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1116538526541900834)
,p_name=>'P7777_AT_RISK_LABEL'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(15991103646058130)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(34301224356833701)
,p_computation_sequence=>10
,p_computation_item=>'P7777_AT_RISK_LABEL'
,p_computation_point=>'BEFORE_HEADER'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>'wwv_flow_lang.system_message(''AT_RISK_LABEL'')'
);
end;
/
prompt --application/pages/page_08000
begin
wwv_flow_imp_page.create_page(
 p_id=>8000
,p_name=>'Search'
,p_alias=>'SEARCH'
,p_step_title=>'Search'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_file_urls=>'#IMAGE_PREFIX#apex_ui/js/#MIN_DIRECTORY#f4000_searchResults#MIN#.js'
,p_step_template=>wwv_flow_imp.id(19943204431962826)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(30710309677866793)
,p_plug_name=>'Search'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174795123140076650)
,p_plug_display_sequence=>10
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(33628013409955025)
,p_name=>'Search Result'
,p_region_name=>'search_results'
,p_template=>wwv_flow_imp.id(208928010704475743)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'role="region" aria-label="Search Results"'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select path,',
'       attribute_name,',
'       ''<pre>''||wwv_flow_escape.html_trunc(attribute_value,3980)||''</pre>'' as attribute_value,',
'       ''<button type="button" class="a-Button edit-button" data-link="'' ||',
'       wwv_flow_utilities.prepare_url( link_url ) || ''"'' ||',
'       case when component_type_id is not null then',
'         '' data-appid="''           || flow_id || ''"'' ||',
'         '' data-pageid="''          || page_id || ''"'' ||',
'         '' data-typeid="''          || component_type_id || ''"'' ||',
'         '' data-componentid="''     || component_id || ''"'' ||',
'         '' data-designer="''        || designer_type || ''"''',
'       end ||',
'       ''>'' || wwv_flow_lang.system_message( ''VIEW_IN_BUILDER'' ) || ''</button>'' as view_button',
'  from wwv_flow_search_result_dev',
' order by order_value,',
'          attribute_name'))
,p_display_when_condition=>':P8000_SEARCH is not null and :P8000_START_SEARCH = ''0'''
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_translate_title=>'N'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(33634627411119986)
,p_query_num_rows=>9999
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>'Nothing found with the search term <strong>&P8000_SEARCH.</strong>'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>9999
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'REPEAT_HEADINGS_ON_BREAK_1'
,p_break_repeat_heading_format=>'<span style="white-space:nowrap;"><strong>#COLUMN_VALUE#</strong></span>'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(68885953031473503)
,p_query_column_id=>1
,p_column_alias=>'PATH'
,p_column_display_sequence=>10
,p_column_heading=>'Path'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(33635502250218990)
,p_query_column_id=>2
,p_column_alias=>'ATTRIBUTE_NAME'
,p_column_display_sequence=>20
,p_column_heading=>'Attribute'
,p_use_as_row_header=>'N'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(33635613519218990)
,p_query_column_id=>3
,p_column_alias=>'ATTRIBUTE_VALUE'
,p_column_display_sequence=>30
,p_column_heading=>'Value'
,p_use_as_row_header=>'N'
,p_column_hit_highlight=>'&P8000_SEARCH.'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(690213935224382244)
,p_query_column_id=>4
,p_column_alias=>'VIEW_BUTTON'
,p_column_display_sequence=>40
,p_column_heading=>'&nbsp;'
,p_use_as_row_header=>'N'
,p_column_html_expression=>'#VIEW_BUTTON#'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(33630423630995815)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(30710309677866793)
,p_button_name=>'P8000_GO'
,p_button_static_id=>'P8000_GO'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--padRight'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Search'
,p_button_alignment=>'LEFT-CENTER'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(385809145843243616)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(30710309677866793)
,p_button_name=>'P8000_CLOSE'
,p_button_static_id=>'P8000_CLOSE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Close'
,p_button_alignment=>'LEFT-CENTER'
,p_request_source=>'SEARCH'
,p_request_source_type=>'STATIC'
,p_grid_new_row=>'N'
,p_grid_new_column=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(30710630455872765)
,p_name=>'P8000_SEARCH'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(30710309677866793)
,p_prompt=>'Search'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>64
,p_cMaxlength=>4000
,p_begin_on_new_line=>'N'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the search term you are looking for. By prefixing your search term with <pre>regexp:</pre> you can perform a regular expression search. See Oracle Database documentation for more information about regular expression syntax.',
'</p>',
'<p>Example:',
'<pre>regexp:(P1_NAME)|(P2_NAME)</pre>',
'Will find all occurrences of P1_NAME and P2_NAME. ',
'</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(33748409937455691)
,p_name=>'P8000_CASE_SENSITIVE'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(30710309677866793)
,p_prompt=>'Case sensitive'
,p_source=>'N'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select this option if the search term you are looking for is case sensitive.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(34118613284626227)
,p_name=>'P8000_CURRENT_PAGE_ONLY'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(30710309677866793)
,p_prompt=>'Current page only'
,p_source=>'N'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select this option if you only wish to search the current page for the search term you have entered.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1157686899566338229)
,p_name=>'P8000_START_SEARCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(30710309677866793)
,p_source=>'0'
,p_source_type=>'STATIC'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1157686979614338230)
,p_computation_sequence=>10
,p_computation_item=>'P8000_START_SEARCH'
,p_computation_point=>'AFTER_FOOTER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'0'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(385809233568243617)
,p_name=>'CloseWindow'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(385809145843243616)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(385809378838243618)
,p_event_id=>wwv_flow_imp.id(385809233568243617)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'window.close();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1157687042687338231)
,p_name=>'Start Search'
,p_event_sequence=>20
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1157687165348338232)
,p_event_id=>wwv_flow_imp.id(1157687042687338231)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if ($v("P8000_START_SEARCH") === "1") {',
'    $s("P8000_START_SEARCH","0");',
'    doSearch();',
'}',
''))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1157687243160338233)
,p_name=>'Search'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(33630423630995815)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1157687308267338234)
,p_event_id=>wwv_flow_imp.id(1157687243160338233)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'doSearch();'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1157687459299338235)
,p_name=>'Enter'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P8000_SEARCH'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'keypress'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1157687509627338236)
,p_event_id=>wwv_flow_imp.id(1157687459299338235)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if (this.browserEvent.which === 13) {',
'    doSearch();',
'}'))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(33630019690985289)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Perform search'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    -- let''s perform the search',
'    wwv_flow_builder_search_dev.search_application (',
'        p_application_id => :FB_FLOW_ID,',
'        p_page_id        => case when :P8000_CURRENT_PAGE_ONLY = ''Y'' then :FB_FLOW_PAGE_ID end,',
'        p_case_sensitive => (nvl(:P8000_CASE_SENSITIVE, ''N'') = ''Y''),',
'        p_search_string  => :P8000_SEARCH );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>'P8000_SEARCH'
,p_process_when_type=>'ITEM_IS_NOT_NULL'
,p_internal_uid=>33630019690985289
);
end;
/
prompt --application/pages/page_08101
begin
wwv_flow_imp_page.create_page(
 p_id=>8101
,p_name=>'Advisor'
,p_alias=>'ADVISOR'
,p_step_title=>'Advisor'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_javascript_file_urls=>'#IMAGE_PREFIX#apex_ui/js/#MIN_DIRECTORY#f4000_searchResults#MIN#.js'
,p_step_template=>wwv_flow_imp.id(19943204431962826)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'debug.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(171875619216973594)
,p_name=>'Check Results'
,p_template=>wwv_flow_imp.id(208928010704475743)
,p_display_sequence=>20
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'role="region" aria-label="Check Results"'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select path,',
'       attribute_name,',
'       check_description,',
'       category_description,',
'       ''<pre>''||wwv_flow_escape.html_trunc(message_text, 3880)||''</pre>'' as message_text,',
'       help_text,',
'       ''<pre>''||wwv_flow_escape.html_trunc(attribute_value, 3880)||''</pre>'' as attribute_value,',
'       ''<button type="button" class="a-Button edit-button" data-link="'' ||',
'       wwv_flow_utilities.prepare_url( link_url ) || ''"'' ||',
'       case when component_type_id is not null then',
'         '' data-appid="''       || flow_id || ''"'' ||',
'         '' data-pageid="''      || page_id || ''"'' ||',
'         '' data-typeid="''      || component_type_id || ''"'' ||',
'         '' data-componentid="'' || component_id || ''"''',
'       end ||',
'       ''>'' || wwv_flow_lang.system_message( ''VIEW_IN_BUILDER'' ) || ''</button>'' as view_button',
'  from wwv_flow_advisor_result_dev',
' where flow_id       = :FB_FLOW_ID',
'   and :P8101_FILTER is not null',
'   and instr('':''||:P8101_FILTER||'':'', '':''||check_id||'':'') > 0',
' order by order_value,',
'          attribute_name,',
'          check_description'))
,p_display_when_condition=>'P8101_HAS_RESULT'
,p_display_when_cond2=>'Y'
,p_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(33634627411119986)
,p_query_num_rows=>9999
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'1'
,p_query_no_data_found=>'No errors/warnings found for the specified checks and categories.'
,p_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_query_row_count_max=>9999
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_break_type_flag=>'REPEAT_HEADINGS_ON_BREAK_1'
,p_break_repeat_heading_format=>'<span style="white-space:nowrap;"><strong>#COLUMN_VALUE#</strong></span>'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'F'
,p_query_asc_image_attr=>'width="13" height="12" alt=""'
,p_query_desc_image_attr=>'width="13" height="12" alt=""'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(171875832581973594)
,p_query_column_id=>1
,p_column_alias=>'PATH'
,p_column_display_sequence=>1
,p_column_heading=>'Path'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(171875918473973594)
,p_query_column_id=>2
,p_column_alias=>'ATTRIBUTE_NAME'
,p_column_display_sequence=>2
,p_column_heading=>'Attribute'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(172065624337353870)
,p_query_column_id=>3
,p_column_alias=>'CHECK_DESCRIPTION'
,p_column_display_sequence=>3
,p_column_heading=>'Check'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(171885706724034537)
,p_query_column_id=>4
,p_column_alias=>'CATEGORY_DESCRIPTION'
,p_column_display_sequence=>4
,p_column_heading=>'Category'
,p_use_as_row_header=>'N'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(171885815843034537)
,p_query_column_id=>5
,p_column_alias=>'MESSAGE_TEXT'
,p_column_display_sequence=>5
,p_column_heading=>'Message'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(172065724192353870)
,p_query_column_id=>6
,p_column_alias=>'HELP_TEXT'
,p_column_display_sequence=>6
,p_column_heading=>'Help Text'
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(171876019380973594)
,p_query_column_id=>7
,p_column_alias=>'ATTRIBUTE_VALUE'
,p_column_display_sequence=>7
,p_column_heading=>'Value'
,p_use_as_row_header=>'N'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_lov_show_nulls=>'NO'
,p_lov_display_extra=>'YES'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(690214074709382245)
,p_query_column_id=>8
,p_column_alias=>'VIEW_BUTTON'
,p_column_display_sequence=>8
,p_use_as_row_header=>'N'
,p_column_html_expression=>'#VIEW_BUTTON#'
,p_display_as=>'WITHOUT_MODIFICATION'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(172043008895384369)
,p_plug_name=>'Filter Result'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'The results are displayed for the checks that you performed.  You can filter the result set by unchecking any category or specific checks under Filter Results and clicking the Apply Filter button.',
'</p> ',
'<p>',
'To address the issues identified, click the View link within each result.  Once issues have been fixed, you can use the <em>Perform Check</em> button to re-run the report or view <em>Checks to Perform</em> to select different checks to be performed.',
'</p> ',
''))
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P8101_HAS_RESULT'
,p_plug_display_when_cond2=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(172072727716723789)
,p_plug_name=>'No Errors'
,p_region_template_options=>'#DEFAULT#:a-Alert--success:a-Alert--wizard'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(770240542605907344)
,p_plug_display_sequence=>30
,p_plug_source=>'<p>No errors or warnings found for the specified checks.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P8101_HAS_RESULT'
,p_plug_display_when_cond2=>'N'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1289323958309903542)
,p_plug_name=>'Check Page(s)'
,p_region_name=>'configuration'
,p_region_template_options=>'#DEFAULT#:is-expanded'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689970285456172024)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>The Advisor performs various checks on your application, including programming errors, security issues, quality assurance, and other best practices. For the list of checks, see <em>Checks to Perform</em>. Once executed, your previous settings will'
||' be recalled for the next use.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1253548469643954909)
,p_plug_name=>'Pages last edited within the last 7 days'
,p_region_name=>'last_pages'
,p_parent_plug_id=>wwv_flow_imp.id(1289323958309903542)
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(689970285456172024)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1289324822177903547)
,p_plug_name=>'Edited by me'
,p_parent_plug_id=>wwv_flow_imp.id(1253548469643954909)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare c pls_integer := 0;',
'begin',
'for c1 in (',
'select id',
'from wwv_flow_steps ',
'where flow_id = :fb_flow_id and ',
'          security_group_id = :flow_security_group_id and',
'          nvl(last_updated_on,created_on) > sysdate - 7 and',
'          nvl(last_updated_by,created_by) = :APP_USER',
'order by nvl(last_updated_on,created_on) desc ) loop',
'  c := c + 1;',
'  if c > 1 then sys.htp.prn('', ''); end if;',
'  sys.htp.prn(to_char(c1.id));',
'  if c > 100 then exit; end if;',
'end loop;',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1289325063575903547)
,p_plug_name=>'All edited pages'
,p_parent_plug_id=>wwv_flow_imp.id(1253548469643954909)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare c pls_integer := 0;',
'begin',
'for c1 in (',
'select id',
'from wwv_flow_steps ',
'where flow_id = :fb_flow_id and ',
'          security_group_id = :flow_security_group_id and',
'          nvl(last_updated_on,created_on) > sysdate - 7',
'order by nvl(last_updated_on,created_on) desc ) loop',
'  c := c + 1;',
'  if c > 1 then sys.htp.prn('', ''); end if;',
'  sys.htp.prn(to_char(c1.id));',
'  if c > 300 then exit; end if;',
'end loop;',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1289318474075864284)
,p_plug_name=>'Checks to Perform'
,p_region_name=>'checks_to_perform'
,p_parent_plug_id=>wwv_flow_imp.id(1289323958309903542)
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noBorder'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689970285456172024)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1289319229814864296)
,p_plug_name=>'left checkboxes'
,p_parent_plug_id=>wwv_flow_imp.id(1289318474075864284)
,p_region_template_options=>'#DEFAULT#:a-Form--labelsAbove'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>15
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1289320081911864300)
,p_plug_name=>'right checkboxes'
,p_parent_plug_id=>wwv_flow_imp.id(1289318474075864284)
,p_region_template_options=>'#DEFAULT#:a-Form--labelsAbove'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>16
,p_plug_new_grid_row=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1289324123074903542)
,p_plug_name=>'Check Page'
,p_parent_plug_id=>wwv_flow_imp.id(1289323958309903542)
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'Specify a comma separated list of pages to check, or leave blank to check all pages.'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(172079732629904948)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(172043008895384369)
,p_button_name=>'FILTER'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Apply Filter'
,p_button_position=>'EDIT'
,p_button_condition=>'P8101_HAS_RESULT'
,p_button_condition2=>'Y'
,p_button_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1289323892563901246)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(1289323958309903542)
,p_button_name=>'PERFORM_CHECK'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Perform Check'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1289318688677864288)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(1289318474075864284)
,p_button_name=>'SELECT_ALL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Select All'
,p_button_position=>'TOP'
,p_button_alignment=>'LEFT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1289318896947864292)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(1289318474075864284)
,p_button_name=>'DESELECT_ALL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Deselect All'
,p_button_position=>'TOP'
,p_button_alignment=>'LEFT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(171878324327973609)
,p_branch_name=>'Go To Page 8101'
,p_branch_action=>'f?p=&APP_ID.:8101:&SESSION.::&DEBUG.::::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(1289323892563901246)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(172058710420170031)
,p_name=>'P8101_HAS_RESULT'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(1289323958309903542)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(504967428701627048)
,p_name=>'P8101_FILTER'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(172043008895384369)
,p_prompt=>'Filter Result'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.HIERARCHICAL_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d, r, l',
'  from (select ''<strong>''||wwv_flow_escape.html(wwv_flow_lang.system_message(''ADVISOR.CATEGORY.''||code))||''</strong> (''||l.message_count||'')'' as d,',
'               c.id        as r,',
'               1           as l,',
'               category_id,',
'               order_seq',
'          from ( select category_id,',
'                        count(*) as message_count',
'                   from wwv_flow_advisor_result_dev',
'                  where flow_id = :FB_FLOW_ID',
'                  group by category_id',
'                 having count(*) > 0',
'               ) l,',
'               wwv_flow_advisor_categories c',
'         where c.id = l.category_id',
'         union all',
'        select wwv_flow_escape.html(description)||'' (''||l.message_count||'')'' as d,',
'               c.id        as r,',
'               2           as l,',
'               c.category_id,',
'               order_seq',
'          from ( select check_id,',
'                        count(*) as message_count',
'                   from wwv_flow_advisor_result_dev',
'                  where flow_id = :FB_FLOW_ID',
'                  group by check_id',
'                 having count(*) > 0',
'               ) l,',
'               ( select id,',
'                        nvl(description, wwv_flow_lang.system_message(''ADVISOR.CHECK.DESC_''||code)) as description,',
'                        category_id,',
'                        order_seq',
'                   from wwv_flow_advisor_checks',
'               ) c',
'         where c.id = l.check_id',
'       )',
' order by category_id, l, order_seq'))
,p_label_alignment=>'RIGHT-CENTER'
,p_field_alignment=>'LEFT-CENTER'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_encrypt_session_state_yn=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1289319099571864292)
,p_name=>'P8101_ALL_CHECKS'
,p_item_sequence=>260
,p_item_plug_id=>wwv_flow_imp.id(1289318474075864284)
,p_use_cache_before_default=>'NO'
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1289319416451864298)
,p_name=>'P8101_ERROR_CHECKS'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1289319229814864296)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_result varchar2(2000);',
'begin',
'    for l_check in (',
'        select code',
'          from wwv_flow_advisor_checks',
'         where is_default = ''Y'' )',
'    loop',
'        l_result := case when l_result is not null then l_result||'':'' end||',
'                    l_check.code;',
'    end loop;',
'    --',
'    return l_result;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Errors:'
,p_source=>'ADVISOR_CHECKS'
,p_source_type=>'PREFERENCE'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(description) as d,',
'       code as r',
'  from ( select nvl(chk.description, wwv_flow_lang.system_message(''ADVISOR.CHECK.DESC_''||chk.code)) as description,',
'                chk.code,',
'                chk.order_seq',
'           from wwv_flow_advisor_categories cat,',
'                wwv_flow_advisor_checks chk',
'          where cat.code        = ''ERROR''',
'            and chk.category_id = cat.id',
'            and chk.code       <> ''VERIFY_CLOB_PROPERTY''',
'            and chk.is_custom   = ''N''',
'            and (  chk.flow_id is null',
'                or chk.flow_id = :FB_FLOW_ID )',
'       )',
' order by order_seq'))
,p_label_alignment=>'ABOVE'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'    <dt>References with Substitution Syntax</dt>',
'    <dd>Does the item or tabular form column referenced with ''&amp;P999_NAME.'' exist?</dd>',
'    <dt>References with Column Syntax</dt>',
'    <dd>Does the report column referenced with #NAME# exist?</dd>',
'    <dt>References with Bind Variable Syntax</dt>',
'    <dd>Does the item or column referenced with '':P999_NAME'' exist?</dd>',
'    <dt>Declarative References of Application Items, Page Items, Columns or Interactive Report Filters</dt>',
'    <dd>Do the specified items and column aliases exist?</dd>',
'    <dt>Referenced Page Number Exists</dt>',
'    <dd>Does the referenced page number exists?</dd>',
'    <dt>Is Valid SQL or PL/SQL Code</dt>',
'    <dd>Verifies if the SQL statement or PL/SQL code is valid.</dd>',
'    <dt>Fetch, DML, MR* Processes are Valid</dt>',
'    <dd>Verifies that the table, columns, and runtime where clause are valid.</dd>',
'    <dt>Unconditional Branch before other Branches</dt>',
'    <dd>Is there an unconditional branch before another branch? If so, the other branch will never be executed.</dd>',
'    <dt>Referenced Button in When Button Pressed exists</dt>',
'    <dd>Does the button referenced in "When Button Pressed" of a process or validation exist?</dd>',
'    <dt>Button is not compatible with Dynamic Actions</dt>',
'    <dd>Buttons with an ID defined in ''Button Attributes'' or Template based buttons that reference a button template where the template does not contain the #BUTTON_ID# substitution string, are not compatible with Dynamic Actions.</dd>',
'</dl>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1289319600666864299)
,p_name=>'P8101_SECURITY_CHECKS'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(1289319229814864296)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_result varchar2(2000);',
'begin',
'    for l_check in (',
'        select code',
'          from wwv_flow_advisor_checks',
'         where is_default = ''Y'' )',
'    loop',
'        l_result := case when l_result is not null then l_result||'':'' end||',
'                    l_check.code;',
'    end loop;',
'    --',
'    return l_result;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Security:'
,p_source=>'ADVISOR_CHECKS'
,p_source_type=>'PREFERENCE'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(description) as d,',
'       code as r',
'  from ( select nvl(chk.description, wwv_flow_lang.system_message(''ADVISOR.CHECK.DESC_''||chk.code)) as description,',
'                chk.code,',
'                chk.order_seq',
'           from wwv_flow_advisor_categories cat,',
'                wwv_flow_advisor_checks chk',
'          where cat.code        = ''SECURITY''',
'            and chk.category_id = cat.id',
'            and chk.code        <> ''VERIFY_CLOB_PROPERTY''',
'            and chk.is_custom   = ''N''',
'            and (  chk.flow_id is null',
'                or chk.flow_id = :FB_FLOW_ID )',
'       )',
' order by order_seq'))
,p_label_alignment=>'ABOVE'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'    <dt>Inappropriate use of Substitution Syntax</dt>',
'    <dd>Checks if SQL or PL/SQL code contains an application, page item or tabular form column reference with the substitution syntax (example &NAME.). Such an item or column reference has the potential for SQL injection. Additionally, overall applic'
||'ation performance is better when using bind variables instead of item substitutions in SQL and PL/SQL.</dd>',
'    <dt>Application attributes that can be locked down</dt>',
'    <dd>Reports application level attributes that can be locked down to improve security.</dd>',
'    <dt>Authorization</dt>',
'    <dd>Reports missing or inconsistent authorizations.</dd>',
'    <dt>Session State Protection</dt>',
'    <dd>Reports missing session state protection.</dd>',
'    <dt>Browser Security Settings</dt>',
'    <dd>Reports security attributes that can be locked down to protect the client browser.</dd>',
'</dl>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
,p_item_comment=>'CNEUMUEL: MISSING_SYS_PREFIX is only enabled for builder apps'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1289319879223864300)
,p_name=>'P8101_WARNING_CHECKS'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(1289319229814864296)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_result varchar2(2000);',
'begin',
'    for l_check in (',
'        select code',
'          from wwv_flow_advisor_checks',
'         where is_default = ''Y'' )',
'    loop',
'        l_result := case when l_result is not null then l_result||'':'' end||',
'                    l_check.code;',
'    end loop;',
'    --',
'    return l_result;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Warnings:'
,p_source=>'ADVISOR_CHECKS'
,p_source_type=>'PREFERENCE'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(description) as d,',
'       code as r',
'  from ( select nvl(chk.description, wwv_flow_lang.system_message(''ADVISOR.CHECK.DESC_''||chk.code)) as description,',
'                chk.code,',
'                chk.order_seq',
'           from wwv_flow_advisor_categories cat,',
'                wwv_flow_advisor_checks chk',
'          where cat.code        = ''WARNING''',
'            and chk.category_id = cat.id',
'            and chk.code       <> ''VERIFY_CLOB_PROPERTY''',
'            and ( chk.code      <> ''APEX_CODE_SMELL'' or :WORKSPACE_ID between 10 and 20 )        ',
'            and chk.is_custom   = ''N''',
'            and (  chk.flow_id is null',
'                or chk.flow_id = :FB_FLOW_ID )',
'       )',
' order by order_seq'))
,p_label_alignment=>'ABOVE'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'    <dt>Referenced Item is on Current Page</dt>',
'    <dd>Do page items referenced in page components belong to the current page?</dd>',
'    <dt>Referenced Item is Page Item of Target Page</dt>',
'    <dd>Is the page item set in the link a page item within the target page?</dd>',
'    <dt>References of Page Item in a String</dt>',
'    <dd>Search for the patterns ''P999_NAME'' and "P999_NAME" and verify if they are valid page items. A page item name as a string might be used in JavaScript, V, NV or any other function or procedure call requiring a page item name.</dd>',
'    <dt>Clear Cache Page Number equals Target or Current Page</dt>',
'    <dd>Does the clear cache page number in a link match with the target or current page? This check is not performed if multiple clear cache page numbers are specified.</dd>',
'    <dt>Length of Item or Tabular Form Column Name</dt>',
'    <dd>Application, Page Items and Tabular Form Columns should be <= 30 characters long, otherwise they cannot be referenced with bind variable syntax.</dd>',
'    <dt>Inconsistent references between Dynamic Actions and Buttons</dt>',
'    <dd>Buttons referenced by Dynamic Actions with an ''Action'' not equal to ''Defined by Dynamic Action'' or Buttons with an ''Action'' of ''Defined by Dynamic Action'' and no corresponding Dynamic Action.</dd>',
'    <dt>Protected items in Ajax calls</dt>',
'    <dd>Items which have session state protection enabled should not be referenced in "Page Items to Submit" of items, interactive reports or dynamic actions. They can not be submitted without a valid checksum value.</dd>',
'    <dt>Legacy Orphan Components</dt>',
'    <dd>Search for items and buttons that are assigned to the "Legacy Orphan Components" slot, which is not a valid slot.</dd>',
'</dl>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1289320295084864300)
,p_name=>'P8101_PERFORMANCE_CHECKS'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(1289320081911864300)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_result varchar2(2000);',
'begin',
'    for l_check in (',
'        select code',
'          from wwv_flow_advisor_checks',
'         where is_default = ''Y'' )',
'    loop',
'        l_result := case when l_result is not null then l_result||'':'' end||',
'                    l_check.code;',
'    end loop;',
'    --',
'    return l_result;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Performance:'
,p_source=>'ADVISOR_CHECKS'
,p_source_type=>'PREFERENCE'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(description) as d,',
'       code as r',
'  from ( select nvl(chk.description, wwv_flow_lang.system_message(''ADVISOR.CHECK.DESC_''||chk.code)) as description,',
'                chk.code,',
'                chk.order_seq',
'           from wwv_flow_advisor_categories cat,',
'                wwv_flow_advisor_checks chk',
'          where cat.code        = ''PERFORMANCE''',
'            and chk.category_id = cat.id',
'            and chk.code       <> ''VERIFY_CLOB_PROPERTY''',
'            and chk.is_custom   = ''N''',
'            and (  chk.flow_id is null',
'                or chk.flow_id = :FB_FLOW_ID )',
'       )',
' order by order_seq'))
,p_begin_on_new_line=>'N'
,p_label_alignment=>'ABOVE'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'    <dt>V Function used in SQL Statements</dt>',
'    <dd>Using the V/NV/DV in SQL statements can result in performance problems. Use bind variable syntax instead.</dd>',
'    <dt>User Interface includes compatibility JavaScript</dt>',
'    <dd>User Interface includes compatibility JavaScript, either Deprecated / Desupported APEX JavaScript, or jQuery Migrate</dd>',
'</dl>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1289320450173864301)
,p_name=>'P8101_USABILITY_CHECKS'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(1289320081911864300)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_result varchar2(2000);',
'begin',
'    for l_check in (',
'        select code',
'          from wwv_flow_advisor_checks',
'         where is_default = ''Y'' )',
'    loop',
'        l_result := case when l_result is not null then l_result||'':'' end||',
'                    l_check.code;',
'    end loop;',
'    --',
'    return l_result;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Usability:'
,p_source=>'ADVISOR_CHECKS'
,p_source_type=>'PREFERENCE'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(description) as d,',
'       code as r',
'  from ( select nvl(chk.description, wwv_flow_lang.system_message(''ADVISOR.CHECK.DESC_''||chk.code)) as description,',
'                chk.code,',
'                chk.order_seq',
'           from wwv_flow_advisor_categories cat,',
'                wwv_flow_advisor_checks chk',
'          where cat.code        = ''USABILITY''',
'            and chk.category_id = cat.id',
'            and chk.code       <> ''VERIFY_CLOB_PROPERTY''',
'            and chk.is_custom   = ''N''',
'            and (  chk.flow_id is null',
'                or chk.flow_id = :FB_FLOW_ID )',
'       )',
' order by order_seq'))
,p_label_alignment=>'ABOVE'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'    <dt>Target Page Authorization is also set for Current Component</dt>',
'    <dd>If a target page has an authorization scheme associated with it, does the processed component also have the same authorization scheme? If not, a user may see a tab, but will get an error when it is clicked.</dd>',
'    <dt>Associated Item or Column of Validations</dt>',
'    <dd>Checks if the item or tabular form column used in the validation expression matches with the Associated Item\Column.  Also checks if an Associated Item\Column is selected when necessary, such as when validations are to be displayed "Inline wi'
||'th Field".</dd>',
'</dl>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1289320632943864301)
,p_name=>'P8101_QA_CHECKS'
,p_item_sequence=>220
,p_item_plug_id=>wwv_flow_imp.id(1289320081911864300)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_result varchar2(2000);',
'begin',
'    for l_check in (',
'        select code',
'          from wwv_flow_advisor_checks',
'         where is_default = ''Y'' )',
'    loop',
'        l_result := case when l_result is not null then l_result||'':'' end||',
'                    l_check.code;',
'    end loop;',
'    --',
'    return l_result;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Quality Assurance:'
,p_source=>'ADVISOR_CHECKS'
,p_source_type=>'PREFERENCE'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(description) as d,',
'       code as r',
'  from ( select nvl(chk.description, wwv_flow_lang.system_message(''ADVISOR.CHECK.DESC_''||chk.code)) as description,',
'                chk.code,',
'                chk.order_seq',
'           from wwv_flow_advisor_categories cat,',
'                wwv_flow_advisor_checks chk',
'          where cat.code        = ''QA''',
'            and chk.category_id = cat.id',
'            and chk.code       <> ''VERIFY_CLOB_PROPERTY''',
'            and chk.is_custom   = ''N''',
'            and (  chk.flow_id is null',
'                or chk.flow_id = :FB_FLOW_ID )',
'       )',
' order by order_seq'))
,p_label_alignment=>'ABOVE'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'    <dt>Hardcoded Application ID</dt>',
'    <dd>Has the current Application ID been hard coded in links?</dd>',
'    <dt>Report has Default Order</dt>',
'    <dd>Is the "Sort Sequence" set at least for one column of the report or does the SQL statement contain the ORDER BY clause.</dd>',
'    <dt>Page Item has Help Text</dt>',
'    <dd>Does each page item with a label template of type "Optional Label with Help" or "Required Label with Help" have help text?</dd>',
'    <dt>Deprecated attribute values</dt>',
'    <dd>Reports page and page component attributes which are set to deprecated values</dd>',
'</dl>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1289324354932903543)
,p_name=>'P8101_PAGE_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1289324123074903542)
,p_prompt=>'Page(s)'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>32767
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the page number or numbers to for which the check should be restricted.  Enter no value to check all pages.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1703136529372369148)
,p_name=>'P8101_ACCESSIBILITY_CHECKS'
,p_item_sequence=>230
,p_item_plug_id=>wwv_flow_imp.id(1289320081911864300)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_result varchar2(2000);',
'begin',
'    for l_check in (',
'        select code',
'          from wwv_flow_advisor_checks',
'         where is_default = ''Y'' )',
'    loop',
'        l_result := case when l_result is not null then l_result||'':'' end||',
'                    l_check.code;',
'    end loop;',
'    --',
'    return l_result;',
'end;'))
,p_item_default_type=>'FUNCTION_BODY'
,p_item_default_language=>'PLSQL'
,p_prompt=>'Accessibility:'
,p_source=>'ADVISOR_CHECKS'
,p_source_type=>'PREFERENCE'
,p_display_as=>'NATIVE_CHECKBOX'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(description) as d,',
'       code as r',
'  from ( select nvl(chk.description, wwv_flow_lang.system_message(''ADVISOR.CHECK.DESC_''||chk.code)) as description,',
'                chk.code,',
'                chk.order_seq',
'           from wwv_flow_advisor_categories cat,',
'                wwv_flow_advisor_checks chk',
'          where cat.code        = ''ACCESSIBILITY''',
'            and chk.category_id = cat.id',
'            and chk.code       <> ''VERIFY_CLOB_PROPERTY''',
'            and chk.is_custom   = ''N''',
'            and (  chk.flow_id is null',
'                or chk.flow_id = :FB_FLOW_ID )',
'       )',
' order by order_seq'))
,p_label_alignment=>'ABOVE'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_output=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<dl>',
'    <dt>Theme Style tested for accessibility</dt>',
'    <dd>Is your app using a Theme Style that has been tested for accessibility? Theme Styles that have not been accessibility tested may contain more issues, such as insufficient color contrast.</dd>',
'    <dt>Page has page title</dt>',
'    <dd>Does the page have a title? Meaningful page titles are important for accessibility, to help users understand the content and purpose of the current page. Note: Global pages, and pages with no regions are excluded from this check.</dd>',
'    <dt>Region has Row Header</dt>',
'    <dd>Regions that support row headers should have a column with the "Use as Row Header" attribute set to Yes.</dd>',
'    <dt>Chart type supports accessibility</dt>',
'    <dd>Are you using any older Chart Types that have limited accessibility support? These should instead be switched to using our new charts based on Oracle JET.</dd>',
'    <dt>Page item has label</dt>',
'    <dd>Does the item have a label defined? For example just defining the ''Value Placeholder'' text is not sufficient in labelling an item for accessibility.</dd>',
'    <dt>Page item does not cause an unexpected context change</dt>',
'    <dd>Some page item settings can cause an unexpected change of context for the user, such as select lists that submit the page after a value is selected. Unless the user has prior warning that this will happen, this represents an accessibility iss'
||'ue.</dd>',
'    <dt>Display Image item has image ALT text defined</dt>',
'    <dd>Display Image page items must provide text, or a column (depending on the Based On setting), that will be used as the image''s alternative text. This is important for accessibility, as without it some user''s may have no way of perceiving the c'
||'ontent of the image.</dd>',
'</dl>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'1'
,p_multi_value_type=>'SEPARATED'
,p_multi_value_separator=>':'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1289332684453915182)
,p_computation_sequence=>30
,p_computation_item=>'P8101_ALL_CHECKS'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_result varchar2(32767);',
'    procedure add (',
'        p_checks in varchar2 )',
'    is',
'    begin',
'        if p_checks is not null then',
'            l_result := l_result||',
'                        case when l_result is not null then '':'' end||',
'                        p_checks;',
'        end if;',
'    end add;',
'begin',
'    add(:P8101_ERROR_CHECKS);',
'    add(:P8101_SECURITY_CHECKS);',
'    add(:P8101_WARNING_CHECKS);',
'    add(:P8101_PERFORMANCE_CHECKS);',
'    add(:P8101_QA_CHECKS);',
'    add(:P8101_USABILITY_CHECKS);',
'    add(:P8101_ACCESSIBILITY_CHECKS);',
'    return l_result;',
'end;'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(1289333036545916435)
,p_computation_sequence=>30
,p_computation_item=>'P8101_ALL_CHECKS'
,p_computation_type=>'FUNCTION_BODY'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_result varchar2(2000);',
'begin',
'    l_result := wwv_flow_preferences.get_preference(''ADVISOR_CHECKS'');',
'',
'    if l_result is null then',
'        for l_check in (',
'            select code',
'              from wwv_flow_advisor_checks',
'             where is_default = ''Y'' )',
'        loop',
'            l_result := case when l_result is not null then l_result||'':'' end||',
'                        l_check.code;',
'        end loop;',
'    end if;',
'    --',
'    return l_result;',
'end;'))
,p_compute_when=>'P8101_ALL_CHECKS'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1253548558373954910)
,p_name=>'Perform Check'
,p_event_sequence=>10
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1289323892563901246)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1253548649011954911)
,p_event_id=>wwv_flow_imp.id(1253548558373954910)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'PERFORM_CHECK'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1253548729095954912)
,p_name=>'Select All'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1289318688677864288)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1253548824088954913)
,p_event_id=>wwv_flow_imp.id(1253548729095954912)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'apex.jQuery(":checkbox").prop("checked", true);',
''))
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1253548997962954914)
,p_name=>'Select None'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1289318896947864292)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1253549050315954915)
,p_event_id=>wwv_flow_imp.id(1253548997962954914)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'apex.jQuery(":checkbox").prop("checked", false);'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1253549100966954916)
,p_name=>'Collapse/Expand "Check Pages"'
,p_event_sequence=>40
,p_triggering_condition_type=>'JAVASCRIPT_EXPRESSION'
,p_triggering_expression=>'$v( "P8101_HAS_RESULT" ) === ""'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1253549377829954918)
,p_event_id=>wwv_flow_imp.id(1253549100966954916)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1289323958309903542)
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// If no result is displayed we always want to see the "Check Page(s)" region!',
'this.affectedElements.collapsible( "expand" );'))
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1253549208328954917)
,p_event_id=>wwv_flow_imp.id(1253549100966954916)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1289323958309903542)
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// As soon as we have performed a check, we do want to hide the check details',
'this.affectedElements.collapsible( "collapse" );'))
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1253549496513954919)
,p_event_id=>wwv_flow_imp.id(1253549100966954916)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1253548469643954909)
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// Avoid clutter',
'this.affectedElements.collapsible( "collapse" );'))
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1253549522170954920)
,p_event_id=>wwv_flow_imp.id(1253549100966954916)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1289318474075864284)
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'// Avoid clutter',
'this.affectedElements.collapsible( "collapse" );'))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1289333372117920049)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_USER_PREFERENCES'
,p_process_name=>'Set preference'
,p_attribute_01=>'SET_PREFERENCE_TO_ITEM_VALUE_IF_ITEM_NOT_NULL'
,p_attribute_02=>'ADVISOR_CHECKS'
,p_attribute_03=>'P8101_ALL_CHECKS'
,p_process_when_button_id=>wwv_flow_imp.id(1289323892563901246)
,p_internal_uid=>1289333372117920049
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1289335637278921844)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Perform checks'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare ',
'    l_pages        varchar2(32767);',
'    l_temp_list    wwv_flow_global.vc_arr2;',
'    l_page_id_list wwv_flow_global.n_arr;',
'    l_count        number;',
'begin',
'    if :P8101_PAGE_ID is not null then',
'        -- set all whitespace to a comma',
'        l_pages := replace(replace(replace(replace(replace(:P8101_PAGE_ID,'' '','',''),chr(10),'' ''),chr(13),null),'':'','',''),'';'','','');',
'        -- create table of pages',
'        l_temp_list := wwv_flow_utilities.string_to_table2(:P8101_PAGE_ID, '','');',
'        for i in 1 .. l_temp_list.count',
'        loop',
'            if l_temp_list(i) is not null and wwv_flow_utilities.is_numeric(l_temp_list(i)) then',
'                l_page_id_list(l_page_id_list.count+1) := l_temp_list(i);',
'            end if;',
'        end loop;',
'    end if;',
'    ',
'    -- let''s perform the check',
'    wwv_flow_advisor_dev.check_application (',
'        p_application_id => :FB_FLOW_ID,',
'        p_page_id_list   => l_page_id_list,',
'        p_check_list     => wwv_flow_utilities.string_to_table(:P8101_ALL_CHECKS) );',
'',
'    -- verify result',
'    select count(*)',
'      into l_count',
'      from wwv_flow_advisor_result_dev;',
'    ',
'    :P8101_HAS_RESULT := case when l_count > 0 then ''Y'' else ''N'' end;',
'',
'    -- re-initialize filter checkboxes',
'    :P8101_FILTER := null;',
'    for l_filter in ( select category_id as val',
'                        from wwv_flow_advisor_result_dev',
'                       where flow_id = :FB_FLOW_ID',
'                       union',
'                      select check_id as val',
'                        from wwv_flow_advisor_result_dev',
'                       where flow_id = :FB_FLOW_ID )',
'    loop',
'        :P8101_FILTER := :P8101_FILTER ||',
'                         case when :P8101_FILTER is not null then '':'' end ||',
'                         l_filter.val;',
'    end loop;',
'',
'exception when others then',
'    wwv_flow_error.raise_internal_error (',
'        p_error_message => sqlerrm );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(1289323892563901246)
,p_internal_uid=>1289335637278921844
);
end;
/
prompt --application/pages/page_09000
begin
wwv_flow_imp_page.create_page(
 p_id=>9000
,p_name=>'Manage Tabs'
,p_alias=>'MANAGE-TABS'
,p_step_title=>'Manage Tabs'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213240607818867991)
,p_html_page_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<style type="text/css">             ',
'.tabmgrPageCur{                     ',
'    font-size: 8pt;                 ',
'    height:70px;                    ',
'    width:60px;                     ',
'    text-align:center;              ',
'    border:1px #9cadcc solid;       ',
'    color:#9cadcc;    ',
'    text-overflow:elipsis;',
'    overflow:hidden;',
'    white-space:normal;',
'}                                   ',
'                                    ',
'.tabmgrPageAlsoCur{                 ',
'    font-size: 8pt;                 ',
'    height:70px;                    ',
'    width:60px;                     ',
'    text-align:center;              ',
'    border:1px #cccccc solid;       ',
'    color:#9cadcc;                  ',
'    float:left;                     ',
'    margin-right:10px;              ',
'    text-overflow:elipsis;',
'    overflow:hidden;',
'    white-space:normal;',
'                                    ',
'}                                   ',
'                                    ',
'.tabmgrAddPage{                     ',
'    font-size: 8pt;                 ',
'    padding:3px;                    ',
'    height:70px;                    ',
'    width:60px;                     ',
'    text-align:center;              ',
'    border:1px #999999 dashed;      ',
'    background-color:#eeeeee;       ',
'}                                   ',
'                                    ',
'.tabmgrStdOn{                       ',
'    font-size: 8pt;                 ',
'    padding:3px;                    ',
'    height:20px;                    ',
'    padding-left:5px;               ',
'    padding-right:5px;              ',
'    text-align:center;              ',
'    font-weight:bold;               ',
'    background-color:#9cadcc;       ',
'    color:#ffffff;                  ',
'    font-size:8pt;                  ',
'}                                   ',
'                                    ',
'.tabmgrStdOff{                      ',
'    font-size: 8pt;                 ',
'    padding:3px;                    ',
'    height:20px;                    ',
'    padding-left:5px;               ',
'    padding-right:5px;              ',
'    text-align:center;              ',
'    background-color:#9cadcc;       ',
'    color:#222222;                  ',
'}                                   ',
'',
'.tabmgrStdOff a:link,.tabmgrStdOff a:visited{color:#222222;}',
'                                 ',
'.tabmgrStdAdd{                      ',
'    font-size: 8pt;                 ',
'    height:20px;                    ',
'    width: 50px;                    ',
'    background-color:#eeeeee;       ',
'    border:1px #999999 dashed;      ',
'    padding: 3px;                   ',
'    text-align:center;              ',
'}                                   ',
'                                    ',
'.tabmgrPntOn{                       ',
'    font-size: 8pt;                 ',
'    margin:6px;                     ',
'    padding:3px;                    ',
'    height:20px;                    ',
'    width:65px;                     ',
'    text-align:center;              ',
'    font-weight:bold;               ',
'    background-color:#9cadcc;       ',
'    color:#ffffff;                  ',
'}                                   ',
'                                    ',
'.tabmgrPntOff{                      ',
'    font-size: 8pt;                 ',
'    margin:6px;                     ',
'    padding:3px;                    ',
'    height:20px;                    ',
'    width:50px;                     ',
'    text-align:center;              ',
'    background-color:#9cadcc;       ',
'    color:#ffffff;                  ',
'    border-left:1px #9cadcc solid;  ',
'    border-top:1px #9cadcc solid;   ',
'    border-right:1px #9cadcc solid; ',
'    background-color:#cccccc;       ',
'    color:#000000                   ',
'}                                   ',
'                                    ',
'.tabmgrPntAdd{                      ',
'    font-size: 8pt;                 ',
'    margin:6px;                     ',
'    padding:3px;                    ',
'    height:20px;                    ',
'    width:30px;                     ',
'    text-align:center;              ',
'    color:#ffffff;                  ',
'    border-left:1px #999999 dashed; ',
'    border-top:1px #999999 dashed;  ',
'    border-right:1px #999999 dashed;',
'    background-color:#eeeeee;}      ',
'                                    ',
'.tabmgrPntNoneOn{                   ',
'    font-size: 8pt;                 ',
'    margin:6px;                     ',
'    padding:3px;                    ',
'    height:20px;                    ',
'    width:80px;                     ',
'    text-align:center;              ',
'    font-size:8pt;                  ',
'    font-weight:bold;               ',
'    color:#ffffff;                  ',
'    border-left: 2px #cccccc dashed;',
'    border-top:  2px #cccccc dashed;',
'    border-right:2px #cccccc dashed;',
'    background-color:#9cadcc;       ',
'}                                   ',
'                                    ',
'.tabmgrPntNoneOff{                  ',
'    font-size: 8pt;                 ',
'    margin:6px;                     ',
'    padding:3px;                    ',
'    height:20px;                    ',
'    width:70px;                     ',
'    text-align:center;              ',
'    font-size:8pt;                  ',
'    color:#ffffff;                  ',
'    border-left: 2px #9cadcc dashed;',
'    border-top:  2px #9cadcc dashed;',
'    border-right:2px #9cadcc dashed;',
'    background-color:#cccccc;       ',
'}                                   ',
'                                    ',
'.tabmgrPntPseudoOn{                 ',
'    font-size: 8pt;                 ',
'    margin:6px;                     ',
'    padding:3px;                    ',
'    height:20px;                    ',
'    width:50px;                     ',
'    text-align:center;              ',
'    font-size:8pt;                  ',
'    font-weight:bold;               ',
'    color:#ffffff;                  ',
'    border-left: 2px #cccccc dashed;',
'    border-top:  2px #cccccc dashed;',
'    border-right:2px #cccccc dashed;',
'    background-color:#9cadcc;       ',
'}                                   ',
'                                    ',
'.tabmgrPntPseudoOff{                ',
'    font-size: 8pt;                 ',
'    margin:6px;                     ',
'    padding:3px;                    ',
'    height:20px;                    ',
'    width:50px;                     ',
'    text-align:center;              ',
'    font-size:8pt;                  ',
'    color:#ffffff;                  ',
'    border-left: 2px #9cadcc dashed;',
'    border-top:  2px #9cadcc dashed;',
'    border-right:2px #9cadcc dashed;',
'    background-color:#cccccc;       ',
'}                                                                    ',
'',
'#tabInfo td{padding-right:5px;}',
'                                    ',
'</style>                            '))
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(28723731200606674)
,p_plug_name=>'Parent Tab Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(165884427300110704)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
,p_plug_display_condition_type=>'EXISTS'
,p_plug_display_when_condition=>'select 1 from WWV_FLOW_TOPLEVEL_TABS where flow_id = :fb_flow_id'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(28903824226344284)
,p_plug_name=>'Tabs'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page displays a graphical representation of the Tabs defined in your application.</p>',
'<p>Use Standard Tabs to link users to a specific page. A Parent Tab functions as a container to hold a group of Standard Tabs. Parent Tabs give users another level of navigation as well as a sense of place within the application.</p>',
'<p>Click <strong>Add</strong> in the upper row to add Parent Tabs. Click <strong>Add</strong> in the lower row to add Standard Tabs.</p> ',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(35063524529617959)
,p_plug_name=>'Standard Tab Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(35060712015585948)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(40991013498419203)
,p_plug_name=>'Tab List'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>40
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_tab_mgr.tabs(',
'    p_flow          => :fb_flow_id,',
'    p_session       => :SESSION,',
'    p_img_prefix    => ''#IMAGE_PREFIX#'',',
'    p_current_stab  => :F4000_CUR_STD_TAB,',
'    p_current_page  => :F4000_P9000_PAGE,',
'    p_current_ptab  => :F4000_P9000_CUR_PTAB',
');'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_header=>'Click on a tab name to make a tab current.  Once you select a tab you will be able to change that tab''s properties.'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(46196824027657446)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(5297709875)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(50286210849589701)
,p_plug_name=>'warning'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'   l_flow number;',
'   l_page number;',
'   j int; x varchar2(4000);',
'   l_pg_found boolean := false;',
'begin',
'for c1 in (select TAB_TARGET from wwv_flow_toplevel_tabs',
'            where id = :F4000_P9000_CUR_PTAB',
'              and security_group_id = :flow_security_group_id ) loop',
'   --sys.htp.p(c1.tab_target);',
'   if instr(c1.tab_target,'':'') > 0 and ',
'      upper(substr(c1.tab_target,1,4))=''F?P='' then',
'      x := substr(c1.tab_target,5);',
'      j := instr(x,'':''); ',
'      l_flow := substr(x,1,j-1); ',
'      x := substr(x,j+1); ',
'      j := instr(x,'':'');',
'      l_page := substr(x,1,j-1); ',
'   end if;',
'   --sys.htp.p(l_flow);',
'   --sys.htp.p(l_page);',
'   for c2 in (select 1 from wwv_flow_steps ',
'               where flow_id = l_flow',
'                 and security_group_id = :flow_security_group_id',
'                 and id = l_page ) loop',
'    l_pg_found := true;',
'   end loop;',
'   if not l_pg_found then',
'      sys.htp.p(''<span class="instructiontext">''||',
'          wwv_flow_lang.system_message(p_name=>''TAB_MANAGER.WARNING'',p0=>wwv_flow_escape.html(c1.tab_target)));',
'   end if;',
'end loop;',
'exception when others then',
'   null;',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_query_row_template=>wwv_flow_imp.id(79387910442923002)
,p_plug_query_num_rows=>1500
,p_plug_query_num_rows_type=>'0'
,p_plug_query_row_count_max=>5000
,p_plug_query_show_nulls_as=>'(null)'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(185885705983544002)
,p_plug_name=>'Parent Tab Tasks'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>No parent tabs exist.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'NOT_EXISTS'
,p_plug_display_when_condition=>'select 1 from WWV_FLOW_TOPLEVEL_TABS where flow_id = :fb_flow_id'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(41486418275203439)
,p_branch_action=>'9000'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(41048805076292043)
,p_name=>'F4000_P9000_CUR_PTAB'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(40991013498419203)
,p_prompt=>'F4000_P9000_CUR_PTAB'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_restricted_characters=>'WEB_SAFE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(49331618592021132)
,p_name=>'F4000_P9000_PAGE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(40991013498419203)
,p_prompt=>'F4000_P9000_PAGE'
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_item_template_options=>'#DEFAULT#'
,p_restricted_characters=>'WEB_SAFE'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(36278805375348469)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'9000'
,p_computation_error_message=>'Unable to compute item value.'
,p_compute_when_type=>'%null%'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(49500503766225514)
,p_validation_name=>'F4000_CUR_STD_TAB not null'
,p_validation_sequence=>10
,p_validation=>'F4000_CUR_STD_TAB'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Standard Tab must be specified.'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1143101075566434579)
,p_name=>'refresh Tab List'
,p_event_sequence=>10
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(40991013498419203)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'apexafterclosedialog'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1143101340209434585)
,p_event_id=>wwv_flow_imp.id(1143101075566434579)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'var lSuccessMsg = this.data.APEX_SUCCESS_MESSAGE,',
'      lUrl = ''f?p=&APP_ID.:9000:&SESSION.::'',',
'      lVal = this.data[ ''REQUEST'' ];',
'',
'if ( lSuccessMsg ) {',
'   lUrl += ''&success_msg='' + lSuccessMsg;',
'}',
'setTimeout(function() {',
'    apex.navigation.redirect(lUrl);',
'}, 0);'))
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(50384724324720175)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_SESSION_STATE'
,p_process_name=>'CLEAR Page 77'
,p_attribute_01=>'CLEAR_CACHE_FOR_PAGES'
,p_attribute_04=>'77'
,p_internal_uid=>50384724324720175
);
end;
/
prompt --application/pages/page_09005
begin
wwv_flow_imp_page.create_page(
 p_id=>9005
,p_name=>'Tab Manager: Add Page(s)'
,p_alias=>'TAB-MANAGER-ADD-PAGE-S'
,p_step_title=>'Add Tab Association'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213240607818867991)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'nav_tabs.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(42885205674387110)
,p_plug_name=>'Tab Association'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<p>Select the page to be displayed when clicking on the tab.  Optionally, enter other pages that will display this tab as current.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(42915318577426701)
,p_plug_name=>'Add Tab Association'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>140
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(44157316349655128)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(42915318577426701)
,p_button_name=>'CANCEL'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(44170624445666940)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(42915318577426701)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'CREATE'
,p_button_cattributes=>' tabindex="2"'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(44157728149655143)
,p_branch_action=>'9000'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(44157316349655128)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(44171029730666942)
,p_branch_action=>'9000'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'BRANCH_TO_STEP'
,p_branch_when_button_id=>wwv_flow_imp.id(44170624445666940)
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(42888532619389835)
,p_name=>'F4000_P9005_TAB'
,p_item_sequence=>1
,p_item_plug_id=>wwv_flow_imp.id(42915318577426701)
,p_prompt=>'Tab:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Name of the current tab you are editing.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(42891525287393167)
,p_name=>'F4000_P9005_TAB_SET'
,p_item_sequence=>2
,p_item_plug_id=>wwv_flow_imp.id(42915318577426701)
,p_prompt=>'Standard Tab - Tab Set:'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The tab set that the tab you are currently editing belongs to. Tab sets are collections of related tabs.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(42895216014397540)
,p_name=>'F4000_P9005_TAB_ID'
,p_item_sequence=>4
,p_item_plug_id=>wwv_flow_imp.id(42915318577426701)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(42992521725531592)
,p_name=>'F4000_P9005_CUR_PAGE'
,p_item_sequence=>5
,p_item_plug_id=>wwv_flow_imp.id(42915318577426701)
,p_prompt=>'Current Page'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'SELECT ID||''-''||NAME D,ID R',
'',
'FROM WWV_FLOW_STEPS',
'',
'WHERE FLOW_ID = :FB_FLOW_ID'))
,p_cSize=>10
,p_cMaxlength=>2000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Identify which page this tab is current for.  When a user clicks on the tab, they will navigate to this page.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(43699306320918662)
,p_name=>'F4000_P9005_ALSO_CUR'
,p_item_sequence=>6
,p_item_plug_id=>wwv_flow_imp.id(42915318577426701)
,p_prompt=>'Also Current for Pages (comma delimited list of pages)'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select TAB_ALSO_CURRENT_FOR_PAGES',
'',
'  from wwv_flow_tabs',
'',
' where id = :F4000_P9005_TAB_ID'))
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>64
,p_cMaxlength=>32767
,p_cHeight=>6
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'List the page numbers that will (in addition to the current page attribute) cause this tab to be "current".  The current tab is the tab selected.  For example:',
'',
'<pre>',
'',
'3,4,8',
'',
'</pre>',
'',
'The list above would cause pages 3, 4 and 8 to be also current for the given tab.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'NONE'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(186016712712056941)
,p_validation_name=>'Current page not null'
,p_validation_sequence=>10
,p_validation=>'F4000_P9005_CUR_PAGE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'Current page must be specified'
,p_when_button_pressed=>wwv_flow_imp.id(44170624445666940)
,p_associated_item=>wwv_flow_imp.id(42992521725531592)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(186019305224064245)
,p_validation_name=>'Current page must be a number'
,p_validation_sequence=>20
,p_validation=>'F4000_P9005_CUR_PAGE'
,p_validation_type=>'ITEM_IS_NUMERIC'
,p_error_message=>'Current page must be numeric'
,p_when_button_pressed=>wwv_flow_imp.id(44170624445666940)
,p_associated_item=>wwv_flow_imp.id(42992521725531592)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(248922131113274331)
,p_validation_name=>'ensure proper also current for page numbers'
,p_validation_sequence=>30
,p_validation=>'return true;'
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Invalid value, use properly delimited page numbers'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(42938228029467909)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'POPULATE TAB INFO'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select TAB_TEXT,TAB_SET,TAB_STEP',
'into :F4000_P9005_TAB,:F4000_P9005_TAB_SET,:F4000_P9005_CUR_PAGE',
'from wwv_flow_tabs',
'where id = :F4000_P9005_TAB_ID'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>42938228029467909
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(44147020176641548)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'UPDATE'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_tab_mgr.update_tab_pages(',
'        p_tab_id        => :F4000_P9005_TAB_ID,',
'        p_tab_set       => :F4000_P9005_TAB_SET,',
'        p_flow          => :fb_flow_id,',
'        p_tab_page      => :F4000_P9005_CUR_PAGE,',
'        p_also_cur_for  => :F4000_P9005_ALSO_CUR);'))
,p_process_clob_language=>'PLSQL'
,p_process_when_button_id=>wwv_flow_imp.id(44170624445666940)
,p_internal_uid=>44147020176641548
);
end;
/
prompt --application/pages/page_09006
begin
wwv_flow_imp_page.create_page(
 p_id=>9006
,p_name=>'Configure Session State Protection'
,p_alias=>'CONFIGURE-SESSION-STATE-PROTECTION'
,p_step_title=>'Configure Session State Protection'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'sec_session_protection.htm'
,p_page_component_map=>'17'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(109644632478757939)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(109642120442735590)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(110815404272935626)
,p_plug_name=>'Application Session State Protection Controls'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_footer=>'<p />'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(114201125450070219)
,p_plug_name=>'Page and Item Attributes'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<p>Select security attributes for pages and items. You may accept the default settings displayed here, or make new selections. Note that the value you choose for an attribute category will be applied to all pages and items throughout the application.'
||'</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(208201821610056060)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747150046530138181)
,p_plug_name=>'Set Application Protection'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(109624632275452566)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(208201821610056060)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:510:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(109648706122797609)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(208201821610056060)
,p_button_name=>'NEXT'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Next'
,p_button_position=>'CREATE'
,p_icon_css_classes=>'icon-right-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(109628129074470573)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(208201821610056060)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:525:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(110713302730648390)
,p_branch_action=>'f?p=&APP_ID.:9007:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(110817930758945836)
,p_name=>'P9006_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(110815404272935626)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application:'
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'This attribute identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(110818806994948415)
,p_name=>'P9006_APPLICATION_SESSION_STATE_SECURITY'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(110815404272935626)
,p_item_default=>'N'
,p_prompt=>'Session State Protection:'
,p_source=>'select PAGE_PROTECTION_ENABLED_Y_N from wwv_flows where id = :fb_flow_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'ENABLED_DISABLED_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(91439803955181562)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p />',
'Indicates whether Session State Protection is enabled or disabled. When enabled, this feature, uses the <i>Page Access Protection</i> page attributes and the <i>Session State Protection</i> item attributes in conjunction with checksums positioned in '
||'"f?p=" URLs. The feature prevents URL tampering and unauthorized access to and alteration of session state. ',
'<p />',
'When this feature is disabled, the page and item attributes related to session state protection are ignored and checksums are not included checksums in generated "f?p=" URLs.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(110852702080117376)
,p_name=>'P9006_PAGE_LEVEL'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(114201125450070219)
,p_use_cache_before_default=>'NO'
,p_item_default=>'C'
,p_prompt=>'Page Access Protection'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'PAGE PROTECTION LEVEL'
,p_lov=>'.'||wwv_flow_imp.id(17255429593772638)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Do not update pages -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select Page Access Protection:',
'<ul>',
'<li><strong>Unrestricted</strong> - The page may be requested using an URL with or without session state arguments (Request, Clear ',
'',
'Cache, Name/Values).</li>',
'<li><strong>Arguments Must Have Checksum</strong> - If Request, Clear Cache, or Name/Value arguments appear in the URL, a checksum must ',
'',
'also be provided. The checksum type must be compatible with the most stringent Session State Protection attribute of all the ',
'',
'items passed as arguments.</li>',
'<li><strong>No Arguments Allowed</strong> - A URL may be used to request the page but no Request, Clear Cache, or Name/Value arguments ',
'',
'are allowed.</li>',
'<li><strong>No URL Access</strong> - The page may not be accessed using a URL, however the page may be the target of a Branch to Page ',
'',
'branch type, which does not do a URL redirect.</li> ',
'</ul>      '))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(110853923551123561)
,p_name=>'P9006_APP_ITEM_LEVEL'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(114201125450070219)
,p_use_cache_before_default=>'NO'
,p_item_default=>'S'
,p_prompt=>'Application Item Protection'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ITEM PROTECTION LEVEL'
,p_lov=>'.'||wwv_flow_imp.id(17287012676783081)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Do not update application items -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select Session State Protection:',
'<ul>',
'<li><strong>Unrestricted</strong> - The item''s session state may be set by passing the item name/value in a URL or in a form. No checksum is required in the URL.</li><br />       ',
'<li><strong>Restricted - May not be set from browser</strong> - The item may not be altered using the URL or POSTDATA. Use this option when you want to restrict the way that the item value can be set to internal processes, computations, and so on. Th'
||'is attribute is only applicable only to items that cannot be used as data entry items and is always observed even if Session State Protection is disabled. This attribute may be used for application items or for page items with any of these "Display A'
||'s" types:',
'<br />',
'<ul>',
'<li>Display Only (Save State=No)</li>               ',
'<li>Text Field (Disabled, does not save state)</li>                          ',
'<li>Stop and Start Grid Layout (Displays label only)</li>',
'</li></ul>',
'<li><strong>Checksum Required: Application Level</strong> - The item may be set by passing the item name/value in a URL if a checksum is also provided that is specific to the workspace and application. A user-level checksum or a session-level checksu'
||'m will also suffice (see next bullets). Use this option when you want to allow the item to be set only by URLs having checksums that were generated by any user running the same application in the current workspace but in a different session.</li>',
'<li><strong>Checksum Required: User Level</strong> - The item may be set by passing the item name/value in a URL if a checksum is also provided that is specific to the workspace, application, and user. A session-level checksum will also suffice (see '
||'next bullet). Use this option when you want to allow the item to be set only by URLs having checksums that were generated by the same named user, running the same application in the current workspace but in a different session.</li>      ',
'<li><strong>Checksum Required: Session Level</strong> - The item may be set by passing the item name/value in a URL if a checksum is also provided that is specific to the current session. Use this option when you want to allow this item to be set onl'
||'y by URLs having checksums that were generated in the current session.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(110854500826126459)
,p_name=>'P9006_DISPLAY_ONLY_ITEM_LEVEL'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(114201125450070219)
,p_use_cache_before_default=>'NO'
,p_item_default=>'S'
,p_prompt=>'Page Display-Only Item Protection'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ITEM PROTECTION LEVEL'
,p_lov=>'.'||wwv_flow_imp.id(17287012676783081)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Do not update display-only items -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select Session State Protection:',
'<ul>',
'<li><strong>Unrestricted</strong> - The item may be set by passing the item name/value in a URL or in a form. No checksum is required in the URL.</li>',
'<li><strong>Restricted: May not be set from browser</strong> - The item may not be altered via the URL or POSTDATA. Use this when you want to restrict the way that the item value can be set to internal processes, computations, and so on. This attribu'
||'te is always observed, even if Session State Protection is disabled. This attribute may be used with any of these "Display As" types: ',
'<br />',
'<ul>',
'<li>Display Only (Save State=No)</li>',
'<li>Display as Text (does not save state)</li>                               ',
'<li>Display as Text (based on LOV, does not save state)</li>                 ',
'<li>Display as Text (based on PLSQL, does not save state)</li>               ',
'<li>Text Field (Disabled, does not save state)</li>                          ',
'<li>Stop and Start Grid Layout (Displays label only)</li>',
'</ul>',
'<li><strong>Checksum Required: Application Level</strong> - The item''s session state may be set by passing the item name/value in a URL if a checksum is also provided that is specific to the workspace and application. A user-level checksum or a sessi'
||'on-level checksum will also suffice (see next bullets). Use this option when you want to allow the item to be set only by URLs having checksums that were generated by any user running the same application in the current workspace but in a different s'
||'ession.</li>',
'<li><strong>Checksum Required: User Level</strong> - The item''s session state may be set by passing the item name/value in a URL if a checksum is also provided that is specific to the workspace, application, and user. A session-level checksum will al'
||'so suffice (see next bullet). Use this option when you want to allow the item to be set only by URLs having checksums that were generated by the same named user, running the same application in the current workspace but in a different session.</li>  '
||'       ',
'<li><strong>Checksum Required: Session Level</strong> - The item''s session state may be set by passing the item name/value in a URL if a checksum is also provided that is specific to the current session. Use this option when you want to allow this it'
||'em to be set only by URLs having checksums that were generated in the current session.</li>',
'</ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(110856609615138431)
,p_name=>'P9006_DATA_ENTRY_ITEM_LEVEL'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(114201125450070219)
,p_use_cache_before_default=>'NO'
,p_item_default=>'S'
,p_prompt=>'Page Data Entry Item Protection'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'ITEM PROTECTION LEVEL NO RESTRICTED'
,p_lov=>'.'||wwv_flow_imp.id(109314413723246310)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Do not update data entry items -'
,p_lov_null_value=>'%null%'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select Session State Protection:',
'<ul>',
'<li><strong>Unrestricted</strong> - The item''s session state may be set by passing the item name/value in a URL or in a form. No checksum is required in the URL.</li>                ',
'<li><strong>Checksum Required: Application Level</strong> - The item''s session state may be set by passing the item name/value in a URL if a checksum is also provided that is specific to the workspace and application. A user-level checksum or a sessi'
||'on-level checksum will also suffice (see next bullets). Use this option when you want to allow the item to be set only by URLs having checksums that were generated by any user running the same application in the current workspace but in a different s'
||'ession.</li>',
'<li><strong>Checksum Required: User Level</strong> - The item''s session state may be set by passing the item name/value in a URL if a checksum is also provided that is specific to the workspace, application, and user. A session-level checksum will al'
||'so suffice (see next bullet). Use this option when you want to allow the item to be set only by URLs having checksums that were generated by the same named user, running the same application in the current workspace but in a different session.</li>  '
||'         ',
'<li><strong>Checksum Required: Session Level</strong> - The item''s session state may be set by passing the item name/value in a URL if a checksum is also provided that is specific to the current session. Use this option when you want to allow this it'
||'em to be set only by URLs having checksums that were generated in the current session.</li>                                                                   </ul>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'NONE'
);
end;
/
prompt --application/pages/page_09007
begin
wwv_flow_imp_page.create_page(
 p_id=>9007
,p_name=>'Enable Session State Protection'
,p_alias=>'ENABLE-SESSION-STATE-PROTECTION'
,p_step_title=>'Enable Session State Protection'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(262753407599695606)
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'sec_session_protection.htm'
,p_page_component_map=>'03'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(114268211484422739)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(109642120442735590)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
,p_translate_title=>'N'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(114268403942422739)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(114311809575869982)
,p_plug_name=>'Set Attributes'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>30
,p_list_id=>wwv_flow_imp.id(114371329791585494)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(137847231212506770)
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P525_LEVEL'
,p_plug_display_when_cond2=>'ALL'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>'<p>Confirm your request to update page and item attributes and to enable Session State Protection for the application. The following list summarizes the updates to be performed.</p>'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(114321320975996219)
,p_name=>'Pages To Be Updated'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>40
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(protection_level,''N'') protection,',
'       count(*) c',
'  from wwv_flow_steps p',
' where flow_id                   = :FB_FLOW_ID',
'   and security_group_id         = :FLOW_SECURITY_GROUP_ID ',
'   and nvl(protection_level,''N'') <> :P9006_PAGE_LEVEL',
'   and replace(:P9006_PAGE_LEVEL,''%''||''null%'',null) is not null',
' group by protection_level'))
,p_display_when_condition=>'replace(:P9006_PAGE_LEVEL,''%''||''null%'',null) is not null'
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No pages will be updated.'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(114321529882996221)
,p_query_column_id=>1
,p_column_alias=>'PROTECTION'
,p_column_display_sequence=>1
,p_column_heading=>'Page Access Protection'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(17255429593772638)
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(114321628588996221)
,p_query_column_id=>2
,p_column_alias=>'C'
,p_column_display_sequence=>2
,p_column_heading=>'Page Count'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(114323008424011520)
,p_name=>'Application Items To Be Updated'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>50
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(protection_level,''N'') protection,',
'       count(*) c',
'  from wwv_flow_items p',
' where flow_id                   = :FB_FLOW_ID',
'   and security_group_id         = :FLOW_SECURITY_GROUP_ID',
'   and nvl(protection_level,''N'') <> :P9006_APP_ITEM_LEVEL',
'   and name                      <> ''FSP_AFTER_LOGIN_URL''',
'   and replace(:P9006_APP_ITEM_LEVEL,''%''||''null%'',null) is not null',
'   -- we don''t update items that are subscribed',
'   and p.reference_id is null',
'group by protection_level'))
,p_display_when_condition=>'replace(:P9006_APP_ITEM_LEVEL,''%''||''null%'',null) is not null'
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_footer=>'Please note, session state protection for application items subscribed from other applications is not updated via this wizard. '
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No application items will be updated.'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(114323229654011521)
,p_query_column_id=>1
,p_column_alias=>'PROTECTION'
,p_column_display_sequence=>1
,p_column_heading=>'Item Session State Protection'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(17287012676783081)
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(114323317757011521)
,p_query_column_id=>2
,p_column_alias=>'C'
,p_column_display_sequence=>2
,p_column_heading=>'Page Count'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_disable_sort_column=>'N'
,p_sum_column=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(114323818121014305)
,p_name=>'Data Entry Items To Be Updated'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>60
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select flow_step_id "Page",',
'       nvl(protection_level,''N'') protection,         ',
'       count(*) c',
'  from wwv_flow_step_items p',
' where flow_id            = :FB_FLOW_ID',
'   and security_group_id  = :FLOW_SECURITY_GROUP_ID',
'   and ( display_as not in (''TEXT_DISABLED'',''NATIVE_STOP_AND_START_HTML_TABLE'')',
'         and not ( display_as = ''NATIVE_DISPLAY_ONLY'' and nvl(attribute_01, ''N'') = ''N'' /* save state */ ) )',
'   and nvl(protection_level,''N'') <> :P9006_DATA_ENTRY_ITEM_LEVEL',
'   and replace(:P9006_DATA_ENTRY_ITEM_LEVEL,''%''||''null%'',null) is not null',
' group by flow_step_id, nvl(protection_level,''N'')'))
,p_display_when_condition=>'replace(:P9006_DATA_ENTRY_ITEM_LEVEL,''%''||''null%'',null) is not null'
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No data entry items will be updated.'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(114324316292014307)
,p_query_column_id=>1
,p_column_alias=>'Page'
,p_column_display_sequence=>1
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(114324023616014307)
,p_query_column_id=>2
,p_column_alias=>'PROTECTION'
,p_column_display_sequence=>2
,p_column_heading=>'Item Session State Protection'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(17287012676783081)
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(114324126697014307)
,p_query_column_id=>3
,p_column_alias=>'C'
,p_column_display_sequence=>3
,p_column_heading=>'Item Count'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_sum_column=>'Y'
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(114326619075033547)
,p_name=>'Display-Only Items  To Be Updated'
,p_template=>wwv_flow_imp.id(399849897040726767)
,p_display_sequence=>70
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:a-Report--stretch'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select	 ',
'	 flow_step_id "Page",',
'         nvl(PROTECTION_LEVEL,''N'') Protection, ',
'         count(*) c',
' from	 WWV_FLOW_STEP_ITEMS p',
' where flow_id = :fb_flow_id',
'   and security_group_id  = :FLOW_SECURITY_GROUP_ID',
'   and (  display_as in (''TEXT_DISABLED'',''NATIVE_STOP_AND_START_HTML_TABLE'')',
'       or (   display_as             = ''NATIVE_DISPLAY_ONLY''',
'          and nvl(attribute_01, ''N'') = ''N'' /* save state */',
'          )',
'       )',
'   and nvl(PROTECTION_LEVEL,''N'') <> :P9006_DISPLAY_ONLY_ITEM_LEVEL',
'   and replace(:P9006_DISPLAY_ONLY_ITEM_LEVEL,''%''||''null%'',null) is not null',
'group by flow_step_id, nvl(PROTECTION_LEVEL,''N'')'))
,p_display_when_condition=>'replace(:P9006_DISPLAY_ONLY_ITEM_LEVEL,''%''||''null%'',null) is not null'
,p_display_when_cond2=>'PLSQL'
,p_display_condition_type=>'EXPRESSION'
,p_ajax_enabled=>'Y'
,p_fixed_header=>'NONE'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(123728124628276646)
,p_query_num_rows=>1500
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_query_show_nulls_as=>' - '
,p_query_break_cols=>'0'
,p_query_no_data_found=>'No display-only items will be updated.'
,p_query_num_rows_type=>'ROWS_X_TO_Y_OF_Z'
,p_query_row_count_max=>500
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_csv_output=>'N'
,p_plug_query_strip_html=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(114327113310033549)
,p_query_column_id=>1
,p_column_alias=>'Page'
,p_column_display_sequence=>1
,p_column_heading=>'Page'
,p_use_as_row_header=>'N'
,p_default_sort_column_sequence=>1
,p_disable_sort_column=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(114326814977033548)
,p_query_column_id=>2
,p_column_alias=>'PROTECTION'
,p_column_display_sequence=>2
,p_column_heading=>'Item Session State Protection'
,p_use_as_row_header=>'N'
,p_heading_alignment=>'LEFT'
,p_default_sort_column_sequence=>2
,p_disable_sort_column=>'N'
,p_display_as=>'TEXT_FROM_LOV_ESC'
,p_named_lov=>wwv_flow_imp.id(17287012676783081)
,p_lov_show_nulls=>'NO'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(114326913105033549)
,p_query_column_id=>3
,p_column_alias=>'C'
,p_column_display_sequence=>3
,p_column_heading=>'Item Count'
,p_use_as_row_header=>'N'
,p_column_alignment=>'RIGHT'
,p_sum_column=>'Y'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(114526816263221046)
,p_plug_name=>'Enable'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>20
,p_plug_source=>'<p>Confirm your request to enable Session State Protection. This action will not alter page or item attributes.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P525_LEVEL'
,p_plug_display_when_cond2=>'ENABLE'
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(208204218278064557)
,p_plug_name=>'Wizard Buttons - Enable'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>90
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P525_LEVEL'
,p_plug_display_when_cond2=>'ENABLE'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(208208215077082588)
,p_plug_name=>'Wizard Buttons - Set'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>110
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_plug_display_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_plug_display_when_condition=>'P525_LEVEL'
,p_plug_display_when_cond2=>'ALL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747150140279138182)
,p_plug_name=>'Set Application Protection'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(114529304320255412)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(208204218278064557)
,p_button_name=>'Cancel2'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:510:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(114268818793422743)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(208208215077082588)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:510:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(114528018734250167)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(208204218278064557)
,p_button_name=>'ENABLE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Enable'
,p_button_position=>'CREATE'
,p_button_condition=>'select 1 from wwv_flows where id=:FB_FLOW_ID and nvl(page_protection_enabled_y_n,''N'') = ''N'''
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(114268611722422740)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(208208215077082588)
,p_button_name=>'SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Finish'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(114528627045252549)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(208204218278064557)
,p_button_name=>'PREVIOUS2'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(114269007397422743)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(208208215077082588)
,p_button_name=>'PREVIOUS'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(114286228922497084)
,p_branch_action=>'f?p=&APP_ID.:525:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(114528627045252549)
,p_branch_sequence=>10
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P525_LEVEL'
,p_branch_condition_text=>'ENABLE'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(114287113123501951)
,p_branch_action=>'f?p=&APP_ID.:9006:&SESSION.::&DEBUG.:::'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(114269007397422743)
,p_branch_sequence=>20
,p_branch_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_branch_condition=>'P525_LEVEL'
,p_branch_condition_text=>'ALL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(114270422033422748)
,p_branch_action=>'f?p=&APP_ID.:510:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114269207753422744)
,p_name=>'P9007_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(114268403942422739)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application:'
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'This attribute identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114269722522422745)
,p_name=>'P9007_APPLICATION_SESSION_STATE_SECURITY'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(114268403942422739)
,p_item_default=>'N'
,p_prompt=>'Session State Protection:'
,p_source=>'select PAGE_PROTECTION_ENABLED_Y_N from wwv_flows where id = :fb_flow_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'ENABLED_DISABLED_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(91439803955181562)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Indicates whether Session State Protection is enabled or disabled. When enabled, this feature, uses the <i>Page Access Protection</i> page attributes and the <i>Session State Protection</i> item attributes in conjunction with checksums positioned in '
||'"f?p=" URLs. The feature prevents URL tampering and unauthorized access to and alteration of session state. ',
'<p />',
'When this feature is disabled, the page and item attributes related to session state protection are ignored and checksums are not included checksums in generated "f?p=" URLs.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114361329951471975)
,p_name=>'P9007_PAGE_LEVEL'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(114268403942422739)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114466403273479258)
,p_name=>'P9007_APP_ITEM_LEVEL'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(114268403942422739)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114467313662482290)
,p_name=>'P9007_DATA_ENTRY_ITEM_LEVEL'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(114268403942422739)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114467925090485520)
,p_name=>'P9007_DISPLAY_ONLY_ITEM_LEVEL'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(114268403942422739)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(114468605828489480)
,p_name=>'P9007_PAGE_ITEM_ESCAPE'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(114268403942422739)
,p_display_as=>'NATIVE_HIDDEN'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(114270230740422747)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set application attribute'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in ( select 1',
'              from wwv_flows',
'             where id                = :FB_FLOW_ID',
'               and security_group_id = wwv_flow_security.g_security_group_id',
'               and id not between 4000 and 4999 ) loop',
'    --',
'    update wwv_flows',
'       set page_protection_enabled_y_n = ''Y''',
'     where nvl(page_protection_enabled_y_n,''N'') = ''N''',
'       and id                                   = :FB_FLOW_ID',
'       and security_group_id                    = :FLOW_SECURITY_GROUP_ID;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error enabling Session State Protection.'
,p_process_when=>'SET,ENABLE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'Session State Protection enabled.  '
,p_internal_uid=>114270230740422747
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(114283732685469729)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Update page and item attributes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in ( select 1',
'              from wwv_flows',
'             where id                = :FB_FLOW_ID',
'               and security_group_id = :FLOW_SECURITY_GROUP_ID',
'               and id not between 4000 and 4999 ) loop',
'    --',
'    update wwv_flow_steps',
'       set protection_level = :P9006_PAGE_LEVEL',
'     where flow_id           = :FB_FLOW_ID',
'       and security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and replace(:P9006_PAGE_LEVEL,''%''||''null%'',null) is not null;',
'    --',
'    update wwv_flow_items',
'       set protection_level = :P9006_APP_ITEM_LEVEL',
'     where name <> ''FSP_AFTER_LOGIN_URL''',
'       and flow_id           = :FB_FLOW_ID',
'       and security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and replace(:P9006_APP_ITEM_LEVEL,''%''||''null%'',null) is not null',
'       -- update only if the application item is not subscribed',
'       and reference_id is null;',
'    --',
'    update wwv_flow_step_items',
'       set protection_level = :P9006_DATA_ENTRY_ITEM_LEVEL',
'     where (   display_as not in (''TEXT_DISABLED'',''NATIVE_STOP_AND_START_HTML_TABLE'')',
'           and not (   display_as             = ''NATIVE_DISPLAY_ONLY''',
'                   and nvl(attribute_01, ''N'') = ''N'' /* save state */',
'                   )',
'           )',
'       and flow_id           = :FB_FLOW_ID',
'       and security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and replace(:P9006_DATA_ENTRY_ITEM_LEVEL,''%''||''null%'',null) is not null;',
'    --',
'    update wwv_flow_step_items',
'       set protection_level = :P9006_DISPLAY_ONLY_ITEM_LEVEL',
'     where (  display_as in (''TEXT_DISABLED'',''NATIVE_STOP_AND_START_HTML_TABLE'')',
'           or (   display_as             = ''NATIVE_DISPLAY_ONLY''',
'              and nvl(attribute_01, ''N'') = ''N'' /* save state */',
'              )',
'           )',
'       and flow_id           = :FB_FLOW_ID',
'       and security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and replace(:P9006_DISPLAY_ONLY_ITEM_LEVEL,''%''||''null%'',null) is not null;',
'    --',
'    update wwv_flow_step_items',
'       set escape_on_http_input = :P9006_PAGE_ITEM_ESCAPE',
'     where flow_id           = :FB_FLOW_ID',
'       and security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and replace(:P9006_PAGE_ITEM_ESCAPE,''%''||''null%'',null) is not null;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error updating page and item session state security attributes.'
,p_process_when_button_id=>wwv_flow_imp.id(114268611722422740)
,p_process_when=>'P525_LEVEL'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'ALL'
,p_process_success_message=>'<p />Page and item session state security attributes updated.'
,p_internal_uid=>114283732685469729
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(114376500842662215)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select decode(:P9006_PAGE_LEVEL,',
'null,''- ''||wwv_flow_lang.system_message(''DO_NOT_UPDATE_PAGES'')||'' -'',',
'''%''||''null%'',''- ''||wwv_flow_lang.system_message(''DO_NOT_UPDATE_PAGES'')||'' -'',',
'''N'',wwv_flow_lang.system_message(''UNRESTRICTED''),',
'''C'',wwv_flow_lang.system_message(''ARGUMENTS_MUST_HAVE_CHECKSUM''),',
'''U'',wwv_flow_lang.system_message(''NO_ARGUMENTS_ALLOWED''),',
'''D'',wwv_flow_lang.system_message(''NO_URL_ACCESS'')) val from sys.dual) loop',
'  :P9007_PAGE_LEVEL := c1.val;',
'end loop;',
'--',
'for c1 in (select decode(:P9006_APP_ITEM_LEVEL,',
'null,''- ''||wwv_flow_lang.system_message(''DO_NOT_UPDATE_APPLICATION_ITEMS'')||'' -'',',
'''%''||''null%'',''- ''||wwv_flow_lang.system_message(''DO_NOT_UPDATE_APPLICATION_ITEMS'')||'' -'',',
'''N'',wwv_flow_lang.system_message(''UNRESTRICTED''),',
'''B'',wwv_flow_lang.system_message(''CHECKSUM_REQUIRED_WORKSPACE''),',
'''P'',wwv_flow_lang.system_message(''CHECKSUM_REQUIRED_USER''), ',
'''S'',wwv_flow_lang.system_message(''CHECKSUM_REQUIRED_SESSION''),',
'''I'',wwv_flow_lang.system_message(''RESTRICTED_NO_SET_FROM_BROWSER'')) val from sys.dual) loop',
'  :P9007_APP_ITEM_LEVEL := c1.val;',
'end loop;',
'--',
'for c1 in (select decode(:P9006_DATA_ENTRY_ITEM_LEVEL,',
'null,''- ''||wwv_flow_lang.system_message(''DO_NOT_UPDATE_DATA_ENTRY_ITEMS'')||'' -'',',
'''%''||''null%'',''- ''||wwv_flow_lang.system_message(''DO_NOT_UPDATE_DATA_ENTRY_ITEMS'')||'' -'',',
'''N'',wwv_flow_lang.system_message(''UNRESTRICTED''),',
'''B'',wwv_flow_lang.system_message(''CHECKSUM_REQUIRED_WORKSPACE''),',
'''P'',wwv_flow_lang.system_message(''CHECKSUM_REQUIRED_USER''), ',
'''S'',wwv_flow_lang.system_message(''CHECKSUM_REQUIRED_SESSION''),',
'''I'',wwv_flow_lang.system_message(''RESTRICTED_NO_SET_FROM_BROWSER'')) val from sys.dual) loop',
'  :P9007_DATA_ENTRY_ITEM_LEVEL := c1.val;',
'end loop;',
'--',
'for c1 in (select decode(:P9006_DISPLAY_ONLY_ITEM_LEVEL,',
'null,''- ''||wwv_flow_lang.system_message(''DO_NOT_UPDATE_DISPLAY_ONLY_ITEMS'')||'' -'',',
'''%''||''null%'',''- ''||wwv_flow_lang.system_message(''DO_NOT_UPDATE_DISPLAY_ONLY_ITEMS'')||'' -'',',
'''N'',wwv_flow_lang.system_message(''UNRESTRICTED''),',
'''B'',wwv_flow_lang.system_message(''CHECKSUM_REQUIRED_WORKSPACE''),',
'''P'',wwv_flow_lang.system_message(''CHECKSUM_REQUIRED_USER''), ',
'''S'',wwv_flow_lang.system_message(''CHECKSUM_REQUIRED_SESSION''),',
'''I'',wwv_flow_lang.system_message(''RESTRICTED_NO_SET_FROM_BROWSER'')) val from sys.dual) loop',
'  :P9007_DISPLAY_ONLY_ITEM_LEVEL := c1.val;',
'end loop;',
'--',
'for c1 in (select decode(:P9006_PAGE_ITEM_ESCAPE,',
'null,''- ''||wwv_flow_lang.system_message(''DO_NOT_UPDATE_PAGE_ITEMS'')||'' -'',',
'''%''||''null%'',''- ''||wwv_flow_lang.system_message(''DO_NOT_UPDATE_PAGE_ITEMS'')||'' -'',',
'''N'',wwv_flow_lang.system_message(''F4000.NO''),',
'''Y'',wwv_flow_lang.system_message(''F4000.YES'')) val from sys.dual) loop',
'  :P9007_PAGE_ITEM_ESCAPE := c1.val;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>114376500842662215
);
end;
/
prompt --application/pages/page_09008
begin
wwv_flow_imp_page.create_page(
 p_id=>9008
,p_name=>'Disable Session State Protection'
,p_alias=>'DISABLE-SESSION-STATE-PROTECTION'
,p_step_title=>'Disable Session State Protection'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(702688271851047856)
,p_page_template_options=>'#DEFAULT#'
,p_help_text=>'sec_session_protection.htm'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(109520210095194155)
,p_plug_name=>'Disable'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--hideHeader'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_list_id=>wwv_flow_imp.id(109521305294221172)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(1141992015120113961)
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_header=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Disabling Session State Protection is typically adequate for applications that do not manage highly sensitive information.</p>',
'<p>When the feature is disabled, the following session state security rules are used:</p>'))
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(109645406637759954)
,p_plug_name=>'Progress'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(40778201261099606)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_01'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(109642120442735590)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(40780006081223991)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(110814830114933628)
,p_plug_name=>'Application Session State Protection Controls'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_footer=>'<p />'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(111855318025791886)
,p_plug_name=>'Disabling Session State Protection'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--simple'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_source=>'<p>Disabling the feature changes only the application attribute and will not change any page or item attributes related to session state security; those attributes will be ignored when your application runs with the feature disabled, but they will ag'
||'ain take effect when you re-enable Session State Protection.</p>'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(208210118110102377)
,p_plug_name=>'Wizard Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_escape_on_http_output=>'Y'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_03'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(747150238761138182)
,p_plug_name=>'Set Application Protection'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'DEFAULT'
,p_plug_template=>wwv_flow_imp.id(703488066986172098)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_02'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(109524813726275298)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(208210118110102377)
,p_button_name=>'Cancel'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_button_redirect_url=>'f?p=&APP_ID.:510:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(109524628805275296)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(208210118110102377)
,p_button_name=>'SET'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Finish'
,p_button_position=>'CREATE'
,p_button_condition=>'select 1 from wwv_flows where id=:FB_FLOW_ID and nvl(page_protection_enabled_y_n,''N'') = ''Y'''
,p_button_condition_type=>'EXISTS'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(109619118460401290)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(208210118110102377)
,p_button_name=>'PREVIOUS'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Previous'
,p_button_position=>'PREVIOUS'
,p_button_redirect_url=>'f?p=&APP_ID.:525:&SESSION.::&DEBUG.:::'
,p_icon_css_classes=>'icon-left-chevron'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(109595321586127705)
,p_branch_action=>'f?p=&APP_ID.:510:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(110816015354938887)
,p_name=>'P9008_APPLICATION'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(110814830114933628)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Application:'
,p_source=>'wwv_flow_builder.get_current_flow_id_and_name'
,p_source_type=>'EXPRESSION'
,p_source_language=>'PLSQL'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>'This attribute identifies the current application.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'N'
,p_attribute_05=>'HTML'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(110816918638942316)
,p_name=>'P9008_APPLICATION_SESSION_STATE_SECURITY'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(110814830114933628)
,p_item_default=>'N'
,p_prompt=>'Session State Protection:'
,p_source=>'select PAGE_PROTECTION_ENABLED_Y_N from wwv_flows where id = :fb_flow_id'
,p_source_type=>'QUERY'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'ENABLED_DISABLED_RETURNS_Y_OR_N'
,p_lov=>'.'||wwv_flow_imp.id(91439803955181562)||'.'
,p_cSize=>30
,p_cMaxlength=>2000
,p_cHeight=>1
,p_cAttributes=>'nowrap="nowrap"'
,p_tag_css_classes=>'fielddatabold'
,p_label_alignment=>'RIGHT'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_escape_on_http_input=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Indicates whether Session State Protection is enabled or disabled. When enabled, this feature, uses the <i>Page Access Protection</i> page attributes and the <i>Session State Protection</i> item attributes in conjunction with checksums positioned in '
||'"f?p=" URLs. The feature prevents URL tampering and unauthorized access to and alteration of session state. ',
'<p />',
'When this feature is disabled, the page and item attributes related to session state protection are ignored and checksums are not included checksums in generated "f?p=" URLs.'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'LOV'
,p_attribute_04=>'N'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(110698229152438343)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'set session state security Standard'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'for c1 in (select 1 from wwv_flows where id = :FB_FLOW_ID ',
'  and nvl(page_protection_enabled_y_n,''N'') = ''Y'' ) loop',
'    update wwv_flows set page_protection_enabled_y_n = ''N'' ',
'          where id = :FB_FLOW_ID ',
'          and security_group_id = wwv_flow_security.g_security_group_id;',
'end loop;'))
,p_process_clob_language=>'PLSQL'
,p_process_error_message=>'Error disabling Application Session State Protection.'
,p_process_when_button_id=>wwv_flow_imp.id(109524628805275296)
,p_process_success_message=>'Application Session State Protection disabled.'
,p_internal_uid=>110698229152438343
);
end;
/
prompt --application/pages/page_09009
begin
wwv_flow_imp_page.create_page(
 p_id=>9009
,p_name=>'Cross Application Reports'
,p_alias=>'CROSS-APPLICATION-REPORTS'
,p_step_title=>'Cross Application Reports'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(11501804013545635)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
,p_page_component_map=>'06'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(15031017595405628)
,p_plug_name=>'Application Comparison Reports'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--shadowScroll:a-Region--noPadding:h480'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_imp.id(15030113309394959)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(693422331030340241)
,p_plug_column_width=>'apex-col--rightBorder '
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47651812435054562)
,p_plug_name=>'Security'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:h240'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_list_id=>wwv_flow_imp.id(47648606548052805)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(693422331030340241)
,p_plug_column_width=>'apex-col--rightBorder apex-col--bottomBorder'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(47659104994090209)
,p_plug_name=>'User Interface'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:h240'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_plug_new_grid_row=>false
,p_list_id=>wwv_flow_imp.id(47656832568088745)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(693422331030340241)
,p_plug_column_width=>'apex-col--bottomBorder'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(162364406853895742)
,p_plug_name=>'Application Attributes'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--shadowScroll:a-Region--noPadding:h480'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_list_id=>wwv_flow_imp.id(162360828277873558)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(693422331030340241)
,p_plug_column_width=>'apex-col--rightBorder '
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(698800915639413302)
,p_plug_name=>'Region Container'
,p_region_css_classes=>'apex-grid--tableBased'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>100
,p_translate_title=>'N'
,p_plug_display_condition_type=>'NEVER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'TEXT',
  'show_line_breaks', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(699069038663848517)
,p_plug_name=>'Workspace Utilities'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>161
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(2778715503937249)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
end;
/
prompt --application/pages/page_09010
begin
wwv_flow_imp_page.create_page(
 p_id=>9010
,p_name=>'Application Attributes by Application'
,p_alias=>'APPLICATION-ATTRIBUTES-BY-APPLICATION'
,p_step_title=>'Application Attributes'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(11501804013545635)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1285400196517282)
,p_plug_name=>'Application Attributes'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P9010a */',
'ID, ',
'SECURITY_GROUP_ID,',
'OWNER,',
'"NAME",',
'LAST_UPDATED_BY, LAST_UPDATED_ON,',
'(select count(*) from wwv_flow_steps where flow_id = f.id) pages,',
'CHARSET,',
'FLOW_LANGUAGE,',
'nvl(APPLICATION_TAB_SET,1) APPLICATION_TAB_SET,',
'(select BANNER ',
'from WWV_FLOW_BANNER b',
'where b.id = f.id) application_comment,',
'  (select count(*) c from wwv_flow_page_plugs where flow_id = f.id) regions,',
'  (select count(*) c from wwv_flow_step_items where flow_id = f.id) +',
'  (select count(*) c from wwv_flow_items where flow_id = f.id)  items,',
'  (select count(*) c from wwv_flow_step_buttons where flow_id = f.id) buttons,',
'  (select count(*) c from wwv_flow_step_branches where flow_id = f.id) branches,',
'  (select count(*) c from wwv_flow_step_validations where flow_id = f.id) validations,',
'  (select count(*) c from wwv_flow_step_processing where flow_id = f.id) +',
'  (select count(*) c from wwv_flow_processing where flow_id = f.id) processes,',
'  (select count(*) c from WWV_FLOW_LISTS_OF_VALUES$ where flow_id = f.id) lists_of_values,',
'  (select count(*) c from wwv_flow_page_plugs where flow_id = f.id and plug_source_type = ''NATIVE_IR'') interactive_reports,',
'(select count(*) c from wwv_flow_page_plugs where flow_id = f.id and plug_source_type in (''NATIVE_SQL_REPORT'', ''NATIVE_TABFORM'')) ',
'  classic_reports,',
'SECURITY_SCHEME,',
'replace(replace(AUTHENTICATION,''CUSTOM2'',wwv_flow_lang.system_message(''AUTHENTICATION SCHEME'')),''COOKIE'',''INTERNAL'') authentication,',
'  (select count(*) c from wwv_flow_authentications where flow_id = f.id) authorization_schemes,',
'  (select count(*) c from WWV_FLOW_SECURITY_SCHEMES where flow_id = f.id) authentication_schemes',
'from wwv_flow_visible_flows f',
'where f.build_status != ''RUN_AND_HIDDEN'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(1285528456517282)
,p_name=>'Application Attributes'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1285725043517289)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Application'
,p_column_link=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:RP,1:FB_FLOW_ID,F4000_P1_FLOW:#ID#,#ID#'
,p_column_linktext=>'#ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1285818266517289)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'SECURITY_GROUP_ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1285903514517289)
,p_db_column_name=>'OWNER'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Parsing Schema'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1286029046517290)
,p_db_column_name=>'NAME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1286100408517290)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Updated'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1286205356517290)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Date'
,p_column_type=>'DATE'
,p_format_mask=>'SINCE'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1286322799517290)
,p_db_column_name=>'PAGES'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Pages'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1286413808517290)
,p_db_column_name=>'CHARSET'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Character Set'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1286507095517290)
,p_db_column_name=>'FLOW_LANGUAGE'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Language'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1286602361517291)
,p_db_column_name=>'APPLICATION_TAB_SET'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Debugging'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1288230732533568)
,p_db_column_name=>'APPLICATION_COMMENT'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Application Comment'
,p_allow_sorting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_column_type=>'CLOB'
,p_rpt_show_filter_lov=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1296500529619366)
,p_db_column_name=>'REGIONS'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Regions'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1296609383619366)
,p_db_column_name=>'ITEMS'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'Items'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1296732635619366)
,p_db_column_name=>'BUTTONS'
,p_display_order=>14
,p_column_identifier=>'N'
,p_column_label=>'Buttons'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1296818103619366)
,p_db_column_name=>'BRANCHES'
,p_display_order=>15
,p_column_identifier=>'O'
,p_column_label=>'Branches'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1296925281619367)
,p_db_column_name=>'VALIDATIONS'
,p_display_order=>16
,p_column_identifier=>'P'
,p_column_label=>'Validations'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1297022202619367)
,p_db_column_name=>'PROCESSES'
,p_display_order=>17
,p_column_identifier=>'Q'
,p_column_label=>'Processes'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1297111885619367)
,p_db_column_name=>'LISTS_OF_VALUES'
,p_display_order=>18
,p_column_identifier=>'R'
,p_column_label=>'Lists of Values'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1297221426619367)
,p_db_column_name=>'INTERACTIVE_REPORTS'
,p_display_order=>19
,p_column_identifier=>'S'
,p_column_label=>'Interactive Reports'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1297310456619367)
,p_db_column_name=>'CLASSIC_REPORTS'
,p_display_order=>20
,p_column_identifier=>'T'
,p_column_label=>'Classic Reports'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1300429450665635)
,p_db_column_name=>'SECURITY_SCHEME'
,p_display_order=>21
,p_column_identifier=>'U'
,p_column_label=>'Security Scheme'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1300508052665636)
,p_db_column_name=>'AUTHENTICATION'
,p_display_order=>22
,p_column_identifier=>'V'
,p_column_label=>'Authentication'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1300632697665636)
,p_db_column_name=>'AUTHORIZATION_SCHEMES'
,p_display_order=>23
,p_column_identifier=>'W'
,p_column_label=>'Authorization Schemes'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1300702863665636)
,p_db_column_name=>'AUTHENTICATION_SCHEMES'
,p_display_order=>24
,p_column_identifier=>'X'
,p_column_label=>'Authentication Schemes'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(1287618134520444)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1307131843536647'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'ID:NAME:LAST_UPDATED_BY:PAGES:REGIONS:ITEMS:BUTTONS:BRANCHES:VALIDATIONS:PROCESSES:LISTS_OF_VALUES:INTERACTIVE_REPORTS:CLASSIC_REPORTS'
,p_sort_column_1=>'ID'
,p_sort_direction_1=>'ASC'
,p_sum_columns_on_break=>'INTERACTIVE_REPORTS:PAGES:REGIONS:ITEMS:BUTTONS:BRANCHES:VALIDATIONS:PROCESSES:LISTS_OF_VALUES:CLASSIC_REPORTS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(702929941780192950)
,p_plug_name=>'Cross Application Reports'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(702923103587108064)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
end;
/
prompt --application/pages/page_09012
begin
wwv_flow_imp_page.create_page(
 p_id=>9012
,p_name=>'Build Options by Application'
,p_alias=>'BUILD-OPTIONS-BY-APPLICATION'
,p_step_title=>'Build Options'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_util_cross_app.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1293121700583306)
,p_plug_name=>'Build Options'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P9012a */',
'       wwv_flows.id,',
'       "WWV_FLOW_BUILD_OPTIONS".FLOW_ID           as "FLOW_ID",',
'       "WWV_FLOW_BUILD_OPTIONS".PATCH_NAME        as "PATCH_NAME",',
'       "WWV_FLOW_BUILD_OPTIONS".SECURITY_GROUP_ID as "SECURITY_GROUP_ID",',
'       "WWV_FLOW_BUILD_OPTIONS".PATCH_STATUS      as "PATCH_STATUS",',
'       "WWV_FLOW_BUILD_OPTIONS".PATCH_COMMENT     as "PATCH_COMMENT",',
'       "WWV_FLOWS".NAME                           as "NAME" ',
'  from wwv_flow_visible_flows   "WWV_FLOWS",',
'       "WWV_FLOW_BUILD_OPTIONS" "WWV_FLOW_BUILD_OPTIONS" ',
' where WWV_FLOW_BUILD_OPTIONS.FLOW_ID           = WWV_FLOWS.ID',
'   and WWV_FLOW_BUILD_OPTIONS.SECURITY_GROUP_ID = WWV_FLOWS.SECURITY_GROUP_ID',
'   and WWV_FLOWS.build_status != ''RUN_AND_HIDDEN'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(1293214501583306)
,p_name=>'Build Options'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML:PDF'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1293512113583308)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>1
,p_column_identifier=>'B'
,p_column_label=>'Application'
,p_column_link=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:RP,1:FB_FLOW_ID,F4000_P1_FLOW:#ID#,#ID#'
,p_column_linktext=>'#FLOW_ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1294013273583309)
,p_db_column_name=>'NAME'
,p_display_order=>2
,p_column_identifier=>'G'
,p_column_label=>'Application Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1293622398583309)
,p_db_column_name=>'PATCH_NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Build Option'
,p_column_link=>'f?p=&APP_ID.:4910:&SESSION.::&DEBUG.:RP,1,RIR,CIR:FB_FLOW_ID,F4000_P1_FLOW,IR_PATCH_NAME:#ID#,#ID#,#PATCH_NAME#'
,p_column_linktext=>'#PATCH_NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1293730437583309)
,p_db_column_name=>'SECURITY_GROUP_ID'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'SECURITY_GROUP_ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1293827025583309)
,p_db_column_name=>'PATCH_STATUS'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Status'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1293905668583309)
,p_db_column_name=>'PATCH_COMMENT'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Comment'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1293417316583308)
,p_db_column_name=>'ID'
,p_display_order=>7
,p_column_identifier=>'A'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(1295219398587025)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1307205964536647'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'FLOW_ID:NAME:PATCH_NAME:SECURITY_GROUP_ID:PATCH_STATUS:PATCH_COMMENT:ID'
,p_sort_column_1=>'FLOW_ID'
,p_sort_direction_1=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(702932627302212342)
,p_plug_name=>'Cross Application Reports'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(702923103587108064)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
end;
/
prompt --application/pages/page_09014
begin
wwv_flow_imp_page.create_page(
 p_id=>9014
,p_name=>'Security profiles by Application'
,p_alias=>'SECURITY-PROFILES-BY-APPLICATION'
,p_step_title=>'Security Profiles'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213425326892450628)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'bldr_app_rpt.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1302730874700602)
,p_plug_name=>'Security Profiles by Application'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P9014a */ id,',
'  name, ',
'  OWNER parse_as, ',
'  SECURITY_SCHEME,',
'  (select count(*) c from wwv_flow_authentications where flow_id = f.id) aset,',
'  (select count(*) c from WWV_FLOW_SECURITY_SCHEMES where flow_id = f.id) ss,',
'  (select count(*) c from WWV_FLOW_steps where flow_id = f.id) pages,',
'  --',
'  (select count(*) c ',
'   from wwv_flow_step_items ',
'   where flow_id = f.id and display_as like ''NATIVE_PASSWORD'') ',
'   password_items,',
'  (select count(*) c ',
'   from wwv_flow_step_items ',
'   where flow_id = f.id and display_as like ''NATIVE_PASSWORD''',
'     and is_persistent = ''N'')',
'   password_items_no_state,',
'  (select count(*) c ',
'   from wwv_flow_step_items ',
'   where flow_id = f.id ',
'   and display_as = ''NATIVE_PASSWORD''',
'   and is_persistent <> ''N''',
'   and nvl(ENCRYPT_SESSION_STATE_YN,''N'') = ''N'')',
'   at_risk_password_items,',
'  (select count(*) c ',
'   from wwv_flow_step_items ',
'   where flow_id = f.id and display_as like ''NATIVE_PASSWORD'' ',
'     and nvl(ENCRYPT_SESSION_STATE_YN,''N'') = ''Y'') ',
'   encrypted_password_items,',
'  (select count(*) c ',
'   from wwv_flow_step_items ',
'   where flow_id = f.id ',
'   and nvl(ENCRYPT_SESSION_STATE_YN,''N'') = ''Y'') ',
'   encrypted_items',
'from wwv_flow_visible_flows f',
'where f.build_status != ''RUN_AND_HIDDEN'''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_plug_footer=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<br /><p>Password items which can pose a risk are items of type Password that save session state and do not encrypt the saved state.  The security of these password items can be improved by not saving state or saving state encrypted.</p>',
''))
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(1302829764700602)
,p_name=>'Security Profiles by Application'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_allow_report_categories=>'N'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_show_calendar=>'N'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_allow_exclude_null_values=>'N'
,p_allow_hide_extra_columns=>'N'
,p_icon_view_columns_per_row=>1
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1303014156700603)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Application'
,p_column_link=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:RP,1:FB_FLOW_ID,F4000_P1_FLOW:#ID#,#ID#'
,p_column_linktext=>'#ID#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1303119499700604)
,p_db_column_name=>'NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1303206511700604)
,p_db_column_name=>'PARSE_AS'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Parsing Schema'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1303300290700604)
,p_db_column_name=>'SECURITY_SCHEME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Application Level<br />Authorization Scheme'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1303500712700605)
,p_db_column_name=>'ASET'
,p_display_order=>6
,p_column_identifier=>'F'
,p_column_label=>'Authentication<br />Schemes'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1303604536700605)
,p_db_column_name=>'SS'
,p_display_order=>7
,p_column_identifier=>'G'
,p_column_label=>'Authorization<br />Schemes'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1303731349700605)
,p_db_column_name=>'PAGES'
,p_display_order=>8
,p_column_identifier=>'H'
,p_column_label=>'Pages'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_format_mask=>'999G999G999G999G999G999G990'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15974320568537590)
,p_db_column_name=>'PASSWORD_ITEMS'
,p_display_order=>9
,p_column_identifier=>'I'
,p_column_label=>'Password Items'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15983104123570700)
,p_db_column_name=>'PASSWORD_ITEMS_NO_STATE'
,p_display_order=>10
,p_column_identifier=>'J'
,p_column_label=>'Password Items No State'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15983212340570701)
,p_db_column_name=>'ENCRYPTED_PASSWORD_ITEMS'
,p_display_order=>11
,p_column_identifier=>'K'
,p_column_label=>'Encrypted Password Items'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15983323127570701)
,p_db_column_name=>'ENCRYPTED_ITEMS'
,p_display_order=>12
,p_column_identifier=>'L'
,p_column_label=>'Encrypted Items'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(15985201493655103)
,p_db_column_name=>'AT_RISK_PASSWORD_ITEMS'
,p_display_order=>13
,p_column_identifier=>'M'
,p_column_label=>'At Risk Password Items'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(1304702401705144)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1307329882536647'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'ID:NAME:PAGES:PARSE_AS:SECURITY_SCHEME:ASET:SS:ENCRYPTED_ITEMS:AT_RISK_PASSWORD_ITEMS'
,p_sort_column_1=>'ID'
,p_sort_direction_1=>'ASC'
,p_sum_columns_on_break=>'PAGES:PASSWORD_ITEMS:ENCRYPTED_ITEMS'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(702954370001516801)
,p_plug_name=>'Cross Application Reports'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(702923103587108064)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
end;
/
prompt --application/pages/page_09015
begin
wwv_flow_imp_page.create_page(
 p_id=>9015
,p_name=>'Authentication schemes by Application'
,p_alias=>'AUTHENTICATION-SCHEMES-BY-APPLICATION'
,p_step_title=>'Authentication Schemes'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(213425326892450628)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_nav_list_template_options=>'#DEFAULT#'
,p_help_text=>'sec_authentication.htm'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1305702192713900)
,p_plug_name=>'Authorization Schemes'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>10
,p_plug_new_grid_row=>false
,p_plug_display_column=>1
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P9015a */',
'  f.id flow,  ',
'  f.name application_name,',
'  a.name,',
'  case',
'    when a.id = f.authentication_id then  ',
'      wwv_flow_lang.system_message(''F4350.CURRENT'')',
'    else',
'      wwv_flow_lang.system_message(''F4350.AVAILABLE'')',
'  end status,',
'  a.help_text as description ',
' from wwv_flow_visible_flows f,',
'      wwv_flow_authentications a',
'where a.security_group_id = f.security_group_id',
'  and a.flow_id           = f.id',
'  and f.build_status      != ''RUN_AND_HIDDEN''',
''))
,p_plug_source_type=>'NATIVE_IR'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(1305831271713900)
,p_name=>'Authorization Schemes'
,p_max_row_count=>'10000'
,p_max_row_count_message=>'This query returns more then 10,000 rows, please filter your data to ensure complete results.'
,p_no_data_found_message=>'No data found.'
,p_allow_save_rpt_public=>'Y'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML'
,p_enable_mail_download=>'Y'
,p_owner=>'MIKE'
,p_internal_uid=>1
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1306009273713902)
,p_db_column_name=>'FLOW'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'Application'
,p_column_link=>'f?p=&APP_ID.:1:&SESSION.::&DEBUG.:RP,1,4015,RP:FB_FLOW_ID,F4000_P1_FLOW:#FLOW#,#FLOW#'
,p_column_linktext=>'#FLOW#'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1306115727713902)
,p_db_column_name=>'APPLICATION_NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Application Name'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1306225409713902)
,p_db_column_name=>'NAME'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Authentication Scheme Name'
,p_column_link=>'f?p=&APP_ID.:801:&SESSION.::&DEBUG.:RP,1,4015,801,CIR,RIR:FB_FLOW_ID,F4000_P1_FLOW,IRC_NAME:#FLOW#,#FLOW#,#NAME#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1306317599713902)
,p_db_column_name=>'STATUS'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Status'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1306407405713903)
,p_db_column_name=>'DESCRIPTION'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Description'
,p_column_type=>'STRING'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(1307412228717448)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'1307423512536647'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'FLOW:APPLICATION_NAME:NAME:STATUS:DESCRIPTION'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(702954735784520575)
,p_plug_name=>'Cross Application Reports'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_list_id=>wwv_flow_imp.id(702923103587108064)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(697214733556634905)
);
end;
/
prompt --application/pages/page_09500
begin
wwv_flow_imp_page.create_page(
 p_id=>9500
,p_name=>'Task Definitions'
,p_alias=>'TASK-DEFINITIONS'
,p_step_title=>'Task Definitions'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1600373153144101)
,p_plug_name=>'Copy Task Definition'
,p_region_template_options=>'#DEFAULT#:js-dialog-size600x400'
,p_plug_template=>wwv_flow_imp.id(557449278618308550)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6235482311406749)
,p_plug_name=>'Task Definitions Report'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select t.ID,',
'       t.FLOW_ID,',
'       t.NAME,',
'       t.STATIC_ID,',
'       t.SUBJECT,',
'       t.TASK_TYPE,',
'       t.PRIORITY,',
'       t.TASK_DEF_COMMENT,',
'       t.LAST_UPDATED_BY,',
'       t.LAST_UPDATED_ON,',
'       (select count(a.ID) ',
'          from WWV_FLOW_TASK_DEF_ACTIONS a ',
'         where a.task_def_id=t.id) ACTIONS_COUNT,',
'       (select count(p.id) ',
'          from WWV_FLOW_TASK_DEF_PARAMS p ',
'         where p.task_def_id=t.id) PARAMS_COUNT,',
'       (select count(part.id) ',
'          from WWV_FLOW_TASK_DEF_PARTICIPANTS part ',
'         where part.task_def_id=t.id) PARTICIPANTS_COUNT',
'from WWV_FLOW_TASK_DEFS t where t.flow_id = :FB_FLOW_ID and t.security_group_id = :WORKSPACE_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Automations Report '
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(6235802409406749)
,p_name=>'Report 1'
,p_max_row_count_message=>'The maximum row count for this report is #MAX_ROW_COUNT# rows.  Please apply a filter to reduce the number of records in your query.'
,p_no_data_found_message=>'No task definitions found.'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'MARC'
,p_internal_uid=>6235802409406749
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1903496371255432)
,p_db_column_name=>'NAME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Name'
,p_column_link=>'f?p=&APP_ID.:9502:&SESSION.::&DEBUG.::P9502_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1903857776255433)
,p_db_column_name=>'STATIC_ID'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Static ID'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1902258440255423)
,p_db_column_name=>'ID'
,p_display_order=>23
,p_column_identifier=>'A'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1902658277255430)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>33
,p_column_identifier=>'B'
,p_column_label=>'Flow Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1904228695255434)
,p_db_column_name=>'SUBJECT'
,p_display_order=>53
,p_column_identifier=>'P'
,p_column_label=>'Subject'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1801200044324510)
,p_db_column_name=>'TASK_TYPE'
,p_display_order=>63
,p_column_identifier=>'AJ'
,p_column_label=>'Type'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(1500990392400098)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1907402504255439)
,p_db_column_name=>'TASK_DEF_COMMENT'
,p_display_order=>73
,p_column_identifier=>'X'
,p_column_label=>'Task Def Comment'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1908624255255441)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>83
,p_column_identifier=>'AA'
,p_column_label=>'Last Updated By'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1909092265255442)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>93
,p_column_identifier=>'AB'
,p_column_label=>'Last Updated On'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_column_alignment=>'CENTER'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1968278884480244)
,p_db_column_name=>'PRIORITY'
,p_display_order=>103
,p_column_identifier=>'AE'
,p_column_label=>'Priority'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(8804388708066904)
,p_db_column_name=>'ACTIONS_COUNT'
,p_display_order=>113
,p_column_identifier=>'AG'
,p_column_label=>'Actions'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(8804443944066905)
,p_db_column_name=>'PARAMS_COUNT'
,p_display_order=>123
,p_column_identifier=>'AH'
,p_column_label=>'Parameters'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(8804514224066906)
,p_db_column_name=>'PARTICIPANTS_COUNT'
,p_display_order=>133
,p_column_identifier=>'AI'
,p_column_label=>'Participants'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(6252917602407791)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'25507'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'NAME:SUBJECT:TASK_TYPE:PRIORITY:PARTICIPANTS_COUNT:PARAMS_COUNT:ACTIONS_COUNT:LAST_UPDATED_BY:LAST_UPDATED_ON:'
,p_sort_column_1=>'POLLING_NEXT_RUN_TIMESTAMP'
,p_sort_direction_1=>'ASC NULLS LAST'
,p_sort_column_2=>'0'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6603153594288177)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_imp.id(1507124731460473)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6603274250288178)
,p_plug_name=>'Task Definitions'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Task Definitions define the participants, parameters and actions for a task that requires human action - also called the human task.',
'</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(6603371589288179)
,p_name=>'Recently Edited'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'REGION_POSITION_03'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P9500b */ replace(replace(name,''_'','' ''),''.'','' '') name, id',
'from  wwv_flow_task_defs',
'where flow_id = :fb_flow_id',
'and last_updated_on is not null',
'and security_group_id = :flow_security_group_id',
'order by last_updated_on desc'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_task_defs ',
' where flow_id = :fb_flow_id',
'   and last_updated_on is not null',
'   and security_group_id = :flow_security_group_id'))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(11667910335347890)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1921433131255490)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_column_link=>'f?p=&APP_ID.:9502:&SESSION.::&DEBUG.::P502_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1921807204255491)
,p_query_column_id=>2
,p_column_alias=>'ID'
,p_column_display_sequence=>2
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1602679991144124)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(1600373153144101)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'CLOSE'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1602995829144127)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(1600373153144101)
,p_button_name=>'COPY_TASK_DEFINITION'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Copy Task Definition'
,p_button_position=>'CREATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1602179505144119)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(6235482311406749)
,p_button_name=>'COPY'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Copy'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1909784741255452)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(6235482311406749)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:9501:&SESSION.::&DEBUG.:9501::'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1600492690144102)
,p_name=>'P9500_COPY_SOURCE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1600373153144101)
,p_prompt=>'Copy Source'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'P7020_COPY_SOURCE'
,p_lov=>'.'||wwv_flow_imp.id(601116568254832030)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose whether to copy the task definition from this application or from another application.'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1600545811144103)
,p_name=>'P9500_APPLICATIONS'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1600373153144101)
,p_prompt=>'Applications'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'APPLICATIONS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id||''. ''||name d, id r',
'  from wwv_flow_visible_flows f',
' where f.build_status != ''RUN_AND_HIDDEN''',
' order by 2'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose the application to copy the task definition from.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1601160788144109)
,p_name=>'P9500_FROM_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1600373153144101)
,p_prompt=>'Copy Task Definition'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name,',
'       id',
'  from wwv_flow_task_defs',
' where security_group_id = :WORKSPACE_ID',
'   and flow_id           = :P9500_APPLICATIONS'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_lov_cascade_parent_items=>'P9500_APPLICATIONS'
,p_ajax_optimize_refresh=>'Y'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Choose the task definition to copy.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1601289904144110)
,p_name=>'P9500_COPY_NEW_ID'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(1600373153144101)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1601378460144111)
,p_name=>'P9500_COPY_NEW_NAME'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(1600373153144101)
,p_prompt=>'New Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Provide a name for the copied task definition.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1601494330144112)
,p_name=>'P9500_COPY_NEW_STATIC_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(1600373153144101)
,p_prompt=>'New Static ID'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Provide a static ID for the copied task definition.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1910197512255458)
,p_name=>'P9500_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(6235482311406749)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2401172326782401)
,p_validation_name=>'From Id must not be null'
,p_validation_sequence=>10
,p_validation=>'P9500_FROM_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'A task definition to copy is required.'
,p_when_button_pressed=>wwv_flow_imp.id(1602995829144127)
,p_associated_item=>wwv_flow_imp.id(1601160788144109)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1601728153144115)
,p_validation_name=>'New Name Must Not Be Null'
,p_validation_sequence=>20
,p_validation=>'P9500_COPY_NEW_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_when_button_pressed=>wwv_flow_imp.id(1602995829144127)
,p_associated_item=>wwv_flow_imp.id(1601378460144111)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1602025171144118)
,p_validation_name=>'New Static ID Must Not Be Null'
,p_validation_sequence=>30
,p_validation=>'P9500_COPY_NEW_STATIC_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_when_button_pressed=>wwv_flow_imp.id(1602995829144127)
,p_associated_item=>wwv_flow_imp.id(1601494330144112)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1601801034144116)
,p_validation_name=>'New Name Must Be Unique'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_task_defs',
' where security_group_id = :WORKSPACE_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and name              = :P9500_COPY_NEW_NAME;'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'The new task definition name is already taken. '
,p_when_button_pressed=>wwv_flow_imp.id(1602995829144127)
,p_associated_item=>wwv_flow_imp.id(1601378460144111)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1601914404144117)
,p_validation_name=>'New Static ID Must Be Unique'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1 ',
'  from wwv_flow_task_defs',
' where security_group_id = :WORKSPACE_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and static_id         = :P9500_COPY_NEW_STATIC_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'The new task definition static ID is already taken. '
,p_when_button_pressed=>wwv_flow_imp.id(1602995829144127)
,p_associated_item=>wwv_flow_imp.id(1601378460144111)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1600684509144104)
,p_name=>'This App'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P9500_COPY_SOURCE'
,p_condition_element=>'P9500_COPY_SOURCE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'THIS'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1600704479144105)
,p_event_id=>wwv_flow_imp.id(1600684509144104)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9500_APPLICATIONS'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1600966318144107)
,p_event_id=>wwv_flow_imp.id(1600684509144104)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9500_APPLICATIONS'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1600821031144106)
,p_event_id=>wwv_flow_imp.id(1600684509144104)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9500_APPLICATIONS'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>':FB_FLOW_ID'
,p_attribute_08=>'Y'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1601022658144108)
,p_event_id=>wwv_flow_imp.id(1600684509144104)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9500_APPLICATIONS'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1602223198144120)
,p_name=>'Copy Task Definition'
,p_event_sequence=>20
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1602179505144119)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1602356336144121)
,p_event_id=>wwv_flow_imp.id(1602223198144120)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9500_FROM_ID,P9500_APPLICATIONS,P9500_COPY_NEW_ID,P9500_COPY_NEW_NAME,P9500_COPY_NEW_STATIC_ID'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1602463730144122)
,p_event_id=>wwv_flow_imp.id(1602223198144120)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9500_COPY_SOURCE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'THIS'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1602550156144123)
,p_event_id=>wwv_flow_imp.id(1602223198144120)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1600373153144101)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1602718387144125)
,p_name=>'Cancel Copy Dialog'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1602679991144124)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1602804721144126)
,p_event_id=>wwv_flow_imp.id(1602718387144125)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLOSE_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1600373153144101)
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1603011196144128)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Copy Task Definition'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    :P9500_COPY_NEW_ID :=wwv_flow_approval_dev.copy(',
'                    p_id           => :P9500_FROM_ID,',
'                    p_to_name      => :P9500_COPY_NEW_NAME,',
'                    p_to_static_id => :P9500_COPY_NEW_STATIC_ID,',
'                    p_to_flow_id   => :FB_FLOW_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(1602995829144127)
,p_process_success_message=>'Task Definition Copied'
,p_internal_uid=>1603011196144128
);
end;
/
prompt --application/pages/page_09501
begin
wwv_flow_imp_page.create_page(
 p_id=>9501
,p_name=>'Create Task Definition'
,p_alias=>'CREATE-TASK-DEFINITION1'
,p_page_mode=>'MODAL'
,p_step_title=>'Create Task Definition'
,p_first_item=>'AUTO_FIRST_ITEM'
,p_autocomplete_on_off=>'OFF'
,p_inline_css=>'div#P7030_POLLING_STARTAT_DAILY_CONTAINER span.apex-quick-picks {display: inline; padding-left: 5px; }'
,p_page_template_options=>'#DEFAULT#'
,p_dialog_attributes=>'resizable:true'
,p_page_component_map=>'16'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5383269121373620)
,p_plug_name=>'Buttons'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8185473332191148)
,p_plug_name=>'Task Definition Details'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(42025417508627628)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2001529467260594)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(5383269121373620)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2001955126260594)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(5383269121373620)
,p_button_name=>'CANCEL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2012867249260631)
,p_branch_name=>'Go To Page 9502'
,p_branch_action=>'f?p=&APP_ID.:9502:&SESSION.::&DEBUG.::P9502_ID:&P9501_NEW_TASK_DEF_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_when_button_id=>wwv_flow_imp.id(2001529467260594)
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1801357245324511)
,p_name=>'P9501_TASK_TYPE'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(8185473332191148)
,p_item_default=>'APPROVAL'
,p_prompt=>'Type'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TASK_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(1500990392400098)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the type of task - Action Task or Approval Task. The default is Approval Task.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2002627262260599)
,p_name=>'P9501_TASK_DEF_NAME'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(8185473332191148)
,p_prompt=>'Name'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter a name for the new Task Definition.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2003505525260604)
,p_name=>'P9501_NEW_TASK_DEF_ID'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(8185473332191148)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2003959673260604)
,p_name=>'P9501_SUBJECT'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(8185473332191148)
,p_prompt=>'Subject'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Provide a subject for the task definition.</p>',
'',
'<p>For example, <strong>"Purchase Requisition for Order &amp;ORDER_ID."</strong>, where ORDER_ID is a defined parameter of the task definition, which will be substituted with the parameter value on task creation.</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2005276623260605)
,p_name=>'P9501_STATIC_ID'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(8185473332191148)
,p_prompt=>'Static ID'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Static ID of the task definition. This can be used to create a new task instance based on the task definition.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2006095619260606)
,p_name=>'P9501_PRIORITY'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(8185473332191148)
,p_item_default=>'3'
,p_prompt=>'Priority'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TASK_PRIORITY_LEVELS'
,p_lov=>'.'||wwv_flow_imp.id(1532482169327772)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify the level of priority for the task. Choose a number between 1 and 5, where 1 is Urgent and 5 is the Lowest. The default value is 3 - Medium.'
,p_inline_help_text=>'Specify the level of priority for the task. Choose a number between 1 and 5, where 1 is Urgent and 5 is the Lowest. The default value is 3 - Medium.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2107281125618215)
,p_name=>'P9501_POTENTIAL'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(8185473332191148)
,p_prompt=>'Potential Owner'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The user to whom this task can be potentially assigned.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2107344345618216)
,p_name=>'P9501_BUSINESS'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(8185473332191148)
,p_prompt=>'Business Admin'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The user who will have administrative rights on this task.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2009967255260625)
,p_validation_name=>'Task Def Name is unique'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_task_defs',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and name              = :P9501_TASK_DEF_NAME'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Task Definition name is already taken'
,p_validation_condition=>'NEXT:CREATE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(2002627262260599)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2010227187260625)
,p_validation_name=>'Task Def Static ID is unique'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_task_defs',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id     = :FB_FLOW_ID',
'   and static_id  = :P9501_STATIC_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Static ID is already in use.'
,p_associated_item=>wwv_flow_imp.id(2005276623260605)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3203383490436633)
,p_validation_name=>'Task Def Static ID is alphanumeric'
,p_validation_sequence=>50
,p_validation=>'P9501_STATIC_ID'
,p_validation_type=>'ITEM_IS_ALPHANUMERIC'
,p_error_message=>'Identifier must contain alphanurmeric characters or ''_'''
,p_associated_item=>wwv_flow_imp.id(2005276623260605)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2010973914260626)
,p_name=>'Cancel'
,p_event_sequence=>50
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2001955126260594)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2011493485260628)
,p_event_id=>wwv_flow_imp.id(2010973914260626)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_DIALOG_CANCEL'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3203131624436631)
,p_name=>'Update Static Id'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P9501_TASK_DEF_NAME'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'keyup'
,p_display_when_type=>'ITEM_IS_NULL'
,p_display_when_cond=>'P9501_NEW_TASK_DEF_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3203258634436632)
,p_event_id=>wwv_flow_imp.id(3203131624436631)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>'$s(''P9501_STATIC_ID'',$v(''P9501_TASK_DEF_NAME'').replace(/\s+/g, ''_'').toUpperCase());'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2010569659260625)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Task Definition'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    :P9501_NEW_TASK_DEF_ID := wwv_flow_approval_dev.create_task_def (',
'        p_flow_id                => :FB_FLOW_ID,                                  ',
'        p_name                   => :P9501_TASK_DEF_NAME,                                    ',
'        p_static_id              => :P9501_STATIC_ID,                                   ',
'        p_subject                => :P9501_SUBJECT,',
'        p_task_type              => :P9501_TASK_TYPE,                                 ',
'        p_potential_participant  => :P9501_POTENTIAL,',
'        p_admin_participant      => :P9501_BUSINESS,',
'        p_priority               => :P9501_PRIORITY); ',
'end;',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when_button_id=>wwv_flow_imp.id(2001529467260594)
,p_process_success_message=>'Task Definition has been created. Now create <em>Participants</em> to assign additional owners of the task and <em>Parameters</em> for the task.'
,p_internal_uid=>2010569659260625
);
end;
/
prompt --application/pages/page_09502
begin
wwv_flow_imp_page.create_page(
 p_id=>9502
,p_name=>'Edit Task Definition'
,p_alias=>'EDIT-TASK-DEFINITION'
,p_step_title=>'Edit Task Definition'
,p_autocomplete_on_off=>'OFF'
,p_javascript_code=>'var htmldb_delete_message=''"DELETE_CONFIRM_MSG"'';'
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1504790347422308)
,p_plug_name=>'Deadline'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_TASK_DEFS'
,p_query_where=>wwv_flow_string.join(wwv_flow_t_varchar2(
'security_group_id = :WORKSPACE_ID ',
'and flow_id = :FB_FLOW_ID'))
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1904913767312218)
,p_plug_name=>'Actions'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_TASK_DEF_ACTIONS'
,p_query_where=>wwv_flow_string.join(wwv_flow_t_varchar2(
'task_def_id = :P9502_ID and  ',
'flow_id = :FB_FLOW_ID and  ',
'security_group_id = :flow_security_group_id'))
,p_include_rowid_column=>false
,p_plug_source_type=>'NATIVE_IG'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Actions'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1905245345312221)
,p_name=>'APEX$ROW_SELECTOR'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_use_as_row_header=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1905333624312222)
,p_name=>'APEX$ROW_ACTION'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>20
,p_use_as_row_header=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1905450520312223)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_LINK'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>30
,p_value_alignment=>'LEFT'
,p_link_target=>'javascript:apex.submit({request:''APPLY_CHANGES_EDIT_9502'',set:{''P9502_ACTION_ID'':''&ID.''}});'
,p_link_text=>'<span class="a-Icon icon-edit" title="&EDIT."></span>'
,p_link_attributes=>'class="a-Button a-Button--noUI"'
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
,p_escape_on_http_output=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1905541290312224)
,p_name=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FLOW_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>40
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'P9502_FLOW_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1905696513312225)
,p_name=>'SECURITY_GROUP_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'SECURITY_GROUP_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>50
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'EXPRESSION'
,p_default_language=>'SQL'
,p_default_expression=>':WORKSPACE_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1905716726312226)
,p_name=>'TASK_DEF_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'TASK_DEF_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>60
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'P9502_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1906317264312232)
,p_name=>'CREATED_BY'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'CREATED_BY'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>120
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1906432340312233)
,p_name=>'CREATED_ON'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'CREATED_ON'
,p_data_type=>'DATE'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>130
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1906532247312234)
,p_name=>'LAST_UPDATED_BY'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LAST_UPDATED_BY'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>140
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1906633378312235)
,p_name=>'LAST_UPDATED_ON'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LAST_UPDATED_ON'
,p_data_type=>'DATE'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>150
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1906753543312236)
,p_name=>'NAME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'NAME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Name'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>70
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_max_length=>255
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>true
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>'Name of the Action on the Task Definition.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1906808485312237)
,p_name=>'OUTCOME'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'OUTCOME'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Outcome'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>100
,p_value_alignment=>'LEFT'
,p_attribute_02=>'LOV'
,p_attribute_05=>'PLAIN'
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(1744994760068865)
,p_lov_display_extra=>true
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>'This restricts the action to be performed only when the task is completed with a specific outcome: Approved or Rejected.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1906988501312238)
,p_name=>'ON_EVENT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ON_EVENT'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'On Event'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>90
,p_value_alignment=>'LEFT'
,p_attribute_02=>'LOV'
,p_attribute_05=>'PLAIN'
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(2058881135907033)
,p_lov_display_extra=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>'The task event which triggers this Action. Events can be Complete, Cancel, Release, Delegate, Claim, Create, Update Comment, Update Priority.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1907015406312239)
,p_name=>'EXECUTION_SEQUENCE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'EXECUTION_SEQUENCE'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_NUMBER_FIELD'
,p_heading=>'Execution Sequence'
,p_heading_alignment=>'RIGHT'
,p_display_sequence=>110
,p_value_alignment=>'RIGHT'
,p_attribute_03=>'right'
,p_is_required=>true
,p_enable_filter=>true
,p_filter_is_required=>false
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(1907139442312240)
,p_name=>'ACTION_TYPE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ACTION_TYPE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_DISPLAY_ONLY'
,p_heading=>'Action Type'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>80
,p_value_alignment=>'LEFT'
,p_attribute_02=>'LOV'
,p_attribute_05=>'PLAIN'
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(362343527524601835)
,p_lov_display_extra=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>'The Action Type - Send Email or Execute PL/SQL code'
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(1905174208312220)
,p_internal_uid=>1905174208312220
,p_is_editable=>true
,p_edit_operations=>'u:d'
,p_lost_update_check_type=>'VALUES'
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>true
,p_no_data_found_message=>'Click <strong>Add Action</strong> to create the first Action.'
,p_show_toolbar=>true
,p_toolbar_buttons=>'SEARCH_COLUMN:SEARCH_FIELD:ACTIONS_MENU:RESET'
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>true
,p_define_chart_view=>true
,p_enable_download=>true
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>true
,p_fixed_header=>'NONE'
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(1927933294467510)
,p_interactive_grid_id=>wwv_flow_imp.id(1905174208312220)
,p_static_id=>'19280'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(1928159923467511)
,p_report_id=>wwv_flow_imp.id(1927933294467510)
,p_view_type=>'GRID'
,p_stretch_columns=>true
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1929073627467522)
,p_view_id=>wwv_flow_imp.id(1928159923467511)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(1905333624312222)
,p_is_visible=>true
,p_is_frozen=>true
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1929919249467526)
,p_view_id=>wwv_flow_imp.id(1928159923467511)
,p_display_seq=>2
,p_column_id=>wwv_flow_imp.id(1905450520312223)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1930847875467530)
,p_view_id=>wwv_flow_imp.id(1928159923467511)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(1905541290312224)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1931753934467534)
,p_view_id=>wwv_flow_imp.id(1928159923467511)
,p_display_seq=>4
,p_column_id=>wwv_flow_imp.id(1905696513312225)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1932672655467538)
,p_view_id=>wwv_flow_imp.id(1928159923467511)
,p_display_seq=>5
,p_column_id=>wwv_flow_imp.id(1905716726312226)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1933569489467541)
,p_view_id=>wwv_flow_imp.id(1928159923467511)
,p_display_seq=>11
,p_column_id=>wwv_flow_imp.id(1906317264312232)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1934434130467545)
,p_view_id=>wwv_flow_imp.id(1928159923467511)
,p_display_seq=>12
,p_column_id=>wwv_flow_imp.id(1906432340312233)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1935340801467549)
,p_view_id=>wwv_flow_imp.id(1928159923467511)
,p_display_seq=>13
,p_column_id=>wwv_flow_imp.id(1906532247312234)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1936203289467553)
,p_view_id=>wwv_flow_imp.id(1928159923467511)
,p_display_seq=>14
,p_column_id=>wwv_flow_imp.id(1906633378312235)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1937187152467557)
,p_view_id=>wwv_flow_imp.id(1928159923467511)
,p_display_seq=>6
,p_column_id=>wwv_flow_imp.id(1906753543312236)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1938055964467560)
,p_view_id=>wwv_flow_imp.id(1928159923467511)
,p_display_seq=>7
,p_column_id=>wwv_flow_imp.id(1906808485312237)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1938924176467564)
,p_view_id=>wwv_flow_imp.id(1928159923467511)
,p_display_seq=>8
,p_column_id=>wwv_flow_imp.id(1906988501312238)
,p_is_visible=>false
,p_is_frozen=>false
,p_break_order=>1
,p_break_is_enabled=>true
,p_break_sort_direction=>'ASC'
,p_break_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1939872959467568)
,p_view_id=>wwv_flow_imp.id(1928159923467511)
,p_display_seq=>9
,p_column_id=>wwv_flow_imp.id(1907015406312239)
,p_is_visible=>true
,p_is_frozen=>false
,p_sort_order=>1
,p_sort_direction=>'ASC'
,p_sort_nulls=>'LAST'
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1940799577467572)
,p_view_id=>wwv_flow_imp.id(1928159923467511)
,p_display_seq=>10
,p_column_id=>wwv_flow_imp.id(1907139442312240)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2260871315557304)
,p_plug_name=>'Comments'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2261657670557312)
,p_plug_name=>'Last Updated'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(29434107863295859)
,p_plug_display_sequence=>80
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3200143775436601)
,p_plug_name=>'Parameters'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_TASK_DEF_PARAMS'
,p_query_where=>wwv_flow_string.join(wwv_flow_t_varchar2(
'task_def_id = :P9502_ID and  ',
'flow_id = :FB_FLOW_ID and  ',
'security_group_id = :flow_security_group_id'))
,p_query_order_by_type=>'STATIC'
,p_query_order_by=>'LABEL'
,p_include_rowid_column=>false
,p_plug_source_type=>'NATIVE_IG'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Parameters'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2000429426299502)
,p_name=>'IS_UPDATABLE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'IS_UPDATABLE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_YES_NO'
,p_heading=>'Updatable'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>130
,p_value_alignment=>'LEFT'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
,p_attribute_03=>'Yes'
,p_attribute_04=>'N'
,p_attribute_05=>'No'
,p_is_required=>true
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'N'
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Indicates whether this parameter will be updatable in the Details Page of a task instantiated using the task definition, ',
'or by using the APEX_APPROVAL.SET_TASK_PARAMETER_VALUES() API by passing the ID of the instantiated task.'))
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2518881647988331)
,p_name=>'IS_VISIBLE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'IS_VISIBLE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_YES_NO'
,p_heading=>'Visible'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>120
,p_value_alignment=>'LEFT'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
,p_attribute_03=>'Yes'
,p_attribute_04=>'N'
,p_attribute_05=>'No'
,p_is_required=>true
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'Y'
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>'Indicates whether this parameter will be visible in the Details Page of a task instantiated using the task definition.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3200336236436603)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>30
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3200463338436604)
,p_name=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FLOW_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>40
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'P9502_FLOW_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3200598236436605)
,p_name=>'SECURITY_GROUP_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'SECURITY_GROUP_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>50
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'EXPRESSION'
,p_default_language=>'SQL'
,p_default_expression=>':WORKSPACE_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3200600372436606)
,p_name=>'TASK_DEF_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'TASK_DEF_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>60
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'P9502_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3200712338436607)
,p_name=>'STATIC_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'STATIC_ID'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Static ID'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>70
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_max_length=>255
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>true
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3200802980436608)
,p_name=>'LABEL'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LABEL'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Label'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>80
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_max_length=>255
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>'An end-user friendly name of the task parameter.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3200909722436609)
,p_name=>'DATA_TYPE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'DATA_TYPE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Data Type'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>100
,p_value_alignment=>'LEFT'
,p_is_required=>true
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(1501568839405634)
,p_lov_display_extra=>false
,p_lov_display_null=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'VARCHAR2'
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>'Data type of the task parameter is String'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3201095736436610)
,p_name=>'IS_REQUIRED'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'IS_REQUIRED'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_YES_NO'
,p_heading=>'Required'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>110
,p_value_alignment=>'LEFT'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
,p_attribute_03=>'Yes'
,p_attribute_04=>'N'
,p_attribute_05=>'No'
,p_is_required=>true
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'DISTINCT'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_enable_hide=>true
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'Y'
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>'Indicates whether this parameter is mandatory when a task is being instantiated using this task definition, using the Human Task - Create Page Processing type.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3201124529436611)
,p_name=>'PARAM_COMMENT'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'PARAM_COMMENT'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Comment'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>140
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
,p_help_text=>'Optional comment note describing the task parameter.'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3201260504436612)
,p_name=>'CREATED_BY'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'CREATED_BY'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>150
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3201393406436613)
,p_name=>'CREATED_ON'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'CREATED_ON'
,p_data_type=>'DATE'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>160
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3201412359436614)
,p_name=>'LAST_UPDATED_BY'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LAST_UPDATED_BY'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>170
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3201539167436615)
,p_name=>'LAST_UPDATED_ON'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'LAST_UPDATED_ON'
,p_data_type=>'DATE'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>180
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3202528827436625)
,p_name=>'APEX$ROW_ACTION'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>20
,p_use_as_row_header=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(3202640264436626)
,p_name=>'APEX$ROW_SELECTOR'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_use_as_row_header=>false
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(3200253576436602)
,p_internal_uid=>3200253576436602
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_add_row_if_empty=>false
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>true
,p_no_data_found_message=>'Click <strong>Add Row</strong> to create the first Parameter.'
,p_show_toolbar=>true
,p_toolbar_buttons=>'SEARCH_COLUMN:SEARCH_FIELD:ACTIONS_MENU:RESET'
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>true
,p_define_chart_view=>true
,p_enable_download=>true
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>true
,p_fixed_header=>'NONE'
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(3205782730441012)
,p_interactive_grid_id=>wwv_flow_imp.id(3200253576436602)
,p_static_id=>'32058'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(3205934623441013)
,p_report_id=>wwv_flow_imp.id(3205782730441012)
,p_view_type=>'GRID'
,p_stretch_columns=>true
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(1906814632378274)
,p_view_id=>wwv_flow_imp.id(3205934623441013)
,p_display_seq=>10
,p_column_id=>wwv_flow_imp.id(2518881647988331)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(2801125241369313)
,p_view_id=>wwv_flow_imp.id(3205934623441013)
,p_display_seq=>11
,p_column_id=>wwv_flow_imp.id(2000429426299502)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3206440241441018)
,p_view_id=>wwv_flow_imp.id(3205934623441013)
,p_display_seq=>2
,p_column_id=>wwv_flow_imp.id(3200336236436603)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3207381130441024)
,p_view_id=>wwv_flow_imp.id(3205934623441013)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(3200463338436604)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3208103529441028)
,p_view_id=>wwv_flow_imp.id(3205934623441013)
,p_display_seq=>4
,p_column_id=>wwv_flow_imp.id(3200598236436605)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3209062282441031)
,p_view_id=>wwv_flow_imp.id(3205934623441013)
,p_display_seq=>5
,p_column_id=>wwv_flow_imp.id(3200600372436606)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3209902275441034)
,p_view_id=>wwv_flow_imp.id(3205934623441013)
,p_display_seq=>6
,p_column_id=>wwv_flow_imp.id(3200712338436607)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3210818991441038)
,p_view_id=>wwv_flow_imp.id(3205934623441013)
,p_display_seq=>7
,p_column_id=>wwv_flow_imp.id(3200802980436608)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3211773250441041)
,p_view_id=>wwv_flow_imp.id(3205934623441013)
,p_display_seq=>8
,p_column_id=>wwv_flow_imp.id(3200909722436609)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3212650293441044)
,p_view_id=>wwv_flow_imp.id(3205934623441013)
,p_display_seq=>9
,p_column_id=>wwv_flow_imp.id(3201095736436610)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3213573015441047)
,p_view_id=>wwv_flow_imp.id(3205934623441013)
,p_display_seq=>16
,p_column_id=>wwv_flow_imp.id(3201124529436611)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3214409608441051)
,p_view_id=>wwv_flow_imp.id(3205934623441013)
,p_display_seq=>12
,p_column_id=>wwv_flow_imp.id(3201260504436612)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3215318177441054)
,p_view_id=>wwv_flow_imp.id(3205934623441013)
,p_display_seq=>13
,p_column_id=>wwv_flow_imp.id(3201393406436613)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3216233969441057)
,p_view_id=>wwv_flow_imp.id(3205934623441013)
,p_display_seq=>14
,p_column_id=>wwv_flow_imp.id(3201412359436614)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3217100827441060)
,p_view_id=>wwv_flow_imp.id(3205934623441013)
,p_display_seq=>15
,p_column_id=>wwv_flow_imp.id(3201539167436615)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3236445839596442)
,p_view_id=>wwv_flow_imp.id(3205934623441013)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(3202528827436625)
,p_is_visible=>true
,p_is_frozen=>true
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3201962690436619)
,p_plug_name=>'Task Definitions'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    <strong>Task Definitions</strong> define the properties of a human task.',
'    They are used to create task instances and then perform the appropriate',
'    action (examples are approving or rejecting the task instances. Tasks can',
'    also be claimed, released, delegated, canceled.',
'</p>',
'<p>',
'    <strong>Task Definition Participants</strong> define the participants of',
'    a human task who can act on the task. Participants can be either of type',
'    <strong> Potential Owner </strong> or <strong> Business Administrator',
'    </strong>.',
'</p>',
'<p>',
'    <strong>Task Definition Parameters</strong> define the parameters of a',
'    human task. These are typically attributes of a system of records for',
'    which the task has been defined. They constitute the payload of the task.',
'</p>',
'<p>',
'    <strong>Task Definition Actions</strong> fire once for an event performed',
'    on the task. Events can be:',
'</p>',
'<ul>',
'    <li><strong>Claim</strong></li>',
'    <li><strong>Complete</strong></li>',
'    <li><strong>Delegate</strong></li>',
'    <li><strong>Update Comment</strong></li>',
'    <li><strong>Update Priority</strong></li>',
'    <li><strong>Update Parameter</strong></li>',
'    <li><strong>Release</strong></li>',
'    <li><strong>Cancel</strong></li>',
'    <li><strong>Create</strong></li>',
'    <li><strong>Request Information</strong></li>',
'    <li><strong>Submit Information</strong></li>',
'    <li><strong>Before Expire</strong></li>',
'    <li><strong>Expire</strong></li>',
'</ul>',
'<p>',
'    <a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a>',
'</p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5402471995904376)
,p_plug_name=>'Settings'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_TASK_DEFS'
,p_query_where=>wwv_flow_string.join(wwv_flow_t_varchar2(
'security_group_id = :WORKSPACE_ID ',
'and flow_id = :FB_FLOW_ID'))
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5803225178785828)
,p_plug_name=>'Task Definition: &P9502_NAME.'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_item_display_point=>'BELOW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5803407882785829)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5803447828785830)
,p_plug_name=>'Name'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7705803391510760)
,p_plug_name=>'Participants'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>40
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_TASK_DEF_PARTICIPANTS'
,p_query_where=>wwv_flow_string.join(wwv_flow_t_varchar2(
'task_def_id = :P9502_ID and  ',
'flow_id = :FB_FLOW_ID and  ',
'security_group_id = :flow_security_group_id'))
,p_include_rowid_column=>false
,p_plug_source_type=>'NATIVE_IG'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Actions'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2110245541618245)
,p_name=>'TASK_DEF_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'TASK_DEF_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>60
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'ITEM'
,p_default_expression=>'P9502_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2110398706618246)
,p_name=>'PARTICIPANT_TYPE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'PARTICIPANT_TYPE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_SELECT_LIST'
,p_heading=>'Participant Type'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>70
,p_value_alignment=>'LEFT'
,p_is_required=>true
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(1502966218419601)
,p_lov_display_extra=>true
,p_lov_display_null=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>true
,p_enable_sort_group=>true
,p_enable_control_break=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'POTENTIAL_OWNER'
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2110499993618247)
,p_name=>'IDENTITY_TYPE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'IDENTITY_TYPE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>80
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'USER'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2110555025618248)
,p_name=>'VALUE_TYPE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'VALUE_TYPE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_RADIOGROUP'
,p_heading=>'Value Type'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>90
,p_value_alignment=>'LEFT'
,p_attribute_01=>'1'
,p_is_required=>true
,p_lov_type=>'SHARED'
,p_lov_id=>wwv_flow_imp.id(1503965976427173)
,p_lov_display_extra=>true
,p_lov_display_null=>false
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_exact_match=>true
,p_filter_lov_type=>'LOV'
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'STATIC'
,p_duplicate_value=>true
,p_include_in_export=>true
,p_escape_on_http_output=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2110668498618249)
,p_name=>'VALUE_LANGUAGE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'VALUE_LANGUAGE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>100
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(2110777506618250)
,p_name=>'VALUE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'VALUE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXTAREA'
,p_heading=>'Value'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>110
,p_value_alignment=>'LEFT'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_is_required=>true
,p_max_length=>4000
,p_enable_filter=>true
,p_filter_operators=>'C:S:CASE_INSENSITIVE:REGEXP'
,p_filter_is_required=>false
,p_filter_text_case=>'MIXED'
,p_filter_lov_type=>'NONE'
,p_use_as_row_header=>true
,p_enable_sort_group=>false
,p_enable_hide=>true
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>true
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(7705952250510762)
,p_name=>'ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>30
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(7706076848510763)
,p_name=>'FLOW_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'FLOW_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>40
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_is_primary_key=>false
,p_default_type=>'STATIC'
,p_default_expression=>'&FB_FLOW_ID.'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(7706188899510764)
,p_name=>'SECURITY_GROUP_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'SECURITY_GROUP_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>50
,p_attribute_01=>'Y'
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>true
,p_enable_control_break=>true
,p_is_primary_key=>false
,p_default_type=>'EXPRESSION'
,p_default_language=>'SQL'
,p_default_expression=>':WORKSPACE_ID'
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(8718638873925751)
,p_name=>'APEX$ROW_ACTION'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>20
,p_use_as_row_header=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(8718722969925752)
,p_name=>'APEX$ROW_SELECTOR'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_use_as_row_header=>false
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(7705823572510761)
,p_internal_uid=>7705823572510761
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_add_row_if_empty=>false
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>true
,p_no_data_found_message=>'Click <strong>Add Row</strong> to create the first Participant.'
,p_show_toolbar=>true
,p_toolbar_buttons=>'SEARCH_COLUMN:SEARCH_FIELD:RESET'
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>false
,p_define_chart_view=>false
,p_enable_download=>false
,p_download_formats=>null
,p_enable_mail_download=>true
,p_fixed_header=>'PAGE'
,p_show_icon_view=>false
,p_show_detail_view=>false
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(8722386155925944)
,p_interactive_grid_id=>wwv_flow_imp.id(7705823572510761)
,p_static_id=>'14393'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(8722445494925945)
,p_report_id=>wwv_flow_imp.id(8722386155925944)
,p_view_type=>'GRID'
,p_stretch_columns=>true
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3105839641672702)
,p_view_id=>wwv_flow_imp.id(8722445494925945)
,p_display_seq=>40
,p_column_id=>wwv_flow_imp.id(2110245541618245)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3106733093672708)
,p_view_id=>wwv_flow_imp.id(8722445494925945)
,p_display_seq=>41
,p_column_id=>wwv_flow_imp.id(2110398706618246)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3107645846672712)
,p_view_id=>wwv_flow_imp.id(8722445494925945)
,p_display_seq=>42
,p_column_id=>wwv_flow_imp.id(2110499993618247)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3108543605672716)
,p_view_id=>wwv_flow_imp.id(8722445494925945)
,p_display_seq=>43
,p_column_id=>wwv_flow_imp.id(2110555025618248)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3109427411672719)
,p_view_id=>wwv_flow_imp.id(8722445494925945)
,p_display_seq=>44
,p_column_id=>wwv_flow_imp.id(2110668498618249)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(3110332456672722)
,p_view_id=>wwv_flow_imp.id(8722445494925945)
,p_display_seq=>45
,p_column_id=>wwv_flow_imp.id(2110777506618250)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(8722920263925951)
,p_view_id=>wwv_flow_imp.id(8722445494925945)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(7705952250510762)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>40
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(8723482685925955)
,p_view_id=>wwv_flow_imp.id(8722445494925945)
,p_display_seq=>1
,p_column_id=>wwv_flow_imp.id(7706076848510763)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(8723999023925957)
,p_view_id=>wwv_flow_imp.id(8722445494925945)
,p_display_seq=>2
,p_column_id=>wwv_flow_imp.id(7706188899510764)
,p_is_visible=>false
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(8803925067987974)
,p_view_id=>wwv_flow_imp.id(8722445494925945)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(8718638873925751)
,p_is_visible=>true
,p_is_frozen=>false
,p_width=>62.667
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1924019899455021)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(1904913767312218)
,p_button_name=>'ADD_ACTION'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--strongLabel:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Add Action'
,p_button_position=>'CREATE'
,p_button_redirect_url=>'f?p=&APP_ID.:9506:&SESSION.::&DEBUG.:9506:P9506_TASK_DEF_ID,P9506_FLOW_ID,P9506_TASK_TYPE:&P9502_ID.,&P9502_FLOW_ID.,&P9502_TASK_TYPE.'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2932225196391285)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(5803225178785828)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:9500:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2932627917391286)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(5803225178785828)
,p_button_name=>'DELETE'
,p_button_action=>'REDIRECT_URL'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'javascript:apex.confirm(htmldb_delete_message,''DELETE'');'
,p_button_condition=>'P9502_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2933021960391287)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(5803225178785828)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P9502_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2933492022391287)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(5803225178785828)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>'P9502_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3087185159391443)
,p_branch_name=>'Go To Page 9502'
,p_branch_action=>'f?p=&APP_ID.:9502:&SESSION.::&DEBUG.:::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>20
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':REQUEST in (''CREATE'', ''SAVE'') and :P9502_RETURN_TO_PAGE = ''Y'''
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(3086729227391443)
,p_branch_name=>'Go To Page 9500'
,p_branch_action=>'f?p=&APP_ID.:9500:&SESSION.::&DEBUG.:9502:P9502_ID,P9502_RETURN_TO_PAGE:&P9502_ID.,&P9502_RETURN_TO_PAGE.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>30
,p_branch_condition_type=>'EXPRESSION'
,p_branch_condition=>':REQUEST in (''CREATE'', ''SAVE'', ''DELETE'')'
,p_branch_condition_text=>'PLSQL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1925481187455035)
,p_branch_name=>'Go To Page 9506'
,p_branch_action=>'f?p=&APP_ID.:9506:&SESSION.::&DEBUG.:9506:P9506_ID,P9506_TASK_TYPE:&P9502_ACTION_ID.,&P9502_TASK_TYPE.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>40
,p_branch_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_branch_condition=>'APPLY_CHANGES_EDIT_9502'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1504846232422309)
,p_name=>'P9502_EXPIRATION_POLICY'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(1504790347422308)
,p_item_source_plug_id=>wwv_flow_imp.id(5402471995904376)
,p_prompt=>'Expiration Policy'
,p_source=>'EXPIRATION_POLICY'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TASK_EXPIRATION_POLICY'
,p_lov=>'.'||wwv_flow_imp.id(1502210050672785)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specifies what happens automatically when a task remains open beyond its due',
'date. Choose <strong>Expire</strong> to transition the task to the Expired state ',
'or <strong>Renew</strong> to do that and also create a distinct renewal task ',
'related to the expired task. ',
'Choose <strong>None</strong> if no automatic expiration processing should occur.'))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1504927269422310)
,p_name=>'P9502_MAX_RENEWAL_COUNT'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(1504790347422308)
,p_item_source_plug_id=>wwv_flow_imp.id(5402471995904376)
,p_prompt=>'Maximum Renewal Count'
,p_source=>'MAX_RENEWAL_COUNT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>30
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Specifies the maximum number a task can be renewed after it has been expired. A task can be renewed up to 99 times.'
,p_attribute_01=>'1'
,p_attribute_02=>'99'
,p_attribute_03=>'left'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1508282082405302)
,p_name=>'P9502_DUE_ON_QUERY'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(1504790347422308)
,p_prompt=>'Due On'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'A SQL Query , Expression or PL/SQL Function Body returning a valid Due Date for the task.'
,p_attribute_01=>'SQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'N'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1509965410405319)
,p_name=>'P9502_DUE_ON_RESULT'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(1504790347422308)
,p_item_source_plug_id=>wwv_flow_imp.id(5402471995904376)
,p_source=>'DUE_ON_INTERVAL'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1794724308863536)
,p_name=>'P9502_PARAM_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3200143775436601)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1800556291962702)
,p_name=>'P9502_INITIATOR_CAN_COMPLETE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(5402471995904376)
,p_item_source_plug_id=>wwv_flow_imp.id(5402471995904376)
,p_item_default=>'N'
,p_prompt=>'Initiator Can Complete'
,p_source=>'INITIATOR_CAN_COMPLETE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_display_when=>'P9502_TASK_TYPE'
,p_display_when2=>'APPROVAL'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'<p>Specify if an initiator can approve or reject the task.</p><p>Choose <strong>on</strong> to allow task initiators to approve or reject the task.</p><p>Choose <strong>off</strong> to prohibit the initiator from completing the task.</p>'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1801411421324512)
,p_name=>'P9502_TASK_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_is_query_only=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(5402471995904376)
,p_item_source_plug_id=>wwv_flow_imp.id(5402471995904376)
,p_prompt=>'Type'
,p_source=>'TASK_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_named_lov=>'TASK_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(1500990392400098)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The task type.</p>',
'',
'<p>For example, an Action Task or an Approval Task.</p>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'LOV'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1905098433312219)
,p_name=>'P9502_ACTION_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1904913767312218)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1968325318480245)
,p_name=>'P9502_ACTIONS_SOURCE'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(5402471995904376)
,p_item_default=>'NONE'
,p_prompt=>'Actions Source'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'TASK_ACTION_SOURCES'
,p_lov=>'.'||wwv_flow_imp.id(1702015671505978)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Specify the source of the data evaluated during the execution of the actions defined on the task definition. These actions can be based on tables or SQL queries. ',
'An Actions SQL Query can reference the bind variable <tt>:APEX$TASK_PK</tt> to access the value of the primary key of the task detail row.'))
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2001246523304308)
,p_name=>'P9502_VACATION_RULE_PROC'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(7705803391510760)
,p_item_source_plug_id=>wwv_flow_imp.id(5402471995904376)
,p_prompt=>'Vacation Rule Procedure'
,p_source=>'VACATION_RULE_PROCEDURE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>100
,p_cMaxlength=>500
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify the name of a PL/SQL procedure in the format <strong>[schemaName.[packageName.]]procedureName</strong>. ',
'The procedure is expected to return additional alternate participants for this task definitions.',
'The vacation rule procedure should implement the following interface.</p>',
'<pre>',
'    procedure my_vacation_rule (',
'        p_param    in apex_approval.t_vacation_rule_input,',
'        p_result  out apex_approval.t_vacation_rule_output );',
'</pre>',
'<p>The procedure input is of type <strong>apex_approval.t_vacation_rule_input</strong> and the result output is of type <strong>apex_approval.t_vacation_rule_output</strong> </p>',
'<p>',
'This example shows a vacation rule procedure implementation where SCOTT is added as an alternate participant as JANE ',
'would be on maternity leave.</p>',
'<pre>',
'',
'    procedure alternate_job_approvers(',
'                p_param    in apex_approval.t_vacation_rule_input,',
'                p_result  out apex_approval.t_vacation_rule_result)',
'    is ',
'        l_result            apex_approval.t_vacation_rule_result;',
'        l_changes           apex_approval.t_task_participant_changes;',
'        l_participants      apex_approval.t_task_participants;',
'        l_new_participant   apex_approval.t_task_participant;',
'        l_old_participant   apex_approval.t_task_participant;',
'        l_has_changed       boolean                             := false;',
'        l_index             pls_integer                         := 1;',
'    begin',
'        l_participants := p_param.original_participants;',
'        for i in 1..l_participants.count loop',
'            if l_participants(i).value = ''JANE'' then',
'                l_old_participant               :=  l_participants(i);',
'                l_new_participant.value         := ''SCOTT'';',
'                l_new_participant.type          := ''POTENTIAL_OWNER'';',
'                l_new_participant.identity      := ''USER'';',
'                l_has_changed                   := true;',
'            end if;',
'        end loop;',
'        if l_has_changed then',
'            l_participants(l_participants.count + 1) := l_new_participant;',
'        ',
'            l_changes(l_index).old_participant   := l_old_participant;',
'            l_changes(l_index).new_participant   := l_new_participant;',
'            l_changes(l_index).change_reason     := ''Jane is out on maternity leave'';',
'        end if;',
'        l_result.participant_changes            := l_changes;',
'        l_result.has_participant_changes        := l_has_changed;',
'        p_result                                := l_result;',
'    end;',
'</pre>',
''))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2103427245135930)
,p_name=>'P9502_DUE_ON_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1504790347422308)
,p_item_source_plug_id=>wwv_flow_imp.id(5402471995904376)
,p_item_default=>'STATIC'
,p_prompt=>'Due On Type'
,p_source=>'DUE_ON_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TASK_DUE_ON_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(2155568708112694)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'None'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specifies if the Due Date is based on an ISO/SQL interval, SQL Query, Function Body, PL/SQL Expression or Scheduler Expression.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2103530672135931)
,p_name=>'P9502_DUE_ON_LANG'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(1504790347422308)
,p_item_source_plug_id=>wwv_flow_imp.id(5402471995904376)
,p_source=>'DUE_ON_LANGUAGE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_help_text=>'The programming language used in case the Due Date is derived from a Query or Expression.'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2108907596618232)
,p_name=>'P9502_SUBJECT'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(5402471995904376)
,p_item_source_plug_id=>wwv_flow_imp.id(5402471995904376)
,p_prompt=>'Subject'
,p_source=>'SUBJECT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>100
,p_cMaxlength=>400
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The subject for the task definition.</p>',
'',
'<p>For example, <strong>"Purchase Requisition for Order &amp;ORDER_ID."</strong>, where ORDER_ID is a defined parameter of the task definition, which will be substituted with the parameter value on task creation.</p>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2109033975618233)
,p_name=>'P9502_PRIORITY'
,p_source_data_type=>'NUMBER'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(5402471995904376)
,p_item_source_plug_id=>wwv_flow_imp.id(5402471995904376)
,p_prompt=>'Priority'
,p_source=>'PRIORITY'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TASK_PRIORITY_LEVELS'
,p_lov=>'.'||wwv_flow_imp.id(1532482169327772)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'The level of priority for the task. Choose a number between 1 and 5, where 1 is Urgent and 5 is the Lowest. The default value is 3 - Medium.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2109125538618234)
,p_name=>'P9502_DUE_ON_INTERVAL'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(1504790347422308)
,p_prompt=>'Due On Interval'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>20
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The ISO format or SQL format duration which specifies when a task is due.',
'Only positive interval values are allowed so the due date will be in the',
'future.'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_show_quick_picks=>'Y'
,p_quick_pick_label_01=>'In 30 Minutes'
,p_quick_pick_value_01=>'PT30M'
,p_quick_pick_label_02=>'In 1 Hour'
,p_quick_pick_value_02=>'PT1H'
,p_quick_pick_label_03=>'In 6 Hours'
,p_quick_pick_value_03=>'PT6H'
,p_quick_pick_label_04=>'In 12 Hours'
,p_quick_pick_value_04=>'PT12H'
,p_quick_pick_label_05=>'Tomorrow'
,p_quick_pick_value_05=>'P1D'
,p_quick_pick_label_06=>'Next Week'
,p_quick_pick_value_06=>'P7D'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2109280997618235)
,p_name=>'P9502_DETAILS_LINK_TARGET'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(5402471995904376)
,p_item_source_plug_id=>wwv_flow_imp.id(5402471995904376)
,p_prompt=>'Task Details Page URL'
,p_source=>'DETAILS_LINK_TARGET'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>100
,p_display_when=>'P9502_DETAILS_LINK_TARGET'
,p_display_when_type=>'ITEM_IS_NOT_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The URL of the task details page.</p>',
'',
'<p>The Tasks Details page will allow you to view the details of the task definition, when the task is selected on the unified task list report.</p>',
'',
'<p>The unified task list will show all initiated user tasks in the workspace.</p>',
'',
'<p>If your task definitions and unified task list are defined in different applications within your workspace, then ensure you configure session sharing in each application. This will allow the unified task list application to open the task details p'
||'ages in the task definition application. To configure session sharing in each application, navigate to Shared Components, Authentication Schemes, Your Scheme, Session Sharing.</p>',
'<div>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2109313436618236)
,p_name=>'P9502_ACTIONS_SQL_QUERY'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(5402471995904376)
,p_item_source_plug_id=>wwv_flow_imp.id(5402471995904376)
,p_prompt=>'Actions SQL Query'
,p_source=>'ACTIONS_SQL_QUERY'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'A SQL Query returning the system of records ',
'Specify the SQL query that will be the source of the data evaluated during the execution of the task associated with this task definition, for example: ',
'<pre>',
'select empno, ename, job, sal',
'from  emp',
'</pre>',
'Column values can be used within task definition actions with bind variable syntax (for example, <strong>:EMPNO</strong>). ',
''))
,p_attribute_01=>'SQL'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2109485792618237)
,p_name=>'P9502_ACTIONS_TABLE_OWNER'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(5402471995904376)
,p_item_source_plug_id=>wwv_flow_imp.id(5402471995904376)
,p_prompt=>'Table Owner'
,p_source=>'ACTIONS_TABLE_OWNER'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_SCHEMAS_HAVE_PRIVS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(owner) d, owner v',
'  from wwv_flow_object_owners_dev',
'order by d                   '))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'Parsing Schema'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'The schema owning the table which will serve as the system of records for actions defined for this task definition.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2109576077618238)
,p_name=>'P9502_ACTIONS_TABLE_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(5402471995904376)
,p_item_source_plug_id=>wwv_flow_imp.id(5402471995904376)
,p_prompt=>'Table Name'
,p_source=>'ACTIONS_TABLE_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_named_lov=>'P7021_TABLE_VIEWS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select object_name_esc,',
'       object_name',
'  from wwv_flow_tables_views_dev',
' where owner = coalesce( :P7021_TABLE_OWNER, wwv_flow_security.flow_owner( p_flow_id => :FB_FLOW_ID, p_security_group_id => :WORKSPACE_ID ) )',
''))
,p_lov_display_null=>'YES'
,p_cSize=>60
,p_cMaxlength=>128
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'A table which will serve as the system of records for actions defined for this task definition.'
,p_attribute_01=>'POPUP'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2109692064618239)
,p_name=>'P9502_ACTIONS_PK_COLUMN_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(5402471995904376)
,p_item_source_plug_id=>wwv_flow_imp.id(5402471995904376)
,p_prompt=>'Actions  Table Primary Key Column'
,p_source=>'ACTIONS_PK_COLUMN_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_POPUP_LOV'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select column_name_esc,',
'       column_name',
'  from table(wwv_flow_exec_dev.get_query_columns(',
'      p_location               => ''LOCAL'',',
'      p_query_type             => ''TABLE'',',
'      p_owner                  => :P9502_ACTIONS_TABLE_OWNER,',
'      p_table_name             => :P9502_ACTIONS_TABLE_NAME,',
'      p_sql_query              => null,      ',
'      p_function_body          => null,    ',
'      p_function_body_language => null,     ',
'      p_web_src_module_id      => null,',
'      p_remote_server_id       => null,',
'      p_post_processing_type   => null))',
' ',
''))
,p_lov_display_null=>'YES'
,p_lov_cascade_parent_items=>'P9502_ACTIONS_TABLE_NAME'
,p_ajax_optimize_refresh=>'Y'
,p_cSize=>60
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'The primary key column for the table which will serve as the system of records for actions defined for this task definition.'
,p_attribute_01=>'DIALOG'
,p_attribute_02=>'FIRST_ROWSET'
,p_attribute_04=>'N'
,p_attribute_05=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2109796414618240)
,p_name=>'P9502_TASK_DEF_COMMENT'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2260871315557304)
,p_item_source_plug_id=>wwv_flow_imp.id(5402471995904376)
,p_prompt=>'Comments'
,p_source=>'TASK_DEF_COMMENT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'A comment related to this task definition.'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2109835155618241)
,p_name=>'P9502_CREATED_BY'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(5402471995904376)
,p_item_source_plug_id=>wwv_flow_imp.id(5402471995904376)
,p_source=>'CREATED_BY'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2109954623618242)
,p_name=>'P9502_CREATED_ON'
,p_source_data_type=>'DATE'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(5402471995904376)
,p_item_source_plug_id=>wwv_flow_imp.id(5402471995904376)
,p_source=>'CREATED_ON'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2110054308618243)
,p_name=>'P9502_LAST_UPDATED_BY'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(2261657670557312)
,p_item_source_plug_id=>wwv_flow_imp.id(5402471995904376)
,p_prompt=>'Last Updated By'
,p_source=>'LAST_UPDATED_BY'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_begin_on_new_line=>'N'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2110133107618244)
,p_name=>'P9502_LAST_UPDATED_ON'
,p_source_data_type=>'DATE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2261657670557312)
,p_item_source_plug_id=>wwv_flow_imp.id(5402471995904376)
,p_prompt=>'Last Updated On'
,p_format_mask=>'DD-MON-RR'
,p_source=>'LAST_UPDATED_ON'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_DISPLAY_ONLY'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
,p_attribute_02=>'VALUE'
,p_attribute_04=>'Y'
,p_attribute_05=>'PLAIN'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2175156870753401)
,p_name=>'P9502_DUE_ON_SCHEDULER_VAL'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(1504790347422308)
,p_prompt=>'Due On Scheduler Expression'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>30
,p_cMaxlength=>255
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Use the <em>Database Scheduler calendaring syntax</em> to schedule a due date, such as "first Friday  of the month at 4:00 p.m." or "the 1st of a month". ',
'</p>',
'<p>',
'    To have more complex due on schedules, review details about the <strong>Scheduler Calendaring Syntax</strong> in the documentation of the <strong>DBMS_SCHEDULER</strong> PL/SQL package, and provide your expression manually.',
'</p>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2934811187391288)
,p_name=>'P9502_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(5803447828785830)
,p_item_source_plug_id=>wwv_flow_imp.id(5402471995904376)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2935698173391289)
,p_name=>'P9502_FLOW_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(5803447828785830)
,p_item_source_plug_id=>wwv_flow_imp.id(5402471995904376)
,p_item_default=>'&FB_FLOW_ID.'
,p_source=>'FLOW_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2936034632391289)
,p_name=>'P9502_NAME'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(5803447828785830)
,p_item_source_plug_id=>wwv_flow_imp.id(5402471995904376)
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Name of this task definition.'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2936975102391290)
,p_name=>'P9502_STATIC_ID'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(5803447828785830)
,p_item_source_plug_id=>wwv_flow_imp.id(5402471995904376)
,p_prompt=>'Static ID'
,p_source=>'STATIC_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Static ID for this task definition. The static ID is used when creating the task with the <strong>APEX_APPROVAL</strong> package (<strong>APEX_APPROVAL.CREATE_TASK</strong>).'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2965218534391338)
,p_name=>'P9502_PARTICIPANT_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(7705803391510760)
,p_display_as=>'NATIVE_HIDDEN'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3202235701436622)
,p_name=>'P9502_RETURN_TO_PAGE'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3201962690436619)
,p_prompt=>'Return to page'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4402487657135820)
,p_name=>'P9502_DUE_ON_EXPRESSION'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(1504790347422308)
,p_prompt=>'Due On'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'A SQL Query , Expression or PL/SQL Function Body returning a valid Due Date for the task.'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(4402509782135821)
,p_name=>'P9502_DUE_ON_FUNCTION_BODY'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(1504790347422308)
,p_prompt=>'Due On'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>100
,p_cMaxlength=>4000
,p_cHeight=>3
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'A SQL Query , Expression or PL/SQL Function Body returning a valid Due Date for the task.'
,p_attribute_01=>'PLSQL_FUNCTION_BODY'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(238045583179396401)
,p_name=>'P9502_DETAILS_LINK_PAGE_ID'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(5402471995904376)
,p_prompt=>'Task Details Page Number'
,p_post_element_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
' <a href="#" id="CREATE_TASK_DETAILS_PAGE_BUTTON" class="a-Button a-Button--small "',
'    title="Create Task Details Page" tabindex="0">Create Task Details Page</a>'))
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>30
,p_display_when=>'P9502_DETAILS_LINK_TARGET'
,p_display_when_type=>'ITEM_IS_NULL'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the page number that identifies a new page to be created in the application. The new Tasks Details page will allow you to view the details of the task, when the task is selected on the unified task list report. Click the <strong>Create Task '
||'Details Page</strong> button, to create the new page.</p>',
'',
'<p>If you do not specify a page number, the next available page number will be used in the creation of the new page, when <strong>Create Task Details Page</strong> is clicked.</p>',
'',
'<p>If your task definitions and unified task list are defined in different applications within your workspace, then ensure you configure session sharing in each application. This will allow the unified task list application to open the task details p'
||'ages in the task definition application. To configure session sharing in each application, navigate to Shared Components, Authentication Schemes, Your Scheme, Session Sharing.</p>'))
,p_attribute_03=>'right'
,p_attribute_04=>'decimal'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(222734847839034405)
,p_computation_sequence=>10
,p_computation_item=>'P9502_ACTIONS_SOURCE'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'EXPRESSION'
,p_computation_language=>'PLSQL'
,p_computation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'case when :P9502_ACTIONS_TABLE_NAME is not null',
'     then ''TABLE''',
'     when :P9502_ACTIONS_SQL_QUERY is not null',
'     then ''SQL''',
'     else ''NONE''',
'end'))
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(9164093529091029)
,p_computation_sequence=>20
,p_computation_item=>'P9502_EXPIRATION_POLICY'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'NONE'
,p_compute_when=>'P9502_EXPIRATION_POLICY'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3203003951436630)
,p_tabular_form_region_id=>wwv_flow_imp.id(7705803391510760)
,p_validation_name=>'Task Definition Participants: Validate Code'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_error varchar2(32767);',
'begin',
'    if :VALUE_TYPE in ( ''FUNCTION_BODY'', ''EXPRESSION'' ) then ',
'        l_error := wwv_flow_code_exec_dev.check_code (',
'                       p_type             => :VALUE_TYPE,',
'                       p_return_data_type => wwv_flow_code_exec_dev.c_return_data_type_varchar2,',
'                       p_code             => :VALUE,',
'                       p_language         => coalesce( :VALUE_LANGUAGE, wwv_flow_code_exec.c_plsql ),',
'                       p_application_id   => :FB_FLOW_ID );            ',
'    elsif :VALUE_TYPE = ''SQL_QUERY'' then',
'        l_error := wwv_flow_f4000_util.check_sql(',
'                       p_sql               => :VALUE,',
'                       p_flow_id           => :FB_FLOW_ID );',
'    end if;',
'    ',
'    return l_error;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_associated_column=>'VALUE'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3203696231436636)
,p_tabular_form_region_id=>wwv_flow_imp.id(3200143775436601)
,p_validation_name=>'Static ID must be alphanumeric'
,p_validation_sequence=>20
,p_validation=>'STATIC_ID'
,p_validation_type=>'ITEM_IS_ALPHANUMERIC'
,p_error_message=>'#COLUMN_HEADER# must be alphanumeric.'
,p_associated_column=>'STATIC_ID'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1705428619273907)
,p_validation_name=>'Due On Interval must be valid ISO or SQL interval format'
,p_validation_sequence=>30
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_due_on timestamp := null;',
'begin',
'    if :P9502_DUE_ON_TYPE is not null and :P9502_DUE_ON_TYPE != ''INTERVAL'' then',
'        return true;',
'    else   ',
'        -- Due On Interval should not be null or negative',
'        if :P9502_DUE_ON_TYPE is not null ',
'            and (:P9502_DUE_ON_INTERVAL is null',
'            or :P9502_DUE_ON_INTERVAL like ''-%'') then ',
'            return false;',
'        end if;',
'        select systimestamp + to_dsinterval(:P9502_DUE_ON_INTERVAL) ',
'          into l_due_on ',
'          from sys.dual;',
'    end if;      ',
'    return true;',
'exception',
'    when others then',
'    return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Invalid Interval format.'
,p_validation_condition=>'CREATE:SAVE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(2109125538618234)
,p_error_display_location=>'INLINE_WITH_FIELD'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2260933541557305)
,p_validation_name=>'Validate SQL Actions Source'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    return wwv_flow_code_exec_dev.check_code (',
'               p_code     => :P9502_ACTIONS_SQL_QUERY,',
'               p_language => ''SQL'' );',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':REQUEST in (''APPLY_CHANGES'',''CREATE'') and :P9502_ACTIONS_SOURCE = ''SQL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(2109313436618236)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2261241066557308)
,p_validation_name=>'Task Definition in use'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_steps           p,',
'       wwv_flow_step_processing pr,',
'       wwv_flow_task_defs       t',
' where t.id = pr.attribute_01',
'   and t.id = :P9502_ID',
'   and pr.process_type      = ''NATIVE_CREATE_TASK''',
'   and pr.flow_step_id      = p.id',
'   and pr.flow_id           = p.flow_id',
'   and p.flow_id            = t.flow_id',
'   and pr.security_group_id = :flow_security_group_id',
'   and p.security_group_id  = :flow_security_group_id',
'   and t.security_group_id  = :flow_security_group_id'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Task Definition can not be deleted as it is in use by one or more page processes.'
,p_when_button_pressed=>wwv_flow_imp.id(2932627917391286)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(238464660669582701)
,p_validation_name=>'Details page exists'
,p_validation_sequence=>60
,p_validation=>'not wwv_flow_wizard_api.page_exists( :FB_FLOW_ID, :P9502_DETAILS_LINK_PAGE_ID )'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'The specified page for the task details page already exists. Please specify another one.'
,p_validation_condition=>'CREATE_TASK_DETAILS_PAGE'
,p_validation_condition_type=>'REQUEST_EQUALS_CONDITION'
,p_associated_item=>wwv_flow_imp.id(238045583179396401)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2178094020753430)
,p_validation_name=>'Scheduler Expression is valid'
,p_validation_sequence=>70
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'l_task_due_on timestamp with time zone := null;',
'begin',
'  if :P9502_DUE_ON_TYPE = ''SCHEDULER_EXPRESSION'' then',
'    sys.dbms_scheduler.evaluate_calendar_string(:P9502_DUE_ON_SCHEDULER_VAL,null,null,l_task_due_on);',
'  end if; ',
'  return true;',
'exception',
'  when others then',
'      return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Scheduler Expression is not valid'
,p_validation_condition=>'CREATE:SAVE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(2175156870753401)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4401315237135809)
,p_validation_name=>'Due On Query Not Empty'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if :P9502_DUE_ON_TYPE =''SQL_QUERY''',
'        and :P9502_DUE_ON_QUERY is null then',
'        return false;',
'    end if;',
'    return true;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Due On must contain a non empty value when the Due On Type is SQL Query.'
,p_validation_condition=>'CREATE:SAVE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(1508282082405302)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(8804648013066907)
,p_validation_name=>'Validate Due On Code'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_error varchar2(32767);',
'begin',
'    if :P9502_DUE_ON_TYPE = ''SQL_QUERY'' then',
'        l_error := wwv_flow_f4000_util.check_sql(',
'                       p_sql               => :P9502_DUE_ON_QUERY,',
'                       p_flow_id           => :FB_FLOW_ID );',
'    end if;',
'    ',
'    return l_error;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'CREATE:SAVE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(1508282082405302)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4402664453135822)
,p_validation_name=>'Due On Expression Not Empty'
,p_validation_sequence=>100
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if :P9502_DUE_ON_TYPE =''EXPRESSION'' ',
'        and :P9502_DUE_ON_EXPRESSION is null then',
'        return false;',
'    end if;',
'    return true;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Due On must contain a non empty value when the Due On Type is Expression.'
,p_validation_condition=>'CREATE:SAVE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(4402487657135820)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4402727774135823)
,p_validation_name=>'Validate Due On Expression'
,p_validation_sequence=>110
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_error varchar2(32767);',
'begin    ',
'    if  :P9502_DUE_ON_TYPE = ''EXPRESSION'' then  ',
'        l_error := wwv_flow_code_exec_dev.check_code (',
'                       p_type             => :P9502_DUE_ON_TYPE,',
'                       p_return_data_type => wwv_flow_code_exec_dev.c_return_data_type_custom,',
'                       p_custom_data_type => ''TIMESTAMP WITH TIME ZONE'',',
'                       p_code             => :P9502_DUE_ON_EXPRESSION,',
'                       p_language         => ''PLSQL'',',
'                       p_application_id   => :FB_FLOW_ID );            ',
'    end if;',
'    return l_error;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'CREATE:SAVE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(4402487657135820)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4402885180135824)
,p_validation_name=>'Due On Function Body Not Empty'
,p_validation_sequence=>120
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if :P9502_DUE_ON_TYPE =''FUNCTION_BODY''',
'        and :P9502_DUE_ON_FUNCTION_BODY is null then',
'        return false;',
'    end if;',
'    return true;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Due On must contain a non empty value when the Due On Type is Function Body.'
,p_validation_condition=>'CREATE:SAVE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(4402509782135821)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4402979399135825)
,p_validation_name=>'Validate Due On Function Body'
,p_validation_sequence=>130
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_error varchar2(32767);',
'begin    ',
'    if  :P9502_DUE_ON_TYPE = ''FUNCTION_BODY'' then  ',
'        l_error := wwv_flow_code_exec_dev.check_code (',
'                       p_type             => :P9502_DUE_ON_TYPE,',
'                       p_return_data_type => wwv_flow_code_exec_dev.c_return_data_type_custom,',
'                       p_custom_data_type => ''TIMESTAMP WITH TIME ZONE'',',
'                       p_code             => :P9502_DUE_ON_FUNCTION_BODY,',
'                       p_language         => ''PLSQL'',',
'                       p_application_id   => :FB_FLOW_ID );            ',
'    end if;',
'    return l_error;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>'CREATE:SAVE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(4402509782135821)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(130920038509152702)
,p_validation_name=>'Validate Expire Actions'
,p_validation_sequence=>140
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_expire_events_exist varchar2(1);',
'    ',
'begin',
'    select 1 into l_expire_events_exist',
'      from sys.dual',
'     where exists (select td.id',
'      from wwv_flow_task_def_actions ta,wwv_flow_task_defs td',
'     where ta.task_def_id = :P9502_ID',
'       and td.id = :P9502_ID',
'       and ta.on_event in (''EXPIRE'',''BEFORE_EXPIRE'')',
'       and (:P9502_DUE_ON_TYPE is null or :P9502_EXPIRATION_POLICY =''NONE'')',
'       and ta.security_group_id = :WORKSPACE_ID);',
'',
'     return false;',
'exception   ',
'    when no_data_found then ',
'     return true;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'The task definition must define a <strong>Due On Type</strong> and an <strong>Expiration Policy</strong> to use actions for <strong>Before Expire</strong> or <strong>Expire</strong> events.'
,p_when_button_pressed=>wwv_flow_imp.id(2933021960391287)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2200818192294803)
,p_validation_name=>'Vacation Rule Procedure Name is valid'
,p_validation_sequence=>150
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    return wwv_flow_approval_dev.validate_vacation_rule_proc(p_proc_name => :P9502_VACATION_RULE_PROC);',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Please provide a valid name for the Vacation Rule Procedure.'
,p_validation_condition=>'P9502_VACATION_RULE_PROC'
,p_validation_condition_type=>'ITEM_IS_NOT_NULL'
,p_associated_item=>wwv_flow_imp.id(2001246523304308)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1968480305480246)
,p_name=>'Selected Table Source'
,p_event_sequence=>390
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P9502_ACTIONS_SOURCE'
,p_condition_element=>'P9502_ACTIONS_SOURCE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'TABLE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1968567067480247)
,p_event_id=>wwv_flow_imp.id(1968480305480246)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9502_ACTIONS_TABLE_OWNER,P9502_ACTIONS_TABLE_NAME,P9502_ACTIONS_PK_COLUMN_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1968692673480248)
,p_event_id=>wwv_flow_imp.id(1968480305480246)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9502_ACTIONS_SQL_QUERY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(222734974198034406)
,p_event_id=>wwv_flow_imp.id(1968480305480246)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9502_ACTIONS_SQL_QUERY'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1968764648480249)
,p_name=>'Selected SQL Source'
,p_event_sequence=>400
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P9502_ACTIONS_SOURCE'
,p_condition_element=>'P9502_ACTIONS_SOURCE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SQL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1968882085480250)
,p_event_id=>wwv_flow_imp.id(1968764648480249)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9502_ACTIONS_SQL_QUERY,P9502_ACTIONS_PK_COLUMN_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2260528283557301)
,p_event_id=>wwv_flow_imp.id(1968764648480249)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9502_ACTIONS_TABLE_OWNER,P9502_ACTIONS_TABLE_NAME,P9502_ACTIONS_PK_COLUMN_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(222735070747034407)
,p_event_id=>wwv_flow_imp.id(1968764648480249)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9502_ACTIONS_TABLE_OWNER,P9502_ACTIONS_TABLE_NAME,P9502_ACTIONS_PK_COLUMN_NAME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2260624780557302)
,p_name=>'Selected None'
,p_event_sequence=>410
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P9502_ACTIONS_SOURCE'
,p_condition_element=>'P9502_ACTIONS_SOURCE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NONE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2260709019557303)
,p_event_id=>wwv_flow_imp.id(2260624780557302)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9502_ACTIONS_SQL_QUERY,P9502_ACTIONS_TABLE_OWNER,P9502_ACTIONS_TABLE_NAME,P9502_ACTIONS_PK_COLUMN_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(222735116424034408)
,p_event_id=>wwv_flow_imp.id(2260624780557302)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9502_ACTIONS_SQL_QUERY,P9502_ACTIONS_TABLE_OWNER,P9502_ACTIONS_TABLE_NAME,P9502_ACTIONS_PK_COLUMN_NAME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2261089177557306)
,p_name=>'Update Parameter Label'
,p_event_sequence=>420
,p_triggering_element_type=>'COLUMN'
,p_triggering_region_id=>wwv_flow_imp.id(3200143775436601)
,p_triggering_element=>'STATIC_ID'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2261141685557307)
,p_event_id=>wwv_flow_imp.id(2261089177557306)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'COLUMN'
,p_affected_elements=>'LABEL'
,p_attribute_01=>'PLSQL_EXPRESSION'
,p_attribute_04=>'replace(initcap(:STATIC_ID),''_'','' '')'
,p_attribute_07=>'STATIC_ID'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(238464700551582702)
,p_name=>'Create Task Details Page'
,p_event_sequence=>430
,p_triggering_element_type=>'JQUERY_SELECTOR'
,p_triggering_element=>'#CREATE_TASK_DETAILS_PAGE_BUTTON'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(238464996913582704)
,p_event_id=>wwv_flow_imp.id(238464700551582702)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'You have not specified a page number. Should we use the next available page number?'
,p_client_condition_type=>'NULL'
,p_client_condition_element=>'P9502_DETAILS_LINK_PAGE_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(264561050614141101)
,p_event_id=>wwv_flow_imp.id(238464700551582702)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>':P9502_DETAILS_LINK_PAGE_ID := wwv_flow_utilities.minimum_free_page(:FB_FLOW_ID);'
,p_attribute_03=>'P9502_DETAILS_LINK_PAGE_ID'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
,p_client_condition_type=>'NULL'
,p_client_condition_element=>'P9502_DETAILS_LINK_PAGE_ID'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(238464862149582703)
,p_event_id=>wwv_flow_imp.id(238464700551582702)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'SAVE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2103874325135934)
,p_name=>'Interval Due On'
,p_event_sequence=>440
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P9502_DUE_ON_TYPE'
,p_condition_element=>'P9502_DUE_ON_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'INTERVAL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2103994105135935)
,p_event_id=>wwv_flow_imp.id(2103874325135934)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9502_DUE_ON_QUERY,P9502_DUE_ON_SCHEDULER_VAL,P9502_DUE_ON_EXPRESSION,P9502_DUE_ON_FUNCTION_BODY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1508508307405305)
,p_event_id=>wwv_flow_imp.id(2103874325135934)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9502_DUE_ON_INTERVAL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1510179738405321)
,p_event_id=>wwv_flow_imp.id(2103874325135934)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9502_DUE_ON_QUERY,P9502_DUE_ON_INTERVAL,P9502_DUE_ON_LANG,P9502_DUE_ON_SCHEDULER_VAL,P9502_DUE_ON_EXPRESSION,P9502_DUE_ON_FUNCTION_BODY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2176353749753413)
,p_event_id=>wwv_flow_imp.id(2103874325135934)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9502_DUE_ON_LANG'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'NULL'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2104300614135939)
,p_name=>'Null Due On Format'
,p_event_sequence=>450
,p_condition_element=>'P9502_DUE_ON_TYPE'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'ready'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2104414807135940)
,p_event_id=>wwv_flow_imp.id(2104300614135939)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9502_DUE_ON_LANG'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2175227220753402)
,p_name=>'Query  Based Due On'
,p_event_sequence=>460
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P9502_DUE_ON_TYPE'
,p_condition_element=>'P9502_DUE_ON_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SQL_QUERY'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2175340973753403)
,p_event_id=>wwv_flow_imp.id(2175227220753402)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9502_DUE_ON_INTERVAL,P9502_DUE_ON_SCHEDULER_VAL,P9502_DUE_ON_EXPRESSION,P9502_DUE_ON_FUNCTION_BODY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2175405116753404)
,p_event_id=>wwv_flow_imp.id(2175227220753402)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9502_DUE_ON_QUERY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2175587870753405)
,p_event_id=>wwv_flow_imp.id(2175227220753402)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9502_DUE_ON_QUERY,P9502_DUE_ON_EXPRESSION,P9502_DUE_ON_FUNCTION_BODY'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2175688281753406)
,p_name=>'Scheduler Due On'
,p_event_sequence=>470
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P9502_DUE_ON_TYPE'
,p_condition_element=>'P9502_DUE_ON_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'SCHEDULER_EXPRESSION'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2175704030753407)
,p_event_id=>wwv_flow_imp.id(2175688281753406)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9502_DUE_ON_INTERVAL,P9502_DUE_ON_QUERY,P9502_DUE_ON_EXPRESSION,P9502_DUE_ON_FUNCTION_BODY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2176092268753410)
,p_event_id=>wwv_flow_imp.id(2175688281753406)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9502_DUE_ON_SCHEDULER_VAL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2176154871753411)
,p_event_id=>wwv_flow_imp.id(2175688281753406)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9502_DUE_ON_SCHEDULER_VAL,P9502_DUE_ON_LANG,P9502_DUE_ON_INTERVAL,P9502_DUE_ON_QUERY,P9502_DUE_ON_EXPRESSION,P9502_DUE_ON_FUNCTION_BODY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2176210694753412)
,p_event_id=>wwv_flow_imp.id(2175688281753406)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9502_DUE_ON_LANG'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'NULL'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(8804737361066908)
,p_name=>'Expression Based Due On'
,p_event_sequence=>480
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P9502_DUE_ON_TYPE'
,p_condition_element=>'P9502_DUE_ON_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'EXPRESSION'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8804825583066909)
,p_event_id=>wwv_flow_imp.id(8804737361066908)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9502_DUE_ON_EXPRESSION'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8804936039066910)
,p_event_id=>wwv_flow_imp.id(8804737361066908)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9502_DUE_ON_INTERVAL,P9502_DUE_ON_SCHEDULER_VAL,P9502_DUE_ON_QUERY,P9502_DUE_ON_FUNCTION_BODY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(8805090090066911)
,p_event_id=>wwv_flow_imp.id(8804737361066908)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9502_DUE_ON_SCHEDULER_VAL,P9502_DUE_ON_LANG,P9502_DUE_ON_INTERVAL,P9502_DUE_ON_QUERY,P9502_DUE_ON_EXPRESSION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4400880193135804)
,p_name=>'Function Body Based Due On'
,p_event_sequence=>490
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P9502_DUE_ON_TYPE'
,p_condition_element=>'P9502_DUE_ON_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'FUNCTION_BODY'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4400978200135805)
,p_event_id=>wwv_flow_imp.id(4400880193135804)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9502_DUE_ON_FUNCTION_BODY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4401017388135806)
,p_event_id=>wwv_flow_imp.id(4400880193135804)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9502_DUE_ON_INTERVAL,P9502_DUE_ON_SCHEDULER_VAL,P9502_DUE_ON_LANG,P9502_DUE_ON_EXPRESSION,P9502_DUE_ON_QUERY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4401116940135807)
,p_event_id=>wwv_flow_imp.id(4400880193135804)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9502_DUE_ON_SCHEDULER_VAL,P9502_DUE_ON_LANG,P9502_DUE_ON_INTERVAL,P9502_DUE_ON_QUERY,P9502_DUE_ON_EXPRESSION,P9502_DUE_ON_FUNCTION_BODY'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4401428145135810)
,p_name=>'No Due On'
,p_event_sequence=>500
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P9502_DUE_ON_TYPE'
,p_condition_element=>'P9502_DUE_ON_TYPE'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1497766648762209)
,p_event_id=>wwv_flow_imp.id(4401428145135810)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9502_EXPIRATION_POLICY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4401509217135811)
,p_event_id=>wwv_flow_imp.id(4401428145135810)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9502_DUE_ON_INTERVAL,P9502_DUE_ON_QUERY,P9502_DUE_ON_SCHEDULER_VAL,P9502_DUE_ON_EXPRESSION,P9502_DUE_ON_FUNCTION_BODY,P9502_EXPIRATION_POLICY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4401785182135813)
,p_event_id=>wwv_flow_imp.id(4401428145135810)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9502_DUE_ON_LANG,P9502_DUE_ON_INTERVAL,P9502_DUE_ON_QUERY,P9502_DUE_ON_SCHEDULER_VAL,P9502_DUE_ON_EXPRESSION,P9502_DUE_ON_FUNCTION_BODY,P9502_EXPIRATION_POLICY,P9502_MAX_RENEWAL_COUNT'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1505066703422311)
,p_name=>'Expiration Policy is Renew'
,p_event_sequence=>510
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P9502_EXPIRATION_POLICY'
,p_condition_element=>'P9502_EXPIRATION_POLICY'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'RENEW'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1505153408422312)
,p_event_id=>wwv_flow_imp.id(1505066703422311)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9502_MAX_RENEWAL_COUNT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1505287962422313)
,p_event_id=>wwv_flow_imp.id(1505066703422311)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9502_MAX_RENEWAL_COUNT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1505328873422314)
,p_event_id=>wwv_flow_imp.id(1505066703422311)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9502_MAX_RENEWAL_COUNT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3600228318108602)
,p_event_id=>wwv_flow_imp.id(1505066703422311)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9502_MAX_RENEWAL_COUNT'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'3'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4400560466135801)
,p_process_sequence=>10
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch Due On Value'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare     ',
'    l_due_on varchar2(500);',
'begin',
'    select due_on_interval into l_due_on ',
'      from wwv_flow_task_defs',
'     where id = :P9502_ID',
'       and security_group_id = :WORKSPACE_ID;',
'',
'    if l_due_on is not null then   ',
'        if :P9502_DUE_ON_TYPE    = ''INTERVAL''  then',
'            :P9502_DUE_ON_INTERVAL      := l_due_on;',
'        elsif :P9502_DUE_ON_TYPE = ''SCHEDULER_EXPRESSION'' then',
'            :P9502_DUE_ON_SCHEDULER_VAL := l_due_on;',
'        elsif :P9502_DUE_ON_TYPE = ''EXPRESSION'' then',
'            :P9502_DUE_ON_EXPRESSION    := l_due_on;',
'        elsif :P9502_DUE_ON_TYPE = ''FUNCTION_BODY'' then',
'            :P9502_DUE_ON_FUNCTION_BODY := l_due_on;',
'        elsif :P9502_DUE_ON_TYPE = ''SQL_QUERY'' then',
'            :P9502_DUE_ON_QUERY         := l_due_on;',
'        end if;',
'    end if;',
'end;    ',
''))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>4400560466135801
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1497869624762210)
,p_process_sequence=>20
,p_process_point=>'AFTER_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Fetch Max Renewal Count'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare     ',
'    l_max_renewal_count number;',
'begin',
'    select max_renewal_count into l_max_renewal_count ',
'      from wwv_flow_task_defs',
'     where id = :P9502_ID',
'       and security_group_id = :WORKSPACE_ID;',
'',
'    if l_max_renewal_count is null then   ',
'        :P9502_MAX_RENEWAL_COUNT := 3;',
'    end if;',
'end;    ',
''))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>1497869624762210
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2931562059391285)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(5402471995904376)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process form Edit Task Definition'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Changes applied.'
,p_internal_uid=>2931562059391285
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3202927445436629)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(7705803391510760)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Participants - Set value language'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    -- Task Definition Participant Values should always be handled as PL/SQL,',
'    -- in an IG it''s to complicated having a dynamic languages column',
'    if :VALUE_TYPE in ( ''FUNCTION_BODY'', ''EXPRESSION'' ) then',
'        :VALUE_LANGUAGE := ''PLSQL'';',
'    else',
'        :VALUE_LANGUAGE := null;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>3202927445436629
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2965633144391339)
,p_process_sequence=>40
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(7705803391510760)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Participants- Save Interactive Grid Data'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Participants saved.'
,p_internal_uid=>2965633144391339
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3202793903436627)
,p_process_sequence=>50
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(3200143775436601)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Parameters - Save Interactive Grid Data'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Parameters saved.'
,p_internal_uid=>3202793903436627
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2516133581988304)
,p_process_sequence=>60
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(3200143775436601)
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Sync New Parameters'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'wwv_flow_approval_dev.sync_task_def_param_attributes(',
'    p_application_id    => :FB_FLOW_ID,',
'    p_task_def_id => :P9502_ID );',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2516133581988304
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1925565635455036)
,p_process_sequence=>70
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(1904913767312218)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Actions- Save Interactive Grid Data'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>' Actions saved.'
,p_internal_uid=>1925565635455036
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2501980122989403)
,p_process_sequence=>90
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Create Task Details Page'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_approval_dev.create_task_details_forms (',
'        p_flow_id              => :FB_FLOW_ID,',
'        p_details_page_id      => :P9502_DETAILS_LINK_PAGE_ID,',
'        p_task_definition_name => :P9502_NAME,',
'        p_task_type            => :P9502_TASK_TYPE',
'    );',
'',
'    :P9502_DETAILS_LINK_TARGET :=',
'        -- the funny text concatenation is needed to prevent placeholder',
'        -- replacements by the APEX engine',
'        ''f?p=&'' || ''APP_ID.:'' || :P9502_DETAILS_LINK_PAGE_ID ||',
'        '':&'' || ''SESSION.::&'' || ''DEBUG.:RP,''  || :P9502_DETAILS_LINK_PAGE_ID || ',
'        '':P'' || :P9502_DETAILS_LINK_PAGE_ID || ''_TASK_ID:&'' || ''TASK_ID.'';',
'',
'    update wwv_flow_task_defs ',
'       set details_link_target = :P9502_DETAILS_LINK_TARGET',
'     where id                  = :P9502_ID',
'       and flow_id             = :FB_FLOW_ID',
'       and security_group_id   = wwv_flow_security.g_security_group_id;',
'',
'    :P9502_DETAILS_LINK_PAGE_ID := null;',
'end;',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':P9502_DETAILS_LINK_PAGE_ID > 0'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_process_success_message=>' Task details page created.'
,p_internal_uid=>2501980122989403
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2931105024391284)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(5402471995904376)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Edit Task Definition'
,p_internal_uid=>2931105024391284
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4400695478135802)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Due On Result'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
':P9502_DUE_ON_RESULT :=',
'    case  :P9502_DUE_ON_TYPE',
'        when ''INTERVAL''             then :P9502_DUE_ON_INTERVAL',
'        when ''SCHEDULER_EXPRESSION'' then :P9502_DUE_ON_SCHEDULER_VAL',
'        when ''SQL_QUERY''            then :P9502_DUE_ON_QUERY',
'        when ''FUNCTION_BODY''        then :P9502_DUE_ON_FUNCTION_BODY',
'        when ''EXPRESSION''           then :P9502_DUE_ON_EXPRESSION',
'        else  null',
'    end;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>4400695478135802
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(8805142006066912)
,p_process_sequence=>20
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Due On Language'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
':P9502_DUE_ON_LANG :=',
'    case  :P9502_DUE_ON_TYPE ',
'        when ''SQL_QUERY'' then ''SQL''',
'        when ''FUNCTION_BODY'' then ''PLSQL''',
'        when ''EXPRESSION'' then ''PLSQL''',
'        else  null',
'    end;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>8805142006066912
);
end;
/
prompt --application/pages/page_09503
begin
wwv_flow_imp_page.create_page(
 p_id=>9503
,p_name=>'Edit Task Definition Actions'
,p_alias=>'EDIT-TASK-DEFINITION-ACTIONS'
,p_step_title=>'Edit Task Definition Actions'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'11'
);
end;
/
prompt --application/pages/page_09505
begin
wwv_flow_imp_page.create_page(
 p_id=>9505
,p_name=>'Task Details'
,p_alias=>'TASK-DETAILS'
,p_step_title=>'Task Details'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'11'
);
end;
/
prompt --application/pages/page_09506
begin
wwv_flow_imp_page.create_page(
 p_id=>9506
,p_name=>'Edit Task Definition Action'
,p_alias=>'EDIT-TASK-DEFINITION-ACTION'
,p_step_title=>'Edit Task Definition Action'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_step_template=>wwv_flow_imp.id(689605897838965863)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3378716669607831)
,p_plug_name=>'Set Plugin Settings'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>85
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    -- create the onChange event for the P9506_ACTION_TYPE and',
'    -- also the initialization code for the dynamic attributes',
'    wwv_flow_plugin_dev.add_onload_code (',
'        p_plugin_type         => wwv_flow_plugin.c_plugin_type_process_type,',
'        p_type_page_item_name => ''P9506_ACTION_TYPE'',',
'        p_page_item_prefix    => ''P9506_'',',
'        p_is_wizard           => false',
'    );',
'end;'))
,p_plug_source_type=>'NATIVE_PLSQL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3379050589607834)
,p_plug_name=>'Code'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>45
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(31864742114684957)
,p_plug_name=>' Examples'
,p_parent_plug_id=>wwv_flow_imp.id(3379050589607834)
,p_region_template_options=>'#DEFAULT#:is-collapsed:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(689970285456172024)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Example 1: Send en email. This assumes that an email template named <strong>ORDER</strong> exists, with the placeholders used in the ',
'    <strong>p_placeholders</strong> parameter.',
'</p>',
'<pre>',
'begin',
'    apex_mail.send (',
'        p_template_static_id => ''ORDER'',',
'        p_placeholders       => ''{ "ORDER_NUMBER": '' || :ORDER_NUMBER ||',
'                                  ''"ORDER_DATE":"''   || to_char( :ORDER_DATE, ''YYYY-MM-DD'' ) || ''", ''',
'                                  ''"ORDER_TOTAL":''   || :ORDER_TOTAL || ',
'                                ''}'',',
'        p_to                 => ''some_user@somewhere.com'' );',
'end;',
'</pre>',
'<p>',
'    Example 2: Insert a row into another table. If the :SAL value is NULL, write a message to the task history log.',
'</p>',
'<pre>',
'begin',
'    insert into other_table( empno, ename, sal )',
'                     values( :EMPNO, :ENAME, :SAL );',
'    if :SAL is null then',
'        apex_approval.add_to_history( ''EMPNO '' || :APEX$TASK_PK ||'' has a NULL Salary'');',
'    end if;',
'end;',
'</pre>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(92085503084145721)
,p_plug_name=>'Local Code'
,p_parent_plug_id=>wwv_flow_imp.id(3379050589607834)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(92085647717145722)
,p_plug_name=>'Remote Code'
,p_parent_plug_id=>wwv_flow_imp.id(3379050589607834)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3379750715607841)
,p_plug_name=>'Action'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>5
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_FLOW_TASK_DEF_ACTIONS'
,p_query_where=>'security_group_id = :WORKSPACE_ID'
,p_include_rowid_column=>false
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_plug_source_type=>'NATIVE_FORM'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3703046278987832)
,p_plug_name=>'Error Handling'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>55
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3703135543987833)
,p_plug_name=>'Server Side Condition'
,p_region_name=>'CON'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>65
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3703192515987834)
,p_plug_name=>'Advanced'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>75
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3703959874987841)
,p_plug_name=>'Edit Action'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>15
,p_plug_display_point=>'REGION_POSITION_04'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3896769560103423)
,p_plug_name=>'Edit Action'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>35
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>'The Action''s PL/SQL code will be executed for the row which the task definition query returns. Bind variables can be used to reference column values from the task definition query.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3906264012071450)
,p_plug_name=>'Send Email Settings'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>35
,p_include_in_reg_disp_sel_yn=>'Y'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5674040527817936)
,p_plug_name=>'Placeholders Grid'
,p_parent_plug_id=>wwv_flow_imp.id(3906264012071450)
,p_region_template_options=>'#DEFAULT#:js-dialog-size720x480'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(557449278618308550)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select seq_id,',
'       c001 placeholder,',
'       c002 value',
'  from wwv_flow_collections',
' where collection_name = ''P9506_EMAIL_PLACEHOLDER_COLL''',
'   and :P9506_ACTION_TYPE = ''NATIVE_SEND_EMAIL''',
'   and :P9506_EMAIL_TEMPLATE_ID is not null'))
,p_plug_source_type=>'NATIVE_IG'
,p_ajax_items_to_submit=>'P9506_EMAIL_TEMPLATE_ID,P9506_ACTION_TYPE'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Placeholders Grid'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5674524722817941)
,p_name=>'PLACEHOLDER'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'PLACEHOLDER'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Placeholder'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>40
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>true
,p_max_length=>4000
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5674591100817942)
,p_name=>'VALUE'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'VALUE'
,p_data_type=>'VARCHAR2'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_TEXT_FIELD'
,p_heading=>'Column or Value'
,p_heading_alignment=>'LEFT'
,p_display_sequence=>50
,p_value_alignment=>'LEFT'
,p_attribute_05=>'BOTH'
,p_is_required=>false
,p_max_length=>4000
,p_enable_filter=>false
,p_filter_is_required=>false
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_enable_hide=>false
,p_is_primary_key=>false
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5674729385817943)
,p_name=>'APEX$ROW_ACTION'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_ACTION'
,p_display_sequence=>20
,p_use_as_row_header=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5674793861817944)
,p_name=>'APEX$ROW_SELECTOR'
,p_session_state_data_type=>'VARCHAR2'
,p_item_type=>'NATIVE_ROW_SELECTOR'
,p_display_sequence=>10
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_use_as_row_header=>false
);
wwv_flow_imp_page.create_region_column(
 p_id=>wwv_flow_imp.id(5675186536817948)
,p_name=>'SEQ_ID'
,p_source_type=>'DB_COLUMN'
,p_source_expression=>'SEQ_ID'
,p_data_type=>'NUMBER'
,p_session_state_data_type=>'VARCHAR2'
,p_is_query_only=>false
,p_item_type=>'NATIVE_HIDDEN'
,p_display_sequence=>60
,p_attribute_01=>'Y'
,p_use_as_row_header=>false
,p_enable_sort_group=>false
,p_is_primary_key=>true
,p_duplicate_value=>true
,p_include_in_export=>false
);
wwv_flow_imp_page.create_interactive_grid(
 p_id=>wwv_flow_imp.id(5674125327817937)
,p_internal_uid=>5674125327817937
,p_is_editable=>true
,p_edit_operations=>'i:u:d'
,p_lost_update_check_type=>'VALUES'
,p_add_row_if_empty=>false
,p_submit_checked_rows=>false
,p_lazy_loading=>false
,p_requires_filter=>false
,p_select_first_row=>false
,p_fixed_row_height=>true
,p_pagination_type=>'SCROLL'
,p_show_total_row_count=>false
,p_no_data_found_message=>'No Placeholders defined.'
,p_show_toolbar=>true
,p_toolbar_buttons=>'SAVE'
,p_add_button_label=>'Add Placeholder'
,p_enable_save_public_report=>false
,p_enable_subscriptions=>true
,p_enable_flashback=>false
,p_define_chart_view=>false
,p_enable_download=>false
,p_download_formats=>null
,p_enable_mail_download=>true
,p_fixed_header=>'REGION'
,p_fixed_header_max_height=>380
,p_show_icon_view=>false
,p_show_detail_view=>false
,p_javascript_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'function( options ) {',
'    options.initialSelection = false;',
'    return options;',
'}',
''))
);
wwv_flow_imp_page.create_ig_report(
 p_id=>wwv_flow_imp.id(7074591464739595)
,p_interactive_grid_id=>wwv_flow_imp.id(5674125327817937)
,p_static_id=>'51051'
,p_type=>'PRIMARY'
,p_default_view=>'GRID'
,p_show_row_number=>false
,p_settings_area_expanded=>true
);
wwv_flow_imp_page.create_ig_report_view(
 p_id=>wwv_flow_imp.id(7074866648739596)
,p_report_id=>wwv_flow_imp.id(7074591464739595)
,p_view_type=>'GRID'
,p_srv_exclude_null_values=>false
,p_srv_only_display_columns=>true
,p_edit_mode=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(7080272188759207)
,p_view_id=>wwv_flow_imp.id(7074866648739596)
,p_display_seq=>3
,p_column_id=>wwv_flow_imp.id(5674524722817941)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(7081103022759212)
,p_view_id=>wwv_flow_imp.id(7074866648739596)
,p_display_seq=>4
,p_column_id=>wwv_flow_imp.id(5674591100817942)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(7083942254763162)
,p_view_id=>wwv_flow_imp.id(7074866648739596)
,p_display_seq=>0
,p_column_id=>wwv_flow_imp.id(5674729385817943)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_ig_report_column(
 p_id=>wwv_flow_imp.id(7087469579774615)
,p_view_id=>wwv_flow_imp.id(7074866648739596)
,p_display_seq=>5
,p_column_id=>wwv_flow_imp.id(5675186536817948)
,p_is_visible=>true
,p_is_frozen=>false
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7787044217231649)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>25
,p_plug_display_point=>'REGION_POSITION_04'
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'SESSION')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(350676922521197030)
,p_plug_name=>'Action Settings'
,p_region_name=>'PLUGIN'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_component_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="color:#FFFFFF;display:none;"'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>25
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2001754010697204)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_imp.id(3906264012071450)
,p_button_name=>'SET_PLACEHOLDERS'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--small:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Set Placeholder Values'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_button_cattributes=>'style="margin-top:8px"'
,p_grid_new_row=>'N'
,p_grid_column=>8
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1999534164697202)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(3703959874987841)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:9502:&SESSION.::&DEBUG.:9506:P9502_ID:&P9506_TASK_DEF_ID.'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1999979663697202)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(3703959874987841)
,p_button_name=>'DELETE'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>'P9506_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2000315850697203)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(3703959874987841)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>'P9506_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2000780787697203)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(3703959874987841)
,p_button_name=>'APPLY_CHANGES'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P9506_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(2051489594697286)
,p_branch_name=>'Back to 9502'
,p_branch_action=>'f?p=&APP_ID.:9502:&SESSION.::&DEBUG.:9506:P9502_ID:&P9506_TASK_DEF_ID.&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1505449566422315)
,p_name=>'P9506_BEFORE_EXPIRE_INTERVAL'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_item_source_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_prompt=>'Before Expire Interval'
,p_source=>'BEFORE_EXPIRE_INTERVAL'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>30
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The ISO format or SQL format duration which specifies time interval when an action should be performed before the task expires. ',
'For example, if an email needs to be sent out to the owner of the task one day before the task is due to expire, ',
'the action can have',
'<strong>On Event</strong> set to <strong>Before Expire</strong> and the ',
'<strong>Before Expire Interval</strong>  set as <strong>PT1D</strong>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_show_quick_picks=>'Y'
,p_quick_pick_label_01=>'1 hour before'
,p_quick_pick_value_01=>'PT1H'
,p_quick_pick_label_02=>'12 hours before'
,p_quick_pick_value_02=>'PT12H'
,p_quick_pick_label_03=>'24 hours before'
,p_quick_pick_value_03=>'PT24H'
,p_quick_pick_label_04=>'3 days before'
,p_quick_pick_value_04=>'P3D'
,p_quick_pick_label_05=>'1 week before'
,p_quick_pick_value_05=>'P7D'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1801509700324513)
,p_name=>'P9506_TASK_TYPE'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_display_as=>'NATIVE_HIDDEN'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1924240083455023)
,p_name=>'P9506_TASK_DEF_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_item_source_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_source=>'TASK_DEF_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1924391622455024)
,p_name=>'P9506_OUTCOME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_item_source_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_prompt=>'Outcome'
,p_source=>'OUTCOME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'TASK_OUTCOMES'
,p_lov=>'.'||wwv_flow_imp.id(1744994760068865)||'.'
,p_lov_display_null=>'YES'
,p_display_when=>'P9506_TASK_TYPE'
,p_display_when2=>'APPROVAL'
,p_display_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'The Action can be executed for a Task when it is completed with a specific outcome: Approved or Rejected.'
,p_attribute_01=>'1'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1924412464455025)
,p_name=>'P9506_ON_EVENT'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_item_source_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_prompt=>'On Event'
,p_source=>'ON_EVENT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TASK_ACTION_ON_EVENTS'
,p_lov=>'.'||wwv_flow_imp.id(2058881135907033)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The event for which the action will be executed. Actions can be executed for the following events on the task',
'<dl>',
'    <dt>Claim</dt>',
'    <dd>When the task is claimed by a potential owner. Claiming a task transitions the task from Unassigned to Assigned State.</dd>',
'    <dt>Complete</dt>',
'    <dd>When the task is being completed. In addition, for an Approval Task you can choose if the action occurs only on an outcome of Approved or Rejected.</dd>',
'    <dt>Delegate</dt>',
'    <dd>When the task is being delegated to another potential owner of the task.</dd>',
'    <dt>Update Comment</dt>',
'    <dd>When a comment is added to the task.</dd>',
'    <dt>Update Priority</dt>',
'    <dd>When the priority of the task is being updated.</dd>',
'    <dt>Update Parameter</dt>',
'    <dd>When parameters of the task are being updated.</dd>',
'    <dt>Release</dt>',
'    <dd>When the task is being released. This transitions the task from state Assigned to Unassigned.</dd>',
'    <dt>Cancel</dt>',
'    <dd>When the task is being canceled, thus showing no more interest in the task.</dd>',
'    <dt>Create</dt>',
'    <dd>When the task is being created.</dd>',
'    <dt>Request Information</dt>',
'    <dd>When information by the initiator of the task is being requested.</dd>',
'    <dt>Submit Information</dt>',
'    <dd>When information by the initiator is submitted to the requester.</dd>',
'    <dt>Before Expire</dt>',
'    <dd>Before the task due date is reached and the task is about to expire. An ISO/SQL interval must be specified.</dd>',
'    <dt>Expire</dt>',
'    <dd>When the task due date is reached and the task expires.</dd>',
' </dl>'))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1924844414455029)
,p_name=>'P9506_SUCCESS_MESSAGE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_item_source_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_prompt=>'Success Message'
,p_source=>'SUCCESS_MESSAGE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter a success message to be written to the task history when the processing succeeds.'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1924931533455030)
,p_name=>'P9506_CREATED_BY'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_item_source_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_source=>'CREATED_BY'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1925023049455031)
,p_name=>'P9506_CREATED_ON'
,p_source_data_type=>'DATE'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_item_source_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_source=>'CREATED_ON'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1925168372455032)
,p_name=>'P9506_LAST_UPDATED_BY'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_item_source_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_source=>'LAST_UPDATED_BY'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1925218370455033)
,p_name=>'P9506_LAST_UPDATED_ON'
,p_source_data_type=>'DATE'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_item_source_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_source=>'LAST_UPDATED_ON'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1970350530697164)
,p_name=>'P9506_LOCATION'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3379050589607834)
,p_item_source_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_item_default=>'LOCAL'
,p_prompt=>'Location'
,p_source=>'LOCATION'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_RADIOGROUP'
,p_named_lov=>'EXEC_SQL_LOCATIONS'
,p_lov=>'.'||wwv_flow_imp.id(601110993871808630)||'.'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_css_classes=>'apex-button-group'
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Specify whether your PL/SQL code is to be executed in the <em>Local Database</em> or on a <em>REST Enabled SQL Service</em>.'
,p_attribute_01=>'2'
,p_attribute_02=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1971274879697173)
,p_name=>'P9506_CODE'
,p_source_data_type=>'CLOB'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3379050589607834)
,p_item_source_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_source=>'ACTION_CLOB'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1973488327697178)
,p_name=>'P9506_ACTION_CLOB_LANGUAGE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(92085503084145721)
,p_item_source_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_prompt=>'Language'
,p_source=>'ACTION_CLOB_LANGUAGE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Select a language that is used to evaluate the entered programming code.'
,p_attribute_03=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1974380900697179)
,p_name=>'P9506_LOCAL_CODE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(92085503084145721)
,p_prompt=>'Code'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>10
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Provide the PL/SQL code to be executed. Column values from the task definition action query are available as bind variables, by column name, for example <strong>:EMPNO</strong>, <strong>:ENAME</strong> and so on. Additionally, APEX provides the f'
||'ollowing, generic bind variables:',
'</p>',
'<ul>',
'    <li><strong>APEX$TASK_PK</strong>: If a primary key column has been defined, this bind variable contains the primary key value.</li>',
'    <li><strong>APEX$TASK_ID</strong>: This bind variable contains the id of the task for which this action is defined.</li>',
'    <li><strong>APEX$TASK_SUBJECT</strong>: This bind variable contains the subject of the task for which this action is defined.</li>',
'    <li><strong>APEX$TASK_STATE</strong>: This bind variable contains the current state of the task for which this action is defined.</li>',
'    <li><strong>APEX$TASK_OUTCOME</strong>: This bind variable contains the outcome of the task for which this action is defined.This variable is populated only for tasks in <strong>Completed</strong> state.</li>',
'    <li><strong>APEX$TASK_CREATED_ON</strong>: Contains the timestamp of the task creation, in the <strong>YYYY-MM-DD"T"HH24:MI:SS.FF3TZH:TZM</strong> format.</li>        ',
'    <li><strong>APEX$TASK_INITIATOR</strong>: Contains the user who has initiated the task. This value defaults to the logged-in user if not explicitly specified as part of the <strong>Human Task - Create</strong> Page Process type.</li>        ',
'    <li><strong>APEX$TASK_DUE_ON</strong>: Contains the timestamp of when this task is due , in the <strong>YYYY-MM-DD"T"HH24:MI:SS.FF3TZH:TZM</strong> format.</li>        ',
'    <li><strong>APEX$TASK_OWNER</strong>: Contains the user to whom the task is currently assigned.</li>',
'    <li> The parameters for the task definition are also available as bind variables.</li>',
'</ul>'))
,p_attribute_01=>'PLSQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1976401780697182)
,p_name=>'P9506_REMOTE_SERVER_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(92085647717145722)
,p_item_source_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_prompt=>'REST Enabled SQL Reference'
,p_source=>'REMOTE_SERVER_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'REMOTE_SQL_SERVERS'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name, id ',
'  from wwv_remote_servers',
' where server_type = ''REMOTE_SQL''',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Pick the REST Enabled SQL service to execute the PL/SQL code on.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1977384552697183)
,p_name=>'P9506_REMOTE_PLSQL_CODE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(92085647717145722)
,p_prompt=>'PL/SQL Code (executes at the REST Enabled SQL Service)'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>80
,p_cMaxlength=>32767
,p_cHeight=>10
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'    Provide the PL/SQL code to be executed. Column values from the task definition action query are available as bind variables, by column name, for example <strong>:EMPNO</strong>, <strong>:ENAME</strong> and so on. Additionally, APEX provides the f'
||'ollowing generic bind variables:',
'</p>',
'<ul>',
'    <li><strong>APEX$TASK_PK</strong>: If a primary key column has been defined, this bind variable contains the primary key value.</li>',
'    <li><strong>APEX$TASK_ID</strong>: This bind variable contains the id of the task for which this action is defined.</li>',
'    <li><strong>APEX$TASK_SUBJECT</strong>: This bind variable contains the subject of the task for which this action is defined.</li>',
'    <li><strong>APEX$TASK_STATE</strong>: This bind variable contains the current state of the task for which this action is defined.</li>',
'    <li><strong>APEX$TASK_OUTCOME</strong>: This bind variable contains the outcome of the task for which this action is defined.This variable is populated only for tasks in <strong>Completed</strong> state.</li>',
'    <li><strong>APEX$TASK_CREATED_ON</strong>: Contains the timestamp of the task creation, in the <strong>YYYY-MM-DD"T"HH24:MI:SS.FF3TZH:TZM</strong> format.</li>        ',
'    <li><strong>APEX$TASK_INITIATOR</strong>: Contains the user who has initiated the task. This value defaults to the logged-in user if not explicitly specified as part of the <strong>Human Task - Create</strong> Page Process type.</li>        ',
'    <li><strong>APEX$TASK_DUE_ON</strong>: Contains the timestamp of when this task is due, in the <strong>YYYY-MM-DD"T"HH24:MI:SS.FF3TZH:TZM</strong> format.</li>        ',
'    <li><strong>APEX$TASK_OWNER</strong>: Contains the user to whom the task is currently assigned.</li>',
'    <li> The parameters for the task definition are also available as bind variables.</li>',
'</ul>'))
,p_attribute_01=>'PLSQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'Y'
,p_attribute_05=>'P9506_REMOTE_SERVER_ID'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1979751467697186)
,p_name=>'P9506_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_item_source_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1980572639697186)
,p_name=>'P9506_FLOW_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_item_source_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_source=>'FLOW_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1980938437697186)
,p_name=>'P9506_NAME'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_item_source_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>60
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter a name for the task definition action.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1981887596697187)
,p_name=>'P9506_ACTION_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_item_source_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_item_default=>'NATIVE_PLSQL'
,p_prompt=>'Type'
,p_source=>'ACTION_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select d,',
'       r',
'  from (',
'         select wwv_flow_lang.system_message(''PROCESS.''|| name_with_prefix) as d,',
'               name_with_prefix as r',
'          from wwv_flow_native_plugins',
'         where plugin_type               = ''PROCESS TYPE''',
'           and supported_component_types like ''%APEX_APPL_TASKDEF_ACTIONS%''',
'           and ( ( select wwv_flow_f4000_util.is_cloud',
'                     from sys.dual ) = ''Y''',
'                  or name != ''GEOCODING'' )',
'         union all',
'        select display_name || wwv_flow_lang.system_message(''PLUGIN.DISPLAY_NAME_POSTFIX'') as d,',
'               ''PLUGIN_'' || name     as r',
'          from wwv_flow_plugins',
'         where flow_id                   = to_number(:FB_FLOW_ID)',
'           and security_group_id         = to_number(:WORKSPACE_ID)',
'           and plugin_type               = ''PROCESS TYPE''',
'           and supported_component_types like ''%APEX_APPL_TASKDEF_ACTIONS%''',
'       )',
' order by 1'))
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>'Select the type of action.'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1982769852697188)
,p_name=>'P9506_EXECUTION_SEQUENCE'
,p_source_data_type=>'NUMBER'
,p_is_required=>true
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_item_source_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_item_default=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select nvl(ceil( ( max( execution_sequence ) + 1 ) / 10 ) * 10,10)',
'  from wwv_flow_task_def_actions',
' where task_def_id     = :P9506_TASK_DEF_ID',
'   and flow_id           = :FB_FLOW_ID',
'   and security_group_id = :WORKSPACE_ID'))
,p_item_default_type=>'SQL_QUERY'
,p_prompt=>'Execution Sequence'
,p_source=>'EXECUTION_SEQUENCE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_NUMBER_FIELD'
,p_cSize=>5
,p_cMaxlength=>5
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Specify the execution sequence. Higher numbers will be executed after lower numbers.'
,p_attribute_01=>'0'
,p_attribute_03=>'right'
,p_attribute_04=>'decimal'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1987701146697193)
,p_name=>'P9506_ERROR_MESSAGE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(3703046278987832)
,p_item_source_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_prompt=>'Error Message'
,p_source=>'ERROR_MESSAGE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter an error message to be written to the task history when the processing fails. Use #SQLERRM# as a placeholder for the actual ORA error message.'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1988683520697193)
,p_name=>'P9506_STOP_EXECUTION_ON_ERROR'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(3703046278987832)
,p_item_source_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_item_default=>'Y'
,p_prompt=>'Stop Execution On Error'
,p_source=>'STOP_EXECUTION_ON_ERROR'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enable when processing for the current task should stop on error. Subsequent actions will not be processed in this case and the task will go the Errored state'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1990493273697194)
,p_name=>'P9506_CONDITION_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(3703135543987833)
,p_item_source_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_prompt=>'Condition Type'
,p_source=>'CONDITION_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CONDITION_LIST'
,p_named_lov=>'STANDARD_CONDITION_TYPES'
,p_lov=>'.'||wwv_flow_imp.id(13602414170805697)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select Condition Type -'
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Select a condition type from the list that must be met in order for this action to be executed.',
'',
''))
,p_attribute_01=>'P9506_CONDITION_EXPR1'
,p_attribute_02=>'P9506_CONDITION_EXPR2'
,p_attribute_06=>'ACTION'
,p_attribute_07=>'P9506_CONDITION_LANG'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1991303565697195)
,p_name=>'P9506_CONDITION_LANG'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(3703135543987833)
,p_prompt=>'Language'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_LANGUAGE'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Select a language that is used to evaluate the entered programming code.'
,p_attribute_03=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1992227608697196)
,p_name=>'P9506_CONDITION_EXPR1'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(3703135543987833)
,p_item_source_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_prompt=>'Expression 1'
,p_source=>'CONDITION_EXPR1'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>6
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'This attribute allows you to conditionally control the circumstances under which this action will be executed.  Enter values in this attribute based on the specific condition type selected.  The action will execute only if the specified condition is '
||'met.'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1993557065697197)
,p_name=>'P9506_CONDITION_EXPR2'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(3703135543987833)
,p_item_source_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_prompt=>'Expression 2'
,p_source=>'CONDITION_EXPR2'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>96
,p_cMaxlength=>4000
,p_cHeight=>6
,p_tag_attributes=>'onchange="htmldb_item_change(this)"'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Some condition types require two expressions for comparison.  Enter the second expression or item here.'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1996826604697199)
,p_name=>'P9506_BUILD_OPTION_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(3703192515987834)
,p_item_source_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_prompt=>'Build Option'
,p_source=>'BUILD_OPTION_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'LIST_PATCHES'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select wwv_flow_escape.html(patch_name) pn, id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' union all',
'select ''{''||wwv_flow_lang.system_message(''NOT_W_ARGUMENT'', wwv_flow_escape.html(patch_name))||',
'''} '' pn,0-id id',
'  from wwv_flow_patches',
' where flow_id = :FB_FLOW_ID',
'   and security_group_id = :flow_security_group_id',
' order by pn'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Build Option - '
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Select a build option for this action.</p>',
'<p>Build options are predefined settings that determine whether or not components within an application are enabled.</p>'))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(1997760911697200)
,p_name=>'P9506_ACTION_COMMENT'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(3703192515987834)
,p_item_source_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_prompt=>'Comments'
,p_source=>'ACTION_COMMENT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>60
,p_cMaxlength=>4000
,p_cHeight=>6
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter any developer comments or notes here. These comments only display within App Builder and never display when running the application.'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
,p_item_comment=>'Enter any developer comments or notes here. These comments only display within App Builder and never display when running the application.'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2002148161697204)
,p_name=>'P9506_EMAIL_FROM'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3906264012071450)
,p_item_default=>'''&''||''APP_EMAIL.'''
,p_item_default_type=>'EXPRESSION'
,p_item_default_language=>'PLSQL'
,p_prompt=>'From'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>65
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Enter the email address to display as the sender of the email. This email address must be a valid address. Otherwise, the message will not be sent. Use substitution syntax if you want to use a dynamic value.',
'</p>',
'<ul>',
'<li><code>noreply@test.com</code></li>',
'<li><code>Do not reply &lt;noreply@test.com&gt;</code></li>',
'<li><code>&amp;P6_FROM.</code></li>',
'</ul>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2003087041697205)
,p_name=>'P9506_EMAIL_TO'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3906264012071450)
,p_prompt=>'To'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>65
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Enter the email recipients by specifying one or more email addresses. For multiple email addresses, use a comma-separated list. Use substitution syntax if you want to use a dynamic value.</p>',
'<ul>',
'<li><code>john.doe@test.com, jane.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;, Jane Doe &lt;jane.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_TO.</code></li>',
'</ul>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2003994282697205)
,p_name=>'P9506_EMAIL_CC'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3906264012071450)
,p_prompt=>'Cc'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>65
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Enter the carbon copy email recipients by specifying one or more email addresses. For multiple email addresses, use a comma-separated list. Use substitution syntax if you want to use a dynamic value.',
'</p>',
'<ul>',
'<li><code>john.doe@test.com, jane.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;, Jane Doe &lt;jane.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_CC.</code></li>',
'</ul>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2004894118697206)
,p_name=>'P9506_EMAIL_BCC'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(3906264012071450)
,p_prompt=>'Bcc'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>65
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Enter the blind carbon copy email recipients by specifying one or more email addresses. For multiple email addresses, use a comma-separated list. Use substitution syntax if you want to use a dynamic value.',
'</p>',
'<ul>',
'<li><code>john.doe@test.com, jane.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;, Jane Doe &lt;jane.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_BCC.</code></li>',
'</ul>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2005768804697206)
,p_name=>'P9506_EMAIL_REPLYTO'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(3906264012071450)
,p_prompt=>'Reply To'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>65
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'Enter the email address replies should be sent to. If not specified the e-mail address entered in <strong>From</strong> will be used. Use substitution syntax if you want to use a dynamic value.</p>',
'<ul>',
'<li><code>john.doe@test.com</code></li>',
'<li><code>John Doe &lt;john.doe@test.com&gt;</code></li>',
'<li><code>&amp;P6_REPLY_TO.</code></li>',
'</ul>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2006628434697207)
,p_name=>'P9506_EMAIL_TEMPLATE_ID'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(3906264012071450)
,p_prompt=>'Email Template'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select name,',
'       id',
'  from wwv_flow_email_templates',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and flow_id           = :FB_FLOW_ID',
' order by name'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- No Template -'
,p_cHeight=>1
,p_colspan=>7
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_lov_display_extra=>'YES'
,p_help_text=>'Choose an email template. Use the <strong>Set Placeholder Values</strong> button to assign column or static values to the Email template placeholders. To assign a column value, use substitution syntax, for example <code>&amp;COLUMN_NAME.<code>'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2007550320697207)
,p_name=>'P9506_EMAIL_LANG_OVERRIDE'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(3906264012071450)
,p_prompt=>'Language Override'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>65
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>If a language code is specified, the process will look up the template from an application translation for this language. If no translation exists, the process uses the primary language of the application. Substitution syntax is supported.</p>',
'<p>Language code hierarchy is supported. If a value of "fr-ca" (French - Canada) is specified, but only a translation for "fr" (french) exists, this translation is being used.</p>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2008452678697207)
,p_name=>'P9506_EMAIL_PLACEHOLDERS'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(3906264012071450)
,p_display_as=>'NATIVE_HIDDEN'
,p_help_text=>'Template placeholder names along with the values, to be substituted. Internally stored as a JSON string.'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2009353559697208)
,p_name=>'P9506_EMAIL_SUBJECT'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(3906264012071450)
,p_prompt=>'Subject'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>120
,p_cMaxlength=>4000
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'Enter the subject of the e-mail. Use substitution syntax, such as <code>&amp;P6_PRODUCT_NAME.</code>, if you want to include a dynamic value.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2010260004697208)
,p_name=>'P9506_EMAIL_BODY_TEXT'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(3906264012071450)
,p_prompt=>'Body Plain Text'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>65
,p_cMaxlength=>4000
,p_cHeight=>8
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the text of the e-mail. The plain text version is used if the recipient&#39;s e-mail client does not support rich text display. Use substitution syntax, such as <code>&amp;P6_PRODUCT_NAME.</code>, if you want to include dynamic content in yo'
||'ur text.</p>',
'<p><em>Note: The SMTP/MIME specification dictates that no single line shall exceed 1000 characters. To comply with this restriction, you must add a carriage return or line feed characters to break your text into chunks of 1000 characters or less. Fai'
||'ling to do so will result in erroneous email messages, including partial messages or messages with extraneous exclamation points.</em></p>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2011138008697209)
,p_name=>'P9506_EMAIL_BODY_HTML'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(3906264012071450)
,p_prompt=>'Body HTML'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>30
,p_cMaxlength=>4000
,p_cHeight=>8
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter text that yields a multi-part HTML message, including both plain text and HTML content. The settings and capabilities of the recipient&#39;s email client will determine what displays. Although most modern email clients can read an HTML forma'
||'tted email, remember that some users disable this functionality to address security issues. Use substitution syntax, such as <code>&amp;P6_PRODUCT_NAME.</code>, if you want to include dynamic content in the text.</p>',
'<p>When referencing images using the &lt;img /&gt; tag, remember that the images must be accessible to the recipient&#39;s email client in order for them to see the image. For example, suppose you reference an image on your network called hello.gif a'
||'s follows:</p>',
'<pre>',
'&lt;img src=&quot;http://example.com/hello.gif&quot; alt=&quot;Hello&quot; /&gt;',
'</pre>',
'<p>In this example, the image is not attached to the email, but is referenced by the email. For the recipient to see it, they must be able to access the image using a Web browser. If the image is inside a firewall and the recipient is outside of the '
||'firewall, the image will not display. For this reason, avoid using images. If you must include images, be sure to include the ALT attribute to provide a textual description in the event the image is not accessible.</p>',
'<p><em>Note: The SMTP/MIME specification dictates that no single line shall exceed 1000 characters. To comply with this restriction, you must add a carriage return or line feed characters to break your text into chunks of 1000 characters or less. Fai'
||'ling to do so will result in erroneous email messages, including partial messages or messages with extraneous exclamation points.</em></p>'))
,p_attribute_01=>'HTMLMIXED'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'Y'
,p_attribute_04=>'N'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2012090337697209)
,p_name=>'P9506_EMAIL_ATTACH_QUERY'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(3906264012071450)
,p_prompt=>'Attachment SQL'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>65
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter a SQL statement which returns one or more BLOBs that are attached as files to the e-mail.</p>',
'<p>If the content_id column contains a null value then the associated files will be regular attachments. Files such as documents or zip archives are generally attached in this way.</p>',
'<p>If the value of the content_id is non-null then the associated file will be marked as being attached inline. The value of the content_id column will be used as the CID (Content ID) of the attachment. This CID value can be used in the HTML code of '
||'the email in order to embed images directly within the email content. Note that some email clients may not automatically display inline attachments. Also note that email standards dictate various requirements for the format of content identifiers. Or'
||'acle APEX does not enforce compliance with these standards.</p>',
'<p></p>',
'<p>The SQL statement must be in the following format:</p>',
'<pre>',
'select blob_column,',
'       file_name,',
'       mime_type,',
'       content_id',
'  from table',
'</pre>',
'<p>The columns mime_type and content_id are optional. If content_id is present then the file will be attached inline and the value of content_id will be used for the attachment''s CID.</p>',
'<p>If the content_id column contains the value ''my_inline_content'' then that image may be embedded within the email using the following HTML:</p>',
'<p>',
'<pre>',
'&lt;div&gt;',
'&nbsp;&nbsp;&lt;h1&gt;Some Embedded Content&lt;/h1&gt;',
'&nbsp;&nbsp;&lt;p&gt;',
'&nbsp;&nbsp;&nbsp;&nbsp;&lt;img src="cid:my_inline_content" alt="Inline Image" &gt;',
'&nbsp;&nbsp;&lt;/p&gt;',
'&lt;/div&gt;',
'</pre>',
'</p>'))
,p_attribute_01=>'SQL'
,p_attribute_02=>'VARCHAR2'
,p_attribute_03=>'N'
,p_attribute_04=>'N'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2016963321697230)
,p_name=>'P9506_ATTRIBUTE_01'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>70
,p_item_plug_id=>wwv_flow_imp.id(350676922521197030)
,p_item_source_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_source=>'ATTRIBUTE_01'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2017394426697231)
,p_name=>'P9506_ATTRIBUTE_02'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>80
,p_item_plug_id=>wwv_flow_imp.id(350676922521197030)
,p_item_source_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_source=>'ATTRIBUTE_02'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2017780029697232)
,p_name=>'P9506_ATTRIBUTE_03'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>90
,p_item_plug_id=>wwv_flow_imp.id(350676922521197030)
,p_item_source_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_source=>'ATTRIBUTE_03'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2018161566697232)
,p_name=>'P9506_ATTRIBUTE_04'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>100
,p_item_plug_id=>wwv_flow_imp.id(350676922521197030)
,p_item_source_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_source=>'ATTRIBUTE_04'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2018505596697232)
,p_name=>'P9506_ATTRIBUTE_05'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>110
,p_item_plug_id=>wwv_flow_imp.id(350676922521197030)
,p_item_source_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_source=>'ATTRIBUTE_05'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2018990867697232)
,p_name=>'P9506_ATTRIBUTE_06'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>120
,p_item_plug_id=>wwv_flow_imp.id(350676922521197030)
,p_item_source_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_source=>'ATTRIBUTE_06'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2019378767697232)
,p_name=>'P9506_ATTRIBUTE_07'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>130
,p_item_plug_id=>wwv_flow_imp.id(350676922521197030)
,p_item_source_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_source=>'ATTRIBUTE_07'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2019786475697233)
,p_name=>'P9506_ATTRIBUTE_08'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(350676922521197030)
,p_item_source_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_source=>'ATTRIBUTE_08'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2020190516697233)
,p_name=>'P9506_ATTRIBUTE_09'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(350676922521197030)
,p_item_source_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_source=>'ATTRIBUTE_09'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2020573442697233)
,p_name=>'P9506_ATTRIBUTE_10'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>160
,p_item_plug_id=>wwv_flow_imp.id(350676922521197030)
,p_item_source_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_source=>'ATTRIBUTE_10'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2020987038697233)
,p_name=>'P9506_ATTRIBUTE_11'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>170
,p_item_plug_id=>wwv_flow_imp.id(350676922521197030)
,p_item_source_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_source=>'ATTRIBUTE_11'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2021343378697233)
,p_name=>'P9506_ATTRIBUTE_12'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>180
,p_item_plug_id=>wwv_flow_imp.id(350676922521197030)
,p_item_source_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_source=>'ATTRIBUTE_12'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2021776879697234)
,p_name=>'P9506_ATTRIBUTE_13'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>190
,p_item_plug_id=>wwv_flow_imp.id(350676922521197030)
,p_item_source_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_source=>'ATTRIBUTE_13'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2022116457697234)
,p_name=>'P9506_ATTRIBUTE_14'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>200
,p_item_plug_id=>wwv_flow_imp.id(350676922521197030)
,p_item_source_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_source=>'ATTRIBUTE_14'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2022559176697234)
,p_name=>'P9506_ATTRIBUTE_15'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>210
,p_item_plug_id=>wwv_flow_imp.id(350676922521197030)
,p_item_source_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_source=>'ATTRIBUTE_15'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.PLUGIN_DYNAMIC_ATTRIBUTE'
,p_field_template=>wwv_flow_imp.id(566053095724681231)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2176404482753414)
,p_name=>'P9506_LOG_MESSAGE_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>140
,p_item_plug_id=>wwv_flow_imp.id(3703046278987832)
,p_item_source_plug_id=>wwv_flow_imp.id(3379750715607841)
,p_prompt=>'Log Messages When'
,p_source=>'LOG_MESSAGE_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'TASK_ACTION_LOG_TYPE'
,p_lov=>'.'||wwv_flow_imp.id(1446742001365910)||'.'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'NO'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Specify the Actions that will be logged in the task history. ',
'</p>',
' <ul>',
'    <li><strong>None</strong>: No Action is logged in the task history.</li>',
'    <li><strong>Success</strong>: Only Successful Actions are logged in the task history.</li>',
'    <li><strong>Failure</strong>: Only Failed Actions are logged in the task history.</li>',
'    <li><strong>All</strong>: All Actions are logged in the task history.</li>',
' </ul>',
''))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2028629560697261)
,p_computation_sequence=>10
,p_computation_item=>'P9506_REMOTE_SERVER_ID'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_compute_when=>'P9506_LOCATION'
,p_compute_when_text=>'LOCAL'
,p_compute_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2027820276697261)
,p_computation_sequence=>10
,p_computation_item=>'P9506_LOCATION'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'LOCAL'
,p_compute_when=>'P9506_LOCATION'
,p_compute_when_type=>'ITEM_IS_NULL'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(2028286244697261)
,p_computation_sequence=>20
,p_computation_item=>'P9506_FLOW_ID'
,p_computation_point=>'BEFORE_BOX_BODY'
,p_computation_type=>'ITEM_VALUE'
,p_computation=>'FB_FLOW_ID'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2029098433697261)
,p_validation_name=>'Validate Remote PL/SQL Code'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    return wwv_flow_exec_dev.check_code (',
'               p_location         => ''REMOTE'',',
'               p_remote_server_id => :P9506_REMOTE_SERVER_ID,',
'               p_code             => :P9506_CODE,',
'               p_language         => wwv_flow_code_exec.c_plsql );',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':REQUEST in (''APPLY_CHANGES'',''CREATE'') and :P9506_ACTION_TYPE = wwv_flow_process_native.c_plsql and :P9506_LOCATION = ''REMOTE'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(1977384552697183)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2029418889697262)
,p_validation_name=>'Validate Local Code'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    return wwv_flow_code_exec_dev.check_code (',
'               p_code     => :P9506_CODE,',
'               p_language => :P9506_ACTION_CLOB_LANGUAGE );',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_ERR_TEXT'
,p_validation_condition=>':REQUEST in (''APPLY_CHANGES'',''CREATE'') and :P9506_ACTION_TYPE = wwv_flow_process_native.c_plsql and :P9506_LOCATION = ''LOCAL'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(1974380900697179)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2029882675697262)
,p_validation_name=>'Code is required'
,p_validation_sequence=>30
,p_validation=>'P9506_CODE'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'PL/SQL Code is required'
,p_validation_condition=>':REQUEST in (''CREATE'', ''APPLY_CHANGES'' ) and :P9506_ACTION_TYPE = wwv_flow_process_native.c_plsql'
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2030236368697262)
,p_validation_name=>'Email Subject is required'
,p_validation_sequence=>40
,p_validation=>'P9506_EMAIL_SUBJECT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST              in (''APPLY_CHANGES'',''CREATE'') and ',
':P9506_ACTION_TYPE     = ''NATIVE_SEND_EMAIL''        and',
':P9506_EMAIL_TEMPLATE_ID is null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(2009353559697208)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2031410727697263)
,p_validation_name=>'Email From is required'
,p_validation_sequence=>50
,p_validation=>'P9506_EMAIL_FROM'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST              in (''APPLY_CHANGES'',''CREATE'') and ',
':P9506_ACTION_TYPE     = ''NATIVE_SEND_EMAIL'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(2002148161697204)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2031861453697264)
,p_validation_name=>'Email To is required'
,p_validation_sequence=>60
,p_validation=>'P9506_EMAIL_TO'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST              in (''APPLY_CHANGES'',''CREATE'') and ',
':P9506_ACTION_TYPE     = ''NATIVE_SEND_EMAIL'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(2003087041697205)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2030663960697263)
,p_validation_name=>'Email Body Plain Text is required'
,p_validation_sequence=>70
,p_validation=>'P9506_EMAIL_BODY_TEXT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST              in (''APPLY_CHANGES'',''CREATE'') and ',
':P9506_ACTION_TYPE     = ''NATIVE_SEND_EMAIL''        and',
':P9506_EMAIL_TEMPLATE_ID is null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(2010260004697208)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2031052830697263)
,p_validation_name=>'Email Placeholders are valid JSON'
,p_validation_sequence=>80
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_values wwv_flow_json.t_values;',
'begin',
'    wwv_flow_json.parse(',
'        p_values => l_values,',
'        p_source => coalesce( :P9506_EMAIL_PLACEHOLDERS, ''{}'' ) );',
'',
'    return true;',
'exception',
'    when others then',
'        return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'#LABEL# is not a valid JSON object.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
':REQUEST              in (''APPLY_CHANGES'',''CREATE'') and ',
':P9506_ACTION_TYPE     = ''NATIVE_SEND_EMAIL''        and',
':P9506_EMAIL_TEMPLATE_ID is not null'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(2008452678697207)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1497633323762208)
,p_validation_name=>'Before Expiration Interval is valid'
,p_validation_sequence=>90
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_due_on timestamp := null;',
'begin',
'    if :P9506_BEFORE_EXPIRE_INTERVAL is null then',
'        if :P9506_ON_EVENT = ''BEFORE_EXPIRE'' then    ',
'            return false;',
'        end if;',
'        return true;',
'    else',
'        -- check for negative intervals',
'        if :P9506_BEFORE_EXPIRE_INTERVAL like ''-%'' then     ',
'            return false;',
'        end if;',
'        select systimestamp + to_dsinterval(:P9506_BEFORE_EXPIRE_INTERVAL) ',
'          into l_due_on ',
'          from sys.dual;',
'    end if; ',
'    return true;',
'exception',
'    when others then',
'    return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'The <strong>Before Expire Interval</strong> must be a positive ISO or SQL interval expression if the <strong>On Event</strong> is <strong>Before Expire</strong>'
,p_associated_item=>wwv_flow_imp.id(1505449566422315)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3600123052108601)
,p_validation_name=>'Check for Expire actions'
,p_validation_sequence=>100
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_is_valid          boolean;',
'    l_due_on_type       varchar2(30);',
'    l_expiration_policy varchar2(30);',
'begin',
'    select due_on_type ,expiration_policy',
'      into l_due_on_type,l_expiration_policy',
'      from wwv_flow_task_defs',
'     where id = :P9506_TASK_DEF_ID',
'       and security_group_id = :WORKSPACE_ID;',
'',
'     if (l_due_on_type is null or l_expiration_policy = ''NONE'')',
'        and :P9506_ON_EVENT in (''BEFORE_EXPIRE'', ''EXPIRE'') then',
'        return false;',
'     end if;',
'',
'     return true;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'The task definition must define a <strong>Due On Type</strong> and an <strong>Expiration Policy</strong> to use <strong>Before Expire</strong> and <strong>Expire</strong> Events.'
,p_associated_item=>wwv_flow_imp.id(1924412464455025)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2200602432294801)
,p_validation_name=>'Action Name is Unique'
,p_validation_sequence=>110
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_task_def_actions',
' where security_group_id = :WORKSPACE_ID',
'   and flow_id           = :P9506_FLOW_ID',
'   and task_def_id       = :P9506_TASK_DEF_ID',
'   and name              = :P9506_NAME',
'   and id               != :P9506_ID'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'#LABEL# is already used by another action in this task definition.'
,p_associated_item=>wwv_flow_imp.id(1980938437697186)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2034169585697265)
,p_name=>'onChange P9506_ACTION_TYPE = NATIVE_PLSQL'
,p_event_sequence=>10
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P9506_ACTION_TYPE'
,p_condition_element=>'P9506_ACTION_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NATIVE_PLSQL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2034607607697268)
,p_event_id=>wwv_flow_imp.id(2034169585697265)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show - Region - Code'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3379050589607834)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2262878833557324)
,p_event_id=>wwv_flow_imp.id(2034169585697265)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Hide - Region - Action Settings'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(350676922521197030)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(17203947367083649)
,p_event_id=>wwv_flow_imp.id(2034169585697265)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_name=>'Hide - Region - Send Email Settings'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3906264012071450)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2035569895697270)
,p_name=>'REST Enabled SQL Reference'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P9506_LOCATION'
,p_condition_element=>'P9506_LOCATION'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'REMOTE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2036062196697270)
,p_event_id=>wwv_flow_imp.id(2035569895697270)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(92085503084145721)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2036580948697271)
,p_event_id=>wwv_flow_imp.id(2035569895697270)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(92085647717145722)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2037011812697271)
,p_event_id=>wwv_flow_imp.id(2035569895697270)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(92085647717145722)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2037514588697272)
,p_event_id=>wwv_flow_imp.id(2035569895697270)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(92085503084145721)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2037910427697272)
,p_name=>'Confirm'
,p_event_sequence=>30
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(1999979663697202)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2038431478697273)
,p_event_id=>wwv_flow_imp.id(2037910427697272)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CONFIRM'
,p_attribute_01=>'Do you really want to delete this action?'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2038998929697273)
,p_event_id=>wwv_flow_imp.id(2037910427697272)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SUBMIT_PAGE'
,p_attribute_01=>'DELETE'
,p_attribute_02=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2039352001697273)
,p_name=>'Remote Server Chosen'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P9506_REMOTE_SERVER_ID'
,p_condition_element=>'P9506_REMOTE_SERVER_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2039811472697273)
,p_event_id=>wwv_flow_imp.id(2039352001697273)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9506_REMOTE_PLSQL_CODE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2040334058697273)
,p_event_id=>wwv_flow_imp.id(2039352001697273)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9506_REMOTE_PLSQL_CODE'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2040728206697273)
,p_name=>'onChange P9506_ACTION_TYPE = NATIVE_SEND_EMAIL'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P9506_ACTION_TYPE'
,p_condition_element=>'P9506_ACTION_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'NATIVE_SEND_EMAIL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(220664558913624502)
,p_event_id=>wwv_flow_imp.id(2040728206697273)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show - Region - Send Email Settings'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3906264012071450)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(17204014512083650)
,p_event_id=>wwv_flow_imp.id(2040728206697273)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Hide - Region - Code'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3379050589607834)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(220664498517624501)
,p_event_id=>wwv_flow_imp.id(2040728206697273)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Hide - Region - Action Settings'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(350676922521197030)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(220664671060624503)
,p_name=>'onChange P9506_ACTION_TYPE not in NATIVE_PLSQL,NATIVE_SEND_EMAIL'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P9506_ACTION_TYPE'
,p_condition_element=>'P9506_ACTION_TYPE'
,p_triggering_condition_type=>'NOT_IN_LIST'
,p_triggering_expression=>'NATIVE_PLSQL,NATIVE_SEND_EMAIL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(220664926481624506)
,p_event_id=>wwv_flow_imp.id(220664671060624503)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show - Region - Action Settings'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(350676922521197030)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(220664736260624504)
,p_event_id=>wwv_flow_imp.id(220664671060624503)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Hide - Region - Send Email Settings'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3906264012071450)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(220664812961624505)
,p_event_id=>wwv_flow_imp.id(220664671060624503)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Hide - Region - Code'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3379050589607834)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2043128055697276)
,p_name=>'Email Template chosen'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P9506_EMAIL_TEMPLATE_ID'
,p_condition_element=>'P9506_EMAIL_TEMPLATE_ID'
,p_triggering_condition_type=>'NOT_NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2043674928697277)
,p_event_id=>wwv_flow_imp.id(2043128055697276)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9506_EMAIL_PLACEHOLDERS,P9506_EMAIL_LANG_OVERRIDE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2044111385697277)
,p_event_id=>wwv_flow_imp.id(2043128055697276)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9506_EMAIL_PLACEHOLDERS,P9506_EMAIL_LANG_OVERRIDE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2044674074697279)
,p_event_id=>wwv_flow_imp.id(2043128055697276)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(2001754010697204)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2045116410697280)
,p_event_id=>wwv_flow_imp.id(2043128055697276)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'BUTTON'
,p_affected_button_id=>wwv_flow_imp.id(2001754010697204)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2045655812697280)
,p_event_id=>wwv_flow_imp.id(2043128055697276)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9506_EMAIL_SUBJECT,P9506_EMAIL_BODY_TEXT,P9506_EMAIL_BODY_HTML'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2046160529697280)
,p_event_id=>wwv_flow_imp.id(2043128055697276)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9506_EMAIL_SUBJECT,P9506_EMAIL_BODY_TEXT,P9506_EMAIL_BODY_HTML'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2046621539697280)
,p_event_id=>wwv_flow_imp.id(2043128055697276)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9506_EMAIL_PLACEHOLDERS,P9506_EMAIL_LANG_OVERRIDE'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2047157805697281)
,p_event_id=>wwv_flow_imp.id(2043128055697276)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_JAVASCRIPT_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'$s("P9506_EMAIL_SUBJECT", "");',
'$s("P9506_EMAIL_BODY_TEXT", "");',
'$s("P9506_EMAIL_BODY_HTML","");'))
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2047692718697281)
,p_event_id=>wwv_flow_imp.id(2043128055697276)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9506_EMAIL_PLACEHOLDERS'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'return wwv_flow_template_dev.add_new_placeholders(',
'           p_application_id    => :FB_FLOW_ID,',
'           p_email_template_id => :P9506_EMAIL_TEMPLATE_ID,',
'           p_placeholder_json  => :P9506_EMAIL_PLACEHOLDERS );'))
,p_attribute_07=>'P9506_EMAIL_TEMPLATE_ID,P9506_EMAIL_PLACEHOLDERS'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2048029352697281)
,p_name=>'Open Placeholders dialog'
,p_event_sequence=>80
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(2001754010697204)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2048571214697282)
,p_event_id=>wwv_flow_imp.id(2048029352697281)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'',
'wwv_flow_template_dev.placeholders_to_collection(',
'    p_placeholder_json => :P9506_EMAIL_PLACEHOLDERS,',
'    p_collection_name  => ''P9506_EMAIL_PLACEHOLDER_COLL'' );',
''))
,p_attribute_02=>'P9506_EMAIL_PLACEHOLDERS,P9506_EMAIL_TEMPLATE_ID'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2049068258697283)
,p_event_id=>wwv_flow_imp.id(2048029352697281)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_REFRESH'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(5674040527817936)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2049572992697283)
,p_event_id=>wwv_flow_imp.id(2048029352697281)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(5674040527817936)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2049917076697283)
,p_name=>'Save Placeholders: Copy Placeholders from to Item (JSON)'
,p_event_sequence=>90
,p_triggering_element_type=>'REGION'
,p_triggering_region_id=>wwv_flow_imp.id(5674040527817936)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'NATIVE_IG|REGION TYPE|interactivegridsave'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2050468868697284)
,p_event_id=>wwv_flow_imp.id(2049917076697283)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P9506_EMAIL_PLACEHOLDERS := wwv_flow_template_dev.placeholders_from_collection(',
'                                 p_collection_name => ''P9506_EMAIL_PLACEHOLDER_COLL'' );',
''))
,p_attribute_03=>'P9506_EMAIL_PLACEHOLDERS'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2050922097697285)
,p_event_id=>wwv_flow_imp.id(2049917076697283)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLOSE_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(5674040527817936)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2517967749988322)
,p_name=>'Show Outcome'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P9506_ON_EVENT'
,p_condition_element=>'P9506_ON_EVENT'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'COMPLETE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2518007785988323)
,p_event_id=>wwv_flow_imp.id(2517967749988322)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9506_OUTCOME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2518183239988324)
,p_event_id=>wwv_flow_imp.id(2517967749988322)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9506_OUTCOME'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1505525982422316)
,p_name=>'Show Before Expiration Internval'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P9506_ON_EVENT'
,p_condition_element=>'P9506_ON_EVENT'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'BEFORE_EXPIRE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1505672796422317)
,p_event_id=>wwv_flow_imp.id(1505525982422316)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9506_BEFORE_EXPIRE_INTERVAL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1505749911422318)
,p_event_id=>wwv_flow_imp.id(1505525982422316)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9506_BEFORE_EXPIRE_INTERVAL'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1505867610422319)
,p_event_id=>wwv_flow_imp.id(1505525982422316)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9506_BEFORE_EXPIRE_INTERVAL'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1987078167697192)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(3379750715607841)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process form Action'
,p_attribute_01=>'REGION_SOURCE'
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_attribute_08=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_success_message=>'Action processed.'
,p_internal_uid=>1987078167697192
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2032903881697264)
,p_process_sequence=>10
,p_process_point=>'BEFORE_BOX_BODY'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Load "Load and Remote" Code'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'if :P9506_LOCATION = wwv_flow_exec_api.c_location_local_db then',
'    :P9506_LOCAL_CODE := :P9506_CODE;',
'else',
'    :P9506_REMOTE_PLSQL_CODE := :P9506_CODE;',
'end if;',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2032903881697264
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2033727585697265)
,p_process_sequence=>20
,p_process_point=>'BEFORE_BOX_BODY'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Send Email Attributes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'  :P9506_EMAIL_FROM            := :P9506_ATTRIBUTE_01;',
'  :P9506_EMAIL_TO              := :P9506_ATTRIBUTE_02;',
'  :P9506_EMAIL_CC              := :P9506_ATTRIBUTE_03;',
'  :P9506_EMAIL_BCC             := :P9506_ATTRIBUTE_04;',
'  :P9506_EMAIL_REPLYTO         := :P9506_ATTRIBUTE_05;',
'  :P9506_EMAIL_SUBJECT         := :P9506_ATTRIBUTE_06;',
'  :P9506_EMAIL_BODY_TEXT       := :P9506_ATTRIBUTE_07;',
'  :P9506_EMAIL_BODY_HTML       := :P9506_ATTRIBUTE_08;',
'  :P9506_EMAIL_ATTACH_QUERY    := :P9506_ATTRIBUTE_09;',
'  :P9506_EMAIL_TEMPLATE_ID     := :P9506_ATTRIBUTE_11;',
'  :P9506_EMAIL_PLACEHOLDERS    := :P9506_ATTRIBUTE_12;',
'  :P9506_EMAIL_LANG_OVERRIDE   := :P9506_ATTRIBUTE_13;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'P9506_ACTION_TYPE'
,p_process_when_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_process_when2=>'NATIVE_SEND_EMAIL'
,p_internal_uid=>2033727585697265
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1986613822697191)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(3379750715607841)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form WWV_FLOW_TASK_DEF_ACTIONS'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>1986613822697191
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2033305996697264)
,p_process_sequence=>20
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Process Send Email Attributes'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    :P9506_ATTRIBUTE_01 := :P9506_EMAIL_FROM;',
'    :P9506_ATTRIBUTE_02 := :P9506_EMAIL_TO;',
'    :P9506_ATTRIBUTE_03 := :P9506_EMAIL_CC;',
'    :P9506_ATTRIBUTE_04 := :P9506_EMAIL_BCC;',
'    :P9506_ATTRIBUTE_05 := :P9506_EMAIL_REPLYTO;',
'    :P9506_ATTRIBUTE_06 := :P9506_EMAIL_SUBJECT;',
'    :P9506_ATTRIBUTE_07 := :P9506_EMAIL_BODY_TEXT;',
'    :P9506_ATTRIBUTE_08 := :P9506_EMAIL_BODY_HTML;',
'    :P9506_ATTRIBUTE_09 := :P9506_EMAIL_ATTACH_QUERY;',
'    :P9506_ATTRIBUTE_10 := ''N'';',
'    :P9506_ATTRIBUTE_11 := :P9506_EMAIL_TEMPLATE_ID;',
'    :P9506_ATTRIBUTE_12 := :P9506_EMAIL_PLACEHOLDERS;',
'    :P9506_ATTRIBUTE_13 := :P9506_EMAIL_LANG_OVERRIDE;',
'end;',
''))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':REQUEST in (''APPLY_CHANGES'',''CREATE'') and :P9506_ACTION_TYPE = ''NATIVE_SEND_EMAIL'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>2033305996697264
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2032509485697264)
,p_process_sequence=>30
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Execute Code Items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    if :P9506_ACTION_TYPE = wwv_flow_process_native.c_plsql then',
'        if :P9506_LOCATION = wwv_flow_exec_api.c_location_local_db then',
'            :P9506_CODE := :P9506_LOCAL_CODE;',
'        else',
'            :P9506_CODE                 := :P9506_REMOTE_PLSQL_CODE;',
'            :P9506_ACTION_CLOB_LANGUAGE := null;',
'        end if;',
'    else',
'        :P9506_CODE                 := null;',
'        :P9506_ACTION_CLOB_LANGUAGE := null;',
'    end if;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_internal_uid=>2032509485697264
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2015993230697228)
,p_process_sequence=>40
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_region_id=>wwv_flow_imp.id(5674040527817936)
,p_process_type=>'NATIVE_IG_DML'
,p_process_name=>'Copy Placeholders Grid to Collection'
,p_attribute_01=>'PLSQL_CODE'
,p_attribute_04=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    case :APEX$ROW_STATUS',
'    when ''C'' then',
'        :SEQ_ID := wwv_flow_collection.add_member( p_collection_name => ''P9506_EMAIL_PLACEHOLDER_COLL'', p_c001 => :PLACEHOLDER, p_c002 => :VALUE );',
'    when ''U'' then',
'        wwv_flow_collection.update_member( p_collection_name => ''P9506_EMAIL_PLACEHOLDER_COLL'', p_seq => :SEQ_ID, p_c001 => :PLACEHOLDER, p_c002 => :VALUE );',
'    when ''D'' then',
'        wwv_flow_collection.delete_member( p_collection_name => ''P9506_EMAIL_PLACEHOLDER_COLL'', p_seq => :SEQ_ID );',
'    end case;',
'end;'))
,p_attribute_05=>'N'
,p_attribute_06=>'N'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':REQUEST is null'
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_exec_cond_for_each_row=>'Y'
,p_internal_uid=>2015993230697228
);
end;
/
prompt --application/pages/page_09507
begin
wwv_flow_imp_page.create_page(
 p_id=>9507
,p_name=>'Task Definition History'
,p_alias=>'TASK-DEFINITION-HISTORY'
,p_step_title=>'Task Definition History'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4913148488259994)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.a object_type,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from sys.dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from sys.dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from sys.dual) u,',
'  (select wwv_flow_lang.system_message(''TASK_DEFINITION'') a from sys.dual) t',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_TASK_DEFS''',
'union',
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.a object_type,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from sys.dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from sys.dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from sys.dual) u,',
'  (select wwv_flow_lang.system_message(''TASK_DEFINTION_ACTION'') a from sys.dual) t',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_TASK_DEF_ACTIONS''',
'union  ',
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.a object_type,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from sys.dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from sys.dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from sys.dual) u,',
'  (select wwv_flow_lang.system_message(''TASK_DEFINITION_PARAMETERS'') a from sys.dual) t',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_TASK_DEF_PARAMS''',
'union',
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.a object_type,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from sys.dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from sys.dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from sys.dual) u,',
'  (select wwv_flow_lang.system_message(''TASK_DEFINITION_PARTICIPANTS'') a from sys.dual) t',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_TASK_DEF_PARTICIPANTS''  '))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'History'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(4913237504259995)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'No history information found.'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'ADMIN'
,p_internal_uid=>4913237504259995
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1809341596110194)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1809779333110199)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Audit Date'
,p_column_type=>'DATE'
,p_column_alignment=>'CENTER'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1810157078110200)
,p_db_column_name=>'ACTION'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1811720262110204)
,p_db_column_name=>'OBJECT_TYPE'
,p_display_order=>70
,p_column_identifier=>'G'
,p_column_label=>'Object Type'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(1387977807801823)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1812115923110205)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>80
,p_column_identifier=>'H'
,p_column_label=>'Component Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1810578215110201)
,p_db_column_name=>'SCN'
,p_display_order=>90
,p_column_identifier=>'D'
,p_column_label=>'Scn'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1810959547110201)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>100
,p_column_identifier=>'E'
,p_column_label=>'Audit Comment'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1811322247110202)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>110
,p_column_identifier=>'F'
,p_column_label=>'Component Key'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(6829157381168337)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'50204'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'AUDIT_DATE:ACTION:DEVELOPER:OBJECT_TYPE:COMPONENT_NAME:'
,p_sort_column_1=>'AUDIT_DATE'
,p_sort_direction_1=>'DESC NULLS LAST'
,p_sort_column_2=>'0'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(14487857502216186)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_imp.id(1507124731460473)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(31704452142098000)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>'This page displays recent modifications made to Task Definitions in this application.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
end;
/
prompt --application/pages/page_09508
begin
wwv_flow_imp_page.create_page(
 p_id=>9508
,p_name=>'Utilization'
,p_alias=>'UTILIZATION1'
,p_step_title=>'Task Definition Utilization'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213240607818867991)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(5806815018990471)
,p_plug_name=>'Utilization'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  ',
'    t.id                    task_def_id,',
'    wwv_flow_utilities.prepare_url(''f?p=4000:4500:''||:flow_session||''::::FB_FLOW_PAGE_ID:''||p.id) ',
'                            the_url,',
'    p.id                    page_id, ',
'    p.name                  page_name, ',
'    wwv_flow_lang.system_message(''PAGE PROCESS'') ',
'                            process_type,',
'    pr.process_name         process_name,',
'    t.name                  task_def_name',
'from wwv_flow_steps           p,',
'     wwv_flow_step_processing pr,',
'     wwv_flow_task_defs       t',
'where t.id = pr.attribute_01',
'  and pr.process_type     = ''NATIVE_CREATE_TASK''',
'  and pr.flow_step_id     = p.id',
'  and pr.flow_id          = p.flow_id',
'  and p.flow_id           = t.flow_id',
'  and t.security_group_id = :flow_security_group_id',
'  and t.flow_id           = :FB_FLOW_ID',
''))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Utilization'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(5110163354375350)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'No Task Definitions utilizations found.'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_pivot=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'ADMIN'
,p_internal_uid=>5110163354375350
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2704693497550084)
,p_db_column_name=>'THE_URL'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'The Url'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2705034858550085)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>40
,p_column_identifier=>'C'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2705427810550085)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>50
,p_column_identifier=>'D'
,p_column_label=>'Page Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2705821104550086)
,p_db_column_name=>'PROCESS_TYPE'
,p_display_order=>60
,p_column_identifier=>'E'
,p_column_label=>'Component Type'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2706280615550088)
,p_db_column_name=>'PROCESS_NAME'
,p_display_order=>70
,p_column_identifier=>'F'
,p_column_label=>'Component Name'
,p_column_link=>'#THE_URL#'
,p_column_linktext=>'#PROCESS_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2261375425557309)
,p_db_column_name=>'TASK_DEF_ID'
,p_display_order=>80
,p_column_identifier=>'H'
,p_column_label=>'Task Definition ID'
,p_column_type=>'NUMBER'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(2261422054557310)
,p_db_column_name=>'TASK_DEF_NAME'
,p_display_order=>90
,p_column_identifier=>'I'
,p_column_label=>'Task Definition Name'
,p_column_link=>'f?p=&APP_ID.:9502:&SESSION.::&DEBUG.::P9502_ID:#TASK_DEF_ID#'
,p_column_linktext=>'#TASK_DEF_NAME#'
,p_allow_sorting=>'N'
,p_allow_filtering=>'N'
,p_allow_highlighting=>'N'
,p_allow_ctrl_breaks=>'N'
,p_allow_aggregations=>'N'
,p_allow_computations=>'N'
,p_allow_charting=>'N'
,p_allow_group_by=>'N'
,p_allow_pivot=>'N'
,p_allow_hide=>'N'
,p_column_type=>'STRING'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(5811762933584905)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'33018'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'PROCESS_TYPE:PROCESS_NAME:PAGE_ID:PAGE_NAME::TASK_DEF_ID:TASK_DEF_NAME'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(487700001322006454)
,p_plug_name=>'Utilization'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page displays where <strong>Task Definitions</strong> are being used within the application.',
'</p>',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(487700200515006455)
,p_plug_name=>'tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_imp.id(1507124731460473)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
);
end;
/
prompt --application/pages/page_09509
begin
wwv_flow_imp_page.create_page(
 p_id=>9509
,p_name=>'Reserved for Workflow/Task'
,p_alias=>'RESERVED-FOR-WORKFLOW-TASK3'
,p_step_title=>'Reserved for Workflow/Task'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'11'
);
end;
/
prompt --application/pages/page_09510
begin
wwv_flow_imp_page.create_page(
 p_id=>9510
,p_name=>'Reserved for Workflow/Task'
,p_alias=>'RESERVED-FOR-WORKFLOW-TASK4'
,p_step_title=>'Reserved for Workflow/Task'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'11'
);
end;
/
prompt --application/pages/page_09600
begin
wwv_flow_imp_page.create_page(
 p_id=>9600
,p_name=>'Workflow Definition'
,p_alias=>'WORKFLOW-DEFINITION'
,p_step_title=>'Workflow Definition'
,p_reload_on_submit=>'A'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'ON'
,p_group_id=>wwv_flow_imp.id(212963412798528796)
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- keep in sync with app 4000 combined files (under shared components - user interfaces - combined files)',
'#APEX_FILES#libraries/apex/#MIN_DIRECTORY#widget.treeView#MIN#.js',
'#APEX_FILES#libraries/apex/#MIN_DIRECTORY#widget.iconList#MIN#.js',
'#APEX_FILES#libraries/apex/#MIN_DIRECTORY#commandHistory#MIN#.js',
'#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#templateOptionsHelper#MIN#.js',
'#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#pe.model#MIN#.js',
'#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#f4000.designer#MIN#.js',
'#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#f4000.tree#MIN#.js',
'#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#f4000_p9600.diagram.controller#MIN#.js',
'#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#f4000_p9600#MIN#.js',
'#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#pe.callbacks#MIN#.js',
'#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#widget.peMessagesView#MIN#.js',
'#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#widget.peSearch#MIN#.js',
'#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#f4000_p9600.gallery#MIN#.js',
'#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#f4000_p9600.tree#MIN#.js',
'#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#widget.propertyEditor#MIN#.js',
'#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#widget.lovDialog#MIN#.js',
'#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#widget.pdPropertyEditor#MIN#.js',
'#APEX_FILES#libraries/apex/#MIN_DIRECTORY#item.Colorpicker#MIN#.js',
'[require requirejs]#APEX_FILES#libraries/apex/#MIN_DIRECTORY#widget.toolbar#MIN#.js',
'[require requirejs]#APEX_FILES#apex_ui/js/#MIN_DIRECTORY#widget.codeEditor#MIN#.js'))
,p_step_template=>wwv_flow_imp.id(384711093594980574)
,p_page_css_classes=>'apex-page-designer'
,p_page_template_options=>'#DEFAULT#'
,p_required_role=>wwv_flow_imp.id(74845831538733642)
,p_help_text=>'bldr_pg_def_about.htm'
,p_page_component_map=>'10'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1455814530486701)
,p_plug_name=>'AI Hook'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_plug_display_point=>'REGION_POSITION_06'
,p_location=>null
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.AI_HOOK'
,p_ai_system_prompt=>'APEX$CODE_EDITOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'ai_key', 'codeEditor')).to_clob
,p_plug_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'*** Do not remove *** ',
'This region is necessary for the AI Chat feature in the code editors.',
''))
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3005064774123987)
,p_plug_name=>'APEX 5 Main Control Bar'
,p_region_css_classes=>'a-ControlBar apex-app-builder a-Toolbar--simple'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_point=>'REGION_POSITION_01'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3005059992192152)
,p_plug_name=>'Control Bar'
,p_parent_plug_id=>wwv_flow_imp.id(3005064774123987)
,p_region_css_classes=>'a-ControlBar-col'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_landmark_type=>'region'
,p_landmark_label=>'Page Actions'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3005127435442424)
,p_plug_name=>'Utilitiies Menu'
,p_region_name=>'utilitiesMenu'
,p_parent_plug_id=>wwv_flow_imp.id(3005059992192152)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#:js-addActions'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_imp.id(3115558112261397)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(3712705120335)
,p_translate_title=>'N'
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(416692351013878398)
,p_plug_name=>'Working Copy Menu'
,p_region_name=>'workingCopyMenu'
,p_parent_plug_id=>wwv_flow_imp.id(3005059992192152)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_imp.id(3056785755622754)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(3712705120335)
,p_translate_title=>'N'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_working_copy_dev.is_working_copy( ',
'    p_application_id    => :FB_FLOW_ID,',
'    p_security_group_id => :WORKSPACE_ID )'))
,p_plug_display_when_cond2=>'PLSQL'
,p_landmark_type=>'exclude_landmark'
,p_plug_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'1500,460,514,516,527,273,2100,2101,2102,2103,2105,2106,2107,2108,2109,2111,2115,1556,1555,163,1550,56,320,176,189,351,433,437,447,448,451,454,458,494,495,496,3001,3002,3003,3004,3005,3006,3014,3015,3020,49,57,3000,2116,598,2117,73',
'',
'-- condition: current page is not in expression 1 (as of 01/06/2014)',
'4500,1500,460,514,516,527,273,2100,2101,2102,2103,2105,2106,2107,2108,2109,2111,2115,163,56,320,176,189,351,433,437,447,448,451,454,458,494,495,496,3001,3002,3003,3004,3005,3006,3014,3015,3020,49,57,3000,2116,598,2117,73,227,262,20,800,662,544,2150,2'
||'151,2152,2153,2154,2155,2156,2157,733,870,871,872,873,874,550,555,560,580,585,588,589,599,226,595,875,876,700,705,710,715,720,725,730,735,750,880,882,600,605,610,615,620,625,630,635,640,884,886,196,722,523,689,4460,479,224,4900,76,489,488,487,441,110'
||'05,933,559,934,679,11002,11003,11004,78,279,50,83,209,81,650,680',
''))
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(636364966988098540)
,p_plug_name=>'Working Copy Main App Menu'
,p_region_name=>'mainAppMenu'
,p_parent_plug_id=>wwv_flow_imp.id(3005059992192152)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_list_id=>wwv_flow_imp.id(1415423878169192)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(3712705120335)
,p_translate_title=>'N'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_working_copy_dev.is_main_app (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_security_group_id => :WORKSPACE_ID )'))
,p_plug_display_when_cond2=>'PLSQL'
,p_landmark_type=>'exclude_landmark'
,p_plug_comment=>wwv_flow_string.join(wwv_flow_t_varchar2(
'1500,460,514,516,527,273,2100,2101,2102,2103,2105,2106,2107,2108,2109,2111,2115,1556,1555,163,1550,56,320,176,189,351,433,437,447,448,451,454,458,494,495,496,3001,3002,3003,3004,3005,3006,3014,3015,3020,49,57,3000,2116,598,2117,73',
'',
'-- condition: current page is not in expression 1 (as of 01/06/2014)',
'4500,1500,460,514,516,527,273,2100,2101,2102,2103,2105,2106,2107,2108,2109,2111,2115,163,56,320,176,189,351,433,437,447,448,451,454,458,494,495,496,3001,3002,3003,3004,3005,3006,3014,3015,3020,49,57,3000,2116,598,2117,73,227,262,20,800,662,544,2150,2'
||'151,2152,2153,2154,2155,2156,2157,733,870,871,872,873,874,550,555,560,580,585,588,589,599,226,595,875,876,700,705,710,715,720,725,730,735,750,880,882,600,605,610,615,620,625,630,635,640,884,886,196,722,523,689,4460,479,224,4900,76,489,488,487,441,110'
||'05,933,559,934,679,11002,11003,11004,78,279,50,83,209,81,650,680',
''))
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(51790981502802176)
,p_plug_name=>'Breadcrumb'
,p_parent_plug_id=>wwv_flow_imp.id(3005064774123987)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_menu_id=>wwv_flow_imp.id(6341600034528019)
,p_plug_source_type=>'NATIVE_BREADCRUMB'
,p_menu_template_id=>wwv_flow_imp.id(3705314539083)
,p_landmark_type=>'navigation'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3005067211829548)
,p_plug_name=>'Global JavaScript variables'
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>40
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_allow_team_dev varchar2( 1 );',
'begin',
'    sys.htp.p(''<script type="text/javascript">'');',
'',
'    select /*+ result_cache */',
'           nvl( allow_team_development_yn, ''Y'' )',
'      into l_allow_team_dev',
'      from wwv_flow_companies',
'     where provisioning_company_id = :WORKSPACE_ID;',
'     ',
'    sys.htp.p(',
'        ''var gTeamDevEnabled = '' || wwv_flow_javascript.add_value( l_allow_team_dev = ''Y'', false ) ||',
'        '', gBuilderLang = '' || wwv_flow_escape.js_literal( wwv_flow.g_flow_language ) ||',
'        '', gIsInternal  = '' || wwv_flow_javascript.add_value( :WORKSPACE_ID = 10, false ) ||',
'        '', gIsReadOnly  = '' || wwv_flow_javascript.add_value( false, false ) ||',
'        '', gLanguage    = '' || wwv_flow_javascript.add_value( wwv_flow.g_flow_language, false ) ||',
'        '', gApexVersion = '' || wwv_flow_javascript.add_value( wwv_flows_release, false ) ||',
'        '';'' );',
'',
'    wwv_flow_json.initialize_clob_output;',
'    wwv_flow_json.open_object;',
'    for l_preferences in ( select preference_name,',
'                                  attribute_value',
'                             from wwv_flow_preferences$',
'                            where user_id = wwv_flow.g_user',
'                              and security_group_id = :WORKSPACE_ID',
'                              and preference_name in ( ''CODE_EDITOR_SETTINGS'',',
'                                                       ''CODE_LANGUAGE'',',
'                                                       ''WD_PE_CODE_EDITOR_DLG_W'',',
'                                                       ''WD_PE_CODE_EDITOR_DLG_H'',',
'                                                       ''WD_ENABLE_TOOLTIPS'',',
'                                                       ''WD_TAB_LAYOUT_2'',',
'                                                       ''WD_TAB_LAYOUT_3'',',
'                                                       ''WD_TWO_COLUMN_MODE'' ) )',
'    loop',
'        wwv_flow_json.write(l_preferences.preference_name, l_preferences.attribute_value);',
'    end loop;',
'    wwv_flow_json.close_object;',
'    ',
'    sys.htp.prn(''var gPreferences = '' || wwv_flow_json.get_clob_output(p_free => true) || '';'');',
'    sys.htp.p(''</script>'');',
'',
'end;',
''))
,p_plug_source_type=>'NATIVE_PLSQL'
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3128038121909801)
,p_plug_name=>'Start Screen'
,p_region_name=>'startRegion'
,p_region_css_classes=>'b-WorkflowSplash'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="display:none"'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'<h2>Create your first Workflow!</h2>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(51565961986352711)
,p_plug_name=>'Button Bar'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'REGION_POSITION_01'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(153656635342334714)
,p_plug_name=>'Message Dialog'
,p_region_name=>'pdMessagesDialog'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="display:none;"'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_06'
,p_plug_source=>'<div id="pdMessages" class="padding-md"></div>'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(206906187134624410)
,p_plug_name=>'[Splitter] Main'
,p_region_name=>'sp_main'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="display:none"'
,p_plug_template=>wwv_flow_imp.id(177373906751600776)
,p_plug_display_sequence=>30
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SPLITTER'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', '#sp_main_content',
  'attribute_02', 'horizontal',
  'attribute_03', 'begin',
  'attribute_04', '290',
  'attribute_05', 'N',
  'attribute_08', '200',
  'attribute_09', 'N',
  'attribute_12', 'Left Splitter',
  'attribute_13', 'Y',
  'attribute_14', 'Y',
  'attribute_15', 'N',
  'attribute_16', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(206906384551624424)
,p_plug_name=>'Page Elements'
,p_region_name=>'left_col'
,p_parent_plug_id=>wwv_flow_imp.id(206906187134624410)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(226071526010722245)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(206906582575624425)
,p_plug_name=>'Page Elements - Container'
,p_region_name=>'pageElementsContainers'
,p_parent_plug_id=>wwv_flow_imp.id(206906384551624424)
,p_component_template_options=>'#DEFAULT#'
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1343564532454812850)
,p_plug_name=>'Left Column Tree'
,p_region_name=>'trees'
,p_parent_plug_id=>wwv_flow_imp.id(206906582575624425)
,p_region_css_classes=>'resize ui-tabs--simpleInset a-Tabs--pageDesignerTabs'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(1094670710611261973)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_landmark_label=>'Workflow Elements Tabs'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3719640954826715)
,p_plug_name=>'Workflow'
,p_region_name=>'workflowTree_container'
,p_parent_plug_id=>wwv_flow_imp.id(1343564532454812850)
,p_region_css_classes=>'resize'
,p_icon_css_classes=>'icon-workflow-designer'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3720028161826719)
,p_plug_name=>'Workflow'
,p_region_name=>'r_workflow_tree'
,p_parent_plug_id=>wwv_flow_imp.id(3719640954826715)
,p_region_css_classes=>'u-ScrollingViewport resize a-PageDesigner-treeWrap'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div aria-label=''&"APP_TEXT$PD.WF.TREE.NAME_WORKFLOW".'' id="workflowTree"></div>',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4023765812179132)
,p_plug_name=>'Workflow Toolbar'
,p_parent_plug_id=>wwv_flow_imp.id(3719640954826715)
,p_region_css_classes=>'a-Toolbar-pageColumn a-Toolbar--floating'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174795802901076650)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4025577511179150)
,p_plug_name=>'Used Shared Components'
,p_region_name=>'sharedComp_container'
,p_parent_plug_id=>wwv_flow_imp.id(1343564532454812850)
,p_region_css_classes=>'resize'
,p_icon_css_classes=>'icon-pd-shared-components'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1782460879967201)
,p_plug_name=>'Used Shared Components Toolbar'
,p_parent_plug_id=>wwv_flow_imp.id(4025577511179150)
,p_region_css_classes=>'a-Toolbar-pageColumn a-Toolbar--floating'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174795802901076650)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1782696345967203)
,p_plug_name=>'Used Shared Components'
,p_region_name=>'r_shared_comp_tree'
,p_parent_plug_id=>wwv_flow_imp.id(4025577511179150)
,p_region_css_classes=>'u-ScrollingViewport resize a-PageDesigner-treeWrap'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<div aria-label=''&"APP_TEXT$PD.WF.TREE.NAME_PDSHAREDCOMP".'' id="PDsharedCompTree"></div>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(206907763710624430)
,p_plug_name=>'[Splitter] Right'
,p_region_name=>'sp_right'
,p_parent_plug_id=>wwv_flow_imp.id(206906187134624410)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(177373906751600776)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SPLITTER'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', '#sp_right_content',
  'attribute_02', 'horizontal',
  'attribute_03', 'end',
  'attribute_04', '290',
  'attribute_05', 'N',
  'attribute_08', '200',
  'attribute_09', 'N',
  'attribute_12', 'Right Splitter',
  'attribute_13', 'Y',
  'attribute_14', 'Y',
  'attribute_15', 'N',
  'attribute_16', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(206908362804624433)
,p_plug_name=>'Primary Editor'
,p_region_name=>'top_col'
,p_parent_plug_id=>wwv_flow_imp.id(206907763710624430)
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(226071526010722245)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(206908565702624433)
,p_plug_name=>'Editor Tabs'
,p_region_name=>'editor_tabs'
,p_parent_plug_id=>wwv_flow_imp.id(206908362804624433)
,p_region_css_classes=>'resize ui-tabs--simpleInset a-Tabs--pageDesignerTabs a-Tabs--pageDesignerPrimaryTabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(1094670710611261973)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_landmark_label=>'Primary Editor Tabs'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(206908774294624434)
,p_plug_name=>'Diagram Builder'
,p_region_name=>'grid_diagram'
,p_parent_plug_id=>wwv_flow_imp.id(206908565702624433)
,p_region_css_classes=>'resize'
,p_icon_css_classes=>'icon-pd-layout'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_query_num_rows=>15
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(206908982922624435)
,p_plug_name=>'Diagram Builder'
,p_region_name=>'diagramToolbar'
,p_parent_plug_id=>wwv_flow_imp.id(206908774294624434)
,p_region_css_classes=>'a-Toolbar-pageColumn a-Toolbar-pageColumn--gridLayout a-Toolbar--simple'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174795802901076650)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1160689086381952747)
,p_plug_name=>'[Splitter] GLV'
,p_region_name=>'sp_glv'
,p_parent_plug_id=>wwv_flow_imp.id(206908774294624434)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(177373906751600776)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source_type=>'PLUGIN_COM.ORACLE.APEX.SPLITTER'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'attribute_01', '#sp_glv_content',
  'attribute_02', 'vertical',
  'attribute_03', 'end',
  'attribute_04', '200',
  'attribute_05', 'N',
  'attribute_08', '140',
  'attribute_09', 'N',
  'attribute_12', 'Gallery Splitter',
  'attribute_13', 'Y',
  'attribute_14', 'Y',
  'attribute_15', 'N',
  'attribute_16', 'Y')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(206922391103212270)
,p_plug_name=>'Drag and Drop Editor'
,p_region_name=>'glv-viewport-container'
,p_parent_plug_id=>wwv_flow_imp.id(1160689086381952747)
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="app-viewport" class="dark-scroll resize u-ScrollingViewport a-GridLayout-wrapper">',
'  <div id="app" class="a-WorkflowApp" tabindex="0" role="img" aria-label=''&"APP_TEXT$WF.DIAGRAM_ARIA_LABEL".'' aria-description=''&"APP_TEXT$WF.DIAGRAM_ARIA_DESC".''>',
'        <div class="paper" id="paper"></div>',
'        <div class="stencil"></div>',
'    </div>',
'</div>',
'<div id="diagramMenu"></div>'))
,p_translate_title=>'N'
,p_plug_query_headings_type=>'QUERY_COLUMNS'
,p_plug_query_num_rows=>15
,p_plug_query_num_rows_type=>'NEXT_PREVIOUS_LINKS'
,p_plug_query_show_nulls_as=>' - '
,p_pagination_display_position=>'BOTTOM_RIGHT'
,p_landmark_type=>'region'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1160689363551952750)
,p_plug_name=>'TabHolder'
,p_parent_plug_id=>wwv_flow_imp.id(1160689086381952747)
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
,p_plug_comment=>'For proper sizing tabs must be in a container div that is sized.'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(206913869154846324)
,p_plug_name=>'Gallery'
,p_region_name=>'gallery-tabs'
,p_parent_plug_id=>wwv_flow_imp.id(1160689363551952750)
,p_region_css_classes=>'resize ui-tabs--subTabButtons a-Toolbar--simple'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(183219627032331552)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3140802988913301)
,p_plug_name=>'Activities'
,p_region_name=>'cg-activities'
,p_parent_plug_id=>wwv_flow_imp.id(206913869154846324)
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div class=''resize u-ScrollingViewport''>',
'  <ul></ul>',
'</div>',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(229344885668918527)
,p_plug_name=>'Help'
,p_region_name=>'help'
,p_parent_plug_id=>wwv_flow_imp.id(206908565702624433)
,p_icon_css_classes=>'icon-help'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>50
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>'<div id="help-container" class="a-HelpRegion resize u-ScrollingViewport"></div>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(364879272029088298)
,p_plug_name=>'Search'
,p_region_name=>'search'
,p_parent_plug_id=>wwv_flow_imp.id(206908565702624433)
,p_region_css_classes=>'resize'
,p_icon_css_classes=>'icon-search'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>40
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6345510537810851)
,p_plug_name=>'Search Toolbar'
,p_parent_plug_id=>wwv_flow_imp.id(364879272029088298)
,p_region_css_classes=>'a-Toolbar-pageColumn a-Toolbar-pageColumn--search'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6345642647810852)
,p_plug_name=>'Search Bar'
,p_parent_plug_id=>wwv_flow_imp.id(6345510537810851)
,p_region_css_classes=>'a-Toolbar-pageColumn--searchBar'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6345736619810853)
,p_plug_name=>'Search Options'
,p_parent_plug_id=>wwv_flow_imp.id(6345510537810851)
,p_region_css_classes=>'a-Toolbar-pageColumn--searchOptions'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6345831348810854)
,p_plug_name=>'Search Results'
,p_region_name=>'search-container'
,p_parent_plug_id=>wwv_flow_imp.id(364879272029088298)
,p_region_css_classes=>'resize u-ScrollingViewport'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'aria-live="polite"'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1344169914951459554)
,p_plug_name=>'Right Column Pane'
,p_region_name=>'right_col'
,p_parent_plug_id=>wwv_flow_imp.id(206907763710624430)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(226071526010722245)
,p_plug_display_sequence=>40
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1527155875798284917)
,p_plug_name=>'Property Editor Tabs'
,p_region_name=>'peTabs'
,p_parent_plug_id=>wwv_flow_imp.id(1344169914951459554)
,p_region_css_classes=>'resize ui-tabs--simpleInset a-Tabs--pageDesignerTabs'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(183219627032331552)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_column=>false
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1527155481903284913)
,p_plug_name=>'Component Properties'
,p_region_name=>'peComponentProperties'
,p_parent_plug_id=>wwv_flow_imp.id(1527155875798284917)
,p_region_css_classes=>'resize'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1344169990274459555)
,p_plug_name=>'Property Editor Toolbar'
,p_region_name=>'peMainToolbar'
,p_parent_plug_id=>wwv_flow_imp.id(1527155481903284913)
,p_region_css_classes=>'a-Toolbar-pageColumn a-Toolbar--simple a-Toolbar--propertyEditor'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(174795802901076650)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1527155427646284912)
,p_plug_name=>'Property Editor'
,p_parent_plug_id=>wwv_flow_imp.id(1527155481903284913)
,p_plug_display_sequence=>30
,p_plug_display_point=>'SUB_REGIONS'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<div id="peMain" class="resize"></div>',
'<div id="pe_goto_group_menu"></div>'))
,p_translate_title=>'N'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3128140355909802)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(3128038121909801)
,p_button_name=>'CREATE_WORKFLOW'
,p_button_static_id=>'createWorkflow'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--large'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_warn_on_unsaved_changes=>null
,p_button_cattributes=>'type="button"'
,p_grid_new_row=>'Y'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3024508412614546)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(6345642647810852)
,p_button_name=>'CLEAR_PAGE_SEARCH'
,p_button_static_id=>'CLEAR_PAGE_SEARCH'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--pillEnd'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Clear'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'icon-remove'
,p_button_cattributes=>'aria-controls="search-container"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1782540136967202)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(1782460879967201)
,p_button_name=>'SHARED_COMPONENTS_MENU'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(3705362896815)
,p_button_image_alt=>'Application Shared Components'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'icon-menu'
,p_button_cattributes=>'data-menu="PDsharedCompTreeMenu"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4023837744179133)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(4023765812179132)
,p_button_name=>'WORKFLOW_MENU'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(3705362896815)
,p_button_image_alt=>'Rendering Menu'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_icon_css_classes=>'icon-menu'
,p_button_cattributes=>'data-menu="workflowTreeMenu"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3020084830614542)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(206908982922624435)
,p_button_name=>'DIAGRAM_ZOOM_IN'
,p_button_static_id=>'glvDispFromHereBtn'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Diagram Zoom In'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--simple a-Button--pillStart'
,p_icon_css_classes=>'icon-zoom-region'
,p_button_cattributes=>'data-action="diagram-zoom-in"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3030596655614551)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(1344169990274459555)
,p_button_name=>'GOTO_GROUP_MAIN'
,p_button_static_id=>'peGoToGroupBtn'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(3705362896815)
,p_button_image_alt=>'Go to Group'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--simple'
,p_icon_css_classes=>'icon-goto-group'
,p_button_cattributes=>'data-menu="pe_goto_group_menu"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3002610607614523)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(3005059992192152)
,p_button_name=>'SHOW_MESSAGES'
,p_button_static_id=>'pdShowMessagesBtn'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(3781715377307)
,p_button_image_alt=>'Show Messages'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--simple'
,p_icon_css_classes=>'icon-pd-messages'
,p_button_cattributes=>'style="display:none"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3019658069614541)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(206908982922624435)
,p_button_name=>'DIAGRAM_ZOOM_OUT'
,p_button_static_id=>'glvDispFromPageBtn'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Diagram Zoom Out'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--simple a-Button--pillEnd'
,p_icon_css_classes=>'icon-zoom-page'
,p_button_cattributes=>'data-action="diagram-zoom-out"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3022087712614543)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(206913869154846324)
,p_button_name=>'GALLERY_MENU'
,p_button_static_id=>'galleryMenuBtn'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(3705362896815)
,p_button_image_alt=>'Gallery Menu'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--simple '
,p_icon_css_classes=>'icon-menu'
,p_button_cattributes=>'data-menu="galleryMenu"'
,p_required_patch=>wwv_flow_imp.id(170786031904296885)
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3003444514614523)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(3005059992192152)
,p_button_name=>'UNDO'
,p_button_static_id=>'button-undo'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Undo'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--pillStart a-Button--padLeft a-Button--simple'
,p_icon_css_classes=>'icon-undo'
,p_button_cattributes=>'data-action="pd-undo"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1799778679336207)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(206908982922624435)
,p_button_name=>'DIAGRAM_SHOW_NAVIGATOR'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Diagram Show Navigator'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--simple a-Button--gapLeft'
,p_icon_css_classes=>'icon-navigator'
,p_button_cattributes=>'data-action="diagram-show-navigator"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3003898853614523)
,p_button_sequence=>70
,p_button_plug_id=>wwv_flow_imp.id(3005059992192152)
,p_button_name=>'REDO'
,p_button_static_id=>'button-redo'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Redo'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--pillEnd a-Button--simple a-Button--gapRight'
,p_icon_css_classes=>'icon-redo'
,p_button_cattributes=>'data-action="pd-redo"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3019213646614541)
,p_button_sequence=>80
,p_button_plug_id=>wwv_flow_imp.id(206908982922624435)
,p_button_name=>'GLV_MENU'
,p_button_static_id=>'glvMenuBtn'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(3705362896815)
,p_button_image_alt=>'Layout Menu'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--simple a-Button--gapLeft'
,p_icon_css_classes=>'icon-menu'
,p_button_cattributes=>'data-menu="diagramMenu"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3004662270614524)
,p_button_sequence=>100
,p_button_plug_id=>wwv_flow_imp.id(3005059992192152)
,p_button_name=>'UTILITIES_MENU'
,p_button_static_id=>'menu-utilities'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(3705362896815)
,p_button_image_alt=>'Utilities'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--gapRight a-Button--simple'
,p_icon_css_classes=>'icon-tools'
,p_button_cattributes=>'data-menu="utilitiesMenu_menu"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3005431905614524)
,p_button_sequence=>120
,p_button_plug_id=>wwv_flow_imp.id(3005059992192152)
,p_button_name=>'SHARED_COMP'
,p_button_static_id=>'menu-shared-components'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Shared Components'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:9:&SESSION.::&DEBUG.:RP::'
,p_button_css_classes=>'a-Button--gapRight a-Button--simple'
,p_icon_css_classes=>'icon-shared-components'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(411795850542380412)
,p_button_sequence=>130
,p_button_plug_id=>wwv_flow_imp.id(3005059992192152)
,p_button_name=>'MAIN_APP_MENU'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(267402330762941782)
,p_button_image_alt=>'Main'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_working_copy_dev.app_has_working_copy (',
'    p_application_id    => :FB_FLOW_ID,',
'    p_security_group_id => :WORKSPACE_ID )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_css_classes=>'a-Button a-Button--padLeft a-Button--gapRight'
,p_icon_css_classes=>'icon-working-copy-main'
,p_button_cattributes=>'data-menu="mainAppMenu_menu" aria-label="Working Copy: Main" title="Working Copy: Main"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(411797926204381835)
,p_button_sequence=>140
,p_button_plug_id=>wwv_flow_imp.id(3005059992192152)
,p_button_name=>'WORKING_COPY_MENU'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(267402330762941782)
,p_button_image_alt=>'&WORKING_COPY_NAME.'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
,p_button_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_working_copy_dev.is_working_copy( ',
'    p_application_id    => :FB_FLOW_ID,',
'    p_security_group_id => :WORKSPACE_ID )'))
,p_button_condition2=>'PLSQL'
,p_button_condition_type=>'EXPRESSION'
,p_button_css_classes=>'a-Button a-Button--padLeft a-Button--gapRight is-working-copy'
,p_icon_css_classes=>'icon-working-copy'
,p_button_cattributes=>'data-menu="workingCopyMenu_menu" aria-label="Working Copy: &WORKING_COPY_NAME." title="Working Copy: &WORKING_COPY_NAME."'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(139952294760709308)
,p_button_sequence=>150
,p_button_plug_id=>wwv_flow_imp.id(3005059992192152)
,p_button_name=>'EDIT_PAGE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#:a-Button--iconLeft'
,p_button_template_id=>wwv_flow_imp.id(2045667935478789095)
,p_button_image_alt=>'Edit Page &FB_FLOW_PAGE_ID. '
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:4500:&SESSION.::&DEBUG.::FB_FLOW_ID,FB_FLOW_PAGE_ID:&FB_FLOW_ID.,&FB_FLOW_PAGE_ID.'
,p_button_condition=>'FB_FLOW_PAGE_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_button_css_classes=>'a-Button--withIcon a-Button--padRight a-Button--editPageButton a-Button--iconTopAction'
,p_icon_css_classes=>'icon-edit-page'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3005826674614525)
,p_button_sequence=>160
,p_button_plug_id=>wwv_flow_imp.id(3005059992192152)
,p_button_name=>'SAVE_PAGE'
,p_button_static_id=>'button-save-page'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Save'
,p_button_position=>'NEXT'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--iconTopAction a-Button--savePage'
,p_button_cattributes=>'data-action="pd-save-page" disabled'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1801108509336221)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(206908982922624435)
,p_button_name=>'DIAGRAM_TO_FRONT'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Bring to Front'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--simple a-Button--pillStart'
,p_button_cattributes=>'data-action="diagram-cell-to-front"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1801263699336222)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(206908982922624435)
,p_button_name=>'DIAGRAM_TO_BACK'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Bring to Back'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--simple a-Button--pillEnd'
,p_button_cattributes=>'data-action="diagram-cell-to-back"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1799835922336208)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(206908982922624435)
,p_button_name=>'DIAGRAM_LINK_NORMAL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Direct Connection'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--simple a-Button--pillStart a-Button--gapLeft'
,p_button_cattributes=>'data-action="diagram-link-normal"'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1799925959336209)
,p_button_sequence=>50
,p_button_plug_id=>wwv_flow_imp.id(206908982922624435)
,p_button_name=>'DIAGRAM_LINK_ORTHOGNAL'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(354034308421865099)
,p_button_image_alt=>'Orthogonal Connection'
,p_button_position=>'PREVIOUS'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
,p_button_css_classes=>'a-Button--simple a-Button--pillEnd'
,p_button_cattributes=>'data-action="diagram-link-orthogonal"'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3009512730614531)
,p_name=>'P9600_CURRENT_APP'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(51565961986352711)
,p_use_cache_before_default=>'NO'
,p_source=>'FB_FLOW_ID'
,p_source_type=>'ITEM'
,p_display_as=>'NATIVE_HIDDEN'
,p_escape_on_http_input=>'Y'
,p_restricted_characters=>'WEB_SAFE'
,p_help_text=>'Identifies the page number. To view another page, select or enter a new page number and click <strong>Go</strong>.'
,p_attribute_01=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3024985442614546)
,p_name=>'P9600_LOCAL_SEARCH'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(6345642647810852)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Search'
,p_placeholder=>'Search page...'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>40
,p_cMaxlength=>255
,p_tag_attributes=>'aria-controls="search-container"'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--search'
,p_item_icon_css_classes=>'a-Icon icon-search'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3025601856614547)
,p_name=>'P9600_IS_REGEXP'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(6345736619810853)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Regular Expression'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_tag_attributes=>'aria-controls="search-container"'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--inline'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3026008605614547)
,p_name=>'P9600_MATCH_CASE'
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(6345736619810853)
,p_use_cache_before_default=>'NO'
,p_prompt=>'Match Case'
,p_display_as=>'NATIVE_SINGLE_CHECKBOX'
,p_tag_attributes=>'aria-controls="search-container"'
,p_field_template=>wwv_flow_imp.id(566010921977401124)
,p_item_css_classes=>'a-Form-fieldContainer--inline'
,p_item_template_options=>'#DEFAULT#'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_computation(
 p_id=>wwv_flow_imp.id(3032174046614557)
,p_computation_sequence=>10
,p_computation_item=>'F4000_LAST_VIEW'
,p_computation_point=>'AFTER_HEADER'
,p_computation_type=>'STATIC_ASSIGNMENT'
,p_computation=>'4500'
,p_required_patch=>wwv_flow_imp.id(170786031904296885)
,p_computation_error_message=>'Unable to compute item value.'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3034872870614559)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'security'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_error.raise_internal_error(',
'    p_error_message => wwv_flow_lang.system_message( p_name => ''F4000.P1.APP_DOES_NOT_EXIST'',',
'                                                     p0     => wwv_flow_escape.html( nvl( :FB_FLOW_ID, ''NULL'' ) ) ) );'))
,p_process_clob_language=>'PLSQL'
,p_process_when=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from sys.dual',
' where :FB_FLOW_ID is null',
'union all',
'select 1',
'    from   wwv_flow_developers',
'    where  userid = :FLOW_USER ',
'       and',
'       security_group_id = :FLOW_SECURITY_GROUP_ID',
'       and',
'       security_group_id = ',
'         (select security_group_id from wwv_flows where id=:FB_FLOW_ID)',
'       and',
'       instr(developer_role,''EDIT'') > 0 ',
'       and',
'       (flow_id = :FB_FLOW_ID or flow_id is null)  ',
'intersect',
'select 1',
'  from wwv_flows',
' where security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and id = :FB_FLOW_ID',
'   and build_status = ''RUN_AND_BUILD'''))
,p_process_when_type=>'NOT_EXISTS'
,p_internal_uid=>3034872870614559
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4299640640060402)
,p_process_sequence=>30
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'add libraries'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_javascript.add_3rd_party_library_file (',
'    p_library => wwv_flow_cdn.c_library_lodash );',
'',
'wwv_flow_javascript.add_3rd_party_library_file (',
'    p_library => wwv_flow_cdn.c_library_backbone );',
'',
'wwv_flow_javascript.add_3rd_party_library_file (',
'    p_library => wwv_flow_cdn.c_library_rappid );',
'',
'wwv_flow_css.add_3rd_party_library_file (',
'    p_library => wwv_flow_cdn.c_library_rappid );',
'',
'wwv_flow_javascript.add_apex_library (',
'    p_name => ''DiagramBuilder'' );'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>4299640640060402
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3032888882614558)
,p_process_sequence=>10
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'getDistinctValues'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_property_dev.emit_distinct_values (',
'        p_application_id    => :FB_FLOW_ID,',
'        p_component_type_id => wwv_flow.g_x01,',
'        p_property_id       => wwv_flow.g_x02 );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>3032888882614558
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3033279211614559)
,p_process_sequence=>10
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'getPageItems'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_property_dev.emit_page_items (',
'        p_application_id => :FB_FLOW_ID,',
'        p_page_id        => wwv_flow.g_x01 );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>3033279211614559
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3034082514614559)
,p_process_sequence=>10
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'getDbObjects'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_property_dev.emit_db_objects (',
'        p_application_id   => :FB_FLOW_ID,',
'        p_type             => wwv_flow.g_x01,',
'        p_owner            => wwv_flow.g_x02,',
'        p_parent           => wwv_flow.g_x03,',
'        p_remote_server_id => wwv_flow.g_x04 );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>3034082514614559
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3036810157614560)
,p_process_sequence=>10
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'getNewComponentId'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_property_dev.emit_new_component_id (',
'        p_count => wwv_flow.g_x01 );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>3036810157614560
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3032464517614558)
,p_process_sequence=>40
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'getCodeCompleteList'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_f4000_plugins.emit_code_complete_list (',
'        p_application_id => :FB_FLOW_ID,',
'        p_type           => wwv_flow.g_widget_name,',
'        p_search_prefix  => wwv_flow.g_x01,',
'        p_parent         => wwv_flow.g_x02,',
'        p_grand_parent   => wwv_flow.g_x03 );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>3032464517614558
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3720255171826721)
,p_process_sequence=>60
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'getWorkflowData'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_property_dev.emit_workflow_data (',
'        p_application_id => :FB_FLOW_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>3720255171826721
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3035625423614560)
,p_process_sequence=>70
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'getSharedData'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_property_dev.emit_shared_data (',
'        p_application_id => :FB_FLOW_ID );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>3035625423614560
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3038058961614561)
,p_process_sequence=>80
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'getWorkspaceData'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_property_dev.emit_workspace_data;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>3038058961614561
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3035258203614560)
,p_process_sequence=>90
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'getStaticData'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_property_dev.emit_static_data;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>3035258203614560
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3038469684614561)
,p_process_sequence=>100
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'getAdditionalData'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    c_page_id constant number := to_number( wwv_flow.g_x01 );',
'',
'    l_count   pls_integer;',
'    l_page_id number;',
'begin',
'    ',
'    wwv_flow_json.open_object;',
'',
'    -- Get previous page id',
'    begin',
'        select id',
'          into l_page_id',
'          from ( select id',
'                   from wwv_flow_steps',
'                  where flow_id = :FB_FLOW_ID',
'                    and security_group_id = :WORKSPACE_ID',
'                    and id                < c_page_id',
'                  order by id desc',
'               )',
'         where rownum <= 1;',
'        wwv_flow_json.  write( ''prevPageId'', to_char( l_page_id ));',
'    exception when no_data_found then null;',
'    end;',
'',
'    -- Get next page id',
'    begin',
'        select id',
'          into l_page_id',
'          from ( select id',
'                   from wwv_flow_steps',
'                  where flow_id = :FB_FLOW_ID',
'                    and security_group_id = :WORKSPACE_ID',
'                    and id                > c_page_id',
'                  order by id',
'               )',
'         where rownum <= 1;',
'        wwv_flow_json.  write( ''nextPageId'', to_char( l_page_id ));',
'    exception when no_data_found then null;',
'    end;',
'    ',
'    select count(*)',
'      into l_count',
'      from wwv_flow_app_comments',
'     where flow_id            = :FB_FLOW_ID',
'       and security_group_id  = :WORKSPACE_ID',
'       and instr( '','' || replace( replace( pages, '' '', null ), '':'', '','' ) || '','' , '','' || c_page_id || '','' ) > 0;',
'',
'    wwv_flow_json.  write( ''comments'', l_count );',
'',
'    wwv_flow_json.  open_object( ''teamDev'' );',
'    ',
'    ',
'    select count(*)',
'      into l_count',
'      from wwv_flow_feedback',
'     where application_id            = :FB_FLOW_ID',
'       and page_id                   = c_page_id',
'       and security_group_id         = :WORKSPACE_ID',
'       and nvl( feedback_status, 0 ) < 3;',
'',
'    wwv_flow_json.    write( ''feedback'', l_count );',
'    ',
'    --',
'    ',
'     select count(*)',
'      into l_count',
'      from wwv_flow_issues',
'     where application_id            = :FB_FLOW_ID',
'       and page_id                   = c_page_id',
'       and security_group_id         = :WORKSPACE_ID',
'       and status = ''OPEN'';',
'',
'    wwv_flow_json.    write( ''issues'', l_count );',
'    ',
'    wwv_flow_json.write( ''todos'', 0 );',
'    wwv_flow_json.write( ''features'', 0 );',
'    wwv_flow_json.write( ''bugs'', 0 );',
'    ',
'',
'',
'    wwv_flow_json.close_all;',
'end;',
''))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>3038469684614561
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3038836814614562)
,p_process_sequence=>110
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'setPreference'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_property_dev.set_preference (',
'        p_preference_name   => wwv_flow.g_x01,',
'        p_preference_value  => wwv_flow.g_x02 );',
'end;        '))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>3038836814614562
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3036486524614560)
,p_process_sequence=>120
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'validateProperty'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_property_dev.validate_browser_property (',
'        p_application_id       => :FB_FLOW_ID,',
'        p_property_id          => wwv_flow.g_x01,',
'        p_property_type        => wwv_flow.g_x02,',
'        p_sql_min_column_count => wwv_flow.g_x03,',
'        p_sql_max_column_count => wwv_flow.g_x04,',
'        p_value                => wwv_flow.g_x05,',
'        p_location             => wwv_flow.g_x06,',
'        p_query_type           => wwv_flow.g_x07,',
'        p_owner                => wwv_flow.g_x08,',
'        p_object_name          => wwv_flow.g_x09,',
'        p_sql_query            => wwv_flow.g_x09,',
'        p_function_body        => wwv_flow.g_x09,',
'        p_web_source_query_id  => wwv_flow.g_x09,',
'        p_include_rowid_column => ( wwv_flow.g_x10 = ''Y'' ),',
'        p_optimizer_hint       => wwv_flow.g_x11,',
'        p_remote_database_id   => wwv_flow.g_x12,',
'        p_package_name         => wwv_flow.g_x13,',
'        p_custom_data_type     => wwv_flow.g_x14,',
'        p_match_clause         => wwv_flow.g_x15,',
'        p_columns_clause       => wwv_flow.g_x16 );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>3036486524614560
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3034448721614559)
,p_process_sequence=>150
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'writePageData'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_property_dev.write_data (',
'        p_application_id        => wwv_flow.g_x01,',
'        p_data                  => wwv_flow.g_f01,',
'        p_designer_type         => ''WORKFLOW'' );',
'    commit;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>3034448721614559
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1426015071957601)
,p_process_sequence=>160
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'isComponentInUse'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_property_dev.get_component_reference (',
'        p_application_id => wwv_flow.g_x01,',
'        p_component_type => wwv_flow.g_x02,',
'        p_component_id   => wwv_flow.g_x03 );',
'',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>1426015071957601
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4675795880208811)
,p_process_sequence=>170
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'getEmailPlaceholders'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_json.open_object;',
'    wwv_flow_json.write( ',
'        p_name          => ''placeholders'',',
'        p_values        =>  wwv_flow_template_dev.email_template_placeholders(',
'                                p_application_id    => :FB_FLOW_ID,',
'                                p_email_template_id => wwv_flow.g_x01 ),',
'        p_write_null    => true );',
'    wwv_flow_json.close_object;',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>4675795880208811
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1709338767953201)
,p_process_sequence=>180
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'getPages'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    wwv_flow_property_dev.emit_pages (',
'        p_application_id => :FB_FLOW_ID,',
'        p_include_global => wwv_flow.g_x01 = ''Y'',',
'        p_filter_type    => wwv_flow.g_x02,',
'        p_filter_id      => wwv_flow.g_x03 );',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>1709338767953201
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1415889587864001)
,p_process_sequence=>190
,p_process_point=>'ON_DEMAND'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'getWorkflowDiagramConfig'
,p_process_sql_clob=>'sys.htp.p( ''{"config":'' || wwv_flow_workflow.get_workflow_diagram_config().stringify || ''}'' );'
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>1415889587864001
);
end;
/
prompt --application/pages/page_09601
begin
wwv_flow_imp_page.create_page(
 p_id=>9601
,p_name=>'Workflows'
,p_alias=>'WORKFLOWS'
,p_step_title=>'Workflows'
,p_warn_on_unsaved_changes=>'N'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7715719444378463)
,p_plug_name=>'Workflows Report'
,p_region_name=>'Workflows Report'
,p_region_template_options=>'#DEFAULT#:a-IRR-region--noOuterBorders'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select w.id,',
'       w.flow_id,',
'       w.name,',
'       wwv_flow_utilities.prepare_url(''f?p=4000:9600:''||:flow_session||''::NO:1:FB_FLOW_ID,F4000_P1_FLOW:''||:FB_FLOW_ID||'',''||:FB_FLOW_ID||''#8800:''||w.id )',
'       as workflow_url,',
'       w.static_id,',
'       w.title,',
'       w.workflow_comment,',
'       w.last_updated_by,',
'       w.last_updated_on,',
'       (select count(v.ID) ',
'          from wwv_flow_workflow_versions v ',
'         where v.workflow_id=w.id',
'           and v.security_group_id = w.security_group_id',
'           and v.state = ''ACTIVE'') active_version_count,',
'       (select count(v.id) ',
'          from wwv_flow_workflow_versions v ',
'         where v.workflow_id=w.id',
'           and v.security_group_id = w.security_group_id',
'           and v.state = ''DEVELOPMENT'') dev_version_count,',
'       (select count(v.id) ',
'          from wwv_flow_workflow_versions v ',
'         where v.workflow_id=w.id',
'           and v.security_group_id = w.security_group_id',
'           and v.state = ''INACTIVE'') inactive_version_count,',
'       (select count(p.id) ',
'          from wwv_flow_workflow_variables p',
'         where p.workflow_id=w.id ',
'           and p.security_group_id = w.security_group_id',
'           and p.direction = ''IN'') params_count',
' from wwv_flow_workflows w ',
'where w.flow_id = :FB_FLOW_ID ',
'  and w.security_group_id = :WORKSPACE_ID'))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Automations Report '
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(7716039542378463)
,p_name=>'Report 1'
,p_no_data_found_message=>'No workflows found.'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'MARC'
,p_internal_uid=>7716039542378463
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3383733504227146)
,p_db_column_name=>'NAME'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Name'
,p_column_link=>'#WORKFLOW_URL#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3384094909227147)
,p_db_column_name=>'STATIC_ID'
,p_display_order=>5
,p_column_identifier=>'E'
,p_column_label=>'Static ID'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3382495573227137)
,p_db_column_name=>'ID'
,p_display_order=>23
,p_column_identifier=>'A'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3382895410227144)
,p_db_column_name=>'FLOW_ID'
,p_display_order=>33
,p_column_identifier=>'B'
,p_column_label=>'Flow Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4404018675824721)
,p_db_column_name=>'TITLE'
,p_display_order=>43
,p_column_identifier=>'AK'
,p_column_label=>'Title'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3388861388227155)
,p_db_column_name=>'LAST_UPDATED_BY'
,p_display_order=>53
,p_column_identifier=>'AA'
,p_column_label=>'Last Updated By'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3389329398227156)
,p_db_column_name=>'LAST_UPDATED_ON'
,p_display_order=>63
,p_column_identifier=>'AB'
,p_column_label=>'Last Updated On'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(10284681077038619)
,p_db_column_name=>'PARAMS_COUNT'
,p_display_order=>73
,p_column_identifier=>'AH'
,p_column_label=>'Parameters'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4404294532824723)
,p_db_column_name=>'ACTIVE_VERSION_COUNT'
,p_display_order=>103
,p_column_identifier=>'AM'
,p_column_label=>'Active Versions'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4404387313824724)
,p_db_column_name=>'DEV_VERSION_COUNT'
,p_display_order=>113
,p_column_identifier=>'AN'
,p_column_label=>'In Development Versions'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4404454186824725)
,p_db_column_name=>'INACTIVE_VERSION_COUNT'
,p_display_order=>123
,p_column_identifier=>'AO'
,p_column_label=>'Inactive Versions'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4404117223824722)
,p_db_column_name=>'WORKFLOW_COMMENT'
,p_display_order=>133
,p_column_identifier=>'AL'
,p_column_label=>'Workflow Comment'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4404729251824728)
,p_db_column_name=>'WORKFLOW_URL'
,p_display_order=>143
,p_column_identifier=>'AP'
,p_column_label=>'Workflow Url'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(7733154735379505)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'25507'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'NAME:TITLE:PARAMS_COUNT:ACTIVE_VERSION_COUNT:DEV_VERSION_COUNT:INACTIVE_VERSION_COUNT:LAST_UPDATED_BY:LAST_UPDATED_ON:WORKFLOW_COMMENT:'
,p_sort_column_1=>'POLLING_NEXT_RUN_TIMESTAMP'
,p_sort_direction_1=>'ASC NULLS LAST'
,p_sort_column_2=>'0'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8083390727259891)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_imp.id(1518491468091534)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(8083511383259892)
,p_plug_name=>'Workflows'
,p_region_name=>'Workflows'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--sideRegion:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>',
'A workflow represents the automation of a business process, in whole or part, during which documents, information or tasks are passed from ',
'one participant to another for action, according to a set of procedural rules, for example, sequence flows or transition conditions.',
'</p>',
'<p>',
'Workflow Definitions contain the versions and, parameters for the execution of a workflow instance.',
'</p>',
'<p><a target="_blank" href="&SYSTEM_HELP_URL.">Learn More ...</a></p>'))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_report_region(
 p_id=>wwv_flow_imp.id(8083608722259893)
,p_name=>'Recently Edited'
,p_template=>wwv_flow_imp.id(174794400314076650)
,p_display_sequence=>60
,p_include_in_reg_disp_sel_yn=>'Y'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding:a-Region--sideRegion'
,p_component_template_options=>'#DEFAULT#'
,p_display_point=>'REGION_POSITION_03'
,p_item_display_point=>'BELOW'
,p_source_type=>'NATIVE_SQL_REPORT'
,p_query_type=>'SQL'
,p_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select /* APEX 4000P9601b */ ',
'        replace(replace(name,''_'','' ''),''.'','' '') name, ',
'        wwv_flow_utilities.prepare_url(''f?p=4000:9600:''||:flow_session||''::NO:1:FB_FLOW_ID,F4000_P1_FLOW:''||:FB_FLOW_ID||'',''||:FB_FLOW_ID||''#8800:''||id )',
'       as workflow_url',
'  from  wwv_flow_workflows',
' where  flow_id = :fb_flow_id',
'   and  last_updated_on is not null',
'   and  security_group_id = :flow_security_group_id',
' order  by last_updated_on desc'))
,p_display_when_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select 1',
'  from wwv_flow_workflows ',
' where flow_id = :fb_flow_id',
'   and last_updated_on is not null',
'   and security_group_id = :flow_security_group_id'))
,p_display_condition_type=>'EXISTS'
,p_ajax_enabled=>'Y'
,p_lazy_loading=>false
,p_query_row_template=>wwv_flow_imp.id(11667910335347890)
,p_query_num_rows=>15
,p_query_options=>'DERIVED_REPORT_COLUMNS'
,p_csv_output=>'N'
,p_prn_output=>'N'
,p_sort_null=>'L'
,p_plug_query_strip_html=>'N'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(1492723151971779)
,p_query_column_id=>1
,p_column_alias=>'NAME'
,p_column_display_sequence=>1
,p_column_heading=>'Name'
,p_use_as_row_header=>'N'
,p_column_link=>'#WORKFLOW_URL#'
,p_column_linktext=>'#NAME#'
,p_derived_column=>'N'
,p_include_in_export=>'Y'
);
wwv_flow_imp_page.create_report_columns(
 p_id=>wwv_flow_imp.id(4404828986824729)
,p_query_column_id=>2
,p_column_alias=>'WORKFLOW_URL'
,p_column_display_sequence=>11
,p_use_as_row_header=>'N'
,p_hidden_column=>'Y'
,p_derived_column=>'N'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(1490822371971776)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(7715719444378463)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:9600:&SESSION.:newWorkflow:&DEBUG.:9600::'
);
end;
/
prompt --application/pages/page_09602
begin
wwv_flow_imp_page.create_page(
 p_id=>9602
,p_name=>'Workflow History'
,p_alias=>'WORKFLOW-HISTORY'
,p_step_title=>'Workflow History'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(6434677440390019)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.a object_type,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from sys.dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from sys.dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from sys.dual) u,',
'  (select wwv_flow_lang.system_message(''WORKFLOW'') a from sys.dual) t',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_WORKFLOWS''',
'union',
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.a object_type,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from sys.dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from sys.dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from sys.dual) u,',
'  (select wwv_flow_lang.system_message(''WORKFLOW_VERSION'') a from sys.dual) t',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_WORKFLOW_VERSIONS''',
'union  ',
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.a object_type,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from sys.dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from sys.dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from sys.dual) u,',
'  (select wwv_flow_lang.system_message(''WORKFLOW_PARAMETERS'') a from sys.dual) t',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_WORKFLOW_VARIABLES''',
'union',
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.a object_type,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from sys.dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from sys.dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from sys.dual) u,',
'  (select wwv_flow_lang.system_message(''WORKFLOW_PARTICIPANTS'') a from sys.dual) t',
'where  ',
'  t.flow_ID = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table = ''WWV_FLOW_WORKFLOW_PARTICIPANTS''  '))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'History'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(6434766456390020)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'No history information found.'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'ADMIN'
,p_internal_uid=>6434766456390020
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3330870548240219)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3331308285240224)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Audit Date'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3331686030240225)
,p_db_column_name=>'ACTION'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3333249214240229)
,p_db_column_name=>'OBJECT_TYPE'
,p_display_order=>70
,p_column_identifier=>'G'
,p_column_label=>'Object Type'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(1387977807801823)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3333644875240230)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>80
,p_column_identifier=>'H'
,p_column_label=>'Component Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3332107167240226)
,p_db_column_name=>'SCN'
,p_display_order=>90
,p_column_identifier=>'D'
,p_column_label=>'Scn'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3332488499240226)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>100
,p_column_identifier=>'E'
,p_column_label=>'Audit Comment'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3332851199240227)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>110
,p_column_identifier=>'F'
,p_column_label=>'Component Key'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(8350686333298362)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'50204'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'AUDIT_DATE:ACTION:DEVELOPER:OBJECT_TYPE:COMPONENT_NAME:'
,p_sort_column_1=>'AUDIT_DATE'
,p_sort_direction_1=>'DESC NULLS LAST'
,p_sort_column_2=>'0'
,p_sort_direction_2=>'ASC'
,p_sort_column_3=>'0'
,p_sort_direction_3=>'ASC'
,p_sort_column_4=>'0'
,p_sort_direction_4=>'ASC'
,p_sort_column_5=>'0'
,p_sort_direction_5=>'ASC'
,p_sort_column_6=>'0'
,p_sort_direction_6=>'ASC'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(16009386454346211)
,p_plug_name=>'Navigate'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_imp.id(1518491468091534)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(33225981094228025)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#:a-Region--noTopBorder:a-Region--paddedBody:a-Region--noBorder'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>'This page displays recent modifications made to Workflows in this application.'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
end;
/
prompt --application/pages/page_09603
begin
wwv_flow_imp_page.create_page(
 p_id=>9603
,p_name=>'Utilization'
,p_alias=>'UTILIZATION3'
,p_step_title=>'Utilization'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213240607818867991)
,p_step_template=>wwv_flow_imp.id(386677207130845076)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(7407541970340353)
,p_plug_name=>'Utilization'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select  ',
'     w.id                    workflow_id,',
'     wwv_flow_utilities.prepare_url(''f?p=4000:4500:''||:flow_session||''::::FB_FLOW_PAGE_ID:''||p.id) ',
'                             the_url,',
'     p.id                    page_id, ',
'     p.name                  page_name, ',
'     wwv_flow_lang.system_message(''PAGE PROCESS'') ',
'                             process_type,',
'     pr.process_name         process_name,',
'     w.name                  workflow_name,',
'     wwv_flow_utilities.prepare_url(''f?p=4000:9600:''||:flow_session||''::NO:1:FB_FLOW_ID,F4000_P1_FLOW:''||:FB_FLOW_ID||'',''||:FB_FLOW_ID||''#8800:''||w.id )',
'                             workflow_url',
' from wwv_flow_steps           p,',
'      wwv_flow_step_processing pr,',
'      wwv_flow_workflows       w',
'where w.flow_id           = p.flow_id',
'  and w.security_group_id = p.security_group_id',
'   --',
'  and p.flow_id           = pr.flow_id',
'  and p.security_group_id = pr.security_group_id',
'  and p.id                = pr.flow_step_id',
'   --',
'   -- for translated applications, ATTRIBUTE_02 contains a VARCHAR2 with decimal character,',
'   -- and that character might be different from the current session NLS settings. So we need',
'   -- to normalize this.',
'  and w.id                = to_number( replace( replace( pr.attribute_02, '','', ''.'' ), ''.'', wwv_flow.get_nls_decimal_separator ) )',
'  and pr.process_type     = ''NATIVE_WORKFLOW''',
'  and pr.attribute_01     = ''START''',
'   --',
'  and w.security_group_id = :FLOW_SECURITY_GROUP_ID',
'  and w.flow_id           = :FB_FLOW_ID',
''))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>11
,p_prn_height=>8.5
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header=>'Utilization'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#EEEEEE'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'bold'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#FFFFFF'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
,p_prn_border_color=>'#666666'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(6710890305725232)
,p_max_row_count=>'1000000'
,p_no_data_found_message=>'No Workflow utilizations found.'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_pivot=>'N'
,p_show_flashback=>'N'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'ADMIN'
,p_internal_uid=>6710890305725232
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4305420448899966)
,p_db_column_name=>'THE_URL'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'The Url'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4305761809899967)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>40
,p_column_identifier=>'C'
,p_column_label=>'Page'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4306154761899967)
,p_db_column_name=>'PAGE_NAME'
,p_display_order=>50
,p_column_identifier=>'D'
,p_column_label=>'Page Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4306548055899968)
,p_db_column_name=>'PROCESS_TYPE'
,p_display_order=>60
,p_column_identifier=>'E'
,p_column_label=>'Component Type'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4307007566899970)
,p_db_column_name=>'PROCESS_NAME'
,p_display_order=>70
,p_column_identifier=>'F'
,p_column_label=>'Component Name'
,p_column_link=>'#THE_URL#'
,p_column_linktext=>'#PROCESS_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4404538469824726)
,p_db_column_name=>'WORKFLOW_ID'
,p_display_order=>80
,p_column_identifier=>'J'
,p_column_label=>'Workflow Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4404654413824727)
,p_db_column_name=>'WORKFLOW_NAME'
,p_display_order=>90
,p_column_identifier=>'K'
,p_column_label=>'Workflow Name'
,p_column_link=>'#WORKFLOW_URL#'
,p_column_linktext=>'#WORKFLOW_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4404965776824730)
,p_db_column_name=>'WORKFLOW_URL'
,p_display_order=>100
,p_column_identifier=>'L'
,p_column_label=>'Workflow Url'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(7412489884934787)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'33018'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'PROCESS_TYPE:PROCESS_NAME:PAGE_ID:PAGE_NAME::WORKFLOW_ID:WORKFLOW_NAME:WORKFLOW_URL'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(489300728273356336)
,p_plug_name=>'Utilization'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>This page displays where <strong>Workflows</strong> are being used within the application.',
'</p>',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(489300927466356337)
,p_plug_name=>'tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_imp.id(1518491468091534)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
);
end;
/
prompt --application/pages/page_09800
begin
wwv_flow_imp_page.create_page(
 p_id=>9800
,p_name=>'Generative AI Services'
,p_alias=>'GENERATIVE-AI-SERVICES'
,p_step_title=>'Generative AI Services'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3401382348525813)
,p_plug_name=>'Generative AI Services'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ais.id,',
'       ais.name,',
'       ais.static_id,',
'       ais.ai_provider_type,',
'       ais.ai_is_builder_service,',
'       ais.base_url',
'  from wwv_remote_servers ais',
' where security_group_id = :WORKSPACE_ID',
'   and server_type       = ''GENERATIVE_AI'''))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_page_header=>'Generative AI Services'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(3401447582525813)
,p_name=>'Generative AI Services'
,p_no_data_found_message=>'No AI Services configured in this workspace.'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'CSV:HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'ADMIN'
,p_internal_uid=>3401447582525813
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3402105909525820)
,p_db_column_name=>'ID'
,p_display_order=>1
,p_column_identifier=>'A'
,p_column_label=>'ID'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3402513656525822)
,p_db_column_name=>'NAME'
,p_display_order=>2
,p_column_identifier=>'B'
,p_column_label=>'Name'
,p_column_link=>'f?p=&APP_ID.:9801:&SESSION.::&DEBUG.::P9801_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3402981770525822)
,p_db_column_name=>'STATIC_ID'
,p_display_order=>3
,p_column_identifier=>'C'
,p_column_label=>'Static ID'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3403349163525822)
,p_db_column_name=>'AI_PROVIDER_TYPE'
,p_display_order=>4
,p_column_identifier=>'D'
,p_column_label=>'Provider Type'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(3600433605650143)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1616394538727104)
,p_db_column_name=>'AI_IS_BUILDER_SERVICE'
,p_display_order=>14
,p_column_identifier=>'G'
,p_column_label=>'Used by App Builder'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(84887415298521126)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(3404169267525823)
,p_db_column_name=>'BASE_URL'
,p_display_order=>24
,p_column_identifier=>'F'
,p_column_label=>'Base URL'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(3407798782570138)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'34078'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'ID:NAME:STATIC_ID:AI_PROVIDER_TYPE:BASE_URL:AI_IS_BUILDER_SERVICE'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(163224799729053460)
,p_plug_name=>'tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_imp.id(2400998349683334)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(228259524730656176)
,p_plug_name=>'Generative AI Services'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>30
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Generative AI Service information is stored as a <strong>Generative AI</strong> object. Generative AI Services offer an abstraction to popular ',
' commercial Generative AI products like Open AI, Cohere and others. The <code>APEX_AI</code> public API refers Generative AI Services configured here.</p>',
'<p>Generative AI Services are stored at the workspace level and therefore are visible in all applications. When you export an application, used Generative AI Services are added to the export file. When you import the application into another workspac'
||'e, &PRODUCT_NAME. checks whether the target workspace already contains Generative AI Services with the same <strong>static ID</strong>. If a Generative AI Service already exists, the application uses it. Otherwise the Generative AI Services from the '
||'import file are created in the target workspace.</p>'))
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(715109030894818867)
,p_plug_name=>'Learn More'
,p_region_template_options=>'#DEFAULT#'
,p_region_attributes=>'style="padding: 0 12px 12px 12px;"'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>40
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_item_display_point=>'BELOW'
,p_plug_source=>'sys.htp.p(''<p><a href="&SYSTEM_HELP_URL." rel="noopener noreferrer" target="_blank">''||wwv_flow_lang.system_message(''LEARN MORE'')||'' ...</a></p>'');'
,p_plug_source_type=>'NATIVE_PLSQL'
,p_plug_display_condition_type=>'EXPRESSION'
,p_plug_display_when_condition=>'nvl(#OWNER#.wwv_flow_preferences.get_preference(''FP_PREF_SHOW_INFORMATION''),''YES'') = ''YES'''
,p_plug_display_when_cond2=>'PLSQL'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(2200229200704990)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(3401382348525813)
,p_button_name=>'CREATE'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(651364628215578370)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'RIGHT_OF_IR_SEARCH_BAR'
,p_button_redirect_url=>'f?p=&APP_ID.:9801:&SESSION.::&DEBUG.:9801::'
,p_icon_css_classes=>'icon-right-chevron'
);
end;
/
prompt --application/pages/page_09801
begin
wwv_flow_imp_page.create_page(
 p_id=>9801
,p_name=>'Generative AI Details'
,p_alias=>'GENERATIVE-AI-DETAILS'
,p_step_title=>'Generative AI Details'
,p_autocomplete_on_off=>'OFF'
,p_page_template_options=>'#DEFAULT#'
,p_protection_level=>'C'
,p_page_component_map=>'02'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1801614952232008)
,p_plug_name=>'Generative AI Service'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>80
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'The Name and Static ID must be <strong>unique</strong> within the workspace. The developer can select from a list of supported AI Services and specify if the AI Service should be used by App Builder. Only <strong>one</strong> AI Service can be config'
||'ured for App Builder. Advanced properties including additional HTTP headers and JSON attributes can be configured.</li>',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1957406633376301)
,p_plug_name=>'Region Display Selector'
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(5938210987232439)
,p_plug_display_sequence=>40
,p_plug_source_type=>'NATIVE_DISPLAY_SELECTOR'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'display_region_icons', 'N',
  'include_show_all', 'Y',
  'rds_mode', 'STANDARD',
  'remember_selection', 'USER')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1957527983376302)
,p_plug_name=>'Advanced'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>100
,p_include_in_reg_disp_sel_yn=>'Y'
,p_location=>null
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4373786736092306)
,p_plug_name=>'Additional Attributes'
,p_parent_plug_id=>wwv_flow_imp.id(1957527983376302)
,p_region_template_options=>'#DEFAULT#:js-dialog-size720x480'
,p_plug_template=>wwv_flow_imp.id(557449278618308550)
,p_plug_display_sequence=>20
,p_location=>null
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4374571109092314)
,p_plug_name=>'Info'
,p_parent_plug_id=>wwv_flow_imp.id(4373786736092306)
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody:a-Region--noBorder:a-Region--accessibleHeader'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_plug_display_point=>'SUB_REGIONS'
,p_location=>null
,p_plug_source=>'<p>Include additional attributes that will be added to the JSON request payload as part of performing a Generative AI Service operation.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(4374631951092315)
,p_plug_name=>'Item'
,p_parent_plug_id=>wwv_flow_imp.id(4373786736092306)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>20
,p_plug_display_point=>'SUB_REGIONS'
,p_location=>null
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2370835924845501)
,p_plug_name=>'Credentials'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>90
,p_location=>null
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2371415445845507)
,p_plug_name=>'API Key Credentials'
,p_parent_plug_id=>wwv_flow_imp.id(2370835924845501)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>130
,p_location=>null
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(2371581038845508)
,p_plug_name=>'OCI Credentials'
,p_parent_plug_id=>wwv_flow_imp.id(2370835924845501)
,p_region_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>140
,p_location=>null
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3011863444977914)
,p_plug_name=>'Settings'
,p_title=>'Settings'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>70
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'TABLE'
,p_query_table=>'WWV_REMOTE_SERVERS'
,p_query_where=>wwv_flow_string.join(wwv_flow_t_varchar2(
'security_group_id = :WORKSPACE_ID',
'',
''))
,p_include_rowid_column=>false
,p_is_editable=>false
,p_plug_source_type=>'NATIVE_FORM'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(3574907901259601)
,p_plug_name=>'OCI Generative AI'
,p_region_template_options=>'#DEFAULT#:a-Region--noPadding'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>60
,p_location=>null
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9045440620038634)
,p_plug_name=>'Identification'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>50
,p_include_in_reg_disp_sel_yn=>'Y'
,p_location=>null
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(9051748460086928)
,p_plug_name=>'Generative AI Service &P9801_NAME.'
,p_region_template_options=>'#DEFAULT#:a-ButtonRegion--withItems:a-ButtonRegion--noBorder:a-ButtonRegion--showTitle'
,p_plug_template=>wwv_flow_imp.id(689274781922315777)
,p_plug_display_sequence=>30
,p_plug_item_display_point=>'BELOW'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4374280903092311)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(4373786736092306)
,p_button_name=>'Close'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Close Dialog'
,p_button_position=>'CLOSE'
,p_button_execute_validations=>'N'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3248838068301101)
,p_button_sequence=>10
,p_button_plug_id=>wwv_flow_imp.id(9051748460086928)
,p_button_name=>'CANCEL'
,p_button_action=>'REDIRECT_PAGE'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Cancel'
,p_button_position=>'NEXT'
,p_button_redirect_url=>'f?p=&APP_ID.:9800:&SESSION.::&DEBUG.:::'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3249256613301102)
,p_button_sequence=>20
,p_button_plug_id=>wwv_flow_imp.id(9051748460086928)
,p_button_name=>'DELETE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Delete'
,p_button_position=>'NEXT'
,p_confirm_message=>'&APP_TEXT$DELETE_MSG!RAW.'
,p_confirm_style=>'danger'
,p_button_condition=>'P9801_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'DELETE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3249681282301103)
,p_button_sequence=>30
,p_button_plug_id=>wwv_flow_imp.id(9051748460086928)
,p_button_name=>'SAVE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Apply Changes'
,p_button_position=>'NEXT'
,p_button_condition=>'P9801_ID'
,p_button_condition_type=>'ITEM_IS_NOT_NULL'
,p_database_action=>'UPDATE'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(3250090732301103)
,p_button_sequence=>40
,p_button_plug_id=>wwv_flow_imp.id(9051748460086928)
,p_button_name=>'CREATE'
,p_button_action=>'SUBMIT'
,p_button_template_options=>'#DEFAULT#'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_is_hot=>'Y'
,p_button_image_alt=>'Create'
,p_button_position=>'NEXT'
,p_button_condition=>'P9801_ID'
,p_button_condition_type=>'ITEM_IS_NULL'
,p_database_action=>'INSERT'
);
wwv_flow_imp_page.create_page_button(
 p_id=>wwv_flow_imp.id(4373860287092307)
,p_button_sequence=>60
,p_button_plug_id=>wwv_flow_imp.id(1957527983376302)
,p_button_name=>'Attributes'
,p_button_action=>'DEFINED_BY_DA'
,p_button_template_options=>'#DEFAULT#:a-Button--primary'
,p_button_template_id=>wwv_flow_imp.id(183227826797404355)
,p_button_image_alt=>'Additional Attributes'
,p_button_position=>'NEXT'
,p_warn_on_unsaved_changes=>null
);
wwv_flow_imp_page.create_page_branch(
 p_id=>wwv_flow_imp.id(1411156294331401)
,p_branch_name=>'Go to Page 9800'
,p_branch_action=>'f?p=&APP_ID.:9800:&SESSION.::&DEBUG.:9801::&success_msg=#SUCCESS_MSG#'
,p_branch_point=>'AFTER_PROCESSING'
,p_branch_type=>'REDIRECT_URL'
,p_branch_sequence=>10
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2001134026749011)
,p_name=>'P9801_AI_IS_BUILDER_SERVICE'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3011863444977914)
,p_item_source_plug_id=>wwv_flow_imp.id(3011863444977914)
,p_item_default=>'N'
,p_prompt=>'Used by App Builder'
,p_source=>'AI_IS_BUILDER_SERVICE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_YES_NO'
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'<p>Indicates whether this Generative AI Service will be used by App Builder.</p>'
,p_attribute_01=>'N'
,p_attribute_02=>'Y'
,p_attribute_03=>'Yes'
,p_attribute_04=>'N'
,p_attribute_05=>'No'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2370941537845502)
,p_name=>'P9801_API_KEY'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2371415445845507)
,p_prompt=>'API Key'
,p_display_as=>'NATIVE_PASSWORD'
,p_cSize=>80
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Enter the <em>API Key</em> to authenticate against the AI Provider.</p>'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2371050352845503)
,p_name=>'P9801_OCI_USER_ID'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(2371581038845508)
,p_prompt=>'OCI User ID'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Enter the Oracle Cloud Infrastructure <em>User OCID</em>. &PRODUCT_NAME. does not store this information encrypted.</p> <p><a rel="noopener noreferrer" target="_blank" href="https://docs.cloud.oracle.com/iaas/Content/API/Concepts/apisigningkey.htm'
||'">Oracle Cloud Infrastructure Documentation</a></p>'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2371179647845504)
,p_name=>'P9801_OCI_PRIVATE_KEY'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(2371581038845508)
,p_prompt=>'OCI Private Key'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>80
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Enter the private key in PEM format for OCI authentication. &PRODUCT_NAME. stores this information encrypted and secure, so it cannot be retrieved back in clear text.</p><p><a rel="noopener noreferrer" target="_blank" href="https://docs.cloud.orac'
||'le.com/iaas/Content/API/Concepts/apisigningkey.htm">Oracle Cloud Infrastructure Documentation</a></p>'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2371201694845505)
,p_name=>'P9801_OCI_TENANCY_ID'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(2371581038845508)
,p_prompt=>'OCI Tenancy ID'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Enter the Oracle Cloud Infrastructure <em>Tenancy''s OCID</em>.</p>',
'<p><a rel="noopener noreferrer" target="_blank" href="https://docs.cloud.oracle.com/iaas/Content/API/Concepts/apisigningkey.htm">Oracle Cloud Infrastructure Documentation</a></p>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2371373252845506)
,p_name=>'P9801_OCI_FINGERPRINT'
,p_item_sequence=>60
,p_item_plug_id=>wwv_flow_imp.id(2371581038845508)
,p_prompt=>'OCI Public Key Fingerprint'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'<p>Enter the <em>public RSA key fingerprint</em> for OCI authentication. </p><p><a rel="noopener noreferrer" target="_blank" href="https://docs.cloud.oracle.com/iaas/Content/API/Concepts/apisigningkey.htm">Oracle Cloud Infrastructure Documentation</a'
||'></p>'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2382814586262601)
,p_name=>'P9801_OCI_CREDENTIAL_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2371581038845508)
,p_prompt=>'Credential'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select static_id, id',
'  from wwv_credentials',
' where security_group_id   = :WORKSPACE_ID',
'   and authentication_type = ''OCI''',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Create New -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The <strong>Web Credential</strong> to use for this Generative AI Service.</p>',
'<p>Customers are supposed to sign-up for or use existing credentials of their respective AI provider.</p>',
''))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2382926583262602)
,p_name=>'P9801_CREDENTIAL_ID'
,p_source_data_type=>'NUMBER'
,p_item_sequence=>150
,p_item_plug_id=>wwv_flow_imp.id(2370835924845501)
,p_item_source_plug_id=>wwv_flow_imp.id(3011863444977914)
,p_source=>'CREDENTIAL_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2800220597719102)
,p_name=>'P9801_AI_MODEL_NAME'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(1957527983376302)
,p_item_source_plug_id=>wwv_flow_imp.id(3011863444977914)
,p_prompt=>'AI Model'
,p_source=>'AI_MODEL_NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'<p>An optional model name or ID for the Generative AI Service. If no model information is given, the default model of the respective AI provider will be used.</p>'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2800578593719105)
,p_name=>'P9801_AI_HTTP_HEADERS'
,p_data_type=>'CLOB'
,p_source_data_type=>'CLOB'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(1957527983376302)
,p_item_source_plug_id=>wwv_flow_imp.id(3011863444977914)
,p_prompt=>'HTTP Headers'
,p_source=>'AI_HTTP_HEADERS'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>67
,p_cHeight=>4
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Additional HTTP headers used in the Generative AI Service (REST) request.</p>',
'<p>HTTP headers are specified in the following format:</p>',
'<pre><code>',
'name_1=value_1',
'name_2=value_2',
'</code></pre>'))
,p_attribute_01=>'Y'
,p_attribute_02=>'Y'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(2800624044719106)
,p_name=>'P9801_AI_ATTRIBUTES'
,p_data_type=>'CLOB'
,p_source_data_type=>'CLOB'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(4374631951092315)
,p_item_source_plug_id=>wwv_flow_imp.id(3011863444977914)
,p_prompt=>'JSON Attributes'
,p_source=>'AI_ATTRIBUTES'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'PLUGIN_COM.ORACLE.APEX.CODE_EDITOR'
,p_cSize=>70
,p_cHeight=>10
,p_field_template=>wwv_flow_imp.id(561549638722251517)
,p_item_template_options=>'#DEFAULT#:a-Form-fieldContainer--stretch'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Include additional attributes that will be added to the JSON request payload as part of performing a Generative AI Service operation. The attributes must be specified in JSON format, and depend on the AI Service provider type. See the API document'
||'ation of the provider for more details.</p>',
'<p><strong>Example:</strong></p>',
'',
'<code>',
'    {',
'        "temperature" : 0.5',
'    }',
'</code>'))
,p_attribute_01=>'json'
,p_attribute_04=>'Y'
,p_attribute_07=>'N'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3047562453077039)
,p_name=>'P9801_BASE_URL'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(3011863444977914)
,p_item_source_plug_id=>wwv_flow_imp.id(3011863444977914)
,p_prompt=>'Base URL'
,p_source=>'BASE_URL'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The base URL of the Generative AI Service.</p>',
'<p>The base URL is typically the REST API endpoint for the specified Generative AI Provider. Please make sure the URL in the selected Web Credential is reflected in the base URL of the Generative AI Service.</p>'))
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3047644656077040)
,p_name=>'P9801_SERVER_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(3011863444977914)
,p_item_source_plug_id=>wwv_flow_imp.id(3011863444977914)
,p_source=>'SERVER_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3047728873077041)
,p_name=>'P9801_APIKEY_CREDENTIAL_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(2371415445845507)
,p_prompt=>'Credential'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_lov=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select static_id, id',
'  from wwv_credentials',
' where security_group_id   = :WORKSPACE_ID',
'   and authentication_type = ''HTTP_HEADER''',
' order by 1'))
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Create New -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_lov_display_extra=>'YES'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The <strong>Web Credential</strong> to use for this Generative AI Service.</p>',
'<p>Customers are supposed to sign-up for or use existing credentials of their respective AI provider.</p>',
''))
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3048002992077044)
,p_name=>'P9801_PROMPT_ON_INSTALL'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3011863444977914)
,p_item_source_plug_id=>wwv_flow_imp.id(3011863444977914)
,p_source=>'PROMPT_ON_INSTALL'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3200536136086505)
,p_name=>'P9801_SERVER_COMMENT'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>50
,p_item_plug_id=>wwv_flow_imp.id(1957527983376302)
,p_item_source_plug_id=>wwv_flow_imp.id(3011863444977914)
,p_prompt=>'Comments'
,p_source=>'SERVER_COMMENT'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXTAREA'
,p_cSize=>67
,p_cMaxlength=>4000
,p_cHeight=>5
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>'Enter any developer comments or notes here. These comments only display within App Builder and never display when running the application.'
,p_attribute_01=>'Y'
,p_attribute_02=>'N'
,p_attribute_03=>'N'
,p_attribute_04=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3201322362086513)
,p_name=>'P9801_AI_PROVIDER_TYPE'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(9045440620038634)
,p_item_source_plug_id=>wwv_flow_imp.id(3011863444977914)
,p_prompt=>'AI Provider'
,p_source=>'AI_PROVIDER_TYPE'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_SELECT_LIST'
,p_named_lov=>'GENAI_PROVIDERS'
,p_lov=>'.'||wwv_flow_imp.id(3600433605650143)||'.'
,p_lov_display_null=>'YES'
,p_lov_null_text=>'- Select -'
,p_cHeight=>1
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_lov_display_extra=>'YES'
,p_help_text=>'<p>The AI Provider to use for this Generative AI Service.</p>'
,p_attribute_01=>'NONE'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3575054982259602)
,p_name=>'P9801_OCI_COMPARTMENT_ID'
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(3574907901259601)
,p_prompt=>'Compartment ID'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The Oracle Cloud Infrastructure Compartment ID'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3575163960259603)
,p_name=>'P9801_OCI_REGION'
,p_is_required=>true
,p_item_sequence=>20
,p_item_plug_id=>wwv_flow_imp.id(3574907901259601)
,p_item_default=>'us-chicago-1'
,p_prompt=>'Region'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The Oracle Cloud Infrastructure Region. The default is us-chicago-1'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
,p_show_quick_picks=>'Y'
,p_quick_pick_label_01=>'US Midwest (Chicago)'
,p_quick_pick_value_01=>'us-chicago-1'
,p_quick_pick_label_02=>'US East (Ashburn)'
,p_quick_pick_value_02=>'us-ashburn-1'
,p_quick_pick_label_03=>'US West (Phoenix)'
,p_quick_pick_value_03=>'us-phoenix-1'
,p_quick_pick_label_04=>'Germany Central (Frankfurt)'
,p_quick_pick_value_04=>'eu-frankfurt-1'
,p_quick_pick_label_05=>'UK South (London)'
,p_quick_pick_value_05=>'uk-london-1'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(3575810718259610)
,p_name=>'P9801_OCI_MODEL_ID'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(3574907901259601)
,p_item_default=>'cohere.command'
,p_prompt=>'Model ID'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_help_text=>'The OCI Generative AI Model ID.'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6177081344644105)
,p_name=>'P9801_ID'
,p_source_data_type=>'NUMBER'
,p_is_primary_key=>true
,p_item_sequence=>10
,p_item_plug_id=>wwv_flow_imp.id(9045440620038634)
,p_item_source_plug_id=>wwv_flow_imp.id(3011863444977914)
,p_source=>'ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_HIDDEN'
,p_is_persistent=>'N'
,p_protection_level=>'S'
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'Y'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6178304789644106)
,p_name=>'P9801_NAME'
,p_source_data_type=>'VARCHAR2'
,p_is_required=>true
,p_item_sequence=>30
,p_item_plug_id=>wwv_flow_imp.id(9045440620038634)
,p_item_source_plug_id=>wwv_flow_imp.id(3011863444977914)
,p_prompt=>'Name'
,p_source=>'NAME'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(452656722938220607)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The name of the Generative AI Service. The name will be shown in the Generative AI  Services overview page.</p>',
'<p><strong>Example:</strong> HCM Open AI Service</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_item(
 p_id=>wwv_flow_imp.id(6179245259644107)
,p_name=>'P9801_STATIC_ID'
,p_source_data_type=>'VARCHAR2'
,p_item_sequence=>40
,p_item_plug_id=>wwv_flow_imp.id(9045440620038634)
,p_item_source_plug_id=>wwv_flow_imp.id(3011863444977914)
,p_prompt=>'Static ID'
,p_source=>'STATIC_ID'
,p_source_type=>'REGION_SOURCE_COLUMN'
,p_display_as=>'NATIVE_TEXT_FIELD'
,p_cSize=>80
,p_cMaxlength=>255
,p_field_template=>wwv_flow_imp.id(561547836135222071)
,p_item_template_options=>'#DEFAULT#'
,p_is_persistent=>'N'
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>The Static ID for the Generative AI Service. The static ID is used when using the service with the <code>APEX_AI</code> package (<code>APEX_AI.CHAT</code>).</p>',
'<p><strong>Example:</strong> HCM_OPENAI</p>'))
,p_encrypt_session_state_yn=>'N'
,p_attribute_01=>'N'
,p_attribute_02=>'N'
,p_attribute_04=>'TEXT'
,p_attribute_05=>'BOTH'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1411235335331402)
,p_validation_name=>'Name must be unique'
,p_validation_sequence=>10
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'  from wwv_remote_servers',
' where name = :P9801_NAME',
'   and security_group_id  = :FLOW_SECURITY_GROUP_ID',
'   and ( id              != :P9801_ID or :P9801_ID is null )'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Generative AI Service name must be unique'
,p_validation_condition=>'CREATE,SAVE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(6178304789644106)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1411317945331403)
,p_validation_name=>'Static ID must be unique'
,p_validation_sequence=>20
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select id',
'  from wwv_remote_servers',
' where static_id = :P9801_STATIC_ID',
'   and security_group_id = :FLOW_SECURITY_GROUP_ID',
'   and ( id              != :P9801_ID or :P9801_ID is null )'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Generative AI Service static ID must be unique'
,p_validation_condition=>'CREATE, SAVE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(6179245259644107)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1411441402331404)
,p_validation_name=>'Cannot delete used Generative AI Service'
,p_validation_sequence=>40
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select s.id',
'  from wwv_remote_servers s ',
' where s.security_group_id  = :FLOW_SECURITY_GROUP_ID',
'   and s.id                 = :P9801_ID',
'   and s.server_type        = ''GENERATIVE_AI''',
'   and (    exists ( select 1',
'                       from wwv_flows f',
'                      where f.ai_remote_server_id   = s.id',
'                        and f.security_group_id     = s.security_group_id )',
'         or exists ( select 1',
'                       from wwv_flow_page_plugs f',
'                      where f.ai_remote_server_id = s.id',
'                        and f.security_group_id      = s.security_group_id ) ',
'         or exists ( select 1',
'                       from wwv_flow_step_items f',
'                      where f.ai_remote_server_id = s.id',
'                        and f.security_group_id      = s.security_group_id ) )'))
,p_validation_type=>'NOT_EXISTS'
,p_error_message=>'Generative AI Service is in use and cannot be deleted.'
,p_when_button_pressed=>wwv_flow_imp.id(3249256613301102)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1411631855331406)
,p_validation_name=>'Only one default for App Builder on CREATE'
,p_validation_sequence=>50
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_count number;',
'begin',
'    select count(id)',
'      into l_count',
'      from wwv_remote_servers',
'     where ai_is_builder_service        = ''Y''',
'       and server_type                  = ''GENERATIVE_AI''',
'       and id                          != :P9801_ID',
'       and security_group_id            = :FLOW_SECURITY_GROUP_ID;',
'    ',
'    return (    ((l_count  = 0) and (:P9801_AI_IS_BUILDER_SERVICE = ''Y''))',
'             or ((l_count <= 1) and (:P9801_AI_IS_BUILDER_SERVICE = ''N'')));',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>'Only one Generative AI Service can be configured to be used by App Builder.'
,p_validation_condition=>':REQUEST in ( ''CREATE'', ''SAVE'' ) and :P9801_AI_IS_BUILDER_SERVICE = ''Y'''
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(2001134026749011)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1801850961232010)
,p_validation_name=>'Attributes null or valid JSON'
,p_validation_sequence=>60
,p_validation=>wwv_flow_string.join(wwv_flow_t_varchar2(
'declare',
'    l_json   sys.json_object_t;',
'begin',
'    if :P9801_AI_ATTRIBUTES is null or :P9801_AI_ATTRIBUTES = '''' then',
'        return true;',
'    else ',
'        l_json := sys.json_object_t.parse(:P9801_AI_ATTRIBUTES);',
'        return true;',
'    end if;',
'exception',
'    when others then',
'        return false;',
'end;'))
,p_validation2=>'PLSQL'
,p_validation_type=>'FUNC_BODY_RETURNING_BOOLEAN'
,p_error_message=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Additional Attributes is not valid JSON.',
'Click the <strong>Additional Attributes</strong> button and provide valid JSON.</p>'))
,p_validation_condition=>'CREATE, SAVE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(2800624044719106)
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1802428278232016)
,p_validation_name=>'Base URL must start with http or https'
,p_validation_sequence=>80
,p_validation=>'substr( :P9801_BASE_URL, 1, 8 ) = ''https://'' or substr( :P9801_BASE_URL, 1, 7 ) = ''http://'''
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'Base URL must start with http:// or https://'
,p_validation_condition=>'CREATE, SAVE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_associated_item=>wwv_flow_imp.id(3047562453077039)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(3576751817259619)
,p_validation_name=>'OCI Generative AI can''t be used for App Builder'
,p_validation_sequence=>90
,p_validation=>'not (:P9801_AI_IS_BUILDER_SERVICE = ''Y'' and :P9801_AI_PROVIDER_TYPE = ''OCI_GENAI'')'
,p_validation2=>'PLSQL'
,p_validation_type=>'EXPRESSION'
,p_error_message=>'OCI Generative AI cannot be used for App Builder.'
,p_validation_condition=>'CREATE, SAVE'
,p_validation_condition_type=>'REQUEST_IN_CONDITION'
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(4375098041092319)
,p_validation_name=>'Compartment ID is not null'
,p_validation_sequence=>100
,p_validation=>'P9801_OCI_COMPARTMENT_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'OCI Compartment ID must be provided when the AI Provider Type is OCI Generative AI.'
,p_validation_condition=>'P9801_AI_PROVIDER_TYPE'
,p_validation_condition2=>'OCI_GENAI'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(3575054982259602)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(1425841069854701)
,p_validation_name=>'AI Model must be provided for Open AI'
,p_validation_sequence=>110
,p_validation=>'P9801_AI_MODEL_NAME'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have some value.'
,p_validation_condition=>'P9801_AI_PROVIDER_TYPE'
,p_validation_condition2=>'OPENAI'
,p_validation_condition_type=>'VAL_OF_ITEM_IN_COND_EQ_COND2'
,p_associated_item=>wwv_flow_imp.id(2800220597719102)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2385018367262623)
,p_validation_name=>'OCI User ID required for new OCI credential'
,p_validation_sequence=>120
,p_validation=>'P9801_OCI_USER_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      :REQUEST                 in ( ''SAVE'',''CREATE'' )',
'  and :P9801_OCI_CREDENTIAL_ID is null',
'  and :P9801_AI_PROVIDER_TYPE   = ''OCI_GENAI'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(2371050352845503)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2385402625262627)
,p_validation_name=>'API Key required for new API Key Credential'
,p_validation_sequence=>130
,p_validation=>'P9801_API_KEY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      :REQUEST                    in ( ''SAVE'',''CREATE'' )',
'  and :P9801_APIKEY_CREDENTIAL_ID is null',
'  and :P9801_AI_PROVIDER_TYPE     in ( ''OPENAI'', ''COHERE'' )'))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(2370941537845502)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2385271690262625)
,p_validation_name=>'OCI Tenancy ID required for new OCI credential'
,p_validation_sequence=>140
,p_validation=>'P9801_OCI_TENANCY_ID'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      :REQUEST                 in ( ''SAVE'',''CREATE'' )',
'  and :P9801_OCI_CREDENTIAL_ID is null',
'  and :P9801_AI_PROVIDER_TYPE   = ''OCI_GENAI'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(2371201694845505)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2385383933262626)
,p_validation_name=>'OCI Fingerprint required for new OCI credential'
,p_validation_sequence=>150
,p_validation=>'P9801_OCI_FINGERPRINT'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      :REQUEST                 in ( ''SAVE'',''CREATE'' )',
'  and :P9801_OCI_CREDENTIAL_ID is null',
'  and :P9801_AI_PROVIDER_TYPE   = ''OCI_GENAI'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(2371373252845506)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_validation(
 p_id=>wwv_flow_imp.id(2385151086262624)
,p_validation_name=>'OCI Private Key required for new OCI credential_1'
,p_validation_sequence=>160
,p_validation=>'P9801_OCI_PRIVATE_KEY'
,p_validation_type=>'ITEM_NOT_NULL'
,p_error_message=>'#LABEL# must have a value.'
,p_validation_condition=>wwv_flow_string.join(wwv_flow_t_varchar2(
'      :REQUEST                 in ( ''SAVE'',''CREATE'' )',
'  and :P9801_OCI_CREDENTIAL_ID is null',
'  and :P9801_AI_PROVIDER_TYPE   = ''OCI_GENAI'''))
,p_validation_condition2=>'PLSQL'
,p_validation_condition_type=>'EXPRESSION'
,p_associated_item=>wwv_flow_imp.id(2371179647845504)
,p_error_display_location=>'INLINE_WITH_FIELD_AND_NOTIFICATION'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1802503789232017)
,p_name=>'Provider Type Change'
,p_event_sequence=>20
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P9801_AI_PROVIDER_TYPE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1802616335232018)
,p_event_id=>wwv_flow_imp.id(1802503789232017)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_name=>'Set Base URL and Attributes'
,p_action=>'NATIVE_EXECUTE_PLSQL_CODE'
,p_attribute_01=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    :P9801_BASE_URL := wwv_flow_ai_dev.get_base_url(',
'        p_provider_type      => :P9801_AI_PROVIDER_TYPE,',
'        p_oci_region         => :P9801_OCI_REGION);',
'    ',
'    :P9801_AI_ATTRIBUTES := wwv_flow_ai_dev.get_mandatory_attributes(',
'        p_provider_type      => :P9801_AI_PROVIDER_TYPE,',
'        p_oci_compartment_id => :P9801_OCI_COMPARTMENT_ID,',
'        p_oci_model_id       => :P9801_OCI_MODEL_ID);',
'end;'))
,p_attribute_02=>'P9801_AI_PROVIDER_TYPE,P9801_OCI_REGION,P9801_OCI_COMPARTMENT_ID,P9801_OCI_MODEL_ID'
,p_attribute_03=>'P9801_BASE_URL,P9801_AI_ATTRIBUTES'
,p_attribute_04=>'N'
,p_attribute_05=>'PLSQL'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1426368657854706)
,p_event_id=>wwv_flow_imp.id(1802503789232017)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9801_AI_MODEL_NAME,P9801_OCI_CREDENTIAL_ID,P9801_APIKEY_CREDENTIAL_ID'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2385992600262632)
,p_name=>'Nothing selected'
,p_event_sequence=>35
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P9801_AI_PROVIDER_TYPE'
,p_condition_element=>'P9801_AI_PROVIDER_TYPE'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2386099393262633)
,p_event_id=>wwv_flow_imp.id(2385992600262632)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Credentials'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2370835924845501)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2386918454262642)
,p_event_id=>wwv_flow_imp.id(2385992600262632)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Show Advanced'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1957527983376302)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2386564272262638)
,p_event_id=>wwv_flow_imp.id(2385992600262632)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Settings'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3011863444977914)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2386886100262641)
,p_event_id=>wwv_flow_imp.id(2385992600262632)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Show OCI Generative AI'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3574907901259601)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2386616704262639)
,p_event_id=>wwv_flow_imp.id(2385992600262632)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Hide OCI Generative AI'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3574907901259601)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2386797644262640)
,p_event_id=>wwv_flow_imp.id(2385992600262632)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Show Settings'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3011863444977914)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2386224802262635)
,p_event_id=>wwv_flow_imp.id(2385992600262632)
,p_event_result=>'FALSE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_name=>'Show Credentials'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2370835924845501)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2386374107262636)
,p_event_id=>wwv_flow_imp.id(2385992600262632)
,p_event_result=>'TRUE'
,p_action_sequence=>40
,p_execute_on_page_init=>'Y'
,p_name=>'Hide Advanced'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(1957527983376302)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3575539631259607)
,p_name=>'OCI Generative AI'
,p_event_sequence=>40
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P9801_AI_PROVIDER_TYPE'
,p_condition_element=>'P9801_AI_PROVIDER_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'OCI_GENAI'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4373677188092305)
,p_event_id=>wwv_flow_imp.id(3575539631259607)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9801_AI_IS_BUILDER_SERVICE,P9801_AI_MODEL_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3575612891259608)
,p_event_id=>wwv_flow_imp.id(3575539631259607)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3574907901259601)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4373489172092303)
,p_event_id=>wwv_flow_imp.id(3575539631259607)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_ENABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9801_BASE_URL,P9801_AI_IS_BUILDER_SERVICE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3575741252259609)
,p_event_id=>wwv_flow_imp.id(3575539631259607)
,p_event_result=>'FALSE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(3574907901259601)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4373390634092302)
,p_event_id=>wwv_flow_imp.id(3575539631259607)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_DISABLE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9801_BASE_URL,P9801_AI_IS_BUILDER_SERVICE'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4373567899092304)
,p_event_id=>wwv_flow_imp.id(3575539631259607)
,p_event_result=>'TRUE'
,p_action_sequence=>50
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9801_AI_IS_BUILDER_SERVICE,P9801_AI_MODEL_NAME'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2383957625262612)
,p_event_id=>wwv_flow_imp.id(3575539631259607)
,p_event_result=>'TRUE'
,p_action_sequence=>60
,p_execute_on_page_init=>'Y'
,p_name=>'Hide API Key Credential Region'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2371415445845507)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2384022168262613)
,p_event_id=>wwv_flow_imp.id(3575539631259607)
,p_event_result=>'TRUE'
,p_action_sequence=>70
,p_execute_on_page_init=>'Y'
,p_name=>'Show OCI Credential Region'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2371581038845508)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3576080477259612)
,p_name=>'OCI Region Change'
,p_event_sequence=>50
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P9801_OCI_REGION'
,p_condition_element=>'P9801_AI_PROVIDER_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'OCI_GENAI'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3576126271259613)
,p_event_id=>wwv_flow_imp.id(3576080477259612)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Set OCI Base URL'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9801_BASE_URL'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    :P9801_BASE_URL := wwv_flow_ai_dev.get_base_url(',
'        p_provider_type => :P9801_AI_PROVIDER_TYPE,',
'        p_oci_region    => :P9801_OCI_REGION);',
'        ',
'    return :P9801_BASE_URL;',
'end;'))
,p_attribute_07=>'P9801_AI_PROVIDER_TYPE,P9801_OCI_REGION'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_client_condition_type=>'EQUALS'
,p_client_condition_element=>'P9801_AI_PROVIDER_TYPE'
,p_client_condition_expression=>'OCI_GENAI'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3576227696259614)
,p_name=>'OCI Compartment ID Change'
,p_event_sequence=>60
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P9801_OCI_COMPARTMENT_ID'
,p_condition_element=>'P9801_AI_PROVIDER_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'OCI_GENAI'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3576304905259615)
,p_event_id=>wwv_flow_imp.id(3576227696259614)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Set OCI Compartment ID'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9801_AI_ATTRIBUTES'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    :P9801_AI_ATTRIBUTES := wwv_flow_ai_dev.get_mandatory_attributes(',
'        p_provider_type      => :P9801_AI_PROVIDER_TYPE,',
'        p_oci_compartment_id => :P9801_OCI_COMPARTMENT_ID,',
'        p_oci_model_id       => :P9801_OCI_MODEL_ID);',
'    ',
'    return :P9801_AI_ATTRIBUTES;',
'end;'))
,p_attribute_07=>'P9801_AI_PROVIDER_TYPE,P9801_OCI_COMPARTMENT_ID,P9801_OCI_MODEL_ID'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_client_condition_type=>'EQUALS'
,p_client_condition_element=>'P9801_AI_PROVIDER_TYPE'
,p_client_condition_expression=>'OCI_GENAI'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(3576448560259616)
,p_name=>'OCI Model ID change'
,p_event_sequence=>70
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P9801_OCI_MODEL_ID'
,p_condition_element=>'P9801_AI_PROVIDER_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'OCI_GENAI'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(3576508433259617)
,p_event_id=>wwv_flow_imp.id(3576448560259616)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_name=>'Set OCI Model ID'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9801_AI_ATTRIBUTES'
,p_attribute_01=>'FUNCTION_BODY'
,p_attribute_06=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    :P9801_AI_ATTRIBUTES := wwv_flow_ai_dev.get_mandatory_attributes(',
'        p_provider_type      => :P9801_AI_PROVIDER_TYPE,',
'        p_oci_compartment_id => :P9801_OCI_COMPARTMENT_ID,',
'        p_oci_model_id       => :P9801_OCI_MODEL_ID);',
'    ',
'    return :P9801_AI_ATTRIBUTES;',
'end;'))
,p_attribute_07=>'P9801_AI_PROVIDER_TYPE,P9801_OCI_COMPARTMENT_ID,P9801_OCI_MODEL_ID'
,p_attribute_08=>'N'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
,p_client_condition_type=>'EQUALS'
,p_client_condition_element=>'P9801_AI_PROVIDER_TYPE'
,p_client_condition_expression=>'OCI_GENAI'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4373913756092308)
,p_name=>'Open Additional Attributes Dialog'
,p_event_sequence=>80
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(4373860287092307)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4374076727092309)
,p_event_id=>wwv_flow_imp.id(4373913756092308)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_OPEN_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(4373786736092306)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(4374347245092312)
,p_name=>'Close Additional Attributes'
,p_event_sequence=>90
,p_triggering_element_type=>'BUTTON'
,p_triggering_button_id=>wwv_flow_imp.id(4374280903092311)
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'click'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(4374426286092313)
,p_event_id=>wwv_flow_imp.id(4374347245092312)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLOSE_REGION'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(4373786736092306)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(1425900463854702)
,p_name=>'OpenAI'
,p_event_sequence=>100
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P9801_AI_PROVIDER_TYPE'
,p_condition_element=>'P9801_AI_PROVIDER_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'OPENAI'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(1426096956854703)
,p_event_id=>wwv_flow_imp.id(1425900463854702)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'N'
,p_name=>'Set default AI Model'
,p_action=>'NATIVE_SET_VALUE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9801_AI_MODEL_NAME'
,p_attribute_01=>'STATIC_ASSIGNMENT'
,p_attribute_02=>'gpt-3.5-turbo'
,p_attribute_09=>'N'
,p_wait_for_result=>'Y'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2384155656262614)
,p_event_id=>wwv_flow_imp.id(1425900463854702)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Show API Key Credentials'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2371415445845507)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2384281924262615)
,p_event_id=>wwv_flow_imp.id(1425900463854702)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Hide OCI Credentials'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2371581038845508)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2384340824262616)
,p_name=>'Cohere'
,p_event_sequence=>110
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P9801_AI_PROVIDER_TYPE'
,p_condition_element=>'P9801_AI_PROVIDER_TYPE'
,p_triggering_condition_type=>'EQUALS'
,p_triggering_expression=>'COHERE'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2384552045262618)
,p_event_id=>wwv_flow_imp.id(2384340824262616)
,p_event_result=>'TRUE'
,p_action_sequence=>20
,p_execute_on_page_init=>'Y'
,p_name=>'Show API Key Credentials'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2371415445845507)
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2384694691262619)
,p_event_id=>wwv_flow_imp.id(2384340824262616)
,p_event_result=>'TRUE'
,p_action_sequence=>30
,p_execute_on_page_init=>'Y'
,p_name=>'Hide OCI Credentials'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'REGION'
,p_affected_region_id=>wwv_flow_imp.id(2371581038845508)
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2383060588262603)
,p_name=>'Create New API Key Credential'
,p_event_sequence=>130
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P9801_APIKEY_CREDENTIAL_ID'
,p_condition_element=>'P9801_APIKEY_CREDENTIAL_ID'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2383160521262604)
,p_event_id=>wwv_flow_imp.id(2383060588262603)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9801_API_KEY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2383274580262605)
,p_event_id=>wwv_flow_imp.id(2383060588262603)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9801_API_KEY'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2385633246262629)
,p_event_id=>wwv_flow_imp.id(2383060588262603)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9801_API_KEY'
);
wwv_flow_imp_page.create_page_da_event(
 p_id=>wwv_flow_imp.id(2383402493262607)
,p_name=>'Create New OCI Credential'
,p_event_sequence=>140
,p_triggering_element_type=>'ITEM'
,p_triggering_element=>'P9801_OCI_CREDENTIAL_ID'
,p_condition_element=>'P9801_OCI_CREDENTIAL_ID'
,p_triggering_condition_type=>'NULL'
,p_bind_type=>'bind'
,p_execution_type=>'IMMEDIATE'
,p_bind_event_type=>'change'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2383560440262608)
,p_event_id=>wwv_flow_imp.id(2383402493262607)
,p_event_result=>'TRUE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_SHOW'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9801_OCI_USER_ID,P9801_OCI_PRIVATE_KEY,P9801_OCI_TENANCY_ID,P9801_OCI_FINGERPRINT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2383778593262610)
,p_event_id=>wwv_flow_imp.id(2383402493262607)
,p_event_result=>'FALSE'
,p_action_sequence=>10
,p_execute_on_page_init=>'Y'
,p_action=>'NATIVE_HIDE'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9801_OCI_USER_ID,P9801_OCI_PRIVATE_KEY,P9801_OCI_TENANCY_ID,P9801_OCI_FINGERPRINT'
);
wwv_flow_imp_page.create_page_da_action(
 p_id=>wwv_flow_imp.id(2385576117262628)
,p_event_id=>wwv_flow_imp.id(2383402493262607)
,p_event_result=>'FALSE'
,p_action_sequence=>20
,p_execute_on_page_init=>'N'
,p_action=>'NATIVE_CLEAR'
,p_affected_elements_type=>'ITEM'
,p_affected_elements=>'P9801_OCI_USER_ID,P9801_OCI_PRIVATE_KEY,P9801_OCI_TENANCY_ID,P9801_OCI_FINGERPRINT'
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2384929578262622)
,p_process_sequence=>10
,p_process_point=>'AFTER_SUBMIT'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Consolidate Page Items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
':P9801_CREDENTIAL_ID := case when :P9801_AI_PROVIDER_TYPE = ''OCI_GENAI''',
'                            then :P9801_OCI_CREDENTIAL_ID',
'                            else :P9801_APIKEY_CREDENTIAL_ID',
'                        end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE,SAVE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_internal_uid=>2384929578262622
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3254719257368126)
,p_process_sequence=>20
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(3011863444977914)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Process form Edit Generative AI Service'
,p_attribute_01=>'PLSQL_CODE'
,p_attribute_04=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ai_dev.merge_remote_server (',
'    p_id                    => :P9801_ID,',
'    p_name                  => :P9801_NAME,',
'    p_static_id             => :P9801_STATIC_ID,',
'    p_base_url              => :P9801_BASE_URL,',
'    p_credential_id         => :P9801_CREDENTIAL_ID,',
'    p_ai_provider_type      => :P9801_AI_PROVIDER_TYPE,',
'    p_ai_is_builder_service => :P9801_AI_IS_BUILDER_SERVICE,',
'    p_ai_model_name         => :P9801_AI_MODEL_NAME,',
'    p_ai_http_headers       => :P9801_AI_HTTP_HEADERS,',
'    p_ai_attributes         => :P9801_AI_ATTRIBUTES,',
'    p_server_comment        => :P9801_SERVER_COMMENT,',
'    --',
'    p_new_api_key           => :P9801_API_KEY,',
'    p_new_oci_userid        => :P9801_OCI_USER_ID,',
'    p_new_oci_tenancyid     => :P9801_OCI_TENANCY_ID,',
'    p_new_oci_privatekey    => :P9801_OCI_PRIVATE_KEY,',
'    p_new_oci_fingerprint   => :P9801_OCI_FINGERPRINT );'))
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'CREATE,SAVE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'Changes applied.'
,p_internal_uid=>3254719257368126
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(1411567780331405)
,p_process_sequence=>30
,p_process_point=>'AFTER_SUBMIT'
,p_region_id=>wwv_flow_imp.id(3011863444977914)
,p_process_type=>'NATIVE_FORM_DML'
,p_process_name=>'Delete Generative AI Service'
,p_attribute_01=>'PLSQL_CODE'
,p_attribute_04=>wwv_flow_string.join(wwv_flow_t_varchar2(
'wwv_flow_ai_dev.delete_remote_server (',
'    p_id => :P9801_ID );'))
,p_attribute_05=>'Y'
,p_attribute_06=>'Y'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>'DELETE'
,p_process_when_type=>'REQUEST_IN_CONDITION'
,p_process_success_message=>'Generative AI Service &P9801_NAME. deleted'
,p_internal_uid=>1411567780331405
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(3047080269077034)
,p_process_sequence=>10
,p_process_point=>'BEFORE_HEADER'
,p_region_id=>wwv_flow_imp.id(3011863444977914)
,p_process_type=>'NATIVE_FORM_INIT'
,p_process_name=>'Initialize form Generative AI Details'
,p_internal_uid=>3047080269077034
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(2384839101262621)
,p_process_sequence=>20
,p_process_point=>'BEFORE_HEADER'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Distribute Page Items'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'     if :P9801_AI_PROVIDER_TYPE = ''OCI_GENAI'' then',
'         :P9801_OCI_CREDENTIAL_ID := :P9801_CREDENTIAL_ID;',
'     else',
'         :P9801_APIKEY_CREDENTIAL_ID := :P9801_CREDENTIAL_ID;',
'     end if;',
'end;',
''))
,p_process_clob_language=>'PLSQL'
,p_internal_uid=>2384839101262621
);
wwv_flow_imp_page.create_page_process(
 p_id=>wwv_flow_imp.id(4374907795092318)
,p_process_sequence=>10
,p_process_point=>'ON_SUBMIT_BEFORE_COMPUTATION'
,p_process_type=>'NATIVE_PLSQL'
,p_process_name=>'Set Disabled props for OCI Generative AI'
,p_process_sql_clob=>wwv_flow_string.join(wwv_flow_t_varchar2(
'begin',
'    :P9801_BASE_URL := wwv_flow_ai_dev.get_base_url(',
'        p_provider_type      => :P9801_AI_PROVIDER_TYPE,',
'        p_oci_region         => :P9801_OCI_REGION);',
'    ',
'    :P9801_AI_ATTRIBUTES := wwv_flow_ai_dev.get_mandatory_attributes(',
'        p_provider_type      => :P9801_AI_PROVIDER_TYPE,',
'        p_oci_compartment_id => :P9801_OCI_COMPARTMENT_ID,',
'        p_oci_model_id       => :P9801_OCI_MODEL_ID);',
'',
'    :P9801_AI_IS_BUILDER_SERVICE := ''N'';',
'end;'))
,p_process_clob_language=>'PLSQL'
,p_error_display_location=>'INLINE_IN_NOTIFICATION'
,p_process_when=>':REQUEST in (''CREATE'', ''SAVE'') and :P9801_AI_PROVIDER_TYPE = ''OCI_GENAI'''
,p_process_when_type=>'EXPRESSION'
,p_process_when2=>'PLSQL'
,p_internal_uid=>4374907795092318
);
end;
/
prompt --application/pages/page_09803
begin
wwv_flow_imp_page.create_page(
 p_id=>9803
,p_name=>'Utilization'
,p_alias=>'AI-SERVICE-UTILIZATION'
,p_step_title=>'Utilization'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(695865518379549515)
,p_plug_name=>'tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_imp.id(2400998349683334)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(760696416145090828)
,p_plug_name=>'Utilization'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<p>Review where Generative AI Service objects are being used within this workspace.</p>',
''))
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(784190633194047348)
,p_plug_name=>'Remote AI Service Usage'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select * ',
'  from wwv_flow_ai_usage_dev'))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(784190678034047349)
,p_no_data_found_message=>'No used AI Services found in this workspace.'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_rows_per_page=>'N'
,p_show_control_break=>'N'
,p_show_computation=>'N'
,p_show_aggregate=>'N'
,p_show_chart=>'N'
,p_show_group_by=>'N'
,p_show_pivot=>'N'
,p_show_flashback=>'N'
,p_show_download=>'N'
,p_enable_mail_download=>'Y'
,p_owner=>'CARSTEN'
,p_internal_uid=>784190678034047349
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(534842475854164333)
,p_db_column_name=>'ID'
,p_display_order=>10
,p_column_identifier=>'A'
,p_column_label=>'Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(534842897701164338)
,p_db_column_name=>'NAME'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Name'
,p_column_link=>'f?p=&APP_ID.:9801:&SESSION.::&DEBUG.:RP,:P9801_ID:#ID#'
,p_column_linktext=>'#NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'Y'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(534843252276164338)
,p_db_column_name=>'BASE_URL'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Base URL'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(530928511353141150)
,p_db_column_name=>'APPLICATION_ID'
,p_display_order=>70
,p_column_identifier=>'G'
,p_column_label=>'Application ID'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1379994407058063529)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>80
,p_column_identifier=>'J'
,p_column_label=>'Component Name'
,p_column_link=>'#COMPONENT_URL#'
,p_column_linktext=>'#COMPONENT_NAME#'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1379994515005063530)
,p_db_column_name=>'PAGE_ID'
,p_display_order=>90
,p_column_identifier=>'K'
,p_column_label=>'Page Id'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1379994590545063531)
,p_db_column_name=>'ITEM_NAME'
,p_display_order=>100
,p_column_identifier=>'L'
,p_column_label=>'Item Name'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1379994678085063532)
,p_db_column_name=>'ITEM_VALUE'
,p_display_order=>110
,p_column_identifier=>'M'
,p_column_label=>'Item Value'
,p_column_type=>'NUMBER'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(1801500203232007)
,p_db_column_name=>'AI_PROVIDER_TYPE'
,p_display_order=>120
,p_column_identifier=>'N'
,p_column_label=>'AI Service Provider'
,p_column_type=>'STRING'
,p_display_text_as=>'LOV_ESCAPE_SC'
,p_heading_alignment=>'LEFT'
,p_rpt_named_lov=>wwv_flow_imp.id(3600433605650143)
,p_rpt_show_filter_lov=>'1'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(4373274876092301)
,p_db_column_name=>'COMPONENT_URL'
,p_display_order=>130
,p_column_identifier=>'O'
,p_column_label=>'Component URL'
,p_column_type=>'STRING'
,p_display_text_as=>'HIDDEN_ESCAPE_SC'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(844761334599996757)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'5331393'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'NAME:BASE_URL::APPLICATION_ID:COMPONENT_NAME:PAGE_ID:ITEM_NAME:ITEM_VALUE:AI_PROVIDER_TYPE:COMPONENT_URL'
);
end;
/
prompt --application/pages/page_09804
begin
wwv_flow_imp_page.create_page(
 p_id=>9804
,p_name=>'History'
,p_alias=>'AI-SERVICE-HISTORY'
,p_step_title=>'History'
,p_autocomplete_on_off=>'OFF'
,p_group_id=>wwv_flow_imp.id(213347710073256556)
,p_page_template_options=>'#DEFAULT#'
,p_page_component_map=>'18'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(534868355843221353)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(646287526247383209)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_new_grid_row=>false
,p_plug_new_grid_column=>false
,p_query_type=>'SQL'
,p_plug_source=>wwv_flow_string.join(wwv_flow_t_varchar2(
'select ',
'  t.flow_user developer, ',
'  t.audit_date,',
'  decode(audit_action,',
'         ''I'',i.a,',
'         ''D'',d.a,',
'         u.a) action,',
'  SCN,',
'  audit_comment,',
'  FLOW_TABLE_PK component_key,',
'  t.object_name component_name',
'from   ',
'  wwv_flow_builder_audit_trail t,',
'  (select wwv_flow_lang.system_message(''F4350.CREATE'') a from dual) i,',
'  (select wwv_flow_lang.system_message(''F4350.DELETE'') a from dual) d,',
'  (select wwv_flow_lang.system_message(''F4350.CHANGE'') a from dual) u',
'where  ',
'  t.flow_ID           = :FB_FLOW_ID and',
'  t.security_group_id = :flow_security_group_id and',
'  t.flow_table        = ''WWV_REMOTE_SERVERS'' and',
'  t.flow_table_pk    in ( select id ',
'                            from WWV_REMOTE_SERVERS ',
'                           where security_group_id = :flow_security_group_id ',
'                             and server_type = ''GENERATIVE_AI'')'))
,p_plug_source_type=>'NATIVE_IR'
,p_prn_content_disposition=>'ATTACHMENT'
,p_prn_units=>'INCHES'
,p_prn_paper_size=>'LETTER'
,p_prn_width=>8.5
,p_prn_height=>11
,p_prn_orientation=>'HORIZONTAL'
,p_prn_page_header_font_color=>'#000000'
,p_prn_page_header_font_family=>'Helvetica'
,p_prn_page_header_font_weight=>'normal'
,p_prn_page_header_font_size=>'12'
,p_prn_page_footer_font_color=>'#000000'
,p_prn_page_footer_font_family=>'Helvetica'
,p_prn_page_footer_font_weight=>'normal'
,p_prn_page_footer_font_size=>'12'
,p_prn_header_bg_color=>'#9bafde'
,p_prn_header_font_color=>'#000000'
,p_prn_header_font_family=>'Helvetica'
,p_prn_header_font_weight=>'normal'
,p_prn_header_font_size=>'10'
,p_prn_body_bg_color=>'#efefef'
,p_prn_body_font_color=>'#000000'
,p_prn_body_font_family=>'Helvetica'
,p_prn_body_font_weight=>'normal'
,p_prn_body_font_size=>'10'
,p_prn_border_width=>.5
,p_prn_page_header_alignment=>'CENTER'
,p_prn_page_footer_alignment=>'CENTER'
);
wwv_flow_imp_page.create_worksheet(
 p_id=>wwv_flow_imp.id(534868494173221354)
,p_max_row_count=>'1000000'
,p_show_nulls_as=>'-'
,p_pagination_type=>'ROWS_X_TO_Y'
,p_pagination_display_pos=>'BOTTOM_RIGHT'
,p_report_list_mode=>'TABS'
,p_lazy_loading=>false
,p_show_detail_link=>'N'
,p_show_notify=>'Y'
,p_download_formats=>'HTML:XLSX:PDF'
,p_enable_mail_download=>'Y'
,p_owner=>'CARSTEN'
,p_internal_uid=>534868494173221354
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(534868641514221356)
,p_db_column_name=>'AUDIT_DATE'
,p_display_order=>20
,p_column_identifier=>'B'
,p_column_label=>'Audit Date'
,p_column_type=>'DATE'
,p_heading_alignment=>'LEFT'
,p_format_mask=>'SINCE'
,p_tz_dependent=>'N'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(534868728803221357)
,p_db_column_name=>'ACTION'
,p_display_order=>30
,p_column_identifier=>'C'
,p_column_label=>'Action'
,p_column_type=>'STRING'
,p_column_alignment=>'CENTER'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(534868596031221355)
,p_db_column_name=>'DEVELOPER'
,p_display_order=>40
,p_column_identifier=>'A'
,p_column_label=>'Developer'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(534868889015221358)
,p_db_column_name=>'SCN'
,p_display_order=>50
,p_column_identifier=>'D'
,p_column_label=>'SCN'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(534868955239221359)
,p_db_column_name=>'AUDIT_COMMENT'
,p_display_order=>60
,p_column_identifier=>'E'
,p_column_label=>'Audit Comment'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(534869074451221360)
,p_db_column_name=>'COMPONENT_KEY'
,p_display_order=>70
,p_column_identifier=>'F'
,p_column_label=>'Component Key'
,p_column_type=>'NUMBER'
,p_heading_alignment=>'RIGHT'
,p_column_alignment=>'RIGHT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_column(
 p_id=>wwv_flow_imp.id(534869110900221361)
,p_db_column_name=>'COMPONENT_NAME'
,p_display_order=>80
,p_column_identifier=>'G'
,p_column_label=>'Component Name'
,p_column_type=>'STRING'
,p_heading_alignment=>'LEFT'
,p_use_as_row_header=>'N'
);
wwv_flow_imp_page.create_worksheet_rpt(
 p_id=>wwv_flow_imp.id(534925815269382437)
,p_application_user=>'APXWS_DEFAULT'
,p_report_seq=>10
,p_report_alias=>'5332100'
,p_status=>'PUBLIC'
,p_is_default=>'Y'
,p_report_columns=>'AUDIT_DATE:ACTION:DEVELOPER:COMPONENT_NAME:'
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1229052870922860112)
,p_plug_name=>'tabs'
,p_region_template_options=>'#DEFAULT#'
,p_component_template_options=>'#DEFAULT#'
,p_plug_template=>wwv_flow_imp.id(208928010704475743)
,p_plug_display_sequence=>10
,p_include_in_reg_disp_sel_yn=>'Y'
,p_list_id=>wwv_flow_imp.id(2400998349683334)
,p_plug_source_type=>'NATIVE_LIST'
,p_list_template_id=>wwv_flow_imp.id(168712225287236339)
);
wwv_flow_imp_page.create_page_plug(
 p_id=>wwv_flow_imp.id(1293883768688401425)
,p_plug_name=>'History'
,p_region_template_options=>'#DEFAULT#:a-Region--paddedBody'
,p_plug_template=>wwv_flow_imp.id(174794400314076650)
,p_plug_display_sequence=>20
,p_include_in_reg_disp_sel_yn=>'Y'
,p_plug_display_point=>'REGION_POSITION_03'
,p_plug_source=>'<p>This page displays recent modifications made to Generative AI Services in this workspace.</p>'
,p_attributes=>wwv_flow_t_plugin_attributes(wwv_flow_t_varchar2(
  'expand_shortcuts', 'N',
  'output_as', 'HTML')).to_clob
);
end;
/
prompt --application/deployment/definition
begin
wwv_flow_imp_shared.create_install(
 p_id=>wwv_flow_imp.id(87611795747632818)
);
end;
/
prompt --application/deployment/checks
begin
null;
end;
/
prompt --application/deployment/buildoptions
begin
null;
end;
/
prompt --application/end_environment
begin
wwv_flow_imp.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false)
);
commit;
end;
/
set verify on feedback on define on
prompt  ...done
